#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 11733
#define LARGE_STATE_COUNT 3482
#define SYMBOL_COUNT 610
#define ALIAS_COUNT 5
#define TOKEN_COUNT 260
#define EXTERNAL_TOKEN_COUNT 2
#define FIELD_COUNT 53
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 243

enum ts_symbol_identifiers {
  sym_identifier = 1,
  aux_sym_preproc_include_token1 = 2,
  aux_sym_preproc_include_token2 = 3,
  aux_sym_preproc_def_token1 = 4,
  anon_sym_LPAREN = 5,
  anon_sym_DOT_DOT_DOT = 6,
  anon_sym_COMMA = 7,
  anon_sym_RPAREN = 8,
  aux_sym_preproc_if_token1 = 9,
  anon_sym_LF = 10,
  aux_sym_preproc_if_token2 = 11,
  aux_sym_preproc_ifdef_token1 = 12,
  aux_sym_preproc_ifdef_token2 = 13,
  aux_sym_preproc_else_token1 = 14,
  aux_sym_preproc_elif_token1 = 15,
  aux_sym_preproc_elifdef_token1 = 16,
  aux_sym_preproc_elifdef_token2 = 17,
  sym_preproc_arg = 18,
  sym_preproc_directive = 19,
  anon_sym_LPAREN2 = 20,
  anon_sym_defined = 21,
  anon_sym_BANG = 22,
  anon_sym_TILDE = 23,
  anon_sym_DASH = 24,
  anon_sym_PLUS = 25,
  anon_sym_STAR = 26,
  anon_sym_SLASH = 27,
  anon_sym_PERCENT = 28,
  anon_sym_PIPE_PIPE = 29,
  anon_sym_AMP_AMP = 30,
  anon_sym_PIPE = 31,
  anon_sym_CARET = 32,
  anon_sym_AMP = 33,
  anon_sym_EQ_EQ = 34,
  anon_sym_BANG_EQ = 35,
  anon_sym_GT = 36,
  anon_sym_GT_EQ = 37,
  anon_sym_LT_EQ = 38,
  anon_sym_LT = 39,
  anon_sym_LT_LT = 40,
  anon_sym_GT_GT = 41,
  anon_sym_COLON = 42,
  anon_sym_SEMI = 43,
  anon_sym___extension__ = 44,
  anon_sym_typedef = 45,
  anon_sym_in = 46,
  anon_sym_out = 47,
  anon_sym_inout = 48,
  anon_sym_virtual = 49,
  anon_sym_extern = 50,
  anon_sym___attribute__ = 51,
  anon_sym___attribute = 52,
  anon_sym_using = 53,
  anon_sym_COLON_COLON = 54,
  anon_sym_LBRACK_LBRACK = 55,
  anon_sym_RBRACK_RBRACK = 56,
  anon_sym___declspec = 57,
  anon_sym___based = 58,
  anon_sym___cdecl = 59,
  anon_sym___clrcall = 60,
  anon_sym___stdcall = 61,
  anon_sym___fastcall = 62,
  anon_sym___thiscall = 63,
  anon_sym___vectorcall = 64,
  sym_ms_restrict_modifier = 65,
  sym_ms_unsigned_ptr_modifier = 66,
  sym_ms_signed_ptr_modifier = 67,
  anon_sym__unaligned = 68,
  anon_sym___unaligned = 69,
  anon_sym_LBRACE = 70,
  anon_sym_RBRACE = 71,
  anon_sym_signed = 72,
  anon_sym_unsigned = 73,
  anon_sym_long = 74,
  anon_sym_short = 75,
  anon_sym_LBRACK = 76,
  anon_sym_static = 77,
  anon_sym_RBRACK = 78,
  anon_sym_EQ = 79,
  anon_sym_register = 80,
  anon_sym_inline = 81,
  anon_sym___inline = 82,
  anon_sym___inline__ = 83,
  anon_sym___forceinline = 84,
  anon_sym_thread_local = 85,
  anon_sym___thread = 86,
  anon_sym_const = 87,
  anon_sym_constexpr = 88,
  anon_sym_volatile = 89,
  anon_sym_restrict = 90,
  anon_sym___restrict__ = 91,
  anon_sym__Atomic = 92,
  anon_sym__Noreturn = 93,
  anon_sym_noreturn = 94,
  anon_sym__Nonnull = 95,
  anon_sym_mutable = 96,
  anon_sym_constinit = 97,
  anon_sym_consteval = 98,
  anon_sym_alignas = 99,
  anon_sym__Alignas = 100,
  sym_primitive_type = 101,
  anon_sym_enum = 102,
  anon_sym_class = 103,
  anon_sym_struct = 104,
  anon_sym_union = 105,
  anon_sym_if = 106,
  anon_sym_else = 107,
  anon_sym_switch = 108,
  anon_sym_case = 109,
  anon_sym_default = 110,
  anon_sym_while = 111,
  anon_sym_do = 112,
  anon_sym_for = 113,
  anon_sym_return = 114,
  anon_sym_break = 115,
  anon_sym_continue = 116,
  anon_sym_goto = 117,
  anon_sym___try = 118,
  anon_sym___except = 119,
  anon_sym___finally = 120,
  anon_sym___leave = 121,
  anon_sym_QMARK = 122,
  anon_sym_STAR_EQ = 123,
  anon_sym_SLASH_EQ = 124,
  anon_sym_PERCENT_EQ = 125,
  anon_sym_PLUS_EQ = 126,
  anon_sym_DASH_EQ = 127,
  anon_sym_LT_LT_EQ = 128,
  anon_sym_GT_GT_EQ = 129,
  anon_sym_AMP_EQ = 130,
  anon_sym_CARET_EQ = 131,
  anon_sym_PIPE_EQ = 132,
  anon_sym_and_eq = 133,
  anon_sym_or_eq = 134,
  anon_sym_xor_eq = 135,
  anon_sym_not = 136,
  anon_sym_compl = 137,
  anon_sym_LT_EQ_GT = 138,
  anon_sym_or = 139,
  anon_sym_and = 140,
  anon_sym_bitor = 141,
  anon_sym_xor = 142,
  anon_sym_bitand = 143,
  anon_sym_not_eq = 144,
  anon_sym_is = 145,
  anon_sym_as = 146,
  anon_sym_DASH_DASH = 147,
  anon_sym_PLUS_PLUS = 148,
  anon_sym_sizeof = 149,
  anon_sym___alignof__ = 150,
  anon_sym___alignof = 151,
  anon_sym__alignof = 152,
  anon_sym_alignof = 153,
  anon_sym__Alignof = 154,
  anon_sym_offsetof = 155,
  anon_sym__Generic = 156,
  anon_sym_asm = 157,
  anon_sym___asm__ = 158,
  anon_sym___asm = 159,
  anon_sym___volatile__ = 160,
  anon_sym_DOT = 161,
  anon_sym_DOT_STAR = 162,
  anon_sym_DASH_GT = 163,
  sym_number_literal = 164,
  anon_sym_L_SQUOTE = 165,
  anon_sym_u_SQUOTE = 166,
  anon_sym_U_SQUOTE = 167,
  anon_sym_u8_SQUOTE = 168,
  anon_sym_SQUOTE = 169,
  aux_sym_char_literal_token1 = 170,
  anon_sym_L_DQUOTE = 171,
  anon_sym_u_DQUOTE = 172,
  anon_sym_U_DQUOTE = 173,
  anon_sym_u8_DQUOTE = 174,
  anon_sym_DQUOTE = 175,
  aux_sym_string_literal_token1 = 176,
  sym_escape_sequence = 177,
  sym_system_lib_string = 178,
  sym_true = 179,
  sym_false = 180,
  anon_sym_NULL = 181,
  anon_sym_nullptr = 182,
  sym_comment = 183,
  anon_sym_var = 184,
  anon_sym_let = 185,
  anon_sym_This = 186,
  anon_sym_decltype = 187,
  anon_sym_final = 188,
  anon_sym_override = 189,
  anon_sym_explicit = 190,
  anon_sym_typename = 191,
  anon_sym_export = 192,
  anon_sym_module = 193,
  anon_sym_import = 194,
  anon_sym_private = 195,
  anon_sym_template = 196,
  anon_sym_GT2 = 197,
  anon_sym_operator = 198,
  anon_sym_try = 199,
  anon_sym_delete = 200,
  aux_sym_pure_virtual_clause_token1 = 201,
  anon_sym_friend = 202,
  anon_sym_public = 203,
  anon_sym_protected = 204,
  anon_sym_noexcept = 205,
  anon_sym_throw = 206,
  anon_sym_namespace = 207,
  anon_sym_static_assert = 208,
  anon_sym_concept = 209,
  anon_sym_co_return = 210,
  anon_sym_co_yield = 211,
  anon_sym_catch = 212,
  anon_sym_R_DQUOTE = 213,
  anon_sym_LR_DQUOTE = 214,
  anon_sym_uR_DQUOTE = 215,
  anon_sym_UR_DQUOTE = 216,
  anon_sym_u8R_DQUOTE = 217,
  anon_sym_co_await = 218,
  anon_sym_new = 219,
  anon_sym_requires = 220,
  anon_sym_DASH_GT_STAR = 221,
  anon_sym_LPAREN_RPAREN = 222,
  anon_sym_LBRACK_RBRACK = 223,
  anon_sym_DQUOTE_DQUOTE = 224,
  sym_this = 225,
  sym_literal_suffix = 226,
  anon_sym_discard = 227,
  anon_sym_precise = 228,
  anon_sym_shared = 229,
  anon_sym_groupshared = 230,
  anon_sym_uniform = 231,
  anon_sym_row_major = 232,
  anon_sym_column_major = 233,
  anon_sym_globallycoherent = 234,
  anon_sym_centroid = 235,
  anon_sym_noperspective = 236,
  anon_sym_nointerpolation = 237,
  anon_sym_sample = 238,
  anon_sym_linear = 239,
  anon_sym_snorm = 240,
  anon_sym_unorm = 241,
  anon_sym_point = 242,
  anon_sym_line = 243,
  anon_sym_triangleadj = 244,
  anon_sym_lineadj = 245,
  anon_sym_triangle = 246,
  anon_sym_cbuffer = 247,
  anon_sym_interface = 248,
  anon_sym_extension = 249,
  anon_sym_where = 250,
  anon_sym___exported = 251,
  anon_sym___init = 252,
  anon_sym___subscript = 253,
  anon_sym_property = 254,
  anon_sym_get = 255,
  anon_sym_set = 256,
  anon_sym_associatedtype = 257,
  sym_raw_string_delimiter = 258,
  sym_raw_string_content = 259,
  sym_translation_unit = 260,
  sym__top_level_item = 261,
  sym__block_item = 262,
  sym_preproc_include = 263,
  sym_preproc_def = 264,
  sym_preproc_function_def = 265,
  sym_preproc_params = 266,
  sym_preproc_call = 267,
  sym_preproc_if = 268,
  sym_preproc_ifdef = 269,
  sym_preproc_else = 270,
  sym_preproc_elif = 271,
  sym_preproc_elifdef = 272,
  sym_preproc_if_in_field_declaration_list = 273,
  sym_preproc_ifdef_in_field_declaration_list = 274,
  sym_preproc_else_in_field_declaration_list = 275,
  sym_preproc_elif_in_field_declaration_list = 276,
  sym_preproc_elifdef_in_field_declaration_list = 277,
  sym_preproc_if_in_enumerator_list = 278,
  sym_preproc_ifdef_in_enumerator_list = 279,
  sym_preproc_else_in_enumerator_list = 280,
  sym_preproc_elif_in_enumerator_list = 281,
  sym_preproc_elifdef_in_enumerator_list = 282,
  sym_preproc_if_in_enumerator_list_no_comma = 283,
  sym_preproc_ifdef_in_enumerator_list_no_comma = 284,
  sym_preproc_else_in_enumerator_list_no_comma = 285,
  sym_preproc_elif_in_enumerator_list_no_comma = 286,
  sym_preproc_elifdef_in_enumerator_list_no_comma = 287,
  sym__preproc_expression = 288,
  sym_preproc_parenthesized_expression = 289,
  sym_preproc_defined = 290,
  sym_preproc_unary_expression = 291,
  sym_preproc_call_expression = 292,
  sym_preproc_argument_list = 293,
  sym_preproc_binary_expression = 294,
  sym_function_definition = 295,
  sym_declaration = 296,
  sym_type_definition = 297,
  sym__type_definition_type = 298,
  sym__type_definition_declarators = 299,
  sym__declaration_modifiers = 300,
  sym__declaration_specifiers = 301,
  sym_linkage_specification = 302,
  sym_attribute_specifier = 303,
  sym_attribute = 304,
  sym_attribute_declaration = 305,
  sym_ms_declspec_modifier = 306,
  sym_ms_based_modifier = 307,
  sym_ms_call_modifier = 308,
  sym_ms_unaligned_ptr_modifier = 309,
  sym_ms_pointer_modifier = 310,
  sym_declaration_list = 311,
  sym__declarator = 312,
  sym__field_declarator = 313,
  sym__type_declarator = 314,
  sym__abstract_declarator = 315,
  sym_parenthesized_declarator = 316,
  sym_parenthesized_field_declarator = 317,
  sym_parenthesized_type_declarator = 318,
  sym_abstract_parenthesized_declarator = 319,
  sym_attributed_declarator = 320,
  sym_attributed_field_declarator = 321,
  sym_attributed_type_declarator = 322,
  sym_pointer_declarator = 323,
  sym_pointer_field_declarator = 324,
  sym_pointer_type_declarator = 325,
  sym_abstract_pointer_declarator = 326,
  sym_function_declarator = 327,
  sym_function_field_declarator = 328,
  sym_function_type_declarator = 329,
  sym_abstract_function_declarator = 330,
  sym_array_declarator = 331,
  sym_array_field_declarator = 332,
  sym_array_type_declarator = 333,
  sym_abstract_array_declarator = 334,
  sym_init_declarator = 335,
  sym_compound_statement = 336,
  sym_storage_class_specifier = 337,
  sym_type_qualifier = 338,
  sym_alignas_qualifier = 339,
  sym_type_specifier = 340,
  sym_sized_type_specifier = 341,
  sym_enum_specifier = 342,
  sym_enumerator_list = 343,
  sym_struct_specifier = 344,
  sym_union_specifier = 345,
  sym_field_declaration_list = 346,
  sym__field_declaration_list_item = 347,
  sym_field_declaration = 348,
  sym_bitfield_clause = 349,
  sym_enumerator = 350,
  sym_parameter_list = 351,
  sym_parameter_declaration = 352,
  sym_attributed_statement = 353,
  sym_statement = 354,
  sym__top_level_statement = 355,
  sym_labeled_statement = 356,
  sym__top_level_expression_statement = 357,
  sym_expression_statement = 358,
  sym_if_statement = 359,
  sym_else_clause = 360,
  sym_switch_statement = 361,
  sym_case_statement = 362,
  sym_while_statement = 363,
  sym_do_statement = 364,
  sym_for_statement = 365,
  sym__for_statement_body = 366,
  sym_return_statement = 367,
  sym_break_statement = 368,
  sym_continue_statement = 369,
  sym_goto_statement = 370,
  sym_seh_try_statement = 371,
  sym_seh_except_clause = 372,
  sym_seh_finally_clause = 373,
  sym_seh_leave_statement = 374,
  sym_expression = 375,
  sym__string = 376,
  sym_comma_expression = 377,
  sym_conditional_expression = 378,
  sym_assignment_expression = 379,
  sym_pointer_expression = 380,
  sym_unary_expression = 381,
  sym_binary_expression = 382,
  sym_update_expression = 383,
  sym_cast_expression = 384,
  sym_type_descriptor = 385,
  sym_sizeof_expression = 386,
  sym_alignof_expression = 387,
  sym_offsetof_expression = 388,
  sym_generic_expression = 389,
  sym_subscript_expression = 390,
  sym_call_expression = 391,
  sym_gnu_asm_expression = 392,
  sym_gnu_asm_qualifier = 393,
  sym_gnu_asm_output_operand_list = 394,
  sym_gnu_asm_output_operand = 395,
  sym_gnu_asm_input_operand_list = 396,
  sym_gnu_asm_input_operand = 397,
  sym_gnu_asm_clobber_list = 398,
  sym_gnu_asm_goto_list = 399,
  sym_extension_expression = 400,
  sym_argument_list = 401,
  sym_field_expression = 402,
  sym_compound_literal_expression = 403,
  sym_parenthesized_expression = 404,
  sym_initializer_list = 405,
  sym_initializer_pair = 406,
  sym_subscript_designator = 407,
  sym_subscript_range_designator = 408,
  sym_field_designator = 409,
  sym_char_literal = 410,
  sym_concatenated_string = 411,
  sym_string_literal = 412,
  sym_null = 413,
  sym__empty_declaration = 414,
  sym_placeholder_type_specifier = 415,
  sym_decltype = 416,
  sym__class_declaration = 417,
  sym__class_declaration_item = 418,
  sym_class_specifier = 419,
  sym__class_name = 420,
  sym_virtual_specifier = 421,
  sym_explicit_function_specifier = 422,
  sym_base_class_clause = 423,
  sym__enum_base_clause = 424,
  sym_dependent_type = 425,
  sym_module_name = 426,
  sym_module_partition = 427,
  sym_module_declaration = 428,
  sym_export_declaration = 429,
  sym_import_declaration = 430,
  sym_global_module_fragment_declaration = 431,
  sym_private_module_fragment_declaration = 432,
  sym_template_declaration = 433,
  sym_template_instantiation = 434,
  sym_template_parameter_list = 435,
  sym_type_parameter_declaration = 436,
  sym_variadic_type_parameter_declaration = 437,
  sym_optional_type_parameter_declaration = 438,
  sym_template_template_parameter_declaration = 439,
  sym_optional_parameter_declaration = 440,
  sym_variadic_parameter_declaration = 441,
  sym_variadic_declarator = 442,
  sym_variadic_reference_declarator = 443,
  sym_operator_cast = 444,
  sym_field_initializer_list = 445,
  sym_field_initializer = 446,
  sym_inline_method_definition = 447,
  sym__constructor_specifiers = 448,
  sym_operator_cast_definition = 449,
  sym_operator_cast_declaration = 450,
  sym_constructor_try_statement = 451,
  sym_constructor_or_destructor_definition = 452,
  sym_constructor_or_destructor_declaration = 453,
  sym_default_method_clause = 454,
  sym_delete_method_clause = 455,
  sym_pure_virtual_clause = 456,
  sym_friend_declaration = 457,
  sym_access_specifier = 458,
  sym_reference_declarator = 459,
  sym_reference_field_declarator = 460,
  sym_reference_type_declarator = 461,
  sym_abstract_reference_declarator = 462,
  sym_structured_binding_declarator = 463,
  sym_ref_qualifier = 464,
  sym__function_declarator_seq = 465,
  sym__function_attributes_start = 466,
  sym__function_exception_specification = 467,
  sym__function_attributes_end = 468,
  sym__function_postfix = 469,
  sym_trailing_return_type = 470,
  sym_noexcept = 471,
  sym_throw_specifier = 472,
  sym_template_type = 473,
  sym_template_method = 474,
  sym_template_function = 475,
  sym_template_argument_list = 476,
  sym_namespace_definition = 477,
  sym_namespace_alias_definition = 478,
  sym__namespace_specifier = 479,
  sym_nested_namespace_specifier = 480,
  sym_using_declaration = 481,
  sym_alias_declaration = 482,
  sym_static_assert_declaration = 483,
  sym_concept_definition = 484,
  sym_for_range_loop = 485,
  sym__for_range_loop_body = 486,
  sym_init_statement = 487,
  sym_condition_clause = 488,
  sym_condition_declaration = 489,
  sym_co_return_statement = 490,
  sym_co_yield_statement = 491,
  sym_throw_statement = 492,
  sym_try_statement = 493,
  sym_catch_clause = 494,
  sym_raw_string_literal = 495,
  sym_subscript_argument_list = 496,
  sym_co_await_expression = 497,
  sym_new_expression = 498,
  sym_new_declarator = 499,
  sym_delete_expression = 500,
  sym_type_requirement = 501,
  sym_compound_requirement = 502,
  sym__requirement = 503,
  sym_requirement_seq = 504,
  sym_constraint_conjunction = 505,
  sym_constraint_disjunction = 506,
  sym__requirement_clause_constraint = 507,
  sym_requires_clause = 508,
  sym_requires_parameter_list = 509,
  sym_requires_expression = 510,
  sym_lambda_declarator = 511,
  sym_lambda_expression = 512,
  sym_lambda_capture_specifier = 513,
  sym_lambda_default_capture = 514,
  sym__lambda_capture_identifier = 515,
  sym_lambda_capture_initializer = 516,
  sym__lambda_capture = 517,
  sym__fold_operator = 518,
  sym__binary_fold_operator = 519,
  sym__unary_left_fold = 520,
  sym__unary_right_fold = 521,
  sym__binary_fold = 522,
  sym_fold_expression = 523,
  sym_parameter_pack_expansion = 524,
  sym_type_parameter_pack_expansion = 525,
  sym_identifier_parameter_pack_expansion = 526,
  sym_destructor_name = 527,
  sym_dependent_identifier = 528,
  sym_dependent_field_identifier = 529,
  sym_dependent_type_identifier = 530,
  sym__scope_resolution = 531,
  sym_qualified_field_identifier = 532,
  sym_qualified_identifier = 533,
  sym_qualified_type_identifier = 534,
  sym_qualified_operator_cast_identifier = 535,
  sym__assignment_expression_lhs = 536,
  sym_operator_name = 537,
  sym_user_defined_literal = 538,
  sym_semantics = 539,
  sym_discard_statement = 540,
  sym_qualifiers = 541,
  sym_cbuffer_specifier = 542,
  sym_hlsl_attribute = 543,
  sym_type_hinted_declarator = 544,
  sym_type_hint = 545,
  sym_interface_specifier = 546,
  sym_extension_specifier = 547,
  sym_interface_requirements = 548,
  sym_where_clause = 549,
  sym_import_statement = 550,
  sym_init_declaration = 551,
  sym_subscript_declaration = 552,
  sym_property_declaration = 553,
  sym_property_get = 554,
  sym_property_set = 555,
  sym_associatedtype_declaration = 556,
  sym_associatedtype_specifier = 557,
  aux_sym_translation_unit_repeat1 = 558,
  aux_sym_preproc_params_repeat1 = 559,
  aux_sym_preproc_if_repeat1 = 560,
  aux_sym_preproc_if_in_field_declaration_list_repeat1 = 561,
  aux_sym_preproc_if_in_enumerator_list_repeat1 = 562,
  aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1 = 563,
  aux_sym_preproc_argument_list_repeat1 = 564,
  aux_sym_declaration_repeat1 = 565,
  aux_sym_type_definition_repeat1 = 566,
  aux_sym__type_definition_type_repeat1 = 567,
  aux_sym__type_definition_declarators_repeat1 = 568,
  aux_sym__declaration_specifiers_repeat1 = 569,
  aux_sym_attribute_declaration_repeat1 = 570,
  aux_sym_declaration_list_repeat1 = 571,
  aux_sym_attributed_declarator_repeat1 = 572,
  aux_sym_pointer_declarator_repeat1 = 573,
  aux_sym_array_declarator_repeat1 = 574,
  aux_sym_sized_type_specifier_repeat1 = 575,
  aux_sym_enumerator_list_repeat1 = 576,
  aux_sym_field_declaration_repeat1 = 577,
  aux_sym_parameter_list_repeat1 = 578,
  aux_sym_case_statement_repeat1 = 579,
  aux_sym_generic_expression_repeat1 = 580,
  aux_sym_gnu_asm_expression_repeat1 = 581,
  aux_sym_gnu_asm_output_operand_list_repeat1 = 582,
  aux_sym_gnu_asm_input_operand_list_repeat1 = 583,
  aux_sym_gnu_asm_clobber_list_repeat1 = 584,
  aux_sym_gnu_asm_goto_list_repeat1 = 585,
  aux_sym_argument_list_repeat1 = 586,
  aux_sym_initializer_list_repeat1 = 587,
  aux_sym_initializer_pair_repeat1 = 588,
  aux_sym_char_literal_repeat1 = 589,
  aux_sym_concatenated_string_repeat1 = 590,
  aux_sym_string_literal_repeat1 = 591,
  aux_sym__class_declaration_repeat1 = 592,
  aux_sym_base_class_clause_repeat1 = 593,
  aux_sym_module_name_repeat1 = 594,
  aux_sym_template_parameter_list_repeat1 = 595,
  aux_sym_field_initializer_list_repeat1 = 596,
  aux_sym_operator_cast_definition_repeat1 = 597,
  aux_sym_constructor_try_statement_repeat1 = 598,
  aux_sym_structured_binding_declarator_repeat1 = 599,
  aux_sym__function_postfix_repeat1 = 600,
  aux_sym_throw_specifier_repeat1 = 601,
  aux_sym_template_argument_list_repeat1 = 602,
  aux_sym_subscript_argument_list_repeat1 = 603,
  aux_sym_requirement_seq_repeat1 = 604,
  aux_sym_requires_parameter_list_repeat1 = 605,
  aux_sym_lambda_capture_specifier_repeat1 = 606,
  aux_sym_interface_requirements_repeat1 = 607,
  aux_sym_where_clause_repeat1 = 608,
  aux_sym_subscript_declaration_repeat1 = 609,
  alias_sym_field_identifier = 610,
  alias_sym_namespace_identifier = 611,
  alias_sym_simple_requirement = 612,
  alias_sym_statement_identifier = 613,
  alias_sym_type_identifier = 614,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [aux_sym_preproc_include_token1] = "#include",
  [aux_sym_preproc_include_token2] = "preproc_include_token2",
  [aux_sym_preproc_def_token1] = "#define",
  [anon_sym_LPAREN] = "(",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [aux_sym_preproc_if_token1] = "#if",
  [anon_sym_LF] = "\n",
  [aux_sym_preproc_if_token2] = "#endif",
  [aux_sym_preproc_ifdef_token1] = "#ifdef",
  [aux_sym_preproc_ifdef_token2] = "#ifndef",
  [aux_sym_preproc_else_token1] = "#else",
  [aux_sym_preproc_elif_token1] = "#elif",
  [aux_sym_preproc_elifdef_token1] = "#elifdef",
  [aux_sym_preproc_elifdef_token2] = "#elifndef",
  [sym_preproc_arg] = "preproc_arg",
  [sym_preproc_directive] = "preproc_directive",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_defined] = "defined",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS] = "+",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_AMP] = "&",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_COLON] = ":",
  [anon_sym_SEMI] = ";",
  [anon_sym___extension__] = "__extension__",
  [anon_sym_typedef] = "typedef",
  [anon_sym_in] = "in",
  [anon_sym_out] = "out",
  [anon_sym_inout] = "inout",
  [anon_sym_virtual] = "virtual",
  [anon_sym_extern] = "extern",
  [anon_sym___attribute__] = "__attribute__",
  [anon_sym___attribute] = "__attribute",
  [anon_sym_using] = "using",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym___declspec] = "__declspec",
  [anon_sym___based] = "__based",
  [anon_sym___cdecl] = "__cdecl",
  [anon_sym___clrcall] = "__clrcall",
  [anon_sym___stdcall] = "__stdcall",
  [anon_sym___fastcall] = "__fastcall",
  [anon_sym___thiscall] = "__thiscall",
  [anon_sym___vectorcall] = "__vectorcall",
  [sym_ms_restrict_modifier] = "ms_restrict_modifier",
  [sym_ms_unsigned_ptr_modifier] = "ms_unsigned_ptr_modifier",
  [sym_ms_signed_ptr_modifier] = "ms_signed_ptr_modifier",
  [anon_sym__unaligned] = "_unaligned",
  [anon_sym___unaligned] = "__unaligned",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_signed] = "signed",
  [anon_sym_unsigned] = "unsigned",
  [anon_sym_long] = "long",
  [anon_sym_short] = "short",
  [anon_sym_LBRACK] = "[",
  [anon_sym_static] = "static",
  [anon_sym_RBRACK] = "]",
  [anon_sym_EQ] = "=",
  [anon_sym_register] = "register",
  [anon_sym_inline] = "inline",
  [anon_sym___inline] = "__inline",
  [anon_sym___inline__] = "__inline__",
  [anon_sym___forceinline] = "__forceinline",
  [anon_sym_thread_local] = "thread_local",
  [anon_sym___thread] = "__thread",
  [anon_sym_const] = "const",
  [anon_sym_constexpr] = "constexpr",
  [anon_sym_volatile] = "volatile",
  [anon_sym_restrict] = "restrict",
  [anon_sym___restrict__] = "__restrict__",
  [anon_sym__Atomic] = "_Atomic",
  [anon_sym__Noreturn] = "_Noreturn",
  [anon_sym_noreturn] = "noreturn",
  [anon_sym__Nonnull] = "_Nonnull",
  [anon_sym_mutable] = "mutable",
  [anon_sym_constinit] = "constinit",
  [anon_sym_consteval] = "consteval",
  [anon_sym_alignas] = "alignas",
  [anon_sym__Alignas] = "_Alignas",
  [sym_primitive_type] = "primitive_type",
  [anon_sym_enum] = "enum",
  [anon_sym_class] = "class",
  [anon_sym_struct] = "struct",
  [anon_sym_union] = "union",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_for] = "for",
  [anon_sym_return] = "return",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_goto] = "goto",
  [anon_sym___try] = "__try",
  [anon_sym___except] = "__except",
  [anon_sym___finally] = "__finally",
  [anon_sym___leave] = "__leave",
  [anon_sym_QMARK] = "\?",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_and_eq] = "and_eq",
  [anon_sym_or_eq] = "or_eq",
  [anon_sym_xor_eq] = "xor_eq",
  [anon_sym_not] = "not",
  [anon_sym_compl] = "compl",
  [anon_sym_LT_EQ_GT] = "<=>",
  [anon_sym_or] = "or",
  [anon_sym_and] = "and",
  [anon_sym_bitor] = "bitor",
  [anon_sym_xor] = "xor",
  [anon_sym_bitand] = "bitand",
  [anon_sym_not_eq] = "not_eq",
  [anon_sym_is] = "is",
  [anon_sym_as] = "as",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_sizeof] = "sizeof",
  [anon_sym___alignof__] = "__alignof__",
  [anon_sym___alignof] = "__alignof",
  [anon_sym__alignof] = "_alignof",
  [anon_sym_alignof] = "alignof",
  [anon_sym__Alignof] = "_Alignof",
  [anon_sym_offsetof] = "offsetof",
  [anon_sym__Generic] = "_Generic",
  [anon_sym_asm] = "asm",
  [anon_sym___asm__] = "__asm__",
  [anon_sym___asm] = "__asm",
  [anon_sym___volatile__] = "__volatile__",
  [anon_sym_DOT] = ".",
  [anon_sym_DOT_STAR] = ".*",
  [anon_sym_DASH_GT] = "->",
  [sym_number_literal] = "number_literal",
  [anon_sym_L_SQUOTE] = "L'",
  [anon_sym_u_SQUOTE] = "u'",
  [anon_sym_U_SQUOTE] = "U'",
  [anon_sym_u8_SQUOTE] = "u8'",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_char_literal_token1] = "character",
  [anon_sym_L_DQUOTE] = "L\"",
  [anon_sym_u_DQUOTE] = "u\"",
  [anon_sym_U_DQUOTE] = "U\"",
  [anon_sym_u8_DQUOTE] = "u8\"",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_literal_token1] = "string_content",
  [sym_escape_sequence] = "escape_sequence",
  [sym_system_lib_string] = "system_lib_string",
  [sym_true] = "true",
  [sym_false] = "false",
  [anon_sym_NULL] = "NULL",
  [anon_sym_nullptr] = "nullptr",
  [sym_comment] = "comment",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_This] = "This",
  [anon_sym_decltype] = "decltype",
  [anon_sym_final] = "final",
  [anon_sym_override] = "override",
  [anon_sym_explicit] = "explicit",
  [anon_sym_typename] = "typename",
  [anon_sym_export] = "export",
  [anon_sym_module] = "module",
  [anon_sym_import] = "import",
  [anon_sym_private] = "private",
  [anon_sym_template] = "template",
  [anon_sym_GT2] = ">",
  [anon_sym_operator] = "operator",
  [anon_sym_try] = "try",
  [anon_sym_delete] = "delete",
  [aux_sym_pure_virtual_clause_token1] = "pure_virtual_clause_token1",
  [anon_sym_friend] = "friend",
  [anon_sym_public] = "public",
  [anon_sym_protected] = "protected",
  [anon_sym_noexcept] = "noexcept",
  [anon_sym_throw] = "throw",
  [anon_sym_namespace] = "namespace",
  [anon_sym_static_assert] = "static_assert",
  [anon_sym_concept] = "concept",
  [anon_sym_co_return] = "co_return",
  [anon_sym_co_yield] = "co_yield",
  [anon_sym_catch] = "catch",
  [anon_sym_R_DQUOTE] = "R\"",
  [anon_sym_LR_DQUOTE] = "LR\"",
  [anon_sym_uR_DQUOTE] = "uR\"",
  [anon_sym_UR_DQUOTE] = "UR\"",
  [anon_sym_u8R_DQUOTE] = "u8R\"",
  [anon_sym_co_await] = "co_await",
  [anon_sym_new] = "new",
  [anon_sym_requires] = "requires",
  [anon_sym_DASH_GT_STAR] = "->*",
  [anon_sym_LPAREN_RPAREN] = "()",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_DQUOTE_DQUOTE] = "\"\"",
  [sym_this] = "this",
  [sym_literal_suffix] = "literal_suffix",
  [anon_sym_discard] = "discard",
  [anon_sym_precise] = "precise",
  [anon_sym_shared] = "shared",
  [anon_sym_groupshared] = "groupshared",
  [anon_sym_uniform] = "uniform",
  [anon_sym_row_major] = "row_major",
  [anon_sym_column_major] = "column_major",
  [anon_sym_globallycoherent] = "globallycoherent",
  [anon_sym_centroid] = "centroid",
  [anon_sym_noperspective] = "noperspective",
  [anon_sym_nointerpolation] = "nointerpolation",
  [anon_sym_sample] = "sample",
  [anon_sym_linear] = "linear",
  [anon_sym_snorm] = "snorm",
  [anon_sym_unorm] = "unorm",
  [anon_sym_point] = "point",
  [anon_sym_line] = "line",
  [anon_sym_triangleadj] = "triangleadj",
  [anon_sym_lineadj] = "lineadj",
  [anon_sym_triangle] = "triangle",
  [anon_sym_cbuffer] = "cbuffer",
  [anon_sym_interface] = "interface",
  [anon_sym_extension] = "extension",
  [anon_sym_where] = "where",
  [anon_sym___exported] = "__exported",
  [anon_sym___init] = "__init",
  [anon_sym___subscript] = "__subscript",
  [anon_sym_property] = "property",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_associatedtype] = "associatedtype",
  [sym_raw_string_delimiter] = "raw_string_delimiter",
  [sym_raw_string_content] = "raw_string_content",
  [sym_translation_unit] = "translation_unit",
  [sym__top_level_item] = "_top_level_item",
  [sym__block_item] = "_block_item",
  [sym_preproc_include] = "preproc_include",
  [sym_preproc_def] = "preproc_def",
  [sym_preproc_function_def] = "preproc_function_def",
  [sym_preproc_params] = "preproc_params",
  [sym_preproc_call] = "preproc_call",
  [sym_preproc_if] = "preproc_if",
  [sym_preproc_ifdef] = "preproc_ifdef",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_elif] = "preproc_elif",
  [sym_preproc_elifdef] = "preproc_elifdef",
  [sym_preproc_if_in_field_declaration_list] = "preproc_if",
  [sym_preproc_ifdef_in_field_declaration_list] = "preproc_ifdef",
  [sym_preproc_else_in_field_declaration_list] = "preproc_else",
  [sym_preproc_elif_in_field_declaration_list] = "preproc_elif",
  [sym_preproc_elifdef_in_field_declaration_list] = "preproc_elifdef",
  [sym_preproc_if_in_enumerator_list] = "preproc_if",
  [sym_preproc_ifdef_in_enumerator_list] = "preproc_ifdef",
  [sym_preproc_else_in_enumerator_list] = "preproc_else",
  [sym_preproc_elif_in_enumerator_list] = "preproc_elif",
  [sym_preproc_elifdef_in_enumerator_list] = "preproc_elifdef",
  [sym_preproc_if_in_enumerator_list_no_comma] = "preproc_if",
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = "preproc_ifdef",
  [sym_preproc_else_in_enumerator_list_no_comma] = "preproc_else",
  [sym_preproc_elif_in_enumerator_list_no_comma] = "preproc_elif",
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = "preproc_elifdef",
  [sym__preproc_expression] = "_preproc_expression",
  [sym_preproc_parenthesized_expression] = "parenthesized_expression",
  [sym_preproc_defined] = "preproc_defined",
  [sym_preproc_unary_expression] = "unary_expression",
  [sym_preproc_call_expression] = "call_expression",
  [sym_preproc_argument_list] = "argument_list",
  [sym_preproc_binary_expression] = "binary_expression",
  [sym_function_definition] = "function_definition",
  [sym_declaration] = "declaration",
  [sym_type_definition] = "type_definition",
  [sym__type_definition_type] = "_type_definition_type",
  [sym__type_definition_declarators] = "_type_definition_declarators",
  [sym__declaration_modifiers] = "_declaration_modifiers",
  [sym__declaration_specifiers] = "_declaration_specifiers",
  [sym_linkage_specification] = "linkage_specification",
  [sym_attribute_specifier] = "attribute_specifier",
  [sym_attribute] = "attribute",
  [sym_attribute_declaration] = "attribute_declaration",
  [sym_ms_declspec_modifier] = "ms_declspec_modifier",
  [sym_ms_based_modifier] = "ms_based_modifier",
  [sym_ms_call_modifier] = "ms_call_modifier",
  [sym_ms_unaligned_ptr_modifier] = "ms_unaligned_ptr_modifier",
  [sym_ms_pointer_modifier] = "ms_pointer_modifier",
  [sym_declaration_list] = "declaration_list",
  [sym__declarator] = "_declarator",
  [sym__field_declarator] = "_field_declarator",
  [sym__type_declarator] = "_type_declarator",
  [sym__abstract_declarator] = "_abstract_declarator",
  [sym_parenthesized_declarator] = "parenthesized_declarator",
  [sym_parenthesized_field_declarator] = "parenthesized_declarator",
  [sym_parenthesized_type_declarator] = "parenthesized_declarator",
  [sym_abstract_parenthesized_declarator] = "abstract_parenthesized_declarator",
  [sym_attributed_declarator] = "attributed_declarator",
  [sym_attributed_field_declarator] = "attributed_declarator",
  [sym_attributed_type_declarator] = "attributed_declarator",
  [sym_pointer_declarator] = "pointer_declarator",
  [sym_pointer_field_declarator] = "pointer_declarator",
  [sym_pointer_type_declarator] = "pointer_type_declarator",
  [sym_abstract_pointer_declarator] = "abstract_pointer_declarator",
  [sym_function_declarator] = "function_declarator",
  [sym_function_field_declarator] = "function_declarator",
  [sym_function_type_declarator] = "function_declarator",
  [sym_abstract_function_declarator] = "abstract_function_declarator",
  [sym_array_declarator] = "array_declarator",
  [sym_array_field_declarator] = "array_declarator",
  [sym_array_type_declarator] = "array_declarator",
  [sym_abstract_array_declarator] = "abstract_array_declarator",
  [sym_init_declarator] = "init_declarator",
  [sym_compound_statement] = "compound_statement",
  [sym_storage_class_specifier] = "storage_class_specifier",
  [sym_type_qualifier] = "type_qualifier",
  [sym_alignas_qualifier] = "alignas_qualifier",
  [sym_type_specifier] = "type_specifier",
  [sym_sized_type_specifier] = "sized_type_specifier",
  [sym_enum_specifier] = "enum_specifier",
  [sym_enumerator_list] = "enumerator_list",
  [sym_struct_specifier] = "struct_specifier",
  [sym_union_specifier] = "union_specifier",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym__field_declaration_list_item] = "_field_declaration_list_item",
  [sym_field_declaration] = "field_declaration",
  [sym_bitfield_clause] = "bitfield_clause",
  [sym_enumerator] = "enumerator",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_attributed_statement] = "attributed_statement",
  [sym_statement] = "statement",
  [sym__top_level_statement] = "_top_level_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym__top_level_expression_statement] = "expression_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym_else_clause] = "else_clause",
  [sym_switch_statement] = "switch_statement",
  [sym_case_statement] = "case_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym__for_statement_body] = "_for_statement_body",
  [sym_return_statement] = "return_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_goto_statement] = "goto_statement",
  [sym_seh_try_statement] = "seh_try_statement",
  [sym_seh_except_clause] = "seh_except_clause",
  [sym_seh_finally_clause] = "seh_finally_clause",
  [sym_seh_leave_statement] = "seh_leave_statement",
  [sym_expression] = "expression",
  [sym__string] = "_string",
  [sym_comma_expression] = "comma_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_pointer_expression] = "pointer_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_update_expression] = "update_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_type_descriptor] = "type_descriptor",
  [sym_sizeof_expression] = "sizeof_expression",
  [sym_alignof_expression] = "alignof_expression",
  [sym_offsetof_expression] = "offsetof_expression",
  [sym_generic_expression] = "generic_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_call_expression] = "call_expression",
  [sym_gnu_asm_expression] = "gnu_asm_expression",
  [sym_gnu_asm_qualifier] = "gnu_asm_qualifier",
  [sym_gnu_asm_output_operand_list] = "gnu_asm_output_operand_list",
  [sym_gnu_asm_output_operand] = "gnu_asm_output_operand",
  [sym_gnu_asm_input_operand_list] = "gnu_asm_input_operand_list",
  [sym_gnu_asm_input_operand] = "gnu_asm_input_operand",
  [sym_gnu_asm_clobber_list] = "gnu_asm_clobber_list",
  [sym_gnu_asm_goto_list] = "gnu_asm_goto_list",
  [sym_extension_expression] = "extension_expression",
  [sym_argument_list] = "argument_list",
  [sym_field_expression] = "field_expression",
  [sym_compound_literal_expression] = "compound_literal_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_initializer_list] = "initializer_list",
  [sym_initializer_pair] = "initializer_pair",
  [sym_subscript_designator] = "subscript_designator",
  [sym_subscript_range_designator] = "subscript_range_designator",
  [sym_field_designator] = "field_designator",
  [sym_char_literal] = "char_literal",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string_literal] = "string_literal",
  [sym_null] = "null",
  [sym__empty_declaration] = "_empty_declaration",
  [sym_placeholder_type_specifier] = "placeholder_type_specifier",
  [sym_decltype] = "decltype",
  [sym__class_declaration] = "_class_declaration",
  [sym__class_declaration_item] = "_class_declaration_item",
  [sym_class_specifier] = "class_specifier",
  [sym__class_name] = "_class_name",
  [sym_virtual_specifier] = "virtual_specifier",
  [sym_explicit_function_specifier] = "explicit_function_specifier",
  [sym_base_class_clause] = "base_class_clause",
  [sym__enum_base_clause] = "_enum_base_clause",
  [sym_dependent_type] = "dependent_type",
  [sym_module_name] = "module_name",
  [sym_module_partition] = "module_partition",
  [sym_module_declaration] = "module_declaration",
  [sym_export_declaration] = "export_declaration",
  [sym_import_declaration] = "import_declaration",
  [sym_global_module_fragment_declaration] = "global_module_fragment_declaration",
  [sym_private_module_fragment_declaration] = "private_module_fragment_declaration",
  [sym_template_declaration] = "template_declaration",
  [sym_template_instantiation] = "template_instantiation",
  [sym_template_parameter_list] = "template_parameter_list",
  [sym_type_parameter_declaration] = "type_parameter_declaration",
  [sym_variadic_type_parameter_declaration] = "variadic_type_parameter_declaration",
  [sym_optional_type_parameter_declaration] = "optional_type_parameter_declaration",
  [sym_template_template_parameter_declaration] = "template_template_parameter_declaration",
  [sym_optional_parameter_declaration] = "optional_parameter_declaration",
  [sym_variadic_parameter_declaration] = "variadic_parameter_declaration",
  [sym_variadic_declarator] = "variadic_declarator",
  [sym_variadic_reference_declarator] = "reference_declarator",
  [sym_operator_cast] = "operator_cast",
  [sym_field_initializer_list] = "field_initializer_list",
  [sym_field_initializer] = "field_initializer",
  [sym_inline_method_definition] = "function_definition",
  [sym__constructor_specifiers] = "_constructor_specifiers",
  [sym_operator_cast_definition] = "function_definition",
  [sym_operator_cast_declaration] = "declaration",
  [sym_constructor_try_statement] = "try_statement",
  [sym_constructor_or_destructor_definition] = "function_definition",
  [sym_constructor_or_destructor_declaration] = "declaration",
  [sym_default_method_clause] = "default_method_clause",
  [sym_delete_method_clause] = "delete_method_clause",
  [sym_pure_virtual_clause] = "pure_virtual_clause",
  [sym_friend_declaration] = "friend_declaration",
  [sym_access_specifier] = "access_specifier",
  [sym_reference_declarator] = "reference_declarator",
  [sym_reference_field_declarator] = "reference_declarator",
  [sym_reference_type_declarator] = "reference_declarator",
  [sym_abstract_reference_declarator] = "abstract_reference_declarator",
  [sym_structured_binding_declarator] = "structured_binding_declarator",
  [sym_ref_qualifier] = "ref_qualifier",
  [sym__function_declarator_seq] = "_function_declarator_seq",
  [sym__function_attributes_start] = "_function_attributes_start",
  [sym__function_exception_specification] = "_function_exception_specification",
  [sym__function_attributes_end] = "_function_attributes_end",
  [sym__function_postfix] = "_function_postfix",
  [sym_trailing_return_type] = "trailing_return_type",
  [sym_noexcept] = "noexcept",
  [sym_throw_specifier] = "throw_specifier",
  [sym_template_type] = "template_type",
  [sym_template_method] = "template_method",
  [sym_template_function] = "template_function",
  [sym_template_argument_list] = "template_argument_list",
  [sym_namespace_definition] = "namespace_definition",
  [sym_namespace_alias_definition] = "namespace_alias_definition",
  [sym__namespace_specifier] = "_namespace_specifier",
  [sym_nested_namespace_specifier] = "nested_namespace_specifier",
  [sym_using_declaration] = "using_declaration",
  [sym_alias_declaration] = "alias_declaration",
  [sym_static_assert_declaration] = "static_assert_declaration",
  [sym_concept_definition] = "concept_definition",
  [sym_for_range_loop] = "for_range_loop",
  [sym__for_range_loop_body] = "_for_range_loop_body",
  [sym_init_statement] = "init_statement",
  [sym_condition_clause] = "condition_clause",
  [sym_condition_declaration] = "declaration",
  [sym_co_return_statement] = "co_return_statement",
  [sym_co_yield_statement] = "co_yield_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_raw_string_literal] = "raw_string_literal",
  [sym_subscript_argument_list] = "subscript_argument_list",
  [sym_co_await_expression] = "co_await_expression",
  [sym_new_expression] = "new_expression",
  [sym_new_declarator] = "new_declarator",
  [sym_delete_expression] = "delete_expression",
  [sym_type_requirement] = "type_requirement",
  [sym_compound_requirement] = "compound_requirement",
  [sym__requirement] = "_requirement",
  [sym_requirement_seq] = "requirement_seq",
  [sym_constraint_conjunction] = "constraint_conjunction",
  [sym_constraint_disjunction] = "constraint_disjunction",
  [sym__requirement_clause_constraint] = "_requirement_clause_constraint",
  [sym_requires_clause] = "requires_clause",
  [sym_requires_parameter_list] = "parameter_list",
  [sym_requires_expression] = "requires_expression",
  [sym_lambda_declarator] = "lambda_declarator",
  [sym_lambda_expression] = "lambda_expression",
  [sym_lambda_capture_specifier] = "lambda_capture_specifier",
  [sym_lambda_default_capture] = "lambda_default_capture",
  [sym__lambda_capture_identifier] = "_lambda_capture_identifier",
  [sym_lambda_capture_initializer] = "lambda_capture_initializer",
  [sym__lambda_capture] = "_lambda_capture",
  [sym__fold_operator] = "_fold_operator",
  [sym__binary_fold_operator] = "_binary_fold_operator",
  [sym__unary_left_fold] = "_unary_left_fold",
  [sym__unary_right_fold] = "_unary_right_fold",
  [sym__binary_fold] = "_binary_fold",
  [sym_fold_expression] = "fold_expression",
  [sym_parameter_pack_expansion] = "parameter_pack_expansion",
  [sym_type_parameter_pack_expansion] = "parameter_pack_expansion",
  [sym_identifier_parameter_pack_expansion] = "parameter_pack_expansion",
  [sym_destructor_name] = "destructor_name",
  [sym_dependent_identifier] = "dependent_name",
  [sym_dependent_field_identifier] = "dependent_name",
  [sym_dependent_type_identifier] = "dependent_name",
  [sym__scope_resolution] = "_scope_resolution",
  [sym_qualified_field_identifier] = "qualified_identifier",
  [sym_qualified_identifier] = "qualified_identifier",
  [sym_qualified_type_identifier] = "qualified_identifier",
  [sym_qualified_operator_cast_identifier] = "qualified_identifier",
  [sym__assignment_expression_lhs] = "assignment_expression",
  [sym_operator_name] = "operator_name",
  [sym_user_defined_literal] = "user_defined_literal",
  [sym_semantics] = "semantics",
  [sym_discard_statement] = "discard_statement",
  [sym_qualifiers] = "qualifiers",
  [sym_cbuffer_specifier] = "cbuffer_specifier",
  [sym_hlsl_attribute] = "hlsl_attribute",
  [sym_type_hinted_declarator] = "type_hinted_declarator",
  [sym_type_hint] = "type_hint",
  [sym_interface_specifier] = "interface_specifier",
  [sym_extension_specifier] = "extension_specifier",
  [sym_interface_requirements] = "interface_requirements",
  [sym_where_clause] = "where_clause",
  [sym_import_statement] = "import_statement",
  [sym_init_declaration] = "init_declaration",
  [sym_subscript_declaration] = "subscript_declaration",
  [sym_property_declaration] = "property_declaration",
  [sym_property_get] = "property_get",
  [sym_property_set] = "property_set",
  [sym_associatedtype_declaration] = "associatedtype_declaration",
  [sym_associatedtype_specifier] = "associatedtype_specifier",
  [aux_sym_translation_unit_repeat1] = "translation_unit_repeat1",
  [aux_sym_preproc_params_repeat1] = "preproc_params_repeat1",
  [aux_sym_preproc_if_repeat1] = "preproc_if_repeat1",
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = "preproc_if_in_field_declaration_list_repeat1",
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = "preproc_if_in_enumerator_list_repeat1",
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = "preproc_if_in_enumerator_list_no_comma_repeat1",
  [aux_sym_preproc_argument_list_repeat1] = "preproc_argument_list_repeat1",
  [aux_sym_declaration_repeat1] = "declaration_repeat1",
  [aux_sym_type_definition_repeat1] = "type_definition_repeat1",
  [aux_sym__type_definition_type_repeat1] = "_type_definition_type_repeat1",
  [aux_sym__type_definition_declarators_repeat1] = "_type_definition_declarators_repeat1",
  [aux_sym__declaration_specifiers_repeat1] = "_declaration_specifiers_repeat1",
  [aux_sym_attribute_declaration_repeat1] = "attribute_declaration_repeat1",
  [aux_sym_declaration_list_repeat1] = "declaration_list_repeat1",
  [aux_sym_attributed_declarator_repeat1] = "attributed_declarator_repeat1",
  [aux_sym_pointer_declarator_repeat1] = "pointer_declarator_repeat1",
  [aux_sym_array_declarator_repeat1] = "array_declarator_repeat1",
  [aux_sym_sized_type_specifier_repeat1] = "sized_type_specifier_repeat1",
  [aux_sym_enumerator_list_repeat1] = "enumerator_list_repeat1",
  [aux_sym_field_declaration_repeat1] = "field_declaration_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_generic_expression_repeat1] = "generic_expression_repeat1",
  [aux_sym_gnu_asm_expression_repeat1] = "gnu_asm_expression_repeat1",
  [aux_sym_gnu_asm_output_operand_list_repeat1] = "gnu_asm_output_operand_list_repeat1",
  [aux_sym_gnu_asm_input_operand_list_repeat1] = "gnu_asm_input_operand_list_repeat1",
  [aux_sym_gnu_asm_clobber_list_repeat1] = "gnu_asm_clobber_list_repeat1",
  [aux_sym_gnu_asm_goto_list_repeat1] = "gnu_asm_goto_list_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_initializer_list_repeat1] = "initializer_list_repeat1",
  [aux_sym_initializer_pair_repeat1] = "initializer_pair_repeat1",
  [aux_sym_char_literal_repeat1] = "char_literal_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [aux_sym__class_declaration_repeat1] = "_class_declaration_repeat1",
  [aux_sym_base_class_clause_repeat1] = "base_class_clause_repeat1",
  [aux_sym_module_name_repeat1] = "module_name_repeat1",
  [aux_sym_template_parameter_list_repeat1] = "template_parameter_list_repeat1",
  [aux_sym_field_initializer_list_repeat1] = "field_initializer_list_repeat1",
  [aux_sym_operator_cast_definition_repeat1] = "operator_cast_definition_repeat1",
  [aux_sym_constructor_try_statement_repeat1] = "constructor_try_statement_repeat1",
  [aux_sym_structured_binding_declarator_repeat1] = "structured_binding_declarator_repeat1",
  [aux_sym__function_postfix_repeat1] = "_function_postfix_repeat1",
  [aux_sym_throw_specifier_repeat1] = "throw_specifier_repeat1",
  [aux_sym_template_argument_list_repeat1] = "template_argument_list_repeat1",
  [aux_sym_subscript_argument_list_repeat1] = "subscript_argument_list_repeat1",
  [aux_sym_requirement_seq_repeat1] = "requirement_seq_repeat1",
  [aux_sym_requires_parameter_list_repeat1] = "requires_parameter_list_repeat1",
  [aux_sym_lambda_capture_specifier_repeat1] = "lambda_capture_specifier_repeat1",
  [aux_sym_interface_requirements_repeat1] = "interface_requirements_repeat1",
  [aux_sym_where_clause_repeat1] = "where_clause_repeat1",
  [aux_sym_subscript_declaration_repeat1] = "subscript_declaration_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_namespace_identifier] = "namespace_identifier",
  [alias_sym_simple_requirement] = "simple_requirement",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [aux_sym_preproc_include_token1] = aux_sym_preproc_include_token1,
  [aux_sym_preproc_include_token2] = aux_sym_preproc_include_token2,
  [aux_sym_preproc_def_token1] = aux_sym_preproc_def_token1,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [aux_sym_preproc_if_token1] = aux_sym_preproc_if_token1,
  [anon_sym_LF] = anon_sym_LF,
  [aux_sym_preproc_if_token2] = aux_sym_preproc_if_token2,
  [aux_sym_preproc_ifdef_token1] = aux_sym_preproc_ifdef_token1,
  [aux_sym_preproc_ifdef_token2] = aux_sym_preproc_ifdef_token2,
  [aux_sym_preproc_else_token1] = aux_sym_preproc_else_token1,
  [aux_sym_preproc_elif_token1] = aux_sym_preproc_elif_token1,
  [aux_sym_preproc_elifdef_token1] = aux_sym_preproc_elifdef_token1,
  [aux_sym_preproc_elifdef_token2] = aux_sym_preproc_elifdef_token2,
  [sym_preproc_arg] = sym_preproc_arg,
  [sym_preproc_directive] = sym_preproc_directive,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [anon_sym_defined] = anon_sym_defined,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym___extension__] = anon_sym___extension__,
  [anon_sym_typedef] = anon_sym_typedef,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_out] = anon_sym_out,
  [anon_sym_inout] = anon_sym_inout,
  [anon_sym_virtual] = anon_sym_virtual,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym___attribute__] = anon_sym___attribute__,
  [anon_sym___attribute] = anon_sym___attribute,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_LBRACK_LBRACK] = anon_sym_LBRACK_LBRACK,
  [anon_sym_RBRACK_RBRACK] = anon_sym_RBRACK_RBRACK,
  [anon_sym___declspec] = anon_sym___declspec,
  [anon_sym___based] = anon_sym___based,
  [anon_sym___cdecl] = anon_sym___cdecl,
  [anon_sym___clrcall] = anon_sym___clrcall,
  [anon_sym___stdcall] = anon_sym___stdcall,
  [anon_sym___fastcall] = anon_sym___fastcall,
  [anon_sym___thiscall] = anon_sym___thiscall,
  [anon_sym___vectorcall] = anon_sym___vectorcall,
  [sym_ms_restrict_modifier] = sym_ms_restrict_modifier,
  [sym_ms_unsigned_ptr_modifier] = sym_ms_unsigned_ptr_modifier,
  [sym_ms_signed_ptr_modifier] = sym_ms_signed_ptr_modifier,
  [anon_sym__unaligned] = anon_sym__unaligned,
  [anon_sym___unaligned] = anon_sym___unaligned,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_signed] = anon_sym_signed,
  [anon_sym_unsigned] = anon_sym_unsigned,
  [anon_sym_long] = anon_sym_long,
  [anon_sym_short] = anon_sym_short,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_register] = anon_sym_register,
  [anon_sym_inline] = anon_sym_inline,
  [anon_sym___inline] = anon_sym___inline,
  [anon_sym___inline__] = anon_sym___inline__,
  [anon_sym___forceinline] = anon_sym___forceinline,
  [anon_sym_thread_local] = anon_sym_thread_local,
  [anon_sym___thread] = anon_sym___thread,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_constexpr] = anon_sym_constexpr,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_restrict] = anon_sym_restrict,
  [anon_sym___restrict__] = anon_sym___restrict__,
  [anon_sym__Atomic] = anon_sym__Atomic,
  [anon_sym__Noreturn] = anon_sym__Noreturn,
  [anon_sym_noreturn] = anon_sym_noreturn,
  [anon_sym__Nonnull] = anon_sym__Nonnull,
  [anon_sym_mutable] = anon_sym_mutable,
  [anon_sym_constinit] = anon_sym_constinit,
  [anon_sym_consteval] = anon_sym_consteval,
  [anon_sym_alignas] = anon_sym_alignas,
  [anon_sym__Alignas] = anon_sym__Alignas,
  [sym_primitive_type] = sym_primitive_type,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym___try] = anon_sym___try,
  [anon_sym___except] = anon_sym___except,
  [anon_sym___finally] = anon_sym___finally,
  [anon_sym___leave] = anon_sym___leave,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_and_eq] = anon_sym_and_eq,
  [anon_sym_or_eq] = anon_sym_or_eq,
  [anon_sym_xor_eq] = anon_sym_xor_eq,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_compl] = anon_sym_compl,
  [anon_sym_LT_EQ_GT] = anon_sym_LT_EQ_GT,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_bitor] = anon_sym_bitor,
  [anon_sym_xor] = anon_sym_xor,
  [anon_sym_bitand] = anon_sym_bitand,
  [anon_sym_not_eq] = anon_sym_not_eq,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_sizeof] = anon_sym_sizeof,
  [anon_sym___alignof__] = anon_sym___alignof__,
  [anon_sym___alignof] = anon_sym___alignof,
  [anon_sym__alignof] = anon_sym__alignof,
  [anon_sym_alignof] = anon_sym_alignof,
  [anon_sym__Alignof] = anon_sym__Alignof,
  [anon_sym_offsetof] = anon_sym_offsetof,
  [anon_sym__Generic] = anon_sym__Generic,
  [anon_sym_asm] = anon_sym_asm,
  [anon_sym___asm__] = anon_sym___asm__,
  [anon_sym___asm] = anon_sym___asm,
  [anon_sym___volatile__] = anon_sym___volatile__,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DOT_STAR] = anon_sym_DOT_STAR,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [sym_number_literal] = sym_number_literal,
  [anon_sym_L_SQUOTE] = anon_sym_L_SQUOTE,
  [anon_sym_u_SQUOTE] = anon_sym_u_SQUOTE,
  [anon_sym_U_SQUOTE] = anon_sym_U_SQUOTE,
  [anon_sym_u8_SQUOTE] = anon_sym_u8_SQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_char_literal_token1] = aux_sym_char_literal_token1,
  [anon_sym_L_DQUOTE] = anon_sym_L_DQUOTE,
  [anon_sym_u_DQUOTE] = anon_sym_u_DQUOTE,
  [anon_sym_U_DQUOTE] = anon_sym_U_DQUOTE,
  [anon_sym_u8_DQUOTE] = anon_sym_u8_DQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_literal_token1] = aux_sym_string_literal_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_system_lib_string] = sym_system_lib_string,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [anon_sym_NULL] = anon_sym_NULL,
  [anon_sym_nullptr] = anon_sym_nullptr,
  [sym_comment] = sym_comment,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_This] = anon_sym_This,
  [anon_sym_decltype] = anon_sym_decltype,
  [anon_sym_final] = anon_sym_final,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_explicit] = anon_sym_explicit,
  [anon_sym_typename] = anon_sym_typename,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_template] = anon_sym_template,
  [anon_sym_GT2] = anon_sym_GT,
  [anon_sym_operator] = anon_sym_operator,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_delete] = anon_sym_delete,
  [aux_sym_pure_virtual_clause_token1] = aux_sym_pure_virtual_clause_token1,
  [anon_sym_friend] = anon_sym_friend,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_noexcept] = anon_sym_noexcept,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_static_assert] = anon_sym_static_assert,
  [anon_sym_concept] = anon_sym_concept,
  [anon_sym_co_return] = anon_sym_co_return,
  [anon_sym_co_yield] = anon_sym_co_yield,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_R_DQUOTE] = anon_sym_R_DQUOTE,
  [anon_sym_LR_DQUOTE] = anon_sym_LR_DQUOTE,
  [anon_sym_uR_DQUOTE] = anon_sym_uR_DQUOTE,
  [anon_sym_UR_DQUOTE] = anon_sym_UR_DQUOTE,
  [anon_sym_u8R_DQUOTE] = anon_sym_u8R_DQUOTE,
  [anon_sym_co_await] = anon_sym_co_await,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_requires] = anon_sym_requires,
  [anon_sym_DASH_GT_STAR] = anon_sym_DASH_GT_STAR,
  [anon_sym_LPAREN_RPAREN] = anon_sym_LPAREN_RPAREN,
  [anon_sym_LBRACK_RBRACK] = anon_sym_LBRACK_RBRACK,
  [anon_sym_DQUOTE_DQUOTE] = anon_sym_DQUOTE_DQUOTE,
  [sym_this] = sym_this,
  [sym_literal_suffix] = sym_literal_suffix,
  [anon_sym_discard] = anon_sym_discard,
  [anon_sym_precise] = anon_sym_precise,
  [anon_sym_shared] = anon_sym_shared,
  [anon_sym_groupshared] = anon_sym_groupshared,
  [anon_sym_uniform] = anon_sym_uniform,
  [anon_sym_row_major] = anon_sym_row_major,
  [anon_sym_column_major] = anon_sym_column_major,
  [anon_sym_globallycoherent] = anon_sym_globallycoherent,
  [anon_sym_centroid] = anon_sym_centroid,
  [anon_sym_noperspective] = anon_sym_noperspective,
  [anon_sym_nointerpolation] = anon_sym_nointerpolation,
  [anon_sym_sample] = anon_sym_sample,
  [anon_sym_linear] = anon_sym_linear,
  [anon_sym_snorm] = anon_sym_snorm,
  [anon_sym_unorm] = anon_sym_unorm,
  [anon_sym_point] = anon_sym_point,
  [anon_sym_line] = anon_sym_line,
  [anon_sym_triangleadj] = anon_sym_triangleadj,
  [anon_sym_lineadj] = anon_sym_lineadj,
  [anon_sym_triangle] = anon_sym_triangle,
  [anon_sym_cbuffer] = anon_sym_cbuffer,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_extension] = anon_sym_extension,
  [anon_sym_where] = anon_sym_where,
  [anon_sym___exported] = anon_sym___exported,
  [anon_sym___init] = anon_sym___init,
  [anon_sym___subscript] = anon_sym___subscript,
  [anon_sym_property] = anon_sym_property,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_associatedtype] = anon_sym_associatedtype,
  [sym_raw_string_delimiter] = sym_raw_string_delimiter,
  [sym_raw_string_content] = sym_raw_string_content,
  [sym_translation_unit] = sym_translation_unit,
  [sym__top_level_item] = sym__top_level_item,
  [sym__block_item] = sym__block_item,
  [sym_preproc_include] = sym_preproc_include,
  [sym_preproc_def] = sym_preproc_def,
  [sym_preproc_function_def] = sym_preproc_function_def,
  [sym_preproc_params] = sym_preproc_params,
  [sym_preproc_call] = sym_preproc_call,
  [sym_preproc_if] = sym_preproc_if,
  [sym_preproc_ifdef] = sym_preproc_ifdef,
  [sym_preproc_else] = sym_preproc_else,
  [sym_preproc_elif] = sym_preproc_elif,
  [sym_preproc_elifdef] = sym_preproc_elifdef,
  [sym_preproc_if_in_field_declaration_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_field_declaration_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_field_declaration_list] = sym_preproc_else,
  [sym_preproc_elif_in_field_declaration_list] = sym_preproc_elif,
  [sym_preproc_elifdef_in_field_declaration_list] = sym_preproc_elifdef,
  [sym_preproc_if_in_enumerator_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_enumerator_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_enumerator_list] = sym_preproc_else,
  [sym_preproc_elif_in_enumerator_list] = sym_preproc_elif,
  [sym_preproc_elifdef_in_enumerator_list] = sym_preproc_elifdef,
  [sym_preproc_if_in_enumerator_list_no_comma] = sym_preproc_if,
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = sym_preproc_ifdef,
  [sym_preproc_else_in_enumerator_list_no_comma] = sym_preproc_else,
  [sym_preproc_elif_in_enumerator_list_no_comma] = sym_preproc_elif,
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = sym_preproc_elifdef,
  [sym__preproc_expression] = sym__preproc_expression,
  [sym_preproc_parenthesized_expression] = sym_parenthesized_expression,
  [sym_preproc_defined] = sym_preproc_defined,
  [sym_preproc_unary_expression] = sym_unary_expression,
  [sym_preproc_call_expression] = sym_call_expression,
  [sym_preproc_argument_list] = sym_argument_list,
  [sym_preproc_binary_expression] = sym_binary_expression,
  [sym_function_definition] = sym_function_definition,
  [sym_declaration] = sym_declaration,
  [sym_type_definition] = sym_type_definition,
  [sym__type_definition_type] = sym__type_definition_type,
  [sym__type_definition_declarators] = sym__type_definition_declarators,
  [sym__declaration_modifiers] = sym__declaration_modifiers,
  [sym__declaration_specifiers] = sym__declaration_specifiers,
  [sym_linkage_specification] = sym_linkage_specification,
  [sym_attribute_specifier] = sym_attribute_specifier,
  [sym_attribute] = sym_attribute,
  [sym_attribute_declaration] = sym_attribute_declaration,
  [sym_ms_declspec_modifier] = sym_ms_declspec_modifier,
  [sym_ms_based_modifier] = sym_ms_based_modifier,
  [sym_ms_call_modifier] = sym_ms_call_modifier,
  [sym_ms_unaligned_ptr_modifier] = sym_ms_unaligned_ptr_modifier,
  [sym_ms_pointer_modifier] = sym_ms_pointer_modifier,
  [sym_declaration_list] = sym_declaration_list,
  [sym__declarator] = sym__declarator,
  [sym__field_declarator] = sym__field_declarator,
  [sym__type_declarator] = sym__type_declarator,
  [sym__abstract_declarator] = sym__abstract_declarator,
  [sym_parenthesized_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_field_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_type_declarator] = sym_parenthesized_declarator,
  [sym_abstract_parenthesized_declarator] = sym_abstract_parenthesized_declarator,
  [sym_attributed_declarator] = sym_attributed_declarator,
  [sym_attributed_field_declarator] = sym_attributed_declarator,
  [sym_attributed_type_declarator] = sym_attributed_declarator,
  [sym_pointer_declarator] = sym_pointer_declarator,
  [sym_pointer_field_declarator] = sym_pointer_declarator,
  [sym_pointer_type_declarator] = sym_pointer_type_declarator,
  [sym_abstract_pointer_declarator] = sym_abstract_pointer_declarator,
  [sym_function_declarator] = sym_function_declarator,
  [sym_function_field_declarator] = sym_function_declarator,
  [sym_function_type_declarator] = sym_function_declarator,
  [sym_abstract_function_declarator] = sym_abstract_function_declarator,
  [sym_array_declarator] = sym_array_declarator,
  [sym_array_field_declarator] = sym_array_declarator,
  [sym_array_type_declarator] = sym_array_declarator,
  [sym_abstract_array_declarator] = sym_abstract_array_declarator,
  [sym_init_declarator] = sym_init_declarator,
  [sym_compound_statement] = sym_compound_statement,
  [sym_storage_class_specifier] = sym_storage_class_specifier,
  [sym_type_qualifier] = sym_type_qualifier,
  [sym_alignas_qualifier] = sym_alignas_qualifier,
  [sym_type_specifier] = sym_type_specifier,
  [sym_sized_type_specifier] = sym_sized_type_specifier,
  [sym_enum_specifier] = sym_enum_specifier,
  [sym_enumerator_list] = sym_enumerator_list,
  [sym_struct_specifier] = sym_struct_specifier,
  [sym_union_specifier] = sym_union_specifier,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym__field_declaration_list_item] = sym__field_declaration_list_item,
  [sym_field_declaration] = sym_field_declaration,
  [sym_bitfield_clause] = sym_bitfield_clause,
  [sym_enumerator] = sym_enumerator,
  [sym_parameter_list] = sym_parameter_list,
  [sym_parameter_declaration] = sym_parameter_declaration,
  [sym_attributed_statement] = sym_attributed_statement,
  [sym_statement] = sym_statement,
  [sym__top_level_statement] = sym__top_level_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym__top_level_expression_statement] = sym_expression_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_else_clause] = sym_else_clause,
  [sym_switch_statement] = sym_switch_statement,
  [sym_case_statement] = sym_case_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_for_statement] = sym_for_statement,
  [sym__for_statement_body] = sym__for_statement_body,
  [sym_return_statement] = sym_return_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym_seh_try_statement] = sym_seh_try_statement,
  [sym_seh_except_clause] = sym_seh_except_clause,
  [sym_seh_finally_clause] = sym_seh_finally_clause,
  [sym_seh_leave_statement] = sym_seh_leave_statement,
  [sym_expression] = sym_expression,
  [sym__string] = sym__string,
  [sym_comma_expression] = sym_comma_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_pointer_expression] = sym_pointer_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_type_descriptor] = sym_type_descriptor,
  [sym_sizeof_expression] = sym_sizeof_expression,
  [sym_alignof_expression] = sym_alignof_expression,
  [sym_offsetof_expression] = sym_offsetof_expression,
  [sym_generic_expression] = sym_generic_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_gnu_asm_expression] = sym_gnu_asm_expression,
  [sym_gnu_asm_qualifier] = sym_gnu_asm_qualifier,
  [sym_gnu_asm_output_operand_list] = sym_gnu_asm_output_operand_list,
  [sym_gnu_asm_output_operand] = sym_gnu_asm_output_operand,
  [sym_gnu_asm_input_operand_list] = sym_gnu_asm_input_operand_list,
  [sym_gnu_asm_input_operand] = sym_gnu_asm_input_operand,
  [sym_gnu_asm_clobber_list] = sym_gnu_asm_clobber_list,
  [sym_gnu_asm_goto_list] = sym_gnu_asm_goto_list,
  [sym_extension_expression] = sym_extension_expression,
  [sym_argument_list] = sym_argument_list,
  [sym_field_expression] = sym_field_expression,
  [sym_compound_literal_expression] = sym_compound_literal_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_initializer_list] = sym_initializer_list,
  [sym_initializer_pair] = sym_initializer_pair,
  [sym_subscript_designator] = sym_subscript_designator,
  [sym_subscript_range_designator] = sym_subscript_range_designator,
  [sym_field_designator] = sym_field_designator,
  [sym_char_literal] = sym_char_literal,
  [sym_concatenated_string] = sym_concatenated_string,
  [sym_string_literal] = sym_string_literal,
  [sym_null] = sym_null,
  [sym__empty_declaration] = sym__empty_declaration,
  [sym_placeholder_type_specifier] = sym_placeholder_type_specifier,
  [sym_decltype] = sym_decltype,
  [sym__class_declaration] = sym__class_declaration,
  [sym__class_declaration_item] = sym__class_declaration_item,
  [sym_class_specifier] = sym_class_specifier,
  [sym__class_name] = sym__class_name,
  [sym_virtual_specifier] = sym_virtual_specifier,
  [sym_explicit_function_specifier] = sym_explicit_function_specifier,
  [sym_base_class_clause] = sym_base_class_clause,
  [sym__enum_base_clause] = sym__enum_base_clause,
  [sym_dependent_type] = sym_dependent_type,
  [sym_module_name] = sym_module_name,
  [sym_module_partition] = sym_module_partition,
  [sym_module_declaration] = sym_module_declaration,
  [sym_export_declaration] = sym_export_declaration,
  [sym_import_declaration] = sym_import_declaration,
  [sym_global_module_fragment_declaration] = sym_global_module_fragment_declaration,
  [sym_private_module_fragment_declaration] = sym_private_module_fragment_declaration,
  [sym_template_declaration] = sym_template_declaration,
  [sym_template_instantiation] = sym_template_instantiation,
  [sym_template_parameter_list] = sym_template_parameter_list,
  [sym_type_parameter_declaration] = sym_type_parameter_declaration,
  [sym_variadic_type_parameter_declaration] = sym_variadic_type_parameter_declaration,
  [sym_optional_type_parameter_declaration] = sym_optional_type_parameter_declaration,
  [sym_template_template_parameter_declaration] = sym_template_template_parameter_declaration,
  [sym_optional_parameter_declaration] = sym_optional_parameter_declaration,
  [sym_variadic_parameter_declaration] = sym_variadic_parameter_declaration,
  [sym_variadic_declarator] = sym_variadic_declarator,
  [sym_variadic_reference_declarator] = sym_reference_declarator,
  [sym_operator_cast] = sym_operator_cast,
  [sym_field_initializer_list] = sym_field_initializer_list,
  [sym_field_initializer] = sym_field_initializer,
  [sym_inline_method_definition] = sym_function_definition,
  [sym__constructor_specifiers] = sym__constructor_specifiers,
  [sym_operator_cast_definition] = sym_function_definition,
  [sym_operator_cast_declaration] = sym_declaration,
  [sym_constructor_try_statement] = sym_try_statement,
  [sym_constructor_or_destructor_definition] = sym_function_definition,
  [sym_constructor_or_destructor_declaration] = sym_declaration,
  [sym_default_method_clause] = sym_default_method_clause,
  [sym_delete_method_clause] = sym_delete_method_clause,
  [sym_pure_virtual_clause] = sym_pure_virtual_clause,
  [sym_friend_declaration] = sym_friend_declaration,
  [sym_access_specifier] = sym_access_specifier,
  [sym_reference_declarator] = sym_reference_declarator,
  [sym_reference_field_declarator] = sym_reference_declarator,
  [sym_reference_type_declarator] = sym_reference_declarator,
  [sym_abstract_reference_declarator] = sym_abstract_reference_declarator,
  [sym_structured_binding_declarator] = sym_structured_binding_declarator,
  [sym_ref_qualifier] = sym_ref_qualifier,
  [sym__function_declarator_seq] = sym__function_declarator_seq,
  [sym__function_attributes_start] = sym__function_attributes_start,
  [sym__function_exception_specification] = sym__function_exception_specification,
  [sym__function_attributes_end] = sym__function_attributes_end,
  [sym__function_postfix] = sym__function_postfix,
  [sym_trailing_return_type] = sym_trailing_return_type,
  [sym_noexcept] = sym_noexcept,
  [sym_throw_specifier] = sym_throw_specifier,
  [sym_template_type] = sym_template_type,
  [sym_template_method] = sym_template_method,
  [sym_template_function] = sym_template_function,
  [sym_template_argument_list] = sym_template_argument_list,
  [sym_namespace_definition] = sym_namespace_definition,
  [sym_namespace_alias_definition] = sym_namespace_alias_definition,
  [sym__namespace_specifier] = sym__namespace_specifier,
  [sym_nested_namespace_specifier] = sym_nested_namespace_specifier,
  [sym_using_declaration] = sym_using_declaration,
  [sym_alias_declaration] = sym_alias_declaration,
  [sym_static_assert_declaration] = sym_static_assert_declaration,
  [sym_concept_definition] = sym_concept_definition,
  [sym_for_range_loop] = sym_for_range_loop,
  [sym__for_range_loop_body] = sym__for_range_loop_body,
  [sym_init_statement] = sym_init_statement,
  [sym_condition_clause] = sym_condition_clause,
  [sym_condition_declaration] = sym_declaration,
  [sym_co_return_statement] = sym_co_return_statement,
  [sym_co_yield_statement] = sym_co_yield_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_raw_string_literal] = sym_raw_string_literal,
  [sym_subscript_argument_list] = sym_subscript_argument_list,
  [sym_co_await_expression] = sym_co_await_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_new_declarator] = sym_new_declarator,
  [sym_delete_expression] = sym_delete_expression,
  [sym_type_requirement] = sym_type_requirement,
  [sym_compound_requirement] = sym_compound_requirement,
  [sym__requirement] = sym__requirement,
  [sym_requirement_seq] = sym_requirement_seq,
  [sym_constraint_conjunction] = sym_constraint_conjunction,
  [sym_constraint_disjunction] = sym_constraint_disjunction,
  [sym__requirement_clause_constraint] = sym__requirement_clause_constraint,
  [sym_requires_clause] = sym_requires_clause,
  [sym_requires_parameter_list] = sym_parameter_list,
  [sym_requires_expression] = sym_requires_expression,
  [sym_lambda_declarator] = sym_lambda_declarator,
  [sym_lambda_expression] = sym_lambda_expression,
  [sym_lambda_capture_specifier] = sym_lambda_capture_specifier,
  [sym_lambda_default_capture] = sym_lambda_default_capture,
  [sym__lambda_capture_identifier] = sym__lambda_capture_identifier,
  [sym_lambda_capture_initializer] = sym_lambda_capture_initializer,
  [sym__lambda_capture] = sym__lambda_capture,
  [sym__fold_operator] = sym__fold_operator,
  [sym__binary_fold_operator] = sym__binary_fold_operator,
  [sym__unary_left_fold] = sym__unary_left_fold,
  [sym__unary_right_fold] = sym__unary_right_fold,
  [sym__binary_fold] = sym__binary_fold,
  [sym_fold_expression] = sym_fold_expression,
  [sym_parameter_pack_expansion] = sym_parameter_pack_expansion,
  [sym_type_parameter_pack_expansion] = sym_parameter_pack_expansion,
  [sym_identifier_parameter_pack_expansion] = sym_parameter_pack_expansion,
  [sym_destructor_name] = sym_destructor_name,
  [sym_dependent_identifier] = sym_dependent_identifier,
  [sym_dependent_field_identifier] = sym_dependent_identifier,
  [sym_dependent_type_identifier] = sym_dependent_identifier,
  [sym__scope_resolution] = sym__scope_resolution,
  [sym_qualified_field_identifier] = sym_qualified_identifier,
  [sym_qualified_identifier] = sym_qualified_identifier,
  [sym_qualified_type_identifier] = sym_qualified_identifier,
  [sym_qualified_operator_cast_identifier] = sym_qualified_identifier,
  [sym__assignment_expression_lhs] = sym_assignment_expression,
  [sym_operator_name] = sym_operator_name,
  [sym_user_defined_literal] = sym_user_defined_literal,
  [sym_semantics] = sym_semantics,
  [sym_discard_statement] = sym_discard_statement,
  [sym_qualifiers] = sym_qualifiers,
  [sym_cbuffer_specifier] = sym_cbuffer_specifier,
  [sym_hlsl_attribute] = sym_hlsl_attribute,
  [sym_type_hinted_declarator] = sym_type_hinted_declarator,
  [sym_type_hint] = sym_type_hint,
  [sym_interface_specifier] = sym_interface_specifier,
  [sym_extension_specifier] = sym_extension_specifier,
  [sym_interface_requirements] = sym_interface_requirements,
  [sym_where_clause] = sym_where_clause,
  [sym_import_statement] = sym_import_statement,
  [sym_init_declaration] = sym_init_declaration,
  [sym_subscript_declaration] = sym_subscript_declaration,
  [sym_property_declaration] = sym_property_declaration,
  [sym_property_get] = sym_property_get,
  [sym_property_set] = sym_property_set,
  [sym_associatedtype_declaration] = sym_associatedtype_declaration,
  [sym_associatedtype_specifier] = sym_associatedtype_specifier,
  [aux_sym_translation_unit_repeat1] = aux_sym_translation_unit_repeat1,
  [aux_sym_preproc_params_repeat1] = aux_sym_preproc_params_repeat1,
  [aux_sym_preproc_if_repeat1] = aux_sym_preproc_if_repeat1,
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = aux_sym_preproc_if_in_enumerator_list_repeat1,
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [aux_sym_preproc_argument_list_repeat1] = aux_sym_preproc_argument_list_repeat1,
  [aux_sym_declaration_repeat1] = aux_sym_declaration_repeat1,
  [aux_sym_type_definition_repeat1] = aux_sym_type_definition_repeat1,
  [aux_sym__type_definition_type_repeat1] = aux_sym__type_definition_type_repeat1,
  [aux_sym__type_definition_declarators_repeat1] = aux_sym__type_definition_declarators_repeat1,
  [aux_sym__declaration_specifiers_repeat1] = aux_sym__declaration_specifiers_repeat1,
  [aux_sym_attribute_declaration_repeat1] = aux_sym_attribute_declaration_repeat1,
  [aux_sym_declaration_list_repeat1] = aux_sym_declaration_list_repeat1,
  [aux_sym_attributed_declarator_repeat1] = aux_sym_attributed_declarator_repeat1,
  [aux_sym_pointer_declarator_repeat1] = aux_sym_pointer_declarator_repeat1,
  [aux_sym_array_declarator_repeat1] = aux_sym_array_declarator_repeat1,
  [aux_sym_sized_type_specifier_repeat1] = aux_sym_sized_type_specifier_repeat1,
  [aux_sym_enumerator_list_repeat1] = aux_sym_enumerator_list_repeat1,
  [aux_sym_field_declaration_repeat1] = aux_sym_field_declaration_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym_case_statement_repeat1] = aux_sym_case_statement_repeat1,
  [aux_sym_generic_expression_repeat1] = aux_sym_generic_expression_repeat1,
  [aux_sym_gnu_asm_expression_repeat1] = aux_sym_gnu_asm_expression_repeat1,
  [aux_sym_gnu_asm_output_operand_list_repeat1] = aux_sym_gnu_asm_output_operand_list_repeat1,
  [aux_sym_gnu_asm_input_operand_list_repeat1] = aux_sym_gnu_asm_input_operand_list_repeat1,
  [aux_sym_gnu_asm_clobber_list_repeat1] = aux_sym_gnu_asm_clobber_list_repeat1,
  [aux_sym_gnu_asm_goto_list_repeat1] = aux_sym_gnu_asm_goto_list_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_initializer_list_repeat1] = aux_sym_initializer_list_repeat1,
  [aux_sym_initializer_pair_repeat1] = aux_sym_initializer_pair_repeat1,
  [aux_sym_char_literal_repeat1] = aux_sym_char_literal_repeat1,
  [aux_sym_concatenated_string_repeat1] = aux_sym_concatenated_string_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [aux_sym__class_declaration_repeat1] = aux_sym__class_declaration_repeat1,
  [aux_sym_base_class_clause_repeat1] = aux_sym_base_class_clause_repeat1,
  [aux_sym_module_name_repeat1] = aux_sym_module_name_repeat1,
  [aux_sym_template_parameter_list_repeat1] = aux_sym_template_parameter_list_repeat1,
  [aux_sym_field_initializer_list_repeat1] = aux_sym_field_initializer_list_repeat1,
  [aux_sym_operator_cast_definition_repeat1] = aux_sym_operator_cast_definition_repeat1,
  [aux_sym_constructor_try_statement_repeat1] = aux_sym_constructor_try_statement_repeat1,
  [aux_sym_structured_binding_declarator_repeat1] = aux_sym_structured_binding_declarator_repeat1,
  [aux_sym__function_postfix_repeat1] = aux_sym__function_postfix_repeat1,
  [aux_sym_throw_specifier_repeat1] = aux_sym_throw_specifier_repeat1,
  [aux_sym_template_argument_list_repeat1] = aux_sym_template_argument_list_repeat1,
  [aux_sym_subscript_argument_list_repeat1] = aux_sym_subscript_argument_list_repeat1,
  [aux_sym_requirement_seq_repeat1] = aux_sym_requirement_seq_repeat1,
  [aux_sym_requires_parameter_list_repeat1] = aux_sym_requires_parameter_list_repeat1,
  [aux_sym_lambda_capture_specifier_repeat1] = aux_sym_lambda_capture_specifier_repeat1,
  [aux_sym_interface_requirements_repeat1] = aux_sym_interface_requirements_repeat1,
  [aux_sym_where_clause_repeat1] = aux_sym_where_clause_repeat1,
  [aux_sym_subscript_declaration_repeat1] = aux_sym_subscript_declaration_repeat1,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_namespace_identifier] = alias_sym_namespace_identifier,
  [alias_sym_simple_requirement] = alias_sym_simple_requirement,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_preproc_include_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_include_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_def_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_else_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elif_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [sym_preproc_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_directive] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defined] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___extension__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typedef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_out] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inout] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_virtual] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___attribute__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___attribute] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___declspec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___based] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___cdecl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___clrcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___stdcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___fastcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thiscall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___vectorcall] = {
    .visible = true,
    .named = false,
  },
  [sym_ms_restrict_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unsigned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_signed_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_signed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsigned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_register] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___inline__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___forceinline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_thread_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thread] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constexpr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_restrict] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___restrict__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Atomic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Nonnull] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mutable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constinit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_consteval] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alignas] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Alignas] = {
    .visible = true,
    .named = false,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___except] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___leave] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_compl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bitor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bitand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sizeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___alignof__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_offsetof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Generic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___asm__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___asm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___volatile__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_L_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_char_literal_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_L_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_literal_token1] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_system_lib_string] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_NULL] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nullptr] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_This] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_decltype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_final] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_explicit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typename] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_template] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_operator] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_pure_virtual_clause_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_friend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noexcept] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_concept] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_co_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_co_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_R_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_UR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8R_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_co_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_requires] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_suffix] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_discard] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_precise] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shared] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_groupshared] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uniform] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_row_major] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_column_major] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_globallycoherent] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_centroid] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noperspective] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nointerpolation] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sample] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_linear] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_snorm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unorm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_point] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_line] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_triangleadj] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lineadj] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_triangle] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cbuffer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extension] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_where] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___exported] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___init] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___subscript] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_property] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_associatedtype] = {
    .visible = true,
    .named = false,
  },
  [sym_raw_string_delimiter] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_translation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_item] = {
    .visible = false,
    .named = true,
  },
  [sym__block_item] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_include] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_function_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_params] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym__preproc_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_defined] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__type_definition_type] = {
    .visible = false,
    .named = true,
  },
  [sym__type_definition_declarators] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_modifiers] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_linkage_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_declspec_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_based_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_call_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unaligned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_pointer_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__field_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__type_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__abstract_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_init_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_storage_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_alignas_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_specifier] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_sized_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_union_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__field_declaration_list_item] = {
    .visible = false,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_bitfield_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__top_level_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_statement_body] = {
    .visible = false,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_except_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_leave_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__string] = {
    .visible = false,
    .named = true,
  },
  [sym_comma_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym_sizeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_alignof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_offsetof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_output_operand_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_output_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_input_operand_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_input_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_clobber_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_goto_list] = {
    .visible = true,
    .named = true,
  },
  [sym_extension_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_literal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_range_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_field_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_placeholder_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_decltype] = {
    .visible = true,
    .named = true,
  },
  [sym__class_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym__class_declaration_item] = {
    .visible = false,
    .named = true,
  },
  [sym_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym__class_name] = {
    .visible = false,
    .named = true,
  },
  [sym_virtual_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_explicit_function_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_base_class_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__enum_base_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_dependent_type] = {
    .visible = true,
    .named = true,
  },
  [sym_module_name] = {
    .visible = true,
    .named = true,
  },
  [sym_module_partition] = {
    .visible = true,
    .named = true,
  },
  [sym_module_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_export_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_import_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_global_module_fragment_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_private_module_fragment_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_instantiation] = {
    .visible = true,
    .named = true,
  },
  [sym_template_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_template_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_cast] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__constructor_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_operator_cast_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_cast_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_or_destructor_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_or_destructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_default_method_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_method_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_pure_virtual_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_friend_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_access_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_structured_binding_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym__function_declarator_seq] = {
    .visible = false,
    .named = true,
  },
  [sym__function_attributes_start] = {
    .visible = false,
    .named = true,
  },
  [sym__function_exception_specification] = {
    .visible = false,
    .named = true,
  },
  [sym__function_attributes_end] = {
    .visible = false,
    .named = true,
  },
  [sym__function_postfix] = {
    .visible = false,
    .named = true,
  },
  [sym_trailing_return_type] = {
    .visible = true,
    .named = true,
  },
  [sym_noexcept] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_template_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_method] = {
    .visible = true,
    .named = true,
  },
  [sym_template_function] = {
    .visible = true,
    .named = true,
  },
  [sym_template_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_alias_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__namespace_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym_nested_namespace_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_using_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_static_assert_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_concept_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_for_range_loop] = {
    .visible = true,
    .named = true,
  },
  [sym__for_range_loop_body] = {
    .visible = false,
    .named = true,
  },
  [sym_init_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_condition_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_condition_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_co_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_co_yield_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_co_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_requirement] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_requirement] = {
    .visible = true,
    .named = true,
  },
  [sym__requirement] = {
    .visible = false,
    .named = true,
  },
  [sym_requirement_seq] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_conjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_disjunction] = {
    .visible = true,
    .named = true,
  },
  [sym__requirement_clause_constraint] = {
    .visible = false,
    .named = true,
  },
  [sym_requires_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_requires_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_requires_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_capture_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_default_capture] = {
    .visible = true,
    .named = true,
  },
  [sym__lambda_capture_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_lambda_capture_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym__lambda_capture] = {
    .visible = false,
    .named = true,
  },
  [sym__fold_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__binary_fold_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_left_fold] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_right_fold] = {
    .visible = false,
    .named = true,
  },
  [sym__binary_fold] = {
    .visible = false,
    .named = true,
  },
  [sym_fold_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_pack_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_pack_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier_parameter_pack_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_destructor_name] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__scope_resolution] = {
    .visible = false,
    .named = true,
  },
  [sym_qualified_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_operator_cast_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__assignment_expression_lhs] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_name] = {
    .visible = true,
    .named = true,
  },
  [sym_user_defined_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_semantics] = {
    .visible = true,
    .named = true,
  },
  [sym_discard_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_qualifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_cbuffer_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hlsl_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_type_hinted_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_type_hint] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_extension_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_requirements] = {
    .visible = true,
    .named = true,
  },
  [sym_where_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_init_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_property_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_property_get] = {
    .visible = true,
    .named = true,
  },
  [sym_property_set] = {
    .visible = true,
    .named = true,
  },
  [sym_associatedtype_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_associatedtype_specifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_translation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_params_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_definition_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_definition_declarators_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declaration_specifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attributed_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pointer_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sized_type_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_generic_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_output_operand_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_input_operand_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_clobber_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_goto_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_pair_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_char_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__class_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_base_class_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_operator_cast_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constructor_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_structured_binding_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__function_postfix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_throw_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subscript_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_requirement_seq_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_requires_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_lambda_capture_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interface_requirements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_where_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subscript_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_namespace_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_simple_requirement] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_argument = 2,
  field_arguments = 3,
  field_assembly_code = 4,
  field_base = 5,
  field_body = 6,
  field_captures = 7,
  field_clobbers = 8,
  field_condition = 9,
  field_consequence = 10,
  field_constraint = 11,
  field_declarator = 12,
  field_default_type = 13,
  field_default_value = 14,
  field_delimiter = 15,
  field_designator = 16,
  field_directive = 17,
  field_end = 18,
  field_field = 19,
  field_filter = 20,
  field_function = 21,
  field_goto_labels = 22,
  field_header = 23,
  field_indices = 24,
  field_initializer = 25,
  field_input_operands = 26,
  field_label = 27,
  field_left = 28,
  field_length = 29,
  field_member = 30,
  field_message = 31,
  field_name = 32,
  field_namespace = 33,
  field_operand = 34,
  field_operator = 35,
  field_output_operands = 36,
  field_parameters = 37,
  field_partition = 38,
  field_path = 39,
  field_pattern = 40,
  field_placement = 41,
  field_prefix = 42,
  field_register = 43,
  field_requirements = 44,
  field_right = 45,
  field_scope = 46,
  field_size = 47,
  field_start = 48,
  field_symbol = 49,
  field_template_parameters = 50,
  field_type = 51,
  field_update = 52,
  field_value = 53,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_assembly_code] = "assembly_code",
  [field_base] = "base",
  [field_body] = "body",
  [field_captures] = "captures",
  [field_clobbers] = "clobbers",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constraint] = "constraint",
  [field_declarator] = "declarator",
  [field_default_type] = "default_type",
  [field_default_value] = "default_value",
  [field_delimiter] = "delimiter",
  [field_designator] = "designator",
  [field_directive] = "directive",
  [field_end] = "end",
  [field_field] = "field",
  [field_filter] = "filter",
  [field_function] = "function",
  [field_goto_labels] = "goto_labels",
  [field_header] = "header",
  [field_indices] = "indices",
  [field_initializer] = "initializer",
  [field_input_operands] = "input_operands",
  [field_label] = "label",
  [field_left] = "left",
  [field_length] = "length",
  [field_member] = "member",
  [field_message] = "message",
  [field_name] = "name",
  [field_namespace] = "namespace",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_output_operands] = "output_operands",
  [field_parameters] = "parameters",
  [field_partition] = "partition",
  [field_path] = "path",
  [field_pattern] = "pattern",
  [field_placement] = "placement",
  [field_prefix] = "prefix",
  [field_register] = "register",
  [field_requirements] = "requirements",
  [field_right] = "right",
  [field_scope] = "scope",
  [field_size] = "size",
  [field_start] = "start",
  [field_symbol] = "symbol",
  [field_template_parameters] = "template_parameters",
  [field_type] = "type",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 2},
  [5] = {.index = 4, .length = 1},
  [6] = {.index = 5, .length = 1},
  [7] = {.index = 6, .length = 2},
  [8] = {.index = 8, .length = 2},
  [9] = {.index = 10, .length = 1},
  [10] = {.index = 11, .length = 1},
  [11] = {.index = 12, .length = 1},
  [12] = {.index = 13, .length = 2},
  [13] = {.index = 15, .length = 2},
  [14] = {.index = 17, .length = 1},
  [15] = {.index = 18, .length = 1},
  [16] = {.index = 19, .length = 2},
  [17] = {.index = 19, .length = 2},
  [18] = {.index = 0, .length = 1},
  [20] = {.index = 21, .length = 1},
  [21] = {.index = 22, .length = 1},
  [22] = {.index = 23, .length = 1},
  [23] = {.index = 24, .length = 1},
  [24] = {.index = 25, .length = 2},
  [25] = {.index = 27, .length = 2},
  [26] = {.index = 29, .length = 1},
  [27] = {.index = 30, .length = 1},
  [28] = {.index = 31, .length = 1},
  [29] = {.index = 32, .length = 2},
  [30] = {.index = 34, .length = 2},
  [31] = {.index = 18, .length = 1},
  [32] = {.index = 36, .length = 2},
  [33] = {.index = 38, .length = 2},
  [34] = {.index = 38, .length = 2},
  [35] = {.index = 21, .length = 1},
  [36] = {.index = 40, .length = 1},
  [37] = {.index = 41, .length = 2},
  [38] = {.index = 43, .length = 2},
  [39] = {.index = 45, .length = 1},
  [40] = {.index = 46, .length = 3},
  [41] = {.index = 49, .length = 1},
  [44] = {.index = 50, .length = 2},
  [45] = {.index = 52, .length = 1},
  [46] = {.index = 53, .length = 1},
  [47] = {.index = 54, .length = 1},
  [48] = {.index = 55, .length = 2},
  [49] = {.index = 57, .length = 2},
  [50] = {.index = 59, .length = 2},
  [51] = {.index = 61, .length = 2},
  [52] = {.index = 63, .length = 2},
  [53] = {.index = 65, .length = 1},
  [54] = {.index = 66, .length = 1},
  [55] = {.index = 67, .length = 3},
  [56] = {.index = 70, .length = 1},
  [57] = {.index = 71, .length = 1},
  [58] = {.index = 72, .length = 1},
  [59] = {.index = 73, .length = 1},
  [60] = {.index = 74, .length = 2},
  [62] = {.index = 55, .length = 2},
  [63] = {.index = 76, .length = 2},
  [64] = {.index = 78, .length = 2},
  [65] = {.index = 80, .length = 2},
  [67] = {.index = 82, .length = 2},
  [68] = {.index = 84, .length = 2},
  [69] = {.index = 86, .length = 3},
  [70] = {.index = 89, .length = 2},
  [71] = {.index = 91, .length = 3},
  [72] = {.index = 91, .length = 3},
  [73] = {.index = 94, .length = 3},
  [74] = {.index = 97, .length = 3},
  [75] = {.index = 100, .length = 3},
  [76] = {.index = 52, .length = 1},
  [77] = {.index = 103, .length = 2},
  [78] = {.index = 105, .length = 2},
  [79] = {.index = 107, .length = 2},
  [80] = {.index = 109, .length = 1},
  [81] = {.index = 110, .length = 2},
  [82] = {.index = 112, .length = 2},
  [83] = {.index = 114, .length = 2},
  [84] = {.index = 116, .length = 3},
  [85] = {.index = 119, .length = 2},
  [86] = {.index = 121, .length = 1},
  [87] = {.index = 122, .length = 2},
  [88] = {.index = 124, .length = 2},
  [89] = {.index = 126, .length = 2},
  [90] = {.index = 128, .length = 2},
  [91] = {.index = 130, .length = 2},
  [92] = {.index = 132, .length = 2},
  [93] = {.index = 134, .length = 2},
  [94] = {.index = 136, .length = 2},
  [95] = {.index = 138, .length = 1},
  [96] = {.index = 136, .length = 2},
  [98] = {.index = 139, .length = 2},
  [99] = {.index = 141, .length = 1},
  [100] = {.index = 141, .length = 1},
  [101] = {.index = 142, .length = 3},
  [103] = {.index = 145, .length = 2},
  [104] = {.index = 147, .length = 2},
  [105] = {.index = 149, .length = 2},
  [106] = {.index = 151, .length = 3},
  [107] = {.index = 154, .length = 1},
  [108] = {.index = 155, .length = 1},
  [109] = {.index = 156, .length = 1},
  [110] = {.index = 157, .length = 1},
  [111] = {.index = 158, .length = 2},
  [113] = {.index = 160, .length = 3},
  [114] = {.index = 163, .length = 3},
  [115] = {.index = 166, .length = 3},
  [116] = {.index = 169, .length = 3},
  [117] = {.index = 172, .length = 2},
  [118] = {.index = 174, .length = 3},
  [119] = {.index = 177, .length = 2},
  [120] = {.index = 179, .length = 3},
  [121] = {.index = 182, .length = 2},
  [122] = {.index = 19, .length = 2},
  [123] = {.index = 38, .length = 2},
  [124] = {.index = 184, .length = 2},
  [125] = {.index = 186, .length = 2},
  [126] = {.index = 188, .length = 4},
  [127] = {.index = 192, .length = 4},
  [128] = {.index = 196, .length = 2},
  [129] = {.index = 198, .length = 3},
  [130] = {.index = 201, .length = 2},
  [131] = {.index = 203, .length = 2},
  [132] = {.index = 205, .length = 1},
  [133] = {.index = 206, .length = 1},
  [134] = {.index = 207, .length = 2},
  [135] = {.index = 209, .length = 2},
  [136] = {.index = 211, .length = 2},
  [137] = {.index = 213, .length = 3},
  [138] = {.index = 216, .length = 3},
  [139] = {.index = 219, .length = 3},
  [140] = {.index = 222, .length = 2},
  [141] = {.index = 224, .length = 2},
  [142] = {.index = 226, .length = 2},
  [143] = {.index = 228, .length = 2},
  [144] = {.index = 228, .length = 2},
  [145] = {.index = 230, .length = 2},
  [146] = {.index = 230, .length = 2},
  [147] = {.index = 232, .length = 2},
  [148] = {.index = 234, .length = 3},
  [149] = {.index = 237, .length = 2},
  [150] = {.index = 239, .length = 2},
  [151] = {.index = 241, .length = 3},
  [152] = {.index = 244, .length = 2},
  [153] = {.index = 246, .length = 3},
  [154] = {.index = 249, .length = 2},
  [155] = {.index = 251, .length = 1},
  [156] = {.index = 252, .length = 2},
  [157] = {.index = 254, .length = 2},
  [158] = {.index = 256, .length = 4},
  [159] = {.index = 260, .length = 5},
  [160] = {.index = 265, .length = 1},
  [161] = {.index = 266, .length = 1},
  [162] = {.index = 267, .length = 2},
  [163] = {.index = 269, .length = 1},
  [164] = {.index = 270, .length = 2},
  [166] = {.index = 272, .length = 1},
  [167] = {.index = 273, .length = 2},
  [168] = {.index = 275, .length = 2},
  [169] = {.index = 11, .length = 1},
  [170] = {.index = 11, .length = 1},
  [171] = {.index = 277, .length = 1},
  [172] = {.index = 278, .length = 1},
  [173] = {.index = 279, .length = 4},
  [174] = {.index = 283, .length = 4},
  [175] = {.index = 287, .length = 1},
  [176] = {.index = 288, .length = 3},
  [177] = {.index = 291, .length = 2},
  [178] = {.index = 293, .length = 3},
  [179] = {.index = 296, .length = 5},
  [180] = {.index = 301, .length = 2},
  [181] = {.index = 303, .length = 3},
  [182] = {.index = 306, .length = 2},
  [183] = {.index = 308, .length = 2},
  [184] = {.index = 310, .length = 1},
  [185] = {.index = 311, .length = 2},
  [186] = {.index = 313, .length = 4},
  [187] = {.index = 317, .length = 2},
  [188] = {.index = 319, .length = 2},
  [189] = {.index = 321, .length = 1},
  [190] = {.index = 322, .length = 2},
  [191] = {.index = 324, .length = 2},
  [193] = {.index = 326, .length = 3},
  [194] = {.index = 329, .length = 4},
  [195] = {.index = 333, .length = 4},
  [196] = {.index = 337, .length = 3},
  [197] = {.index = 340, .length = 2},
  [198] = {.index = 342, .length = 3},
  [199] = {.index = 345, .length = 3},
  [200] = {.index = 348, .length = 2},
  [201] = {.index = 350, .length = 2},
  [202] = {.index = 352, .length = 2},
  [203] = {.index = 354, .length = 2},
  [204] = {.index = 356, .length = 3},
  [205] = {.index = 359, .length = 2},
  [206] = {.index = 361, .length = 2},
  [207] = {.index = 363, .length = 3},
  [208] = {.index = 366, .length = 3},
  [209] = {.index = 369, .length = 5},
  [210] = {.index = 374, .length = 3},
  [211] = {.index = 377, .length = 4},
  [212] = {.index = 381, .length = 3},
  [213] = {.index = 384, .length = 3},
  [214] = {.index = 387, .length = 2},
  [215] = {.index = 389, .length = 2},
  [218] = {.index = 391, .length = 2},
  [219] = {.index = 393, .length = 4},
  [220] = {.index = 397, .length = 5},
  [221] = {.index = 402, .length = 3},
  [222] = {.index = 405, .length = 4},
  [223] = {.index = 409, .length = 2},
  [224] = {.index = 411, .length = 1},
  [225] = {.index = 412, .length = 4},
  [226] = {.index = 416, .length = 3},
  [227] = {.index = 419, .length = 2},
  [228] = {.index = 421, .length = 1},
  [231] = {.index = 422, .length = 5},
  [232] = {.index = 427, .length = 2},
  [233] = {.index = 429, .length = 2},
  [234] = {.index = 65, .length = 1},
  [235] = {.index = 431, .length = 5},
  [236] = {.index = 436, .length = 4},
  [238] = {.index = 440, .length = 2},
  [239] = {.index = 442, .length = 2},
  [240] = {.index = 444, .length = 5},
  [241] = {.index = 449, .length = 2},
  [242] = {.index = 451, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_type, 0},
  [1] =
    {field_directive, 0},
  [2] =
    {field_argument, 1},
    {field_operator, 0},
  [4] =
    {field_declarator, 1},
  [5] =
    {field_name, 0},
  [6] =
    {field_arguments, 1},
    {field_function, 0},
  [8] =
    {field_type, 0},
    {field_value, 1},
  [10] =
    {field_body, 1},
  [11] =
    {field_name, 1},
  [12] =
    {field_body, 0},
  [13] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [15] =
    {field_body, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [17] =
    {field_value, 1},
  [18] =
    {field_scope, 0},
  [19] =
    {field_arguments, 1},
    {field_name, 0},
  [21] =
    {field_type, 1},
  [22] =
    {field_requirements, 1},
  [23] =
    {field_constraint, 1},
  [24] =
    {field_parameters, 0},
  [25] =
    {field_declarator, 0},
    {field_parameters, 1, .inherited = true},
  [27] =
    {field_body, 1},
    {field_declarator, 0},
  [29] =
    {field_declarator, 0},
  [30] =
    {field_constraint, 0},
  [31] =
    {field_pattern, 0},
  [32] =
    {field_argument, 0},
    {field_operator, 1},
  [34] =
    {field_argument, 0},
    {field_indices, 1},
  [36] =
    {field_body, 1},
    {field_captures, 0},
  [38] =
    {field_name, 1},
    {field_scope, 0, .inherited = true},
  [40] =
    {field_path, 1},
  [41] =
    {field_argument, 1},
    {field_directive, 0},
  [43] =
    {field_declarator, 1},
    {field_type, 0},
  [45] =
    {field_parameters, 0, .inherited = true},
  [46] =
    {field_left, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [49] =
    {field_declarator, 2},
  [50] =
    {field_body, 2},
    {field_value, 1},
  [52] =
    {field_type, 2},
  [53] =
    {field_body, 2},
  [54] =
    {field_name, 2},
  [55] =
    {field_body, 2},
    {field_name, 1},
  [57] =
    {field_base, 2, .inherited = true},
    {field_name, 1},
  [59] =
    {field_body, 1},
    {field_name, 0},
  [61] =
    {field_condition, 1},
    {field_consequence, 2},
  [63] =
    {field_body, 2},
    {field_condition, 1},
  [65] =
    {field_label, 1},
  [66] =
    {field_label, 0},
  [67] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [70] =
    {field_header, 1},
  [71] =
    {field_partition, 1},
  [72] =
    {field_type, 0, .inherited = true},
  [73] =
    {field_parameters, 1},
  [74] =
    {field_declarator, 2},
    {field_type, 1, .inherited = true},
  [76] =
    {field_arguments, 2},
    {field_type, 1},
  [78] =
    {field_declarator, 2},
    {field_type, 1},
  [80] =
    {field_placement, 1},
    {field_type, 2},
  [82] =
    {field_parameters, 1},
    {field_requirements, 2},
  [84] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [86] =
    {field_body, 2},
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [89] =
    {field_body, 2},
    {field_declarator, 0},
  [91] =
    {field_argument, 0},
    {field_field, 2},
    {field_operator, 1},
  [94] =
    {field_body, 2},
    {field_captures, 0},
    {field_template_parameters, 1},
  [97] =
    {field_body, 2},
    {field_captures, 0},
    {field_declarator, 1},
  [100] =
    {field_name, 1},
    {field_name, 2},
    {field_scope, 0, .inherited = true},
  [103] =
    {field_body, 2},
    {field_declarator, 1},
  [105] =
    {field_name, 1},
    {field_value, 2},
  [107] =
    {field_name, 1},
    {field_parameters, 2},
  [109] =
    {field_condition, 1},
  [110] =
    {field_alternative, 2},
    {field_name, 1},
  [112] =
    {field_declarator, 2},
    {field_type, 0},
  [114] =
    {field_left, 0},
    {field_right, 2},
  [116] =
    {field_left, 0},
    {field_operator, 1, .inherited = true},
    {field_right, 2},
  [119] =
    {field_type, 1},
    {field_value, 3},
  [121] =
    {field_declarator, 3},
  [122] =
    {field_declarator, 2, .inherited = true},
    {field_type, 1, .inherited = true},
  [124] =
    {field_declarator, 0},
    {field_parameters, 1},
  [126] =
    {field_declarator, 0},
    {field_declarator, 1, .inherited = true},
  [128] =
    {field_arguments, 3},
    {field_type, 2},
  [130] =
    {field_declarator, 3},
    {field_type, 2},
  [132] =
    {field_placement, 2},
    {field_type, 3},
  [134] =
    {field_name, 2},
    {field_prefix, 0},
  [136] =
    {field_body, 3},
    {field_name, 2},
  [138] =
    {field_body, 3},
  [139] =
    {field_base, 3, .inherited = true},
    {field_name, 2},
  [141] =
    {field_base, 1},
  [142] =
    {field_base, 2, .inherited = true},
    {field_body, 3},
    {field_name, 1},
  [145] =
    {field_body, 2, .inherited = true},
    {field_name, 2, .inherited = true},
  [147] =
    {field_body, 2},
    {field_name, 0},
  [149] =
    {field_condition, 2},
    {field_consequence, 3},
  [151] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [154] =
    {field_initializer, 0},
  [155] =
    {field_assembly_code, 2},
  [156] =
    {field_header, 2},
  [157] =
    {field_partition, 2},
  [158] =
    {field_name, 1},
    {field_partition, 2},
  [160] =
    {field_arguments, 3},
    {field_declarator, 2},
    {field_type, 1},
  [163] =
    {field_arguments, 3},
    {field_placement, 1},
    {field_type, 2},
  [166] =
    {field_declarator, 3},
    {field_placement, 1},
    {field_type, 2},
  [169] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 0, .inherited = true},
  [172] =
    {field_declarator, 0},
    {field_value, 2},
  [174] =
    {field_declarator, 1},
    {field_declarator, 2, .inherited = true},
    {field_type, 0, .inherited = true},
  [177] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
  [179] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 1, .inherited = true},
  [182] =
    {field_declarator, 0},
    {field_size, 2},
  [184] =
    {field_alternative, 3},
    {field_condition, 0},
  [186] =
    {field_declarator, 0},
    {field_default_value, 2},
  [188] =
    {field_body, 3},
    {field_captures, 0},
    {field_constraint, 2},
    {field_template_parameters, 1},
  [192] =
    {field_body, 3},
    {field_captures, 0},
    {field_declarator, 2},
    {field_template_parameters, 1},
  [196] =
    {field_body, 3},
    {field_declarator, 1},
  [198] =
    {field_name, 1},
    {field_parameters, 2},
    {field_value, 3},
  [201] =
    {field_alternative, 3},
    {field_condition, 1},
  [203] =
    {field_alternative, 3},
    {field_name, 1},
  [205] =
    {field_size, 1},
  [206] =
    {field_operator, 0},
  [207] =
    {field_declarator, 3},
    {field_type, 1},
  [209] =
    {field_declarator, 3, .inherited = true},
    {field_type, 2, .inherited = true},
  [211] =
    {field_name, 1},
    {field_type, 3},
  [213] =
    {field_arguments, 4},
    {field_declarator, 3},
    {field_type, 2},
  [216] =
    {field_arguments, 4},
    {field_placement, 2},
    {field_type, 3},
  [219] =
    {field_declarator, 4},
    {field_placement, 2},
    {field_type, 3},
  [222] =
    {field_name, 3},
    {field_namespace, 1},
  [224] =
    {field_body, 3},
    {field_name, 1},
  [226] =
    {field_left, 1},
    {field_right, 3},
  [228] =
    {field_body, 4},
    {field_name, 3},
  [230] =
    {field_designator, 0},
    {field_value, 2},
  [232] =
    {field_name, 0},
    {field_value, 2},
  [234] =
    {field_base, 3, .inherited = true},
    {field_body, 4},
    {field_name, 2},
  [237] =
    {field_body, 3},
    {field_name, 0},
  [239] =
    {field_body, 3, .inherited = true},
    {field_name, 3, .inherited = true},
  [241] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
    {field_value, 2},
  [244] =
    {field_initializer, 1},
    {field_value, 2},
  [246] =
    {field_alternative, 4},
    {field_condition, 2},
    {field_consequence, 3},
  [249] =
    {field_body, 1},
    {field_condition, 3},
  [251] =
    {field_update, 2},
  [252] =
    {field_initializer, 0},
    {field_update, 2},
  [254] =
    {field_condition, 1},
    {field_initializer, 0},
  [256] =
    {field_body, 4},
    {field_condition, 2, .inherited = true},
    {field_initializer, 2, .inherited = true},
    {field_update, 2, .inherited = true},
  [260] =
    {field_body, 4},
    {field_declarator, 2, .inherited = true},
    {field_initializer, 2, .inherited = true},
    {field_right, 2, .inherited = true},
    {field_type, 2, .inherited = true},
  [265] =
    {field_value, 3},
  [266] =
    {field_operand, 1},
  [267] =
    {field_assembly_code, 2},
    {field_output_operands, 3},
  [269] =
    {field_assembly_code, 3},
  [270] =
    {field_name, 2},
    {field_partition, 3},
  [272] =
    {field_default_type, 2},
  [273] =
    {field_default_value, 2},
    {field_type, 0, .inherited = true},
  [275] =
    {field_body, 2},
    {field_parameters, 1},
  [277] =
    {field_condition, 2},
  [278] =
    {field_length, 1},
  [279] =
    {field_arguments, 4},
    {field_declarator, 3},
    {field_placement, 1},
    {field_type, 2},
  [283] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3},
    {field_type, 0, .inherited = true},
  [287] =
    {field_declarator, 4},
  [288] =
    {field_body, 4},
    {field_declarator, 3},
    {field_type, 1, .inherited = true},
  [291] =
    {field_declarator, 0},
    {field_size, 3},
  [293] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [296] =
    {field_body, 4},
    {field_captures, 0},
    {field_constraint, 2},
    {field_declarator, 3},
    {field_template_parameters, 1},
  [301] =
    {field_condition, 3},
    {field_consequence, 4},
  [303] =
    {field_body, 4},
    {field_declarator, 3},
    {field_type, 2, .inherited = true},
  [306] =
    {field_declarator, 1},
    {field_default_value, 3},
  [308] =
    {field_alternative, 4},
    {field_condition, 1},
  [310] =
    {field_size, 2},
  [311] =
    {field_name, 1},
    {field_type, 4},
  [313] =
    {field_arguments, 5},
    {field_declarator, 4},
    {field_placement, 2},
    {field_type, 3},
  [317] =
    {field_body, 2},
    {field_filter, 1},
  [319] =
    {field_body, 4},
    {field_name, 2},
  [321] =
    {field_body, 4},
  [322] =
    {field_body, 4},
    {field_name, 1},
  [324] =
    {field_left, 2},
    {field_right, 4},
  [326] =
    {field_declarator, 1},
    {field_default_value, 2},
    {field_type, 0, .inherited = true},
  [329] =
    {field_declarator, 1},
    {field_declarator, 2, .inherited = true},
    {field_default_value, 2, .inherited = true},
    {field_type, 0, .inherited = true},
  [333] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
    {field_default_value, 0, .inherited = true},
    {field_default_value, 1, .inherited = true},
  [337] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
    {field_value, 3},
  [340] =
    {field_condition, 1},
    {field_update, 3},
  [342] =
    {field_condition, 1},
    {field_initializer, 0},
    {field_update, 3},
  [345] =
    {field_declarator, 1},
    {field_right, 3},
    {field_type, 0, .inherited = true},
  [348] =
    {field_initializer, 0},
    {field_update, 3},
  [350] =
    {field_condition, 2},
    {field_initializer, 0},
  [352] =
    {field_member, 4},
    {field_type, 2},
  [354] =
    {field_operand, 1},
    {field_operand, 2, .inherited = true},
  [356] =
    {field_assembly_code, 2},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [359] =
    {field_assembly_code, 3},
    {field_output_operands, 4},
  [361] =
    {field_default_type, 3},
    {field_name, 1},
  [363] =
    {field_declarator, 1},
    {field_default_value, 3},
    {field_type, 0, .inherited = true},
  [366] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3},
  [369] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3},
    {field_declarator, 4, .inherited = true},
    {field_type, 0, .inherited = true},
  [374] =
    {field_alternative, 5},
    {field_condition, 3},
    {field_consequence, 4},
  [377] =
    {field_body, 5},
    {field_condition, 3, .inherited = true},
    {field_initializer, 3, .inherited = true},
    {field_update, 3, .inherited = true},
  [381] =
    {field_body, 5},
    {field_declarator, 4},
    {field_type, 2, .inherited = true},
  [384] =
    {field_name, 5},
    {field_namespace, 1},
    {field_prefix, 3},
  [387] =
    {field_body, 5},
    {field_name, 2},
  [389] =
    {field_end, 3},
    {field_start, 1},
  [391] =
    {field_declarator, 1},
    {field_default_value, 2},
  [393] =
    {field_declarator, 1},
    {field_declarator, 3, .inherited = true},
    {field_default_value, 3, .inherited = true},
    {field_type, 0, .inherited = true},
  [397] =
    {field_declarator, 1},
    {field_declarator, 3, .inherited = true},
    {field_default_value, 2},
    {field_default_value, 3, .inherited = true},
    {field_type, 0, .inherited = true},
  [402] =
    {field_condition, 2},
    {field_initializer, 0},
    {field_update, 4},
  [405] =
    {field_declarator, 2},
    {field_initializer, 0},
    {field_right, 4},
    {field_type, 1, .inherited = true},
  [409] =
    {field_operand, 0, .inherited = true},
    {field_operand, 1, .inherited = true},
  [411] =
    {field_register, 1},
  [412] =
    {field_assembly_code, 2},
    {field_clobbers, 5},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [416] =
    {field_assembly_code, 3},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [419] =
    {field_condition, 2},
    {field_message, 4},
  [421] =
    {field_delimiter, 1},
  [422] =
    {field_declarator, 1},
    {field_declarator, 4, .inherited = true},
    {field_default_value, 3},
    {field_default_value, 4, .inherited = true},
    {field_type, 0, .inherited = true},
  [427] =
    {field_constraint, 0},
    {field_value, 2},
  [429] =
    {field_register, 1},
    {field_register, 2, .inherited = true},
  [431] =
    {field_assembly_code, 2},
    {field_clobbers, 5},
    {field_goto_labels, 6},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [436] =
    {field_assembly_code, 3},
    {field_clobbers, 6},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [440] =
    {field_register, 0, .inherited = true},
    {field_register, 1, .inherited = true},
  [442] =
    {field_label, 1},
    {field_label, 2, .inherited = true},
  [444] =
    {field_assembly_code, 3},
    {field_clobbers, 6},
    {field_goto_labels, 7},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [449] =
    {field_label, 0, .inherited = true},
    {field_label, 1, .inherited = true},
  [451] =
    {field_constraint, 3},
    {field_symbol, 1},
    {field_value, 5},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [15] = {
    [0] = alias_sym_namespace_identifier,
  },
  [16] = {
    [0] = alias_sym_type_identifier,
  },
  [18] = {
    [0] = alias_sym_type_identifier,
  },
  [19] = {
    [0] = alias_sym_namespace_identifier,
  },
  [34] = {
    [1] = alias_sym_type_identifier,
  },
  [35] = {
    [1] = alias_sym_type_identifier,
  },
  [42] = {
    [0] = sym_primitive_type,
  },
  [43] = {
    [0] = sym_pointer_declarator,
  },
  [53] = {
    [1] = alias_sym_statement_identifier,
  },
  [54] = {
    [0] = alias_sym_statement_identifier,
  },
  [61] = {
    [1] = alias_sym_namespace_identifier,
  },
  [62] = {
    [1] = alias_sym_namespace_identifier,
  },
  [66] = {
    [0] = alias_sym_simple_requirement,
  },
  [71] = {
    [2] = alias_sym_field_identifier,
  },
  [76] = {
    [2] = alias_sym_type_identifier,
  },
  [94] = {
    [2] = alias_sym_namespace_identifier,
  },
  [97] = {
    [1] = alias_sym_field_identifier,
  },
  [100] = {
    [1] = alias_sym_type_identifier,
  },
  [102] = {
    [0] = alias_sym_field_identifier,
  },
  [112] = {
    [1] = alias_sym_type_identifier,
  },
  [122] = {
    [0] = alias_sym_field_identifier,
  },
  [123] = {
    [1] = alias_sym_field_identifier,
  },
  [136] = {
    [1] = alias_sym_type_identifier,
  },
  [143] = {
    [3] = alias_sym_namespace_identifier,
  },
  [145] = {
    [0] = alias_sym_field_identifier,
  },
  [165] = {
    [2] = alias_sym_type_identifier,
  },
  [169] = {
    [1] = alias_sym_namespace_identifier,
    [3] = alias_sym_namespace_identifier,
  },
  [170] = {
    [1] = alias_sym_namespace_identifier,
  },
  [174] = {
    [2] = sym_semantics,
    [3] = sym_semantics,
  },
  [185] = {
    [1] = alias_sym_type_identifier,
  },
  [192] = {
    [2] = sym_compound_statement,
    [3] = sym_compound_statement,
  },
  [202] = {
    [4] = alias_sym_field_identifier,
  },
  [206] = {
    [1] = alias_sym_type_identifier,
  },
  [208] = {
    [2] = sym_semantics,
    [3] = sym_semantics,
  },
  [209] = {
    [2] = sym_semantics,
    [3] = sym_semantics,
  },
  [216] = {
    [2] = sym_compound_statement,
    [3] = sym_compound_statement,
    [4] = sym_compound_statement,
  },
  [217] = {
    [3] = sym_compound_statement,
    [4] = sym_compound_statement,
  },
  [229] = {
    [3] = sym_compound_statement,
    [4] = sym_compound_statement,
    [5] = sym_compound_statement,
  },
  [230] = {
    [4] = sym_compound_statement,
    [5] = sym_compound_statement,
  },
  [237] = {
    [4] = sym_compound_statement,
    [5] = sym_compound_statement,
    [6] = sym_compound_statement,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_pointer_type_declarator, 2,
    sym_pointer_type_declarator,
    sym_pointer_declarator,
  sym_expression_statement, 2,
    sym_expression_statement,
    alias_sym_simple_requirement,
  sym_expression, 2,
    sym_expression,
    sym_semantics,
  aux_sym_subscript_declaration_repeat1, 2,
    aux_sym_subscript_declaration_repeat1,
    sym_compound_statement,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 2,
  [5] = 2,
  [6] = 2,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 10,
  [16] = 8,
  [17] = 11,
  [18] = 10,
  [19] = 7,
  [20] = 8,
  [21] = 7,
  [22] = 11,
  [23] = 10,
  [24] = 7,
  [25] = 8,
  [26] = 11,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 27,
  [33] = 30,
  [34] = 31,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 35,
  [39] = 37,
  [40] = 40,
  [41] = 30,
  [42] = 31,
  [43] = 31,
  [44] = 35,
  [45] = 45,
  [46] = 37,
  [47] = 30,
  [48] = 48,
  [49] = 31,
  [50] = 35,
  [51] = 51,
  [52] = 37,
  [53] = 27,
  [54] = 30,
  [55] = 31,
  [56] = 30,
  [57] = 31,
  [58] = 30,
  [59] = 31,
  [60] = 30,
  [61] = 31,
  [62] = 30,
  [63] = 31,
  [64] = 30,
  [65] = 31,
  [66] = 30,
  [67] = 31,
  [68] = 30,
  [69] = 31,
  [70] = 30,
  [71] = 31,
  [72] = 30,
  [73] = 31,
  [74] = 30,
  [75] = 31,
  [76] = 30,
  [77] = 31,
  [78] = 30,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 80,
  [86] = 81,
  [87] = 82,
  [88] = 83,
  [89] = 84,
  [90] = 84,
  [91] = 81,
  [92] = 82,
  [93] = 80,
  [94] = 83,
  [95] = 84,
  [96] = 82,
  [97] = 80,
  [98] = 81,
  [99] = 83,
  [100] = 100,
  [101] = 101,
  [102] = 101,
  [103] = 101,
  [104] = 83,
  [105] = 101,
  [106] = 81,
  [107] = 101,
  [108] = 82,
  [109] = 80,
  [110] = 84,
  [111] = 101,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 114,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 120,
  [133] = 121,
  [134] = 122,
  [135] = 115,
  [136] = 123,
  [137] = 124,
  [138] = 125,
  [139] = 126,
  [140] = 127,
  [141] = 119,
  [142] = 128,
  [143] = 118,
  [144] = 129,
  [145] = 130,
  [146] = 116,
  [147] = 131,
  [148] = 120,
  [149] = 127,
  [150] = 131,
  [151] = 130,
  [152] = 118,
  [153] = 119,
  [154] = 128,
  [155] = 122,
  [156] = 129,
  [157] = 115,
  [158] = 125,
  [159] = 121,
  [160] = 123,
  [161] = 124,
  [162] = 126,
  [163] = 163,
  [164] = 163,
  [165] = 163,
  [166] = 163,
  [167] = 163,
  [168] = 163,
  [169] = 169,
  [170] = 170,
  [171] = 170,
  [172] = 170,
  [173] = 170,
  [174] = 170,
  [175] = 170,
  [176] = 116,
  [177] = 125,
  [178] = 124,
  [179] = 123,
  [180] = 115,
  [181] = 121,
  [182] = 120,
  [183] = 122,
  [184] = 126,
  [185] = 127,
  [186] = 119,
  [187] = 128,
  [188] = 118,
  [189] = 129,
  [190] = 130,
  [191] = 131,
  [192] = 116,
  [193] = 193,
  [194] = 193,
  [195] = 193,
  [196] = 193,
  [197] = 193,
  [198] = 193,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 125,
  [209] = 119,
  [210] = 210,
  [211] = 129,
  [212] = 130,
  [213] = 131,
  [214] = 214,
  [215] = 120,
  [216] = 121,
  [217] = 122,
  [218] = 115,
  [219] = 123,
  [220] = 124,
  [221] = 128,
  [222] = 126,
  [223] = 127,
  [224] = 118,
  [225] = 225,
  [226] = 226,
  [227] = 225,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 225,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 229,
  [236] = 234,
  [237] = 229,
  [238] = 234,
  [239] = 233,
  [240] = 233,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 243,
  [246] = 244,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 202,
  [251] = 201,
  [252] = 252,
  [253] = 252,
  [254] = 254,
  [255] = 252,
  [256] = 256,
  [257] = 257,
  [258] = 257,
  [259] = 207,
  [260] = 260,
  [261] = 205,
  [262] = 262,
  [263] = 204,
  [264] = 210,
  [265] = 206,
  [266] = 214,
  [267] = 262,
  [268] = 120,
  [269] = 121,
  [270] = 122,
  [271] = 115,
  [272] = 123,
  [273] = 124,
  [274] = 125,
  [275] = 126,
  [276] = 127,
  [277] = 119,
  [278] = 128,
  [279] = 118,
  [280] = 129,
  [281] = 130,
  [282] = 131,
  [283] = 260,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 244,
  [292] = 243,
  [293] = 293,
  [294] = 294,
  [295] = 243,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 202,
  [300] = 300,
  [301] = 201,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 244,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 320,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 249,
  [333] = 333,
  [334] = 334,
  [335] = 200,
  [336] = 336,
  [337] = 330,
  [338] = 338,
  [339] = 331,
  [340] = 203,
  [341] = 338,
  [342] = 202,
  [343] = 201,
  [344] = 330,
  [345] = 330,
  [346] = 346,
  [347] = 338,
  [348] = 346,
  [349] = 330,
  [350] = 338,
  [351] = 338,
  [352] = 330,
  [353] = 338,
  [354] = 330,
  [355] = 338,
  [356] = 356,
  [357] = 330,
  [358] = 338,
  [359] = 330,
  [360] = 338,
  [361] = 330,
  [362] = 338,
  [363] = 333,
  [364] = 330,
  [365] = 338,
  [366] = 356,
  [367] = 338,
  [368] = 330,
  [369] = 338,
  [370] = 330,
  [371] = 338,
  [372] = 330,
  [373] = 338,
  [374] = 249,
  [375] = 330,
  [376] = 376,
  [377] = 377,
  [378] = 378,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 382,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 393,
  [394] = 394,
  [395] = 241,
  [396] = 396,
  [397] = 242,
  [398] = 207,
  [399] = 205,
  [400] = 206,
  [401] = 214,
  [402] = 204,
  [403] = 210,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 407,
  [408] = 408,
  [409] = 409,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 410,
  [417] = 413,
  [418] = 418,
  [419] = 409,
  [420] = 388,
  [421] = 387,
  [422] = 422,
  [423] = 390,
  [424] = 389,
  [425] = 425,
  [426] = 120,
  [427] = 121,
  [428] = 122,
  [429] = 115,
  [430] = 123,
  [431] = 124,
  [432] = 125,
  [433] = 126,
  [434] = 127,
  [435] = 119,
  [436] = 128,
  [437] = 118,
  [438] = 129,
  [439] = 130,
  [440] = 131,
  [441] = 391,
  [442] = 392,
  [443] = 443,
  [444] = 393,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 425,
  [449] = 394,
  [450] = 450,
  [451] = 404,
  [452] = 376,
  [453] = 453,
  [454] = 418,
  [455] = 455,
  [456] = 456,
  [457] = 396,
  [458] = 422,
  [459] = 459,
  [460] = 460,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 445,
  [466] = 466,
  [467] = 446,
  [468] = 468,
  [469] = 447,
  [470] = 470,
  [471] = 377,
  [472] = 414,
  [473] = 382,
  [474] = 383,
  [475] = 384,
  [476] = 385,
  [477] = 459,
  [478] = 478,
  [479] = 450,
  [480] = 480,
  [481] = 455,
  [482] = 482,
  [483] = 483,
  [484] = 405,
  [485] = 406,
  [486] = 486,
  [487] = 407,
  [488] = 408,
  [489] = 489,
  [490] = 411,
  [491] = 460,
  [492] = 461,
  [493] = 412,
  [494] = 462,
  [495] = 463,
  [496] = 496,
  [497] = 464,
  [498] = 453,
  [499] = 456,
  [500] = 466,
  [501] = 415,
  [502] = 468,
  [503] = 482,
  [504] = 483,
  [505] = 443,
  [506] = 486,
  [507] = 489,
  [508] = 378,
  [509] = 379,
  [510] = 380,
  [511] = 376,
  [512] = 381,
  [513] = 386,
  [514] = 478,
  [515] = 480,
  [516] = 470,
  [517] = 376,
  [518] = 496,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 205,
  [524] = 206,
  [525] = 204,
  [526] = 214,
  [527] = 210,
  [528] = 207,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 120,
  [554] = 121,
  [555] = 122,
  [556] = 115,
  [557] = 123,
  [558] = 124,
  [559] = 125,
  [560] = 126,
  [561] = 127,
  [562] = 119,
  [563] = 128,
  [564] = 118,
  [565] = 129,
  [566] = 130,
  [567] = 131,
  [568] = 568,
  [569] = 262,
  [570] = 570,
  [571] = 571,
  [572] = 572,
  [573] = 573,
  [574] = 574,
  [575] = 575,
  [576] = 576,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 581,
  [582] = 582,
  [583] = 583,
  [584] = 584,
  [585] = 585,
  [586] = 586,
  [587] = 587,
  [588] = 588,
  [589] = 589,
  [590] = 590,
  [591] = 591,
  [592] = 592,
  [593] = 593,
  [594] = 594,
  [595] = 595,
  [596] = 596,
  [597] = 597,
  [598] = 598,
  [599] = 599,
  [600] = 600,
  [601] = 601,
  [602] = 602,
  [603] = 603,
  [604] = 604,
  [605] = 595,
  [606] = 606,
  [607] = 607,
  [608] = 257,
  [609] = 609,
  [610] = 610,
  [611] = 611,
  [612] = 612,
  [613] = 613,
  [614] = 585,
  [615] = 615,
  [616] = 262,
  [617] = 617,
  [618] = 618,
  [619] = 619,
  [620] = 620,
  [621] = 621,
  [622] = 531,
  [623] = 623,
  [624] = 624,
  [625] = 568,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 629,
  [630] = 257,
  [631] = 631,
  [632] = 632,
  [633] = 285,
  [634] = 632,
  [635] = 300,
  [636] = 285,
  [637] = 637,
  [638] = 300,
  [639] = 285,
  [640] = 300,
  [641] = 637,
  [642] = 642,
  [643] = 241,
  [644] = 644,
  [645] = 346,
  [646] = 646,
  [647] = 647,
  [648] = 648,
  [649] = 642,
  [650] = 650,
  [651] = 203,
  [652] = 652,
  [653] = 653,
  [654] = 654,
  [655] = 356,
  [656] = 656,
  [657] = 200,
  [658] = 658,
  [659] = 626,
  [660] = 356,
  [661] = 661,
  [662] = 662,
  [663] = 663,
  [664] = 664,
  [665] = 665,
  [666] = 666,
  [667] = 667,
  [668] = 668,
  [669] = 653,
  [670] = 670,
  [671] = 671,
  [672] = 284,
  [673] = 673,
  [674] = 333,
  [675] = 650,
  [676] = 346,
  [677] = 331,
  [678] = 667,
  [679] = 662,
  [680] = 666,
  [681] = 681,
  [682] = 203,
  [683] = 601,
  [684] = 668,
  [685] = 656,
  [686] = 686,
  [687] = 687,
  [688] = 688,
  [689] = 689,
  [690] = 663,
  [691] = 658,
  [692] = 661,
  [693] = 686,
  [694] = 689,
  [695] = 333,
  [696] = 652,
  [697] = 331,
  [698] = 698,
  [699] = 200,
  [700] = 646,
  [701] = 647,
  [702] = 681,
  [703] = 688,
  [704] = 670,
  [705] = 242,
  [706] = 687,
  [707] = 673,
  [708] = 644,
  [709] = 709,
  [710] = 710,
  [711] = 664,
  [712] = 698,
  [713] = 654,
  [714] = 665,
  [715] = 380,
  [716] = 496,
  [717] = 453,
  [718] = 456,
  [719] = 719,
  [720] = 387,
  [721] = 422,
  [722] = 390,
  [723] = 391,
  [724] = 482,
  [725] = 483,
  [726] = 486,
  [727] = 489,
  [728] = 392,
  [729] = 460,
  [730] = 461,
  [731] = 462,
  [732] = 463,
  [733] = 464,
  [734] = 393,
  [735] = 378,
  [736] = 379,
  [737] = 376,
  [738] = 381,
  [739] = 394,
  [740] = 384,
  [741] = 385,
  [742] = 386,
  [743] = 392,
  [744] = 393,
  [745] = 394,
  [746] = 404,
  [747] = 445,
  [748] = 446,
  [749] = 447,
  [750] = 466,
  [751] = 468,
  [752] = 382,
  [753] = 383,
  [754] = 313,
  [755] = 315,
  [756] = 256,
  [757] = 478,
  [758] = 289,
  [759] = 290,
  [760] = 308,
  [761] = 309,
  [762] = 762,
  [763] = 293,
  [764] = 294,
  [765] = 328,
  [766] = 408,
  [767] = 318,
  [768] = 320,
  [769] = 321,
  [770] = 422,
  [771] = 322,
  [772] = 323,
  [773] = 325,
  [774] = 326,
  [775] = 327,
  [776] = 296,
  [777] = 297,
  [778] = 298,
  [779] = 302,
  [780] = 303,
  [781] = 317,
  [782] = 305,
  [783] = 286,
  [784] = 287,
  [785] = 288,
  [786] = 254,
  [787] = 304,
  [788] = 329,
  [789] = 306,
  [790] = 445,
  [791] = 307,
  [792] = 310,
  [793] = 446,
  [794] = 311,
  [795] = 312,
  [796] = 447,
  [797] = 316,
  [798] = 319,
  [799] = 407,
  [800] = 324,
  [801] = 450,
  [802] = 455,
  [803] = 404,
  [804] = 450,
  [805] = 455,
  [806] = 460,
  [807] = 391,
  [808] = 462,
  [809] = 463,
  [810] = 377,
  [811] = 464,
  [812] = 466,
  [813] = 468,
  [814] = 241,
  [815] = 377,
  [816] = 408,
  [817] = 817,
  [818] = 242,
  [819] = 819,
  [820] = 382,
  [821] = 383,
  [822] = 384,
  [823] = 385,
  [824] = 824,
  [825] = 719,
  [826] = 819,
  [827] = 482,
  [828] = 483,
  [829] = 486,
  [830] = 489,
  [831] = 831,
  [832] = 496,
  [833] = 453,
  [834] = 478,
  [835] = 456,
  [836] = 817,
  [837] = 378,
  [838] = 379,
  [839] = 380,
  [840] = 381,
  [841] = 841,
  [842] = 480,
  [843] = 762,
  [844] = 386,
  [845] = 376,
  [846] = 470,
  [847] = 459,
  [848] = 411,
  [849] = 388,
  [850] = 396,
  [851] = 443,
  [852] = 405,
  [853] = 406,
  [854] = 824,
  [855] = 831,
  [856] = 841,
  [857] = 480,
  [858] = 412,
  [859] = 470,
  [860] = 459,
  [861] = 411,
  [862] = 388,
  [863] = 396,
  [864] = 443,
  [865] = 405,
  [866] = 406,
  [867] = 407,
  [868] = 415,
  [869] = 410,
  [870] = 412,
  [871] = 413,
  [872] = 418,
  [873] = 415,
  [874] = 410,
  [875] = 413,
  [876] = 418,
  [877] = 376,
  [878] = 387,
  [879] = 376,
  [880] = 376,
  [881] = 390,
  [882] = 376,
  [883] = 461,
  [884] = 593,
  [885] = 532,
  [886] = 552,
  [887] = 533,
  [888] = 571,
  [889] = 626,
  [890] = 571,
  [891] = 572,
  [892] = 573,
  [893] = 893,
  [894] = 534,
  [895] = 519,
  [896] = 570,
  [897] = 609,
  [898] = 618,
  [899] = 574,
  [900] = 575,
  [901] = 597,
  [902] = 601,
  [903] = 544,
  [904] = 535,
  [905] = 536,
  [906] = 578,
  [907] = 579,
  [908] = 580,
  [909] = 537,
  [910] = 577,
  [911] = 538,
  [912] = 581,
  [913] = 582,
  [914] = 584,
  [915] = 599,
  [916] = 588,
  [917] = 589,
  [918] = 590,
  [919] = 591,
  [920] = 589,
  [921] = 592,
  [922] = 593,
  [923] = 594,
  [924] = 596,
  [925] = 590,
  [926] = 593,
  [927] = 600,
  [928] = 572,
  [929] = 573,
  [930] = 603,
  [931] = 604,
  [932] = 532,
  [933] = 606,
  [934] = 574,
  [935] = 575,
  [936] = 533,
  [937] = 534,
  [938] = 600,
  [939] = 535,
  [940] = 536,
  [941] = 537,
  [942] = 538,
  [943] = 543,
  [944] = 550,
  [945] = 539,
  [946] = 607,
  [947] = 610,
  [948] = 611,
  [949] = 612,
  [950] = 613,
  [951] = 540,
  [952] = 541,
  [953] = 615,
  [954] = 617,
  [955] = 578,
  [956] = 579,
  [957] = 619,
  [958] = 620,
  [959] = 621,
  [960] = 623,
  [961] = 624,
  [962] = 594,
  [963] = 631,
  [964] = 629,
  [965] = 552,
  [966] = 550,
  [967] = 596,
  [968] = 539,
  [969] = 580,
  [970] = 546,
  [971] = 581,
  [972] = 582,
  [973] = 577,
  [974] = 580,
  [975] = 581,
  [976] = 582,
  [977] = 543,
  [978] = 588,
  [979] = 586,
  [980] = 627,
  [981] = 584,
  [982] = 520,
  [983] = 588,
  [984] = 589,
  [985] = 590,
  [986] = 529,
  [987] = 591,
  [988] = 592,
  [989] = 989,
  [990] = 591,
  [991] = 594,
  [992] = 530,
  [993] = 576,
  [994] = 592,
  [995] = 596,
  [996] = 532,
  [997] = 600,
  [998] = 612,
  [999] = 547,
  [1000] = 548,
  [1001] = 1001,
  [1002] = 624,
  [1003] = 604,
  [1004] = 606,
  [1005] = 519,
  [1006] = 570,
  [1007] = 583,
  [1008] = 1008,
  [1009] = 609,
  [1010] = 618,
  [1011] = 533,
  [1012] = 534,
  [1013] = 535,
  [1014] = 536,
  [1015] = 537,
  [1016] = 538,
  [1017] = 539,
  [1018] = 631,
  [1019] = 540,
  [1020] = 541,
  [1021] = 543,
  [1022] = 1022,
  [1023] = 1023,
  [1024] = 1024,
  [1025] = 1025,
  [1026] = 1026,
  [1027] = 1027,
  [1028] = 1028,
  [1029] = 604,
  [1030] = 610,
  [1031] = 611,
  [1032] = 612,
  [1033] = 613,
  [1034] = 1034,
  [1035] = 579,
  [1036] = 520,
  [1037] = 615,
  [1038] = 617,
  [1039] = 540,
  [1040] = 546,
  [1041] = 529,
  [1042] = 619,
  [1043] = 620,
  [1044] = 621,
  [1045] = 623,
  [1046] = 624,
  [1047] = 631,
  [1048] = 629,
  [1049] = 547,
  [1050] = 521,
  [1051] = 522,
  [1052] = 548,
  [1053] = 550,
  [1054] = 1054,
  [1055] = 893,
  [1056] = 1056,
  [1057] = 541,
  [1058] = 1058,
  [1059] = 546,
  [1060] = 602,
  [1061] = 628,
  [1062] = 545,
  [1063] = 1063,
  [1064] = 597,
  [1065] = 1065,
  [1066] = 587,
  [1067] = 1067,
  [1068] = 586,
  [1069] = 627,
  [1070] = 603,
  [1071] = 542,
  [1072] = 520,
  [1073] = 544,
  [1074] = 1074,
  [1075] = 549,
  [1076] = 529,
  [1077] = 626,
  [1078] = 1078,
  [1079] = 1079,
  [1080] = 1080,
  [1081] = 1081,
  [1082] = 574,
  [1083] = 575,
  [1084] = 1084,
  [1085] = 628,
  [1086] = 598,
  [1087] = 530,
  [1088] = 610,
  [1089] = 611,
  [1090] = 613,
  [1091] = 549,
  [1092] = 615,
  [1093] = 519,
  [1094] = 570,
  [1095] = 583,
  [1096] = 609,
  [1097] = 618,
  [1098] = 547,
  [1099] = 545,
  [1100] = 597,
  [1101] = 587,
  [1102] = 601,
  [1103] = 599,
  [1104] = 542,
  [1105] = 544,
  [1106] = 577,
  [1107] = 548,
  [1108] = 521,
  [1109] = 1109,
  [1110] = 1110,
  [1111] = 1111,
  [1112] = 1112,
  [1113] = 576,
  [1114] = 584,
  [1115] = 522,
  [1116] = 1116,
  [1117] = 1117,
  [1118] = 617,
  [1119] = 628,
  [1120] = 607,
  [1121] = 551,
  [1122] = 619,
  [1123] = 620,
  [1124] = 549,
  [1125] = 621,
  [1126] = 583,
  [1127] = 623,
  [1128] = 545,
  [1129] = 587,
  [1130] = 542,
  [1131] = 629,
  [1132] = 530,
  [1133] = 552,
  [1134] = 1134,
  [1135] = 1135,
  [1136] = 576,
  [1137] = 602,
  [1138] = 551,
  [1139] = 599,
  [1140] = 571,
  [1141] = 572,
  [1142] = 522,
  [1143] = 573,
  [1144] = 598,
  [1145] = 598,
  [1146] = 578,
  [1147] = 602,
  [1148] = 603,
  [1149] = 586,
  [1150] = 607,
  [1151] = 627,
  [1152] = 551,
  [1153] = 521,
  [1154] = 606,
  [1155] = 1155,
  [1156] = 1155,
  [1157] = 1157,
  [1158] = 1158,
  [1159] = 1157,
  [1160] = 1158,
  [1161] = 1157,
  [1162] = 1158,
  [1163] = 1157,
  [1164] = 1158,
  [1165] = 1158,
  [1166] = 1158,
  [1167] = 1157,
  [1168] = 1158,
  [1169] = 1158,
  [1170] = 1157,
  [1171] = 1157,
  [1172] = 1158,
  [1173] = 1158,
  [1174] = 1157,
  [1175] = 1158,
  [1176] = 1157,
  [1177] = 1157,
  [1178] = 1157,
  [1179] = 1158,
  [1180] = 1157,
  [1181] = 1158,
  [1182] = 1157,
  [1183] = 1183,
  [1184] = 1184,
  [1185] = 1184,
  [1186] = 1186,
  [1187] = 1184,
  [1188] = 1183,
  [1189] = 1183,
  [1190] = 1186,
  [1191] = 1184,
  [1192] = 1184,
  [1193] = 1184,
  [1194] = 1194,
  [1195] = 1183,
  [1196] = 1186,
  [1197] = 1184,
  [1198] = 1186,
  [1199] = 1199,
  [1200] = 1200,
  [1201] = 1201,
  [1202] = 1202,
  [1203] = 1203,
  [1204] = 1204,
  [1205] = 1205,
  [1206] = 1186,
  [1207] = 1207,
  [1208] = 1203,
  [1209] = 1205,
  [1210] = 1210,
  [1211] = 1211,
  [1212] = 1204,
  [1213] = 1207,
  [1214] = 1214,
  [1215] = 1201,
  [1216] = 1210,
  [1217] = 1211,
  [1218] = 1200,
  [1219] = 1200,
  [1220] = 1214,
  [1221] = 1202,
  [1222] = 1204,
  [1223] = 1203,
  [1224] = 1207,
  [1225] = 1211,
  [1226] = 1214,
  [1227] = 1186,
  [1228] = 1228,
  [1229] = 1204,
  [1230] = 1207,
  [1231] = 1202,
  [1232] = 1207,
  [1233] = 1202,
  [1234] = 1204,
  [1235] = 1204,
  [1236] = 1203,
  [1237] = 1203,
  [1238] = 1205,
  [1239] = 1205,
  [1240] = 1205,
  [1241] = 1210,
  [1242] = 1211,
  [1243] = 1214,
  [1244] = 1214,
  [1245] = 1210,
  [1246] = 1210,
  [1247] = 1210,
  [1248] = 1207,
  [1249] = 1200,
  [1250] = 1211,
  [1251] = 1201,
  [1252] = 1214,
  [1253] = 1205,
  [1254] = 1200,
  [1255] = 1211,
  [1256] = 1201,
  [1257] = 1200,
  [1258] = 1202,
  [1259] = 1201,
  [1260] = 1202,
  [1261] = 1203,
  [1262] = 1228,
  [1263] = 1263,
  [1264] = 1263,
  [1265] = 1263,
  [1266] = 1263,
  [1267] = 1263,
  [1268] = 1263,
  [1269] = 1263,
  [1270] = 243,
  [1271] = 1228,
  [1272] = 244,
  [1273] = 202,
  [1274] = 1228,
  [1275] = 201,
  [1276] = 1276,
  [1277] = 1277,
  [1278] = 1277,
  [1279] = 1277,
  [1280] = 1228,
  [1281] = 1277,
  [1282] = 1277,
  [1283] = 1277,
  [1284] = 1277,
  [1285] = 1277,
  [1286] = 1277,
  [1287] = 1277,
  [1288] = 1277,
  [1289] = 1277,
  [1290] = 1277,
  [1291] = 1277,
  [1292] = 1277,
  [1293] = 1277,
  [1294] = 1277,
  [1295] = 1277,
  [1296] = 1277,
  [1297] = 1277,
  [1298] = 1277,
  [1299] = 1277,
  [1300] = 1277,
  [1301] = 1277,
  [1302] = 1277,
  [1303] = 1228,
  [1304] = 1277,
  [1305] = 204,
  [1306] = 214,
  [1307] = 210,
  [1308] = 207,
  [1309] = 120,
  [1310] = 121,
  [1311] = 122,
  [1312] = 115,
  [1313] = 123,
  [1314] = 124,
  [1315] = 125,
  [1316] = 257,
  [1317] = 126,
  [1318] = 127,
  [1319] = 119,
  [1320] = 128,
  [1321] = 118,
  [1322] = 129,
  [1323] = 130,
  [1324] = 131,
  [1325] = 205,
  [1326] = 206,
  [1327] = 1327,
  [1328] = 262,
  [1329] = 1329,
  [1330] = 1329,
  [1331] = 1228,
  [1332] = 1329,
  [1333] = 1329,
  [1334] = 1329,
  [1335] = 1329,
  [1336] = 1329,
  [1337] = 1329,
  [1338] = 1329,
  [1339] = 1329,
  [1340] = 1329,
  [1341] = 1329,
  [1342] = 1329,
  [1343] = 1329,
  [1344] = 1329,
  [1345] = 1329,
  [1346] = 1329,
  [1347] = 203,
  [1348] = 356,
  [1349] = 346,
  [1350] = 200,
  [1351] = 333,
  [1352] = 1352,
  [1353] = 331,
  [1354] = 384,
  [1355] = 406,
  [1356] = 407,
  [1357] = 112,
  [1358] = 388,
  [1359] = 412,
  [1360] = 415,
  [1361] = 447,
  [1362] = 410,
  [1363] = 413,
  [1364] = 418,
  [1365] = 387,
  [1366] = 390,
  [1367] = 391,
  [1368] = 404,
  [1369] = 1199,
  [1370] = 496,
  [1371] = 453,
  [1372] = 456,
  [1373] = 396,
  [1374] = 422,
  [1375] = 112,
  [1376] = 1276,
  [1377] = 443,
  [1378] = 450,
  [1379] = 455,
  [1380] = 478,
  [1381] = 482,
  [1382] = 405,
  [1383] = 486,
  [1384] = 489,
  [1385] = 460,
  [1386] = 461,
  [1387] = 462,
  [1388] = 463,
  [1389] = 464,
  [1390] = 112,
  [1391] = 377,
  [1392] = 378,
  [1393] = 379,
  [1394] = 380,
  [1395] = 381,
  [1396] = 385,
  [1397] = 386,
  [1398] = 408,
  [1399] = 470,
  [1400] = 466,
  [1401] = 112,
  [1402] = 468,
  [1403] = 382,
  [1404] = 383,
  [1405] = 392,
  [1406] = 393,
  [1407] = 394,
  [1408] = 459,
  [1409] = 411,
  [1410] = 241,
  [1411] = 242,
  [1412] = 445,
  [1413] = 446,
  [1414] = 1194,
  [1415] = 480,
  [1416] = 483,
  [1417] = 1417,
  [1418] = 1418,
  [1419] = 1418,
  [1420] = 1420,
  [1421] = 1421,
  [1422] = 1421,
  [1423] = 1420,
  [1424] = 1420,
  [1425] = 1228,
  [1426] = 1420,
  [1427] = 1420,
  [1428] = 1420,
  [1429] = 1228,
  [1430] = 1228,
  [1431] = 1228,
  [1432] = 1228,
  [1433] = 1228,
  [1434] = 1434,
  [1435] = 893,
  [1436] = 893,
  [1437] = 893,
  [1438] = 1438,
  [1439] = 1438,
  [1440] = 127,
  [1441] = 119,
  [1442] = 114,
  [1443] = 128,
  [1444] = 118,
  [1445] = 129,
  [1446] = 130,
  [1447] = 131,
  [1448] = 126,
  [1449] = 121,
  [1450] = 122,
  [1451] = 115,
  [1452] = 120,
  [1453] = 123,
  [1454] = 124,
  [1455] = 125,
  [1456] = 116,
  [1457] = 1457,
  [1458] = 1457,
  [1459] = 1457,
  [1460] = 1457,
  [1461] = 600,
  [1462] = 1462,
  [1463] = 550,
  [1464] = 1464,
  [1465] = 1464,
  [1466] = 1466,
  [1467] = 1464,
  [1468] = 1464,
  [1469] = 114,
  [1470] = 1464,
  [1471] = 1466,
  [1472] = 1466,
  [1473] = 1464,
  [1474] = 1464,
  [1475] = 1466,
  [1476] = 1466,
  [1477] = 114,
  [1478] = 1466,
  [1479] = 1464,
  [1480] = 1466,
  [1481] = 1466,
  [1482] = 1466,
  [1483] = 1464,
  [1484] = 1464,
  [1485] = 1466,
  [1486] = 1466,
  [1487] = 1464,
  [1488] = 1466,
  [1489] = 1464,
  [1490] = 1466,
  [1491] = 1464,
  [1492] = 121,
  [1493] = 1493,
  [1494] = 116,
  [1495] = 129,
  [1496] = 130,
  [1497] = 1497,
  [1498] = 124,
  [1499] = 131,
  [1500] = 1497,
  [1501] = 1493,
  [1502] = 1502,
  [1503] = 123,
  [1504] = 122,
  [1505] = 115,
  [1506] = 127,
  [1507] = 1507,
  [1508] = 119,
  [1509] = 1509,
  [1510] = 1493,
  [1511] = 1511,
  [1512] = 125,
  [1513] = 126,
  [1514] = 116,
  [1515] = 1515,
  [1516] = 128,
  [1517] = 118,
  [1518] = 1518,
  [1519] = 1497,
  [1520] = 1515,
  [1521] = 1521,
  [1522] = 1502,
  [1523] = 1523,
  [1524] = 1497,
  [1525] = 1521,
  [1526] = 1493,
  [1527] = 1527,
  [1528] = 120,
  [1529] = 1523,
  [1530] = 893,
  [1531] = 893,
  [1532] = 116,
  [1533] = 120,
  [1534] = 121,
  [1535] = 122,
  [1536] = 115,
  [1537] = 123,
  [1538] = 124,
  [1539] = 125,
  [1540] = 126,
  [1541] = 127,
  [1542] = 119,
  [1543] = 128,
  [1544] = 118,
  [1545] = 129,
  [1546] = 130,
  [1547] = 131,
  [1548] = 893,
  [1549] = 121,
  [1550] = 124,
  [1551] = 128,
  [1552] = 118,
  [1553] = 122,
  [1554] = 1554,
  [1555] = 120,
  [1556] = 129,
  [1557] = 119,
  [1558] = 115,
  [1559] = 130,
  [1560] = 126,
  [1561] = 127,
  [1562] = 125,
  [1563] = 123,
  [1564] = 131,
  [1565] = 1554,
  [1566] = 1566,
  [1567] = 1566,
  [1568] = 1566,
  [1569] = 1566,
  [1570] = 1570,
  [1571] = 1571,
  [1572] = 1570,
  [1573] = 1570,
  [1574] = 1571,
  [1575] = 1570,
  [1576] = 1570,
  [1577] = 1571,
  [1578] = 1571,
  [1579] = 1571,
  [1580] = 1571,
  [1581] = 1570,
  [1582] = 1571,
  [1583] = 1570,
  [1584] = 1584,
  [1585] = 1585,
  [1586] = 1584,
  [1587] = 1585,
  [1588] = 1588,
  [1589] = 1584,
  [1590] = 1588,
  [1591] = 1585,
  [1592] = 1584,
  [1593] = 1588,
  [1594] = 1588,
  [1595] = 1584,
  [1596] = 1588,
  [1597] = 1584,
  [1598] = 1585,
  [1599] = 1584,
  [1600] = 1584,
  [1601] = 1601,
  [1602] = 1588,
  [1603] = 1585,
  [1604] = 1585,
  [1605] = 116,
  [1606] = 1588,
  [1607] = 1588,
  [1608] = 1608,
  [1609] = 1584,
  [1610] = 1588,
  [1611] = 1611,
  [1612] = 1612,
  [1613] = 1613,
  [1614] = 1613,
  [1615] = 1613,
  [1616] = 1611,
  [1617] = 1612,
  [1618] = 1611,
  [1619] = 1613,
  [1620] = 1612,
  [1621] = 1612,
  [1622] = 1613,
  [1623] = 1612,
  [1624] = 1613,
  [1625] = 1612,
  [1626] = 1611,
  [1627] = 1627,
  [1628] = 203,
  [1629] = 1629,
  [1630] = 1630,
  [1631] = 1631,
  [1632] = 1632,
  [1633] = 1633,
  [1634] = 200,
  [1635] = 1635,
  [1636] = 1636,
  [1637] = 1636,
  [1638] = 300,
  [1639] = 1636,
  [1640] = 1636,
  [1641] = 262,
  [1642] = 1636,
  [1643] = 1636,
  [1644] = 285,
  [1645] = 1636,
  [1646] = 257,
  [1647] = 1647,
  [1648] = 1647,
  [1649] = 333,
  [1650] = 1647,
  [1651] = 203,
  [1652] = 116,
  [1653] = 200,
  [1654] = 709,
  [1655] = 1647,
  [1656] = 1656,
  [1657] = 522,
  [1658] = 1658,
  [1659] = 617,
  [1660] = 1660,
  [1661] = 1661,
  [1662] = 1662,
  [1663] = 1663,
  [1664] = 1664,
  [1665] = 1665,
  [1666] = 1666,
  [1667] = 590,
  [1668] = 1668,
  [1669] = 619,
  [1670] = 1670,
  [1671] = 1671,
  [1672] = 620,
  [1673] = 621,
  [1674] = 1674,
  [1675] = 1675,
  [1676] = 1676,
  [1677] = 623,
  [1678] = 624,
  [1679] = 631,
  [1680] = 1664,
  [1681] = 1681,
  [1682] = 574,
  [1683] = 575,
  [1684] = 1660,
  [1685] = 1685,
  [1686] = 1664,
  [1687] = 1687,
  [1688] = 1688,
  [1689] = 1689,
  [1690] = 1690,
  [1691] = 1691,
  [1692] = 1692,
  [1693] = 586,
  [1694] = 1694,
  [1695] = 1695,
  [1696] = 627,
  [1697] = 1697,
  [1698] = 577,
  [1699] = 1699,
  [1700] = 1700,
  [1701] = 1701,
  [1702] = 591,
  [1703] = 520,
  [1704] = 1704,
  [1705] = 1660,
  [1706] = 1706,
  [1707] = 1664,
  [1708] = 584,
  [1709] = 392,
  [1710] = 393,
  [1711] = 394,
  [1712] = 1712,
  [1713] = 592,
  [1714] = 1714,
  [1715] = 1715,
  [1716] = 1664,
  [1717] = 626,
  [1718] = 404,
  [1719] = 1719,
  [1720] = 1720,
  [1721] = 1721,
  [1722] = 1722,
  [1723] = 445,
  [1724] = 446,
  [1725] = 447,
  [1726] = 1726,
  [1727] = 1664,
  [1728] = 1728,
  [1729] = 450,
  [1730] = 455,
  [1731] = 600,
  [1732] = 466,
  [1733] = 519,
  [1734] = 468,
  [1735] = 570,
  [1736] = 583,
  [1737] = 377,
  [1738] = 609,
  [1739] = 550,
  [1740] = 521,
  [1741] = 618,
  [1742] = 1660,
  [1743] = 383,
  [1744] = 597,
  [1745] = 601,
  [1746] = 1746,
  [1747] = 544,
  [1748] = 1748,
  [1749] = 582,
  [1750] = 581,
  [1751] = 1664,
  [1752] = 1752,
  [1753] = 588,
  [1754] = 1660,
  [1755] = 589,
  [1756] = 1756,
  [1757] = 599,
  [1758] = 612,
  [1759] = 1759,
  [1760] = 529,
  [1761] = 530,
  [1762] = 1762,
  [1763] = 532,
  [1764] = 533,
  [1765] = 1765,
  [1766] = 534,
  [1767] = 1767,
  [1768] = 1768,
  [1769] = 1769,
  [1770] = 1770,
  [1771] = 535,
  [1772] = 536,
  [1773] = 1773,
  [1774] = 537,
  [1775] = 538,
  [1776] = 1776,
  [1777] = 543,
  [1778] = 1778,
  [1779] = 1748,
  [1780] = 1691,
  [1781] = 1781,
  [1782] = 1782,
  [1783] = 1748,
  [1784] = 1691,
  [1785] = 1785,
  [1786] = 1748,
  [1787] = 1748,
  [1788] = 1748,
  [1789] = 1748,
  [1790] = 1748,
  [1791] = 1791,
  [1792] = 1748,
  [1793] = 1793,
  [1794] = 1794,
  [1795] = 1795,
  [1796] = 1796,
  [1797] = 1797,
  [1798] = 1798,
  [1799] = 1799,
  [1800] = 1800,
  [1801] = 1801,
  [1802] = 1802,
  [1803] = 1803,
  [1804] = 613,
  [1805] = 1805,
  [1806] = 615,
  [1807] = 552,
  [1808] = 572,
  [1809] = 573,
  [1810] = 578,
  [1811] = 579,
  [1812] = 580,
  [1813] = 382,
  [1814] = 1814,
  [1815] = 285,
  [1816] = 1816,
  [1817] = 300,
  [1818] = 285,
  [1819] = 300,
  [1820] = 1820,
  [1821] = 257,
  [1822] = 1822,
  [1823] = 1814,
  [1824] = 1824,
  [1825] = 1814,
  [1826] = 1826,
  [1827] = 1827,
  [1828] = 257,
  [1829] = 262,
  [1830] = 1830,
  [1831] = 1831,
  [1832] = 1832,
  [1833] = 1833,
  [1834] = 1834,
  [1835] = 1835,
  [1836] = 262,
  [1837] = 1837,
  [1838] = 1838,
  [1839] = 1839,
  [1840] = 1840,
  [1841] = 1841,
  [1842] = 1842,
  [1843] = 1841,
  [1844] = 1844,
  [1845] = 1845,
  [1846] = 1845,
  [1847] = 1847,
  [1848] = 1848,
  [1849] = 1849,
  [1850] = 1850,
  [1851] = 1851,
  [1852] = 1851,
  [1853] = 1853,
  [1854] = 1841,
  [1855] = 1845,
  [1856] = 1845,
  [1857] = 1841,
  [1858] = 1851,
  [1859] = 1851,
  [1860] = 1845,
  [1861] = 1841,
  [1862] = 1841,
  [1863] = 1841,
  [1864] = 1864,
  [1865] = 1865,
  [1866] = 1845,
  [1867] = 1841,
  [1868] = 1841,
  [1869] = 1845,
  [1870] = 1870,
  [1871] = 1871,
  [1872] = 1845,
  [1873] = 1841,
  [1874] = 1841,
  [1875] = 1875,
  [1876] = 1851,
  [1877] = 1851,
  [1878] = 1841,
  [1879] = 1879,
  [1880] = 1845,
  [1881] = 1881,
  [1882] = 1841,
  [1883] = 1883,
  [1884] = 1845,
  [1885] = 1851,
  [1886] = 1886,
  [1887] = 1887,
  [1888] = 1845,
  [1889] = 1845,
  [1890] = 1845,
  [1891] = 1891,
  [1892] = 1892,
  [1893] = 1893,
  [1894] = 1894,
  [1895] = 1895,
  [1896] = 1896,
  [1897] = 1897,
  [1898] = 1898,
  [1899] = 1899,
  [1900] = 1900,
  [1901] = 1901,
  [1902] = 1902,
  [1903] = 1903,
  [1904] = 1904,
  [1905] = 1905,
  [1906] = 1894,
  [1907] = 1907,
  [1908] = 1908,
  [1909] = 1909,
  [1910] = 1899,
  [1911] = 1894,
  [1912] = 1899,
  [1913] = 1913,
  [1914] = 1905,
  [1915] = 1893,
  [1916] = 1916,
  [1917] = 1917,
  [1918] = 1902,
  [1919] = 1919,
  [1920] = 1920,
  [1921] = 1921,
  [1922] = 1897,
  [1923] = 1923,
  [1924] = 1908,
  [1925] = 1895,
  [1926] = 1926,
  [1927] = 1927,
  [1928] = 1928,
  [1929] = 1898,
  [1930] = 1930,
  [1931] = 1900,
  [1932] = 1932,
  [1933] = 1932,
  [1934] = 1934,
  [1935] = 1896,
  [1936] = 1920,
  [1937] = 1917,
  [1938] = 1938,
  [1939] = 1939,
  [1940] = 1899,
  [1941] = 1941,
  [1942] = 1904,
  [1943] = 1892,
  [1944] = 709,
  [1945] = 1945,
  [1946] = 1893,
  [1947] = 1938,
  [1948] = 1899,
  [1949] = 1949,
  [1950] = 1930,
  [1951] = 333,
  [1952] = 1952,
  [1953] = 1926,
  [1954] = 1899,
  [1955] = 1899,
  [1956] = 1908,
  [1957] = 1899,
  [1958] = 1907,
  [1959] = 1919,
  [1960] = 1893,
  [1961] = 1908,
  [1962] = 1949,
  [1963] = 1934,
  [1964] = 1921,
  [1965] = 1899,
  [1966] = 1894,
  [1967] = 333,
  [1968] = 1927,
  [1969] = 1913,
  [1970] = 1893,
  [1971] = 1926,
  [1972] = 1972,
  [1973] = 1899,
  [1974] = 1892,
  [1975] = 1939,
  [1976] = 1941,
  [1977] = 1952,
  [1978] = 709,
  [1979] = 1979,
  [1980] = 1928,
  [1981] = 1926,
  [1982] = 1899,
  [1983] = 1899,
  [1984] = 203,
  [1985] = 1979,
  [1986] = 1899,
  [1987] = 1891,
  [1988] = 1988,
  [1989] = 1972,
  [1990] = 200,
  [1991] = 1945,
  [1992] = 1988,
  [1993] = 1894,
  [1994] = 1801,
  [1995] = 1995,
  [1996] = 1996,
  [1997] = 1785,
  [1998] = 1998,
  [1999] = 1794,
  [2000] = 1795,
  [2001] = 1796,
  [2002] = 1797,
  [2003] = 1799,
  [2004] = 1800,
  [2005] = 1801,
  [2006] = 1802,
  [2007] = 1803,
  [2008] = 2008,
  [2009] = 2009,
  [2010] = 2010,
  [2011] = 2011,
  [2012] = 2012,
  [2013] = 2013,
  [2014] = 2014,
  [2015] = 2015,
  [2016] = 2016,
  [2017] = 1759,
  [2018] = 1770,
  [2019] = 1773,
  [2020] = 1793,
  [2021] = 1798,
  [2022] = 1805,
  [2023] = 1666,
  [2024] = 1670,
  [2025] = 1671,
  [2026] = 2026,
  [2027] = 1685,
  [2028] = 1687,
  [2029] = 1688,
  [2030] = 1689,
  [2031] = 1690,
  [2032] = 1694,
  [2033] = 1697,
  [2034] = 1699,
  [2035] = 1700,
  [2036] = 1701,
  [2037] = 1704,
  [2038] = 1706,
  [2039] = 1712,
  [2040] = 2040,
  [2041] = 1714,
  [2042] = 1719,
  [2043] = 1720,
  [2044] = 1721,
  [2045] = 2045,
  [2046] = 1726,
  [2047] = 1728,
  [2048] = 1746,
  [2049] = 1752,
  [2050] = 1762,
  [2051] = 1768,
  [2052] = 1769,
  [2053] = 1776,
  [2054] = 2054,
  [2055] = 2055,
  [2056] = 626,
  [2057] = 2057,
  [2058] = 2058,
  [2059] = 2059,
  [2060] = 2060,
  [2061] = 1759,
  [2062] = 519,
  [2063] = 570,
  [2064] = 2064,
  [2065] = 2065,
  [2066] = 2066,
  [2067] = 1996,
  [2068] = 2008,
  [2069] = 2010,
  [2070] = 2011,
  [2071] = 2012,
  [2072] = 2013,
  [2073] = 2014,
  [2074] = 2015,
  [2075] = 609,
  [2076] = 618,
  [2077] = 597,
  [2078] = 1770,
  [2079] = 601,
  [2080] = 1773,
  [2081] = 544,
  [2082] = 577,
  [2083] = 1793,
  [2084] = 1798,
  [2085] = 2085,
  [2086] = 1805,
  [2087] = 1666,
  [2088] = 1670,
  [2089] = 1671,
  [2090] = 2090,
  [2091] = 599,
  [2092] = 2092,
  [2093] = 2093,
  [2094] = 2094,
  [2095] = 532,
  [2096] = 2096,
  [2097] = 533,
  [2098] = 534,
  [2099] = 535,
  [2100] = 536,
  [2101] = 537,
  [2102] = 538,
  [2103] = 404,
  [2104] = 543,
  [2105] = 1685,
  [2106] = 1687,
  [2107] = 552,
  [2108] = 1688,
  [2109] = 584,
  [2110] = 1689,
  [2111] = 1690,
  [2112] = 1694,
  [2113] = 580,
  [2114] = 581,
  [2115] = 582,
  [2116] = 1697,
  [2117] = 2117,
  [2118] = 588,
  [2119] = 1699,
  [2120] = 1700,
  [2121] = 591,
  [2122] = 592,
  [2123] = 1701,
  [2124] = 1704,
  [2125] = 1706,
  [2126] = 450,
  [2127] = 455,
  [2128] = 600,
  [2129] = 1712,
  [2130] = 2130,
  [2131] = 2131,
  [2132] = 1714,
  [2133] = 612,
  [2134] = 1719,
  [2135] = 1720,
  [2136] = 1721,
  [2137] = 1722,
  [2138] = 1726,
  [2139] = 1728,
  [2140] = 1746,
  [2141] = 1752,
  [2142] = 1762,
  [2143] = 624,
  [2144] = 631,
  [2145] = 377,
  [2146] = 550,
  [2147] = 2147,
  [2148] = 1768,
  [2149] = 1769,
  [2150] = 1776,
  [2151] = 2151,
  [2152] = 520,
  [2153] = 2153,
  [2154] = 2154,
  [2155] = 2054,
  [2156] = 2055,
  [2157] = 2058,
  [2158] = 2054,
  [2159] = 2055,
  [2160] = 583,
  [2161] = 2015,
  [2162] = 2162,
  [2163] = 2057,
  [2164] = 2096,
  [2165] = 2058,
  [2166] = 529,
  [2167] = 530,
  [2168] = 2096,
  [2169] = 572,
  [2170] = 573,
  [2171] = 578,
  [2172] = 579,
  [2173] = 2117,
  [2174] = 589,
  [2175] = 590,
  [2176] = 2064,
  [2177] = 2065,
  [2178] = 2066,
  [2179] = 1996,
  [2180] = 2008,
  [2181] = 2010,
  [2182] = 2011,
  [2183] = 2012,
  [2184] = 2013,
  [2185] = 2014,
  [2186] = 2015,
  [2187] = 613,
  [2188] = 615,
  [2189] = 617,
  [2190] = 619,
  [2191] = 620,
  [2192] = 621,
  [2193] = 623,
  [2194] = 586,
  [2195] = 627,
  [2196] = 2054,
  [2197] = 2055,
  [2198] = 2198,
  [2199] = 2058,
  [2200] = 2200,
  [2201] = 2058,
  [2202] = 2054,
  [2203] = 2203,
  [2204] = 2015,
  [2205] = 2205,
  [2206] = 2055,
  [2207] = 392,
  [2208] = 817,
  [2209] = 393,
  [2210] = 394,
  [2211] = 2096,
  [2212] = 2212,
  [2213] = 2213,
  [2214] = 445,
  [2215] = 446,
  [2216] = 447,
  [2217] = 2217,
  [2218] = 2117,
  [2219] = 2219,
  [2220] = 2220,
  [2221] = 466,
  [2222] = 468,
  [2223] = 382,
  [2224] = 383,
  [2225] = 2096,
  [2226] = 626,
  [2227] = 2058,
  [2228] = 519,
  [2229] = 570,
  [2230] = 583,
  [2231] = 2015,
  [2232] = 609,
  [2233] = 618,
  [2234] = 2234,
  [2235] = 597,
  [2236] = 601,
  [2237] = 2237,
  [2238] = 544,
  [2239] = 599,
  [2240] = 529,
  [2241] = 530,
  [2242] = 532,
  [2243] = 2096,
  [2244] = 533,
  [2245] = 534,
  [2246] = 535,
  [2247] = 536,
  [2248] = 537,
  [2249] = 538,
  [2250] = 543,
  [2251] = 521,
  [2252] = 522,
  [2253] = 552,
  [2254] = 572,
  [2255] = 573,
  [2256] = 578,
  [2257] = 579,
  [2258] = 580,
  [2259] = 581,
  [2260] = 582,
  [2261] = 2117,
  [2262] = 588,
  [2263] = 589,
  [2264] = 590,
  [2265] = 591,
  [2266] = 592,
  [2267] = 521,
  [2268] = 574,
  [2269] = 575,
  [2270] = 612,
  [2271] = 613,
  [2272] = 615,
  [2273] = 617,
  [2274] = 619,
  [2275] = 620,
  [2276] = 621,
  [2277] = 623,
  [2278] = 624,
  [2279] = 631,
  [2280] = 577,
  [2281] = 586,
  [2282] = 627,
  [2283] = 584,
  [2284] = 520,
  [2285] = 1692,
  [2286] = 522,
  [2287] = 1695,
  [2288] = 2288,
  [2289] = 2289,
  [2290] = 2290,
  [2291] = 2291,
  [2292] = 392,
  [2293] = 393,
  [2294] = 394,
  [2295] = 404,
  [2296] = 445,
  [2297] = 446,
  [2298] = 447,
  [2299] = 450,
  [2300] = 455,
  [2301] = 600,
  [2302] = 466,
  [2303] = 468,
  [2304] = 377,
  [2305] = 550,
  [2306] = 382,
  [2307] = 383,
  [2308] = 2117,
  [2309] = 2309,
  [2310] = 2045,
  [2311] = 2289,
  [2312] = 2312,
  [2313] = 1995,
  [2314] = 2314,
  [2315] = 2315,
  [2316] = 2316,
  [2317] = 2314,
  [2318] = 2290,
  [2319] = 2288,
  [2320] = 2054,
  [2321] = 2055,
  [2322] = 2162,
  [2323] = 2057,
  [2324] = 2058,
  [2325] = 2117,
  [2326] = 2064,
  [2327] = 2065,
  [2328] = 2066,
  [2329] = 1996,
  [2330] = 2008,
  [2331] = 2010,
  [2332] = 2011,
  [2333] = 2012,
  [2334] = 2013,
  [2335] = 2014,
  [2336] = 2015,
  [2337] = 2096,
  [2338] = 2220,
  [2339] = 2117,
  [2340] = 2054,
  [2341] = 2055,
  [2342] = 2057,
  [2343] = 2064,
  [2344] = 2065,
  [2345] = 2066,
  [2346] = 1996,
  [2347] = 2008,
  [2348] = 2010,
  [2349] = 2011,
  [2350] = 2012,
  [2351] = 2013,
  [2352] = 2014,
  [2353] = 2057,
  [2354] = 2054,
  [2355] = 2055,
  [2356] = 2058,
  [2357] = 2015,
  [2358] = 2096,
  [2359] = 2117,
  [2360] = 2314,
  [2361] = 2290,
  [2362] = 2058,
  [2363] = 2288,
  [2364] = 2054,
  [2365] = 2055,
  [2366] = 2162,
  [2367] = 2057,
  [2368] = 2058,
  [2369] = 2064,
  [2370] = 2065,
  [2371] = 2066,
  [2372] = 1996,
  [2373] = 2008,
  [2374] = 2010,
  [2375] = 2011,
  [2376] = 2012,
  [2377] = 2013,
  [2378] = 2014,
  [2379] = 2015,
  [2380] = 2380,
  [2381] = 2096,
  [2382] = 2117,
  [2383] = 2064,
  [2384] = 2065,
  [2385] = 2066,
  [2386] = 1996,
  [2387] = 2008,
  [2388] = 2010,
  [2389] = 2011,
  [2390] = 2057,
  [2391] = 2064,
  [2392] = 2065,
  [2393] = 2066,
  [2394] = 1996,
  [2395] = 2008,
  [2396] = 2010,
  [2397] = 2011,
  [2398] = 2012,
  [2399] = 2013,
  [2400] = 2014,
  [2401] = 2054,
  [2402] = 2055,
  [2403] = 2314,
  [2404] = 2012,
  [2405] = 2013,
  [2406] = 2288,
  [2407] = 2014,
  [2408] = 2015,
  [2409] = 2162,
  [2410] = 2057,
  [2411] = 2064,
  [2412] = 2065,
  [2413] = 2066,
  [2414] = 1996,
  [2415] = 2008,
  [2416] = 2010,
  [2417] = 2011,
  [2418] = 2012,
  [2419] = 2013,
  [2420] = 2014,
  [2421] = 2314,
  [2422] = 2162,
  [2423] = 2288,
  [2424] = 2424,
  [2425] = 2057,
  [2426] = 2057,
  [2427] = 2064,
  [2428] = 2065,
  [2429] = 2066,
  [2430] = 1996,
  [2431] = 2008,
  [2432] = 2010,
  [2433] = 2011,
  [2434] = 2012,
  [2435] = 2013,
  [2436] = 2014,
  [2437] = 2314,
  [2438] = 2288,
  [2439] = 2314,
  [2440] = 2288,
  [2441] = 1785,
  [2442] = 574,
  [2443] = 2314,
  [2444] = 2288,
  [2445] = 1794,
  [2446] = 1795,
  [2447] = 2314,
  [2448] = 2288,
  [2449] = 2314,
  [2450] = 2288,
  [2451] = 2096,
  [2452] = 1796,
  [2453] = 2453,
  [2454] = 1797,
  [2455] = 1799,
  [2456] = 1800,
  [2457] = 1802,
  [2458] = 1803,
  [2459] = 575,
  [2460] = 2460,
  [2461] = 2237,
  [2462] = 2205,
  [2463] = 2057,
  [2464] = 2058,
  [2465] = 2315,
  [2466] = 2064,
  [2467] = 2065,
  [2468] = 2066,
  [2469] = 1996,
  [2470] = 2008,
  [2471] = 2010,
  [2472] = 2011,
  [2473] = 2012,
  [2474] = 2013,
  [2475] = 2014,
  [2476] = 2015,
  [2477] = 2059,
  [2478] = 2016,
  [2479] = 2026,
  [2480] = 2060,
  [2481] = 2085,
  [2482] = 2096,
  [2483] = 2200,
  [2484] = 2117,
  [2485] = 2485,
  [2486] = 2092,
  [2487] = 2094,
  [2488] = 1692,
  [2489] = 2237,
  [2490] = 2205,
  [2491] = 1695,
  [2492] = 2315,
  [2493] = 2059,
  [2494] = 2016,
  [2495] = 2026,
  [2496] = 2060,
  [2497] = 2085,
  [2498] = 2200,
  [2499] = 2485,
  [2500] = 2092,
  [2501] = 2094,
  [2502] = 2237,
  [2503] = 2205,
  [2504] = 2315,
  [2505] = 2059,
  [2506] = 2016,
  [2507] = 2026,
  [2508] = 2060,
  [2509] = 2085,
  [2510] = 2200,
  [2511] = 2485,
  [2512] = 2092,
  [2513] = 2094,
  [2514] = 2237,
  [2515] = 2205,
  [2516] = 2315,
  [2517] = 2059,
  [2518] = 2016,
  [2519] = 2026,
  [2520] = 2060,
  [2521] = 2085,
  [2522] = 2200,
  [2523] = 2485,
  [2524] = 2092,
  [2525] = 2094,
  [2526] = 2315,
  [2527] = 2059,
  [2528] = 2016,
  [2529] = 2026,
  [2530] = 2060,
  [2531] = 2085,
  [2532] = 2200,
  [2533] = 2485,
  [2534] = 2092,
  [2535] = 2094,
  [2536] = 2315,
  [2537] = 2059,
  [2538] = 2016,
  [2539] = 2060,
  [2540] = 2085,
  [2541] = 2200,
  [2542] = 2485,
  [2543] = 2094,
  [2544] = 2315,
  [2545] = 2060,
  [2546] = 2085,
  [2547] = 2485,
  [2548] = 2094,
  [2549] = 2315,
  [2550] = 2060,
  [2551] = 2085,
  [2552] = 2485,
  [2553] = 2094,
  [2554] = 2315,
  [2555] = 2485,
  [2556] = 2094,
  [2557] = 2315,
  [2558] = 2485,
  [2559] = 2094,
  [2560] = 2485,
  [2561] = 2094,
  [2562] = 2485,
  [2563] = 2094,
  [2564] = 2485,
  [2565] = 2094,
  [2566] = 2485,
  [2567] = 2094,
  [2568] = 2485,
  [2569] = 2094,
  [2570] = 2485,
  [2571] = 2094,
  [2572] = 2485,
  [2573] = 2094,
  [2574] = 2485,
  [2575] = 2094,
  [2576] = 2485,
  [2577] = 2094,
  [2578] = 2485,
  [2579] = 2094,
  [2580] = 2485,
  [2581] = 2094,
  [2582] = 2485,
  [2583] = 2094,
  [2584] = 2485,
  [2585] = 2094,
  [2586] = 2485,
  [2587] = 2094,
  [2588] = 2485,
  [2589] = 2094,
  [2590] = 2314,
  [2591] = 2288,
  [2592] = 2054,
  [2593] = 2055,
  [2594] = 2234,
  [2595] = 2485,
  [2596] = 2380,
  [2597] = 2198,
  [2598] = 2314,
  [2599] = 2288,
  [2600] = 2065,
  [2601] = 2234,
  [2602] = 2380,
  [2603] = 2198,
  [2604] = 2234,
  [2605] = 2380,
  [2606] = 2198,
  [2607] = 2234,
  [2608] = 2380,
  [2609] = 2198,
  [2610] = 2234,
  [2611] = 2380,
  [2612] = 2198,
  [2613] = 2234,
  [2614] = 2380,
  [2615] = 2198,
  [2616] = 2162,
  [2617] = 2117,
  [2618] = 2057,
  [2619] = 2064,
  [2620] = 2065,
  [2621] = 2066,
  [2622] = 1996,
  [2623] = 2008,
  [2624] = 2010,
  [2625] = 2011,
  [2626] = 2012,
  [2627] = 2013,
  [2628] = 2014,
  [2629] = 2054,
  [2630] = 2055,
  [2631] = 2058,
  [2632] = 2015,
  [2633] = 2064,
  [2634] = 2096,
  [2635] = 2117,
  [2636] = 2057,
  [2637] = 2058,
  [2638] = 2065,
  [2639] = 2064,
  [2640] = 2066,
  [2641] = 1996,
  [2642] = 2008,
  [2643] = 2010,
  [2644] = 2011,
  [2645] = 2012,
  [2646] = 2013,
  [2647] = 2014,
  [2648] = 2015,
  [2649] = 2066,
  [2650] = 2096,
  [2651] = 2117,
  [2652] = 2314,
  [2653] = 2288,
  [2654] = 2054,
  [2655] = 2055,
  [2656] = 2312,
  [2657] = 2045,
  [2658] = 2045,
  [2659] = 2045,
  [2660] = 2045,
  [2661] = 1722,
  [2662] = 2662,
  [2663] = 824,
  [2664] = 719,
  [2665] = 2662,
  [2666] = 2662,
  [2667] = 2662,
  [2668] = 2668,
  [2669] = 2668,
  [2670] = 2670,
  [2671] = 2668,
  [2672] = 2670,
  [2673] = 2670,
  [2674] = 2668,
  [2675] = 2668,
  [2676] = 2668,
  [2677] = 2668,
  [2678] = 2670,
  [2679] = 531,
  [2680] = 201,
  [2681] = 2681,
  [2682] = 2682,
  [2683] = 202,
  [2684] = 2684,
  [2685] = 817,
  [2686] = 2686,
  [2687] = 122,
  [2688] = 210,
  [2689] = 206,
  [2690] = 204,
  [2691] = 207,
  [2692] = 531,
  [2693] = 284,
  [2694] = 203,
  [2695] = 1421,
  [2696] = 200,
  [2697] = 2697,
  [2698] = 1421,
  [2699] = 2699,
  [2700] = 205,
  [2701] = 214,
  [2702] = 120,
  [2703] = 121,
  [2704] = 131,
  [2705] = 115,
  [2706] = 123,
  [2707] = 124,
  [2708] = 125,
  [2709] = 126,
  [2710] = 127,
  [2711] = 119,
  [2712] = 128,
  [2713] = 118,
  [2714] = 129,
  [2715] = 130,
  [2716] = 719,
  [2717] = 389,
  [2718] = 425,
  [2719] = 824,
  [2720] = 214,
  [2721] = 206,
  [2722] = 210,
  [2723] = 205,
  [2724] = 204,
  [2725] = 1199,
  [2726] = 284,
  [2727] = 1421,
  [2728] = 1194,
  [2729] = 207,
  [2730] = 568,
  [2731] = 719,
  [2732] = 824,
  [2733] = 719,
  [2734] = 670,
  [2735] = 389,
  [2736] = 425,
  [2737] = 260,
  [2738] = 824,
  [2739] = 389,
  [2740] = 425,
  [2741] = 131,
  [2742] = 115,
  [2743] = 642,
  [2744] = 653,
  [2745] = 666,
  [2746] = 681,
  [2747] = 123,
  [2748] = 124,
  [2749] = 125,
  [2750] = 126,
  [2751] = 687,
  [2752] = 688,
  [2753] = 127,
  [2754] = 119,
  [2755] = 128,
  [2756] = 118,
  [2757] = 129,
  [2758] = 130,
  [2759] = 662,
  [2760] = 658,
  [2761] = 661,
  [2762] = 284,
  [2763] = 689,
  [2764] = 665,
  [2765] = 120,
  [2766] = 121,
  [2767] = 122,
  [2768] = 668,
  [2769] = 2769,
  [2770] = 2770,
  [2771] = 2770,
  [2772] = 2772,
  [2773] = 2773,
  [2774] = 656,
  [2775] = 2770,
  [2776] = 2770,
  [2777] = 425,
  [2778] = 389,
  [2779] = 670,
  [2780] = 670,
  [2781] = 2781,
  [2782] = 2781,
  [2783] = 632,
  [2784] = 637,
  [2785] = 2781,
  [2786] = 2781,
  [2787] = 2781,
  [2788] = 389,
  [2789] = 531,
  [2790] = 425,
  [2791] = 2781,
  [2792] = 2781,
  [2793] = 2793,
  [2794] = 2794,
  [2795] = 2794,
  [2796] = 2793,
  [2797] = 2797,
  [2798] = 2794,
  [2799] = 531,
  [2800] = 2797,
  [2801] = 585,
  [2802] = 2794,
  [2803] = 2794,
  [2804] = 531,
  [2805] = 2805,
  [2806] = 2805,
  [2807] = 2797,
  [2808] = 2797,
  [2809] = 2797,
  [2810] = 2794,
  [2811] = 2797,
  [2812] = 2794,
  [2813] = 2797,
  [2814] = 663,
  [2815] = 389,
  [2816] = 646,
  [2817] = 425,
  [2818] = 670,
  [2819] = 647,
  [2820] = 698,
  [2821] = 650,
  [2822] = 652,
  [2823] = 595,
  [2824] = 667,
  [2825] = 2825,
  [2826] = 302,
  [2827] = 2827,
  [2828] = 284,
  [2829] = 2829,
  [2830] = 686,
  [2831] = 654,
  [2832] = 644,
  [2833] = 673,
  [2834] = 664,
  [2835] = 2835,
  [2836] = 2835,
  [2837] = 1276,
  [2838] = 287,
  [2839] = 315,
  [2840] = 288,
  [2841] = 2841,
  [2842] = 256,
  [2843] = 2835,
  [2844] = 831,
  [2845] = 824,
  [2846] = 318,
  [2847] = 841,
  [2848] = 2835,
  [2849] = 310,
  [2850] = 293,
  [2851] = 319,
  [2852] = 719,
  [2853] = 320,
  [2854] = 321,
  [2855] = 2835,
  [2856] = 1194,
  [2857] = 2841,
  [2858] = 294,
  [2859] = 241,
  [2860] = 2841,
  [2861] = 202,
  [2862] = 2835,
  [2863] = 322,
  [2864] = 2864,
  [2865] = 201,
  [2866] = 254,
  [2867] = 328,
  [2868] = 306,
  [2869] = 296,
  [2870] = 297,
  [2871] = 286,
  [2872] = 311,
  [2873] = 531,
  [2874] = 1199,
  [2875] = 2835,
  [2876] = 312,
  [2877] = 2877,
  [2878] = 284,
  [2879] = 307,
  [2880] = 323,
  [2881] = 284,
  [2882] = 325,
  [2883] = 303,
  [2884] = 585,
  [2885] = 317,
  [2886] = 313,
  [2887] = 595,
  [2888] = 324,
  [2889] = 670,
  [2890] = 2864,
  [2891] = 326,
  [2892] = 327,
  [2893] = 2841,
  [2894] = 316,
  [2895] = 242,
  [2896] = 305,
  [2897] = 289,
  [2898] = 290,
  [2899] = 308,
  [2900] = 309,
  [2901] = 304,
  [2902] = 2864,
  [2903] = 329,
  [2904] = 298,
  [2905] = 719,
  [2906] = 2772,
  [2907] = 824,
  [2908] = 2908,
  [2909] = 719,
  [2910] = 2910,
  [2911] = 2911,
  [2912] = 824,
  [2913] = 2827,
  [2914] = 2914,
  [2915] = 2877,
  [2916] = 2916,
  [2917] = 409,
  [2918] = 414,
  [2919] = 2919,
  [2920] = 121,
  [2921] = 214,
  [2922] = 129,
  [2923] = 202,
  [2924] = 119,
  [2925] = 2925,
  [2926] = 131,
  [2927] = 130,
  [2928] = 115,
  [2929] = 123,
  [2930] = 120,
  [2931] = 125,
  [2932] = 124,
  [2933] = 126,
  [2934] = 128,
  [2935] = 670,
  [2936] = 118,
  [2937] = 127,
  [2938] = 201,
  [2939] = 284,
  [2940] = 122,
  [2941] = 122,
  [2942] = 128,
  [2943] = 409,
  [2944] = 118,
  [2945] = 414,
  [2946] = 129,
  [2947] = 130,
  [2948] = 131,
  [2949] = 1194,
  [2950] = 719,
  [2951] = 1199,
  [2952] = 2952,
  [2953] = 210,
  [2954] = 2916,
  [2955] = 2914,
  [2956] = 2956,
  [2957] = 120,
  [2958] = 121,
  [2959] = 824,
  [2960] = 115,
  [2961] = 123,
  [2962] = 124,
  [2963] = 125,
  [2964] = 126,
  [2965] = 127,
  [2966] = 119,
  [2967] = 214,
  [2968] = 125,
  [2969] = 126,
  [2970] = 2970,
  [2971] = 127,
  [2972] = 119,
  [2973] = 114,
  [2974] = 128,
  [2975] = 118,
  [2976] = 129,
  [2977] = 130,
  [2978] = 131,
  [2979] = 120,
  [2980] = 121,
  [2981] = 2981,
  [2982] = 2982,
  [2983] = 122,
  [2984] = 2984,
  [2985] = 115,
  [2986] = 123,
  [2987] = 2987,
  [2988] = 124,
  [2989] = 2827,
  [2990] = 120,
  [2991] = 118,
  [2992] = 125,
  [2993] = 126,
  [2994] = 127,
  [2995] = 131,
  [2996] = 119,
  [2997] = 256,
  [2998] = 121,
  [2999] = 116,
  [3000] = 122,
  [3001] = 114,
  [3002] = 115,
  [3003] = 205,
  [3004] = 206,
  [3005] = 123,
  [3006] = 124,
  [3007] = 130,
  [3008] = 207,
  [3009] = 129,
  [3010] = 3010,
  [3011] = 254,
  [3012] = 128,
  [3013] = 204,
  [3014] = 286,
  [3015] = 260,
  [3016] = 293,
  [3017] = 302,
  [3018] = 294,
  [3019] = 328,
  [3020] = 303,
  [3021] = 317,
  [3022] = 297,
  [3023] = 309,
  [3024] = 242,
  [3025] = 831,
  [3026] = 841,
  [3027] = 114,
  [3028] = 305,
  [3029] = 327,
  [3030] = 304,
  [3031] = 329,
  [3032] = 306,
  [3033] = 307,
  [3034] = 318,
  [3035] = 287,
  [3036] = 288,
  [3037] = 310,
  [3038] = 324,
  [3039] = 311,
  [3040] = 312,
  [3041] = 819,
  [3042] = 114,
  [3043] = 116,
  [3044] = 313,
  [3045] = 320,
  [3046] = 298,
  [3047] = 762,
  [3048] = 321,
  [3049] = 114,
  [3050] = 670,
  [3051] = 241,
  [3052] = 322,
  [3053] = 323,
  [3054] = 319,
  [3055] = 289,
  [3056] = 290,
  [3057] = 308,
  [3058] = 325,
  [3059] = 326,
  [3060] = 316,
  [3061] = 296,
  [3062] = 315,
  [3063] = 817,
  [3064] = 116,
  [3065] = 389,
  [3066] = 2908,
  [3067] = 762,
  [3068] = 389,
  [3069] = 425,
  [3070] = 2911,
  [3071] = 3071,
  [3072] = 3072,
  [3073] = 116,
  [3074] = 425,
  [3075] = 819,
  [3076] = 3076,
  [3077] = 116,
  [3078] = 2952,
  [3079] = 668,
  [3080] = 653,
  [3081] = 656,
  [3082] = 687,
  [3083] = 2827,
  [3084] = 260,
  [3085] = 642,
  [3086] = 665,
  [3087] = 114,
  [3088] = 2793,
  [3089] = 666,
  [3090] = 688,
  [3091] = 2805,
  [3092] = 658,
  [3093] = 662,
  [3094] = 661,
  [3095] = 689,
  [3096] = 201,
  [3097] = 681,
  [3098] = 202,
  [3099] = 260,
  [3100] = 3100,
  [3101] = 389,
  [3102] = 204,
  [3103] = 207,
  [3104] = 3104,
  [3105] = 210,
  [3106] = 3106,
  [3107] = 205,
  [3108] = 116,
  [3109] = 206,
  [3110] = 3110,
  [3111] = 425,
  [3112] = 568,
  [3113] = 824,
  [3114] = 632,
  [3115] = 450,
  [3116] = 670,
  [3117] = 455,
  [3118] = 719,
  [3119] = 600,
  [3120] = 3120,
  [3121] = 1462,
  [3122] = 3122,
  [3123] = 3123,
  [3124] = 3124,
  [3125] = 114,
  [3126] = 214,
  [3127] = 670,
  [3128] = 637,
  [3129] = 377,
  [3130] = 550,
  [3131] = 404,
  [3132] = 637,
  [3133] = 3133,
  [3134] = 2952,
  [3135] = 2952,
  [3136] = 2793,
  [3137] = 663,
  [3138] = 3133,
  [3139] = 632,
  [3140] = 256,
  [3141] = 2952,
  [3142] = 568,
  [3143] = 646,
  [3144] = 2987,
  [3145] = 673,
  [3146] = 2805,
  [3147] = 652,
  [3148] = 698,
  [3149] = 595,
  [3150] = 254,
  [3151] = 644,
  [3152] = 667,
  [3153] = 654,
  [3154] = 2984,
  [3155] = 3120,
  [3156] = 389,
  [3157] = 3157,
  [3158] = 2970,
  [3159] = 425,
  [3160] = 686,
  [3161] = 3133,
  [3162] = 664,
  [3163] = 3157,
  [3164] = 650,
  [3165] = 3165,
  [3166] = 647,
  [3167] = 3167,
  [3168] = 663,
  [3169] = 284,
  [3170] = 3123,
  [3171] = 686,
  [3172] = 662,
  [3173] = 665,
  [3174] = 668,
  [3175] = 653,
  [3176] = 531,
  [3177] = 3177,
  [3178] = 642,
  [3179] = 666,
  [3180] = 681,
  [3181] = 687,
  [3182] = 688,
  [3183] = 689,
  [3184] = 658,
  [3185] = 661,
  [3186] = 698,
  [3187] = 313,
  [3188] = 667,
  [3189] = 315,
  [3190] = 646,
  [3191] = 647,
  [3192] = 324,
  [3193] = 2987,
  [3194] = 3194,
  [3195] = 289,
  [3196] = 290,
  [3197] = 3197,
  [3198] = 3198,
  [3199] = 308,
  [3200] = 309,
  [3201] = 3201,
  [3202] = 3123,
  [3203] = 3124,
  [3204] = 293,
  [3205] = 294,
  [3206] = 328,
  [3207] = 409,
  [3208] = 414,
  [3209] = 241,
  [3210] = 3197,
  [3211] = 318,
  [3212] = 320,
  [3213] = 321,
  [3214] = 322,
  [3215] = 3124,
  [3216] = 817,
  [3217] = 325,
  [3218] = 326,
  [3219] = 242,
  [3220] = 327,
  [3221] = 2952,
  [3222] = 3197,
  [3223] = 3197,
  [3224] = 644,
  [3225] = 664,
  [3226] = 673,
  [3227] = 296,
  [3228] = 297,
  [3229] = 298,
  [3230] = 302,
  [3231] = 654,
  [3232] = 303,
  [3233] = 317,
  [3234] = 305,
  [3235] = 286,
  [3236] = 287,
  [3237] = 650,
  [3238] = 288,
  [3239] = 3239,
  [3240] = 652,
  [3241] = 2970,
  [3242] = 3197,
  [3243] = 2984,
  [3244] = 3197,
  [3245] = 304,
  [3246] = 329,
  [3247] = 306,
  [3248] = 307,
  [3249] = 310,
  [3250] = 311,
  [3251] = 312,
  [3252] = 3252,
  [3253] = 316,
  [3254] = 319,
  [3255] = 2952,
  [3256] = 595,
  [3257] = 323,
  [3258] = 3076,
  [3259] = 3259,
  [3260] = 3260,
  [3261] = 2970,
  [3262] = 642,
  [3263] = 409,
  [3264] = 414,
  [3265] = 666,
  [3266] = 681,
  [3267] = 3267,
  [3268] = 2987,
  [3269] = 2908,
  [3270] = 687,
  [3271] = 3271,
  [3272] = 688,
  [3273] = 3273,
  [3274] = 3274,
  [3275] = 689,
  [3276] = 2984,
  [3277] = 3277,
  [3278] = 114,
  [3279] = 2952,
  [3280] = 3071,
  [3281] = 2952,
  [3282] = 3282,
  [3283] = 3283,
  [3284] = 3284,
  [3285] = 3285,
  [3286] = 3286,
  [3287] = 3287,
  [3288] = 658,
  [3289] = 661,
  [3290] = 3120,
  [3291] = 3291,
  [3292] = 3292,
  [3293] = 3293,
  [3294] = 114,
  [3295] = 120,
  [3296] = 121,
  [3297] = 122,
  [3298] = 115,
  [3299] = 123,
  [3300] = 124,
  [3301] = 2952,
  [3302] = 125,
  [3303] = 126,
  [3304] = 127,
  [3305] = 119,
  [3306] = 128,
  [3307] = 118,
  [3308] = 129,
  [3309] = 130,
  [3310] = 131,
  [3311] = 656,
  [3312] = 3312,
  [3313] = 3313,
  [3314] = 662,
  [3315] = 3315,
  [3316] = 665,
  [3317] = 668,
  [3318] = 2952,
  [3319] = 653,
  [3320] = 2911,
  [3321] = 3321,
  [3322] = 568,
  [3323] = 3323,
  [3324] = 2908,
  [3325] = 116,
  [3326] = 670,
  [3327] = 284,
  [3328] = 260,
  [3329] = 3329,
  [3330] = 3330,
  [3331] = 3076,
  [3332] = 656,
  [3333] = 2911,
  [3334] = 3334,
  [3335] = 3071,
  [3336] = 3120,
  [3337] = 2970,
  [3338] = 3338,
  [3339] = 3339,
  [3340] = 2984,
  [3341] = 1194,
  [3342] = 116,
  [3343] = 3343,
  [3344] = 414,
  [3345] = 2908,
  [3346] = 2911,
  [3347] = 3347,
  [3348] = 3348,
  [3349] = 2911,
  [3350] = 3350,
  [3351] = 3351,
  [3352] = 3352,
  [3353] = 3353,
  [3354] = 3354,
  [3355] = 3355,
  [3356] = 824,
  [3357] = 3076,
  [3358] = 260,
  [3359] = 3359,
  [3360] = 3360,
  [3361] = 3361,
  [3362] = 3071,
  [3363] = 2908,
  [3364] = 3364,
  [3365] = 3071,
  [3366] = 3076,
  [3367] = 414,
  [3368] = 3120,
  [3369] = 3369,
  [3370] = 3370,
  [3371] = 409,
  [3372] = 1199,
  [3373] = 719,
  [3374] = 2987,
  [3375] = 3375,
  [3376] = 3376,
  [3377] = 568,
  [3378] = 409,
  [3379] = 3379,
  [3380] = 3380,
  [3381] = 3381,
  [3382] = 3382,
  [3383] = 681,
  [3384] = 3384,
  [3385] = 201,
  [3386] = 3386,
  [3387] = 3387,
  [3388] = 1681,
  [3389] = 3389,
  [3390] = 3390,
  [3391] = 658,
  [3392] = 202,
  [3393] = 661,
  [3394] = 3394,
  [3395] = 662,
  [3396] = 3396,
  [3397] = 687,
  [3398] = 3398,
  [3399] = 3399,
  [3400] = 2911,
  [3401] = 3401,
  [3402] = 3402,
  [3403] = 3403,
  [3404] = 2908,
  [3405] = 688,
  [3406] = 200,
  [3407] = 3407,
  [3408] = 3408,
  [3409] = 3409,
  [3410] = 3410,
  [3411] = 3411,
  [3412] = 3412,
  [3413] = 1765,
  [3414] = 3414,
  [3415] = 3415,
  [3416] = 3416,
  [3417] = 3076,
  [3418] = 3418,
  [3419] = 3419,
  [3420] = 3420,
  [3421] = 2697,
  [3422] = 595,
  [3423] = 3423,
  [3424] = 3424,
  [3425] = 3425,
  [3426] = 3426,
  [3427] = 1656,
  [3428] = 3428,
  [3429] = 642,
  [3430] = 3430,
  [3431] = 1661,
  [3432] = 3432,
  [3433] = 3433,
  [3434] = 1674,
  [3435] = 3435,
  [3436] = 1662,
  [3437] = 3124,
  [3438] = 2699,
  [3439] = 665,
  [3440] = 1668,
  [3441] = 3441,
  [3442] = 3442,
  [3443] = 2911,
  [3444] = 3071,
  [3445] = 3445,
  [3446] = 666,
  [3447] = 3447,
  [3448] = 3448,
  [3449] = 3449,
  [3450] = 3450,
  [3451] = 668,
  [3452] = 1767,
  [3453] = 653,
  [3454] = 1663,
  [3455] = 1665,
  [3456] = 3456,
  [3457] = 3457,
  [3458] = 3458,
  [3459] = 3459,
  [3460] = 3460,
  [3461] = 203,
  [3462] = 3076,
  [3463] = 2908,
  [3464] = 3464,
  [3465] = 3465,
  [3466] = 3466,
  [3467] = 1675,
  [3468] = 3468,
  [3469] = 1676,
  [3470] = 3470,
  [3471] = 3471,
  [3472] = 689,
  [3473] = 3473,
  [3474] = 1778,
  [3475] = 1781,
  [3476] = 1791,
  [3477] = 3477,
  [3478] = 3478,
  [3479] = 3479,
  [3480] = 3071,
  [3481] = 3123,
  [3482] = 2911,
  [3483] = 414,
  [3484] = 3477,
  [3485] = 201,
  [3486] = 3478,
  [3487] = 409,
  [3488] = 260,
  [3489] = 3419,
  [3490] = 205,
  [3491] = 206,
  [3492] = 204,
  [3493] = 819,
  [3494] = 205,
  [3495] = 206,
  [3496] = 3071,
  [3497] = 3076,
  [3498] = 202,
  [3499] = 204,
  [3500] = 3120,
  [3501] = 568,
  [3502] = 207,
  [3503] = 762,
  [3504] = 662,
  [3505] = 2908,
  [3506] = 665,
  [3507] = 668,
  [3508] = 653,
  [3509] = 642,
  [3510] = 666,
  [3511] = 681,
  [3512] = 687,
  [3513] = 688,
  [3514] = 689,
  [3515] = 210,
  [3516] = 658,
  [3517] = 661,
  [3518] = 595,
  [3519] = 214,
  [3520] = 819,
  [3521] = 762,
  [3522] = 210,
  [3523] = 214,
  [3524] = 409,
  [3525] = 414,
  [3526] = 2987,
  [3527] = 2970,
  [3528] = 207,
  [3529] = 3529,
  [3530] = 3530,
  [3531] = 2984,
  [3532] = 2911,
  [3533] = 204,
  [3534] = 2908,
  [3535] = 656,
  [3536] = 3071,
  [3537] = 3076,
  [3538] = 205,
  [3539] = 206,
  [3540] = 3540,
  [3541] = 681,
  [3542] = 687,
  [3543] = 688,
  [3544] = 689,
  [3545] = 658,
  [3546] = 661,
  [3547] = 656,
  [3548] = 202,
  [3549] = 3076,
  [3550] = 662,
  [3551] = 3540,
  [3552] = 2908,
  [3553] = 665,
  [3554] = 214,
  [3555] = 668,
  [3556] = 201,
  [3557] = 762,
  [3558] = 637,
  [3559] = 653,
  [3560] = 819,
  [3561] = 632,
  [3562] = 595,
  [3563] = 2911,
  [3564] = 3071,
  [3565] = 642,
  [3566] = 666,
  [3567] = 654,
  [3568] = 3530,
  [3569] = 128,
  [3570] = 118,
  [3571] = 207,
  [3572] = 663,
  [3573] = 129,
  [3574] = 686,
  [3575] = 644,
  [3576] = 130,
  [3577] = 131,
  [3578] = 3104,
  [3579] = 647,
  [3580] = 123,
  [3581] = 646,
  [3582] = 664,
  [3583] = 3110,
  [3584] = 698,
  [3585] = 120,
  [3586] = 3530,
  [3587] = 409,
  [3588] = 121,
  [3589] = 122,
  [3590] = 3540,
  [3591] = 414,
  [3592] = 124,
  [3593] = 819,
  [3594] = 125,
  [3595] = 210,
  [3596] = 673,
  [3597] = 116,
  [3598] = 126,
  [3599] = 667,
  [3600] = 762,
  [3601] = 3100,
  [3602] = 3106,
  [3603] = 115,
  [3604] = 632,
  [3605] = 650,
  [3606] = 3529,
  [3607] = 637,
  [3608] = 3540,
  [3609] = 127,
  [3610] = 119,
  [3611] = 652,
  [3612] = 201,
  [3613] = 3529,
  [3614] = 202,
  [3615] = 3615,
  [3616] = 3540,
  [3617] = 3464,
  [3618] = 3457,
  [3619] = 3458,
  [3620] = 656,
  [3621] = 644,
  [3622] = 664,
  [3623] = 3540,
  [3624] = 3624,
  [3625] = 3625,
  [3626] = 698,
  [3627] = 3627,
  [3628] = 3628,
  [3629] = 3629,
  [3630] = 667,
  [3631] = 646,
  [3632] = 647,
  [3633] = 673,
  [3634] = 654,
  [3635] = 650,
  [3636] = 652,
  [3637] = 663,
  [3638] = 686,
  [3639] = 3639,
  [3640] = 3460,
  [3641] = 3468,
  [3642] = 296,
  [3643] = 3470,
  [3644] = 3471,
  [3645] = 3645,
  [3646] = 3076,
  [3647] = 2911,
  [3648] = 302,
  [3649] = 3110,
  [3650] = 3100,
  [3651] = 3071,
  [3652] = 242,
  [3653] = 2908,
  [3654] = 3654,
  [3655] = 3655,
  [3656] = 3656,
  [3657] = 3106,
  [3658] = 3658,
  [3659] = 3659,
  [3660] = 3660,
  [3661] = 3661,
  [3662] = 3104,
  [3663] = 3663,
  [3664] = 3664,
  [3665] = 241,
  [3666] = 318,
  [3667] = 3667,
  [3668] = 304,
  [3669] = 3669,
  [3670] = 3670,
  [3671] = 128,
  [3672] = 3672,
  [3673] = 318,
  [3674] = 3674,
  [3675] = 478,
  [3676] = 3540,
  [3677] = 205,
  [3678] = 206,
  [3679] = 204,
  [3680] = 408,
  [3681] = 3681,
  [3682] = 3682,
  [3683] = 118,
  [3684] = 214,
  [3685] = 210,
  [3686] = 116,
  [3687] = 3540,
  [3688] = 120,
  [3689] = 119,
  [3690] = 126,
  [3691] = 124,
  [3692] = 207,
  [3693] = 122,
  [3694] = 115,
  [3695] = 123,
  [3696] = 129,
  [3697] = 241,
  [3698] = 3698,
  [3699] = 637,
  [3700] = 242,
  [3701] = 296,
  [3702] = 125,
  [3703] = 130,
  [3704] = 256,
  [3705] = 302,
  [3706] = 131,
  [3707] = 254,
  [3708] = 632,
  [3709] = 304,
  [3710] = 127,
  [3711] = 121,
  [3712] = 3106,
  [3713] = 116,
  [3714] = 654,
  [3715] = 325,
  [3716] = 3198,
  [3717] = 303,
  [3718] = 3104,
  [3719] = 317,
  [3720] = 311,
  [3721] = 3721,
  [3722] = 312,
  [3723] = 644,
  [3724] = 819,
  [3725] = 306,
  [3726] = 305,
  [3727] = 3540,
  [3728] = 664,
  [3729] = 286,
  [3730] = 698,
  [3731] = 309,
  [3732] = 326,
  [3733] = 3698,
  [3734] = 652,
  [3735] = 256,
  [3736] = 297,
  [3737] = 3110,
  [3738] = 289,
  [3739] = 646,
  [3740] = 3655,
  [3741] = 3674,
  [3742] = 307,
  [3743] = 3100,
  [3744] = 298,
  [3745] = 3721,
  [3746] = 287,
  [3747] = 310,
  [3748] = 762,
  [3749] = 327,
  [3750] = 114,
  [3751] = 3402,
  [3752] = 673,
  [3753] = 817,
  [3754] = 313,
  [3755] = 3540,
  [3756] = 647,
  [3757] = 3639,
  [3758] = 322,
  [3759] = 288,
  [3760] = 294,
  [3761] = 3627,
  [3762] = 3656,
  [3763] = 3615,
  [3764] = 3659,
  [3765] = 329,
  [3766] = 320,
  [3767] = 3540,
  [3768] = 290,
  [3769] = 3660,
  [3770] = 308,
  [3771] = 3661,
  [3772] = 3663,
  [3773] = 3624,
  [3774] = 315,
  [3775] = 3664,
  [3776] = 663,
  [3777] = 3654,
  [3778] = 686,
  [3779] = 3167,
  [3780] = 293,
  [3781] = 3628,
  [3782] = 328,
  [3783] = 667,
  [3784] = 650,
  [3785] = 254,
  [3786] = 3629,
  [3787] = 324,
  [3788] = 316,
  [3789] = 3721,
  [3790] = 114,
  [3791] = 321,
  [3792] = 3667,
  [3793] = 3252,
  [3794] = 3625,
  [3795] = 3645,
  [3796] = 319,
  [3797] = 3658,
  [3798] = 3239,
  [3799] = 3201,
  [3800] = 3540,
  [3801] = 323,
  [3802] = 302,
  [3803] = 762,
  [3804] = 293,
  [3805] = 294,
  [3806] = 328,
  [3807] = 296,
  [3808] = 3530,
  [3809] = 819,
  [3810] = 568,
  [3811] = 320,
  [3812] = 3615,
  [3813] = 321,
  [3814] = 322,
  [3815] = 323,
  [3816] = 325,
  [3817] = 326,
  [3818] = 327,
  [3819] = 3198,
  [3820] = 297,
  [3821] = 298,
  [3822] = 3645,
  [3823] = 3659,
  [3824] = 303,
  [3825] = 317,
  [3826] = 3660,
  [3827] = 3661,
  [3828] = 305,
  [3829] = 286,
  [3830] = 287,
  [3831] = 288,
  [3832] = 3663,
  [3833] = 3833,
  [3834] = 3655,
  [3835] = 329,
  [3836] = 306,
  [3837] = 307,
  [3838] = 310,
  [3839] = 311,
  [3840] = 312,
  [3841] = 3287,
  [3842] = 316,
  [3843] = 319,
  [3844] = 3120,
  [3845] = 116,
  [3846] = 308,
  [3847] = 241,
  [3848] = 309,
  [3849] = 3284,
  [3850] = 3667,
  [3851] = 817,
  [3852] = 242,
  [3853] = 3260,
  [3854] = 318,
  [3855] = 260,
  [3856] = 3540,
  [3857] = 3540,
  [3858] = 3282,
  [3859] = 3239,
  [3860] = 3624,
  [3861] = 3625,
  [3862] = 3627,
  [3863] = 3628,
  [3864] = 3201,
  [3865] = 3629,
  [3866] = 3293,
  [3867] = 3167,
  [3868] = 3252,
  [3869] = 3540,
  [3870] = 3639,
  [3871] = 114,
  [3872] = 3529,
  [3873] = 3540,
  [3874] = 313,
  [3875] = 315,
  [3876] = 3656,
  [3877] = 3654,
  [3878] = 324,
  [3879] = 3658,
  [3880] = 304,
  [3881] = 289,
  [3882] = 3313,
  [3883] = 3540,
  [3884] = 290,
  [3885] = 3664,
  [3886] = 3886,
  [3887] = 3887,
  [3888] = 3888,
  [3889] = 1674,
  [3890] = 3260,
  [3891] = 3891,
  [3892] = 3628,
  [3893] = 3887,
  [3894] = 3894,
  [3895] = 3895,
  [3896] = 3896,
  [3897] = 3897,
  [3898] = 3898,
  [3899] = 3886,
  [3900] = 3888,
  [3901] = 3901,
  [3902] = 3902,
  [3903] = 3891,
  [3904] = 3887,
  [3905] = 3896,
  [3906] = 3897,
  [3907] = 3891,
  [3908] = 3888,
  [3909] = 3901,
  [3910] = 3887,
  [3911] = 3896,
  [3912] = 3897,
  [3913] = 3888,
  [3914] = 3891,
  [3915] = 3901,
  [3916] = 3887,
  [3917] = 3896,
  [3918] = 3897,
  [3919] = 3354,
  [3920] = 3902,
  [3921] = 3888,
  [3922] = 3888,
  [3923] = 114,
  [3924] = 1656,
  [3925] = 3282,
  [3926] = 3901,
  [3927] = 3645,
  [3928] = 3928,
  [3929] = 3929,
  [3930] = 3887,
  [3931] = 3888,
  [3932] = 3901,
  [3933] = 3933,
  [3934] = 3888,
  [3935] = 3902,
  [3936] = 3896,
  [3937] = 3896,
  [3938] = 3897,
  [3939] = 3891,
  [3940] = 3891,
  [3941] = 3887,
  [3942] = 3894,
  [3943] = 3895,
  [3944] = 3902,
  [3945] = 3886,
  [3946] = 3888,
  [3947] = 3901,
  [3948] = 595,
  [3949] = 3887,
  [3950] = 3887,
  [3951] = 3896,
  [3952] = 3897,
  [3953] = 3891,
  [3954] = 3901,
  [3955] = 3887,
  [3956] = 3896,
  [3957] = 3897,
  [3958] = 3891,
  [3959] = 3901,
  [3960] = 3887,
  [3961] = 3896,
  [3962] = 3897,
  [3963] = 3902,
  [3964] = 3888,
  [3965] = 3894,
  [3966] = 382,
  [3967] = 3928,
  [3968] = 3929,
  [3969] = 3896,
  [3970] = 3891,
  [3971] = 3933,
  [3972] = 383,
  [3973] = 200,
  [3974] = 3895,
  [3975] = 3928,
  [3976] = 3897,
  [3977] = 3891,
  [3978] = 3891,
  [3979] = 3902,
  [3980] = 3894,
  [3981] = 3895,
  [3982] = 3888,
  [3983] = 3901,
  [3984] = 3886,
  [3985] = 3901,
  [3986] = 3888,
  [3987] = 568,
  [3988] = 3887,
  [3989] = 3896,
  [3990] = 3897,
  [3991] = 3891,
  [3992] = 3901,
  [3993] = 3887,
  [3994] = 3896,
  [3995] = 3897,
  [3996] = 3902,
  [3997] = 3928,
  [3998] = 3998,
  [3999] = 3929,
  [4000] = 3902,
  [4001] = 3901,
  [4002] = 3933,
  [4003] = 3887,
  [4004] = 3887,
  [4005] = 3896,
  [4006] = 3887,
  [4007] = 3896,
  [4008] = 3897,
  [4009] = 3891,
  [4010] = 3896,
  [4011] = 3894,
  [4012] = 3895,
  [4013] = 3897,
  [4014] = 4014,
  [4015] = 3886,
  [4016] = 3901,
  [4017] = 3898,
  [4018] = 3887,
  [4019] = 3887,
  [4020] = 3896,
  [4021] = 3897,
  [4022] = 3891,
  [4023] = 3901,
  [4024] = 3887,
  [4025] = 3896,
  [4026] = 3897,
  [4027] = 256,
  [4028] = 1663,
  [4029] = 4029,
  [4030] = 3933,
  [4031] = 1765,
  [4032] = 4032,
  [4033] = 1665,
  [4034] = 3284,
  [4035] = 3891,
  [4036] = 3897,
  [4037] = 3894,
  [4038] = 3895,
  [4039] = 3901,
  [4040] = 3898,
  [4041] = 3886,
  [4042] = 3351,
  [4043] = 3891,
  [4044] = 3901,
  [4045] = 3887,
  [4046] = 3896,
  [4047] = 3897,
  [4048] = 3351,
  [4049] = 1675,
  [4050] = 3933,
  [4051] = 3888,
  [4052] = 1668,
  [4053] = 3894,
  [4054] = 3895,
  [4055] = 3888,
  [4056] = 254,
  [4057] = 3886,
  [4058] = 3998,
  [4059] = 3891,
  [4060] = 3901,
  [4061] = 3887,
  [4062] = 3896,
  [4063] = 3897,
  [4064] = 2970,
  [4065] = 3933,
  [4066] = 1676,
  [4067] = 3887,
  [4068] = 3894,
  [4069] = 3895,
  [4070] = 4032,
  [4071] = 3886,
  [4072] = 4072,
  [4073] = 3891,
  [4074] = 3901,
  [4075] = 3887,
  [4076] = 3896,
  [4077] = 3897,
  [4078] = 3933,
  [4079] = 4032,
  [4080] = 3895,
  [4081] = 4032,
  [4082] = 3896,
  [4083] = 3313,
  [4084] = 3891,
  [4085] = 3901,
  [4086] = 3887,
  [4087] = 3896,
  [4088] = 3897,
  [4089] = 3897,
  [4090] = 3895,
  [4091] = 3897,
  [4092] = 3886,
  [4093] = 3664,
  [4094] = 3891,
  [4095] = 3901,
  [4096] = 3887,
  [4097] = 3370,
  [4098] = 3895,
  [4099] = 3896,
  [4100] = 3886,
  [4101] = 3888,
  [4102] = 3891,
  [4103] = 3895,
  [4104] = 466,
  [4105] = 3886,
  [4106] = 1778,
  [4107] = 3891,
  [4108] = 3888,
  [4109] = 3895,
  [4110] = 3888,
  [4111] = 3886,
  [4112] = 3894,
  [4113] = 3891,
  [4114] = 3897,
  [4115] = 3895,
  [4116] = 3639,
  [4117] = 3886,
  [4118] = 4118,
  [4119] = 3891,
  [4120] = 3540,
  [4121] = 3895,
  [4122] = 3901,
  [4123] = 3886,
  [4124] = 4124,
  [4125] = 3891,
  [4126] = 3897,
  [4127] = 3895,
  [4128] = 3998,
  [4129] = 3886,
  [4130] = 3355,
  [4131] = 3891,
  [4132] = 3895,
  [4133] = 1781,
  [4134] = 3886,
  [4135] = 3379,
  [4136] = 3895,
  [4137] = 4137,
  [4138] = 3886,
  [4139] = 3891,
  [4140] = 3895,
  [4141] = 3888,
  [4142] = 3886,
  [4143] = 3887,
  [4144] = 3895,
  [4145] = 3902,
  [4146] = 3886,
  [4147] = 3896,
  [4148] = 3895,
  [4149] = 3901,
  [4150] = 3886,
  [4151] = 1791,
  [4152] = 3895,
  [4153] = 445,
  [4154] = 3886,
  [4155] = 3287,
  [4156] = 3895,
  [4157] = 3353,
  [4158] = 3886,
  [4159] = 3897,
  [4160] = 3895,
  [4161] = 446,
  [4162] = 3886,
  [4163] = 3698,
  [4164] = 3895,
  [4165] = 3888,
  [4166] = 3886,
  [4167] = 3895,
  [4168] = 531,
  [4169] = 4169,
  [4170] = 3902,
  [4171] = 392,
  [4172] = 3540,
  [4173] = 3351,
  [4174] = 3901,
  [4175] = 3323,
  [4176] = 3654,
  [4177] = 3888,
  [4178] = 3901,
  [4179] = 4179,
  [4180] = 3887,
  [4181] = 3896,
  [4182] = 3897,
  [4183] = 447,
  [4184] = 3901,
  [4185] = 3887,
  [4186] = 3891,
  [4187] = 4187,
  [4188] = 4137,
  [4189] = 3888,
  [4190] = 3896,
  [4191] = 203,
  [4192] = 3891,
  [4193] = 3896,
  [4194] = 4032,
  [4195] = 3896,
  [4196] = 3897,
  [4197] = 3897,
  [4198] = 3902,
  [4199] = 3886,
  [4200] = 3902,
  [4201] = 4169,
  [4202] = 3888,
  [4203] = 3329,
  [4204] = 4179,
  [4205] = 3902,
  [4206] = 3896,
  [4207] = 3902,
  [4208] = 2987,
  [4209] = 4137,
  [4210] = 3888,
  [4211] = 4169,
  [4212] = 3898,
  [4213] = 4179,
  [4214] = 4179,
  [4215] = 3888,
  [4216] = 3293,
  [4217] = 3627,
  [4218] = 4169,
  [4219] = 3350,
  [4220] = 4179,
  [4221] = 3656,
  [4222] = 3901,
  [4223] = 4169,
  [4224] = 3887,
  [4225] = 4179,
  [4226] = 3896,
  [4227] = 3898,
  [4228] = 4169,
  [4229] = 3625,
  [4230] = 4179,
  [4231] = 3998,
  [4232] = 3891,
  [4233] = 4169,
  [4234] = 4179,
  [4235] = 4169,
  [4236] = 4179,
  [4237] = 3897,
  [4238] = 3615,
  [4239] = 4072,
  [4240] = 3655,
  [4241] = 4014,
  [4242] = 4124,
  [4243] = 2984,
  [4244] = 393,
  [4245] = 3887,
  [4246] = 3376,
  [4247] = 3667,
  [4248] = 3888,
  [4249] = 3364,
  [4250] = 3351,
  [4251] = 3888,
  [4252] = 3901,
  [4253] = 3888,
  [4254] = 3624,
  [4255] = 3897,
  [4256] = 3928,
  [4257] = 116,
  [4258] = 3998,
  [4259] = 3120,
  [4260] = 4032,
  [4261] = 3929,
  [4262] = 3659,
  [4263] = 3929,
  [4264] = 468,
  [4265] = 3540,
  [4266] = 3660,
  [4267] = 1681,
  [4268] = 3886,
  [4269] = 4269,
  [4270] = 3354,
  [4271] = 394,
  [4272] = 1661,
  [4273] = 3540,
  [4274] = 3888,
  [4275] = 3901,
  [4276] = 3902,
  [4277] = 1767,
  [4278] = 3888,
  [4279] = 3928,
  [4280] = 1662,
  [4281] = 3674,
  [4282] = 4169,
  [4283] = 3998,
  [4284] = 3658,
  [4285] = 3902,
  [4286] = 3929,
  [4287] = 4072,
  [4288] = 3661,
  [4289] = 4014,
  [4290] = 4124,
  [4291] = 3888,
  [4292] = 3901,
  [4293] = 4072,
  [4294] = 4124,
  [4295] = 3898,
  [4296] = 4072,
  [4297] = 4124,
  [4298] = 3933,
  [4299] = 4072,
  [4300] = 4124,
  [4301] = 3901,
  [4302] = 3933,
  [4303] = 3629,
  [4304] = 3663,
  [4305] = 3334,
  [4306] = 3351,
  [4307] = 3624,
  [4308] = 661,
  [4309] = 3639,
  [4310] = 3658,
  [4311] = 3323,
  [4312] = 3401,
  [4313] = 3645,
  [4314] = 3540,
  [4315] = 3402,
  [4316] = 4316,
  [4317] = 4317,
  [4318] = 4318,
  [4319] = 313,
  [4320] = 315,
  [4321] = 3464,
  [4322] = 289,
  [4323] = 3540,
  [4324] = 290,
  [4325] = 308,
  [4326] = 309,
  [4327] = 762,
  [4328] = 293,
  [4329] = 294,
  [4330] = 3540,
  [4331] = 3540,
  [4332] = 328,
  [4333] = 3435,
  [4334] = 116,
  [4335] = 3291,
  [4336] = 3292,
  [4337] = 3312,
  [4338] = 3674,
  [4339] = 3361,
  [4340] = 320,
  [4341] = 321,
  [4342] = 322,
  [4343] = 4343,
  [4344] = 323,
  [4345] = 4318,
  [4346] = 3321,
  [4347] = 325,
  [4348] = 326,
  [4349] = 327,
  [4350] = 4343,
  [4351] = 3274,
  [4352] = 3329,
  [4353] = 3351,
  [4354] = 4354,
  [4355] = 4354,
  [4356] = 4316,
  [4357] = 297,
  [4358] = 298,
  [4359] = 303,
  [4360] = 317,
  [4361] = 305,
  [4362] = 286,
  [4363] = 3402,
  [4364] = 287,
  [4365] = 202,
  [4366] = 288,
  [4367] = 4317,
  [4368] = 3376,
  [4369] = 201,
  [4370] = 3351,
  [4371] = 329,
  [4372] = 306,
  [4373] = 307,
  [4374] = 310,
  [4375] = 311,
  [4376] = 312,
  [4377] = 4317,
  [4378] = 4343,
  [4379] = 4318,
  [4380] = 316,
  [4381] = 319,
  [4382] = 4382,
  [4383] = 4318,
  [4384] = 3354,
  [4385] = 4354,
  [4386] = 324,
  [4387] = 1194,
  [4388] = 4388,
  [4389] = 4389,
  [4390] = 3351,
  [4391] = 4343,
  [4392] = 4318,
  [4393] = 1199,
  [4394] = 4354,
  [4395] = 3351,
  [4396] = 4343,
  [4397] = 4318,
  [4398] = 4398,
  [4399] = 4354,
  [4400] = 4343,
  [4401] = 4318,
  [4402] = 3698,
  [4403] = 4354,
  [4404] = 3457,
  [4405] = 3458,
  [4406] = 3460,
  [4407] = 4318,
  [4408] = 3468,
  [4409] = 4354,
  [4410] = 3470,
  [4411] = 3471,
  [4412] = 4318,
  [4413] = 3369,
  [4414] = 4354,
  [4415] = 4318,
  [4416] = 4354,
  [4417] = 4318,
  [4418] = 4318,
  [4419] = 3334,
  [4420] = 4318,
  [4421] = 4318,
  [4422] = 4318,
  [4423] = 658,
  [4424] = 4318,
  [4425] = 4318,
  [4426] = 4318,
  [4427] = 4318,
  [4428] = 4318,
  [4429] = 4318,
  [4430] = 4318,
  [4431] = 817,
  [4432] = 4318,
  [4433] = 3330,
  [4434] = 4434,
  [4435] = 3370,
  [4436] = 3624,
  [4437] = 4437,
  [4438] = 3355,
  [4439] = 3379,
  [4440] = 3382,
  [4441] = 3625,
  [4442] = 3364,
  [4443] = 4318,
  [4444] = 3540,
  [4445] = 3540,
  [4446] = 3540,
  [4447] = 4318,
  [4448] = 4318,
  [4449] = 4318,
  [4450] = 4318,
  [4451] = 4318,
  [4452] = 3338,
  [4453] = 3401,
  [4454] = 3654,
  [4455] = 3285,
  [4456] = 3277,
  [4457] = 3315,
  [4458] = 3273,
  [4459] = 3655,
  [4460] = 3435,
  [4461] = 595,
  [4462] = 3627,
  [4463] = 3350,
  [4464] = 3540,
  [4465] = 3656,
  [4466] = 3615,
  [4467] = 3659,
  [4468] = 3660,
  [4469] = 3661,
  [4470] = 3663,
  [4471] = 3664,
  [4472] = 3628,
  [4473] = 3629,
  [4474] = 819,
  [4475] = 3353,
  [4476] = 3370,
  [4477] = 3355,
  [4478] = 3379,
  [4479] = 3625,
  [4480] = 3364,
  [4481] = 3654,
  [4482] = 3655,
  [4483] = 3627,
  [4484] = 3350,
  [4485] = 3656,
  [4486] = 3615,
  [4487] = 3659,
  [4488] = 3660,
  [4489] = 3661,
  [4490] = 3663,
  [4491] = 3664,
  [4492] = 3628,
  [4493] = 3629,
  [4494] = 3353,
  [4495] = 3667,
  [4496] = 3639,
  [4497] = 3658,
  [4498] = 3645,
  [4499] = 3382,
  [4500] = 3267,
  [4501] = 3359,
  [4502] = 3271,
  [4503] = 3540,
  [4504] = 284,
  [4505] = 3376,
  [4506] = 3667,
  [4507] = 662,
  [4508] = 665,
  [4509] = 668,
  [4510] = 653,
  [4511] = 642,
  [4512] = 666,
  [4513] = 681,
  [4514] = 687,
  [4515] = 688,
  [4516] = 689,
  [4517] = 4318,
  [4518] = 3292,
  [4519] = 3402,
  [4520] = 2908,
  [4521] = 1194,
  [4522] = 207,
  [4523] = 3425,
  [4524] = 3428,
  [4525] = 3418,
  [4526] = 3387,
  [4527] = 3470,
  [4528] = 3426,
  [4529] = 3471,
  [4530] = 3277,
  [4531] = 3354,
  [4532] = 2987,
  [4533] = 3287,
  [4534] = 3315,
  [4535] = 3273,
  [4536] = 205,
  [4537] = 206,
  [4538] = 1199,
  [4539] = 3477,
  [4540] = 3386,
  [4541] = 3071,
  [4542] = 3339,
  [4543] = 3674,
  [4544] = 2911,
  [4545] = 3285,
  [4546] = 3267,
  [4547] = 3271,
  [4548] = 3321,
  [4549] = 3343,
  [4550] = 3420,
  [4551] = 3410,
  [4552] = 3466,
  [4553] = 3351,
  [4554] = 3389,
  [4555] = 3390,
  [4556] = 3394,
  [4557] = 120,
  [4558] = 3347,
  [4559] = 121,
  [4560] = 122,
  [4561] = 3348,
  [4562] = 3352,
  [4563] = 3398,
  [4564] = 3396,
  [4565] = 409,
  [4566] = 414,
  [4567] = 2984,
  [4568] = 115,
  [4569] = 123,
  [4570] = 1778,
  [4571] = 124,
  [4572] = 3399,
  [4573] = 1781,
  [4574] = 1791,
  [4575] = 3360,
  [4576] = 1675,
  [4577] = 1676,
  [4578] = 3375,
  [4579] = 3402,
  [4580] = 3293,
  [4581] = 125,
  [4582] = 126,
  [4583] = 127,
  [4584] = 119,
  [4585] = 3351,
  [4586] = 203,
  [4587] = 3274,
  [4588] = 3382,
  [4589] = 817,
  [4590] = 128,
  [4591] = 118,
  [4592] = 129,
  [4593] = 1765,
  [4594] = 3412,
  [4595] = 3076,
  [4596] = 3313,
  [4597] = 130,
  [4598] = 131,
  [4599] = 3284,
  [4600] = 3361,
  [4601] = 3698,
  [4602] = 3351,
  [4603] = 3433,
  [4604] = 3441,
  [4605] = 3408,
  [4606] = 200,
  [4607] = 2970,
  [4608] = 3432,
  [4609] = 3416,
  [4610] = 3380,
  [4611] = 3359,
  [4612] = 1663,
  [4613] = 1665,
  [4614] = 3338,
  [4615] = 3401,
  [4616] = 3423,
  [4617] = 3419,
  [4618] = 204,
  [4619] = 210,
  [4620] = 3424,
  [4621] = 3120,
  [4622] = 1656,
  [4623] = 1674,
  [4624] = 2699,
  [4625] = 3456,
  [4626] = 1668,
  [4627] = 3369,
  [4628] = 3450,
  [4629] = 3465,
  [4630] = 3430,
  [4631] = 3447,
  [4632] = 1681,
  [4633] = 3291,
  [4634] = 3330,
  [4635] = 3478,
  [4636] = 3468,
  [4637] = 3403,
  [4638] = 3414,
  [4639] = 3312,
  [4640] = 3449,
  [4641] = 3384,
  [4642] = 3442,
  [4643] = 3445,
  [4644] = 3415,
  [4645] = 1767,
  [4646] = 3381,
  [4647] = 3479,
  [4648] = 1661,
  [4649] = 1662,
  [4650] = 3457,
  [4651] = 3458,
  [4652] = 3460,
  [4653] = 3435,
  [4654] = 3473,
  [4655] = 3464,
  [4656] = 3409,
  [4657] = 3407,
  [4658] = 3411,
  [4659] = 2697,
  [4660] = 3348,
  [4661] = 2911,
  [4662] = 3654,
  [4663] = 202,
  [4664] = 3353,
  [4665] = 3442,
  [4666] = 3420,
  [4667] = 3466,
  [4668] = 1675,
  [4669] = 3389,
  [4670] = 3419,
  [4671] = 3415,
  [4672] = 3380,
  [4673] = 3447,
  [4674] = 3402,
  [4675] = 3351,
  [4676] = 3478,
  [4677] = 3473,
  [4678] = 3407,
  [4679] = 3667,
  [4680] = 3418,
  [4681] = 1676,
  [4682] = 3409,
  [4683] = 3390,
  [4684] = 3394,
  [4685] = 3435,
  [4686] = 3425,
  [4687] = 3381,
  [4688] = 3479,
  [4689] = 3411,
  [4690] = 3412,
  [4691] = 3639,
  [4692] = 3428,
  [4693] = 3396,
  [4694] = 824,
  [4695] = 116,
  [4696] = 201,
  [4697] = 3658,
  [4698] = 2697,
  [4699] = 656,
  [4700] = 3323,
  [4701] = 4388,
  [4702] = 4389,
  [4703] = 4703,
  [4704] = 4704,
  [4705] = 3465,
  [4706] = 3430,
  [4707] = 719,
  [4708] = 3339,
  [4709] = 3375,
  [4710] = 1656,
  [4711] = 1668,
  [4712] = 3456,
  [4713] = 3323,
  [4714] = 3645,
  [4715] = 3382,
  [4716] = 3655,
  [4717] = 3410,
  [4718] = 3432,
  [4719] = 4719,
  [4720] = 3441,
  [4721] = 214,
  [4722] = 3445,
  [4723] = 3071,
  [4724] = 3076,
  [4725] = 3402,
  [4726] = 3426,
  [4727] = 116,
  [4728] = 3387,
  [4729] = 1765,
  [4730] = 3402,
  [4731] = 3433,
  [4732] = 3450,
  [4733] = 1767,
  [4734] = 3457,
  [4735] = 3458,
  [4736] = 3460,
  [4737] = 3468,
  [4738] = 3470,
  [4739] = 3471,
  [4740] = 120,
  [4741] = 1778,
  [4742] = 1781,
  [4743] = 1791,
  [4744] = 121,
  [4745] = 122,
  [4746] = 115,
  [4747] = 123,
  [4748] = 4748,
  [4749] = 124,
  [4750] = 3408,
  [4751] = 125,
  [4752] = 126,
  [4753] = 3370,
  [4754] = 3624,
  [4755] = 3403,
  [4756] = 3414,
  [4757] = 1661,
  [4758] = 1662,
  [4759] = 203,
  [4760] = 127,
  [4761] = 119,
  [4762] = 128,
  [4763] = 3627,
  [4764] = 3350,
  [4765] = 3656,
  [4766] = 3615,
  [4767] = 3659,
  [4768] = 200,
  [4769] = 1663,
  [4770] = 1665,
  [4771] = 3660,
  [4772] = 3464,
  [4773] = 3661,
  [4774] = 3663,
  [4775] = 3384,
  [4776] = 3355,
  [4777] = 3379,
  [4778] = 3386,
  [4779] = 3664,
  [4780] = 3477,
  [4781] = 3398,
  [4782] = 3628,
  [4783] = 118,
  [4784] = 3629,
  [4785] = 129,
  [4786] = 130,
  [4787] = 3625,
  [4788] = 131,
  [4789] = 3364,
  [4790] = 3343,
  [4791] = 2908,
  [4792] = 3347,
  [4793] = 3352,
  [4794] = 3399,
  [4795] = 3416,
  [4796] = 3360,
  [4797] = 3423,
  [4798] = 3424,
  [4799] = 1674,
  [4800] = 3402,
  [4801] = 3401,
  [4802] = 1681,
  [4803] = 3449,
  [4804] = 2699,
  [4805] = 3415,
  [4806] = 632,
  [4807] = 637,
  [4808] = 3076,
  [4809] = 3355,
  [4810] = 3398,
  [4811] = 3353,
  [4812] = 3370,
  [4813] = 260,
  [4814] = 3361,
  [4815] = 3071,
  [4816] = 3120,
  [4817] = 3361,
  [4818] = 2908,
  [4819] = 409,
  [4820] = 414,
  [4821] = 568,
  [4822] = 4822,
  [4823] = 4388,
  [4824] = 3379,
  [4825] = 3466,
  [4826] = 3364,
  [4827] = 4389,
  [4828] = 3698,
  [4829] = 3408,
  [4830] = 3674,
  [4831] = 3350,
  [4832] = 2911,
  [4833] = 1662,
  [4834] = 3478,
  [4835] = 4835,
  [4836] = 3415,
  [4837] = 3389,
  [4838] = 4838,
  [4839] = 3477,
  [4840] = 3449,
  [4841] = 3442,
  [4842] = 3398,
  [4843] = 3456,
  [4844] = 3473,
  [4845] = 3407,
  [4846] = 4388,
  [4847] = 4389,
  [4848] = 3420,
  [4849] = 3441,
  [4850] = 1778,
  [4851] = 3390,
  [4852] = 3394,
  [4853] = 3426,
  [4854] = 3408,
  [4855] = 3426,
  [4856] = 3387,
  [4857] = 1681,
  [4858] = 1781,
  [4859] = 3409,
  [4860] = 3403,
  [4861] = 3420,
  [4862] = 1791,
  [4863] = 3466,
  [4864] = 3411,
  [4865] = 3412,
  [4866] = 3389,
  [4867] = 3390,
  [4868] = 3394,
  [4869] = 3423,
  [4870] = 3424,
  [4871] = 3381,
  [4872] = 3479,
  [4873] = 3409,
  [4874] = 3411,
  [4875] = 3412,
  [4876] = 3425,
  [4877] = 3428,
  [4878] = 3425,
  [4879] = 3428,
  [4880] = 3414,
  [4881] = 3416,
  [4882] = 2697,
  [4883] = 3441,
  [4884] = 1661,
  [4885] = 3380,
  [4886] = 4388,
  [4887] = 4389,
  [4888] = 3445,
  [4889] = 3384,
  [4890] = 3450,
  [4891] = 3423,
  [4892] = 3419,
  [4893] = 3442,
  [4894] = 3424,
  [4895] = 1674,
  [4896] = 3380,
  [4897] = 3381,
  [4898] = 203,
  [4899] = 4899,
  [4900] = 644,
  [4901] = 3403,
  [4902] = 664,
  [4903] = 3384,
  [4904] = 200,
  [4905] = 698,
  [4906] = 667,
  [4907] = 646,
  [4908] = 647,
  [4909] = 673,
  [4910] = 654,
  [4911] = 650,
  [4912] = 652,
  [4913] = 663,
  [4914] = 686,
  [4915] = 3071,
  [4916] = 3387,
  [4917] = 3076,
  [4918] = 3414,
  [4919] = 3106,
  [4920] = 3456,
  [4921] = 3479,
  [4922] = 3445,
  [4923] = 3473,
  [4924] = 3386,
  [4925] = 3386,
  [4926] = 3100,
  [4927] = 3407,
  [4928] = 1675,
  [4929] = 1676,
  [4930] = 3110,
  [4931] = 4388,
  [4932] = 1663,
  [4933] = 1665,
  [4934] = 4389,
  [4935] = 1765,
  [4936] = 2908,
  [4937] = 2911,
  [4938] = 3433,
  [4939] = 3433,
  [4940] = 3450,
  [4941] = 3449,
  [4942] = 1767,
  [4943] = 3104,
  [4944] = 1656,
  [4945] = 2699,
  [4946] = 1668,
  [4947] = 3416,
  [4948] = 3110,
  [4949] = 318,
  [4950] = 642,
  [4951] = 666,
  [4952] = 681,
  [4953] = 296,
  [4954] = 687,
  [4955] = 302,
  [4956] = 688,
  [4957] = 689,
  [4958] = 304,
  [4959] = 658,
  [4960] = 661,
  [4961] = 2908,
  [4962] = 3076,
  [4963] = 665,
  [4964] = 241,
  [4965] = 4965,
  [4966] = 3106,
  [4967] = 201,
  [4968] = 595,
  [4969] = 3071,
  [4970] = 389,
  [4971] = 668,
  [4972] = 4965,
  [4973] = 242,
  [4974] = 653,
  [4975] = 425,
  [4976] = 4899,
  [4977] = 3100,
  [4978] = 389,
  [4979] = 662,
  [4980] = 2911,
  [4981] = 202,
  [4982] = 425,
  [4983] = 3104,
  [4984] = 201,
  [4985] = 205,
  [4986] = 762,
  [4987] = 819,
  [4988] = 4389,
  [4989] = 4388,
  [4990] = 210,
  [4991] = 3284,
  [4992] = 4389,
  [4993] = 256,
  [4994] = 409,
  [4995] = 4388,
  [4996] = 414,
  [4997] = 254,
  [4998] = 4835,
  [4999] = 207,
  [5000] = 4388,
  [5001] = 4388,
  [5002] = 202,
  [5003] = 3313,
  [5004] = 4389,
  [5005] = 4389,
  [5006] = 204,
  [5007] = 3293,
  [5008] = 4838,
  [5009] = 5009,
  [5010] = 531,
  [5011] = 206,
  [5012] = 3287,
  [5013] = 5013,
  [5014] = 321,
  [5015] = 322,
  [5016] = 323,
  [5017] = 325,
  [5018] = 4388,
  [5019] = 214,
  [5020] = 326,
  [5021] = 327,
  [5022] = 5022,
  [5023] = 297,
  [5024] = 298,
  [5025] = 5022,
  [5026] = 303,
  [5027] = 317,
  [5028] = 305,
  [5029] = 286,
  [5030] = 5030,
  [5031] = 287,
  [5032] = 4388,
  [5033] = 288,
  [5034] = 4388,
  [5035] = 329,
  [5036] = 306,
  [5037] = 4835,
  [5038] = 307,
  [5039] = 310,
  [5040] = 5013,
  [5041] = 311,
  [5042] = 312,
  [5043] = 316,
  [5044] = 319,
  [5045] = 5030,
  [5046] = 5046,
  [5047] = 5022,
  [5048] = 5022,
  [5049] = 819,
  [5050] = 5013,
  [5051] = 762,
  [5052] = 4389,
  [5053] = 4389,
  [5054] = 320,
  [5055] = 568,
  [5056] = 5030,
  [5057] = 5022,
  [5058] = 5013,
  [5059] = 595,
  [5060] = 5030,
  [5061] = 595,
  [5062] = 313,
  [5063] = 315,
  [5064] = 568,
  [5065] = 5065,
  [5066] = 324,
  [5067] = 5030,
  [5068] = 5022,
  [5069] = 5013,
  [5070] = 289,
  [5071] = 290,
  [5072] = 308,
  [5073] = 309,
  [5074] = 293,
  [5075] = 656,
  [5076] = 294,
  [5077] = 328,
  [5078] = 4389,
  [5079] = 5013,
  [5080] = 4838,
  [5081] = 5030,
  [5082] = 632,
  [5083] = 4835,
  [5084] = 4388,
  [5085] = 4389,
  [5086] = 637,
  [5087] = 3110,
  [5088] = 5088,
  [5089] = 4835,
  [5090] = 4388,
  [5091] = 5046,
  [5092] = 4389,
  [5093] = 4389,
  [5094] = 5065,
  [5095] = 5095,
  [5096] = 4838,
  [5097] = 4838,
  [5098] = 4835,
  [5099] = 5099,
  [5100] = 3104,
  [5101] = 5101,
  [5102] = 3106,
  [5103] = 4838,
  [5104] = 4388,
  [5105] = 670,
  [5106] = 284,
  [5107] = 284,
  [5108] = 670,
  [5109] = 3100,
  [5110] = 5009,
  [5111] = 5111,
  [5112] = 3628,
  [5113] = 1662,
  [5114] = 5114,
  [5115] = 4388,
  [5116] = 4389,
  [5117] = 3293,
  [5118] = 200,
  [5119] = 3624,
  [5120] = 3625,
  [5121] = 5121,
  [5122] = 3284,
  [5123] = 5114,
  [5124] = 5124,
  [5125] = 5125,
  [5126] = 4388,
  [5127] = 5127,
  [5128] = 5125,
  [5129] = 4389,
  [5130] = 3419,
  [5131] = 5125,
  [5132] = 719,
  [5133] = 3478,
  [5134] = 1656,
  [5135] = 4388,
  [5136] = 4389,
  [5137] = 1681,
  [5138] = 3110,
  [5139] = 425,
  [5140] = 1674,
  [5141] = 5121,
  [5142] = 5114,
  [5143] = 5124,
  [5144] = 1661,
  [5145] = 3313,
  [5146] = 5121,
  [5147] = 824,
  [5148] = 1668,
  [5149] = 202,
  [5150] = 1765,
  [5151] = 644,
  [5152] = 664,
  [5153] = 5114,
  [5154] = 3106,
  [5155] = 5124,
  [5156] = 1675,
  [5157] = 1676,
  [5158] = 698,
  [5159] = 667,
  [5160] = 646,
  [5161] = 647,
  [5162] = 5121,
  [5163] = 389,
  [5164] = 5125,
  [5165] = 673,
  [5166] = 654,
  [5167] = 3287,
  [5168] = 650,
  [5169] = 652,
  [5170] = 201,
  [5171] = 3654,
  [5172] = 663,
  [5173] = 686,
  [5174] = 3104,
  [5175] = 3100,
  [5176] = 3645,
  [5177] = 3477,
  [5178] = 5121,
  [5179] = 3655,
  [5180] = 5121,
  [5181] = 1663,
  [5182] = 1665,
  [5183] = 5114,
  [5184] = 5124,
  [5185] = 5114,
  [5186] = 5125,
  [5187] = 5124,
  [5188] = 3627,
  [5189] = 3656,
  [5190] = 3615,
  [5191] = 3659,
  [5192] = 3660,
  [5193] = 3661,
  [5194] = 3663,
  [5195] = 3664,
  [5196] = 5121,
  [5197] = 1778,
  [5198] = 1781,
  [5199] = 1791,
  [5200] = 5114,
  [5201] = 5124,
  [5202] = 3658,
  [5203] = 5125,
  [5204] = 3629,
  [5205] = 1767,
  [5206] = 5125,
  [5207] = 203,
  [5208] = 3667,
  [5209] = 3639,
  [5210] = 5124,
  [5211] = 689,
  [5212] = 661,
  [5213] = 4838,
  [5214] = 5099,
  [5215] = 389,
  [5216] = 131,
  [5217] = 241,
  [5218] = 120,
  [5219] = 121,
  [5220] = 5101,
  [5221] = 4388,
  [5222] = 425,
  [5223] = 4389,
  [5224] = 389,
  [5225] = 122,
  [5226] = 4838,
  [5227] = 210,
  [5228] = 115,
  [5229] = 4835,
  [5230] = 318,
  [5231] = 665,
  [5232] = 5232,
  [5233] = 3698,
  [5234] = 662,
  [5235] = 5088,
  [5236] = 118,
  [5237] = 4388,
  [5238] = 296,
  [5239] = 5239,
  [5240] = 302,
  [5241] = 4388,
  [5242] = 123,
  [5243] = 4389,
  [5244] = 665,
  [5245] = 124,
  [5246] = 304,
  [5247] = 128,
  [5248] = 4835,
  [5249] = 668,
  [5250] = 653,
  [5251] = 4835,
  [5252] = 129,
  [5253] = 3674,
  [5254] = 662,
  [5255] = 4388,
  [5256] = 2699,
  [5257] = 658,
  [5258] = 207,
  [5259] = 2697,
  [5260] = 4835,
  [5261] = 130,
  [5262] = 4389,
  [5263] = 642,
  [5264] = 4838,
  [5265] = 666,
  [5266] = 681,
  [5267] = 687,
  [5268] = 125,
  [5269] = 284,
  [5270] = 688,
  [5271] = 661,
  [5272] = 119,
  [5273] = 642,
  [5274] = 126,
  [5275] = 689,
  [5276] = 242,
  [5277] = 687,
  [5278] = 5095,
  [5279] = 5232,
  [5280] = 668,
  [5281] = 653,
  [5282] = 5232,
  [5283] = 260,
  [5284] = 656,
  [5285] = 656,
  [5286] = 688,
  [5287] = 5287,
  [5288] = 5288,
  [5289] = 205,
  [5290] = 206,
  [5291] = 204,
  [5292] = 666,
  [5293] = 658,
  [5294] = 127,
  [5295] = 681,
  [5296] = 425,
  [5297] = 4389,
  [5298] = 4838,
  [5299] = 4835,
  [5300] = 595,
  [5301] = 4389,
  [5302] = 5302,
  [5303] = 4388,
  [5304] = 3369,
  [5305] = 214,
  [5306] = 5306,
  [5307] = 256,
  [5308] = 5308,
  [5309] = 568,
  [5310] = 4838,
  [5311] = 5302,
  [5312] = 4389,
  [5313] = 5313,
  [5314] = 568,
  [5315] = 5099,
  [5316] = 3359,
  [5317] = 201,
  [5318] = 4838,
  [5319] = 4838,
  [5320] = 5306,
  [5321] = 5313,
  [5322] = 5101,
  [5323] = 5323,
  [5324] = 260,
  [5325] = 254,
  [5326] = 3338,
  [5327] = 4835,
  [5328] = 4899,
  [5329] = 595,
  [5330] = 5009,
  [5331] = 2699,
  [5332] = 3698,
  [5333] = 5323,
  [5334] = 4835,
  [5335] = 202,
  [5336] = 5088,
  [5337] = 5095,
  [5338] = 568,
  [5339] = 2697,
  [5340] = 3282,
  [5341] = 3674,
  [5342] = 4388,
  [5343] = 322,
  [5344] = 409,
  [5345] = 311,
  [5346] = 3663,
  [5347] = 312,
  [5348] = 5348,
  [5349] = 313,
  [5350] = 315,
  [5351] = 324,
  [5352] = 316,
  [5353] = 319,
  [5354] = 5101,
  [5355] = 5088,
  [5356] = 414,
  [5357] = 3629,
  [5358] = 289,
  [5359] = 290,
  [5360] = 3624,
  [5361] = 308,
  [5362] = 309,
  [5363] = 3664,
  [5364] = 5095,
  [5365] = 5088,
  [5366] = 5287,
  [5367] = 531,
  [5368] = 293,
  [5369] = 3654,
  [5370] = 294,
  [5371] = 5288,
  [5372] = 3667,
  [5373] = 328,
  [5374] = 5099,
  [5375] = 5375,
  [5376] = 5101,
  [5377] = 3655,
  [5378] = 5088,
  [5379] = 3639,
  [5380] = 3645,
  [5381] = 3625,
  [5382] = 3624,
  [5383] = 3659,
  [5384] = 5095,
  [5385] = 425,
  [5386] = 3628,
  [5387] = 4838,
  [5388] = 5288,
  [5389] = 5239,
  [5390] = 320,
  [5391] = 321,
  [5392] = 3639,
  [5393] = 4389,
  [5394] = 389,
  [5395] = 3615,
  [5396] = 762,
  [5397] = 323,
  [5398] = 325,
  [5399] = 5099,
  [5400] = 670,
  [5401] = 326,
  [5402] = 327,
  [5403] = 310,
  [5404] = 3627,
  [5405] = 4388,
  [5406] = 3627,
  [5407] = 5095,
  [5408] = 4835,
  [5409] = 3656,
  [5410] = 817,
  [5411] = 4835,
  [5412] = 3615,
  [5413] = 3645,
  [5414] = 297,
  [5415] = 298,
  [5416] = 5416,
  [5417] = 5417,
  [5418] = 3659,
  [5419] = 5417,
  [5420] = 3660,
  [5421] = 3625,
  [5422] = 5101,
  [5423] = 3661,
  [5424] = 3658,
  [5425] = 632,
  [5426] = 637,
  [5427] = 3656,
  [5428] = 303,
  [5429] = 317,
  [5430] = 409,
  [5431] = 3661,
  [5432] = 3663,
  [5433] = 305,
  [5434] = 286,
  [5435] = 3664,
  [5436] = 5099,
  [5437] = 287,
  [5438] = 414,
  [5439] = 288,
  [5440] = 3658,
  [5441] = 3628,
  [5442] = 3654,
  [5443] = 4835,
  [5444] = 4388,
  [5445] = 5445,
  [5446] = 3660,
  [5447] = 819,
  [5448] = 4838,
  [5449] = 4838,
  [5450] = 3655,
  [5451] = 3629,
  [5452] = 329,
  [5453] = 306,
  [5454] = 4389,
  [5455] = 307,
  [5456] = 3667,
  [5457] = 5457,
  [5458] = 254,
  [5459] = 5457,
  [5460] = 5460,
  [5461] = 5461,
  [5462] = 5462,
  [5463] = 5463,
  [5464] = 5464,
  [5465] = 4389,
  [5466] = 5466,
  [5467] = 201,
  [5468] = 202,
  [5469] = 4388,
  [5470] = 4389,
  [5471] = 5457,
  [5472] = 3293,
  [5473] = 595,
  [5474] = 5466,
  [5475] = 5475,
  [5476] = 5476,
  [5477] = 5477,
  [5478] = 5476,
  [5479] = 670,
  [5480] = 4838,
  [5481] = 4835,
  [5482] = 5482,
  [5483] = 5483,
  [5484] = 5484,
  [5485] = 5485,
  [5486] = 5457,
  [5487] = 5466,
  [5488] = 5476,
  [5489] = 3674,
  [5490] = 4388,
  [5491] = 5485,
  [5492] = 5457,
  [5493] = 5460,
  [5494] = 5462,
  [5495] = 531,
  [5496] = 5457,
  [5497] = 5460,
  [5498] = 256,
  [5499] = 5460,
  [5500] = 5462,
  [5501] = 5462,
  [5502] = 4389,
  [5503] = 5483,
  [5504] = 5484,
  [5505] = 5485,
  [5506] = 5466,
  [5507] = 5476,
  [5508] = 5457,
  [5509] = 5460,
  [5510] = 5462,
  [5511] = 5463,
  [5512] = 5466,
  [5513] = 632,
  [5514] = 4838,
  [5515] = 5483,
  [5516] = 5485,
  [5517] = 5460,
  [5518] = 5466,
  [5519] = 5476,
  [5520] = 5457,
  [5521] = 5462,
  [5522] = 5462,
  [5523] = 5476,
  [5524] = 4838,
  [5525] = 5485,
  [5526] = 5466,
  [5527] = 5476,
  [5528] = 5457,
  [5529] = 5462,
  [5530] = 5417,
  [5531] = 5485,
  [5532] = 5466,
  [5533] = 5476,
  [5534] = 5457,
  [5535] = 5462,
  [5536] = 4388,
  [5537] = 3284,
  [5538] = 719,
  [5539] = 824,
  [5540] = 3287,
  [5541] = 5485,
  [5542] = 5457,
  [5543] = 5462,
  [5544] = 5483,
  [5545] = 5476,
  [5546] = 5457,
  [5547] = 5462,
  [5548] = 5484,
  [5549] = 3698,
  [5550] = 5485,
  [5551] = 5457,
  [5552] = 5462,
  [5553] = 4835,
  [5554] = 5485,
  [5555] = 5457,
  [5556] = 5462,
  [5557] = 5308,
  [5558] = 5485,
  [5559] = 5462,
  [5560] = 3313,
  [5561] = 5485,
  [5562] = 5457,
  [5563] = 5462,
  [5564] = 4835,
  [5565] = 5484,
  [5566] = 5483,
  [5567] = 5484,
  [5568] = 5485,
  [5569] = 5485,
  [5570] = 5457,
  [5571] = 5485,
  [5572] = 5462,
  [5573] = 5483,
  [5574] = 5484,
  [5575] = 5485,
  [5576] = 5457,
  [5577] = 5462,
  [5578] = 5485,
  [5579] = 5457,
  [5580] = 5462,
  [5581] = 5485,
  [5582] = 5485,
  [5583] = 5457,
  [5584] = 5462,
  [5585] = 5485,
  [5586] = 5457,
  [5587] = 5462,
  [5588] = 5483,
  [5589] = 5009,
  [5590] = 5485,
  [5591] = 5457,
  [5592] = 5462,
  [5593] = 637,
  [5594] = 5485,
  [5595] = 5457,
  [5596] = 5462,
  [5597] = 5485,
  [5598] = 5457,
  [5599] = 5462,
  [5600] = 5485,
  [5601] = 5457,
  [5602] = 5462,
  [5603] = 5485,
  [5604] = 5457,
  [5605] = 5462,
  [5606] = 5417,
  [5607] = 644,
  [5608] = 664,
  [5609] = 5485,
  [5610] = 698,
  [5611] = 667,
  [5612] = 5457,
  [5613] = 646,
  [5614] = 647,
  [5615] = 673,
  [5616] = 5462,
  [5617] = 654,
  [5618] = 650,
  [5619] = 652,
  [5620] = 663,
  [5621] = 686,
  [5622] = 5463,
  [5623] = 5466,
  [5624] = 5485,
  [5625] = 652,
  [5626] = 3629,
  [5627] = 3370,
  [5628] = 302,
  [5629] = 303,
  [5630] = 317,
  [5631] = 305,
  [5632] = 286,
  [5633] = 287,
  [5634] = 288,
  [5635] = 116,
  [5636] = 5636,
  [5637] = 5637,
  [5638] = 5638,
  [5639] = 5475,
  [5640] = 304,
  [5641] = 650,
  [5642] = 329,
  [5643] = 306,
  [5644] = 307,
  [5645] = 310,
  [5646] = 311,
  [5647] = 5637,
  [5648] = 312,
  [5649] = 5649,
  [5650] = 3667,
  [5651] = 5651,
  [5652] = 316,
  [5653] = 319,
  [5654] = 5654,
  [5655] = 5654,
  [5656] = 5656,
  [5657] = 5046,
  [5658] = 5658,
  [5659] = 4838,
  [5660] = 5065,
  [5661] = 3639,
  [5662] = 3639,
  [5663] = 324,
  [5664] = 5654,
  [5665] = 3658,
  [5666] = 3624,
  [5667] = 5667,
  [5668] = 5668,
  [5669] = 5669,
  [5670] = 5127,
  [5671] = 5667,
  [5672] = 5637,
  [5673] = 5095,
  [5674] = 3654,
  [5675] = 3645,
  [5676] = 5676,
  [5677] = 5677,
  [5678] = 654,
  [5679] = 3625,
  [5680] = 5680,
  [5681] = 5099,
  [5682] = 5101,
  [5683] = 698,
  [5684] = 662,
  [5685] = 5637,
  [5686] = 5088,
  [5687] = 665,
  [5688] = 5680,
  [5689] = 5095,
  [5690] = 284,
  [5691] = 5667,
  [5692] = 5095,
  [5693] = 5099,
  [5694] = 5101,
  [5695] = 5088,
  [5696] = 5637,
  [5697] = 5099,
  [5698] = 313,
  [5699] = 5699,
  [5700] = 5417,
  [5701] = 667,
  [5702] = 315,
  [5703] = 5101,
  [5704] = 5088,
  [5705] = 5680,
  [5706] = 646,
  [5707] = 5101,
  [5708] = 3353,
  [5709] = 5709,
  [5710] = 5710,
  [5711] = 3629,
  [5712] = 647,
  [5713] = 644,
  [5714] = 3658,
  [5715] = 5715,
  [5716] = 260,
  [5717] = 5717,
  [5718] = 3627,
  [5719] = 668,
  [5720] = 5680,
  [5721] = 653,
  [5722] = 681,
  [5723] = 687,
  [5724] = 3323,
  [5725] = 5725,
  [5726] = 3350,
  [5727] = 201,
  [5728] = 5088,
  [5729] = 4316,
  [5730] = 642,
  [5731] = 202,
  [5732] = 409,
  [5733] = 5680,
  [5734] = 664,
  [5735] = 414,
  [5736] = 595,
  [5737] = 4838,
  [5738] = 666,
  [5739] = 3654,
  [5740] = 688,
  [5741] = 689,
  [5742] = 5417,
  [5743] = 5654,
  [5744] = 3656,
  [5745] = 817,
  [5746] = 3655,
  [5747] = 3667,
  [5748] = 3645,
  [5749] = 289,
  [5750] = 5750,
  [5751] = 5667,
  [5752] = 290,
  [5753] = 308,
  [5754] = 309,
  [5755] = 5637,
  [5756] = 5099,
  [5757] = 202,
  [5758] = 201,
  [5759] = 3624,
  [5760] = 293,
  [5761] = 298,
  [5762] = 294,
  [5763] = 3350,
  [5764] = 5680,
  [5765] = 3353,
  [5766] = 3364,
  [5767] = 328,
  [5768] = 5768,
  [5769] = 5769,
  [5770] = 3615,
  [5771] = 4835,
  [5772] = 5772,
  [5773] = 5654,
  [5774] = 5774,
  [5775] = 3627,
  [5776] = 4838,
  [5777] = 3656,
  [5778] = 658,
  [5779] = 5667,
  [5780] = 5780,
  [5781] = 3615,
  [5782] = 4838,
  [5783] = 661,
  [5784] = 4835,
  [5785] = 5785,
  [5786] = 5772,
  [5787] = 5649,
  [5788] = 3659,
  [5789] = 3654,
  [5790] = 3655,
  [5791] = 3627,
  [5792] = 3656,
  [5793] = 3615,
  [5794] = 3659,
  [5795] = 3660,
  [5796] = 3661,
  [5797] = 3663,
  [5798] = 3664,
  [5799] = 3628,
  [5800] = 3629,
  [5801] = 3667,
  [5802] = 3639,
  [5803] = 3658,
  [5804] = 3645,
  [5805] = 5805,
  [5806] = 673,
  [5807] = 662,
  [5808] = 3624,
  [5809] = 4835,
  [5810] = 3625,
  [5811] = 3660,
  [5812] = 665,
  [5813] = 663,
  [5814] = 5814,
  [5815] = 5815,
  [5816] = 4835,
  [5817] = 668,
  [5818] = 653,
  [5819] = 3661,
  [5820] = 5820,
  [5821] = 5654,
  [5822] = 241,
  [5823] = 5823,
  [5824] = 5824,
  [5825] = 642,
  [5826] = 666,
  [5827] = 318,
  [5828] = 681,
  [5829] = 3370,
  [5830] = 3355,
  [5831] = 687,
  [5832] = 3379,
  [5833] = 688,
  [5834] = 3364,
  [5835] = 689,
  [5836] = 3663,
  [5837] = 242,
  [5838] = 260,
  [5839] = 320,
  [5840] = 321,
  [5841] = 658,
  [5842] = 661,
  [5843] = 3664,
  [5844] = 686,
  [5845] = 5680,
  [5846] = 322,
  [5847] = 5847,
  [5848] = 323,
  [5849] = 325,
  [5850] = 326,
  [5851] = 5637,
  [5852] = 327,
  [5853] = 3628,
  [5854] = 5680,
  [5855] = 5680,
  [5856] = 3655,
  [5857] = 5680,
  [5858] = 3659,
  [5859] = 3660,
  [5860] = 5680,
  [5861] = 3661,
  [5862] = 3663,
  [5863] = 5863,
  [5864] = 3664,
  [5865] = 5095,
  [5866] = 5680,
  [5867] = 3628,
  [5868] = 5680,
  [5869] = 3355,
  [5870] = 5780,
  [5871] = 296,
  [5872] = 3379,
  [5873] = 297,
  [5874] = 3625,
  [5875] = 5875,
  [5876] = 4835,
  [5877] = 5417,
  [5878] = 670,
  [5879] = 5879,
  [5880] = 5880,
  [5881] = 5881,
  [5882] = 5882,
  [5883] = 297,
  [5884] = 298,
  [5885] = 5885,
  [5886] = 5886,
  [5887] = 5887,
  [5888] = 3361,
  [5889] = 3698,
  [5890] = 5890,
  [5891] = 5891,
  [5892] = 5892,
  [5893] = 4835,
  [5894] = 316,
  [5895] = 5875,
  [5896] = 288,
  [5897] = 5887,
  [5898] = 5898,
  [5899] = 5879,
  [5900] = 5900,
  [5901] = 5901,
  [5902] = 5095,
  [5903] = 5903,
  [5904] = 5904,
  [5905] = 5892,
  [5906] = 5887,
  [5907] = 5907,
  [5908] = 5908,
  [5909] = 319,
  [5910] = 5887,
  [5911] = 326,
  [5912] = 5239,
  [5913] = 318,
  [5914] = 5882,
  [5915] = 5915,
  [5916] = 5881,
  [5917] = 5880,
  [5918] = 5879,
  [5919] = 5919,
  [5920] = 5887,
  [5921] = 5898,
  [5922] = 324,
  [5923] = 5882,
  [5924] = 5887,
  [5925] = 5925,
  [5926] = 293,
  [5927] = 5927,
  [5928] = 5099,
  [5929] = 5929,
  [5930] = 241,
  [5931] = 327,
  [5932] = 5887,
  [5933] = 5886,
  [5934] = 5927,
  [5935] = 5875,
  [5936] = 5880,
  [5937] = 5937,
  [5938] = 287,
  [5939] = 5891,
  [5940] = 5940,
  [5941] = 305,
  [5942] = 5417,
  [5943] = 4838,
  [5944] = 320,
  [5945] = 5095,
  [5946] = 5898,
  [5947] = 5880,
  [5948] = 5875,
  [5949] = 5949,
  [5950] = 5927,
  [5951] = 304,
  [5952] = 5875,
  [5953] = 294,
  [5954] = 5088,
  [5955] = 5880,
  [5956] = 329,
  [5957] = 306,
  [5958] = 5095,
  [5959] = 317,
  [5960] = 5904,
  [5961] = 5961,
  [5962] = 5887,
  [5963] = 5882,
  [5964] = 307,
  [5965] = 5880,
  [5966] = 313,
  [5967] = 5900,
  [5968] = 531,
  [5969] = 531,
  [5970] = 595,
  [5971] = 5900,
  [5972] = 5898,
  [5973] = 308,
  [5974] = 5898,
  [5975] = 5886,
  [5976] = 3674,
  [5977] = 819,
  [5978] = 5886,
  [5979] = 5979,
  [5980] = 5099,
  [5981] = 286,
  [5982] = 5982,
  [5983] = 328,
  [5984] = 310,
  [5985] = 5949,
  [5986] = 819,
  [5987] = 5987,
  [5988] = 289,
  [5989] = 5898,
  [5990] = 5990,
  [5991] = 5887,
  [5992] = 242,
  [5993] = 5887,
  [5994] = 5892,
  [5995] = 762,
  [5996] = 5880,
  [5997] = 5927,
  [5998] = 321,
  [5999] = 5887,
  [6000] = 4838,
  [6001] = 6001,
  [6002] = 6002,
  [6003] = 5892,
  [6004] = 5887,
  [6005] = 6005,
  [6006] = 315,
  [6007] = 6007,
  [6008] = 311,
  [6009] = 5879,
  [6010] = 5887,
  [6011] = 5887,
  [6012] = 5891,
  [6013] = 5880,
  [6014] = 5880,
  [6015] = 312,
  [6016] = 6016,
  [6017] = 5919,
  [6018] = 309,
  [6019] = 5891,
  [6020] = 5879,
  [6021] = 5099,
  [6022] = 5088,
  [6023] = 6023,
  [6024] = 5887,
  [6025] = 5882,
  [6026] = 322,
  [6027] = 5887,
  [6028] = 296,
  [6029] = 5879,
  [6030] = 5919,
  [6031] = 6031,
  [6032] = 290,
  [6033] = 5101,
  [6034] = 5900,
  [6035] = 5101,
  [6036] = 5101,
  [6037] = 5919,
  [6038] = 302,
  [6039] = 303,
  [6040] = 5927,
  [6041] = 5886,
  [6042] = 6001,
  [6043] = 6043,
  [6044] = 5287,
  [6045] = 5892,
  [6046] = 5886,
  [6047] = 5891,
  [6048] = 6048,
  [6049] = 6043,
  [6050] = 5880,
  [6051] = 5898,
  [6052] = 5887,
  [6053] = 323,
  [6054] = 5891,
  [6055] = 5879,
  [6056] = 325,
  [6057] = 5880,
  [6058] = 6031,
  [6059] = 6031,
  [6060] = 6031,
  [6061] = 6031,
  [6062] = 6031,
  [6063] = 5088,
  [6064] = 5886,
  [6065] = 5979,
  [6066] = 762,
  [6067] = 6067,
  [6068] = 6068,
  [6069] = 3442,
  [6070] = 3445,
  [6071] = 5417,
  [6072] = 3408,
  [6073] = 5095,
  [6074] = 260,
  [6075] = 3419,
  [6076] = 3450,
  [6077] = 3423,
  [6078] = 3424,
  [6079] = 6079,
  [6080] = 3420,
  [6081] = 6081,
  [6082] = 3387,
  [6083] = 4838,
  [6084] = 6079,
  [6085] = 6085,
  [6086] = 3478,
  [6087] = 6068,
  [6088] = 2699,
  [6089] = 409,
  [6090] = 414,
  [6091] = 3414,
  [6092] = 6085,
  [6093] = 3426,
  [6094] = 3466,
  [6095] = 6079,
  [6096] = 6079,
  [6097] = 6068,
  [6098] = 6068,
  [6099] = 4835,
  [6100] = 6085,
  [6101] = 5417,
  [6102] = 3415,
  [6103] = 6068,
  [6104] = 6085,
  [6105] = 6105,
  [6106] = 3389,
  [6107] = 6085,
  [6108] = 3390,
  [6109] = 5417,
  [6110] = 3394,
  [6111] = 6085,
  [6112] = 409,
  [6113] = 3477,
  [6114] = 5099,
  [6115] = 6079,
  [6116] = 3384,
  [6117] = 3441,
  [6118] = 409,
  [6119] = 6068,
  [6120] = 414,
  [6121] = 3403,
  [6122] = 5101,
  [6123] = 595,
  [6124] = 6079,
  [6125] = 2697,
  [6126] = 6001,
  [6127] = 6001,
  [6128] = 6128,
  [6129] = 3416,
  [6130] = 6079,
  [6131] = 414,
  [6132] = 4838,
  [6133] = 6068,
  [6134] = 6079,
  [6135] = 6085,
  [6136] = 3380,
  [6137] = 5095,
  [6138] = 5099,
  [6139] = 6043,
  [6140] = 5101,
  [6141] = 5088,
  [6142] = 6068,
  [6143] = 3456,
  [6144] = 3381,
  [6145] = 3479,
  [6146] = 3409,
  [6147] = 3411,
  [6148] = 3398,
  [6149] = 3473,
  [6150] = 3412,
  [6151] = 3407,
  [6152] = 6043,
  [6153] = 3433,
  [6154] = 4835,
  [6155] = 3425,
  [6156] = 3428,
  [6157] = 3449,
  [6158] = 5095,
  [6159] = 5099,
  [6160] = 6068,
  [6161] = 5101,
  [6162] = 5088,
  [6163] = 5088,
  [6164] = 6079,
  [6165] = 5288,
  [6166] = 5308,
  [6167] = 5417,
  [6168] = 3386,
  [6169] = 5417,
  [6170] = 632,
  [6171] = 637,
  [6172] = 6172,
  [6173] = 5099,
  [6174] = 6043,
  [6175] = 5101,
  [6176] = 5088,
  [6177] = 5287,
  [6178] = 531,
  [6179] = 4838,
  [6180] = 5099,
  [6181] = 5101,
  [6182] = 6043,
  [6183] = 5239,
  [6184] = 414,
  [6185] = 5095,
  [6186] = 5088,
  [6187] = 5099,
  [6188] = 425,
  [6189] = 409,
  [6190] = 414,
  [6191] = 4835,
  [6192] = 4838,
  [6193] = 5101,
  [6194] = 6194,
  [6195] = 5088,
  [6196] = 5095,
  [6197] = 6194,
  [6198] = 6198,
  [6199] = 5417,
  [6200] = 585,
  [6201] = 656,
  [6202] = 6198,
  [6203] = 6198,
  [6204] = 5095,
  [6205] = 6198,
  [6206] = 656,
  [6207] = 6194,
  [6208] = 531,
  [6209] = 6198,
  [6210] = 4838,
  [6211] = 6198,
  [6212] = 6172,
  [6213] = 6172,
  [6214] = 568,
  [6215] = 5417,
  [6216] = 6172,
  [6217] = 5417,
  [6218] = 6194,
  [6219] = 6219,
  [6220] = 6172,
  [6221] = 6194,
  [6222] = 6172,
  [6223] = 389,
  [6224] = 409,
  [6225] = 414,
  [6226] = 6001,
  [6227] = 5417,
  [6228] = 6001,
  [6229] = 6229,
  [6230] = 6198,
  [6231] = 6194,
  [6232] = 6172,
  [6233] = 6194,
  [6234] = 4835,
  [6235] = 409,
  [6236] = 4835,
  [6237] = 6237,
  [6238] = 719,
  [6239] = 5417,
  [6240] = 817,
  [6241] = 6241,
  [6242] = 6242,
  [6243] = 6241,
  [6244] = 6244,
  [6245] = 6245,
  [6246] = 6237,
  [6247] = 5088,
  [6248] = 6248,
  [6249] = 6249,
  [6250] = 6237,
  [6251] = 6249,
  [6252] = 6248,
  [6253] = 6244,
  [6254] = 6237,
  [6255] = 6248,
  [6256] = 6237,
  [6257] = 6257,
  [6258] = 6244,
  [6259] = 6237,
  [6260] = 6242,
  [6261] = 5417,
  [6262] = 6244,
  [6263] = 6242,
  [6264] = 6244,
  [6265] = 6237,
  [6266] = 6249,
  [6267] = 6244,
  [6268] = 719,
  [6269] = 5095,
  [6270] = 6242,
  [6271] = 6237,
  [6272] = 6244,
  [6273] = 6244,
  [6274] = 6244,
  [6275] = 5101,
  [6276] = 6001,
  [6277] = 6237,
  [6278] = 6043,
  [6279] = 5095,
  [6280] = 5099,
  [6281] = 6244,
  [6282] = 6245,
  [6283] = 6237,
  [6284] = 5101,
  [6285] = 5088,
  [6286] = 6241,
  [6287] = 6244,
  [6288] = 6245,
  [6289] = 6249,
  [6290] = 6237,
  [6291] = 5095,
  [6292] = 5099,
  [6293] = 6244,
  [6294] = 6249,
  [6295] = 6237,
  [6296] = 5101,
  [6297] = 6242,
  [6298] = 6244,
  [6299] = 5088,
  [6300] = 6248,
  [6301] = 5088,
  [6302] = 5099,
  [6303] = 6244,
  [6304] = 6242,
  [6305] = 6244,
  [6306] = 6249,
  [6307] = 6242,
  [6308] = 6241,
  [6309] = 6244,
  [6310] = 6249,
  [6311] = 6237,
  [6312] = 6245,
  [6313] = 6237,
  [6314] = 6237,
  [6315] = 6249,
  [6316] = 6244,
  [6317] = 6043,
  [6318] = 6237,
  [6319] = 5417,
  [6320] = 6241,
  [6321] = 6001,
  [6322] = 6245,
  [6323] = 6249,
  [6324] = 5308,
  [6325] = 6248,
  [6326] = 6248,
  [6327] = 6237,
  [6328] = 6244,
  [6329] = 824,
  [6330] = 6237,
  [6331] = 6244,
  [6332] = 6332,
  [6333] = 6242,
  [6334] = 6237,
  [6335] = 6241,
  [6336] = 824,
  [6337] = 6244,
  [6338] = 6241,
  [6339] = 5417,
  [6340] = 4899,
  [6341] = 6245,
  [6342] = 6237,
  [6343] = 6237,
  [6344] = 6244,
  [6345] = 6237,
  [6346] = 6346,
  [6347] = 6242,
  [6348] = 5095,
  [6349] = 5099,
  [6350] = 6244,
  [6351] = 6248,
  [6352] = 6244,
  [6353] = 5101,
  [6354] = 6244,
  [6355] = 6237,
  [6356] = 6245,
  [6357] = 6237,
  [6358] = 5417,
  [6359] = 5099,
  [6360] = 6043,
  [6361] = 637,
  [6362] = 762,
  [6363] = 6363,
  [6364] = 819,
  [6365] = 5417,
  [6366] = 6366,
  [6367] = 5417,
  [6368] = 6043,
  [6369] = 6043,
  [6370] = 5088,
  [6371] = 6001,
  [6372] = 819,
  [6373] = 6373,
  [6374] = 5088,
  [6375] = 5417,
  [6376] = 5101,
  [6377] = 6363,
  [6378] = 644,
  [6379] = 664,
  [6380] = 6043,
  [6381] = 5101,
  [6382] = 6366,
  [6383] = 5417,
  [6384] = 6001,
  [6385] = 632,
  [6386] = 637,
  [6387] = 698,
  [6388] = 667,
  [6389] = 6373,
  [6390] = 646,
  [6391] = 5417,
  [6392] = 647,
  [6393] = 632,
  [6394] = 673,
  [6395] = 654,
  [6396] = 650,
  [6397] = 652,
  [6398] = 5099,
  [6399] = 663,
  [6400] = 686,
  [6401] = 5095,
  [6402] = 5095,
  [6403] = 6403,
  [6404] = 5417,
  [6405] = 5417,
  [6406] = 6001,
  [6407] = 762,
  [6408] = 6001,
  [6409] = 5417,
  [6410] = 6410,
  [6411] = 6411,
  [6412] = 6412,
  [6413] = 688,
  [6414] = 5095,
  [6415] = 6410,
  [6416] = 6411,
  [6417] = 6043,
  [6418] = 6043,
  [6419] = 689,
  [6420] = 6001,
  [6421] = 6421,
  [6422] = 6412,
  [6423] = 6410,
  [6424] = 6043,
  [6425] = 5088,
  [6426] = 6412,
  [6427] = 6412,
  [6428] = 6412,
  [6429] = 6410,
  [6430] = 6430,
  [6431] = 6410,
  [6432] = 653,
  [6433] = 6410,
  [6434] = 6412,
  [6435] = 6412,
  [6436] = 6410,
  [6437] = 6410,
  [6438] = 6001,
  [6439] = 6410,
  [6440] = 6412,
  [6441] = 595,
  [6442] = 5099,
  [6443] = 6412,
  [6444] = 6043,
  [6445] = 6412,
  [6446] = 425,
  [6447] = 389,
  [6448] = 531,
  [6449] = 6449,
  [6450] = 658,
  [6451] = 5101,
  [6452] = 6430,
  [6453] = 670,
  [6454] = 661,
  [6455] = 5099,
  [6456] = 6421,
  [6457] = 6410,
  [6458] = 6412,
  [6459] = 6043,
  [6460] = 642,
  [6461] = 6001,
  [6462] = 666,
  [6463] = 6411,
  [6464] = 681,
  [6465] = 6410,
  [6466] = 6412,
  [6467] = 5095,
  [6468] = 665,
  [6469] = 668,
  [6470] = 6449,
  [6471] = 5088,
  [6472] = 6001,
  [6473] = 5101,
  [6474] = 662,
  [6475] = 687,
  [6476] = 6001,
  [6477] = 6410,
  [6478] = 6478,
  [6479] = 6421,
  [6480] = 673,
  [6481] = 644,
  [6482] = 5099,
  [6483] = 6043,
  [6484] = 5088,
  [6485] = 654,
  [6486] = 650,
  [6487] = 664,
  [6488] = 652,
  [6489] = 6001,
  [6490] = 585,
  [6491] = 6043,
  [6492] = 6043,
  [6493] = 6449,
  [6494] = 663,
  [6495] = 686,
  [6496] = 585,
  [6497] = 6449,
  [6498] = 5095,
  [6499] = 6001,
  [6500] = 6430,
  [6501] = 819,
  [6502] = 762,
  [6503] = 5095,
  [6504] = 6421,
  [6505] = 5095,
  [6506] = 5088,
  [6507] = 5101,
  [6508] = 6508,
  [6509] = 5046,
  [6510] = 5088,
  [6511] = 5101,
  [6512] = 5065,
  [6513] = 6001,
  [6514] = 6430,
  [6515] = 5099,
  [6516] = 644,
  [6517] = 664,
  [6518] = 6043,
  [6519] = 698,
  [6520] = 698,
  [6521] = 667,
  [6522] = 646,
  [6523] = 647,
  [6524] = 673,
  [6525] = 654,
  [6526] = 650,
  [6527] = 652,
  [6528] = 663,
  [6529] = 686,
  [6530] = 6001,
  [6531] = 667,
  [6532] = 646,
  [6533] = 647,
  [6534] = 5101,
  [6535] = 5099,
  [6536] = 6043,
  [6537] = 6449,
  [6538] = 6001,
  [6539] = 6043,
  [6540] = 6043,
  [6541] = 6541,
  [6542] = 819,
  [6543] = 6430,
  [6544] = 6541,
  [6545] = 6430,
  [6546] = 6541,
  [6547] = 6421,
  [6548] = 6541,
  [6549] = 6449,
  [6550] = 762,
  [6551] = 6001,
  [6552] = 6001,
  [6553] = 6043,
  [6554] = 6001,
  [6555] = 6043,
  [6556] = 6541,
  [6557] = 6541,
  [6558] = 6001,
  [6559] = 6043,
  [6560] = 6421,
  [6561] = 6541,
  [6562] = 6541,
  [6563] = 6043,
  [6564] = 6541,
  [6565] = 6043,
  [6566] = 6541,
  [6567] = 6001,
  [6568] = 6541,
  [6569] = 831,
  [6570] = 6001,
  [6571] = 6001,
  [6572] = 6541,
  [6573] = 6043,
  [6574] = 6001,
  [6575] = 6575,
  [6576] = 6576,
  [6577] = 6577,
  [6578] = 6575,
  [6579] = 6579,
  [6580] = 6580,
  [6581] = 6581,
  [6582] = 6582,
  [6583] = 6583,
  [6584] = 6575,
  [6585] = 6449,
  [6586] = 670,
  [6587] = 6576,
  [6588] = 6581,
  [6589] = 6577,
  [6590] = 6580,
  [6591] = 6430,
  [6592] = 6592,
  [6593] = 6593,
  [6594] = 6582,
  [6595] = 6575,
  [6596] = 6576,
  [6597] = 6581,
  [6598] = 6582,
  [6599] = 6421,
  [6600] = 6583,
  [6601] = 6601,
  [6602] = 6601,
  [6603] = 6603,
  [6604] = 6577,
  [6605] = 6576,
  [6606] = 6577,
  [6607] = 6576,
  [6608] = 6577,
  [6609] = 6582,
  [6610] = 6603,
  [6611] = 6592,
  [6612] = 6575,
  [6613] = 6575,
  [6614] = 6614,
  [6615] = 6581,
  [6616] = 6582,
  [6617] = 6576,
  [6618] = 6577,
  [6619] = 6593,
  [6620] = 819,
  [6621] = 6621,
  [6622] = 6575,
  [6623] = 6581,
  [6624] = 6621,
  [6625] = 6582,
  [6626] = 6575,
  [6627] = 6581,
  [6628] = 6582,
  [6629] = 6581,
  [6630] = 6576,
  [6631] = 6576,
  [6632] = 6577,
  [6633] = 6577,
  [6634] = 6575,
  [6635] = 6581,
  [6636] = 6592,
  [6637] = 6603,
  [6638] = 6575,
  [6639] = 6582,
  [6640] = 6581,
  [6641] = 6577,
  [6642] = 6576,
  [6643] = 6577,
  [6644] = 6575,
  [6645] = 6581,
  [6646] = 6575,
  [6647] = 6621,
  [6648] = 6583,
  [6649] = 6581,
  [6650] = 6581,
  [6651] = 6577,
  [6652] = 6582,
  [6653] = 6582,
  [6654] = 6601,
  [6655] = 6655,
  [6656] = 6581,
  [6657] = 6576,
  [6658] = 6580,
  [6659] = 6592,
  [6660] = 6593,
  [6661] = 6582,
  [6662] = 6577,
  [6663] = 6583,
  [6664] = 6601,
  [6665] = 6603,
  [6666] = 6576,
  [6667] = 6582,
  [6668] = 6603,
  [6669] = 6575,
  [6670] = 6577,
  [6671] = 6576,
  [6672] = 6577,
  [6673] = 6621,
  [6674] = 6582,
  [6675] = 6581,
  [6676] = 6582,
  [6677] = 6575,
  [6678] = 6581,
  [6679] = 6576,
  [6680] = 6577,
  [6681] = 656,
  [6682] = 6449,
  [6683] = 6575,
  [6684] = 762,
  [6685] = 841,
  [6686] = 6575,
  [6687] = 6581,
  [6688] = 6576,
  [6689] = 6582,
  [6690] = 6576,
  [6691] = 6577,
  [6692] = 6576,
  [6693] = 6580,
  [6694] = 6430,
  [6695] = 6592,
  [6696] = 6575,
  [6697] = 6577,
  [6698] = 6580,
  [6699] = 6592,
  [6700] = 6593,
  [6701] = 6582,
  [6702] = 6582,
  [6703] = 6576,
  [6704] = 6577,
  [6705] = 6582,
  [6706] = 6583,
  [6707] = 6601,
  [6708] = 6603,
  [6709] = 6593,
  [6710] = 6580,
  [6711] = 6621,
  [6712] = 6575,
  [6713] = 6581,
  [6714] = 6582,
  [6715] = 6576,
  [6716] = 6577,
  [6717] = 6575,
  [6718] = 6580,
  [6719] = 6592,
  [6720] = 6593,
  [6721] = 6581,
  [6722] = 6576,
  [6723] = 6582,
  [6724] = 6583,
  [6725] = 6601,
  [6726] = 6603,
  [6727] = 6577,
  [6728] = 6575,
  [6729] = 6593,
  [6730] = 6581,
  [6731] = 6581,
  [6732] = 6621,
  [6733] = 6582,
  [6734] = 6576,
  [6735] = 6582,
  [6736] = 6575,
  [6737] = 6581,
  [6738] = 6577,
  [6739] = 6576,
  [6740] = 6577,
  [6741] = 6421,
  [6742] = 6583,
  [6743] = 6601,
  [6744] = 6575,
  [6745] = 6581,
  [6746] = 6576,
  [6747] = 6747,
  [6748] = 6747,
  [6749] = 6747,
  [6750] = 6750,
  [6751] = 6747,
  [6752] = 6750,
  [6753] = 6747,
  [6754] = 6750,
  [6755] = 6750,
  [6756] = 6747,
  [6757] = 6747,
  [6758] = 6750,
  [6759] = 6430,
  [6760] = 6747,
  [6761] = 6449,
  [6762] = 6762,
  [6763] = 6750,
  [6764] = 6421,
  [6765] = 6747,
  [6766] = 6747,
  [6767] = 6747,
  [6768] = 6750,
  [6769] = 6747,
  [6770] = 6770,
  [6771] = 6421,
  [6772] = 6747,
  [6773] = 762,
  [6774] = 819,
  [6775] = 6750,
  [6776] = 6750,
  [6777] = 6750,
  [6778] = 6750,
  [6779] = 6779,
  [6780] = 6747,
  [6781] = 6747,
  [6782] = 6750,
  [6783] = 6750,
  [6784] = 6747,
  [6785] = 6750,
  [6786] = 6750,
  [6787] = 6747,
  [6788] = 762,
  [6789] = 6750,
  [6790] = 6747,
  [6791] = 6747,
  [6792] = 6747,
  [6793] = 6750,
  [6794] = 6750,
  [6795] = 6449,
  [6796] = 6750,
  [6797] = 6747,
  [6798] = 531,
  [6799] = 6747,
  [6800] = 6430,
  [6801] = 6750,
  [6802] = 6449,
  [6803] = 6747,
  [6804] = 6430,
  [6805] = 6421,
  [6806] = 6747,
  [6807] = 819,
  [6808] = 6808,
  [6809] = 6747,
  [6810] = 6747,
  [6811] = 6750,
  [6812] = 6421,
  [6813] = 6449,
  [6814] = 6430,
  [6815] = 6750,
  [6816] = 6816,
  [6817] = 6817,
  [6818] = 6818,
  [6819] = 6818,
  [6820] = 6449,
  [6821] = 6821,
  [6822] = 6430,
  [6823] = 6817,
  [6824] = 6824,
  [6825] = 6825,
  [6826] = 6825,
  [6827] = 6827,
  [6828] = 6817,
  [6829] = 6825,
  [6830] = 6421,
  [6831] = 6817,
  [6832] = 6421,
  [6833] = 6818,
  [6834] = 6430,
  [6835] = 6821,
  [6836] = 6825,
  [6837] = 6827,
  [6838] = 6430,
  [6839] = 6421,
  [6840] = 6818,
  [6841] = 6821,
  [6842] = 6449,
  [6843] = 6843,
  [6844] = 6824,
  [6845] = 6449,
  [6846] = 6818,
  [6847] = 6817,
  [6848] = 6824,
  [6849] = 6817,
  [6850] = 6825,
  [6851] = 6821,
  [6852] = 6421,
  [6853] = 6853,
  [6854] = 6827,
  [6855] = 6818,
  [6856] = 6449,
  [6857] = 6827,
  [6858] = 6858,
  [6859] = 6821,
  [6860] = 6818,
  [6861] = 6827,
  [6862] = 6862,
  [6863] = 6430,
  [6864] = 6824,
  [6865] = 6430,
  [6866] = 6421,
  [6867] = 6825,
  [6868] = 6827,
  [6869] = 6821,
  [6870] = 6817,
  [6871] = 6825,
  [6872] = 6821,
  [6873] = 6449,
  [6874] = 6449,
  [6875] = 6430,
  [6876] = 6430,
  [6877] = 201,
  [6878] = 6421,
  [6879] = 6421,
  [6880] = 6449,
  [6881] = 6449,
  [6882] = 6430,
  [6883] = 6449,
  [6884] = 6421,
  [6885] = 6885,
  [6886] = 6421,
  [6887] = 202,
  [6888] = 6430,
  [6889] = 6421,
  [6890] = 6430,
  [6891] = 6430,
  [6892] = 6449,
  [6893] = 6430,
  [6894] = 6449,
  [6895] = 6421,
  [6896] = 6421,
  [6897] = 6449,
  [6898] = 6430,
  [6899] = 6449,
  [6900] = 6449,
  [6901] = 6430,
  [6902] = 6430,
  [6903] = 6430,
  [6904] = 6430,
  [6905] = 6421,
  [6906] = 6421,
  [6907] = 6449,
  [6908] = 6421,
  [6909] = 6430,
  [6910] = 6449,
  [6911] = 6449,
  [6912] = 6421,
  [6913] = 6421,
  [6914] = 6449,
  [6915] = 6421,
  [6916] = 6885,
  [6917] = 6917,
  [6918] = 6917,
  [6919] = 6917,
  [6920] = 6917,
  [6921] = 6921,
  [6922] = 6885,
  [6923] = 6921,
  [6924] = 6921,
  [6925] = 2697,
  [6926] = 6921,
  [6927] = 6921,
  [6928] = 2699,
  [6929] = 6921,
  [6930] = 6921,
  [6931] = 6931,
  [6932] = 6932,
  [6933] = 6933,
  [6934] = 6934,
  [6935] = 6932,
  [6936] = 6936,
  [6937] = 6885,
  [6938] = 6938,
  [6939] = 6932,
  [6940] = 6885,
  [6941] = 6934,
  [6942] = 6885,
  [6943] = 6938,
  [6944] = 6936,
  [6945] = 6945,
  [6946] = 6933,
  [6947] = 6947,
  [6948] = 6948,
  [6949] = 6949,
  [6950] = 6950,
  [6951] = 6951,
  [6952] = 6952,
  [6953] = 6953,
  [6954] = 6954,
  [6955] = 6955,
  [6956] = 1662,
  [6957] = 6957,
  [6958] = 1663,
  [6959] = 1665,
  [6960] = 6960,
  [6961] = 1656,
  [6962] = 1674,
  [6963] = 1668,
  [6964] = 6964,
  [6965] = 6957,
  [6966] = 1675,
  [6967] = 1676,
  [6968] = 1681,
  [6969] = 6969,
  [6970] = 6964,
  [6971] = 6957,
  [6972] = 6972,
  [6973] = 1661,
  [6974] = 6960,
  [6975] = 6964,
  [6976] = 6957,
  [6977] = 6960,
  [6978] = 6964,
  [6979] = 6957,
  [6980] = 6980,
  [6981] = 6885,
  [6982] = 6964,
  [6983] = 6957,
  [6984] = 6972,
  [6985] = 6972,
  [6986] = 6960,
  [6987] = 6987,
  [6988] = 6964,
  [6989] = 6957,
  [6990] = 6885,
  [6991] = 6885,
  [6992] = 6960,
  [6993] = 6964,
  [6994] = 6957,
  [6995] = 6964,
  [6996] = 6957,
  [6997] = 6964,
  [6998] = 6957,
  [6999] = 203,
  [7000] = 200,
  [7001] = 7001,
  [7002] = 7002,
  [7003] = 7003,
  [7004] = 7004,
  [7005] = 7005,
  [7006] = 7006,
  [7007] = 6957,
  [7008] = 7008,
  [7009] = 6960,
  [7010] = 6964,
  [7011] = 6957,
  [7012] = 7012,
  [7013] = 6964,
  [7014] = 6957,
  [7015] = 6972,
  [7016] = 6885,
  [7017] = 6960,
  [7018] = 6964,
  [7019] = 6957,
  [7020] = 6960,
  [7021] = 3282,
  [7022] = 6964,
  [7023] = 6957,
  [7024] = 6960,
  [7025] = 6964,
  [7026] = 6957,
  [7027] = 6960,
  [7028] = 6964,
  [7029] = 6957,
  [7030] = 6934,
  [7031] = 6938,
  [7032] = 6936,
  [7033] = 6933,
  [7034] = 7002,
  [7035] = 7004,
  [7036] = 7006,
  [7037] = 7037,
  [7038] = 7008,
  [7039] = 6934,
  [7040] = 6938,
  [7041] = 6936,
  [7042] = 6933,
  [7043] = 6964,
  [7044] = 6957,
  [7045] = 6960,
  [7046] = 6964,
  [7047] = 1765,
  [7048] = 1767,
  [7049] = 6972,
  [7050] = 1778,
  [7051] = 1781,
  [7052] = 1791,
  [7053] = 7053,
  [7054] = 6964,
  [7055] = 7037,
  [7056] = 7056,
  [7057] = 7057,
  [7058] = 7058,
  [7059] = 7059,
  [7060] = 7059,
  [7061] = 6936,
  [7062] = 7059,
  [7063] = 7063,
  [7064] = 7056,
  [7065] = 7057,
  [7066] = 7058,
  [7067] = 7059,
  [7068] = 7057,
  [7069] = 7057,
  [7070] = 7058,
  [7071] = 7058,
  [7072] = 7059,
  [7073] = 7073,
  [7074] = 2697,
  [7075] = 7059,
  [7076] = 7073,
  [7077] = 7063,
  [7078] = 7056,
  [7079] = 6885,
  [7080] = 7063,
  [7081] = 7056,
  [7082] = 7059,
  [7083] = 2699,
  [7084] = 7084,
  [7085] = 6938,
  [7086] = 7003,
  [7087] = 7063,
  [7088] = 7056,
  [7089] = 7057,
  [7090] = 7063,
  [7091] = 7056,
  [7092] = 7057,
  [7093] = 7058,
  [7094] = 7059,
  [7095] = 7063,
  [7096] = 7056,
  [7097] = 7057,
  [7098] = 7058,
  [7099] = 7059,
  [7100] = 7063,
  [7101] = 7056,
  [7102] = 7057,
  [7103] = 7058,
  [7104] = 7059,
  [7105] = 7063,
  [7106] = 7056,
  [7107] = 7063,
  [7108] = 7056,
  [7109] = 7057,
  [7110] = 7058,
  [7111] = 7059,
  [7112] = 7112,
  [7113] = 7063,
  [7114] = 7056,
  [7115] = 7057,
  [7116] = 7058,
  [7117] = 7059,
  [7118] = 7057,
  [7119] = 7084,
  [7120] = 1656,
  [7121] = 2699,
  [7122] = 1668,
  [7123] = 7058,
  [7124] = 7112,
  [7125] = 7057,
  [7126] = 7058,
  [7127] = 7059,
  [7128] = 7058,
  [7129] = 6934,
  [7130] = 7112,
  [7131] = 7063,
  [7132] = 7073,
  [7133] = 7059,
  [7134] = 6950,
  [7135] = 6949,
  [7136] = 7057,
  [7137] = 7063,
  [7138] = 7056,
  [7139] = 6936,
  [7140] = 7056,
  [7141] = 7063,
  [7142] = 7056,
  [7143] = 7056,
  [7144] = 1765,
  [7145] = 6938,
  [7146] = 1767,
  [7147] = 7063,
  [7148] = 7056,
  [7149] = 7057,
  [7150] = 7058,
  [7151] = 1778,
  [7152] = 1781,
  [7153] = 1791,
  [7154] = 7057,
  [7155] = 7058,
  [7156] = 7059,
  [7157] = 7059,
  [7158] = 1661,
  [7159] = 7057,
  [7160] = 6933,
  [7161] = 1662,
  [7162] = 1663,
  [7163] = 1665,
  [7164] = 7063,
  [7165] = 7056,
  [7166] = 6885,
  [7167] = 7057,
  [7168] = 7058,
  [7169] = 7058,
  [7170] = 7059,
  [7171] = 7057,
  [7172] = 6934,
  [7173] = 7063,
  [7174] = 7056,
  [7175] = 7058,
  [7176] = 7063,
  [7177] = 7056,
  [7178] = 7057,
  [7179] = 7058,
  [7180] = 7059,
  [7181] = 6933,
  [7182] = 203,
  [7183] = 6885,
  [7184] = 1674,
  [7185] = 1675,
  [7186] = 7063,
  [7187] = 7056,
  [7188] = 1676,
  [7189] = 1681,
  [7190] = 7190,
  [7191] = 7057,
  [7192] = 7084,
  [7193] = 7058,
  [7194] = 7059,
  [7195] = 7057,
  [7196] = 7058,
  [7197] = 7059,
  [7198] = 7059,
  [7199] = 2697,
  [7200] = 200,
  [7201] = 7063,
  [7202] = 7056,
  [7203] = 7057,
  [7204] = 7058,
  [7205] = 7063,
  [7206] = 7056,
  [7207] = 7059,
  [7208] = 7063,
  [7209] = 7063,
  [7210] = 7058,
  [7211] = 6885,
  [7212] = 7212,
  [7213] = 7213,
  [7214] = 7214,
  [7215] = 1199,
  [7216] = 7216,
  [7217] = 7217,
  [7218] = 7218,
  [7219] = 7219,
  [7220] = 7212,
  [7221] = 7221,
  [7222] = 7222,
  [7223] = 7214,
  [7224] = 7224,
  [7225] = 7213,
  [7226] = 7212,
  [7227] = 7217,
  [7228] = 7228,
  [7229] = 7229,
  [7230] = 6934,
  [7231] = 6938,
  [7232] = 6936,
  [7233] = 6933,
  [7234] = 7212,
  [7235] = 7214,
  [7236] = 7236,
  [7237] = 7214,
  [7238] = 7236,
  [7239] = 7213,
  [7240] = 7240,
  [7241] = 7213,
  [7242] = 7212,
  [7243] = 7243,
  [7244] = 6885,
  [7245] = 7245,
  [7246] = 7246,
  [7247] = 7247,
  [7248] = 7248,
  [7249] = 7249,
  [7250] = 7250,
  [7251] = 7251,
  [7252] = 7252,
  [7253] = 7253,
  [7254] = 7254,
  [7255] = 7255,
  [7256] = 7256,
  [7257] = 7257,
  [7258] = 7218,
  [7259] = 7212,
  [7260] = 7260,
  [7261] = 7222,
  [7262] = 7214,
  [7263] = 7213,
  [7264] = 7264,
  [7265] = 7214,
  [7266] = 7212,
  [7267] = 7218,
  [7268] = 7214,
  [7269] = 7222,
  [7270] = 7222,
  [7271] = 7218,
  [7272] = 7222,
  [7273] = 7218,
  [7274] = 7222,
  [7275] = 7218,
  [7276] = 7222,
  [7277] = 7277,
  [7278] = 7218,
  [7279] = 7222,
  [7280] = 7213,
  [7281] = 7222,
  [7282] = 7213,
  [7283] = 7283,
  [7284] = 7213,
  [7285] = 7285,
  [7286] = 7212,
  [7287] = 7214,
  [7288] = 7283,
  [7289] = 7289,
  [7290] = 7213,
  [7291] = 7212,
  [7292] = 7212,
  [7293] = 7214,
  [7294] = 7240,
  [7295] = 6934,
  [7296] = 6938,
  [7297] = 6936,
  [7298] = 6933,
  [7299] = 7213,
  [7300] = 7002,
  [7301] = 7212,
  [7302] = 7302,
  [7303] = 7004,
  [7304] = 7006,
  [7305] = 7037,
  [7306] = 7214,
  [7307] = 7307,
  [7308] = 7008,
  [7309] = 7309,
  [7310] = 7214,
  [7311] = 7311,
  [7312] = 7312,
  [7313] = 7313,
  [7314] = 3698,
  [7315] = 7002,
  [7316] = 7316,
  [7317] = 7317,
  [7318] = 7004,
  [7319] = 7006,
  [7320] = 7037,
  [7321] = 7321,
  [7322] = 7008,
  [7323] = 7323,
  [7324] = 7324,
  [7325] = 6885,
  [7326] = 7326,
  [7327] = 7327,
  [7328] = 7328,
  [7329] = 7329,
  [7330] = 7213,
  [7331] = 7283,
  [7332] = 7240,
  [7333] = 6934,
  [7334] = 6938,
  [7335] = 6936,
  [7336] = 6933,
  [7337] = 6934,
  [7338] = 6938,
  [7339] = 6936,
  [7340] = 6933,
  [7341] = 7283,
  [7342] = 7342,
  [7343] = 7343,
  [7344] = 7344,
  [7345] = 1194,
  [7346] = 7213,
  [7347] = 7248,
  [7348] = 7218,
  [7349] = 7249,
  [7350] = 7250,
  [7351] = 7213,
  [7352] = 7251,
  [7353] = 7252,
  [7354] = 7212,
  [7355] = 7214,
  [7356] = 7253,
  [7357] = 7254,
  [7358] = 7212,
  [7359] = 7214,
  [7360] = 7255,
  [7361] = 7256,
  [7362] = 7257,
  [7363] = 7363,
  [7364] = 7218,
  [7365] = 7329,
  [7366] = 7366,
  [7367] = 7344,
  [7368] = 7368,
  [7369] = 7369,
  [7370] = 7370,
  [7371] = 7366,
  [7372] = 7369,
  [7373] = 7323,
  [7374] = 7374,
  [7375] = 7006,
  [7376] = 7037,
  [7377] = 7221,
  [7378] = 7370,
  [7379] = 7302,
  [7380] = 7380,
  [7381] = 7307,
  [7382] = 7382,
  [7383] = 7309,
  [7384] = 7366,
  [7385] = 7366,
  [7386] = 7312,
  [7387] = 6885,
  [7388] = 7388,
  [7389] = 7369,
  [7390] = 7390,
  [7391] = 7366,
  [7392] = 7313,
  [7393] = 7393,
  [7394] = 7394,
  [7395] = 7374,
  [7396] = 7396,
  [7397] = 7316,
  [7398] = 7369,
  [7399] = 7370,
  [7400] = 7370,
  [7401] = 7324,
  [7402] = 7326,
  [7403] = 7394,
  [7404] = 7006,
  [7405] = 7327,
  [7406] = 7406,
  [7407] = 7393,
  [7408] = 7408,
  [7409] = 7409,
  [7410] = 7393,
  [7411] = 7328,
  [7412] = 7002,
  [7413] = 7374,
  [7414] = 6885,
  [7415] = 7415,
  [7416] = 7363,
  [7417] = 7417,
  [7418] = 7418,
  [7419] = 7004,
  [7420] = 7420,
  [7421] = 7370,
  [7422] = 7422,
  [7423] = 7277,
  [7424] = 7216,
  [7425] = 7425,
  [7426] = 3698,
  [7427] = 7382,
  [7428] = 7037,
  [7429] = 7246,
  [7430] = 7247,
  [7431] = 7370,
  [7432] = 7394,
  [7433] = 7433,
  [7434] = 7366,
  [7435] = 7008,
  [7436] = 7004,
  [7437] = 7437,
  [7438] = 7008,
  [7439] = 6885,
  [7440] = 7440,
  [7441] = 7002,
  [7442] = 7393,
  [7443] = 7393,
  [7444] = 7285,
  [7445] = 7321,
  [7446] = 7264,
  [7447] = 7447,
  [7448] = 7393,
  [7449] = 7370,
  [7450] = 7450,
  [7451] = 7289,
  [7452] = 7394,
  [7453] = 7366,
  [7454] = 7454,
  [7455] = 6934,
  [7456] = 6938,
  [7457] = 6936,
  [7458] = 6933,
  [7459] = 7459,
  [7460] = 6934,
  [7461] = 6938,
  [7462] = 6936,
  [7463] = 6933,
  [7464] = 6933,
  [7465] = 7465,
  [7466] = 7466,
  [7467] = 6885,
  [7468] = 7002,
  [7469] = 7004,
  [7470] = 6934,
  [7471] = 6938,
  [7472] = 7006,
  [7473] = 7473,
  [7474] = 7037,
  [7475] = 7475,
  [7476] = 7008,
  [7477] = 6934,
  [7478] = 6936,
  [7479] = 7479,
  [7480] = 6885,
  [7481] = 7481,
  [7482] = 7482,
  [7483] = 7406,
  [7484] = 7484,
  [7485] = 7485,
  [7486] = 7486,
  [7487] = 7487,
  [7488] = 7488,
  [7489] = 6969,
  [7490] = 6934,
  [7491] = 6938,
  [7492] = 7492,
  [7493] = 7493,
  [7494] = 6938,
  [7495] = 7495,
  [7496] = 7496,
  [7497] = 7497,
  [7498] = 7498,
  [7499] = 7499,
  [7500] = 7500,
  [7501] = 7002,
  [7502] = 6936,
  [7503] = 7004,
  [7504] = 6933,
  [7505] = 7006,
  [7506] = 7037,
  [7507] = 7008,
  [7508] = 7508,
  [7509] = 7509,
  [7510] = 7510,
  [7511] = 7511,
  [7512] = 7512,
  [7513] = 7513,
  [7514] = 7002,
  [7515] = 7004,
  [7516] = 7516,
  [7517] = 7006,
  [7518] = 7037,
  [7519] = 7519,
  [7520] = 7008,
  [7521] = 6936,
  [7522] = 6885,
  [7523] = 7523,
  [7524] = 6955,
  [7525] = 6933,
  [7526] = 7526,
  [7527] = 7527,
  [7528] = 7528,
  [7529] = 7529,
  [7530] = 6950,
  [7531] = 6949,
  [7532] = 7532,
  [7533] = 6934,
  [7534] = 6885,
  [7535] = 7535,
  [7536] = 6938,
  [7537] = 7537,
  [7538] = 6936,
  [7539] = 6933,
  [7540] = 7002,
  [7541] = 7541,
  [7542] = 6980,
  [7543] = 7543,
  [7544] = 7004,
  [7545] = 7006,
  [7546] = 7546,
  [7547] = 7037,
  [7548] = 7008,
  [7549] = 7549,
  [7550] = 7550,
  [7551] = 2987,
  [7552] = 7552,
  [7553] = 6934,
  [7554] = 7454,
  [7555] = 7555,
  [7556] = 7543,
  [7557] = 7555,
  [7558] = 6938,
  [7559] = 7466,
  [7560] = 6936,
  [7561] = 2697,
  [7562] = 7555,
  [7563] = 7475,
  [7564] = 6936,
  [7565] = 7565,
  [7566] = 7485,
  [7567] = 6885,
  [7568] = 7555,
  [7569] = 6938,
  [7570] = 2699,
  [7571] = 6934,
  [7572] = 6934,
  [7573] = 6933,
  [7574] = 7574,
  [7575] = 7415,
  [7576] = 7418,
  [7577] = 7577,
  [7578] = 7437,
  [7579] = 2697,
  [7580] = 7532,
  [7581] = 7555,
  [7582] = 6933,
  [7583] = 7473,
  [7584] = 2699,
  [7585] = 6933,
  [7586] = 7519,
  [7587] = 6936,
  [7588] = 7527,
  [7589] = 6938,
  [7590] = 7590,
  [7591] = 7591,
  [7592] = 2984,
  [7593] = 7593,
  [7594] = 7594,
  [7595] = 2970,
  [7596] = 7479,
  [7597] = 7481,
  [7598] = 6934,
  [7599] = 6936,
  [7600] = 6933,
  [7601] = 7422,
  [7602] = 7390,
  [7603] = 7440,
  [7604] = 7486,
  [7605] = 7487,
  [7606] = 7555,
  [7607] = 6885,
  [7608] = 7535,
  [7609] = 7552,
  [7610] = 7516,
  [7611] = 7526,
  [7612] = 7529,
  [7613] = 7380,
  [7614] = 7425,
  [7615] = 6938,
  [7616] = 6936,
  [7617] = 7465,
  [7618] = 7459,
  [7619] = 6933,
  [7620] = 7528,
  [7621] = 7541,
  [7622] = 6938,
  [7623] = 6934,
  [7624] = 7549,
  [7625] = 7546,
  [7626] = 7537,
  [7627] = 7368,
  [7628] = 7008,
  [7629] = 6933,
  [7630] = 7630,
  [7631] = 7002,
  [7632] = 7437,
  [7633] = 7440,
  [7634] = 7634,
  [7635] = 3239,
  [7636] = 7634,
  [7637] = 3201,
  [7638] = 7638,
  [7639] = 7634,
  [7640] = 7638,
  [7641] = 7004,
  [7642] = 3198,
  [7643] = 7634,
  [7644] = 7638,
  [7645] = 7006,
  [7646] = 3252,
  [7647] = 6885,
  [7648] = 7638,
  [7649] = 7037,
  [7650] = 3167,
  [7651] = 7002,
  [7652] = 7004,
  [7653] = 7006,
  [7654] = 7037,
  [7655] = 7008,
  [7656] = 7002,
  [7657] = 7004,
  [7658] = 7006,
  [7659] = 7037,
  [7660] = 7008,
  [7661] = 7634,
  [7662] = 7634,
  [7663] = 7002,
  [7664] = 7004,
  [7665] = 7006,
  [7666] = 7037,
  [7667] = 7008,
  [7668] = 7634,
  [7669] = 7669,
  [7670] = 7634,
  [7671] = 202,
  [7672] = 7492,
  [7673] = 7493,
  [7674] = 7495,
  [7675] = 7496,
  [7676] = 7497,
  [7677] = 7498,
  [7678] = 7499,
  [7679] = 7500,
  [7680] = 7638,
  [7681] = 7634,
  [7682] = 3354,
  [7683] = 7634,
  [7684] = 7684,
  [7685] = 201,
  [7686] = 7390,
  [7687] = 7422,
  [7688] = 7634,
  [7689] = 7689,
  [7690] = 6934,
  [7691] = 7634,
  [7692] = 7689,
  [7693] = 7634,
  [7694] = 6938,
  [7695] = 6936,
  [7696] = 6933,
  [7697] = 7634,
  [7698] = 7634,
  [7699] = 7002,
  [7700] = 7634,
  [7701] = 7634,
  [7702] = 7634,
  [7703] = 7634,
  [7704] = 6934,
  [7705] = 7002,
  [7706] = 7004,
  [7707] = 7006,
  [7708] = 7037,
  [7709] = 7008,
  [7710] = 7638,
  [7711] = 6950,
  [7712] = 6949,
  [7713] = 7368,
  [7714] = 7004,
  [7715] = 6885,
  [7716] = 7380,
  [7717] = 7634,
  [7718] = 7415,
  [7719] = 7418,
  [7720] = 7634,
  [7721] = 7422,
  [7722] = 7722,
  [7723] = 7508,
  [7724] = 7509,
  [7725] = 7510,
  [7726] = 7523,
  [7727] = 7511,
  [7728] = 7512,
  [7729] = 7513,
  [7730] = 6938,
  [7731] = 7425,
  [7732] = 7006,
  [7733] = 7037,
  [7734] = 7008,
  [7735] = 7634,
  [7736] = 6936,
  [7737] = 7634,
  [7738] = 7638,
  [7739] = 7739,
  [7740] = 7513,
  [7741] = 7002,
  [7742] = 3120,
  [7743] = 6885,
  [7744] = 7002,
  [7745] = 7390,
  [7746] = 6933,
  [7747] = 6933,
  [7748] = 7368,
  [7749] = 7380,
  [7750] = 7415,
  [7751] = 7418,
  [7752] = 7425,
  [7753] = 7437,
  [7754] = 7754,
  [7755] = 6938,
  [7756] = 7756,
  [7757] = 7440,
  [7758] = 7390,
  [7759] = 7415,
  [7760] = 7418,
  [7761] = 7437,
  [7762] = 7368,
  [7763] = 7380,
  [7764] = 7425,
  [7765] = 7440,
  [7766] = 7006,
  [7767] = 7767,
  [7768] = 7002,
  [7769] = 7769,
  [7770] = 3382,
  [7771] = 3351,
  [7772] = 7739,
  [7773] = 7773,
  [7774] = 6936,
  [7775] = 7739,
  [7776] = 7773,
  [7777] = 7777,
  [7778] = 7037,
  [7779] = 2699,
  [7780] = 7780,
  [7781] = 3260,
  [7782] = 7004,
  [7783] = 7492,
  [7784] = 7493,
  [7785] = 7495,
  [7786] = 7496,
  [7787] = 7497,
  [7788] = 7498,
  [7789] = 7499,
  [7790] = 7500,
  [7791] = 6934,
  [7792] = 6938,
  [7793] = 6936,
  [7794] = 6933,
  [7795] = 7004,
  [7796] = 3282,
  [7797] = 7797,
  [7798] = 6934,
  [7799] = 6938,
  [7800] = 6936,
  [7801] = 6933,
  [7802] = 7004,
  [7803] = 7739,
  [7804] = 7739,
  [7805] = 7777,
  [7806] = 7777,
  [7807] = 6933,
  [7808] = 7006,
  [7809] = 7037,
  [7810] = 7810,
  [7811] = 6936,
  [7812] = 7739,
  [7813] = 201,
  [7814] = 7777,
  [7815] = 7008,
  [7816] = 7006,
  [7817] = 7492,
  [7818] = 7818,
  [7819] = 7512,
  [7820] = 7820,
  [7821] = 7037,
  [7822] = 7508,
  [7823] = 7739,
  [7824] = 7777,
  [7825] = 7008,
  [7826] = 7422,
  [7827] = 6934,
  [7828] = 7508,
  [7829] = 7777,
  [7830] = 7008,
  [7831] = 6934,
  [7832] = 6885,
  [7833] = 7002,
  [7834] = 7834,
  [7835] = 7773,
  [7836] = 7810,
  [7837] = 7422,
  [7838] = 7509,
  [7839] = 7390,
  [7840] = 7368,
  [7841] = 7380,
  [7842] = 7415,
  [7843] = 7418,
  [7844] = 7425,
  [7845] = 7437,
  [7846] = 7440,
  [7847] = 7523,
  [7848] = 7510,
  [7849] = 7511,
  [7850] = 7002,
  [7851] = 2697,
  [7852] = 7510,
  [7853] = 7512,
  [7854] = 7854,
  [7855] = 7513,
  [7856] = 6934,
  [7857] = 6938,
  [7858] = 6936,
  [7859] = 6933,
  [7860] = 6934,
  [7861] = 6938,
  [7862] = 6936,
  [7863] = 6933,
  [7864] = 7864,
  [7865] = 6938,
  [7866] = 7810,
  [7867] = 7523,
  [7868] = 7773,
  [7869] = 6934,
  [7870] = 7004,
  [7871] = 7004,
  [7872] = 7574,
  [7873] = 6938,
  [7874] = 7509,
  [7875] = 7810,
  [7876] = 6936,
  [7877] = 7810,
  [7878] = 7810,
  [7879] = 7008,
  [7880] = 6885,
  [7881] = 7810,
  [7882] = 3435,
  [7883] = 7006,
  [7884] = 7037,
  [7885] = 7037,
  [7886] = 7008,
  [7887] = 7511,
  [7888] = 7006,
  [7889] = 7777,
  [7890] = 7513,
  [7891] = 7497,
  [7892] = 7892,
  [7893] = 7892,
  [7894] = 7892,
  [7895] = 7523,
  [7896] = 7896,
  [7897] = 7006,
  [7898] = 3076,
  [7899] = 7896,
  [7900] = 7900,
  [7901] = 7901,
  [7902] = 7422,
  [7903] = 7037,
  [7904] = 3239,
  [7905] = 7896,
  [7906] = 7574,
  [7907] = 7907,
  [7908] = 7892,
  [7909] = 116,
  [7910] = 7910,
  [7911] = 3401,
  [7912] = 7508,
  [7913] = 7509,
  [7914] = 7510,
  [7915] = 7511,
  [7916] = 7512,
  [7917] = 7513,
  [7918] = 7492,
  [7919] = 7493,
  [7920] = 2911,
  [7921] = 7495,
  [7922] = 7496,
  [7923] = 7497,
  [7924] = 7892,
  [7925] = 7008,
  [7926] = 7892,
  [7927] = 7896,
  [7928] = 7498,
  [7929] = 7498,
  [7930] = 7499,
  [7931] = 7499,
  [7932] = 7892,
  [7933] = 7933,
  [7934] = 7896,
  [7935] = 7500,
  [7936] = 7936,
  [7937] = 7892,
  [7938] = 7892,
  [7939] = 7002,
  [7940] = 7892,
  [7941] = 7892,
  [7942] = 7493,
  [7943] = 7892,
  [7944] = 7944,
  [7945] = 7892,
  [7946] = 7002,
  [7947] = 7892,
  [7948] = 7422,
  [7949] = 7422,
  [7950] = 7496,
  [7951] = 7006,
  [7952] = 7037,
  [7953] = 7008,
  [7954] = 3198,
  [7955] = 7892,
  [7956] = 3071,
  [7957] = 7892,
  [7958] = 7574,
  [7959] = 7500,
  [7960] = 7892,
  [7961] = 3201,
  [7962] = 7892,
  [7963] = 7936,
  [7964] = 7936,
  [7965] = 7422,
  [7966] = 7892,
  [7967] = 7967,
  [7968] = 2908,
  [7969] = 7936,
  [7970] = 7892,
  [7971] = 7936,
  [7972] = 7972,
  [7973] = 3252,
  [7974] = 7492,
  [7975] = 7493,
  [7976] = 7523,
  [7977] = 7495,
  [7978] = 7496,
  [7979] = 3167,
  [7980] = 7508,
  [7981] = 7509,
  [7982] = 7510,
  [7983] = 7511,
  [7984] = 7512,
  [7985] = 7896,
  [7986] = 7497,
  [7987] = 595,
  [7988] = 7498,
  [7989] = 7892,
  [7990] = 7499,
  [7991] = 2697,
  [7992] = 7936,
  [7993] = 7892,
  [7994] = 7892,
  [7995] = 7936,
  [7996] = 2699,
  [7997] = 7892,
  [7998] = 7998,
  [7999] = 7896,
  [8000] = 8000,
  [8001] = 7500,
  [8002] = 7495,
  [8003] = 8003,
  [8004] = 7004,
  [8005] = 7004,
  [8006] = 8006,
  [8007] = 7418,
  [8008] = 7512,
  [8009] = 7513,
  [8010] = 8010,
  [8011] = 7425,
  [8012] = 7437,
  [8013] = 7440,
  [8014] = 8014,
  [8015] = 8015,
  [8016] = 7004,
  [8017] = 8017,
  [8018] = 8018,
  [8019] = 8017,
  [8020] = 8015,
  [8021] = 8021,
  [8022] = 7415,
  [8023] = 7002,
  [8024] = 8024,
  [8025] = 8021,
  [8026] = 3260,
  [8027] = 7418,
  [8028] = 8015,
  [8029] = 8015,
  [8030] = 8017,
  [8031] = 8031,
  [8032] = 7390,
  [8033] = 8015,
  [8034] = 7368,
  [8035] = 7415,
  [8036] = 7418,
  [8037] = 7944,
  [8038] = 7380,
  [8039] = 7523,
  [8040] = 7415,
  [8041] = 7418,
  [8042] = 7425,
  [8043] = 7437,
  [8044] = 7440,
  [8045] = 7006,
  [8046] = 7437,
  [8047] = 8015,
  [8048] = 7440,
  [8049] = 7368,
  [8050] = 7380,
  [8051] = 7425,
  [8052] = 7437,
  [8053] = 7440,
  [8054] = 8054,
  [8055] = 7900,
  [8056] = 8014,
  [8057] = 7006,
  [8058] = 7002,
  [8059] = 8059,
  [8060] = 8060,
  [8061] = 8061,
  [8062] = 7368,
  [8063] = 3464,
  [8064] = 8064,
  [8065] = 8065,
  [8066] = 7422,
  [8067] = 7422,
  [8068] = 7998,
  [8069] = 7037,
  [8070] = 8000,
  [8071] = 8071,
  [8072] = 7037,
  [8073] = 8017,
  [8074] = 8017,
  [8075] = 7574,
  [8076] = 7492,
  [8077] = 7002,
  [8078] = 7004,
  [8079] = 7006,
  [8080] = 7037,
  [8081] = 3267,
  [8082] = 7008,
  [8083] = 7492,
  [8084] = 8084,
  [8085] = 3271,
  [8086] = 8017,
  [8087] = 8087,
  [8088] = 8017,
  [8089] = 7425,
  [8090] = 7523,
  [8091] = 3274,
  [8092] = 8092,
  [8093] = 8093,
  [8094] = 8021,
  [8095] = 8015,
  [8096] = 7523,
  [8097] = 8015,
  [8098] = 2697,
  [8099] = 7004,
  [8100] = 3285,
  [8101] = 8014,
  [8102] = 3277,
  [8103] = 3315,
  [8104] = 8104,
  [8105] = 7008,
  [8106] = 7002,
  [8107] = 7004,
  [8108] = 7380,
  [8109] = 7006,
  [8110] = 7037,
  [8111] = 7008,
  [8112] = 7002,
  [8113] = 8071,
  [8114] = 7004,
  [8115] = 7006,
  [8116] = 7037,
  [8117] = 7008,
  [8118] = 7002,
  [8119] = 409,
  [8120] = 414,
  [8121] = 7006,
  [8122] = 3273,
  [8123] = 3291,
  [8124] = 8124,
  [8125] = 3292,
  [8126] = 3312,
  [8127] = 8071,
  [8128] = 8017,
  [8129] = 8071,
  [8130] = 2699,
  [8131] = 3457,
  [8132] = 8132,
  [8133] = 3458,
  [8134] = 7390,
  [8135] = 7002,
  [8136] = 7004,
  [8137] = 7006,
  [8138] = 7523,
  [8139] = 7037,
  [8140] = 7008,
  [8141] = 3460,
  [8142] = 7008,
  [8143] = 7901,
  [8144] = 3468,
  [8145] = 7037,
  [8146] = 3470,
  [8147] = 7390,
  [8148] = 7574,
  [8149] = 7004,
  [8150] = 3471,
  [8151] = 8017,
  [8152] = 8017,
  [8153] = 7008,
  [8154] = 8021,
  [8155] = 7390,
  [8156] = 8015,
  [8157] = 8093,
  [8158] = 3321,
  [8159] = 8015,
  [8160] = 8015,
  [8161] = 8161,
  [8162] = 8162,
  [8163] = 8021,
  [8164] = 8014,
  [8165] = 8165,
  [8166] = 7368,
  [8167] = 7380,
  [8168] = 7508,
  [8169] = 8169,
  [8170] = 7509,
  [8171] = 8017,
  [8172] = 7415,
  [8173] = 7510,
  [8174] = 8017,
  [8175] = 7511,
  [8176] = 8015,
  [8177] = 8177,
  [8178] = 7437,
  [8179] = 7440,
  [8180] = 7437,
  [8181] = 8181,
  [8182] = 8181,
  [8183] = 7509,
  [8184] = 8184,
  [8185] = 2699,
  [8186] = 8186,
  [8187] = 7508,
  [8188] = 7495,
  [8189] = 8181,
  [8190] = 8190,
  [8191] = 8181,
  [8192] = 8181,
  [8193] = 7511,
  [8194] = 7390,
  [8195] = 7440,
  [8196] = 3352,
  [8197] = 7390,
  [8198] = 7510,
  [8199] = 8184,
  [8200] = 7513,
  [8201] = 7512,
  [8202] = 7422,
  [8203] = 7496,
  [8204] = 7368,
  [8205] = 8205,
  [8206] = 7574,
  [8207] = 7380,
  [8208] = 8181,
  [8209] = 7415,
  [8210] = 7492,
  [8211] = 7418,
  [8212] = 8181,
  [8213] = 7415,
  [8214] = 7493,
  [8215] = 7418,
  [8216] = 7500,
  [8217] = 7495,
  [8218] = 7425,
  [8219] = 7437,
  [8220] = 8181,
  [8221] = 7496,
  [8222] = 7440,
  [8223] = 8184,
  [8224] = 7497,
  [8225] = 8181,
  [8226] = 7498,
  [8227] = 8181,
  [8228] = 7493,
  [8229] = 8229,
  [8230] = 8181,
  [8231] = 8231,
  [8232] = 8184,
  [8233] = 7493,
  [8234] = 8234,
  [8235] = 7495,
  [8236] = 2697,
  [8237] = 8181,
  [8238] = 7496,
  [8239] = 7497,
  [8240] = 7368,
  [8241] = 7499,
  [8242] = 7498,
  [8243] = 7499,
  [8244] = 8244,
  [8245] = 7500,
  [8246] = 8181,
  [8247] = 7380,
  [8248] = 7422,
  [8249] = 8249,
  [8250] = 7498,
  [8251] = 7493,
  [8252] = 7495,
  [8253] = 3122,
  [8254] = 8181,
  [8255] = 7500,
  [8256] = 7496,
  [8257] = 7508,
  [8258] = 7509,
  [8259] = 7510,
  [8260] = 7497,
  [8261] = 7511,
  [8262] = 7512,
  [8263] = 7513,
  [8264] = 8184,
  [8265] = 7422,
  [8266] = 7497,
  [8267] = 7498,
  [8268] = 7508,
  [8269] = 7509,
  [8270] = 7510,
  [8271] = 7511,
  [8272] = 7512,
  [8273] = 7513,
  [8274] = 7492,
  [8275] = 7499,
  [8276] = 7500,
  [8277] = 8181,
  [8278] = 8181,
  [8279] = 8279,
  [8280] = 8181,
  [8281] = 8181,
  [8282] = 8181,
  [8283] = 7508,
  [8284] = 7422,
  [8285] = 7509,
  [8286] = 7510,
  [8287] = 7523,
  [8288] = 7425,
  [8289] = 7511,
  [8290] = 8290,
  [8291] = 8181,
  [8292] = 8184,
  [8293] = 7422,
  [8294] = 7574,
  [8295] = 7512,
  [8296] = 7513,
  [8297] = 8249,
  [8298] = 8181,
  [8299] = 7499,
  [8300] = 8181,
  [8301] = 7390,
  [8302] = 7523,
  [8303] = 7492,
  [8304] = 7368,
  [8305] = 7380,
  [8306] = 8181,
  [8307] = 7415,
  [8308] = 7418,
  [8309] = 8181,
  [8310] = 7425,
  [8311] = 8311,
  [8312] = 8312,
  [8313] = 8313,
  [8314] = 7422,
  [8315] = 8315,
  [8316] = 8316,
  [8317] = 7495,
  [8318] = 8318,
  [8319] = 7390,
  [8320] = 8318,
  [8321] = 8315,
  [8322] = 8312,
  [8323] = 8323,
  [8324] = 7492,
  [8325] = 8316,
  [8326] = 7493,
  [8327] = 7496,
  [8328] = 8318,
  [8329] = 8329,
  [8330] = 8330,
  [8331] = 8318,
  [8332] = 8332,
  [8333] = 8315,
  [8334] = 8332,
  [8335] = 7415,
  [8336] = 8313,
  [8337] = 7508,
  [8338] = 7509,
  [8339] = 7510,
  [8340] = 7511,
  [8341] = 7512,
  [8342] = 7513,
  [8343] = 7418,
  [8344] = 8312,
  [8345] = 7437,
  [8346] = 8346,
  [8347] = 8347,
  [8348] = 8316,
  [8349] = 3122,
  [8350] = 7497,
  [8351] = 7523,
  [8352] = 8352,
  [8353] = 7422,
  [8354] = 8332,
  [8355] = 7492,
  [8356] = 8346,
  [8357] = 7574,
  [8358] = 7368,
  [8359] = 8332,
  [8360] = 8313,
  [8361] = 7425,
  [8362] = 7440,
  [8363] = 8347,
  [8364] = 8364,
  [8365] = 7513,
  [8366] = 7901,
  [8367] = 7509,
  [8368] = 7492,
  [8369] = 8313,
  [8370] = 8346,
  [8371] = 8371,
  [8372] = 8347,
  [8373] = 8312,
  [8374] = 8374,
  [8375] = 7500,
  [8376] = 8376,
  [8377] = 8377,
  [8378] = 8378,
  [8379] = 8323,
  [8380] = 8332,
  [8381] = 8346,
  [8382] = 7390,
  [8383] = 8383,
  [8384] = 8347,
  [8385] = 7944,
  [8386] = 8323,
  [8387] = 7368,
  [8388] = 8315,
  [8389] = 7380,
  [8390] = 7415,
  [8391] = 7418,
  [8392] = 7508,
  [8393] = 8393,
  [8394] = 7425,
  [8395] = 7509,
  [8396] = 7437,
  [8397] = 8313,
  [8398] = 7440,
  [8399] = 7510,
  [8400] = 8316,
  [8401] = 7511,
  [8402] = 7512,
  [8403] = 7513,
  [8404] = 7523,
  [8405] = 8405,
  [8406] = 8312,
  [8407] = 8316,
  [8408] = 8408,
  [8409] = 8409,
  [8410] = 8410,
  [8411] = 8411,
  [8412] = 8412,
  [8413] = 8312,
  [8414] = 8315,
  [8415] = 8415,
  [8416] = 7508,
  [8417] = 7509,
  [8418] = 7510,
  [8419] = 7511,
  [8420] = 7512,
  [8421] = 7513,
  [8422] = 8323,
  [8423] = 7498,
  [8424] = 7499,
  [8425] = 7523,
  [8426] = 7523,
  [8427] = 7390,
  [8428] = 7368,
  [8429] = 7380,
  [8430] = 7415,
  [8431] = 7418,
  [8432] = 7425,
  [8433] = 7437,
  [8434] = 7440,
  [8435] = 8316,
  [8436] = 8436,
  [8437] = 120,
  [8438] = 121,
  [8439] = 122,
  [8440] = 8313,
  [8441] = 115,
  [8442] = 7510,
  [8443] = 123,
  [8444] = 124,
  [8445] = 8323,
  [8446] = 8318,
  [8447] = 125,
  [8448] = 126,
  [8449] = 127,
  [8450] = 119,
  [8451] = 7574,
  [8452] = 128,
  [8453] = 118,
  [8454] = 8346,
  [8455] = 129,
  [8456] = 8315,
  [8457] = 8347,
  [8458] = 130,
  [8459] = 7380,
  [8460] = 7493,
  [8461] = 131,
  [8462] = 8323,
  [8463] = 7495,
  [8464] = 8318,
  [8465] = 7496,
  [8466] = 8315,
  [8467] = 7497,
  [8468] = 7998,
  [8469] = 7498,
  [8470] = 7499,
  [8471] = 8471,
  [8472] = 7500,
  [8473] = 7492,
  [8474] = 7493,
  [8475] = 7495,
  [8476] = 7496,
  [8477] = 7497,
  [8478] = 7498,
  [8479] = 7499,
  [8480] = 7500,
  [8481] = 8332,
  [8482] = 8346,
  [8483] = 8347,
  [8484] = 7574,
  [8485] = 8000,
  [8486] = 8313,
  [8487] = 8487,
  [8488] = 8488,
  [8489] = 8489,
  [8490] = 8332,
  [8491] = 8346,
  [8492] = 8312,
  [8493] = 8347,
  [8494] = 8494,
  [8495] = 8495,
  [8496] = 7900,
  [8497] = 8323,
  [8498] = 8316,
  [8499] = 8318,
  [8500] = 7511,
  [8501] = 8501,
  [8502] = 7523,
  [8503] = 7508,
  [8504] = 7512,
  [8505] = 7440,
  [8506] = 8506,
  [8507] = 7492,
  [8508] = 7418,
  [8509] = 7437,
  [8510] = 7523,
  [8511] = 8511,
  [8512] = 7495,
  [8513] = 7496,
  [8514] = 7497,
  [8515] = 7574,
  [8516] = 8511,
  [8517] = 7498,
  [8518] = 7499,
  [8519] = 7368,
  [8520] = 7767,
  [8521] = 7500,
  [8522] = 7380,
  [8523] = 7574,
  [8524] = 7425,
  [8525] = 8525,
  [8526] = 7492,
  [8527] = 8511,
  [8528] = 8511,
  [8529] = 7422,
  [8530] = 8511,
  [8531] = 8003,
  [8532] = 7422,
  [8533] = 8533,
  [8534] = 8534,
  [8535] = 8511,
  [8536] = 7390,
  [8537] = 8537,
  [8538] = 7574,
  [8539] = 7440,
  [8540] = 7493,
  [8541] = 7415,
  [8542] = 8542,
  [8543] = 7418,
  [8544] = 7508,
  [8545] = 7509,
  [8546] = 7510,
  [8547] = 7511,
  [8548] = 7512,
  [8549] = 7513,
  [8550] = 7437,
  [8551] = 7422,
  [8552] = 7493,
  [8553] = 7440,
  [8554] = 7523,
  [8555] = 7496,
  [8556] = 7497,
  [8557] = 7498,
  [8558] = 7499,
  [8559] = 7500,
  [8560] = 7492,
  [8561] = 8511,
  [8562] = 8562,
  [8563] = 7390,
  [8564] = 7415,
  [8565] = 7418,
  [8566] = 7574,
  [8567] = 7437,
  [8568] = 7390,
  [8569] = 8569,
  [8570] = 8511,
  [8571] = 8571,
  [8572] = 7368,
  [8573] = 7492,
  [8574] = 7493,
  [8575] = 7495,
  [8576] = 7496,
  [8577] = 7380,
  [8578] = 7497,
  [8579] = 7498,
  [8580] = 7499,
  [8581] = 7500,
  [8582] = 8511,
  [8583] = 7368,
  [8584] = 8511,
  [8585] = 7380,
  [8586] = 8511,
  [8587] = 8511,
  [8588] = 8511,
  [8589] = 7425,
  [8590] = 7425,
  [8591] = 8591,
  [8592] = 7422,
  [8593] = 7415,
  [8594] = 7495,
  [8595] = 7380,
  [8596] = 7508,
  [8597] = 7368,
  [8598] = 7415,
  [8599] = 7418,
  [8600] = 7437,
  [8601] = 8601,
  [8602] = 8602,
  [8603] = 7508,
  [8604] = 8601,
  [8605] = 7512,
  [8606] = 8601,
  [8607] = 7509,
  [8608] = 7498,
  [8609] = 7510,
  [8610] = 7368,
  [8611] = 7511,
  [8612] = 8602,
  [8613] = 7512,
  [8614] = 8602,
  [8615] = 7508,
  [8616] = 7509,
  [8617] = 7510,
  [8618] = 7511,
  [8619] = 7512,
  [8620] = 7513,
  [8621] = 7380,
  [8622] = 7513,
  [8623] = 7513,
  [8624] = 8601,
  [8625] = 8625,
  [8626] = 7510,
  [8627] = 7368,
  [8628] = 7901,
  [8629] = 7422,
  [8630] = 8601,
  [8631] = 7425,
  [8632] = 7523,
  [8633] = 8633,
  [8634] = 7499,
  [8635] = 8601,
  [8636] = 8601,
  [8637] = 8601,
  [8638] = 7511,
  [8639] = 7418,
  [8640] = 8601,
  [8641] = 8641,
  [8642] = 7380,
  [8643] = 7669,
  [8644] = 8601,
  [8645] = 7500,
  [8646] = 7944,
  [8647] = 8601,
  [8648] = 8648,
  [8649] = 8649,
  [8650] = 7574,
  [8651] = 7437,
  [8652] = 7368,
  [8653] = 7510,
  [8654] = 8633,
  [8655] = 8601,
  [8656] = 8641,
  [8657] = 7492,
  [8658] = 7900,
  [8659] = 7390,
  [8660] = 7493,
  [8661] = 7523,
  [8662] = 7512,
  [8663] = 7380,
  [8664] = 7390,
  [8665] = 7422,
  [8666] = 8601,
  [8667] = 7523,
  [8668] = 7574,
  [8669] = 8601,
  [8670] = 7425,
  [8671] = 8633,
  [8672] = 244,
  [8673] = 7574,
  [8674] = 8601,
  [8675] = 7425,
  [8676] = 8601,
  [8677] = 8601,
  [8678] = 7440,
  [8679] = 8601,
  [8680] = 8625,
  [8681] = 7415,
  [8682] = 7495,
  [8683] = 8633,
  [8684] = 8601,
  [8685] = 7496,
  [8686] = 7497,
  [8687] = 7630,
  [8688] = 7418,
  [8689] = 8601,
  [8690] = 8602,
  [8691] = 7390,
  [8692] = 7493,
  [8693] = 7495,
  [8694] = 7496,
  [8695] = 7497,
  [8696] = 243,
  [8697] = 7498,
  [8698] = 7499,
  [8699] = 7500,
  [8700] = 7437,
  [8701] = 7499,
  [8702] = 7500,
  [8703] = 7492,
  [8704] = 7422,
  [8705] = 8601,
  [8706] = 8601,
  [8707] = 7508,
  [8708] = 7509,
  [8709] = 7510,
  [8710] = 7511,
  [8711] = 7512,
  [8712] = 7513,
  [8713] = 7508,
  [8714] = 7509,
  [8715] = 7510,
  [8716] = 7511,
  [8717] = 7512,
  [8718] = 7513,
  [8719] = 8641,
  [8720] = 7415,
  [8721] = 8625,
  [8722] = 7509,
  [8723] = 8601,
  [8724] = 7998,
  [8725] = 8000,
  [8726] = 7425,
  [8727] = 8601,
  [8728] = 7523,
  [8729] = 8602,
  [8730] = 8625,
  [8731] = 8601,
  [8732] = 7511,
  [8733] = 7390,
  [8734] = 7440,
  [8735] = 7508,
  [8736] = 7509,
  [8737] = 8649,
  [8738] = 7510,
  [8739] = 7511,
  [8740] = 7440,
  [8741] = 8601,
  [8742] = 7512,
  [8743] = 8649,
  [8744] = 7493,
  [8745] = 7513,
  [8746] = 8601,
  [8747] = 7495,
  [8748] = 7496,
  [8749] = 7513,
  [8750] = 7574,
  [8751] = 8751,
  [8752] = 8601,
  [8753] = 7415,
  [8754] = 8601,
  [8755] = 7418,
  [8756] = 8756,
  [8757] = 8633,
  [8758] = 8641,
  [8759] = 8633,
  [8760] = 7497,
  [8761] = 7440,
  [8762] = 8633,
  [8763] = 8601,
  [8764] = 8602,
  [8765] = 7437,
  [8766] = 8602,
  [8767] = 8649,
  [8768] = 7508,
  [8769] = 8601,
  [8770] = 7509,
  [8771] = 7498,
  [8772] = 8772,
  [8773] = 8773,
  [8774] = 7854,
  [8775] = 8775,
  [8776] = 7864,
  [8777] = 7498,
  [8778] = 7499,
  [8779] = 7754,
  [8780] = 7500,
  [8781] = 3351,
  [8782] = 7508,
  [8783] = 8783,
  [8784] = 8784,
  [8785] = 8785,
  [8786] = 8786,
  [8787] = 7492,
  [8788] = 7493,
  [8789] = 8772,
  [8790] = 7495,
  [8791] = 7496,
  [8792] = 7497,
  [8793] = 7498,
  [8794] = 7499,
  [8795] = 8795,
  [8796] = 7500,
  [8797] = 8797,
  [8798] = 7493,
  [8799] = 7495,
  [8800] = 7496,
  [8801] = 7497,
  [8802] = 7498,
  [8803] = 7422,
  [8804] = 7499,
  [8805] = 7500,
  [8806] = 8806,
  [8807] = 7511,
  [8808] = 8808,
  [8809] = 8809,
  [8810] = 8810,
  [8811] = 7508,
  [8812] = 3239,
  [8813] = 8813,
  [8814] = 3201,
  [8815] = 8815,
  [8816] = 3198,
  [8817] = 7509,
  [8818] = 3252,
  [8819] = 7523,
  [8820] = 3167,
  [8821] = 7510,
  [8822] = 7574,
  [8823] = 8823,
  [8824] = 7511,
  [8825] = 8772,
  [8826] = 7512,
  [8827] = 7513,
  [8828] = 7512,
  [8829] = 7422,
  [8830] = 8830,
  [8831] = 7998,
  [8832] = 8000,
  [8833] = 7901,
  [8834] = 8806,
  [8835] = 7944,
  [8836] = 8836,
  [8837] = 7418,
  [8838] = 8838,
  [8839] = 7368,
  [8840] = 8840,
  [8841] = 8773,
  [8842] = 7440,
  [8843] = 7513,
  [8844] = 8844,
  [8845] = 8845,
  [8846] = 7630,
  [8847] = 8772,
  [8848] = 7523,
  [8849] = 8849,
  [8850] = 7492,
  [8851] = 7493,
  [8852] = 7495,
  [8853] = 7496,
  [8854] = 7497,
  [8855] = 7498,
  [8856] = 7380,
  [8857] = 7499,
  [8858] = 7500,
  [8859] = 8772,
  [8860] = 7390,
  [8861] = 8773,
  [8862] = 7415,
  [8863] = 7415,
  [8864] = 7418,
  [8865] = 7422,
  [8866] = 7437,
  [8867] = 8867,
  [8868] = 8844,
  [8869] = 7523,
  [8870] = 8870,
  [8871] = 8871,
  [8872] = 7368,
  [8873] = 7380,
  [8874] = 8806,
  [8875] = 7390,
  [8876] = 8876,
  [8877] = 7425,
  [8878] = 7425,
  [8879] = 7437,
  [8880] = 7440,
  [8881] = 7493,
  [8882] = 7780,
  [8883] = 7797,
  [8884] = 7492,
  [8885] = 7669,
  [8886] = 8772,
  [8887] = 7495,
  [8888] = 7496,
  [8889] = 7510,
  [8890] = 7497,
  [8891] = 8772,
  [8892] = 7509,
  [8893] = 8893,
  [8894] = 8773,
  [8895] = 8806,
  [8896] = 7574,
  [8897] = 7900,
  [8898] = 7510,
  [8899] = 8899,
  [8900] = 7500,
  [8901] = 8901,
  [8902] = 8899,
  [8903] = 7495,
  [8904] = 7496,
  [8905] = 7511,
  [8906] = 7497,
  [8907] = 8907,
  [8908] = 8899,
  [8909] = 8899,
  [8910] = 8899,
  [8911] = 8911,
  [8912] = 8912,
  [8913] = 7498,
  [8914] = 8899,
  [8915] = 8915,
  [8916] = 8916,
  [8917] = 7512,
  [8918] = 7523,
  [8919] = 8919,
  [8920] = 8901,
  [8921] = 7499,
  [8922] = 8916,
  [8923] = 8899,
  [8924] = 7523,
  [8925] = 7513,
  [8926] = 7508,
  [8927] = 3201,
  [8928] = 3167,
  [8929] = 3260,
  [8930] = 7500,
  [8931] = 8931,
  [8932] = 7492,
  [8933] = 8901,
  [8934] = 7574,
  [8935] = 8912,
  [8936] = 7495,
  [8937] = 8899,
  [8938] = 3198,
  [8939] = 8939,
  [8940] = 8899,
  [8941] = 8899,
  [8942] = 7390,
  [8943] = 7422,
  [8944] = 8916,
  [8945] = 8901,
  [8946] = 8916,
  [8947] = 8939,
  [8948] = 8939,
  [8949] = 7496,
  [8950] = 8950,
  [8951] = 8951,
  [8952] = 7574,
  [8953] = 7498,
  [8954] = 3351,
  [8955] = 7425,
  [8956] = 8899,
  [8957] = 8901,
  [8958] = 8916,
  [8959] = 8959,
  [8960] = 7499,
  [8961] = 3252,
  [8962] = 8899,
  [8963] = 7574,
  [8964] = 8901,
  [8965] = 8916,
  [8966] = 8899,
  [8967] = 7497,
  [8968] = 8939,
  [8969] = 7368,
  [8970] = 7523,
  [8971] = 8901,
  [8972] = 8916,
  [8973] = 3239,
  [8974] = 7380,
  [8975] = 8899,
  [8976] = 8899,
  [8977] = 8919,
  [8978] = 8899,
  [8979] = 8911,
  [8980] = 7440,
  [8981] = 8899,
  [8982] = 8899,
  [8983] = 7437,
  [8984] = 8984,
  [8985] = 7390,
  [8986] = 8912,
  [8987] = 8987,
  [8988] = 7368,
  [8989] = 8950,
  [8990] = 8899,
  [8991] = 7380,
  [8992] = 8950,
  [8993] = 7415,
  [8994] = 7418,
  [8995] = 8950,
  [8996] = 7508,
  [8997] = 8997,
  [8998] = 7425,
  [8999] = 7437,
  [9000] = 7509,
  [9001] = 8919,
  [9002] = 7511,
  [9003] = 7440,
  [9004] = 7512,
  [9005] = 7513,
  [9006] = 7509,
  [9007] = 8919,
  [9008] = 8899,
  [9009] = 8899,
  [9010] = 8899,
  [9011] = 7492,
  [9012] = 7493,
  [9013] = 8911,
  [9014] = 7415,
  [9015] = 8899,
  [9016] = 8899,
  [9017] = 8911,
  [9018] = 7492,
  [9019] = 7493,
  [9020] = 8912,
  [9021] = 7418,
  [9022] = 7510,
  [9023] = 8899,
  [9024] = 8899,
  [9025] = 9025,
  [9026] = 7390,
  [9027] = 9027,
  [9028] = 9028,
  [9029] = 9029,
  [9030] = 9030,
  [9031] = 9029,
  [9032] = 9032,
  [9033] = 9029,
  [9034] = 9034,
  [9035] = 9035,
  [9036] = 7368,
  [9037] = 9037,
  [9038] = 819,
  [9039] = 9039,
  [9040] = 7508,
  [9041] = 7440,
  [9042] = 7380,
  [9043] = 9043,
  [9044] = 7425,
  [9045] = 9045,
  [9046] = 9046,
  [9047] = 7440,
  [9048] = 9045,
  [9049] = 9049,
  [9050] = 9050,
  [9051] = 9051,
  [9052] = 9052,
  [9053] = 9053,
  [9054] = 9029,
  [9055] = 7509,
  [9056] = 9056,
  [9057] = 7574,
  [9058] = 9058,
  [9059] = 7390,
  [9060] = 9029,
  [9061] = 9043,
  [9062] = 7492,
  [9063] = 7510,
  [9064] = 9029,
  [9065] = 9053,
  [9066] = 9066,
  [9067] = 7510,
  [9068] = 9068,
  [9069] = 9069,
  [9070] = 7508,
  [9071] = 7511,
  [9072] = 7493,
  [9073] = 7492,
  [9074] = 9046,
  [9075] = 9075,
  [9076] = 7512,
  [9077] = 9066,
  [9078] = 7493,
  [9079] = 7495,
  [9080] = 7513,
  [9081] = 9081,
  [9082] = 9082,
  [9083] = 9083,
  [9084] = 3260,
  [9085] = 9085,
  [9086] = 7368,
  [9087] = 9046,
  [9088] = 9029,
  [9089] = 7415,
  [9090] = 7418,
  [9091] = 7496,
  [9092] = 9043,
  [9093] = 7497,
  [9094] = 7498,
  [9095] = 7499,
  [9096] = 9096,
  [9097] = 7500,
  [9098] = 9029,
  [9099] = 9025,
  [9100] = 3351,
  [9101] = 9101,
  [9102] = 9102,
  [9103] = 9103,
  [9104] = 9029,
  [9105] = 7495,
  [9106] = 9032,
  [9107] = 8024,
  [9108] = 7496,
  [9109] = 9025,
  [9110] = 9046,
  [9111] = 7425,
  [9112] = 7497,
  [9113] = 7415,
  [9114] = 7437,
  [9115] = 9115,
  [9116] = 9025,
  [9117] = 7437,
  [9118] = 9051,
  [9119] = 9029,
  [9120] = 8031,
  [9121] = 7418,
  [9122] = 9029,
  [9123] = 9029,
  [9124] = 9030,
  [9125] = 9029,
  [9126] = 3351,
  [9127] = 9127,
  [9128] = 9128,
  [9129] = 7498,
  [9130] = 9130,
  [9131] = 9053,
  [9132] = 9027,
  [9133] = 7440,
  [9134] = 9056,
  [9135] = 7499,
  [9136] = 7437,
  [9137] = 9137,
  [9138] = 9066,
  [9139] = 9052,
  [9140] = 9140,
  [9141] = 9052,
  [9142] = 7511,
  [9143] = 9103,
  [9144] = 9030,
  [9145] = 9028,
  [9146] = 9146,
  [9147] = 7574,
  [9148] = 7380,
  [9149] = 9032,
  [9150] = 762,
  [9151] = 9029,
  [9152] = 9152,
  [9153] = 9153,
  [9154] = 7574,
  [9155] = 9029,
  [9156] = 9029,
  [9157] = 9058,
  [9158] = 9029,
  [9159] = 7512,
  [9160] = 9029,
  [9161] = 9029,
  [9162] = 9051,
  [9163] = 9049,
  [9164] = 7500,
  [9165] = 7425,
  [9166] = 9029,
  [9167] = 9167,
  [9168] = 9056,
  [9169] = 9029,
  [9170] = 7509,
  [9171] = 9050,
  [9172] = 9025,
  [9173] = 9029,
  [9174] = 9045,
  [9175] = 9039,
  [9176] = 9029,
  [9177] = 9177,
  [9178] = 9027,
  [9179] = 7523,
  [9180] = 9049,
  [9181] = 9050,
  [9182] = 7508,
  [9183] = 9046,
  [9184] = 7509,
  [9185] = 7510,
  [9186] = 7511,
  [9187] = 7368,
  [9188] = 7512,
  [9189] = 7513,
  [9190] = 8087,
  [9191] = 9058,
  [9192] = 7492,
  [9193] = 9028,
  [9194] = 9039,
  [9195] = 9029,
  [9196] = 9025,
  [9197] = 9046,
  [9198] = 7380,
  [9199] = 7415,
  [9200] = 7418,
  [9201] = 9025,
  [9202] = 9046,
  [9203] = 9029,
  [9204] = 9029,
  [9205] = 9103,
  [9206] = 7390,
  [9207] = 7513,
  [9208] = 9208,
  [9209] = 7497,
  [9210] = 9210,
  [9211] = 7495,
  [9212] = 7499,
  [9213] = 9213,
  [9214] = 9214,
  [9215] = 7496,
  [9216] = 7497,
  [9217] = 9210,
  [9218] = 9213,
  [9219] = 9213,
  [9220] = 9220,
  [9221] = 9213,
  [9222] = 7497,
  [9223] = 9220,
  [9224] = 7493,
  [9225] = 7498,
  [9226] = 9210,
  [9227] = 7498,
  [9228] = 7499,
  [9229] = 7574,
  [9230] = 9230,
  [9231] = 7495,
  [9232] = 7499,
  [9233] = 9233,
  [9234] = 9234,
  [9235] = 9220,
  [9236] = 9236,
  [9237] = 9230,
  [9238] = 7498,
  [9239] = 7500,
  [9240] = 9213,
  [9241] = 9210,
  [9242] = 7496,
  [9243] = 9243,
  [9244] = 2699,
  [9245] = 9220,
  [9246] = 9246,
  [9247] = 9213,
  [9248] = 9248,
  [9249] = 9243,
  [9250] = 3329,
  [9251] = 3351,
  [9252] = 9210,
  [9253] = 9220,
  [9254] = 9208,
  [9255] = 9236,
  [9256] = 9256,
  [9257] = 9243,
  [9258] = 9243,
  [9259] = 9259,
  [9260] = 9260,
  [9261] = 9261,
  [9262] = 9262,
  [9263] = 9263,
  [9264] = 7500,
  [9265] = 9263,
  [9266] = 9243,
  [9267] = 7630,
  [9268] = 7493,
  [9269] = 9269,
  [9270] = 9270,
  [9271] = 9210,
  [9272] = 9213,
  [9273] = 9273,
  [9274] = 9208,
  [9275] = 7500,
  [9276] = 9243,
  [9277] = 9277,
  [9278] = 3351,
  [9279] = 9208,
  [9280] = 9208,
  [9281] = 9281,
  [9282] = 9282,
  [9283] = 9283,
  [9284] = 9220,
  [9285] = 9210,
  [9286] = 9263,
  [9287] = 9287,
  [9288] = 9220,
  [9289] = 9213,
  [9290] = 9236,
  [9291] = 9220,
  [9292] = 7495,
  [9293] = 7574,
  [9294] = 9208,
  [9295] = 9295,
  [9296] = 7493,
  [9297] = 9220,
  [9298] = 9243,
  [9299] = 7574,
  [9300] = 7496,
  [9301] = 9208,
  [9302] = 9236,
  [9303] = 9303,
  [9304] = 9304,
  [9305] = 9263,
  [9306] = 9208,
  [9307] = 9210,
  [9308] = 9210,
  [9309] = 9208,
  [9310] = 9213,
  [9311] = 9283,
  [9312] = 9312,
  [9313] = 9313,
  [9314] = 9263,
  [9315] = 9243,
  [9316] = 2697,
  [9317] = 9243,
  [9318] = 9318,
  [9319] = 9319,
  [9320] = 9320,
  [9321] = 9321,
  [9322] = 9322,
  [9323] = 9323,
  [9324] = 9323,
  [9325] = 9325,
  [9326] = 9326,
  [9327] = 9318,
  [9328] = 9328,
  [9329] = 9329,
  [9330] = 9326,
  [9331] = 9318,
  [9332] = 9326,
  [9333] = 9318,
  [9334] = 9334,
  [9335] = 9335,
  [9336] = 9336,
  [9337] = 9326,
  [9338] = 9326,
  [9339] = 9318,
  [9340] = 9340,
  [9341] = 9341,
  [9342] = 9342,
  [9343] = 9318,
  [9344] = 9326,
  [9345] = 9318,
  [9346] = 9346,
  [9347] = 9347,
  [9348] = 9326,
  [9349] = 9318,
  [9350] = 9350,
  [9351] = 9326,
  [9352] = 9318,
  [9353] = 3351,
  [9354] = 9354,
  [9355] = 9355,
  [9356] = 9356,
  [9357] = 9319,
  [9358] = 9358,
  [9359] = 9325,
  [9360] = 9360,
  [9361] = 9361,
  [9362] = 9362,
  [9363] = 9363,
  [9364] = 9334,
  [9365] = 9325,
  [9366] = 9366,
  [9367] = 9367,
  [9368] = 9320,
  [9369] = 9323,
  [9370] = 9370,
  [9371] = 9346,
  [9372] = 9325,
  [9373] = 9373,
  [9374] = 9334,
  [9375] = 9375,
  [9376] = 9376,
  [9377] = 9370,
  [9378] = 9334,
  [9379] = 9379,
  [9380] = 9379,
  [9381] = 9362,
  [9382] = 9336,
  [9383] = 9342,
  [9384] = 9361,
  [9385] = 9326,
  [9386] = 9373,
  [9387] = 9387,
  [9388] = 9388,
  [9389] = 9318,
  [9390] = 9319,
  [9391] = 9391,
  [9392] = 9361,
  [9393] = 9393,
  [9394] = 9394,
  [9395] = 9363,
  [9396] = 9379,
  [9397] = 9336,
  [9398] = 9342,
  [9399] = 9319,
  [9400] = 9361,
  [9401] = 9366,
  [9402] = 9367,
  [9403] = 9326,
  [9404] = 9367,
  [9405] = 9320,
  [9406] = 9323,
  [9407] = 9326,
  [9408] = 9320,
  [9409] = 9323,
  [9410] = 9346,
  [9411] = 9411,
  [9412] = 9412,
  [9413] = 9413,
  [9414] = 9335,
  [9415] = 9370,
  [9416] = 9416,
  [9417] = 9417,
  [9418] = 9379,
  [9419] = 9346,
  [9420] = 9420,
  [9421] = 9421,
  [9422] = 9387,
  [9423] = 9326,
  [9424] = 9362,
  [9425] = 9366,
  [9426] = 9387,
  [9427] = 9388,
  [9428] = 7630,
  [9429] = 9370,
  [9430] = 9318,
  [9431] = 9325,
  [9432] = 9334,
  [9433] = 9379,
  [9434] = 9366,
  [9435] = 9318,
  [9436] = 9336,
  [9437] = 9342,
  [9438] = 9319,
  [9439] = 9379,
  [9440] = 9367,
  [9441] = 9320,
  [9442] = 9323,
  [9443] = 9346,
  [9444] = 9444,
  [9445] = 9445,
  [9446] = 9379,
  [9447] = 9362,
  [9448] = 9366,
  [9449] = 9326,
  [9450] = 9318,
  [9451] = 9362,
  [9452] = 9366,
  [9453] = 9453,
  [9454] = 9320,
  [9455] = 9336,
  [9456] = 9342,
  [9457] = 9326,
  [9458] = 9323,
  [9459] = 9319,
  [9460] = 9362,
  [9461] = 9326,
  [9462] = 9366,
  [9463] = 9367,
  [9464] = 9367,
  [9465] = 9320,
  [9466] = 9323,
  [9467] = 9346,
  [9468] = 9319,
  [9469] = 9362,
  [9470] = 9387,
  [9471] = 9379,
  [9472] = 9472,
  [9473] = 9388,
  [9474] = 9335,
  [9475] = 9475,
  [9476] = 9346,
  [9477] = 9326,
  [9478] = 9319,
  [9479] = 9318,
  [9480] = 9318,
  [9481] = 9481,
  [9482] = 9482,
  [9483] = 9361,
  [9484] = 9484,
  [9485] = 9485,
  [9486] = 9363,
  [9487] = 9319,
  [9488] = 9488,
  [9489] = 9370,
  [9490] = 9367,
  [9491] = 9320,
  [9492] = 9323,
  [9493] = 9493,
  [9494] = 9379,
  [9495] = 9495,
  [9496] = 9496,
  [9497] = 9367,
  [9498] = 9326,
  [9499] = 9318,
  [9500] = 9500,
  [9501] = 9320,
  [9502] = 9416,
  [9503] = 9323,
  [9504] = 9318,
  [9505] = 9373,
  [9506] = 9346,
  [9507] = 9319,
  [9508] = 9319,
  [9509] = 9367,
  [9510] = 9320,
  [9511] = 9323,
  [9512] = 9379,
  [9513] = 9387,
  [9514] = 9370,
  [9515] = 9326,
  [9516] = 9318,
  [9517] = 9517,
  [9518] = 9325,
  [9519] = 9334,
  [9520] = 9319,
  [9521] = 9370,
  [9522] = 9522,
  [9523] = 9367,
  [9524] = 9320,
  [9525] = 9323,
  [9526] = 9361,
  [9527] = 9527,
  [9528] = 9379,
  [9529] = 9529,
  [9530] = 9379,
  [9531] = 9326,
  [9532] = 9318,
  [9533] = 9319,
  [9534] = 9335,
  [9535] = 9500,
  [9536] = 9323,
  [9537] = 9326,
  [9538] = 9318,
  [9539] = 9539,
  [9540] = 9319,
  [9541] = 9346,
  [9542] = 9323,
  [9543] = 9363,
  [9544] = 9544,
  [9545] = 9387,
  [9546] = 9500,
  [9547] = 9416,
  [9548] = 9373,
  [9549] = 9336,
  [9550] = 9326,
  [9551] = 9342,
  [9552] = 9318,
  [9553] = 9319,
  [9554] = 9323,
  [9555] = 9326,
  [9556] = 9500,
  [9557] = 9373,
  [9558] = 9326,
  [9559] = 9318,
  [9560] = 9500,
  [9561] = 9373,
  [9562] = 9319,
  [9563] = 9387,
  [9564] = 9388,
  [9565] = 9500,
  [9566] = 9373,
  [9567] = 9323,
  [9568] = 9388,
  [9569] = 9500,
  [9570] = 9373,
  [9571] = 9367,
  [9572] = 9326,
  [9573] = 9363,
  [9574] = 9500,
  [9575] = 9373,
  [9576] = 9318,
  [9577] = 9500,
  [9578] = 9318,
  [9579] = 9367,
  [9580] = 9319,
  [9581] = 9379,
  [9582] = 9323,
  [9583] = 9319,
  [9584] = 9326,
  [9585] = 9318,
  [9586] = 9361,
  [9587] = 9587,
  [9588] = 9367,
  [9589] = 9379,
  [9590] = 9590,
  [9591] = 9363,
  [9592] = 9367,
  [9593] = 9379,
  [9594] = 9319,
  [9595] = 9388,
  [9596] = 9323,
  [9597] = 9367,
  [9598] = 9326,
  [9599] = 9320,
  [9600] = 9323,
  [9601] = 9318,
  [9602] = 9602,
  [9603] = 9603,
  [9604] = 9604,
  [9605] = 9605,
  [9606] = 9606,
  [9607] = 9603,
  [9608] = 9608,
  [9609] = 9609,
  [9610] = 9610,
  [9611] = 9611,
  [9612] = 9612,
  [9613] = 9613,
  [9614] = 9614,
  [9615] = 9615,
  [9616] = 9616,
  [9617] = 9606,
  [9618] = 9609,
  [9619] = 9609,
  [9620] = 9620,
  [9621] = 9621,
  [9622] = 9622,
  [9623] = 9623,
  [9624] = 9624,
  [9625] = 9625,
  [9626] = 9626,
  [9627] = 9627,
  [9628] = 9628,
  [9629] = 9629,
  [9630] = 9630,
  [9631] = 9631,
  [9632] = 9621,
  [9633] = 9633,
  [9634] = 9626,
  [9635] = 9635,
  [9636] = 9636,
  [9637] = 9637,
  [9638] = 9638,
  [9639] = 9639,
  [9640] = 9640,
  [9641] = 9641,
  [9642] = 9642,
  [9643] = 9643,
  [9644] = 9644,
  [9645] = 9628,
  [9646] = 9610,
  [9647] = 9609,
  [9648] = 9648,
  [9649] = 9603,
  [9650] = 9608,
  [9651] = 9629,
  [9652] = 9630,
  [9653] = 9653,
  [9654] = 9654,
  [9655] = 9655,
  [9656] = 9637,
  [9657] = 9605,
  [9658] = 8867,
  [9659] = 9631,
  [9660] = 9635,
  [9661] = 9661,
  [9662] = 9638,
  [9663] = 9663,
  [9664] = 9664,
  [9665] = 9603,
  [9666] = 9615,
  [9667] = 9620,
  [9668] = 9627,
  [9669] = 9669,
  [9670] = 9608,
  [9671] = 9671,
  [9672] = 9642,
  [9673] = 9640,
  [9674] = 9641,
  [9675] = 9637,
  [9676] = 9638,
  [9677] = 9642,
  [9678] = 9678,
  [9679] = 9648,
  [9680] = 9680,
  [9681] = 9605,
  [9682] = 9682,
  [9683] = 9606,
  [9684] = 9635,
  [9685] = 9626,
  [9686] = 9686,
  [9687] = 9629,
  [9688] = 9610,
  [9689] = 9636,
  [9690] = 9603,
  [9691] = 9608,
  [9692] = 9692,
  [9693] = 9693,
  [9694] = 9639,
  [9695] = 9643,
  [9696] = 9644,
  [9697] = 9697,
  [9698] = 9698,
  [9699] = 9615,
  [9700] = 9610,
  [9701] = 9643,
  [9702] = 9697,
  [9703] = 9620,
  [9704] = 9627,
  [9705] = 9644,
  [9706] = 9706,
  [9707] = 9637,
  [9708] = 9638,
  [9709] = 9642,
  [9710] = 9610,
  [9711] = 9711,
  [9712] = 9603,
  [9713] = 9648,
  [9714] = 9608,
  [9715] = 9682,
  [9716] = 9603,
  [9717] = 9608,
  [9718] = 9605,
  [9719] = 9635,
  [9720] = 9698,
  [9721] = 9721,
  [9722] = 9722,
  [9723] = 9722,
  [9724] = 9724,
  [9725] = 9626,
  [9726] = 9711,
  [9727] = 9663,
  [9728] = 9728,
  [9729] = 9610,
  [9730] = 9615,
  [9731] = 9613,
  [9732] = 9614,
  [9733] = 9678,
  [9734] = 9603,
  [9735] = 9735,
  [9736] = 9648,
  [9737] = 9608,
  [9738] = 9640,
  [9739] = 9620,
  [9740] = 9615,
  [9741] = 9621,
  [9742] = 9742,
  [9743] = 9626,
  [9744] = 9641,
  [9745] = 9654,
  [9746] = 9628,
  [9747] = 9629,
  [9748] = 9698,
  [9749] = 9630,
  [9750] = 9620,
  [9751] = 9631,
  [9752] = 9637,
  [9753] = 9753,
  [9754] = 9605,
  [9755] = 9627,
  [9756] = 9756,
  [9757] = 9661,
  [9758] = 9758,
  [9759] = 9759,
  [9760] = 9664,
  [9761] = 9669,
  [9762] = 9636,
  [9763] = 9722,
  [9764] = 9764,
  [9765] = 9643,
  [9766] = 9644,
  [9767] = 9610,
  [9768] = 9637,
  [9769] = 9625,
  [9770] = 9638,
  [9771] = 9603,
  [9772] = 9608,
  [9773] = 9764,
  [9774] = 9671,
  [9775] = 9642,
  [9776] = 9654,
  [9777] = 9682,
  [9778] = 9648,
  [9779] = 9638,
  [9780] = 9642,
  [9781] = 9781,
  [9782] = 9605,
  [9783] = 9663,
  [9784] = 9635,
  [9785] = 9664,
  [9786] = 9627,
  [9787] = 9615,
  [9788] = 9620,
  [9789] = 9627,
  [9790] = 9669,
  [9791] = 9671,
  [9792] = 9613,
  [9793] = 9622,
  [9794] = 9614,
  [9795] = 9640,
  [9796] = 9636,
  [9797] = 9641,
  [9798] = 9637,
  [9799] = 9606,
  [9800] = 9635,
  [9801] = 9637,
  [9802] = 9638,
  [9803] = 9642,
  [9804] = 9638,
  [9805] = 9609,
  [9806] = 9678,
  [9807] = 9648,
  [9808] = 9605,
  [9809] = 9635,
  [9810] = 9663,
  [9811] = 9664,
  [9812] = 9812,
  [9813] = 9626,
  [9814] = 9615,
  [9815] = 9615,
  [9816] = 9620,
  [9817] = 9627,
  [9818] = 9818,
  [9819] = 9819,
  [9820] = 9669,
  [9821] = 9671,
  [9822] = 9636,
  [9823] = 9610,
  [9824] = 9642,
  [9825] = 9825,
  [9826] = 9640,
  [9827] = 9641,
  [9828] = 9637,
  [9829] = 9638,
  [9830] = 9642,
  [9831] = 9831,
  [9832] = 9603,
  [9833] = 9833,
  [9834] = 9608,
  [9835] = 356,
  [9836] = 9693,
  [9837] = 9678,
  [9838] = 9697,
  [9839] = 9648,
  [9840] = 9605,
  [9841] = 9648,
  [9842] = 9615,
  [9843] = 9620,
  [9844] = 9682,
  [9845] = 9711,
  [9846] = 9635,
  [9847] = 9621,
  [9848] = 9627,
  [9849] = 9698,
  [9850] = 9630,
  [9851] = 9639,
  [9852] = 9852,
  [9853] = 9722,
  [9854] = 9722,
  [9855] = 9756,
  [9856] = 9756,
  [9857] = 9626,
  [9858] = 9661,
  [9859] = 9637,
  [9860] = 9759,
  [9861] = 9613,
  [9862] = 9638,
  [9863] = 9863,
  [9864] = 9864,
  [9865] = 9625,
  [9866] = 9642,
  [9867] = 9626,
  [9868] = 9764,
  [9869] = 9628,
  [9870] = 9870,
  [9871] = 9629,
  [9872] = 9630,
  [9873] = 9873,
  [9874] = 9648,
  [9875] = 9655,
  [9876] = 9628,
  [9877] = 9629,
  [9878] = 9630,
  [9879] = 9879,
  [9880] = 9880,
  [9881] = 9623,
  [9882] = 9631,
  [9883] = 9883,
  [9884] = 9884,
  [9885] = 9610,
  [9886] = 9605,
  [9887] = 9648,
  [9888] = 9608,
  [9889] = 9889,
  [9890] = 9621,
  [9891] = 9605,
  [9892] = 9615,
  [9893] = 9620,
  [9894] = 9627,
  [9895] = 9669,
  [9896] = 9671,
  [9897] = 9637,
  [9898] = 9638,
  [9899] = 9642,
  [9900] = 9648,
  [9901] = 9605,
  [9902] = 9756,
  [9903] = 9759,
  [9904] = 9635,
  [9905] = 9625,
  [9906] = 9635,
  [9907] = 9626,
  [9908] = 9631,
  [9909] = 9909,
  [9910] = 9643,
  [9911] = 9911,
  [9912] = 9636,
  [9913] = 9626,
  [9914] = 9620,
  [9915] = 9693,
  [9916] = 9759,
  [9917] = 9639,
  [9918] = 9644,
  [9919] = 9623,
  [9920] = 9610,
  [9921] = 9610,
  [9922] = 9922,
  [9923] = 9603,
  [9924] = 9608,
  [9925] = 9635,
  [9926] = 9603,
  [9927] = 346,
  [9928] = 9756,
  [9929] = 9759,
  [9930] = 9930,
  [9931] = 9643,
  [9932] = 9644,
  [9933] = 9625,
  [9934] = 9608,
  [9935] = 9610,
  [9936] = 9615,
  [9937] = 9603,
  [9938] = 9608,
  [9939] = 9697,
  [9940] = 9620,
  [9941] = 9722,
  [9942] = 9627,
  [9943] = 9742,
  [9944] = 9614,
  [9945] = 9637,
  [9946] = 9946,
  [9947] = 9638,
  [9948] = 9654,
  [9949] = 9698,
  [9950] = 9642,
  [9951] = 9722,
  [9952] = 9952,
  [9953] = 9756,
  [9954] = 9759,
  [9955] = 9613,
  [9956] = 9625,
  [9957] = 9648,
  [9958] = 9605,
  [9959] = 9635,
  [9960] = 9960,
  [9961] = 9698,
  [9962] = 9626,
  [9963] = 9963,
  [9964] = 9964,
  [9965] = 9628,
  [9966] = 9629,
  [9967] = 9630,
  [9968] = 9968,
  [9969] = 9635,
  [9970] = 9627,
  [9971] = 9626,
  [9972] = 9756,
  [9973] = 9759,
  [9974] = 9610,
  [9975] = 9610,
  [9976] = 9603,
  [9977] = 9608,
  [9978] = 9722,
  [9979] = 9979,
  [9980] = 9603,
  [9981] = 9615,
  [9982] = 9620,
  [9983] = 9627,
  [9984] = 9669,
  [9985] = 9663,
  [9986] = 9671,
  [9987] = 9756,
  [9988] = 9759,
  [9989] = 9664,
  [9990] = 9608,
  [9991] = 9722,
  [9992] = 9615,
  [9993] = 9620,
  [9994] = 9627,
  [9995] = 9995,
  [9996] = 9669,
  [9997] = 9671,
  [9998] = 9637,
  [9999] = 9638,
  [10000] = 9642,
  [10001] = 9648,
  [10002] = 10002,
  [10003] = 9759,
  [10004] = 9605,
  [10005] = 9635,
  [10006] = 9655,
  [10007] = 9615,
  [10008] = 9621,
  [10009] = 9620,
  [10010] = 9759,
  [10011] = 9627,
  [10012] = 9711,
  [10013] = 9759,
  [10014] = 9742,
  [10015] = 9610,
  [10016] = 9641,
  [10017] = 9637,
  [10018] = 9638,
  [10019] = 9642,
  [10020] = 9764,
  [10021] = 9742,
  [10022] = 9637,
  [10023] = 10023,
  [10024] = 10024,
  [10025] = 9638,
  [10026] = 9678,
  [10027] = 9648,
  [10028] = 9605,
  [10029] = 9642,
  [10030] = 9648,
  [10031] = 9697,
  [10032] = 9682,
  [10033] = 9635,
  [10034] = 9654,
  [10035] = 9952,
  [10036] = 9605,
  [10037] = 9635,
  [10038] = 9663,
  [10039] = 9722,
  [10040] = 9626,
  [10041] = 10041,
  [10042] = 10042,
  [10043] = 10043,
  [10044] = 10044,
  [10045] = 9664,
  [10046] = 9626,
  [10047] = 10047,
  [10048] = 10048,
  [10049] = 9764,
  [10050] = 9610,
  [10051] = 9669,
  [10052] = 9603,
  [10053] = 9608,
  [10054] = 10054,
  [10055] = 9654,
  [10056] = 9615,
  [10057] = 10057,
  [10058] = 10058,
  [10059] = 9620,
  [10060] = 9756,
  [10061] = 9627,
  [10062] = 9637,
  [10063] = 9638,
  [10064] = 9661,
  [10065] = 9642,
  [10066] = 9648,
  [10067] = 9605,
  [10068] = 9952,
  [10069] = 9635,
  [10070] = 10070,
  [10071] = 331,
  [10072] = 9711,
  [10073] = 10073,
  [10074] = 10074,
  [10075] = 9759,
  [10076] = 9615,
  [10077] = 9698,
  [10078] = 10078,
  [10079] = 9722,
  [10080] = 9722,
  [10081] = 10081,
  [10082] = 9671,
  [10083] = 9697,
  [10084] = 9722,
  [10085] = 9626,
  [10086] = 10086,
  [10087] = 10087,
  [10088] = 9628,
  [10089] = 9620,
  [10090] = 10090,
  [10091] = 9626,
  [10092] = 9610,
  [10093] = 9610,
  [10094] = 10094,
  [10095] = 9603,
  [10096] = 9608,
  [10097] = 10097,
  [10098] = 3473,
  [10099] = 9615,
  [10100] = 9620,
  [10101] = 9627,
  [10102] = 9629,
  [10103] = 9613,
  [10104] = 3407,
  [10105] = 9637,
  [10106] = 9638,
  [10107] = 9642,
  [10108] = 9648,
  [10109] = 9960,
  [10110] = 9605,
  [10111] = 9635,
  [10112] = 9614,
  [10113] = 9603,
  [10114] = 9608,
  [10115] = 10115,
  [10116] = 10116,
  [10117] = 9609,
  [10118] = 10118,
  [10119] = 9680,
  [10120] = 9722,
  [10121] = 9630,
  [10122] = 10122,
  [10123] = 10123,
  [10124] = 9626,
  [10125] = 9626,
  [10126] = 9610,
  [10127] = 9603,
  [10128] = 9608,
  [10129] = 9621,
  [10130] = 10130,
  [10131] = 9615,
  [10132] = 9620,
  [10133] = 9627,
  [10134] = 9637,
  [10135] = 9638,
  [10136] = 9642,
  [10137] = 9648,
  [10138] = 9605,
  [10139] = 9635,
  [10140] = 9626,
  [10141] = 9661,
  [10142] = 9627,
  [10143] = 9678,
  [10144] = 10144,
  [10145] = 9615,
  [10146] = 10146,
  [10147] = 9648,
  [10148] = 9628,
  [10149] = 9620,
  [10150] = 9722,
  [10151] = 9629,
  [10152] = 3351,
  [10153] = 10153,
  [10154] = 9630,
  [10155] = 9626,
  [10156] = 9631,
  [10157] = 9610,
  [10158] = 9603,
  [10159] = 9608,
  [10160] = 9613,
  [10161] = 9883,
  [10162] = 9615,
  [10163] = 9620,
  [10164] = 9627,
  [10165] = 9625,
  [10166] = 9637,
  [10167] = 9638,
  [10168] = 9642,
  [10169] = 9648,
  [10170] = 9605,
  [10171] = 9635,
  [10172] = 9883,
  [10173] = 9605,
  [10174] = 9627,
  [10175] = 10175,
  [10176] = 10176,
  [10177] = 9693,
  [10178] = 9722,
  [10179] = 9655,
  [10180] = 10180,
  [10181] = 9637,
  [10182] = 10182,
  [10183] = 9614,
  [10184] = 9722,
  [10185] = 9626,
  [10186] = 9636,
  [10187] = 9764,
  [10188] = 9610,
  [10189] = 9698,
  [10190] = 9603,
  [10191] = 9608,
  [10192] = 10192,
  [10193] = 3390,
  [10194] = 9615,
  [10195] = 9620,
  [10196] = 9627,
  [10197] = 9637,
  [10198] = 9638,
  [10199] = 9642,
  [10200] = 9648,
  [10201] = 9639,
  [10202] = 9605,
  [10203] = 9635,
  [10204] = 9697,
  [10205] = 3394,
  [10206] = 10206,
  [10207] = 9643,
  [10208] = 9644,
  [10209] = 10209,
  [10210] = 10210,
  [10211] = 9722,
  [10212] = 9610,
  [10213] = 9628,
  [10214] = 9603,
  [10215] = 9608,
  [10216] = 10216,
  [10217] = 9626,
  [10218] = 9638,
  [10219] = 9610,
  [10220] = 10220,
  [10221] = 9603,
  [10222] = 9608,
  [10223] = 9615,
  [10224] = 9620,
  [10225] = 9627,
  [10226] = 9637,
  [10227] = 9638,
  [10228] = 9642,
  [10229] = 9648,
  [10230] = 9960,
  [10231] = 9654,
  [10232] = 9642,
  [10233] = 9697,
  [10234] = 9605,
  [10235] = 9635,
  [10236] = 9648,
  [10237] = 10237,
  [10238] = 10238,
  [10239] = 9639,
  [10240] = 9722,
  [10241] = 9626,
  [10242] = 3381,
  [10243] = 9610,
  [10244] = 3479,
  [10245] = 9603,
  [10246] = 9608,
  [10247] = 9613,
  [10248] = 9663,
  [10249] = 9605,
  [10250] = 9615,
  [10251] = 9620,
  [10252] = 9627,
  [10253] = 9664,
  [10254] = 9635,
  [10255] = 9637,
  [10256] = 9638,
  [10257] = 9642,
  [10258] = 9648,
  [10259] = 9615,
  [10260] = 9711,
  [10261] = 9605,
  [10262] = 9635,
  [10263] = 9620,
  [10264] = 3411,
  [10265] = 3412,
  [10266] = 9627,
  [10267] = 9669,
  [10268] = 10268,
  [10269] = 3380,
  [10270] = 10270,
  [10271] = 10271,
  [10272] = 9671,
  [10273] = 9722,
  [10274] = 10274,
  [10275] = 10275,
  [10276] = 9626,
  [10277] = 9661,
  [10278] = 9640,
  [10279] = 9641,
  [10280] = 9631,
  [10281] = 9711,
  [10282] = 9610,
  [10283] = 3428,
  [10284] = 9603,
  [10285] = 9608,
  [10286] = 9637,
  [10287] = 9638,
  [10288] = 9615,
  [10289] = 9620,
  [10290] = 9627,
  [10291] = 9680,
  [10292] = 9613,
  [10293] = 9642,
  [10294] = 9722,
  [10295] = 9637,
  [10296] = 9638,
  [10297] = 9642,
  [10298] = 9648,
  [10299] = 9605,
  [10300] = 9698,
  [10301] = 9614,
  [10302] = 9635,
  [10303] = 10303,
  [10304] = 10304,
  [10305] = 9697,
  [10306] = 10306,
  [10307] = 10307,
  [10308] = 9722,
  [10309] = 9678,
  [10310] = 9626,
  [10311] = 9648,
  [10312] = 9680,
  [10313] = 9605,
  [10314] = 9682,
  [10315] = 9610,
  [10316] = 10316,
  [10317] = 9603,
  [10318] = 9608,
  [10319] = 9722,
  [10320] = 9622,
  [10321] = 9635,
  [10322] = 10322,
  [10323] = 9615,
  [10324] = 9620,
  [10325] = 9642,
  [10326] = 9627,
  [10327] = 9711,
  [10328] = 9637,
  [10329] = 9626,
  [10330] = 9638,
  [10331] = 9640,
  [10332] = 10332,
  [10333] = 10333,
  [10334] = 10334,
  [10335] = 10334,
  [10336] = 10336,
  [10337] = 10337,
  [10338] = 10338,
  [10339] = 10339,
  [10340] = 10340,
  [10341] = 10341,
  [10342] = 10342,
  [10343] = 10343,
  [10344] = 10344,
  [10345] = 10338,
  [10346] = 10346,
  [10347] = 10347,
  [10348] = 10337,
  [10349] = 10349,
  [10350] = 10350,
  [10351] = 10336,
  [10352] = 10352,
  [10353] = 10353,
  [10354] = 10354,
  [10355] = 10337,
  [10356] = 10356,
  [10357] = 10357,
  [10358] = 10358,
  [10359] = 10359,
  [10360] = 10360,
  [10361] = 10361,
  [10362] = 10362,
  [10363] = 10363,
  [10364] = 10364,
  [10365] = 10365,
  [10366] = 10366,
  [10367] = 10367,
  [10368] = 10339,
  [10369] = 10369,
  [10370] = 10341,
  [10371] = 10336,
  [10372] = 10372,
  [10373] = 10342,
  [10374] = 10364,
  [10375] = 10375,
  [10376] = 10376,
  [10377] = 10347,
  [10378] = 10378,
  [10379] = 10379,
  [10380] = 10380,
  [10381] = 10339,
  [10382] = 10382,
  [10383] = 10341,
  [10384] = 10354,
  [10385] = 10385,
  [10386] = 10386,
  [10387] = 10364,
  [10388] = 10347,
  [10389] = 10358,
  [10390] = 10339,
  [10391] = 10346,
  [10392] = 10375,
  [10393] = 10385,
  [10394] = 10394,
  [10395] = 10395,
  [10396] = 10396,
  [10397] = 10358,
  [10398] = 10398,
  [10399] = 10333,
  [10400] = 10353,
  [10401] = 10401,
  [10402] = 10347,
  [10403] = 10403,
  [10404] = 10404,
  [10405] = 10334,
  [10406] = 10336,
  [10407] = 10337,
  [10408] = 10394,
  [10409] = 10360,
  [10410] = 10346,
  [10411] = 10411,
  [10412] = 10369,
  [10413] = 10337,
  [10414] = 10349,
  [10415] = 10344,
  [10416] = 10357,
  [10417] = 10417,
  [10418] = 10378,
  [10419] = 10401,
  [10420] = 10420,
  [10421] = 10421,
  [10422] = 10378,
  [10423] = 10349,
  [10424] = 10424,
  [10425] = 10350,
  [10426] = 10340,
  [10427] = 10421,
  [10428] = 10428,
  [10429] = 10429,
  [10430] = 10346,
  [10431] = 10424,
  [10432] = 10432,
  [10433] = 10433,
  [10434] = 10398,
  [10435] = 10435,
  [10436] = 10375,
  [10437] = 10336,
  [10438] = 10438,
  [10439] = 10334,
  [10440] = 10346,
  [10441] = 10404,
  [10442] = 10442,
  [10443] = 10341,
  [10444] = 10333,
  [10445] = 10356,
  [10446] = 10404,
  [10447] = 10447,
  [10448] = 10339,
  [10449] = 10369,
  [10450] = 10401,
  [10451] = 10346,
  [10452] = 10338,
  [10453] = 10385,
  [10454] = 10394,
  [10455] = 10455,
  [10456] = 10433,
  [10457] = 10457,
  [10458] = 10385,
  [10459] = 10394,
  [10460] = 10334,
  [10461] = 10336,
  [10462] = 10342,
  [10463] = 10380,
  [10464] = 10428,
  [10465] = 10336,
  [10466] = 10385,
  [10467] = 10347,
  [10468] = 10429,
  [10469] = 10380,
  [10470] = 10364,
  [10471] = 10375,
  [10472] = 10398,
  [10473] = 10375,
  [10474] = 10401,
  [10475] = 10339,
  [10476] = 10476,
  [10477] = 10346,
  [10478] = 10347,
  [10479] = 10394,
  [10480] = 10338,
  [10481] = 10353,
  [10482] = 10342,
  [10483] = 10337,
  [10484] = 10433,
  [10485] = 10375,
  [10486] = 10486,
  [10487] = 10358,
  [10488] = 10357,
  [10489] = 10361,
  [10490] = 10338,
  [10491] = 10339,
  [10492] = 10378,
  [10493] = 10457,
  [10494] = 10421,
  [10495] = 10495,
  [10496] = 10369,
  [10497] = 10375,
  [10498] = 10375,
  [10499] = 10353,
  [10500] = 10338,
  [10501] = 10341,
  [10502] = 10375,
  [10503] = 10503,
  [10504] = 10504,
  [10505] = 10505,
  [10506] = 10360,
  [10507] = 10341,
  [10508] = 10433,
  [10509] = 10353,
  [10510] = 10347,
  [10511] = 10346,
  [10512] = 10512,
  [10513] = 10369,
  [10514] = 10339,
  [10515] = 10515,
  [10516] = 10340,
  [10517] = 10457,
  [10518] = 10353,
  [10519] = 10360,
  [10520] = 10360,
  [10521] = 10521,
  [10522] = 10347,
  [10523] = 10429,
  [10524] = 10339,
  [10525] = 10366,
  [10526] = 10375,
  [10527] = 10354,
  [10528] = 10528,
  [10529] = 10333,
  [10530] = 10365,
  [10531] = 10435,
  [10532] = 10532,
  [10533] = 10339,
  [10534] = 10420,
  [10535] = 10339,
  [10536] = 10364,
  [10537] = 10337,
  [10538] = 10538,
  [10539] = 10350,
  [10540] = 10375,
  [10541] = 10398,
  [10542] = 10346,
  [10543] = 10361,
  [10544] = 10337,
  [10545] = 10340,
  [10546] = 10353,
  [10547] = 10424,
  [10548] = 10339,
  [10549] = 10385,
  [10550] = 10394,
  [10551] = 10429,
  [10552] = 10552,
  [10553] = 10357,
  [10554] = 10385,
  [10555] = 10394,
  [10556] = 10512,
  [10557] = 10424,
  [10558] = 10404,
  [10559] = 10378,
  [10560] = 10512,
  [10561] = 10447,
  [10562] = 10375,
  [10563] = 10385,
  [10564] = 10353,
  [10565] = 10394,
  [10566] = 10334,
  [10567] = 10367,
  [10568] = 10385,
  [10569] = 10375,
  [10570] = 10376,
  [10571] = 10336,
  [10572] = 10382,
  [10573] = 10438,
  [10574] = 10334,
  [10575] = 10336,
  [10576] = 10576,
  [10577] = 10577,
  [10578] = 10339,
  [10579] = 10369,
  [10580] = 10375,
  [10581] = 10339,
  [10582] = 10394,
  [10583] = 10369,
  [10584] = 10457,
  [10585] = 10385,
  [10586] = 10338,
  [10587] = 10420,
  [10588] = 10398,
  [10589] = 10365,
  [10590] = 10590,
  [10591] = 10428,
  [10592] = 10505,
  [10593] = 10433,
  [10594] = 10357,
  [10595] = 10340,
  [10596] = 10421,
  [10597] = 10597,
  [10598] = 10337,
  [10599] = 10341,
  [10600] = 10503,
  [10601] = 10429,
  [10602] = 10340,
  [10603] = 10337,
  [10604] = 10604,
  [10605] = 10605,
  [10606] = 10505,
  [10607] = 10435,
  [10608] = 10342,
  [10609] = 10424,
  [10610] = 10337,
  [10611] = 10361,
  [10612] = 10369,
  [10613] = 10375,
  [10614] = 10380,
  [10615] = 10367,
  [10616] = 10344,
  [10617] = 10376,
  [10618] = 10398,
  [10619] = 10349,
  [10620] = 10382,
  [10621] = 10353,
  [10622] = 10438,
  [10623] = 10361,
  [10624] = 10339,
  [10625] = 10367,
  [10626] = 10357,
  [10627] = 10376,
  [10628] = 10360,
  [10629] = 10382,
  [10630] = 10438,
  [10631] = 10631,
  [10632] = 10380,
  [10633] = 10347,
  [10634] = 10341,
  [10635] = 10435,
  [10636] = 10339,
  [10637] = 10346,
  [10638] = 10334,
  [10639] = 10354,
  [10640] = 10341,
  [10641] = 10641,
  [10642] = 10394,
  [10643] = 10366,
  [10644] = 10354,
  [10645] = 10367,
  [10646] = 10366,
  [10647] = 10512,
  [10648] = 10398,
  [10649] = 10378,
  [10650] = 10332,
  [10651] = 10332,
  [10652] = 10364,
  [10653] = 10334,
  [10654] = 10404,
  [10655] = 10505,
  [10656] = 10364,
  [10657] = 10341,
  [10658] = 10357,
  [10659] = 10420,
  [10660] = 10660,
  [10661] = 10346,
  [10662] = 10398,
  [10663] = 10398,
  [10664] = 10385,
  [10665] = 10394,
  [10666] = 10375,
  [10667] = 10336,
  [10668] = 10375,
  [10669] = 10333,
  [10670] = 10375,
  [10671] = 10398,
  [10672] = 10356,
  [10673] = 10673,
  [10674] = 10398,
  [10675] = 10401,
  [10676] = 10334,
  [10677] = 10429,
  [10678] = 10380,
  [10679] = 10361,
  [10680] = 10339,
  [10681] = 10385,
  [10682] = 10359,
  [10683] = 10394,
  [10684] = 10684,
  [10685] = 10375,
  [10686] = 10376,
  [10687] = 10420,
  [10688] = 10366,
  [10689] = 10334,
  [10690] = 10690,
  [10691] = 10360,
  [10692] = 10347,
  [10693] = 10398,
  [10694] = 10333,
  [10695] = 10336,
  [10696] = 10356,
  [10697] = 10401,
  [10698] = 10375,
  [10699] = 10420,
  [10700] = 10404,
  [10701] = 10382,
  [10702] = 10336,
  [10703] = 10339,
  [10704] = 10438,
  [10705] = 10398,
  [10706] = 10706,
  [10707] = 10375,
  [10708] = 10349,
  [10709] = 10375,
  [10710] = 10356,
  [10711] = 10711,
  [10712] = 10358,
  [10713] = 10341,
  [10714] = 10369,
  [10715] = 10385,
  [10716] = 10394,
  [10717] = 10336,
  [10718] = 10718,
  [10719] = 10357,
  [10720] = 10720,
  [10721] = 10353,
  [10722] = 10341,
  [10723] = 10339,
  [10724] = 10724,
  [10725] = 10341,
  [10726] = 10342,
  [10727] = 10385,
  [10728] = 10394,
  [10729] = 10336,
  [10730] = 10424,
  [10731] = 10347,
  [10732] = 10353,
  [10733] = 10367,
  [10734] = 10339,
  [10735] = 10359,
  [10736] = 10421,
  [10737] = 10361,
  [10738] = 10376,
  [10739] = 10380,
  [10740] = 10382,
  [10741] = 10339,
  [10742] = 10342,
  [10743] = 10346,
  [10744] = 10378,
  [10745] = 10438,
  [10746] = 10332,
  [10747] = 10358,
  [10748] = 10341,
  [10749] = 10447,
  [10750] = 10365,
  [10751] = 10356,
  [10752] = 10359,
  [10753] = 10428,
  [10754] = 10347,
  [10755] = 10505,
  [10756] = 10332,
  [10757] = 10385,
  [10758] = 10394,
  [10759] = 10332,
  [10760] = 10760,
  [10761] = 10366,
  [10762] = 10421,
  [10763] = 10332,
  [10764] = 10764,
  [10765] = 10332,
  [10766] = 10332,
  [10767] = 10332,
  [10768] = 10332,
  [10769] = 10332,
  [10770] = 10332,
  [10771] = 10332,
  [10772] = 10433,
  [10773] = 10332,
  [10774] = 10332,
  [10775] = 10332,
  [10776] = 10776,
  [10777] = 10353,
  [10778] = 10341,
  [10779] = 10359,
  [10780] = 10337,
  [10781] = 10781,
  [10782] = 10334,
  [10783] = 10338,
  [10784] = 10336,
  [10785] = 10364,
  [10786] = 10786,
  [10787] = 10787,
  [10788] = 10788,
  [10789] = 10789,
  [10790] = 10790,
  [10791] = 10791,
  [10792] = 10792,
  [10793] = 10793,
  [10794] = 10794,
  [10795] = 10795,
  [10796] = 10796,
  [10797] = 10797,
  [10798] = 10792,
  [10799] = 10799,
  [10800] = 10800,
  [10801] = 10787,
  [10802] = 10802,
  [10803] = 10803,
  [10804] = 10800,
  [10805] = 10805,
  [10806] = 10806,
  [10807] = 10797,
  [10808] = 10808,
  [10809] = 10796,
  [10810] = 10810,
  [10811] = 10787,
  [10812] = 10812,
  [10813] = 10803,
  [10814] = 10814,
  [10815] = 10815,
  [10816] = 10797,
  [10817] = 10817,
  [10818] = 10818,
  [10819] = 10808,
  [10820] = 10787,
  [10821] = 10821,
  [10822] = 10822,
  [10823] = 10823,
  [10824] = 10824,
  [10825] = 10797,
  [10826] = 10826,
  [10827] = 10789,
  [10828] = 10828,
  [10829] = 10787,
  [10830] = 10830,
  [10831] = 10831,
  [10832] = 10832,
  [10833] = 10833,
  [10834] = 10797,
  [10835] = 10835,
  [10836] = 10836,
  [10837] = 10814,
  [10838] = 10787,
  [10839] = 10839,
  [10840] = 10840,
  [10841] = 10841,
  [10842] = 10788,
  [10843] = 10797,
  [10844] = 10844,
  [10845] = 10845,
  [10846] = 10846,
  [10847] = 10787,
  [10848] = 10848,
  [10849] = 10849,
  [10850] = 10850,
  [10851] = 10851,
  [10852] = 10852,
  [10853] = 10796,
  [10854] = 10815,
  [10855] = 10855,
  [10856] = 10856,
  [10857] = 10792,
  [10858] = 10858,
  [10859] = 10800,
  [10860] = 10803,
  [10861] = 10786,
  [10862] = 10792,
  [10863] = 10831,
  [10864] = 10817,
  [10865] = 10865,
  [10866] = 10818,
  [10867] = 10796,
  [10868] = 10868,
  [10869] = 10869,
  [10870] = 10870,
  [10871] = 10869,
  [10872] = 10844,
  [10873] = 10873,
  [10874] = 10874,
  [10875] = 10792,
  [10876] = 10876,
  [10877] = 10839,
  [10878] = 10878,
  [10879] = 10879,
  [10880] = 10880,
  [10881] = 10881,
  [10882] = 10800,
  [10883] = 10883,
  [10884] = 10803,
  [10885] = 10800,
  [10886] = 10886,
  [10887] = 10887,
  [10888] = 10840,
  [10889] = 10889,
  [10890] = 10890,
  [10891] = 10841,
  [10892] = 10892,
  [10893] = 10858,
  [10894] = 10788,
  [10895] = 10799,
  [10896] = 10896,
  [10897] = 10897,
  [10898] = 10836,
  [10899] = 10899,
  [10900] = 10900,
  [10901] = 10901,
  [10902] = 10902,
  [10903] = 10903,
  [10904] = 10802,
  [10905] = 10905,
  [10906] = 10879,
  [10907] = 10907,
  [10908] = 7323,
  [10909] = 10909,
  [10910] = 10910,
  [10911] = 10794,
  [10912] = 10912,
  [10913] = 10796,
  [10914] = 10803,
  [10915] = 10787,
  [10916] = 10901,
  [10917] = 10917,
  [10918] = 10918,
  [10919] = 10919,
  [10920] = 10920,
  [10921] = 10921,
  [10922] = 10922,
  [10923] = 10788,
  [10924] = 10924,
  [10925] = 10925,
  [10926] = 10926,
  [10927] = 10839,
  [10928] = 10928,
  [10929] = 10929,
  [10930] = 10919,
  [10931] = 10931,
  [10932] = 10932,
  [10933] = 10933,
  [10934] = 10849,
  [10935] = 10831,
  [10936] = 10936,
  [10937] = 10912,
  [10938] = 10938,
  [10939] = 10939,
  [10940] = 10940,
  [10941] = 10941,
  [10942] = 10869,
  [10943] = 10830,
  [10944] = 10920,
  [10945] = 10805,
  [10946] = 10946,
  [10947] = 10947,
  [10948] = 10948,
  [10949] = 10949,
  [10950] = 10818,
  [10951] = 10951,
  [10952] = 10886,
  [10953] = 10953,
  [10954] = 10879,
  [10955] = 10955,
  [10956] = 10883,
  [10957] = 10957,
  [10958] = 10928,
  [10959] = 7221,
  [10960] = 10960,
  [10961] = 10929,
  [10962] = 10962,
  [10963] = 10821,
  [10964] = 10964,
  [10965] = 10850,
  [10966] = 10794,
  [10967] = 10967,
  [10968] = 10968,
  [10969] = 10793,
  [10970] = 10970,
  [10971] = 10971,
  [10972] = 10972,
  [10973] = 10973,
  [10974] = 10886,
  [10975] = 10892,
  [10976] = 10976,
  [10977] = 10977,
  [10978] = 10978,
  [10979] = 10979,
  [10980] = 10980,
  [10981] = 10964,
  [10982] = 10982,
  [10983] = 10983,
  [10984] = 10922,
  [10985] = 10835,
  [10986] = 10986,
  [10987] = 10987,
  [10988] = 10988,
  [10989] = 10989,
  [10990] = 10990,
  [10991] = 10932,
  [10992] = 10992,
  [10993] = 10993,
  [10994] = 10994,
  [10995] = 10814,
  [10996] = 10996,
  [10997] = 10830,
  [10998] = 10998,
  [10999] = 10999,
  [11000] = 11000,
  [11001] = 10986,
  [11002] = 10794,
  [11003] = 10986,
  [11004] = 10855,
  [11005] = 11005,
  [11006] = 10870,
  [11007] = 10873,
  [11008] = 11008,
  [11009] = 10840,
  [11010] = 10879,
  [11011] = 10874,
  [11012] = 11012,
  [11013] = 11013,
  [11014] = 11014,
  [11015] = 10839,
  [11016] = 11016,
  [11017] = 10879,
  [11018] = 11000,
  [11019] = 10883,
  [11020] = 11020,
  [11021] = 10841,
  [11022] = 10926,
  [11023] = 10797,
  [11024] = 10821,
  [11025] = 10951,
  [11026] = 11026,
  [11027] = 11027,
  [11028] = 11028,
  [11029] = 10986,
  [11030] = 11030,
  [11031] = 2908,
  [11032] = 11032,
  [11033] = 10886,
  [11034] = 10793,
  [11035] = 11035,
  [11036] = 10964,
  [11037] = 11037,
  [11038] = 10839,
  [11039] = 10926,
  [11040] = 10794,
  [11041] = 10979,
  [11042] = 11042,
  [11043] = 11043,
  [11044] = 11044,
  [11045] = 11045,
  [11046] = 11046,
  [11047] = 11037,
  [11048] = 10902,
  [11049] = 10926,
  [11050] = 10868,
  [11051] = 11020,
  [11052] = 11052,
  [11053] = 10876,
  [11054] = 11054,
  [11055] = 11055,
  [11056] = 11043,
  [11057] = 10839,
  [11058] = 11058,
  [11059] = 11059,
  [11060] = 10919,
  [11061] = 10851,
  [11062] = 10787,
  [11063] = 10917,
  [11064] = 10900,
  [11065] = 10876,
  [11066] = 10818,
  [11067] = 10794,
  [11068] = 10844,
  [11069] = 10990,
  [11070] = 11070,
  [11071] = 10931,
  [11072] = 11072,
  [11073] = 10887,
  [11074] = 11016,
  [11075] = 10821,
  [11076] = 11076,
  [11077] = 10879,
  [11078] = 10938,
  [11079] = 11079,
  [11080] = 10839,
  [11081] = 11081,
  [11082] = 10939,
  [11083] = 11083,
  [11084] = 10972,
  [11085] = 10879,
  [11086] = 11086,
  [11087] = 10788,
  [11088] = 10926,
  [11089] = 10883,
  [11090] = 10917,
  [11091] = 10883,
  [11092] = 11092,
  [11093] = 11093,
  [11094] = 10832,
  [11095] = 11095,
  [11096] = 11096,
  [11097] = 11097,
  [11098] = 11098,
  [11099] = 11000,
  [11100] = 10986,
  [11101] = 11101,
  [11102] = 10839,
  [11103] = 11103,
  [11104] = 10879,
  [11105] = 11054,
  [11106] = 10883,
  [11107] = 10808,
  [11108] = 10876,
  [11109] = 11109,
  [11110] = 10858,
  [11111] = 11111,
  [11112] = 11112,
  [11113] = 11113,
  [11114] = 10808,
  [11115] = 11115,
  [11116] = 11116,
  [11117] = 10850,
  [11118] = 10886,
  [11119] = 11044,
  [11120] = 10794,
  [11121] = 10979,
  [11122] = 10887,
  [11123] = 10886,
  [11124] = 11043,
  [11125] = 10818,
  [11126] = 11044,
  [11127] = 10926,
  [11128] = 11128,
  [11129] = 11115,
  [11130] = 10919,
  [11131] = 10896,
  [11132] = 11132,
  [11133] = 11020,
  [11134] = 11098,
  [11135] = 11135,
  [11136] = 10977,
  [11137] = 10940,
  [11138] = 10940,
  [11139] = 10818,
  [11140] = 11140,
  [11141] = 10939,
  [11142] = 10839,
  [11143] = 10947,
  [11144] = 10844,
  [11145] = 11145,
  [11146] = 10926,
  [11147] = 11147,
  [11148] = 10821,
  [11149] = 11149,
  [11150] = 11150,
  [11151] = 10876,
  [11152] = 11152,
  [11153] = 10896,
  [11154] = 10883,
  [11155] = 10796,
  [11156] = 11156,
  [11157] = 10792,
  [11158] = 10826,
  [11159] = 11159,
  [11160] = 11160,
  [11161] = 11161,
  [11162] = 11162,
  [11163] = 11163,
  [11164] = 10839,
  [11165] = 10799,
  [11166] = 11005,
  [11167] = 10879,
  [11168] = 11168,
  [11169] = 10979,
  [11170] = 11170,
  [11171] = 11171,
  [11172] = 11172,
  [11173] = 10886,
  [11174] = 11043,
  [11175] = 10800,
  [11176] = 10920,
  [11177] = 10982,
  [11178] = 11178,
  [11179] = 10803,
  [11180] = 10979,
  [11181] = 11043,
  [11182] = 11044,
  [11183] = 11044,
  [11184] = 11005,
  [11185] = 10973,
  [11186] = 11008,
  [11187] = 11187,
  [11188] = 10926,
  [11189] = 11189,
  [11190] = 10821,
  [11191] = 11191,
  [11192] = 10892,
  [11193] = 11020,
  [11194] = 10821,
  [11195] = 10797,
  [11196] = 11196,
  [11197] = 11197,
  [11198] = 11198,
  [11199] = 11199,
  [11200] = 10917,
  [11201] = 10818,
  [11202] = 10919,
  [11203] = 10920,
  [11204] = 11204,
  [11205] = 10980,
  [11206] = 10851,
  [11207] = 10787,
  [11208] = 10808,
  [11209] = 11209,
  [11210] = 11197,
  [11211] = 11211,
  [11212] = 10905,
  [11213] = 10879,
  [11214] = 11037,
  [11215] = 10982,
  [11216] = 10808,
  [11217] = 10992,
  [11218] = 11218,
  [11219] = 11219,
  [11220] = 11220,
  [11221] = 10940,
  [11222] = 10836,
  [11223] = 10901,
  [11224] = 10902,
  [11225] = 10905,
  [11226] = 10870,
  [11227] = 10907,
  [11228] = 11228,
  [11229] = 11229,
  [11230] = 10796,
  [11231] = 10938,
  [11232] = 10794,
  [11233] = 10830,
  [11234] = 10922,
  [11235] = 11235,
  [11236] = 10924,
  [11237] = 10851,
  [11238] = 10879,
  [11239] = 10787,
  [11240] = 10928,
  [11241] = 10931,
  [11242] = 10932,
  [11243] = 10936,
  [11244] = 10912,
  [11245] = 10879,
  [11246] = 11246,
  [11247] = 10793,
  [11248] = 10821,
  [11249] = 11054,
  [11250] = 11250,
  [11251] = 10886,
  [11252] = 10953,
  [11253] = 11253,
  [11254] = 10971,
  [11255] = 10868,
  [11256] = 10947,
  [11257] = 10977,
  [11258] = 10788,
  [11259] = 11054,
  [11260] = 10988,
  [11261] = 10917,
  [11262] = 11262,
  [11263] = 10812,
  [11264] = 11264,
  [11265] = 11076,
  [11266] = 10826,
  [11267] = 11267,
  [11268] = 11268,
  [11269] = 10926,
  [11270] = 10796,
  [11271] = 10917,
  [11272] = 10917,
  [11273] = 10821,
  [11274] = 11274,
  [11275] = 10919,
  [11276] = 10873,
  [11277] = 11277,
  [11278] = 11008,
  [11279] = 10794,
  [11280] = 11280,
  [11281] = 10818,
  [11282] = 11282,
  [11283] = 10947,
  [11284] = 10826,
  [11285] = 11285,
  [11286] = 11286,
  [11287] = 10794,
  [11288] = 10907,
  [11289] = 10793,
  [11290] = 11290,
  [11291] = 10802,
  [11292] = 11292,
  [11293] = 10910,
  [11294] = 11294,
  [11295] = 10793,
  [11296] = 10892,
  [11297] = 10826,
  [11298] = 10892,
  [11299] = 11112,
  [11300] = 11300,
  [11301] = 11301,
  [11302] = 10938,
  [11303] = 10886,
  [11304] = 10936,
  [11305] = 10792,
  [11306] = 10836,
  [11307] = 10901,
  [11308] = 10905,
  [11309] = 10815,
  [11310] = 10907,
  [11311] = 11311,
  [11312] = 10879,
  [11313] = 10922,
  [11314] = 7216,
  [11315] = 10924,
  [11316] = 10800,
  [11317] = 10803,
  [11318] = 11318,
  [11319] = 10932,
  [11320] = 10880,
  [11321] = 10870,
  [11322] = 10953,
  [11323] = 10869,
  [11324] = 11324,
  [11325] = 11008,
  [11326] = 10977,
  [11327] = 11000,
  [11328] = 10988,
  [11329] = 10883,
  [11330] = 10926,
  [11331] = 11331,
  [11332] = 10873,
  [11333] = 11333,
  [11334] = 11334,
  [11335] = 11335,
  [11336] = 10926,
  [11337] = 10831,
  [11338] = 10797,
  [11339] = 11339,
  [11340] = 11340,
  [11341] = 11341,
  [11342] = 10986,
  [11343] = 11343,
  [11344] = 11098,
  [11345] = 10817,
  [11346] = 10818,
  [11347] = 10990,
  [11348] = 10836,
  [11349] = 10901,
  [11350] = 10905,
  [11351] = 10818,
  [11352] = 10907,
  [11353] = 11353,
  [11354] = 11000,
  [11355] = 10922,
  [11356] = 10924,
  [11357] = 11357,
  [11358] = 11358,
  [11359] = 10931,
  [11360] = 10932,
  [11361] = 10926,
  [11362] = 10844,
  [11363] = 10953,
  [11364] = 10883,
  [11365] = 11037,
  [11366] = 10977,
  [11367] = 10988,
  [11368] = 11368,
  [11369] = 11369,
  [11370] = 10910,
  [11371] = 11371,
  [11372] = 10869,
  [11373] = 10979,
  [11374] = 10805,
  [11375] = 11000,
  [11376] = 11054,
  [11377] = 10836,
  [11378] = 10901,
  [11379] = 10905,
  [11380] = 10855,
  [11381] = 10907,
  [11382] = 10926,
  [11383] = 11383,
  [11384] = 10924,
  [11385] = 10972,
  [11386] = 10938,
  [11387] = 10931,
  [11388] = 10932,
  [11389] = 10851,
  [11390] = 10787,
  [11391] = 10953,
  [11392] = 11392,
  [11393] = 11140,
  [11394] = 10977,
  [11395] = 10988,
  [11396] = 10856,
  [11397] = 10947,
  [11398] = 11398,
  [11399] = 9269,
  [11400] = 11098,
  [11401] = 10980,
  [11402] = 10879,
  [11403] = 10836,
  [11404] = 10901,
  [11405] = 10858,
  [11406] = 10907,
  [11407] = 10797,
  [11408] = 10870,
  [11409] = 10873,
  [11410] = 11008,
  [11411] = 10931,
  [11412] = 10932,
  [11413] = 11076,
  [11414] = 10886,
  [11415] = 11197,
  [11416] = 10793,
  [11417] = 10977,
  [11418] = 11005,
  [11419] = 10870,
  [11420] = 10936,
  [11421] = 10887,
  [11422] = 10988,
  [11423] = 10919,
  [11424] = 10839,
  [11425] = 10836,
  [11426] = 10901,
  [11427] = 10907,
  [11428] = 10926,
  [11429] = 10932,
  [11430] = 11098,
  [11431] = 11431,
  [11432] = 10977,
  [11433] = 11197,
  [11434] = 11054,
  [11435] = 10797,
  [11436] = 11436,
  [11437] = 10817,
  [11438] = 11438,
  [11439] = 10879,
  [11440] = 10836,
  [11441] = 10901,
  [11442] = 10907,
  [11443] = 11443,
  [11444] = 10932,
  [11445] = 10818,
  [11446] = 10977,
  [11447] = 10836,
  [11448] = 10901,
  [11449] = 10907,
  [11450] = 10932,
  [11451] = 10977,
  [11452] = 10836,
  [11453] = 10901,
  [11454] = 10907,
  [11455] = 10932,
  [11456] = 10977,
  [11457] = 10836,
  [11458] = 10901,
  [11459] = 10932,
  [11460] = 10977,
  [11461] = 10836,
  [11462] = 10901,
  [11463] = 10932,
  [11464] = 10977,
  [11465] = 10901,
  [11466] = 10932,
  [11467] = 10977,
  [11468] = 10901,
  [11469] = 10932,
  [11470] = 10977,
  [11471] = 10901,
  [11472] = 10932,
  [11473] = 10977,
  [11474] = 10901,
  [11475] = 10932,
  [11476] = 10977,
  [11477] = 10883,
  [11478] = 11020,
  [11479] = 10902,
  [11480] = 10921,
  [11481] = 11096,
  [11482] = 10850,
  [11483] = 10850,
  [11484] = 10808,
  [11485] = 10818,
  [11486] = 10964,
  [11487] = 11098,
  [11488] = 10883,
  [11489] = 11005,
  [11490] = 11054,
  [11491] = 10821,
  [11492] = 10886,
  [11493] = 11493,
  [11494] = 10971,
  [11495] = 10912,
  [11496] = 10896,
  [11497] = 7264,
  [11498] = 11076,
  [11499] = 10839,
  [11500] = 10797,
  [11501] = 10951,
  [11502] = 11502,
  [11503] = 10990,
  [11504] = 11504,
  [11505] = 11152,
  [11506] = 10929,
  [11507] = 11507,
  [11508] = 10815,
  [11509] = 10876,
  [11510] = 11510,
  [11511] = 11000,
  [11512] = 10939,
  [11513] = 11513,
  [11514] = 10910,
  [11515] = 10796,
  [11516] = 10986,
  [11517] = 11043,
  [11518] = 11518,
  [11519] = 10873,
  [11520] = 10839,
  [11521] = 11521,
  [11522] = 11098,
  [11523] = 10973,
  [11524] = 11044,
  [11525] = 10879,
  [11526] = 11526,
  [11527] = 11527,
  [11528] = 11045,
  [11529] = 10792,
  [11530] = 10851,
  [11531] = 10973,
  [11532] = 10787,
  [11533] = 11527,
  [11534] = 11013,
  [11535] = 10982,
  [11536] = 10992,
  [11537] = 10999,
  [11538] = 10800,
  [11539] = 10982,
  [11540] = 10992,
  [11541] = 11541,
  [11542] = 10917,
  [11543] = 11037,
  [11544] = 10794,
  [11545] = 11098,
  [11546] = 10926,
  [11547] = 10947,
  [11548] = 11548,
  [11549] = 10803,
  [11550] = 11550,
  [11551] = 10858,
  [11552] = 11527,
  [11553] = 11502,
  [11554] = 11005,
  [11555] = 10925,
  [11556] = 10972,
  [11557] = 11557,
  [11558] = 11020,
  [11559] = 10892,
  [11560] = 10850,
  [11561] = 11561,
  [11562] = 10797,
  [11563] = 11152,
  [11564] = 10992,
  [11565] = 11005,
  [11566] = 10796,
  [11567] = 10792,
  [11568] = 10800,
  [11569] = 10803,
  [11570] = 10789,
  [11571] = 10925,
  [11572] = 11572,
  [11573] = 11162,
  [11574] = 11163,
  [11575] = 10797,
  [11576] = 11014,
  [11577] = 10936,
  [11578] = 11008,
  [11579] = 10926,
  [11580] = 10796,
  [11581] = 10856,
  [11582] = 10818,
  [11583] = 10926,
  [11584] = 11209,
  [11585] = 10787,
  [11586] = 11037,
  [11587] = 10821,
  [11588] = 11162,
  [11589] = 10851,
  [11590] = 10787,
  [11591] = 11098,
  [11592] = 10879,
  [11593] = 10938,
  [11594] = 11014,
  [11595] = 10830,
  [11596] = 10817,
  [11597] = 10830,
  [11598] = 11598,
  [11599] = 11599,
  [11600] = 10818,
  [11601] = 10817,
  [11602] = 11602,
  [11603] = 10788,
  [11604] = 11197,
  [11605] = 11605,
  [11606] = 10818,
  [11607] = 11140,
  [11608] = 10815,
  [11609] = 11112,
  [11610] = 10831,
  [11611] = 10876,
  [11612] = 11612,
  [11613] = 11613,
  [11614] = 11614,
  [11615] = 10869,
  [11616] = 10844,
  [11617] = 10883,
  [11618] = 10844,
  [11619] = 11619,
  [11620] = 10917,
  [11621] = 10964,
  [11622] = 11197,
  [11623] = 10821,
  [11624] = 10797,
  [11625] = 11625,
  [11626] = 10902,
  [11627] = 10921,
  [11628] = 11096,
  [11629] = 10796,
  [11630] = 10858,
  [11631] = 10886,
  [11632] = 10912,
  [11633] = 10887,
  [11634] = 11209,
  [11635] = 10951,
  [11636] = 11502,
  [11637] = 10973,
  [11638] = 10858,
  [11639] = 10787,
  [11640] = 10886,
  [11641] = 10953,
  [11642] = 10936,
  [11643] = 10902,
  [11644] = 10921,
  [11645] = 11096,
  [11646] = 10887,
  [11647] = 10818,
  [11648] = 10912,
  [11649] = 10951,
  [11650] = 11502,
  [11651] = 10928,
  [11652] = 10929,
  [11653] = 10979,
  [11654] = 10921,
  [11655] = 11096,
  [11656] = 11043,
  [11657] = 11657,
  [11658] = 10951,
  [11659] = 11502,
  [11660] = 11044,
  [11661] = 11661,
  [11662] = 10921,
  [11663] = 11096,
  [11664] = 2911,
  [11665] = 10928,
  [11666] = 10951,
  [11667] = 11502,
  [11668] = 10940,
  [11669] = 10921,
  [11670] = 11096,
  [11671] = 10797,
  [11672] = 10951,
  [11673] = 11502,
  [11674] = 10796,
  [11675] = 10951,
  [11676] = 11502,
  [11677] = 10835,
  [11678] = 11502,
  [11679] = 11679,
  [11680] = 11502,
  [11681] = 10787,
  [11682] = 11502,
  [11683] = 11683,
  [11684] = 11502,
  [11685] = 11163,
  [11686] = 11502,
  [11687] = 10817,
  [11688] = 11502,
  [11689] = 11689,
  [11690] = 11502,
  [11691] = 10936,
  [11692] = 11502,
  [11693] = 11045,
  [11694] = 11502,
  [11695] = 11235,
  [11696] = 10786,
  [11697] = 10818,
  [11698] = 11698,
  [11699] = 11235,
  [11700] = 10821,
  [11701] = 10849,
  [11702] = 11235,
  [11703] = 10786,
  [11704] = 10924,
  [11705] = 11235,
  [11706] = 10786,
  [11707] = 10964,
  [11708] = 11235,
  [11709] = 10786,
  [11710] = 10850,
  [11711] = 10786,
  [11712] = 10786,
  [11713] = 10786,
  [11714] = 10786,
  [11715] = 10786,
  [11716] = 10786,
  [11717] = 10786,
  [11718] = 10786,
  [11719] = 10786,
  [11720] = 10786,
  [11721] = 10786,
  [11722] = 10929,
  [11723] = 10832,
  [11724] = 10797,
  [11725] = 10794,
  [11726] = 11726,
  [11727] = 11253,
  [11728] = 11253,
  [11729] = 11253,
  [11730] = 11253,
  [11731] = 11253,
  [11732] = 10931,
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'$', '$'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba},
  {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374},
  {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5},
  {0x3f7, 0x481}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a},
  {0x66e, 0x66f}, {0x671, 0x6d3}, {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710},
  {0x712, 0x72f}, {0x74d, 0x7a5}, {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a},
  {0x824, 0x824}, {0x828, 0x828}, {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939},
  {0x93d, 0x93d}, {0x950, 0x950}, {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0},
  {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc},
  {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c},
  {0xa5e, 0xa5e}, {0xa72, 0xa74}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9},
  {0xabd, 0xabd}, {0xad0, 0xad0}, {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30},
  {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a},
  {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9},
  {0xbd0, 0xbd0}, {0xc05, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d},
  {0xc60, 0xc61}, {0xc80, 0xc80}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd},
  {0xcdd, 0xcde}, {0xce0, 0xce1}, {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e},
  {0xd54, 0xd56}, {0xd5f, 0xd61}, {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6},
  {0xe01, 0xe30}, {0xe32, 0xe32}, {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5},
  {0xea7, 0xeb0}, {0xeb2, 0xeb2}, {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47},
  {0xf49, 0xf6c}, {0xf88, 0xf8c}, {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066},
  {0x106e, 0x1070}, {0x1075, 0x1081}, {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248},
  {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5},
  {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f},
  {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711},
  {0x171f, 0x1731}, {0x1740, 0x1751}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878},
  {0x1880, 0x18a8}, {0x18aa, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9},
  {0x1a00, 0x1a16}, {0x1a20, 0x1a54}, {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5},
  {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f}, {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3},
  {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa}, {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57},
  {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4},
  {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f},
  {0x2090, 0x209c}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126},
  {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee},
  {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6},
  {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007},
  {0x3021, 0x3029}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f},
  {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f},
  {0xa62a, 0xa62b}, {0xa640, 0xa66e}, {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1},
  {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3},
  {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf},
  {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef}, {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a},
  {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1}, {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea},
  {0xaaf2, 0xaaf4}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69},
  {0xab70, 0xabe2}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17},
  {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1},
  {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77},
  {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe},
  {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d},
  {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a},
  {0x10350, 0x10375}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb},
  {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1},
  {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba},
  {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e},
  {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13},
  {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55},
  {0x10b60, 0x10b72}, {0x10b80, 0x10b91}, {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1},
  {0x10f00, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f45}, {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072},
  {0x11075, 0x11075}, {0x11083, 0x110af}, {0x110d0, 0x110e8}, {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176},
  {0x11183, 0x111b2}, {0x111c1, 0x111c4}, {0x111da, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x1123f, 0x11240}, {0x11280, 0x11286},
  {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328},
  {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a},
  {0x1145f, 0x11461}, {0x11480, 0x114af}, {0x114c4, 0x114c5}, {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644},
  {0x11680, 0x116aa}, {0x116b8, 0x116b8}, {0x11700, 0x1171a}, {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909},
  {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x1192f}, {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1},
  {0x119e3, 0x119e3}, {0x11a00, 0x11a00}, {0x11a0b, 0x11a32}, {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8},
  {0x11c00, 0x11c08}, {0x11c0a, 0x11c2e}, {0x11c40, 0x11c40}, {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46},
  {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d89}, {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11f02, 0x11f02}, {0x11f04, 0x11f10}, {0x11f12, 0x11f33},
  {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13441, 0x13446}, {0x14400, 0x14646},
  {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a70, 0x16abe}, {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f}, {0x16b40, 0x16b43}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f},
  {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f50, 0x16f50}, {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe3}, {0x17000, 0x187f7}, {0x18800, 0x18cd5},
  {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152}, {0x1b155, 0x1b155},
  {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c},
  {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505},
  {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550},
  {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e},
  {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e030, 0x1e06d}, {0x1e100, 0x1e12c},
  {0x1e137, 0x1e13d}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ad}, {0x1e2c0, 0x1e2eb}, {0x1e4d0, 0x1e4eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee},
  {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e900, 0x1e943}, {0x1e94b, 0x1e94b}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24},
  {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49},
  {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d},
  {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e},
  {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b739}, {0x2b740, 0x2b81d},
  {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'$', '$'}, {'0', '9'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5},
  {0xb7, 0xb7}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec},
  {0x2ee, 0x2ee}, {0x300, 0x374}, {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1},
  {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd},
  {0x5bf, 0x5bf}, {0x5c1, 0x5c2}, {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669},
  {0x66e, 0x6d3}, {0x6d5, 0x6dc}, {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5},
  {0x7fa, 0x7fa}, {0x7fd, 0x7fd}, {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1},
  {0x8e3, 0x963}, {0x966, 0x96f}, {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2},
  {0x9b6, 0x9b9}, {0x9bc, 0x9c4}, {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1},
  {0x9fc, 0x9fc}, {0x9fe, 0x9fe}, {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33},
  {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c},
  {0xa5e, 0xa5e}, {0xa66, 0xa75}, {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3},
  {0xab5, 0xab9}, {0xabc, 0xac5}, {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff},
  {0xb01, 0xb03}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44},
  {0xb47, 0xb48}, {0xb4b, 0xb4d}, {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83},
  {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa},
  {0xbae, 0xbb9}, {0xbbe, 0xbc2}, {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c},
  {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a},
  {0xc5d, 0xc5d}, {0xc60, 0xc63}, {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3},
  {0xcb5, 0xcb9}, {0xcbc, 0xcc4}, {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef},
  {0xcf1, 0xcf3}, {0xd00, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63},
  {0xd66, 0xd6f}, {0xd7a, 0xd7f}, {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6},
  {0xdca, 0xdca}, {0xdcf, 0xdd4}, {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e},
  {0xe50, 0xe59}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4},
  {0xec6, 0xec6}, {0xec8, 0xece}, {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35},
  {0xf37, 0xf37}, {0xf39, 0xf39}, {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6},
  {0x1000, 0x1049}, {0x1050, 0x109d}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d},
  {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be},
  {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1369, 0x1371},
  {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8},
  {0x1700, 0x1715}, {0x171f, 0x1734}, {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7},
  {0x17dc, 0x17dd}, {0x17e0, 0x17e9}, {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e},
  {0x1920, 0x192b}, {0x1930, 0x193b}, {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19da}, {0x1a00, 0x1a1b},
  {0x1a20, 0x1a5e}, {0x1a60, 0x1a7c}, {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c},
  {0x1b50, 0x1b59}, {0x1b6b, 0x1b73}, {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba},
  {0x1cbd, 0x1cbf}, {0x1cd0, 0x1cd2}, {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57},
  {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4},
  {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x200c, 0x200d}, {0x203f, 0x2040},
  {0x2054, 0x2054}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102},
  {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139},
  {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27},
  {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe},
  {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035},
  {0x3038, 0x303c}, {0x3041, 0x3096}, {0x3099, 0x309a}, {0x309d, 0x309f}, {0x30a1, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf},
  {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d},
  {0xa67f, 0xa6f1}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827},
  {0xa82c, 0xa82c}, {0xa840, 0xa873}, {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953},
  {0xa960, 0xa97c}, {0xa980, 0xa9c0}, {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76},
  {0xaa7a, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26},
  {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6},
  {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c},
  {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7},
  {0xfdf0, 0xfdf9}, {0xfe00, 0xfe0f}, {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77},
  {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a},
  {0xff65, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a},
  {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0},
  {0x102e0, 0x102e0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5},
  {0x10400, 0x1049d}, {0x104a0, 0x104a9}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a},
  {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755},
  {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838},
  {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939},
  {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a},
  {0x10a3f, 0x10a3f}, {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72},
  {0x10b80, 0x10b91}, {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac},
  {0x10eb0, 0x10eb1}, {0x10efd, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046},
  {0x11066, 0x11075}, {0x1107f, 0x110ba}, {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147},
  {0x11150, 0x11173}, {0x11176, 0x11176}, {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237},
  {0x1123e, 0x11241}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9},
  {0x11300, 0x11303}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344},
  {0x11347, 0x11348}, {0x1134b, 0x1134d}, {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a},
  {0x11450, 0x11459}, {0x1145e, 0x11461}, {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd},
  {0x11600, 0x11640}, {0x11644, 0x11644}, {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739},
  {0x11740, 0x11746}, {0x11800, 0x1183a}, {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935},
  {0x11937, 0x11938}, {0x1193b, 0x11943}, {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e},
  {0x11a47, 0x11a47}, {0x11a50, 0x11a99}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59},
  {0x11c72, 0x11c8f}, {0x11c92, 0x11ca7}, {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d},
  {0x11d3f, 0x11d47}, {0x11d50, 0x11d59}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9},
  {0x11ee0, 0x11ef6}, {0x11f00, 0x11f10}, {0x11f12, 0x11f3a}, {0x11f3e, 0x11f42}, {0x11f50, 0x11f59}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e},
  {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13440, 0x13455}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a60, 0x16a69},
  {0x16a70, 0x16abe}, {0x16ac0, 0x16ac9}, {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36}, {0x16b40, 0x16b43}, {0x16b50, 0x16b59}, {0x16b63, 0x16b77},
  {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe4}, {0x16ff0, 0x16ff1},
  {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132},
  {0x1b150, 0x1b152}, {0x1b155, 0x1b155}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99},
  {0x1bc9d, 0x1bc9e}, {0x1cf00, 0x1cf2d}, {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b}, {0x1d1aa, 0x1d1ad},
  {0x1d242, 0x1d244}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9},
  {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e},
  {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714},
  {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1d7ce, 0x1d7ff},
  {0x1da00, 0x1da36}, {0x1da3b, 0x1da6c}, {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a},
  {0x1e000, 0x1e006}, {0x1e008, 0x1e018}, {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e030, 0x1e06d}, {0x1e08f, 0x1e08f}, {0x1e100, 0x1e12c},
  {0x1e130, 0x1e13d}, {0x1e140, 0x1e149}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ae}, {0x1e2c0, 0x1e2f9}, {0x1e4d0, 0x1e4f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb},
  {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e8d0, 0x1e8d6}, {0x1e900, 0x1e94b}, {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f},
  {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42},
  {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59},
  {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77},
  {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9},
  {0x20000, 0x2a6df}, {0x2a700, 0x2b739}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a},
  {0x31350, 0x323af}, {0xe0100, 0xe01ef},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 424,
        '"', 544,
        '#', 301,
        '%', 448,
        '&', 458,
        '\'', 535,
        '(', 361,
        ')', 364,
        '*', 444,
        '+', 438,
        ',', 363,
        '-', 427,
        '.', 509,
        '/', 446,
        '0', 517,
        ':', 477,
        ';', 478,
        '<', 468,
        '=', 490,
        '>', 660,
        '?', 493,
        'F', 587,
        'L', 561,
        'R', 564,
        'T', 591,
        'U', 565,
        '[', 486,
        '\\', 2,
        ']', 488,
        '^', 455,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 596,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        't', 638,
        'u', 568,
        'v', 630,
        '{', 482,
        '|', 452,
        '}', 483,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(353);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(173);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(173);
      if (lookahead == '\r') SKIP(1);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(184);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(184);
      if (lookahead == '\r') SKIP(3);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(183);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(183);
      if (lookahead == '\r') SKIP(5);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(186);
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(186);
      if (lookahead == '\r') SKIP(7);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(185);
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(185);
      if (lookahead == '\r') SKIP(9);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 11:
      if (lookahead == '\n') SKIP(174);
      END_STATE();
    case 12:
      if (lookahead == '\n') SKIP(174);
      if (lookahead == '\r') SKIP(11);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 13:
      if (lookahead == '\n') SKIP(252);
      END_STATE();
    case 14:
      if (lookahead == '\n') SKIP(252);
      if (lookahead == '\r') SKIP(13);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 15:
      if (lookahead == '\n') SKIP(187);
      END_STATE();
    case 16:
      if (lookahead == '\n') SKIP(187);
      if (lookahead == '\r') SKIP(15);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 17:
      if (lookahead == '\n') SKIP(250);
      END_STATE();
    case 18:
      if (lookahead == '\n') SKIP(250);
      if (lookahead == '\r') SKIP(17);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 19:
      if (lookahead == '\n') SKIP(220);
      END_STATE();
    case 20:
      if (lookahead == '\n') SKIP(220);
      if (lookahead == '\r') SKIP(19);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 21:
      if (lookahead == '\n') SKIP(181);
      END_STATE();
    case 22:
      if (lookahead == '\n') SKIP(181);
      if (lookahead == '\r') SKIP(21);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 23:
      if (lookahead == '\n') SKIP(188);
      END_STATE();
    case 24:
      if (lookahead == '\n') SKIP(188);
      if (lookahead == '\r') SKIP(23);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 25:
      if (lookahead == '\n') SKIP(178);
      END_STATE();
    case 26:
      if (lookahead == '\n') SKIP(178);
      if (lookahead == '\r') SKIP(25);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 27:
      if (lookahead == '\n') SKIP(179);
      END_STATE();
    case 28:
      if (lookahead == '\n') SKIP(179);
      if (lookahead == '\r') SKIP(27);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 29:
      if (lookahead == '\n') SKIP(200);
      END_STATE();
    case 30:
      if (lookahead == '\n') SKIP(200);
      if (lookahead == '\r') SKIP(29);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 31:
      if (lookahead == '\n') SKIP(196);
      END_STATE();
    case 32:
      if (lookahead == '\n') SKIP(196);
      if (lookahead == '\r') SKIP(31);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 33:
      if (lookahead == '\n') SKIP(207);
      END_STATE();
    case 34:
      if (lookahead == '\n') SKIP(207);
      if (lookahead == '\r') SKIP(33);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 35:
      if (lookahead == '\n') SKIP(189);
      END_STATE();
    case 36:
      if (lookahead == '\n') SKIP(189);
      if (lookahead == '\r') SKIP(35);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 37:
      if (lookahead == '\n') SKIP(206);
      END_STATE();
    case 38:
      if (lookahead == '\n') SKIP(206);
      if (lookahead == '\r') SKIP(37);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 39:
      if (lookahead == '\n') SKIP(237);
      END_STATE();
    case 40:
      if (lookahead == '\n') SKIP(237);
      if (lookahead == '\r') SKIP(39);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 41:
      if (lookahead == '\n') SKIP(251);
      END_STATE();
    case 42:
      if (lookahead == '\n') SKIP(251);
      if (lookahead == '\r') SKIP(41);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 43:
      if (lookahead == '\n') SKIP(210);
      END_STATE();
    case 44:
      if (lookahead == '\n') SKIP(210);
      if (lookahead == '\r') SKIP(43);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 45:
      if (lookahead == '\n') SKIP(197);
      END_STATE();
    case 46:
      if (lookahead == '\n') SKIP(197);
      if (lookahead == '\r') SKIP(45);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 47:
      if (lookahead == '\n') SKIP(201);
      END_STATE();
    case 48:
      if (lookahead == '\n') SKIP(201);
      if (lookahead == '\r') SKIP(47);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 49:
      if (lookahead == '\n') SKIP(191);
      END_STATE();
    case 50:
      if (lookahead == '\n') SKIP(191);
      if (lookahead == '\r') SKIP(49);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 51:
      if (lookahead == '\n') SKIP(208);
      END_STATE();
    case 52:
      if (lookahead == '\n') SKIP(208);
      if (lookahead == '\r') SKIP(51);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 53:
      if (lookahead == '\n') SKIP(245);
      END_STATE();
    case 54:
      if (lookahead == '\n') SKIP(245);
      if (lookahead == '\r') SKIP(53);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 55:
      if (lookahead == '\n') SKIP(224);
      END_STATE();
    case 56:
      if (lookahead == '\n') SKIP(224);
      if (lookahead == '\r') SKIP(55);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 57:
      if (lookahead == '\n') SKIP(232);
      END_STATE();
    case 58:
      if (lookahead == '\n') SKIP(232);
      if (lookahead == '\r') SKIP(57);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 59:
      if (lookahead == '\n') SKIP(221);
      END_STATE();
    case 60:
      if (lookahead == '\n') SKIP(221);
      if (lookahead == '\r') SKIP(59);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 61:
      if (lookahead == '\n') SKIP(254);
      END_STATE();
    case 62:
      if (lookahead == '\n') SKIP(254);
      if (lookahead == '\r') SKIP(61);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 63:
      if (lookahead == '\n') SKIP(228);
      END_STATE();
    case 64:
      if (lookahead == '\n') SKIP(228);
      if (lookahead == '\r') SKIP(63);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 65:
      if (lookahead == '\n') SKIP(238);
      END_STATE();
    case 66:
      if (lookahead == '\n') SKIP(238);
      if (lookahead == '\r') SKIP(65);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 67:
      if (lookahead == '\n') SKIP(192);
      END_STATE();
    case 68:
      if (lookahead == '\n') SKIP(192);
      if (lookahead == '\r') SKIP(67);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 69:
      if (lookahead == '\n') SKIP(253);
      END_STATE();
    case 70:
      if (lookahead == '\n') SKIP(253);
      if (lookahead == '\r') SKIP(69);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 71:
      if (lookahead == '\n') SKIP(198);
      END_STATE();
    case 72:
      if (lookahead == '\n') SKIP(198);
      if (lookahead == '\r') SKIP(71);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 73:
      if (lookahead == '\n') SKIP(202);
      END_STATE();
    case 74:
      if (lookahead == '\n') SKIP(202);
      if (lookahead == '\r') SKIP(73);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 75:
      if (lookahead == '\n') SKIP(214);
      END_STATE();
    case 76:
      if (lookahead == '\n') SKIP(214);
      if (lookahead == '\r') SKIP(75);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 77:
      if (lookahead == '\n') SKIP(231);
      END_STATE();
    case 78:
      if (lookahead == '\n') SKIP(231);
      if (lookahead == '\r') SKIP(77);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 79:
      if (lookahead == '\n') SKIP(230);
      END_STATE();
    case 80:
      if (lookahead == '\n') SKIP(230);
      if (lookahead == '\r') SKIP(79);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 81:
      if (lookahead == '\n') SKIP(255);
      END_STATE();
    case 82:
      if (lookahead == '\n') SKIP(255);
      if (lookahead == '\r') SKIP(81);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 83:
      if (lookahead == '\n') SKIP(223);
      END_STATE();
    case 84:
      if (lookahead == '\n') SKIP(223);
      if (lookahead == '\r') SKIP(83);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 85:
      if (lookahead == '\n') SKIP(182);
      END_STATE();
    case 86:
      if (lookahead == '\n') SKIP(182);
      if (lookahead == '\r') SKIP(85);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 87:
      if (lookahead == '\n') SKIP(256);
      END_STATE();
    case 88:
      if (lookahead == '\n') SKIP(256);
      if (lookahead == '\r') SKIP(87);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 89:
      if (lookahead == '\n') SKIP(257);
      END_STATE();
    case 90:
      if (lookahead == '\n') SKIP(257);
      if (lookahead == '\r') SKIP(89);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 91:
      if (lookahead == '\n') SKIP(258);
      END_STATE();
    case 92:
      if (lookahead == '\n') SKIP(258);
      if (lookahead == '\r') SKIP(91);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 93:
      if (lookahead == '\n') SKIP(236);
      END_STATE();
    case 94:
      if (lookahead == '\n') SKIP(236);
      if (lookahead == '\r') SKIP(93);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 95:
      if (lookahead == '\n') SKIP(266);
      END_STATE();
    case 96:
      if (lookahead == '\n') SKIP(266);
      if (lookahead == '\r') SKIP(95);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 97:
      if (lookahead == '\n') SKIP(190);
      END_STATE();
    case 98:
      if (lookahead == '\n') SKIP(190);
      if (lookahead == '\r') SKIP(97);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 99:
      if (lookahead == '\n') SKIP(101);
      END_STATE();
    case 100:
      if (lookahead == '\n') SKIP(101);
      if (lookahead == '\r') SKIP(99);
      END_STATE();
    case 101:
      ADVANCE_MAP(
        '\n', 366,
        '!', 287,
        '%', 447,
        '&', 457,
        '(', 422,
        '*', 443,
        '+', 436,
        '-', 426,
        '/', 445,
        '<', 471,
        '=', 288,
        '>', 462,
      );
      if (lookahead == '\\') SKIP(100);
      if (lookahead == '^') ADVANCE(454);
      if (lookahead == '|') ADVANCE(453);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(101);
      END_STATE();
    case 102:
      if (lookahead == '\n') SKIP(261);
      END_STATE();
    case 103:
      if (lookahead == '\n') SKIP(261);
      if (lookahead == '\r') SKIP(102);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 104:
      if (lookahead == '\n') SKIP(259);
      END_STATE();
    case 105:
      if (lookahead == '\n') SKIP(259);
      if (lookahead == '\r') SKIP(104);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 106:
      if (lookahead == '\n') SKIP(260);
      END_STATE();
    case 107:
      if (lookahead == '\n') SKIP(260);
      if (lookahead == '\r') SKIP(106);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 108:
      if (lookahead == '\n') SKIP(246);
      END_STATE();
    case 109:
      if (lookahead == '\n') SKIP(246);
      if (lookahead == '\r') SKIP(108);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 110:
      if (lookahead == '\n') SKIP(265);
      END_STATE();
    case 111:
      if (lookahead == '\n') SKIP(265);
      if (lookahead == '\r') SKIP(110);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 112:
      if (lookahead == '\n') SKIP(247);
      END_STATE();
    case 113:
      if (lookahead == '\n') SKIP(247);
      if (lookahead == '\r') SKIP(112);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 114:
      if (lookahead == '\n') SKIP(248);
      if (lookahead == '"') ADVANCE(544);
      if (lookahead == '/') ADVANCE(545);
      if (lookahead == '\\') ADVANCE(115);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(548);
      if (lookahead != 0) ADVANCE(549);
      END_STATE();
    case 115:
      if (lookahead == '\n') ADVANCE(551);
      if (lookahead == '\r') ADVANCE(550);
      if (lookahead == 'U') ADVANCE(351);
      if (lookahead == 'u') ADVANCE(343);
      if (lookahead == 'x') ADVANCE(337);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(553);
      if (lookahead != 0) ADVANCE(550);
      END_STATE();
    case 116:
      if (lookahead == '\n') SKIP(262);
      if (lookahead == '\'') ADVANCE(535);
      if (lookahead == '/') ADVANCE(538);
      if (lookahead == '\\') ADVANCE(537);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(539);
      if (lookahead != 0) ADVANCE(536);
      END_STATE();
    case 117:
      if (lookahead == '\n') ADVANCE(359);
      if (lookahead == '\r') ADVANCE(121);
      if (lookahead == '(') ADVANCE(361);
      if (lookahead == '/') ADVANCE(387);
      if (lookahead == '\\') ADVANCE(382);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(279);
      if (lookahead != 0) ADVANCE(389);
      END_STATE();
    case 118:
      if (lookahead == '\n') ADVANCE(359);
      if (lookahead == '\r') ADVANCE(121);
      if (lookahead == '/') ADVANCE(387);
      if (lookahead == '\\') ADVANCE(382);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(279);
      if (lookahead != 0) ADVANCE(389);
      END_STATE();
    case 119:
      if (lookahead == '\n') ADVANCE(359);
      if (lookahead == '\r') ADVANCE(120);
      if (lookahead == '(') ADVANCE(422);
      if (lookahead == '/') ADVANCE(270);
      if (lookahead == '\\') SKIP(123);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(267);
      END_STATE();
    case 120:
      if (lookahead == '\n') ADVANCE(359);
      if (lookahead == '(') ADVANCE(422);
      if (lookahead == '/') ADVANCE(270);
      if (lookahead == '\\') SKIP(123);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(267);
      END_STATE();
    case 121:
      if (lookahead == '\n') ADVANCE(359);
      if (lookahead == '/') ADVANCE(387);
      if (lookahead == '\\') ADVANCE(382);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(279);
      if (lookahead != 0) ADVANCE(389);
      END_STATE();
    case 122:
      if (lookahead == '\n') SKIP(267);
      END_STATE();
    case 123:
      if (lookahead == '\n') SKIP(267);
      if (lookahead == '\r') SKIP(122);
      END_STATE();
    case 124:
      if (lookahead == '\n') SKIP(175);
      END_STATE();
    case 125:
      if (lookahead == '\n') SKIP(175);
      if (lookahead == '\r') SKIP(124);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 126:
      if (lookahead == '\n') SKIP(180);
      END_STATE();
    case 127:
      if (lookahead == '\n') SKIP(180);
      if (lookahead == '\r') SKIP(126);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 128:
      if (lookahead == '\n') SKIP(216);
      END_STATE();
    case 129:
      if (lookahead == '\n') SKIP(216);
      if (lookahead == '\r') SKIP(128);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 130:
      if (lookahead == '\n') SKIP(211);
      END_STATE();
    case 131:
      if (lookahead == '\n') SKIP(211);
      if (lookahead == '\r') SKIP(130);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 132:
      if (lookahead == '\n') SKIP(242);
      END_STATE();
    case 133:
      if (lookahead == '\n') SKIP(242);
      if (lookahead == '\r') SKIP(132);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 134:
      if (lookahead == '\n') SKIP(222);
      END_STATE();
    case 135:
      if (lookahead == '\n') SKIP(222);
      if (lookahead == '\r') SKIP(134);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 136:
      if (lookahead == '\n') SKIP(240);
      END_STATE();
    case 137:
      if (lookahead == '\n') SKIP(240);
      if (lookahead == '\r') SKIP(136);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 138:
      if (lookahead == '\n') SKIP(239);
      END_STATE();
    case 139:
      if (lookahead == '\n') SKIP(239);
      if (lookahead == '\r') SKIP(138);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 140:
      if (lookahead == '\n') SKIP(194);
      END_STATE();
    case 141:
      if (lookahead == '\n') SKIP(194);
      if (lookahead == '\r') SKIP(140);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 142:
      if (lookahead == '\n') SKIP(204);
      END_STATE();
    case 143:
      if (lookahead == '\n') SKIP(204);
      if (lookahead == '\r') SKIP(142);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 144:
      if (lookahead == '\n') SKIP(213);
      END_STATE();
    case 145:
      if (lookahead == '\n') SKIP(213);
      if (lookahead == '\r') SKIP(144);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 146:
      if (lookahead == '\n') SKIP(235);
      END_STATE();
    case 147:
      if (lookahead == '\n') SKIP(235);
      if (lookahead == '\r') SKIP(146);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 148:
      if (lookahead == '\n') SKIP(226);
      END_STATE();
    case 149:
      if (lookahead == '\n') SKIP(226);
      if (lookahead == '\r') SKIP(148);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 150:
      if (lookahead == '\n') SKIP(176);
      END_STATE();
    case 151:
      if (lookahead == '\n') SKIP(176);
      if (lookahead == '\r') SKIP(150);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 152:
      if (lookahead == '\n') SKIP(217);
      END_STATE();
    case 153:
      if (lookahead == '\n') SKIP(217);
      if (lookahead == '\r') SKIP(152);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 154:
      if (lookahead == '\n') SKIP(229);
      END_STATE();
    case 155:
      if (lookahead == '\n') SKIP(229);
      if (lookahead == '\r') SKIP(154);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 156:
      if (lookahead == '\n') SKIP(219);
      END_STATE();
    case 157:
      if (lookahead == '\n') SKIP(219);
      if (lookahead == '\r') SKIP(156);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 158:
      if (lookahead == '\n') SKIP(234);
      END_STATE();
    case 159:
      if (lookahead == '\n') SKIP(234);
      if (lookahead == '\r') SKIP(158);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 160:
      if (lookahead == '\n') SKIP(227);
      END_STATE();
    case 161:
      if (lookahead == '\n') SKIP(227);
      if (lookahead == '\r') SKIP(160);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 162:
      if (lookahead == '\n') SKIP(177);
      END_STATE();
    case 163:
      if (lookahead == '\n') SKIP(177);
      if (lookahead == '\r') SKIP(162);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 164:
      if (lookahead == '\n') SKIP(209);
      END_STATE();
    case 165:
      if (lookahead == '\n') SKIP(209);
      if (lookahead == '\r') SKIP(164);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 166:
      if (lookahead == '\n') SKIP(241);
      END_STATE();
    case 167:
      if (lookahead == '\n') SKIP(241);
      if (lookahead == '\r') SKIP(166);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 168:
      if (lookahead == '\n') SKIP(244);
      END_STATE();
    case 169:
      if (lookahead == '\n') SKIP(244);
      if (lookahead == '\r') SKIP(168);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 170:
      if (lookahead == '\n') SKIP(215);
      END_STATE();
    case 171:
      if (lookahead == '\n') SKIP(215);
      if (lookahead == '\r') SKIP(170);
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 172:
      if (lookahead == '\r') ADVANCE(659);
      if (lookahead == '\\') ADVANCE(653);
      if (lookahead != 0) ADVANCE(658);
      END_STATE();
    case 173:
      ADVANCE_MAP(
        '!', 424,
        '"', 544,
        '#', 301,
        '%', 448,
        '&', 458,
        '\'', 535,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 438,
        ',', 363,
        '-', 427,
        '.', 509,
        '/', 446,
        '0', 517,
        ':', 477,
        ';', 478,
        '<', 468,
        '=', 490,
        '>', 660,
        '?', 493,
        'F', 587,
        'L', 561,
        'R', 564,
        'T', 591,
        'U', 565,
        '[', 486,
        '\\', 2,
        ']', 488,
        '^', 455,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 596,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        't', 638,
        'u', 568,
        'v', 630,
        '{', 482,
        '|', 452,
        '}', 483,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(173);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 174:
      ADVANCE_MAP(
        '!', 424,
        '"', 544,
        '#', 305,
        '%', 448,
        '&', 458,
        '\'', 535,
        '(', 422,
        '*', 444,
        '+', 438,
        ',', 363,
        '-', 428,
        '.', 509,
        '/', 446,
        '0', 517,
        ':', 477,
        ';', 478,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        'F', 587,
        'L', 561,
        'R', 564,
        'T', 591,
        'U', 565,
        '[', 485,
        '\\', 12,
        '^', 455,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 596,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        't', 638,
        'u', 568,
        'v', 630,
        '{', 482,
        '|', 452,
        '}', 483,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(174);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 175:
      ADVANCE_MAP(
        '!', 424,
        '"', 544,
        '#', 305,
        '%', 447,
        '&', 457,
        '\'', 535,
        '(', 422,
        ')', 364,
        '*', 443,
        '+', 439,
        ',', 363,
        '-', 429,
        '.', 509,
        '/', 445,
        '0', 517,
        ':', 477,
        ';', 478,
        '<', 470,
        '=', 288,
        '>', 462,
        '?', 493,
        'F', 587,
        'L', 561,
        'R', 564,
        'T', 591,
        'U', 565,
        '[', 485,
        '\\', 125,
        ']', 488,
        '^', 454,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 596,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        't', 638,
        'u', 568,
        'v', 630,
        '{', 482,
        '|', 453,
        '}', 483,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(175);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 176:
      ADVANCE_MAP(
        '!', 424,
        '"', 544,
        '#', 310,
        '%', 448,
        '&', 458,
        '\'', 535,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 438,
        ',', 363,
        '-', 428,
        '.', 509,
        '/', 446,
        '0', 517,
        ':', 477,
        ';', 478,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        'F', 587,
        'L', 561,
        'R', 564,
        'T', 591,
        'U', 565,
        '[', 484,
        '\\', 151,
        ']', 488,
        '^', 455,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 596,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        't', 638,
        'u', 568,
        'v', 630,
        '{', 482,
        '|', 452,
        '}', 483,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(176);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 177:
      ADVANCE_MAP(
        '!', 424,
        '"', 544,
        '#', 310,
        '%', 447,
        '&', 457,
        '\'', 535,
        '(', 422,
        ')', 364,
        '*', 443,
        '+', 439,
        ',', 363,
        '-', 429,
        '.', 509,
        '/', 445,
        '0', 517,
        ':', 477,
        ';', 478,
        '<', 470,
        '=', 288,
        '>', 462,
        '?', 493,
        'F', 587,
        'L', 561,
        'R', 564,
        'T', 591,
        'U', 565,
        '[', 484,
        '\\', 163,
        ']', 488,
        '^', 454,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 596,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        't', 638,
        'u', 568,
        'v', 630,
        '{', 482,
        '|', 453,
        '}', 483,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(177);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 178:
      ADVANCE_MAP(
        '!', 424,
        '"', 544,
        '%', 448,
        '&', 458,
        '\'', 535,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 438,
        ',', 363,
        '-', 427,
        '.', 509,
        '/', 446,
        '0', 517,
        ':', 286,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        'F', 587,
        'L', 561,
        'R', 564,
        'T', 591,
        'U', 565,
        '[', 484,
        '\\', 26,
        '^', 455,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 596,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        't', 638,
        'u', 568,
        'v', 630,
        '{', 482,
        '|', 452,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(178);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 179:
      ADVANCE_MAP(
        '!', 424,
        '"', 544,
        '%', 448,
        '&', 458,
        '\'', 535,
        '(', 422,
        '*', 444,
        '+', 438,
        ',', 363,
        '-', 428,
        '.', 509,
        '/', 446,
        '0', 517,
        ':', 286,
        '<', 468,
        '=', 490,
        '>', 660,
        '?', 493,
        'F', 587,
        'L', 561,
        'R', 564,
        'T', 591,
        'U', 565,
        '[', 484,
        '\\', 28,
        '^', 455,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 596,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        't', 638,
        'u', 568,
        'v', 630,
        '{', 482,
        '|', 452,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(179);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 180:
      ADVANCE_MAP(
        '!', 424,
        '"', 544,
        '%', 447,
        '&', 457,
        '\'', 535,
        '(', 422,
        '*', 443,
        '+', 439,
        ',', 363,
        '-', 429,
        '.', 509,
        '/', 445,
        '0', 517,
        ':', 286,
        '<', 470,
        '=', 288,
        '>', 660,
        '?', 493,
        'F', 587,
        'L', 561,
        'R', 564,
        'T', 591,
        'U', 565,
        '[', 484,
        '\\', 127,
        '^', 454,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 596,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        't', 638,
        'u', 568,
        'v', 630,
        '{', 482,
        '|', 453,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(180);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 181:
      ADVANCE_MAP(
        '!', 424,
        '"', 249,
        '%', 448,
        '&', 458,
        '(', 268,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 431,
        '/', 446,
        ':', 286,
        '<', 468,
        '=', 490,
        '>', 463,
        '[', 298,
        '\\', 22,
        '^', 455,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 625,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        'u', 618,
        'v', 630,
        '|', 452,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(181);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 182:
      ADVANCE_MAP(
        '!', 424,
        '"', 249,
        '%', 448,
        '&', 458,
        '(', 268,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 431,
        '/', 446,
        '<', 468,
        '=', 490,
        '>', 463,
        '[', 299,
        '\\', 86,
        '^', 455,
        '|', 452,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(182);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 183:
      ADVANCE_MAP(
        '!', 423,
        '"', 544,
        '#', 301,
        '&', 457,
        '\'', 535,
        '(', 422,
        '*', 443,
        '+', 439,
        ',', 363,
        '-', 430,
        '.', 330,
        '/', 270,
        '0', 517,
        ':', 477,
        ';', 478,
        '<', 467,
        '>', 289,
        'F', 587,
        'L', 561,
        'R', 564,
        'T', 591,
        'U', 565,
        '[', 485,
        '\\', 6,
        ']', 300,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 596,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        't', 638,
        'u', 568,
        'v', 630,
        '{', 482,
        '|', 451,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(183);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 184:
      ADVANCE_MAP(
        '!', 423,
        '"', 544,
        '#', 305,
        '%', 447,
        '&', 457,
        '\'', 535,
        '(', 422,
        ')', 364,
        '*', 443,
        '+', 439,
        ',', 363,
        '-', 430,
        '.', 511,
        '/', 445,
        '0', 517,
        ':', 477,
        ';', 478,
        '<', 467,
        '=', 489,
        '>', 660,
        'F', 587,
        'L', 561,
        'R', 564,
        'T', 591,
        'U', 565,
        '[', 485,
        '\\', 4,
        ']', 488,
        '^', 454,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 596,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        't', 638,
        'u', 568,
        'v', 630,
        '{', 482,
        '|', 324,
        '}', 483,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(184);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 185:
      ADVANCE_MAP(
        '!', 423,
        '"', 544,
        '#', 309,
        '&', 456,
        '\'', 535,
        '(', 422,
        ')', 364,
        '*', 443,
        '+', 439,
        '-', 430,
        '.', 276,
        '/', 270,
        '0', 517,
        ':', 477,
        ';', 478,
        '<', 467,
        '>', 292,
        'F', 587,
        'L', 561,
        'R', 564,
        'T', 591,
        'U', 565,
        '[', 485,
        '\\', 10,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 596,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        't', 638,
        'u', 568,
        'v', 630,
        '{', 482,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(185);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 186:
      ADVANCE_MAP(
        '!', 423,
        '"', 544,
        '#', 303,
        '&', 457,
        '\'', 535,
        '(', 422,
        '*', 443,
        '+', 439,
        '-', 430,
        '.', 330,
        '/', 270,
        '0', 517,
        ':', 477,
        ';', 478,
        '<', 467,
        '>', 461,
        'F', 587,
        'L', 561,
        'R', 564,
        'T', 591,
        'U', 565,
        '[', 485,
        '\\', 8,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 596,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        't', 638,
        'u', 568,
        'v', 630,
        '{', 482,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(186);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 187:
      ADVANCE_MAP(
        '!', 423,
        '"', 544,
        '&', 457,
        '\'', 535,
        '(', 422,
        ')', 364,
        '*', 443,
        '+', 439,
        ',', 363,
        '-', 430,
        '.', 511,
        '/', 270,
        '0', 517,
        ':', 286,
        ';', 478,
        '<', 291,
        '=', 489,
        '>', 660,
        'F', 587,
        'L', 561,
        'R', 564,
        'T', 591,
        'U', 565,
        '[', 484,
        '\\', 16,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 596,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        't', 638,
        'u', 568,
        'v', 630,
        '{', 482,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(187);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 188:
      ADVANCE_MAP(
        '!', 423,
        '"', 544,
        '&', 456,
        '\'', 535,
        '(', 422,
        ')', 364,
        '*', 443,
        '+', 439,
        ',', 363,
        '-', 430,
        '.', 511,
        '/', 270,
        '0', 517,
        ':', 477,
        ';', 478,
        '<', 467,
        '=', 489,
        '>', 660,
        'F', 587,
        'L', 561,
        'R', 564,
        'T', 591,
        'U', 565,
        '[', 484,
        '\\', 24,
        ']', 488,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 596,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        't', 638,
        'u', 568,
        'v', 630,
        '{', 482,
        '}', 483,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(188);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 189:
      ADVANCE_MAP(
        '!', 423,
        '"', 544,
        '&', 456,
        '\'', 535,
        '(', 422,
        '*', 443,
        '+', 439,
        '-', 429,
        '.', 330,
        '/', 270,
        '0', 517,
        ':', 286,
        '<', 467,
        'F', 587,
        'L', 561,
        'R', 564,
        'T', 591,
        'U', 565,
        '[', 485,
        '\\', 36,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 596,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        't', 638,
        'u', 568,
        'v', 630,
        '{', 482,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(189);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 190:
      ADVANCE_MAP(
        '!', 423,
        '\'', 535,
        '(', 422,
        ')', 364,
        '+', 441,
        '-', 434,
        '.', 330,
        '/', 270,
        '0', 517,
        'L', 579,
        'U', 580,
        '\\', 98,
        'u', 581,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(190);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 191:
      ADVANCE_MAP(
        '!', 287,
        '"', 544,
        '#', 310,
        '%', 448,
        '&', 458,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 432,
        '.', 508,
        '/', 446,
        ':', 477,
        ';', 478,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        'L', 562,
        'R', 564,
        'U', 566,
        '[', 484,
        '\\', 50,
        ']', 488,
        '^', 455,
        'u', 569,
        '{', 482,
        '|', 452,
        '}', 483,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(191);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 192:
      ADVANCE_MAP(
        '!', 287,
        '"', 544,
        '#', 310,
        '%', 448,
        '&', 458,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 432,
        '.', 508,
        '/', 446,
        ':', 476,
        ';', 478,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        'L', 562,
        'R', 564,
        'U', 566,
        '[', 484,
        '\\', 68,
        ']', 488,
        '^', 455,
        'u', 569,
        '|', 452,
        '}', 483,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(192);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 193:
      ADVANCE_MAP(
        '!', 287,
        '"', 544,
        '#', 310,
        '%', 448,
        '&', 458,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 432,
        '.', 508,
        '/', 446,
        ':', 476,
        ';', 478,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        'L', 671,
        'R', 672,
        'U', 673,
        '[', 484,
        '\\', 68,
        ']', 488,
        '^', 455,
        'u', 674,
        '|', 452,
        '}', 483,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(192);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(680);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 194:
      ADVANCE_MAP(
        '!', 287,
        '"', 544,
        '#', 310,
        '%', 447,
        '&', 457,
        '(', 422,
        ')', 364,
        '*', 443,
        '+', 437,
        ',', 363,
        '-', 433,
        '.', 508,
        '/', 445,
        ':', 476,
        ';', 478,
        '<', 470,
        '=', 288,
        '>', 462,
        '?', 493,
        'L', 562,
        'R', 564,
        'U', 566,
        '[', 484,
        '\\', 141,
        ']', 488,
        '^', 454,
        'u', 569,
        '|', 453,
        '}', 483,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(194);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 195:
      ADVANCE_MAP(
        '!', 287,
        '"', 544,
        '#', 310,
        '%', 447,
        '&', 457,
        '(', 422,
        ')', 364,
        '*', 443,
        '+', 437,
        ',', 363,
        '-', 433,
        '.', 508,
        '/', 445,
        ':', 476,
        ';', 478,
        '<', 470,
        '=', 288,
        '>', 462,
        '?', 493,
        'L', 671,
        'R', 672,
        'U', 673,
        '[', 484,
        '\\', 141,
        ']', 488,
        '^', 454,
        'u', 674,
        '|', 453,
        '}', 483,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(194);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(680);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 196:
      ADVANCE_MAP(
        '!', 287,
        '"', 544,
        '%', 448,
        '&', 458,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 431,
        '.', 508,
        '/', 446,
        ':', 477,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        'L', 562,
        'R', 564,
        'U', 566,
        '[', 485,
        '\\', 32,
        '^', 455,
        'u', 569,
        '{', 482,
        '|', 452,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(196);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 197:
      ADVANCE_MAP(
        '!', 287,
        '"', 544,
        '%', 448,
        '&', 458,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 431,
        '.', 508,
        '/', 446,
        ':', 286,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        'L', 562,
        'R', 564,
        'U', 566,
        '[', 484,
        '\\', 46,
        '^', 455,
        'u', 569,
        '{', 482,
        '|', 452,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(197);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 198:
      ADVANCE_MAP(
        '!', 287,
        '"', 544,
        '%', 448,
        '&', 458,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 431,
        '.', 508,
        '/', 446,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        'L', 562,
        'R', 564,
        'U', 566,
        '[', 484,
        '\\', 72,
        '^', 455,
        'u', 569,
        '|', 452,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(198);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 199:
      ADVANCE_MAP(
        '!', 287,
        '"', 544,
        '%', 448,
        '&', 458,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 431,
        '.', 508,
        '/', 446,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        'L', 671,
        'R', 672,
        'U', 673,
        '[', 484,
        '\\', 72,
        '^', 455,
        'u', 674,
        '|', 452,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(198);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(680);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 200:
      ADVANCE_MAP(
        '!', 287,
        '"', 544,
        '%', 448,
        '&', 458,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 432,
        '.', 508,
        '/', 446,
        ':', 477,
        ';', 478,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        'L', 562,
        'R', 564,
        'U', 566,
        '[', 485,
        '\\', 30,
        '^', 455,
        'u', 569,
        '{', 482,
        '|', 452,
        '}', 483,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(200);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 201:
      ADVANCE_MAP(
        '!', 287,
        '"', 544,
        '%', 448,
        '&', 458,
        '(', 422,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 432,
        '.', 508,
        '/', 446,
        ':', 477,
        '<', 468,
        '=', 490,
        '>', 660,
        '?', 493,
        'L', 562,
        'R', 564,
        'U', 566,
        '[', 484,
        '\\', 48,
        '^', 455,
        'u', 569,
        '{', 482,
        '|', 452,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(201);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 202:
      ADVANCE_MAP(
        '!', 287,
        '"', 544,
        '%', 448,
        '&', 458,
        '(', 422,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 432,
        '.', 508,
        '/', 446,
        '<', 468,
        '=', 490,
        '>', 660,
        '?', 493,
        'L', 562,
        'R', 564,
        'U', 566,
        '[', 484,
        '\\', 74,
        '^', 455,
        'u', 569,
        '|', 452,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(202);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 203:
      ADVANCE_MAP(
        '!', 287,
        '"', 544,
        '%', 448,
        '&', 458,
        '(', 422,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 432,
        '.', 508,
        '/', 446,
        '<', 468,
        '=', 490,
        '>', 660,
        '?', 493,
        'L', 671,
        'R', 672,
        'U', 673,
        '[', 484,
        '\\', 74,
        '^', 455,
        'u', 674,
        '|', 452,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(202);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(680);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 204:
      ADVANCE_MAP(
        '!', 287,
        '"', 544,
        '%', 447,
        '&', 457,
        '(', 422,
        '*', 443,
        '+', 437,
        ',', 363,
        '-', 433,
        '.', 508,
        '/', 445,
        '<', 470,
        '=', 288,
        '>', 660,
        '?', 493,
        'L', 562,
        'R', 564,
        'U', 566,
        '[', 484,
        '\\', 143,
        '^', 454,
        'u', 569,
        '|', 453,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(204);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 205:
      ADVANCE_MAP(
        '!', 287,
        '"', 544,
        '%', 447,
        '&', 457,
        '(', 422,
        '*', 443,
        '+', 437,
        ',', 363,
        '-', 433,
        '.', 508,
        '/', 445,
        '<', 470,
        '=', 288,
        '>', 660,
        '?', 493,
        'L', 671,
        'R', 672,
        'U', 673,
        '[', 484,
        '\\', 143,
        '^', 454,
        'u', 674,
        '|', 453,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(204);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(680);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 206:
      ADVANCE_MAP(
        '!', 287,
        '#', 321,
        '%', 448,
        '&', 458,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 431,
        '.', 508,
        '/', 446,
        ':', 477,
        ';', 478,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        '[', 485,
        '\\', 38,
        '^', 455,
        '{', 482,
        '|', 452,
        '}', 483,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(206);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 207:
      ADVANCE_MAP(
        '!', 287,
        '#', 310,
        '%', 448,
        '&', 458,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 432,
        '.', 508,
        '/', 446,
        '0', 661,
        ':', 477,
        ';', 478,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        '[', 485,
        '\\', 34,
        ']', 488,
        '^', 455,
        '{', 482,
        '|', 452,
        '}', 483,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(207);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 208:
      ADVANCE_MAP(
        '!', 287,
        '#', 310,
        '%', 448,
        '&', 458,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 432,
        '.', 508,
        '/', 446,
        ':', 477,
        ';', 478,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        '[', 484,
        '\\', 52,
        ']', 488,
        '^', 455,
        '{', 482,
        '|', 452,
        '}', 483,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(208);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 209:
      ADVANCE_MAP(
        '!', 287,
        '#', 310,
        '%', 448,
        '&', 458,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 432,
        '.', 508,
        '/', 446,
        ':', 476,
        ';', 478,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        '[', 485,
        '\\', 165,
        ']', 488,
        '^', 455,
        '{', 482,
        '|', 452,
        '}', 483,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(209);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 210:
      ADVANCE_MAP(
        '!', 287,
        '#', 310,
        '%', 448,
        '&', 458,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 432,
        '.', 508,
        '/', 446,
        ':', 476,
        ';', 478,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        '[', 484,
        '\\', 44,
        ']', 488,
        '^', 455,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 625,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        'u', 618,
        'v', 630,
        '{', 482,
        '|', 452,
        '}', 483,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(210);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 211:
      ADVANCE_MAP(
        '!', 287,
        '#', 310,
        '%', 448,
        '&', 458,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 432,
        '.', 508,
        '/', 446,
        ':', 476,
        ';', 478,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        '[', 484,
        '\\', 131,
        ']', 488,
        '^', 455,
        '{', 482,
        '|', 452,
        '}', 483,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(211);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 212:
      ADVANCE_MAP(
        '!', 287,
        '#', 310,
        '%', 448,
        '&', 458,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 432,
        '.', 508,
        '/', 446,
        ':', 476,
        ';', 478,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        '[', 484,
        '\\', 145,
        ']', 488,
        '^', 455,
        '|', 452,
        '}', 483,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(213);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(680);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 213:
      ADVANCE_MAP(
        '!', 287,
        '#', 310,
        '%', 448,
        '&', 458,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 432,
        '.', 508,
        '/', 446,
        ':', 476,
        ';', 478,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        '[', 484,
        '\\', 145,
        ']', 488,
        '^', 455,
        '|', 452,
        '}', 483,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(213);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 214:
      ADVANCE_MAP(
        '!', 287,
        '#', 310,
        '%', 448,
        '&', 458,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 432,
        '.', 508,
        '/', 446,
        ':', 476,
        ';', 478,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        '[', 487,
        '\\', 76,
        ']', 488,
        '^', 455,
        '|', 452,
        '}', 483,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(214);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 215:
      ADVANCE_MAP(
        '!', 287,
        '#', 310,
        '%', 447,
        '&', 457,
        '(', 422,
        ')', 364,
        '*', 443,
        '+', 437,
        ',', 363,
        '-', 433,
        '.', 508,
        '/', 445,
        ':', 477,
        ';', 478,
        '<', 470,
        '=', 288,
        '>', 462,
        '?', 493,
        '[', 484,
        '\\', 171,
        ']', 488,
        '^', 454,
        '{', 482,
        '|', 453,
        '}', 483,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(215);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 216:
      ADVANCE_MAP(
        '!', 287,
        '#', 310,
        '%', 447,
        '&', 457,
        '(', 422,
        ')', 364,
        '*', 443,
        '+', 437,
        ',', 363,
        '-', 433,
        '.', 508,
        '/', 445,
        ':', 476,
        ';', 478,
        '<', 470,
        '=', 288,
        '>', 462,
        '?', 493,
        '[', 484,
        '\\', 129,
        ']', 488,
        '^', 454,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 625,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        'u', 618,
        'v', 630,
        '{', 482,
        '|', 453,
        '}', 483,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(216);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 217:
      ADVANCE_MAP(
        '!', 287,
        '#', 310,
        '%', 447,
        '&', 457,
        '(', 422,
        ')', 364,
        '*', 443,
        '+', 437,
        ',', 363,
        '-', 433,
        '.', 508,
        '/', 445,
        ':', 476,
        ';', 478,
        '<', 470,
        '=', 288,
        '>', 462,
        '?', 493,
        '[', 484,
        '\\', 153,
        ']', 488,
        '^', 454,
        '{', 482,
        '|', 453,
        '}', 483,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(217);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 218:
      ADVANCE_MAP(
        '!', 287,
        '#', 310,
        '%', 447,
        '&', 457,
        '(', 422,
        ')', 364,
        '*', 443,
        '+', 437,
        ',', 363,
        '-', 433,
        '.', 508,
        '/', 445,
        ':', 476,
        ';', 478,
        '<', 470,
        '=', 288,
        '>', 462,
        '?', 493,
        '[', 484,
        '\\', 157,
        ']', 488,
        '^', 454,
        '|', 453,
        '}', 483,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(219);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(680);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 219:
      ADVANCE_MAP(
        '!', 287,
        '#', 310,
        '%', 447,
        '&', 457,
        '(', 422,
        ')', 364,
        '*', 443,
        '+', 437,
        ',', 363,
        '-', 433,
        '.', 508,
        '/', 445,
        ':', 476,
        ';', 478,
        '<', 470,
        '=', 288,
        '>', 462,
        '?', 493,
        '[', 484,
        '\\', 157,
        ']', 488,
        '^', 454,
        '|', 453,
        '}', 483,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(219);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 220:
      ADVANCE_MAP(
        '!', 287,
        '#', 304,
        '%', 447,
        '&', 457,
        '(', 422,
        ')', 364,
        '*', 443,
        '+', 436,
        ',', 363,
        '-', 426,
        '/', 445,
        ':', 286,
        ';', 478,
        '<', 471,
        '=', 288,
        '>', 462,
        '[', 485,
        '\\', 20,
        '^', 454,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 625,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        'u', 618,
        'v', 630,
        '|', 453,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(220);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 221:
      ADVANCE_MAP(
        '!', 287,
        '%', 448,
        '&', 458,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 431,
        '.', 508,
        '/', 446,
        ':', 477,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        '[', 484,
        '\\', 60,
        '^', 455,
        '{', 482,
        '|', 452,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(221);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 222:
      ADVANCE_MAP(
        '!', 287,
        '%', 448,
        '&', 458,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 431,
        '.', 508,
        '/', 446,
        ':', 476,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        '[', 484,
        '\\', 135,
        '^', 455,
        '{', 482,
        '|', 452,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(222);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 223:
      ADVANCE_MAP(
        '!', 287,
        '%', 448,
        '&', 458,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 431,
        '.', 508,
        '/', 446,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        '[', 486,
        '\\', 84,
        '^', 455,
        '|', 452,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(223);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 224:
      ADVANCE_MAP(
        '!', 287,
        '%', 448,
        '&', 458,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 431,
        '.', 508,
        '/', 446,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        '[', 484,
        '\\', 56,
        '^', 455,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 625,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        'u', 618,
        'v', 630,
        '{', 482,
        '|', 452,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(224);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 225:
      ADVANCE_MAP(
        '!', 287,
        '%', 448,
        '&', 458,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 431,
        '.', 508,
        '/', 446,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        '[', 484,
        '\\', 149,
        '^', 455,
        '|', 452,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(226);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(680);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 226:
      ADVANCE_MAP(
        '!', 287,
        '%', 448,
        '&', 458,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 431,
        '.', 508,
        '/', 446,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        '[', 484,
        '\\', 149,
        '^', 455,
        '|', 452,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(226);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 227:
      ADVANCE_MAP(
        '!', 287,
        '%', 448,
        '&', 458,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 431,
        '.', 508,
        '/', 446,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        '[', 487,
        '\\', 161,
        '^', 455,
        '|', 452,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(227);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 228:
      ADVANCE_MAP(
        '!', 287,
        '%', 448,
        '&', 458,
        '(', 422,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 432,
        '.', 508,
        '/', 446,
        ':', 477,
        '<', 468,
        '=', 490,
        '>', 660,
        '?', 493,
        '[', 484,
        '\\', 64,
        '^', 455,
        '{', 482,
        '|', 452,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(228);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 229:
      ADVANCE_MAP(
        '!', 287,
        '%', 448,
        '&', 458,
        '(', 422,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 432,
        '.', 508,
        '/', 446,
        ':', 476,
        '<', 468,
        '=', 490,
        '>', 660,
        '?', 493,
        '[', 484,
        '\\', 155,
        '^', 455,
        '{', 482,
        '|', 452,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(229);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 230:
      ADVANCE_MAP(
        '!', 287,
        '%', 448,
        '&', 458,
        '(', 422,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 432,
        '.', 508,
        '/', 446,
        ';', 478,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        '[', 486,
        '\\', 80,
        '^', 455,
        '|', 452,
        '}', 483,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(230);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 231:
      ADVANCE_MAP(
        '!', 287,
        '%', 448,
        '&', 458,
        '(', 422,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 432,
        '.', 508,
        '/', 446,
        '<', 468,
        '=', 490,
        '>', 660,
        '?', 493,
        '[', 485,
        '\\', 78,
        '^', 455,
        '|', 452,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(231);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 232:
      ADVANCE_MAP(
        '!', 287,
        '%', 448,
        '&', 458,
        '(', 422,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 432,
        '.', 508,
        '/', 446,
        '<', 468,
        '=', 490,
        '>', 660,
        '?', 493,
        '[', 484,
        '\\', 58,
        '^', 455,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 625,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        'u', 618,
        'v', 630,
        '{', 482,
        '|', 452,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(232);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 233:
      ADVANCE_MAP(
        '!', 287,
        '%', 448,
        '&', 458,
        '(', 422,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 432,
        '.', 508,
        '/', 446,
        '<', 468,
        '=', 490,
        '>', 660,
        '?', 493,
        '[', 484,
        '\\', 159,
        '^', 455,
        '|', 452,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(234);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(680);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 234:
      ADVANCE_MAP(
        '!', 287,
        '%', 448,
        '&', 458,
        '(', 422,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 432,
        '.', 508,
        '/', 446,
        '<', 468,
        '=', 490,
        '>', 660,
        '?', 493,
        '[', 484,
        '\\', 159,
        '^', 455,
        '|', 452,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(234);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 235:
      ADVANCE_MAP(
        '!', 287,
        '%', 448,
        '&', 458,
        '(', 422,
        '*', 444,
        '+', 440,
        ',', 363,
        '-', 432,
        '.', 508,
        '/', 446,
        '<', 468,
        '=', 490,
        '>', 660,
        '?', 493,
        '[', 487,
        '\\', 147,
        '^', 455,
        '|', 452,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(235);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 236:
      ADVANCE_MAP(
        '!', 287,
        '%', 448,
        '&', 458,
        '*', 444,
        '+', 442,
        ',', 363,
        '-', 435,
        '.', 269,
        '/', 446,
        '<', 469,
        '=', 490,
        '>', 463,
        '\\', 94,
        '^', 455,
        '|', 452,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(236);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 237:
      ADVANCE_MAP(
        '!', 287,
        '%', 447,
        '&', 457,
        '(', 422,
        ')', 364,
        '*', 443,
        '+', 437,
        ',', 363,
        '-', 433,
        '.', 508,
        '/', 445,
        ':', 477,
        ';', 478,
        '<', 470,
        '=', 288,
        '>', 462,
        '?', 493,
        '[', 485,
        '\\', 40,
        '^', 454,
        '{', 482,
        '|', 453,
        '}', 483,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(237);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 238:
      ADVANCE_MAP(
        '!', 287,
        '%', 447,
        '&', 457,
        '(', 422,
        ')', 364,
        '*', 443,
        '+', 437,
        ',', 363,
        '-', 433,
        '.', 508,
        '/', 445,
        ':', 477,
        ';', 478,
        '<', 470,
        '=', 288,
        '>', 462,
        '?', 493,
        '[', 484,
        '\\', 66,
        ']', 488,
        '^', 454,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 625,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        'u', 618,
        'v', 630,
        '{', 482,
        '|', 453,
        '}', 483,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(238);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 239:
      ADVANCE_MAP(
        '!', 287,
        '%', 447,
        '&', 457,
        '(', 422,
        ')', 364,
        '*', 443,
        '+', 437,
        ',', 363,
        '-', 433,
        '.', 508,
        '/', 445,
        ':', 286,
        ';', 478,
        '<', 470,
        '=', 288,
        '>', 462,
        '?', 493,
        '[', 484,
        '\\', 139,
        ']', 300,
        '^', 454,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 625,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        'u', 618,
        'v', 630,
        '{', 482,
        '|', 453,
        '}', 483,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(239);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 240:
      ADVANCE_MAP(
        '!', 287,
        '%', 447,
        '&', 457,
        '(', 422,
        '*', 443,
        '+', 437,
        ',', 363,
        '-', 433,
        '.', 508,
        '/', 445,
        ':', 477,
        '<', 470,
        '=', 490,
        '>', 660,
        '?', 493,
        '[', 484,
        '\\', 137,
        '^', 454,
        '{', 482,
        '|', 453,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(240);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 241:
      ADVANCE_MAP(
        '!', 287,
        '%', 447,
        '&', 457,
        '(', 422,
        '*', 443,
        '+', 437,
        ',', 363,
        '-', 433,
        '.', 508,
        '/', 445,
        ':', 476,
        '<', 470,
        '=', 288,
        '>', 660,
        '?', 493,
        '[', 484,
        '\\', 167,
        '^', 454,
        '{', 482,
        '|', 453,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(241);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 242:
      ADVANCE_MAP(
        '!', 287,
        '%', 447,
        '&', 457,
        '(', 422,
        '*', 443,
        '+', 437,
        ',', 363,
        '-', 433,
        '.', 508,
        '/', 445,
        '<', 470,
        '=', 288,
        '>', 660,
        '?', 493,
        '[', 484,
        '\\', 133,
        '^', 454,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 625,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        'u', 618,
        'v', 630,
        '{', 482,
        '|', 453,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(242);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 243:
      ADVANCE_MAP(
        '!', 287,
        '%', 447,
        '&', 457,
        '(', 422,
        '*', 443,
        '+', 437,
        ',', 363,
        '-', 433,
        '.', 508,
        '/', 445,
        '<', 470,
        '=', 288,
        '>', 660,
        '?', 493,
        '[', 484,
        '\\', 169,
        '^', 454,
        '|', 453,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(244);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(680);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 244:
      ADVANCE_MAP(
        '!', 287,
        '%', 447,
        '&', 457,
        '(', 422,
        '*', 443,
        '+', 437,
        ',', 363,
        '-', 433,
        '.', 508,
        '/', 445,
        '<', 470,
        '=', 288,
        '>', 660,
        '?', 493,
        '[', 484,
        '\\', 169,
        '^', 454,
        '|', 453,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(244);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 245:
      ADVANCE_MAP(
        '"', 544,
        '&', 457,
        '(', 422,
        '*', 443,
        '/', 270,
        ':', 286,
        'L', 563,
        'U', 567,
        '[', 485,
        '\\', 54,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 625,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        'u', 570,
        'v', 630,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(245);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 246:
      ADVANCE_MAP(
        '"', 544,
        ')', 364,
        ',', 363,
        '/', 270,
        ':', 476,
        'L', 562,
        'R', 564,
        'U', 566,
        '\\', 109,
        'u', 569,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(246);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 247:
      ADVANCE_MAP(
        '"', 544,
        '/', 270,
        ':', 476,
        '<', 294,
        'L', 563,
        'U', 567,
        '\\', 113,
        'u', 571,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(247);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 248:
      if (lookahead == '"') ADVANCE(544);
      if (lookahead == '/') ADVANCE(270);
      if (lookahead == '\\') ADVANCE(115);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(248);
      END_STATE();
    case 249:
      if (lookahead == '"') ADVANCE(670);
      END_STATE();
    case 250:
      ADVANCE_MAP(
        '#', 306,
        '&', 457,
        '(', 422,
        '*', 443,
        ',', 363,
        '-', 293,
        '/', 270,
        ':', 286,
        ';', 478,
        '[', 485,
        '\\', 18,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 625,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        'u', 618,
        'v', 630,
        '{', 482,
        '|', 324,
        '}', 483,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(250);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 251:
      ADVANCE_MAP(
        '#', 310,
        '&', 457,
        '(', 422,
        ')', 364,
        '*', 443,
        ',', 363,
        '-', 293,
        '.', 510,
        '/', 270,
        ':', 477,
        ';', 478,
        '<', 467,
        '=', 489,
        '>', 660,
        '[', 485,
        '\\', 42,
        ']', 488,
        '{', 482,
        '|', 324,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(251);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 252:
      ADVANCE_MAP(
        '#', 302,
        '&', 457,
        '(', 422,
        ')', 364,
        '*', 443,
        '+', 436,
        ',', 363,
        '-', 293,
        '.', 510,
        '/', 270,
        ':', 477,
        ';', 478,
        '<', 467,
        '=', 489,
        '>', 660,
        '[', 485,
        '\\', 14,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 625,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        'u', 618,
        'v', 630,
        '{', 482,
        '|', 324,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(252);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 253:
      ADVANCE_MAP(
        '&', 457,
        '(', 422,
        ')', 364,
        '*', 443,
        ',', 363,
        '-', 293,
        '.', 510,
        '/', 270,
        ':', 477,
        ';', 478,
        '<', 467,
        '=', 489,
        '>', 660,
        '[', 484,
        '\\', 70,
        '{', 482,
        '|', 324,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(253);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 254:
      ADVANCE_MAP(
        '&', 457,
        '(', 422,
        ')', 364,
        '*', 443,
        ',', 363,
        '-', 293,
        '.', 510,
        '/', 270,
        ':', 476,
        ';', 478,
        '<', 467,
        '=', 489,
        '>', 660,
        '[', 485,
        '\\', 62,
        ']', 488,
        '{', 482,
        '|', 324,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(254);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 255:
      ADVANCE_MAP(
        '&', 457,
        '(', 422,
        ')', 364,
        '*', 443,
        ',', 363,
        '-', 293,
        '.', 510,
        '/', 270,
        ':', 476,
        ';', 478,
        '=', 489,
        '>', 660,
        '[', 485,
        '\\', 82,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 625,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        'u', 618,
        'v', 630,
        '{', 482,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(255);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 256:
      ADVANCE_MAP(
        '&', 457,
        '(', 422,
        ')', 364,
        '*', 443,
        ',', 363,
        '-', 293,
        '.', 510,
        '/', 270,
        ':', 476,
        ';', 478,
        '=', 489,
        '>', 660,
        '[', 484,
        '\\', 88,
        '{', 482,
        '|', 324,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(256);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 257:
      ADVANCE_MAP(
        '&', 457,
        '(', 422,
        ')', 364,
        '*', 443,
        ',', 363,
        '.', 510,
        '/', 270,
        ':', 476,
        ';', 478,
        '=', 489,
        '>', 660,
        '[', 484,
        '\\', 90,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 625,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        'u', 618,
        'v', 630,
        '{', 482,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(257);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 258:
      ADVANCE_MAP(
        '&', 457,
        '(', 422,
        ')', 364,
        '*', 443,
        ',', 363,
        '.', 507,
        '/', 270,
        ':', 477,
        ';', 478,
        '<', 467,
        '[', 484,
        '\\', 92,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 625,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        'u', 618,
        'v', 630,
        '{', 482,
        '|', 324,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(258);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 259:
      ADVANCE_MAP(
        '&', 456,
        '(', 422,
        ')', 364,
        ',', 363,
        '.', 275,
        '/', 270,
        ':', 476,
        ';', 478,
        '=', 489,
        '>', 660,
        '[', 484,
        '\\', 105,
        '{', 482,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(259);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 260:
      ADVANCE_MAP(
        '&', 456,
        '(', 422,
        ')', 364,
        ',', 363,
        '/', 270,
        ':', 476,
        ';', 478,
        '=', 489,
        '>', 660,
        '[', 485,
        '\\', 107,
        '{', 482,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(260);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 261:
      ADVANCE_MAP(
        '&', 456,
        '*', 443,
        '.', 275,
        '/', 270,
        ':', 286,
        '=', 489,
        '\\', 103,
        ']', 488,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(261);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 262:
      if (lookahead == '\'') ADVANCE(535);
      if (lookahead == '/') ADVANCE(270);
      if (lookahead == '\\') ADVANCE(115);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(262);
      END_STATE();
    case 263:
      if (lookahead == '\'') ADVANCE(335);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(325);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(263);
      END_STATE();
    case 264:
      if (lookahead == '\'') ADVANCE(331);
      if (lookahead == '.') ADVANCE(524);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(325);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(264);
      END_STATE();
    case 265:
      ADVANCE_MAP(
        '(', 422,
        ')', 364,
        ',', 363,
        '/', 270,
        ':', 476,
        ';', 478,
        '<', 467,
        '=', 489,
        '>', 660,
        '[', 486,
        '\\', 111,
        ']', 488,
        '{', 482,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(265);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 266:
      ADVANCE_MAP(
        '(', 422,
        '/', 270,
        ':', 286,
        'F', 587,
        'T', 591,
        '[', 484,
        '\\', 96,
        'f', 597,
        't', 638,
        '{', 482,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(266);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 267:
      if (lookahead == '(') ADVANCE(422);
      if (lookahead == '/') ADVANCE(270);
      if (lookahead == '\\') SKIP(123);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(267);
      END_STATE();
    case 268:
      if (lookahead == ')') ADVANCE(668);
      END_STATE();
    case 269:
      if (lookahead == '*') ADVANCE(512);
      END_STATE();
    case 270:
      if (lookahead == '*') ADVANCE(273);
      if (lookahead == '/') ADVANCE(658);
      END_STATE();
    case 271:
      if (lookahead == '*') ADVANCE(667);
      END_STATE();
    case 272:
      if (lookahead == '*') ADVANCE(272);
      if (lookahead == '/') ADVANCE(651);
      if (lookahead != 0) ADVANCE(273);
      END_STATE();
    case 273:
      if (lookahead == '*') ADVANCE(272);
      if (lookahead != 0) ADVANCE(273);
      END_STATE();
    case 274:
      if (lookahead == '*') ADVANCE(272);
      if (lookahead != 0) ADVANCE(380);
      END_STATE();
    case 275:
      if (lookahead == '.') ADVANCE(277);
      END_STATE();
    case 276:
      if (lookahead == '.') ADVANCE(277);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(516);
      END_STATE();
    case 277:
      if (lookahead == '.') ADVANCE(362);
      END_STATE();
    case 278:
      if (lookahead == '.') ADVANCE(335);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(522);
      END_STATE();
    case 279:
      if (lookahead == '/') ADVANCE(387);
      if (lookahead == '\\') ADVANCE(382);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(279);
      if (lookahead != 0) ADVANCE(389);
      END_STATE();
    case 280:
      if (lookahead == '1') ADVANCE(284);
      END_STATE();
    case 281:
      if (lookahead == '2') ADVANCE(515);
      END_STATE();
    case 282:
      if (lookahead == '2') ADVANCE(285);
      if (lookahead == '6') ADVANCE(515);
      END_STATE();
    case 283:
      if (lookahead == '4') ADVANCE(515);
      END_STATE();
    case 284:
      if (lookahead == '6') ADVANCE(515);
      END_STATE();
    case 285:
      if (lookahead == '8') ADVANCE(515);
      END_STATE();
    case 286:
      if (lookahead == ':') ADVANCE(479);
      END_STATE();
    case 287:
      if (lookahead == '=') ADVANCE(460);
      END_STATE();
    case 288:
      if (lookahead == '=') ADVANCE(459);
      END_STATE();
    case 289:
      if (lookahead == '=') ADVANCE(464);
      if (lookahead == '>') ADVANCE(290);
      END_STATE();
    case 290:
      if (lookahead == '=') ADVANCE(500);
      END_STATE();
    case 291:
      if (lookahead == '=') ADVANCE(465);
      END_STATE();
    case 292:
      if (lookahead == '>') ADVANCE(474);
      END_STATE();
    case 293:
      if (lookahead == '>') ADVANCE(513);
      END_STATE();
    case 294:
      if (lookahead == '>') ADVANCE(557);
      if (lookahead == '\\') ADVANCE(295);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(294);
      END_STATE();
    case 295:
      if (lookahead == '>') ADVANCE(558);
      if (lookahead == '\\') ADVANCE(295);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(294);
      END_STATE();
    case 296:
      if (lookahead == 'F') ADVANCE(280);
      END_STATE();
    case 297:
      if (lookahead == 'U') ADVANCE(350);
      if (lookahead == 'u') ADVANCE(342);
      END_STATE();
    case 298:
      if (lookahead == '[') ADVANCE(480);
      if (lookahead == ']') ADVANCE(669);
      END_STATE();
    case 299:
      if (lookahead == ']') ADVANCE(669);
      END_STATE();
    case 300:
      if (lookahead == ']') ADVANCE(481);
      END_STATE();
    case 301:
      if (lookahead == 'd') ADVANCE(396);
      if (lookahead == 'e') ADVANCE(416);
      if (lookahead == 'i') ADVANCE(404);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(301);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 302:
      if (lookahead == 'd') ADVANCE(396);
      if (lookahead == 'e') ADVANCE(416);
      if (lookahead == 'i') ADVANCE(405);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(302);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 303:
      if (lookahead == 'd') ADVANCE(396);
      if (lookahead == 'e') ADVANCE(418);
      if (lookahead == 'i') ADVANCE(404);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(303);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 304:
      if (lookahead == 'd') ADVANCE(396);
      if (lookahead == 'e') ADVANCE(418);
      if (lookahead == 'i') ADVANCE(405);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(304);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 305:
      if (lookahead == 'd') ADVANCE(396);
      if (lookahead == 'i') ADVANCE(404);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(305);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 306:
      if (lookahead == 'd') ADVANCE(396);
      if (lookahead == 'i') ADVANCE(405);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(306);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 307:
      if (lookahead == 'd') ADVANCE(319);
      END_STATE();
    case 308:
      if (lookahead == 'd') ADVANCE(313);
      END_STATE();
    case 309:
      if (lookahead == 'e') ADVANCE(323);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(309);
      END_STATE();
    case 310:
      if (lookahead == 'e') ADVANCE(322);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(310);
      END_STATE();
    case 311:
      if (lookahead == 'e') ADVANCE(371);
      END_STATE();
    case 312:
      if (lookahead == 'e') ADVANCE(317);
      END_STATE();
    case 313:
      if (lookahead == 'e') ADVANCE(318);
      END_STATE();
    case 314:
      if (lookahead == 'f') ADVANCE(280);
      END_STATE();
    case 315:
      if (lookahead == 'f') ADVANCE(367);
      END_STATE();
    case 316:
      if (lookahead == 'f') ADVANCE(373);
      END_STATE();
    case 317:
      if (lookahead == 'f') ADVANCE(375);
      END_STATE();
    case 318:
      if (lookahead == 'f') ADVANCE(377);
      END_STATE();
    case 319:
      if (lookahead == 'i') ADVANCE(315);
      END_STATE();
    case 320:
      if (lookahead == 'i') ADVANCE(316);
      if (lookahead == 's') ADVANCE(311);
      END_STATE();
    case 321:
      if (lookahead == 'i') ADVANCE(405);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(321);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 322:
      if (lookahead == 'l') ADVANCE(320);
      if (lookahead == 'n') ADVANCE(307);
      END_STATE();
    case 323:
      if (lookahead == 'n') ADVANCE(307);
      END_STATE();
    case 324:
      if (lookahead == '|') ADVANCE(449);
      END_STATE();
    case 325:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(332);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(521);
      END_STATE();
    case 326:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(325);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(263);
      END_STATE();
    case 327:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(519);
      END_STATE();
    case 328:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(264);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(518);
      END_STATE();
    case 329:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(520);
      END_STATE();
    case 330:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(516);
      END_STATE();
    case 331:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(264);
      END_STATE();
    case 332:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(521);
      END_STATE();
    case 333:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(650);
      END_STATE();
    case 334:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(522);
      END_STATE();
    case 335:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(263);
      END_STATE();
    case 336:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(550);
      END_STATE();
    case 337:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(556);
      END_STATE();
    case 338:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(333);
      END_STATE();
    case 339:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(336);
      END_STATE();
    case 340:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(338);
      END_STATE();
    case 341:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(339);
      END_STATE();
    case 342:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(340);
      END_STATE();
    case 343:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(341);
      END_STATE();
    case 344:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(342);
      END_STATE();
    case 345:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(343);
      END_STATE();
    case 346:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(344);
      END_STATE();
    case 347:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(345);
      END_STATE();
    case 348:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(346);
      END_STATE();
    case 349:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(347);
      END_STATE();
    case 350:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(348);
      END_STATE();
    case 351:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(349);
      END_STATE();
    case 352:
      if (lookahead != 0 &&
          lookahead != '*') ADVANCE(389);
      END_STATE();
    case 353:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 424,
        '"', 544,
        '#', 301,
        '%', 448,
        '&', 458,
        '\'', 535,
        '(', 422,
        ')', 364,
        '*', 444,
        '+', 438,
        ',', 363,
        '-', 427,
        '.', 509,
        '/', 446,
        '0', 517,
        ':', 477,
        ';', 478,
        '<', 468,
        '=', 490,
        '>', 660,
        '?', 493,
        'F', 587,
        'L', 561,
        'R', 564,
        'T', 591,
        'U', 565,
        '[', 486,
        '\\', 2,
        ']', 488,
        '^', 455,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 596,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        't', 638,
        'u', 568,
        'v', 630,
        '{', 482,
        '|', 452,
        '}', 483,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(353);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 354:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 424,
        '"', 544,
        '#', 305,
        '%', 448,
        '&', 458,
        '\'', 535,
        '(', 422,
        '*', 444,
        '+', 438,
        ',', 363,
        '-', 428,
        '.', 509,
        '/', 446,
        '0', 517,
        ':', 477,
        ';', 478,
        '<', 468,
        '=', 490,
        '>', 463,
        '?', 493,
        'F', 587,
        'L', 561,
        'R', 564,
        'T', 591,
        'U', 565,
        '[', 485,
        '\\', 12,
        '^', 455,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 596,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        't', 638,
        'u', 568,
        'v', 630,
        '{', 482,
        '|', 452,
        '}', 483,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(354);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 355:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 424,
        '"', 544,
        '#', 305,
        '%', 447,
        '&', 457,
        '\'', 535,
        '(', 422,
        ')', 364,
        '*', 443,
        '+', 439,
        ',', 363,
        '-', 429,
        '.', 509,
        '/', 445,
        '0', 517,
        ':', 477,
        ';', 478,
        '<', 470,
        '=', 288,
        '>', 462,
        '?', 493,
        'F', 587,
        'L', 561,
        'R', 564,
        'T', 591,
        'U', 565,
        '[', 485,
        '\\', 125,
        ']', 488,
        '^', 454,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 596,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        't', 638,
        'u', 568,
        'v', 630,
        '{', 482,
        '|', 453,
        '}', 483,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(355);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 356:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 423,
        '"', 544,
        '#', 305,
        '%', 447,
        '&', 457,
        '\'', 535,
        '(', 422,
        ')', 364,
        '*', 443,
        '+', 439,
        ',', 363,
        '-', 430,
        '.', 511,
        '/', 445,
        '0', 517,
        ':', 477,
        ';', 478,
        '<', 467,
        '=', 489,
        '>', 660,
        'F', 587,
        'L', 561,
        'R', 564,
        'T', 591,
        'U', 565,
        '[', 485,
        '\\', 4,
        ']', 488,
        '^', 454,
        'b', 633,
        'c', 612,
        'd', 629,
        'f', 596,
        'i', 626,
        'm', 598,
        'n', 646,
        'p', 643,
        's', 613,
        't', 638,
        'u', 568,
        'v', 630,
        '{', 482,
        '|', 324,
        '}', 483,
        '~', 425,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(356);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(650);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(aux_sym_preproc_include_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(aux_sym_preproc_include_token2);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(aux_sym_preproc_def_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(aux_sym_preproc_if_token1);
      if (lookahead == 'd') ADVANCE(400);
      if (lookahead == 'n') ADVANCE(394);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(366);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (lookahead == 'd') ADVANCE(312);
      if (lookahead == 'n') ADVANCE(308);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (lookahead == 'd') ADVANCE(402);
      if (lookahead == 'n') ADVANCE(395);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token1);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token2);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(273);
      if (lookahead == '*') ADVANCE(379);
      if (lookahead == '/') ADVANCE(651);
      if (lookahead == '\\') ADVANCE(385);
      if (lookahead != 0) ADVANCE(380);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(273);
      if (lookahead == '*') ADVANCE(379);
      if (lookahead == '/') ADVANCE(274);
      if (lookahead == '\\') ADVANCE(385);
      if (lookahead != 0) ADVANCE(380);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(658);
      if (lookahead == '\r') ADVANCE(652);
      if (lookahead == '/') ADVANCE(655);
      if (lookahead == '\\') ADVANCE(654);
      if (lookahead != 0) ADVANCE(656);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(279);
      if (lookahead == '\r') ADVANCE(383);
      if (lookahead == '/') ADVANCE(352);
      if (lookahead == '\\') ADVANCE(384);
      if (lookahead != 0) ADVANCE(389);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(279);
      if (lookahead == '/') ADVANCE(352);
      if (lookahead == '\\') ADVANCE(384);
      if (lookahead != 0) ADVANCE(389);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(390);
      if (lookahead == '/') ADVANCE(352);
      if (lookahead == '\\') ADVANCE(384);
      if (lookahead != 0) ADVANCE(389);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(388);
      if (lookahead == '*') ADVANCE(379);
      if (lookahead == '/') ADVANCE(274);
      if (lookahead == '\\') ADVANCE(385);
      if (lookahead != 0) ADVANCE(380);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(657);
      if (lookahead == '/') ADVANCE(655);
      if (lookahead == '\\') ADVANCE(654);
      if (lookahead != 0) ADVANCE(656);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(380);
      if (lookahead == '/') ADVANCE(655);
      if (lookahead == '\\') ADVANCE(384);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(389);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(379);
      if (lookahead == '/') ADVANCE(274);
      if (lookahead == '\\') ADVANCE(385);
      if (lookahead != 0) ADVANCE(380);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(352);
      if (lookahead == '\\') ADVANCE(384);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(389);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(352);
      if (lookahead == '\\') ADVANCE(384);
      if (lookahead != 0) ADVANCE(389);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'c') ADVANCE(417);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(415);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(399);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(401);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(403);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(406);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(372);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(360);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(358);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(409);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(410);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(411);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(412);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(365);
      if (lookahead == 'n') ADVANCE(391);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(365);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(413);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(374);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(368);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(369);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(370);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(376);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(378);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(419);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(407);
      if (lookahead == 's') ADVANCE(397);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(408);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(414);
      if (lookahead == 'n') ADVANCE(392);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(420);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(392);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(398);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'u') ADVANCE(393);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(421);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(460);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(505);
      if (lookahead == '.') ADVANCE(330);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == '=') ADVANCE(498);
      if (lookahead == '>') ADVANCE(514);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(505);
      if (lookahead == '.') ADVANCE(330);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == '=') ADVANCE(498);
      if (lookahead == '>') ADVANCE(513);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(505);
      if (lookahead == '.') ADVANCE(330);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == '>') ADVANCE(513);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(505);
      if (lookahead == '.') ADVANCE(330);
      if (lookahead == '0') ADVANCE(517);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(505);
      if (lookahead == '=') ADVANCE(498);
      if (lookahead == '>') ADVANCE(514);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(505);
      if (lookahead == '=') ADVANCE(498);
      if (lookahead == '>') ADVANCE(513);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(505);
      if (lookahead == '>') ADVANCE(513);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(330);
      if (lookahead == '0') ADVANCE(517);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(498);
      if (lookahead == '>') ADVANCE(271);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(506);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(506);
      if (lookahead == '.') ADVANCE(330);
      if (lookahead == '0') ADVANCE(517);
      if (lookahead == '=') ADVANCE(497);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(506);
      if (lookahead == '.') ADVANCE(330);
      if (lookahead == '0') ADVANCE(517);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(506);
      if (lookahead == '=') ADVANCE(497);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(330);
      if (lookahead == '0') ADVANCE(517);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(520);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(497);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(494);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(273);
      if (lookahead == '/') ADVANCE(658);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(273);
      if (lookahead == '/') ADVANCE(658);
      if (lookahead == '=') ADVANCE(495);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(496);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(503);
      if (lookahead == '|') ADVANCE(449);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(449);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(502);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(450);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(450);
      if (lookahead == '=') ADVANCE(501);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(464);
      if (lookahead == '>') ADVANCE(474);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(464);
      if (lookahead == '>') ADVANCE(475);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>') ADVANCE(504);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(473);
      if (lookahead == '=') ADVANCE(466);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(473);
      if (lookahead == '=') ADVANCE(465);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(472);
      if (lookahead == '=') ADVANCE(466);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(472);
      if (lookahead == '=') ADVANCE(465);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(499);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(500);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(479);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[') ADVANCE(480);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[') ADVANCE(480);
      if (lookahead == ']') ADVANCE(669);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == ']') ADVANCE(669);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(459);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '1') ADVANCE(586);
      if (lookahead == '3') ADVANCE(584);
      if (lookahead == '6') ADVANCE(585);
      if (lookahead == '8') ADVANCE(595);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'p') ADVANCE(644);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(anon_sym_LT_EQ_GT);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '*') ADVANCE(512);
      if (lookahead == '.') ADVANCE(277);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '*') ADVANCE(512);
      if (lookahead == '.') ADVANCE(277);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(516);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(277);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(277);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(516);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(anon_sym_DOT_STAR);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      if (lookahead == '*') ADVANCE(667);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(sym_number_literal);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 330,
        'B', 296,
        'b', 314,
        'E', 325,
        'e', 325,
        'F', 523,
        'f', 523,
        'L', 515,
        'l', 515,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(516);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 328,
        '.', 524,
        'L', 525,
        'l', 528,
        'B', 327,
        'b', 327,
        'E', 325,
        'e', 325,
        'U', 527,
        'u', 527,
        'X', 278,
        'x', 278,
        'Z', 530,
        'z', 530,
        '8', 264,
        '9', 264,
      );
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(518);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 328,
        '.', 524,
        'L', 525,
        'l', 528,
        'E', 325,
        'e', 325,
        'U', 527,
        'u', 527,
        'Z', 530,
        'z', 530,
        '8', 264,
        '9', 264,
      );
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(518);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 327,
        'L', 525,
        'l', 528,
        'U', 527,
        'u', 527,
        'Z', 530,
        'z', 530,
        '0', 519,
        '1', 519,
      );
      END_STATE();
    case 520:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 329,
        '.', 524,
        'L', 525,
        'l', 528,
        'E', 325,
        'e', 325,
        'U', 527,
        'u', 527,
        'Z', 530,
        'z', 530,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(520);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(332);
      if (lookahead == 'B') ADVANCE(296);
      if (lookahead == 'b') ADVANCE(314);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(523);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(515);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(521);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 334,
        '.', 326,
        'L', 525,
        'l', 528,
        'P', 325,
        'p', 325,
        'U', 527,
        'u', 527,
        'Z', 530,
        'z', 530,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(522);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '1') ADVANCE(282);
      if (lookahead == '3') ADVANCE(281);
      if (lookahead == '6') ADVANCE(283);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        'B', 296,
        'b', 314,
        'E', 325,
        'e', 325,
        'F', 523,
        'f', 523,
        'L', 515,
        'l', 515,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(516);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L') ADVANCE(530);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(515);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L') ADVANCE(515);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L') ADVANCE(526);
      if (lookahead == 'l') ADVANCE(529);
      if (lookahead == 'Z' ||
          lookahead == 'z') ADVANCE(515);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'l') ADVANCE(530);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(515);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'l') ADVANCE(515);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(515);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(anon_sym_L_SQUOTE);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(anon_sym_u_SQUOTE);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(anon_sym_U_SQUOTE);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(anon_sym_u8_SQUOTE);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\n') ADVANCE(551);
      if (lookahead == '\r') ADVANCE(550);
      if (lookahead == 'U') ADVANCE(351);
      if (lookahead == 'u') ADVANCE(343);
      if (lookahead == 'x') ADVANCE(337);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(553);
      if (lookahead != 0) ADVANCE(550);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '*') ADVANCE(273);
      if (lookahead == '/') ADVANCE(658);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\\') ADVANCE(115);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(anon_sym_L_DQUOTE);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(anon_sym_u_DQUOTE);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(anon_sym_U_DQUOTE);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(anon_sym_u8_DQUOTE);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(547);
      if (lookahead == '/') ADVANCE(549);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(549);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(546);
      if (lookahead == '/') ADVANCE(549);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(547);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(546);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(547);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '/') ADVANCE(545);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(548);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(549);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(549);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(115);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(550);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(552);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(550);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(554);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(555);
      END_STATE();
    case 557:
      ACCEPT_TOKEN(sym_system_lib_string);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(sym_system_lib_string);
      if (lookahead == '>') ADVANCE(557);
      if (lookahead == '\\') ADVANCE(295);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(294);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(sym_true);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(sym_false);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(540);
      if (lookahead == '\'') ADVANCE(531);
      if (lookahead == 'R') ADVANCE(572);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(540);
      if (lookahead == 'R') ADVANCE(572);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(540);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(662);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(542);
      if (lookahead == '\'') ADVANCE(533);
      if (lookahead == 'R') ADVANCE(573);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(542);
      if (lookahead == 'R') ADVANCE(573);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(542);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(541);
      if (lookahead == '\'') ADVANCE(532);
      if (lookahead == '8') ADVANCE(574);
      if (lookahead == 'R') ADVANCE(577);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'i') ADVANCE(628);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(541);
      if (lookahead == '8') ADVANCE(575);
      if (lookahead == 'R') ADVANCE(577);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(541);
      if (lookahead == '8') ADVANCE(576);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'i') ADVANCE(628);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(541);
      if (lookahead == '8') ADVANCE(576);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(663);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(543);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == 'R') ADVANCE(578);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(543);
      if (lookahead == 'R') ADVANCE(578);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(543);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(664);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(666);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(531);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(533);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 581:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(532);
      if (lookahead == '8') ADVANCE(582);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '1') ADVANCE(586);
      if (lookahead == '3') ADVANCE(584);
      if (lookahead == '6') ADVANCE(585);
      if (lookahead == '8') ADVANCE(595);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'p') ADVANCE(644);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '2') ADVANCE(595);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '4') ADVANCE(595);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '6') ADVANCE(595);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'A') ADVANCE(590);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E') ADVANCE(559);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E') ADVANCE(560);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'L') ADVANCE(592);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'R') ADVANCE(593);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'S') ADVANCE(589);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'U') ADVANCE(588);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == '_') ADVANCE(601);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == '_') ADVANCE(641);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'a') ADVANCE(619);
      if (lookahead == 'l') ADVANCE(631);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'a') ADVANCE(619);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'a') ADVANCE(648);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'a') ADVANCE(635);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'a') ADVANCE(641);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'a') ADVANCE(623);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'b') ADVANCE(624);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'd') ADVANCE(492);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'd') ADVANCE(615);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'e') ADVANCE(559);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'e') ADVANCE(492);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'e') ADVANCE(560);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'e') ADVANCE(595);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'f') ADVANCE(595);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'f') ADVANCE(609);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'g') ADVANCE(627);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 612:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'h') ADVANCE(599);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'i') ADVANCE(649);
      if (lookahead == 's') ADVANCE(614);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'i') ADVANCE(649);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'i') ADVANCE(610);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'i') ADVANCE(611);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'i') ADVANCE(603);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'i') ADVANCE(628);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'l') ADVANCE(639);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'l') ADVANCE(492);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 621:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'l') ADVANCE(634);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'l') ADVANCE(621);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 623:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'l') ADVANCE(616);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'l') ADVANCE(606);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 625:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'l') ADVANCE(631);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'n') ADVANCE(640);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 627:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'n') ADVANCE(595);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'n') ADVANCE(642);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'o') ADVANCE(645);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'o') ADVANCE(617);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'o') ADVANCE(600);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'o') ADVANCE(620);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'o') ADVANCE(632);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 634:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'p') ADVANCE(644);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 635:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'r') ADVANCE(491);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'r') ADVANCE(604);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 637:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'r') ADVANCE(595);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 638:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'r') ADVANCE(647);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 's') ADVANCE(607);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 640:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 't') ADVANCE(491);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 641:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 't') ADVANCE(492);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 642:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 't') ADVANCE(583);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 't') ADVANCE(636);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 644:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 't') ADVANCE(637);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 645:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'u') ADVANCE(602);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 646:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'u') ADVANCE(622);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 647:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'u') ADVANCE(605);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 648:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'x') ADVANCE(594);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 649:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (lookahead == 'z') ADVANCE(608);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 650:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 651:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 652:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n') ADVANCE(658);
      if (lookahead == '/') ADVANCE(655);
      if (lookahead == '\\') ADVANCE(386);
      if (lookahead != 0) ADVANCE(656);
      END_STATE();
    case 653:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\r') ADVANCE(659);
      if (lookahead == '\\') ADVANCE(653);
      if (lookahead != 0) ADVANCE(658);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\r') ADVANCE(657);
      if (lookahead == '/') ADVANCE(655);
      if (lookahead == '\\') ADVANCE(654);
      if (lookahead != 0) ADVANCE(656);
      END_STATE();
    case 655:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '*') ADVANCE(658);
      if (lookahead == '\\') ADVANCE(381);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(656);
      END_STATE();
    case 656:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(655);
      if (lookahead == '\\') ADVANCE(386);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(656);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(655);
      if (lookahead == '\\') ADVANCE(386);
      if (lookahead != 0) ADVANCE(656);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(172);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(658);
      END_STATE();
    case 659:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(172);
      if (lookahead != 0) ADVANCE(658);
      END_STATE();
    case 660:
      ACCEPT_TOKEN(anon_sym_GT2);
      END_STATE();
    case 661:
      ACCEPT_TOKEN(aux_sym_pure_virtual_clause_token1);
      END_STATE();
    case 662:
      ACCEPT_TOKEN(anon_sym_R_DQUOTE);
      END_STATE();
    case 663:
      ACCEPT_TOKEN(anon_sym_LR_DQUOTE);
      END_STATE();
    case 664:
      ACCEPT_TOKEN(anon_sym_uR_DQUOTE);
      END_STATE();
    case 665:
      ACCEPT_TOKEN(anon_sym_UR_DQUOTE);
      END_STATE();
    case 666:
      ACCEPT_TOKEN(anon_sym_u8R_DQUOTE);
      END_STATE();
    case 667:
      ACCEPT_TOKEN(anon_sym_DASH_GT_STAR);
      END_STATE();
    case 668:
      ACCEPT_TOKEN(anon_sym_LPAREN_RPAREN);
      END_STATE();
    case 669:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      END_STATE();
    case 670:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE);
      END_STATE();
    case 671:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(540);
      if (lookahead == 'R') ADVANCE(675);
      if (lookahead == '\\') ADVANCE(297);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(680);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 672:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(662);
      if (lookahead == '\\') ADVANCE(297);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(680);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 673:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(542);
      if (lookahead == 'R') ADVANCE(676);
      if (lookahead == '\\') ADVANCE(297);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(680);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 674:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(541);
      if (lookahead == '8') ADVANCE(677);
      if (lookahead == 'R') ADVANCE(678);
      if (lookahead == '\\') ADVANCE(297);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(680);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 675:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(663);
      if (lookahead == '\\') ADVANCE(297);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(680);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 676:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(665);
      if (lookahead == '\\') ADVANCE(297);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(680);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 677:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(543);
      if (lookahead == 'R') ADVANCE(679);
      if (lookahead == '\\') ADVANCE(297);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(680);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 678:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(664);
      if (lookahead == '\\') ADVANCE(297);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(680);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 679:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(666);
      if (lookahead == '\\') ADVANCE(297);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(680);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    case 680:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '\\') ADVANCE(297);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(680);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(650);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'N') ADVANCE(1);
      if (lookahead == 'T') ADVANCE(2);
      if (lookahead == '\\') SKIP(3);
      if (lookahead == '_') ADVANCE(4);
      if (lookahead == 'a') ADVANCE(5);
      if (lookahead == 'b') ADVANCE(6);
      if (lookahead == 'c') ADVANCE(7);
      if (lookahead == 'd') ADVANCE(8);
      if (lookahead == 'e') ADVANCE(9);
      if (lookahead == 'f') ADVANCE(10);
      if (lookahead == 'g') ADVANCE(11);
      if (lookahead == 'i') ADVANCE(12);
      if (lookahead == 'l') ADVANCE(13);
      if (lookahead == 'm') ADVANCE(14);
      if (lookahead == 'n') ADVANCE(15);
      if (lookahead == 'o') ADVANCE(16);
      if (lookahead == 'p') ADVANCE(17);
      if (lookahead == 'r') ADVANCE(18);
      if (lookahead == 's') ADVANCE(19);
      if (lookahead == 't') ADVANCE(20);
      if (lookahead == 'u') ADVANCE(21);
      if (lookahead == 'v') ADVANCE(22);
      if (lookahead == 'w') ADVANCE(23);
      if (lookahead == 'x') ADVANCE(24);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'U') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'h') ADVANCE(26);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(0);
      if (lookahead == '\r') SKIP(27);
      END_STATE();
    case 4:
      if (lookahead == 'A') ADVANCE(28);
      if (lookahead == 'G') ADVANCE(29);
      if (lookahead == 'N') ADVANCE(30);
      if (lookahead == '_') ADVANCE(31);
      if (lookahead == 'a') ADVANCE(32);
      if (lookahead == 'u') ADVANCE(33);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(34);
      if (lookahead == 'n') ADVANCE(35);
      if (lookahead == 's') ADVANCE(36);
      END_STATE();
    case 6:
      if (lookahead == 'i') ADVANCE(37);
      if (lookahead == 'r') ADVANCE(38);
      END_STATE();
    case 7:
      if (lookahead == 'a') ADVANCE(39);
      if (lookahead == 'b') ADVANCE(40);
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'l') ADVANCE(42);
      if (lookahead == 'o') ADVANCE(43);
      END_STATE();
    case 8:
      if (lookahead == 'e') ADVANCE(44);
      if (lookahead == 'i') ADVANCE(45);
      if (lookahead == 'o') ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'l') ADVANCE(47);
      if (lookahead == 'n') ADVANCE(48);
      if (lookahead == 'x') ADVANCE(49);
      END_STATE();
    case 10:
      if (lookahead == 'i') ADVANCE(50);
      if (lookahead == 'o') ADVANCE(51);
      if (lookahead == 'r') ADVANCE(52);
      END_STATE();
    case 11:
      if (lookahead == 'e') ADVANCE(53);
      if (lookahead == 'l') ADVANCE(54);
      if (lookahead == 'o') ADVANCE(55);
      if (lookahead == 'r') ADVANCE(56);
      END_STATE();
    case 12:
      if (lookahead == 'f') ADVANCE(57);
      if (lookahead == 'm') ADVANCE(58);
      if (lookahead == 'n') ADVANCE(59);
      if (lookahead == 's') ADVANCE(60);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(61);
      if (lookahead == 'i') ADVANCE(62);
      if (lookahead == 'o') ADVANCE(63);
      END_STATE();
    case 14:
      if (lookahead == 'o') ADVANCE(64);
      if (lookahead == 'u') ADVANCE(65);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(66);
      if (lookahead == 'e') ADVANCE(67);
      if (lookahead == 'o') ADVANCE(68);
      if (lookahead == 'u') ADVANCE(69);
      END_STATE();
    case 16:
      if (lookahead == 'f') ADVANCE(70);
      if (lookahead == 'p') ADVANCE(71);
      if (lookahead == 'r') ADVANCE(72);
      if (lookahead == 'u') ADVANCE(73);
      if (lookahead == 'v') ADVANCE(74);
      END_STATE();
    case 17:
      if (lookahead == 'o') ADVANCE(75);
      if (lookahead == 'r') ADVANCE(76);
      if (lookahead == 'u') ADVANCE(77);
      END_STATE();
    case 18:
      if (lookahead == 'e') ADVANCE(78);
      if (lookahead == 'o') ADVANCE(79);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(80);
      if (lookahead == 'e') ADVANCE(81);
      if (lookahead == 'h') ADVANCE(82);
      if (lookahead == 'i') ADVANCE(83);
      if (lookahead == 'n') ADVANCE(84);
      if (lookahead == 't') ADVANCE(85);
      if (lookahead == 'w') ADVANCE(86);
      END_STATE();
    case 20:
      if (lookahead == 'e') ADVANCE(87);
      if (lookahead == 'h') ADVANCE(88);
      if (lookahead == 'r') ADVANCE(89);
      if (lookahead == 'y') ADVANCE(90);
      END_STATE();
    case 21:
      if (lookahead == 'n') ADVANCE(91);
      if (lookahead == 's') ADVANCE(92);
      END_STATE();
    case 22:
      if (lookahead == 'a') ADVANCE(93);
      if (lookahead == 'i') ADVANCE(94);
      if (lookahead == 'o') ADVANCE(95);
      END_STATE();
    case 23:
      if (lookahead == 'h') ADVANCE(96);
      END_STATE();
    case 24:
      if (lookahead == 'o') ADVANCE(97);
      END_STATE();
    case 25:
      if (lookahead == 'L') ADVANCE(98);
      END_STATE();
    case 26:
      if (lookahead == 'i') ADVANCE(99);
      END_STATE();
    case 27:
      if (lookahead == '\n') SKIP(0);
      END_STATE();
    case 28:
      if (lookahead == 'l') ADVANCE(100);
      if (lookahead == 't') ADVANCE(101);
      END_STATE();
    case 29:
      if (lookahead == 'e') ADVANCE(102);
      END_STATE();
    case 30:
      if (lookahead == 'o') ADVANCE(103);
      END_STATE();
    case 31:
      ADVANCE_MAP(
        'a', 104,
        'b', 105,
        'c', 106,
        'd', 107,
        'e', 108,
        'f', 109,
        'i', 110,
        'l', 111,
        'r', 112,
        's', 113,
        't', 114,
        'u', 115,
        'v', 116,
      );
      END_STATE();
    case 32:
      if (lookahead == 'l') ADVANCE(117);
      END_STATE();
    case 33:
      if (lookahead == 'n') ADVANCE(118);
      END_STATE();
    case 34:
      if (lookahead == 'i') ADVANCE(119);
      END_STATE();
    case 35:
      if (lookahead == 'd') ADVANCE(120);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'm') ADVANCE(121);
      if (lookahead == 's') ADVANCE(122);
      END_STATE();
    case 37:
      if (lookahead == 't') ADVANCE(123);
      END_STATE();
    case 38:
      if (lookahead == 'e') ADVANCE(124);
      END_STATE();
    case 39:
      if (lookahead == 's') ADVANCE(125);
      if (lookahead == 't') ADVANCE(126);
      END_STATE();
    case 40:
      if (lookahead == 'u') ADVANCE(127);
      END_STATE();
    case 41:
      if (lookahead == 'n') ADVANCE(128);
      END_STATE();
    case 42:
      if (lookahead == 'a') ADVANCE(129);
      END_STATE();
    case 43:
      if (lookahead == '_') ADVANCE(130);
      if (lookahead == 'l') ADVANCE(131);
      if (lookahead == 'm') ADVANCE(132);
      if (lookahead == 'n') ADVANCE(133);
      END_STATE();
    case 44:
      if (lookahead == 'c') ADVANCE(134);
      if (lookahead == 'f') ADVANCE(135);
      if (lookahead == 'l') ADVANCE(136);
      END_STATE();
    case 45:
      if (lookahead == 's') ADVANCE(137);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 47:
      if (lookahead == 's') ADVANCE(138);
      END_STATE();
    case 48:
      if (lookahead == 'u') ADVANCE(139);
      END_STATE();
    case 49:
      if (lookahead == 'p') ADVANCE(140);
      if (lookahead == 't') ADVANCE(141);
      END_STATE();
    case 50:
      if (lookahead == 'n') ADVANCE(142);
      END_STATE();
    case 51:
      if (lookahead == 'r') ADVANCE(143);
      END_STATE();
    case 52:
      if (lookahead == 'i') ADVANCE(144);
      END_STATE();
    case 53:
      if (lookahead == 't') ADVANCE(145);
      END_STATE();
    case 54:
      if (lookahead == 'o') ADVANCE(146);
      END_STATE();
    case 55:
      if (lookahead == 't') ADVANCE(147);
      END_STATE();
    case 56:
      if (lookahead == 'o') ADVANCE(148);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 58:
      if (lookahead == 'p') ADVANCE(149);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'l') ADVANCE(150);
      if (lookahead == 'o') ADVANCE(151);
      if (lookahead == 't') ADVANCE(152);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 61:
      if (lookahead == 't') ADVANCE(153);
      END_STATE();
    case 62:
      if (lookahead == 'n') ADVANCE(154);
      END_STATE();
    case 63:
      if (lookahead == 'n') ADVANCE(155);
      END_STATE();
    case 64:
      if (lookahead == 'd') ADVANCE(156);
      END_STATE();
    case 65:
      if (lookahead == 't') ADVANCE(157);
      END_STATE();
    case 66:
      if (lookahead == 'm') ADVANCE(158);
      END_STATE();
    case 67:
      if (lookahead == 'w') ADVANCE(159);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(160);
      if (lookahead == 'i') ADVANCE(161);
      if (lookahead == 'p') ADVANCE(162);
      if (lookahead == 'r') ADVANCE(163);
      if (lookahead == 't') ADVANCE(164);
      END_STATE();
    case 69:
      if (lookahead == 'l') ADVANCE(165);
      END_STATE();
    case 70:
      if (lookahead == 'f') ADVANCE(166);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(167);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == '_') ADVANCE(168);
      END_STATE();
    case 73:
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(170);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(171);
      END_STATE();
    case 76:
      if (lookahead == 'e') ADVANCE(172);
      if (lookahead == 'i') ADVANCE(173);
      if (lookahead == 'o') ADVANCE(174);
      END_STATE();
    case 77:
      if (lookahead == 'b') ADVANCE(175);
      END_STATE();
    case 78:
      if (lookahead == 'g') ADVANCE(176);
      if (lookahead == 'q') ADVANCE(177);
      if (lookahead == 's') ADVANCE(178);
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 79:
      if (lookahead == 'w') ADVANCE(180);
      END_STATE();
    case 80:
      if (lookahead == 'm') ADVANCE(181);
      END_STATE();
    case 81:
      if (lookahead == 't') ADVANCE(182);
      END_STATE();
    case 82:
      if (lookahead == 'a') ADVANCE(183);
      if (lookahead == 'o') ADVANCE(184);
      END_STATE();
    case 83:
      if (lookahead == 'g') ADVANCE(185);
      if (lookahead == 'z') ADVANCE(186);
      END_STATE();
    case 84:
      if (lookahead == 'o') ADVANCE(187);
      END_STATE();
    case 85:
      if (lookahead == 'a') ADVANCE(188);
      if (lookahead == 'r') ADVANCE(189);
      END_STATE();
    case 86:
      if (lookahead == 'i') ADVANCE(190);
      END_STATE();
    case 87:
      if (lookahead == 'm') ADVANCE(191);
      END_STATE();
    case 88:
      if (lookahead == 'i') ADVANCE(192);
      if (lookahead == 'r') ADVANCE(193);
      END_STATE();
    case 89:
      if (lookahead == 'i') ADVANCE(194);
      if (lookahead == 'y') ADVANCE(195);
      END_STATE();
    case 90:
      if (lookahead == 'p') ADVANCE(196);
      END_STATE();
    case 91:
      if (lookahead == 'i') ADVANCE(197);
      if (lookahead == 'o') ADVANCE(198);
      if (lookahead == 's') ADVANCE(199);
      END_STATE();
    case 92:
      if (lookahead == 'i') ADVANCE(200);
      END_STATE();
    case 93:
      if (lookahead == 'r') ADVANCE(201);
      END_STATE();
    case 94:
      if (lookahead == 'r') ADVANCE(202);
      END_STATE();
    case 95:
      if (lookahead == 'l') ADVANCE(203);
      END_STATE();
    case 96:
      if (lookahead == 'e') ADVANCE(204);
      if (lookahead == 'i') ADVANCE(205);
      END_STATE();
    case 97:
      if (lookahead == 'r') ADVANCE(206);
      END_STATE();
    case 98:
      if (lookahead == 'L') ADVANCE(207);
      END_STATE();
    case 99:
      if (lookahead == 's') ADVANCE(208);
      END_STATE();
    case 100:
      if (lookahead == 'i') ADVANCE(209);
      END_STATE();
    case 101:
      if (lookahead == 'o') ADVANCE(210);
      END_STATE();
    case 102:
      if (lookahead == 'n') ADVANCE(211);
      END_STATE();
    case 103:
      if (lookahead == 'n') ADVANCE(212);
      if (lookahead == 'r') ADVANCE(213);
      END_STATE();
    case 104:
      if (lookahead == 'l') ADVANCE(214);
      if (lookahead == 's') ADVANCE(215);
      if (lookahead == 't') ADVANCE(216);
      END_STATE();
    case 105:
      if (lookahead == 'a') ADVANCE(217);
      END_STATE();
    case 106:
      if (lookahead == 'd') ADVANCE(218);
      if (lookahead == 'l') ADVANCE(219);
      END_STATE();
    case 107:
      if (lookahead == 'e') ADVANCE(220);
      END_STATE();
    case 108:
      if (lookahead == 'x') ADVANCE(221);
      END_STATE();
    case 109:
      if (lookahead == 'a') ADVANCE(222);
      if (lookahead == 'i') ADVANCE(223);
      if (lookahead == 'o') ADVANCE(224);
      END_STATE();
    case 110:
      if (lookahead == 'n') ADVANCE(225);
      END_STATE();
    case 111:
      if (lookahead == 'e') ADVANCE(226);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(227);
      END_STATE();
    case 113:
      if (lookahead == 'p') ADVANCE(228);
      if (lookahead == 't') ADVANCE(229);
      if (lookahead == 'u') ADVANCE(230);
      END_STATE();
    case 114:
      if (lookahead == 'h') ADVANCE(231);
      if (lookahead == 'r') ADVANCE(232);
      END_STATE();
    case 115:
      if (lookahead == 'n') ADVANCE(233);
      if (lookahead == 'p') ADVANCE(234);
      END_STATE();
    case 116:
      if (lookahead == 'e') ADVANCE(235);
      if (lookahead == 'o') ADVANCE(236);
      END_STATE();
    case 117:
      if (lookahead == 'i') ADVANCE(237);
      END_STATE();
    case 118:
      if (lookahead == 'a') ADVANCE(238);
      END_STATE();
    case 119:
      if (lookahead == 'g') ADVANCE(239);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_and);
      if (lookahead == '_') ADVANCE(240);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_asm);
      END_STATE();
    case 122:
      if (lookahead == 'o') ADVANCE(241);
      END_STATE();
    case 123:
      if (lookahead == 'a') ADVANCE(242);
      if (lookahead == 'o') ADVANCE(243);
      END_STATE();
    case 124:
      if (lookahead == 'a') ADVANCE(244);
      END_STATE();
    case 125:
      if (lookahead == 'e') ADVANCE(245);
      END_STATE();
    case 126:
      if (lookahead == 'c') ADVANCE(246);
      END_STATE();
    case 127:
      if (lookahead == 'f') ADVANCE(247);
      END_STATE();
    case 128:
      if (lookahead == 't') ADVANCE(248);
      END_STATE();
    case 129:
      if (lookahead == 's') ADVANCE(249);
      END_STATE();
    case 130:
      if (lookahead == 'a') ADVANCE(250);
      if (lookahead == 'r') ADVANCE(251);
      if (lookahead == 'y') ADVANCE(252);
      END_STATE();
    case 131:
      if (lookahead == 'u') ADVANCE(253);
      END_STATE();
    case 132:
      if (lookahead == 'p') ADVANCE(254);
      END_STATE();
    case 133:
      if (lookahead == 'c') ADVANCE(255);
      if (lookahead == 's') ADVANCE(256);
      if (lookahead == 't') ADVANCE(257);
      END_STATE();
    case 134:
      if (lookahead == 'l') ADVANCE(258);
      END_STATE();
    case 135:
      if (lookahead == 'a') ADVANCE(259);
      if (lookahead == 'i') ADVANCE(260);
      END_STATE();
    case 136:
      if (lookahead == 'e') ADVANCE(261);
      END_STATE();
    case 137:
      if (lookahead == 'c') ADVANCE(262);
      END_STATE();
    case 138:
      if (lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 139:
      if (lookahead == 'm') ADVANCE(264);
      END_STATE();
    case 140:
      if (lookahead == 'l') ADVANCE(265);
      if (lookahead == 'o') ADVANCE(266);
      END_STATE();
    case 141:
      if (lookahead == 'e') ADVANCE(267);
      END_STATE();
    case 142:
      if (lookahead == 'a') ADVANCE(268);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 144:
      if (lookahead == 'e') ADVANCE(269);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 146:
      if (lookahead == 'b') ADVANCE(270);
      END_STATE();
    case 147:
      if (lookahead == 'o') ADVANCE(271);
      END_STATE();
    case 148:
      if (lookahead == 'u') ADVANCE(272);
      END_STATE();
    case 149:
      if (lookahead == 'o') ADVANCE(273);
      END_STATE();
    case 150:
      if (lookahead == 'i') ADVANCE(274);
      END_STATE();
    case 151:
      if (lookahead == 'u') ADVANCE(275);
      END_STATE();
    case 152:
      if (lookahead == 'e') ADVANCE(276);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 154:
      if (lookahead == 'e') ADVANCE(277);
      END_STATE();
    case 155:
      if (lookahead == 'g') ADVANCE(278);
      END_STATE();
    case 156:
      if (lookahead == 'u') ADVANCE(279);
      END_STATE();
    case 157:
      if (lookahead == 'a') ADVANCE(280);
      END_STATE();
    case 158:
      if (lookahead == 'e') ADVANCE(281);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 160:
      if (lookahead == 'x') ADVANCE(282);
      END_STATE();
    case 161:
      if (lookahead == 'n') ADVANCE(283);
      END_STATE();
    case 162:
      if (lookahead == 'e') ADVANCE(284);
      END_STATE();
    case 163:
      if (lookahead == 'e') ADVANCE(285);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_not);
      if (lookahead == '_') ADVANCE(286);
      END_STATE();
    case 165:
      if (lookahead == 'l') ADVANCE(287);
      END_STATE();
    case 166:
      if (lookahead == 's') ADVANCE(288);
      END_STATE();
    case 167:
      if (lookahead == 'r') ADVANCE(289);
      END_STATE();
    case 168:
      if (lookahead == 'e') ADVANCE(290);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_out);
      END_STATE();
    case 170:
      if (lookahead == 'r') ADVANCE(291);
      END_STATE();
    case 171:
      if (lookahead == 'n') ADVANCE(292);
      END_STATE();
    case 172:
      if (lookahead == 'c') ADVANCE(293);
      END_STATE();
    case 173:
      if (lookahead == 'v') ADVANCE(294);
      END_STATE();
    case 174:
      if (lookahead == 'p') ADVANCE(295);
      if (lookahead == 't') ADVANCE(296);
      END_STATE();
    case 175:
      if (lookahead == 'l') ADVANCE(297);
      END_STATE();
    case 176:
      if (lookahead == 'i') ADVANCE(298);
      END_STATE();
    case 177:
      if (lookahead == 'u') ADVANCE(299);
      END_STATE();
    case 178:
      if (lookahead == 't') ADVANCE(300);
      END_STATE();
    case 179:
      if (lookahead == 'u') ADVANCE(301);
      END_STATE();
    case 180:
      if (lookahead == '_') ADVANCE(302);
      END_STATE();
    case 181:
      if (lookahead == 'p') ADVANCE(303);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 183:
      if (lookahead == 'r') ADVANCE(304);
      END_STATE();
    case 184:
      if (lookahead == 'r') ADVANCE(305);
      END_STATE();
    case 185:
      if (lookahead == 'n') ADVANCE(306);
      END_STATE();
    case 186:
      if (lookahead == 'e') ADVANCE(307);
      END_STATE();
    case 187:
      if (lookahead == 'r') ADVANCE(308);
      END_STATE();
    case 188:
      if (lookahead == 't') ADVANCE(309);
      END_STATE();
    case 189:
      if (lookahead == 'u') ADVANCE(310);
      END_STATE();
    case 190:
      if (lookahead == 't') ADVANCE(311);
      END_STATE();
    case 191:
      if (lookahead == 'p') ADVANCE(312);
      END_STATE();
    case 192:
      if (lookahead == 's') ADVANCE(313);
      END_STATE();
    case 193:
      if (lookahead == 'e') ADVANCE(314);
      if (lookahead == 'o') ADVANCE(315);
      END_STATE();
    case 194:
      if (lookahead == 'a') ADVANCE(316);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 196:
      if (lookahead == 'e') ADVANCE(317);
      END_STATE();
    case 197:
      if (lookahead == 'f') ADVANCE(318);
      if (lookahead == 'o') ADVANCE(319);
      END_STATE();
    case 198:
      if (lookahead == 'r') ADVANCE(320);
      END_STATE();
    case 199:
      if (lookahead == 'i') ADVANCE(321);
      END_STATE();
    case 200:
      if (lookahead == 'n') ADVANCE(322);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 202:
      if (lookahead == 't') ADVANCE(323);
      END_STATE();
    case 203:
      if (lookahead == 'a') ADVANCE(324);
      END_STATE();
    case 204:
      if (lookahead == 'r') ADVANCE(325);
      END_STATE();
    case 205:
      if (lookahead == 'l') ADVANCE(326);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_xor);
      if (lookahead == '_') ADVANCE(327);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_NULL);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_This);
      END_STATE();
    case 209:
      if (lookahead == 'g') ADVANCE(328);
      END_STATE();
    case 210:
      if (lookahead == 'm') ADVANCE(329);
      END_STATE();
    case 211:
      if (lookahead == 'e') ADVANCE(330);
      END_STATE();
    case 212:
      if (lookahead == 'n') ADVANCE(331);
      END_STATE();
    case 213:
      if (lookahead == 'e') ADVANCE(332);
      END_STATE();
    case 214:
      if (lookahead == 'i') ADVANCE(333);
      END_STATE();
    case 215:
      if (lookahead == 'm') ADVANCE(334);
      END_STATE();
    case 216:
      if (lookahead == 't') ADVANCE(335);
      END_STATE();
    case 217:
      if (lookahead == 's') ADVANCE(336);
      END_STATE();
    case 218:
      if (lookahead == 'e') ADVANCE(337);
      END_STATE();
    case 219:
      if (lookahead == 'r') ADVANCE(338);
      END_STATE();
    case 220:
      if (lookahead == 'c') ADVANCE(339);
      END_STATE();
    case 221:
      if (lookahead == 'c') ADVANCE(340);
      if (lookahead == 'p') ADVANCE(341);
      if (lookahead == 't') ADVANCE(342);
      END_STATE();
    case 222:
      if (lookahead == 's') ADVANCE(343);
      END_STATE();
    case 223:
      if (lookahead == 'n') ADVANCE(344);
      END_STATE();
    case 224:
      if (lookahead == 'r') ADVANCE(345);
      END_STATE();
    case 225:
      if (lookahead == 'i') ADVANCE(346);
      if (lookahead == 'l') ADVANCE(347);
      END_STATE();
    case 226:
      if (lookahead == 'a') ADVANCE(348);
      END_STATE();
    case 227:
      if (lookahead == 's') ADVANCE(349);
      END_STATE();
    case 228:
      if (lookahead == 't') ADVANCE(350);
      END_STATE();
    case 229:
      if (lookahead == 'd') ADVANCE(351);
      END_STATE();
    case 230:
      if (lookahead == 'b') ADVANCE(352);
      END_STATE();
    case 231:
      if (lookahead == 'i') ADVANCE(353);
      if (lookahead == 'r') ADVANCE(354);
      END_STATE();
    case 232:
      if (lookahead == 'y') ADVANCE(355);
      END_STATE();
    case 233:
      if (lookahead == 'a') ADVANCE(356);
      END_STATE();
    case 234:
      if (lookahead == 't') ADVANCE(357);
      END_STATE();
    case 235:
      if (lookahead == 'c') ADVANCE(358);
      END_STATE();
    case 236:
      if (lookahead == 'l') ADVANCE(359);
      END_STATE();
    case 237:
      if (lookahead == 'g') ADVANCE(360);
      END_STATE();
    case 238:
      if (lookahead == 'l') ADVANCE(361);
      END_STATE();
    case 239:
      if (lookahead == 'n') ADVANCE(362);
      END_STATE();
    case 240:
      if (lookahead == 'e') ADVANCE(363);
      END_STATE();
    case 241:
      if (lookahead == 'c') ADVANCE(364);
      END_STATE();
    case 242:
      if (lookahead == 'n') ADVANCE(365);
      END_STATE();
    case 243:
      if (lookahead == 'r') ADVANCE(366);
      END_STATE();
    case 244:
      if (lookahead == 'k') ADVANCE(367);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 246:
      if (lookahead == 'h') ADVANCE(368);
      END_STATE();
    case 247:
      if (lookahead == 'f') ADVANCE(369);
      END_STATE();
    case 248:
      if (lookahead == 'r') ADVANCE(370);
      END_STATE();
    case 249:
      if (lookahead == 's') ADVANCE(371);
      END_STATE();
    case 250:
      if (lookahead == 'w') ADVANCE(372);
      END_STATE();
    case 251:
      if (lookahead == 'e') ADVANCE(373);
      END_STATE();
    case 252:
      if (lookahead == 'i') ADVANCE(374);
      END_STATE();
    case 253:
      if (lookahead == 'm') ADVANCE(375);
      END_STATE();
    case 254:
      if (lookahead == 'l') ADVANCE(376);
      END_STATE();
    case 255:
      if (lookahead == 'e') ADVANCE(377);
      END_STATE();
    case 256:
      if (lookahead == 't') ADVANCE(378);
      END_STATE();
    case 257:
      if (lookahead == 'i') ADVANCE(379);
      END_STATE();
    case 258:
      if (lookahead == 't') ADVANCE(380);
      END_STATE();
    case 259:
      if (lookahead == 'u') ADVANCE(381);
      END_STATE();
    case 260:
      if (lookahead == 'n') ADVANCE(382);
      END_STATE();
    case 261:
      if (lookahead == 't') ADVANCE(383);
      END_STATE();
    case 262:
      if (lookahead == 'a') ADVANCE(384);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 265:
      if (lookahead == 'i') ADVANCE(385);
      END_STATE();
    case 266:
      if (lookahead == 'r') ADVANCE(386);
      END_STATE();
    case 267:
      if (lookahead == 'n') ADVANCE(387);
      if (lookahead == 'r') ADVANCE(388);
      END_STATE();
    case 268:
      if (lookahead == 'l') ADVANCE(389);
      END_STATE();
    case 269:
      if (lookahead == 'n') ADVANCE(390);
      END_STATE();
    case 270:
      if (lookahead == 'a') ADVANCE(391);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 272:
      if (lookahead == 'p') ADVANCE(392);
      END_STATE();
    case 273:
      if (lookahead == 'r') ADVANCE(393);
      END_STATE();
    case 274:
      if (lookahead == 'n') ADVANCE(394);
      END_STATE();
    case 275:
      if (lookahead == 't') ADVANCE(395);
      END_STATE();
    case 276:
      if (lookahead == 'r') ADVANCE(396);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_line);
      if (lookahead == 'a') ADVANCE(397);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_long);
      END_STATE();
    case 279:
      if (lookahead == 'l') ADVANCE(398);
      END_STATE();
    case 280:
      if (lookahead == 'b') ADVANCE(399);
      END_STATE();
    case 281:
      if (lookahead == 's') ADVANCE(400);
      END_STATE();
    case 282:
      if (lookahead == 'c') ADVANCE(401);
      END_STATE();
    case 283:
      if (lookahead == 't') ADVANCE(402);
      END_STATE();
    case 284:
      if (lookahead == 'r') ADVANCE(403);
      END_STATE();
    case 285:
      if (lookahead == 't') ADVANCE(404);
      END_STATE();
    case 286:
      if (lookahead == 'e') ADVANCE(405);
      END_STATE();
    case 287:
      if (lookahead == 'p') ADVANCE(406);
      END_STATE();
    case 288:
      if (lookahead == 'e') ADVANCE(407);
      END_STATE();
    case 289:
      if (lookahead == 'a') ADVANCE(408);
      END_STATE();
    case 290:
      if (lookahead == 'q') ADVANCE(409);
      END_STATE();
    case 291:
      if (lookahead == 'r') ADVANCE(410);
      END_STATE();
    case 292:
      if (lookahead == 't') ADVANCE(411);
      END_STATE();
    case 293:
      if (lookahead == 'i') ADVANCE(412);
      END_STATE();
    case 294:
      if (lookahead == 'a') ADVANCE(413);
      END_STATE();
    case 295:
      if (lookahead == 'e') ADVANCE(414);
      END_STATE();
    case 296:
      if (lookahead == 'e') ADVANCE(415);
      END_STATE();
    case 297:
      if (lookahead == 'i') ADVANCE(416);
      END_STATE();
    case 298:
      if (lookahead == 's') ADVANCE(417);
      END_STATE();
    case 299:
      if (lookahead == 'i') ADVANCE(418);
      END_STATE();
    case 300:
      if (lookahead == 'r') ADVANCE(419);
      END_STATE();
    case 301:
      if (lookahead == 'r') ADVANCE(420);
      END_STATE();
    case 302:
      if (lookahead == 'm') ADVANCE(421);
      END_STATE();
    case 303:
      if (lookahead == 'l') ADVANCE(422);
      END_STATE();
    case 304:
      if (lookahead == 'e') ADVANCE(423);
      END_STATE();
    case 305:
      if (lookahead == 't') ADVANCE(424);
      END_STATE();
    case 306:
      if (lookahead == 'e') ADVANCE(425);
      END_STATE();
    case 307:
      if (lookahead == 'o') ADVANCE(426);
      END_STATE();
    case 308:
      if (lookahead == 'm') ADVANCE(427);
      END_STATE();
    case 309:
      if (lookahead == 'i') ADVANCE(428);
      END_STATE();
    case 310:
      if (lookahead == 'c') ADVANCE(429);
      END_STATE();
    case 311:
      if (lookahead == 'c') ADVANCE(430);
      END_STATE();
    case 312:
      if (lookahead == 'l') ADVANCE(431);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 314:
      if (lookahead == 'a') ADVANCE(432);
      END_STATE();
    case 315:
      if (lookahead == 'w') ADVANCE(433);
      END_STATE();
    case 316:
      if (lookahead == 'n') ADVANCE(434);
      END_STATE();
    case 317:
      if (lookahead == 'd') ADVANCE(435);
      if (lookahead == 'n') ADVANCE(436);
      END_STATE();
    case 318:
      if (lookahead == 'o') ADVANCE(437);
      END_STATE();
    case 319:
      if (lookahead == 'n') ADVANCE(438);
      END_STATE();
    case 320:
      if (lookahead == 'm') ADVANCE(439);
      END_STATE();
    case 321:
      if (lookahead == 'g') ADVANCE(440);
      END_STATE();
    case 322:
      if (lookahead == 'g') ADVANCE(441);
      END_STATE();
    case 323:
      if (lookahead == 'u') ADVANCE(442);
      END_STATE();
    case 324:
      if (lookahead == 't') ADVANCE(443);
      END_STATE();
    case 325:
      if (lookahead == 'e') ADVANCE(444);
      END_STATE();
    case 326:
      if (lookahead == 'e') ADVANCE(445);
      END_STATE();
    case 327:
      if (lookahead == 'e') ADVANCE(446);
      END_STATE();
    case 328:
      if (lookahead == 'n') ADVANCE(447);
      END_STATE();
    case 329:
      if (lookahead == 'i') ADVANCE(448);
      END_STATE();
    case 330:
      if (lookahead == 'r') ADVANCE(449);
      END_STATE();
    case 331:
      if (lookahead == 'u') ADVANCE(450);
      END_STATE();
    case 332:
      if (lookahead == 't') ADVANCE(451);
      END_STATE();
    case 333:
      if (lookahead == 'g') ADVANCE(452);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(anon_sym___asm);
      if (lookahead == '_') ADVANCE(453);
      END_STATE();
    case 335:
      if (lookahead == 'r') ADVANCE(454);
      END_STATE();
    case 336:
      if (lookahead == 'e') ADVANCE(455);
      END_STATE();
    case 337:
      if (lookahead == 'c') ADVANCE(456);
      END_STATE();
    case 338:
      if (lookahead == 'c') ADVANCE(457);
      END_STATE();
    case 339:
      if (lookahead == 'l') ADVANCE(458);
      END_STATE();
    case 340:
      if (lookahead == 'e') ADVANCE(459);
      END_STATE();
    case 341:
      if (lookahead == 'o') ADVANCE(460);
      END_STATE();
    case 342:
      if (lookahead == 'e') ADVANCE(461);
      END_STATE();
    case 343:
      if (lookahead == 't') ADVANCE(462);
      END_STATE();
    case 344:
      if (lookahead == 'a') ADVANCE(463);
      END_STATE();
    case 345:
      if (lookahead == 'c') ADVANCE(464);
      END_STATE();
    case 346:
      if (lookahead == 't') ADVANCE(465);
      END_STATE();
    case 347:
      if (lookahead == 'i') ADVANCE(466);
      END_STATE();
    case 348:
      if (lookahead == 'v') ADVANCE(467);
      END_STATE();
    case 349:
      if (lookahead == 't') ADVANCE(468);
      END_STATE();
    case 350:
      if (lookahead == 'r') ADVANCE(469);
      END_STATE();
    case 351:
      if (lookahead == 'c') ADVANCE(470);
      END_STATE();
    case 352:
      if (lookahead == 's') ADVANCE(471);
      END_STATE();
    case 353:
      if (lookahead == 's') ADVANCE(472);
      END_STATE();
    case 354:
      if (lookahead == 'e') ADVANCE(473);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(anon_sym___try);
      END_STATE();
    case 356:
      if (lookahead == 'l') ADVANCE(474);
      END_STATE();
    case 357:
      if (lookahead == 'r') ADVANCE(475);
      END_STATE();
    case 358:
      if (lookahead == 't') ADVANCE(476);
      END_STATE();
    case 359:
      if (lookahead == 'a') ADVANCE(477);
      END_STATE();
    case 360:
      if (lookahead == 'n') ADVANCE(478);
      END_STATE();
    case 361:
      if (lookahead == 'i') ADVANCE(479);
      END_STATE();
    case 362:
      if (lookahead == 'a') ADVANCE(480);
      if (lookahead == 'o') ADVANCE(481);
      END_STATE();
    case 363:
      if (lookahead == 'q') ADVANCE(482);
      END_STATE();
    case 364:
      if (lookahead == 'i') ADVANCE(483);
      END_STATE();
    case 365:
      if (lookahead == 'd') ADVANCE(484);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(anon_sym_bitor);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 369:
      if (lookahead == 'e') ADVANCE(485);
      END_STATE();
    case 370:
      if (lookahead == 'o') ADVANCE(486);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 372:
      if (lookahead == 'a') ADVANCE(487);
      END_STATE();
    case 373:
      if (lookahead == 't') ADVANCE(488);
      END_STATE();
    case 374:
      if (lookahead == 'e') ADVANCE(489);
      END_STATE();
    case 375:
      if (lookahead == 'n') ADVANCE(490);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(anon_sym_compl);
      END_STATE();
    case 377:
      if (lookahead == 'p') ADVANCE(491);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(anon_sym_const);
      if (lookahead == 'e') ADVANCE(492);
      if (lookahead == 'i') ADVANCE(493);
      END_STATE();
    case 379:
      if (lookahead == 'n') ADVANCE(494);
      END_STATE();
    case 380:
      if (lookahead == 'y') ADVANCE(495);
      END_STATE();
    case 381:
      if (lookahead == 'l') ADVANCE(496);
      END_STATE();
    case 382:
      if (lookahead == 'e') ADVANCE(497);
      END_STATE();
    case 383:
      if (lookahead == 'e') ADVANCE(498);
      END_STATE();
    case 384:
      if (lookahead == 'r') ADVANCE(499);
      END_STATE();
    case 385:
      if (lookahead == 'c') ADVANCE(500);
      END_STATE();
    case 386:
      if (lookahead == 't') ADVANCE(501);
      END_STATE();
    case 387:
      if (lookahead == 's') ADVANCE(502);
      END_STATE();
    case 388:
      if (lookahead == 'n') ADVANCE(503);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(anon_sym_final);
      END_STATE();
    case 390:
      if (lookahead == 'd') ADVANCE(504);
      END_STATE();
    case 391:
      if (lookahead == 'l') ADVANCE(505);
      END_STATE();
    case 392:
      if (lookahead == 's') ADVANCE(506);
      END_STATE();
    case 393:
      if (lookahead == 't') ADVANCE(507);
      END_STATE();
    case 394:
      if (lookahead == 'e') ADVANCE(508);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(anon_sym_inout);
      END_STATE();
    case 396:
      if (lookahead == 'f') ADVANCE(509);
      END_STATE();
    case 397:
      if (lookahead == 'd') ADVANCE(510);
      if (lookahead == 'r') ADVANCE(511);
      END_STATE();
    case 398:
      if (lookahead == 'e') ADVANCE(512);
      END_STATE();
    case 399:
      if (lookahead == 'l') ADVANCE(513);
      END_STATE();
    case 400:
      if (lookahead == 'p') ADVANCE(514);
      END_STATE();
    case 401:
      if (lookahead == 'e') ADVANCE(515);
      END_STATE();
    case 402:
      if (lookahead == 'e') ADVANCE(516);
      END_STATE();
    case 403:
      if (lookahead == 's') ADVANCE(517);
      END_STATE();
    case 404:
      if (lookahead == 'u') ADVANCE(518);
      END_STATE();
    case 405:
      if (lookahead == 'q') ADVANCE(519);
      END_STATE();
    case 406:
      if (lookahead == 't') ADVANCE(520);
      END_STATE();
    case 407:
      if (lookahead == 't') ADVANCE(521);
      END_STATE();
    case 408:
      if (lookahead == 't') ADVANCE(522);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(anon_sym_or_eq);
      END_STATE();
    case 410:
      if (lookahead == 'i') ADVANCE(523);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(anon_sym_point);
      END_STATE();
    case 412:
      if (lookahead == 's') ADVANCE(524);
      END_STATE();
    case 413:
      if (lookahead == 't') ADVANCE(525);
      END_STATE();
    case 414:
      if (lookahead == 'r') ADVANCE(526);
      END_STATE();
    case 415:
      if (lookahead == 'c') ADVANCE(527);
      END_STATE();
    case 416:
      if (lookahead == 'c') ADVANCE(528);
      END_STATE();
    case 417:
      if (lookahead == 't') ADVANCE(529);
      END_STATE();
    case 418:
      if (lookahead == 'r') ADVANCE(530);
      END_STATE();
    case 419:
      if (lookahead == 'i') ADVANCE(531);
      END_STATE();
    case 420:
      if (lookahead == 'n') ADVANCE(532);
      END_STATE();
    case 421:
      if (lookahead == 'a') ADVANCE(533);
      END_STATE();
    case 422:
      if (lookahead == 'e') ADVANCE(534);
      END_STATE();
    case 423:
      if (lookahead == 'd') ADVANCE(535);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(anon_sym_short);
      END_STATE();
    case 425:
      if (lookahead == 'd') ADVANCE(536);
      END_STATE();
    case 426:
      if (lookahead == 'f') ADVANCE(537);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(anon_sym_snorm);
      END_STATE();
    case 428:
      if (lookahead == 'c') ADVANCE(538);
      END_STATE();
    case 429:
      if (lookahead == 't') ADVANCE(539);
      END_STATE();
    case 430:
      if (lookahead == 'h') ADVANCE(540);
      END_STATE();
    case 431:
      if (lookahead == 'a') ADVANCE(541);
      END_STATE();
    case 432:
      if (lookahead == 'd') ADVANCE(542);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 434:
      if (lookahead == 'g') ADVANCE(543);
      END_STATE();
    case 435:
      if (lookahead == 'e') ADVANCE(544);
      END_STATE();
    case 436:
      if (lookahead == 'a') ADVANCE(545);
      END_STATE();
    case 437:
      if (lookahead == 'r') ADVANCE(546);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(anon_sym_unorm);
      END_STATE();
    case 440:
      if (lookahead == 'n') ADVANCE(547);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 442:
      if (lookahead == 'a') ADVANCE(548);
      END_STATE();
    case 443:
      if (lookahead == 'i') ADVANCE(549);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(anon_sym_where);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 446:
      if (lookahead == 'q') ADVANCE(550);
      END_STATE();
    case 447:
      if (lookahead == 'a') ADVANCE(551);
      if (lookahead == 'o') ADVANCE(552);
      END_STATE();
    case 448:
      if (lookahead == 'c') ADVANCE(553);
      END_STATE();
    case 449:
      if (lookahead == 'i') ADVANCE(554);
      END_STATE();
    case 450:
      if (lookahead == 'l') ADVANCE(555);
      END_STATE();
    case 451:
      if (lookahead == 'u') ADVANCE(556);
      END_STATE();
    case 452:
      if (lookahead == 'n') ADVANCE(557);
      END_STATE();
    case 453:
      if (lookahead == '_') ADVANCE(558);
      END_STATE();
    case 454:
      if (lookahead == 'i') ADVANCE(559);
      END_STATE();
    case 455:
      if (lookahead == 'd') ADVANCE(560);
      END_STATE();
    case 456:
      if (lookahead == 'l') ADVANCE(561);
      END_STATE();
    case 457:
      if (lookahead == 'a') ADVANCE(562);
      END_STATE();
    case 458:
      if (lookahead == 's') ADVANCE(563);
      END_STATE();
    case 459:
      if (lookahead == 'p') ADVANCE(564);
      END_STATE();
    case 460:
      if (lookahead == 'r') ADVANCE(565);
      END_STATE();
    case 461:
      if (lookahead == 'n') ADVANCE(566);
      END_STATE();
    case 462:
      if (lookahead == 'c') ADVANCE(567);
      END_STATE();
    case 463:
      if (lookahead == 'l') ADVANCE(568);
      END_STATE();
    case 464:
      if (lookahead == 'e') ADVANCE(569);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym___init);
      END_STATE();
    case 466:
      if (lookahead == 'n') ADVANCE(570);
      END_STATE();
    case 467:
      if (lookahead == 'e') ADVANCE(571);
      END_STATE();
    case 468:
      if (lookahead == 'r') ADVANCE(572);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(sym_ms_signed_ptr_modifier);
      END_STATE();
    case 470:
      if (lookahead == 'a') ADVANCE(573);
      END_STATE();
    case 471:
      if (lookahead == 'c') ADVANCE(574);
      END_STATE();
    case 472:
      if (lookahead == 'c') ADVANCE(575);
      END_STATE();
    case 473:
      if (lookahead == 'a') ADVANCE(576);
      END_STATE();
    case 474:
      if (lookahead == 'i') ADVANCE(577);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(sym_ms_unsigned_ptr_modifier);
      END_STATE();
    case 476:
      if (lookahead == 'o') ADVANCE(578);
      END_STATE();
    case 477:
      if (lookahead == 't') ADVANCE(579);
      END_STATE();
    case 478:
      if (lookahead == 'o') ADVANCE(580);
      END_STATE();
    case 479:
      if (lookahead == 'g') ADVANCE(581);
      END_STATE();
    case 480:
      if (lookahead == 's') ADVANCE(582);
      END_STATE();
    case 481:
      if (lookahead == 'f') ADVANCE(583);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(anon_sym_and_eq);
      END_STATE();
    case 483:
      if (lookahead == 'a') ADVANCE(584);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym_bitand);
      END_STATE();
    case 485:
      if (lookahead == 'r') ADVANCE(585);
      END_STATE();
    case 486:
      if (lookahead == 'i') ADVANCE(586);
      END_STATE();
    case 487:
      if (lookahead == 'i') ADVANCE(587);
      END_STATE();
    case 488:
      if (lookahead == 'u') ADVANCE(588);
      END_STATE();
    case 489:
      if (lookahead == 'l') ADVANCE(589);
      END_STATE();
    case 490:
      if (lookahead == '_') ADVANCE(590);
      END_STATE();
    case 491:
      if (lookahead == 't') ADVANCE(591);
      END_STATE();
    case 492:
      if (lookahead == 'v') ADVANCE(592);
      if (lookahead == 'x') ADVANCE(593);
      END_STATE();
    case 493:
      if (lookahead == 'n') ADVANCE(594);
      END_STATE();
    case 494:
      if (lookahead == 'u') ADVANCE(595);
      END_STATE();
    case 495:
      if (lookahead == 'p') ADVANCE(596);
      END_STATE();
    case 496:
      if (lookahead == 't') ADVANCE(597);
      END_STATE();
    case 497:
      if (lookahead == 'd') ADVANCE(598);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 499:
      if (lookahead == 'd') ADVANCE(599);
      END_STATE();
    case 500:
      if (lookahead == 'i') ADVANCE(600);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 502:
      if (lookahead == 'i') ADVANCE(601);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(anon_sym_friend);
      END_STATE();
    case 505:
      if (lookahead == 'l') ADVANCE(602);
      END_STATE();
    case 506:
      if (lookahead == 'h') ADVANCE(603);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(anon_sym_inline);
      END_STATE();
    case 509:
      if (lookahead == 'a') ADVANCE(604);
      END_STATE();
    case 510:
      if (lookahead == 'j') ADVANCE(605);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(anon_sym_linear);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 513:
      if (lookahead == 'e') ADVANCE(606);
      END_STATE();
    case 514:
      if (lookahead == 'a') ADVANCE(607);
      END_STATE();
    case 515:
      if (lookahead == 'p') ADVANCE(608);
      END_STATE();
    case 516:
      if (lookahead == 'r') ADVANCE(609);
      END_STATE();
    case 517:
      if (lookahead == 'p') ADVANCE(610);
      END_STATE();
    case 518:
      if (lookahead == 'r') ADVANCE(611);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(anon_sym_not_eq);
      END_STATE();
    case 520:
      if (lookahead == 'r') ADVANCE(612);
      END_STATE();
    case 521:
      if (lookahead == 'o') ADVANCE(613);
      END_STATE();
    case 522:
      if (lookahead == 'o') ADVANCE(614);
      END_STATE();
    case 523:
      if (lookahead == 'd') ADVANCE(615);
      END_STATE();
    case 524:
      if (lookahead == 'e') ADVANCE(616);
      END_STATE();
    case 525:
      if (lookahead == 'e') ADVANCE(617);
      END_STATE();
    case 526:
      if (lookahead == 't') ADVANCE(618);
      END_STATE();
    case 527:
      if (lookahead == 't') ADVANCE(619);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 529:
      if (lookahead == 'e') ADVANCE(620);
      END_STATE();
    case 530:
      if (lookahead == 'e') ADVANCE(621);
      END_STATE();
    case 531:
      if (lookahead == 'c') ADVANCE(622);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 533:
      if (lookahead == 'j') ADVANCE(623);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(anon_sym_sample);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(anon_sym_shared);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(anon_sym_signed);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(anon_sym_sizeof);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(anon_sym_static);
      if (lookahead == '_') ADVANCE(624);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 541:
      if (lookahead == 't') ADVANCE(625);
      END_STATE();
    case 542:
      if (lookahead == '_') ADVANCE(626);
      END_STATE();
    case 543:
      if (lookahead == 'l') ADVANCE(627);
      END_STATE();
    case 544:
      if (lookahead == 'f') ADVANCE(628);
      END_STATE();
    case 545:
      if (lookahead == 'm') ADVANCE(629);
      END_STATE();
    case 546:
      if (lookahead == 'm') ADVANCE(630);
      END_STATE();
    case 547:
      if (lookahead == 'e') ADVANCE(631);
      END_STATE();
    case 548:
      if (lookahead == 'l') ADVANCE(632);
      END_STATE();
    case 549:
      if (lookahead == 'l') ADVANCE(633);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(anon_sym_xor_eq);
      END_STATE();
    case 551:
      if (lookahead == 's') ADVANCE(634);
      END_STATE();
    case 552:
      if (lookahead == 'f') ADVANCE(635);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(anon_sym__Atomic);
      END_STATE();
    case 554:
      if (lookahead == 'c') ADVANCE(636);
      END_STATE();
    case 555:
      if (lookahead == 'l') ADVANCE(637);
      END_STATE();
    case 556:
      if (lookahead == 'r') ADVANCE(638);
      END_STATE();
    case 557:
      if (lookahead == 'o') ADVANCE(639);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(anon_sym___asm__);
      END_STATE();
    case 559:
      if (lookahead == 'b') ADVANCE(640);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(anon_sym___based);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(anon_sym___cdecl);
      END_STATE();
    case 562:
      if (lookahead == 'l') ADVANCE(641);
      END_STATE();
    case 563:
      if (lookahead == 'p') ADVANCE(642);
      END_STATE();
    case 564:
      if (lookahead == 't') ADVANCE(643);
      END_STATE();
    case 565:
      if (lookahead == 't') ADVANCE(644);
      END_STATE();
    case 566:
      if (lookahead == 's') ADVANCE(645);
      END_STATE();
    case 567:
      if (lookahead == 'a') ADVANCE(646);
      END_STATE();
    case 568:
      if (lookahead == 'l') ADVANCE(647);
      END_STATE();
    case 569:
      if (lookahead == 'i') ADVANCE(648);
      END_STATE();
    case 570:
      if (lookahead == 'e') ADVANCE(649);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(anon_sym___leave);
      END_STATE();
    case 572:
      if (lookahead == 'i') ADVANCE(650);
      END_STATE();
    case 573:
      if (lookahead == 'l') ADVANCE(651);
      END_STATE();
    case 574:
      if (lookahead == 'r') ADVANCE(652);
      END_STATE();
    case 575:
      if (lookahead == 'a') ADVANCE(653);
      END_STATE();
    case 576:
      if (lookahead == 'd') ADVANCE(654);
      END_STATE();
    case 577:
      if (lookahead == 'g') ADVANCE(655);
      END_STATE();
    case 578:
      if (lookahead == 'r') ADVANCE(656);
      END_STATE();
    case 579:
      if (lookahead == 'i') ADVANCE(657);
      END_STATE();
    case 580:
      if (lookahead == 'f') ADVANCE(658);
      END_STATE();
    case 581:
      if (lookahead == 'n') ADVANCE(659);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(anon_sym_alignas);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(anon_sym_alignof);
      END_STATE();
    case 584:
      if (lookahead == 't') ADVANCE(660);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(anon_sym_cbuffer);
      END_STATE();
    case 586:
      if (lookahead == 'd') ADVANCE(661);
      END_STATE();
    case 587:
      if (lookahead == 't') ADVANCE(662);
      END_STATE();
    case 588:
      if (lookahead == 'r') ADVANCE(663);
      END_STATE();
    case 589:
      if (lookahead == 'd') ADVANCE(664);
      END_STATE();
    case 590:
      if (lookahead == 'm') ADVANCE(665);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(anon_sym_concept);
      END_STATE();
    case 592:
      if (lookahead == 'a') ADVANCE(666);
      END_STATE();
    case 593:
      if (lookahead == 'p') ADVANCE(667);
      END_STATE();
    case 594:
      if (lookahead == 'i') ADVANCE(668);
      END_STATE();
    case 595:
      if (lookahead == 'e') ADVANCE(669);
      END_STATE();
    case 596:
      if (lookahead == 'e') ADVANCE(670);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(anon_sym_defined);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(anon_sym_discard);
      END_STATE();
    case 600:
      if (lookahead == 't') ADVANCE(671);
      END_STATE();
    case 601:
      if (lookahead == 'o') ADVANCE(672);
      END_STATE();
    case 602:
      if (lookahead == 'y') ADVANCE(673);
      END_STATE();
    case 603:
      if (lookahead == 'a') ADVANCE(674);
      END_STATE();
    case 604:
      if (lookahead == 'c') ADVANCE(675);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(anon_sym_lineadj);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(anon_sym_mutable);
      END_STATE();
    case 607:
      if (lookahead == 'c') ADVANCE(676);
      END_STATE();
    case 608:
      if (lookahead == 't') ADVANCE(677);
      END_STATE();
    case 609:
      if (lookahead == 'p') ADVANCE(678);
      END_STATE();
    case 610:
      if (lookahead == 'e') ADVANCE(679);
      END_STATE();
    case 611:
      if (lookahead == 'n') ADVANCE(680);
      END_STATE();
    case 612:
      ACCEPT_TOKEN(anon_sym_nullptr);
      END_STATE();
    case 613:
      if (lookahead == 'f') ADVANCE(681);
      END_STATE();
    case 614:
      if (lookahead == 'r') ADVANCE(682);
      END_STATE();
    case 615:
      if (lookahead == 'e') ADVANCE(683);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(anon_sym_precise);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 618:
      if (lookahead == 'y') ADVANCE(684);
      END_STATE();
    case 619:
      if (lookahead == 'e') ADVANCE(685);
      END_STATE();
    case 620:
      if (lookahead == 'r') ADVANCE(686);
      END_STATE();
    case 621:
      if (lookahead == 's') ADVANCE(687);
      END_STATE();
    case 622:
      if (lookahead == 't') ADVANCE(688);
      END_STATE();
    case 623:
      if (lookahead == 'o') ADVANCE(689);
      END_STATE();
    case 624:
      if (lookahead == 'a') ADVANCE(690);
      END_STATE();
    case 625:
      if (lookahead == 'e') ADVANCE(691);
      END_STATE();
    case 626:
      if (lookahead == 'l') ADVANCE(692);
      END_STATE();
    case 627:
      if (lookahead == 'e') ADVANCE(693);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(anon_sym_typedef);
      END_STATE();
    case 629:
      if (lookahead == 'e') ADVANCE(694);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(anon_sym_uniform);
      END_STATE();
    case 631:
      if (lookahead == 'd') ADVANCE(695);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(anon_sym_virtual);
      END_STATE();
    case 633:
      if (lookahead == 'e') ADVANCE(696);
      END_STATE();
    case 634:
      ACCEPT_TOKEN(anon_sym__Alignas);
      END_STATE();
    case 635:
      ACCEPT_TOKEN(anon_sym__Alignof);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(anon_sym__Generic);
      END_STATE();
    case 637:
      ACCEPT_TOKEN(anon_sym__Nonnull);
      END_STATE();
    case 638:
      if (lookahead == 'n') ADVANCE(697);
      END_STATE();
    case 639:
      if (lookahead == 'f') ADVANCE(698);
      END_STATE();
    case 640:
      if (lookahead == 'u') ADVANCE(699);
      END_STATE();
    case 641:
      if (lookahead == 'l') ADVANCE(700);
      END_STATE();
    case 642:
      if (lookahead == 'e') ADVANCE(701);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(anon_sym___except);
      END_STATE();
    case 644:
      if (lookahead == 'e') ADVANCE(702);
      END_STATE();
    case 645:
      if (lookahead == 'i') ADVANCE(703);
      END_STATE();
    case 646:
      if (lookahead == 'l') ADVANCE(704);
      END_STATE();
    case 647:
      if (lookahead == 'y') ADVANCE(705);
      END_STATE();
    case 648:
      if (lookahead == 'n') ADVANCE(706);
      END_STATE();
    case 649:
      ACCEPT_TOKEN(anon_sym___inline);
      if (lookahead == '_') ADVANCE(707);
      END_STATE();
    case 650:
      if (lookahead == 'c') ADVANCE(708);
      END_STATE();
    case 651:
      if (lookahead == 'l') ADVANCE(709);
      END_STATE();
    case 652:
      if (lookahead == 'i') ADVANCE(710);
      END_STATE();
    case 653:
      if (lookahead == 'l') ADVANCE(711);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(anon_sym___thread);
      END_STATE();
    case 655:
      if (lookahead == 'n') ADVANCE(712);
      END_STATE();
    case 656:
      if (lookahead == 'c') ADVANCE(713);
      END_STATE();
    case 657:
      if (lookahead == 'l') ADVANCE(714);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(anon_sym__alignof);
      END_STATE();
    case 659:
      if (lookahead == 'e') ADVANCE(715);
      END_STATE();
    case 660:
      if (lookahead == 'e') ADVANCE(716);
      END_STATE();
    case 661:
      ACCEPT_TOKEN(anon_sym_centroid);
      END_STATE();
    case 662:
      ACCEPT_TOKEN(anon_sym_co_await);
      END_STATE();
    case 663:
      if (lookahead == 'n') ADVANCE(717);
      END_STATE();
    case 664:
      ACCEPT_TOKEN(anon_sym_co_yield);
      END_STATE();
    case 665:
      if (lookahead == 'a') ADVANCE(718);
      END_STATE();
    case 666:
      if (lookahead == 'l') ADVANCE(719);
      END_STATE();
    case 667:
      if (lookahead == 'r') ADVANCE(720);
      END_STATE();
    case 668:
      if (lookahead == 't') ADVANCE(721);
      END_STATE();
    case 669:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 670:
      ACCEPT_TOKEN(anon_sym_decltype);
      END_STATE();
    case 671:
      ACCEPT_TOKEN(anon_sym_explicit);
      END_STATE();
    case 672:
      if (lookahead == 'n') ADVANCE(722);
      END_STATE();
    case 673:
      if (lookahead == 'c') ADVANCE(723);
      END_STATE();
    case 674:
      if (lookahead == 'r') ADVANCE(724);
      END_STATE();
    case 675:
      if (lookahead == 'e') ADVANCE(725);
      END_STATE();
    case 676:
      if (lookahead == 'e') ADVANCE(726);
      END_STATE();
    case 677:
      ACCEPT_TOKEN(anon_sym_noexcept);
      END_STATE();
    case 678:
      if (lookahead == 'o') ADVANCE(727);
      END_STATE();
    case 679:
      if (lookahead == 'c') ADVANCE(728);
      END_STATE();
    case 680:
      ACCEPT_TOKEN(anon_sym_noreturn);
      END_STATE();
    case 681:
      ACCEPT_TOKEN(anon_sym_offsetof);
      END_STATE();
    case 682:
      ACCEPT_TOKEN(anon_sym_operator);
      END_STATE();
    case 683:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 684:
      ACCEPT_TOKEN(anon_sym_property);
      END_STATE();
    case 685:
      if (lookahead == 'd') ADVANCE(729);
      END_STATE();
    case 686:
      ACCEPT_TOKEN(anon_sym_register);
      END_STATE();
    case 687:
      ACCEPT_TOKEN(anon_sym_requires);
      END_STATE();
    case 688:
      ACCEPT_TOKEN(anon_sym_restrict);
      END_STATE();
    case 689:
      if (lookahead == 'r') ADVANCE(730);
      END_STATE();
    case 690:
      if (lookahead == 's') ADVANCE(731);
      END_STATE();
    case 691:
      ACCEPT_TOKEN(anon_sym_template);
      END_STATE();
    case 692:
      if (lookahead == 'o') ADVANCE(732);
      END_STATE();
    case 693:
      ACCEPT_TOKEN(anon_sym_triangle);
      if (lookahead == 'a') ADVANCE(733);
      END_STATE();
    case 694:
      ACCEPT_TOKEN(anon_sym_typename);
      END_STATE();
    case 695:
      ACCEPT_TOKEN(anon_sym_unsigned);
      END_STATE();
    case 696:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 697:
      ACCEPT_TOKEN(anon_sym__Noreturn);
      END_STATE();
    case 698:
      ACCEPT_TOKEN(anon_sym___alignof);
      if (lookahead == '_') ADVANCE(734);
      END_STATE();
    case 699:
      if (lookahead == 't') ADVANCE(735);
      END_STATE();
    case 700:
      ACCEPT_TOKEN(anon_sym___clrcall);
      END_STATE();
    case 701:
      if (lookahead == 'c') ADVANCE(736);
      END_STATE();
    case 702:
      if (lookahead == 'd') ADVANCE(737);
      END_STATE();
    case 703:
      if (lookahead == 'o') ADVANCE(738);
      END_STATE();
    case 704:
      if (lookahead == 'l') ADVANCE(739);
      END_STATE();
    case 705:
      ACCEPT_TOKEN(anon_sym___finally);
      END_STATE();
    case 706:
      if (lookahead == 'l') ADVANCE(740);
      END_STATE();
    case 707:
      if (lookahead == '_') ADVANCE(741);
      END_STATE();
    case 708:
      if (lookahead == 't') ADVANCE(742);
      END_STATE();
    case 709:
      ACCEPT_TOKEN(anon_sym___stdcall);
      END_STATE();
    case 710:
      if (lookahead == 'p') ADVANCE(743);
      END_STATE();
    case 711:
      if (lookahead == 'l') ADVANCE(744);
      END_STATE();
    case 712:
      if (lookahead == 'e') ADVANCE(745);
      END_STATE();
    case 713:
      if (lookahead == 'a') ADVANCE(746);
      END_STATE();
    case 714:
      if (lookahead == 'e') ADVANCE(747);
      END_STATE();
    case 715:
      if (lookahead == 'd') ADVANCE(748);
      END_STATE();
    case 716:
      if (lookahead == 'd') ADVANCE(749);
      END_STATE();
    case 717:
      ACCEPT_TOKEN(anon_sym_co_return);
      END_STATE();
    case 718:
      if (lookahead == 'j') ADVANCE(750);
      END_STATE();
    case 719:
      ACCEPT_TOKEN(anon_sym_consteval);
      END_STATE();
    case 720:
      ACCEPT_TOKEN(anon_sym_constexpr);
      END_STATE();
    case 721:
      ACCEPT_TOKEN(anon_sym_constinit);
      END_STATE();
    case 722:
      ACCEPT_TOKEN(anon_sym_extension);
      END_STATE();
    case 723:
      if (lookahead == 'o') ADVANCE(751);
      END_STATE();
    case 724:
      if (lookahead == 'e') ADVANCE(752);
      END_STATE();
    case 725:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 726:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 727:
      if (lookahead == 'l') ADVANCE(753);
      END_STATE();
    case 728:
      if (lookahead == 't') ADVANCE(754);
      END_STATE();
    case 729:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 730:
      ACCEPT_TOKEN(anon_sym_row_major);
      END_STATE();
    case 731:
      if (lookahead == 's') ADVANCE(755);
      END_STATE();
    case 732:
      if (lookahead == 'c') ADVANCE(756);
      END_STATE();
    case 733:
      if (lookahead == 'd') ADVANCE(757);
      END_STATE();
    case 734:
      if (lookahead == '_') ADVANCE(758);
      END_STATE();
    case 735:
      if (lookahead == 'e') ADVANCE(759);
      END_STATE();
    case 736:
      ACCEPT_TOKEN(anon_sym___declspec);
      END_STATE();
    case 737:
      ACCEPT_TOKEN(anon_sym___exported);
      END_STATE();
    case 738:
      if (lookahead == 'n') ADVANCE(760);
      END_STATE();
    case 739:
      ACCEPT_TOKEN(anon_sym___fastcall);
      END_STATE();
    case 740:
      if (lookahead == 'i') ADVANCE(761);
      END_STATE();
    case 741:
      ACCEPT_TOKEN(anon_sym___inline__);
      END_STATE();
    case 742:
      ACCEPT_TOKEN(sym_ms_restrict_modifier);
      if (lookahead == '_') ADVANCE(762);
      END_STATE();
    case 743:
      if (lookahead == 't') ADVANCE(763);
      END_STATE();
    case 744:
      ACCEPT_TOKEN(anon_sym___thiscall);
      END_STATE();
    case 745:
      if (lookahead == 'd') ADVANCE(764);
      END_STATE();
    case 746:
      if (lookahead == 'l') ADVANCE(765);
      END_STATE();
    case 747:
      if (lookahead == '_') ADVANCE(766);
      END_STATE();
    case 748:
      ACCEPT_TOKEN(anon_sym__unaligned);
      END_STATE();
    case 749:
      if (lookahead == 't') ADVANCE(767);
      END_STATE();
    case 750:
      if (lookahead == 'o') ADVANCE(768);
      END_STATE();
    case 751:
      if (lookahead == 'h') ADVANCE(769);
      END_STATE();
    case 752:
      if (lookahead == 'd') ADVANCE(770);
      END_STATE();
    case 753:
      if (lookahead == 'a') ADVANCE(771);
      END_STATE();
    case 754:
      if (lookahead == 'i') ADVANCE(772);
      END_STATE();
    case 755:
      if (lookahead == 'e') ADVANCE(773);
      END_STATE();
    case 756:
      if (lookahead == 'a') ADVANCE(774);
      END_STATE();
    case 757:
      if (lookahead == 'j') ADVANCE(775);
      END_STATE();
    case 758:
      ACCEPT_TOKEN(anon_sym___alignof__);
      END_STATE();
    case 759:
      ACCEPT_TOKEN(anon_sym___attribute);
      if (lookahead == '_') ADVANCE(776);
      END_STATE();
    case 760:
      if (lookahead == '_') ADVANCE(777);
      END_STATE();
    case 761:
      if (lookahead == 'n') ADVANCE(778);
      END_STATE();
    case 762:
      if (lookahead == '_') ADVANCE(779);
      END_STATE();
    case 763:
      ACCEPT_TOKEN(anon_sym___subscript);
      END_STATE();
    case 764:
      ACCEPT_TOKEN(anon_sym___unaligned);
      END_STATE();
    case 765:
      if (lookahead == 'l') ADVANCE(780);
      END_STATE();
    case 766:
      if (lookahead == '_') ADVANCE(781);
      END_STATE();
    case 767:
      if (lookahead == 'y') ADVANCE(782);
      END_STATE();
    case 768:
      if (lookahead == 'r') ADVANCE(783);
      END_STATE();
    case 769:
      if (lookahead == 'e') ADVANCE(784);
      END_STATE();
    case 770:
      ACCEPT_TOKEN(anon_sym_groupshared);
      END_STATE();
    case 771:
      if (lookahead == 't') ADVANCE(785);
      END_STATE();
    case 772:
      if (lookahead == 'v') ADVANCE(786);
      END_STATE();
    case 773:
      if (lookahead == 'r') ADVANCE(787);
      END_STATE();
    case 774:
      if (lookahead == 'l') ADVANCE(788);
      END_STATE();
    case 775:
      ACCEPT_TOKEN(anon_sym_triangleadj);
      END_STATE();
    case 776:
      if (lookahead == '_') ADVANCE(789);
      END_STATE();
    case 777:
      if (lookahead == '_') ADVANCE(790);
      END_STATE();
    case 778:
      if (lookahead == 'e') ADVANCE(791);
      END_STATE();
    case 779:
      ACCEPT_TOKEN(anon_sym___restrict__);
      END_STATE();
    case 780:
      ACCEPT_TOKEN(anon_sym___vectorcall);
      END_STATE();
    case 781:
      ACCEPT_TOKEN(anon_sym___volatile__);
      END_STATE();
    case 782:
      if (lookahead == 'p') ADVANCE(792);
      END_STATE();
    case 783:
      ACCEPT_TOKEN(anon_sym_column_major);
      END_STATE();
    case 784:
      if (lookahead == 'r') ADVANCE(793);
      END_STATE();
    case 785:
      if (lookahead == 'i') ADVANCE(794);
      END_STATE();
    case 786:
      if (lookahead == 'e') ADVANCE(795);
      END_STATE();
    case 787:
      if (lookahead == 't') ADVANCE(796);
      END_STATE();
    case 788:
      ACCEPT_TOKEN(anon_sym_thread_local);
      END_STATE();
    case 789:
      ACCEPT_TOKEN(anon_sym___attribute__);
      END_STATE();
    case 790:
      ACCEPT_TOKEN(anon_sym___extension__);
      END_STATE();
    case 791:
      ACCEPT_TOKEN(anon_sym___forceinline);
      END_STATE();
    case 792:
      if (lookahead == 'e') ADVANCE(797);
      END_STATE();
    case 793:
      if (lookahead == 'e') ADVANCE(798);
      END_STATE();
    case 794:
      if (lookahead == 'o') ADVANCE(799);
      END_STATE();
    case 795:
      ACCEPT_TOKEN(anon_sym_noperspective);
      END_STATE();
    case 796:
      ACCEPT_TOKEN(anon_sym_static_assert);
      END_STATE();
    case 797:
      ACCEPT_TOKEN(anon_sym_associatedtype);
      END_STATE();
    case 798:
      if (lookahead == 'n') ADVANCE(800);
      END_STATE();
    case 799:
      if (lookahead == 'n') ADVANCE(801);
      END_STATE();
    case 800:
      if (lookahead == 't') ADVANCE(802);
      END_STATE();
    case 801:
      ACCEPT_TOKEN(anon_sym_nointerpolation);
      END_STATE();
    case 802:
      ACCEPT_TOKEN(anon_sym_globallycoherent);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 356},
  [2] = {.lex_state = 356},
  [3] = {.lex_state = 356},
  [4] = {.lex_state = 356},
  [5] = {.lex_state = 356},
  [6] = {.lex_state = 356},
  [7] = {.lex_state = 183},
  [8] = {.lex_state = 183},
  [9] = {.lex_state = 183},
  [10] = {.lex_state = 183},
  [11] = {.lex_state = 183},
  [12] = {.lex_state = 183},
  [13] = {.lex_state = 183},
  [14] = {.lex_state = 183},
  [15] = {.lex_state = 183},
  [16] = {.lex_state = 183},
  [17] = {.lex_state = 183},
  [18] = {.lex_state = 183},
  [19] = {.lex_state = 183},
  [20] = {.lex_state = 183},
  [21] = {.lex_state = 183},
  [22] = {.lex_state = 183},
  [23] = {.lex_state = 183},
  [24] = {.lex_state = 183},
  [25] = {.lex_state = 183},
  [26] = {.lex_state = 183},
  [27] = {.lex_state = 183},
  [28] = {.lex_state = 356},
  [29] = {.lex_state = 356},
  [30] = {.lex_state = 356},
  [31] = {.lex_state = 356},
  [32] = {.lex_state = 186},
  [33] = {.lex_state = 356},
  [34] = {.lex_state = 356},
  [35] = {.lex_state = 356},
  [36] = {.lex_state = 356},
  [37] = {.lex_state = 356},
  [38] = {.lex_state = 356},
  [39] = {.lex_state = 356},
  [40] = {.lex_state = 186},
  [41] = {.lex_state = 356},
  [42] = {.lex_state = 356},
  [43] = {.lex_state = 356},
  [44] = {.lex_state = 356},
  [45] = {.lex_state = 356},
  [46] = {.lex_state = 356},
  [47] = {.lex_state = 356},
  [48] = {.lex_state = 186},
  [49] = {.lex_state = 356},
  [50] = {.lex_state = 356},
  [51] = {.lex_state = 356},
  [52] = {.lex_state = 356},
  [53] = {.lex_state = 356},
  [54] = {.lex_state = 356},
  [55] = {.lex_state = 356},
  [56] = {.lex_state = 356},
  [57] = {.lex_state = 356},
  [58] = {.lex_state = 356},
  [59] = {.lex_state = 356},
  [60] = {.lex_state = 356},
  [61] = {.lex_state = 356},
  [62] = {.lex_state = 356},
  [63] = {.lex_state = 356},
  [64] = {.lex_state = 356},
  [65] = {.lex_state = 356},
  [66] = {.lex_state = 356},
  [67] = {.lex_state = 356},
  [68] = {.lex_state = 356},
  [69] = {.lex_state = 356},
  [70] = {.lex_state = 356},
  [71] = {.lex_state = 356},
  [72] = {.lex_state = 356},
  [73] = {.lex_state = 356},
  [74] = {.lex_state = 356},
  [75] = {.lex_state = 356},
  [76] = {.lex_state = 356},
  [77] = {.lex_state = 356},
  [78] = {.lex_state = 356},
  [79] = {.lex_state = 356},
  [80] = {.lex_state = 183},
  [81] = {.lex_state = 356},
  [82] = {.lex_state = 356},
  [83] = {.lex_state = 183},
  [84] = {.lex_state = 356},
  [85] = {.lex_state = 356},
  [86] = {.lex_state = 183},
  [87] = {.lex_state = 183},
  [88] = {.lex_state = 356},
  [89] = {.lex_state = 183},
  [90] = {.lex_state = 356},
  [91] = {.lex_state = 356},
  [92] = {.lex_state = 356},
  [93] = {.lex_state = 356},
  [94] = {.lex_state = 356},
  [95] = {.lex_state = 186},
  [96] = {.lex_state = 186},
  [97] = {.lex_state = 186},
  [98] = {.lex_state = 186},
  [99] = {.lex_state = 186},
  [100] = {.lex_state = 185},
  [101] = {.lex_state = 185},
  [102] = {.lex_state = 185},
  [103] = {.lex_state = 185},
  [104] = {.lex_state = 185},
  [105] = {.lex_state = 185},
  [106] = {.lex_state = 185},
  [107] = {.lex_state = 185},
  [108] = {.lex_state = 185},
  [109] = {.lex_state = 185},
  [110] = {.lex_state = 185},
  [111] = {.lex_state = 185},
  [112] = {.lex_state = 354},
  [113] = {.lex_state = 354},
  [114] = {.lex_state = 354},
  [115] = {.lex_state = 354},
  [116] = {.lex_state = 354},
  [117] = {.lex_state = 354},
  [118] = {.lex_state = 354},
  [119] = {.lex_state = 354},
  [120] = {.lex_state = 354},
  [121] = {.lex_state = 354},
  [122] = {.lex_state = 354},
  [123] = {.lex_state = 354},
  [124] = {.lex_state = 354},
  [125] = {.lex_state = 354},
  [126] = {.lex_state = 354},
  [127] = {.lex_state = 354},
  [128] = {.lex_state = 354},
  [129] = {.lex_state = 354},
  [130] = {.lex_state = 354},
  [131] = {.lex_state = 354},
  [132] = {.lex_state = 354},
  [133] = {.lex_state = 354},
  [134] = {.lex_state = 354},
  [135] = {.lex_state = 354},
  [136] = {.lex_state = 354},
  [137] = {.lex_state = 354},
  [138] = {.lex_state = 354},
  [139] = {.lex_state = 354},
  [140] = {.lex_state = 354},
  [141] = {.lex_state = 354},
  [142] = {.lex_state = 354},
  [143] = {.lex_state = 354},
  [144] = {.lex_state = 354},
  [145] = {.lex_state = 354},
  [146] = {.lex_state = 354},
  [147] = {.lex_state = 354},
  [148] = {.lex_state = 355},
  [149] = {.lex_state = 355},
  [150] = {.lex_state = 355},
  [151] = {.lex_state = 355},
  [152] = {.lex_state = 355},
  [153] = {.lex_state = 355},
  [154] = {.lex_state = 355},
  [155] = {.lex_state = 355},
  [156] = {.lex_state = 355},
  [157] = {.lex_state = 355},
  [158] = {.lex_state = 355},
  [159] = {.lex_state = 355},
  [160] = {.lex_state = 355},
  [161] = {.lex_state = 355},
  [162] = {.lex_state = 355},
  [163] = {.lex_state = 185},
  [164] = {.lex_state = 185},
  [165] = {.lex_state = 185},
  [166] = {.lex_state = 185},
  [167] = {.lex_state = 185},
  [168] = {.lex_state = 185},
  [169] = {.lex_state = 185},
  [170] = {.lex_state = 185},
  [171] = {.lex_state = 185},
  [172] = {.lex_state = 185},
  [173] = {.lex_state = 185},
  [174] = {.lex_state = 185},
  [175] = {.lex_state = 185},
  [176] = {.lex_state = 355},
  [177] = {.lex_state = 355},
  [178] = {.lex_state = 355},
  [179] = {.lex_state = 355},
  [180] = {.lex_state = 355},
  [181] = {.lex_state = 355},
  [182] = {.lex_state = 355},
  [183] = {.lex_state = 355},
  [184] = {.lex_state = 355},
  [185] = {.lex_state = 355},
  [186] = {.lex_state = 355},
  [187] = {.lex_state = 355},
  [188] = {.lex_state = 355},
  [189] = {.lex_state = 355},
  [190] = {.lex_state = 355},
  [191] = {.lex_state = 355},
  [192] = {.lex_state = 355},
  [193] = {.lex_state = 185},
  [194] = {.lex_state = 185},
  [195] = {.lex_state = 185},
  [196] = {.lex_state = 185},
  [197] = {.lex_state = 185},
  [198] = {.lex_state = 185},
  [199] = {.lex_state = 185},
  [200] = {.lex_state = 356},
  [201] = {.lex_state = 356},
  [202] = {.lex_state = 356},
  [203] = {.lex_state = 356},
  [204] = {.lex_state = 356},
  [205] = {.lex_state = 356},
  [206] = {.lex_state = 356},
  [207] = {.lex_state = 356},
  [208] = {.lex_state = 356},
  [209] = {.lex_state = 356},
  [210] = {.lex_state = 356},
  [211] = {.lex_state = 356},
  [212] = {.lex_state = 356},
  [213] = {.lex_state = 356},
  [214] = {.lex_state = 356},
  [215] = {.lex_state = 356},
  [216] = {.lex_state = 356},
  [217] = {.lex_state = 356},
  [218] = {.lex_state = 356},
  [219] = {.lex_state = 356},
  [220] = {.lex_state = 356},
  [221] = {.lex_state = 356},
  [222] = {.lex_state = 356},
  [223] = {.lex_state = 356},
  [224] = {.lex_state = 356},
  [225] = {.lex_state = 252},
  [226] = {.lex_state = 252},
  [227] = {.lex_state = 252},
  [228] = {.lex_state = 252},
  [229] = {.lex_state = 252},
  [230] = {.lex_state = 252},
  [231] = {.lex_state = 252},
  [232] = {.lex_state = 252},
  [233] = {.lex_state = 252},
  [234] = {.lex_state = 252},
  [235] = {.lex_state = 252},
  [236] = {.lex_state = 252},
  [237] = {.lex_state = 252},
  [238] = {.lex_state = 252},
  [239] = {.lex_state = 252},
  [240] = {.lex_state = 252},
  [241] = {.lex_state = 356},
  [242] = {.lex_state = 356},
  [243] = {.lex_state = 183},
  [244] = {.lex_state = 183},
  [245] = {.lex_state = 356},
  [246] = {.lex_state = 356},
  [247] = {.lex_state = 356},
  [248] = {.lex_state = 356},
  [249] = {.lex_state = 252},
  [250] = {.lex_state = 183},
  [251] = {.lex_state = 183},
  [252] = {.lex_state = 187},
  [253] = {.lex_state = 187},
  [254] = {.lex_state = 356},
  [255] = {.lex_state = 187},
  [256] = {.lex_state = 356},
  [257] = {.lex_state = 183},
  [258] = {.lex_state = 356},
  [259] = {.lex_state = 183},
  [260] = {.lex_state = 356},
  [261] = {.lex_state = 183},
  [262] = {.lex_state = 183},
  [263] = {.lex_state = 183},
  [264] = {.lex_state = 183},
  [265] = {.lex_state = 183},
  [266] = {.lex_state = 183},
  [267] = {.lex_state = 356},
  [268] = {.lex_state = 183},
  [269] = {.lex_state = 183},
  [270] = {.lex_state = 183},
  [271] = {.lex_state = 183},
  [272] = {.lex_state = 183},
  [273] = {.lex_state = 183},
  [274] = {.lex_state = 183},
  [275] = {.lex_state = 183},
  [276] = {.lex_state = 183},
  [277] = {.lex_state = 183},
  [278] = {.lex_state = 183},
  [279] = {.lex_state = 183},
  [280] = {.lex_state = 183},
  [281] = {.lex_state = 183},
  [282] = {.lex_state = 183},
  [283] = {.lex_state = 356},
  [284] = {.lex_state = 356},
  [285] = {.lex_state = 183},
  [286] = {.lex_state = 356},
  [287] = {.lex_state = 356},
  [288] = {.lex_state = 356},
  [289] = {.lex_state = 356},
  [290] = {.lex_state = 356},
  [291] = {.lex_state = 186},
  [292] = {.lex_state = 186},
  [293] = {.lex_state = 356},
  [294] = {.lex_state = 356},
  [295] = {.lex_state = 356},
  [296] = {.lex_state = 356},
  [297] = {.lex_state = 356},
  [298] = {.lex_state = 356},
  [299] = {.lex_state = 356},
  [300] = {.lex_state = 183},
  [301] = {.lex_state = 356},
  [302] = {.lex_state = 356},
  [303] = {.lex_state = 356},
  [304] = {.lex_state = 356},
  [305] = {.lex_state = 356},
  [306] = {.lex_state = 356},
  [307] = {.lex_state = 356},
  [308] = {.lex_state = 356},
  [309] = {.lex_state = 356},
  [310] = {.lex_state = 356},
  [311] = {.lex_state = 356},
  [312] = {.lex_state = 356},
  [313] = {.lex_state = 356},
  [314] = {.lex_state = 356},
  [315] = {.lex_state = 356},
  [316] = {.lex_state = 356},
  [317] = {.lex_state = 356},
  [318] = {.lex_state = 356},
  [319] = {.lex_state = 356},
  [320] = {.lex_state = 356},
  [321] = {.lex_state = 356},
  [322] = {.lex_state = 356},
  [323] = {.lex_state = 356},
  [324] = {.lex_state = 356},
  [325] = {.lex_state = 356},
  [326] = {.lex_state = 356},
  [327] = {.lex_state = 356},
  [328] = {.lex_state = 356},
  [329] = {.lex_state = 356},
  [330] = {.lex_state = 250},
  [331] = {.lex_state = 356},
  [332] = {.lex_state = 220},
  [333] = {.lex_state = 183},
  [334] = {.lex_state = 220},
  [335] = {.lex_state = 183},
  [336] = {.lex_state = 220},
  [337] = {.lex_state = 250},
  [338] = {.lex_state = 250},
  [339] = {.lex_state = 183},
  [340] = {.lex_state = 183},
  [341] = {.lex_state = 250},
  [342] = {.lex_state = 186},
  [343] = {.lex_state = 186},
  [344] = {.lex_state = 250},
  [345] = {.lex_state = 250},
  [346] = {.lex_state = 356},
  [347] = {.lex_state = 250},
  [348] = {.lex_state = 183},
  [349] = {.lex_state = 250},
  [350] = {.lex_state = 250},
  [351] = {.lex_state = 250},
  [352] = {.lex_state = 250},
  [353] = {.lex_state = 250},
  [354] = {.lex_state = 250},
  [355] = {.lex_state = 250},
  [356] = {.lex_state = 356},
  [357] = {.lex_state = 250},
  [358] = {.lex_state = 250},
  [359] = {.lex_state = 250},
  [360] = {.lex_state = 250},
  [361] = {.lex_state = 250},
  [362] = {.lex_state = 250},
  [363] = {.lex_state = 356},
  [364] = {.lex_state = 250},
  [365] = {.lex_state = 250},
  [366] = {.lex_state = 183},
  [367] = {.lex_state = 250},
  [368] = {.lex_state = 250},
  [369] = {.lex_state = 250},
  [370] = {.lex_state = 250},
  [371] = {.lex_state = 250},
  [372] = {.lex_state = 250},
  [373] = {.lex_state = 250},
  [374] = {.lex_state = 250},
  [375] = {.lex_state = 250},
  [376] = {.lex_state = 356},
  [377] = {.lex_state = 183},
  [378] = {.lex_state = 183},
  [379] = {.lex_state = 183},
  [380] = {.lex_state = 183},
  [381] = {.lex_state = 183},
  [382] = {.lex_state = 183},
  [383] = {.lex_state = 183},
  [384] = {.lex_state = 183},
  [385] = {.lex_state = 183},
  [386] = {.lex_state = 183},
  [387] = {.lex_state = 356},
  [388] = {.lex_state = 356},
  [389] = {.lex_state = 356},
  [390] = {.lex_state = 356},
  [391] = {.lex_state = 356},
  [392] = {.lex_state = 356},
  [393] = {.lex_state = 356},
  [394] = {.lex_state = 356},
  [395] = {.lex_state = 183},
  [396] = {.lex_state = 356},
  [397] = {.lex_state = 183},
  [398] = {.lex_state = 356},
  [399] = {.lex_state = 356},
  [400] = {.lex_state = 356},
  [401] = {.lex_state = 356},
  [402] = {.lex_state = 356},
  [403] = {.lex_state = 356},
  [404] = {.lex_state = 356},
  [405] = {.lex_state = 183},
  [406] = {.lex_state = 183},
  [407] = {.lex_state = 183},
  [408] = {.lex_state = 183},
  [409] = {.lex_state = 356},
  [410] = {.lex_state = 356},
  [411] = {.lex_state = 183},
  [412] = {.lex_state = 183},
  [413] = {.lex_state = 356},
  [414] = {.lex_state = 356},
  [415] = {.lex_state = 183},
  [416] = {.lex_state = 183},
  [417] = {.lex_state = 183},
  [418] = {.lex_state = 183},
  [419] = {.lex_state = 356},
  [420] = {.lex_state = 183},
  [421] = {.lex_state = 183},
  [422] = {.lex_state = 356},
  [423] = {.lex_state = 183},
  [424] = {.lex_state = 356},
  [425] = {.lex_state = 356},
  [426] = {.lex_state = 356},
  [427] = {.lex_state = 356},
  [428] = {.lex_state = 356},
  [429] = {.lex_state = 356},
  [430] = {.lex_state = 356},
  [431] = {.lex_state = 356},
  [432] = {.lex_state = 356},
  [433] = {.lex_state = 356},
  [434] = {.lex_state = 356},
  [435] = {.lex_state = 356},
  [436] = {.lex_state = 356},
  [437] = {.lex_state = 356},
  [438] = {.lex_state = 356},
  [439] = {.lex_state = 356},
  [440] = {.lex_state = 356},
  [441] = {.lex_state = 183},
  [442] = {.lex_state = 183},
  [443] = {.lex_state = 356},
  [444] = {.lex_state = 183},
  [445] = {.lex_state = 356},
  [446] = {.lex_state = 356},
  [447] = {.lex_state = 356},
  [448] = {.lex_state = 356},
  [449] = {.lex_state = 183},
  [450] = {.lex_state = 356},
  [451] = {.lex_state = 183},
  [452] = {.lex_state = 356},
  [453] = {.lex_state = 183},
  [454] = {.lex_state = 356},
  [455] = {.lex_state = 356},
  [456] = {.lex_state = 183},
  [457] = {.lex_state = 183},
  [458] = {.lex_state = 183},
  [459] = {.lex_state = 183},
  [460] = {.lex_state = 356},
  [461] = {.lex_state = 356},
  [462] = {.lex_state = 356},
  [463] = {.lex_state = 356},
  [464] = {.lex_state = 356},
  [465] = {.lex_state = 183},
  [466] = {.lex_state = 356},
  [467] = {.lex_state = 183},
  [468] = {.lex_state = 356},
  [469] = {.lex_state = 183},
  [470] = {.lex_state = 356},
  [471] = {.lex_state = 356},
  [472] = {.lex_state = 356},
  [473] = {.lex_state = 356},
  [474] = {.lex_state = 356},
  [475] = {.lex_state = 356},
  [476] = {.lex_state = 356},
  [477] = {.lex_state = 356},
  [478] = {.lex_state = 356},
  [479] = {.lex_state = 183},
  [480] = {.lex_state = 356},
  [481] = {.lex_state = 183},
  [482] = {.lex_state = 183},
  [483] = {.lex_state = 183},
  [484] = {.lex_state = 356},
  [485] = {.lex_state = 356},
  [486] = {.lex_state = 183},
  [487] = {.lex_state = 356},
  [488] = {.lex_state = 356},
  [489] = {.lex_state = 183},
  [490] = {.lex_state = 356},
  [491] = {.lex_state = 183},
  [492] = {.lex_state = 183},
  [493] = {.lex_state = 356},
  [494] = {.lex_state = 183},
  [495] = {.lex_state = 183},
  [496] = {.lex_state = 356},
  [497] = {.lex_state = 183},
  [498] = {.lex_state = 356},
  [499] = {.lex_state = 356},
  [500] = {.lex_state = 183},
  [501] = {.lex_state = 356},
  [502] = {.lex_state = 183},
  [503] = {.lex_state = 356},
  [504] = {.lex_state = 356},
  [505] = {.lex_state = 183},
  [506] = {.lex_state = 356},
  [507] = {.lex_state = 356},
  [508] = {.lex_state = 356},
  [509] = {.lex_state = 356},
  [510] = {.lex_state = 356},
  [511] = {.lex_state = 356},
  [512] = {.lex_state = 356},
  [513] = {.lex_state = 356},
  [514] = {.lex_state = 183},
  [515] = {.lex_state = 183},
  [516] = {.lex_state = 183},
  [517] = {.lex_state = 356},
  [518] = {.lex_state = 183},
  [519] = {.lex_state = 183},
  [520] = {.lex_state = 183},
  [521] = {.lex_state = 183},
  [522] = {.lex_state = 183},
  [523] = {.lex_state = 186},
  [524] = {.lex_state = 186},
  [525] = {.lex_state = 186},
  [526] = {.lex_state = 186},
  [527] = {.lex_state = 186},
  [528] = {.lex_state = 186},
  [529] = {.lex_state = 183},
  [530] = {.lex_state = 183},
  [531] = {.lex_state = 356},
  [532] = {.lex_state = 183},
  [533] = {.lex_state = 183},
  [534] = {.lex_state = 183},
  [535] = {.lex_state = 183},
  [536] = {.lex_state = 183},
  [537] = {.lex_state = 183},
  [538] = {.lex_state = 183},
  [539] = {.lex_state = 183},
  [540] = {.lex_state = 183},
  [541] = {.lex_state = 183},
  [542] = {.lex_state = 183},
  [543] = {.lex_state = 183},
  [544] = {.lex_state = 183},
  [545] = {.lex_state = 183},
  [546] = {.lex_state = 183},
  [547] = {.lex_state = 183},
  [548] = {.lex_state = 183},
  [549] = {.lex_state = 183},
  [550] = {.lex_state = 183},
  [551] = {.lex_state = 183},
  [552] = {.lex_state = 183},
  [553] = {.lex_state = 186},
  [554] = {.lex_state = 186},
  [555] = {.lex_state = 186},
  [556] = {.lex_state = 186},
  [557] = {.lex_state = 186},
  [558] = {.lex_state = 186},
  [559] = {.lex_state = 186},
  [560] = {.lex_state = 186},
  [561] = {.lex_state = 186},
  [562] = {.lex_state = 186},
  [563] = {.lex_state = 186},
  [564] = {.lex_state = 186},
  [565] = {.lex_state = 186},
  [566] = {.lex_state = 186},
  [567] = {.lex_state = 186},
  [568] = {.lex_state = 356},
  [569] = {.lex_state = 186},
  [570] = {.lex_state = 183},
  [571] = {.lex_state = 183},
  [572] = {.lex_state = 183},
  [573] = {.lex_state = 183},
  [574] = {.lex_state = 183},
  [575] = {.lex_state = 183},
  [576] = {.lex_state = 183},
  [577] = {.lex_state = 183},
  [578] = {.lex_state = 183},
  [579] = {.lex_state = 183},
  [580] = {.lex_state = 183},
  [581] = {.lex_state = 183},
  [582] = {.lex_state = 183},
  [583] = {.lex_state = 183},
  [584] = {.lex_state = 183},
  [585] = {.lex_state = 356},
  [586] = {.lex_state = 183},
  [587] = {.lex_state = 183},
  [588] = {.lex_state = 183},
  [589] = {.lex_state = 183},
  [590] = {.lex_state = 183},
  [591] = {.lex_state = 183},
  [592] = {.lex_state = 183},
  [593] = {.lex_state = 183},
  [594] = {.lex_state = 183},
  [595] = {.lex_state = 356},
  [596] = {.lex_state = 183},
  [597] = {.lex_state = 183},
  [598] = {.lex_state = 183},
  [599] = {.lex_state = 183},
  [600] = {.lex_state = 183},
  [601] = {.lex_state = 183},
  [602] = {.lex_state = 183},
  [603] = {.lex_state = 183},
  [604] = {.lex_state = 183},
  [605] = {.lex_state = 356},
  [606] = {.lex_state = 183},
  [607] = {.lex_state = 183},
  [608] = {.lex_state = 356},
  [609] = {.lex_state = 183},
  [610] = {.lex_state = 183},
  [611] = {.lex_state = 183},
  [612] = {.lex_state = 183},
  [613] = {.lex_state = 183},
  [614] = {.lex_state = 356},
  [615] = {.lex_state = 183},
  [616] = {.lex_state = 356},
  [617] = {.lex_state = 183},
  [618] = {.lex_state = 183},
  [619] = {.lex_state = 183},
  [620] = {.lex_state = 183},
  [621] = {.lex_state = 183},
  [622] = {.lex_state = 356},
  [623] = {.lex_state = 183},
  [624] = {.lex_state = 183},
  [625] = {.lex_state = 356},
  [626] = {.lex_state = 183},
  [627] = {.lex_state = 183},
  [628] = {.lex_state = 183},
  [629] = {.lex_state = 183},
  [630] = {.lex_state = 186},
  [631] = {.lex_state = 183},
  [632] = {.lex_state = 356},
  [633] = {.lex_state = 356},
  [634] = {.lex_state = 356},
  [635] = {.lex_state = 356},
  [636] = {.lex_state = 356},
  [637] = {.lex_state = 356},
  [638] = {.lex_state = 356},
  [639] = {.lex_state = 186},
  [640] = {.lex_state = 186},
  [641] = {.lex_state = 356},
  [642] = {.lex_state = 356},
  [643] = {.lex_state = 356},
  [644] = {.lex_state = 356},
  [645] = {.lex_state = 186},
  [646] = {.lex_state = 356},
  [647] = {.lex_state = 356},
  [648] = {.lex_state = 185},
  [649] = {.lex_state = 356},
  [650] = {.lex_state = 356},
  [651] = {.lex_state = 186},
  [652] = {.lex_state = 356},
  [653] = {.lex_state = 356},
  [654] = {.lex_state = 356},
  [655] = {.lex_state = 186},
  [656] = {.lex_state = 356},
  [657] = {.lex_state = 356},
  [658] = {.lex_state = 356},
  [659] = {.lex_state = 356},
  [660] = {.lex_state = 356},
  [661] = {.lex_state = 356},
  [662] = {.lex_state = 356},
  [663] = {.lex_state = 356},
  [664] = {.lex_state = 356},
  [665] = {.lex_state = 356},
  [666] = {.lex_state = 356},
  [667] = {.lex_state = 356},
  [668] = {.lex_state = 356},
  [669] = {.lex_state = 356},
  [670] = {.lex_state = 356},
  [671] = {.lex_state = 185},
  [672] = {.lex_state = 356},
  [673] = {.lex_state = 356},
  [674] = {.lex_state = 186},
  [675] = {.lex_state = 356},
  [676] = {.lex_state = 356},
  [677] = {.lex_state = 186},
  [678] = {.lex_state = 356},
  [679] = {.lex_state = 356},
  [680] = {.lex_state = 356},
  [681] = {.lex_state = 356},
  [682] = {.lex_state = 356},
  [683] = {.lex_state = 356},
  [684] = {.lex_state = 356},
  [685] = {.lex_state = 356},
  [686] = {.lex_state = 356},
  [687] = {.lex_state = 356},
  [688] = {.lex_state = 356},
  [689] = {.lex_state = 356},
  [690] = {.lex_state = 356},
  [691] = {.lex_state = 356},
  [692] = {.lex_state = 356},
  [693] = {.lex_state = 356},
  [694] = {.lex_state = 356},
  [695] = {.lex_state = 356},
  [696] = {.lex_state = 356},
  [697] = {.lex_state = 356},
  [698] = {.lex_state = 356},
  [699] = {.lex_state = 186},
  [700] = {.lex_state = 356},
  [701] = {.lex_state = 356},
  [702] = {.lex_state = 356},
  [703] = {.lex_state = 356},
  [704] = {.lex_state = 356},
  [705] = {.lex_state = 356},
  [706] = {.lex_state = 356},
  [707] = {.lex_state = 356},
  [708] = {.lex_state = 356},
  [709] = {.lex_state = 356},
  [710] = {.lex_state = 185},
  [711] = {.lex_state = 356},
  [712] = {.lex_state = 356},
  [713] = {.lex_state = 356},
  [714] = {.lex_state = 356},
  [715] = {.lex_state = 186},
  [716] = {.lex_state = 186},
  [717] = {.lex_state = 186},
  [718] = {.lex_state = 186},
  [719] = {.lex_state = 356},
  [720] = {.lex_state = 356},
  [721] = {.lex_state = 186},
  [722] = {.lex_state = 356},
  [723] = {.lex_state = 356},
  [724] = {.lex_state = 186},
  [725] = {.lex_state = 186},
  [726] = {.lex_state = 186},
  [727] = {.lex_state = 186},
  [728] = {.lex_state = 356},
  [729] = {.lex_state = 186},
  [730] = {.lex_state = 186},
  [731] = {.lex_state = 186},
  [732] = {.lex_state = 186},
  [733] = {.lex_state = 186},
  [734] = {.lex_state = 356},
  [735] = {.lex_state = 186},
  [736] = {.lex_state = 186},
  [737] = {.lex_state = 185},
  [738] = {.lex_state = 186},
  [739] = {.lex_state = 356},
  [740] = {.lex_state = 186},
  [741] = {.lex_state = 186},
  [742] = {.lex_state = 186},
  [743] = {.lex_state = 186},
  [744] = {.lex_state = 186},
  [745] = {.lex_state = 186},
  [746] = {.lex_state = 356},
  [747] = {.lex_state = 186},
  [748] = {.lex_state = 186},
  [749] = {.lex_state = 186},
  [750] = {.lex_state = 186},
  [751] = {.lex_state = 186},
  [752] = {.lex_state = 186},
  [753] = {.lex_state = 186},
  [754] = {.lex_state = 356},
  [755] = {.lex_state = 356},
  [756] = {.lex_state = 356},
  [757] = {.lex_state = 186},
  [758] = {.lex_state = 356},
  [759] = {.lex_state = 356},
  [760] = {.lex_state = 356},
  [761] = {.lex_state = 356},
  [762] = {.lex_state = 356},
  [763] = {.lex_state = 356},
  [764] = {.lex_state = 356},
  [765] = {.lex_state = 356},
  [766] = {.lex_state = 186},
  [767] = {.lex_state = 356},
  [768] = {.lex_state = 356},
  [769] = {.lex_state = 356},
  [770] = {.lex_state = 356},
  [771] = {.lex_state = 356},
  [772] = {.lex_state = 356},
  [773] = {.lex_state = 356},
  [774] = {.lex_state = 356},
  [775] = {.lex_state = 356},
  [776] = {.lex_state = 356},
  [777] = {.lex_state = 356},
  [778] = {.lex_state = 356},
  [779] = {.lex_state = 356},
  [780] = {.lex_state = 356},
  [781] = {.lex_state = 356},
  [782] = {.lex_state = 356},
  [783] = {.lex_state = 356},
  [784] = {.lex_state = 356},
  [785] = {.lex_state = 356},
  [786] = {.lex_state = 356},
  [787] = {.lex_state = 356},
  [788] = {.lex_state = 356},
  [789] = {.lex_state = 356},
  [790] = {.lex_state = 356},
  [791] = {.lex_state = 356},
  [792] = {.lex_state = 356},
  [793] = {.lex_state = 356},
  [794] = {.lex_state = 356},
  [795] = {.lex_state = 356},
  [796] = {.lex_state = 356},
  [797] = {.lex_state = 356},
  [798] = {.lex_state = 356},
  [799] = {.lex_state = 356},
  [800] = {.lex_state = 356},
  [801] = {.lex_state = 356},
  [802] = {.lex_state = 356},
  [803] = {.lex_state = 186},
  [804] = {.lex_state = 186},
  [805] = {.lex_state = 186},
  [806] = {.lex_state = 356},
  [807] = {.lex_state = 186},
  [808] = {.lex_state = 356},
  [809] = {.lex_state = 356},
  [810] = {.lex_state = 186},
  [811] = {.lex_state = 356},
  [812] = {.lex_state = 356},
  [813] = {.lex_state = 356},
  [814] = {.lex_state = 186},
  [815] = {.lex_state = 356},
  [816] = {.lex_state = 356},
  [817] = {.lex_state = 356},
  [818] = {.lex_state = 186},
  [819] = {.lex_state = 356},
  [820] = {.lex_state = 356},
  [821] = {.lex_state = 356},
  [822] = {.lex_state = 356},
  [823] = {.lex_state = 356},
  [824] = {.lex_state = 356},
  [825] = {.lex_state = 356},
  [826] = {.lex_state = 356},
  [827] = {.lex_state = 356},
  [828] = {.lex_state = 356},
  [829] = {.lex_state = 356},
  [830] = {.lex_state = 356},
  [831] = {.lex_state = 356},
  [832] = {.lex_state = 356},
  [833] = {.lex_state = 356},
  [834] = {.lex_state = 356},
  [835] = {.lex_state = 356},
  [836] = {.lex_state = 356},
  [837] = {.lex_state = 356},
  [838] = {.lex_state = 356},
  [839] = {.lex_state = 356},
  [840] = {.lex_state = 356},
  [841] = {.lex_state = 356},
  [842] = {.lex_state = 356},
  [843] = {.lex_state = 356},
  [844] = {.lex_state = 356},
  [845] = {.lex_state = 185},
  [846] = {.lex_state = 356},
  [847] = {.lex_state = 356},
  [848] = {.lex_state = 356},
  [849] = {.lex_state = 356},
  [850] = {.lex_state = 356},
  [851] = {.lex_state = 356},
  [852] = {.lex_state = 356},
  [853] = {.lex_state = 356},
  [854] = {.lex_state = 356},
  [855] = {.lex_state = 356},
  [856] = {.lex_state = 356},
  [857] = {.lex_state = 186},
  [858] = {.lex_state = 356},
  [859] = {.lex_state = 186},
  [860] = {.lex_state = 186},
  [861] = {.lex_state = 186},
  [862] = {.lex_state = 186},
  [863] = {.lex_state = 186},
  [864] = {.lex_state = 186},
  [865] = {.lex_state = 186},
  [866] = {.lex_state = 186},
  [867] = {.lex_state = 186},
  [868] = {.lex_state = 356},
  [869] = {.lex_state = 356},
  [870] = {.lex_state = 186},
  [871] = {.lex_state = 356},
  [872] = {.lex_state = 356},
  [873] = {.lex_state = 186},
  [874] = {.lex_state = 186},
  [875] = {.lex_state = 186},
  [876] = {.lex_state = 186},
  [877] = {.lex_state = 185},
  [878] = {.lex_state = 186},
  [879] = {.lex_state = 185},
  [880] = {.lex_state = 185},
  [881] = {.lex_state = 186},
  [882] = {.lex_state = 185},
  [883] = {.lex_state = 356},
  [884] = {.lex_state = 356},
  [885] = {.lex_state = 356},
  [886] = {.lex_state = 356},
  [887] = {.lex_state = 356},
  [888] = {.lex_state = 356},
  [889] = {.lex_state = 186},
  [890] = {.lex_state = 356},
  [891] = {.lex_state = 356},
  [892] = {.lex_state = 356},
  [893] = {.lex_state = 185},
  [894] = {.lex_state = 356},
  [895] = {.lex_state = 186},
  [896] = {.lex_state = 186},
  [897] = {.lex_state = 186},
  [898] = {.lex_state = 186},
  [899] = {.lex_state = 186},
  [900] = {.lex_state = 186},
  [901] = {.lex_state = 186},
  [902] = {.lex_state = 186},
  [903] = {.lex_state = 186},
  [904] = {.lex_state = 356},
  [905] = {.lex_state = 356},
  [906] = {.lex_state = 356},
  [907] = {.lex_state = 356},
  [908] = {.lex_state = 356},
  [909] = {.lex_state = 356},
  [910] = {.lex_state = 186},
  [911] = {.lex_state = 356},
  [912] = {.lex_state = 356},
  [913] = {.lex_state = 356},
  [914] = {.lex_state = 186},
  [915] = {.lex_state = 186},
  [916] = {.lex_state = 356},
  [917] = {.lex_state = 356},
  [918] = {.lex_state = 356},
  [919] = {.lex_state = 356},
  [920] = {.lex_state = 186},
  [921] = {.lex_state = 356},
  [922] = {.lex_state = 356},
  [923] = {.lex_state = 356},
  [924] = {.lex_state = 356},
  [925] = {.lex_state = 186},
  [926] = {.lex_state = 186},
  [927] = {.lex_state = 356},
  [928] = {.lex_state = 356},
  [929] = {.lex_state = 356},
  [930] = {.lex_state = 356},
  [931] = {.lex_state = 356},
  [932] = {.lex_state = 186},
  [933] = {.lex_state = 356},
  [934] = {.lex_state = 356},
  [935] = {.lex_state = 356},
  [936] = {.lex_state = 186},
  [937] = {.lex_state = 186},
  [938] = {.lex_state = 186},
  [939] = {.lex_state = 186},
  [940] = {.lex_state = 186},
  [941] = {.lex_state = 186},
  [942] = {.lex_state = 186},
  [943] = {.lex_state = 186},
  [944] = {.lex_state = 186},
  [945] = {.lex_state = 356},
  [946] = {.lex_state = 356},
  [947] = {.lex_state = 356},
  [948] = {.lex_state = 356},
  [949] = {.lex_state = 356},
  [950] = {.lex_state = 356},
  [951] = {.lex_state = 356},
  [952] = {.lex_state = 356},
  [953] = {.lex_state = 356},
  [954] = {.lex_state = 356},
  [955] = {.lex_state = 356},
  [956] = {.lex_state = 356},
  [957] = {.lex_state = 356},
  [958] = {.lex_state = 356},
  [959] = {.lex_state = 356},
  [960] = {.lex_state = 356},
  [961] = {.lex_state = 356},
  [962] = {.lex_state = 186},
  [963] = {.lex_state = 356},
  [964] = {.lex_state = 356},
  [965] = {.lex_state = 186},
  [966] = {.lex_state = 356},
  [967] = {.lex_state = 186},
  [968] = {.lex_state = 186},
  [969] = {.lex_state = 356},
  [970] = {.lex_state = 186},
  [971] = {.lex_state = 356},
  [972] = {.lex_state = 356},
  [973] = {.lex_state = 356},
  [974] = {.lex_state = 186},
  [975] = {.lex_state = 186},
  [976] = {.lex_state = 186},
  [977] = {.lex_state = 356},
  [978] = {.lex_state = 186},
  [979] = {.lex_state = 356},
  [980] = {.lex_state = 356},
  [981] = {.lex_state = 356},
  [982] = {.lex_state = 356},
  [983] = {.lex_state = 356},
  [984] = {.lex_state = 356},
  [985] = {.lex_state = 356},
  [986] = {.lex_state = 356},
  [987] = {.lex_state = 356},
  [988] = {.lex_state = 356},
  [989] = {.lex_state = 356},
  [990] = {.lex_state = 186},
  [991] = {.lex_state = 356},
  [992] = {.lex_state = 356},
  [993] = {.lex_state = 356},
  [994] = {.lex_state = 186},
  [995] = {.lex_state = 356},
  [996] = {.lex_state = 356},
  [997] = {.lex_state = 356},
  [998] = {.lex_state = 186},
  [999] = {.lex_state = 186},
  [1000] = {.lex_state = 186},
  [1001] = {.lex_state = 356},
  [1002] = {.lex_state = 186},
  [1003] = {.lex_state = 356},
  [1004] = {.lex_state = 356},
  [1005] = {.lex_state = 356},
  [1006] = {.lex_state = 356},
  [1007] = {.lex_state = 356},
  [1008] = {.lex_state = 356},
  [1009] = {.lex_state = 356},
  [1010] = {.lex_state = 356},
  [1011] = {.lex_state = 356},
  [1012] = {.lex_state = 356},
  [1013] = {.lex_state = 356},
  [1014] = {.lex_state = 356},
  [1015] = {.lex_state = 356},
  [1016] = {.lex_state = 356},
  [1017] = {.lex_state = 356},
  [1018] = {.lex_state = 186},
  [1019] = {.lex_state = 356},
  [1020] = {.lex_state = 356},
  [1021] = {.lex_state = 356},
  [1022] = {.lex_state = 356},
  [1023] = {.lex_state = 356},
  [1024] = {.lex_state = 356},
  [1025] = {.lex_state = 356},
  [1026] = {.lex_state = 356},
  [1027] = {.lex_state = 356},
  [1028] = {.lex_state = 356},
  [1029] = {.lex_state = 186},
  [1030] = {.lex_state = 356},
  [1031] = {.lex_state = 356},
  [1032] = {.lex_state = 356},
  [1033] = {.lex_state = 356},
  [1034] = {.lex_state = 356},
  [1035] = {.lex_state = 186},
  [1036] = {.lex_state = 186},
  [1037] = {.lex_state = 356},
  [1038] = {.lex_state = 356},
  [1039] = {.lex_state = 186},
  [1040] = {.lex_state = 356},
  [1041] = {.lex_state = 356},
  [1042] = {.lex_state = 356},
  [1043] = {.lex_state = 356},
  [1044] = {.lex_state = 356},
  [1045] = {.lex_state = 356},
  [1046] = {.lex_state = 356},
  [1047] = {.lex_state = 356},
  [1048] = {.lex_state = 356},
  [1049] = {.lex_state = 356},
  [1050] = {.lex_state = 356},
  [1051] = {.lex_state = 356},
  [1052] = {.lex_state = 356},
  [1053] = {.lex_state = 356},
  [1054] = {.lex_state = 356},
  [1055] = {.lex_state = 185},
  [1056] = {.lex_state = 356},
  [1057] = {.lex_state = 186},
  [1058] = {.lex_state = 356},
  [1059] = {.lex_state = 356},
  [1060] = {.lex_state = 356},
  [1061] = {.lex_state = 356},
  [1062] = {.lex_state = 356},
  [1063] = {.lex_state = 356},
  [1064] = {.lex_state = 356},
  [1065] = {.lex_state = 356},
  [1066] = {.lex_state = 356},
  [1067] = {.lex_state = 356},
  [1068] = {.lex_state = 356},
  [1069] = {.lex_state = 356},
  [1070] = {.lex_state = 356},
  [1071] = {.lex_state = 356},
  [1072] = {.lex_state = 356},
  [1073] = {.lex_state = 356},
  [1074] = {.lex_state = 356},
  [1075] = {.lex_state = 356},
  [1076] = {.lex_state = 186},
  [1077] = {.lex_state = 356},
  [1078] = {.lex_state = 356},
  [1079] = {.lex_state = 356},
  [1080] = {.lex_state = 356},
  [1081] = {.lex_state = 356},
  [1082] = {.lex_state = 356},
  [1083] = {.lex_state = 356},
  [1084] = {.lex_state = 356},
  [1085] = {.lex_state = 356},
  [1086] = {.lex_state = 356},
  [1087] = {.lex_state = 356},
  [1088] = {.lex_state = 186},
  [1089] = {.lex_state = 186},
  [1090] = {.lex_state = 186},
  [1091] = {.lex_state = 356},
  [1092] = {.lex_state = 186},
  [1093] = {.lex_state = 356},
  [1094] = {.lex_state = 356},
  [1095] = {.lex_state = 356},
  [1096] = {.lex_state = 356},
  [1097] = {.lex_state = 356},
  [1098] = {.lex_state = 356},
  [1099] = {.lex_state = 356},
  [1100] = {.lex_state = 356},
  [1101] = {.lex_state = 356},
  [1102] = {.lex_state = 356},
  [1103] = {.lex_state = 356},
  [1104] = {.lex_state = 356},
  [1105] = {.lex_state = 356},
  [1106] = {.lex_state = 356},
  [1107] = {.lex_state = 356},
  [1108] = {.lex_state = 356},
  [1109] = {.lex_state = 356},
  [1110] = {.lex_state = 356},
  [1111] = {.lex_state = 356},
  [1112] = {.lex_state = 356},
  [1113] = {.lex_state = 356},
  [1114] = {.lex_state = 356},
  [1115] = {.lex_state = 356},
  [1116] = {.lex_state = 356},
  [1117] = {.lex_state = 356},
  [1118] = {.lex_state = 186},
  [1119] = {.lex_state = 186},
  [1120] = {.lex_state = 356},
  [1121] = {.lex_state = 356},
  [1122] = {.lex_state = 186},
  [1123] = {.lex_state = 186},
  [1124] = {.lex_state = 186},
  [1125] = {.lex_state = 186},
  [1126] = {.lex_state = 186},
  [1127] = {.lex_state = 186},
  [1128] = {.lex_state = 186},
  [1129] = {.lex_state = 186},
  [1130] = {.lex_state = 186},
  [1131] = {.lex_state = 186},
  [1132] = {.lex_state = 186},
  [1133] = {.lex_state = 356},
  [1134] = {.lex_state = 356},
  [1135] = {.lex_state = 356},
  [1136] = {.lex_state = 186},
  [1137] = {.lex_state = 356},
  [1138] = {.lex_state = 186},
  [1139] = {.lex_state = 356},
  [1140] = {.lex_state = 186},
  [1141] = {.lex_state = 186},
  [1142] = {.lex_state = 186},
  [1143] = {.lex_state = 186},
  [1144] = {.lex_state = 186},
  [1145] = {.lex_state = 356},
  [1146] = {.lex_state = 186},
  [1147] = {.lex_state = 186},
  [1148] = {.lex_state = 186},
  [1149] = {.lex_state = 186},
  [1150] = {.lex_state = 186},
  [1151] = {.lex_state = 186},
  [1152] = {.lex_state = 356},
  [1153] = {.lex_state = 186},
  [1154] = {.lex_state = 186},
  [1155] = {.lex_state = 181},
  [1156] = {.lex_state = 181},
  [1157] = {.lex_state = 188},
  [1158] = {.lex_state = 188},
  [1159] = {.lex_state = 188},
  [1160] = {.lex_state = 188},
  [1161] = {.lex_state = 188},
  [1162] = {.lex_state = 188},
  [1163] = {.lex_state = 188},
  [1164] = {.lex_state = 188},
  [1165] = {.lex_state = 188},
  [1166] = {.lex_state = 188},
  [1167] = {.lex_state = 188},
  [1168] = {.lex_state = 188},
  [1169] = {.lex_state = 188},
  [1170] = {.lex_state = 188},
  [1171] = {.lex_state = 188},
  [1172] = {.lex_state = 188},
  [1173] = {.lex_state = 188},
  [1174] = {.lex_state = 188},
  [1175] = {.lex_state = 188},
  [1176] = {.lex_state = 188},
  [1177] = {.lex_state = 188},
  [1178] = {.lex_state = 188},
  [1179] = {.lex_state = 188},
  [1180] = {.lex_state = 188},
  [1181] = {.lex_state = 188},
  [1182] = {.lex_state = 188},
  [1183] = {.lex_state = 185},
  [1184] = {.lex_state = 252},
  [1185] = {.lex_state = 252},
  [1186] = {.lex_state = 185},
  [1187] = {.lex_state = 252},
  [1188] = {.lex_state = 185},
  [1189] = {.lex_state = 185},
  [1190] = {.lex_state = 185},
  [1191] = {.lex_state = 252},
  [1192] = {.lex_state = 252},
  [1193] = {.lex_state = 252},
  [1194] = {.lex_state = 356},
  [1195] = {.lex_state = 185},
  [1196] = {.lex_state = 185},
  [1197] = {.lex_state = 252},
  [1198] = {.lex_state = 185},
  [1199] = {.lex_state = 356},
  [1200] = {.lex_state = 185},
  [1201] = {.lex_state = 185},
  [1202] = {.lex_state = 185},
  [1203] = {.lex_state = 185},
  [1204] = {.lex_state = 185},
  [1205] = {.lex_state = 185},
  [1206] = {.lex_state = 185},
  [1207] = {.lex_state = 185},
  [1208] = {.lex_state = 185},
  [1209] = {.lex_state = 185},
  [1210] = {.lex_state = 185},
  [1211] = {.lex_state = 185},
  [1212] = {.lex_state = 185},
  [1213] = {.lex_state = 185},
  [1214] = {.lex_state = 185},
  [1215] = {.lex_state = 185},
  [1216] = {.lex_state = 185},
  [1217] = {.lex_state = 185},
  [1218] = {.lex_state = 185},
  [1219] = {.lex_state = 185},
  [1220] = {.lex_state = 185},
  [1221] = {.lex_state = 185},
  [1222] = {.lex_state = 185},
  [1223] = {.lex_state = 185},
  [1224] = {.lex_state = 185},
  [1225] = {.lex_state = 185},
  [1226] = {.lex_state = 185},
  [1227] = {.lex_state = 185},
  [1228] = {.lex_state = 176},
  [1229] = {.lex_state = 185},
  [1230] = {.lex_state = 185},
  [1231] = {.lex_state = 185},
  [1232] = {.lex_state = 185},
  [1233] = {.lex_state = 185},
  [1234] = {.lex_state = 185},
  [1235] = {.lex_state = 185},
  [1236] = {.lex_state = 185},
  [1237] = {.lex_state = 185},
  [1238] = {.lex_state = 185},
  [1239] = {.lex_state = 185},
  [1240] = {.lex_state = 185},
  [1241] = {.lex_state = 185},
  [1242] = {.lex_state = 185},
  [1243] = {.lex_state = 185},
  [1244] = {.lex_state = 185},
  [1245] = {.lex_state = 185},
  [1246] = {.lex_state = 185},
  [1247] = {.lex_state = 185},
  [1248] = {.lex_state = 185},
  [1249] = {.lex_state = 185},
  [1250] = {.lex_state = 185},
  [1251] = {.lex_state = 185},
  [1252] = {.lex_state = 185},
  [1253] = {.lex_state = 185},
  [1254] = {.lex_state = 185},
  [1255] = {.lex_state = 185},
  [1256] = {.lex_state = 185},
  [1257] = {.lex_state = 185},
  [1258] = {.lex_state = 185},
  [1259] = {.lex_state = 185},
  [1260] = {.lex_state = 185},
  [1261] = {.lex_state = 185},
  [1262] = {.lex_state = 176},
  [1263] = {.lex_state = 252},
  [1264] = {.lex_state = 252},
  [1265] = {.lex_state = 252},
  [1266] = {.lex_state = 252},
  [1267] = {.lex_state = 252},
  [1268] = {.lex_state = 252},
  [1269] = {.lex_state = 252},
  [1270] = {.lex_state = 185},
  [1271] = {.lex_state = 176},
  [1272] = {.lex_state = 185},
  [1273] = {.lex_state = 185},
  [1274] = {.lex_state = 178},
  [1275] = {.lex_state = 185},
  [1276] = {.lex_state = 356},
  [1277] = {.lex_state = 188},
  [1278] = {.lex_state = 188},
  [1279] = {.lex_state = 188},
  [1280] = {.lex_state = 176},
  [1281] = {.lex_state = 188},
  [1282] = {.lex_state = 188},
  [1283] = {.lex_state = 188},
  [1284] = {.lex_state = 188},
  [1285] = {.lex_state = 188},
  [1286] = {.lex_state = 188},
  [1287] = {.lex_state = 188},
  [1288] = {.lex_state = 188},
  [1289] = {.lex_state = 188},
  [1290] = {.lex_state = 188},
  [1291] = {.lex_state = 188},
  [1292] = {.lex_state = 188},
  [1293] = {.lex_state = 188},
  [1294] = {.lex_state = 188},
  [1295] = {.lex_state = 188},
  [1296] = {.lex_state = 188},
  [1297] = {.lex_state = 188},
  [1298] = {.lex_state = 188},
  [1299] = {.lex_state = 188},
  [1300] = {.lex_state = 188},
  [1301] = {.lex_state = 188},
  [1302] = {.lex_state = 188},
  [1303] = {.lex_state = 179},
  [1304] = {.lex_state = 188},
  [1305] = {.lex_state = 185},
  [1306] = {.lex_state = 185},
  [1307] = {.lex_state = 185},
  [1308] = {.lex_state = 185},
  [1309] = {.lex_state = 185},
  [1310] = {.lex_state = 185},
  [1311] = {.lex_state = 185},
  [1312] = {.lex_state = 185},
  [1313] = {.lex_state = 185},
  [1314] = {.lex_state = 185},
  [1315] = {.lex_state = 185},
  [1316] = {.lex_state = 185},
  [1317] = {.lex_state = 185},
  [1318] = {.lex_state = 185},
  [1319] = {.lex_state = 185},
  [1320] = {.lex_state = 185},
  [1321] = {.lex_state = 185},
  [1322] = {.lex_state = 185},
  [1323] = {.lex_state = 185},
  [1324] = {.lex_state = 185},
  [1325] = {.lex_state = 185},
  [1326] = {.lex_state = 185},
  [1327] = {.lex_state = 188},
  [1328] = {.lex_state = 185},
  [1329] = {.lex_state = 188},
  [1330] = {.lex_state = 188},
  [1331] = {.lex_state = 178},
  [1332] = {.lex_state = 188},
  [1333] = {.lex_state = 188},
  [1334] = {.lex_state = 188},
  [1335] = {.lex_state = 188},
  [1336] = {.lex_state = 188},
  [1337] = {.lex_state = 188},
  [1338] = {.lex_state = 188},
  [1339] = {.lex_state = 188},
  [1340] = {.lex_state = 188},
  [1341] = {.lex_state = 188},
  [1342] = {.lex_state = 188},
  [1343] = {.lex_state = 188},
  [1344] = {.lex_state = 188},
  [1345] = {.lex_state = 188},
  [1346] = {.lex_state = 188},
  [1347] = {.lex_state = 185},
  [1348] = {.lex_state = 185},
  [1349] = {.lex_state = 185},
  [1350] = {.lex_state = 185},
  [1351] = {.lex_state = 185},
  [1352] = {.lex_state = 200},
  [1353] = {.lex_state = 185},
  [1354] = {.lex_state = 185},
  [1355] = {.lex_state = 185},
  [1356] = {.lex_state = 185},
  [1357] = {.lex_state = 200},
  [1358] = {.lex_state = 185},
  [1359] = {.lex_state = 185},
  [1360] = {.lex_state = 185},
  [1361] = {.lex_state = 185},
  [1362] = {.lex_state = 185},
  [1363] = {.lex_state = 185},
  [1364] = {.lex_state = 185},
  [1365] = {.lex_state = 185},
  [1366] = {.lex_state = 185},
  [1367] = {.lex_state = 185},
  [1368] = {.lex_state = 185},
  [1369] = {.lex_state = 185},
  [1370] = {.lex_state = 185},
  [1371] = {.lex_state = 185},
  [1372] = {.lex_state = 185},
  [1373] = {.lex_state = 185},
  [1374] = {.lex_state = 185},
  [1375] = {.lex_state = 200},
  [1376] = {.lex_state = 185},
  [1377] = {.lex_state = 185},
  [1378] = {.lex_state = 185},
  [1379] = {.lex_state = 185},
  [1380] = {.lex_state = 185},
  [1381] = {.lex_state = 185},
  [1382] = {.lex_state = 185},
  [1383] = {.lex_state = 185},
  [1384] = {.lex_state = 185},
  [1385] = {.lex_state = 185},
  [1386] = {.lex_state = 185},
  [1387] = {.lex_state = 185},
  [1388] = {.lex_state = 185},
  [1389] = {.lex_state = 185},
  [1390] = {.lex_state = 200},
  [1391] = {.lex_state = 185},
  [1392] = {.lex_state = 185},
  [1393] = {.lex_state = 185},
  [1394] = {.lex_state = 185},
  [1395] = {.lex_state = 185},
  [1396] = {.lex_state = 185},
  [1397] = {.lex_state = 185},
  [1398] = {.lex_state = 185},
  [1399] = {.lex_state = 185},
  [1400] = {.lex_state = 185},
  [1401] = {.lex_state = 200},
  [1402] = {.lex_state = 185},
  [1403] = {.lex_state = 185},
  [1404] = {.lex_state = 185},
  [1405] = {.lex_state = 185},
  [1406] = {.lex_state = 185},
  [1407] = {.lex_state = 185},
  [1408] = {.lex_state = 185},
  [1409] = {.lex_state = 185},
  [1410] = {.lex_state = 185},
  [1411] = {.lex_state = 185},
  [1412] = {.lex_state = 185},
  [1413] = {.lex_state = 185},
  [1414] = {.lex_state = 185},
  [1415] = {.lex_state = 185},
  [1416] = {.lex_state = 185},
  [1417] = {.lex_state = 252},
  [1418] = {.lex_state = 187},
  [1419] = {.lex_state = 187},
  [1420] = {.lex_state = 200},
  [1421] = {.lex_state = 196},
  [1422] = {.lex_state = 200},
  [1423] = {.lex_state = 200},
  [1424] = {.lex_state = 200},
  [1425] = {.lex_state = 177},
  [1426] = {.lex_state = 200},
  [1427] = {.lex_state = 200},
  [1428] = {.lex_state = 200},
  [1429] = {.lex_state = 177},
  [1430] = {.lex_state = 177},
  [1431] = {.lex_state = 177},
  [1432] = {.lex_state = 177},
  [1433] = {.lex_state = 180},
  [1434] = {.lex_state = 177},
  [1435] = {.lex_state = 188},
  [1436] = {.lex_state = 188},
  [1437] = {.lex_state = 188},
  [1438] = {.lex_state = 252},
  [1439] = {.lex_state = 252},
  [1440] = {.lex_state = 207},
  [1441] = {.lex_state = 207},
  [1442] = {.lex_state = 207},
  [1443] = {.lex_state = 207},
  [1444] = {.lex_state = 207},
  [1445] = {.lex_state = 207},
  [1446] = {.lex_state = 207},
  [1447] = {.lex_state = 207},
  [1448] = {.lex_state = 207},
  [1449] = {.lex_state = 207},
  [1450] = {.lex_state = 207},
  [1451] = {.lex_state = 207},
  [1452] = {.lex_state = 207},
  [1453] = {.lex_state = 207},
  [1454] = {.lex_state = 207},
  [1455] = {.lex_state = 207},
  [1456] = {.lex_state = 207},
  [1457] = {.lex_state = 252},
  [1458] = {.lex_state = 252},
  [1459] = {.lex_state = 252},
  [1460] = {.lex_state = 252},
  [1461] = {.lex_state = 185},
  [1462] = {.lex_state = 185},
  [1463] = {.lex_state = 185},
  [1464] = {.lex_state = 189},
  [1465] = {.lex_state = 189},
  [1466] = {.lex_state = 189},
  [1467] = {.lex_state = 189},
  [1468] = {.lex_state = 189},
  [1469] = {.lex_state = 206},
  [1470] = {.lex_state = 189},
  [1471] = {.lex_state = 189},
  [1472] = {.lex_state = 189},
  [1473] = {.lex_state = 189},
  [1474] = {.lex_state = 189},
  [1475] = {.lex_state = 189},
  [1476] = {.lex_state = 189},
  [1477] = {.lex_state = 207},
  [1478] = {.lex_state = 189},
  [1479] = {.lex_state = 189},
  [1480] = {.lex_state = 189},
  [1481] = {.lex_state = 189},
  [1482] = {.lex_state = 189},
  [1483] = {.lex_state = 189},
  [1484] = {.lex_state = 189},
  [1485] = {.lex_state = 189},
  [1486] = {.lex_state = 189},
  [1487] = {.lex_state = 189},
  [1488] = {.lex_state = 189},
  [1489] = {.lex_state = 189},
  [1490] = {.lex_state = 189},
  [1491] = {.lex_state = 189},
  [1492] = {.lex_state = 206},
  [1493] = {.lex_state = 188},
  [1494] = {.lex_state = 207},
  [1495] = {.lex_state = 206},
  [1496] = {.lex_state = 206},
  [1497] = {.lex_state = 188},
  [1498] = {.lex_state = 206},
  [1499] = {.lex_state = 206},
  [1500] = {.lex_state = 188},
  [1501] = {.lex_state = 188},
  [1502] = {.lex_state = 188},
  [1503] = {.lex_state = 206},
  [1504] = {.lex_state = 206},
  [1505] = {.lex_state = 206},
  [1506] = {.lex_state = 206},
  [1507] = {.lex_state = 188},
  [1508] = {.lex_state = 206},
  [1509] = {.lex_state = 188},
  [1510] = {.lex_state = 188},
  [1511] = {.lex_state = 188},
  [1512] = {.lex_state = 206},
  [1513] = {.lex_state = 206},
  [1514] = {.lex_state = 206},
  [1515] = {.lex_state = 188},
  [1516] = {.lex_state = 206},
  [1517] = {.lex_state = 206},
  [1518] = {.lex_state = 188},
  [1519] = {.lex_state = 188},
  [1520] = {.lex_state = 188},
  [1521] = {.lex_state = 188},
  [1522] = {.lex_state = 188},
  [1523] = {.lex_state = 188},
  [1524] = {.lex_state = 188},
  [1525] = {.lex_state = 188},
  [1526] = {.lex_state = 188},
  [1527] = {.lex_state = 188},
  [1528] = {.lex_state = 206},
  [1529] = {.lex_state = 188},
  [1530] = {.lex_state = 187},
  [1531] = {.lex_state = 187},
  [1532] = {.lex_state = 206},
  [1533] = {.lex_state = 206},
  [1534] = {.lex_state = 206},
  [1535] = {.lex_state = 206},
  [1536] = {.lex_state = 206},
  [1537] = {.lex_state = 206},
  [1538] = {.lex_state = 206},
  [1539] = {.lex_state = 206},
  [1540] = {.lex_state = 206},
  [1541] = {.lex_state = 206},
  [1542] = {.lex_state = 206},
  [1543] = {.lex_state = 206},
  [1544] = {.lex_state = 206},
  [1545] = {.lex_state = 206},
  [1546] = {.lex_state = 206},
  [1547] = {.lex_state = 206},
  [1548] = {.lex_state = 188},
  [1549] = {.lex_state = 237},
  [1550] = {.lex_state = 237},
  [1551] = {.lex_state = 237},
  [1552] = {.lex_state = 237},
  [1553] = {.lex_state = 237},
  [1554] = {.lex_state = 187},
  [1555] = {.lex_state = 237},
  [1556] = {.lex_state = 237},
  [1557] = {.lex_state = 237},
  [1558] = {.lex_state = 237},
  [1559] = {.lex_state = 237},
  [1560] = {.lex_state = 237},
  [1561] = {.lex_state = 237},
  [1562] = {.lex_state = 237},
  [1563] = {.lex_state = 237},
  [1564] = {.lex_state = 237},
  [1565] = {.lex_state = 187},
  [1566] = {.lex_state = 252},
  [1567] = {.lex_state = 252},
  [1568] = {.lex_state = 252},
  [1569] = {.lex_state = 252},
  [1570] = {.lex_state = 252},
  [1571] = {.lex_state = 252},
  [1572] = {.lex_state = 252},
  [1573] = {.lex_state = 252},
  [1574] = {.lex_state = 252},
  [1575] = {.lex_state = 252},
  [1576] = {.lex_state = 252},
  [1577] = {.lex_state = 252},
  [1578] = {.lex_state = 252},
  [1579] = {.lex_state = 252},
  [1580] = {.lex_state = 252},
  [1581] = {.lex_state = 252},
  [1582] = {.lex_state = 252},
  [1583] = {.lex_state = 252},
  [1584] = {.lex_state = 188},
  [1585] = {.lex_state = 188},
  [1586] = {.lex_state = 188},
  [1587] = {.lex_state = 188},
  [1588] = {.lex_state = 188},
  [1589] = {.lex_state = 188},
  [1590] = {.lex_state = 188},
  [1591] = {.lex_state = 188},
  [1592] = {.lex_state = 188},
  [1593] = {.lex_state = 188},
  [1594] = {.lex_state = 188},
  [1595] = {.lex_state = 188},
  [1596] = {.lex_state = 188},
  [1597] = {.lex_state = 188},
  [1598] = {.lex_state = 188},
  [1599] = {.lex_state = 188},
  [1600] = {.lex_state = 188},
  [1601] = {.lex_state = 188},
  [1602] = {.lex_state = 188},
  [1603] = {.lex_state = 188},
  [1604] = {.lex_state = 188},
  [1605] = {.lex_state = 237},
  [1606] = {.lex_state = 188},
  [1607] = {.lex_state = 188},
  [1608] = {.lex_state = 188},
  [1609] = {.lex_state = 188},
  [1610] = {.lex_state = 188},
  [1611] = {.lex_state = 252},
  [1612] = {.lex_state = 188},
  [1613] = {.lex_state = 188},
  [1614] = {.lex_state = 188},
  [1615] = {.lex_state = 188},
  [1616] = {.lex_state = 252},
  [1617] = {.lex_state = 188},
  [1618] = {.lex_state = 252},
  [1619] = {.lex_state = 188},
  [1620] = {.lex_state = 188},
  [1621] = {.lex_state = 188},
  [1622] = {.lex_state = 188},
  [1623] = {.lex_state = 188},
  [1624] = {.lex_state = 188},
  [1625] = {.lex_state = 188},
  [1626] = {.lex_state = 252},
  [1627] = {.lex_state = 188},
  [1628] = {.lex_state = 250},
  [1629] = {.lex_state = 188},
  [1630] = {.lex_state = 188},
  [1631] = {.lex_state = 252},
  [1632] = {.lex_state = 188},
  [1633] = {.lex_state = 188},
  [1634] = {.lex_state = 250},
  [1635] = {.lex_state = 252},
  [1636] = {.lex_state = 252},
  [1637] = {.lex_state = 252},
  [1638] = {.lex_state = 252},
  [1639] = {.lex_state = 252},
  [1640] = {.lex_state = 252},
  [1641] = {.lex_state = 252},
  [1642] = {.lex_state = 252},
  [1643] = {.lex_state = 252},
  [1644] = {.lex_state = 252},
  [1645] = {.lex_state = 252},
  [1646] = {.lex_state = 252},
  [1647] = {.lex_state = 252},
  [1648] = {.lex_state = 252},
  [1649] = {.lex_state = 252},
  [1650] = {.lex_state = 252},
  [1651] = {.lex_state = 252},
  [1652] = {.lex_state = 237},
  [1653] = {.lex_state = 252},
  [1654] = {.lex_state = 252},
  [1655] = {.lex_state = 252},
  [1656] = {.lex_state = 252},
  [1657] = {.lex_state = 252},
  [1658] = {.lex_state = 188},
  [1659] = {.lex_state = 252},
  [1660] = {.lex_state = 188},
  [1661] = {.lex_state = 252},
  [1662] = {.lex_state = 252},
  [1663] = {.lex_state = 252},
  [1664] = {.lex_state = 188},
  [1665] = {.lex_state = 252},
  [1666] = {.lex_state = 252},
  [1667] = {.lex_state = 252},
  [1668] = {.lex_state = 252},
  [1669] = {.lex_state = 252},
  [1670] = {.lex_state = 252},
  [1671] = {.lex_state = 252},
  [1672] = {.lex_state = 252},
  [1673] = {.lex_state = 252},
  [1674] = {.lex_state = 252},
  [1675] = {.lex_state = 252},
  [1676] = {.lex_state = 252},
  [1677] = {.lex_state = 252},
  [1678] = {.lex_state = 252},
  [1679] = {.lex_state = 252},
  [1680] = {.lex_state = 188},
  [1681] = {.lex_state = 252},
  [1682] = {.lex_state = 252},
  [1683] = {.lex_state = 252},
  [1684] = {.lex_state = 188},
  [1685] = {.lex_state = 252},
  [1686] = {.lex_state = 188},
  [1687] = {.lex_state = 252},
  [1688] = {.lex_state = 252},
  [1689] = {.lex_state = 252},
  [1690] = {.lex_state = 252},
  [1691] = {.lex_state = 188},
  [1692] = {.lex_state = 252},
  [1693] = {.lex_state = 252},
  [1694] = {.lex_state = 252},
  [1695] = {.lex_state = 252},
  [1696] = {.lex_state = 252},
  [1697] = {.lex_state = 252},
  [1698] = {.lex_state = 252},
  [1699] = {.lex_state = 252},
  [1700] = {.lex_state = 252},
  [1701] = {.lex_state = 252},
  [1702] = {.lex_state = 252},
  [1703] = {.lex_state = 252},
  [1704] = {.lex_state = 252},
  [1705] = {.lex_state = 188},
  [1706] = {.lex_state = 252},
  [1707] = {.lex_state = 188},
  [1708] = {.lex_state = 252},
  [1709] = {.lex_state = 252},
  [1710] = {.lex_state = 252},
  [1711] = {.lex_state = 252},
  [1712] = {.lex_state = 252},
  [1713] = {.lex_state = 252},
  [1714] = {.lex_state = 252},
  [1715] = {.lex_state = 252},
  [1716] = {.lex_state = 188},
  [1717] = {.lex_state = 252},
  [1718] = {.lex_state = 252},
  [1719] = {.lex_state = 252},
  [1720] = {.lex_state = 252},
  [1721] = {.lex_state = 252},
  [1722] = {.lex_state = 252},
  [1723] = {.lex_state = 252},
  [1724] = {.lex_state = 252},
  [1725] = {.lex_state = 252},
  [1726] = {.lex_state = 252},
  [1727] = {.lex_state = 188},
  [1728] = {.lex_state = 252},
  [1729] = {.lex_state = 252},
  [1730] = {.lex_state = 252},
  [1731] = {.lex_state = 252},
  [1732] = {.lex_state = 252},
  [1733] = {.lex_state = 252},
  [1734] = {.lex_state = 252},
  [1735] = {.lex_state = 252},
  [1736] = {.lex_state = 252},
  [1737] = {.lex_state = 252},
  [1738] = {.lex_state = 252},
  [1739] = {.lex_state = 252},
  [1740] = {.lex_state = 252},
  [1741] = {.lex_state = 252},
  [1742] = {.lex_state = 188},
  [1743] = {.lex_state = 252},
  [1744] = {.lex_state = 252},
  [1745] = {.lex_state = 252},
  [1746] = {.lex_state = 252},
  [1747] = {.lex_state = 252},
  [1748] = {.lex_state = 188},
  [1749] = {.lex_state = 252},
  [1750] = {.lex_state = 252},
  [1751] = {.lex_state = 188},
  [1752] = {.lex_state = 252},
  [1753] = {.lex_state = 252},
  [1754] = {.lex_state = 188},
  [1755] = {.lex_state = 252},
  [1756] = {.lex_state = 188},
  [1757] = {.lex_state = 252},
  [1758] = {.lex_state = 252},
  [1759] = {.lex_state = 252},
  [1760] = {.lex_state = 252},
  [1761] = {.lex_state = 252},
  [1762] = {.lex_state = 252},
  [1763] = {.lex_state = 252},
  [1764] = {.lex_state = 252},
  [1765] = {.lex_state = 252},
  [1766] = {.lex_state = 252},
  [1767] = {.lex_state = 252},
  [1768] = {.lex_state = 252},
  [1769] = {.lex_state = 252},
  [1770] = {.lex_state = 252},
  [1771] = {.lex_state = 252},
  [1772] = {.lex_state = 252},
  [1773] = {.lex_state = 252},
  [1774] = {.lex_state = 252},
  [1775] = {.lex_state = 252},
  [1776] = {.lex_state = 252},
  [1777] = {.lex_state = 252},
  [1778] = {.lex_state = 252},
  [1779] = {.lex_state = 188},
  [1780] = {.lex_state = 188},
  [1781] = {.lex_state = 252},
  [1782] = {.lex_state = 252},
  [1783] = {.lex_state = 188},
  [1784] = {.lex_state = 188},
  [1785] = {.lex_state = 252},
  [1786] = {.lex_state = 188},
  [1787] = {.lex_state = 188},
  [1788] = {.lex_state = 188},
  [1789] = {.lex_state = 188},
  [1790] = {.lex_state = 188},
  [1791] = {.lex_state = 252},
  [1792] = {.lex_state = 188},
  [1793] = {.lex_state = 252},
  [1794] = {.lex_state = 252},
  [1795] = {.lex_state = 252},
  [1796] = {.lex_state = 252},
  [1797] = {.lex_state = 252},
  [1798] = {.lex_state = 252},
  [1799] = {.lex_state = 252},
  [1800] = {.lex_state = 252},
  [1801] = {.lex_state = 252},
  [1802] = {.lex_state = 252},
  [1803] = {.lex_state = 252},
  [1804] = {.lex_state = 252},
  [1805] = {.lex_state = 252},
  [1806] = {.lex_state = 252},
  [1807] = {.lex_state = 252},
  [1808] = {.lex_state = 252},
  [1809] = {.lex_state = 252},
  [1810] = {.lex_state = 252},
  [1811] = {.lex_state = 252},
  [1812] = {.lex_state = 252},
  [1813] = {.lex_state = 252},
  [1814] = {.lex_state = 188},
  [1815] = {.lex_state = 250},
  [1816] = {.lex_state = 252},
  [1817] = {.lex_state = 250},
  [1818] = {.lex_state = 220},
  [1819] = {.lex_state = 220},
  [1820] = {.lex_state = 188},
  [1821] = {.lex_state = 220},
  [1822] = {.lex_state = 188},
  [1823] = {.lex_state = 188},
  [1824] = {.lex_state = 188},
  [1825] = {.lex_state = 188},
  [1826] = {.lex_state = 188},
  [1827] = {.lex_state = 188},
  [1828] = {.lex_state = 250},
  [1829] = {.lex_state = 220},
  [1830] = {.lex_state = 188},
  [1831] = {.lex_state = 188},
  [1832] = {.lex_state = 188},
  [1833] = {.lex_state = 188},
  [1834] = {.lex_state = 188},
  [1835] = {.lex_state = 188},
  [1836] = {.lex_state = 250},
  [1837] = {.lex_state = 188},
  [1838] = {.lex_state = 188},
  [1839] = {.lex_state = 188},
  [1840] = {.lex_state = 188},
  [1841] = {.lex_state = 188},
  [1842] = {.lex_state = 188},
  [1843] = {.lex_state = 188},
  [1844] = {.lex_state = 188},
  [1845] = {.lex_state = 188},
  [1846] = {.lex_state = 188},
  [1847] = {.lex_state = 188},
  [1848] = {.lex_state = 188},
  [1849] = {.lex_state = 188},
  [1850] = {.lex_state = 188},
  [1851] = {.lex_state = 188},
  [1852] = {.lex_state = 188},
  [1853] = {.lex_state = 188},
  [1854] = {.lex_state = 188},
  [1855] = {.lex_state = 188},
  [1856] = {.lex_state = 188},
  [1857] = {.lex_state = 188},
  [1858] = {.lex_state = 188},
  [1859] = {.lex_state = 188},
  [1860] = {.lex_state = 188},
  [1861] = {.lex_state = 188},
  [1862] = {.lex_state = 188},
  [1863] = {.lex_state = 188},
  [1864] = {.lex_state = 188},
  [1865] = {.lex_state = 188},
  [1866] = {.lex_state = 188},
  [1867] = {.lex_state = 188},
  [1868] = {.lex_state = 188},
  [1869] = {.lex_state = 188},
  [1870] = {.lex_state = 188},
  [1871] = {.lex_state = 188},
  [1872] = {.lex_state = 188},
  [1873] = {.lex_state = 188},
  [1874] = {.lex_state = 188},
  [1875] = {.lex_state = 188},
  [1876] = {.lex_state = 188},
  [1877] = {.lex_state = 188},
  [1878] = {.lex_state = 188},
  [1879] = {.lex_state = 188},
  [1880] = {.lex_state = 188},
  [1881] = {.lex_state = 188},
  [1882] = {.lex_state = 188},
  [1883] = {.lex_state = 188},
  [1884] = {.lex_state = 188},
  [1885] = {.lex_state = 188},
  [1886] = {.lex_state = 188},
  [1887] = {.lex_state = 188},
  [1888] = {.lex_state = 188},
  [1889] = {.lex_state = 188},
  [1890] = {.lex_state = 188},
  [1891] = {.lex_state = 188},
  [1892] = {.lex_state = 188},
  [1893] = {.lex_state = 188},
  [1894] = {.lex_state = 188},
  [1895] = {.lex_state = 188},
  [1896] = {.lex_state = 188},
  [1897] = {.lex_state = 188},
  [1898] = {.lex_state = 188},
  [1899] = {.lex_state = 188},
  [1900] = {.lex_state = 188},
  [1901] = {.lex_state = 188},
  [1902] = {.lex_state = 188},
  [1903] = {.lex_state = 188},
  [1904] = {.lex_state = 188},
  [1905] = {.lex_state = 188},
  [1906] = {.lex_state = 188},
  [1907] = {.lex_state = 188},
  [1908] = {.lex_state = 188},
  [1909] = {.lex_state = 188},
  [1910] = {.lex_state = 188},
  [1911] = {.lex_state = 188},
  [1912] = {.lex_state = 188},
  [1913] = {.lex_state = 188},
  [1914] = {.lex_state = 188},
  [1915] = {.lex_state = 188},
  [1916] = {.lex_state = 188},
  [1917] = {.lex_state = 188},
  [1918] = {.lex_state = 188},
  [1919] = {.lex_state = 188},
  [1920] = {.lex_state = 188},
  [1921] = {.lex_state = 188},
  [1922] = {.lex_state = 188},
  [1923] = {.lex_state = 188},
  [1924] = {.lex_state = 188},
  [1925] = {.lex_state = 188},
  [1926] = {.lex_state = 188},
  [1927] = {.lex_state = 188},
  [1928] = {.lex_state = 188},
  [1929] = {.lex_state = 188},
  [1930] = {.lex_state = 188},
  [1931] = {.lex_state = 188},
  [1932] = {.lex_state = 188},
  [1933] = {.lex_state = 188},
  [1934] = {.lex_state = 188},
  [1935] = {.lex_state = 188},
  [1936] = {.lex_state = 188},
  [1937] = {.lex_state = 188},
  [1938] = {.lex_state = 188},
  [1939] = {.lex_state = 188},
  [1940] = {.lex_state = 188},
  [1941] = {.lex_state = 188},
  [1942] = {.lex_state = 188},
  [1943] = {.lex_state = 188},
  [1944] = {.lex_state = 220},
  [1945] = {.lex_state = 188},
  [1946] = {.lex_state = 188},
  [1947] = {.lex_state = 188},
  [1948] = {.lex_state = 188},
  [1949] = {.lex_state = 188},
  [1950] = {.lex_state = 188},
  [1951] = {.lex_state = 250},
  [1952] = {.lex_state = 188},
  [1953] = {.lex_state = 188},
  [1954] = {.lex_state = 188},
  [1955] = {.lex_state = 188},
  [1956] = {.lex_state = 188},
  [1957] = {.lex_state = 188},
  [1958] = {.lex_state = 188},
  [1959] = {.lex_state = 188},
  [1960] = {.lex_state = 188},
  [1961] = {.lex_state = 188},
  [1962] = {.lex_state = 188},
  [1963] = {.lex_state = 188},
  [1964] = {.lex_state = 188},
  [1965] = {.lex_state = 188},
  [1966] = {.lex_state = 188},
  [1967] = {.lex_state = 220},
  [1968] = {.lex_state = 188},
  [1969] = {.lex_state = 188},
  [1970] = {.lex_state = 188},
  [1971] = {.lex_state = 188},
  [1972] = {.lex_state = 188},
  [1973] = {.lex_state = 188},
  [1974] = {.lex_state = 188},
  [1975] = {.lex_state = 188},
  [1976] = {.lex_state = 188},
  [1977] = {.lex_state = 188},
  [1978] = {.lex_state = 250},
  [1979] = {.lex_state = 188},
  [1980] = {.lex_state = 188},
  [1981] = {.lex_state = 188},
  [1982] = {.lex_state = 188},
  [1983] = {.lex_state = 188},
  [1984] = {.lex_state = 220},
  [1985] = {.lex_state = 188},
  [1986] = {.lex_state = 188},
  [1987] = {.lex_state = 188},
  [1988] = {.lex_state = 188},
  [1989] = {.lex_state = 188},
  [1990] = {.lex_state = 220},
  [1991] = {.lex_state = 188},
  [1992] = {.lex_state = 188},
  [1993] = {.lex_state = 188},
  [1994] = {.lex_state = 250},
  [1995] = {.lex_state = 188},
  [1996] = {.lex_state = 188},
  [1997] = {.lex_state = 220},
  [1998] = {.lex_state = 188},
  [1999] = {.lex_state = 220},
  [2000] = {.lex_state = 220},
  [2001] = {.lex_state = 220},
  [2002] = {.lex_state = 220},
  [2003] = {.lex_state = 220},
  [2004] = {.lex_state = 220},
  [2005] = {.lex_state = 220},
  [2006] = {.lex_state = 220},
  [2007] = {.lex_state = 220},
  [2008] = {.lex_state = 188},
  [2009] = {.lex_state = 188},
  [2010] = {.lex_state = 188},
  [2011] = {.lex_state = 188},
  [2012] = {.lex_state = 188},
  [2013] = {.lex_state = 188},
  [2014] = {.lex_state = 188},
  [2015] = {.lex_state = 188},
  [2016] = {.lex_state = 188},
  [2017] = {.lex_state = 220},
  [2018] = {.lex_state = 220},
  [2019] = {.lex_state = 220},
  [2020] = {.lex_state = 220},
  [2021] = {.lex_state = 220},
  [2022] = {.lex_state = 220},
  [2023] = {.lex_state = 220},
  [2024] = {.lex_state = 220},
  [2025] = {.lex_state = 220},
  [2026] = {.lex_state = 188},
  [2027] = {.lex_state = 220},
  [2028] = {.lex_state = 220},
  [2029] = {.lex_state = 220},
  [2030] = {.lex_state = 220},
  [2031] = {.lex_state = 220},
  [2032] = {.lex_state = 220},
  [2033] = {.lex_state = 220},
  [2034] = {.lex_state = 220},
  [2035] = {.lex_state = 220},
  [2036] = {.lex_state = 220},
  [2037] = {.lex_state = 220},
  [2038] = {.lex_state = 220},
  [2039] = {.lex_state = 220},
  [2040] = {.lex_state = 188},
  [2041] = {.lex_state = 220},
  [2042] = {.lex_state = 220},
  [2043] = {.lex_state = 220},
  [2044] = {.lex_state = 220},
  [2045] = {.lex_state = 188},
  [2046] = {.lex_state = 220},
  [2047] = {.lex_state = 220},
  [2048] = {.lex_state = 220},
  [2049] = {.lex_state = 220},
  [2050] = {.lex_state = 220},
  [2051] = {.lex_state = 220},
  [2052] = {.lex_state = 220},
  [2053] = {.lex_state = 220},
  [2054] = {.lex_state = 188},
  [2055] = {.lex_state = 188},
  [2056] = {.lex_state = 250},
  [2057] = {.lex_state = 188},
  [2058] = {.lex_state = 188},
  [2059] = {.lex_state = 188},
  [2060] = {.lex_state = 188},
  [2061] = {.lex_state = 250},
  [2062] = {.lex_state = 250},
  [2063] = {.lex_state = 250},
  [2064] = {.lex_state = 188},
  [2065] = {.lex_state = 188},
  [2066] = {.lex_state = 188},
  [2067] = {.lex_state = 188},
  [2068] = {.lex_state = 188},
  [2069] = {.lex_state = 188},
  [2070] = {.lex_state = 188},
  [2071] = {.lex_state = 188},
  [2072] = {.lex_state = 188},
  [2073] = {.lex_state = 188},
  [2074] = {.lex_state = 188},
  [2075] = {.lex_state = 250},
  [2076] = {.lex_state = 250},
  [2077] = {.lex_state = 250},
  [2078] = {.lex_state = 250},
  [2079] = {.lex_state = 250},
  [2080] = {.lex_state = 250},
  [2081] = {.lex_state = 250},
  [2082] = {.lex_state = 250},
  [2083] = {.lex_state = 250},
  [2084] = {.lex_state = 250},
  [2085] = {.lex_state = 188},
  [2086] = {.lex_state = 250},
  [2087] = {.lex_state = 250},
  [2088] = {.lex_state = 250},
  [2089] = {.lex_state = 250},
  [2090] = {.lex_state = 188},
  [2091] = {.lex_state = 250},
  [2092] = {.lex_state = 188},
  [2093] = {.lex_state = 188},
  [2094] = {.lex_state = 188},
  [2095] = {.lex_state = 250},
  [2096] = {.lex_state = 188},
  [2097] = {.lex_state = 250},
  [2098] = {.lex_state = 250},
  [2099] = {.lex_state = 250},
  [2100] = {.lex_state = 250},
  [2101] = {.lex_state = 250},
  [2102] = {.lex_state = 250},
  [2103] = {.lex_state = 250},
  [2104] = {.lex_state = 250},
  [2105] = {.lex_state = 250},
  [2106] = {.lex_state = 250},
  [2107] = {.lex_state = 250},
  [2108] = {.lex_state = 250},
  [2109] = {.lex_state = 250},
  [2110] = {.lex_state = 250},
  [2111] = {.lex_state = 250},
  [2112] = {.lex_state = 250},
  [2113] = {.lex_state = 250},
  [2114] = {.lex_state = 250},
  [2115] = {.lex_state = 250},
  [2116] = {.lex_state = 250},
  [2117] = {.lex_state = 188},
  [2118] = {.lex_state = 250},
  [2119] = {.lex_state = 250},
  [2120] = {.lex_state = 250},
  [2121] = {.lex_state = 250},
  [2122] = {.lex_state = 250},
  [2123] = {.lex_state = 250},
  [2124] = {.lex_state = 250},
  [2125] = {.lex_state = 250},
  [2126] = {.lex_state = 250},
  [2127] = {.lex_state = 250},
  [2128] = {.lex_state = 250},
  [2129] = {.lex_state = 250},
  [2130] = {.lex_state = 188},
  [2131] = {.lex_state = 188},
  [2132] = {.lex_state = 250},
  [2133] = {.lex_state = 250},
  [2134] = {.lex_state = 250},
  [2135] = {.lex_state = 250},
  [2136] = {.lex_state = 250},
  [2137] = {.lex_state = 250},
  [2138] = {.lex_state = 250},
  [2139] = {.lex_state = 250},
  [2140] = {.lex_state = 250},
  [2141] = {.lex_state = 250},
  [2142] = {.lex_state = 250},
  [2143] = {.lex_state = 250},
  [2144] = {.lex_state = 250},
  [2145] = {.lex_state = 250},
  [2146] = {.lex_state = 250},
  [2147] = {.lex_state = 188},
  [2148] = {.lex_state = 250},
  [2149] = {.lex_state = 250},
  [2150] = {.lex_state = 250},
  [2151] = {.lex_state = 188},
  [2152] = {.lex_state = 250},
  [2153] = {.lex_state = 188},
  [2154] = {.lex_state = 188},
  [2155] = {.lex_state = 188},
  [2156] = {.lex_state = 188},
  [2157] = {.lex_state = 188},
  [2158] = {.lex_state = 188},
  [2159] = {.lex_state = 188},
  [2160] = {.lex_state = 250},
  [2161] = {.lex_state = 188},
  [2162] = {.lex_state = 188},
  [2163] = {.lex_state = 188},
  [2164] = {.lex_state = 188},
  [2165] = {.lex_state = 188},
  [2166] = {.lex_state = 250},
  [2167] = {.lex_state = 250},
  [2168] = {.lex_state = 188},
  [2169] = {.lex_state = 250},
  [2170] = {.lex_state = 250},
  [2171] = {.lex_state = 250},
  [2172] = {.lex_state = 250},
  [2173] = {.lex_state = 188},
  [2174] = {.lex_state = 250},
  [2175] = {.lex_state = 250},
  [2176] = {.lex_state = 188},
  [2177] = {.lex_state = 188},
  [2178] = {.lex_state = 188},
  [2179] = {.lex_state = 188},
  [2180] = {.lex_state = 188},
  [2181] = {.lex_state = 188},
  [2182] = {.lex_state = 188},
  [2183] = {.lex_state = 188},
  [2184] = {.lex_state = 188},
  [2185] = {.lex_state = 188},
  [2186] = {.lex_state = 188},
  [2187] = {.lex_state = 250},
  [2188] = {.lex_state = 250},
  [2189] = {.lex_state = 250},
  [2190] = {.lex_state = 250},
  [2191] = {.lex_state = 250},
  [2192] = {.lex_state = 250},
  [2193] = {.lex_state = 250},
  [2194] = {.lex_state = 250},
  [2195] = {.lex_state = 250},
  [2196] = {.lex_state = 188},
  [2197] = {.lex_state = 188},
  [2198] = {.lex_state = 252},
  [2199] = {.lex_state = 188},
  [2200] = {.lex_state = 188},
  [2201] = {.lex_state = 188},
  [2202] = {.lex_state = 188},
  [2203] = {.lex_state = 188},
  [2204] = {.lex_state = 188},
  [2205] = {.lex_state = 188},
  [2206] = {.lex_state = 188},
  [2207] = {.lex_state = 250},
  [2208] = {.lex_state = 252},
  [2209] = {.lex_state = 250},
  [2210] = {.lex_state = 250},
  [2211] = {.lex_state = 188},
  [2212] = {.lex_state = 188},
  [2213] = {.lex_state = 188},
  [2214] = {.lex_state = 250},
  [2215] = {.lex_state = 250},
  [2216] = {.lex_state = 250},
  [2217] = {.lex_state = 188},
  [2218] = {.lex_state = 188},
  [2219] = {.lex_state = 188},
  [2220] = {.lex_state = 188},
  [2221] = {.lex_state = 250},
  [2222] = {.lex_state = 250},
  [2223] = {.lex_state = 250},
  [2224] = {.lex_state = 250},
  [2225] = {.lex_state = 188},
  [2226] = {.lex_state = 220},
  [2227] = {.lex_state = 188},
  [2228] = {.lex_state = 220},
  [2229] = {.lex_state = 220},
  [2230] = {.lex_state = 220},
  [2231] = {.lex_state = 188},
  [2232] = {.lex_state = 220},
  [2233] = {.lex_state = 220},
  [2234] = {.lex_state = 252},
  [2235] = {.lex_state = 220},
  [2236] = {.lex_state = 220},
  [2237] = {.lex_state = 188},
  [2238] = {.lex_state = 220},
  [2239] = {.lex_state = 220},
  [2240] = {.lex_state = 220},
  [2241] = {.lex_state = 220},
  [2242] = {.lex_state = 220},
  [2243] = {.lex_state = 188},
  [2244] = {.lex_state = 220},
  [2245] = {.lex_state = 220},
  [2246] = {.lex_state = 220},
  [2247] = {.lex_state = 220},
  [2248] = {.lex_state = 220},
  [2249] = {.lex_state = 220},
  [2250] = {.lex_state = 220},
  [2251] = {.lex_state = 220},
  [2252] = {.lex_state = 220},
  [2253] = {.lex_state = 220},
  [2254] = {.lex_state = 220},
  [2255] = {.lex_state = 220},
  [2256] = {.lex_state = 220},
  [2257] = {.lex_state = 220},
  [2258] = {.lex_state = 220},
  [2259] = {.lex_state = 220},
  [2260] = {.lex_state = 220},
  [2261] = {.lex_state = 188},
  [2262] = {.lex_state = 220},
  [2263] = {.lex_state = 220},
  [2264] = {.lex_state = 220},
  [2265] = {.lex_state = 220},
  [2266] = {.lex_state = 220},
  [2267] = {.lex_state = 250},
  [2268] = {.lex_state = 220},
  [2269] = {.lex_state = 220},
  [2270] = {.lex_state = 220},
  [2271] = {.lex_state = 220},
  [2272] = {.lex_state = 220},
  [2273] = {.lex_state = 220},
  [2274] = {.lex_state = 220},
  [2275] = {.lex_state = 220},
  [2276] = {.lex_state = 220},
  [2277] = {.lex_state = 220},
  [2278] = {.lex_state = 220},
  [2279] = {.lex_state = 220},
  [2280] = {.lex_state = 220},
  [2281] = {.lex_state = 220},
  [2282] = {.lex_state = 220},
  [2283] = {.lex_state = 220},
  [2284] = {.lex_state = 220},
  [2285] = {.lex_state = 250},
  [2286] = {.lex_state = 250},
  [2287] = {.lex_state = 250},
  [2288] = {.lex_state = 188},
  [2289] = {.lex_state = 188},
  [2290] = {.lex_state = 188},
  [2291] = {.lex_state = 188},
  [2292] = {.lex_state = 220},
  [2293] = {.lex_state = 220},
  [2294] = {.lex_state = 220},
  [2295] = {.lex_state = 220},
  [2296] = {.lex_state = 220},
  [2297] = {.lex_state = 220},
  [2298] = {.lex_state = 220},
  [2299] = {.lex_state = 220},
  [2300] = {.lex_state = 220},
  [2301] = {.lex_state = 220},
  [2302] = {.lex_state = 220},
  [2303] = {.lex_state = 220},
  [2304] = {.lex_state = 220},
  [2305] = {.lex_state = 220},
  [2306] = {.lex_state = 220},
  [2307] = {.lex_state = 220},
  [2308] = {.lex_state = 188},
  [2309] = {.lex_state = 188},
  [2310] = {.lex_state = 188},
  [2311] = {.lex_state = 188},
  [2312] = {.lex_state = 188},
  [2313] = {.lex_state = 188},
  [2314] = {.lex_state = 188},
  [2315] = {.lex_state = 188},
  [2316] = {.lex_state = 188},
  [2317] = {.lex_state = 188},
  [2318] = {.lex_state = 188},
  [2319] = {.lex_state = 188},
  [2320] = {.lex_state = 188},
  [2321] = {.lex_state = 188},
  [2322] = {.lex_state = 188},
  [2323] = {.lex_state = 188},
  [2324] = {.lex_state = 188},
  [2325] = {.lex_state = 188},
  [2326] = {.lex_state = 188},
  [2327] = {.lex_state = 188},
  [2328] = {.lex_state = 188},
  [2329] = {.lex_state = 188},
  [2330] = {.lex_state = 188},
  [2331] = {.lex_state = 188},
  [2332] = {.lex_state = 188},
  [2333] = {.lex_state = 188},
  [2334] = {.lex_state = 188},
  [2335] = {.lex_state = 188},
  [2336] = {.lex_state = 188},
  [2337] = {.lex_state = 188},
  [2338] = {.lex_state = 188},
  [2339] = {.lex_state = 188},
  [2340] = {.lex_state = 188},
  [2341] = {.lex_state = 188},
  [2342] = {.lex_state = 188},
  [2343] = {.lex_state = 188},
  [2344] = {.lex_state = 188},
  [2345] = {.lex_state = 188},
  [2346] = {.lex_state = 188},
  [2347] = {.lex_state = 188},
  [2348] = {.lex_state = 188},
  [2349] = {.lex_state = 188},
  [2350] = {.lex_state = 188},
  [2351] = {.lex_state = 188},
  [2352] = {.lex_state = 188},
  [2353] = {.lex_state = 188},
  [2354] = {.lex_state = 188},
  [2355] = {.lex_state = 188},
  [2356] = {.lex_state = 188},
  [2357] = {.lex_state = 188},
  [2358] = {.lex_state = 188},
  [2359] = {.lex_state = 188},
  [2360] = {.lex_state = 188},
  [2361] = {.lex_state = 188},
  [2362] = {.lex_state = 188},
  [2363] = {.lex_state = 188},
  [2364] = {.lex_state = 188},
  [2365] = {.lex_state = 188},
  [2366] = {.lex_state = 188},
  [2367] = {.lex_state = 188},
  [2368] = {.lex_state = 188},
  [2369] = {.lex_state = 188},
  [2370] = {.lex_state = 188},
  [2371] = {.lex_state = 188},
  [2372] = {.lex_state = 188},
  [2373] = {.lex_state = 188},
  [2374] = {.lex_state = 188},
  [2375] = {.lex_state = 188},
  [2376] = {.lex_state = 188},
  [2377] = {.lex_state = 188},
  [2378] = {.lex_state = 188},
  [2379] = {.lex_state = 188},
  [2380] = {.lex_state = 188},
  [2381] = {.lex_state = 188},
  [2382] = {.lex_state = 188},
  [2383] = {.lex_state = 188},
  [2384] = {.lex_state = 188},
  [2385] = {.lex_state = 188},
  [2386] = {.lex_state = 188},
  [2387] = {.lex_state = 188},
  [2388] = {.lex_state = 188},
  [2389] = {.lex_state = 188},
  [2390] = {.lex_state = 188},
  [2391] = {.lex_state = 188},
  [2392] = {.lex_state = 188},
  [2393] = {.lex_state = 188},
  [2394] = {.lex_state = 188},
  [2395] = {.lex_state = 188},
  [2396] = {.lex_state = 188},
  [2397] = {.lex_state = 188},
  [2398] = {.lex_state = 188},
  [2399] = {.lex_state = 188},
  [2400] = {.lex_state = 188},
  [2401] = {.lex_state = 188},
  [2402] = {.lex_state = 188},
  [2403] = {.lex_state = 188},
  [2404] = {.lex_state = 188},
  [2405] = {.lex_state = 188},
  [2406] = {.lex_state = 188},
  [2407] = {.lex_state = 188},
  [2408] = {.lex_state = 188},
  [2409] = {.lex_state = 188},
  [2410] = {.lex_state = 188},
  [2411] = {.lex_state = 188},
  [2412] = {.lex_state = 188},
  [2413] = {.lex_state = 188},
  [2414] = {.lex_state = 188},
  [2415] = {.lex_state = 188},
  [2416] = {.lex_state = 188},
  [2417] = {.lex_state = 188},
  [2418] = {.lex_state = 188},
  [2419] = {.lex_state = 188},
  [2420] = {.lex_state = 188},
  [2421] = {.lex_state = 188},
  [2422] = {.lex_state = 188},
  [2423] = {.lex_state = 188},
  [2424] = {.lex_state = 188},
  [2425] = {.lex_state = 188},
  [2426] = {.lex_state = 188},
  [2427] = {.lex_state = 188},
  [2428] = {.lex_state = 188},
  [2429] = {.lex_state = 188},
  [2430] = {.lex_state = 188},
  [2431] = {.lex_state = 188},
  [2432] = {.lex_state = 188},
  [2433] = {.lex_state = 188},
  [2434] = {.lex_state = 188},
  [2435] = {.lex_state = 188},
  [2436] = {.lex_state = 188},
  [2437] = {.lex_state = 188},
  [2438] = {.lex_state = 188},
  [2439] = {.lex_state = 188},
  [2440] = {.lex_state = 188},
  [2441] = {.lex_state = 250},
  [2442] = {.lex_state = 250},
  [2443] = {.lex_state = 188},
  [2444] = {.lex_state = 188},
  [2445] = {.lex_state = 250},
  [2446] = {.lex_state = 250},
  [2447] = {.lex_state = 188},
  [2448] = {.lex_state = 188},
  [2449] = {.lex_state = 188},
  [2450] = {.lex_state = 188},
  [2451] = {.lex_state = 188},
  [2452] = {.lex_state = 250},
  [2453] = {.lex_state = 188},
  [2454] = {.lex_state = 250},
  [2455] = {.lex_state = 250},
  [2456] = {.lex_state = 250},
  [2457] = {.lex_state = 250},
  [2458] = {.lex_state = 250},
  [2459] = {.lex_state = 250},
  [2460] = {.lex_state = 252},
  [2461] = {.lex_state = 188},
  [2462] = {.lex_state = 188},
  [2463] = {.lex_state = 188},
  [2464] = {.lex_state = 188},
  [2465] = {.lex_state = 188},
  [2466] = {.lex_state = 188},
  [2467] = {.lex_state = 188},
  [2468] = {.lex_state = 188},
  [2469] = {.lex_state = 188},
  [2470] = {.lex_state = 188},
  [2471] = {.lex_state = 188},
  [2472] = {.lex_state = 188},
  [2473] = {.lex_state = 188},
  [2474] = {.lex_state = 188},
  [2475] = {.lex_state = 188},
  [2476] = {.lex_state = 188},
  [2477] = {.lex_state = 188},
  [2478] = {.lex_state = 188},
  [2479] = {.lex_state = 188},
  [2480] = {.lex_state = 188},
  [2481] = {.lex_state = 188},
  [2482] = {.lex_state = 188},
  [2483] = {.lex_state = 188},
  [2484] = {.lex_state = 188},
  [2485] = {.lex_state = 188},
  [2486] = {.lex_state = 188},
  [2487] = {.lex_state = 188},
  [2488] = {.lex_state = 220},
  [2489] = {.lex_state = 188},
  [2490] = {.lex_state = 188},
  [2491] = {.lex_state = 220},
  [2492] = {.lex_state = 188},
  [2493] = {.lex_state = 188},
  [2494] = {.lex_state = 188},
  [2495] = {.lex_state = 188},
  [2496] = {.lex_state = 188},
  [2497] = {.lex_state = 188},
  [2498] = {.lex_state = 188},
  [2499] = {.lex_state = 188},
  [2500] = {.lex_state = 188},
  [2501] = {.lex_state = 188},
  [2502] = {.lex_state = 188},
  [2503] = {.lex_state = 188},
  [2504] = {.lex_state = 188},
  [2505] = {.lex_state = 188},
  [2506] = {.lex_state = 188},
  [2507] = {.lex_state = 188},
  [2508] = {.lex_state = 188},
  [2509] = {.lex_state = 188},
  [2510] = {.lex_state = 188},
  [2511] = {.lex_state = 188},
  [2512] = {.lex_state = 188},
  [2513] = {.lex_state = 188},
  [2514] = {.lex_state = 188},
  [2515] = {.lex_state = 188},
  [2516] = {.lex_state = 188},
  [2517] = {.lex_state = 188},
  [2518] = {.lex_state = 188},
  [2519] = {.lex_state = 188},
  [2520] = {.lex_state = 188},
  [2521] = {.lex_state = 188},
  [2522] = {.lex_state = 188},
  [2523] = {.lex_state = 188},
  [2524] = {.lex_state = 188},
  [2525] = {.lex_state = 188},
  [2526] = {.lex_state = 188},
  [2527] = {.lex_state = 188},
  [2528] = {.lex_state = 188},
  [2529] = {.lex_state = 188},
  [2530] = {.lex_state = 188},
  [2531] = {.lex_state = 188},
  [2532] = {.lex_state = 188},
  [2533] = {.lex_state = 188},
  [2534] = {.lex_state = 188},
  [2535] = {.lex_state = 188},
  [2536] = {.lex_state = 188},
  [2537] = {.lex_state = 188},
  [2538] = {.lex_state = 188},
  [2539] = {.lex_state = 188},
  [2540] = {.lex_state = 188},
  [2541] = {.lex_state = 188},
  [2542] = {.lex_state = 188},
  [2543] = {.lex_state = 188},
  [2544] = {.lex_state = 188},
  [2545] = {.lex_state = 188},
  [2546] = {.lex_state = 188},
  [2547] = {.lex_state = 188},
  [2548] = {.lex_state = 188},
  [2549] = {.lex_state = 188},
  [2550] = {.lex_state = 188},
  [2551] = {.lex_state = 188},
  [2552] = {.lex_state = 188},
  [2553] = {.lex_state = 188},
  [2554] = {.lex_state = 188},
  [2555] = {.lex_state = 188},
  [2556] = {.lex_state = 188},
  [2557] = {.lex_state = 188},
  [2558] = {.lex_state = 188},
  [2559] = {.lex_state = 188},
  [2560] = {.lex_state = 188},
  [2561] = {.lex_state = 188},
  [2562] = {.lex_state = 188},
  [2563] = {.lex_state = 188},
  [2564] = {.lex_state = 188},
  [2565] = {.lex_state = 188},
  [2566] = {.lex_state = 188},
  [2567] = {.lex_state = 188},
  [2568] = {.lex_state = 188},
  [2569] = {.lex_state = 188},
  [2570] = {.lex_state = 188},
  [2571] = {.lex_state = 188},
  [2572] = {.lex_state = 188},
  [2573] = {.lex_state = 188},
  [2574] = {.lex_state = 188},
  [2575] = {.lex_state = 188},
  [2576] = {.lex_state = 188},
  [2577] = {.lex_state = 188},
  [2578] = {.lex_state = 188},
  [2579] = {.lex_state = 188},
  [2580] = {.lex_state = 188},
  [2581] = {.lex_state = 188},
  [2582] = {.lex_state = 188},
  [2583] = {.lex_state = 188},
  [2584] = {.lex_state = 188},
  [2585] = {.lex_state = 188},
  [2586] = {.lex_state = 188},
  [2587] = {.lex_state = 188},
  [2588] = {.lex_state = 188},
  [2589] = {.lex_state = 188},
  [2590] = {.lex_state = 188},
  [2591] = {.lex_state = 188},
  [2592] = {.lex_state = 188},
  [2593] = {.lex_state = 188},
  [2594] = {.lex_state = 252},
  [2595] = {.lex_state = 188},
  [2596] = {.lex_state = 188},
  [2597] = {.lex_state = 252},
  [2598] = {.lex_state = 188},
  [2599] = {.lex_state = 188},
  [2600] = {.lex_state = 188},
  [2601] = {.lex_state = 252},
  [2602] = {.lex_state = 188},
  [2603] = {.lex_state = 252},
  [2604] = {.lex_state = 252},
  [2605] = {.lex_state = 188},
  [2606] = {.lex_state = 252},
  [2607] = {.lex_state = 252},
  [2608] = {.lex_state = 188},
  [2609] = {.lex_state = 252},
  [2610] = {.lex_state = 252},
  [2611] = {.lex_state = 188},
  [2612] = {.lex_state = 252},
  [2613] = {.lex_state = 252},
  [2614] = {.lex_state = 188},
  [2615] = {.lex_state = 252},
  [2616] = {.lex_state = 188},
  [2617] = {.lex_state = 188},
  [2618] = {.lex_state = 188},
  [2619] = {.lex_state = 188},
  [2620] = {.lex_state = 188},
  [2621] = {.lex_state = 188},
  [2622] = {.lex_state = 188},
  [2623] = {.lex_state = 188},
  [2624] = {.lex_state = 188},
  [2625] = {.lex_state = 188},
  [2626] = {.lex_state = 188},
  [2627] = {.lex_state = 188},
  [2628] = {.lex_state = 188},
  [2629] = {.lex_state = 188},
  [2630] = {.lex_state = 188},
  [2631] = {.lex_state = 188},
  [2632] = {.lex_state = 188},
  [2633] = {.lex_state = 188},
  [2634] = {.lex_state = 188},
  [2635] = {.lex_state = 188},
  [2636] = {.lex_state = 188},
  [2637] = {.lex_state = 188},
  [2638] = {.lex_state = 188},
  [2639] = {.lex_state = 188},
  [2640] = {.lex_state = 188},
  [2641] = {.lex_state = 188},
  [2642] = {.lex_state = 188},
  [2643] = {.lex_state = 188},
  [2644] = {.lex_state = 188},
  [2645] = {.lex_state = 188},
  [2646] = {.lex_state = 188},
  [2647] = {.lex_state = 188},
  [2648] = {.lex_state = 188},
  [2649] = {.lex_state = 188},
  [2650] = {.lex_state = 188},
  [2651] = {.lex_state = 188},
  [2652] = {.lex_state = 188},
  [2653] = {.lex_state = 188},
  [2654] = {.lex_state = 188},
  [2655] = {.lex_state = 188},
  [2656] = {.lex_state = 188},
  [2657] = {.lex_state = 188},
  [2658] = {.lex_state = 188},
  [2659] = {.lex_state = 188},
  [2660] = {.lex_state = 188},
  [2661] = {.lex_state = 220},
  [2662] = {.lex_state = 252},
  [2663] = {.lex_state = 252},
  [2664] = {.lex_state = 252},
  [2665] = {.lex_state = 252},
  [2666] = {.lex_state = 252},
  [2667] = {.lex_state = 252},
  [2668] = {.lex_state = 237},
  [2669] = {.lex_state = 237},
  [2670] = {.lex_state = 237},
  [2671] = {.lex_state = 237},
  [2672] = {.lex_state = 237},
  [2673] = {.lex_state = 237},
  [2674] = {.lex_state = 237},
  [2675] = {.lex_state = 237},
  [2676] = {.lex_state = 237},
  [2677] = {.lex_state = 237},
  [2678] = {.lex_state = 237},
  [2679] = {.lex_state = 252},
  [2680] = {.lex_state = 252},
  [2681] = {.lex_state = 252},
  [2682] = {.lex_state = 252},
  [2683] = {.lex_state = 252},
  [2684] = {.lex_state = 252},
  [2685] = {.lex_state = 251},
  [2686] = {.lex_state = 196},
  [2687] = {.lex_state = 252},
  [2688] = {.lex_state = 252},
  [2689] = {.lex_state = 252},
  [2690] = {.lex_state = 252},
  [2691] = {.lex_state = 252},
  [2692] = {.lex_state = 210},
  [2693] = {.lex_state = 252},
  [2694] = {.lex_state = 252},
  [2695] = {.lex_state = 197},
  [2696] = {.lex_state = 252},
  [2697] = {.lex_state = 252},
  [2698] = {.lex_state = 201},
  [2699] = {.lex_state = 252},
  [2700] = {.lex_state = 252},
  [2701] = {.lex_state = 252},
  [2702] = {.lex_state = 252},
  [2703] = {.lex_state = 252},
  [2704] = {.lex_state = 252},
  [2705] = {.lex_state = 252},
  [2706] = {.lex_state = 252},
  [2707] = {.lex_state = 252},
  [2708] = {.lex_state = 252},
  [2709] = {.lex_state = 252},
  [2710] = {.lex_state = 252},
  [2711] = {.lex_state = 252},
  [2712] = {.lex_state = 252},
  [2713] = {.lex_state = 252},
  [2714] = {.lex_state = 252},
  [2715] = {.lex_state = 252},
  [2716] = {.lex_state = 252},
  [2717] = {.lex_state = 252},
  [2718] = {.lex_state = 252},
  [2719] = {.lex_state = 252},
  [2720] = {.lex_state = 251},
  [2721] = {.lex_state = 251},
  [2722] = {.lex_state = 251},
  [2723] = {.lex_state = 251},
  [2724] = {.lex_state = 251},
  [2725] = {.lex_state = 251},
  [2726] = {.lex_state = 210},
  [2727] = {.lex_state = 191},
  [2728] = {.lex_state = 251},
  [2729] = {.lex_state = 251},
  [2730] = {.lex_state = 251},
  [2731] = {.lex_state = 251},
  [2732] = {.lex_state = 210},
  [2733] = {.lex_state = 210},
  [2734] = {.lex_state = 252},
  [2735] = {.lex_state = 210},
  [2736] = {.lex_state = 210},
  [2737] = {.lex_state = 251},
  [2738] = {.lex_state = 251},
  [2739] = {.lex_state = 210},
  [2740] = {.lex_state = 210},
  [2741] = {.lex_state = 208},
  [2742] = {.lex_state = 208},
  [2743] = {.lex_state = 251},
  [2744] = {.lex_state = 251},
  [2745] = {.lex_state = 251},
  [2746] = {.lex_state = 251},
  [2747] = {.lex_state = 208},
  [2748] = {.lex_state = 208},
  [2749] = {.lex_state = 208},
  [2750] = {.lex_state = 208},
  [2751] = {.lex_state = 251},
  [2752] = {.lex_state = 251},
  [2753] = {.lex_state = 208},
  [2754] = {.lex_state = 208},
  [2755] = {.lex_state = 208},
  [2756] = {.lex_state = 208},
  [2757] = {.lex_state = 208},
  [2758] = {.lex_state = 208},
  [2759] = {.lex_state = 251},
  [2760] = {.lex_state = 251},
  [2761] = {.lex_state = 251},
  [2762] = {.lex_state = 251},
  [2763] = {.lex_state = 251},
  [2764] = {.lex_state = 251},
  [2765] = {.lex_state = 208},
  [2766] = {.lex_state = 208},
  [2767] = {.lex_state = 208},
  [2768] = {.lex_state = 251},
  [2769] = {.lex_state = 251},
  [2770] = {.lex_state = 245},
  [2771] = {.lex_state = 245},
  [2772] = {.lex_state = 251},
  [2773] = {.lex_state = 251},
  [2774] = {.lex_state = 251},
  [2775] = {.lex_state = 245},
  [2776] = {.lex_state = 245},
  [2777] = {.lex_state = 224},
  [2778] = {.lex_state = 224},
  [2779] = {.lex_state = 210},
  [2780] = {.lex_state = 210},
  [2781] = {.lex_state = 237},
  [2782] = {.lex_state = 237},
  [2783] = {.lex_state = 251},
  [2784] = {.lex_state = 251},
  [2785] = {.lex_state = 237},
  [2786] = {.lex_state = 237},
  [2787] = {.lex_state = 237},
  [2788] = {.lex_state = 232},
  [2789] = {.lex_state = 224},
  [2790] = {.lex_state = 232},
  [2791] = {.lex_state = 237},
  [2792] = {.lex_state = 237},
  [2793] = {.lex_state = 251},
  [2794] = {.lex_state = 237},
  [2795] = {.lex_state = 237},
  [2796] = {.lex_state = 237},
  [2797] = {.lex_state = 237},
  [2798] = {.lex_state = 237},
  [2799] = {.lex_state = 216},
  [2800] = {.lex_state = 237},
  [2801] = {.lex_state = 237},
  [2802] = {.lex_state = 237},
  [2803] = {.lex_state = 237},
  [2804] = {.lex_state = 232},
  [2805] = {.lex_state = 237},
  [2806] = {.lex_state = 251},
  [2807] = {.lex_state = 237},
  [2808] = {.lex_state = 237},
  [2809] = {.lex_state = 237},
  [2810] = {.lex_state = 237},
  [2811] = {.lex_state = 237},
  [2812] = {.lex_state = 237},
  [2813] = {.lex_state = 237},
  [2814] = {.lex_state = 251},
  [2815] = {.lex_state = 224},
  [2816] = {.lex_state = 251},
  [2817] = {.lex_state = 224},
  [2818] = {.lex_state = 224},
  [2819] = {.lex_state = 251},
  [2820] = {.lex_state = 251},
  [2821] = {.lex_state = 251},
  [2822] = {.lex_state = 251},
  [2823] = {.lex_state = 251},
  [2824] = {.lex_state = 251},
  [2825] = {.lex_state = 252},
  [2826] = {.lex_state = 251},
  [2827] = {.lex_state = 251},
  [2828] = {.lex_state = 224},
  [2829] = {.lex_state = 251},
  [2830] = {.lex_state = 251},
  [2831] = {.lex_state = 251},
  [2832] = {.lex_state = 251},
  [2833] = {.lex_state = 251},
  [2834] = {.lex_state = 251},
  [2835] = {.lex_state = 252},
  [2836] = {.lex_state = 252},
  [2837] = {.lex_state = 252},
  [2838] = {.lex_state = 251},
  [2839] = {.lex_state = 251},
  [2840] = {.lex_state = 251},
  [2841] = {.lex_state = 252},
  [2842] = {.lex_state = 251},
  [2843] = {.lex_state = 252},
  [2844] = {.lex_state = 251},
  [2845] = {.lex_state = 224},
  [2846] = {.lex_state = 251},
  [2847] = {.lex_state = 251},
  [2848] = {.lex_state = 252},
  [2849] = {.lex_state = 251},
  [2850] = {.lex_state = 251},
  [2851] = {.lex_state = 251},
  [2852] = {.lex_state = 224},
  [2853] = {.lex_state = 251},
  [2854] = {.lex_state = 251},
  [2855] = {.lex_state = 252},
  [2856] = {.lex_state = 252},
  [2857] = {.lex_state = 252},
  [2858] = {.lex_state = 251},
  [2859] = {.lex_state = 251},
  [2860] = {.lex_state = 252},
  [2861] = {.lex_state = 251},
  [2862] = {.lex_state = 252},
  [2863] = {.lex_state = 251},
  [2864] = {.lex_state = 252},
  [2865] = {.lex_state = 251},
  [2866] = {.lex_state = 251},
  [2867] = {.lex_state = 251},
  [2868] = {.lex_state = 251},
  [2869] = {.lex_state = 251},
  [2870] = {.lex_state = 251},
  [2871] = {.lex_state = 251},
  [2872] = {.lex_state = 251},
  [2873] = {.lex_state = 224},
  [2874] = {.lex_state = 252},
  [2875] = {.lex_state = 252},
  [2876] = {.lex_state = 251},
  [2877] = {.lex_state = 251},
  [2878] = {.lex_state = 232},
  [2879] = {.lex_state = 251},
  [2880] = {.lex_state = 251},
  [2881] = {.lex_state = 216},
  [2882] = {.lex_state = 251},
  [2883] = {.lex_state = 251},
  [2884] = {.lex_state = 251},
  [2885] = {.lex_state = 251},
  [2886] = {.lex_state = 251},
  [2887] = {.lex_state = 251},
  [2888] = {.lex_state = 251},
  [2889] = {.lex_state = 232},
  [2890] = {.lex_state = 252},
  [2891] = {.lex_state = 251},
  [2892] = {.lex_state = 251},
  [2893] = {.lex_state = 252},
  [2894] = {.lex_state = 251},
  [2895] = {.lex_state = 251},
  [2896] = {.lex_state = 251},
  [2897] = {.lex_state = 251},
  [2898] = {.lex_state = 251},
  [2899] = {.lex_state = 251},
  [2900] = {.lex_state = 251},
  [2901] = {.lex_state = 251},
  [2902] = {.lex_state = 252},
  [2903] = {.lex_state = 251},
  [2904] = {.lex_state = 251},
  [2905] = {.lex_state = 216},
  [2906] = {.lex_state = 252},
  [2907] = {.lex_state = 232},
  [2908] = {.lex_state = 252},
  [2909] = {.lex_state = 232},
  [2910] = {.lex_state = 251},
  [2911] = {.lex_state = 252},
  [2912] = {.lex_state = 216},
  [2913] = {.lex_state = 251},
  [2914] = {.lex_state = 252},
  [2915] = {.lex_state = 252},
  [2916] = {.lex_state = 252},
  [2917] = {.lex_state = 237},
  [2918] = {.lex_state = 237},
  [2919] = {.lex_state = 252},
  [2920] = {.lex_state = 221},
  [2921] = {.lex_state = 254},
  [2922] = {.lex_state = 221},
  [2923] = {.lex_state = 251},
  [2924] = {.lex_state = 221},
  [2925] = {.lex_state = 252},
  [2926] = {.lex_state = 221},
  [2927] = {.lex_state = 221},
  [2928] = {.lex_state = 221},
  [2929] = {.lex_state = 221},
  [2930] = {.lex_state = 221},
  [2931] = {.lex_state = 221},
  [2932] = {.lex_state = 221},
  [2933] = {.lex_state = 221},
  [2934] = {.lex_state = 221},
  [2935] = {.lex_state = 224},
  [2936] = {.lex_state = 221},
  [2937] = {.lex_state = 221},
  [2938] = {.lex_state = 251},
  [2939] = {.lex_state = 224},
  [2940] = {.lex_state = 221},
  [2941] = {.lex_state = 228},
  [2942] = {.lex_state = 228},
  [2943] = {.lex_state = 251},
  [2944] = {.lex_state = 228},
  [2945] = {.lex_state = 251},
  [2946] = {.lex_state = 228},
  [2947] = {.lex_state = 228},
  [2948] = {.lex_state = 228},
  [2949] = {.lex_state = 185},
  [2950] = {.lex_state = 224},
  [2951] = {.lex_state = 185},
  [2952] = {.lex_state = 191},
  [2953] = {.lex_state = 238},
  [2954] = {.lex_state = 251},
  [2955] = {.lex_state = 251},
  [2956] = {.lex_state = 251},
  [2957] = {.lex_state = 228},
  [2958] = {.lex_state = 228},
  [2959] = {.lex_state = 224},
  [2960] = {.lex_state = 228},
  [2961] = {.lex_state = 228},
  [2962] = {.lex_state = 228},
  [2963] = {.lex_state = 228},
  [2964] = {.lex_state = 228},
  [2965] = {.lex_state = 228},
  [2966] = {.lex_state = 228},
  [2967] = {.lex_state = 216},
  [2968] = {.lex_state = 251},
  [2969] = {.lex_state = 251},
  [2970] = {.lex_state = 193},
  [2971] = {.lex_state = 251},
  [2972] = {.lex_state = 251},
  [2973] = {.lex_state = 251},
  [2974] = {.lex_state = 251},
  [2975] = {.lex_state = 251},
  [2976] = {.lex_state = 251},
  [2977] = {.lex_state = 251},
  [2978] = {.lex_state = 251},
  [2979] = {.lex_state = 251},
  [2980] = {.lex_state = 251},
  [2981] = {.lex_state = 185},
  [2982] = {.lex_state = 185},
  [2983] = {.lex_state = 251},
  [2984] = {.lex_state = 193},
  [2985] = {.lex_state = 251},
  [2986] = {.lex_state = 251},
  [2987] = {.lex_state = 193},
  [2988] = {.lex_state = 251},
  [2989] = {.lex_state = 251},
  [2990] = {.lex_state = 238},
  [2991] = {.lex_state = 238},
  [2992] = {.lex_state = 238},
  [2993] = {.lex_state = 238},
  [2994] = {.lex_state = 238},
  [2995] = {.lex_state = 238},
  [2996] = {.lex_state = 238},
  [2997] = {.lex_state = 238},
  [2998] = {.lex_state = 238},
  [2999] = {.lex_state = 206},
  [3000] = {.lex_state = 238},
  [3001] = {.lex_state = 206},
  [3002] = {.lex_state = 238},
  [3003] = {.lex_state = 238},
  [3004] = {.lex_state = 238},
  [3005] = {.lex_state = 238},
  [3006] = {.lex_state = 238},
  [3007] = {.lex_state = 238},
  [3008] = {.lex_state = 238},
  [3009] = {.lex_state = 238},
  [3010] = {.lex_state = 237},
  [3011] = {.lex_state = 238},
  [3012] = {.lex_state = 238},
  [3013] = {.lex_state = 238},
  [3014] = {.lex_state = 216},
  [3015] = {.lex_state = 211},
  [3016] = {.lex_state = 216},
  [3017] = {.lex_state = 216},
  [3018] = {.lex_state = 216},
  [3019] = {.lex_state = 216},
  [3020] = {.lex_state = 216},
  [3021] = {.lex_state = 216},
  [3022] = {.lex_state = 216},
  [3023] = {.lex_state = 216},
  [3024] = {.lex_state = 216},
  [3025] = {.lex_state = 237},
  [3026] = {.lex_state = 237},
  [3027] = {.lex_state = 228},
  [3028] = {.lex_state = 216},
  [3029] = {.lex_state = 216},
  [3030] = {.lex_state = 216},
  [3031] = {.lex_state = 216},
  [3032] = {.lex_state = 216},
  [3033] = {.lex_state = 216},
  [3034] = {.lex_state = 216},
  [3035] = {.lex_state = 216},
  [3036] = {.lex_state = 216},
  [3037] = {.lex_state = 216},
  [3038] = {.lex_state = 216},
  [3039] = {.lex_state = 216},
  [3040] = {.lex_state = 216},
  [3041] = {.lex_state = 237},
  [3042] = {.lex_state = 251},
  [3043] = {.lex_state = 237},
  [3044] = {.lex_state = 216},
  [3045] = {.lex_state = 216},
  [3046] = {.lex_state = 216},
  [3047] = {.lex_state = 237},
  [3048] = {.lex_state = 216},
  [3049] = {.lex_state = 221},
  [3050] = {.lex_state = 252},
  [3051] = {.lex_state = 216},
  [3052] = {.lex_state = 216},
  [3053] = {.lex_state = 216},
  [3054] = {.lex_state = 216},
  [3055] = {.lex_state = 216},
  [3056] = {.lex_state = 216},
  [3057] = {.lex_state = 216},
  [3058] = {.lex_state = 216},
  [3059] = {.lex_state = 216},
  [3060] = {.lex_state = 216},
  [3061] = {.lex_state = 216},
  [3062] = {.lex_state = 216},
  [3063] = {.lex_state = 217},
  [3064] = {.lex_state = 251},
  [3065] = {.lex_state = 216},
  [3066] = {.lex_state = 193},
  [3067] = {.lex_state = 251},
  [3068] = {.lex_state = 216},
  [3069] = {.lex_state = 216},
  [3070] = {.lex_state = 193},
  [3071] = {.lex_state = 193},
  [3072] = {.lex_state = 188},
  [3073] = {.lex_state = 221},
  [3074] = {.lex_state = 216},
  [3075] = {.lex_state = 251},
  [3076] = {.lex_state = 193},
  [3077] = {.lex_state = 228},
  [3078] = {.lex_state = 191},
  [3079] = {.lex_state = 217},
  [3080] = {.lex_state = 217},
  [3081] = {.lex_state = 217},
  [3082] = {.lex_state = 217},
  [3083] = {.lex_state = 251},
  [3084] = {.lex_state = 254},
  [3085] = {.lex_state = 217},
  [3086] = {.lex_state = 217},
  [3087] = {.lex_state = 208},
  [3088] = {.lex_state = 237},
  [3089] = {.lex_state = 217},
  [3090] = {.lex_state = 217},
  [3091] = {.lex_state = 237},
  [3092] = {.lex_state = 217},
  [3093] = {.lex_state = 217},
  [3094] = {.lex_state = 217},
  [3095] = {.lex_state = 217},
  [3096] = {.lex_state = 208},
  [3097] = {.lex_state = 217},
  [3098] = {.lex_state = 208},
  [3099] = {.lex_state = 217},
  [3100] = {.lex_state = 211},
  [3101] = {.lex_state = 252},
  [3102] = {.lex_state = 208},
  [3103] = {.lex_state = 208},
  [3104] = {.lex_state = 211},
  [3105] = {.lex_state = 208},
  [3106] = {.lex_state = 211},
  [3107] = {.lex_state = 208},
  [3108] = {.lex_state = 208},
  [3109] = {.lex_state = 208},
  [3110] = {.lex_state = 211},
  [3111] = {.lex_state = 252},
  [3112] = {.lex_state = 208},
  [3113] = {.lex_state = 188},
  [3114] = {.lex_state = 211},
  [3115] = {.lex_state = 252},
  [3116] = {.lex_state = 216},
  [3117] = {.lex_state = 252},
  [3118] = {.lex_state = 188},
  [3119] = {.lex_state = 252},
  [3120] = {.lex_state = 193},
  [3121] = {.lex_state = 252},
  [3122] = {.lex_state = 252},
  [3123] = {.lex_state = 253},
  [3124] = {.lex_state = 253},
  [3125] = {.lex_state = 251},
  [3126] = {.lex_state = 211},
  [3127] = {.lex_state = 216},
  [3128] = {.lex_state = 211},
  [3129] = {.lex_state = 252},
  [3130] = {.lex_state = 252},
  [3131] = {.lex_state = 252},
  [3132] = {.lex_state = 217},
  [3133] = {.lex_state = 200},
  [3134] = {.lex_state = 191},
  [3135] = {.lex_state = 191},
  [3136] = {.lex_state = 237},
  [3137] = {.lex_state = 211},
  [3138] = {.lex_state = 200},
  [3139] = {.lex_state = 217},
  [3140] = {.lex_state = 208},
  [3141] = {.lex_state = 191},
  [3142] = {.lex_state = 208},
  [3143] = {.lex_state = 211},
  [3144] = {.lex_state = 193},
  [3145] = {.lex_state = 211},
  [3146] = {.lex_state = 237},
  [3147] = {.lex_state = 211},
  [3148] = {.lex_state = 211},
  [3149] = {.lex_state = 208},
  [3150] = {.lex_state = 208},
  [3151] = {.lex_state = 211},
  [3152] = {.lex_state = 211},
  [3153] = {.lex_state = 211},
  [3154] = {.lex_state = 193},
  [3155] = {.lex_state = 193},
  [3156] = {.lex_state = 242},
  [3157] = {.lex_state = 200},
  [3158] = {.lex_state = 193},
  [3159] = {.lex_state = 242},
  [3160] = {.lex_state = 211},
  [3161] = {.lex_state = 196},
  [3162] = {.lex_state = 211},
  [3163] = {.lex_state = 196},
  [3164] = {.lex_state = 211},
  [3165] = {.lex_state = 191},
  [3166] = {.lex_state = 211},
  [3167] = {.lex_state = 209},
  [3168] = {.lex_state = 217},
  [3169] = {.lex_state = 208},
  [3170] = {.lex_state = 253},
  [3171] = {.lex_state = 217},
  [3172] = {.lex_state = 208},
  [3173] = {.lex_state = 208},
  [3174] = {.lex_state = 208},
  [3175] = {.lex_state = 208},
  [3176] = {.lex_state = 242},
  [3177] = {.lex_state = 191},
  [3178] = {.lex_state = 208},
  [3179] = {.lex_state = 208},
  [3180] = {.lex_state = 208},
  [3181] = {.lex_state = 208},
  [3182] = {.lex_state = 208},
  [3183] = {.lex_state = 208},
  [3184] = {.lex_state = 208},
  [3185] = {.lex_state = 208},
  [3186] = {.lex_state = 217},
  [3187] = {.lex_state = 211},
  [3188] = {.lex_state = 217},
  [3189] = {.lex_state = 211},
  [3190] = {.lex_state = 217},
  [3191] = {.lex_state = 217},
  [3192] = {.lex_state = 211},
  [3193] = {.lex_state = 199},
  [3194] = {.lex_state = 191},
  [3195] = {.lex_state = 211},
  [3196] = {.lex_state = 211},
  [3197] = {.lex_state = 191},
  [3198] = {.lex_state = 209},
  [3199] = {.lex_state = 211},
  [3200] = {.lex_state = 211},
  [3201] = {.lex_state = 209},
  [3202] = {.lex_state = 253},
  [3203] = {.lex_state = 253},
  [3204] = {.lex_state = 211},
  [3205] = {.lex_state = 211},
  [3206] = {.lex_state = 211},
  [3207] = {.lex_state = 254},
  [3208] = {.lex_state = 254},
  [3209] = {.lex_state = 211},
  [3210] = {.lex_state = 191},
  [3211] = {.lex_state = 211},
  [3212] = {.lex_state = 211},
  [3213] = {.lex_state = 211},
  [3214] = {.lex_state = 211},
  [3215] = {.lex_state = 253},
  [3216] = {.lex_state = 211},
  [3217] = {.lex_state = 211},
  [3218] = {.lex_state = 211},
  [3219] = {.lex_state = 211},
  [3220] = {.lex_state = 211},
  [3221] = {.lex_state = 197},
  [3222] = {.lex_state = 191},
  [3223] = {.lex_state = 191},
  [3224] = {.lex_state = 217},
  [3225] = {.lex_state = 217},
  [3226] = {.lex_state = 217},
  [3227] = {.lex_state = 211},
  [3228] = {.lex_state = 211},
  [3229] = {.lex_state = 211},
  [3230] = {.lex_state = 211},
  [3231] = {.lex_state = 217},
  [3232] = {.lex_state = 211},
  [3233] = {.lex_state = 211},
  [3234] = {.lex_state = 211},
  [3235] = {.lex_state = 211},
  [3236] = {.lex_state = 211},
  [3237] = {.lex_state = 217},
  [3238] = {.lex_state = 211},
  [3239] = {.lex_state = 209},
  [3240] = {.lex_state = 217},
  [3241] = {.lex_state = 199},
  [3242] = {.lex_state = 191},
  [3243] = {.lex_state = 199},
  [3244] = {.lex_state = 191},
  [3245] = {.lex_state = 211},
  [3246] = {.lex_state = 211},
  [3247] = {.lex_state = 211},
  [3248] = {.lex_state = 211},
  [3249] = {.lex_state = 211},
  [3250] = {.lex_state = 211},
  [3251] = {.lex_state = 211},
  [3252] = {.lex_state = 209},
  [3253] = {.lex_state = 211},
  [3254] = {.lex_state = 211},
  [3255] = {.lex_state = 197},
  [3256] = {.lex_state = 208},
  [3257] = {.lex_state = 211},
  [3258] = {.lex_state = 193},
  [3259] = {.lex_state = 237},
  [3260] = {.lex_state = 209},
  [3261] = {.lex_state = 203},
  [3262] = {.lex_state = 211},
  [3263] = {.lex_state = 211},
  [3264] = {.lex_state = 211},
  [3265] = {.lex_state = 211},
  [3266] = {.lex_state = 211},
  [3267] = {.lex_state = 209},
  [3268] = {.lex_state = 203},
  [3269] = {.lex_state = 193},
  [3270] = {.lex_state = 211},
  [3271] = {.lex_state = 209},
  [3272] = {.lex_state = 211},
  [3273] = {.lex_state = 209},
  [3274] = {.lex_state = 209},
  [3275] = {.lex_state = 211},
  [3276] = {.lex_state = 203},
  [3277] = {.lex_state = 209},
  [3278] = {.lex_state = 208},
  [3279] = {.lex_state = 201},
  [3280] = {.lex_state = 193},
  [3281] = {.lex_state = 201},
  [3282] = {.lex_state = 209},
  [3283] = {.lex_state = 191},
  [3284] = {.lex_state = 211},
  [3285] = {.lex_state = 209},
  [3286] = {.lex_state = 191},
  [3287] = {.lex_state = 211},
  [3288] = {.lex_state = 211},
  [3289] = {.lex_state = 211},
  [3290] = {.lex_state = 193},
  [3291] = {.lex_state = 209},
  [3292] = {.lex_state = 209},
  [3293] = {.lex_state = 211},
  [3294] = {.lex_state = 251},
  [3295] = {.lex_state = 240},
  [3296] = {.lex_state = 240},
  [3297] = {.lex_state = 240},
  [3298] = {.lex_state = 240},
  [3299] = {.lex_state = 240},
  [3300] = {.lex_state = 240},
  [3301] = {.lex_state = 191},
  [3302] = {.lex_state = 240},
  [3303] = {.lex_state = 240},
  [3304] = {.lex_state = 240},
  [3305] = {.lex_state = 240},
  [3306] = {.lex_state = 240},
  [3307] = {.lex_state = 240},
  [3308] = {.lex_state = 240},
  [3309] = {.lex_state = 240},
  [3310] = {.lex_state = 240},
  [3311] = {.lex_state = 211},
  [3312] = {.lex_state = 209},
  [3313] = {.lex_state = 211},
  [3314] = {.lex_state = 211},
  [3315] = {.lex_state = 209},
  [3316] = {.lex_state = 211},
  [3317] = {.lex_state = 211},
  [3318] = {.lex_state = 191},
  [3319] = {.lex_state = 211},
  [3320] = {.lex_state = 193},
  [3321] = {.lex_state = 209},
  [3322] = {.lex_state = 221},
  [3323] = {.lex_state = 211},
  [3324] = {.lex_state = 193},
  [3325] = {.lex_state = 208},
  [3326] = {.lex_state = 242},
  [3327] = {.lex_state = 242},
  [3328] = {.lex_state = 222},
  [3329] = {.lex_state = 208},
  [3330] = {.lex_state = 208},
  [3331] = {.lex_state = 193},
  [3332] = {.lex_state = 208},
  [3333] = {.lex_state = 193},
  [3334] = {.lex_state = 208},
  [3335] = {.lex_state = 193},
  [3336] = {.lex_state = 199},
  [3337] = {.lex_state = 199},
  [3338] = {.lex_state = 209},
  [3339] = {.lex_state = 211},
  [3340] = {.lex_state = 199},
  [3341] = {.lex_state = 209},
  [3342] = {.lex_state = 237},
  [3343] = {.lex_state = 211},
  [3344] = {.lex_state = 211},
  [3345] = {.lex_state = 193},
  [3346] = {.lex_state = 199},
  [3347] = {.lex_state = 211},
  [3348] = {.lex_state = 211},
  [3349] = {.lex_state = 193},
  [3350] = {.lex_state = 208},
  [3351] = {.lex_state = 211},
  [3352] = {.lex_state = 211},
  [3353] = {.lex_state = 208},
  [3354] = {.lex_state = 214},
  [3355] = {.lex_state = 208},
  [3356] = {.lex_state = 242},
  [3357] = {.lex_state = 193},
  [3358] = {.lex_state = 229},
  [3359] = {.lex_state = 209},
  [3360] = {.lex_state = 211},
  [3361] = {.lex_state = 211},
  [3362] = {.lex_state = 193},
  [3363] = {.lex_state = 199},
  [3364] = {.lex_state = 208},
  [3365] = {.lex_state = 199},
  [3366] = {.lex_state = 199},
  [3367] = {.lex_state = 254},
  [3368] = {.lex_state = 203},
  [3369] = {.lex_state = 209},
  [3370] = {.lex_state = 208},
  [3371] = {.lex_state = 254},
  [3372] = {.lex_state = 209},
  [3373] = {.lex_state = 242},
  [3374] = {.lex_state = 199},
  [3375] = {.lex_state = 211},
  [3376] = {.lex_state = 208},
  [3377] = {.lex_state = 228},
  [3378] = {.lex_state = 211},
  [3379] = {.lex_state = 208},
  [3380] = {.lex_state = 211},
  [3381] = {.lex_state = 211},
  [3382] = {.lex_state = 211},
  [3383] = {.lex_state = 221},
  [3384] = {.lex_state = 211},
  [3385] = {.lex_state = 221},
  [3386] = {.lex_state = 211},
  [3387] = {.lex_state = 211},
  [3388] = {.lex_state = 211},
  [3389] = {.lex_state = 211},
  [3390] = {.lex_state = 211},
  [3391] = {.lex_state = 221},
  [3392] = {.lex_state = 221},
  [3393] = {.lex_state = 221},
  [3394] = {.lex_state = 211},
  [3395] = {.lex_state = 221},
  [3396] = {.lex_state = 211},
  [3397] = {.lex_state = 221},
  [3398] = {.lex_state = 211},
  [3399] = {.lex_state = 211},
  [3400] = {.lex_state = 199},
  [3401] = {.lex_state = 211},
  [3402] = {.lex_state = 211},
  [3403] = {.lex_state = 211},
  [3404] = {.lex_state = 199},
  [3405] = {.lex_state = 221},
  [3406] = {.lex_state = 211},
  [3407] = {.lex_state = 211},
  [3408] = {.lex_state = 211},
  [3409] = {.lex_state = 211},
  [3410] = {.lex_state = 211},
  [3411] = {.lex_state = 211},
  [3412] = {.lex_state = 211},
  [3413] = {.lex_state = 211},
  [3414] = {.lex_state = 211},
  [3415] = {.lex_state = 211},
  [3416] = {.lex_state = 211},
  [3417] = {.lex_state = 199},
  [3418] = {.lex_state = 211},
  [3419] = {.lex_state = 211},
  [3420] = {.lex_state = 211},
  [3421] = {.lex_state = 211},
  [3422] = {.lex_state = 221},
  [3423] = {.lex_state = 211},
  [3424] = {.lex_state = 211},
  [3425] = {.lex_state = 211},
  [3426] = {.lex_state = 211},
  [3427] = {.lex_state = 211},
  [3428] = {.lex_state = 211},
  [3429] = {.lex_state = 221},
  [3430] = {.lex_state = 211},
  [3431] = {.lex_state = 211},
  [3432] = {.lex_state = 211},
  [3433] = {.lex_state = 211},
  [3434] = {.lex_state = 211},
  [3435] = {.lex_state = 211},
  [3436] = {.lex_state = 211},
  [3437] = {.lex_state = 253},
  [3438] = {.lex_state = 211},
  [3439] = {.lex_state = 221},
  [3440] = {.lex_state = 211},
  [3441] = {.lex_state = 211},
  [3442] = {.lex_state = 211},
  [3443] = {.lex_state = 203},
  [3444] = {.lex_state = 199},
  [3445] = {.lex_state = 211},
  [3446] = {.lex_state = 221},
  [3447] = {.lex_state = 211},
  [3448] = {.lex_state = 237},
  [3449] = {.lex_state = 211},
  [3450] = {.lex_state = 211},
  [3451] = {.lex_state = 221},
  [3452] = {.lex_state = 211},
  [3453] = {.lex_state = 221},
  [3454] = {.lex_state = 211},
  [3455] = {.lex_state = 211},
  [3456] = {.lex_state = 211},
  [3457] = {.lex_state = 211},
  [3458] = {.lex_state = 211},
  [3459] = {.lex_state = 237},
  [3460] = {.lex_state = 211},
  [3461] = {.lex_state = 211},
  [3462] = {.lex_state = 203},
  [3463] = {.lex_state = 203},
  [3464] = {.lex_state = 211},
  [3465] = {.lex_state = 211},
  [3466] = {.lex_state = 211},
  [3467] = {.lex_state = 211},
  [3468] = {.lex_state = 211},
  [3469] = {.lex_state = 211},
  [3470] = {.lex_state = 211},
  [3471] = {.lex_state = 211},
  [3472] = {.lex_state = 221},
  [3473] = {.lex_state = 211},
  [3474] = {.lex_state = 211},
  [3475] = {.lex_state = 211},
  [3476] = {.lex_state = 211},
  [3477] = {.lex_state = 211},
  [3478] = {.lex_state = 211},
  [3479] = {.lex_state = 211},
  [3480] = {.lex_state = 203},
  [3481] = {.lex_state = 253},
  [3482] = {.lex_state = 203},
  [3483] = {.lex_state = 222},
  [3484] = {.lex_state = 239},
  [3485] = {.lex_state = 228},
  [3486] = {.lex_state = 239},
  [3487] = {.lex_state = 222},
  [3488] = {.lex_state = 222},
  [3489] = {.lex_state = 239},
  [3490] = {.lex_state = 221},
  [3491] = {.lex_state = 221},
  [3492] = {.lex_state = 221},
  [3493] = {.lex_state = 237},
  [3494] = {.lex_state = 221},
  [3495] = {.lex_state = 221},
  [3496] = {.lex_state = 203},
  [3497] = {.lex_state = 203},
  [3498] = {.lex_state = 228},
  [3499] = {.lex_state = 221},
  [3500] = {.lex_state = 199},
  [3501] = {.lex_state = 221},
  [3502] = {.lex_state = 221},
  [3503] = {.lex_state = 237},
  [3504] = {.lex_state = 228},
  [3505] = {.lex_state = 203},
  [3506] = {.lex_state = 228},
  [3507] = {.lex_state = 228},
  [3508] = {.lex_state = 228},
  [3509] = {.lex_state = 228},
  [3510] = {.lex_state = 228},
  [3511] = {.lex_state = 228},
  [3512] = {.lex_state = 228},
  [3513] = {.lex_state = 228},
  [3514] = {.lex_state = 228},
  [3515] = {.lex_state = 221},
  [3516] = {.lex_state = 228},
  [3517] = {.lex_state = 228},
  [3518] = {.lex_state = 228},
  [3519] = {.lex_state = 222},
  [3520] = {.lex_state = 211},
  [3521] = {.lex_state = 211},
  [3522] = {.lex_state = 228},
  [3523] = {.lex_state = 222},
  [3524] = {.lex_state = 229},
  [3525] = {.lex_state = 229},
  [3526] = {.lex_state = 195},
  [3527] = {.lex_state = 195},
  [3528] = {.lex_state = 228},
  [3529] = {.lex_state = 253},
  [3530] = {.lex_state = 253},
  [3531] = {.lex_state = 195},
  [3532] = {.lex_state = 199},
  [3533] = {.lex_state = 228},
  [3534] = {.lex_state = 199},
  [3535] = {.lex_state = 221},
  [3536] = {.lex_state = 199},
  [3537] = {.lex_state = 199},
  [3538] = {.lex_state = 228},
  [3539] = {.lex_state = 228},
  [3540] = {.lex_state = 254},
  [3541] = {.lex_state = 221},
  [3542] = {.lex_state = 221},
  [3543] = {.lex_state = 221},
  [3544] = {.lex_state = 221},
  [3545] = {.lex_state = 221},
  [3546] = {.lex_state = 221},
  [3547] = {.lex_state = 228},
  [3548] = {.lex_state = 221},
  [3549] = {.lex_state = 199},
  [3550] = {.lex_state = 221},
  [3551] = {.lex_state = 254},
  [3552] = {.lex_state = 199},
  [3553] = {.lex_state = 221},
  [3554] = {.lex_state = 229},
  [3555] = {.lex_state = 221},
  [3556] = {.lex_state = 221},
  [3557] = {.lex_state = 208},
  [3558] = {.lex_state = 221},
  [3559] = {.lex_state = 221},
  [3560] = {.lex_state = 208},
  [3561] = {.lex_state = 221},
  [3562] = {.lex_state = 221},
  [3563] = {.lex_state = 199},
  [3564] = {.lex_state = 199},
  [3565] = {.lex_state = 221},
  [3566] = {.lex_state = 221},
  [3567] = {.lex_state = 221},
  [3568] = {.lex_state = 253},
  [3569] = {.lex_state = 221},
  [3570] = {.lex_state = 221},
  [3571] = {.lex_state = 221},
  [3572] = {.lex_state = 221},
  [3573] = {.lex_state = 221},
  [3574] = {.lex_state = 221},
  [3575] = {.lex_state = 221},
  [3576] = {.lex_state = 221},
  [3577] = {.lex_state = 221},
  [3578] = {.lex_state = 221},
  [3579] = {.lex_state = 221},
  [3580] = {.lex_state = 221},
  [3581] = {.lex_state = 221},
  [3582] = {.lex_state = 221},
  [3583] = {.lex_state = 221},
  [3584] = {.lex_state = 221},
  [3585] = {.lex_state = 221},
  [3586] = {.lex_state = 253},
  [3587] = {.lex_state = 222},
  [3588] = {.lex_state = 221},
  [3589] = {.lex_state = 221},
  [3590] = {.lex_state = 254},
  [3591] = {.lex_state = 222},
  [3592] = {.lex_state = 221},
  [3593] = {.lex_state = 237},
  [3594] = {.lex_state = 221},
  [3595] = {.lex_state = 221},
  [3596] = {.lex_state = 221},
  [3597] = {.lex_state = 240},
  [3598] = {.lex_state = 221},
  [3599] = {.lex_state = 221},
  [3600] = {.lex_state = 237},
  [3601] = {.lex_state = 221},
  [3602] = {.lex_state = 221},
  [3603] = {.lex_state = 221},
  [3604] = {.lex_state = 228},
  [3605] = {.lex_state = 221},
  [3606] = {.lex_state = 253},
  [3607] = {.lex_state = 228},
  [3608] = {.lex_state = 254},
  [3609] = {.lex_state = 221},
  [3610] = {.lex_state = 221},
  [3611] = {.lex_state = 221},
  [3612] = {.lex_state = 188},
  [3613] = {.lex_state = 253},
  [3614] = {.lex_state = 188},
  [3615] = {.lex_state = 208},
  [3616] = {.lex_state = 254},
  [3617] = {.lex_state = 209},
  [3618] = {.lex_state = 209},
  [3619] = {.lex_state = 209},
  [3620] = {.lex_state = 221},
  [3621] = {.lex_state = 228},
  [3622] = {.lex_state = 228},
  [3623] = {.lex_state = 254},
  [3624] = {.lex_state = 208},
  [3625] = {.lex_state = 208},
  [3626] = {.lex_state = 228},
  [3627] = {.lex_state = 208},
  [3628] = {.lex_state = 208},
  [3629] = {.lex_state = 208},
  [3630] = {.lex_state = 228},
  [3631] = {.lex_state = 228},
  [3632] = {.lex_state = 228},
  [3633] = {.lex_state = 228},
  [3634] = {.lex_state = 228},
  [3635] = {.lex_state = 228},
  [3636] = {.lex_state = 228},
  [3637] = {.lex_state = 228},
  [3638] = {.lex_state = 228},
  [3639] = {.lex_state = 208},
  [3640] = {.lex_state = 209},
  [3641] = {.lex_state = 209},
  [3642] = {.lex_state = 221},
  [3643] = {.lex_state = 209},
  [3644] = {.lex_state = 209},
  [3645] = {.lex_state = 208},
  [3646] = {.lex_state = 195},
  [3647] = {.lex_state = 195},
  [3648] = {.lex_state = 221},
  [3649] = {.lex_state = 228},
  [3650] = {.lex_state = 228},
  [3651] = {.lex_state = 195},
  [3652] = {.lex_state = 221},
  [3653] = {.lex_state = 195},
  [3654] = {.lex_state = 208},
  [3655] = {.lex_state = 208},
  [3656] = {.lex_state = 208},
  [3657] = {.lex_state = 228},
  [3658] = {.lex_state = 208},
  [3659] = {.lex_state = 208},
  [3660] = {.lex_state = 208},
  [3661] = {.lex_state = 208},
  [3662] = {.lex_state = 228},
  [3663] = {.lex_state = 208},
  [3664] = {.lex_state = 208},
  [3665] = {.lex_state = 221},
  [3666] = {.lex_state = 221},
  [3667] = {.lex_state = 208},
  [3668] = {.lex_state = 221},
  [3669] = {.lex_state = 188},
  [3670] = {.lex_state = 188},
  [3671] = {.lex_state = 188},
  [3672] = {.lex_state = 188},
  [3673] = {.lex_state = 228},
  [3674] = {.lex_state = 212},
  [3675] = {.lex_state = 188},
  [3676] = {.lex_state = 254},
  [3677] = {.lex_state = 188},
  [3678] = {.lex_state = 188},
  [3679] = {.lex_state = 188},
  [3680] = {.lex_state = 188},
  [3681] = {.lex_state = 188},
  [3682] = {.lex_state = 188},
  [3683] = {.lex_state = 188},
  [3684] = {.lex_state = 188},
  [3685] = {.lex_state = 188},
  [3686] = {.lex_state = 207},
  [3687] = {.lex_state = 254},
  [3688] = {.lex_state = 188},
  [3689] = {.lex_state = 188},
  [3690] = {.lex_state = 188},
  [3691] = {.lex_state = 188},
  [3692] = {.lex_state = 188},
  [3693] = {.lex_state = 188},
  [3694] = {.lex_state = 188},
  [3695] = {.lex_state = 188},
  [3696] = {.lex_state = 188},
  [3697] = {.lex_state = 228},
  [3698] = {.lex_state = 212},
  [3699] = {.lex_state = 221},
  [3700] = {.lex_state = 228},
  [3701] = {.lex_state = 228},
  [3702] = {.lex_state = 188},
  [3703] = {.lex_state = 188},
  [3704] = {.lex_state = 221},
  [3705] = {.lex_state = 228},
  [3706] = {.lex_state = 188},
  [3707] = {.lex_state = 221},
  [3708] = {.lex_state = 221},
  [3709] = {.lex_state = 228},
  [3710] = {.lex_state = 188},
  [3711] = {.lex_state = 188},
  [3712] = {.lex_state = 221},
  [3713] = {.lex_state = 215},
  [3714] = {.lex_state = 221},
  [3715] = {.lex_state = 221},
  [3716] = {.lex_state = 206},
  [3717] = {.lex_state = 221},
  [3718] = {.lex_state = 221},
  [3719] = {.lex_state = 221},
  [3720] = {.lex_state = 221},
  [3721] = {.lex_state = 221},
  [3722] = {.lex_state = 221},
  [3723] = {.lex_state = 221},
  [3724] = {.lex_state = 221},
  [3725] = {.lex_state = 221},
  [3726] = {.lex_state = 221},
  [3727] = {.lex_state = 254},
  [3728] = {.lex_state = 221},
  [3729] = {.lex_state = 221},
  [3730] = {.lex_state = 221},
  [3731] = {.lex_state = 221},
  [3732] = {.lex_state = 221},
  [3733] = {.lex_state = 212},
  [3734] = {.lex_state = 221},
  [3735] = {.lex_state = 228},
  [3736] = {.lex_state = 221},
  [3737] = {.lex_state = 221},
  [3738] = {.lex_state = 221},
  [3739] = {.lex_state = 221},
  [3740] = {.lex_state = 208},
  [3741] = {.lex_state = 212},
  [3742] = {.lex_state = 221},
  [3743] = {.lex_state = 221},
  [3744] = {.lex_state = 221},
  [3745] = {.lex_state = 221},
  [3746] = {.lex_state = 221},
  [3747] = {.lex_state = 221},
  [3748] = {.lex_state = 221},
  [3749] = {.lex_state = 221},
  [3750] = {.lex_state = 206},
  [3751] = {.lex_state = 208},
  [3752] = {.lex_state = 221},
  [3753] = {.lex_state = 221},
  [3754] = {.lex_state = 221},
  [3755] = {.lex_state = 254},
  [3756] = {.lex_state = 221},
  [3757] = {.lex_state = 208},
  [3758] = {.lex_state = 221},
  [3759] = {.lex_state = 221},
  [3760] = {.lex_state = 221},
  [3761] = {.lex_state = 208},
  [3762] = {.lex_state = 208},
  [3763] = {.lex_state = 208},
  [3764] = {.lex_state = 208},
  [3765] = {.lex_state = 221},
  [3766] = {.lex_state = 221},
  [3767] = {.lex_state = 251},
  [3768] = {.lex_state = 221},
  [3769] = {.lex_state = 208},
  [3770] = {.lex_state = 221},
  [3771] = {.lex_state = 208},
  [3772] = {.lex_state = 208},
  [3773] = {.lex_state = 208},
  [3774] = {.lex_state = 221},
  [3775] = {.lex_state = 208},
  [3776] = {.lex_state = 221},
  [3777] = {.lex_state = 208},
  [3778] = {.lex_state = 221},
  [3779] = {.lex_state = 206},
  [3780] = {.lex_state = 221},
  [3781] = {.lex_state = 208},
  [3782] = {.lex_state = 221},
  [3783] = {.lex_state = 221},
  [3784] = {.lex_state = 221},
  [3785] = {.lex_state = 228},
  [3786] = {.lex_state = 208},
  [3787] = {.lex_state = 221},
  [3788] = {.lex_state = 221},
  [3789] = {.lex_state = 221},
  [3790] = {.lex_state = 207},
  [3791] = {.lex_state = 221},
  [3792] = {.lex_state = 208},
  [3793] = {.lex_state = 206},
  [3794] = {.lex_state = 208},
  [3795] = {.lex_state = 208},
  [3796] = {.lex_state = 221},
  [3797] = {.lex_state = 208},
  [3798] = {.lex_state = 206},
  [3799] = {.lex_state = 206},
  [3800] = {.lex_state = 251},
  [3801] = {.lex_state = 221},
  [3802] = {.lex_state = 221},
  [3803] = {.lex_state = 228},
  [3804] = {.lex_state = 228},
  [3805] = {.lex_state = 228},
  [3806] = {.lex_state = 228},
  [3807] = {.lex_state = 221},
  [3808] = {.lex_state = 253},
  [3809] = {.lex_state = 228},
  [3810] = {.lex_state = 215},
  [3811] = {.lex_state = 228},
  [3812] = {.lex_state = 208},
  [3813] = {.lex_state = 228},
  [3814] = {.lex_state = 228},
  [3815] = {.lex_state = 228},
  [3816] = {.lex_state = 228},
  [3817] = {.lex_state = 228},
  [3818] = {.lex_state = 228},
  [3819] = {.lex_state = 231},
  [3820] = {.lex_state = 228},
  [3821] = {.lex_state = 228},
  [3822] = {.lex_state = 208},
  [3823] = {.lex_state = 208},
  [3824] = {.lex_state = 228},
  [3825] = {.lex_state = 228},
  [3826] = {.lex_state = 208},
  [3827] = {.lex_state = 208},
  [3828] = {.lex_state = 228},
  [3829] = {.lex_state = 228},
  [3830] = {.lex_state = 228},
  [3831] = {.lex_state = 228},
  [3832] = {.lex_state = 208},
  [3833] = {.lex_state = 252},
  [3834] = {.lex_state = 208},
  [3835] = {.lex_state = 228},
  [3836] = {.lex_state = 228},
  [3837] = {.lex_state = 228},
  [3838] = {.lex_state = 228},
  [3839] = {.lex_state = 228},
  [3840] = {.lex_state = 228},
  [3841] = {.lex_state = 221},
  [3842] = {.lex_state = 228},
  [3843] = {.lex_state = 228},
  [3844] = {.lex_state = 195},
  [3845] = {.lex_state = 206},
  [3846] = {.lex_state = 228},
  [3847] = {.lex_state = 221},
  [3848] = {.lex_state = 228},
  [3849] = {.lex_state = 221},
  [3850] = {.lex_state = 208},
  [3851] = {.lex_state = 228},
  [3852] = {.lex_state = 221},
  [3853] = {.lex_state = 206},
  [3854] = {.lex_state = 221},
  [3855] = {.lex_state = 217},
  [3856] = {.lex_state = 237},
  [3857] = {.lex_state = 254},
  [3858] = {.lex_state = 206},
  [3859] = {.lex_state = 231},
  [3860] = {.lex_state = 208},
  [3861] = {.lex_state = 208},
  [3862] = {.lex_state = 208},
  [3863] = {.lex_state = 208},
  [3864] = {.lex_state = 231},
  [3865] = {.lex_state = 208},
  [3866] = {.lex_state = 221},
  [3867] = {.lex_state = 231},
  [3868] = {.lex_state = 231},
  [3869] = {.lex_state = 254},
  [3870] = {.lex_state = 208},
  [3871] = {.lex_state = 221},
  [3872] = {.lex_state = 253},
  [3873] = {.lex_state = 237},
  [3874] = {.lex_state = 228},
  [3875] = {.lex_state = 228},
  [3876] = {.lex_state = 208},
  [3877] = {.lex_state = 208},
  [3878] = {.lex_state = 228},
  [3879] = {.lex_state = 208},
  [3880] = {.lex_state = 221},
  [3881] = {.lex_state = 228},
  [3882] = {.lex_state = 221},
  [3883] = {.lex_state = 254},
  [3884] = {.lex_state = 228},
  [3885] = {.lex_state = 208},
  [3886] = {.lex_state = 252},
  [3887] = {.lex_state = 252},
  [3888] = {.lex_state = 252},
  [3889] = {.lex_state = 217},
  [3890] = {.lex_state = 231},
  [3891] = {.lex_state = 252},
  [3892] = {.lex_state = 221},
  [3893] = {.lex_state = 252},
  [3894] = {.lex_state = 252},
  [3895] = {.lex_state = 252},
  [3896] = {.lex_state = 252},
  [3897] = {.lex_state = 252},
  [3898] = {.lex_state = 253},
  [3899] = {.lex_state = 252},
  [3900] = {.lex_state = 252},
  [3901] = {.lex_state = 252},
  [3902] = {.lex_state = 252},
  [3903] = {.lex_state = 252},
  [3904] = {.lex_state = 252},
  [3905] = {.lex_state = 252},
  [3906] = {.lex_state = 252},
  [3907] = {.lex_state = 252},
  [3908] = {.lex_state = 252},
  [3909] = {.lex_state = 252},
  [3910] = {.lex_state = 252},
  [3911] = {.lex_state = 252},
  [3912] = {.lex_state = 252},
  [3913] = {.lex_state = 252},
  [3914] = {.lex_state = 252},
  [3915] = {.lex_state = 252},
  [3916] = {.lex_state = 252},
  [3917] = {.lex_state = 252},
  [3918] = {.lex_state = 252},
  [3919] = {.lex_state = 230},
  [3920] = {.lex_state = 252},
  [3921] = {.lex_state = 252},
  [3922] = {.lex_state = 252},
  [3923] = {.lex_state = 228},
  [3924] = {.lex_state = 217},
  [3925] = {.lex_state = 231},
  [3926] = {.lex_state = 252},
  [3927] = {.lex_state = 221},
  [3928] = {.lex_state = 253},
  [3929] = {.lex_state = 252},
  [3930] = {.lex_state = 252},
  [3931] = {.lex_state = 252},
  [3932] = {.lex_state = 252},
  [3933] = {.lex_state = 252},
  [3934] = {.lex_state = 252},
  [3935] = {.lex_state = 252},
  [3936] = {.lex_state = 252},
  [3937] = {.lex_state = 252},
  [3938] = {.lex_state = 252},
  [3939] = {.lex_state = 252},
  [3940] = {.lex_state = 252},
  [3941] = {.lex_state = 252},
  [3942] = {.lex_state = 252},
  [3943] = {.lex_state = 252},
  [3944] = {.lex_state = 252},
  [3945] = {.lex_state = 252},
  [3946] = {.lex_state = 252},
  [3947] = {.lex_state = 252},
  [3948] = {.lex_state = 215},
  [3949] = {.lex_state = 252},
  [3950] = {.lex_state = 252},
  [3951] = {.lex_state = 252},
  [3952] = {.lex_state = 252},
  [3953] = {.lex_state = 252},
  [3954] = {.lex_state = 252},
  [3955] = {.lex_state = 252},
  [3956] = {.lex_state = 252},
  [3957] = {.lex_state = 252},
  [3958] = {.lex_state = 252},
  [3959] = {.lex_state = 252},
  [3960] = {.lex_state = 252},
  [3961] = {.lex_state = 252},
  [3962] = {.lex_state = 252},
  [3963] = {.lex_state = 252},
  [3964] = {.lex_state = 252},
  [3965] = {.lex_state = 252},
  [3966] = {.lex_state = 188},
  [3967] = {.lex_state = 253},
  [3968] = {.lex_state = 252},
  [3969] = {.lex_state = 252},
  [3970] = {.lex_state = 252},
  [3971] = {.lex_state = 252},
  [3972] = {.lex_state = 188},
  [3973] = {.lex_state = 217},
  [3974] = {.lex_state = 252},
  [3975] = {.lex_state = 253},
  [3976] = {.lex_state = 252},
  [3977] = {.lex_state = 252},
  [3978] = {.lex_state = 252},
  [3979] = {.lex_state = 252},
  [3980] = {.lex_state = 252},
  [3981] = {.lex_state = 252},
  [3982] = {.lex_state = 252},
  [3983] = {.lex_state = 252},
  [3984] = {.lex_state = 252},
  [3985] = {.lex_state = 252},
  [3986] = {.lex_state = 252},
  [3987] = {.lex_state = 215},
  [3988] = {.lex_state = 252},
  [3989] = {.lex_state = 252},
  [3990] = {.lex_state = 252},
  [3991] = {.lex_state = 252},
  [3992] = {.lex_state = 252},
  [3993] = {.lex_state = 252},
  [3994] = {.lex_state = 252},
  [3995] = {.lex_state = 252},
  [3996] = {.lex_state = 252},
  [3997] = {.lex_state = 253},
  [3998] = {.lex_state = 253},
  [3999] = {.lex_state = 252},
  [4000] = {.lex_state = 252},
  [4001] = {.lex_state = 252},
  [4002] = {.lex_state = 252},
  [4003] = {.lex_state = 252},
  [4004] = {.lex_state = 252},
  [4005] = {.lex_state = 252},
  [4006] = {.lex_state = 252},
  [4007] = {.lex_state = 252},
  [4008] = {.lex_state = 252},
  [4009] = {.lex_state = 252},
  [4010] = {.lex_state = 252},
  [4011] = {.lex_state = 252},
  [4012] = {.lex_state = 252},
  [4013] = {.lex_state = 252},
  [4014] = {.lex_state = 252},
  [4015] = {.lex_state = 252},
  [4016] = {.lex_state = 252},
  [4017] = {.lex_state = 253},
  [4018] = {.lex_state = 252},
  [4019] = {.lex_state = 252},
  [4020] = {.lex_state = 252},
  [4021] = {.lex_state = 252},
  [4022] = {.lex_state = 252},
  [4023] = {.lex_state = 252},
  [4024] = {.lex_state = 252},
  [4025] = {.lex_state = 252},
  [4026] = {.lex_state = 252},
  [4027] = {.lex_state = 221},
  [4028] = {.lex_state = 217},
  [4029] = {.lex_state = 252},
  [4030] = {.lex_state = 252},
  [4031] = {.lex_state = 217},
  [4032] = {.lex_state = 253},
  [4033] = {.lex_state = 217},
  [4034] = {.lex_state = 228},
  [4035] = {.lex_state = 252},
  [4036] = {.lex_state = 252},
  [4037] = {.lex_state = 252},
  [4038] = {.lex_state = 252},
  [4039] = {.lex_state = 252},
  [4040] = {.lex_state = 253},
  [4041] = {.lex_state = 252},
  [4042] = {.lex_state = 207},
  [4043] = {.lex_state = 252},
  [4044] = {.lex_state = 252},
  [4045] = {.lex_state = 252},
  [4046] = {.lex_state = 252},
  [4047] = {.lex_state = 252},
  [4048] = {.lex_state = 208},
  [4049] = {.lex_state = 217},
  [4050] = {.lex_state = 252},
  [4051] = {.lex_state = 252},
  [4052] = {.lex_state = 217},
  [4053] = {.lex_state = 252},
  [4054] = {.lex_state = 252},
  [4055] = {.lex_state = 252},
  [4056] = {.lex_state = 221},
  [4057] = {.lex_state = 252},
  [4058] = {.lex_state = 253},
  [4059] = {.lex_state = 252},
  [4060] = {.lex_state = 252},
  [4061] = {.lex_state = 252},
  [4062] = {.lex_state = 252},
  [4063] = {.lex_state = 252},
  [4064] = {.lex_state = 195},
  [4065] = {.lex_state = 252},
  [4066] = {.lex_state = 217},
  [4067] = {.lex_state = 252},
  [4068] = {.lex_state = 252},
  [4069] = {.lex_state = 252},
  [4070] = {.lex_state = 253},
  [4071] = {.lex_state = 252},
  [4072] = {.lex_state = 252},
  [4073] = {.lex_state = 252},
  [4074] = {.lex_state = 252},
  [4075] = {.lex_state = 252},
  [4076] = {.lex_state = 252},
  [4077] = {.lex_state = 252},
  [4078] = {.lex_state = 252},
  [4079] = {.lex_state = 253},
  [4080] = {.lex_state = 252},
  [4081] = {.lex_state = 253},
  [4082] = {.lex_state = 252},
  [4083] = {.lex_state = 228},
  [4084] = {.lex_state = 252},
  [4085] = {.lex_state = 252},
  [4086] = {.lex_state = 252},
  [4087] = {.lex_state = 252},
  [4088] = {.lex_state = 252},
  [4089] = {.lex_state = 252},
  [4090] = {.lex_state = 252},
  [4091] = {.lex_state = 252},
  [4092] = {.lex_state = 252},
  [4093] = {.lex_state = 221},
  [4094] = {.lex_state = 252},
  [4095] = {.lex_state = 252},
  [4096] = {.lex_state = 252},
  [4097] = {.lex_state = 221},
  [4098] = {.lex_state = 252},
  [4099] = {.lex_state = 252},
  [4100] = {.lex_state = 252},
  [4101] = {.lex_state = 252},
  [4102] = {.lex_state = 252},
  [4103] = {.lex_state = 252},
  [4104] = {.lex_state = 188},
  [4105] = {.lex_state = 252},
  [4106] = {.lex_state = 217},
  [4107] = {.lex_state = 252},
  [4108] = {.lex_state = 252},
  [4109] = {.lex_state = 252},
  [4110] = {.lex_state = 252},
  [4111] = {.lex_state = 252},
  [4112] = {.lex_state = 252},
  [4113] = {.lex_state = 252},
  [4114] = {.lex_state = 252},
  [4115] = {.lex_state = 252},
  [4116] = {.lex_state = 221},
  [4117] = {.lex_state = 252},
  [4118] = {.lex_state = 252},
  [4119] = {.lex_state = 252},
  [4120] = {.lex_state = 254},
  [4121] = {.lex_state = 252},
  [4122] = {.lex_state = 252},
  [4123] = {.lex_state = 252},
  [4124] = {.lex_state = 252},
  [4125] = {.lex_state = 252},
  [4126] = {.lex_state = 252},
  [4127] = {.lex_state = 252},
  [4128] = {.lex_state = 253},
  [4129] = {.lex_state = 252},
  [4130] = {.lex_state = 221},
  [4131] = {.lex_state = 252},
  [4132] = {.lex_state = 252},
  [4133] = {.lex_state = 217},
  [4134] = {.lex_state = 252},
  [4135] = {.lex_state = 221},
  [4136] = {.lex_state = 252},
  [4137] = {.lex_state = 252},
  [4138] = {.lex_state = 252},
  [4139] = {.lex_state = 252},
  [4140] = {.lex_state = 252},
  [4141] = {.lex_state = 252},
  [4142] = {.lex_state = 252},
  [4143] = {.lex_state = 252},
  [4144] = {.lex_state = 252},
  [4145] = {.lex_state = 252},
  [4146] = {.lex_state = 252},
  [4147] = {.lex_state = 252},
  [4148] = {.lex_state = 252},
  [4149] = {.lex_state = 252},
  [4150] = {.lex_state = 252},
  [4151] = {.lex_state = 217},
  [4152] = {.lex_state = 252},
  [4153] = {.lex_state = 188},
  [4154] = {.lex_state = 252},
  [4155] = {.lex_state = 228},
  [4156] = {.lex_state = 252},
  [4157] = {.lex_state = 221},
  [4158] = {.lex_state = 252},
  [4159] = {.lex_state = 252},
  [4160] = {.lex_state = 252},
  [4161] = {.lex_state = 188},
  [4162] = {.lex_state = 252},
  [4163] = {.lex_state = 212},
  [4164] = {.lex_state = 252},
  [4165] = {.lex_state = 252},
  [4166] = {.lex_state = 252},
  [4167] = {.lex_state = 252},
  [4168] = {.lex_state = 255},
  [4169] = {.lex_state = 252},
  [4170] = {.lex_state = 252},
  [4171] = {.lex_state = 188},
  [4172] = {.lex_state = 254},
  [4173] = {.lex_state = 206},
  [4174] = {.lex_state = 252},
  [4175] = {.lex_state = 221},
  [4176] = {.lex_state = 221},
  [4177] = {.lex_state = 252},
  [4178] = {.lex_state = 252},
  [4179] = {.lex_state = 252},
  [4180] = {.lex_state = 252},
  [4181] = {.lex_state = 252},
  [4182] = {.lex_state = 252},
  [4183] = {.lex_state = 188},
  [4184] = {.lex_state = 252},
  [4185] = {.lex_state = 252},
  [4186] = {.lex_state = 252},
  [4187] = {.lex_state = 252},
  [4188] = {.lex_state = 252},
  [4189] = {.lex_state = 252},
  [4190] = {.lex_state = 252},
  [4191] = {.lex_state = 217},
  [4192] = {.lex_state = 252},
  [4193] = {.lex_state = 252},
  [4194] = {.lex_state = 253},
  [4195] = {.lex_state = 252},
  [4196] = {.lex_state = 252},
  [4197] = {.lex_state = 252},
  [4198] = {.lex_state = 252},
  [4199] = {.lex_state = 252},
  [4200] = {.lex_state = 252},
  [4201] = {.lex_state = 252},
  [4202] = {.lex_state = 252},
  [4203] = {.lex_state = 221},
  [4204] = {.lex_state = 252},
  [4205] = {.lex_state = 252},
  [4206] = {.lex_state = 252},
  [4207] = {.lex_state = 252},
  [4208] = {.lex_state = 195},
  [4209] = {.lex_state = 252},
  [4210] = {.lex_state = 252},
  [4211] = {.lex_state = 252},
  [4212] = {.lex_state = 253},
  [4213] = {.lex_state = 252},
  [4214] = {.lex_state = 252},
  [4215] = {.lex_state = 252},
  [4216] = {.lex_state = 228},
  [4217] = {.lex_state = 221},
  [4218] = {.lex_state = 252},
  [4219] = {.lex_state = 221},
  [4220] = {.lex_state = 252},
  [4221] = {.lex_state = 221},
  [4222] = {.lex_state = 252},
  [4223] = {.lex_state = 252},
  [4224] = {.lex_state = 252},
  [4225] = {.lex_state = 252},
  [4226] = {.lex_state = 252},
  [4227] = {.lex_state = 253},
  [4228] = {.lex_state = 252},
  [4229] = {.lex_state = 221},
  [4230] = {.lex_state = 252},
  [4231] = {.lex_state = 253},
  [4232] = {.lex_state = 252},
  [4233] = {.lex_state = 252},
  [4234] = {.lex_state = 252},
  [4235] = {.lex_state = 252},
  [4236] = {.lex_state = 252},
  [4237] = {.lex_state = 252},
  [4238] = {.lex_state = 221},
  [4239] = {.lex_state = 252},
  [4240] = {.lex_state = 221},
  [4241] = {.lex_state = 252},
  [4242] = {.lex_state = 252},
  [4243] = {.lex_state = 195},
  [4244] = {.lex_state = 188},
  [4245] = {.lex_state = 252},
  [4246] = {.lex_state = 221},
  [4247] = {.lex_state = 221},
  [4248] = {.lex_state = 252},
  [4249] = {.lex_state = 221},
  [4250] = {.lex_state = 207},
  [4251] = {.lex_state = 252},
  [4252] = {.lex_state = 252},
  [4253] = {.lex_state = 252},
  [4254] = {.lex_state = 221},
  [4255] = {.lex_state = 252},
  [4256] = {.lex_state = 253},
  [4257] = {.lex_state = 221},
  [4258] = {.lex_state = 253},
  [4259] = {.lex_state = 195},
  [4260] = {.lex_state = 253},
  [4261] = {.lex_state = 252},
  [4262] = {.lex_state = 221},
  [4263] = {.lex_state = 252},
  [4264] = {.lex_state = 188},
  [4265] = {.lex_state = 254},
  [4266] = {.lex_state = 221},
  [4267] = {.lex_state = 217},
  [4268] = {.lex_state = 252},
  [4269] = {.lex_state = 252},
  [4270] = {.lex_state = 223},
  [4271] = {.lex_state = 188},
  [4272] = {.lex_state = 217},
  [4273] = {.lex_state = 254},
  [4274] = {.lex_state = 252},
  [4275] = {.lex_state = 252},
  [4276] = {.lex_state = 252},
  [4277] = {.lex_state = 217},
  [4278] = {.lex_state = 252},
  [4279] = {.lex_state = 253},
  [4280] = {.lex_state = 217},
  [4281] = {.lex_state = 212},
  [4282] = {.lex_state = 252},
  [4283] = {.lex_state = 253},
  [4284] = {.lex_state = 221},
  [4285] = {.lex_state = 252},
  [4286] = {.lex_state = 252},
  [4287] = {.lex_state = 252},
  [4288] = {.lex_state = 221},
  [4289] = {.lex_state = 252},
  [4290] = {.lex_state = 252},
  [4291] = {.lex_state = 252},
  [4292] = {.lex_state = 252},
  [4293] = {.lex_state = 252},
  [4294] = {.lex_state = 252},
  [4295] = {.lex_state = 253},
  [4296] = {.lex_state = 252},
  [4297] = {.lex_state = 252},
  [4298] = {.lex_state = 252},
  [4299] = {.lex_state = 252},
  [4300] = {.lex_state = 252},
  [4301] = {.lex_state = 252},
  [4302] = {.lex_state = 252},
  [4303] = {.lex_state = 221},
  [4304] = {.lex_state = 221},
  [4305] = {.lex_state = 221},
  [4306] = {.lex_state = 206},
  [4307] = {.lex_state = 211},
  [4308] = {.lex_state = 217},
  [4309] = {.lex_state = 228},
  [4310] = {.lex_state = 228},
  [4311] = {.lex_state = 228},
  [4312] = {.lex_state = 207},
  [4313] = {.lex_state = 228},
  [4314] = {.lex_state = 237},
  [4315] = {.lex_state = 208},
  [4316] = {.lex_state = 207},
  [4317] = {.lex_state = 207},
  [4318] = {.lex_state = 252},
  [4319] = {.lex_state = 221},
  [4320] = {.lex_state = 221},
  [4321] = {.lex_state = 206},
  [4322] = {.lex_state = 221},
  [4323] = {.lex_state = 237},
  [4324] = {.lex_state = 221},
  [4325] = {.lex_state = 221},
  [4326] = {.lex_state = 221},
  [4327] = {.lex_state = 221},
  [4328] = {.lex_state = 221},
  [4329] = {.lex_state = 221},
  [4330] = {.lex_state = 237},
  [4331] = {.lex_state = 254},
  [4332] = {.lex_state = 221},
  [4333] = {.lex_state = 207},
  [4334] = {.lex_state = 228},
  [4335] = {.lex_state = 206},
  [4336] = {.lex_state = 206},
  [4337] = {.lex_state = 206},
  [4338] = {.lex_state = 225},
  [4339] = {.lex_state = 221},
  [4340] = {.lex_state = 221},
  [4341] = {.lex_state = 221},
  [4342] = {.lex_state = 221},
  [4343] = {.lex_state = 182},
  [4344] = {.lex_state = 221},
  [4345] = {.lex_state = 252},
  [4346] = {.lex_state = 206},
  [4347] = {.lex_state = 221},
  [4348] = {.lex_state = 221},
  [4349] = {.lex_state = 221},
  [4350] = {.lex_state = 182},
  [4351] = {.lex_state = 206},
  [4352] = {.lex_state = 228},
  [4353] = {.lex_state = 221},
  [4354] = {.lex_state = 221},
  [4355] = {.lex_state = 221},
  [4356] = {.lex_state = 206},
  [4357] = {.lex_state = 221},
  [4358] = {.lex_state = 221},
  [4359] = {.lex_state = 221},
  [4360] = {.lex_state = 221},
  [4361] = {.lex_state = 221},
  [4362] = {.lex_state = 221},
  [4363] = {.lex_state = 208},
  [4364] = {.lex_state = 221},
  [4365] = {.lex_state = 215},
  [4366] = {.lex_state = 221},
  [4367] = {.lex_state = 207},
  [4368] = {.lex_state = 228},
  [4369] = {.lex_state = 215},
  [4370] = {.lex_state = 221},
  [4371] = {.lex_state = 221},
  [4372] = {.lex_state = 221},
  [4373] = {.lex_state = 221},
  [4374] = {.lex_state = 221},
  [4375] = {.lex_state = 221},
  [4376] = {.lex_state = 221},
  [4377] = {.lex_state = 206},
  [4378] = {.lex_state = 182},
  [4379] = {.lex_state = 252},
  [4380] = {.lex_state = 221},
  [4381] = {.lex_state = 221},
  [4382] = {.lex_state = 188},
  [4383] = {.lex_state = 252},
  [4384] = {.lex_state = 227},
  [4385] = {.lex_state = 221},
  [4386] = {.lex_state = 221},
  [4387] = {.lex_state = 206},
  [4388] = {.lex_state = 254},
  [4389] = {.lex_state = 254},
  [4390] = {.lex_state = 221},
  [4391] = {.lex_state = 182},
  [4392] = {.lex_state = 252},
  [4393] = {.lex_state = 206},
  [4394] = {.lex_state = 221},
  [4395] = {.lex_state = 207},
  [4396] = {.lex_state = 182},
  [4397] = {.lex_state = 252},
  [4398] = {.lex_state = 208},
  [4399] = {.lex_state = 221},
  [4400] = {.lex_state = 182},
  [4401] = {.lex_state = 252},
  [4402] = {.lex_state = 225},
  [4403] = {.lex_state = 221},
  [4404] = {.lex_state = 206},
  [4405] = {.lex_state = 206},
  [4406] = {.lex_state = 206},
  [4407] = {.lex_state = 252},
  [4408] = {.lex_state = 206},
  [4409] = {.lex_state = 221},
  [4410] = {.lex_state = 206},
  [4411] = {.lex_state = 206},
  [4412] = {.lex_state = 252},
  [4413] = {.lex_state = 206},
  [4414] = {.lex_state = 221},
  [4415] = {.lex_state = 252},
  [4416] = {.lex_state = 221},
  [4417] = {.lex_state = 252},
  [4418] = {.lex_state = 252},
  [4419] = {.lex_state = 228},
  [4420] = {.lex_state = 252},
  [4421] = {.lex_state = 252},
  [4422] = {.lex_state = 252},
  [4423] = {.lex_state = 217},
  [4424] = {.lex_state = 252},
  [4425] = {.lex_state = 252},
  [4426] = {.lex_state = 252},
  [4427] = {.lex_state = 252},
  [4428] = {.lex_state = 252},
  [4429] = {.lex_state = 252},
  [4430] = {.lex_state = 252},
  [4431] = {.lex_state = 221},
  [4432] = {.lex_state = 252},
  [4433] = {.lex_state = 221},
  [4434] = {.lex_state = 208},
  [4435] = {.lex_state = 228},
  [4436] = {.lex_state = 228},
  [4437] = {.lex_state = 252},
  [4438] = {.lex_state = 228},
  [4439] = {.lex_state = 228},
  [4440] = {.lex_state = 206},
  [4441] = {.lex_state = 228},
  [4442] = {.lex_state = 228},
  [4443] = {.lex_state = 252},
  [4444] = {.lex_state = 251},
  [4445] = {.lex_state = 251},
  [4446] = {.lex_state = 237},
  [4447] = {.lex_state = 252},
  [4448] = {.lex_state = 252},
  [4449] = {.lex_state = 252},
  [4450] = {.lex_state = 252},
  [4451] = {.lex_state = 252},
  [4452] = {.lex_state = 206},
  [4453] = {.lex_state = 206},
  [4454] = {.lex_state = 228},
  [4455] = {.lex_state = 206},
  [4456] = {.lex_state = 206},
  [4457] = {.lex_state = 206},
  [4458] = {.lex_state = 206},
  [4459] = {.lex_state = 228},
  [4460] = {.lex_state = 206},
  [4461] = {.lex_state = 215},
  [4462] = {.lex_state = 228},
  [4463] = {.lex_state = 228},
  [4464] = {.lex_state = 237},
  [4465] = {.lex_state = 228},
  [4466] = {.lex_state = 228},
  [4467] = {.lex_state = 228},
  [4468] = {.lex_state = 228},
  [4469] = {.lex_state = 228},
  [4470] = {.lex_state = 228},
  [4471] = {.lex_state = 228},
  [4472] = {.lex_state = 228},
  [4473] = {.lex_state = 228},
  [4474] = {.lex_state = 221},
  [4475] = {.lex_state = 228},
  [4476] = {.lex_state = 211},
  [4477] = {.lex_state = 211},
  [4478] = {.lex_state = 211},
  [4479] = {.lex_state = 211},
  [4480] = {.lex_state = 211},
  [4481] = {.lex_state = 211},
  [4482] = {.lex_state = 211},
  [4483] = {.lex_state = 211},
  [4484] = {.lex_state = 211},
  [4485] = {.lex_state = 211},
  [4486] = {.lex_state = 211},
  [4487] = {.lex_state = 211},
  [4488] = {.lex_state = 211},
  [4489] = {.lex_state = 211},
  [4490] = {.lex_state = 211},
  [4491] = {.lex_state = 211},
  [4492] = {.lex_state = 211},
  [4493] = {.lex_state = 211},
  [4494] = {.lex_state = 211},
  [4495] = {.lex_state = 211},
  [4496] = {.lex_state = 211},
  [4497] = {.lex_state = 211},
  [4498] = {.lex_state = 211},
  [4499] = {.lex_state = 207},
  [4500] = {.lex_state = 206},
  [4501] = {.lex_state = 206},
  [4502] = {.lex_state = 206},
  [4503] = {.lex_state = 254},
  [4504] = {.lex_state = 217},
  [4505] = {.lex_state = 211},
  [4506] = {.lex_state = 228},
  [4507] = {.lex_state = 217},
  [4508] = {.lex_state = 217},
  [4509] = {.lex_state = 217},
  [4510] = {.lex_state = 217},
  [4511] = {.lex_state = 217},
  [4512] = {.lex_state = 217},
  [4513] = {.lex_state = 217},
  [4514] = {.lex_state = 217},
  [4515] = {.lex_state = 217},
  [4516] = {.lex_state = 217},
  [4517] = {.lex_state = 252},
  [4518] = {.lex_state = 231},
  [4519] = {.lex_state = 221},
  [4520] = {.lex_state = 195},
  [4521] = {.lex_state = 231},
  [4522] = {.lex_state = 215},
  [4523] = {.lex_state = 221},
  [4524] = {.lex_state = 221},
  [4525] = {.lex_state = 221},
  [4526] = {.lex_state = 221},
  [4527] = {.lex_state = 221},
  [4528] = {.lex_state = 221},
  [4529] = {.lex_state = 221},
  [4530] = {.lex_state = 231},
  [4531] = {.lex_state = 235},
  [4532] = {.lex_state = 205},
  [4533] = {.lex_state = 221},
  [4534] = {.lex_state = 231},
  [4535] = {.lex_state = 231},
  [4536] = {.lex_state = 215},
  [4537] = {.lex_state = 215},
  [4538] = {.lex_state = 231},
  [4539] = {.lex_state = 221},
  [4540] = {.lex_state = 221},
  [4541] = {.lex_state = 195},
  [4542] = {.lex_state = 221},
  [4543] = {.lex_state = 233},
  [4544] = {.lex_state = 195},
  [4545] = {.lex_state = 231},
  [4546] = {.lex_state = 231},
  [4547] = {.lex_state = 231},
  [4548] = {.lex_state = 231},
  [4549] = {.lex_state = 221},
  [4550] = {.lex_state = 221},
  [4551] = {.lex_state = 221},
  [4552] = {.lex_state = 221},
  [4553] = {.lex_state = 228},
  [4554] = {.lex_state = 221},
  [4555] = {.lex_state = 221},
  [4556] = {.lex_state = 221},
  [4557] = {.lex_state = 215},
  [4558] = {.lex_state = 221},
  [4559] = {.lex_state = 215},
  [4560] = {.lex_state = 215},
  [4561] = {.lex_state = 221},
  [4562] = {.lex_state = 221},
  [4563] = {.lex_state = 221},
  [4564] = {.lex_state = 221},
  [4565] = {.lex_state = 217},
  [4566] = {.lex_state = 217},
  [4567] = {.lex_state = 205},
  [4568] = {.lex_state = 215},
  [4569] = {.lex_state = 215},
  [4570] = {.lex_state = 221},
  [4571] = {.lex_state = 215},
  [4572] = {.lex_state = 221},
  [4573] = {.lex_state = 221},
  [4574] = {.lex_state = 221},
  [4575] = {.lex_state = 221},
  [4576] = {.lex_state = 221},
  [4577] = {.lex_state = 221},
  [4578] = {.lex_state = 221},
  [4579] = {.lex_state = 221},
  [4580] = {.lex_state = 221},
  [4581] = {.lex_state = 215},
  [4582] = {.lex_state = 215},
  [4583] = {.lex_state = 215},
  [4584] = {.lex_state = 215},
  [4585] = {.lex_state = 207},
  [4586] = {.lex_state = 221},
  [4587] = {.lex_state = 231},
  [4588] = {.lex_state = 221},
  [4589] = {.lex_state = 255},
  [4590] = {.lex_state = 215},
  [4591] = {.lex_state = 215},
  [4592] = {.lex_state = 215},
  [4593] = {.lex_state = 221},
  [4594] = {.lex_state = 221},
  [4595] = {.lex_state = 195},
  [4596] = {.lex_state = 221},
  [4597] = {.lex_state = 215},
  [4598] = {.lex_state = 215},
  [4599] = {.lex_state = 221},
  [4600] = {.lex_state = 228},
  [4601] = {.lex_state = 233},
  [4602] = {.lex_state = 228},
  [4603] = {.lex_state = 221},
  [4604] = {.lex_state = 221},
  [4605] = {.lex_state = 221},
  [4606] = {.lex_state = 221},
  [4607] = {.lex_state = 205},
  [4608] = {.lex_state = 221},
  [4609] = {.lex_state = 221},
  [4610] = {.lex_state = 221},
  [4611] = {.lex_state = 231},
  [4612] = {.lex_state = 221},
  [4613] = {.lex_state = 221},
  [4614] = {.lex_state = 231},
  [4615] = {.lex_state = 221},
  [4616] = {.lex_state = 221},
  [4617] = {.lex_state = 221},
  [4618] = {.lex_state = 215},
  [4619] = {.lex_state = 215},
  [4620] = {.lex_state = 221},
  [4621] = {.lex_state = 195},
  [4622] = {.lex_state = 221},
  [4623] = {.lex_state = 221},
  [4624] = {.lex_state = 221},
  [4625] = {.lex_state = 221},
  [4626] = {.lex_state = 221},
  [4627] = {.lex_state = 231},
  [4628] = {.lex_state = 221},
  [4629] = {.lex_state = 221},
  [4630] = {.lex_state = 221},
  [4631] = {.lex_state = 221},
  [4632] = {.lex_state = 221},
  [4633] = {.lex_state = 231},
  [4634] = {.lex_state = 228},
  [4635] = {.lex_state = 221},
  [4636] = {.lex_state = 221},
  [4637] = {.lex_state = 221},
  [4638] = {.lex_state = 221},
  [4639] = {.lex_state = 231},
  [4640] = {.lex_state = 221},
  [4641] = {.lex_state = 221},
  [4642] = {.lex_state = 221},
  [4643] = {.lex_state = 221},
  [4644] = {.lex_state = 221},
  [4645] = {.lex_state = 221},
  [4646] = {.lex_state = 221},
  [4647] = {.lex_state = 221},
  [4648] = {.lex_state = 221},
  [4649] = {.lex_state = 221},
  [4650] = {.lex_state = 221},
  [4651] = {.lex_state = 221},
  [4652] = {.lex_state = 221},
  [4653] = {.lex_state = 221},
  [4654] = {.lex_state = 221},
  [4655] = {.lex_state = 221},
  [4656] = {.lex_state = 221},
  [4657] = {.lex_state = 221},
  [4658] = {.lex_state = 221},
  [4659] = {.lex_state = 221},
  [4660] = {.lex_state = 228},
  [4661] = {.lex_state = 195},
  [4662] = {.lex_state = 221},
  [4663] = {.lex_state = 215},
  [4664] = {.lex_state = 221},
  [4665] = {.lex_state = 228},
  [4666] = {.lex_state = 228},
  [4667] = {.lex_state = 228},
  [4668] = {.lex_state = 228},
  [4669] = {.lex_state = 228},
  [4670] = {.lex_state = 228},
  [4671] = {.lex_state = 228},
  [4672] = {.lex_state = 228},
  [4673] = {.lex_state = 228},
  [4674] = {.lex_state = 228},
  [4675] = {.lex_state = 208},
  [4676] = {.lex_state = 228},
  [4677] = {.lex_state = 228},
  [4678] = {.lex_state = 228},
  [4679] = {.lex_state = 221},
  [4680] = {.lex_state = 228},
  [4681] = {.lex_state = 228},
  [4682] = {.lex_state = 228},
  [4683] = {.lex_state = 228},
  [4684] = {.lex_state = 228},
  [4685] = {.lex_state = 228},
  [4686] = {.lex_state = 228},
  [4687] = {.lex_state = 228},
  [4688] = {.lex_state = 228},
  [4689] = {.lex_state = 228},
  [4690] = {.lex_state = 228},
  [4691] = {.lex_state = 221},
  [4692] = {.lex_state = 228},
  [4693] = {.lex_state = 228},
  [4694] = {.lex_state = 255},
  [4695] = {.lex_state = 215},
  [4696] = {.lex_state = 215},
  [4697] = {.lex_state = 221},
  [4698] = {.lex_state = 228},
  [4699] = {.lex_state = 217},
  [4700] = {.lex_state = 217},
  [4701] = {.lex_state = 256},
  [4702] = {.lex_state = 256},
  [4703] = {.lex_state = 208},
  [4704] = {.lex_state = 207},
  [4705] = {.lex_state = 228},
  [4706] = {.lex_state = 228},
  [4707] = {.lex_state = 255},
  [4708] = {.lex_state = 228},
  [4709] = {.lex_state = 228},
  [4710] = {.lex_state = 228},
  [4711] = {.lex_state = 228},
  [4712] = {.lex_state = 228},
  [4713] = {.lex_state = 221},
  [4714] = {.lex_state = 221},
  [4715] = {.lex_state = 228},
  [4716] = {.lex_state = 221},
  [4717] = {.lex_state = 228},
  [4718] = {.lex_state = 228},
  [4719] = {.lex_state = 208},
  [4720] = {.lex_state = 228},
  [4721] = {.lex_state = 217},
  [4722] = {.lex_state = 228},
  [4723] = {.lex_state = 195},
  [4724] = {.lex_state = 195},
  [4725] = {.lex_state = 228},
  [4726] = {.lex_state = 228},
  [4727] = {.lex_state = 221},
  [4728] = {.lex_state = 228},
  [4729] = {.lex_state = 228},
  [4730] = {.lex_state = 208},
  [4731] = {.lex_state = 228},
  [4732] = {.lex_state = 228},
  [4733] = {.lex_state = 228},
  [4734] = {.lex_state = 228},
  [4735] = {.lex_state = 228},
  [4736] = {.lex_state = 228},
  [4737] = {.lex_state = 228},
  [4738] = {.lex_state = 228},
  [4739] = {.lex_state = 228},
  [4740] = {.lex_state = 211},
  [4741] = {.lex_state = 228},
  [4742] = {.lex_state = 228},
  [4743] = {.lex_state = 228},
  [4744] = {.lex_state = 211},
  [4745] = {.lex_state = 211},
  [4746] = {.lex_state = 211},
  [4747] = {.lex_state = 211},
  [4748] = {.lex_state = 208},
  [4749] = {.lex_state = 211},
  [4750] = {.lex_state = 228},
  [4751] = {.lex_state = 211},
  [4752] = {.lex_state = 211},
  [4753] = {.lex_state = 221},
  [4754] = {.lex_state = 221},
  [4755] = {.lex_state = 228},
  [4756] = {.lex_state = 228},
  [4757] = {.lex_state = 228},
  [4758] = {.lex_state = 228},
  [4759] = {.lex_state = 228},
  [4760] = {.lex_state = 211},
  [4761] = {.lex_state = 211},
  [4762] = {.lex_state = 211},
  [4763] = {.lex_state = 221},
  [4764] = {.lex_state = 221},
  [4765] = {.lex_state = 221},
  [4766] = {.lex_state = 221},
  [4767] = {.lex_state = 221},
  [4768] = {.lex_state = 228},
  [4769] = {.lex_state = 228},
  [4770] = {.lex_state = 228},
  [4771] = {.lex_state = 221},
  [4772] = {.lex_state = 228},
  [4773] = {.lex_state = 221},
  [4774] = {.lex_state = 221},
  [4775] = {.lex_state = 228},
  [4776] = {.lex_state = 221},
  [4777] = {.lex_state = 221},
  [4778] = {.lex_state = 228},
  [4779] = {.lex_state = 221},
  [4780] = {.lex_state = 228},
  [4781] = {.lex_state = 228},
  [4782] = {.lex_state = 221},
  [4783] = {.lex_state = 211},
  [4784] = {.lex_state = 221},
  [4785] = {.lex_state = 211},
  [4786] = {.lex_state = 211},
  [4787] = {.lex_state = 221},
  [4788] = {.lex_state = 211},
  [4789] = {.lex_state = 221},
  [4790] = {.lex_state = 228},
  [4791] = {.lex_state = 195},
  [4792] = {.lex_state = 228},
  [4793] = {.lex_state = 228},
  [4794] = {.lex_state = 228},
  [4795] = {.lex_state = 228},
  [4796] = {.lex_state = 228},
  [4797] = {.lex_state = 228},
  [4798] = {.lex_state = 228},
  [4799] = {.lex_state = 228},
  [4800] = {.lex_state = 211},
  [4801] = {.lex_state = 228},
  [4802] = {.lex_state = 228},
  [4803] = {.lex_state = 228},
  [4804] = {.lex_state = 228},
  [4805] = {.lex_state = 217},
  [4806] = {.lex_state = 217},
  [4807] = {.lex_state = 217},
  [4808] = {.lex_state = 195},
  [4809] = {.lex_state = 217},
  [4810] = {.lex_state = 217},
  [4811] = {.lex_state = 217},
  [4812] = {.lex_state = 217},
  [4813] = {.lex_state = 241},
  [4814] = {.lex_state = 221},
  [4815] = {.lex_state = 195},
  [4816] = {.lex_state = 205},
  [4817] = {.lex_state = 217},
  [4818] = {.lex_state = 195},
  [4819] = {.lex_state = 217},
  [4820] = {.lex_state = 217},
  [4821] = {.lex_state = 240},
  [4822] = {.lex_state = 208},
  [4823] = {.lex_state = 254},
  [4824] = {.lex_state = 217},
  [4825] = {.lex_state = 217},
  [4826] = {.lex_state = 217},
  [4827] = {.lex_state = 254},
  [4828] = {.lex_state = 225},
  [4829] = {.lex_state = 217},
  [4830] = {.lex_state = 225},
  [4831] = {.lex_state = 217},
  [4832] = {.lex_state = 195},
  [4833] = {.lex_state = 221},
  [4834] = {.lex_state = 221},
  [4835] = {.lex_state = 254},
  [4836] = {.lex_state = 221},
  [4837] = {.lex_state = 217},
  [4838] = {.lex_state = 254},
  [4839] = {.lex_state = 221},
  [4840] = {.lex_state = 217},
  [4841] = {.lex_state = 217},
  [4842] = {.lex_state = 221},
  [4843] = {.lex_state = 221},
  [4844] = {.lex_state = 221},
  [4845] = {.lex_state = 221},
  [4846] = {.lex_state = 254},
  [4847] = {.lex_state = 254},
  [4848] = {.lex_state = 217},
  [4849] = {.lex_state = 217},
  [4850] = {.lex_state = 221},
  [4851] = {.lex_state = 217},
  [4852] = {.lex_state = 217},
  [4853] = {.lex_state = 217},
  [4854] = {.lex_state = 221},
  [4855] = {.lex_state = 221},
  [4856] = {.lex_state = 217},
  [4857] = {.lex_state = 221},
  [4858] = {.lex_state = 221},
  [4859] = {.lex_state = 217},
  [4860] = {.lex_state = 221},
  [4861] = {.lex_state = 221},
  [4862] = {.lex_state = 221},
  [4863] = {.lex_state = 221},
  [4864] = {.lex_state = 217},
  [4865] = {.lex_state = 217},
  [4866] = {.lex_state = 221},
  [4867] = {.lex_state = 221},
  [4868] = {.lex_state = 221},
  [4869] = {.lex_state = 217},
  [4870] = {.lex_state = 217},
  [4871] = {.lex_state = 221},
  [4872] = {.lex_state = 221},
  [4873] = {.lex_state = 221},
  [4874] = {.lex_state = 221},
  [4875] = {.lex_state = 221},
  [4876] = {.lex_state = 221},
  [4877] = {.lex_state = 221},
  [4878] = {.lex_state = 217},
  [4879] = {.lex_state = 217},
  [4880] = {.lex_state = 221},
  [4881] = {.lex_state = 221},
  [4882] = {.lex_state = 221},
  [4883] = {.lex_state = 221},
  [4884] = {.lex_state = 221},
  [4885] = {.lex_state = 221},
  [4886] = {.lex_state = 256},
  [4887] = {.lex_state = 256},
  [4888] = {.lex_state = 221},
  [4889] = {.lex_state = 217},
  [4890] = {.lex_state = 217},
  [4891] = {.lex_state = 221},
  [4892] = {.lex_state = 221},
  [4893] = {.lex_state = 221},
  [4894] = {.lex_state = 221},
  [4895] = {.lex_state = 221},
  [4896] = {.lex_state = 217},
  [4897] = {.lex_state = 217},
  [4898] = {.lex_state = 221},
  [4899] = {.lex_state = 257},
  [4900] = {.lex_state = 217},
  [4901] = {.lex_state = 217},
  [4902] = {.lex_state = 217},
  [4903] = {.lex_state = 221},
  [4904] = {.lex_state = 221},
  [4905] = {.lex_state = 217},
  [4906] = {.lex_state = 217},
  [4907] = {.lex_state = 217},
  [4908] = {.lex_state = 217},
  [4909] = {.lex_state = 217},
  [4910] = {.lex_state = 217},
  [4911] = {.lex_state = 217},
  [4912] = {.lex_state = 217},
  [4913] = {.lex_state = 217},
  [4914] = {.lex_state = 217},
  [4915] = {.lex_state = 205},
  [4916] = {.lex_state = 221},
  [4917] = {.lex_state = 205},
  [4918] = {.lex_state = 217},
  [4919] = {.lex_state = 217},
  [4920] = {.lex_state = 217},
  [4921] = {.lex_state = 217},
  [4922] = {.lex_state = 217},
  [4923] = {.lex_state = 217},
  [4924] = {.lex_state = 221},
  [4925] = {.lex_state = 217},
  [4926] = {.lex_state = 217},
  [4927] = {.lex_state = 217},
  [4928] = {.lex_state = 221},
  [4929] = {.lex_state = 221},
  [4930] = {.lex_state = 217},
  [4931] = {.lex_state = 254},
  [4932] = {.lex_state = 221},
  [4933] = {.lex_state = 221},
  [4934] = {.lex_state = 254},
  [4935] = {.lex_state = 221},
  [4936] = {.lex_state = 205},
  [4937] = {.lex_state = 205},
  [4938] = {.lex_state = 217},
  [4939] = {.lex_state = 221},
  [4940] = {.lex_state = 221},
  [4941] = {.lex_state = 221},
  [4942] = {.lex_state = 221},
  [4943] = {.lex_state = 217},
  [4944] = {.lex_state = 221},
  [4945] = {.lex_state = 221},
  [4946] = {.lex_state = 221},
  [4947] = {.lex_state = 217},
  [4948] = {.lex_state = 217},
  [4949] = {.lex_state = 217},
  [4950] = {.lex_state = 240},
  [4951] = {.lex_state = 240},
  [4952] = {.lex_state = 240},
  [4953] = {.lex_state = 217},
  [4954] = {.lex_state = 240},
  [4955] = {.lex_state = 217},
  [4956] = {.lex_state = 240},
  [4957] = {.lex_state = 240},
  [4958] = {.lex_state = 217},
  [4959] = {.lex_state = 240},
  [4960] = {.lex_state = 240},
  [4961] = {.lex_state = 205},
  [4962] = {.lex_state = 205},
  [4963] = {.lex_state = 240},
  [4964] = {.lex_state = 217},
  [4965] = {.lex_state = 253},
  [4966] = {.lex_state = 217},
  [4967] = {.lex_state = 240},
  [4968] = {.lex_state = 240},
  [4969] = {.lex_state = 205},
  [4970] = {.lex_state = 257},
  [4971] = {.lex_state = 240},
  [4972] = {.lex_state = 253},
  [4973] = {.lex_state = 217},
  [4974] = {.lex_state = 240},
  [4975] = {.lex_state = 257},
  [4976] = {.lex_state = 253},
  [4977] = {.lex_state = 217},
  [4978] = {.lex_state = 255},
  [4979] = {.lex_state = 240},
  [4980] = {.lex_state = 205},
  [4981] = {.lex_state = 240},
  [4982] = {.lex_state = 255},
  [4983] = {.lex_state = 217},
  [4984] = {.lex_state = 258},
  [4985] = {.lex_state = 240},
  [4986] = {.lex_state = 217},
  [4987] = {.lex_state = 217},
  [4988] = {.lex_state = 256},
  [4989] = {.lex_state = 256},
  [4990] = {.lex_state = 240},
  [4991] = {.lex_state = 217},
  [4992] = {.lex_state = 256},
  [4993] = {.lex_state = 215},
  [4994] = {.lex_state = 241},
  [4995] = {.lex_state = 256},
  [4996] = {.lex_state = 241},
  [4997] = {.lex_state = 215},
  [4998] = {.lex_state = 256},
  [4999] = {.lex_state = 240},
  [5000] = {.lex_state = 217},
  [5001] = {.lex_state = 253},
  [5002] = {.lex_state = 258},
  [5003] = {.lex_state = 217},
  [5004] = {.lex_state = 217},
  [5005] = {.lex_state = 253},
  [5006] = {.lex_state = 240},
  [5007] = {.lex_state = 217},
  [5008] = {.lex_state = 256},
  [5009] = {.lex_state = 254},
  [5010] = {.lex_state = 257},
  [5011] = {.lex_state = 240},
  [5012] = {.lex_state = 217},
  [5013] = {.lex_state = 253},
  [5014] = {.lex_state = 217},
  [5015] = {.lex_state = 217},
  [5016] = {.lex_state = 217},
  [5017] = {.lex_state = 217},
  [5018] = {.lex_state = 254},
  [5019] = {.lex_state = 241},
  [5020] = {.lex_state = 217},
  [5021] = {.lex_state = 217},
  [5022] = {.lex_state = 253},
  [5023] = {.lex_state = 217},
  [5024] = {.lex_state = 217},
  [5025] = {.lex_state = 253},
  [5026] = {.lex_state = 217},
  [5027] = {.lex_state = 217},
  [5028] = {.lex_state = 217},
  [5029] = {.lex_state = 217},
  [5030] = {.lex_state = 253},
  [5031] = {.lex_state = 217},
  [5032] = {.lex_state = 217},
  [5033] = {.lex_state = 217},
  [5034] = {.lex_state = 256},
  [5035] = {.lex_state = 217},
  [5036] = {.lex_state = 217},
  [5037] = {.lex_state = 254},
  [5038] = {.lex_state = 217},
  [5039] = {.lex_state = 217},
  [5040] = {.lex_state = 253},
  [5041] = {.lex_state = 217},
  [5042] = {.lex_state = 217},
  [5043] = {.lex_state = 217},
  [5044] = {.lex_state = 217},
  [5045] = {.lex_state = 253},
  [5046] = {.lex_state = 257},
  [5047] = {.lex_state = 253},
  [5048] = {.lex_state = 253},
  [5049] = {.lex_state = 217},
  [5050] = {.lex_state = 253},
  [5051] = {.lex_state = 217},
  [5052] = {.lex_state = 217},
  [5053] = {.lex_state = 256},
  [5054] = {.lex_state = 217},
  [5055] = {.lex_state = 251},
  [5056] = {.lex_state = 253},
  [5057] = {.lex_state = 253},
  [5058] = {.lex_state = 253},
  [5059] = {.lex_state = 251},
  [5060] = {.lex_state = 253},
  [5061] = {.lex_state = 253},
  [5062] = {.lex_state = 217},
  [5063] = {.lex_state = 217},
  [5064] = {.lex_state = 253},
  [5065] = {.lex_state = 257},
  [5066] = {.lex_state = 217},
  [5067] = {.lex_state = 253},
  [5068] = {.lex_state = 253},
  [5069] = {.lex_state = 253},
  [5070] = {.lex_state = 217},
  [5071] = {.lex_state = 217},
  [5072] = {.lex_state = 217},
  [5073] = {.lex_state = 217},
  [5074] = {.lex_state = 217},
  [5075] = {.lex_state = 240},
  [5076] = {.lex_state = 217},
  [5077] = {.lex_state = 217},
  [5078] = {.lex_state = 254},
  [5079] = {.lex_state = 253},
  [5080] = {.lex_state = 254},
  [5081] = {.lex_state = 253},
  [5082] = {.lex_state = 240},
  [5083] = {.lex_state = 256},
  [5084] = {.lex_state = 254},
  [5085] = {.lex_state = 254},
  [5086] = {.lex_state = 240},
  [5087] = {.lex_state = 217},
  [5088] = {.lex_state = 254},
  [5089] = {.lex_state = 254},
  [5090] = {.lex_state = 256},
  [5091] = {.lex_state = 253},
  [5092] = {.lex_state = 237},
  [5093] = {.lex_state = 256},
  [5094] = {.lex_state = 253},
  [5095] = {.lex_state = 254},
  [5096] = {.lex_state = 254},
  [5097] = {.lex_state = 256},
  [5098] = {.lex_state = 254},
  [5099] = {.lex_state = 254},
  [5100] = {.lex_state = 217},
  [5101] = {.lex_state = 254},
  [5102] = {.lex_state = 217},
  [5103] = {.lex_state = 254},
  [5104] = {.lex_state = 237},
  [5105] = {.lex_state = 257},
  [5106] = {.lex_state = 257},
  [5107] = {.lex_state = 255},
  [5108] = {.lex_state = 255},
  [5109] = {.lex_state = 217},
  [5110] = {.lex_state = 251},
  [5111] = {.lex_state = 253},
  [5112] = {.lex_state = 217},
  [5113] = {.lex_state = 241},
  [5114] = {.lex_state = 252},
  [5115] = {.lex_state = 253},
  [5116] = {.lex_state = 253},
  [5117] = {.lex_state = 217},
  [5118] = {.lex_state = 241},
  [5119] = {.lex_state = 217},
  [5120] = {.lex_state = 217},
  [5121] = {.lex_state = 252},
  [5122] = {.lex_state = 217},
  [5123] = {.lex_state = 252},
  [5124] = {.lex_state = 252},
  [5125] = {.lex_state = 252},
  [5126] = {.lex_state = 217},
  [5127] = {.lex_state = 217},
  [5128] = {.lex_state = 252},
  [5129] = {.lex_state = 217},
  [5130] = {.lex_state = 217},
  [5131] = {.lex_state = 252},
  [5132] = {.lex_state = 257},
  [5133] = {.lex_state = 217},
  [5134] = {.lex_state = 241},
  [5135] = {.lex_state = 217},
  [5136] = {.lex_state = 217},
  [5137] = {.lex_state = 241},
  [5138] = {.lex_state = 240},
  [5139] = {.lex_state = 216},
  [5140] = {.lex_state = 241},
  [5141] = {.lex_state = 252},
  [5142] = {.lex_state = 252},
  [5143] = {.lex_state = 252},
  [5144] = {.lex_state = 241},
  [5145] = {.lex_state = 217},
  [5146] = {.lex_state = 252},
  [5147] = {.lex_state = 257},
  [5148] = {.lex_state = 241},
  [5149] = {.lex_state = 253},
  [5150] = {.lex_state = 241},
  [5151] = {.lex_state = 240},
  [5152] = {.lex_state = 240},
  [5153] = {.lex_state = 252},
  [5154] = {.lex_state = 240},
  [5155] = {.lex_state = 252},
  [5156] = {.lex_state = 241},
  [5157] = {.lex_state = 241},
  [5158] = {.lex_state = 240},
  [5159] = {.lex_state = 240},
  [5160] = {.lex_state = 240},
  [5161] = {.lex_state = 240},
  [5162] = {.lex_state = 252},
  [5163] = {.lex_state = 216},
  [5164] = {.lex_state = 252},
  [5165] = {.lex_state = 240},
  [5166] = {.lex_state = 240},
  [5167] = {.lex_state = 217},
  [5168] = {.lex_state = 240},
  [5169] = {.lex_state = 240},
  [5170] = {.lex_state = 253},
  [5171] = {.lex_state = 217},
  [5172] = {.lex_state = 240},
  [5173] = {.lex_state = 240},
  [5174] = {.lex_state = 240},
  [5175] = {.lex_state = 240},
  [5176] = {.lex_state = 217},
  [5177] = {.lex_state = 217},
  [5178] = {.lex_state = 252},
  [5179] = {.lex_state = 217},
  [5180] = {.lex_state = 252},
  [5181] = {.lex_state = 241},
  [5182] = {.lex_state = 241},
  [5183] = {.lex_state = 252},
  [5184] = {.lex_state = 252},
  [5185] = {.lex_state = 252},
  [5186] = {.lex_state = 252},
  [5187] = {.lex_state = 252},
  [5188] = {.lex_state = 217},
  [5189] = {.lex_state = 217},
  [5190] = {.lex_state = 217},
  [5191] = {.lex_state = 217},
  [5192] = {.lex_state = 217},
  [5193] = {.lex_state = 217},
  [5194] = {.lex_state = 217},
  [5195] = {.lex_state = 217},
  [5196] = {.lex_state = 252},
  [5197] = {.lex_state = 241},
  [5198] = {.lex_state = 241},
  [5199] = {.lex_state = 241},
  [5200] = {.lex_state = 252},
  [5201] = {.lex_state = 252},
  [5202] = {.lex_state = 217},
  [5203] = {.lex_state = 252},
  [5204] = {.lex_state = 217},
  [5205] = {.lex_state = 241},
  [5206] = {.lex_state = 252},
  [5207] = {.lex_state = 241},
  [5208] = {.lex_state = 217},
  [5209] = {.lex_state = 217},
  [5210] = {.lex_state = 252},
  [5211] = {.lex_state = 256},
  [5212] = {.lex_state = 254},
  [5213] = {.lex_state = 256},
  [5214] = {.lex_state = 256},
  [5215] = {.lex_state = 252},
  [5216] = {.lex_state = 253},
  [5217] = {.lex_state = 240},
  [5218] = {.lex_state = 253},
  [5219] = {.lex_state = 253},
  [5220] = {.lex_state = 256},
  [5221] = {.lex_state = 256},
  [5222] = {.lex_state = 252},
  [5223] = {.lex_state = 256},
  [5224] = {.lex_state = 257},
  [5225] = {.lex_state = 253},
  [5226] = {.lex_state = 256},
  [5227] = {.lex_state = 253},
  [5228] = {.lex_state = 253},
  [5229] = {.lex_state = 253},
  [5230] = {.lex_state = 240},
  [5231] = {.lex_state = 256},
  [5232] = {.lex_state = 217},
  [5233] = {.lex_state = 218},
  [5234] = {.lex_state = 254},
  [5235] = {.lex_state = 256},
  [5236] = {.lex_state = 253},
  [5237] = {.lex_state = 256},
  [5238] = {.lex_state = 240},
  [5239] = {.lex_state = 254},
  [5240] = {.lex_state = 240},
  [5241] = {.lex_state = 217},
  [5242] = {.lex_state = 253},
  [5243] = {.lex_state = 217},
  [5244] = {.lex_state = 254},
  [5245] = {.lex_state = 253},
  [5246] = {.lex_state = 240},
  [5247] = {.lex_state = 253},
  [5248] = {.lex_state = 256},
  [5249] = {.lex_state = 254},
  [5250] = {.lex_state = 254},
  [5251] = {.lex_state = 256},
  [5252] = {.lex_state = 253},
  [5253] = {.lex_state = 218},
  [5254] = {.lex_state = 256},
  [5255] = {.lex_state = 253},
  [5256] = {.lex_state = 217},
  [5257] = {.lex_state = 256},
  [5258] = {.lex_state = 253},
  [5259] = {.lex_state = 217},
  [5260] = {.lex_state = 217},
  [5261] = {.lex_state = 253},
  [5262] = {.lex_state = 256},
  [5263] = {.lex_state = 254},
  [5264] = {.lex_state = 253},
  [5265] = {.lex_state = 254},
  [5266] = {.lex_state = 254},
  [5267] = {.lex_state = 254},
  [5268] = {.lex_state = 253},
  [5269] = {.lex_state = 256},
  [5270] = {.lex_state = 254},
  [5271] = {.lex_state = 256},
  [5272] = {.lex_state = 253},
  [5273] = {.lex_state = 256},
  [5274] = {.lex_state = 253},
  [5275] = {.lex_state = 254},
  [5276] = {.lex_state = 240},
  [5277] = {.lex_state = 256},
  [5278] = {.lex_state = 256},
  [5279] = {.lex_state = 217},
  [5280] = {.lex_state = 256},
  [5281] = {.lex_state = 256},
  [5282] = {.lex_state = 217},
  [5283] = {.lex_state = 256},
  [5284] = {.lex_state = 254},
  [5285] = {.lex_state = 256},
  [5286] = {.lex_state = 256},
  [5287] = {.lex_state = 254},
  [5288] = {.lex_state = 253},
  [5289] = {.lex_state = 253},
  [5290] = {.lex_state = 253},
  [5291] = {.lex_state = 253},
  [5292] = {.lex_state = 256},
  [5293] = {.lex_state = 254},
  [5294] = {.lex_state = 253},
  [5295] = {.lex_state = 256},
  [5296] = {.lex_state = 257},
  [5297] = {.lex_state = 253},
  [5298] = {.lex_state = 217},
  [5299] = {.lex_state = 254},
  [5300] = {.lex_state = 253},
  [5301] = {.lex_state = 217},
  [5302] = {.lex_state = 237},
  [5303] = {.lex_state = 256},
  [5304] = {.lex_state = 254},
  [5305] = {.lex_state = 256},
  [5306] = {.lex_state = 237},
  [5307] = {.lex_state = 240},
  [5308] = {.lex_state = 254},
  [5309] = {.lex_state = 253},
  [5310] = {.lex_state = 254},
  [5311] = {.lex_state = 237},
  [5312] = {.lex_state = 256},
  [5313] = {.lex_state = 237},
  [5314] = {.lex_state = 251},
  [5315] = {.lex_state = 254},
  [5316] = {.lex_state = 254},
  [5317] = {.lex_state = 251},
  [5318] = {.lex_state = 217},
  [5319] = {.lex_state = 256},
  [5320] = {.lex_state = 237},
  [5321] = {.lex_state = 237},
  [5322] = {.lex_state = 254},
  [5323] = {.lex_state = 237},
  [5324] = {.lex_state = 254},
  [5325] = {.lex_state = 240},
  [5326] = {.lex_state = 254},
  [5327] = {.lex_state = 256},
  [5328] = {.lex_state = 254},
  [5329] = {.lex_state = 251},
  [5330] = {.lex_state = 254},
  [5331] = {.lex_state = 217},
  [5332] = {.lex_state = 218},
  [5333] = {.lex_state = 237},
  [5334] = {.lex_state = 217},
  [5335] = {.lex_state = 251},
  [5336] = {.lex_state = 254},
  [5337] = {.lex_state = 254},
  [5338] = {.lex_state = 253},
  [5339] = {.lex_state = 217},
  [5340] = {.lex_state = 251},
  [5341] = {.lex_state = 218},
  [5342] = {.lex_state = 217},
  [5343] = {.lex_state = 240},
  [5344] = {.lex_state = 254},
  [5345] = {.lex_state = 240},
  [5346] = {.lex_state = 217},
  [5347] = {.lex_state = 240},
  [5348] = {.lex_state = 217},
  [5349] = {.lex_state = 240},
  [5350] = {.lex_state = 240},
  [5351] = {.lex_state = 240},
  [5352] = {.lex_state = 240},
  [5353] = {.lex_state = 240},
  [5354] = {.lex_state = 256},
  [5355] = {.lex_state = 254},
  [5356] = {.lex_state = 254},
  [5357] = {.lex_state = 217},
  [5358] = {.lex_state = 240},
  [5359] = {.lex_state = 240},
  [5360] = {.lex_state = 217},
  [5361] = {.lex_state = 240},
  [5362] = {.lex_state = 240},
  [5363] = {.lex_state = 217},
  [5364] = {.lex_state = 254},
  [5365] = {.lex_state = 256},
  [5366] = {.lex_state = 251},
  [5367] = {.lex_state = 251},
  [5368] = {.lex_state = 240},
  [5369] = {.lex_state = 217},
  [5370] = {.lex_state = 240},
  [5371] = {.lex_state = 253},
  [5372] = {.lex_state = 217},
  [5373] = {.lex_state = 240},
  [5374] = {.lex_state = 254},
  [5375] = {.lex_state = 217},
  [5376] = {.lex_state = 254},
  [5377] = {.lex_state = 217},
  [5378] = {.lex_state = 254},
  [5379] = {.lex_state = 217},
  [5380] = {.lex_state = 217},
  [5381] = {.lex_state = 217},
  [5382] = {.lex_state = 217},
  [5383] = {.lex_state = 217},
  [5384] = {.lex_state = 254},
  [5385] = {.lex_state = 216},
  [5386] = {.lex_state = 217},
  [5387] = {.lex_state = 256},
  [5388] = {.lex_state = 253},
  [5389] = {.lex_state = 251},
  [5390] = {.lex_state = 240},
  [5391] = {.lex_state = 240},
  [5392] = {.lex_state = 217},
  [5393] = {.lex_state = 217},
  [5394] = {.lex_state = 216},
  [5395] = {.lex_state = 217},
  [5396] = {.lex_state = 240},
  [5397] = {.lex_state = 240},
  [5398] = {.lex_state = 240},
  [5399] = {.lex_state = 254},
  [5400] = {.lex_state = 216},
  [5401] = {.lex_state = 240},
  [5402] = {.lex_state = 240},
  [5403] = {.lex_state = 240},
  [5404] = {.lex_state = 217},
  [5405] = {.lex_state = 217},
  [5406] = {.lex_state = 217},
  [5407] = {.lex_state = 256},
  [5408] = {.lex_state = 237},
  [5409] = {.lex_state = 217},
  [5410] = {.lex_state = 240},
  [5411] = {.lex_state = 256},
  [5412] = {.lex_state = 217},
  [5413] = {.lex_state = 217},
  [5414] = {.lex_state = 240},
  [5415] = {.lex_state = 240},
  [5416] = {.lex_state = 217},
  [5417] = {.lex_state = 254},
  [5418] = {.lex_state = 217},
  [5419] = {.lex_state = 254},
  [5420] = {.lex_state = 217},
  [5421] = {.lex_state = 217},
  [5422] = {.lex_state = 254},
  [5423] = {.lex_state = 217},
  [5424] = {.lex_state = 217},
  [5425] = {.lex_state = 256},
  [5426] = {.lex_state = 256},
  [5427] = {.lex_state = 217},
  [5428] = {.lex_state = 240},
  [5429] = {.lex_state = 240},
  [5430] = {.lex_state = 256},
  [5431] = {.lex_state = 217},
  [5432] = {.lex_state = 217},
  [5433] = {.lex_state = 240},
  [5434] = {.lex_state = 240},
  [5435] = {.lex_state = 217},
  [5436] = {.lex_state = 256},
  [5437] = {.lex_state = 240},
  [5438] = {.lex_state = 256},
  [5439] = {.lex_state = 240},
  [5440] = {.lex_state = 217},
  [5441] = {.lex_state = 217},
  [5442] = {.lex_state = 217},
  [5443] = {.lex_state = 254},
  [5444] = {.lex_state = 237},
  [5445] = {.lex_state = 217},
  [5446] = {.lex_state = 217},
  [5447] = {.lex_state = 240},
  [5448] = {.lex_state = 254},
  [5449] = {.lex_state = 237},
  [5450] = {.lex_state = 217},
  [5451] = {.lex_state = 217},
  [5452] = {.lex_state = 240},
  [5453] = {.lex_state = 240},
  [5454] = {.lex_state = 237},
  [5455] = {.lex_state = 240},
  [5456] = {.lex_state = 217},
  [5457] = {.lex_state = 240},
  [5458] = {.lex_state = 253},
  [5459] = {.lex_state = 240},
  [5460] = {.lex_state = 217},
  [5461] = {.lex_state = 217},
  [5462] = {.lex_state = 240},
  [5463] = {.lex_state = 217},
  [5464] = {.lex_state = 217},
  [5465] = {.lex_state = 217},
  [5466] = {.lex_state = 217},
  [5467] = {.lex_state = 253},
  [5468] = {.lex_state = 253},
  [5469] = {.lex_state = 253},
  [5470] = {.lex_state = 253},
  [5471] = {.lex_state = 240},
  [5472] = {.lex_state = 240},
  [5473] = {.lex_state = 253},
  [5474] = {.lex_state = 217},
  [5475] = {.lex_state = 217},
  [5476] = {.lex_state = 217},
  [5477] = {.lex_state = 217},
  [5478] = {.lex_state = 217},
  [5479] = {.lex_state = 257},
  [5480] = {.lex_state = 253},
  [5481] = {.lex_state = 253},
  [5482] = {.lex_state = 217},
  [5483] = {.lex_state = 217},
  [5484] = {.lex_state = 217},
  [5485] = {.lex_state = 240},
  [5486] = {.lex_state = 240},
  [5487] = {.lex_state = 217},
  [5488] = {.lex_state = 217},
  [5489] = {.lex_state = 218},
  [5490] = {.lex_state = 217},
  [5491] = {.lex_state = 240},
  [5492] = {.lex_state = 240},
  [5493] = {.lex_state = 217},
  [5494] = {.lex_state = 240},
  [5495] = {.lex_state = 253},
  [5496] = {.lex_state = 240},
  [5497] = {.lex_state = 217},
  [5498] = {.lex_state = 253},
  [5499] = {.lex_state = 217},
  [5500] = {.lex_state = 240},
  [5501] = {.lex_state = 240},
  [5502] = {.lex_state = 217},
  [5503] = {.lex_state = 217},
  [5504] = {.lex_state = 217},
  [5505] = {.lex_state = 240},
  [5506] = {.lex_state = 217},
  [5507] = {.lex_state = 217},
  [5508] = {.lex_state = 240},
  [5509] = {.lex_state = 217},
  [5510] = {.lex_state = 240},
  [5511] = {.lex_state = 217},
  [5512] = {.lex_state = 217},
  [5513] = {.lex_state = 254},
  [5514] = {.lex_state = 217},
  [5515] = {.lex_state = 217},
  [5516] = {.lex_state = 240},
  [5517] = {.lex_state = 217},
  [5518] = {.lex_state = 217},
  [5519] = {.lex_state = 217},
  [5520] = {.lex_state = 240},
  [5521] = {.lex_state = 240},
  [5522] = {.lex_state = 240},
  [5523] = {.lex_state = 217},
  [5524] = {.lex_state = 217},
  [5525] = {.lex_state = 240},
  [5526] = {.lex_state = 217},
  [5527] = {.lex_state = 217},
  [5528] = {.lex_state = 240},
  [5529] = {.lex_state = 240},
  [5530] = {.lex_state = 254},
  [5531] = {.lex_state = 240},
  [5532] = {.lex_state = 217},
  [5533] = {.lex_state = 217},
  [5534] = {.lex_state = 240},
  [5535] = {.lex_state = 240},
  [5536] = {.lex_state = 217},
  [5537] = {.lex_state = 240},
  [5538] = {.lex_state = 253},
  [5539] = {.lex_state = 253},
  [5540] = {.lex_state = 240},
  [5541] = {.lex_state = 240},
  [5542] = {.lex_state = 240},
  [5543] = {.lex_state = 240},
  [5544] = {.lex_state = 217},
  [5545] = {.lex_state = 217},
  [5546] = {.lex_state = 240},
  [5547] = {.lex_state = 240},
  [5548] = {.lex_state = 217},
  [5549] = {.lex_state = 218},
  [5550] = {.lex_state = 240},
  [5551] = {.lex_state = 240},
  [5552] = {.lex_state = 240},
  [5553] = {.lex_state = 217},
  [5554] = {.lex_state = 240},
  [5555] = {.lex_state = 240},
  [5556] = {.lex_state = 240},
  [5557] = {.lex_state = 251},
  [5558] = {.lex_state = 240},
  [5559] = {.lex_state = 240},
  [5560] = {.lex_state = 240},
  [5561] = {.lex_state = 240},
  [5562] = {.lex_state = 240},
  [5563] = {.lex_state = 240},
  [5564] = {.lex_state = 217},
  [5565] = {.lex_state = 217},
  [5566] = {.lex_state = 217},
  [5567] = {.lex_state = 217},
  [5568] = {.lex_state = 240},
  [5569] = {.lex_state = 240},
  [5570] = {.lex_state = 240},
  [5571] = {.lex_state = 240},
  [5572] = {.lex_state = 240},
  [5573] = {.lex_state = 217},
  [5574] = {.lex_state = 217},
  [5575] = {.lex_state = 240},
  [5576] = {.lex_state = 240},
  [5577] = {.lex_state = 240},
  [5578] = {.lex_state = 240},
  [5579] = {.lex_state = 240},
  [5580] = {.lex_state = 240},
  [5581] = {.lex_state = 240},
  [5582] = {.lex_state = 240},
  [5583] = {.lex_state = 240},
  [5584] = {.lex_state = 240},
  [5585] = {.lex_state = 240},
  [5586] = {.lex_state = 240},
  [5587] = {.lex_state = 240},
  [5588] = {.lex_state = 217},
  [5589] = {.lex_state = 237},
  [5590] = {.lex_state = 240},
  [5591] = {.lex_state = 240},
  [5592] = {.lex_state = 240},
  [5593] = {.lex_state = 254},
  [5594] = {.lex_state = 240},
  [5595] = {.lex_state = 240},
  [5596] = {.lex_state = 240},
  [5597] = {.lex_state = 240},
  [5598] = {.lex_state = 240},
  [5599] = {.lex_state = 240},
  [5600] = {.lex_state = 240},
  [5601] = {.lex_state = 240},
  [5602] = {.lex_state = 240},
  [5603] = {.lex_state = 240},
  [5604] = {.lex_state = 240},
  [5605] = {.lex_state = 240},
  [5606] = {.lex_state = 254},
  [5607] = {.lex_state = 256},
  [5608] = {.lex_state = 256},
  [5609] = {.lex_state = 240},
  [5610] = {.lex_state = 256},
  [5611] = {.lex_state = 256},
  [5612] = {.lex_state = 240},
  [5613] = {.lex_state = 256},
  [5614] = {.lex_state = 256},
  [5615] = {.lex_state = 256},
  [5616] = {.lex_state = 240},
  [5617] = {.lex_state = 256},
  [5618] = {.lex_state = 256},
  [5619] = {.lex_state = 256},
  [5620] = {.lex_state = 256},
  [5621] = {.lex_state = 256},
  [5622] = {.lex_state = 217},
  [5623] = {.lex_state = 217},
  [5624] = {.lex_state = 240},
  [5625] = {.lex_state = 254},
  [5626] = {.lex_state = 217},
  [5627] = {.lex_state = 240},
  [5628] = {.lex_state = 256},
  [5629] = {.lex_state = 256},
  [5630] = {.lex_state = 256},
  [5631] = {.lex_state = 256},
  [5632] = {.lex_state = 256},
  [5633] = {.lex_state = 256},
  [5634] = {.lex_state = 256},
  [5635] = {.lex_state = 240},
  [5636] = {.lex_state = 217},
  [5637] = {.lex_state = 217},
  [5638] = {.lex_state = 217},
  [5639] = {.lex_state = 217},
  [5640] = {.lex_state = 256},
  [5641] = {.lex_state = 254},
  [5642] = {.lex_state = 256},
  [5643] = {.lex_state = 256},
  [5644] = {.lex_state = 256},
  [5645] = {.lex_state = 256},
  [5646] = {.lex_state = 256},
  [5647] = {.lex_state = 217},
  [5648] = {.lex_state = 256},
  [5649] = {.lex_state = 217},
  [5650] = {.lex_state = 217},
  [5651] = {.lex_state = 217},
  [5652] = {.lex_state = 256},
  [5653] = {.lex_state = 256},
  [5654] = {.lex_state = 217},
  [5655] = {.lex_state = 217},
  [5656] = {.lex_state = 217},
  [5657] = {.lex_state = 254},
  [5658] = {.lex_state = 217},
  [5659] = {.lex_state = 256},
  [5660] = {.lex_state = 254},
  [5661] = {.lex_state = 217},
  [5662] = {.lex_state = 240},
  [5663] = {.lex_state = 256},
  [5664] = {.lex_state = 217},
  [5665] = {.lex_state = 217},
  [5666] = {.lex_state = 240},
  [5667] = {.lex_state = 217},
  [5668] = {.lex_state = 217},
  [5669] = {.lex_state = 217},
  [5670] = {.lex_state = 217},
  [5671] = {.lex_state = 217},
  [5672] = {.lex_state = 217},
  [5673] = {.lex_state = 253},
  [5674] = {.lex_state = 240},
  [5675] = {.lex_state = 217},
  [5676] = {.lex_state = 217},
  [5677] = {.lex_state = 217},
  [5678] = {.lex_state = 254},
  [5679] = {.lex_state = 240},
  [5680] = {.lex_state = 217},
  [5681] = {.lex_state = 253},
  [5682] = {.lex_state = 253},
  [5683] = {.lex_state = 254},
  [5684] = {.lex_state = 256},
  [5685] = {.lex_state = 217},
  [5686] = {.lex_state = 253},
  [5687] = {.lex_state = 256},
  [5688] = {.lex_state = 217},
  [5689] = {.lex_state = 256},
  [5690] = {.lex_state = 256},
  [5691] = {.lex_state = 217},
  [5692] = {.lex_state = 217},
  [5693] = {.lex_state = 217},
  [5694] = {.lex_state = 217},
  [5695] = {.lex_state = 217},
  [5696] = {.lex_state = 217},
  [5697] = {.lex_state = 256},
  [5698] = {.lex_state = 256},
  [5699] = {.lex_state = 217},
  [5700] = {.lex_state = 254},
  [5701] = {.lex_state = 254},
  [5702] = {.lex_state = 256},
  [5703] = {.lex_state = 256},
  [5704] = {.lex_state = 256},
  [5705] = {.lex_state = 217},
  [5706] = {.lex_state = 254},
  [5707] = {.lex_state = 256},
  [5708] = {.lex_state = 240},
  [5709] = {.lex_state = 240},
  [5710] = {.lex_state = 217},
  [5711] = {.lex_state = 240},
  [5712] = {.lex_state = 254},
  [5713] = {.lex_state = 254},
  [5714] = {.lex_state = 240},
  [5715] = {.lex_state = 217},
  [5716] = {.lex_state = 254},
  [5717] = {.lex_state = 217},
  [5718] = {.lex_state = 240},
  [5719] = {.lex_state = 256},
  [5720] = {.lex_state = 217},
  [5721] = {.lex_state = 256},
  [5722] = {.lex_state = 256},
  [5723] = {.lex_state = 256},
  [5724] = {.lex_state = 240},
  [5725] = {.lex_state = 240},
  [5726] = {.lex_state = 240},
  [5727] = {.lex_state = 253},
  [5728] = {.lex_state = 256},
  [5729] = {.lex_state = 237},
  [5730] = {.lex_state = 256},
  [5731] = {.lex_state = 253},
  [5732] = {.lex_state = 254},
  [5733] = {.lex_state = 217},
  [5734] = {.lex_state = 254},
  [5735] = {.lex_state = 254},
  [5736] = {.lex_state = 253},
  [5737] = {.lex_state = 217},
  [5738] = {.lex_state = 256},
  [5739] = {.lex_state = 217},
  [5740] = {.lex_state = 256},
  [5741] = {.lex_state = 256},
  [5742] = {.lex_state = 254},
  [5743] = {.lex_state = 217},
  [5744] = {.lex_state = 240},
  [5745] = {.lex_state = 256},
  [5746] = {.lex_state = 217},
  [5747] = {.lex_state = 240},
  [5748] = {.lex_state = 240},
  [5749] = {.lex_state = 256},
  [5750] = {.lex_state = 217},
  [5751] = {.lex_state = 217},
  [5752] = {.lex_state = 256},
  [5753] = {.lex_state = 256},
  [5754] = {.lex_state = 256},
  [5755] = {.lex_state = 217},
  [5756] = {.lex_state = 256},
  [5757] = {.lex_state = 253},
  [5758] = {.lex_state = 253},
  [5759] = {.lex_state = 217},
  [5760] = {.lex_state = 256},
  [5761] = {.lex_state = 256},
  [5762] = {.lex_state = 256},
  [5763] = {.lex_state = 217},
  [5764] = {.lex_state = 217},
  [5765] = {.lex_state = 217},
  [5766] = {.lex_state = 240},
  [5767] = {.lex_state = 256},
  [5768] = {.lex_state = 240},
  [5769] = {.lex_state = 217},
  [5770] = {.lex_state = 240},
  [5771] = {.lex_state = 256},
  [5772] = {.lex_state = 217},
  [5773] = {.lex_state = 217},
  [5774] = {.lex_state = 217},
  [5775] = {.lex_state = 217},
  [5776] = {.lex_state = 256},
  [5777] = {.lex_state = 217},
  [5778] = {.lex_state = 256},
  [5779] = {.lex_state = 217},
  [5780] = {.lex_state = 217},
  [5781] = {.lex_state = 217},
  [5782] = {.lex_state = 253},
  [5783] = {.lex_state = 256},
  [5784] = {.lex_state = 217},
  [5785] = {.lex_state = 217},
  [5786] = {.lex_state = 240},
  [5787] = {.lex_state = 240},
  [5788] = {.lex_state = 217},
  [5789] = {.lex_state = 217},
  [5790] = {.lex_state = 217},
  [5791] = {.lex_state = 217},
  [5792] = {.lex_state = 217},
  [5793] = {.lex_state = 217},
  [5794] = {.lex_state = 217},
  [5795] = {.lex_state = 217},
  [5796] = {.lex_state = 217},
  [5797] = {.lex_state = 217},
  [5798] = {.lex_state = 217},
  [5799] = {.lex_state = 217},
  [5800] = {.lex_state = 217},
  [5801] = {.lex_state = 217},
  [5802] = {.lex_state = 217},
  [5803] = {.lex_state = 217},
  [5804] = {.lex_state = 217},
  [5805] = {.lex_state = 217},
  [5806] = {.lex_state = 254},
  [5807] = {.lex_state = 251},
  [5808] = {.lex_state = 217},
  [5809] = {.lex_state = 253},
  [5810] = {.lex_state = 217},
  [5811] = {.lex_state = 217},
  [5812] = {.lex_state = 251},
  [5813] = {.lex_state = 254},
  [5814] = {.lex_state = 217},
  [5815] = {.lex_state = 217},
  [5816] = {.lex_state = 256},
  [5817] = {.lex_state = 251},
  [5818] = {.lex_state = 251},
  [5819] = {.lex_state = 217},
  [5820] = {.lex_state = 252},
  [5821] = {.lex_state = 217},
  [5822] = {.lex_state = 256},
  [5823] = {.lex_state = 217},
  [5824] = {.lex_state = 217},
  [5825] = {.lex_state = 251},
  [5826] = {.lex_state = 251},
  [5827] = {.lex_state = 256},
  [5828] = {.lex_state = 251},
  [5829] = {.lex_state = 217},
  [5830] = {.lex_state = 217},
  [5831] = {.lex_state = 251},
  [5832] = {.lex_state = 217},
  [5833] = {.lex_state = 251},
  [5834] = {.lex_state = 217},
  [5835] = {.lex_state = 251},
  [5836] = {.lex_state = 217},
  [5837] = {.lex_state = 256},
  [5838] = {.lex_state = 216},
  [5839] = {.lex_state = 256},
  [5840] = {.lex_state = 256},
  [5841] = {.lex_state = 251},
  [5842] = {.lex_state = 251},
  [5843] = {.lex_state = 217},
  [5844] = {.lex_state = 254},
  [5845] = {.lex_state = 217},
  [5846] = {.lex_state = 256},
  [5847] = {.lex_state = 217},
  [5848] = {.lex_state = 256},
  [5849] = {.lex_state = 256},
  [5850] = {.lex_state = 256},
  [5851] = {.lex_state = 217},
  [5852] = {.lex_state = 256},
  [5853] = {.lex_state = 217},
  [5854] = {.lex_state = 217},
  [5855] = {.lex_state = 217},
  [5856] = {.lex_state = 240},
  [5857] = {.lex_state = 217},
  [5858] = {.lex_state = 240},
  [5859] = {.lex_state = 240},
  [5860] = {.lex_state = 217},
  [5861] = {.lex_state = 240},
  [5862] = {.lex_state = 240},
  [5863] = {.lex_state = 217},
  [5864] = {.lex_state = 240},
  [5865] = {.lex_state = 256},
  [5866] = {.lex_state = 217},
  [5867] = {.lex_state = 240},
  [5868] = {.lex_state = 217},
  [5869] = {.lex_state = 240},
  [5870] = {.lex_state = 240},
  [5871] = {.lex_state = 256},
  [5872] = {.lex_state = 240},
  [5873] = {.lex_state = 256},
  [5874] = {.lex_state = 217},
  [5875] = {.lex_state = 217},
  [5876] = {.lex_state = 256},
  [5877] = {.lex_state = 254},
  [5878] = {.lex_state = 216},
  [5879] = {.lex_state = 217},
  [5880] = {.lex_state = 217},
  [5881] = {.lex_state = 217},
  [5882] = {.lex_state = 217},
  [5883] = {.lex_state = 254},
  [5884] = {.lex_state = 254},
  [5885] = {.lex_state = 217},
  [5886] = {.lex_state = 217},
  [5887] = {.lex_state = 217},
  [5888] = {.lex_state = 240},
  [5889] = {.lex_state = 243},
  [5890] = {.lex_state = 217},
  [5891] = {.lex_state = 217},
  [5892] = {.lex_state = 217},
  [5893] = {.lex_state = 217},
  [5894] = {.lex_state = 254},
  [5895] = {.lex_state = 217},
  [5896] = {.lex_state = 254},
  [5897] = {.lex_state = 217},
  [5898] = {.lex_state = 217},
  [5899] = {.lex_state = 217},
  [5900] = {.lex_state = 217},
  [5901] = {.lex_state = 217},
  [5902] = {.lex_state = 217},
  [5903] = {.lex_state = 217},
  [5904] = {.lex_state = 217},
  [5905] = {.lex_state = 217},
  [5906] = {.lex_state = 217},
  [5907] = {.lex_state = 217},
  [5908] = {.lex_state = 217},
  [5909] = {.lex_state = 254},
  [5910] = {.lex_state = 217},
  [5911] = {.lex_state = 254},
  [5912] = {.lex_state = 254},
  [5913] = {.lex_state = 254},
  [5914] = {.lex_state = 217},
  [5915] = {.lex_state = 217},
  [5916] = {.lex_state = 217},
  [5917] = {.lex_state = 217},
  [5918] = {.lex_state = 217},
  [5919] = {.lex_state = 217},
  [5920] = {.lex_state = 217},
  [5921] = {.lex_state = 217},
  [5922] = {.lex_state = 254},
  [5923] = {.lex_state = 217},
  [5924] = {.lex_state = 217},
  [5925] = {.lex_state = 217},
  [5926] = {.lex_state = 254},
  [5927] = {.lex_state = 217},
  [5928] = {.lex_state = 256},
  [5929] = {.lex_state = 217},
  [5930] = {.lex_state = 254},
  [5931] = {.lex_state = 254},
  [5932] = {.lex_state = 217},
  [5933] = {.lex_state = 217},
  [5934] = {.lex_state = 217},
  [5935] = {.lex_state = 217},
  [5936] = {.lex_state = 217},
  [5937] = {.lex_state = 217},
  [5938] = {.lex_state = 254},
  [5939] = {.lex_state = 217},
  [5940] = {.lex_state = 217},
  [5941] = {.lex_state = 254},
  [5942] = {.lex_state = 254},
  [5943] = {.lex_state = 217},
  [5944] = {.lex_state = 254},
  [5945] = {.lex_state = 254},
  [5946] = {.lex_state = 217},
  [5947] = {.lex_state = 217},
  [5948] = {.lex_state = 217},
  [5949] = {.lex_state = 217},
  [5950] = {.lex_state = 217},
  [5951] = {.lex_state = 254},
  [5952] = {.lex_state = 217},
  [5953] = {.lex_state = 254},
  [5954] = {.lex_state = 217},
  [5955] = {.lex_state = 217},
  [5956] = {.lex_state = 254},
  [5957] = {.lex_state = 254},
  [5958] = {.lex_state = 256},
  [5959] = {.lex_state = 254},
  [5960] = {.lex_state = 217},
  [5961] = {.lex_state = 217},
  [5962] = {.lex_state = 217},
  [5963] = {.lex_state = 217},
  [5964] = {.lex_state = 254},
  [5965] = {.lex_state = 217},
  [5966] = {.lex_state = 254},
  [5967] = {.lex_state = 217},
  [5968] = {.lex_state = 254},
  [5969] = {.lex_state = 256},
  [5970] = {.lex_state = 251},
  [5971] = {.lex_state = 217},
  [5972] = {.lex_state = 217},
  [5973] = {.lex_state = 254},
  [5974] = {.lex_state = 217},
  [5975] = {.lex_state = 217},
  [5976] = {.lex_state = 243},
  [5977] = {.lex_state = 254},
  [5978] = {.lex_state = 217},
  [5979] = {.lex_state = 217},
  [5980] = {.lex_state = 254},
  [5981] = {.lex_state = 254},
  [5982] = {.lex_state = 217},
  [5983] = {.lex_state = 254},
  [5984] = {.lex_state = 254},
  [5985] = {.lex_state = 217},
  [5986] = {.lex_state = 256},
  [5987] = {.lex_state = 217},
  [5988] = {.lex_state = 254},
  [5989] = {.lex_state = 217},
  [5990] = {.lex_state = 217},
  [5991] = {.lex_state = 217},
  [5992] = {.lex_state = 254},
  [5993] = {.lex_state = 217},
  [5994] = {.lex_state = 217},
  [5995] = {.lex_state = 254},
  [5996] = {.lex_state = 217},
  [5997] = {.lex_state = 217},
  [5998] = {.lex_state = 254},
  [5999] = {.lex_state = 217},
  [6000] = {.lex_state = 256},
  [6001] = {.lex_state = 254},
  [6002] = {.lex_state = 217},
  [6003] = {.lex_state = 217},
  [6004] = {.lex_state = 217},
  [6005] = {.lex_state = 236},
  [6006] = {.lex_state = 254},
  [6007] = {.lex_state = 217},
  [6008] = {.lex_state = 254},
  [6009] = {.lex_state = 217},
  [6010] = {.lex_state = 217},
  [6011] = {.lex_state = 217},
  [6012] = {.lex_state = 217},
  [6013] = {.lex_state = 217},
  [6014] = {.lex_state = 217},
  [6015] = {.lex_state = 254},
  [6016] = {.lex_state = 217},
  [6017] = {.lex_state = 217},
  [6018] = {.lex_state = 254},
  [6019] = {.lex_state = 217},
  [6020] = {.lex_state = 217},
  [6021] = {.lex_state = 217},
  [6022] = {.lex_state = 256},
  [6023] = {.lex_state = 217},
  [6024] = {.lex_state = 217},
  [6025] = {.lex_state = 217},
  [6026] = {.lex_state = 254},
  [6027] = {.lex_state = 217},
  [6028] = {.lex_state = 254},
  [6029] = {.lex_state = 217},
  [6030] = {.lex_state = 217},
  [6031] = {.lex_state = 217},
  [6032] = {.lex_state = 254},
  [6033] = {.lex_state = 256},
  [6034] = {.lex_state = 217},
  [6035] = {.lex_state = 217},
  [6036] = {.lex_state = 254},
  [6037] = {.lex_state = 217},
  [6038] = {.lex_state = 254},
  [6039] = {.lex_state = 254},
  [6040] = {.lex_state = 217},
  [6041] = {.lex_state = 217},
  [6042] = {.lex_state = 254},
  [6043] = {.lex_state = 254},
  [6044] = {.lex_state = 254},
  [6045] = {.lex_state = 217},
  [6046] = {.lex_state = 217},
  [6047] = {.lex_state = 217},
  [6048] = {.lex_state = 217},
  [6049] = {.lex_state = 254},
  [6050] = {.lex_state = 217},
  [6051] = {.lex_state = 217},
  [6052] = {.lex_state = 217},
  [6053] = {.lex_state = 254},
  [6054] = {.lex_state = 217},
  [6055] = {.lex_state = 217},
  [6056] = {.lex_state = 254},
  [6057] = {.lex_state = 217},
  [6058] = {.lex_state = 217},
  [6059] = {.lex_state = 217},
  [6060] = {.lex_state = 217},
  [6061] = {.lex_state = 217},
  [6062] = {.lex_state = 217},
  [6063] = {.lex_state = 254},
  [6064] = {.lex_state = 217},
  [6065] = {.lex_state = 217},
  [6066] = {.lex_state = 256},
  [6067] = {.lex_state = 217},
  [6068] = {.lex_state = 252},
  [6069] = {.lex_state = 240},
  [6070] = {.lex_state = 240},
  [6071] = {.lex_state = 254},
  [6072] = {.lex_state = 240},
  [6073] = {.lex_state = 237},
  [6074] = {.lex_state = 217},
  [6075] = {.lex_state = 240},
  [6076] = {.lex_state = 240},
  [6077] = {.lex_state = 240},
  [6078] = {.lex_state = 240},
  [6079] = {.lex_state = 252},
  [6080] = {.lex_state = 240},
  [6081] = {.lex_state = 237},
  [6082] = {.lex_state = 240},
  [6083] = {.lex_state = 237},
  [6084] = {.lex_state = 252},
  [6085] = {.lex_state = 253},
  [6086] = {.lex_state = 240},
  [6087] = {.lex_state = 252},
  [6088] = {.lex_state = 240},
  [6089] = {.lex_state = 254},
  [6090] = {.lex_state = 254},
  [6091] = {.lex_state = 240},
  [6092] = {.lex_state = 253},
  [6093] = {.lex_state = 240},
  [6094] = {.lex_state = 240},
  [6095] = {.lex_state = 252},
  [6096] = {.lex_state = 252},
  [6097] = {.lex_state = 252},
  [6098] = {.lex_state = 252},
  [6099] = {.lex_state = 217},
  [6100] = {.lex_state = 253},
  [6101] = {.lex_state = 251},
  [6102] = {.lex_state = 240},
  [6103] = {.lex_state = 252},
  [6104] = {.lex_state = 253},
  [6105] = {.lex_state = 218},
  [6106] = {.lex_state = 240},
  [6107] = {.lex_state = 253},
  [6108] = {.lex_state = 240},
  [6109] = {.lex_state = 251},
  [6110] = {.lex_state = 240},
  [6111] = {.lex_state = 253},
  [6112] = {.lex_state = 217},
  [6113] = {.lex_state = 240},
  [6114] = {.lex_state = 237},
  [6115] = {.lex_state = 252},
  [6116] = {.lex_state = 240},
  [6117] = {.lex_state = 240},
  [6118] = {.lex_state = 256},
  [6119] = {.lex_state = 252},
  [6120] = {.lex_state = 256},
  [6121] = {.lex_state = 240},
  [6122] = {.lex_state = 237},
  [6123] = {.lex_state = 253},
  [6124] = {.lex_state = 252},
  [6125] = {.lex_state = 240},
  [6126] = {.lex_state = 254},
  [6127] = {.lex_state = 254},
  [6128] = {.lex_state = 217},
  [6129] = {.lex_state = 240},
  [6130] = {.lex_state = 252},
  [6131] = {.lex_state = 217},
  [6132] = {.lex_state = 217},
  [6133] = {.lex_state = 252},
  [6134] = {.lex_state = 252},
  [6135] = {.lex_state = 253},
  [6136] = {.lex_state = 240},
  [6137] = {.lex_state = 254},
  [6138] = {.lex_state = 254},
  [6139] = {.lex_state = 254},
  [6140] = {.lex_state = 254},
  [6141] = {.lex_state = 254},
  [6142] = {.lex_state = 252},
  [6143] = {.lex_state = 240},
  [6144] = {.lex_state = 240},
  [6145] = {.lex_state = 240},
  [6146] = {.lex_state = 240},
  [6147] = {.lex_state = 240},
  [6148] = {.lex_state = 240},
  [6149] = {.lex_state = 240},
  [6150] = {.lex_state = 240},
  [6151] = {.lex_state = 240},
  [6152] = {.lex_state = 254},
  [6153] = {.lex_state = 240},
  [6154] = {.lex_state = 237},
  [6155] = {.lex_state = 240},
  [6156] = {.lex_state = 240},
  [6157] = {.lex_state = 240},
  [6158] = {.lex_state = 256},
  [6159] = {.lex_state = 256},
  [6160] = {.lex_state = 252},
  [6161] = {.lex_state = 256},
  [6162] = {.lex_state = 256},
  [6163] = {.lex_state = 237},
  [6164] = {.lex_state = 252},
  [6165] = {.lex_state = 253},
  [6166] = {.lex_state = 254},
  [6167] = {.lex_state = 254},
  [6168] = {.lex_state = 240},
  [6169] = {.lex_state = 254},
  [6170] = {.lex_state = 251},
  [6171] = {.lex_state = 251},
  [6172] = {.lex_state = 252},
  [6173] = {.lex_state = 217},
  [6174] = {.lex_state = 254},
  [6175] = {.lex_state = 217},
  [6176] = {.lex_state = 217},
  [6177] = {.lex_state = 237},
  [6178] = {.lex_state = 237},
  [6179] = {.lex_state = 217},
  [6180] = {.lex_state = 217},
  [6181] = {.lex_state = 217},
  [6182] = {.lex_state = 254},
  [6183] = {.lex_state = 237},
  [6184] = {.lex_state = 217},
  [6185] = {.lex_state = 253},
  [6186] = {.lex_state = 217},
  [6187] = {.lex_state = 253},
  [6188] = {.lex_state = 252},
  [6189] = {.lex_state = 256},
  [6190] = {.lex_state = 256},
  [6191] = {.lex_state = 253},
  [6192] = {.lex_state = 253},
  [6193] = {.lex_state = 253},
  [6194] = {.lex_state = 252},
  [6195] = {.lex_state = 253},
  [6196] = {.lex_state = 217},
  [6197] = {.lex_state = 252},
  [6198] = {.lex_state = 252},
  [6199] = {.lex_state = 237},
  [6200] = {.lex_state = 256},
  [6201] = {.lex_state = 251},
  [6202] = {.lex_state = 252},
  [6203] = {.lex_state = 252},
  [6204] = {.lex_state = 217},
  [6205] = {.lex_state = 252},
  [6206] = {.lex_state = 256},
  [6207] = {.lex_state = 252},
  [6208] = {.lex_state = 252},
  [6209] = {.lex_state = 252},
  [6210] = {.lex_state = 217},
  [6211] = {.lex_state = 252},
  [6212] = {.lex_state = 252},
  [6213] = {.lex_state = 252},
  [6214] = {.lex_state = 252},
  [6215] = {.lex_state = 237},
  [6216] = {.lex_state = 252},
  [6217] = {.lex_state = 254},
  [6218] = {.lex_state = 252},
  [6219] = {.lex_state = 217},
  [6220] = {.lex_state = 252},
  [6221] = {.lex_state = 252},
  [6222] = {.lex_state = 252},
  [6223] = {.lex_state = 252},
  [6224] = {.lex_state = 216},
  [6225] = {.lex_state = 216},
  [6226] = {.lex_state = 254},
  [6227] = {.lex_state = 254},
  [6228] = {.lex_state = 254},
  [6229] = {.lex_state = 253},
  [6230] = {.lex_state = 252},
  [6231] = {.lex_state = 252},
  [6232] = {.lex_state = 252},
  [6233] = {.lex_state = 252},
  [6234] = {.lex_state = 217},
  [6235] = {.lex_state = 217},
  [6236] = {.lex_state = 217},
  [6237] = {.lex_state = 252},
  [6238] = {.lex_state = 256},
  [6239] = {.lex_state = 254},
  [6240] = {.lex_state = 254},
  [6241] = {.lex_state = 253},
  [6242] = {.lex_state = 252},
  [6243] = {.lex_state = 253},
  [6244] = {.lex_state = 252},
  [6245] = {.lex_state = 253},
  [6246] = {.lex_state = 252},
  [6247] = {.lex_state = 253},
  [6248] = {.lex_state = 253},
  [6249] = {.lex_state = 252},
  [6250] = {.lex_state = 252},
  [6251] = {.lex_state = 252},
  [6252] = {.lex_state = 253},
  [6253] = {.lex_state = 252},
  [6254] = {.lex_state = 252},
  [6255] = {.lex_state = 253},
  [6256] = {.lex_state = 252},
  [6257] = {.lex_state = 253},
  [6258] = {.lex_state = 252},
  [6259] = {.lex_state = 252},
  [6260] = {.lex_state = 252},
  [6261] = {.lex_state = 254},
  [6262] = {.lex_state = 252},
  [6263] = {.lex_state = 252},
  [6264] = {.lex_state = 252},
  [6265] = {.lex_state = 252},
  [6266] = {.lex_state = 252},
  [6267] = {.lex_state = 252},
  [6268] = {.lex_state = 254},
  [6269] = {.lex_state = 253},
  [6270] = {.lex_state = 252},
  [6271] = {.lex_state = 252},
  [6272] = {.lex_state = 252},
  [6273] = {.lex_state = 252},
  [6274] = {.lex_state = 252},
  [6275] = {.lex_state = 253},
  [6276] = {.lex_state = 254},
  [6277] = {.lex_state = 252},
  [6278] = {.lex_state = 254},
  [6279] = {.lex_state = 256},
  [6280] = {.lex_state = 256},
  [6281] = {.lex_state = 252},
  [6282] = {.lex_state = 253},
  [6283] = {.lex_state = 252},
  [6284] = {.lex_state = 256},
  [6285] = {.lex_state = 256},
  [6286] = {.lex_state = 253},
  [6287] = {.lex_state = 252},
  [6288] = {.lex_state = 253},
  [6289] = {.lex_state = 252},
  [6290] = {.lex_state = 252},
  [6291] = {.lex_state = 256},
  [6292] = {.lex_state = 256},
  [6293] = {.lex_state = 252},
  [6294] = {.lex_state = 252},
  [6295] = {.lex_state = 252},
  [6296] = {.lex_state = 256},
  [6297] = {.lex_state = 252},
  [6298] = {.lex_state = 252},
  [6299] = {.lex_state = 217},
  [6300] = {.lex_state = 253},
  [6301] = {.lex_state = 256},
  [6302] = {.lex_state = 253},
  [6303] = {.lex_state = 252},
  [6304] = {.lex_state = 252},
  [6305] = {.lex_state = 252},
  [6306] = {.lex_state = 252},
  [6307] = {.lex_state = 252},
  [6308] = {.lex_state = 253},
  [6309] = {.lex_state = 252},
  [6310] = {.lex_state = 252},
  [6311] = {.lex_state = 252},
  [6312] = {.lex_state = 253},
  [6313] = {.lex_state = 252},
  [6314] = {.lex_state = 252},
  [6315] = {.lex_state = 252},
  [6316] = {.lex_state = 252},
  [6317] = {.lex_state = 254},
  [6318] = {.lex_state = 252},
  [6319] = {.lex_state = 254},
  [6320] = {.lex_state = 253},
  [6321] = {.lex_state = 254},
  [6322] = {.lex_state = 253},
  [6323] = {.lex_state = 252},
  [6324] = {.lex_state = 237},
  [6325] = {.lex_state = 253},
  [6326] = {.lex_state = 253},
  [6327] = {.lex_state = 252},
  [6328] = {.lex_state = 252},
  [6329] = {.lex_state = 254},
  [6330] = {.lex_state = 252},
  [6331] = {.lex_state = 252},
  [6332] = {.lex_state = 252},
  [6333] = {.lex_state = 252},
  [6334] = {.lex_state = 252},
  [6335] = {.lex_state = 253},
  [6336] = {.lex_state = 256},
  [6337] = {.lex_state = 252},
  [6338] = {.lex_state = 253},
  [6339] = {.lex_state = 254},
  [6340] = {.lex_state = 256},
  [6341] = {.lex_state = 253},
  [6342] = {.lex_state = 252},
  [6343] = {.lex_state = 252},
  [6344] = {.lex_state = 252},
  [6345] = {.lex_state = 252},
  [6346] = {.lex_state = 252},
  [6347] = {.lex_state = 252},
  [6348] = {.lex_state = 217},
  [6349] = {.lex_state = 217},
  [6350] = {.lex_state = 252},
  [6351] = {.lex_state = 253},
  [6352] = {.lex_state = 252},
  [6353] = {.lex_state = 217},
  [6354] = {.lex_state = 252},
  [6355] = {.lex_state = 252},
  [6356] = {.lex_state = 253},
  [6357] = {.lex_state = 252},
  [6358] = {.lex_state = 237},
  [6359] = {.lex_state = 256},
  [6360] = {.lex_state = 251},
  [6361] = {.lex_state = 217},
  [6362] = {.lex_state = 254},
  [6363] = {.lex_state = 237},
  [6364] = {.lex_state = 254},
  [6365] = {.lex_state = 237},
  [6366] = {.lex_state = 237},
  [6367] = {.lex_state = 254},
  [6368] = {.lex_state = 254},
  [6369] = {.lex_state = 251},
  [6370] = {.lex_state = 217},
  [6371] = {.lex_state = 251},
  [6372] = {.lex_state = 217},
  [6373] = {.lex_state = 237},
  [6374] = {.lex_state = 256},
  [6375] = {.lex_state = 251},
  [6376] = {.lex_state = 256},
  [6377] = {.lex_state = 237},
  [6378] = {.lex_state = 251},
  [6379] = {.lex_state = 251},
  [6380] = {.lex_state = 254},
  [6381] = {.lex_state = 217},
  [6382] = {.lex_state = 237},
  [6383] = {.lex_state = 254},
  [6384] = {.lex_state = 254},
  [6385] = {.lex_state = 252},
  [6386] = {.lex_state = 252},
  [6387] = {.lex_state = 251},
  [6388] = {.lex_state = 251},
  [6389] = {.lex_state = 237},
  [6390] = {.lex_state = 251},
  [6391] = {.lex_state = 237},
  [6392] = {.lex_state = 251},
  [6393] = {.lex_state = 217},
  [6394] = {.lex_state = 251},
  [6395] = {.lex_state = 251},
  [6396] = {.lex_state = 251},
  [6397] = {.lex_state = 251},
  [6398] = {.lex_state = 217},
  [6399] = {.lex_state = 251},
  [6400] = {.lex_state = 251},
  [6401] = {.lex_state = 217},
  [6402] = {.lex_state = 256},
  [6403] = {.lex_state = 251},
  [6404] = {.lex_state = 251},
  [6405] = {.lex_state = 237},
  [6406] = {.lex_state = 251},
  [6407] = {.lex_state = 217},
  [6408] = {.lex_state = 254},
  [6409] = {.lex_state = 237},
  [6410] = {.lex_state = 251},
  [6411] = {.lex_state = 253},
  [6412] = {.lex_state = 207},
  [6413] = {.lex_state = 252},
  [6414] = {.lex_state = 237},
  [6415] = {.lex_state = 251},
  [6416] = {.lex_state = 253},
  [6417] = {.lex_state = 254},
  [6418] = {.lex_state = 207},
  [6419] = {.lex_state = 252},
  [6420] = {.lex_state = 207},
  [6421] = {.lex_state = 254},
  [6422] = {.lex_state = 207},
  [6423] = {.lex_state = 251},
  [6424] = {.lex_state = 207},
  [6425] = {.lex_state = 217},
  [6426] = {.lex_state = 207},
  [6427] = {.lex_state = 207},
  [6428] = {.lex_state = 207},
  [6429] = {.lex_state = 251},
  [6430] = {.lex_state = 254},
  [6431] = {.lex_state = 251},
  [6432] = {.lex_state = 252},
  [6433] = {.lex_state = 251},
  [6434] = {.lex_state = 207},
  [6435] = {.lex_state = 207},
  [6436] = {.lex_state = 251},
  [6437] = {.lex_state = 251},
  [6438] = {.lex_state = 254},
  [6439] = {.lex_state = 251},
  [6440] = {.lex_state = 207},
  [6441] = {.lex_state = 252},
  [6442] = {.lex_state = 237},
  [6443] = {.lex_state = 207},
  [6444] = {.lex_state = 254},
  [6445] = {.lex_state = 207},
  [6446] = {.lex_state = 252},
  [6447] = {.lex_state = 252},
  [6448] = {.lex_state = 253},
  [6449] = {.lex_state = 254},
  [6450] = {.lex_state = 252},
  [6451] = {.lex_state = 237},
  [6452] = {.lex_state = 254},
  [6453] = {.lex_state = 252},
  [6454] = {.lex_state = 252},
  [6455] = {.lex_state = 217},
  [6456] = {.lex_state = 254},
  [6457] = {.lex_state = 251},
  [6458] = {.lex_state = 207},
  [6459] = {.lex_state = 254},
  [6460] = {.lex_state = 252},
  [6461] = {.lex_state = 207},
  [6462] = {.lex_state = 252},
  [6463] = {.lex_state = 253},
  [6464] = {.lex_state = 252},
  [6465] = {.lex_state = 251},
  [6466] = {.lex_state = 207},
  [6467] = {.lex_state = 217},
  [6468] = {.lex_state = 252},
  [6469] = {.lex_state = 252},
  [6470] = {.lex_state = 254},
  [6471] = {.lex_state = 237},
  [6472] = {.lex_state = 254},
  [6473] = {.lex_state = 217},
  [6474] = {.lex_state = 252},
  [6475] = {.lex_state = 252},
  [6476] = {.lex_state = 254},
  [6477] = {.lex_state = 251},
  [6478] = {.lex_state = 252},
  [6479] = {.lex_state = 254},
  [6480] = {.lex_state = 217},
  [6481] = {.lex_state = 217},
  [6482] = {.lex_state = 253},
  [6483] = {.lex_state = 254},
  [6484] = {.lex_state = 253},
  [6485] = {.lex_state = 217},
  [6486] = {.lex_state = 217},
  [6487] = {.lex_state = 217},
  [6488] = {.lex_state = 217},
  [6489] = {.lex_state = 254},
  [6490] = {.lex_state = 217},
  [6491] = {.lex_state = 254},
  [6492] = {.lex_state = 254},
  [6493] = {.lex_state = 254},
  [6494] = {.lex_state = 217},
  [6495] = {.lex_state = 217},
  [6496] = {.lex_state = 217},
  [6497] = {.lex_state = 254},
  [6498] = {.lex_state = 217},
  [6499] = {.lex_state = 254},
  [6500] = {.lex_state = 254},
  [6501] = {.lex_state = 256},
  [6502] = {.lex_state = 256},
  [6503] = {.lex_state = 217},
  [6504] = {.lex_state = 254},
  [6505] = {.lex_state = 253},
  [6506] = {.lex_state = 217},
  [6507] = {.lex_state = 217},
  [6508] = {.lex_state = 252},
  [6509] = {.lex_state = 256},
  [6510] = {.lex_state = 217},
  [6511] = {.lex_state = 253},
  [6512] = {.lex_state = 256},
  [6513] = {.lex_state = 254},
  [6514] = {.lex_state = 254},
  [6515] = {.lex_state = 217},
  [6516] = {.lex_state = 252},
  [6517] = {.lex_state = 252},
  [6518] = {.lex_state = 254},
  [6519] = {.lex_state = 217},
  [6520] = {.lex_state = 252},
  [6521] = {.lex_state = 252},
  [6522] = {.lex_state = 252},
  [6523] = {.lex_state = 252},
  [6524] = {.lex_state = 252},
  [6525] = {.lex_state = 252},
  [6526] = {.lex_state = 252},
  [6527] = {.lex_state = 252},
  [6528] = {.lex_state = 252},
  [6529] = {.lex_state = 252},
  [6530] = {.lex_state = 254},
  [6531] = {.lex_state = 217},
  [6532] = {.lex_state = 217},
  [6533] = {.lex_state = 217},
  [6534] = {.lex_state = 217},
  [6535] = {.lex_state = 217},
  [6536] = {.lex_state = 207},
  [6537] = {.lex_state = 254},
  [6538] = {.lex_state = 207},
  [6539] = {.lex_state = 251},
  [6540] = {.lex_state = 207},
  [6541] = {.lex_state = 207},
  [6542] = {.lex_state = 256},
  [6543] = {.lex_state = 254},
  [6544] = {.lex_state = 207},
  [6545] = {.lex_state = 254},
  [6546] = {.lex_state = 207},
  [6547] = {.lex_state = 254},
  [6548] = {.lex_state = 207},
  [6549] = {.lex_state = 254},
  [6550] = {.lex_state = 256},
  [6551] = {.lex_state = 254},
  [6552] = {.lex_state = 207},
  [6553] = {.lex_state = 207},
  [6554] = {.lex_state = 207},
  [6555] = {.lex_state = 254},
  [6556] = {.lex_state = 207},
  [6557] = {.lex_state = 207},
  [6558] = {.lex_state = 207},
  [6559] = {.lex_state = 254},
  [6560] = {.lex_state = 254},
  [6561] = {.lex_state = 207},
  [6562] = {.lex_state = 207},
  [6563] = {.lex_state = 207},
  [6564] = {.lex_state = 207},
  [6565] = {.lex_state = 207},
  [6566] = {.lex_state = 207},
  [6567] = {.lex_state = 251},
  [6568] = {.lex_state = 207},
  [6569] = {.lex_state = 253},
  [6570] = {.lex_state = 251},
  [6571] = {.lex_state = 207},
  [6572] = {.lex_state = 207},
  [6573] = {.lex_state = 251},
  [6574] = {.lex_state = 254},
  [6575] = {.lex_state = 207},
  [6576] = {.lex_state = 207},
  [6577] = {.lex_state = 207},
  [6578] = {.lex_state = 207},
  [6579] = {.lex_state = 253},
  [6580] = {.lex_state = 207},
  [6581] = {.lex_state = 207},
  [6582] = {.lex_state = 207},
  [6583] = {.lex_state = 207},
  [6584] = {.lex_state = 207},
  [6585] = {.lex_state = 254},
  [6586] = {.lex_state = 252},
  [6587] = {.lex_state = 207},
  [6588] = {.lex_state = 207},
  [6589] = {.lex_state = 207},
  [6590] = {.lex_state = 207},
  [6591] = {.lex_state = 254},
  [6592] = {.lex_state = 207},
  [6593] = {.lex_state = 207},
  [6594] = {.lex_state = 207},
  [6595] = {.lex_state = 207},
  [6596] = {.lex_state = 207},
  [6597] = {.lex_state = 207},
  [6598] = {.lex_state = 207},
  [6599] = {.lex_state = 254},
  [6600] = {.lex_state = 207},
  [6601] = {.lex_state = 207},
  [6602] = {.lex_state = 207},
  [6603] = {.lex_state = 207},
  [6604] = {.lex_state = 207},
  [6605] = {.lex_state = 207},
  [6606] = {.lex_state = 207},
  [6607] = {.lex_state = 207},
  [6608] = {.lex_state = 207},
  [6609] = {.lex_state = 207},
  [6610] = {.lex_state = 207},
  [6611] = {.lex_state = 207},
  [6612] = {.lex_state = 207},
  [6613] = {.lex_state = 207},
  [6614] = {.lex_state = 253},
  [6615] = {.lex_state = 207},
  [6616] = {.lex_state = 207},
  [6617] = {.lex_state = 207},
  [6618] = {.lex_state = 207},
  [6619] = {.lex_state = 207},
  [6620] = {.lex_state = 237},
  [6621] = {.lex_state = 253},
  [6622] = {.lex_state = 207},
  [6623] = {.lex_state = 207},
  [6624] = {.lex_state = 253},
  [6625] = {.lex_state = 207},
  [6626] = {.lex_state = 207},
  [6627] = {.lex_state = 207},
  [6628] = {.lex_state = 207},
  [6629] = {.lex_state = 207},
  [6630] = {.lex_state = 207},
  [6631] = {.lex_state = 207},
  [6632] = {.lex_state = 207},
  [6633] = {.lex_state = 207},
  [6634] = {.lex_state = 207},
  [6635] = {.lex_state = 207},
  [6636] = {.lex_state = 207},
  [6637] = {.lex_state = 207},
  [6638] = {.lex_state = 207},
  [6639] = {.lex_state = 207},
  [6640] = {.lex_state = 207},
  [6641] = {.lex_state = 207},
  [6642] = {.lex_state = 207},
  [6643] = {.lex_state = 207},
  [6644] = {.lex_state = 207},
  [6645] = {.lex_state = 207},
  [6646] = {.lex_state = 207},
  [6647] = {.lex_state = 253},
  [6648] = {.lex_state = 207},
  [6649] = {.lex_state = 207},
  [6650] = {.lex_state = 207},
  [6651] = {.lex_state = 207},
  [6652] = {.lex_state = 207},
  [6653] = {.lex_state = 207},
  [6654] = {.lex_state = 207},
  [6655] = {.lex_state = 253},
  [6656] = {.lex_state = 207},
  [6657] = {.lex_state = 207},
  [6658] = {.lex_state = 207},
  [6659] = {.lex_state = 207},
  [6660] = {.lex_state = 207},
  [6661] = {.lex_state = 207},
  [6662] = {.lex_state = 207},
  [6663] = {.lex_state = 207},
  [6664] = {.lex_state = 207},
  [6665] = {.lex_state = 207},
  [6666] = {.lex_state = 207},
  [6667] = {.lex_state = 207},
  [6668] = {.lex_state = 207},
  [6669] = {.lex_state = 207},
  [6670] = {.lex_state = 207},
  [6671] = {.lex_state = 207},
  [6672] = {.lex_state = 207},
  [6673] = {.lex_state = 253},
  [6674] = {.lex_state = 207},
  [6675] = {.lex_state = 207},
  [6676] = {.lex_state = 207},
  [6677] = {.lex_state = 207},
  [6678] = {.lex_state = 207},
  [6679] = {.lex_state = 207},
  [6680] = {.lex_state = 207},
  [6681] = {.lex_state = 252},
  [6682] = {.lex_state = 254},
  [6683] = {.lex_state = 207},
  [6684] = {.lex_state = 237},
  [6685] = {.lex_state = 256},
  [6686] = {.lex_state = 207},
  [6687] = {.lex_state = 207},
  [6688] = {.lex_state = 207},
  [6689] = {.lex_state = 207},
  [6690] = {.lex_state = 207},
  [6691] = {.lex_state = 207},
  [6692] = {.lex_state = 207},
  [6693] = {.lex_state = 207},
  [6694] = {.lex_state = 254},
  [6695] = {.lex_state = 207},
  [6696] = {.lex_state = 207},
  [6697] = {.lex_state = 207},
  [6698] = {.lex_state = 207},
  [6699] = {.lex_state = 207},
  [6700] = {.lex_state = 207},
  [6701] = {.lex_state = 207},
  [6702] = {.lex_state = 207},
  [6703] = {.lex_state = 207},
  [6704] = {.lex_state = 207},
  [6705] = {.lex_state = 207},
  [6706] = {.lex_state = 207},
  [6707] = {.lex_state = 207},
  [6708] = {.lex_state = 207},
  [6709] = {.lex_state = 207},
  [6710] = {.lex_state = 207},
  [6711] = {.lex_state = 253},
  [6712] = {.lex_state = 207},
  [6713] = {.lex_state = 207},
  [6714] = {.lex_state = 207},
  [6715] = {.lex_state = 207},
  [6716] = {.lex_state = 207},
  [6717] = {.lex_state = 207},
  [6718] = {.lex_state = 207},
  [6719] = {.lex_state = 207},
  [6720] = {.lex_state = 207},
  [6721] = {.lex_state = 207},
  [6722] = {.lex_state = 207},
  [6723] = {.lex_state = 207},
  [6724] = {.lex_state = 207},
  [6725] = {.lex_state = 207},
  [6726] = {.lex_state = 207},
  [6727] = {.lex_state = 207},
  [6728] = {.lex_state = 207},
  [6729] = {.lex_state = 207},
  [6730] = {.lex_state = 207},
  [6731] = {.lex_state = 207},
  [6732] = {.lex_state = 253},
  [6733] = {.lex_state = 207},
  [6734] = {.lex_state = 207},
  [6735] = {.lex_state = 207},
  [6736] = {.lex_state = 207},
  [6737] = {.lex_state = 207},
  [6738] = {.lex_state = 207},
  [6739] = {.lex_state = 207},
  [6740] = {.lex_state = 207},
  [6741] = {.lex_state = 254},
  [6742] = {.lex_state = 207},
  [6743] = {.lex_state = 207},
  [6744] = {.lex_state = 207},
  [6745] = {.lex_state = 207},
  [6746] = {.lex_state = 207},
  [6747] = {.lex_state = 256},
  [6748] = {.lex_state = 256},
  [6749] = {.lex_state = 256},
  [6750] = {.lex_state = 207},
  [6751] = {.lex_state = 256},
  [6752] = {.lex_state = 207},
  [6753] = {.lex_state = 256},
  [6754] = {.lex_state = 207},
  [6755] = {.lex_state = 207},
  [6756] = {.lex_state = 256},
  [6757] = {.lex_state = 256},
  [6758] = {.lex_state = 207},
  [6759] = {.lex_state = 251},
  [6760] = {.lex_state = 256},
  [6761] = {.lex_state = 251},
  [6762] = {.lex_state = 207},
  [6763] = {.lex_state = 207},
  [6764] = {.lex_state = 251},
  [6765] = {.lex_state = 256},
  [6766] = {.lex_state = 256},
  [6767] = {.lex_state = 256},
  [6768] = {.lex_state = 207},
  [6769] = {.lex_state = 256},
  [6770] = {.lex_state = 207},
  [6771] = {.lex_state = 254},
  [6772] = {.lex_state = 256},
  [6773] = {.lex_state = 217},
  [6774] = {.lex_state = 252},
  [6775] = {.lex_state = 207},
  [6776] = {.lex_state = 207},
  [6777] = {.lex_state = 207},
  [6778] = {.lex_state = 207},
  [6779] = {.lex_state = 256},
  [6780] = {.lex_state = 256},
  [6781] = {.lex_state = 256},
  [6782] = {.lex_state = 207},
  [6783] = {.lex_state = 207},
  [6784] = {.lex_state = 256},
  [6785] = {.lex_state = 207},
  [6786] = {.lex_state = 207},
  [6787] = {.lex_state = 256},
  [6788] = {.lex_state = 252},
  [6789] = {.lex_state = 207},
  [6790] = {.lex_state = 256},
  [6791] = {.lex_state = 256},
  [6792] = {.lex_state = 256},
  [6793] = {.lex_state = 207},
  [6794] = {.lex_state = 207},
  [6795] = {.lex_state = 254},
  [6796] = {.lex_state = 207},
  [6797] = {.lex_state = 256},
  [6798] = {.lex_state = 237},
  [6799] = {.lex_state = 256},
  [6800] = {.lex_state = 251},
  [6801] = {.lex_state = 207},
  [6802] = {.lex_state = 251},
  [6803] = {.lex_state = 256},
  [6804] = {.lex_state = 254},
  [6805] = {.lex_state = 254},
  [6806] = {.lex_state = 256},
  [6807] = {.lex_state = 217},
  [6808] = {.lex_state = 207},
  [6809] = {.lex_state = 256},
  [6810] = {.lex_state = 256},
  [6811] = {.lex_state = 207},
  [6812] = {.lex_state = 251},
  [6813] = {.lex_state = 254},
  [6814] = {.lex_state = 254},
  [6815] = {.lex_state = 207},
  [6816] = {.lex_state = 253},
  [6817] = {.lex_state = 253},
  [6818] = {.lex_state = 253},
  [6819] = {.lex_state = 253},
  [6820] = {.lex_state = 254},
  [6821] = {.lex_state = 253},
  [6822] = {.lex_state = 207},
  [6823] = {.lex_state = 253},
  [6824] = {.lex_state = 253},
  [6825] = {.lex_state = 253},
  [6826] = {.lex_state = 253},
  [6827] = {.lex_state = 253},
  [6828] = {.lex_state = 253},
  [6829] = {.lex_state = 253},
  [6830] = {.lex_state = 207},
  [6831] = {.lex_state = 253},
  [6832] = {.lex_state = 254},
  [6833] = {.lex_state = 253},
  [6834] = {.lex_state = 254},
  [6835] = {.lex_state = 253},
  [6836] = {.lex_state = 253},
  [6837] = {.lex_state = 253},
  [6838] = {.lex_state = 254},
  [6839] = {.lex_state = 207},
  [6840] = {.lex_state = 253},
  [6841] = {.lex_state = 253},
  [6842] = {.lex_state = 207},
  [6843] = {.lex_state = 253},
  [6844] = {.lex_state = 253},
  [6845] = {.lex_state = 254},
  [6846] = {.lex_state = 253},
  [6847] = {.lex_state = 253},
  [6848] = {.lex_state = 253},
  [6849] = {.lex_state = 253},
  [6850] = {.lex_state = 253},
  [6851] = {.lex_state = 253},
  [6852] = {.lex_state = 254},
  [6853] = {.lex_state = 252},
  [6854] = {.lex_state = 253},
  [6855] = {.lex_state = 253},
  [6856] = {.lex_state = 254},
  [6857] = {.lex_state = 253},
  [6858] = {.lex_state = 253},
  [6859] = {.lex_state = 253},
  [6860] = {.lex_state = 253},
  [6861] = {.lex_state = 253},
  [6862] = {.lex_state = 252},
  [6863] = {.lex_state = 207},
  [6864] = {.lex_state = 253},
  [6865] = {.lex_state = 254},
  [6866] = {.lex_state = 254},
  [6867] = {.lex_state = 253},
  [6868] = {.lex_state = 253},
  [6869] = {.lex_state = 253},
  [6870] = {.lex_state = 253},
  [6871] = {.lex_state = 253},
  [6872] = {.lex_state = 253},
  [6873] = {.lex_state = 207},
  [6874] = {.lex_state = 254},
  [6875] = {.lex_state = 254},
  [6876] = {.lex_state = 254},
  [6877] = {.lex_state = 251},
  [6878] = {.lex_state = 254},
  [6879] = {.lex_state = 254},
  [6880] = {.lex_state = 254},
  [6881] = {.lex_state = 254},
  [6882] = {.lex_state = 254},
  [6883] = {.lex_state = 254},
  [6884] = {.lex_state = 254},
  [6885] = {.lex_state = 254},
  [6886] = {.lex_state = 254},
  [6887] = {.lex_state = 251},
  [6888] = {.lex_state = 254},
  [6889] = {.lex_state = 251},
  [6890] = {.lex_state = 254},
  [6891] = {.lex_state = 207},
  [6892] = {.lex_state = 207},
  [6893] = {.lex_state = 207},
  [6894] = {.lex_state = 254},
  [6895] = {.lex_state = 207},
  [6896] = {.lex_state = 207},
  [6897] = {.lex_state = 207},
  [6898] = {.lex_state = 207},
  [6899] = {.lex_state = 207},
  [6900] = {.lex_state = 251},
  [6901] = {.lex_state = 254},
  [6902] = {.lex_state = 251},
  [6903] = {.lex_state = 251},
  [6904] = {.lex_state = 207},
  [6905] = {.lex_state = 254},
  [6906] = {.lex_state = 207},
  [6907] = {.lex_state = 207},
  [6908] = {.lex_state = 254},
  [6909] = {.lex_state = 207},
  [6910] = {.lex_state = 207},
  [6911] = {.lex_state = 251},
  [6912] = {.lex_state = 251},
  [6913] = {.lex_state = 207},
  [6914] = {.lex_state = 254},
  [6915] = {.lex_state = 207},
  [6916] = {.lex_state = 256},
  [6917] = {.lex_state = 252},
  [6918] = {.lex_state = 252},
  [6919] = {.lex_state = 252},
  [6920] = {.lex_state = 252},
  [6921] = {.lex_state = 266},
  [6922] = {.lex_state = 254},
  [6923] = {.lex_state = 266},
  [6924] = {.lex_state = 266},
  [6925] = {.lex_state = 207},
  [6926] = {.lex_state = 266},
  [6927] = {.lex_state = 266},
  [6928] = {.lex_state = 207},
  [6929] = {.lex_state = 266},
  [6930] = {.lex_state = 266},
  [6931] = {.lex_state = 254},
  [6932] = {.lex_state = 254},
  [6933] = {.lex_state = 254},
  [6934] = {.lex_state = 254},
  [6935] = {.lex_state = 254},
  [6936] = {.lex_state = 254},
  [6937] = {.lex_state = 254},
  [6938] = {.lex_state = 254},
  [6939] = {.lex_state = 254},
  [6940] = {.lex_state = 254},
  [6941] = {.lex_state = 254},
  [6942] = {.lex_state = 256},
  [6943] = {.lex_state = 254},
  [6944] = {.lex_state = 254},
  [6945] = {.lex_state = 237},
  [6946] = {.lex_state = 254},
  [6947] = {.lex_state = 254},
  [6948] = {.lex_state = 254},
  [6949] = {.lex_state = 254},
  [6950] = {.lex_state = 254},
  [6951] = {.lex_state = 254},
  [6952] = {.lex_state = 254},
  [6953] = {.lex_state = 254},
  [6954] = {.lex_state = 254},
  [6955] = {.lex_state = 254},
  [6956] = {.lex_state = 256},
  [6957] = {.lex_state = 266},
  [6958] = {.lex_state = 256},
  [6959] = {.lex_state = 256},
  [6960] = {.lex_state = 266},
  [6961] = {.lex_state = 256},
  [6962] = {.lex_state = 256},
  [6963] = {.lex_state = 256},
  [6964] = {.lex_state = 266},
  [6965] = {.lex_state = 266},
  [6966] = {.lex_state = 256},
  [6967] = {.lex_state = 256},
  [6968] = {.lex_state = 256},
  [6969] = {.lex_state = 254},
  [6970] = {.lex_state = 266},
  [6971] = {.lex_state = 266},
  [6972] = {.lex_state = 237},
  [6973] = {.lex_state = 256},
  [6974] = {.lex_state = 266},
  [6975] = {.lex_state = 266},
  [6976] = {.lex_state = 266},
  [6977] = {.lex_state = 266},
  [6978] = {.lex_state = 266},
  [6979] = {.lex_state = 266},
  [6980] = {.lex_state = 254},
  [6981] = {.lex_state = 256},
  [6982] = {.lex_state = 266},
  [6983] = {.lex_state = 266},
  [6984] = {.lex_state = 237},
  [6985] = {.lex_state = 237},
  [6986] = {.lex_state = 266},
  [6987] = {.lex_state = 251},
  [6988] = {.lex_state = 266},
  [6989] = {.lex_state = 266},
  [6990] = {.lex_state = 253},
  [6991] = {.lex_state = 217},
  [6992] = {.lex_state = 266},
  [6993] = {.lex_state = 266},
  [6994] = {.lex_state = 266},
  [6995] = {.lex_state = 266},
  [6996] = {.lex_state = 266},
  [6997] = {.lex_state = 266},
  [6998] = {.lex_state = 266},
  [6999] = {.lex_state = 256},
  [7000] = {.lex_state = 256},
  [7001] = {.lex_state = 251},
  [7002] = {.lex_state = 254},
  [7003] = {.lex_state = 220},
  [7004] = {.lex_state = 254},
  [7005] = {.lex_state = 251},
  [7006] = {.lex_state = 254},
  [7007] = {.lex_state = 266},
  [7008] = {.lex_state = 254},
  [7009] = {.lex_state = 266},
  [7010] = {.lex_state = 266},
  [7011] = {.lex_state = 266},
  [7012] = {.lex_state = 251},
  [7013] = {.lex_state = 266},
  [7014] = {.lex_state = 266},
  [7015] = {.lex_state = 237},
  [7016] = {.lex_state = 256},
  [7017] = {.lex_state = 266},
  [7018] = {.lex_state = 266},
  [7019] = {.lex_state = 266},
  [7020] = {.lex_state = 266},
  [7021] = {.lex_state = 254},
  [7022] = {.lex_state = 266},
  [7023] = {.lex_state = 266},
  [7024] = {.lex_state = 266},
  [7025] = {.lex_state = 266},
  [7026] = {.lex_state = 266},
  [7027] = {.lex_state = 266},
  [7028] = {.lex_state = 266},
  [7029] = {.lex_state = 266},
  [7030] = {.lex_state = 256},
  [7031] = {.lex_state = 256},
  [7032] = {.lex_state = 256},
  [7033] = {.lex_state = 256},
  [7034] = {.lex_state = 254},
  [7035] = {.lex_state = 254},
  [7036] = {.lex_state = 254},
  [7037] = {.lex_state = 254},
  [7038] = {.lex_state = 254},
  [7039] = {.lex_state = 256},
  [7040] = {.lex_state = 256},
  [7041] = {.lex_state = 256},
  [7042] = {.lex_state = 256},
  [7043] = {.lex_state = 266},
  [7044] = {.lex_state = 266},
  [7045] = {.lex_state = 266},
  [7046] = {.lex_state = 266},
  [7047] = {.lex_state = 256},
  [7048] = {.lex_state = 256},
  [7049] = {.lex_state = 237},
  [7050] = {.lex_state = 256},
  [7051] = {.lex_state = 256},
  [7052] = {.lex_state = 256},
  [7053] = {.lex_state = 251},
  [7054] = {.lex_state = 266},
  [7055] = {.lex_state = 254},
  [7056] = {.lex_state = 207},
  [7057] = {.lex_state = 207},
  [7058] = {.lex_state = 207},
  [7059] = {.lex_state = 207},
  [7060] = {.lex_state = 207},
  [7061] = {.lex_state = 254},
  [7062] = {.lex_state = 207},
  [7063] = {.lex_state = 207},
  [7064] = {.lex_state = 207},
  [7065] = {.lex_state = 207},
  [7066] = {.lex_state = 207},
  [7067] = {.lex_state = 207},
  [7068] = {.lex_state = 207},
  [7069] = {.lex_state = 207},
  [7070] = {.lex_state = 207},
  [7071] = {.lex_state = 207},
  [7072] = {.lex_state = 207},
  [7073] = {.lex_state = 220},
  [7074] = {.lex_state = 254},
  [7075] = {.lex_state = 207},
  [7076] = {.lex_state = 220},
  [7077] = {.lex_state = 207},
  [7078] = {.lex_state = 207},
  [7079] = {.lex_state = 217},
  [7080] = {.lex_state = 207},
  [7081] = {.lex_state = 207},
  [7082] = {.lex_state = 207},
  [7083] = {.lex_state = 256},
  [7084] = {.lex_state = 190},
  [7085] = {.lex_state = 254},
  [7086] = {.lex_state = 101},
  [7087] = {.lex_state = 207},
  [7088] = {.lex_state = 207},
  [7089] = {.lex_state = 207},
  [7090] = {.lex_state = 207},
  [7091] = {.lex_state = 207},
  [7092] = {.lex_state = 207},
  [7093] = {.lex_state = 207},
  [7094] = {.lex_state = 207},
  [7095] = {.lex_state = 207},
  [7096] = {.lex_state = 207},
  [7097] = {.lex_state = 207},
  [7098] = {.lex_state = 207},
  [7099] = {.lex_state = 207},
  [7100] = {.lex_state = 207},
  [7101] = {.lex_state = 207},
  [7102] = {.lex_state = 207},
  [7103] = {.lex_state = 207},
  [7104] = {.lex_state = 207},
  [7105] = {.lex_state = 207},
  [7106] = {.lex_state = 207},
  [7107] = {.lex_state = 207},
  [7108] = {.lex_state = 207},
  [7109] = {.lex_state = 207},
  [7110] = {.lex_state = 207},
  [7111] = {.lex_state = 207},
  [7112] = {.lex_state = 237},
  [7113] = {.lex_state = 207},
  [7114] = {.lex_state = 207},
  [7115] = {.lex_state = 207},
  [7116] = {.lex_state = 207},
  [7117] = {.lex_state = 207},
  [7118] = {.lex_state = 207},
  [7119] = {.lex_state = 190},
  [7120] = {.lex_state = 254},
  [7121] = {.lex_state = 254},
  [7122] = {.lex_state = 254},
  [7123] = {.lex_state = 207},
  [7124] = {.lex_state = 237},
  [7125] = {.lex_state = 207},
  [7126] = {.lex_state = 207},
  [7127] = {.lex_state = 207},
  [7128] = {.lex_state = 207},
  [7129] = {.lex_state = 254},
  [7130] = {.lex_state = 237},
  [7131] = {.lex_state = 207},
  [7132] = {.lex_state = 220},
  [7133] = {.lex_state = 207},
  [7134] = {.lex_state = 251},
  [7135] = {.lex_state = 251},
  [7136] = {.lex_state = 207},
  [7137] = {.lex_state = 207},
  [7138] = {.lex_state = 207},
  [7139] = {.lex_state = 254},
  [7140] = {.lex_state = 207},
  [7141] = {.lex_state = 207},
  [7142] = {.lex_state = 207},
  [7143] = {.lex_state = 207},
  [7144] = {.lex_state = 254},
  [7145] = {.lex_state = 254},
  [7146] = {.lex_state = 254},
  [7147] = {.lex_state = 207},
  [7148] = {.lex_state = 207},
  [7149] = {.lex_state = 207},
  [7150] = {.lex_state = 207},
  [7151] = {.lex_state = 254},
  [7152] = {.lex_state = 254},
  [7153] = {.lex_state = 254},
  [7154] = {.lex_state = 207},
  [7155] = {.lex_state = 207},
  [7156] = {.lex_state = 207},
  [7157] = {.lex_state = 207},
  [7158] = {.lex_state = 254},
  [7159] = {.lex_state = 207},
  [7160] = {.lex_state = 254},
  [7161] = {.lex_state = 254},
  [7162] = {.lex_state = 254},
  [7163] = {.lex_state = 254},
  [7164] = {.lex_state = 207},
  [7165] = {.lex_state = 207},
  [7166] = {.lex_state = 254},
  [7167] = {.lex_state = 207},
  [7168] = {.lex_state = 207},
  [7169] = {.lex_state = 207},
  [7170] = {.lex_state = 207},
  [7171] = {.lex_state = 207},
  [7172] = {.lex_state = 254},
  [7173] = {.lex_state = 207},
  [7174] = {.lex_state = 207},
  [7175] = {.lex_state = 207},
  [7176] = {.lex_state = 207},
  [7177] = {.lex_state = 207},
  [7178] = {.lex_state = 207},
  [7179] = {.lex_state = 207},
  [7180] = {.lex_state = 207},
  [7181] = {.lex_state = 254},
  [7182] = {.lex_state = 254},
  [7183] = {.lex_state = 256},
  [7184] = {.lex_state = 254},
  [7185] = {.lex_state = 254},
  [7186] = {.lex_state = 207},
  [7187] = {.lex_state = 207},
  [7188] = {.lex_state = 254},
  [7189] = {.lex_state = 254},
  [7190] = {.lex_state = 237},
  [7191] = {.lex_state = 207},
  [7192] = {.lex_state = 190},
  [7193] = {.lex_state = 207},
  [7194] = {.lex_state = 207},
  [7195] = {.lex_state = 207},
  [7196] = {.lex_state = 207},
  [7197] = {.lex_state = 207},
  [7198] = {.lex_state = 207},
  [7199] = {.lex_state = 256},
  [7200] = {.lex_state = 254},
  [7201] = {.lex_state = 207},
  [7202] = {.lex_state = 207},
  [7203] = {.lex_state = 207},
  [7204] = {.lex_state = 207},
  [7205] = {.lex_state = 207},
  [7206] = {.lex_state = 207},
  [7207] = {.lex_state = 207},
  [7208] = {.lex_state = 207},
  [7209] = {.lex_state = 207},
  [7210] = {.lex_state = 207},
  [7211] = {.lex_state = 237},
  [7212] = {.lex_state = 261},
  [7213] = {.lex_state = 237},
  [7214] = {.lex_state = 261},
  [7215] = {.lex_state = 254},
  [7216] = {.lex_state = 220},
  [7217] = {.lex_state = 190},
  [7218] = {.lex_state = 252},
  [7219] = {.lex_state = 190},
  [7220] = {.lex_state = 261},
  [7221] = {.lex_state = 220},
  [7222] = {.lex_state = 252},
  [7223] = {.lex_state = 261},
  [7224] = {.lex_state = 190},
  [7225] = {.lex_state = 237},
  [7226] = {.lex_state = 261},
  [7227] = {.lex_state = 190},
  [7228] = {.lex_state = 190},
  [7229] = {.lex_state = 220},
  [7230] = {.lex_state = 254},
  [7231] = {.lex_state = 254},
  [7232] = {.lex_state = 254},
  [7233] = {.lex_state = 254},
  [7234] = {.lex_state = 261},
  [7235] = {.lex_state = 261},
  [7236] = {.lex_state = 190},
  [7237] = {.lex_state = 261},
  [7238] = {.lex_state = 190},
  [7239] = {.lex_state = 237},
  [7240] = {.lex_state = 190},
  [7241] = {.lex_state = 237},
  [7242] = {.lex_state = 261},
  [7243] = {.lex_state = 190},
  [7244] = {.lex_state = 256},
  [7245] = {.lex_state = 261},
  [7246] = {.lex_state = 220},
  [7247] = {.lex_state = 220},
  [7248] = {.lex_state = 190},
  [7249] = {.lex_state = 190},
  [7250] = {.lex_state = 190},
  [7251] = {.lex_state = 190},
  [7252] = {.lex_state = 190},
  [7253] = {.lex_state = 190},
  [7254] = {.lex_state = 190},
  [7255] = {.lex_state = 190},
  [7256] = {.lex_state = 190},
  [7257] = {.lex_state = 190},
  [7258] = {.lex_state = 252},
  [7259] = {.lex_state = 261},
  [7260] = {.lex_state = 190},
  [7261] = {.lex_state = 252},
  [7262] = {.lex_state = 261},
  [7263] = {.lex_state = 237},
  [7264] = {.lex_state = 220},
  [7265] = {.lex_state = 261},
  [7266] = {.lex_state = 261},
  [7267] = {.lex_state = 252},
  [7268] = {.lex_state = 261},
  [7269] = {.lex_state = 252},
  [7270] = {.lex_state = 252},
  [7271] = {.lex_state = 252},
  [7272] = {.lex_state = 252},
  [7273] = {.lex_state = 252},
  [7274] = {.lex_state = 252},
  [7275] = {.lex_state = 252},
  [7276] = {.lex_state = 252},
  [7277] = {.lex_state = 220},
  [7278] = {.lex_state = 252},
  [7279] = {.lex_state = 252},
  [7280] = {.lex_state = 237},
  [7281] = {.lex_state = 252},
  [7282] = {.lex_state = 237},
  [7283] = {.lex_state = 190},
  [7284] = {.lex_state = 237},
  [7285] = {.lex_state = 259},
  [7286] = {.lex_state = 261},
  [7287] = {.lex_state = 261},
  [7288] = {.lex_state = 190},
  [7289] = {.lex_state = 256},
  [7290] = {.lex_state = 237},
  [7291] = {.lex_state = 261},
  [7292] = {.lex_state = 261},
  [7293] = {.lex_state = 261},
  [7294] = {.lex_state = 190},
  [7295] = {.lex_state = 254},
  [7296] = {.lex_state = 254},
  [7297] = {.lex_state = 254},
  [7298] = {.lex_state = 254},
  [7299] = {.lex_state = 237},
  [7300] = {.lex_state = 256},
  [7301] = {.lex_state = 261},
  [7302] = {.lex_state = 220},
  [7303] = {.lex_state = 256},
  [7304] = {.lex_state = 256},
  [7305] = {.lex_state = 256},
  [7306] = {.lex_state = 261},
  [7307] = {.lex_state = 220},
  [7308] = {.lex_state = 256},
  [7309] = {.lex_state = 220},
  [7310] = {.lex_state = 261},
  [7311] = {.lex_state = 190},
  [7312] = {.lex_state = 220},
  [7313] = {.lex_state = 220},
  [7314] = {.lex_state = 220},
  [7315] = {.lex_state = 256},
  [7316] = {.lex_state = 220},
  [7317] = {.lex_state = 190},
  [7318] = {.lex_state = 256},
  [7319] = {.lex_state = 256},
  [7320] = {.lex_state = 256},
  [7321] = {.lex_state = 256},
  [7322] = {.lex_state = 256},
  [7323] = {.lex_state = 220},
  [7324] = {.lex_state = 220},
  [7325] = {.lex_state = 254},
  [7326] = {.lex_state = 220},
  [7327] = {.lex_state = 220},
  [7328] = {.lex_state = 220},
  [7329] = {.lex_state = 220},
  [7330] = {.lex_state = 237},
  [7331] = {.lex_state = 190},
  [7332] = {.lex_state = 190},
  [7333] = {.lex_state = 256},
  [7334] = {.lex_state = 256},
  [7335] = {.lex_state = 256},
  [7336] = {.lex_state = 256},
  [7337] = {.lex_state = 256},
  [7338] = {.lex_state = 256},
  [7339] = {.lex_state = 256},
  [7340] = {.lex_state = 256},
  [7341] = {.lex_state = 190},
  [7342] = {.lex_state = 190},
  [7343] = {.lex_state = 261},
  [7344] = {.lex_state = 259},
  [7345] = {.lex_state = 254},
  [7346] = {.lex_state = 237},
  [7347] = {.lex_state = 190},
  [7348] = {.lex_state = 252},
  [7349] = {.lex_state = 190},
  [7350] = {.lex_state = 190},
  [7351] = {.lex_state = 237},
  [7352] = {.lex_state = 190},
  [7353] = {.lex_state = 190},
  [7354] = {.lex_state = 261},
  [7355] = {.lex_state = 261},
  [7356] = {.lex_state = 190},
  [7357] = {.lex_state = 190},
  [7358] = {.lex_state = 261},
  [7359] = {.lex_state = 261},
  [7360] = {.lex_state = 190},
  [7361] = {.lex_state = 190},
  [7362] = {.lex_state = 190},
  [7363] = {.lex_state = 259},
  [7364] = {.lex_state = 252},
  [7365] = {.lex_state = 101},
  [7366] = {.lex_state = 252},
  [7367] = {.lex_state = 260},
  [7368] = {.lex_state = 254},
  [7369] = {.lex_state = 101},
  [7370] = {.lex_state = 237},
  [7371] = {.lex_state = 252},
  [7372] = {.lex_state = 101},
  [7373] = {.lex_state = 101},
  [7374] = {.lex_state = 101},
  [7375] = {.lex_state = 254},
  [7376] = {.lex_state = 254},
  [7377] = {.lex_state = 101},
  [7378] = {.lex_state = 237},
  [7379] = {.lex_state = 101},
  [7380] = {.lex_state = 254},
  [7381] = {.lex_state = 101},
  [7382] = {.lex_state = 220},
  [7383] = {.lex_state = 101},
  [7384] = {.lex_state = 252},
  [7385] = {.lex_state = 252},
  [7386] = {.lex_state = 101},
  [7387] = {.lex_state = 217},
  [7388] = {.lex_state = 101},
  [7389] = {.lex_state = 101},
  [7390] = {.lex_state = 254},
  [7391] = {.lex_state = 252},
  [7392] = {.lex_state = 101},
  [7393] = {.lex_state = 207},
  [7394] = {.lex_state = 252},
  [7395] = {.lex_state = 101},
  [7396] = {.lex_state = 101},
  [7397] = {.lex_state = 101},
  [7398] = {.lex_state = 101},
  [7399] = {.lex_state = 237},
  [7400] = {.lex_state = 237},
  [7401] = {.lex_state = 101},
  [7402] = {.lex_state = 101},
  [7403] = {.lex_state = 252},
  [7404] = {.lex_state = 254},
  [7405] = {.lex_state = 101},
  [7406] = {.lex_state = 259},
  [7407] = {.lex_state = 207},
  [7408] = {.lex_state = 101},
  [7409] = {.lex_state = 101},
  [7410] = {.lex_state = 207},
  [7411] = {.lex_state = 101},
  [7412] = {.lex_state = 254},
  [7413] = {.lex_state = 101},
  [7414] = {.lex_state = 253},
  [7415] = {.lex_state = 254},
  [7416] = {.lex_state = 260},
  [7417] = {.lex_state = 101},
  [7418] = {.lex_state = 254},
  [7419] = {.lex_state = 254},
  [7420] = {.lex_state = 252},
  [7421] = {.lex_state = 237},
  [7422] = {.lex_state = 254},
  [7423] = {.lex_state = 101},
  [7424] = {.lex_state = 101},
  [7425] = {.lex_state = 254},
  [7426] = {.lex_state = 101},
  [7427] = {.lex_state = 220},
  [7428] = {.lex_state = 254},
  [7429] = {.lex_state = 101},
  [7430] = {.lex_state = 101},
  [7431] = {.lex_state = 237},
  [7432] = {.lex_state = 252},
  [7433] = {.lex_state = 101},
  [7434] = {.lex_state = 252},
  [7435] = {.lex_state = 254},
  [7436] = {.lex_state = 254},
  [7437] = {.lex_state = 254},
  [7438] = {.lex_state = 254},
  [7439] = {.lex_state = 217},
  [7440] = {.lex_state = 254},
  [7441] = {.lex_state = 254},
  [7442] = {.lex_state = 207},
  [7443] = {.lex_state = 207},
  [7444] = {.lex_state = 260},
  [7445] = {.lex_state = 254},
  [7446] = {.lex_state = 101},
  [7447] = {.lex_state = 252},
  [7448] = {.lex_state = 207},
  [7449] = {.lex_state = 237},
  [7450] = {.lex_state = 101},
  [7451] = {.lex_state = 254},
  [7452] = {.lex_state = 252},
  [7453] = {.lex_state = 252},
  [7454] = {.lex_state = 256},
  [7455] = {.lex_state = 211},
  [7456] = {.lex_state = 211},
  [7457] = {.lex_state = 211},
  [7458] = {.lex_state = 211},
  [7459] = {.lex_state = 256},
  [7460] = {.lex_state = 229},
  [7461] = {.lex_state = 229},
  [7462] = {.lex_state = 229},
  [7463] = {.lex_state = 229},
  [7464] = {.lex_state = 253},
  [7465] = {.lex_state = 256},
  [7466] = {.lex_state = 256},
  [7467] = {.lex_state = 256},
  [7468] = {.lex_state = 254},
  [7469] = {.lex_state = 254},
  [7470] = {.lex_state = 253},
  [7471] = {.lex_state = 253},
  [7472] = {.lex_state = 254},
  [7473] = {.lex_state = 256},
  [7474] = {.lex_state = 254},
  [7475] = {.lex_state = 256},
  [7476] = {.lex_state = 254},
  [7477] = {.lex_state = 253},
  [7478] = {.lex_state = 253},
  [7479] = {.lex_state = 256},
  [7480] = {.lex_state = 253},
  [7481] = {.lex_state = 256},
  [7482] = {.lex_state = 207},
  [7483] = {.lex_state = 260},
  [7484] = {.lex_state = 207},
  [7485] = {.lex_state = 256},
  [7486] = {.lex_state = 256},
  [7487] = {.lex_state = 256},
  [7488] = {.lex_state = 207},
  [7489] = {.lex_state = 251},
  [7490] = {.lex_state = 211},
  [7491] = {.lex_state = 211},
  [7492] = {.lex_state = 254},
  [7493] = {.lex_state = 254},
  [7494] = {.lex_state = 253},
  [7495] = {.lex_state = 254},
  [7496] = {.lex_state = 254},
  [7497] = {.lex_state = 254},
  [7498] = {.lex_state = 254},
  [7499] = {.lex_state = 254},
  [7500] = {.lex_state = 254},
  [7501] = {.lex_state = 256},
  [7502] = {.lex_state = 211},
  [7503] = {.lex_state = 256},
  [7504] = {.lex_state = 211},
  [7505] = {.lex_state = 256},
  [7506] = {.lex_state = 256},
  [7507] = {.lex_state = 256},
  [7508] = {.lex_state = 254},
  [7509] = {.lex_state = 254},
  [7510] = {.lex_state = 254},
  [7511] = {.lex_state = 254},
  [7512] = {.lex_state = 254},
  [7513] = {.lex_state = 254},
  [7514] = {.lex_state = 256},
  [7515] = {.lex_state = 256},
  [7516] = {.lex_state = 256},
  [7517] = {.lex_state = 256},
  [7518] = {.lex_state = 256},
  [7519] = {.lex_state = 256},
  [7520] = {.lex_state = 256},
  [7521] = {.lex_state = 253},
  [7522] = {.lex_state = 256},
  [7523] = {.lex_state = 254},
  [7524] = {.lex_state = 251},
  [7525] = {.lex_state = 253},
  [7526] = {.lex_state = 256},
  [7527] = {.lex_state = 256},
  [7528] = {.lex_state = 256},
  [7529] = {.lex_state = 256},
  [7530] = {.lex_state = 254},
  [7531] = {.lex_state = 254},
  [7532] = {.lex_state = 256},
  [7533] = {.lex_state = 229},
  [7534] = {.lex_state = 217},
  [7535] = {.lex_state = 256},
  [7536] = {.lex_state = 229},
  [7537] = {.lex_state = 256},
  [7538] = {.lex_state = 229},
  [7539] = {.lex_state = 229},
  [7540] = {.lex_state = 254},
  [7541] = {.lex_state = 256},
  [7542] = {.lex_state = 251},
  [7543] = {.lex_state = 256},
  [7544] = {.lex_state = 254},
  [7545] = {.lex_state = 254},
  [7546] = {.lex_state = 256},
  [7547] = {.lex_state = 254},
  [7548] = {.lex_state = 254},
  [7549] = {.lex_state = 256},
  [7550] = {.lex_state = 207},
  [7551] = {.lex_state = 246},
  [7552] = {.lex_state = 237},
  [7553] = {.lex_state = 256},
  [7554] = {.lex_state = 254},
  [7555] = {.lex_state = 207},
  [7556] = {.lex_state = 254},
  [7557] = {.lex_state = 207},
  [7558] = {.lex_state = 208},
  [7559] = {.lex_state = 254},
  [7560] = {.lex_state = 208},
  [7561] = {.lex_state = 254},
  [7562] = {.lex_state = 207},
  [7563] = {.lex_state = 254},
  [7564] = {.lex_state = 208},
  [7565] = {.lex_state = 261},
  [7566] = {.lex_state = 254},
  [7567] = {.lex_state = 256},
  [7568] = {.lex_state = 207},
  [7569] = {.lex_state = 256},
  [7570] = {.lex_state = 211},
  [7571] = {.lex_state = 208},
  [7572] = {.lex_state = 256},
  [7573] = {.lex_state = 208},
  [7574] = {.lex_state = 254},
  [7575] = {.lex_state = 256},
  [7576] = {.lex_state = 256},
  [7577] = {.lex_state = 207},
  [7578] = {.lex_state = 256},
  [7579] = {.lex_state = 211},
  [7580] = {.lex_state = 254},
  [7581] = {.lex_state = 207},
  [7582] = {.lex_state = 208},
  [7583] = {.lex_state = 254},
  [7584] = {.lex_state = 254},
  [7585] = {.lex_state = 256},
  [7586] = {.lex_state = 254},
  [7587] = {.lex_state = 256},
  [7588] = {.lex_state = 254},
  [7589] = {.lex_state = 256},
  [7590] = {.lex_state = 246},
  [7591] = {.lex_state = 261},
  [7592] = {.lex_state = 246},
  [7593] = {.lex_state = 237},
  [7594] = {.lex_state = 237},
  [7595] = {.lex_state = 246},
  [7596] = {.lex_state = 254},
  [7597] = {.lex_state = 254},
  [7598] = {.lex_state = 256},
  [7599] = {.lex_state = 256},
  [7600] = {.lex_state = 256},
  [7601] = {.lex_state = 256},
  [7602] = {.lex_state = 256},
  [7603] = {.lex_state = 256},
  [7604] = {.lex_state = 254},
  [7605] = {.lex_state = 254},
  [7606] = {.lex_state = 207},
  [7607] = {.lex_state = 187},
  [7608] = {.lex_state = 254},
  [7609] = {.lex_state = 237},
  [7610] = {.lex_state = 254},
  [7611] = {.lex_state = 254},
  [7612] = {.lex_state = 254},
  [7613] = {.lex_state = 256},
  [7614] = {.lex_state = 256},
  [7615] = {.lex_state = 256},
  [7616] = {.lex_state = 256},
  [7617] = {.lex_state = 254},
  [7618] = {.lex_state = 254},
  [7619] = {.lex_state = 256},
  [7620] = {.lex_state = 254},
  [7621] = {.lex_state = 254},
  [7622] = {.lex_state = 208},
  [7623] = {.lex_state = 208},
  [7624] = {.lex_state = 254},
  [7625] = {.lex_state = 254},
  [7626] = {.lex_state = 254},
  [7627] = {.lex_state = 256},
  [7628] = {.lex_state = 253},
  [7629] = {.lex_state = 207},
  [7630] = {.lex_state = 251},
  [7631] = {.lex_state = 253},
  [7632] = {.lex_state = 254},
  [7633] = {.lex_state = 254},
  [7634] = {.lex_state = 252},
  [7635] = {.lex_state = 254},
  [7636] = {.lex_state = 252},
  [7637] = {.lex_state = 254},
  [7638] = {.lex_state = 254},
  [7639] = {.lex_state = 252},
  [7640] = {.lex_state = 254},
  [7641] = {.lex_state = 253},
  [7642] = {.lex_state = 254},
  [7643] = {.lex_state = 252},
  [7644] = {.lex_state = 254},
  [7645] = {.lex_state = 253},
  [7646] = {.lex_state = 254},
  [7647] = {.lex_state = 217},
  [7648] = {.lex_state = 254},
  [7649] = {.lex_state = 253},
  [7650] = {.lex_state = 254},
  [7651] = {.lex_state = 211},
  [7652] = {.lex_state = 211},
  [7653] = {.lex_state = 211},
  [7654] = {.lex_state = 211},
  [7655] = {.lex_state = 211},
  [7656] = {.lex_state = 229},
  [7657] = {.lex_state = 229},
  [7658] = {.lex_state = 229},
  [7659] = {.lex_state = 229},
  [7660] = {.lex_state = 229},
  [7661] = {.lex_state = 252},
  [7662] = {.lex_state = 252},
  [7663] = {.lex_state = 229},
  [7664] = {.lex_state = 229},
  [7665] = {.lex_state = 229},
  [7666] = {.lex_state = 229},
  [7667] = {.lex_state = 229},
  [7668] = {.lex_state = 252},
  [7669] = {.lex_state = 251},
  [7670] = {.lex_state = 252},
  [7671] = {.lex_state = 251},
  [7672] = {.lex_state = 256},
  [7673] = {.lex_state = 256},
  [7674] = {.lex_state = 256},
  [7675] = {.lex_state = 256},
  [7676] = {.lex_state = 256},
  [7677] = {.lex_state = 256},
  [7678] = {.lex_state = 256},
  [7679] = {.lex_state = 256},
  [7680] = {.lex_state = 254},
  [7681] = {.lex_state = 252},
  [7682] = {.lex_state = 265},
  [7683] = {.lex_state = 252},
  [7684] = {.lex_state = 207},
  [7685] = {.lex_state = 251},
  [7686] = {.lex_state = 254},
  [7687] = {.lex_state = 254},
  [7688] = {.lex_state = 252},
  [7689] = {.lex_state = 254},
  [7690] = {.lex_state = 207},
  [7691] = {.lex_state = 252},
  [7692] = {.lex_state = 254},
  [7693] = {.lex_state = 252},
  [7694] = {.lex_state = 207},
  [7695] = {.lex_state = 207},
  [7696] = {.lex_state = 207},
  [7697] = {.lex_state = 252},
  [7698] = {.lex_state = 252},
  [7699] = {.lex_state = 253},
  [7700] = {.lex_state = 252},
  [7701] = {.lex_state = 252},
  [7702] = {.lex_state = 252},
  [7703] = {.lex_state = 252},
  [7704] = {.lex_state = 207},
  [7705] = {.lex_state = 211},
  [7706] = {.lex_state = 211},
  [7707] = {.lex_state = 211},
  [7708] = {.lex_state = 211},
  [7709] = {.lex_state = 211},
  [7710] = {.lex_state = 254},
  [7711] = {.lex_state = 207},
  [7712] = {.lex_state = 207},
  [7713] = {.lex_state = 254},
  [7714] = {.lex_state = 253},
  [7715] = {.lex_state = 356},
  [7716] = {.lex_state = 254},
  [7717] = {.lex_state = 252},
  [7718] = {.lex_state = 254},
  [7719] = {.lex_state = 254},
  [7720] = {.lex_state = 252},
  [7721] = {.lex_state = 254},
  [7722] = {.lex_state = 254},
  [7723] = {.lex_state = 256},
  [7724] = {.lex_state = 256},
  [7725] = {.lex_state = 256},
  [7726] = {.lex_state = 256},
  [7727] = {.lex_state = 256},
  [7728] = {.lex_state = 256},
  [7729] = {.lex_state = 256},
  [7730] = {.lex_state = 207},
  [7731] = {.lex_state = 254},
  [7732] = {.lex_state = 253},
  [7733] = {.lex_state = 253},
  [7734] = {.lex_state = 253},
  [7735] = {.lex_state = 252},
  [7736] = {.lex_state = 207},
  [7737] = {.lex_state = 252},
  [7738] = {.lex_state = 254},
  [7739] = {.lex_state = 200},
  [7740] = {.lex_state = 254},
  [7741] = {.lex_state = 256},
  [7742] = {.lex_state = 193},
  [7743] = {.lex_state = 187},
  [7744] = {.lex_state = 208},
  [7745] = {.lex_state = 254},
  [7746] = {.lex_state = 208},
  [7747] = {.lex_state = 208},
  [7748] = {.lex_state = 254},
  [7749] = {.lex_state = 254},
  [7750] = {.lex_state = 254},
  [7751] = {.lex_state = 254},
  [7752] = {.lex_state = 254},
  [7753] = {.lex_state = 254},
  [7754] = {.lex_state = 254},
  [7755] = {.lex_state = 208},
  [7756] = {.lex_state = 200},
  [7757] = {.lex_state = 254},
  [7758] = {.lex_state = 256},
  [7759] = {.lex_state = 256},
  [7760] = {.lex_state = 256},
  [7761] = {.lex_state = 256},
  [7762] = {.lex_state = 256},
  [7763] = {.lex_state = 256},
  [7764] = {.lex_state = 256},
  [7765] = {.lex_state = 256},
  [7766] = {.lex_state = 256},
  [7767] = {.lex_state = 254},
  [7768] = {.lex_state = 256},
  [7769] = {.lex_state = 207},
  [7770] = {.lex_state = 254},
  [7771] = {.lex_state = 254},
  [7772] = {.lex_state = 200},
  [7773] = {.lex_state = 207},
  [7774] = {.lex_state = 208},
  [7775] = {.lex_state = 200},
  [7776] = {.lex_state = 207},
  [7777] = {.lex_state = 200},
  [7778] = {.lex_state = 256},
  [7779] = {.lex_state = 229},
  [7780] = {.lex_state = 254},
  [7781] = {.lex_state = 254},
  [7782] = {.lex_state = 256},
  [7783] = {.lex_state = 254},
  [7784] = {.lex_state = 254},
  [7785] = {.lex_state = 254},
  [7786] = {.lex_state = 254},
  [7787] = {.lex_state = 254},
  [7788] = {.lex_state = 254},
  [7789] = {.lex_state = 254},
  [7790] = {.lex_state = 254},
  [7791] = {.lex_state = 211},
  [7792] = {.lex_state = 211},
  [7793] = {.lex_state = 211},
  [7794] = {.lex_state = 211},
  [7795] = {.lex_state = 208},
  [7796] = {.lex_state = 251},
  [7797] = {.lex_state = 254},
  [7798] = {.lex_state = 211},
  [7799] = {.lex_state = 211},
  [7800] = {.lex_state = 211},
  [7801] = {.lex_state = 211},
  [7802] = {.lex_state = 208},
  [7803] = {.lex_state = 200},
  [7804] = {.lex_state = 200},
  [7805] = {.lex_state = 200},
  [7806] = {.lex_state = 200},
  [7807] = {.lex_state = 208},
  [7808] = {.lex_state = 256},
  [7809] = {.lex_state = 256},
  [7810] = {.lex_state = 200},
  [7811] = {.lex_state = 208},
  [7812] = {.lex_state = 200},
  [7813] = {.lex_state = 251},
  [7814] = {.lex_state = 200},
  [7815] = {.lex_state = 256},
  [7816] = {.lex_state = 208},
  [7817] = {.lex_state = 254},
  [7818] = {.lex_state = 207},
  [7819] = {.lex_state = 254},
  [7820] = {.lex_state = 207},
  [7821] = {.lex_state = 208},
  [7822] = {.lex_state = 254},
  [7823] = {.lex_state = 200},
  [7824] = {.lex_state = 200},
  [7825] = {.lex_state = 208},
  [7826] = {.lex_state = 256},
  [7827] = {.lex_state = 208},
  [7828] = {.lex_state = 254},
  [7829] = {.lex_state = 200},
  [7830] = {.lex_state = 256},
  [7831] = {.lex_state = 208},
  [7832] = {.lex_state = 216},
  [7833] = {.lex_state = 208},
  [7834] = {.lex_state = 207},
  [7835] = {.lex_state = 207},
  [7836] = {.lex_state = 200},
  [7837] = {.lex_state = 254},
  [7838] = {.lex_state = 254},
  [7839] = {.lex_state = 254},
  [7840] = {.lex_state = 254},
  [7841] = {.lex_state = 254},
  [7842] = {.lex_state = 254},
  [7843] = {.lex_state = 254},
  [7844] = {.lex_state = 254},
  [7845] = {.lex_state = 254},
  [7846] = {.lex_state = 254},
  [7847] = {.lex_state = 254},
  [7848] = {.lex_state = 254},
  [7849] = {.lex_state = 254},
  [7850] = {.lex_state = 256},
  [7851] = {.lex_state = 229},
  [7852] = {.lex_state = 254},
  [7853] = {.lex_state = 254},
  [7854] = {.lex_state = 254},
  [7855] = {.lex_state = 254},
  [7856] = {.lex_state = 228},
  [7857] = {.lex_state = 228},
  [7858] = {.lex_state = 228},
  [7859] = {.lex_state = 228},
  [7860] = {.lex_state = 228},
  [7861] = {.lex_state = 228},
  [7862] = {.lex_state = 228},
  [7863] = {.lex_state = 228},
  [7864] = {.lex_state = 254},
  [7865] = {.lex_state = 208},
  [7866] = {.lex_state = 200},
  [7867] = {.lex_state = 254},
  [7868] = {.lex_state = 207},
  [7869] = {.lex_state = 208},
  [7870] = {.lex_state = 256},
  [7871] = {.lex_state = 256},
  [7872] = {.lex_state = 256},
  [7873] = {.lex_state = 208},
  [7874] = {.lex_state = 254},
  [7875] = {.lex_state = 200},
  [7876] = {.lex_state = 208},
  [7877] = {.lex_state = 200},
  [7878] = {.lex_state = 200},
  [7879] = {.lex_state = 208},
  [7880] = {.lex_state = 217},
  [7881] = {.lex_state = 200},
  [7882] = {.lex_state = 254},
  [7883] = {.lex_state = 256},
  [7884] = {.lex_state = 256},
  [7885] = {.lex_state = 208},
  [7886] = {.lex_state = 256},
  [7887] = {.lex_state = 254},
  [7888] = {.lex_state = 208},
  [7889] = {.lex_state = 200},
  [7890] = {.lex_state = 256},
  [7891] = {.lex_state = 254},
  [7892] = {.lex_state = 207},
  [7893] = {.lex_state = 207},
  [7894] = {.lex_state = 207},
  [7895] = {.lex_state = 254},
  [7896] = {.lex_state = 254},
  [7897] = {.lex_state = 207},
  [7898] = {.lex_state = 246},
  [7899] = {.lex_state = 254},
  [7900] = {.lex_state = 254},
  [7901] = {.lex_state = 254},
  [7902] = {.lex_state = 256},
  [7903] = {.lex_state = 207},
  [7904] = {.lex_state = 207},
  [7905] = {.lex_state = 254},
  [7906] = {.lex_state = 254},
  [7907] = {.lex_state = 207},
  [7908] = {.lex_state = 207},
  [7909] = {.lex_state = 251},
  [7910] = {.lex_state = 207},
  [7911] = {.lex_state = 254},
  [7912] = {.lex_state = 254},
  [7913] = {.lex_state = 254},
  [7914] = {.lex_state = 254},
  [7915] = {.lex_state = 254},
  [7916] = {.lex_state = 254},
  [7917] = {.lex_state = 254},
  [7918] = {.lex_state = 254},
  [7919] = {.lex_state = 254},
  [7920] = {.lex_state = 246},
  [7921] = {.lex_state = 254},
  [7922] = {.lex_state = 254},
  [7923] = {.lex_state = 254},
  [7924] = {.lex_state = 207},
  [7925] = {.lex_state = 207},
  [7926] = {.lex_state = 207},
  [7927] = {.lex_state = 254},
  [7928] = {.lex_state = 254},
  [7929] = {.lex_state = 254},
  [7930] = {.lex_state = 254},
  [7931] = {.lex_state = 254},
  [7932] = {.lex_state = 207},
  [7933] = {.lex_state = 207},
  [7934] = {.lex_state = 254},
  [7935] = {.lex_state = 254},
  [7936] = {.lex_state = 254},
  [7937] = {.lex_state = 207},
  [7938] = {.lex_state = 207},
  [7939] = {.lex_state = 207},
  [7940] = {.lex_state = 207},
  [7941] = {.lex_state = 207},
  [7942] = {.lex_state = 254},
  [7943] = {.lex_state = 207},
  [7944] = {.lex_state = 254},
  [7945] = {.lex_state = 207},
  [7946] = {.lex_state = 207},
  [7947] = {.lex_state = 207},
  [7948] = {.lex_state = 256},
  [7949] = {.lex_state = 256},
  [7950] = {.lex_state = 254},
  [7951] = {.lex_state = 207},
  [7952] = {.lex_state = 207},
  [7953] = {.lex_state = 207},
  [7954] = {.lex_state = 207},
  [7955] = {.lex_state = 207},
  [7956] = {.lex_state = 246},
  [7957] = {.lex_state = 207},
  [7958] = {.lex_state = 254},
  [7959] = {.lex_state = 254},
  [7960] = {.lex_state = 207},
  [7961] = {.lex_state = 207},
  [7962] = {.lex_state = 207},
  [7963] = {.lex_state = 254},
  [7964] = {.lex_state = 254},
  [7965] = {.lex_state = 256},
  [7966] = {.lex_state = 207},
  [7967] = {.lex_state = 254},
  [7968] = {.lex_state = 246},
  [7969] = {.lex_state = 254},
  [7970] = {.lex_state = 207},
  [7971] = {.lex_state = 254},
  [7972] = {.lex_state = 207},
  [7973] = {.lex_state = 207},
  [7974] = {.lex_state = 256},
  [7975] = {.lex_state = 256},
  [7976] = {.lex_state = 256},
  [7977] = {.lex_state = 256},
  [7978] = {.lex_state = 256},
  [7979] = {.lex_state = 207},
  [7980] = {.lex_state = 256},
  [7981] = {.lex_state = 256},
  [7982] = {.lex_state = 256},
  [7983] = {.lex_state = 256},
  [7984] = {.lex_state = 256},
  [7985] = {.lex_state = 254},
  [7986] = {.lex_state = 256},
  [7987] = {.lex_state = 251},
  [7988] = {.lex_state = 256},
  [7989] = {.lex_state = 207},
  [7990] = {.lex_state = 256},
  [7991] = {.lex_state = 256},
  [7992] = {.lex_state = 254},
  [7993] = {.lex_state = 207},
  [7994] = {.lex_state = 207},
  [7995] = {.lex_state = 254},
  [7996] = {.lex_state = 256},
  [7997] = {.lex_state = 207},
  [7998] = {.lex_state = 254},
  [7999] = {.lex_state = 254},
  [8000] = {.lex_state = 254},
  [8001] = {.lex_state = 256},
  [8002] = {.lex_state = 254},
  [8003] = {.lex_state = 254},
  [8004] = {.lex_state = 207},
  [8005] = {.lex_state = 207},
  [8006] = {.lex_state = 254},
  [8007] = {.lex_state = 229},
  [8008] = {.lex_state = 256},
  [8009] = {.lex_state = 256},
  [8010] = {.lex_state = 207},
  [8011] = {.lex_state = 253},
  [8012] = {.lex_state = 229},
  [8013] = {.lex_state = 253},
  [8014] = {.lex_state = 254},
  [8015] = {.lex_state = 206},
  [8016] = {.lex_state = 208},
  [8017] = {.lex_state = 206},
  [8018] = {.lex_state = 207},
  [8019] = {.lex_state = 206},
  [8020] = {.lex_state = 206},
  [8021] = {.lex_state = 207},
  [8022] = {.lex_state = 253},
  [8023] = {.lex_state = 208},
  [8024] = {.lex_state = 254},
  [8025] = {.lex_state = 207},
  [8026] = {.lex_state = 207},
  [8027] = {.lex_state = 253},
  [8028] = {.lex_state = 206},
  [8029] = {.lex_state = 206},
  [8030] = {.lex_state = 206},
  [8031] = {.lex_state = 254},
  [8032] = {.lex_state = 211},
  [8033] = {.lex_state = 206},
  [8034] = {.lex_state = 229},
  [8035] = {.lex_state = 256},
  [8036] = {.lex_state = 256},
  [8037] = {.lex_state = 254},
  [8038] = {.lex_state = 229},
  [8039] = {.lex_state = 256},
  [8040] = {.lex_state = 211},
  [8041] = {.lex_state = 211},
  [8042] = {.lex_state = 229},
  [8043] = {.lex_state = 211},
  [8044] = {.lex_state = 229},
  [8045] = {.lex_state = 208},
  [8046] = {.lex_state = 253},
  [8047] = {.lex_state = 206},
  [8048] = {.lex_state = 256},
  [8049] = {.lex_state = 211},
  [8050] = {.lex_state = 211},
  [8051] = {.lex_state = 211},
  [8052] = {.lex_state = 256},
  [8053] = {.lex_state = 211},
  [8054] = {.lex_state = 254},
  [8055] = {.lex_state = 254},
  [8056] = {.lex_state = 254},
  [8057] = {.lex_state = 208},
  [8058] = {.lex_state = 208},
  [8059] = {.lex_state = 254},
  [8060] = {.lex_state = 254},
  [8061] = {.lex_state = 254},
  [8062] = {.lex_state = 256},
  [8063] = {.lex_state = 254},
  [8064] = {.lex_state = 254},
  [8065] = {.lex_state = 207},
  [8066] = {.lex_state = 256},
  [8067] = {.lex_state = 254},
  [8068] = {.lex_state = 254},
  [8069] = {.lex_state = 208},
  [8070] = {.lex_state = 254},
  [8071] = {.lex_state = 254},
  [8072] = {.lex_state = 208},
  [8073] = {.lex_state = 206},
  [8074] = {.lex_state = 206},
  [8075] = {.lex_state = 254},
  [8076] = {.lex_state = 256},
  [8077] = {.lex_state = 211},
  [8078] = {.lex_state = 211},
  [8079] = {.lex_state = 211},
  [8080] = {.lex_state = 211},
  [8081] = {.lex_state = 254},
  [8082] = {.lex_state = 211},
  [8083] = {.lex_state = 256},
  [8084] = {.lex_state = 207},
  [8085] = {.lex_state = 254},
  [8086] = {.lex_state = 206},
  [8087] = {.lex_state = 254},
  [8088] = {.lex_state = 206},
  [8089] = {.lex_state = 256},
  [8090] = {.lex_state = 256},
  [8091] = {.lex_state = 254},
  [8092] = {.lex_state = 254},
  [8093] = {.lex_state = 187},
  [8094] = {.lex_state = 207},
  [8095] = {.lex_state = 206},
  [8096] = {.lex_state = 256},
  [8097] = {.lex_state = 206},
  [8098] = {.lex_state = 207},
  [8099] = {.lex_state = 208},
  [8100] = {.lex_state = 254},
  [8101] = {.lex_state = 254},
  [8102] = {.lex_state = 254},
  [8103] = {.lex_state = 254},
  [8104] = {.lex_state = 254},
  [8105] = {.lex_state = 208},
  [8106] = {.lex_state = 228},
  [8107] = {.lex_state = 228},
  [8108] = {.lex_state = 256},
  [8109] = {.lex_state = 228},
  [8110] = {.lex_state = 228},
  [8111] = {.lex_state = 228},
  [8112] = {.lex_state = 228},
  [8113] = {.lex_state = 254},
  [8114] = {.lex_state = 228},
  [8115] = {.lex_state = 228},
  [8116] = {.lex_state = 228},
  [8117] = {.lex_state = 228},
  [8118] = {.lex_state = 208},
  [8119] = {.lex_state = 254},
  [8120] = {.lex_state = 254},
  [8121] = {.lex_state = 208},
  [8122] = {.lex_state = 254},
  [8123] = {.lex_state = 254},
  [8124] = {.lex_state = 187},
  [8125] = {.lex_state = 254},
  [8126] = {.lex_state = 254},
  [8127] = {.lex_state = 254},
  [8128] = {.lex_state = 206},
  [8129] = {.lex_state = 254},
  [8130] = {.lex_state = 207},
  [8131] = {.lex_state = 254},
  [8132] = {.lex_state = 251},
  [8133] = {.lex_state = 254},
  [8134] = {.lex_state = 256},
  [8135] = {.lex_state = 211},
  [8136] = {.lex_state = 211},
  [8137] = {.lex_state = 211},
  [8138] = {.lex_state = 256},
  [8139] = {.lex_state = 211},
  [8140] = {.lex_state = 211},
  [8141] = {.lex_state = 254},
  [8142] = {.lex_state = 208},
  [8143] = {.lex_state = 254},
  [8144] = {.lex_state = 254},
  [8145] = {.lex_state = 208},
  [8146] = {.lex_state = 254},
  [8147] = {.lex_state = 253},
  [8148] = {.lex_state = 256},
  [8149] = {.lex_state = 208},
  [8150] = {.lex_state = 254},
  [8151] = {.lex_state = 206},
  [8152] = {.lex_state = 206},
  [8153] = {.lex_state = 208},
  [8154] = {.lex_state = 207},
  [8155] = {.lex_state = 229},
  [8156] = {.lex_state = 206},
  [8157] = {.lex_state = 187},
  [8158] = {.lex_state = 254},
  [8159] = {.lex_state = 206},
  [8160] = {.lex_state = 206},
  [8161] = {.lex_state = 254},
  [8162] = {.lex_state = 254},
  [8163] = {.lex_state = 207},
  [8164] = {.lex_state = 254},
  [8165] = {.lex_state = 254},
  [8166] = {.lex_state = 253},
  [8167] = {.lex_state = 253},
  [8168] = {.lex_state = 256},
  [8169] = {.lex_state = 207},
  [8170] = {.lex_state = 256},
  [8171] = {.lex_state = 206},
  [8172] = {.lex_state = 229},
  [8173] = {.lex_state = 256},
  [8174] = {.lex_state = 206},
  [8175] = {.lex_state = 256},
  [8176] = {.lex_state = 206},
  [8177] = {.lex_state = 254},
  [8178] = {.lex_state = 256},
  [8179] = {.lex_state = 256},
  [8180] = {.lex_state = 208},
  [8181] = {.lex_state = 207},
  [8182] = {.lex_state = 207},
  [8183] = {.lex_state = 254},
  [8184] = {.lex_state = 254},
  [8185] = {.lex_state = 208},
  [8186] = {.lex_state = 254},
  [8187] = {.lex_state = 254},
  [8188] = {.lex_state = 256},
  [8189] = {.lex_state = 207},
  [8190] = {.lex_state = 254},
  [8191] = {.lex_state = 207},
  [8192] = {.lex_state = 207},
  [8193] = {.lex_state = 254},
  [8194] = {.lex_state = 208},
  [8195] = {.lex_state = 208},
  [8196] = {.lex_state = 254},
  [8197] = {.lex_state = 254},
  [8198] = {.lex_state = 254},
  [8199] = {.lex_state = 254},
  [8200] = {.lex_state = 254},
  [8201] = {.lex_state = 254},
  [8202] = {.lex_state = 256},
  [8203] = {.lex_state = 256},
  [8204] = {.lex_state = 254},
  [8205] = {.lex_state = 254},
  [8206] = {.lex_state = 256},
  [8207] = {.lex_state = 254},
  [8208] = {.lex_state = 207},
  [8209] = {.lex_state = 254},
  [8210] = {.lex_state = 253},
  [8211] = {.lex_state = 254},
  [8212] = {.lex_state = 207},
  [8213] = {.lex_state = 208},
  [8214] = {.lex_state = 253},
  [8215] = {.lex_state = 208},
  [8216] = {.lex_state = 256},
  [8217] = {.lex_state = 253},
  [8218] = {.lex_state = 254},
  [8219] = {.lex_state = 254},
  [8220] = {.lex_state = 207},
  [8221] = {.lex_state = 253},
  [8222] = {.lex_state = 254},
  [8223] = {.lex_state = 254},
  [8224] = {.lex_state = 253},
  [8225] = {.lex_state = 207},
  [8226] = {.lex_state = 253},
  [8227] = {.lex_state = 207},
  [8228] = {.lex_state = 256},
  [8229] = {.lex_state = 254},
  [8230] = {.lex_state = 207},
  [8231] = {.lex_state = 254},
  [8232] = {.lex_state = 254},
  [8233] = {.lex_state = 229},
  [8234] = {.lex_state = 254},
  [8235] = {.lex_state = 229},
  [8236] = {.lex_state = 208},
  [8237] = {.lex_state = 207},
  [8238] = {.lex_state = 229},
  [8239] = {.lex_state = 229},
  [8240] = {.lex_state = 208},
  [8241] = {.lex_state = 253},
  [8242] = {.lex_state = 229},
  [8243] = {.lex_state = 229},
  [8244] = {.lex_state = 254},
  [8245] = {.lex_state = 229},
  [8246] = {.lex_state = 207},
  [8247] = {.lex_state = 208},
  [8248] = {.lex_state = 254},
  [8249] = {.lex_state = 229},
  [8250] = {.lex_state = 256},
  [8251] = {.lex_state = 211},
  [8252] = {.lex_state = 211},
  [8253] = {.lex_state = 253},
  [8254] = {.lex_state = 207},
  [8255] = {.lex_state = 253},
  [8256] = {.lex_state = 211},
  [8257] = {.lex_state = 229},
  [8258] = {.lex_state = 229},
  [8259] = {.lex_state = 229},
  [8260] = {.lex_state = 256},
  [8261] = {.lex_state = 229},
  [8262] = {.lex_state = 229},
  [8263] = {.lex_state = 229},
  [8264] = {.lex_state = 254},
  [8265] = {.lex_state = 256},
  [8266] = {.lex_state = 211},
  [8267] = {.lex_state = 211},
  [8268] = {.lex_state = 211},
  [8269] = {.lex_state = 211},
  [8270] = {.lex_state = 211},
  [8271] = {.lex_state = 211},
  [8272] = {.lex_state = 211},
  [8273] = {.lex_state = 211},
  [8274] = {.lex_state = 256},
  [8275] = {.lex_state = 211},
  [8276] = {.lex_state = 211},
  [8277] = {.lex_state = 207},
  [8278] = {.lex_state = 207},
  [8279] = {.lex_state = 254},
  [8280] = {.lex_state = 207},
  [8281] = {.lex_state = 207},
  [8282] = {.lex_state = 207},
  [8283] = {.lex_state = 253},
  [8284] = {.lex_state = 256},
  [8285] = {.lex_state = 253},
  [8286] = {.lex_state = 253},
  [8287] = {.lex_state = 254},
  [8288] = {.lex_state = 208},
  [8289] = {.lex_state = 253},
  [8290] = {.lex_state = 254},
  [8291] = {.lex_state = 207},
  [8292] = {.lex_state = 254},
  [8293] = {.lex_state = 254},
  [8294] = {.lex_state = 256},
  [8295] = {.lex_state = 253},
  [8296] = {.lex_state = 253},
  [8297] = {.lex_state = 211},
  [8298] = {.lex_state = 207},
  [8299] = {.lex_state = 256},
  [8300] = {.lex_state = 207},
  [8301] = {.lex_state = 256},
  [8302] = {.lex_state = 256},
  [8303] = {.lex_state = 253},
  [8304] = {.lex_state = 256},
  [8305] = {.lex_state = 256},
  [8306] = {.lex_state = 207},
  [8307] = {.lex_state = 256},
  [8308] = {.lex_state = 256},
  [8309] = {.lex_state = 207},
  [8310] = {.lex_state = 256},
  [8311] = {.lex_state = 0},
  [8312] = {.lex_state = 207},
  [8313] = {.lex_state = 207},
  [8314] = {.lex_state = 256},
  [8315] = {.lex_state = 207},
  [8316] = {.lex_state = 207},
  [8317] = {.lex_state = 254},
  [8318] = {.lex_state = 207},
  [8319] = {.lex_state = 256},
  [8320] = {.lex_state = 207},
  [8321] = {.lex_state = 207},
  [8322] = {.lex_state = 207},
  [8323] = {.lex_state = 207},
  [8324] = {.lex_state = 254},
  [8325] = {.lex_state = 207},
  [8326] = {.lex_state = 254},
  [8327] = {.lex_state = 254},
  [8328] = {.lex_state = 207},
  [8329] = {.lex_state = 207},
  [8330] = {.lex_state = 207},
  [8331] = {.lex_state = 207},
  [8332] = {.lex_state = 207},
  [8333] = {.lex_state = 207},
  [8334] = {.lex_state = 207},
  [8335] = {.lex_state = 256},
  [8336] = {.lex_state = 207},
  [8337] = {.lex_state = 256},
  [8338] = {.lex_state = 256},
  [8339] = {.lex_state = 256},
  [8340] = {.lex_state = 256},
  [8341] = {.lex_state = 256},
  [8342] = {.lex_state = 256},
  [8343] = {.lex_state = 256},
  [8344] = {.lex_state = 207},
  [8345] = {.lex_state = 256},
  [8346] = {.lex_state = 207},
  [8347] = {.lex_state = 207},
  [8348] = {.lex_state = 207},
  [8349] = {.lex_state = 252},
  [8350] = {.lex_state = 254},
  [8351] = {.lex_state = 254},
  [8352] = {.lex_state = 254},
  [8353] = {.lex_state = 256},
  [8354] = {.lex_state = 207},
  [8355] = {.lex_state = 254},
  [8356] = {.lex_state = 207},
  [8357] = {.lex_state = 253},
  [8358] = {.lex_state = 256},
  [8359] = {.lex_state = 207},
  [8360] = {.lex_state = 207},
  [8361] = {.lex_state = 256},
  [8362] = {.lex_state = 256},
  [8363] = {.lex_state = 207},
  [8364] = {.lex_state = 247},
  [8365] = {.lex_state = 208},
  [8366] = {.lex_state = 207},
  [8367] = {.lex_state = 208},
  [8368] = {.lex_state = 251},
  [8369] = {.lex_state = 207},
  [8370] = {.lex_state = 207},
  [8371] = {.lex_state = 207},
  [8372] = {.lex_state = 207},
  [8373] = {.lex_state = 207},
  [8374] = {.lex_state = 207},
  [8375] = {.lex_state = 254},
  [8376] = {.lex_state = 207},
  [8377] = {.lex_state = 207},
  [8378] = {.lex_state = 207},
  [8379] = {.lex_state = 207},
  [8380] = {.lex_state = 207},
  [8381] = {.lex_state = 207},
  [8382] = {.lex_state = 207},
  [8383] = {.lex_state = 207},
  [8384] = {.lex_state = 207},
  [8385] = {.lex_state = 207},
  [8386] = {.lex_state = 207},
  [8387] = {.lex_state = 207},
  [8388] = {.lex_state = 207},
  [8389] = {.lex_state = 207},
  [8390] = {.lex_state = 207},
  [8391] = {.lex_state = 207},
  [8392] = {.lex_state = 254},
  [8393] = {.lex_state = 207},
  [8394] = {.lex_state = 207},
  [8395] = {.lex_state = 254},
  [8396] = {.lex_state = 207},
  [8397] = {.lex_state = 207},
  [8398] = {.lex_state = 207},
  [8399] = {.lex_state = 254},
  [8400] = {.lex_state = 207},
  [8401] = {.lex_state = 254},
  [8402] = {.lex_state = 254},
  [8403] = {.lex_state = 254},
  [8404] = {.lex_state = 254},
  [8405] = {.lex_state = 207},
  [8406] = {.lex_state = 207},
  [8407] = {.lex_state = 207},
  [8408] = {.lex_state = 207},
  [8409] = {.lex_state = 207},
  [8410] = {.lex_state = 207},
  [8411] = {.lex_state = 207},
  [8412] = {.lex_state = 206},
  [8413] = {.lex_state = 207},
  [8414] = {.lex_state = 207},
  [8415] = {.lex_state = 247},
  [8416] = {.lex_state = 256},
  [8417] = {.lex_state = 256},
  [8418] = {.lex_state = 256},
  [8419] = {.lex_state = 256},
  [8420] = {.lex_state = 208},
  [8421] = {.lex_state = 256},
  [8422] = {.lex_state = 207},
  [8423] = {.lex_state = 254},
  [8424] = {.lex_state = 254},
  [8425] = {.lex_state = 256},
  [8426] = {.lex_state = 256},
  [8427] = {.lex_state = 254},
  [8428] = {.lex_state = 254},
  [8429] = {.lex_state = 254},
  [8430] = {.lex_state = 254},
  [8431] = {.lex_state = 254},
  [8432] = {.lex_state = 254},
  [8433] = {.lex_state = 254},
  [8434] = {.lex_state = 254},
  [8435] = {.lex_state = 207},
  [8436] = {.lex_state = 207},
  [8437] = {.lex_state = 254},
  [8438] = {.lex_state = 254},
  [8439] = {.lex_state = 254},
  [8440] = {.lex_state = 207},
  [8441] = {.lex_state = 254},
  [8442] = {.lex_state = 208},
  [8443] = {.lex_state = 254},
  [8444] = {.lex_state = 254},
  [8445] = {.lex_state = 207},
  [8446] = {.lex_state = 207},
  [8447] = {.lex_state = 254},
  [8448] = {.lex_state = 254},
  [8449] = {.lex_state = 254},
  [8450] = {.lex_state = 254},
  [8451] = {.lex_state = 253},
  [8452] = {.lex_state = 254},
  [8453] = {.lex_state = 254},
  [8454] = {.lex_state = 207},
  [8455] = {.lex_state = 254},
  [8456] = {.lex_state = 207},
  [8457] = {.lex_state = 207},
  [8458] = {.lex_state = 254},
  [8459] = {.lex_state = 256},
  [8460] = {.lex_state = 208},
  [8461] = {.lex_state = 254},
  [8462] = {.lex_state = 207},
  [8463] = {.lex_state = 208},
  [8464] = {.lex_state = 207},
  [8465] = {.lex_state = 208},
  [8466] = {.lex_state = 207},
  [8467] = {.lex_state = 208},
  [8468] = {.lex_state = 207},
  [8469] = {.lex_state = 208},
  [8470] = {.lex_state = 208},
  [8471] = {.lex_state = 207},
  [8472] = {.lex_state = 208},
  [8473] = {.lex_state = 256},
  [8474] = {.lex_state = 256},
  [8475] = {.lex_state = 256},
  [8476] = {.lex_state = 256},
  [8477] = {.lex_state = 256},
  [8478] = {.lex_state = 256},
  [8479] = {.lex_state = 256},
  [8480] = {.lex_state = 256},
  [8481] = {.lex_state = 207},
  [8482] = {.lex_state = 207},
  [8483] = {.lex_state = 207},
  [8484] = {.lex_state = 256},
  [8485] = {.lex_state = 207},
  [8486] = {.lex_state = 207},
  [8487] = {.lex_state = 207},
  [8488] = {.lex_state = 207},
  [8489] = {.lex_state = 207},
  [8490] = {.lex_state = 207},
  [8491] = {.lex_state = 207},
  [8492] = {.lex_state = 207},
  [8493] = {.lex_state = 207},
  [8494] = {.lex_state = 207},
  [8495] = {.lex_state = 207},
  [8496] = {.lex_state = 207},
  [8497] = {.lex_state = 207},
  [8498] = {.lex_state = 207},
  [8499] = {.lex_state = 207},
  [8500] = {.lex_state = 208},
  [8501] = {.lex_state = 207},
  [8502] = {.lex_state = 256},
  [8503] = {.lex_state = 208},
  [8504] = {.lex_state = 256},
  [8505] = {.lex_state = 208},
  [8506] = {.lex_state = 207},
  [8507] = {.lex_state = 253},
  [8508] = {.lex_state = 208},
  [8509] = {.lex_state = 208},
  [8510] = {.lex_state = 256},
  [8511] = {.lex_state = 237},
  [8512] = {.lex_state = 254},
  [8513] = {.lex_state = 254},
  [8514] = {.lex_state = 254},
  [8515] = {.lex_state = 254},
  [8516] = {.lex_state = 237},
  [8517] = {.lex_state = 254},
  [8518] = {.lex_state = 254},
  [8519] = {.lex_state = 208},
  [8520] = {.lex_state = 251},
  [8521] = {.lex_state = 254},
  [8522] = {.lex_state = 208},
  [8523] = {.lex_state = 256},
  [8524] = {.lex_state = 208},
  [8525] = {.lex_state = 207},
  [8526] = {.lex_state = 253},
  [8527] = {.lex_state = 237},
  [8528] = {.lex_state = 237},
  [8529] = {.lex_state = 256},
  [8530] = {.lex_state = 237},
  [8531] = {.lex_state = 254},
  [8532] = {.lex_state = 256},
  [8533] = {.lex_state = 254},
  [8534] = {.lex_state = 193},
  [8535] = {.lex_state = 237},
  [8536] = {.lex_state = 211},
  [8537] = {.lex_state = 193},
  [8538] = {.lex_state = 254},
  [8539] = {.lex_state = 211},
  [8540] = {.lex_state = 254},
  [8541] = {.lex_state = 211},
  [8542] = {.lex_state = 207},
  [8543] = {.lex_state = 211},
  [8544] = {.lex_state = 207},
  [8545] = {.lex_state = 207},
  [8546] = {.lex_state = 207},
  [8547] = {.lex_state = 207},
  [8548] = {.lex_state = 207},
  [8549] = {.lex_state = 207},
  [8550] = {.lex_state = 211},
  [8551] = {.lex_state = 256},
  [8552] = {.lex_state = 207},
  [8553] = {.lex_state = 228},
  [8554] = {.lex_state = 256},
  [8555] = {.lex_state = 207},
  [8556] = {.lex_state = 207},
  [8557] = {.lex_state = 207},
  [8558] = {.lex_state = 207},
  [8559] = {.lex_state = 207},
  [8560] = {.lex_state = 256},
  [8561] = {.lex_state = 237},
  [8562] = {.lex_state = 207},
  [8563] = {.lex_state = 228},
  [8564] = {.lex_state = 228},
  [8565] = {.lex_state = 228},
  [8566] = {.lex_state = 251},
  [8567] = {.lex_state = 228},
  [8568] = {.lex_state = 208},
  [8569] = {.lex_state = 356},
  [8570] = {.lex_state = 237},
  [8571] = {.lex_state = 207},
  [8572] = {.lex_state = 228},
  [8573] = {.lex_state = 256},
  [8574] = {.lex_state = 256},
  [8575] = {.lex_state = 256},
  [8576] = {.lex_state = 256},
  [8577] = {.lex_state = 228},
  [8578] = {.lex_state = 256},
  [8579] = {.lex_state = 256},
  [8580] = {.lex_state = 256},
  [8581] = {.lex_state = 256},
  [8582] = {.lex_state = 237},
  [8583] = {.lex_state = 211},
  [8584] = {.lex_state = 237},
  [8585] = {.lex_state = 211},
  [8586] = {.lex_state = 237},
  [8587] = {.lex_state = 237},
  [8588] = {.lex_state = 237},
  [8589] = {.lex_state = 228},
  [8590] = {.lex_state = 211},
  [8591] = {.lex_state = 207},
  [8592] = {.lex_state = 256},
  [8593] = {.lex_state = 208},
  [8594] = {.lex_state = 207},
  [8595] = {.lex_state = 256},
  [8596] = {.lex_state = 208},
  [8597] = {.lex_state = 253},
  [8598] = {.lex_state = 256},
  [8599] = {.lex_state = 256},
  [8600] = {.lex_state = 256},
  [8601] = {.lex_state = 207},
  [8602] = {.lex_state = 207},
  [8603] = {.lex_state = 253},
  [8604] = {.lex_state = 207},
  [8605] = {.lex_state = 208},
  [8606] = {.lex_state = 207},
  [8607] = {.lex_state = 253},
  [8608] = {.lex_state = 228},
  [8609] = {.lex_state = 253},
  [8610] = {.lex_state = 211},
  [8611] = {.lex_state = 253},
  [8612] = {.lex_state = 207},
  [8613] = {.lex_state = 253},
  [8614] = {.lex_state = 207},
  [8615] = {.lex_state = 256},
  [8616] = {.lex_state = 256},
  [8617] = {.lex_state = 256},
  [8618] = {.lex_state = 256},
  [8619] = {.lex_state = 256},
  [8620] = {.lex_state = 256},
  [8621] = {.lex_state = 253},
  [8622] = {.lex_state = 253},
  [8623] = {.lex_state = 208},
  [8624] = {.lex_state = 207},
  [8625] = {.lex_state = 247},
  [8626] = {.lex_state = 208},
  [8627] = {.lex_state = 229},
  [8628] = {.lex_state = 356},
  [8629] = {.lex_state = 256},
  [8630] = {.lex_state = 207},
  [8631] = {.lex_state = 253},
  [8632] = {.lex_state = 256},
  [8633] = {.lex_state = 207},
  [8634] = {.lex_state = 228},
  [8635] = {.lex_state = 207},
  [8636] = {.lex_state = 207},
  [8637] = {.lex_state = 207},
  [8638] = {.lex_state = 229},
  [8639] = {.lex_state = 229},
  [8640] = {.lex_state = 207},
  [8641] = {.lex_state = 207},
  [8642] = {.lex_state = 211},
  [8643] = {.lex_state = 356},
  [8644] = {.lex_state = 207},
  [8645] = {.lex_state = 228},
  [8646] = {.lex_state = 356},
  [8647] = {.lex_state = 207},
  [8648] = {.lex_state = 254},
  [8649] = {.lex_state = 207},
  [8650] = {.lex_state = 253},
  [8651] = {.lex_state = 229},
  [8652] = {.lex_state = 256},
  [8653] = {.lex_state = 229},
  [8654] = {.lex_state = 207},
  [8655] = {.lex_state = 207},
  [8656] = {.lex_state = 207},
  [8657] = {.lex_state = 256},
  [8658] = {.lex_state = 356},
  [8659] = {.lex_state = 229},
  [8660] = {.lex_state = 208},
  [8661] = {.lex_state = 256},
  [8662] = {.lex_state = 229},
  [8663] = {.lex_state = 229},
  [8664] = {.lex_state = 253},
  [8665] = {.lex_state = 254},
  [8666] = {.lex_state = 207},
  [8667] = {.lex_state = 256},
  [8668] = {.lex_state = 256},
  [8669] = {.lex_state = 207},
  [8670] = {.lex_state = 256},
  [8671] = {.lex_state = 207},
  [8672] = {.lex_state = 254},
  [8673] = {.lex_state = 253},
  [8674] = {.lex_state = 207},
  [8675] = {.lex_state = 211},
  [8676] = {.lex_state = 207},
  [8677] = {.lex_state = 207},
  [8678] = {.lex_state = 256},
  [8679] = {.lex_state = 207},
  [8680] = {.lex_state = 247},
  [8681] = {.lex_state = 253},
  [8682] = {.lex_state = 208},
  [8683] = {.lex_state = 207},
  [8684] = {.lex_state = 207},
  [8685] = {.lex_state = 208},
  [8686] = {.lex_state = 208},
  [8687] = {.lex_state = 356},
  [8688] = {.lex_state = 253},
  [8689] = {.lex_state = 207},
  [8690] = {.lex_state = 207},
  [8691] = {.lex_state = 256},
  [8692] = {.lex_state = 211},
  [8693] = {.lex_state = 211},
  [8694] = {.lex_state = 211},
  [8695] = {.lex_state = 211},
  [8696] = {.lex_state = 254},
  [8697] = {.lex_state = 211},
  [8698] = {.lex_state = 211},
  [8699] = {.lex_state = 211},
  [8700] = {.lex_state = 253},
  [8701] = {.lex_state = 208},
  [8702] = {.lex_state = 208},
  [8703] = {.lex_state = 256},
  [8704] = {.lex_state = 256},
  [8705] = {.lex_state = 207},
  [8706] = {.lex_state = 207},
  [8707] = {.lex_state = 211},
  [8708] = {.lex_state = 211},
  [8709] = {.lex_state = 211},
  [8710] = {.lex_state = 211},
  [8711] = {.lex_state = 211},
  [8712] = {.lex_state = 211},
  [8713] = {.lex_state = 228},
  [8714] = {.lex_state = 228},
  [8715] = {.lex_state = 228},
  [8716] = {.lex_state = 228},
  [8717] = {.lex_state = 228},
  [8718] = {.lex_state = 228},
  [8719] = {.lex_state = 207},
  [8720] = {.lex_state = 229},
  [8721] = {.lex_state = 247},
  [8722] = {.lex_state = 229},
  [8723] = {.lex_state = 207},
  [8724] = {.lex_state = 356},
  [8725] = {.lex_state = 356},
  [8726] = {.lex_state = 229},
  [8727] = {.lex_state = 207},
  [8728] = {.lex_state = 256},
  [8729] = {.lex_state = 207},
  [8730] = {.lex_state = 247},
  [8731] = {.lex_state = 207},
  [8732] = {.lex_state = 208},
  [8733] = {.lex_state = 211},
  [8734] = {.lex_state = 253},
  [8735] = {.lex_state = 211},
  [8736] = {.lex_state = 211},
  [8737] = {.lex_state = 207},
  [8738] = {.lex_state = 211},
  [8739] = {.lex_state = 211},
  [8740] = {.lex_state = 211},
  [8741] = {.lex_state = 207},
  [8742] = {.lex_state = 211},
  [8743] = {.lex_state = 207},
  [8744] = {.lex_state = 228},
  [8745] = {.lex_state = 211},
  [8746] = {.lex_state = 207},
  [8747] = {.lex_state = 228},
  [8748] = {.lex_state = 228},
  [8749] = {.lex_state = 229},
  [8750] = {.lex_state = 256},
  [8751] = {.lex_state = 254},
  [8752] = {.lex_state = 207},
  [8753] = {.lex_state = 211},
  [8754] = {.lex_state = 207},
  [8755] = {.lex_state = 211},
  [8756] = {.lex_state = 254},
  [8757] = {.lex_state = 207},
  [8758] = {.lex_state = 207},
  [8759] = {.lex_state = 207},
  [8760] = {.lex_state = 228},
  [8761] = {.lex_state = 229},
  [8762] = {.lex_state = 207},
  [8763] = {.lex_state = 207},
  [8764] = {.lex_state = 207},
  [8765] = {.lex_state = 211},
  [8766] = {.lex_state = 207},
  [8767] = {.lex_state = 207},
  [8768] = {.lex_state = 229},
  [8769] = {.lex_state = 207},
  [8770] = {.lex_state = 208},
  [8771] = {.lex_state = 208},
  [8772] = {.lex_state = 356},
  [8773] = {.lex_state = 356},
  [8774] = {.lex_state = 356},
  [8775] = {.lex_state = 207},
  [8776] = {.lex_state = 356},
  [8777] = {.lex_state = 229},
  [8778] = {.lex_state = 229},
  [8779] = {.lex_state = 356},
  [8780] = {.lex_state = 229},
  [8781] = {.lex_state = 254},
  [8782] = {.lex_state = 208},
  [8783] = {.lex_state = 207},
  [8784] = {.lex_state = 207},
  [8785] = {.lex_state = 207},
  [8786] = {.lex_state = 207},
  [8787] = {.lex_state = 253},
  [8788] = {.lex_state = 253},
  [8789] = {.lex_state = 356},
  [8790] = {.lex_state = 253},
  [8791] = {.lex_state = 253},
  [8792] = {.lex_state = 253},
  [8793] = {.lex_state = 253},
  [8794] = {.lex_state = 253},
  [8795] = {.lex_state = 356},
  [8796] = {.lex_state = 253},
  [8797] = {.lex_state = 356},
  [8798] = {.lex_state = 211},
  [8799] = {.lex_state = 211},
  [8800] = {.lex_state = 211},
  [8801] = {.lex_state = 211},
  [8802] = {.lex_state = 211},
  [8803] = {.lex_state = 256},
  [8804] = {.lex_state = 211},
  [8805] = {.lex_state = 211},
  [8806] = {.lex_state = 356},
  [8807] = {.lex_state = 208},
  [8808] = {.lex_state = 207},
  [8809] = {.lex_state = 207},
  [8810] = {.lex_state = 207},
  [8811] = {.lex_state = 256},
  [8812] = {.lex_state = 356},
  [8813] = {.lex_state = 207},
  [8814] = {.lex_state = 356},
  [8815] = {.lex_state = 207},
  [8816] = {.lex_state = 356},
  [8817] = {.lex_state = 256},
  [8818] = {.lex_state = 356},
  [8819] = {.lex_state = 256},
  [8820] = {.lex_state = 356},
  [8821] = {.lex_state = 256},
  [8822] = {.lex_state = 256},
  [8823] = {.lex_state = 187},
  [8824] = {.lex_state = 256},
  [8825] = {.lex_state = 356},
  [8826] = {.lex_state = 256},
  [8827] = {.lex_state = 256},
  [8828] = {.lex_state = 208},
  [8829] = {.lex_state = 256},
  [8830] = {.lex_state = 207},
  [8831] = {.lex_state = 254},
  [8832] = {.lex_state = 254},
  [8833] = {.lex_state = 254},
  [8834] = {.lex_state = 356},
  [8835] = {.lex_state = 254},
  [8836] = {.lex_state = 207},
  [8837] = {.lex_state = 187},
  [8838] = {.lex_state = 237},
  [8839] = {.lex_state = 187},
  [8840] = {.lex_state = 356},
  [8841] = {.lex_state = 356},
  [8842] = {.lex_state = 187},
  [8843] = {.lex_state = 208},
  [8844] = {.lex_state = 256},
  [8845] = {.lex_state = 356},
  [8846] = {.lex_state = 251},
  [8847] = {.lex_state = 356},
  [8848] = {.lex_state = 254},
  [8849] = {.lex_state = 356},
  [8850] = {.lex_state = 256},
  [8851] = {.lex_state = 256},
  [8852] = {.lex_state = 256},
  [8853] = {.lex_state = 256},
  [8854] = {.lex_state = 256},
  [8855] = {.lex_state = 256},
  [8856] = {.lex_state = 187},
  [8857] = {.lex_state = 256},
  [8858] = {.lex_state = 256},
  [8859] = {.lex_state = 356},
  [8860] = {.lex_state = 256},
  [8861] = {.lex_state = 356},
  [8862] = {.lex_state = 256},
  [8863] = {.lex_state = 187},
  [8864] = {.lex_state = 256},
  [8865] = {.lex_state = 256},
  [8866] = {.lex_state = 256},
  [8867] = {.lex_state = 251},
  [8868] = {.lex_state = 256},
  [8869] = {.lex_state = 256},
  [8870] = {.lex_state = 254},
  [8871] = {.lex_state = 237},
  [8872] = {.lex_state = 256},
  [8873] = {.lex_state = 256},
  [8874] = {.lex_state = 356},
  [8875] = {.lex_state = 187},
  [8876] = {.lex_state = 253},
  [8877] = {.lex_state = 256},
  [8878] = {.lex_state = 187},
  [8879] = {.lex_state = 187},
  [8880] = {.lex_state = 256},
  [8881] = {.lex_state = 229},
  [8882] = {.lex_state = 356},
  [8883] = {.lex_state = 356},
  [8884] = {.lex_state = 187},
  [8885] = {.lex_state = 251},
  [8886] = {.lex_state = 356},
  [8887] = {.lex_state = 229},
  [8888] = {.lex_state = 229},
  [8889] = {.lex_state = 208},
  [8890] = {.lex_state = 229},
  [8891] = {.lex_state = 356},
  [8892] = {.lex_state = 208},
  [8893] = {.lex_state = 187},
  [8894] = {.lex_state = 356},
  [8895] = {.lex_state = 356},
  [8896] = {.lex_state = 256},
  [8897] = {.lex_state = 254},
  [8898] = {.lex_state = 208},
  [8899] = {.lex_state = 254},
  [8900] = {.lex_state = 187},
  [8901] = {.lex_state = 207},
  [8902] = {.lex_state = 254},
  [8903] = {.lex_state = 256},
  [8904] = {.lex_state = 256},
  [8905] = {.lex_state = 207},
  [8906] = {.lex_state = 256},
  [8907] = {.lex_state = 207},
  [8908] = {.lex_state = 254},
  [8909] = {.lex_state = 254},
  [8910] = {.lex_state = 254},
  [8911] = {.lex_state = 207},
  [8912] = {.lex_state = 207},
  [8913] = {.lex_state = 256},
  [8914] = {.lex_state = 254},
  [8915] = {.lex_state = 356},
  [8916] = {.lex_state = 207},
  [8917] = {.lex_state = 207},
  [8918] = {.lex_state = 256},
  [8919] = {.lex_state = 207},
  [8920] = {.lex_state = 207},
  [8921] = {.lex_state = 256},
  [8922] = {.lex_state = 207},
  [8923] = {.lex_state = 254},
  [8924] = {.lex_state = 256},
  [8925] = {.lex_state = 207},
  [8926] = {.lex_state = 207},
  [8927] = {.lex_state = 254},
  [8928] = {.lex_state = 254},
  [8929] = {.lex_state = 356},
  [8930] = {.lex_state = 256},
  [8931] = {.lex_state = 187},
  [8932] = {.lex_state = 253},
  [8933] = {.lex_state = 207},
  [8934] = {.lex_state = 253},
  [8935] = {.lex_state = 207},
  [8936] = {.lex_state = 187},
  [8937] = {.lex_state = 254},
  [8938] = {.lex_state = 254},
  [8939] = {.lex_state = 356},
  [8940] = {.lex_state = 254},
  [8941] = {.lex_state = 254},
  [8942] = {.lex_state = 208},
  [8943] = {.lex_state = 256},
  [8944] = {.lex_state = 207},
  [8945] = {.lex_state = 207},
  [8946] = {.lex_state = 207},
  [8947] = {.lex_state = 356},
  [8948] = {.lex_state = 356},
  [8949] = {.lex_state = 187},
  [8950] = {.lex_state = 356},
  [8951] = {.lex_state = 356},
  [8952] = {.lex_state = 187},
  [8953] = {.lex_state = 187},
  [8954] = {.lex_state = 251},
  [8955] = {.lex_state = 208},
  [8956] = {.lex_state = 254},
  [8957] = {.lex_state = 207},
  [8958] = {.lex_state = 207},
  [8959] = {.lex_state = 187},
  [8960] = {.lex_state = 187},
  [8961] = {.lex_state = 254},
  [8962] = {.lex_state = 254},
  [8963] = {.lex_state = 256},
  [8964] = {.lex_state = 207},
  [8965] = {.lex_state = 207},
  [8966] = {.lex_state = 254},
  [8967] = {.lex_state = 187},
  [8968] = {.lex_state = 356},
  [8969] = {.lex_state = 208},
  [8970] = {.lex_state = 256},
  [8971] = {.lex_state = 207},
  [8972] = {.lex_state = 207},
  [8973] = {.lex_state = 254},
  [8974] = {.lex_state = 208},
  [8975] = {.lex_state = 254},
  [8976] = {.lex_state = 254},
  [8977] = {.lex_state = 207},
  [8978] = {.lex_state = 254},
  [8979] = {.lex_state = 207},
  [8980] = {.lex_state = 208},
  [8981] = {.lex_state = 254},
  [8982] = {.lex_state = 254},
  [8983] = {.lex_state = 208},
  [8984] = {.lex_state = 356},
  [8985] = {.lex_state = 356},
  [8986] = {.lex_state = 207},
  [8987] = {.lex_state = 356},
  [8988] = {.lex_state = 356},
  [8989] = {.lex_state = 356},
  [8990] = {.lex_state = 254},
  [8991] = {.lex_state = 356},
  [8992] = {.lex_state = 356},
  [8993] = {.lex_state = 356},
  [8994] = {.lex_state = 356},
  [8995] = {.lex_state = 356},
  [8996] = {.lex_state = 208},
  [8997] = {.lex_state = 207},
  [8998] = {.lex_state = 356},
  [8999] = {.lex_state = 356},
  [9000] = {.lex_state = 208},
  [9001] = {.lex_state = 207},
  [9002] = {.lex_state = 208},
  [9003] = {.lex_state = 356},
  [9004] = {.lex_state = 208},
  [9005] = {.lex_state = 208},
  [9006] = {.lex_state = 207},
  [9007] = {.lex_state = 207},
  [9008] = {.lex_state = 254},
  [9009] = {.lex_state = 254},
  [9010] = {.lex_state = 254},
  [9011] = {.lex_state = 356},
  [9012] = {.lex_state = 187},
  [9013] = {.lex_state = 207},
  [9014] = {.lex_state = 208},
  [9015] = {.lex_state = 254},
  [9016] = {.lex_state = 254},
  [9017] = {.lex_state = 207},
  [9018] = {.lex_state = 256},
  [9019] = {.lex_state = 256},
  [9020] = {.lex_state = 207},
  [9021] = {.lex_state = 208},
  [9022] = {.lex_state = 207},
  [9023] = {.lex_state = 254},
  [9024] = {.lex_state = 254},
  [9025] = {.lex_state = 251},
  [9026] = {.lex_state = 208},
  [9027] = {.lex_state = 207},
  [9028] = {.lex_state = 207},
  [9029] = {.lex_state = 254},
  [9030] = {.lex_state = 207},
  [9031] = {.lex_state = 254},
  [9032] = {.lex_state = 207},
  [9033] = {.lex_state = 254},
  [9034] = {.lex_state = 207},
  [9035] = {.lex_state = 206},
  [9036] = {.lex_state = 187},
  [9037] = {.lex_state = 254},
  [9038] = {.lex_state = 251},
  [9039] = {.lex_state = 207},
  [9040] = {.lex_state = 211},
  [9041] = {.lex_state = 210},
  [9042] = {.lex_state = 187},
  [9043] = {.lex_state = 207},
  [9044] = {.lex_state = 187},
  [9045] = {.lex_state = 207},
  [9046] = {.lex_state = 251},
  [9047] = {.lex_state = 187},
  [9048] = {.lex_state = 207},
  [9049] = {.lex_state = 207},
  [9050] = {.lex_state = 207},
  [9051] = {.lex_state = 207},
  [9052] = {.lex_state = 207},
  [9053] = {.lex_state = 207},
  [9054] = {.lex_state = 254},
  [9055] = {.lex_state = 211},
  [9056] = {.lex_state = 207},
  [9057] = {.lex_state = 253},
  [9058] = {.lex_state = 207},
  [9059] = {.lex_state = 187},
  [9060] = {.lex_state = 254},
  [9061] = {.lex_state = 207},
  [9062] = {.lex_state = 253},
  [9063] = {.lex_state = 211},
  [9064] = {.lex_state = 254},
  [9065] = {.lex_state = 207},
  [9066] = {.lex_state = 207},
  [9067] = {.lex_state = 208},
  [9068] = {.lex_state = 0},
  [9069] = {.lex_state = 354},
  [9070] = {.lex_state = 208},
  [9071] = {.lex_state = 211},
  [9072] = {.lex_state = 208},
  [9073] = {.lex_state = 187},
  [9074] = {.lex_state = 251},
  [9075] = {.lex_state = 206},
  [9076] = {.lex_state = 211},
  [9077] = {.lex_state = 207},
  [9078] = {.lex_state = 356},
  [9079] = {.lex_state = 356},
  [9080] = {.lex_state = 211},
  [9081] = {.lex_state = 354},
  [9082] = {.lex_state = 207},
  [9083] = {.lex_state = 206},
  [9084] = {.lex_state = 254},
  [9085] = {.lex_state = 354},
  [9086] = {.lex_state = 208},
  [9087] = {.lex_state = 251},
  [9088] = {.lex_state = 254},
  [9089] = {.lex_state = 210},
  [9090] = {.lex_state = 210},
  [9091] = {.lex_state = 356},
  [9092] = {.lex_state = 207},
  [9093] = {.lex_state = 356},
  [9094] = {.lex_state = 356},
  [9095] = {.lex_state = 356},
  [9096] = {.lex_state = 354},
  [9097] = {.lex_state = 356},
  [9098] = {.lex_state = 254},
  [9099] = {.lex_state = 251},
  [9100] = {.lex_state = 356},
  [9101] = {.lex_state = 354},
  [9102] = {.lex_state = 251},
  [9103] = {.lex_state = 207},
  [9104] = {.lex_state = 254},
  [9105] = {.lex_state = 208},
  [9106] = {.lex_state = 207},
  [9107] = {.lex_state = 356},
  [9108] = {.lex_state = 208},
  [9109] = {.lex_state = 251},
  [9110] = {.lex_state = 251},
  [9111] = {.lex_state = 208},
  [9112] = {.lex_state = 208},
  [9113] = {.lex_state = 208},
  [9114] = {.lex_state = 208},
  [9115] = {.lex_state = 206},
  [9116] = {.lex_state = 251},
  [9117] = {.lex_state = 210},
  [9118] = {.lex_state = 207},
  [9119] = {.lex_state = 254},
  [9120] = {.lex_state = 356},
  [9121] = {.lex_state = 208},
  [9122] = {.lex_state = 254},
  [9123] = {.lex_state = 254},
  [9124] = {.lex_state = 207},
  [9125] = {.lex_state = 254},
  [9126] = {.lex_state = 356},
  [9127] = {.lex_state = 206},
  [9128] = {.lex_state = 206},
  [9129] = {.lex_state = 208},
  [9130] = {.lex_state = 206},
  [9131] = {.lex_state = 207},
  [9132] = {.lex_state = 207},
  [9133] = {.lex_state = 208},
  [9134] = {.lex_state = 207},
  [9135] = {.lex_state = 208},
  [9136] = {.lex_state = 187},
  [9137] = {.lex_state = 206},
  [9138] = {.lex_state = 207},
  [9139] = {.lex_state = 207},
  [9140] = {.lex_state = 206},
  [9141] = {.lex_state = 207},
  [9142] = {.lex_state = 208},
  [9143] = {.lex_state = 207},
  [9144] = {.lex_state = 207},
  [9145] = {.lex_state = 207},
  [9146] = {.lex_state = 206},
  [9147] = {.lex_state = 256},
  [9148] = {.lex_state = 208},
  [9149] = {.lex_state = 207},
  [9150] = {.lex_state = 251},
  [9151] = {.lex_state = 254},
  [9152] = {.lex_state = 251},
  [9153] = {.lex_state = 354},
  [9154] = {.lex_state = 356},
  [9155] = {.lex_state = 254},
  [9156] = {.lex_state = 254},
  [9157] = {.lex_state = 207},
  [9158] = {.lex_state = 254},
  [9159] = {.lex_state = 208},
  [9160] = {.lex_state = 254},
  [9161] = {.lex_state = 254},
  [9162] = {.lex_state = 207},
  [9163] = {.lex_state = 207},
  [9164] = {.lex_state = 208},
  [9165] = {.lex_state = 210},
  [9166] = {.lex_state = 254},
  [9167] = {.lex_state = 206},
  [9168] = {.lex_state = 207},
  [9169] = {.lex_state = 254},
  [9170] = {.lex_state = 208},
  [9171] = {.lex_state = 207},
  [9172] = {.lex_state = 251},
  [9173] = {.lex_state = 254},
  [9174] = {.lex_state = 207},
  [9175] = {.lex_state = 207},
  [9176] = {.lex_state = 254},
  [9177] = {.lex_state = 0},
  [9178] = {.lex_state = 207},
  [9179] = {.lex_state = 256},
  [9180] = {.lex_state = 207},
  [9181] = {.lex_state = 207},
  [9182] = {.lex_state = 228},
  [9183] = {.lex_state = 251},
  [9184] = {.lex_state = 228},
  [9185] = {.lex_state = 228},
  [9186] = {.lex_state = 228},
  [9187] = {.lex_state = 210},
  [9188] = {.lex_state = 228},
  [9189] = {.lex_state = 228},
  [9190] = {.lex_state = 356},
  [9191] = {.lex_state = 207},
  [9192] = {.lex_state = 256},
  [9193] = {.lex_state = 207},
  [9194] = {.lex_state = 207},
  [9195] = {.lex_state = 254},
  [9196] = {.lex_state = 251},
  [9197] = {.lex_state = 251},
  [9198] = {.lex_state = 210},
  [9199] = {.lex_state = 187},
  [9200] = {.lex_state = 187},
  [9201] = {.lex_state = 251},
  [9202] = {.lex_state = 251},
  [9203] = {.lex_state = 254},
  [9204] = {.lex_state = 254},
  [9205] = {.lex_state = 207},
  [9206] = {.lex_state = 210},
  [9207] = {.lex_state = 208},
  [9208] = {.lex_state = 207},
  [9209] = {.lex_state = 210},
  [9210] = {.lex_state = 207},
  [9211] = {.lex_state = 208},
  [9212] = {.lex_state = 208},
  [9213] = {.lex_state = 254},
  [9214] = {.lex_state = 207},
  [9215] = {.lex_state = 208},
  [9216] = {.lex_state = 208},
  [9217] = {.lex_state = 207},
  [9218] = {.lex_state = 254},
  [9219] = {.lex_state = 254},
  [9220] = {.lex_state = 207},
  [9221] = {.lex_state = 254},
  [9222] = {.lex_state = 187},
  [9223] = {.lex_state = 207},
  [9224] = {.lex_state = 187},
  [9225] = {.lex_state = 187},
  [9226] = {.lex_state = 207},
  [9227] = {.lex_state = 210},
  [9228] = {.lex_state = 187},
  [9229] = {.lex_state = 187},
  [9230] = {.lex_state = 187},
  [9231] = {.lex_state = 187},
  [9232] = {.lex_state = 210},
  [9233] = {.lex_state = 207},
  [9234] = {.lex_state = 254},
  [9235] = {.lex_state = 207},
  [9236] = {.lex_state = 207},
  [9237] = {.lex_state = 187},
  [9238] = {.lex_state = 208},
  [9239] = {.lex_state = 210},
  [9240] = {.lex_state = 254},
  [9241] = {.lex_state = 207},
  [9242] = {.lex_state = 187},
  [9243] = {.lex_state = 207},
  [9244] = {.lex_state = 207},
  [9245] = {.lex_state = 207},
  [9246] = {.lex_state = 254},
  [9247] = {.lex_state = 254},
  [9248] = {.lex_state = 254},
  [9249] = {.lex_state = 207},
  [9250] = {.lex_state = 356},
  [9251] = {.lex_state = 356},
  [9252] = {.lex_state = 207},
  [9253] = {.lex_state = 207},
  [9254] = {.lex_state = 207},
  [9255] = {.lex_state = 207},
  [9256] = {.lex_state = 207},
  [9257] = {.lex_state = 207},
  [9258] = {.lex_state = 207},
  [9259] = {.lex_state = 254},
  [9260] = {.lex_state = 207},
  [9261] = {.lex_state = 207},
  [9262] = {.lex_state = 207},
  [9263] = {.lex_state = 207},
  [9264] = {.lex_state = 208},
  [9265] = {.lex_state = 207},
  [9266] = {.lex_state = 207},
  [9267] = {.lex_state = 356},
  [9268] = {.lex_state = 210},
  [9269] = {.lex_state = 207},
  [9270] = {.lex_state = 183},
  [9271] = {.lex_state = 207},
  [9272] = {.lex_state = 254},
  [9273] = {.lex_state = 183},
  [9274] = {.lex_state = 207},
  [9275] = {.lex_state = 187},
  [9276] = {.lex_state = 207},
  [9277] = {.lex_state = 0},
  [9278] = {.lex_state = 356},
  [9279] = {.lex_state = 207},
  [9280] = {.lex_state = 207},
  [9281] = {.lex_state = 254},
  [9282] = {.lex_state = 0},
  [9283] = {.lex_state = 187},
  [9284] = {.lex_state = 207},
  [9285] = {.lex_state = 207},
  [9286] = {.lex_state = 207},
  [9287] = {.lex_state = 207},
  [9288] = {.lex_state = 207},
  [9289] = {.lex_state = 254},
  [9290] = {.lex_state = 207},
  [9291] = {.lex_state = 207},
  [9292] = {.lex_state = 210},
  [9293] = {.lex_state = 256},
  [9294] = {.lex_state = 207},
  [9295] = {.lex_state = 207},
  [9296] = {.lex_state = 208},
  [9297] = {.lex_state = 207},
  [9298] = {.lex_state = 207},
  [9299] = {.lex_state = 253},
  [9300] = {.lex_state = 210},
  [9301] = {.lex_state = 207},
  [9302] = {.lex_state = 207},
  [9303] = {.lex_state = 0},
  [9304] = {.lex_state = 0},
  [9305] = {.lex_state = 207},
  [9306] = {.lex_state = 207},
  [9307] = {.lex_state = 207},
  [9308] = {.lex_state = 207},
  [9309] = {.lex_state = 207},
  [9310] = {.lex_state = 254},
  [9311] = {.lex_state = 187},
  [9312] = {.lex_state = 254},
  [9313] = {.lex_state = 251},
  [9314] = {.lex_state = 207},
  [9315] = {.lex_state = 207},
  [9316] = {.lex_state = 207},
  [9317] = {.lex_state = 207},
  [9318] = {.lex_state = 356},
  [9319] = {.lex_state = 114},
  [9320] = {.lex_state = 116},
  [9321] = {.lex_state = 207},
  [9322] = {.lex_state = 207},
  [9323] = {.lex_state = 114},
  [9324] = {.lex_state = 114},
  [9325] = {.lex_state = 207},
  [9326] = {.lex_state = 356},
  [9327] = {.lex_state = 356},
  [9328] = {.lex_state = 207},
  [9329] = {.lex_state = 207},
  [9330] = {.lex_state = 356},
  [9331] = {.lex_state = 356},
  [9332] = {.lex_state = 356},
  [9333] = {.lex_state = 356},
  [9334] = {.lex_state = 210},
  [9335] = {.lex_state = 356},
  [9336] = {.lex_state = 210},
  [9337] = {.lex_state = 356},
  [9338] = {.lex_state = 356},
  [9339] = {.lex_state = 356},
  [9340] = {.lex_state = 207},
  [9341] = {.lex_state = 210},
  [9342] = {.lex_state = 210},
  [9343] = {.lex_state = 356},
  [9344] = {.lex_state = 356},
  [9345] = {.lex_state = 356},
  [9346] = {.lex_state = 356},
  [9347] = {.lex_state = 210},
  [9348] = {.lex_state = 356},
  [9349] = {.lex_state = 356},
  [9350] = {.lex_state = 0},
  [9351] = {.lex_state = 356},
  [9352] = {.lex_state = 356},
  [9353] = {.lex_state = 356},
  [9354] = {.lex_state = 0},
  [9355] = {.lex_state = 0},
  [9356] = {.lex_state = 0},
  [9357] = {.lex_state = 114},
  [9358] = {.lex_state = 0},
  [9359] = {.lex_state = 207},
  [9360] = {.lex_state = 210},
  [9361] = {.lex_state = 117},
  [9362] = {.lex_state = 210},
  [9363] = {.lex_state = 356},
  [9364] = {.lex_state = 210},
  [9365] = {.lex_state = 207},
  [9366] = {.lex_state = 251},
  [9367] = {.lex_state = 210},
  [9368] = {.lex_state = 116},
  [9369] = {.lex_state = 114},
  [9370] = {.lex_state = 356},
  [9371] = {.lex_state = 356},
  [9372] = {.lex_state = 207},
  [9373] = {.lex_state = 356},
  [9374] = {.lex_state = 210},
  [9375] = {.lex_state = 0},
  [9376] = {.lex_state = 0},
  [9377] = {.lex_state = 356},
  [9378] = {.lex_state = 210},
  [9379] = {.lex_state = 210},
  [9380] = {.lex_state = 210},
  [9381] = {.lex_state = 210},
  [9382] = {.lex_state = 210},
  [9383] = {.lex_state = 210},
  [9384] = {.lex_state = 117},
  [9385] = {.lex_state = 356},
  [9386] = {.lex_state = 356},
  [9387] = {.lex_state = 356},
  [9388] = {.lex_state = 210},
  [9389] = {.lex_state = 356},
  [9390] = {.lex_state = 114},
  [9391] = {.lex_state = 254},
  [9392] = {.lex_state = 117},
  [9393] = {.lex_state = 0},
  [9394] = {.lex_state = 0},
  [9395] = {.lex_state = 356},
  [9396] = {.lex_state = 210},
  [9397] = {.lex_state = 210},
  [9398] = {.lex_state = 210},
  [9399] = {.lex_state = 114},
  [9400] = {.lex_state = 117},
  [9401] = {.lex_state = 251},
  [9402] = {.lex_state = 210},
  [9403] = {.lex_state = 356},
  [9404] = {.lex_state = 210},
  [9405] = {.lex_state = 116},
  [9406] = {.lex_state = 114},
  [9407] = {.lex_state = 356},
  [9408] = {.lex_state = 116},
  [9409] = {.lex_state = 114},
  [9410] = {.lex_state = 356},
  [9411] = {.lex_state = 210},
  [9412] = {.lex_state = 210},
  [9413] = {.lex_state = 207},
  [9414] = {.lex_state = 356},
  [9415] = {.lex_state = 356},
  [9416] = {.lex_state = 207},
  [9417] = {.lex_state = 254},
  [9418] = {.lex_state = 210},
  [9419] = {.lex_state = 356},
  [9420] = {.lex_state = 254},
  [9421] = {.lex_state = 0},
  [9422] = {.lex_state = 356},
  [9423] = {.lex_state = 356},
  [9424] = {.lex_state = 210},
  [9425] = {.lex_state = 251},
  [9426] = {.lex_state = 356},
  [9427] = {.lex_state = 210},
  [9428] = {.lex_state = 356},
  [9429] = {.lex_state = 356},
  [9430] = {.lex_state = 356},
  [9431] = {.lex_state = 207},
  [9432] = {.lex_state = 210},
  [9433] = {.lex_state = 210},
  [9434] = {.lex_state = 251},
  [9435] = {.lex_state = 356},
  [9436] = {.lex_state = 210},
  [9437] = {.lex_state = 210},
  [9438] = {.lex_state = 114},
  [9439] = {.lex_state = 210},
  [9440] = {.lex_state = 210},
  [9441] = {.lex_state = 116},
  [9442] = {.lex_state = 114},
  [9443] = {.lex_state = 356},
  [9444] = {.lex_state = 356},
  [9445] = {.lex_state = 251},
  [9446] = {.lex_state = 210},
  [9447] = {.lex_state = 210},
  [9448] = {.lex_state = 251},
  [9449] = {.lex_state = 356},
  [9450] = {.lex_state = 356},
  [9451] = {.lex_state = 210},
  [9452] = {.lex_state = 251},
  [9453] = {.lex_state = 183},
  [9454] = {.lex_state = 116},
  [9455] = {.lex_state = 210},
  [9456] = {.lex_state = 210},
  [9457] = {.lex_state = 356},
  [9458] = {.lex_state = 114},
  [9459] = {.lex_state = 114},
  [9460] = {.lex_state = 210},
  [9461] = {.lex_state = 356},
  [9462] = {.lex_state = 251},
  [9463] = {.lex_state = 210},
  [9464] = {.lex_state = 210},
  [9465] = {.lex_state = 116},
  [9466] = {.lex_state = 114},
  [9467] = {.lex_state = 356},
  [9468] = {.lex_state = 114},
  [9469] = {.lex_state = 210},
  [9470] = {.lex_state = 356},
  [9471] = {.lex_state = 210},
  [9472] = {.lex_state = 210},
  [9473] = {.lex_state = 210},
  [9474] = {.lex_state = 356},
  [9475] = {.lex_state = 251},
  [9476] = {.lex_state = 356},
  [9477] = {.lex_state = 356},
  [9478] = {.lex_state = 114},
  [9479] = {.lex_state = 356},
  [9480] = {.lex_state = 356},
  [9481] = {.lex_state = 0},
  [9482] = {.lex_state = 0},
  [9483] = {.lex_state = 117},
  [9484] = {.lex_state = 0},
  [9485] = {.lex_state = 116},
  [9486] = {.lex_state = 356},
  [9487] = {.lex_state = 114},
  [9488] = {.lex_state = 114},
  [9489] = {.lex_state = 356},
  [9490] = {.lex_state = 210},
  [9491] = {.lex_state = 116},
  [9492] = {.lex_state = 114},
  [9493] = {.lex_state = 251},
  [9494] = {.lex_state = 210},
  [9495] = {.lex_state = 207},
  [9496] = {.lex_state = 207},
  [9497] = {.lex_state = 210},
  [9498] = {.lex_state = 356},
  [9499] = {.lex_state = 356},
  [9500] = {.lex_state = 356},
  [9501] = {.lex_state = 116},
  [9502] = {.lex_state = 207},
  [9503] = {.lex_state = 114},
  [9504] = {.lex_state = 356},
  [9505] = {.lex_state = 356},
  [9506] = {.lex_state = 356},
  [9507] = {.lex_state = 114},
  [9508] = {.lex_state = 114},
  [9509] = {.lex_state = 210},
  [9510] = {.lex_state = 116},
  [9511] = {.lex_state = 114},
  [9512] = {.lex_state = 210},
  [9513] = {.lex_state = 356},
  [9514] = {.lex_state = 356},
  [9515] = {.lex_state = 356},
  [9516] = {.lex_state = 356},
  [9517] = {.lex_state = 0},
  [9518] = {.lex_state = 207},
  [9519] = {.lex_state = 210},
  [9520] = {.lex_state = 114},
  [9521] = {.lex_state = 356},
  [9522] = {.lex_state = 210},
  [9523] = {.lex_state = 210},
  [9524] = {.lex_state = 116},
  [9525] = {.lex_state = 114},
  [9526] = {.lex_state = 117},
  [9527] = {.lex_state = 210},
  [9528] = {.lex_state = 210},
  [9529] = {.lex_state = 210},
  [9530] = {.lex_state = 210},
  [9531] = {.lex_state = 356},
  [9532] = {.lex_state = 356},
  [9533] = {.lex_state = 114},
  [9534] = {.lex_state = 356},
  [9535] = {.lex_state = 356},
  [9536] = {.lex_state = 114},
  [9537] = {.lex_state = 356},
  [9538] = {.lex_state = 356},
  [9539] = {.lex_state = 183},
  [9540] = {.lex_state = 114},
  [9541] = {.lex_state = 356},
  [9542] = {.lex_state = 114},
  [9543] = {.lex_state = 356},
  [9544] = {.lex_state = 251},
  [9545] = {.lex_state = 356},
  [9546] = {.lex_state = 356},
  [9547] = {.lex_state = 207},
  [9548] = {.lex_state = 356},
  [9549] = {.lex_state = 210},
  [9550] = {.lex_state = 356},
  [9551] = {.lex_state = 210},
  [9552] = {.lex_state = 356},
  [9553] = {.lex_state = 114},
  [9554] = {.lex_state = 114},
  [9555] = {.lex_state = 356},
  [9556] = {.lex_state = 356},
  [9557] = {.lex_state = 356},
  [9558] = {.lex_state = 356},
  [9559] = {.lex_state = 356},
  [9560] = {.lex_state = 356},
  [9561] = {.lex_state = 356},
  [9562] = {.lex_state = 114},
  [9563] = {.lex_state = 356},
  [9564] = {.lex_state = 210},
  [9565] = {.lex_state = 356},
  [9566] = {.lex_state = 356},
  [9567] = {.lex_state = 114},
  [9568] = {.lex_state = 210},
  [9569] = {.lex_state = 356},
  [9570] = {.lex_state = 356},
  [9571] = {.lex_state = 210},
  [9572] = {.lex_state = 356},
  [9573] = {.lex_state = 356},
  [9574] = {.lex_state = 356},
  [9575] = {.lex_state = 356},
  [9576] = {.lex_state = 356},
  [9577] = {.lex_state = 356},
  [9578] = {.lex_state = 356},
  [9579] = {.lex_state = 210},
  [9580] = {.lex_state = 114},
  [9581] = {.lex_state = 210},
  [9582] = {.lex_state = 114},
  [9583] = {.lex_state = 114},
  [9584] = {.lex_state = 356},
  [9585] = {.lex_state = 356},
  [9586] = {.lex_state = 117},
  [9587] = {.lex_state = 0},
  [9588] = {.lex_state = 210},
  [9589] = {.lex_state = 210},
  [9590] = {.lex_state = 0},
  [9591] = {.lex_state = 356},
  [9592] = {.lex_state = 210},
  [9593] = {.lex_state = 210},
  [9594] = {.lex_state = 114},
  [9595] = {.lex_state = 210},
  [9596] = {.lex_state = 114},
  [9597] = {.lex_state = 210},
  [9598] = {.lex_state = 356},
  [9599] = {.lex_state = 116},
  [9600] = {.lex_state = 114},
  [9601] = {.lex_state = 356},
  [9602] = {.lex_state = 254},
  [9603] = {.lex_state = 0},
  [9604] = {.lex_state = 207},
  [9605] = {.lex_state = 0},
  [9606] = {.lex_state = 0},
  [9607] = {.lex_state = 0},
  [9608] = {.lex_state = 0},
  [9609] = {.lex_state = 0},
  [9610] = {.lex_state = 0},
  [9611] = {.lex_state = 0},
  [9612] = {.lex_state = 0},
  [9613] = {.lex_state = 183},
  [9614] = {.lex_state = 0},
  [9615] = {.lex_state = 0},
  [9616] = {.lex_state = 0},
  [9617] = {.lex_state = 0},
  [9618] = {.lex_state = 0},
  [9619] = {.lex_state = 0},
  [9620] = {.lex_state = 0},
  [9621] = {.lex_state = 210},
  [9622] = {.lex_state = 354},
  [9623] = {.lex_state = 210},
  [9624] = {.lex_state = 0},
  [9625] = {.lex_state = 207},
  [9626] = {.lex_state = 0},
  [9627] = {.lex_state = 0},
  [9628] = {.lex_state = 0},
  [9629] = {.lex_state = 0},
  [9630] = {.lex_state = 0},
  [9631] = {.lex_state = 207},
  [9632] = {.lex_state = 210},
  [9633] = {.lex_state = 207},
  [9634] = {.lex_state = 0},
  [9635] = {.lex_state = 0},
  [9636] = {.lex_state = 0},
  [9637] = {.lex_state = 0},
  [9638] = {.lex_state = 0},
  [9639] = {.lex_state = 0},
  [9640] = {.lex_state = 210},
  [9641] = {.lex_state = 210},
  [9642] = {.lex_state = 0},
  [9643] = {.lex_state = 210},
  [9644] = {.lex_state = 210},
  [9645] = {.lex_state = 0},
  [9646] = {.lex_state = 0},
  [9647] = {.lex_state = 0},
  [9648] = {.lex_state = 0},
  [9649] = {.lex_state = 0},
  [9650] = {.lex_state = 0},
  [9651] = {.lex_state = 0},
  [9652] = {.lex_state = 0},
  [9653] = {.lex_state = 0},
  [9654] = {.lex_state = 207},
  [9655] = {.lex_state = 0},
  [9656] = {.lex_state = 0},
  [9657] = {.lex_state = 0},
  [9658] = {.lex_state = 356},
  [9659] = {.lex_state = 207},
  [9660] = {.lex_state = 0},
  [9661] = {.lex_state = 207},
  [9662] = {.lex_state = 0},
  [9663] = {.lex_state = 210},
  [9664] = {.lex_state = 210},
  [9665] = {.lex_state = 0},
  [9666] = {.lex_state = 0},
  [9667] = {.lex_state = 0},
  [9668] = {.lex_state = 0},
  [9669] = {.lex_state = 0},
  [9670] = {.lex_state = 0},
  [9671] = {.lex_state = 0},
  [9672] = {.lex_state = 0},
  [9673] = {.lex_state = 210},
  [9674] = {.lex_state = 210},
  [9675] = {.lex_state = 0},
  [9676] = {.lex_state = 0},
  [9677] = {.lex_state = 0},
  [9678] = {.lex_state = 210},
  [9679] = {.lex_state = 0},
  [9680] = {.lex_state = 119},
  [9681] = {.lex_state = 0},
  [9682] = {.lex_state = 0},
  [9683] = {.lex_state = 0},
  [9684] = {.lex_state = 0},
  [9685] = {.lex_state = 0},
  [9686] = {.lex_state = 210},
  [9687] = {.lex_state = 0},
  [9688] = {.lex_state = 0},
  [9689] = {.lex_state = 0},
  [9690] = {.lex_state = 0},
  [9691] = {.lex_state = 0},
  [9692] = {.lex_state = 0},
  [9693] = {.lex_state = 0},
  [9694] = {.lex_state = 0},
  [9695] = {.lex_state = 210},
  [9696] = {.lex_state = 210},
  [9697] = {.lex_state = 183},
  [9698] = {.lex_state = 0},
  [9699] = {.lex_state = 0},
  [9700] = {.lex_state = 0},
  [9701] = {.lex_state = 210},
  [9702] = {.lex_state = 183},
  [9703] = {.lex_state = 0},
  [9704] = {.lex_state = 0},
  [9705] = {.lex_state = 210},
  [9706] = {.lex_state = 0},
  [9707] = {.lex_state = 0},
  [9708] = {.lex_state = 0},
  [9709] = {.lex_state = 0},
  [9710] = {.lex_state = 0},
  [9711] = {.lex_state = 207},
  [9712] = {.lex_state = 0},
  [9713] = {.lex_state = 0},
  [9714] = {.lex_state = 0},
  [9715] = {.lex_state = 0},
  [9716] = {.lex_state = 0},
  [9717] = {.lex_state = 0},
  [9718] = {.lex_state = 0},
  [9719] = {.lex_state = 0},
  [9720] = {.lex_state = 0},
  [9721] = {.lex_state = 210},
  [9722] = {.lex_state = 207},
  [9723] = {.lex_state = 207},
  [9724] = {.lex_state = 0},
  [9725] = {.lex_state = 0},
  [9726] = {.lex_state = 207},
  [9727] = {.lex_state = 210},
  [9728] = {.lex_state = 0},
  [9729] = {.lex_state = 0},
  [9730] = {.lex_state = 0},
  [9731] = {.lex_state = 183},
  [9732] = {.lex_state = 0},
  [9733] = {.lex_state = 210},
  [9734] = {.lex_state = 0},
  [9735] = {.lex_state = 0},
  [9736] = {.lex_state = 0},
  [9737] = {.lex_state = 0},
  [9738] = {.lex_state = 210},
  [9739] = {.lex_state = 0},
  [9740] = {.lex_state = 0},
  [9741] = {.lex_state = 210},
  [9742] = {.lex_state = 0},
  [9743] = {.lex_state = 0},
  [9744] = {.lex_state = 210},
  [9745] = {.lex_state = 207},
  [9746] = {.lex_state = 0},
  [9747] = {.lex_state = 0},
  [9748] = {.lex_state = 0},
  [9749] = {.lex_state = 0},
  [9750] = {.lex_state = 0},
  [9751] = {.lex_state = 207},
  [9752] = {.lex_state = 0},
  [9753] = {.lex_state = 0},
  [9754] = {.lex_state = 0},
  [9755] = {.lex_state = 0},
  [9756] = {.lex_state = 207},
  [9757] = {.lex_state = 207},
  [9758] = {.lex_state = 356},
  [9759] = {.lex_state = 116},
  [9760] = {.lex_state = 210},
  [9761] = {.lex_state = 0},
  [9762] = {.lex_state = 0},
  [9763] = {.lex_state = 207},
  [9764] = {.lex_state = 207},
  [9765] = {.lex_state = 210},
  [9766] = {.lex_state = 210},
  [9767] = {.lex_state = 0},
  [9768] = {.lex_state = 0},
  [9769] = {.lex_state = 207},
  [9770] = {.lex_state = 0},
  [9771] = {.lex_state = 0},
  [9772] = {.lex_state = 0},
  [9773] = {.lex_state = 207},
  [9774] = {.lex_state = 0},
  [9775] = {.lex_state = 0},
  [9776] = {.lex_state = 207},
  [9777] = {.lex_state = 0},
  [9778] = {.lex_state = 0},
  [9779] = {.lex_state = 0},
  [9780] = {.lex_state = 0},
  [9781] = {.lex_state = 210},
  [9782] = {.lex_state = 0},
  [9783] = {.lex_state = 210},
  [9784] = {.lex_state = 0},
  [9785] = {.lex_state = 210},
  [9786] = {.lex_state = 0},
  [9787] = {.lex_state = 0},
  [9788] = {.lex_state = 0},
  [9789] = {.lex_state = 0},
  [9790] = {.lex_state = 0},
  [9791] = {.lex_state = 0},
  [9792] = {.lex_state = 183},
  [9793] = {.lex_state = 354},
  [9794] = {.lex_state = 0},
  [9795] = {.lex_state = 210},
  [9796] = {.lex_state = 0},
  [9797] = {.lex_state = 210},
  [9798] = {.lex_state = 0},
  [9799] = {.lex_state = 0},
  [9800] = {.lex_state = 0},
  [9801] = {.lex_state = 0},
  [9802] = {.lex_state = 0},
  [9803] = {.lex_state = 0},
  [9804] = {.lex_state = 0},
  [9805] = {.lex_state = 0},
  [9806] = {.lex_state = 210},
  [9807] = {.lex_state = 0},
  [9808] = {.lex_state = 0},
  [9809] = {.lex_state = 0},
  [9810] = {.lex_state = 210},
  [9811] = {.lex_state = 210},
  [9812] = {.lex_state = 356},
  [9813] = {.lex_state = 0},
  [9814] = {.lex_state = 0},
  [9815] = {.lex_state = 0},
  [9816] = {.lex_state = 0},
  [9817] = {.lex_state = 0},
  [9818] = {.lex_state = 0},
  [9819] = {.lex_state = 0},
  [9820] = {.lex_state = 0},
  [9821] = {.lex_state = 0},
  [9822] = {.lex_state = 0},
  [9823] = {.lex_state = 0},
  [9824] = {.lex_state = 0},
  [9825] = {.lex_state = 0},
  [9826] = {.lex_state = 210},
  [9827] = {.lex_state = 210},
  [9828] = {.lex_state = 0},
  [9829] = {.lex_state = 0},
  [9830] = {.lex_state = 0},
  [9831] = {.lex_state = 251},
  [9832] = {.lex_state = 0},
  [9833] = {.lex_state = 354},
  [9834] = {.lex_state = 0},
  [9835] = {.lex_state = 207},
  [9836] = {.lex_state = 0},
  [9837] = {.lex_state = 210},
  [9838] = {.lex_state = 183},
  [9839] = {.lex_state = 0},
  [9840] = {.lex_state = 0},
  [9841] = {.lex_state = 0},
  [9842] = {.lex_state = 0},
  [9843] = {.lex_state = 0},
  [9844] = {.lex_state = 0},
  [9845] = {.lex_state = 207},
  [9846] = {.lex_state = 0},
  [9847] = {.lex_state = 210},
  [9848] = {.lex_state = 0},
  [9849] = {.lex_state = 0},
  [9850] = {.lex_state = 0},
  [9851] = {.lex_state = 0},
  [9852] = {.lex_state = 0},
  [9853] = {.lex_state = 207},
  [9854] = {.lex_state = 207},
  [9855] = {.lex_state = 207},
  [9856] = {.lex_state = 207},
  [9857] = {.lex_state = 0},
  [9858] = {.lex_state = 207},
  [9859] = {.lex_state = 0},
  [9860] = {.lex_state = 116},
  [9861] = {.lex_state = 183},
  [9862] = {.lex_state = 0},
  [9863] = {.lex_state = 0},
  [9864] = {.lex_state = 0},
  [9865] = {.lex_state = 207},
  [9866] = {.lex_state = 0},
  [9867] = {.lex_state = 0},
  [9868] = {.lex_state = 207},
  [9869] = {.lex_state = 0},
  [9870] = {.lex_state = 207},
  [9871] = {.lex_state = 0},
  [9872] = {.lex_state = 0},
  [9873] = {.lex_state = 0},
  [9874] = {.lex_state = 0},
  [9875] = {.lex_state = 0},
  [9876] = {.lex_state = 0},
  [9877] = {.lex_state = 0},
  [9878] = {.lex_state = 0},
  [9879] = {.lex_state = 0},
  [9880] = {.lex_state = 0},
  [9881] = {.lex_state = 210},
  [9882] = {.lex_state = 207},
  [9883] = {.lex_state = 0},
  [9884] = {.lex_state = 0},
  [9885] = {.lex_state = 0},
  [9886] = {.lex_state = 0},
  [9887] = {.lex_state = 0},
  [9888] = {.lex_state = 0},
  [9889] = {.lex_state = 207},
  [9890] = {.lex_state = 210},
  [9891] = {.lex_state = 0},
  [9892] = {.lex_state = 0},
  [9893] = {.lex_state = 0},
  [9894] = {.lex_state = 0},
  [9895] = {.lex_state = 0},
  [9896] = {.lex_state = 0},
  [9897] = {.lex_state = 0},
  [9898] = {.lex_state = 0},
  [9899] = {.lex_state = 0},
  [9900] = {.lex_state = 0},
  [9901] = {.lex_state = 0},
  [9902] = {.lex_state = 207},
  [9903] = {.lex_state = 116},
  [9904] = {.lex_state = 0},
  [9905] = {.lex_state = 207},
  [9906] = {.lex_state = 0},
  [9907] = {.lex_state = 0},
  [9908] = {.lex_state = 207},
  [9909] = {.lex_state = 0},
  [9910] = {.lex_state = 210},
  [9911] = {.lex_state = 0},
  [9912] = {.lex_state = 0},
  [9913] = {.lex_state = 0},
  [9914] = {.lex_state = 0},
  [9915] = {.lex_state = 0},
  [9916] = {.lex_state = 116},
  [9917] = {.lex_state = 0},
  [9918] = {.lex_state = 210},
  [9919] = {.lex_state = 210},
  [9920] = {.lex_state = 0},
  [9921] = {.lex_state = 0},
  [9922] = {.lex_state = 187},
  [9923] = {.lex_state = 0},
  [9924] = {.lex_state = 0},
  [9925] = {.lex_state = 0},
  [9926] = {.lex_state = 0},
  [9927] = {.lex_state = 207},
  [9928] = {.lex_state = 207},
  [9929] = {.lex_state = 116},
  [9930] = {.lex_state = 0},
  [9931] = {.lex_state = 210},
  [9932] = {.lex_state = 210},
  [9933] = {.lex_state = 207},
  [9934] = {.lex_state = 0},
  [9935] = {.lex_state = 0},
  [9936] = {.lex_state = 0},
  [9937] = {.lex_state = 0},
  [9938] = {.lex_state = 0},
  [9939] = {.lex_state = 183},
  [9940] = {.lex_state = 0},
  [9941] = {.lex_state = 207},
  [9942] = {.lex_state = 0},
  [9943] = {.lex_state = 0},
  [9944] = {.lex_state = 0},
  [9945] = {.lex_state = 0},
  [9946] = {.lex_state = 0},
  [9947] = {.lex_state = 0},
  [9948] = {.lex_state = 207},
  [9949] = {.lex_state = 0},
  [9950] = {.lex_state = 0},
  [9951] = {.lex_state = 207},
  [9952] = {.lex_state = 0},
  [9953] = {.lex_state = 207},
  [9954] = {.lex_state = 116},
  [9955] = {.lex_state = 183},
  [9956] = {.lex_state = 207},
  [9957] = {.lex_state = 0},
  [9958] = {.lex_state = 0},
  [9959] = {.lex_state = 0},
  [9960] = {.lex_state = 0},
  [9961] = {.lex_state = 0},
  [9962] = {.lex_state = 0},
  [9963] = {.lex_state = 0},
  [9964] = {.lex_state = 0},
  [9965] = {.lex_state = 0},
  [9966] = {.lex_state = 0},
  [9967] = {.lex_state = 0},
  [9968] = {.lex_state = 207},
  [9969] = {.lex_state = 0},
  [9970] = {.lex_state = 0},
  [9971] = {.lex_state = 0},
  [9972] = {.lex_state = 207},
  [9973] = {.lex_state = 116},
  [9974] = {.lex_state = 0},
  [9975] = {.lex_state = 0},
  [9976] = {.lex_state = 0},
  [9977] = {.lex_state = 0},
  [9978] = {.lex_state = 207},
  [9979] = {.lex_state = 207},
  [9980] = {.lex_state = 0},
  [9981] = {.lex_state = 0},
  [9982] = {.lex_state = 0},
  [9983] = {.lex_state = 0},
  [9984] = {.lex_state = 0},
  [9985] = {.lex_state = 210},
  [9986] = {.lex_state = 0},
  [9987] = {.lex_state = 207},
  [9988] = {.lex_state = 116},
  [9989] = {.lex_state = 210},
  [9990] = {.lex_state = 0},
  [9991] = {.lex_state = 207},
  [9992] = {.lex_state = 0},
  [9993] = {.lex_state = 0},
  [9994] = {.lex_state = 0},
  [9995] = {.lex_state = 0},
  [9996] = {.lex_state = 0},
  [9997] = {.lex_state = 0},
  [9998] = {.lex_state = 0},
  [9999] = {.lex_state = 0},
  [10000] = {.lex_state = 0},
  [10001] = {.lex_state = 0},
  [10002] = {.lex_state = 0},
  [10003] = {.lex_state = 116},
  [10004] = {.lex_state = 0},
  [10005] = {.lex_state = 0},
  [10006] = {.lex_state = 0},
  [10007] = {.lex_state = 0},
  [10008] = {.lex_state = 210},
  [10009] = {.lex_state = 0},
  [10010] = {.lex_state = 116},
  [10011] = {.lex_state = 0},
  [10012] = {.lex_state = 207},
  [10013] = {.lex_state = 116},
  [10014] = {.lex_state = 0},
  [10015] = {.lex_state = 0},
  [10016] = {.lex_state = 210},
  [10017] = {.lex_state = 0},
  [10018] = {.lex_state = 0},
  [10019] = {.lex_state = 0},
  [10020] = {.lex_state = 207},
  [10021] = {.lex_state = 0},
  [10022] = {.lex_state = 0},
  [10023] = {.lex_state = 207},
  [10024] = {.lex_state = 207},
  [10025] = {.lex_state = 0},
  [10026] = {.lex_state = 210},
  [10027] = {.lex_state = 0},
  [10028] = {.lex_state = 0},
  [10029] = {.lex_state = 0},
  [10030] = {.lex_state = 0},
  [10031] = {.lex_state = 183},
  [10032] = {.lex_state = 0},
  [10033] = {.lex_state = 0},
  [10034] = {.lex_state = 207},
  [10035] = {.lex_state = 0},
  [10036] = {.lex_state = 0},
  [10037] = {.lex_state = 0},
  [10038] = {.lex_state = 210},
  [10039] = {.lex_state = 207},
  [10040] = {.lex_state = 0},
  [10041] = {.lex_state = 0},
  [10042] = {.lex_state = 0},
  [10043] = {.lex_state = 0},
  [10044] = {.lex_state = 0},
  [10045] = {.lex_state = 210},
  [10046] = {.lex_state = 0},
  [10047] = {.lex_state = 0},
  [10048] = {.lex_state = 0},
  [10049] = {.lex_state = 207},
  [10050] = {.lex_state = 0},
  [10051] = {.lex_state = 0},
  [10052] = {.lex_state = 0},
  [10053] = {.lex_state = 0},
  [10054] = {.lex_state = 0},
  [10055] = {.lex_state = 207},
  [10056] = {.lex_state = 0},
  [10057] = {.lex_state = 0},
  [10058] = {.lex_state = 0},
  [10059] = {.lex_state = 0},
  [10060] = {.lex_state = 207},
  [10061] = {.lex_state = 0},
  [10062] = {.lex_state = 0},
  [10063] = {.lex_state = 0},
  [10064] = {.lex_state = 207},
  [10065] = {.lex_state = 0},
  [10066] = {.lex_state = 0},
  [10067] = {.lex_state = 0},
  [10068] = {.lex_state = 0},
  [10069] = {.lex_state = 0},
  [10070] = {.lex_state = 0},
  [10071] = {.lex_state = 207},
  [10072] = {.lex_state = 207},
  [10073] = {.lex_state = 0},
  [10074] = {.lex_state = 0},
  [10075] = {.lex_state = 116},
  [10076] = {.lex_state = 0},
  [10077] = {.lex_state = 0},
  [10078] = {.lex_state = 0},
  [10079] = {.lex_state = 207},
  [10080] = {.lex_state = 207},
  [10081] = {.lex_state = 0},
  [10082] = {.lex_state = 0},
  [10083] = {.lex_state = 183},
  [10084] = {.lex_state = 207},
  [10085] = {.lex_state = 0},
  [10086] = {.lex_state = 0},
  [10087] = {.lex_state = 0},
  [10088] = {.lex_state = 0},
  [10089] = {.lex_state = 0},
  [10090] = {.lex_state = 207},
  [10091] = {.lex_state = 0},
  [10092] = {.lex_state = 0},
  [10093] = {.lex_state = 0},
  [10094] = {.lex_state = 0},
  [10095] = {.lex_state = 0},
  [10096] = {.lex_state = 0},
  [10097] = {.lex_state = 207},
  [10098] = {.lex_state = 207},
  [10099] = {.lex_state = 0},
  [10100] = {.lex_state = 0},
  [10101] = {.lex_state = 0},
  [10102] = {.lex_state = 0},
  [10103] = {.lex_state = 183},
  [10104] = {.lex_state = 207},
  [10105] = {.lex_state = 0},
  [10106] = {.lex_state = 0},
  [10107] = {.lex_state = 0},
  [10108] = {.lex_state = 0},
  [10109] = {.lex_state = 0},
  [10110] = {.lex_state = 0},
  [10111] = {.lex_state = 0},
  [10112] = {.lex_state = 0},
  [10113] = {.lex_state = 0},
  [10114] = {.lex_state = 0},
  [10115] = {.lex_state = 0},
  [10116] = {.lex_state = 210},
  [10117] = {.lex_state = 0},
  [10118] = {.lex_state = 0},
  [10119] = {.lex_state = 119},
  [10120] = {.lex_state = 207},
  [10121] = {.lex_state = 0},
  [10122] = {.lex_state = 0},
  [10123] = {.lex_state = 0},
  [10124] = {.lex_state = 0},
  [10125] = {.lex_state = 0},
  [10126] = {.lex_state = 0},
  [10127] = {.lex_state = 0},
  [10128] = {.lex_state = 0},
  [10129] = {.lex_state = 210},
  [10130] = {.lex_state = 210},
  [10131] = {.lex_state = 0},
  [10132] = {.lex_state = 0},
  [10133] = {.lex_state = 0},
  [10134] = {.lex_state = 0},
  [10135] = {.lex_state = 0},
  [10136] = {.lex_state = 0},
  [10137] = {.lex_state = 0},
  [10138] = {.lex_state = 0},
  [10139] = {.lex_state = 0},
  [10140] = {.lex_state = 0},
  [10141] = {.lex_state = 207},
  [10142] = {.lex_state = 0},
  [10143] = {.lex_state = 210},
  [10144] = {.lex_state = 210},
  [10145] = {.lex_state = 0},
  [10146] = {.lex_state = 0},
  [10147] = {.lex_state = 0},
  [10148] = {.lex_state = 0},
  [10149] = {.lex_state = 0},
  [10150] = {.lex_state = 207},
  [10151] = {.lex_state = 0},
  [10152] = {.lex_state = 356},
  [10153] = {.lex_state = 356},
  [10154] = {.lex_state = 0},
  [10155] = {.lex_state = 0},
  [10156] = {.lex_state = 207},
  [10157] = {.lex_state = 0},
  [10158] = {.lex_state = 0},
  [10159] = {.lex_state = 0},
  [10160] = {.lex_state = 183},
  [10161] = {.lex_state = 0},
  [10162] = {.lex_state = 0},
  [10163] = {.lex_state = 0},
  [10164] = {.lex_state = 0},
  [10165] = {.lex_state = 207},
  [10166] = {.lex_state = 0},
  [10167] = {.lex_state = 0},
  [10168] = {.lex_state = 0},
  [10169] = {.lex_state = 0},
  [10170] = {.lex_state = 0},
  [10171] = {.lex_state = 0},
  [10172] = {.lex_state = 0},
  [10173] = {.lex_state = 0},
  [10174] = {.lex_state = 0},
  [10175] = {.lex_state = 0},
  [10176] = {.lex_state = 183},
  [10177] = {.lex_state = 0},
  [10178] = {.lex_state = 207},
  [10179] = {.lex_state = 0},
  [10180] = {.lex_state = 187},
  [10181] = {.lex_state = 0},
  [10182] = {.lex_state = 0},
  [10183] = {.lex_state = 0},
  [10184] = {.lex_state = 207},
  [10185] = {.lex_state = 0},
  [10186] = {.lex_state = 0},
  [10187] = {.lex_state = 207},
  [10188] = {.lex_state = 0},
  [10189] = {.lex_state = 0},
  [10190] = {.lex_state = 0},
  [10191] = {.lex_state = 0},
  [10192] = {.lex_state = 210},
  [10193] = {.lex_state = 207},
  [10194] = {.lex_state = 0},
  [10195] = {.lex_state = 0},
  [10196] = {.lex_state = 0},
  [10197] = {.lex_state = 0},
  [10198] = {.lex_state = 0},
  [10199] = {.lex_state = 0},
  [10200] = {.lex_state = 0},
  [10201] = {.lex_state = 0},
  [10202] = {.lex_state = 0},
  [10203] = {.lex_state = 0},
  [10204] = {.lex_state = 183},
  [10205] = {.lex_state = 207},
  [10206] = {.lex_state = 207},
  [10207] = {.lex_state = 210},
  [10208] = {.lex_state = 210},
  [10209] = {.lex_state = 187},
  [10210] = {.lex_state = 0},
  [10211] = {.lex_state = 207},
  [10212] = {.lex_state = 0},
  [10213] = {.lex_state = 0},
  [10214] = {.lex_state = 0},
  [10215] = {.lex_state = 0},
  [10216] = {.lex_state = 210},
  [10217] = {.lex_state = 0},
  [10218] = {.lex_state = 0},
  [10219] = {.lex_state = 0},
  [10220] = {.lex_state = 0},
  [10221] = {.lex_state = 0},
  [10222] = {.lex_state = 0},
  [10223] = {.lex_state = 0},
  [10224] = {.lex_state = 0},
  [10225] = {.lex_state = 0},
  [10226] = {.lex_state = 0},
  [10227] = {.lex_state = 0},
  [10228] = {.lex_state = 0},
  [10229] = {.lex_state = 0},
  [10230] = {.lex_state = 0},
  [10231] = {.lex_state = 207},
  [10232] = {.lex_state = 0},
  [10233] = {.lex_state = 183},
  [10234] = {.lex_state = 0},
  [10235] = {.lex_state = 0},
  [10236] = {.lex_state = 0},
  [10237] = {.lex_state = 0},
  [10238] = {.lex_state = 0},
  [10239] = {.lex_state = 0},
  [10240] = {.lex_state = 207},
  [10241] = {.lex_state = 0},
  [10242] = {.lex_state = 207},
  [10243] = {.lex_state = 0},
  [10244] = {.lex_state = 207},
  [10245] = {.lex_state = 0},
  [10246] = {.lex_state = 0},
  [10247] = {.lex_state = 183},
  [10248] = {.lex_state = 210},
  [10249] = {.lex_state = 0},
  [10250] = {.lex_state = 0},
  [10251] = {.lex_state = 0},
  [10252] = {.lex_state = 0},
  [10253] = {.lex_state = 210},
  [10254] = {.lex_state = 0},
  [10255] = {.lex_state = 0},
  [10256] = {.lex_state = 0},
  [10257] = {.lex_state = 0},
  [10258] = {.lex_state = 0},
  [10259] = {.lex_state = 0},
  [10260] = {.lex_state = 207},
  [10261] = {.lex_state = 0},
  [10262] = {.lex_state = 0},
  [10263] = {.lex_state = 0},
  [10264] = {.lex_state = 207},
  [10265] = {.lex_state = 207},
  [10266] = {.lex_state = 0},
  [10267] = {.lex_state = 0},
  [10268] = {.lex_state = 0},
  [10269] = {.lex_state = 207},
  [10270] = {.lex_state = 0},
  [10271] = {.lex_state = 207},
  [10272] = {.lex_state = 0},
  [10273] = {.lex_state = 207},
  [10274] = {.lex_state = 0},
  [10275] = {.lex_state = 0},
  [10276] = {.lex_state = 0},
  [10277] = {.lex_state = 207},
  [10278] = {.lex_state = 210},
  [10279] = {.lex_state = 210},
  [10280] = {.lex_state = 207},
  [10281] = {.lex_state = 207},
  [10282] = {.lex_state = 0},
  [10283] = {.lex_state = 207},
  [10284] = {.lex_state = 0},
  [10285] = {.lex_state = 0},
  [10286] = {.lex_state = 0},
  [10287] = {.lex_state = 0},
  [10288] = {.lex_state = 0},
  [10289] = {.lex_state = 0},
  [10290] = {.lex_state = 0},
  [10291] = {.lex_state = 119},
  [10292] = {.lex_state = 183},
  [10293] = {.lex_state = 0},
  [10294] = {.lex_state = 207},
  [10295] = {.lex_state = 0},
  [10296] = {.lex_state = 0},
  [10297] = {.lex_state = 0},
  [10298] = {.lex_state = 0},
  [10299] = {.lex_state = 0},
  [10300] = {.lex_state = 0},
  [10301] = {.lex_state = 0},
  [10302] = {.lex_state = 0},
  [10303] = {.lex_state = 0},
  [10304] = {.lex_state = 0},
  [10305] = {.lex_state = 183},
  [10306] = {.lex_state = 0},
  [10307] = {.lex_state = 0},
  [10308] = {.lex_state = 207},
  [10309] = {.lex_state = 210},
  [10310] = {.lex_state = 0},
  [10311] = {.lex_state = 0},
  [10312] = {.lex_state = 119},
  [10313] = {.lex_state = 0},
  [10314] = {.lex_state = 0},
  [10315] = {.lex_state = 0},
  [10316] = {.lex_state = 0},
  [10317] = {.lex_state = 0},
  [10318] = {.lex_state = 0},
  [10319] = {.lex_state = 207},
  [10320] = {.lex_state = 354},
  [10321] = {.lex_state = 0},
  [10322] = {.lex_state = 207},
  [10323] = {.lex_state = 0},
  [10324] = {.lex_state = 0},
  [10325] = {.lex_state = 0},
  [10326] = {.lex_state = 0},
  [10327] = {.lex_state = 207},
  [10328] = {.lex_state = 0},
  [10329] = {.lex_state = 0},
  [10330] = {.lex_state = 0},
  [10331] = {.lex_state = 210},
  [10332] = {.lex_state = 356, .external_lex_state = 2},
  [10333] = {.lex_state = 0},
  [10334] = {.lex_state = 0},
  [10335] = {.lex_state = 0},
  [10336] = {.lex_state = 0},
  [10337] = {.lex_state = 0},
  [10338] = {.lex_state = 0},
  [10339] = {.lex_state = 356},
  [10340] = {.lex_state = 0},
  [10341] = {.lex_state = 0},
  [10342] = {.lex_state = 0},
  [10343] = {.lex_state = 0},
  [10344] = {.lex_state = 356},
  [10345] = {.lex_state = 0},
  [10346] = {.lex_state = 0},
  [10347] = {.lex_state = 0},
  [10348] = {.lex_state = 0},
  [10349] = {.lex_state = 356},
  [10350] = {.lex_state = 356},
  [10351] = {.lex_state = 0},
  [10352] = {.lex_state = 0},
  [10353] = {.lex_state = 0},
  [10354] = {.lex_state = 356},
  [10355] = {.lex_state = 0},
  [10356] = {.lex_state = 356},
  [10357] = {.lex_state = 356},
  [10358] = {.lex_state = 356},
  [10359] = {.lex_state = 0},
  [10360] = {.lex_state = 0},
  [10361] = {.lex_state = 118},
  [10362] = {.lex_state = 0},
  [10363] = {.lex_state = 118},
  [10364] = {.lex_state = 0},
  [10365] = {.lex_state = 356},
  [10366] = {.lex_state = 356},
  [10367] = {.lex_state = 0},
  [10368] = {.lex_state = 356},
  [10369] = {.lex_state = 0},
  [10370] = {.lex_state = 0},
  [10371] = {.lex_state = 0},
  [10372] = {.lex_state = 118},
  [10373] = {.lex_state = 0},
  [10374] = {.lex_state = 0},
  [10375] = {.lex_state = 207},
  [10376] = {.lex_state = 0},
  [10377] = {.lex_state = 0},
  [10378] = {.lex_state = 0},
  [10379] = {.lex_state = 207},
  [10380] = {.lex_state = 118},
  [10381] = {.lex_state = 356},
  [10382] = {.lex_state = 0},
  [10383] = {.lex_state = 0},
  [10384] = {.lex_state = 356},
  [10385] = {.lex_state = 0},
  [10386] = {.lex_state = 0},
  [10387] = {.lex_state = 0},
  [10388] = {.lex_state = 0},
  [10389] = {.lex_state = 356},
  [10390] = {.lex_state = 356},
  [10391] = {.lex_state = 0},
  [10392] = {.lex_state = 207},
  [10393] = {.lex_state = 0},
  [10394] = {.lex_state = 0},
  [10395] = {.lex_state = 0},
  [10396] = {.lex_state = 0},
  [10397] = {.lex_state = 356},
  [10398] = {.lex_state = 356},
  [10399] = {.lex_state = 0},
  [10400] = {.lex_state = 0},
  [10401] = {.lex_state = 207},
  [10402] = {.lex_state = 0},
  [10403] = {.lex_state = 0},
  [10404] = {.lex_state = 0},
  [10405] = {.lex_state = 0},
  [10406] = {.lex_state = 0},
  [10407] = {.lex_state = 0},
  [10408] = {.lex_state = 0},
  [10409] = {.lex_state = 0},
  [10410] = {.lex_state = 0},
  [10411] = {.lex_state = 0},
  [10412] = {.lex_state = 0},
  [10413] = {.lex_state = 0},
  [10414] = {.lex_state = 356},
  [10415] = {.lex_state = 356},
  [10416] = {.lex_state = 356},
  [10417] = {.lex_state = 0},
  [10418] = {.lex_state = 0},
  [10419] = {.lex_state = 207},
  [10420] = {.lex_state = 0},
  [10421] = {.lex_state = 356},
  [10422] = {.lex_state = 0},
  [10423] = {.lex_state = 356},
  [10424] = {.lex_state = 0},
  [10425] = {.lex_state = 356},
  [10426] = {.lex_state = 0},
  [10427] = {.lex_state = 356},
  [10428] = {.lex_state = 0},
  [10429] = {.lex_state = 0},
  [10430] = {.lex_state = 0},
  [10431] = {.lex_state = 0},
  [10432] = {.lex_state = 0},
  [10433] = {.lex_state = 0},
  [10434] = {.lex_state = 356},
  [10435] = {.lex_state = 0},
  [10436] = {.lex_state = 207},
  [10437] = {.lex_state = 0},
  [10438] = {.lex_state = 0},
  [10439] = {.lex_state = 0},
  [10440] = {.lex_state = 0},
  [10441] = {.lex_state = 0},
  [10442] = {.lex_state = 0},
  [10443] = {.lex_state = 0},
  [10444] = {.lex_state = 0},
  [10445] = {.lex_state = 356},
  [10446] = {.lex_state = 0},
  [10447] = {.lex_state = 0},
  [10448] = {.lex_state = 356},
  [10449] = {.lex_state = 0},
  [10450] = {.lex_state = 207},
  [10451] = {.lex_state = 0},
  [10452] = {.lex_state = 0},
  [10453] = {.lex_state = 0},
  [10454] = {.lex_state = 0},
  [10455] = {.lex_state = 0},
  [10456] = {.lex_state = 0},
  [10457] = {.lex_state = 0},
  [10458] = {.lex_state = 0},
  [10459] = {.lex_state = 0},
  [10460] = {.lex_state = 0},
  [10461] = {.lex_state = 0},
  [10462] = {.lex_state = 0},
  [10463] = {.lex_state = 118},
  [10464] = {.lex_state = 0},
  [10465] = {.lex_state = 0},
  [10466] = {.lex_state = 0},
  [10467] = {.lex_state = 0},
  [10468] = {.lex_state = 0},
  [10469] = {.lex_state = 118},
  [10470] = {.lex_state = 0},
  [10471] = {.lex_state = 207},
  [10472] = {.lex_state = 356},
  [10473] = {.lex_state = 207},
  [10474] = {.lex_state = 207},
  [10475] = {.lex_state = 356},
  [10476] = {.lex_state = 207},
  [10477] = {.lex_state = 0},
  [10478] = {.lex_state = 0},
  [10479] = {.lex_state = 0},
  [10480] = {.lex_state = 0},
  [10481] = {.lex_state = 0},
  [10482] = {.lex_state = 0},
  [10483] = {.lex_state = 0},
  [10484] = {.lex_state = 0},
  [10485] = {.lex_state = 207},
  [10486] = {.lex_state = 0},
  [10487] = {.lex_state = 356},
  [10488] = {.lex_state = 356},
  [10489] = {.lex_state = 118},
  [10490] = {.lex_state = 0},
  [10491] = {.lex_state = 356},
  [10492] = {.lex_state = 0},
  [10493] = {.lex_state = 0},
  [10494] = {.lex_state = 356},
  [10495] = {.lex_state = 0},
  [10496] = {.lex_state = 0},
  [10497] = {.lex_state = 207},
  [10498] = {.lex_state = 207},
  [10499] = {.lex_state = 0},
  [10500] = {.lex_state = 0},
  [10501] = {.lex_state = 0},
  [10502] = {.lex_state = 207},
  [10503] = {.lex_state = 207},
  [10504] = {.lex_state = 0},
  [10505] = {.lex_state = 356},
  [10506] = {.lex_state = 0},
  [10507] = {.lex_state = 0},
  [10508] = {.lex_state = 0},
  [10509] = {.lex_state = 0},
  [10510] = {.lex_state = 0},
  [10511] = {.lex_state = 0},
  [10512] = {.lex_state = 0},
  [10513] = {.lex_state = 0},
  [10514] = {.lex_state = 356},
  [10515] = {.lex_state = 183},
  [10516] = {.lex_state = 0},
  [10517] = {.lex_state = 0},
  [10518] = {.lex_state = 0},
  [10519] = {.lex_state = 0},
  [10520] = {.lex_state = 0},
  [10521] = {.lex_state = 183},
  [10522] = {.lex_state = 0},
  [10523] = {.lex_state = 0},
  [10524] = {.lex_state = 356},
  [10525] = {.lex_state = 356},
  [10526] = {.lex_state = 207},
  [10527] = {.lex_state = 356},
  [10528] = {.lex_state = 207},
  [10529] = {.lex_state = 0},
  [10530] = {.lex_state = 356},
  [10531] = {.lex_state = 0},
  [10532] = {.lex_state = 0},
  [10533] = {.lex_state = 356},
  [10534] = {.lex_state = 0},
  [10535] = {.lex_state = 356},
  [10536] = {.lex_state = 0},
  [10537] = {.lex_state = 0},
  [10538] = {.lex_state = 0},
  [10539] = {.lex_state = 356},
  [10540] = {.lex_state = 207},
  [10541] = {.lex_state = 356},
  [10542] = {.lex_state = 0},
  [10543] = {.lex_state = 118},
  [10544] = {.lex_state = 0},
  [10545] = {.lex_state = 0},
  [10546] = {.lex_state = 0},
  [10547] = {.lex_state = 0},
  [10548] = {.lex_state = 356},
  [10549] = {.lex_state = 0},
  [10550] = {.lex_state = 0},
  [10551] = {.lex_state = 0},
  [10552] = {.lex_state = 0},
  [10553] = {.lex_state = 356},
  [10554] = {.lex_state = 0},
  [10555] = {.lex_state = 0},
  [10556] = {.lex_state = 0},
  [10557] = {.lex_state = 0},
  [10558] = {.lex_state = 0},
  [10559] = {.lex_state = 0},
  [10560] = {.lex_state = 0},
  [10561] = {.lex_state = 0},
  [10562] = {.lex_state = 207},
  [10563] = {.lex_state = 0},
  [10564] = {.lex_state = 0},
  [10565] = {.lex_state = 0},
  [10566] = {.lex_state = 0},
  [10567] = {.lex_state = 0},
  [10568] = {.lex_state = 0},
  [10569] = {.lex_state = 207},
  [10570] = {.lex_state = 0},
  [10571] = {.lex_state = 0},
  [10572] = {.lex_state = 0},
  [10573] = {.lex_state = 0},
  [10574] = {.lex_state = 0},
  [10575] = {.lex_state = 0},
  [10576] = {.lex_state = 183},
  [10577] = {.lex_state = 0},
  [10578] = {.lex_state = 356},
  [10579] = {.lex_state = 0},
  [10580] = {.lex_state = 207},
  [10581] = {.lex_state = 356},
  [10582] = {.lex_state = 0},
  [10583] = {.lex_state = 0},
  [10584] = {.lex_state = 0},
  [10585] = {.lex_state = 0},
  [10586] = {.lex_state = 0},
  [10587] = {.lex_state = 0},
  [10588] = {.lex_state = 356},
  [10589] = {.lex_state = 356},
  [10590] = {.lex_state = 0},
  [10591] = {.lex_state = 0},
  [10592] = {.lex_state = 356},
  [10593] = {.lex_state = 0},
  [10594] = {.lex_state = 356},
  [10595] = {.lex_state = 0},
  [10596] = {.lex_state = 356},
  [10597] = {.lex_state = 0},
  [10598] = {.lex_state = 0},
  [10599] = {.lex_state = 0},
  [10600] = {.lex_state = 207},
  [10601] = {.lex_state = 0},
  [10602] = {.lex_state = 0},
  [10603] = {.lex_state = 0},
  [10604] = {.lex_state = 207},
  [10605] = {.lex_state = 118},
  [10606] = {.lex_state = 356},
  [10607] = {.lex_state = 0},
  [10608] = {.lex_state = 0},
  [10609] = {.lex_state = 0},
  [10610] = {.lex_state = 0},
  [10611] = {.lex_state = 118},
  [10612] = {.lex_state = 0},
  [10613] = {.lex_state = 207},
  [10614] = {.lex_state = 118},
  [10615] = {.lex_state = 0},
  [10616] = {.lex_state = 356},
  [10617] = {.lex_state = 0},
  [10618] = {.lex_state = 356},
  [10619] = {.lex_state = 356},
  [10620] = {.lex_state = 0},
  [10621] = {.lex_state = 0},
  [10622] = {.lex_state = 0},
  [10623] = {.lex_state = 118},
  [10624] = {.lex_state = 356},
  [10625] = {.lex_state = 0},
  [10626] = {.lex_state = 356},
  [10627] = {.lex_state = 0},
  [10628] = {.lex_state = 0},
  [10629] = {.lex_state = 0},
  [10630] = {.lex_state = 0},
  [10631] = {.lex_state = 0},
  [10632] = {.lex_state = 118},
  [10633] = {.lex_state = 0},
  [10634] = {.lex_state = 0},
  [10635] = {.lex_state = 0},
  [10636] = {.lex_state = 356},
  [10637] = {.lex_state = 0},
  [10638] = {.lex_state = 0},
  [10639] = {.lex_state = 356},
  [10640] = {.lex_state = 0},
  [10641] = {.lex_state = 356},
  [10642] = {.lex_state = 0},
  [10643] = {.lex_state = 356},
  [10644] = {.lex_state = 356},
  [10645] = {.lex_state = 0},
  [10646] = {.lex_state = 356},
  [10647] = {.lex_state = 0},
  [10648] = {.lex_state = 356},
  [10649] = {.lex_state = 0},
  [10650] = {.lex_state = 356, .external_lex_state = 2},
  [10651] = {.lex_state = 356, .external_lex_state = 2},
  [10652] = {.lex_state = 0},
  [10653] = {.lex_state = 0},
  [10654] = {.lex_state = 0},
  [10655] = {.lex_state = 356},
  [10656] = {.lex_state = 0},
  [10657] = {.lex_state = 0},
  [10658] = {.lex_state = 356},
  [10659] = {.lex_state = 0},
  [10660] = {.lex_state = 0},
  [10661] = {.lex_state = 0},
  [10662] = {.lex_state = 356},
  [10663] = {.lex_state = 356},
  [10664] = {.lex_state = 0},
  [10665] = {.lex_state = 0},
  [10666] = {.lex_state = 207},
  [10667] = {.lex_state = 0},
  [10668] = {.lex_state = 207},
  [10669] = {.lex_state = 0},
  [10670] = {.lex_state = 207},
  [10671] = {.lex_state = 356},
  [10672] = {.lex_state = 356},
  [10673] = {.lex_state = 0},
  [10674] = {.lex_state = 356},
  [10675] = {.lex_state = 207},
  [10676] = {.lex_state = 0},
  [10677] = {.lex_state = 0},
  [10678] = {.lex_state = 118},
  [10679] = {.lex_state = 118},
  [10680] = {.lex_state = 356},
  [10681] = {.lex_state = 0},
  [10682] = {.lex_state = 0},
  [10683] = {.lex_state = 0},
  [10684] = {.lex_state = 0},
  [10685] = {.lex_state = 207},
  [10686] = {.lex_state = 0},
  [10687] = {.lex_state = 0},
  [10688] = {.lex_state = 356},
  [10689] = {.lex_state = 0},
  [10690] = {.lex_state = 0},
  [10691] = {.lex_state = 0},
  [10692] = {.lex_state = 0},
  [10693] = {.lex_state = 356},
  [10694] = {.lex_state = 0},
  [10695] = {.lex_state = 0},
  [10696] = {.lex_state = 356},
  [10697] = {.lex_state = 207},
  [10698] = {.lex_state = 207},
  [10699] = {.lex_state = 0},
  [10700] = {.lex_state = 0},
  [10701] = {.lex_state = 0},
  [10702] = {.lex_state = 0},
  [10703] = {.lex_state = 356},
  [10704] = {.lex_state = 0},
  [10705] = {.lex_state = 356},
  [10706] = {.lex_state = 183},
  [10707] = {.lex_state = 207},
  [10708] = {.lex_state = 356},
  [10709] = {.lex_state = 207},
  [10710] = {.lex_state = 356},
  [10711] = {.lex_state = 0},
  [10712] = {.lex_state = 356},
  [10713] = {.lex_state = 0},
  [10714] = {.lex_state = 0},
  [10715] = {.lex_state = 0},
  [10716] = {.lex_state = 0},
  [10717] = {.lex_state = 0},
  [10718] = {.lex_state = 0},
  [10719] = {.lex_state = 356},
  [10720] = {.lex_state = 0},
  [10721] = {.lex_state = 0},
  [10722] = {.lex_state = 0},
  [10723] = {.lex_state = 356},
  [10724] = {.lex_state = 0},
  [10725] = {.lex_state = 0},
  [10726] = {.lex_state = 0},
  [10727] = {.lex_state = 0},
  [10728] = {.lex_state = 0},
  [10729] = {.lex_state = 0},
  [10730] = {.lex_state = 0},
  [10731] = {.lex_state = 0},
  [10732] = {.lex_state = 0},
  [10733] = {.lex_state = 0},
  [10734] = {.lex_state = 356},
  [10735] = {.lex_state = 0},
  [10736] = {.lex_state = 356},
  [10737] = {.lex_state = 118},
  [10738] = {.lex_state = 0},
  [10739] = {.lex_state = 118},
  [10740] = {.lex_state = 0},
  [10741] = {.lex_state = 356},
  [10742] = {.lex_state = 0},
  [10743] = {.lex_state = 0},
  [10744] = {.lex_state = 0},
  [10745] = {.lex_state = 0},
  [10746] = {.lex_state = 356, .external_lex_state = 2},
  [10747] = {.lex_state = 356},
  [10748] = {.lex_state = 0},
  [10749] = {.lex_state = 0},
  [10750] = {.lex_state = 356},
  [10751] = {.lex_state = 356},
  [10752] = {.lex_state = 0},
  [10753] = {.lex_state = 0},
  [10754] = {.lex_state = 0},
  [10755] = {.lex_state = 356},
  [10756] = {.lex_state = 356, .external_lex_state = 2},
  [10757] = {.lex_state = 0},
  [10758] = {.lex_state = 0},
  [10759] = {.lex_state = 356, .external_lex_state = 2},
  [10760] = {.lex_state = 0},
  [10761] = {.lex_state = 356},
  [10762] = {.lex_state = 356},
  [10763] = {.lex_state = 356, .external_lex_state = 2},
  [10764] = {.lex_state = 0},
  [10765] = {.lex_state = 356, .external_lex_state = 2},
  [10766] = {.lex_state = 356, .external_lex_state = 2},
  [10767] = {.lex_state = 356, .external_lex_state = 2},
  [10768] = {.lex_state = 356, .external_lex_state = 2},
  [10769] = {.lex_state = 356, .external_lex_state = 2},
  [10770] = {.lex_state = 356, .external_lex_state = 2},
  [10771] = {.lex_state = 356, .external_lex_state = 2},
  [10772] = {.lex_state = 0},
  [10773] = {.lex_state = 356, .external_lex_state = 2},
  [10774] = {.lex_state = 356, .external_lex_state = 2},
  [10775] = {.lex_state = 356, .external_lex_state = 2},
  [10776] = {.lex_state = 0},
  [10777] = {.lex_state = 0},
  [10778] = {.lex_state = 0},
  [10779] = {.lex_state = 0},
  [10780] = {.lex_state = 0},
  [10781] = {.lex_state = 183},
  [10782] = {.lex_state = 0},
  [10783] = {.lex_state = 0},
  [10784] = {.lex_state = 0},
  [10785] = {.lex_state = 0},
  [10786] = {.lex_state = 356},
  [10787] = {.lex_state = 0, .external_lex_state = 2},
  [10788] = {.lex_state = 0},
  [10789] = {.lex_state = 185},
  [10790] = {.lex_state = 0},
  [10791] = {.lex_state = 0},
  [10792] = {.lex_state = 0},
  [10793] = {.lex_state = 0},
  [10794] = {.lex_state = 0},
  [10795] = {.lex_state = 207},
  [10796] = {.lex_state = 0},
  [10797] = {.lex_state = 0},
  [10798] = {.lex_state = 0},
  [10799] = {.lex_state = 0},
  [10800] = {.lex_state = 0},
  [10801] = {.lex_state = 0, .external_lex_state = 2},
  [10802] = {.lex_state = 0},
  [10803] = {.lex_state = 0},
  [10804] = {.lex_state = 0},
  [10805] = {.lex_state = 0},
  [10806] = {.lex_state = 0},
  [10807] = {.lex_state = 0},
  [10808] = {.lex_state = 119},
  [10809] = {.lex_state = 0},
  [10810] = {.lex_state = 0},
  [10811] = {.lex_state = 0, .external_lex_state = 2},
  [10812] = {.lex_state = 207},
  [10813] = {.lex_state = 0},
  [10814] = {.lex_state = 0},
  [10815] = {.lex_state = 0},
  [10816] = {.lex_state = 0},
  [10817] = {.lex_state = 0},
  [10818] = {.lex_state = 0},
  [10819] = {.lex_state = 119},
  [10820] = {.lex_state = 0, .external_lex_state = 2},
  [10821] = {.lex_state = 210},
  [10822] = {.lex_state = 185},
  [10823] = {.lex_state = 0},
  [10824] = {.lex_state = 0},
  [10825] = {.lex_state = 0},
  [10826] = {.lex_state = 0},
  [10827] = {.lex_state = 185},
  [10828] = {.lex_state = 207},
  [10829] = {.lex_state = 0, .external_lex_state = 2},
  [10830] = {.lex_state = 207},
  [10831] = {.lex_state = 0},
  [10832] = {.lex_state = 185},
  [10833] = {.lex_state = 0},
  [10834] = {.lex_state = 0},
  [10835] = {.lex_state = 0},
  [10836] = {.lex_state = 356},
  [10837] = {.lex_state = 0},
  [10838] = {.lex_state = 0, .external_lex_state = 2},
  [10839] = {.lex_state = 0},
  [10840] = {.lex_state = 0},
  [10841] = {.lex_state = 0},
  [10842] = {.lex_state = 0},
  [10843] = {.lex_state = 0},
  [10844] = {.lex_state = 0},
  [10845] = {.lex_state = 0},
  [10846] = {.lex_state = 0},
  [10847] = {.lex_state = 0, .external_lex_state = 2},
  [10848] = {.lex_state = 356},
  [10849] = {.lex_state = 185},
  [10850] = {.lex_state = 119},
  [10851] = {.lex_state = 0},
  [10852] = {.lex_state = 0},
  [10853] = {.lex_state = 0},
  [10854] = {.lex_state = 0},
  [10855] = {.lex_state = 0},
  [10856] = {.lex_state = 0},
  [10857] = {.lex_state = 0},
  [10858] = {.lex_state = 0},
  [10859] = {.lex_state = 0},
  [10860] = {.lex_state = 0},
  [10861] = {.lex_state = 356},
  [10862] = {.lex_state = 0},
  [10863] = {.lex_state = 0},
  [10864] = {.lex_state = 0},
  [10865] = {.lex_state = 0},
  [10866] = {.lex_state = 0},
  [10867] = {.lex_state = 0},
  [10868] = {.lex_state = 0},
  [10869] = {.lex_state = 0},
  [10870] = {.lex_state = 0},
  [10871] = {.lex_state = 0},
  [10872] = {.lex_state = 0},
  [10873] = {.lex_state = 0},
  [10874] = {.lex_state = 356},
  [10875] = {.lex_state = 0},
  [10876] = {.lex_state = 0},
  [10877] = {.lex_state = 0},
  [10878] = {.lex_state = 183},
  [10879] = {.lex_state = 0},
  [10880] = {.lex_state = 207},
  [10881] = {.lex_state = 0},
  [10882] = {.lex_state = 0},
  [10883] = {.lex_state = 0},
  [10884] = {.lex_state = 0},
  [10885] = {.lex_state = 0},
  [10886] = {.lex_state = 0},
  [10887] = {.lex_state = 0},
  [10888] = {.lex_state = 0},
  [10889] = {.lex_state = 0},
  [10890] = {.lex_state = 0},
  [10891] = {.lex_state = 0},
  [10892] = {.lex_state = 0},
  [10893] = {.lex_state = 0},
  [10894] = {.lex_state = 0},
  [10895] = {.lex_state = 0},
  [10896] = {.lex_state = 185},
  [10897] = {.lex_state = 0},
  [10898] = {.lex_state = 356},
  [10899] = {.lex_state = 0},
  [10900] = {.lex_state = 356},
  [10901] = {.lex_state = 356},
  [10902] = {.lex_state = 356},
  [10903] = {.lex_state = 183},
  [10904] = {.lex_state = 0},
  [10905] = {.lex_state = 356},
  [10906] = {.lex_state = 0},
  [10907] = {.lex_state = 356},
  [10908] = {.lex_state = 119},
  [10909] = {.lex_state = 356},
  [10910] = {.lex_state = 185},
  [10911] = {.lex_state = 0},
  [10912] = {.lex_state = 356},
  [10913] = {.lex_state = 0},
  [10914] = {.lex_state = 0},
  [10915] = {.lex_state = 0, .external_lex_state = 2},
  [10916] = {.lex_state = 356},
  [10917] = {.lex_state = 0},
  [10918] = {.lex_state = 207},
  [10919] = {.lex_state = 207},
  [10920] = {.lex_state = 207},
  [10921] = {.lex_state = 356},
  [10922] = {.lex_state = 207},
  [10923] = {.lex_state = 0},
  [10924] = {.lex_state = 356},
  [10925] = {.lex_state = 0},
  [10926] = {.lex_state = 0},
  [10927] = {.lex_state = 0},
  [10928] = {.lex_state = 0},
  [10929] = {.lex_state = 0},
  [10930] = {.lex_state = 207},
  [10931] = {.lex_state = 356},
  [10932] = {.lex_state = 0, .external_lex_state = 3},
  [10933] = {.lex_state = 185},
  [10934] = {.lex_state = 185},
  [10935] = {.lex_state = 0},
  [10936] = {.lex_state = 356},
  [10937] = {.lex_state = 356},
  [10938] = {.lex_state = 0},
  [10939] = {.lex_state = 185},
  [10940] = {.lex_state = 207},
  [10941] = {.lex_state = 0},
  [10942] = {.lex_state = 0},
  [10943] = {.lex_state = 207},
  [10944] = {.lex_state = 207},
  [10945] = {.lex_state = 0},
  [10946] = {.lex_state = 185},
  [10947] = {.lex_state = 356},
  [10948] = {.lex_state = 0},
  [10949] = {.lex_state = 0},
  [10950] = {.lex_state = 0},
  [10951] = {.lex_state = 207},
  [10952] = {.lex_state = 0},
  [10953] = {.lex_state = 0},
  [10954] = {.lex_state = 0},
  [10955] = {.lex_state = 207},
  [10956] = {.lex_state = 0},
  [10957] = {.lex_state = 0},
  [10958] = {.lex_state = 0},
  [10959] = {.lex_state = 119},
  [10960] = {.lex_state = 0},
  [10961] = {.lex_state = 0},
  [10962] = {.lex_state = 0},
  [10963] = {.lex_state = 210},
  [10964] = {.lex_state = 207},
  [10965] = {.lex_state = 119},
  [10966] = {.lex_state = 0},
  [10967] = {.lex_state = 356},
  [10968] = {.lex_state = 207},
  [10969] = {.lex_state = 0},
  [10970] = {.lex_state = 0},
  [10971] = {.lex_state = 207},
  [10972] = {.lex_state = 119},
  [10973] = {.lex_state = 210},
  [10974] = {.lex_state = 0},
  [10975] = {.lex_state = 0},
  [10976] = {.lex_state = 185},
  [10977] = {.lex_state = 0},
  [10978] = {.lex_state = 207},
  [10979] = {.lex_state = 0},
  [10980] = {.lex_state = 207},
  [10981] = {.lex_state = 207},
  [10982] = {.lex_state = 0},
  [10983] = {.lex_state = 185},
  [10984] = {.lex_state = 207},
  [10985] = {.lex_state = 0},
  [10986] = {.lex_state = 119},
  [10987] = {.lex_state = 0},
  [10988] = {.lex_state = 210},
  [10989] = {.lex_state = 185},
  [10990] = {.lex_state = 0},
  [10991] = {.lex_state = 0, .external_lex_state = 3},
  [10992] = {.lex_state = 0},
  [10993] = {.lex_state = 207},
  [10994] = {.lex_state = 0},
  [10995] = {.lex_state = 0},
  [10996] = {.lex_state = 207},
  [10997] = {.lex_state = 207},
  [10998] = {.lex_state = 207},
  [10999] = {.lex_state = 207},
  [11000] = {.lex_state = 0},
  [11001] = {.lex_state = 119},
  [11002] = {.lex_state = 0},
  [11003] = {.lex_state = 119},
  [11004] = {.lex_state = 0},
  [11005] = {.lex_state = 0},
  [11006] = {.lex_state = 0},
  [11007] = {.lex_state = 0},
  [11008] = {.lex_state = 207},
  [11009] = {.lex_state = 0},
  [11010] = {.lex_state = 0},
  [11011] = {.lex_state = 356},
  [11012] = {.lex_state = 0},
  [11013] = {.lex_state = 0},
  [11014] = {.lex_state = 0},
  [11015] = {.lex_state = 0},
  [11016] = {.lex_state = 207},
  [11017] = {.lex_state = 0},
  [11018] = {.lex_state = 0},
  [11019] = {.lex_state = 0},
  [11020] = {.lex_state = 0},
  [11021] = {.lex_state = 0},
  [11022] = {.lex_state = 0},
  [11023] = {.lex_state = 0},
  [11024] = {.lex_state = 210},
  [11025] = {.lex_state = 207},
  [11026] = {.lex_state = 0},
  [11027] = {.lex_state = 0},
  [11028] = {.lex_state = 207},
  [11029] = {.lex_state = 119},
  [11030] = {.lex_state = 0},
  [11031] = {.lex_state = 119},
  [11032] = {.lex_state = 0},
  [11033] = {.lex_state = 0},
  [11034] = {.lex_state = 0},
  [11035] = {.lex_state = 0},
  [11036] = {.lex_state = 207},
  [11037] = {.lex_state = 207},
  [11038] = {.lex_state = 0},
  [11039] = {.lex_state = 0},
  [11040] = {.lex_state = 0},
  [11041] = {.lex_state = 0},
  [11042] = {.lex_state = 0},
  [11043] = {.lex_state = 0},
  [11044] = {.lex_state = 0},
  [11045] = {.lex_state = 210},
  [11046] = {.lex_state = 0},
  [11047] = {.lex_state = 207},
  [11048] = {.lex_state = 356},
  [11049] = {.lex_state = 0},
  [11050] = {.lex_state = 0},
  [11051] = {.lex_state = 0},
  [11052] = {.lex_state = 0},
  [11053] = {.lex_state = 0},
  [11054] = {.lex_state = 0},
  [11055] = {.lex_state = 207},
  [11056] = {.lex_state = 0},
  [11057] = {.lex_state = 0},
  [11058] = {.lex_state = 0},
  [11059] = {.lex_state = 356},
  [11060] = {.lex_state = 207},
  [11061] = {.lex_state = 0},
  [11062] = {.lex_state = 0, .external_lex_state = 2},
  [11063] = {.lex_state = 0},
  [11064] = {.lex_state = 356},
  [11065] = {.lex_state = 0},
  [11066] = {.lex_state = 0},
  [11067] = {.lex_state = 0},
  [11068] = {.lex_state = 0},
  [11069] = {.lex_state = 0},
  [11070] = {.lex_state = 356},
  [11071] = {.lex_state = 356},
  [11072] = {.lex_state = 207},
  [11073] = {.lex_state = 0},
  [11074] = {.lex_state = 207},
  [11075] = {.lex_state = 210},
  [11076] = {.lex_state = 185},
  [11077] = {.lex_state = 0},
  [11078] = {.lex_state = 0},
  [11079] = {.lex_state = 0},
  [11080] = {.lex_state = 0},
  [11081] = {.lex_state = 0},
  [11082] = {.lex_state = 185},
  [11083] = {.lex_state = 0},
  [11084] = {.lex_state = 119},
  [11085] = {.lex_state = 0},
  [11086] = {.lex_state = 356},
  [11087] = {.lex_state = 0},
  [11088] = {.lex_state = 0},
  [11089] = {.lex_state = 0},
  [11090] = {.lex_state = 0},
  [11091] = {.lex_state = 0},
  [11092] = {.lex_state = 0},
  [11093] = {.lex_state = 0},
  [11094] = {.lex_state = 185},
  [11095] = {.lex_state = 0},
  [11096] = {.lex_state = 207},
  [11097] = {.lex_state = 0},
  [11098] = {.lex_state = 0},
  [11099] = {.lex_state = 0},
  [11100] = {.lex_state = 119},
  [11101] = {.lex_state = 0},
  [11102] = {.lex_state = 0},
  [11103] = {.lex_state = 210},
  [11104] = {.lex_state = 0},
  [11105] = {.lex_state = 0},
  [11106] = {.lex_state = 0},
  [11107] = {.lex_state = 119},
  [11108] = {.lex_state = 0},
  [11109] = {.lex_state = 207},
  [11110] = {.lex_state = 0},
  [11111] = {.lex_state = 207},
  [11112] = {.lex_state = 0},
  [11113] = {.lex_state = 0},
  [11114] = {.lex_state = 119},
  [11115] = {.lex_state = 0},
  [11116] = {.lex_state = 0},
  [11117] = {.lex_state = 119},
  [11118] = {.lex_state = 0},
  [11119] = {.lex_state = 0},
  [11120] = {.lex_state = 0},
  [11121] = {.lex_state = 0},
  [11122] = {.lex_state = 0},
  [11123] = {.lex_state = 0},
  [11124] = {.lex_state = 0},
  [11125] = {.lex_state = 0},
  [11126] = {.lex_state = 0},
  [11127] = {.lex_state = 0},
  [11128] = {.lex_state = 0},
  [11129] = {.lex_state = 0},
  [11130] = {.lex_state = 207},
  [11131] = {.lex_state = 185},
  [11132] = {.lex_state = 186},
  [11133] = {.lex_state = 0},
  [11134] = {.lex_state = 0},
  [11135] = {.lex_state = 356},
  [11136] = {.lex_state = 0},
  [11137] = {.lex_state = 207},
  [11138] = {.lex_state = 207},
  [11139] = {.lex_state = 0},
  [11140] = {.lex_state = 207},
  [11141] = {.lex_state = 185},
  [11142] = {.lex_state = 0},
  [11143] = {.lex_state = 356},
  [11144] = {.lex_state = 0},
  [11145] = {.lex_state = 183},
  [11146] = {.lex_state = 0},
  [11147] = {.lex_state = 187},
  [11148] = {.lex_state = 210},
  [11149] = {.lex_state = 0},
  [11150] = {.lex_state = 207},
  [11151] = {.lex_state = 0},
  [11152] = {.lex_state = 0},
  [11153] = {.lex_state = 185},
  [11154] = {.lex_state = 0},
  [11155] = {.lex_state = 0},
  [11156] = {.lex_state = 207},
  [11157] = {.lex_state = 0},
  [11158] = {.lex_state = 0},
  [11159] = {.lex_state = 207},
  [11160] = {.lex_state = 207},
  [11161] = {.lex_state = 0},
  [11162] = {.lex_state = 0},
  [11163] = {.lex_state = 0},
  [11164] = {.lex_state = 0},
  [11165] = {.lex_state = 0},
  [11166] = {.lex_state = 0},
  [11167] = {.lex_state = 0},
  [11168] = {.lex_state = 0},
  [11169] = {.lex_state = 0},
  [11170] = {.lex_state = 207},
  [11171] = {.lex_state = 0},
  [11172] = {.lex_state = 185},
  [11173] = {.lex_state = 0},
  [11174] = {.lex_state = 0},
  [11175] = {.lex_state = 0},
  [11176] = {.lex_state = 207},
  [11177] = {.lex_state = 0},
  [11178] = {.lex_state = 0},
  [11179] = {.lex_state = 0},
  [11180] = {.lex_state = 0},
  [11181] = {.lex_state = 0},
  [11182] = {.lex_state = 0},
  [11183] = {.lex_state = 0},
  [11184] = {.lex_state = 0},
  [11185] = {.lex_state = 210},
  [11186] = {.lex_state = 207},
  [11187] = {.lex_state = 207},
  [11188] = {.lex_state = 0},
  [11189] = {.lex_state = 207},
  [11190] = {.lex_state = 210},
  [11191] = {.lex_state = 356},
  [11192] = {.lex_state = 0},
  [11193] = {.lex_state = 0},
  [11194] = {.lex_state = 210},
  [11195] = {.lex_state = 0},
  [11196] = {.lex_state = 207},
  [11197] = {.lex_state = 0},
  [11198] = {.lex_state = 185},
  [11199] = {.lex_state = 0},
  [11200] = {.lex_state = 0},
  [11201] = {.lex_state = 0},
  [11202] = {.lex_state = 207},
  [11203] = {.lex_state = 207},
  [11204] = {.lex_state = 0},
  [11205] = {.lex_state = 207},
  [11206] = {.lex_state = 0},
  [11207] = {.lex_state = 0, .external_lex_state = 2},
  [11208] = {.lex_state = 119},
  [11209] = {.lex_state = 0},
  [11210] = {.lex_state = 0},
  [11211] = {.lex_state = 355},
  [11212] = {.lex_state = 356},
  [11213] = {.lex_state = 0},
  [11214] = {.lex_state = 207},
  [11215] = {.lex_state = 0},
  [11216] = {.lex_state = 119},
  [11217] = {.lex_state = 0},
  [11218] = {.lex_state = 207},
  [11219] = {.lex_state = 0},
  [11220] = {.lex_state = 0},
  [11221] = {.lex_state = 207},
  [11222] = {.lex_state = 356},
  [11223] = {.lex_state = 356},
  [11224] = {.lex_state = 356},
  [11225] = {.lex_state = 356},
  [11226] = {.lex_state = 0},
  [11227] = {.lex_state = 356},
  [11228] = {.lex_state = 0},
  [11229] = {.lex_state = 0},
  [11230] = {.lex_state = 0},
  [11231] = {.lex_state = 0},
  [11232] = {.lex_state = 0},
  [11233] = {.lex_state = 207},
  [11234] = {.lex_state = 207},
  [11235] = {.lex_state = 356},
  [11236] = {.lex_state = 356},
  [11237] = {.lex_state = 0},
  [11238] = {.lex_state = 0},
  [11239] = {.lex_state = 0, .external_lex_state = 2},
  [11240] = {.lex_state = 0},
  [11241] = {.lex_state = 356},
  [11242] = {.lex_state = 0, .external_lex_state = 3},
  [11243] = {.lex_state = 356},
  [11244] = {.lex_state = 356},
  [11245] = {.lex_state = 0},
  [11246] = {.lex_state = 0},
  [11247] = {.lex_state = 0},
  [11248] = {.lex_state = 210},
  [11249] = {.lex_state = 0},
  [11250] = {.lex_state = 0},
  [11251] = {.lex_state = 0},
  [11252] = {.lex_state = 0},
  [11253] = {.lex_state = 356},
  [11254] = {.lex_state = 207},
  [11255] = {.lex_state = 0},
  [11256] = {.lex_state = 356},
  [11257] = {.lex_state = 0},
  [11258] = {.lex_state = 0},
  [11259] = {.lex_state = 0},
  [11260] = {.lex_state = 210},
  [11261] = {.lex_state = 0},
  [11262] = {.lex_state = 207},
  [11263] = {.lex_state = 207},
  [11264] = {.lex_state = 0},
  [11265] = {.lex_state = 185},
  [11266] = {.lex_state = 0},
  [11267] = {.lex_state = 0},
  [11268] = {.lex_state = 0},
  [11269] = {.lex_state = 0},
  [11270] = {.lex_state = 0},
  [11271] = {.lex_state = 0},
  [11272] = {.lex_state = 0},
  [11273] = {.lex_state = 210},
  [11274] = {.lex_state = 185},
  [11275] = {.lex_state = 207},
  [11276] = {.lex_state = 0},
  [11277] = {.lex_state = 0},
  [11278] = {.lex_state = 207},
  [11279] = {.lex_state = 0},
  [11280] = {.lex_state = 0},
  [11281] = {.lex_state = 0},
  [11282] = {.lex_state = 0},
  [11283] = {.lex_state = 356},
  [11284] = {.lex_state = 0},
  [11285] = {.lex_state = 0},
  [11286] = {.lex_state = 185},
  [11287] = {.lex_state = 0},
  [11288] = {.lex_state = 356},
  [11289] = {.lex_state = 0},
  [11290] = {.lex_state = 0},
  [11291] = {.lex_state = 0},
  [11292] = {.lex_state = 0},
  [11293] = {.lex_state = 185},
  [11294] = {.lex_state = 0},
  [11295] = {.lex_state = 0},
  [11296] = {.lex_state = 0},
  [11297] = {.lex_state = 0},
  [11298] = {.lex_state = 0},
  [11299] = {.lex_state = 0},
  [11300] = {.lex_state = 0},
  [11301] = {.lex_state = 0},
  [11302] = {.lex_state = 0},
  [11303] = {.lex_state = 0},
  [11304] = {.lex_state = 356},
  [11305] = {.lex_state = 0},
  [11306] = {.lex_state = 356},
  [11307] = {.lex_state = 356},
  [11308] = {.lex_state = 356},
  [11309] = {.lex_state = 0},
  [11310] = {.lex_state = 356},
  [11311] = {.lex_state = 185},
  [11312] = {.lex_state = 0},
  [11313] = {.lex_state = 207},
  [11314] = {.lex_state = 119},
  [11315] = {.lex_state = 356},
  [11316] = {.lex_state = 0},
  [11317] = {.lex_state = 0},
  [11318] = {.lex_state = 0},
  [11319] = {.lex_state = 0, .external_lex_state = 3},
  [11320] = {.lex_state = 207},
  [11321] = {.lex_state = 0},
  [11322] = {.lex_state = 0},
  [11323] = {.lex_state = 0},
  [11324] = {.lex_state = 207},
  [11325] = {.lex_state = 207},
  [11326] = {.lex_state = 0},
  [11327] = {.lex_state = 0},
  [11328] = {.lex_state = 210},
  [11329] = {.lex_state = 0},
  [11330] = {.lex_state = 0},
  [11331] = {.lex_state = 207},
  [11332] = {.lex_state = 0},
  [11333] = {.lex_state = 0},
  [11334] = {.lex_state = 0},
  [11335] = {.lex_state = 185},
  [11336] = {.lex_state = 0},
  [11337] = {.lex_state = 0},
  [11338] = {.lex_state = 0},
  [11339] = {.lex_state = 0},
  [11340] = {.lex_state = 356},
  [11341] = {.lex_state = 0},
  [11342] = {.lex_state = 119},
  [11343] = {.lex_state = 0},
  [11344] = {.lex_state = 0},
  [11345] = {.lex_state = 0},
  [11346] = {.lex_state = 0},
  [11347] = {.lex_state = 0},
  [11348] = {.lex_state = 356},
  [11349] = {.lex_state = 356},
  [11350] = {.lex_state = 356},
  [11351] = {.lex_state = 0},
  [11352] = {.lex_state = 356},
  [11353] = {.lex_state = 185},
  [11354] = {.lex_state = 0},
  [11355] = {.lex_state = 207},
  [11356] = {.lex_state = 356},
  [11357] = {.lex_state = 0},
  [11358] = {.lex_state = 356},
  [11359] = {.lex_state = 356},
  [11360] = {.lex_state = 0, .external_lex_state = 3},
  [11361] = {.lex_state = 0},
  [11362] = {.lex_state = 0},
  [11363] = {.lex_state = 0},
  [11364] = {.lex_state = 0},
  [11365] = {.lex_state = 207},
  [11366] = {.lex_state = 0},
  [11367] = {.lex_state = 210},
  [11368] = {.lex_state = 0},
  [11369] = {.lex_state = 0},
  [11370] = {.lex_state = 185},
  [11371] = {.lex_state = 185},
  [11372] = {.lex_state = 0},
  [11373] = {.lex_state = 0},
  [11374] = {.lex_state = 0},
  [11375] = {.lex_state = 0},
  [11376] = {.lex_state = 0},
  [11377] = {.lex_state = 356},
  [11378] = {.lex_state = 356},
  [11379] = {.lex_state = 356},
  [11380] = {.lex_state = 0},
  [11381] = {.lex_state = 356},
  [11382] = {.lex_state = 0},
  [11383] = {.lex_state = 185},
  [11384] = {.lex_state = 356},
  [11385] = {.lex_state = 119},
  [11386] = {.lex_state = 0},
  [11387] = {.lex_state = 356},
  [11388] = {.lex_state = 0, .external_lex_state = 3},
  [11389] = {.lex_state = 0},
  [11390] = {.lex_state = 0, .external_lex_state = 2},
  [11391] = {.lex_state = 0},
  [11392] = {.lex_state = 185},
  [11393] = {.lex_state = 207},
  [11394] = {.lex_state = 0},
  [11395] = {.lex_state = 210},
  [11396] = {.lex_state = 0},
  [11397] = {.lex_state = 356},
  [11398] = {.lex_state = 185},
  [11399] = {.lex_state = 210},
  [11400] = {.lex_state = 0},
  [11401] = {.lex_state = 207},
  [11402] = {.lex_state = 0},
  [11403] = {.lex_state = 356},
  [11404] = {.lex_state = 356},
  [11405] = {.lex_state = 0},
  [11406] = {.lex_state = 356},
  [11407] = {.lex_state = 0},
  [11408] = {.lex_state = 0},
  [11409] = {.lex_state = 0},
  [11410] = {.lex_state = 207},
  [11411] = {.lex_state = 356},
  [11412] = {.lex_state = 0, .external_lex_state = 3},
  [11413] = {.lex_state = 185},
  [11414] = {.lex_state = 0},
  [11415] = {.lex_state = 0},
  [11416] = {.lex_state = 0},
  [11417] = {.lex_state = 0},
  [11418] = {.lex_state = 0},
  [11419] = {.lex_state = 0},
  [11420] = {.lex_state = 356},
  [11421] = {.lex_state = 0},
  [11422] = {.lex_state = 210},
  [11423] = {.lex_state = 207},
  [11424] = {.lex_state = 0},
  [11425] = {.lex_state = 356},
  [11426] = {.lex_state = 356},
  [11427] = {.lex_state = 356},
  [11428] = {.lex_state = 0},
  [11429] = {.lex_state = 0, .external_lex_state = 3},
  [11430] = {.lex_state = 0},
  [11431] = {.lex_state = 185},
  [11432] = {.lex_state = 0},
  [11433] = {.lex_state = 0},
  [11434] = {.lex_state = 0},
  [11435] = {.lex_state = 0},
  [11436] = {.lex_state = 207},
  [11437] = {.lex_state = 0},
  [11438] = {.lex_state = 207},
  [11439] = {.lex_state = 0},
  [11440] = {.lex_state = 356},
  [11441] = {.lex_state = 356},
  [11442] = {.lex_state = 356},
  [11443] = {.lex_state = 185},
  [11444] = {.lex_state = 0, .external_lex_state = 3},
  [11445] = {.lex_state = 0},
  [11446] = {.lex_state = 0},
  [11447] = {.lex_state = 356},
  [11448] = {.lex_state = 356},
  [11449] = {.lex_state = 356},
  [11450] = {.lex_state = 0, .external_lex_state = 3},
  [11451] = {.lex_state = 0},
  [11452] = {.lex_state = 356},
  [11453] = {.lex_state = 356},
  [11454] = {.lex_state = 356},
  [11455] = {.lex_state = 0, .external_lex_state = 3},
  [11456] = {.lex_state = 0},
  [11457] = {.lex_state = 356},
  [11458] = {.lex_state = 356},
  [11459] = {.lex_state = 0, .external_lex_state = 3},
  [11460] = {.lex_state = 0},
  [11461] = {.lex_state = 356},
  [11462] = {.lex_state = 356},
  [11463] = {.lex_state = 0, .external_lex_state = 3},
  [11464] = {.lex_state = 0},
  [11465] = {.lex_state = 356},
  [11466] = {.lex_state = 0, .external_lex_state = 3},
  [11467] = {.lex_state = 0},
  [11468] = {.lex_state = 356},
  [11469] = {.lex_state = 0, .external_lex_state = 3},
  [11470] = {.lex_state = 0},
  [11471] = {.lex_state = 356},
  [11472] = {.lex_state = 0, .external_lex_state = 3},
  [11473] = {.lex_state = 0},
  [11474] = {.lex_state = 356},
  [11475] = {.lex_state = 0, .external_lex_state = 3},
  [11476] = {.lex_state = 0},
  [11477] = {.lex_state = 0},
  [11478] = {.lex_state = 0},
  [11479] = {.lex_state = 356},
  [11480] = {.lex_state = 356},
  [11481] = {.lex_state = 207},
  [11482] = {.lex_state = 119},
  [11483] = {.lex_state = 119},
  [11484] = {.lex_state = 119},
  [11485] = {.lex_state = 0},
  [11486] = {.lex_state = 207},
  [11487] = {.lex_state = 0},
  [11488] = {.lex_state = 0},
  [11489] = {.lex_state = 0},
  [11490] = {.lex_state = 0},
  [11491] = {.lex_state = 210},
  [11492] = {.lex_state = 0},
  [11493] = {.lex_state = 185},
  [11494] = {.lex_state = 207},
  [11495] = {.lex_state = 356},
  [11496] = {.lex_state = 185},
  [11497] = {.lex_state = 119},
  [11498] = {.lex_state = 185},
  [11499] = {.lex_state = 0},
  [11500] = {.lex_state = 0},
  [11501] = {.lex_state = 207},
  [11502] = {.lex_state = 0, .external_lex_state = 3},
  [11503] = {.lex_state = 0},
  [11504] = {.lex_state = 185},
  [11505] = {.lex_state = 0},
  [11506] = {.lex_state = 0},
  [11507] = {.lex_state = 0},
  [11508] = {.lex_state = 0},
  [11509] = {.lex_state = 0},
  [11510] = {.lex_state = 356},
  [11511] = {.lex_state = 0},
  [11512] = {.lex_state = 185},
  [11513] = {.lex_state = 220},
  [11514] = {.lex_state = 185},
  [11515] = {.lex_state = 0},
  [11516] = {.lex_state = 119},
  [11517] = {.lex_state = 0},
  [11518] = {.lex_state = 0},
  [11519] = {.lex_state = 0},
  [11520] = {.lex_state = 0},
  [11521] = {.lex_state = 0},
  [11522] = {.lex_state = 0},
  [11523] = {.lex_state = 210},
  [11524] = {.lex_state = 0},
  [11525] = {.lex_state = 0},
  [11526] = {.lex_state = 0},
  [11527] = {.lex_state = 185},
  [11528] = {.lex_state = 210},
  [11529] = {.lex_state = 0},
  [11530] = {.lex_state = 0},
  [11531] = {.lex_state = 210},
  [11532] = {.lex_state = 0, .external_lex_state = 2},
  [11533] = {.lex_state = 185},
  [11534] = {.lex_state = 0},
  [11535] = {.lex_state = 0},
  [11536] = {.lex_state = 0},
  [11537] = {.lex_state = 207},
  [11538] = {.lex_state = 0},
  [11539] = {.lex_state = 0},
  [11540] = {.lex_state = 0},
  [11541] = {.lex_state = 0},
  [11542] = {.lex_state = 0},
  [11543] = {.lex_state = 207},
  [11544] = {.lex_state = 0},
  [11545] = {.lex_state = 0},
  [11546] = {.lex_state = 0},
  [11547] = {.lex_state = 356},
  [11548] = {.lex_state = 356},
  [11549] = {.lex_state = 0},
  [11550] = {.lex_state = 207},
  [11551] = {.lex_state = 0},
  [11552] = {.lex_state = 185},
  [11553] = {.lex_state = 0, .external_lex_state = 3},
  [11554] = {.lex_state = 0},
  [11555] = {.lex_state = 0},
  [11556] = {.lex_state = 119},
  [11557] = {.lex_state = 185},
  [11558] = {.lex_state = 0},
  [11559] = {.lex_state = 0},
  [11560] = {.lex_state = 119},
  [11561] = {.lex_state = 252},
  [11562] = {.lex_state = 0},
  [11563] = {.lex_state = 0},
  [11564] = {.lex_state = 0},
  [11565] = {.lex_state = 0},
  [11566] = {.lex_state = 0},
  [11567] = {.lex_state = 0},
  [11568] = {.lex_state = 0},
  [11569] = {.lex_state = 0},
  [11570] = {.lex_state = 185},
  [11571] = {.lex_state = 0},
  [11572] = {.lex_state = 356},
  [11573] = {.lex_state = 0},
  [11574] = {.lex_state = 0},
  [11575] = {.lex_state = 0},
  [11576] = {.lex_state = 0},
  [11577] = {.lex_state = 356},
  [11578] = {.lex_state = 207},
  [11579] = {.lex_state = 0},
  [11580] = {.lex_state = 0},
  [11581] = {.lex_state = 0},
  [11582] = {.lex_state = 0},
  [11583] = {.lex_state = 0},
  [11584] = {.lex_state = 0},
  [11585] = {.lex_state = 0, .external_lex_state = 2},
  [11586] = {.lex_state = 207},
  [11587] = {.lex_state = 210},
  [11588] = {.lex_state = 0},
  [11589] = {.lex_state = 0},
  [11590] = {.lex_state = 0, .external_lex_state = 2},
  [11591] = {.lex_state = 0},
  [11592] = {.lex_state = 0},
  [11593] = {.lex_state = 0},
  [11594] = {.lex_state = 0},
  [11595] = {.lex_state = 207},
  [11596] = {.lex_state = 0},
  [11597] = {.lex_state = 207},
  [11598] = {.lex_state = 210},
  [11599] = {.lex_state = 185},
  [11600] = {.lex_state = 0},
  [11601] = {.lex_state = 0},
  [11602] = {.lex_state = 185},
  [11603] = {.lex_state = 0},
  [11604] = {.lex_state = 0},
  [11605] = {.lex_state = 0},
  [11606] = {.lex_state = 0},
  [11607] = {.lex_state = 207},
  [11608] = {.lex_state = 0},
  [11609] = {.lex_state = 0},
  [11610] = {.lex_state = 0},
  [11611] = {.lex_state = 0},
  [11612] = {.lex_state = 0},
  [11613] = {.lex_state = 207},
  [11614] = {.lex_state = 207},
  [11615] = {.lex_state = 0},
  [11616] = {.lex_state = 0},
  [11617] = {.lex_state = 0},
  [11618] = {.lex_state = 0},
  [11619] = {.lex_state = 185},
  [11620] = {.lex_state = 0},
  [11621] = {.lex_state = 207},
  [11622] = {.lex_state = 0},
  [11623] = {.lex_state = 210},
  [11624] = {.lex_state = 0},
  [11625] = {.lex_state = 185},
  [11626] = {.lex_state = 356},
  [11627] = {.lex_state = 356},
  [11628] = {.lex_state = 207},
  [11629] = {.lex_state = 0},
  [11630] = {.lex_state = 0},
  [11631] = {.lex_state = 0},
  [11632] = {.lex_state = 356},
  [11633] = {.lex_state = 0},
  [11634] = {.lex_state = 0},
  [11635] = {.lex_state = 207},
  [11636] = {.lex_state = 0, .external_lex_state = 3},
  [11637] = {.lex_state = 210},
  [11638] = {.lex_state = 0},
  [11639] = {.lex_state = 0, .external_lex_state = 2},
  [11640] = {.lex_state = 0},
  [11641] = {.lex_state = 0},
  [11642] = {.lex_state = 356},
  [11643] = {.lex_state = 356},
  [11644] = {.lex_state = 356},
  [11645] = {.lex_state = 207},
  [11646] = {.lex_state = 0},
  [11647] = {.lex_state = 0},
  [11648] = {.lex_state = 356},
  [11649] = {.lex_state = 207},
  [11650] = {.lex_state = 0, .external_lex_state = 3},
  [11651] = {.lex_state = 0},
  [11652] = {.lex_state = 0},
  [11653] = {.lex_state = 0},
  [11654] = {.lex_state = 356},
  [11655] = {.lex_state = 207},
  [11656] = {.lex_state = 0},
  [11657] = {.lex_state = 0},
  [11658] = {.lex_state = 207},
  [11659] = {.lex_state = 0, .external_lex_state = 3},
  [11660] = {.lex_state = 0},
  [11661] = {.lex_state = 0},
  [11662] = {.lex_state = 356},
  [11663] = {.lex_state = 207},
  [11664] = {.lex_state = 119},
  [11665] = {.lex_state = 0},
  [11666] = {.lex_state = 207},
  [11667] = {.lex_state = 0, .external_lex_state = 3},
  [11668] = {.lex_state = 207},
  [11669] = {.lex_state = 356},
  [11670] = {.lex_state = 207},
  [11671] = {.lex_state = 0},
  [11672] = {.lex_state = 207},
  [11673] = {.lex_state = 0, .external_lex_state = 3},
  [11674] = {.lex_state = 0},
  [11675] = {.lex_state = 207},
  [11676] = {.lex_state = 0, .external_lex_state = 3},
  [11677] = {.lex_state = 0},
  [11678] = {.lex_state = 0, .external_lex_state = 3},
  [11679] = {.lex_state = 0},
  [11680] = {.lex_state = 0, .external_lex_state = 3},
  [11681] = {.lex_state = 0, .external_lex_state = 2},
  [11682] = {.lex_state = 0, .external_lex_state = 3},
  [11683] = {.lex_state = 0},
  [11684] = {.lex_state = 0, .external_lex_state = 3},
  [11685] = {.lex_state = 0},
  [11686] = {.lex_state = 0, .external_lex_state = 3},
  [11687] = {.lex_state = 0},
  [11688] = {.lex_state = 0, .external_lex_state = 3},
  [11689] = {.lex_state = 0},
  [11690] = {.lex_state = 0, .external_lex_state = 3},
  [11691] = {.lex_state = 356},
  [11692] = {.lex_state = 0, .external_lex_state = 3},
  [11693] = {.lex_state = 210},
  [11694] = {.lex_state = 0, .external_lex_state = 3},
  [11695] = {.lex_state = 356},
  [11696] = {.lex_state = 356},
  [11697] = {.lex_state = 0},
  [11698] = {.lex_state = 356},
  [11699] = {.lex_state = 356},
  [11700] = {.lex_state = 210},
  [11701] = {.lex_state = 185},
  [11702] = {.lex_state = 356},
  [11703] = {.lex_state = 356},
  [11704] = {.lex_state = 356},
  [11705] = {.lex_state = 356},
  [11706] = {.lex_state = 356},
  [11707] = {.lex_state = 207},
  [11708] = {.lex_state = 356},
  [11709] = {.lex_state = 356},
  [11710] = {.lex_state = 119},
  [11711] = {.lex_state = 356},
  [11712] = {.lex_state = 356},
  [11713] = {.lex_state = 356},
  [11714] = {.lex_state = 356},
  [11715] = {.lex_state = 356},
  [11716] = {.lex_state = 356},
  [11717] = {.lex_state = 356},
  [11718] = {.lex_state = 356},
  [11719] = {.lex_state = 356},
  [11720] = {.lex_state = 356},
  [11721] = {.lex_state = 356},
  [11722] = {.lex_state = 0},
  [11723] = {.lex_state = 185},
  [11724] = {.lex_state = 0},
  [11725] = {.lex_state = 0},
  [11726] = {.lex_state = 207},
  [11727] = {.lex_state = 356},
  [11728] = {.lex_state = 356},
  [11729] = {.lex_state = 356},
  [11730] = {.lex_state = 356},
  [11731] = {.lex_state = 356},
  [11732] = {.lex_state = 356},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [aux_sym_preproc_include_token1] = ACTIONS(1),
    [aux_sym_preproc_def_token1] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [aux_sym_preproc_if_token1] = ACTIONS(1),
    [aux_sym_preproc_if_token2] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1),
    [aux_sym_preproc_else_token1] = ACTIONS(1),
    [aux_sym_preproc_elif_token1] = ACTIONS(1),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1),
    [sym_preproc_directive] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_defined] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym___extension__] = ACTIONS(1),
    [anon_sym_typedef] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_out] = ACTIONS(1),
    [anon_sym_inout] = ACTIONS(1),
    [anon_sym_virtual] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym___attribute__] = ACTIONS(1),
    [anon_sym___attribute] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym___declspec] = ACTIONS(1),
    [anon_sym___based] = ACTIONS(1),
    [anon_sym___cdecl] = ACTIONS(1),
    [anon_sym___clrcall] = ACTIONS(1),
    [anon_sym___stdcall] = ACTIONS(1),
    [anon_sym___fastcall] = ACTIONS(1),
    [anon_sym___thiscall] = ACTIONS(1),
    [anon_sym___vectorcall] = ACTIONS(1),
    [sym_ms_restrict_modifier] = ACTIONS(1),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(1),
    [sym_ms_signed_ptr_modifier] = ACTIONS(1),
    [anon_sym__unaligned] = ACTIONS(1),
    [anon_sym___unaligned] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_signed] = ACTIONS(1),
    [anon_sym_unsigned] = ACTIONS(1),
    [anon_sym_long] = ACTIONS(1),
    [anon_sym_short] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_register] = ACTIONS(1),
    [anon_sym_inline] = ACTIONS(1),
    [anon_sym___inline] = ACTIONS(1),
    [anon_sym___inline__] = ACTIONS(1),
    [anon_sym___forceinline] = ACTIONS(1),
    [anon_sym_thread_local] = ACTIONS(1),
    [anon_sym___thread] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_constexpr] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_restrict] = ACTIONS(1),
    [anon_sym___restrict__] = ACTIONS(1),
    [anon_sym__Atomic] = ACTIONS(1),
    [anon_sym__Noreturn] = ACTIONS(1),
    [anon_sym_noreturn] = ACTIONS(1),
    [anon_sym__Nonnull] = ACTIONS(1),
    [anon_sym_mutable] = ACTIONS(1),
    [anon_sym_constinit] = ACTIONS(1),
    [anon_sym_consteval] = ACTIONS(1),
    [anon_sym_alignas] = ACTIONS(1),
    [anon_sym__Alignas] = ACTIONS(1),
    [sym_primitive_type] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym___try] = ACTIONS(1),
    [anon_sym___except] = ACTIONS(1),
    [anon_sym___finally] = ACTIONS(1),
    [anon_sym___leave] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_and_eq] = ACTIONS(1),
    [anon_sym_or_eq] = ACTIONS(1),
    [anon_sym_xor_eq] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_compl] = ACTIONS(1),
    [anon_sym_LT_EQ_GT] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_bitor] = ACTIONS(1),
    [anon_sym_xor] = ACTIONS(1),
    [anon_sym_bitand] = ACTIONS(1),
    [anon_sym_not_eq] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_sizeof] = ACTIONS(1),
    [anon_sym___alignof__] = ACTIONS(1),
    [anon_sym___alignof] = ACTIONS(1),
    [anon_sym__alignof] = ACTIONS(1),
    [anon_sym_alignof] = ACTIONS(1),
    [anon_sym__Alignof] = ACTIONS(1),
    [anon_sym_offsetof] = ACTIONS(1),
    [anon_sym__Generic] = ACTIONS(1),
    [anon_sym_asm] = ACTIONS(1),
    [anon_sym___asm__] = ACTIONS(1),
    [anon_sym___asm] = ACTIONS(1),
    [anon_sym___volatile__] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DOT_STAR] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [sym_number_literal] = ACTIONS(1),
    [anon_sym_L_SQUOTE] = ACTIONS(1),
    [anon_sym_u_SQUOTE] = ACTIONS(1),
    [anon_sym_U_SQUOTE] = ACTIONS(1),
    [anon_sym_u8_SQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_L_DQUOTE] = ACTIONS(1),
    [anon_sym_u_DQUOTE] = ACTIONS(1),
    [anon_sym_U_DQUOTE] = ACTIONS(1),
    [anon_sym_u8_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [anon_sym_NULL] = ACTIONS(1),
    [anon_sym_nullptr] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_This] = ACTIONS(1),
    [anon_sym_decltype] = ACTIONS(1),
    [anon_sym_final] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_explicit] = ACTIONS(1),
    [anon_sym_typename] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_template] = ACTIONS(1),
    [anon_sym_GT2] = ACTIONS(1),
    [anon_sym_operator] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [aux_sym_pure_virtual_clause_token1] = ACTIONS(1),
    [anon_sym_friend] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_noexcept] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_static_assert] = ACTIONS(1),
    [anon_sym_concept] = ACTIONS(1),
    [anon_sym_co_return] = ACTIONS(1),
    [anon_sym_co_yield] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_R_DQUOTE] = ACTIONS(1),
    [anon_sym_LR_DQUOTE] = ACTIONS(1),
    [anon_sym_uR_DQUOTE] = ACTIONS(1),
    [anon_sym_UR_DQUOTE] = ACTIONS(1),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1),
    [anon_sym_co_await] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_requires] = ACTIONS(1),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [anon_sym_discard] = ACTIONS(1),
    [anon_sym_precise] = ACTIONS(1),
    [anon_sym_shared] = ACTIONS(1),
    [anon_sym_groupshared] = ACTIONS(1),
    [anon_sym_uniform] = ACTIONS(1),
    [anon_sym_row_major] = ACTIONS(1),
    [anon_sym_column_major] = ACTIONS(1),
    [anon_sym_globallycoherent] = ACTIONS(1),
    [anon_sym_centroid] = ACTIONS(1),
    [anon_sym_noperspective] = ACTIONS(1),
    [anon_sym_nointerpolation] = ACTIONS(1),
    [anon_sym_sample] = ACTIONS(1),
    [anon_sym_linear] = ACTIONS(1),
    [anon_sym_snorm] = ACTIONS(1),
    [anon_sym_unorm] = ACTIONS(1),
    [anon_sym_point] = ACTIONS(1),
    [anon_sym_line] = ACTIONS(1),
    [anon_sym_triangleadj] = ACTIONS(1),
    [anon_sym_lineadj] = ACTIONS(1),
    [anon_sym_triangle] = ACTIONS(1),
    [anon_sym_cbuffer] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_extension] = ACTIONS(1),
    [anon_sym_where] = ACTIONS(1),
    [anon_sym___exported] = ACTIONS(1),
    [anon_sym___init] = ACTIONS(1),
    [anon_sym___subscript] = ACTIONS(1),
    [anon_sym_property] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_associatedtype] = ACTIONS(1),
    [sym_raw_string_delimiter] = ACTIONS(1),
    [sym_raw_string_content] = ACTIONS(1),
  },
  [1] = {
    [sym_translation_unit] = STATE(11168),
    [sym__top_level_item] = STATE(29),
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6100),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2234),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8014),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(29),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(247),
    [sym_sized_type_specifier] = STATE(315),
    [sym_enum_specifier] = STATE(315),
    [sym_struct_specifier] = STATE(315),
    [sym_union_specifier] = STATE(315),
    [sym_attributed_statement] = STATE(1008),
    [sym__top_level_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym__top_level_expression_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_goto_statement] = STATE(29),
    [sym_expression] = STATE(6128),
    [sym__string] = STATE(6105),
    [sym_conditional_expression] = STATE(6219),
    [sym_assignment_expression] = STATE(6219),
    [sym_pointer_expression] = STATE(4822),
    [sym_unary_expression] = STATE(6219),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(6219),
    [sym_cast_expression] = STATE(6219),
    [sym_sizeof_expression] = STATE(6219),
    [sym_alignof_expression] = STATE(6219),
    [sym_offsetof_expression] = STATE(6219),
    [sym_generic_expression] = STATE(6219),
    [sym_subscript_expression] = STATE(4822),
    [sym_call_expression] = STATE(4822),
    [sym_gnu_asm_expression] = STATE(6219),
    [sym_extension_expression] = STATE(6219),
    [sym_field_expression] = STATE(4822),
    [sym_compound_literal_expression] = STATE(6219),
    [sym_parenthesized_expression] = STATE(4822),
    [sym_char_literal] = STATE(6105),
    [sym_concatenated_string] = STATE(6105),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(6219),
    [sym__empty_declaration] = STATE(29),
    [sym_placeholder_type_specifier] = STATE(315),
    [sym_decltype] = STATE(256),
    [sym_class_specifier] = STATE(315),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2678),
    [sym_dependent_type] = STATE(315),
    [sym_module_declaration] = STATE(29),
    [sym_export_declaration] = STATE(29),
    [sym_import_declaration] = STATE(29),
    [sym_global_module_fragment_declaration] = STATE(29),
    [sym_private_module_fragment_declaration] = STATE(29),
    [sym_template_declaration] = STATE(29),
    [sym_template_instantiation] = STATE(29),
    [sym_operator_cast] = STATE(9025),
    [sym__constructor_specifiers] = STATE(2678),
    [sym_operator_cast_definition] = STATE(29),
    [sym_operator_cast_declaration] = STATE(29),
    [sym_constructor_or_destructor_definition] = STATE(29),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(831),
    [sym_template_function] = STATE(6081),
    [sym_namespace_definition] = STATE(29),
    [sym_namespace_alias_definition] = STATE(29),
    [sym_using_declaration] = STATE(29),
    [sym_alias_declaration] = STATE(29),
    [sym_static_assert_declaration] = STATE(29),
    [sym_concept_definition] = STATE(29),
    [sym_for_range_loop] = STATE(29),
    [sym_co_return_statement] = STATE(29),
    [sym_co_yield_statement] = STATE(29),
    [sym_throw_statement] = STATE(29),
    [sym_try_statement] = STATE(29),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(6219),
    [sym_new_expression] = STATE(6219),
    [sym_delete_expression] = STATE(6219),
    [sym_requires_clause] = STATE(6219),
    [sym_requires_expression] = STATE(6219),
    [sym_lambda_expression] = STATE(6219),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(6219),
    [sym_parameter_pack_expansion] = STATE(6219),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6985),
    [sym_qualified_identifier] = STATE(4704),
    [sym_qualified_type_identifier] = STATE(841),
    [sym_qualified_operator_cast_identifier] = STATE(9025),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4822),
    [sym_qualifiers] = STATE(2919),
    [sym_hlsl_attribute] = STATE(1611),
    [sym_interface_specifier] = STATE(315),
    [sym_extension_specifier] = STATE(315),
    [sym_import_statement] = STATE(29),
    [sym_associatedtype_specifier] = STATE(315),
    [aux_sym_translation_unit_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1189),
    [aux_sym_sized_type_specifier_repeat1] = STATE(389),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2678),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(33),
    [anon_sym___extension__] = ACTIONS(35),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(65),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(115),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(121),
    [sym_false] = ACTIONS(121),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(125),
    [anon_sym_let] = ACTIONS(125),
    [anon_sym_This] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_module] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(137),
    [anon_sym_template] = ACTIONS(139),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_namespace] = ACTIONS(149),
    [anon_sym_static_assert] = ACTIONS(151),
    [anon_sym_concept] = ACTIONS(153),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(121),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(169),
    [anon_sym_extension] = ACTIONS(171),
    [anon_sym___exported] = ACTIONS(173),
  },
  [2] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5416),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(9647),
    [sym_initializer_pair] = STATE(9647),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(175),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(181),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(199),
    [anon_sym_RBRACE] = ACTIONS(201),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(205),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [3] = {
    [sym__block_item] = STATE(31),
    [sym_preproc_include] = STATE(31),
    [sym_preproc_def] = STATE(31),
    [sym_preproc_function_def] = STATE(31),
    [sym_preproc_call] = STATE(31),
    [sym_preproc_if] = STATE(31),
    [sym_preproc_ifdef] = STATE(31),
    [sym_function_definition] = STATE(31),
    [sym_declaration] = STATE(31),
    [sym_type_definition] = STATE(31),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(31),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(31),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5416),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(9647),
    [sym_initializer_pair] = STATE(9647),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(31),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(31),
    [sym_template_instantiation] = STATE(31),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(31),
    [sym_operator_cast_declaration] = STATE(31),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(31),
    [sym_namespace_alias_definition] = STATE(31),
    [sym_using_declaration] = STATE(31),
    [sym_alias_declaration] = STATE(31),
    [sym_static_assert_declaration] = STATE(31),
    [sym_concept_definition] = STATE(31),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(31),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(175),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(181),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(199),
    [anon_sym_RBRACE] = ACTIONS(281),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(205),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [4] = {
    [sym__block_item] = STATE(61),
    [sym_preproc_include] = STATE(61),
    [sym_preproc_def] = STATE(61),
    [sym_preproc_function_def] = STATE(61),
    [sym_preproc_call] = STATE(61),
    [sym_preproc_if] = STATE(61),
    [sym_preproc_ifdef] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_declaration] = STATE(61),
    [sym_type_definition] = STATE(61),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(61),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(61),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5416),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(9647),
    [sym_initializer_pair] = STATE(9647),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(61),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(61),
    [sym_template_instantiation] = STATE(61),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(61),
    [sym_operator_cast_declaration] = STATE(61),
    [sym_constructor_or_destructor_definition] = STATE(61),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(61),
    [sym_namespace_alias_definition] = STATE(61),
    [sym_using_declaration] = STATE(61),
    [sym_alias_declaration] = STATE(61),
    [sym_static_assert_declaration] = STATE(61),
    [sym_concept_definition] = STATE(61),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(61),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(175),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(181),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(199),
    [anon_sym_RBRACE] = ACTIONS(283),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(205),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [5] = {
    [sym__block_item] = STATE(34),
    [sym_preproc_include] = STATE(34),
    [sym_preproc_def] = STATE(34),
    [sym_preproc_function_def] = STATE(34),
    [sym_preproc_call] = STATE(34),
    [sym_preproc_if] = STATE(34),
    [sym_preproc_ifdef] = STATE(34),
    [sym_function_definition] = STATE(34),
    [sym_declaration] = STATE(34),
    [sym_type_definition] = STATE(34),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(34),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(34),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5416),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(9647),
    [sym_initializer_pair] = STATE(9647),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(34),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(34),
    [sym_template_instantiation] = STATE(34),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(34),
    [sym_operator_cast_declaration] = STATE(34),
    [sym_constructor_or_destructor_definition] = STATE(34),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(34),
    [sym_namespace_alias_definition] = STATE(34),
    [sym_using_declaration] = STATE(34),
    [sym_alias_declaration] = STATE(34),
    [sym_static_assert_declaration] = STATE(34),
    [sym_concept_definition] = STATE(34),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(34),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(175),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(181),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(199),
    [anon_sym_RBRACE] = ACTIONS(201),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(205),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [6] = {
    [sym__block_item] = STATE(75),
    [sym_preproc_include] = STATE(75),
    [sym_preproc_def] = STATE(75),
    [sym_preproc_function_def] = STATE(75),
    [sym_preproc_call] = STATE(75),
    [sym_preproc_if] = STATE(75),
    [sym_preproc_ifdef] = STATE(75),
    [sym_function_definition] = STATE(75),
    [sym_declaration] = STATE(75),
    [sym_type_definition] = STATE(75),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(75),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(75),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5416),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(9647),
    [sym_initializer_pair] = STATE(9647),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(75),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(75),
    [sym_template_instantiation] = STATE(75),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(75),
    [sym_operator_cast_declaration] = STATE(75),
    [sym_constructor_or_destructor_definition] = STATE(75),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(75),
    [sym_namespace_alias_definition] = STATE(75),
    [sym_using_declaration] = STATE(75),
    [sym_alias_declaration] = STATE(75),
    [sym_static_assert_declaration] = STATE(75),
    [sym_concept_definition] = STATE(75),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(75),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(175),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(181),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(199),
    [anon_sym_RBRACE] = ACTIONS(285),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(205),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [7] = {
    [sym__block_item] = STATE(11),
    [sym_preproc_include] = STATE(11),
    [sym_preproc_def] = STATE(11),
    [sym_preproc_function_def] = STATE(11),
    [sym_preproc_call] = STATE(11),
    [sym_preproc_if] = STATE(11),
    [sym_preproc_ifdef] = STATE(11),
    [sym_preproc_else] = STATE(11153),
    [sym_preproc_elif] = STATE(11153),
    [sym_preproc_elifdef] = STATE(11153),
    [sym_function_definition] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_type_definition] = STATE(11),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_linkage_specification] = STATE(11),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2601),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8164),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(515),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2792),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(628),
    [sym_statement] = STATE(11),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(11),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2672),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(11),
    [sym_template_instantiation] = STATE(11),
    [sym_operator_cast] = STATE(9172),
    [sym__constructor_specifiers] = STATE(2672),
    [sym_operator_cast_definition] = STATE(11),
    [sym_operator_cast_declaration] = STATE(11),
    [sym_constructor_or_destructor_definition] = STATE(11),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(11),
    [sym_namespace_alias_definition] = STATE(11),
    [sym_using_declaration] = STATE(11),
    [sym_alias_declaration] = STATE(11),
    [sym_static_assert_declaration] = STATE(11),
    [sym_concept_definition] = STATE(11),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9172),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(1616),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(11),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1188),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2672),
    [sym_identifier] = ACTIONS(287),
    [aux_sym_preproc_include_token1] = ACTIONS(289),
    [aux_sym_preproc_def_token1] = ACTIONS(291),
    [aux_sym_preproc_if_token1] = ACTIONS(293),
    [aux_sym_preproc_if_token2] = ACTIONS(295),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(297),
    [aux_sym_preproc_else_token1] = ACTIONS(299),
    [aux_sym_preproc_elif_token1] = ACTIONS(301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(303),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(303),
    [sym_preproc_directive] = ACTIONS(305),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(309),
    [anon_sym_typedef] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(313),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(319),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(347),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_namespace] = ACTIONS(353),
    [anon_sym_static_assert] = ACTIONS(355),
    [anon_sym_concept] = ACTIONS(357),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [8] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(10939),
    [sym_preproc_elif] = STATE(10939),
    [sym_preproc_elifdef] = STATE(10939),
    [sym_function_definition] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2601),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8164),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(515),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2792),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(628),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(27),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2672),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(27),
    [sym_template_instantiation] = STATE(27),
    [sym_operator_cast] = STATE(9172),
    [sym__constructor_specifiers] = STATE(2672),
    [sym_operator_cast_definition] = STATE(27),
    [sym_operator_cast_declaration] = STATE(27),
    [sym_constructor_or_destructor_definition] = STATE(27),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(27),
    [sym_namespace_alias_definition] = STATE(27),
    [sym_using_declaration] = STATE(27),
    [sym_alias_declaration] = STATE(27),
    [sym_static_assert_declaration] = STATE(27),
    [sym_concept_definition] = STATE(27),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9172),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(1616),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1188),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2672),
    [sym_identifier] = ACTIONS(287),
    [aux_sym_preproc_include_token1] = ACTIONS(289),
    [aux_sym_preproc_def_token1] = ACTIONS(291),
    [aux_sym_preproc_if_token1] = ACTIONS(293),
    [aux_sym_preproc_if_token2] = ACTIONS(367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(297),
    [aux_sym_preproc_else_token1] = ACTIONS(299),
    [aux_sym_preproc_elif_token1] = ACTIONS(301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(303),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(303),
    [sym_preproc_directive] = ACTIONS(305),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(309),
    [anon_sym_typedef] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(313),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(319),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(347),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_namespace] = ACTIONS(353),
    [anon_sym_static_assert] = ACTIONS(355),
    [anon_sym_concept] = ACTIONS(357),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [9] = {
    [sym__block_item] = STATE(14),
    [sym_preproc_include] = STATE(14),
    [sym_preproc_def] = STATE(14),
    [sym_preproc_function_def] = STATE(14),
    [sym_preproc_call] = STATE(14),
    [sym_preproc_if] = STATE(14),
    [sym_preproc_ifdef] = STATE(14),
    [sym_preproc_else] = STATE(10976),
    [sym_preproc_elif] = STATE(10976),
    [sym_preproc_elifdef] = STATE(10976),
    [sym_function_definition] = STATE(14),
    [sym_declaration] = STATE(14),
    [sym_type_definition] = STATE(14),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_linkage_specification] = STATE(14),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2601),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8164),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(515),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2792),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(628),
    [sym_statement] = STATE(14),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(14),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2672),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(14),
    [sym_template_instantiation] = STATE(14),
    [sym_operator_cast] = STATE(9172),
    [sym__constructor_specifiers] = STATE(2672),
    [sym_operator_cast_definition] = STATE(14),
    [sym_operator_cast_declaration] = STATE(14),
    [sym_constructor_or_destructor_definition] = STATE(14),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(14),
    [sym_namespace_alias_definition] = STATE(14),
    [sym_using_declaration] = STATE(14),
    [sym_alias_declaration] = STATE(14),
    [sym_static_assert_declaration] = STATE(14),
    [sym_concept_definition] = STATE(14),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9172),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(1616),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(14),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1188),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2672),
    [sym_identifier] = ACTIONS(287),
    [aux_sym_preproc_include_token1] = ACTIONS(289),
    [aux_sym_preproc_def_token1] = ACTIONS(291),
    [aux_sym_preproc_if_token1] = ACTIONS(293),
    [aux_sym_preproc_if_token2] = ACTIONS(369),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(297),
    [aux_sym_preproc_else_token1] = ACTIONS(299),
    [aux_sym_preproc_elif_token1] = ACTIONS(301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(303),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(303),
    [sym_preproc_directive] = ACTIONS(305),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(309),
    [anon_sym_typedef] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(313),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(319),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(347),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_namespace] = ACTIONS(353),
    [anon_sym_static_assert] = ACTIONS(355),
    [anon_sym_concept] = ACTIONS(357),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [10] = {
    [sym__block_item] = STATE(8),
    [sym_preproc_include] = STATE(8),
    [sym_preproc_def] = STATE(8),
    [sym_preproc_function_def] = STATE(8),
    [sym_preproc_call] = STATE(8),
    [sym_preproc_if] = STATE(8),
    [sym_preproc_ifdef] = STATE(8),
    [sym_preproc_else] = STATE(11293),
    [sym_preproc_elif] = STATE(11293),
    [sym_preproc_elifdef] = STATE(11293),
    [sym_function_definition] = STATE(8),
    [sym_declaration] = STATE(8),
    [sym_type_definition] = STATE(8),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_linkage_specification] = STATE(8),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2601),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8164),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(515),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2792),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(628),
    [sym_statement] = STATE(8),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(8),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2672),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(8),
    [sym_template_instantiation] = STATE(8),
    [sym_operator_cast] = STATE(9172),
    [sym__constructor_specifiers] = STATE(2672),
    [sym_operator_cast_definition] = STATE(8),
    [sym_operator_cast_declaration] = STATE(8),
    [sym_constructor_or_destructor_definition] = STATE(8),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(8),
    [sym_namespace_alias_definition] = STATE(8),
    [sym_using_declaration] = STATE(8),
    [sym_alias_declaration] = STATE(8),
    [sym_static_assert_declaration] = STATE(8),
    [sym_concept_definition] = STATE(8),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9172),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(1616),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(8),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1188),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2672),
    [sym_identifier] = ACTIONS(287),
    [aux_sym_preproc_include_token1] = ACTIONS(289),
    [aux_sym_preproc_def_token1] = ACTIONS(291),
    [aux_sym_preproc_if_token1] = ACTIONS(293),
    [aux_sym_preproc_if_token2] = ACTIONS(371),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(297),
    [aux_sym_preproc_else_token1] = ACTIONS(299),
    [aux_sym_preproc_elif_token1] = ACTIONS(301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(303),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(303),
    [sym_preproc_directive] = ACTIONS(305),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(309),
    [anon_sym_typedef] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(313),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(319),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(347),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_namespace] = ACTIONS(353),
    [anon_sym_static_assert] = ACTIONS(355),
    [anon_sym_concept] = ACTIONS(357),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [11] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(11413),
    [sym_preproc_elif] = STATE(11413),
    [sym_preproc_elifdef] = STATE(11413),
    [sym_function_definition] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2601),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8164),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(515),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2792),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(628),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(27),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2672),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(27),
    [sym_template_instantiation] = STATE(27),
    [sym_operator_cast] = STATE(9172),
    [sym__constructor_specifiers] = STATE(2672),
    [sym_operator_cast_definition] = STATE(27),
    [sym_operator_cast_declaration] = STATE(27),
    [sym_constructor_or_destructor_definition] = STATE(27),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(27),
    [sym_namespace_alias_definition] = STATE(27),
    [sym_using_declaration] = STATE(27),
    [sym_alias_declaration] = STATE(27),
    [sym_static_assert_declaration] = STATE(27),
    [sym_concept_definition] = STATE(27),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9172),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(1616),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1188),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2672),
    [sym_identifier] = ACTIONS(287),
    [aux_sym_preproc_include_token1] = ACTIONS(289),
    [aux_sym_preproc_def_token1] = ACTIONS(291),
    [aux_sym_preproc_if_token1] = ACTIONS(293),
    [aux_sym_preproc_if_token2] = ACTIONS(373),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(297),
    [aux_sym_preproc_else_token1] = ACTIONS(299),
    [aux_sym_preproc_elif_token1] = ACTIONS(301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(303),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(303),
    [sym_preproc_directive] = ACTIONS(305),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(309),
    [anon_sym_typedef] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(313),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(319),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(347),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_namespace] = ACTIONS(353),
    [anon_sym_static_assert] = ACTIONS(355),
    [anon_sym_concept] = ACTIONS(357),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [12] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(10989),
    [sym_preproc_elif] = STATE(10989),
    [sym_preproc_elifdef] = STATE(10989),
    [sym_function_definition] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2601),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8164),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(515),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2792),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(628),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(27),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2672),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(27),
    [sym_template_instantiation] = STATE(27),
    [sym_operator_cast] = STATE(9172),
    [sym__constructor_specifiers] = STATE(2672),
    [sym_operator_cast_definition] = STATE(27),
    [sym_operator_cast_declaration] = STATE(27),
    [sym_constructor_or_destructor_definition] = STATE(27),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(27),
    [sym_namespace_alias_definition] = STATE(27),
    [sym_using_declaration] = STATE(27),
    [sym_alias_declaration] = STATE(27),
    [sym_static_assert_declaration] = STATE(27),
    [sym_concept_definition] = STATE(27),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9172),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(1616),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1188),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2672),
    [sym_identifier] = ACTIONS(287),
    [aux_sym_preproc_include_token1] = ACTIONS(289),
    [aux_sym_preproc_def_token1] = ACTIONS(291),
    [aux_sym_preproc_if_token1] = ACTIONS(293),
    [aux_sym_preproc_if_token2] = ACTIONS(375),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(297),
    [aux_sym_preproc_else_token1] = ACTIONS(299),
    [aux_sym_preproc_elif_token1] = ACTIONS(301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(303),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(303),
    [sym_preproc_directive] = ACTIONS(305),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(309),
    [anon_sym_typedef] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(313),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(319),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(347),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_namespace] = ACTIONS(353),
    [anon_sym_static_assert] = ACTIONS(355),
    [anon_sym_concept] = ACTIONS(357),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [13] = {
    [sym__block_item] = STATE(12),
    [sym_preproc_include] = STATE(12),
    [sym_preproc_def] = STATE(12),
    [sym_preproc_function_def] = STATE(12),
    [sym_preproc_call] = STATE(12),
    [sym_preproc_if] = STATE(12),
    [sym_preproc_ifdef] = STATE(12),
    [sym_preproc_else] = STATE(11443),
    [sym_preproc_elif] = STATE(11443),
    [sym_preproc_elifdef] = STATE(11443),
    [sym_function_definition] = STATE(12),
    [sym_declaration] = STATE(12),
    [sym_type_definition] = STATE(12),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_linkage_specification] = STATE(12),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2601),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8164),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(515),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2792),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(628),
    [sym_statement] = STATE(12),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(12),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2672),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(12),
    [sym_template_instantiation] = STATE(12),
    [sym_operator_cast] = STATE(9172),
    [sym__constructor_specifiers] = STATE(2672),
    [sym_operator_cast_definition] = STATE(12),
    [sym_operator_cast_declaration] = STATE(12),
    [sym_constructor_or_destructor_definition] = STATE(12),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(12),
    [sym_namespace_alias_definition] = STATE(12),
    [sym_using_declaration] = STATE(12),
    [sym_alias_declaration] = STATE(12),
    [sym_static_assert_declaration] = STATE(12),
    [sym_concept_definition] = STATE(12),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9172),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(1616),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(12),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1188),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2672),
    [sym_identifier] = ACTIONS(287),
    [aux_sym_preproc_include_token1] = ACTIONS(289),
    [aux_sym_preproc_def_token1] = ACTIONS(291),
    [aux_sym_preproc_if_token1] = ACTIONS(293),
    [aux_sym_preproc_if_token2] = ACTIONS(377),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(297),
    [aux_sym_preproc_else_token1] = ACTIONS(299),
    [aux_sym_preproc_elif_token1] = ACTIONS(301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(303),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(303),
    [sym_preproc_directive] = ACTIONS(305),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(309),
    [anon_sym_typedef] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(313),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(319),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(347),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_namespace] = ACTIONS(353),
    [anon_sym_static_assert] = ACTIONS(355),
    [anon_sym_concept] = ACTIONS(357),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [14] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(11172),
    [sym_preproc_elif] = STATE(11172),
    [sym_preproc_elifdef] = STATE(11172),
    [sym_function_definition] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2601),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8164),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(515),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2792),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(628),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(27),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2672),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(27),
    [sym_template_instantiation] = STATE(27),
    [sym_operator_cast] = STATE(9172),
    [sym__constructor_specifiers] = STATE(2672),
    [sym_operator_cast_definition] = STATE(27),
    [sym_operator_cast_declaration] = STATE(27),
    [sym_constructor_or_destructor_definition] = STATE(27),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(27),
    [sym_namespace_alias_definition] = STATE(27),
    [sym_using_declaration] = STATE(27),
    [sym_alias_declaration] = STATE(27),
    [sym_static_assert_declaration] = STATE(27),
    [sym_concept_definition] = STATE(27),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9172),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(1616),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1188),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2672),
    [sym_identifier] = ACTIONS(287),
    [aux_sym_preproc_include_token1] = ACTIONS(289),
    [aux_sym_preproc_def_token1] = ACTIONS(291),
    [aux_sym_preproc_if_token1] = ACTIONS(293),
    [aux_sym_preproc_if_token2] = ACTIONS(379),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(297),
    [aux_sym_preproc_else_token1] = ACTIONS(299),
    [aux_sym_preproc_elif_token1] = ACTIONS(301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(303),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(303),
    [sym_preproc_directive] = ACTIONS(305),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(309),
    [anon_sym_typedef] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(313),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(319),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(347),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_namespace] = ACTIONS(353),
    [anon_sym_static_assert] = ACTIONS(355),
    [anon_sym_concept] = ACTIONS(357),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [15] = {
    [sym__block_item] = STATE(16),
    [sym_preproc_include] = STATE(16),
    [sym_preproc_def] = STATE(16),
    [sym_preproc_function_def] = STATE(16),
    [sym_preproc_call] = STATE(16),
    [sym_preproc_if] = STATE(16),
    [sym_preproc_ifdef] = STATE(16),
    [sym_preproc_else] = STATE(11370),
    [sym_preproc_elif] = STATE(11370),
    [sym_preproc_elifdef] = STATE(11370),
    [sym_function_definition] = STATE(16),
    [sym_declaration] = STATE(16),
    [sym_type_definition] = STATE(16),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_linkage_specification] = STATE(16),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2601),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8164),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(515),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2792),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(628),
    [sym_statement] = STATE(16),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(16),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2672),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(16),
    [sym_template_instantiation] = STATE(16),
    [sym_operator_cast] = STATE(9172),
    [sym__constructor_specifiers] = STATE(2672),
    [sym_operator_cast_definition] = STATE(16),
    [sym_operator_cast_declaration] = STATE(16),
    [sym_constructor_or_destructor_definition] = STATE(16),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(16),
    [sym_namespace_alias_definition] = STATE(16),
    [sym_using_declaration] = STATE(16),
    [sym_alias_declaration] = STATE(16),
    [sym_static_assert_declaration] = STATE(16),
    [sym_concept_definition] = STATE(16),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9172),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(1616),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(16),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1188),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2672),
    [sym_identifier] = ACTIONS(287),
    [aux_sym_preproc_include_token1] = ACTIONS(289),
    [aux_sym_preproc_def_token1] = ACTIONS(291),
    [aux_sym_preproc_if_token1] = ACTIONS(293),
    [aux_sym_preproc_if_token2] = ACTIONS(381),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(297),
    [aux_sym_preproc_else_token1] = ACTIONS(299),
    [aux_sym_preproc_elif_token1] = ACTIONS(301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(303),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(303),
    [sym_preproc_directive] = ACTIONS(305),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(309),
    [anon_sym_typedef] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(313),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(319),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(347),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_namespace] = ACTIONS(353),
    [anon_sym_static_assert] = ACTIONS(355),
    [anon_sym_concept] = ACTIONS(357),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [16] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(11141),
    [sym_preproc_elif] = STATE(11141),
    [sym_preproc_elifdef] = STATE(11141),
    [sym_function_definition] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2601),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8164),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(515),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2792),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(628),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(27),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2672),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(27),
    [sym_template_instantiation] = STATE(27),
    [sym_operator_cast] = STATE(9172),
    [sym__constructor_specifiers] = STATE(2672),
    [sym_operator_cast_definition] = STATE(27),
    [sym_operator_cast_declaration] = STATE(27),
    [sym_constructor_or_destructor_definition] = STATE(27),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(27),
    [sym_namespace_alias_definition] = STATE(27),
    [sym_using_declaration] = STATE(27),
    [sym_alias_declaration] = STATE(27),
    [sym_static_assert_declaration] = STATE(27),
    [sym_concept_definition] = STATE(27),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9172),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(1616),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1188),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2672),
    [sym_identifier] = ACTIONS(287),
    [aux_sym_preproc_include_token1] = ACTIONS(289),
    [aux_sym_preproc_def_token1] = ACTIONS(291),
    [aux_sym_preproc_if_token1] = ACTIONS(293),
    [aux_sym_preproc_if_token2] = ACTIONS(383),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(297),
    [aux_sym_preproc_else_token1] = ACTIONS(299),
    [aux_sym_preproc_elif_token1] = ACTIONS(301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(303),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(303),
    [sym_preproc_directive] = ACTIONS(305),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(309),
    [anon_sym_typedef] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(313),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(319),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(347),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_namespace] = ACTIONS(353),
    [anon_sym_static_assert] = ACTIONS(355),
    [anon_sym_concept] = ACTIONS(357),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [17] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(11498),
    [sym_preproc_elif] = STATE(11498),
    [sym_preproc_elifdef] = STATE(11498),
    [sym_function_definition] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2601),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8164),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(515),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2792),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(628),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(27),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2672),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(27),
    [sym_template_instantiation] = STATE(27),
    [sym_operator_cast] = STATE(9172),
    [sym__constructor_specifiers] = STATE(2672),
    [sym_operator_cast_definition] = STATE(27),
    [sym_operator_cast_declaration] = STATE(27),
    [sym_constructor_or_destructor_definition] = STATE(27),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(27),
    [sym_namespace_alias_definition] = STATE(27),
    [sym_using_declaration] = STATE(27),
    [sym_alias_declaration] = STATE(27),
    [sym_static_assert_declaration] = STATE(27),
    [sym_concept_definition] = STATE(27),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9172),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(1616),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1188),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2672),
    [sym_identifier] = ACTIONS(287),
    [aux_sym_preproc_include_token1] = ACTIONS(289),
    [aux_sym_preproc_def_token1] = ACTIONS(291),
    [aux_sym_preproc_if_token1] = ACTIONS(293),
    [aux_sym_preproc_if_token2] = ACTIONS(385),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(297),
    [aux_sym_preproc_else_token1] = ACTIONS(299),
    [aux_sym_preproc_elif_token1] = ACTIONS(301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(303),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(303),
    [sym_preproc_directive] = ACTIONS(305),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(309),
    [anon_sym_typedef] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(313),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(319),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(347),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_namespace] = ACTIONS(353),
    [anon_sym_static_assert] = ACTIONS(355),
    [anon_sym_concept] = ACTIONS(357),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [18] = {
    [sym__block_item] = STATE(20),
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(10910),
    [sym_preproc_elif] = STATE(10910),
    [sym_preproc_elifdef] = STATE(10910),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2601),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8164),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(515),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2792),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(628),
    [sym_statement] = STATE(20),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(20),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2672),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(20),
    [sym_template_instantiation] = STATE(20),
    [sym_operator_cast] = STATE(9172),
    [sym__constructor_specifiers] = STATE(2672),
    [sym_operator_cast_definition] = STATE(20),
    [sym_operator_cast_declaration] = STATE(20),
    [sym_constructor_or_destructor_definition] = STATE(20),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(20),
    [sym_namespace_alias_definition] = STATE(20),
    [sym_using_declaration] = STATE(20),
    [sym_alias_declaration] = STATE(20),
    [sym_static_assert_declaration] = STATE(20),
    [sym_concept_definition] = STATE(20),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9172),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(1616),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1188),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2672),
    [sym_identifier] = ACTIONS(287),
    [aux_sym_preproc_include_token1] = ACTIONS(289),
    [aux_sym_preproc_def_token1] = ACTIONS(291),
    [aux_sym_preproc_if_token1] = ACTIONS(293),
    [aux_sym_preproc_if_token2] = ACTIONS(387),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(297),
    [aux_sym_preproc_else_token1] = ACTIONS(299),
    [aux_sym_preproc_elif_token1] = ACTIONS(301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(303),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(303),
    [sym_preproc_directive] = ACTIONS(305),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(309),
    [anon_sym_typedef] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(313),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(319),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(347),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_namespace] = ACTIONS(353),
    [anon_sym_static_assert] = ACTIONS(355),
    [anon_sym_concept] = ACTIONS(357),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [19] = {
    [sym__block_item] = STATE(17),
    [sym_preproc_include] = STATE(17),
    [sym_preproc_def] = STATE(17),
    [sym_preproc_function_def] = STATE(17),
    [sym_preproc_call] = STATE(17),
    [sym_preproc_if] = STATE(17),
    [sym_preproc_ifdef] = STATE(17),
    [sym_preproc_else] = STATE(11131),
    [sym_preproc_elif] = STATE(11131),
    [sym_preproc_elifdef] = STATE(11131),
    [sym_function_definition] = STATE(17),
    [sym_declaration] = STATE(17),
    [sym_type_definition] = STATE(17),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_linkage_specification] = STATE(17),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2601),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8164),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(515),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2792),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(628),
    [sym_statement] = STATE(17),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(17),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2672),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(17),
    [sym_template_instantiation] = STATE(17),
    [sym_operator_cast] = STATE(9172),
    [sym__constructor_specifiers] = STATE(2672),
    [sym_operator_cast_definition] = STATE(17),
    [sym_operator_cast_declaration] = STATE(17),
    [sym_constructor_or_destructor_definition] = STATE(17),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(17),
    [sym_namespace_alias_definition] = STATE(17),
    [sym_using_declaration] = STATE(17),
    [sym_alias_declaration] = STATE(17),
    [sym_static_assert_declaration] = STATE(17),
    [sym_concept_definition] = STATE(17),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9172),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(1616),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(17),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1188),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2672),
    [sym_identifier] = ACTIONS(287),
    [aux_sym_preproc_include_token1] = ACTIONS(289),
    [aux_sym_preproc_def_token1] = ACTIONS(291),
    [aux_sym_preproc_if_token1] = ACTIONS(293),
    [aux_sym_preproc_if_token2] = ACTIONS(389),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(297),
    [aux_sym_preproc_else_token1] = ACTIONS(299),
    [aux_sym_preproc_elif_token1] = ACTIONS(301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(303),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(303),
    [sym_preproc_directive] = ACTIONS(305),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(309),
    [anon_sym_typedef] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(313),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(319),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(347),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_namespace] = ACTIONS(353),
    [anon_sym_static_assert] = ACTIONS(355),
    [anon_sym_concept] = ACTIONS(357),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [20] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(11082),
    [sym_preproc_elif] = STATE(11082),
    [sym_preproc_elifdef] = STATE(11082),
    [sym_function_definition] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2601),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8164),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(515),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2792),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(628),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(27),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2672),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(27),
    [sym_template_instantiation] = STATE(27),
    [sym_operator_cast] = STATE(9172),
    [sym__constructor_specifiers] = STATE(2672),
    [sym_operator_cast_definition] = STATE(27),
    [sym_operator_cast_declaration] = STATE(27),
    [sym_constructor_or_destructor_definition] = STATE(27),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(27),
    [sym_namespace_alias_definition] = STATE(27),
    [sym_using_declaration] = STATE(27),
    [sym_alias_declaration] = STATE(27),
    [sym_static_assert_declaration] = STATE(27),
    [sym_concept_definition] = STATE(27),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9172),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(1616),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1188),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2672),
    [sym_identifier] = ACTIONS(287),
    [aux_sym_preproc_include_token1] = ACTIONS(289),
    [aux_sym_preproc_def_token1] = ACTIONS(291),
    [aux_sym_preproc_if_token1] = ACTIONS(293),
    [aux_sym_preproc_if_token2] = ACTIONS(391),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(297),
    [aux_sym_preproc_else_token1] = ACTIONS(299),
    [aux_sym_preproc_elif_token1] = ACTIONS(301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(303),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(303),
    [sym_preproc_directive] = ACTIONS(305),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(309),
    [anon_sym_typedef] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(313),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(319),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(347),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_namespace] = ACTIONS(353),
    [anon_sym_static_assert] = ACTIONS(355),
    [anon_sym_concept] = ACTIONS(357),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [21] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(10896),
    [sym_preproc_elif] = STATE(10896),
    [sym_preproc_elifdef] = STATE(10896),
    [sym_function_definition] = STATE(22),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2601),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8164),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(515),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2792),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(628),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(22),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2672),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(22),
    [sym_template_instantiation] = STATE(22),
    [sym_operator_cast] = STATE(9172),
    [sym__constructor_specifiers] = STATE(2672),
    [sym_operator_cast_definition] = STATE(22),
    [sym_operator_cast_declaration] = STATE(22),
    [sym_constructor_or_destructor_definition] = STATE(22),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(22),
    [sym_namespace_alias_definition] = STATE(22),
    [sym_using_declaration] = STATE(22),
    [sym_alias_declaration] = STATE(22),
    [sym_static_assert_declaration] = STATE(22),
    [sym_concept_definition] = STATE(22),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9172),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(1616),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1188),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2672),
    [sym_identifier] = ACTIONS(287),
    [aux_sym_preproc_include_token1] = ACTIONS(289),
    [aux_sym_preproc_def_token1] = ACTIONS(291),
    [aux_sym_preproc_if_token1] = ACTIONS(293),
    [aux_sym_preproc_if_token2] = ACTIONS(393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(297),
    [aux_sym_preproc_else_token1] = ACTIONS(299),
    [aux_sym_preproc_elif_token1] = ACTIONS(301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(303),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(303),
    [sym_preproc_directive] = ACTIONS(305),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(309),
    [anon_sym_typedef] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(313),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(319),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(347),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_namespace] = ACTIONS(353),
    [anon_sym_static_assert] = ACTIONS(355),
    [anon_sym_concept] = ACTIONS(357),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [22] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(11076),
    [sym_preproc_elif] = STATE(11076),
    [sym_preproc_elifdef] = STATE(11076),
    [sym_function_definition] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2601),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8164),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(515),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2792),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(628),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(27),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2672),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(27),
    [sym_template_instantiation] = STATE(27),
    [sym_operator_cast] = STATE(9172),
    [sym__constructor_specifiers] = STATE(2672),
    [sym_operator_cast_definition] = STATE(27),
    [sym_operator_cast_declaration] = STATE(27),
    [sym_constructor_or_destructor_definition] = STATE(27),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(27),
    [sym_namespace_alias_definition] = STATE(27),
    [sym_using_declaration] = STATE(27),
    [sym_alias_declaration] = STATE(27),
    [sym_static_assert_declaration] = STATE(27),
    [sym_concept_definition] = STATE(27),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9172),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(1616),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1188),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2672),
    [sym_identifier] = ACTIONS(287),
    [aux_sym_preproc_include_token1] = ACTIONS(289),
    [aux_sym_preproc_def_token1] = ACTIONS(291),
    [aux_sym_preproc_if_token1] = ACTIONS(293),
    [aux_sym_preproc_if_token2] = ACTIONS(395),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(297),
    [aux_sym_preproc_else_token1] = ACTIONS(299),
    [aux_sym_preproc_elif_token1] = ACTIONS(301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(303),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(303),
    [sym_preproc_directive] = ACTIONS(305),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(309),
    [anon_sym_typedef] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(313),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(319),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(347),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_namespace] = ACTIONS(353),
    [anon_sym_static_assert] = ACTIONS(355),
    [anon_sym_concept] = ACTIONS(357),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [23] = {
    [sym__block_item] = STATE(25),
    [sym_preproc_include] = STATE(25),
    [sym_preproc_def] = STATE(25),
    [sym_preproc_function_def] = STATE(25),
    [sym_preproc_call] = STATE(25),
    [sym_preproc_if] = STATE(25),
    [sym_preproc_ifdef] = STATE(25),
    [sym_preproc_else] = STATE(11514),
    [sym_preproc_elif] = STATE(11514),
    [sym_preproc_elifdef] = STATE(11514),
    [sym_function_definition] = STATE(25),
    [sym_declaration] = STATE(25),
    [sym_type_definition] = STATE(25),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_linkage_specification] = STATE(25),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2601),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8164),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(515),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2792),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(628),
    [sym_statement] = STATE(25),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(25),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2672),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(25),
    [sym_template_instantiation] = STATE(25),
    [sym_operator_cast] = STATE(9172),
    [sym__constructor_specifiers] = STATE(2672),
    [sym_operator_cast_definition] = STATE(25),
    [sym_operator_cast_declaration] = STATE(25),
    [sym_constructor_or_destructor_definition] = STATE(25),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(25),
    [sym_namespace_alias_definition] = STATE(25),
    [sym_using_declaration] = STATE(25),
    [sym_alias_declaration] = STATE(25),
    [sym_static_assert_declaration] = STATE(25),
    [sym_concept_definition] = STATE(25),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9172),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(1616),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(25),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1188),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2672),
    [sym_identifier] = ACTIONS(287),
    [aux_sym_preproc_include_token1] = ACTIONS(289),
    [aux_sym_preproc_def_token1] = ACTIONS(291),
    [aux_sym_preproc_if_token1] = ACTIONS(293),
    [aux_sym_preproc_if_token2] = ACTIONS(397),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(297),
    [aux_sym_preproc_else_token1] = ACTIONS(299),
    [aux_sym_preproc_elif_token1] = ACTIONS(301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(303),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(303),
    [sym_preproc_directive] = ACTIONS(305),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(309),
    [anon_sym_typedef] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(313),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(319),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(347),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_namespace] = ACTIONS(353),
    [anon_sym_static_assert] = ACTIONS(355),
    [anon_sym_concept] = ACTIONS(357),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [24] = {
    [sym__block_item] = STATE(26),
    [sym_preproc_include] = STATE(26),
    [sym_preproc_def] = STATE(26),
    [sym_preproc_function_def] = STATE(26),
    [sym_preproc_call] = STATE(26),
    [sym_preproc_if] = STATE(26),
    [sym_preproc_ifdef] = STATE(26),
    [sym_preproc_else] = STATE(11496),
    [sym_preproc_elif] = STATE(11496),
    [sym_preproc_elifdef] = STATE(11496),
    [sym_function_definition] = STATE(26),
    [sym_declaration] = STATE(26),
    [sym_type_definition] = STATE(26),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_linkage_specification] = STATE(26),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2601),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8164),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(515),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2792),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(628),
    [sym_statement] = STATE(26),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(26),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2672),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(26),
    [sym_template_instantiation] = STATE(26),
    [sym_operator_cast] = STATE(9172),
    [sym__constructor_specifiers] = STATE(2672),
    [sym_operator_cast_definition] = STATE(26),
    [sym_operator_cast_declaration] = STATE(26),
    [sym_constructor_or_destructor_definition] = STATE(26),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(26),
    [sym_namespace_alias_definition] = STATE(26),
    [sym_using_declaration] = STATE(26),
    [sym_alias_declaration] = STATE(26),
    [sym_static_assert_declaration] = STATE(26),
    [sym_concept_definition] = STATE(26),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9172),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(1616),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(26),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1188),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2672),
    [sym_identifier] = ACTIONS(287),
    [aux_sym_preproc_include_token1] = ACTIONS(289),
    [aux_sym_preproc_def_token1] = ACTIONS(291),
    [aux_sym_preproc_if_token1] = ACTIONS(293),
    [aux_sym_preproc_if_token2] = ACTIONS(399),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(297),
    [aux_sym_preproc_else_token1] = ACTIONS(299),
    [aux_sym_preproc_elif_token1] = ACTIONS(301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(303),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(303),
    [sym_preproc_directive] = ACTIONS(305),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(309),
    [anon_sym_typedef] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(313),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(319),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(347),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_namespace] = ACTIONS(353),
    [anon_sym_static_assert] = ACTIONS(355),
    [anon_sym_concept] = ACTIONS(357),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [25] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(11512),
    [sym_preproc_elif] = STATE(11512),
    [sym_preproc_elifdef] = STATE(11512),
    [sym_function_definition] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2601),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8164),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(515),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2792),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(628),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(27),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2672),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(27),
    [sym_template_instantiation] = STATE(27),
    [sym_operator_cast] = STATE(9172),
    [sym__constructor_specifiers] = STATE(2672),
    [sym_operator_cast_definition] = STATE(27),
    [sym_operator_cast_declaration] = STATE(27),
    [sym_constructor_or_destructor_definition] = STATE(27),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(27),
    [sym_namespace_alias_definition] = STATE(27),
    [sym_using_declaration] = STATE(27),
    [sym_alias_declaration] = STATE(27),
    [sym_static_assert_declaration] = STATE(27),
    [sym_concept_definition] = STATE(27),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9172),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(1616),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1188),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2672),
    [sym_identifier] = ACTIONS(287),
    [aux_sym_preproc_include_token1] = ACTIONS(289),
    [aux_sym_preproc_def_token1] = ACTIONS(291),
    [aux_sym_preproc_if_token1] = ACTIONS(293),
    [aux_sym_preproc_if_token2] = ACTIONS(401),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(297),
    [aux_sym_preproc_else_token1] = ACTIONS(299),
    [aux_sym_preproc_elif_token1] = ACTIONS(301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(303),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(303),
    [sym_preproc_directive] = ACTIONS(305),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(309),
    [anon_sym_typedef] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(313),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(319),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(347),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_namespace] = ACTIONS(353),
    [anon_sym_static_assert] = ACTIONS(355),
    [anon_sym_concept] = ACTIONS(357),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [26] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(11265),
    [sym_preproc_elif] = STATE(11265),
    [sym_preproc_elifdef] = STATE(11265),
    [sym_function_definition] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2601),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8164),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(515),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2792),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(628),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(27),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2672),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(27),
    [sym_template_instantiation] = STATE(27),
    [sym_operator_cast] = STATE(9172),
    [sym__constructor_specifiers] = STATE(2672),
    [sym_operator_cast_definition] = STATE(27),
    [sym_operator_cast_declaration] = STATE(27),
    [sym_constructor_or_destructor_definition] = STATE(27),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(27),
    [sym_namespace_alias_definition] = STATE(27),
    [sym_using_declaration] = STATE(27),
    [sym_alias_declaration] = STATE(27),
    [sym_static_assert_declaration] = STATE(27),
    [sym_concept_definition] = STATE(27),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9172),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(1616),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1188),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2672),
    [sym_identifier] = ACTIONS(287),
    [aux_sym_preproc_include_token1] = ACTIONS(289),
    [aux_sym_preproc_def_token1] = ACTIONS(291),
    [aux_sym_preproc_if_token1] = ACTIONS(293),
    [aux_sym_preproc_if_token2] = ACTIONS(403),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(297),
    [aux_sym_preproc_else_token1] = ACTIONS(299),
    [aux_sym_preproc_elif_token1] = ACTIONS(301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(303),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(303),
    [sym_preproc_directive] = ACTIONS(305),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(309),
    [anon_sym_typedef] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(313),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(315),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(319),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(347),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_namespace] = ACTIONS(353),
    [anon_sym_static_assert] = ACTIONS(355),
    [anon_sym_concept] = ACTIONS(357),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [27] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_function_definition] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2601),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8164),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(515),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2792),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(628),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(27),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2672),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(27),
    [sym_template_instantiation] = STATE(27),
    [sym_operator_cast] = STATE(9172),
    [sym__constructor_specifiers] = STATE(2672),
    [sym_operator_cast_definition] = STATE(27),
    [sym_operator_cast_declaration] = STATE(27),
    [sym_constructor_or_destructor_definition] = STATE(27),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(27),
    [sym_namespace_alias_definition] = STATE(27),
    [sym_using_declaration] = STATE(27),
    [sym_alias_declaration] = STATE(27),
    [sym_static_assert_declaration] = STATE(27),
    [sym_concept_definition] = STATE(27),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9172),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(1616),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1188),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2672),
    [sym_identifier] = ACTIONS(405),
    [aux_sym_preproc_include_token1] = ACTIONS(408),
    [aux_sym_preproc_def_token1] = ACTIONS(411),
    [aux_sym_preproc_if_token1] = ACTIONS(414),
    [aux_sym_preproc_if_token2] = ACTIONS(417),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(419),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(419),
    [aux_sym_preproc_else_token1] = ACTIONS(417),
    [aux_sym_preproc_elif_token1] = ACTIONS(417),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(417),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(417),
    [sym_preproc_directive] = ACTIONS(422),
    [anon_sym_LPAREN2] = ACTIONS(425),
    [anon_sym_BANG] = ACTIONS(428),
    [anon_sym_TILDE] = ACTIONS(431),
    [anon_sym_DASH] = ACTIONS(434),
    [anon_sym_PLUS] = ACTIONS(434),
    [anon_sym_STAR] = ACTIONS(437),
    [anon_sym_AMP_AMP] = ACTIONS(440),
    [anon_sym_AMP] = ACTIONS(443),
    [anon_sym_SEMI] = ACTIONS(446),
    [anon_sym___extension__] = ACTIONS(449),
    [anon_sym_typedef] = ACTIONS(452),
    [anon_sym_in] = ACTIONS(455),
    [anon_sym_out] = ACTIONS(455),
    [anon_sym_inout] = ACTIONS(455),
    [anon_sym_virtual] = ACTIONS(455),
    [anon_sym_extern] = ACTIONS(458),
    [anon_sym___attribute__] = ACTIONS(461),
    [anon_sym___attribute] = ACTIONS(461),
    [anon_sym_using] = ACTIONS(464),
    [anon_sym_COLON_COLON] = ACTIONS(467),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(470),
    [anon_sym___declspec] = ACTIONS(473),
    [anon_sym___based] = ACTIONS(476),
    [anon_sym___cdecl] = ACTIONS(479),
    [anon_sym___clrcall] = ACTIONS(479),
    [anon_sym___stdcall] = ACTIONS(479),
    [anon_sym___fastcall] = ACTIONS(479),
    [anon_sym___thiscall] = ACTIONS(479),
    [anon_sym___vectorcall] = ACTIONS(479),
    [anon_sym_LBRACE] = ACTIONS(482),
    [anon_sym_signed] = ACTIONS(485),
    [anon_sym_unsigned] = ACTIONS(485),
    [anon_sym_long] = ACTIONS(485),
    [anon_sym_short] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_register] = ACTIONS(491),
    [anon_sym_inline] = ACTIONS(494),
    [anon_sym___inline] = ACTIONS(491),
    [anon_sym___inline__] = ACTIONS(491),
    [anon_sym___forceinline] = ACTIONS(491),
    [anon_sym_thread_local] = ACTIONS(491),
    [anon_sym___thread] = ACTIONS(491),
    [anon_sym_const] = ACTIONS(497),
    [anon_sym_constexpr] = ACTIONS(497),
    [anon_sym_volatile] = ACTIONS(497),
    [anon_sym_restrict] = ACTIONS(497),
    [anon_sym___restrict__] = ACTIONS(497),
    [anon_sym__Atomic] = ACTIONS(497),
    [anon_sym__Noreturn] = ACTIONS(497),
    [anon_sym_noreturn] = ACTIONS(497),
    [anon_sym__Nonnull] = ACTIONS(497),
    [anon_sym_mutable] = ACTIONS(497),
    [anon_sym_constinit] = ACTIONS(497),
    [anon_sym_consteval] = ACTIONS(497),
    [anon_sym_alignas] = ACTIONS(500),
    [anon_sym__Alignas] = ACTIONS(500),
    [sym_primitive_type] = ACTIONS(503),
    [anon_sym_enum] = ACTIONS(506),
    [anon_sym_class] = ACTIONS(509),
    [anon_sym_struct] = ACTIONS(512),
    [anon_sym_union] = ACTIONS(515),
    [anon_sym_if] = ACTIONS(518),
    [anon_sym_switch] = ACTIONS(521),
    [anon_sym_case] = ACTIONS(524),
    [anon_sym_default] = ACTIONS(527),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(533),
    [anon_sym_for] = ACTIONS(536),
    [anon_sym_return] = ACTIONS(539),
    [anon_sym_break] = ACTIONS(542),
    [anon_sym_continue] = ACTIONS(545),
    [anon_sym_goto] = ACTIONS(548),
    [anon_sym___try] = ACTIONS(551),
    [anon_sym___leave] = ACTIONS(554),
    [anon_sym_not] = ACTIONS(434),
    [anon_sym_compl] = ACTIONS(434),
    [anon_sym_DASH_DASH] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(557),
    [anon_sym_sizeof] = ACTIONS(560),
    [anon_sym___alignof__] = ACTIONS(563),
    [anon_sym___alignof] = ACTIONS(563),
    [anon_sym__alignof] = ACTIONS(563),
    [anon_sym_alignof] = ACTIONS(563),
    [anon_sym__Alignof] = ACTIONS(563),
    [anon_sym_offsetof] = ACTIONS(566),
    [anon_sym__Generic] = ACTIONS(569),
    [anon_sym_asm] = ACTIONS(572),
    [anon_sym___asm__] = ACTIONS(572),
    [anon_sym___asm] = ACTIONS(572),
    [sym_number_literal] = ACTIONS(575),
    [anon_sym_L_SQUOTE] = ACTIONS(578),
    [anon_sym_u_SQUOTE] = ACTIONS(578),
    [anon_sym_U_SQUOTE] = ACTIONS(578),
    [anon_sym_u8_SQUOTE] = ACTIONS(578),
    [anon_sym_SQUOTE] = ACTIONS(578),
    [anon_sym_L_DQUOTE] = ACTIONS(581),
    [anon_sym_u_DQUOTE] = ACTIONS(581),
    [anon_sym_U_DQUOTE] = ACTIONS(581),
    [anon_sym_u8_DQUOTE] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(581),
    [sym_true] = ACTIONS(584),
    [sym_false] = ACTIONS(584),
    [anon_sym_NULL] = ACTIONS(587),
    [anon_sym_nullptr] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(590),
    [anon_sym_let] = ACTIONS(590),
    [anon_sym_This] = ACTIONS(590),
    [anon_sym_decltype] = ACTIONS(593),
    [anon_sym_explicit] = ACTIONS(596),
    [anon_sym_typename] = ACTIONS(599),
    [anon_sym_template] = ACTIONS(602),
    [anon_sym_operator] = ACTIONS(605),
    [anon_sym_try] = ACTIONS(608),
    [anon_sym_delete] = ACTIONS(611),
    [anon_sym_throw] = ACTIONS(614),
    [anon_sym_namespace] = ACTIONS(617),
    [anon_sym_static_assert] = ACTIONS(620),
    [anon_sym_concept] = ACTIONS(623),
    [anon_sym_co_return] = ACTIONS(626),
    [anon_sym_co_yield] = ACTIONS(629),
    [anon_sym_R_DQUOTE] = ACTIONS(632),
    [anon_sym_LR_DQUOTE] = ACTIONS(632),
    [anon_sym_uR_DQUOTE] = ACTIONS(632),
    [anon_sym_UR_DQUOTE] = ACTIONS(632),
    [anon_sym_u8R_DQUOTE] = ACTIONS(632),
    [anon_sym_co_await] = ACTIONS(635),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_requires] = ACTIONS(641),
    [sym_this] = ACTIONS(584),
    [anon_sym_discard] = ACTIONS(644),
    [anon_sym_precise] = ACTIONS(647),
    [anon_sym_shared] = ACTIONS(647),
    [anon_sym_groupshared] = ACTIONS(647),
    [anon_sym_uniform] = ACTIONS(647),
    [anon_sym_row_major] = ACTIONS(647),
    [anon_sym_column_major] = ACTIONS(647),
    [anon_sym_globallycoherent] = ACTIONS(647),
    [anon_sym_centroid] = ACTIONS(647),
    [anon_sym_noperspective] = ACTIONS(647),
    [anon_sym_nointerpolation] = ACTIONS(647),
    [anon_sym_sample] = ACTIONS(647),
    [anon_sym_linear] = ACTIONS(647),
    [anon_sym_snorm] = ACTIONS(647),
    [anon_sym_unorm] = ACTIONS(647),
    [anon_sym_point] = ACTIONS(647),
    [anon_sym_line] = ACTIONS(647),
    [anon_sym_triangleadj] = ACTIONS(647),
    [anon_sym_lineadj] = ACTIONS(647),
    [anon_sym_triangle] = ACTIONS(647),
    [anon_sym_cbuffer] = ACTIONS(650),
    [anon_sym_interface] = ACTIONS(653),
    [anon_sym_extension] = ACTIONS(656),
  },
  [28] = {
    [sym__top_level_item] = STATE(28),
    [sym_preproc_include] = STATE(28),
    [sym_preproc_def] = STATE(28),
    [sym_preproc_function_def] = STATE(28),
    [sym_preproc_call] = STATE(28),
    [sym_preproc_if] = STATE(28),
    [sym_preproc_ifdef] = STATE(28),
    [sym_function_definition] = STATE(28),
    [sym_declaration] = STATE(28),
    [sym_type_definition] = STATE(28),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6100),
    [sym_linkage_specification] = STATE(28),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2234),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8014),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(28),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(247),
    [sym_sized_type_specifier] = STATE(315),
    [sym_enum_specifier] = STATE(315),
    [sym_struct_specifier] = STATE(315),
    [sym_union_specifier] = STATE(315),
    [sym_attributed_statement] = STATE(1008),
    [sym__top_level_statement] = STATE(28),
    [sym_labeled_statement] = STATE(28),
    [sym__top_level_expression_statement] = STATE(28),
    [sym_if_statement] = STATE(28),
    [sym_switch_statement] = STATE(28),
    [sym_case_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_do_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_return_statement] = STATE(28),
    [sym_break_statement] = STATE(28),
    [sym_continue_statement] = STATE(28),
    [sym_goto_statement] = STATE(28),
    [sym_expression] = STATE(6128),
    [sym__string] = STATE(6105),
    [sym_conditional_expression] = STATE(6219),
    [sym_assignment_expression] = STATE(6219),
    [sym_pointer_expression] = STATE(4822),
    [sym_unary_expression] = STATE(6219),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(6219),
    [sym_cast_expression] = STATE(6219),
    [sym_sizeof_expression] = STATE(6219),
    [sym_alignof_expression] = STATE(6219),
    [sym_offsetof_expression] = STATE(6219),
    [sym_generic_expression] = STATE(6219),
    [sym_subscript_expression] = STATE(4822),
    [sym_call_expression] = STATE(4822),
    [sym_gnu_asm_expression] = STATE(6219),
    [sym_extension_expression] = STATE(6219),
    [sym_field_expression] = STATE(4822),
    [sym_compound_literal_expression] = STATE(6219),
    [sym_parenthesized_expression] = STATE(4822),
    [sym_char_literal] = STATE(6105),
    [sym_concatenated_string] = STATE(6105),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(6219),
    [sym__empty_declaration] = STATE(28),
    [sym_placeholder_type_specifier] = STATE(315),
    [sym_decltype] = STATE(256),
    [sym_class_specifier] = STATE(315),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2678),
    [sym_dependent_type] = STATE(315),
    [sym_module_declaration] = STATE(28),
    [sym_export_declaration] = STATE(28),
    [sym_import_declaration] = STATE(28),
    [sym_global_module_fragment_declaration] = STATE(28),
    [sym_private_module_fragment_declaration] = STATE(28),
    [sym_template_declaration] = STATE(28),
    [sym_template_instantiation] = STATE(28),
    [sym_operator_cast] = STATE(9025),
    [sym__constructor_specifiers] = STATE(2678),
    [sym_operator_cast_definition] = STATE(28),
    [sym_operator_cast_declaration] = STATE(28),
    [sym_constructor_or_destructor_definition] = STATE(28),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(831),
    [sym_template_function] = STATE(6081),
    [sym_namespace_definition] = STATE(28),
    [sym_namespace_alias_definition] = STATE(28),
    [sym_using_declaration] = STATE(28),
    [sym_alias_declaration] = STATE(28),
    [sym_static_assert_declaration] = STATE(28),
    [sym_concept_definition] = STATE(28),
    [sym_for_range_loop] = STATE(28),
    [sym_co_return_statement] = STATE(28),
    [sym_co_yield_statement] = STATE(28),
    [sym_throw_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(6219),
    [sym_new_expression] = STATE(6219),
    [sym_delete_expression] = STATE(6219),
    [sym_requires_clause] = STATE(6219),
    [sym_requires_expression] = STATE(6219),
    [sym_lambda_expression] = STATE(6219),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(6219),
    [sym_parameter_pack_expansion] = STATE(6219),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6985),
    [sym_qualified_identifier] = STATE(4704),
    [sym_qualified_type_identifier] = STATE(841),
    [sym_qualified_operator_cast_identifier] = STATE(9025),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4822),
    [sym_qualifiers] = STATE(2919),
    [sym_hlsl_attribute] = STATE(1611),
    [sym_interface_specifier] = STATE(315),
    [sym_extension_specifier] = STATE(315),
    [sym_import_statement] = STATE(28),
    [sym_associatedtype_specifier] = STATE(315),
    [aux_sym_translation_unit_repeat1] = STATE(28),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1189),
    [aux_sym_sized_type_specifier_repeat1] = STATE(389),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2678),
    [ts_builtin_sym_end] = ACTIONS(659),
    [sym_identifier] = ACTIONS(661),
    [aux_sym_preproc_include_token1] = ACTIONS(664),
    [aux_sym_preproc_def_token1] = ACTIONS(667),
    [aux_sym_preproc_if_token1] = ACTIONS(670),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(673),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(673),
    [sym_preproc_directive] = ACTIONS(676),
    [anon_sym_LPAREN2] = ACTIONS(679),
    [anon_sym_BANG] = ACTIONS(682),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_DASH] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(688),
    [anon_sym_STAR] = ACTIONS(691),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(697),
    [anon_sym_SEMI] = ACTIONS(700),
    [anon_sym___extension__] = ACTIONS(703),
    [anon_sym_typedef] = ACTIONS(706),
    [anon_sym_in] = ACTIONS(709),
    [anon_sym_out] = ACTIONS(709),
    [anon_sym_inout] = ACTIONS(709),
    [anon_sym_virtual] = ACTIONS(709),
    [anon_sym_extern] = ACTIONS(712),
    [anon_sym___attribute__] = ACTIONS(715),
    [anon_sym___attribute] = ACTIONS(715),
    [anon_sym_using] = ACTIONS(718),
    [anon_sym_COLON_COLON] = ACTIONS(721),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(724),
    [anon_sym___declspec] = ACTIONS(727),
    [anon_sym___based] = ACTIONS(730),
    [anon_sym___cdecl] = ACTIONS(733),
    [anon_sym___clrcall] = ACTIONS(733),
    [anon_sym___stdcall] = ACTIONS(733),
    [anon_sym___fastcall] = ACTIONS(733),
    [anon_sym___thiscall] = ACTIONS(733),
    [anon_sym___vectorcall] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(736),
    [anon_sym_signed] = ACTIONS(739),
    [anon_sym_unsigned] = ACTIONS(739),
    [anon_sym_long] = ACTIONS(739),
    [anon_sym_short] = ACTIONS(739),
    [anon_sym_LBRACK] = ACTIONS(742),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_register] = ACTIONS(745),
    [anon_sym_inline] = ACTIONS(748),
    [anon_sym___inline] = ACTIONS(745),
    [anon_sym___inline__] = ACTIONS(745),
    [anon_sym___forceinline] = ACTIONS(745),
    [anon_sym_thread_local] = ACTIONS(745),
    [anon_sym___thread] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(751),
    [anon_sym_constexpr] = ACTIONS(751),
    [anon_sym_volatile] = ACTIONS(751),
    [anon_sym_restrict] = ACTIONS(751),
    [anon_sym___restrict__] = ACTIONS(751),
    [anon_sym__Atomic] = ACTIONS(751),
    [anon_sym__Noreturn] = ACTIONS(751),
    [anon_sym_noreturn] = ACTIONS(751),
    [anon_sym__Nonnull] = ACTIONS(751),
    [anon_sym_mutable] = ACTIONS(751),
    [anon_sym_constinit] = ACTIONS(751),
    [anon_sym_consteval] = ACTIONS(751),
    [anon_sym_alignas] = ACTIONS(754),
    [anon_sym__Alignas] = ACTIONS(754),
    [sym_primitive_type] = ACTIONS(757),
    [anon_sym_enum] = ACTIONS(760),
    [anon_sym_class] = ACTIONS(763),
    [anon_sym_struct] = ACTIONS(766),
    [anon_sym_union] = ACTIONS(769),
    [anon_sym_if] = ACTIONS(772),
    [anon_sym_switch] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(778),
    [anon_sym_default] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(784),
    [anon_sym_do] = ACTIONS(787),
    [anon_sym_for] = ACTIONS(790),
    [anon_sym_return] = ACTIONS(793),
    [anon_sym_break] = ACTIONS(796),
    [anon_sym_continue] = ACTIONS(799),
    [anon_sym_goto] = ACTIONS(802),
    [anon_sym_not] = ACTIONS(688),
    [anon_sym_compl] = ACTIONS(688),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
    [anon_sym_sizeof] = ACTIONS(808),
    [anon_sym___alignof__] = ACTIONS(811),
    [anon_sym___alignof] = ACTIONS(811),
    [anon_sym__alignof] = ACTIONS(811),
    [anon_sym_alignof] = ACTIONS(811),
    [anon_sym__Alignof] = ACTIONS(811),
    [anon_sym_offsetof] = ACTIONS(814),
    [anon_sym__Generic] = ACTIONS(817),
    [anon_sym_asm] = ACTIONS(820),
    [anon_sym___asm__] = ACTIONS(820),
    [anon_sym___asm] = ACTIONS(820),
    [sym_number_literal] = ACTIONS(823),
    [anon_sym_L_SQUOTE] = ACTIONS(826),
    [anon_sym_u_SQUOTE] = ACTIONS(826),
    [anon_sym_U_SQUOTE] = ACTIONS(826),
    [anon_sym_u8_SQUOTE] = ACTIONS(826),
    [anon_sym_SQUOTE] = ACTIONS(826),
    [anon_sym_L_DQUOTE] = ACTIONS(829),
    [anon_sym_u_DQUOTE] = ACTIONS(829),
    [anon_sym_U_DQUOTE] = ACTIONS(829),
    [anon_sym_u8_DQUOTE] = ACTIONS(829),
    [anon_sym_DQUOTE] = ACTIONS(829),
    [sym_true] = ACTIONS(832),
    [sym_false] = ACTIONS(832),
    [anon_sym_NULL] = ACTIONS(835),
    [anon_sym_nullptr] = ACTIONS(835),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(838),
    [anon_sym_let] = ACTIONS(838),
    [anon_sym_This] = ACTIONS(838),
    [anon_sym_decltype] = ACTIONS(841),
    [anon_sym_explicit] = ACTIONS(844),
    [anon_sym_typename] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(850),
    [anon_sym_module] = ACTIONS(853),
    [anon_sym_import] = ACTIONS(856),
    [anon_sym_template] = ACTIONS(859),
    [anon_sym_operator] = ACTIONS(862),
    [anon_sym_try] = ACTIONS(865),
    [anon_sym_delete] = ACTIONS(868),
    [anon_sym_throw] = ACTIONS(871),
    [anon_sym_namespace] = ACTIONS(874),
    [anon_sym_static_assert] = ACTIONS(877),
    [anon_sym_concept] = ACTIONS(880),
    [anon_sym_co_return] = ACTIONS(883),
    [anon_sym_co_yield] = ACTIONS(886),
    [anon_sym_R_DQUOTE] = ACTIONS(889),
    [anon_sym_LR_DQUOTE] = ACTIONS(889),
    [anon_sym_uR_DQUOTE] = ACTIONS(889),
    [anon_sym_UR_DQUOTE] = ACTIONS(889),
    [anon_sym_u8R_DQUOTE] = ACTIONS(889),
    [anon_sym_co_await] = ACTIONS(892),
    [anon_sym_new] = ACTIONS(895),
    [anon_sym_requires] = ACTIONS(898),
    [sym_this] = ACTIONS(832),
    [anon_sym_precise] = ACTIONS(901),
    [anon_sym_shared] = ACTIONS(901),
    [anon_sym_groupshared] = ACTIONS(901),
    [anon_sym_uniform] = ACTIONS(901),
    [anon_sym_row_major] = ACTIONS(901),
    [anon_sym_column_major] = ACTIONS(901),
    [anon_sym_globallycoherent] = ACTIONS(901),
    [anon_sym_centroid] = ACTIONS(901),
    [anon_sym_noperspective] = ACTIONS(901),
    [anon_sym_nointerpolation] = ACTIONS(901),
    [anon_sym_sample] = ACTIONS(901),
    [anon_sym_linear] = ACTIONS(901),
    [anon_sym_snorm] = ACTIONS(901),
    [anon_sym_unorm] = ACTIONS(901),
    [anon_sym_point] = ACTIONS(901),
    [anon_sym_line] = ACTIONS(901),
    [anon_sym_triangleadj] = ACTIONS(901),
    [anon_sym_lineadj] = ACTIONS(901),
    [anon_sym_triangle] = ACTIONS(901),
    [anon_sym_interface] = ACTIONS(904),
    [anon_sym_extension] = ACTIONS(907),
    [anon_sym___exported] = ACTIONS(910),
  },
  [29] = {
    [sym__top_level_item] = STATE(28),
    [sym_preproc_include] = STATE(28),
    [sym_preproc_def] = STATE(28),
    [sym_preproc_function_def] = STATE(28),
    [sym_preproc_call] = STATE(28),
    [sym_preproc_if] = STATE(28),
    [sym_preproc_ifdef] = STATE(28),
    [sym_function_definition] = STATE(28),
    [sym_declaration] = STATE(28),
    [sym_type_definition] = STATE(28),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6100),
    [sym_linkage_specification] = STATE(28),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2234),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8014),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(28),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(247),
    [sym_sized_type_specifier] = STATE(315),
    [sym_enum_specifier] = STATE(315),
    [sym_struct_specifier] = STATE(315),
    [sym_union_specifier] = STATE(315),
    [sym_attributed_statement] = STATE(1008),
    [sym__top_level_statement] = STATE(28),
    [sym_labeled_statement] = STATE(28),
    [sym__top_level_expression_statement] = STATE(28),
    [sym_if_statement] = STATE(28),
    [sym_switch_statement] = STATE(28),
    [sym_case_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_do_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_return_statement] = STATE(28),
    [sym_break_statement] = STATE(28),
    [sym_continue_statement] = STATE(28),
    [sym_goto_statement] = STATE(28),
    [sym_expression] = STATE(6128),
    [sym__string] = STATE(6105),
    [sym_conditional_expression] = STATE(6219),
    [sym_assignment_expression] = STATE(6219),
    [sym_pointer_expression] = STATE(4822),
    [sym_unary_expression] = STATE(6219),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(6219),
    [sym_cast_expression] = STATE(6219),
    [sym_sizeof_expression] = STATE(6219),
    [sym_alignof_expression] = STATE(6219),
    [sym_offsetof_expression] = STATE(6219),
    [sym_generic_expression] = STATE(6219),
    [sym_subscript_expression] = STATE(4822),
    [sym_call_expression] = STATE(4822),
    [sym_gnu_asm_expression] = STATE(6219),
    [sym_extension_expression] = STATE(6219),
    [sym_field_expression] = STATE(4822),
    [sym_compound_literal_expression] = STATE(6219),
    [sym_parenthesized_expression] = STATE(4822),
    [sym_char_literal] = STATE(6105),
    [sym_concatenated_string] = STATE(6105),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(6219),
    [sym__empty_declaration] = STATE(28),
    [sym_placeholder_type_specifier] = STATE(315),
    [sym_decltype] = STATE(256),
    [sym_class_specifier] = STATE(315),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2678),
    [sym_dependent_type] = STATE(315),
    [sym_module_declaration] = STATE(28),
    [sym_export_declaration] = STATE(28),
    [sym_import_declaration] = STATE(28),
    [sym_global_module_fragment_declaration] = STATE(28),
    [sym_private_module_fragment_declaration] = STATE(28),
    [sym_template_declaration] = STATE(28),
    [sym_template_instantiation] = STATE(28),
    [sym_operator_cast] = STATE(9025),
    [sym__constructor_specifiers] = STATE(2678),
    [sym_operator_cast_definition] = STATE(28),
    [sym_operator_cast_declaration] = STATE(28),
    [sym_constructor_or_destructor_definition] = STATE(28),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(831),
    [sym_template_function] = STATE(6081),
    [sym_namespace_definition] = STATE(28),
    [sym_namespace_alias_definition] = STATE(28),
    [sym_using_declaration] = STATE(28),
    [sym_alias_declaration] = STATE(28),
    [sym_static_assert_declaration] = STATE(28),
    [sym_concept_definition] = STATE(28),
    [sym_for_range_loop] = STATE(28),
    [sym_co_return_statement] = STATE(28),
    [sym_co_yield_statement] = STATE(28),
    [sym_throw_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(6219),
    [sym_new_expression] = STATE(6219),
    [sym_delete_expression] = STATE(6219),
    [sym_requires_clause] = STATE(6219),
    [sym_requires_expression] = STATE(6219),
    [sym_lambda_expression] = STATE(6219),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(6219),
    [sym_parameter_pack_expansion] = STATE(6219),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6985),
    [sym_qualified_identifier] = STATE(4704),
    [sym_qualified_type_identifier] = STATE(841),
    [sym_qualified_operator_cast_identifier] = STATE(9025),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4822),
    [sym_qualifiers] = STATE(2919),
    [sym_hlsl_attribute] = STATE(1611),
    [sym_interface_specifier] = STATE(315),
    [sym_extension_specifier] = STATE(315),
    [sym_import_statement] = STATE(28),
    [sym_associatedtype_specifier] = STATE(315),
    [aux_sym_translation_unit_repeat1] = STATE(28),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1189),
    [aux_sym_sized_type_specifier_repeat1] = STATE(389),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2678),
    [ts_builtin_sym_end] = ACTIONS(913),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(33),
    [anon_sym___extension__] = ACTIONS(35),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(65),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(115),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(121),
    [sym_false] = ACTIONS(121),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(125),
    [anon_sym_let] = ACTIONS(125),
    [anon_sym_This] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_module] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(137),
    [anon_sym_template] = ACTIONS(139),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_namespace] = ACTIONS(149),
    [anon_sym_static_assert] = ACTIONS(151),
    [anon_sym_concept] = ACTIONS(153),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(121),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(169),
    [anon_sym_extension] = ACTIONS(171),
    [anon_sym___exported] = ACTIONS(173),
  },
  [30] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(919),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [31] = {
    [sym__block_item] = STATE(53),
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(53),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(53),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(53),
    [sym_template_instantiation] = STATE(53),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(53),
    [sym_operator_cast_declaration] = STATE(53),
    [sym_constructor_or_destructor_definition] = STATE(53),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(53),
    [sym_namespace_alias_definition] = STATE(53),
    [sym_using_declaration] = STATE(53),
    [sym_alias_declaration] = STATE(53),
    [sym_static_assert_declaration] = STATE(53),
    [sym_concept_definition] = STATE(53),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(921),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [32] = {
    [sym__block_item] = STATE(32),
    [sym_preproc_include] = STATE(32),
    [sym_preproc_def] = STATE(32),
    [sym_preproc_function_def] = STATE(32),
    [sym_preproc_call] = STATE(32),
    [sym_preproc_if] = STATE(32),
    [sym_preproc_ifdef] = STATE(32),
    [sym_function_definition] = STATE(32),
    [sym_declaration] = STATE(32),
    [sym_type_definition] = STATE(32),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6092),
    [sym_linkage_specification] = STATE(32),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2604),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8101),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(857),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1119),
    [sym_statement] = STATE(32),
    [sym_labeled_statement] = STATE(857),
    [sym_expression_statement] = STATE(857),
    [sym_if_statement] = STATE(857),
    [sym_switch_statement] = STATE(857),
    [sym_case_statement] = STATE(857),
    [sym_while_statement] = STATE(857),
    [sym_do_statement] = STATE(857),
    [sym_for_statement] = STATE(857),
    [sym_return_statement] = STATE(857),
    [sym_break_statement] = STATE(857),
    [sym_continue_statement] = STATE(857),
    [sym_goto_statement] = STATE(857),
    [sym_seh_try_statement] = STATE(857),
    [sym_seh_leave_statement] = STATE(857),
    [sym_expression] = STATE(5773),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10871),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(32),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2673),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(32),
    [sym_template_instantiation] = STATE(32),
    [sym_operator_cast] = STATE(9109),
    [sym__constructor_specifiers] = STATE(2673),
    [sym_operator_cast_definition] = STATE(32),
    [sym_operator_cast_declaration] = STATE(32),
    [sym_constructor_or_destructor_definition] = STATE(32),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(32),
    [sym_namespace_alias_definition] = STATE(32),
    [sym_using_declaration] = STATE(32),
    [sym_alias_declaration] = STATE(32),
    [sym_static_assert_declaration] = STATE(32),
    [sym_concept_definition] = STATE(32),
    [sym_for_range_loop] = STATE(857),
    [sym_co_return_statement] = STATE(857),
    [sym_co_yield_statement] = STATE(857),
    [sym_throw_statement] = STATE(857),
    [sym_try_statement] = STATE(857),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9109),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(857),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(857),
    [sym_hlsl_attribute] = STATE(1618),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(32),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1183),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2673),
    [sym_identifier] = ACTIONS(923),
    [aux_sym_preproc_include_token1] = ACTIONS(926),
    [aux_sym_preproc_def_token1] = ACTIONS(929),
    [aux_sym_preproc_if_token1] = ACTIONS(932),
    [aux_sym_preproc_if_token2] = ACTIONS(417),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(935),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(935),
    [sym_preproc_directive] = ACTIONS(938),
    [anon_sym_LPAREN2] = ACTIONS(425),
    [anon_sym_BANG] = ACTIONS(428),
    [anon_sym_TILDE] = ACTIONS(431),
    [anon_sym_DASH] = ACTIONS(434),
    [anon_sym_PLUS] = ACTIONS(434),
    [anon_sym_STAR] = ACTIONS(437),
    [anon_sym_AMP_AMP] = ACTIONS(440),
    [anon_sym_AMP] = ACTIONS(443),
    [anon_sym_SEMI] = ACTIONS(941),
    [anon_sym___extension__] = ACTIONS(944),
    [anon_sym_typedef] = ACTIONS(947),
    [anon_sym_in] = ACTIONS(455),
    [anon_sym_out] = ACTIONS(455),
    [anon_sym_inout] = ACTIONS(455),
    [anon_sym_virtual] = ACTIONS(455),
    [anon_sym_extern] = ACTIONS(950),
    [anon_sym___attribute__] = ACTIONS(461),
    [anon_sym___attribute] = ACTIONS(461),
    [anon_sym_using] = ACTIONS(953),
    [anon_sym_COLON_COLON] = ACTIONS(467),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(470),
    [anon_sym___declspec] = ACTIONS(473),
    [anon_sym___based] = ACTIONS(476),
    [anon_sym___cdecl] = ACTIONS(479),
    [anon_sym___clrcall] = ACTIONS(479),
    [anon_sym___stdcall] = ACTIONS(479),
    [anon_sym___fastcall] = ACTIONS(479),
    [anon_sym___thiscall] = ACTIONS(479),
    [anon_sym___vectorcall] = ACTIONS(479),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_signed] = ACTIONS(485),
    [anon_sym_unsigned] = ACTIONS(485),
    [anon_sym_long] = ACTIONS(485),
    [anon_sym_short] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_register] = ACTIONS(491),
    [anon_sym_inline] = ACTIONS(959),
    [anon_sym___inline] = ACTIONS(491),
    [anon_sym___inline__] = ACTIONS(491),
    [anon_sym___forceinline] = ACTIONS(491),
    [anon_sym_thread_local] = ACTIONS(491),
    [anon_sym___thread] = ACTIONS(491),
    [anon_sym_const] = ACTIONS(497),
    [anon_sym_constexpr] = ACTIONS(497),
    [anon_sym_volatile] = ACTIONS(497),
    [anon_sym_restrict] = ACTIONS(497),
    [anon_sym___restrict__] = ACTIONS(497),
    [anon_sym__Atomic] = ACTIONS(497),
    [anon_sym__Noreturn] = ACTIONS(497),
    [anon_sym_noreturn] = ACTIONS(497),
    [anon_sym__Nonnull] = ACTIONS(497),
    [anon_sym_mutable] = ACTIONS(497),
    [anon_sym_constinit] = ACTIONS(497),
    [anon_sym_consteval] = ACTIONS(497),
    [anon_sym_alignas] = ACTIONS(500),
    [anon_sym__Alignas] = ACTIONS(500),
    [sym_primitive_type] = ACTIONS(503),
    [anon_sym_enum] = ACTIONS(506),
    [anon_sym_class] = ACTIONS(509),
    [anon_sym_struct] = ACTIONS(512),
    [anon_sym_union] = ACTIONS(515),
    [anon_sym_if] = ACTIONS(962),
    [anon_sym_switch] = ACTIONS(965),
    [anon_sym_case] = ACTIONS(968),
    [anon_sym_default] = ACTIONS(971),
    [anon_sym_while] = ACTIONS(974),
    [anon_sym_do] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(980),
    [anon_sym_return] = ACTIONS(983),
    [anon_sym_break] = ACTIONS(986),
    [anon_sym_continue] = ACTIONS(989),
    [anon_sym_goto] = ACTIONS(992),
    [anon_sym___try] = ACTIONS(995),
    [anon_sym___leave] = ACTIONS(998),
    [anon_sym_not] = ACTIONS(434),
    [anon_sym_compl] = ACTIONS(434),
    [anon_sym_DASH_DASH] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(557),
    [anon_sym_sizeof] = ACTIONS(560),
    [anon_sym___alignof__] = ACTIONS(563),
    [anon_sym___alignof] = ACTIONS(563),
    [anon_sym__alignof] = ACTIONS(563),
    [anon_sym_alignof] = ACTIONS(563),
    [anon_sym__Alignof] = ACTIONS(563),
    [anon_sym_offsetof] = ACTIONS(566),
    [anon_sym__Generic] = ACTIONS(569),
    [anon_sym_asm] = ACTIONS(572),
    [anon_sym___asm__] = ACTIONS(572),
    [anon_sym___asm] = ACTIONS(572),
    [sym_number_literal] = ACTIONS(575),
    [anon_sym_L_SQUOTE] = ACTIONS(578),
    [anon_sym_u_SQUOTE] = ACTIONS(578),
    [anon_sym_U_SQUOTE] = ACTIONS(578),
    [anon_sym_u8_SQUOTE] = ACTIONS(578),
    [anon_sym_SQUOTE] = ACTIONS(578),
    [anon_sym_L_DQUOTE] = ACTIONS(581),
    [anon_sym_u_DQUOTE] = ACTIONS(581),
    [anon_sym_U_DQUOTE] = ACTIONS(581),
    [anon_sym_u8_DQUOTE] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(581),
    [sym_true] = ACTIONS(584),
    [sym_false] = ACTIONS(584),
    [anon_sym_NULL] = ACTIONS(587),
    [anon_sym_nullptr] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(590),
    [anon_sym_let] = ACTIONS(590),
    [anon_sym_This] = ACTIONS(590),
    [anon_sym_decltype] = ACTIONS(593),
    [anon_sym_explicit] = ACTIONS(596),
    [anon_sym_typename] = ACTIONS(599),
    [anon_sym_template] = ACTIONS(1001),
    [anon_sym_operator] = ACTIONS(605),
    [anon_sym_try] = ACTIONS(1004),
    [anon_sym_delete] = ACTIONS(611),
    [anon_sym_throw] = ACTIONS(1007),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_static_assert] = ACTIONS(1013),
    [anon_sym_concept] = ACTIONS(1016),
    [anon_sym_co_return] = ACTIONS(1019),
    [anon_sym_co_yield] = ACTIONS(1022),
    [anon_sym_R_DQUOTE] = ACTIONS(632),
    [anon_sym_LR_DQUOTE] = ACTIONS(632),
    [anon_sym_uR_DQUOTE] = ACTIONS(632),
    [anon_sym_UR_DQUOTE] = ACTIONS(632),
    [anon_sym_u8R_DQUOTE] = ACTIONS(632),
    [anon_sym_co_await] = ACTIONS(635),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_requires] = ACTIONS(641),
    [sym_this] = ACTIONS(584),
    [anon_sym_discard] = ACTIONS(1025),
    [anon_sym_precise] = ACTIONS(647),
    [anon_sym_shared] = ACTIONS(647),
    [anon_sym_groupshared] = ACTIONS(647),
    [anon_sym_uniform] = ACTIONS(647),
    [anon_sym_row_major] = ACTIONS(647),
    [anon_sym_column_major] = ACTIONS(647),
    [anon_sym_globallycoherent] = ACTIONS(647),
    [anon_sym_centroid] = ACTIONS(647),
    [anon_sym_noperspective] = ACTIONS(647),
    [anon_sym_nointerpolation] = ACTIONS(647),
    [anon_sym_sample] = ACTIONS(647),
    [anon_sym_linear] = ACTIONS(647),
    [anon_sym_snorm] = ACTIONS(647),
    [anon_sym_unorm] = ACTIONS(647),
    [anon_sym_point] = ACTIONS(647),
    [anon_sym_line] = ACTIONS(647),
    [anon_sym_triangleadj] = ACTIONS(647),
    [anon_sym_lineadj] = ACTIONS(647),
    [anon_sym_triangle] = ACTIONS(647),
    [anon_sym_cbuffer] = ACTIONS(1028),
    [anon_sym_interface] = ACTIONS(653),
    [anon_sym_extension] = ACTIONS(656),
  },
  [33] = {
    [sym__block_item] = STATE(34),
    [sym_preproc_include] = STATE(34),
    [sym_preproc_def] = STATE(34),
    [sym_preproc_function_def] = STATE(34),
    [sym_preproc_call] = STATE(34),
    [sym_preproc_if] = STATE(34),
    [sym_preproc_ifdef] = STATE(34),
    [sym_function_definition] = STATE(34),
    [sym_declaration] = STATE(34),
    [sym_type_definition] = STATE(34),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(34),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(34),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(34),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(34),
    [sym_template_instantiation] = STATE(34),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(34),
    [sym_operator_cast_declaration] = STATE(34),
    [sym_constructor_or_destructor_definition] = STATE(34),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(34),
    [sym_namespace_alias_definition] = STATE(34),
    [sym_using_declaration] = STATE(34),
    [sym_alias_declaration] = STATE(34),
    [sym_static_assert_declaration] = STATE(34),
    [sym_concept_definition] = STATE(34),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(34),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1031),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [34] = {
    [sym__block_item] = STATE(53),
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(53),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(53),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(53),
    [sym_template_instantiation] = STATE(53),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(53),
    [sym_operator_cast_declaration] = STATE(53),
    [sym_constructor_or_destructor_definition] = STATE(53),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(53),
    [sym_namespace_alias_definition] = STATE(53),
    [sym_using_declaration] = STATE(53),
    [sym_alias_declaration] = STATE(53),
    [sym_static_assert_declaration] = STATE(53),
    [sym_concept_definition] = STATE(53),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1033),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [35] = {
    [sym__block_item] = STATE(39),
    [sym_preproc_include] = STATE(39),
    [sym_preproc_def] = STATE(39),
    [sym_preproc_function_def] = STATE(39),
    [sym_preproc_call] = STATE(39),
    [sym_preproc_if] = STATE(39),
    [sym_preproc_ifdef] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_declaration] = STATE(39),
    [sym_type_definition] = STATE(39),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(39),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(248),
    [sym_sized_type_specifier] = STATE(755),
    [sym_enum_specifier] = STATE(755),
    [sym_struct_specifier] = STATE(755),
    [sym_union_specifier] = STATE(755),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(39),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(39),
    [sym_placeholder_type_specifier] = STATE(755),
    [sym_decltype] = STATE(756),
    [sym_class_specifier] = STATE(755),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(755),
    [sym_template_declaration] = STATE(39),
    [sym_template_instantiation] = STATE(39),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(39),
    [sym_operator_cast_declaration] = STATE(39),
    [sym_constructor_or_destructor_definition] = STATE(39),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(855),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(39),
    [sym_namespace_alias_definition] = STATE(39),
    [sym_using_declaration] = STATE(39),
    [sym_alias_declaration] = STATE(39),
    [sym_static_assert_declaration] = STATE(39),
    [sym_concept_definition] = STATE(39),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6984),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(856),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(755),
    [sym_extension_specifier] = STATE(755),
    [sym_associatedtype_specifier] = STATE(755),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_declaration_list_repeat1] = STATE(39),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(424),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(1035),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1037),
    [anon_sym_signed] = ACTIONS(1039),
    [anon_sym_unsigned] = ACTIONS(1039),
    [anon_sym_long] = ACTIONS(1039),
    [anon_sym_short] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1041),
    [anon_sym_enum] = ACTIONS(1043),
    [anon_sym_class] = ACTIONS(1045),
    [anon_sym_struct] = ACTIONS(1047),
    [anon_sym_union] = ACTIONS(1049),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1051),
    [anon_sym_let] = ACTIONS(1051),
    [anon_sym_This] = ACTIONS(1051),
    [anon_sym_decltype] = ACTIONS(1053),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(1055),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(1057),
    [anon_sym_extension] = ACTIONS(1059),
  },
  [36] = {
    [sym__block_item] = STATE(53),
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(53),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(53),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(53),
    [sym_template_instantiation] = STATE(53),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(53),
    [sym_operator_cast_declaration] = STATE(53),
    [sym_constructor_or_destructor_definition] = STATE(53),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(53),
    [sym_namespace_alias_definition] = STATE(53),
    [sym_using_declaration] = STATE(53),
    [sym_alias_declaration] = STATE(53),
    [sym_static_assert_declaration] = STATE(53),
    [sym_concept_definition] = STATE(53),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [37] = {
    [sym__block_item] = STATE(79),
    [sym_preproc_include] = STATE(79),
    [sym_preproc_def] = STATE(79),
    [sym_preproc_function_def] = STATE(79),
    [sym_preproc_call] = STATE(79),
    [sym_preproc_if] = STATE(79),
    [sym_preproc_ifdef] = STATE(79),
    [sym_function_definition] = STATE(79),
    [sym_declaration] = STATE(79),
    [sym_type_definition] = STATE(79),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(79),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(248),
    [sym_sized_type_specifier] = STATE(755),
    [sym_enum_specifier] = STATE(755),
    [sym_struct_specifier] = STATE(755),
    [sym_union_specifier] = STATE(755),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(79),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(79),
    [sym_placeholder_type_specifier] = STATE(755),
    [sym_decltype] = STATE(756),
    [sym_class_specifier] = STATE(755),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(755),
    [sym_template_declaration] = STATE(79),
    [sym_template_instantiation] = STATE(79),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(79),
    [sym_operator_cast_declaration] = STATE(79),
    [sym_constructor_or_destructor_definition] = STATE(79),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(855),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(79),
    [sym_namespace_alias_definition] = STATE(79),
    [sym_using_declaration] = STATE(79),
    [sym_alias_declaration] = STATE(79),
    [sym_static_assert_declaration] = STATE(79),
    [sym_concept_definition] = STATE(79),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6984),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(856),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(755),
    [sym_extension_specifier] = STATE(755),
    [sym_associatedtype_specifier] = STATE(755),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_declaration_list_repeat1] = STATE(79),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(424),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(1035),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1063),
    [anon_sym_signed] = ACTIONS(1039),
    [anon_sym_unsigned] = ACTIONS(1039),
    [anon_sym_long] = ACTIONS(1039),
    [anon_sym_short] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1041),
    [anon_sym_enum] = ACTIONS(1043),
    [anon_sym_class] = ACTIONS(1045),
    [anon_sym_struct] = ACTIONS(1047),
    [anon_sym_union] = ACTIONS(1049),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1051),
    [anon_sym_let] = ACTIONS(1051),
    [anon_sym_This] = ACTIONS(1051),
    [anon_sym_decltype] = ACTIONS(1053),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(1055),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(1057),
    [anon_sym_extension] = ACTIONS(1059),
  },
  [38] = {
    [sym__block_item] = STATE(37),
    [sym_preproc_include] = STATE(37),
    [sym_preproc_def] = STATE(37),
    [sym_preproc_function_def] = STATE(37),
    [sym_preproc_call] = STATE(37),
    [sym_preproc_if] = STATE(37),
    [sym_preproc_ifdef] = STATE(37),
    [sym_function_definition] = STATE(37),
    [sym_declaration] = STATE(37),
    [sym_type_definition] = STATE(37),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(37),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(248),
    [sym_sized_type_specifier] = STATE(755),
    [sym_enum_specifier] = STATE(755),
    [sym_struct_specifier] = STATE(755),
    [sym_union_specifier] = STATE(755),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(37),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(37),
    [sym_placeholder_type_specifier] = STATE(755),
    [sym_decltype] = STATE(756),
    [sym_class_specifier] = STATE(755),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(755),
    [sym_template_declaration] = STATE(37),
    [sym_template_instantiation] = STATE(37),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(37),
    [sym_operator_cast_declaration] = STATE(37),
    [sym_constructor_or_destructor_definition] = STATE(37),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(855),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(37),
    [sym_namespace_alias_definition] = STATE(37),
    [sym_using_declaration] = STATE(37),
    [sym_alias_declaration] = STATE(37),
    [sym_static_assert_declaration] = STATE(37),
    [sym_concept_definition] = STATE(37),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6984),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(856),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(755),
    [sym_extension_specifier] = STATE(755),
    [sym_associatedtype_specifier] = STATE(755),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_declaration_list_repeat1] = STATE(37),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(424),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(1035),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_signed] = ACTIONS(1039),
    [anon_sym_unsigned] = ACTIONS(1039),
    [anon_sym_long] = ACTIONS(1039),
    [anon_sym_short] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1041),
    [anon_sym_enum] = ACTIONS(1043),
    [anon_sym_class] = ACTIONS(1045),
    [anon_sym_struct] = ACTIONS(1047),
    [anon_sym_union] = ACTIONS(1049),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1051),
    [anon_sym_let] = ACTIONS(1051),
    [anon_sym_This] = ACTIONS(1051),
    [anon_sym_decltype] = ACTIONS(1053),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(1055),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(1057),
    [anon_sym_extension] = ACTIONS(1059),
  },
  [39] = {
    [sym__block_item] = STATE(79),
    [sym_preproc_include] = STATE(79),
    [sym_preproc_def] = STATE(79),
    [sym_preproc_function_def] = STATE(79),
    [sym_preproc_call] = STATE(79),
    [sym_preproc_if] = STATE(79),
    [sym_preproc_ifdef] = STATE(79),
    [sym_function_definition] = STATE(79),
    [sym_declaration] = STATE(79),
    [sym_type_definition] = STATE(79),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(79),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(248),
    [sym_sized_type_specifier] = STATE(755),
    [sym_enum_specifier] = STATE(755),
    [sym_struct_specifier] = STATE(755),
    [sym_union_specifier] = STATE(755),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(79),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(79),
    [sym_placeholder_type_specifier] = STATE(755),
    [sym_decltype] = STATE(756),
    [sym_class_specifier] = STATE(755),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(755),
    [sym_template_declaration] = STATE(79),
    [sym_template_instantiation] = STATE(79),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(79),
    [sym_operator_cast_declaration] = STATE(79),
    [sym_constructor_or_destructor_definition] = STATE(79),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(855),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(79),
    [sym_namespace_alias_definition] = STATE(79),
    [sym_using_declaration] = STATE(79),
    [sym_alias_declaration] = STATE(79),
    [sym_static_assert_declaration] = STATE(79),
    [sym_concept_definition] = STATE(79),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6984),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(856),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(755),
    [sym_extension_specifier] = STATE(755),
    [sym_associatedtype_specifier] = STATE(755),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_declaration_list_repeat1] = STATE(79),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(424),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(1035),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1067),
    [anon_sym_signed] = ACTIONS(1039),
    [anon_sym_unsigned] = ACTIONS(1039),
    [anon_sym_long] = ACTIONS(1039),
    [anon_sym_short] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1041),
    [anon_sym_enum] = ACTIONS(1043),
    [anon_sym_class] = ACTIONS(1045),
    [anon_sym_struct] = ACTIONS(1047),
    [anon_sym_union] = ACTIONS(1049),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1051),
    [anon_sym_let] = ACTIONS(1051),
    [anon_sym_This] = ACTIONS(1051),
    [anon_sym_decltype] = ACTIONS(1053),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(1055),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(1057),
    [anon_sym_extension] = ACTIONS(1059),
  },
  [40] = {
    [sym__block_item] = STATE(32),
    [sym_preproc_include] = STATE(32),
    [sym_preproc_def] = STATE(32),
    [sym_preproc_function_def] = STATE(32),
    [sym_preproc_call] = STATE(32),
    [sym_preproc_if] = STATE(32),
    [sym_preproc_ifdef] = STATE(32),
    [sym_function_definition] = STATE(32),
    [sym_declaration] = STATE(32),
    [sym_type_definition] = STATE(32),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6092),
    [sym_linkage_specification] = STATE(32),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2604),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8101),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(857),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1119),
    [sym_statement] = STATE(32),
    [sym_labeled_statement] = STATE(857),
    [sym_expression_statement] = STATE(857),
    [sym_if_statement] = STATE(857),
    [sym_switch_statement] = STATE(857),
    [sym_case_statement] = STATE(857),
    [sym_while_statement] = STATE(857),
    [sym_do_statement] = STATE(857),
    [sym_for_statement] = STATE(857),
    [sym_return_statement] = STATE(857),
    [sym_break_statement] = STATE(857),
    [sym_continue_statement] = STATE(857),
    [sym_goto_statement] = STATE(857),
    [sym_seh_try_statement] = STATE(857),
    [sym_seh_leave_statement] = STATE(857),
    [sym_expression] = STATE(5773),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10871),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(32),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2673),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(32),
    [sym_template_instantiation] = STATE(32),
    [sym_operator_cast] = STATE(9109),
    [sym__constructor_specifiers] = STATE(2673),
    [sym_operator_cast_definition] = STATE(32),
    [sym_operator_cast_declaration] = STATE(32),
    [sym_constructor_or_destructor_definition] = STATE(32),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(32),
    [sym_namespace_alias_definition] = STATE(32),
    [sym_using_declaration] = STATE(32),
    [sym_alias_declaration] = STATE(32),
    [sym_static_assert_declaration] = STATE(32),
    [sym_concept_definition] = STATE(32),
    [sym_for_range_loop] = STATE(857),
    [sym_co_return_statement] = STATE(857),
    [sym_co_yield_statement] = STATE(857),
    [sym_throw_statement] = STATE(857),
    [sym_try_statement] = STATE(857),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9109),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(857),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(857),
    [sym_hlsl_attribute] = STATE(1618),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(32),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1183),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2673),
    [sym_identifier] = ACTIONS(1069),
    [aux_sym_preproc_include_token1] = ACTIONS(1071),
    [aux_sym_preproc_def_token1] = ACTIONS(1073),
    [aux_sym_preproc_if_token1] = ACTIONS(1075),
    [aux_sym_preproc_if_token2] = ACTIONS(1077),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1079),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1079),
    [sym_preproc_directive] = ACTIONS(1081),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(1083),
    [anon_sym___extension__] = ACTIONS(1085),
    [anon_sym_typedef] = ACTIONS(1087),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(1089),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(1095),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_case] = ACTIONS(1101),
    [anon_sym_default] = ACTIONS(1103),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1107),
    [anon_sym_for] = ACTIONS(1109),
    [anon_sym_return] = ACTIONS(1111),
    [anon_sym_break] = ACTIONS(1113),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_goto] = ACTIONS(1117),
    [anon_sym___try] = ACTIONS(1119),
    [anon_sym___leave] = ACTIONS(1121),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1123),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(1125),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_namespace] = ACTIONS(1129),
    [anon_sym_static_assert] = ACTIONS(1131),
    [anon_sym_concept] = ACTIONS(1133),
    [anon_sym_co_return] = ACTIONS(1135),
    [anon_sym_co_yield] = ACTIONS(1137),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1139),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(1141),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [41] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1143),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [42] = {
    [sym__block_item] = STATE(53),
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(53),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(53),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(53),
    [sym_template_instantiation] = STATE(53),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(53),
    [sym_operator_cast_declaration] = STATE(53),
    [sym_constructor_or_destructor_definition] = STATE(53),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(53),
    [sym_namespace_alias_definition] = STATE(53),
    [sym_using_declaration] = STATE(53),
    [sym_alias_declaration] = STATE(53),
    [sym_static_assert_declaration] = STATE(53),
    [sym_concept_definition] = STATE(53),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1145),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [43] = {
    [sym__block_item] = STATE(53),
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(53),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(53),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(53),
    [sym_template_instantiation] = STATE(53),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(53),
    [sym_operator_cast_declaration] = STATE(53),
    [sym_constructor_or_destructor_definition] = STATE(53),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(53),
    [sym_namespace_alias_definition] = STATE(53),
    [sym_using_declaration] = STATE(53),
    [sym_alias_declaration] = STATE(53),
    [sym_static_assert_declaration] = STATE(53),
    [sym_concept_definition] = STATE(53),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1147),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [44] = {
    [sym__block_item] = STATE(46),
    [sym_preproc_include] = STATE(46),
    [sym_preproc_def] = STATE(46),
    [sym_preproc_function_def] = STATE(46),
    [sym_preproc_call] = STATE(46),
    [sym_preproc_if] = STATE(46),
    [sym_preproc_ifdef] = STATE(46),
    [sym_function_definition] = STATE(46),
    [sym_declaration] = STATE(46),
    [sym_type_definition] = STATE(46),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(46),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(248),
    [sym_sized_type_specifier] = STATE(755),
    [sym_enum_specifier] = STATE(755),
    [sym_struct_specifier] = STATE(755),
    [sym_union_specifier] = STATE(755),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(46),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(46),
    [sym_placeholder_type_specifier] = STATE(755),
    [sym_decltype] = STATE(756),
    [sym_class_specifier] = STATE(755),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(755),
    [sym_template_declaration] = STATE(46),
    [sym_template_instantiation] = STATE(46),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(46),
    [sym_operator_cast_declaration] = STATE(46),
    [sym_constructor_or_destructor_definition] = STATE(46),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(855),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(46),
    [sym_namespace_alias_definition] = STATE(46),
    [sym_using_declaration] = STATE(46),
    [sym_alias_declaration] = STATE(46),
    [sym_static_assert_declaration] = STATE(46),
    [sym_concept_definition] = STATE(46),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6984),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(856),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(755),
    [sym_extension_specifier] = STATE(755),
    [sym_associatedtype_specifier] = STATE(755),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_declaration_list_repeat1] = STATE(46),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(424),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(1035),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1149),
    [anon_sym_signed] = ACTIONS(1039),
    [anon_sym_unsigned] = ACTIONS(1039),
    [anon_sym_long] = ACTIONS(1039),
    [anon_sym_short] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1041),
    [anon_sym_enum] = ACTIONS(1043),
    [anon_sym_class] = ACTIONS(1045),
    [anon_sym_struct] = ACTIONS(1047),
    [anon_sym_union] = ACTIONS(1049),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1051),
    [anon_sym_let] = ACTIONS(1051),
    [anon_sym_This] = ACTIONS(1051),
    [anon_sym_decltype] = ACTIONS(1053),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(1055),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(1057),
    [anon_sym_extension] = ACTIONS(1059),
  },
  [45] = {
    [sym__block_item] = STATE(1065),
    [sym_preproc_include] = STATE(1065),
    [sym_preproc_def] = STATE(1065),
    [sym_preproc_function_def] = STATE(1065),
    [sym_preproc_call] = STATE(1065),
    [sym_preproc_if] = STATE(1065),
    [sym_preproc_ifdef] = STATE(1065),
    [sym_function_definition] = STATE(1065),
    [sym_declaration] = STATE(1065),
    [sym_type_definition] = STATE(1065),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6100),
    [sym_linkage_specification] = STATE(1065),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2234),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8014),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(480),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2791),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1085),
    [sym_statement] = STATE(1065),
    [sym_labeled_statement] = STATE(480),
    [sym_expression_statement] = STATE(480),
    [sym_if_statement] = STATE(480),
    [sym_switch_statement] = STATE(480),
    [sym_case_statement] = STATE(480),
    [sym_while_statement] = STATE(480),
    [sym_do_statement] = STATE(480),
    [sym_for_statement] = STATE(480),
    [sym_return_statement] = STATE(480),
    [sym_break_statement] = STATE(480),
    [sym_continue_statement] = STATE(480),
    [sym_goto_statement] = STATE(480),
    [sym_seh_try_statement] = STATE(480),
    [sym_seh_leave_statement] = STATE(480),
    [sym_expression] = STATE(5655),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10869),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(1065),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2678),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(1065),
    [sym_template_instantiation] = STATE(1065),
    [sym_operator_cast] = STATE(9025),
    [sym__constructor_specifiers] = STATE(2678),
    [sym_operator_cast_definition] = STATE(1065),
    [sym_operator_cast_declaration] = STATE(1065),
    [sym_constructor_or_destructor_definition] = STATE(1065),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(1065),
    [sym_namespace_alias_definition] = STATE(1065),
    [sym_using_declaration] = STATE(1065),
    [sym_alias_declaration] = STATE(1065),
    [sym_static_assert_declaration] = STATE(1065),
    [sym_concept_definition] = STATE(1065),
    [sym_for_range_loop] = STATE(480),
    [sym_co_return_statement] = STATE(480),
    [sym_co_yield_statement] = STATE(480),
    [sym_throw_statement] = STATE(480),
    [sym_try_statement] = STATE(480),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9025),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(480),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(480),
    [sym_hlsl_attribute] = STATE(1611),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1189),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2678),
    [sym_identifier] = ACTIONS(1151),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym___extension__] = ACTIONS(35),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(1155),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(65),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1157),
    [anon_sym___leave] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_module] = ACTIONS(1161),
    [anon_sym_import] = ACTIONS(1163),
    [anon_sym_template] = ACTIONS(139),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_namespace] = ACTIONS(149),
    [anon_sym_static_assert] = ACTIONS(151),
    [anon_sym_concept] = ACTIONS(153),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1165),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(1167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [46] = {
    [sym__block_item] = STATE(79),
    [sym_preproc_include] = STATE(79),
    [sym_preproc_def] = STATE(79),
    [sym_preproc_function_def] = STATE(79),
    [sym_preproc_call] = STATE(79),
    [sym_preproc_if] = STATE(79),
    [sym_preproc_ifdef] = STATE(79),
    [sym_function_definition] = STATE(79),
    [sym_declaration] = STATE(79),
    [sym_type_definition] = STATE(79),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(79),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(248),
    [sym_sized_type_specifier] = STATE(755),
    [sym_enum_specifier] = STATE(755),
    [sym_struct_specifier] = STATE(755),
    [sym_union_specifier] = STATE(755),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(79),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(79),
    [sym_placeholder_type_specifier] = STATE(755),
    [sym_decltype] = STATE(756),
    [sym_class_specifier] = STATE(755),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(755),
    [sym_template_declaration] = STATE(79),
    [sym_template_instantiation] = STATE(79),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(79),
    [sym_operator_cast_declaration] = STATE(79),
    [sym_constructor_or_destructor_definition] = STATE(79),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(855),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(79),
    [sym_namespace_alias_definition] = STATE(79),
    [sym_using_declaration] = STATE(79),
    [sym_alias_declaration] = STATE(79),
    [sym_static_assert_declaration] = STATE(79),
    [sym_concept_definition] = STATE(79),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6984),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(856),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(755),
    [sym_extension_specifier] = STATE(755),
    [sym_associatedtype_specifier] = STATE(755),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_declaration_list_repeat1] = STATE(79),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(424),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(1035),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1169),
    [anon_sym_signed] = ACTIONS(1039),
    [anon_sym_unsigned] = ACTIONS(1039),
    [anon_sym_long] = ACTIONS(1039),
    [anon_sym_short] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1041),
    [anon_sym_enum] = ACTIONS(1043),
    [anon_sym_class] = ACTIONS(1045),
    [anon_sym_struct] = ACTIONS(1047),
    [anon_sym_union] = ACTIONS(1049),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1051),
    [anon_sym_let] = ACTIONS(1051),
    [anon_sym_This] = ACTIONS(1051),
    [anon_sym_decltype] = ACTIONS(1053),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(1055),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(1057),
    [anon_sym_extension] = ACTIONS(1059),
  },
  [47] = {
    [sym__block_item] = STATE(49),
    [sym_preproc_include] = STATE(49),
    [sym_preproc_def] = STATE(49),
    [sym_preproc_function_def] = STATE(49),
    [sym_preproc_call] = STATE(49),
    [sym_preproc_if] = STATE(49),
    [sym_preproc_ifdef] = STATE(49),
    [sym_function_definition] = STATE(49),
    [sym_declaration] = STATE(49),
    [sym_type_definition] = STATE(49),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(49),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(49),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(49),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(49),
    [sym_template_instantiation] = STATE(49),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(49),
    [sym_operator_cast_declaration] = STATE(49),
    [sym_constructor_or_destructor_definition] = STATE(49),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(49),
    [sym_namespace_alias_definition] = STATE(49),
    [sym_using_declaration] = STATE(49),
    [sym_alias_declaration] = STATE(49),
    [sym_static_assert_declaration] = STATE(49),
    [sym_concept_definition] = STATE(49),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(49),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1171),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [48] = {
    [sym__block_item] = STATE(40),
    [sym_preproc_include] = STATE(40),
    [sym_preproc_def] = STATE(40),
    [sym_preproc_function_def] = STATE(40),
    [sym_preproc_call] = STATE(40),
    [sym_preproc_if] = STATE(40),
    [sym_preproc_ifdef] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym_declaration] = STATE(40),
    [sym_type_definition] = STATE(40),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6092),
    [sym_linkage_specification] = STATE(40),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2604),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8101),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(857),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1119),
    [sym_statement] = STATE(40),
    [sym_labeled_statement] = STATE(857),
    [sym_expression_statement] = STATE(857),
    [sym_if_statement] = STATE(857),
    [sym_switch_statement] = STATE(857),
    [sym_case_statement] = STATE(857),
    [sym_while_statement] = STATE(857),
    [sym_do_statement] = STATE(857),
    [sym_for_statement] = STATE(857),
    [sym_return_statement] = STATE(857),
    [sym_break_statement] = STATE(857),
    [sym_continue_statement] = STATE(857),
    [sym_goto_statement] = STATE(857),
    [sym_seh_try_statement] = STATE(857),
    [sym_seh_leave_statement] = STATE(857),
    [sym_expression] = STATE(5773),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10871),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(40),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2673),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(40),
    [sym_template_instantiation] = STATE(40),
    [sym_operator_cast] = STATE(9109),
    [sym__constructor_specifiers] = STATE(2673),
    [sym_operator_cast_definition] = STATE(40),
    [sym_operator_cast_declaration] = STATE(40),
    [sym_constructor_or_destructor_definition] = STATE(40),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(40),
    [sym_namespace_alias_definition] = STATE(40),
    [sym_using_declaration] = STATE(40),
    [sym_alias_declaration] = STATE(40),
    [sym_static_assert_declaration] = STATE(40),
    [sym_concept_definition] = STATE(40),
    [sym_for_range_loop] = STATE(857),
    [sym_co_return_statement] = STATE(857),
    [sym_co_yield_statement] = STATE(857),
    [sym_throw_statement] = STATE(857),
    [sym_try_statement] = STATE(857),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9109),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(857),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(857),
    [sym_hlsl_attribute] = STATE(1618),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(40),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1183),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2673),
    [sym_identifier] = ACTIONS(1069),
    [aux_sym_preproc_include_token1] = ACTIONS(1071),
    [aux_sym_preproc_def_token1] = ACTIONS(1073),
    [aux_sym_preproc_if_token1] = ACTIONS(1075),
    [aux_sym_preproc_if_token2] = ACTIONS(1173),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1079),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1079),
    [sym_preproc_directive] = ACTIONS(1081),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(1083),
    [anon_sym___extension__] = ACTIONS(1085),
    [anon_sym_typedef] = ACTIONS(1087),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(1089),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(1095),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_case] = ACTIONS(1101),
    [anon_sym_default] = ACTIONS(1103),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1107),
    [anon_sym_for] = ACTIONS(1109),
    [anon_sym_return] = ACTIONS(1111),
    [anon_sym_break] = ACTIONS(1113),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_goto] = ACTIONS(1117),
    [anon_sym___try] = ACTIONS(1119),
    [anon_sym___leave] = ACTIONS(1121),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1123),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(1125),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_namespace] = ACTIONS(1129),
    [anon_sym_static_assert] = ACTIONS(1131),
    [anon_sym_concept] = ACTIONS(1133),
    [anon_sym_co_return] = ACTIONS(1135),
    [anon_sym_co_yield] = ACTIONS(1137),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1139),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(1141),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [49] = {
    [sym__block_item] = STATE(53),
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(53),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(53),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(53),
    [sym_template_instantiation] = STATE(53),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(53),
    [sym_operator_cast_declaration] = STATE(53),
    [sym_constructor_or_destructor_definition] = STATE(53),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(53),
    [sym_namespace_alias_definition] = STATE(53),
    [sym_using_declaration] = STATE(53),
    [sym_alias_declaration] = STATE(53),
    [sym_static_assert_declaration] = STATE(53),
    [sym_concept_definition] = STATE(53),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1175),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [50] = {
    [sym__block_item] = STATE(52),
    [sym_preproc_include] = STATE(52),
    [sym_preproc_def] = STATE(52),
    [sym_preproc_function_def] = STATE(52),
    [sym_preproc_call] = STATE(52),
    [sym_preproc_if] = STATE(52),
    [sym_preproc_ifdef] = STATE(52),
    [sym_function_definition] = STATE(52),
    [sym_declaration] = STATE(52),
    [sym_type_definition] = STATE(52),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(52),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(248),
    [sym_sized_type_specifier] = STATE(755),
    [sym_enum_specifier] = STATE(755),
    [sym_struct_specifier] = STATE(755),
    [sym_union_specifier] = STATE(755),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(52),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(52),
    [sym_placeholder_type_specifier] = STATE(755),
    [sym_decltype] = STATE(756),
    [sym_class_specifier] = STATE(755),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(755),
    [sym_template_declaration] = STATE(52),
    [sym_template_instantiation] = STATE(52),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(52),
    [sym_operator_cast_declaration] = STATE(52),
    [sym_constructor_or_destructor_definition] = STATE(52),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(855),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(52),
    [sym_namespace_alias_definition] = STATE(52),
    [sym_using_declaration] = STATE(52),
    [sym_alias_declaration] = STATE(52),
    [sym_static_assert_declaration] = STATE(52),
    [sym_concept_definition] = STATE(52),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6984),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(856),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(755),
    [sym_extension_specifier] = STATE(755),
    [sym_associatedtype_specifier] = STATE(755),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_declaration_list_repeat1] = STATE(52),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(424),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(1035),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1177),
    [anon_sym_signed] = ACTIONS(1039),
    [anon_sym_unsigned] = ACTIONS(1039),
    [anon_sym_long] = ACTIONS(1039),
    [anon_sym_short] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1041),
    [anon_sym_enum] = ACTIONS(1043),
    [anon_sym_class] = ACTIONS(1045),
    [anon_sym_struct] = ACTIONS(1047),
    [anon_sym_union] = ACTIONS(1049),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1051),
    [anon_sym_let] = ACTIONS(1051),
    [anon_sym_This] = ACTIONS(1051),
    [anon_sym_decltype] = ACTIONS(1053),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(1055),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(1057),
    [anon_sym_extension] = ACTIONS(1059),
  },
  [51] = {
    [sym__block_item] = STATE(36),
    [sym_preproc_include] = STATE(36),
    [sym_preproc_def] = STATE(36),
    [sym_preproc_function_def] = STATE(36),
    [sym_preproc_call] = STATE(36),
    [sym_preproc_if] = STATE(36),
    [sym_preproc_ifdef] = STATE(36),
    [sym_function_definition] = STATE(36),
    [sym_declaration] = STATE(36),
    [sym_type_definition] = STATE(36),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(36),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(36),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(36),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(36),
    [sym_template_instantiation] = STATE(36),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(36),
    [sym_operator_cast_declaration] = STATE(36),
    [sym_constructor_or_destructor_definition] = STATE(36),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(36),
    [sym_namespace_alias_definition] = STATE(36),
    [sym_using_declaration] = STATE(36),
    [sym_alias_declaration] = STATE(36),
    [sym_static_assert_declaration] = STATE(36),
    [sym_concept_definition] = STATE(36),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(36),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1179),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [52] = {
    [sym__block_item] = STATE(79),
    [sym_preproc_include] = STATE(79),
    [sym_preproc_def] = STATE(79),
    [sym_preproc_function_def] = STATE(79),
    [sym_preproc_call] = STATE(79),
    [sym_preproc_if] = STATE(79),
    [sym_preproc_ifdef] = STATE(79),
    [sym_function_definition] = STATE(79),
    [sym_declaration] = STATE(79),
    [sym_type_definition] = STATE(79),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(79),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(248),
    [sym_sized_type_specifier] = STATE(755),
    [sym_enum_specifier] = STATE(755),
    [sym_struct_specifier] = STATE(755),
    [sym_union_specifier] = STATE(755),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(79),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(79),
    [sym_placeholder_type_specifier] = STATE(755),
    [sym_decltype] = STATE(756),
    [sym_class_specifier] = STATE(755),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(755),
    [sym_template_declaration] = STATE(79),
    [sym_template_instantiation] = STATE(79),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(79),
    [sym_operator_cast_declaration] = STATE(79),
    [sym_constructor_or_destructor_definition] = STATE(79),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(855),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(79),
    [sym_namespace_alias_definition] = STATE(79),
    [sym_using_declaration] = STATE(79),
    [sym_alias_declaration] = STATE(79),
    [sym_static_assert_declaration] = STATE(79),
    [sym_concept_definition] = STATE(79),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6984),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(856),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(755),
    [sym_extension_specifier] = STATE(755),
    [sym_associatedtype_specifier] = STATE(755),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_declaration_list_repeat1] = STATE(79),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(424),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(1035),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym_signed] = ACTIONS(1039),
    [anon_sym_unsigned] = ACTIONS(1039),
    [anon_sym_long] = ACTIONS(1039),
    [anon_sym_short] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1041),
    [anon_sym_enum] = ACTIONS(1043),
    [anon_sym_class] = ACTIONS(1045),
    [anon_sym_struct] = ACTIONS(1047),
    [anon_sym_union] = ACTIONS(1049),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1051),
    [anon_sym_let] = ACTIONS(1051),
    [anon_sym_This] = ACTIONS(1051),
    [anon_sym_decltype] = ACTIONS(1053),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(1055),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(1057),
    [anon_sym_extension] = ACTIONS(1059),
  },
  [53] = {
    [sym__block_item] = STATE(53),
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(53),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(53),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(53),
    [sym_template_instantiation] = STATE(53),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(53),
    [sym_operator_cast_declaration] = STATE(53),
    [sym_constructor_or_destructor_definition] = STATE(53),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(53),
    [sym_namespace_alias_definition] = STATE(53),
    [sym_using_declaration] = STATE(53),
    [sym_alias_declaration] = STATE(53),
    [sym_static_assert_declaration] = STATE(53),
    [sym_concept_definition] = STATE(53),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(1183),
    [aux_sym_preproc_include_token1] = ACTIONS(1186),
    [aux_sym_preproc_def_token1] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1192),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1195),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1195),
    [sym_preproc_directive] = ACTIONS(1198),
    [anon_sym_LPAREN2] = ACTIONS(425),
    [anon_sym_BANG] = ACTIONS(428),
    [anon_sym_TILDE] = ACTIONS(431),
    [anon_sym_DASH] = ACTIONS(434),
    [anon_sym_PLUS] = ACTIONS(434),
    [anon_sym_STAR] = ACTIONS(437),
    [anon_sym_AMP_AMP] = ACTIONS(440),
    [anon_sym_AMP] = ACTIONS(443),
    [anon_sym_SEMI] = ACTIONS(1201),
    [anon_sym___extension__] = ACTIONS(1204),
    [anon_sym_typedef] = ACTIONS(1207),
    [anon_sym_in] = ACTIONS(455),
    [anon_sym_out] = ACTIONS(455),
    [anon_sym_inout] = ACTIONS(455),
    [anon_sym_virtual] = ACTIONS(455),
    [anon_sym_extern] = ACTIONS(1210),
    [anon_sym___attribute__] = ACTIONS(461),
    [anon_sym___attribute] = ACTIONS(461),
    [anon_sym_using] = ACTIONS(1213),
    [anon_sym_COLON_COLON] = ACTIONS(467),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(470),
    [anon_sym___declspec] = ACTIONS(473),
    [anon_sym___based] = ACTIONS(476),
    [anon_sym___cdecl] = ACTIONS(479),
    [anon_sym___clrcall] = ACTIONS(479),
    [anon_sym___stdcall] = ACTIONS(479),
    [anon_sym___fastcall] = ACTIONS(479),
    [anon_sym___thiscall] = ACTIONS(479),
    [anon_sym___vectorcall] = ACTIONS(479),
    [anon_sym_LBRACE] = ACTIONS(1216),
    [anon_sym_RBRACE] = ACTIONS(1219),
    [anon_sym_signed] = ACTIONS(485),
    [anon_sym_unsigned] = ACTIONS(485),
    [anon_sym_long] = ACTIONS(485),
    [anon_sym_short] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_register] = ACTIONS(491),
    [anon_sym_inline] = ACTIONS(1221),
    [anon_sym___inline] = ACTIONS(491),
    [anon_sym___inline__] = ACTIONS(491),
    [anon_sym___forceinline] = ACTIONS(491),
    [anon_sym_thread_local] = ACTIONS(491),
    [anon_sym___thread] = ACTIONS(491),
    [anon_sym_const] = ACTIONS(497),
    [anon_sym_constexpr] = ACTIONS(497),
    [anon_sym_volatile] = ACTIONS(497),
    [anon_sym_restrict] = ACTIONS(497),
    [anon_sym___restrict__] = ACTIONS(497),
    [anon_sym__Atomic] = ACTIONS(497),
    [anon_sym__Noreturn] = ACTIONS(497),
    [anon_sym_noreturn] = ACTIONS(497),
    [anon_sym__Nonnull] = ACTIONS(497),
    [anon_sym_mutable] = ACTIONS(497),
    [anon_sym_constinit] = ACTIONS(497),
    [anon_sym_consteval] = ACTIONS(497),
    [anon_sym_alignas] = ACTIONS(500),
    [anon_sym__Alignas] = ACTIONS(500),
    [sym_primitive_type] = ACTIONS(503),
    [anon_sym_enum] = ACTIONS(506),
    [anon_sym_class] = ACTIONS(509),
    [anon_sym_struct] = ACTIONS(512),
    [anon_sym_union] = ACTIONS(515),
    [anon_sym_if] = ACTIONS(1224),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_case] = ACTIONS(1230),
    [anon_sym_default] = ACTIONS(1233),
    [anon_sym_while] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(1239),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_return] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1248),
    [anon_sym_continue] = ACTIONS(1251),
    [anon_sym_goto] = ACTIONS(1254),
    [anon_sym___try] = ACTIONS(1257),
    [anon_sym___leave] = ACTIONS(1260),
    [anon_sym_not] = ACTIONS(434),
    [anon_sym_compl] = ACTIONS(434),
    [anon_sym_DASH_DASH] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(557),
    [anon_sym_sizeof] = ACTIONS(560),
    [anon_sym___alignof__] = ACTIONS(563),
    [anon_sym___alignof] = ACTIONS(563),
    [anon_sym__alignof] = ACTIONS(563),
    [anon_sym_alignof] = ACTIONS(563),
    [anon_sym__Alignof] = ACTIONS(563),
    [anon_sym_offsetof] = ACTIONS(566),
    [anon_sym__Generic] = ACTIONS(569),
    [anon_sym_asm] = ACTIONS(572),
    [anon_sym___asm__] = ACTIONS(572),
    [anon_sym___asm] = ACTIONS(572),
    [sym_number_literal] = ACTIONS(575),
    [anon_sym_L_SQUOTE] = ACTIONS(578),
    [anon_sym_u_SQUOTE] = ACTIONS(578),
    [anon_sym_U_SQUOTE] = ACTIONS(578),
    [anon_sym_u8_SQUOTE] = ACTIONS(578),
    [anon_sym_SQUOTE] = ACTIONS(578),
    [anon_sym_L_DQUOTE] = ACTIONS(581),
    [anon_sym_u_DQUOTE] = ACTIONS(581),
    [anon_sym_U_DQUOTE] = ACTIONS(581),
    [anon_sym_u8_DQUOTE] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(581),
    [sym_true] = ACTIONS(584),
    [sym_false] = ACTIONS(584),
    [anon_sym_NULL] = ACTIONS(587),
    [anon_sym_nullptr] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(590),
    [anon_sym_let] = ACTIONS(590),
    [anon_sym_This] = ACTIONS(590),
    [anon_sym_decltype] = ACTIONS(593),
    [anon_sym_explicit] = ACTIONS(596),
    [anon_sym_typename] = ACTIONS(599),
    [anon_sym_template] = ACTIONS(1263),
    [anon_sym_operator] = ACTIONS(605),
    [anon_sym_try] = ACTIONS(1266),
    [anon_sym_delete] = ACTIONS(611),
    [anon_sym_throw] = ACTIONS(1269),
    [anon_sym_namespace] = ACTIONS(1272),
    [anon_sym_static_assert] = ACTIONS(1275),
    [anon_sym_concept] = ACTIONS(1278),
    [anon_sym_co_return] = ACTIONS(1281),
    [anon_sym_co_yield] = ACTIONS(1284),
    [anon_sym_R_DQUOTE] = ACTIONS(632),
    [anon_sym_LR_DQUOTE] = ACTIONS(632),
    [anon_sym_uR_DQUOTE] = ACTIONS(632),
    [anon_sym_UR_DQUOTE] = ACTIONS(632),
    [anon_sym_u8R_DQUOTE] = ACTIONS(632),
    [anon_sym_co_await] = ACTIONS(635),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_requires] = ACTIONS(641),
    [sym_this] = ACTIONS(584),
    [anon_sym_discard] = ACTIONS(1287),
    [anon_sym_precise] = ACTIONS(647),
    [anon_sym_shared] = ACTIONS(647),
    [anon_sym_groupshared] = ACTIONS(647),
    [anon_sym_uniform] = ACTIONS(647),
    [anon_sym_row_major] = ACTIONS(647),
    [anon_sym_column_major] = ACTIONS(647),
    [anon_sym_globallycoherent] = ACTIONS(647),
    [anon_sym_centroid] = ACTIONS(647),
    [anon_sym_noperspective] = ACTIONS(647),
    [anon_sym_nointerpolation] = ACTIONS(647),
    [anon_sym_sample] = ACTIONS(647),
    [anon_sym_linear] = ACTIONS(647),
    [anon_sym_snorm] = ACTIONS(647),
    [anon_sym_unorm] = ACTIONS(647),
    [anon_sym_point] = ACTIONS(647),
    [anon_sym_line] = ACTIONS(647),
    [anon_sym_triangleadj] = ACTIONS(647),
    [anon_sym_lineadj] = ACTIONS(647),
    [anon_sym_triangle] = ACTIONS(647),
    [anon_sym_cbuffer] = ACTIONS(1290),
    [anon_sym_interface] = ACTIONS(653),
    [anon_sym_extension] = ACTIONS(656),
  },
  [54] = {
    [sym__block_item] = STATE(55),
    [sym_preproc_include] = STATE(55),
    [sym_preproc_def] = STATE(55),
    [sym_preproc_function_def] = STATE(55),
    [sym_preproc_call] = STATE(55),
    [sym_preproc_if] = STATE(55),
    [sym_preproc_ifdef] = STATE(55),
    [sym_function_definition] = STATE(55),
    [sym_declaration] = STATE(55),
    [sym_type_definition] = STATE(55),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(55),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(55),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(55),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(55),
    [sym_template_instantiation] = STATE(55),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(55),
    [sym_operator_cast_declaration] = STATE(55),
    [sym_constructor_or_destructor_definition] = STATE(55),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(55),
    [sym_namespace_alias_definition] = STATE(55),
    [sym_using_declaration] = STATE(55),
    [sym_alias_declaration] = STATE(55),
    [sym_static_assert_declaration] = STATE(55),
    [sym_concept_definition] = STATE(55),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(55),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1293),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [55] = {
    [sym__block_item] = STATE(53),
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(53),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(53),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(53),
    [sym_template_instantiation] = STATE(53),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(53),
    [sym_operator_cast_declaration] = STATE(53),
    [sym_constructor_or_destructor_definition] = STATE(53),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(53),
    [sym_namespace_alias_definition] = STATE(53),
    [sym_using_declaration] = STATE(53),
    [sym_alias_declaration] = STATE(53),
    [sym_static_assert_declaration] = STATE(53),
    [sym_concept_definition] = STATE(53),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1295),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [56] = {
    [sym__block_item] = STATE(57),
    [sym_preproc_include] = STATE(57),
    [sym_preproc_def] = STATE(57),
    [sym_preproc_function_def] = STATE(57),
    [sym_preproc_call] = STATE(57),
    [sym_preproc_if] = STATE(57),
    [sym_preproc_ifdef] = STATE(57),
    [sym_function_definition] = STATE(57),
    [sym_declaration] = STATE(57),
    [sym_type_definition] = STATE(57),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(57),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(57),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(57),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(57),
    [sym_template_instantiation] = STATE(57),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(57),
    [sym_operator_cast_declaration] = STATE(57),
    [sym_constructor_or_destructor_definition] = STATE(57),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(57),
    [sym_namespace_alias_definition] = STATE(57),
    [sym_using_declaration] = STATE(57),
    [sym_alias_declaration] = STATE(57),
    [sym_static_assert_declaration] = STATE(57),
    [sym_concept_definition] = STATE(57),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(57),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1297),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [57] = {
    [sym__block_item] = STATE(53),
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(53),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(53),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(53),
    [sym_template_instantiation] = STATE(53),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(53),
    [sym_operator_cast_declaration] = STATE(53),
    [sym_constructor_or_destructor_definition] = STATE(53),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(53),
    [sym_namespace_alias_definition] = STATE(53),
    [sym_using_declaration] = STATE(53),
    [sym_alias_declaration] = STATE(53),
    [sym_static_assert_declaration] = STATE(53),
    [sym_concept_definition] = STATE(53),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1299),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [58] = {
    [sym__block_item] = STATE(59),
    [sym_preproc_include] = STATE(59),
    [sym_preproc_def] = STATE(59),
    [sym_preproc_function_def] = STATE(59),
    [sym_preproc_call] = STATE(59),
    [sym_preproc_if] = STATE(59),
    [sym_preproc_ifdef] = STATE(59),
    [sym_function_definition] = STATE(59),
    [sym_declaration] = STATE(59),
    [sym_type_definition] = STATE(59),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(59),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(59),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(59),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(59),
    [sym_template_instantiation] = STATE(59),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(59),
    [sym_operator_cast_declaration] = STATE(59),
    [sym_constructor_or_destructor_definition] = STATE(59),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(59),
    [sym_namespace_alias_definition] = STATE(59),
    [sym_using_declaration] = STATE(59),
    [sym_alias_declaration] = STATE(59),
    [sym_static_assert_declaration] = STATE(59),
    [sym_concept_definition] = STATE(59),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(59),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1301),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [59] = {
    [sym__block_item] = STATE(53),
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(53),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(53),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(53),
    [sym_template_instantiation] = STATE(53),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(53),
    [sym_operator_cast_declaration] = STATE(53),
    [sym_constructor_or_destructor_definition] = STATE(53),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(53),
    [sym_namespace_alias_definition] = STATE(53),
    [sym_using_declaration] = STATE(53),
    [sym_alias_declaration] = STATE(53),
    [sym_static_assert_declaration] = STATE(53),
    [sym_concept_definition] = STATE(53),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1303),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [60] = {
    [sym__block_item] = STATE(61),
    [sym_preproc_include] = STATE(61),
    [sym_preproc_def] = STATE(61),
    [sym_preproc_function_def] = STATE(61),
    [sym_preproc_call] = STATE(61),
    [sym_preproc_if] = STATE(61),
    [sym_preproc_ifdef] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_declaration] = STATE(61),
    [sym_type_definition] = STATE(61),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(61),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(61),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(61),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(61),
    [sym_template_instantiation] = STATE(61),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(61),
    [sym_operator_cast_declaration] = STATE(61),
    [sym_constructor_or_destructor_definition] = STATE(61),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(61),
    [sym_namespace_alias_definition] = STATE(61),
    [sym_using_declaration] = STATE(61),
    [sym_alias_declaration] = STATE(61),
    [sym_static_assert_declaration] = STATE(61),
    [sym_concept_definition] = STATE(61),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(61),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [61] = {
    [sym__block_item] = STATE(53),
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(53),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(53),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(53),
    [sym_template_instantiation] = STATE(53),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(53),
    [sym_operator_cast_declaration] = STATE(53),
    [sym_constructor_or_destructor_definition] = STATE(53),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(53),
    [sym_namespace_alias_definition] = STATE(53),
    [sym_using_declaration] = STATE(53),
    [sym_alias_declaration] = STATE(53),
    [sym_static_assert_declaration] = STATE(53),
    [sym_concept_definition] = STATE(53),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1307),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [62] = {
    [sym__block_item] = STATE(63),
    [sym_preproc_include] = STATE(63),
    [sym_preproc_def] = STATE(63),
    [sym_preproc_function_def] = STATE(63),
    [sym_preproc_call] = STATE(63),
    [sym_preproc_if] = STATE(63),
    [sym_preproc_ifdef] = STATE(63),
    [sym_function_definition] = STATE(63),
    [sym_declaration] = STATE(63),
    [sym_type_definition] = STATE(63),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(63),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(63),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(63),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(63),
    [sym_template_instantiation] = STATE(63),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(63),
    [sym_operator_cast_declaration] = STATE(63),
    [sym_constructor_or_destructor_definition] = STATE(63),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(63),
    [sym_namespace_alias_definition] = STATE(63),
    [sym_using_declaration] = STATE(63),
    [sym_alias_declaration] = STATE(63),
    [sym_static_assert_declaration] = STATE(63),
    [sym_concept_definition] = STATE(63),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(63),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1309),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [63] = {
    [sym__block_item] = STATE(53),
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(53),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(53),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(53),
    [sym_template_instantiation] = STATE(53),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(53),
    [sym_operator_cast_declaration] = STATE(53),
    [sym_constructor_or_destructor_definition] = STATE(53),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(53),
    [sym_namespace_alias_definition] = STATE(53),
    [sym_using_declaration] = STATE(53),
    [sym_alias_declaration] = STATE(53),
    [sym_static_assert_declaration] = STATE(53),
    [sym_concept_definition] = STATE(53),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1311),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [64] = {
    [sym__block_item] = STATE(65),
    [sym_preproc_include] = STATE(65),
    [sym_preproc_def] = STATE(65),
    [sym_preproc_function_def] = STATE(65),
    [sym_preproc_call] = STATE(65),
    [sym_preproc_if] = STATE(65),
    [sym_preproc_ifdef] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_declaration] = STATE(65),
    [sym_type_definition] = STATE(65),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(65),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(65),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(65),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(65),
    [sym_template_instantiation] = STATE(65),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(65),
    [sym_operator_cast_declaration] = STATE(65),
    [sym_constructor_or_destructor_definition] = STATE(65),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(65),
    [sym_namespace_alias_definition] = STATE(65),
    [sym_using_declaration] = STATE(65),
    [sym_alias_declaration] = STATE(65),
    [sym_static_assert_declaration] = STATE(65),
    [sym_concept_definition] = STATE(65),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(65),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1313),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [65] = {
    [sym__block_item] = STATE(53),
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(53),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(53),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(53),
    [sym_template_instantiation] = STATE(53),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(53),
    [sym_operator_cast_declaration] = STATE(53),
    [sym_constructor_or_destructor_definition] = STATE(53),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(53),
    [sym_namespace_alias_definition] = STATE(53),
    [sym_using_declaration] = STATE(53),
    [sym_alias_declaration] = STATE(53),
    [sym_static_assert_declaration] = STATE(53),
    [sym_concept_definition] = STATE(53),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1315),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [66] = {
    [sym__block_item] = STATE(67),
    [sym_preproc_include] = STATE(67),
    [sym_preproc_def] = STATE(67),
    [sym_preproc_function_def] = STATE(67),
    [sym_preproc_call] = STATE(67),
    [sym_preproc_if] = STATE(67),
    [sym_preproc_ifdef] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_declaration] = STATE(67),
    [sym_type_definition] = STATE(67),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(67),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(67),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(67),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(67),
    [sym_template_instantiation] = STATE(67),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(67),
    [sym_operator_cast_declaration] = STATE(67),
    [sym_constructor_or_destructor_definition] = STATE(67),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(67),
    [sym_namespace_alias_definition] = STATE(67),
    [sym_using_declaration] = STATE(67),
    [sym_alias_declaration] = STATE(67),
    [sym_static_assert_declaration] = STATE(67),
    [sym_concept_definition] = STATE(67),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(67),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [67] = {
    [sym__block_item] = STATE(53),
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(53),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(53),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(53),
    [sym_template_instantiation] = STATE(53),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(53),
    [sym_operator_cast_declaration] = STATE(53),
    [sym_constructor_or_destructor_definition] = STATE(53),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(53),
    [sym_namespace_alias_definition] = STATE(53),
    [sym_using_declaration] = STATE(53),
    [sym_alias_declaration] = STATE(53),
    [sym_static_assert_declaration] = STATE(53),
    [sym_concept_definition] = STATE(53),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1319),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [68] = {
    [sym__block_item] = STATE(69),
    [sym_preproc_include] = STATE(69),
    [sym_preproc_def] = STATE(69),
    [sym_preproc_function_def] = STATE(69),
    [sym_preproc_call] = STATE(69),
    [sym_preproc_if] = STATE(69),
    [sym_preproc_ifdef] = STATE(69),
    [sym_function_definition] = STATE(69),
    [sym_declaration] = STATE(69),
    [sym_type_definition] = STATE(69),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(69),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(69),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(69),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(69),
    [sym_template_instantiation] = STATE(69),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(69),
    [sym_operator_cast_declaration] = STATE(69),
    [sym_constructor_or_destructor_definition] = STATE(69),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(69),
    [sym_namespace_alias_definition] = STATE(69),
    [sym_using_declaration] = STATE(69),
    [sym_alias_declaration] = STATE(69),
    [sym_static_assert_declaration] = STATE(69),
    [sym_concept_definition] = STATE(69),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(69),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1321),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [69] = {
    [sym__block_item] = STATE(53),
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(53),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(53),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(53),
    [sym_template_instantiation] = STATE(53),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(53),
    [sym_operator_cast_declaration] = STATE(53),
    [sym_constructor_or_destructor_definition] = STATE(53),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(53),
    [sym_namespace_alias_definition] = STATE(53),
    [sym_using_declaration] = STATE(53),
    [sym_alias_declaration] = STATE(53),
    [sym_static_assert_declaration] = STATE(53),
    [sym_concept_definition] = STATE(53),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1323),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [70] = {
    [sym__block_item] = STATE(71),
    [sym_preproc_include] = STATE(71),
    [sym_preproc_def] = STATE(71),
    [sym_preproc_function_def] = STATE(71),
    [sym_preproc_call] = STATE(71),
    [sym_preproc_if] = STATE(71),
    [sym_preproc_ifdef] = STATE(71),
    [sym_function_definition] = STATE(71),
    [sym_declaration] = STATE(71),
    [sym_type_definition] = STATE(71),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(71),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(71),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(71),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(71),
    [sym_template_instantiation] = STATE(71),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(71),
    [sym_operator_cast_declaration] = STATE(71),
    [sym_constructor_or_destructor_definition] = STATE(71),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(71),
    [sym_namespace_alias_definition] = STATE(71),
    [sym_using_declaration] = STATE(71),
    [sym_alias_declaration] = STATE(71),
    [sym_static_assert_declaration] = STATE(71),
    [sym_concept_definition] = STATE(71),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(71),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1325),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [71] = {
    [sym__block_item] = STATE(53),
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(53),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(53),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(53),
    [sym_template_instantiation] = STATE(53),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(53),
    [sym_operator_cast_declaration] = STATE(53),
    [sym_constructor_or_destructor_definition] = STATE(53),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(53),
    [sym_namespace_alias_definition] = STATE(53),
    [sym_using_declaration] = STATE(53),
    [sym_alias_declaration] = STATE(53),
    [sym_static_assert_declaration] = STATE(53),
    [sym_concept_definition] = STATE(53),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1327),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [72] = {
    [sym__block_item] = STATE(73),
    [sym_preproc_include] = STATE(73),
    [sym_preproc_def] = STATE(73),
    [sym_preproc_function_def] = STATE(73),
    [sym_preproc_call] = STATE(73),
    [sym_preproc_if] = STATE(73),
    [sym_preproc_ifdef] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_declaration] = STATE(73),
    [sym_type_definition] = STATE(73),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(73),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(73),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(73),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(73),
    [sym_template_instantiation] = STATE(73),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(73),
    [sym_operator_cast_declaration] = STATE(73),
    [sym_constructor_or_destructor_definition] = STATE(73),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(73),
    [sym_namespace_alias_definition] = STATE(73),
    [sym_using_declaration] = STATE(73),
    [sym_alias_declaration] = STATE(73),
    [sym_static_assert_declaration] = STATE(73),
    [sym_concept_definition] = STATE(73),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(73),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1329),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [73] = {
    [sym__block_item] = STATE(53),
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(53),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(53),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(53),
    [sym_template_instantiation] = STATE(53),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(53),
    [sym_operator_cast_declaration] = STATE(53),
    [sym_constructor_or_destructor_definition] = STATE(53),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(53),
    [sym_namespace_alias_definition] = STATE(53),
    [sym_using_declaration] = STATE(53),
    [sym_alias_declaration] = STATE(53),
    [sym_static_assert_declaration] = STATE(53),
    [sym_concept_definition] = STATE(53),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1331),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [74] = {
    [sym__block_item] = STATE(75),
    [sym_preproc_include] = STATE(75),
    [sym_preproc_def] = STATE(75),
    [sym_preproc_function_def] = STATE(75),
    [sym_preproc_call] = STATE(75),
    [sym_preproc_if] = STATE(75),
    [sym_preproc_ifdef] = STATE(75),
    [sym_function_definition] = STATE(75),
    [sym_declaration] = STATE(75),
    [sym_type_definition] = STATE(75),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(75),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(75),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(75),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(75),
    [sym_template_instantiation] = STATE(75),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(75),
    [sym_operator_cast_declaration] = STATE(75),
    [sym_constructor_or_destructor_definition] = STATE(75),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(75),
    [sym_namespace_alias_definition] = STATE(75),
    [sym_using_declaration] = STATE(75),
    [sym_alias_declaration] = STATE(75),
    [sym_static_assert_declaration] = STATE(75),
    [sym_concept_definition] = STATE(75),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(75),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1333),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [75] = {
    [sym__block_item] = STATE(53),
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(53),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(53),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(53),
    [sym_template_instantiation] = STATE(53),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(53),
    [sym_operator_cast_declaration] = STATE(53),
    [sym_constructor_or_destructor_definition] = STATE(53),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(53),
    [sym_namespace_alias_definition] = STATE(53),
    [sym_using_declaration] = STATE(53),
    [sym_alias_declaration] = STATE(53),
    [sym_static_assert_declaration] = STATE(53),
    [sym_concept_definition] = STATE(53),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1335),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [76] = {
    [sym__block_item] = STATE(77),
    [sym_preproc_include] = STATE(77),
    [sym_preproc_def] = STATE(77),
    [sym_preproc_function_def] = STATE(77),
    [sym_preproc_call] = STATE(77),
    [sym_preproc_if] = STATE(77),
    [sym_preproc_ifdef] = STATE(77),
    [sym_function_definition] = STATE(77),
    [sym_declaration] = STATE(77),
    [sym_type_definition] = STATE(77),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(77),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(77),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(77),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(77),
    [sym_template_instantiation] = STATE(77),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(77),
    [sym_operator_cast_declaration] = STATE(77),
    [sym_constructor_or_destructor_definition] = STATE(77),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(77),
    [sym_namespace_alias_definition] = STATE(77),
    [sym_using_declaration] = STATE(77),
    [sym_alias_declaration] = STATE(77),
    [sym_static_assert_declaration] = STATE(77),
    [sym_concept_definition] = STATE(77),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(77),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1337),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [77] = {
    [sym__block_item] = STATE(53),
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(53),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(53),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(53),
    [sym_template_instantiation] = STATE(53),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(53),
    [sym_operator_cast_declaration] = STATE(53),
    [sym_constructor_or_destructor_definition] = STATE(53),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(53),
    [sym_namespace_alias_definition] = STATE(53),
    [sym_using_declaration] = STATE(53),
    [sym_alias_declaration] = STATE(53),
    [sym_static_assert_declaration] = STATE(53),
    [sym_concept_definition] = STATE(53),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1339),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [78] = {
    [sym__block_item] = STATE(31),
    [sym_preproc_include] = STATE(31),
    [sym_preproc_def] = STATE(31),
    [sym_preproc_function_def] = STATE(31),
    [sym_preproc_call] = STATE(31),
    [sym_preproc_if] = STATE(31),
    [sym_preproc_ifdef] = STATE(31),
    [sym_function_definition] = STATE(31),
    [sym_declaration] = STATE(31),
    [sym_type_definition] = STATE(31),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(31),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(31),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(31),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(31),
    [sym_template_instantiation] = STATE(31),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(31),
    [sym_operator_cast_declaration] = STATE(31),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(31),
    [sym_namespace_alias_definition] = STATE(31),
    [sym_using_declaration] = STATE(31),
    [sym_alias_declaration] = STATE(31),
    [sym_static_assert_declaration] = STATE(31),
    [sym_concept_definition] = STATE(31),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7015),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_repeat1] = STATE(31),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(915),
    [aux_sym_preproc_include_token1] = ACTIONS(177),
    [aux_sym_preproc_def_token1] = ACTIONS(179),
    [aux_sym_preproc_if_token1] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(185),
    [sym_preproc_directive] = ACTIONS(187),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(191),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(195),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1341),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(207),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(257),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_static_assert] = ACTIONS(265),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [79] = {
    [sym__block_item] = STATE(79),
    [sym_preproc_include] = STATE(79),
    [sym_preproc_def] = STATE(79),
    [sym_preproc_function_def] = STATE(79),
    [sym_preproc_call] = STATE(79),
    [sym_preproc_if] = STATE(79),
    [sym_preproc_ifdef] = STATE(79),
    [sym_function_definition] = STATE(79),
    [sym_declaration] = STATE(79),
    [sym_type_definition] = STATE(79),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_linkage_specification] = STATE(79),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(1276),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8056),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(248),
    [sym_sized_type_specifier] = STATE(755),
    [sym_enum_specifier] = STATE(755),
    [sym_struct_specifier] = STATE(755),
    [sym_union_specifier] = STATE(755),
    [sym_attributed_statement] = STATE(1061),
    [sym_statement] = STATE(79),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym__empty_declaration] = STATE(79),
    [sym_placeholder_type_specifier] = STATE(755),
    [sym_decltype] = STATE(756),
    [sym_class_specifier] = STATE(755),
    [sym__class_name] = STATE(10558),
    [sym_explicit_function_specifier] = STATE(2670),
    [sym_dependent_type] = STATE(755),
    [sym_template_declaration] = STATE(79),
    [sym_template_instantiation] = STATE(79),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2670),
    [sym_operator_cast_definition] = STATE(79),
    [sym_operator_cast_declaration] = STATE(79),
    [sym_constructor_or_destructor_definition] = STATE(79),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(855),
    [sym_template_function] = STATE(5729),
    [sym_namespace_definition] = STATE(79),
    [sym_namespace_alias_definition] = STATE(79),
    [sym_using_declaration] = STATE(79),
    [sym_alias_declaration] = STATE(79),
    [sym_static_assert_declaration] = STATE(79),
    [sym_concept_definition] = STATE(79),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6984),
    [sym_qualified_identifier] = STATE(4367),
    [sym_qualified_type_identifier] = STATE(856),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2919),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(1626),
    [sym_interface_specifier] = STATE(755),
    [sym_extension_specifier] = STATE(755),
    [sym_associatedtype_specifier] = STATE(755),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_declaration_list_repeat1] = STATE(79),
    [aux_sym_attributed_declarator_repeat1] = STATE(1195),
    [aux_sym_sized_type_specifier_repeat1] = STATE(424),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2670),
    [sym_identifier] = ACTIONS(1343),
    [aux_sym_preproc_include_token1] = ACTIONS(1346),
    [aux_sym_preproc_def_token1] = ACTIONS(1349),
    [aux_sym_preproc_if_token1] = ACTIONS(1352),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1355),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1355),
    [sym_preproc_directive] = ACTIONS(1358),
    [anon_sym_LPAREN2] = ACTIONS(1361),
    [anon_sym_BANG] = ACTIONS(1364),
    [anon_sym_TILDE] = ACTIONS(1367),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1376),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_SEMI] = ACTIONS(1382),
    [anon_sym___extension__] = ACTIONS(1385),
    [anon_sym_typedef] = ACTIONS(1388),
    [anon_sym_in] = ACTIONS(1391),
    [anon_sym_out] = ACTIONS(1391),
    [anon_sym_inout] = ACTIONS(1391),
    [anon_sym_virtual] = ACTIONS(1391),
    [anon_sym_extern] = ACTIONS(1394),
    [anon_sym___attribute__] = ACTIONS(1397),
    [anon_sym___attribute] = ACTIONS(1397),
    [anon_sym_using] = ACTIONS(1400),
    [anon_sym_COLON_COLON] = ACTIONS(1403),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1406),
    [anon_sym___declspec] = ACTIONS(1409),
    [anon_sym___based] = ACTIONS(1412),
    [anon_sym___cdecl] = ACTIONS(1415),
    [anon_sym___clrcall] = ACTIONS(1415),
    [anon_sym___stdcall] = ACTIONS(1415),
    [anon_sym___fastcall] = ACTIONS(1415),
    [anon_sym___thiscall] = ACTIONS(1415),
    [anon_sym___vectorcall] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(1418),
    [anon_sym_RBRACE] = ACTIONS(1421),
    [anon_sym_signed] = ACTIONS(1423),
    [anon_sym_unsigned] = ACTIONS(1423),
    [anon_sym_long] = ACTIONS(1423),
    [anon_sym_short] = ACTIONS(1423),
    [anon_sym_LBRACK] = ACTIONS(1426),
    [anon_sym_static] = ACTIONS(1429),
    [anon_sym_register] = ACTIONS(1429),
    [anon_sym_inline] = ACTIONS(1432),
    [anon_sym___inline] = ACTIONS(1429),
    [anon_sym___inline__] = ACTIONS(1429),
    [anon_sym___forceinline] = ACTIONS(1429),
    [anon_sym_thread_local] = ACTIONS(1429),
    [anon_sym___thread] = ACTIONS(1429),
    [anon_sym_const] = ACTIONS(1435),
    [anon_sym_constexpr] = ACTIONS(1435),
    [anon_sym_volatile] = ACTIONS(1435),
    [anon_sym_restrict] = ACTIONS(1435),
    [anon_sym___restrict__] = ACTIONS(1435),
    [anon_sym__Atomic] = ACTIONS(1435),
    [anon_sym__Noreturn] = ACTIONS(1435),
    [anon_sym_noreturn] = ACTIONS(1435),
    [anon_sym__Nonnull] = ACTIONS(1435),
    [anon_sym_mutable] = ACTIONS(1435),
    [anon_sym_constinit] = ACTIONS(1435),
    [anon_sym_consteval] = ACTIONS(1435),
    [anon_sym_alignas] = ACTIONS(1438),
    [anon_sym__Alignas] = ACTIONS(1438),
    [sym_primitive_type] = ACTIONS(1441),
    [anon_sym_enum] = ACTIONS(1444),
    [anon_sym_class] = ACTIONS(1447),
    [anon_sym_struct] = ACTIONS(1450),
    [anon_sym_union] = ACTIONS(1453),
    [anon_sym_if] = ACTIONS(1456),
    [anon_sym_switch] = ACTIONS(1459),
    [anon_sym_case] = ACTIONS(1462),
    [anon_sym_default] = ACTIONS(1465),
    [anon_sym_while] = ACTIONS(1468),
    [anon_sym_do] = ACTIONS(1471),
    [anon_sym_for] = ACTIONS(1474),
    [anon_sym_return] = ACTIONS(1477),
    [anon_sym_break] = ACTIONS(1480),
    [anon_sym_continue] = ACTIONS(1483),
    [anon_sym_goto] = ACTIONS(1486),
    [anon_sym___try] = ACTIONS(1489),
    [anon_sym___leave] = ACTIONS(1492),
    [anon_sym_not] = ACTIONS(1370),
    [anon_sym_compl] = ACTIONS(1370),
    [anon_sym_DASH_DASH] = ACTIONS(1495),
    [anon_sym_PLUS_PLUS] = ACTIONS(1495),
    [anon_sym_sizeof] = ACTIONS(1498),
    [anon_sym___alignof__] = ACTIONS(1501),
    [anon_sym___alignof] = ACTIONS(1501),
    [anon_sym__alignof] = ACTIONS(1501),
    [anon_sym_alignof] = ACTIONS(1501),
    [anon_sym__Alignof] = ACTIONS(1501),
    [anon_sym_offsetof] = ACTIONS(1504),
    [anon_sym__Generic] = ACTIONS(1507),
    [anon_sym_asm] = ACTIONS(1510),
    [anon_sym___asm__] = ACTIONS(1510),
    [anon_sym___asm] = ACTIONS(1510),
    [sym_number_literal] = ACTIONS(1513),
    [anon_sym_L_SQUOTE] = ACTIONS(1516),
    [anon_sym_u_SQUOTE] = ACTIONS(1516),
    [anon_sym_U_SQUOTE] = ACTIONS(1516),
    [anon_sym_u8_SQUOTE] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(1516),
    [anon_sym_L_DQUOTE] = ACTIONS(1519),
    [anon_sym_u_DQUOTE] = ACTIONS(1519),
    [anon_sym_U_DQUOTE] = ACTIONS(1519),
    [anon_sym_u8_DQUOTE] = ACTIONS(1519),
    [anon_sym_DQUOTE] = ACTIONS(1519),
    [sym_true] = ACTIONS(1522),
    [sym_false] = ACTIONS(1522),
    [anon_sym_NULL] = ACTIONS(1525),
    [anon_sym_nullptr] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1528),
    [anon_sym_let] = ACTIONS(1528),
    [anon_sym_This] = ACTIONS(1528),
    [anon_sym_decltype] = ACTIONS(1531),
    [anon_sym_explicit] = ACTIONS(1534),
    [anon_sym_typename] = ACTIONS(1537),
    [anon_sym_template] = ACTIONS(1540),
    [anon_sym_operator] = ACTIONS(1543),
    [anon_sym_try] = ACTIONS(1546),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_throw] = ACTIONS(1552),
    [anon_sym_namespace] = ACTIONS(1555),
    [anon_sym_static_assert] = ACTIONS(1558),
    [anon_sym_concept] = ACTIONS(1561),
    [anon_sym_co_return] = ACTIONS(1564),
    [anon_sym_co_yield] = ACTIONS(1567),
    [anon_sym_R_DQUOTE] = ACTIONS(1570),
    [anon_sym_LR_DQUOTE] = ACTIONS(1570),
    [anon_sym_uR_DQUOTE] = ACTIONS(1570),
    [anon_sym_UR_DQUOTE] = ACTIONS(1570),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1570),
    [anon_sym_co_await] = ACTIONS(1573),
    [anon_sym_new] = ACTIONS(1576),
    [anon_sym_requires] = ACTIONS(1579),
    [sym_this] = ACTIONS(1522),
    [anon_sym_discard] = ACTIONS(1582),
    [anon_sym_precise] = ACTIONS(1585),
    [anon_sym_shared] = ACTIONS(1585),
    [anon_sym_groupshared] = ACTIONS(1585),
    [anon_sym_uniform] = ACTIONS(1585),
    [anon_sym_row_major] = ACTIONS(1585),
    [anon_sym_column_major] = ACTIONS(1585),
    [anon_sym_globallycoherent] = ACTIONS(1585),
    [anon_sym_centroid] = ACTIONS(1585),
    [anon_sym_noperspective] = ACTIONS(1585),
    [anon_sym_nointerpolation] = ACTIONS(1585),
    [anon_sym_sample] = ACTIONS(1585),
    [anon_sym_linear] = ACTIONS(1585),
    [anon_sym_snorm] = ACTIONS(1585),
    [anon_sym_unorm] = ACTIONS(1585),
    [anon_sym_point] = ACTIONS(1585),
    [anon_sym_line] = ACTIONS(1585),
    [anon_sym_triangleadj] = ACTIONS(1585),
    [anon_sym_lineadj] = ACTIONS(1585),
    [anon_sym_triangle] = ACTIONS(1585),
    [anon_sym_cbuffer] = ACTIONS(1588),
    [anon_sym_interface] = ACTIONS(1591),
    [anon_sym_extension] = ACTIONS(1594),
  },
  [80] = {
    [sym_declaration] = STATE(80),
    [sym_type_definition] = STATE(80),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6647),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(80),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(80),
    [sym_labeled_statement] = STATE(80),
    [sym_expression_statement] = STATE(80),
    [sym_if_statement] = STATE(80),
    [sym_switch_statement] = STATE(80),
    [sym_while_statement] = STATE(80),
    [sym_do_statement] = STATE(80),
    [sym_for_statement] = STATE(80),
    [sym_return_statement] = STATE(80),
    [sym_break_statement] = STATE(80),
    [sym_continue_statement] = STATE(80),
    [sym_goto_statement] = STATE(80),
    [sym_seh_try_statement] = STATE(80),
    [sym_seh_leave_statement] = STATE(80),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(80),
    [sym_co_return_statement] = STATE(80),
    [sym_co_yield_statement] = STATE(80),
    [sym_throw_statement] = STATE(80),
    [sym_try_statement] = STATE(80),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(80),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(80),
    [sym_hlsl_attribute] = STATE(10675),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1220),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(80),
    [sym_identifier] = ACTIONS(1597),
    [aux_sym_preproc_include_token1] = ACTIONS(1600),
    [aux_sym_preproc_def_token1] = ACTIONS(1600),
    [aux_sym_preproc_if_token1] = ACTIONS(1600),
    [aux_sym_preproc_if_token2] = ACTIONS(1600),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1600),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1600),
    [aux_sym_preproc_else_token1] = ACTIONS(1600),
    [aux_sym_preproc_elif_token1] = ACTIONS(1600),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1600),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1600),
    [sym_preproc_directive] = ACTIONS(1600),
    [anon_sym_LPAREN2] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_SEMI] = ACTIONS(1619),
    [anon_sym___extension__] = ACTIONS(1622),
    [anon_sym_typedef] = ACTIONS(1625),
    [anon_sym_in] = ACTIONS(1628),
    [anon_sym_out] = ACTIONS(1628),
    [anon_sym_inout] = ACTIONS(1628),
    [anon_sym_virtual] = ACTIONS(1628),
    [anon_sym_extern] = ACTIONS(1631),
    [anon_sym___attribute__] = ACTIONS(1634),
    [anon_sym___attribute] = ACTIONS(1634),
    [anon_sym_using] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(1637),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1640),
    [anon_sym___declspec] = ACTIONS(1643),
    [anon_sym___based] = ACTIONS(1600),
    [anon_sym___cdecl] = ACTIONS(1600),
    [anon_sym___clrcall] = ACTIONS(1600),
    [anon_sym___stdcall] = ACTIONS(1600),
    [anon_sym___fastcall] = ACTIONS(1600),
    [anon_sym___thiscall] = ACTIONS(1600),
    [anon_sym___vectorcall] = ACTIONS(1600),
    [anon_sym_LBRACE] = ACTIONS(1646),
    [anon_sym_signed] = ACTIONS(1649),
    [anon_sym_unsigned] = ACTIONS(1649),
    [anon_sym_long] = ACTIONS(1649),
    [anon_sym_short] = ACTIONS(1649),
    [anon_sym_LBRACK] = ACTIONS(1652),
    [anon_sym_static] = ACTIONS(1631),
    [anon_sym_register] = ACTIONS(1631),
    [anon_sym_inline] = ACTIONS(1631),
    [anon_sym___inline] = ACTIONS(1631),
    [anon_sym___inline__] = ACTIONS(1631),
    [anon_sym___forceinline] = ACTIONS(1631),
    [anon_sym_thread_local] = ACTIONS(1631),
    [anon_sym___thread] = ACTIONS(1631),
    [anon_sym_const] = ACTIONS(1655),
    [anon_sym_constexpr] = ACTIONS(1655),
    [anon_sym_volatile] = ACTIONS(1655),
    [anon_sym_restrict] = ACTIONS(1655),
    [anon_sym___restrict__] = ACTIONS(1655),
    [anon_sym__Atomic] = ACTIONS(1655),
    [anon_sym__Noreturn] = ACTIONS(1655),
    [anon_sym_noreturn] = ACTIONS(1655),
    [anon_sym__Nonnull] = ACTIONS(1655),
    [anon_sym_mutable] = ACTIONS(1655),
    [anon_sym_constinit] = ACTIONS(1655),
    [anon_sym_consteval] = ACTIONS(1655),
    [anon_sym_alignas] = ACTIONS(1658),
    [anon_sym__Alignas] = ACTIONS(1658),
    [sym_primitive_type] = ACTIONS(1661),
    [anon_sym_enum] = ACTIONS(1664),
    [anon_sym_class] = ACTIONS(1667),
    [anon_sym_struct] = ACTIONS(1670),
    [anon_sym_union] = ACTIONS(1673),
    [anon_sym_if] = ACTIONS(1676),
    [anon_sym_else] = ACTIONS(1600),
    [anon_sym_switch] = ACTIONS(1679),
    [anon_sym_case] = ACTIONS(1600),
    [anon_sym_default] = ACTIONS(1600),
    [anon_sym_while] = ACTIONS(1682),
    [anon_sym_do] = ACTIONS(1685),
    [anon_sym_for] = ACTIONS(1688),
    [anon_sym_return] = ACTIONS(1691),
    [anon_sym_break] = ACTIONS(1694),
    [anon_sym_continue] = ACTIONS(1697),
    [anon_sym_goto] = ACTIONS(1700),
    [anon_sym___try] = ACTIONS(1703),
    [anon_sym___leave] = ACTIONS(1706),
    [anon_sym_not] = ACTIONS(1608),
    [anon_sym_compl] = ACTIONS(1608),
    [anon_sym_DASH_DASH] = ACTIONS(1709),
    [anon_sym_PLUS_PLUS] = ACTIONS(1709),
    [anon_sym_sizeof] = ACTIONS(1712),
    [anon_sym___alignof__] = ACTIONS(1715),
    [anon_sym___alignof] = ACTIONS(1715),
    [anon_sym__alignof] = ACTIONS(1715),
    [anon_sym_alignof] = ACTIONS(1715),
    [anon_sym__Alignof] = ACTIONS(1715),
    [anon_sym_offsetof] = ACTIONS(1718),
    [anon_sym__Generic] = ACTIONS(1721),
    [anon_sym_asm] = ACTIONS(1724),
    [anon_sym___asm__] = ACTIONS(1724),
    [anon_sym___asm] = ACTIONS(1724),
    [sym_number_literal] = ACTIONS(1727),
    [anon_sym_L_SQUOTE] = ACTIONS(1730),
    [anon_sym_u_SQUOTE] = ACTIONS(1730),
    [anon_sym_U_SQUOTE] = ACTIONS(1730),
    [anon_sym_u8_SQUOTE] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1730),
    [anon_sym_L_DQUOTE] = ACTIONS(1733),
    [anon_sym_u_DQUOTE] = ACTIONS(1733),
    [anon_sym_U_DQUOTE] = ACTIONS(1733),
    [anon_sym_u8_DQUOTE] = ACTIONS(1733),
    [anon_sym_DQUOTE] = ACTIONS(1733),
    [sym_true] = ACTIONS(1736),
    [sym_false] = ACTIONS(1736),
    [anon_sym_NULL] = ACTIONS(1739),
    [anon_sym_nullptr] = ACTIONS(1739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1742),
    [anon_sym_let] = ACTIONS(1742),
    [anon_sym_This] = ACTIONS(1742),
    [anon_sym_decltype] = ACTIONS(1745),
    [anon_sym_explicit] = ACTIONS(1600),
    [anon_sym_typename] = ACTIONS(1748),
    [anon_sym_template] = ACTIONS(1751),
    [anon_sym_operator] = ACTIONS(1600),
    [anon_sym_try] = ACTIONS(1754),
    [anon_sym_delete] = ACTIONS(1757),
    [anon_sym_throw] = ACTIONS(1760),
    [anon_sym_namespace] = ACTIONS(1600),
    [anon_sym_static_assert] = ACTIONS(1600),
    [anon_sym_concept] = ACTIONS(1600),
    [anon_sym_co_return] = ACTIONS(1763),
    [anon_sym_co_yield] = ACTIONS(1766),
    [anon_sym_R_DQUOTE] = ACTIONS(1769),
    [anon_sym_LR_DQUOTE] = ACTIONS(1769),
    [anon_sym_uR_DQUOTE] = ACTIONS(1769),
    [anon_sym_UR_DQUOTE] = ACTIONS(1769),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1769),
    [anon_sym_co_await] = ACTIONS(1772),
    [anon_sym_new] = ACTIONS(1775),
    [anon_sym_requires] = ACTIONS(1778),
    [sym_this] = ACTIONS(1736),
    [anon_sym_discard] = ACTIONS(1781),
    [anon_sym_precise] = ACTIONS(1784),
    [anon_sym_shared] = ACTIONS(1784),
    [anon_sym_groupshared] = ACTIONS(1784),
    [anon_sym_uniform] = ACTIONS(1784),
    [anon_sym_row_major] = ACTIONS(1784),
    [anon_sym_column_major] = ACTIONS(1784),
    [anon_sym_globallycoherent] = ACTIONS(1784),
    [anon_sym_centroid] = ACTIONS(1784),
    [anon_sym_noperspective] = ACTIONS(1784),
    [anon_sym_nointerpolation] = ACTIONS(1784),
    [anon_sym_sample] = ACTIONS(1784),
    [anon_sym_linear] = ACTIONS(1784),
    [anon_sym_snorm] = ACTIONS(1784),
    [anon_sym_unorm] = ACTIONS(1784),
    [anon_sym_point] = ACTIONS(1784),
    [anon_sym_line] = ACTIONS(1784),
    [anon_sym_triangleadj] = ACTIONS(1784),
    [anon_sym_lineadj] = ACTIONS(1784),
    [anon_sym_triangle] = ACTIONS(1784),
    [anon_sym_cbuffer] = ACTIONS(1787),
    [anon_sym_interface] = ACTIONS(1790),
    [anon_sym_extension] = ACTIONS(1793),
  },
  [81] = {
    [sym_declaration] = STATE(84),
    [sym_type_definition] = STATE(84),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6711),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(84),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(5655),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10869),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(84),
    [sym_co_return_statement] = STATE(84),
    [sym_co_yield_statement] = STATE(84),
    [sym_throw_statement] = STATE(84),
    [sym_try_statement] = STATE(84),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(84),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(84),
    [sym_hlsl_attribute] = STATE(10450),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1226),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(84),
    [ts_builtin_sym_end] = ACTIONS(1796),
    [sym_identifier] = ACTIONS(1798),
    [aux_sym_preproc_include_token1] = ACTIONS(1800),
    [aux_sym_preproc_def_token1] = ACTIONS(1800),
    [aux_sym_preproc_if_token1] = ACTIONS(1800),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1800),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1800),
    [sym_preproc_directive] = ACTIONS(1800),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP_AMP] = ACTIONS(1796),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym___extension__] = ACTIONS(1808),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1800),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1800),
    [anon_sym___cdecl] = ACTIONS(1800),
    [anon_sym___clrcall] = ACTIONS(1800),
    [anon_sym___stdcall] = ACTIONS(1800),
    [anon_sym___fastcall] = ACTIONS(1800),
    [anon_sym___thiscall] = ACTIONS(1800),
    [anon_sym___vectorcall] = ACTIONS(1800),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_else] = ACTIONS(1800),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1800),
    [anon_sym_default] = ACTIONS(1800),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1157),
    [anon_sym___leave] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(1800),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_export] = ACTIONS(1800),
    [anon_sym_module] = ACTIONS(1800),
    [anon_sym_import] = ACTIONS(1800),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(1800),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_namespace] = ACTIONS(1800),
    [anon_sym_static_assert] = ACTIONS(1800),
    [anon_sym_concept] = ACTIONS(1800),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1165),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(1167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
    [anon_sym___exported] = ACTIONS(1800),
  },
  [82] = {
    [sym_declaration] = STATE(85),
    [sym_type_definition] = STATE(85),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6711),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(85),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(85),
    [sym_labeled_statement] = STATE(85),
    [sym_expression_statement] = STATE(85),
    [sym_if_statement] = STATE(85),
    [sym_switch_statement] = STATE(85),
    [sym_while_statement] = STATE(85),
    [sym_do_statement] = STATE(85),
    [sym_for_statement] = STATE(85),
    [sym_return_statement] = STATE(85),
    [sym_break_statement] = STATE(85),
    [sym_continue_statement] = STATE(85),
    [sym_goto_statement] = STATE(85),
    [sym_seh_try_statement] = STATE(85),
    [sym_seh_leave_statement] = STATE(85),
    [sym_expression] = STATE(5655),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10869),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(85),
    [sym_co_return_statement] = STATE(85),
    [sym_co_yield_statement] = STATE(85),
    [sym_throw_statement] = STATE(85),
    [sym_try_statement] = STATE(85),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(85),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(85),
    [sym_hlsl_attribute] = STATE(10450),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1226),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(85),
    [ts_builtin_sym_end] = ACTIONS(1818),
    [sym_identifier] = ACTIONS(1798),
    [aux_sym_preproc_include_token1] = ACTIONS(1820),
    [aux_sym_preproc_def_token1] = ACTIONS(1820),
    [aux_sym_preproc_if_token1] = ACTIONS(1820),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1820),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1820),
    [sym_preproc_directive] = ACTIONS(1820),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym___extension__] = ACTIONS(1808),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1820),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1820),
    [anon_sym___cdecl] = ACTIONS(1820),
    [anon_sym___clrcall] = ACTIONS(1820),
    [anon_sym___stdcall] = ACTIONS(1820),
    [anon_sym___fastcall] = ACTIONS(1820),
    [anon_sym___thiscall] = ACTIONS(1820),
    [anon_sym___vectorcall] = ACTIONS(1820),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_else] = ACTIONS(1820),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1820),
    [anon_sym_default] = ACTIONS(1820),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1157),
    [anon_sym___leave] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(1820),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_export] = ACTIONS(1820),
    [anon_sym_module] = ACTIONS(1820),
    [anon_sym_import] = ACTIONS(1820),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(1820),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_namespace] = ACTIONS(1820),
    [anon_sym_static_assert] = ACTIONS(1820),
    [anon_sym_concept] = ACTIONS(1820),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1165),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(1167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
    [anon_sym___exported] = ACTIONS(1820),
  },
  [83] = {
    [sym_declaration] = STATE(87),
    [sym_type_definition] = STATE(87),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6647),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(87),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(87),
    [sym_labeled_statement] = STATE(87),
    [sym_expression_statement] = STATE(87),
    [sym_if_statement] = STATE(87),
    [sym_switch_statement] = STATE(87),
    [sym_while_statement] = STATE(87),
    [sym_do_statement] = STATE(87),
    [sym_for_statement] = STATE(87),
    [sym_return_statement] = STATE(87),
    [sym_break_statement] = STATE(87),
    [sym_continue_statement] = STATE(87),
    [sym_goto_statement] = STATE(87),
    [sym_seh_try_statement] = STATE(87),
    [sym_seh_leave_statement] = STATE(87),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(87),
    [sym_co_return_statement] = STATE(87),
    [sym_co_yield_statement] = STATE(87),
    [sym_throw_statement] = STATE(87),
    [sym_try_statement] = STATE(87),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(87),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(87),
    [sym_hlsl_attribute] = STATE(10675),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1220),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(87),
    [sym_identifier] = ACTIONS(1822),
    [aux_sym_preproc_include_token1] = ACTIONS(1824),
    [aux_sym_preproc_def_token1] = ACTIONS(1824),
    [aux_sym_preproc_if_token1] = ACTIONS(1824),
    [aux_sym_preproc_if_token2] = ACTIONS(1824),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1824),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1824),
    [aux_sym_preproc_else_token1] = ACTIONS(1824),
    [aux_sym_preproc_elif_token1] = ACTIONS(1824),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1824),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1824),
    [sym_preproc_directive] = ACTIONS(1824),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP_AMP] = ACTIONS(1826),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(1828),
    [anon_sym_typedef] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1824),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1824),
    [anon_sym___cdecl] = ACTIONS(1824),
    [anon_sym___clrcall] = ACTIONS(1824),
    [anon_sym___stdcall] = ACTIONS(1824),
    [anon_sym___fastcall] = ACTIONS(1824),
    [anon_sym___thiscall] = ACTIONS(1824),
    [anon_sym___vectorcall] = ACTIONS(1824),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_else] = ACTIONS(1824),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(1824),
    [anon_sym_default] = ACTIONS(1824),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(1824),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(1824),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_namespace] = ACTIONS(1824),
    [anon_sym_static_assert] = ACTIONS(1824),
    [anon_sym_concept] = ACTIONS(1824),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [84] = {
    [sym_declaration] = STATE(85),
    [sym_type_definition] = STATE(85),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6711),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(85),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(85),
    [sym_labeled_statement] = STATE(85),
    [sym_expression_statement] = STATE(85),
    [sym_if_statement] = STATE(85),
    [sym_switch_statement] = STATE(85),
    [sym_while_statement] = STATE(85),
    [sym_do_statement] = STATE(85),
    [sym_for_statement] = STATE(85),
    [sym_return_statement] = STATE(85),
    [sym_break_statement] = STATE(85),
    [sym_continue_statement] = STATE(85),
    [sym_goto_statement] = STATE(85),
    [sym_seh_try_statement] = STATE(85),
    [sym_seh_leave_statement] = STATE(85),
    [sym_expression] = STATE(5655),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10869),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(85),
    [sym_co_return_statement] = STATE(85),
    [sym_co_yield_statement] = STATE(85),
    [sym_throw_statement] = STATE(85),
    [sym_try_statement] = STATE(85),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(85),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(85),
    [sym_hlsl_attribute] = STATE(10450),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1226),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(85),
    [ts_builtin_sym_end] = ACTIONS(1830),
    [sym_identifier] = ACTIONS(1798),
    [aux_sym_preproc_include_token1] = ACTIONS(1832),
    [aux_sym_preproc_def_token1] = ACTIONS(1832),
    [aux_sym_preproc_if_token1] = ACTIONS(1832),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1832),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1832),
    [sym_preproc_directive] = ACTIONS(1832),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP_AMP] = ACTIONS(1830),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym___extension__] = ACTIONS(1808),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1832),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1832),
    [anon_sym___cdecl] = ACTIONS(1832),
    [anon_sym___clrcall] = ACTIONS(1832),
    [anon_sym___stdcall] = ACTIONS(1832),
    [anon_sym___fastcall] = ACTIONS(1832),
    [anon_sym___thiscall] = ACTIONS(1832),
    [anon_sym___vectorcall] = ACTIONS(1832),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_else] = ACTIONS(1832),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1832),
    [anon_sym_default] = ACTIONS(1832),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1157),
    [anon_sym___leave] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(1832),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_export] = ACTIONS(1832),
    [anon_sym_module] = ACTIONS(1832),
    [anon_sym_import] = ACTIONS(1832),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(1832),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_namespace] = ACTIONS(1832),
    [anon_sym_static_assert] = ACTIONS(1832),
    [anon_sym_concept] = ACTIONS(1832),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1165),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(1167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
    [anon_sym___exported] = ACTIONS(1832),
  },
  [85] = {
    [sym_declaration] = STATE(85),
    [sym_type_definition] = STATE(85),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6711),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(85),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(85),
    [sym_labeled_statement] = STATE(85),
    [sym_expression_statement] = STATE(85),
    [sym_if_statement] = STATE(85),
    [sym_switch_statement] = STATE(85),
    [sym_while_statement] = STATE(85),
    [sym_do_statement] = STATE(85),
    [sym_for_statement] = STATE(85),
    [sym_return_statement] = STATE(85),
    [sym_break_statement] = STATE(85),
    [sym_continue_statement] = STATE(85),
    [sym_goto_statement] = STATE(85),
    [sym_seh_try_statement] = STATE(85),
    [sym_seh_leave_statement] = STATE(85),
    [sym_expression] = STATE(5655),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10869),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(85),
    [sym_co_return_statement] = STATE(85),
    [sym_co_yield_statement] = STATE(85),
    [sym_throw_statement] = STATE(85),
    [sym_try_statement] = STATE(85),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(85),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(85),
    [sym_hlsl_attribute] = STATE(10450),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1226),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(85),
    [ts_builtin_sym_end] = ACTIONS(1614),
    [sym_identifier] = ACTIONS(1834),
    [aux_sym_preproc_include_token1] = ACTIONS(1600),
    [aux_sym_preproc_def_token1] = ACTIONS(1600),
    [aux_sym_preproc_if_token1] = ACTIONS(1600),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1600),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1600),
    [sym_preproc_directive] = ACTIONS(1600),
    [anon_sym_LPAREN2] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_SEMI] = ACTIONS(1837),
    [anon_sym___extension__] = ACTIONS(1840),
    [anon_sym_typedef] = ACTIONS(1843),
    [anon_sym_in] = ACTIONS(1628),
    [anon_sym_out] = ACTIONS(1628),
    [anon_sym_inout] = ACTIONS(1628),
    [anon_sym_virtual] = ACTIONS(1628),
    [anon_sym_extern] = ACTIONS(1631),
    [anon_sym___attribute__] = ACTIONS(1634),
    [anon_sym___attribute] = ACTIONS(1634),
    [anon_sym_using] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(1637),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1640),
    [anon_sym___declspec] = ACTIONS(1643),
    [anon_sym___based] = ACTIONS(1600),
    [anon_sym___cdecl] = ACTIONS(1600),
    [anon_sym___clrcall] = ACTIONS(1600),
    [anon_sym___stdcall] = ACTIONS(1600),
    [anon_sym___fastcall] = ACTIONS(1600),
    [anon_sym___thiscall] = ACTIONS(1600),
    [anon_sym___vectorcall] = ACTIONS(1600),
    [anon_sym_LBRACE] = ACTIONS(1846),
    [anon_sym_signed] = ACTIONS(1649),
    [anon_sym_unsigned] = ACTIONS(1649),
    [anon_sym_long] = ACTIONS(1649),
    [anon_sym_short] = ACTIONS(1649),
    [anon_sym_LBRACK] = ACTIONS(1652),
    [anon_sym_static] = ACTIONS(1631),
    [anon_sym_register] = ACTIONS(1631),
    [anon_sym_inline] = ACTIONS(1631),
    [anon_sym___inline] = ACTIONS(1631),
    [anon_sym___inline__] = ACTIONS(1631),
    [anon_sym___forceinline] = ACTIONS(1631),
    [anon_sym_thread_local] = ACTIONS(1631),
    [anon_sym___thread] = ACTIONS(1631),
    [anon_sym_const] = ACTIONS(1655),
    [anon_sym_constexpr] = ACTIONS(1655),
    [anon_sym_volatile] = ACTIONS(1655),
    [anon_sym_restrict] = ACTIONS(1655),
    [anon_sym___restrict__] = ACTIONS(1655),
    [anon_sym__Atomic] = ACTIONS(1655),
    [anon_sym__Noreturn] = ACTIONS(1655),
    [anon_sym_noreturn] = ACTIONS(1655),
    [anon_sym__Nonnull] = ACTIONS(1655),
    [anon_sym_mutable] = ACTIONS(1655),
    [anon_sym_constinit] = ACTIONS(1655),
    [anon_sym_consteval] = ACTIONS(1655),
    [anon_sym_alignas] = ACTIONS(1658),
    [anon_sym__Alignas] = ACTIONS(1658),
    [sym_primitive_type] = ACTIONS(1661),
    [anon_sym_enum] = ACTIONS(1664),
    [anon_sym_class] = ACTIONS(1667),
    [anon_sym_struct] = ACTIONS(1670),
    [anon_sym_union] = ACTIONS(1673),
    [anon_sym_if] = ACTIONS(1849),
    [anon_sym_else] = ACTIONS(1600),
    [anon_sym_switch] = ACTIONS(1852),
    [anon_sym_case] = ACTIONS(1600),
    [anon_sym_default] = ACTIONS(1600),
    [anon_sym_while] = ACTIONS(1855),
    [anon_sym_do] = ACTIONS(1858),
    [anon_sym_for] = ACTIONS(1861),
    [anon_sym_return] = ACTIONS(1864),
    [anon_sym_break] = ACTIONS(1867),
    [anon_sym_continue] = ACTIONS(1870),
    [anon_sym_goto] = ACTIONS(1873),
    [anon_sym___try] = ACTIONS(1876),
    [anon_sym___leave] = ACTIONS(1879),
    [anon_sym_not] = ACTIONS(1608),
    [anon_sym_compl] = ACTIONS(1608),
    [anon_sym_DASH_DASH] = ACTIONS(1709),
    [anon_sym_PLUS_PLUS] = ACTIONS(1709),
    [anon_sym_sizeof] = ACTIONS(1712),
    [anon_sym___alignof__] = ACTIONS(1715),
    [anon_sym___alignof] = ACTIONS(1715),
    [anon_sym__alignof] = ACTIONS(1715),
    [anon_sym_alignof] = ACTIONS(1715),
    [anon_sym__Alignof] = ACTIONS(1715),
    [anon_sym_offsetof] = ACTIONS(1718),
    [anon_sym__Generic] = ACTIONS(1721),
    [anon_sym_asm] = ACTIONS(1724),
    [anon_sym___asm__] = ACTIONS(1724),
    [anon_sym___asm] = ACTIONS(1724),
    [sym_number_literal] = ACTIONS(1727),
    [anon_sym_L_SQUOTE] = ACTIONS(1730),
    [anon_sym_u_SQUOTE] = ACTIONS(1730),
    [anon_sym_U_SQUOTE] = ACTIONS(1730),
    [anon_sym_u8_SQUOTE] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1730),
    [anon_sym_L_DQUOTE] = ACTIONS(1733),
    [anon_sym_u_DQUOTE] = ACTIONS(1733),
    [anon_sym_U_DQUOTE] = ACTIONS(1733),
    [anon_sym_u8_DQUOTE] = ACTIONS(1733),
    [anon_sym_DQUOTE] = ACTIONS(1733),
    [sym_true] = ACTIONS(1736),
    [sym_false] = ACTIONS(1736),
    [anon_sym_NULL] = ACTIONS(1739),
    [anon_sym_nullptr] = ACTIONS(1739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1742),
    [anon_sym_let] = ACTIONS(1742),
    [anon_sym_This] = ACTIONS(1742),
    [anon_sym_decltype] = ACTIONS(1745),
    [anon_sym_explicit] = ACTIONS(1600),
    [anon_sym_typename] = ACTIONS(1748),
    [anon_sym_export] = ACTIONS(1600),
    [anon_sym_module] = ACTIONS(1600),
    [anon_sym_import] = ACTIONS(1600),
    [anon_sym_template] = ACTIONS(1751),
    [anon_sym_operator] = ACTIONS(1600),
    [anon_sym_try] = ACTIONS(1882),
    [anon_sym_delete] = ACTIONS(1757),
    [anon_sym_throw] = ACTIONS(1885),
    [anon_sym_namespace] = ACTIONS(1600),
    [anon_sym_static_assert] = ACTIONS(1600),
    [anon_sym_concept] = ACTIONS(1600),
    [anon_sym_co_return] = ACTIONS(1888),
    [anon_sym_co_yield] = ACTIONS(1891),
    [anon_sym_R_DQUOTE] = ACTIONS(1769),
    [anon_sym_LR_DQUOTE] = ACTIONS(1769),
    [anon_sym_uR_DQUOTE] = ACTIONS(1769),
    [anon_sym_UR_DQUOTE] = ACTIONS(1769),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1769),
    [anon_sym_co_await] = ACTIONS(1772),
    [anon_sym_new] = ACTIONS(1775),
    [anon_sym_requires] = ACTIONS(1778),
    [sym_this] = ACTIONS(1736),
    [anon_sym_discard] = ACTIONS(1894),
    [anon_sym_precise] = ACTIONS(1784),
    [anon_sym_shared] = ACTIONS(1784),
    [anon_sym_groupshared] = ACTIONS(1784),
    [anon_sym_uniform] = ACTIONS(1784),
    [anon_sym_row_major] = ACTIONS(1784),
    [anon_sym_column_major] = ACTIONS(1784),
    [anon_sym_globallycoherent] = ACTIONS(1784),
    [anon_sym_centroid] = ACTIONS(1784),
    [anon_sym_noperspective] = ACTIONS(1784),
    [anon_sym_nointerpolation] = ACTIONS(1784),
    [anon_sym_sample] = ACTIONS(1784),
    [anon_sym_linear] = ACTIONS(1784),
    [anon_sym_snorm] = ACTIONS(1784),
    [anon_sym_unorm] = ACTIONS(1784),
    [anon_sym_point] = ACTIONS(1784),
    [anon_sym_line] = ACTIONS(1784),
    [anon_sym_triangleadj] = ACTIONS(1784),
    [anon_sym_lineadj] = ACTIONS(1784),
    [anon_sym_triangle] = ACTIONS(1784),
    [anon_sym_cbuffer] = ACTIONS(1897),
    [anon_sym_interface] = ACTIONS(1790),
    [anon_sym_extension] = ACTIONS(1793),
    [anon_sym___exported] = ACTIONS(1600),
  },
  [86] = {
    [sym_declaration] = STATE(89),
    [sym_type_definition] = STATE(89),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6647),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(89),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(89),
    [sym_labeled_statement] = STATE(89),
    [sym_expression_statement] = STATE(89),
    [sym_if_statement] = STATE(89),
    [sym_switch_statement] = STATE(89),
    [sym_while_statement] = STATE(89),
    [sym_do_statement] = STATE(89),
    [sym_for_statement] = STATE(89),
    [sym_return_statement] = STATE(89),
    [sym_break_statement] = STATE(89),
    [sym_continue_statement] = STATE(89),
    [sym_goto_statement] = STATE(89),
    [sym_seh_try_statement] = STATE(89),
    [sym_seh_leave_statement] = STATE(89),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(89),
    [sym_co_return_statement] = STATE(89),
    [sym_co_yield_statement] = STATE(89),
    [sym_throw_statement] = STATE(89),
    [sym_try_statement] = STATE(89),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(89),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(89),
    [sym_hlsl_attribute] = STATE(10675),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1220),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(89),
    [sym_identifier] = ACTIONS(1822),
    [aux_sym_preproc_include_token1] = ACTIONS(1800),
    [aux_sym_preproc_def_token1] = ACTIONS(1800),
    [aux_sym_preproc_if_token1] = ACTIONS(1800),
    [aux_sym_preproc_if_token2] = ACTIONS(1800),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1800),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1800),
    [aux_sym_preproc_else_token1] = ACTIONS(1800),
    [aux_sym_preproc_elif_token1] = ACTIONS(1800),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1800),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1800),
    [sym_preproc_directive] = ACTIONS(1800),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP_AMP] = ACTIONS(1796),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(1828),
    [anon_sym_typedef] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1800),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1800),
    [anon_sym___cdecl] = ACTIONS(1800),
    [anon_sym___clrcall] = ACTIONS(1800),
    [anon_sym___stdcall] = ACTIONS(1800),
    [anon_sym___fastcall] = ACTIONS(1800),
    [anon_sym___thiscall] = ACTIONS(1800),
    [anon_sym___vectorcall] = ACTIONS(1800),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_else] = ACTIONS(1800),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(1800),
    [anon_sym_default] = ACTIONS(1800),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(1800),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(1800),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_namespace] = ACTIONS(1800),
    [anon_sym_static_assert] = ACTIONS(1800),
    [anon_sym_concept] = ACTIONS(1800),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [87] = {
    [sym_declaration] = STATE(80),
    [sym_type_definition] = STATE(80),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6647),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(80),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(80),
    [sym_labeled_statement] = STATE(80),
    [sym_expression_statement] = STATE(80),
    [sym_if_statement] = STATE(80),
    [sym_switch_statement] = STATE(80),
    [sym_while_statement] = STATE(80),
    [sym_do_statement] = STATE(80),
    [sym_for_statement] = STATE(80),
    [sym_return_statement] = STATE(80),
    [sym_break_statement] = STATE(80),
    [sym_continue_statement] = STATE(80),
    [sym_goto_statement] = STATE(80),
    [sym_seh_try_statement] = STATE(80),
    [sym_seh_leave_statement] = STATE(80),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(80),
    [sym_co_return_statement] = STATE(80),
    [sym_co_yield_statement] = STATE(80),
    [sym_throw_statement] = STATE(80),
    [sym_try_statement] = STATE(80),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(80),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(80),
    [sym_hlsl_attribute] = STATE(10675),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1220),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(80),
    [sym_identifier] = ACTIONS(1822),
    [aux_sym_preproc_include_token1] = ACTIONS(1820),
    [aux_sym_preproc_def_token1] = ACTIONS(1820),
    [aux_sym_preproc_if_token1] = ACTIONS(1820),
    [aux_sym_preproc_if_token2] = ACTIONS(1820),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1820),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1820),
    [aux_sym_preproc_else_token1] = ACTIONS(1820),
    [aux_sym_preproc_elif_token1] = ACTIONS(1820),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1820),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1820),
    [sym_preproc_directive] = ACTIONS(1820),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(1828),
    [anon_sym_typedef] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1820),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1820),
    [anon_sym___cdecl] = ACTIONS(1820),
    [anon_sym___clrcall] = ACTIONS(1820),
    [anon_sym___stdcall] = ACTIONS(1820),
    [anon_sym___fastcall] = ACTIONS(1820),
    [anon_sym___thiscall] = ACTIONS(1820),
    [anon_sym___vectorcall] = ACTIONS(1820),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_else] = ACTIONS(1820),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(1820),
    [anon_sym_default] = ACTIONS(1820),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(1820),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(1820),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_namespace] = ACTIONS(1820),
    [anon_sym_static_assert] = ACTIONS(1820),
    [anon_sym_concept] = ACTIONS(1820),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [88] = {
    [sym_declaration] = STATE(82),
    [sym_type_definition] = STATE(82),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6711),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(82),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(82),
    [sym_labeled_statement] = STATE(82),
    [sym_expression_statement] = STATE(82),
    [sym_if_statement] = STATE(82),
    [sym_switch_statement] = STATE(82),
    [sym_while_statement] = STATE(82),
    [sym_do_statement] = STATE(82),
    [sym_for_statement] = STATE(82),
    [sym_return_statement] = STATE(82),
    [sym_break_statement] = STATE(82),
    [sym_continue_statement] = STATE(82),
    [sym_goto_statement] = STATE(82),
    [sym_seh_try_statement] = STATE(82),
    [sym_seh_leave_statement] = STATE(82),
    [sym_expression] = STATE(5655),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10869),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(82),
    [sym_co_return_statement] = STATE(82),
    [sym_co_yield_statement] = STATE(82),
    [sym_throw_statement] = STATE(82),
    [sym_try_statement] = STATE(82),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(82),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(82),
    [sym_hlsl_attribute] = STATE(10450),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1226),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(82),
    [ts_builtin_sym_end] = ACTIONS(1826),
    [sym_identifier] = ACTIONS(1798),
    [aux_sym_preproc_include_token1] = ACTIONS(1824),
    [aux_sym_preproc_def_token1] = ACTIONS(1824),
    [aux_sym_preproc_if_token1] = ACTIONS(1824),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1824),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1824),
    [sym_preproc_directive] = ACTIONS(1824),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP_AMP] = ACTIONS(1826),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym___extension__] = ACTIONS(1808),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1824),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1824),
    [anon_sym___cdecl] = ACTIONS(1824),
    [anon_sym___clrcall] = ACTIONS(1824),
    [anon_sym___stdcall] = ACTIONS(1824),
    [anon_sym___fastcall] = ACTIONS(1824),
    [anon_sym___thiscall] = ACTIONS(1824),
    [anon_sym___vectorcall] = ACTIONS(1824),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_else] = ACTIONS(1824),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1824),
    [anon_sym_default] = ACTIONS(1824),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1157),
    [anon_sym___leave] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(1824),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_export] = ACTIONS(1824),
    [anon_sym_module] = ACTIONS(1824),
    [anon_sym_import] = ACTIONS(1824),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(1824),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_namespace] = ACTIONS(1824),
    [anon_sym_static_assert] = ACTIONS(1824),
    [anon_sym_concept] = ACTIONS(1824),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1165),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(1167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
    [anon_sym___exported] = ACTIONS(1824),
  },
  [89] = {
    [sym_declaration] = STATE(80),
    [sym_type_definition] = STATE(80),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6647),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(80),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(80),
    [sym_labeled_statement] = STATE(80),
    [sym_expression_statement] = STATE(80),
    [sym_if_statement] = STATE(80),
    [sym_switch_statement] = STATE(80),
    [sym_while_statement] = STATE(80),
    [sym_do_statement] = STATE(80),
    [sym_for_statement] = STATE(80),
    [sym_return_statement] = STATE(80),
    [sym_break_statement] = STATE(80),
    [sym_continue_statement] = STATE(80),
    [sym_goto_statement] = STATE(80),
    [sym_seh_try_statement] = STATE(80),
    [sym_seh_leave_statement] = STATE(80),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(80),
    [sym_co_return_statement] = STATE(80),
    [sym_co_yield_statement] = STATE(80),
    [sym_throw_statement] = STATE(80),
    [sym_try_statement] = STATE(80),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(80),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(80),
    [sym_hlsl_attribute] = STATE(10675),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1220),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(80),
    [sym_identifier] = ACTIONS(1822),
    [aux_sym_preproc_include_token1] = ACTIONS(1832),
    [aux_sym_preproc_def_token1] = ACTIONS(1832),
    [aux_sym_preproc_if_token1] = ACTIONS(1832),
    [aux_sym_preproc_if_token2] = ACTIONS(1832),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1832),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1832),
    [aux_sym_preproc_else_token1] = ACTIONS(1832),
    [aux_sym_preproc_elif_token1] = ACTIONS(1832),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1832),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1832),
    [sym_preproc_directive] = ACTIONS(1832),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP_AMP] = ACTIONS(1830),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(1828),
    [anon_sym_typedef] = ACTIONS(311),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1832),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1832),
    [anon_sym___cdecl] = ACTIONS(1832),
    [anon_sym___clrcall] = ACTIONS(1832),
    [anon_sym___stdcall] = ACTIONS(1832),
    [anon_sym___fastcall] = ACTIONS(1832),
    [anon_sym___thiscall] = ACTIONS(1832),
    [anon_sym___vectorcall] = ACTIONS(1832),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_else] = ACTIONS(1832),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(1832),
    [anon_sym_default] = ACTIONS(1832),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(1832),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(1832),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_namespace] = ACTIONS(1832),
    [anon_sym_static_assert] = ACTIONS(1832),
    [anon_sym_concept] = ACTIONS(1832),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [90] = {
    [sym_declaration] = STATE(93),
    [sym_type_definition] = STATE(93),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6673),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(93),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(93),
    [sym_labeled_statement] = STATE(93),
    [sym_expression_statement] = STATE(93),
    [sym_if_statement] = STATE(93),
    [sym_switch_statement] = STATE(93),
    [sym_while_statement] = STATE(93),
    [sym_do_statement] = STATE(93),
    [sym_for_statement] = STATE(93),
    [sym_return_statement] = STATE(93),
    [sym_break_statement] = STATE(93),
    [sym_continue_statement] = STATE(93),
    [sym_goto_statement] = STATE(93),
    [sym_seh_try_statement] = STATE(93),
    [sym_seh_leave_statement] = STATE(93),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(93),
    [sym_co_return_statement] = STATE(93),
    [sym_co_yield_statement] = STATE(93),
    [sym_throw_statement] = STATE(93),
    [sym_try_statement] = STATE(93),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(93),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(93),
    [sym_hlsl_attribute] = STATE(10697),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1244),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(93),
    [sym_identifier] = ACTIONS(1900),
    [aux_sym_preproc_include_token1] = ACTIONS(1832),
    [aux_sym_preproc_def_token1] = ACTIONS(1832),
    [aux_sym_preproc_if_token1] = ACTIONS(1832),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1832),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1832),
    [sym_preproc_directive] = ACTIONS(1832),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP_AMP] = ACTIONS(1830),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(1902),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1832),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1832),
    [anon_sym___cdecl] = ACTIONS(1832),
    [anon_sym___clrcall] = ACTIONS(1832),
    [anon_sym___stdcall] = ACTIONS(1832),
    [anon_sym___fastcall] = ACTIONS(1832),
    [anon_sym___thiscall] = ACTIONS(1832),
    [anon_sym___vectorcall] = ACTIONS(1832),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1830),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_else] = ACTIONS(1832),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(1832),
    [anon_sym_default] = ACTIONS(1832),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(1832),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(1832),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(1832),
    [anon_sym_static_assert] = ACTIONS(1832),
    [anon_sym_concept] = ACTIONS(1832),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [91] = {
    [sym_declaration] = STATE(90),
    [sym_type_definition] = STATE(90),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6673),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(90),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(90),
    [sym_labeled_statement] = STATE(90),
    [sym_expression_statement] = STATE(90),
    [sym_if_statement] = STATE(90),
    [sym_switch_statement] = STATE(90),
    [sym_while_statement] = STATE(90),
    [sym_do_statement] = STATE(90),
    [sym_for_statement] = STATE(90),
    [sym_return_statement] = STATE(90),
    [sym_break_statement] = STATE(90),
    [sym_continue_statement] = STATE(90),
    [sym_goto_statement] = STATE(90),
    [sym_seh_try_statement] = STATE(90),
    [sym_seh_leave_statement] = STATE(90),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(90),
    [sym_co_return_statement] = STATE(90),
    [sym_co_yield_statement] = STATE(90),
    [sym_throw_statement] = STATE(90),
    [sym_try_statement] = STATE(90),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(90),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(90),
    [sym_hlsl_attribute] = STATE(10697),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1244),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(90),
    [sym_identifier] = ACTIONS(1900),
    [aux_sym_preproc_include_token1] = ACTIONS(1800),
    [aux_sym_preproc_def_token1] = ACTIONS(1800),
    [aux_sym_preproc_if_token1] = ACTIONS(1800),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1800),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1800),
    [sym_preproc_directive] = ACTIONS(1800),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP_AMP] = ACTIONS(1796),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(1902),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1800),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1800),
    [anon_sym___cdecl] = ACTIONS(1800),
    [anon_sym___clrcall] = ACTIONS(1800),
    [anon_sym___stdcall] = ACTIONS(1800),
    [anon_sym___fastcall] = ACTIONS(1800),
    [anon_sym___thiscall] = ACTIONS(1800),
    [anon_sym___vectorcall] = ACTIONS(1800),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1796),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_else] = ACTIONS(1800),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(1800),
    [anon_sym_default] = ACTIONS(1800),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(1800),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(1800),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(1800),
    [anon_sym_static_assert] = ACTIONS(1800),
    [anon_sym_concept] = ACTIONS(1800),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [92] = {
    [sym_declaration] = STATE(93),
    [sym_type_definition] = STATE(93),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6673),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(93),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(93),
    [sym_labeled_statement] = STATE(93),
    [sym_expression_statement] = STATE(93),
    [sym_if_statement] = STATE(93),
    [sym_switch_statement] = STATE(93),
    [sym_while_statement] = STATE(93),
    [sym_do_statement] = STATE(93),
    [sym_for_statement] = STATE(93),
    [sym_return_statement] = STATE(93),
    [sym_break_statement] = STATE(93),
    [sym_continue_statement] = STATE(93),
    [sym_goto_statement] = STATE(93),
    [sym_seh_try_statement] = STATE(93),
    [sym_seh_leave_statement] = STATE(93),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(93),
    [sym_co_return_statement] = STATE(93),
    [sym_co_yield_statement] = STATE(93),
    [sym_throw_statement] = STATE(93),
    [sym_try_statement] = STATE(93),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(93),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(93),
    [sym_hlsl_attribute] = STATE(10697),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1244),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(93),
    [sym_identifier] = ACTIONS(1900),
    [aux_sym_preproc_include_token1] = ACTIONS(1820),
    [aux_sym_preproc_def_token1] = ACTIONS(1820),
    [aux_sym_preproc_if_token1] = ACTIONS(1820),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1820),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1820),
    [sym_preproc_directive] = ACTIONS(1820),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(1902),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1820),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1820),
    [anon_sym___cdecl] = ACTIONS(1820),
    [anon_sym___clrcall] = ACTIONS(1820),
    [anon_sym___stdcall] = ACTIONS(1820),
    [anon_sym___fastcall] = ACTIONS(1820),
    [anon_sym___thiscall] = ACTIONS(1820),
    [anon_sym___vectorcall] = ACTIONS(1820),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1818),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_else] = ACTIONS(1820),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(1820),
    [anon_sym_default] = ACTIONS(1820),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(1820),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(1820),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(1820),
    [anon_sym_static_assert] = ACTIONS(1820),
    [anon_sym_concept] = ACTIONS(1820),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [93] = {
    [sym_declaration] = STATE(93),
    [sym_type_definition] = STATE(93),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6673),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(93),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(93),
    [sym_labeled_statement] = STATE(93),
    [sym_expression_statement] = STATE(93),
    [sym_if_statement] = STATE(93),
    [sym_switch_statement] = STATE(93),
    [sym_while_statement] = STATE(93),
    [sym_do_statement] = STATE(93),
    [sym_for_statement] = STATE(93),
    [sym_return_statement] = STATE(93),
    [sym_break_statement] = STATE(93),
    [sym_continue_statement] = STATE(93),
    [sym_goto_statement] = STATE(93),
    [sym_seh_try_statement] = STATE(93),
    [sym_seh_leave_statement] = STATE(93),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(93),
    [sym_co_return_statement] = STATE(93),
    [sym_co_yield_statement] = STATE(93),
    [sym_throw_statement] = STATE(93),
    [sym_try_statement] = STATE(93),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(93),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(93),
    [sym_hlsl_attribute] = STATE(10697),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1244),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(93),
    [sym_identifier] = ACTIONS(1904),
    [aux_sym_preproc_include_token1] = ACTIONS(1600),
    [aux_sym_preproc_def_token1] = ACTIONS(1600),
    [aux_sym_preproc_if_token1] = ACTIONS(1600),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1600),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1600),
    [sym_preproc_directive] = ACTIONS(1600),
    [anon_sym_LPAREN2] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_SEMI] = ACTIONS(1907),
    [anon_sym___extension__] = ACTIONS(1910),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_in] = ACTIONS(1628),
    [anon_sym_out] = ACTIONS(1628),
    [anon_sym_inout] = ACTIONS(1628),
    [anon_sym_virtual] = ACTIONS(1628),
    [anon_sym_extern] = ACTIONS(1631),
    [anon_sym___attribute__] = ACTIONS(1634),
    [anon_sym___attribute] = ACTIONS(1634),
    [anon_sym_using] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(1637),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1640),
    [anon_sym___declspec] = ACTIONS(1643),
    [anon_sym___based] = ACTIONS(1600),
    [anon_sym___cdecl] = ACTIONS(1600),
    [anon_sym___clrcall] = ACTIONS(1600),
    [anon_sym___stdcall] = ACTIONS(1600),
    [anon_sym___fastcall] = ACTIONS(1600),
    [anon_sym___thiscall] = ACTIONS(1600),
    [anon_sym___vectorcall] = ACTIONS(1600),
    [anon_sym_LBRACE] = ACTIONS(1916),
    [anon_sym_RBRACE] = ACTIONS(1614),
    [anon_sym_signed] = ACTIONS(1649),
    [anon_sym_unsigned] = ACTIONS(1649),
    [anon_sym_long] = ACTIONS(1649),
    [anon_sym_short] = ACTIONS(1649),
    [anon_sym_LBRACK] = ACTIONS(1652),
    [anon_sym_static] = ACTIONS(1631),
    [anon_sym_register] = ACTIONS(1631),
    [anon_sym_inline] = ACTIONS(1631),
    [anon_sym___inline] = ACTIONS(1631),
    [anon_sym___inline__] = ACTIONS(1631),
    [anon_sym___forceinline] = ACTIONS(1631),
    [anon_sym_thread_local] = ACTIONS(1631),
    [anon_sym___thread] = ACTIONS(1631),
    [anon_sym_const] = ACTIONS(1655),
    [anon_sym_constexpr] = ACTIONS(1655),
    [anon_sym_volatile] = ACTIONS(1655),
    [anon_sym_restrict] = ACTIONS(1655),
    [anon_sym___restrict__] = ACTIONS(1655),
    [anon_sym__Atomic] = ACTIONS(1655),
    [anon_sym__Noreturn] = ACTIONS(1655),
    [anon_sym_noreturn] = ACTIONS(1655),
    [anon_sym__Nonnull] = ACTIONS(1655),
    [anon_sym_mutable] = ACTIONS(1655),
    [anon_sym_constinit] = ACTIONS(1655),
    [anon_sym_consteval] = ACTIONS(1655),
    [anon_sym_alignas] = ACTIONS(1658),
    [anon_sym__Alignas] = ACTIONS(1658),
    [sym_primitive_type] = ACTIONS(1661),
    [anon_sym_enum] = ACTIONS(1664),
    [anon_sym_class] = ACTIONS(1667),
    [anon_sym_struct] = ACTIONS(1670),
    [anon_sym_union] = ACTIONS(1673),
    [anon_sym_if] = ACTIONS(1919),
    [anon_sym_else] = ACTIONS(1600),
    [anon_sym_switch] = ACTIONS(1922),
    [anon_sym_case] = ACTIONS(1600),
    [anon_sym_default] = ACTIONS(1600),
    [anon_sym_while] = ACTIONS(1925),
    [anon_sym_do] = ACTIONS(1928),
    [anon_sym_for] = ACTIONS(1931),
    [anon_sym_return] = ACTIONS(1934),
    [anon_sym_break] = ACTIONS(1937),
    [anon_sym_continue] = ACTIONS(1940),
    [anon_sym_goto] = ACTIONS(1943),
    [anon_sym___try] = ACTIONS(1946),
    [anon_sym___leave] = ACTIONS(1949),
    [anon_sym_not] = ACTIONS(1608),
    [anon_sym_compl] = ACTIONS(1608),
    [anon_sym_DASH_DASH] = ACTIONS(1709),
    [anon_sym_PLUS_PLUS] = ACTIONS(1709),
    [anon_sym_sizeof] = ACTIONS(1712),
    [anon_sym___alignof__] = ACTIONS(1715),
    [anon_sym___alignof] = ACTIONS(1715),
    [anon_sym__alignof] = ACTIONS(1715),
    [anon_sym_alignof] = ACTIONS(1715),
    [anon_sym__Alignof] = ACTIONS(1715),
    [anon_sym_offsetof] = ACTIONS(1718),
    [anon_sym__Generic] = ACTIONS(1721),
    [anon_sym_asm] = ACTIONS(1724),
    [anon_sym___asm__] = ACTIONS(1724),
    [anon_sym___asm] = ACTIONS(1724),
    [sym_number_literal] = ACTIONS(1727),
    [anon_sym_L_SQUOTE] = ACTIONS(1730),
    [anon_sym_u_SQUOTE] = ACTIONS(1730),
    [anon_sym_U_SQUOTE] = ACTIONS(1730),
    [anon_sym_u8_SQUOTE] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1730),
    [anon_sym_L_DQUOTE] = ACTIONS(1733),
    [anon_sym_u_DQUOTE] = ACTIONS(1733),
    [anon_sym_U_DQUOTE] = ACTIONS(1733),
    [anon_sym_u8_DQUOTE] = ACTIONS(1733),
    [anon_sym_DQUOTE] = ACTIONS(1733),
    [sym_true] = ACTIONS(1736),
    [sym_false] = ACTIONS(1736),
    [anon_sym_NULL] = ACTIONS(1739),
    [anon_sym_nullptr] = ACTIONS(1739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1742),
    [anon_sym_let] = ACTIONS(1742),
    [anon_sym_This] = ACTIONS(1742),
    [anon_sym_decltype] = ACTIONS(1745),
    [anon_sym_explicit] = ACTIONS(1600),
    [anon_sym_typename] = ACTIONS(1748),
    [anon_sym_template] = ACTIONS(1751),
    [anon_sym_operator] = ACTIONS(1600),
    [anon_sym_try] = ACTIONS(1952),
    [anon_sym_delete] = ACTIONS(1757),
    [anon_sym_throw] = ACTIONS(1955),
    [anon_sym_namespace] = ACTIONS(1600),
    [anon_sym_static_assert] = ACTIONS(1600),
    [anon_sym_concept] = ACTIONS(1600),
    [anon_sym_co_return] = ACTIONS(1958),
    [anon_sym_co_yield] = ACTIONS(1961),
    [anon_sym_R_DQUOTE] = ACTIONS(1769),
    [anon_sym_LR_DQUOTE] = ACTIONS(1769),
    [anon_sym_uR_DQUOTE] = ACTIONS(1769),
    [anon_sym_UR_DQUOTE] = ACTIONS(1769),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1769),
    [anon_sym_co_await] = ACTIONS(1772),
    [anon_sym_new] = ACTIONS(1775),
    [anon_sym_requires] = ACTIONS(1778),
    [sym_this] = ACTIONS(1736),
    [anon_sym_discard] = ACTIONS(1964),
    [anon_sym_precise] = ACTIONS(1784),
    [anon_sym_shared] = ACTIONS(1784),
    [anon_sym_groupshared] = ACTIONS(1784),
    [anon_sym_uniform] = ACTIONS(1784),
    [anon_sym_row_major] = ACTIONS(1784),
    [anon_sym_column_major] = ACTIONS(1784),
    [anon_sym_globallycoherent] = ACTIONS(1784),
    [anon_sym_centroid] = ACTIONS(1784),
    [anon_sym_noperspective] = ACTIONS(1784),
    [anon_sym_nointerpolation] = ACTIONS(1784),
    [anon_sym_sample] = ACTIONS(1784),
    [anon_sym_linear] = ACTIONS(1784),
    [anon_sym_snorm] = ACTIONS(1784),
    [anon_sym_unorm] = ACTIONS(1784),
    [anon_sym_point] = ACTIONS(1784),
    [anon_sym_line] = ACTIONS(1784),
    [anon_sym_triangleadj] = ACTIONS(1784),
    [anon_sym_lineadj] = ACTIONS(1784),
    [anon_sym_triangle] = ACTIONS(1784),
    [anon_sym_cbuffer] = ACTIONS(1967),
    [anon_sym_interface] = ACTIONS(1790),
    [anon_sym_extension] = ACTIONS(1793),
  },
  [94] = {
    [sym_declaration] = STATE(92),
    [sym_type_definition] = STATE(92),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6673),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(92),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(92),
    [sym_labeled_statement] = STATE(92),
    [sym_expression_statement] = STATE(92),
    [sym_if_statement] = STATE(92),
    [sym_switch_statement] = STATE(92),
    [sym_while_statement] = STATE(92),
    [sym_do_statement] = STATE(92),
    [sym_for_statement] = STATE(92),
    [sym_return_statement] = STATE(92),
    [sym_break_statement] = STATE(92),
    [sym_continue_statement] = STATE(92),
    [sym_goto_statement] = STATE(92),
    [sym_seh_try_statement] = STATE(92),
    [sym_seh_leave_statement] = STATE(92),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(92),
    [sym_co_return_statement] = STATE(92),
    [sym_co_yield_statement] = STATE(92),
    [sym_throw_statement] = STATE(92),
    [sym_try_statement] = STATE(92),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(92),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(92),
    [sym_hlsl_attribute] = STATE(10697),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1244),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(92),
    [sym_identifier] = ACTIONS(1900),
    [aux_sym_preproc_include_token1] = ACTIONS(1824),
    [aux_sym_preproc_def_token1] = ACTIONS(1824),
    [aux_sym_preproc_if_token1] = ACTIONS(1824),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1824),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1824),
    [sym_preproc_directive] = ACTIONS(1824),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP_AMP] = ACTIONS(1826),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(1902),
    [anon_sym_typedef] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1824),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1824),
    [anon_sym___cdecl] = ACTIONS(1824),
    [anon_sym___clrcall] = ACTIONS(1824),
    [anon_sym___stdcall] = ACTIONS(1824),
    [anon_sym___fastcall] = ACTIONS(1824),
    [anon_sym___thiscall] = ACTIONS(1824),
    [anon_sym___vectorcall] = ACTIONS(1824),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(1826),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_else] = ACTIONS(1824),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(1824),
    [anon_sym_default] = ACTIONS(1824),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(1824),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(1824),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(1824),
    [anon_sym_static_assert] = ACTIONS(1824),
    [anon_sym_concept] = ACTIONS(1824),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [95] = {
    [sym_declaration] = STATE(97),
    [sym_type_definition] = STATE(97),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6732),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(97),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(97),
    [sym_labeled_statement] = STATE(97),
    [sym_expression_statement] = STATE(97),
    [sym_if_statement] = STATE(97),
    [sym_switch_statement] = STATE(97),
    [sym_while_statement] = STATE(97),
    [sym_do_statement] = STATE(97),
    [sym_for_statement] = STATE(97),
    [sym_return_statement] = STATE(97),
    [sym_break_statement] = STATE(97),
    [sym_continue_statement] = STATE(97),
    [sym_goto_statement] = STATE(97),
    [sym_seh_try_statement] = STATE(97),
    [sym_seh_leave_statement] = STATE(97),
    [sym_expression] = STATE(5773),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10871),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(97),
    [sym_co_return_statement] = STATE(97),
    [sym_co_yield_statement] = STATE(97),
    [sym_throw_statement] = STATE(97),
    [sym_try_statement] = STATE(97),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(97),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(97),
    [sym_hlsl_attribute] = STATE(10474),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1214),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(97),
    [sym_identifier] = ACTIONS(1970),
    [aux_sym_preproc_include_token1] = ACTIONS(1832),
    [aux_sym_preproc_def_token1] = ACTIONS(1832),
    [aux_sym_preproc_if_token1] = ACTIONS(1832),
    [aux_sym_preproc_if_token2] = ACTIONS(1832),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1832),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1832),
    [sym_preproc_directive] = ACTIONS(1832),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP_AMP] = ACTIONS(1830),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_SEMI] = ACTIONS(1083),
    [anon_sym___extension__] = ACTIONS(1972),
    [anon_sym_typedef] = ACTIONS(1087),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1832),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1832),
    [anon_sym___cdecl] = ACTIONS(1832),
    [anon_sym___clrcall] = ACTIONS(1832),
    [anon_sym___stdcall] = ACTIONS(1832),
    [anon_sym___fastcall] = ACTIONS(1832),
    [anon_sym___thiscall] = ACTIONS(1832),
    [anon_sym___vectorcall] = ACTIONS(1832),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_else] = ACTIONS(1832),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_case] = ACTIONS(1832),
    [anon_sym_default] = ACTIONS(1832),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1107),
    [anon_sym_for] = ACTIONS(1109),
    [anon_sym_return] = ACTIONS(1111),
    [anon_sym_break] = ACTIONS(1113),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_goto] = ACTIONS(1117),
    [anon_sym___try] = ACTIONS(1119),
    [anon_sym___leave] = ACTIONS(1121),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(1832),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(1832),
    [anon_sym_try] = ACTIONS(1125),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_namespace] = ACTIONS(1832),
    [anon_sym_static_assert] = ACTIONS(1832),
    [anon_sym_concept] = ACTIONS(1832),
    [anon_sym_co_return] = ACTIONS(1135),
    [anon_sym_co_yield] = ACTIONS(1137),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1139),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(1141),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [96] = {
    [sym_declaration] = STATE(97),
    [sym_type_definition] = STATE(97),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6732),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(97),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(97),
    [sym_labeled_statement] = STATE(97),
    [sym_expression_statement] = STATE(97),
    [sym_if_statement] = STATE(97),
    [sym_switch_statement] = STATE(97),
    [sym_while_statement] = STATE(97),
    [sym_do_statement] = STATE(97),
    [sym_for_statement] = STATE(97),
    [sym_return_statement] = STATE(97),
    [sym_break_statement] = STATE(97),
    [sym_continue_statement] = STATE(97),
    [sym_goto_statement] = STATE(97),
    [sym_seh_try_statement] = STATE(97),
    [sym_seh_leave_statement] = STATE(97),
    [sym_expression] = STATE(5773),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10871),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(97),
    [sym_co_return_statement] = STATE(97),
    [sym_co_yield_statement] = STATE(97),
    [sym_throw_statement] = STATE(97),
    [sym_try_statement] = STATE(97),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(97),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(97),
    [sym_hlsl_attribute] = STATE(10474),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1214),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(97),
    [sym_identifier] = ACTIONS(1970),
    [aux_sym_preproc_include_token1] = ACTIONS(1820),
    [aux_sym_preproc_def_token1] = ACTIONS(1820),
    [aux_sym_preproc_if_token1] = ACTIONS(1820),
    [aux_sym_preproc_if_token2] = ACTIONS(1820),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1820),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1820),
    [sym_preproc_directive] = ACTIONS(1820),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_SEMI] = ACTIONS(1083),
    [anon_sym___extension__] = ACTIONS(1972),
    [anon_sym_typedef] = ACTIONS(1087),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1820),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1820),
    [anon_sym___cdecl] = ACTIONS(1820),
    [anon_sym___clrcall] = ACTIONS(1820),
    [anon_sym___stdcall] = ACTIONS(1820),
    [anon_sym___fastcall] = ACTIONS(1820),
    [anon_sym___thiscall] = ACTIONS(1820),
    [anon_sym___vectorcall] = ACTIONS(1820),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_else] = ACTIONS(1820),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_case] = ACTIONS(1820),
    [anon_sym_default] = ACTIONS(1820),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1107),
    [anon_sym_for] = ACTIONS(1109),
    [anon_sym_return] = ACTIONS(1111),
    [anon_sym_break] = ACTIONS(1113),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_goto] = ACTIONS(1117),
    [anon_sym___try] = ACTIONS(1119),
    [anon_sym___leave] = ACTIONS(1121),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(1820),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(1820),
    [anon_sym_try] = ACTIONS(1125),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_namespace] = ACTIONS(1820),
    [anon_sym_static_assert] = ACTIONS(1820),
    [anon_sym_concept] = ACTIONS(1820),
    [anon_sym_co_return] = ACTIONS(1135),
    [anon_sym_co_yield] = ACTIONS(1137),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1139),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(1141),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [97] = {
    [sym_declaration] = STATE(97),
    [sym_type_definition] = STATE(97),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6732),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(97),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(97),
    [sym_labeled_statement] = STATE(97),
    [sym_expression_statement] = STATE(97),
    [sym_if_statement] = STATE(97),
    [sym_switch_statement] = STATE(97),
    [sym_while_statement] = STATE(97),
    [sym_do_statement] = STATE(97),
    [sym_for_statement] = STATE(97),
    [sym_return_statement] = STATE(97),
    [sym_break_statement] = STATE(97),
    [sym_continue_statement] = STATE(97),
    [sym_goto_statement] = STATE(97),
    [sym_seh_try_statement] = STATE(97),
    [sym_seh_leave_statement] = STATE(97),
    [sym_expression] = STATE(5773),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10871),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(97),
    [sym_co_return_statement] = STATE(97),
    [sym_co_yield_statement] = STATE(97),
    [sym_throw_statement] = STATE(97),
    [sym_try_statement] = STATE(97),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(97),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(97),
    [sym_hlsl_attribute] = STATE(10474),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1214),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(97),
    [sym_identifier] = ACTIONS(1974),
    [aux_sym_preproc_include_token1] = ACTIONS(1600),
    [aux_sym_preproc_def_token1] = ACTIONS(1600),
    [aux_sym_preproc_if_token1] = ACTIONS(1600),
    [aux_sym_preproc_if_token2] = ACTIONS(1600),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1600),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1600),
    [sym_preproc_directive] = ACTIONS(1600),
    [anon_sym_LPAREN2] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1614),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym___extension__] = ACTIONS(1980),
    [anon_sym_typedef] = ACTIONS(1983),
    [anon_sym_in] = ACTIONS(1628),
    [anon_sym_out] = ACTIONS(1628),
    [anon_sym_inout] = ACTIONS(1628),
    [anon_sym_virtual] = ACTIONS(1628),
    [anon_sym_extern] = ACTIONS(1631),
    [anon_sym___attribute__] = ACTIONS(1634),
    [anon_sym___attribute] = ACTIONS(1634),
    [anon_sym_using] = ACTIONS(1600),
    [anon_sym_COLON_COLON] = ACTIONS(1637),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1640),
    [anon_sym___declspec] = ACTIONS(1643),
    [anon_sym___based] = ACTIONS(1600),
    [anon_sym___cdecl] = ACTIONS(1600),
    [anon_sym___clrcall] = ACTIONS(1600),
    [anon_sym___stdcall] = ACTIONS(1600),
    [anon_sym___fastcall] = ACTIONS(1600),
    [anon_sym___thiscall] = ACTIONS(1600),
    [anon_sym___vectorcall] = ACTIONS(1600),
    [anon_sym_LBRACE] = ACTIONS(1986),
    [anon_sym_signed] = ACTIONS(1649),
    [anon_sym_unsigned] = ACTIONS(1649),
    [anon_sym_long] = ACTIONS(1649),
    [anon_sym_short] = ACTIONS(1649),
    [anon_sym_LBRACK] = ACTIONS(1652),
    [anon_sym_static] = ACTIONS(1631),
    [anon_sym_register] = ACTIONS(1631),
    [anon_sym_inline] = ACTIONS(1631),
    [anon_sym___inline] = ACTIONS(1631),
    [anon_sym___inline__] = ACTIONS(1631),
    [anon_sym___forceinline] = ACTIONS(1631),
    [anon_sym_thread_local] = ACTIONS(1631),
    [anon_sym___thread] = ACTIONS(1631),
    [anon_sym_const] = ACTIONS(1655),
    [anon_sym_constexpr] = ACTIONS(1655),
    [anon_sym_volatile] = ACTIONS(1655),
    [anon_sym_restrict] = ACTIONS(1655),
    [anon_sym___restrict__] = ACTIONS(1655),
    [anon_sym__Atomic] = ACTIONS(1655),
    [anon_sym__Noreturn] = ACTIONS(1655),
    [anon_sym_noreturn] = ACTIONS(1655),
    [anon_sym__Nonnull] = ACTIONS(1655),
    [anon_sym_mutable] = ACTIONS(1655),
    [anon_sym_constinit] = ACTIONS(1655),
    [anon_sym_consteval] = ACTIONS(1655),
    [anon_sym_alignas] = ACTIONS(1658),
    [anon_sym__Alignas] = ACTIONS(1658),
    [sym_primitive_type] = ACTIONS(1661),
    [anon_sym_enum] = ACTIONS(1664),
    [anon_sym_class] = ACTIONS(1667),
    [anon_sym_struct] = ACTIONS(1670),
    [anon_sym_union] = ACTIONS(1673),
    [anon_sym_if] = ACTIONS(1989),
    [anon_sym_else] = ACTIONS(1600),
    [anon_sym_switch] = ACTIONS(1992),
    [anon_sym_case] = ACTIONS(1600),
    [anon_sym_default] = ACTIONS(1600),
    [anon_sym_while] = ACTIONS(1995),
    [anon_sym_do] = ACTIONS(1998),
    [anon_sym_for] = ACTIONS(2001),
    [anon_sym_return] = ACTIONS(2004),
    [anon_sym_break] = ACTIONS(2007),
    [anon_sym_continue] = ACTIONS(2010),
    [anon_sym_goto] = ACTIONS(2013),
    [anon_sym___try] = ACTIONS(2016),
    [anon_sym___leave] = ACTIONS(2019),
    [anon_sym_not] = ACTIONS(1608),
    [anon_sym_compl] = ACTIONS(1608),
    [anon_sym_DASH_DASH] = ACTIONS(1709),
    [anon_sym_PLUS_PLUS] = ACTIONS(1709),
    [anon_sym_sizeof] = ACTIONS(1712),
    [anon_sym___alignof__] = ACTIONS(1715),
    [anon_sym___alignof] = ACTIONS(1715),
    [anon_sym__alignof] = ACTIONS(1715),
    [anon_sym_alignof] = ACTIONS(1715),
    [anon_sym__Alignof] = ACTIONS(1715),
    [anon_sym_offsetof] = ACTIONS(1718),
    [anon_sym__Generic] = ACTIONS(1721),
    [anon_sym_asm] = ACTIONS(1724),
    [anon_sym___asm__] = ACTIONS(1724),
    [anon_sym___asm] = ACTIONS(1724),
    [sym_number_literal] = ACTIONS(1727),
    [anon_sym_L_SQUOTE] = ACTIONS(1730),
    [anon_sym_u_SQUOTE] = ACTIONS(1730),
    [anon_sym_U_SQUOTE] = ACTIONS(1730),
    [anon_sym_u8_SQUOTE] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1730),
    [anon_sym_L_DQUOTE] = ACTIONS(1733),
    [anon_sym_u_DQUOTE] = ACTIONS(1733),
    [anon_sym_U_DQUOTE] = ACTIONS(1733),
    [anon_sym_u8_DQUOTE] = ACTIONS(1733),
    [anon_sym_DQUOTE] = ACTIONS(1733),
    [sym_true] = ACTIONS(1736),
    [sym_false] = ACTIONS(1736),
    [anon_sym_NULL] = ACTIONS(1739),
    [anon_sym_nullptr] = ACTIONS(1739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1742),
    [anon_sym_let] = ACTIONS(1742),
    [anon_sym_This] = ACTIONS(1742),
    [anon_sym_decltype] = ACTIONS(1745),
    [anon_sym_explicit] = ACTIONS(1600),
    [anon_sym_typename] = ACTIONS(1748),
    [anon_sym_template] = ACTIONS(1751),
    [anon_sym_operator] = ACTIONS(1600),
    [anon_sym_try] = ACTIONS(2022),
    [anon_sym_delete] = ACTIONS(1757),
    [anon_sym_throw] = ACTIONS(2025),
    [anon_sym_namespace] = ACTIONS(1600),
    [anon_sym_static_assert] = ACTIONS(1600),
    [anon_sym_concept] = ACTIONS(1600),
    [anon_sym_co_return] = ACTIONS(2028),
    [anon_sym_co_yield] = ACTIONS(2031),
    [anon_sym_R_DQUOTE] = ACTIONS(1769),
    [anon_sym_LR_DQUOTE] = ACTIONS(1769),
    [anon_sym_uR_DQUOTE] = ACTIONS(1769),
    [anon_sym_UR_DQUOTE] = ACTIONS(1769),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1769),
    [anon_sym_co_await] = ACTIONS(1772),
    [anon_sym_new] = ACTIONS(1775),
    [anon_sym_requires] = ACTIONS(1778),
    [sym_this] = ACTIONS(1736),
    [anon_sym_discard] = ACTIONS(2034),
    [anon_sym_precise] = ACTIONS(1784),
    [anon_sym_shared] = ACTIONS(1784),
    [anon_sym_groupshared] = ACTIONS(1784),
    [anon_sym_uniform] = ACTIONS(1784),
    [anon_sym_row_major] = ACTIONS(1784),
    [anon_sym_column_major] = ACTIONS(1784),
    [anon_sym_globallycoherent] = ACTIONS(1784),
    [anon_sym_centroid] = ACTIONS(1784),
    [anon_sym_noperspective] = ACTIONS(1784),
    [anon_sym_nointerpolation] = ACTIONS(1784),
    [anon_sym_sample] = ACTIONS(1784),
    [anon_sym_linear] = ACTIONS(1784),
    [anon_sym_snorm] = ACTIONS(1784),
    [anon_sym_unorm] = ACTIONS(1784),
    [anon_sym_point] = ACTIONS(1784),
    [anon_sym_line] = ACTIONS(1784),
    [anon_sym_triangleadj] = ACTIONS(1784),
    [anon_sym_lineadj] = ACTIONS(1784),
    [anon_sym_triangle] = ACTIONS(1784),
    [anon_sym_cbuffer] = ACTIONS(2037),
    [anon_sym_interface] = ACTIONS(1790),
    [anon_sym_extension] = ACTIONS(1793),
  },
  [98] = {
    [sym_declaration] = STATE(95),
    [sym_type_definition] = STATE(95),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6732),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(95),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(95),
    [sym_labeled_statement] = STATE(95),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_switch_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_goto_statement] = STATE(95),
    [sym_seh_try_statement] = STATE(95),
    [sym_seh_leave_statement] = STATE(95),
    [sym_expression] = STATE(5773),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10871),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(95),
    [sym_co_return_statement] = STATE(95),
    [sym_co_yield_statement] = STATE(95),
    [sym_throw_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(95),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(95),
    [sym_hlsl_attribute] = STATE(10474),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1214),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(95),
    [sym_identifier] = ACTIONS(1970),
    [aux_sym_preproc_include_token1] = ACTIONS(1800),
    [aux_sym_preproc_def_token1] = ACTIONS(1800),
    [aux_sym_preproc_if_token1] = ACTIONS(1800),
    [aux_sym_preproc_if_token2] = ACTIONS(1800),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1800),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1800),
    [sym_preproc_directive] = ACTIONS(1800),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP_AMP] = ACTIONS(1796),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_SEMI] = ACTIONS(1083),
    [anon_sym___extension__] = ACTIONS(1972),
    [anon_sym_typedef] = ACTIONS(1087),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1800),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1800),
    [anon_sym___cdecl] = ACTIONS(1800),
    [anon_sym___clrcall] = ACTIONS(1800),
    [anon_sym___stdcall] = ACTIONS(1800),
    [anon_sym___fastcall] = ACTIONS(1800),
    [anon_sym___thiscall] = ACTIONS(1800),
    [anon_sym___vectorcall] = ACTIONS(1800),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_else] = ACTIONS(1800),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_case] = ACTIONS(1800),
    [anon_sym_default] = ACTIONS(1800),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1107),
    [anon_sym_for] = ACTIONS(1109),
    [anon_sym_return] = ACTIONS(1111),
    [anon_sym_break] = ACTIONS(1113),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_goto] = ACTIONS(1117),
    [anon_sym___try] = ACTIONS(1119),
    [anon_sym___leave] = ACTIONS(1121),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(1800),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(1800),
    [anon_sym_try] = ACTIONS(1125),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_namespace] = ACTIONS(1800),
    [anon_sym_static_assert] = ACTIONS(1800),
    [anon_sym_concept] = ACTIONS(1800),
    [anon_sym_co_return] = ACTIONS(1135),
    [anon_sym_co_yield] = ACTIONS(1137),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1139),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(1141),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [99] = {
    [sym_declaration] = STATE(96),
    [sym_type_definition] = STATE(96),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6732),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(96),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(96),
    [sym_labeled_statement] = STATE(96),
    [sym_expression_statement] = STATE(96),
    [sym_if_statement] = STATE(96),
    [sym_switch_statement] = STATE(96),
    [sym_while_statement] = STATE(96),
    [sym_do_statement] = STATE(96),
    [sym_for_statement] = STATE(96),
    [sym_return_statement] = STATE(96),
    [sym_break_statement] = STATE(96),
    [sym_continue_statement] = STATE(96),
    [sym_goto_statement] = STATE(96),
    [sym_seh_try_statement] = STATE(96),
    [sym_seh_leave_statement] = STATE(96),
    [sym_expression] = STATE(5773),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10871),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(96),
    [sym_co_return_statement] = STATE(96),
    [sym_co_yield_statement] = STATE(96),
    [sym_throw_statement] = STATE(96),
    [sym_try_statement] = STATE(96),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(96),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(96),
    [sym_hlsl_attribute] = STATE(10474),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1214),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(96),
    [sym_identifier] = ACTIONS(1970),
    [aux_sym_preproc_include_token1] = ACTIONS(1824),
    [aux_sym_preproc_def_token1] = ACTIONS(1824),
    [aux_sym_preproc_if_token1] = ACTIONS(1824),
    [aux_sym_preproc_if_token2] = ACTIONS(1824),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1824),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1824),
    [sym_preproc_directive] = ACTIONS(1824),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP_AMP] = ACTIONS(1826),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_SEMI] = ACTIONS(1083),
    [anon_sym___extension__] = ACTIONS(1972),
    [anon_sym_typedef] = ACTIONS(1087),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1824),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1824),
    [anon_sym___cdecl] = ACTIONS(1824),
    [anon_sym___clrcall] = ACTIONS(1824),
    [anon_sym___stdcall] = ACTIONS(1824),
    [anon_sym___fastcall] = ACTIONS(1824),
    [anon_sym___thiscall] = ACTIONS(1824),
    [anon_sym___vectorcall] = ACTIONS(1824),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_else] = ACTIONS(1824),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_case] = ACTIONS(1824),
    [anon_sym_default] = ACTIONS(1824),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1107),
    [anon_sym_for] = ACTIONS(1109),
    [anon_sym_return] = ACTIONS(1111),
    [anon_sym_break] = ACTIONS(1113),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_goto] = ACTIONS(1117),
    [anon_sym___try] = ACTIONS(1119),
    [anon_sym___leave] = ACTIONS(1121),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(1824),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(1824),
    [anon_sym_try] = ACTIONS(1125),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_namespace] = ACTIONS(1824),
    [anon_sym_static_assert] = ACTIONS(1824),
    [anon_sym_concept] = ACTIONS(1824),
    [anon_sym_co_return] = ACTIONS(1135),
    [anon_sym_co_yield] = ACTIONS(1137),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1139),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(1141),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [100] = {
    [sym_declaration] = STATE(872),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6673),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(872),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5461),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10396),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10697),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1244),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(1900),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(2040),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(199),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [101] = {
    [sym_declaration] = STATE(1364),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6621),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(1415),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(1415),
    [sym_statement] = STATE(1364),
    [sym_labeled_statement] = STATE(1415),
    [sym_expression_statement] = STATE(1415),
    [sym_if_statement] = STATE(1415),
    [sym_switch_statement] = STATE(1415),
    [sym_case_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_do_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_break_statement] = STATE(1415),
    [sym_continue_statement] = STATE(1415),
    [sym_goto_statement] = STATE(1415),
    [sym_seh_try_statement] = STATE(1415),
    [sym_seh_leave_statement] = STATE(1415),
    [sym_expression] = STATE(5664),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11323),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(1415),
    [sym_co_return_statement] = STATE(1415),
    [sym_co_yield_statement] = STATE(1415),
    [sym_throw_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(1415),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(1415),
    [sym_hlsl_attribute] = STATE(10401),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1243),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2044),
    [anon_sym___extension__] = ACTIONS(2040),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_switch] = ACTIONS(2050),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2058),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2062),
    [anon_sym_break] = ACTIONS(2064),
    [anon_sym_continue] = ACTIONS(2066),
    [anon_sym_goto] = ACTIONS(2068),
    [anon_sym___try] = ACTIONS(2070),
    [anon_sym___leave] = ACTIONS(2072),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(2074),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(2076),
    [anon_sym_co_return] = ACTIONS(2078),
    [anon_sym_co_yield] = ACTIONS(2080),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(2082),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [102] = {
    [sym_declaration] = STATE(454),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6711),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(480),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(480),
    [sym_statement] = STATE(454),
    [sym_labeled_statement] = STATE(480),
    [sym_expression_statement] = STATE(480),
    [sym_if_statement] = STATE(480),
    [sym_switch_statement] = STATE(480),
    [sym_case_statement] = STATE(480),
    [sym_while_statement] = STATE(480),
    [sym_do_statement] = STATE(480),
    [sym_for_statement] = STATE(480),
    [sym_return_statement] = STATE(480),
    [sym_break_statement] = STATE(480),
    [sym_continue_statement] = STATE(480),
    [sym_goto_statement] = STATE(480),
    [sym_seh_try_statement] = STATE(480),
    [sym_seh_leave_statement] = STATE(480),
    [sym_expression] = STATE(5655),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10869),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(480),
    [sym_co_return_statement] = STATE(480),
    [sym_co_yield_statement] = STATE(480),
    [sym_throw_statement] = STATE(480),
    [sym_try_statement] = STATE(480),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(480),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(480),
    [sym_hlsl_attribute] = STATE(10450),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1226),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(1798),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym___extension__] = ACTIONS(2040),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1157),
    [anon_sym___leave] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1165),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(1167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [103] = {
    [sym_declaration] = STATE(418),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6647),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(515),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(515),
    [sym_statement] = STATE(418),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(10675),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1220),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(1822),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(2040),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [104] = {
    [sym_declaration] = STATE(108),
    [sym_type_definition] = STATE(108),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6621),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(108),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(108),
    [sym_labeled_statement] = STATE(108),
    [sym_expression_statement] = STATE(108),
    [sym_if_statement] = STATE(108),
    [sym_switch_statement] = STATE(108),
    [sym_while_statement] = STATE(108),
    [sym_do_statement] = STATE(108),
    [sym_for_statement] = STATE(108),
    [sym_return_statement] = STATE(108),
    [sym_break_statement] = STATE(108),
    [sym_continue_statement] = STATE(108),
    [sym_goto_statement] = STATE(108),
    [sym_seh_try_statement] = STATE(108),
    [sym_seh_leave_statement] = STATE(108),
    [sym_expression] = STATE(5664),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11323),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(108),
    [sym_co_return_statement] = STATE(108),
    [sym_co_yield_statement] = STATE(108),
    [sym_throw_statement] = STATE(108),
    [sym_try_statement] = STATE(108),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(108),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(108),
    [sym_hlsl_attribute] = STATE(10401),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1243),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(108),
    [sym_identifier] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2044),
    [anon_sym___extension__] = ACTIONS(2086),
    [anon_sym_typedef] = ACTIONS(2088),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_else] = ACTIONS(1824),
    [anon_sym_switch] = ACTIONS(2050),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2058),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2062),
    [anon_sym_break] = ACTIONS(2064),
    [anon_sym_continue] = ACTIONS(2066),
    [anon_sym_goto] = ACTIONS(2068),
    [anon_sym___try] = ACTIONS(2070),
    [anon_sym___leave] = ACTIONS(2072),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(2074),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(2076),
    [anon_sym_co_return] = ACTIONS(2078),
    [anon_sym_co_yield] = ACTIONS(2080),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(2082),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [105] = {
    [sym_declaration] = STATE(872),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6673),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(872),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10697),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1244),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(1900),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(2040),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(275),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [106] = {
    [sym_declaration] = STATE(110),
    [sym_type_definition] = STATE(110),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6621),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(110),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(110),
    [sym_labeled_statement] = STATE(110),
    [sym_expression_statement] = STATE(110),
    [sym_if_statement] = STATE(110),
    [sym_switch_statement] = STATE(110),
    [sym_while_statement] = STATE(110),
    [sym_do_statement] = STATE(110),
    [sym_for_statement] = STATE(110),
    [sym_return_statement] = STATE(110),
    [sym_break_statement] = STATE(110),
    [sym_continue_statement] = STATE(110),
    [sym_goto_statement] = STATE(110),
    [sym_seh_try_statement] = STATE(110),
    [sym_seh_leave_statement] = STATE(110),
    [sym_expression] = STATE(5664),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11323),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(110),
    [sym_co_return_statement] = STATE(110),
    [sym_co_yield_statement] = STATE(110),
    [sym_throw_statement] = STATE(110),
    [sym_try_statement] = STATE(110),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(110),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(110),
    [sym_hlsl_attribute] = STATE(10401),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1243),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(110),
    [sym_identifier] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2044),
    [anon_sym___extension__] = ACTIONS(2086),
    [anon_sym_typedef] = ACTIONS(2088),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_else] = ACTIONS(1800),
    [anon_sym_switch] = ACTIONS(2050),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2058),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2062),
    [anon_sym_break] = ACTIONS(2064),
    [anon_sym_continue] = ACTIONS(2066),
    [anon_sym_goto] = ACTIONS(2068),
    [anon_sym___try] = ACTIONS(2070),
    [anon_sym___leave] = ACTIONS(2072),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(2074),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(2076),
    [anon_sym_co_return] = ACTIONS(2078),
    [anon_sym_co_yield] = ACTIONS(2080),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(2082),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [107] = {
    [sym_declaration] = STATE(454),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6711),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(842),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(454),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10419),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1252),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(2090),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(2040),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(2092),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2094),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(2096),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(2098),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(2100),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [108] = {
    [sym_declaration] = STATE(109),
    [sym_type_definition] = STATE(109),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6621),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(109),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(109),
    [sym_labeled_statement] = STATE(109),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_switch_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_goto_statement] = STATE(109),
    [sym_seh_try_statement] = STATE(109),
    [sym_seh_leave_statement] = STATE(109),
    [sym_expression] = STATE(5664),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11323),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(109),
    [sym_co_return_statement] = STATE(109),
    [sym_co_yield_statement] = STATE(109),
    [sym_throw_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(109),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(109),
    [sym_hlsl_attribute] = STATE(10401),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1243),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(109),
    [sym_identifier] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2044),
    [anon_sym___extension__] = ACTIONS(2086),
    [anon_sym_typedef] = ACTIONS(2088),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_else] = ACTIONS(1820),
    [anon_sym_switch] = ACTIONS(2050),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2058),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2062),
    [anon_sym_break] = ACTIONS(2064),
    [anon_sym_continue] = ACTIONS(2066),
    [anon_sym_goto] = ACTIONS(2068),
    [anon_sym___try] = ACTIONS(2070),
    [anon_sym___leave] = ACTIONS(2072),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(2074),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(2076),
    [anon_sym_co_return] = ACTIONS(2078),
    [anon_sym_co_yield] = ACTIONS(2080),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(2082),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [109] = {
    [sym_declaration] = STATE(109),
    [sym_type_definition] = STATE(109),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6621),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(109),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(109),
    [sym_labeled_statement] = STATE(109),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_switch_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_goto_statement] = STATE(109),
    [sym_seh_try_statement] = STATE(109),
    [sym_seh_leave_statement] = STATE(109),
    [sym_expression] = STATE(5664),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11323),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(109),
    [sym_co_return_statement] = STATE(109),
    [sym_co_yield_statement] = STATE(109),
    [sym_throw_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(109),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(109),
    [sym_hlsl_attribute] = STATE(10401),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1243),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(109),
    [sym_identifier] = ACTIONS(2102),
    [anon_sym_LPAREN2] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_AMP] = ACTIONS(1611),
    [anon_sym_SEMI] = ACTIONS(2105),
    [anon_sym___extension__] = ACTIONS(2108),
    [anon_sym_typedef] = ACTIONS(2111),
    [anon_sym_in] = ACTIONS(1628),
    [anon_sym_out] = ACTIONS(1628),
    [anon_sym_inout] = ACTIONS(1628),
    [anon_sym_virtual] = ACTIONS(1628),
    [anon_sym_extern] = ACTIONS(1631),
    [anon_sym___attribute__] = ACTIONS(1634),
    [anon_sym___attribute] = ACTIONS(1634),
    [anon_sym_COLON_COLON] = ACTIONS(1637),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1640),
    [anon_sym___declspec] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(2114),
    [anon_sym_signed] = ACTIONS(1649),
    [anon_sym_unsigned] = ACTIONS(1649),
    [anon_sym_long] = ACTIONS(1649),
    [anon_sym_short] = ACTIONS(1649),
    [anon_sym_LBRACK] = ACTIONS(1652),
    [anon_sym_static] = ACTIONS(1631),
    [anon_sym_register] = ACTIONS(1631),
    [anon_sym_inline] = ACTIONS(1631),
    [anon_sym___inline] = ACTIONS(1631),
    [anon_sym___inline__] = ACTIONS(1631),
    [anon_sym___forceinline] = ACTIONS(1631),
    [anon_sym_thread_local] = ACTIONS(1631),
    [anon_sym___thread] = ACTIONS(1631),
    [anon_sym_const] = ACTIONS(1655),
    [anon_sym_constexpr] = ACTIONS(1655),
    [anon_sym_volatile] = ACTIONS(1655),
    [anon_sym_restrict] = ACTIONS(1655),
    [anon_sym___restrict__] = ACTIONS(1655),
    [anon_sym__Atomic] = ACTIONS(1655),
    [anon_sym__Noreturn] = ACTIONS(1655),
    [anon_sym_noreturn] = ACTIONS(1655),
    [anon_sym__Nonnull] = ACTIONS(1655),
    [anon_sym_mutable] = ACTIONS(1655),
    [anon_sym_constinit] = ACTIONS(1655),
    [anon_sym_consteval] = ACTIONS(1655),
    [anon_sym_alignas] = ACTIONS(1658),
    [anon_sym__Alignas] = ACTIONS(1658),
    [sym_primitive_type] = ACTIONS(1661),
    [anon_sym_enum] = ACTIONS(1664),
    [anon_sym_class] = ACTIONS(1667),
    [anon_sym_struct] = ACTIONS(1670),
    [anon_sym_union] = ACTIONS(1673),
    [anon_sym_if] = ACTIONS(2117),
    [anon_sym_else] = ACTIONS(1600),
    [anon_sym_switch] = ACTIONS(2120),
    [anon_sym_while] = ACTIONS(2123),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2129),
    [anon_sym_return] = ACTIONS(2132),
    [anon_sym_break] = ACTIONS(2135),
    [anon_sym_continue] = ACTIONS(2138),
    [anon_sym_goto] = ACTIONS(2141),
    [anon_sym___try] = ACTIONS(2144),
    [anon_sym___leave] = ACTIONS(2147),
    [anon_sym_not] = ACTIONS(1608),
    [anon_sym_compl] = ACTIONS(1608),
    [anon_sym_DASH_DASH] = ACTIONS(1709),
    [anon_sym_PLUS_PLUS] = ACTIONS(1709),
    [anon_sym_sizeof] = ACTIONS(1712),
    [anon_sym___alignof__] = ACTIONS(1715),
    [anon_sym___alignof] = ACTIONS(1715),
    [anon_sym__alignof] = ACTIONS(1715),
    [anon_sym_alignof] = ACTIONS(1715),
    [anon_sym__Alignof] = ACTIONS(1715),
    [anon_sym_offsetof] = ACTIONS(1718),
    [anon_sym__Generic] = ACTIONS(1721),
    [anon_sym_asm] = ACTIONS(1724),
    [anon_sym___asm__] = ACTIONS(1724),
    [anon_sym___asm] = ACTIONS(1724),
    [sym_number_literal] = ACTIONS(1727),
    [anon_sym_L_SQUOTE] = ACTIONS(1730),
    [anon_sym_u_SQUOTE] = ACTIONS(1730),
    [anon_sym_U_SQUOTE] = ACTIONS(1730),
    [anon_sym_u8_SQUOTE] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1730),
    [anon_sym_L_DQUOTE] = ACTIONS(1733),
    [anon_sym_u_DQUOTE] = ACTIONS(1733),
    [anon_sym_U_DQUOTE] = ACTIONS(1733),
    [anon_sym_u8_DQUOTE] = ACTIONS(1733),
    [anon_sym_DQUOTE] = ACTIONS(1733),
    [sym_true] = ACTIONS(1736),
    [sym_false] = ACTIONS(1736),
    [anon_sym_NULL] = ACTIONS(1739),
    [anon_sym_nullptr] = ACTIONS(1739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(1742),
    [anon_sym_let] = ACTIONS(1742),
    [anon_sym_This] = ACTIONS(1742),
    [anon_sym_decltype] = ACTIONS(1745),
    [anon_sym_typename] = ACTIONS(1748),
    [anon_sym_template] = ACTIONS(1751),
    [anon_sym_try] = ACTIONS(2150),
    [anon_sym_delete] = ACTIONS(1757),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_co_return] = ACTIONS(2156),
    [anon_sym_co_yield] = ACTIONS(2159),
    [anon_sym_R_DQUOTE] = ACTIONS(1769),
    [anon_sym_LR_DQUOTE] = ACTIONS(1769),
    [anon_sym_uR_DQUOTE] = ACTIONS(1769),
    [anon_sym_UR_DQUOTE] = ACTIONS(1769),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1769),
    [anon_sym_co_await] = ACTIONS(1772),
    [anon_sym_new] = ACTIONS(1775),
    [anon_sym_requires] = ACTIONS(1778),
    [sym_this] = ACTIONS(1736),
    [anon_sym_discard] = ACTIONS(2162),
    [anon_sym_precise] = ACTIONS(1784),
    [anon_sym_shared] = ACTIONS(1784),
    [anon_sym_groupshared] = ACTIONS(1784),
    [anon_sym_uniform] = ACTIONS(1784),
    [anon_sym_row_major] = ACTIONS(1784),
    [anon_sym_column_major] = ACTIONS(1784),
    [anon_sym_globallycoherent] = ACTIONS(1784),
    [anon_sym_centroid] = ACTIONS(1784),
    [anon_sym_noperspective] = ACTIONS(1784),
    [anon_sym_nointerpolation] = ACTIONS(1784),
    [anon_sym_sample] = ACTIONS(1784),
    [anon_sym_linear] = ACTIONS(1784),
    [anon_sym_snorm] = ACTIONS(1784),
    [anon_sym_unorm] = ACTIONS(1784),
    [anon_sym_point] = ACTIONS(1784),
    [anon_sym_line] = ACTIONS(1784),
    [anon_sym_triangleadj] = ACTIONS(1784),
    [anon_sym_lineadj] = ACTIONS(1784),
    [anon_sym_triangle] = ACTIONS(1784),
    [anon_sym_cbuffer] = ACTIONS(2165),
    [anon_sym_interface] = ACTIONS(1790),
    [anon_sym_extension] = ACTIONS(1793),
  },
  [110] = {
    [sym_declaration] = STATE(109),
    [sym_type_definition] = STATE(109),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6621),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(109),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(109),
    [sym_labeled_statement] = STATE(109),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_switch_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_goto_statement] = STATE(109),
    [sym_seh_try_statement] = STATE(109),
    [sym_seh_leave_statement] = STATE(109),
    [sym_expression] = STATE(5664),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11323),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(109),
    [sym_co_return_statement] = STATE(109),
    [sym_co_yield_statement] = STATE(109),
    [sym_throw_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(109),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(109),
    [sym_hlsl_attribute] = STATE(10401),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1243),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_case_statement_repeat1] = STATE(109),
    [sym_identifier] = ACTIONS(2042),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2044),
    [anon_sym___extension__] = ACTIONS(2086),
    [anon_sym_typedef] = ACTIONS(2088),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_else] = ACTIONS(1832),
    [anon_sym_switch] = ACTIONS(2050),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2058),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2062),
    [anon_sym_break] = ACTIONS(2064),
    [anon_sym_continue] = ACTIONS(2066),
    [anon_sym_goto] = ACTIONS(2068),
    [anon_sym___try] = ACTIONS(2070),
    [anon_sym___leave] = ACTIONS(2072),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(2074),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(2076),
    [anon_sym_co_return] = ACTIONS(2078),
    [anon_sym_co_yield] = ACTIONS(2080),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(2082),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [111] = {
    [sym_declaration] = STATE(876),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6732),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(1376),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_compound_statement] = STATE(857),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_attributed_statement] = STATE(857),
    [sym_statement] = STATE(876),
    [sym_labeled_statement] = STATE(857),
    [sym_expression_statement] = STATE(857),
    [sym_if_statement] = STATE(857),
    [sym_switch_statement] = STATE(857),
    [sym_case_statement] = STATE(857),
    [sym_while_statement] = STATE(857),
    [sym_do_statement] = STATE(857),
    [sym_for_statement] = STATE(857),
    [sym_return_statement] = STATE(857),
    [sym_break_statement] = STATE(857),
    [sym_continue_statement] = STATE(857),
    [sym_goto_statement] = STATE(857),
    [sym_seh_try_statement] = STATE(857),
    [sym_seh_leave_statement] = STATE(857),
    [sym_expression] = STATE(5773),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10871),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(857),
    [sym_co_return_statement] = STATE(857),
    [sym_co_yield_statement] = STATE(857),
    [sym_throw_statement] = STATE(857),
    [sym_try_statement] = STATE(857),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(857),
    [sym_qualifiers] = STATE(2666),
    [sym_cbuffer_specifier] = STATE(857),
    [sym_hlsl_attribute] = STATE(10474),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_attributed_declarator_repeat1] = STATE(1214),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(1970),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1083),
    [anon_sym___extension__] = ACTIONS(2040),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1812),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_case] = ACTIONS(1101),
    [anon_sym_default] = ACTIONS(1103),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1107),
    [anon_sym_for] = ACTIONS(1109),
    [anon_sym_return] = ACTIONS(1111),
    [anon_sym_break] = ACTIONS(1113),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_goto] = ACTIONS(1117),
    [anon_sym___try] = ACTIONS(1119),
    [anon_sym___leave] = ACTIONS(1121),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(1125),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_co_return] = ACTIONS(1135),
    [anon_sym_co_yield] = ACTIONS(1137),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1139),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(1141),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [112] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(192),
    [sym_raw_string_literal] = STATE(3527),
    [aux_sym_sized_type_specifier_repeat1] = STATE(665),
    [sym_identifier] = ACTIONS(2168),
    [aux_sym_preproc_include_token1] = ACTIONS(2168),
    [aux_sym_preproc_def_token1] = ACTIONS(2168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [aux_sym_preproc_if_token1] = ACTIONS(2168),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2168),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2168),
    [sym_preproc_directive] = ACTIONS(2168),
    [anon_sym_LPAREN2] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2168),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2178),
    [anon_sym_PLUS] = ACTIONS(2178),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(2186),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2183),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_typedef] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_using] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2193),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym___cdecl] = ACTIONS(2168),
    [anon_sym___clrcall] = ACTIONS(2168),
    [anon_sym___stdcall] = ACTIONS(2168),
    [anon_sym___fastcall] = ACTIONS(2168),
    [anon_sym___thiscall] = ACTIONS(2168),
    [anon_sym___vectorcall] = ACTIONS(2168),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_RBRACE] = ACTIONS(2176),
    [anon_sym_signed] = ACTIONS(2199),
    [anon_sym_unsigned] = ACTIONS(2199),
    [anon_sym_long] = ACTIONS(2199),
    [anon_sym_short] = ACTIONS(2199),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [sym_primitive_type] = ACTIONS(2168),
    [anon_sym_enum] = ACTIONS(2168),
    [anon_sym_class] = ACTIONS(2168),
    [anon_sym_struct] = ACTIONS(2168),
    [anon_sym_union] = ACTIONS(2168),
    [anon_sym_if] = ACTIONS(2168),
    [anon_sym_switch] = ACTIONS(2168),
    [anon_sym_case] = ACTIONS(2168),
    [anon_sym_default] = ACTIONS(2168),
    [anon_sym_while] = ACTIONS(2168),
    [anon_sym_do] = ACTIONS(2168),
    [anon_sym_for] = ACTIONS(2168),
    [anon_sym_return] = ACTIONS(2168),
    [anon_sym_break] = ACTIONS(2168),
    [anon_sym_continue] = ACTIONS(2168),
    [anon_sym_goto] = ACTIONS(2168),
    [anon_sym___try] = ACTIONS(2168),
    [anon_sym___leave] = ACTIONS(2168),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2207),
    [anon_sym_SLASH_EQ] = ACTIONS(2207),
    [anon_sym_PERCENT_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_GT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_EQ] = ACTIONS(2207),
    [anon_sym_CARET_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_EQ] = ACTIONS(2207),
    [anon_sym_and_eq] = ACTIONS(2205),
    [anon_sym_or_eq] = ACTIONS(2205),
    [anon_sym_xor_eq] = ACTIONS(2205),
    [anon_sym_not] = ACTIONS(2168),
    [anon_sym_compl] = ACTIONS(2168),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_sizeof] = ACTIONS(2168),
    [anon_sym___alignof__] = ACTIONS(2168),
    [anon_sym___alignof] = ACTIONS(2168),
    [anon_sym__alignof] = ACTIONS(2168),
    [anon_sym_alignof] = ACTIONS(2168),
    [anon_sym__Alignof] = ACTIONS(2168),
    [anon_sym_offsetof] = ACTIONS(2168),
    [anon_sym__Generic] = ACTIONS(2168),
    [anon_sym_asm] = ACTIONS(2168),
    [anon_sym___asm__] = ACTIONS(2168),
    [anon_sym___asm] = ACTIONS(2168),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [sym_number_literal] = ACTIONS(2176),
    [anon_sym_L_SQUOTE] = ACTIONS(2176),
    [anon_sym_u_SQUOTE] = ACTIONS(2176),
    [anon_sym_U_SQUOTE] = ACTIONS(2176),
    [anon_sym_u8_SQUOTE] = ACTIONS(2176),
    [anon_sym_SQUOTE] = ACTIONS(2176),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(2168),
    [sym_false] = ACTIONS(2168),
    [anon_sym_NULL] = ACTIONS(2168),
    [anon_sym_nullptr] = ACTIONS(2168),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_decltype] = ACTIONS(2168),
    [anon_sym_explicit] = ACTIONS(2168),
    [anon_sym_typename] = ACTIONS(2168),
    [anon_sym_template] = ACTIONS(2168),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_try] = ACTIONS(2168),
    [anon_sym_delete] = ACTIONS(2168),
    [anon_sym_throw] = ACTIONS(2168),
    [anon_sym_namespace] = ACTIONS(2168),
    [anon_sym_static_assert] = ACTIONS(2168),
    [anon_sym_concept] = ACTIONS(2168),
    [anon_sym_co_return] = ACTIONS(2168),
    [anon_sym_co_yield] = ACTIONS(2168),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(2168),
    [anon_sym_new] = ACTIONS(2168),
    [anon_sym_requires] = ACTIONS(2168),
    [sym_this] = ACTIONS(2168),
    [anon_sym_discard] = ACTIONS(2168),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
    [anon_sym_cbuffer] = ACTIONS(2168),
    [anon_sym_interface] = ACTIONS(2168),
    [anon_sym_extension] = ACTIONS(2168),
  },
  [113] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(176),
    [sym_raw_string_literal] = STATE(3527),
    [aux_sym_sized_type_specifier_repeat1] = STATE(714),
    [ts_builtin_sym_end] = ACTIONS(2176),
    [sym_identifier] = ACTIONS(2168),
    [aux_sym_preproc_include_token1] = ACTIONS(2168),
    [aux_sym_preproc_def_token1] = ACTIONS(2168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [aux_sym_preproc_if_token1] = ACTIONS(2168),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2168),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2168),
    [sym_preproc_directive] = ACTIONS(2168),
    [anon_sym_LPAREN2] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2168),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2178),
    [anon_sym_PLUS] = ACTIONS(2178),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(2213),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(2216),
    [anon_sym_SEMI] = ACTIONS(2218),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_typedef] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_using] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2193),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym___cdecl] = ACTIONS(2168),
    [anon_sym___clrcall] = ACTIONS(2168),
    [anon_sym___stdcall] = ACTIONS(2168),
    [anon_sym___fastcall] = ACTIONS(2168),
    [anon_sym___thiscall] = ACTIONS(2168),
    [anon_sym___vectorcall] = ACTIONS(2168),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_signed] = ACTIONS(2220),
    [anon_sym_unsigned] = ACTIONS(2220),
    [anon_sym_long] = ACTIONS(2220),
    [anon_sym_short] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [sym_primitive_type] = ACTIONS(2168),
    [anon_sym_enum] = ACTIONS(2168),
    [anon_sym_class] = ACTIONS(2168),
    [anon_sym_struct] = ACTIONS(2168),
    [anon_sym_union] = ACTIONS(2168),
    [anon_sym_if] = ACTIONS(2168),
    [anon_sym_switch] = ACTIONS(2168),
    [anon_sym_case] = ACTIONS(2168),
    [anon_sym_default] = ACTIONS(2168),
    [anon_sym_while] = ACTIONS(2168),
    [anon_sym_do] = ACTIONS(2168),
    [anon_sym_for] = ACTIONS(2168),
    [anon_sym_return] = ACTIONS(2168),
    [anon_sym_break] = ACTIONS(2168),
    [anon_sym_continue] = ACTIONS(2168),
    [anon_sym_goto] = ACTIONS(2168),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2207),
    [anon_sym_SLASH_EQ] = ACTIONS(2207),
    [anon_sym_PERCENT_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_GT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_EQ] = ACTIONS(2207),
    [anon_sym_CARET_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_EQ] = ACTIONS(2207),
    [anon_sym_and_eq] = ACTIONS(2205),
    [anon_sym_or_eq] = ACTIONS(2205),
    [anon_sym_xor_eq] = ACTIONS(2205),
    [anon_sym_not] = ACTIONS(2168),
    [anon_sym_compl] = ACTIONS(2168),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_sizeof] = ACTIONS(2168),
    [anon_sym___alignof__] = ACTIONS(2168),
    [anon_sym___alignof] = ACTIONS(2168),
    [anon_sym__alignof] = ACTIONS(2168),
    [anon_sym_alignof] = ACTIONS(2168),
    [anon_sym__Alignof] = ACTIONS(2168),
    [anon_sym_offsetof] = ACTIONS(2168),
    [anon_sym__Generic] = ACTIONS(2168),
    [anon_sym_asm] = ACTIONS(2168),
    [anon_sym___asm__] = ACTIONS(2168),
    [anon_sym___asm] = ACTIONS(2168),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [sym_number_literal] = ACTIONS(2176),
    [anon_sym_L_SQUOTE] = ACTIONS(2176),
    [anon_sym_u_SQUOTE] = ACTIONS(2176),
    [anon_sym_U_SQUOTE] = ACTIONS(2176),
    [anon_sym_u8_SQUOTE] = ACTIONS(2176),
    [anon_sym_SQUOTE] = ACTIONS(2176),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(2168),
    [sym_false] = ACTIONS(2168),
    [anon_sym_NULL] = ACTIONS(2168),
    [anon_sym_nullptr] = ACTIONS(2168),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_decltype] = ACTIONS(2168),
    [anon_sym_explicit] = ACTIONS(2168),
    [anon_sym_typename] = ACTIONS(2168),
    [anon_sym_export] = ACTIONS(2168),
    [anon_sym_module] = ACTIONS(2168),
    [anon_sym_import] = ACTIONS(2168),
    [anon_sym_template] = ACTIONS(2168),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_try] = ACTIONS(2168),
    [anon_sym_delete] = ACTIONS(2168),
    [anon_sym_throw] = ACTIONS(2168),
    [anon_sym_namespace] = ACTIONS(2168),
    [anon_sym_static_assert] = ACTIONS(2168),
    [anon_sym_concept] = ACTIONS(2168),
    [anon_sym_co_return] = ACTIONS(2168),
    [anon_sym_co_yield] = ACTIONS(2168),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(2168),
    [anon_sym_new] = ACTIONS(2168),
    [anon_sym_requires] = ACTIONS(2168),
    [sym_this] = ACTIONS(2168),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
    [anon_sym_interface] = ACTIONS(2168),
    [anon_sym_extension] = ACTIONS(2168),
    [anon_sym___exported] = ACTIONS(2168),
  },
  [114] = {
    [sym_template_argument_list] = STATE(116),
    [sym_identifier] = ACTIONS(2222),
    [aux_sym_preproc_include_token1] = ACTIONS(2222),
    [aux_sym_preproc_def_token1] = ACTIONS(2222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2224),
    [anon_sym_COMMA] = ACTIONS(2224),
    [aux_sym_preproc_if_token1] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2222),
    [sym_preproc_directive] = ACTIONS(2222),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2229),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2231),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_PIPE_PIPE] = ACTIONS(2224),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_EQ_EQ] = ACTIONS(2224),
    [anon_sym_BANG_EQ] = ACTIONS(2224),
    [anon_sym_GT] = ACTIONS(2234),
    [anon_sym_GT_EQ] = ACTIONS(2224),
    [anon_sym_LT_EQ] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2234),
    [anon_sym_GT_GT] = ACTIONS(2234),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_typedef] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_virtual] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym___attribute] = ACTIONS(2222),
    [anon_sym_using] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2226),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym___based] = ACTIONS(2222),
    [anon_sym___cdecl] = ACTIONS(2222),
    [anon_sym___clrcall] = ACTIONS(2222),
    [anon_sym___stdcall] = ACTIONS(2222),
    [anon_sym___fastcall] = ACTIONS(2222),
    [anon_sym___thiscall] = ACTIONS(2222),
    [anon_sym___vectorcall] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_RBRACE] = ACTIONS(2229),
    [anon_sym_signed] = ACTIONS(2222),
    [anon_sym_unsigned] = ACTIONS(2222),
    [anon_sym_long] = ACTIONS(2222),
    [anon_sym_short] = ACTIONS(2222),
    [anon_sym_LBRACK] = ACTIONS(2231),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym__Nonnull] = ACTIONS(2222),
    [anon_sym_mutable] = ACTIONS(2222),
    [anon_sym_constinit] = ACTIONS(2222),
    [anon_sym_consteval] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [sym_primitive_type] = ACTIONS(2222),
    [anon_sym_enum] = ACTIONS(2222),
    [anon_sym_class] = ACTIONS(2222),
    [anon_sym_struct] = ACTIONS(2222),
    [anon_sym_union] = ACTIONS(2222),
    [anon_sym_if] = ACTIONS(2222),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2222),
    [anon_sym_default] = ACTIONS(2222),
    [anon_sym_while] = ACTIONS(2222),
    [anon_sym_do] = ACTIONS(2222),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_return] = ACTIONS(2222),
    [anon_sym_break] = ACTIONS(2222),
    [anon_sym_continue] = ACTIONS(2222),
    [anon_sym_goto] = ACTIONS(2222),
    [anon_sym___try] = ACTIONS(2222),
    [anon_sym___leave] = ACTIONS(2222),
    [anon_sym_QMARK] = ACTIONS(2224),
    [anon_sym_STAR_EQ] = ACTIONS(2224),
    [anon_sym_SLASH_EQ] = ACTIONS(2224),
    [anon_sym_PERCENT_EQ] = ACTIONS(2224),
    [anon_sym_PLUS_EQ] = ACTIONS(2224),
    [anon_sym_DASH_EQ] = ACTIONS(2224),
    [anon_sym_LT_LT_EQ] = ACTIONS(2224),
    [anon_sym_GT_GT_EQ] = ACTIONS(2224),
    [anon_sym_AMP_EQ] = ACTIONS(2224),
    [anon_sym_CARET_EQ] = ACTIONS(2224),
    [anon_sym_PIPE_EQ] = ACTIONS(2224),
    [anon_sym_and_eq] = ACTIONS(2234),
    [anon_sym_or_eq] = ACTIONS(2234),
    [anon_sym_xor_eq] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_compl] = ACTIONS(2222),
    [anon_sym_LT_EQ_GT] = ACTIONS(2224),
    [anon_sym_or] = ACTIONS(2234),
    [anon_sym_and] = ACTIONS(2234),
    [anon_sym_bitor] = ACTIONS(2234),
    [anon_sym_xor] = ACTIONS(2234),
    [anon_sym_bitand] = ACTIONS(2234),
    [anon_sym_not_eq] = ACTIONS(2234),
    [anon_sym_is] = ACTIONS(2234),
    [anon_sym_as] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(2222),
    [anon_sym___alignof] = ACTIONS(2222),
    [anon_sym__alignof] = ACTIONS(2222),
    [anon_sym_alignof] = ACTIONS(2222),
    [anon_sym__Alignof] = ACTIONS(2222),
    [anon_sym_offsetof] = ACTIONS(2222),
    [anon_sym__Generic] = ACTIONS(2222),
    [anon_sym_asm] = ACTIONS(2222),
    [anon_sym___asm__] = ACTIONS(2222),
    [anon_sym___asm] = ACTIONS(2222),
    [anon_sym_DOT] = ACTIONS(2231),
    [anon_sym_DOT_STAR] = ACTIONS(2224),
    [anon_sym_DASH_GT] = ACTIONS(2224),
    [sym_number_literal] = ACTIONS(2229),
    [anon_sym_L_SQUOTE] = ACTIONS(2229),
    [anon_sym_u_SQUOTE] = ACTIONS(2229),
    [anon_sym_U_SQUOTE] = ACTIONS(2229),
    [anon_sym_u8_SQUOTE] = ACTIONS(2229),
    [anon_sym_SQUOTE] = ACTIONS(2229),
    [anon_sym_L_DQUOTE] = ACTIONS(2229),
    [anon_sym_u_DQUOTE] = ACTIONS(2229),
    [anon_sym_U_DQUOTE] = ACTIONS(2229),
    [anon_sym_u8_DQUOTE] = ACTIONS(2229),
    [anon_sym_DQUOTE] = ACTIONS(2229),
    [sym_true] = ACTIONS(2222),
    [sym_false] = ACTIONS(2222),
    [anon_sym_NULL] = ACTIONS(2222),
    [anon_sym_nullptr] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2222),
    [anon_sym_let] = ACTIONS(2222),
    [anon_sym_This] = ACTIONS(2222),
    [anon_sym_decltype] = ACTIONS(2222),
    [anon_sym_explicit] = ACTIONS(2222),
    [anon_sym_typename] = ACTIONS(2222),
    [anon_sym_template] = ACTIONS(2222),
    [anon_sym_operator] = ACTIONS(2222),
    [anon_sym_try] = ACTIONS(2222),
    [anon_sym_delete] = ACTIONS(2222),
    [anon_sym_throw] = ACTIONS(2222),
    [anon_sym_namespace] = ACTIONS(2222),
    [anon_sym_static_assert] = ACTIONS(2222),
    [anon_sym_concept] = ACTIONS(2222),
    [anon_sym_co_return] = ACTIONS(2222),
    [anon_sym_co_yield] = ACTIONS(2222),
    [anon_sym_R_DQUOTE] = ACTIONS(2229),
    [anon_sym_LR_DQUOTE] = ACTIONS(2229),
    [anon_sym_uR_DQUOTE] = ACTIONS(2229),
    [anon_sym_UR_DQUOTE] = ACTIONS(2229),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2229),
    [anon_sym_co_await] = ACTIONS(2222),
    [anon_sym_new] = ACTIONS(2222),
    [anon_sym_requires] = ACTIONS(2222),
    [sym_this] = ACTIONS(2222),
    [anon_sym_discard] = ACTIONS(2222),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_groupshared] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_row_major] = ACTIONS(2222),
    [anon_sym_column_major] = ACTIONS(2222),
    [anon_sym_globallycoherent] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym_nointerpolation] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_linear] = ACTIONS(2222),
    [anon_sym_snorm] = ACTIONS(2222),
    [anon_sym_unorm] = ACTIONS(2222),
    [anon_sym_point] = ACTIONS(2222),
    [anon_sym_line] = ACTIONS(2222),
    [anon_sym_triangleadj] = ACTIONS(2222),
    [anon_sym_lineadj] = ACTIONS(2222),
    [anon_sym_triangle] = ACTIONS(2222),
    [anon_sym_cbuffer] = ACTIONS(2222),
    [anon_sym_interface] = ACTIONS(2222),
    [anon_sym_extension] = ACTIONS(2222),
  },
  [115] = {
    [sym_identifier] = ACTIONS(2239),
    [aux_sym_preproc_include_token1] = ACTIONS(2239),
    [aux_sym_preproc_def_token1] = ACTIONS(2239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2241),
    [anon_sym_COMMA] = ACTIONS(2241),
    [aux_sym_preproc_if_token1] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2239),
    [sym_preproc_directive] = ACTIONS(2239),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2239),
    [anon_sym_PLUS] = ACTIONS(2239),
    [anon_sym_STAR] = ACTIONS(2239),
    [anon_sym_SLASH] = ACTIONS(2239),
    [anon_sym_PERCENT] = ACTIONS(2239),
    [anon_sym_PIPE_PIPE] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_PIPE] = ACTIONS(2239),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_LT_EQ] = ACTIONS(2239),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_LT_LT] = ACTIONS(2239),
    [anon_sym_GT_GT] = ACTIONS(2239),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym_typedef] = ACTIONS(2239),
    [anon_sym_in] = ACTIONS(2239),
    [anon_sym_out] = ACTIONS(2239),
    [anon_sym_inout] = ACTIONS(2239),
    [anon_sym_virtual] = ACTIONS(2239),
    [anon_sym_extern] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym___attribute] = ACTIONS(2239),
    [anon_sym_using] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2241),
    [anon_sym___declspec] = ACTIONS(2239),
    [anon_sym___based] = ACTIONS(2239),
    [anon_sym___cdecl] = ACTIONS(2239),
    [anon_sym___clrcall] = ACTIONS(2239),
    [anon_sym___stdcall] = ACTIONS(2239),
    [anon_sym___fastcall] = ACTIONS(2239),
    [anon_sym___thiscall] = ACTIONS(2239),
    [anon_sym___vectorcall] = ACTIONS(2239),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_RBRACE] = ACTIONS(2241),
    [anon_sym_signed] = ACTIONS(2239),
    [anon_sym_unsigned] = ACTIONS(2239),
    [anon_sym_long] = ACTIONS(2239),
    [anon_sym_short] = ACTIONS(2239),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2239),
    [anon_sym_EQ] = ACTIONS(2239),
    [anon_sym_register] = ACTIONS(2239),
    [anon_sym_inline] = ACTIONS(2239),
    [anon_sym___inline] = ACTIONS(2239),
    [anon_sym___inline__] = ACTIONS(2239),
    [anon_sym___forceinline] = ACTIONS(2239),
    [anon_sym_thread_local] = ACTIONS(2239),
    [anon_sym___thread] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym__Nonnull] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [sym_primitive_type] = ACTIONS(2239),
    [anon_sym_enum] = ACTIONS(2239),
    [anon_sym_class] = ACTIONS(2239),
    [anon_sym_struct] = ACTIONS(2239),
    [anon_sym_union] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(2239),
    [anon_sym_switch] = ACTIONS(2239),
    [anon_sym_case] = ACTIONS(2239),
    [anon_sym_default] = ACTIONS(2239),
    [anon_sym_while] = ACTIONS(2239),
    [anon_sym_do] = ACTIONS(2239),
    [anon_sym_for] = ACTIONS(2239),
    [anon_sym_return] = ACTIONS(2239),
    [anon_sym_break] = ACTIONS(2239),
    [anon_sym_continue] = ACTIONS(2239),
    [anon_sym_goto] = ACTIONS(2239),
    [anon_sym___try] = ACTIONS(2239),
    [anon_sym___leave] = ACTIONS(2239),
    [anon_sym_QMARK] = ACTIONS(2241),
    [anon_sym_STAR_EQ] = ACTIONS(2241),
    [anon_sym_SLASH_EQ] = ACTIONS(2241),
    [anon_sym_PERCENT_EQ] = ACTIONS(2241),
    [anon_sym_PLUS_EQ] = ACTIONS(2241),
    [anon_sym_DASH_EQ] = ACTIONS(2241),
    [anon_sym_LT_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_GT_EQ] = ACTIONS(2241),
    [anon_sym_AMP_EQ] = ACTIONS(2241),
    [anon_sym_CARET_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_EQ] = ACTIONS(2241),
    [anon_sym_and_eq] = ACTIONS(2239),
    [anon_sym_or_eq] = ACTIONS(2239),
    [anon_sym_xor_eq] = ACTIONS(2239),
    [anon_sym_not] = ACTIONS(2239),
    [anon_sym_compl] = ACTIONS(2239),
    [anon_sym_LT_EQ_GT] = ACTIONS(2241),
    [anon_sym_or] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(2239),
    [anon_sym_bitor] = ACTIONS(2239),
    [anon_sym_xor] = ACTIONS(2239),
    [anon_sym_bitand] = ACTIONS(2239),
    [anon_sym_not_eq] = ACTIONS(2239),
    [anon_sym_is] = ACTIONS(2239),
    [anon_sym_as] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_sizeof] = ACTIONS(2239),
    [anon_sym___alignof__] = ACTIONS(2239),
    [anon_sym___alignof] = ACTIONS(2239),
    [anon_sym__alignof] = ACTIONS(2239),
    [anon_sym_alignof] = ACTIONS(2239),
    [anon_sym__Alignof] = ACTIONS(2239),
    [anon_sym_offsetof] = ACTIONS(2239),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2239),
    [anon_sym___asm__] = ACTIONS(2239),
    [anon_sym___asm] = ACTIONS(2239),
    [anon_sym_DOT] = ACTIONS(2239),
    [anon_sym_DOT_STAR] = ACTIONS(2241),
    [anon_sym_DASH_GT] = ACTIONS(2241),
    [sym_number_literal] = ACTIONS(2241),
    [anon_sym_L_SQUOTE] = ACTIONS(2241),
    [anon_sym_u_SQUOTE] = ACTIONS(2241),
    [anon_sym_U_SQUOTE] = ACTIONS(2241),
    [anon_sym_u8_SQUOTE] = ACTIONS(2241),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_L_DQUOTE] = ACTIONS(2241),
    [anon_sym_u_DQUOTE] = ACTIONS(2241),
    [anon_sym_U_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8_DQUOTE] = ACTIONS(2241),
    [anon_sym_DQUOTE] = ACTIONS(2241),
    [sym_true] = ACTIONS(2239),
    [sym_false] = ACTIONS(2239),
    [anon_sym_NULL] = ACTIONS(2239),
    [anon_sym_nullptr] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2239),
    [anon_sym_let] = ACTIONS(2239),
    [anon_sym_This] = ACTIONS(2239),
    [anon_sym_decltype] = ACTIONS(2239),
    [anon_sym_explicit] = ACTIONS(2239),
    [anon_sym_typename] = ACTIONS(2239),
    [anon_sym_template] = ACTIONS(2239),
    [anon_sym_operator] = ACTIONS(2239),
    [anon_sym_try] = ACTIONS(2239),
    [anon_sym_delete] = ACTIONS(2239),
    [anon_sym_throw] = ACTIONS(2239),
    [anon_sym_namespace] = ACTIONS(2239),
    [anon_sym_static_assert] = ACTIONS(2239),
    [anon_sym_concept] = ACTIONS(2239),
    [anon_sym_co_return] = ACTIONS(2239),
    [anon_sym_co_yield] = ACTIONS(2239),
    [anon_sym_R_DQUOTE] = ACTIONS(2241),
    [anon_sym_LR_DQUOTE] = ACTIONS(2241),
    [anon_sym_uR_DQUOTE] = ACTIONS(2241),
    [anon_sym_UR_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2241),
    [anon_sym_co_await] = ACTIONS(2239),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_requires] = ACTIONS(2239),
    [sym_this] = ACTIONS(2239),
    [anon_sym_discard] = ACTIONS(2239),
    [anon_sym_precise] = ACTIONS(2239),
    [anon_sym_shared] = ACTIONS(2239),
    [anon_sym_groupshared] = ACTIONS(2239),
    [anon_sym_uniform] = ACTIONS(2239),
    [anon_sym_row_major] = ACTIONS(2239),
    [anon_sym_column_major] = ACTIONS(2239),
    [anon_sym_globallycoherent] = ACTIONS(2239),
    [anon_sym_centroid] = ACTIONS(2239),
    [anon_sym_noperspective] = ACTIONS(2239),
    [anon_sym_nointerpolation] = ACTIONS(2239),
    [anon_sym_sample] = ACTIONS(2239),
    [anon_sym_linear] = ACTIONS(2239),
    [anon_sym_snorm] = ACTIONS(2239),
    [anon_sym_unorm] = ACTIONS(2239),
    [anon_sym_point] = ACTIONS(2239),
    [anon_sym_line] = ACTIONS(2239),
    [anon_sym_triangleadj] = ACTIONS(2239),
    [anon_sym_lineadj] = ACTIONS(2239),
    [anon_sym_triangle] = ACTIONS(2239),
    [anon_sym_cbuffer] = ACTIONS(2239),
    [anon_sym_interface] = ACTIONS(2239),
    [anon_sym_extension] = ACTIONS(2239),
  },
  [116] = {
    [sym_identifier] = ACTIONS(2243),
    [aux_sym_preproc_include_token1] = ACTIONS(2243),
    [aux_sym_preproc_def_token1] = ACTIONS(2243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2245),
    [anon_sym_COMMA] = ACTIONS(2245),
    [aux_sym_preproc_if_token1] = ACTIONS(2243),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2243),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2243),
    [sym_preproc_directive] = ACTIONS(2243),
    [anon_sym_LPAREN2] = ACTIONS(2247),
    [anon_sym_BANG] = ACTIONS(2243),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_SLASH] = ACTIONS(2255),
    [anon_sym_PERCENT] = ACTIONS(2255),
    [anon_sym_PIPE_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2255),
    [anon_sym_CARET] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2245),
    [anon_sym_BANG_EQ] = ACTIONS(2245),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_GT_EQ] = ACTIONS(2245),
    [anon_sym_LT_EQ] = ACTIONS(2255),
    [anon_sym_LT] = ACTIONS(2255),
    [anon_sym_LT_LT] = ACTIONS(2255),
    [anon_sym_GT_GT] = ACTIONS(2255),
    [anon_sym_SEMI] = ACTIONS(2247),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym_typedef] = ACTIONS(2243),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_out] = ACTIONS(2243),
    [anon_sym_inout] = ACTIONS(2243),
    [anon_sym_virtual] = ACTIONS(2243),
    [anon_sym_extern] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym___attribute] = ACTIONS(2243),
    [anon_sym_using] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2247),
    [anon_sym___declspec] = ACTIONS(2243),
    [anon_sym___based] = ACTIONS(2243),
    [anon_sym___cdecl] = ACTIONS(2243),
    [anon_sym___clrcall] = ACTIONS(2243),
    [anon_sym___stdcall] = ACTIONS(2243),
    [anon_sym___fastcall] = ACTIONS(2243),
    [anon_sym___thiscall] = ACTIONS(2243),
    [anon_sym___vectorcall] = ACTIONS(2243),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_signed] = ACTIONS(2243),
    [anon_sym_unsigned] = ACTIONS(2243),
    [anon_sym_long] = ACTIONS(2243),
    [anon_sym_short] = ACTIONS(2243),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_EQ] = ACTIONS(2255),
    [anon_sym_register] = ACTIONS(2243),
    [anon_sym_inline] = ACTIONS(2243),
    [anon_sym___inline] = ACTIONS(2243),
    [anon_sym___inline__] = ACTIONS(2243),
    [anon_sym___forceinline] = ACTIONS(2243),
    [anon_sym_thread_local] = ACTIONS(2243),
    [anon_sym___thread] = ACTIONS(2243),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym__Nonnull] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [sym_primitive_type] = ACTIONS(2243),
    [anon_sym_enum] = ACTIONS(2243),
    [anon_sym_class] = ACTIONS(2243),
    [anon_sym_struct] = ACTIONS(2243),
    [anon_sym_union] = ACTIONS(2243),
    [anon_sym_if] = ACTIONS(2243),
    [anon_sym_switch] = ACTIONS(2243),
    [anon_sym_case] = ACTIONS(2243),
    [anon_sym_default] = ACTIONS(2243),
    [anon_sym_while] = ACTIONS(2243),
    [anon_sym_do] = ACTIONS(2243),
    [anon_sym_for] = ACTIONS(2243),
    [anon_sym_return] = ACTIONS(2243),
    [anon_sym_break] = ACTIONS(2243),
    [anon_sym_continue] = ACTIONS(2243),
    [anon_sym_goto] = ACTIONS(2243),
    [anon_sym___try] = ACTIONS(2243),
    [anon_sym___leave] = ACTIONS(2243),
    [anon_sym_QMARK] = ACTIONS(2245),
    [anon_sym_STAR_EQ] = ACTIONS(2245),
    [anon_sym_SLASH_EQ] = ACTIONS(2245),
    [anon_sym_PERCENT_EQ] = ACTIONS(2245),
    [anon_sym_PLUS_EQ] = ACTIONS(2245),
    [anon_sym_DASH_EQ] = ACTIONS(2245),
    [anon_sym_LT_LT_EQ] = ACTIONS(2245),
    [anon_sym_GT_GT_EQ] = ACTIONS(2245),
    [anon_sym_AMP_EQ] = ACTIONS(2245),
    [anon_sym_CARET_EQ] = ACTIONS(2245),
    [anon_sym_PIPE_EQ] = ACTIONS(2245),
    [anon_sym_and_eq] = ACTIONS(2255),
    [anon_sym_or_eq] = ACTIONS(2255),
    [anon_sym_xor_eq] = ACTIONS(2255),
    [anon_sym_not] = ACTIONS(2243),
    [anon_sym_compl] = ACTIONS(2243),
    [anon_sym_LT_EQ_GT] = ACTIONS(2245),
    [anon_sym_or] = ACTIONS(2255),
    [anon_sym_and] = ACTIONS(2255),
    [anon_sym_bitor] = ACTIONS(2255),
    [anon_sym_xor] = ACTIONS(2255),
    [anon_sym_bitand] = ACTIONS(2255),
    [anon_sym_not_eq] = ACTIONS(2255),
    [anon_sym_is] = ACTIONS(2255),
    [anon_sym_as] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2247),
    [anon_sym_PLUS_PLUS] = ACTIONS(2247),
    [anon_sym_sizeof] = ACTIONS(2243),
    [anon_sym___alignof__] = ACTIONS(2243),
    [anon_sym___alignof] = ACTIONS(2243),
    [anon_sym__alignof] = ACTIONS(2243),
    [anon_sym_alignof] = ACTIONS(2243),
    [anon_sym__Alignof] = ACTIONS(2243),
    [anon_sym_offsetof] = ACTIONS(2243),
    [anon_sym__Generic] = ACTIONS(2243),
    [anon_sym_asm] = ACTIONS(2243),
    [anon_sym___asm__] = ACTIONS(2243),
    [anon_sym___asm] = ACTIONS(2243),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2245),
    [anon_sym_DASH_GT] = ACTIONS(2245),
    [sym_number_literal] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2250),
    [anon_sym_u_SQUOTE] = ACTIONS(2250),
    [anon_sym_U_SQUOTE] = ACTIONS(2250),
    [anon_sym_u8_SQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_L_DQUOTE] = ACTIONS(2250),
    [anon_sym_u_DQUOTE] = ACTIONS(2250),
    [anon_sym_U_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [sym_true] = ACTIONS(2243),
    [sym_false] = ACTIONS(2243),
    [anon_sym_NULL] = ACTIONS(2243),
    [anon_sym_nullptr] = ACTIONS(2243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2243),
    [anon_sym_let] = ACTIONS(2243),
    [anon_sym_This] = ACTIONS(2243),
    [anon_sym_decltype] = ACTIONS(2243),
    [anon_sym_explicit] = ACTIONS(2243),
    [anon_sym_typename] = ACTIONS(2243),
    [anon_sym_template] = ACTIONS(2243),
    [anon_sym_operator] = ACTIONS(2243),
    [anon_sym_try] = ACTIONS(2243),
    [anon_sym_delete] = ACTIONS(2243),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_namespace] = ACTIONS(2243),
    [anon_sym_static_assert] = ACTIONS(2243),
    [anon_sym_concept] = ACTIONS(2243),
    [anon_sym_co_return] = ACTIONS(2243),
    [anon_sym_co_yield] = ACTIONS(2243),
    [anon_sym_R_DQUOTE] = ACTIONS(2250),
    [anon_sym_LR_DQUOTE] = ACTIONS(2250),
    [anon_sym_uR_DQUOTE] = ACTIONS(2250),
    [anon_sym_UR_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2250),
    [anon_sym_co_await] = ACTIONS(2243),
    [anon_sym_new] = ACTIONS(2243),
    [anon_sym_requires] = ACTIONS(2243),
    [sym_this] = ACTIONS(2243),
    [anon_sym_discard] = ACTIONS(2243),
    [anon_sym_precise] = ACTIONS(2243),
    [anon_sym_shared] = ACTIONS(2243),
    [anon_sym_groupshared] = ACTIONS(2243),
    [anon_sym_uniform] = ACTIONS(2243),
    [anon_sym_row_major] = ACTIONS(2243),
    [anon_sym_column_major] = ACTIONS(2243),
    [anon_sym_globallycoherent] = ACTIONS(2243),
    [anon_sym_centroid] = ACTIONS(2243),
    [anon_sym_noperspective] = ACTIONS(2243),
    [anon_sym_nointerpolation] = ACTIONS(2243),
    [anon_sym_sample] = ACTIONS(2243),
    [anon_sym_linear] = ACTIONS(2243),
    [anon_sym_snorm] = ACTIONS(2243),
    [anon_sym_unorm] = ACTIONS(2243),
    [anon_sym_point] = ACTIONS(2243),
    [anon_sym_line] = ACTIONS(2243),
    [anon_sym_triangleadj] = ACTIONS(2243),
    [anon_sym_lineadj] = ACTIONS(2243),
    [anon_sym_triangle] = ACTIONS(2243),
    [anon_sym_cbuffer] = ACTIONS(2243),
    [anon_sym_interface] = ACTIONS(2243),
    [anon_sym_extension] = ACTIONS(2243),
  },
  [117] = {
    [sym_template_argument_list] = STATE(146),
    [ts_builtin_sym_end] = ACTIONS(2229),
    [sym_identifier] = ACTIONS(2222),
    [aux_sym_preproc_include_token1] = ACTIONS(2222),
    [aux_sym_preproc_def_token1] = ACTIONS(2222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2224),
    [aux_sym_preproc_if_token1] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2222),
    [sym_preproc_directive] = ACTIONS(2222),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2229),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2231),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_PIPE_PIPE] = ACTIONS(2224),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_EQ_EQ] = ACTIONS(2224),
    [anon_sym_BANG_EQ] = ACTIONS(2224),
    [anon_sym_GT] = ACTIONS(2234),
    [anon_sym_GT_EQ] = ACTIONS(2224),
    [anon_sym_LT_EQ] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2257),
    [anon_sym_LT_LT] = ACTIONS(2234),
    [anon_sym_GT_GT] = ACTIONS(2234),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_typedef] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_virtual] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym___attribute] = ACTIONS(2222),
    [anon_sym_using] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2226),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym___based] = ACTIONS(2222),
    [anon_sym___cdecl] = ACTIONS(2222),
    [anon_sym___clrcall] = ACTIONS(2222),
    [anon_sym___stdcall] = ACTIONS(2222),
    [anon_sym___fastcall] = ACTIONS(2222),
    [anon_sym___thiscall] = ACTIONS(2222),
    [anon_sym___vectorcall] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_signed] = ACTIONS(2222),
    [anon_sym_unsigned] = ACTIONS(2222),
    [anon_sym_long] = ACTIONS(2222),
    [anon_sym_short] = ACTIONS(2222),
    [anon_sym_LBRACK] = ACTIONS(2231),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym__Nonnull] = ACTIONS(2222),
    [anon_sym_mutable] = ACTIONS(2222),
    [anon_sym_constinit] = ACTIONS(2222),
    [anon_sym_consteval] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [sym_primitive_type] = ACTIONS(2222),
    [anon_sym_enum] = ACTIONS(2222),
    [anon_sym_class] = ACTIONS(2222),
    [anon_sym_struct] = ACTIONS(2222),
    [anon_sym_union] = ACTIONS(2222),
    [anon_sym_if] = ACTIONS(2222),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2222),
    [anon_sym_default] = ACTIONS(2222),
    [anon_sym_while] = ACTIONS(2222),
    [anon_sym_do] = ACTIONS(2222),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_return] = ACTIONS(2222),
    [anon_sym_break] = ACTIONS(2222),
    [anon_sym_continue] = ACTIONS(2222),
    [anon_sym_goto] = ACTIONS(2222),
    [anon_sym_QMARK] = ACTIONS(2224),
    [anon_sym_STAR_EQ] = ACTIONS(2224),
    [anon_sym_SLASH_EQ] = ACTIONS(2224),
    [anon_sym_PERCENT_EQ] = ACTIONS(2224),
    [anon_sym_PLUS_EQ] = ACTIONS(2224),
    [anon_sym_DASH_EQ] = ACTIONS(2224),
    [anon_sym_LT_LT_EQ] = ACTIONS(2224),
    [anon_sym_GT_GT_EQ] = ACTIONS(2224),
    [anon_sym_AMP_EQ] = ACTIONS(2224),
    [anon_sym_CARET_EQ] = ACTIONS(2224),
    [anon_sym_PIPE_EQ] = ACTIONS(2224),
    [anon_sym_and_eq] = ACTIONS(2234),
    [anon_sym_or_eq] = ACTIONS(2234),
    [anon_sym_xor_eq] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_compl] = ACTIONS(2222),
    [anon_sym_LT_EQ_GT] = ACTIONS(2224),
    [anon_sym_or] = ACTIONS(2234),
    [anon_sym_and] = ACTIONS(2234),
    [anon_sym_bitor] = ACTIONS(2234),
    [anon_sym_xor] = ACTIONS(2234),
    [anon_sym_bitand] = ACTIONS(2234),
    [anon_sym_not_eq] = ACTIONS(2234),
    [anon_sym_is] = ACTIONS(2234),
    [anon_sym_as] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(2222),
    [anon_sym___alignof] = ACTIONS(2222),
    [anon_sym__alignof] = ACTIONS(2222),
    [anon_sym_alignof] = ACTIONS(2222),
    [anon_sym__Alignof] = ACTIONS(2222),
    [anon_sym_offsetof] = ACTIONS(2222),
    [anon_sym__Generic] = ACTIONS(2222),
    [anon_sym_asm] = ACTIONS(2222),
    [anon_sym___asm__] = ACTIONS(2222),
    [anon_sym___asm] = ACTIONS(2222),
    [anon_sym_DOT] = ACTIONS(2231),
    [anon_sym_DOT_STAR] = ACTIONS(2224),
    [anon_sym_DASH_GT] = ACTIONS(2224),
    [sym_number_literal] = ACTIONS(2229),
    [anon_sym_L_SQUOTE] = ACTIONS(2229),
    [anon_sym_u_SQUOTE] = ACTIONS(2229),
    [anon_sym_U_SQUOTE] = ACTIONS(2229),
    [anon_sym_u8_SQUOTE] = ACTIONS(2229),
    [anon_sym_SQUOTE] = ACTIONS(2229),
    [anon_sym_L_DQUOTE] = ACTIONS(2229),
    [anon_sym_u_DQUOTE] = ACTIONS(2229),
    [anon_sym_U_DQUOTE] = ACTIONS(2229),
    [anon_sym_u8_DQUOTE] = ACTIONS(2229),
    [anon_sym_DQUOTE] = ACTIONS(2229),
    [sym_true] = ACTIONS(2222),
    [sym_false] = ACTIONS(2222),
    [anon_sym_NULL] = ACTIONS(2222),
    [anon_sym_nullptr] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2222),
    [anon_sym_let] = ACTIONS(2222),
    [anon_sym_This] = ACTIONS(2222),
    [anon_sym_decltype] = ACTIONS(2222),
    [anon_sym_explicit] = ACTIONS(2222),
    [anon_sym_typename] = ACTIONS(2222),
    [anon_sym_export] = ACTIONS(2222),
    [anon_sym_module] = ACTIONS(2222),
    [anon_sym_import] = ACTIONS(2222),
    [anon_sym_template] = ACTIONS(2222),
    [anon_sym_operator] = ACTIONS(2222),
    [anon_sym_try] = ACTIONS(2222),
    [anon_sym_delete] = ACTIONS(2222),
    [anon_sym_throw] = ACTIONS(2222),
    [anon_sym_namespace] = ACTIONS(2222),
    [anon_sym_static_assert] = ACTIONS(2222),
    [anon_sym_concept] = ACTIONS(2222),
    [anon_sym_co_return] = ACTIONS(2222),
    [anon_sym_co_yield] = ACTIONS(2222),
    [anon_sym_R_DQUOTE] = ACTIONS(2229),
    [anon_sym_LR_DQUOTE] = ACTIONS(2229),
    [anon_sym_uR_DQUOTE] = ACTIONS(2229),
    [anon_sym_UR_DQUOTE] = ACTIONS(2229),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2229),
    [anon_sym_co_await] = ACTIONS(2222),
    [anon_sym_new] = ACTIONS(2222),
    [anon_sym_requires] = ACTIONS(2222),
    [sym_this] = ACTIONS(2222),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_groupshared] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_row_major] = ACTIONS(2222),
    [anon_sym_column_major] = ACTIONS(2222),
    [anon_sym_globallycoherent] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym_nointerpolation] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_linear] = ACTIONS(2222),
    [anon_sym_snorm] = ACTIONS(2222),
    [anon_sym_unorm] = ACTIONS(2222),
    [anon_sym_point] = ACTIONS(2222),
    [anon_sym_line] = ACTIONS(2222),
    [anon_sym_triangleadj] = ACTIONS(2222),
    [anon_sym_lineadj] = ACTIONS(2222),
    [anon_sym_triangle] = ACTIONS(2222),
    [anon_sym_interface] = ACTIONS(2222),
    [anon_sym_extension] = ACTIONS(2222),
    [anon_sym___exported] = ACTIONS(2222),
  },
  [118] = {
    [sym_identifier] = ACTIONS(2260),
    [aux_sym_preproc_include_token1] = ACTIONS(2260),
    [aux_sym_preproc_def_token1] = ACTIONS(2260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_COMMA] = ACTIONS(2262),
    [aux_sym_preproc_if_token1] = ACTIONS(2260),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2260),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2260),
    [sym_preproc_directive] = ACTIONS(2260),
    [anon_sym_LPAREN2] = ACTIONS(2262),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2260),
    [anon_sym_PERCENT] = ACTIONS(2260),
    [anon_sym_PIPE_PIPE] = ACTIONS(2262),
    [anon_sym_AMP_AMP] = ACTIONS(2262),
    [anon_sym_PIPE] = ACTIONS(2260),
    [anon_sym_CARET] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_EQ_EQ] = ACTIONS(2262),
    [anon_sym_BANG_EQ] = ACTIONS(2262),
    [anon_sym_GT] = ACTIONS(2260),
    [anon_sym_GT_EQ] = ACTIONS(2262),
    [anon_sym_LT_EQ] = ACTIONS(2260),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_LT_LT] = ACTIONS(2260),
    [anon_sym_GT_GT] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym___extension__] = ACTIONS(2260),
    [anon_sym_typedef] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(2260),
    [anon_sym_out] = ACTIONS(2260),
    [anon_sym_inout] = ACTIONS(2260),
    [anon_sym_virtual] = ACTIONS(2260),
    [anon_sym_extern] = ACTIONS(2260),
    [anon_sym___attribute__] = ACTIONS(2260),
    [anon_sym___attribute] = ACTIONS(2260),
    [anon_sym_using] = ACTIONS(2260),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2262),
    [anon_sym___declspec] = ACTIONS(2260),
    [anon_sym___based] = ACTIONS(2260),
    [anon_sym___cdecl] = ACTIONS(2260),
    [anon_sym___clrcall] = ACTIONS(2260),
    [anon_sym___stdcall] = ACTIONS(2260),
    [anon_sym___fastcall] = ACTIONS(2260),
    [anon_sym___thiscall] = ACTIONS(2260),
    [anon_sym___vectorcall] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_RBRACE] = ACTIONS(2262),
    [anon_sym_signed] = ACTIONS(2260),
    [anon_sym_unsigned] = ACTIONS(2260),
    [anon_sym_long] = ACTIONS(2260),
    [anon_sym_short] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_EQ] = ACTIONS(2260),
    [anon_sym_register] = ACTIONS(2260),
    [anon_sym_inline] = ACTIONS(2260),
    [anon_sym___inline] = ACTIONS(2260),
    [anon_sym___inline__] = ACTIONS(2260),
    [anon_sym___forceinline] = ACTIONS(2260),
    [anon_sym_thread_local] = ACTIONS(2260),
    [anon_sym___thread] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_constexpr] = ACTIONS(2260),
    [anon_sym_volatile] = ACTIONS(2260),
    [anon_sym_restrict] = ACTIONS(2260),
    [anon_sym___restrict__] = ACTIONS(2260),
    [anon_sym__Atomic] = ACTIONS(2260),
    [anon_sym__Noreturn] = ACTIONS(2260),
    [anon_sym_noreturn] = ACTIONS(2260),
    [anon_sym__Nonnull] = ACTIONS(2260),
    [anon_sym_mutable] = ACTIONS(2260),
    [anon_sym_constinit] = ACTIONS(2260),
    [anon_sym_consteval] = ACTIONS(2260),
    [anon_sym_alignas] = ACTIONS(2260),
    [anon_sym__Alignas] = ACTIONS(2260),
    [sym_primitive_type] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
    [anon_sym_class] = ACTIONS(2260),
    [anon_sym_struct] = ACTIONS(2260),
    [anon_sym_union] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_switch] = ACTIONS(2260),
    [anon_sym_case] = ACTIONS(2260),
    [anon_sym_default] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_do] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_goto] = ACTIONS(2260),
    [anon_sym___try] = ACTIONS(2260),
    [anon_sym___leave] = ACTIONS(2260),
    [anon_sym_QMARK] = ACTIONS(2262),
    [anon_sym_STAR_EQ] = ACTIONS(2262),
    [anon_sym_SLASH_EQ] = ACTIONS(2262),
    [anon_sym_PERCENT_EQ] = ACTIONS(2262),
    [anon_sym_PLUS_EQ] = ACTIONS(2262),
    [anon_sym_DASH_EQ] = ACTIONS(2262),
    [anon_sym_LT_LT_EQ] = ACTIONS(2262),
    [anon_sym_GT_GT_EQ] = ACTIONS(2262),
    [anon_sym_AMP_EQ] = ACTIONS(2262),
    [anon_sym_CARET_EQ] = ACTIONS(2262),
    [anon_sym_PIPE_EQ] = ACTIONS(2262),
    [anon_sym_and_eq] = ACTIONS(2260),
    [anon_sym_or_eq] = ACTIONS(2260),
    [anon_sym_xor_eq] = ACTIONS(2260),
    [anon_sym_not] = ACTIONS(2260),
    [anon_sym_compl] = ACTIONS(2260),
    [anon_sym_LT_EQ_GT] = ACTIONS(2262),
    [anon_sym_or] = ACTIONS(2260),
    [anon_sym_and] = ACTIONS(2260),
    [anon_sym_bitor] = ACTIONS(2260),
    [anon_sym_xor] = ACTIONS(2260),
    [anon_sym_bitand] = ACTIONS(2260),
    [anon_sym_not_eq] = ACTIONS(2260),
    [anon_sym_is] = ACTIONS(2260),
    [anon_sym_as] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_sizeof] = ACTIONS(2260),
    [anon_sym___alignof__] = ACTIONS(2260),
    [anon_sym___alignof] = ACTIONS(2260),
    [anon_sym__alignof] = ACTIONS(2260),
    [anon_sym_alignof] = ACTIONS(2260),
    [anon_sym__Alignof] = ACTIONS(2260),
    [anon_sym_offsetof] = ACTIONS(2260),
    [anon_sym__Generic] = ACTIONS(2260),
    [anon_sym_asm] = ACTIONS(2260),
    [anon_sym___asm__] = ACTIONS(2260),
    [anon_sym___asm] = ACTIONS(2260),
    [anon_sym_DOT] = ACTIONS(2260),
    [anon_sym_DOT_STAR] = ACTIONS(2262),
    [anon_sym_DASH_GT] = ACTIONS(2262),
    [sym_number_literal] = ACTIONS(2262),
    [anon_sym_L_SQUOTE] = ACTIONS(2262),
    [anon_sym_u_SQUOTE] = ACTIONS(2262),
    [anon_sym_U_SQUOTE] = ACTIONS(2262),
    [anon_sym_u8_SQUOTE] = ACTIONS(2262),
    [anon_sym_SQUOTE] = ACTIONS(2262),
    [anon_sym_L_DQUOTE] = ACTIONS(2262),
    [anon_sym_u_DQUOTE] = ACTIONS(2262),
    [anon_sym_U_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8_DQUOTE] = ACTIONS(2262),
    [anon_sym_DQUOTE] = ACTIONS(2262),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [anon_sym_NULL] = ACTIONS(2260),
    [anon_sym_nullptr] = ACTIONS(2260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_This] = ACTIONS(2260),
    [anon_sym_decltype] = ACTIONS(2260),
    [anon_sym_explicit] = ACTIONS(2260),
    [anon_sym_typename] = ACTIONS(2260),
    [anon_sym_template] = ACTIONS(2260),
    [anon_sym_operator] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_throw] = ACTIONS(2260),
    [anon_sym_namespace] = ACTIONS(2260),
    [anon_sym_static_assert] = ACTIONS(2260),
    [anon_sym_concept] = ACTIONS(2260),
    [anon_sym_co_return] = ACTIONS(2260),
    [anon_sym_co_yield] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2260),
    [anon_sym_new] = ACTIONS(2260),
    [anon_sym_requires] = ACTIONS(2260),
    [sym_this] = ACTIONS(2260),
    [anon_sym_discard] = ACTIONS(2260),
    [anon_sym_precise] = ACTIONS(2260),
    [anon_sym_shared] = ACTIONS(2260),
    [anon_sym_groupshared] = ACTIONS(2260),
    [anon_sym_uniform] = ACTIONS(2260),
    [anon_sym_row_major] = ACTIONS(2260),
    [anon_sym_column_major] = ACTIONS(2260),
    [anon_sym_globallycoherent] = ACTIONS(2260),
    [anon_sym_centroid] = ACTIONS(2260),
    [anon_sym_noperspective] = ACTIONS(2260),
    [anon_sym_nointerpolation] = ACTIONS(2260),
    [anon_sym_sample] = ACTIONS(2260),
    [anon_sym_linear] = ACTIONS(2260),
    [anon_sym_snorm] = ACTIONS(2260),
    [anon_sym_unorm] = ACTIONS(2260),
    [anon_sym_point] = ACTIONS(2260),
    [anon_sym_line] = ACTIONS(2260),
    [anon_sym_triangleadj] = ACTIONS(2260),
    [anon_sym_lineadj] = ACTIONS(2260),
    [anon_sym_triangle] = ACTIONS(2260),
    [anon_sym_cbuffer] = ACTIONS(2260),
    [anon_sym_interface] = ACTIONS(2260),
    [anon_sym_extension] = ACTIONS(2260),
  },
  [119] = {
    [sym_identifier] = ACTIONS(2264),
    [aux_sym_preproc_include_token1] = ACTIONS(2264),
    [aux_sym_preproc_def_token1] = ACTIONS(2264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2266),
    [anon_sym_COMMA] = ACTIONS(2266),
    [aux_sym_preproc_if_token1] = ACTIONS(2264),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2264),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2264),
    [sym_preproc_directive] = ACTIONS(2264),
    [anon_sym_LPAREN2] = ACTIONS(2266),
    [anon_sym_BANG] = ACTIONS(2264),
    [anon_sym_TILDE] = ACTIONS(2266),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2264),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_PERCENT] = ACTIONS(2264),
    [anon_sym_PIPE_PIPE] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2266),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_CARET] = ACTIONS(2264),
    [anon_sym_AMP] = ACTIONS(2264),
    [anon_sym_EQ_EQ] = ACTIONS(2266),
    [anon_sym_BANG_EQ] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(2264),
    [anon_sym_GT_EQ] = ACTIONS(2266),
    [anon_sym_LT_EQ] = ACTIONS(2264),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_LT_LT] = ACTIONS(2264),
    [anon_sym_GT_GT] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2266),
    [anon_sym___extension__] = ACTIONS(2264),
    [anon_sym_typedef] = ACTIONS(2264),
    [anon_sym_in] = ACTIONS(2264),
    [anon_sym_out] = ACTIONS(2264),
    [anon_sym_inout] = ACTIONS(2264),
    [anon_sym_virtual] = ACTIONS(2264),
    [anon_sym_extern] = ACTIONS(2264),
    [anon_sym___attribute__] = ACTIONS(2264),
    [anon_sym___attribute] = ACTIONS(2264),
    [anon_sym_using] = ACTIONS(2264),
    [anon_sym_COLON_COLON] = ACTIONS(2266),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2266),
    [anon_sym___declspec] = ACTIONS(2264),
    [anon_sym___based] = ACTIONS(2264),
    [anon_sym___cdecl] = ACTIONS(2264),
    [anon_sym___clrcall] = ACTIONS(2264),
    [anon_sym___stdcall] = ACTIONS(2264),
    [anon_sym___fastcall] = ACTIONS(2264),
    [anon_sym___thiscall] = ACTIONS(2264),
    [anon_sym___vectorcall] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_RBRACE] = ACTIONS(2266),
    [anon_sym_signed] = ACTIONS(2264),
    [anon_sym_unsigned] = ACTIONS(2264),
    [anon_sym_long] = ACTIONS(2264),
    [anon_sym_short] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_EQ] = ACTIONS(2264),
    [anon_sym_register] = ACTIONS(2264),
    [anon_sym_inline] = ACTIONS(2264),
    [anon_sym___inline] = ACTIONS(2264),
    [anon_sym___inline__] = ACTIONS(2264),
    [anon_sym___forceinline] = ACTIONS(2264),
    [anon_sym_thread_local] = ACTIONS(2264),
    [anon_sym___thread] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_constexpr] = ACTIONS(2264),
    [anon_sym_volatile] = ACTIONS(2264),
    [anon_sym_restrict] = ACTIONS(2264),
    [anon_sym___restrict__] = ACTIONS(2264),
    [anon_sym__Atomic] = ACTIONS(2264),
    [anon_sym__Noreturn] = ACTIONS(2264),
    [anon_sym_noreturn] = ACTIONS(2264),
    [anon_sym__Nonnull] = ACTIONS(2264),
    [anon_sym_mutable] = ACTIONS(2264),
    [anon_sym_constinit] = ACTIONS(2264),
    [anon_sym_consteval] = ACTIONS(2264),
    [anon_sym_alignas] = ACTIONS(2264),
    [anon_sym__Alignas] = ACTIONS(2264),
    [sym_primitive_type] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
    [anon_sym_class] = ACTIONS(2264),
    [anon_sym_struct] = ACTIONS(2264),
    [anon_sym_union] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_switch] = ACTIONS(2264),
    [anon_sym_case] = ACTIONS(2264),
    [anon_sym_default] = ACTIONS(2264),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_do] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_goto] = ACTIONS(2264),
    [anon_sym___try] = ACTIONS(2264),
    [anon_sym___leave] = ACTIONS(2264),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_STAR_EQ] = ACTIONS(2266),
    [anon_sym_SLASH_EQ] = ACTIONS(2266),
    [anon_sym_PERCENT_EQ] = ACTIONS(2266),
    [anon_sym_PLUS_EQ] = ACTIONS(2266),
    [anon_sym_DASH_EQ] = ACTIONS(2266),
    [anon_sym_LT_LT_EQ] = ACTIONS(2266),
    [anon_sym_GT_GT_EQ] = ACTIONS(2266),
    [anon_sym_AMP_EQ] = ACTIONS(2266),
    [anon_sym_CARET_EQ] = ACTIONS(2266),
    [anon_sym_PIPE_EQ] = ACTIONS(2266),
    [anon_sym_and_eq] = ACTIONS(2264),
    [anon_sym_or_eq] = ACTIONS(2264),
    [anon_sym_xor_eq] = ACTIONS(2264),
    [anon_sym_not] = ACTIONS(2264),
    [anon_sym_compl] = ACTIONS(2264),
    [anon_sym_LT_EQ_GT] = ACTIONS(2266),
    [anon_sym_or] = ACTIONS(2264),
    [anon_sym_and] = ACTIONS(2264),
    [anon_sym_bitor] = ACTIONS(2264),
    [anon_sym_xor] = ACTIONS(2264),
    [anon_sym_bitand] = ACTIONS(2264),
    [anon_sym_not_eq] = ACTIONS(2264),
    [anon_sym_is] = ACTIONS(2264),
    [anon_sym_as] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2266),
    [anon_sym_PLUS_PLUS] = ACTIONS(2266),
    [anon_sym_sizeof] = ACTIONS(2264),
    [anon_sym___alignof__] = ACTIONS(2264),
    [anon_sym___alignof] = ACTIONS(2264),
    [anon_sym__alignof] = ACTIONS(2264),
    [anon_sym_alignof] = ACTIONS(2264),
    [anon_sym__Alignof] = ACTIONS(2264),
    [anon_sym_offsetof] = ACTIONS(2264),
    [anon_sym__Generic] = ACTIONS(2264),
    [anon_sym_asm] = ACTIONS(2264),
    [anon_sym___asm__] = ACTIONS(2264),
    [anon_sym___asm] = ACTIONS(2264),
    [anon_sym_DOT] = ACTIONS(2264),
    [anon_sym_DOT_STAR] = ACTIONS(2266),
    [anon_sym_DASH_GT] = ACTIONS(2266),
    [sym_number_literal] = ACTIONS(2266),
    [anon_sym_L_SQUOTE] = ACTIONS(2266),
    [anon_sym_u_SQUOTE] = ACTIONS(2266),
    [anon_sym_U_SQUOTE] = ACTIONS(2266),
    [anon_sym_u8_SQUOTE] = ACTIONS(2266),
    [anon_sym_SQUOTE] = ACTIONS(2266),
    [anon_sym_L_DQUOTE] = ACTIONS(2266),
    [anon_sym_u_DQUOTE] = ACTIONS(2266),
    [anon_sym_U_DQUOTE] = ACTIONS(2266),
    [anon_sym_u8_DQUOTE] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(2266),
    [sym_true] = ACTIONS(2264),
    [sym_false] = ACTIONS(2264),
    [anon_sym_NULL] = ACTIONS(2264),
    [anon_sym_nullptr] = ACTIONS(2264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_This] = ACTIONS(2264),
    [anon_sym_decltype] = ACTIONS(2264),
    [anon_sym_explicit] = ACTIONS(2264),
    [anon_sym_typename] = ACTIONS(2264),
    [anon_sym_template] = ACTIONS(2264),
    [anon_sym_operator] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [anon_sym_delete] = ACTIONS(2264),
    [anon_sym_throw] = ACTIONS(2264),
    [anon_sym_namespace] = ACTIONS(2264),
    [anon_sym_static_assert] = ACTIONS(2264),
    [anon_sym_concept] = ACTIONS(2264),
    [anon_sym_co_return] = ACTIONS(2264),
    [anon_sym_co_yield] = ACTIONS(2264),
    [anon_sym_R_DQUOTE] = ACTIONS(2266),
    [anon_sym_LR_DQUOTE] = ACTIONS(2266),
    [anon_sym_uR_DQUOTE] = ACTIONS(2266),
    [anon_sym_UR_DQUOTE] = ACTIONS(2266),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2266),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2264),
    [anon_sym_requires] = ACTIONS(2264),
    [sym_this] = ACTIONS(2264),
    [anon_sym_discard] = ACTIONS(2264),
    [anon_sym_precise] = ACTIONS(2264),
    [anon_sym_shared] = ACTIONS(2264),
    [anon_sym_groupshared] = ACTIONS(2264),
    [anon_sym_uniform] = ACTIONS(2264),
    [anon_sym_row_major] = ACTIONS(2264),
    [anon_sym_column_major] = ACTIONS(2264),
    [anon_sym_globallycoherent] = ACTIONS(2264),
    [anon_sym_centroid] = ACTIONS(2264),
    [anon_sym_noperspective] = ACTIONS(2264),
    [anon_sym_nointerpolation] = ACTIONS(2264),
    [anon_sym_sample] = ACTIONS(2264),
    [anon_sym_linear] = ACTIONS(2264),
    [anon_sym_snorm] = ACTIONS(2264),
    [anon_sym_unorm] = ACTIONS(2264),
    [anon_sym_point] = ACTIONS(2264),
    [anon_sym_line] = ACTIONS(2264),
    [anon_sym_triangleadj] = ACTIONS(2264),
    [anon_sym_lineadj] = ACTIONS(2264),
    [anon_sym_triangle] = ACTIONS(2264),
    [anon_sym_cbuffer] = ACTIONS(2264),
    [anon_sym_interface] = ACTIONS(2264),
    [anon_sym_extension] = ACTIONS(2264),
  },
  [120] = {
    [sym_identifier] = ACTIONS(2268),
    [aux_sym_preproc_include_token1] = ACTIONS(2268),
    [aux_sym_preproc_def_token1] = ACTIONS(2268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2270),
    [anon_sym_COMMA] = ACTIONS(2270),
    [aux_sym_preproc_if_token1] = ACTIONS(2268),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2268),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2268),
    [sym_preproc_directive] = ACTIONS(2268),
    [anon_sym_LPAREN2] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2268),
    [anon_sym_TILDE] = ACTIONS(2270),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2268),
    [anon_sym_SLASH] = ACTIONS(2268),
    [anon_sym_PERCENT] = ACTIONS(2268),
    [anon_sym_PIPE_PIPE] = ACTIONS(2270),
    [anon_sym_AMP_AMP] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2268),
    [anon_sym_CARET] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2268),
    [anon_sym_EQ_EQ] = ACTIONS(2270),
    [anon_sym_BANG_EQ] = ACTIONS(2270),
    [anon_sym_GT] = ACTIONS(2268),
    [anon_sym_GT_EQ] = ACTIONS(2270),
    [anon_sym_LT_EQ] = ACTIONS(2268),
    [anon_sym_LT] = ACTIONS(2268),
    [anon_sym_LT_LT] = ACTIONS(2268),
    [anon_sym_GT_GT] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym___extension__] = ACTIONS(2268),
    [anon_sym_typedef] = ACTIONS(2268),
    [anon_sym_in] = ACTIONS(2268),
    [anon_sym_out] = ACTIONS(2268),
    [anon_sym_inout] = ACTIONS(2268),
    [anon_sym_virtual] = ACTIONS(2268),
    [anon_sym_extern] = ACTIONS(2268),
    [anon_sym___attribute__] = ACTIONS(2268),
    [anon_sym___attribute] = ACTIONS(2268),
    [anon_sym_using] = ACTIONS(2268),
    [anon_sym_COLON_COLON] = ACTIONS(2270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2270),
    [anon_sym___declspec] = ACTIONS(2268),
    [anon_sym___based] = ACTIONS(2268),
    [anon_sym___cdecl] = ACTIONS(2268),
    [anon_sym___clrcall] = ACTIONS(2268),
    [anon_sym___stdcall] = ACTIONS(2268),
    [anon_sym___fastcall] = ACTIONS(2268),
    [anon_sym___thiscall] = ACTIONS(2268),
    [anon_sym___vectorcall] = ACTIONS(2268),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_RBRACE] = ACTIONS(2270),
    [anon_sym_signed] = ACTIONS(2268),
    [anon_sym_unsigned] = ACTIONS(2268),
    [anon_sym_long] = ACTIONS(2268),
    [anon_sym_short] = ACTIONS(2268),
    [anon_sym_LBRACK] = ACTIONS(2268),
    [anon_sym_static] = ACTIONS(2268),
    [anon_sym_EQ] = ACTIONS(2268),
    [anon_sym_register] = ACTIONS(2268),
    [anon_sym_inline] = ACTIONS(2268),
    [anon_sym___inline] = ACTIONS(2268),
    [anon_sym___inline__] = ACTIONS(2268),
    [anon_sym___forceinline] = ACTIONS(2268),
    [anon_sym_thread_local] = ACTIONS(2268),
    [anon_sym___thread] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_constexpr] = ACTIONS(2268),
    [anon_sym_volatile] = ACTIONS(2268),
    [anon_sym_restrict] = ACTIONS(2268),
    [anon_sym___restrict__] = ACTIONS(2268),
    [anon_sym__Atomic] = ACTIONS(2268),
    [anon_sym__Noreturn] = ACTIONS(2268),
    [anon_sym_noreturn] = ACTIONS(2268),
    [anon_sym__Nonnull] = ACTIONS(2268),
    [anon_sym_mutable] = ACTIONS(2268),
    [anon_sym_constinit] = ACTIONS(2268),
    [anon_sym_consteval] = ACTIONS(2268),
    [anon_sym_alignas] = ACTIONS(2268),
    [anon_sym__Alignas] = ACTIONS(2268),
    [sym_primitive_type] = ACTIONS(2268),
    [anon_sym_enum] = ACTIONS(2268),
    [anon_sym_class] = ACTIONS(2268),
    [anon_sym_struct] = ACTIONS(2268),
    [anon_sym_union] = ACTIONS(2268),
    [anon_sym_if] = ACTIONS(2268),
    [anon_sym_switch] = ACTIONS(2268),
    [anon_sym_case] = ACTIONS(2268),
    [anon_sym_default] = ACTIONS(2268),
    [anon_sym_while] = ACTIONS(2268),
    [anon_sym_do] = ACTIONS(2268),
    [anon_sym_for] = ACTIONS(2268),
    [anon_sym_return] = ACTIONS(2268),
    [anon_sym_break] = ACTIONS(2268),
    [anon_sym_continue] = ACTIONS(2268),
    [anon_sym_goto] = ACTIONS(2268),
    [anon_sym___try] = ACTIONS(2268),
    [anon_sym___leave] = ACTIONS(2268),
    [anon_sym_QMARK] = ACTIONS(2270),
    [anon_sym_STAR_EQ] = ACTIONS(2270),
    [anon_sym_SLASH_EQ] = ACTIONS(2270),
    [anon_sym_PERCENT_EQ] = ACTIONS(2270),
    [anon_sym_PLUS_EQ] = ACTIONS(2270),
    [anon_sym_DASH_EQ] = ACTIONS(2270),
    [anon_sym_LT_LT_EQ] = ACTIONS(2270),
    [anon_sym_GT_GT_EQ] = ACTIONS(2270),
    [anon_sym_AMP_EQ] = ACTIONS(2270),
    [anon_sym_CARET_EQ] = ACTIONS(2270),
    [anon_sym_PIPE_EQ] = ACTIONS(2270),
    [anon_sym_and_eq] = ACTIONS(2268),
    [anon_sym_or_eq] = ACTIONS(2268),
    [anon_sym_xor_eq] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2268),
    [anon_sym_compl] = ACTIONS(2268),
    [anon_sym_LT_EQ_GT] = ACTIONS(2270),
    [anon_sym_or] = ACTIONS(2268),
    [anon_sym_and] = ACTIONS(2268),
    [anon_sym_bitor] = ACTIONS(2268),
    [anon_sym_xor] = ACTIONS(2268),
    [anon_sym_bitand] = ACTIONS(2268),
    [anon_sym_not_eq] = ACTIONS(2268),
    [anon_sym_is] = ACTIONS(2268),
    [anon_sym_as] = ACTIONS(2268),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_sizeof] = ACTIONS(2268),
    [anon_sym___alignof__] = ACTIONS(2268),
    [anon_sym___alignof] = ACTIONS(2268),
    [anon_sym__alignof] = ACTIONS(2268),
    [anon_sym_alignof] = ACTIONS(2268),
    [anon_sym__Alignof] = ACTIONS(2268),
    [anon_sym_offsetof] = ACTIONS(2268),
    [anon_sym__Generic] = ACTIONS(2268),
    [anon_sym_asm] = ACTIONS(2268),
    [anon_sym___asm__] = ACTIONS(2268),
    [anon_sym___asm] = ACTIONS(2268),
    [anon_sym_DOT] = ACTIONS(2268),
    [anon_sym_DOT_STAR] = ACTIONS(2270),
    [anon_sym_DASH_GT] = ACTIONS(2270),
    [sym_number_literal] = ACTIONS(2270),
    [anon_sym_L_SQUOTE] = ACTIONS(2270),
    [anon_sym_u_SQUOTE] = ACTIONS(2270),
    [anon_sym_U_SQUOTE] = ACTIONS(2270),
    [anon_sym_u8_SQUOTE] = ACTIONS(2270),
    [anon_sym_SQUOTE] = ACTIONS(2270),
    [anon_sym_L_DQUOTE] = ACTIONS(2270),
    [anon_sym_u_DQUOTE] = ACTIONS(2270),
    [anon_sym_U_DQUOTE] = ACTIONS(2270),
    [anon_sym_u8_DQUOTE] = ACTIONS(2270),
    [anon_sym_DQUOTE] = ACTIONS(2270),
    [sym_true] = ACTIONS(2268),
    [sym_false] = ACTIONS(2268),
    [anon_sym_NULL] = ACTIONS(2268),
    [anon_sym_nullptr] = ACTIONS(2268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_This] = ACTIONS(2268),
    [anon_sym_decltype] = ACTIONS(2268),
    [anon_sym_explicit] = ACTIONS(2268),
    [anon_sym_typename] = ACTIONS(2268),
    [anon_sym_template] = ACTIONS(2268),
    [anon_sym_operator] = ACTIONS(2268),
    [anon_sym_try] = ACTIONS(2268),
    [anon_sym_delete] = ACTIONS(2268),
    [anon_sym_throw] = ACTIONS(2268),
    [anon_sym_namespace] = ACTIONS(2268),
    [anon_sym_static_assert] = ACTIONS(2268),
    [anon_sym_concept] = ACTIONS(2268),
    [anon_sym_co_return] = ACTIONS(2268),
    [anon_sym_co_yield] = ACTIONS(2268),
    [anon_sym_R_DQUOTE] = ACTIONS(2270),
    [anon_sym_LR_DQUOTE] = ACTIONS(2270),
    [anon_sym_uR_DQUOTE] = ACTIONS(2270),
    [anon_sym_UR_DQUOTE] = ACTIONS(2270),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2270),
    [anon_sym_co_await] = ACTIONS(2268),
    [anon_sym_new] = ACTIONS(2268),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2268),
    [anon_sym_discard] = ACTIONS(2268),
    [anon_sym_precise] = ACTIONS(2268),
    [anon_sym_shared] = ACTIONS(2268),
    [anon_sym_groupshared] = ACTIONS(2268),
    [anon_sym_uniform] = ACTIONS(2268),
    [anon_sym_row_major] = ACTIONS(2268),
    [anon_sym_column_major] = ACTIONS(2268),
    [anon_sym_globallycoherent] = ACTIONS(2268),
    [anon_sym_centroid] = ACTIONS(2268),
    [anon_sym_noperspective] = ACTIONS(2268),
    [anon_sym_nointerpolation] = ACTIONS(2268),
    [anon_sym_sample] = ACTIONS(2268),
    [anon_sym_linear] = ACTIONS(2268),
    [anon_sym_snorm] = ACTIONS(2268),
    [anon_sym_unorm] = ACTIONS(2268),
    [anon_sym_point] = ACTIONS(2268),
    [anon_sym_line] = ACTIONS(2268),
    [anon_sym_triangleadj] = ACTIONS(2268),
    [anon_sym_lineadj] = ACTIONS(2268),
    [anon_sym_triangle] = ACTIONS(2268),
    [anon_sym_cbuffer] = ACTIONS(2268),
    [anon_sym_interface] = ACTIONS(2268),
    [anon_sym_extension] = ACTIONS(2268),
  },
  [121] = {
    [sym_identifier] = ACTIONS(2272),
    [aux_sym_preproc_include_token1] = ACTIONS(2272),
    [aux_sym_preproc_def_token1] = ACTIONS(2272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2274),
    [anon_sym_COMMA] = ACTIONS(2274),
    [aux_sym_preproc_if_token1] = ACTIONS(2272),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2272),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2272),
    [sym_preproc_directive] = ACTIONS(2272),
    [anon_sym_LPAREN2] = ACTIONS(2274),
    [anon_sym_BANG] = ACTIONS(2272),
    [anon_sym_TILDE] = ACTIONS(2274),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2272),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_PERCENT] = ACTIONS(2272),
    [anon_sym_PIPE_PIPE] = ACTIONS(2274),
    [anon_sym_AMP_AMP] = ACTIONS(2274),
    [anon_sym_PIPE] = ACTIONS(2272),
    [anon_sym_CARET] = ACTIONS(2272),
    [anon_sym_AMP] = ACTIONS(2272),
    [anon_sym_EQ_EQ] = ACTIONS(2274),
    [anon_sym_BANG_EQ] = ACTIONS(2274),
    [anon_sym_GT] = ACTIONS(2272),
    [anon_sym_GT_EQ] = ACTIONS(2274),
    [anon_sym_LT_EQ] = ACTIONS(2272),
    [anon_sym_LT] = ACTIONS(2272),
    [anon_sym_LT_LT] = ACTIONS(2272),
    [anon_sym_GT_GT] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym___extension__] = ACTIONS(2272),
    [anon_sym_typedef] = ACTIONS(2272),
    [anon_sym_in] = ACTIONS(2272),
    [anon_sym_out] = ACTIONS(2272),
    [anon_sym_inout] = ACTIONS(2272),
    [anon_sym_virtual] = ACTIONS(2272),
    [anon_sym_extern] = ACTIONS(2272),
    [anon_sym___attribute__] = ACTIONS(2272),
    [anon_sym___attribute] = ACTIONS(2272),
    [anon_sym_using] = ACTIONS(2272),
    [anon_sym_COLON_COLON] = ACTIONS(2274),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2274),
    [anon_sym___declspec] = ACTIONS(2272),
    [anon_sym___based] = ACTIONS(2272),
    [anon_sym___cdecl] = ACTIONS(2272),
    [anon_sym___clrcall] = ACTIONS(2272),
    [anon_sym___stdcall] = ACTIONS(2272),
    [anon_sym___fastcall] = ACTIONS(2272),
    [anon_sym___thiscall] = ACTIONS(2272),
    [anon_sym___vectorcall] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_RBRACE] = ACTIONS(2274),
    [anon_sym_signed] = ACTIONS(2272),
    [anon_sym_unsigned] = ACTIONS(2272),
    [anon_sym_long] = ACTIONS(2272),
    [anon_sym_short] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_EQ] = ACTIONS(2272),
    [anon_sym_register] = ACTIONS(2272),
    [anon_sym_inline] = ACTIONS(2272),
    [anon_sym___inline] = ACTIONS(2272),
    [anon_sym___inline__] = ACTIONS(2272),
    [anon_sym___forceinline] = ACTIONS(2272),
    [anon_sym_thread_local] = ACTIONS(2272),
    [anon_sym___thread] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_constexpr] = ACTIONS(2272),
    [anon_sym_volatile] = ACTIONS(2272),
    [anon_sym_restrict] = ACTIONS(2272),
    [anon_sym___restrict__] = ACTIONS(2272),
    [anon_sym__Atomic] = ACTIONS(2272),
    [anon_sym__Noreturn] = ACTIONS(2272),
    [anon_sym_noreturn] = ACTIONS(2272),
    [anon_sym__Nonnull] = ACTIONS(2272),
    [anon_sym_mutable] = ACTIONS(2272),
    [anon_sym_constinit] = ACTIONS(2272),
    [anon_sym_consteval] = ACTIONS(2272),
    [anon_sym_alignas] = ACTIONS(2272),
    [anon_sym__Alignas] = ACTIONS(2272),
    [sym_primitive_type] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_struct] = ACTIONS(2272),
    [anon_sym_union] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_case] = ACTIONS(2272),
    [anon_sym_default] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_goto] = ACTIONS(2272),
    [anon_sym___try] = ACTIONS(2272),
    [anon_sym___leave] = ACTIONS(2272),
    [anon_sym_QMARK] = ACTIONS(2274),
    [anon_sym_STAR_EQ] = ACTIONS(2274),
    [anon_sym_SLASH_EQ] = ACTIONS(2274),
    [anon_sym_PERCENT_EQ] = ACTIONS(2274),
    [anon_sym_PLUS_EQ] = ACTIONS(2274),
    [anon_sym_DASH_EQ] = ACTIONS(2274),
    [anon_sym_LT_LT_EQ] = ACTIONS(2274),
    [anon_sym_GT_GT_EQ] = ACTIONS(2274),
    [anon_sym_AMP_EQ] = ACTIONS(2274),
    [anon_sym_CARET_EQ] = ACTIONS(2274),
    [anon_sym_PIPE_EQ] = ACTIONS(2274),
    [anon_sym_and_eq] = ACTIONS(2272),
    [anon_sym_or_eq] = ACTIONS(2272),
    [anon_sym_xor_eq] = ACTIONS(2272),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_compl] = ACTIONS(2272),
    [anon_sym_LT_EQ_GT] = ACTIONS(2274),
    [anon_sym_or] = ACTIONS(2272),
    [anon_sym_and] = ACTIONS(2272),
    [anon_sym_bitor] = ACTIONS(2272),
    [anon_sym_xor] = ACTIONS(2272),
    [anon_sym_bitand] = ACTIONS(2272),
    [anon_sym_not_eq] = ACTIONS(2272),
    [anon_sym_is] = ACTIONS(2272),
    [anon_sym_as] = ACTIONS(2272),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_sizeof] = ACTIONS(2272),
    [anon_sym___alignof__] = ACTIONS(2272),
    [anon_sym___alignof] = ACTIONS(2272),
    [anon_sym__alignof] = ACTIONS(2272),
    [anon_sym_alignof] = ACTIONS(2272),
    [anon_sym__Alignof] = ACTIONS(2272),
    [anon_sym_offsetof] = ACTIONS(2272),
    [anon_sym__Generic] = ACTIONS(2272),
    [anon_sym_asm] = ACTIONS(2272),
    [anon_sym___asm__] = ACTIONS(2272),
    [anon_sym___asm] = ACTIONS(2272),
    [anon_sym_DOT] = ACTIONS(2272),
    [anon_sym_DOT_STAR] = ACTIONS(2274),
    [anon_sym_DASH_GT] = ACTIONS(2274),
    [sym_number_literal] = ACTIONS(2274),
    [anon_sym_L_SQUOTE] = ACTIONS(2274),
    [anon_sym_u_SQUOTE] = ACTIONS(2274),
    [anon_sym_U_SQUOTE] = ACTIONS(2274),
    [anon_sym_u8_SQUOTE] = ACTIONS(2274),
    [anon_sym_SQUOTE] = ACTIONS(2274),
    [anon_sym_L_DQUOTE] = ACTIONS(2274),
    [anon_sym_u_DQUOTE] = ACTIONS(2274),
    [anon_sym_U_DQUOTE] = ACTIONS(2274),
    [anon_sym_u8_DQUOTE] = ACTIONS(2274),
    [anon_sym_DQUOTE] = ACTIONS(2274),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [anon_sym_NULL] = ACTIONS(2272),
    [anon_sym_nullptr] = ACTIONS(2272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_This] = ACTIONS(2272),
    [anon_sym_decltype] = ACTIONS(2272),
    [anon_sym_explicit] = ACTIONS(2272),
    [anon_sym_typename] = ACTIONS(2272),
    [anon_sym_template] = ACTIONS(2272),
    [anon_sym_operator] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_namespace] = ACTIONS(2272),
    [anon_sym_static_assert] = ACTIONS(2272),
    [anon_sym_concept] = ACTIONS(2272),
    [anon_sym_co_return] = ACTIONS(2272),
    [anon_sym_co_yield] = ACTIONS(2272),
    [anon_sym_R_DQUOTE] = ACTIONS(2274),
    [anon_sym_LR_DQUOTE] = ACTIONS(2274),
    [anon_sym_uR_DQUOTE] = ACTIONS(2274),
    [anon_sym_UR_DQUOTE] = ACTIONS(2274),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2274),
    [anon_sym_co_await] = ACTIONS(2272),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_requires] = ACTIONS(2272),
    [sym_this] = ACTIONS(2272),
    [anon_sym_discard] = ACTIONS(2272),
    [anon_sym_precise] = ACTIONS(2272),
    [anon_sym_shared] = ACTIONS(2272),
    [anon_sym_groupshared] = ACTIONS(2272),
    [anon_sym_uniform] = ACTIONS(2272),
    [anon_sym_row_major] = ACTIONS(2272),
    [anon_sym_column_major] = ACTIONS(2272),
    [anon_sym_globallycoherent] = ACTIONS(2272),
    [anon_sym_centroid] = ACTIONS(2272),
    [anon_sym_noperspective] = ACTIONS(2272),
    [anon_sym_nointerpolation] = ACTIONS(2272),
    [anon_sym_sample] = ACTIONS(2272),
    [anon_sym_linear] = ACTIONS(2272),
    [anon_sym_snorm] = ACTIONS(2272),
    [anon_sym_unorm] = ACTIONS(2272),
    [anon_sym_point] = ACTIONS(2272),
    [anon_sym_line] = ACTIONS(2272),
    [anon_sym_triangleadj] = ACTIONS(2272),
    [anon_sym_lineadj] = ACTIONS(2272),
    [anon_sym_triangle] = ACTIONS(2272),
    [anon_sym_cbuffer] = ACTIONS(2272),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_extension] = ACTIONS(2272),
  },
  [122] = {
    [sym_identifier] = ACTIONS(2276),
    [aux_sym_preproc_include_token1] = ACTIONS(2276),
    [aux_sym_preproc_def_token1] = ACTIONS(2276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2278),
    [anon_sym_COMMA] = ACTIONS(2278),
    [aux_sym_preproc_if_token1] = ACTIONS(2276),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2276),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2276),
    [sym_preproc_directive] = ACTIONS(2276),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_PLUS] = ACTIONS(2276),
    [anon_sym_STAR] = ACTIONS(2276),
    [anon_sym_SLASH] = ACTIONS(2276),
    [anon_sym_PERCENT] = ACTIONS(2276),
    [anon_sym_PIPE_PIPE] = ACTIONS(2278),
    [anon_sym_AMP_AMP] = ACTIONS(2278),
    [anon_sym_PIPE] = ACTIONS(2276),
    [anon_sym_CARET] = ACTIONS(2276),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_EQ_EQ] = ACTIONS(2278),
    [anon_sym_BANG_EQ] = ACTIONS(2278),
    [anon_sym_GT] = ACTIONS(2276),
    [anon_sym_GT_EQ] = ACTIONS(2278),
    [anon_sym_LT_EQ] = ACTIONS(2276),
    [anon_sym_LT] = ACTIONS(2276),
    [anon_sym_LT_LT] = ACTIONS(2276),
    [anon_sym_GT_GT] = ACTIONS(2276),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym___extension__] = ACTIONS(2276),
    [anon_sym_typedef] = ACTIONS(2276),
    [anon_sym_in] = ACTIONS(2276),
    [anon_sym_out] = ACTIONS(2276),
    [anon_sym_inout] = ACTIONS(2276),
    [anon_sym_virtual] = ACTIONS(2276),
    [anon_sym_extern] = ACTIONS(2276),
    [anon_sym___attribute__] = ACTIONS(2276),
    [anon_sym___attribute] = ACTIONS(2276),
    [anon_sym_using] = ACTIONS(2276),
    [anon_sym_COLON_COLON] = ACTIONS(2278),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2278),
    [anon_sym___declspec] = ACTIONS(2276),
    [anon_sym___based] = ACTIONS(2276),
    [anon_sym___cdecl] = ACTIONS(2276),
    [anon_sym___clrcall] = ACTIONS(2276),
    [anon_sym___stdcall] = ACTIONS(2276),
    [anon_sym___fastcall] = ACTIONS(2276),
    [anon_sym___thiscall] = ACTIONS(2276),
    [anon_sym___vectorcall] = ACTIONS(2276),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_signed] = ACTIONS(2276),
    [anon_sym_unsigned] = ACTIONS(2276),
    [anon_sym_long] = ACTIONS(2276),
    [anon_sym_short] = ACTIONS(2276),
    [anon_sym_LBRACK] = ACTIONS(2276),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_EQ] = ACTIONS(2276),
    [anon_sym_register] = ACTIONS(2276),
    [anon_sym_inline] = ACTIONS(2276),
    [anon_sym___inline] = ACTIONS(2276),
    [anon_sym___inline__] = ACTIONS(2276),
    [anon_sym___forceinline] = ACTIONS(2276),
    [anon_sym_thread_local] = ACTIONS(2276),
    [anon_sym___thread] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_constexpr] = ACTIONS(2276),
    [anon_sym_volatile] = ACTIONS(2276),
    [anon_sym_restrict] = ACTIONS(2276),
    [anon_sym___restrict__] = ACTIONS(2276),
    [anon_sym__Atomic] = ACTIONS(2276),
    [anon_sym__Noreturn] = ACTIONS(2276),
    [anon_sym_noreturn] = ACTIONS(2276),
    [anon_sym__Nonnull] = ACTIONS(2276),
    [anon_sym_mutable] = ACTIONS(2276),
    [anon_sym_constinit] = ACTIONS(2276),
    [anon_sym_consteval] = ACTIONS(2276),
    [anon_sym_alignas] = ACTIONS(2276),
    [anon_sym__Alignas] = ACTIONS(2276),
    [sym_primitive_type] = ACTIONS(2276),
    [anon_sym_enum] = ACTIONS(2276),
    [anon_sym_class] = ACTIONS(2276),
    [anon_sym_struct] = ACTIONS(2276),
    [anon_sym_union] = ACTIONS(2276),
    [anon_sym_if] = ACTIONS(2276),
    [anon_sym_switch] = ACTIONS(2276),
    [anon_sym_case] = ACTIONS(2276),
    [anon_sym_default] = ACTIONS(2276),
    [anon_sym_while] = ACTIONS(2276),
    [anon_sym_do] = ACTIONS(2276),
    [anon_sym_for] = ACTIONS(2276),
    [anon_sym_return] = ACTIONS(2276),
    [anon_sym_break] = ACTIONS(2276),
    [anon_sym_continue] = ACTIONS(2276),
    [anon_sym_goto] = ACTIONS(2276),
    [anon_sym___try] = ACTIONS(2276),
    [anon_sym___leave] = ACTIONS(2276),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_STAR_EQ] = ACTIONS(2278),
    [anon_sym_SLASH_EQ] = ACTIONS(2278),
    [anon_sym_PERCENT_EQ] = ACTIONS(2278),
    [anon_sym_PLUS_EQ] = ACTIONS(2278),
    [anon_sym_DASH_EQ] = ACTIONS(2278),
    [anon_sym_LT_LT_EQ] = ACTIONS(2278),
    [anon_sym_GT_GT_EQ] = ACTIONS(2278),
    [anon_sym_AMP_EQ] = ACTIONS(2278),
    [anon_sym_CARET_EQ] = ACTIONS(2278),
    [anon_sym_PIPE_EQ] = ACTIONS(2278),
    [anon_sym_and_eq] = ACTIONS(2276),
    [anon_sym_or_eq] = ACTIONS(2276),
    [anon_sym_xor_eq] = ACTIONS(2276),
    [anon_sym_not] = ACTIONS(2276),
    [anon_sym_compl] = ACTIONS(2276),
    [anon_sym_LT_EQ_GT] = ACTIONS(2278),
    [anon_sym_or] = ACTIONS(2276),
    [anon_sym_and] = ACTIONS(2276),
    [anon_sym_bitor] = ACTIONS(2276),
    [anon_sym_xor] = ACTIONS(2276),
    [anon_sym_bitand] = ACTIONS(2276),
    [anon_sym_not_eq] = ACTIONS(2276),
    [anon_sym_is] = ACTIONS(2276),
    [anon_sym_as] = ACTIONS(2276),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_sizeof] = ACTIONS(2276),
    [anon_sym___alignof__] = ACTIONS(2276),
    [anon_sym___alignof] = ACTIONS(2276),
    [anon_sym__alignof] = ACTIONS(2276),
    [anon_sym_alignof] = ACTIONS(2276),
    [anon_sym__Alignof] = ACTIONS(2276),
    [anon_sym_offsetof] = ACTIONS(2276),
    [anon_sym__Generic] = ACTIONS(2276),
    [anon_sym_asm] = ACTIONS(2276),
    [anon_sym___asm__] = ACTIONS(2276),
    [anon_sym___asm] = ACTIONS(2276),
    [anon_sym_DOT] = ACTIONS(2276),
    [anon_sym_DOT_STAR] = ACTIONS(2278),
    [anon_sym_DASH_GT] = ACTIONS(2278),
    [sym_number_literal] = ACTIONS(2278),
    [anon_sym_L_SQUOTE] = ACTIONS(2278),
    [anon_sym_u_SQUOTE] = ACTIONS(2278),
    [anon_sym_U_SQUOTE] = ACTIONS(2278),
    [anon_sym_u8_SQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_L_DQUOTE] = ACTIONS(2278),
    [anon_sym_u_DQUOTE] = ACTIONS(2278),
    [anon_sym_U_DQUOTE] = ACTIONS(2278),
    [anon_sym_u8_DQUOTE] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [sym_true] = ACTIONS(2276),
    [sym_false] = ACTIONS(2276),
    [anon_sym_NULL] = ACTIONS(2276),
    [anon_sym_nullptr] = ACTIONS(2276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_This] = ACTIONS(2276),
    [anon_sym_decltype] = ACTIONS(2276),
    [anon_sym_explicit] = ACTIONS(2276),
    [anon_sym_typename] = ACTIONS(2276),
    [anon_sym_template] = ACTIONS(2276),
    [anon_sym_operator] = ACTIONS(2276),
    [anon_sym_try] = ACTIONS(2276),
    [anon_sym_delete] = ACTIONS(2276),
    [anon_sym_throw] = ACTIONS(2276),
    [anon_sym_namespace] = ACTIONS(2276),
    [anon_sym_static_assert] = ACTIONS(2276),
    [anon_sym_concept] = ACTIONS(2276),
    [anon_sym_co_return] = ACTIONS(2276),
    [anon_sym_co_yield] = ACTIONS(2276),
    [anon_sym_R_DQUOTE] = ACTIONS(2278),
    [anon_sym_LR_DQUOTE] = ACTIONS(2278),
    [anon_sym_uR_DQUOTE] = ACTIONS(2278),
    [anon_sym_UR_DQUOTE] = ACTIONS(2278),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2278),
    [anon_sym_co_await] = ACTIONS(2276),
    [anon_sym_new] = ACTIONS(2276),
    [anon_sym_requires] = ACTIONS(2276),
    [sym_this] = ACTIONS(2276),
    [anon_sym_discard] = ACTIONS(2276),
    [anon_sym_precise] = ACTIONS(2276),
    [anon_sym_shared] = ACTIONS(2276),
    [anon_sym_groupshared] = ACTIONS(2276),
    [anon_sym_uniform] = ACTIONS(2276),
    [anon_sym_row_major] = ACTIONS(2276),
    [anon_sym_column_major] = ACTIONS(2276),
    [anon_sym_globallycoherent] = ACTIONS(2276),
    [anon_sym_centroid] = ACTIONS(2276),
    [anon_sym_noperspective] = ACTIONS(2276),
    [anon_sym_nointerpolation] = ACTIONS(2276),
    [anon_sym_sample] = ACTIONS(2276),
    [anon_sym_linear] = ACTIONS(2276),
    [anon_sym_snorm] = ACTIONS(2276),
    [anon_sym_unorm] = ACTIONS(2276),
    [anon_sym_point] = ACTIONS(2276),
    [anon_sym_line] = ACTIONS(2276),
    [anon_sym_triangleadj] = ACTIONS(2276),
    [anon_sym_lineadj] = ACTIONS(2276),
    [anon_sym_triangle] = ACTIONS(2276),
    [anon_sym_cbuffer] = ACTIONS(2276),
    [anon_sym_interface] = ACTIONS(2276),
    [anon_sym_extension] = ACTIONS(2276),
  },
  [123] = {
    [sym_identifier] = ACTIONS(2280),
    [aux_sym_preproc_include_token1] = ACTIONS(2280),
    [aux_sym_preproc_def_token1] = ACTIONS(2280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_COMMA] = ACTIONS(2282),
    [aux_sym_preproc_if_token1] = ACTIONS(2280),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2280),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2280),
    [sym_preproc_directive] = ACTIONS(2280),
    [anon_sym_LPAREN2] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2282),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2280),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_PERCENT] = ACTIONS(2280),
    [anon_sym_PIPE_PIPE] = ACTIONS(2282),
    [anon_sym_AMP_AMP] = ACTIONS(2282),
    [anon_sym_PIPE] = ACTIONS(2280),
    [anon_sym_CARET] = ACTIONS(2280),
    [anon_sym_AMP] = ACTIONS(2280),
    [anon_sym_EQ_EQ] = ACTIONS(2282),
    [anon_sym_BANG_EQ] = ACTIONS(2282),
    [anon_sym_GT] = ACTIONS(2280),
    [anon_sym_GT_EQ] = ACTIONS(2282),
    [anon_sym_LT_EQ] = ACTIONS(2280),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_LT_LT] = ACTIONS(2280),
    [anon_sym_GT_GT] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(2280),
    [anon_sym_typedef] = ACTIONS(2280),
    [anon_sym_in] = ACTIONS(2280),
    [anon_sym_out] = ACTIONS(2280),
    [anon_sym_inout] = ACTIONS(2280),
    [anon_sym_virtual] = ACTIONS(2280),
    [anon_sym_extern] = ACTIONS(2280),
    [anon_sym___attribute__] = ACTIONS(2280),
    [anon_sym___attribute] = ACTIONS(2280),
    [anon_sym_using] = ACTIONS(2280),
    [anon_sym_COLON_COLON] = ACTIONS(2282),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2282),
    [anon_sym___declspec] = ACTIONS(2280),
    [anon_sym___based] = ACTIONS(2280),
    [anon_sym___cdecl] = ACTIONS(2280),
    [anon_sym___clrcall] = ACTIONS(2280),
    [anon_sym___stdcall] = ACTIONS(2280),
    [anon_sym___fastcall] = ACTIONS(2280),
    [anon_sym___thiscall] = ACTIONS(2280),
    [anon_sym___vectorcall] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_RBRACE] = ACTIONS(2282),
    [anon_sym_signed] = ACTIONS(2280),
    [anon_sym_unsigned] = ACTIONS(2280),
    [anon_sym_long] = ACTIONS(2280),
    [anon_sym_short] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_EQ] = ACTIONS(2280),
    [anon_sym_register] = ACTIONS(2280),
    [anon_sym_inline] = ACTIONS(2280),
    [anon_sym___inline] = ACTIONS(2280),
    [anon_sym___inline__] = ACTIONS(2280),
    [anon_sym___forceinline] = ACTIONS(2280),
    [anon_sym_thread_local] = ACTIONS(2280),
    [anon_sym___thread] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_constexpr] = ACTIONS(2280),
    [anon_sym_volatile] = ACTIONS(2280),
    [anon_sym_restrict] = ACTIONS(2280),
    [anon_sym___restrict__] = ACTIONS(2280),
    [anon_sym__Atomic] = ACTIONS(2280),
    [anon_sym__Noreturn] = ACTIONS(2280),
    [anon_sym_noreturn] = ACTIONS(2280),
    [anon_sym__Nonnull] = ACTIONS(2280),
    [anon_sym_mutable] = ACTIONS(2280),
    [anon_sym_constinit] = ACTIONS(2280),
    [anon_sym_consteval] = ACTIONS(2280),
    [anon_sym_alignas] = ACTIONS(2280),
    [anon_sym__Alignas] = ACTIONS(2280),
    [sym_primitive_type] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_struct] = ACTIONS(2280),
    [anon_sym_union] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_goto] = ACTIONS(2280),
    [anon_sym___try] = ACTIONS(2280),
    [anon_sym___leave] = ACTIONS(2280),
    [anon_sym_QMARK] = ACTIONS(2282),
    [anon_sym_STAR_EQ] = ACTIONS(2282),
    [anon_sym_SLASH_EQ] = ACTIONS(2282),
    [anon_sym_PERCENT_EQ] = ACTIONS(2282),
    [anon_sym_PLUS_EQ] = ACTIONS(2282),
    [anon_sym_DASH_EQ] = ACTIONS(2282),
    [anon_sym_LT_LT_EQ] = ACTIONS(2282),
    [anon_sym_GT_GT_EQ] = ACTIONS(2282),
    [anon_sym_AMP_EQ] = ACTIONS(2282),
    [anon_sym_CARET_EQ] = ACTIONS(2282),
    [anon_sym_PIPE_EQ] = ACTIONS(2282),
    [anon_sym_and_eq] = ACTIONS(2280),
    [anon_sym_or_eq] = ACTIONS(2280),
    [anon_sym_xor_eq] = ACTIONS(2280),
    [anon_sym_not] = ACTIONS(2280),
    [anon_sym_compl] = ACTIONS(2280),
    [anon_sym_LT_EQ_GT] = ACTIONS(2282),
    [anon_sym_or] = ACTIONS(2280),
    [anon_sym_and] = ACTIONS(2280),
    [anon_sym_bitor] = ACTIONS(2280),
    [anon_sym_xor] = ACTIONS(2280),
    [anon_sym_bitand] = ACTIONS(2280),
    [anon_sym_not_eq] = ACTIONS(2280),
    [anon_sym_is] = ACTIONS(2280),
    [anon_sym_as] = ACTIONS(2280),
    [anon_sym_DASH_DASH] = ACTIONS(2282),
    [anon_sym_PLUS_PLUS] = ACTIONS(2282),
    [anon_sym_sizeof] = ACTIONS(2280),
    [anon_sym___alignof__] = ACTIONS(2280),
    [anon_sym___alignof] = ACTIONS(2280),
    [anon_sym__alignof] = ACTIONS(2280),
    [anon_sym_alignof] = ACTIONS(2280),
    [anon_sym__Alignof] = ACTIONS(2280),
    [anon_sym_offsetof] = ACTIONS(2280),
    [anon_sym__Generic] = ACTIONS(2280),
    [anon_sym_asm] = ACTIONS(2280),
    [anon_sym___asm__] = ACTIONS(2280),
    [anon_sym___asm] = ACTIONS(2280),
    [anon_sym_DOT] = ACTIONS(2280),
    [anon_sym_DOT_STAR] = ACTIONS(2282),
    [anon_sym_DASH_GT] = ACTIONS(2282),
    [sym_number_literal] = ACTIONS(2282),
    [anon_sym_L_SQUOTE] = ACTIONS(2282),
    [anon_sym_u_SQUOTE] = ACTIONS(2282),
    [anon_sym_U_SQUOTE] = ACTIONS(2282),
    [anon_sym_u8_SQUOTE] = ACTIONS(2282),
    [anon_sym_SQUOTE] = ACTIONS(2282),
    [anon_sym_L_DQUOTE] = ACTIONS(2282),
    [anon_sym_u_DQUOTE] = ACTIONS(2282),
    [anon_sym_U_DQUOTE] = ACTIONS(2282),
    [anon_sym_u8_DQUOTE] = ACTIONS(2282),
    [anon_sym_DQUOTE] = ACTIONS(2282),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [anon_sym_NULL] = ACTIONS(2280),
    [anon_sym_nullptr] = ACTIONS(2280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_This] = ACTIONS(2280),
    [anon_sym_decltype] = ACTIONS(2280),
    [anon_sym_explicit] = ACTIONS(2280),
    [anon_sym_typename] = ACTIONS(2280),
    [anon_sym_template] = ACTIONS(2280),
    [anon_sym_operator] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_static_assert] = ACTIONS(2280),
    [anon_sym_concept] = ACTIONS(2280),
    [anon_sym_co_return] = ACTIONS(2280),
    [anon_sym_co_yield] = ACTIONS(2280),
    [anon_sym_R_DQUOTE] = ACTIONS(2282),
    [anon_sym_LR_DQUOTE] = ACTIONS(2282),
    [anon_sym_uR_DQUOTE] = ACTIONS(2282),
    [anon_sym_UR_DQUOTE] = ACTIONS(2282),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2282),
    [anon_sym_co_await] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_requires] = ACTIONS(2280),
    [sym_this] = ACTIONS(2280),
    [anon_sym_discard] = ACTIONS(2280),
    [anon_sym_precise] = ACTIONS(2280),
    [anon_sym_shared] = ACTIONS(2280),
    [anon_sym_groupshared] = ACTIONS(2280),
    [anon_sym_uniform] = ACTIONS(2280),
    [anon_sym_row_major] = ACTIONS(2280),
    [anon_sym_column_major] = ACTIONS(2280),
    [anon_sym_globallycoherent] = ACTIONS(2280),
    [anon_sym_centroid] = ACTIONS(2280),
    [anon_sym_noperspective] = ACTIONS(2280),
    [anon_sym_nointerpolation] = ACTIONS(2280),
    [anon_sym_sample] = ACTIONS(2280),
    [anon_sym_linear] = ACTIONS(2280),
    [anon_sym_snorm] = ACTIONS(2280),
    [anon_sym_unorm] = ACTIONS(2280),
    [anon_sym_point] = ACTIONS(2280),
    [anon_sym_line] = ACTIONS(2280),
    [anon_sym_triangleadj] = ACTIONS(2280),
    [anon_sym_lineadj] = ACTIONS(2280),
    [anon_sym_triangle] = ACTIONS(2280),
    [anon_sym_cbuffer] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_extension] = ACTIONS(2280),
  },
  [124] = {
    [sym_identifier] = ACTIONS(2284),
    [aux_sym_preproc_include_token1] = ACTIONS(2284),
    [aux_sym_preproc_def_token1] = ACTIONS(2284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2286),
    [anon_sym_COMMA] = ACTIONS(2286),
    [aux_sym_preproc_if_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2284),
    [sym_preproc_directive] = ACTIONS(2284),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2284),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2284),
    [anon_sym_SLASH] = ACTIONS(2284),
    [anon_sym_PERCENT] = ACTIONS(2284),
    [anon_sym_PIPE_PIPE] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2284),
    [anon_sym_CARET] = ACTIONS(2284),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_EQ_EQ] = ACTIONS(2286),
    [anon_sym_BANG_EQ] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2284),
    [anon_sym_GT_EQ] = ACTIONS(2286),
    [anon_sym_LT_EQ] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2284),
    [anon_sym_LT_LT] = ACTIONS(2284),
    [anon_sym_GT_GT] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_typedef] = ACTIONS(2284),
    [anon_sym_in] = ACTIONS(2284),
    [anon_sym_out] = ACTIONS(2284),
    [anon_sym_inout] = ACTIONS(2284),
    [anon_sym_virtual] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_using] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym___cdecl] = ACTIONS(2284),
    [anon_sym___clrcall] = ACTIONS(2284),
    [anon_sym___stdcall] = ACTIONS(2284),
    [anon_sym___fastcall] = ACTIONS(2284),
    [anon_sym___thiscall] = ACTIONS(2284),
    [anon_sym___vectorcall] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_signed] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_EQ] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_switch] = ACTIONS(2284),
    [anon_sym_case] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_goto] = ACTIONS(2284),
    [anon_sym___try] = ACTIONS(2284),
    [anon_sym___leave] = ACTIONS(2284),
    [anon_sym_QMARK] = ACTIONS(2286),
    [anon_sym_STAR_EQ] = ACTIONS(2286),
    [anon_sym_SLASH_EQ] = ACTIONS(2286),
    [anon_sym_PERCENT_EQ] = ACTIONS(2286),
    [anon_sym_PLUS_EQ] = ACTIONS(2286),
    [anon_sym_DASH_EQ] = ACTIONS(2286),
    [anon_sym_LT_LT_EQ] = ACTIONS(2286),
    [anon_sym_GT_GT_EQ] = ACTIONS(2286),
    [anon_sym_AMP_EQ] = ACTIONS(2286),
    [anon_sym_CARET_EQ] = ACTIONS(2286),
    [anon_sym_PIPE_EQ] = ACTIONS(2286),
    [anon_sym_and_eq] = ACTIONS(2284),
    [anon_sym_or_eq] = ACTIONS(2284),
    [anon_sym_xor_eq] = ACTIONS(2284),
    [anon_sym_not] = ACTIONS(2284),
    [anon_sym_compl] = ACTIONS(2284),
    [anon_sym_LT_EQ_GT] = ACTIONS(2286),
    [anon_sym_or] = ACTIONS(2284),
    [anon_sym_and] = ACTIONS(2284),
    [anon_sym_bitor] = ACTIONS(2284),
    [anon_sym_xor] = ACTIONS(2284),
    [anon_sym_bitand] = ACTIONS(2284),
    [anon_sym_not_eq] = ACTIONS(2284),
    [anon_sym_is] = ACTIONS(2284),
    [anon_sym_as] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_sizeof] = ACTIONS(2284),
    [anon_sym___alignof__] = ACTIONS(2284),
    [anon_sym___alignof] = ACTIONS(2284),
    [anon_sym__alignof] = ACTIONS(2284),
    [anon_sym_alignof] = ACTIONS(2284),
    [anon_sym__Alignof] = ACTIONS(2284),
    [anon_sym_offsetof] = ACTIONS(2284),
    [anon_sym__Generic] = ACTIONS(2284),
    [anon_sym_asm] = ACTIONS(2284),
    [anon_sym___asm__] = ACTIONS(2284),
    [anon_sym___asm] = ACTIONS(2284),
    [anon_sym_DOT] = ACTIONS(2284),
    [anon_sym_DOT_STAR] = ACTIONS(2286),
    [anon_sym_DASH_GT] = ACTIONS(2286),
    [sym_number_literal] = ACTIONS(2286),
    [anon_sym_L_SQUOTE] = ACTIONS(2286),
    [anon_sym_u_SQUOTE] = ACTIONS(2286),
    [anon_sym_U_SQUOTE] = ACTIONS(2286),
    [anon_sym_u8_SQUOTE] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_L_DQUOTE] = ACTIONS(2286),
    [anon_sym_u_DQUOTE] = ACTIONS(2286),
    [anon_sym_U_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8_DQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [sym_true] = ACTIONS(2284),
    [sym_false] = ACTIONS(2284),
    [anon_sym_NULL] = ACTIONS(2284),
    [anon_sym_nullptr] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_This] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_typename] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_delete] = ACTIONS(2284),
    [anon_sym_throw] = ACTIONS(2284),
    [anon_sym_namespace] = ACTIONS(2284),
    [anon_sym_static_assert] = ACTIONS(2284),
    [anon_sym_concept] = ACTIONS(2284),
    [anon_sym_co_return] = ACTIONS(2284),
    [anon_sym_co_yield] = ACTIONS(2284),
    [anon_sym_R_DQUOTE] = ACTIONS(2286),
    [anon_sym_LR_DQUOTE] = ACTIONS(2286),
    [anon_sym_uR_DQUOTE] = ACTIONS(2286),
    [anon_sym_UR_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2286),
    [anon_sym_co_await] = ACTIONS(2284),
    [anon_sym_new] = ACTIONS(2284),
    [anon_sym_requires] = ACTIONS(2284),
    [sym_this] = ACTIONS(2284),
    [anon_sym_discard] = ACTIONS(2284),
    [anon_sym_precise] = ACTIONS(2284),
    [anon_sym_shared] = ACTIONS(2284),
    [anon_sym_groupshared] = ACTIONS(2284),
    [anon_sym_uniform] = ACTIONS(2284),
    [anon_sym_row_major] = ACTIONS(2284),
    [anon_sym_column_major] = ACTIONS(2284),
    [anon_sym_globallycoherent] = ACTIONS(2284),
    [anon_sym_centroid] = ACTIONS(2284),
    [anon_sym_noperspective] = ACTIONS(2284),
    [anon_sym_nointerpolation] = ACTIONS(2284),
    [anon_sym_sample] = ACTIONS(2284),
    [anon_sym_linear] = ACTIONS(2284),
    [anon_sym_snorm] = ACTIONS(2284),
    [anon_sym_unorm] = ACTIONS(2284),
    [anon_sym_point] = ACTIONS(2284),
    [anon_sym_line] = ACTIONS(2284),
    [anon_sym_triangleadj] = ACTIONS(2284),
    [anon_sym_lineadj] = ACTIONS(2284),
    [anon_sym_triangle] = ACTIONS(2284),
    [anon_sym_cbuffer] = ACTIONS(2284),
    [anon_sym_interface] = ACTIONS(2284),
    [anon_sym_extension] = ACTIONS(2284),
  },
  [125] = {
    [sym_identifier] = ACTIONS(2288),
    [aux_sym_preproc_include_token1] = ACTIONS(2288),
    [aux_sym_preproc_def_token1] = ACTIONS(2288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2290),
    [anon_sym_COMMA] = ACTIONS(2290),
    [aux_sym_preproc_if_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_PERCENT] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_CARET] = ACTIONS(2288),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_EQ_EQ] = ACTIONS(2290),
    [anon_sym_BANG_EQ] = ACTIONS(2290),
    [anon_sym_GT] = ACTIONS(2288),
    [anon_sym_GT_EQ] = ACTIONS(2290),
    [anon_sym_LT_EQ] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(2288),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_out] = ACTIONS(2288),
    [anon_sym_inout] = ACTIONS(2288),
    [anon_sym_virtual] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym___cdecl] = ACTIONS(2288),
    [anon_sym___clrcall] = ACTIONS(2288),
    [anon_sym___stdcall] = ACTIONS(2288),
    [anon_sym___fastcall] = ACTIONS(2288),
    [anon_sym___thiscall] = ACTIONS(2288),
    [anon_sym___vectorcall] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_RBRACE] = ACTIONS(2290),
    [anon_sym_signed] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_EQ] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym___try] = ACTIONS(2288),
    [anon_sym___leave] = ACTIONS(2288),
    [anon_sym_QMARK] = ACTIONS(2290),
    [anon_sym_STAR_EQ] = ACTIONS(2290),
    [anon_sym_SLASH_EQ] = ACTIONS(2290),
    [anon_sym_PERCENT_EQ] = ACTIONS(2290),
    [anon_sym_PLUS_EQ] = ACTIONS(2290),
    [anon_sym_DASH_EQ] = ACTIONS(2290),
    [anon_sym_LT_LT_EQ] = ACTIONS(2290),
    [anon_sym_GT_GT_EQ] = ACTIONS(2290),
    [anon_sym_AMP_EQ] = ACTIONS(2290),
    [anon_sym_CARET_EQ] = ACTIONS(2290),
    [anon_sym_PIPE_EQ] = ACTIONS(2290),
    [anon_sym_and_eq] = ACTIONS(2288),
    [anon_sym_or_eq] = ACTIONS(2288),
    [anon_sym_xor_eq] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2288),
    [anon_sym_compl] = ACTIONS(2288),
    [anon_sym_LT_EQ_GT] = ACTIONS(2290),
    [anon_sym_or] = ACTIONS(2288),
    [anon_sym_and] = ACTIONS(2288),
    [anon_sym_bitor] = ACTIONS(2288),
    [anon_sym_xor] = ACTIONS(2288),
    [anon_sym_bitand] = ACTIONS(2288),
    [anon_sym_not_eq] = ACTIONS(2288),
    [anon_sym_is] = ACTIONS(2288),
    [anon_sym_as] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_sizeof] = ACTIONS(2288),
    [anon_sym___alignof__] = ACTIONS(2288),
    [anon_sym___alignof] = ACTIONS(2288),
    [anon_sym__alignof] = ACTIONS(2288),
    [anon_sym_alignof] = ACTIONS(2288),
    [anon_sym__Alignof] = ACTIONS(2288),
    [anon_sym_offsetof] = ACTIONS(2288),
    [anon_sym__Generic] = ACTIONS(2288),
    [anon_sym_asm] = ACTIONS(2288),
    [anon_sym___asm__] = ACTIONS(2288),
    [anon_sym___asm] = ACTIONS(2288),
    [anon_sym_DOT] = ACTIONS(2288),
    [anon_sym_DOT_STAR] = ACTIONS(2290),
    [anon_sym_DASH_GT] = ACTIONS(2290),
    [sym_number_literal] = ACTIONS(2290),
    [anon_sym_L_SQUOTE] = ACTIONS(2290),
    [anon_sym_u_SQUOTE] = ACTIONS(2290),
    [anon_sym_U_SQUOTE] = ACTIONS(2290),
    [anon_sym_u8_SQUOTE] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [anon_sym_L_DQUOTE] = ACTIONS(2290),
    [anon_sym_u_DQUOTE] = ACTIONS(2290),
    [anon_sym_U_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8_DQUOTE] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [anon_sym_NULL] = ACTIONS(2288),
    [anon_sym_nullptr] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_This] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_static_assert] = ACTIONS(2288),
    [anon_sym_concept] = ACTIONS(2288),
    [anon_sym_co_return] = ACTIONS(2288),
    [anon_sym_co_yield] = ACTIONS(2288),
    [anon_sym_R_DQUOTE] = ACTIONS(2290),
    [anon_sym_LR_DQUOTE] = ACTIONS(2290),
    [anon_sym_uR_DQUOTE] = ACTIONS(2290),
    [anon_sym_UR_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2290),
    [anon_sym_co_await] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_requires] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [anon_sym_discard] = ACTIONS(2288),
    [anon_sym_precise] = ACTIONS(2288),
    [anon_sym_shared] = ACTIONS(2288),
    [anon_sym_groupshared] = ACTIONS(2288),
    [anon_sym_uniform] = ACTIONS(2288),
    [anon_sym_row_major] = ACTIONS(2288),
    [anon_sym_column_major] = ACTIONS(2288),
    [anon_sym_globallycoherent] = ACTIONS(2288),
    [anon_sym_centroid] = ACTIONS(2288),
    [anon_sym_noperspective] = ACTIONS(2288),
    [anon_sym_nointerpolation] = ACTIONS(2288),
    [anon_sym_sample] = ACTIONS(2288),
    [anon_sym_linear] = ACTIONS(2288),
    [anon_sym_snorm] = ACTIONS(2288),
    [anon_sym_unorm] = ACTIONS(2288),
    [anon_sym_point] = ACTIONS(2288),
    [anon_sym_line] = ACTIONS(2288),
    [anon_sym_triangleadj] = ACTIONS(2288),
    [anon_sym_lineadj] = ACTIONS(2288),
    [anon_sym_triangle] = ACTIONS(2288),
    [anon_sym_cbuffer] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_extension] = ACTIONS(2288),
  },
  [126] = {
    [sym_identifier] = ACTIONS(2292),
    [aux_sym_preproc_include_token1] = ACTIONS(2292),
    [aux_sym_preproc_def_token1] = ACTIONS(2292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2294),
    [anon_sym_COMMA] = ACTIONS(2294),
    [aux_sym_preproc_if_token1] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2292),
    [sym_preproc_directive] = ACTIONS(2292),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_BANG] = ACTIONS(2292),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2292),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_PERCENT] = ACTIONS(2292),
    [anon_sym_PIPE_PIPE] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_PIPE] = ACTIONS(2292),
    [anon_sym_CARET] = ACTIONS(2292),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_EQ_EQ] = ACTIONS(2294),
    [anon_sym_BANG_EQ] = ACTIONS(2294),
    [anon_sym_GT] = ACTIONS(2292),
    [anon_sym_GT_EQ] = ACTIONS(2294),
    [anon_sym_LT_EQ] = ACTIONS(2292),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_LT_LT] = ACTIONS(2292),
    [anon_sym_GT_GT] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym_typedef] = ACTIONS(2292),
    [anon_sym_in] = ACTIONS(2292),
    [anon_sym_out] = ACTIONS(2292),
    [anon_sym_inout] = ACTIONS(2292),
    [anon_sym_virtual] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym___attribute] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2294),
    [anon_sym___declspec] = ACTIONS(2292),
    [anon_sym___based] = ACTIONS(2292),
    [anon_sym___cdecl] = ACTIONS(2292),
    [anon_sym___clrcall] = ACTIONS(2292),
    [anon_sym___stdcall] = ACTIONS(2292),
    [anon_sym___fastcall] = ACTIONS(2292),
    [anon_sym___thiscall] = ACTIONS(2292),
    [anon_sym___vectorcall] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_signed] = ACTIONS(2292),
    [anon_sym_unsigned] = ACTIONS(2292),
    [anon_sym_long] = ACTIONS(2292),
    [anon_sym_short] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_EQ] = ACTIONS(2292),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym___inline] = ACTIONS(2292),
    [anon_sym___inline__] = ACTIONS(2292),
    [anon_sym___forceinline] = ACTIONS(2292),
    [anon_sym_thread_local] = ACTIONS(2292),
    [anon_sym___thread] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym__Nonnull] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [sym_primitive_type] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_struct] = ACTIONS(2292),
    [anon_sym_union] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_case] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_goto] = ACTIONS(2292),
    [anon_sym___try] = ACTIONS(2292),
    [anon_sym___leave] = ACTIONS(2292),
    [anon_sym_QMARK] = ACTIONS(2294),
    [anon_sym_STAR_EQ] = ACTIONS(2294),
    [anon_sym_SLASH_EQ] = ACTIONS(2294),
    [anon_sym_PERCENT_EQ] = ACTIONS(2294),
    [anon_sym_PLUS_EQ] = ACTIONS(2294),
    [anon_sym_DASH_EQ] = ACTIONS(2294),
    [anon_sym_LT_LT_EQ] = ACTIONS(2294),
    [anon_sym_GT_GT_EQ] = ACTIONS(2294),
    [anon_sym_AMP_EQ] = ACTIONS(2294),
    [anon_sym_CARET_EQ] = ACTIONS(2294),
    [anon_sym_PIPE_EQ] = ACTIONS(2294),
    [anon_sym_and_eq] = ACTIONS(2292),
    [anon_sym_or_eq] = ACTIONS(2292),
    [anon_sym_xor_eq] = ACTIONS(2292),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_compl] = ACTIONS(2292),
    [anon_sym_LT_EQ_GT] = ACTIONS(2294),
    [anon_sym_or] = ACTIONS(2292),
    [anon_sym_and] = ACTIONS(2292),
    [anon_sym_bitor] = ACTIONS(2292),
    [anon_sym_xor] = ACTIONS(2292),
    [anon_sym_bitand] = ACTIONS(2292),
    [anon_sym_not_eq] = ACTIONS(2292),
    [anon_sym_is] = ACTIONS(2292),
    [anon_sym_as] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_sizeof] = ACTIONS(2292),
    [anon_sym___alignof__] = ACTIONS(2292),
    [anon_sym___alignof] = ACTIONS(2292),
    [anon_sym__alignof] = ACTIONS(2292),
    [anon_sym_alignof] = ACTIONS(2292),
    [anon_sym__Alignof] = ACTIONS(2292),
    [anon_sym_offsetof] = ACTIONS(2292),
    [anon_sym__Generic] = ACTIONS(2292),
    [anon_sym_asm] = ACTIONS(2292),
    [anon_sym___asm__] = ACTIONS(2292),
    [anon_sym___asm] = ACTIONS(2292),
    [anon_sym_DOT] = ACTIONS(2292),
    [anon_sym_DOT_STAR] = ACTIONS(2294),
    [anon_sym_DASH_GT] = ACTIONS(2294),
    [sym_number_literal] = ACTIONS(2294),
    [anon_sym_L_SQUOTE] = ACTIONS(2294),
    [anon_sym_u_SQUOTE] = ACTIONS(2294),
    [anon_sym_U_SQUOTE] = ACTIONS(2294),
    [anon_sym_u8_SQUOTE] = ACTIONS(2294),
    [anon_sym_SQUOTE] = ACTIONS(2294),
    [anon_sym_L_DQUOTE] = ACTIONS(2294),
    [anon_sym_u_DQUOTE] = ACTIONS(2294),
    [anon_sym_U_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8_DQUOTE] = ACTIONS(2294),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [anon_sym_NULL] = ACTIONS(2292),
    [anon_sym_nullptr] = ACTIONS(2292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_This] = ACTIONS(2292),
    [anon_sym_decltype] = ACTIONS(2292),
    [anon_sym_explicit] = ACTIONS(2292),
    [anon_sym_typename] = ACTIONS(2292),
    [anon_sym_template] = ACTIONS(2292),
    [anon_sym_operator] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_static_assert] = ACTIONS(2292),
    [anon_sym_concept] = ACTIONS(2292),
    [anon_sym_co_return] = ACTIONS(2292),
    [anon_sym_co_yield] = ACTIONS(2292),
    [anon_sym_R_DQUOTE] = ACTIONS(2294),
    [anon_sym_LR_DQUOTE] = ACTIONS(2294),
    [anon_sym_uR_DQUOTE] = ACTIONS(2294),
    [anon_sym_UR_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2294),
    [anon_sym_co_await] = ACTIONS(2292),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_requires] = ACTIONS(2292),
    [sym_this] = ACTIONS(2292),
    [anon_sym_discard] = ACTIONS(2292),
    [anon_sym_precise] = ACTIONS(2292),
    [anon_sym_shared] = ACTIONS(2292),
    [anon_sym_groupshared] = ACTIONS(2292),
    [anon_sym_uniform] = ACTIONS(2292),
    [anon_sym_row_major] = ACTIONS(2292),
    [anon_sym_column_major] = ACTIONS(2292),
    [anon_sym_globallycoherent] = ACTIONS(2292),
    [anon_sym_centroid] = ACTIONS(2292),
    [anon_sym_noperspective] = ACTIONS(2292),
    [anon_sym_nointerpolation] = ACTIONS(2292),
    [anon_sym_sample] = ACTIONS(2292),
    [anon_sym_linear] = ACTIONS(2292),
    [anon_sym_snorm] = ACTIONS(2292),
    [anon_sym_unorm] = ACTIONS(2292),
    [anon_sym_point] = ACTIONS(2292),
    [anon_sym_line] = ACTIONS(2292),
    [anon_sym_triangleadj] = ACTIONS(2292),
    [anon_sym_lineadj] = ACTIONS(2292),
    [anon_sym_triangle] = ACTIONS(2292),
    [anon_sym_cbuffer] = ACTIONS(2292),
    [anon_sym_interface] = ACTIONS(2292),
    [anon_sym_extension] = ACTIONS(2292),
  },
  [127] = {
    [sym_identifier] = ACTIONS(2296),
    [aux_sym_preproc_include_token1] = ACTIONS(2296),
    [aux_sym_preproc_def_token1] = ACTIONS(2296),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2298),
    [anon_sym_COMMA] = ACTIONS(2298),
    [aux_sym_preproc_if_token1] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2296),
    [sym_preproc_directive] = ACTIONS(2296),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2296),
    [anon_sym_SLASH] = ACTIONS(2296),
    [anon_sym_PERCENT] = ACTIONS(2296),
    [anon_sym_PIPE_PIPE] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_PIPE] = ACTIONS(2296),
    [anon_sym_CARET] = ACTIONS(2296),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_EQ_EQ] = ACTIONS(2298),
    [anon_sym_BANG_EQ] = ACTIONS(2298),
    [anon_sym_GT] = ACTIONS(2296),
    [anon_sym_GT_EQ] = ACTIONS(2298),
    [anon_sym_LT_EQ] = ACTIONS(2296),
    [anon_sym_LT] = ACTIONS(2296),
    [anon_sym_LT_LT] = ACTIONS(2296),
    [anon_sym_GT_GT] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2298),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym_typedef] = ACTIONS(2296),
    [anon_sym_in] = ACTIONS(2296),
    [anon_sym_out] = ACTIONS(2296),
    [anon_sym_inout] = ACTIONS(2296),
    [anon_sym_virtual] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym___attribute] = ACTIONS(2296),
    [anon_sym_using] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2298),
    [anon_sym___declspec] = ACTIONS(2296),
    [anon_sym___based] = ACTIONS(2296),
    [anon_sym___cdecl] = ACTIONS(2296),
    [anon_sym___clrcall] = ACTIONS(2296),
    [anon_sym___stdcall] = ACTIONS(2296),
    [anon_sym___fastcall] = ACTIONS(2296),
    [anon_sym___thiscall] = ACTIONS(2296),
    [anon_sym___vectorcall] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_RBRACE] = ACTIONS(2298),
    [anon_sym_signed] = ACTIONS(2296),
    [anon_sym_unsigned] = ACTIONS(2296),
    [anon_sym_long] = ACTIONS(2296),
    [anon_sym_short] = ACTIONS(2296),
    [anon_sym_LBRACK] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_EQ] = ACTIONS(2296),
    [anon_sym_register] = ACTIONS(2296),
    [anon_sym_inline] = ACTIONS(2296),
    [anon_sym___inline] = ACTIONS(2296),
    [anon_sym___inline__] = ACTIONS(2296),
    [anon_sym___forceinline] = ACTIONS(2296),
    [anon_sym_thread_local] = ACTIONS(2296),
    [anon_sym___thread] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym__Nonnull] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [sym_primitive_type] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2296),
    [anon_sym_class] = ACTIONS(2296),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_union] = ACTIONS(2296),
    [anon_sym_if] = ACTIONS(2296),
    [anon_sym_switch] = ACTIONS(2296),
    [anon_sym_case] = ACTIONS(2296),
    [anon_sym_default] = ACTIONS(2296),
    [anon_sym_while] = ACTIONS(2296),
    [anon_sym_do] = ACTIONS(2296),
    [anon_sym_for] = ACTIONS(2296),
    [anon_sym_return] = ACTIONS(2296),
    [anon_sym_break] = ACTIONS(2296),
    [anon_sym_continue] = ACTIONS(2296),
    [anon_sym_goto] = ACTIONS(2296),
    [anon_sym___try] = ACTIONS(2296),
    [anon_sym___leave] = ACTIONS(2296),
    [anon_sym_QMARK] = ACTIONS(2298),
    [anon_sym_STAR_EQ] = ACTIONS(2298),
    [anon_sym_SLASH_EQ] = ACTIONS(2298),
    [anon_sym_PERCENT_EQ] = ACTIONS(2298),
    [anon_sym_PLUS_EQ] = ACTIONS(2298),
    [anon_sym_DASH_EQ] = ACTIONS(2298),
    [anon_sym_LT_LT_EQ] = ACTIONS(2298),
    [anon_sym_GT_GT_EQ] = ACTIONS(2298),
    [anon_sym_AMP_EQ] = ACTIONS(2298),
    [anon_sym_CARET_EQ] = ACTIONS(2298),
    [anon_sym_PIPE_EQ] = ACTIONS(2298),
    [anon_sym_and_eq] = ACTIONS(2296),
    [anon_sym_or_eq] = ACTIONS(2296),
    [anon_sym_xor_eq] = ACTIONS(2296),
    [anon_sym_not] = ACTIONS(2296),
    [anon_sym_compl] = ACTIONS(2296),
    [anon_sym_LT_EQ_GT] = ACTIONS(2298),
    [anon_sym_or] = ACTIONS(2296),
    [anon_sym_and] = ACTIONS(2296),
    [anon_sym_bitor] = ACTIONS(2296),
    [anon_sym_xor] = ACTIONS(2296),
    [anon_sym_bitand] = ACTIONS(2296),
    [anon_sym_not_eq] = ACTIONS(2296),
    [anon_sym_is] = ACTIONS(2296),
    [anon_sym_as] = ACTIONS(2296),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_sizeof] = ACTIONS(2296),
    [anon_sym___alignof__] = ACTIONS(2296),
    [anon_sym___alignof] = ACTIONS(2296),
    [anon_sym__alignof] = ACTIONS(2296),
    [anon_sym_alignof] = ACTIONS(2296),
    [anon_sym__Alignof] = ACTIONS(2296),
    [anon_sym_offsetof] = ACTIONS(2296),
    [anon_sym__Generic] = ACTIONS(2296),
    [anon_sym_asm] = ACTIONS(2296),
    [anon_sym___asm__] = ACTIONS(2296),
    [anon_sym___asm] = ACTIONS(2296),
    [anon_sym_DOT] = ACTIONS(2296),
    [anon_sym_DOT_STAR] = ACTIONS(2298),
    [anon_sym_DASH_GT] = ACTIONS(2298),
    [sym_number_literal] = ACTIONS(2298),
    [anon_sym_L_SQUOTE] = ACTIONS(2298),
    [anon_sym_u_SQUOTE] = ACTIONS(2298),
    [anon_sym_U_SQUOTE] = ACTIONS(2298),
    [anon_sym_u8_SQUOTE] = ACTIONS(2298),
    [anon_sym_SQUOTE] = ACTIONS(2298),
    [anon_sym_L_DQUOTE] = ACTIONS(2298),
    [anon_sym_u_DQUOTE] = ACTIONS(2298),
    [anon_sym_U_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8_DQUOTE] = ACTIONS(2298),
    [anon_sym_DQUOTE] = ACTIONS(2298),
    [sym_true] = ACTIONS(2296),
    [sym_false] = ACTIONS(2296),
    [anon_sym_NULL] = ACTIONS(2296),
    [anon_sym_nullptr] = ACTIONS(2296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_This] = ACTIONS(2296),
    [anon_sym_decltype] = ACTIONS(2296),
    [anon_sym_explicit] = ACTIONS(2296),
    [anon_sym_typename] = ACTIONS(2296),
    [anon_sym_template] = ACTIONS(2296),
    [anon_sym_operator] = ACTIONS(2296),
    [anon_sym_try] = ACTIONS(2296),
    [anon_sym_delete] = ACTIONS(2296),
    [anon_sym_throw] = ACTIONS(2296),
    [anon_sym_namespace] = ACTIONS(2296),
    [anon_sym_static_assert] = ACTIONS(2296),
    [anon_sym_concept] = ACTIONS(2296),
    [anon_sym_co_return] = ACTIONS(2296),
    [anon_sym_co_yield] = ACTIONS(2296),
    [anon_sym_R_DQUOTE] = ACTIONS(2298),
    [anon_sym_LR_DQUOTE] = ACTIONS(2298),
    [anon_sym_uR_DQUOTE] = ACTIONS(2298),
    [anon_sym_UR_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2298),
    [anon_sym_co_await] = ACTIONS(2296),
    [anon_sym_new] = ACTIONS(2296),
    [anon_sym_requires] = ACTIONS(2296),
    [sym_this] = ACTIONS(2296),
    [anon_sym_discard] = ACTIONS(2296),
    [anon_sym_precise] = ACTIONS(2296),
    [anon_sym_shared] = ACTIONS(2296),
    [anon_sym_groupshared] = ACTIONS(2296),
    [anon_sym_uniform] = ACTIONS(2296),
    [anon_sym_row_major] = ACTIONS(2296),
    [anon_sym_column_major] = ACTIONS(2296),
    [anon_sym_globallycoherent] = ACTIONS(2296),
    [anon_sym_centroid] = ACTIONS(2296),
    [anon_sym_noperspective] = ACTIONS(2296),
    [anon_sym_nointerpolation] = ACTIONS(2296),
    [anon_sym_sample] = ACTIONS(2296),
    [anon_sym_linear] = ACTIONS(2296),
    [anon_sym_snorm] = ACTIONS(2296),
    [anon_sym_unorm] = ACTIONS(2296),
    [anon_sym_point] = ACTIONS(2296),
    [anon_sym_line] = ACTIONS(2296),
    [anon_sym_triangleadj] = ACTIONS(2296),
    [anon_sym_lineadj] = ACTIONS(2296),
    [anon_sym_triangle] = ACTIONS(2296),
    [anon_sym_cbuffer] = ACTIONS(2296),
    [anon_sym_interface] = ACTIONS(2296),
    [anon_sym_extension] = ACTIONS(2296),
  },
  [128] = {
    [sym_identifier] = ACTIONS(2300),
    [aux_sym_preproc_include_token1] = ACTIONS(2300),
    [aux_sym_preproc_def_token1] = ACTIONS(2300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2302),
    [anon_sym_COMMA] = ACTIONS(2302),
    [aux_sym_preproc_if_token1] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2300),
    [sym_preproc_directive] = ACTIONS(2300),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_BANG] = ACTIONS(2300),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_PIPE_PIPE] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_PIPE] = ACTIONS(2300),
    [anon_sym_CARET] = ACTIONS(2300),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_EQ_EQ] = ACTIONS(2302),
    [anon_sym_BANG_EQ] = ACTIONS(2302),
    [anon_sym_GT] = ACTIONS(2300),
    [anon_sym_GT_EQ] = ACTIONS(2302),
    [anon_sym_LT_EQ] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_LT_LT] = ACTIONS(2300),
    [anon_sym_GT_GT] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym_typedef] = ACTIONS(2300),
    [anon_sym_in] = ACTIONS(2300),
    [anon_sym_out] = ACTIONS(2300),
    [anon_sym_inout] = ACTIONS(2300),
    [anon_sym_virtual] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym___attribute] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2302),
    [anon_sym___declspec] = ACTIONS(2300),
    [anon_sym___based] = ACTIONS(2300),
    [anon_sym___cdecl] = ACTIONS(2300),
    [anon_sym___clrcall] = ACTIONS(2300),
    [anon_sym___stdcall] = ACTIONS(2300),
    [anon_sym___fastcall] = ACTIONS(2300),
    [anon_sym___thiscall] = ACTIONS(2300),
    [anon_sym___vectorcall] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_RBRACE] = ACTIONS(2302),
    [anon_sym_signed] = ACTIONS(2300),
    [anon_sym_unsigned] = ACTIONS(2300),
    [anon_sym_long] = ACTIONS(2300),
    [anon_sym_short] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_EQ] = ACTIONS(2300),
    [anon_sym_register] = ACTIONS(2300),
    [anon_sym_inline] = ACTIONS(2300),
    [anon_sym___inline] = ACTIONS(2300),
    [anon_sym___inline__] = ACTIONS(2300),
    [anon_sym___forceinline] = ACTIONS(2300),
    [anon_sym_thread_local] = ACTIONS(2300),
    [anon_sym___thread] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym__Nonnull] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [sym_primitive_type] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_struct] = ACTIONS(2300),
    [anon_sym_union] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_case] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_goto] = ACTIONS(2300),
    [anon_sym___try] = ACTIONS(2300),
    [anon_sym___leave] = ACTIONS(2300),
    [anon_sym_QMARK] = ACTIONS(2302),
    [anon_sym_STAR_EQ] = ACTIONS(2302),
    [anon_sym_SLASH_EQ] = ACTIONS(2302),
    [anon_sym_PERCENT_EQ] = ACTIONS(2302),
    [anon_sym_PLUS_EQ] = ACTIONS(2302),
    [anon_sym_DASH_EQ] = ACTIONS(2302),
    [anon_sym_LT_LT_EQ] = ACTIONS(2302),
    [anon_sym_GT_GT_EQ] = ACTIONS(2302),
    [anon_sym_AMP_EQ] = ACTIONS(2302),
    [anon_sym_CARET_EQ] = ACTIONS(2302),
    [anon_sym_PIPE_EQ] = ACTIONS(2302),
    [anon_sym_and_eq] = ACTIONS(2300),
    [anon_sym_or_eq] = ACTIONS(2300),
    [anon_sym_xor_eq] = ACTIONS(2300),
    [anon_sym_not] = ACTIONS(2300),
    [anon_sym_compl] = ACTIONS(2300),
    [anon_sym_LT_EQ_GT] = ACTIONS(2302),
    [anon_sym_or] = ACTIONS(2300),
    [anon_sym_and] = ACTIONS(2300),
    [anon_sym_bitor] = ACTIONS(2300),
    [anon_sym_xor] = ACTIONS(2300),
    [anon_sym_bitand] = ACTIONS(2300),
    [anon_sym_not_eq] = ACTIONS(2300),
    [anon_sym_is] = ACTIONS(2300),
    [anon_sym_as] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_sizeof] = ACTIONS(2300),
    [anon_sym___alignof__] = ACTIONS(2300),
    [anon_sym___alignof] = ACTIONS(2300),
    [anon_sym__alignof] = ACTIONS(2300),
    [anon_sym_alignof] = ACTIONS(2300),
    [anon_sym__Alignof] = ACTIONS(2300),
    [anon_sym_offsetof] = ACTIONS(2300),
    [anon_sym__Generic] = ACTIONS(2300),
    [anon_sym_asm] = ACTIONS(2300),
    [anon_sym___asm__] = ACTIONS(2300),
    [anon_sym___asm] = ACTIONS(2300),
    [anon_sym_DOT] = ACTIONS(2300),
    [anon_sym_DOT_STAR] = ACTIONS(2302),
    [anon_sym_DASH_GT] = ACTIONS(2302),
    [sym_number_literal] = ACTIONS(2302),
    [anon_sym_L_SQUOTE] = ACTIONS(2302),
    [anon_sym_u_SQUOTE] = ACTIONS(2302),
    [anon_sym_U_SQUOTE] = ACTIONS(2302),
    [anon_sym_u8_SQUOTE] = ACTIONS(2302),
    [anon_sym_SQUOTE] = ACTIONS(2302),
    [anon_sym_L_DQUOTE] = ACTIONS(2302),
    [anon_sym_u_DQUOTE] = ACTIONS(2302),
    [anon_sym_U_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8_DQUOTE] = ACTIONS(2302),
    [anon_sym_DQUOTE] = ACTIONS(2302),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [anon_sym_NULL] = ACTIONS(2300),
    [anon_sym_nullptr] = ACTIONS(2300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_This] = ACTIONS(2300),
    [anon_sym_decltype] = ACTIONS(2300),
    [anon_sym_explicit] = ACTIONS(2300),
    [anon_sym_typename] = ACTIONS(2300),
    [anon_sym_template] = ACTIONS(2300),
    [anon_sym_operator] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_static_assert] = ACTIONS(2300),
    [anon_sym_concept] = ACTIONS(2300),
    [anon_sym_co_return] = ACTIONS(2300),
    [anon_sym_co_yield] = ACTIONS(2300),
    [anon_sym_R_DQUOTE] = ACTIONS(2302),
    [anon_sym_LR_DQUOTE] = ACTIONS(2302),
    [anon_sym_uR_DQUOTE] = ACTIONS(2302),
    [anon_sym_UR_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2302),
    [anon_sym_co_await] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_requires] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [anon_sym_discard] = ACTIONS(2300),
    [anon_sym_precise] = ACTIONS(2300),
    [anon_sym_shared] = ACTIONS(2300),
    [anon_sym_groupshared] = ACTIONS(2300),
    [anon_sym_uniform] = ACTIONS(2300),
    [anon_sym_row_major] = ACTIONS(2300),
    [anon_sym_column_major] = ACTIONS(2300),
    [anon_sym_globallycoherent] = ACTIONS(2300),
    [anon_sym_centroid] = ACTIONS(2300),
    [anon_sym_noperspective] = ACTIONS(2300),
    [anon_sym_nointerpolation] = ACTIONS(2300),
    [anon_sym_sample] = ACTIONS(2300),
    [anon_sym_linear] = ACTIONS(2300),
    [anon_sym_snorm] = ACTIONS(2300),
    [anon_sym_unorm] = ACTIONS(2300),
    [anon_sym_point] = ACTIONS(2300),
    [anon_sym_line] = ACTIONS(2300),
    [anon_sym_triangleadj] = ACTIONS(2300),
    [anon_sym_lineadj] = ACTIONS(2300),
    [anon_sym_triangle] = ACTIONS(2300),
    [anon_sym_cbuffer] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_extension] = ACTIONS(2300),
  },
  [129] = {
    [sym_identifier] = ACTIONS(2304),
    [aux_sym_preproc_include_token1] = ACTIONS(2304),
    [aux_sym_preproc_def_token1] = ACTIONS(2304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_COMMA] = ACTIONS(2306),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2304),
    [sym_preproc_directive] = ACTIONS(2304),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_BANG] = ACTIONS(2304),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2304),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_PERCENT] = ACTIONS(2304),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE] = ACTIONS(2304),
    [anon_sym_CARET] = ACTIONS(2304),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_GT] = ACTIONS(2304),
    [anon_sym_GT_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_LT_LT] = ACTIONS(2304),
    [anon_sym_GT_GT] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2306),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym_typedef] = ACTIONS(2304),
    [anon_sym_in] = ACTIONS(2304),
    [anon_sym_out] = ACTIONS(2304),
    [anon_sym_inout] = ACTIONS(2304),
    [anon_sym_virtual] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym___attribute] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2306),
    [anon_sym___declspec] = ACTIONS(2304),
    [anon_sym___based] = ACTIONS(2304),
    [anon_sym___cdecl] = ACTIONS(2304),
    [anon_sym___clrcall] = ACTIONS(2304),
    [anon_sym___stdcall] = ACTIONS(2304),
    [anon_sym___fastcall] = ACTIONS(2304),
    [anon_sym___thiscall] = ACTIONS(2304),
    [anon_sym___vectorcall] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_signed] = ACTIONS(2304),
    [anon_sym_unsigned] = ACTIONS(2304),
    [anon_sym_long] = ACTIONS(2304),
    [anon_sym_short] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_EQ] = ACTIONS(2304),
    [anon_sym_register] = ACTIONS(2304),
    [anon_sym_inline] = ACTIONS(2304),
    [anon_sym___inline] = ACTIONS(2304),
    [anon_sym___inline__] = ACTIONS(2304),
    [anon_sym___forceinline] = ACTIONS(2304),
    [anon_sym_thread_local] = ACTIONS(2304),
    [anon_sym___thread] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym__Nonnull] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [sym_primitive_type] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_struct] = ACTIONS(2304),
    [anon_sym_union] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_case] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_goto] = ACTIONS(2304),
    [anon_sym___try] = ACTIONS(2304),
    [anon_sym___leave] = ACTIONS(2304),
    [anon_sym_QMARK] = ACTIONS(2306),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_and_eq] = ACTIONS(2304),
    [anon_sym_or_eq] = ACTIONS(2304),
    [anon_sym_xor_eq] = ACTIONS(2304),
    [anon_sym_not] = ACTIONS(2304),
    [anon_sym_compl] = ACTIONS(2304),
    [anon_sym_LT_EQ_GT] = ACTIONS(2306),
    [anon_sym_or] = ACTIONS(2304),
    [anon_sym_and] = ACTIONS(2304),
    [anon_sym_bitor] = ACTIONS(2304),
    [anon_sym_xor] = ACTIONS(2304),
    [anon_sym_bitand] = ACTIONS(2304),
    [anon_sym_not_eq] = ACTIONS(2304),
    [anon_sym_is] = ACTIONS(2304),
    [anon_sym_as] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_sizeof] = ACTIONS(2304),
    [anon_sym___alignof__] = ACTIONS(2304),
    [anon_sym___alignof] = ACTIONS(2304),
    [anon_sym__alignof] = ACTIONS(2304),
    [anon_sym_alignof] = ACTIONS(2304),
    [anon_sym__Alignof] = ACTIONS(2304),
    [anon_sym_offsetof] = ACTIONS(2304),
    [anon_sym__Generic] = ACTIONS(2304),
    [anon_sym_asm] = ACTIONS(2304),
    [anon_sym___asm__] = ACTIONS(2304),
    [anon_sym___asm] = ACTIONS(2304),
    [anon_sym_DOT] = ACTIONS(2304),
    [anon_sym_DOT_STAR] = ACTIONS(2306),
    [anon_sym_DASH_GT] = ACTIONS(2306),
    [sym_number_literal] = ACTIONS(2306),
    [anon_sym_L_SQUOTE] = ACTIONS(2306),
    [anon_sym_u_SQUOTE] = ACTIONS(2306),
    [anon_sym_U_SQUOTE] = ACTIONS(2306),
    [anon_sym_u8_SQUOTE] = ACTIONS(2306),
    [anon_sym_SQUOTE] = ACTIONS(2306),
    [anon_sym_L_DQUOTE] = ACTIONS(2306),
    [anon_sym_u_DQUOTE] = ACTIONS(2306),
    [anon_sym_U_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8_DQUOTE] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [anon_sym_NULL] = ACTIONS(2304),
    [anon_sym_nullptr] = ACTIONS(2304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_This] = ACTIONS(2304),
    [anon_sym_decltype] = ACTIONS(2304),
    [anon_sym_explicit] = ACTIONS(2304),
    [anon_sym_typename] = ACTIONS(2304),
    [anon_sym_template] = ACTIONS(2304),
    [anon_sym_operator] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_static_assert] = ACTIONS(2304),
    [anon_sym_concept] = ACTIONS(2304),
    [anon_sym_co_return] = ACTIONS(2304),
    [anon_sym_co_yield] = ACTIONS(2304),
    [anon_sym_R_DQUOTE] = ACTIONS(2306),
    [anon_sym_LR_DQUOTE] = ACTIONS(2306),
    [anon_sym_uR_DQUOTE] = ACTIONS(2306),
    [anon_sym_UR_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2306),
    [anon_sym_co_await] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_requires] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [anon_sym_discard] = ACTIONS(2304),
    [anon_sym_precise] = ACTIONS(2304),
    [anon_sym_shared] = ACTIONS(2304),
    [anon_sym_groupshared] = ACTIONS(2304),
    [anon_sym_uniform] = ACTIONS(2304),
    [anon_sym_row_major] = ACTIONS(2304),
    [anon_sym_column_major] = ACTIONS(2304),
    [anon_sym_globallycoherent] = ACTIONS(2304),
    [anon_sym_centroid] = ACTIONS(2304),
    [anon_sym_noperspective] = ACTIONS(2304),
    [anon_sym_nointerpolation] = ACTIONS(2304),
    [anon_sym_sample] = ACTIONS(2304),
    [anon_sym_linear] = ACTIONS(2304),
    [anon_sym_snorm] = ACTIONS(2304),
    [anon_sym_unorm] = ACTIONS(2304),
    [anon_sym_point] = ACTIONS(2304),
    [anon_sym_line] = ACTIONS(2304),
    [anon_sym_triangleadj] = ACTIONS(2304),
    [anon_sym_lineadj] = ACTIONS(2304),
    [anon_sym_triangle] = ACTIONS(2304),
    [anon_sym_cbuffer] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_extension] = ACTIONS(2304),
  },
  [130] = {
    [sym_identifier] = ACTIONS(2308),
    [aux_sym_preproc_include_token1] = ACTIONS(2308),
    [aux_sym_preproc_def_token1] = ACTIONS(2308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2310),
    [anon_sym_COMMA] = ACTIONS(2310),
    [aux_sym_preproc_if_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2308),
    [sym_preproc_directive] = ACTIONS(2308),
    [anon_sym_LPAREN2] = ACTIONS(2310),
    [anon_sym_BANG] = ACTIONS(2308),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2308),
    [anon_sym_SLASH] = ACTIONS(2308),
    [anon_sym_PERCENT] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_CARET] = ACTIONS(2308),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2310),
    [anon_sym_BANG_EQ] = ACTIONS(2310),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_EQ] = ACTIONS(2310),
    [anon_sym_LT_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(2308),
    [anon_sym_typedef] = ACTIONS(2308),
    [anon_sym_in] = ACTIONS(2308),
    [anon_sym_out] = ACTIONS(2308),
    [anon_sym_inout] = ACTIONS(2308),
    [anon_sym_virtual] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2308),
    [anon_sym___attribute__] = ACTIONS(2308),
    [anon_sym___attribute] = ACTIONS(2308),
    [anon_sym_using] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2310),
    [anon_sym___declspec] = ACTIONS(2308),
    [anon_sym___based] = ACTIONS(2308),
    [anon_sym___cdecl] = ACTIONS(2308),
    [anon_sym___clrcall] = ACTIONS(2308),
    [anon_sym___stdcall] = ACTIONS(2308),
    [anon_sym___fastcall] = ACTIONS(2308),
    [anon_sym___thiscall] = ACTIONS(2308),
    [anon_sym___vectorcall] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_RBRACE] = ACTIONS(2310),
    [anon_sym_signed] = ACTIONS(2308),
    [anon_sym_unsigned] = ACTIONS(2308),
    [anon_sym_long] = ACTIONS(2308),
    [anon_sym_short] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_EQ] = ACTIONS(2308),
    [anon_sym_register] = ACTIONS(2308),
    [anon_sym_inline] = ACTIONS(2308),
    [anon_sym___inline] = ACTIONS(2308),
    [anon_sym___inline__] = ACTIONS(2308),
    [anon_sym___forceinline] = ACTIONS(2308),
    [anon_sym_thread_local] = ACTIONS(2308),
    [anon_sym___thread] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_constexpr] = ACTIONS(2308),
    [anon_sym_volatile] = ACTIONS(2308),
    [anon_sym_restrict] = ACTIONS(2308),
    [anon_sym___restrict__] = ACTIONS(2308),
    [anon_sym__Atomic] = ACTIONS(2308),
    [anon_sym__Noreturn] = ACTIONS(2308),
    [anon_sym_noreturn] = ACTIONS(2308),
    [anon_sym__Nonnull] = ACTIONS(2308),
    [anon_sym_mutable] = ACTIONS(2308),
    [anon_sym_constinit] = ACTIONS(2308),
    [anon_sym_consteval] = ACTIONS(2308),
    [anon_sym_alignas] = ACTIONS(2308),
    [anon_sym__Alignas] = ACTIONS(2308),
    [sym_primitive_type] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_struct] = ACTIONS(2308),
    [anon_sym_union] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_case] = ACTIONS(2308),
    [anon_sym_default] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_goto] = ACTIONS(2308),
    [anon_sym___try] = ACTIONS(2308),
    [anon_sym___leave] = ACTIONS(2308),
    [anon_sym_QMARK] = ACTIONS(2310),
    [anon_sym_STAR_EQ] = ACTIONS(2310),
    [anon_sym_SLASH_EQ] = ACTIONS(2310),
    [anon_sym_PERCENT_EQ] = ACTIONS(2310),
    [anon_sym_PLUS_EQ] = ACTIONS(2310),
    [anon_sym_DASH_EQ] = ACTIONS(2310),
    [anon_sym_LT_LT_EQ] = ACTIONS(2310),
    [anon_sym_GT_GT_EQ] = ACTIONS(2310),
    [anon_sym_AMP_EQ] = ACTIONS(2310),
    [anon_sym_CARET_EQ] = ACTIONS(2310),
    [anon_sym_PIPE_EQ] = ACTIONS(2310),
    [anon_sym_and_eq] = ACTIONS(2308),
    [anon_sym_or_eq] = ACTIONS(2308),
    [anon_sym_xor_eq] = ACTIONS(2308),
    [anon_sym_not] = ACTIONS(2308),
    [anon_sym_compl] = ACTIONS(2308),
    [anon_sym_LT_EQ_GT] = ACTIONS(2310),
    [anon_sym_or] = ACTIONS(2308),
    [anon_sym_and] = ACTIONS(2308),
    [anon_sym_bitor] = ACTIONS(2308),
    [anon_sym_xor] = ACTIONS(2308),
    [anon_sym_bitand] = ACTIONS(2308),
    [anon_sym_not_eq] = ACTIONS(2308),
    [anon_sym_is] = ACTIONS(2308),
    [anon_sym_as] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_sizeof] = ACTIONS(2308),
    [anon_sym___alignof__] = ACTIONS(2308),
    [anon_sym___alignof] = ACTIONS(2308),
    [anon_sym__alignof] = ACTIONS(2308),
    [anon_sym_alignof] = ACTIONS(2308),
    [anon_sym__Alignof] = ACTIONS(2308),
    [anon_sym_offsetof] = ACTIONS(2308),
    [anon_sym__Generic] = ACTIONS(2308),
    [anon_sym_asm] = ACTIONS(2308),
    [anon_sym___asm__] = ACTIONS(2308),
    [anon_sym___asm] = ACTIONS(2308),
    [anon_sym_DOT] = ACTIONS(2308),
    [anon_sym_DOT_STAR] = ACTIONS(2310),
    [anon_sym_DASH_GT] = ACTIONS(2310),
    [sym_number_literal] = ACTIONS(2310),
    [anon_sym_L_SQUOTE] = ACTIONS(2310),
    [anon_sym_u_SQUOTE] = ACTIONS(2310),
    [anon_sym_U_SQUOTE] = ACTIONS(2310),
    [anon_sym_u8_SQUOTE] = ACTIONS(2310),
    [anon_sym_SQUOTE] = ACTIONS(2310),
    [anon_sym_L_DQUOTE] = ACTIONS(2310),
    [anon_sym_u_DQUOTE] = ACTIONS(2310),
    [anon_sym_U_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8_DQUOTE] = ACTIONS(2310),
    [anon_sym_DQUOTE] = ACTIONS(2310),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [anon_sym_NULL] = ACTIONS(2308),
    [anon_sym_nullptr] = ACTIONS(2308),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_This] = ACTIONS(2308),
    [anon_sym_decltype] = ACTIONS(2308),
    [anon_sym_explicit] = ACTIONS(2308),
    [anon_sym_typename] = ACTIONS(2308),
    [anon_sym_template] = ACTIONS(2308),
    [anon_sym_operator] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_delete] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_namespace] = ACTIONS(2308),
    [anon_sym_static_assert] = ACTIONS(2308),
    [anon_sym_concept] = ACTIONS(2308),
    [anon_sym_co_return] = ACTIONS(2308),
    [anon_sym_co_yield] = ACTIONS(2308),
    [anon_sym_R_DQUOTE] = ACTIONS(2310),
    [anon_sym_LR_DQUOTE] = ACTIONS(2310),
    [anon_sym_uR_DQUOTE] = ACTIONS(2310),
    [anon_sym_UR_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2310),
    [anon_sym_co_await] = ACTIONS(2308),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_requires] = ACTIONS(2308),
    [sym_this] = ACTIONS(2308),
    [anon_sym_discard] = ACTIONS(2308),
    [anon_sym_precise] = ACTIONS(2308),
    [anon_sym_shared] = ACTIONS(2308),
    [anon_sym_groupshared] = ACTIONS(2308),
    [anon_sym_uniform] = ACTIONS(2308),
    [anon_sym_row_major] = ACTIONS(2308),
    [anon_sym_column_major] = ACTIONS(2308),
    [anon_sym_globallycoherent] = ACTIONS(2308),
    [anon_sym_centroid] = ACTIONS(2308),
    [anon_sym_noperspective] = ACTIONS(2308),
    [anon_sym_nointerpolation] = ACTIONS(2308),
    [anon_sym_sample] = ACTIONS(2308),
    [anon_sym_linear] = ACTIONS(2308),
    [anon_sym_snorm] = ACTIONS(2308),
    [anon_sym_unorm] = ACTIONS(2308),
    [anon_sym_point] = ACTIONS(2308),
    [anon_sym_line] = ACTIONS(2308),
    [anon_sym_triangleadj] = ACTIONS(2308),
    [anon_sym_lineadj] = ACTIONS(2308),
    [anon_sym_triangle] = ACTIONS(2308),
    [anon_sym_cbuffer] = ACTIONS(2308),
    [anon_sym_interface] = ACTIONS(2308),
    [anon_sym_extension] = ACTIONS(2308),
  },
  [131] = {
    [sym_identifier] = ACTIONS(2312),
    [aux_sym_preproc_include_token1] = ACTIONS(2312),
    [aux_sym_preproc_def_token1] = ACTIONS(2312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2314),
    [anon_sym_COMMA] = ACTIONS(2314),
    [aux_sym_preproc_if_token1] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2312),
    [sym_preproc_directive] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_SLASH] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2312),
    [anon_sym_PIPE_PIPE] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2314),
    [anon_sym_PIPE] = ACTIONS(2312),
    [anon_sym_CARET] = ACTIONS(2312),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_EQ_EQ] = ACTIONS(2314),
    [anon_sym_BANG_EQ] = ACTIONS(2314),
    [anon_sym_GT] = ACTIONS(2312),
    [anon_sym_GT_EQ] = ACTIONS(2314),
    [anon_sym_LT_EQ] = ACTIONS(2312),
    [anon_sym_LT] = ACTIONS(2312),
    [anon_sym_LT_LT] = ACTIONS(2312),
    [anon_sym_GT_GT] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym___extension__] = ACTIONS(2312),
    [anon_sym_typedef] = ACTIONS(2312),
    [anon_sym_in] = ACTIONS(2312),
    [anon_sym_out] = ACTIONS(2312),
    [anon_sym_inout] = ACTIONS(2312),
    [anon_sym_virtual] = ACTIONS(2312),
    [anon_sym_extern] = ACTIONS(2312),
    [anon_sym___attribute__] = ACTIONS(2312),
    [anon_sym___attribute] = ACTIONS(2312),
    [anon_sym_using] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2314),
    [anon_sym___declspec] = ACTIONS(2312),
    [anon_sym___based] = ACTIONS(2312),
    [anon_sym___cdecl] = ACTIONS(2312),
    [anon_sym___clrcall] = ACTIONS(2312),
    [anon_sym___stdcall] = ACTIONS(2312),
    [anon_sym___fastcall] = ACTIONS(2312),
    [anon_sym___thiscall] = ACTIONS(2312),
    [anon_sym___vectorcall] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_RBRACE] = ACTIONS(2314),
    [anon_sym_signed] = ACTIONS(2312),
    [anon_sym_unsigned] = ACTIONS(2312),
    [anon_sym_long] = ACTIONS(2312),
    [anon_sym_short] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_EQ] = ACTIONS(2312),
    [anon_sym_register] = ACTIONS(2312),
    [anon_sym_inline] = ACTIONS(2312),
    [anon_sym___inline] = ACTIONS(2312),
    [anon_sym___inline__] = ACTIONS(2312),
    [anon_sym___forceinline] = ACTIONS(2312),
    [anon_sym_thread_local] = ACTIONS(2312),
    [anon_sym___thread] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_constexpr] = ACTIONS(2312),
    [anon_sym_volatile] = ACTIONS(2312),
    [anon_sym_restrict] = ACTIONS(2312),
    [anon_sym___restrict__] = ACTIONS(2312),
    [anon_sym__Atomic] = ACTIONS(2312),
    [anon_sym__Noreturn] = ACTIONS(2312),
    [anon_sym_noreturn] = ACTIONS(2312),
    [anon_sym__Nonnull] = ACTIONS(2312),
    [anon_sym_mutable] = ACTIONS(2312),
    [anon_sym_constinit] = ACTIONS(2312),
    [anon_sym_consteval] = ACTIONS(2312),
    [anon_sym_alignas] = ACTIONS(2312),
    [anon_sym__Alignas] = ACTIONS(2312),
    [sym_primitive_type] = ACTIONS(2312),
    [anon_sym_enum] = ACTIONS(2312),
    [anon_sym_class] = ACTIONS(2312),
    [anon_sym_struct] = ACTIONS(2312),
    [anon_sym_union] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_switch] = ACTIONS(2312),
    [anon_sym_case] = ACTIONS(2312),
    [anon_sym_default] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_break] = ACTIONS(2312),
    [anon_sym_continue] = ACTIONS(2312),
    [anon_sym_goto] = ACTIONS(2312),
    [anon_sym___try] = ACTIONS(2312),
    [anon_sym___leave] = ACTIONS(2312),
    [anon_sym_QMARK] = ACTIONS(2314),
    [anon_sym_STAR_EQ] = ACTIONS(2314),
    [anon_sym_SLASH_EQ] = ACTIONS(2314),
    [anon_sym_PERCENT_EQ] = ACTIONS(2314),
    [anon_sym_PLUS_EQ] = ACTIONS(2314),
    [anon_sym_DASH_EQ] = ACTIONS(2314),
    [anon_sym_LT_LT_EQ] = ACTIONS(2314),
    [anon_sym_GT_GT_EQ] = ACTIONS(2314),
    [anon_sym_AMP_EQ] = ACTIONS(2314),
    [anon_sym_CARET_EQ] = ACTIONS(2314),
    [anon_sym_PIPE_EQ] = ACTIONS(2314),
    [anon_sym_and_eq] = ACTIONS(2312),
    [anon_sym_or_eq] = ACTIONS(2312),
    [anon_sym_xor_eq] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2312),
    [anon_sym_compl] = ACTIONS(2312),
    [anon_sym_LT_EQ_GT] = ACTIONS(2314),
    [anon_sym_or] = ACTIONS(2312),
    [anon_sym_and] = ACTIONS(2312),
    [anon_sym_bitor] = ACTIONS(2312),
    [anon_sym_xor] = ACTIONS(2312),
    [anon_sym_bitand] = ACTIONS(2312),
    [anon_sym_not_eq] = ACTIONS(2312),
    [anon_sym_is] = ACTIONS(2312),
    [anon_sym_as] = ACTIONS(2312),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_sizeof] = ACTIONS(2312),
    [anon_sym___alignof__] = ACTIONS(2312),
    [anon_sym___alignof] = ACTIONS(2312),
    [anon_sym__alignof] = ACTIONS(2312),
    [anon_sym_alignof] = ACTIONS(2312),
    [anon_sym__Alignof] = ACTIONS(2312),
    [anon_sym_offsetof] = ACTIONS(2312),
    [anon_sym__Generic] = ACTIONS(2312),
    [anon_sym_asm] = ACTIONS(2312),
    [anon_sym___asm__] = ACTIONS(2312),
    [anon_sym___asm] = ACTIONS(2312),
    [anon_sym_DOT] = ACTIONS(2312),
    [anon_sym_DOT_STAR] = ACTIONS(2314),
    [anon_sym_DASH_GT] = ACTIONS(2314),
    [sym_number_literal] = ACTIONS(2314),
    [anon_sym_L_SQUOTE] = ACTIONS(2314),
    [anon_sym_u_SQUOTE] = ACTIONS(2314),
    [anon_sym_U_SQUOTE] = ACTIONS(2314),
    [anon_sym_u8_SQUOTE] = ACTIONS(2314),
    [anon_sym_SQUOTE] = ACTIONS(2314),
    [anon_sym_L_DQUOTE] = ACTIONS(2314),
    [anon_sym_u_DQUOTE] = ACTIONS(2314),
    [anon_sym_U_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE] = ACTIONS(2314),
    [sym_true] = ACTIONS(2312),
    [sym_false] = ACTIONS(2312),
    [anon_sym_NULL] = ACTIONS(2312),
    [anon_sym_nullptr] = ACTIONS(2312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_This] = ACTIONS(2312),
    [anon_sym_decltype] = ACTIONS(2312),
    [anon_sym_explicit] = ACTIONS(2312),
    [anon_sym_typename] = ACTIONS(2312),
    [anon_sym_template] = ACTIONS(2312),
    [anon_sym_operator] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_delete] = ACTIONS(2312),
    [anon_sym_throw] = ACTIONS(2312),
    [anon_sym_namespace] = ACTIONS(2312),
    [anon_sym_static_assert] = ACTIONS(2312),
    [anon_sym_concept] = ACTIONS(2312),
    [anon_sym_co_return] = ACTIONS(2312),
    [anon_sym_co_yield] = ACTIONS(2312),
    [anon_sym_R_DQUOTE] = ACTIONS(2314),
    [anon_sym_LR_DQUOTE] = ACTIONS(2314),
    [anon_sym_uR_DQUOTE] = ACTIONS(2314),
    [anon_sym_UR_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2314),
    [anon_sym_co_await] = ACTIONS(2312),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_requires] = ACTIONS(2312),
    [sym_this] = ACTIONS(2312),
    [anon_sym_discard] = ACTIONS(2312),
    [anon_sym_precise] = ACTIONS(2312),
    [anon_sym_shared] = ACTIONS(2312),
    [anon_sym_groupshared] = ACTIONS(2312),
    [anon_sym_uniform] = ACTIONS(2312),
    [anon_sym_row_major] = ACTIONS(2312),
    [anon_sym_column_major] = ACTIONS(2312),
    [anon_sym_globallycoherent] = ACTIONS(2312),
    [anon_sym_centroid] = ACTIONS(2312),
    [anon_sym_noperspective] = ACTIONS(2312),
    [anon_sym_nointerpolation] = ACTIONS(2312),
    [anon_sym_sample] = ACTIONS(2312),
    [anon_sym_linear] = ACTIONS(2312),
    [anon_sym_snorm] = ACTIONS(2312),
    [anon_sym_unorm] = ACTIONS(2312),
    [anon_sym_point] = ACTIONS(2312),
    [anon_sym_line] = ACTIONS(2312),
    [anon_sym_triangleadj] = ACTIONS(2312),
    [anon_sym_lineadj] = ACTIONS(2312),
    [anon_sym_triangle] = ACTIONS(2312),
    [anon_sym_cbuffer] = ACTIONS(2312),
    [anon_sym_interface] = ACTIONS(2312),
    [anon_sym_extension] = ACTIONS(2312),
  },
  [132] = {
    [ts_builtin_sym_end] = ACTIONS(2270),
    [sym_identifier] = ACTIONS(2268),
    [aux_sym_preproc_include_token1] = ACTIONS(2268),
    [aux_sym_preproc_def_token1] = ACTIONS(2268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2270),
    [aux_sym_preproc_if_token1] = ACTIONS(2268),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2268),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2268),
    [sym_preproc_directive] = ACTIONS(2268),
    [anon_sym_LPAREN2] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2268),
    [anon_sym_TILDE] = ACTIONS(2270),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2268),
    [anon_sym_SLASH] = ACTIONS(2268),
    [anon_sym_PERCENT] = ACTIONS(2268),
    [anon_sym_PIPE_PIPE] = ACTIONS(2270),
    [anon_sym_AMP_AMP] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2268),
    [anon_sym_CARET] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2268),
    [anon_sym_EQ_EQ] = ACTIONS(2270),
    [anon_sym_BANG_EQ] = ACTIONS(2270),
    [anon_sym_GT] = ACTIONS(2268),
    [anon_sym_GT_EQ] = ACTIONS(2270),
    [anon_sym_LT_EQ] = ACTIONS(2268),
    [anon_sym_LT] = ACTIONS(2268),
    [anon_sym_LT_LT] = ACTIONS(2268),
    [anon_sym_GT_GT] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym___extension__] = ACTIONS(2268),
    [anon_sym_typedef] = ACTIONS(2268),
    [anon_sym_in] = ACTIONS(2268),
    [anon_sym_out] = ACTIONS(2268),
    [anon_sym_inout] = ACTIONS(2268),
    [anon_sym_virtual] = ACTIONS(2268),
    [anon_sym_extern] = ACTIONS(2268),
    [anon_sym___attribute__] = ACTIONS(2268),
    [anon_sym___attribute] = ACTIONS(2268),
    [anon_sym_using] = ACTIONS(2268),
    [anon_sym_COLON_COLON] = ACTIONS(2270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2270),
    [anon_sym___declspec] = ACTIONS(2268),
    [anon_sym___based] = ACTIONS(2268),
    [anon_sym___cdecl] = ACTIONS(2268),
    [anon_sym___clrcall] = ACTIONS(2268),
    [anon_sym___stdcall] = ACTIONS(2268),
    [anon_sym___fastcall] = ACTIONS(2268),
    [anon_sym___thiscall] = ACTIONS(2268),
    [anon_sym___vectorcall] = ACTIONS(2268),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_signed] = ACTIONS(2268),
    [anon_sym_unsigned] = ACTIONS(2268),
    [anon_sym_long] = ACTIONS(2268),
    [anon_sym_short] = ACTIONS(2268),
    [anon_sym_LBRACK] = ACTIONS(2268),
    [anon_sym_static] = ACTIONS(2268),
    [anon_sym_EQ] = ACTIONS(2268),
    [anon_sym_register] = ACTIONS(2268),
    [anon_sym_inline] = ACTIONS(2268),
    [anon_sym___inline] = ACTIONS(2268),
    [anon_sym___inline__] = ACTIONS(2268),
    [anon_sym___forceinline] = ACTIONS(2268),
    [anon_sym_thread_local] = ACTIONS(2268),
    [anon_sym___thread] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_constexpr] = ACTIONS(2268),
    [anon_sym_volatile] = ACTIONS(2268),
    [anon_sym_restrict] = ACTIONS(2268),
    [anon_sym___restrict__] = ACTIONS(2268),
    [anon_sym__Atomic] = ACTIONS(2268),
    [anon_sym__Noreturn] = ACTIONS(2268),
    [anon_sym_noreturn] = ACTIONS(2268),
    [anon_sym__Nonnull] = ACTIONS(2268),
    [anon_sym_mutable] = ACTIONS(2268),
    [anon_sym_constinit] = ACTIONS(2268),
    [anon_sym_consteval] = ACTIONS(2268),
    [anon_sym_alignas] = ACTIONS(2268),
    [anon_sym__Alignas] = ACTIONS(2268),
    [sym_primitive_type] = ACTIONS(2268),
    [anon_sym_enum] = ACTIONS(2268),
    [anon_sym_class] = ACTIONS(2268),
    [anon_sym_struct] = ACTIONS(2268),
    [anon_sym_union] = ACTIONS(2268),
    [anon_sym_if] = ACTIONS(2268),
    [anon_sym_switch] = ACTIONS(2268),
    [anon_sym_case] = ACTIONS(2268),
    [anon_sym_default] = ACTIONS(2268),
    [anon_sym_while] = ACTIONS(2268),
    [anon_sym_do] = ACTIONS(2268),
    [anon_sym_for] = ACTIONS(2268),
    [anon_sym_return] = ACTIONS(2268),
    [anon_sym_break] = ACTIONS(2268),
    [anon_sym_continue] = ACTIONS(2268),
    [anon_sym_goto] = ACTIONS(2268),
    [anon_sym_QMARK] = ACTIONS(2270),
    [anon_sym_STAR_EQ] = ACTIONS(2270),
    [anon_sym_SLASH_EQ] = ACTIONS(2270),
    [anon_sym_PERCENT_EQ] = ACTIONS(2270),
    [anon_sym_PLUS_EQ] = ACTIONS(2270),
    [anon_sym_DASH_EQ] = ACTIONS(2270),
    [anon_sym_LT_LT_EQ] = ACTIONS(2270),
    [anon_sym_GT_GT_EQ] = ACTIONS(2270),
    [anon_sym_AMP_EQ] = ACTIONS(2270),
    [anon_sym_CARET_EQ] = ACTIONS(2270),
    [anon_sym_PIPE_EQ] = ACTIONS(2270),
    [anon_sym_and_eq] = ACTIONS(2268),
    [anon_sym_or_eq] = ACTIONS(2268),
    [anon_sym_xor_eq] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2268),
    [anon_sym_compl] = ACTIONS(2268),
    [anon_sym_LT_EQ_GT] = ACTIONS(2270),
    [anon_sym_or] = ACTIONS(2268),
    [anon_sym_and] = ACTIONS(2268),
    [anon_sym_bitor] = ACTIONS(2268),
    [anon_sym_xor] = ACTIONS(2268),
    [anon_sym_bitand] = ACTIONS(2268),
    [anon_sym_not_eq] = ACTIONS(2268),
    [anon_sym_is] = ACTIONS(2268),
    [anon_sym_as] = ACTIONS(2268),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_sizeof] = ACTIONS(2268),
    [anon_sym___alignof__] = ACTIONS(2268),
    [anon_sym___alignof] = ACTIONS(2268),
    [anon_sym__alignof] = ACTIONS(2268),
    [anon_sym_alignof] = ACTIONS(2268),
    [anon_sym__Alignof] = ACTIONS(2268),
    [anon_sym_offsetof] = ACTIONS(2268),
    [anon_sym__Generic] = ACTIONS(2268),
    [anon_sym_asm] = ACTIONS(2268),
    [anon_sym___asm__] = ACTIONS(2268),
    [anon_sym___asm] = ACTIONS(2268),
    [anon_sym_DOT] = ACTIONS(2268),
    [anon_sym_DOT_STAR] = ACTIONS(2270),
    [anon_sym_DASH_GT] = ACTIONS(2270),
    [sym_number_literal] = ACTIONS(2270),
    [anon_sym_L_SQUOTE] = ACTIONS(2270),
    [anon_sym_u_SQUOTE] = ACTIONS(2270),
    [anon_sym_U_SQUOTE] = ACTIONS(2270),
    [anon_sym_u8_SQUOTE] = ACTIONS(2270),
    [anon_sym_SQUOTE] = ACTIONS(2270),
    [anon_sym_L_DQUOTE] = ACTIONS(2270),
    [anon_sym_u_DQUOTE] = ACTIONS(2270),
    [anon_sym_U_DQUOTE] = ACTIONS(2270),
    [anon_sym_u8_DQUOTE] = ACTIONS(2270),
    [anon_sym_DQUOTE] = ACTIONS(2270),
    [sym_true] = ACTIONS(2268),
    [sym_false] = ACTIONS(2268),
    [anon_sym_NULL] = ACTIONS(2268),
    [anon_sym_nullptr] = ACTIONS(2268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_This] = ACTIONS(2268),
    [anon_sym_decltype] = ACTIONS(2268),
    [anon_sym_explicit] = ACTIONS(2268),
    [anon_sym_typename] = ACTIONS(2268),
    [anon_sym_export] = ACTIONS(2268),
    [anon_sym_module] = ACTIONS(2268),
    [anon_sym_import] = ACTIONS(2268),
    [anon_sym_template] = ACTIONS(2268),
    [anon_sym_operator] = ACTIONS(2268),
    [anon_sym_try] = ACTIONS(2268),
    [anon_sym_delete] = ACTIONS(2268),
    [anon_sym_throw] = ACTIONS(2268),
    [anon_sym_namespace] = ACTIONS(2268),
    [anon_sym_static_assert] = ACTIONS(2268),
    [anon_sym_concept] = ACTIONS(2268),
    [anon_sym_co_return] = ACTIONS(2268),
    [anon_sym_co_yield] = ACTIONS(2268),
    [anon_sym_R_DQUOTE] = ACTIONS(2270),
    [anon_sym_LR_DQUOTE] = ACTIONS(2270),
    [anon_sym_uR_DQUOTE] = ACTIONS(2270),
    [anon_sym_UR_DQUOTE] = ACTIONS(2270),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2270),
    [anon_sym_co_await] = ACTIONS(2268),
    [anon_sym_new] = ACTIONS(2268),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2268),
    [anon_sym_precise] = ACTIONS(2268),
    [anon_sym_shared] = ACTIONS(2268),
    [anon_sym_groupshared] = ACTIONS(2268),
    [anon_sym_uniform] = ACTIONS(2268),
    [anon_sym_row_major] = ACTIONS(2268),
    [anon_sym_column_major] = ACTIONS(2268),
    [anon_sym_globallycoherent] = ACTIONS(2268),
    [anon_sym_centroid] = ACTIONS(2268),
    [anon_sym_noperspective] = ACTIONS(2268),
    [anon_sym_nointerpolation] = ACTIONS(2268),
    [anon_sym_sample] = ACTIONS(2268),
    [anon_sym_linear] = ACTIONS(2268),
    [anon_sym_snorm] = ACTIONS(2268),
    [anon_sym_unorm] = ACTIONS(2268),
    [anon_sym_point] = ACTIONS(2268),
    [anon_sym_line] = ACTIONS(2268),
    [anon_sym_triangleadj] = ACTIONS(2268),
    [anon_sym_lineadj] = ACTIONS(2268),
    [anon_sym_triangle] = ACTIONS(2268),
    [anon_sym_interface] = ACTIONS(2268),
    [anon_sym_extension] = ACTIONS(2268),
    [anon_sym___exported] = ACTIONS(2268),
  },
  [133] = {
    [ts_builtin_sym_end] = ACTIONS(2274),
    [sym_identifier] = ACTIONS(2272),
    [aux_sym_preproc_include_token1] = ACTIONS(2272),
    [aux_sym_preproc_def_token1] = ACTIONS(2272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2274),
    [aux_sym_preproc_if_token1] = ACTIONS(2272),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2272),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2272),
    [sym_preproc_directive] = ACTIONS(2272),
    [anon_sym_LPAREN2] = ACTIONS(2274),
    [anon_sym_BANG] = ACTIONS(2272),
    [anon_sym_TILDE] = ACTIONS(2274),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2272),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_PERCENT] = ACTIONS(2272),
    [anon_sym_PIPE_PIPE] = ACTIONS(2274),
    [anon_sym_AMP_AMP] = ACTIONS(2274),
    [anon_sym_PIPE] = ACTIONS(2272),
    [anon_sym_CARET] = ACTIONS(2272),
    [anon_sym_AMP] = ACTIONS(2272),
    [anon_sym_EQ_EQ] = ACTIONS(2274),
    [anon_sym_BANG_EQ] = ACTIONS(2274),
    [anon_sym_GT] = ACTIONS(2272),
    [anon_sym_GT_EQ] = ACTIONS(2274),
    [anon_sym_LT_EQ] = ACTIONS(2272),
    [anon_sym_LT] = ACTIONS(2272),
    [anon_sym_LT_LT] = ACTIONS(2272),
    [anon_sym_GT_GT] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym___extension__] = ACTIONS(2272),
    [anon_sym_typedef] = ACTIONS(2272),
    [anon_sym_in] = ACTIONS(2272),
    [anon_sym_out] = ACTIONS(2272),
    [anon_sym_inout] = ACTIONS(2272),
    [anon_sym_virtual] = ACTIONS(2272),
    [anon_sym_extern] = ACTIONS(2272),
    [anon_sym___attribute__] = ACTIONS(2272),
    [anon_sym___attribute] = ACTIONS(2272),
    [anon_sym_using] = ACTIONS(2272),
    [anon_sym_COLON_COLON] = ACTIONS(2274),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2274),
    [anon_sym___declspec] = ACTIONS(2272),
    [anon_sym___based] = ACTIONS(2272),
    [anon_sym___cdecl] = ACTIONS(2272),
    [anon_sym___clrcall] = ACTIONS(2272),
    [anon_sym___stdcall] = ACTIONS(2272),
    [anon_sym___fastcall] = ACTIONS(2272),
    [anon_sym___thiscall] = ACTIONS(2272),
    [anon_sym___vectorcall] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_signed] = ACTIONS(2272),
    [anon_sym_unsigned] = ACTIONS(2272),
    [anon_sym_long] = ACTIONS(2272),
    [anon_sym_short] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_EQ] = ACTIONS(2272),
    [anon_sym_register] = ACTIONS(2272),
    [anon_sym_inline] = ACTIONS(2272),
    [anon_sym___inline] = ACTIONS(2272),
    [anon_sym___inline__] = ACTIONS(2272),
    [anon_sym___forceinline] = ACTIONS(2272),
    [anon_sym_thread_local] = ACTIONS(2272),
    [anon_sym___thread] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_constexpr] = ACTIONS(2272),
    [anon_sym_volatile] = ACTIONS(2272),
    [anon_sym_restrict] = ACTIONS(2272),
    [anon_sym___restrict__] = ACTIONS(2272),
    [anon_sym__Atomic] = ACTIONS(2272),
    [anon_sym__Noreturn] = ACTIONS(2272),
    [anon_sym_noreturn] = ACTIONS(2272),
    [anon_sym__Nonnull] = ACTIONS(2272),
    [anon_sym_mutable] = ACTIONS(2272),
    [anon_sym_constinit] = ACTIONS(2272),
    [anon_sym_consteval] = ACTIONS(2272),
    [anon_sym_alignas] = ACTIONS(2272),
    [anon_sym__Alignas] = ACTIONS(2272),
    [sym_primitive_type] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_struct] = ACTIONS(2272),
    [anon_sym_union] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_case] = ACTIONS(2272),
    [anon_sym_default] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_goto] = ACTIONS(2272),
    [anon_sym_QMARK] = ACTIONS(2274),
    [anon_sym_STAR_EQ] = ACTIONS(2274),
    [anon_sym_SLASH_EQ] = ACTIONS(2274),
    [anon_sym_PERCENT_EQ] = ACTIONS(2274),
    [anon_sym_PLUS_EQ] = ACTIONS(2274),
    [anon_sym_DASH_EQ] = ACTIONS(2274),
    [anon_sym_LT_LT_EQ] = ACTIONS(2274),
    [anon_sym_GT_GT_EQ] = ACTIONS(2274),
    [anon_sym_AMP_EQ] = ACTIONS(2274),
    [anon_sym_CARET_EQ] = ACTIONS(2274),
    [anon_sym_PIPE_EQ] = ACTIONS(2274),
    [anon_sym_and_eq] = ACTIONS(2272),
    [anon_sym_or_eq] = ACTIONS(2272),
    [anon_sym_xor_eq] = ACTIONS(2272),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_compl] = ACTIONS(2272),
    [anon_sym_LT_EQ_GT] = ACTIONS(2274),
    [anon_sym_or] = ACTIONS(2272),
    [anon_sym_and] = ACTIONS(2272),
    [anon_sym_bitor] = ACTIONS(2272),
    [anon_sym_xor] = ACTIONS(2272),
    [anon_sym_bitand] = ACTIONS(2272),
    [anon_sym_not_eq] = ACTIONS(2272),
    [anon_sym_is] = ACTIONS(2272),
    [anon_sym_as] = ACTIONS(2272),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_sizeof] = ACTIONS(2272),
    [anon_sym___alignof__] = ACTIONS(2272),
    [anon_sym___alignof] = ACTIONS(2272),
    [anon_sym__alignof] = ACTIONS(2272),
    [anon_sym_alignof] = ACTIONS(2272),
    [anon_sym__Alignof] = ACTIONS(2272),
    [anon_sym_offsetof] = ACTIONS(2272),
    [anon_sym__Generic] = ACTIONS(2272),
    [anon_sym_asm] = ACTIONS(2272),
    [anon_sym___asm__] = ACTIONS(2272),
    [anon_sym___asm] = ACTIONS(2272),
    [anon_sym_DOT] = ACTIONS(2272),
    [anon_sym_DOT_STAR] = ACTIONS(2274),
    [anon_sym_DASH_GT] = ACTIONS(2274),
    [sym_number_literal] = ACTIONS(2274),
    [anon_sym_L_SQUOTE] = ACTIONS(2274),
    [anon_sym_u_SQUOTE] = ACTIONS(2274),
    [anon_sym_U_SQUOTE] = ACTIONS(2274),
    [anon_sym_u8_SQUOTE] = ACTIONS(2274),
    [anon_sym_SQUOTE] = ACTIONS(2274),
    [anon_sym_L_DQUOTE] = ACTIONS(2274),
    [anon_sym_u_DQUOTE] = ACTIONS(2274),
    [anon_sym_U_DQUOTE] = ACTIONS(2274),
    [anon_sym_u8_DQUOTE] = ACTIONS(2274),
    [anon_sym_DQUOTE] = ACTIONS(2274),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [anon_sym_NULL] = ACTIONS(2272),
    [anon_sym_nullptr] = ACTIONS(2272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_This] = ACTIONS(2272),
    [anon_sym_decltype] = ACTIONS(2272),
    [anon_sym_explicit] = ACTIONS(2272),
    [anon_sym_typename] = ACTIONS(2272),
    [anon_sym_export] = ACTIONS(2272),
    [anon_sym_module] = ACTIONS(2272),
    [anon_sym_import] = ACTIONS(2272),
    [anon_sym_template] = ACTIONS(2272),
    [anon_sym_operator] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_namespace] = ACTIONS(2272),
    [anon_sym_static_assert] = ACTIONS(2272),
    [anon_sym_concept] = ACTIONS(2272),
    [anon_sym_co_return] = ACTIONS(2272),
    [anon_sym_co_yield] = ACTIONS(2272),
    [anon_sym_R_DQUOTE] = ACTIONS(2274),
    [anon_sym_LR_DQUOTE] = ACTIONS(2274),
    [anon_sym_uR_DQUOTE] = ACTIONS(2274),
    [anon_sym_UR_DQUOTE] = ACTIONS(2274),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2274),
    [anon_sym_co_await] = ACTIONS(2272),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_requires] = ACTIONS(2272),
    [sym_this] = ACTIONS(2272),
    [anon_sym_precise] = ACTIONS(2272),
    [anon_sym_shared] = ACTIONS(2272),
    [anon_sym_groupshared] = ACTIONS(2272),
    [anon_sym_uniform] = ACTIONS(2272),
    [anon_sym_row_major] = ACTIONS(2272),
    [anon_sym_column_major] = ACTIONS(2272),
    [anon_sym_globallycoherent] = ACTIONS(2272),
    [anon_sym_centroid] = ACTIONS(2272),
    [anon_sym_noperspective] = ACTIONS(2272),
    [anon_sym_nointerpolation] = ACTIONS(2272),
    [anon_sym_sample] = ACTIONS(2272),
    [anon_sym_linear] = ACTIONS(2272),
    [anon_sym_snorm] = ACTIONS(2272),
    [anon_sym_unorm] = ACTIONS(2272),
    [anon_sym_point] = ACTIONS(2272),
    [anon_sym_line] = ACTIONS(2272),
    [anon_sym_triangleadj] = ACTIONS(2272),
    [anon_sym_lineadj] = ACTIONS(2272),
    [anon_sym_triangle] = ACTIONS(2272),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_extension] = ACTIONS(2272),
    [anon_sym___exported] = ACTIONS(2272),
  },
  [134] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2276),
    [aux_sym_preproc_include_token1] = ACTIONS(2276),
    [aux_sym_preproc_def_token1] = ACTIONS(2276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2278),
    [aux_sym_preproc_if_token1] = ACTIONS(2276),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2276),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2276),
    [sym_preproc_directive] = ACTIONS(2276),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_PLUS] = ACTIONS(2276),
    [anon_sym_STAR] = ACTIONS(2276),
    [anon_sym_SLASH] = ACTIONS(2276),
    [anon_sym_PERCENT] = ACTIONS(2276),
    [anon_sym_PIPE_PIPE] = ACTIONS(2278),
    [anon_sym_AMP_AMP] = ACTIONS(2278),
    [anon_sym_PIPE] = ACTIONS(2276),
    [anon_sym_CARET] = ACTIONS(2276),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_EQ_EQ] = ACTIONS(2278),
    [anon_sym_BANG_EQ] = ACTIONS(2278),
    [anon_sym_GT] = ACTIONS(2276),
    [anon_sym_GT_EQ] = ACTIONS(2278),
    [anon_sym_LT_EQ] = ACTIONS(2276),
    [anon_sym_LT] = ACTIONS(2276),
    [anon_sym_LT_LT] = ACTIONS(2276),
    [anon_sym_GT_GT] = ACTIONS(2276),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym___extension__] = ACTIONS(2276),
    [anon_sym_typedef] = ACTIONS(2276),
    [anon_sym_in] = ACTIONS(2276),
    [anon_sym_out] = ACTIONS(2276),
    [anon_sym_inout] = ACTIONS(2276),
    [anon_sym_virtual] = ACTIONS(2276),
    [anon_sym_extern] = ACTIONS(2276),
    [anon_sym___attribute__] = ACTIONS(2276),
    [anon_sym___attribute] = ACTIONS(2276),
    [anon_sym_using] = ACTIONS(2276),
    [anon_sym_COLON_COLON] = ACTIONS(2278),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2278),
    [anon_sym___declspec] = ACTIONS(2276),
    [anon_sym___based] = ACTIONS(2276),
    [anon_sym___cdecl] = ACTIONS(2276),
    [anon_sym___clrcall] = ACTIONS(2276),
    [anon_sym___stdcall] = ACTIONS(2276),
    [anon_sym___fastcall] = ACTIONS(2276),
    [anon_sym___thiscall] = ACTIONS(2276),
    [anon_sym___vectorcall] = ACTIONS(2276),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_signed] = ACTIONS(2276),
    [anon_sym_unsigned] = ACTIONS(2276),
    [anon_sym_long] = ACTIONS(2276),
    [anon_sym_short] = ACTIONS(2276),
    [anon_sym_LBRACK] = ACTIONS(2276),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_EQ] = ACTIONS(2276),
    [anon_sym_register] = ACTIONS(2276),
    [anon_sym_inline] = ACTIONS(2276),
    [anon_sym___inline] = ACTIONS(2276),
    [anon_sym___inline__] = ACTIONS(2276),
    [anon_sym___forceinline] = ACTIONS(2276),
    [anon_sym_thread_local] = ACTIONS(2276),
    [anon_sym___thread] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_constexpr] = ACTIONS(2276),
    [anon_sym_volatile] = ACTIONS(2276),
    [anon_sym_restrict] = ACTIONS(2276),
    [anon_sym___restrict__] = ACTIONS(2276),
    [anon_sym__Atomic] = ACTIONS(2276),
    [anon_sym__Noreturn] = ACTIONS(2276),
    [anon_sym_noreturn] = ACTIONS(2276),
    [anon_sym__Nonnull] = ACTIONS(2276),
    [anon_sym_mutable] = ACTIONS(2276),
    [anon_sym_constinit] = ACTIONS(2276),
    [anon_sym_consteval] = ACTIONS(2276),
    [anon_sym_alignas] = ACTIONS(2276),
    [anon_sym__Alignas] = ACTIONS(2276),
    [sym_primitive_type] = ACTIONS(2276),
    [anon_sym_enum] = ACTIONS(2276),
    [anon_sym_class] = ACTIONS(2276),
    [anon_sym_struct] = ACTIONS(2276),
    [anon_sym_union] = ACTIONS(2276),
    [anon_sym_if] = ACTIONS(2276),
    [anon_sym_switch] = ACTIONS(2276),
    [anon_sym_case] = ACTIONS(2276),
    [anon_sym_default] = ACTIONS(2276),
    [anon_sym_while] = ACTIONS(2276),
    [anon_sym_do] = ACTIONS(2276),
    [anon_sym_for] = ACTIONS(2276),
    [anon_sym_return] = ACTIONS(2276),
    [anon_sym_break] = ACTIONS(2276),
    [anon_sym_continue] = ACTIONS(2276),
    [anon_sym_goto] = ACTIONS(2276),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_STAR_EQ] = ACTIONS(2278),
    [anon_sym_SLASH_EQ] = ACTIONS(2278),
    [anon_sym_PERCENT_EQ] = ACTIONS(2278),
    [anon_sym_PLUS_EQ] = ACTIONS(2278),
    [anon_sym_DASH_EQ] = ACTIONS(2278),
    [anon_sym_LT_LT_EQ] = ACTIONS(2278),
    [anon_sym_GT_GT_EQ] = ACTIONS(2278),
    [anon_sym_AMP_EQ] = ACTIONS(2278),
    [anon_sym_CARET_EQ] = ACTIONS(2278),
    [anon_sym_PIPE_EQ] = ACTIONS(2278),
    [anon_sym_and_eq] = ACTIONS(2276),
    [anon_sym_or_eq] = ACTIONS(2276),
    [anon_sym_xor_eq] = ACTIONS(2276),
    [anon_sym_not] = ACTIONS(2276),
    [anon_sym_compl] = ACTIONS(2276),
    [anon_sym_LT_EQ_GT] = ACTIONS(2278),
    [anon_sym_or] = ACTIONS(2276),
    [anon_sym_and] = ACTIONS(2276),
    [anon_sym_bitor] = ACTIONS(2276),
    [anon_sym_xor] = ACTIONS(2276),
    [anon_sym_bitand] = ACTIONS(2276),
    [anon_sym_not_eq] = ACTIONS(2276),
    [anon_sym_is] = ACTIONS(2276),
    [anon_sym_as] = ACTIONS(2276),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_sizeof] = ACTIONS(2276),
    [anon_sym___alignof__] = ACTIONS(2276),
    [anon_sym___alignof] = ACTIONS(2276),
    [anon_sym__alignof] = ACTIONS(2276),
    [anon_sym_alignof] = ACTIONS(2276),
    [anon_sym__Alignof] = ACTIONS(2276),
    [anon_sym_offsetof] = ACTIONS(2276),
    [anon_sym__Generic] = ACTIONS(2276),
    [anon_sym_asm] = ACTIONS(2276),
    [anon_sym___asm__] = ACTIONS(2276),
    [anon_sym___asm] = ACTIONS(2276),
    [anon_sym_DOT] = ACTIONS(2276),
    [anon_sym_DOT_STAR] = ACTIONS(2278),
    [anon_sym_DASH_GT] = ACTIONS(2278),
    [sym_number_literal] = ACTIONS(2278),
    [anon_sym_L_SQUOTE] = ACTIONS(2278),
    [anon_sym_u_SQUOTE] = ACTIONS(2278),
    [anon_sym_U_SQUOTE] = ACTIONS(2278),
    [anon_sym_u8_SQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_L_DQUOTE] = ACTIONS(2278),
    [anon_sym_u_DQUOTE] = ACTIONS(2278),
    [anon_sym_U_DQUOTE] = ACTIONS(2278),
    [anon_sym_u8_DQUOTE] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [sym_true] = ACTIONS(2276),
    [sym_false] = ACTIONS(2276),
    [anon_sym_NULL] = ACTIONS(2276),
    [anon_sym_nullptr] = ACTIONS(2276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_This] = ACTIONS(2276),
    [anon_sym_decltype] = ACTIONS(2276),
    [anon_sym_explicit] = ACTIONS(2276),
    [anon_sym_typename] = ACTIONS(2276),
    [anon_sym_export] = ACTIONS(2276),
    [anon_sym_module] = ACTIONS(2276),
    [anon_sym_import] = ACTIONS(2276),
    [anon_sym_template] = ACTIONS(2276),
    [anon_sym_operator] = ACTIONS(2276),
    [anon_sym_try] = ACTIONS(2276),
    [anon_sym_delete] = ACTIONS(2276),
    [anon_sym_throw] = ACTIONS(2276),
    [anon_sym_namespace] = ACTIONS(2276),
    [anon_sym_static_assert] = ACTIONS(2276),
    [anon_sym_concept] = ACTIONS(2276),
    [anon_sym_co_return] = ACTIONS(2276),
    [anon_sym_co_yield] = ACTIONS(2276),
    [anon_sym_R_DQUOTE] = ACTIONS(2278),
    [anon_sym_LR_DQUOTE] = ACTIONS(2278),
    [anon_sym_uR_DQUOTE] = ACTIONS(2278),
    [anon_sym_UR_DQUOTE] = ACTIONS(2278),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2278),
    [anon_sym_co_await] = ACTIONS(2276),
    [anon_sym_new] = ACTIONS(2276),
    [anon_sym_requires] = ACTIONS(2276),
    [sym_this] = ACTIONS(2276),
    [anon_sym_precise] = ACTIONS(2276),
    [anon_sym_shared] = ACTIONS(2276),
    [anon_sym_groupshared] = ACTIONS(2276),
    [anon_sym_uniform] = ACTIONS(2276),
    [anon_sym_row_major] = ACTIONS(2276),
    [anon_sym_column_major] = ACTIONS(2276),
    [anon_sym_globallycoherent] = ACTIONS(2276),
    [anon_sym_centroid] = ACTIONS(2276),
    [anon_sym_noperspective] = ACTIONS(2276),
    [anon_sym_nointerpolation] = ACTIONS(2276),
    [anon_sym_sample] = ACTIONS(2276),
    [anon_sym_linear] = ACTIONS(2276),
    [anon_sym_snorm] = ACTIONS(2276),
    [anon_sym_unorm] = ACTIONS(2276),
    [anon_sym_point] = ACTIONS(2276),
    [anon_sym_line] = ACTIONS(2276),
    [anon_sym_triangleadj] = ACTIONS(2276),
    [anon_sym_lineadj] = ACTIONS(2276),
    [anon_sym_triangle] = ACTIONS(2276),
    [anon_sym_interface] = ACTIONS(2276),
    [anon_sym_extension] = ACTIONS(2276),
    [anon_sym___exported] = ACTIONS(2276),
  },
  [135] = {
    [ts_builtin_sym_end] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2239),
    [aux_sym_preproc_include_token1] = ACTIONS(2239),
    [aux_sym_preproc_def_token1] = ACTIONS(2239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2241),
    [aux_sym_preproc_if_token1] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2239),
    [sym_preproc_directive] = ACTIONS(2239),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2239),
    [anon_sym_PLUS] = ACTIONS(2239),
    [anon_sym_STAR] = ACTIONS(2239),
    [anon_sym_SLASH] = ACTIONS(2239),
    [anon_sym_PERCENT] = ACTIONS(2239),
    [anon_sym_PIPE_PIPE] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_PIPE] = ACTIONS(2239),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_LT_EQ] = ACTIONS(2239),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_LT_LT] = ACTIONS(2239),
    [anon_sym_GT_GT] = ACTIONS(2239),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym_typedef] = ACTIONS(2239),
    [anon_sym_in] = ACTIONS(2239),
    [anon_sym_out] = ACTIONS(2239),
    [anon_sym_inout] = ACTIONS(2239),
    [anon_sym_virtual] = ACTIONS(2239),
    [anon_sym_extern] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym___attribute] = ACTIONS(2239),
    [anon_sym_using] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2241),
    [anon_sym___declspec] = ACTIONS(2239),
    [anon_sym___based] = ACTIONS(2239),
    [anon_sym___cdecl] = ACTIONS(2239),
    [anon_sym___clrcall] = ACTIONS(2239),
    [anon_sym___stdcall] = ACTIONS(2239),
    [anon_sym___fastcall] = ACTIONS(2239),
    [anon_sym___thiscall] = ACTIONS(2239),
    [anon_sym___vectorcall] = ACTIONS(2239),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_signed] = ACTIONS(2239),
    [anon_sym_unsigned] = ACTIONS(2239),
    [anon_sym_long] = ACTIONS(2239),
    [anon_sym_short] = ACTIONS(2239),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2239),
    [anon_sym_EQ] = ACTIONS(2239),
    [anon_sym_register] = ACTIONS(2239),
    [anon_sym_inline] = ACTIONS(2239),
    [anon_sym___inline] = ACTIONS(2239),
    [anon_sym___inline__] = ACTIONS(2239),
    [anon_sym___forceinline] = ACTIONS(2239),
    [anon_sym_thread_local] = ACTIONS(2239),
    [anon_sym___thread] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym__Nonnull] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [sym_primitive_type] = ACTIONS(2239),
    [anon_sym_enum] = ACTIONS(2239),
    [anon_sym_class] = ACTIONS(2239),
    [anon_sym_struct] = ACTIONS(2239),
    [anon_sym_union] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(2239),
    [anon_sym_switch] = ACTIONS(2239),
    [anon_sym_case] = ACTIONS(2239),
    [anon_sym_default] = ACTIONS(2239),
    [anon_sym_while] = ACTIONS(2239),
    [anon_sym_do] = ACTIONS(2239),
    [anon_sym_for] = ACTIONS(2239),
    [anon_sym_return] = ACTIONS(2239),
    [anon_sym_break] = ACTIONS(2239),
    [anon_sym_continue] = ACTIONS(2239),
    [anon_sym_goto] = ACTIONS(2239),
    [anon_sym_QMARK] = ACTIONS(2241),
    [anon_sym_STAR_EQ] = ACTIONS(2241),
    [anon_sym_SLASH_EQ] = ACTIONS(2241),
    [anon_sym_PERCENT_EQ] = ACTIONS(2241),
    [anon_sym_PLUS_EQ] = ACTIONS(2241),
    [anon_sym_DASH_EQ] = ACTIONS(2241),
    [anon_sym_LT_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_GT_EQ] = ACTIONS(2241),
    [anon_sym_AMP_EQ] = ACTIONS(2241),
    [anon_sym_CARET_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_EQ] = ACTIONS(2241),
    [anon_sym_and_eq] = ACTIONS(2239),
    [anon_sym_or_eq] = ACTIONS(2239),
    [anon_sym_xor_eq] = ACTIONS(2239),
    [anon_sym_not] = ACTIONS(2239),
    [anon_sym_compl] = ACTIONS(2239),
    [anon_sym_LT_EQ_GT] = ACTIONS(2241),
    [anon_sym_or] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(2239),
    [anon_sym_bitor] = ACTIONS(2239),
    [anon_sym_xor] = ACTIONS(2239),
    [anon_sym_bitand] = ACTIONS(2239),
    [anon_sym_not_eq] = ACTIONS(2239),
    [anon_sym_is] = ACTIONS(2239),
    [anon_sym_as] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_sizeof] = ACTIONS(2239),
    [anon_sym___alignof__] = ACTIONS(2239),
    [anon_sym___alignof] = ACTIONS(2239),
    [anon_sym__alignof] = ACTIONS(2239),
    [anon_sym_alignof] = ACTIONS(2239),
    [anon_sym__Alignof] = ACTIONS(2239),
    [anon_sym_offsetof] = ACTIONS(2239),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2239),
    [anon_sym___asm__] = ACTIONS(2239),
    [anon_sym___asm] = ACTIONS(2239),
    [anon_sym_DOT] = ACTIONS(2239),
    [anon_sym_DOT_STAR] = ACTIONS(2241),
    [anon_sym_DASH_GT] = ACTIONS(2241),
    [sym_number_literal] = ACTIONS(2241),
    [anon_sym_L_SQUOTE] = ACTIONS(2241),
    [anon_sym_u_SQUOTE] = ACTIONS(2241),
    [anon_sym_U_SQUOTE] = ACTIONS(2241),
    [anon_sym_u8_SQUOTE] = ACTIONS(2241),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_L_DQUOTE] = ACTIONS(2241),
    [anon_sym_u_DQUOTE] = ACTIONS(2241),
    [anon_sym_U_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8_DQUOTE] = ACTIONS(2241),
    [anon_sym_DQUOTE] = ACTIONS(2241),
    [sym_true] = ACTIONS(2239),
    [sym_false] = ACTIONS(2239),
    [anon_sym_NULL] = ACTIONS(2239),
    [anon_sym_nullptr] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2239),
    [anon_sym_let] = ACTIONS(2239),
    [anon_sym_This] = ACTIONS(2239),
    [anon_sym_decltype] = ACTIONS(2239),
    [anon_sym_explicit] = ACTIONS(2239),
    [anon_sym_typename] = ACTIONS(2239),
    [anon_sym_export] = ACTIONS(2239),
    [anon_sym_module] = ACTIONS(2239),
    [anon_sym_import] = ACTIONS(2239),
    [anon_sym_template] = ACTIONS(2239),
    [anon_sym_operator] = ACTIONS(2239),
    [anon_sym_try] = ACTIONS(2239),
    [anon_sym_delete] = ACTIONS(2239),
    [anon_sym_throw] = ACTIONS(2239),
    [anon_sym_namespace] = ACTIONS(2239),
    [anon_sym_static_assert] = ACTIONS(2239),
    [anon_sym_concept] = ACTIONS(2239),
    [anon_sym_co_return] = ACTIONS(2239),
    [anon_sym_co_yield] = ACTIONS(2239),
    [anon_sym_R_DQUOTE] = ACTIONS(2241),
    [anon_sym_LR_DQUOTE] = ACTIONS(2241),
    [anon_sym_uR_DQUOTE] = ACTIONS(2241),
    [anon_sym_UR_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2241),
    [anon_sym_co_await] = ACTIONS(2239),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_requires] = ACTIONS(2239),
    [sym_this] = ACTIONS(2239),
    [anon_sym_precise] = ACTIONS(2239),
    [anon_sym_shared] = ACTIONS(2239),
    [anon_sym_groupshared] = ACTIONS(2239),
    [anon_sym_uniform] = ACTIONS(2239),
    [anon_sym_row_major] = ACTIONS(2239),
    [anon_sym_column_major] = ACTIONS(2239),
    [anon_sym_globallycoherent] = ACTIONS(2239),
    [anon_sym_centroid] = ACTIONS(2239),
    [anon_sym_noperspective] = ACTIONS(2239),
    [anon_sym_nointerpolation] = ACTIONS(2239),
    [anon_sym_sample] = ACTIONS(2239),
    [anon_sym_linear] = ACTIONS(2239),
    [anon_sym_snorm] = ACTIONS(2239),
    [anon_sym_unorm] = ACTIONS(2239),
    [anon_sym_point] = ACTIONS(2239),
    [anon_sym_line] = ACTIONS(2239),
    [anon_sym_triangleadj] = ACTIONS(2239),
    [anon_sym_lineadj] = ACTIONS(2239),
    [anon_sym_triangle] = ACTIONS(2239),
    [anon_sym_interface] = ACTIONS(2239),
    [anon_sym_extension] = ACTIONS(2239),
    [anon_sym___exported] = ACTIONS(2239),
  },
  [136] = {
    [ts_builtin_sym_end] = ACTIONS(2282),
    [sym_identifier] = ACTIONS(2280),
    [aux_sym_preproc_include_token1] = ACTIONS(2280),
    [aux_sym_preproc_def_token1] = ACTIONS(2280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [aux_sym_preproc_if_token1] = ACTIONS(2280),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2280),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2280),
    [sym_preproc_directive] = ACTIONS(2280),
    [anon_sym_LPAREN2] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2282),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2280),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_PERCENT] = ACTIONS(2280),
    [anon_sym_PIPE_PIPE] = ACTIONS(2282),
    [anon_sym_AMP_AMP] = ACTIONS(2282),
    [anon_sym_PIPE] = ACTIONS(2280),
    [anon_sym_CARET] = ACTIONS(2280),
    [anon_sym_AMP] = ACTIONS(2280),
    [anon_sym_EQ_EQ] = ACTIONS(2282),
    [anon_sym_BANG_EQ] = ACTIONS(2282),
    [anon_sym_GT] = ACTIONS(2280),
    [anon_sym_GT_EQ] = ACTIONS(2282),
    [anon_sym_LT_EQ] = ACTIONS(2280),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_LT_LT] = ACTIONS(2280),
    [anon_sym_GT_GT] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(2280),
    [anon_sym_typedef] = ACTIONS(2280),
    [anon_sym_in] = ACTIONS(2280),
    [anon_sym_out] = ACTIONS(2280),
    [anon_sym_inout] = ACTIONS(2280),
    [anon_sym_virtual] = ACTIONS(2280),
    [anon_sym_extern] = ACTIONS(2280),
    [anon_sym___attribute__] = ACTIONS(2280),
    [anon_sym___attribute] = ACTIONS(2280),
    [anon_sym_using] = ACTIONS(2280),
    [anon_sym_COLON_COLON] = ACTIONS(2282),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2282),
    [anon_sym___declspec] = ACTIONS(2280),
    [anon_sym___based] = ACTIONS(2280),
    [anon_sym___cdecl] = ACTIONS(2280),
    [anon_sym___clrcall] = ACTIONS(2280),
    [anon_sym___stdcall] = ACTIONS(2280),
    [anon_sym___fastcall] = ACTIONS(2280),
    [anon_sym___thiscall] = ACTIONS(2280),
    [anon_sym___vectorcall] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_signed] = ACTIONS(2280),
    [anon_sym_unsigned] = ACTIONS(2280),
    [anon_sym_long] = ACTIONS(2280),
    [anon_sym_short] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_EQ] = ACTIONS(2280),
    [anon_sym_register] = ACTIONS(2280),
    [anon_sym_inline] = ACTIONS(2280),
    [anon_sym___inline] = ACTIONS(2280),
    [anon_sym___inline__] = ACTIONS(2280),
    [anon_sym___forceinline] = ACTIONS(2280),
    [anon_sym_thread_local] = ACTIONS(2280),
    [anon_sym___thread] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_constexpr] = ACTIONS(2280),
    [anon_sym_volatile] = ACTIONS(2280),
    [anon_sym_restrict] = ACTIONS(2280),
    [anon_sym___restrict__] = ACTIONS(2280),
    [anon_sym__Atomic] = ACTIONS(2280),
    [anon_sym__Noreturn] = ACTIONS(2280),
    [anon_sym_noreturn] = ACTIONS(2280),
    [anon_sym__Nonnull] = ACTIONS(2280),
    [anon_sym_mutable] = ACTIONS(2280),
    [anon_sym_constinit] = ACTIONS(2280),
    [anon_sym_consteval] = ACTIONS(2280),
    [anon_sym_alignas] = ACTIONS(2280),
    [anon_sym__Alignas] = ACTIONS(2280),
    [sym_primitive_type] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_struct] = ACTIONS(2280),
    [anon_sym_union] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_goto] = ACTIONS(2280),
    [anon_sym_QMARK] = ACTIONS(2282),
    [anon_sym_STAR_EQ] = ACTIONS(2282),
    [anon_sym_SLASH_EQ] = ACTIONS(2282),
    [anon_sym_PERCENT_EQ] = ACTIONS(2282),
    [anon_sym_PLUS_EQ] = ACTIONS(2282),
    [anon_sym_DASH_EQ] = ACTIONS(2282),
    [anon_sym_LT_LT_EQ] = ACTIONS(2282),
    [anon_sym_GT_GT_EQ] = ACTIONS(2282),
    [anon_sym_AMP_EQ] = ACTIONS(2282),
    [anon_sym_CARET_EQ] = ACTIONS(2282),
    [anon_sym_PIPE_EQ] = ACTIONS(2282),
    [anon_sym_and_eq] = ACTIONS(2280),
    [anon_sym_or_eq] = ACTIONS(2280),
    [anon_sym_xor_eq] = ACTIONS(2280),
    [anon_sym_not] = ACTIONS(2280),
    [anon_sym_compl] = ACTIONS(2280),
    [anon_sym_LT_EQ_GT] = ACTIONS(2282),
    [anon_sym_or] = ACTIONS(2280),
    [anon_sym_and] = ACTIONS(2280),
    [anon_sym_bitor] = ACTIONS(2280),
    [anon_sym_xor] = ACTIONS(2280),
    [anon_sym_bitand] = ACTIONS(2280),
    [anon_sym_not_eq] = ACTIONS(2280),
    [anon_sym_is] = ACTIONS(2280),
    [anon_sym_as] = ACTIONS(2280),
    [anon_sym_DASH_DASH] = ACTIONS(2282),
    [anon_sym_PLUS_PLUS] = ACTIONS(2282),
    [anon_sym_sizeof] = ACTIONS(2280),
    [anon_sym___alignof__] = ACTIONS(2280),
    [anon_sym___alignof] = ACTIONS(2280),
    [anon_sym__alignof] = ACTIONS(2280),
    [anon_sym_alignof] = ACTIONS(2280),
    [anon_sym__Alignof] = ACTIONS(2280),
    [anon_sym_offsetof] = ACTIONS(2280),
    [anon_sym__Generic] = ACTIONS(2280),
    [anon_sym_asm] = ACTIONS(2280),
    [anon_sym___asm__] = ACTIONS(2280),
    [anon_sym___asm] = ACTIONS(2280),
    [anon_sym_DOT] = ACTIONS(2280),
    [anon_sym_DOT_STAR] = ACTIONS(2282),
    [anon_sym_DASH_GT] = ACTIONS(2282),
    [sym_number_literal] = ACTIONS(2282),
    [anon_sym_L_SQUOTE] = ACTIONS(2282),
    [anon_sym_u_SQUOTE] = ACTIONS(2282),
    [anon_sym_U_SQUOTE] = ACTIONS(2282),
    [anon_sym_u8_SQUOTE] = ACTIONS(2282),
    [anon_sym_SQUOTE] = ACTIONS(2282),
    [anon_sym_L_DQUOTE] = ACTIONS(2282),
    [anon_sym_u_DQUOTE] = ACTIONS(2282),
    [anon_sym_U_DQUOTE] = ACTIONS(2282),
    [anon_sym_u8_DQUOTE] = ACTIONS(2282),
    [anon_sym_DQUOTE] = ACTIONS(2282),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [anon_sym_NULL] = ACTIONS(2280),
    [anon_sym_nullptr] = ACTIONS(2280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_This] = ACTIONS(2280),
    [anon_sym_decltype] = ACTIONS(2280),
    [anon_sym_explicit] = ACTIONS(2280),
    [anon_sym_typename] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_template] = ACTIONS(2280),
    [anon_sym_operator] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_static_assert] = ACTIONS(2280),
    [anon_sym_concept] = ACTIONS(2280),
    [anon_sym_co_return] = ACTIONS(2280),
    [anon_sym_co_yield] = ACTIONS(2280),
    [anon_sym_R_DQUOTE] = ACTIONS(2282),
    [anon_sym_LR_DQUOTE] = ACTIONS(2282),
    [anon_sym_uR_DQUOTE] = ACTIONS(2282),
    [anon_sym_UR_DQUOTE] = ACTIONS(2282),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2282),
    [anon_sym_co_await] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_requires] = ACTIONS(2280),
    [sym_this] = ACTIONS(2280),
    [anon_sym_precise] = ACTIONS(2280),
    [anon_sym_shared] = ACTIONS(2280),
    [anon_sym_groupshared] = ACTIONS(2280),
    [anon_sym_uniform] = ACTIONS(2280),
    [anon_sym_row_major] = ACTIONS(2280),
    [anon_sym_column_major] = ACTIONS(2280),
    [anon_sym_globallycoherent] = ACTIONS(2280),
    [anon_sym_centroid] = ACTIONS(2280),
    [anon_sym_noperspective] = ACTIONS(2280),
    [anon_sym_nointerpolation] = ACTIONS(2280),
    [anon_sym_sample] = ACTIONS(2280),
    [anon_sym_linear] = ACTIONS(2280),
    [anon_sym_snorm] = ACTIONS(2280),
    [anon_sym_unorm] = ACTIONS(2280),
    [anon_sym_point] = ACTIONS(2280),
    [anon_sym_line] = ACTIONS(2280),
    [anon_sym_triangleadj] = ACTIONS(2280),
    [anon_sym_lineadj] = ACTIONS(2280),
    [anon_sym_triangle] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_extension] = ACTIONS(2280),
    [anon_sym___exported] = ACTIONS(2280),
  },
  [137] = {
    [ts_builtin_sym_end] = ACTIONS(2286),
    [sym_identifier] = ACTIONS(2284),
    [aux_sym_preproc_include_token1] = ACTIONS(2284),
    [aux_sym_preproc_def_token1] = ACTIONS(2284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2286),
    [aux_sym_preproc_if_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2284),
    [sym_preproc_directive] = ACTIONS(2284),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2284),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2284),
    [anon_sym_SLASH] = ACTIONS(2284),
    [anon_sym_PERCENT] = ACTIONS(2284),
    [anon_sym_PIPE_PIPE] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2284),
    [anon_sym_CARET] = ACTIONS(2284),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_EQ_EQ] = ACTIONS(2286),
    [anon_sym_BANG_EQ] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2284),
    [anon_sym_GT_EQ] = ACTIONS(2286),
    [anon_sym_LT_EQ] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2284),
    [anon_sym_LT_LT] = ACTIONS(2284),
    [anon_sym_GT_GT] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_typedef] = ACTIONS(2284),
    [anon_sym_in] = ACTIONS(2284),
    [anon_sym_out] = ACTIONS(2284),
    [anon_sym_inout] = ACTIONS(2284),
    [anon_sym_virtual] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_using] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym___cdecl] = ACTIONS(2284),
    [anon_sym___clrcall] = ACTIONS(2284),
    [anon_sym___stdcall] = ACTIONS(2284),
    [anon_sym___fastcall] = ACTIONS(2284),
    [anon_sym___thiscall] = ACTIONS(2284),
    [anon_sym___vectorcall] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_signed] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_EQ] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_switch] = ACTIONS(2284),
    [anon_sym_case] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_goto] = ACTIONS(2284),
    [anon_sym_QMARK] = ACTIONS(2286),
    [anon_sym_STAR_EQ] = ACTIONS(2286),
    [anon_sym_SLASH_EQ] = ACTIONS(2286),
    [anon_sym_PERCENT_EQ] = ACTIONS(2286),
    [anon_sym_PLUS_EQ] = ACTIONS(2286),
    [anon_sym_DASH_EQ] = ACTIONS(2286),
    [anon_sym_LT_LT_EQ] = ACTIONS(2286),
    [anon_sym_GT_GT_EQ] = ACTIONS(2286),
    [anon_sym_AMP_EQ] = ACTIONS(2286),
    [anon_sym_CARET_EQ] = ACTIONS(2286),
    [anon_sym_PIPE_EQ] = ACTIONS(2286),
    [anon_sym_and_eq] = ACTIONS(2284),
    [anon_sym_or_eq] = ACTIONS(2284),
    [anon_sym_xor_eq] = ACTIONS(2284),
    [anon_sym_not] = ACTIONS(2284),
    [anon_sym_compl] = ACTIONS(2284),
    [anon_sym_LT_EQ_GT] = ACTIONS(2286),
    [anon_sym_or] = ACTIONS(2284),
    [anon_sym_and] = ACTIONS(2284),
    [anon_sym_bitor] = ACTIONS(2284),
    [anon_sym_xor] = ACTIONS(2284),
    [anon_sym_bitand] = ACTIONS(2284),
    [anon_sym_not_eq] = ACTIONS(2284),
    [anon_sym_is] = ACTIONS(2284),
    [anon_sym_as] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_sizeof] = ACTIONS(2284),
    [anon_sym___alignof__] = ACTIONS(2284),
    [anon_sym___alignof] = ACTIONS(2284),
    [anon_sym__alignof] = ACTIONS(2284),
    [anon_sym_alignof] = ACTIONS(2284),
    [anon_sym__Alignof] = ACTIONS(2284),
    [anon_sym_offsetof] = ACTIONS(2284),
    [anon_sym__Generic] = ACTIONS(2284),
    [anon_sym_asm] = ACTIONS(2284),
    [anon_sym___asm__] = ACTIONS(2284),
    [anon_sym___asm] = ACTIONS(2284),
    [anon_sym_DOT] = ACTIONS(2284),
    [anon_sym_DOT_STAR] = ACTIONS(2286),
    [anon_sym_DASH_GT] = ACTIONS(2286),
    [sym_number_literal] = ACTIONS(2286),
    [anon_sym_L_SQUOTE] = ACTIONS(2286),
    [anon_sym_u_SQUOTE] = ACTIONS(2286),
    [anon_sym_U_SQUOTE] = ACTIONS(2286),
    [anon_sym_u8_SQUOTE] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_L_DQUOTE] = ACTIONS(2286),
    [anon_sym_u_DQUOTE] = ACTIONS(2286),
    [anon_sym_U_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8_DQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [sym_true] = ACTIONS(2284),
    [sym_false] = ACTIONS(2284),
    [anon_sym_NULL] = ACTIONS(2284),
    [anon_sym_nullptr] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_This] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_typename] = ACTIONS(2284),
    [anon_sym_export] = ACTIONS(2284),
    [anon_sym_module] = ACTIONS(2284),
    [anon_sym_import] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_delete] = ACTIONS(2284),
    [anon_sym_throw] = ACTIONS(2284),
    [anon_sym_namespace] = ACTIONS(2284),
    [anon_sym_static_assert] = ACTIONS(2284),
    [anon_sym_concept] = ACTIONS(2284),
    [anon_sym_co_return] = ACTIONS(2284),
    [anon_sym_co_yield] = ACTIONS(2284),
    [anon_sym_R_DQUOTE] = ACTIONS(2286),
    [anon_sym_LR_DQUOTE] = ACTIONS(2286),
    [anon_sym_uR_DQUOTE] = ACTIONS(2286),
    [anon_sym_UR_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2286),
    [anon_sym_co_await] = ACTIONS(2284),
    [anon_sym_new] = ACTIONS(2284),
    [anon_sym_requires] = ACTIONS(2284),
    [sym_this] = ACTIONS(2284),
    [anon_sym_precise] = ACTIONS(2284),
    [anon_sym_shared] = ACTIONS(2284),
    [anon_sym_groupshared] = ACTIONS(2284),
    [anon_sym_uniform] = ACTIONS(2284),
    [anon_sym_row_major] = ACTIONS(2284),
    [anon_sym_column_major] = ACTIONS(2284),
    [anon_sym_globallycoherent] = ACTIONS(2284),
    [anon_sym_centroid] = ACTIONS(2284),
    [anon_sym_noperspective] = ACTIONS(2284),
    [anon_sym_nointerpolation] = ACTIONS(2284),
    [anon_sym_sample] = ACTIONS(2284),
    [anon_sym_linear] = ACTIONS(2284),
    [anon_sym_snorm] = ACTIONS(2284),
    [anon_sym_unorm] = ACTIONS(2284),
    [anon_sym_point] = ACTIONS(2284),
    [anon_sym_line] = ACTIONS(2284),
    [anon_sym_triangleadj] = ACTIONS(2284),
    [anon_sym_lineadj] = ACTIONS(2284),
    [anon_sym_triangle] = ACTIONS(2284),
    [anon_sym_interface] = ACTIONS(2284),
    [anon_sym_extension] = ACTIONS(2284),
    [anon_sym___exported] = ACTIONS(2284),
  },
  [138] = {
    [ts_builtin_sym_end] = ACTIONS(2290),
    [sym_identifier] = ACTIONS(2288),
    [aux_sym_preproc_include_token1] = ACTIONS(2288),
    [aux_sym_preproc_def_token1] = ACTIONS(2288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2290),
    [aux_sym_preproc_if_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_PERCENT] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_CARET] = ACTIONS(2288),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_EQ_EQ] = ACTIONS(2290),
    [anon_sym_BANG_EQ] = ACTIONS(2290),
    [anon_sym_GT] = ACTIONS(2288),
    [anon_sym_GT_EQ] = ACTIONS(2290),
    [anon_sym_LT_EQ] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(2288),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_out] = ACTIONS(2288),
    [anon_sym_inout] = ACTIONS(2288),
    [anon_sym_virtual] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym___cdecl] = ACTIONS(2288),
    [anon_sym___clrcall] = ACTIONS(2288),
    [anon_sym___stdcall] = ACTIONS(2288),
    [anon_sym___fastcall] = ACTIONS(2288),
    [anon_sym___thiscall] = ACTIONS(2288),
    [anon_sym___vectorcall] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_signed] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_EQ] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym_QMARK] = ACTIONS(2290),
    [anon_sym_STAR_EQ] = ACTIONS(2290),
    [anon_sym_SLASH_EQ] = ACTIONS(2290),
    [anon_sym_PERCENT_EQ] = ACTIONS(2290),
    [anon_sym_PLUS_EQ] = ACTIONS(2290),
    [anon_sym_DASH_EQ] = ACTIONS(2290),
    [anon_sym_LT_LT_EQ] = ACTIONS(2290),
    [anon_sym_GT_GT_EQ] = ACTIONS(2290),
    [anon_sym_AMP_EQ] = ACTIONS(2290),
    [anon_sym_CARET_EQ] = ACTIONS(2290),
    [anon_sym_PIPE_EQ] = ACTIONS(2290),
    [anon_sym_and_eq] = ACTIONS(2288),
    [anon_sym_or_eq] = ACTIONS(2288),
    [anon_sym_xor_eq] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2288),
    [anon_sym_compl] = ACTIONS(2288),
    [anon_sym_LT_EQ_GT] = ACTIONS(2290),
    [anon_sym_or] = ACTIONS(2288),
    [anon_sym_and] = ACTIONS(2288),
    [anon_sym_bitor] = ACTIONS(2288),
    [anon_sym_xor] = ACTIONS(2288),
    [anon_sym_bitand] = ACTIONS(2288),
    [anon_sym_not_eq] = ACTIONS(2288),
    [anon_sym_is] = ACTIONS(2288),
    [anon_sym_as] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_sizeof] = ACTIONS(2288),
    [anon_sym___alignof__] = ACTIONS(2288),
    [anon_sym___alignof] = ACTIONS(2288),
    [anon_sym__alignof] = ACTIONS(2288),
    [anon_sym_alignof] = ACTIONS(2288),
    [anon_sym__Alignof] = ACTIONS(2288),
    [anon_sym_offsetof] = ACTIONS(2288),
    [anon_sym__Generic] = ACTIONS(2288),
    [anon_sym_asm] = ACTIONS(2288),
    [anon_sym___asm__] = ACTIONS(2288),
    [anon_sym___asm] = ACTIONS(2288),
    [anon_sym_DOT] = ACTIONS(2288),
    [anon_sym_DOT_STAR] = ACTIONS(2290),
    [anon_sym_DASH_GT] = ACTIONS(2290),
    [sym_number_literal] = ACTIONS(2290),
    [anon_sym_L_SQUOTE] = ACTIONS(2290),
    [anon_sym_u_SQUOTE] = ACTIONS(2290),
    [anon_sym_U_SQUOTE] = ACTIONS(2290),
    [anon_sym_u8_SQUOTE] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [anon_sym_L_DQUOTE] = ACTIONS(2290),
    [anon_sym_u_DQUOTE] = ACTIONS(2290),
    [anon_sym_U_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8_DQUOTE] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [anon_sym_NULL] = ACTIONS(2288),
    [anon_sym_nullptr] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_This] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_static_assert] = ACTIONS(2288),
    [anon_sym_concept] = ACTIONS(2288),
    [anon_sym_co_return] = ACTIONS(2288),
    [anon_sym_co_yield] = ACTIONS(2288),
    [anon_sym_R_DQUOTE] = ACTIONS(2290),
    [anon_sym_LR_DQUOTE] = ACTIONS(2290),
    [anon_sym_uR_DQUOTE] = ACTIONS(2290),
    [anon_sym_UR_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2290),
    [anon_sym_co_await] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_requires] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [anon_sym_precise] = ACTIONS(2288),
    [anon_sym_shared] = ACTIONS(2288),
    [anon_sym_groupshared] = ACTIONS(2288),
    [anon_sym_uniform] = ACTIONS(2288),
    [anon_sym_row_major] = ACTIONS(2288),
    [anon_sym_column_major] = ACTIONS(2288),
    [anon_sym_globallycoherent] = ACTIONS(2288),
    [anon_sym_centroid] = ACTIONS(2288),
    [anon_sym_noperspective] = ACTIONS(2288),
    [anon_sym_nointerpolation] = ACTIONS(2288),
    [anon_sym_sample] = ACTIONS(2288),
    [anon_sym_linear] = ACTIONS(2288),
    [anon_sym_snorm] = ACTIONS(2288),
    [anon_sym_unorm] = ACTIONS(2288),
    [anon_sym_point] = ACTIONS(2288),
    [anon_sym_line] = ACTIONS(2288),
    [anon_sym_triangleadj] = ACTIONS(2288),
    [anon_sym_lineadj] = ACTIONS(2288),
    [anon_sym_triangle] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_extension] = ACTIONS(2288),
    [anon_sym___exported] = ACTIONS(2288),
  },
  [139] = {
    [ts_builtin_sym_end] = ACTIONS(2294),
    [sym_identifier] = ACTIONS(2292),
    [aux_sym_preproc_include_token1] = ACTIONS(2292),
    [aux_sym_preproc_def_token1] = ACTIONS(2292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2294),
    [aux_sym_preproc_if_token1] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2292),
    [sym_preproc_directive] = ACTIONS(2292),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_BANG] = ACTIONS(2292),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2292),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_PERCENT] = ACTIONS(2292),
    [anon_sym_PIPE_PIPE] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_PIPE] = ACTIONS(2292),
    [anon_sym_CARET] = ACTIONS(2292),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_EQ_EQ] = ACTIONS(2294),
    [anon_sym_BANG_EQ] = ACTIONS(2294),
    [anon_sym_GT] = ACTIONS(2292),
    [anon_sym_GT_EQ] = ACTIONS(2294),
    [anon_sym_LT_EQ] = ACTIONS(2292),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_LT_LT] = ACTIONS(2292),
    [anon_sym_GT_GT] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym_typedef] = ACTIONS(2292),
    [anon_sym_in] = ACTIONS(2292),
    [anon_sym_out] = ACTIONS(2292),
    [anon_sym_inout] = ACTIONS(2292),
    [anon_sym_virtual] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym___attribute] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2294),
    [anon_sym___declspec] = ACTIONS(2292),
    [anon_sym___based] = ACTIONS(2292),
    [anon_sym___cdecl] = ACTIONS(2292),
    [anon_sym___clrcall] = ACTIONS(2292),
    [anon_sym___stdcall] = ACTIONS(2292),
    [anon_sym___fastcall] = ACTIONS(2292),
    [anon_sym___thiscall] = ACTIONS(2292),
    [anon_sym___vectorcall] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_signed] = ACTIONS(2292),
    [anon_sym_unsigned] = ACTIONS(2292),
    [anon_sym_long] = ACTIONS(2292),
    [anon_sym_short] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_EQ] = ACTIONS(2292),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym___inline] = ACTIONS(2292),
    [anon_sym___inline__] = ACTIONS(2292),
    [anon_sym___forceinline] = ACTIONS(2292),
    [anon_sym_thread_local] = ACTIONS(2292),
    [anon_sym___thread] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym__Nonnull] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [sym_primitive_type] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_struct] = ACTIONS(2292),
    [anon_sym_union] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_case] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_goto] = ACTIONS(2292),
    [anon_sym_QMARK] = ACTIONS(2294),
    [anon_sym_STAR_EQ] = ACTIONS(2294),
    [anon_sym_SLASH_EQ] = ACTIONS(2294),
    [anon_sym_PERCENT_EQ] = ACTIONS(2294),
    [anon_sym_PLUS_EQ] = ACTIONS(2294),
    [anon_sym_DASH_EQ] = ACTIONS(2294),
    [anon_sym_LT_LT_EQ] = ACTIONS(2294),
    [anon_sym_GT_GT_EQ] = ACTIONS(2294),
    [anon_sym_AMP_EQ] = ACTIONS(2294),
    [anon_sym_CARET_EQ] = ACTIONS(2294),
    [anon_sym_PIPE_EQ] = ACTIONS(2294),
    [anon_sym_and_eq] = ACTIONS(2292),
    [anon_sym_or_eq] = ACTIONS(2292),
    [anon_sym_xor_eq] = ACTIONS(2292),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_compl] = ACTIONS(2292),
    [anon_sym_LT_EQ_GT] = ACTIONS(2294),
    [anon_sym_or] = ACTIONS(2292),
    [anon_sym_and] = ACTIONS(2292),
    [anon_sym_bitor] = ACTIONS(2292),
    [anon_sym_xor] = ACTIONS(2292),
    [anon_sym_bitand] = ACTIONS(2292),
    [anon_sym_not_eq] = ACTIONS(2292),
    [anon_sym_is] = ACTIONS(2292),
    [anon_sym_as] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_sizeof] = ACTIONS(2292),
    [anon_sym___alignof__] = ACTIONS(2292),
    [anon_sym___alignof] = ACTIONS(2292),
    [anon_sym__alignof] = ACTIONS(2292),
    [anon_sym_alignof] = ACTIONS(2292),
    [anon_sym__Alignof] = ACTIONS(2292),
    [anon_sym_offsetof] = ACTIONS(2292),
    [anon_sym__Generic] = ACTIONS(2292),
    [anon_sym_asm] = ACTIONS(2292),
    [anon_sym___asm__] = ACTIONS(2292),
    [anon_sym___asm] = ACTIONS(2292),
    [anon_sym_DOT] = ACTIONS(2292),
    [anon_sym_DOT_STAR] = ACTIONS(2294),
    [anon_sym_DASH_GT] = ACTIONS(2294),
    [sym_number_literal] = ACTIONS(2294),
    [anon_sym_L_SQUOTE] = ACTIONS(2294),
    [anon_sym_u_SQUOTE] = ACTIONS(2294),
    [anon_sym_U_SQUOTE] = ACTIONS(2294),
    [anon_sym_u8_SQUOTE] = ACTIONS(2294),
    [anon_sym_SQUOTE] = ACTIONS(2294),
    [anon_sym_L_DQUOTE] = ACTIONS(2294),
    [anon_sym_u_DQUOTE] = ACTIONS(2294),
    [anon_sym_U_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8_DQUOTE] = ACTIONS(2294),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [anon_sym_NULL] = ACTIONS(2292),
    [anon_sym_nullptr] = ACTIONS(2292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_This] = ACTIONS(2292),
    [anon_sym_decltype] = ACTIONS(2292),
    [anon_sym_explicit] = ACTIONS(2292),
    [anon_sym_typename] = ACTIONS(2292),
    [anon_sym_export] = ACTIONS(2292),
    [anon_sym_module] = ACTIONS(2292),
    [anon_sym_import] = ACTIONS(2292),
    [anon_sym_template] = ACTIONS(2292),
    [anon_sym_operator] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_static_assert] = ACTIONS(2292),
    [anon_sym_concept] = ACTIONS(2292),
    [anon_sym_co_return] = ACTIONS(2292),
    [anon_sym_co_yield] = ACTIONS(2292),
    [anon_sym_R_DQUOTE] = ACTIONS(2294),
    [anon_sym_LR_DQUOTE] = ACTIONS(2294),
    [anon_sym_uR_DQUOTE] = ACTIONS(2294),
    [anon_sym_UR_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2294),
    [anon_sym_co_await] = ACTIONS(2292),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_requires] = ACTIONS(2292),
    [sym_this] = ACTIONS(2292),
    [anon_sym_precise] = ACTIONS(2292),
    [anon_sym_shared] = ACTIONS(2292),
    [anon_sym_groupshared] = ACTIONS(2292),
    [anon_sym_uniform] = ACTIONS(2292),
    [anon_sym_row_major] = ACTIONS(2292),
    [anon_sym_column_major] = ACTIONS(2292),
    [anon_sym_globallycoherent] = ACTIONS(2292),
    [anon_sym_centroid] = ACTIONS(2292),
    [anon_sym_noperspective] = ACTIONS(2292),
    [anon_sym_nointerpolation] = ACTIONS(2292),
    [anon_sym_sample] = ACTIONS(2292),
    [anon_sym_linear] = ACTIONS(2292),
    [anon_sym_snorm] = ACTIONS(2292),
    [anon_sym_unorm] = ACTIONS(2292),
    [anon_sym_point] = ACTIONS(2292),
    [anon_sym_line] = ACTIONS(2292),
    [anon_sym_triangleadj] = ACTIONS(2292),
    [anon_sym_lineadj] = ACTIONS(2292),
    [anon_sym_triangle] = ACTIONS(2292),
    [anon_sym_interface] = ACTIONS(2292),
    [anon_sym_extension] = ACTIONS(2292),
    [anon_sym___exported] = ACTIONS(2292),
  },
  [140] = {
    [ts_builtin_sym_end] = ACTIONS(2298),
    [sym_identifier] = ACTIONS(2296),
    [aux_sym_preproc_include_token1] = ACTIONS(2296),
    [aux_sym_preproc_def_token1] = ACTIONS(2296),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2298),
    [aux_sym_preproc_if_token1] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2296),
    [sym_preproc_directive] = ACTIONS(2296),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2296),
    [anon_sym_SLASH] = ACTIONS(2296),
    [anon_sym_PERCENT] = ACTIONS(2296),
    [anon_sym_PIPE_PIPE] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_PIPE] = ACTIONS(2296),
    [anon_sym_CARET] = ACTIONS(2296),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_EQ_EQ] = ACTIONS(2298),
    [anon_sym_BANG_EQ] = ACTIONS(2298),
    [anon_sym_GT] = ACTIONS(2296),
    [anon_sym_GT_EQ] = ACTIONS(2298),
    [anon_sym_LT_EQ] = ACTIONS(2296),
    [anon_sym_LT] = ACTIONS(2296),
    [anon_sym_LT_LT] = ACTIONS(2296),
    [anon_sym_GT_GT] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2298),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym_typedef] = ACTIONS(2296),
    [anon_sym_in] = ACTIONS(2296),
    [anon_sym_out] = ACTIONS(2296),
    [anon_sym_inout] = ACTIONS(2296),
    [anon_sym_virtual] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym___attribute] = ACTIONS(2296),
    [anon_sym_using] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2298),
    [anon_sym___declspec] = ACTIONS(2296),
    [anon_sym___based] = ACTIONS(2296),
    [anon_sym___cdecl] = ACTIONS(2296),
    [anon_sym___clrcall] = ACTIONS(2296),
    [anon_sym___stdcall] = ACTIONS(2296),
    [anon_sym___fastcall] = ACTIONS(2296),
    [anon_sym___thiscall] = ACTIONS(2296),
    [anon_sym___vectorcall] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_signed] = ACTIONS(2296),
    [anon_sym_unsigned] = ACTIONS(2296),
    [anon_sym_long] = ACTIONS(2296),
    [anon_sym_short] = ACTIONS(2296),
    [anon_sym_LBRACK] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_EQ] = ACTIONS(2296),
    [anon_sym_register] = ACTIONS(2296),
    [anon_sym_inline] = ACTIONS(2296),
    [anon_sym___inline] = ACTIONS(2296),
    [anon_sym___inline__] = ACTIONS(2296),
    [anon_sym___forceinline] = ACTIONS(2296),
    [anon_sym_thread_local] = ACTIONS(2296),
    [anon_sym___thread] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym__Nonnull] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [sym_primitive_type] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2296),
    [anon_sym_class] = ACTIONS(2296),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_union] = ACTIONS(2296),
    [anon_sym_if] = ACTIONS(2296),
    [anon_sym_switch] = ACTIONS(2296),
    [anon_sym_case] = ACTIONS(2296),
    [anon_sym_default] = ACTIONS(2296),
    [anon_sym_while] = ACTIONS(2296),
    [anon_sym_do] = ACTIONS(2296),
    [anon_sym_for] = ACTIONS(2296),
    [anon_sym_return] = ACTIONS(2296),
    [anon_sym_break] = ACTIONS(2296),
    [anon_sym_continue] = ACTIONS(2296),
    [anon_sym_goto] = ACTIONS(2296),
    [anon_sym_QMARK] = ACTIONS(2298),
    [anon_sym_STAR_EQ] = ACTIONS(2298),
    [anon_sym_SLASH_EQ] = ACTIONS(2298),
    [anon_sym_PERCENT_EQ] = ACTIONS(2298),
    [anon_sym_PLUS_EQ] = ACTIONS(2298),
    [anon_sym_DASH_EQ] = ACTIONS(2298),
    [anon_sym_LT_LT_EQ] = ACTIONS(2298),
    [anon_sym_GT_GT_EQ] = ACTIONS(2298),
    [anon_sym_AMP_EQ] = ACTIONS(2298),
    [anon_sym_CARET_EQ] = ACTIONS(2298),
    [anon_sym_PIPE_EQ] = ACTIONS(2298),
    [anon_sym_and_eq] = ACTIONS(2296),
    [anon_sym_or_eq] = ACTIONS(2296),
    [anon_sym_xor_eq] = ACTIONS(2296),
    [anon_sym_not] = ACTIONS(2296),
    [anon_sym_compl] = ACTIONS(2296),
    [anon_sym_LT_EQ_GT] = ACTIONS(2298),
    [anon_sym_or] = ACTIONS(2296),
    [anon_sym_and] = ACTIONS(2296),
    [anon_sym_bitor] = ACTIONS(2296),
    [anon_sym_xor] = ACTIONS(2296),
    [anon_sym_bitand] = ACTIONS(2296),
    [anon_sym_not_eq] = ACTIONS(2296),
    [anon_sym_is] = ACTIONS(2296),
    [anon_sym_as] = ACTIONS(2296),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_sizeof] = ACTIONS(2296),
    [anon_sym___alignof__] = ACTIONS(2296),
    [anon_sym___alignof] = ACTIONS(2296),
    [anon_sym__alignof] = ACTIONS(2296),
    [anon_sym_alignof] = ACTIONS(2296),
    [anon_sym__Alignof] = ACTIONS(2296),
    [anon_sym_offsetof] = ACTIONS(2296),
    [anon_sym__Generic] = ACTIONS(2296),
    [anon_sym_asm] = ACTIONS(2296),
    [anon_sym___asm__] = ACTIONS(2296),
    [anon_sym___asm] = ACTIONS(2296),
    [anon_sym_DOT] = ACTIONS(2296),
    [anon_sym_DOT_STAR] = ACTIONS(2298),
    [anon_sym_DASH_GT] = ACTIONS(2298),
    [sym_number_literal] = ACTIONS(2298),
    [anon_sym_L_SQUOTE] = ACTIONS(2298),
    [anon_sym_u_SQUOTE] = ACTIONS(2298),
    [anon_sym_U_SQUOTE] = ACTIONS(2298),
    [anon_sym_u8_SQUOTE] = ACTIONS(2298),
    [anon_sym_SQUOTE] = ACTIONS(2298),
    [anon_sym_L_DQUOTE] = ACTIONS(2298),
    [anon_sym_u_DQUOTE] = ACTIONS(2298),
    [anon_sym_U_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8_DQUOTE] = ACTIONS(2298),
    [anon_sym_DQUOTE] = ACTIONS(2298),
    [sym_true] = ACTIONS(2296),
    [sym_false] = ACTIONS(2296),
    [anon_sym_NULL] = ACTIONS(2296),
    [anon_sym_nullptr] = ACTIONS(2296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_This] = ACTIONS(2296),
    [anon_sym_decltype] = ACTIONS(2296),
    [anon_sym_explicit] = ACTIONS(2296),
    [anon_sym_typename] = ACTIONS(2296),
    [anon_sym_export] = ACTIONS(2296),
    [anon_sym_module] = ACTIONS(2296),
    [anon_sym_import] = ACTIONS(2296),
    [anon_sym_template] = ACTIONS(2296),
    [anon_sym_operator] = ACTIONS(2296),
    [anon_sym_try] = ACTIONS(2296),
    [anon_sym_delete] = ACTIONS(2296),
    [anon_sym_throw] = ACTIONS(2296),
    [anon_sym_namespace] = ACTIONS(2296),
    [anon_sym_static_assert] = ACTIONS(2296),
    [anon_sym_concept] = ACTIONS(2296),
    [anon_sym_co_return] = ACTIONS(2296),
    [anon_sym_co_yield] = ACTIONS(2296),
    [anon_sym_R_DQUOTE] = ACTIONS(2298),
    [anon_sym_LR_DQUOTE] = ACTIONS(2298),
    [anon_sym_uR_DQUOTE] = ACTIONS(2298),
    [anon_sym_UR_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2298),
    [anon_sym_co_await] = ACTIONS(2296),
    [anon_sym_new] = ACTIONS(2296),
    [anon_sym_requires] = ACTIONS(2296),
    [sym_this] = ACTIONS(2296),
    [anon_sym_precise] = ACTIONS(2296),
    [anon_sym_shared] = ACTIONS(2296),
    [anon_sym_groupshared] = ACTIONS(2296),
    [anon_sym_uniform] = ACTIONS(2296),
    [anon_sym_row_major] = ACTIONS(2296),
    [anon_sym_column_major] = ACTIONS(2296),
    [anon_sym_globallycoherent] = ACTIONS(2296),
    [anon_sym_centroid] = ACTIONS(2296),
    [anon_sym_noperspective] = ACTIONS(2296),
    [anon_sym_nointerpolation] = ACTIONS(2296),
    [anon_sym_sample] = ACTIONS(2296),
    [anon_sym_linear] = ACTIONS(2296),
    [anon_sym_snorm] = ACTIONS(2296),
    [anon_sym_unorm] = ACTIONS(2296),
    [anon_sym_point] = ACTIONS(2296),
    [anon_sym_line] = ACTIONS(2296),
    [anon_sym_triangleadj] = ACTIONS(2296),
    [anon_sym_lineadj] = ACTIONS(2296),
    [anon_sym_triangle] = ACTIONS(2296),
    [anon_sym_interface] = ACTIONS(2296),
    [anon_sym_extension] = ACTIONS(2296),
    [anon_sym___exported] = ACTIONS(2296),
  },
  [141] = {
    [ts_builtin_sym_end] = ACTIONS(2266),
    [sym_identifier] = ACTIONS(2264),
    [aux_sym_preproc_include_token1] = ACTIONS(2264),
    [aux_sym_preproc_def_token1] = ACTIONS(2264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2266),
    [aux_sym_preproc_if_token1] = ACTIONS(2264),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2264),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2264),
    [sym_preproc_directive] = ACTIONS(2264),
    [anon_sym_LPAREN2] = ACTIONS(2266),
    [anon_sym_BANG] = ACTIONS(2264),
    [anon_sym_TILDE] = ACTIONS(2266),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2264),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_PERCENT] = ACTIONS(2264),
    [anon_sym_PIPE_PIPE] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2266),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_CARET] = ACTIONS(2264),
    [anon_sym_AMP] = ACTIONS(2264),
    [anon_sym_EQ_EQ] = ACTIONS(2266),
    [anon_sym_BANG_EQ] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(2264),
    [anon_sym_GT_EQ] = ACTIONS(2266),
    [anon_sym_LT_EQ] = ACTIONS(2264),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_LT_LT] = ACTIONS(2264),
    [anon_sym_GT_GT] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2266),
    [anon_sym___extension__] = ACTIONS(2264),
    [anon_sym_typedef] = ACTIONS(2264),
    [anon_sym_in] = ACTIONS(2264),
    [anon_sym_out] = ACTIONS(2264),
    [anon_sym_inout] = ACTIONS(2264),
    [anon_sym_virtual] = ACTIONS(2264),
    [anon_sym_extern] = ACTIONS(2264),
    [anon_sym___attribute__] = ACTIONS(2264),
    [anon_sym___attribute] = ACTIONS(2264),
    [anon_sym_using] = ACTIONS(2264),
    [anon_sym_COLON_COLON] = ACTIONS(2266),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2266),
    [anon_sym___declspec] = ACTIONS(2264),
    [anon_sym___based] = ACTIONS(2264),
    [anon_sym___cdecl] = ACTIONS(2264),
    [anon_sym___clrcall] = ACTIONS(2264),
    [anon_sym___stdcall] = ACTIONS(2264),
    [anon_sym___fastcall] = ACTIONS(2264),
    [anon_sym___thiscall] = ACTIONS(2264),
    [anon_sym___vectorcall] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_signed] = ACTIONS(2264),
    [anon_sym_unsigned] = ACTIONS(2264),
    [anon_sym_long] = ACTIONS(2264),
    [anon_sym_short] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_EQ] = ACTIONS(2264),
    [anon_sym_register] = ACTIONS(2264),
    [anon_sym_inline] = ACTIONS(2264),
    [anon_sym___inline] = ACTIONS(2264),
    [anon_sym___inline__] = ACTIONS(2264),
    [anon_sym___forceinline] = ACTIONS(2264),
    [anon_sym_thread_local] = ACTIONS(2264),
    [anon_sym___thread] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_constexpr] = ACTIONS(2264),
    [anon_sym_volatile] = ACTIONS(2264),
    [anon_sym_restrict] = ACTIONS(2264),
    [anon_sym___restrict__] = ACTIONS(2264),
    [anon_sym__Atomic] = ACTIONS(2264),
    [anon_sym__Noreturn] = ACTIONS(2264),
    [anon_sym_noreturn] = ACTIONS(2264),
    [anon_sym__Nonnull] = ACTIONS(2264),
    [anon_sym_mutable] = ACTIONS(2264),
    [anon_sym_constinit] = ACTIONS(2264),
    [anon_sym_consteval] = ACTIONS(2264),
    [anon_sym_alignas] = ACTIONS(2264),
    [anon_sym__Alignas] = ACTIONS(2264),
    [sym_primitive_type] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
    [anon_sym_class] = ACTIONS(2264),
    [anon_sym_struct] = ACTIONS(2264),
    [anon_sym_union] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_switch] = ACTIONS(2264),
    [anon_sym_case] = ACTIONS(2264),
    [anon_sym_default] = ACTIONS(2264),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_do] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_goto] = ACTIONS(2264),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_STAR_EQ] = ACTIONS(2266),
    [anon_sym_SLASH_EQ] = ACTIONS(2266),
    [anon_sym_PERCENT_EQ] = ACTIONS(2266),
    [anon_sym_PLUS_EQ] = ACTIONS(2266),
    [anon_sym_DASH_EQ] = ACTIONS(2266),
    [anon_sym_LT_LT_EQ] = ACTIONS(2266),
    [anon_sym_GT_GT_EQ] = ACTIONS(2266),
    [anon_sym_AMP_EQ] = ACTIONS(2266),
    [anon_sym_CARET_EQ] = ACTIONS(2266),
    [anon_sym_PIPE_EQ] = ACTIONS(2266),
    [anon_sym_and_eq] = ACTIONS(2264),
    [anon_sym_or_eq] = ACTIONS(2264),
    [anon_sym_xor_eq] = ACTIONS(2264),
    [anon_sym_not] = ACTIONS(2264),
    [anon_sym_compl] = ACTIONS(2264),
    [anon_sym_LT_EQ_GT] = ACTIONS(2266),
    [anon_sym_or] = ACTIONS(2264),
    [anon_sym_and] = ACTIONS(2264),
    [anon_sym_bitor] = ACTIONS(2264),
    [anon_sym_xor] = ACTIONS(2264),
    [anon_sym_bitand] = ACTIONS(2264),
    [anon_sym_not_eq] = ACTIONS(2264),
    [anon_sym_is] = ACTIONS(2264),
    [anon_sym_as] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2266),
    [anon_sym_PLUS_PLUS] = ACTIONS(2266),
    [anon_sym_sizeof] = ACTIONS(2264),
    [anon_sym___alignof__] = ACTIONS(2264),
    [anon_sym___alignof] = ACTIONS(2264),
    [anon_sym__alignof] = ACTIONS(2264),
    [anon_sym_alignof] = ACTIONS(2264),
    [anon_sym__Alignof] = ACTIONS(2264),
    [anon_sym_offsetof] = ACTIONS(2264),
    [anon_sym__Generic] = ACTIONS(2264),
    [anon_sym_asm] = ACTIONS(2264),
    [anon_sym___asm__] = ACTIONS(2264),
    [anon_sym___asm] = ACTIONS(2264),
    [anon_sym_DOT] = ACTIONS(2264),
    [anon_sym_DOT_STAR] = ACTIONS(2266),
    [anon_sym_DASH_GT] = ACTIONS(2266),
    [sym_number_literal] = ACTIONS(2266),
    [anon_sym_L_SQUOTE] = ACTIONS(2266),
    [anon_sym_u_SQUOTE] = ACTIONS(2266),
    [anon_sym_U_SQUOTE] = ACTIONS(2266),
    [anon_sym_u8_SQUOTE] = ACTIONS(2266),
    [anon_sym_SQUOTE] = ACTIONS(2266),
    [anon_sym_L_DQUOTE] = ACTIONS(2266),
    [anon_sym_u_DQUOTE] = ACTIONS(2266),
    [anon_sym_U_DQUOTE] = ACTIONS(2266),
    [anon_sym_u8_DQUOTE] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(2266),
    [sym_true] = ACTIONS(2264),
    [sym_false] = ACTIONS(2264),
    [anon_sym_NULL] = ACTIONS(2264),
    [anon_sym_nullptr] = ACTIONS(2264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_This] = ACTIONS(2264),
    [anon_sym_decltype] = ACTIONS(2264),
    [anon_sym_explicit] = ACTIONS(2264),
    [anon_sym_typename] = ACTIONS(2264),
    [anon_sym_export] = ACTIONS(2264),
    [anon_sym_module] = ACTIONS(2264),
    [anon_sym_import] = ACTIONS(2264),
    [anon_sym_template] = ACTIONS(2264),
    [anon_sym_operator] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [anon_sym_delete] = ACTIONS(2264),
    [anon_sym_throw] = ACTIONS(2264),
    [anon_sym_namespace] = ACTIONS(2264),
    [anon_sym_static_assert] = ACTIONS(2264),
    [anon_sym_concept] = ACTIONS(2264),
    [anon_sym_co_return] = ACTIONS(2264),
    [anon_sym_co_yield] = ACTIONS(2264),
    [anon_sym_R_DQUOTE] = ACTIONS(2266),
    [anon_sym_LR_DQUOTE] = ACTIONS(2266),
    [anon_sym_uR_DQUOTE] = ACTIONS(2266),
    [anon_sym_UR_DQUOTE] = ACTIONS(2266),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2266),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2264),
    [anon_sym_requires] = ACTIONS(2264),
    [sym_this] = ACTIONS(2264),
    [anon_sym_precise] = ACTIONS(2264),
    [anon_sym_shared] = ACTIONS(2264),
    [anon_sym_groupshared] = ACTIONS(2264),
    [anon_sym_uniform] = ACTIONS(2264),
    [anon_sym_row_major] = ACTIONS(2264),
    [anon_sym_column_major] = ACTIONS(2264),
    [anon_sym_globallycoherent] = ACTIONS(2264),
    [anon_sym_centroid] = ACTIONS(2264),
    [anon_sym_noperspective] = ACTIONS(2264),
    [anon_sym_nointerpolation] = ACTIONS(2264),
    [anon_sym_sample] = ACTIONS(2264),
    [anon_sym_linear] = ACTIONS(2264),
    [anon_sym_snorm] = ACTIONS(2264),
    [anon_sym_unorm] = ACTIONS(2264),
    [anon_sym_point] = ACTIONS(2264),
    [anon_sym_line] = ACTIONS(2264),
    [anon_sym_triangleadj] = ACTIONS(2264),
    [anon_sym_lineadj] = ACTIONS(2264),
    [anon_sym_triangle] = ACTIONS(2264),
    [anon_sym_interface] = ACTIONS(2264),
    [anon_sym_extension] = ACTIONS(2264),
    [anon_sym___exported] = ACTIONS(2264),
  },
  [142] = {
    [ts_builtin_sym_end] = ACTIONS(2302),
    [sym_identifier] = ACTIONS(2300),
    [aux_sym_preproc_include_token1] = ACTIONS(2300),
    [aux_sym_preproc_def_token1] = ACTIONS(2300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2302),
    [aux_sym_preproc_if_token1] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2300),
    [sym_preproc_directive] = ACTIONS(2300),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_BANG] = ACTIONS(2300),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_PIPE_PIPE] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_PIPE] = ACTIONS(2300),
    [anon_sym_CARET] = ACTIONS(2300),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_EQ_EQ] = ACTIONS(2302),
    [anon_sym_BANG_EQ] = ACTIONS(2302),
    [anon_sym_GT] = ACTIONS(2300),
    [anon_sym_GT_EQ] = ACTIONS(2302),
    [anon_sym_LT_EQ] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_LT_LT] = ACTIONS(2300),
    [anon_sym_GT_GT] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym_typedef] = ACTIONS(2300),
    [anon_sym_in] = ACTIONS(2300),
    [anon_sym_out] = ACTIONS(2300),
    [anon_sym_inout] = ACTIONS(2300),
    [anon_sym_virtual] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym___attribute] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2302),
    [anon_sym___declspec] = ACTIONS(2300),
    [anon_sym___based] = ACTIONS(2300),
    [anon_sym___cdecl] = ACTIONS(2300),
    [anon_sym___clrcall] = ACTIONS(2300),
    [anon_sym___stdcall] = ACTIONS(2300),
    [anon_sym___fastcall] = ACTIONS(2300),
    [anon_sym___thiscall] = ACTIONS(2300),
    [anon_sym___vectorcall] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_signed] = ACTIONS(2300),
    [anon_sym_unsigned] = ACTIONS(2300),
    [anon_sym_long] = ACTIONS(2300),
    [anon_sym_short] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_EQ] = ACTIONS(2300),
    [anon_sym_register] = ACTIONS(2300),
    [anon_sym_inline] = ACTIONS(2300),
    [anon_sym___inline] = ACTIONS(2300),
    [anon_sym___inline__] = ACTIONS(2300),
    [anon_sym___forceinline] = ACTIONS(2300),
    [anon_sym_thread_local] = ACTIONS(2300),
    [anon_sym___thread] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym__Nonnull] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [sym_primitive_type] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_struct] = ACTIONS(2300),
    [anon_sym_union] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_case] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_goto] = ACTIONS(2300),
    [anon_sym_QMARK] = ACTIONS(2302),
    [anon_sym_STAR_EQ] = ACTIONS(2302),
    [anon_sym_SLASH_EQ] = ACTIONS(2302),
    [anon_sym_PERCENT_EQ] = ACTIONS(2302),
    [anon_sym_PLUS_EQ] = ACTIONS(2302),
    [anon_sym_DASH_EQ] = ACTIONS(2302),
    [anon_sym_LT_LT_EQ] = ACTIONS(2302),
    [anon_sym_GT_GT_EQ] = ACTIONS(2302),
    [anon_sym_AMP_EQ] = ACTIONS(2302),
    [anon_sym_CARET_EQ] = ACTIONS(2302),
    [anon_sym_PIPE_EQ] = ACTIONS(2302),
    [anon_sym_and_eq] = ACTIONS(2300),
    [anon_sym_or_eq] = ACTIONS(2300),
    [anon_sym_xor_eq] = ACTIONS(2300),
    [anon_sym_not] = ACTIONS(2300),
    [anon_sym_compl] = ACTIONS(2300),
    [anon_sym_LT_EQ_GT] = ACTIONS(2302),
    [anon_sym_or] = ACTIONS(2300),
    [anon_sym_and] = ACTIONS(2300),
    [anon_sym_bitor] = ACTIONS(2300),
    [anon_sym_xor] = ACTIONS(2300),
    [anon_sym_bitand] = ACTIONS(2300),
    [anon_sym_not_eq] = ACTIONS(2300),
    [anon_sym_is] = ACTIONS(2300),
    [anon_sym_as] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_sizeof] = ACTIONS(2300),
    [anon_sym___alignof__] = ACTIONS(2300),
    [anon_sym___alignof] = ACTIONS(2300),
    [anon_sym__alignof] = ACTIONS(2300),
    [anon_sym_alignof] = ACTIONS(2300),
    [anon_sym__Alignof] = ACTIONS(2300),
    [anon_sym_offsetof] = ACTIONS(2300),
    [anon_sym__Generic] = ACTIONS(2300),
    [anon_sym_asm] = ACTIONS(2300),
    [anon_sym___asm__] = ACTIONS(2300),
    [anon_sym___asm] = ACTIONS(2300),
    [anon_sym_DOT] = ACTIONS(2300),
    [anon_sym_DOT_STAR] = ACTIONS(2302),
    [anon_sym_DASH_GT] = ACTIONS(2302),
    [sym_number_literal] = ACTIONS(2302),
    [anon_sym_L_SQUOTE] = ACTIONS(2302),
    [anon_sym_u_SQUOTE] = ACTIONS(2302),
    [anon_sym_U_SQUOTE] = ACTIONS(2302),
    [anon_sym_u8_SQUOTE] = ACTIONS(2302),
    [anon_sym_SQUOTE] = ACTIONS(2302),
    [anon_sym_L_DQUOTE] = ACTIONS(2302),
    [anon_sym_u_DQUOTE] = ACTIONS(2302),
    [anon_sym_U_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8_DQUOTE] = ACTIONS(2302),
    [anon_sym_DQUOTE] = ACTIONS(2302),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [anon_sym_NULL] = ACTIONS(2300),
    [anon_sym_nullptr] = ACTIONS(2300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_This] = ACTIONS(2300),
    [anon_sym_decltype] = ACTIONS(2300),
    [anon_sym_explicit] = ACTIONS(2300),
    [anon_sym_typename] = ACTIONS(2300),
    [anon_sym_export] = ACTIONS(2300),
    [anon_sym_module] = ACTIONS(2300),
    [anon_sym_import] = ACTIONS(2300),
    [anon_sym_template] = ACTIONS(2300),
    [anon_sym_operator] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_static_assert] = ACTIONS(2300),
    [anon_sym_concept] = ACTIONS(2300),
    [anon_sym_co_return] = ACTIONS(2300),
    [anon_sym_co_yield] = ACTIONS(2300),
    [anon_sym_R_DQUOTE] = ACTIONS(2302),
    [anon_sym_LR_DQUOTE] = ACTIONS(2302),
    [anon_sym_uR_DQUOTE] = ACTIONS(2302),
    [anon_sym_UR_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2302),
    [anon_sym_co_await] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_requires] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [anon_sym_precise] = ACTIONS(2300),
    [anon_sym_shared] = ACTIONS(2300),
    [anon_sym_groupshared] = ACTIONS(2300),
    [anon_sym_uniform] = ACTIONS(2300),
    [anon_sym_row_major] = ACTIONS(2300),
    [anon_sym_column_major] = ACTIONS(2300),
    [anon_sym_globallycoherent] = ACTIONS(2300),
    [anon_sym_centroid] = ACTIONS(2300),
    [anon_sym_noperspective] = ACTIONS(2300),
    [anon_sym_nointerpolation] = ACTIONS(2300),
    [anon_sym_sample] = ACTIONS(2300),
    [anon_sym_linear] = ACTIONS(2300),
    [anon_sym_snorm] = ACTIONS(2300),
    [anon_sym_unorm] = ACTIONS(2300),
    [anon_sym_point] = ACTIONS(2300),
    [anon_sym_line] = ACTIONS(2300),
    [anon_sym_triangleadj] = ACTIONS(2300),
    [anon_sym_lineadj] = ACTIONS(2300),
    [anon_sym_triangle] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_extension] = ACTIONS(2300),
    [anon_sym___exported] = ACTIONS(2300),
  },
  [143] = {
    [ts_builtin_sym_end] = ACTIONS(2262),
    [sym_identifier] = ACTIONS(2260),
    [aux_sym_preproc_include_token1] = ACTIONS(2260),
    [aux_sym_preproc_def_token1] = ACTIONS(2260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [aux_sym_preproc_if_token1] = ACTIONS(2260),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2260),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2260),
    [sym_preproc_directive] = ACTIONS(2260),
    [anon_sym_LPAREN2] = ACTIONS(2262),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2260),
    [anon_sym_PERCENT] = ACTIONS(2260),
    [anon_sym_PIPE_PIPE] = ACTIONS(2262),
    [anon_sym_AMP_AMP] = ACTIONS(2262),
    [anon_sym_PIPE] = ACTIONS(2260),
    [anon_sym_CARET] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_EQ_EQ] = ACTIONS(2262),
    [anon_sym_BANG_EQ] = ACTIONS(2262),
    [anon_sym_GT] = ACTIONS(2260),
    [anon_sym_GT_EQ] = ACTIONS(2262),
    [anon_sym_LT_EQ] = ACTIONS(2260),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_LT_LT] = ACTIONS(2260),
    [anon_sym_GT_GT] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym___extension__] = ACTIONS(2260),
    [anon_sym_typedef] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(2260),
    [anon_sym_out] = ACTIONS(2260),
    [anon_sym_inout] = ACTIONS(2260),
    [anon_sym_virtual] = ACTIONS(2260),
    [anon_sym_extern] = ACTIONS(2260),
    [anon_sym___attribute__] = ACTIONS(2260),
    [anon_sym___attribute] = ACTIONS(2260),
    [anon_sym_using] = ACTIONS(2260),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2262),
    [anon_sym___declspec] = ACTIONS(2260),
    [anon_sym___based] = ACTIONS(2260),
    [anon_sym___cdecl] = ACTIONS(2260),
    [anon_sym___clrcall] = ACTIONS(2260),
    [anon_sym___stdcall] = ACTIONS(2260),
    [anon_sym___fastcall] = ACTIONS(2260),
    [anon_sym___thiscall] = ACTIONS(2260),
    [anon_sym___vectorcall] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_signed] = ACTIONS(2260),
    [anon_sym_unsigned] = ACTIONS(2260),
    [anon_sym_long] = ACTIONS(2260),
    [anon_sym_short] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_EQ] = ACTIONS(2260),
    [anon_sym_register] = ACTIONS(2260),
    [anon_sym_inline] = ACTIONS(2260),
    [anon_sym___inline] = ACTIONS(2260),
    [anon_sym___inline__] = ACTIONS(2260),
    [anon_sym___forceinline] = ACTIONS(2260),
    [anon_sym_thread_local] = ACTIONS(2260),
    [anon_sym___thread] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_constexpr] = ACTIONS(2260),
    [anon_sym_volatile] = ACTIONS(2260),
    [anon_sym_restrict] = ACTIONS(2260),
    [anon_sym___restrict__] = ACTIONS(2260),
    [anon_sym__Atomic] = ACTIONS(2260),
    [anon_sym__Noreturn] = ACTIONS(2260),
    [anon_sym_noreturn] = ACTIONS(2260),
    [anon_sym__Nonnull] = ACTIONS(2260),
    [anon_sym_mutable] = ACTIONS(2260),
    [anon_sym_constinit] = ACTIONS(2260),
    [anon_sym_consteval] = ACTIONS(2260),
    [anon_sym_alignas] = ACTIONS(2260),
    [anon_sym__Alignas] = ACTIONS(2260),
    [sym_primitive_type] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
    [anon_sym_class] = ACTIONS(2260),
    [anon_sym_struct] = ACTIONS(2260),
    [anon_sym_union] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_switch] = ACTIONS(2260),
    [anon_sym_case] = ACTIONS(2260),
    [anon_sym_default] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_do] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_goto] = ACTIONS(2260),
    [anon_sym_QMARK] = ACTIONS(2262),
    [anon_sym_STAR_EQ] = ACTIONS(2262),
    [anon_sym_SLASH_EQ] = ACTIONS(2262),
    [anon_sym_PERCENT_EQ] = ACTIONS(2262),
    [anon_sym_PLUS_EQ] = ACTIONS(2262),
    [anon_sym_DASH_EQ] = ACTIONS(2262),
    [anon_sym_LT_LT_EQ] = ACTIONS(2262),
    [anon_sym_GT_GT_EQ] = ACTIONS(2262),
    [anon_sym_AMP_EQ] = ACTIONS(2262),
    [anon_sym_CARET_EQ] = ACTIONS(2262),
    [anon_sym_PIPE_EQ] = ACTIONS(2262),
    [anon_sym_and_eq] = ACTIONS(2260),
    [anon_sym_or_eq] = ACTIONS(2260),
    [anon_sym_xor_eq] = ACTIONS(2260),
    [anon_sym_not] = ACTIONS(2260),
    [anon_sym_compl] = ACTIONS(2260),
    [anon_sym_LT_EQ_GT] = ACTIONS(2262),
    [anon_sym_or] = ACTIONS(2260),
    [anon_sym_and] = ACTIONS(2260),
    [anon_sym_bitor] = ACTIONS(2260),
    [anon_sym_xor] = ACTIONS(2260),
    [anon_sym_bitand] = ACTIONS(2260),
    [anon_sym_not_eq] = ACTIONS(2260),
    [anon_sym_is] = ACTIONS(2260),
    [anon_sym_as] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_sizeof] = ACTIONS(2260),
    [anon_sym___alignof__] = ACTIONS(2260),
    [anon_sym___alignof] = ACTIONS(2260),
    [anon_sym__alignof] = ACTIONS(2260),
    [anon_sym_alignof] = ACTIONS(2260),
    [anon_sym__Alignof] = ACTIONS(2260),
    [anon_sym_offsetof] = ACTIONS(2260),
    [anon_sym__Generic] = ACTIONS(2260),
    [anon_sym_asm] = ACTIONS(2260),
    [anon_sym___asm__] = ACTIONS(2260),
    [anon_sym___asm] = ACTIONS(2260),
    [anon_sym_DOT] = ACTIONS(2260),
    [anon_sym_DOT_STAR] = ACTIONS(2262),
    [anon_sym_DASH_GT] = ACTIONS(2262),
    [sym_number_literal] = ACTIONS(2262),
    [anon_sym_L_SQUOTE] = ACTIONS(2262),
    [anon_sym_u_SQUOTE] = ACTIONS(2262),
    [anon_sym_U_SQUOTE] = ACTIONS(2262),
    [anon_sym_u8_SQUOTE] = ACTIONS(2262),
    [anon_sym_SQUOTE] = ACTIONS(2262),
    [anon_sym_L_DQUOTE] = ACTIONS(2262),
    [anon_sym_u_DQUOTE] = ACTIONS(2262),
    [anon_sym_U_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8_DQUOTE] = ACTIONS(2262),
    [anon_sym_DQUOTE] = ACTIONS(2262),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [anon_sym_NULL] = ACTIONS(2260),
    [anon_sym_nullptr] = ACTIONS(2260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_This] = ACTIONS(2260),
    [anon_sym_decltype] = ACTIONS(2260),
    [anon_sym_explicit] = ACTIONS(2260),
    [anon_sym_typename] = ACTIONS(2260),
    [anon_sym_export] = ACTIONS(2260),
    [anon_sym_module] = ACTIONS(2260),
    [anon_sym_import] = ACTIONS(2260),
    [anon_sym_template] = ACTIONS(2260),
    [anon_sym_operator] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_throw] = ACTIONS(2260),
    [anon_sym_namespace] = ACTIONS(2260),
    [anon_sym_static_assert] = ACTIONS(2260),
    [anon_sym_concept] = ACTIONS(2260),
    [anon_sym_co_return] = ACTIONS(2260),
    [anon_sym_co_yield] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2260),
    [anon_sym_new] = ACTIONS(2260),
    [anon_sym_requires] = ACTIONS(2260),
    [sym_this] = ACTIONS(2260),
    [anon_sym_precise] = ACTIONS(2260),
    [anon_sym_shared] = ACTIONS(2260),
    [anon_sym_groupshared] = ACTIONS(2260),
    [anon_sym_uniform] = ACTIONS(2260),
    [anon_sym_row_major] = ACTIONS(2260),
    [anon_sym_column_major] = ACTIONS(2260),
    [anon_sym_globallycoherent] = ACTIONS(2260),
    [anon_sym_centroid] = ACTIONS(2260),
    [anon_sym_noperspective] = ACTIONS(2260),
    [anon_sym_nointerpolation] = ACTIONS(2260),
    [anon_sym_sample] = ACTIONS(2260),
    [anon_sym_linear] = ACTIONS(2260),
    [anon_sym_snorm] = ACTIONS(2260),
    [anon_sym_unorm] = ACTIONS(2260),
    [anon_sym_point] = ACTIONS(2260),
    [anon_sym_line] = ACTIONS(2260),
    [anon_sym_triangleadj] = ACTIONS(2260),
    [anon_sym_lineadj] = ACTIONS(2260),
    [anon_sym_triangle] = ACTIONS(2260),
    [anon_sym_interface] = ACTIONS(2260),
    [anon_sym_extension] = ACTIONS(2260),
    [anon_sym___exported] = ACTIONS(2260),
  },
  [144] = {
    [ts_builtin_sym_end] = ACTIONS(2306),
    [sym_identifier] = ACTIONS(2304),
    [aux_sym_preproc_include_token1] = ACTIONS(2304),
    [aux_sym_preproc_def_token1] = ACTIONS(2304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2304),
    [sym_preproc_directive] = ACTIONS(2304),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_BANG] = ACTIONS(2304),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2304),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_PERCENT] = ACTIONS(2304),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE] = ACTIONS(2304),
    [anon_sym_CARET] = ACTIONS(2304),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_GT] = ACTIONS(2304),
    [anon_sym_GT_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_LT_LT] = ACTIONS(2304),
    [anon_sym_GT_GT] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2306),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym_typedef] = ACTIONS(2304),
    [anon_sym_in] = ACTIONS(2304),
    [anon_sym_out] = ACTIONS(2304),
    [anon_sym_inout] = ACTIONS(2304),
    [anon_sym_virtual] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym___attribute] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2306),
    [anon_sym___declspec] = ACTIONS(2304),
    [anon_sym___based] = ACTIONS(2304),
    [anon_sym___cdecl] = ACTIONS(2304),
    [anon_sym___clrcall] = ACTIONS(2304),
    [anon_sym___stdcall] = ACTIONS(2304),
    [anon_sym___fastcall] = ACTIONS(2304),
    [anon_sym___thiscall] = ACTIONS(2304),
    [anon_sym___vectorcall] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_signed] = ACTIONS(2304),
    [anon_sym_unsigned] = ACTIONS(2304),
    [anon_sym_long] = ACTIONS(2304),
    [anon_sym_short] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_EQ] = ACTIONS(2304),
    [anon_sym_register] = ACTIONS(2304),
    [anon_sym_inline] = ACTIONS(2304),
    [anon_sym___inline] = ACTIONS(2304),
    [anon_sym___inline__] = ACTIONS(2304),
    [anon_sym___forceinline] = ACTIONS(2304),
    [anon_sym_thread_local] = ACTIONS(2304),
    [anon_sym___thread] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym__Nonnull] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [sym_primitive_type] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_struct] = ACTIONS(2304),
    [anon_sym_union] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_case] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_goto] = ACTIONS(2304),
    [anon_sym_QMARK] = ACTIONS(2306),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_and_eq] = ACTIONS(2304),
    [anon_sym_or_eq] = ACTIONS(2304),
    [anon_sym_xor_eq] = ACTIONS(2304),
    [anon_sym_not] = ACTIONS(2304),
    [anon_sym_compl] = ACTIONS(2304),
    [anon_sym_LT_EQ_GT] = ACTIONS(2306),
    [anon_sym_or] = ACTIONS(2304),
    [anon_sym_and] = ACTIONS(2304),
    [anon_sym_bitor] = ACTIONS(2304),
    [anon_sym_xor] = ACTIONS(2304),
    [anon_sym_bitand] = ACTIONS(2304),
    [anon_sym_not_eq] = ACTIONS(2304),
    [anon_sym_is] = ACTIONS(2304),
    [anon_sym_as] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_sizeof] = ACTIONS(2304),
    [anon_sym___alignof__] = ACTIONS(2304),
    [anon_sym___alignof] = ACTIONS(2304),
    [anon_sym__alignof] = ACTIONS(2304),
    [anon_sym_alignof] = ACTIONS(2304),
    [anon_sym__Alignof] = ACTIONS(2304),
    [anon_sym_offsetof] = ACTIONS(2304),
    [anon_sym__Generic] = ACTIONS(2304),
    [anon_sym_asm] = ACTIONS(2304),
    [anon_sym___asm__] = ACTIONS(2304),
    [anon_sym___asm] = ACTIONS(2304),
    [anon_sym_DOT] = ACTIONS(2304),
    [anon_sym_DOT_STAR] = ACTIONS(2306),
    [anon_sym_DASH_GT] = ACTIONS(2306),
    [sym_number_literal] = ACTIONS(2306),
    [anon_sym_L_SQUOTE] = ACTIONS(2306),
    [anon_sym_u_SQUOTE] = ACTIONS(2306),
    [anon_sym_U_SQUOTE] = ACTIONS(2306),
    [anon_sym_u8_SQUOTE] = ACTIONS(2306),
    [anon_sym_SQUOTE] = ACTIONS(2306),
    [anon_sym_L_DQUOTE] = ACTIONS(2306),
    [anon_sym_u_DQUOTE] = ACTIONS(2306),
    [anon_sym_U_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8_DQUOTE] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [anon_sym_NULL] = ACTIONS(2304),
    [anon_sym_nullptr] = ACTIONS(2304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_This] = ACTIONS(2304),
    [anon_sym_decltype] = ACTIONS(2304),
    [anon_sym_explicit] = ACTIONS(2304),
    [anon_sym_typename] = ACTIONS(2304),
    [anon_sym_export] = ACTIONS(2304),
    [anon_sym_module] = ACTIONS(2304),
    [anon_sym_import] = ACTIONS(2304),
    [anon_sym_template] = ACTIONS(2304),
    [anon_sym_operator] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_static_assert] = ACTIONS(2304),
    [anon_sym_concept] = ACTIONS(2304),
    [anon_sym_co_return] = ACTIONS(2304),
    [anon_sym_co_yield] = ACTIONS(2304),
    [anon_sym_R_DQUOTE] = ACTIONS(2306),
    [anon_sym_LR_DQUOTE] = ACTIONS(2306),
    [anon_sym_uR_DQUOTE] = ACTIONS(2306),
    [anon_sym_UR_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2306),
    [anon_sym_co_await] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_requires] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [anon_sym_precise] = ACTIONS(2304),
    [anon_sym_shared] = ACTIONS(2304),
    [anon_sym_groupshared] = ACTIONS(2304),
    [anon_sym_uniform] = ACTIONS(2304),
    [anon_sym_row_major] = ACTIONS(2304),
    [anon_sym_column_major] = ACTIONS(2304),
    [anon_sym_globallycoherent] = ACTIONS(2304),
    [anon_sym_centroid] = ACTIONS(2304),
    [anon_sym_noperspective] = ACTIONS(2304),
    [anon_sym_nointerpolation] = ACTIONS(2304),
    [anon_sym_sample] = ACTIONS(2304),
    [anon_sym_linear] = ACTIONS(2304),
    [anon_sym_snorm] = ACTIONS(2304),
    [anon_sym_unorm] = ACTIONS(2304),
    [anon_sym_point] = ACTIONS(2304),
    [anon_sym_line] = ACTIONS(2304),
    [anon_sym_triangleadj] = ACTIONS(2304),
    [anon_sym_lineadj] = ACTIONS(2304),
    [anon_sym_triangle] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_extension] = ACTIONS(2304),
    [anon_sym___exported] = ACTIONS(2304),
  },
  [145] = {
    [ts_builtin_sym_end] = ACTIONS(2310),
    [sym_identifier] = ACTIONS(2308),
    [aux_sym_preproc_include_token1] = ACTIONS(2308),
    [aux_sym_preproc_def_token1] = ACTIONS(2308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2310),
    [aux_sym_preproc_if_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2308),
    [sym_preproc_directive] = ACTIONS(2308),
    [anon_sym_LPAREN2] = ACTIONS(2310),
    [anon_sym_BANG] = ACTIONS(2308),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2308),
    [anon_sym_SLASH] = ACTIONS(2308),
    [anon_sym_PERCENT] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_CARET] = ACTIONS(2308),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2310),
    [anon_sym_BANG_EQ] = ACTIONS(2310),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_EQ] = ACTIONS(2310),
    [anon_sym_LT_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(2308),
    [anon_sym_typedef] = ACTIONS(2308),
    [anon_sym_in] = ACTIONS(2308),
    [anon_sym_out] = ACTIONS(2308),
    [anon_sym_inout] = ACTIONS(2308),
    [anon_sym_virtual] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2308),
    [anon_sym___attribute__] = ACTIONS(2308),
    [anon_sym___attribute] = ACTIONS(2308),
    [anon_sym_using] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2310),
    [anon_sym___declspec] = ACTIONS(2308),
    [anon_sym___based] = ACTIONS(2308),
    [anon_sym___cdecl] = ACTIONS(2308),
    [anon_sym___clrcall] = ACTIONS(2308),
    [anon_sym___stdcall] = ACTIONS(2308),
    [anon_sym___fastcall] = ACTIONS(2308),
    [anon_sym___thiscall] = ACTIONS(2308),
    [anon_sym___vectorcall] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_signed] = ACTIONS(2308),
    [anon_sym_unsigned] = ACTIONS(2308),
    [anon_sym_long] = ACTIONS(2308),
    [anon_sym_short] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_EQ] = ACTIONS(2308),
    [anon_sym_register] = ACTIONS(2308),
    [anon_sym_inline] = ACTIONS(2308),
    [anon_sym___inline] = ACTIONS(2308),
    [anon_sym___inline__] = ACTIONS(2308),
    [anon_sym___forceinline] = ACTIONS(2308),
    [anon_sym_thread_local] = ACTIONS(2308),
    [anon_sym___thread] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_constexpr] = ACTIONS(2308),
    [anon_sym_volatile] = ACTIONS(2308),
    [anon_sym_restrict] = ACTIONS(2308),
    [anon_sym___restrict__] = ACTIONS(2308),
    [anon_sym__Atomic] = ACTIONS(2308),
    [anon_sym__Noreturn] = ACTIONS(2308),
    [anon_sym_noreturn] = ACTIONS(2308),
    [anon_sym__Nonnull] = ACTIONS(2308),
    [anon_sym_mutable] = ACTIONS(2308),
    [anon_sym_constinit] = ACTIONS(2308),
    [anon_sym_consteval] = ACTIONS(2308),
    [anon_sym_alignas] = ACTIONS(2308),
    [anon_sym__Alignas] = ACTIONS(2308),
    [sym_primitive_type] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_struct] = ACTIONS(2308),
    [anon_sym_union] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_case] = ACTIONS(2308),
    [anon_sym_default] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_goto] = ACTIONS(2308),
    [anon_sym_QMARK] = ACTIONS(2310),
    [anon_sym_STAR_EQ] = ACTIONS(2310),
    [anon_sym_SLASH_EQ] = ACTIONS(2310),
    [anon_sym_PERCENT_EQ] = ACTIONS(2310),
    [anon_sym_PLUS_EQ] = ACTIONS(2310),
    [anon_sym_DASH_EQ] = ACTIONS(2310),
    [anon_sym_LT_LT_EQ] = ACTIONS(2310),
    [anon_sym_GT_GT_EQ] = ACTIONS(2310),
    [anon_sym_AMP_EQ] = ACTIONS(2310),
    [anon_sym_CARET_EQ] = ACTIONS(2310),
    [anon_sym_PIPE_EQ] = ACTIONS(2310),
    [anon_sym_and_eq] = ACTIONS(2308),
    [anon_sym_or_eq] = ACTIONS(2308),
    [anon_sym_xor_eq] = ACTIONS(2308),
    [anon_sym_not] = ACTIONS(2308),
    [anon_sym_compl] = ACTIONS(2308),
    [anon_sym_LT_EQ_GT] = ACTIONS(2310),
    [anon_sym_or] = ACTIONS(2308),
    [anon_sym_and] = ACTIONS(2308),
    [anon_sym_bitor] = ACTIONS(2308),
    [anon_sym_xor] = ACTIONS(2308),
    [anon_sym_bitand] = ACTIONS(2308),
    [anon_sym_not_eq] = ACTIONS(2308),
    [anon_sym_is] = ACTIONS(2308),
    [anon_sym_as] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_sizeof] = ACTIONS(2308),
    [anon_sym___alignof__] = ACTIONS(2308),
    [anon_sym___alignof] = ACTIONS(2308),
    [anon_sym__alignof] = ACTIONS(2308),
    [anon_sym_alignof] = ACTIONS(2308),
    [anon_sym__Alignof] = ACTIONS(2308),
    [anon_sym_offsetof] = ACTIONS(2308),
    [anon_sym__Generic] = ACTIONS(2308),
    [anon_sym_asm] = ACTIONS(2308),
    [anon_sym___asm__] = ACTIONS(2308),
    [anon_sym___asm] = ACTIONS(2308),
    [anon_sym_DOT] = ACTIONS(2308),
    [anon_sym_DOT_STAR] = ACTIONS(2310),
    [anon_sym_DASH_GT] = ACTIONS(2310),
    [sym_number_literal] = ACTIONS(2310),
    [anon_sym_L_SQUOTE] = ACTIONS(2310),
    [anon_sym_u_SQUOTE] = ACTIONS(2310),
    [anon_sym_U_SQUOTE] = ACTIONS(2310),
    [anon_sym_u8_SQUOTE] = ACTIONS(2310),
    [anon_sym_SQUOTE] = ACTIONS(2310),
    [anon_sym_L_DQUOTE] = ACTIONS(2310),
    [anon_sym_u_DQUOTE] = ACTIONS(2310),
    [anon_sym_U_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8_DQUOTE] = ACTIONS(2310),
    [anon_sym_DQUOTE] = ACTIONS(2310),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [anon_sym_NULL] = ACTIONS(2308),
    [anon_sym_nullptr] = ACTIONS(2308),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_This] = ACTIONS(2308),
    [anon_sym_decltype] = ACTIONS(2308),
    [anon_sym_explicit] = ACTIONS(2308),
    [anon_sym_typename] = ACTIONS(2308),
    [anon_sym_export] = ACTIONS(2308),
    [anon_sym_module] = ACTIONS(2308),
    [anon_sym_import] = ACTIONS(2308),
    [anon_sym_template] = ACTIONS(2308),
    [anon_sym_operator] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_delete] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_namespace] = ACTIONS(2308),
    [anon_sym_static_assert] = ACTIONS(2308),
    [anon_sym_concept] = ACTIONS(2308),
    [anon_sym_co_return] = ACTIONS(2308),
    [anon_sym_co_yield] = ACTIONS(2308),
    [anon_sym_R_DQUOTE] = ACTIONS(2310),
    [anon_sym_LR_DQUOTE] = ACTIONS(2310),
    [anon_sym_uR_DQUOTE] = ACTIONS(2310),
    [anon_sym_UR_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2310),
    [anon_sym_co_await] = ACTIONS(2308),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_requires] = ACTIONS(2308),
    [sym_this] = ACTIONS(2308),
    [anon_sym_precise] = ACTIONS(2308),
    [anon_sym_shared] = ACTIONS(2308),
    [anon_sym_groupshared] = ACTIONS(2308),
    [anon_sym_uniform] = ACTIONS(2308),
    [anon_sym_row_major] = ACTIONS(2308),
    [anon_sym_column_major] = ACTIONS(2308),
    [anon_sym_globallycoherent] = ACTIONS(2308),
    [anon_sym_centroid] = ACTIONS(2308),
    [anon_sym_noperspective] = ACTIONS(2308),
    [anon_sym_nointerpolation] = ACTIONS(2308),
    [anon_sym_sample] = ACTIONS(2308),
    [anon_sym_linear] = ACTIONS(2308),
    [anon_sym_snorm] = ACTIONS(2308),
    [anon_sym_unorm] = ACTIONS(2308),
    [anon_sym_point] = ACTIONS(2308),
    [anon_sym_line] = ACTIONS(2308),
    [anon_sym_triangleadj] = ACTIONS(2308),
    [anon_sym_lineadj] = ACTIONS(2308),
    [anon_sym_triangle] = ACTIONS(2308),
    [anon_sym_interface] = ACTIONS(2308),
    [anon_sym_extension] = ACTIONS(2308),
    [anon_sym___exported] = ACTIONS(2308),
  },
  [146] = {
    [ts_builtin_sym_end] = ACTIONS(2250),
    [sym_identifier] = ACTIONS(2243),
    [aux_sym_preproc_include_token1] = ACTIONS(2243),
    [aux_sym_preproc_def_token1] = ACTIONS(2243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2245),
    [aux_sym_preproc_if_token1] = ACTIONS(2243),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2243),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2243),
    [sym_preproc_directive] = ACTIONS(2243),
    [anon_sym_LPAREN2] = ACTIONS(2247),
    [anon_sym_BANG] = ACTIONS(2243),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_SLASH] = ACTIONS(2255),
    [anon_sym_PERCENT] = ACTIONS(2255),
    [anon_sym_PIPE_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2255),
    [anon_sym_CARET] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2245),
    [anon_sym_BANG_EQ] = ACTIONS(2245),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_GT_EQ] = ACTIONS(2245),
    [anon_sym_LT_EQ] = ACTIONS(2255),
    [anon_sym_LT] = ACTIONS(2255),
    [anon_sym_LT_LT] = ACTIONS(2255),
    [anon_sym_GT_GT] = ACTIONS(2255),
    [anon_sym_SEMI] = ACTIONS(2247),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym_typedef] = ACTIONS(2243),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_out] = ACTIONS(2243),
    [anon_sym_inout] = ACTIONS(2243),
    [anon_sym_virtual] = ACTIONS(2243),
    [anon_sym_extern] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym___attribute] = ACTIONS(2243),
    [anon_sym_using] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2247),
    [anon_sym___declspec] = ACTIONS(2243),
    [anon_sym___based] = ACTIONS(2243),
    [anon_sym___cdecl] = ACTIONS(2243),
    [anon_sym___clrcall] = ACTIONS(2243),
    [anon_sym___stdcall] = ACTIONS(2243),
    [anon_sym___fastcall] = ACTIONS(2243),
    [anon_sym___thiscall] = ACTIONS(2243),
    [anon_sym___vectorcall] = ACTIONS(2243),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_signed] = ACTIONS(2243),
    [anon_sym_unsigned] = ACTIONS(2243),
    [anon_sym_long] = ACTIONS(2243),
    [anon_sym_short] = ACTIONS(2243),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_EQ] = ACTIONS(2255),
    [anon_sym_register] = ACTIONS(2243),
    [anon_sym_inline] = ACTIONS(2243),
    [anon_sym___inline] = ACTIONS(2243),
    [anon_sym___inline__] = ACTIONS(2243),
    [anon_sym___forceinline] = ACTIONS(2243),
    [anon_sym_thread_local] = ACTIONS(2243),
    [anon_sym___thread] = ACTIONS(2243),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym__Nonnull] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [sym_primitive_type] = ACTIONS(2243),
    [anon_sym_enum] = ACTIONS(2243),
    [anon_sym_class] = ACTIONS(2243),
    [anon_sym_struct] = ACTIONS(2243),
    [anon_sym_union] = ACTIONS(2243),
    [anon_sym_if] = ACTIONS(2243),
    [anon_sym_switch] = ACTIONS(2243),
    [anon_sym_case] = ACTIONS(2243),
    [anon_sym_default] = ACTIONS(2243),
    [anon_sym_while] = ACTIONS(2243),
    [anon_sym_do] = ACTIONS(2243),
    [anon_sym_for] = ACTIONS(2243),
    [anon_sym_return] = ACTIONS(2243),
    [anon_sym_break] = ACTIONS(2243),
    [anon_sym_continue] = ACTIONS(2243),
    [anon_sym_goto] = ACTIONS(2243),
    [anon_sym_QMARK] = ACTIONS(2245),
    [anon_sym_STAR_EQ] = ACTIONS(2245),
    [anon_sym_SLASH_EQ] = ACTIONS(2245),
    [anon_sym_PERCENT_EQ] = ACTIONS(2245),
    [anon_sym_PLUS_EQ] = ACTIONS(2245),
    [anon_sym_DASH_EQ] = ACTIONS(2245),
    [anon_sym_LT_LT_EQ] = ACTIONS(2245),
    [anon_sym_GT_GT_EQ] = ACTIONS(2245),
    [anon_sym_AMP_EQ] = ACTIONS(2245),
    [anon_sym_CARET_EQ] = ACTIONS(2245),
    [anon_sym_PIPE_EQ] = ACTIONS(2245),
    [anon_sym_and_eq] = ACTIONS(2255),
    [anon_sym_or_eq] = ACTIONS(2255),
    [anon_sym_xor_eq] = ACTIONS(2255),
    [anon_sym_not] = ACTIONS(2243),
    [anon_sym_compl] = ACTIONS(2243),
    [anon_sym_LT_EQ_GT] = ACTIONS(2245),
    [anon_sym_or] = ACTIONS(2255),
    [anon_sym_and] = ACTIONS(2255),
    [anon_sym_bitor] = ACTIONS(2255),
    [anon_sym_xor] = ACTIONS(2255),
    [anon_sym_bitand] = ACTIONS(2255),
    [anon_sym_not_eq] = ACTIONS(2255),
    [anon_sym_is] = ACTIONS(2255),
    [anon_sym_as] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2247),
    [anon_sym_PLUS_PLUS] = ACTIONS(2247),
    [anon_sym_sizeof] = ACTIONS(2243),
    [anon_sym___alignof__] = ACTIONS(2243),
    [anon_sym___alignof] = ACTIONS(2243),
    [anon_sym__alignof] = ACTIONS(2243),
    [anon_sym_alignof] = ACTIONS(2243),
    [anon_sym__Alignof] = ACTIONS(2243),
    [anon_sym_offsetof] = ACTIONS(2243),
    [anon_sym__Generic] = ACTIONS(2243),
    [anon_sym_asm] = ACTIONS(2243),
    [anon_sym___asm__] = ACTIONS(2243),
    [anon_sym___asm] = ACTIONS(2243),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2245),
    [anon_sym_DASH_GT] = ACTIONS(2245),
    [sym_number_literal] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2250),
    [anon_sym_u_SQUOTE] = ACTIONS(2250),
    [anon_sym_U_SQUOTE] = ACTIONS(2250),
    [anon_sym_u8_SQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_L_DQUOTE] = ACTIONS(2250),
    [anon_sym_u_DQUOTE] = ACTIONS(2250),
    [anon_sym_U_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [sym_true] = ACTIONS(2243),
    [sym_false] = ACTIONS(2243),
    [anon_sym_NULL] = ACTIONS(2243),
    [anon_sym_nullptr] = ACTIONS(2243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2243),
    [anon_sym_let] = ACTIONS(2243),
    [anon_sym_This] = ACTIONS(2243),
    [anon_sym_decltype] = ACTIONS(2243),
    [anon_sym_explicit] = ACTIONS(2243),
    [anon_sym_typename] = ACTIONS(2243),
    [anon_sym_export] = ACTIONS(2243),
    [anon_sym_module] = ACTIONS(2243),
    [anon_sym_import] = ACTIONS(2243),
    [anon_sym_template] = ACTIONS(2243),
    [anon_sym_operator] = ACTIONS(2243),
    [anon_sym_try] = ACTIONS(2243),
    [anon_sym_delete] = ACTIONS(2243),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_namespace] = ACTIONS(2243),
    [anon_sym_static_assert] = ACTIONS(2243),
    [anon_sym_concept] = ACTIONS(2243),
    [anon_sym_co_return] = ACTIONS(2243),
    [anon_sym_co_yield] = ACTIONS(2243),
    [anon_sym_R_DQUOTE] = ACTIONS(2250),
    [anon_sym_LR_DQUOTE] = ACTIONS(2250),
    [anon_sym_uR_DQUOTE] = ACTIONS(2250),
    [anon_sym_UR_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2250),
    [anon_sym_co_await] = ACTIONS(2243),
    [anon_sym_new] = ACTIONS(2243),
    [anon_sym_requires] = ACTIONS(2243),
    [sym_this] = ACTIONS(2243),
    [anon_sym_precise] = ACTIONS(2243),
    [anon_sym_shared] = ACTIONS(2243),
    [anon_sym_groupshared] = ACTIONS(2243),
    [anon_sym_uniform] = ACTIONS(2243),
    [anon_sym_row_major] = ACTIONS(2243),
    [anon_sym_column_major] = ACTIONS(2243),
    [anon_sym_globallycoherent] = ACTIONS(2243),
    [anon_sym_centroid] = ACTIONS(2243),
    [anon_sym_noperspective] = ACTIONS(2243),
    [anon_sym_nointerpolation] = ACTIONS(2243),
    [anon_sym_sample] = ACTIONS(2243),
    [anon_sym_linear] = ACTIONS(2243),
    [anon_sym_snorm] = ACTIONS(2243),
    [anon_sym_unorm] = ACTIONS(2243),
    [anon_sym_point] = ACTIONS(2243),
    [anon_sym_line] = ACTIONS(2243),
    [anon_sym_triangleadj] = ACTIONS(2243),
    [anon_sym_lineadj] = ACTIONS(2243),
    [anon_sym_triangle] = ACTIONS(2243),
    [anon_sym_interface] = ACTIONS(2243),
    [anon_sym_extension] = ACTIONS(2243),
    [anon_sym___exported] = ACTIONS(2243),
  },
  [147] = {
    [ts_builtin_sym_end] = ACTIONS(2314),
    [sym_identifier] = ACTIONS(2312),
    [aux_sym_preproc_include_token1] = ACTIONS(2312),
    [aux_sym_preproc_def_token1] = ACTIONS(2312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2314),
    [aux_sym_preproc_if_token1] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2312),
    [sym_preproc_directive] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_SLASH] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2312),
    [anon_sym_PIPE_PIPE] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2314),
    [anon_sym_PIPE] = ACTIONS(2312),
    [anon_sym_CARET] = ACTIONS(2312),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_EQ_EQ] = ACTIONS(2314),
    [anon_sym_BANG_EQ] = ACTIONS(2314),
    [anon_sym_GT] = ACTIONS(2312),
    [anon_sym_GT_EQ] = ACTIONS(2314),
    [anon_sym_LT_EQ] = ACTIONS(2312),
    [anon_sym_LT] = ACTIONS(2312),
    [anon_sym_LT_LT] = ACTIONS(2312),
    [anon_sym_GT_GT] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym___extension__] = ACTIONS(2312),
    [anon_sym_typedef] = ACTIONS(2312),
    [anon_sym_in] = ACTIONS(2312),
    [anon_sym_out] = ACTIONS(2312),
    [anon_sym_inout] = ACTIONS(2312),
    [anon_sym_virtual] = ACTIONS(2312),
    [anon_sym_extern] = ACTIONS(2312),
    [anon_sym___attribute__] = ACTIONS(2312),
    [anon_sym___attribute] = ACTIONS(2312),
    [anon_sym_using] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2314),
    [anon_sym___declspec] = ACTIONS(2312),
    [anon_sym___based] = ACTIONS(2312),
    [anon_sym___cdecl] = ACTIONS(2312),
    [anon_sym___clrcall] = ACTIONS(2312),
    [anon_sym___stdcall] = ACTIONS(2312),
    [anon_sym___fastcall] = ACTIONS(2312),
    [anon_sym___thiscall] = ACTIONS(2312),
    [anon_sym___vectorcall] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_signed] = ACTIONS(2312),
    [anon_sym_unsigned] = ACTIONS(2312),
    [anon_sym_long] = ACTIONS(2312),
    [anon_sym_short] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_EQ] = ACTIONS(2312),
    [anon_sym_register] = ACTIONS(2312),
    [anon_sym_inline] = ACTIONS(2312),
    [anon_sym___inline] = ACTIONS(2312),
    [anon_sym___inline__] = ACTIONS(2312),
    [anon_sym___forceinline] = ACTIONS(2312),
    [anon_sym_thread_local] = ACTIONS(2312),
    [anon_sym___thread] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_constexpr] = ACTIONS(2312),
    [anon_sym_volatile] = ACTIONS(2312),
    [anon_sym_restrict] = ACTIONS(2312),
    [anon_sym___restrict__] = ACTIONS(2312),
    [anon_sym__Atomic] = ACTIONS(2312),
    [anon_sym__Noreturn] = ACTIONS(2312),
    [anon_sym_noreturn] = ACTIONS(2312),
    [anon_sym__Nonnull] = ACTIONS(2312),
    [anon_sym_mutable] = ACTIONS(2312),
    [anon_sym_constinit] = ACTIONS(2312),
    [anon_sym_consteval] = ACTIONS(2312),
    [anon_sym_alignas] = ACTIONS(2312),
    [anon_sym__Alignas] = ACTIONS(2312),
    [sym_primitive_type] = ACTIONS(2312),
    [anon_sym_enum] = ACTIONS(2312),
    [anon_sym_class] = ACTIONS(2312),
    [anon_sym_struct] = ACTIONS(2312),
    [anon_sym_union] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_switch] = ACTIONS(2312),
    [anon_sym_case] = ACTIONS(2312),
    [anon_sym_default] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_break] = ACTIONS(2312),
    [anon_sym_continue] = ACTIONS(2312),
    [anon_sym_goto] = ACTIONS(2312),
    [anon_sym_QMARK] = ACTIONS(2314),
    [anon_sym_STAR_EQ] = ACTIONS(2314),
    [anon_sym_SLASH_EQ] = ACTIONS(2314),
    [anon_sym_PERCENT_EQ] = ACTIONS(2314),
    [anon_sym_PLUS_EQ] = ACTIONS(2314),
    [anon_sym_DASH_EQ] = ACTIONS(2314),
    [anon_sym_LT_LT_EQ] = ACTIONS(2314),
    [anon_sym_GT_GT_EQ] = ACTIONS(2314),
    [anon_sym_AMP_EQ] = ACTIONS(2314),
    [anon_sym_CARET_EQ] = ACTIONS(2314),
    [anon_sym_PIPE_EQ] = ACTIONS(2314),
    [anon_sym_and_eq] = ACTIONS(2312),
    [anon_sym_or_eq] = ACTIONS(2312),
    [anon_sym_xor_eq] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2312),
    [anon_sym_compl] = ACTIONS(2312),
    [anon_sym_LT_EQ_GT] = ACTIONS(2314),
    [anon_sym_or] = ACTIONS(2312),
    [anon_sym_and] = ACTIONS(2312),
    [anon_sym_bitor] = ACTIONS(2312),
    [anon_sym_xor] = ACTIONS(2312),
    [anon_sym_bitand] = ACTIONS(2312),
    [anon_sym_not_eq] = ACTIONS(2312),
    [anon_sym_is] = ACTIONS(2312),
    [anon_sym_as] = ACTIONS(2312),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_sizeof] = ACTIONS(2312),
    [anon_sym___alignof__] = ACTIONS(2312),
    [anon_sym___alignof] = ACTIONS(2312),
    [anon_sym__alignof] = ACTIONS(2312),
    [anon_sym_alignof] = ACTIONS(2312),
    [anon_sym__Alignof] = ACTIONS(2312),
    [anon_sym_offsetof] = ACTIONS(2312),
    [anon_sym__Generic] = ACTIONS(2312),
    [anon_sym_asm] = ACTIONS(2312),
    [anon_sym___asm__] = ACTIONS(2312),
    [anon_sym___asm] = ACTIONS(2312),
    [anon_sym_DOT] = ACTIONS(2312),
    [anon_sym_DOT_STAR] = ACTIONS(2314),
    [anon_sym_DASH_GT] = ACTIONS(2314),
    [sym_number_literal] = ACTIONS(2314),
    [anon_sym_L_SQUOTE] = ACTIONS(2314),
    [anon_sym_u_SQUOTE] = ACTIONS(2314),
    [anon_sym_U_SQUOTE] = ACTIONS(2314),
    [anon_sym_u8_SQUOTE] = ACTIONS(2314),
    [anon_sym_SQUOTE] = ACTIONS(2314),
    [anon_sym_L_DQUOTE] = ACTIONS(2314),
    [anon_sym_u_DQUOTE] = ACTIONS(2314),
    [anon_sym_U_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE] = ACTIONS(2314),
    [sym_true] = ACTIONS(2312),
    [sym_false] = ACTIONS(2312),
    [anon_sym_NULL] = ACTIONS(2312),
    [anon_sym_nullptr] = ACTIONS(2312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_This] = ACTIONS(2312),
    [anon_sym_decltype] = ACTIONS(2312),
    [anon_sym_explicit] = ACTIONS(2312),
    [anon_sym_typename] = ACTIONS(2312),
    [anon_sym_export] = ACTIONS(2312),
    [anon_sym_module] = ACTIONS(2312),
    [anon_sym_import] = ACTIONS(2312),
    [anon_sym_template] = ACTIONS(2312),
    [anon_sym_operator] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_delete] = ACTIONS(2312),
    [anon_sym_throw] = ACTIONS(2312),
    [anon_sym_namespace] = ACTIONS(2312),
    [anon_sym_static_assert] = ACTIONS(2312),
    [anon_sym_concept] = ACTIONS(2312),
    [anon_sym_co_return] = ACTIONS(2312),
    [anon_sym_co_yield] = ACTIONS(2312),
    [anon_sym_R_DQUOTE] = ACTIONS(2314),
    [anon_sym_LR_DQUOTE] = ACTIONS(2314),
    [anon_sym_uR_DQUOTE] = ACTIONS(2314),
    [anon_sym_UR_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2314),
    [anon_sym_co_await] = ACTIONS(2312),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_requires] = ACTIONS(2312),
    [sym_this] = ACTIONS(2312),
    [anon_sym_precise] = ACTIONS(2312),
    [anon_sym_shared] = ACTIONS(2312),
    [anon_sym_groupshared] = ACTIONS(2312),
    [anon_sym_uniform] = ACTIONS(2312),
    [anon_sym_row_major] = ACTIONS(2312),
    [anon_sym_column_major] = ACTIONS(2312),
    [anon_sym_globallycoherent] = ACTIONS(2312),
    [anon_sym_centroid] = ACTIONS(2312),
    [anon_sym_noperspective] = ACTIONS(2312),
    [anon_sym_nointerpolation] = ACTIONS(2312),
    [anon_sym_sample] = ACTIONS(2312),
    [anon_sym_linear] = ACTIONS(2312),
    [anon_sym_snorm] = ACTIONS(2312),
    [anon_sym_unorm] = ACTIONS(2312),
    [anon_sym_point] = ACTIONS(2312),
    [anon_sym_line] = ACTIONS(2312),
    [anon_sym_triangleadj] = ACTIONS(2312),
    [anon_sym_lineadj] = ACTIONS(2312),
    [anon_sym_triangle] = ACTIONS(2312),
    [anon_sym_interface] = ACTIONS(2312),
    [anon_sym_extension] = ACTIONS(2312),
    [anon_sym___exported] = ACTIONS(2312),
  },
  [148] = {
    [ts_builtin_sym_end] = ACTIONS(2270),
    [sym_identifier] = ACTIONS(2268),
    [aux_sym_preproc_include_token1] = ACTIONS(2268),
    [aux_sym_preproc_def_token1] = ACTIONS(2268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2270),
    [anon_sym_COMMA] = ACTIONS(2270),
    [anon_sym_RPAREN] = ACTIONS(2270),
    [aux_sym_preproc_if_token1] = ACTIONS(2268),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2268),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2268),
    [sym_preproc_directive] = ACTIONS(2268),
    [anon_sym_LPAREN2] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2268),
    [anon_sym_TILDE] = ACTIONS(2270),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2270),
    [anon_sym_SLASH] = ACTIONS(2268),
    [anon_sym_PERCENT] = ACTIONS(2270),
    [anon_sym_PIPE_PIPE] = ACTIONS(2270),
    [anon_sym_AMP_AMP] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2268),
    [anon_sym_CARET] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(2268),
    [anon_sym_EQ_EQ] = ACTIONS(2270),
    [anon_sym_BANG_EQ] = ACTIONS(2270),
    [anon_sym_GT] = ACTIONS(2268),
    [anon_sym_GT_EQ] = ACTIONS(2270),
    [anon_sym_LT_EQ] = ACTIONS(2268),
    [anon_sym_LT] = ACTIONS(2268),
    [anon_sym_LT_LT] = ACTIONS(2270),
    [anon_sym_GT_GT] = ACTIONS(2270),
    [anon_sym_COLON] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym___extension__] = ACTIONS(2268),
    [anon_sym_typedef] = ACTIONS(2268),
    [anon_sym_in] = ACTIONS(2268),
    [anon_sym_out] = ACTIONS(2268),
    [anon_sym_inout] = ACTIONS(2268),
    [anon_sym_virtual] = ACTIONS(2268),
    [anon_sym_extern] = ACTIONS(2268),
    [anon_sym___attribute__] = ACTIONS(2268),
    [anon_sym___attribute] = ACTIONS(2268),
    [anon_sym_using] = ACTIONS(2268),
    [anon_sym_COLON_COLON] = ACTIONS(2270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2270),
    [anon_sym___declspec] = ACTIONS(2268),
    [anon_sym___based] = ACTIONS(2268),
    [anon_sym___cdecl] = ACTIONS(2268),
    [anon_sym___clrcall] = ACTIONS(2268),
    [anon_sym___stdcall] = ACTIONS(2268),
    [anon_sym___fastcall] = ACTIONS(2268),
    [anon_sym___thiscall] = ACTIONS(2268),
    [anon_sym___vectorcall] = ACTIONS(2268),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_signed] = ACTIONS(2268),
    [anon_sym_unsigned] = ACTIONS(2268),
    [anon_sym_long] = ACTIONS(2268),
    [anon_sym_short] = ACTIONS(2268),
    [anon_sym_LBRACK] = ACTIONS(2268),
    [anon_sym_static] = ACTIONS(2268),
    [anon_sym_RBRACK] = ACTIONS(2270),
    [anon_sym_register] = ACTIONS(2268),
    [anon_sym_inline] = ACTIONS(2268),
    [anon_sym___inline] = ACTIONS(2268),
    [anon_sym___inline__] = ACTIONS(2268),
    [anon_sym___forceinline] = ACTIONS(2268),
    [anon_sym_thread_local] = ACTIONS(2268),
    [anon_sym___thread] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_constexpr] = ACTIONS(2268),
    [anon_sym_volatile] = ACTIONS(2268),
    [anon_sym_restrict] = ACTIONS(2268),
    [anon_sym___restrict__] = ACTIONS(2268),
    [anon_sym__Atomic] = ACTIONS(2268),
    [anon_sym__Noreturn] = ACTIONS(2268),
    [anon_sym_noreturn] = ACTIONS(2268),
    [anon_sym__Nonnull] = ACTIONS(2268),
    [anon_sym_mutable] = ACTIONS(2268),
    [anon_sym_constinit] = ACTIONS(2268),
    [anon_sym_consteval] = ACTIONS(2268),
    [anon_sym_alignas] = ACTIONS(2268),
    [anon_sym__Alignas] = ACTIONS(2268),
    [sym_primitive_type] = ACTIONS(2268),
    [anon_sym_enum] = ACTIONS(2268),
    [anon_sym_class] = ACTIONS(2268),
    [anon_sym_struct] = ACTIONS(2268),
    [anon_sym_union] = ACTIONS(2268),
    [anon_sym_if] = ACTIONS(2268),
    [anon_sym_else] = ACTIONS(2268),
    [anon_sym_switch] = ACTIONS(2268),
    [anon_sym_case] = ACTIONS(2268),
    [anon_sym_default] = ACTIONS(2268),
    [anon_sym_while] = ACTIONS(2268),
    [anon_sym_do] = ACTIONS(2268),
    [anon_sym_for] = ACTIONS(2268),
    [anon_sym_return] = ACTIONS(2268),
    [anon_sym_break] = ACTIONS(2268),
    [anon_sym_continue] = ACTIONS(2268),
    [anon_sym_goto] = ACTIONS(2268),
    [anon_sym_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2268),
    [anon_sym_compl] = ACTIONS(2268),
    [anon_sym_LT_EQ_GT] = ACTIONS(2270),
    [anon_sym_or] = ACTIONS(2268),
    [anon_sym_and] = ACTIONS(2268),
    [anon_sym_bitor] = ACTIONS(2268),
    [anon_sym_xor] = ACTIONS(2268),
    [anon_sym_bitand] = ACTIONS(2268),
    [anon_sym_not_eq] = ACTIONS(2268),
    [anon_sym_is] = ACTIONS(2268),
    [anon_sym_as] = ACTIONS(2268),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_sizeof] = ACTIONS(2268),
    [anon_sym___alignof__] = ACTIONS(2268),
    [anon_sym___alignof] = ACTIONS(2268),
    [anon_sym__alignof] = ACTIONS(2268),
    [anon_sym_alignof] = ACTIONS(2268),
    [anon_sym__Alignof] = ACTIONS(2268),
    [anon_sym_offsetof] = ACTIONS(2268),
    [anon_sym__Generic] = ACTIONS(2268),
    [anon_sym_asm] = ACTIONS(2268),
    [anon_sym___asm__] = ACTIONS(2268),
    [anon_sym___asm] = ACTIONS(2268),
    [anon_sym_DOT] = ACTIONS(2268),
    [anon_sym_DOT_STAR] = ACTIONS(2270),
    [anon_sym_DASH_GT] = ACTIONS(2270),
    [sym_number_literal] = ACTIONS(2270),
    [anon_sym_L_SQUOTE] = ACTIONS(2270),
    [anon_sym_u_SQUOTE] = ACTIONS(2270),
    [anon_sym_U_SQUOTE] = ACTIONS(2270),
    [anon_sym_u8_SQUOTE] = ACTIONS(2270),
    [anon_sym_SQUOTE] = ACTIONS(2270),
    [anon_sym_L_DQUOTE] = ACTIONS(2270),
    [anon_sym_u_DQUOTE] = ACTIONS(2270),
    [anon_sym_U_DQUOTE] = ACTIONS(2270),
    [anon_sym_u8_DQUOTE] = ACTIONS(2270),
    [anon_sym_DQUOTE] = ACTIONS(2270),
    [sym_true] = ACTIONS(2268),
    [sym_false] = ACTIONS(2268),
    [anon_sym_NULL] = ACTIONS(2268),
    [anon_sym_nullptr] = ACTIONS(2268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_This] = ACTIONS(2268),
    [anon_sym_decltype] = ACTIONS(2268),
    [anon_sym_final] = ACTIONS(2268),
    [anon_sym_override] = ACTIONS(2268),
    [anon_sym_explicit] = ACTIONS(2268),
    [anon_sym_typename] = ACTIONS(2268),
    [anon_sym_export] = ACTIONS(2268),
    [anon_sym_module] = ACTIONS(2268),
    [anon_sym_import] = ACTIONS(2268),
    [anon_sym_template] = ACTIONS(2268),
    [anon_sym_operator] = ACTIONS(2268),
    [anon_sym_try] = ACTIONS(2268),
    [anon_sym_delete] = ACTIONS(2268),
    [anon_sym_noexcept] = ACTIONS(2268),
    [anon_sym_throw] = ACTIONS(2268),
    [anon_sym_namespace] = ACTIONS(2268),
    [anon_sym_static_assert] = ACTIONS(2268),
    [anon_sym_concept] = ACTIONS(2268),
    [anon_sym_co_return] = ACTIONS(2268),
    [anon_sym_co_yield] = ACTIONS(2268),
    [anon_sym_R_DQUOTE] = ACTIONS(2270),
    [anon_sym_LR_DQUOTE] = ACTIONS(2270),
    [anon_sym_uR_DQUOTE] = ACTIONS(2270),
    [anon_sym_UR_DQUOTE] = ACTIONS(2270),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2270),
    [anon_sym_co_await] = ACTIONS(2268),
    [anon_sym_new] = ACTIONS(2268),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2268),
    [anon_sym_precise] = ACTIONS(2268),
    [anon_sym_shared] = ACTIONS(2268),
    [anon_sym_groupshared] = ACTIONS(2268),
    [anon_sym_uniform] = ACTIONS(2268),
    [anon_sym_row_major] = ACTIONS(2268),
    [anon_sym_column_major] = ACTIONS(2268),
    [anon_sym_globallycoherent] = ACTIONS(2268),
    [anon_sym_centroid] = ACTIONS(2268),
    [anon_sym_noperspective] = ACTIONS(2268),
    [anon_sym_nointerpolation] = ACTIONS(2268),
    [anon_sym_sample] = ACTIONS(2268),
    [anon_sym_linear] = ACTIONS(2268),
    [anon_sym_snorm] = ACTIONS(2268),
    [anon_sym_unorm] = ACTIONS(2268),
    [anon_sym_point] = ACTIONS(2268),
    [anon_sym_line] = ACTIONS(2268),
    [anon_sym_triangleadj] = ACTIONS(2268),
    [anon_sym_lineadj] = ACTIONS(2268),
    [anon_sym_triangle] = ACTIONS(2268),
    [anon_sym_interface] = ACTIONS(2268),
    [anon_sym_extension] = ACTIONS(2268),
    [anon_sym_where] = ACTIONS(2268),
    [anon_sym___exported] = ACTIONS(2268),
  },
  [149] = {
    [ts_builtin_sym_end] = ACTIONS(2298),
    [sym_identifier] = ACTIONS(2296),
    [aux_sym_preproc_include_token1] = ACTIONS(2296),
    [aux_sym_preproc_def_token1] = ACTIONS(2296),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2298),
    [anon_sym_COMMA] = ACTIONS(2298),
    [anon_sym_RPAREN] = ACTIONS(2298),
    [aux_sym_preproc_if_token1] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2296),
    [sym_preproc_directive] = ACTIONS(2296),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2298),
    [anon_sym_SLASH] = ACTIONS(2296),
    [anon_sym_PERCENT] = ACTIONS(2298),
    [anon_sym_PIPE_PIPE] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_PIPE] = ACTIONS(2296),
    [anon_sym_CARET] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_EQ_EQ] = ACTIONS(2298),
    [anon_sym_BANG_EQ] = ACTIONS(2298),
    [anon_sym_GT] = ACTIONS(2296),
    [anon_sym_GT_EQ] = ACTIONS(2298),
    [anon_sym_LT_EQ] = ACTIONS(2296),
    [anon_sym_LT] = ACTIONS(2296),
    [anon_sym_LT_LT] = ACTIONS(2298),
    [anon_sym_GT_GT] = ACTIONS(2298),
    [anon_sym_COLON] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2298),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym_typedef] = ACTIONS(2296),
    [anon_sym_in] = ACTIONS(2296),
    [anon_sym_out] = ACTIONS(2296),
    [anon_sym_inout] = ACTIONS(2296),
    [anon_sym_virtual] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym___attribute] = ACTIONS(2296),
    [anon_sym_using] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2298),
    [anon_sym___declspec] = ACTIONS(2296),
    [anon_sym___based] = ACTIONS(2296),
    [anon_sym___cdecl] = ACTIONS(2296),
    [anon_sym___clrcall] = ACTIONS(2296),
    [anon_sym___stdcall] = ACTIONS(2296),
    [anon_sym___fastcall] = ACTIONS(2296),
    [anon_sym___thiscall] = ACTIONS(2296),
    [anon_sym___vectorcall] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_signed] = ACTIONS(2296),
    [anon_sym_unsigned] = ACTIONS(2296),
    [anon_sym_long] = ACTIONS(2296),
    [anon_sym_short] = ACTIONS(2296),
    [anon_sym_LBRACK] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_RBRACK] = ACTIONS(2298),
    [anon_sym_register] = ACTIONS(2296),
    [anon_sym_inline] = ACTIONS(2296),
    [anon_sym___inline] = ACTIONS(2296),
    [anon_sym___inline__] = ACTIONS(2296),
    [anon_sym___forceinline] = ACTIONS(2296),
    [anon_sym_thread_local] = ACTIONS(2296),
    [anon_sym___thread] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym__Nonnull] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [sym_primitive_type] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2296),
    [anon_sym_class] = ACTIONS(2296),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_union] = ACTIONS(2296),
    [anon_sym_if] = ACTIONS(2296),
    [anon_sym_else] = ACTIONS(2296),
    [anon_sym_switch] = ACTIONS(2296),
    [anon_sym_case] = ACTIONS(2296),
    [anon_sym_default] = ACTIONS(2296),
    [anon_sym_while] = ACTIONS(2296),
    [anon_sym_do] = ACTIONS(2296),
    [anon_sym_for] = ACTIONS(2296),
    [anon_sym_return] = ACTIONS(2296),
    [anon_sym_break] = ACTIONS(2296),
    [anon_sym_continue] = ACTIONS(2296),
    [anon_sym_goto] = ACTIONS(2296),
    [anon_sym_QMARK] = ACTIONS(2298),
    [anon_sym_not] = ACTIONS(2296),
    [anon_sym_compl] = ACTIONS(2296),
    [anon_sym_LT_EQ_GT] = ACTIONS(2298),
    [anon_sym_or] = ACTIONS(2296),
    [anon_sym_and] = ACTIONS(2296),
    [anon_sym_bitor] = ACTIONS(2296),
    [anon_sym_xor] = ACTIONS(2296),
    [anon_sym_bitand] = ACTIONS(2296),
    [anon_sym_not_eq] = ACTIONS(2296),
    [anon_sym_is] = ACTIONS(2296),
    [anon_sym_as] = ACTIONS(2296),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_sizeof] = ACTIONS(2296),
    [anon_sym___alignof__] = ACTIONS(2296),
    [anon_sym___alignof] = ACTIONS(2296),
    [anon_sym__alignof] = ACTIONS(2296),
    [anon_sym_alignof] = ACTIONS(2296),
    [anon_sym__Alignof] = ACTIONS(2296),
    [anon_sym_offsetof] = ACTIONS(2296),
    [anon_sym__Generic] = ACTIONS(2296),
    [anon_sym_asm] = ACTIONS(2296),
    [anon_sym___asm__] = ACTIONS(2296),
    [anon_sym___asm] = ACTIONS(2296),
    [anon_sym_DOT] = ACTIONS(2296),
    [anon_sym_DOT_STAR] = ACTIONS(2298),
    [anon_sym_DASH_GT] = ACTIONS(2298),
    [sym_number_literal] = ACTIONS(2298),
    [anon_sym_L_SQUOTE] = ACTIONS(2298),
    [anon_sym_u_SQUOTE] = ACTIONS(2298),
    [anon_sym_U_SQUOTE] = ACTIONS(2298),
    [anon_sym_u8_SQUOTE] = ACTIONS(2298),
    [anon_sym_SQUOTE] = ACTIONS(2298),
    [anon_sym_L_DQUOTE] = ACTIONS(2298),
    [anon_sym_u_DQUOTE] = ACTIONS(2298),
    [anon_sym_U_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8_DQUOTE] = ACTIONS(2298),
    [anon_sym_DQUOTE] = ACTIONS(2298),
    [sym_true] = ACTIONS(2296),
    [sym_false] = ACTIONS(2296),
    [anon_sym_NULL] = ACTIONS(2296),
    [anon_sym_nullptr] = ACTIONS(2296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_This] = ACTIONS(2296),
    [anon_sym_decltype] = ACTIONS(2296),
    [anon_sym_final] = ACTIONS(2296),
    [anon_sym_override] = ACTIONS(2296),
    [anon_sym_explicit] = ACTIONS(2296),
    [anon_sym_typename] = ACTIONS(2296),
    [anon_sym_export] = ACTIONS(2296),
    [anon_sym_module] = ACTIONS(2296),
    [anon_sym_import] = ACTIONS(2296),
    [anon_sym_template] = ACTIONS(2296),
    [anon_sym_operator] = ACTIONS(2296),
    [anon_sym_try] = ACTIONS(2296),
    [anon_sym_delete] = ACTIONS(2296),
    [anon_sym_noexcept] = ACTIONS(2296),
    [anon_sym_throw] = ACTIONS(2296),
    [anon_sym_namespace] = ACTIONS(2296),
    [anon_sym_static_assert] = ACTIONS(2296),
    [anon_sym_concept] = ACTIONS(2296),
    [anon_sym_co_return] = ACTIONS(2296),
    [anon_sym_co_yield] = ACTIONS(2296),
    [anon_sym_R_DQUOTE] = ACTIONS(2298),
    [anon_sym_LR_DQUOTE] = ACTIONS(2298),
    [anon_sym_uR_DQUOTE] = ACTIONS(2298),
    [anon_sym_UR_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2298),
    [anon_sym_co_await] = ACTIONS(2296),
    [anon_sym_new] = ACTIONS(2296),
    [anon_sym_requires] = ACTIONS(2296),
    [sym_this] = ACTIONS(2296),
    [anon_sym_precise] = ACTIONS(2296),
    [anon_sym_shared] = ACTIONS(2296),
    [anon_sym_groupshared] = ACTIONS(2296),
    [anon_sym_uniform] = ACTIONS(2296),
    [anon_sym_row_major] = ACTIONS(2296),
    [anon_sym_column_major] = ACTIONS(2296),
    [anon_sym_globallycoherent] = ACTIONS(2296),
    [anon_sym_centroid] = ACTIONS(2296),
    [anon_sym_noperspective] = ACTIONS(2296),
    [anon_sym_nointerpolation] = ACTIONS(2296),
    [anon_sym_sample] = ACTIONS(2296),
    [anon_sym_linear] = ACTIONS(2296),
    [anon_sym_snorm] = ACTIONS(2296),
    [anon_sym_unorm] = ACTIONS(2296),
    [anon_sym_point] = ACTIONS(2296),
    [anon_sym_line] = ACTIONS(2296),
    [anon_sym_triangleadj] = ACTIONS(2296),
    [anon_sym_lineadj] = ACTIONS(2296),
    [anon_sym_triangle] = ACTIONS(2296),
    [anon_sym_interface] = ACTIONS(2296),
    [anon_sym_extension] = ACTIONS(2296),
    [anon_sym_where] = ACTIONS(2296),
    [anon_sym___exported] = ACTIONS(2296),
  },
  [150] = {
    [ts_builtin_sym_end] = ACTIONS(2314),
    [sym_identifier] = ACTIONS(2312),
    [aux_sym_preproc_include_token1] = ACTIONS(2312),
    [aux_sym_preproc_def_token1] = ACTIONS(2312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2314),
    [anon_sym_COMMA] = ACTIONS(2314),
    [anon_sym_RPAREN] = ACTIONS(2314),
    [aux_sym_preproc_if_token1] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2312),
    [sym_preproc_directive] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_SLASH] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2314),
    [anon_sym_PIPE_PIPE] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2314),
    [anon_sym_PIPE] = ACTIONS(2312),
    [anon_sym_CARET] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_EQ_EQ] = ACTIONS(2314),
    [anon_sym_BANG_EQ] = ACTIONS(2314),
    [anon_sym_GT] = ACTIONS(2312),
    [anon_sym_GT_EQ] = ACTIONS(2314),
    [anon_sym_LT_EQ] = ACTIONS(2312),
    [anon_sym_LT] = ACTIONS(2312),
    [anon_sym_LT_LT] = ACTIONS(2314),
    [anon_sym_GT_GT] = ACTIONS(2314),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym___extension__] = ACTIONS(2312),
    [anon_sym_typedef] = ACTIONS(2312),
    [anon_sym_in] = ACTIONS(2312),
    [anon_sym_out] = ACTIONS(2312),
    [anon_sym_inout] = ACTIONS(2312),
    [anon_sym_virtual] = ACTIONS(2312),
    [anon_sym_extern] = ACTIONS(2312),
    [anon_sym___attribute__] = ACTIONS(2312),
    [anon_sym___attribute] = ACTIONS(2312),
    [anon_sym_using] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2314),
    [anon_sym___declspec] = ACTIONS(2312),
    [anon_sym___based] = ACTIONS(2312),
    [anon_sym___cdecl] = ACTIONS(2312),
    [anon_sym___clrcall] = ACTIONS(2312),
    [anon_sym___stdcall] = ACTIONS(2312),
    [anon_sym___fastcall] = ACTIONS(2312),
    [anon_sym___thiscall] = ACTIONS(2312),
    [anon_sym___vectorcall] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_signed] = ACTIONS(2312),
    [anon_sym_unsigned] = ACTIONS(2312),
    [anon_sym_long] = ACTIONS(2312),
    [anon_sym_short] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_RBRACK] = ACTIONS(2314),
    [anon_sym_register] = ACTIONS(2312),
    [anon_sym_inline] = ACTIONS(2312),
    [anon_sym___inline] = ACTIONS(2312),
    [anon_sym___inline__] = ACTIONS(2312),
    [anon_sym___forceinline] = ACTIONS(2312),
    [anon_sym_thread_local] = ACTIONS(2312),
    [anon_sym___thread] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_constexpr] = ACTIONS(2312),
    [anon_sym_volatile] = ACTIONS(2312),
    [anon_sym_restrict] = ACTIONS(2312),
    [anon_sym___restrict__] = ACTIONS(2312),
    [anon_sym__Atomic] = ACTIONS(2312),
    [anon_sym__Noreturn] = ACTIONS(2312),
    [anon_sym_noreturn] = ACTIONS(2312),
    [anon_sym__Nonnull] = ACTIONS(2312),
    [anon_sym_mutable] = ACTIONS(2312),
    [anon_sym_constinit] = ACTIONS(2312),
    [anon_sym_consteval] = ACTIONS(2312),
    [anon_sym_alignas] = ACTIONS(2312),
    [anon_sym__Alignas] = ACTIONS(2312),
    [sym_primitive_type] = ACTIONS(2312),
    [anon_sym_enum] = ACTIONS(2312),
    [anon_sym_class] = ACTIONS(2312),
    [anon_sym_struct] = ACTIONS(2312),
    [anon_sym_union] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_else] = ACTIONS(2312),
    [anon_sym_switch] = ACTIONS(2312),
    [anon_sym_case] = ACTIONS(2312),
    [anon_sym_default] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_break] = ACTIONS(2312),
    [anon_sym_continue] = ACTIONS(2312),
    [anon_sym_goto] = ACTIONS(2312),
    [anon_sym_QMARK] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2312),
    [anon_sym_compl] = ACTIONS(2312),
    [anon_sym_LT_EQ_GT] = ACTIONS(2314),
    [anon_sym_or] = ACTIONS(2312),
    [anon_sym_and] = ACTIONS(2312),
    [anon_sym_bitor] = ACTIONS(2312),
    [anon_sym_xor] = ACTIONS(2312),
    [anon_sym_bitand] = ACTIONS(2312),
    [anon_sym_not_eq] = ACTIONS(2312),
    [anon_sym_is] = ACTIONS(2312),
    [anon_sym_as] = ACTIONS(2312),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_sizeof] = ACTIONS(2312),
    [anon_sym___alignof__] = ACTIONS(2312),
    [anon_sym___alignof] = ACTIONS(2312),
    [anon_sym__alignof] = ACTIONS(2312),
    [anon_sym_alignof] = ACTIONS(2312),
    [anon_sym__Alignof] = ACTIONS(2312),
    [anon_sym_offsetof] = ACTIONS(2312),
    [anon_sym__Generic] = ACTIONS(2312),
    [anon_sym_asm] = ACTIONS(2312),
    [anon_sym___asm__] = ACTIONS(2312),
    [anon_sym___asm] = ACTIONS(2312),
    [anon_sym_DOT] = ACTIONS(2312),
    [anon_sym_DOT_STAR] = ACTIONS(2314),
    [anon_sym_DASH_GT] = ACTIONS(2314),
    [sym_number_literal] = ACTIONS(2314),
    [anon_sym_L_SQUOTE] = ACTIONS(2314),
    [anon_sym_u_SQUOTE] = ACTIONS(2314),
    [anon_sym_U_SQUOTE] = ACTIONS(2314),
    [anon_sym_u8_SQUOTE] = ACTIONS(2314),
    [anon_sym_SQUOTE] = ACTIONS(2314),
    [anon_sym_L_DQUOTE] = ACTIONS(2314),
    [anon_sym_u_DQUOTE] = ACTIONS(2314),
    [anon_sym_U_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE] = ACTIONS(2314),
    [sym_true] = ACTIONS(2312),
    [sym_false] = ACTIONS(2312),
    [anon_sym_NULL] = ACTIONS(2312),
    [anon_sym_nullptr] = ACTIONS(2312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_This] = ACTIONS(2312),
    [anon_sym_decltype] = ACTIONS(2312),
    [anon_sym_final] = ACTIONS(2312),
    [anon_sym_override] = ACTIONS(2312),
    [anon_sym_explicit] = ACTIONS(2312),
    [anon_sym_typename] = ACTIONS(2312),
    [anon_sym_export] = ACTIONS(2312),
    [anon_sym_module] = ACTIONS(2312),
    [anon_sym_import] = ACTIONS(2312),
    [anon_sym_template] = ACTIONS(2312),
    [anon_sym_operator] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_delete] = ACTIONS(2312),
    [anon_sym_noexcept] = ACTIONS(2312),
    [anon_sym_throw] = ACTIONS(2312),
    [anon_sym_namespace] = ACTIONS(2312),
    [anon_sym_static_assert] = ACTIONS(2312),
    [anon_sym_concept] = ACTIONS(2312),
    [anon_sym_co_return] = ACTIONS(2312),
    [anon_sym_co_yield] = ACTIONS(2312),
    [anon_sym_R_DQUOTE] = ACTIONS(2314),
    [anon_sym_LR_DQUOTE] = ACTIONS(2314),
    [anon_sym_uR_DQUOTE] = ACTIONS(2314),
    [anon_sym_UR_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2314),
    [anon_sym_co_await] = ACTIONS(2312),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_requires] = ACTIONS(2312),
    [sym_this] = ACTIONS(2312),
    [anon_sym_precise] = ACTIONS(2312),
    [anon_sym_shared] = ACTIONS(2312),
    [anon_sym_groupshared] = ACTIONS(2312),
    [anon_sym_uniform] = ACTIONS(2312),
    [anon_sym_row_major] = ACTIONS(2312),
    [anon_sym_column_major] = ACTIONS(2312),
    [anon_sym_globallycoherent] = ACTIONS(2312),
    [anon_sym_centroid] = ACTIONS(2312),
    [anon_sym_noperspective] = ACTIONS(2312),
    [anon_sym_nointerpolation] = ACTIONS(2312),
    [anon_sym_sample] = ACTIONS(2312),
    [anon_sym_linear] = ACTIONS(2312),
    [anon_sym_snorm] = ACTIONS(2312),
    [anon_sym_unorm] = ACTIONS(2312),
    [anon_sym_point] = ACTIONS(2312),
    [anon_sym_line] = ACTIONS(2312),
    [anon_sym_triangleadj] = ACTIONS(2312),
    [anon_sym_lineadj] = ACTIONS(2312),
    [anon_sym_triangle] = ACTIONS(2312),
    [anon_sym_interface] = ACTIONS(2312),
    [anon_sym_extension] = ACTIONS(2312),
    [anon_sym_where] = ACTIONS(2312),
    [anon_sym___exported] = ACTIONS(2312),
  },
  [151] = {
    [ts_builtin_sym_end] = ACTIONS(2310),
    [sym_identifier] = ACTIONS(2308),
    [aux_sym_preproc_include_token1] = ACTIONS(2308),
    [aux_sym_preproc_def_token1] = ACTIONS(2308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2310),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_RPAREN] = ACTIONS(2310),
    [aux_sym_preproc_if_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2308),
    [sym_preproc_directive] = ACTIONS(2308),
    [anon_sym_LPAREN2] = ACTIONS(2310),
    [anon_sym_BANG] = ACTIONS(2308),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_SLASH] = ACTIONS(2308),
    [anon_sym_PERCENT] = ACTIONS(2310),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_CARET] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2310),
    [anon_sym_BANG_EQ] = ACTIONS(2310),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_EQ] = ACTIONS(2310),
    [anon_sym_LT_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_LT_LT] = ACTIONS(2310),
    [anon_sym_GT_GT] = ACTIONS(2310),
    [anon_sym_COLON] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(2308),
    [anon_sym_typedef] = ACTIONS(2308),
    [anon_sym_in] = ACTIONS(2308),
    [anon_sym_out] = ACTIONS(2308),
    [anon_sym_inout] = ACTIONS(2308),
    [anon_sym_virtual] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2308),
    [anon_sym___attribute__] = ACTIONS(2308),
    [anon_sym___attribute] = ACTIONS(2308),
    [anon_sym_using] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2310),
    [anon_sym___declspec] = ACTIONS(2308),
    [anon_sym___based] = ACTIONS(2308),
    [anon_sym___cdecl] = ACTIONS(2308),
    [anon_sym___clrcall] = ACTIONS(2308),
    [anon_sym___stdcall] = ACTIONS(2308),
    [anon_sym___fastcall] = ACTIONS(2308),
    [anon_sym___thiscall] = ACTIONS(2308),
    [anon_sym___vectorcall] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_signed] = ACTIONS(2308),
    [anon_sym_unsigned] = ACTIONS(2308),
    [anon_sym_long] = ACTIONS(2308),
    [anon_sym_short] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_RBRACK] = ACTIONS(2310),
    [anon_sym_register] = ACTIONS(2308),
    [anon_sym_inline] = ACTIONS(2308),
    [anon_sym___inline] = ACTIONS(2308),
    [anon_sym___inline__] = ACTIONS(2308),
    [anon_sym___forceinline] = ACTIONS(2308),
    [anon_sym_thread_local] = ACTIONS(2308),
    [anon_sym___thread] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_constexpr] = ACTIONS(2308),
    [anon_sym_volatile] = ACTIONS(2308),
    [anon_sym_restrict] = ACTIONS(2308),
    [anon_sym___restrict__] = ACTIONS(2308),
    [anon_sym__Atomic] = ACTIONS(2308),
    [anon_sym__Noreturn] = ACTIONS(2308),
    [anon_sym_noreturn] = ACTIONS(2308),
    [anon_sym__Nonnull] = ACTIONS(2308),
    [anon_sym_mutable] = ACTIONS(2308),
    [anon_sym_constinit] = ACTIONS(2308),
    [anon_sym_consteval] = ACTIONS(2308),
    [anon_sym_alignas] = ACTIONS(2308),
    [anon_sym__Alignas] = ACTIONS(2308),
    [sym_primitive_type] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_struct] = ACTIONS(2308),
    [anon_sym_union] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_else] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_case] = ACTIONS(2308),
    [anon_sym_default] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_goto] = ACTIONS(2308),
    [anon_sym_QMARK] = ACTIONS(2310),
    [anon_sym_not] = ACTIONS(2308),
    [anon_sym_compl] = ACTIONS(2308),
    [anon_sym_LT_EQ_GT] = ACTIONS(2310),
    [anon_sym_or] = ACTIONS(2308),
    [anon_sym_and] = ACTIONS(2308),
    [anon_sym_bitor] = ACTIONS(2308),
    [anon_sym_xor] = ACTIONS(2308),
    [anon_sym_bitand] = ACTIONS(2308),
    [anon_sym_not_eq] = ACTIONS(2308),
    [anon_sym_is] = ACTIONS(2308),
    [anon_sym_as] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_sizeof] = ACTIONS(2308),
    [anon_sym___alignof__] = ACTIONS(2308),
    [anon_sym___alignof] = ACTIONS(2308),
    [anon_sym__alignof] = ACTIONS(2308),
    [anon_sym_alignof] = ACTIONS(2308),
    [anon_sym__Alignof] = ACTIONS(2308),
    [anon_sym_offsetof] = ACTIONS(2308),
    [anon_sym__Generic] = ACTIONS(2308),
    [anon_sym_asm] = ACTIONS(2308),
    [anon_sym___asm__] = ACTIONS(2308),
    [anon_sym___asm] = ACTIONS(2308),
    [anon_sym_DOT] = ACTIONS(2308),
    [anon_sym_DOT_STAR] = ACTIONS(2310),
    [anon_sym_DASH_GT] = ACTIONS(2310),
    [sym_number_literal] = ACTIONS(2310),
    [anon_sym_L_SQUOTE] = ACTIONS(2310),
    [anon_sym_u_SQUOTE] = ACTIONS(2310),
    [anon_sym_U_SQUOTE] = ACTIONS(2310),
    [anon_sym_u8_SQUOTE] = ACTIONS(2310),
    [anon_sym_SQUOTE] = ACTIONS(2310),
    [anon_sym_L_DQUOTE] = ACTIONS(2310),
    [anon_sym_u_DQUOTE] = ACTIONS(2310),
    [anon_sym_U_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8_DQUOTE] = ACTIONS(2310),
    [anon_sym_DQUOTE] = ACTIONS(2310),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [anon_sym_NULL] = ACTIONS(2308),
    [anon_sym_nullptr] = ACTIONS(2308),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_This] = ACTIONS(2308),
    [anon_sym_decltype] = ACTIONS(2308),
    [anon_sym_final] = ACTIONS(2308),
    [anon_sym_override] = ACTIONS(2308),
    [anon_sym_explicit] = ACTIONS(2308),
    [anon_sym_typename] = ACTIONS(2308),
    [anon_sym_export] = ACTIONS(2308),
    [anon_sym_module] = ACTIONS(2308),
    [anon_sym_import] = ACTIONS(2308),
    [anon_sym_template] = ACTIONS(2308),
    [anon_sym_operator] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_delete] = ACTIONS(2308),
    [anon_sym_noexcept] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_namespace] = ACTIONS(2308),
    [anon_sym_static_assert] = ACTIONS(2308),
    [anon_sym_concept] = ACTIONS(2308),
    [anon_sym_co_return] = ACTIONS(2308),
    [anon_sym_co_yield] = ACTIONS(2308),
    [anon_sym_R_DQUOTE] = ACTIONS(2310),
    [anon_sym_LR_DQUOTE] = ACTIONS(2310),
    [anon_sym_uR_DQUOTE] = ACTIONS(2310),
    [anon_sym_UR_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2310),
    [anon_sym_co_await] = ACTIONS(2308),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_requires] = ACTIONS(2308),
    [sym_this] = ACTIONS(2308),
    [anon_sym_precise] = ACTIONS(2308),
    [anon_sym_shared] = ACTIONS(2308),
    [anon_sym_groupshared] = ACTIONS(2308),
    [anon_sym_uniform] = ACTIONS(2308),
    [anon_sym_row_major] = ACTIONS(2308),
    [anon_sym_column_major] = ACTIONS(2308),
    [anon_sym_globallycoherent] = ACTIONS(2308),
    [anon_sym_centroid] = ACTIONS(2308),
    [anon_sym_noperspective] = ACTIONS(2308),
    [anon_sym_nointerpolation] = ACTIONS(2308),
    [anon_sym_sample] = ACTIONS(2308),
    [anon_sym_linear] = ACTIONS(2308),
    [anon_sym_snorm] = ACTIONS(2308),
    [anon_sym_unorm] = ACTIONS(2308),
    [anon_sym_point] = ACTIONS(2308),
    [anon_sym_line] = ACTIONS(2308),
    [anon_sym_triangleadj] = ACTIONS(2308),
    [anon_sym_lineadj] = ACTIONS(2308),
    [anon_sym_triangle] = ACTIONS(2308),
    [anon_sym_interface] = ACTIONS(2308),
    [anon_sym_extension] = ACTIONS(2308),
    [anon_sym_where] = ACTIONS(2308),
    [anon_sym___exported] = ACTIONS(2308),
  },
  [152] = {
    [ts_builtin_sym_end] = ACTIONS(2262),
    [sym_identifier] = ACTIONS(2260),
    [aux_sym_preproc_include_token1] = ACTIONS(2260),
    [aux_sym_preproc_def_token1] = ACTIONS(2260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_COMMA] = ACTIONS(2262),
    [anon_sym_RPAREN] = ACTIONS(2262),
    [aux_sym_preproc_if_token1] = ACTIONS(2260),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2260),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2260),
    [sym_preproc_directive] = ACTIONS(2260),
    [anon_sym_LPAREN2] = ACTIONS(2262),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2262),
    [anon_sym_SLASH] = ACTIONS(2260),
    [anon_sym_PERCENT] = ACTIONS(2262),
    [anon_sym_PIPE_PIPE] = ACTIONS(2262),
    [anon_sym_AMP_AMP] = ACTIONS(2262),
    [anon_sym_PIPE] = ACTIONS(2260),
    [anon_sym_CARET] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_EQ_EQ] = ACTIONS(2262),
    [anon_sym_BANG_EQ] = ACTIONS(2262),
    [anon_sym_GT] = ACTIONS(2260),
    [anon_sym_GT_EQ] = ACTIONS(2262),
    [anon_sym_LT_EQ] = ACTIONS(2260),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_LT_LT] = ACTIONS(2262),
    [anon_sym_GT_GT] = ACTIONS(2262),
    [anon_sym_COLON] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym___extension__] = ACTIONS(2260),
    [anon_sym_typedef] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(2260),
    [anon_sym_out] = ACTIONS(2260),
    [anon_sym_inout] = ACTIONS(2260),
    [anon_sym_virtual] = ACTIONS(2260),
    [anon_sym_extern] = ACTIONS(2260),
    [anon_sym___attribute__] = ACTIONS(2260),
    [anon_sym___attribute] = ACTIONS(2260),
    [anon_sym_using] = ACTIONS(2260),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2262),
    [anon_sym___declspec] = ACTIONS(2260),
    [anon_sym___based] = ACTIONS(2260),
    [anon_sym___cdecl] = ACTIONS(2260),
    [anon_sym___clrcall] = ACTIONS(2260),
    [anon_sym___stdcall] = ACTIONS(2260),
    [anon_sym___fastcall] = ACTIONS(2260),
    [anon_sym___thiscall] = ACTIONS(2260),
    [anon_sym___vectorcall] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_signed] = ACTIONS(2260),
    [anon_sym_unsigned] = ACTIONS(2260),
    [anon_sym_long] = ACTIONS(2260),
    [anon_sym_short] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_RBRACK] = ACTIONS(2262),
    [anon_sym_register] = ACTIONS(2260),
    [anon_sym_inline] = ACTIONS(2260),
    [anon_sym___inline] = ACTIONS(2260),
    [anon_sym___inline__] = ACTIONS(2260),
    [anon_sym___forceinline] = ACTIONS(2260),
    [anon_sym_thread_local] = ACTIONS(2260),
    [anon_sym___thread] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_constexpr] = ACTIONS(2260),
    [anon_sym_volatile] = ACTIONS(2260),
    [anon_sym_restrict] = ACTIONS(2260),
    [anon_sym___restrict__] = ACTIONS(2260),
    [anon_sym__Atomic] = ACTIONS(2260),
    [anon_sym__Noreturn] = ACTIONS(2260),
    [anon_sym_noreturn] = ACTIONS(2260),
    [anon_sym__Nonnull] = ACTIONS(2260),
    [anon_sym_mutable] = ACTIONS(2260),
    [anon_sym_constinit] = ACTIONS(2260),
    [anon_sym_consteval] = ACTIONS(2260),
    [anon_sym_alignas] = ACTIONS(2260),
    [anon_sym__Alignas] = ACTIONS(2260),
    [sym_primitive_type] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
    [anon_sym_class] = ACTIONS(2260),
    [anon_sym_struct] = ACTIONS(2260),
    [anon_sym_union] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_else] = ACTIONS(2260),
    [anon_sym_switch] = ACTIONS(2260),
    [anon_sym_case] = ACTIONS(2260),
    [anon_sym_default] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_do] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_goto] = ACTIONS(2260),
    [anon_sym_QMARK] = ACTIONS(2262),
    [anon_sym_not] = ACTIONS(2260),
    [anon_sym_compl] = ACTIONS(2260),
    [anon_sym_LT_EQ_GT] = ACTIONS(2262),
    [anon_sym_or] = ACTIONS(2260),
    [anon_sym_and] = ACTIONS(2260),
    [anon_sym_bitor] = ACTIONS(2260),
    [anon_sym_xor] = ACTIONS(2260),
    [anon_sym_bitand] = ACTIONS(2260),
    [anon_sym_not_eq] = ACTIONS(2260),
    [anon_sym_is] = ACTIONS(2260),
    [anon_sym_as] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_sizeof] = ACTIONS(2260),
    [anon_sym___alignof__] = ACTIONS(2260),
    [anon_sym___alignof] = ACTIONS(2260),
    [anon_sym__alignof] = ACTIONS(2260),
    [anon_sym_alignof] = ACTIONS(2260),
    [anon_sym__Alignof] = ACTIONS(2260),
    [anon_sym_offsetof] = ACTIONS(2260),
    [anon_sym__Generic] = ACTIONS(2260),
    [anon_sym_asm] = ACTIONS(2260),
    [anon_sym___asm__] = ACTIONS(2260),
    [anon_sym___asm] = ACTIONS(2260),
    [anon_sym_DOT] = ACTIONS(2260),
    [anon_sym_DOT_STAR] = ACTIONS(2262),
    [anon_sym_DASH_GT] = ACTIONS(2262),
    [sym_number_literal] = ACTIONS(2262),
    [anon_sym_L_SQUOTE] = ACTIONS(2262),
    [anon_sym_u_SQUOTE] = ACTIONS(2262),
    [anon_sym_U_SQUOTE] = ACTIONS(2262),
    [anon_sym_u8_SQUOTE] = ACTIONS(2262),
    [anon_sym_SQUOTE] = ACTIONS(2262),
    [anon_sym_L_DQUOTE] = ACTIONS(2262),
    [anon_sym_u_DQUOTE] = ACTIONS(2262),
    [anon_sym_U_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8_DQUOTE] = ACTIONS(2262),
    [anon_sym_DQUOTE] = ACTIONS(2262),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [anon_sym_NULL] = ACTIONS(2260),
    [anon_sym_nullptr] = ACTIONS(2260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_This] = ACTIONS(2260),
    [anon_sym_decltype] = ACTIONS(2260),
    [anon_sym_final] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
    [anon_sym_explicit] = ACTIONS(2260),
    [anon_sym_typename] = ACTIONS(2260),
    [anon_sym_export] = ACTIONS(2260),
    [anon_sym_module] = ACTIONS(2260),
    [anon_sym_import] = ACTIONS(2260),
    [anon_sym_template] = ACTIONS(2260),
    [anon_sym_operator] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_noexcept] = ACTIONS(2260),
    [anon_sym_throw] = ACTIONS(2260),
    [anon_sym_namespace] = ACTIONS(2260),
    [anon_sym_static_assert] = ACTIONS(2260),
    [anon_sym_concept] = ACTIONS(2260),
    [anon_sym_co_return] = ACTIONS(2260),
    [anon_sym_co_yield] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2260),
    [anon_sym_new] = ACTIONS(2260),
    [anon_sym_requires] = ACTIONS(2260),
    [sym_this] = ACTIONS(2260),
    [anon_sym_precise] = ACTIONS(2260),
    [anon_sym_shared] = ACTIONS(2260),
    [anon_sym_groupshared] = ACTIONS(2260),
    [anon_sym_uniform] = ACTIONS(2260),
    [anon_sym_row_major] = ACTIONS(2260),
    [anon_sym_column_major] = ACTIONS(2260),
    [anon_sym_globallycoherent] = ACTIONS(2260),
    [anon_sym_centroid] = ACTIONS(2260),
    [anon_sym_noperspective] = ACTIONS(2260),
    [anon_sym_nointerpolation] = ACTIONS(2260),
    [anon_sym_sample] = ACTIONS(2260),
    [anon_sym_linear] = ACTIONS(2260),
    [anon_sym_snorm] = ACTIONS(2260),
    [anon_sym_unorm] = ACTIONS(2260),
    [anon_sym_point] = ACTIONS(2260),
    [anon_sym_line] = ACTIONS(2260),
    [anon_sym_triangleadj] = ACTIONS(2260),
    [anon_sym_lineadj] = ACTIONS(2260),
    [anon_sym_triangle] = ACTIONS(2260),
    [anon_sym_interface] = ACTIONS(2260),
    [anon_sym_extension] = ACTIONS(2260),
    [anon_sym_where] = ACTIONS(2260),
    [anon_sym___exported] = ACTIONS(2260),
  },
  [153] = {
    [ts_builtin_sym_end] = ACTIONS(2266),
    [sym_identifier] = ACTIONS(2264),
    [aux_sym_preproc_include_token1] = ACTIONS(2264),
    [aux_sym_preproc_def_token1] = ACTIONS(2264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2266),
    [anon_sym_COMMA] = ACTIONS(2266),
    [anon_sym_RPAREN] = ACTIONS(2266),
    [aux_sym_preproc_if_token1] = ACTIONS(2264),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2264),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2264),
    [sym_preproc_directive] = ACTIONS(2264),
    [anon_sym_LPAREN2] = ACTIONS(2266),
    [anon_sym_BANG] = ACTIONS(2264),
    [anon_sym_TILDE] = ACTIONS(2266),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2266),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_PERCENT] = ACTIONS(2266),
    [anon_sym_PIPE_PIPE] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2266),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_CARET] = ACTIONS(2266),
    [anon_sym_AMP] = ACTIONS(2264),
    [anon_sym_EQ_EQ] = ACTIONS(2266),
    [anon_sym_BANG_EQ] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(2264),
    [anon_sym_GT_EQ] = ACTIONS(2266),
    [anon_sym_LT_EQ] = ACTIONS(2264),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_LT_LT] = ACTIONS(2266),
    [anon_sym_GT_GT] = ACTIONS(2266),
    [anon_sym_COLON] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2266),
    [anon_sym___extension__] = ACTIONS(2264),
    [anon_sym_typedef] = ACTIONS(2264),
    [anon_sym_in] = ACTIONS(2264),
    [anon_sym_out] = ACTIONS(2264),
    [anon_sym_inout] = ACTIONS(2264),
    [anon_sym_virtual] = ACTIONS(2264),
    [anon_sym_extern] = ACTIONS(2264),
    [anon_sym___attribute__] = ACTIONS(2264),
    [anon_sym___attribute] = ACTIONS(2264),
    [anon_sym_using] = ACTIONS(2264),
    [anon_sym_COLON_COLON] = ACTIONS(2266),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2266),
    [anon_sym___declspec] = ACTIONS(2264),
    [anon_sym___based] = ACTIONS(2264),
    [anon_sym___cdecl] = ACTIONS(2264),
    [anon_sym___clrcall] = ACTIONS(2264),
    [anon_sym___stdcall] = ACTIONS(2264),
    [anon_sym___fastcall] = ACTIONS(2264),
    [anon_sym___thiscall] = ACTIONS(2264),
    [anon_sym___vectorcall] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_signed] = ACTIONS(2264),
    [anon_sym_unsigned] = ACTIONS(2264),
    [anon_sym_long] = ACTIONS(2264),
    [anon_sym_short] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_RBRACK] = ACTIONS(2266),
    [anon_sym_register] = ACTIONS(2264),
    [anon_sym_inline] = ACTIONS(2264),
    [anon_sym___inline] = ACTIONS(2264),
    [anon_sym___inline__] = ACTIONS(2264),
    [anon_sym___forceinline] = ACTIONS(2264),
    [anon_sym_thread_local] = ACTIONS(2264),
    [anon_sym___thread] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_constexpr] = ACTIONS(2264),
    [anon_sym_volatile] = ACTIONS(2264),
    [anon_sym_restrict] = ACTIONS(2264),
    [anon_sym___restrict__] = ACTIONS(2264),
    [anon_sym__Atomic] = ACTIONS(2264),
    [anon_sym__Noreturn] = ACTIONS(2264),
    [anon_sym_noreturn] = ACTIONS(2264),
    [anon_sym__Nonnull] = ACTIONS(2264),
    [anon_sym_mutable] = ACTIONS(2264),
    [anon_sym_constinit] = ACTIONS(2264),
    [anon_sym_consteval] = ACTIONS(2264),
    [anon_sym_alignas] = ACTIONS(2264),
    [anon_sym__Alignas] = ACTIONS(2264),
    [sym_primitive_type] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
    [anon_sym_class] = ACTIONS(2264),
    [anon_sym_struct] = ACTIONS(2264),
    [anon_sym_union] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_else] = ACTIONS(2264),
    [anon_sym_switch] = ACTIONS(2264),
    [anon_sym_case] = ACTIONS(2264),
    [anon_sym_default] = ACTIONS(2264),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_do] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_goto] = ACTIONS(2264),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_not] = ACTIONS(2264),
    [anon_sym_compl] = ACTIONS(2264),
    [anon_sym_LT_EQ_GT] = ACTIONS(2266),
    [anon_sym_or] = ACTIONS(2264),
    [anon_sym_and] = ACTIONS(2264),
    [anon_sym_bitor] = ACTIONS(2264),
    [anon_sym_xor] = ACTIONS(2264),
    [anon_sym_bitand] = ACTIONS(2264),
    [anon_sym_not_eq] = ACTIONS(2264),
    [anon_sym_is] = ACTIONS(2264),
    [anon_sym_as] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2266),
    [anon_sym_PLUS_PLUS] = ACTIONS(2266),
    [anon_sym_sizeof] = ACTIONS(2264),
    [anon_sym___alignof__] = ACTIONS(2264),
    [anon_sym___alignof] = ACTIONS(2264),
    [anon_sym__alignof] = ACTIONS(2264),
    [anon_sym_alignof] = ACTIONS(2264),
    [anon_sym__Alignof] = ACTIONS(2264),
    [anon_sym_offsetof] = ACTIONS(2264),
    [anon_sym__Generic] = ACTIONS(2264),
    [anon_sym_asm] = ACTIONS(2264),
    [anon_sym___asm__] = ACTIONS(2264),
    [anon_sym___asm] = ACTIONS(2264),
    [anon_sym_DOT] = ACTIONS(2264),
    [anon_sym_DOT_STAR] = ACTIONS(2266),
    [anon_sym_DASH_GT] = ACTIONS(2266),
    [sym_number_literal] = ACTIONS(2266),
    [anon_sym_L_SQUOTE] = ACTIONS(2266),
    [anon_sym_u_SQUOTE] = ACTIONS(2266),
    [anon_sym_U_SQUOTE] = ACTIONS(2266),
    [anon_sym_u8_SQUOTE] = ACTIONS(2266),
    [anon_sym_SQUOTE] = ACTIONS(2266),
    [anon_sym_L_DQUOTE] = ACTIONS(2266),
    [anon_sym_u_DQUOTE] = ACTIONS(2266),
    [anon_sym_U_DQUOTE] = ACTIONS(2266),
    [anon_sym_u8_DQUOTE] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(2266),
    [sym_true] = ACTIONS(2264),
    [sym_false] = ACTIONS(2264),
    [anon_sym_NULL] = ACTIONS(2264),
    [anon_sym_nullptr] = ACTIONS(2264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_This] = ACTIONS(2264),
    [anon_sym_decltype] = ACTIONS(2264),
    [anon_sym_final] = ACTIONS(2264),
    [anon_sym_override] = ACTIONS(2264),
    [anon_sym_explicit] = ACTIONS(2264),
    [anon_sym_typename] = ACTIONS(2264),
    [anon_sym_export] = ACTIONS(2264),
    [anon_sym_module] = ACTIONS(2264),
    [anon_sym_import] = ACTIONS(2264),
    [anon_sym_template] = ACTIONS(2264),
    [anon_sym_operator] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [anon_sym_delete] = ACTIONS(2264),
    [anon_sym_noexcept] = ACTIONS(2264),
    [anon_sym_throw] = ACTIONS(2264),
    [anon_sym_namespace] = ACTIONS(2264),
    [anon_sym_static_assert] = ACTIONS(2264),
    [anon_sym_concept] = ACTIONS(2264),
    [anon_sym_co_return] = ACTIONS(2264),
    [anon_sym_co_yield] = ACTIONS(2264),
    [anon_sym_R_DQUOTE] = ACTIONS(2266),
    [anon_sym_LR_DQUOTE] = ACTIONS(2266),
    [anon_sym_uR_DQUOTE] = ACTIONS(2266),
    [anon_sym_UR_DQUOTE] = ACTIONS(2266),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2266),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2264),
    [anon_sym_requires] = ACTIONS(2264),
    [sym_this] = ACTIONS(2264),
    [anon_sym_precise] = ACTIONS(2264),
    [anon_sym_shared] = ACTIONS(2264),
    [anon_sym_groupshared] = ACTIONS(2264),
    [anon_sym_uniform] = ACTIONS(2264),
    [anon_sym_row_major] = ACTIONS(2264),
    [anon_sym_column_major] = ACTIONS(2264),
    [anon_sym_globallycoherent] = ACTIONS(2264),
    [anon_sym_centroid] = ACTIONS(2264),
    [anon_sym_noperspective] = ACTIONS(2264),
    [anon_sym_nointerpolation] = ACTIONS(2264),
    [anon_sym_sample] = ACTIONS(2264),
    [anon_sym_linear] = ACTIONS(2264),
    [anon_sym_snorm] = ACTIONS(2264),
    [anon_sym_unorm] = ACTIONS(2264),
    [anon_sym_point] = ACTIONS(2264),
    [anon_sym_line] = ACTIONS(2264),
    [anon_sym_triangleadj] = ACTIONS(2264),
    [anon_sym_lineadj] = ACTIONS(2264),
    [anon_sym_triangle] = ACTIONS(2264),
    [anon_sym_interface] = ACTIONS(2264),
    [anon_sym_extension] = ACTIONS(2264),
    [anon_sym_where] = ACTIONS(2264),
    [anon_sym___exported] = ACTIONS(2264),
  },
  [154] = {
    [ts_builtin_sym_end] = ACTIONS(2302),
    [sym_identifier] = ACTIONS(2300),
    [aux_sym_preproc_include_token1] = ACTIONS(2300),
    [aux_sym_preproc_def_token1] = ACTIONS(2300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2302),
    [anon_sym_COMMA] = ACTIONS(2302),
    [anon_sym_RPAREN] = ACTIONS(2302),
    [aux_sym_preproc_if_token1] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2300),
    [sym_preproc_directive] = ACTIONS(2300),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_BANG] = ACTIONS(2300),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2302),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2302),
    [anon_sym_PIPE_PIPE] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_PIPE] = ACTIONS(2300),
    [anon_sym_CARET] = ACTIONS(2302),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_EQ_EQ] = ACTIONS(2302),
    [anon_sym_BANG_EQ] = ACTIONS(2302),
    [anon_sym_GT] = ACTIONS(2300),
    [anon_sym_GT_EQ] = ACTIONS(2302),
    [anon_sym_LT_EQ] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_LT_LT] = ACTIONS(2302),
    [anon_sym_GT_GT] = ACTIONS(2302),
    [anon_sym_COLON] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym_typedef] = ACTIONS(2300),
    [anon_sym_in] = ACTIONS(2300),
    [anon_sym_out] = ACTIONS(2300),
    [anon_sym_inout] = ACTIONS(2300),
    [anon_sym_virtual] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym___attribute] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2302),
    [anon_sym___declspec] = ACTIONS(2300),
    [anon_sym___based] = ACTIONS(2300),
    [anon_sym___cdecl] = ACTIONS(2300),
    [anon_sym___clrcall] = ACTIONS(2300),
    [anon_sym___stdcall] = ACTIONS(2300),
    [anon_sym___fastcall] = ACTIONS(2300),
    [anon_sym___thiscall] = ACTIONS(2300),
    [anon_sym___vectorcall] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_signed] = ACTIONS(2300),
    [anon_sym_unsigned] = ACTIONS(2300),
    [anon_sym_long] = ACTIONS(2300),
    [anon_sym_short] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_RBRACK] = ACTIONS(2302),
    [anon_sym_register] = ACTIONS(2300),
    [anon_sym_inline] = ACTIONS(2300),
    [anon_sym___inline] = ACTIONS(2300),
    [anon_sym___inline__] = ACTIONS(2300),
    [anon_sym___forceinline] = ACTIONS(2300),
    [anon_sym_thread_local] = ACTIONS(2300),
    [anon_sym___thread] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym__Nonnull] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [sym_primitive_type] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_struct] = ACTIONS(2300),
    [anon_sym_union] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_else] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_case] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_goto] = ACTIONS(2300),
    [anon_sym_QMARK] = ACTIONS(2302),
    [anon_sym_not] = ACTIONS(2300),
    [anon_sym_compl] = ACTIONS(2300),
    [anon_sym_LT_EQ_GT] = ACTIONS(2302),
    [anon_sym_or] = ACTIONS(2300),
    [anon_sym_and] = ACTIONS(2300),
    [anon_sym_bitor] = ACTIONS(2300),
    [anon_sym_xor] = ACTIONS(2300),
    [anon_sym_bitand] = ACTIONS(2300),
    [anon_sym_not_eq] = ACTIONS(2300),
    [anon_sym_is] = ACTIONS(2300),
    [anon_sym_as] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_sizeof] = ACTIONS(2300),
    [anon_sym___alignof__] = ACTIONS(2300),
    [anon_sym___alignof] = ACTIONS(2300),
    [anon_sym__alignof] = ACTIONS(2300),
    [anon_sym_alignof] = ACTIONS(2300),
    [anon_sym__Alignof] = ACTIONS(2300),
    [anon_sym_offsetof] = ACTIONS(2300),
    [anon_sym__Generic] = ACTIONS(2300),
    [anon_sym_asm] = ACTIONS(2300),
    [anon_sym___asm__] = ACTIONS(2300),
    [anon_sym___asm] = ACTIONS(2300),
    [anon_sym_DOT] = ACTIONS(2300),
    [anon_sym_DOT_STAR] = ACTIONS(2302),
    [anon_sym_DASH_GT] = ACTIONS(2302),
    [sym_number_literal] = ACTIONS(2302),
    [anon_sym_L_SQUOTE] = ACTIONS(2302),
    [anon_sym_u_SQUOTE] = ACTIONS(2302),
    [anon_sym_U_SQUOTE] = ACTIONS(2302),
    [anon_sym_u8_SQUOTE] = ACTIONS(2302),
    [anon_sym_SQUOTE] = ACTIONS(2302),
    [anon_sym_L_DQUOTE] = ACTIONS(2302),
    [anon_sym_u_DQUOTE] = ACTIONS(2302),
    [anon_sym_U_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8_DQUOTE] = ACTIONS(2302),
    [anon_sym_DQUOTE] = ACTIONS(2302),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [anon_sym_NULL] = ACTIONS(2300),
    [anon_sym_nullptr] = ACTIONS(2300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_This] = ACTIONS(2300),
    [anon_sym_decltype] = ACTIONS(2300),
    [anon_sym_final] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_explicit] = ACTIONS(2300),
    [anon_sym_typename] = ACTIONS(2300),
    [anon_sym_export] = ACTIONS(2300),
    [anon_sym_module] = ACTIONS(2300),
    [anon_sym_import] = ACTIONS(2300),
    [anon_sym_template] = ACTIONS(2300),
    [anon_sym_operator] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_noexcept] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_static_assert] = ACTIONS(2300),
    [anon_sym_concept] = ACTIONS(2300),
    [anon_sym_co_return] = ACTIONS(2300),
    [anon_sym_co_yield] = ACTIONS(2300),
    [anon_sym_R_DQUOTE] = ACTIONS(2302),
    [anon_sym_LR_DQUOTE] = ACTIONS(2302),
    [anon_sym_uR_DQUOTE] = ACTIONS(2302),
    [anon_sym_UR_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2302),
    [anon_sym_co_await] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_requires] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [anon_sym_precise] = ACTIONS(2300),
    [anon_sym_shared] = ACTIONS(2300),
    [anon_sym_groupshared] = ACTIONS(2300),
    [anon_sym_uniform] = ACTIONS(2300),
    [anon_sym_row_major] = ACTIONS(2300),
    [anon_sym_column_major] = ACTIONS(2300),
    [anon_sym_globallycoherent] = ACTIONS(2300),
    [anon_sym_centroid] = ACTIONS(2300),
    [anon_sym_noperspective] = ACTIONS(2300),
    [anon_sym_nointerpolation] = ACTIONS(2300),
    [anon_sym_sample] = ACTIONS(2300),
    [anon_sym_linear] = ACTIONS(2300),
    [anon_sym_snorm] = ACTIONS(2300),
    [anon_sym_unorm] = ACTIONS(2300),
    [anon_sym_point] = ACTIONS(2300),
    [anon_sym_line] = ACTIONS(2300),
    [anon_sym_triangleadj] = ACTIONS(2300),
    [anon_sym_lineadj] = ACTIONS(2300),
    [anon_sym_triangle] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_extension] = ACTIONS(2300),
    [anon_sym_where] = ACTIONS(2300),
    [anon_sym___exported] = ACTIONS(2300),
  },
  [155] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2276),
    [aux_sym_preproc_include_token1] = ACTIONS(2276),
    [aux_sym_preproc_def_token1] = ACTIONS(2276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2278),
    [anon_sym_COMMA] = ACTIONS(2278),
    [anon_sym_RPAREN] = ACTIONS(2278),
    [aux_sym_preproc_if_token1] = ACTIONS(2276),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2276),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2276),
    [sym_preproc_directive] = ACTIONS(2276),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_PLUS] = ACTIONS(2276),
    [anon_sym_STAR] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2276),
    [anon_sym_PERCENT] = ACTIONS(2278),
    [anon_sym_PIPE_PIPE] = ACTIONS(2278),
    [anon_sym_AMP_AMP] = ACTIONS(2278),
    [anon_sym_PIPE] = ACTIONS(2276),
    [anon_sym_CARET] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_EQ_EQ] = ACTIONS(2278),
    [anon_sym_BANG_EQ] = ACTIONS(2278),
    [anon_sym_GT] = ACTIONS(2276),
    [anon_sym_GT_EQ] = ACTIONS(2278),
    [anon_sym_LT_EQ] = ACTIONS(2276),
    [anon_sym_LT] = ACTIONS(2276),
    [anon_sym_LT_LT] = ACTIONS(2278),
    [anon_sym_GT_GT] = ACTIONS(2278),
    [anon_sym_COLON] = ACTIONS(2276),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym___extension__] = ACTIONS(2276),
    [anon_sym_typedef] = ACTIONS(2276),
    [anon_sym_in] = ACTIONS(2276),
    [anon_sym_out] = ACTIONS(2276),
    [anon_sym_inout] = ACTIONS(2276),
    [anon_sym_virtual] = ACTIONS(2276),
    [anon_sym_extern] = ACTIONS(2276),
    [anon_sym___attribute__] = ACTIONS(2276),
    [anon_sym___attribute] = ACTIONS(2276),
    [anon_sym_using] = ACTIONS(2276),
    [anon_sym_COLON_COLON] = ACTIONS(2278),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2278),
    [anon_sym___declspec] = ACTIONS(2276),
    [anon_sym___based] = ACTIONS(2276),
    [anon_sym___cdecl] = ACTIONS(2276),
    [anon_sym___clrcall] = ACTIONS(2276),
    [anon_sym___stdcall] = ACTIONS(2276),
    [anon_sym___fastcall] = ACTIONS(2276),
    [anon_sym___thiscall] = ACTIONS(2276),
    [anon_sym___vectorcall] = ACTIONS(2276),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_signed] = ACTIONS(2276),
    [anon_sym_unsigned] = ACTIONS(2276),
    [anon_sym_long] = ACTIONS(2276),
    [anon_sym_short] = ACTIONS(2276),
    [anon_sym_LBRACK] = ACTIONS(2276),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_RBRACK] = ACTIONS(2278),
    [anon_sym_register] = ACTIONS(2276),
    [anon_sym_inline] = ACTIONS(2276),
    [anon_sym___inline] = ACTIONS(2276),
    [anon_sym___inline__] = ACTIONS(2276),
    [anon_sym___forceinline] = ACTIONS(2276),
    [anon_sym_thread_local] = ACTIONS(2276),
    [anon_sym___thread] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_constexpr] = ACTIONS(2276),
    [anon_sym_volatile] = ACTIONS(2276),
    [anon_sym_restrict] = ACTIONS(2276),
    [anon_sym___restrict__] = ACTIONS(2276),
    [anon_sym__Atomic] = ACTIONS(2276),
    [anon_sym__Noreturn] = ACTIONS(2276),
    [anon_sym_noreturn] = ACTIONS(2276),
    [anon_sym__Nonnull] = ACTIONS(2276),
    [anon_sym_mutable] = ACTIONS(2276),
    [anon_sym_constinit] = ACTIONS(2276),
    [anon_sym_consteval] = ACTIONS(2276),
    [anon_sym_alignas] = ACTIONS(2276),
    [anon_sym__Alignas] = ACTIONS(2276),
    [sym_primitive_type] = ACTIONS(2276),
    [anon_sym_enum] = ACTIONS(2276),
    [anon_sym_class] = ACTIONS(2276),
    [anon_sym_struct] = ACTIONS(2276),
    [anon_sym_union] = ACTIONS(2276),
    [anon_sym_if] = ACTIONS(2276),
    [anon_sym_else] = ACTIONS(2276),
    [anon_sym_switch] = ACTIONS(2276),
    [anon_sym_case] = ACTIONS(2276),
    [anon_sym_default] = ACTIONS(2276),
    [anon_sym_while] = ACTIONS(2276),
    [anon_sym_do] = ACTIONS(2276),
    [anon_sym_for] = ACTIONS(2276),
    [anon_sym_return] = ACTIONS(2276),
    [anon_sym_break] = ACTIONS(2276),
    [anon_sym_continue] = ACTIONS(2276),
    [anon_sym_goto] = ACTIONS(2276),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_not] = ACTIONS(2276),
    [anon_sym_compl] = ACTIONS(2276),
    [anon_sym_LT_EQ_GT] = ACTIONS(2278),
    [anon_sym_or] = ACTIONS(2276),
    [anon_sym_and] = ACTIONS(2276),
    [anon_sym_bitor] = ACTIONS(2276),
    [anon_sym_xor] = ACTIONS(2276),
    [anon_sym_bitand] = ACTIONS(2276),
    [anon_sym_not_eq] = ACTIONS(2276),
    [anon_sym_is] = ACTIONS(2276),
    [anon_sym_as] = ACTIONS(2276),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_sizeof] = ACTIONS(2276),
    [anon_sym___alignof__] = ACTIONS(2276),
    [anon_sym___alignof] = ACTIONS(2276),
    [anon_sym__alignof] = ACTIONS(2276),
    [anon_sym_alignof] = ACTIONS(2276),
    [anon_sym__Alignof] = ACTIONS(2276),
    [anon_sym_offsetof] = ACTIONS(2276),
    [anon_sym__Generic] = ACTIONS(2276),
    [anon_sym_asm] = ACTIONS(2276),
    [anon_sym___asm__] = ACTIONS(2276),
    [anon_sym___asm] = ACTIONS(2276),
    [anon_sym_DOT] = ACTIONS(2276),
    [anon_sym_DOT_STAR] = ACTIONS(2278),
    [anon_sym_DASH_GT] = ACTIONS(2278),
    [sym_number_literal] = ACTIONS(2278),
    [anon_sym_L_SQUOTE] = ACTIONS(2278),
    [anon_sym_u_SQUOTE] = ACTIONS(2278),
    [anon_sym_U_SQUOTE] = ACTIONS(2278),
    [anon_sym_u8_SQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_L_DQUOTE] = ACTIONS(2278),
    [anon_sym_u_DQUOTE] = ACTIONS(2278),
    [anon_sym_U_DQUOTE] = ACTIONS(2278),
    [anon_sym_u8_DQUOTE] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [sym_true] = ACTIONS(2276),
    [sym_false] = ACTIONS(2276),
    [anon_sym_NULL] = ACTIONS(2276),
    [anon_sym_nullptr] = ACTIONS(2276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_This] = ACTIONS(2276),
    [anon_sym_decltype] = ACTIONS(2276),
    [anon_sym_final] = ACTIONS(2276),
    [anon_sym_override] = ACTIONS(2276),
    [anon_sym_explicit] = ACTIONS(2276),
    [anon_sym_typename] = ACTIONS(2276),
    [anon_sym_export] = ACTIONS(2276),
    [anon_sym_module] = ACTIONS(2276),
    [anon_sym_import] = ACTIONS(2276),
    [anon_sym_template] = ACTIONS(2276),
    [anon_sym_operator] = ACTIONS(2276),
    [anon_sym_try] = ACTIONS(2276),
    [anon_sym_delete] = ACTIONS(2276),
    [anon_sym_noexcept] = ACTIONS(2276),
    [anon_sym_throw] = ACTIONS(2276),
    [anon_sym_namespace] = ACTIONS(2276),
    [anon_sym_static_assert] = ACTIONS(2276),
    [anon_sym_concept] = ACTIONS(2276),
    [anon_sym_co_return] = ACTIONS(2276),
    [anon_sym_co_yield] = ACTIONS(2276),
    [anon_sym_R_DQUOTE] = ACTIONS(2278),
    [anon_sym_LR_DQUOTE] = ACTIONS(2278),
    [anon_sym_uR_DQUOTE] = ACTIONS(2278),
    [anon_sym_UR_DQUOTE] = ACTIONS(2278),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2278),
    [anon_sym_co_await] = ACTIONS(2276),
    [anon_sym_new] = ACTIONS(2276),
    [anon_sym_requires] = ACTIONS(2276),
    [sym_this] = ACTIONS(2276),
    [anon_sym_precise] = ACTIONS(2276),
    [anon_sym_shared] = ACTIONS(2276),
    [anon_sym_groupshared] = ACTIONS(2276),
    [anon_sym_uniform] = ACTIONS(2276),
    [anon_sym_row_major] = ACTIONS(2276),
    [anon_sym_column_major] = ACTIONS(2276),
    [anon_sym_globallycoherent] = ACTIONS(2276),
    [anon_sym_centroid] = ACTIONS(2276),
    [anon_sym_noperspective] = ACTIONS(2276),
    [anon_sym_nointerpolation] = ACTIONS(2276),
    [anon_sym_sample] = ACTIONS(2276),
    [anon_sym_linear] = ACTIONS(2276),
    [anon_sym_snorm] = ACTIONS(2276),
    [anon_sym_unorm] = ACTIONS(2276),
    [anon_sym_point] = ACTIONS(2276),
    [anon_sym_line] = ACTIONS(2276),
    [anon_sym_triangleadj] = ACTIONS(2276),
    [anon_sym_lineadj] = ACTIONS(2276),
    [anon_sym_triangle] = ACTIONS(2276),
    [anon_sym_interface] = ACTIONS(2276),
    [anon_sym_extension] = ACTIONS(2276),
    [anon_sym_where] = ACTIONS(2276),
    [anon_sym___exported] = ACTIONS(2276),
  },
  [156] = {
    [ts_builtin_sym_end] = ACTIONS(2306),
    [sym_identifier] = ACTIONS(2304),
    [aux_sym_preproc_include_token1] = ACTIONS(2304),
    [aux_sym_preproc_def_token1] = ACTIONS(2304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_COMMA] = ACTIONS(2306),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2304),
    [sym_preproc_directive] = ACTIONS(2304),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_BANG] = ACTIONS(2304),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_PERCENT] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE] = ACTIONS(2304),
    [anon_sym_CARET] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_GT] = ACTIONS(2304),
    [anon_sym_GT_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_LT_LT] = ACTIONS(2306),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_COLON] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2306),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym_typedef] = ACTIONS(2304),
    [anon_sym_in] = ACTIONS(2304),
    [anon_sym_out] = ACTIONS(2304),
    [anon_sym_inout] = ACTIONS(2304),
    [anon_sym_virtual] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym___attribute] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2306),
    [anon_sym___declspec] = ACTIONS(2304),
    [anon_sym___based] = ACTIONS(2304),
    [anon_sym___cdecl] = ACTIONS(2304),
    [anon_sym___clrcall] = ACTIONS(2304),
    [anon_sym___stdcall] = ACTIONS(2304),
    [anon_sym___fastcall] = ACTIONS(2304),
    [anon_sym___thiscall] = ACTIONS(2304),
    [anon_sym___vectorcall] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_signed] = ACTIONS(2304),
    [anon_sym_unsigned] = ACTIONS(2304),
    [anon_sym_long] = ACTIONS(2304),
    [anon_sym_short] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_RBRACK] = ACTIONS(2306),
    [anon_sym_register] = ACTIONS(2304),
    [anon_sym_inline] = ACTIONS(2304),
    [anon_sym___inline] = ACTIONS(2304),
    [anon_sym___inline__] = ACTIONS(2304),
    [anon_sym___forceinline] = ACTIONS(2304),
    [anon_sym_thread_local] = ACTIONS(2304),
    [anon_sym___thread] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym__Nonnull] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [sym_primitive_type] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_struct] = ACTIONS(2304),
    [anon_sym_union] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_else] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_case] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_goto] = ACTIONS(2304),
    [anon_sym_QMARK] = ACTIONS(2306),
    [anon_sym_not] = ACTIONS(2304),
    [anon_sym_compl] = ACTIONS(2304),
    [anon_sym_LT_EQ_GT] = ACTIONS(2306),
    [anon_sym_or] = ACTIONS(2304),
    [anon_sym_and] = ACTIONS(2304),
    [anon_sym_bitor] = ACTIONS(2304),
    [anon_sym_xor] = ACTIONS(2304),
    [anon_sym_bitand] = ACTIONS(2304),
    [anon_sym_not_eq] = ACTIONS(2304),
    [anon_sym_is] = ACTIONS(2304),
    [anon_sym_as] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_sizeof] = ACTIONS(2304),
    [anon_sym___alignof__] = ACTIONS(2304),
    [anon_sym___alignof] = ACTIONS(2304),
    [anon_sym__alignof] = ACTIONS(2304),
    [anon_sym_alignof] = ACTIONS(2304),
    [anon_sym__Alignof] = ACTIONS(2304),
    [anon_sym_offsetof] = ACTIONS(2304),
    [anon_sym__Generic] = ACTIONS(2304),
    [anon_sym_asm] = ACTIONS(2304),
    [anon_sym___asm__] = ACTIONS(2304),
    [anon_sym___asm] = ACTIONS(2304),
    [anon_sym_DOT] = ACTIONS(2304),
    [anon_sym_DOT_STAR] = ACTIONS(2306),
    [anon_sym_DASH_GT] = ACTIONS(2306),
    [sym_number_literal] = ACTIONS(2306),
    [anon_sym_L_SQUOTE] = ACTIONS(2306),
    [anon_sym_u_SQUOTE] = ACTIONS(2306),
    [anon_sym_U_SQUOTE] = ACTIONS(2306),
    [anon_sym_u8_SQUOTE] = ACTIONS(2306),
    [anon_sym_SQUOTE] = ACTIONS(2306),
    [anon_sym_L_DQUOTE] = ACTIONS(2306),
    [anon_sym_u_DQUOTE] = ACTIONS(2306),
    [anon_sym_U_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8_DQUOTE] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [anon_sym_NULL] = ACTIONS(2304),
    [anon_sym_nullptr] = ACTIONS(2304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_This] = ACTIONS(2304),
    [anon_sym_decltype] = ACTIONS(2304),
    [anon_sym_final] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_explicit] = ACTIONS(2304),
    [anon_sym_typename] = ACTIONS(2304),
    [anon_sym_export] = ACTIONS(2304),
    [anon_sym_module] = ACTIONS(2304),
    [anon_sym_import] = ACTIONS(2304),
    [anon_sym_template] = ACTIONS(2304),
    [anon_sym_operator] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_noexcept] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_static_assert] = ACTIONS(2304),
    [anon_sym_concept] = ACTIONS(2304),
    [anon_sym_co_return] = ACTIONS(2304),
    [anon_sym_co_yield] = ACTIONS(2304),
    [anon_sym_R_DQUOTE] = ACTIONS(2306),
    [anon_sym_LR_DQUOTE] = ACTIONS(2306),
    [anon_sym_uR_DQUOTE] = ACTIONS(2306),
    [anon_sym_UR_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2306),
    [anon_sym_co_await] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_requires] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [anon_sym_precise] = ACTIONS(2304),
    [anon_sym_shared] = ACTIONS(2304),
    [anon_sym_groupshared] = ACTIONS(2304),
    [anon_sym_uniform] = ACTIONS(2304),
    [anon_sym_row_major] = ACTIONS(2304),
    [anon_sym_column_major] = ACTIONS(2304),
    [anon_sym_globallycoherent] = ACTIONS(2304),
    [anon_sym_centroid] = ACTIONS(2304),
    [anon_sym_noperspective] = ACTIONS(2304),
    [anon_sym_nointerpolation] = ACTIONS(2304),
    [anon_sym_sample] = ACTIONS(2304),
    [anon_sym_linear] = ACTIONS(2304),
    [anon_sym_snorm] = ACTIONS(2304),
    [anon_sym_unorm] = ACTIONS(2304),
    [anon_sym_point] = ACTIONS(2304),
    [anon_sym_line] = ACTIONS(2304),
    [anon_sym_triangleadj] = ACTIONS(2304),
    [anon_sym_lineadj] = ACTIONS(2304),
    [anon_sym_triangle] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_extension] = ACTIONS(2304),
    [anon_sym_where] = ACTIONS(2304),
    [anon_sym___exported] = ACTIONS(2304),
  },
  [157] = {
    [ts_builtin_sym_end] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2239),
    [aux_sym_preproc_include_token1] = ACTIONS(2239),
    [aux_sym_preproc_def_token1] = ACTIONS(2239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2241),
    [anon_sym_COMMA] = ACTIONS(2241),
    [anon_sym_RPAREN] = ACTIONS(2241),
    [aux_sym_preproc_if_token1] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2239),
    [sym_preproc_directive] = ACTIONS(2239),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2239),
    [anon_sym_PLUS] = ACTIONS(2239),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_SLASH] = ACTIONS(2239),
    [anon_sym_PERCENT] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_PIPE] = ACTIONS(2239),
    [anon_sym_CARET] = ACTIONS(2241),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_LT_EQ] = ACTIONS(2239),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_LT_LT] = ACTIONS(2241),
    [anon_sym_GT_GT] = ACTIONS(2241),
    [anon_sym_COLON] = ACTIONS(2239),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym_typedef] = ACTIONS(2239),
    [anon_sym_in] = ACTIONS(2239),
    [anon_sym_out] = ACTIONS(2239),
    [anon_sym_inout] = ACTIONS(2239),
    [anon_sym_virtual] = ACTIONS(2239),
    [anon_sym_extern] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym___attribute] = ACTIONS(2239),
    [anon_sym_using] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2241),
    [anon_sym___declspec] = ACTIONS(2239),
    [anon_sym___based] = ACTIONS(2239),
    [anon_sym___cdecl] = ACTIONS(2239),
    [anon_sym___clrcall] = ACTIONS(2239),
    [anon_sym___stdcall] = ACTIONS(2239),
    [anon_sym___fastcall] = ACTIONS(2239),
    [anon_sym___thiscall] = ACTIONS(2239),
    [anon_sym___vectorcall] = ACTIONS(2239),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_signed] = ACTIONS(2239),
    [anon_sym_unsigned] = ACTIONS(2239),
    [anon_sym_long] = ACTIONS(2239),
    [anon_sym_short] = ACTIONS(2239),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2239),
    [anon_sym_RBRACK] = ACTIONS(2241),
    [anon_sym_register] = ACTIONS(2239),
    [anon_sym_inline] = ACTIONS(2239),
    [anon_sym___inline] = ACTIONS(2239),
    [anon_sym___inline__] = ACTIONS(2239),
    [anon_sym___forceinline] = ACTIONS(2239),
    [anon_sym_thread_local] = ACTIONS(2239),
    [anon_sym___thread] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym__Nonnull] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [sym_primitive_type] = ACTIONS(2239),
    [anon_sym_enum] = ACTIONS(2239),
    [anon_sym_class] = ACTIONS(2239),
    [anon_sym_struct] = ACTIONS(2239),
    [anon_sym_union] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(2239),
    [anon_sym_else] = ACTIONS(2239),
    [anon_sym_switch] = ACTIONS(2239),
    [anon_sym_case] = ACTIONS(2239),
    [anon_sym_default] = ACTIONS(2239),
    [anon_sym_while] = ACTIONS(2239),
    [anon_sym_do] = ACTIONS(2239),
    [anon_sym_for] = ACTIONS(2239),
    [anon_sym_return] = ACTIONS(2239),
    [anon_sym_break] = ACTIONS(2239),
    [anon_sym_continue] = ACTIONS(2239),
    [anon_sym_goto] = ACTIONS(2239),
    [anon_sym_QMARK] = ACTIONS(2241),
    [anon_sym_not] = ACTIONS(2239),
    [anon_sym_compl] = ACTIONS(2239),
    [anon_sym_LT_EQ_GT] = ACTIONS(2241),
    [anon_sym_or] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(2239),
    [anon_sym_bitor] = ACTIONS(2239),
    [anon_sym_xor] = ACTIONS(2239),
    [anon_sym_bitand] = ACTIONS(2239),
    [anon_sym_not_eq] = ACTIONS(2239),
    [anon_sym_is] = ACTIONS(2239),
    [anon_sym_as] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_sizeof] = ACTIONS(2239),
    [anon_sym___alignof__] = ACTIONS(2239),
    [anon_sym___alignof] = ACTIONS(2239),
    [anon_sym__alignof] = ACTIONS(2239),
    [anon_sym_alignof] = ACTIONS(2239),
    [anon_sym__Alignof] = ACTIONS(2239),
    [anon_sym_offsetof] = ACTIONS(2239),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2239),
    [anon_sym___asm__] = ACTIONS(2239),
    [anon_sym___asm] = ACTIONS(2239),
    [anon_sym_DOT] = ACTIONS(2239),
    [anon_sym_DOT_STAR] = ACTIONS(2241),
    [anon_sym_DASH_GT] = ACTIONS(2241),
    [sym_number_literal] = ACTIONS(2241),
    [anon_sym_L_SQUOTE] = ACTIONS(2241),
    [anon_sym_u_SQUOTE] = ACTIONS(2241),
    [anon_sym_U_SQUOTE] = ACTIONS(2241),
    [anon_sym_u8_SQUOTE] = ACTIONS(2241),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_L_DQUOTE] = ACTIONS(2241),
    [anon_sym_u_DQUOTE] = ACTIONS(2241),
    [anon_sym_U_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8_DQUOTE] = ACTIONS(2241),
    [anon_sym_DQUOTE] = ACTIONS(2241),
    [sym_true] = ACTIONS(2239),
    [sym_false] = ACTIONS(2239),
    [anon_sym_NULL] = ACTIONS(2239),
    [anon_sym_nullptr] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2239),
    [anon_sym_let] = ACTIONS(2239),
    [anon_sym_This] = ACTIONS(2239),
    [anon_sym_decltype] = ACTIONS(2239),
    [anon_sym_final] = ACTIONS(2239),
    [anon_sym_override] = ACTIONS(2239),
    [anon_sym_explicit] = ACTIONS(2239),
    [anon_sym_typename] = ACTIONS(2239),
    [anon_sym_export] = ACTIONS(2239),
    [anon_sym_module] = ACTIONS(2239),
    [anon_sym_import] = ACTIONS(2239),
    [anon_sym_template] = ACTIONS(2239),
    [anon_sym_operator] = ACTIONS(2239),
    [anon_sym_try] = ACTIONS(2239),
    [anon_sym_delete] = ACTIONS(2239),
    [anon_sym_noexcept] = ACTIONS(2239),
    [anon_sym_throw] = ACTIONS(2239),
    [anon_sym_namespace] = ACTIONS(2239),
    [anon_sym_static_assert] = ACTIONS(2239),
    [anon_sym_concept] = ACTIONS(2239),
    [anon_sym_co_return] = ACTIONS(2239),
    [anon_sym_co_yield] = ACTIONS(2239),
    [anon_sym_R_DQUOTE] = ACTIONS(2241),
    [anon_sym_LR_DQUOTE] = ACTIONS(2241),
    [anon_sym_uR_DQUOTE] = ACTIONS(2241),
    [anon_sym_UR_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2241),
    [anon_sym_co_await] = ACTIONS(2239),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_requires] = ACTIONS(2239),
    [sym_this] = ACTIONS(2239),
    [anon_sym_precise] = ACTIONS(2239),
    [anon_sym_shared] = ACTIONS(2239),
    [anon_sym_groupshared] = ACTIONS(2239),
    [anon_sym_uniform] = ACTIONS(2239),
    [anon_sym_row_major] = ACTIONS(2239),
    [anon_sym_column_major] = ACTIONS(2239),
    [anon_sym_globallycoherent] = ACTIONS(2239),
    [anon_sym_centroid] = ACTIONS(2239),
    [anon_sym_noperspective] = ACTIONS(2239),
    [anon_sym_nointerpolation] = ACTIONS(2239),
    [anon_sym_sample] = ACTIONS(2239),
    [anon_sym_linear] = ACTIONS(2239),
    [anon_sym_snorm] = ACTIONS(2239),
    [anon_sym_unorm] = ACTIONS(2239),
    [anon_sym_point] = ACTIONS(2239),
    [anon_sym_line] = ACTIONS(2239),
    [anon_sym_triangleadj] = ACTIONS(2239),
    [anon_sym_lineadj] = ACTIONS(2239),
    [anon_sym_triangle] = ACTIONS(2239),
    [anon_sym_interface] = ACTIONS(2239),
    [anon_sym_extension] = ACTIONS(2239),
    [anon_sym_where] = ACTIONS(2239),
    [anon_sym___exported] = ACTIONS(2239),
  },
  [158] = {
    [ts_builtin_sym_end] = ACTIONS(2290),
    [sym_identifier] = ACTIONS(2288),
    [aux_sym_preproc_include_token1] = ACTIONS(2288),
    [aux_sym_preproc_def_token1] = ACTIONS(2288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2290),
    [anon_sym_COMMA] = ACTIONS(2290),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [aux_sym_preproc_if_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_PERCENT] = ACTIONS(2290),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_CARET] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_EQ_EQ] = ACTIONS(2290),
    [anon_sym_BANG_EQ] = ACTIONS(2290),
    [anon_sym_GT] = ACTIONS(2288),
    [anon_sym_GT_EQ] = ACTIONS(2290),
    [anon_sym_LT_EQ] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(2290),
    [anon_sym_GT_GT] = ACTIONS(2290),
    [anon_sym_COLON] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_out] = ACTIONS(2288),
    [anon_sym_inout] = ACTIONS(2288),
    [anon_sym_virtual] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym___cdecl] = ACTIONS(2288),
    [anon_sym___clrcall] = ACTIONS(2288),
    [anon_sym___stdcall] = ACTIONS(2288),
    [anon_sym___fastcall] = ACTIONS(2288),
    [anon_sym___thiscall] = ACTIONS(2288),
    [anon_sym___vectorcall] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_signed] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_RBRACK] = ACTIONS(2290),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym_QMARK] = ACTIONS(2290),
    [anon_sym_not] = ACTIONS(2288),
    [anon_sym_compl] = ACTIONS(2288),
    [anon_sym_LT_EQ_GT] = ACTIONS(2290),
    [anon_sym_or] = ACTIONS(2288),
    [anon_sym_and] = ACTIONS(2288),
    [anon_sym_bitor] = ACTIONS(2288),
    [anon_sym_xor] = ACTIONS(2288),
    [anon_sym_bitand] = ACTIONS(2288),
    [anon_sym_not_eq] = ACTIONS(2288),
    [anon_sym_is] = ACTIONS(2288),
    [anon_sym_as] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_sizeof] = ACTIONS(2288),
    [anon_sym___alignof__] = ACTIONS(2288),
    [anon_sym___alignof] = ACTIONS(2288),
    [anon_sym__alignof] = ACTIONS(2288),
    [anon_sym_alignof] = ACTIONS(2288),
    [anon_sym__Alignof] = ACTIONS(2288),
    [anon_sym_offsetof] = ACTIONS(2288),
    [anon_sym__Generic] = ACTIONS(2288),
    [anon_sym_asm] = ACTIONS(2288),
    [anon_sym___asm__] = ACTIONS(2288),
    [anon_sym___asm] = ACTIONS(2288),
    [anon_sym_DOT] = ACTIONS(2288),
    [anon_sym_DOT_STAR] = ACTIONS(2290),
    [anon_sym_DASH_GT] = ACTIONS(2290),
    [sym_number_literal] = ACTIONS(2290),
    [anon_sym_L_SQUOTE] = ACTIONS(2290),
    [anon_sym_u_SQUOTE] = ACTIONS(2290),
    [anon_sym_U_SQUOTE] = ACTIONS(2290),
    [anon_sym_u8_SQUOTE] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [anon_sym_L_DQUOTE] = ACTIONS(2290),
    [anon_sym_u_DQUOTE] = ACTIONS(2290),
    [anon_sym_U_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8_DQUOTE] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [anon_sym_NULL] = ACTIONS(2288),
    [anon_sym_nullptr] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_This] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [anon_sym_final] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_noexcept] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_static_assert] = ACTIONS(2288),
    [anon_sym_concept] = ACTIONS(2288),
    [anon_sym_co_return] = ACTIONS(2288),
    [anon_sym_co_yield] = ACTIONS(2288),
    [anon_sym_R_DQUOTE] = ACTIONS(2290),
    [anon_sym_LR_DQUOTE] = ACTIONS(2290),
    [anon_sym_uR_DQUOTE] = ACTIONS(2290),
    [anon_sym_UR_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2290),
    [anon_sym_co_await] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_requires] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [anon_sym_precise] = ACTIONS(2288),
    [anon_sym_shared] = ACTIONS(2288),
    [anon_sym_groupshared] = ACTIONS(2288),
    [anon_sym_uniform] = ACTIONS(2288),
    [anon_sym_row_major] = ACTIONS(2288),
    [anon_sym_column_major] = ACTIONS(2288),
    [anon_sym_globallycoherent] = ACTIONS(2288),
    [anon_sym_centroid] = ACTIONS(2288),
    [anon_sym_noperspective] = ACTIONS(2288),
    [anon_sym_nointerpolation] = ACTIONS(2288),
    [anon_sym_sample] = ACTIONS(2288),
    [anon_sym_linear] = ACTIONS(2288),
    [anon_sym_snorm] = ACTIONS(2288),
    [anon_sym_unorm] = ACTIONS(2288),
    [anon_sym_point] = ACTIONS(2288),
    [anon_sym_line] = ACTIONS(2288),
    [anon_sym_triangleadj] = ACTIONS(2288),
    [anon_sym_lineadj] = ACTIONS(2288),
    [anon_sym_triangle] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_extension] = ACTIONS(2288),
    [anon_sym_where] = ACTIONS(2288),
    [anon_sym___exported] = ACTIONS(2288),
  },
  [159] = {
    [ts_builtin_sym_end] = ACTIONS(2274),
    [sym_identifier] = ACTIONS(2272),
    [aux_sym_preproc_include_token1] = ACTIONS(2272),
    [aux_sym_preproc_def_token1] = ACTIONS(2272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2274),
    [anon_sym_COMMA] = ACTIONS(2274),
    [anon_sym_RPAREN] = ACTIONS(2274),
    [aux_sym_preproc_if_token1] = ACTIONS(2272),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2272),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2272),
    [sym_preproc_directive] = ACTIONS(2272),
    [anon_sym_LPAREN2] = ACTIONS(2274),
    [anon_sym_BANG] = ACTIONS(2272),
    [anon_sym_TILDE] = ACTIONS(2274),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2274),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_PERCENT] = ACTIONS(2274),
    [anon_sym_PIPE_PIPE] = ACTIONS(2274),
    [anon_sym_AMP_AMP] = ACTIONS(2274),
    [anon_sym_PIPE] = ACTIONS(2272),
    [anon_sym_CARET] = ACTIONS(2274),
    [anon_sym_AMP] = ACTIONS(2272),
    [anon_sym_EQ_EQ] = ACTIONS(2274),
    [anon_sym_BANG_EQ] = ACTIONS(2274),
    [anon_sym_GT] = ACTIONS(2272),
    [anon_sym_GT_EQ] = ACTIONS(2274),
    [anon_sym_LT_EQ] = ACTIONS(2272),
    [anon_sym_LT] = ACTIONS(2272),
    [anon_sym_LT_LT] = ACTIONS(2274),
    [anon_sym_GT_GT] = ACTIONS(2274),
    [anon_sym_COLON] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym___extension__] = ACTIONS(2272),
    [anon_sym_typedef] = ACTIONS(2272),
    [anon_sym_in] = ACTIONS(2272),
    [anon_sym_out] = ACTIONS(2272),
    [anon_sym_inout] = ACTIONS(2272),
    [anon_sym_virtual] = ACTIONS(2272),
    [anon_sym_extern] = ACTIONS(2272),
    [anon_sym___attribute__] = ACTIONS(2272),
    [anon_sym___attribute] = ACTIONS(2272),
    [anon_sym_using] = ACTIONS(2272),
    [anon_sym_COLON_COLON] = ACTIONS(2274),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2274),
    [anon_sym___declspec] = ACTIONS(2272),
    [anon_sym___based] = ACTIONS(2272),
    [anon_sym___cdecl] = ACTIONS(2272),
    [anon_sym___clrcall] = ACTIONS(2272),
    [anon_sym___stdcall] = ACTIONS(2272),
    [anon_sym___fastcall] = ACTIONS(2272),
    [anon_sym___thiscall] = ACTIONS(2272),
    [anon_sym___vectorcall] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_signed] = ACTIONS(2272),
    [anon_sym_unsigned] = ACTIONS(2272),
    [anon_sym_long] = ACTIONS(2272),
    [anon_sym_short] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_RBRACK] = ACTIONS(2274),
    [anon_sym_register] = ACTIONS(2272),
    [anon_sym_inline] = ACTIONS(2272),
    [anon_sym___inline] = ACTIONS(2272),
    [anon_sym___inline__] = ACTIONS(2272),
    [anon_sym___forceinline] = ACTIONS(2272),
    [anon_sym_thread_local] = ACTIONS(2272),
    [anon_sym___thread] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_constexpr] = ACTIONS(2272),
    [anon_sym_volatile] = ACTIONS(2272),
    [anon_sym_restrict] = ACTIONS(2272),
    [anon_sym___restrict__] = ACTIONS(2272),
    [anon_sym__Atomic] = ACTIONS(2272),
    [anon_sym__Noreturn] = ACTIONS(2272),
    [anon_sym_noreturn] = ACTIONS(2272),
    [anon_sym__Nonnull] = ACTIONS(2272),
    [anon_sym_mutable] = ACTIONS(2272),
    [anon_sym_constinit] = ACTIONS(2272),
    [anon_sym_consteval] = ACTIONS(2272),
    [anon_sym_alignas] = ACTIONS(2272),
    [anon_sym__Alignas] = ACTIONS(2272),
    [sym_primitive_type] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_struct] = ACTIONS(2272),
    [anon_sym_union] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_else] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_case] = ACTIONS(2272),
    [anon_sym_default] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_goto] = ACTIONS(2272),
    [anon_sym_QMARK] = ACTIONS(2274),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_compl] = ACTIONS(2272),
    [anon_sym_LT_EQ_GT] = ACTIONS(2274),
    [anon_sym_or] = ACTIONS(2272),
    [anon_sym_and] = ACTIONS(2272),
    [anon_sym_bitor] = ACTIONS(2272),
    [anon_sym_xor] = ACTIONS(2272),
    [anon_sym_bitand] = ACTIONS(2272),
    [anon_sym_not_eq] = ACTIONS(2272),
    [anon_sym_is] = ACTIONS(2272),
    [anon_sym_as] = ACTIONS(2272),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_sizeof] = ACTIONS(2272),
    [anon_sym___alignof__] = ACTIONS(2272),
    [anon_sym___alignof] = ACTIONS(2272),
    [anon_sym__alignof] = ACTIONS(2272),
    [anon_sym_alignof] = ACTIONS(2272),
    [anon_sym__Alignof] = ACTIONS(2272),
    [anon_sym_offsetof] = ACTIONS(2272),
    [anon_sym__Generic] = ACTIONS(2272),
    [anon_sym_asm] = ACTIONS(2272),
    [anon_sym___asm__] = ACTIONS(2272),
    [anon_sym___asm] = ACTIONS(2272),
    [anon_sym_DOT] = ACTIONS(2272),
    [anon_sym_DOT_STAR] = ACTIONS(2274),
    [anon_sym_DASH_GT] = ACTIONS(2274),
    [sym_number_literal] = ACTIONS(2274),
    [anon_sym_L_SQUOTE] = ACTIONS(2274),
    [anon_sym_u_SQUOTE] = ACTIONS(2274),
    [anon_sym_U_SQUOTE] = ACTIONS(2274),
    [anon_sym_u8_SQUOTE] = ACTIONS(2274),
    [anon_sym_SQUOTE] = ACTIONS(2274),
    [anon_sym_L_DQUOTE] = ACTIONS(2274),
    [anon_sym_u_DQUOTE] = ACTIONS(2274),
    [anon_sym_U_DQUOTE] = ACTIONS(2274),
    [anon_sym_u8_DQUOTE] = ACTIONS(2274),
    [anon_sym_DQUOTE] = ACTIONS(2274),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [anon_sym_NULL] = ACTIONS(2272),
    [anon_sym_nullptr] = ACTIONS(2272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_This] = ACTIONS(2272),
    [anon_sym_decltype] = ACTIONS(2272),
    [anon_sym_final] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_explicit] = ACTIONS(2272),
    [anon_sym_typename] = ACTIONS(2272),
    [anon_sym_export] = ACTIONS(2272),
    [anon_sym_module] = ACTIONS(2272),
    [anon_sym_import] = ACTIONS(2272),
    [anon_sym_template] = ACTIONS(2272),
    [anon_sym_operator] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2272),
    [anon_sym_noexcept] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_namespace] = ACTIONS(2272),
    [anon_sym_static_assert] = ACTIONS(2272),
    [anon_sym_concept] = ACTIONS(2272),
    [anon_sym_co_return] = ACTIONS(2272),
    [anon_sym_co_yield] = ACTIONS(2272),
    [anon_sym_R_DQUOTE] = ACTIONS(2274),
    [anon_sym_LR_DQUOTE] = ACTIONS(2274),
    [anon_sym_uR_DQUOTE] = ACTIONS(2274),
    [anon_sym_UR_DQUOTE] = ACTIONS(2274),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2274),
    [anon_sym_co_await] = ACTIONS(2272),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_requires] = ACTIONS(2272),
    [sym_this] = ACTIONS(2272),
    [anon_sym_precise] = ACTIONS(2272),
    [anon_sym_shared] = ACTIONS(2272),
    [anon_sym_groupshared] = ACTIONS(2272),
    [anon_sym_uniform] = ACTIONS(2272),
    [anon_sym_row_major] = ACTIONS(2272),
    [anon_sym_column_major] = ACTIONS(2272),
    [anon_sym_globallycoherent] = ACTIONS(2272),
    [anon_sym_centroid] = ACTIONS(2272),
    [anon_sym_noperspective] = ACTIONS(2272),
    [anon_sym_nointerpolation] = ACTIONS(2272),
    [anon_sym_sample] = ACTIONS(2272),
    [anon_sym_linear] = ACTIONS(2272),
    [anon_sym_snorm] = ACTIONS(2272),
    [anon_sym_unorm] = ACTIONS(2272),
    [anon_sym_point] = ACTIONS(2272),
    [anon_sym_line] = ACTIONS(2272),
    [anon_sym_triangleadj] = ACTIONS(2272),
    [anon_sym_lineadj] = ACTIONS(2272),
    [anon_sym_triangle] = ACTIONS(2272),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_extension] = ACTIONS(2272),
    [anon_sym_where] = ACTIONS(2272),
    [anon_sym___exported] = ACTIONS(2272),
  },
  [160] = {
    [ts_builtin_sym_end] = ACTIONS(2282),
    [sym_identifier] = ACTIONS(2280),
    [aux_sym_preproc_include_token1] = ACTIONS(2280),
    [aux_sym_preproc_def_token1] = ACTIONS(2280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_COMMA] = ACTIONS(2282),
    [anon_sym_RPAREN] = ACTIONS(2282),
    [aux_sym_preproc_if_token1] = ACTIONS(2280),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2280),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2280),
    [sym_preproc_directive] = ACTIONS(2280),
    [anon_sym_LPAREN2] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2282),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2282),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_PERCENT] = ACTIONS(2282),
    [anon_sym_PIPE_PIPE] = ACTIONS(2282),
    [anon_sym_AMP_AMP] = ACTIONS(2282),
    [anon_sym_PIPE] = ACTIONS(2280),
    [anon_sym_CARET] = ACTIONS(2282),
    [anon_sym_AMP] = ACTIONS(2280),
    [anon_sym_EQ_EQ] = ACTIONS(2282),
    [anon_sym_BANG_EQ] = ACTIONS(2282),
    [anon_sym_GT] = ACTIONS(2280),
    [anon_sym_GT_EQ] = ACTIONS(2282),
    [anon_sym_LT_EQ] = ACTIONS(2280),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_LT_LT] = ACTIONS(2282),
    [anon_sym_GT_GT] = ACTIONS(2282),
    [anon_sym_COLON] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(2280),
    [anon_sym_typedef] = ACTIONS(2280),
    [anon_sym_in] = ACTIONS(2280),
    [anon_sym_out] = ACTIONS(2280),
    [anon_sym_inout] = ACTIONS(2280),
    [anon_sym_virtual] = ACTIONS(2280),
    [anon_sym_extern] = ACTIONS(2280),
    [anon_sym___attribute__] = ACTIONS(2280),
    [anon_sym___attribute] = ACTIONS(2280),
    [anon_sym_using] = ACTIONS(2280),
    [anon_sym_COLON_COLON] = ACTIONS(2282),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2282),
    [anon_sym___declspec] = ACTIONS(2280),
    [anon_sym___based] = ACTIONS(2280),
    [anon_sym___cdecl] = ACTIONS(2280),
    [anon_sym___clrcall] = ACTIONS(2280),
    [anon_sym___stdcall] = ACTIONS(2280),
    [anon_sym___fastcall] = ACTIONS(2280),
    [anon_sym___thiscall] = ACTIONS(2280),
    [anon_sym___vectorcall] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_signed] = ACTIONS(2280),
    [anon_sym_unsigned] = ACTIONS(2280),
    [anon_sym_long] = ACTIONS(2280),
    [anon_sym_short] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_RBRACK] = ACTIONS(2282),
    [anon_sym_register] = ACTIONS(2280),
    [anon_sym_inline] = ACTIONS(2280),
    [anon_sym___inline] = ACTIONS(2280),
    [anon_sym___inline__] = ACTIONS(2280),
    [anon_sym___forceinline] = ACTIONS(2280),
    [anon_sym_thread_local] = ACTIONS(2280),
    [anon_sym___thread] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_constexpr] = ACTIONS(2280),
    [anon_sym_volatile] = ACTIONS(2280),
    [anon_sym_restrict] = ACTIONS(2280),
    [anon_sym___restrict__] = ACTIONS(2280),
    [anon_sym__Atomic] = ACTIONS(2280),
    [anon_sym__Noreturn] = ACTIONS(2280),
    [anon_sym_noreturn] = ACTIONS(2280),
    [anon_sym__Nonnull] = ACTIONS(2280),
    [anon_sym_mutable] = ACTIONS(2280),
    [anon_sym_constinit] = ACTIONS(2280),
    [anon_sym_consteval] = ACTIONS(2280),
    [anon_sym_alignas] = ACTIONS(2280),
    [anon_sym__Alignas] = ACTIONS(2280),
    [sym_primitive_type] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_struct] = ACTIONS(2280),
    [anon_sym_union] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_goto] = ACTIONS(2280),
    [anon_sym_QMARK] = ACTIONS(2282),
    [anon_sym_not] = ACTIONS(2280),
    [anon_sym_compl] = ACTIONS(2280),
    [anon_sym_LT_EQ_GT] = ACTIONS(2282),
    [anon_sym_or] = ACTIONS(2280),
    [anon_sym_and] = ACTIONS(2280),
    [anon_sym_bitor] = ACTIONS(2280),
    [anon_sym_xor] = ACTIONS(2280),
    [anon_sym_bitand] = ACTIONS(2280),
    [anon_sym_not_eq] = ACTIONS(2280),
    [anon_sym_is] = ACTIONS(2280),
    [anon_sym_as] = ACTIONS(2280),
    [anon_sym_DASH_DASH] = ACTIONS(2282),
    [anon_sym_PLUS_PLUS] = ACTIONS(2282),
    [anon_sym_sizeof] = ACTIONS(2280),
    [anon_sym___alignof__] = ACTIONS(2280),
    [anon_sym___alignof] = ACTIONS(2280),
    [anon_sym__alignof] = ACTIONS(2280),
    [anon_sym_alignof] = ACTIONS(2280),
    [anon_sym__Alignof] = ACTIONS(2280),
    [anon_sym_offsetof] = ACTIONS(2280),
    [anon_sym__Generic] = ACTIONS(2280),
    [anon_sym_asm] = ACTIONS(2280),
    [anon_sym___asm__] = ACTIONS(2280),
    [anon_sym___asm] = ACTIONS(2280),
    [anon_sym_DOT] = ACTIONS(2280),
    [anon_sym_DOT_STAR] = ACTIONS(2282),
    [anon_sym_DASH_GT] = ACTIONS(2282),
    [sym_number_literal] = ACTIONS(2282),
    [anon_sym_L_SQUOTE] = ACTIONS(2282),
    [anon_sym_u_SQUOTE] = ACTIONS(2282),
    [anon_sym_U_SQUOTE] = ACTIONS(2282),
    [anon_sym_u8_SQUOTE] = ACTIONS(2282),
    [anon_sym_SQUOTE] = ACTIONS(2282),
    [anon_sym_L_DQUOTE] = ACTIONS(2282),
    [anon_sym_u_DQUOTE] = ACTIONS(2282),
    [anon_sym_U_DQUOTE] = ACTIONS(2282),
    [anon_sym_u8_DQUOTE] = ACTIONS(2282),
    [anon_sym_DQUOTE] = ACTIONS(2282),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [anon_sym_NULL] = ACTIONS(2280),
    [anon_sym_nullptr] = ACTIONS(2280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_This] = ACTIONS(2280),
    [anon_sym_decltype] = ACTIONS(2280),
    [anon_sym_final] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_explicit] = ACTIONS(2280),
    [anon_sym_typename] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_template] = ACTIONS(2280),
    [anon_sym_operator] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_noexcept] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_static_assert] = ACTIONS(2280),
    [anon_sym_concept] = ACTIONS(2280),
    [anon_sym_co_return] = ACTIONS(2280),
    [anon_sym_co_yield] = ACTIONS(2280),
    [anon_sym_R_DQUOTE] = ACTIONS(2282),
    [anon_sym_LR_DQUOTE] = ACTIONS(2282),
    [anon_sym_uR_DQUOTE] = ACTIONS(2282),
    [anon_sym_UR_DQUOTE] = ACTIONS(2282),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2282),
    [anon_sym_co_await] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_requires] = ACTIONS(2280),
    [sym_this] = ACTIONS(2280),
    [anon_sym_precise] = ACTIONS(2280),
    [anon_sym_shared] = ACTIONS(2280),
    [anon_sym_groupshared] = ACTIONS(2280),
    [anon_sym_uniform] = ACTIONS(2280),
    [anon_sym_row_major] = ACTIONS(2280),
    [anon_sym_column_major] = ACTIONS(2280),
    [anon_sym_globallycoherent] = ACTIONS(2280),
    [anon_sym_centroid] = ACTIONS(2280),
    [anon_sym_noperspective] = ACTIONS(2280),
    [anon_sym_nointerpolation] = ACTIONS(2280),
    [anon_sym_sample] = ACTIONS(2280),
    [anon_sym_linear] = ACTIONS(2280),
    [anon_sym_snorm] = ACTIONS(2280),
    [anon_sym_unorm] = ACTIONS(2280),
    [anon_sym_point] = ACTIONS(2280),
    [anon_sym_line] = ACTIONS(2280),
    [anon_sym_triangleadj] = ACTIONS(2280),
    [anon_sym_lineadj] = ACTIONS(2280),
    [anon_sym_triangle] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_extension] = ACTIONS(2280),
    [anon_sym_where] = ACTIONS(2280),
    [anon_sym___exported] = ACTIONS(2280),
  },
  [161] = {
    [ts_builtin_sym_end] = ACTIONS(2286),
    [sym_identifier] = ACTIONS(2284),
    [aux_sym_preproc_include_token1] = ACTIONS(2284),
    [aux_sym_preproc_def_token1] = ACTIONS(2284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2286),
    [anon_sym_COMMA] = ACTIONS(2286),
    [anon_sym_RPAREN] = ACTIONS(2286),
    [aux_sym_preproc_if_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2284),
    [sym_preproc_directive] = ACTIONS(2284),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2284),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_SLASH] = ACTIONS(2284),
    [anon_sym_PERCENT] = ACTIONS(2286),
    [anon_sym_PIPE_PIPE] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2284),
    [anon_sym_CARET] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_EQ_EQ] = ACTIONS(2286),
    [anon_sym_BANG_EQ] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2284),
    [anon_sym_GT_EQ] = ACTIONS(2286),
    [anon_sym_LT_EQ] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2284),
    [anon_sym_LT_LT] = ACTIONS(2286),
    [anon_sym_GT_GT] = ACTIONS(2286),
    [anon_sym_COLON] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_typedef] = ACTIONS(2284),
    [anon_sym_in] = ACTIONS(2284),
    [anon_sym_out] = ACTIONS(2284),
    [anon_sym_inout] = ACTIONS(2284),
    [anon_sym_virtual] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_using] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym___cdecl] = ACTIONS(2284),
    [anon_sym___clrcall] = ACTIONS(2284),
    [anon_sym___stdcall] = ACTIONS(2284),
    [anon_sym___fastcall] = ACTIONS(2284),
    [anon_sym___thiscall] = ACTIONS(2284),
    [anon_sym___vectorcall] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_signed] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_RBRACK] = ACTIONS(2286),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_else] = ACTIONS(2284),
    [anon_sym_switch] = ACTIONS(2284),
    [anon_sym_case] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_goto] = ACTIONS(2284),
    [anon_sym_QMARK] = ACTIONS(2286),
    [anon_sym_not] = ACTIONS(2284),
    [anon_sym_compl] = ACTIONS(2284),
    [anon_sym_LT_EQ_GT] = ACTIONS(2286),
    [anon_sym_or] = ACTIONS(2284),
    [anon_sym_and] = ACTIONS(2284),
    [anon_sym_bitor] = ACTIONS(2284),
    [anon_sym_xor] = ACTIONS(2284),
    [anon_sym_bitand] = ACTIONS(2284),
    [anon_sym_not_eq] = ACTIONS(2284),
    [anon_sym_is] = ACTIONS(2284),
    [anon_sym_as] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_sizeof] = ACTIONS(2284),
    [anon_sym___alignof__] = ACTIONS(2284),
    [anon_sym___alignof] = ACTIONS(2284),
    [anon_sym__alignof] = ACTIONS(2284),
    [anon_sym_alignof] = ACTIONS(2284),
    [anon_sym__Alignof] = ACTIONS(2284),
    [anon_sym_offsetof] = ACTIONS(2284),
    [anon_sym__Generic] = ACTIONS(2284),
    [anon_sym_asm] = ACTIONS(2284),
    [anon_sym___asm__] = ACTIONS(2284),
    [anon_sym___asm] = ACTIONS(2284),
    [anon_sym_DOT] = ACTIONS(2284),
    [anon_sym_DOT_STAR] = ACTIONS(2286),
    [anon_sym_DASH_GT] = ACTIONS(2286),
    [sym_number_literal] = ACTIONS(2286),
    [anon_sym_L_SQUOTE] = ACTIONS(2286),
    [anon_sym_u_SQUOTE] = ACTIONS(2286),
    [anon_sym_U_SQUOTE] = ACTIONS(2286),
    [anon_sym_u8_SQUOTE] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_L_DQUOTE] = ACTIONS(2286),
    [anon_sym_u_DQUOTE] = ACTIONS(2286),
    [anon_sym_U_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8_DQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [sym_true] = ACTIONS(2284),
    [sym_false] = ACTIONS(2284),
    [anon_sym_NULL] = ACTIONS(2284),
    [anon_sym_nullptr] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_This] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [anon_sym_final] = ACTIONS(2284),
    [anon_sym_override] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_typename] = ACTIONS(2284),
    [anon_sym_export] = ACTIONS(2284),
    [anon_sym_module] = ACTIONS(2284),
    [anon_sym_import] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_delete] = ACTIONS(2284),
    [anon_sym_noexcept] = ACTIONS(2284),
    [anon_sym_throw] = ACTIONS(2284),
    [anon_sym_namespace] = ACTIONS(2284),
    [anon_sym_static_assert] = ACTIONS(2284),
    [anon_sym_concept] = ACTIONS(2284),
    [anon_sym_co_return] = ACTIONS(2284),
    [anon_sym_co_yield] = ACTIONS(2284),
    [anon_sym_R_DQUOTE] = ACTIONS(2286),
    [anon_sym_LR_DQUOTE] = ACTIONS(2286),
    [anon_sym_uR_DQUOTE] = ACTIONS(2286),
    [anon_sym_UR_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2286),
    [anon_sym_co_await] = ACTIONS(2284),
    [anon_sym_new] = ACTIONS(2284),
    [anon_sym_requires] = ACTIONS(2284),
    [sym_this] = ACTIONS(2284),
    [anon_sym_precise] = ACTIONS(2284),
    [anon_sym_shared] = ACTIONS(2284),
    [anon_sym_groupshared] = ACTIONS(2284),
    [anon_sym_uniform] = ACTIONS(2284),
    [anon_sym_row_major] = ACTIONS(2284),
    [anon_sym_column_major] = ACTIONS(2284),
    [anon_sym_globallycoherent] = ACTIONS(2284),
    [anon_sym_centroid] = ACTIONS(2284),
    [anon_sym_noperspective] = ACTIONS(2284),
    [anon_sym_nointerpolation] = ACTIONS(2284),
    [anon_sym_sample] = ACTIONS(2284),
    [anon_sym_linear] = ACTIONS(2284),
    [anon_sym_snorm] = ACTIONS(2284),
    [anon_sym_unorm] = ACTIONS(2284),
    [anon_sym_point] = ACTIONS(2284),
    [anon_sym_line] = ACTIONS(2284),
    [anon_sym_triangleadj] = ACTIONS(2284),
    [anon_sym_lineadj] = ACTIONS(2284),
    [anon_sym_triangle] = ACTIONS(2284),
    [anon_sym_interface] = ACTIONS(2284),
    [anon_sym_extension] = ACTIONS(2284),
    [anon_sym_where] = ACTIONS(2284),
    [anon_sym___exported] = ACTIONS(2284),
  },
  [162] = {
    [ts_builtin_sym_end] = ACTIONS(2294),
    [sym_identifier] = ACTIONS(2292),
    [aux_sym_preproc_include_token1] = ACTIONS(2292),
    [aux_sym_preproc_def_token1] = ACTIONS(2292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2294),
    [anon_sym_COMMA] = ACTIONS(2294),
    [anon_sym_RPAREN] = ACTIONS(2294),
    [aux_sym_preproc_if_token1] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2292),
    [sym_preproc_directive] = ACTIONS(2292),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_BANG] = ACTIONS(2292),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_PERCENT] = ACTIONS(2294),
    [anon_sym_PIPE_PIPE] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_PIPE] = ACTIONS(2292),
    [anon_sym_CARET] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_EQ_EQ] = ACTIONS(2294),
    [anon_sym_BANG_EQ] = ACTIONS(2294),
    [anon_sym_GT] = ACTIONS(2292),
    [anon_sym_GT_EQ] = ACTIONS(2294),
    [anon_sym_LT_EQ] = ACTIONS(2292),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_LT_LT] = ACTIONS(2294),
    [anon_sym_GT_GT] = ACTIONS(2294),
    [anon_sym_COLON] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym_typedef] = ACTIONS(2292),
    [anon_sym_in] = ACTIONS(2292),
    [anon_sym_out] = ACTIONS(2292),
    [anon_sym_inout] = ACTIONS(2292),
    [anon_sym_virtual] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym___attribute] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2294),
    [anon_sym___declspec] = ACTIONS(2292),
    [anon_sym___based] = ACTIONS(2292),
    [anon_sym___cdecl] = ACTIONS(2292),
    [anon_sym___clrcall] = ACTIONS(2292),
    [anon_sym___stdcall] = ACTIONS(2292),
    [anon_sym___fastcall] = ACTIONS(2292),
    [anon_sym___thiscall] = ACTIONS(2292),
    [anon_sym___vectorcall] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_signed] = ACTIONS(2292),
    [anon_sym_unsigned] = ACTIONS(2292),
    [anon_sym_long] = ACTIONS(2292),
    [anon_sym_short] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_RBRACK] = ACTIONS(2294),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym___inline] = ACTIONS(2292),
    [anon_sym___inline__] = ACTIONS(2292),
    [anon_sym___forceinline] = ACTIONS(2292),
    [anon_sym_thread_local] = ACTIONS(2292),
    [anon_sym___thread] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym__Nonnull] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [sym_primitive_type] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_struct] = ACTIONS(2292),
    [anon_sym_union] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_else] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_case] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_goto] = ACTIONS(2292),
    [anon_sym_QMARK] = ACTIONS(2294),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_compl] = ACTIONS(2292),
    [anon_sym_LT_EQ_GT] = ACTIONS(2294),
    [anon_sym_or] = ACTIONS(2292),
    [anon_sym_and] = ACTIONS(2292),
    [anon_sym_bitor] = ACTIONS(2292),
    [anon_sym_xor] = ACTIONS(2292),
    [anon_sym_bitand] = ACTIONS(2292),
    [anon_sym_not_eq] = ACTIONS(2292),
    [anon_sym_is] = ACTIONS(2292),
    [anon_sym_as] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_sizeof] = ACTIONS(2292),
    [anon_sym___alignof__] = ACTIONS(2292),
    [anon_sym___alignof] = ACTIONS(2292),
    [anon_sym__alignof] = ACTIONS(2292),
    [anon_sym_alignof] = ACTIONS(2292),
    [anon_sym__Alignof] = ACTIONS(2292),
    [anon_sym_offsetof] = ACTIONS(2292),
    [anon_sym__Generic] = ACTIONS(2292),
    [anon_sym_asm] = ACTIONS(2292),
    [anon_sym___asm__] = ACTIONS(2292),
    [anon_sym___asm] = ACTIONS(2292),
    [anon_sym_DOT] = ACTIONS(2292),
    [anon_sym_DOT_STAR] = ACTIONS(2294),
    [anon_sym_DASH_GT] = ACTIONS(2294),
    [sym_number_literal] = ACTIONS(2294),
    [anon_sym_L_SQUOTE] = ACTIONS(2294),
    [anon_sym_u_SQUOTE] = ACTIONS(2294),
    [anon_sym_U_SQUOTE] = ACTIONS(2294),
    [anon_sym_u8_SQUOTE] = ACTIONS(2294),
    [anon_sym_SQUOTE] = ACTIONS(2294),
    [anon_sym_L_DQUOTE] = ACTIONS(2294),
    [anon_sym_u_DQUOTE] = ACTIONS(2294),
    [anon_sym_U_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8_DQUOTE] = ACTIONS(2294),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [anon_sym_NULL] = ACTIONS(2292),
    [anon_sym_nullptr] = ACTIONS(2292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_This] = ACTIONS(2292),
    [anon_sym_decltype] = ACTIONS(2292),
    [anon_sym_final] = ACTIONS(2292),
    [anon_sym_override] = ACTIONS(2292),
    [anon_sym_explicit] = ACTIONS(2292),
    [anon_sym_typename] = ACTIONS(2292),
    [anon_sym_export] = ACTIONS(2292),
    [anon_sym_module] = ACTIONS(2292),
    [anon_sym_import] = ACTIONS(2292),
    [anon_sym_template] = ACTIONS(2292),
    [anon_sym_operator] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_noexcept] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_static_assert] = ACTIONS(2292),
    [anon_sym_concept] = ACTIONS(2292),
    [anon_sym_co_return] = ACTIONS(2292),
    [anon_sym_co_yield] = ACTIONS(2292),
    [anon_sym_R_DQUOTE] = ACTIONS(2294),
    [anon_sym_LR_DQUOTE] = ACTIONS(2294),
    [anon_sym_uR_DQUOTE] = ACTIONS(2294),
    [anon_sym_UR_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2294),
    [anon_sym_co_await] = ACTIONS(2292),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_requires] = ACTIONS(2292),
    [sym_this] = ACTIONS(2292),
    [anon_sym_precise] = ACTIONS(2292),
    [anon_sym_shared] = ACTIONS(2292),
    [anon_sym_groupshared] = ACTIONS(2292),
    [anon_sym_uniform] = ACTIONS(2292),
    [anon_sym_row_major] = ACTIONS(2292),
    [anon_sym_column_major] = ACTIONS(2292),
    [anon_sym_globallycoherent] = ACTIONS(2292),
    [anon_sym_centroid] = ACTIONS(2292),
    [anon_sym_noperspective] = ACTIONS(2292),
    [anon_sym_nointerpolation] = ACTIONS(2292),
    [anon_sym_sample] = ACTIONS(2292),
    [anon_sym_linear] = ACTIONS(2292),
    [anon_sym_snorm] = ACTIONS(2292),
    [anon_sym_unorm] = ACTIONS(2292),
    [anon_sym_point] = ACTIONS(2292),
    [anon_sym_line] = ACTIONS(2292),
    [anon_sym_triangleadj] = ACTIONS(2292),
    [anon_sym_lineadj] = ACTIONS(2292),
    [anon_sym_triangle] = ACTIONS(2292),
    [anon_sym_interface] = ACTIONS(2292),
    [anon_sym_extension] = ACTIONS(2292),
    [anon_sym_where] = ACTIONS(2292),
    [anon_sym___exported] = ACTIONS(2292),
  },
  [163] = {
    [sym_declaration] = STATE(648),
    [sym_type_definition] = STATE(3121),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6655),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_expression_statement] = STATE(3121),
    [sym__for_statement_body] = STATE(11419),
    [sym_expression] = STATE(5814),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11507),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_alias_declaration] = STATE(3121),
    [sym__for_range_loop_body] = STATE(11519),
    [sym_init_statement] = STATE(2460),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(2316),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2318),
    [anon_sym___extension__] = ACTIONS(2320),
    [anon_sym_typedef] = ACTIONS(2322),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2324),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [164] = {
    [sym_declaration] = STATE(648),
    [sym_type_definition] = STATE(3121),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6655),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_expression_statement] = STATE(3121),
    [sym__for_statement_body] = STATE(11321),
    [sym_expression] = STATE(5814),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11507),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_alias_declaration] = STATE(3121),
    [sym__for_range_loop_body] = STATE(11332),
    [sym_init_statement] = STATE(2460),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(2316),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2318),
    [anon_sym___extension__] = ACTIONS(2320),
    [anon_sym_typedef] = ACTIONS(2322),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2324),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [165] = {
    [sym_declaration] = STATE(648),
    [sym_type_definition] = STATE(3121),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6655),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_expression_statement] = STATE(3121),
    [sym__for_statement_body] = STATE(11226),
    [sym_expression] = STATE(5814),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11507),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_alias_declaration] = STATE(3121),
    [sym__for_range_loop_body] = STATE(11276),
    [sym_init_statement] = STATE(2460),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(2316),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2318),
    [anon_sym___extension__] = ACTIONS(2320),
    [anon_sym_typedef] = ACTIONS(2322),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2324),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [166] = {
    [sym_declaration] = STATE(648),
    [sym_type_definition] = STATE(3121),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6655),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_expression_statement] = STATE(3121),
    [sym__for_statement_body] = STATE(10870),
    [sym_expression] = STATE(5814),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11507),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_alias_declaration] = STATE(3121),
    [sym__for_range_loop_body] = STATE(10873),
    [sym_init_statement] = STATE(2460),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(2316),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2318),
    [anon_sym___extension__] = ACTIONS(2320),
    [anon_sym_typedef] = ACTIONS(2322),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2324),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [167] = {
    [sym_declaration] = STATE(648),
    [sym_type_definition] = STATE(3121),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6655),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_expression_statement] = STATE(3121),
    [sym__for_statement_body] = STATE(11408),
    [sym_expression] = STATE(5814),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11507),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_alias_declaration] = STATE(3121),
    [sym__for_range_loop_body] = STATE(11409),
    [sym_init_statement] = STATE(2460),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(2316),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2318),
    [anon_sym___extension__] = ACTIONS(2320),
    [anon_sym_typedef] = ACTIONS(2322),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2324),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [168] = {
    [sym_declaration] = STATE(648),
    [sym_type_definition] = STATE(3121),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6655),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_expression_statement] = STATE(3121),
    [sym__for_statement_body] = STATE(11006),
    [sym_expression] = STATE(5814),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11507),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_alias_declaration] = STATE(3121),
    [sym__for_range_loop_body] = STATE(11007),
    [sym_init_statement] = STATE(2460),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(2316),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2318),
    [anon_sym___extension__] = ACTIONS(2320),
    [anon_sym_typedef] = ACTIONS(2322),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2324),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [169] = {
    [sym_declaration] = STATE(1462),
    [sym_type_definition] = STATE(1462),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6614),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_expression_statement] = STATE(1462),
    [sym_expression] = STATE(5477),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10776),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_alias_declaration] = STATE(1462),
    [sym_init_statement] = STATE(199),
    [sym_condition_declaration] = STATE(11058),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(2316),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2044),
    [anon_sym___extension__] = ACTIONS(2086),
    [anon_sym_typedef] = ACTIONS(2088),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2330),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [170] = {
    [sym__declaration_modifiers] = STATE(2667),
    [sym__declaration_specifiers] = STATE(4972),
    [sym_attribute_specifier] = STATE(2667),
    [sym_attribute_declaration] = STATE(2667),
    [sym_ms_declspec_modifier] = STATE(2667),
    [sym_storage_class_specifier] = STATE(2667),
    [sym_type_qualifier] = STATE(2667),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2793),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_parameter_declaration] = STATE(10306),
    [sym_expression] = STATE(4403),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10654),
    [sym_dependent_type] = STATE(2839),
    [sym_optional_parameter_declaration] = STATE(10306),
    [sym_variadic_parameter_declaration] = STATE(10306),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym__unary_left_fold] = STATE(10798),
    [sym__unary_right_fold] = STATE(10800),
    [sym__binary_fold] = STATE(10803),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7280),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4579),
    [sym_qualifiers] = STATE(2667),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2667),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_RPAREN] = ACTIONS(2336),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2346),
    [anon_sym_in] = ACTIONS(2348),
    [anon_sym_out] = ACTIONS(2348),
    [anon_sym_inout] = ACTIONS(2348),
    [anon_sym_virtual] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2352),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2360),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_extension] = ACTIONS(2398),
  },
  [171] = {
    [sym__declaration_modifiers] = STATE(2667),
    [sym__declaration_specifiers] = STATE(4972),
    [sym_attribute_specifier] = STATE(2667),
    [sym_attribute_declaration] = STATE(2667),
    [sym_ms_declspec_modifier] = STATE(2667),
    [sym_storage_class_specifier] = STATE(2667),
    [sym_type_qualifier] = STATE(2667),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2793),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_parameter_declaration] = STATE(10306),
    [sym_expression] = STATE(4394),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10654),
    [sym_dependent_type] = STATE(2839),
    [sym_optional_parameter_declaration] = STATE(10306),
    [sym_variadic_parameter_declaration] = STATE(10306),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym__unary_left_fold] = STATE(11157),
    [sym__unary_right_fold] = STATE(11175),
    [sym__binary_fold] = STATE(11179),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7280),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4579),
    [sym_qualifiers] = STATE(2667),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2667),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_RPAREN] = ACTIONS(2336),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2346),
    [anon_sym_in] = ACTIONS(2348),
    [anon_sym_out] = ACTIONS(2348),
    [anon_sym_inout] = ACTIONS(2348),
    [anon_sym_virtual] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2352),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2360),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_extension] = ACTIONS(2398),
  },
  [172] = {
    [sym__declaration_modifiers] = STATE(2667),
    [sym__declaration_specifiers] = STATE(4972),
    [sym_attribute_specifier] = STATE(2667),
    [sym_attribute_declaration] = STATE(2667),
    [sym_ms_declspec_modifier] = STATE(2667),
    [sym_storage_class_specifier] = STATE(2667),
    [sym_type_qualifier] = STATE(2667),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2793),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_parameter_declaration] = STATE(10306),
    [sym_expression] = STATE(4385),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10654),
    [sym_dependent_type] = STATE(2839),
    [sym_optional_parameter_declaration] = STATE(10306),
    [sym_variadic_parameter_declaration] = STATE(10306),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym__unary_left_fold] = STATE(11567),
    [sym__unary_right_fold] = STATE(11568),
    [sym__binary_fold] = STATE(11569),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7280),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4579),
    [sym_qualifiers] = STATE(2667),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2667),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_RPAREN] = ACTIONS(2336),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2346),
    [anon_sym_in] = ACTIONS(2348),
    [anon_sym_out] = ACTIONS(2348),
    [anon_sym_inout] = ACTIONS(2348),
    [anon_sym_virtual] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2352),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2360),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_extension] = ACTIONS(2398),
  },
  [173] = {
    [sym__declaration_modifiers] = STATE(2667),
    [sym__declaration_specifiers] = STATE(4972),
    [sym_attribute_specifier] = STATE(2667),
    [sym_attribute_declaration] = STATE(2667),
    [sym_ms_declspec_modifier] = STATE(2667),
    [sym_storage_class_specifier] = STATE(2667),
    [sym_type_qualifier] = STATE(2667),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2793),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_parameter_declaration] = STATE(10306),
    [sym_expression] = STATE(4354),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10654),
    [sym_dependent_type] = STATE(2839),
    [sym_optional_parameter_declaration] = STATE(10306),
    [sym_variadic_parameter_declaration] = STATE(10306),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym__unary_left_fold] = STATE(11529),
    [sym__unary_right_fold] = STATE(11538),
    [sym__binary_fold] = STATE(11549),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7280),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4579),
    [sym_qualifiers] = STATE(2667),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2667),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_RPAREN] = ACTIONS(2336),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2346),
    [anon_sym_in] = ACTIONS(2348),
    [anon_sym_out] = ACTIONS(2348),
    [anon_sym_inout] = ACTIONS(2348),
    [anon_sym_virtual] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2352),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2360),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_extension] = ACTIONS(2398),
  },
  [174] = {
    [sym__declaration_modifiers] = STATE(2667),
    [sym__declaration_specifiers] = STATE(4972),
    [sym_attribute_specifier] = STATE(2667),
    [sym_attribute_declaration] = STATE(2667),
    [sym_ms_declspec_modifier] = STATE(2667),
    [sym_storage_class_specifier] = STATE(2667),
    [sym_type_qualifier] = STATE(2667),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2793),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_parameter_declaration] = STATE(10306),
    [sym_expression] = STATE(4355),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10654),
    [sym_dependent_type] = STATE(2839),
    [sym_optional_parameter_declaration] = STATE(10306),
    [sym_variadic_parameter_declaration] = STATE(10306),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym__unary_left_fold] = STATE(10862),
    [sym__unary_right_fold] = STATE(10885),
    [sym__binary_fold] = STATE(10914),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7280),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4579),
    [sym_qualifiers] = STATE(2667),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2667),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_RPAREN] = ACTIONS(2336),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2346),
    [anon_sym_in] = ACTIONS(2348),
    [anon_sym_out] = ACTIONS(2348),
    [anon_sym_inout] = ACTIONS(2348),
    [anon_sym_virtual] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2352),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2360),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_extension] = ACTIONS(2398),
  },
  [175] = {
    [sym__declaration_modifiers] = STATE(2667),
    [sym__declaration_specifiers] = STATE(4972),
    [sym_attribute_specifier] = STATE(2667),
    [sym_attribute_declaration] = STATE(2667),
    [sym_ms_declspec_modifier] = STATE(2667),
    [sym_storage_class_specifier] = STATE(2667),
    [sym_type_qualifier] = STATE(2667),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2793),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_parameter_declaration] = STATE(10306),
    [sym_expression] = STATE(4414),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10654),
    [sym_dependent_type] = STATE(2839),
    [sym_optional_parameter_declaration] = STATE(10306),
    [sym_variadic_parameter_declaration] = STATE(10306),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym__unary_left_fold] = STATE(10792),
    [sym__unary_right_fold] = STATE(10804),
    [sym__binary_fold] = STATE(10813),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7280),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4579),
    [sym_qualifiers] = STATE(2667),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2667),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_RPAREN] = ACTIONS(2336),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2346),
    [anon_sym_in] = ACTIONS(2348),
    [anon_sym_out] = ACTIONS(2348),
    [anon_sym_inout] = ACTIONS(2348),
    [anon_sym_virtual] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2352),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2360),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_extension] = ACTIONS(2398),
  },
  [176] = {
    [ts_builtin_sym_end] = ACTIONS(2250),
    [sym_identifier] = ACTIONS(2243),
    [aux_sym_preproc_include_token1] = ACTIONS(2243),
    [aux_sym_preproc_def_token1] = ACTIONS(2243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2245),
    [anon_sym_COMMA] = ACTIONS(2245),
    [aux_sym_preproc_if_token1] = ACTIONS(2243),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2243),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2243),
    [sym_preproc_directive] = ACTIONS(2243),
    [anon_sym_LPAREN2] = ACTIONS(2247),
    [anon_sym_BANG] = ACTIONS(2243),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2247),
    [anon_sym_SLASH] = ACTIONS(2255),
    [anon_sym_PERCENT] = ACTIONS(2245),
    [anon_sym_PIPE_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2255),
    [anon_sym_CARET] = ACTIONS(2245),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2245),
    [anon_sym_BANG_EQ] = ACTIONS(2245),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_GT_EQ] = ACTIONS(2245),
    [anon_sym_LT_EQ] = ACTIONS(2255),
    [anon_sym_LT] = ACTIONS(2255),
    [anon_sym_LT_LT] = ACTIONS(2245),
    [anon_sym_GT_GT] = ACTIONS(2245),
    [anon_sym_SEMI] = ACTIONS(2247),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym_typedef] = ACTIONS(2243),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_out] = ACTIONS(2243),
    [anon_sym_inout] = ACTIONS(2243),
    [anon_sym_virtual] = ACTIONS(2243),
    [anon_sym_extern] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym___attribute] = ACTIONS(2243),
    [anon_sym_using] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2247),
    [anon_sym___declspec] = ACTIONS(2243),
    [anon_sym___based] = ACTIONS(2243),
    [anon_sym___cdecl] = ACTIONS(2243),
    [anon_sym___clrcall] = ACTIONS(2243),
    [anon_sym___stdcall] = ACTIONS(2243),
    [anon_sym___fastcall] = ACTIONS(2243),
    [anon_sym___thiscall] = ACTIONS(2243),
    [anon_sym___vectorcall] = ACTIONS(2243),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_signed] = ACTIONS(2243),
    [anon_sym_unsigned] = ACTIONS(2243),
    [anon_sym_long] = ACTIONS(2243),
    [anon_sym_short] = ACTIONS(2243),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_RBRACK] = ACTIONS(2245),
    [anon_sym_register] = ACTIONS(2243),
    [anon_sym_inline] = ACTIONS(2243),
    [anon_sym___inline] = ACTIONS(2243),
    [anon_sym___inline__] = ACTIONS(2243),
    [anon_sym___forceinline] = ACTIONS(2243),
    [anon_sym_thread_local] = ACTIONS(2243),
    [anon_sym___thread] = ACTIONS(2243),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym__Nonnull] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [sym_primitive_type] = ACTIONS(2243),
    [anon_sym_enum] = ACTIONS(2243),
    [anon_sym_class] = ACTIONS(2243),
    [anon_sym_struct] = ACTIONS(2243),
    [anon_sym_union] = ACTIONS(2243),
    [anon_sym_if] = ACTIONS(2243),
    [anon_sym_switch] = ACTIONS(2243),
    [anon_sym_case] = ACTIONS(2243),
    [anon_sym_default] = ACTIONS(2243),
    [anon_sym_while] = ACTIONS(2243),
    [anon_sym_do] = ACTIONS(2243),
    [anon_sym_for] = ACTIONS(2243),
    [anon_sym_return] = ACTIONS(2243),
    [anon_sym_break] = ACTIONS(2243),
    [anon_sym_continue] = ACTIONS(2243),
    [anon_sym_goto] = ACTIONS(2243),
    [anon_sym_QMARK] = ACTIONS(2245),
    [anon_sym_not] = ACTIONS(2243),
    [anon_sym_compl] = ACTIONS(2243),
    [anon_sym_LT_EQ_GT] = ACTIONS(2245),
    [anon_sym_or] = ACTIONS(2255),
    [anon_sym_and] = ACTIONS(2255),
    [anon_sym_bitor] = ACTIONS(2255),
    [anon_sym_xor] = ACTIONS(2255),
    [anon_sym_bitand] = ACTIONS(2255),
    [anon_sym_not_eq] = ACTIONS(2255),
    [anon_sym_is] = ACTIONS(2255),
    [anon_sym_as] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2247),
    [anon_sym_PLUS_PLUS] = ACTIONS(2247),
    [anon_sym_sizeof] = ACTIONS(2243),
    [anon_sym___alignof__] = ACTIONS(2243),
    [anon_sym___alignof] = ACTIONS(2243),
    [anon_sym__alignof] = ACTIONS(2243),
    [anon_sym_alignof] = ACTIONS(2243),
    [anon_sym__Alignof] = ACTIONS(2243),
    [anon_sym_offsetof] = ACTIONS(2243),
    [anon_sym__Generic] = ACTIONS(2243),
    [anon_sym_asm] = ACTIONS(2243),
    [anon_sym___asm__] = ACTIONS(2243),
    [anon_sym___asm] = ACTIONS(2243),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2245),
    [anon_sym_DASH_GT] = ACTIONS(2245),
    [sym_number_literal] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2250),
    [anon_sym_u_SQUOTE] = ACTIONS(2250),
    [anon_sym_U_SQUOTE] = ACTIONS(2250),
    [anon_sym_u8_SQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_L_DQUOTE] = ACTIONS(2250),
    [anon_sym_u_DQUOTE] = ACTIONS(2250),
    [anon_sym_U_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [sym_true] = ACTIONS(2243),
    [sym_false] = ACTIONS(2243),
    [anon_sym_NULL] = ACTIONS(2243),
    [anon_sym_nullptr] = ACTIONS(2243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2243),
    [anon_sym_let] = ACTIONS(2243),
    [anon_sym_This] = ACTIONS(2243),
    [anon_sym_decltype] = ACTIONS(2243),
    [anon_sym_explicit] = ACTIONS(2243),
    [anon_sym_typename] = ACTIONS(2243),
    [anon_sym_export] = ACTIONS(2243),
    [anon_sym_module] = ACTIONS(2243),
    [anon_sym_import] = ACTIONS(2243),
    [anon_sym_template] = ACTIONS(2243),
    [anon_sym_operator] = ACTIONS(2243),
    [anon_sym_try] = ACTIONS(2243),
    [anon_sym_delete] = ACTIONS(2243),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_namespace] = ACTIONS(2243),
    [anon_sym_static_assert] = ACTIONS(2243),
    [anon_sym_concept] = ACTIONS(2243),
    [anon_sym_co_return] = ACTIONS(2243),
    [anon_sym_co_yield] = ACTIONS(2243),
    [anon_sym_R_DQUOTE] = ACTIONS(2250),
    [anon_sym_LR_DQUOTE] = ACTIONS(2250),
    [anon_sym_uR_DQUOTE] = ACTIONS(2250),
    [anon_sym_UR_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2250),
    [anon_sym_co_await] = ACTIONS(2243),
    [anon_sym_new] = ACTIONS(2243),
    [anon_sym_requires] = ACTIONS(2243),
    [sym_this] = ACTIONS(2243),
    [anon_sym_precise] = ACTIONS(2243),
    [anon_sym_shared] = ACTIONS(2243),
    [anon_sym_groupshared] = ACTIONS(2243),
    [anon_sym_uniform] = ACTIONS(2243),
    [anon_sym_row_major] = ACTIONS(2243),
    [anon_sym_column_major] = ACTIONS(2243),
    [anon_sym_globallycoherent] = ACTIONS(2243),
    [anon_sym_centroid] = ACTIONS(2243),
    [anon_sym_noperspective] = ACTIONS(2243),
    [anon_sym_nointerpolation] = ACTIONS(2243),
    [anon_sym_sample] = ACTIONS(2243),
    [anon_sym_linear] = ACTIONS(2243),
    [anon_sym_snorm] = ACTIONS(2243),
    [anon_sym_unorm] = ACTIONS(2243),
    [anon_sym_point] = ACTIONS(2243),
    [anon_sym_line] = ACTIONS(2243),
    [anon_sym_triangleadj] = ACTIONS(2243),
    [anon_sym_lineadj] = ACTIONS(2243),
    [anon_sym_triangle] = ACTIONS(2243),
    [anon_sym_interface] = ACTIONS(2243),
    [anon_sym_extension] = ACTIONS(2243),
    [anon_sym___exported] = ACTIONS(2243),
  },
  [177] = {
    [sym_identifier] = ACTIONS(2288),
    [aux_sym_preproc_include_token1] = ACTIONS(2288),
    [aux_sym_preproc_def_token1] = ACTIONS(2288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2290),
    [anon_sym_COMMA] = ACTIONS(2290),
    [aux_sym_preproc_if_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_PERCENT] = ACTIONS(2290),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_CARET] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_EQ_EQ] = ACTIONS(2290),
    [anon_sym_BANG_EQ] = ACTIONS(2290),
    [anon_sym_GT] = ACTIONS(2288),
    [anon_sym_GT_EQ] = ACTIONS(2290),
    [anon_sym_LT_EQ] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(2290),
    [anon_sym_GT_GT] = ACTIONS(2290),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_out] = ACTIONS(2288),
    [anon_sym_inout] = ACTIONS(2288),
    [anon_sym_virtual] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym___cdecl] = ACTIONS(2288),
    [anon_sym___clrcall] = ACTIONS(2288),
    [anon_sym___stdcall] = ACTIONS(2288),
    [anon_sym___fastcall] = ACTIONS(2288),
    [anon_sym___thiscall] = ACTIONS(2288),
    [anon_sym___vectorcall] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_RBRACE] = ACTIONS(2290),
    [anon_sym_signed] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym___try] = ACTIONS(2288),
    [anon_sym___leave] = ACTIONS(2288),
    [anon_sym_QMARK] = ACTIONS(2290),
    [anon_sym_not] = ACTIONS(2288),
    [anon_sym_compl] = ACTIONS(2288),
    [anon_sym_LT_EQ_GT] = ACTIONS(2290),
    [anon_sym_or] = ACTIONS(2288),
    [anon_sym_and] = ACTIONS(2288),
    [anon_sym_bitor] = ACTIONS(2288),
    [anon_sym_xor] = ACTIONS(2288),
    [anon_sym_bitand] = ACTIONS(2288),
    [anon_sym_not_eq] = ACTIONS(2288),
    [anon_sym_is] = ACTIONS(2288),
    [anon_sym_as] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_sizeof] = ACTIONS(2288),
    [anon_sym___alignof__] = ACTIONS(2288),
    [anon_sym___alignof] = ACTIONS(2288),
    [anon_sym__alignof] = ACTIONS(2288),
    [anon_sym_alignof] = ACTIONS(2288),
    [anon_sym__Alignof] = ACTIONS(2288),
    [anon_sym_offsetof] = ACTIONS(2288),
    [anon_sym__Generic] = ACTIONS(2288),
    [anon_sym_asm] = ACTIONS(2288),
    [anon_sym___asm__] = ACTIONS(2288),
    [anon_sym___asm] = ACTIONS(2288),
    [anon_sym_DOT] = ACTIONS(2288),
    [anon_sym_DOT_STAR] = ACTIONS(2290),
    [anon_sym_DASH_GT] = ACTIONS(2290),
    [sym_number_literal] = ACTIONS(2290),
    [anon_sym_L_SQUOTE] = ACTIONS(2290),
    [anon_sym_u_SQUOTE] = ACTIONS(2290),
    [anon_sym_U_SQUOTE] = ACTIONS(2290),
    [anon_sym_u8_SQUOTE] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [anon_sym_L_DQUOTE] = ACTIONS(2290),
    [anon_sym_u_DQUOTE] = ACTIONS(2290),
    [anon_sym_U_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8_DQUOTE] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [anon_sym_NULL] = ACTIONS(2288),
    [anon_sym_nullptr] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_This] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_static_assert] = ACTIONS(2288),
    [anon_sym_concept] = ACTIONS(2288),
    [anon_sym_co_return] = ACTIONS(2288),
    [anon_sym_co_yield] = ACTIONS(2288),
    [anon_sym_R_DQUOTE] = ACTIONS(2290),
    [anon_sym_LR_DQUOTE] = ACTIONS(2290),
    [anon_sym_uR_DQUOTE] = ACTIONS(2290),
    [anon_sym_UR_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2290),
    [anon_sym_co_await] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_requires] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [anon_sym_discard] = ACTIONS(2288),
    [anon_sym_precise] = ACTIONS(2288),
    [anon_sym_shared] = ACTIONS(2288),
    [anon_sym_groupshared] = ACTIONS(2288),
    [anon_sym_uniform] = ACTIONS(2288),
    [anon_sym_row_major] = ACTIONS(2288),
    [anon_sym_column_major] = ACTIONS(2288),
    [anon_sym_globallycoherent] = ACTIONS(2288),
    [anon_sym_centroid] = ACTIONS(2288),
    [anon_sym_noperspective] = ACTIONS(2288),
    [anon_sym_nointerpolation] = ACTIONS(2288),
    [anon_sym_sample] = ACTIONS(2288),
    [anon_sym_linear] = ACTIONS(2288),
    [anon_sym_snorm] = ACTIONS(2288),
    [anon_sym_unorm] = ACTIONS(2288),
    [anon_sym_point] = ACTIONS(2288),
    [anon_sym_line] = ACTIONS(2288),
    [anon_sym_triangleadj] = ACTIONS(2288),
    [anon_sym_lineadj] = ACTIONS(2288),
    [anon_sym_triangle] = ACTIONS(2288),
    [anon_sym_cbuffer] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_extension] = ACTIONS(2288),
  },
  [178] = {
    [sym_identifier] = ACTIONS(2284),
    [aux_sym_preproc_include_token1] = ACTIONS(2284),
    [aux_sym_preproc_def_token1] = ACTIONS(2284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2286),
    [anon_sym_COMMA] = ACTIONS(2286),
    [aux_sym_preproc_if_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2284),
    [sym_preproc_directive] = ACTIONS(2284),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2284),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_SLASH] = ACTIONS(2284),
    [anon_sym_PERCENT] = ACTIONS(2286),
    [anon_sym_PIPE_PIPE] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2284),
    [anon_sym_CARET] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_EQ_EQ] = ACTIONS(2286),
    [anon_sym_BANG_EQ] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2284),
    [anon_sym_GT_EQ] = ACTIONS(2286),
    [anon_sym_LT_EQ] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2284),
    [anon_sym_LT_LT] = ACTIONS(2286),
    [anon_sym_GT_GT] = ACTIONS(2286),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_typedef] = ACTIONS(2284),
    [anon_sym_in] = ACTIONS(2284),
    [anon_sym_out] = ACTIONS(2284),
    [anon_sym_inout] = ACTIONS(2284),
    [anon_sym_virtual] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_using] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym___cdecl] = ACTIONS(2284),
    [anon_sym___clrcall] = ACTIONS(2284),
    [anon_sym___stdcall] = ACTIONS(2284),
    [anon_sym___fastcall] = ACTIONS(2284),
    [anon_sym___thiscall] = ACTIONS(2284),
    [anon_sym___vectorcall] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_signed] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_switch] = ACTIONS(2284),
    [anon_sym_case] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_goto] = ACTIONS(2284),
    [anon_sym___try] = ACTIONS(2284),
    [anon_sym___leave] = ACTIONS(2284),
    [anon_sym_QMARK] = ACTIONS(2286),
    [anon_sym_not] = ACTIONS(2284),
    [anon_sym_compl] = ACTIONS(2284),
    [anon_sym_LT_EQ_GT] = ACTIONS(2286),
    [anon_sym_or] = ACTIONS(2284),
    [anon_sym_and] = ACTIONS(2284),
    [anon_sym_bitor] = ACTIONS(2284),
    [anon_sym_xor] = ACTIONS(2284),
    [anon_sym_bitand] = ACTIONS(2284),
    [anon_sym_not_eq] = ACTIONS(2284),
    [anon_sym_is] = ACTIONS(2284),
    [anon_sym_as] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_sizeof] = ACTIONS(2284),
    [anon_sym___alignof__] = ACTIONS(2284),
    [anon_sym___alignof] = ACTIONS(2284),
    [anon_sym__alignof] = ACTIONS(2284),
    [anon_sym_alignof] = ACTIONS(2284),
    [anon_sym__Alignof] = ACTIONS(2284),
    [anon_sym_offsetof] = ACTIONS(2284),
    [anon_sym__Generic] = ACTIONS(2284),
    [anon_sym_asm] = ACTIONS(2284),
    [anon_sym___asm__] = ACTIONS(2284),
    [anon_sym___asm] = ACTIONS(2284),
    [anon_sym_DOT] = ACTIONS(2284),
    [anon_sym_DOT_STAR] = ACTIONS(2286),
    [anon_sym_DASH_GT] = ACTIONS(2286),
    [sym_number_literal] = ACTIONS(2286),
    [anon_sym_L_SQUOTE] = ACTIONS(2286),
    [anon_sym_u_SQUOTE] = ACTIONS(2286),
    [anon_sym_U_SQUOTE] = ACTIONS(2286),
    [anon_sym_u8_SQUOTE] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_L_DQUOTE] = ACTIONS(2286),
    [anon_sym_u_DQUOTE] = ACTIONS(2286),
    [anon_sym_U_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8_DQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [sym_true] = ACTIONS(2284),
    [sym_false] = ACTIONS(2284),
    [anon_sym_NULL] = ACTIONS(2284),
    [anon_sym_nullptr] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_This] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_typename] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_delete] = ACTIONS(2284),
    [anon_sym_throw] = ACTIONS(2284),
    [anon_sym_namespace] = ACTIONS(2284),
    [anon_sym_static_assert] = ACTIONS(2284),
    [anon_sym_concept] = ACTIONS(2284),
    [anon_sym_co_return] = ACTIONS(2284),
    [anon_sym_co_yield] = ACTIONS(2284),
    [anon_sym_R_DQUOTE] = ACTIONS(2286),
    [anon_sym_LR_DQUOTE] = ACTIONS(2286),
    [anon_sym_uR_DQUOTE] = ACTIONS(2286),
    [anon_sym_UR_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2286),
    [anon_sym_co_await] = ACTIONS(2284),
    [anon_sym_new] = ACTIONS(2284),
    [anon_sym_requires] = ACTIONS(2284),
    [sym_this] = ACTIONS(2284),
    [anon_sym_discard] = ACTIONS(2284),
    [anon_sym_precise] = ACTIONS(2284),
    [anon_sym_shared] = ACTIONS(2284),
    [anon_sym_groupshared] = ACTIONS(2284),
    [anon_sym_uniform] = ACTIONS(2284),
    [anon_sym_row_major] = ACTIONS(2284),
    [anon_sym_column_major] = ACTIONS(2284),
    [anon_sym_globallycoherent] = ACTIONS(2284),
    [anon_sym_centroid] = ACTIONS(2284),
    [anon_sym_noperspective] = ACTIONS(2284),
    [anon_sym_nointerpolation] = ACTIONS(2284),
    [anon_sym_sample] = ACTIONS(2284),
    [anon_sym_linear] = ACTIONS(2284),
    [anon_sym_snorm] = ACTIONS(2284),
    [anon_sym_unorm] = ACTIONS(2284),
    [anon_sym_point] = ACTIONS(2284),
    [anon_sym_line] = ACTIONS(2284),
    [anon_sym_triangleadj] = ACTIONS(2284),
    [anon_sym_lineadj] = ACTIONS(2284),
    [anon_sym_triangle] = ACTIONS(2284),
    [anon_sym_cbuffer] = ACTIONS(2284),
    [anon_sym_interface] = ACTIONS(2284),
    [anon_sym_extension] = ACTIONS(2284),
  },
  [179] = {
    [sym_identifier] = ACTIONS(2280),
    [aux_sym_preproc_include_token1] = ACTIONS(2280),
    [aux_sym_preproc_def_token1] = ACTIONS(2280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_COMMA] = ACTIONS(2282),
    [aux_sym_preproc_if_token1] = ACTIONS(2280),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2280),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2280),
    [sym_preproc_directive] = ACTIONS(2280),
    [anon_sym_LPAREN2] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2282),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2282),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_PERCENT] = ACTIONS(2282),
    [anon_sym_PIPE_PIPE] = ACTIONS(2282),
    [anon_sym_AMP_AMP] = ACTIONS(2282),
    [anon_sym_PIPE] = ACTIONS(2280),
    [anon_sym_CARET] = ACTIONS(2282),
    [anon_sym_AMP] = ACTIONS(2280),
    [anon_sym_EQ_EQ] = ACTIONS(2282),
    [anon_sym_BANG_EQ] = ACTIONS(2282),
    [anon_sym_GT] = ACTIONS(2280),
    [anon_sym_GT_EQ] = ACTIONS(2282),
    [anon_sym_LT_EQ] = ACTIONS(2280),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_LT_LT] = ACTIONS(2282),
    [anon_sym_GT_GT] = ACTIONS(2282),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(2280),
    [anon_sym_typedef] = ACTIONS(2280),
    [anon_sym_in] = ACTIONS(2280),
    [anon_sym_out] = ACTIONS(2280),
    [anon_sym_inout] = ACTIONS(2280),
    [anon_sym_virtual] = ACTIONS(2280),
    [anon_sym_extern] = ACTIONS(2280),
    [anon_sym___attribute__] = ACTIONS(2280),
    [anon_sym___attribute] = ACTIONS(2280),
    [anon_sym_using] = ACTIONS(2280),
    [anon_sym_COLON_COLON] = ACTIONS(2282),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2282),
    [anon_sym___declspec] = ACTIONS(2280),
    [anon_sym___based] = ACTIONS(2280),
    [anon_sym___cdecl] = ACTIONS(2280),
    [anon_sym___clrcall] = ACTIONS(2280),
    [anon_sym___stdcall] = ACTIONS(2280),
    [anon_sym___fastcall] = ACTIONS(2280),
    [anon_sym___thiscall] = ACTIONS(2280),
    [anon_sym___vectorcall] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_RBRACE] = ACTIONS(2282),
    [anon_sym_signed] = ACTIONS(2280),
    [anon_sym_unsigned] = ACTIONS(2280),
    [anon_sym_long] = ACTIONS(2280),
    [anon_sym_short] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_register] = ACTIONS(2280),
    [anon_sym_inline] = ACTIONS(2280),
    [anon_sym___inline] = ACTIONS(2280),
    [anon_sym___inline__] = ACTIONS(2280),
    [anon_sym___forceinline] = ACTIONS(2280),
    [anon_sym_thread_local] = ACTIONS(2280),
    [anon_sym___thread] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_constexpr] = ACTIONS(2280),
    [anon_sym_volatile] = ACTIONS(2280),
    [anon_sym_restrict] = ACTIONS(2280),
    [anon_sym___restrict__] = ACTIONS(2280),
    [anon_sym__Atomic] = ACTIONS(2280),
    [anon_sym__Noreturn] = ACTIONS(2280),
    [anon_sym_noreturn] = ACTIONS(2280),
    [anon_sym__Nonnull] = ACTIONS(2280),
    [anon_sym_mutable] = ACTIONS(2280),
    [anon_sym_constinit] = ACTIONS(2280),
    [anon_sym_consteval] = ACTIONS(2280),
    [anon_sym_alignas] = ACTIONS(2280),
    [anon_sym__Alignas] = ACTIONS(2280),
    [sym_primitive_type] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_struct] = ACTIONS(2280),
    [anon_sym_union] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_goto] = ACTIONS(2280),
    [anon_sym___try] = ACTIONS(2280),
    [anon_sym___leave] = ACTIONS(2280),
    [anon_sym_QMARK] = ACTIONS(2282),
    [anon_sym_not] = ACTIONS(2280),
    [anon_sym_compl] = ACTIONS(2280),
    [anon_sym_LT_EQ_GT] = ACTIONS(2282),
    [anon_sym_or] = ACTIONS(2280),
    [anon_sym_and] = ACTIONS(2280),
    [anon_sym_bitor] = ACTIONS(2280),
    [anon_sym_xor] = ACTIONS(2280),
    [anon_sym_bitand] = ACTIONS(2280),
    [anon_sym_not_eq] = ACTIONS(2280),
    [anon_sym_is] = ACTIONS(2280),
    [anon_sym_as] = ACTIONS(2280),
    [anon_sym_DASH_DASH] = ACTIONS(2282),
    [anon_sym_PLUS_PLUS] = ACTIONS(2282),
    [anon_sym_sizeof] = ACTIONS(2280),
    [anon_sym___alignof__] = ACTIONS(2280),
    [anon_sym___alignof] = ACTIONS(2280),
    [anon_sym__alignof] = ACTIONS(2280),
    [anon_sym_alignof] = ACTIONS(2280),
    [anon_sym__Alignof] = ACTIONS(2280),
    [anon_sym_offsetof] = ACTIONS(2280),
    [anon_sym__Generic] = ACTIONS(2280),
    [anon_sym_asm] = ACTIONS(2280),
    [anon_sym___asm__] = ACTIONS(2280),
    [anon_sym___asm] = ACTIONS(2280),
    [anon_sym_DOT] = ACTIONS(2280),
    [anon_sym_DOT_STAR] = ACTIONS(2282),
    [anon_sym_DASH_GT] = ACTIONS(2282),
    [sym_number_literal] = ACTIONS(2282),
    [anon_sym_L_SQUOTE] = ACTIONS(2282),
    [anon_sym_u_SQUOTE] = ACTIONS(2282),
    [anon_sym_U_SQUOTE] = ACTIONS(2282),
    [anon_sym_u8_SQUOTE] = ACTIONS(2282),
    [anon_sym_SQUOTE] = ACTIONS(2282),
    [anon_sym_L_DQUOTE] = ACTIONS(2282),
    [anon_sym_u_DQUOTE] = ACTIONS(2282),
    [anon_sym_U_DQUOTE] = ACTIONS(2282),
    [anon_sym_u8_DQUOTE] = ACTIONS(2282),
    [anon_sym_DQUOTE] = ACTIONS(2282),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [anon_sym_NULL] = ACTIONS(2280),
    [anon_sym_nullptr] = ACTIONS(2280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_This] = ACTIONS(2280),
    [anon_sym_decltype] = ACTIONS(2280),
    [anon_sym_explicit] = ACTIONS(2280),
    [anon_sym_typename] = ACTIONS(2280),
    [anon_sym_template] = ACTIONS(2280),
    [anon_sym_operator] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_static_assert] = ACTIONS(2280),
    [anon_sym_concept] = ACTIONS(2280),
    [anon_sym_co_return] = ACTIONS(2280),
    [anon_sym_co_yield] = ACTIONS(2280),
    [anon_sym_R_DQUOTE] = ACTIONS(2282),
    [anon_sym_LR_DQUOTE] = ACTIONS(2282),
    [anon_sym_uR_DQUOTE] = ACTIONS(2282),
    [anon_sym_UR_DQUOTE] = ACTIONS(2282),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2282),
    [anon_sym_co_await] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_requires] = ACTIONS(2280),
    [sym_this] = ACTIONS(2280),
    [anon_sym_discard] = ACTIONS(2280),
    [anon_sym_precise] = ACTIONS(2280),
    [anon_sym_shared] = ACTIONS(2280),
    [anon_sym_groupshared] = ACTIONS(2280),
    [anon_sym_uniform] = ACTIONS(2280),
    [anon_sym_row_major] = ACTIONS(2280),
    [anon_sym_column_major] = ACTIONS(2280),
    [anon_sym_globallycoherent] = ACTIONS(2280),
    [anon_sym_centroid] = ACTIONS(2280),
    [anon_sym_noperspective] = ACTIONS(2280),
    [anon_sym_nointerpolation] = ACTIONS(2280),
    [anon_sym_sample] = ACTIONS(2280),
    [anon_sym_linear] = ACTIONS(2280),
    [anon_sym_snorm] = ACTIONS(2280),
    [anon_sym_unorm] = ACTIONS(2280),
    [anon_sym_point] = ACTIONS(2280),
    [anon_sym_line] = ACTIONS(2280),
    [anon_sym_triangleadj] = ACTIONS(2280),
    [anon_sym_lineadj] = ACTIONS(2280),
    [anon_sym_triangle] = ACTIONS(2280),
    [anon_sym_cbuffer] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_extension] = ACTIONS(2280),
  },
  [180] = {
    [sym_identifier] = ACTIONS(2239),
    [aux_sym_preproc_include_token1] = ACTIONS(2239),
    [aux_sym_preproc_def_token1] = ACTIONS(2239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2241),
    [anon_sym_COMMA] = ACTIONS(2241),
    [aux_sym_preproc_if_token1] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2239),
    [sym_preproc_directive] = ACTIONS(2239),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2239),
    [anon_sym_PLUS] = ACTIONS(2239),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_SLASH] = ACTIONS(2239),
    [anon_sym_PERCENT] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_PIPE] = ACTIONS(2239),
    [anon_sym_CARET] = ACTIONS(2241),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_LT_EQ] = ACTIONS(2239),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_LT_LT] = ACTIONS(2241),
    [anon_sym_GT_GT] = ACTIONS(2241),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym_typedef] = ACTIONS(2239),
    [anon_sym_in] = ACTIONS(2239),
    [anon_sym_out] = ACTIONS(2239),
    [anon_sym_inout] = ACTIONS(2239),
    [anon_sym_virtual] = ACTIONS(2239),
    [anon_sym_extern] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym___attribute] = ACTIONS(2239),
    [anon_sym_using] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2241),
    [anon_sym___declspec] = ACTIONS(2239),
    [anon_sym___based] = ACTIONS(2239),
    [anon_sym___cdecl] = ACTIONS(2239),
    [anon_sym___clrcall] = ACTIONS(2239),
    [anon_sym___stdcall] = ACTIONS(2239),
    [anon_sym___fastcall] = ACTIONS(2239),
    [anon_sym___thiscall] = ACTIONS(2239),
    [anon_sym___vectorcall] = ACTIONS(2239),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_RBRACE] = ACTIONS(2241),
    [anon_sym_signed] = ACTIONS(2239),
    [anon_sym_unsigned] = ACTIONS(2239),
    [anon_sym_long] = ACTIONS(2239),
    [anon_sym_short] = ACTIONS(2239),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2239),
    [anon_sym_register] = ACTIONS(2239),
    [anon_sym_inline] = ACTIONS(2239),
    [anon_sym___inline] = ACTIONS(2239),
    [anon_sym___inline__] = ACTIONS(2239),
    [anon_sym___forceinline] = ACTIONS(2239),
    [anon_sym_thread_local] = ACTIONS(2239),
    [anon_sym___thread] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym__Nonnull] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [sym_primitive_type] = ACTIONS(2239),
    [anon_sym_enum] = ACTIONS(2239),
    [anon_sym_class] = ACTIONS(2239),
    [anon_sym_struct] = ACTIONS(2239),
    [anon_sym_union] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(2239),
    [anon_sym_switch] = ACTIONS(2239),
    [anon_sym_case] = ACTIONS(2239),
    [anon_sym_default] = ACTIONS(2239),
    [anon_sym_while] = ACTIONS(2239),
    [anon_sym_do] = ACTIONS(2239),
    [anon_sym_for] = ACTIONS(2239),
    [anon_sym_return] = ACTIONS(2239),
    [anon_sym_break] = ACTIONS(2239),
    [anon_sym_continue] = ACTIONS(2239),
    [anon_sym_goto] = ACTIONS(2239),
    [anon_sym___try] = ACTIONS(2239),
    [anon_sym___leave] = ACTIONS(2239),
    [anon_sym_QMARK] = ACTIONS(2241),
    [anon_sym_not] = ACTIONS(2239),
    [anon_sym_compl] = ACTIONS(2239),
    [anon_sym_LT_EQ_GT] = ACTIONS(2241),
    [anon_sym_or] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(2239),
    [anon_sym_bitor] = ACTIONS(2239),
    [anon_sym_xor] = ACTIONS(2239),
    [anon_sym_bitand] = ACTIONS(2239),
    [anon_sym_not_eq] = ACTIONS(2239),
    [anon_sym_is] = ACTIONS(2239),
    [anon_sym_as] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_sizeof] = ACTIONS(2239),
    [anon_sym___alignof__] = ACTIONS(2239),
    [anon_sym___alignof] = ACTIONS(2239),
    [anon_sym__alignof] = ACTIONS(2239),
    [anon_sym_alignof] = ACTIONS(2239),
    [anon_sym__Alignof] = ACTIONS(2239),
    [anon_sym_offsetof] = ACTIONS(2239),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2239),
    [anon_sym___asm__] = ACTIONS(2239),
    [anon_sym___asm] = ACTIONS(2239),
    [anon_sym_DOT] = ACTIONS(2239),
    [anon_sym_DOT_STAR] = ACTIONS(2241),
    [anon_sym_DASH_GT] = ACTIONS(2241),
    [sym_number_literal] = ACTIONS(2241),
    [anon_sym_L_SQUOTE] = ACTIONS(2241),
    [anon_sym_u_SQUOTE] = ACTIONS(2241),
    [anon_sym_U_SQUOTE] = ACTIONS(2241),
    [anon_sym_u8_SQUOTE] = ACTIONS(2241),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_L_DQUOTE] = ACTIONS(2241),
    [anon_sym_u_DQUOTE] = ACTIONS(2241),
    [anon_sym_U_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8_DQUOTE] = ACTIONS(2241),
    [anon_sym_DQUOTE] = ACTIONS(2241),
    [sym_true] = ACTIONS(2239),
    [sym_false] = ACTIONS(2239),
    [anon_sym_NULL] = ACTIONS(2239),
    [anon_sym_nullptr] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2239),
    [anon_sym_let] = ACTIONS(2239),
    [anon_sym_This] = ACTIONS(2239),
    [anon_sym_decltype] = ACTIONS(2239),
    [anon_sym_explicit] = ACTIONS(2239),
    [anon_sym_typename] = ACTIONS(2239),
    [anon_sym_template] = ACTIONS(2239),
    [anon_sym_operator] = ACTIONS(2239),
    [anon_sym_try] = ACTIONS(2239),
    [anon_sym_delete] = ACTIONS(2239),
    [anon_sym_throw] = ACTIONS(2239),
    [anon_sym_namespace] = ACTIONS(2239),
    [anon_sym_static_assert] = ACTIONS(2239),
    [anon_sym_concept] = ACTIONS(2239),
    [anon_sym_co_return] = ACTIONS(2239),
    [anon_sym_co_yield] = ACTIONS(2239),
    [anon_sym_R_DQUOTE] = ACTIONS(2241),
    [anon_sym_LR_DQUOTE] = ACTIONS(2241),
    [anon_sym_uR_DQUOTE] = ACTIONS(2241),
    [anon_sym_UR_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2241),
    [anon_sym_co_await] = ACTIONS(2239),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_requires] = ACTIONS(2239),
    [sym_this] = ACTIONS(2239),
    [anon_sym_discard] = ACTIONS(2239),
    [anon_sym_precise] = ACTIONS(2239),
    [anon_sym_shared] = ACTIONS(2239),
    [anon_sym_groupshared] = ACTIONS(2239),
    [anon_sym_uniform] = ACTIONS(2239),
    [anon_sym_row_major] = ACTIONS(2239),
    [anon_sym_column_major] = ACTIONS(2239),
    [anon_sym_globallycoherent] = ACTIONS(2239),
    [anon_sym_centroid] = ACTIONS(2239),
    [anon_sym_noperspective] = ACTIONS(2239),
    [anon_sym_nointerpolation] = ACTIONS(2239),
    [anon_sym_sample] = ACTIONS(2239),
    [anon_sym_linear] = ACTIONS(2239),
    [anon_sym_snorm] = ACTIONS(2239),
    [anon_sym_unorm] = ACTIONS(2239),
    [anon_sym_point] = ACTIONS(2239),
    [anon_sym_line] = ACTIONS(2239),
    [anon_sym_triangleadj] = ACTIONS(2239),
    [anon_sym_lineadj] = ACTIONS(2239),
    [anon_sym_triangle] = ACTIONS(2239),
    [anon_sym_cbuffer] = ACTIONS(2239),
    [anon_sym_interface] = ACTIONS(2239),
    [anon_sym_extension] = ACTIONS(2239),
  },
  [181] = {
    [sym_identifier] = ACTIONS(2272),
    [aux_sym_preproc_include_token1] = ACTIONS(2272),
    [aux_sym_preproc_def_token1] = ACTIONS(2272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2274),
    [anon_sym_COMMA] = ACTIONS(2274),
    [aux_sym_preproc_if_token1] = ACTIONS(2272),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2272),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2272),
    [sym_preproc_directive] = ACTIONS(2272),
    [anon_sym_LPAREN2] = ACTIONS(2274),
    [anon_sym_BANG] = ACTIONS(2272),
    [anon_sym_TILDE] = ACTIONS(2274),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2274),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_PERCENT] = ACTIONS(2274),
    [anon_sym_PIPE_PIPE] = ACTIONS(2274),
    [anon_sym_AMP_AMP] = ACTIONS(2274),
    [anon_sym_PIPE] = ACTIONS(2272),
    [anon_sym_CARET] = ACTIONS(2274),
    [anon_sym_AMP] = ACTIONS(2272),
    [anon_sym_EQ_EQ] = ACTIONS(2274),
    [anon_sym_BANG_EQ] = ACTIONS(2274),
    [anon_sym_GT] = ACTIONS(2272),
    [anon_sym_GT_EQ] = ACTIONS(2274),
    [anon_sym_LT_EQ] = ACTIONS(2272),
    [anon_sym_LT] = ACTIONS(2272),
    [anon_sym_LT_LT] = ACTIONS(2274),
    [anon_sym_GT_GT] = ACTIONS(2274),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym___extension__] = ACTIONS(2272),
    [anon_sym_typedef] = ACTIONS(2272),
    [anon_sym_in] = ACTIONS(2272),
    [anon_sym_out] = ACTIONS(2272),
    [anon_sym_inout] = ACTIONS(2272),
    [anon_sym_virtual] = ACTIONS(2272),
    [anon_sym_extern] = ACTIONS(2272),
    [anon_sym___attribute__] = ACTIONS(2272),
    [anon_sym___attribute] = ACTIONS(2272),
    [anon_sym_using] = ACTIONS(2272),
    [anon_sym_COLON_COLON] = ACTIONS(2274),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2274),
    [anon_sym___declspec] = ACTIONS(2272),
    [anon_sym___based] = ACTIONS(2272),
    [anon_sym___cdecl] = ACTIONS(2272),
    [anon_sym___clrcall] = ACTIONS(2272),
    [anon_sym___stdcall] = ACTIONS(2272),
    [anon_sym___fastcall] = ACTIONS(2272),
    [anon_sym___thiscall] = ACTIONS(2272),
    [anon_sym___vectorcall] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_RBRACE] = ACTIONS(2274),
    [anon_sym_signed] = ACTIONS(2272),
    [anon_sym_unsigned] = ACTIONS(2272),
    [anon_sym_long] = ACTIONS(2272),
    [anon_sym_short] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_register] = ACTIONS(2272),
    [anon_sym_inline] = ACTIONS(2272),
    [anon_sym___inline] = ACTIONS(2272),
    [anon_sym___inline__] = ACTIONS(2272),
    [anon_sym___forceinline] = ACTIONS(2272),
    [anon_sym_thread_local] = ACTIONS(2272),
    [anon_sym___thread] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_constexpr] = ACTIONS(2272),
    [anon_sym_volatile] = ACTIONS(2272),
    [anon_sym_restrict] = ACTIONS(2272),
    [anon_sym___restrict__] = ACTIONS(2272),
    [anon_sym__Atomic] = ACTIONS(2272),
    [anon_sym__Noreturn] = ACTIONS(2272),
    [anon_sym_noreturn] = ACTIONS(2272),
    [anon_sym__Nonnull] = ACTIONS(2272),
    [anon_sym_mutable] = ACTIONS(2272),
    [anon_sym_constinit] = ACTIONS(2272),
    [anon_sym_consteval] = ACTIONS(2272),
    [anon_sym_alignas] = ACTIONS(2272),
    [anon_sym__Alignas] = ACTIONS(2272),
    [sym_primitive_type] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_struct] = ACTIONS(2272),
    [anon_sym_union] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_case] = ACTIONS(2272),
    [anon_sym_default] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_goto] = ACTIONS(2272),
    [anon_sym___try] = ACTIONS(2272),
    [anon_sym___leave] = ACTIONS(2272),
    [anon_sym_QMARK] = ACTIONS(2274),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_compl] = ACTIONS(2272),
    [anon_sym_LT_EQ_GT] = ACTIONS(2274),
    [anon_sym_or] = ACTIONS(2272),
    [anon_sym_and] = ACTIONS(2272),
    [anon_sym_bitor] = ACTIONS(2272),
    [anon_sym_xor] = ACTIONS(2272),
    [anon_sym_bitand] = ACTIONS(2272),
    [anon_sym_not_eq] = ACTIONS(2272),
    [anon_sym_is] = ACTIONS(2272),
    [anon_sym_as] = ACTIONS(2272),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_sizeof] = ACTIONS(2272),
    [anon_sym___alignof__] = ACTIONS(2272),
    [anon_sym___alignof] = ACTIONS(2272),
    [anon_sym__alignof] = ACTIONS(2272),
    [anon_sym_alignof] = ACTIONS(2272),
    [anon_sym__Alignof] = ACTIONS(2272),
    [anon_sym_offsetof] = ACTIONS(2272),
    [anon_sym__Generic] = ACTIONS(2272),
    [anon_sym_asm] = ACTIONS(2272),
    [anon_sym___asm__] = ACTIONS(2272),
    [anon_sym___asm] = ACTIONS(2272),
    [anon_sym_DOT] = ACTIONS(2272),
    [anon_sym_DOT_STAR] = ACTIONS(2274),
    [anon_sym_DASH_GT] = ACTIONS(2274),
    [sym_number_literal] = ACTIONS(2274),
    [anon_sym_L_SQUOTE] = ACTIONS(2274),
    [anon_sym_u_SQUOTE] = ACTIONS(2274),
    [anon_sym_U_SQUOTE] = ACTIONS(2274),
    [anon_sym_u8_SQUOTE] = ACTIONS(2274),
    [anon_sym_SQUOTE] = ACTIONS(2274),
    [anon_sym_L_DQUOTE] = ACTIONS(2274),
    [anon_sym_u_DQUOTE] = ACTIONS(2274),
    [anon_sym_U_DQUOTE] = ACTIONS(2274),
    [anon_sym_u8_DQUOTE] = ACTIONS(2274),
    [anon_sym_DQUOTE] = ACTIONS(2274),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [anon_sym_NULL] = ACTIONS(2272),
    [anon_sym_nullptr] = ACTIONS(2272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_This] = ACTIONS(2272),
    [anon_sym_decltype] = ACTIONS(2272),
    [anon_sym_explicit] = ACTIONS(2272),
    [anon_sym_typename] = ACTIONS(2272),
    [anon_sym_template] = ACTIONS(2272),
    [anon_sym_operator] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_namespace] = ACTIONS(2272),
    [anon_sym_static_assert] = ACTIONS(2272),
    [anon_sym_concept] = ACTIONS(2272),
    [anon_sym_co_return] = ACTIONS(2272),
    [anon_sym_co_yield] = ACTIONS(2272),
    [anon_sym_R_DQUOTE] = ACTIONS(2274),
    [anon_sym_LR_DQUOTE] = ACTIONS(2274),
    [anon_sym_uR_DQUOTE] = ACTIONS(2274),
    [anon_sym_UR_DQUOTE] = ACTIONS(2274),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2274),
    [anon_sym_co_await] = ACTIONS(2272),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_requires] = ACTIONS(2272),
    [sym_this] = ACTIONS(2272),
    [anon_sym_discard] = ACTIONS(2272),
    [anon_sym_precise] = ACTIONS(2272),
    [anon_sym_shared] = ACTIONS(2272),
    [anon_sym_groupshared] = ACTIONS(2272),
    [anon_sym_uniform] = ACTIONS(2272),
    [anon_sym_row_major] = ACTIONS(2272),
    [anon_sym_column_major] = ACTIONS(2272),
    [anon_sym_globallycoherent] = ACTIONS(2272),
    [anon_sym_centroid] = ACTIONS(2272),
    [anon_sym_noperspective] = ACTIONS(2272),
    [anon_sym_nointerpolation] = ACTIONS(2272),
    [anon_sym_sample] = ACTIONS(2272),
    [anon_sym_linear] = ACTIONS(2272),
    [anon_sym_snorm] = ACTIONS(2272),
    [anon_sym_unorm] = ACTIONS(2272),
    [anon_sym_point] = ACTIONS(2272),
    [anon_sym_line] = ACTIONS(2272),
    [anon_sym_triangleadj] = ACTIONS(2272),
    [anon_sym_lineadj] = ACTIONS(2272),
    [anon_sym_triangle] = ACTIONS(2272),
    [anon_sym_cbuffer] = ACTIONS(2272),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_extension] = ACTIONS(2272),
  },
  [182] = {
    [sym_identifier] = ACTIONS(2268),
    [aux_sym_preproc_include_token1] = ACTIONS(2268),
    [aux_sym_preproc_def_token1] = ACTIONS(2268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2270),
    [anon_sym_COMMA] = ACTIONS(2270),
    [aux_sym_preproc_if_token1] = ACTIONS(2268),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2268),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2268),
    [sym_preproc_directive] = ACTIONS(2268),
    [anon_sym_LPAREN2] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2268),
    [anon_sym_TILDE] = ACTIONS(2270),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2270),
    [anon_sym_SLASH] = ACTIONS(2268),
    [anon_sym_PERCENT] = ACTIONS(2270),
    [anon_sym_PIPE_PIPE] = ACTIONS(2270),
    [anon_sym_AMP_AMP] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2268),
    [anon_sym_CARET] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(2268),
    [anon_sym_EQ_EQ] = ACTIONS(2270),
    [anon_sym_BANG_EQ] = ACTIONS(2270),
    [anon_sym_GT] = ACTIONS(2268),
    [anon_sym_GT_EQ] = ACTIONS(2270),
    [anon_sym_LT_EQ] = ACTIONS(2268),
    [anon_sym_LT] = ACTIONS(2268),
    [anon_sym_LT_LT] = ACTIONS(2270),
    [anon_sym_GT_GT] = ACTIONS(2270),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym___extension__] = ACTIONS(2268),
    [anon_sym_typedef] = ACTIONS(2268),
    [anon_sym_in] = ACTIONS(2268),
    [anon_sym_out] = ACTIONS(2268),
    [anon_sym_inout] = ACTIONS(2268),
    [anon_sym_virtual] = ACTIONS(2268),
    [anon_sym_extern] = ACTIONS(2268),
    [anon_sym___attribute__] = ACTIONS(2268),
    [anon_sym___attribute] = ACTIONS(2268),
    [anon_sym_using] = ACTIONS(2268),
    [anon_sym_COLON_COLON] = ACTIONS(2270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2270),
    [anon_sym___declspec] = ACTIONS(2268),
    [anon_sym___based] = ACTIONS(2268),
    [anon_sym___cdecl] = ACTIONS(2268),
    [anon_sym___clrcall] = ACTIONS(2268),
    [anon_sym___stdcall] = ACTIONS(2268),
    [anon_sym___fastcall] = ACTIONS(2268),
    [anon_sym___thiscall] = ACTIONS(2268),
    [anon_sym___vectorcall] = ACTIONS(2268),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_RBRACE] = ACTIONS(2270),
    [anon_sym_signed] = ACTIONS(2268),
    [anon_sym_unsigned] = ACTIONS(2268),
    [anon_sym_long] = ACTIONS(2268),
    [anon_sym_short] = ACTIONS(2268),
    [anon_sym_LBRACK] = ACTIONS(2268),
    [anon_sym_static] = ACTIONS(2268),
    [anon_sym_register] = ACTIONS(2268),
    [anon_sym_inline] = ACTIONS(2268),
    [anon_sym___inline] = ACTIONS(2268),
    [anon_sym___inline__] = ACTIONS(2268),
    [anon_sym___forceinline] = ACTIONS(2268),
    [anon_sym_thread_local] = ACTIONS(2268),
    [anon_sym___thread] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_constexpr] = ACTIONS(2268),
    [anon_sym_volatile] = ACTIONS(2268),
    [anon_sym_restrict] = ACTIONS(2268),
    [anon_sym___restrict__] = ACTIONS(2268),
    [anon_sym__Atomic] = ACTIONS(2268),
    [anon_sym__Noreturn] = ACTIONS(2268),
    [anon_sym_noreturn] = ACTIONS(2268),
    [anon_sym__Nonnull] = ACTIONS(2268),
    [anon_sym_mutable] = ACTIONS(2268),
    [anon_sym_constinit] = ACTIONS(2268),
    [anon_sym_consteval] = ACTIONS(2268),
    [anon_sym_alignas] = ACTIONS(2268),
    [anon_sym__Alignas] = ACTIONS(2268),
    [sym_primitive_type] = ACTIONS(2268),
    [anon_sym_enum] = ACTIONS(2268),
    [anon_sym_class] = ACTIONS(2268),
    [anon_sym_struct] = ACTIONS(2268),
    [anon_sym_union] = ACTIONS(2268),
    [anon_sym_if] = ACTIONS(2268),
    [anon_sym_switch] = ACTIONS(2268),
    [anon_sym_case] = ACTIONS(2268),
    [anon_sym_default] = ACTIONS(2268),
    [anon_sym_while] = ACTIONS(2268),
    [anon_sym_do] = ACTIONS(2268),
    [anon_sym_for] = ACTIONS(2268),
    [anon_sym_return] = ACTIONS(2268),
    [anon_sym_break] = ACTIONS(2268),
    [anon_sym_continue] = ACTIONS(2268),
    [anon_sym_goto] = ACTIONS(2268),
    [anon_sym___try] = ACTIONS(2268),
    [anon_sym___leave] = ACTIONS(2268),
    [anon_sym_QMARK] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2268),
    [anon_sym_compl] = ACTIONS(2268),
    [anon_sym_LT_EQ_GT] = ACTIONS(2270),
    [anon_sym_or] = ACTIONS(2268),
    [anon_sym_and] = ACTIONS(2268),
    [anon_sym_bitor] = ACTIONS(2268),
    [anon_sym_xor] = ACTIONS(2268),
    [anon_sym_bitand] = ACTIONS(2268),
    [anon_sym_not_eq] = ACTIONS(2268),
    [anon_sym_is] = ACTIONS(2268),
    [anon_sym_as] = ACTIONS(2268),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_sizeof] = ACTIONS(2268),
    [anon_sym___alignof__] = ACTIONS(2268),
    [anon_sym___alignof] = ACTIONS(2268),
    [anon_sym__alignof] = ACTIONS(2268),
    [anon_sym_alignof] = ACTIONS(2268),
    [anon_sym__Alignof] = ACTIONS(2268),
    [anon_sym_offsetof] = ACTIONS(2268),
    [anon_sym__Generic] = ACTIONS(2268),
    [anon_sym_asm] = ACTIONS(2268),
    [anon_sym___asm__] = ACTIONS(2268),
    [anon_sym___asm] = ACTIONS(2268),
    [anon_sym_DOT] = ACTIONS(2268),
    [anon_sym_DOT_STAR] = ACTIONS(2270),
    [anon_sym_DASH_GT] = ACTIONS(2270),
    [sym_number_literal] = ACTIONS(2270),
    [anon_sym_L_SQUOTE] = ACTIONS(2270),
    [anon_sym_u_SQUOTE] = ACTIONS(2270),
    [anon_sym_U_SQUOTE] = ACTIONS(2270),
    [anon_sym_u8_SQUOTE] = ACTIONS(2270),
    [anon_sym_SQUOTE] = ACTIONS(2270),
    [anon_sym_L_DQUOTE] = ACTIONS(2270),
    [anon_sym_u_DQUOTE] = ACTIONS(2270),
    [anon_sym_U_DQUOTE] = ACTIONS(2270),
    [anon_sym_u8_DQUOTE] = ACTIONS(2270),
    [anon_sym_DQUOTE] = ACTIONS(2270),
    [sym_true] = ACTIONS(2268),
    [sym_false] = ACTIONS(2268),
    [anon_sym_NULL] = ACTIONS(2268),
    [anon_sym_nullptr] = ACTIONS(2268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_This] = ACTIONS(2268),
    [anon_sym_decltype] = ACTIONS(2268),
    [anon_sym_explicit] = ACTIONS(2268),
    [anon_sym_typename] = ACTIONS(2268),
    [anon_sym_template] = ACTIONS(2268),
    [anon_sym_operator] = ACTIONS(2268),
    [anon_sym_try] = ACTIONS(2268),
    [anon_sym_delete] = ACTIONS(2268),
    [anon_sym_throw] = ACTIONS(2268),
    [anon_sym_namespace] = ACTIONS(2268),
    [anon_sym_static_assert] = ACTIONS(2268),
    [anon_sym_concept] = ACTIONS(2268),
    [anon_sym_co_return] = ACTIONS(2268),
    [anon_sym_co_yield] = ACTIONS(2268),
    [anon_sym_R_DQUOTE] = ACTIONS(2270),
    [anon_sym_LR_DQUOTE] = ACTIONS(2270),
    [anon_sym_uR_DQUOTE] = ACTIONS(2270),
    [anon_sym_UR_DQUOTE] = ACTIONS(2270),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2270),
    [anon_sym_co_await] = ACTIONS(2268),
    [anon_sym_new] = ACTIONS(2268),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2268),
    [anon_sym_discard] = ACTIONS(2268),
    [anon_sym_precise] = ACTIONS(2268),
    [anon_sym_shared] = ACTIONS(2268),
    [anon_sym_groupshared] = ACTIONS(2268),
    [anon_sym_uniform] = ACTIONS(2268),
    [anon_sym_row_major] = ACTIONS(2268),
    [anon_sym_column_major] = ACTIONS(2268),
    [anon_sym_globallycoherent] = ACTIONS(2268),
    [anon_sym_centroid] = ACTIONS(2268),
    [anon_sym_noperspective] = ACTIONS(2268),
    [anon_sym_nointerpolation] = ACTIONS(2268),
    [anon_sym_sample] = ACTIONS(2268),
    [anon_sym_linear] = ACTIONS(2268),
    [anon_sym_snorm] = ACTIONS(2268),
    [anon_sym_unorm] = ACTIONS(2268),
    [anon_sym_point] = ACTIONS(2268),
    [anon_sym_line] = ACTIONS(2268),
    [anon_sym_triangleadj] = ACTIONS(2268),
    [anon_sym_lineadj] = ACTIONS(2268),
    [anon_sym_triangle] = ACTIONS(2268),
    [anon_sym_cbuffer] = ACTIONS(2268),
    [anon_sym_interface] = ACTIONS(2268),
    [anon_sym_extension] = ACTIONS(2268),
  },
  [183] = {
    [sym_identifier] = ACTIONS(2276),
    [aux_sym_preproc_include_token1] = ACTIONS(2276),
    [aux_sym_preproc_def_token1] = ACTIONS(2276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2278),
    [anon_sym_COMMA] = ACTIONS(2278),
    [aux_sym_preproc_if_token1] = ACTIONS(2276),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2276),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2276),
    [sym_preproc_directive] = ACTIONS(2276),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_PLUS] = ACTIONS(2276),
    [anon_sym_STAR] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2276),
    [anon_sym_PERCENT] = ACTIONS(2278),
    [anon_sym_PIPE_PIPE] = ACTIONS(2278),
    [anon_sym_AMP_AMP] = ACTIONS(2278),
    [anon_sym_PIPE] = ACTIONS(2276),
    [anon_sym_CARET] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_EQ_EQ] = ACTIONS(2278),
    [anon_sym_BANG_EQ] = ACTIONS(2278),
    [anon_sym_GT] = ACTIONS(2276),
    [anon_sym_GT_EQ] = ACTIONS(2278),
    [anon_sym_LT_EQ] = ACTIONS(2276),
    [anon_sym_LT] = ACTIONS(2276),
    [anon_sym_LT_LT] = ACTIONS(2278),
    [anon_sym_GT_GT] = ACTIONS(2278),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym___extension__] = ACTIONS(2276),
    [anon_sym_typedef] = ACTIONS(2276),
    [anon_sym_in] = ACTIONS(2276),
    [anon_sym_out] = ACTIONS(2276),
    [anon_sym_inout] = ACTIONS(2276),
    [anon_sym_virtual] = ACTIONS(2276),
    [anon_sym_extern] = ACTIONS(2276),
    [anon_sym___attribute__] = ACTIONS(2276),
    [anon_sym___attribute] = ACTIONS(2276),
    [anon_sym_using] = ACTIONS(2276),
    [anon_sym_COLON_COLON] = ACTIONS(2278),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2278),
    [anon_sym___declspec] = ACTIONS(2276),
    [anon_sym___based] = ACTIONS(2276),
    [anon_sym___cdecl] = ACTIONS(2276),
    [anon_sym___clrcall] = ACTIONS(2276),
    [anon_sym___stdcall] = ACTIONS(2276),
    [anon_sym___fastcall] = ACTIONS(2276),
    [anon_sym___thiscall] = ACTIONS(2276),
    [anon_sym___vectorcall] = ACTIONS(2276),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_signed] = ACTIONS(2276),
    [anon_sym_unsigned] = ACTIONS(2276),
    [anon_sym_long] = ACTIONS(2276),
    [anon_sym_short] = ACTIONS(2276),
    [anon_sym_LBRACK] = ACTIONS(2276),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_register] = ACTIONS(2276),
    [anon_sym_inline] = ACTIONS(2276),
    [anon_sym___inline] = ACTIONS(2276),
    [anon_sym___inline__] = ACTIONS(2276),
    [anon_sym___forceinline] = ACTIONS(2276),
    [anon_sym_thread_local] = ACTIONS(2276),
    [anon_sym___thread] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_constexpr] = ACTIONS(2276),
    [anon_sym_volatile] = ACTIONS(2276),
    [anon_sym_restrict] = ACTIONS(2276),
    [anon_sym___restrict__] = ACTIONS(2276),
    [anon_sym__Atomic] = ACTIONS(2276),
    [anon_sym__Noreturn] = ACTIONS(2276),
    [anon_sym_noreturn] = ACTIONS(2276),
    [anon_sym__Nonnull] = ACTIONS(2276),
    [anon_sym_mutable] = ACTIONS(2276),
    [anon_sym_constinit] = ACTIONS(2276),
    [anon_sym_consteval] = ACTIONS(2276),
    [anon_sym_alignas] = ACTIONS(2276),
    [anon_sym__Alignas] = ACTIONS(2276),
    [sym_primitive_type] = ACTIONS(2276),
    [anon_sym_enum] = ACTIONS(2276),
    [anon_sym_class] = ACTIONS(2276),
    [anon_sym_struct] = ACTIONS(2276),
    [anon_sym_union] = ACTIONS(2276),
    [anon_sym_if] = ACTIONS(2276),
    [anon_sym_switch] = ACTIONS(2276),
    [anon_sym_case] = ACTIONS(2276),
    [anon_sym_default] = ACTIONS(2276),
    [anon_sym_while] = ACTIONS(2276),
    [anon_sym_do] = ACTIONS(2276),
    [anon_sym_for] = ACTIONS(2276),
    [anon_sym_return] = ACTIONS(2276),
    [anon_sym_break] = ACTIONS(2276),
    [anon_sym_continue] = ACTIONS(2276),
    [anon_sym_goto] = ACTIONS(2276),
    [anon_sym___try] = ACTIONS(2276),
    [anon_sym___leave] = ACTIONS(2276),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_not] = ACTIONS(2276),
    [anon_sym_compl] = ACTIONS(2276),
    [anon_sym_LT_EQ_GT] = ACTIONS(2278),
    [anon_sym_or] = ACTIONS(2276),
    [anon_sym_and] = ACTIONS(2276),
    [anon_sym_bitor] = ACTIONS(2276),
    [anon_sym_xor] = ACTIONS(2276),
    [anon_sym_bitand] = ACTIONS(2276),
    [anon_sym_not_eq] = ACTIONS(2276),
    [anon_sym_is] = ACTIONS(2276),
    [anon_sym_as] = ACTIONS(2276),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_sizeof] = ACTIONS(2276),
    [anon_sym___alignof__] = ACTIONS(2276),
    [anon_sym___alignof] = ACTIONS(2276),
    [anon_sym__alignof] = ACTIONS(2276),
    [anon_sym_alignof] = ACTIONS(2276),
    [anon_sym__Alignof] = ACTIONS(2276),
    [anon_sym_offsetof] = ACTIONS(2276),
    [anon_sym__Generic] = ACTIONS(2276),
    [anon_sym_asm] = ACTIONS(2276),
    [anon_sym___asm__] = ACTIONS(2276),
    [anon_sym___asm] = ACTIONS(2276),
    [anon_sym_DOT] = ACTIONS(2276),
    [anon_sym_DOT_STAR] = ACTIONS(2278),
    [anon_sym_DASH_GT] = ACTIONS(2278),
    [sym_number_literal] = ACTIONS(2278),
    [anon_sym_L_SQUOTE] = ACTIONS(2278),
    [anon_sym_u_SQUOTE] = ACTIONS(2278),
    [anon_sym_U_SQUOTE] = ACTIONS(2278),
    [anon_sym_u8_SQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_L_DQUOTE] = ACTIONS(2278),
    [anon_sym_u_DQUOTE] = ACTIONS(2278),
    [anon_sym_U_DQUOTE] = ACTIONS(2278),
    [anon_sym_u8_DQUOTE] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [sym_true] = ACTIONS(2276),
    [sym_false] = ACTIONS(2276),
    [anon_sym_NULL] = ACTIONS(2276),
    [anon_sym_nullptr] = ACTIONS(2276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_This] = ACTIONS(2276),
    [anon_sym_decltype] = ACTIONS(2276),
    [anon_sym_explicit] = ACTIONS(2276),
    [anon_sym_typename] = ACTIONS(2276),
    [anon_sym_template] = ACTIONS(2276),
    [anon_sym_operator] = ACTIONS(2276),
    [anon_sym_try] = ACTIONS(2276),
    [anon_sym_delete] = ACTIONS(2276),
    [anon_sym_throw] = ACTIONS(2276),
    [anon_sym_namespace] = ACTIONS(2276),
    [anon_sym_static_assert] = ACTIONS(2276),
    [anon_sym_concept] = ACTIONS(2276),
    [anon_sym_co_return] = ACTIONS(2276),
    [anon_sym_co_yield] = ACTIONS(2276),
    [anon_sym_R_DQUOTE] = ACTIONS(2278),
    [anon_sym_LR_DQUOTE] = ACTIONS(2278),
    [anon_sym_uR_DQUOTE] = ACTIONS(2278),
    [anon_sym_UR_DQUOTE] = ACTIONS(2278),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2278),
    [anon_sym_co_await] = ACTIONS(2276),
    [anon_sym_new] = ACTIONS(2276),
    [anon_sym_requires] = ACTIONS(2276),
    [sym_this] = ACTIONS(2276),
    [anon_sym_discard] = ACTIONS(2276),
    [anon_sym_precise] = ACTIONS(2276),
    [anon_sym_shared] = ACTIONS(2276),
    [anon_sym_groupshared] = ACTIONS(2276),
    [anon_sym_uniform] = ACTIONS(2276),
    [anon_sym_row_major] = ACTIONS(2276),
    [anon_sym_column_major] = ACTIONS(2276),
    [anon_sym_globallycoherent] = ACTIONS(2276),
    [anon_sym_centroid] = ACTIONS(2276),
    [anon_sym_noperspective] = ACTIONS(2276),
    [anon_sym_nointerpolation] = ACTIONS(2276),
    [anon_sym_sample] = ACTIONS(2276),
    [anon_sym_linear] = ACTIONS(2276),
    [anon_sym_snorm] = ACTIONS(2276),
    [anon_sym_unorm] = ACTIONS(2276),
    [anon_sym_point] = ACTIONS(2276),
    [anon_sym_line] = ACTIONS(2276),
    [anon_sym_triangleadj] = ACTIONS(2276),
    [anon_sym_lineadj] = ACTIONS(2276),
    [anon_sym_triangle] = ACTIONS(2276),
    [anon_sym_cbuffer] = ACTIONS(2276),
    [anon_sym_interface] = ACTIONS(2276),
    [anon_sym_extension] = ACTIONS(2276),
  },
  [184] = {
    [sym_identifier] = ACTIONS(2292),
    [aux_sym_preproc_include_token1] = ACTIONS(2292),
    [aux_sym_preproc_def_token1] = ACTIONS(2292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2294),
    [anon_sym_COMMA] = ACTIONS(2294),
    [aux_sym_preproc_if_token1] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2292),
    [sym_preproc_directive] = ACTIONS(2292),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_BANG] = ACTIONS(2292),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_PERCENT] = ACTIONS(2294),
    [anon_sym_PIPE_PIPE] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_PIPE] = ACTIONS(2292),
    [anon_sym_CARET] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_EQ_EQ] = ACTIONS(2294),
    [anon_sym_BANG_EQ] = ACTIONS(2294),
    [anon_sym_GT] = ACTIONS(2292),
    [anon_sym_GT_EQ] = ACTIONS(2294),
    [anon_sym_LT_EQ] = ACTIONS(2292),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_LT_LT] = ACTIONS(2294),
    [anon_sym_GT_GT] = ACTIONS(2294),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym_typedef] = ACTIONS(2292),
    [anon_sym_in] = ACTIONS(2292),
    [anon_sym_out] = ACTIONS(2292),
    [anon_sym_inout] = ACTIONS(2292),
    [anon_sym_virtual] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym___attribute] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2294),
    [anon_sym___declspec] = ACTIONS(2292),
    [anon_sym___based] = ACTIONS(2292),
    [anon_sym___cdecl] = ACTIONS(2292),
    [anon_sym___clrcall] = ACTIONS(2292),
    [anon_sym___stdcall] = ACTIONS(2292),
    [anon_sym___fastcall] = ACTIONS(2292),
    [anon_sym___thiscall] = ACTIONS(2292),
    [anon_sym___vectorcall] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_signed] = ACTIONS(2292),
    [anon_sym_unsigned] = ACTIONS(2292),
    [anon_sym_long] = ACTIONS(2292),
    [anon_sym_short] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym___inline] = ACTIONS(2292),
    [anon_sym___inline__] = ACTIONS(2292),
    [anon_sym___forceinline] = ACTIONS(2292),
    [anon_sym_thread_local] = ACTIONS(2292),
    [anon_sym___thread] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym__Nonnull] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [sym_primitive_type] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_struct] = ACTIONS(2292),
    [anon_sym_union] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_case] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_goto] = ACTIONS(2292),
    [anon_sym___try] = ACTIONS(2292),
    [anon_sym___leave] = ACTIONS(2292),
    [anon_sym_QMARK] = ACTIONS(2294),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_compl] = ACTIONS(2292),
    [anon_sym_LT_EQ_GT] = ACTIONS(2294),
    [anon_sym_or] = ACTIONS(2292),
    [anon_sym_and] = ACTIONS(2292),
    [anon_sym_bitor] = ACTIONS(2292),
    [anon_sym_xor] = ACTIONS(2292),
    [anon_sym_bitand] = ACTIONS(2292),
    [anon_sym_not_eq] = ACTIONS(2292),
    [anon_sym_is] = ACTIONS(2292),
    [anon_sym_as] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_sizeof] = ACTIONS(2292),
    [anon_sym___alignof__] = ACTIONS(2292),
    [anon_sym___alignof] = ACTIONS(2292),
    [anon_sym__alignof] = ACTIONS(2292),
    [anon_sym_alignof] = ACTIONS(2292),
    [anon_sym__Alignof] = ACTIONS(2292),
    [anon_sym_offsetof] = ACTIONS(2292),
    [anon_sym__Generic] = ACTIONS(2292),
    [anon_sym_asm] = ACTIONS(2292),
    [anon_sym___asm__] = ACTIONS(2292),
    [anon_sym___asm] = ACTIONS(2292),
    [anon_sym_DOT] = ACTIONS(2292),
    [anon_sym_DOT_STAR] = ACTIONS(2294),
    [anon_sym_DASH_GT] = ACTIONS(2294),
    [sym_number_literal] = ACTIONS(2294),
    [anon_sym_L_SQUOTE] = ACTIONS(2294),
    [anon_sym_u_SQUOTE] = ACTIONS(2294),
    [anon_sym_U_SQUOTE] = ACTIONS(2294),
    [anon_sym_u8_SQUOTE] = ACTIONS(2294),
    [anon_sym_SQUOTE] = ACTIONS(2294),
    [anon_sym_L_DQUOTE] = ACTIONS(2294),
    [anon_sym_u_DQUOTE] = ACTIONS(2294),
    [anon_sym_U_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8_DQUOTE] = ACTIONS(2294),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [anon_sym_NULL] = ACTIONS(2292),
    [anon_sym_nullptr] = ACTIONS(2292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_This] = ACTIONS(2292),
    [anon_sym_decltype] = ACTIONS(2292),
    [anon_sym_explicit] = ACTIONS(2292),
    [anon_sym_typename] = ACTIONS(2292),
    [anon_sym_template] = ACTIONS(2292),
    [anon_sym_operator] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_static_assert] = ACTIONS(2292),
    [anon_sym_concept] = ACTIONS(2292),
    [anon_sym_co_return] = ACTIONS(2292),
    [anon_sym_co_yield] = ACTIONS(2292),
    [anon_sym_R_DQUOTE] = ACTIONS(2294),
    [anon_sym_LR_DQUOTE] = ACTIONS(2294),
    [anon_sym_uR_DQUOTE] = ACTIONS(2294),
    [anon_sym_UR_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2294),
    [anon_sym_co_await] = ACTIONS(2292),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_requires] = ACTIONS(2292),
    [sym_this] = ACTIONS(2292),
    [anon_sym_discard] = ACTIONS(2292),
    [anon_sym_precise] = ACTIONS(2292),
    [anon_sym_shared] = ACTIONS(2292),
    [anon_sym_groupshared] = ACTIONS(2292),
    [anon_sym_uniform] = ACTIONS(2292),
    [anon_sym_row_major] = ACTIONS(2292),
    [anon_sym_column_major] = ACTIONS(2292),
    [anon_sym_globallycoherent] = ACTIONS(2292),
    [anon_sym_centroid] = ACTIONS(2292),
    [anon_sym_noperspective] = ACTIONS(2292),
    [anon_sym_nointerpolation] = ACTIONS(2292),
    [anon_sym_sample] = ACTIONS(2292),
    [anon_sym_linear] = ACTIONS(2292),
    [anon_sym_snorm] = ACTIONS(2292),
    [anon_sym_unorm] = ACTIONS(2292),
    [anon_sym_point] = ACTIONS(2292),
    [anon_sym_line] = ACTIONS(2292),
    [anon_sym_triangleadj] = ACTIONS(2292),
    [anon_sym_lineadj] = ACTIONS(2292),
    [anon_sym_triangle] = ACTIONS(2292),
    [anon_sym_cbuffer] = ACTIONS(2292),
    [anon_sym_interface] = ACTIONS(2292),
    [anon_sym_extension] = ACTIONS(2292),
  },
  [185] = {
    [sym_identifier] = ACTIONS(2296),
    [aux_sym_preproc_include_token1] = ACTIONS(2296),
    [aux_sym_preproc_def_token1] = ACTIONS(2296),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2298),
    [anon_sym_COMMA] = ACTIONS(2298),
    [aux_sym_preproc_if_token1] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2296),
    [sym_preproc_directive] = ACTIONS(2296),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2298),
    [anon_sym_SLASH] = ACTIONS(2296),
    [anon_sym_PERCENT] = ACTIONS(2298),
    [anon_sym_PIPE_PIPE] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_PIPE] = ACTIONS(2296),
    [anon_sym_CARET] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_EQ_EQ] = ACTIONS(2298),
    [anon_sym_BANG_EQ] = ACTIONS(2298),
    [anon_sym_GT] = ACTIONS(2296),
    [anon_sym_GT_EQ] = ACTIONS(2298),
    [anon_sym_LT_EQ] = ACTIONS(2296),
    [anon_sym_LT] = ACTIONS(2296),
    [anon_sym_LT_LT] = ACTIONS(2298),
    [anon_sym_GT_GT] = ACTIONS(2298),
    [anon_sym_SEMI] = ACTIONS(2298),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym_typedef] = ACTIONS(2296),
    [anon_sym_in] = ACTIONS(2296),
    [anon_sym_out] = ACTIONS(2296),
    [anon_sym_inout] = ACTIONS(2296),
    [anon_sym_virtual] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym___attribute] = ACTIONS(2296),
    [anon_sym_using] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2298),
    [anon_sym___declspec] = ACTIONS(2296),
    [anon_sym___based] = ACTIONS(2296),
    [anon_sym___cdecl] = ACTIONS(2296),
    [anon_sym___clrcall] = ACTIONS(2296),
    [anon_sym___stdcall] = ACTIONS(2296),
    [anon_sym___fastcall] = ACTIONS(2296),
    [anon_sym___thiscall] = ACTIONS(2296),
    [anon_sym___vectorcall] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_RBRACE] = ACTIONS(2298),
    [anon_sym_signed] = ACTIONS(2296),
    [anon_sym_unsigned] = ACTIONS(2296),
    [anon_sym_long] = ACTIONS(2296),
    [anon_sym_short] = ACTIONS(2296),
    [anon_sym_LBRACK] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_register] = ACTIONS(2296),
    [anon_sym_inline] = ACTIONS(2296),
    [anon_sym___inline] = ACTIONS(2296),
    [anon_sym___inline__] = ACTIONS(2296),
    [anon_sym___forceinline] = ACTIONS(2296),
    [anon_sym_thread_local] = ACTIONS(2296),
    [anon_sym___thread] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym__Nonnull] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [sym_primitive_type] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2296),
    [anon_sym_class] = ACTIONS(2296),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_union] = ACTIONS(2296),
    [anon_sym_if] = ACTIONS(2296),
    [anon_sym_switch] = ACTIONS(2296),
    [anon_sym_case] = ACTIONS(2296),
    [anon_sym_default] = ACTIONS(2296),
    [anon_sym_while] = ACTIONS(2296),
    [anon_sym_do] = ACTIONS(2296),
    [anon_sym_for] = ACTIONS(2296),
    [anon_sym_return] = ACTIONS(2296),
    [anon_sym_break] = ACTIONS(2296),
    [anon_sym_continue] = ACTIONS(2296),
    [anon_sym_goto] = ACTIONS(2296),
    [anon_sym___try] = ACTIONS(2296),
    [anon_sym___leave] = ACTIONS(2296),
    [anon_sym_QMARK] = ACTIONS(2298),
    [anon_sym_not] = ACTIONS(2296),
    [anon_sym_compl] = ACTIONS(2296),
    [anon_sym_LT_EQ_GT] = ACTIONS(2298),
    [anon_sym_or] = ACTIONS(2296),
    [anon_sym_and] = ACTIONS(2296),
    [anon_sym_bitor] = ACTIONS(2296),
    [anon_sym_xor] = ACTIONS(2296),
    [anon_sym_bitand] = ACTIONS(2296),
    [anon_sym_not_eq] = ACTIONS(2296),
    [anon_sym_is] = ACTIONS(2296),
    [anon_sym_as] = ACTIONS(2296),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_sizeof] = ACTIONS(2296),
    [anon_sym___alignof__] = ACTIONS(2296),
    [anon_sym___alignof] = ACTIONS(2296),
    [anon_sym__alignof] = ACTIONS(2296),
    [anon_sym_alignof] = ACTIONS(2296),
    [anon_sym__Alignof] = ACTIONS(2296),
    [anon_sym_offsetof] = ACTIONS(2296),
    [anon_sym__Generic] = ACTIONS(2296),
    [anon_sym_asm] = ACTIONS(2296),
    [anon_sym___asm__] = ACTIONS(2296),
    [anon_sym___asm] = ACTIONS(2296),
    [anon_sym_DOT] = ACTIONS(2296),
    [anon_sym_DOT_STAR] = ACTIONS(2298),
    [anon_sym_DASH_GT] = ACTIONS(2298),
    [sym_number_literal] = ACTIONS(2298),
    [anon_sym_L_SQUOTE] = ACTIONS(2298),
    [anon_sym_u_SQUOTE] = ACTIONS(2298),
    [anon_sym_U_SQUOTE] = ACTIONS(2298),
    [anon_sym_u8_SQUOTE] = ACTIONS(2298),
    [anon_sym_SQUOTE] = ACTIONS(2298),
    [anon_sym_L_DQUOTE] = ACTIONS(2298),
    [anon_sym_u_DQUOTE] = ACTIONS(2298),
    [anon_sym_U_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8_DQUOTE] = ACTIONS(2298),
    [anon_sym_DQUOTE] = ACTIONS(2298),
    [sym_true] = ACTIONS(2296),
    [sym_false] = ACTIONS(2296),
    [anon_sym_NULL] = ACTIONS(2296),
    [anon_sym_nullptr] = ACTIONS(2296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_This] = ACTIONS(2296),
    [anon_sym_decltype] = ACTIONS(2296),
    [anon_sym_explicit] = ACTIONS(2296),
    [anon_sym_typename] = ACTIONS(2296),
    [anon_sym_template] = ACTIONS(2296),
    [anon_sym_operator] = ACTIONS(2296),
    [anon_sym_try] = ACTIONS(2296),
    [anon_sym_delete] = ACTIONS(2296),
    [anon_sym_throw] = ACTIONS(2296),
    [anon_sym_namespace] = ACTIONS(2296),
    [anon_sym_static_assert] = ACTIONS(2296),
    [anon_sym_concept] = ACTIONS(2296),
    [anon_sym_co_return] = ACTIONS(2296),
    [anon_sym_co_yield] = ACTIONS(2296),
    [anon_sym_R_DQUOTE] = ACTIONS(2298),
    [anon_sym_LR_DQUOTE] = ACTIONS(2298),
    [anon_sym_uR_DQUOTE] = ACTIONS(2298),
    [anon_sym_UR_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2298),
    [anon_sym_co_await] = ACTIONS(2296),
    [anon_sym_new] = ACTIONS(2296),
    [anon_sym_requires] = ACTIONS(2296),
    [sym_this] = ACTIONS(2296),
    [anon_sym_discard] = ACTIONS(2296),
    [anon_sym_precise] = ACTIONS(2296),
    [anon_sym_shared] = ACTIONS(2296),
    [anon_sym_groupshared] = ACTIONS(2296),
    [anon_sym_uniform] = ACTIONS(2296),
    [anon_sym_row_major] = ACTIONS(2296),
    [anon_sym_column_major] = ACTIONS(2296),
    [anon_sym_globallycoherent] = ACTIONS(2296),
    [anon_sym_centroid] = ACTIONS(2296),
    [anon_sym_noperspective] = ACTIONS(2296),
    [anon_sym_nointerpolation] = ACTIONS(2296),
    [anon_sym_sample] = ACTIONS(2296),
    [anon_sym_linear] = ACTIONS(2296),
    [anon_sym_snorm] = ACTIONS(2296),
    [anon_sym_unorm] = ACTIONS(2296),
    [anon_sym_point] = ACTIONS(2296),
    [anon_sym_line] = ACTIONS(2296),
    [anon_sym_triangleadj] = ACTIONS(2296),
    [anon_sym_lineadj] = ACTIONS(2296),
    [anon_sym_triangle] = ACTIONS(2296),
    [anon_sym_cbuffer] = ACTIONS(2296),
    [anon_sym_interface] = ACTIONS(2296),
    [anon_sym_extension] = ACTIONS(2296),
  },
  [186] = {
    [sym_identifier] = ACTIONS(2264),
    [aux_sym_preproc_include_token1] = ACTIONS(2264),
    [aux_sym_preproc_def_token1] = ACTIONS(2264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2266),
    [anon_sym_COMMA] = ACTIONS(2266),
    [aux_sym_preproc_if_token1] = ACTIONS(2264),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2264),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2264),
    [sym_preproc_directive] = ACTIONS(2264),
    [anon_sym_LPAREN2] = ACTIONS(2266),
    [anon_sym_BANG] = ACTIONS(2264),
    [anon_sym_TILDE] = ACTIONS(2266),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2266),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_PERCENT] = ACTIONS(2266),
    [anon_sym_PIPE_PIPE] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2266),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_CARET] = ACTIONS(2266),
    [anon_sym_AMP] = ACTIONS(2264),
    [anon_sym_EQ_EQ] = ACTIONS(2266),
    [anon_sym_BANG_EQ] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(2264),
    [anon_sym_GT_EQ] = ACTIONS(2266),
    [anon_sym_LT_EQ] = ACTIONS(2264),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_LT_LT] = ACTIONS(2266),
    [anon_sym_GT_GT] = ACTIONS(2266),
    [anon_sym_SEMI] = ACTIONS(2266),
    [anon_sym___extension__] = ACTIONS(2264),
    [anon_sym_typedef] = ACTIONS(2264),
    [anon_sym_in] = ACTIONS(2264),
    [anon_sym_out] = ACTIONS(2264),
    [anon_sym_inout] = ACTIONS(2264),
    [anon_sym_virtual] = ACTIONS(2264),
    [anon_sym_extern] = ACTIONS(2264),
    [anon_sym___attribute__] = ACTIONS(2264),
    [anon_sym___attribute] = ACTIONS(2264),
    [anon_sym_using] = ACTIONS(2264),
    [anon_sym_COLON_COLON] = ACTIONS(2266),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2266),
    [anon_sym___declspec] = ACTIONS(2264),
    [anon_sym___based] = ACTIONS(2264),
    [anon_sym___cdecl] = ACTIONS(2264),
    [anon_sym___clrcall] = ACTIONS(2264),
    [anon_sym___stdcall] = ACTIONS(2264),
    [anon_sym___fastcall] = ACTIONS(2264),
    [anon_sym___thiscall] = ACTIONS(2264),
    [anon_sym___vectorcall] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_RBRACE] = ACTIONS(2266),
    [anon_sym_signed] = ACTIONS(2264),
    [anon_sym_unsigned] = ACTIONS(2264),
    [anon_sym_long] = ACTIONS(2264),
    [anon_sym_short] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_register] = ACTIONS(2264),
    [anon_sym_inline] = ACTIONS(2264),
    [anon_sym___inline] = ACTIONS(2264),
    [anon_sym___inline__] = ACTIONS(2264),
    [anon_sym___forceinline] = ACTIONS(2264),
    [anon_sym_thread_local] = ACTIONS(2264),
    [anon_sym___thread] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_constexpr] = ACTIONS(2264),
    [anon_sym_volatile] = ACTIONS(2264),
    [anon_sym_restrict] = ACTIONS(2264),
    [anon_sym___restrict__] = ACTIONS(2264),
    [anon_sym__Atomic] = ACTIONS(2264),
    [anon_sym__Noreturn] = ACTIONS(2264),
    [anon_sym_noreturn] = ACTIONS(2264),
    [anon_sym__Nonnull] = ACTIONS(2264),
    [anon_sym_mutable] = ACTIONS(2264),
    [anon_sym_constinit] = ACTIONS(2264),
    [anon_sym_consteval] = ACTIONS(2264),
    [anon_sym_alignas] = ACTIONS(2264),
    [anon_sym__Alignas] = ACTIONS(2264),
    [sym_primitive_type] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
    [anon_sym_class] = ACTIONS(2264),
    [anon_sym_struct] = ACTIONS(2264),
    [anon_sym_union] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_switch] = ACTIONS(2264),
    [anon_sym_case] = ACTIONS(2264),
    [anon_sym_default] = ACTIONS(2264),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_do] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_goto] = ACTIONS(2264),
    [anon_sym___try] = ACTIONS(2264),
    [anon_sym___leave] = ACTIONS(2264),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_not] = ACTIONS(2264),
    [anon_sym_compl] = ACTIONS(2264),
    [anon_sym_LT_EQ_GT] = ACTIONS(2266),
    [anon_sym_or] = ACTIONS(2264),
    [anon_sym_and] = ACTIONS(2264),
    [anon_sym_bitor] = ACTIONS(2264),
    [anon_sym_xor] = ACTIONS(2264),
    [anon_sym_bitand] = ACTIONS(2264),
    [anon_sym_not_eq] = ACTIONS(2264),
    [anon_sym_is] = ACTIONS(2264),
    [anon_sym_as] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2266),
    [anon_sym_PLUS_PLUS] = ACTIONS(2266),
    [anon_sym_sizeof] = ACTIONS(2264),
    [anon_sym___alignof__] = ACTIONS(2264),
    [anon_sym___alignof] = ACTIONS(2264),
    [anon_sym__alignof] = ACTIONS(2264),
    [anon_sym_alignof] = ACTIONS(2264),
    [anon_sym__Alignof] = ACTIONS(2264),
    [anon_sym_offsetof] = ACTIONS(2264),
    [anon_sym__Generic] = ACTIONS(2264),
    [anon_sym_asm] = ACTIONS(2264),
    [anon_sym___asm__] = ACTIONS(2264),
    [anon_sym___asm] = ACTIONS(2264),
    [anon_sym_DOT] = ACTIONS(2264),
    [anon_sym_DOT_STAR] = ACTIONS(2266),
    [anon_sym_DASH_GT] = ACTIONS(2266),
    [sym_number_literal] = ACTIONS(2266),
    [anon_sym_L_SQUOTE] = ACTIONS(2266),
    [anon_sym_u_SQUOTE] = ACTIONS(2266),
    [anon_sym_U_SQUOTE] = ACTIONS(2266),
    [anon_sym_u8_SQUOTE] = ACTIONS(2266),
    [anon_sym_SQUOTE] = ACTIONS(2266),
    [anon_sym_L_DQUOTE] = ACTIONS(2266),
    [anon_sym_u_DQUOTE] = ACTIONS(2266),
    [anon_sym_U_DQUOTE] = ACTIONS(2266),
    [anon_sym_u8_DQUOTE] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(2266),
    [sym_true] = ACTIONS(2264),
    [sym_false] = ACTIONS(2264),
    [anon_sym_NULL] = ACTIONS(2264),
    [anon_sym_nullptr] = ACTIONS(2264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_This] = ACTIONS(2264),
    [anon_sym_decltype] = ACTIONS(2264),
    [anon_sym_explicit] = ACTIONS(2264),
    [anon_sym_typename] = ACTIONS(2264),
    [anon_sym_template] = ACTIONS(2264),
    [anon_sym_operator] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [anon_sym_delete] = ACTIONS(2264),
    [anon_sym_throw] = ACTIONS(2264),
    [anon_sym_namespace] = ACTIONS(2264),
    [anon_sym_static_assert] = ACTIONS(2264),
    [anon_sym_concept] = ACTIONS(2264),
    [anon_sym_co_return] = ACTIONS(2264),
    [anon_sym_co_yield] = ACTIONS(2264),
    [anon_sym_R_DQUOTE] = ACTIONS(2266),
    [anon_sym_LR_DQUOTE] = ACTIONS(2266),
    [anon_sym_uR_DQUOTE] = ACTIONS(2266),
    [anon_sym_UR_DQUOTE] = ACTIONS(2266),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2266),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2264),
    [anon_sym_requires] = ACTIONS(2264),
    [sym_this] = ACTIONS(2264),
    [anon_sym_discard] = ACTIONS(2264),
    [anon_sym_precise] = ACTIONS(2264),
    [anon_sym_shared] = ACTIONS(2264),
    [anon_sym_groupshared] = ACTIONS(2264),
    [anon_sym_uniform] = ACTIONS(2264),
    [anon_sym_row_major] = ACTIONS(2264),
    [anon_sym_column_major] = ACTIONS(2264),
    [anon_sym_globallycoherent] = ACTIONS(2264),
    [anon_sym_centroid] = ACTIONS(2264),
    [anon_sym_noperspective] = ACTIONS(2264),
    [anon_sym_nointerpolation] = ACTIONS(2264),
    [anon_sym_sample] = ACTIONS(2264),
    [anon_sym_linear] = ACTIONS(2264),
    [anon_sym_snorm] = ACTIONS(2264),
    [anon_sym_unorm] = ACTIONS(2264),
    [anon_sym_point] = ACTIONS(2264),
    [anon_sym_line] = ACTIONS(2264),
    [anon_sym_triangleadj] = ACTIONS(2264),
    [anon_sym_lineadj] = ACTIONS(2264),
    [anon_sym_triangle] = ACTIONS(2264),
    [anon_sym_cbuffer] = ACTIONS(2264),
    [anon_sym_interface] = ACTIONS(2264),
    [anon_sym_extension] = ACTIONS(2264),
  },
  [187] = {
    [sym_identifier] = ACTIONS(2300),
    [aux_sym_preproc_include_token1] = ACTIONS(2300),
    [aux_sym_preproc_def_token1] = ACTIONS(2300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2302),
    [anon_sym_COMMA] = ACTIONS(2302),
    [aux_sym_preproc_if_token1] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2300),
    [sym_preproc_directive] = ACTIONS(2300),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_BANG] = ACTIONS(2300),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2302),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2302),
    [anon_sym_PIPE_PIPE] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_PIPE] = ACTIONS(2300),
    [anon_sym_CARET] = ACTIONS(2302),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_EQ_EQ] = ACTIONS(2302),
    [anon_sym_BANG_EQ] = ACTIONS(2302),
    [anon_sym_GT] = ACTIONS(2300),
    [anon_sym_GT_EQ] = ACTIONS(2302),
    [anon_sym_LT_EQ] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_LT_LT] = ACTIONS(2302),
    [anon_sym_GT_GT] = ACTIONS(2302),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym_typedef] = ACTIONS(2300),
    [anon_sym_in] = ACTIONS(2300),
    [anon_sym_out] = ACTIONS(2300),
    [anon_sym_inout] = ACTIONS(2300),
    [anon_sym_virtual] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym___attribute] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2302),
    [anon_sym___declspec] = ACTIONS(2300),
    [anon_sym___based] = ACTIONS(2300),
    [anon_sym___cdecl] = ACTIONS(2300),
    [anon_sym___clrcall] = ACTIONS(2300),
    [anon_sym___stdcall] = ACTIONS(2300),
    [anon_sym___fastcall] = ACTIONS(2300),
    [anon_sym___thiscall] = ACTIONS(2300),
    [anon_sym___vectorcall] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_RBRACE] = ACTIONS(2302),
    [anon_sym_signed] = ACTIONS(2300),
    [anon_sym_unsigned] = ACTIONS(2300),
    [anon_sym_long] = ACTIONS(2300),
    [anon_sym_short] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_register] = ACTIONS(2300),
    [anon_sym_inline] = ACTIONS(2300),
    [anon_sym___inline] = ACTIONS(2300),
    [anon_sym___inline__] = ACTIONS(2300),
    [anon_sym___forceinline] = ACTIONS(2300),
    [anon_sym_thread_local] = ACTIONS(2300),
    [anon_sym___thread] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym__Nonnull] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [sym_primitive_type] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_struct] = ACTIONS(2300),
    [anon_sym_union] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_case] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_goto] = ACTIONS(2300),
    [anon_sym___try] = ACTIONS(2300),
    [anon_sym___leave] = ACTIONS(2300),
    [anon_sym_QMARK] = ACTIONS(2302),
    [anon_sym_not] = ACTIONS(2300),
    [anon_sym_compl] = ACTIONS(2300),
    [anon_sym_LT_EQ_GT] = ACTIONS(2302),
    [anon_sym_or] = ACTIONS(2300),
    [anon_sym_and] = ACTIONS(2300),
    [anon_sym_bitor] = ACTIONS(2300),
    [anon_sym_xor] = ACTIONS(2300),
    [anon_sym_bitand] = ACTIONS(2300),
    [anon_sym_not_eq] = ACTIONS(2300),
    [anon_sym_is] = ACTIONS(2300),
    [anon_sym_as] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_sizeof] = ACTIONS(2300),
    [anon_sym___alignof__] = ACTIONS(2300),
    [anon_sym___alignof] = ACTIONS(2300),
    [anon_sym__alignof] = ACTIONS(2300),
    [anon_sym_alignof] = ACTIONS(2300),
    [anon_sym__Alignof] = ACTIONS(2300),
    [anon_sym_offsetof] = ACTIONS(2300),
    [anon_sym__Generic] = ACTIONS(2300),
    [anon_sym_asm] = ACTIONS(2300),
    [anon_sym___asm__] = ACTIONS(2300),
    [anon_sym___asm] = ACTIONS(2300),
    [anon_sym_DOT] = ACTIONS(2300),
    [anon_sym_DOT_STAR] = ACTIONS(2302),
    [anon_sym_DASH_GT] = ACTIONS(2302),
    [sym_number_literal] = ACTIONS(2302),
    [anon_sym_L_SQUOTE] = ACTIONS(2302),
    [anon_sym_u_SQUOTE] = ACTIONS(2302),
    [anon_sym_U_SQUOTE] = ACTIONS(2302),
    [anon_sym_u8_SQUOTE] = ACTIONS(2302),
    [anon_sym_SQUOTE] = ACTIONS(2302),
    [anon_sym_L_DQUOTE] = ACTIONS(2302),
    [anon_sym_u_DQUOTE] = ACTIONS(2302),
    [anon_sym_U_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8_DQUOTE] = ACTIONS(2302),
    [anon_sym_DQUOTE] = ACTIONS(2302),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [anon_sym_NULL] = ACTIONS(2300),
    [anon_sym_nullptr] = ACTIONS(2300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_This] = ACTIONS(2300),
    [anon_sym_decltype] = ACTIONS(2300),
    [anon_sym_explicit] = ACTIONS(2300),
    [anon_sym_typename] = ACTIONS(2300),
    [anon_sym_template] = ACTIONS(2300),
    [anon_sym_operator] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_static_assert] = ACTIONS(2300),
    [anon_sym_concept] = ACTIONS(2300),
    [anon_sym_co_return] = ACTIONS(2300),
    [anon_sym_co_yield] = ACTIONS(2300),
    [anon_sym_R_DQUOTE] = ACTIONS(2302),
    [anon_sym_LR_DQUOTE] = ACTIONS(2302),
    [anon_sym_uR_DQUOTE] = ACTIONS(2302),
    [anon_sym_UR_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2302),
    [anon_sym_co_await] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_requires] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [anon_sym_discard] = ACTIONS(2300),
    [anon_sym_precise] = ACTIONS(2300),
    [anon_sym_shared] = ACTIONS(2300),
    [anon_sym_groupshared] = ACTIONS(2300),
    [anon_sym_uniform] = ACTIONS(2300),
    [anon_sym_row_major] = ACTIONS(2300),
    [anon_sym_column_major] = ACTIONS(2300),
    [anon_sym_globallycoherent] = ACTIONS(2300),
    [anon_sym_centroid] = ACTIONS(2300),
    [anon_sym_noperspective] = ACTIONS(2300),
    [anon_sym_nointerpolation] = ACTIONS(2300),
    [anon_sym_sample] = ACTIONS(2300),
    [anon_sym_linear] = ACTIONS(2300),
    [anon_sym_snorm] = ACTIONS(2300),
    [anon_sym_unorm] = ACTIONS(2300),
    [anon_sym_point] = ACTIONS(2300),
    [anon_sym_line] = ACTIONS(2300),
    [anon_sym_triangleadj] = ACTIONS(2300),
    [anon_sym_lineadj] = ACTIONS(2300),
    [anon_sym_triangle] = ACTIONS(2300),
    [anon_sym_cbuffer] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_extension] = ACTIONS(2300),
  },
  [188] = {
    [sym_identifier] = ACTIONS(2260),
    [aux_sym_preproc_include_token1] = ACTIONS(2260),
    [aux_sym_preproc_def_token1] = ACTIONS(2260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_COMMA] = ACTIONS(2262),
    [aux_sym_preproc_if_token1] = ACTIONS(2260),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2260),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2260),
    [sym_preproc_directive] = ACTIONS(2260),
    [anon_sym_LPAREN2] = ACTIONS(2262),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2262),
    [anon_sym_SLASH] = ACTIONS(2260),
    [anon_sym_PERCENT] = ACTIONS(2262),
    [anon_sym_PIPE_PIPE] = ACTIONS(2262),
    [anon_sym_AMP_AMP] = ACTIONS(2262),
    [anon_sym_PIPE] = ACTIONS(2260),
    [anon_sym_CARET] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_EQ_EQ] = ACTIONS(2262),
    [anon_sym_BANG_EQ] = ACTIONS(2262),
    [anon_sym_GT] = ACTIONS(2260),
    [anon_sym_GT_EQ] = ACTIONS(2262),
    [anon_sym_LT_EQ] = ACTIONS(2260),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_LT_LT] = ACTIONS(2262),
    [anon_sym_GT_GT] = ACTIONS(2262),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym___extension__] = ACTIONS(2260),
    [anon_sym_typedef] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(2260),
    [anon_sym_out] = ACTIONS(2260),
    [anon_sym_inout] = ACTIONS(2260),
    [anon_sym_virtual] = ACTIONS(2260),
    [anon_sym_extern] = ACTIONS(2260),
    [anon_sym___attribute__] = ACTIONS(2260),
    [anon_sym___attribute] = ACTIONS(2260),
    [anon_sym_using] = ACTIONS(2260),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2262),
    [anon_sym___declspec] = ACTIONS(2260),
    [anon_sym___based] = ACTIONS(2260),
    [anon_sym___cdecl] = ACTIONS(2260),
    [anon_sym___clrcall] = ACTIONS(2260),
    [anon_sym___stdcall] = ACTIONS(2260),
    [anon_sym___fastcall] = ACTIONS(2260),
    [anon_sym___thiscall] = ACTIONS(2260),
    [anon_sym___vectorcall] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_RBRACE] = ACTIONS(2262),
    [anon_sym_signed] = ACTIONS(2260),
    [anon_sym_unsigned] = ACTIONS(2260),
    [anon_sym_long] = ACTIONS(2260),
    [anon_sym_short] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_register] = ACTIONS(2260),
    [anon_sym_inline] = ACTIONS(2260),
    [anon_sym___inline] = ACTIONS(2260),
    [anon_sym___inline__] = ACTIONS(2260),
    [anon_sym___forceinline] = ACTIONS(2260),
    [anon_sym_thread_local] = ACTIONS(2260),
    [anon_sym___thread] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_constexpr] = ACTIONS(2260),
    [anon_sym_volatile] = ACTIONS(2260),
    [anon_sym_restrict] = ACTIONS(2260),
    [anon_sym___restrict__] = ACTIONS(2260),
    [anon_sym__Atomic] = ACTIONS(2260),
    [anon_sym__Noreturn] = ACTIONS(2260),
    [anon_sym_noreturn] = ACTIONS(2260),
    [anon_sym__Nonnull] = ACTIONS(2260),
    [anon_sym_mutable] = ACTIONS(2260),
    [anon_sym_constinit] = ACTIONS(2260),
    [anon_sym_consteval] = ACTIONS(2260),
    [anon_sym_alignas] = ACTIONS(2260),
    [anon_sym__Alignas] = ACTIONS(2260),
    [sym_primitive_type] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
    [anon_sym_class] = ACTIONS(2260),
    [anon_sym_struct] = ACTIONS(2260),
    [anon_sym_union] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_switch] = ACTIONS(2260),
    [anon_sym_case] = ACTIONS(2260),
    [anon_sym_default] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_do] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_goto] = ACTIONS(2260),
    [anon_sym___try] = ACTIONS(2260),
    [anon_sym___leave] = ACTIONS(2260),
    [anon_sym_QMARK] = ACTIONS(2262),
    [anon_sym_not] = ACTIONS(2260),
    [anon_sym_compl] = ACTIONS(2260),
    [anon_sym_LT_EQ_GT] = ACTIONS(2262),
    [anon_sym_or] = ACTIONS(2260),
    [anon_sym_and] = ACTIONS(2260),
    [anon_sym_bitor] = ACTIONS(2260),
    [anon_sym_xor] = ACTIONS(2260),
    [anon_sym_bitand] = ACTIONS(2260),
    [anon_sym_not_eq] = ACTIONS(2260),
    [anon_sym_is] = ACTIONS(2260),
    [anon_sym_as] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_sizeof] = ACTIONS(2260),
    [anon_sym___alignof__] = ACTIONS(2260),
    [anon_sym___alignof] = ACTIONS(2260),
    [anon_sym__alignof] = ACTIONS(2260),
    [anon_sym_alignof] = ACTIONS(2260),
    [anon_sym__Alignof] = ACTIONS(2260),
    [anon_sym_offsetof] = ACTIONS(2260),
    [anon_sym__Generic] = ACTIONS(2260),
    [anon_sym_asm] = ACTIONS(2260),
    [anon_sym___asm__] = ACTIONS(2260),
    [anon_sym___asm] = ACTIONS(2260),
    [anon_sym_DOT] = ACTIONS(2260),
    [anon_sym_DOT_STAR] = ACTIONS(2262),
    [anon_sym_DASH_GT] = ACTIONS(2262),
    [sym_number_literal] = ACTIONS(2262),
    [anon_sym_L_SQUOTE] = ACTIONS(2262),
    [anon_sym_u_SQUOTE] = ACTIONS(2262),
    [anon_sym_U_SQUOTE] = ACTIONS(2262),
    [anon_sym_u8_SQUOTE] = ACTIONS(2262),
    [anon_sym_SQUOTE] = ACTIONS(2262),
    [anon_sym_L_DQUOTE] = ACTIONS(2262),
    [anon_sym_u_DQUOTE] = ACTIONS(2262),
    [anon_sym_U_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8_DQUOTE] = ACTIONS(2262),
    [anon_sym_DQUOTE] = ACTIONS(2262),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [anon_sym_NULL] = ACTIONS(2260),
    [anon_sym_nullptr] = ACTIONS(2260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_This] = ACTIONS(2260),
    [anon_sym_decltype] = ACTIONS(2260),
    [anon_sym_explicit] = ACTIONS(2260),
    [anon_sym_typename] = ACTIONS(2260),
    [anon_sym_template] = ACTIONS(2260),
    [anon_sym_operator] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_throw] = ACTIONS(2260),
    [anon_sym_namespace] = ACTIONS(2260),
    [anon_sym_static_assert] = ACTIONS(2260),
    [anon_sym_concept] = ACTIONS(2260),
    [anon_sym_co_return] = ACTIONS(2260),
    [anon_sym_co_yield] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2260),
    [anon_sym_new] = ACTIONS(2260),
    [anon_sym_requires] = ACTIONS(2260),
    [sym_this] = ACTIONS(2260),
    [anon_sym_discard] = ACTIONS(2260),
    [anon_sym_precise] = ACTIONS(2260),
    [anon_sym_shared] = ACTIONS(2260),
    [anon_sym_groupshared] = ACTIONS(2260),
    [anon_sym_uniform] = ACTIONS(2260),
    [anon_sym_row_major] = ACTIONS(2260),
    [anon_sym_column_major] = ACTIONS(2260),
    [anon_sym_globallycoherent] = ACTIONS(2260),
    [anon_sym_centroid] = ACTIONS(2260),
    [anon_sym_noperspective] = ACTIONS(2260),
    [anon_sym_nointerpolation] = ACTIONS(2260),
    [anon_sym_sample] = ACTIONS(2260),
    [anon_sym_linear] = ACTIONS(2260),
    [anon_sym_snorm] = ACTIONS(2260),
    [anon_sym_unorm] = ACTIONS(2260),
    [anon_sym_point] = ACTIONS(2260),
    [anon_sym_line] = ACTIONS(2260),
    [anon_sym_triangleadj] = ACTIONS(2260),
    [anon_sym_lineadj] = ACTIONS(2260),
    [anon_sym_triangle] = ACTIONS(2260),
    [anon_sym_cbuffer] = ACTIONS(2260),
    [anon_sym_interface] = ACTIONS(2260),
    [anon_sym_extension] = ACTIONS(2260),
  },
  [189] = {
    [sym_identifier] = ACTIONS(2304),
    [aux_sym_preproc_include_token1] = ACTIONS(2304),
    [aux_sym_preproc_def_token1] = ACTIONS(2304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_COMMA] = ACTIONS(2306),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2304),
    [sym_preproc_directive] = ACTIONS(2304),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_BANG] = ACTIONS(2304),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_PERCENT] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE] = ACTIONS(2304),
    [anon_sym_CARET] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_GT] = ACTIONS(2304),
    [anon_sym_GT_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_LT_LT] = ACTIONS(2306),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2306),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym_typedef] = ACTIONS(2304),
    [anon_sym_in] = ACTIONS(2304),
    [anon_sym_out] = ACTIONS(2304),
    [anon_sym_inout] = ACTIONS(2304),
    [anon_sym_virtual] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym___attribute] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2306),
    [anon_sym___declspec] = ACTIONS(2304),
    [anon_sym___based] = ACTIONS(2304),
    [anon_sym___cdecl] = ACTIONS(2304),
    [anon_sym___clrcall] = ACTIONS(2304),
    [anon_sym___stdcall] = ACTIONS(2304),
    [anon_sym___fastcall] = ACTIONS(2304),
    [anon_sym___thiscall] = ACTIONS(2304),
    [anon_sym___vectorcall] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_signed] = ACTIONS(2304),
    [anon_sym_unsigned] = ACTIONS(2304),
    [anon_sym_long] = ACTIONS(2304),
    [anon_sym_short] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_register] = ACTIONS(2304),
    [anon_sym_inline] = ACTIONS(2304),
    [anon_sym___inline] = ACTIONS(2304),
    [anon_sym___inline__] = ACTIONS(2304),
    [anon_sym___forceinline] = ACTIONS(2304),
    [anon_sym_thread_local] = ACTIONS(2304),
    [anon_sym___thread] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym__Nonnull] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [sym_primitive_type] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_struct] = ACTIONS(2304),
    [anon_sym_union] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_case] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_goto] = ACTIONS(2304),
    [anon_sym___try] = ACTIONS(2304),
    [anon_sym___leave] = ACTIONS(2304),
    [anon_sym_QMARK] = ACTIONS(2306),
    [anon_sym_not] = ACTIONS(2304),
    [anon_sym_compl] = ACTIONS(2304),
    [anon_sym_LT_EQ_GT] = ACTIONS(2306),
    [anon_sym_or] = ACTIONS(2304),
    [anon_sym_and] = ACTIONS(2304),
    [anon_sym_bitor] = ACTIONS(2304),
    [anon_sym_xor] = ACTIONS(2304),
    [anon_sym_bitand] = ACTIONS(2304),
    [anon_sym_not_eq] = ACTIONS(2304),
    [anon_sym_is] = ACTIONS(2304),
    [anon_sym_as] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_sizeof] = ACTIONS(2304),
    [anon_sym___alignof__] = ACTIONS(2304),
    [anon_sym___alignof] = ACTIONS(2304),
    [anon_sym__alignof] = ACTIONS(2304),
    [anon_sym_alignof] = ACTIONS(2304),
    [anon_sym__Alignof] = ACTIONS(2304),
    [anon_sym_offsetof] = ACTIONS(2304),
    [anon_sym__Generic] = ACTIONS(2304),
    [anon_sym_asm] = ACTIONS(2304),
    [anon_sym___asm__] = ACTIONS(2304),
    [anon_sym___asm] = ACTIONS(2304),
    [anon_sym_DOT] = ACTIONS(2304),
    [anon_sym_DOT_STAR] = ACTIONS(2306),
    [anon_sym_DASH_GT] = ACTIONS(2306),
    [sym_number_literal] = ACTIONS(2306),
    [anon_sym_L_SQUOTE] = ACTIONS(2306),
    [anon_sym_u_SQUOTE] = ACTIONS(2306),
    [anon_sym_U_SQUOTE] = ACTIONS(2306),
    [anon_sym_u8_SQUOTE] = ACTIONS(2306),
    [anon_sym_SQUOTE] = ACTIONS(2306),
    [anon_sym_L_DQUOTE] = ACTIONS(2306),
    [anon_sym_u_DQUOTE] = ACTIONS(2306),
    [anon_sym_U_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8_DQUOTE] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [anon_sym_NULL] = ACTIONS(2304),
    [anon_sym_nullptr] = ACTIONS(2304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_This] = ACTIONS(2304),
    [anon_sym_decltype] = ACTIONS(2304),
    [anon_sym_explicit] = ACTIONS(2304),
    [anon_sym_typename] = ACTIONS(2304),
    [anon_sym_template] = ACTIONS(2304),
    [anon_sym_operator] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_static_assert] = ACTIONS(2304),
    [anon_sym_concept] = ACTIONS(2304),
    [anon_sym_co_return] = ACTIONS(2304),
    [anon_sym_co_yield] = ACTIONS(2304),
    [anon_sym_R_DQUOTE] = ACTIONS(2306),
    [anon_sym_LR_DQUOTE] = ACTIONS(2306),
    [anon_sym_uR_DQUOTE] = ACTIONS(2306),
    [anon_sym_UR_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2306),
    [anon_sym_co_await] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_requires] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [anon_sym_discard] = ACTIONS(2304),
    [anon_sym_precise] = ACTIONS(2304),
    [anon_sym_shared] = ACTIONS(2304),
    [anon_sym_groupshared] = ACTIONS(2304),
    [anon_sym_uniform] = ACTIONS(2304),
    [anon_sym_row_major] = ACTIONS(2304),
    [anon_sym_column_major] = ACTIONS(2304),
    [anon_sym_globallycoherent] = ACTIONS(2304),
    [anon_sym_centroid] = ACTIONS(2304),
    [anon_sym_noperspective] = ACTIONS(2304),
    [anon_sym_nointerpolation] = ACTIONS(2304),
    [anon_sym_sample] = ACTIONS(2304),
    [anon_sym_linear] = ACTIONS(2304),
    [anon_sym_snorm] = ACTIONS(2304),
    [anon_sym_unorm] = ACTIONS(2304),
    [anon_sym_point] = ACTIONS(2304),
    [anon_sym_line] = ACTIONS(2304),
    [anon_sym_triangleadj] = ACTIONS(2304),
    [anon_sym_lineadj] = ACTIONS(2304),
    [anon_sym_triangle] = ACTIONS(2304),
    [anon_sym_cbuffer] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_extension] = ACTIONS(2304),
  },
  [190] = {
    [sym_identifier] = ACTIONS(2308),
    [aux_sym_preproc_include_token1] = ACTIONS(2308),
    [aux_sym_preproc_def_token1] = ACTIONS(2308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2310),
    [anon_sym_COMMA] = ACTIONS(2310),
    [aux_sym_preproc_if_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2308),
    [sym_preproc_directive] = ACTIONS(2308),
    [anon_sym_LPAREN2] = ACTIONS(2310),
    [anon_sym_BANG] = ACTIONS(2308),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_SLASH] = ACTIONS(2308),
    [anon_sym_PERCENT] = ACTIONS(2310),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_CARET] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2310),
    [anon_sym_BANG_EQ] = ACTIONS(2310),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_EQ] = ACTIONS(2310),
    [anon_sym_LT_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_LT_LT] = ACTIONS(2310),
    [anon_sym_GT_GT] = ACTIONS(2310),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(2308),
    [anon_sym_typedef] = ACTIONS(2308),
    [anon_sym_in] = ACTIONS(2308),
    [anon_sym_out] = ACTIONS(2308),
    [anon_sym_inout] = ACTIONS(2308),
    [anon_sym_virtual] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2308),
    [anon_sym___attribute__] = ACTIONS(2308),
    [anon_sym___attribute] = ACTIONS(2308),
    [anon_sym_using] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2310),
    [anon_sym___declspec] = ACTIONS(2308),
    [anon_sym___based] = ACTIONS(2308),
    [anon_sym___cdecl] = ACTIONS(2308),
    [anon_sym___clrcall] = ACTIONS(2308),
    [anon_sym___stdcall] = ACTIONS(2308),
    [anon_sym___fastcall] = ACTIONS(2308),
    [anon_sym___thiscall] = ACTIONS(2308),
    [anon_sym___vectorcall] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_RBRACE] = ACTIONS(2310),
    [anon_sym_signed] = ACTIONS(2308),
    [anon_sym_unsigned] = ACTIONS(2308),
    [anon_sym_long] = ACTIONS(2308),
    [anon_sym_short] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_register] = ACTIONS(2308),
    [anon_sym_inline] = ACTIONS(2308),
    [anon_sym___inline] = ACTIONS(2308),
    [anon_sym___inline__] = ACTIONS(2308),
    [anon_sym___forceinline] = ACTIONS(2308),
    [anon_sym_thread_local] = ACTIONS(2308),
    [anon_sym___thread] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_constexpr] = ACTIONS(2308),
    [anon_sym_volatile] = ACTIONS(2308),
    [anon_sym_restrict] = ACTIONS(2308),
    [anon_sym___restrict__] = ACTIONS(2308),
    [anon_sym__Atomic] = ACTIONS(2308),
    [anon_sym__Noreturn] = ACTIONS(2308),
    [anon_sym_noreturn] = ACTIONS(2308),
    [anon_sym__Nonnull] = ACTIONS(2308),
    [anon_sym_mutable] = ACTIONS(2308),
    [anon_sym_constinit] = ACTIONS(2308),
    [anon_sym_consteval] = ACTIONS(2308),
    [anon_sym_alignas] = ACTIONS(2308),
    [anon_sym__Alignas] = ACTIONS(2308),
    [sym_primitive_type] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_struct] = ACTIONS(2308),
    [anon_sym_union] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_case] = ACTIONS(2308),
    [anon_sym_default] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_goto] = ACTIONS(2308),
    [anon_sym___try] = ACTIONS(2308),
    [anon_sym___leave] = ACTIONS(2308),
    [anon_sym_QMARK] = ACTIONS(2310),
    [anon_sym_not] = ACTIONS(2308),
    [anon_sym_compl] = ACTIONS(2308),
    [anon_sym_LT_EQ_GT] = ACTIONS(2310),
    [anon_sym_or] = ACTIONS(2308),
    [anon_sym_and] = ACTIONS(2308),
    [anon_sym_bitor] = ACTIONS(2308),
    [anon_sym_xor] = ACTIONS(2308),
    [anon_sym_bitand] = ACTIONS(2308),
    [anon_sym_not_eq] = ACTIONS(2308),
    [anon_sym_is] = ACTIONS(2308),
    [anon_sym_as] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_sizeof] = ACTIONS(2308),
    [anon_sym___alignof__] = ACTIONS(2308),
    [anon_sym___alignof] = ACTIONS(2308),
    [anon_sym__alignof] = ACTIONS(2308),
    [anon_sym_alignof] = ACTIONS(2308),
    [anon_sym__Alignof] = ACTIONS(2308),
    [anon_sym_offsetof] = ACTIONS(2308),
    [anon_sym__Generic] = ACTIONS(2308),
    [anon_sym_asm] = ACTIONS(2308),
    [anon_sym___asm__] = ACTIONS(2308),
    [anon_sym___asm] = ACTIONS(2308),
    [anon_sym_DOT] = ACTIONS(2308),
    [anon_sym_DOT_STAR] = ACTIONS(2310),
    [anon_sym_DASH_GT] = ACTIONS(2310),
    [sym_number_literal] = ACTIONS(2310),
    [anon_sym_L_SQUOTE] = ACTIONS(2310),
    [anon_sym_u_SQUOTE] = ACTIONS(2310),
    [anon_sym_U_SQUOTE] = ACTIONS(2310),
    [anon_sym_u8_SQUOTE] = ACTIONS(2310),
    [anon_sym_SQUOTE] = ACTIONS(2310),
    [anon_sym_L_DQUOTE] = ACTIONS(2310),
    [anon_sym_u_DQUOTE] = ACTIONS(2310),
    [anon_sym_U_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8_DQUOTE] = ACTIONS(2310),
    [anon_sym_DQUOTE] = ACTIONS(2310),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [anon_sym_NULL] = ACTIONS(2308),
    [anon_sym_nullptr] = ACTIONS(2308),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_This] = ACTIONS(2308),
    [anon_sym_decltype] = ACTIONS(2308),
    [anon_sym_explicit] = ACTIONS(2308),
    [anon_sym_typename] = ACTIONS(2308),
    [anon_sym_template] = ACTIONS(2308),
    [anon_sym_operator] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_delete] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_namespace] = ACTIONS(2308),
    [anon_sym_static_assert] = ACTIONS(2308),
    [anon_sym_concept] = ACTIONS(2308),
    [anon_sym_co_return] = ACTIONS(2308),
    [anon_sym_co_yield] = ACTIONS(2308),
    [anon_sym_R_DQUOTE] = ACTIONS(2310),
    [anon_sym_LR_DQUOTE] = ACTIONS(2310),
    [anon_sym_uR_DQUOTE] = ACTIONS(2310),
    [anon_sym_UR_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2310),
    [anon_sym_co_await] = ACTIONS(2308),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_requires] = ACTIONS(2308),
    [sym_this] = ACTIONS(2308),
    [anon_sym_discard] = ACTIONS(2308),
    [anon_sym_precise] = ACTIONS(2308),
    [anon_sym_shared] = ACTIONS(2308),
    [anon_sym_groupshared] = ACTIONS(2308),
    [anon_sym_uniform] = ACTIONS(2308),
    [anon_sym_row_major] = ACTIONS(2308),
    [anon_sym_column_major] = ACTIONS(2308),
    [anon_sym_globallycoherent] = ACTIONS(2308),
    [anon_sym_centroid] = ACTIONS(2308),
    [anon_sym_noperspective] = ACTIONS(2308),
    [anon_sym_nointerpolation] = ACTIONS(2308),
    [anon_sym_sample] = ACTIONS(2308),
    [anon_sym_linear] = ACTIONS(2308),
    [anon_sym_snorm] = ACTIONS(2308),
    [anon_sym_unorm] = ACTIONS(2308),
    [anon_sym_point] = ACTIONS(2308),
    [anon_sym_line] = ACTIONS(2308),
    [anon_sym_triangleadj] = ACTIONS(2308),
    [anon_sym_lineadj] = ACTIONS(2308),
    [anon_sym_triangle] = ACTIONS(2308),
    [anon_sym_cbuffer] = ACTIONS(2308),
    [anon_sym_interface] = ACTIONS(2308),
    [anon_sym_extension] = ACTIONS(2308),
  },
  [191] = {
    [sym_identifier] = ACTIONS(2312),
    [aux_sym_preproc_include_token1] = ACTIONS(2312),
    [aux_sym_preproc_def_token1] = ACTIONS(2312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2314),
    [anon_sym_COMMA] = ACTIONS(2314),
    [aux_sym_preproc_if_token1] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2312),
    [sym_preproc_directive] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_SLASH] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2314),
    [anon_sym_PIPE_PIPE] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2314),
    [anon_sym_PIPE] = ACTIONS(2312),
    [anon_sym_CARET] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_EQ_EQ] = ACTIONS(2314),
    [anon_sym_BANG_EQ] = ACTIONS(2314),
    [anon_sym_GT] = ACTIONS(2312),
    [anon_sym_GT_EQ] = ACTIONS(2314),
    [anon_sym_LT_EQ] = ACTIONS(2312),
    [anon_sym_LT] = ACTIONS(2312),
    [anon_sym_LT_LT] = ACTIONS(2314),
    [anon_sym_GT_GT] = ACTIONS(2314),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym___extension__] = ACTIONS(2312),
    [anon_sym_typedef] = ACTIONS(2312),
    [anon_sym_in] = ACTIONS(2312),
    [anon_sym_out] = ACTIONS(2312),
    [anon_sym_inout] = ACTIONS(2312),
    [anon_sym_virtual] = ACTIONS(2312),
    [anon_sym_extern] = ACTIONS(2312),
    [anon_sym___attribute__] = ACTIONS(2312),
    [anon_sym___attribute] = ACTIONS(2312),
    [anon_sym_using] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2314),
    [anon_sym___declspec] = ACTIONS(2312),
    [anon_sym___based] = ACTIONS(2312),
    [anon_sym___cdecl] = ACTIONS(2312),
    [anon_sym___clrcall] = ACTIONS(2312),
    [anon_sym___stdcall] = ACTIONS(2312),
    [anon_sym___fastcall] = ACTIONS(2312),
    [anon_sym___thiscall] = ACTIONS(2312),
    [anon_sym___vectorcall] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_RBRACE] = ACTIONS(2314),
    [anon_sym_signed] = ACTIONS(2312),
    [anon_sym_unsigned] = ACTIONS(2312),
    [anon_sym_long] = ACTIONS(2312),
    [anon_sym_short] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_register] = ACTIONS(2312),
    [anon_sym_inline] = ACTIONS(2312),
    [anon_sym___inline] = ACTIONS(2312),
    [anon_sym___inline__] = ACTIONS(2312),
    [anon_sym___forceinline] = ACTIONS(2312),
    [anon_sym_thread_local] = ACTIONS(2312),
    [anon_sym___thread] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_constexpr] = ACTIONS(2312),
    [anon_sym_volatile] = ACTIONS(2312),
    [anon_sym_restrict] = ACTIONS(2312),
    [anon_sym___restrict__] = ACTIONS(2312),
    [anon_sym__Atomic] = ACTIONS(2312),
    [anon_sym__Noreturn] = ACTIONS(2312),
    [anon_sym_noreturn] = ACTIONS(2312),
    [anon_sym__Nonnull] = ACTIONS(2312),
    [anon_sym_mutable] = ACTIONS(2312),
    [anon_sym_constinit] = ACTIONS(2312),
    [anon_sym_consteval] = ACTIONS(2312),
    [anon_sym_alignas] = ACTIONS(2312),
    [anon_sym__Alignas] = ACTIONS(2312),
    [sym_primitive_type] = ACTIONS(2312),
    [anon_sym_enum] = ACTIONS(2312),
    [anon_sym_class] = ACTIONS(2312),
    [anon_sym_struct] = ACTIONS(2312),
    [anon_sym_union] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_switch] = ACTIONS(2312),
    [anon_sym_case] = ACTIONS(2312),
    [anon_sym_default] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_break] = ACTIONS(2312),
    [anon_sym_continue] = ACTIONS(2312),
    [anon_sym_goto] = ACTIONS(2312),
    [anon_sym___try] = ACTIONS(2312),
    [anon_sym___leave] = ACTIONS(2312),
    [anon_sym_QMARK] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2312),
    [anon_sym_compl] = ACTIONS(2312),
    [anon_sym_LT_EQ_GT] = ACTIONS(2314),
    [anon_sym_or] = ACTIONS(2312),
    [anon_sym_and] = ACTIONS(2312),
    [anon_sym_bitor] = ACTIONS(2312),
    [anon_sym_xor] = ACTIONS(2312),
    [anon_sym_bitand] = ACTIONS(2312),
    [anon_sym_not_eq] = ACTIONS(2312),
    [anon_sym_is] = ACTIONS(2312),
    [anon_sym_as] = ACTIONS(2312),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_sizeof] = ACTIONS(2312),
    [anon_sym___alignof__] = ACTIONS(2312),
    [anon_sym___alignof] = ACTIONS(2312),
    [anon_sym__alignof] = ACTIONS(2312),
    [anon_sym_alignof] = ACTIONS(2312),
    [anon_sym__Alignof] = ACTIONS(2312),
    [anon_sym_offsetof] = ACTIONS(2312),
    [anon_sym__Generic] = ACTIONS(2312),
    [anon_sym_asm] = ACTIONS(2312),
    [anon_sym___asm__] = ACTIONS(2312),
    [anon_sym___asm] = ACTIONS(2312),
    [anon_sym_DOT] = ACTIONS(2312),
    [anon_sym_DOT_STAR] = ACTIONS(2314),
    [anon_sym_DASH_GT] = ACTIONS(2314),
    [sym_number_literal] = ACTIONS(2314),
    [anon_sym_L_SQUOTE] = ACTIONS(2314),
    [anon_sym_u_SQUOTE] = ACTIONS(2314),
    [anon_sym_U_SQUOTE] = ACTIONS(2314),
    [anon_sym_u8_SQUOTE] = ACTIONS(2314),
    [anon_sym_SQUOTE] = ACTIONS(2314),
    [anon_sym_L_DQUOTE] = ACTIONS(2314),
    [anon_sym_u_DQUOTE] = ACTIONS(2314),
    [anon_sym_U_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE] = ACTIONS(2314),
    [sym_true] = ACTIONS(2312),
    [sym_false] = ACTIONS(2312),
    [anon_sym_NULL] = ACTIONS(2312),
    [anon_sym_nullptr] = ACTIONS(2312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_This] = ACTIONS(2312),
    [anon_sym_decltype] = ACTIONS(2312),
    [anon_sym_explicit] = ACTIONS(2312),
    [anon_sym_typename] = ACTIONS(2312),
    [anon_sym_template] = ACTIONS(2312),
    [anon_sym_operator] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_delete] = ACTIONS(2312),
    [anon_sym_throw] = ACTIONS(2312),
    [anon_sym_namespace] = ACTIONS(2312),
    [anon_sym_static_assert] = ACTIONS(2312),
    [anon_sym_concept] = ACTIONS(2312),
    [anon_sym_co_return] = ACTIONS(2312),
    [anon_sym_co_yield] = ACTIONS(2312),
    [anon_sym_R_DQUOTE] = ACTIONS(2314),
    [anon_sym_LR_DQUOTE] = ACTIONS(2314),
    [anon_sym_uR_DQUOTE] = ACTIONS(2314),
    [anon_sym_UR_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2314),
    [anon_sym_co_await] = ACTIONS(2312),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_requires] = ACTIONS(2312),
    [sym_this] = ACTIONS(2312),
    [anon_sym_discard] = ACTIONS(2312),
    [anon_sym_precise] = ACTIONS(2312),
    [anon_sym_shared] = ACTIONS(2312),
    [anon_sym_groupshared] = ACTIONS(2312),
    [anon_sym_uniform] = ACTIONS(2312),
    [anon_sym_row_major] = ACTIONS(2312),
    [anon_sym_column_major] = ACTIONS(2312),
    [anon_sym_globallycoherent] = ACTIONS(2312),
    [anon_sym_centroid] = ACTIONS(2312),
    [anon_sym_noperspective] = ACTIONS(2312),
    [anon_sym_nointerpolation] = ACTIONS(2312),
    [anon_sym_sample] = ACTIONS(2312),
    [anon_sym_linear] = ACTIONS(2312),
    [anon_sym_snorm] = ACTIONS(2312),
    [anon_sym_unorm] = ACTIONS(2312),
    [anon_sym_point] = ACTIONS(2312),
    [anon_sym_line] = ACTIONS(2312),
    [anon_sym_triangleadj] = ACTIONS(2312),
    [anon_sym_lineadj] = ACTIONS(2312),
    [anon_sym_triangle] = ACTIONS(2312),
    [anon_sym_cbuffer] = ACTIONS(2312),
    [anon_sym_interface] = ACTIONS(2312),
    [anon_sym_extension] = ACTIONS(2312),
  },
  [192] = {
    [sym_identifier] = ACTIONS(2243),
    [aux_sym_preproc_include_token1] = ACTIONS(2243),
    [aux_sym_preproc_def_token1] = ACTIONS(2243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2245),
    [anon_sym_COMMA] = ACTIONS(2245),
    [aux_sym_preproc_if_token1] = ACTIONS(2243),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2243),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2243),
    [sym_preproc_directive] = ACTIONS(2243),
    [anon_sym_LPAREN2] = ACTIONS(2247),
    [anon_sym_BANG] = ACTIONS(2243),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2247),
    [anon_sym_SLASH] = ACTIONS(2255),
    [anon_sym_PERCENT] = ACTIONS(2245),
    [anon_sym_PIPE_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2255),
    [anon_sym_CARET] = ACTIONS(2245),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2245),
    [anon_sym_BANG_EQ] = ACTIONS(2245),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_GT_EQ] = ACTIONS(2245),
    [anon_sym_LT_EQ] = ACTIONS(2255),
    [anon_sym_LT] = ACTIONS(2255),
    [anon_sym_LT_LT] = ACTIONS(2245),
    [anon_sym_GT_GT] = ACTIONS(2245),
    [anon_sym_SEMI] = ACTIONS(2247),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym_typedef] = ACTIONS(2243),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_out] = ACTIONS(2243),
    [anon_sym_inout] = ACTIONS(2243),
    [anon_sym_virtual] = ACTIONS(2243),
    [anon_sym_extern] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym___attribute] = ACTIONS(2243),
    [anon_sym_using] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2247),
    [anon_sym___declspec] = ACTIONS(2243),
    [anon_sym___based] = ACTIONS(2243),
    [anon_sym___cdecl] = ACTIONS(2243),
    [anon_sym___clrcall] = ACTIONS(2243),
    [anon_sym___stdcall] = ACTIONS(2243),
    [anon_sym___fastcall] = ACTIONS(2243),
    [anon_sym___thiscall] = ACTIONS(2243),
    [anon_sym___vectorcall] = ACTIONS(2243),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_signed] = ACTIONS(2243),
    [anon_sym_unsigned] = ACTIONS(2243),
    [anon_sym_long] = ACTIONS(2243),
    [anon_sym_short] = ACTIONS(2243),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_register] = ACTIONS(2243),
    [anon_sym_inline] = ACTIONS(2243),
    [anon_sym___inline] = ACTIONS(2243),
    [anon_sym___inline__] = ACTIONS(2243),
    [anon_sym___forceinline] = ACTIONS(2243),
    [anon_sym_thread_local] = ACTIONS(2243),
    [anon_sym___thread] = ACTIONS(2243),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym__Nonnull] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [sym_primitive_type] = ACTIONS(2243),
    [anon_sym_enum] = ACTIONS(2243),
    [anon_sym_class] = ACTIONS(2243),
    [anon_sym_struct] = ACTIONS(2243),
    [anon_sym_union] = ACTIONS(2243),
    [anon_sym_if] = ACTIONS(2243),
    [anon_sym_switch] = ACTIONS(2243),
    [anon_sym_case] = ACTIONS(2243),
    [anon_sym_default] = ACTIONS(2243),
    [anon_sym_while] = ACTIONS(2243),
    [anon_sym_do] = ACTIONS(2243),
    [anon_sym_for] = ACTIONS(2243),
    [anon_sym_return] = ACTIONS(2243),
    [anon_sym_break] = ACTIONS(2243),
    [anon_sym_continue] = ACTIONS(2243),
    [anon_sym_goto] = ACTIONS(2243),
    [anon_sym___try] = ACTIONS(2243),
    [anon_sym___leave] = ACTIONS(2243),
    [anon_sym_QMARK] = ACTIONS(2245),
    [anon_sym_not] = ACTIONS(2243),
    [anon_sym_compl] = ACTIONS(2243),
    [anon_sym_LT_EQ_GT] = ACTIONS(2245),
    [anon_sym_or] = ACTIONS(2255),
    [anon_sym_and] = ACTIONS(2255),
    [anon_sym_bitor] = ACTIONS(2255),
    [anon_sym_xor] = ACTIONS(2255),
    [anon_sym_bitand] = ACTIONS(2255),
    [anon_sym_not_eq] = ACTIONS(2255),
    [anon_sym_is] = ACTIONS(2255),
    [anon_sym_as] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2247),
    [anon_sym_PLUS_PLUS] = ACTIONS(2247),
    [anon_sym_sizeof] = ACTIONS(2243),
    [anon_sym___alignof__] = ACTIONS(2243),
    [anon_sym___alignof] = ACTIONS(2243),
    [anon_sym__alignof] = ACTIONS(2243),
    [anon_sym_alignof] = ACTIONS(2243),
    [anon_sym__Alignof] = ACTIONS(2243),
    [anon_sym_offsetof] = ACTIONS(2243),
    [anon_sym__Generic] = ACTIONS(2243),
    [anon_sym_asm] = ACTIONS(2243),
    [anon_sym___asm__] = ACTIONS(2243),
    [anon_sym___asm] = ACTIONS(2243),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2245),
    [anon_sym_DASH_GT] = ACTIONS(2245),
    [sym_number_literal] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2250),
    [anon_sym_u_SQUOTE] = ACTIONS(2250),
    [anon_sym_U_SQUOTE] = ACTIONS(2250),
    [anon_sym_u8_SQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_L_DQUOTE] = ACTIONS(2250),
    [anon_sym_u_DQUOTE] = ACTIONS(2250),
    [anon_sym_U_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [sym_true] = ACTIONS(2243),
    [sym_false] = ACTIONS(2243),
    [anon_sym_NULL] = ACTIONS(2243),
    [anon_sym_nullptr] = ACTIONS(2243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2243),
    [anon_sym_let] = ACTIONS(2243),
    [anon_sym_This] = ACTIONS(2243),
    [anon_sym_decltype] = ACTIONS(2243),
    [anon_sym_explicit] = ACTIONS(2243),
    [anon_sym_typename] = ACTIONS(2243),
    [anon_sym_template] = ACTIONS(2243),
    [anon_sym_operator] = ACTIONS(2243),
    [anon_sym_try] = ACTIONS(2243),
    [anon_sym_delete] = ACTIONS(2243),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_namespace] = ACTIONS(2243),
    [anon_sym_static_assert] = ACTIONS(2243),
    [anon_sym_concept] = ACTIONS(2243),
    [anon_sym_co_return] = ACTIONS(2243),
    [anon_sym_co_yield] = ACTIONS(2243),
    [anon_sym_R_DQUOTE] = ACTIONS(2250),
    [anon_sym_LR_DQUOTE] = ACTIONS(2250),
    [anon_sym_uR_DQUOTE] = ACTIONS(2250),
    [anon_sym_UR_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2250),
    [anon_sym_co_await] = ACTIONS(2243),
    [anon_sym_new] = ACTIONS(2243),
    [anon_sym_requires] = ACTIONS(2243),
    [sym_this] = ACTIONS(2243),
    [anon_sym_discard] = ACTIONS(2243),
    [anon_sym_precise] = ACTIONS(2243),
    [anon_sym_shared] = ACTIONS(2243),
    [anon_sym_groupshared] = ACTIONS(2243),
    [anon_sym_uniform] = ACTIONS(2243),
    [anon_sym_row_major] = ACTIONS(2243),
    [anon_sym_column_major] = ACTIONS(2243),
    [anon_sym_globallycoherent] = ACTIONS(2243),
    [anon_sym_centroid] = ACTIONS(2243),
    [anon_sym_noperspective] = ACTIONS(2243),
    [anon_sym_nointerpolation] = ACTIONS(2243),
    [anon_sym_sample] = ACTIONS(2243),
    [anon_sym_linear] = ACTIONS(2243),
    [anon_sym_snorm] = ACTIONS(2243),
    [anon_sym_unorm] = ACTIONS(2243),
    [anon_sym_point] = ACTIONS(2243),
    [anon_sym_line] = ACTIONS(2243),
    [anon_sym_triangleadj] = ACTIONS(2243),
    [anon_sym_lineadj] = ACTIONS(2243),
    [anon_sym_triangle] = ACTIONS(2243),
    [anon_sym_cbuffer] = ACTIONS(2243),
    [anon_sym_interface] = ACTIONS(2243),
    [anon_sym_extension] = ACTIONS(2243),
  },
  [193] = {
    [sym_declaration] = STATE(1840),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6624),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__for_statement_body] = STATE(11051),
    [sym_expression] = STATE(5774),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11229),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(2316),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym___extension__] = ACTIONS(2040),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [194] = {
    [sym_declaration] = STATE(1840),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6624),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__for_statement_body] = STATE(11558),
    [sym_expression] = STATE(5774),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11229),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(2316),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym___extension__] = ACTIONS(2040),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [195] = {
    [sym_declaration] = STATE(1840),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6624),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__for_statement_body] = STATE(11478),
    [sym_expression] = STATE(5774),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11229),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(2316),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym___extension__] = ACTIONS(2040),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [196] = {
    [sym_declaration] = STATE(1840),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6624),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__for_statement_body] = STATE(11193),
    [sym_expression] = STATE(5774),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11229),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(2316),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym___extension__] = ACTIONS(2040),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [197] = {
    [sym_declaration] = STATE(1840),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6624),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__for_statement_body] = STATE(11020),
    [sym_expression] = STATE(5774),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11229),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(2316),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym___extension__] = ACTIONS(2040),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [198] = {
    [sym_declaration] = STATE(1840),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6624),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__for_statement_body] = STATE(11133),
    [sym_expression] = STATE(5774),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11229),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(2316),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym___extension__] = ACTIONS(2040),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [199] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6858),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_expression] = STATE(5750),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11113),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2844),
    [sym_template_function] = STATE(4922),
    [sym_condition_declaration] = STATE(11113),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7330),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(2847),
    [sym_user_defined_literal] = STATE(4315),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(2316),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(2040),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [200] = {
    [ts_builtin_sym_end] = ACTIONS(2402),
    [sym_identifier] = ACTIONS(2404),
    [aux_sym_preproc_include_token1] = ACTIONS(2404),
    [aux_sym_preproc_def_token1] = ACTIONS(2404),
    [anon_sym_COMMA] = ACTIONS(2402),
    [anon_sym_RPAREN] = ACTIONS(2402),
    [aux_sym_preproc_if_token1] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2404),
    [sym_preproc_directive] = ACTIONS(2404),
    [anon_sym_LPAREN2] = ACTIONS(2402),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_TILDE] = ACTIONS(2402),
    [anon_sym_DASH] = ACTIONS(2404),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_STAR] = ACTIONS(2402),
    [anon_sym_PIPE_PIPE] = ACTIONS(2402),
    [anon_sym_AMP_AMP] = ACTIONS(2402),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2402),
    [anon_sym___extension__] = ACTIONS(2404),
    [anon_sym_typedef] = ACTIONS(2404),
    [anon_sym_in] = ACTIONS(2404),
    [anon_sym_out] = ACTIONS(2404),
    [anon_sym_inout] = ACTIONS(2404),
    [anon_sym_virtual] = ACTIONS(2404),
    [anon_sym_extern] = ACTIONS(2404),
    [anon_sym___attribute__] = ACTIONS(2404),
    [anon_sym___attribute] = ACTIONS(2404),
    [anon_sym_using] = ACTIONS(2404),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2402),
    [anon_sym___declspec] = ACTIONS(2404),
    [anon_sym___based] = ACTIONS(2404),
    [anon_sym___cdecl] = ACTIONS(2404),
    [anon_sym___clrcall] = ACTIONS(2404),
    [anon_sym___stdcall] = ACTIONS(2404),
    [anon_sym___fastcall] = ACTIONS(2404),
    [anon_sym___thiscall] = ACTIONS(2404),
    [anon_sym___vectorcall] = ACTIONS(2404),
    [anon_sym_LBRACE] = ACTIONS(2402),
    [anon_sym_RBRACE] = ACTIONS(2402),
    [anon_sym_signed] = ACTIONS(2404),
    [anon_sym_unsigned] = ACTIONS(2404),
    [anon_sym_long] = ACTIONS(2404),
    [anon_sym_short] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_register] = ACTIONS(2404),
    [anon_sym_inline] = ACTIONS(2404),
    [anon_sym___inline] = ACTIONS(2404),
    [anon_sym___inline__] = ACTIONS(2404),
    [anon_sym___forceinline] = ACTIONS(2404),
    [anon_sym_thread_local] = ACTIONS(2404),
    [anon_sym___thread] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [anon_sym_constexpr] = ACTIONS(2404),
    [anon_sym_volatile] = ACTIONS(2404),
    [anon_sym_restrict] = ACTIONS(2404),
    [anon_sym___restrict__] = ACTIONS(2404),
    [anon_sym__Atomic] = ACTIONS(2404),
    [anon_sym__Noreturn] = ACTIONS(2404),
    [anon_sym_noreturn] = ACTIONS(2404),
    [anon_sym__Nonnull] = ACTIONS(2404),
    [anon_sym_mutable] = ACTIONS(2404),
    [anon_sym_constinit] = ACTIONS(2404),
    [anon_sym_consteval] = ACTIONS(2404),
    [anon_sym_alignas] = ACTIONS(2404),
    [anon_sym__Alignas] = ACTIONS(2404),
    [sym_primitive_type] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
    [anon_sym_class] = ACTIONS(2404),
    [anon_sym_struct] = ACTIONS(2404),
    [anon_sym_union] = ACTIONS(2404),
    [anon_sym_if] = ACTIONS(2404),
    [anon_sym_else] = ACTIONS(2404),
    [anon_sym_switch] = ACTIONS(2404),
    [anon_sym_case] = ACTIONS(2404),
    [anon_sym_default] = ACTIONS(2404),
    [anon_sym_while] = ACTIONS(2404),
    [anon_sym_do] = ACTIONS(2404),
    [anon_sym_for] = ACTIONS(2404),
    [anon_sym_return] = ACTIONS(2404),
    [anon_sym_break] = ACTIONS(2404),
    [anon_sym_continue] = ACTIONS(2404),
    [anon_sym_goto] = ACTIONS(2404),
    [anon_sym___try] = ACTIONS(2404),
    [anon_sym___except] = ACTIONS(2404),
    [anon_sym___finally] = ACTIONS(2404),
    [anon_sym___leave] = ACTIONS(2404),
    [anon_sym_not] = ACTIONS(2404),
    [anon_sym_compl] = ACTIONS(2404),
    [anon_sym_or] = ACTIONS(2404),
    [anon_sym_and] = ACTIONS(2404),
    [anon_sym_DASH_DASH] = ACTIONS(2402),
    [anon_sym_PLUS_PLUS] = ACTIONS(2402),
    [anon_sym_sizeof] = ACTIONS(2404),
    [anon_sym___alignof__] = ACTIONS(2404),
    [anon_sym___alignof] = ACTIONS(2404),
    [anon_sym__alignof] = ACTIONS(2404),
    [anon_sym_alignof] = ACTIONS(2404),
    [anon_sym__Alignof] = ACTIONS(2404),
    [anon_sym_offsetof] = ACTIONS(2404),
    [anon_sym__Generic] = ACTIONS(2404),
    [anon_sym_asm] = ACTIONS(2404),
    [anon_sym___asm__] = ACTIONS(2404),
    [anon_sym___asm] = ACTIONS(2404),
    [sym_number_literal] = ACTIONS(2402),
    [anon_sym_L_SQUOTE] = ACTIONS(2402),
    [anon_sym_u_SQUOTE] = ACTIONS(2402),
    [anon_sym_U_SQUOTE] = ACTIONS(2402),
    [anon_sym_u8_SQUOTE] = ACTIONS(2402),
    [anon_sym_SQUOTE] = ACTIONS(2402),
    [anon_sym_L_DQUOTE] = ACTIONS(2402),
    [anon_sym_u_DQUOTE] = ACTIONS(2402),
    [anon_sym_U_DQUOTE] = ACTIONS(2402),
    [anon_sym_u8_DQUOTE] = ACTIONS(2402),
    [anon_sym_DQUOTE] = ACTIONS(2402),
    [sym_true] = ACTIONS(2404),
    [sym_false] = ACTIONS(2404),
    [anon_sym_NULL] = ACTIONS(2404),
    [anon_sym_nullptr] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2404),
    [anon_sym_let] = ACTIONS(2404),
    [anon_sym_This] = ACTIONS(2404),
    [anon_sym_decltype] = ACTIONS(2404),
    [anon_sym_final] = ACTIONS(2404),
    [anon_sym_override] = ACTIONS(2404),
    [anon_sym_explicit] = ACTIONS(2404),
    [anon_sym_typename] = ACTIONS(2404),
    [anon_sym_export] = ACTIONS(2404),
    [anon_sym_module] = ACTIONS(2404),
    [anon_sym_import] = ACTIONS(2404),
    [anon_sym_template] = ACTIONS(2404),
    [anon_sym_operator] = ACTIONS(2404),
    [anon_sym_try] = ACTIONS(2404),
    [anon_sym_delete] = ACTIONS(2404),
    [anon_sym_throw] = ACTIONS(2404),
    [anon_sym_namespace] = ACTIONS(2404),
    [anon_sym_static_assert] = ACTIONS(2404),
    [anon_sym_concept] = ACTIONS(2404),
    [anon_sym_co_return] = ACTIONS(2404),
    [anon_sym_co_yield] = ACTIONS(2404),
    [anon_sym_catch] = ACTIONS(2404),
    [anon_sym_R_DQUOTE] = ACTIONS(2402),
    [anon_sym_LR_DQUOTE] = ACTIONS(2402),
    [anon_sym_uR_DQUOTE] = ACTIONS(2402),
    [anon_sym_UR_DQUOTE] = ACTIONS(2402),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2402),
    [anon_sym_co_await] = ACTIONS(2404),
    [anon_sym_new] = ACTIONS(2404),
    [anon_sym_requires] = ACTIONS(2404),
    [sym_this] = ACTIONS(2404),
    [anon_sym_discard] = ACTIONS(2404),
    [anon_sym_precise] = ACTIONS(2404),
    [anon_sym_shared] = ACTIONS(2404),
    [anon_sym_groupshared] = ACTIONS(2404),
    [anon_sym_uniform] = ACTIONS(2404),
    [anon_sym_row_major] = ACTIONS(2404),
    [anon_sym_column_major] = ACTIONS(2404),
    [anon_sym_globallycoherent] = ACTIONS(2404),
    [anon_sym_centroid] = ACTIONS(2404),
    [anon_sym_noperspective] = ACTIONS(2404),
    [anon_sym_nointerpolation] = ACTIONS(2404),
    [anon_sym_sample] = ACTIONS(2404),
    [anon_sym_linear] = ACTIONS(2404),
    [anon_sym_snorm] = ACTIONS(2404),
    [anon_sym_unorm] = ACTIONS(2404),
    [anon_sym_point] = ACTIONS(2404),
    [anon_sym_line] = ACTIONS(2404),
    [anon_sym_triangleadj] = ACTIONS(2404),
    [anon_sym_lineadj] = ACTIONS(2404),
    [anon_sym_triangle] = ACTIONS(2404),
    [anon_sym_cbuffer] = ACTIONS(2404),
    [anon_sym_interface] = ACTIONS(2404),
    [anon_sym_extension] = ACTIONS(2404),
    [anon_sym_where] = ACTIONS(2404),
    [anon_sym___exported] = ACTIONS(2404),
    [anon_sym_get] = ACTIONS(2404),
    [anon_sym_set] = ACTIONS(2404),
  },
  [201] = {
    [sym_template_argument_list] = STATE(210),
    [ts_builtin_sym_end] = ACTIONS(2229),
    [sym_identifier] = ACTIONS(2222),
    [aux_sym_preproc_include_token1] = ACTIONS(2222),
    [aux_sym_preproc_def_token1] = ACTIONS(2222),
    [anon_sym_COMMA] = ACTIONS(2229),
    [anon_sym_RPAREN] = ACTIONS(2229),
    [aux_sym_preproc_if_token1] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2222),
    [sym_preproc_directive] = ACTIONS(2222),
    [anon_sym_LPAREN2] = ACTIONS(2229),
    [anon_sym_BANG] = ACTIONS(2229),
    [anon_sym_TILDE] = ACTIONS(2229),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2229),
    [anon_sym_PIPE_PIPE] = ACTIONS(2229),
    [anon_sym_AMP_AMP] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2406),
    [anon_sym_COLON] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(2229),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_typedef] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_virtual] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym___attribute] = ACTIONS(2222),
    [anon_sym_using] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2229),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym___based] = ACTIONS(2222),
    [anon_sym___cdecl] = ACTIONS(2222),
    [anon_sym___clrcall] = ACTIONS(2222),
    [anon_sym___stdcall] = ACTIONS(2222),
    [anon_sym___fastcall] = ACTIONS(2222),
    [anon_sym___thiscall] = ACTIONS(2222),
    [anon_sym___vectorcall] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_signed] = ACTIONS(2222),
    [anon_sym_unsigned] = ACTIONS(2222),
    [anon_sym_long] = ACTIONS(2222),
    [anon_sym_short] = ACTIONS(2222),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_EQ] = ACTIONS(2229),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym__Nonnull] = ACTIONS(2222),
    [anon_sym_mutable] = ACTIONS(2222),
    [anon_sym_constinit] = ACTIONS(2222),
    [anon_sym_consteval] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [sym_primitive_type] = ACTIONS(2222),
    [anon_sym_enum] = ACTIONS(2222),
    [anon_sym_class] = ACTIONS(2222),
    [anon_sym_struct] = ACTIONS(2222),
    [anon_sym_union] = ACTIONS(2222),
    [anon_sym_if] = ACTIONS(2222),
    [anon_sym_else] = ACTIONS(2222),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2222),
    [anon_sym_default] = ACTIONS(2222),
    [anon_sym_while] = ACTIONS(2222),
    [anon_sym_do] = ACTIONS(2222),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_return] = ACTIONS(2222),
    [anon_sym_break] = ACTIONS(2222),
    [anon_sym_continue] = ACTIONS(2222),
    [anon_sym_goto] = ACTIONS(2222),
    [anon_sym___try] = ACTIONS(2222),
    [anon_sym___leave] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_compl] = ACTIONS(2222),
    [anon_sym_or] = ACTIONS(2222),
    [anon_sym_and] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2229),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(2222),
    [anon_sym___alignof] = ACTIONS(2222),
    [anon_sym__alignof] = ACTIONS(2222),
    [anon_sym_alignof] = ACTIONS(2222),
    [anon_sym__Alignof] = ACTIONS(2222),
    [anon_sym_offsetof] = ACTIONS(2222),
    [anon_sym__Generic] = ACTIONS(2222),
    [anon_sym_asm] = ACTIONS(2222),
    [anon_sym___asm__] = ACTIONS(2222),
    [anon_sym___asm] = ACTIONS(2222),
    [anon_sym_DOT] = ACTIONS(2222),
    [sym_number_literal] = ACTIONS(2229),
    [anon_sym_L_SQUOTE] = ACTIONS(2229),
    [anon_sym_u_SQUOTE] = ACTIONS(2229),
    [anon_sym_U_SQUOTE] = ACTIONS(2229),
    [anon_sym_u8_SQUOTE] = ACTIONS(2229),
    [anon_sym_SQUOTE] = ACTIONS(2229),
    [anon_sym_L_DQUOTE] = ACTIONS(2229),
    [anon_sym_u_DQUOTE] = ACTIONS(2229),
    [anon_sym_U_DQUOTE] = ACTIONS(2229),
    [anon_sym_u8_DQUOTE] = ACTIONS(2229),
    [anon_sym_DQUOTE] = ACTIONS(2229),
    [sym_true] = ACTIONS(2222),
    [sym_false] = ACTIONS(2222),
    [anon_sym_NULL] = ACTIONS(2222),
    [anon_sym_nullptr] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2222),
    [anon_sym_let] = ACTIONS(2222),
    [anon_sym_This] = ACTIONS(2222),
    [anon_sym_decltype] = ACTIONS(2222),
    [anon_sym_final] = ACTIONS(2222),
    [anon_sym_override] = ACTIONS(2222),
    [anon_sym_explicit] = ACTIONS(2222),
    [anon_sym_typename] = ACTIONS(2222),
    [anon_sym_export] = ACTIONS(2222),
    [anon_sym_module] = ACTIONS(2222),
    [anon_sym_import] = ACTIONS(2222),
    [anon_sym_template] = ACTIONS(2222),
    [anon_sym_GT2] = ACTIONS(2229),
    [anon_sym_operator] = ACTIONS(2222),
    [anon_sym_try] = ACTIONS(2222),
    [anon_sym_delete] = ACTIONS(2222),
    [anon_sym_throw] = ACTIONS(2222),
    [anon_sym_namespace] = ACTIONS(2222),
    [anon_sym_static_assert] = ACTIONS(2222),
    [anon_sym_concept] = ACTIONS(2222),
    [anon_sym_co_return] = ACTIONS(2222),
    [anon_sym_co_yield] = ACTIONS(2222),
    [anon_sym_R_DQUOTE] = ACTIONS(2229),
    [anon_sym_LR_DQUOTE] = ACTIONS(2229),
    [anon_sym_uR_DQUOTE] = ACTIONS(2229),
    [anon_sym_UR_DQUOTE] = ACTIONS(2229),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2229),
    [anon_sym_co_await] = ACTIONS(2222),
    [anon_sym_new] = ACTIONS(2222),
    [anon_sym_requires] = ACTIONS(2222),
    [sym_this] = ACTIONS(2222),
    [anon_sym_discard] = ACTIONS(2222),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_groupshared] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_row_major] = ACTIONS(2222),
    [anon_sym_column_major] = ACTIONS(2222),
    [anon_sym_globallycoherent] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym_nointerpolation] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_linear] = ACTIONS(2222),
    [anon_sym_snorm] = ACTIONS(2222),
    [anon_sym_unorm] = ACTIONS(2222),
    [anon_sym_point] = ACTIONS(2222),
    [anon_sym_line] = ACTIONS(2222),
    [anon_sym_triangleadj] = ACTIONS(2222),
    [anon_sym_lineadj] = ACTIONS(2222),
    [anon_sym_triangle] = ACTIONS(2222),
    [anon_sym_cbuffer] = ACTIONS(2222),
    [anon_sym_interface] = ACTIONS(2222),
    [anon_sym_extension] = ACTIONS(2222),
    [anon_sym_where] = ACTIONS(2222),
    [anon_sym___exported] = ACTIONS(2222),
  },
  [202] = {
    [sym_template_argument_list] = STATE(210),
    [ts_builtin_sym_end] = ACTIONS(2408),
    [sym_identifier] = ACTIONS(2410),
    [aux_sym_preproc_include_token1] = ACTIONS(2410),
    [aux_sym_preproc_def_token1] = ACTIONS(2410),
    [anon_sym_COMMA] = ACTIONS(2408),
    [anon_sym_RPAREN] = ACTIONS(2408),
    [aux_sym_preproc_if_token1] = ACTIONS(2410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2410),
    [sym_preproc_directive] = ACTIONS(2410),
    [anon_sym_LPAREN2] = ACTIONS(2408),
    [anon_sym_BANG] = ACTIONS(2408),
    [anon_sym_TILDE] = ACTIONS(2408),
    [anon_sym_DASH] = ACTIONS(2410),
    [anon_sym_PLUS] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(2408),
    [anon_sym_PIPE_PIPE] = ACTIONS(2408),
    [anon_sym_AMP_AMP] = ACTIONS(2408),
    [anon_sym_AMP] = ACTIONS(2410),
    [anon_sym_LT] = ACTIONS(2406),
    [anon_sym_COLON] = ACTIONS(2410),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym___extension__] = ACTIONS(2410),
    [anon_sym_typedef] = ACTIONS(2410),
    [anon_sym_in] = ACTIONS(2410),
    [anon_sym_out] = ACTIONS(2410),
    [anon_sym_inout] = ACTIONS(2410),
    [anon_sym_virtual] = ACTIONS(2410),
    [anon_sym_extern] = ACTIONS(2410),
    [anon_sym___attribute__] = ACTIONS(2410),
    [anon_sym___attribute] = ACTIONS(2410),
    [anon_sym_using] = ACTIONS(2410),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2408),
    [anon_sym___declspec] = ACTIONS(2410),
    [anon_sym___based] = ACTIONS(2410),
    [anon_sym___cdecl] = ACTIONS(2410),
    [anon_sym___clrcall] = ACTIONS(2410),
    [anon_sym___stdcall] = ACTIONS(2410),
    [anon_sym___fastcall] = ACTIONS(2410),
    [anon_sym___thiscall] = ACTIONS(2410),
    [anon_sym___vectorcall] = ACTIONS(2410),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_signed] = ACTIONS(2410),
    [anon_sym_unsigned] = ACTIONS(2410),
    [anon_sym_long] = ACTIONS(2410),
    [anon_sym_short] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_static] = ACTIONS(2410),
    [anon_sym_EQ] = ACTIONS(2408),
    [anon_sym_register] = ACTIONS(2410),
    [anon_sym_inline] = ACTIONS(2410),
    [anon_sym___inline] = ACTIONS(2410),
    [anon_sym___inline__] = ACTIONS(2410),
    [anon_sym___forceinline] = ACTIONS(2410),
    [anon_sym_thread_local] = ACTIONS(2410),
    [anon_sym___thread] = ACTIONS(2410),
    [anon_sym_const] = ACTIONS(2410),
    [anon_sym_constexpr] = ACTIONS(2410),
    [anon_sym_volatile] = ACTIONS(2410),
    [anon_sym_restrict] = ACTIONS(2410),
    [anon_sym___restrict__] = ACTIONS(2410),
    [anon_sym__Atomic] = ACTIONS(2410),
    [anon_sym__Noreturn] = ACTIONS(2410),
    [anon_sym_noreturn] = ACTIONS(2410),
    [anon_sym__Nonnull] = ACTIONS(2410),
    [anon_sym_mutable] = ACTIONS(2410),
    [anon_sym_constinit] = ACTIONS(2410),
    [anon_sym_consteval] = ACTIONS(2410),
    [anon_sym_alignas] = ACTIONS(2410),
    [anon_sym__Alignas] = ACTIONS(2410),
    [sym_primitive_type] = ACTIONS(2410),
    [anon_sym_enum] = ACTIONS(2410),
    [anon_sym_class] = ACTIONS(2410),
    [anon_sym_struct] = ACTIONS(2410),
    [anon_sym_union] = ACTIONS(2410),
    [anon_sym_if] = ACTIONS(2410),
    [anon_sym_else] = ACTIONS(2410),
    [anon_sym_switch] = ACTIONS(2410),
    [anon_sym_case] = ACTIONS(2410),
    [anon_sym_default] = ACTIONS(2410),
    [anon_sym_while] = ACTIONS(2410),
    [anon_sym_do] = ACTIONS(2410),
    [anon_sym_for] = ACTIONS(2410),
    [anon_sym_return] = ACTIONS(2410),
    [anon_sym_break] = ACTIONS(2410),
    [anon_sym_continue] = ACTIONS(2410),
    [anon_sym_goto] = ACTIONS(2410),
    [anon_sym___try] = ACTIONS(2410),
    [anon_sym___leave] = ACTIONS(2410),
    [anon_sym_not] = ACTIONS(2410),
    [anon_sym_compl] = ACTIONS(2410),
    [anon_sym_or] = ACTIONS(2410),
    [anon_sym_and] = ACTIONS(2410),
    [anon_sym_DASH_DASH] = ACTIONS(2408),
    [anon_sym_PLUS_PLUS] = ACTIONS(2408),
    [anon_sym_sizeof] = ACTIONS(2410),
    [anon_sym___alignof__] = ACTIONS(2410),
    [anon_sym___alignof] = ACTIONS(2410),
    [anon_sym__alignof] = ACTIONS(2410),
    [anon_sym_alignof] = ACTIONS(2410),
    [anon_sym__Alignof] = ACTIONS(2410),
    [anon_sym_offsetof] = ACTIONS(2410),
    [anon_sym__Generic] = ACTIONS(2410),
    [anon_sym_asm] = ACTIONS(2410),
    [anon_sym___asm__] = ACTIONS(2410),
    [anon_sym___asm] = ACTIONS(2410),
    [anon_sym_DOT] = ACTIONS(2410),
    [sym_number_literal] = ACTIONS(2408),
    [anon_sym_L_SQUOTE] = ACTIONS(2408),
    [anon_sym_u_SQUOTE] = ACTIONS(2408),
    [anon_sym_U_SQUOTE] = ACTIONS(2408),
    [anon_sym_u8_SQUOTE] = ACTIONS(2408),
    [anon_sym_SQUOTE] = ACTIONS(2408),
    [anon_sym_L_DQUOTE] = ACTIONS(2408),
    [anon_sym_u_DQUOTE] = ACTIONS(2408),
    [anon_sym_U_DQUOTE] = ACTIONS(2408),
    [anon_sym_u8_DQUOTE] = ACTIONS(2408),
    [anon_sym_DQUOTE] = ACTIONS(2408),
    [sym_true] = ACTIONS(2410),
    [sym_false] = ACTIONS(2410),
    [anon_sym_NULL] = ACTIONS(2410),
    [anon_sym_nullptr] = ACTIONS(2410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2410),
    [anon_sym_let] = ACTIONS(2410),
    [anon_sym_This] = ACTIONS(2410),
    [anon_sym_decltype] = ACTIONS(2410),
    [anon_sym_final] = ACTIONS(2410),
    [anon_sym_override] = ACTIONS(2410),
    [anon_sym_explicit] = ACTIONS(2410),
    [anon_sym_typename] = ACTIONS(2410),
    [anon_sym_export] = ACTIONS(2410),
    [anon_sym_module] = ACTIONS(2410),
    [anon_sym_import] = ACTIONS(2410),
    [anon_sym_template] = ACTIONS(2410),
    [anon_sym_GT2] = ACTIONS(2408),
    [anon_sym_operator] = ACTIONS(2410),
    [anon_sym_try] = ACTIONS(2410),
    [anon_sym_delete] = ACTIONS(2410),
    [anon_sym_throw] = ACTIONS(2410),
    [anon_sym_namespace] = ACTIONS(2410),
    [anon_sym_static_assert] = ACTIONS(2410),
    [anon_sym_concept] = ACTIONS(2410),
    [anon_sym_co_return] = ACTIONS(2410),
    [anon_sym_co_yield] = ACTIONS(2410),
    [anon_sym_R_DQUOTE] = ACTIONS(2408),
    [anon_sym_LR_DQUOTE] = ACTIONS(2408),
    [anon_sym_uR_DQUOTE] = ACTIONS(2408),
    [anon_sym_UR_DQUOTE] = ACTIONS(2408),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2408),
    [anon_sym_co_await] = ACTIONS(2410),
    [anon_sym_new] = ACTIONS(2410),
    [anon_sym_requires] = ACTIONS(2410),
    [sym_this] = ACTIONS(2410),
    [anon_sym_discard] = ACTIONS(2410),
    [anon_sym_precise] = ACTIONS(2410),
    [anon_sym_shared] = ACTIONS(2410),
    [anon_sym_groupshared] = ACTIONS(2410),
    [anon_sym_uniform] = ACTIONS(2410),
    [anon_sym_row_major] = ACTIONS(2410),
    [anon_sym_column_major] = ACTIONS(2410),
    [anon_sym_globallycoherent] = ACTIONS(2410),
    [anon_sym_centroid] = ACTIONS(2410),
    [anon_sym_noperspective] = ACTIONS(2410),
    [anon_sym_nointerpolation] = ACTIONS(2410),
    [anon_sym_sample] = ACTIONS(2410),
    [anon_sym_linear] = ACTIONS(2410),
    [anon_sym_snorm] = ACTIONS(2410),
    [anon_sym_unorm] = ACTIONS(2410),
    [anon_sym_point] = ACTIONS(2410),
    [anon_sym_line] = ACTIONS(2410),
    [anon_sym_triangleadj] = ACTIONS(2410),
    [anon_sym_lineadj] = ACTIONS(2410),
    [anon_sym_triangle] = ACTIONS(2410),
    [anon_sym_cbuffer] = ACTIONS(2410),
    [anon_sym_interface] = ACTIONS(2410),
    [anon_sym_extension] = ACTIONS(2410),
    [anon_sym_where] = ACTIONS(2410),
    [anon_sym___exported] = ACTIONS(2410),
  },
  [203] = {
    [ts_builtin_sym_end] = ACTIONS(2412),
    [sym_identifier] = ACTIONS(2414),
    [aux_sym_preproc_include_token1] = ACTIONS(2414),
    [aux_sym_preproc_def_token1] = ACTIONS(2414),
    [anon_sym_COMMA] = ACTIONS(2412),
    [anon_sym_RPAREN] = ACTIONS(2412),
    [aux_sym_preproc_if_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2414),
    [sym_preproc_directive] = ACTIONS(2414),
    [anon_sym_LPAREN2] = ACTIONS(2412),
    [anon_sym_BANG] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_PIPE_PIPE] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym___extension__] = ACTIONS(2414),
    [anon_sym_typedef] = ACTIONS(2414),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_out] = ACTIONS(2414),
    [anon_sym_inout] = ACTIONS(2414),
    [anon_sym_virtual] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym___attribute__] = ACTIONS(2414),
    [anon_sym___attribute] = ACTIONS(2414),
    [anon_sym_using] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2412),
    [anon_sym___declspec] = ACTIONS(2414),
    [anon_sym___based] = ACTIONS(2414),
    [anon_sym___cdecl] = ACTIONS(2414),
    [anon_sym___clrcall] = ACTIONS(2414),
    [anon_sym___stdcall] = ACTIONS(2414),
    [anon_sym___fastcall] = ACTIONS(2414),
    [anon_sym___thiscall] = ACTIONS(2414),
    [anon_sym___vectorcall] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(2412),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [anon_sym_signed] = ACTIONS(2414),
    [anon_sym_unsigned] = ACTIONS(2414),
    [anon_sym_long] = ACTIONS(2414),
    [anon_sym_short] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_register] = ACTIONS(2414),
    [anon_sym_inline] = ACTIONS(2414),
    [anon_sym___inline] = ACTIONS(2414),
    [anon_sym___inline__] = ACTIONS(2414),
    [anon_sym___forceinline] = ACTIONS(2414),
    [anon_sym_thread_local] = ACTIONS(2414),
    [anon_sym___thread] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_constexpr] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym_restrict] = ACTIONS(2414),
    [anon_sym___restrict__] = ACTIONS(2414),
    [anon_sym__Atomic] = ACTIONS(2414),
    [anon_sym__Noreturn] = ACTIONS(2414),
    [anon_sym_noreturn] = ACTIONS(2414),
    [anon_sym__Nonnull] = ACTIONS(2414),
    [anon_sym_mutable] = ACTIONS(2414),
    [anon_sym_constinit] = ACTIONS(2414),
    [anon_sym_consteval] = ACTIONS(2414),
    [anon_sym_alignas] = ACTIONS(2414),
    [anon_sym__Alignas] = ACTIONS(2414),
    [sym_primitive_type] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [anon_sym_if] = ACTIONS(2414),
    [anon_sym_else] = ACTIONS(2414),
    [anon_sym_switch] = ACTIONS(2414),
    [anon_sym_case] = ACTIONS(2414),
    [anon_sym_default] = ACTIONS(2414),
    [anon_sym_while] = ACTIONS(2414),
    [anon_sym_do] = ACTIONS(2414),
    [anon_sym_for] = ACTIONS(2414),
    [anon_sym_return] = ACTIONS(2414),
    [anon_sym_break] = ACTIONS(2414),
    [anon_sym_continue] = ACTIONS(2414),
    [anon_sym_goto] = ACTIONS(2414),
    [anon_sym___try] = ACTIONS(2414),
    [anon_sym___except] = ACTIONS(2414),
    [anon_sym___finally] = ACTIONS(2414),
    [anon_sym___leave] = ACTIONS(2414),
    [anon_sym_not] = ACTIONS(2414),
    [anon_sym_compl] = ACTIONS(2414),
    [anon_sym_or] = ACTIONS(2414),
    [anon_sym_and] = ACTIONS(2414),
    [anon_sym_DASH_DASH] = ACTIONS(2412),
    [anon_sym_PLUS_PLUS] = ACTIONS(2412),
    [anon_sym_sizeof] = ACTIONS(2414),
    [anon_sym___alignof__] = ACTIONS(2414),
    [anon_sym___alignof] = ACTIONS(2414),
    [anon_sym__alignof] = ACTIONS(2414),
    [anon_sym_alignof] = ACTIONS(2414),
    [anon_sym__Alignof] = ACTIONS(2414),
    [anon_sym_offsetof] = ACTIONS(2414),
    [anon_sym__Generic] = ACTIONS(2414),
    [anon_sym_asm] = ACTIONS(2414),
    [anon_sym___asm__] = ACTIONS(2414),
    [anon_sym___asm] = ACTIONS(2414),
    [sym_number_literal] = ACTIONS(2412),
    [anon_sym_L_SQUOTE] = ACTIONS(2412),
    [anon_sym_u_SQUOTE] = ACTIONS(2412),
    [anon_sym_U_SQUOTE] = ACTIONS(2412),
    [anon_sym_u8_SQUOTE] = ACTIONS(2412),
    [anon_sym_SQUOTE] = ACTIONS(2412),
    [anon_sym_L_DQUOTE] = ACTIONS(2412),
    [anon_sym_u_DQUOTE] = ACTIONS(2412),
    [anon_sym_U_DQUOTE] = ACTIONS(2412),
    [anon_sym_u8_DQUOTE] = ACTIONS(2412),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [sym_true] = ACTIONS(2414),
    [sym_false] = ACTIONS(2414),
    [anon_sym_NULL] = ACTIONS(2414),
    [anon_sym_nullptr] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2414),
    [anon_sym_let] = ACTIONS(2414),
    [anon_sym_This] = ACTIONS(2414),
    [anon_sym_decltype] = ACTIONS(2414),
    [anon_sym_final] = ACTIONS(2414),
    [anon_sym_override] = ACTIONS(2414),
    [anon_sym_explicit] = ACTIONS(2414),
    [anon_sym_typename] = ACTIONS(2414),
    [anon_sym_export] = ACTIONS(2414),
    [anon_sym_module] = ACTIONS(2414),
    [anon_sym_import] = ACTIONS(2414),
    [anon_sym_template] = ACTIONS(2414),
    [anon_sym_operator] = ACTIONS(2414),
    [anon_sym_try] = ACTIONS(2414),
    [anon_sym_delete] = ACTIONS(2414),
    [anon_sym_throw] = ACTIONS(2414),
    [anon_sym_namespace] = ACTIONS(2414),
    [anon_sym_static_assert] = ACTIONS(2414),
    [anon_sym_concept] = ACTIONS(2414),
    [anon_sym_co_return] = ACTIONS(2414),
    [anon_sym_co_yield] = ACTIONS(2414),
    [anon_sym_catch] = ACTIONS(2414),
    [anon_sym_R_DQUOTE] = ACTIONS(2412),
    [anon_sym_LR_DQUOTE] = ACTIONS(2412),
    [anon_sym_uR_DQUOTE] = ACTIONS(2412),
    [anon_sym_UR_DQUOTE] = ACTIONS(2412),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2412),
    [anon_sym_co_await] = ACTIONS(2414),
    [anon_sym_new] = ACTIONS(2414),
    [anon_sym_requires] = ACTIONS(2414),
    [sym_this] = ACTIONS(2414),
    [anon_sym_discard] = ACTIONS(2414),
    [anon_sym_precise] = ACTIONS(2414),
    [anon_sym_shared] = ACTIONS(2414),
    [anon_sym_groupshared] = ACTIONS(2414),
    [anon_sym_uniform] = ACTIONS(2414),
    [anon_sym_row_major] = ACTIONS(2414),
    [anon_sym_column_major] = ACTIONS(2414),
    [anon_sym_globallycoherent] = ACTIONS(2414),
    [anon_sym_centroid] = ACTIONS(2414),
    [anon_sym_noperspective] = ACTIONS(2414),
    [anon_sym_nointerpolation] = ACTIONS(2414),
    [anon_sym_sample] = ACTIONS(2414),
    [anon_sym_linear] = ACTIONS(2414),
    [anon_sym_snorm] = ACTIONS(2414),
    [anon_sym_unorm] = ACTIONS(2414),
    [anon_sym_point] = ACTIONS(2414),
    [anon_sym_line] = ACTIONS(2414),
    [anon_sym_triangleadj] = ACTIONS(2414),
    [anon_sym_lineadj] = ACTIONS(2414),
    [anon_sym_triangle] = ACTIONS(2414),
    [anon_sym_cbuffer] = ACTIONS(2414),
    [anon_sym_interface] = ACTIONS(2414),
    [anon_sym_extension] = ACTIONS(2414),
    [anon_sym_where] = ACTIONS(2414),
    [anon_sym___exported] = ACTIONS(2414),
    [anon_sym_get] = ACTIONS(2414),
    [anon_sym_set] = ACTIONS(2414),
  },
  [204] = {
    [ts_builtin_sym_end] = ACTIONS(2416),
    [sym_identifier] = ACTIONS(2418),
    [aux_sym_preproc_include_token1] = ACTIONS(2418),
    [aux_sym_preproc_def_token1] = ACTIONS(2418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2416),
    [anon_sym_COMMA] = ACTIONS(2416),
    [anon_sym_RPAREN] = ACTIONS(2416),
    [aux_sym_preproc_if_token1] = ACTIONS(2418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2418),
    [sym_preproc_directive] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2416),
    [anon_sym_TILDE] = ACTIONS(2416),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2416),
    [anon_sym_PIPE_PIPE] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym___extension__] = ACTIONS(2418),
    [anon_sym_typedef] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(2418),
    [anon_sym_out] = ACTIONS(2418),
    [anon_sym_inout] = ACTIONS(2418),
    [anon_sym_virtual] = ACTIONS(2418),
    [anon_sym_extern] = ACTIONS(2418),
    [anon_sym___attribute__] = ACTIONS(2418),
    [anon_sym___attribute] = ACTIONS(2418),
    [anon_sym_using] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2416),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2416),
    [anon_sym___declspec] = ACTIONS(2418),
    [anon_sym___based] = ACTIONS(2418),
    [anon_sym___cdecl] = ACTIONS(2418),
    [anon_sym___clrcall] = ACTIONS(2418),
    [anon_sym___stdcall] = ACTIONS(2418),
    [anon_sym___fastcall] = ACTIONS(2418),
    [anon_sym___thiscall] = ACTIONS(2418),
    [anon_sym___vectorcall] = ACTIONS(2418),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_signed] = ACTIONS(2418),
    [anon_sym_unsigned] = ACTIONS(2418),
    [anon_sym_long] = ACTIONS(2418),
    [anon_sym_short] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2416),
    [anon_sym_register] = ACTIONS(2418),
    [anon_sym_inline] = ACTIONS(2418),
    [anon_sym___inline] = ACTIONS(2418),
    [anon_sym___inline__] = ACTIONS(2418),
    [anon_sym___forceinline] = ACTIONS(2418),
    [anon_sym_thread_local] = ACTIONS(2418),
    [anon_sym___thread] = ACTIONS(2418),
    [anon_sym_const] = ACTIONS(2418),
    [anon_sym_constexpr] = ACTIONS(2418),
    [anon_sym_volatile] = ACTIONS(2418),
    [anon_sym_restrict] = ACTIONS(2418),
    [anon_sym___restrict__] = ACTIONS(2418),
    [anon_sym__Atomic] = ACTIONS(2418),
    [anon_sym__Noreturn] = ACTIONS(2418),
    [anon_sym_noreturn] = ACTIONS(2418),
    [anon_sym__Nonnull] = ACTIONS(2418),
    [anon_sym_mutable] = ACTIONS(2418),
    [anon_sym_constinit] = ACTIONS(2418),
    [anon_sym_consteval] = ACTIONS(2418),
    [anon_sym_alignas] = ACTIONS(2418),
    [anon_sym__Alignas] = ACTIONS(2418),
    [sym_primitive_type] = ACTIONS(2418),
    [anon_sym_enum] = ACTIONS(2418),
    [anon_sym_class] = ACTIONS(2418),
    [anon_sym_struct] = ACTIONS(2418),
    [anon_sym_union] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_else] = ACTIONS(2418),
    [anon_sym_switch] = ACTIONS(2418),
    [anon_sym_case] = ACTIONS(2418),
    [anon_sym_default] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_break] = ACTIONS(2418),
    [anon_sym_continue] = ACTIONS(2418),
    [anon_sym_goto] = ACTIONS(2418),
    [anon_sym___try] = ACTIONS(2418),
    [anon_sym___leave] = ACTIONS(2418),
    [anon_sym_not] = ACTIONS(2418),
    [anon_sym_compl] = ACTIONS(2418),
    [anon_sym_or] = ACTIONS(2418),
    [anon_sym_and] = ACTIONS(2418),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_sizeof] = ACTIONS(2418),
    [anon_sym___alignof__] = ACTIONS(2418),
    [anon_sym___alignof] = ACTIONS(2418),
    [anon_sym__alignof] = ACTIONS(2418),
    [anon_sym_alignof] = ACTIONS(2418),
    [anon_sym__Alignof] = ACTIONS(2418),
    [anon_sym_offsetof] = ACTIONS(2418),
    [anon_sym__Generic] = ACTIONS(2418),
    [anon_sym_asm] = ACTIONS(2418),
    [anon_sym___asm__] = ACTIONS(2418),
    [anon_sym___asm] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(2418),
    [sym_number_literal] = ACTIONS(2416),
    [anon_sym_L_SQUOTE] = ACTIONS(2416),
    [anon_sym_u_SQUOTE] = ACTIONS(2416),
    [anon_sym_U_SQUOTE] = ACTIONS(2416),
    [anon_sym_u8_SQUOTE] = ACTIONS(2416),
    [anon_sym_SQUOTE] = ACTIONS(2416),
    [anon_sym_L_DQUOTE] = ACTIONS(2416),
    [anon_sym_u_DQUOTE] = ACTIONS(2416),
    [anon_sym_U_DQUOTE] = ACTIONS(2416),
    [anon_sym_u8_DQUOTE] = ACTIONS(2416),
    [anon_sym_DQUOTE] = ACTIONS(2416),
    [sym_true] = ACTIONS(2418),
    [sym_false] = ACTIONS(2418),
    [anon_sym_NULL] = ACTIONS(2418),
    [anon_sym_nullptr] = ACTIONS(2418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_This] = ACTIONS(2418),
    [anon_sym_decltype] = ACTIONS(2418),
    [anon_sym_final] = ACTIONS(2418),
    [anon_sym_override] = ACTIONS(2418),
    [anon_sym_explicit] = ACTIONS(2418),
    [anon_sym_typename] = ACTIONS(2418),
    [anon_sym_export] = ACTIONS(2418),
    [anon_sym_module] = ACTIONS(2418),
    [anon_sym_import] = ACTIONS(2418),
    [anon_sym_template] = ACTIONS(2418),
    [anon_sym_GT2] = ACTIONS(2416),
    [anon_sym_operator] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_delete] = ACTIONS(2418),
    [anon_sym_throw] = ACTIONS(2418),
    [anon_sym_namespace] = ACTIONS(2418),
    [anon_sym_static_assert] = ACTIONS(2418),
    [anon_sym_concept] = ACTIONS(2418),
    [anon_sym_co_return] = ACTIONS(2418),
    [anon_sym_co_yield] = ACTIONS(2418),
    [anon_sym_R_DQUOTE] = ACTIONS(2416),
    [anon_sym_LR_DQUOTE] = ACTIONS(2416),
    [anon_sym_uR_DQUOTE] = ACTIONS(2416),
    [anon_sym_UR_DQUOTE] = ACTIONS(2416),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2416),
    [anon_sym_co_await] = ACTIONS(2418),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_requires] = ACTIONS(2418),
    [sym_this] = ACTIONS(2418),
    [anon_sym_discard] = ACTIONS(2418),
    [anon_sym_precise] = ACTIONS(2418),
    [anon_sym_shared] = ACTIONS(2418),
    [anon_sym_groupshared] = ACTIONS(2418),
    [anon_sym_uniform] = ACTIONS(2418),
    [anon_sym_row_major] = ACTIONS(2418),
    [anon_sym_column_major] = ACTIONS(2418),
    [anon_sym_globallycoherent] = ACTIONS(2418),
    [anon_sym_centroid] = ACTIONS(2418),
    [anon_sym_noperspective] = ACTIONS(2418),
    [anon_sym_nointerpolation] = ACTIONS(2418),
    [anon_sym_sample] = ACTIONS(2418),
    [anon_sym_linear] = ACTIONS(2418),
    [anon_sym_snorm] = ACTIONS(2418),
    [anon_sym_unorm] = ACTIONS(2418),
    [anon_sym_point] = ACTIONS(2418),
    [anon_sym_line] = ACTIONS(2418),
    [anon_sym_triangleadj] = ACTIONS(2418),
    [anon_sym_lineadj] = ACTIONS(2418),
    [anon_sym_triangle] = ACTIONS(2418),
    [anon_sym_cbuffer] = ACTIONS(2418),
    [anon_sym_interface] = ACTIONS(2418),
    [anon_sym_extension] = ACTIONS(2418),
    [anon_sym_where] = ACTIONS(2418),
    [anon_sym___exported] = ACTIONS(2418),
  },
  [205] = {
    [ts_builtin_sym_end] = ACTIONS(2420),
    [sym_identifier] = ACTIONS(2422),
    [aux_sym_preproc_include_token1] = ACTIONS(2422),
    [aux_sym_preproc_def_token1] = ACTIONS(2422),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_RPAREN] = ACTIONS(2420),
    [aux_sym_preproc_if_token1] = ACTIONS(2422),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2422),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2422),
    [sym_preproc_directive] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_PIPE_PIPE] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym_typedef] = ACTIONS(2422),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_out] = ACTIONS(2422),
    [anon_sym_inout] = ACTIONS(2422),
    [anon_sym_virtual] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_using] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2422),
    [anon_sym___based] = ACTIONS(2422),
    [anon_sym___cdecl] = ACTIONS(2422),
    [anon_sym___clrcall] = ACTIONS(2422),
    [anon_sym___stdcall] = ACTIONS(2422),
    [anon_sym___fastcall] = ACTIONS(2422),
    [anon_sym___thiscall] = ACTIONS(2422),
    [anon_sym___vectorcall] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2422),
    [anon_sym_unsigned] = ACTIONS(2422),
    [anon_sym_long] = ACTIONS(2422),
    [anon_sym_short] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_register] = ACTIONS(2422),
    [anon_sym_inline] = ACTIONS(2422),
    [anon_sym___inline] = ACTIONS(2422),
    [anon_sym___inline__] = ACTIONS(2422),
    [anon_sym___forceinline] = ACTIONS(2422),
    [anon_sym_thread_local] = ACTIONS(2422),
    [anon_sym___thread] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [sym_primitive_type] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
    [anon_sym_class] = ACTIONS(2422),
    [anon_sym_struct] = ACTIONS(2422),
    [anon_sym_union] = ACTIONS(2422),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(2422),
    [anon_sym_switch] = ACTIONS(2422),
    [anon_sym_case] = ACTIONS(2422),
    [anon_sym_default] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_break] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(2422),
    [anon_sym_goto] = ACTIONS(2422),
    [anon_sym___try] = ACTIONS(2422),
    [anon_sym___leave] = ACTIONS(2422),
    [anon_sym_not] = ACTIONS(2422),
    [anon_sym_compl] = ACTIONS(2422),
    [anon_sym_or] = ACTIONS(2422),
    [anon_sym_and] = ACTIONS(2422),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_sizeof] = ACTIONS(2422),
    [anon_sym___alignof__] = ACTIONS(2422),
    [anon_sym___alignof] = ACTIONS(2422),
    [anon_sym__alignof] = ACTIONS(2422),
    [anon_sym_alignof] = ACTIONS(2422),
    [anon_sym__Alignof] = ACTIONS(2422),
    [anon_sym_offsetof] = ACTIONS(2422),
    [anon_sym__Generic] = ACTIONS(2422),
    [anon_sym_asm] = ACTIONS(2422),
    [anon_sym___asm__] = ACTIONS(2422),
    [anon_sym___asm] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2422),
    [sym_number_literal] = ACTIONS(2420),
    [anon_sym_L_SQUOTE] = ACTIONS(2420),
    [anon_sym_u_SQUOTE] = ACTIONS(2420),
    [anon_sym_U_SQUOTE] = ACTIONS(2420),
    [anon_sym_u8_SQUOTE] = ACTIONS(2420),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [anon_sym_L_DQUOTE] = ACTIONS(2420),
    [anon_sym_u_DQUOTE] = ACTIONS(2420),
    [anon_sym_U_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [sym_true] = ACTIONS(2422),
    [sym_false] = ACTIONS(2422),
    [anon_sym_NULL] = ACTIONS(2422),
    [anon_sym_nullptr] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_decltype] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_explicit] = ACTIONS(2422),
    [anon_sym_typename] = ACTIONS(2422),
    [anon_sym_export] = ACTIONS(2422),
    [anon_sym_module] = ACTIONS(2422),
    [anon_sym_import] = ACTIONS(2422),
    [anon_sym_template] = ACTIONS(2422),
    [anon_sym_GT2] = ACTIONS(2420),
    [anon_sym_operator] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_delete] = ACTIONS(2422),
    [anon_sym_throw] = ACTIONS(2422),
    [anon_sym_namespace] = ACTIONS(2422),
    [anon_sym_static_assert] = ACTIONS(2422),
    [anon_sym_concept] = ACTIONS(2422),
    [anon_sym_co_return] = ACTIONS(2422),
    [anon_sym_co_yield] = ACTIONS(2422),
    [anon_sym_R_DQUOTE] = ACTIONS(2420),
    [anon_sym_LR_DQUOTE] = ACTIONS(2420),
    [anon_sym_uR_DQUOTE] = ACTIONS(2420),
    [anon_sym_UR_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2420),
    [anon_sym_co_await] = ACTIONS(2422),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_requires] = ACTIONS(2422),
    [sym_this] = ACTIONS(2422),
    [anon_sym_discard] = ACTIONS(2422),
    [anon_sym_precise] = ACTIONS(2422),
    [anon_sym_shared] = ACTIONS(2422),
    [anon_sym_groupshared] = ACTIONS(2422),
    [anon_sym_uniform] = ACTIONS(2422),
    [anon_sym_row_major] = ACTIONS(2422),
    [anon_sym_column_major] = ACTIONS(2422),
    [anon_sym_globallycoherent] = ACTIONS(2422),
    [anon_sym_centroid] = ACTIONS(2422),
    [anon_sym_noperspective] = ACTIONS(2422),
    [anon_sym_nointerpolation] = ACTIONS(2422),
    [anon_sym_sample] = ACTIONS(2422),
    [anon_sym_linear] = ACTIONS(2422),
    [anon_sym_snorm] = ACTIONS(2422),
    [anon_sym_unorm] = ACTIONS(2422),
    [anon_sym_point] = ACTIONS(2422),
    [anon_sym_line] = ACTIONS(2422),
    [anon_sym_triangleadj] = ACTIONS(2422),
    [anon_sym_lineadj] = ACTIONS(2422),
    [anon_sym_triangle] = ACTIONS(2422),
    [anon_sym_cbuffer] = ACTIONS(2422),
    [anon_sym_interface] = ACTIONS(2422),
    [anon_sym_extension] = ACTIONS(2422),
    [anon_sym_where] = ACTIONS(2422),
    [anon_sym___exported] = ACTIONS(2422),
  },
  [206] = {
    [ts_builtin_sym_end] = ACTIONS(2420),
    [sym_identifier] = ACTIONS(2422),
    [aux_sym_preproc_include_token1] = ACTIONS(2422),
    [aux_sym_preproc_def_token1] = ACTIONS(2422),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_RPAREN] = ACTIONS(2420),
    [aux_sym_preproc_if_token1] = ACTIONS(2422),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2422),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2422),
    [sym_preproc_directive] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_PIPE_PIPE] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym_typedef] = ACTIONS(2422),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_out] = ACTIONS(2422),
    [anon_sym_inout] = ACTIONS(2422),
    [anon_sym_virtual] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_using] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2422),
    [anon_sym___based] = ACTIONS(2422),
    [anon_sym___cdecl] = ACTIONS(2422),
    [anon_sym___clrcall] = ACTIONS(2422),
    [anon_sym___stdcall] = ACTIONS(2422),
    [anon_sym___fastcall] = ACTIONS(2422),
    [anon_sym___thiscall] = ACTIONS(2422),
    [anon_sym___vectorcall] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2422),
    [anon_sym_unsigned] = ACTIONS(2422),
    [anon_sym_long] = ACTIONS(2422),
    [anon_sym_short] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_register] = ACTIONS(2422),
    [anon_sym_inline] = ACTIONS(2422),
    [anon_sym___inline] = ACTIONS(2422),
    [anon_sym___inline__] = ACTIONS(2422),
    [anon_sym___forceinline] = ACTIONS(2422),
    [anon_sym_thread_local] = ACTIONS(2422),
    [anon_sym___thread] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [sym_primitive_type] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
    [anon_sym_class] = ACTIONS(2422),
    [anon_sym_struct] = ACTIONS(2422),
    [anon_sym_union] = ACTIONS(2422),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(2422),
    [anon_sym_switch] = ACTIONS(2422),
    [anon_sym_case] = ACTIONS(2422),
    [anon_sym_default] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_break] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(2422),
    [anon_sym_goto] = ACTIONS(2422),
    [anon_sym___try] = ACTIONS(2422),
    [anon_sym___leave] = ACTIONS(2422),
    [anon_sym_not] = ACTIONS(2422),
    [anon_sym_compl] = ACTIONS(2422),
    [anon_sym_or] = ACTIONS(2422),
    [anon_sym_and] = ACTIONS(2422),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_sizeof] = ACTIONS(2422),
    [anon_sym___alignof__] = ACTIONS(2422),
    [anon_sym___alignof] = ACTIONS(2422),
    [anon_sym__alignof] = ACTIONS(2422),
    [anon_sym_alignof] = ACTIONS(2422),
    [anon_sym__Alignof] = ACTIONS(2422),
    [anon_sym_offsetof] = ACTIONS(2422),
    [anon_sym__Generic] = ACTIONS(2422),
    [anon_sym_asm] = ACTIONS(2422),
    [anon_sym___asm__] = ACTIONS(2422),
    [anon_sym___asm] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2422),
    [sym_number_literal] = ACTIONS(2420),
    [anon_sym_L_SQUOTE] = ACTIONS(2420),
    [anon_sym_u_SQUOTE] = ACTIONS(2420),
    [anon_sym_U_SQUOTE] = ACTIONS(2420),
    [anon_sym_u8_SQUOTE] = ACTIONS(2420),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [anon_sym_L_DQUOTE] = ACTIONS(2420),
    [anon_sym_u_DQUOTE] = ACTIONS(2420),
    [anon_sym_U_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [sym_true] = ACTIONS(2422),
    [sym_false] = ACTIONS(2422),
    [anon_sym_NULL] = ACTIONS(2422),
    [anon_sym_nullptr] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_decltype] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_explicit] = ACTIONS(2422),
    [anon_sym_typename] = ACTIONS(2422),
    [anon_sym_export] = ACTIONS(2422),
    [anon_sym_module] = ACTIONS(2422),
    [anon_sym_import] = ACTIONS(2422),
    [anon_sym_template] = ACTIONS(2422),
    [anon_sym_GT2] = ACTIONS(2420),
    [anon_sym_operator] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_delete] = ACTIONS(2422),
    [anon_sym_throw] = ACTIONS(2422),
    [anon_sym_namespace] = ACTIONS(2422),
    [anon_sym_static_assert] = ACTIONS(2422),
    [anon_sym_concept] = ACTIONS(2422),
    [anon_sym_co_return] = ACTIONS(2422),
    [anon_sym_co_yield] = ACTIONS(2422),
    [anon_sym_R_DQUOTE] = ACTIONS(2420),
    [anon_sym_LR_DQUOTE] = ACTIONS(2420),
    [anon_sym_uR_DQUOTE] = ACTIONS(2420),
    [anon_sym_UR_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2420),
    [anon_sym_co_await] = ACTIONS(2422),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_requires] = ACTIONS(2422),
    [sym_this] = ACTIONS(2422),
    [anon_sym_discard] = ACTIONS(2422),
    [anon_sym_precise] = ACTIONS(2422),
    [anon_sym_shared] = ACTIONS(2422),
    [anon_sym_groupshared] = ACTIONS(2422),
    [anon_sym_uniform] = ACTIONS(2422),
    [anon_sym_row_major] = ACTIONS(2422),
    [anon_sym_column_major] = ACTIONS(2422),
    [anon_sym_globallycoherent] = ACTIONS(2422),
    [anon_sym_centroid] = ACTIONS(2422),
    [anon_sym_noperspective] = ACTIONS(2422),
    [anon_sym_nointerpolation] = ACTIONS(2422),
    [anon_sym_sample] = ACTIONS(2422),
    [anon_sym_linear] = ACTIONS(2422),
    [anon_sym_snorm] = ACTIONS(2422),
    [anon_sym_unorm] = ACTIONS(2422),
    [anon_sym_point] = ACTIONS(2422),
    [anon_sym_line] = ACTIONS(2422),
    [anon_sym_triangleadj] = ACTIONS(2422),
    [anon_sym_lineadj] = ACTIONS(2422),
    [anon_sym_triangle] = ACTIONS(2422),
    [anon_sym_cbuffer] = ACTIONS(2422),
    [anon_sym_interface] = ACTIONS(2422),
    [anon_sym_extension] = ACTIONS(2422),
    [anon_sym_where] = ACTIONS(2422),
    [anon_sym___exported] = ACTIONS(2422),
  },
  [207] = {
    [ts_builtin_sym_end] = ACTIONS(2426),
    [sym_identifier] = ACTIONS(2428),
    [aux_sym_preproc_include_token1] = ACTIONS(2428),
    [aux_sym_preproc_def_token1] = ACTIONS(2428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2426),
    [anon_sym_COMMA] = ACTIONS(2426),
    [anon_sym_RPAREN] = ACTIONS(2426),
    [aux_sym_preproc_if_token1] = ACTIONS(2428),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2428),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2428),
    [sym_preproc_directive] = ACTIONS(2428),
    [anon_sym_LPAREN2] = ACTIONS(2426),
    [anon_sym_BANG] = ACTIONS(2426),
    [anon_sym_TILDE] = ACTIONS(2426),
    [anon_sym_DASH] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2428),
    [anon_sym_STAR] = ACTIONS(2426),
    [anon_sym_PIPE_PIPE] = ACTIONS(2426),
    [anon_sym_AMP_AMP] = ACTIONS(2426),
    [anon_sym_AMP] = ACTIONS(2428),
    [anon_sym_COLON] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2426),
    [anon_sym___extension__] = ACTIONS(2428),
    [anon_sym_typedef] = ACTIONS(2428),
    [anon_sym_in] = ACTIONS(2428),
    [anon_sym_out] = ACTIONS(2428),
    [anon_sym_inout] = ACTIONS(2428),
    [anon_sym_virtual] = ACTIONS(2428),
    [anon_sym_extern] = ACTIONS(2428),
    [anon_sym___attribute__] = ACTIONS(2428),
    [anon_sym___attribute] = ACTIONS(2428),
    [anon_sym_using] = ACTIONS(2428),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2426),
    [anon_sym___declspec] = ACTIONS(2428),
    [anon_sym___based] = ACTIONS(2428),
    [anon_sym___cdecl] = ACTIONS(2428),
    [anon_sym___clrcall] = ACTIONS(2428),
    [anon_sym___stdcall] = ACTIONS(2428),
    [anon_sym___fastcall] = ACTIONS(2428),
    [anon_sym___thiscall] = ACTIONS(2428),
    [anon_sym___vectorcall] = ACTIONS(2428),
    [anon_sym_LBRACE] = ACTIONS(2426),
    [anon_sym_signed] = ACTIONS(2428),
    [anon_sym_unsigned] = ACTIONS(2428),
    [anon_sym_long] = ACTIONS(2428),
    [anon_sym_short] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_static] = ACTIONS(2428),
    [anon_sym_EQ] = ACTIONS(2426),
    [anon_sym_register] = ACTIONS(2428),
    [anon_sym_inline] = ACTIONS(2428),
    [anon_sym___inline] = ACTIONS(2428),
    [anon_sym___inline__] = ACTIONS(2428),
    [anon_sym___forceinline] = ACTIONS(2428),
    [anon_sym_thread_local] = ACTIONS(2428),
    [anon_sym___thread] = ACTIONS(2428),
    [anon_sym_const] = ACTIONS(2428),
    [anon_sym_constexpr] = ACTIONS(2428),
    [anon_sym_volatile] = ACTIONS(2428),
    [anon_sym_restrict] = ACTIONS(2428),
    [anon_sym___restrict__] = ACTIONS(2428),
    [anon_sym__Atomic] = ACTIONS(2428),
    [anon_sym__Noreturn] = ACTIONS(2428),
    [anon_sym_noreturn] = ACTIONS(2428),
    [anon_sym__Nonnull] = ACTIONS(2428),
    [anon_sym_mutable] = ACTIONS(2428),
    [anon_sym_constinit] = ACTIONS(2428),
    [anon_sym_consteval] = ACTIONS(2428),
    [anon_sym_alignas] = ACTIONS(2428),
    [anon_sym__Alignas] = ACTIONS(2428),
    [sym_primitive_type] = ACTIONS(2428),
    [anon_sym_enum] = ACTIONS(2428),
    [anon_sym_class] = ACTIONS(2428),
    [anon_sym_struct] = ACTIONS(2428),
    [anon_sym_union] = ACTIONS(2428),
    [anon_sym_if] = ACTIONS(2428),
    [anon_sym_else] = ACTIONS(2428),
    [anon_sym_switch] = ACTIONS(2428),
    [anon_sym_case] = ACTIONS(2428),
    [anon_sym_default] = ACTIONS(2428),
    [anon_sym_while] = ACTIONS(2428),
    [anon_sym_do] = ACTIONS(2428),
    [anon_sym_for] = ACTIONS(2428),
    [anon_sym_return] = ACTIONS(2428),
    [anon_sym_break] = ACTIONS(2428),
    [anon_sym_continue] = ACTIONS(2428),
    [anon_sym_goto] = ACTIONS(2428),
    [anon_sym___try] = ACTIONS(2428),
    [anon_sym___leave] = ACTIONS(2428),
    [anon_sym_not] = ACTIONS(2428),
    [anon_sym_compl] = ACTIONS(2428),
    [anon_sym_or] = ACTIONS(2428),
    [anon_sym_and] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2426),
    [anon_sym_PLUS_PLUS] = ACTIONS(2426),
    [anon_sym_sizeof] = ACTIONS(2428),
    [anon_sym___alignof__] = ACTIONS(2428),
    [anon_sym___alignof] = ACTIONS(2428),
    [anon_sym__alignof] = ACTIONS(2428),
    [anon_sym_alignof] = ACTIONS(2428),
    [anon_sym__Alignof] = ACTIONS(2428),
    [anon_sym_offsetof] = ACTIONS(2428),
    [anon_sym__Generic] = ACTIONS(2428),
    [anon_sym_asm] = ACTIONS(2428),
    [anon_sym___asm__] = ACTIONS(2428),
    [anon_sym___asm] = ACTIONS(2428),
    [anon_sym_DOT] = ACTIONS(2428),
    [sym_number_literal] = ACTIONS(2426),
    [anon_sym_L_SQUOTE] = ACTIONS(2426),
    [anon_sym_u_SQUOTE] = ACTIONS(2426),
    [anon_sym_U_SQUOTE] = ACTIONS(2426),
    [anon_sym_u8_SQUOTE] = ACTIONS(2426),
    [anon_sym_SQUOTE] = ACTIONS(2426),
    [anon_sym_L_DQUOTE] = ACTIONS(2426),
    [anon_sym_u_DQUOTE] = ACTIONS(2426),
    [anon_sym_U_DQUOTE] = ACTIONS(2426),
    [anon_sym_u8_DQUOTE] = ACTIONS(2426),
    [anon_sym_DQUOTE] = ACTIONS(2426),
    [sym_true] = ACTIONS(2428),
    [sym_false] = ACTIONS(2428),
    [anon_sym_NULL] = ACTIONS(2428),
    [anon_sym_nullptr] = ACTIONS(2428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2428),
    [anon_sym_let] = ACTIONS(2428),
    [anon_sym_This] = ACTIONS(2428),
    [anon_sym_decltype] = ACTIONS(2428),
    [anon_sym_final] = ACTIONS(2428),
    [anon_sym_override] = ACTIONS(2428),
    [anon_sym_explicit] = ACTIONS(2428),
    [anon_sym_typename] = ACTIONS(2428),
    [anon_sym_export] = ACTIONS(2428),
    [anon_sym_module] = ACTIONS(2428),
    [anon_sym_import] = ACTIONS(2428),
    [anon_sym_template] = ACTIONS(2428),
    [anon_sym_GT2] = ACTIONS(2426),
    [anon_sym_operator] = ACTIONS(2428),
    [anon_sym_try] = ACTIONS(2428),
    [anon_sym_delete] = ACTIONS(2428),
    [anon_sym_throw] = ACTIONS(2428),
    [anon_sym_namespace] = ACTIONS(2428),
    [anon_sym_static_assert] = ACTIONS(2428),
    [anon_sym_concept] = ACTIONS(2428),
    [anon_sym_co_return] = ACTIONS(2428),
    [anon_sym_co_yield] = ACTIONS(2428),
    [anon_sym_R_DQUOTE] = ACTIONS(2426),
    [anon_sym_LR_DQUOTE] = ACTIONS(2426),
    [anon_sym_uR_DQUOTE] = ACTIONS(2426),
    [anon_sym_UR_DQUOTE] = ACTIONS(2426),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2426),
    [anon_sym_co_await] = ACTIONS(2428),
    [anon_sym_new] = ACTIONS(2428),
    [anon_sym_requires] = ACTIONS(2428),
    [sym_this] = ACTIONS(2428),
    [anon_sym_discard] = ACTIONS(2428),
    [anon_sym_precise] = ACTIONS(2428),
    [anon_sym_shared] = ACTIONS(2428),
    [anon_sym_groupshared] = ACTIONS(2428),
    [anon_sym_uniform] = ACTIONS(2428),
    [anon_sym_row_major] = ACTIONS(2428),
    [anon_sym_column_major] = ACTIONS(2428),
    [anon_sym_globallycoherent] = ACTIONS(2428),
    [anon_sym_centroid] = ACTIONS(2428),
    [anon_sym_noperspective] = ACTIONS(2428),
    [anon_sym_nointerpolation] = ACTIONS(2428),
    [anon_sym_sample] = ACTIONS(2428),
    [anon_sym_linear] = ACTIONS(2428),
    [anon_sym_snorm] = ACTIONS(2428),
    [anon_sym_unorm] = ACTIONS(2428),
    [anon_sym_point] = ACTIONS(2428),
    [anon_sym_line] = ACTIONS(2428),
    [anon_sym_triangleadj] = ACTIONS(2428),
    [anon_sym_lineadj] = ACTIONS(2428),
    [anon_sym_triangle] = ACTIONS(2428),
    [anon_sym_cbuffer] = ACTIONS(2428),
    [anon_sym_interface] = ACTIONS(2428),
    [anon_sym_extension] = ACTIONS(2428),
    [anon_sym_where] = ACTIONS(2428),
    [anon_sym___exported] = ACTIONS(2428),
  },
  [208] = {
    [ts_builtin_sym_end] = ACTIONS(2290),
    [sym_identifier] = ACTIONS(2288),
    [aux_sym_preproc_include_token1] = ACTIONS(2288),
    [aux_sym_preproc_def_token1] = ACTIONS(2288),
    [anon_sym_COMMA] = ACTIONS(2290),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [aux_sym_preproc_if_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_COLON] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_out] = ACTIONS(2288),
    [anon_sym_inout] = ACTIONS(2288),
    [anon_sym_virtual] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym___cdecl] = ACTIONS(2288),
    [anon_sym___clrcall] = ACTIONS(2288),
    [anon_sym___stdcall] = ACTIONS(2288),
    [anon_sym___fastcall] = ACTIONS(2288),
    [anon_sym___thiscall] = ACTIONS(2288),
    [anon_sym___vectorcall] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_signed] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_EQ] = ACTIONS(2290),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym___try] = ACTIONS(2288),
    [anon_sym___leave] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2288),
    [anon_sym_compl] = ACTIONS(2288),
    [anon_sym_or] = ACTIONS(2288),
    [anon_sym_and] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_sizeof] = ACTIONS(2288),
    [anon_sym___alignof__] = ACTIONS(2288),
    [anon_sym___alignof] = ACTIONS(2288),
    [anon_sym__alignof] = ACTIONS(2288),
    [anon_sym_alignof] = ACTIONS(2288),
    [anon_sym__Alignof] = ACTIONS(2288),
    [anon_sym_offsetof] = ACTIONS(2288),
    [anon_sym__Generic] = ACTIONS(2288),
    [anon_sym_asm] = ACTIONS(2288),
    [anon_sym___asm__] = ACTIONS(2288),
    [anon_sym___asm] = ACTIONS(2288),
    [anon_sym_DOT] = ACTIONS(2288),
    [sym_number_literal] = ACTIONS(2290),
    [anon_sym_L_SQUOTE] = ACTIONS(2290),
    [anon_sym_u_SQUOTE] = ACTIONS(2290),
    [anon_sym_U_SQUOTE] = ACTIONS(2290),
    [anon_sym_u8_SQUOTE] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [anon_sym_L_DQUOTE] = ACTIONS(2290),
    [anon_sym_u_DQUOTE] = ACTIONS(2290),
    [anon_sym_U_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8_DQUOTE] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [anon_sym_NULL] = ACTIONS(2288),
    [anon_sym_nullptr] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_This] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [anon_sym_final] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_GT2] = ACTIONS(2290),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_static_assert] = ACTIONS(2288),
    [anon_sym_concept] = ACTIONS(2288),
    [anon_sym_co_return] = ACTIONS(2288),
    [anon_sym_co_yield] = ACTIONS(2288),
    [anon_sym_R_DQUOTE] = ACTIONS(2290),
    [anon_sym_LR_DQUOTE] = ACTIONS(2290),
    [anon_sym_uR_DQUOTE] = ACTIONS(2290),
    [anon_sym_UR_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2290),
    [anon_sym_co_await] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_requires] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [anon_sym_discard] = ACTIONS(2288),
    [anon_sym_precise] = ACTIONS(2288),
    [anon_sym_shared] = ACTIONS(2288),
    [anon_sym_groupshared] = ACTIONS(2288),
    [anon_sym_uniform] = ACTIONS(2288),
    [anon_sym_row_major] = ACTIONS(2288),
    [anon_sym_column_major] = ACTIONS(2288),
    [anon_sym_globallycoherent] = ACTIONS(2288),
    [anon_sym_centroid] = ACTIONS(2288),
    [anon_sym_noperspective] = ACTIONS(2288),
    [anon_sym_nointerpolation] = ACTIONS(2288),
    [anon_sym_sample] = ACTIONS(2288),
    [anon_sym_linear] = ACTIONS(2288),
    [anon_sym_snorm] = ACTIONS(2288),
    [anon_sym_unorm] = ACTIONS(2288),
    [anon_sym_point] = ACTIONS(2288),
    [anon_sym_line] = ACTIONS(2288),
    [anon_sym_triangleadj] = ACTIONS(2288),
    [anon_sym_lineadj] = ACTIONS(2288),
    [anon_sym_triangle] = ACTIONS(2288),
    [anon_sym_cbuffer] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_extension] = ACTIONS(2288),
    [anon_sym_where] = ACTIONS(2288),
    [anon_sym___exported] = ACTIONS(2288),
  },
  [209] = {
    [ts_builtin_sym_end] = ACTIONS(2266),
    [sym_identifier] = ACTIONS(2264),
    [aux_sym_preproc_include_token1] = ACTIONS(2264),
    [aux_sym_preproc_def_token1] = ACTIONS(2264),
    [anon_sym_COMMA] = ACTIONS(2266),
    [anon_sym_RPAREN] = ACTIONS(2266),
    [aux_sym_preproc_if_token1] = ACTIONS(2264),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2264),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2264),
    [sym_preproc_directive] = ACTIONS(2264),
    [anon_sym_LPAREN2] = ACTIONS(2266),
    [anon_sym_BANG] = ACTIONS(2266),
    [anon_sym_TILDE] = ACTIONS(2266),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2266),
    [anon_sym_PIPE_PIPE] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2266),
    [anon_sym_AMP] = ACTIONS(2264),
    [anon_sym_COLON] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2266),
    [anon_sym___extension__] = ACTIONS(2264),
    [anon_sym_typedef] = ACTIONS(2264),
    [anon_sym_in] = ACTIONS(2264),
    [anon_sym_out] = ACTIONS(2264),
    [anon_sym_inout] = ACTIONS(2264),
    [anon_sym_virtual] = ACTIONS(2264),
    [anon_sym_extern] = ACTIONS(2264),
    [anon_sym___attribute__] = ACTIONS(2264),
    [anon_sym___attribute] = ACTIONS(2264),
    [anon_sym_using] = ACTIONS(2264),
    [anon_sym_COLON_COLON] = ACTIONS(2266),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2266),
    [anon_sym___declspec] = ACTIONS(2264),
    [anon_sym___based] = ACTIONS(2264),
    [anon_sym___cdecl] = ACTIONS(2264),
    [anon_sym___clrcall] = ACTIONS(2264),
    [anon_sym___stdcall] = ACTIONS(2264),
    [anon_sym___fastcall] = ACTIONS(2264),
    [anon_sym___thiscall] = ACTIONS(2264),
    [anon_sym___vectorcall] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_signed] = ACTIONS(2264),
    [anon_sym_unsigned] = ACTIONS(2264),
    [anon_sym_long] = ACTIONS(2264),
    [anon_sym_short] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_EQ] = ACTIONS(2266),
    [anon_sym_register] = ACTIONS(2264),
    [anon_sym_inline] = ACTIONS(2264),
    [anon_sym___inline] = ACTIONS(2264),
    [anon_sym___inline__] = ACTIONS(2264),
    [anon_sym___forceinline] = ACTIONS(2264),
    [anon_sym_thread_local] = ACTIONS(2264),
    [anon_sym___thread] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_constexpr] = ACTIONS(2264),
    [anon_sym_volatile] = ACTIONS(2264),
    [anon_sym_restrict] = ACTIONS(2264),
    [anon_sym___restrict__] = ACTIONS(2264),
    [anon_sym__Atomic] = ACTIONS(2264),
    [anon_sym__Noreturn] = ACTIONS(2264),
    [anon_sym_noreturn] = ACTIONS(2264),
    [anon_sym__Nonnull] = ACTIONS(2264),
    [anon_sym_mutable] = ACTIONS(2264),
    [anon_sym_constinit] = ACTIONS(2264),
    [anon_sym_consteval] = ACTIONS(2264),
    [anon_sym_alignas] = ACTIONS(2264),
    [anon_sym__Alignas] = ACTIONS(2264),
    [sym_primitive_type] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
    [anon_sym_class] = ACTIONS(2264),
    [anon_sym_struct] = ACTIONS(2264),
    [anon_sym_union] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_else] = ACTIONS(2264),
    [anon_sym_switch] = ACTIONS(2264),
    [anon_sym_case] = ACTIONS(2264),
    [anon_sym_default] = ACTIONS(2264),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_do] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_goto] = ACTIONS(2264),
    [anon_sym___try] = ACTIONS(2264),
    [anon_sym___leave] = ACTIONS(2264),
    [anon_sym_not] = ACTIONS(2264),
    [anon_sym_compl] = ACTIONS(2264),
    [anon_sym_or] = ACTIONS(2264),
    [anon_sym_and] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2266),
    [anon_sym_PLUS_PLUS] = ACTIONS(2266),
    [anon_sym_sizeof] = ACTIONS(2264),
    [anon_sym___alignof__] = ACTIONS(2264),
    [anon_sym___alignof] = ACTIONS(2264),
    [anon_sym__alignof] = ACTIONS(2264),
    [anon_sym_alignof] = ACTIONS(2264),
    [anon_sym__Alignof] = ACTIONS(2264),
    [anon_sym_offsetof] = ACTIONS(2264),
    [anon_sym__Generic] = ACTIONS(2264),
    [anon_sym_asm] = ACTIONS(2264),
    [anon_sym___asm__] = ACTIONS(2264),
    [anon_sym___asm] = ACTIONS(2264),
    [anon_sym_DOT] = ACTIONS(2264),
    [sym_number_literal] = ACTIONS(2266),
    [anon_sym_L_SQUOTE] = ACTIONS(2266),
    [anon_sym_u_SQUOTE] = ACTIONS(2266),
    [anon_sym_U_SQUOTE] = ACTIONS(2266),
    [anon_sym_u8_SQUOTE] = ACTIONS(2266),
    [anon_sym_SQUOTE] = ACTIONS(2266),
    [anon_sym_L_DQUOTE] = ACTIONS(2266),
    [anon_sym_u_DQUOTE] = ACTIONS(2266),
    [anon_sym_U_DQUOTE] = ACTIONS(2266),
    [anon_sym_u8_DQUOTE] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(2266),
    [sym_true] = ACTIONS(2264),
    [sym_false] = ACTIONS(2264),
    [anon_sym_NULL] = ACTIONS(2264),
    [anon_sym_nullptr] = ACTIONS(2264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_This] = ACTIONS(2264),
    [anon_sym_decltype] = ACTIONS(2264),
    [anon_sym_final] = ACTIONS(2264),
    [anon_sym_override] = ACTIONS(2264),
    [anon_sym_explicit] = ACTIONS(2264),
    [anon_sym_typename] = ACTIONS(2264),
    [anon_sym_export] = ACTIONS(2264),
    [anon_sym_module] = ACTIONS(2264),
    [anon_sym_import] = ACTIONS(2264),
    [anon_sym_template] = ACTIONS(2264),
    [anon_sym_GT2] = ACTIONS(2266),
    [anon_sym_operator] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [anon_sym_delete] = ACTIONS(2264),
    [anon_sym_throw] = ACTIONS(2264),
    [anon_sym_namespace] = ACTIONS(2264),
    [anon_sym_static_assert] = ACTIONS(2264),
    [anon_sym_concept] = ACTIONS(2264),
    [anon_sym_co_return] = ACTIONS(2264),
    [anon_sym_co_yield] = ACTIONS(2264),
    [anon_sym_R_DQUOTE] = ACTIONS(2266),
    [anon_sym_LR_DQUOTE] = ACTIONS(2266),
    [anon_sym_uR_DQUOTE] = ACTIONS(2266),
    [anon_sym_UR_DQUOTE] = ACTIONS(2266),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2266),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2264),
    [anon_sym_requires] = ACTIONS(2264),
    [sym_this] = ACTIONS(2264),
    [anon_sym_discard] = ACTIONS(2264),
    [anon_sym_precise] = ACTIONS(2264),
    [anon_sym_shared] = ACTIONS(2264),
    [anon_sym_groupshared] = ACTIONS(2264),
    [anon_sym_uniform] = ACTIONS(2264),
    [anon_sym_row_major] = ACTIONS(2264),
    [anon_sym_column_major] = ACTIONS(2264),
    [anon_sym_globallycoherent] = ACTIONS(2264),
    [anon_sym_centroid] = ACTIONS(2264),
    [anon_sym_noperspective] = ACTIONS(2264),
    [anon_sym_nointerpolation] = ACTIONS(2264),
    [anon_sym_sample] = ACTIONS(2264),
    [anon_sym_linear] = ACTIONS(2264),
    [anon_sym_snorm] = ACTIONS(2264),
    [anon_sym_unorm] = ACTIONS(2264),
    [anon_sym_point] = ACTIONS(2264),
    [anon_sym_line] = ACTIONS(2264),
    [anon_sym_triangleadj] = ACTIONS(2264),
    [anon_sym_lineadj] = ACTIONS(2264),
    [anon_sym_triangle] = ACTIONS(2264),
    [anon_sym_cbuffer] = ACTIONS(2264),
    [anon_sym_interface] = ACTIONS(2264),
    [anon_sym_extension] = ACTIONS(2264),
    [anon_sym_where] = ACTIONS(2264),
    [anon_sym___exported] = ACTIONS(2264),
  },
  [210] = {
    [ts_builtin_sym_end] = ACTIONS(2250),
    [sym_identifier] = ACTIONS(2243),
    [aux_sym_preproc_include_token1] = ACTIONS(2243),
    [aux_sym_preproc_def_token1] = ACTIONS(2243),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_RPAREN] = ACTIONS(2250),
    [aux_sym_preproc_if_token1] = ACTIONS(2243),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2243),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2243),
    [sym_preproc_directive] = ACTIONS(2243),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2243),
    [anon_sym_PLUS] = ACTIONS(2243),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_COLON] = ACTIONS(2243),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym_typedef] = ACTIONS(2243),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_out] = ACTIONS(2243),
    [anon_sym_inout] = ACTIONS(2243),
    [anon_sym_virtual] = ACTIONS(2243),
    [anon_sym_extern] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym___attribute] = ACTIONS(2243),
    [anon_sym_using] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2243),
    [anon_sym___based] = ACTIONS(2243),
    [anon_sym___cdecl] = ACTIONS(2243),
    [anon_sym___clrcall] = ACTIONS(2243),
    [anon_sym___stdcall] = ACTIONS(2243),
    [anon_sym___fastcall] = ACTIONS(2243),
    [anon_sym___thiscall] = ACTIONS(2243),
    [anon_sym___vectorcall] = ACTIONS(2243),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_signed] = ACTIONS(2243),
    [anon_sym_unsigned] = ACTIONS(2243),
    [anon_sym_long] = ACTIONS(2243),
    [anon_sym_short] = ACTIONS(2243),
    [anon_sym_LBRACK] = ACTIONS(2243),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_EQ] = ACTIONS(2250),
    [anon_sym_register] = ACTIONS(2243),
    [anon_sym_inline] = ACTIONS(2243),
    [anon_sym___inline] = ACTIONS(2243),
    [anon_sym___inline__] = ACTIONS(2243),
    [anon_sym___forceinline] = ACTIONS(2243),
    [anon_sym_thread_local] = ACTIONS(2243),
    [anon_sym___thread] = ACTIONS(2243),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym__Nonnull] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [sym_primitive_type] = ACTIONS(2243),
    [anon_sym_enum] = ACTIONS(2243),
    [anon_sym_class] = ACTIONS(2243),
    [anon_sym_struct] = ACTIONS(2243),
    [anon_sym_union] = ACTIONS(2243),
    [anon_sym_if] = ACTIONS(2243),
    [anon_sym_else] = ACTIONS(2243),
    [anon_sym_switch] = ACTIONS(2243),
    [anon_sym_case] = ACTIONS(2243),
    [anon_sym_default] = ACTIONS(2243),
    [anon_sym_while] = ACTIONS(2243),
    [anon_sym_do] = ACTIONS(2243),
    [anon_sym_for] = ACTIONS(2243),
    [anon_sym_return] = ACTIONS(2243),
    [anon_sym_break] = ACTIONS(2243),
    [anon_sym_continue] = ACTIONS(2243),
    [anon_sym_goto] = ACTIONS(2243),
    [anon_sym___try] = ACTIONS(2243),
    [anon_sym___leave] = ACTIONS(2243),
    [anon_sym_not] = ACTIONS(2243),
    [anon_sym_compl] = ACTIONS(2243),
    [anon_sym_or] = ACTIONS(2243),
    [anon_sym_and] = ACTIONS(2243),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_sizeof] = ACTIONS(2243),
    [anon_sym___alignof__] = ACTIONS(2243),
    [anon_sym___alignof] = ACTIONS(2243),
    [anon_sym__alignof] = ACTIONS(2243),
    [anon_sym_alignof] = ACTIONS(2243),
    [anon_sym__Alignof] = ACTIONS(2243),
    [anon_sym_offsetof] = ACTIONS(2243),
    [anon_sym__Generic] = ACTIONS(2243),
    [anon_sym_asm] = ACTIONS(2243),
    [anon_sym___asm__] = ACTIONS(2243),
    [anon_sym___asm] = ACTIONS(2243),
    [anon_sym_DOT] = ACTIONS(2243),
    [sym_number_literal] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2250),
    [anon_sym_u_SQUOTE] = ACTIONS(2250),
    [anon_sym_U_SQUOTE] = ACTIONS(2250),
    [anon_sym_u8_SQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_L_DQUOTE] = ACTIONS(2250),
    [anon_sym_u_DQUOTE] = ACTIONS(2250),
    [anon_sym_U_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [sym_true] = ACTIONS(2243),
    [sym_false] = ACTIONS(2243),
    [anon_sym_NULL] = ACTIONS(2243),
    [anon_sym_nullptr] = ACTIONS(2243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2243),
    [anon_sym_let] = ACTIONS(2243),
    [anon_sym_This] = ACTIONS(2243),
    [anon_sym_decltype] = ACTIONS(2243),
    [anon_sym_final] = ACTIONS(2243),
    [anon_sym_override] = ACTIONS(2243),
    [anon_sym_explicit] = ACTIONS(2243),
    [anon_sym_typename] = ACTIONS(2243),
    [anon_sym_export] = ACTIONS(2243),
    [anon_sym_module] = ACTIONS(2243),
    [anon_sym_import] = ACTIONS(2243),
    [anon_sym_template] = ACTIONS(2243),
    [anon_sym_GT2] = ACTIONS(2250),
    [anon_sym_operator] = ACTIONS(2243),
    [anon_sym_try] = ACTIONS(2243),
    [anon_sym_delete] = ACTIONS(2243),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_namespace] = ACTIONS(2243),
    [anon_sym_static_assert] = ACTIONS(2243),
    [anon_sym_concept] = ACTIONS(2243),
    [anon_sym_co_return] = ACTIONS(2243),
    [anon_sym_co_yield] = ACTIONS(2243),
    [anon_sym_R_DQUOTE] = ACTIONS(2250),
    [anon_sym_LR_DQUOTE] = ACTIONS(2250),
    [anon_sym_uR_DQUOTE] = ACTIONS(2250),
    [anon_sym_UR_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2250),
    [anon_sym_co_await] = ACTIONS(2243),
    [anon_sym_new] = ACTIONS(2243),
    [anon_sym_requires] = ACTIONS(2243),
    [sym_this] = ACTIONS(2243),
    [anon_sym_discard] = ACTIONS(2243),
    [anon_sym_precise] = ACTIONS(2243),
    [anon_sym_shared] = ACTIONS(2243),
    [anon_sym_groupshared] = ACTIONS(2243),
    [anon_sym_uniform] = ACTIONS(2243),
    [anon_sym_row_major] = ACTIONS(2243),
    [anon_sym_column_major] = ACTIONS(2243),
    [anon_sym_globallycoherent] = ACTIONS(2243),
    [anon_sym_centroid] = ACTIONS(2243),
    [anon_sym_noperspective] = ACTIONS(2243),
    [anon_sym_nointerpolation] = ACTIONS(2243),
    [anon_sym_sample] = ACTIONS(2243),
    [anon_sym_linear] = ACTIONS(2243),
    [anon_sym_snorm] = ACTIONS(2243),
    [anon_sym_unorm] = ACTIONS(2243),
    [anon_sym_point] = ACTIONS(2243),
    [anon_sym_line] = ACTIONS(2243),
    [anon_sym_triangleadj] = ACTIONS(2243),
    [anon_sym_lineadj] = ACTIONS(2243),
    [anon_sym_triangle] = ACTIONS(2243),
    [anon_sym_cbuffer] = ACTIONS(2243),
    [anon_sym_interface] = ACTIONS(2243),
    [anon_sym_extension] = ACTIONS(2243),
    [anon_sym_where] = ACTIONS(2243),
    [anon_sym___exported] = ACTIONS(2243),
  },
  [211] = {
    [ts_builtin_sym_end] = ACTIONS(2306),
    [sym_identifier] = ACTIONS(2304),
    [aux_sym_preproc_include_token1] = ACTIONS(2304),
    [aux_sym_preproc_def_token1] = ACTIONS(2304),
    [anon_sym_COMMA] = ACTIONS(2306),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2304),
    [sym_preproc_directive] = ACTIONS(2304),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_BANG] = ACTIONS(2306),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_COLON] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2306),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym_typedef] = ACTIONS(2304),
    [anon_sym_in] = ACTIONS(2304),
    [anon_sym_out] = ACTIONS(2304),
    [anon_sym_inout] = ACTIONS(2304),
    [anon_sym_virtual] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym___attribute] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2306),
    [anon_sym___declspec] = ACTIONS(2304),
    [anon_sym___based] = ACTIONS(2304),
    [anon_sym___cdecl] = ACTIONS(2304),
    [anon_sym___clrcall] = ACTIONS(2304),
    [anon_sym___stdcall] = ACTIONS(2304),
    [anon_sym___fastcall] = ACTIONS(2304),
    [anon_sym___thiscall] = ACTIONS(2304),
    [anon_sym___vectorcall] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_signed] = ACTIONS(2304),
    [anon_sym_unsigned] = ACTIONS(2304),
    [anon_sym_long] = ACTIONS(2304),
    [anon_sym_short] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_EQ] = ACTIONS(2306),
    [anon_sym_register] = ACTIONS(2304),
    [anon_sym_inline] = ACTIONS(2304),
    [anon_sym___inline] = ACTIONS(2304),
    [anon_sym___inline__] = ACTIONS(2304),
    [anon_sym___forceinline] = ACTIONS(2304),
    [anon_sym_thread_local] = ACTIONS(2304),
    [anon_sym___thread] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym__Nonnull] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [sym_primitive_type] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_struct] = ACTIONS(2304),
    [anon_sym_union] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_else] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_case] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_goto] = ACTIONS(2304),
    [anon_sym___try] = ACTIONS(2304),
    [anon_sym___leave] = ACTIONS(2304),
    [anon_sym_not] = ACTIONS(2304),
    [anon_sym_compl] = ACTIONS(2304),
    [anon_sym_or] = ACTIONS(2304),
    [anon_sym_and] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_sizeof] = ACTIONS(2304),
    [anon_sym___alignof__] = ACTIONS(2304),
    [anon_sym___alignof] = ACTIONS(2304),
    [anon_sym__alignof] = ACTIONS(2304),
    [anon_sym_alignof] = ACTIONS(2304),
    [anon_sym__Alignof] = ACTIONS(2304),
    [anon_sym_offsetof] = ACTIONS(2304),
    [anon_sym__Generic] = ACTIONS(2304),
    [anon_sym_asm] = ACTIONS(2304),
    [anon_sym___asm__] = ACTIONS(2304),
    [anon_sym___asm] = ACTIONS(2304),
    [anon_sym_DOT] = ACTIONS(2304),
    [sym_number_literal] = ACTIONS(2306),
    [anon_sym_L_SQUOTE] = ACTIONS(2306),
    [anon_sym_u_SQUOTE] = ACTIONS(2306),
    [anon_sym_U_SQUOTE] = ACTIONS(2306),
    [anon_sym_u8_SQUOTE] = ACTIONS(2306),
    [anon_sym_SQUOTE] = ACTIONS(2306),
    [anon_sym_L_DQUOTE] = ACTIONS(2306),
    [anon_sym_u_DQUOTE] = ACTIONS(2306),
    [anon_sym_U_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8_DQUOTE] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [anon_sym_NULL] = ACTIONS(2304),
    [anon_sym_nullptr] = ACTIONS(2304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_This] = ACTIONS(2304),
    [anon_sym_decltype] = ACTIONS(2304),
    [anon_sym_final] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_explicit] = ACTIONS(2304),
    [anon_sym_typename] = ACTIONS(2304),
    [anon_sym_export] = ACTIONS(2304),
    [anon_sym_module] = ACTIONS(2304),
    [anon_sym_import] = ACTIONS(2304),
    [anon_sym_template] = ACTIONS(2304),
    [anon_sym_GT2] = ACTIONS(2306),
    [anon_sym_operator] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_static_assert] = ACTIONS(2304),
    [anon_sym_concept] = ACTIONS(2304),
    [anon_sym_co_return] = ACTIONS(2304),
    [anon_sym_co_yield] = ACTIONS(2304),
    [anon_sym_R_DQUOTE] = ACTIONS(2306),
    [anon_sym_LR_DQUOTE] = ACTIONS(2306),
    [anon_sym_uR_DQUOTE] = ACTIONS(2306),
    [anon_sym_UR_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2306),
    [anon_sym_co_await] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_requires] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [anon_sym_discard] = ACTIONS(2304),
    [anon_sym_precise] = ACTIONS(2304),
    [anon_sym_shared] = ACTIONS(2304),
    [anon_sym_groupshared] = ACTIONS(2304),
    [anon_sym_uniform] = ACTIONS(2304),
    [anon_sym_row_major] = ACTIONS(2304),
    [anon_sym_column_major] = ACTIONS(2304),
    [anon_sym_globallycoherent] = ACTIONS(2304),
    [anon_sym_centroid] = ACTIONS(2304),
    [anon_sym_noperspective] = ACTIONS(2304),
    [anon_sym_nointerpolation] = ACTIONS(2304),
    [anon_sym_sample] = ACTIONS(2304),
    [anon_sym_linear] = ACTIONS(2304),
    [anon_sym_snorm] = ACTIONS(2304),
    [anon_sym_unorm] = ACTIONS(2304),
    [anon_sym_point] = ACTIONS(2304),
    [anon_sym_line] = ACTIONS(2304),
    [anon_sym_triangleadj] = ACTIONS(2304),
    [anon_sym_lineadj] = ACTIONS(2304),
    [anon_sym_triangle] = ACTIONS(2304),
    [anon_sym_cbuffer] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_extension] = ACTIONS(2304),
    [anon_sym_where] = ACTIONS(2304),
    [anon_sym___exported] = ACTIONS(2304),
  },
  [212] = {
    [ts_builtin_sym_end] = ACTIONS(2310),
    [sym_identifier] = ACTIONS(2308),
    [aux_sym_preproc_include_token1] = ACTIONS(2308),
    [aux_sym_preproc_def_token1] = ACTIONS(2308),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_RPAREN] = ACTIONS(2310),
    [aux_sym_preproc_if_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2308),
    [sym_preproc_directive] = ACTIONS(2308),
    [anon_sym_LPAREN2] = ACTIONS(2310),
    [anon_sym_BANG] = ACTIONS(2310),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_COLON] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(2308),
    [anon_sym_typedef] = ACTIONS(2308),
    [anon_sym_in] = ACTIONS(2308),
    [anon_sym_out] = ACTIONS(2308),
    [anon_sym_inout] = ACTIONS(2308),
    [anon_sym_virtual] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2308),
    [anon_sym___attribute__] = ACTIONS(2308),
    [anon_sym___attribute] = ACTIONS(2308),
    [anon_sym_using] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2310),
    [anon_sym___declspec] = ACTIONS(2308),
    [anon_sym___based] = ACTIONS(2308),
    [anon_sym___cdecl] = ACTIONS(2308),
    [anon_sym___clrcall] = ACTIONS(2308),
    [anon_sym___stdcall] = ACTIONS(2308),
    [anon_sym___fastcall] = ACTIONS(2308),
    [anon_sym___thiscall] = ACTIONS(2308),
    [anon_sym___vectorcall] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_signed] = ACTIONS(2308),
    [anon_sym_unsigned] = ACTIONS(2308),
    [anon_sym_long] = ACTIONS(2308),
    [anon_sym_short] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_EQ] = ACTIONS(2310),
    [anon_sym_register] = ACTIONS(2308),
    [anon_sym_inline] = ACTIONS(2308),
    [anon_sym___inline] = ACTIONS(2308),
    [anon_sym___inline__] = ACTIONS(2308),
    [anon_sym___forceinline] = ACTIONS(2308),
    [anon_sym_thread_local] = ACTIONS(2308),
    [anon_sym___thread] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_constexpr] = ACTIONS(2308),
    [anon_sym_volatile] = ACTIONS(2308),
    [anon_sym_restrict] = ACTIONS(2308),
    [anon_sym___restrict__] = ACTIONS(2308),
    [anon_sym__Atomic] = ACTIONS(2308),
    [anon_sym__Noreturn] = ACTIONS(2308),
    [anon_sym_noreturn] = ACTIONS(2308),
    [anon_sym__Nonnull] = ACTIONS(2308),
    [anon_sym_mutable] = ACTIONS(2308),
    [anon_sym_constinit] = ACTIONS(2308),
    [anon_sym_consteval] = ACTIONS(2308),
    [anon_sym_alignas] = ACTIONS(2308),
    [anon_sym__Alignas] = ACTIONS(2308),
    [sym_primitive_type] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_struct] = ACTIONS(2308),
    [anon_sym_union] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_else] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_case] = ACTIONS(2308),
    [anon_sym_default] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_goto] = ACTIONS(2308),
    [anon_sym___try] = ACTIONS(2308),
    [anon_sym___leave] = ACTIONS(2308),
    [anon_sym_not] = ACTIONS(2308),
    [anon_sym_compl] = ACTIONS(2308),
    [anon_sym_or] = ACTIONS(2308),
    [anon_sym_and] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_sizeof] = ACTIONS(2308),
    [anon_sym___alignof__] = ACTIONS(2308),
    [anon_sym___alignof] = ACTIONS(2308),
    [anon_sym__alignof] = ACTIONS(2308),
    [anon_sym_alignof] = ACTIONS(2308),
    [anon_sym__Alignof] = ACTIONS(2308),
    [anon_sym_offsetof] = ACTIONS(2308),
    [anon_sym__Generic] = ACTIONS(2308),
    [anon_sym_asm] = ACTIONS(2308),
    [anon_sym___asm__] = ACTIONS(2308),
    [anon_sym___asm] = ACTIONS(2308),
    [anon_sym_DOT] = ACTIONS(2308),
    [sym_number_literal] = ACTIONS(2310),
    [anon_sym_L_SQUOTE] = ACTIONS(2310),
    [anon_sym_u_SQUOTE] = ACTIONS(2310),
    [anon_sym_U_SQUOTE] = ACTIONS(2310),
    [anon_sym_u8_SQUOTE] = ACTIONS(2310),
    [anon_sym_SQUOTE] = ACTIONS(2310),
    [anon_sym_L_DQUOTE] = ACTIONS(2310),
    [anon_sym_u_DQUOTE] = ACTIONS(2310),
    [anon_sym_U_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8_DQUOTE] = ACTIONS(2310),
    [anon_sym_DQUOTE] = ACTIONS(2310),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [anon_sym_NULL] = ACTIONS(2308),
    [anon_sym_nullptr] = ACTIONS(2308),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_This] = ACTIONS(2308),
    [anon_sym_decltype] = ACTIONS(2308),
    [anon_sym_final] = ACTIONS(2308),
    [anon_sym_override] = ACTIONS(2308),
    [anon_sym_explicit] = ACTIONS(2308),
    [anon_sym_typename] = ACTIONS(2308),
    [anon_sym_export] = ACTIONS(2308),
    [anon_sym_module] = ACTIONS(2308),
    [anon_sym_import] = ACTIONS(2308),
    [anon_sym_template] = ACTIONS(2308),
    [anon_sym_GT2] = ACTIONS(2310),
    [anon_sym_operator] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_delete] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_namespace] = ACTIONS(2308),
    [anon_sym_static_assert] = ACTIONS(2308),
    [anon_sym_concept] = ACTIONS(2308),
    [anon_sym_co_return] = ACTIONS(2308),
    [anon_sym_co_yield] = ACTIONS(2308),
    [anon_sym_R_DQUOTE] = ACTIONS(2310),
    [anon_sym_LR_DQUOTE] = ACTIONS(2310),
    [anon_sym_uR_DQUOTE] = ACTIONS(2310),
    [anon_sym_UR_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2310),
    [anon_sym_co_await] = ACTIONS(2308),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_requires] = ACTIONS(2308),
    [sym_this] = ACTIONS(2308),
    [anon_sym_discard] = ACTIONS(2308),
    [anon_sym_precise] = ACTIONS(2308),
    [anon_sym_shared] = ACTIONS(2308),
    [anon_sym_groupshared] = ACTIONS(2308),
    [anon_sym_uniform] = ACTIONS(2308),
    [anon_sym_row_major] = ACTIONS(2308),
    [anon_sym_column_major] = ACTIONS(2308),
    [anon_sym_globallycoherent] = ACTIONS(2308),
    [anon_sym_centroid] = ACTIONS(2308),
    [anon_sym_noperspective] = ACTIONS(2308),
    [anon_sym_nointerpolation] = ACTIONS(2308),
    [anon_sym_sample] = ACTIONS(2308),
    [anon_sym_linear] = ACTIONS(2308),
    [anon_sym_snorm] = ACTIONS(2308),
    [anon_sym_unorm] = ACTIONS(2308),
    [anon_sym_point] = ACTIONS(2308),
    [anon_sym_line] = ACTIONS(2308),
    [anon_sym_triangleadj] = ACTIONS(2308),
    [anon_sym_lineadj] = ACTIONS(2308),
    [anon_sym_triangle] = ACTIONS(2308),
    [anon_sym_cbuffer] = ACTIONS(2308),
    [anon_sym_interface] = ACTIONS(2308),
    [anon_sym_extension] = ACTIONS(2308),
    [anon_sym_where] = ACTIONS(2308),
    [anon_sym___exported] = ACTIONS(2308),
  },
  [213] = {
    [ts_builtin_sym_end] = ACTIONS(2314),
    [sym_identifier] = ACTIONS(2312),
    [aux_sym_preproc_include_token1] = ACTIONS(2312),
    [aux_sym_preproc_def_token1] = ACTIONS(2312),
    [anon_sym_COMMA] = ACTIONS(2314),
    [anon_sym_RPAREN] = ACTIONS(2314),
    [aux_sym_preproc_if_token1] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2312),
    [sym_preproc_directive] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2314),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_PIPE_PIPE] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym___extension__] = ACTIONS(2312),
    [anon_sym_typedef] = ACTIONS(2312),
    [anon_sym_in] = ACTIONS(2312),
    [anon_sym_out] = ACTIONS(2312),
    [anon_sym_inout] = ACTIONS(2312),
    [anon_sym_virtual] = ACTIONS(2312),
    [anon_sym_extern] = ACTIONS(2312),
    [anon_sym___attribute__] = ACTIONS(2312),
    [anon_sym___attribute] = ACTIONS(2312),
    [anon_sym_using] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2314),
    [anon_sym___declspec] = ACTIONS(2312),
    [anon_sym___based] = ACTIONS(2312),
    [anon_sym___cdecl] = ACTIONS(2312),
    [anon_sym___clrcall] = ACTIONS(2312),
    [anon_sym___stdcall] = ACTIONS(2312),
    [anon_sym___fastcall] = ACTIONS(2312),
    [anon_sym___thiscall] = ACTIONS(2312),
    [anon_sym___vectorcall] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_signed] = ACTIONS(2312),
    [anon_sym_unsigned] = ACTIONS(2312),
    [anon_sym_long] = ACTIONS(2312),
    [anon_sym_short] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_EQ] = ACTIONS(2314),
    [anon_sym_register] = ACTIONS(2312),
    [anon_sym_inline] = ACTIONS(2312),
    [anon_sym___inline] = ACTIONS(2312),
    [anon_sym___inline__] = ACTIONS(2312),
    [anon_sym___forceinline] = ACTIONS(2312),
    [anon_sym_thread_local] = ACTIONS(2312),
    [anon_sym___thread] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_constexpr] = ACTIONS(2312),
    [anon_sym_volatile] = ACTIONS(2312),
    [anon_sym_restrict] = ACTIONS(2312),
    [anon_sym___restrict__] = ACTIONS(2312),
    [anon_sym__Atomic] = ACTIONS(2312),
    [anon_sym__Noreturn] = ACTIONS(2312),
    [anon_sym_noreturn] = ACTIONS(2312),
    [anon_sym__Nonnull] = ACTIONS(2312),
    [anon_sym_mutable] = ACTIONS(2312),
    [anon_sym_constinit] = ACTIONS(2312),
    [anon_sym_consteval] = ACTIONS(2312),
    [anon_sym_alignas] = ACTIONS(2312),
    [anon_sym__Alignas] = ACTIONS(2312),
    [sym_primitive_type] = ACTIONS(2312),
    [anon_sym_enum] = ACTIONS(2312),
    [anon_sym_class] = ACTIONS(2312),
    [anon_sym_struct] = ACTIONS(2312),
    [anon_sym_union] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_else] = ACTIONS(2312),
    [anon_sym_switch] = ACTIONS(2312),
    [anon_sym_case] = ACTIONS(2312),
    [anon_sym_default] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_break] = ACTIONS(2312),
    [anon_sym_continue] = ACTIONS(2312),
    [anon_sym_goto] = ACTIONS(2312),
    [anon_sym___try] = ACTIONS(2312),
    [anon_sym___leave] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2312),
    [anon_sym_compl] = ACTIONS(2312),
    [anon_sym_or] = ACTIONS(2312),
    [anon_sym_and] = ACTIONS(2312),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_sizeof] = ACTIONS(2312),
    [anon_sym___alignof__] = ACTIONS(2312),
    [anon_sym___alignof] = ACTIONS(2312),
    [anon_sym__alignof] = ACTIONS(2312),
    [anon_sym_alignof] = ACTIONS(2312),
    [anon_sym__Alignof] = ACTIONS(2312),
    [anon_sym_offsetof] = ACTIONS(2312),
    [anon_sym__Generic] = ACTIONS(2312),
    [anon_sym_asm] = ACTIONS(2312),
    [anon_sym___asm__] = ACTIONS(2312),
    [anon_sym___asm] = ACTIONS(2312),
    [anon_sym_DOT] = ACTIONS(2312),
    [sym_number_literal] = ACTIONS(2314),
    [anon_sym_L_SQUOTE] = ACTIONS(2314),
    [anon_sym_u_SQUOTE] = ACTIONS(2314),
    [anon_sym_U_SQUOTE] = ACTIONS(2314),
    [anon_sym_u8_SQUOTE] = ACTIONS(2314),
    [anon_sym_SQUOTE] = ACTIONS(2314),
    [anon_sym_L_DQUOTE] = ACTIONS(2314),
    [anon_sym_u_DQUOTE] = ACTIONS(2314),
    [anon_sym_U_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE] = ACTIONS(2314),
    [sym_true] = ACTIONS(2312),
    [sym_false] = ACTIONS(2312),
    [anon_sym_NULL] = ACTIONS(2312),
    [anon_sym_nullptr] = ACTIONS(2312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_This] = ACTIONS(2312),
    [anon_sym_decltype] = ACTIONS(2312),
    [anon_sym_final] = ACTIONS(2312),
    [anon_sym_override] = ACTIONS(2312),
    [anon_sym_explicit] = ACTIONS(2312),
    [anon_sym_typename] = ACTIONS(2312),
    [anon_sym_export] = ACTIONS(2312),
    [anon_sym_module] = ACTIONS(2312),
    [anon_sym_import] = ACTIONS(2312),
    [anon_sym_template] = ACTIONS(2312),
    [anon_sym_GT2] = ACTIONS(2314),
    [anon_sym_operator] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_delete] = ACTIONS(2312),
    [anon_sym_throw] = ACTIONS(2312),
    [anon_sym_namespace] = ACTIONS(2312),
    [anon_sym_static_assert] = ACTIONS(2312),
    [anon_sym_concept] = ACTIONS(2312),
    [anon_sym_co_return] = ACTIONS(2312),
    [anon_sym_co_yield] = ACTIONS(2312),
    [anon_sym_R_DQUOTE] = ACTIONS(2314),
    [anon_sym_LR_DQUOTE] = ACTIONS(2314),
    [anon_sym_uR_DQUOTE] = ACTIONS(2314),
    [anon_sym_UR_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2314),
    [anon_sym_co_await] = ACTIONS(2312),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_requires] = ACTIONS(2312),
    [sym_this] = ACTIONS(2312),
    [anon_sym_discard] = ACTIONS(2312),
    [anon_sym_precise] = ACTIONS(2312),
    [anon_sym_shared] = ACTIONS(2312),
    [anon_sym_groupshared] = ACTIONS(2312),
    [anon_sym_uniform] = ACTIONS(2312),
    [anon_sym_row_major] = ACTIONS(2312),
    [anon_sym_column_major] = ACTIONS(2312),
    [anon_sym_globallycoherent] = ACTIONS(2312),
    [anon_sym_centroid] = ACTIONS(2312),
    [anon_sym_noperspective] = ACTIONS(2312),
    [anon_sym_nointerpolation] = ACTIONS(2312),
    [anon_sym_sample] = ACTIONS(2312),
    [anon_sym_linear] = ACTIONS(2312),
    [anon_sym_snorm] = ACTIONS(2312),
    [anon_sym_unorm] = ACTIONS(2312),
    [anon_sym_point] = ACTIONS(2312),
    [anon_sym_line] = ACTIONS(2312),
    [anon_sym_triangleadj] = ACTIONS(2312),
    [anon_sym_lineadj] = ACTIONS(2312),
    [anon_sym_triangle] = ACTIONS(2312),
    [anon_sym_cbuffer] = ACTIONS(2312),
    [anon_sym_interface] = ACTIONS(2312),
    [anon_sym_extension] = ACTIONS(2312),
    [anon_sym_where] = ACTIONS(2312),
    [anon_sym___exported] = ACTIONS(2312),
  },
  [214] = {
    [ts_builtin_sym_end] = ACTIONS(2420),
    [sym_identifier] = ACTIONS(2422),
    [aux_sym_preproc_include_token1] = ACTIONS(2422),
    [aux_sym_preproc_def_token1] = ACTIONS(2422),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_RPAREN] = ACTIONS(2420),
    [aux_sym_preproc_if_token1] = ACTIONS(2422),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2422),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2422),
    [sym_preproc_directive] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_PIPE_PIPE] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym_typedef] = ACTIONS(2422),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_out] = ACTIONS(2422),
    [anon_sym_inout] = ACTIONS(2422),
    [anon_sym_virtual] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_using] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2422),
    [anon_sym___based] = ACTIONS(2422),
    [anon_sym___cdecl] = ACTIONS(2422),
    [anon_sym___clrcall] = ACTIONS(2422),
    [anon_sym___stdcall] = ACTIONS(2422),
    [anon_sym___fastcall] = ACTIONS(2422),
    [anon_sym___thiscall] = ACTIONS(2422),
    [anon_sym___vectorcall] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2422),
    [anon_sym_unsigned] = ACTIONS(2422),
    [anon_sym_long] = ACTIONS(2422),
    [anon_sym_short] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_register] = ACTIONS(2422),
    [anon_sym_inline] = ACTIONS(2422),
    [anon_sym___inline] = ACTIONS(2422),
    [anon_sym___inline__] = ACTIONS(2422),
    [anon_sym___forceinline] = ACTIONS(2422),
    [anon_sym_thread_local] = ACTIONS(2422),
    [anon_sym___thread] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [sym_primitive_type] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
    [anon_sym_class] = ACTIONS(2422),
    [anon_sym_struct] = ACTIONS(2422),
    [anon_sym_union] = ACTIONS(2422),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(2422),
    [anon_sym_switch] = ACTIONS(2422),
    [anon_sym_case] = ACTIONS(2422),
    [anon_sym_default] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_break] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(2422),
    [anon_sym_goto] = ACTIONS(2422),
    [anon_sym___try] = ACTIONS(2422),
    [anon_sym___leave] = ACTIONS(2422),
    [anon_sym_not] = ACTIONS(2422),
    [anon_sym_compl] = ACTIONS(2422),
    [anon_sym_or] = ACTIONS(2422),
    [anon_sym_and] = ACTIONS(2422),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_sizeof] = ACTIONS(2422),
    [anon_sym___alignof__] = ACTIONS(2422),
    [anon_sym___alignof] = ACTIONS(2422),
    [anon_sym__alignof] = ACTIONS(2422),
    [anon_sym_alignof] = ACTIONS(2422),
    [anon_sym__Alignof] = ACTIONS(2422),
    [anon_sym_offsetof] = ACTIONS(2422),
    [anon_sym__Generic] = ACTIONS(2422),
    [anon_sym_asm] = ACTIONS(2422),
    [anon_sym___asm__] = ACTIONS(2422),
    [anon_sym___asm] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2422),
    [sym_number_literal] = ACTIONS(2420),
    [anon_sym_L_SQUOTE] = ACTIONS(2420),
    [anon_sym_u_SQUOTE] = ACTIONS(2420),
    [anon_sym_U_SQUOTE] = ACTIONS(2420),
    [anon_sym_u8_SQUOTE] = ACTIONS(2420),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [anon_sym_L_DQUOTE] = ACTIONS(2420),
    [anon_sym_u_DQUOTE] = ACTIONS(2420),
    [anon_sym_U_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [sym_true] = ACTIONS(2422),
    [sym_false] = ACTIONS(2422),
    [anon_sym_NULL] = ACTIONS(2422),
    [anon_sym_nullptr] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_decltype] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_explicit] = ACTIONS(2422),
    [anon_sym_typename] = ACTIONS(2422),
    [anon_sym_export] = ACTIONS(2422),
    [anon_sym_module] = ACTIONS(2422),
    [anon_sym_import] = ACTIONS(2422),
    [anon_sym_template] = ACTIONS(2422),
    [anon_sym_GT2] = ACTIONS(2420),
    [anon_sym_operator] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_delete] = ACTIONS(2422),
    [anon_sym_throw] = ACTIONS(2422),
    [anon_sym_namespace] = ACTIONS(2422),
    [anon_sym_static_assert] = ACTIONS(2422),
    [anon_sym_concept] = ACTIONS(2422),
    [anon_sym_co_return] = ACTIONS(2422),
    [anon_sym_co_yield] = ACTIONS(2422),
    [anon_sym_R_DQUOTE] = ACTIONS(2420),
    [anon_sym_LR_DQUOTE] = ACTIONS(2420),
    [anon_sym_uR_DQUOTE] = ACTIONS(2420),
    [anon_sym_UR_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2420),
    [anon_sym_co_await] = ACTIONS(2422),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_requires] = ACTIONS(2422),
    [sym_this] = ACTIONS(2422),
    [anon_sym_discard] = ACTIONS(2422),
    [anon_sym_precise] = ACTIONS(2422),
    [anon_sym_shared] = ACTIONS(2422),
    [anon_sym_groupshared] = ACTIONS(2422),
    [anon_sym_uniform] = ACTIONS(2422),
    [anon_sym_row_major] = ACTIONS(2422),
    [anon_sym_column_major] = ACTIONS(2422),
    [anon_sym_globallycoherent] = ACTIONS(2422),
    [anon_sym_centroid] = ACTIONS(2422),
    [anon_sym_noperspective] = ACTIONS(2422),
    [anon_sym_nointerpolation] = ACTIONS(2422),
    [anon_sym_sample] = ACTIONS(2422),
    [anon_sym_linear] = ACTIONS(2422),
    [anon_sym_snorm] = ACTIONS(2422),
    [anon_sym_unorm] = ACTIONS(2422),
    [anon_sym_point] = ACTIONS(2422),
    [anon_sym_line] = ACTIONS(2422),
    [anon_sym_triangleadj] = ACTIONS(2422),
    [anon_sym_lineadj] = ACTIONS(2422),
    [anon_sym_triangle] = ACTIONS(2422),
    [anon_sym_cbuffer] = ACTIONS(2422),
    [anon_sym_interface] = ACTIONS(2422),
    [anon_sym_extension] = ACTIONS(2422),
    [anon_sym_where] = ACTIONS(2422),
    [anon_sym___exported] = ACTIONS(2422),
  },
  [215] = {
    [ts_builtin_sym_end] = ACTIONS(2270),
    [sym_identifier] = ACTIONS(2268),
    [aux_sym_preproc_include_token1] = ACTIONS(2268),
    [aux_sym_preproc_def_token1] = ACTIONS(2268),
    [anon_sym_COMMA] = ACTIONS(2270),
    [anon_sym_RPAREN] = ACTIONS(2270),
    [aux_sym_preproc_if_token1] = ACTIONS(2268),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2268),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2268),
    [sym_preproc_directive] = ACTIONS(2268),
    [anon_sym_LPAREN2] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2270),
    [anon_sym_TILDE] = ACTIONS(2270),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2270),
    [anon_sym_PIPE_PIPE] = ACTIONS(2270),
    [anon_sym_AMP_AMP] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(2268),
    [anon_sym_COLON] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym___extension__] = ACTIONS(2268),
    [anon_sym_typedef] = ACTIONS(2268),
    [anon_sym_in] = ACTIONS(2268),
    [anon_sym_out] = ACTIONS(2268),
    [anon_sym_inout] = ACTIONS(2268),
    [anon_sym_virtual] = ACTIONS(2268),
    [anon_sym_extern] = ACTIONS(2268),
    [anon_sym___attribute__] = ACTIONS(2268),
    [anon_sym___attribute] = ACTIONS(2268),
    [anon_sym_using] = ACTIONS(2268),
    [anon_sym_COLON_COLON] = ACTIONS(2270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2270),
    [anon_sym___declspec] = ACTIONS(2268),
    [anon_sym___based] = ACTIONS(2268),
    [anon_sym___cdecl] = ACTIONS(2268),
    [anon_sym___clrcall] = ACTIONS(2268),
    [anon_sym___stdcall] = ACTIONS(2268),
    [anon_sym___fastcall] = ACTIONS(2268),
    [anon_sym___thiscall] = ACTIONS(2268),
    [anon_sym___vectorcall] = ACTIONS(2268),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_signed] = ACTIONS(2268),
    [anon_sym_unsigned] = ACTIONS(2268),
    [anon_sym_long] = ACTIONS(2268),
    [anon_sym_short] = ACTIONS(2268),
    [anon_sym_LBRACK] = ACTIONS(2268),
    [anon_sym_static] = ACTIONS(2268),
    [anon_sym_EQ] = ACTIONS(2270),
    [anon_sym_register] = ACTIONS(2268),
    [anon_sym_inline] = ACTIONS(2268),
    [anon_sym___inline] = ACTIONS(2268),
    [anon_sym___inline__] = ACTIONS(2268),
    [anon_sym___forceinline] = ACTIONS(2268),
    [anon_sym_thread_local] = ACTIONS(2268),
    [anon_sym___thread] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_constexpr] = ACTIONS(2268),
    [anon_sym_volatile] = ACTIONS(2268),
    [anon_sym_restrict] = ACTIONS(2268),
    [anon_sym___restrict__] = ACTIONS(2268),
    [anon_sym__Atomic] = ACTIONS(2268),
    [anon_sym__Noreturn] = ACTIONS(2268),
    [anon_sym_noreturn] = ACTIONS(2268),
    [anon_sym__Nonnull] = ACTIONS(2268),
    [anon_sym_mutable] = ACTIONS(2268),
    [anon_sym_constinit] = ACTIONS(2268),
    [anon_sym_consteval] = ACTIONS(2268),
    [anon_sym_alignas] = ACTIONS(2268),
    [anon_sym__Alignas] = ACTIONS(2268),
    [sym_primitive_type] = ACTIONS(2268),
    [anon_sym_enum] = ACTIONS(2268),
    [anon_sym_class] = ACTIONS(2268),
    [anon_sym_struct] = ACTIONS(2268),
    [anon_sym_union] = ACTIONS(2268),
    [anon_sym_if] = ACTIONS(2268),
    [anon_sym_else] = ACTIONS(2268),
    [anon_sym_switch] = ACTIONS(2268),
    [anon_sym_case] = ACTIONS(2268),
    [anon_sym_default] = ACTIONS(2268),
    [anon_sym_while] = ACTIONS(2268),
    [anon_sym_do] = ACTIONS(2268),
    [anon_sym_for] = ACTIONS(2268),
    [anon_sym_return] = ACTIONS(2268),
    [anon_sym_break] = ACTIONS(2268),
    [anon_sym_continue] = ACTIONS(2268),
    [anon_sym_goto] = ACTIONS(2268),
    [anon_sym___try] = ACTIONS(2268),
    [anon_sym___leave] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2268),
    [anon_sym_compl] = ACTIONS(2268),
    [anon_sym_or] = ACTIONS(2268),
    [anon_sym_and] = ACTIONS(2268),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_sizeof] = ACTIONS(2268),
    [anon_sym___alignof__] = ACTIONS(2268),
    [anon_sym___alignof] = ACTIONS(2268),
    [anon_sym__alignof] = ACTIONS(2268),
    [anon_sym_alignof] = ACTIONS(2268),
    [anon_sym__Alignof] = ACTIONS(2268),
    [anon_sym_offsetof] = ACTIONS(2268),
    [anon_sym__Generic] = ACTIONS(2268),
    [anon_sym_asm] = ACTIONS(2268),
    [anon_sym___asm__] = ACTIONS(2268),
    [anon_sym___asm] = ACTIONS(2268),
    [anon_sym_DOT] = ACTIONS(2268),
    [sym_number_literal] = ACTIONS(2270),
    [anon_sym_L_SQUOTE] = ACTIONS(2270),
    [anon_sym_u_SQUOTE] = ACTIONS(2270),
    [anon_sym_U_SQUOTE] = ACTIONS(2270),
    [anon_sym_u8_SQUOTE] = ACTIONS(2270),
    [anon_sym_SQUOTE] = ACTIONS(2270),
    [anon_sym_L_DQUOTE] = ACTIONS(2270),
    [anon_sym_u_DQUOTE] = ACTIONS(2270),
    [anon_sym_U_DQUOTE] = ACTIONS(2270),
    [anon_sym_u8_DQUOTE] = ACTIONS(2270),
    [anon_sym_DQUOTE] = ACTIONS(2270),
    [sym_true] = ACTIONS(2268),
    [sym_false] = ACTIONS(2268),
    [anon_sym_NULL] = ACTIONS(2268),
    [anon_sym_nullptr] = ACTIONS(2268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_This] = ACTIONS(2268),
    [anon_sym_decltype] = ACTIONS(2268),
    [anon_sym_final] = ACTIONS(2268),
    [anon_sym_override] = ACTIONS(2268),
    [anon_sym_explicit] = ACTIONS(2268),
    [anon_sym_typename] = ACTIONS(2268),
    [anon_sym_export] = ACTIONS(2268),
    [anon_sym_module] = ACTIONS(2268),
    [anon_sym_import] = ACTIONS(2268),
    [anon_sym_template] = ACTIONS(2268),
    [anon_sym_GT2] = ACTIONS(2270),
    [anon_sym_operator] = ACTIONS(2268),
    [anon_sym_try] = ACTIONS(2268),
    [anon_sym_delete] = ACTIONS(2268),
    [anon_sym_throw] = ACTIONS(2268),
    [anon_sym_namespace] = ACTIONS(2268),
    [anon_sym_static_assert] = ACTIONS(2268),
    [anon_sym_concept] = ACTIONS(2268),
    [anon_sym_co_return] = ACTIONS(2268),
    [anon_sym_co_yield] = ACTIONS(2268),
    [anon_sym_R_DQUOTE] = ACTIONS(2270),
    [anon_sym_LR_DQUOTE] = ACTIONS(2270),
    [anon_sym_uR_DQUOTE] = ACTIONS(2270),
    [anon_sym_UR_DQUOTE] = ACTIONS(2270),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2270),
    [anon_sym_co_await] = ACTIONS(2268),
    [anon_sym_new] = ACTIONS(2268),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2268),
    [anon_sym_discard] = ACTIONS(2268),
    [anon_sym_precise] = ACTIONS(2268),
    [anon_sym_shared] = ACTIONS(2268),
    [anon_sym_groupshared] = ACTIONS(2268),
    [anon_sym_uniform] = ACTIONS(2268),
    [anon_sym_row_major] = ACTIONS(2268),
    [anon_sym_column_major] = ACTIONS(2268),
    [anon_sym_globallycoherent] = ACTIONS(2268),
    [anon_sym_centroid] = ACTIONS(2268),
    [anon_sym_noperspective] = ACTIONS(2268),
    [anon_sym_nointerpolation] = ACTIONS(2268),
    [anon_sym_sample] = ACTIONS(2268),
    [anon_sym_linear] = ACTIONS(2268),
    [anon_sym_snorm] = ACTIONS(2268),
    [anon_sym_unorm] = ACTIONS(2268),
    [anon_sym_point] = ACTIONS(2268),
    [anon_sym_line] = ACTIONS(2268),
    [anon_sym_triangleadj] = ACTIONS(2268),
    [anon_sym_lineadj] = ACTIONS(2268),
    [anon_sym_triangle] = ACTIONS(2268),
    [anon_sym_cbuffer] = ACTIONS(2268),
    [anon_sym_interface] = ACTIONS(2268),
    [anon_sym_extension] = ACTIONS(2268),
    [anon_sym_where] = ACTIONS(2268),
    [anon_sym___exported] = ACTIONS(2268),
  },
  [216] = {
    [ts_builtin_sym_end] = ACTIONS(2274),
    [sym_identifier] = ACTIONS(2272),
    [aux_sym_preproc_include_token1] = ACTIONS(2272),
    [aux_sym_preproc_def_token1] = ACTIONS(2272),
    [anon_sym_COMMA] = ACTIONS(2274),
    [anon_sym_RPAREN] = ACTIONS(2274),
    [aux_sym_preproc_if_token1] = ACTIONS(2272),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2272),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2272),
    [sym_preproc_directive] = ACTIONS(2272),
    [anon_sym_LPAREN2] = ACTIONS(2274),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2274),
    [anon_sym_PIPE_PIPE] = ACTIONS(2274),
    [anon_sym_AMP_AMP] = ACTIONS(2274),
    [anon_sym_AMP] = ACTIONS(2272),
    [anon_sym_COLON] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym___extension__] = ACTIONS(2272),
    [anon_sym_typedef] = ACTIONS(2272),
    [anon_sym_in] = ACTIONS(2272),
    [anon_sym_out] = ACTIONS(2272),
    [anon_sym_inout] = ACTIONS(2272),
    [anon_sym_virtual] = ACTIONS(2272),
    [anon_sym_extern] = ACTIONS(2272),
    [anon_sym___attribute__] = ACTIONS(2272),
    [anon_sym___attribute] = ACTIONS(2272),
    [anon_sym_using] = ACTIONS(2272),
    [anon_sym_COLON_COLON] = ACTIONS(2274),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2274),
    [anon_sym___declspec] = ACTIONS(2272),
    [anon_sym___based] = ACTIONS(2272),
    [anon_sym___cdecl] = ACTIONS(2272),
    [anon_sym___clrcall] = ACTIONS(2272),
    [anon_sym___stdcall] = ACTIONS(2272),
    [anon_sym___fastcall] = ACTIONS(2272),
    [anon_sym___thiscall] = ACTIONS(2272),
    [anon_sym___vectorcall] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_signed] = ACTIONS(2272),
    [anon_sym_unsigned] = ACTIONS(2272),
    [anon_sym_long] = ACTIONS(2272),
    [anon_sym_short] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_EQ] = ACTIONS(2274),
    [anon_sym_register] = ACTIONS(2272),
    [anon_sym_inline] = ACTIONS(2272),
    [anon_sym___inline] = ACTIONS(2272),
    [anon_sym___inline__] = ACTIONS(2272),
    [anon_sym___forceinline] = ACTIONS(2272),
    [anon_sym_thread_local] = ACTIONS(2272),
    [anon_sym___thread] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_constexpr] = ACTIONS(2272),
    [anon_sym_volatile] = ACTIONS(2272),
    [anon_sym_restrict] = ACTIONS(2272),
    [anon_sym___restrict__] = ACTIONS(2272),
    [anon_sym__Atomic] = ACTIONS(2272),
    [anon_sym__Noreturn] = ACTIONS(2272),
    [anon_sym_noreturn] = ACTIONS(2272),
    [anon_sym__Nonnull] = ACTIONS(2272),
    [anon_sym_mutable] = ACTIONS(2272),
    [anon_sym_constinit] = ACTIONS(2272),
    [anon_sym_consteval] = ACTIONS(2272),
    [anon_sym_alignas] = ACTIONS(2272),
    [anon_sym__Alignas] = ACTIONS(2272),
    [sym_primitive_type] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_struct] = ACTIONS(2272),
    [anon_sym_union] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_else] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_case] = ACTIONS(2272),
    [anon_sym_default] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_goto] = ACTIONS(2272),
    [anon_sym___try] = ACTIONS(2272),
    [anon_sym___leave] = ACTIONS(2272),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_compl] = ACTIONS(2272),
    [anon_sym_or] = ACTIONS(2272),
    [anon_sym_and] = ACTIONS(2272),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_sizeof] = ACTIONS(2272),
    [anon_sym___alignof__] = ACTIONS(2272),
    [anon_sym___alignof] = ACTIONS(2272),
    [anon_sym__alignof] = ACTIONS(2272),
    [anon_sym_alignof] = ACTIONS(2272),
    [anon_sym__Alignof] = ACTIONS(2272),
    [anon_sym_offsetof] = ACTIONS(2272),
    [anon_sym__Generic] = ACTIONS(2272),
    [anon_sym_asm] = ACTIONS(2272),
    [anon_sym___asm__] = ACTIONS(2272),
    [anon_sym___asm] = ACTIONS(2272),
    [anon_sym_DOT] = ACTIONS(2272),
    [sym_number_literal] = ACTIONS(2274),
    [anon_sym_L_SQUOTE] = ACTIONS(2274),
    [anon_sym_u_SQUOTE] = ACTIONS(2274),
    [anon_sym_U_SQUOTE] = ACTIONS(2274),
    [anon_sym_u8_SQUOTE] = ACTIONS(2274),
    [anon_sym_SQUOTE] = ACTIONS(2274),
    [anon_sym_L_DQUOTE] = ACTIONS(2274),
    [anon_sym_u_DQUOTE] = ACTIONS(2274),
    [anon_sym_U_DQUOTE] = ACTIONS(2274),
    [anon_sym_u8_DQUOTE] = ACTIONS(2274),
    [anon_sym_DQUOTE] = ACTIONS(2274),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [anon_sym_NULL] = ACTIONS(2272),
    [anon_sym_nullptr] = ACTIONS(2272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_This] = ACTIONS(2272),
    [anon_sym_decltype] = ACTIONS(2272),
    [anon_sym_final] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_explicit] = ACTIONS(2272),
    [anon_sym_typename] = ACTIONS(2272),
    [anon_sym_export] = ACTIONS(2272),
    [anon_sym_module] = ACTIONS(2272),
    [anon_sym_import] = ACTIONS(2272),
    [anon_sym_template] = ACTIONS(2272),
    [anon_sym_GT2] = ACTIONS(2274),
    [anon_sym_operator] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_namespace] = ACTIONS(2272),
    [anon_sym_static_assert] = ACTIONS(2272),
    [anon_sym_concept] = ACTIONS(2272),
    [anon_sym_co_return] = ACTIONS(2272),
    [anon_sym_co_yield] = ACTIONS(2272),
    [anon_sym_R_DQUOTE] = ACTIONS(2274),
    [anon_sym_LR_DQUOTE] = ACTIONS(2274),
    [anon_sym_uR_DQUOTE] = ACTIONS(2274),
    [anon_sym_UR_DQUOTE] = ACTIONS(2274),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2274),
    [anon_sym_co_await] = ACTIONS(2272),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_requires] = ACTIONS(2272),
    [sym_this] = ACTIONS(2272),
    [anon_sym_discard] = ACTIONS(2272),
    [anon_sym_precise] = ACTIONS(2272),
    [anon_sym_shared] = ACTIONS(2272),
    [anon_sym_groupshared] = ACTIONS(2272),
    [anon_sym_uniform] = ACTIONS(2272),
    [anon_sym_row_major] = ACTIONS(2272),
    [anon_sym_column_major] = ACTIONS(2272),
    [anon_sym_globallycoherent] = ACTIONS(2272),
    [anon_sym_centroid] = ACTIONS(2272),
    [anon_sym_noperspective] = ACTIONS(2272),
    [anon_sym_nointerpolation] = ACTIONS(2272),
    [anon_sym_sample] = ACTIONS(2272),
    [anon_sym_linear] = ACTIONS(2272),
    [anon_sym_snorm] = ACTIONS(2272),
    [anon_sym_unorm] = ACTIONS(2272),
    [anon_sym_point] = ACTIONS(2272),
    [anon_sym_line] = ACTIONS(2272),
    [anon_sym_triangleadj] = ACTIONS(2272),
    [anon_sym_lineadj] = ACTIONS(2272),
    [anon_sym_triangle] = ACTIONS(2272),
    [anon_sym_cbuffer] = ACTIONS(2272),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_extension] = ACTIONS(2272),
    [anon_sym_where] = ACTIONS(2272),
    [anon_sym___exported] = ACTIONS(2272),
  },
  [217] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2276),
    [aux_sym_preproc_include_token1] = ACTIONS(2276),
    [aux_sym_preproc_def_token1] = ACTIONS(2276),
    [anon_sym_COMMA] = ACTIONS(2278),
    [anon_sym_RPAREN] = ACTIONS(2278),
    [aux_sym_preproc_if_token1] = ACTIONS(2276),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2276),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2276),
    [sym_preproc_directive] = ACTIONS(2276),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_PLUS] = ACTIONS(2276),
    [anon_sym_STAR] = ACTIONS(2278),
    [anon_sym_PIPE_PIPE] = ACTIONS(2278),
    [anon_sym_AMP_AMP] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_COLON] = ACTIONS(2276),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym___extension__] = ACTIONS(2276),
    [anon_sym_typedef] = ACTIONS(2276),
    [anon_sym_in] = ACTIONS(2276),
    [anon_sym_out] = ACTIONS(2276),
    [anon_sym_inout] = ACTIONS(2276),
    [anon_sym_virtual] = ACTIONS(2276),
    [anon_sym_extern] = ACTIONS(2276),
    [anon_sym___attribute__] = ACTIONS(2276),
    [anon_sym___attribute] = ACTIONS(2276),
    [anon_sym_using] = ACTIONS(2276),
    [anon_sym_COLON_COLON] = ACTIONS(2278),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2278),
    [anon_sym___declspec] = ACTIONS(2276),
    [anon_sym___based] = ACTIONS(2276),
    [anon_sym___cdecl] = ACTIONS(2276),
    [anon_sym___clrcall] = ACTIONS(2276),
    [anon_sym___stdcall] = ACTIONS(2276),
    [anon_sym___fastcall] = ACTIONS(2276),
    [anon_sym___thiscall] = ACTIONS(2276),
    [anon_sym___vectorcall] = ACTIONS(2276),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_signed] = ACTIONS(2276),
    [anon_sym_unsigned] = ACTIONS(2276),
    [anon_sym_long] = ACTIONS(2276),
    [anon_sym_short] = ACTIONS(2276),
    [anon_sym_LBRACK] = ACTIONS(2276),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_EQ] = ACTIONS(2278),
    [anon_sym_register] = ACTIONS(2276),
    [anon_sym_inline] = ACTIONS(2276),
    [anon_sym___inline] = ACTIONS(2276),
    [anon_sym___inline__] = ACTIONS(2276),
    [anon_sym___forceinline] = ACTIONS(2276),
    [anon_sym_thread_local] = ACTIONS(2276),
    [anon_sym___thread] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_constexpr] = ACTIONS(2276),
    [anon_sym_volatile] = ACTIONS(2276),
    [anon_sym_restrict] = ACTIONS(2276),
    [anon_sym___restrict__] = ACTIONS(2276),
    [anon_sym__Atomic] = ACTIONS(2276),
    [anon_sym__Noreturn] = ACTIONS(2276),
    [anon_sym_noreturn] = ACTIONS(2276),
    [anon_sym__Nonnull] = ACTIONS(2276),
    [anon_sym_mutable] = ACTIONS(2276),
    [anon_sym_constinit] = ACTIONS(2276),
    [anon_sym_consteval] = ACTIONS(2276),
    [anon_sym_alignas] = ACTIONS(2276),
    [anon_sym__Alignas] = ACTIONS(2276),
    [sym_primitive_type] = ACTIONS(2276),
    [anon_sym_enum] = ACTIONS(2276),
    [anon_sym_class] = ACTIONS(2276),
    [anon_sym_struct] = ACTIONS(2276),
    [anon_sym_union] = ACTIONS(2276),
    [anon_sym_if] = ACTIONS(2276),
    [anon_sym_else] = ACTIONS(2276),
    [anon_sym_switch] = ACTIONS(2276),
    [anon_sym_case] = ACTIONS(2276),
    [anon_sym_default] = ACTIONS(2276),
    [anon_sym_while] = ACTIONS(2276),
    [anon_sym_do] = ACTIONS(2276),
    [anon_sym_for] = ACTIONS(2276),
    [anon_sym_return] = ACTIONS(2276),
    [anon_sym_break] = ACTIONS(2276),
    [anon_sym_continue] = ACTIONS(2276),
    [anon_sym_goto] = ACTIONS(2276),
    [anon_sym___try] = ACTIONS(2276),
    [anon_sym___leave] = ACTIONS(2276),
    [anon_sym_not] = ACTIONS(2276),
    [anon_sym_compl] = ACTIONS(2276),
    [anon_sym_or] = ACTIONS(2276),
    [anon_sym_and] = ACTIONS(2276),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_sizeof] = ACTIONS(2276),
    [anon_sym___alignof__] = ACTIONS(2276),
    [anon_sym___alignof] = ACTIONS(2276),
    [anon_sym__alignof] = ACTIONS(2276),
    [anon_sym_alignof] = ACTIONS(2276),
    [anon_sym__Alignof] = ACTIONS(2276),
    [anon_sym_offsetof] = ACTIONS(2276),
    [anon_sym__Generic] = ACTIONS(2276),
    [anon_sym_asm] = ACTIONS(2276),
    [anon_sym___asm__] = ACTIONS(2276),
    [anon_sym___asm] = ACTIONS(2276),
    [anon_sym_DOT] = ACTIONS(2276),
    [sym_number_literal] = ACTIONS(2278),
    [anon_sym_L_SQUOTE] = ACTIONS(2278),
    [anon_sym_u_SQUOTE] = ACTIONS(2278),
    [anon_sym_U_SQUOTE] = ACTIONS(2278),
    [anon_sym_u8_SQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_L_DQUOTE] = ACTIONS(2278),
    [anon_sym_u_DQUOTE] = ACTIONS(2278),
    [anon_sym_U_DQUOTE] = ACTIONS(2278),
    [anon_sym_u8_DQUOTE] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [sym_true] = ACTIONS(2276),
    [sym_false] = ACTIONS(2276),
    [anon_sym_NULL] = ACTIONS(2276),
    [anon_sym_nullptr] = ACTIONS(2276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_This] = ACTIONS(2276),
    [anon_sym_decltype] = ACTIONS(2276),
    [anon_sym_final] = ACTIONS(2276),
    [anon_sym_override] = ACTIONS(2276),
    [anon_sym_explicit] = ACTIONS(2276),
    [anon_sym_typename] = ACTIONS(2276),
    [anon_sym_export] = ACTIONS(2276),
    [anon_sym_module] = ACTIONS(2276),
    [anon_sym_import] = ACTIONS(2276),
    [anon_sym_template] = ACTIONS(2276),
    [anon_sym_GT2] = ACTIONS(2278),
    [anon_sym_operator] = ACTIONS(2276),
    [anon_sym_try] = ACTIONS(2276),
    [anon_sym_delete] = ACTIONS(2276),
    [anon_sym_throw] = ACTIONS(2276),
    [anon_sym_namespace] = ACTIONS(2276),
    [anon_sym_static_assert] = ACTIONS(2276),
    [anon_sym_concept] = ACTIONS(2276),
    [anon_sym_co_return] = ACTIONS(2276),
    [anon_sym_co_yield] = ACTIONS(2276),
    [anon_sym_R_DQUOTE] = ACTIONS(2278),
    [anon_sym_LR_DQUOTE] = ACTIONS(2278),
    [anon_sym_uR_DQUOTE] = ACTIONS(2278),
    [anon_sym_UR_DQUOTE] = ACTIONS(2278),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2278),
    [anon_sym_co_await] = ACTIONS(2276),
    [anon_sym_new] = ACTIONS(2276),
    [anon_sym_requires] = ACTIONS(2276),
    [sym_this] = ACTIONS(2276),
    [anon_sym_discard] = ACTIONS(2276),
    [anon_sym_precise] = ACTIONS(2276),
    [anon_sym_shared] = ACTIONS(2276),
    [anon_sym_groupshared] = ACTIONS(2276),
    [anon_sym_uniform] = ACTIONS(2276),
    [anon_sym_row_major] = ACTIONS(2276),
    [anon_sym_column_major] = ACTIONS(2276),
    [anon_sym_globallycoherent] = ACTIONS(2276),
    [anon_sym_centroid] = ACTIONS(2276),
    [anon_sym_noperspective] = ACTIONS(2276),
    [anon_sym_nointerpolation] = ACTIONS(2276),
    [anon_sym_sample] = ACTIONS(2276),
    [anon_sym_linear] = ACTIONS(2276),
    [anon_sym_snorm] = ACTIONS(2276),
    [anon_sym_unorm] = ACTIONS(2276),
    [anon_sym_point] = ACTIONS(2276),
    [anon_sym_line] = ACTIONS(2276),
    [anon_sym_triangleadj] = ACTIONS(2276),
    [anon_sym_lineadj] = ACTIONS(2276),
    [anon_sym_triangle] = ACTIONS(2276),
    [anon_sym_cbuffer] = ACTIONS(2276),
    [anon_sym_interface] = ACTIONS(2276),
    [anon_sym_extension] = ACTIONS(2276),
    [anon_sym_where] = ACTIONS(2276),
    [anon_sym___exported] = ACTIONS(2276),
  },
  [218] = {
    [ts_builtin_sym_end] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2239),
    [aux_sym_preproc_include_token1] = ACTIONS(2239),
    [aux_sym_preproc_def_token1] = ACTIONS(2239),
    [anon_sym_COMMA] = ACTIONS(2241),
    [anon_sym_RPAREN] = ACTIONS(2241),
    [aux_sym_preproc_if_token1] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2239),
    [sym_preproc_directive] = ACTIONS(2239),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2239),
    [anon_sym_PLUS] = ACTIONS(2239),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_COLON] = ACTIONS(2239),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym_typedef] = ACTIONS(2239),
    [anon_sym_in] = ACTIONS(2239),
    [anon_sym_out] = ACTIONS(2239),
    [anon_sym_inout] = ACTIONS(2239),
    [anon_sym_virtual] = ACTIONS(2239),
    [anon_sym_extern] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym___attribute] = ACTIONS(2239),
    [anon_sym_using] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2241),
    [anon_sym___declspec] = ACTIONS(2239),
    [anon_sym___based] = ACTIONS(2239),
    [anon_sym___cdecl] = ACTIONS(2239),
    [anon_sym___clrcall] = ACTIONS(2239),
    [anon_sym___stdcall] = ACTIONS(2239),
    [anon_sym___fastcall] = ACTIONS(2239),
    [anon_sym___thiscall] = ACTIONS(2239),
    [anon_sym___vectorcall] = ACTIONS(2239),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_signed] = ACTIONS(2239),
    [anon_sym_unsigned] = ACTIONS(2239),
    [anon_sym_long] = ACTIONS(2239),
    [anon_sym_short] = ACTIONS(2239),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2239),
    [anon_sym_EQ] = ACTIONS(2241),
    [anon_sym_register] = ACTIONS(2239),
    [anon_sym_inline] = ACTIONS(2239),
    [anon_sym___inline] = ACTIONS(2239),
    [anon_sym___inline__] = ACTIONS(2239),
    [anon_sym___forceinline] = ACTIONS(2239),
    [anon_sym_thread_local] = ACTIONS(2239),
    [anon_sym___thread] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym__Nonnull] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [sym_primitive_type] = ACTIONS(2239),
    [anon_sym_enum] = ACTIONS(2239),
    [anon_sym_class] = ACTIONS(2239),
    [anon_sym_struct] = ACTIONS(2239),
    [anon_sym_union] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(2239),
    [anon_sym_else] = ACTIONS(2239),
    [anon_sym_switch] = ACTIONS(2239),
    [anon_sym_case] = ACTIONS(2239),
    [anon_sym_default] = ACTIONS(2239),
    [anon_sym_while] = ACTIONS(2239),
    [anon_sym_do] = ACTIONS(2239),
    [anon_sym_for] = ACTIONS(2239),
    [anon_sym_return] = ACTIONS(2239),
    [anon_sym_break] = ACTIONS(2239),
    [anon_sym_continue] = ACTIONS(2239),
    [anon_sym_goto] = ACTIONS(2239),
    [anon_sym___try] = ACTIONS(2239),
    [anon_sym___leave] = ACTIONS(2239),
    [anon_sym_not] = ACTIONS(2239),
    [anon_sym_compl] = ACTIONS(2239),
    [anon_sym_or] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_sizeof] = ACTIONS(2239),
    [anon_sym___alignof__] = ACTIONS(2239),
    [anon_sym___alignof] = ACTIONS(2239),
    [anon_sym__alignof] = ACTIONS(2239),
    [anon_sym_alignof] = ACTIONS(2239),
    [anon_sym__Alignof] = ACTIONS(2239),
    [anon_sym_offsetof] = ACTIONS(2239),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2239),
    [anon_sym___asm__] = ACTIONS(2239),
    [anon_sym___asm] = ACTIONS(2239),
    [anon_sym_DOT] = ACTIONS(2239),
    [sym_number_literal] = ACTIONS(2241),
    [anon_sym_L_SQUOTE] = ACTIONS(2241),
    [anon_sym_u_SQUOTE] = ACTIONS(2241),
    [anon_sym_U_SQUOTE] = ACTIONS(2241),
    [anon_sym_u8_SQUOTE] = ACTIONS(2241),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_L_DQUOTE] = ACTIONS(2241),
    [anon_sym_u_DQUOTE] = ACTIONS(2241),
    [anon_sym_U_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8_DQUOTE] = ACTIONS(2241),
    [anon_sym_DQUOTE] = ACTIONS(2241),
    [sym_true] = ACTIONS(2239),
    [sym_false] = ACTIONS(2239),
    [anon_sym_NULL] = ACTIONS(2239),
    [anon_sym_nullptr] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2239),
    [anon_sym_let] = ACTIONS(2239),
    [anon_sym_This] = ACTIONS(2239),
    [anon_sym_decltype] = ACTIONS(2239),
    [anon_sym_final] = ACTIONS(2239),
    [anon_sym_override] = ACTIONS(2239),
    [anon_sym_explicit] = ACTIONS(2239),
    [anon_sym_typename] = ACTIONS(2239),
    [anon_sym_export] = ACTIONS(2239),
    [anon_sym_module] = ACTIONS(2239),
    [anon_sym_import] = ACTIONS(2239),
    [anon_sym_template] = ACTIONS(2239),
    [anon_sym_GT2] = ACTIONS(2241),
    [anon_sym_operator] = ACTIONS(2239),
    [anon_sym_try] = ACTIONS(2239),
    [anon_sym_delete] = ACTIONS(2239),
    [anon_sym_throw] = ACTIONS(2239),
    [anon_sym_namespace] = ACTIONS(2239),
    [anon_sym_static_assert] = ACTIONS(2239),
    [anon_sym_concept] = ACTIONS(2239),
    [anon_sym_co_return] = ACTIONS(2239),
    [anon_sym_co_yield] = ACTIONS(2239),
    [anon_sym_R_DQUOTE] = ACTIONS(2241),
    [anon_sym_LR_DQUOTE] = ACTIONS(2241),
    [anon_sym_uR_DQUOTE] = ACTIONS(2241),
    [anon_sym_UR_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2241),
    [anon_sym_co_await] = ACTIONS(2239),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_requires] = ACTIONS(2239),
    [sym_this] = ACTIONS(2239),
    [anon_sym_discard] = ACTIONS(2239),
    [anon_sym_precise] = ACTIONS(2239),
    [anon_sym_shared] = ACTIONS(2239),
    [anon_sym_groupshared] = ACTIONS(2239),
    [anon_sym_uniform] = ACTIONS(2239),
    [anon_sym_row_major] = ACTIONS(2239),
    [anon_sym_column_major] = ACTIONS(2239),
    [anon_sym_globallycoherent] = ACTIONS(2239),
    [anon_sym_centroid] = ACTIONS(2239),
    [anon_sym_noperspective] = ACTIONS(2239),
    [anon_sym_nointerpolation] = ACTIONS(2239),
    [anon_sym_sample] = ACTIONS(2239),
    [anon_sym_linear] = ACTIONS(2239),
    [anon_sym_snorm] = ACTIONS(2239),
    [anon_sym_unorm] = ACTIONS(2239),
    [anon_sym_point] = ACTIONS(2239),
    [anon_sym_line] = ACTIONS(2239),
    [anon_sym_triangleadj] = ACTIONS(2239),
    [anon_sym_lineadj] = ACTIONS(2239),
    [anon_sym_triangle] = ACTIONS(2239),
    [anon_sym_cbuffer] = ACTIONS(2239),
    [anon_sym_interface] = ACTIONS(2239),
    [anon_sym_extension] = ACTIONS(2239),
    [anon_sym_where] = ACTIONS(2239),
    [anon_sym___exported] = ACTIONS(2239),
  },
  [219] = {
    [ts_builtin_sym_end] = ACTIONS(2282),
    [sym_identifier] = ACTIONS(2280),
    [aux_sym_preproc_include_token1] = ACTIONS(2280),
    [aux_sym_preproc_def_token1] = ACTIONS(2280),
    [anon_sym_COMMA] = ACTIONS(2282),
    [anon_sym_RPAREN] = ACTIONS(2282),
    [aux_sym_preproc_if_token1] = ACTIONS(2280),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2280),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2280),
    [sym_preproc_directive] = ACTIONS(2280),
    [anon_sym_LPAREN2] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(2282),
    [anon_sym_TILDE] = ACTIONS(2282),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2282),
    [anon_sym_PIPE_PIPE] = ACTIONS(2282),
    [anon_sym_AMP_AMP] = ACTIONS(2282),
    [anon_sym_AMP] = ACTIONS(2280),
    [anon_sym_COLON] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(2280),
    [anon_sym_typedef] = ACTIONS(2280),
    [anon_sym_in] = ACTIONS(2280),
    [anon_sym_out] = ACTIONS(2280),
    [anon_sym_inout] = ACTIONS(2280),
    [anon_sym_virtual] = ACTIONS(2280),
    [anon_sym_extern] = ACTIONS(2280),
    [anon_sym___attribute__] = ACTIONS(2280),
    [anon_sym___attribute] = ACTIONS(2280),
    [anon_sym_using] = ACTIONS(2280),
    [anon_sym_COLON_COLON] = ACTIONS(2282),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2282),
    [anon_sym___declspec] = ACTIONS(2280),
    [anon_sym___based] = ACTIONS(2280),
    [anon_sym___cdecl] = ACTIONS(2280),
    [anon_sym___clrcall] = ACTIONS(2280),
    [anon_sym___stdcall] = ACTIONS(2280),
    [anon_sym___fastcall] = ACTIONS(2280),
    [anon_sym___thiscall] = ACTIONS(2280),
    [anon_sym___vectorcall] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_signed] = ACTIONS(2280),
    [anon_sym_unsigned] = ACTIONS(2280),
    [anon_sym_long] = ACTIONS(2280),
    [anon_sym_short] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_EQ] = ACTIONS(2282),
    [anon_sym_register] = ACTIONS(2280),
    [anon_sym_inline] = ACTIONS(2280),
    [anon_sym___inline] = ACTIONS(2280),
    [anon_sym___inline__] = ACTIONS(2280),
    [anon_sym___forceinline] = ACTIONS(2280),
    [anon_sym_thread_local] = ACTIONS(2280),
    [anon_sym___thread] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_constexpr] = ACTIONS(2280),
    [anon_sym_volatile] = ACTIONS(2280),
    [anon_sym_restrict] = ACTIONS(2280),
    [anon_sym___restrict__] = ACTIONS(2280),
    [anon_sym__Atomic] = ACTIONS(2280),
    [anon_sym__Noreturn] = ACTIONS(2280),
    [anon_sym_noreturn] = ACTIONS(2280),
    [anon_sym__Nonnull] = ACTIONS(2280),
    [anon_sym_mutable] = ACTIONS(2280),
    [anon_sym_constinit] = ACTIONS(2280),
    [anon_sym_consteval] = ACTIONS(2280),
    [anon_sym_alignas] = ACTIONS(2280),
    [anon_sym__Alignas] = ACTIONS(2280),
    [sym_primitive_type] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_struct] = ACTIONS(2280),
    [anon_sym_union] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_goto] = ACTIONS(2280),
    [anon_sym___try] = ACTIONS(2280),
    [anon_sym___leave] = ACTIONS(2280),
    [anon_sym_not] = ACTIONS(2280),
    [anon_sym_compl] = ACTIONS(2280),
    [anon_sym_or] = ACTIONS(2280),
    [anon_sym_and] = ACTIONS(2280),
    [anon_sym_DASH_DASH] = ACTIONS(2282),
    [anon_sym_PLUS_PLUS] = ACTIONS(2282),
    [anon_sym_sizeof] = ACTIONS(2280),
    [anon_sym___alignof__] = ACTIONS(2280),
    [anon_sym___alignof] = ACTIONS(2280),
    [anon_sym__alignof] = ACTIONS(2280),
    [anon_sym_alignof] = ACTIONS(2280),
    [anon_sym__Alignof] = ACTIONS(2280),
    [anon_sym_offsetof] = ACTIONS(2280),
    [anon_sym__Generic] = ACTIONS(2280),
    [anon_sym_asm] = ACTIONS(2280),
    [anon_sym___asm__] = ACTIONS(2280),
    [anon_sym___asm] = ACTIONS(2280),
    [anon_sym_DOT] = ACTIONS(2280),
    [sym_number_literal] = ACTIONS(2282),
    [anon_sym_L_SQUOTE] = ACTIONS(2282),
    [anon_sym_u_SQUOTE] = ACTIONS(2282),
    [anon_sym_U_SQUOTE] = ACTIONS(2282),
    [anon_sym_u8_SQUOTE] = ACTIONS(2282),
    [anon_sym_SQUOTE] = ACTIONS(2282),
    [anon_sym_L_DQUOTE] = ACTIONS(2282),
    [anon_sym_u_DQUOTE] = ACTIONS(2282),
    [anon_sym_U_DQUOTE] = ACTIONS(2282),
    [anon_sym_u8_DQUOTE] = ACTIONS(2282),
    [anon_sym_DQUOTE] = ACTIONS(2282),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [anon_sym_NULL] = ACTIONS(2280),
    [anon_sym_nullptr] = ACTIONS(2280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_This] = ACTIONS(2280),
    [anon_sym_decltype] = ACTIONS(2280),
    [anon_sym_final] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_explicit] = ACTIONS(2280),
    [anon_sym_typename] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_template] = ACTIONS(2280),
    [anon_sym_GT2] = ACTIONS(2282),
    [anon_sym_operator] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_static_assert] = ACTIONS(2280),
    [anon_sym_concept] = ACTIONS(2280),
    [anon_sym_co_return] = ACTIONS(2280),
    [anon_sym_co_yield] = ACTIONS(2280),
    [anon_sym_R_DQUOTE] = ACTIONS(2282),
    [anon_sym_LR_DQUOTE] = ACTIONS(2282),
    [anon_sym_uR_DQUOTE] = ACTIONS(2282),
    [anon_sym_UR_DQUOTE] = ACTIONS(2282),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2282),
    [anon_sym_co_await] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_requires] = ACTIONS(2280),
    [sym_this] = ACTIONS(2280),
    [anon_sym_discard] = ACTIONS(2280),
    [anon_sym_precise] = ACTIONS(2280),
    [anon_sym_shared] = ACTIONS(2280),
    [anon_sym_groupshared] = ACTIONS(2280),
    [anon_sym_uniform] = ACTIONS(2280),
    [anon_sym_row_major] = ACTIONS(2280),
    [anon_sym_column_major] = ACTIONS(2280),
    [anon_sym_globallycoherent] = ACTIONS(2280),
    [anon_sym_centroid] = ACTIONS(2280),
    [anon_sym_noperspective] = ACTIONS(2280),
    [anon_sym_nointerpolation] = ACTIONS(2280),
    [anon_sym_sample] = ACTIONS(2280),
    [anon_sym_linear] = ACTIONS(2280),
    [anon_sym_snorm] = ACTIONS(2280),
    [anon_sym_unorm] = ACTIONS(2280),
    [anon_sym_point] = ACTIONS(2280),
    [anon_sym_line] = ACTIONS(2280),
    [anon_sym_triangleadj] = ACTIONS(2280),
    [anon_sym_lineadj] = ACTIONS(2280),
    [anon_sym_triangle] = ACTIONS(2280),
    [anon_sym_cbuffer] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_extension] = ACTIONS(2280),
    [anon_sym_where] = ACTIONS(2280),
    [anon_sym___exported] = ACTIONS(2280),
  },
  [220] = {
    [ts_builtin_sym_end] = ACTIONS(2286),
    [sym_identifier] = ACTIONS(2284),
    [aux_sym_preproc_include_token1] = ACTIONS(2284),
    [aux_sym_preproc_def_token1] = ACTIONS(2284),
    [anon_sym_COMMA] = ACTIONS(2286),
    [anon_sym_RPAREN] = ACTIONS(2286),
    [aux_sym_preproc_if_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2284),
    [sym_preproc_directive] = ACTIONS(2284),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_PIPE_PIPE] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_COLON] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_typedef] = ACTIONS(2284),
    [anon_sym_in] = ACTIONS(2284),
    [anon_sym_out] = ACTIONS(2284),
    [anon_sym_inout] = ACTIONS(2284),
    [anon_sym_virtual] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_using] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym___cdecl] = ACTIONS(2284),
    [anon_sym___clrcall] = ACTIONS(2284),
    [anon_sym___stdcall] = ACTIONS(2284),
    [anon_sym___fastcall] = ACTIONS(2284),
    [anon_sym___thiscall] = ACTIONS(2284),
    [anon_sym___vectorcall] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_signed] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_EQ] = ACTIONS(2286),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_else] = ACTIONS(2284),
    [anon_sym_switch] = ACTIONS(2284),
    [anon_sym_case] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_goto] = ACTIONS(2284),
    [anon_sym___try] = ACTIONS(2284),
    [anon_sym___leave] = ACTIONS(2284),
    [anon_sym_not] = ACTIONS(2284),
    [anon_sym_compl] = ACTIONS(2284),
    [anon_sym_or] = ACTIONS(2284),
    [anon_sym_and] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_sizeof] = ACTIONS(2284),
    [anon_sym___alignof__] = ACTIONS(2284),
    [anon_sym___alignof] = ACTIONS(2284),
    [anon_sym__alignof] = ACTIONS(2284),
    [anon_sym_alignof] = ACTIONS(2284),
    [anon_sym__Alignof] = ACTIONS(2284),
    [anon_sym_offsetof] = ACTIONS(2284),
    [anon_sym__Generic] = ACTIONS(2284),
    [anon_sym_asm] = ACTIONS(2284),
    [anon_sym___asm__] = ACTIONS(2284),
    [anon_sym___asm] = ACTIONS(2284),
    [anon_sym_DOT] = ACTIONS(2284),
    [sym_number_literal] = ACTIONS(2286),
    [anon_sym_L_SQUOTE] = ACTIONS(2286),
    [anon_sym_u_SQUOTE] = ACTIONS(2286),
    [anon_sym_U_SQUOTE] = ACTIONS(2286),
    [anon_sym_u8_SQUOTE] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_L_DQUOTE] = ACTIONS(2286),
    [anon_sym_u_DQUOTE] = ACTIONS(2286),
    [anon_sym_U_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8_DQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [sym_true] = ACTIONS(2284),
    [sym_false] = ACTIONS(2284),
    [anon_sym_NULL] = ACTIONS(2284),
    [anon_sym_nullptr] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_This] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [anon_sym_final] = ACTIONS(2284),
    [anon_sym_override] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_typename] = ACTIONS(2284),
    [anon_sym_export] = ACTIONS(2284),
    [anon_sym_module] = ACTIONS(2284),
    [anon_sym_import] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_GT2] = ACTIONS(2286),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_delete] = ACTIONS(2284),
    [anon_sym_throw] = ACTIONS(2284),
    [anon_sym_namespace] = ACTIONS(2284),
    [anon_sym_static_assert] = ACTIONS(2284),
    [anon_sym_concept] = ACTIONS(2284),
    [anon_sym_co_return] = ACTIONS(2284),
    [anon_sym_co_yield] = ACTIONS(2284),
    [anon_sym_R_DQUOTE] = ACTIONS(2286),
    [anon_sym_LR_DQUOTE] = ACTIONS(2286),
    [anon_sym_uR_DQUOTE] = ACTIONS(2286),
    [anon_sym_UR_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2286),
    [anon_sym_co_await] = ACTIONS(2284),
    [anon_sym_new] = ACTIONS(2284),
    [anon_sym_requires] = ACTIONS(2284),
    [sym_this] = ACTIONS(2284),
    [anon_sym_discard] = ACTIONS(2284),
    [anon_sym_precise] = ACTIONS(2284),
    [anon_sym_shared] = ACTIONS(2284),
    [anon_sym_groupshared] = ACTIONS(2284),
    [anon_sym_uniform] = ACTIONS(2284),
    [anon_sym_row_major] = ACTIONS(2284),
    [anon_sym_column_major] = ACTIONS(2284),
    [anon_sym_globallycoherent] = ACTIONS(2284),
    [anon_sym_centroid] = ACTIONS(2284),
    [anon_sym_noperspective] = ACTIONS(2284),
    [anon_sym_nointerpolation] = ACTIONS(2284),
    [anon_sym_sample] = ACTIONS(2284),
    [anon_sym_linear] = ACTIONS(2284),
    [anon_sym_snorm] = ACTIONS(2284),
    [anon_sym_unorm] = ACTIONS(2284),
    [anon_sym_point] = ACTIONS(2284),
    [anon_sym_line] = ACTIONS(2284),
    [anon_sym_triangleadj] = ACTIONS(2284),
    [anon_sym_lineadj] = ACTIONS(2284),
    [anon_sym_triangle] = ACTIONS(2284),
    [anon_sym_cbuffer] = ACTIONS(2284),
    [anon_sym_interface] = ACTIONS(2284),
    [anon_sym_extension] = ACTIONS(2284),
    [anon_sym_where] = ACTIONS(2284),
    [anon_sym___exported] = ACTIONS(2284),
  },
  [221] = {
    [ts_builtin_sym_end] = ACTIONS(2302),
    [sym_identifier] = ACTIONS(2300),
    [aux_sym_preproc_include_token1] = ACTIONS(2300),
    [aux_sym_preproc_def_token1] = ACTIONS(2300),
    [anon_sym_COMMA] = ACTIONS(2302),
    [anon_sym_RPAREN] = ACTIONS(2302),
    [aux_sym_preproc_if_token1] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2300),
    [sym_preproc_directive] = ACTIONS(2300),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_BANG] = ACTIONS(2302),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2302),
    [anon_sym_PIPE_PIPE] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_COLON] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym_typedef] = ACTIONS(2300),
    [anon_sym_in] = ACTIONS(2300),
    [anon_sym_out] = ACTIONS(2300),
    [anon_sym_inout] = ACTIONS(2300),
    [anon_sym_virtual] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym___attribute] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2302),
    [anon_sym___declspec] = ACTIONS(2300),
    [anon_sym___based] = ACTIONS(2300),
    [anon_sym___cdecl] = ACTIONS(2300),
    [anon_sym___clrcall] = ACTIONS(2300),
    [anon_sym___stdcall] = ACTIONS(2300),
    [anon_sym___fastcall] = ACTIONS(2300),
    [anon_sym___thiscall] = ACTIONS(2300),
    [anon_sym___vectorcall] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_signed] = ACTIONS(2300),
    [anon_sym_unsigned] = ACTIONS(2300),
    [anon_sym_long] = ACTIONS(2300),
    [anon_sym_short] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_register] = ACTIONS(2300),
    [anon_sym_inline] = ACTIONS(2300),
    [anon_sym___inline] = ACTIONS(2300),
    [anon_sym___inline__] = ACTIONS(2300),
    [anon_sym___forceinline] = ACTIONS(2300),
    [anon_sym_thread_local] = ACTIONS(2300),
    [anon_sym___thread] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym__Nonnull] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [sym_primitive_type] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_struct] = ACTIONS(2300),
    [anon_sym_union] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_else] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_case] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_goto] = ACTIONS(2300),
    [anon_sym___try] = ACTIONS(2300),
    [anon_sym___leave] = ACTIONS(2300),
    [anon_sym_not] = ACTIONS(2300),
    [anon_sym_compl] = ACTIONS(2300),
    [anon_sym_or] = ACTIONS(2300),
    [anon_sym_and] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_sizeof] = ACTIONS(2300),
    [anon_sym___alignof__] = ACTIONS(2300),
    [anon_sym___alignof] = ACTIONS(2300),
    [anon_sym__alignof] = ACTIONS(2300),
    [anon_sym_alignof] = ACTIONS(2300),
    [anon_sym__Alignof] = ACTIONS(2300),
    [anon_sym_offsetof] = ACTIONS(2300),
    [anon_sym__Generic] = ACTIONS(2300),
    [anon_sym_asm] = ACTIONS(2300),
    [anon_sym___asm__] = ACTIONS(2300),
    [anon_sym___asm] = ACTIONS(2300),
    [anon_sym_DOT] = ACTIONS(2300),
    [sym_number_literal] = ACTIONS(2302),
    [anon_sym_L_SQUOTE] = ACTIONS(2302),
    [anon_sym_u_SQUOTE] = ACTIONS(2302),
    [anon_sym_U_SQUOTE] = ACTIONS(2302),
    [anon_sym_u8_SQUOTE] = ACTIONS(2302),
    [anon_sym_SQUOTE] = ACTIONS(2302),
    [anon_sym_L_DQUOTE] = ACTIONS(2302),
    [anon_sym_u_DQUOTE] = ACTIONS(2302),
    [anon_sym_U_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8_DQUOTE] = ACTIONS(2302),
    [anon_sym_DQUOTE] = ACTIONS(2302),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [anon_sym_NULL] = ACTIONS(2300),
    [anon_sym_nullptr] = ACTIONS(2300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_This] = ACTIONS(2300),
    [anon_sym_decltype] = ACTIONS(2300),
    [anon_sym_final] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_explicit] = ACTIONS(2300),
    [anon_sym_typename] = ACTIONS(2300),
    [anon_sym_export] = ACTIONS(2300),
    [anon_sym_module] = ACTIONS(2300),
    [anon_sym_import] = ACTIONS(2300),
    [anon_sym_template] = ACTIONS(2300),
    [anon_sym_GT2] = ACTIONS(2302),
    [anon_sym_operator] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_static_assert] = ACTIONS(2300),
    [anon_sym_concept] = ACTIONS(2300),
    [anon_sym_co_return] = ACTIONS(2300),
    [anon_sym_co_yield] = ACTIONS(2300),
    [anon_sym_R_DQUOTE] = ACTIONS(2302),
    [anon_sym_LR_DQUOTE] = ACTIONS(2302),
    [anon_sym_uR_DQUOTE] = ACTIONS(2302),
    [anon_sym_UR_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2302),
    [anon_sym_co_await] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_requires] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [anon_sym_discard] = ACTIONS(2300),
    [anon_sym_precise] = ACTIONS(2300),
    [anon_sym_shared] = ACTIONS(2300),
    [anon_sym_groupshared] = ACTIONS(2300),
    [anon_sym_uniform] = ACTIONS(2300),
    [anon_sym_row_major] = ACTIONS(2300),
    [anon_sym_column_major] = ACTIONS(2300),
    [anon_sym_globallycoherent] = ACTIONS(2300),
    [anon_sym_centroid] = ACTIONS(2300),
    [anon_sym_noperspective] = ACTIONS(2300),
    [anon_sym_nointerpolation] = ACTIONS(2300),
    [anon_sym_sample] = ACTIONS(2300),
    [anon_sym_linear] = ACTIONS(2300),
    [anon_sym_snorm] = ACTIONS(2300),
    [anon_sym_unorm] = ACTIONS(2300),
    [anon_sym_point] = ACTIONS(2300),
    [anon_sym_line] = ACTIONS(2300),
    [anon_sym_triangleadj] = ACTIONS(2300),
    [anon_sym_lineadj] = ACTIONS(2300),
    [anon_sym_triangle] = ACTIONS(2300),
    [anon_sym_cbuffer] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_extension] = ACTIONS(2300),
    [anon_sym_where] = ACTIONS(2300),
    [anon_sym___exported] = ACTIONS(2300),
  },
  [222] = {
    [ts_builtin_sym_end] = ACTIONS(2294),
    [sym_identifier] = ACTIONS(2292),
    [aux_sym_preproc_include_token1] = ACTIONS(2292),
    [aux_sym_preproc_def_token1] = ACTIONS(2292),
    [anon_sym_COMMA] = ACTIONS(2294),
    [anon_sym_RPAREN] = ACTIONS(2294),
    [aux_sym_preproc_if_token1] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2292),
    [sym_preproc_directive] = ACTIONS(2292),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_PIPE_PIPE] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_COLON] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym_typedef] = ACTIONS(2292),
    [anon_sym_in] = ACTIONS(2292),
    [anon_sym_out] = ACTIONS(2292),
    [anon_sym_inout] = ACTIONS(2292),
    [anon_sym_virtual] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym___attribute] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2294),
    [anon_sym___declspec] = ACTIONS(2292),
    [anon_sym___based] = ACTIONS(2292),
    [anon_sym___cdecl] = ACTIONS(2292),
    [anon_sym___clrcall] = ACTIONS(2292),
    [anon_sym___stdcall] = ACTIONS(2292),
    [anon_sym___fastcall] = ACTIONS(2292),
    [anon_sym___thiscall] = ACTIONS(2292),
    [anon_sym___vectorcall] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_signed] = ACTIONS(2292),
    [anon_sym_unsigned] = ACTIONS(2292),
    [anon_sym_long] = ACTIONS(2292),
    [anon_sym_short] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_EQ] = ACTIONS(2294),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym___inline] = ACTIONS(2292),
    [anon_sym___inline__] = ACTIONS(2292),
    [anon_sym___forceinline] = ACTIONS(2292),
    [anon_sym_thread_local] = ACTIONS(2292),
    [anon_sym___thread] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym__Nonnull] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [sym_primitive_type] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_struct] = ACTIONS(2292),
    [anon_sym_union] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_else] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_case] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_goto] = ACTIONS(2292),
    [anon_sym___try] = ACTIONS(2292),
    [anon_sym___leave] = ACTIONS(2292),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_compl] = ACTIONS(2292),
    [anon_sym_or] = ACTIONS(2292),
    [anon_sym_and] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_sizeof] = ACTIONS(2292),
    [anon_sym___alignof__] = ACTIONS(2292),
    [anon_sym___alignof] = ACTIONS(2292),
    [anon_sym__alignof] = ACTIONS(2292),
    [anon_sym_alignof] = ACTIONS(2292),
    [anon_sym__Alignof] = ACTIONS(2292),
    [anon_sym_offsetof] = ACTIONS(2292),
    [anon_sym__Generic] = ACTIONS(2292),
    [anon_sym_asm] = ACTIONS(2292),
    [anon_sym___asm__] = ACTIONS(2292),
    [anon_sym___asm] = ACTIONS(2292),
    [anon_sym_DOT] = ACTIONS(2292),
    [sym_number_literal] = ACTIONS(2294),
    [anon_sym_L_SQUOTE] = ACTIONS(2294),
    [anon_sym_u_SQUOTE] = ACTIONS(2294),
    [anon_sym_U_SQUOTE] = ACTIONS(2294),
    [anon_sym_u8_SQUOTE] = ACTIONS(2294),
    [anon_sym_SQUOTE] = ACTIONS(2294),
    [anon_sym_L_DQUOTE] = ACTIONS(2294),
    [anon_sym_u_DQUOTE] = ACTIONS(2294),
    [anon_sym_U_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8_DQUOTE] = ACTIONS(2294),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [anon_sym_NULL] = ACTIONS(2292),
    [anon_sym_nullptr] = ACTIONS(2292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_This] = ACTIONS(2292),
    [anon_sym_decltype] = ACTIONS(2292),
    [anon_sym_final] = ACTIONS(2292),
    [anon_sym_override] = ACTIONS(2292),
    [anon_sym_explicit] = ACTIONS(2292),
    [anon_sym_typename] = ACTIONS(2292),
    [anon_sym_export] = ACTIONS(2292),
    [anon_sym_module] = ACTIONS(2292),
    [anon_sym_import] = ACTIONS(2292),
    [anon_sym_template] = ACTIONS(2292),
    [anon_sym_GT2] = ACTIONS(2294),
    [anon_sym_operator] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_static_assert] = ACTIONS(2292),
    [anon_sym_concept] = ACTIONS(2292),
    [anon_sym_co_return] = ACTIONS(2292),
    [anon_sym_co_yield] = ACTIONS(2292),
    [anon_sym_R_DQUOTE] = ACTIONS(2294),
    [anon_sym_LR_DQUOTE] = ACTIONS(2294),
    [anon_sym_uR_DQUOTE] = ACTIONS(2294),
    [anon_sym_UR_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2294),
    [anon_sym_co_await] = ACTIONS(2292),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_requires] = ACTIONS(2292),
    [sym_this] = ACTIONS(2292),
    [anon_sym_discard] = ACTIONS(2292),
    [anon_sym_precise] = ACTIONS(2292),
    [anon_sym_shared] = ACTIONS(2292),
    [anon_sym_groupshared] = ACTIONS(2292),
    [anon_sym_uniform] = ACTIONS(2292),
    [anon_sym_row_major] = ACTIONS(2292),
    [anon_sym_column_major] = ACTIONS(2292),
    [anon_sym_globallycoherent] = ACTIONS(2292),
    [anon_sym_centroid] = ACTIONS(2292),
    [anon_sym_noperspective] = ACTIONS(2292),
    [anon_sym_nointerpolation] = ACTIONS(2292),
    [anon_sym_sample] = ACTIONS(2292),
    [anon_sym_linear] = ACTIONS(2292),
    [anon_sym_snorm] = ACTIONS(2292),
    [anon_sym_unorm] = ACTIONS(2292),
    [anon_sym_point] = ACTIONS(2292),
    [anon_sym_line] = ACTIONS(2292),
    [anon_sym_triangleadj] = ACTIONS(2292),
    [anon_sym_lineadj] = ACTIONS(2292),
    [anon_sym_triangle] = ACTIONS(2292),
    [anon_sym_cbuffer] = ACTIONS(2292),
    [anon_sym_interface] = ACTIONS(2292),
    [anon_sym_extension] = ACTIONS(2292),
    [anon_sym_where] = ACTIONS(2292),
    [anon_sym___exported] = ACTIONS(2292),
  },
  [223] = {
    [ts_builtin_sym_end] = ACTIONS(2298),
    [sym_identifier] = ACTIONS(2296),
    [aux_sym_preproc_include_token1] = ACTIONS(2296),
    [aux_sym_preproc_def_token1] = ACTIONS(2296),
    [anon_sym_COMMA] = ACTIONS(2298),
    [anon_sym_RPAREN] = ACTIONS(2298),
    [aux_sym_preproc_if_token1] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2296),
    [sym_preproc_directive] = ACTIONS(2296),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_BANG] = ACTIONS(2298),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2298),
    [anon_sym_PIPE_PIPE] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_COLON] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2298),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym_typedef] = ACTIONS(2296),
    [anon_sym_in] = ACTIONS(2296),
    [anon_sym_out] = ACTIONS(2296),
    [anon_sym_inout] = ACTIONS(2296),
    [anon_sym_virtual] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym___attribute] = ACTIONS(2296),
    [anon_sym_using] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2298),
    [anon_sym___declspec] = ACTIONS(2296),
    [anon_sym___based] = ACTIONS(2296),
    [anon_sym___cdecl] = ACTIONS(2296),
    [anon_sym___clrcall] = ACTIONS(2296),
    [anon_sym___stdcall] = ACTIONS(2296),
    [anon_sym___fastcall] = ACTIONS(2296),
    [anon_sym___thiscall] = ACTIONS(2296),
    [anon_sym___vectorcall] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_signed] = ACTIONS(2296),
    [anon_sym_unsigned] = ACTIONS(2296),
    [anon_sym_long] = ACTIONS(2296),
    [anon_sym_short] = ACTIONS(2296),
    [anon_sym_LBRACK] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_EQ] = ACTIONS(2298),
    [anon_sym_register] = ACTIONS(2296),
    [anon_sym_inline] = ACTIONS(2296),
    [anon_sym___inline] = ACTIONS(2296),
    [anon_sym___inline__] = ACTIONS(2296),
    [anon_sym___forceinline] = ACTIONS(2296),
    [anon_sym_thread_local] = ACTIONS(2296),
    [anon_sym___thread] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym__Nonnull] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [sym_primitive_type] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2296),
    [anon_sym_class] = ACTIONS(2296),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_union] = ACTIONS(2296),
    [anon_sym_if] = ACTIONS(2296),
    [anon_sym_else] = ACTIONS(2296),
    [anon_sym_switch] = ACTIONS(2296),
    [anon_sym_case] = ACTIONS(2296),
    [anon_sym_default] = ACTIONS(2296),
    [anon_sym_while] = ACTIONS(2296),
    [anon_sym_do] = ACTIONS(2296),
    [anon_sym_for] = ACTIONS(2296),
    [anon_sym_return] = ACTIONS(2296),
    [anon_sym_break] = ACTIONS(2296),
    [anon_sym_continue] = ACTIONS(2296),
    [anon_sym_goto] = ACTIONS(2296),
    [anon_sym___try] = ACTIONS(2296),
    [anon_sym___leave] = ACTIONS(2296),
    [anon_sym_not] = ACTIONS(2296),
    [anon_sym_compl] = ACTIONS(2296),
    [anon_sym_or] = ACTIONS(2296),
    [anon_sym_and] = ACTIONS(2296),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_sizeof] = ACTIONS(2296),
    [anon_sym___alignof__] = ACTIONS(2296),
    [anon_sym___alignof] = ACTIONS(2296),
    [anon_sym__alignof] = ACTIONS(2296),
    [anon_sym_alignof] = ACTIONS(2296),
    [anon_sym__Alignof] = ACTIONS(2296),
    [anon_sym_offsetof] = ACTIONS(2296),
    [anon_sym__Generic] = ACTIONS(2296),
    [anon_sym_asm] = ACTIONS(2296),
    [anon_sym___asm__] = ACTIONS(2296),
    [anon_sym___asm] = ACTIONS(2296),
    [anon_sym_DOT] = ACTIONS(2296),
    [sym_number_literal] = ACTIONS(2298),
    [anon_sym_L_SQUOTE] = ACTIONS(2298),
    [anon_sym_u_SQUOTE] = ACTIONS(2298),
    [anon_sym_U_SQUOTE] = ACTIONS(2298),
    [anon_sym_u8_SQUOTE] = ACTIONS(2298),
    [anon_sym_SQUOTE] = ACTIONS(2298),
    [anon_sym_L_DQUOTE] = ACTIONS(2298),
    [anon_sym_u_DQUOTE] = ACTIONS(2298),
    [anon_sym_U_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8_DQUOTE] = ACTIONS(2298),
    [anon_sym_DQUOTE] = ACTIONS(2298),
    [sym_true] = ACTIONS(2296),
    [sym_false] = ACTIONS(2296),
    [anon_sym_NULL] = ACTIONS(2296),
    [anon_sym_nullptr] = ACTIONS(2296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_This] = ACTIONS(2296),
    [anon_sym_decltype] = ACTIONS(2296),
    [anon_sym_final] = ACTIONS(2296),
    [anon_sym_override] = ACTIONS(2296),
    [anon_sym_explicit] = ACTIONS(2296),
    [anon_sym_typename] = ACTIONS(2296),
    [anon_sym_export] = ACTIONS(2296),
    [anon_sym_module] = ACTIONS(2296),
    [anon_sym_import] = ACTIONS(2296),
    [anon_sym_template] = ACTIONS(2296),
    [anon_sym_GT2] = ACTIONS(2298),
    [anon_sym_operator] = ACTIONS(2296),
    [anon_sym_try] = ACTIONS(2296),
    [anon_sym_delete] = ACTIONS(2296),
    [anon_sym_throw] = ACTIONS(2296),
    [anon_sym_namespace] = ACTIONS(2296),
    [anon_sym_static_assert] = ACTIONS(2296),
    [anon_sym_concept] = ACTIONS(2296),
    [anon_sym_co_return] = ACTIONS(2296),
    [anon_sym_co_yield] = ACTIONS(2296),
    [anon_sym_R_DQUOTE] = ACTIONS(2298),
    [anon_sym_LR_DQUOTE] = ACTIONS(2298),
    [anon_sym_uR_DQUOTE] = ACTIONS(2298),
    [anon_sym_UR_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2298),
    [anon_sym_co_await] = ACTIONS(2296),
    [anon_sym_new] = ACTIONS(2296),
    [anon_sym_requires] = ACTIONS(2296),
    [sym_this] = ACTIONS(2296),
    [anon_sym_discard] = ACTIONS(2296),
    [anon_sym_precise] = ACTIONS(2296),
    [anon_sym_shared] = ACTIONS(2296),
    [anon_sym_groupshared] = ACTIONS(2296),
    [anon_sym_uniform] = ACTIONS(2296),
    [anon_sym_row_major] = ACTIONS(2296),
    [anon_sym_column_major] = ACTIONS(2296),
    [anon_sym_globallycoherent] = ACTIONS(2296),
    [anon_sym_centroid] = ACTIONS(2296),
    [anon_sym_noperspective] = ACTIONS(2296),
    [anon_sym_nointerpolation] = ACTIONS(2296),
    [anon_sym_sample] = ACTIONS(2296),
    [anon_sym_linear] = ACTIONS(2296),
    [anon_sym_snorm] = ACTIONS(2296),
    [anon_sym_unorm] = ACTIONS(2296),
    [anon_sym_point] = ACTIONS(2296),
    [anon_sym_line] = ACTIONS(2296),
    [anon_sym_triangleadj] = ACTIONS(2296),
    [anon_sym_lineadj] = ACTIONS(2296),
    [anon_sym_triangle] = ACTIONS(2296),
    [anon_sym_cbuffer] = ACTIONS(2296),
    [anon_sym_interface] = ACTIONS(2296),
    [anon_sym_extension] = ACTIONS(2296),
    [anon_sym_where] = ACTIONS(2296),
    [anon_sym___exported] = ACTIONS(2296),
  },
  [224] = {
    [ts_builtin_sym_end] = ACTIONS(2262),
    [sym_identifier] = ACTIONS(2260),
    [aux_sym_preproc_include_token1] = ACTIONS(2260),
    [aux_sym_preproc_def_token1] = ACTIONS(2260),
    [anon_sym_COMMA] = ACTIONS(2262),
    [anon_sym_RPAREN] = ACTIONS(2262),
    [aux_sym_preproc_if_token1] = ACTIONS(2260),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2260),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2260),
    [sym_preproc_directive] = ACTIONS(2260),
    [anon_sym_LPAREN2] = ACTIONS(2262),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2262),
    [anon_sym_PIPE_PIPE] = ACTIONS(2262),
    [anon_sym_AMP_AMP] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_COLON] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym___extension__] = ACTIONS(2260),
    [anon_sym_typedef] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(2260),
    [anon_sym_out] = ACTIONS(2260),
    [anon_sym_inout] = ACTIONS(2260),
    [anon_sym_virtual] = ACTIONS(2260),
    [anon_sym_extern] = ACTIONS(2260),
    [anon_sym___attribute__] = ACTIONS(2260),
    [anon_sym___attribute] = ACTIONS(2260),
    [anon_sym_using] = ACTIONS(2260),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2262),
    [anon_sym___declspec] = ACTIONS(2260),
    [anon_sym___based] = ACTIONS(2260),
    [anon_sym___cdecl] = ACTIONS(2260),
    [anon_sym___clrcall] = ACTIONS(2260),
    [anon_sym___stdcall] = ACTIONS(2260),
    [anon_sym___fastcall] = ACTIONS(2260),
    [anon_sym___thiscall] = ACTIONS(2260),
    [anon_sym___vectorcall] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_signed] = ACTIONS(2260),
    [anon_sym_unsigned] = ACTIONS(2260),
    [anon_sym_long] = ACTIONS(2260),
    [anon_sym_short] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_EQ] = ACTIONS(2262),
    [anon_sym_register] = ACTIONS(2260),
    [anon_sym_inline] = ACTIONS(2260),
    [anon_sym___inline] = ACTIONS(2260),
    [anon_sym___inline__] = ACTIONS(2260),
    [anon_sym___forceinline] = ACTIONS(2260),
    [anon_sym_thread_local] = ACTIONS(2260),
    [anon_sym___thread] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_constexpr] = ACTIONS(2260),
    [anon_sym_volatile] = ACTIONS(2260),
    [anon_sym_restrict] = ACTIONS(2260),
    [anon_sym___restrict__] = ACTIONS(2260),
    [anon_sym__Atomic] = ACTIONS(2260),
    [anon_sym__Noreturn] = ACTIONS(2260),
    [anon_sym_noreturn] = ACTIONS(2260),
    [anon_sym__Nonnull] = ACTIONS(2260),
    [anon_sym_mutable] = ACTIONS(2260),
    [anon_sym_constinit] = ACTIONS(2260),
    [anon_sym_consteval] = ACTIONS(2260),
    [anon_sym_alignas] = ACTIONS(2260),
    [anon_sym__Alignas] = ACTIONS(2260),
    [sym_primitive_type] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
    [anon_sym_class] = ACTIONS(2260),
    [anon_sym_struct] = ACTIONS(2260),
    [anon_sym_union] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_else] = ACTIONS(2260),
    [anon_sym_switch] = ACTIONS(2260),
    [anon_sym_case] = ACTIONS(2260),
    [anon_sym_default] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_do] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_goto] = ACTIONS(2260),
    [anon_sym___try] = ACTIONS(2260),
    [anon_sym___leave] = ACTIONS(2260),
    [anon_sym_not] = ACTIONS(2260),
    [anon_sym_compl] = ACTIONS(2260),
    [anon_sym_or] = ACTIONS(2260),
    [anon_sym_and] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_sizeof] = ACTIONS(2260),
    [anon_sym___alignof__] = ACTIONS(2260),
    [anon_sym___alignof] = ACTIONS(2260),
    [anon_sym__alignof] = ACTIONS(2260),
    [anon_sym_alignof] = ACTIONS(2260),
    [anon_sym__Alignof] = ACTIONS(2260),
    [anon_sym_offsetof] = ACTIONS(2260),
    [anon_sym__Generic] = ACTIONS(2260),
    [anon_sym_asm] = ACTIONS(2260),
    [anon_sym___asm__] = ACTIONS(2260),
    [anon_sym___asm] = ACTIONS(2260),
    [anon_sym_DOT] = ACTIONS(2260),
    [sym_number_literal] = ACTIONS(2262),
    [anon_sym_L_SQUOTE] = ACTIONS(2262),
    [anon_sym_u_SQUOTE] = ACTIONS(2262),
    [anon_sym_U_SQUOTE] = ACTIONS(2262),
    [anon_sym_u8_SQUOTE] = ACTIONS(2262),
    [anon_sym_SQUOTE] = ACTIONS(2262),
    [anon_sym_L_DQUOTE] = ACTIONS(2262),
    [anon_sym_u_DQUOTE] = ACTIONS(2262),
    [anon_sym_U_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8_DQUOTE] = ACTIONS(2262),
    [anon_sym_DQUOTE] = ACTIONS(2262),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [anon_sym_NULL] = ACTIONS(2260),
    [anon_sym_nullptr] = ACTIONS(2260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_This] = ACTIONS(2260),
    [anon_sym_decltype] = ACTIONS(2260),
    [anon_sym_final] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
    [anon_sym_explicit] = ACTIONS(2260),
    [anon_sym_typename] = ACTIONS(2260),
    [anon_sym_export] = ACTIONS(2260),
    [anon_sym_module] = ACTIONS(2260),
    [anon_sym_import] = ACTIONS(2260),
    [anon_sym_template] = ACTIONS(2260),
    [anon_sym_GT2] = ACTIONS(2262),
    [anon_sym_operator] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_throw] = ACTIONS(2260),
    [anon_sym_namespace] = ACTIONS(2260),
    [anon_sym_static_assert] = ACTIONS(2260),
    [anon_sym_concept] = ACTIONS(2260),
    [anon_sym_co_return] = ACTIONS(2260),
    [anon_sym_co_yield] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2260),
    [anon_sym_new] = ACTIONS(2260),
    [anon_sym_requires] = ACTIONS(2260),
    [sym_this] = ACTIONS(2260),
    [anon_sym_discard] = ACTIONS(2260),
    [anon_sym_precise] = ACTIONS(2260),
    [anon_sym_shared] = ACTIONS(2260),
    [anon_sym_groupshared] = ACTIONS(2260),
    [anon_sym_uniform] = ACTIONS(2260),
    [anon_sym_row_major] = ACTIONS(2260),
    [anon_sym_column_major] = ACTIONS(2260),
    [anon_sym_globallycoherent] = ACTIONS(2260),
    [anon_sym_centroid] = ACTIONS(2260),
    [anon_sym_noperspective] = ACTIONS(2260),
    [anon_sym_nointerpolation] = ACTIONS(2260),
    [anon_sym_sample] = ACTIONS(2260),
    [anon_sym_linear] = ACTIONS(2260),
    [anon_sym_snorm] = ACTIONS(2260),
    [anon_sym_unorm] = ACTIONS(2260),
    [anon_sym_point] = ACTIONS(2260),
    [anon_sym_line] = ACTIONS(2260),
    [anon_sym_triangleadj] = ACTIONS(2260),
    [anon_sym_lineadj] = ACTIONS(2260),
    [anon_sym_triangle] = ACTIONS(2260),
    [anon_sym_cbuffer] = ACTIONS(2260),
    [anon_sym_interface] = ACTIONS(2260),
    [anon_sym_extension] = ACTIONS(2260),
    [anon_sym_where] = ACTIONS(2260),
    [anon_sym___exported] = ACTIONS(2260),
  },
  [225] = {
    [sym_preproc_def] = STATE(249),
    [sym_preproc_function_def] = STATE(249),
    [sym_preproc_call] = STATE(249),
    [sym_preproc_if_in_field_declaration_list] = STATE(249),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(249),
    [sym_preproc_else_in_field_declaration_list] = STATE(10827),
    [sym_preproc_elif_in_field_declaration_list] = STATE(10827),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(10827),
    [sym_type_definition] = STATE(249),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7124),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7905),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(249),
    [sym_field_declaration] = STATE(249),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2677),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(249),
    [sym_operator_cast] = STATE(9116),
    [sym_inline_method_definition] = STATE(249),
    [sym__constructor_specifiers] = STATE(2677),
    [sym_operator_cast_definition] = STATE(249),
    [sym_operator_cast_declaration] = STATE(249),
    [sym_constructor_or_destructor_definition] = STATE(249),
    [sym_constructor_or_destructor_declaration] = STATE(249),
    [sym_friend_declaration] = STATE(249),
    [sym_access_specifier] = STATE(11693),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(249),
    [sym_alias_declaration] = STATE(249),
    [sym_static_assert_declaration] = STATE(249),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9116),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(249),
    [sym_subscript_declaration] = STATE(249),
    [sym_property_declaration] = STATE(249),
    [sym_associatedtype_declaration] = STATE(249),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(249),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9502),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2677),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(2432),
    [aux_sym_preproc_if_token1] = ACTIONS(2434),
    [aux_sym_preproc_if_token2] = ACTIONS(2436),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2438),
    [aux_sym_preproc_else_token1] = ACTIONS(2440),
    [aux_sym_preproc_elif_token1] = ACTIONS(2442),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2444),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2444),
    [sym_preproc_directive] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym___extension__] = ACTIONS(2458),
    [anon_sym_typedef] = ACTIONS(2460),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2468),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(2484),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2486),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(2494),
    [anon_sym___subscript] = ACTIONS(2496),
    [anon_sym_property] = ACTIONS(2498),
    [anon_sym_associatedtype] = ACTIONS(2500),
  },
  [226] = {
    [sym_preproc_def] = STATE(232),
    [sym_preproc_function_def] = STATE(232),
    [sym_preproc_call] = STATE(232),
    [sym_preproc_if_in_field_declaration_list] = STATE(232),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(232),
    [sym_preproc_else_in_field_declaration_list] = STATE(11599),
    [sym_preproc_elif_in_field_declaration_list] = STATE(11599),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(11599),
    [sym_type_definition] = STATE(232),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7124),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7905),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(232),
    [sym_field_declaration] = STATE(232),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2677),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(232),
    [sym_operator_cast] = STATE(9116),
    [sym_inline_method_definition] = STATE(232),
    [sym__constructor_specifiers] = STATE(2677),
    [sym_operator_cast_definition] = STATE(232),
    [sym_operator_cast_declaration] = STATE(232),
    [sym_constructor_or_destructor_definition] = STATE(232),
    [sym_constructor_or_destructor_declaration] = STATE(232),
    [sym_friend_declaration] = STATE(232),
    [sym_access_specifier] = STATE(11693),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(232),
    [sym_alias_declaration] = STATE(232),
    [sym_static_assert_declaration] = STATE(232),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9116),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(232),
    [sym_subscript_declaration] = STATE(232),
    [sym_property_declaration] = STATE(232),
    [sym_associatedtype_declaration] = STATE(232),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(232),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9502),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2677),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(2432),
    [aux_sym_preproc_if_token1] = ACTIONS(2434),
    [aux_sym_preproc_if_token2] = ACTIONS(2502),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2438),
    [aux_sym_preproc_else_token1] = ACTIONS(2440),
    [aux_sym_preproc_elif_token1] = ACTIONS(2442),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2444),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2444),
    [sym_preproc_directive] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym___extension__] = ACTIONS(2458),
    [anon_sym_typedef] = ACTIONS(2460),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2468),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(2484),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2486),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(2494),
    [anon_sym___subscript] = ACTIONS(2496),
    [anon_sym_property] = ACTIONS(2498),
    [anon_sym_associatedtype] = ACTIONS(2500),
  },
  [227] = {
    [sym_preproc_def] = STATE(249),
    [sym_preproc_function_def] = STATE(249),
    [sym_preproc_call] = STATE(249),
    [sym_preproc_if_in_field_declaration_list] = STATE(249),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(249),
    [sym_preproc_else_in_field_declaration_list] = STATE(10789),
    [sym_preproc_elif_in_field_declaration_list] = STATE(10789),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(10789),
    [sym_type_definition] = STATE(249),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7124),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7905),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(249),
    [sym_field_declaration] = STATE(249),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2677),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(249),
    [sym_operator_cast] = STATE(9116),
    [sym_inline_method_definition] = STATE(249),
    [sym__constructor_specifiers] = STATE(2677),
    [sym_operator_cast_definition] = STATE(249),
    [sym_operator_cast_declaration] = STATE(249),
    [sym_constructor_or_destructor_definition] = STATE(249),
    [sym_constructor_or_destructor_declaration] = STATE(249),
    [sym_friend_declaration] = STATE(249),
    [sym_access_specifier] = STATE(11693),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(249),
    [sym_alias_declaration] = STATE(249),
    [sym_static_assert_declaration] = STATE(249),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9116),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(249),
    [sym_subscript_declaration] = STATE(249),
    [sym_property_declaration] = STATE(249),
    [sym_associatedtype_declaration] = STATE(249),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(249),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9502),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2677),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(2432),
    [aux_sym_preproc_if_token1] = ACTIONS(2434),
    [aux_sym_preproc_if_token2] = ACTIONS(2506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2438),
    [aux_sym_preproc_else_token1] = ACTIONS(2440),
    [aux_sym_preproc_elif_token1] = ACTIONS(2442),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2444),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2444),
    [sym_preproc_directive] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym___extension__] = ACTIONS(2458),
    [anon_sym_typedef] = ACTIONS(2460),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2468),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(2484),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2486),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(2494),
    [anon_sym___subscript] = ACTIONS(2496),
    [anon_sym_property] = ACTIONS(2498),
    [anon_sym_associatedtype] = ACTIONS(2500),
  },
  [228] = {
    [sym_preproc_def] = STATE(249),
    [sym_preproc_function_def] = STATE(249),
    [sym_preproc_call] = STATE(249),
    [sym_preproc_if_in_field_declaration_list] = STATE(249),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(249),
    [sym_preproc_else_in_field_declaration_list] = STATE(11619),
    [sym_preproc_elif_in_field_declaration_list] = STATE(11619),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(11619),
    [sym_type_definition] = STATE(249),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7124),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7905),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(249),
    [sym_field_declaration] = STATE(249),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2677),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(249),
    [sym_operator_cast] = STATE(9116),
    [sym_inline_method_definition] = STATE(249),
    [sym__constructor_specifiers] = STATE(2677),
    [sym_operator_cast_definition] = STATE(249),
    [sym_operator_cast_declaration] = STATE(249),
    [sym_constructor_or_destructor_definition] = STATE(249),
    [sym_constructor_or_destructor_declaration] = STATE(249),
    [sym_friend_declaration] = STATE(249),
    [sym_access_specifier] = STATE(11693),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(249),
    [sym_alias_declaration] = STATE(249),
    [sym_static_assert_declaration] = STATE(249),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9116),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(249),
    [sym_subscript_declaration] = STATE(249),
    [sym_property_declaration] = STATE(249),
    [sym_associatedtype_declaration] = STATE(249),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(249),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9502),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2677),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(2432),
    [aux_sym_preproc_if_token1] = ACTIONS(2434),
    [aux_sym_preproc_if_token2] = ACTIONS(2508),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2438),
    [aux_sym_preproc_else_token1] = ACTIONS(2440),
    [aux_sym_preproc_elif_token1] = ACTIONS(2442),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2444),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2444),
    [sym_preproc_directive] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym___extension__] = ACTIONS(2458),
    [anon_sym_typedef] = ACTIONS(2460),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2468),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(2484),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2486),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(2494),
    [anon_sym___subscript] = ACTIONS(2496),
    [anon_sym_property] = ACTIONS(2498),
    [anon_sym_associatedtype] = ACTIONS(2500),
  },
  [229] = {
    [sym_preproc_def] = STATE(227),
    [sym_preproc_function_def] = STATE(227),
    [sym_preproc_call] = STATE(227),
    [sym_preproc_if_in_field_declaration_list] = STATE(227),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(227),
    [sym_preproc_else_in_field_declaration_list] = STATE(10934),
    [sym_preproc_elif_in_field_declaration_list] = STATE(10934),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(10934),
    [sym_type_definition] = STATE(227),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7124),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7905),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(227),
    [sym_field_declaration] = STATE(227),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2677),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(227),
    [sym_operator_cast] = STATE(9116),
    [sym_inline_method_definition] = STATE(227),
    [sym__constructor_specifiers] = STATE(2677),
    [sym_operator_cast_definition] = STATE(227),
    [sym_operator_cast_declaration] = STATE(227),
    [sym_constructor_or_destructor_definition] = STATE(227),
    [sym_constructor_or_destructor_declaration] = STATE(227),
    [sym_friend_declaration] = STATE(227),
    [sym_access_specifier] = STATE(11693),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(227),
    [sym_alias_declaration] = STATE(227),
    [sym_static_assert_declaration] = STATE(227),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9116),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(227),
    [sym_subscript_declaration] = STATE(227),
    [sym_property_declaration] = STATE(227),
    [sym_associatedtype_declaration] = STATE(227),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(227),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9502),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2677),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(2432),
    [aux_sym_preproc_if_token1] = ACTIONS(2434),
    [aux_sym_preproc_if_token2] = ACTIONS(2510),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2438),
    [aux_sym_preproc_else_token1] = ACTIONS(2440),
    [aux_sym_preproc_elif_token1] = ACTIONS(2442),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2444),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2444),
    [sym_preproc_directive] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym___extension__] = ACTIONS(2458),
    [anon_sym_typedef] = ACTIONS(2460),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2468),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(2484),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2486),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(2494),
    [anon_sym___subscript] = ACTIONS(2496),
    [anon_sym_property] = ACTIONS(2498),
    [anon_sym_associatedtype] = ACTIONS(2500),
  },
  [230] = {
    [sym_preproc_def] = STATE(228),
    [sym_preproc_function_def] = STATE(228),
    [sym_preproc_call] = STATE(228),
    [sym_preproc_if_in_field_declaration_list] = STATE(228),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(228),
    [sym_preproc_else_in_field_declaration_list] = STATE(10822),
    [sym_preproc_elif_in_field_declaration_list] = STATE(10822),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(10822),
    [sym_type_definition] = STATE(228),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7124),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7905),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(228),
    [sym_field_declaration] = STATE(228),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2677),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(228),
    [sym_operator_cast] = STATE(9116),
    [sym_inline_method_definition] = STATE(228),
    [sym__constructor_specifiers] = STATE(2677),
    [sym_operator_cast_definition] = STATE(228),
    [sym_operator_cast_declaration] = STATE(228),
    [sym_constructor_or_destructor_definition] = STATE(228),
    [sym_constructor_or_destructor_declaration] = STATE(228),
    [sym_friend_declaration] = STATE(228),
    [sym_access_specifier] = STATE(11693),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(228),
    [sym_alias_declaration] = STATE(228),
    [sym_static_assert_declaration] = STATE(228),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9116),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(228),
    [sym_subscript_declaration] = STATE(228),
    [sym_property_declaration] = STATE(228),
    [sym_associatedtype_declaration] = STATE(228),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(228),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9502),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2677),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(2432),
    [aux_sym_preproc_if_token1] = ACTIONS(2434),
    [aux_sym_preproc_if_token2] = ACTIONS(2514),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2438),
    [aux_sym_preproc_else_token1] = ACTIONS(2440),
    [aux_sym_preproc_elif_token1] = ACTIONS(2442),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2444),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2444),
    [sym_preproc_directive] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym___extension__] = ACTIONS(2458),
    [anon_sym_typedef] = ACTIONS(2460),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2468),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(2484),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2486),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(2494),
    [anon_sym___subscript] = ACTIONS(2496),
    [anon_sym_property] = ACTIONS(2498),
    [anon_sym_associatedtype] = ACTIONS(2500),
  },
  [231] = {
    [sym_preproc_def] = STATE(249),
    [sym_preproc_function_def] = STATE(249),
    [sym_preproc_call] = STATE(249),
    [sym_preproc_if_in_field_declaration_list] = STATE(249),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(249),
    [sym_preproc_else_in_field_declaration_list] = STATE(11570),
    [sym_preproc_elif_in_field_declaration_list] = STATE(11570),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(11570),
    [sym_type_definition] = STATE(249),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7124),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7905),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(249),
    [sym_field_declaration] = STATE(249),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2677),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(249),
    [sym_operator_cast] = STATE(9116),
    [sym_inline_method_definition] = STATE(249),
    [sym__constructor_specifiers] = STATE(2677),
    [sym_operator_cast_definition] = STATE(249),
    [sym_operator_cast_declaration] = STATE(249),
    [sym_constructor_or_destructor_definition] = STATE(249),
    [sym_constructor_or_destructor_declaration] = STATE(249),
    [sym_friend_declaration] = STATE(249),
    [sym_access_specifier] = STATE(11693),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(249),
    [sym_alias_declaration] = STATE(249),
    [sym_static_assert_declaration] = STATE(249),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9116),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(249),
    [sym_subscript_declaration] = STATE(249),
    [sym_property_declaration] = STATE(249),
    [sym_associatedtype_declaration] = STATE(249),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(249),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9502),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2677),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(2432),
    [aux_sym_preproc_if_token1] = ACTIONS(2434),
    [aux_sym_preproc_if_token2] = ACTIONS(2518),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2438),
    [aux_sym_preproc_else_token1] = ACTIONS(2440),
    [aux_sym_preproc_elif_token1] = ACTIONS(2442),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2444),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2444),
    [sym_preproc_directive] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym___extension__] = ACTIONS(2458),
    [anon_sym_typedef] = ACTIONS(2460),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2468),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(2484),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2486),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(2494),
    [anon_sym___subscript] = ACTIONS(2496),
    [anon_sym_property] = ACTIONS(2498),
    [anon_sym_associatedtype] = ACTIONS(2500),
  },
  [232] = {
    [sym_preproc_def] = STATE(249),
    [sym_preproc_function_def] = STATE(249),
    [sym_preproc_call] = STATE(249),
    [sym_preproc_if_in_field_declaration_list] = STATE(249),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(249),
    [sym_preproc_else_in_field_declaration_list] = STATE(10983),
    [sym_preproc_elif_in_field_declaration_list] = STATE(10983),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(10983),
    [sym_type_definition] = STATE(249),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7124),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7905),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(249),
    [sym_field_declaration] = STATE(249),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2677),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(249),
    [sym_operator_cast] = STATE(9116),
    [sym_inline_method_definition] = STATE(249),
    [sym__constructor_specifiers] = STATE(2677),
    [sym_operator_cast_definition] = STATE(249),
    [sym_operator_cast_declaration] = STATE(249),
    [sym_constructor_or_destructor_definition] = STATE(249),
    [sym_constructor_or_destructor_declaration] = STATE(249),
    [sym_friend_declaration] = STATE(249),
    [sym_access_specifier] = STATE(11693),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(249),
    [sym_alias_declaration] = STATE(249),
    [sym_static_assert_declaration] = STATE(249),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9116),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(249),
    [sym_subscript_declaration] = STATE(249),
    [sym_property_declaration] = STATE(249),
    [sym_associatedtype_declaration] = STATE(249),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(249),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9502),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2677),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(2432),
    [aux_sym_preproc_if_token1] = ACTIONS(2434),
    [aux_sym_preproc_if_token2] = ACTIONS(2520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2438),
    [aux_sym_preproc_else_token1] = ACTIONS(2440),
    [aux_sym_preproc_elif_token1] = ACTIONS(2442),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2444),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2444),
    [sym_preproc_directive] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym___extension__] = ACTIONS(2458),
    [anon_sym_typedef] = ACTIONS(2460),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2468),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(2484),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2486),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(2494),
    [anon_sym___subscript] = ACTIONS(2496),
    [anon_sym_property] = ACTIONS(2498),
    [anon_sym_associatedtype] = ACTIONS(2500),
  },
  [233] = {
    [sym_preproc_def] = STATE(249),
    [sym_preproc_function_def] = STATE(249),
    [sym_preproc_call] = STATE(249),
    [sym_preproc_if_in_field_declaration_list] = STATE(249),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(249),
    [sym_preproc_else_in_field_declaration_list] = STATE(10832),
    [sym_preproc_elif_in_field_declaration_list] = STATE(10832),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(10832),
    [sym_type_definition] = STATE(249),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7124),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7905),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(249),
    [sym_field_declaration] = STATE(249),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2677),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(249),
    [sym_operator_cast] = STATE(9116),
    [sym_inline_method_definition] = STATE(249),
    [sym__constructor_specifiers] = STATE(2677),
    [sym_operator_cast_definition] = STATE(249),
    [sym_operator_cast_declaration] = STATE(249),
    [sym_constructor_or_destructor_definition] = STATE(249),
    [sym_constructor_or_destructor_declaration] = STATE(249),
    [sym_friend_declaration] = STATE(249),
    [sym_access_specifier] = STATE(11693),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(249),
    [sym_alias_declaration] = STATE(249),
    [sym_static_assert_declaration] = STATE(249),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9116),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(249),
    [sym_subscript_declaration] = STATE(249),
    [sym_property_declaration] = STATE(249),
    [sym_associatedtype_declaration] = STATE(249),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(249),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9502),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2677),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(2432),
    [aux_sym_preproc_if_token1] = ACTIONS(2434),
    [aux_sym_preproc_if_token2] = ACTIONS(2522),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2438),
    [aux_sym_preproc_else_token1] = ACTIONS(2440),
    [aux_sym_preproc_elif_token1] = ACTIONS(2442),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2444),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2444),
    [sym_preproc_directive] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym___extension__] = ACTIONS(2458),
    [anon_sym_typedef] = ACTIONS(2460),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2468),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(2484),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2486),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(2494),
    [anon_sym___subscript] = ACTIONS(2496),
    [anon_sym_property] = ACTIONS(2498),
    [anon_sym_associatedtype] = ACTIONS(2500),
  },
  [234] = {
    [sym_preproc_def] = STATE(239),
    [sym_preproc_function_def] = STATE(239),
    [sym_preproc_call] = STATE(239),
    [sym_preproc_if_in_field_declaration_list] = STATE(239),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(239),
    [sym_preproc_else_in_field_declaration_list] = STATE(11552),
    [sym_preproc_elif_in_field_declaration_list] = STATE(11552),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(11552),
    [sym_type_definition] = STATE(239),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7124),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7905),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(239),
    [sym_field_declaration] = STATE(239),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2677),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(239),
    [sym_operator_cast] = STATE(9116),
    [sym_inline_method_definition] = STATE(239),
    [sym__constructor_specifiers] = STATE(2677),
    [sym_operator_cast_definition] = STATE(239),
    [sym_operator_cast_declaration] = STATE(239),
    [sym_constructor_or_destructor_definition] = STATE(239),
    [sym_constructor_or_destructor_declaration] = STATE(239),
    [sym_friend_declaration] = STATE(239),
    [sym_access_specifier] = STATE(11693),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(239),
    [sym_alias_declaration] = STATE(239),
    [sym_static_assert_declaration] = STATE(239),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9116),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(239),
    [sym_subscript_declaration] = STATE(239),
    [sym_property_declaration] = STATE(239),
    [sym_associatedtype_declaration] = STATE(239),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(239),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9502),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2677),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(2432),
    [aux_sym_preproc_if_token1] = ACTIONS(2434),
    [aux_sym_preproc_if_token2] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2438),
    [aux_sym_preproc_else_token1] = ACTIONS(2440),
    [aux_sym_preproc_elif_token1] = ACTIONS(2442),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2444),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2444),
    [sym_preproc_directive] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2458),
    [anon_sym_typedef] = ACTIONS(2460),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2468),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(2484),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2486),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(2494),
    [anon_sym___subscript] = ACTIONS(2496),
    [anon_sym_property] = ACTIONS(2498),
    [anon_sym_associatedtype] = ACTIONS(2500),
  },
  [235] = {
    [sym_preproc_def] = STATE(231),
    [sym_preproc_function_def] = STATE(231),
    [sym_preproc_call] = STATE(231),
    [sym_preproc_if_in_field_declaration_list] = STATE(231),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(231),
    [sym_preproc_else_in_field_declaration_list] = STATE(10849),
    [sym_preproc_elif_in_field_declaration_list] = STATE(10849),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(10849),
    [sym_type_definition] = STATE(231),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7124),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7905),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(231),
    [sym_field_declaration] = STATE(231),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2677),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(231),
    [sym_operator_cast] = STATE(9116),
    [sym_inline_method_definition] = STATE(231),
    [sym__constructor_specifiers] = STATE(2677),
    [sym_operator_cast_definition] = STATE(231),
    [sym_operator_cast_declaration] = STATE(231),
    [sym_constructor_or_destructor_definition] = STATE(231),
    [sym_constructor_or_destructor_declaration] = STATE(231),
    [sym_friend_declaration] = STATE(231),
    [sym_access_specifier] = STATE(11693),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(231),
    [sym_alias_declaration] = STATE(231),
    [sym_static_assert_declaration] = STATE(231),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9116),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(231),
    [sym_subscript_declaration] = STATE(231),
    [sym_property_declaration] = STATE(231),
    [sym_associatedtype_declaration] = STATE(231),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(231),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9502),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2677),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(2432),
    [aux_sym_preproc_if_token1] = ACTIONS(2434),
    [aux_sym_preproc_if_token2] = ACTIONS(2528),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2438),
    [aux_sym_preproc_else_token1] = ACTIONS(2440),
    [aux_sym_preproc_elif_token1] = ACTIONS(2442),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2444),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2444),
    [sym_preproc_directive] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2530),
    [anon_sym___extension__] = ACTIONS(2458),
    [anon_sym_typedef] = ACTIONS(2460),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2468),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(2484),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2486),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(2494),
    [anon_sym___subscript] = ACTIONS(2496),
    [anon_sym_property] = ACTIONS(2498),
    [anon_sym_associatedtype] = ACTIONS(2500),
  },
  [236] = {
    [sym_preproc_def] = STATE(233),
    [sym_preproc_function_def] = STATE(233),
    [sym_preproc_call] = STATE(233),
    [sym_preproc_if_in_field_declaration_list] = STATE(233),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(233),
    [sym_preproc_else_in_field_declaration_list] = STATE(11527),
    [sym_preproc_elif_in_field_declaration_list] = STATE(11527),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(11527),
    [sym_type_definition] = STATE(233),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7124),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7905),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(233),
    [sym_field_declaration] = STATE(233),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2677),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(233),
    [sym_operator_cast] = STATE(9116),
    [sym_inline_method_definition] = STATE(233),
    [sym__constructor_specifiers] = STATE(2677),
    [sym_operator_cast_definition] = STATE(233),
    [sym_operator_cast_declaration] = STATE(233),
    [sym_constructor_or_destructor_definition] = STATE(233),
    [sym_constructor_or_destructor_declaration] = STATE(233),
    [sym_friend_declaration] = STATE(233),
    [sym_access_specifier] = STATE(11693),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(233),
    [sym_alias_declaration] = STATE(233),
    [sym_static_assert_declaration] = STATE(233),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9116),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(233),
    [sym_subscript_declaration] = STATE(233),
    [sym_property_declaration] = STATE(233),
    [sym_associatedtype_declaration] = STATE(233),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(233),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9502),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2677),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(2432),
    [aux_sym_preproc_if_token1] = ACTIONS(2434),
    [aux_sym_preproc_if_token2] = ACTIONS(2532),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2438),
    [aux_sym_preproc_else_token1] = ACTIONS(2440),
    [aux_sym_preproc_elif_token1] = ACTIONS(2442),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2444),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2444),
    [sym_preproc_directive] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym___extension__] = ACTIONS(2458),
    [anon_sym_typedef] = ACTIONS(2460),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2468),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(2484),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2486),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(2494),
    [anon_sym___subscript] = ACTIONS(2496),
    [anon_sym_property] = ACTIONS(2498),
    [anon_sym_associatedtype] = ACTIONS(2500),
  },
  [237] = {
    [sym_preproc_def] = STATE(225),
    [sym_preproc_function_def] = STATE(225),
    [sym_preproc_call] = STATE(225),
    [sym_preproc_if_in_field_declaration_list] = STATE(225),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(225),
    [sym_preproc_else_in_field_declaration_list] = STATE(11701),
    [sym_preproc_elif_in_field_declaration_list] = STATE(11701),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(11701),
    [sym_type_definition] = STATE(225),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7124),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7905),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(225),
    [sym_field_declaration] = STATE(225),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2677),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(225),
    [sym_operator_cast] = STATE(9116),
    [sym_inline_method_definition] = STATE(225),
    [sym__constructor_specifiers] = STATE(2677),
    [sym_operator_cast_definition] = STATE(225),
    [sym_operator_cast_declaration] = STATE(225),
    [sym_constructor_or_destructor_definition] = STATE(225),
    [sym_constructor_or_destructor_declaration] = STATE(225),
    [sym_friend_declaration] = STATE(225),
    [sym_access_specifier] = STATE(11693),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(225),
    [sym_alias_declaration] = STATE(225),
    [sym_static_assert_declaration] = STATE(225),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9116),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(225),
    [sym_subscript_declaration] = STATE(225),
    [sym_property_declaration] = STATE(225),
    [sym_associatedtype_declaration] = STATE(225),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(225),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9502),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2677),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(2432),
    [aux_sym_preproc_if_token1] = ACTIONS(2434),
    [aux_sym_preproc_if_token2] = ACTIONS(2536),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2438),
    [aux_sym_preproc_else_token1] = ACTIONS(2440),
    [aux_sym_preproc_elif_token1] = ACTIONS(2442),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2444),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2444),
    [sym_preproc_directive] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2538),
    [anon_sym___extension__] = ACTIONS(2458),
    [anon_sym_typedef] = ACTIONS(2460),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2468),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(2484),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2486),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(2494),
    [anon_sym___subscript] = ACTIONS(2496),
    [anon_sym_property] = ACTIONS(2498),
    [anon_sym_associatedtype] = ACTIONS(2500),
  },
  [238] = {
    [sym_preproc_def] = STATE(240),
    [sym_preproc_function_def] = STATE(240),
    [sym_preproc_call] = STATE(240),
    [sym_preproc_if_in_field_declaration_list] = STATE(240),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(240),
    [sym_preproc_else_in_field_declaration_list] = STATE(11533),
    [sym_preproc_elif_in_field_declaration_list] = STATE(11533),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(11533),
    [sym_type_definition] = STATE(240),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7124),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7905),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(240),
    [sym_field_declaration] = STATE(240),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2677),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(240),
    [sym_operator_cast] = STATE(9116),
    [sym_inline_method_definition] = STATE(240),
    [sym__constructor_specifiers] = STATE(2677),
    [sym_operator_cast_definition] = STATE(240),
    [sym_operator_cast_declaration] = STATE(240),
    [sym_constructor_or_destructor_definition] = STATE(240),
    [sym_constructor_or_destructor_declaration] = STATE(240),
    [sym_friend_declaration] = STATE(240),
    [sym_access_specifier] = STATE(11693),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(240),
    [sym_alias_declaration] = STATE(240),
    [sym_static_assert_declaration] = STATE(240),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9116),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(240),
    [sym_subscript_declaration] = STATE(240),
    [sym_property_declaration] = STATE(240),
    [sym_associatedtype_declaration] = STATE(240),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(240),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9502),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2677),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(2432),
    [aux_sym_preproc_if_token1] = ACTIONS(2434),
    [aux_sym_preproc_if_token2] = ACTIONS(2540),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2438),
    [aux_sym_preproc_else_token1] = ACTIONS(2440),
    [aux_sym_preproc_elif_token1] = ACTIONS(2442),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2444),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2444),
    [sym_preproc_directive] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2542),
    [anon_sym___extension__] = ACTIONS(2458),
    [anon_sym_typedef] = ACTIONS(2460),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2468),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(2484),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2486),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(2494),
    [anon_sym___subscript] = ACTIONS(2496),
    [anon_sym_property] = ACTIONS(2498),
    [anon_sym_associatedtype] = ACTIONS(2500),
  },
  [239] = {
    [sym_preproc_def] = STATE(249),
    [sym_preproc_function_def] = STATE(249),
    [sym_preproc_call] = STATE(249),
    [sym_preproc_if_in_field_declaration_list] = STATE(249),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(249),
    [sym_preproc_else_in_field_declaration_list] = STATE(11723),
    [sym_preproc_elif_in_field_declaration_list] = STATE(11723),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(11723),
    [sym_type_definition] = STATE(249),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7124),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7905),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(249),
    [sym_field_declaration] = STATE(249),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2677),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(249),
    [sym_operator_cast] = STATE(9116),
    [sym_inline_method_definition] = STATE(249),
    [sym__constructor_specifiers] = STATE(2677),
    [sym_operator_cast_definition] = STATE(249),
    [sym_operator_cast_declaration] = STATE(249),
    [sym_constructor_or_destructor_definition] = STATE(249),
    [sym_constructor_or_destructor_declaration] = STATE(249),
    [sym_friend_declaration] = STATE(249),
    [sym_access_specifier] = STATE(11693),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(249),
    [sym_alias_declaration] = STATE(249),
    [sym_static_assert_declaration] = STATE(249),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9116),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(249),
    [sym_subscript_declaration] = STATE(249),
    [sym_property_declaration] = STATE(249),
    [sym_associatedtype_declaration] = STATE(249),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(249),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9502),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2677),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(2432),
    [aux_sym_preproc_if_token1] = ACTIONS(2434),
    [aux_sym_preproc_if_token2] = ACTIONS(2544),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2438),
    [aux_sym_preproc_else_token1] = ACTIONS(2440),
    [aux_sym_preproc_elif_token1] = ACTIONS(2442),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2444),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2444),
    [sym_preproc_directive] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym___extension__] = ACTIONS(2458),
    [anon_sym_typedef] = ACTIONS(2460),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2468),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(2484),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2486),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(2494),
    [anon_sym___subscript] = ACTIONS(2496),
    [anon_sym_property] = ACTIONS(2498),
    [anon_sym_associatedtype] = ACTIONS(2500),
  },
  [240] = {
    [sym_preproc_def] = STATE(249),
    [sym_preproc_function_def] = STATE(249),
    [sym_preproc_call] = STATE(249),
    [sym_preproc_if_in_field_declaration_list] = STATE(249),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(249),
    [sym_preproc_else_in_field_declaration_list] = STATE(11094),
    [sym_preproc_elif_in_field_declaration_list] = STATE(11094),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(11094),
    [sym_type_definition] = STATE(249),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7124),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7905),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(249),
    [sym_field_declaration] = STATE(249),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2677),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(249),
    [sym_operator_cast] = STATE(9116),
    [sym_inline_method_definition] = STATE(249),
    [sym__constructor_specifiers] = STATE(2677),
    [sym_operator_cast_definition] = STATE(249),
    [sym_operator_cast_declaration] = STATE(249),
    [sym_constructor_or_destructor_definition] = STATE(249),
    [sym_constructor_or_destructor_declaration] = STATE(249),
    [sym_friend_declaration] = STATE(249),
    [sym_access_specifier] = STATE(11693),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(249),
    [sym_alias_declaration] = STATE(249),
    [sym_static_assert_declaration] = STATE(249),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9116),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(249),
    [sym_subscript_declaration] = STATE(249),
    [sym_property_declaration] = STATE(249),
    [sym_associatedtype_declaration] = STATE(249),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(249),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9502),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2677),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(2432),
    [aux_sym_preproc_if_token1] = ACTIONS(2434),
    [aux_sym_preproc_if_token2] = ACTIONS(2546),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2438),
    [aux_sym_preproc_else_token1] = ACTIONS(2440),
    [aux_sym_preproc_elif_token1] = ACTIONS(2442),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2444),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2444),
    [sym_preproc_directive] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym___extension__] = ACTIONS(2458),
    [anon_sym_typedef] = ACTIONS(2460),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2468),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(2484),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2486),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(2494),
    [anon_sym___subscript] = ACTIONS(2496),
    [anon_sym_property] = ACTIONS(2498),
    [anon_sym_associatedtype] = ACTIONS(2500),
  },
  [241] = {
    [ts_builtin_sym_end] = ACTIONS(2548),
    [sym_identifier] = ACTIONS(2550),
    [aux_sym_preproc_include_token1] = ACTIONS(2550),
    [aux_sym_preproc_def_token1] = ACTIONS(2550),
    [anon_sym_COMMA] = ACTIONS(2548),
    [anon_sym_RPAREN] = ACTIONS(2548),
    [aux_sym_preproc_if_token1] = ACTIONS(2550),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2550),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2550),
    [sym_preproc_directive] = ACTIONS(2550),
    [anon_sym_LPAREN2] = ACTIONS(2548),
    [anon_sym_BANG] = ACTIONS(2548),
    [anon_sym_TILDE] = ACTIONS(2548),
    [anon_sym_DASH] = ACTIONS(2550),
    [anon_sym_PLUS] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(2548),
    [anon_sym_AMP_AMP] = ACTIONS(2548),
    [anon_sym_AMP] = ACTIONS(2550),
    [anon_sym_SEMI] = ACTIONS(2548),
    [anon_sym___extension__] = ACTIONS(2550),
    [anon_sym_typedef] = ACTIONS(2550),
    [anon_sym_in] = ACTIONS(2550),
    [anon_sym_out] = ACTIONS(2550),
    [anon_sym_inout] = ACTIONS(2550),
    [anon_sym_virtual] = ACTIONS(2550),
    [anon_sym_extern] = ACTIONS(2550),
    [anon_sym___attribute__] = ACTIONS(2550),
    [anon_sym___attribute] = ACTIONS(2550),
    [anon_sym_using] = ACTIONS(2550),
    [anon_sym_COLON_COLON] = ACTIONS(2548),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2548),
    [anon_sym___declspec] = ACTIONS(2550),
    [anon_sym___based] = ACTIONS(2550),
    [anon_sym___cdecl] = ACTIONS(2550),
    [anon_sym___clrcall] = ACTIONS(2550),
    [anon_sym___stdcall] = ACTIONS(2550),
    [anon_sym___fastcall] = ACTIONS(2550),
    [anon_sym___thiscall] = ACTIONS(2550),
    [anon_sym___vectorcall] = ACTIONS(2550),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_signed] = ACTIONS(2550),
    [anon_sym_unsigned] = ACTIONS(2550),
    [anon_sym_long] = ACTIONS(2550),
    [anon_sym_short] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_static] = ACTIONS(2550),
    [anon_sym_register] = ACTIONS(2550),
    [anon_sym_inline] = ACTIONS(2550),
    [anon_sym___inline] = ACTIONS(2550),
    [anon_sym___inline__] = ACTIONS(2550),
    [anon_sym___forceinline] = ACTIONS(2550),
    [anon_sym_thread_local] = ACTIONS(2550),
    [anon_sym___thread] = ACTIONS(2550),
    [anon_sym_const] = ACTIONS(2550),
    [anon_sym_constexpr] = ACTIONS(2550),
    [anon_sym_volatile] = ACTIONS(2550),
    [anon_sym_restrict] = ACTIONS(2550),
    [anon_sym___restrict__] = ACTIONS(2550),
    [anon_sym__Atomic] = ACTIONS(2550),
    [anon_sym__Noreturn] = ACTIONS(2550),
    [anon_sym_noreturn] = ACTIONS(2550),
    [anon_sym__Nonnull] = ACTIONS(2550),
    [anon_sym_mutable] = ACTIONS(2550),
    [anon_sym_constinit] = ACTIONS(2550),
    [anon_sym_consteval] = ACTIONS(2550),
    [anon_sym_alignas] = ACTIONS(2550),
    [anon_sym__Alignas] = ACTIONS(2550),
    [sym_primitive_type] = ACTIONS(2550),
    [anon_sym_enum] = ACTIONS(2550),
    [anon_sym_class] = ACTIONS(2550),
    [anon_sym_struct] = ACTIONS(2550),
    [anon_sym_union] = ACTIONS(2550),
    [anon_sym_if] = ACTIONS(2550),
    [anon_sym_else] = ACTIONS(2550),
    [anon_sym_switch] = ACTIONS(2550),
    [anon_sym_case] = ACTIONS(2550),
    [anon_sym_default] = ACTIONS(2550),
    [anon_sym_while] = ACTIONS(2550),
    [anon_sym_do] = ACTIONS(2550),
    [anon_sym_for] = ACTIONS(2550),
    [anon_sym_return] = ACTIONS(2550),
    [anon_sym_break] = ACTIONS(2550),
    [anon_sym_continue] = ACTIONS(2550),
    [anon_sym_goto] = ACTIONS(2550),
    [anon_sym___try] = ACTIONS(2550),
    [anon_sym___leave] = ACTIONS(2550),
    [anon_sym_not] = ACTIONS(2550),
    [anon_sym_compl] = ACTIONS(2550),
    [anon_sym_DASH_DASH] = ACTIONS(2548),
    [anon_sym_PLUS_PLUS] = ACTIONS(2548),
    [anon_sym_sizeof] = ACTIONS(2550),
    [anon_sym___alignof__] = ACTIONS(2550),
    [anon_sym___alignof] = ACTIONS(2550),
    [anon_sym__alignof] = ACTIONS(2550),
    [anon_sym_alignof] = ACTIONS(2550),
    [anon_sym__Alignof] = ACTIONS(2550),
    [anon_sym_offsetof] = ACTIONS(2550),
    [anon_sym__Generic] = ACTIONS(2550),
    [anon_sym_asm] = ACTIONS(2550),
    [anon_sym___asm__] = ACTIONS(2550),
    [anon_sym___asm] = ACTIONS(2550),
    [anon_sym_DOT] = ACTIONS(2550),
    [sym_number_literal] = ACTIONS(2548),
    [anon_sym_L_SQUOTE] = ACTIONS(2548),
    [anon_sym_u_SQUOTE] = ACTIONS(2548),
    [anon_sym_U_SQUOTE] = ACTIONS(2548),
    [anon_sym_u8_SQUOTE] = ACTIONS(2548),
    [anon_sym_SQUOTE] = ACTIONS(2548),
    [anon_sym_L_DQUOTE] = ACTIONS(2548),
    [anon_sym_u_DQUOTE] = ACTIONS(2548),
    [anon_sym_U_DQUOTE] = ACTIONS(2548),
    [anon_sym_u8_DQUOTE] = ACTIONS(2548),
    [anon_sym_DQUOTE] = ACTIONS(2548),
    [sym_true] = ACTIONS(2550),
    [sym_false] = ACTIONS(2550),
    [anon_sym_NULL] = ACTIONS(2550),
    [anon_sym_nullptr] = ACTIONS(2550),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(2550),
    [anon_sym_This] = ACTIONS(2550),
    [anon_sym_decltype] = ACTIONS(2550),
    [anon_sym_final] = ACTIONS(2550),
    [anon_sym_override] = ACTIONS(2550),
    [anon_sym_explicit] = ACTIONS(2550),
    [anon_sym_typename] = ACTIONS(2550),
    [anon_sym_export] = ACTIONS(2550),
    [anon_sym_module] = ACTIONS(2550),
    [anon_sym_import] = ACTIONS(2550),
    [anon_sym_template] = ACTIONS(2550),
    [anon_sym_GT2] = ACTIONS(2548),
    [anon_sym_operator] = ACTIONS(2550),
    [anon_sym_try] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(2550),
    [anon_sym_throw] = ACTIONS(2550),
    [anon_sym_namespace] = ACTIONS(2550),
    [anon_sym_static_assert] = ACTIONS(2550),
    [anon_sym_concept] = ACTIONS(2550),
    [anon_sym_co_return] = ACTIONS(2550),
    [anon_sym_co_yield] = ACTIONS(2550),
    [anon_sym_R_DQUOTE] = ACTIONS(2548),
    [anon_sym_LR_DQUOTE] = ACTIONS(2548),
    [anon_sym_uR_DQUOTE] = ACTIONS(2548),
    [anon_sym_UR_DQUOTE] = ACTIONS(2548),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2548),
    [anon_sym_co_await] = ACTIONS(2550),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2550),
    [sym_this] = ACTIONS(2550),
    [anon_sym_discard] = ACTIONS(2550),
    [anon_sym_precise] = ACTIONS(2550),
    [anon_sym_shared] = ACTIONS(2550),
    [anon_sym_groupshared] = ACTIONS(2550),
    [anon_sym_uniform] = ACTIONS(2550),
    [anon_sym_row_major] = ACTIONS(2550),
    [anon_sym_column_major] = ACTIONS(2550),
    [anon_sym_globallycoherent] = ACTIONS(2550),
    [anon_sym_centroid] = ACTIONS(2550),
    [anon_sym_noperspective] = ACTIONS(2550),
    [anon_sym_nointerpolation] = ACTIONS(2550),
    [anon_sym_sample] = ACTIONS(2550),
    [anon_sym_linear] = ACTIONS(2550),
    [anon_sym_snorm] = ACTIONS(2550),
    [anon_sym_unorm] = ACTIONS(2550),
    [anon_sym_point] = ACTIONS(2550),
    [anon_sym_line] = ACTIONS(2550),
    [anon_sym_triangleadj] = ACTIONS(2550),
    [anon_sym_lineadj] = ACTIONS(2550),
    [anon_sym_triangle] = ACTIONS(2550),
    [anon_sym_cbuffer] = ACTIONS(2550),
    [anon_sym_interface] = ACTIONS(2550),
    [anon_sym_extension] = ACTIONS(2550),
    [anon_sym_where] = ACTIONS(2550),
    [anon_sym___exported] = ACTIONS(2550),
  },
  [242] = {
    [ts_builtin_sym_end] = ACTIONS(2552),
    [sym_identifier] = ACTIONS(2554),
    [aux_sym_preproc_include_token1] = ACTIONS(2554),
    [aux_sym_preproc_def_token1] = ACTIONS(2554),
    [anon_sym_COMMA] = ACTIONS(2552),
    [anon_sym_RPAREN] = ACTIONS(2552),
    [aux_sym_preproc_if_token1] = ACTIONS(2554),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2554),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2554),
    [sym_preproc_directive] = ACTIONS(2554),
    [anon_sym_LPAREN2] = ACTIONS(2552),
    [anon_sym_BANG] = ACTIONS(2552),
    [anon_sym_TILDE] = ACTIONS(2552),
    [anon_sym_DASH] = ACTIONS(2554),
    [anon_sym_PLUS] = ACTIONS(2554),
    [anon_sym_STAR] = ACTIONS(2552),
    [anon_sym_AMP_AMP] = ACTIONS(2552),
    [anon_sym_AMP] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym___extension__] = ACTIONS(2554),
    [anon_sym_typedef] = ACTIONS(2554),
    [anon_sym_in] = ACTIONS(2554),
    [anon_sym_out] = ACTIONS(2554),
    [anon_sym_inout] = ACTIONS(2554),
    [anon_sym_virtual] = ACTIONS(2554),
    [anon_sym_extern] = ACTIONS(2554),
    [anon_sym___attribute__] = ACTIONS(2554),
    [anon_sym___attribute] = ACTIONS(2554),
    [anon_sym_using] = ACTIONS(2554),
    [anon_sym_COLON_COLON] = ACTIONS(2552),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2552),
    [anon_sym___declspec] = ACTIONS(2554),
    [anon_sym___based] = ACTIONS(2554),
    [anon_sym___cdecl] = ACTIONS(2554),
    [anon_sym___clrcall] = ACTIONS(2554),
    [anon_sym___stdcall] = ACTIONS(2554),
    [anon_sym___fastcall] = ACTIONS(2554),
    [anon_sym___thiscall] = ACTIONS(2554),
    [anon_sym___vectorcall] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(2552),
    [anon_sym_signed] = ACTIONS(2554),
    [anon_sym_unsigned] = ACTIONS(2554),
    [anon_sym_long] = ACTIONS(2554),
    [anon_sym_short] = ACTIONS(2554),
    [anon_sym_LBRACK] = ACTIONS(2554),
    [anon_sym_static] = ACTIONS(2554),
    [anon_sym_register] = ACTIONS(2554),
    [anon_sym_inline] = ACTIONS(2554),
    [anon_sym___inline] = ACTIONS(2554),
    [anon_sym___inline__] = ACTIONS(2554),
    [anon_sym___forceinline] = ACTIONS(2554),
    [anon_sym_thread_local] = ACTIONS(2554),
    [anon_sym___thread] = ACTIONS(2554),
    [anon_sym_const] = ACTIONS(2554),
    [anon_sym_constexpr] = ACTIONS(2554),
    [anon_sym_volatile] = ACTIONS(2554),
    [anon_sym_restrict] = ACTIONS(2554),
    [anon_sym___restrict__] = ACTIONS(2554),
    [anon_sym__Atomic] = ACTIONS(2554),
    [anon_sym__Noreturn] = ACTIONS(2554),
    [anon_sym_noreturn] = ACTIONS(2554),
    [anon_sym__Nonnull] = ACTIONS(2554),
    [anon_sym_mutable] = ACTIONS(2554),
    [anon_sym_constinit] = ACTIONS(2554),
    [anon_sym_consteval] = ACTIONS(2554),
    [anon_sym_alignas] = ACTIONS(2554),
    [anon_sym__Alignas] = ACTIONS(2554),
    [sym_primitive_type] = ACTIONS(2554),
    [anon_sym_enum] = ACTIONS(2554),
    [anon_sym_class] = ACTIONS(2554),
    [anon_sym_struct] = ACTIONS(2554),
    [anon_sym_union] = ACTIONS(2554),
    [anon_sym_if] = ACTIONS(2554),
    [anon_sym_else] = ACTIONS(2554),
    [anon_sym_switch] = ACTIONS(2554),
    [anon_sym_case] = ACTIONS(2554),
    [anon_sym_default] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2554),
    [anon_sym_do] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2554),
    [anon_sym_return] = ACTIONS(2554),
    [anon_sym_break] = ACTIONS(2554),
    [anon_sym_continue] = ACTIONS(2554),
    [anon_sym_goto] = ACTIONS(2554),
    [anon_sym___try] = ACTIONS(2554),
    [anon_sym___leave] = ACTIONS(2554),
    [anon_sym_not] = ACTIONS(2554),
    [anon_sym_compl] = ACTIONS(2554),
    [anon_sym_DASH_DASH] = ACTIONS(2552),
    [anon_sym_PLUS_PLUS] = ACTIONS(2552),
    [anon_sym_sizeof] = ACTIONS(2554),
    [anon_sym___alignof__] = ACTIONS(2554),
    [anon_sym___alignof] = ACTIONS(2554),
    [anon_sym__alignof] = ACTIONS(2554),
    [anon_sym_alignof] = ACTIONS(2554),
    [anon_sym__Alignof] = ACTIONS(2554),
    [anon_sym_offsetof] = ACTIONS(2554),
    [anon_sym__Generic] = ACTIONS(2554),
    [anon_sym_asm] = ACTIONS(2554),
    [anon_sym___asm__] = ACTIONS(2554),
    [anon_sym___asm] = ACTIONS(2554),
    [anon_sym_DOT] = ACTIONS(2554),
    [sym_number_literal] = ACTIONS(2552),
    [anon_sym_L_SQUOTE] = ACTIONS(2552),
    [anon_sym_u_SQUOTE] = ACTIONS(2552),
    [anon_sym_U_SQUOTE] = ACTIONS(2552),
    [anon_sym_u8_SQUOTE] = ACTIONS(2552),
    [anon_sym_SQUOTE] = ACTIONS(2552),
    [anon_sym_L_DQUOTE] = ACTIONS(2552),
    [anon_sym_u_DQUOTE] = ACTIONS(2552),
    [anon_sym_U_DQUOTE] = ACTIONS(2552),
    [anon_sym_u8_DQUOTE] = ACTIONS(2552),
    [anon_sym_DQUOTE] = ACTIONS(2552),
    [sym_true] = ACTIONS(2554),
    [sym_false] = ACTIONS(2554),
    [anon_sym_NULL] = ACTIONS(2554),
    [anon_sym_nullptr] = ACTIONS(2554),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2554),
    [anon_sym_let] = ACTIONS(2554),
    [anon_sym_This] = ACTIONS(2554),
    [anon_sym_decltype] = ACTIONS(2554),
    [anon_sym_final] = ACTIONS(2554),
    [anon_sym_override] = ACTIONS(2554),
    [anon_sym_explicit] = ACTIONS(2554),
    [anon_sym_typename] = ACTIONS(2554),
    [anon_sym_export] = ACTIONS(2554),
    [anon_sym_module] = ACTIONS(2554),
    [anon_sym_import] = ACTIONS(2554),
    [anon_sym_template] = ACTIONS(2554),
    [anon_sym_GT2] = ACTIONS(2552),
    [anon_sym_operator] = ACTIONS(2554),
    [anon_sym_try] = ACTIONS(2554),
    [anon_sym_delete] = ACTIONS(2554),
    [anon_sym_throw] = ACTIONS(2554),
    [anon_sym_namespace] = ACTIONS(2554),
    [anon_sym_static_assert] = ACTIONS(2554),
    [anon_sym_concept] = ACTIONS(2554),
    [anon_sym_co_return] = ACTIONS(2554),
    [anon_sym_co_yield] = ACTIONS(2554),
    [anon_sym_R_DQUOTE] = ACTIONS(2552),
    [anon_sym_LR_DQUOTE] = ACTIONS(2552),
    [anon_sym_uR_DQUOTE] = ACTIONS(2552),
    [anon_sym_UR_DQUOTE] = ACTIONS(2552),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2552),
    [anon_sym_co_await] = ACTIONS(2554),
    [anon_sym_new] = ACTIONS(2554),
    [anon_sym_requires] = ACTIONS(2554),
    [sym_this] = ACTIONS(2554),
    [anon_sym_discard] = ACTIONS(2554),
    [anon_sym_precise] = ACTIONS(2554),
    [anon_sym_shared] = ACTIONS(2554),
    [anon_sym_groupshared] = ACTIONS(2554),
    [anon_sym_uniform] = ACTIONS(2554),
    [anon_sym_row_major] = ACTIONS(2554),
    [anon_sym_column_major] = ACTIONS(2554),
    [anon_sym_globallycoherent] = ACTIONS(2554),
    [anon_sym_centroid] = ACTIONS(2554),
    [anon_sym_noperspective] = ACTIONS(2554),
    [anon_sym_nointerpolation] = ACTIONS(2554),
    [anon_sym_sample] = ACTIONS(2554),
    [anon_sym_linear] = ACTIONS(2554),
    [anon_sym_snorm] = ACTIONS(2554),
    [anon_sym_unorm] = ACTIONS(2554),
    [anon_sym_point] = ACTIONS(2554),
    [anon_sym_line] = ACTIONS(2554),
    [anon_sym_triangleadj] = ACTIONS(2554),
    [anon_sym_lineadj] = ACTIONS(2554),
    [anon_sym_triangle] = ACTIONS(2554),
    [anon_sym_cbuffer] = ACTIONS(2554),
    [anon_sym_interface] = ACTIONS(2554),
    [anon_sym_extension] = ACTIONS(2554),
    [anon_sym_where] = ACTIONS(2554),
    [anon_sym___exported] = ACTIONS(2554),
  },
  [243] = {
    [sym_field_declaration_list] = STATE(483),
    [sym_virtual_specifier] = STATE(9427),
    [sym_base_class_clause] = STATE(10376),
    [sym_identifier] = ACTIONS(2556),
    [aux_sym_preproc_include_token1] = ACTIONS(2556),
    [aux_sym_preproc_def_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token2] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2556),
    [aux_sym_preproc_else_token1] = ACTIONS(2556),
    [aux_sym_preproc_elif_token1] = ACTIONS(2556),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2556),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2556),
    [sym_preproc_directive] = ACTIONS(2556),
    [anon_sym_LPAREN2] = ACTIONS(2558),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_TILDE] = ACTIONS(2558),
    [anon_sym_DASH] = ACTIONS(2556),
    [anon_sym_PLUS] = ACTIONS(2556),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym___extension__] = ACTIONS(2556),
    [anon_sym_typedef] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2556),
    [anon_sym_out] = ACTIONS(2556),
    [anon_sym_inout] = ACTIONS(2556),
    [anon_sym_virtual] = ACTIONS(2556),
    [anon_sym_extern] = ACTIONS(2556),
    [anon_sym___attribute__] = ACTIONS(2556),
    [anon_sym___attribute] = ACTIONS(2556),
    [anon_sym_using] = ACTIONS(2556),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2558),
    [anon_sym___declspec] = ACTIONS(2556),
    [anon_sym___based] = ACTIONS(2556),
    [anon_sym___cdecl] = ACTIONS(2556),
    [anon_sym___clrcall] = ACTIONS(2556),
    [anon_sym___stdcall] = ACTIONS(2556),
    [anon_sym___fastcall] = ACTIONS(2556),
    [anon_sym___thiscall] = ACTIONS(2556),
    [anon_sym___vectorcall] = ACTIONS(2556),
    [anon_sym_LBRACE] = ACTIONS(2562),
    [anon_sym_signed] = ACTIONS(2556),
    [anon_sym_unsigned] = ACTIONS(2556),
    [anon_sym_long] = ACTIONS(2556),
    [anon_sym_short] = ACTIONS(2556),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_static] = ACTIONS(2556),
    [anon_sym_register] = ACTIONS(2556),
    [anon_sym_inline] = ACTIONS(2556),
    [anon_sym___inline] = ACTIONS(2556),
    [anon_sym___inline__] = ACTIONS(2556),
    [anon_sym___forceinline] = ACTIONS(2556),
    [anon_sym_thread_local] = ACTIONS(2556),
    [anon_sym___thread] = ACTIONS(2556),
    [anon_sym_const] = ACTIONS(2556),
    [anon_sym_constexpr] = ACTIONS(2556),
    [anon_sym_volatile] = ACTIONS(2556),
    [anon_sym_restrict] = ACTIONS(2556),
    [anon_sym___restrict__] = ACTIONS(2556),
    [anon_sym__Atomic] = ACTIONS(2556),
    [anon_sym__Noreturn] = ACTIONS(2556),
    [anon_sym_noreturn] = ACTIONS(2556),
    [anon_sym__Nonnull] = ACTIONS(2556),
    [anon_sym_mutable] = ACTIONS(2556),
    [anon_sym_constinit] = ACTIONS(2556),
    [anon_sym_consteval] = ACTIONS(2556),
    [anon_sym_alignas] = ACTIONS(2556),
    [anon_sym__Alignas] = ACTIONS(2556),
    [sym_primitive_type] = ACTIONS(2556),
    [anon_sym_enum] = ACTIONS(2556),
    [anon_sym_class] = ACTIONS(2556),
    [anon_sym_struct] = ACTIONS(2556),
    [anon_sym_union] = ACTIONS(2556),
    [anon_sym_if] = ACTIONS(2556),
    [anon_sym_else] = ACTIONS(2556),
    [anon_sym_switch] = ACTIONS(2556),
    [anon_sym_case] = ACTIONS(2556),
    [anon_sym_default] = ACTIONS(2556),
    [anon_sym_while] = ACTIONS(2556),
    [anon_sym_do] = ACTIONS(2556),
    [anon_sym_for] = ACTIONS(2556),
    [anon_sym_return] = ACTIONS(2556),
    [anon_sym_break] = ACTIONS(2556),
    [anon_sym_continue] = ACTIONS(2556),
    [anon_sym_goto] = ACTIONS(2556),
    [anon_sym___try] = ACTIONS(2556),
    [anon_sym___leave] = ACTIONS(2556),
    [anon_sym_not] = ACTIONS(2556),
    [anon_sym_compl] = ACTIONS(2556),
    [anon_sym_DASH_DASH] = ACTIONS(2558),
    [anon_sym_PLUS_PLUS] = ACTIONS(2558),
    [anon_sym_sizeof] = ACTIONS(2556),
    [anon_sym___alignof__] = ACTIONS(2556),
    [anon_sym___alignof] = ACTIONS(2556),
    [anon_sym__alignof] = ACTIONS(2556),
    [anon_sym_alignof] = ACTIONS(2556),
    [anon_sym__Alignof] = ACTIONS(2556),
    [anon_sym_offsetof] = ACTIONS(2556),
    [anon_sym__Generic] = ACTIONS(2556),
    [anon_sym_asm] = ACTIONS(2556),
    [anon_sym___asm__] = ACTIONS(2556),
    [anon_sym___asm] = ACTIONS(2556),
    [sym_number_literal] = ACTIONS(2558),
    [anon_sym_L_SQUOTE] = ACTIONS(2558),
    [anon_sym_u_SQUOTE] = ACTIONS(2558),
    [anon_sym_U_SQUOTE] = ACTIONS(2558),
    [anon_sym_u8_SQUOTE] = ACTIONS(2558),
    [anon_sym_SQUOTE] = ACTIONS(2558),
    [anon_sym_L_DQUOTE] = ACTIONS(2558),
    [anon_sym_u_DQUOTE] = ACTIONS(2558),
    [anon_sym_U_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8_DQUOTE] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2558),
    [sym_true] = ACTIONS(2556),
    [sym_false] = ACTIONS(2556),
    [anon_sym_NULL] = ACTIONS(2556),
    [anon_sym_nullptr] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2556),
    [anon_sym_let] = ACTIONS(2556),
    [anon_sym_This] = ACTIONS(2556),
    [anon_sym_decltype] = ACTIONS(2556),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_explicit] = ACTIONS(2556),
    [anon_sym_typename] = ACTIONS(2556),
    [anon_sym_template] = ACTIONS(2556),
    [anon_sym_operator] = ACTIONS(2556),
    [anon_sym_try] = ACTIONS(2556),
    [anon_sym_delete] = ACTIONS(2556),
    [anon_sym_throw] = ACTIONS(2556),
    [anon_sym_namespace] = ACTIONS(2556),
    [anon_sym_static_assert] = ACTIONS(2556),
    [anon_sym_concept] = ACTIONS(2556),
    [anon_sym_co_return] = ACTIONS(2556),
    [anon_sym_co_yield] = ACTIONS(2556),
    [anon_sym_R_DQUOTE] = ACTIONS(2558),
    [anon_sym_LR_DQUOTE] = ACTIONS(2558),
    [anon_sym_uR_DQUOTE] = ACTIONS(2558),
    [anon_sym_UR_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2558),
    [anon_sym_co_await] = ACTIONS(2556),
    [anon_sym_new] = ACTIONS(2556),
    [anon_sym_requires] = ACTIONS(2556),
    [sym_this] = ACTIONS(2556),
    [anon_sym_discard] = ACTIONS(2556),
    [anon_sym_precise] = ACTIONS(2556),
    [anon_sym_shared] = ACTIONS(2556),
    [anon_sym_groupshared] = ACTIONS(2556),
    [anon_sym_uniform] = ACTIONS(2556),
    [anon_sym_row_major] = ACTIONS(2556),
    [anon_sym_column_major] = ACTIONS(2556),
    [anon_sym_globallycoherent] = ACTIONS(2556),
    [anon_sym_centroid] = ACTIONS(2556),
    [anon_sym_noperspective] = ACTIONS(2556),
    [anon_sym_nointerpolation] = ACTIONS(2556),
    [anon_sym_sample] = ACTIONS(2556),
    [anon_sym_linear] = ACTIONS(2556),
    [anon_sym_snorm] = ACTIONS(2556),
    [anon_sym_unorm] = ACTIONS(2556),
    [anon_sym_point] = ACTIONS(2556),
    [anon_sym_line] = ACTIONS(2556),
    [anon_sym_triangleadj] = ACTIONS(2556),
    [anon_sym_lineadj] = ACTIONS(2556),
    [anon_sym_triangle] = ACTIONS(2556),
    [anon_sym_cbuffer] = ACTIONS(2556),
    [anon_sym_interface] = ACTIONS(2556),
    [anon_sym_extension] = ACTIONS(2556),
  },
  [244] = {
    [sym_field_declaration_list] = STATE(456),
    [sym_virtual_specifier] = STATE(9398),
    [sym_base_class_clause] = STATE(10609),
    [sym_identifier] = ACTIONS(2566),
    [aux_sym_preproc_include_token1] = ACTIONS(2566),
    [aux_sym_preproc_def_token1] = ACTIONS(2566),
    [aux_sym_preproc_if_token1] = ACTIONS(2566),
    [aux_sym_preproc_if_token2] = ACTIONS(2566),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2566),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2566),
    [aux_sym_preproc_else_token1] = ACTIONS(2566),
    [aux_sym_preproc_elif_token1] = ACTIONS(2566),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2566),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2566),
    [sym_preproc_directive] = ACTIONS(2566),
    [anon_sym_LPAREN2] = ACTIONS(2568),
    [anon_sym_BANG] = ACTIONS(2568),
    [anon_sym_TILDE] = ACTIONS(2568),
    [anon_sym_DASH] = ACTIONS(2566),
    [anon_sym_PLUS] = ACTIONS(2566),
    [anon_sym_STAR] = ACTIONS(2568),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2566),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2568),
    [anon_sym___extension__] = ACTIONS(2566),
    [anon_sym_typedef] = ACTIONS(2566),
    [anon_sym_in] = ACTIONS(2566),
    [anon_sym_out] = ACTIONS(2566),
    [anon_sym_inout] = ACTIONS(2566),
    [anon_sym_virtual] = ACTIONS(2566),
    [anon_sym_extern] = ACTIONS(2566),
    [anon_sym___attribute__] = ACTIONS(2566),
    [anon_sym___attribute] = ACTIONS(2566),
    [anon_sym_using] = ACTIONS(2566),
    [anon_sym_COLON_COLON] = ACTIONS(2568),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2568),
    [anon_sym___declspec] = ACTIONS(2566),
    [anon_sym___based] = ACTIONS(2566),
    [anon_sym___cdecl] = ACTIONS(2566),
    [anon_sym___clrcall] = ACTIONS(2566),
    [anon_sym___stdcall] = ACTIONS(2566),
    [anon_sym___fastcall] = ACTIONS(2566),
    [anon_sym___thiscall] = ACTIONS(2566),
    [anon_sym___vectorcall] = ACTIONS(2566),
    [anon_sym_LBRACE] = ACTIONS(2562),
    [anon_sym_signed] = ACTIONS(2566),
    [anon_sym_unsigned] = ACTIONS(2566),
    [anon_sym_long] = ACTIONS(2566),
    [anon_sym_short] = ACTIONS(2566),
    [anon_sym_LBRACK] = ACTIONS(2566),
    [anon_sym_static] = ACTIONS(2566),
    [anon_sym_register] = ACTIONS(2566),
    [anon_sym_inline] = ACTIONS(2566),
    [anon_sym___inline] = ACTIONS(2566),
    [anon_sym___inline__] = ACTIONS(2566),
    [anon_sym___forceinline] = ACTIONS(2566),
    [anon_sym_thread_local] = ACTIONS(2566),
    [anon_sym___thread] = ACTIONS(2566),
    [anon_sym_const] = ACTIONS(2566),
    [anon_sym_constexpr] = ACTIONS(2566),
    [anon_sym_volatile] = ACTIONS(2566),
    [anon_sym_restrict] = ACTIONS(2566),
    [anon_sym___restrict__] = ACTIONS(2566),
    [anon_sym__Atomic] = ACTIONS(2566),
    [anon_sym__Noreturn] = ACTIONS(2566),
    [anon_sym_noreturn] = ACTIONS(2566),
    [anon_sym__Nonnull] = ACTIONS(2566),
    [anon_sym_mutable] = ACTIONS(2566),
    [anon_sym_constinit] = ACTIONS(2566),
    [anon_sym_consteval] = ACTIONS(2566),
    [anon_sym_alignas] = ACTIONS(2566),
    [anon_sym__Alignas] = ACTIONS(2566),
    [sym_primitive_type] = ACTIONS(2566),
    [anon_sym_enum] = ACTIONS(2566),
    [anon_sym_class] = ACTIONS(2566),
    [anon_sym_struct] = ACTIONS(2566),
    [anon_sym_union] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2566),
    [anon_sym_else] = ACTIONS(2566),
    [anon_sym_switch] = ACTIONS(2566),
    [anon_sym_case] = ACTIONS(2566),
    [anon_sym_default] = ACTIONS(2566),
    [anon_sym_while] = ACTIONS(2566),
    [anon_sym_do] = ACTIONS(2566),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_break] = ACTIONS(2566),
    [anon_sym_continue] = ACTIONS(2566),
    [anon_sym_goto] = ACTIONS(2566),
    [anon_sym___try] = ACTIONS(2566),
    [anon_sym___leave] = ACTIONS(2566),
    [anon_sym_not] = ACTIONS(2566),
    [anon_sym_compl] = ACTIONS(2566),
    [anon_sym_DASH_DASH] = ACTIONS(2568),
    [anon_sym_PLUS_PLUS] = ACTIONS(2568),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2566),
    [anon_sym___alignof] = ACTIONS(2566),
    [anon_sym__alignof] = ACTIONS(2566),
    [anon_sym_alignof] = ACTIONS(2566),
    [anon_sym__Alignof] = ACTIONS(2566),
    [anon_sym_offsetof] = ACTIONS(2566),
    [anon_sym__Generic] = ACTIONS(2566),
    [anon_sym_asm] = ACTIONS(2566),
    [anon_sym___asm__] = ACTIONS(2566),
    [anon_sym___asm] = ACTIONS(2566),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2568),
    [anon_sym_u_SQUOTE] = ACTIONS(2568),
    [anon_sym_U_SQUOTE] = ACTIONS(2568),
    [anon_sym_u8_SQUOTE] = ACTIONS(2568),
    [anon_sym_SQUOTE] = ACTIONS(2568),
    [anon_sym_L_DQUOTE] = ACTIONS(2568),
    [anon_sym_u_DQUOTE] = ACTIONS(2568),
    [anon_sym_U_DQUOTE] = ACTIONS(2568),
    [anon_sym_u8_DQUOTE] = ACTIONS(2568),
    [anon_sym_DQUOTE] = ACTIONS(2568),
    [sym_true] = ACTIONS(2566),
    [sym_false] = ACTIONS(2566),
    [anon_sym_NULL] = ACTIONS(2566),
    [anon_sym_nullptr] = ACTIONS(2566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2566),
    [anon_sym_let] = ACTIONS(2566),
    [anon_sym_This] = ACTIONS(2566),
    [anon_sym_decltype] = ACTIONS(2566),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_explicit] = ACTIONS(2566),
    [anon_sym_typename] = ACTIONS(2566),
    [anon_sym_template] = ACTIONS(2566),
    [anon_sym_operator] = ACTIONS(2566),
    [anon_sym_try] = ACTIONS(2566),
    [anon_sym_delete] = ACTIONS(2566),
    [anon_sym_throw] = ACTIONS(2566),
    [anon_sym_namespace] = ACTIONS(2566),
    [anon_sym_static_assert] = ACTIONS(2566),
    [anon_sym_concept] = ACTIONS(2566),
    [anon_sym_co_return] = ACTIONS(2566),
    [anon_sym_co_yield] = ACTIONS(2566),
    [anon_sym_R_DQUOTE] = ACTIONS(2568),
    [anon_sym_LR_DQUOTE] = ACTIONS(2568),
    [anon_sym_uR_DQUOTE] = ACTIONS(2568),
    [anon_sym_UR_DQUOTE] = ACTIONS(2568),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2568),
    [anon_sym_co_await] = ACTIONS(2566),
    [anon_sym_new] = ACTIONS(2566),
    [anon_sym_requires] = ACTIONS(2566),
    [sym_this] = ACTIONS(2566),
    [anon_sym_discard] = ACTIONS(2566),
    [anon_sym_precise] = ACTIONS(2566),
    [anon_sym_shared] = ACTIONS(2566),
    [anon_sym_groupshared] = ACTIONS(2566),
    [anon_sym_uniform] = ACTIONS(2566),
    [anon_sym_row_major] = ACTIONS(2566),
    [anon_sym_column_major] = ACTIONS(2566),
    [anon_sym_globallycoherent] = ACTIONS(2566),
    [anon_sym_centroid] = ACTIONS(2566),
    [anon_sym_noperspective] = ACTIONS(2566),
    [anon_sym_nointerpolation] = ACTIONS(2566),
    [anon_sym_sample] = ACTIONS(2566),
    [anon_sym_linear] = ACTIONS(2566),
    [anon_sym_snorm] = ACTIONS(2566),
    [anon_sym_unorm] = ACTIONS(2566),
    [anon_sym_point] = ACTIONS(2566),
    [anon_sym_line] = ACTIONS(2566),
    [anon_sym_triangleadj] = ACTIONS(2566),
    [anon_sym_lineadj] = ACTIONS(2566),
    [anon_sym_triangle] = ACTIONS(2566),
    [anon_sym_cbuffer] = ACTIONS(2566),
    [anon_sym_interface] = ACTIONS(2566),
    [anon_sym_extension] = ACTIONS(2566),
  },
  [245] = {
    [sym_field_declaration_list] = STATE(504),
    [sym_virtual_specifier] = STATE(9564),
    [sym_base_class_clause] = STATE(10617),
    [ts_builtin_sym_end] = ACTIONS(2558),
    [sym_identifier] = ACTIONS(2556),
    [aux_sym_preproc_include_token1] = ACTIONS(2556),
    [aux_sym_preproc_def_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2556),
    [sym_preproc_directive] = ACTIONS(2556),
    [anon_sym_LPAREN2] = ACTIONS(2558),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_TILDE] = ACTIONS(2558),
    [anon_sym_DASH] = ACTIONS(2556),
    [anon_sym_PLUS] = ACTIONS(2556),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym___extension__] = ACTIONS(2556),
    [anon_sym_typedef] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2556),
    [anon_sym_out] = ACTIONS(2556),
    [anon_sym_inout] = ACTIONS(2556),
    [anon_sym_virtual] = ACTIONS(2556),
    [anon_sym_extern] = ACTIONS(2556),
    [anon_sym___attribute__] = ACTIONS(2556),
    [anon_sym___attribute] = ACTIONS(2556),
    [anon_sym_using] = ACTIONS(2556),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2558),
    [anon_sym___declspec] = ACTIONS(2556),
    [anon_sym___based] = ACTIONS(2556),
    [anon_sym___cdecl] = ACTIONS(2556),
    [anon_sym___clrcall] = ACTIONS(2556),
    [anon_sym___stdcall] = ACTIONS(2556),
    [anon_sym___fastcall] = ACTIONS(2556),
    [anon_sym___thiscall] = ACTIONS(2556),
    [anon_sym___vectorcall] = ACTIONS(2556),
    [anon_sym_LBRACE] = ACTIONS(2570),
    [anon_sym_signed] = ACTIONS(2556),
    [anon_sym_unsigned] = ACTIONS(2556),
    [anon_sym_long] = ACTIONS(2556),
    [anon_sym_short] = ACTIONS(2556),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_static] = ACTIONS(2556),
    [anon_sym_register] = ACTIONS(2556),
    [anon_sym_inline] = ACTIONS(2556),
    [anon_sym___inline] = ACTIONS(2556),
    [anon_sym___inline__] = ACTIONS(2556),
    [anon_sym___forceinline] = ACTIONS(2556),
    [anon_sym_thread_local] = ACTIONS(2556),
    [anon_sym___thread] = ACTIONS(2556),
    [anon_sym_const] = ACTIONS(2556),
    [anon_sym_constexpr] = ACTIONS(2556),
    [anon_sym_volatile] = ACTIONS(2556),
    [anon_sym_restrict] = ACTIONS(2556),
    [anon_sym___restrict__] = ACTIONS(2556),
    [anon_sym__Atomic] = ACTIONS(2556),
    [anon_sym__Noreturn] = ACTIONS(2556),
    [anon_sym_noreturn] = ACTIONS(2556),
    [anon_sym__Nonnull] = ACTIONS(2556),
    [anon_sym_mutable] = ACTIONS(2556),
    [anon_sym_constinit] = ACTIONS(2556),
    [anon_sym_consteval] = ACTIONS(2556),
    [anon_sym_alignas] = ACTIONS(2556),
    [anon_sym__Alignas] = ACTIONS(2556),
    [sym_primitive_type] = ACTIONS(2556),
    [anon_sym_enum] = ACTIONS(2556),
    [anon_sym_class] = ACTIONS(2556),
    [anon_sym_struct] = ACTIONS(2556),
    [anon_sym_union] = ACTIONS(2556),
    [anon_sym_if] = ACTIONS(2556),
    [anon_sym_else] = ACTIONS(2556),
    [anon_sym_switch] = ACTIONS(2556),
    [anon_sym_case] = ACTIONS(2556),
    [anon_sym_default] = ACTIONS(2556),
    [anon_sym_while] = ACTIONS(2556),
    [anon_sym_do] = ACTIONS(2556),
    [anon_sym_for] = ACTIONS(2556),
    [anon_sym_return] = ACTIONS(2556),
    [anon_sym_break] = ACTIONS(2556),
    [anon_sym_continue] = ACTIONS(2556),
    [anon_sym_goto] = ACTIONS(2556),
    [anon_sym___try] = ACTIONS(2556),
    [anon_sym___leave] = ACTIONS(2556),
    [anon_sym_not] = ACTIONS(2556),
    [anon_sym_compl] = ACTIONS(2556),
    [anon_sym_DASH_DASH] = ACTIONS(2558),
    [anon_sym_PLUS_PLUS] = ACTIONS(2558),
    [anon_sym_sizeof] = ACTIONS(2556),
    [anon_sym___alignof__] = ACTIONS(2556),
    [anon_sym___alignof] = ACTIONS(2556),
    [anon_sym__alignof] = ACTIONS(2556),
    [anon_sym_alignof] = ACTIONS(2556),
    [anon_sym__Alignof] = ACTIONS(2556),
    [anon_sym_offsetof] = ACTIONS(2556),
    [anon_sym__Generic] = ACTIONS(2556),
    [anon_sym_asm] = ACTIONS(2556),
    [anon_sym___asm__] = ACTIONS(2556),
    [anon_sym___asm] = ACTIONS(2556),
    [sym_number_literal] = ACTIONS(2558),
    [anon_sym_L_SQUOTE] = ACTIONS(2558),
    [anon_sym_u_SQUOTE] = ACTIONS(2558),
    [anon_sym_U_SQUOTE] = ACTIONS(2558),
    [anon_sym_u8_SQUOTE] = ACTIONS(2558),
    [anon_sym_SQUOTE] = ACTIONS(2558),
    [anon_sym_L_DQUOTE] = ACTIONS(2558),
    [anon_sym_u_DQUOTE] = ACTIONS(2558),
    [anon_sym_U_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8_DQUOTE] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2558),
    [sym_true] = ACTIONS(2556),
    [sym_false] = ACTIONS(2556),
    [anon_sym_NULL] = ACTIONS(2556),
    [anon_sym_nullptr] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2556),
    [anon_sym_let] = ACTIONS(2556),
    [anon_sym_This] = ACTIONS(2556),
    [anon_sym_decltype] = ACTIONS(2556),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_explicit] = ACTIONS(2556),
    [anon_sym_typename] = ACTIONS(2556),
    [anon_sym_export] = ACTIONS(2556),
    [anon_sym_module] = ACTIONS(2556),
    [anon_sym_import] = ACTIONS(2556),
    [anon_sym_template] = ACTIONS(2556),
    [anon_sym_operator] = ACTIONS(2556),
    [anon_sym_try] = ACTIONS(2556),
    [anon_sym_delete] = ACTIONS(2556),
    [anon_sym_throw] = ACTIONS(2556),
    [anon_sym_namespace] = ACTIONS(2556),
    [anon_sym_static_assert] = ACTIONS(2556),
    [anon_sym_concept] = ACTIONS(2556),
    [anon_sym_co_return] = ACTIONS(2556),
    [anon_sym_co_yield] = ACTIONS(2556),
    [anon_sym_R_DQUOTE] = ACTIONS(2558),
    [anon_sym_LR_DQUOTE] = ACTIONS(2558),
    [anon_sym_uR_DQUOTE] = ACTIONS(2558),
    [anon_sym_UR_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2558),
    [anon_sym_co_await] = ACTIONS(2556),
    [anon_sym_new] = ACTIONS(2556),
    [anon_sym_requires] = ACTIONS(2556),
    [sym_this] = ACTIONS(2556),
    [anon_sym_discard] = ACTIONS(2556),
    [anon_sym_precise] = ACTIONS(2556),
    [anon_sym_shared] = ACTIONS(2556),
    [anon_sym_groupshared] = ACTIONS(2556),
    [anon_sym_uniform] = ACTIONS(2556),
    [anon_sym_row_major] = ACTIONS(2556),
    [anon_sym_column_major] = ACTIONS(2556),
    [anon_sym_globallycoherent] = ACTIONS(2556),
    [anon_sym_centroid] = ACTIONS(2556),
    [anon_sym_noperspective] = ACTIONS(2556),
    [anon_sym_nointerpolation] = ACTIONS(2556),
    [anon_sym_sample] = ACTIONS(2556),
    [anon_sym_linear] = ACTIONS(2556),
    [anon_sym_snorm] = ACTIONS(2556),
    [anon_sym_unorm] = ACTIONS(2556),
    [anon_sym_point] = ACTIONS(2556),
    [anon_sym_line] = ACTIONS(2556),
    [anon_sym_triangleadj] = ACTIONS(2556),
    [anon_sym_lineadj] = ACTIONS(2556),
    [anon_sym_triangle] = ACTIONS(2556),
    [anon_sym_cbuffer] = ACTIONS(2556),
    [anon_sym_interface] = ACTIONS(2556),
    [anon_sym_extension] = ACTIONS(2556),
    [anon_sym___exported] = ACTIONS(2556),
  },
  [246] = {
    [sym_field_declaration_list] = STATE(499),
    [sym_virtual_specifier] = STATE(9437),
    [sym_base_class_clause] = STATE(10547),
    [ts_builtin_sym_end] = ACTIONS(2568),
    [sym_identifier] = ACTIONS(2566),
    [aux_sym_preproc_include_token1] = ACTIONS(2566),
    [aux_sym_preproc_def_token1] = ACTIONS(2566),
    [aux_sym_preproc_if_token1] = ACTIONS(2566),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2566),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2566),
    [sym_preproc_directive] = ACTIONS(2566),
    [anon_sym_LPAREN2] = ACTIONS(2568),
    [anon_sym_BANG] = ACTIONS(2568),
    [anon_sym_TILDE] = ACTIONS(2568),
    [anon_sym_DASH] = ACTIONS(2566),
    [anon_sym_PLUS] = ACTIONS(2566),
    [anon_sym_STAR] = ACTIONS(2568),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2566),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2568),
    [anon_sym___extension__] = ACTIONS(2566),
    [anon_sym_typedef] = ACTIONS(2566),
    [anon_sym_in] = ACTIONS(2566),
    [anon_sym_out] = ACTIONS(2566),
    [anon_sym_inout] = ACTIONS(2566),
    [anon_sym_virtual] = ACTIONS(2566),
    [anon_sym_extern] = ACTIONS(2566),
    [anon_sym___attribute__] = ACTIONS(2566),
    [anon_sym___attribute] = ACTIONS(2566),
    [anon_sym_using] = ACTIONS(2566),
    [anon_sym_COLON_COLON] = ACTIONS(2568),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2568),
    [anon_sym___declspec] = ACTIONS(2566),
    [anon_sym___based] = ACTIONS(2566),
    [anon_sym___cdecl] = ACTIONS(2566),
    [anon_sym___clrcall] = ACTIONS(2566),
    [anon_sym___stdcall] = ACTIONS(2566),
    [anon_sym___fastcall] = ACTIONS(2566),
    [anon_sym___thiscall] = ACTIONS(2566),
    [anon_sym___vectorcall] = ACTIONS(2566),
    [anon_sym_LBRACE] = ACTIONS(2570),
    [anon_sym_signed] = ACTIONS(2566),
    [anon_sym_unsigned] = ACTIONS(2566),
    [anon_sym_long] = ACTIONS(2566),
    [anon_sym_short] = ACTIONS(2566),
    [anon_sym_LBRACK] = ACTIONS(2566),
    [anon_sym_static] = ACTIONS(2566),
    [anon_sym_register] = ACTIONS(2566),
    [anon_sym_inline] = ACTIONS(2566),
    [anon_sym___inline] = ACTIONS(2566),
    [anon_sym___inline__] = ACTIONS(2566),
    [anon_sym___forceinline] = ACTIONS(2566),
    [anon_sym_thread_local] = ACTIONS(2566),
    [anon_sym___thread] = ACTIONS(2566),
    [anon_sym_const] = ACTIONS(2566),
    [anon_sym_constexpr] = ACTIONS(2566),
    [anon_sym_volatile] = ACTIONS(2566),
    [anon_sym_restrict] = ACTIONS(2566),
    [anon_sym___restrict__] = ACTIONS(2566),
    [anon_sym__Atomic] = ACTIONS(2566),
    [anon_sym__Noreturn] = ACTIONS(2566),
    [anon_sym_noreturn] = ACTIONS(2566),
    [anon_sym__Nonnull] = ACTIONS(2566),
    [anon_sym_mutable] = ACTIONS(2566),
    [anon_sym_constinit] = ACTIONS(2566),
    [anon_sym_consteval] = ACTIONS(2566),
    [anon_sym_alignas] = ACTIONS(2566),
    [anon_sym__Alignas] = ACTIONS(2566),
    [sym_primitive_type] = ACTIONS(2566),
    [anon_sym_enum] = ACTIONS(2566),
    [anon_sym_class] = ACTIONS(2566),
    [anon_sym_struct] = ACTIONS(2566),
    [anon_sym_union] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2566),
    [anon_sym_else] = ACTIONS(2566),
    [anon_sym_switch] = ACTIONS(2566),
    [anon_sym_case] = ACTIONS(2566),
    [anon_sym_default] = ACTIONS(2566),
    [anon_sym_while] = ACTIONS(2566),
    [anon_sym_do] = ACTIONS(2566),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_break] = ACTIONS(2566),
    [anon_sym_continue] = ACTIONS(2566),
    [anon_sym_goto] = ACTIONS(2566),
    [anon_sym___try] = ACTIONS(2566),
    [anon_sym___leave] = ACTIONS(2566),
    [anon_sym_not] = ACTIONS(2566),
    [anon_sym_compl] = ACTIONS(2566),
    [anon_sym_DASH_DASH] = ACTIONS(2568),
    [anon_sym_PLUS_PLUS] = ACTIONS(2568),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2566),
    [anon_sym___alignof] = ACTIONS(2566),
    [anon_sym__alignof] = ACTIONS(2566),
    [anon_sym_alignof] = ACTIONS(2566),
    [anon_sym__Alignof] = ACTIONS(2566),
    [anon_sym_offsetof] = ACTIONS(2566),
    [anon_sym__Generic] = ACTIONS(2566),
    [anon_sym_asm] = ACTIONS(2566),
    [anon_sym___asm__] = ACTIONS(2566),
    [anon_sym___asm] = ACTIONS(2566),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2568),
    [anon_sym_u_SQUOTE] = ACTIONS(2568),
    [anon_sym_U_SQUOTE] = ACTIONS(2568),
    [anon_sym_u8_SQUOTE] = ACTIONS(2568),
    [anon_sym_SQUOTE] = ACTIONS(2568),
    [anon_sym_L_DQUOTE] = ACTIONS(2568),
    [anon_sym_u_DQUOTE] = ACTIONS(2568),
    [anon_sym_U_DQUOTE] = ACTIONS(2568),
    [anon_sym_u8_DQUOTE] = ACTIONS(2568),
    [anon_sym_DQUOTE] = ACTIONS(2568),
    [sym_true] = ACTIONS(2566),
    [sym_false] = ACTIONS(2566),
    [anon_sym_NULL] = ACTIONS(2566),
    [anon_sym_nullptr] = ACTIONS(2566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2566),
    [anon_sym_let] = ACTIONS(2566),
    [anon_sym_This] = ACTIONS(2566),
    [anon_sym_decltype] = ACTIONS(2566),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_explicit] = ACTIONS(2566),
    [anon_sym_typename] = ACTIONS(2566),
    [anon_sym_export] = ACTIONS(2566),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_import] = ACTIONS(2566),
    [anon_sym_template] = ACTIONS(2566),
    [anon_sym_operator] = ACTIONS(2566),
    [anon_sym_try] = ACTIONS(2566),
    [anon_sym_delete] = ACTIONS(2566),
    [anon_sym_throw] = ACTIONS(2566),
    [anon_sym_namespace] = ACTIONS(2566),
    [anon_sym_static_assert] = ACTIONS(2566),
    [anon_sym_concept] = ACTIONS(2566),
    [anon_sym_co_return] = ACTIONS(2566),
    [anon_sym_co_yield] = ACTIONS(2566),
    [anon_sym_R_DQUOTE] = ACTIONS(2568),
    [anon_sym_LR_DQUOTE] = ACTIONS(2568),
    [anon_sym_uR_DQUOTE] = ACTIONS(2568),
    [anon_sym_UR_DQUOTE] = ACTIONS(2568),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2568),
    [anon_sym_co_await] = ACTIONS(2566),
    [anon_sym_new] = ACTIONS(2566),
    [anon_sym_requires] = ACTIONS(2566),
    [sym_this] = ACTIONS(2566),
    [anon_sym_discard] = ACTIONS(2566),
    [anon_sym_precise] = ACTIONS(2566),
    [anon_sym_shared] = ACTIONS(2566),
    [anon_sym_groupshared] = ACTIONS(2566),
    [anon_sym_uniform] = ACTIONS(2566),
    [anon_sym_row_major] = ACTIONS(2566),
    [anon_sym_column_major] = ACTIONS(2566),
    [anon_sym_globallycoherent] = ACTIONS(2566),
    [anon_sym_centroid] = ACTIONS(2566),
    [anon_sym_noperspective] = ACTIONS(2566),
    [anon_sym_nointerpolation] = ACTIONS(2566),
    [anon_sym_sample] = ACTIONS(2566),
    [anon_sym_linear] = ACTIONS(2566),
    [anon_sym_snorm] = ACTIONS(2566),
    [anon_sym_unorm] = ACTIONS(2566),
    [anon_sym_point] = ACTIONS(2566),
    [anon_sym_line] = ACTIONS(2566),
    [anon_sym_triangleadj] = ACTIONS(2566),
    [anon_sym_lineadj] = ACTIONS(2566),
    [anon_sym_triangle] = ACTIONS(2566),
    [anon_sym_cbuffer] = ACTIONS(2566),
    [anon_sym_interface] = ACTIONS(2566),
    [anon_sym_extension] = ACTIONS(2566),
    [anon_sym___exported] = ACTIONS(2566),
  },
  [247] = {
    [sym__declaration_modifiers] = STATE(2773),
    [sym_attribute_specifier] = STATE(2773),
    [sym_attribute_declaration] = STATE(2773),
    [sym_ms_declspec_modifier] = STATE(2773),
    [sym_storage_class_specifier] = STATE(2773),
    [sym_type_qualifier] = STATE(2773),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_qualifiers] = STATE(2773),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2773),
    [ts_builtin_sym_end] = ACTIONS(2572),
    [sym_identifier] = ACTIONS(2574),
    [aux_sym_preproc_include_token1] = ACTIONS(2577),
    [aux_sym_preproc_def_token1] = ACTIONS(2577),
    [aux_sym_preproc_if_token1] = ACTIONS(2577),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2577),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2577),
    [sym_preproc_directive] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(2579),
    [anon_sym_BANG] = ACTIONS(2572),
    [anon_sym_TILDE] = ACTIONS(2579),
    [anon_sym_DASH] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2577),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_AMP_AMP] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2574),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym___extension__] = ACTIONS(2585),
    [anon_sym_typedef] = ACTIONS(2577),
    [anon_sym_in] = ACTIONS(2588),
    [anon_sym_out] = ACTIONS(2588),
    [anon_sym_inout] = ACTIONS(2588),
    [anon_sym_virtual] = ACTIONS(2588),
    [anon_sym_extern] = ACTIONS(2591),
    [anon_sym___attribute__] = ACTIONS(2594),
    [anon_sym___attribute] = ACTIONS(2594),
    [anon_sym_using] = ACTIONS(2577),
    [anon_sym_COLON_COLON] = ACTIONS(2579),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2597),
    [anon_sym___declspec] = ACTIONS(2600),
    [anon_sym___based] = ACTIONS(2574),
    [anon_sym___cdecl] = ACTIONS(2574),
    [anon_sym___clrcall] = ACTIONS(2574),
    [anon_sym___stdcall] = ACTIONS(2574),
    [anon_sym___fastcall] = ACTIONS(2574),
    [anon_sym___thiscall] = ACTIONS(2574),
    [anon_sym___vectorcall] = ACTIONS(2574),
    [anon_sym_LBRACE] = ACTIONS(2572),
    [anon_sym_signed] = ACTIONS(2577),
    [anon_sym_unsigned] = ACTIONS(2577),
    [anon_sym_long] = ACTIONS(2577),
    [anon_sym_short] = ACTIONS(2577),
    [anon_sym_LBRACK] = ACTIONS(2574),
    [anon_sym_static] = ACTIONS(2591),
    [anon_sym_register] = ACTIONS(2591),
    [anon_sym_inline] = ACTIONS(2591),
    [anon_sym___inline] = ACTIONS(2591),
    [anon_sym___inline__] = ACTIONS(2591),
    [anon_sym___forceinline] = ACTIONS(2591),
    [anon_sym_thread_local] = ACTIONS(2591),
    [anon_sym___thread] = ACTIONS(2591),
    [anon_sym_const] = ACTIONS(2585),
    [anon_sym_constexpr] = ACTIONS(2585),
    [anon_sym_volatile] = ACTIONS(2585),
    [anon_sym_restrict] = ACTIONS(2585),
    [anon_sym___restrict__] = ACTIONS(2585),
    [anon_sym__Atomic] = ACTIONS(2585),
    [anon_sym__Noreturn] = ACTIONS(2585),
    [anon_sym_noreturn] = ACTIONS(2585),
    [anon_sym__Nonnull] = ACTIONS(2585),
    [anon_sym_mutable] = ACTIONS(2585),
    [anon_sym_constinit] = ACTIONS(2585),
    [anon_sym_consteval] = ACTIONS(2585),
    [anon_sym_alignas] = ACTIONS(2603),
    [anon_sym__Alignas] = ACTIONS(2603),
    [sym_primitive_type] = ACTIONS(2577),
    [anon_sym_enum] = ACTIONS(2577),
    [anon_sym_class] = ACTIONS(2577),
    [anon_sym_struct] = ACTIONS(2577),
    [anon_sym_union] = ACTIONS(2577),
    [anon_sym_if] = ACTIONS(2577),
    [anon_sym_switch] = ACTIONS(2577),
    [anon_sym_case] = ACTIONS(2577),
    [anon_sym_default] = ACTIONS(2577),
    [anon_sym_while] = ACTIONS(2577),
    [anon_sym_do] = ACTIONS(2577),
    [anon_sym_for] = ACTIONS(2577),
    [anon_sym_return] = ACTIONS(2577),
    [anon_sym_break] = ACTIONS(2577),
    [anon_sym_continue] = ACTIONS(2577),
    [anon_sym_goto] = ACTIONS(2577),
    [anon_sym_not] = ACTIONS(2577),
    [anon_sym_compl] = ACTIONS(2577),
    [anon_sym_DASH_DASH] = ACTIONS(2572),
    [anon_sym_PLUS_PLUS] = ACTIONS(2572),
    [anon_sym_sizeof] = ACTIONS(2577),
    [anon_sym___alignof__] = ACTIONS(2577),
    [anon_sym___alignof] = ACTIONS(2577),
    [anon_sym__alignof] = ACTIONS(2577),
    [anon_sym_alignof] = ACTIONS(2577),
    [anon_sym__Alignof] = ACTIONS(2577),
    [anon_sym_offsetof] = ACTIONS(2577),
    [anon_sym__Generic] = ACTIONS(2577),
    [anon_sym_asm] = ACTIONS(2577),
    [anon_sym___asm__] = ACTIONS(2577),
    [anon_sym___asm] = ACTIONS(2577),
    [anon_sym_DOT] = ACTIONS(2606),
    [sym_number_literal] = ACTIONS(2572),
    [anon_sym_L_SQUOTE] = ACTIONS(2572),
    [anon_sym_u_SQUOTE] = ACTIONS(2572),
    [anon_sym_U_SQUOTE] = ACTIONS(2572),
    [anon_sym_u8_SQUOTE] = ACTIONS(2572),
    [anon_sym_SQUOTE] = ACTIONS(2572),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2577),
    [sym_false] = ACTIONS(2577),
    [anon_sym_NULL] = ACTIONS(2577),
    [anon_sym_nullptr] = ACTIONS(2577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_This] = ACTIONS(2608),
    [anon_sym_decltype] = ACTIONS(2574),
    [anon_sym_explicit] = ACTIONS(2577),
    [anon_sym_typename] = ACTIONS(2577),
    [anon_sym_export] = ACTIONS(2577),
    [anon_sym_module] = ACTIONS(2577),
    [anon_sym_import] = ACTIONS(2577),
    [anon_sym_template] = ACTIONS(2574),
    [anon_sym_operator] = ACTIONS(2574),
    [anon_sym_try] = ACTIONS(2577),
    [anon_sym_delete] = ACTIONS(2577),
    [anon_sym_throw] = ACTIONS(2577),
    [anon_sym_namespace] = ACTIONS(2577),
    [anon_sym_static_assert] = ACTIONS(2577),
    [anon_sym_concept] = ACTIONS(2577),
    [anon_sym_co_return] = ACTIONS(2577),
    [anon_sym_co_yield] = ACTIONS(2577),
    [anon_sym_R_DQUOTE] = ACTIONS(2572),
    [anon_sym_LR_DQUOTE] = ACTIONS(2572),
    [anon_sym_uR_DQUOTE] = ACTIONS(2572),
    [anon_sym_UR_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2572),
    [anon_sym_co_await] = ACTIONS(2577),
    [anon_sym_new] = ACTIONS(2577),
    [anon_sym_requires] = ACTIONS(2577),
    [sym_this] = ACTIONS(2577),
    [anon_sym_precise] = ACTIONS(2610),
    [anon_sym_shared] = ACTIONS(2610),
    [anon_sym_groupshared] = ACTIONS(2610),
    [anon_sym_uniform] = ACTIONS(2610),
    [anon_sym_row_major] = ACTIONS(2610),
    [anon_sym_column_major] = ACTIONS(2610),
    [anon_sym_globallycoherent] = ACTIONS(2610),
    [anon_sym_centroid] = ACTIONS(2610),
    [anon_sym_noperspective] = ACTIONS(2610),
    [anon_sym_nointerpolation] = ACTIONS(2610),
    [anon_sym_sample] = ACTIONS(2610),
    [anon_sym_linear] = ACTIONS(2610),
    [anon_sym_snorm] = ACTIONS(2610),
    [anon_sym_unorm] = ACTIONS(2610),
    [anon_sym_point] = ACTIONS(2610),
    [anon_sym_line] = ACTIONS(2610),
    [anon_sym_triangleadj] = ACTIONS(2610),
    [anon_sym_lineadj] = ACTIONS(2610),
    [anon_sym_triangle] = ACTIONS(2610),
    [anon_sym_interface] = ACTIONS(2577),
    [anon_sym_extension] = ACTIONS(2577),
    [anon_sym___exported] = ACTIONS(2577),
  },
  [248] = {
    [sym__declaration_modifiers] = STATE(2773),
    [sym_attribute_specifier] = STATE(2773),
    [sym_attribute_declaration] = STATE(2773),
    [sym_ms_declspec_modifier] = STATE(2773),
    [sym_storage_class_specifier] = STATE(2773),
    [sym_type_qualifier] = STATE(2773),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_qualifiers] = STATE(2773),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2773),
    [sym_identifier] = ACTIONS(2613),
    [aux_sym_preproc_include_token1] = ACTIONS(2616),
    [aux_sym_preproc_def_token1] = ACTIONS(2616),
    [aux_sym_preproc_if_token1] = ACTIONS(2616),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2616),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2616),
    [sym_preproc_directive] = ACTIONS(2616),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_BANG] = ACTIONS(2621),
    [anon_sym_TILDE] = ACTIONS(2618),
    [anon_sym_DASH] = ACTIONS(2616),
    [anon_sym_PLUS] = ACTIONS(2616),
    [anon_sym_STAR] = ACTIONS(2618),
    [anon_sym_AMP_AMP] = ACTIONS(2618),
    [anon_sym_AMP] = ACTIONS(2613),
    [anon_sym_SEMI] = ACTIONS(2623),
    [anon_sym___extension__] = ACTIONS(2626),
    [anon_sym_typedef] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2629),
    [anon_sym_out] = ACTIONS(2629),
    [anon_sym_inout] = ACTIONS(2629),
    [anon_sym_virtual] = ACTIONS(2629),
    [anon_sym_extern] = ACTIONS(2632),
    [anon_sym___attribute__] = ACTIONS(2635),
    [anon_sym___attribute] = ACTIONS(2635),
    [anon_sym_using] = ACTIONS(2616),
    [anon_sym_COLON_COLON] = ACTIONS(2618),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2638),
    [anon_sym___declspec] = ACTIONS(2641),
    [anon_sym___based] = ACTIONS(2613),
    [anon_sym___cdecl] = ACTIONS(2613),
    [anon_sym___clrcall] = ACTIONS(2613),
    [anon_sym___stdcall] = ACTIONS(2613),
    [anon_sym___fastcall] = ACTIONS(2613),
    [anon_sym___thiscall] = ACTIONS(2613),
    [anon_sym___vectorcall] = ACTIONS(2613),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_RBRACE] = ACTIONS(2621),
    [anon_sym_signed] = ACTIONS(2616),
    [anon_sym_unsigned] = ACTIONS(2616),
    [anon_sym_long] = ACTIONS(2616),
    [anon_sym_short] = ACTIONS(2616),
    [anon_sym_LBRACK] = ACTIONS(2613),
    [anon_sym_static] = ACTIONS(2632),
    [anon_sym_register] = ACTIONS(2632),
    [anon_sym_inline] = ACTIONS(2632),
    [anon_sym___inline] = ACTIONS(2632),
    [anon_sym___inline__] = ACTIONS(2632),
    [anon_sym___forceinline] = ACTIONS(2632),
    [anon_sym_thread_local] = ACTIONS(2632),
    [anon_sym___thread] = ACTIONS(2632),
    [anon_sym_const] = ACTIONS(2626),
    [anon_sym_constexpr] = ACTIONS(2626),
    [anon_sym_volatile] = ACTIONS(2626),
    [anon_sym_restrict] = ACTIONS(2626),
    [anon_sym___restrict__] = ACTIONS(2626),
    [anon_sym__Atomic] = ACTIONS(2626),
    [anon_sym__Noreturn] = ACTIONS(2626),
    [anon_sym_noreturn] = ACTIONS(2626),
    [anon_sym__Nonnull] = ACTIONS(2626),
    [anon_sym_mutable] = ACTIONS(2626),
    [anon_sym_constinit] = ACTIONS(2626),
    [anon_sym_consteval] = ACTIONS(2626),
    [anon_sym_alignas] = ACTIONS(2644),
    [anon_sym__Alignas] = ACTIONS(2644),
    [sym_primitive_type] = ACTIONS(2616),
    [anon_sym_enum] = ACTIONS(2616),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_struct] = ACTIONS(2616),
    [anon_sym_union] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_switch] = ACTIONS(2616),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_default] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [anon_sym_do] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_continue] = ACTIONS(2616),
    [anon_sym_goto] = ACTIONS(2616),
    [anon_sym___try] = ACTIONS(2616),
    [anon_sym___leave] = ACTIONS(2616),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_compl] = ACTIONS(2616),
    [anon_sym_DASH_DASH] = ACTIONS(2621),
    [anon_sym_PLUS_PLUS] = ACTIONS(2621),
    [anon_sym_sizeof] = ACTIONS(2616),
    [anon_sym___alignof__] = ACTIONS(2616),
    [anon_sym___alignof] = ACTIONS(2616),
    [anon_sym__alignof] = ACTIONS(2616),
    [anon_sym_alignof] = ACTIONS(2616),
    [anon_sym__Alignof] = ACTIONS(2616),
    [anon_sym_offsetof] = ACTIONS(2616),
    [anon_sym__Generic] = ACTIONS(2616),
    [anon_sym_asm] = ACTIONS(2616),
    [anon_sym___asm__] = ACTIONS(2616),
    [anon_sym___asm] = ACTIONS(2616),
    [anon_sym_DOT] = ACTIONS(2647),
    [sym_number_literal] = ACTIONS(2621),
    [anon_sym_L_SQUOTE] = ACTIONS(2621),
    [anon_sym_u_SQUOTE] = ACTIONS(2621),
    [anon_sym_U_SQUOTE] = ACTIONS(2621),
    [anon_sym_u8_SQUOTE] = ACTIONS(2621),
    [anon_sym_SQUOTE] = ACTIONS(2621),
    [anon_sym_L_DQUOTE] = ACTIONS(2621),
    [anon_sym_u_DQUOTE] = ACTIONS(2621),
    [anon_sym_U_DQUOTE] = ACTIONS(2621),
    [anon_sym_u8_DQUOTE] = ACTIONS(2621),
    [anon_sym_DQUOTE] = ACTIONS(2621),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [anon_sym_NULL] = ACTIONS(2616),
    [anon_sym_nullptr] = ACTIONS(2616),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2649),
    [anon_sym_let] = ACTIONS(2649),
    [anon_sym_This] = ACTIONS(2649),
    [anon_sym_decltype] = ACTIONS(2613),
    [anon_sym_explicit] = ACTIONS(2616),
    [anon_sym_typename] = ACTIONS(2616),
    [anon_sym_template] = ACTIONS(2613),
    [anon_sym_operator] = ACTIONS(2613),
    [anon_sym_try] = ACTIONS(2616),
    [anon_sym_delete] = ACTIONS(2616),
    [anon_sym_throw] = ACTIONS(2616),
    [anon_sym_namespace] = ACTIONS(2616),
    [anon_sym_static_assert] = ACTIONS(2616),
    [anon_sym_concept] = ACTIONS(2616),
    [anon_sym_co_return] = ACTIONS(2616),
    [anon_sym_co_yield] = ACTIONS(2616),
    [anon_sym_R_DQUOTE] = ACTIONS(2621),
    [anon_sym_LR_DQUOTE] = ACTIONS(2621),
    [anon_sym_uR_DQUOTE] = ACTIONS(2621),
    [anon_sym_UR_DQUOTE] = ACTIONS(2621),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2621),
    [anon_sym_co_await] = ACTIONS(2616),
    [anon_sym_new] = ACTIONS(2616),
    [anon_sym_requires] = ACTIONS(2616),
    [sym_this] = ACTIONS(2616),
    [anon_sym_discard] = ACTIONS(2616),
    [anon_sym_precise] = ACTIONS(2651),
    [anon_sym_shared] = ACTIONS(2651),
    [anon_sym_groupshared] = ACTIONS(2651),
    [anon_sym_uniform] = ACTIONS(2651),
    [anon_sym_row_major] = ACTIONS(2651),
    [anon_sym_column_major] = ACTIONS(2651),
    [anon_sym_globallycoherent] = ACTIONS(2651),
    [anon_sym_centroid] = ACTIONS(2651),
    [anon_sym_noperspective] = ACTIONS(2651),
    [anon_sym_nointerpolation] = ACTIONS(2651),
    [anon_sym_sample] = ACTIONS(2651),
    [anon_sym_linear] = ACTIONS(2651),
    [anon_sym_snorm] = ACTIONS(2651),
    [anon_sym_unorm] = ACTIONS(2651),
    [anon_sym_point] = ACTIONS(2651),
    [anon_sym_line] = ACTIONS(2651),
    [anon_sym_triangleadj] = ACTIONS(2651),
    [anon_sym_lineadj] = ACTIONS(2651),
    [anon_sym_triangle] = ACTIONS(2651),
    [anon_sym_cbuffer] = ACTIONS(2616),
    [anon_sym_interface] = ACTIONS(2616),
    [anon_sym_extension] = ACTIONS(2616),
  },
  [249] = {
    [sym_preproc_def] = STATE(249),
    [sym_preproc_function_def] = STATE(249),
    [sym_preproc_call] = STATE(249),
    [sym_preproc_if_in_field_declaration_list] = STATE(249),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(249),
    [sym_type_definition] = STATE(249),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7124),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7905),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(249),
    [sym_field_declaration] = STATE(249),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2677),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(249),
    [sym_operator_cast] = STATE(9116),
    [sym_inline_method_definition] = STATE(249),
    [sym__constructor_specifiers] = STATE(2677),
    [sym_operator_cast_definition] = STATE(249),
    [sym_operator_cast_declaration] = STATE(249),
    [sym_constructor_or_destructor_definition] = STATE(249),
    [sym_constructor_or_destructor_declaration] = STATE(249),
    [sym_friend_declaration] = STATE(249),
    [sym_access_specifier] = STATE(11693),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(249),
    [sym_alias_declaration] = STATE(249),
    [sym_static_assert_declaration] = STATE(249),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9116),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(249),
    [sym_subscript_declaration] = STATE(249),
    [sym_property_declaration] = STATE(249),
    [sym_associatedtype_declaration] = STATE(249),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(249),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9502),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2677),
    [sym_identifier] = ACTIONS(2654),
    [aux_sym_preproc_def_token1] = ACTIONS(2657),
    [aux_sym_preproc_if_token1] = ACTIONS(2660),
    [aux_sym_preproc_if_token2] = ACTIONS(2663),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2665),
    [aux_sym_preproc_else_token1] = ACTIONS(2663),
    [aux_sym_preproc_elif_token1] = ACTIONS(2663),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2663),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2663),
    [sym_preproc_directive] = ACTIONS(2668),
    [anon_sym_LPAREN2] = ACTIONS(2671),
    [anon_sym_TILDE] = ACTIONS(2674),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_AMP_AMP] = ACTIONS(2680),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_SEMI] = ACTIONS(2686),
    [anon_sym___extension__] = ACTIONS(2689),
    [anon_sym_typedef] = ACTIONS(2692),
    [anon_sym_in] = ACTIONS(2695),
    [anon_sym_out] = ACTIONS(2695),
    [anon_sym_inout] = ACTIONS(2695),
    [anon_sym_virtual] = ACTIONS(2695),
    [anon_sym_extern] = ACTIONS(2698),
    [anon_sym___attribute__] = ACTIONS(2701),
    [anon_sym___attribute] = ACTIONS(2701),
    [anon_sym_using] = ACTIONS(2704),
    [anon_sym_COLON_COLON] = ACTIONS(2707),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2710),
    [anon_sym___declspec] = ACTIONS(2713),
    [anon_sym___based] = ACTIONS(2716),
    [anon_sym_signed] = ACTIONS(2719),
    [anon_sym_unsigned] = ACTIONS(2719),
    [anon_sym_long] = ACTIONS(2719),
    [anon_sym_short] = ACTIONS(2719),
    [anon_sym_LBRACK] = ACTIONS(2722),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_register] = ACTIONS(2698),
    [anon_sym_inline] = ACTIONS(2698),
    [anon_sym___inline] = ACTIONS(2698),
    [anon_sym___inline__] = ACTIONS(2698),
    [anon_sym___forceinline] = ACTIONS(2698),
    [anon_sym_thread_local] = ACTIONS(2698),
    [anon_sym___thread] = ACTIONS(2698),
    [anon_sym_const] = ACTIONS(2725),
    [anon_sym_constexpr] = ACTIONS(2728),
    [anon_sym_volatile] = ACTIONS(2725),
    [anon_sym_restrict] = ACTIONS(2725),
    [anon_sym___restrict__] = ACTIONS(2725),
    [anon_sym__Atomic] = ACTIONS(2725),
    [anon_sym__Noreturn] = ACTIONS(2725),
    [anon_sym_noreturn] = ACTIONS(2725),
    [anon_sym__Nonnull] = ACTIONS(2725),
    [anon_sym_mutable] = ACTIONS(2725),
    [anon_sym_constinit] = ACTIONS(2725),
    [anon_sym_consteval] = ACTIONS(2725),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2734),
    [anon_sym_enum] = ACTIONS(2737),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2743),
    [anon_sym_union] = ACTIONS(2746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2749),
    [anon_sym_let] = ACTIONS(2749),
    [anon_sym_This] = ACTIONS(2749),
    [anon_sym_decltype] = ACTIONS(2752),
    [anon_sym_explicit] = ACTIONS(2755),
    [anon_sym_typename] = ACTIONS(2758),
    [anon_sym_private] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(2764),
    [anon_sym_operator] = ACTIONS(2767),
    [anon_sym_friend] = ACTIONS(2770),
    [anon_sym_public] = ACTIONS(2761),
    [anon_sym_protected] = ACTIONS(2761),
    [anon_sym_static_assert] = ACTIONS(2773),
    [anon_sym_precise] = ACTIONS(2776),
    [anon_sym_shared] = ACTIONS(2776),
    [anon_sym_groupshared] = ACTIONS(2776),
    [anon_sym_uniform] = ACTIONS(2776),
    [anon_sym_row_major] = ACTIONS(2776),
    [anon_sym_column_major] = ACTIONS(2776),
    [anon_sym_globallycoherent] = ACTIONS(2776),
    [anon_sym_centroid] = ACTIONS(2776),
    [anon_sym_noperspective] = ACTIONS(2776),
    [anon_sym_nointerpolation] = ACTIONS(2776),
    [anon_sym_sample] = ACTIONS(2776),
    [anon_sym_linear] = ACTIONS(2776),
    [anon_sym_snorm] = ACTIONS(2776),
    [anon_sym_unorm] = ACTIONS(2776),
    [anon_sym_point] = ACTIONS(2776),
    [anon_sym_line] = ACTIONS(2776),
    [anon_sym_triangleadj] = ACTIONS(2776),
    [anon_sym_lineadj] = ACTIONS(2776),
    [anon_sym_triangle] = ACTIONS(2776),
    [anon_sym_interface] = ACTIONS(2779),
    [anon_sym_extension] = ACTIONS(2782),
    [anon_sym___init] = ACTIONS(2785),
    [anon_sym___subscript] = ACTIONS(2788),
    [anon_sym_property] = ACTIONS(2791),
    [anon_sym_associatedtype] = ACTIONS(2794),
  },
  [250] = {
    [sym_template_argument_list] = STATE(264),
    [sym_identifier] = ACTIONS(2410),
    [aux_sym_preproc_include_token1] = ACTIONS(2410),
    [aux_sym_preproc_def_token1] = ACTIONS(2410),
    [aux_sym_preproc_if_token1] = ACTIONS(2410),
    [aux_sym_preproc_if_token2] = ACTIONS(2410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2410),
    [aux_sym_preproc_else_token1] = ACTIONS(2410),
    [aux_sym_preproc_elif_token1] = ACTIONS(2410),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2410),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2410),
    [sym_preproc_directive] = ACTIONS(2410),
    [anon_sym_LPAREN2] = ACTIONS(2408),
    [anon_sym_BANG] = ACTIONS(2408),
    [anon_sym_TILDE] = ACTIONS(2408),
    [anon_sym_DASH] = ACTIONS(2410),
    [anon_sym_PLUS] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(2408),
    [anon_sym_AMP_AMP] = ACTIONS(2408),
    [anon_sym_AMP] = ACTIONS(2410),
    [anon_sym_LT] = ACTIONS(2797),
    [anon_sym_COLON] = ACTIONS(2410),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym___extension__] = ACTIONS(2410),
    [anon_sym_typedef] = ACTIONS(2410),
    [anon_sym_in] = ACTIONS(2410),
    [anon_sym_out] = ACTIONS(2410),
    [anon_sym_inout] = ACTIONS(2410),
    [anon_sym_virtual] = ACTIONS(2410),
    [anon_sym_extern] = ACTIONS(2410),
    [anon_sym___attribute__] = ACTIONS(2410),
    [anon_sym___attribute] = ACTIONS(2410),
    [anon_sym_using] = ACTIONS(2410),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2408),
    [anon_sym___declspec] = ACTIONS(2410),
    [anon_sym___based] = ACTIONS(2410),
    [anon_sym___cdecl] = ACTIONS(2410),
    [anon_sym___clrcall] = ACTIONS(2410),
    [anon_sym___stdcall] = ACTIONS(2410),
    [anon_sym___fastcall] = ACTIONS(2410),
    [anon_sym___thiscall] = ACTIONS(2410),
    [anon_sym___vectorcall] = ACTIONS(2410),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_signed] = ACTIONS(2410),
    [anon_sym_unsigned] = ACTIONS(2410),
    [anon_sym_long] = ACTIONS(2410),
    [anon_sym_short] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_static] = ACTIONS(2410),
    [anon_sym_register] = ACTIONS(2410),
    [anon_sym_inline] = ACTIONS(2410),
    [anon_sym___inline] = ACTIONS(2410),
    [anon_sym___inline__] = ACTIONS(2410),
    [anon_sym___forceinline] = ACTIONS(2410),
    [anon_sym_thread_local] = ACTIONS(2410),
    [anon_sym___thread] = ACTIONS(2410),
    [anon_sym_const] = ACTIONS(2410),
    [anon_sym_constexpr] = ACTIONS(2410),
    [anon_sym_volatile] = ACTIONS(2410),
    [anon_sym_restrict] = ACTIONS(2410),
    [anon_sym___restrict__] = ACTIONS(2410),
    [anon_sym__Atomic] = ACTIONS(2410),
    [anon_sym__Noreturn] = ACTIONS(2410),
    [anon_sym_noreturn] = ACTIONS(2410),
    [anon_sym__Nonnull] = ACTIONS(2410),
    [anon_sym_mutable] = ACTIONS(2410),
    [anon_sym_constinit] = ACTIONS(2410),
    [anon_sym_consteval] = ACTIONS(2410),
    [anon_sym_alignas] = ACTIONS(2410),
    [anon_sym__Alignas] = ACTIONS(2410),
    [sym_primitive_type] = ACTIONS(2410),
    [anon_sym_enum] = ACTIONS(2410),
    [anon_sym_class] = ACTIONS(2410),
    [anon_sym_struct] = ACTIONS(2410),
    [anon_sym_union] = ACTIONS(2410),
    [anon_sym_if] = ACTIONS(2410),
    [anon_sym_else] = ACTIONS(2410),
    [anon_sym_switch] = ACTIONS(2410),
    [anon_sym_case] = ACTIONS(2410),
    [anon_sym_default] = ACTIONS(2410),
    [anon_sym_while] = ACTIONS(2410),
    [anon_sym_do] = ACTIONS(2410),
    [anon_sym_for] = ACTIONS(2410),
    [anon_sym_return] = ACTIONS(2410),
    [anon_sym_break] = ACTIONS(2410),
    [anon_sym_continue] = ACTIONS(2410),
    [anon_sym_goto] = ACTIONS(2410),
    [anon_sym___try] = ACTIONS(2410),
    [anon_sym___leave] = ACTIONS(2410),
    [anon_sym_not] = ACTIONS(2410),
    [anon_sym_compl] = ACTIONS(2410),
    [anon_sym_DASH_DASH] = ACTIONS(2408),
    [anon_sym_PLUS_PLUS] = ACTIONS(2408),
    [anon_sym_sizeof] = ACTIONS(2410),
    [anon_sym___alignof__] = ACTIONS(2410),
    [anon_sym___alignof] = ACTIONS(2410),
    [anon_sym__alignof] = ACTIONS(2410),
    [anon_sym_alignof] = ACTIONS(2410),
    [anon_sym__Alignof] = ACTIONS(2410),
    [anon_sym_offsetof] = ACTIONS(2410),
    [anon_sym__Generic] = ACTIONS(2410),
    [anon_sym_asm] = ACTIONS(2410),
    [anon_sym___asm__] = ACTIONS(2410),
    [anon_sym___asm] = ACTIONS(2410),
    [sym_number_literal] = ACTIONS(2408),
    [anon_sym_L_SQUOTE] = ACTIONS(2408),
    [anon_sym_u_SQUOTE] = ACTIONS(2408),
    [anon_sym_U_SQUOTE] = ACTIONS(2408),
    [anon_sym_u8_SQUOTE] = ACTIONS(2408),
    [anon_sym_SQUOTE] = ACTIONS(2408),
    [anon_sym_L_DQUOTE] = ACTIONS(2408),
    [anon_sym_u_DQUOTE] = ACTIONS(2408),
    [anon_sym_U_DQUOTE] = ACTIONS(2408),
    [anon_sym_u8_DQUOTE] = ACTIONS(2408),
    [anon_sym_DQUOTE] = ACTIONS(2408),
    [sym_true] = ACTIONS(2410),
    [sym_false] = ACTIONS(2410),
    [anon_sym_NULL] = ACTIONS(2410),
    [anon_sym_nullptr] = ACTIONS(2410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2410),
    [anon_sym_let] = ACTIONS(2410),
    [anon_sym_This] = ACTIONS(2410),
    [anon_sym_decltype] = ACTIONS(2410),
    [anon_sym_final] = ACTIONS(2410),
    [anon_sym_override] = ACTIONS(2410),
    [anon_sym_explicit] = ACTIONS(2410),
    [anon_sym_typename] = ACTIONS(2410),
    [anon_sym_template] = ACTIONS(2410),
    [anon_sym_operator] = ACTIONS(2410),
    [anon_sym_try] = ACTIONS(2410),
    [anon_sym_delete] = ACTIONS(2410),
    [anon_sym_throw] = ACTIONS(2410),
    [anon_sym_namespace] = ACTIONS(2410),
    [anon_sym_static_assert] = ACTIONS(2410),
    [anon_sym_concept] = ACTIONS(2410),
    [anon_sym_co_return] = ACTIONS(2410),
    [anon_sym_co_yield] = ACTIONS(2410),
    [anon_sym_R_DQUOTE] = ACTIONS(2408),
    [anon_sym_LR_DQUOTE] = ACTIONS(2408),
    [anon_sym_uR_DQUOTE] = ACTIONS(2408),
    [anon_sym_UR_DQUOTE] = ACTIONS(2408),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2408),
    [anon_sym_co_await] = ACTIONS(2410),
    [anon_sym_new] = ACTIONS(2410),
    [anon_sym_requires] = ACTIONS(2410),
    [sym_this] = ACTIONS(2410),
    [anon_sym_discard] = ACTIONS(2410),
    [anon_sym_precise] = ACTIONS(2410),
    [anon_sym_shared] = ACTIONS(2410),
    [anon_sym_groupshared] = ACTIONS(2410),
    [anon_sym_uniform] = ACTIONS(2410),
    [anon_sym_row_major] = ACTIONS(2410),
    [anon_sym_column_major] = ACTIONS(2410),
    [anon_sym_globallycoherent] = ACTIONS(2410),
    [anon_sym_centroid] = ACTIONS(2410),
    [anon_sym_noperspective] = ACTIONS(2410),
    [anon_sym_nointerpolation] = ACTIONS(2410),
    [anon_sym_sample] = ACTIONS(2410),
    [anon_sym_linear] = ACTIONS(2410),
    [anon_sym_snorm] = ACTIONS(2410),
    [anon_sym_unorm] = ACTIONS(2410),
    [anon_sym_point] = ACTIONS(2410),
    [anon_sym_line] = ACTIONS(2410),
    [anon_sym_triangleadj] = ACTIONS(2410),
    [anon_sym_lineadj] = ACTIONS(2410),
    [anon_sym_triangle] = ACTIONS(2410),
    [anon_sym_cbuffer] = ACTIONS(2410),
    [anon_sym_interface] = ACTIONS(2410),
    [anon_sym_extension] = ACTIONS(2410),
  },
  [251] = {
    [sym_template_argument_list] = STATE(264),
    [sym_identifier] = ACTIONS(2222),
    [aux_sym_preproc_include_token1] = ACTIONS(2222),
    [aux_sym_preproc_def_token1] = ACTIONS(2222),
    [aux_sym_preproc_if_token1] = ACTIONS(2222),
    [aux_sym_preproc_if_token2] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2222),
    [aux_sym_preproc_else_token1] = ACTIONS(2222),
    [aux_sym_preproc_elif_token1] = ACTIONS(2222),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2222),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2222),
    [sym_preproc_directive] = ACTIONS(2222),
    [anon_sym_LPAREN2] = ACTIONS(2229),
    [anon_sym_BANG] = ACTIONS(2229),
    [anon_sym_TILDE] = ACTIONS(2229),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2229),
    [anon_sym_AMP_AMP] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2797),
    [anon_sym_COLON] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(2229),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_typedef] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_virtual] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym___attribute] = ACTIONS(2222),
    [anon_sym_using] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2229),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym___based] = ACTIONS(2222),
    [anon_sym___cdecl] = ACTIONS(2222),
    [anon_sym___clrcall] = ACTIONS(2222),
    [anon_sym___stdcall] = ACTIONS(2222),
    [anon_sym___fastcall] = ACTIONS(2222),
    [anon_sym___thiscall] = ACTIONS(2222),
    [anon_sym___vectorcall] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_signed] = ACTIONS(2222),
    [anon_sym_unsigned] = ACTIONS(2222),
    [anon_sym_long] = ACTIONS(2222),
    [anon_sym_short] = ACTIONS(2222),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym__Nonnull] = ACTIONS(2222),
    [anon_sym_mutable] = ACTIONS(2222),
    [anon_sym_constinit] = ACTIONS(2222),
    [anon_sym_consteval] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [sym_primitive_type] = ACTIONS(2222),
    [anon_sym_enum] = ACTIONS(2222),
    [anon_sym_class] = ACTIONS(2222),
    [anon_sym_struct] = ACTIONS(2222),
    [anon_sym_union] = ACTIONS(2222),
    [anon_sym_if] = ACTIONS(2222),
    [anon_sym_else] = ACTIONS(2222),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2222),
    [anon_sym_default] = ACTIONS(2222),
    [anon_sym_while] = ACTIONS(2222),
    [anon_sym_do] = ACTIONS(2222),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_return] = ACTIONS(2222),
    [anon_sym_break] = ACTIONS(2222),
    [anon_sym_continue] = ACTIONS(2222),
    [anon_sym_goto] = ACTIONS(2222),
    [anon_sym___try] = ACTIONS(2222),
    [anon_sym___leave] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_compl] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2229),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(2222),
    [anon_sym___alignof] = ACTIONS(2222),
    [anon_sym__alignof] = ACTIONS(2222),
    [anon_sym_alignof] = ACTIONS(2222),
    [anon_sym__Alignof] = ACTIONS(2222),
    [anon_sym_offsetof] = ACTIONS(2222),
    [anon_sym__Generic] = ACTIONS(2222),
    [anon_sym_asm] = ACTIONS(2222),
    [anon_sym___asm__] = ACTIONS(2222),
    [anon_sym___asm] = ACTIONS(2222),
    [sym_number_literal] = ACTIONS(2229),
    [anon_sym_L_SQUOTE] = ACTIONS(2229),
    [anon_sym_u_SQUOTE] = ACTIONS(2229),
    [anon_sym_U_SQUOTE] = ACTIONS(2229),
    [anon_sym_u8_SQUOTE] = ACTIONS(2229),
    [anon_sym_SQUOTE] = ACTIONS(2229),
    [anon_sym_L_DQUOTE] = ACTIONS(2229),
    [anon_sym_u_DQUOTE] = ACTIONS(2229),
    [anon_sym_U_DQUOTE] = ACTIONS(2229),
    [anon_sym_u8_DQUOTE] = ACTIONS(2229),
    [anon_sym_DQUOTE] = ACTIONS(2229),
    [sym_true] = ACTIONS(2222),
    [sym_false] = ACTIONS(2222),
    [anon_sym_NULL] = ACTIONS(2222),
    [anon_sym_nullptr] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2222),
    [anon_sym_let] = ACTIONS(2222),
    [anon_sym_This] = ACTIONS(2222),
    [anon_sym_decltype] = ACTIONS(2222),
    [anon_sym_final] = ACTIONS(2222),
    [anon_sym_override] = ACTIONS(2222),
    [anon_sym_explicit] = ACTIONS(2222),
    [anon_sym_typename] = ACTIONS(2222),
    [anon_sym_template] = ACTIONS(2222),
    [anon_sym_operator] = ACTIONS(2222),
    [anon_sym_try] = ACTIONS(2222),
    [anon_sym_delete] = ACTIONS(2222),
    [anon_sym_throw] = ACTIONS(2222),
    [anon_sym_namespace] = ACTIONS(2222),
    [anon_sym_static_assert] = ACTIONS(2222),
    [anon_sym_concept] = ACTIONS(2222),
    [anon_sym_co_return] = ACTIONS(2222),
    [anon_sym_co_yield] = ACTIONS(2222),
    [anon_sym_R_DQUOTE] = ACTIONS(2229),
    [anon_sym_LR_DQUOTE] = ACTIONS(2229),
    [anon_sym_uR_DQUOTE] = ACTIONS(2229),
    [anon_sym_UR_DQUOTE] = ACTIONS(2229),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2229),
    [anon_sym_co_await] = ACTIONS(2222),
    [anon_sym_new] = ACTIONS(2222),
    [anon_sym_requires] = ACTIONS(2222),
    [sym_this] = ACTIONS(2222),
    [anon_sym_discard] = ACTIONS(2222),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_groupshared] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_row_major] = ACTIONS(2222),
    [anon_sym_column_major] = ACTIONS(2222),
    [anon_sym_globallycoherent] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym_nointerpolation] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_linear] = ACTIONS(2222),
    [anon_sym_snorm] = ACTIONS(2222),
    [anon_sym_unorm] = ACTIONS(2222),
    [anon_sym_point] = ACTIONS(2222),
    [anon_sym_line] = ACTIONS(2222),
    [anon_sym_triangleadj] = ACTIONS(2222),
    [anon_sym_lineadj] = ACTIONS(2222),
    [anon_sym_triangle] = ACTIONS(2222),
    [anon_sym_cbuffer] = ACTIONS(2222),
    [anon_sym_interface] = ACTIONS(2222),
    [anon_sym_extension] = ACTIONS(2222),
  },
  [252] = {
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(6816),
    [sym__declarator] = STATE(8849),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8054),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(11152),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3789),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11152),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(11566),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4356),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(11567),
    [sym__unary_right_fold] = STATE(11568),
    [sym__binary_fold] = STATE(11569),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7290),
    [sym_qualified_identifier] = STATE(4377),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(10925),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2811),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(2817),
    [anon_sym___clrcall] = ACTIONS(2817),
    [anon_sym___stdcall] = ACTIONS(2817),
    [anon_sym___fastcall] = ACTIONS(2817),
    [anon_sym___thiscall] = ACTIONS(2817),
    [anon_sym___vectorcall] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2821),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(2861),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [253] = {
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(6816),
    [sym__declarator] = STATE(8849),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8054),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(11152),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3789),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11152),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(10809),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4356),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(10862),
    [sym__unary_right_fold] = STATE(10885),
    [sym__binary_fold] = STATE(10914),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7290),
    [sym_qualified_identifier] = STATE(4377),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(10925),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2811),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(2817),
    [anon_sym___clrcall] = ACTIONS(2817),
    [anon_sym___stdcall] = ACTIONS(2817),
    [anon_sym___fastcall] = ACTIONS(2817),
    [anon_sym___thiscall] = ACTIONS(2817),
    [anon_sym___vectorcall] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2821),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(2861),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [254] = {
    [ts_builtin_sym_end] = ACTIONS(2877),
    [sym_identifier] = ACTIONS(2879),
    [aux_sym_preproc_include_token1] = ACTIONS(2879),
    [aux_sym_preproc_def_token1] = ACTIONS(2879),
    [anon_sym_COMMA] = ACTIONS(2877),
    [anon_sym_RPAREN] = ACTIONS(2877),
    [aux_sym_preproc_if_token1] = ACTIONS(2879),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2879),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2879),
    [sym_preproc_directive] = ACTIONS(2879),
    [anon_sym_LPAREN2] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2879),
    [anon_sym_PLUS] = ACTIONS(2879),
    [anon_sym_STAR] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_AMP] = ACTIONS(2879),
    [anon_sym_COLON] = ACTIONS(2879),
    [anon_sym_SEMI] = ACTIONS(2877),
    [anon_sym___extension__] = ACTIONS(2879),
    [anon_sym_typedef] = ACTIONS(2879),
    [anon_sym_in] = ACTIONS(2879),
    [anon_sym_out] = ACTIONS(2879),
    [anon_sym_inout] = ACTIONS(2879),
    [anon_sym_virtual] = ACTIONS(2879),
    [anon_sym_extern] = ACTIONS(2879),
    [anon_sym___attribute__] = ACTIONS(2879),
    [anon_sym___attribute] = ACTIONS(2879),
    [anon_sym_using] = ACTIONS(2879),
    [anon_sym_COLON_COLON] = ACTIONS(2877),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2877),
    [anon_sym___declspec] = ACTIONS(2879),
    [anon_sym___based] = ACTIONS(2879),
    [anon_sym___cdecl] = ACTIONS(2879),
    [anon_sym___clrcall] = ACTIONS(2879),
    [anon_sym___stdcall] = ACTIONS(2879),
    [anon_sym___fastcall] = ACTIONS(2879),
    [anon_sym___thiscall] = ACTIONS(2879),
    [anon_sym___vectorcall] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_signed] = ACTIONS(2879),
    [anon_sym_unsigned] = ACTIONS(2879),
    [anon_sym_long] = ACTIONS(2879),
    [anon_sym_short] = ACTIONS(2879),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_static] = ACTIONS(2879),
    [anon_sym_EQ] = ACTIONS(2877),
    [anon_sym_register] = ACTIONS(2879),
    [anon_sym_inline] = ACTIONS(2879),
    [anon_sym___inline] = ACTIONS(2879),
    [anon_sym___inline__] = ACTIONS(2879),
    [anon_sym___forceinline] = ACTIONS(2879),
    [anon_sym_thread_local] = ACTIONS(2879),
    [anon_sym___thread] = ACTIONS(2879),
    [anon_sym_const] = ACTIONS(2879),
    [anon_sym_constexpr] = ACTIONS(2879),
    [anon_sym_volatile] = ACTIONS(2879),
    [anon_sym_restrict] = ACTIONS(2879),
    [anon_sym___restrict__] = ACTIONS(2879),
    [anon_sym__Atomic] = ACTIONS(2879),
    [anon_sym__Noreturn] = ACTIONS(2879),
    [anon_sym_noreturn] = ACTIONS(2879),
    [anon_sym__Nonnull] = ACTIONS(2879),
    [anon_sym_mutable] = ACTIONS(2879),
    [anon_sym_constinit] = ACTIONS(2879),
    [anon_sym_consteval] = ACTIONS(2879),
    [anon_sym_alignas] = ACTIONS(2879),
    [anon_sym__Alignas] = ACTIONS(2879),
    [sym_primitive_type] = ACTIONS(2879),
    [anon_sym_enum] = ACTIONS(2879),
    [anon_sym_class] = ACTIONS(2879),
    [anon_sym_struct] = ACTIONS(2879),
    [anon_sym_union] = ACTIONS(2879),
    [anon_sym_if] = ACTIONS(2879),
    [anon_sym_switch] = ACTIONS(2879),
    [anon_sym_case] = ACTIONS(2879),
    [anon_sym_default] = ACTIONS(2879),
    [anon_sym_while] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2879),
    [anon_sym_for] = ACTIONS(2879),
    [anon_sym_return] = ACTIONS(2879),
    [anon_sym_break] = ACTIONS(2879),
    [anon_sym_continue] = ACTIONS(2879),
    [anon_sym_goto] = ACTIONS(2879),
    [anon_sym_not] = ACTIONS(2879),
    [anon_sym_compl] = ACTIONS(2879),
    [anon_sym_DASH_DASH] = ACTIONS(2877),
    [anon_sym_PLUS_PLUS] = ACTIONS(2877),
    [anon_sym_sizeof] = ACTIONS(2879),
    [anon_sym___alignof__] = ACTIONS(2879),
    [anon_sym___alignof] = ACTIONS(2879),
    [anon_sym__alignof] = ACTIONS(2879),
    [anon_sym_alignof] = ACTIONS(2879),
    [anon_sym__Alignof] = ACTIONS(2879),
    [anon_sym_offsetof] = ACTIONS(2879),
    [anon_sym__Generic] = ACTIONS(2879),
    [anon_sym_asm] = ACTIONS(2879),
    [anon_sym___asm__] = ACTIONS(2879),
    [anon_sym___asm] = ACTIONS(2879),
    [anon_sym_DOT] = ACTIONS(2879),
    [sym_number_literal] = ACTIONS(2877),
    [anon_sym_L_SQUOTE] = ACTIONS(2877),
    [anon_sym_u_SQUOTE] = ACTIONS(2877),
    [anon_sym_U_SQUOTE] = ACTIONS(2877),
    [anon_sym_u8_SQUOTE] = ACTIONS(2877),
    [anon_sym_SQUOTE] = ACTIONS(2877),
    [anon_sym_L_DQUOTE] = ACTIONS(2877),
    [anon_sym_u_DQUOTE] = ACTIONS(2877),
    [anon_sym_U_DQUOTE] = ACTIONS(2877),
    [anon_sym_u8_DQUOTE] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [sym_true] = ACTIONS(2879),
    [sym_false] = ACTIONS(2879),
    [anon_sym_NULL] = ACTIONS(2879),
    [anon_sym_nullptr] = ACTIONS(2879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2879),
    [anon_sym_let] = ACTIONS(2879),
    [anon_sym_This] = ACTIONS(2879),
    [anon_sym_decltype] = ACTIONS(2879),
    [anon_sym_final] = ACTIONS(2879),
    [anon_sym_override] = ACTIONS(2879),
    [anon_sym_explicit] = ACTIONS(2879),
    [anon_sym_typename] = ACTIONS(2879),
    [anon_sym_export] = ACTIONS(2879),
    [anon_sym_module] = ACTIONS(2879),
    [anon_sym_import] = ACTIONS(2879),
    [anon_sym_template] = ACTIONS(2879),
    [anon_sym_GT2] = ACTIONS(2877),
    [anon_sym_operator] = ACTIONS(2879),
    [anon_sym_try] = ACTIONS(2879),
    [anon_sym_delete] = ACTIONS(2879),
    [anon_sym_throw] = ACTIONS(2879),
    [anon_sym_namespace] = ACTIONS(2879),
    [anon_sym_static_assert] = ACTIONS(2879),
    [anon_sym_concept] = ACTIONS(2879),
    [anon_sym_co_return] = ACTIONS(2879),
    [anon_sym_co_yield] = ACTIONS(2879),
    [anon_sym_R_DQUOTE] = ACTIONS(2877),
    [anon_sym_LR_DQUOTE] = ACTIONS(2877),
    [anon_sym_uR_DQUOTE] = ACTIONS(2877),
    [anon_sym_UR_DQUOTE] = ACTIONS(2877),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2877),
    [anon_sym_co_await] = ACTIONS(2879),
    [anon_sym_new] = ACTIONS(2879),
    [anon_sym_requires] = ACTIONS(2879),
    [sym_this] = ACTIONS(2879),
    [anon_sym_precise] = ACTIONS(2879),
    [anon_sym_shared] = ACTIONS(2879),
    [anon_sym_groupshared] = ACTIONS(2879),
    [anon_sym_uniform] = ACTIONS(2879),
    [anon_sym_row_major] = ACTIONS(2879),
    [anon_sym_column_major] = ACTIONS(2879),
    [anon_sym_globallycoherent] = ACTIONS(2879),
    [anon_sym_centroid] = ACTIONS(2879),
    [anon_sym_noperspective] = ACTIONS(2879),
    [anon_sym_nointerpolation] = ACTIONS(2879),
    [anon_sym_sample] = ACTIONS(2879),
    [anon_sym_linear] = ACTIONS(2879),
    [anon_sym_snorm] = ACTIONS(2879),
    [anon_sym_unorm] = ACTIONS(2879),
    [anon_sym_point] = ACTIONS(2879),
    [anon_sym_line] = ACTIONS(2879),
    [anon_sym_triangleadj] = ACTIONS(2879),
    [anon_sym_lineadj] = ACTIONS(2879),
    [anon_sym_triangle] = ACTIONS(2879),
    [anon_sym_interface] = ACTIONS(2879),
    [anon_sym_extension] = ACTIONS(2879),
    [anon_sym_where] = ACTIONS(2879),
    [anon_sym___exported] = ACTIONS(2879),
  },
  [255] = {
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(6816),
    [sym__declarator] = STATE(8849),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8054),
    [sym_array_declarator] = STATE(8054),
    [sym_compound_statement] = STATE(11505),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3721),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11505),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(11515),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4356),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(11529),
    [sym__unary_right_fold] = STATE(11538),
    [sym__binary_fold] = STATE(11549),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7290),
    [sym_qualified_identifier] = STATE(4377),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(11555),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2811),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(2817),
    [anon_sym___clrcall] = ACTIONS(2817),
    [anon_sym___stdcall] = ACTIONS(2817),
    [anon_sym___fastcall] = ACTIONS(2817),
    [anon_sym___thiscall] = ACTIONS(2817),
    [anon_sym___vectorcall] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2821),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(2861),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [256] = {
    [ts_builtin_sym_end] = ACTIONS(2881),
    [sym_identifier] = ACTIONS(2883),
    [aux_sym_preproc_include_token1] = ACTIONS(2883),
    [aux_sym_preproc_def_token1] = ACTIONS(2883),
    [anon_sym_COMMA] = ACTIONS(2881),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [aux_sym_preproc_if_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2883),
    [sym_preproc_directive] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_typedef] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_using] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_signed] = ACTIONS(2883),
    [anon_sym_unsigned] = ACTIONS(2883),
    [anon_sym_long] = ACTIONS(2883),
    [anon_sym_short] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2881),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [sym_primitive_type] = ACTIONS(2883),
    [anon_sym_enum] = ACTIONS(2883),
    [anon_sym_class] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2883),
    [anon_sym_union] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_switch] = ACTIONS(2883),
    [anon_sym_case] = ACTIONS(2883),
    [anon_sym_default] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_break] = ACTIONS(2883),
    [anon_sym_continue] = ACTIONS(2883),
    [anon_sym_goto] = ACTIONS(2883),
    [anon_sym_not] = ACTIONS(2883),
    [anon_sym_compl] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_sizeof] = ACTIONS(2883),
    [anon_sym___alignof__] = ACTIONS(2883),
    [anon_sym___alignof] = ACTIONS(2883),
    [anon_sym__alignof] = ACTIONS(2883),
    [anon_sym_alignof] = ACTIONS(2883),
    [anon_sym__Alignof] = ACTIONS(2883),
    [anon_sym_offsetof] = ACTIONS(2883),
    [anon_sym__Generic] = ACTIONS(2883),
    [anon_sym_asm] = ACTIONS(2883),
    [anon_sym___asm__] = ACTIONS(2883),
    [anon_sym___asm] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [sym_number_literal] = ACTIONS(2881),
    [anon_sym_L_SQUOTE] = ACTIONS(2881),
    [anon_sym_u_SQUOTE] = ACTIONS(2881),
    [anon_sym_U_SQUOTE] = ACTIONS(2881),
    [anon_sym_u8_SQUOTE] = ACTIONS(2881),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_L_DQUOTE] = ACTIONS(2881),
    [anon_sym_u_DQUOTE] = ACTIONS(2881),
    [anon_sym_U_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [sym_true] = ACTIONS(2883),
    [sym_false] = ACTIONS(2883),
    [anon_sym_NULL] = ACTIONS(2883),
    [anon_sym_nullptr] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_final] = ACTIONS(2883),
    [anon_sym_override] = ACTIONS(2883),
    [anon_sym_explicit] = ACTIONS(2883),
    [anon_sym_typename] = ACTIONS(2883),
    [anon_sym_export] = ACTIONS(2883),
    [anon_sym_module] = ACTIONS(2883),
    [anon_sym_import] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_GT2] = ACTIONS(2881),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_delete] = ACTIONS(2883),
    [anon_sym_throw] = ACTIONS(2883),
    [anon_sym_namespace] = ACTIONS(2883),
    [anon_sym_static_assert] = ACTIONS(2883),
    [anon_sym_concept] = ACTIONS(2883),
    [anon_sym_co_return] = ACTIONS(2883),
    [anon_sym_co_yield] = ACTIONS(2883),
    [anon_sym_R_DQUOTE] = ACTIONS(2881),
    [anon_sym_LR_DQUOTE] = ACTIONS(2881),
    [anon_sym_uR_DQUOTE] = ACTIONS(2881),
    [anon_sym_UR_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2881),
    [anon_sym_co_await] = ACTIONS(2883),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_requires] = ACTIONS(2883),
    [sym_this] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
    [anon_sym_interface] = ACTIONS(2883),
    [anon_sym_extension] = ACTIONS(2883),
    [anon_sym_where] = ACTIONS(2883),
    [anon_sym___exported] = ACTIONS(2883),
  },
  [257] = {
    [sym_catch_clause] = STATE(262),
    [aux_sym_constructor_try_statement_repeat1] = STATE(262),
    [sym_identifier] = ACTIONS(2885),
    [aux_sym_preproc_include_token1] = ACTIONS(2885),
    [aux_sym_preproc_def_token1] = ACTIONS(2885),
    [aux_sym_preproc_if_token1] = ACTIONS(2885),
    [aux_sym_preproc_if_token2] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2885),
    [aux_sym_preproc_else_token1] = ACTIONS(2885),
    [aux_sym_preproc_elif_token1] = ACTIONS(2885),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2885),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2885),
    [sym_preproc_directive] = ACTIONS(2885),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_BANG] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2887),
    [anon_sym_DASH] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym___extension__] = ACTIONS(2885),
    [anon_sym_typedef] = ACTIONS(2885),
    [anon_sym_in] = ACTIONS(2885),
    [anon_sym_out] = ACTIONS(2885),
    [anon_sym_inout] = ACTIONS(2885),
    [anon_sym_virtual] = ACTIONS(2885),
    [anon_sym_extern] = ACTIONS(2885),
    [anon_sym___attribute__] = ACTIONS(2885),
    [anon_sym___attribute] = ACTIONS(2885),
    [anon_sym_using] = ACTIONS(2885),
    [anon_sym_COLON_COLON] = ACTIONS(2887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2887),
    [anon_sym___declspec] = ACTIONS(2885),
    [anon_sym___based] = ACTIONS(2885),
    [anon_sym___cdecl] = ACTIONS(2885),
    [anon_sym___clrcall] = ACTIONS(2885),
    [anon_sym___stdcall] = ACTIONS(2885),
    [anon_sym___fastcall] = ACTIONS(2885),
    [anon_sym___thiscall] = ACTIONS(2885),
    [anon_sym___vectorcall] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_signed] = ACTIONS(2885),
    [anon_sym_unsigned] = ACTIONS(2885),
    [anon_sym_long] = ACTIONS(2885),
    [anon_sym_short] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_static] = ACTIONS(2885),
    [anon_sym_register] = ACTIONS(2885),
    [anon_sym_inline] = ACTIONS(2885),
    [anon_sym___inline] = ACTIONS(2885),
    [anon_sym___inline__] = ACTIONS(2885),
    [anon_sym___forceinline] = ACTIONS(2885),
    [anon_sym_thread_local] = ACTIONS(2885),
    [anon_sym___thread] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_constexpr] = ACTIONS(2885),
    [anon_sym_volatile] = ACTIONS(2885),
    [anon_sym_restrict] = ACTIONS(2885),
    [anon_sym___restrict__] = ACTIONS(2885),
    [anon_sym__Atomic] = ACTIONS(2885),
    [anon_sym__Noreturn] = ACTIONS(2885),
    [anon_sym_noreturn] = ACTIONS(2885),
    [anon_sym__Nonnull] = ACTIONS(2885),
    [anon_sym_mutable] = ACTIONS(2885),
    [anon_sym_constinit] = ACTIONS(2885),
    [anon_sym_consteval] = ACTIONS(2885),
    [anon_sym_alignas] = ACTIONS(2885),
    [anon_sym__Alignas] = ACTIONS(2885),
    [sym_primitive_type] = ACTIONS(2885),
    [anon_sym_enum] = ACTIONS(2885),
    [anon_sym_class] = ACTIONS(2885),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_union] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_else] = ACTIONS(2885),
    [anon_sym_switch] = ACTIONS(2885),
    [anon_sym_case] = ACTIONS(2885),
    [anon_sym_default] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [anon_sym_do] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_break] = ACTIONS(2885),
    [anon_sym_continue] = ACTIONS(2885),
    [anon_sym_goto] = ACTIONS(2885),
    [anon_sym___try] = ACTIONS(2885),
    [anon_sym___leave] = ACTIONS(2885),
    [anon_sym_not] = ACTIONS(2885),
    [anon_sym_compl] = ACTIONS(2885),
    [anon_sym_DASH_DASH] = ACTIONS(2887),
    [anon_sym_PLUS_PLUS] = ACTIONS(2887),
    [anon_sym_sizeof] = ACTIONS(2885),
    [anon_sym___alignof__] = ACTIONS(2885),
    [anon_sym___alignof] = ACTIONS(2885),
    [anon_sym__alignof] = ACTIONS(2885),
    [anon_sym_alignof] = ACTIONS(2885),
    [anon_sym__Alignof] = ACTIONS(2885),
    [anon_sym_offsetof] = ACTIONS(2885),
    [anon_sym__Generic] = ACTIONS(2885),
    [anon_sym_asm] = ACTIONS(2885),
    [anon_sym___asm__] = ACTIONS(2885),
    [anon_sym___asm] = ACTIONS(2885),
    [sym_number_literal] = ACTIONS(2887),
    [anon_sym_L_SQUOTE] = ACTIONS(2887),
    [anon_sym_u_SQUOTE] = ACTIONS(2887),
    [anon_sym_U_SQUOTE] = ACTIONS(2887),
    [anon_sym_u8_SQUOTE] = ACTIONS(2887),
    [anon_sym_SQUOTE] = ACTIONS(2887),
    [anon_sym_L_DQUOTE] = ACTIONS(2887),
    [anon_sym_u_DQUOTE] = ACTIONS(2887),
    [anon_sym_U_DQUOTE] = ACTIONS(2887),
    [anon_sym_u8_DQUOTE] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [sym_true] = ACTIONS(2885),
    [sym_false] = ACTIONS(2885),
    [anon_sym_NULL] = ACTIONS(2885),
    [anon_sym_nullptr] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2885),
    [anon_sym_let] = ACTIONS(2885),
    [anon_sym_This] = ACTIONS(2885),
    [anon_sym_decltype] = ACTIONS(2885),
    [anon_sym_explicit] = ACTIONS(2885),
    [anon_sym_typename] = ACTIONS(2885),
    [anon_sym_template] = ACTIONS(2885),
    [anon_sym_operator] = ACTIONS(2885),
    [anon_sym_try] = ACTIONS(2885),
    [anon_sym_delete] = ACTIONS(2885),
    [anon_sym_throw] = ACTIONS(2885),
    [anon_sym_namespace] = ACTIONS(2885),
    [anon_sym_static_assert] = ACTIONS(2885),
    [anon_sym_concept] = ACTIONS(2885),
    [anon_sym_co_return] = ACTIONS(2885),
    [anon_sym_co_yield] = ACTIONS(2885),
    [anon_sym_catch] = ACTIONS(2889),
    [anon_sym_R_DQUOTE] = ACTIONS(2887),
    [anon_sym_LR_DQUOTE] = ACTIONS(2887),
    [anon_sym_uR_DQUOTE] = ACTIONS(2887),
    [anon_sym_UR_DQUOTE] = ACTIONS(2887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2887),
    [anon_sym_co_await] = ACTIONS(2885),
    [anon_sym_new] = ACTIONS(2885),
    [anon_sym_requires] = ACTIONS(2885),
    [sym_this] = ACTIONS(2885),
    [anon_sym_discard] = ACTIONS(2885),
    [anon_sym_precise] = ACTIONS(2885),
    [anon_sym_shared] = ACTIONS(2885),
    [anon_sym_groupshared] = ACTIONS(2885),
    [anon_sym_uniform] = ACTIONS(2885),
    [anon_sym_row_major] = ACTIONS(2885),
    [anon_sym_column_major] = ACTIONS(2885),
    [anon_sym_globallycoherent] = ACTIONS(2885),
    [anon_sym_centroid] = ACTIONS(2885),
    [anon_sym_noperspective] = ACTIONS(2885),
    [anon_sym_nointerpolation] = ACTIONS(2885),
    [anon_sym_sample] = ACTIONS(2885),
    [anon_sym_linear] = ACTIONS(2885),
    [anon_sym_snorm] = ACTIONS(2885),
    [anon_sym_unorm] = ACTIONS(2885),
    [anon_sym_point] = ACTIONS(2885),
    [anon_sym_line] = ACTIONS(2885),
    [anon_sym_triangleadj] = ACTIONS(2885),
    [anon_sym_lineadj] = ACTIONS(2885),
    [anon_sym_triangle] = ACTIONS(2885),
    [anon_sym_cbuffer] = ACTIONS(2885),
    [anon_sym_interface] = ACTIONS(2885),
    [anon_sym_extension] = ACTIONS(2885),
  },
  [258] = {
    [sym_catch_clause] = STATE(267),
    [aux_sym_constructor_try_statement_repeat1] = STATE(267),
    [ts_builtin_sym_end] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2885),
    [aux_sym_preproc_include_token1] = ACTIONS(2885),
    [aux_sym_preproc_def_token1] = ACTIONS(2885),
    [aux_sym_preproc_if_token1] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2885),
    [sym_preproc_directive] = ACTIONS(2885),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_BANG] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2887),
    [anon_sym_DASH] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym___extension__] = ACTIONS(2885),
    [anon_sym_typedef] = ACTIONS(2885),
    [anon_sym_in] = ACTIONS(2885),
    [anon_sym_out] = ACTIONS(2885),
    [anon_sym_inout] = ACTIONS(2885),
    [anon_sym_virtual] = ACTIONS(2885),
    [anon_sym_extern] = ACTIONS(2885),
    [anon_sym___attribute__] = ACTIONS(2885),
    [anon_sym___attribute] = ACTIONS(2885),
    [anon_sym_using] = ACTIONS(2885),
    [anon_sym_COLON_COLON] = ACTIONS(2887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2887),
    [anon_sym___declspec] = ACTIONS(2885),
    [anon_sym___based] = ACTIONS(2885),
    [anon_sym___cdecl] = ACTIONS(2885),
    [anon_sym___clrcall] = ACTIONS(2885),
    [anon_sym___stdcall] = ACTIONS(2885),
    [anon_sym___fastcall] = ACTIONS(2885),
    [anon_sym___thiscall] = ACTIONS(2885),
    [anon_sym___vectorcall] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_signed] = ACTIONS(2885),
    [anon_sym_unsigned] = ACTIONS(2885),
    [anon_sym_long] = ACTIONS(2885),
    [anon_sym_short] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_static] = ACTIONS(2885),
    [anon_sym_register] = ACTIONS(2885),
    [anon_sym_inline] = ACTIONS(2885),
    [anon_sym___inline] = ACTIONS(2885),
    [anon_sym___inline__] = ACTIONS(2885),
    [anon_sym___forceinline] = ACTIONS(2885),
    [anon_sym_thread_local] = ACTIONS(2885),
    [anon_sym___thread] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_constexpr] = ACTIONS(2885),
    [anon_sym_volatile] = ACTIONS(2885),
    [anon_sym_restrict] = ACTIONS(2885),
    [anon_sym___restrict__] = ACTIONS(2885),
    [anon_sym__Atomic] = ACTIONS(2885),
    [anon_sym__Noreturn] = ACTIONS(2885),
    [anon_sym_noreturn] = ACTIONS(2885),
    [anon_sym__Nonnull] = ACTIONS(2885),
    [anon_sym_mutable] = ACTIONS(2885),
    [anon_sym_constinit] = ACTIONS(2885),
    [anon_sym_consteval] = ACTIONS(2885),
    [anon_sym_alignas] = ACTIONS(2885),
    [anon_sym__Alignas] = ACTIONS(2885),
    [sym_primitive_type] = ACTIONS(2885),
    [anon_sym_enum] = ACTIONS(2885),
    [anon_sym_class] = ACTIONS(2885),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_union] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_else] = ACTIONS(2885),
    [anon_sym_switch] = ACTIONS(2885),
    [anon_sym_case] = ACTIONS(2885),
    [anon_sym_default] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [anon_sym_do] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_break] = ACTIONS(2885),
    [anon_sym_continue] = ACTIONS(2885),
    [anon_sym_goto] = ACTIONS(2885),
    [anon_sym___try] = ACTIONS(2885),
    [anon_sym___leave] = ACTIONS(2885),
    [anon_sym_not] = ACTIONS(2885),
    [anon_sym_compl] = ACTIONS(2885),
    [anon_sym_DASH_DASH] = ACTIONS(2887),
    [anon_sym_PLUS_PLUS] = ACTIONS(2887),
    [anon_sym_sizeof] = ACTIONS(2885),
    [anon_sym___alignof__] = ACTIONS(2885),
    [anon_sym___alignof] = ACTIONS(2885),
    [anon_sym__alignof] = ACTIONS(2885),
    [anon_sym_alignof] = ACTIONS(2885),
    [anon_sym__Alignof] = ACTIONS(2885),
    [anon_sym_offsetof] = ACTIONS(2885),
    [anon_sym__Generic] = ACTIONS(2885),
    [anon_sym_asm] = ACTIONS(2885),
    [anon_sym___asm__] = ACTIONS(2885),
    [anon_sym___asm] = ACTIONS(2885),
    [sym_number_literal] = ACTIONS(2887),
    [anon_sym_L_SQUOTE] = ACTIONS(2887),
    [anon_sym_u_SQUOTE] = ACTIONS(2887),
    [anon_sym_U_SQUOTE] = ACTIONS(2887),
    [anon_sym_u8_SQUOTE] = ACTIONS(2887),
    [anon_sym_SQUOTE] = ACTIONS(2887),
    [anon_sym_L_DQUOTE] = ACTIONS(2887),
    [anon_sym_u_DQUOTE] = ACTIONS(2887),
    [anon_sym_U_DQUOTE] = ACTIONS(2887),
    [anon_sym_u8_DQUOTE] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [sym_true] = ACTIONS(2885),
    [sym_false] = ACTIONS(2885),
    [anon_sym_NULL] = ACTIONS(2885),
    [anon_sym_nullptr] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2885),
    [anon_sym_let] = ACTIONS(2885),
    [anon_sym_This] = ACTIONS(2885),
    [anon_sym_decltype] = ACTIONS(2885),
    [anon_sym_explicit] = ACTIONS(2885),
    [anon_sym_typename] = ACTIONS(2885),
    [anon_sym_export] = ACTIONS(2885),
    [anon_sym_module] = ACTIONS(2885),
    [anon_sym_import] = ACTIONS(2885),
    [anon_sym_template] = ACTIONS(2885),
    [anon_sym_operator] = ACTIONS(2885),
    [anon_sym_try] = ACTIONS(2885),
    [anon_sym_delete] = ACTIONS(2885),
    [anon_sym_throw] = ACTIONS(2885),
    [anon_sym_namespace] = ACTIONS(2885),
    [anon_sym_static_assert] = ACTIONS(2885),
    [anon_sym_concept] = ACTIONS(2885),
    [anon_sym_co_return] = ACTIONS(2885),
    [anon_sym_co_yield] = ACTIONS(2885),
    [anon_sym_catch] = ACTIONS(2891),
    [anon_sym_R_DQUOTE] = ACTIONS(2887),
    [anon_sym_LR_DQUOTE] = ACTIONS(2887),
    [anon_sym_uR_DQUOTE] = ACTIONS(2887),
    [anon_sym_UR_DQUOTE] = ACTIONS(2887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2887),
    [anon_sym_co_await] = ACTIONS(2885),
    [anon_sym_new] = ACTIONS(2885),
    [anon_sym_requires] = ACTIONS(2885),
    [sym_this] = ACTIONS(2885),
    [anon_sym_discard] = ACTIONS(2885),
    [anon_sym_precise] = ACTIONS(2885),
    [anon_sym_shared] = ACTIONS(2885),
    [anon_sym_groupshared] = ACTIONS(2885),
    [anon_sym_uniform] = ACTIONS(2885),
    [anon_sym_row_major] = ACTIONS(2885),
    [anon_sym_column_major] = ACTIONS(2885),
    [anon_sym_globallycoherent] = ACTIONS(2885),
    [anon_sym_centroid] = ACTIONS(2885),
    [anon_sym_noperspective] = ACTIONS(2885),
    [anon_sym_nointerpolation] = ACTIONS(2885),
    [anon_sym_sample] = ACTIONS(2885),
    [anon_sym_linear] = ACTIONS(2885),
    [anon_sym_snorm] = ACTIONS(2885),
    [anon_sym_unorm] = ACTIONS(2885),
    [anon_sym_point] = ACTIONS(2885),
    [anon_sym_line] = ACTIONS(2885),
    [anon_sym_triangleadj] = ACTIONS(2885),
    [anon_sym_lineadj] = ACTIONS(2885),
    [anon_sym_triangle] = ACTIONS(2885),
    [anon_sym_cbuffer] = ACTIONS(2885),
    [anon_sym_interface] = ACTIONS(2885),
    [anon_sym_extension] = ACTIONS(2885),
    [anon_sym___exported] = ACTIONS(2885),
  },
  [259] = {
    [sym_identifier] = ACTIONS(2428),
    [aux_sym_preproc_include_token1] = ACTIONS(2428),
    [aux_sym_preproc_def_token1] = ACTIONS(2428),
    [aux_sym_preproc_if_token1] = ACTIONS(2428),
    [aux_sym_preproc_if_token2] = ACTIONS(2428),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2428),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2428),
    [aux_sym_preproc_else_token1] = ACTIONS(2428),
    [aux_sym_preproc_elif_token1] = ACTIONS(2428),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2428),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2428),
    [sym_preproc_directive] = ACTIONS(2428),
    [anon_sym_LPAREN2] = ACTIONS(2426),
    [anon_sym_BANG] = ACTIONS(2426),
    [anon_sym_TILDE] = ACTIONS(2426),
    [anon_sym_DASH] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2428),
    [anon_sym_STAR] = ACTIONS(2426),
    [anon_sym_AMP_AMP] = ACTIONS(2426),
    [anon_sym_AMP] = ACTIONS(2428),
    [anon_sym_COLON] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2426),
    [anon_sym___extension__] = ACTIONS(2428),
    [anon_sym_typedef] = ACTIONS(2428),
    [anon_sym_in] = ACTIONS(2428),
    [anon_sym_out] = ACTIONS(2428),
    [anon_sym_inout] = ACTIONS(2428),
    [anon_sym_virtual] = ACTIONS(2428),
    [anon_sym_extern] = ACTIONS(2428),
    [anon_sym___attribute__] = ACTIONS(2428),
    [anon_sym___attribute] = ACTIONS(2428),
    [anon_sym_using] = ACTIONS(2428),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2426),
    [anon_sym___declspec] = ACTIONS(2428),
    [anon_sym___based] = ACTIONS(2428),
    [anon_sym___cdecl] = ACTIONS(2428),
    [anon_sym___clrcall] = ACTIONS(2428),
    [anon_sym___stdcall] = ACTIONS(2428),
    [anon_sym___fastcall] = ACTIONS(2428),
    [anon_sym___thiscall] = ACTIONS(2428),
    [anon_sym___vectorcall] = ACTIONS(2428),
    [anon_sym_LBRACE] = ACTIONS(2426),
    [anon_sym_signed] = ACTIONS(2428),
    [anon_sym_unsigned] = ACTIONS(2428),
    [anon_sym_long] = ACTIONS(2428),
    [anon_sym_short] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_static] = ACTIONS(2428),
    [anon_sym_register] = ACTIONS(2428),
    [anon_sym_inline] = ACTIONS(2428),
    [anon_sym___inline] = ACTIONS(2428),
    [anon_sym___inline__] = ACTIONS(2428),
    [anon_sym___forceinline] = ACTIONS(2428),
    [anon_sym_thread_local] = ACTIONS(2428),
    [anon_sym___thread] = ACTIONS(2428),
    [anon_sym_const] = ACTIONS(2428),
    [anon_sym_constexpr] = ACTIONS(2428),
    [anon_sym_volatile] = ACTIONS(2428),
    [anon_sym_restrict] = ACTIONS(2428),
    [anon_sym___restrict__] = ACTIONS(2428),
    [anon_sym__Atomic] = ACTIONS(2428),
    [anon_sym__Noreturn] = ACTIONS(2428),
    [anon_sym_noreturn] = ACTIONS(2428),
    [anon_sym__Nonnull] = ACTIONS(2428),
    [anon_sym_mutable] = ACTIONS(2428),
    [anon_sym_constinit] = ACTIONS(2428),
    [anon_sym_consteval] = ACTIONS(2428),
    [anon_sym_alignas] = ACTIONS(2428),
    [anon_sym__Alignas] = ACTIONS(2428),
    [sym_primitive_type] = ACTIONS(2428),
    [anon_sym_enum] = ACTIONS(2428),
    [anon_sym_class] = ACTIONS(2428),
    [anon_sym_struct] = ACTIONS(2428),
    [anon_sym_union] = ACTIONS(2428),
    [anon_sym_if] = ACTIONS(2428),
    [anon_sym_else] = ACTIONS(2428),
    [anon_sym_switch] = ACTIONS(2428),
    [anon_sym_case] = ACTIONS(2428),
    [anon_sym_default] = ACTIONS(2428),
    [anon_sym_while] = ACTIONS(2428),
    [anon_sym_do] = ACTIONS(2428),
    [anon_sym_for] = ACTIONS(2428),
    [anon_sym_return] = ACTIONS(2428),
    [anon_sym_break] = ACTIONS(2428),
    [anon_sym_continue] = ACTIONS(2428),
    [anon_sym_goto] = ACTIONS(2428),
    [anon_sym___try] = ACTIONS(2428),
    [anon_sym___leave] = ACTIONS(2428),
    [anon_sym_not] = ACTIONS(2428),
    [anon_sym_compl] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2426),
    [anon_sym_PLUS_PLUS] = ACTIONS(2426),
    [anon_sym_sizeof] = ACTIONS(2428),
    [anon_sym___alignof__] = ACTIONS(2428),
    [anon_sym___alignof] = ACTIONS(2428),
    [anon_sym__alignof] = ACTIONS(2428),
    [anon_sym_alignof] = ACTIONS(2428),
    [anon_sym__Alignof] = ACTIONS(2428),
    [anon_sym_offsetof] = ACTIONS(2428),
    [anon_sym__Generic] = ACTIONS(2428),
    [anon_sym_asm] = ACTIONS(2428),
    [anon_sym___asm__] = ACTIONS(2428),
    [anon_sym___asm] = ACTIONS(2428),
    [sym_number_literal] = ACTIONS(2426),
    [anon_sym_L_SQUOTE] = ACTIONS(2426),
    [anon_sym_u_SQUOTE] = ACTIONS(2426),
    [anon_sym_U_SQUOTE] = ACTIONS(2426),
    [anon_sym_u8_SQUOTE] = ACTIONS(2426),
    [anon_sym_SQUOTE] = ACTIONS(2426),
    [anon_sym_L_DQUOTE] = ACTIONS(2426),
    [anon_sym_u_DQUOTE] = ACTIONS(2426),
    [anon_sym_U_DQUOTE] = ACTIONS(2426),
    [anon_sym_u8_DQUOTE] = ACTIONS(2426),
    [anon_sym_DQUOTE] = ACTIONS(2426),
    [sym_true] = ACTIONS(2428),
    [sym_false] = ACTIONS(2428),
    [anon_sym_NULL] = ACTIONS(2428),
    [anon_sym_nullptr] = ACTIONS(2428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2428),
    [anon_sym_let] = ACTIONS(2428),
    [anon_sym_This] = ACTIONS(2428),
    [anon_sym_decltype] = ACTIONS(2428),
    [anon_sym_final] = ACTIONS(2428),
    [anon_sym_override] = ACTIONS(2428),
    [anon_sym_explicit] = ACTIONS(2428),
    [anon_sym_typename] = ACTIONS(2428),
    [anon_sym_template] = ACTIONS(2428),
    [anon_sym_operator] = ACTIONS(2428),
    [anon_sym_try] = ACTIONS(2428),
    [anon_sym_delete] = ACTIONS(2428),
    [anon_sym_throw] = ACTIONS(2428),
    [anon_sym_namespace] = ACTIONS(2428),
    [anon_sym_static_assert] = ACTIONS(2428),
    [anon_sym_concept] = ACTIONS(2428),
    [anon_sym_co_return] = ACTIONS(2428),
    [anon_sym_co_yield] = ACTIONS(2428),
    [anon_sym_R_DQUOTE] = ACTIONS(2426),
    [anon_sym_LR_DQUOTE] = ACTIONS(2426),
    [anon_sym_uR_DQUOTE] = ACTIONS(2426),
    [anon_sym_UR_DQUOTE] = ACTIONS(2426),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2426),
    [anon_sym_co_await] = ACTIONS(2428),
    [anon_sym_new] = ACTIONS(2428),
    [anon_sym_requires] = ACTIONS(2428),
    [sym_this] = ACTIONS(2428),
    [anon_sym_discard] = ACTIONS(2428),
    [anon_sym_precise] = ACTIONS(2428),
    [anon_sym_shared] = ACTIONS(2428),
    [anon_sym_groupshared] = ACTIONS(2428),
    [anon_sym_uniform] = ACTIONS(2428),
    [anon_sym_row_major] = ACTIONS(2428),
    [anon_sym_column_major] = ACTIONS(2428),
    [anon_sym_globallycoherent] = ACTIONS(2428),
    [anon_sym_centroid] = ACTIONS(2428),
    [anon_sym_noperspective] = ACTIONS(2428),
    [anon_sym_nointerpolation] = ACTIONS(2428),
    [anon_sym_sample] = ACTIONS(2428),
    [anon_sym_linear] = ACTIONS(2428),
    [anon_sym_snorm] = ACTIONS(2428),
    [anon_sym_unorm] = ACTIONS(2428),
    [anon_sym_point] = ACTIONS(2428),
    [anon_sym_line] = ACTIONS(2428),
    [anon_sym_triangleadj] = ACTIONS(2428),
    [anon_sym_lineadj] = ACTIONS(2428),
    [anon_sym_triangle] = ACTIONS(2428),
    [anon_sym_cbuffer] = ACTIONS(2428),
    [anon_sym_interface] = ACTIONS(2428),
    [anon_sym_extension] = ACTIONS(2428),
  },
  [260] = {
    [sym_attribute_specifier] = STATE(773),
    [sym_field_declaration_list] = STATE(700),
    [sym_virtual_specifier] = STATE(9418),
    [sym_base_class_clause] = STATE(10554),
    [sym_identifier] = ACTIONS(2893),
    [aux_sym_preproc_include_token1] = ACTIONS(2893),
    [aux_sym_preproc_def_token1] = ACTIONS(2893),
    [aux_sym_preproc_if_token1] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2893),
    [sym_preproc_directive] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_BANG] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_typedef] = ACTIONS(2893),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_out] = ACTIONS(2893),
    [anon_sym_inout] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(2897),
    [anon_sym___attribute] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(2893),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2899),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_signed] = ACTIONS(2893),
    [anon_sym_unsigned] = ACTIONS(2893),
    [anon_sym_long] = ACTIONS(2893),
    [anon_sym_short] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym__Nonnull] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym__Alignas] = ACTIONS(2893),
    [sym_primitive_type] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_union] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_switch] = ACTIONS(2893),
    [anon_sym_case] = ACTIONS(2893),
    [anon_sym_default] = ACTIONS(2893),
    [anon_sym_while] = ACTIONS(2893),
    [anon_sym_do] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_goto] = ACTIONS(2893),
    [anon_sym___try] = ACTIONS(2893),
    [anon_sym___leave] = ACTIONS(2893),
    [anon_sym_not] = ACTIONS(2893),
    [anon_sym_compl] = ACTIONS(2893),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_sizeof] = ACTIONS(2893),
    [anon_sym___alignof__] = ACTIONS(2893),
    [anon_sym___alignof] = ACTIONS(2893),
    [anon_sym__alignof] = ACTIONS(2893),
    [anon_sym_alignof] = ACTIONS(2893),
    [anon_sym__Alignof] = ACTIONS(2893),
    [anon_sym_offsetof] = ACTIONS(2893),
    [anon_sym__Generic] = ACTIONS(2893),
    [anon_sym_asm] = ACTIONS(2893),
    [anon_sym___asm__] = ACTIONS(2893),
    [anon_sym___asm] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2893),
    [sym_number_literal] = ACTIONS(2895),
    [anon_sym_L_SQUOTE] = ACTIONS(2895),
    [anon_sym_u_SQUOTE] = ACTIONS(2895),
    [anon_sym_U_SQUOTE] = ACTIONS(2895),
    [anon_sym_u8_SQUOTE] = ACTIONS(2895),
    [anon_sym_SQUOTE] = ACTIONS(2895),
    [anon_sym_L_DQUOTE] = ACTIONS(2895),
    [anon_sym_u_DQUOTE] = ACTIONS(2895),
    [anon_sym_U_DQUOTE] = ACTIONS(2895),
    [anon_sym_u8_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [anon_sym_NULL] = ACTIONS(2893),
    [anon_sym_nullptr] = ACTIONS(2893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_This] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_explicit] = ACTIONS(2893),
    [anon_sym_typename] = ACTIONS(2893),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_try] = ACTIONS(2893),
    [anon_sym_delete] = ACTIONS(2893),
    [anon_sym_throw] = ACTIONS(2893),
    [anon_sym_namespace] = ACTIONS(2893),
    [anon_sym_static_assert] = ACTIONS(2893),
    [anon_sym_concept] = ACTIONS(2893),
    [anon_sym_co_return] = ACTIONS(2893),
    [anon_sym_co_yield] = ACTIONS(2893),
    [anon_sym_R_DQUOTE] = ACTIONS(2895),
    [anon_sym_LR_DQUOTE] = ACTIONS(2895),
    [anon_sym_uR_DQUOTE] = ACTIONS(2895),
    [anon_sym_UR_DQUOTE] = ACTIONS(2895),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2895),
    [anon_sym_co_await] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2893),
    [anon_sym_requires] = ACTIONS(2893),
    [sym_this] = ACTIONS(2893),
    [anon_sym_discard] = ACTIONS(2893),
    [anon_sym_precise] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_groupshared] = ACTIONS(2893),
    [anon_sym_uniform] = ACTIONS(2893),
    [anon_sym_row_major] = ACTIONS(2893),
    [anon_sym_column_major] = ACTIONS(2893),
    [anon_sym_globallycoherent] = ACTIONS(2893),
    [anon_sym_centroid] = ACTIONS(2893),
    [anon_sym_noperspective] = ACTIONS(2893),
    [anon_sym_nointerpolation] = ACTIONS(2893),
    [anon_sym_sample] = ACTIONS(2893),
    [anon_sym_linear] = ACTIONS(2893),
    [anon_sym_snorm] = ACTIONS(2893),
    [anon_sym_unorm] = ACTIONS(2893),
    [anon_sym_point] = ACTIONS(2893),
    [anon_sym_line] = ACTIONS(2893),
    [anon_sym_triangleadj] = ACTIONS(2893),
    [anon_sym_lineadj] = ACTIONS(2893),
    [anon_sym_triangle] = ACTIONS(2893),
    [anon_sym_cbuffer] = ACTIONS(2893),
    [anon_sym_interface] = ACTIONS(2893),
    [anon_sym_extension] = ACTIONS(2893),
  },
  [261] = {
    [sym_identifier] = ACTIONS(2422),
    [aux_sym_preproc_include_token1] = ACTIONS(2422),
    [aux_sym_preproc_def_token1] = ACTIONS(2422),
    [aux_sym_preproc_if_token1] = ACTIONS(2422),
    [aux_sym_preproc_if_token2] = ACTIONS(2422),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2422),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2422),
    [aux_sym_preproc_else_token1] = ACTIONS(2422),
    [aux_sym_preproc_elif_token1] = ACTIONS(2422),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2422),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2422),
    [sym_preproc_directive] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym_typedef] = ACTIONS(2422),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_out] = ACTIONS(2422),
    [anon_sym_inout] = ACTIONS(2422),
    [anon_sym_virtual] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_using] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2422),
    [anon_sym___based] = ACTIONS(2422),
    [anon_sym___cdecl] = ACTIONS(2422),
    [anon_sym___clrcall] = ACTIONS(2422),
    [anon_sym___stdcall] = ACTIONS(2422),
    [anon_sym___fastcall] = ACTIONS(2422),
    [anon_sym___thiscall] = ACTIONS(2422),
    [anon_sym___vectorcall] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2422),
    [anon_sym_unsigned] = ACTIONS(2422),
    [anon_sym_long] = ACTIONS(2422),
    [anon_sym_short] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_register] = ACTIONS(2422),
    [anon_sym_inline] = ACTIONS(2422),
    [anon_sym___inline] = ACTIONS(2422),
    [anon_sym___inline__] = ACTIONS(2422),
    [anon_sym___forceinline] = ACTIONS(2422),
    [anon_sym_thread_local] = ACTIONS(2422),
    [anon_sym___thread] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [sym_primitive_type] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
    [anon_sym_class] = ACTIONS(2422),
    [anon_sym_struct] = ACTIONS(2422),
    [anon_sym_union] = ACTIONS(2422),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(2422),
    [anon_sym_switch] = ACTIONS(2422),
    [anon_sym_case] = ACTIONS(2422),
    [anon_sym_default] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_break] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(2422),
    [anon_sym_goto] = ACTIONS(2422),
    [anon_sym___try] = ACTIONS(2422),
    [anon_sym___leave] = ACTIONS(2422),
    [anon_sym_not] = ACTIONS(2422),
    [anon_sym_compl] = ACTIONS(2422),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_sizeof] = ACTIONS(2422),
    [anon_sym___alignof__] = ACTIONS(2422),
    [anon_sym___alignof] = ACTIONS(2422),
    [anon_sym__alignof] = ACTIONS(2422),
    [anon_sym_alignof] = ACTIONS(2422),
    [anon_sym__Alignof] = ACTIONS(2422),
    [anon_sym_offsetof] = ACTIONS(2422),
    [anon_sym__Generic] = ACTIONS(2422),
    [anon_sym_asm] = ACTIONS(2422),
    [anon_sym___asm__] = ACTIONS(2422),
    [anon_sym___asm] = ACTIONS(2422),
    [sym_number_literal] = ACTIONS(2420),
    [anon_sym_L_SQUOTE] = ACTIONS(2420),
    [anon_sym_u_SQUOTE] = ACTIONS(2420),
    [anon_sym_U_SQUOTE] = ACTIONS(2420),
    [anon_sym_u8_SQUOTE] = ACTIONS(2420),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [anon_sym_L_DQUOTE] = ACTIONS(2420),
    [anon_sym_u_DQUOTE] = ACTIONS(2420),
    [anon_sym_U_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [sym_true] = ACTIONS(2422),
    [sym_false] = ACTIONS(2422),
    [anon_sym_NULL] = ACTIONS(2422),
    [anon_sym_nullptr] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_decltype] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_explicit] = ACTIONS(2422),
    [anon_sym_typename] = ACTIONS(2422),
    [anon_sym_template] = ACTIONS(2422),
    [anon_sym_operator] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_delete] = ACTIONS(2422),
    [anon_sym_throw] = ACTIONS(2422),
    [anon_sym_namespace] = ACTIONS(2422),
    [anon_sym_static_assert] = ACTIONS(2422),
    [anon_sym_concept] = ACTIONS(2422),
    [anon_sym_co_return] = ACTIONS(2422),
    [anon_sym_co_yield] = ACTIONS(2422),
    [anon_sym_R_DQUOTE] = ACTIONS(2420),
    [anon_sym_LR_DQUOTE] = ACTIONS(2420),
    [anon_sym_uR_DQUOTE] = ACTIONS(2420),
    [anon_sym_UR_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2420),
    [anon_sym_co_await] = ACTIONS(2422),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_requires] = ACTIONS(2422),
    [sym_this] = ACTIONS(2422),
    [anon_sym_discard] = ACTIONS(2422),
    [anon_sym_precise] = ACTIONS(2422),
    [anon_sym_shared] = ACTIONS(2422),
    [anon_sym_groupshared] = ACTIONS(2422),
    [anon_sym_uniform] = ACTIONS(2422),
    [anon_sym_row_major] = ACTIONS(2422),
    [anon_sym_column_major] = ACTIONS(2422),
    [anon_sym_globallycoherent] = ACTIONS(2422),
    [anon_sym_centroid] = ACTIONS(2422),
    [anon_sym_noperspective] = ACTIONS(2422),
    [anon_sym_nointerpolation] = ACTIONS(2422),
    [anon_sym_sample] = ACTIONS(2422),
    [anon_sym_linear] = ACTIONS(2422),
    [anon_sym_snorm] = ACTIONS(2422),
    [anon_sym_unorm] = ACTIONS(2422),
    [anon_sym_point] = ACTIONS(2422),
    [anon_sym_line] = ACTIONS(2422),
    [anon_sym_triangleadj] = ACTIONS(2422),
    [anon_sym_lineadj] = ACTIONS(2422),
    [anon_sym_triangle] = ACTIONS(2422),
    [anon_sym_cbuffer] = ACTIONS(2422),
    [anon_sym_interface] = ACTIONS(2422),
    [anon_sym_extension] = ACTIONS(2422),
  },
  [262] = {
    [sym_catch_clause] = STATE(262),
    [aux_sym_constructor_try_statement_repeat1] = STATE(262),
    [sym_identifier] = ACTIONS(2901),
    [aux_sym_preproc_include_token1] = ACTIONS(2901),
    [aux_sym_preproc_def_token1] = ACTIONS(2901),
    [aux_sym_preproc_if_token1] = ACTIONS(2901),
    [aux_sym_preproc_if_token2] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2901),
    [aux_sym_preproc_else_token1] = ACTIONS(2901),
    [aux_sym_preproc_elif_token1] = ACTIONS(2901),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2901),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2901),
    [sym_preproc_directive] = ACTIONS(2901),
    [anon_sym_LPAREN2] = ACTIONS(2903),
    [anon_sym_BANG] = ACTIONS(2903),
    [anon_sym_TILDE] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2901),
    [anon_sym_STAR] = ACTIONS(2903),
    [anon_sym_AMP_AMP] = ACTIONS(2903),
    [anon_sym_AMP] = ACTIONS(2901),
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym___extension__] = ACTIONS(2901),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_in] = ACTIONS(2901),
    [anon_sym_out] = ACTIONS(2901),
    [anon_sym_inout] = ACTIONS(2901),
    [anon_sym_virtual] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(2901),
    [anon_sym___attribute__] = ACTIONS(2901),
    [anon_sym___attribute] = ACTIONS(2901),
    [anon_sym_using] = ACTIONS(2901),
    [anon_sym_COLON_COLON] = ACTIONS(2903),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2903),
    [anon_sym___declspec] = ACTIONS(2901),
    [anon_sym___based] = ACTIONS(2901),
    [anon_sym___cdecl] = ACTIONS(2901),
    [anon_sym___clrcall] = ACTIONS(2901),
    [anon_sym___stdcall] = ACTIONS(2901),
    [anon_sym___fastcall] = ACTIONS(2901),
    [anon_sym___thiscall] = ACTIONS(2901),
    [anon_sym___vectorcall] = ACTIONS(2901),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_signed] = ACTIONS(2901),
    [anon_sym_unsigned] = ACTIONS(2901),
    [anon_sym_long] = ACTIONS(2901),
    [anon_sym_short] = ACTIONS(2901),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_static] = ACTIONS(2901),
    [anon_sym_register] = ACTIONS(2901),
    [anon_sym_inline] = ACTIONS(2901),
    [anon_sym___inline] = ACTIONS(2901),
    [anon_sym___inline__] = ACTIONS(2901),
    [anon_sym___forceinline] = ACTIONS(2901),
    [anon_sym_thread_local] = ACTIONS(2901),
    [anon_sym___thread] = ACTIONS(2901),
    [anon_sym_const] = ACTIONS(2901),
    [anon_sym_constexpr] = ACTIONS(2901),
    [anon_sym_volatile] = ACTIONS(2901),
    [anon_sym_restrict] = ACTIONS(2901),
    [anon_sym___restrict__] = ACTIONS(2901),
    [anon_sym__Atomic] = ACTIONS(2901),
    [anon_sym__Noreturn] = ACTIONS(2901),
    [anon_sym_noreturn] = ACTIONS(2901),
    [anon_sym__Nonnull] = ACTIONS(2901),
    [anon_sym_mutable] = ACTIONS(2901),
    [anon_sym_constinit] = ACTIONS(2901),
    [anon_sym_consteval] = ACTIONS(2901),
    [anon_sym_alignas] = ACTIONS(2901),
    [anon_sym__Alignas] = ACTIONS(2901),
    [sym_primitive_type] = ACTIONS(2901),
    [anon_sym_enum] = ACTIONS(2901),
    [anon_sym_class] = ACTIONS(2901),
    [anon_sym_struct] = ACTIONS(2901),
    [anon_sym_union] = ACTIONS(2901),
    [anon_sym_if] = ACTIONS(2901),
    [anon_sym_else] = ACTIONS(2901),
    [anon_sym_switch] = ACTIONS(2901),
    [anon_sym_case] = ACTIONS(2901),
    [anon_sym_default] = ACTIONS(2901),
    [anon_sym_while] = ACTIONS(2901),
    [anon_sym_do] = ACTIONS(2901),
    [anon_sym_for] = ACTIONS(2901),
    [anon_sym_return] = ACTIONS(2901),
    [anon_sym_break] = ACTIONS(2901),
    [anon_sym_continue] = ACTIONS(2901),
    [anon_sym_goto] = ACTIONS(2901),
    [anon_sym___try] = ACTIONS(2901),
    [anon_sym___leave] = ACTIONS(2901),
    [anon_sym_not] = ACTIONS(2901),
    [anon_sym_compl] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2903),
    [anon_sym_PLUS_PLUS] = ACTIONS(2903),
    [anon_sym_sizeof] = ACTIONS(2901),
    [anon_sym___alignof__] = ACTIONS(2901),
    [anon_sym___alignof] = ACTIONS(2901),
    [anon_sym__alignof] = ACTIONS(2901),
    [anon_sym_alignof] = ACTIONS(2901),
    [anon_sym__Alignof] = ACTIONS(2901),
    [anon_sym_offsetof] = ACTIONS(2901),
    [anon_sym__Generic] = ACTIONS(2901),
    [anon_sym_asm] = ACTIONS(2901),
    [anon_sym___asm__] = ACTIONS(2901),
    [anon_sym___asm] = ACTIONS(2901),
    [sym_number_literal] = ACTIONS(2903),
    [anon_sym_L_SQUOTE] = ACTIONS(2903),
    [anon_sym_u_SQUOTE] = ACTIONS(2903),
    [anon_sym_U_SQUOTE] = ACTIONS(2903),
    [anon_sym_u8_SQUOTE] = ACTIONS(2903),
    [anon_sym_SQUOTE] = ACTIONS(2903),
    [anon_sym_L_DQUOTE] = ACTIONS(2903),
    [anon_sym_u_DQUOTE] = ACTIONS(2903),
    [anon_sym_U_DQUOTE] = ACTIONS(2903),
    [anon_sym_u8_DQUOTE] = ACTIONS(2903),
    [anon_sym_DQUOTE] = ACTIONS(2903),
    [sym_true] = ACTIONS(2901),
    [sym_false] = ACTIONS(2901),
    [anon_sym_NULL] = ACTIONS(2901),
    [anon_sym_nullptr] = ACTIONS(2901),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2901),
    [anon_sym_let] = ACTIONS(2901),
    [anon_sym_This] = ACTIONS(2901),
    [anon_sym_decltype] = ACTIONS(2901),
    [anon_sym_explicit] = ACTIONS(2901),
    [anon_sym_typename] = ACTIONS(2901),
    [anon_sym_template] = ACTIONS(2901),
    [anon_sym_operator] = ACTIONS(2901),
    [anon_sym_try] = ACTIONS(2901),
    [anon_sym_delete] = ACTIONS(2901),
    [anon_sym_throw] = ACTIONS(2901),
    [anon_sym_namespace] = ACTIONS(2901),
    [anon_sym_static_assert] = ACTIONS(2901),
    [anon_sym_concept] = ACTIONS(2901),
    [anon_sym_co_return] = ACTIONS(2901),
    [anon_sym_co_yield] = ACTIONS(2901),
    [anon_sym_catch] = ACTIONS(2905),
    [anon_sym_R_DQUOTE] = ACTIONS(2903),
    [anon_sym_LR_DQUOTE] = ACTIONS(2903),
    [anon_sym_uR_DQUOTE] = ACTIONS(2903),
    [anon_sym_UR_DQUOTE] = ACTIONS(2903),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2903),
    [anon_sym_co_await] = ACTIONS(2901),
    [anon_sym_new] = ACTIONS(2901),
    [anon_sym_requires] = ACTIONS(2901),
    [sym_this] = ACTIONS(2901),
    [anon_sym_discard] = ACTIONS(2901),
    [anon_sym_precise] = ACTIONS(2901),
    [anon_sym_shared] = ACTIONS(2901),
    [anon_sym_groupshared] = ACTIONS(2901),
    [anon_sym_uniform] = ACTIONS(2901),
    [anon_sym_row_major] = ACTIONS(2901),
    [anon_sym_column_major] = ACTIONS(2901),
    [anon_sym_globallycoherent] = ACTIONS(2901),
    [anon_sym_centroid] = ACTIONS(2901),
    [anon_sym_noperspective] = ACTIONS(2901),
    [anon_sym_nointerpolation] = ACTIONS(2901),
    [anon_sym_sample] = ACTIONS(2901),
    [anon_sym_linear] = ACTIONS(2901),
    [anon_sym_snorm] = ACTIONS(2901),
    [anon_sym_unorm] = ACTIONS(2901),
    [anon_sym_point] = ACTIONS(2901),
    [anon_sym_line] = ACTIONS(2901),
    [anon_sym_triangleadj] = ACTIONS(2901),
    [anon_sym_lineadj] = ACTIONS(2901),
    [anon_sym_triangle] = ACTIONS(2901),
    [anon_sym_cbuffer] = ACTIONS(2901),
    [anon_sym_interface] = ACTIONS(2901),
    [anon_sym_extension] = ACTIONS(2901),
  },
  [263] = {
    [sym_identifier] = ACTIONS(2418),
    [aux_sym_preproc_include_token1] = ACTIONS(2418),
    [aux_sym_preproc_def_token1] = ACTIONS(2418),
    [aux_sym_preproc_if_token1] = ACTIONS(2418),
    [aux_sym_preproc_if_token2] = ACTIONS(2418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2418),
    [aux_sym_preproc_else_token1] = ACTIONS(2418),
    [aux_sym_preproc_elif_token1] = ACTIONS(2418),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2418),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2418),
    [sym_preproc_directive] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2416),
    [anon_sym_TILDE] = ACTIONS(2416),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym___extension__] = ACTIONS(2418),
    [anon_sym_typedef] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(2418),
    [anon_sym_out] = ACTIONS(2418),
    [anon_sym_inout] = ACTIONS(2418),
    [anon_sym_virtual] = ACTIONS(2418),
    [anon_sym_extern] = ACTIONS(2418),
    [anon_sym___attribute__] = ACTIONS(2418),
    [anon_sym___attribute] = ACTIONS(2418),
    [anon_sym_using] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2416),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2416),
    [anon_sym___declspec] = ACTIONS(2418),
    [anon_sym___based] = ACTIONS(2418),
    [anon_sym___cdecl] = ACTIONS(2418),
    [anon_sym___clrcall] = ACTIONS(2418),
    [anon_sym___stdcall] = ACTIONS(2418),
    [anon_sym___fastcall] = ACTIONS(2418),
    [anon_sym___thiscall] = ACTIONS(2418),
    [anon_sym___vectorcall] = ACTIONS(2418),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_signed] = ACTIONS(2418),
    [anon_sym_unsigned] = ACTIONS(2418),
    [anon_sym_long] = ACTIONS(2418),
    [anon_sym_short] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2418),
    [anon_sym_register] = ACTIONS(2418),
    [anon_sym_inline] = ACTIONS(2418),
    [anon_sym___inline] = ACTIONS(2418),
    [anon_sym___inline__] = ACTIONS(2418),
    [anon_sym___forceinline] = ACTIONS(2418),
    [anon_sym_thread_local] = ACTIONS(2418),
    [anon_sym___thread] = ACTIONS(2418),
    [anon_sym_const] = ACTIONS(2418),
    [anon_sym_constexpr] = ACTIONS(2418),
    [anon_sym_volatile] = ACTIONS(2418),
    [anon_sym_restrict] = ACTIONS(2418),
    [anon_sym___restrict__] = ACTIONS(2418),
    [anon_sym__Atomic] = ACTIONS(2418),
    [anon_sym__Noreturn] = ACTIONS(2418),
    [anon_sym_noreturn] = ACTIONS(2418),
    [anon_sym__Nonnull] = ACTIONS(2418),
    [anon_sym_mutable] = ACTIONS(2418),
    [anon_sym_constinit] = ACTIONS(2418),
    [anon_sym_consteval] = ACTIONS(2418),
    [anon_sym_alignas] = ACTIONS(2418),
    [anon_sym__Alignas] = ACTIONS(2418),
    [sym_primitive_type] = ACTIONS(2418),
    [anon_sym_enum] = ACTIONS(2418),
    [anon_sym_class] = ACTIONS(2418),
    [anon_sym_struct] = ACTIONS(2418),
    [anon_sym_union] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_else] = ACTIONS(2418),
    [anon_sym_switch] = ACTIONS(2418),
    [anon_sym_case] = ACTIONS(2418),
    [anon_sym_default] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_break] = ACTIONS(2418),
    [anon_sym_continue] = ACTIONS(2418),
    [anon_sym_goto] = ACTIONS(2418),
    [anon_sym___try] = ACTIONS(2418),
    [anon_sym___leave] = ACTIONS(2418),
    [anon_sym_not] = ACTIONS(2418),
    [anon_sym_compl] = ACTIONS(2418),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_sizeof] = ACTIONS(2418),
    [anon_sym___alignof__] = ACTIONS(2418),
    [anon_sym___alignof] = ACTIONS(2418),
    [anon_sym__alignof] = ACTIONS(2418),
    [anon_sym_alignof] = ACTIONS(2418),
    [anon_sym__Alignof] = ACTIONS(2418),
    [anon_sym_offsetof] = ACTIONS(2418),
    [anon_sym__Generic] = ACTIONS(2418),
    [anon_sym_asm] = ACTIONS(2418),
    [anon_sym___asm__] = ACTIONS(2418),
    [anon_sym___asm] = ACTIONS(2418),
    [sym_number_literal] = ACTIONS(2416),
    [anon_sym_L_SQUOTE] = ACTIONS(2416),
    [anon_sym_u_SQUOTE] = ACTIONS(2416),
    [anon_sym_U_SQUOTE] = ACTIONS(2416),
    [anon_sym_u8_SQUOTE] = ACTIONS(2416),
    [anon_sym_SQUOTE] = ACTIONS(2416),
    [anon_sym_L_DQUOTE] = ACTIONS(2416),
    [anon_sym_u_DQUOTE] = ACTIONS(2416),
    [anon_sym_U_DQUOTE] = ACTIONS(2416),
    [anon_sym_u8_DQUOTE] = ACTIONS(2416),
    [anon_sym_DQUOTE] = ACTIONS(2416),
    [sym_true] = ACTIONS(2418),
    [sym_false] = ACTIONS(2418),
    [anon_sym_NULL] = ACTIONS(2418),
    [anon_sym_nullptr] = ACTIONS(2418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_This] = ACTIONS(2418),
    [anon_sym_decltype] = ACTIONS(2418),
    [anon_sym_final] = ACTIONS(2418),
    [anon_sym_override] = ACTIONS(2418),
    [anon_sym_explicit] = ACTIONS(2418),
    [anon_sym_typename] = ACTIONS(2418),
    [anon_sym_template] = ACTIONS(2418),
    [anon_sym_operator] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_delete] = ACTIONS(2418),
    [anon_sym_throw] = ACTIONS(2418),
    [anon_sym_namespace] = ACTIONS(2418),
    [anon_sym_static_assert] = ACTIONS(2418),
    [anon_sym_concept] = ACTIONS(2418),
    [anon_sym_co_return] = ACTIONS(2418),
    [anon_sym_co_yield] = ACTIONS(2418),
    [anon_sym_R_DQUOTE] = ACTIONS(2416),
    [anon_sym_LR_DQUOTE] = ACTIONS(2416),
    [anon_sym_uR_DQUOTE] = ACTIONS(2416),
    [anon_sym_UR_DQUOTE] = ACTIONS(2416),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2416),
    [anon_sym_co_await] = ACTIONS(2418),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_requires] = ACTIONS(2418),
    [sym_this] = ACTIONS(2418),
    [anon_sym_discard] = ACTIONS(2418),
    [anon_sym_precise] = ACTIONS(2418),
    [anon_sym_shared] = ACTIONS(2418),
    [anon_sym_groupshared] = ACTIONS(2418),
    [anon_sym_uniform] = ACTIONS(2418),
    [anon_sym_row_major] = ACTIONS(2418),
    [anon_sym_column_major] = ACTIONS(2418),
    [anon_sym_globallycoherent] = ACTIONS(2418),
    [anon_sym_centroid] = ACTIONS(2418),
    [anon_sym_noperspective] = ACTIONS(2418),
    [anon_sym_nointerpolation] = ACTIONS(2418),
    [anon_sym_sample] = ACTIONS(2418),
    [anon_sym_linear] = ACTIONS(2418),
    [anon_sym_snorm] = ACTIONS(2418),
    [anon_sym_unorm] = ACTIONS(2418),
    [anon_sym_point] = ACTIONS(2418),
    [anon_sym_line] = ACTIONS(2418),
    [anon_sym_triangleadj] = ACTIONS(2418),
    [anon_sym_lineadj] = ACTIONS(2418),
    [anon_sym_triangle] = ACTIONS(2418),
    [anon_sym_cbuffer] = ACTIONS(2418),
    [anon_sym_interface] = ACTIONS(2418),
    [anon_sym_extension] = ACTIONS(2418),
  },
  [264] = {
    [sym_identifier] = ACTIONS(2243),
    [aux_sym_preproc_include_token1] = ACTIONS(2243),
    [aux_sym_preproc_def_token1] = ACTIONS(2243),
    [aux_sym_preproc_if_token1] = ACTIONS(2243),
    [aux_sym_preproc_if_token2] = ACTIONS(2243),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2243),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2243),
    [aux_sym_preproc_else_token1] = ACTIONS(2243),
    [aux_sym_preproc_elif_token1] = ACTIONS(2243),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2243),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2243),
    [sym_preproc_directive] = ACTIONS(2243),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2243),
    [anon_sym_PLUS] = ACTIONS(2243),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_COLON] = ACTIONS(2243),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym_typedef] = ACTIONS(2243),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_out] = ACTIONS(2243),
    [anon_sym_inout] = ACTIONS(2243),
    [anon_sym_virtual] = ACTIONS(2243),
    [anon_sym_extern] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym___attribute] = ACTIONS(2243),
    [anon_sym_using] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2243),
    [anon_sym___based] = ACTIONS(2243),
    [anon_sym___cdecl] = ACTIONS(2243),
    [anon_sym___clrcall] = ACTIONS(2243),
    [anon_sym___stdcall] = ACTIONS(2243),
    [anon_sym___fastcall] = ACTIONS(2243),
    [anon_sym___thiscall] = ACTIONS(2243),
    [anon_sym___vectorcall] = ACTIONS(2243),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_signed] = ACTIONS(2243),
    [anon_sym_unsigned] = ACTIONS(2243),
    [anon_sym_long] = ACTIONS(2243),
    [anon_sym_short] = ACTIONS(2243),
    [anon_sym_LBRACK] = ACTIONS(2243),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_register] = ACTIONS(2243),
    [anon_sym_inline] = ACTIONS(2243),
    [anon_sym___inline] = ACTIONS(2243),
    [anon_sym___inline__] = ACTIONS(2243),
    [anon_sym___forceinline] = ACTIONS(2243),
    [anon_sym_thread_local] = ACTIONS(2243),
    [anon_sym___thread] = ACTIONS(2243),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym__Nonnull] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [sym_primitive_type] = ACTIONS(2243),
    [anon_sym_enum] = ACTIONS(2243),
    [anon_sym_class] = ACTIONS(2243),
    [anon_sym_struct] = ACTIONS(2243),
    [anon_sym_union] = ACTIONS(2243),
    [anon_sym_if] = ACTIONS(2243),
    [anon_sym_else] = ACTIONS(2243),
    [anon_sym_switch] = ACTIONS(2243),
    [anon_sym_case] = ACTIONS(2243),
    [anon_sym_default] = ACTIONS(2243),
    [anon_sym_while] = ACTIONS(2243),
    [anon_sym_do] = ACTIONS(2243),
    [anon_sym_for] = ACTIONS(2243),
    [anon_sym_return] = ACTIONS(2243),
    [anon_sym_break] = ACTIONS(2243),
    [anon_sym_continue] = ACTIONS(2243),
    [anon_sym_goto] = ACTIONS(2243),
    [anon_sym___try] = ACTIONS(2243),
    [anon_sym___leave] = ACTIONS(2243),
    [anon_sym_not] = ACTIONS(2243),
    [anon_sym_compl] = ACTIONS(2243),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_sizeof] = ACTIONS(2243),
    [anon_sym___alignof__] = ACTIONS(2243),
    [anon_sym___alignof] = ACTIONS(2243),
    [anon_sym__alignof] = ACTIONS(2243),
    [anon_sym_alignof] = ACTIONS(2243),
    [anon_sym__Alignof] = ACTIONS(2243),
    [anon_sym_offsetof] = ACTIONS(2243),
    [anon_sym__Generic] = ACTIONS(2243),
    [anon_sym_asm] = ACTIONS(2243),
    [anon_sym___asm__] = ACTIONS(2243),
    [anon_sym___asm] = ACTIONS(2243),
    [sym_number_literal] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2250),
    [anon_sym_u_SQUOTE] = ACTIONS(2250),
    [anon_sym_U_SQUOTE] = ACTIONS(2250),
    [anon_sym_u8_SQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_L_DQUOTE] = ACTIONS(2250),
    [anon_sym_u_DQUOTE] = ACTIONS(2250),
    [anon_sym_U_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [sym_true] = ACTIONS(2243),
    [sym_false] = ACTIONS(2243),
    [anon_sym_NULL] = ACTIONS(2243),
    [anon_sym_nullptr] = ACTIONS(2243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2243),
    [anon_sym_let] = ACTIONS(2243),
    [anon_sym_This] = ACTIONS(2243),
    [anon_sym_decltype] = ACTIONS(2243),
    [anon_sym_final] = ACTIONS(2243),
    [anon_sym_override] = ACTIONS(2243),
    [anon_sym_explicit] = ACTIONS(2243),
    [anon_sym_typename] = ACTIONS(2243),
    [anon_sym_template] = ACTIONS(2243),
    [anon_sym_operator] = ACTIONS(2243),
    [anon_sym_try] = ACTIONS(2243),
    [anon_sym_delete] = ACTIONS(2243),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_namespace] = ACTIONS(2243),
    [anon_sym_static_assert] = ACTIONS(2243),
    [anon_sym_concept] = ACTIONS(2243),
    [anon_sym_co_return] = ACTIONS(2243),
    [anon_sym_co_yield] = ACTIONS(2243),
    [anon_sym_R_DQUOTE] = ACTIONS(2250),
    [anon_sym_LR_DQUOTE] = ACTIONS(2250),
    [anon_sym_uR_DQUOTE] = ACTIONS(2250),
    [anon_sym_UR_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2250),
    [anon_sym_co_await] = ACTIONS(2243),
    [anon_sym_new] = ACTIONS(2243),
    [anon_sym_requires] = ACTIONS(2243),
    [sym_this] = ACTIONS(2243),
    [anon_sym_discard] = ACTIONS(2243),
    [anon_sym_precise] = ACTIONS(2243),
    [anon_sym_shared] = ACTIONS(2243),
    [anon_sym_groupshared] = ACTIONS(2243),
    [anon_sym_uniform] = ACTIONS(2243),
    [anon_sym_row_major] = ACTIONS(2243),
    [anon_sym_column_major] = ACTIONS(2243),
    [anon_sym_globallycoherent] = ACTIONS(2243),
    [anon_sym_centroid] = ACTIONS(2243),
    [anon_sym_noperspective] = ACTIONS(2243),
    [anon_sym_nointerpolation] = ACTIONS(2243),
    [anon_sym_sample] = ACTIONS(2243),
    [anon_sym_linear] = ACTIONS(2243),
    [anon_sym_snorm] = ACTIONS(2243),
    [anon_sym_unorm] = ACTIONS(2243),
    [anon_sym_point] = ACTIONS(2243),
    [anon_sym_line] = ACTIONS(2243),
    [anon_sym_triangleadj] = ACTIONS(2243),
    [anon_sym_lineadj] = ACTIONS(2243),
    [anon_sym_triangle] = ACTIONS(2243),
    [anon_sym_cbuffer] = ACTIONS(2243),
    [anon_sym_interface] = ACTIONS(2243),
    [anon_sym_extension] = ACTIONS(2243),
  },
  [265] = {
    [sym_identifier] = ACTIONS(2422),
    [aux_sym_preproc_include_token1] = ACTIONS(2422),
    [aux_sym_preproc_def_token1] = ACTIONS(2422),
    [aux_sym_preproc_if_token1] = ACTIONS(2422),
    [aux_sym_preproc_if_token2] = ACTIONS(2422),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2422),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2422),
    [aux_sym_preproc_else_token1] = ACTIONS(2422),
    [aux_sym_preproc_elif_token1] = ACTIONS(2422),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2422),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2422),
    [sym_preproc_directive] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym_typedef] = ACTIONS(2422),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_out] = ACTIONS(2422),
    [anon_sym_inout] = ACTIONS(2422),
    [anon_sym_virtual] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_using] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2422),
    [anon_sym___based] = ACTIONS(2422),
    [anon_sym___cdecl] = ACTIONS(2422),
    [anon_sym___clrcall] = ACTIONS(2422),
    [anon_sym___stdcall] = ACTIONS(2422),
    [anon_sym___fastcall] = ACTIONS(2422),
    [anon_sym___thiscall] = ACTIONS(2422),
    [anon_sym___vectorcall] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2422),
    [anon_sym_unsigned] = ACTIONS(2422),
    [anon_sym_long] = ACTIONS(2422),
    [anon_sym_short] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_register] = ACTIONS(2422),
    [anon_sym_inline] = ACTIONS(2422),
    [anon_sym___inline] = ACTIONS(2422),
    [anon_sym___inline__] = ACTIONS(2422),
    [anon_sym___forceinline] = ACTIONS(2422),
    [anon_sym_thread_local] = ACTIONS(2422),
    [anon_sym___thread] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [sym_primitive_type] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
    [anon_sym_class] = ACTIONS(2422),
    [anon_sym_struct] = ACTIONS(2422),
    [anon_sym_union] = ACTIONS(2422),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(2422),
    [anon_sym_switch] = ACTIONS(2422),
    [anon_sym_case] = ACTIONS(2422),
    [anon_sym_default] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_break] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(2422),
    [anon_sym_goto] = ACTIONS(2422),
    [anon_sym___try] = ACTIONS(2422),
    [anon_sym___leave] = ACTIONS(2422),
    [anon_sym_not] = ACTIONS(2422),
    [anon_sym_compl] = ACTIONS(2422),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_sizeof] = ACTIONS(2422),
    [anon_sym___alignof__] = ACTIONS(2422),
    [anon_sym___alignof] = ACTIONS(2422),
    [anon_sym__alignof] = ACTIONS(2422),
    [anon_sym_alignof] = ACTIONS(2422),
    [anon_sym__Alignof] = ACTIONS(2422),
    [anon_sym_offsetof] = ACTIONS(2422),
    [anon_sym__Generic] = ACTIONS(2422),
    [anon_sym_asm] = ACTIONS(2422),
    [anon_sym___asm__] = ACTIONS(2422),
    [anon_sym___asm] = ACTIONS(2422),
    [sym_number_literal] = ACTIONS(2420),
    [anon_sym_L_SQUOTE] = ACTIONS(2420),
    [anon_sym_u_SQUOTE] = ACTIONS(2420),
    [anon_sym_U_SQUOTE] = ACTIONS(2420),
    [anon_sym_u8_SQUOTE] = ACTIONS(2420),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [anon_sym_L_DQUOTE] = ACTIONS(2420),
    [anon_sym_u_DQUOTE] = ACTIONS(2420),
    [anon_sym_U_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [sym_true] = ACTIONS(2422),
    [sym_false] = ACTIONS(2422),
    [anon_sym_NULL] = ACTIONS(2422),
    [anon_sym_nullptr] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_decltype] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_explicit] = ACTIONS(2422),
    [anon_sym_typename] = ACTIONS(2422),
    [anon_sym_template] = ACTIONS(2422),
    [anon_sym_operator] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_delete] = ACTIONS(2422),
    [anon_sym_throw] = ACTIONS(2422),
    [anon_sym_namespace] = ACTIONS(2422),
    [anon_sym_static_assert] = ACTIONS(2422),
    [anon_sym_concept] = ACTIONS(2422),
    [anon_sym_co_return] = ACTIONS(2422),
    [anon_sym_co_yield] = ACTIONS(2422),
    [anon_sym_R_DQUOTE] = ACTIONS(2420),
    [anon_sym_LR_DQUOTE] = ACTIONS(2420),
    [anon_sym_uR_DQUOTE] = ACTIONS(2420),
    [anon_sym_UR_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2420),
    [anon_sym_co_await] = ACTIONS(2422),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_requires] = ACTIONS(2422),
    [sym_this] = ACTIONS(2422),
    [anon_sym_discard] = ACTIONS(2422),
    [anon_sym_precise] = ACTIONS(2422),
    [anon_sym_shared] = ACTIONS(2422),
    [anon_sym_groupshared] = ACTIONS(2422),
    [anon_sym_uniform] = ACTIONS(2422),
    [anon_sym_row_major] = ACTIONS(2422),
    [anon_sym_column_major] = ACTIONS(2422),
    [anon_sym_globallycoherent] = ACTIONS(2422),
    [anon_sym_centroid] = ACTIONS(2422),
    [anon_sym_noperspective] = ACTIONS(2422),
    [anon_sym_nointerpolation] = ACTIONS(2422),
    [anon_sym_sample] = ACTIONS(2422),
    [anon_sym_linear] = ACTIONS(2422),
    [anon_sym_snorm] = ACTIONS(2422),
    [anon_sym_unorm] = ACTIONS(2422),
    [anon_sym_point] = ACTIONS(2422),
    [anon_sym_line] = ACTIONS(2422),
    [anon_sym_triangleadj] = ACTIONS(2422),
    [anon_sym_lineadj] = ACTIONS(2422),
    [anon_sym_triangle] = ACTIONS(2422),
    [anon_sym_cbuffer] = ACTIONS(2422),
    [anon_sym_interface] = ACTIONS(2422),
    [anon_sym_extension] = ACTIONS(2422),
  },
  [266] = {
    [sym_identifier] = ACTIONS(2422),
    [aux_sym_preproc_include_token1] = ACTIONS(2422),
    [aux_sym_preproc_def_token1] = ACTIONS(2422),
    [aux_sym_preproc_if_token1] = ACTIONS(2422),
    [aux_sym_preproc_if_token2] = ACTIONS(2422),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2422),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2422),
    [aux_sym_preproc_else_token1] = ACTIONS(2422),
    [aux_sym_preproc_elif_token1] = ACTIONS(2422),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2422),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2422),
    [sym_preproc_directive] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym_typedef] = ACTIONS(2422),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_out] = ACTIONS(2422),
    [anon_sym_inout] = ACTIONS(2422),
    [anon_sym_virtual] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_using] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2422),
    [anon_sym___based] = ACTIONS(2422),
    [anon_sym___cdecl] = ACTIONS(2422),
    [anon_sym___clrcall] = ACTIONS(2422),
    [anon_sym___stdcall] = ACTIONS(2422),
    [anon_sym___fastcall] = ACTIONS(2422),
    [anon_sym___thiscall] = ACTIONS(2422),
    [anon_sym___vectorcall] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2422),
    [anon_sym_unsigned] = ACTIONS(2422),
    [anon_sym_long] = ACTIONS(2422),
    [anon_sym_short] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_register] = ACTIONS(2422),
    [anon_sym_inline] = ACTIONS(2422),
    [anon_sym___inline] = ACTIONS(2422),
    [anon_sym___inline__] = ACTIONS(2422),
    [anon_sym___forceinline] = ACTIONS(2422),
    [anon_sym_thread_local] = ACTIONS(2422),
    [anon_sym___thread] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [sym_primitive_type] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
    [anon_sym_class] = ACTIONS(2422),
    [anon_sym_struct] = ACTIONS(2422),
    [anon_sym_union] = ACTIONS(2422),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(2422),
    [anon_sym_switch] = ACTIONS(2422),
    [anon_sym_case] = ACTIONS(2422),
    [anon_sym_default] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_break] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(2422),
    [anon_sym_goto] = ACTIONS(2422),
    [anon_sym___try] = ACTIONS(2422),
    [anon_sym___leave] = ACTIONS(2422),
    [anon_sym_not] = ACTIONS(2422),
    [anon_sym_compl] = ACTIONS(2422),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_sizeof] = ACTIONS(2422),
    [anon_sym___alignof__] = ACTIONS(2422),
    [anon_sym___alignof] = ACTIONS(2422),
    [anon_sym__alignof] = ACTIONS(2422),
    [anon_sym_alignof] = ACTIONS(2422),
    [anon_sym__Alignof] = ACTIONS(2422),
    [anon_sym_offsetof] = ACTIONS(2422),
    [anon_sym__Generic] = ACTIONS(2422),
    [anon_sym_asm] = ACTIONS(2422),
    [anon_sym___asm__] = ACTIONS(2422),
    [anon_sym___asm] = ACTIONS(2422),
    [sym_number_literal] = ACTIONS(2420),
    [anon_sym_L_SQUOTE] = ACTIONS(2420),
    [anon_sym_u_SQUOTE] = ACTIONS(2420),
    [anon_sym_U_SQUOTE] = ACTIONS(2420),
    [anon_sym_u8_SQUOTE] = ACTIONS(2420),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [anon_sym_L_DQUOTE] = ACTIONS(2420),
    [anon_sym_u_DQUOTE] = ACTIONS(2420),
    [anon_sym_U_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [sym_true] = ACTIONS(2422),
    [sym_false] = ACTIONS(2422),
    [anon_sym_NULL] = ACTIONS(2422),
    [anon_sym_nullptr] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_decltype] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_explicit] = ACTIONS(2422),
    [anon_sym_typename] = ACTIONS(2422),
    [anon_sym_template] = ACTIONS(2422),
    [anon_sym_operator] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_delete] = ACTIONS(2422),
    [anon_sym_throw] = ACTIONS(2422),
    [anon_sym_namespace] = ACTIONS(2422),
    [anon_sym_static_assert] = ACTIONS(2422),
    [anon_sym_concept] = ACTIONS(2422),
    [anon_sym_co_return] = ACTIONS(2422),
    [anon_sym_co_yield] = ACTIONS(2422),
    [anon_sym_R_DQUOTE] = ACTIONS(2420),
    [anon_sym_LR_DQUOTE] = ACTIONS(2420),
    [anon_sym_uR_DQUOTE] = ACTIONS(2420),
    [anon_sym_UR_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2420),
    [anon_sym_co_await] = ACTIONS(2422),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_requires] = ACTIONS(2422),
    [sym_this] = ACTIONS(2422),
    [anon_sym_discard] = ACTIONS(2422),
    [anon_sym_precise] = ACTIONS(2422),
    [anon_sym_shared] = ACTIONS(2422),
    [anon_sym_groupshared] = ACTIONS(2422),
    [anon_sym_uniform] = ACTIONS(2422),
    [anon_sym_row_major] = ACTIONS(2422),
    [anon_sym_column_major] = ACTIONS(2422),
    [anon_sym_globallycoherent] = ACTIONS(2422),
    [anon_sym_centroid] = ACTIONS(2422),
    [anon_sym_noperspective] = ACTIONS(2422),
    [anon_sym_nointerpolation] = ACTIONS(2422),
    [anon_sym_sample] = ACTIONS(2422),
    [anon_sym_linear] = ACTIONS(2422),
    [anon_sym_snorm] = ACTIONS(2422),
    [anon_sym_unorm] = ACTIONS(2422),
    [anon_sym_point] = ACTIONS(2422),
    [anon_sym_line] = ACTIONS(2422),
    [anon_sym_triangleadj] = ACTIONS(2422),
    [anon_sym_lineadj] = ACTIONS(2422),
    [anon_sym_triangle] = ACTIONS(2422),
    [anon_sym_cbuffer] = ACTIONS(2422),
    [anon_sym_interface] = ACTIONS(2422),
    [anon_sym_extension] = ACTIONS(2422),
  },
  [267] = {
    [sym_catch_clause] = STATE(267),
    [aux_sym_constructor_try_statement_repeat1] = STATE(267),
    [ts_builtin_sym_end] = ACTIONS(2903),
    [sym_identifier] = ACTIONS(2901),
    [aux_sym_preproc_include_token1] = ACTIONS(2901),
    [aux_sym_preproc_def_token1] = ACTIONS(2901),
    [aux_sym_preproc_if_token1] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2901),
    [sym_preproc_directive] = ACTIONS(2901),
    [anon_sym_LPAREN2] = ACTIONS(2903),
    [anon_sym_BANG] = ACTIONS(2903),
    [anon_sym_TILDE] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2901),
    [anon_sym_STAR] = ACTIONS(2903),
    [anon_sym_AMP_AMP] = ACTIONS(2903),
    [anon_sym_AMP] = ACTIONS(2901),
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym___extension__] = ACTIONS(2901),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_in] = ACTIONS(2901),
    [anon_sym_out] = ACTIONS(2901),
    [anon_sym_inout] = ACTIONS(2901),
    [anon_sym_virtual] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(2901),
    [anon_sym___attribute__] = ACTIONS(2901),
    [anon_sym___attribute] = ACTIONS(2901),
    [anon_sym_using] = ACTIONS(2901),
    [anon_sym_COLON_COLON] = ACTIONS(2903),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2903),
    [anon_sym___declspec] = ACTIONS(2901),
    [anon_sym___based] = ACTIONS(2901),
    [anon_sym___cdecl] = ACTIONS(2901),
    [anon_sym___clrcall] = ACTIONS(2901),
    [anon_sym___stdcall] = ACTIONS(2901),
    [anon_sym___fastcall] = ACTIONS(2901),
    [anon_sym___thiscall] = ACTIONS(2901),
    [anon_sym___vectorcall] = ACTIONS(2901),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_signed] = ACTIONS(2901),
    [anon_sym_unsigned] = ACTIONS(2901),
    [anon_sym_long] = ACTIONS(2901),
    [anon_sym_short] = ACTIONS(2901),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_static] = ACTIONS(2901),
    [anon_sym_register] = ACTIONS(2901),
    [anon_sym_inline] = ACTIONS(2901),
    [anon_sym___inline] = ACTIONS(2901),
    [anon_sym___inline__] = ACTIONS(2901),
    [anon_sym___forceinline] = ACTIONS(2901),
    [anon_sym_thread_local] = ACTIONS(2901),
    [anon_sym___thread] = ACTIONS(2901),
    [anon_sym_const] = ACTIONS(2901),
    [anon_sym_constexpr] = ACTIONS(2901),
    [anon_sym_volatile] = ACTIONS(2901),
    [anon_sym_restrict] = ACTIONS(2901),
    [anon_sym___restrict__] = ACTIONS(2901),
    [anon_sym__Atomic] = ACTIONS(2901),
    [anon_sym__Noreturn] = ACTIONS(2901),
    [anon_sym_noreturn] = ACTIONS(2901),
    [anon_sym__Nonnull] = ACTIONS(2901),
    [anon_sym_mutable] = ACTIONS(2901),
    [anon_sym_constinit] = ACTIONS(2901),
    [anon_sym_consteval] = ACTIONS(2901),
    [anon_sym_alignas] = ACTIONS(2901),
    [anon_sym__Alignas] = ACTIONS(2901),
    [sym_primitive_type] = ACTIONS(2901),
    [anon_sym_enum] = ACTIONS(2901),
    [anon_sym_class] = ACTIONS(2901),
    [anon_sym_struct] = ACTIONS(2901),
    [anon_sym_union] = ACTIONS(2901),
    [anon_sym_if] = ACTIONS(2901),
    [anon_sym_else] = ACTIONS(2901),
    [anon_sym_switch] = ACTIONS(2901),
    [anon_sym_case] = ACTIONS(2901),
    [anon_sym_default] = ACTIONS(2901),
    [anon_sym_while] = ACTIONS(2901),
    [anon_sym_do] = ACTIONS(2901),
    [anon_sym_for] = ACTIONS(2901),
    [anon_sym_return] = ACTIONS(2901),
    [anon_sym_break] = ACTIONS(2901),
    [anon_sym_continue] = ACTIONS(2901),
    [anon_sym_goto] = ACTIONS(2901),
    [anon_sym___try] = ACTIONS(2901),
    [anon_sym___leave] = ACTIONS(2901),
    [anon_sym_not] = ACTIONS(2901),
    [anon_sym_compl] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2903),
    [anon_sym_PLUS_PLUS] = ACTIONS(2903),
    [anon_sym_sizeof] = ACTIONS(2901),
    [anon_sym___alignof__] = ACTIONS(2901),
    [anon_sym___alignof] = ACTIONS(2901),
    [anon_sym__alignof] = ACTIONS(2901),
    [anon_sym_alignof] = ACTIONS(2901),
    [anon_sym__Alignof] = ACTIONS(2901),
    [anon_sym_offsetof] = ACTIONS(2901),
    [anon_sym__Generic] = ACTIONS(2901),
    [anon_sym_asm] = ACTIONS(2901),
    [anon_sym___asm__] = ACTIONS(2901),
    [anon_sym___asm] = ACTIONS(2901),
    [sym_number_literal] = ACTIONS(2903),
    [anon_sym_L_SQUOTE] = ACTIONS(2903),
    [anon_sym_u_SQUOTE] = ACTIONS(2903),
    [anon_sym_U_SQUOTE] = ACTIONS(2903),
    [anon_sym_u8_SQUOTE] = ACTIONS(2903),
    [anon_sym_SQUOTE] = ACTIONS(2903),
    [anon_sym_L_DQUOTE] = ACTIONS(2903),
    [anon_sym_u_DQUOTE] = ACTIONS(2903),
    [anon_sym_U_DQUOTE] = ACTIONS(2903),
    [anon_sym_u8_DQUOTE] = ACTIONS(2903),
    [anon_sym_DQUOTE] = ACTIONS(2903),
    [sym_true] = ACTIONS(2901),
    [sym_false] = ACTIONS(2901),
    [anon_sym_NULL] = ACTIONS(2901),
    [anon_sym_nullptr] = ACTIONS(2901),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2901),
    [anon_sym_let] = ACTIONS(2901),
    [anon_sym_This] = ACTIONS(2901),
    [anon_sym_decltype] = ACTIONS(2901),
    [anon_sym_explicit] = ACTIONS(2901),
    [anon_sym_typename] = ACTIONS(2901),
    [anon_sym_export] = ACTIONS(2901),
    [anon_sym_module] = ACTIONS(2901),
    [anon_sym_import] = ACTIONS(2901),
    [anon_sym_template] = ACTIONS(2901),
    [anon_sym_operator] = ACTIONS(2901),
    [anon_sym_try] = ACTIONS(2901),
    [anon_sym_delete] = ACTIONS(2901),
    [anon_sym_throw] = ACTIONS(2901),
    [anon_sym_namespace] = ACTIONS(2901),
    [anon_sym_static_assert] = ACTIONS(2901),
    [anon_sym_concept] = ACTIONS(2901),
    [anon_sym_co_return] = ACTIONS(2901),
    [anon_sym_co_yield] = ACTIONS(2901),
    [anon_sym_catch] = ACTIONS(2908),
    [anon_sym_R_DQUOTE] = ACTIONS(2903),
    [anon_sym_LR_DQUOTE] = ACTIONS(2903),
    [anon_sym_uR_DQUOTE] = ACTIONS(2903),
    [anon_sym_UR_DQUOTE] = ACTIONS(2903),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2903),
    [anon_sym_co_await] = ACTIONS(2901),
    [anon_sym_new] = ACTIONS(2901),
    [anon_sym_requires] = ACTIONS(2901),
    [sym_this] = ACTIONS(2901),
    [anon_sym_discard] = ACTIONS(2901),
    [anon_sym_precise] = ACTIONS(2901),
    [anon_sym_shared] = ACTIONS(2901),
    [anon_sym_groupshared] = ACTIONS(2901),
    [anon_sym_uniform] = ACTIONS(2901),
    [anon_sym_row_major] = ACTIONS(2901),
    [anon_sym_column_major] = ACTIONS(2901),
    [anon_sym_globallycoherent] = ACTIONS(2901),
    [anon_sym_centroid] = ACTIONS(2901),
    [anon_sym_noperspective] = ACTIONS(2901),
    [anon_sym_nointerpolation] = ACTIONS(2901),
    [anon_sym_sample] = ACTIONS(2901),
    [anon_sym_linear] = ACTIONS(2901),
    [anon_sym_snorm] = ACTIONS(2901),
    [anon_sym_unorm] = ACTIONS(2901),
    [anon_sym_point] = ACTIONS(2901),
    [anon_sym_line] = ACTIONS(2901),
    [anon_sym_triangleadj] = ACTIONS(2901),
    [anon_sym_lineadj] = ACTIONS(2901),
    [anon_sym_triangle] = ACTIONS(2901),
    [anon_sym_cbuffer] = ACTIONS(2901),
    [anon_sym_interface] = ACTIONS(2901),
    [anon_sym_extension] = ACTIONS(2901),
    [anon_sym___exported] = ACTIONS(2901),
  },
  [268] = {
    [sym_identifier] = ACTIONS(2268),
    [aux_sym_preproc_include_token1] = ACTIONS(2268),
    [aux_sym_preproc_def_token1] = ACTIONS(2268),
    [aux_sym_preproc_if_token1] = ACTIONS(2268),
    [aux_sym_preproc_if_token2] = ACTIONS(2268),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2268),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2268),
    [aux_sym_preproc_else_token1] = ACTIONS(2268),
    [aux_sym_preproc_elif_token1] = ACTIONS(2268),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2268),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2268),
    [sym_preproc_directive] = ACTIONS(2268),
    [anon_sym_LPAREN2] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2270),
    [anon_sym_TILDE] = ACTIONS(2270),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2270),
    [anon_sym_AMP_AMP] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(2268),
    [anon_sym_COLON] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym___extension__] = ACTIONS(2268),
    [anon_sym_typedef] = ACTIONS(2268),
    [anon_sym_in] = ACTIONS(2268),
    [anon_sym_out] = ACTIONS(2268),
    [anon_sym_inout] = ACTIONS(2268),
    [anon_sym_virtual] = ACTIONS(2268),
    [anon_sym_extern] = ACTIONS(2268),
    [anon_sym___attribute__] = ACTIONS(2268),
    [anon_sym___attribute] = ACTIONS(2268),
    [anon_sym_using] = ACTIONS(2268),
    [anon_sym_COLON_COLON] = ACTIONS(2270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2270),
    [anon_sym___declspec] = ACTIONS(2268),
    [anon_sym___based] = ACTIONS(2268),
    [anon_sym___cdecl] = ACTIONS(2268),
    [anon_sym___clrcall] = ACTIONS(2268),
    [anon_sym___stdcall] = ACTIONS(2268),
    [anon_sym___fastcall] = ACTIONS(2268),
    [anon_sym___thiscall] = ACTIONS(2268),
    [anon_sym___vectorcall] = ACTIONS(2268),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_signed] = ACTIONS(2268),
    [anon_sym_unsigned] = ACTIONS(2268),
    [anon_sym_long] = ACTIONS(2268),
    [anon_sym_short] = ACTIONS(2268),
    [anon_sym_LBRACK] = ACTIONS(2268),
    [anon_sym_static] = ACTIONS(2268),
    [anon_sym_register] = ACTIONS(2268),
    [anon_sym_inline] = ACTIONS(2268),
    [anon_sym___inline] = ACTIONS(2268),
    [anon_sym___inline__] = ACTIONS(2268),
    [anon_sym___forceinline] = ACTIONS(2268),
    [anon_sym_thread_local] = ACTIONS(2268),
    [anon_sym___thread] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_constexpr] = ACTIONS(2268),
    [anon_sym_volatile] = ACTIONS(2268),
    [anon_sym_restrict] = ACTIONS(2268),
    [anon_sym___restrict__] = ACTIONS(2268),
    [anon_sym__Atomic] = ACTIONS(2268),
    [anon_sym__Noreturn] = ACTIONS(2268),
    [anon_sym_noreturn] = ACTIONS(2268),
    [anon_sym__Nonnull] = ACTIONS(2268),
    [anon_sym_mutable] = ACTIONS(2268),
    [anon_sym_constinit] = ACTIONS(2268),
    [anon_sym_consteval] = ACTIONS(2268),
    [anon_sym_alignas] = ACTIONS(2268),
    [anon_sym__Alignas] = ACTIONS(2268),
    [sym_primitive_type] = ACTIONS(2268),
    [anon_sym_enum] = ACTIONS(2268),
    [anon_sym_class] = ACTIONS(2268),
    [anon_sym_struct] = ACTIONS(2268),
    [anon_sym_union] = ACTIONS(2268),
    [anon_sym_if] = ACTIONS(2268),
    [anon_sym_else] = ACTIONS(2268),
    [anon_sym_switch] = ACTIONS(2268),
    [anon_sym_case] = ACTIONS(2268),
    [anon_sym_default] = ACTIONS(2268),
    [anon_sym_while] = ACTIONS(2268),
    [anon_sym_do] = ACTIONS(2268),
    [anon_sym_for] = ACTIONS(2268),
    [anon_sym_return] = ACTIONS(2268),
    [anon_sym_break] = ACTIONS(2268),
    [anon_sym_continue] = ACTIONS(2268),
    [anon_sym_goto] = ACTIONS(2268),
    [anon_sym___try] = ACTIONS(2268),
    [anon_sym___leave] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2268),
    [anon_sym_compl] = ACTIONS(2268),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_sizeof] = ACTIONS(2268),
    [anon_sym___alignof__] = ACTIONS(2268),
    [anon_sym___alignof] = ACTIONS(2268),
    [anon_sym__alignof] = ACTIONS(2268),
    [anon_sym_alignof] = ACTIONS(2268),
    [anon_sym__Alignof] = ACTIONS(2268),
    [anon_sym_offsetof] = ACTIONS(2268),
    [anon_sym__Generic] = ACTIONS(2268),
    [anon_sym_asm] = ACTIONS(2268),
    [anon_sym___asm__] = ACTIONS(2268),
    [anon_sym___asm] = ACTIONS(2268),
    [sym_number_literal] = ACTIONS(2270),
    [anon_sym_L_SQUOTE] = ACTIONS(2270),
    [anon_sym_u_SQUOTE] = ACTIONS(2270),
    [anon_sym_U_SQUOTE] = ACTIONS(2270),
    [anon_sym_u8_SQUOTE] = ACTIONS(2270),
    [anon_sym_SQUOTE] = ACTIONS(2270),
    [anon_sym_L_DQUOTE] = ACTIONS(2270),
    [anon_sym_u_DQUOTE] = ACTIONS(2270),
    [anon_sym_U_DQUOTE] = ACTIONS(2270),
    [anon_sym_u8_DQUOTE] = ACTIONS(2270),
    [anon_sym_DQUOTE] = ACTIONS(2270),
    [sym_true] = ACTIONS(2268),
    [sym_false] = ACTIONS(2268),
    [anon_sym_NULL] = ACTIONS(2268),
    [anon_sym_nullptr] = ACTIONS(2268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_This] = ACTIONS(2268),
    [anon_sym_decltype] = ACTIONS(2268),
    [anon_sym_final] = ACTIONS(2268),
    [anon_sym_override] = ACTIONS(2268),
    [anon_sym_explicit] = ACTIONS(2268),
    [anon_sym_typename] = ACTIONS(2268),
    [anon_sym_template] = ACTIONS(2268),
    [anon_sym_operator] = ACTIONS(2268),
    [anon_sym_try] = ACTIONS(2268),
    [anon_sym_delete] = ACTIONS(2268),
    [anon_sym_throw] = ACTIONS(2268),
    [anon_sym_namespace] = ACTIONS(2268),
    [anon_sym_static_assert] = ACTIONS(2268),
    [anon_sym_concept] = ACTIONS(2268),
    [anon_sym_co_return] = ACTIONS(2268),
    [anon_sym_co_yield] = ACTIONS(2268),
    [anon_sym_R_DQUOTE] = ACTIONS(2270),
    [anon_sym_LR_DQUOTE] = ACTIONS(2270),
    [anon_sym_uR_DQUOTE] = ACTIONS(2270),
    [anon_sym_UR_DQUOTE] = ACTIONS(2270),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2270),
    [anon_sym_co_await] = ACTIONS(2268),
    [anon_sym_new] = ACTIONS(2268),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2268),
    [anon_sym_discard] = ACTIONS(2268),
    [anon_sym_precise] = ACTIONS(2268),
    [anon_sym_shared] = ACTIONS(2268),
    [anon_sym_groupshared] = ACTIONS(2268),
    [anon_sym_uniform] = ACTIONS(2268),
    [anon_sym_row_major] = ACTIONS(2268),
    [anon_sym_column_major] = ACTIONS(2268),
    [anon_sym_globallycoherent] = ACTIONS(2268),
    [anon_sym_centroid] = ACTIONS(2268),
    [anon_sym_noperspective] = ACTIONS(2268),
    [anon_sym_nointerpolation] = ACTIONS(2268),
    [anon_sym_sample] = ACTIONS(2268),
    [anon_sym_linear] = ACTIONS(2268),
    [anon_sym_snorm] = ACTIONS(2268),
    [anon_sym_unorm] = ACTIONS(2268),
    [anon_sym_point] = ACTIONS(2268),
    [anon_sym_line] = ACTIONS(2268),
    [anon_sym_triangleadj] = ACTIONS(2268),
    [anon_sym_lineadj] = ACTIONS(2268),
    [anon_sym_triangle] = ACTIONS(2268),
    [anon_sym_cbuffer] = ACTIONS(2268),
    [anon_sym_interface] = ACTIONS(2268),
    [anon_sym_extension] = ACTIONS(2268),
  },
  [269] = {
    [sym_identifier] = ACTIONS(2272),
    [aux_sym_preproc_include_token1] = ACTIONS(2272),
    [aux_sym_preproc_def_token1] = ACTIONS(2272),
    [aux_sym_preproc_if_token1] = ACTIONS(2272),
    [aux_sym_preproc_if_token2] = ACTIONS(2272),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2272),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2272),
    [aux_sym_preproc_else_token1] = ACTIONS(2272),
    [aux_sym_preproc_elif_token1] = ACTIONS(2272),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2272),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2272),
    [sym_preproc_directive] = ACTIONS(2272),
    [anon_sym_LPAREN2] = ACTIONS(2274),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2274),
    [anon_sym_AMP_AMP] = ACTIONS(2274),
    [anon_sym_AMP] = ACTIONS(2272),
    [anon_sym_COLON] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym___extension__] = ACTIONS(2272),
    [anon_sym_typedef] = ACTIONS(2272),
    [anon_sym_in] = ACTIONS(2272),
    [anon_sym_out] = ACTIONS(2272),
    [anon_sym_inout] = ACTIONS(2272),
    [anon_sym_virtual] = ACTIONS(2272),
    [anon_sym_extern] = ACTIONS(2272),
    [anon_sym___attribute__] = ACTIONS(2272),
    [anon_sym___attribute] = ACTIONS(2272),
    [anon_sym_using] = ACTIONS(2272),
    [anon_sym_COLON_COLON] = ACTIONS(2274),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2274),
    [anon_sym___declspec] = ACTIONS(2272),
    [anon_sym___based] = ACTIONS(2272),
    [anon_sym___cdecl] = ACTIONS(2272),
    [anon_sym___clrcall] = ACTIONS(2272),
    [anon_sym___stdcall] = ACTIONS(2272),
    [anon_sym___fastcall] = ACTIONS(2272),
    [anon_sym___thiscall] = ACTIONS(2272),
    [anon_sym___vectorcall] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_signed] = ACTIONS(2272),
    [anon_sym_unsigned] = ACTIONS(2272),
    [anon_sym_long] = ACTIONS(2272),
    [anon_sym_short] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_register] = ACTIONS(2272),
    [anon_sym_inline] = ACTIONS(2272),
    [anon_sym___inline] = ACTIONS(2272),
    [anon_sym___inline__] = ACTIONS(2272),
    [anon_sym___forceinline] = ACTIONS(2272),
    [anon_sym_thread_local] = ACTIONS(2272),
    [anon_sym___thread] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_constexpr] = ACTIONS(2272),
    [anon_sym_volatile] = ACTIONS(2272),
    [anon_sym_restrict] = ACTIONS(2272),
    [anon_sym___restrict__] = ACTIONS(2272),
    [anon_sym__Atomic] = ACTIONS(2272),
    [anon_sym__Noreturn] = ACTIONS(2272),
    [anon_sym_noreturn] = ACTIONS(2272),
    [anon_sym__Nonnull] = ACTIONS(2272),
    [anon_sym_mutable] = ACTIONS(2272),
    [anon_sym_constinit] = ACTIONS(2272),
    [anon_sym_consteval] = ACTIONS(2272),
    [anon_sym_alignas] = ACTIONS(2272),
    [anon_sym__Alignas] = ACTIONS(2272),
    [sym_primitive_type] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_struct] = ACTIONS(2272),
    [anon_sym_union] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_else] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_case] = ACTIONS(2272),
    [anon_sym_default] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_goto] = ACTIONS(2272),
    [anon_sym___try] = ACTIONS(2272),
    [anon_sym___leave] = ACTIONS(2272),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_compl] = ACTIONS(2272),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_sizeof] = ACTIONS(2272),
    [anon_sym___alignof__] = ACTIONS(2272),
    [anon_sym___alignof] = ACTIONS(2272),
    [anon_sym__alignof] = ACTIONS(2272),
    [anon_sym_alignof] = ACTIONS(2272),
    [anon_sym__Alignof] = ACTIONS(2272),
    [anon_sym_offsetof] = ACTIONS(2272),
    [anon_sym__Generic] = ACTIONS(2272),
    [anon_sym_asm] = ACTIONS(2272),
    [anon_sym___asm__] = ACTIONS(2272),
    [anon_sym___asm] = ACTIONS(2272),
    [sym_number_literal] = ACTIONS(2274),
    [anon_sym_L_SQUOTE] = ACTIONS(2274),
    [anon_sym_u_SQUOTE] = ACTIONS(2274),
    [anon_sym_U_SQUOTE] = ACTIONS(2274),
    [anon_sym_u8_SQUOTE] = ACTIONS(2274),
    [anon_sym_SQUOTE] = ACTIONS(2274),
    [anon_sym_L_DQUOTE] = ACTIONS(2274),
    [anon_sym_u_DQUOTE] = ACTIONS(2274),
    [anon_sym_U_DQUOTE] = ACTIONS(2274),
    [anon_sym_u8_DQUOTE] = ACTIONS(2274),
    [anon_sym_DQUOTE] = ACTIONS(2274),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [anon_sym_NULL] = ACTIONS(2272),
    [anon_sym_nullptr] = ACTIONS(2272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_This] = ACTIONS(2272),
    [anon_sym_decltype] = ACTIONS(2272),
    [anon_sym_final] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_explicit] = ACTIONS(2272),
    [anon_sym_typename] = ACTIONS(2272),
    [anon_sym_template] = ACTIONS(2272),
    [anon_sym_operator] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_namespace] = ACTIONS(2272),
    [anon_sym_static_assert] = ACTIONS(2272),
    [anon_sym_concept] = ACTIONS(2272),
    [anon_sym_co_return] = ACTIONS(2272),
    [anon_sym_co_yield] = ACTIONS(2272),
    [anon_sym_R_DQUOTE] = ACTIONS(2274),
    [anon_sym_LR_DQUOTE] = ACTIONS(2274),
    [anon_sym_uR_DQUOTE] = ACTIONS(2274),
    [anon_sym_UR_DQUOTE] = ACTIONS(2274),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2274),
    [anon_sym_co_await] = ACTIONS(2272),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_requires] = ACTIONS(2272),
    [sym_this] = ACTIONS(2272),
    [anon_sym_discard] = ACTIONS(2272),
    [anon_sym_precise] = ACTIONS(2272),
    [anon_sym_shared] = ACTIONS(2272),
    [anon_sym_groupshared] = ACTIONS(2272),
    [anon_sym_uniform] = ACTIONS(2272),
    [anon_sym_row_major] = ACTIONS(2272),
    [anon_sym_column_major] = ACTIONS(2272),
    [anon_sym_globallycoherent] = ACTIONS(2272),
    [anon_sym_centroid] = ACTIONS(2272),
    [anon_sym_noperspective] = ACTIONS(2272),
    [anon_sym_nointerpolation] = ACTIONS(2272),
    [anon_sym_sample] = ACTIONS(2272),
    [anon_sym_linear] = ACTIONS(2272),
    [anon_sym_snorm] = ACTIONS(2272),
    [anon_sym_unorm] = ACTIONS(2272),
    [anon_sym_point] = ACTIONS(2272),
    [anon_sym_line] = ACTIONS(2272),
    [anon_sym_triangleadj] = ACTIONS(2272),
    [anon_sym_lineadj] = ACTIONS(2272),
    [anon_sym_triangle] = ACTIONS(2272),
    [anon_sym_cbuffer] = ACTIONS(2272),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_extension] = ACTIONS(2272),
  },
  [270] = {
    [sym_identifier] = ACTIONS(2276),
    [aux_sym_preproc_include_token1] = ACTIONS(2276),
    [aux_sym_preproc_def_token1] = ACTIONS(2276),
    [aux_sym_preproc_if_token1] = ACTIONS(2276),
    [aux_sym_preproc_if_token2] = ACTIONS(2276),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2276),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2276),
    [aux_sym_preproc_else_token1] = ACTIONS(2276),
    [aux_sym_preproc_elif_token1] = ACTIONS(2276),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2276),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2276),
    [sym_preproc_directive] = ACTIONS(2276),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_PLUS] = ACTIONS(2276),
    [anon_sym_STAR] = ACTIONS(2278),
    [anon_sym_AMP_AMP] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_COLON] = ACTIONS(2276),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym___extension__] = ACTIONS(2276),
    [anon_sym_typedef] = ACTIONS(2276),
    [anon_sym_in] = ACTIONS(2276),
    [anon_sym_out] = ACTIONS(2276),
    [anon_sym_inout] = ACTIONS(2276),
    [anon_sym_virtual] = ACTIONS(2276),
    [anon_sym_extern] = ACTIONS(2276),
    [anon_sym___attribute__] = ACTIONS(2276),
    [anon_sym___attribute] = ACTIONS(2276),
    [anon_sym_using] = ACTIONS(2276),
    [anon_sym_COLON_COLON] = ACTIONS(2278),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2278),
    [anon_sym___declspec] = ACTIONS(2276),
    [anon_sym___based] = ACTIONS(2276),
    [anon_sym___cdecl] = ACTIONS(2276),
    [anon_sym___clrcall] = ACTIONS(2276),
    [anon_sym___stdcall] = ACTIONS(2276),
    [anon_sym___fastcall] = ACTIONS(2276),
    [anon_sym___thiscall] = ACTIONS(2276),
    [anon_sym___vectorcall] = ACTIONS(2276),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_signed] = ACTIONS(2276),
    [anon_sym_unsigned] = ACTIONS(2276),
    [anon_sym_long] = ACTIONS(2276),
    [anon_sym_short] = ACTIONS(2276),
    [anon_sym_LBRACK] = ACTIONS(2276),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_register] = ACTIONS(2276),
    [anon_sym_inline] = ACTIONS(2276),
    [anon_sym___inline] = ACTIONS(2276),
    [anon_sym___inline__] = ACTIONS(2276),
    [anon_sym___forceinline] = ACTIONS(2276),
    [anon_sym_thread_local] = ACTIONS(2276),
    [anon_sym___thread] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_constexpr] = ACTIONS(2276),
    [anon_sym_volatile] = ACTIONS(2276),
    [anon_sym_restrict] = ACTIONS(2276),
    [anon_sym___restrict__] = ACTIONS(2276),
    [anon_sym__Atomic] = ACTIONS(2276),
    [anon_sym__Noreturn] = ACTIONS(2276),
    [anon_sym_noreturn] = ACTIONS(2276),
    [anon_sym__Nonnull] = ACTIONS(2276),
    [anon_sym_mutable] = ACTIONS(2276),
    [anon_sym_constinit] = ACTIONS(2276),
    [anon_sym_consteval] = ACTIONS(2276),
    [anon_sym_alignas] = ACTIONS(2276),
    [anon_sym__Alignas] = ACTIONS(2276),
    [sym_primitive_type] = ACTIONS(2276),
    [anon_sym_enum] = ACTIONS(2276),
    [anon_sym_class] = ACTIONS(2276),
    [anon_sym_struct] = ACTIONS(2276),
    [anon_sym_union] = ACTIONS(2276),
    [anon_sym_if] = ACTIONS(2276),
    [anon_sym_else] = ACTIONS(2276),
    [anon_sym_switch] = ACTIONS(2276),
    [anon_sym_case] = ACTIONS(2276),
    [anon_sym_default] = ACTIONS(2276),
    [anon_sym_while] = ACTIONS(2276),
    [anon_sym_do] = ACTIONS(2276),
    [anon_sym_for] = ACTIONS(2276),
    [anon_sym_return] = ACTIONS(2276),
    [anon_sym_break] = ACTIONS(2276),
    [anon_sym_continue] = ACTIONS(2276),
    [anon_sym_goto] = ACTIONS(2276),
    [anon_sym___try] = ACTIONS(2276),
    [anon_sym___leave] = ACTIONS(2276),
    [anon_sym_not] = ACTIONS(2276),
    [anon_sym_compl] = ACTIONS(2276),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_sizeof] = ACTIONS(2276),
    [anon_sym___alignof__] = ACTIONS(2276),
    [anon_sym___alignof] = ACTIONS(2276),
    [anon_sym__alignof] = ACTIONS(2276),
    [anon_sym_alignof] = ACTIONS(2276),
    [anon_sym__Alignof] = ACTIONS(2276),
    [anon_sym_offsetof] = ACTIONS(2276),
    [anon_sym__Generic] = ACTIONS(2276),
    [anon_sym_asm] = ACTIONS(2276),
    [anon_sym___asm__] = ACTIONS(2276),
    [anon_sym___asm] = ACTIONS(2276),
    [sym_number_literal] = ACTIONS(2278),
    [anon_sym_L_SQUOTE] = ACTIONS(2278),
    [anon_sym_u_SQUOTE] = ACTIONS(2278),
    [anon_sym_U_SQUOTE] = ACTIONS(2278),
    [anon_sym_u8_SQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_L_DQUOTE] = ACTIONS(2278),
    [anon_sym_u_DQUOTE] = ACTIONS(2278),
    [anon_sym_U_DQUOTE] = ACTIONS(2278),
    [anon_sym_u8_DQUOTE] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [sym_true] = ACTIONS(2276),
    [sym_false] = ACTIONS(2276),
    [anon_sym_NULL] = ACTIONS(2276),
    [anon_sym_nullptr] = ACTIONS(2276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_This] = ACTIONS(2276),
    [anon_sym_decltype] = ACTIONS(2276),
    [anon_sym_final] = ACTIONS(2276),
    [anon_sym_override] = ACTIONS(2276),
    [anon_sym_explicit] = ACTIONS(2276),
    [anon_sym_typename] = ACTIONS(2276),
    [anon_sym_template] = ACTIONS(2276),
    [anon_sym_operator] = ACTIONS(2276),
    [anon_sym_try] = ACTIONS(2276),
    [anon_sym_delete] = ACTIONS(2276),
    [anon_sym_throw] = ACTIONS(2276),
    [anon_sym_namespace] = ACTIONS(2276),
    [anon_sym_static_assert] = ACTIONS(2276),
    [anon_sym_concept] = ACTIONS(2276),
    [anon_sym_co_return] = ACTIONS(2276),
    [anon_sym_co_yield] = ACTIONS(2276),
    [anon_sym_R_DQUOTE] = ACTIONS(2278),
    [anon_sym_LR_DQUOTE] = ACTIONS(2278),
    [anon_sym_uR_DQUOTE] = ACTIONS(2278),
    [anon_sym_UR_DQUOTE] = ACTIONS(2278),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2278),
    [anon_sym_co_await] = ACTIONS(2276),
    [anon_sym_new] = ACTIONS(2276),
    [anon_sym_requires] = ACTIONS(2276),
    [sym_this] = ACTIONS(2276),
    [anon_sym_discard] = ACTIONS(2276),
    [anon_sym_precise] = ACTIONS(2276),
    [anon_sym_shared] = ACTIONS(2276),
    [anon_sym_groupshared] = ACTIONS(2276),
    [anon_sym_uniform] = ACTIONS(2276),
    [anon_sym_row_major] = ACTIONS(2276),
    [anon_sym_column_major] = ACTIONS(2276),
    [anon_sym_globallycoherent] = ACTIONS(2276),
    [anon_sym_centroid] = ACTIONS(2276),
    [anon_sym_noperspective] = ACTIONS(2276),
    [anon_sym_nointerpolation] = ACTIONS(2276),
    [anon_sym_sample] = ACTIONS(2276),
    [anon_sym_linear] = ACTIONS(2276),
    [anon_sym_snorm] = ACTIONS(2276),
    [anon_sym_unorm] = ACTIONS(2276),
    [anon_sym_point] = ACTIONS(2276),
    [anon_sym_line] = ACTIONS(2276),
    [anon_sym_triangleadj] = ACTIONS(2276),
    [anon_sym_lineadj] = ACTIONS(2276),
    [anon_sym_triangle] = ACTIONS(2276),
    [anon_sym_cbuffer] = ACTIONS(2276),
    [anon_sym_interface] = ACTIONS(2276),
    [anon_sym_extension] = ACTIONS(2276),
  },
  [271] = {
    [sym_identifier] = ACTIONS(2239),
    [aux_sym_preproc_include_token1] = ACTIONS(2239),
    [aux_sym_preproc_def_token1] = ACTIONS(2239),
    [aux_sym_preproc_if_token1] = ACTIONS(2239),
    [aux_sym_preproc_if_token2] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2239),
    [aux_sym_preproc_else_token1] = ACTIONS(2239),
    [aux_sym_preproc_elif_token1] = ACTIONS(2239),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2239),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2239),
    [sym_preproc_directive] = ACTIONS(2239),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2239),
    [anon_sym_PLUS] = ACTIONS(2239),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_COLON] = ACTIONS(2239),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym_typedef] = ACTIONS(2239),
    [anon_sym_in] = ACTIONS(2239),
    [anon_sym_out] = ACTIONS(2239),
    [anon_sym_inout] = ACTIONS(2239),
    [anon_sym_virtual] = ACTIONS(2239),
    [anon_sym_extern] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym___attribute] = ACTIONS(2239),
    [anon_sym_using] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2241),
    [anon_sym___declspec] = ACTIONS(2239),
    [anon_sym___based] = ACTIONS(2239),
    [anon_sym___cdecl] = ACTIONS(2239),
    [anon_sym___clrcall] = ACTIONS(2239),
    [anon_sym___stdcall] = ACTIONS(2239),
    [anon_sym___fastcall] = ACTIONS(2239),
    [anon_sym___thiscall] = ACTIONS(2239),
    [anon_sym___vectorcall] = ACTIONS(2239),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_signed] = ACTIONS(2239),
    [anon_sym_unsigned] = ACTIONS(2239),
    [anon_sym_long] = ACTIONS(2239),
    [anon_sym_short] = ACTIONS(2239),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2239),
    [anon_sym_register] = ACTIONS(2239),
    [anon_sym_inline] = ACTIONS(2239),
    [anon_sym___inline] = ACTIONS(2239),
    [anon_sym___inline__] = ACTIONS(2239),
    [anon_sym___forceinline] = ACTIONS(2239),
    [anon_sym_thread_local] = ACTIONS(2239),
    [anon_sym___thread] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym__Nonnull] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [sym_primitive_type] = ACTIONS(2239),
    [anon_sym_enum] = ACTIONS(2239),
    [anon_sym_class] = ACTIONS(2239),
    [anon_sym_struct] = ACTIONS(2239),
    [anon_sym_union] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(2239),
    [anon_sym_else] = ACTIONS(2239),
    [anon_sym_switch] = ACTIONS(2239),
    [anon_sym_case] = ACTIONS(2239),
    [anon_sym_default] = ACTIONS(2239),
    [anon_sym_while] = ACTIONS(2239),
    [anon_sym_do] = ACTIONS(2239),
    [anon_sym_for] = ACTIONS(2239),
    [anon_sym_return] = ACTIONS(2239),
    [anon_sym_break] = ACTIONS(2239),
    [anon_sym_continue] = ACTIONS(2239),
    [anon_sym_goto] = ACTIONS(2239),
    [anon_sym___try] = ACTIONS(2239),
    [anon_sym___leave] = ACTIONS(2239),
    [anon_sym_not] = ACTIONS(2239),
    [anon_sym_compl] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_sizeof] = ACTIONS(2239),
    [anon_sym___alignof__] = ACTIONS(2239),
    [anon_sym___alignof] = ACTIONS(2239),
    [anon_sym__alignof] = ACTIONS(2239),
    [anon_sym_alignof] = ACTIONS(2239),
    [anon_sym__Alignof] = ACTIONS(2239),
    [anon_sym_offsetof] = ACTIONS(2239),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2239),
    [anon_sym___asm__] = ACTIONS(2239),
    [anon_sym___asm] = ACTIONS(2239),
    [sym_number_literal] = ACTIONS(2241),
    [anon_sym_L_SQUOTE] = ACTIONS(2241),
    [anon_sym_u_SQUOTE] = ACTIONS(2241),
    [anon_sym_U_SQUOTE] = ACTIONS(2241),
    [anon_sym_u8_SQUOTE] = ACTIONS(2241),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_L_DQUOTE] = ACTIONS(2241),
    [anon_sym_u_DQUOTE] = ACTIONS(2241),
    [anon_sym_U_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8_DQUOTE] = ACTIONS(2241),
    [anon_sym_DQUOTE] = ACTIONS(2241),
    [sym_true] = ACTIONS(2239),
    [sym_false] = ACTIONS(2239),
    [anon_sym_NULL] = ACTIONS(2239),
    [anon_sym_nullptr] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2239),
    [anon_sym_let] = ACTIONS(2239),
    [anon_sym_This] = ACTIONS(2239),
    [anon_sym_decltype] = ACTIONS(2239),
    [anon_sym_final] = ACTIONS(2239),
    [anon_sym_override] = ACTIONS(2239),
    [anon_sym_explicit] = ACTIONS(2239),
    [anon_sym_typename] = ACTIONS(2239),
    [anon_sym_template] = ACTIONS(2239),
    [anon_sym_operator] = ACTIONS(2239),
    [anon_sym_try] = ACTIONS(2239),
    [anon_sym_delete] = ACTIONS(2239),
    [anon_sym_throw] = ACTIONS(2239),
    [anon_sym_namespace] = ACTIONS(2239),
    [anon_sym_static_assert] = ACTIONS(2239),
    [anon_sym_concept] = ACTIONS(2239),
    [anon_sym_co_return] = ACTIONS(2239),
    [anon_sym_co_yield] = ACTIONS(2239),
    [anon_sym_R_DQUOTE] = ACTIONS(2241),
    [anon_sym_LR_DQUOTE] = ACTIONS(2241),
    [anon_sym_uR_DQUOTE] = ACTIONS(2241),
    [anon_sym_UR_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2241),
    [anon_sym_co_await] = ACTIONS(2239),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_requires] = ACTIONS(2239),
    [sym_this] = ACTIONS(2239),
    [anon_sym_discard] = ACTIONS(2239),
    [anon_sym_precise] = ACTIONS(2239),
    [anon_sym_shared] = ACTIONS(2239),
    [anon_sym_groupshared] = ACTIONS(2239),
    [anon_sym_uniform] = ACTIONS(2239),
    [anon_sym_row_major] = ACTIONS(2239),
    [anon_sym_column_major] = ACTIONS(2239),
    [anon_sym_globallycoherent] = ACTIONS(2239),
    [anon_sym_centroid] = ACTIONS(2239),
    [anon_sym_noperspective] = ACTIONS(2239),
    [anon_sym_nointerpolation] = ACTIONS(2239),
    [anon_sym_sample] = ACTIONS(2239),
    [anon_sym_linear] = ACTIONS(2239),
    [anon_sym_snorm] = ACTIONS(2239),
    [anon_sym_unorm] = ACTIONS(2239),
    [anon_sym_point] = ACTIONS(2239),
    [anon_sym_line] = ACTIONS(2239),
    [anon_sym_triangleadj] = ACTIONS(2239),
    [anon_sym_lineadj] = ACTIONS(2239),
    [anon_sym_triangle] = ACTIONS(2239),
    [anon_sym_cbuffer] = ACTIONS(2239),
    [anon_sym_interface] = ACTIONS(2239),
    [anon_sym_extension] = ACTIONS(2239),
  },
  [272] = {
    [sym_identifier] = ACTIONS(2280),
    [aux_sym_preproc_include_token1] = ACTIONS(2280),
    [aux_sym_preproc_def_token1] = ACTIONS(2280),
    [aux_sym_preproc_if_token1] = ACTIONS(2280),
    [aux_sym_preproc_if_token2] = ACTIONS(2280),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2280),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2280),
    [aux_sym_preproc_else_token1] = ACTIONS(2280),
    [aux_sym_preproc_elif_token1] = ACTIONS(2280),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2280),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2280),
    [sym_preproc_directive] = ACTIONS(2280),
    [anon_sym_LPAREN2] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(2282),
    [anon_sym_TILDE] = ACTIONS(2282),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2282),
    [anon_sym_AMP_AMP] = ACTIONS(2282),
    [anon_sym_AMP] = ACTIONS(2280),
    [anon_sym_COLON] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(2280),
    [anon_sym_typedef] = ACTIONS(2280),
    [anon_sym_in] = ACTIONS(2280),
    [anon_sym_out] = ACTIONS(2280),
    [anon_sym_inout] = ACTIONS(2280),
    [anon_sym_virtual] = ACTIONS(2280),
    [anon_sym_extern] = ACTIONS(2280),
    [anon_sym___attribute__] = ACTIONS(2280),
    [anon_sym___attribute] = ACTIONS(2280),
    [anon_sym_using] = ACTIONS(2280),
    [anon_sym_COLON_COLON] = ACTIONS(2282),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2282),
    [anon_sym___declspec] = ACTIONS(2280),
    [anon_sym___based] = ACTIONS(2280),
    [anon_sym___cdecl] = ACTIONS(2280),
    [anon_sym___clrcall] = ACTIONS(2280),
    [anon_sym___stdcall] = ACTIONS(2280),
    [anon_sym___fastcall] = ACTIONS(2280),
    [anon_sym___thiscall] = ACTIONS(2280),
    [anon_sym___vectorcall] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_signed] = ACTIONS(2280),
    [anon_sym_unsigned] = ACTIONS(2280),
    [anon_sym_long] = ACTIONS(2280),
    [anon_sym_short] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_register] = ACTIONS(2280),
    [anon_sym_inline] = ACTIONS(2280),
    [anon_sym___inline] = ACTIONS(2280),
    [anon_sym___inline__] = ACTIONS(2280),
    [anon_sym___forceinline] = ACTIONS(2280),
    [anon_sym_thread_local] = ACTIONS(2280),
    [anon_sym___thread] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_constexpr] = ACTIONS(2280),
    [anon_sym_volatile] = ACTIONS(2280),
    [anon_sym_restrict] = ACTIONS(2280),
    [anon_sym___restrict__] = ACTIONS(2280),
    [anon_sym__Atomic] = ACTIONS(2280),
    [anon_sym__Noreturn] = ACTIONS(2280),
    [anon_sym_noreturn] = ACTIONS(2280),
    [anon_sym__Nonnull] = ACTIONS(2280),
    [anon_sym_mutable] = ACTIONS(2280),
    [anon_sym_constinit] = ACTIONS(2280),
    [anon_sym_consteval] = ACTIONS(2280),
    [anon_sym_alignas] = ACTIONS(2280),
    [anon_sym__Alignas] = ACTIONS(2280),
    [sym_primitive_type] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_struct] = ACTIONS(2280),
    [anon_sym_union] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_goto] = ACTIONS(2280),
    [anon_sym___try] = ACTIONS(2280),
    [anon_sym___leave] = ACTIONS(2280),
    [anon_sym_not] = ACTIONS(2280),
    [anon_sym_compl] = ACTIONS(2280),
    [anon_sym_DASH_DASH] = ACTIONS(2282),
    [anon_sym_PLUS_PLUS] = ACTIONS(2282),
    [anon_sym_sizeof] = ACTIONS(2280),
    [anon_sym___alignof__] = ACTIONS(2280),
    [anon_sym___alignof] = ACTIONS(2280),
    [anon_sym__alignof] = ACTIONS(2280),
    [anon_sym_alignof] = ACTIONS(2280),
    [anon_sym__Alignof] = ACTIONS(2280),
    [anon_sym_offsetof] = ACTIONS(2280),
    [anon_sym__Generic] = ACTIONS(2280),
    [anon_sym_asm] = ACTIONS(2280),
    [anon_sym___asm__] = ACTIONS(2280),
    [anon_sym___asm] = ACTIONS(2280),
    [sym_number_literal] = ACTIONS(2282),
    [anon_sym_L_SQUOTE] = ACTIONS(2282),
    [anon_sym_u_SQUOTE] = ACTIONS(2282),
    [anon_sym_U_SQUOTE] = ACTIONS(2282),
    [anon_sym_u8_SQUOTE] = ACTIONS(2282),
    [anon_sym_SQUOTE] = ACTIONS(2282),
    [anon_sym_L_DQUOTE] = ACTIONS(2282),
    [anon_sym_u_DQUOTE] = ACTIONS(2282),
    [anon_sym_U_DQUOTE] = ACTIONS(2282),
    [anon_sym_u8_DQUOTE] = ACTIONS(2282),
    [anon_sym_DQUOTE] = ACTIONS(2282),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [anon_sym_NULL] = ACTIONS(2280),
    [anon_sym_nullptr] = ACTIONS(2280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_This] = ACTIONS(2280),
    [anon_sym_decltype] = ACTIONS(2280),
    [anon_sym_final] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_explicit] = ACTIONS(2280),
    [anon_sym_typename] = ACTIONS(2280),
    [anon_sym_template] = ACTIONS(2280),
    [anon_sym_operator] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_static_assert] = ACTIONS(2280),
    [anon_sym_concept] = ACTIONS(2280),
    [anon_sym_co_return] = ACTIONS(2280),
    [anon_sym_co_yield] = ACTIONS(2280),
    [anon_sym_R_DQUOTE] = ACTIONS(2282),
    [anon_sym_LR_DQUOTE] = ACTIONS(2282),
    [anon_sym_uR_DQUOTE] = ACTIONS(2282),
    [anon_sym_UR_DQUOTE] = ACTIONS(2282),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2282),
    [anon_sym_co_await] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_requires] = ACTIONS(2280),
    [sym_this] = ACTIONS(2280),
    [anon_sym_discard] = ACTIONS(2280),
    [anon_sym_precise] = ACTIONS(2280),
    [anon_sym_shared] = ACTIONS(2280),
    [anon_sym_groupshared] = ACTIONS(2280),
    [anon_sym_uniform] = ACTIONS(2280),
    [anon_sym_row_major] = ACTIONS(2280),
    [anon_sym_column_major] = ACTIONS(2280),
    [anon_sym_globallycoherent] = ACTIONS(2280),
    [anon_sym_centroid] = ACTIONS(2280),
    [anon_sym_noperspective] = ACTIONS(2280),
    [anon_sym_nointerpolation] = ACTIONS(2280),
    [anon_sym_sample] = ACTIONS(2280),
    [anon_sym_linear] = ACTIONS(2280),
    [anon_sym_snorm] = ACTIONS(2280),
    [anon_sym_unorm] = ACTIONS(2280),
    [anon_sym_point] = ACTIONS(2280),
    [anon_sym_line] = ACTIONS(2280),
    [anon_sym_triangleadj] = ACTIONS(2280),
    [anon_sym_lineadj] = ACTIONS(2280),
    [anon_sym_triangle] = ACTIONS(2280),
    [anon_sym_cbuffer] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_extension] = ACTIONS(2280),
  },
  [273] = {
    [sym_identifier] = ACTIONS(2284),
    [aux_sym_preproc_include_token1] = ACTIONS(2284),
    [aux_sym_preproc_def_token1] = ACTIONS(2284),
    [aux_sym_preproc_if_token1] = ACTIONS(2284),
    [aux_sym_preproc_if_token2] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2284),
    [aux_sym_preproc_else_token1] = ACTIONS(2284),
    [aux_sym_preproc_elif_token1] = ACTIONS(2284),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2284),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2284),
    [sym_preproc_directive] = ACTIONS(2284),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_COLON] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_typedef] = ACTIONS(2284),
    [anon_sym_in] = ACTIONS(2284),
    [anon_sym_out] = ACTIONS(2284),
    [anon_sym_inout] = ACTIONS(2284),
    [anon_sym_virtual] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_using] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym___cdecl] = ACTIONS(2284),
    [anon_sym___clrcall] = ACTIONS(2284),
    [anon_sym___stdcall] = ACTIONS(2284),
    [anon_sym___fastcall] = ACTIONS(2284),
    [anon_sym___thiscall] = ACTIONS(2284),
    [anon_sym___vectorcall] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_signed] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_else] = ACTIONS(2284),
    [anon_sym_switch] = ACTIONS(2284),
    [anon_sym_case] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_goto] = ACTIONS(2284),
    [anon_sym___try] = ACTIONS(2284),
    [anon_sym___leave] = ACTIONS(2284),
    [anon_sym_not] = ACTIONS(2284),
    [anon_sym_compl] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_sizeof] = ACTIONS(2284),
    [anon_sym___alignof__] = ACTIONS(2284),
    [anon_sym___alignof] = ACTIONS(2284),
    [anon_sym__alignof] = ACTIONS(2284),
    [anon_sym_alignof] = ACTIONS(2284),
    [anon_sym__Alignof] = ACTIONS(2284),
    [anon_sym_offsetof] = ACTIONS(2284),
    [anon_sym__Generic] = ACTIONS(2284),
    [anon_sym_asm] = ACTIONS(2284),
    [anon_sym___asm__] = ACTIONS(2284),
    [anon_sym___asm] = ACTIONS(2284),
    [sym_number_literal] = ACTIONS(2286),
    [anon_sym_L_SQUOTE] = ACTIONS(2286),
    [anon_sym_u_SQUOTE] = ACTIONS(2286),
    [anon_sym_U_SQUOTE] = ACTIONS(2286),
    [anon_sym_u8_SQUOTE] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_L_DQUOTE] = ACTIONS(2286),
    [anon_sym_u_DQUOTE] = ACTIONS(2286),
    [anon_sym_U_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8_DQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [sym_true] = ACTIONS(2284),
    [sym_false] = ACTIONS(2284),
    [anon_sym_NULL] = ACTIONS(2284),
    [anon_sym_nullptr] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_This] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [anon_sym_final] = ACTIONS(2284),
    [anon_sym_override] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_typename] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_delete] = ACTIONS(2284),
    [anon_sym_throw] = ACTIONS(2284),
    [anon_sym_namespace] = ACTIONS(2284),
    [anon_sym_static_assert] = ACTIONS(2284),
    [anon_sym_concept] = ACTIONS(2284),
    [anon_sym_co_return] = ACTIONS(2284),
    [anon_sym_co_yield] = ACTIONS(2284),
    [anon_sym_R_DQUOTE] = ACTIONS(2286),
    [anon_sym_LR_DQUOTE] = ACTIONS(2286),
    [anon_sym_uR_DQUOTE] = ACTIONS(2286),
    [anon_sym_UR_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2286),
    [anon_sym_co_await] = ACTIONS(2284),
    [anon_sym_new] = ACTIONS(2284),
    [anon_sym_requires] = ACTIONS(2284),
    [sym_this] = ACTIONS(2284),
    [anon_sym_discard] = ACTIONS(2284),
    [anon_sym_precise] = ACTIONS(2284),
    [anon_sym_shared] = ACTIONS(2284),
    [anon_sym_groupshared] = ACTIONS(2284),
    [anon_sym_uniform] = ACTIONS(2284),
    [anon_sym_row_major] = ACTIONS(2284),
    [anon_sym_column_major] = ACTIONS(2284),
    [anon_sym_globallycoherent] = ACTIONS(2284),
    [anon_sym_centroid] = ACTIONS(2284),
    [anon_sym_noperspective] = ACTIONS(2284),
    [anon_sym_nointerpolation] = ACTIONS(2284),
    [anon_sym_sample] = ACTIONS(2284),
    [anon_sym_linear] = ACTIONS(2284),
    [anon_sym_snorm] = ACTIONS(2284),
    [anon_sym_unorm] = ACTIONS(2284),
    [anon_sym_point] = ACTIONS(2284),
    [anon_sym_line] = ACTIONS(2284),
    [anon_sym_triangleadj] = ACTIONS(2284),
    [anon_sym_lineadj] = ACTIONS(2284),
    [anon_sym_triangle] = ACTIONS(2284),
    [anon_sym_cbuffer] = ACTIONS(2284),
    [anon_sym_interface] = ACTIONS(2284),
    [anon_sym_extension] = ACTIONS(2284),
  },
  [274] = {
    [sym_identifier] = ACTIONS(2288),
    [aux_sym_preproc_include_token1] = ACTIONS(2288),
    [aux_sym_preproc_def_token1] = ACTIONS(2288),
    [aux_sym_preproc_if_token1] = ACTIONS(2288),
    [aux_sym_preproc_if_token2] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2288),
    [aux_sym_preproc_else_token1] = ACTIONS(2288),
    [aux_sym_preproc_elif_token1] = ACTIONS(2288),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2288),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_COLON] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_out] = ACTIONS(2288),
    [anon_sym_inout] = ACTIONS(2288),
    [anon_sym_virtual] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym___cdecl] = ACTIONS(2288),
    [anon_sym___clrcall] = ACTIONS(2288),
    [anon_sym___stdcall] = ACTIONS(2288),
    [anon_sym___fastcall] = ACTIONS(2288),
    [anon_sym___thiscall] = ACTIONS(2288),
    [anon_sym___vectorcall] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_signed] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym___try] = ACTIONS(2288),
    [anon_sym___leave] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2288),
    [anon_sym_compl] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_sizeof] = ACTIONS(2288),
    [anon_sym___alignof__] = ACTIONS(2288),
    [anon_sym___alignof] = ACTIONS(2288),
    [anon_sym__alignof] = ACTIONS(2288),
    [anon_sym_alignof] = ACTIONS(2288),
    [anon_sym__Alignof] = ACTIONS(2288),
    [anon_sym_offsetof] = ACTIONS(2288),
    [anon_sym__Generic] = ACTIONS(2288),
    [anon_sym_asm] = ACTIONS(2288),
    [anon_sym___asm__] = ACTIONS(2288),
    [anon_sym___asm] = ACTIONS(2288),
    [sym_number_literal] = ACTIONS(2290),
    [anon_sym_L_SQUOTE] = ACTIONS(2290),
    [anon_sym_u_SQUOTE] = ACTIONS(2290),
    [anon_sym_U_SQUOTE] = ACTIONS(2290),
    [anon_sym_u8_SQUOTE] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [anon_sym_L_DQUOTE] = ACTIONS(2290),
    [anon_sym_u_DQUOTE] = ACTIONS(2290),
    [anon_sym_U_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8_DQUOTE] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [anon_sym_NULL] = ACTIONS(2288),
    [anon_sym_nullptr] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_This] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [anon_sym_final] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_static_assert] = ACTIONS(2288),
    [anon_sym_concept] = ACTIONS(2288),
    [anon_sym_co_return] = ACTIONS(2288),
    [anon_sym_co_yield] = ACTIONS(2288),
    [anon_sym_R_DQUOTE] = ACTIONS(2290),
    [anon_sym_LR_DQUOTE] = ACTIONS(2290),
    [anon_sym_uR_DQUOTE] = ACTIONS(2290),
    [anon_sym_UR_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2290),
    [anon_sym_co_await] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_requires] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [anon_sym_discard] = ACTIONS(2288),
    [anon_sym_precise] = ACTIONS(2288),
    [anon_sym_shared] = ACTIONS(2288),
    [anon_sym_groupshared] = ACTIONS(2288),
    [anon_sym_uniform] = ACTIONS(2288),
    [anon_sym_row_major] = ACTIONS(2288),
    [anon_sym_column_major] = ACTIONS(2288),
    [anon_sym_globallycoherent] = ACTIONS(2288),
    [anon_sym_centroid] = ACTIONS(2288),
    [anon_sym_noperspective] = ACTIONS(2288),
    [anon_sym_nointerpolation] = ACTIONS(2288),
    [anon_sym_sample] = ACTIONS(2288),
    [anon_sym_linear] = ACTIONS(2288),
    [anon_sym_snorm] = ACTIONS(2288),
    [anon_sym_unorm] = ACTIONS(2288),
    [anon_sym_point] = ACTIONS(2288),
    [anon_sym_line] = ACTIONS(2288),
    [anon_sym_triangleadj] = ACTIONS(2288),
    [anon_sym_lineadj] = ACTIONS(2288),
    [anon_sym_triangle] = ACTIONS(2288),
    [anon_sym_cbuffer] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_extension] = ACTIONS(2288),
  },
  [275] = {
    [sym_identifier] = ACTIONS(2292),
    [aux_sym_preproc_include_token1] = ACTIONS(2292),
    [aux_sym_preproc_def_token1] = ACTIONS(2292),
    [aux_sym_preproc_if_token1] = ACTIONS(2292),
    [aux_sym_preproc_if_token2] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2292),
    [aux_sym_preproc_else_token1] = ACTIONS(2292),
    [aux_sym_preproc_elif_token1] = ACTIONS(2292),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2292),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2292),
    [sym_preproc_directive] = ACTIONS(2292),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_COLON] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym_typedef] = ACTIONS(2292),
    [anon_sym_in] = ACTIONS(2292),
    [anon_sym_out] = ACTIONS(2292),
    [anon_sym_inout] = ACTIONS(2292),
    [anon_sym_virtual] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym___attribute] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2294),
    [anon_sym___declspec] = ACTIONS(2292),
    [anon_sym___based] = ACTIONS(2292),
    [anon_sym___cdecl] = ACTIONS(2292),
    [anon_sym___clrcall] = ACTIONS(2292),
    [anon_sym___stdcall] = ACTIONS(2292),
    [anon_sym___fastcall] = ACTIONS(2292),
    [anon_sym___thiscall] = ACTIONS(2292),
    [anon_sym___vectorcall] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_signed] = ACTIONS(2292),
    [anon_sym_unsigned] = ACTIONS(2292),
    [anon_sym_long] = ACTIONS(2292),
    [anon_sym_short] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym___inline] = ACTIONS(2292),
    [anon_sym___inline__] = ACTIONS(2292),
    [anon_sym___forceinline] = ACTIONS(2292),
    [anon_sym_thread_local] = ACTIONS(2292),
    [anon_sym___thread] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym__Nonnull] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [sym_primitive_type] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_struct] = ACTIONS(2292),
    [anon_sym_union] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_else] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_case] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_goto] = ACTIONS(2292),
    [anon_sym___try] = ACTIONS(2292),
    [anon_sym___leave] = ACTIONS(2292),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_compl] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_sizeof] = ACTIONS(2292),
    [anon_sym___alignof__] = ACTIONS(2292),
    [anon_sym___alignof] = ACTIONS(2292),
    [anon_sym__alignof] = ACTIONS(2292),
    [anon_sym_alignof] = ACTIONS(2292),
    [anon_sym__Alignof] = ACTIONS(2292),
    [anon_sym_offsetof] = ACTIONS(2292),
    [anon_sym__Generic] = ACTIONS(2292),
    [anon_sym_asm] = ACTIONS(2292),
    [anon_sym___asm__] = ACTIONS(2292),
    [anon_sym___asm] = ACTIONS(2292),
    [sym_number_literal] = ACTIONS(2294),
    [anon_sym_L_SQUOTE] = ACTIONS(2294),
    [anon_sym_u_SQUOTE] = ACTIONS(2294),
    [anon_sym_U_SQUOTE] = ACTIONS(2294),
    [anon_sym_u8_SQUOTE] = ACTIONS(2294),
    [anon_sym_SQUOTE] = ACTIONS(2294),
    [anon_sym_L_DQUOTE] = ACTIONS(2294),
    [anon_sym_u_DQUOTE] = ACTIONS(2294),
    [anon_sym_U_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8_DQUOTE] = ACTIONS(2294),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [anon_sym_NULL] = ACTIONS(2292),
    [anon_sym_nullptr] = ACTIONS(2292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_This] = ACTIONS(2292),
    [anon_sym_decltype] = ACTIONS(2292),
    [anon_sym_final] = ACTIONS(2292),
    [anon_sym_override] = ACTIONS(2292),
    [anon_sym_explicit] = ACTIONS(2292),
    [anon_sym_typename] = ACTIONS(2292),
    [anon_sym_template] = ACTIONS(2292),
    [anon_sym_operator] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_static_assert] = ACTIONS(2292),
    [anon_sym_concept] = ACTIONS(2292),
    [anon_sym_co_return] = ACTIONS(2292),
    [anon_sym_co_yield] = ACTIONS(2292),
    [anon_sym_R_DQUOTE] = ACTIONS(2294),
    [anon_sym_LR_DQUOTE] = ACTIONS(2294),
    [anon_sym_uR_DQUOTE] = ACTIONS(2294),
    [anon_sym_UR_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2294),
    [anon_sym_co_await] = ACTIONS(2292),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_requires] = ACTIONS(2292),
    [sym_this] = ACTIONS(2292),
    [anon_sym_discard] = ACTIONS(2292),
    [anon_sym_precise] = ACTIONS(2292),
    [anon_sym_shared] = ACTIONS(2292),
    [anon_sym_groupshared] = ACTIONS(2292),
    [anon_sym_uniform] = ACTIONS(2292),
    [anon_sym_row_major] = ACTIONS(2292),
    [anon_sym_column_major] = ACTIONS(2292),
    [anon_sym_globallycoherent] = ACTIONS(2292),
    [anon_sym_centroid] = ACTIONS(2292),
    [anon_sym_noperspective] = ACTIONS(2292),
    [anon_sym_nointerpolation] = ACTIONS(2292),
    [anon_sym_sample] = ACTIONS(2292),
    [anon_sym_linear] = ACTIONS(2292),
    [anon_sym_snorm] = ACTIONS(2292),
    [anon_sym_unorm] = ACTIONS(2292),
    [anon_sym_point] = ACTIONS(2292),
    [anon_sym_line] = ACTIONS(2292),
    [anon_sym_triangleadj] = ACTIONS(2292),
    [anon_sym_lineadj] = ACTIONS(2292),
    [anon_sym_triangle] = ACTIONS(2292),
    [anon_sym_cbuffer] = ACTIONS(2292),
    [anon_sym_interface] = ACTIONS(2292),
    [anon_sym_extension] = ACTIONS(2292),
  },
  [276] = {
    [sym_identifier] = ACTIONS(2296),
    [aux_sym_preproc_include_token1] = ACTIONS(2296),
    [aux_sym_preproc_def_token1] = ACTIONS(2296),
    [aux_sym_preproc_if_token1] = ACTIONS(2296),
    [aux_sym_preproc_if_token2] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2296),
    [aux_sym_preproc_else_token1] = ACTIONS(2296),
    [aux_sym_preproc_elif_token1] = ACTIONS(2296),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2296),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2296),
    [sym_preproc_directive] = ACTIONS(2296),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_BANG] = ACTIONS(2298),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_COLON] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2298),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym_typedef] = ACTIONS(2296),
    [anon_sym_in] = ACTIONS(2296),
    [anon_sym_out] = ACTIONS(2296),
    [anon_sym_inout] = ACTIONS(2296),
    [anon_sym_virtual] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym___attribute] = ACTIONS(2296),
    [anon_sym_using] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2298),
    [anon_sym___declspec] = ACTIONS(2296),
    [anon_sym___based] = ACTIONS(2296),
    [anon_sym___cdecl] = ACTIONS(2296),
    [anon_sym___clrcall] = ACTIONS(2296),
    [anon_sym___stdcall] = ACTIONS(2296),
    [anon_sym___fastcall] = ACTIONS(2296),
    [anon_sym___thiscall] = ACTIONS(2296),
    [anon_sym___vectorcall] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_signed] = ACTIONS(2296),
    [anon_sym_unsigned] = ACTIONS(2296),
    [anon_sym_long] = ACTIONS(2296),
    [anon_sym_short] = ACTIONS(2296),
    [anon_sym_LBRACK] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_register] = ACTIONS(2296),
    [anon_sym_inline] = ACTIONS(2296),
    [anon_sym___inline] = ACTIONS(2296),
    [anon_sym___inline__] = ACTIONS(2296),
    [anon_sym___forceinline] = ACTIONS(2296),
    [anon_sym_thread_local] = ACTIONS(2296),
    [anon_sym___thread] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym__Nonnull] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [sym_primitive_type] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2296),
    [anon_sym_class] = ACTIONS(2296),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_union] = ACTIONS(2296),
    [anon_sym_if] = ACTIONS(2296),
    [anon_sym_else] = ACTIONS(2296),
    [anon_sym_switch] = ACTIONS(2296),
    [anon_sym_case] = ACTIONS(2296),
    [anon_sym_default] = ACTIONS(2296),
    [anon_sym_while] = ACTIONS(2296),
    [anon_sym_do] = ACTIONS(2296),
    [anon_sym_for] = ACTIONS(2296),
    [anon_sym_return] = ACTIONS(2296),
    [anon_sym_break] = ACTIONS(2296),
    [anon_sym_continue] = ACTIONS(2296),
    [anon_sym_goto] = ACTIONS(2296),
    [anon_sym___try] = ACTIONS(2296),
    [anon_sym___leave] = ACTIONS(2296),
    [anon_sym_not] = ACTIONS(2296),
    [anon_sym_compl] = ACTIONS(2296),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_sizeof] = ACTIONS(2296),
    [anon_sym___alignof__] = ACTIONS(2296),
    [anon_sym___alignof] = ACTIONS(2296),
    [anon_sym__alignof] = ACTIONS(2296),
    [anon_sym_alignof] = ACTIONS(2296),
    [anon_sym__Alignof] = ACTIONS(2296),
    [anon_sym_offsetof] = ACTIONS(2296),
    [anon_sym__Generic] = ACTIONS(2296),
    [anon_sym_asm] = ACTIONS(2296),
    [anon_sym___asm__] = ACTIONS(2296),
    [anon_sym___asm] = ACTIONS(2296),
    [sym_number_literal] = ACTIONS(2298),
    [anon_sym_L_SQUOTE] = ACTIONS(2298),
    [anon_sym_u_SQUOTE] = ACTIONS(2298),
    [anon_sym_U_SQUOTE] = ACTIONS(2298),
    [anon_sym_u8_SQUOTE] = ACTIONS(2298),
    [anon_sym_SQUOTE] = ACTIONS(2298),
    [anon_sym_L_DQUOTE] = ACTIONS(2298),
    [anon_sym_u_DQUOTE] = ACTIONS(2298),
    [anon_sym_U_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8_DQUOTE] = ACTIONS(2298),
    [anon_sym_DQUOTE] = ACTIONS(2298),
    [sym_true] = ACTIONS(2296),
    [sym_false] = ACTIONS(2296),
    [anon_sym_NULL] = ACTIONS(2296),
    [anon_sym_nullptr] = ACTIONS(2296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_This] = ACTIONS(2296),
    [anon_sym_decltype] = ACTIONS(2296),
    [anon_sym_final] = ACTIONS(2296),
    [anon_sym_override] = ACTIONS(2296),
    [anon_sym_explicit] = ACTIONS(2296),
    [anon_sym_typename] = ACTIONS(2296),
    [anon_sym_template] = ACTIONS(2296),
    [anon_sym_operator] = ACTIONS(2296),
    [anon_sym_try] = ACTIONS(2296),
    [anon_sym_delete] = ACTIONS(2296),
    [anon_sym_throw] = ACTIONS(2296),
    [anon_sym_namespace] = ACTIONS(2296),
    [anon_sym_static_assert] = ACTIONS(2296),
    [anon_sym_concept] = ACTIONS(2296),
    [anon_sym_co_return] = ACTIONS(2296),
    [anon_sym_co_yield] = ACTIONS(2296),
    [anon_sym_R_DQUOTE] = ACTIONS(2298),
    [anon_sym_LR_DQUOTE] = ACTIONS(2298),
    [anon_sym_uR_DQUOTE] = ACTIONS(2298),
    [anon_sym_UR_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2298),
    [anon_sym_co_await] = ACTIONS(2296),
    [anon_sym_new] = ACTIONS(2296),
    [anon_sym_requires] = ACTIONS(2296),
    [sym_this] = ACTIONS(2296),
    [anon_sym_discard] = ACTIONS(2296),
    [anon_sym_precise] = ACTIONS(2296),
    [anon_sym_shared] = ACTIONS(2296),
    [anon_sym_groupshared] = ACTIONS(2296),
    [anon_sym_uniform] = ACTIONS(2296),
    [anon_sym_row_major] = ACTIONS(2296),
    [anon_sym_column_major] = ACTIONS(2296),
    [anon_sym_globallycoherent] = ACTIONS(2296),
    [anon_sym_centroid] = ACTIONS(2296),
    [anon_sym_noperspective] = ACTIONS(2296),
    [anon_sym_nointerpolation] = ACTIONS(2296),
    [anon_sym_sample] = ACTIONS(2296),
    [anon_sym_linear] = ACTIONS(2296),
    [anon_sym_snorm] = ACTIONS(2296),
    [anon_sym_unorm] = ACTIONS(2296),
    [anon_sym_point] = ACTIONS(2296),
    [anon_sym_line] = ACTIONS(2296),
    [anon_sym_triangleadj] = ACTIONS(2296),
    [anon_sym_lineadj] = ACTIONS(2296),
    [anon_sym_triangle] = ACTIONS(2296),
    [anon_sym_cbuffer] = ACTIONS(2296),
    [anon_sym_interface] = ACTIONS(2296),
    [anon_sym_extension] = ACTIONS(2296),
  },
  [277] = {
    [sym_identifier] = ACTIONS(2264),
    [aux_sym_preproc_include_token1] = ACTIONS(2264),
    [aux_sym_preproc_def_token1] = ACTIONS(2264),
    [aux_sym_preproc_if_token1] = ACTIONS(2264),
    [aux_sym_preproc_if_token2] = ACTIONS(2264),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2264),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2264),
    [aux_sym_preproc_else_token1] = ACTIONS(2264),
    [aux_sym_preproc_elif_token1] = ACTIONS(2264),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2264),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2264),
    [sym_preproc_directive] = ACTIONS(2264),
    [anon_sym_LPAREN2] = ACTIONS(2266),
    [anon_sym_BANG] = ACTIONS(2266),
    [anon_sym_TILDE] = ACTIONS(2266),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2266),
    [anon_sym_AMP] = ACTIONS(2264),
    [anon_sym_COLON] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2266),
    [anon_sym___extension__] = ACTIONS(2264),
    [anon_sym_typedef] = ACTIONS(2264),
    [anon_sym_in] = ACTIONS(2264),
    [anon_sym_out] = ACTIONS(2264),
    [anon_sym_inout] = ACTIONS(2264),
    [anon_sym_virtual] = ACTIONS(2264),
    [anon_sym_extern] = ACTIONS(2264),
    [anon_sym___attribute__] = ACTIONS(2264),
    [anon_sym___attribute] = ACTIONS(2264),
    [anon_sym_using] = ACTIONS(2264),
    [anon_sym_COLON_COLON] = ACTIONS(2266),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2266),
    [anon_sym___declspec] = ACTIONS(2264),
    [anon_sym___based] = ACTIONS(2264),
    [anon_sym___cdecl] = ACTIONS(2264),
    [anon_sym___clrcall] = ACTIONS(2264),
    [anon_sym___stdcall] = ACTIONS(2264),
    [anon_sym___fastcall] = ACTIONS(2264),
    [anon_sym___thiscall] = ACTIONS(2264),
    [anon_sym___vectorcall] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_signed] = ACTIONS(2264),
    [anon_sym_unsigned] = ACTIONS(2264),
    [anon_sym_long] = ACTIONS(2264),
    [anon_sym_short] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_register] = ACTIONS(2264),
    [anon_sym_inline] = ACTIONS(2264),
    [anon_sym___inline] = ACTIONS(2264),
    [anon_sym___inline__] = ACTIONS(2264),
    [anon_sym___forceinline] = ACTIONS(2264),
    [anon_sym_thread_local] = ACTIONS(2264),
    [anon_sym___thread] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_constexpr] = ACTIONS(2264),
    [anon_sym_volatile] = ACTIONS(2264),
    [anon_sym_restrict] = ACTIONS(2264),
    [anon_sym___restrict__] = ACTIONS(2264),
    [anon_sym__Atomic] = ACTIONS(2264),
    [anon_sym__Noreturn] = ACTIONS(2264),
    [anon_sym_noreturn] = ACTIONS(2264),
    [anon_sym__Nonnull] = ACTIONS(2264),
    [anon_sym_mutable] = ACTIONS(2264),
    [anon_sym_constinit] = ACTIONS(2264),
    [anon_sym_consteval] = ACTIONS(2264),
    [anon_sym_alignas] = ACTIONS(2264),
    [anon_sym__Alignas] = ACTIONS(2264),
    [sym_primitive_type] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
    [anon_sym_class] = ACTIONS(2264),
    [anon_sym_struct] = ACTIONS(2264),
    [anon_sym_union] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_else] = ACTIONS(2264),
    [anon_sym_switch] = ACTIONS(2264),
    [anon_sym_case] = ACTIONS(2264),
    [anon_sym_default] = ACTIONS(2264),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_do] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_goto] = ACTIONS(2264),
    [anon_sym___try] = ACTIONS(2264),
    [anon_sym___leave] = ACTIONS(2264),
    [anon_sym_not] = ACTIONS(2264),
    [anon_sym_compl] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2266),
    [anon_sym_PLUS_PLUS] = ACTIONS(2266),
    [anon_sym_sizeof] = ACTIONS(2264),
    [anon_sym___alignof__] = ACTIONS(2264),
    [anon_sym___alignof] = ACTIONS(2264),
    [anon_sym__alignof] = ACTIONS(2264),
    [anon_sym_alignof] = ACTIONS(2264),
    [anon_sym__Alignof] = ACTIONS(2264),
    [anon_sym_offsetof] = ACTIONS(2264),
    [anon_sym__Generic] = ACTIONS(2264),
    [anon_sym_asm] = ACTIONS(2264),
    [anon_sym___asm__] = ACTIONS(2264),
    [anon_sym___asm] = ACTIONS(2264),
    [sym_number_literal] = ACTIONS(2266),
    [anon_sym_L_SQUOTE] = ACTIONS(2266),
    [anon_sym_u_SQUOTE] = ACTIONS(2266),
    [anon_sym_U_SQUOTE] = ACTIONS(2266),
    [anon_sym_u8_SQUOTE] = ACTIONS(2266),
    [anon_sym_SQUOTE] = ACTIONS(2266),
    [anon_sym_L_DQUOTE] = ACTIONS(2266),
    [anon_sym_u_DQUOTE] = ACTIONS(2266),
    [anon_sym_U_DQUOTE] = ACTIONS(2266),
    [anon_sym_u8_DQUOTE] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(2266),
    [sym_true] = ACTIONS(2264),
    [sym_false] = ACTIONS(2264),
    [anon_sym_NULL] = ACTIONS(2264),
    [anon_sym_nullptr] = ACTIONS(2264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_This] = ACTIONS(2264),
    [anon_sym_decltype] = ACTIONS(2264),
    [anon_sym_final] = ACTIONS(2264),
    [anon_sym_override] = ACTIONS(2264),
    [anon_sym_explicit] = ACTIONS(2264),
    [anon_sym_typename] = ACTIONS(2264),
    [anon_sym_template] = ACTIONS(2264),
    [anon_sym_operator] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [anon_sym_delete] = ACTIONS(2264),
    [anon_sym_throw] = ACTIONS(2264),
    [anon_sym_namespace] = ACTIONS(2264),
    [anon_sym_static_assert] = ACTIONS(2264),
    [anon_sym_concept] = ACTIONS(2264),
    [anon_sym_co_return] = ACTIONS(2264),
    [anon_sym_co_yield] = ACTIONS(2264),
    [anon_sym_R_DQUOTE] = ACTIONS(2266),
    [anon_sym_LR_DQUOTE] = ACTIONS(2266),
    [anon_sym_uR_DQUOTE] = ACTIONS(2266),
    [anon_sym_UR_DQUOTE] = ACTIONS(2266),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2266),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2264),
    [anon_sym_requires] = ACTIONS(2264),
    [sym_this] = ACTIONS(2264),
    [anon_sym_discard] = ACTIONS(2264),
    [anon_sym_precise] = ACTIONS(2264),
    [anon_sym_shared] = ACTIONS(2264),
    [anon_sym_groupshared] = ACTIONS(2264),
    [anon_sym_uniform] = ACTIONS(2264),
    [anon_sym_row_major] = ACTIONS(2264),
    [anon_sym_column_major] = ACTIONS(2264),
    [anon_sym_globallycoherent] = ACTIONS(2264),
    [anon_sym_centroid] = ACTIONS(2264),
    [anon_sym_noperspective] = ACTIONS(2264),
    [anon_sym_nointerpolation] = ACTIONS(2264),
    [anon_sym_sample] = ACTIONS(2264),
    [anon_sym_linear] = ACTIONS(2264),
    [anon_sym_snorm] = ACTIONS(2264),
    [anon_sym_unorm] = ACTIONS(2264),
    [anon_sym_point] = ACTIONS(2264),
    [anon_sym_line] = ACTIONS(2264),
    [anon_sym_triangleadj] = ACTIONS(2264),
    [anon_sym_lineadj] = ACTIONS(2264),
    [anon_sym_triangle] = ACTIONS(2264),
    [anon_sym_cbuffer] = ACTIONS(2264),
    [anon_sym_interface] = ACTIONS(2264),
    [anon_sym_extension] = ACTIONS(2264),
  },
  [278] = {
    [sym_identifier] = ACTIONS(2300),
    [aux_sym_preproc_include_token1] = ACTIONS(2300),
    [aux_sym_preproc_def_token1] = ACTIONS(2300),
    [aux_sym_preproc_if_token1] = ACTIONS(2300),
    [aux_sym_preproc_if_token2] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2300),
    [aux_sym_preproc_else_token1] = ACTIONS(2300),
    [aux_sym_preproc_elif_token1] = ACTIONS(2300),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2300),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2300),
    [sym_preproc_directive] = ACTIONS(2300),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_BANG] = ACTIONS(2302),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_COLON] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym_typedef] = ACTIONS(2300),
    [anon_sym_in] = ACTIONS(2300),
    [anon_sym_out] = ACTIONS(2300),
    [anon_sym_inout] = ACTIONS(2300),
    [anon_sym_virtual] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym___attribute] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2302),
    [anon_sym___declspec] = ACTIONS(2300),
    [anon_sym___based] = ACTIONS(2300),
    [anon_sym___cdecl] = ACTIONS(2300),
    [anon_sym___clrcall] = ACTIONS(2300),
    [anon_sym___stdcall] = ACTIONS(2300),
    [anon_sym___fastcall] = ACTIONS(2300),
    [anon_sym___thiscall] = ACTIONS(2300),
    [anon_sym___vectorcall] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_signed] = ACTIONS(2300),
    [anon_sym_unsigned] = ACTIONS(2300),
    [anon_sym_long] = ACTIONS(2300),
    [anon_sym_short] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_register] = ACTIONS(2300),
    [anon_sym_inline] = ACTIONS(2300),
    [anon_sym___inline] = ACTIONS(2300),
    [anon_sym___inline__] = ACTIONS(2300),
    [anon_sym___forceinline] = ACTIONS(2300),
    [anon_sym_thread_local] = ACTIONS(2300),
    [anon_sym___thread] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym__Nonnull] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [sym_primitive_type] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_struct] = ACTIONS(2300),
    [anon_sym_union] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_else] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_case] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_goto] = ACTIONS(2300),
    [anon_sym___try] = ACTIONS(2300),
    [anon_sym___leave] = ACTIONS(2300),
    [anon_sym_not] = ACTIONS(2300),
    [anon_sym_compl] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_sizeof] = ACTIONS(2300),
    [anon_sym___alignof__] = ACTIONS(2300),
    [anon_sym___alignof] = ACTIONS(2300),
    [anon_sym__alignof] = ACTIONS(2300),
    [anon_sym_alignof] = ACTIONS(2300),
    [anon_sym__Alignof] = ACTIONS(2300),
    [anon_sym_offsetof] = ACTIONS(2300),
    [anon_sym__Generic] = ACTIONS(2300),
    [anon_sym_asm] = ACTIONS(2300),
    [anon_sym___asm__] = ACTIONS(2300),
    [anon_sym___asm] = ACTIONS(2300),
    [sym_number_literal] = ACTIONS(2302),
    [anon_sym_L_SQUOTE] = ACTIONS(2302),
    [anon_sym_u_SQUOTE] = ACTIONS(2302),
    [anon_sym_U_SQUOTE] = ACTIONS(2302),
    [anon_sym_u8_SQUOTE] = ACTIONS(2302),
    [anon_sym_SQUOTE] = ACTIONS(2302),
    [anon_sym_L_DQUOTE] = ACTIONS(2302),
    [anon_sym_u_DQUOTE] = ACTIONS(2302),
    [anon_sym_U_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8_DQUOTE] = ACTIONS(2302),
    [anon_sym_DQUOTE] = ACTIONS(2302),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [anon_sym_NULL] = ACTIONS(2300),
    [anon_sym_nullptr] = ACTIONS(2300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_This] = ACTIONS(2300),
    [anon_sym_decltype] = ACTIONS(2300),
    [anon_sym_final] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_explicit] = ACTIONS(2300),
    [anon_sym_typename] = ACTIONS(2300),
    [anon_sym_template] = ACTIONS(2300),
    [anon_sym_operator] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_static_assert] = ACTIONS(2300),
    [anon_sym_concept] = ACTIONS(2300),
    [anon_sym_co_return] = ACTIONS(2300),
    [anon_sym_co_yield] = ACTIONS(2300),
    [anon_sym_R_DQUOTE] = ACTIONS(2302),
    [anon_sym_LR_DQUOTE] = ACTIONS(2302),
    [anon_sym_uR_DQUOTE] = ACTIONS(2302),
    [anon_sym_UR_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2302),
    [anon_sym_co_await] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_requires] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [anon_sym_discard] = ACTIONS(2300),
    [anon_sym_precise] = ACTIONS(2300),
    [anon_sym_shared] = ACTIONS(2300),
    [anon_sym_groupshared] = ACTIONS(2300),
    [anon_sym_uniform] = ACTIONS(2300),
    [anon_sym_row_major] = ACTIONS(2300),
    [anon_sym_column_major] = ACTIONS(2300),
    [anon_sym_globallycoherent] = ACTIONS(2300),
    [anon_sym_centroid] = ACTIONS(2300),
    [anon_sym_noperspective] = ACTIONS(2300),
    [anon_sym_nointerpolation] = ACTIONS(2300),
    [anon_sym_sample] = ACTIONS(2300),
    [anon_sym_linear] = ACTIONS(2300),
    [anon_sym_snorm] = ACTIONS(2300),
    [anon_sym_unorm] = ACTIONS(2300),
    [anon_sym_point] = ACTIONS(2300),
    [anon_sym_line] = ACTIONS(2300),
    [anon_sym_triangleadj] = ACTIONS(2300),
    [anon_sym_lineadj] = ACTIONS(2300),
    [anon_sym_triangle] = ACTIONS(2300),
    [anon_sym_cbuffer] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_extension] = ACTIONS(2300),
  },
  [279] = {
    [sym_identifier] = ACTIONS(2260),
    [aux_sym_preproc_include_token1] = ACTIONS(2260),
    [aux_sym_preproc_def_token1] = ACTIONS(2260),
    [aux_sym_preproc_if_token1] = ACTIONS(2260),
    [aux_sym_preproc_if_token2] = ACTIONS(2260),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2260),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2260),
    [aux_sym_preproc_else_token1] = ACTIONS(2260),
    [aux_sym_preproc_elif_token1] = ACTIONS(2260),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2260),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2260),
    [sym_preproc_directive] = ACTIONS(2260),
    [anon_sym_LPAREN2] = ACTIONS(2262),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2262),
    [anon_sym_AMP_AMP] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_COLON] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym___extension__] = ACTIONS(2260),
    [anon_sym_typedef] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(2260),
    [anon_sym_out] = ACTIONS(2260),
    [anon_sym_inout] = ACTIONS(2260),
    [anon_sym_virtual] = ACTIONS(2260),
    [anon_sym_extern] = ACTIONS(2260),
    [anon_sym___attribute__] = ACTIONS(2260),
    [anon_sym___attribute] = ACTIONS(2260),
    [anon_sym_using] = ACTIONS(2260),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2262),
    [anon_sym___declspec] = ACTIONS(2260),
    [anon_sym___based] = ACTIONS(2260),
    [anon_sym___cdecl] = ACTIONS(2260),
    [anon_sym___clrcall] = ACTIONS(2260),
    [anon_sym___stdcall] = ACTIONS(2260),
    [anon_sym___fastcall] = ACTIONS(2260),
    [anon_sym___thiscall] = ACTIONS(2260),
    [anon_sym___vectorcall] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_signed] = ACTIONS(2260),
    [anon_sym_unsigned] = ACTIONS(2260),
    [anon_sym_long] = ACTIONS(2260),
    [anon_sym_short] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_register] = ACTIONS(2260),
    [anon_sym_inline] = ACTIONS(2260),
    [anon_sym___inline] = ACTIONS(2260),
    [anon_sym___inline__] = ACTIONS(2260),
    [anon_sym___forceinline] = ACTIONS(2260),
    [anon_sym_thread_local] = ACTIONS(2260),
    [anon_sym___thread] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_constexpr] = ACTIONS(2260),
    [anon_sym_volatile] = ACTIONS(2260),
    [anon_sym_restrict] = ACTIONS(2260),
    [anon_sym___restrict__] = ACTIONS(2260),
    [anon_sym__Atomic] = ACTIONS(2260),
    [anon_sym__Noreturn] = ACTIONS(2260),
    [anon_sym_noreturn] = ACTIONS(2260),
    [anon_sym__Nonnull] = ACTIONS(2260),
    [anon_sym_mutable] = ACTIONS(2260),
    [anon_sym_constinit] = ACTIONS(2260),
    [anon_sym_consteval] = ACTIONS(2260),
    [anon_sym_alignas] = ACTIONS(2260),
    [anon_sym__Alignas] = ACTIONS(2260),
    [sym_primitive_type] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
    [anon_sym_class] = ACTIONS(2260),
    [anon_sym_struct] = ACTIONS(2260),
    [anon_sym_union] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_else] = ACTIONS(2260),
    [anon_sym_switch] = ACTIONS(2260),
    [anon_sym_case] = ACTIONS(2260),
    [anon_sym_default] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_do] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_goto] = ACTIONS(2260),
    [anon_sym___try] = ACTIONS(2260),
    [anon_sym___leave] = ACTIONS(2260),
    [anon_sym_not] = ACTIONS(2260),
    [anon_sym_compl] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_sizeof] = ACTIONS(2260),
    [anon_sym___alignof__] = ACTIONS(2260),
    [anon_sym___alignof] = ACTIONS(2260),
    [anon_sym__alignof] = ACTIONS(2260),
    [anon_sym_alignof] = ACTIONS(2260),
    [anon_sym__Alignof] = ACTIONS(2260),
    [anon_sym_offsetof] = ACTIONS(2260),
    [anon_sym__Generic] = ACTIONS(2260),
    [anon_sym_asm] = ACTIONS(2260),
    [anon_sym___asm__] = ACTIONS(2260),
    [anon_sym___asm] = ACTIONS(2260),
    [sym_number_literal] = ACTIONS(2262),
    [anon_sym_L_SQUOTE] = ACTIONS(2262),
    [anon_sym_u_SQUOTE] = ACTIONS(2262),
    [anon_sym_U_SQUOTE] = ACTIONS(2262),
    [anon_sym_u8_SQUOTE] = ACTIONS(2262),
    [anon_sym_SQUOTE] = ACTIONS(2262),
    [anon_sym_L_DQUOTE] = ACTIONS(2262),
    [anon_sym_u_DQUOTE] = ACTIONS(2262),
    [anon_sym_U_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8_DQUOTE] = ACTIONS(2262),
    [anon_sym_DQUOTE] = ACTIONS(2262),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [anon_sym_NULL] = ACTIONS(2260),
    [anon_sym_nullptr] = ACTIONS(2260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_This] = ACTIONS(2260),
    [anon_sym_decltype] = ACTIONS(2260),
    [anon_sym_final] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
    [anon_sym_explicit] = ACTIONS(2260),
    [anon_sym_typename] = ACTIONS(2260),
    [anon_sym_template] = ACTIONS(2260),
    [anon_sym_operator] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_throw] = ACTIONS(2260),
    [anon_sym_namespace] = ACTIONS(2260),
    [anon_sym_static_assert] = ACTIONS(2260),
    [anon_sym_concept] = ACTIONS(2260),
    [anon_sym_co_return] = ACTIONS(2260),
    [anon_sym_co_yield] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2260),
    [anon_sym_new] = ACTIONS(2260),
    [anon_sym_requires] = ACTIONS(2260),
    [sym_this] = ACTIONS(2260),
    [anon_sym_discard] = ACTIONS(2260),
    [anon_sym_precise] = ACTIONS(2260),
    [anon_sym_shared] = ACTIONS(2260),
    [anon_sym_groupshared] = ACTIONS(2260),
    [anon_sym_uniform] = ACTIONS(2260),
    [anon_sym_row_major] = ACTIONS(2260),
    [anon_sym_column_major] = ACTIONS(2260),
    [anon_sym_globallycoherent] = ACTIONS(2260),
    [anon_sym_centroid] = ACTIONS(2260),
    [anon_sym_noperspective] = ACTIONS(2260),
    [anon_sym_nointerpolation] = ACTIONS(2260),
    [anon_sym_sample] = ACTIONS(2260),
    [anon_sym_linear] = ACTIONS(2260),
    [anon_sym_snorm] = ACTIONS(2260),
    [anon_sym_unorm] = ACTIONS(2260),
    [anon_sym_point] = ACTIONS(2260),
    [anon_sym_line] = ACTIONS(2260),
    [anon_sym_triangleadj] = ACTIONS(2260),
    [anon_sym_lineadj] = ACTIONS(2260),
    [anon_sym_triangle] = ACTIONS(2260),
    [anon_sym_cbuffer] = ACTIONS(2260),
    [anon_sym_interface] = ACTIONS(2260),
    [anon_sym_extension] = ACTIONS(2260),
  },
  [280] = {
    [sym_identifier] = ACTIONS(2304),
    [aux_sym_preproc_include_token1] = ACTIONS(2304),
    [aux_sym_preproc_def_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token2] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2304),
    [aux_sym_preproc_else_token1] = ACTIONS(2304),
    [aux_sym_preproc_elif_token1] = ACTIONS(2304),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2304),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2304),
    [sym_preproc_directive] = ACTIONS(2304),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_BANG] = ACTIONS(2306),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_COLON] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2306),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym_typedef] = ACTIONS(2304),
    [anon_sym_in] = ACTIONS(2304),
    [anon_sym_out] = ACTIONS(2304),
    [anon_sym_inout] = ACTIONS(2304),
    [anon_sym_virtual] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym___attribute] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2306),
    [anon_sym___declspec] = ACTIONS(2304),
    [anon_sym___based] = ACTIONS(2304),
    [anon_sym___cdecl] = ACTIONS(2304),
    [anon_sym___clrcall] = ACTIONS(2304),
    [anon_sym___stdcall] = ACTIONS(2304),
    [anon_sym___fastcall] = ACTIONS(2304),
    [anon_sym___thiscall] = ACTIONS(2304),
    [anon_sym___vectorcall] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_signed] = ACTIONS(2304),
    [anon_sym_unsigned] = ACTIONS(2304),
    [anon_sym_long] = ACTIONS(2304),
    [anon_sym_short] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_register] = ACTIONS(2304),
    [anon_sym_inline] = ACTIONS(2304),
    [anon_sym___inline] = ACTIONS(2304),
    [anon_sym___inline__] = ACTIONS(2304),
    [anon_sym___forceinline] = ACTIONS(2304),
    [anon_sym_thread_local] = ACTIONS(2304),
    [anon_sym___thread] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym__Nonnull] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [sym_primitive_type] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_struct] = ACTIONS(2304),
    [anon_sym_union] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_else] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_case] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_goto] = ACTIONS(2304),
    [anon_sym___try] = ACTIONS(2304),
    [anon_sym___leave] = ACTIONS(2304),
    [anon_sym_not] = ACTIONS(2304),
    [anon_sym_compl] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_sizeof] = ACTIONS(2304),
    [anon_sym___alignof__] = ACTIONS(2304),
    [anon_sym___alignof] = ACTIONS(2304),
    [anon_sym__alignof] = ACTIONS(2304),
    [anon_sym_alignof] = ACTIONS(2304),
    [anon_sym__Alignof] = ACTIONS(2304),
    [anon_sym_offsetof] = ACTIONS(2304),
    [anon_sym__Generic] = ACTIONS(2304),
    [anon_sym_asm] = ACTIONS(2304),
    [anon_sym___asm__] = ACTIONS(2304),
    [anon_sym___asm] = ACTIONS(2304),
    [sym_number_literal] = ACTIONS(2306),
    [anon_sym_L_SQUOTE] = ACTIONS(2306),
    [anon_sym_u_SQUOTE] = ACTIONS(2306),
    [anon_sym_U_SQUOTE] = ACTIONS(2306),
    [anon_sym_u8_SQUOTE] = ACTIONS(2306),
    [anon_sym_SQUOTE] = ACTIONS(2306),
    [anon_sym_L_DQUOTE] = ACTIONS(2306),
    [anon_sym_u_DQUOTE] = ACTIONS(2306),
    [anon_sym_U_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8_DQUOTE] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [anon_sym_NULL] = ACTIONS(2304),
    [anon_sym_nullptr] = ACTIONS(2304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_This] = ACTIONS(2304),
    [anon_sym_decltype] = ACTIONS(2304),
    [anon_sym_final] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_explicit] = ACTIONS(2304),
    [anon_sym_typename] = ACTIONS(2304),
    [anon_sym_template] = ACTIONS(2304),
    [anon_sym_operator] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_static_assert] = ACTIONS(2304),
    [anon_sym_concept] = ACTIONS(2304),
    [anon_sym_co_return] = ACTIONS(2304),
    [anon_sym_co_yield] = ACTIONS(2304),
    [anon_sym_R_DQUOTE] = ACTIONS(2306),
    [anon_sym_LR_DQUOTE] = ACTIONS(2306),
    [anon_sym_uR_DQUOTE] = ACTIONS(2306),
    [anon_sym_UR_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2306),
    [anon_sym_co_await] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_requires] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [anon_sym_discard] = ACTIONS(2304),
    [anon_sym_precise] = ACTIONS(2304),
    [anon_sym_shared] = ACTIONS(2304),
    [anon_sym_groupshared] = ACTIONS(2304),
    [anon_sym_uniform] = ACTIONS(2304),
    [anon_sym_row_major] = ACTIONS(2304),
    [anon_sym_column_major] = ACTIONS(2304),
    [anon_sym_globallycoherent] = ACTIONS(2304),
    [anon_sym_centroid] = ACTIONS(2304),
    [anon_sym_noperspective] = ACTIONS(2304),
    [anon_sym_nointerpolation] = ACTIONS(2304),
    [anon_sym_sample] = ACTIONS(2304),
    [anon_sym_linear] = ACTIONS(2304),
    [anon_sym_snorm] = ACTIONS(2304),
    [anon_sym_unorm] = ACTIONS(2304),
    [anon_sym_point] = ACTIONS(2304),
    [anon_sym_line] = ACTIONS(2304),
    [anon_sym_triangleadj] = ACTIONS(2304),
    [anon_sym_lineadj] = ACTIONS(2304),
    [anon_sym_triangle] = ACTIONS(2304),
    [anon_sym_cbuffer] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_extension] = ACTIONS(2304),
  },
  [281] = {
    [sym_identifier] = ACTIONS(2308),
    [aux_sym_preproc_include_token1] = ACTIONS(2308),
    [aux_sym_preproc_def_token1] = ACTIONS(2308),
    [aux_sym_preproc_if_token1] = ACTIONS(2308),
    [aux_sym_preproc_if_token2] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2308),
    [aux_sym_preproc_else_token1] = ACTIONS(2308),
    [aux_sym_preproc_elif_token1] = ACTIONS(2308),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2308),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2308),
    [sym_preproc_directive] = ACTIONS(2308),
    [anon_sym_LPAREN2] = ACTIONS(2310),
    [anon_sym_BANG] = ACTIONS(2310),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_COLON] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(2308),
    [anon_sym_typedef] = ACTIONS(2308),
    [anon_sym_in] = ACTIONS(2308),
    [anon_sym_out] = ACTIONS(2308),
    [anon_sym_inout] = ACTIONS(2308),
    [anon_sym_virtual] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2308),
    [anon_sym___attribute__] = ACTIONS(2308),
    [anon_sym___attribute] = ACTIONS(2308),
    [anon_sym_using] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2310),
    [anon_sym___declspec] = ACTIONS(2308),
    [anon_sym___based] = ACTIONS(2308),
    [anon_sym___cdecl] = ACTIONS(2308),
    [anon_sym___clrcall] = ACTIONS(2308),
    [anon_sym___stdcall] = ACTIONS(2308),
    [anon_sym___fastcall] = ACTIONS(2308),
    [anon_sym___thiscall] = ACTIONS(2308),
    [anon_sym___vectorcall] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_signed] = ACTIONS(2308),
    [anon_sym_unsigned] = ACTIONS(2308),
    [anon_sym_long] = ACTIONS(2308),
    [anon_sym_short] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_register] = ACTIONS(2308),
    [anon_sym_inline] = ACTIONS(2308),
    [anon_sym___inline] = ACTIONS(2308),
    [anon_sym___inline__] = ACTIONS(2308),
    [anon_sym___forceinline] = ACTIONS(2308),
    [anon_sym_thread_local] = ACTIONS(2308),
    [anon_sym___thread] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_constexpr] = ACTIONS(2308),
    [anon_sym_volatile] = ACTIONS(2308),
    [anon_sym_restrict] = ACTIONS(2308),
    [anon_sym___restrict__] = ACTIONS(2308),
    [anon_sym__Atomic] = ACTIONS(2308),
    [anon_sym__Noreturn] = ACTIONS(2308),
    [anon_sym_noreturn] = ACTIONS(2308),
    [anon_sym__Nonnull] = ACTIONS(2308),
    [anon_sym_mutable] = ACTIONS(2308),
    [anon_sym_constinit] = ACTIONS(2308),
    [anon_sym_consteval] = ACTIONS(2308),
    [anon_sym_alignas] = ACTIONS(2308),
    [anon_sym__Alignas] = ACTIONS(2308),
    [sym_primitive_type] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_struct] = ACTIONS(2308),
    [anon_sym_union] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_else] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_case] = ACTIONS(2308),
    [anon_sym_default] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_goto] = ACTIONS(2308),
    [anon_sym___try] = ACTIONS(2308),
    [anon_sym___leave] = ACTIONS(2308),
    [anon_sym_not] = ACTIONS(2308),
    [anon_sym_compl] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_sizeof] = ACTIONS(2308),
    [anon_sym___alignof__] = ACTIONS(2308),
    [anon_sym___alignof] = ACTIONS(2308),
    [anon_sym__alignof] = ACTIONS(2308),
    [anon_sym_alignof] = ACTIONS(2308),
    [anon_sym__Alignof] = ACTIONS(2308),
    [anon_sym_offsetof] = ACTIONS(2308),
    [anon_sym__Generic] = ACTIONS(2308),
    [anon_sym_asm] = ACTIONS(2308),
    [anon_sym___asm__] = ACTIONS(2308),
    [anon_sym___asm] = ACTIONS(2308),
    [sym_number_literal] = ACTIONS(2310),
    [anon_sym_L_SQUOTE] = ACTIONS(2310),
    [anon_sym_u_SQUOTE] = ACTIONS(2310),
    [anon_sym_U_SQUOTE] = ACTIONS(2310),
    [anon_sym_u8_SQUOTE] = ACTIONS(2310),
    [anon_sym_SQUOTE] = ACTIONS(2310),
    [anon_sym_L_DQUOTE] = ACTIONS(2310),
    [anon_sym_u_DQUOTE] = ACTIONS(2310),
    [anon_sym_U_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8_DQUOTE] = ACTIONS(2310),
    [anon_sym_DQUOTE] = ACTIONS(2310),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [anon_sym_NULL] = ACTIONS(2308),
    [anon_sym_nullptr] = ACTIONS(2308),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_This] = ACTIONS(2308),
    [anon_sym_decltype] = ACTIONS(2308),
    [anon_sym_final] = ACTIONS(2308),
    [anon_sym_override] = ACTIONS(2308),
    [anon_sym_explicit] = ACTIONS(2308),
    [anon_sym_typename] = ACTIONS(2308),
    [anon_sym_template] = ACTIONS(2308),
    [anon_sym_operator] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_delete] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_namespace] = ACTIONS(2308),
    [anon_sym_static_assert] = ACTIONS(2308),
    [anon_sym_concept] = ACTIONS(2308),
    [anon_sym_co_return] = ACTIONS(2308),
    [anon_sym_co_yield] = ACTIONS(2308),
    [anon_sym_R_DQUOTE] = ACTIONS(2310),
    [anon_sym_LR_DQUOTE] = ACTIONS(2310),
    [anon_sym_uR_DQUOTE] = ACTIONS(2310),
    [anon_sym_UR_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2310),
    [anon_sym_co_await] = ACTIONS(2308),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_requires] = ACTIONS(2308),
    [sym_this] = ACTIONS(2308),
    [anon_sym_discard] = ACTIONS(2308),
    [anon_sym_precise] = ACTIONS(2308),
    [anon_sym_shared] = ACTIONS(2308),
    [anon_sym_groupshared] = ACTIONS(2308),
    [anon_sym_uniform] = ACTIONS(2308),
    [anon_sym_row_major] = ACTIONS(2308),
    [anon_sym_column_major] = ACTIONS(2308),
    [anon_sym_globallycoherent] = ACTIONS(2308),
    [anon_sym_centroid] = ACTIONS(2308),
    [anon_sym_noperspective] = ACTIONS(2308),
    [anon_sym_nointerpolation] = ACTIONS(2308),
    [anon_sym_sample] = ACTIONS(2308),
    [anon_sym_linear] = ACTIONS(2308),
    [anon_sym_snorm] = ACTIONS(2308),
    [anon_sym_unorm] = ACTIONS(2308),
    [anon_sym_point] = ACTIONS(2308),
    [anon_sym_line] = ACTIONS(2308),
    [anon_sym_triangleadj] = ACTIONS(2308),
    [anon_sym_lineadj] = ACTIONS(2308),
    [anon_sym_triangle] = ACTIONS(2308),
    [anon_sym_cbuffer] = ACTIONS(2308),
    [anon_sym_interface] = ACTIONS(2308),
    [anon_sym_extension] = ACTIONS(2308),
  },
  [282] = {
    [sym_identifier] = ACTIONS(2312),
    [aux_sym_preproc_include_token1] = ACTIONS(2312),
    [aux_sym_preproc_def_token1] = ACTIONS(2312),
    [aux_sym_preproc_if_token1] = ACTIONS(2312),
    [aux_sym_preproc_if_token2] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2312),
    [aux_sym_preproc_else_token1] = ACTIONS(2312),
    [aux_sym_preproc_elif_token1] = ACTIONS(2312),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2312),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2312),
    [sym_preproc_directive] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2314),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym___extension__] = ACTIONS(2312),
    [anon_sym_typedef] = ACTIONS(2312),
    [anon_sym_in] = ACTIONS(2312),
    [anon_sym_out] = ACTIONS(2312),
    [anon_sym_inout] = ACTIONS(2312),
    [anon_sym_virtual] = ACTIONS(2312),
    [anon_sym_extern] = ACTIONS(2312),
    [anon_sym___attribute__] = ACTIONS(2312),
    [anon_sym___attribute] = ACTIONS(2312),
    [anon_sym_using] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2314),
    [anon_sym___declspec] = ACTIONS(2312),
    [anon_sym___based] = ACTIONS(2312),
    [anon_sym___cdecl] = ACTIONS(2312),
    [anon_sym___clrcall] = ACTIONS(2312),
    [anon_sym___stdcall] = ACTIONS(2312),
    [anon_sym___fastcall] = ACTIONS(2312),
    [anon_sym___thiscall] = ACTIONS(2312),
    [anon_sym___vectorcall] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_signed] = ACTIONS(2312),
    [anon_sym_unsigned] = ACTIONS(2312),
    [anon_sym_long] = ACTIONS(2312),
    [anon_sym_short] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_register] = ACTIONS(2312),
    [anon_sym_inline] = ACTIONS(2312),
    [anon_sym___inline] = ACTIONS(2312),
    [anon_sym___inline__] = ACTIONS(2312),
    [anon_sym___forceinline] = ACTIONS(2312),
    [anon_sym_thread_local] = ACTIONS(2312),
    [anon_sym___thread] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_constexpr] = ACTIONS(2312),
    [anon_sym_volatile] = ACTIONS(2312),
    [anon_sym_restrict] = ACTIONS(2312),
    [anon_sym___restrict__] = ACTIONS(2312),
    [anon_sym__Atomic] = ACTIONS(2312),
    [anon_sym__Noreturn] = ACTIONS(2312),
    [anon_sym_noreturn] = ACTIONS(2312),
    [anon_sym__Nonnull] = ACTIONS(2312),
    [anon_sym_mutable] = ACTIONS(2312),
    [anon_sym_constinit] = ACTIONS(2312),
    [anon_sym_consteval] = ACTIONS(2312),
    [anon_sym_alignas] = ACTIONS(2312),
    [anon_sym__Alignas] = ACTIONS(2312),
    [sym_primitive_type] = ACTIONS(2312),
    [anon_sym_enum] = ACTIONS(2312),
    [anon_sym_class] = ACTIONS(2312),
    [anon_sym_struct] = ACTIONS(2312),
    [anon_sym_union] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_else] = ACTIONS(2312),
    [anon_sym_switch] = ACTIONS(2312),
    [anon_sym_case] = ACTIONS(2312),
    [anon_sym_default] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_break] = ACTIONS(2312),
    [anon_sym_continue] = ACTIONS(2312),
    [anon_sym_goto] = ACTIONS(2312),
    [anon_sym___try] = ACTIONS(2312),
    [anon_sym___leave] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2312),
    [anon_sym_compl] = ACTIONS(2312),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_sizeof] = ACTIONS(2312),
    [anon_sym___alignof__] = ACTIONS(2312),
    [anon_sym___alignof] = ACTIONS(2312),
    [anon_sym__alignof] = ACTIONS(2312),
    [anon_sym_alignof] = ACTIONS(2312),
    [anon_sym__Alignof] = ACTIONS(2312),
    [anon_sym_offsetof] = ACTIONS(2312),
    [anon_sym__Generic] = ACTIONS(2312),
    [anon_sym_asm] = ACTIONS(2312),
    [anon_sym___asm__] = ACTIONS(2312),
    [anon_sym___asm] = ACTIONS(2312),
    [sym_number_literal] = ACTIONS(2314),
    [anon_sym_L_SQUOTE] = ACTIONS(2314),
    [anon_sym_u_SQUOTE] = ACTIONS(2314),
    [anon_sym_U_SQUOTE] = ACTIONS(2314),
    [anon_sym_u8_SQUOTE] = ACTIONS(2314),
    [anon_sym_SQUOTE] = ACTIONS(2314),
    [anon_sym_L_DQUOTE] = ACTIONS(2314),
    [anon_sym_u_DQUOTE] = ACTIONS(2314),
    [anon_sym_U_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE] = ACTIONS(2314),
    [sym_true] = ACTIONS(2312),
    [sym_false] = ACTIONS(2312),
    [anon_sym_NULL] = ACTIONS(2312),
    [anon_sym_nullptr] = ACTIONS(2312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_This] = ACTIONS(2312),
    [anon_sym_decltype] = ACTIONS(2312),
    [anon_sym_final] = ACTIONS(2312),
    [anon_sym_override] = ACTIONS(2312),
    [anon_sym_explicit] = ACTIONS(2312),
    [anon_sym_typename] = ACTIONS(2312),
    [anon_sym_template] = ACTIONS(2312),
    [anon_sym_operator] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_delete] = ACTIONS(2312),
    [anon_sym_throw] = ACTIONS(2312),
    [anon_sym_namespace] = ACTIONS(2312),
    [anon_sym_static_assert] = ACTIONS(2312),
    [anon_sym_concept] = ACTIONS(2312),
    [anon_sym_co_return] = ACTIONS(2312),
    [anon_sym_co_yield] = ACTIONS(2312),
    [anon_sym_R_DQUOTE] = ACTIONS(2314),
    [anon_sym_LR_DQUOTE] = ACTIONS(2314),
    [anon_sym_uR_DQUOTE] = ACTIONS(2314),
    [anon_sym_UR_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2314),
    [anon_sym_co_await] = ACTIONS(2312),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_requires] = ACTIONS(2312),
    [sym_this] = ACTIONS(2312),
    [anon_sym_discard] = ACTIONS(2312),
    [anon_sym_precise] = ACTIONS(2312),
    [anon_sym_shared] = ACTIONS(2312),
    [anon_sym_groupshared] = ACTIONS(2312),
    [anon_sym_uniform] = ACTIONS(2312),
    [anon_sym_row_major] = ACTIONS(2312),
    [anon_sym_column_major] = ACTIONS(2312),
    [anon_sym_globallycoherent] = ACTIONS(2312),
    [anon_sym_centroid] = ACTIONS(2312),
    [anon_sym_noperspective] = ACTIONS(2312),
    [anon_sym_nointerpolation] = ACTIONS(2312),
    [anon_sym_sample] = ACTIONS(2312),
    [anon_sym_linear] = ACTIONS(2312),
    [anon_sym_snorm] = ACTIONS(2312),
    [anon_sym_unorm] = ACTIONS(2312),
    [anon_sym_point] = ACTIONS(2312),
    [anon_sym_line] = ACTIONS(2312),
    [anon_sym_triangleadj] = ACTIONS(2312),
    [anon_sym_lineadj] = ACTIONS(2312),
    [anon_sym_triangle] = ACTIONS(2312),
    [anon_sym_cbuffer] = ACTIONS(2312),
    [anon_sym_interface] = ACTIONS(2312),
    [anon_sym_extension] = ACTIONS(2312),
  },
  [283] = {
    [sym_attribute_specifier] = STATE(325),
    [sym_field_declaration_list] = STATE(646),
    [sym_virtual_specifier] = STATE(9433),
    [sym_base_class_clause] = STATE(10568),
    [ts_builtin_sym_end] = ACTIONS(2895),
    [sym_identifier] = ACTIONS(2893),
    [aux_sym_preproc_include_token1] = ACTIONS(2893),
    [aux_sym_preproc_def_token1] = ACTIONS(2893),
    [aux_sym_preproc_if_token1] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2893),
    [sym_preproc_directive] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_BANG] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_typedef] = ACTIONS(2893),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_out] = ACTIONS(2893),
    [anon_sym_inout] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(2893),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2570),
    [anon_sym_signed] = ACTIONS(2893),
    [anon_sym_unsigned] = ACTIONS(2893),
    [anon_sym_long] = ACTIONS(2893),
    [anon_sym_short] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym__Nonnull] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym__Alignas] = ACTIONS(2893),
    [sym_primitive_type] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_union] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_switch] = ACTIONS(2893),
    [anon_sym_case] = ACTIONS(2893),
    [anon_sym_default] = ACTIONS(2893),
    [anon_sym_while] = ACTIONS(2893),
    [anon_sym_do] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_goto] = ACTIONS(2893),
    [anon_sym_not] = ACTIONS(2893),
    [anon_sym_compl] = ACTIONS(2893),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_sizeof] = ACTIONS(2893),
    [anon_sym___alignof__] = ACTIONS(2893),
    [anon_sym___alignof] = ACTIONS(2893),
    [anon_sym__alignof] = ACTIONS(2893),
    [anon_sym_alignof] = ACTIONS(2893),
    [anon_sym__Alignof] = ACTIONS(2893),
    [anon_sym_offsetof] = ACTIONS(2893),
    [anon_sym__Generic] = ACTIONS(2893),
    [anon_sym_asm] = ACTIONS(2893),
    [anon_sym___asm__] = ACTIONS(2893),
    [anon_sym___asm] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2893),
    [sym_number_literal] = ACTIONS(2895),
    [anon_sym_L_SQUOTE] = ACTIONS(2895),
    [anon_sym_u_SQUOTE] = ACTIONS(2895),
    [anon_sym_U_SQUOTE] = ACTIONS(2895),
    [anon_sym_u8_SQUOTE] = ACTIONS(2895),
    [anon_sym_SQUOTE] = ACTIONS(2895),
    [anon_sym_L_DQUOTE] = ACTIONS(2895),
    [anon_sym_u_DQUOTE] = ACTIONS(2895),
    [anon_sym_U_DQUOTE] = ACTIONS(2895),
    [anon_sym_u8_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [anon_sym_NULL] = ACTIONS(2893),
    [anon_sym_nullptr] = ACTIONS(2893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_This] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_explicit] = ACTIONS(2893),
    [anon_sym_typename] = ACTIONS(2893),
    [anon_sym_export] = ACTIONS(2893),
    [anon_sym_module] = ACTIONS(2893),
    [anon_sym_import] = ACTIONS(2893),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_try] = ACTIONS(2893),
    [anon_sym_delete] = ACTIONS(2893),
    [anon_sym_throw] = ACTIONS(2893),
    [anon_sym_namespace] = ACTIONS(2893),
    [anon_sym_static_assert] = ACTIONS(2893),
    [anon_sym_concept] = ACTIONS(2893),
    [anon_sym_co_return] = ACTIONS(2893),
    [anon_sym_co_yield] = ACTIONS(2893),
    [anon_sym_R_DQUOTE] = ACTIONS(2895),
    [anon_sym_LR_DQUOTE] = ACTIONS(2895),
    [anon_sym_uR_DQUOTE] = ACTIONS(2895),
    [anon_sym_UR_DQUOTE] = ACTIONS(2895),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2895),
    [anon_sym_co_await] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2893),
    [anon_sym_requires] = ACTIONS(2893),
    [sym_this] = ACTIONS(2893),
    [anon_sym_precise] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_groupshared] = ACTIONS(2893),
    [anon_sym_uniform] = ACTIONS(2893),
    [anon_sym_row_major] = ACTIONS(2893),
    [anon_sym_column_major] = ACTIONS(2893),
    [anon_sym_globallycoherent] = ACTIONS(2893),
    [anon_sym_centroid] = ACTIONS(2893),
    [anon_sym_noperspective] = ACTIONS(2893),
    [anon_sym_nointerpolation] = ACTIONS(2893),
    [anon_sym_sample] = ACTIONS(2893),
    [anon_sym_linear] = ACTIONS(2893),
    [anon_sym_snorm] = ACTIONS(2893),
    [anon_sym_unorm] = ACTIONS(2893),
    [anon_sym_point] = ACTIONS(2893),
    [anon_sym_line] = ACTIONS(2893),
    [anon_sym_triangleadj] = ACTIONS(2893),
    [anon_sym_lineadj] = ACTIONS(2893),
    [anon_sym_triangle] = ACTIONS(2893),
    [anon_sym_interface] = ACTIONS(2893),
    [anon_sym_extension] = ACTIONS(2893),
    [anon_sym___exported] = ACTIONS(2893),
  },
  [284] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(284),
    [ts_builtin_sym_end] = ACTIONS(2913),
    [sym_identifier] = ACTIONS(2915),
    [aux_sym_preproc_include_token1] = ACTIONS(2915),
    [aux_sym_preproc_def_token1] = ACTIONS(2915),
    [anon_sym_COMMA] = ACTIONS(2913),
    [anon_sym_RPAREN] = ACTIONS(2913),
    [aux_sym_preproc_if_token1] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2915),
    [sym_preproc_directive] = ACTIONS(2915),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2915),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym_typedef] = ACTIONS(2915),
    [anon_sym_in] = ACTIONS(2915),
    [anon_sym_out] = ACTIONS(2915),
    [anon_sym_inout] = ACTIONS(2915),
    [anon_sym_virtual] = ACTIONS(2915),
    [anon_sym_extern] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym_using] = ACTIONS(2915),
    [anon_sym_COLON_COLON] = ACTIONS(2913),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2913),
    [anon_sym___declspec] = ACTIONS(2915),
    [anon_sym___based] = ACTIONS(2915),
    [anon_sym___cdecl] = ACTIONS(2915),
    [anon_sym___clrcall] = ACTIONS(2915),
    [anon_sym___stdcall] = ACTIONS(2915),
    [anon_sym___fastcall] = ACTIONS(2915),
    [anon_sym___thiscall] = ACTIONS(2915),
    [anon_sym___vectorcall] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_signed] = ACTIONS(2917),
    [anon_sym_unsigned] = ACTIONS(2917),
    [anon_sym_long] = ACTIONS(2917),
    [anon_sym_short] = ACTIONS(2917),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_static] = ACTIONS(2915),
    [anon_sym_register] = ACTIONS(2915),
    [anon_sym_inline] = ACTIONS(2915),
    [anon_sym___inline] = ACTIONS(2915),
    [anon_sym___inline__] = ACTIONS(2915),
    [anon_sym___forceinline] = ACTIONS(2915),
    [anon_sym_thread_local] = ACTIONS(2915),
    [anon_sym___thread] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_enum] = ACTIONS(2915),
    [anon_sym_class] = ACTIONS(2915),
    [anon_sym_struct] = ACTIONS(2915),
    [anon_sym_union] = ACTIONS(2915),
    [anon_sym_if] = ACTIONS(2915),
    [anon_sym_switch] = ACTIONS(2915),
    [anon_sym_case] = ACTIONS(2915),
    [anon_sym_default] = ACTIONS(2915),
    [anon_sym_while] = ACTIONS(2915),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2915),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_break] = ACTIONS(2915),
    [anon_sym_continue] = ACTIONS(2915),
    [anon_sym_goto] = ACTIONS(2915),
    [anon_sym_not] = ACTIONS(2915),
    [anon_sym_compl] = ACTIONS(2915),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_sizeof] = ACTIONS(2915),
    [anon_sym___alignof__] = ACTIONS(2915),
    [anon_sym___alignof] = ACTIONS(2915),
    [anon_sym__alignof] = ACTIONS(2915),
    [anon_sym_alignof] = ACTIONS(2915),
    [anon_sym__Alignof] = ACTIONS(2915),
    [anon_sym_offsetof] = ACTIONS(2915),
    [anon_sym__Generic] = ACTIONS(2915),
    [anon_sym_asm] = ACTIONS(2915),
    [anon_sym___asm__] = ACTIONS(2915),
    [anon_sym___asm] = ACTIONS(2915),
    [anon_sym_DOT] = ACTIONS(2915),
    [sym_number_literal] = ACTIONS(2913),
    [anon_sym_L_SQUOTE] = ACTIONS(2913),
    [anon_sym_u_SQUOTE] = ACTIONS(2913),
    [anon_sym_U_SQUOTE] = ACTIONS(2913),
    [anon_sym_u8_SQUOTE] = ACTIONS(2913),
    [anon_sym_SQUOTE] = ACTIONS(2913),
    [anon_sym_L_DQUOTE] = ACTIONS(2913),
    [anon_sym_u_DQUOTE] = ACTIONS(2913),
    [anon_sym_U_DQUOTE] = ACTIONS(2913),
    [anon_sym_u8_DQUOTE] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2913),
    [sym_true] = ACTIONS(2915),
    [sym_false] = ACTIONS(2915),
    [anon_sym_NULL] = ACTIONS(2915),
    [anon_sym_nullptr] = ACTIONS(2915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2915),
    [anon_sym_let] = ACTIONS(2915),
    [anon_sym_This] = ACTIONS(2915),
    [anon_sym_decltype] = ACTIONS(2915),
    [anon_sym_final] = ACTIONS(2915),
    [anon_sym_override] = ACTIONS(2915),
    [anon_sym_explicit] = ACTIONS(2915),
    [anon_sym_typename] = ACTIONS(2915),
    [anon_sym_export] = ACTIONS(2915),
    [anon_sym_module] = ACTIONS(2915),
    [anon_sym_import] = ACTIONS(2915),
    [anon_sym_template] = ACTIONS(2915),
    [anon_sym_GT2] = ACTIONS(2913),
    [anon_sym_operator] = ACTIONS(2915),
    [anon_sym_try] = ACTIONS(2915),
    [anon_sym_delete] = ACTIONS(2915),
    [anon_sym_throw] = ACTIONS(2915),
    [anon_sym_namespace] = ACTIONS(2915),
    [anon_sym_static_assert] = ACTIONS(2915),
    [anon_sym_concept] = ACTIONS(2915),
    [anon_sym_co_return] = ACTIONS(2915),
    [anon_sym_co_yield] = ACTIONS(2915),
    [anon_sym_R_DQUOTE] = ACTIONS(2913),
    [anon_sym_LR_DQUOTE] = ACTIONS(2913),
    [anon_sym_uR_DQUOTE] = ACTIONS(2913),
    [anon_sym_UR_DQUOTE] = ACTIONS(2913),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2913),
    [anon_sym_co_await] = ACTIONS(2915),
    [anon_sym_new] = ACTIONS(2915),
    [anon_sym_requires] = ACTIONS(2915),
    [sym_this] = ACTIONS(2915),
    [anon_sym_precise] = ACTIONS(2915),
    [anon_sym_shared] = ACTIONS(2915),
    [anon_sym_groupshared] = ACTIONS(2915),
    [anon_sym_uniform] = ACTIONS(2915),
    [anon_sym_row_major] = ACTIONS(2915),
    [anon_sym_column_major] = ACTIONS(2915),
    [anon_sym_globallycoherent] = ACTIONS(2915),
    [anon_sym_centroid] = ACTIONS(2915),
    [anon_sym_noperspective] = ACTIONS(2915),
    [anon_sym_nointerpolation] = ACTIONS(2915),
    [anon_sym_sample] = ACTIONS(2915),
    [anon_sym_linear] = ACTIONS(2915),
    [anon_sym_snorm] = ACTIONS(2915),
    [anon_sym_unorm] = ACTIONS(2915),
    [anon_sym_point] = ACTIONS(2915),
    [anon_sym_line] = ACTIONS(2915),
    [anon_sym_triangleadj] = ACTIONS(2915),
    [anon_sym_lineadj] = ACTIONS(2915),
    [anon_sym_triangle] = ACTIONS(2915),
    [anon_sym_interface] = ACTIONS(2915),
    [anon_sym_extension] = ACTIONS(2915),
    [anon_sym_where] = ACTIONS(2915),
    [anon_sym___exported] = ACTIONS(2915),
  },
  [285] = {
    [sym_catch_clause] = STATE(262),
    [aux_sym_constructor_try_statement_repeat1] = STATE(262),
    [sym_identifier] = ACTIONS(2920),
    [aux_sym_preproc_include_token1] = ACTIONS(2920),
    [aux_sym_preproc_def_token1] = ACTIONS(2920),
    [aux_sym_preproc_if_token1] = ACTIONS(2920),
    [aux_sym_preproc_if_token2] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2920),
    [aux_sym_preproc_else_token1] = ACTIONS(2920),
    [aux_sym_preproc_elif_token1] = ACTIONS(2920),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2920),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2920),
    [sym_preproc_directive] = ACTIONS(2920),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2920),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2920),
    [anon_sym_SEMI] = ACTIONS(2922),
    [anon_sym___extension__] = ACTIONS(2920),
    [anon_sym_typedef] = ACTIONS(2920),
    [anon_sym_in] = ACTIONS(2920),
    [anon_sym_out] = ACTIONS(2920),
    [anon_sym_inout] = ACTIONS(2920),
    [anon_sym_virtual] = ACTIONS(2920),
    [anon_sym_extern] = ACTIONS(2920),
    [anon_sym___attribute__] = ACTIONS(2920),
    [anon_sym___attribute] = ACTIONS(2920),
    [anon_sym_using] = ACTIONS(2920),
    [anon_sym_COLON_COLON] = ACTIONS(2922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2922),
    [anon_sym___declspec] = ACTIONS(2920),
    [anon_sym___based] = ACTIONS(2920),
    [anon_sym___cdecl] = ACTIONS(2920),
    [anon_sym___clrcall] = ACTIONS(2920),
    [anon_sym___stdcall] = ACTIONS(2920),
    [anon_sym___fastcall] = ACTIONS(2920),
    [anon_sym___thiscall] = ACTIONS(2920),
    [anon_sym___vectorcall] = ACTIONS(2920),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_signed] = ACTIONS(2920),
    [anon_sym_unsigned] = ACTIONS(2920),
    [anon_sym_long] = ACTIONS(2920),
    [anon_sym_short] = ACTIONS(2920),
    [anon_sym_LBRACK] = ACTIONS(2920),
    [anon_sym_static] = ACTIONS(2920),
    [anon_sym_register] = ACTIONS(2920),
    [anon_sym_inline] = ACTIONS(2920),
    [anon_sym___inline] = ACTIONS(2920),
    [anon_sym___inline__] = ACTIONS(2920),
    [anon_sym___forceinline] = ACTIONS(2920),
    [anon_sym_thread_local] = ACTIONS(2920),
    [anon_sym___thread] = ACTIONS(2920),
    [anon_sym_const] = ACTIONS(2920),
    [anon_sym_constexpr] = ACTIONS(2920),
    [anon_sym_volatile] = ACTIONS(2920),
    [anon_sym_restrict] = ACTIONS(2920),
    [anon_sym___restrict__] = ACTIONS(2920),
    [anon_sym__Atomic] = ACTIONS(2920),
    [anon_sym__Noreturn] = ACTIONS(2920),
    [anon_sym_noreturn] = ACTIONS(2920),
    [anon_sym__Nonnull] = ACTIONS(2920),
    [anon_sym_mutable] = ACTIONS(2920),
    [anon_sym_constinit] = ACTIONS(2920),
    [anon_sym_consteval] = ACTIONS(2920),
    [anon_sym_alignas] = ACTIONS(2920),
    [anon_sym__Alignas] = ACTIONS(2920),
    [sym_primitive_type] = ACTIONS(2920),
    [anon_sym_enum] = ACTIONS(2920),
    [anon_sym_class] = ACTIONS(2920),
    [anon_sym_struct] = ACTIONS(2920),
    [anon_sym_union] = ACTIONS(2920),
    [anon_sym_if] = ACTIONS(2920),
    [anon_sym_switch] = ACTIONS(2920),
    [anon_sym_case] = ACTIONS(2920),
    [anon_sym_default] = ACTIONS(2920),
    [anon_sym_while] = ACTIONS(2920),
    [anon_sym_do] = ACTIONS(2920),
    [anon_sym_for] = ACTIONS(2920),
    [anon_sym_return] = ACTIONS(2920),
    [anon_sym_break] = ACTIONS(2920),
    [anon_sym_continue] = ACTIONS(2920),
    [anon_sym_goto] = ACTIONS(2920),
    [anon_sym___try] = ACTIONS(2920),
    [anon_sym___leave] = ACTIONS(2920),
    [anon_sym_not] = ACTIONS(2920),
    [anon_sym_compl] = ACTIONS(2920),
    [anon_sym_DASH_DASH] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2922),
    [anon_sym_sizeof] = ACTIONS(2920),
    [anon_sym___alignof__] = ACTIONS(2920),
    [anon_sym___alignof] = ACTIONS(2920),
    [anon_sym__alignof] = ACTIONS(2920),
    [anon_sym_alignof] = ACTIONS(2920),
    [anon_sym__Alignof] = ACTIONS(2920),
    [anon_sym_offsetof] = ACTIONS(2920),
    [anon_sym__Generic] = ACTIONS(2920),
    [anon_sym_asm] = ACTIONS(2920),
    [anon_sym___asm__] = ACTIONS(2920),
    [anon_sym___asm] = ACTIONS(2920),
    [sym_number_literal] = ACTIONS(2922),
    [anon_sym_L_SQUOTE] = ACTIONS(2922),
    [anon_sym_u_SQUOTE] = ACTIONS(2922),
    [anon_sym_U_SQUOTE] = ACTIONS(2922),
    [anon_sym_u8_SQUOTE] = ACTIONS(2922),
    [anon_sym_SQUOTE] = ACTIONS(2922),
    [anon_sym_L_DQUOTE] = ACTIONS(2922),
    [anon_sym_u_DQUOTE] = ACTIONS(2922),
    [anon_sym_U_DQUOTE] = ACTIONS(2922),
    [anon_sym_u8_DQUOTE] = ACTIONS(2922),
    [anon_sym_DQUOTE] = ACTIONS(2922),
    [sym_true] = ACTIONS(2920),
    [sym_false] = ACTIONS(2920),
    [anon_sym_NULL] = ACTIONS(2920),
    [anon_sym_nullptr] = ACTIONS(2920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2920),
    [anon_sym_let] = ACTIONS(2920),
    [anon_sym_This] = ACTIONS(2920),
    [anon_sym_decltype] = ACTIONS(2920),
    [anon_sym_explicit] = ACTIONS(2920),
    [anon_sym_typename] = ACTIONS(2920),
    [anon_sym_template] = ACTIONS(2920),
    [anon_sym_operator] = ACTIONS(2920),
    [anon_sym_try] = ACTIONS(2920),
    [anon_sym_delete] = ACTIONS(2920),
    [anon_sym_throw] = ACTIONS(2920),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_static_assert] = ACTIONS(2920),
    [anon_sym_concept] = ACTIONS(2920),
    [anon_sym_co_return] = ACTIONS(2920),
    [anon_sym_co_yield] = ACTIONS(2920),
    [anon_sym_catch] = ACTIONS(2889),
    [anon_sym_R_DQUOTE] = ACTIONS(2922),
    [anon_sym_LR_DQUOTE] = ACTIONS(2922),
    [anon_sym_uR_DQUOTE] = ACTIONS(2922),
    [anon_sym_UR_DQUOTE] = ACTIONS(2922),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2922),
    [anon_sym_co_await] = ACTIONS(2920),
    [anon_sym_new] = ACTIONS(2920),
    [anon_sym_requires] = ACTIONS(2920),
    [sym_this] = ACTIONS(2920),
    [anon_sym_discard] = ACTIONS(2920),
    [anon_sym_precise] = ACTIONS(2920),
    [anon_sym_shared] = ACTIONS(2920),
    [anon_sym_groupshared] = ACTIONS(2920),
    [anon_sym_uniform] = ACTIONS(2920),
    [anon_sym_row_major] = ACTIONS(2920),
    [anon_sym_column_major] = ACTIONS(2920),
    [anon_sym_globallycoherent] = ACTIONS(2920),
    [anon_sym_centroid] = ACTIONS(2920),
    [anon_sym_noperspective] = ACTIONS(2920),
    [anon_sym_nointerpolation] = ACTIONS(2920),
    [anon_sym_sample] = ACTIONS(2920),
    [anon_sym_linear] = ACTIONS(2920),
    [anon_sym_snorm] = ACTIONS(2920),
    [anon_sym_unorm] = ACTIONS(2920),
    [anon_sym_point] = ACTIONS(2920),
    [anon_sym_line] = ACTIONS(2920),
    [anon_sym_triangleadj] = ACTIONS(2920),
    [anon_sym_lineadj] = ACTIONS(2920),
    [anon_sym_triangle] = ACTIONS(2920),
    [anon_sym_cbuffer] = ACTIONS(2920),
    [anon_sym_interface] = ACTIONS(2920),
    [anon_sym_extension] = ACTIONS(2920),
  },
  [286] = {
    [ts_builtin_sym_end] = ACTIONS(2924),
    [sym_identifier] = ACTIONS(2926),
    [aux_sym_preproc_include_token1] = ACTIONS(2926),
    [aux_sym_preproc_def_token1] = ACTIONS(2926),
    [anon_sym_COMMA] = ACTIONS(2924),
    [anon_sym_RPAREN] = ACTIONS(2924),
    [aux_sym_preproc_if_token1] = ACTIONS(2926),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2926),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2926),
    [sym_preproc_directive] = ACTIONS(2926),
    [anon_sym_LPAREN2] = ACTIONS(2924),
    [anon_sym_BANG] = ACTIONS(2924),
    [anon_sym_TILDE] = ACTIONS(2924),
    [anon_sym_DASH] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2926),
    [anon_sym_STAR] = ACTIONS(2924),
    [anon_sym_AMP_AMP] = ACTIONS(2924),
    [anon_sym_AMP] = ACTIONS(2926),
    [anon_sym_SEMI] = ACTIONS(2924),
    [anon_sym___extension__] = ACTIONS(2926),
    [anon_sym_typedef] = ACTIONS(2926),
    [anon_sym_in] = ACTIONS(2926),
    [anon_sym_out] = ACTIONS(2926),
    [anon_sym_inout] = ACTIONS(2926),
    [anon_sym_virtual] = ACTIONS(2926),
    [anon_sym_extern] = ACTIONS(2926),
    [anon_sym___attribute__] = ACTIONS(2926),
    [anon_sym___attribute] = ACTIONS(2926),
    [anon_sym_using] = ACTIONS(2926),
    [anon_sym_COLON_COLON] = ACTIONS(2924),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2924),
    [anon_sym___declspec] = ACTIONS(2926),
    [anon_sym___based] = ACTIONS(2926),
    [anon_sym___cdecl] = ACTIONS(2926),
    [anon_sym___clrcall] = ACTIONS(2926),
    [anon_sym___stdcall] = ACTIONS(2926),
    [anon_sym___fastcall] = ACTIONS(2926),
    [anon_sym___thiscall] = ACTIONS(2926),
    [anon_sym___vectorcall] = ACTIONS(2926),
    [anon_sym_LBRACE] = ACTIONS(2924),
    [anon_sym_signed] = ACTIONS(2926),
    [anon_sym_unsigned] = ACTIONS(2926),
    [anon_sym_long] = ACTIONS(2926),
    [anon_sym_short] = ACTIONS(2926),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_static] = ACTIONS(2926),
    [anon_sym_register] = ACTIONS(2926),
    [anon_sym_inline] = ACTIONS(2926),
    [anon_sym___inline] = ACTIONS(2926),
    [anon_sym___inline__] = ACTIONS(2926),
    [anon_sym___forceinline] = ACTIONS(2926),
    [anon_sym_thread_local] = ACTIONS(2926),
    [anon_sym___thread] = ACTIONS(2926),
    [anon_sym_const] = ACTIONS(2926),
    [anon_sym_constexpr] = ACTIONS(2926),
    [anon_sym_volatile] = ACTIONS(2926),
    [anon_sym_restrict] = ACTIONS(2926),
    [anon_sym___restrict__] = ACTIONS(2926),
    [anon_sym__Atomic] = ACTIONS(2926),
    [anon_sym__Noreturn] = ACTIONS(2926),
    [anon_sym_noreturn] = ACTIONS(2926),
    [anon_sym__Nonnull] = ACTIONS(2926),
    [anon_sym_mutable] = ACTIONS(2926),
    [anon_sym_constinit] = ACTIONS(2926),
    [anon_sym_consteval] = ACTIONS(2926),
    [anon_sym_alignas] = ACTIONS(2926),
    [anon_sym__Alignas] = ACTIONS(2926),
    [sym_primitive_type] = ACTIONS(2926),
    [anon_sym_enum] = ACTIONS(2926),
    [anon_sym_class] = ACTIONS(2926),
    [anon_sym_struct] = ACTIONS(2926),
    [anon_sym_union] = ACTIONS(2926),
    [anon_sym_if] = ACTIONS(2926),
    [anon_sym_switch] = ACTIONS(2926),
    [anon_sym_case] = ACTIONS(2926),
    [anon_sym_default] = ACTIONS(2926),
    [anon_sym_while] = ACTIONS(2926),
    [anon_sym_do] = ACTIONS(2926),
    [anon_sym_for] = ACTIONS(2926),
    [anon_sym_return] = ACTIONS(2926),
    [anon_sym_break] = ACTIONS(2926),
    [anon_sym_continue] = ACTIONS(2926),
    [anon_sym_goto] = ACTIONS(2926),
    [anon_sym_not] = ACTIONS(2926),
    [anon_sym_compl] = ACTIONS(2926),
    [anon_sym_DASH_DASH] = ACTIONS(2924),
    [anon_sym_PLUS_PLUS] = ACTIONS(2924),
    [anon_sym_sizeof] = ACTIONS(2926),
    [anon_sym___alignof__] = ACTIONS(2926),
    [anon_sym___alignof] = ACTIONS(2926),
    [anon_sym__alignof] = ACTIONS(2926),
    [anon_sym_alignof] = ACTIONS(2926),
    [anon_sym__Alignof] = ACTIONS(2926),
    [anon_sym_offsetof] = ACTIONS(2926),
    [anon_sym__Generic] = ACTIONS(2926),
    [anon_sym_asm] = ACTIONS(2926),
    [anon_sym___asm__] = ACTIONS(2926),
    [anon_sym___asm] = ACTIONS(2926),
    [anon_sym_DOT] = ACTIONS(2926),
    [sym_number_literal] = ACTIONS(2924),
    [anon_sym_L_SQUOTE] = ACTIONS(2924),
    [anon_sym_u_SQUOTE] = ACTIONS(2924),
    [anon_sym_U_SQUOTE] = ACTIONS(2924),
    [anon_sym_u8_SQUOTE] = ACTIONS(2924),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_L_DQUOTE] = ACTIONS(2924),
    [anon_sym_u_DQUOTE] = ACTIONS(2924),
    [anon_sym_U_DQUOTE] = ACTIONS(2924),
    [anon_sym_u8_DQUOTE] = ACTIONS(2924),
    [anon_sym_DQUOTE] = ACTIONS(2924),
    [sym_true] = ACTIONS(2926),
    [sym_false] = ACTIONS(2926),
    [anon_sym_NULL] = ACTIONS(2926),
    [anon_sym_nullptr] = ACTIONS(2926),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2926),
    [anon_sym_let] = ACTIONS(2926),
    [anon_sym_This] = ACTIONS(2926),
    [anon_sym_decltype] = ACTIONS(2926),
    [anon_sym_final] = ACTIONS(2926),
    [anon_sym_override] = ACTIONS(2926),
    [anon_sym_explicit] = ACTIONS(2926),
    [anon_sym_typename] = ACTIONS(2926),
    [anon_sym_export] = ACTIONS(2926),
    [anon_sym_module] = ACTIONS(2926),
    [anon_sym_import] = ACTIONS(2926),
    [anon_sym_template] = ACTIONS(2926),
    [anon_sym_GT2] = ACTIONS(2924),
    [anon_sym_operator] = ACTIONS(2926),
    [anon_sym_try] = ACTIONS(2926),
    [anon_sym_delete] = ACTIONS(2926),
    [anon_sym_throw] = ACTIONS(2926),
    [anon_sym_namespace] = ACTIONS(2926),
    [anon_sym_static_assert] = ACTIONS(2926),
    [anon_sym_concept] = ACTIONS(2926),
    [anon_sym_co_return] = ACTIONS(2926),
    [anon_sym_co_yield] = ACTIONS(2926),
    [anon_sym_R_DQUOTE] = ACTIONS(2924),
    [anon_sym_LR_DQUOTE] = ACTIONS(2924),
    [anon_sym_uR_DQUOTE] = ACTIONS(2924),
    [anon_sym_UR_DQUOTE] = ACTIONS(2924),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2924),
    [anon_sym_co_await] = ACTIONS(2926),
    [anon_sym_new] = ACTIONS(2926),
    [anon_sym_requires] = ACTIONS(2926),
    [sym_this] = ACTIONS(2926),
    [anon_sym_precise] = ACTIONS(2926),
    [anon_sym_shared] = ACTIONS(2926),
    [anon_sym_groupshared] = ACTIONS(2926),
    [anon_sym_uniform] = ACTIONS(2926),
    [anon_sym_row_major] = ACTIONS(2926),
    [anon_sym_column_major] = ACTIONS(2926),
    [anon_sym_globallycoherent] = ACTIONS(2926),
    [anon_sym_centroid] = ACTIONS(2926),
    [anon_sym_noperspective] = ACTIONS(2926),
    [anon_sym_nointerpolation] = ACTIONS(2926),
    [anon_sym_sample] = ACTIONS(2926),
    [anon_sym_linear] = ACTIONS(2926),
    [anon_sym_snorm] = ACTIONS(2926),
    [anon_sym_unorm] = ACTIONS(2926),
    [anon_sym_point] = ACTIONS(2926),
    [anon_sym_line] = ACTIONS(2926),
    [anon_sym_triangleadj] = ACTIONS(2926),
    [anon_sym_lineadj] = ACTIONS(2926),
    [anon_sym_triangle] = ACTIONS(2926),
    [anon_sym_interface] = ACTIONS(2926),
    [anon_sym_extension] = ACTIONS(2926),
    [anon_sym_where] = ACTIONS(2926),
    [anon_sym___exported] = ACTIONS(2926),
  },
  [287] = {
    [ts_builtin_sym_end] = ACTIONS(2928),
    [sym_identifier] = ACTIONS(2930),
    [aux_sym_preproc_include_token1] = ACTIONS(2930),
    [aux_sym_preproc_def_token1] = ACTIONS(2930),
    [anon_sym_COMMA] = ACTIONS(2928),
    [anon_sym_RPAREN] = ACTIONS(2928),
    [aux_sym_preproc_if_token1] = ACTIONS(2930),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2930),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2930),
    [sym_preproc_directive] = ACTIONS(2930),
    [anon_sym_LPAREN2] = ACTIONS(2928),
    [anon_sym_BANG] = ACTIONS(2928),
    [anon_sym_TILDE] = ACTIONS(2928),
    [anon_sym_DASH] = ACTIONS(2930),
    [anon_sym_PLUS] = ACTIONS(2930),
    [anon_sym_STAR] = ACTIONS(2928),
    [anon_sym_AMP_AMP] = ACTIONS(2928),
    [anon_sym_AMP] = ACTIONS(2930),
    [anon_sym_SEMI] = ACTIONS(2928),
    [anon_sym___extension__] = ACTIONS(2930),
    [anon_sym_typedef] = ACTIONS(2930),
    [anon_sym_in] = ACTIONS(2930),
    [anon_sym_out] = ACTIONS(2930),
    [anon_sym_inout] = ACTIONS(2930),
    [anon_sym_virtual] = ACTIONS(2930),
    [anon_sym_extern] = ACTIONS(2930),
    [anon_sym___attribute__] = ACTIONS(2930),
    [anon_sym___attribute] = ACTIONS(2930),
    [anon_sym_using] = ACTIONS(2930),
    [anon_sym_COLON_COLON] = ACTIONS(2928),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2928),
    [anon_sym___declspec] = ACTIONS(2930),
    [anon_sym___based] = ACTIONS(2930),
    [anon_sym___cdecl] = ACTIONS(2930),
    [anon_sym___clrcall] = ACTIONS(2930),
    [anon_sym___stdcall] = ACTIONS(2930),
    [anon_sym___fastcall] = ACTIONS(2930),
    [anon_sym___thiscall] = ACTIONS(2930),
    [anon_sym___vectorcall] = ACTIONS(2930),
    [anon_sym_LBRACE] = ACTIONS(2928),
    [anon_sym_signed] = ACTIONS(2930),
    [anon_sym_unsigned] = ACTIONS(2930),
    [anon_sym_long] = ACTIONS(2930),
    [anon_sym_short] = ACTIONS(2930),
    [anon_sym_LBRACK] = ACTIONS(2930),
    [anon_sym_static] = ACTIONS(2930),
    [anon_sym_register] = ACTIONS(2930),
    [anon_sym_inline] = ACTIONS(2930),
    [anon_sym___inline] = ACTIONS(2930),
    [anon_sym___inline__] = ACTIONS(2930),
    [anon_sym___forceinline] = ACTIONS(2930),
    [anon_sym_thread_local] = ACTIONS(2930),
    [anon_sym___thread] = ACTIONS(2930),
    [anon_sym_const] = ACTIONS(2930),
    [anon_sym_constexpr] = ACTIONS(2930),
    [anon_sym_volatile] = ACTIONS(2930),
    [anon_sym_restrict] = ACTIONS(2930),
    [anon_sym___restrict__] = ACTIONS(2930),
    [anon_sym__Atomic] = ACTIONS(2930),
    [anon_sym__Noreturn] = ACTIONS(2930),
    [anon_sym_noreturn] = ACTIONS(2930),
    [anon_sym__Nonnull] = ACTIONS(2930),
    [anon_sym_mutable] = ACTIONS(2930),
    [anon_sym_constinit] = ACTIONS(2930),
    [anon_sym_consteval] = ACTIONS(2930),
    [anon_sym_alignas] = ACTIONS(2930),
    [anon_sym__Alignas] = ACTIONS(2930),
    [sym_primitive_type] = ACTIONS(2930),
    [anon_sym_enum] = ACTIONS(2930),
    [anon_sym_class] = ACTIONS(2930),
    [anon_sym_struct] = ACTIONS(2930),
    [anon_sym_union] = ACTIONS(2930),
    [anon_sym_if] = ACTIONS(2930),
    [anon_sym_switch] = ACTIONS(2930),
    [anon_sym_case] = ACTIONS(2930),
    [anon_sym_default] = ACTIONS(2930),
    [anon_sym_while] = ACTIONS(2930),
    [anon_sym_do] = ACTIONS(2930),
    [anon_sym_for] = ACTIONS(2930),
    [anon_sym_return] = ACTIONS(2930),
    [anon_sym_break] = ACTIONS(2930),
    [anon_sym_continue] = ACTIONS(2930),
    [anon_sym_goto] = ACTIONS(2930),
    [anon_sym_not] = ACTIONS(2930),
    [anon_sym_compl] = ACTIONS(2930),
    [anon_sym_DASH_DASH] = ACTIONS(2928),
    [anon_sym_PLUS_PLUS] = ACTIONS(2928),
    [anon_sym_sizeof] = ACTIONS(2930),
    [anon_sym___alignof__] = ACTIONS(2930),
    [anon_sym___alignof] = ACTIONS(2930),
    [anon_sym__alignof] = ACTIONS(2930),
    [anon_sym_alignof] = ACTIONS(2930),
    [anon_sym__Alignof] = ACTIONS(2930),
    [anon_sym_offsetof] = ACTIONS(2930),
    [anon_sym__Generic] = ACTIONS(2930),
    [anon_sym_asm] = ACTIONS(2930),
    [anon_sym___asm__] = ACTIONS(2930),
    [anon_sym___asm] = ACTIONS(2930),
    [anon_sym_DOT] = ACTIONS(2930),
    [sym_number_literal] = ACTIONS(2928),
    [anon_sym_L_SQUOTE] = ACTIONS(2928),
    [anon_sym_u_SQUOTE] = ACTIONS(2928),
    [anon_sym_U_SQUOTE] = ACTIONS(2928),
    [anon_sym_u8_SQUOTE] = ACTIONS(2928),
    [anon_sym_SQUOTE] = ACTIONS(2928),
    [anon_sym_L_DQUOTE] = ACTIONS(2928),
    [anon_sym_u_DQUOTE] = ACTIONS(2928),
    [anon_sym_U_DQUOTE] = ACTIONS(2928),
    [anon_sym_u8_DQUOTE] = ACTIONS(2928),
    [anon_sym_DQUOTE] = ACTIONS(2928),
    [sym_true] = ACTIONS(2930),
    [sym_false] = ACTIONS(2930),
    [anon_sym_NULL] = ACTIONS(2930),
    [anon_sym_nullptr] = ACTIONS(2930),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2930),
    [anon_sym_This] = ACTIONS(2930),
    [anon_sym_decltype] = ACTIONS(2930),
    [anon_sym_final] = ACTIONS(2930),
    [anon_sym_override] = ACTIONS(2930),
    [anon_sym_explicit] = ACTIONS(2930),
    [anon_sym_typename] = ACTIONS(2930),
    [anon_sym_export] = ACTIONS(2930),
    [anon_sym_module] = ACTIONS(2930),
    [anon_sym_import] = ACTIONS(2930),
    [anon_sym_template] = ACTIONS(2930),
    [anon_sym_GT2] = ACTIONS(2928),
    [anon_sym_operator] = ACTIONS(2930),
    [anon_sym_try] = ACTIONS(2930),
    [anon_sym_delete] = ACTIONS(2930),
    [anon_sym_throw] = ACTIONS(2930),
    [anon_sym_namespace] = ACTIONS(2930),
    [anon_sym_static_assert] = ACTIONS(2930),
    [anon_sym_concept] = ACTIONS(2930),
    [anon_sym_co_return] = ACTIONS(2930),
    [anon_sym_co_yield] = ACTIONS(2930),
    [anon_sym_R_DQUOTE] = ACTIONS(2928),
    [anon_sym_LR_DQUOTE] = ACTIONS(2928),
    [anon_sym_uR_DQUOTE] = ACTIONS(2928),
    [anon_sym_UR_DQUOTE] = ACTIONS(2928),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2928),
    [anon_sym_co_await] = ACTIONS(2930),
    [anon_sym_new] = ACTIONS(2930),
    [anon_sym_requires] = ACTIONS(2930),
    [sym_this] = ACTIONS(2930),
    [anon_sym_precise] = ACTIONS(2930),
    [anon_sym_shared] = ACTIONS(2930),
    [anon_sym_groupshared] = ACTIONS(2930),
    [anon_sym_uniform] = ACTIONS(2930),
    [anon_sym_row_major] = ACTIONS(2930),
    [anon_sym_column_major] = ACTIONS(2930),
    [anon_sym_globallycoherent] = ACTIONS(2930),
    [anon_sym_centroid] = ACTIONS(2930),
    [anon_sym_noperspective] = ACTIONS(2930),
    [anon_sym_nointerpolation] = ACTIONS(2930),
    [anon_sym_sample] = ACTIONS(2930),
    [anon_sym_linear] = ACTIONS(2930),
    [anon_sym_snorm] = ACTIONS(2930),
    [anon_sym_unorm] = ACTIONS(2930),
    [anon_sym_point] = ACTIONS(2930),
    [anon_sym_line] = ACTIONS(2930),
    [anon_sym_triangleadj] = ACTIONS(2930),
    [anon_sym_lineadj] = ACTIONS(2930),
    [anon_sym_triangle] = ACTIONS(2930),
    [anon_sym_interface] = ACTIONS(2930),
    [anon_sym_extension] = ACTIONS(2930),
    [anon_sym_where] = ACTIONS(2930),
    [anon_sym___exported] = ACTIONS(2930),
  },
  [288] = {
    [ts_builtin_sym_end] = ACTIONS(2932),
    [sym_identifier] = ACTIONS(2934),
    [aux_sym_preproc_include_token1] = ACTIONS(2934),
    [aux_sym_preproc_def_token1] = ACTIONS(2934),
    [anon_sym_COMMA] = ACTIONS(2932),
    [anon_sym_RPAREN] = ACTIONS(2932),
    [aux_sym_preproc_if_token1] = ACTIONS(2934),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2934),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2934),
    [sym_preproc_directive] = ACTIONS(2934),
    [anon_sym_LPAREN2] = ACTIONS(2932),
    [anon_sym_BANG] = ACTIONS(2932),
    [anon_sym_TILDE] = ACTIONS(2932),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_STAR] = ACTIONS(2932),
    [anon_sym_AMP_AMP] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym___extension__] = ACTIONS(2934),
    [anon_sym_typedef] = ACTIONS(2934),
    [anon_sym_in] = ACTIONS(2934),
    [anon_sym_out] = ACTIONS(2934),
    [anon_sym_inout] = ACTIONS(2934),
    [anon_sym_virtual] = ACTIONS(2934),
    [anon_sym_extern] = ACTIONS(2934),
    [anon_sym___attribute__] = ACTIONS(2934),
    [anon_sym___attribute] = ACTIONS(2934),
    [anon_sym_using] = ACTIONS(2934),
    [anon_sym_COLON_COLON] = ACTIONS(2932),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2932),
    [anon_sym___declspec] = ACTIONS(2934),
    [anon_sym___based] = ACTIONS(2934),
    [anon_sym___cdecl] = ACTIONS(2934),
    [anon_sym___clrcall] = ACTIONS(2934),
    [anon_sym___stdcall] = ACTIONS(2934),
    [anon_sym___fastcall] = ACTIONS(2934),
    [anon_sym___thiscall] = ACTIONS(2934),
    [anon_sym___vectorcall] = ACTIONS(2934),
    [anon_sym_LBRACE] = ACTIONS(2932),
    [anon_sym_signed] = ACTIONS(2934),
    [anon_sym_unsigned] = ACTIONS(2934),
    [anon_sym_long] = ACTIONS(2934),
    [anon_sym_short] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [anon_sym_static] = ACTIONS(2934),
    [anon_sym_register] = ACTIONS(2934),
    [anon_sym_inline] = ACTIONS(2934),
    [anon_sym___inline] = ACTIONS(2934),
    [anon_sym___inline__] = ACTIONS(2934),
    [anon_sym___forceinline] = ACTIONS(2934),
    [anon_sym_thread_local] = ACTIONS(2934),
    [anon_sym___thread] = ACTIONS(2934),
    [anon_sym_const] = ACTIONS(2934),
    [anon_sym_constexpr] = ACTIONS(2934),
    [anon_sym_volatile] = ACTIONS(2934),
    [anon_sym_restrict] = ACTIONS(2934),
    [anon_sym___restrict__] = ACTIONS(2934),
    [anon_sym__Atomic] = ACTIONS(2934),
    [anon_sym__Noreturn] = ACTIONS(2934),
    [anon_sym_noreturn] = ACTIONS(2934),
    [anon_sym__Nonnull] = ACTIONS(2934),
    [anon_sym_mutable] = ACTIONS(2934),
    [anon_sym_constinit] = ACTIONS(2934),
    [anon_sym_consteval] = ACTIONS(2934),
    [anon_sym_alignas] = ACTIONS(2934),
    [anon_sym__Alignas] = ACTIONS(2934),
    [sym_primitive_type] = ACTIONS(2934),
    [anon_sym_enum] = ACTIONS(2934),
    [anon_sym_class] = ACTIONS(2934),
    [anon_sym_struct] = ACTIONS(2934),
    [anon_sym_union] = ACTIONS(2934),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_switch] = ACTIONS(2934),
    [anon_sym_case] = ACTIONS(2934),
    [anon_sym_default] = ACTIONS(2934),
    [anon_sym_while] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2934),
    [anon_sym_for] = ACTIONS(2934),
    [anon_sym_return] = ACTIONS(2934),
    [anon_sym_break] = ACTIONS(2934),
    [anon_sym_continue] = ACTIONS(2934),
    [anon_sym_goto] = ACTIONS(2934),
    [anon_sym_not] = ACTIONS(2934),
    [anon_sym_compl] = ACTIONS(2934),
    [anon_sym_DASH_DASH] = ACTIONS(2932),
    [anon_sym_PLUS_PLUS] = ACTIONS(2932),
    [anon_sym_sizeof] = ACTIONS(2934),
    [anon_sym___alignof__] = ACTIONS(2934),
    [anon_sym___alignof] = ACTIONS(2934),
    [anon_sym__alignof] = ACTIONS(2934),
    [anon_sym_alignof] = ACTIONS(2934),
    [anon_sym__Alignof] = ACTIONS(2934),
    [anon_sym_offsetof] = ACTIONS(2934),
    [anon_sym__Generic] = ACTIONS(2934),
    [anon_sym_asm] = ACTIONS(2934),
    [anon_sym___asm__] = ACTIONS(2934),
    [anon_sym___asm] = ACTIONS(2934),
    [anon_sym_DOT] = ACTIONS(2934),
    [sym_number_literal] = ACTIONS(2932),
    [anon_sym_L_SQUOTE] = ACTIONS(2932),
    [anon_sym_u_SQUOTE] = ACTIONS(2932),
    [anon_sym_U_SQUOTE] = ACTIONS(2932),
    [anon_sym_u8_SQUOTE] = ACTIONS(2932),
    [anon_sym_SQUOTE] = ACTIONS(2932),
    [anon_sym_L_DQUOTE] = ACTIONS(2932),
    [anon_sym_u_DQUOTE] = ACTIONS(2932),
    [anon_sym_U_DQUOTE] = ACTIONS(2932),
    [anon_sym_u8_DQUOTE] = ACTIONS(2932),
    [anon_sym_DQUOTE] = ACTIONS(2932),
    [sym_true] = ACTIONS(2934),
    [sym_false] = ACTIONS(2934),
    [anon_sym_NULL] = ACTIONS(2934),
    [anon_sym_nullptr] = ACTIONS(2934),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_This] = ACTIONS(2934),
    [anon_sym_decltype] = ACTIONS(2934),
    [anon_sym_final] = ACTIONS(2934),
    [anon_sym_override] = ACTIONS(2934),
    [anon_sym_explicit] = ACTIONS(2934),
    [anon_sym_typename] = ACTIONS(2934),
    [anon_sym_export] = ACTIONS(2934),
    [anon_sym_module] = ACTIONS(2934),
    [anon_sym_import] = ACTIONS(2934),
    [anon_sym_template] = ACTIONS(2934),
    [anon_sym_GT2] = ACTIONS(2932),
    [anon_sym_operator] = ACTIONS(2934),
    [anon_sym_try] = ACTIONS(2934),
    [anon_sym_delete] = ACTIONS(2934),
    [anon_sym_throw] = ACTIONS(2934),
    [anon_sym_namespace] = ACTIONS(2934),
    [anon_sym_static_assert] = ACTIONS(2934),
    [anon_sym_concept] = ACTIONS(2934),
    [anon_sym_co_return] = ACTIONS(2934),
    [anon_sym_co_yield] = ACTIONS(2934),
    [anon_sym_R_DQUOTE] = ACTIONS(2932),
    [anon_sym_LR_DQUOTE] = ACTIONS(2932),
    [anon_sym_uR_DQUOTE] = ACTIONS(2932),
    [anon_sym_UR_DQUOTE] = ACTIONS(2932),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2932),
    [anon_sym_co_await] = ACTIONS(2934),
    [anon_sym_new] = ACTIONS(2934),
    [anon_sym_requires] = ACTIONS(2934),
    [sym_this] = ACTIONS(2934),
    [anon_sym_precise] = ACTIONS(2934),
    [anon_sym_shared] = ACTIONS(2934),
    [anon_sym_groupshared] = ACTIONS(2934),
    [anon_sym_uniform] = ACTIONS(2934),
    [anon_sym_row_major] = ACTIONS(2934),
    [anon_sym_column_major] = ACTIONS(2934),
    [anon_sym_globallycoherent] = ACTIONS(2934),
    [anon_sym_centroid] = ACTIONS(2934),
    [anon_sym_noperspective] = ACTIONS(2934),
    [anon_sym_nointerpolation] = ACTIONS(2934),
    [anon_sym_sample] = ACTIONS(2934),
    [anon_sym_linear] = ACTIONS(2934),
    [anon_sym_snorm] = ACTIONS(2934),
    [anon_sym_unorm] = ACTIONS(2934),
    [anon_sym_point] = ACTIONS(2934),
    [anon_sym_line] = ACTIONS(2934),
    [anon_sym_triangleadj] = ACTIONS(2934),
    [anon_sym_lineadj] = ACTIONS(2934),
    [anon_sym_triangle] = ACTIONS(2934),
    [anon_sym_interface] = ACTIONS(2934),
    [anon_sym_extension] = ACTIONS(2934),
    [anon_sym_where] = ACTIONS(2934),
    [anon_sym___exported] = ACTIONS(2934),
  },
  [289] = {
    [ts_builtin_sym_end] = ACTIONS(2936),
    [sym_identifier] = ACTIONS(2938),
    [aux_sym_preproc_include_token1] = ACTIONS(2938),
    [aux_sym_preproc_def_token1] = ACTIONS(2938),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_RPAREN] = ACTIONS(2936),
    [aux_sym_preproc_if_token1] = ACTIONS(2938),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2938),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2938),
    [sym_preproc_directive] = ACTIONS(2938),
    [anon_sym_LPAREN2] = ACTIONS(2936),
    [anon_sym_BANG] = ACTIONS(2936),
    [anon_sym_TILDE] = ACTIONS(2936),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_STAR] = ACTIONS(2936),
    [anon_sym_AMP_AMP] = ACTIONS(2936),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_SEMI] = ACTIONS(2936),
    [anon_sym___extension__] = ACTIONS(2938),
    [anon_sym_typedef] = ACTIONS(2938),
    [anon_sym_in] = ACTIONS(2938),
    [anon_sym_out] = ACTIONS(2938),
    [anon_sym_inout] = ACTIONS(2938),
    [anon_sym_virtual] = ACTIONS(2938),
    [anon_sym_extern] = ACTIONS(2938),
    [anon_sym___attribute__] = ACTIONS(2938),
    [anon_sym___attribute] = ACTIONS(2938),
    [anon_sym_using] = ACTIONS(2938),
    [anon_sym_COLON_COLON] = ACTIONS(2936),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2936),
    [anon_sym___declspec] = ACTIONS(2938),
    [anon_sym___based] = ACTIONS(2938),
    [anon_sym___cdecl] = ACTIONS(2938),
    [anon_sym___clrcall] = ACTIONS(2938),
    [anon_sym___stdcall] = ACTIONS(2938),
    [anon_sym___fastcall] = ACTIONS(2938),
    [anon_sym___thiscall] = ACTIONS(2938),
    [anon_sym___vectorcall] = ACTIONS(2938),
    [anon_sym_LBRACE] = ACTIONS(2936),
    [anon_sym_signed] = ACTIONS(2938),
    [anon_sym_unsigned] = ACTIONS(2938),
    [anon_sym_long] = ACTIONS(2938),
    [anon_sym_short] = ACTIONS(2938),
    [anon_sym_LBRACK] = ACTIONS(2938),
    [anon_sym_static] = ACTIONS(2938),
    [anon_sym_register] = ACTIONS(2938),
    [anon_sym_inline] = ACTIONS(2938),
    [anon_sym___inline] = ACTIONS(2938),
    [anon_sym___inline__] = ACTIONS(2938),
    [anon_sym___forceinline] = ACTIONS(2938),
    [anon_sym_thread_local] = ACTIONS(2938),
    [anon_sym___thread] = ACTIONS(2938),
    [anon_sym_const] = ACTIONS(2938),
    [anon_sym_constexpr] = ACTIONS(2938),
    [anon_sym_volatile] = ACTIONS(2938),
    [anon_sym_restrict] = ACTIONS(2938),
    [anon_sym___restrict__] = ACTIONS(2938),
    [anon_sym__Atomic] = ACTIONS(2938),
    [anon_sym__Noreturn] = ACTIONS(2938),
    [anon_sym_noreturn] = ACTIONS(2938),
    [anon_sym__Nonnull] = ACTIONS(2938),
    [anon_sym_mutable] = ACTIONS(2938),
    [anon_sym_constinit] = ACTIONS(2938),
    [anon_sym_consteval] = ACTIONS(2938),
    [anon_sym_alignas] = ACTIONS(2938),
    [anon_sym__Alignas] = ACTIONS(2938),
    [sym_primitive_type] = ACTIONS(2938),
    [anon_sym_enum] = ACTIONS(2938),
    [anon_sym_class] = ACTIONS(2938),
    [anon_sym_struct] = ACTIONS(2938),
    [anon_sym_union] = ACTIONS(2938),
    [anon_sym_if] = ACTIONS(2938),
    [anon_sym_switch] = ACTIONS(2938),
    [anon_sym_case] = ACTIONS(2938),
    [anon_sym_default] = ACTIONS(2938),
    [anon_sym_while] = ACTIONS(2938),
    [anon_sym_do] = ACTIONS(2938),
    [anon_sym_for] = ACTIONS(2938),
    [anon_sym_return] = ACTIONS(2938),
    [anon_sym_break] = ACTIONS(2938),
    [anon_sym_continue] = ACTIONS(2938),
    [anon_sym_goto] = ACTIONS(2938),
    [anon_sym_not] = ACTIONS(2938),
    [anon_sym_compl] = ACTIONS(2938),
    [anon_sym_DASH_DASH] = ACTIONS(2936),
    [anon_sym_PLUS_PLUS] = ACTIONS(2936),
    [anon_sym_sizeof] = ACTIONS(2938),
    [anon_sym___alignof__] = ACTIONS(2938),
    [anon_sym___alignof] = ACTIONS(2938),
    [anon_sym__alignof] = ACTIONS(2938),
    [anon_sym_alignof] = ACTIONS(2938),
    [anon_sym__Alignof] = ACTIONS(2938),
    [anon_sym_offsetof] = ACTIONS(2938),
    [anon_sym__Generic] = ACTIONS(2938),
    [anon_sym_asm] = ACTIONS(2938),
    [anon_sym___asm__] = ACTIONS(2938),
    [anon_sym___asm] = ACTIONS(2938),
    [anon_sym_DOT] = ACTIONS(2938),
    [sym_number_literal] = ACTIONS(2936),
    [anon_sym_L_SQUOTE] = ACTIONS(2936),
    [anon_sym_u_SQUOTE] = ACTIONS(2936),
    [anon_sym_U_SQUOTE] = ACTIONS(2936),
    [anon_sym_u8_SQUOTE] = ACTIONS(2936),
    [anon_sym_SQUOTE] = ACTIONS(2936),
    [anon_sym_L_DQUOTE] = ACTIONS(2936),
    [anon_sym_u_DQUOTE] = ACTIONS(2936),
    [anon_sym_U_DQUOTE] = ACTIONS(2936),
    [anon_sym_u8_DQUOTE] = ACTIONS(2936),
    [anon_sym_DQUOTE] = ACTIONS(2936),
    [sym_true] = ACTIONS(2938),
    [sym_false] = ACTIONS(2938),
    [anon_sym_NULL] = ACTIONS(2938),
    [anon_sym_nullptr] = ACTIONS(2938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2938),
    [anon_sym_let] = ACTIONS(2938),
    [anon_sym_This] = ACTIONS(2938),
    [anon_sym_decltype] = ACTIONS(2938),
    [anon_sym_final] = ACTIONS(2938),
    [anon_sym_override] = ACTIONS(2938),
    [anon_sym_explicit] = ACTIONS(2938),
    [anon_sym_typename] = ACTIONS(2938),
    [anon_sym_export] = ACTIONS(2938),
    [anon_sym_module] = ACTIONS(2938),
    [anon_sym_import] = ACTIONS(2938),
    [anon_sym_template] = ACTIONS(2938),
    [anon_sym_GT2] = ACTIONS(2936),
    [anon_sym_operator] = ACTIONS(2938),
    [anon_sym_try] = ACTIONS(2938),
    [anon_sym_delete] = ACTIONS(2938),
    [anon_sym_throw] = ACTIONS(2938),
    [anon_sym_namespace] = ACTIONS(2938),
    [anon_sym_static_assert] = ACTIONS(2938),
    [anon_sym_concept] = ACTIONS(2938),
    [anon_sym_co_return] = ACTIONS(2938),
    [anon_sym_co_yield] = ACTIONS(2938),
    [anon_sym_R_DQUOTE] = ACTIONS(2936),
    [anon_sym_LR_DQUOTE] = ACTIONS(2936),
    [anon_sym_uR_DQUOTE] = ACTIONS(2936),
    [anon_sym_UR_DQUOTE] = ACTIONS(2936),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2936),
    [anon_sym_co_await] = ACTIONS(2938),
    [anon_sym_new] = ACTIONS(2938),
    [anon_sym_requires] = ACTIONS(2938),
    [sym_this] = ACTIONS(2938),
    [anon_sym_precise] = ACTIONS(2938),
    [anon_sym_shared] = ACTIONS(2938),
    [anon_sym_groupshared] = ACTIONS(2938),
    [anon_sym_uniform] = ACTIONS(2938),
    [anon_sym_row_major] = ACTIONS(2938),
    [anon_sym_column_major] = ACTIONS(2938),
    [anon_sym_globallycoherent] = ACTIONS(2938),
    [anon_sym_centroid] = ACTIONS(2938),
    [anon_sym_noperspective] = ACTIONS(2938),
    [anon_sym_nointerpolation] = ACTIONS(2938),
    [anon_sym_sample] = ACTIONS(2938),
    [anon_sym_linear] = ACTIONS(2938),
    [anon_sym_snorm] = ACTIONS(2938),
    [anon_sym_unorm] = ACTIONS(2938),
    [anon_sym_point] = ACTIONS(2938),
    [anon_sym_line] = ACTIONS(2938),
    [anon_sym_triangleadj] = ACTIONS(2938),
    [anon_sym_lineadj] = ACTIONS(2938),
    [anon_sym_triangle] = ACTIONS(2938),
    [anon_sym_interface] = ACTIONS(2938),
    [anon_sym_extension] = ACTIONS(2938),
    [anon_sym_where] = ACTIONS(2938),
    [anon_sym___exported] = ACTIONS(2938),
  },
  [290] = {
    [ts_builtin_sym_end] = ACTIONS(2940),
    [sym_identifier] = ACTIONS(2942),
    [aux_sym_preproc_include_token1] = ACTIONS(2942),
    [aux_sym_preproc_def_token1] = ACTIONS(2942),
    [anon_sym_COMMA] = ACTIONS(2940),
    [anon_sym_RPAREN] = ACTIONS(2940),
    [aux_sym_preproc_if_token1] = ACTIONS(2942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2942),
    [sym_preproc_directive] = ACTIONS(2942),
    [anon_sym_LPAREN2] = ACTIONS(2940),
    [anon_sym_BANG] = ACTIONS(2940),
    [anon_sym_TILDE] = ACTIONS(2940),
    [anon_sym_DASH] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(2940),
    [anon_sym_AMP_AMP] = ACTIONS(2940),
    [anon_sym_AMP] = ACTIONS(2942),
    [anon_sym_SEMI] = ACTIONS(2940),
    [anon_sym___extension__] = ACTIONS(2942),
    [anon_sym_typedef] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_out] = ACTIONS(2942),
    [anon_sym_inout] = ACTIONS(2942),
    [anon_sym_virtual] = ACTIONS(2942),
    [anon_sym_extern] = ACTIONS(2942),
    [anon_sym___attribute__] = ACTIONS(2942),
    [anon_sym___attribute] = ACTIONS(2942),
    [anon_sym_using] = ACTIONS(2942),
    [anon_sym_COLON_COLON] = ACTIONS(2940),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2940),
    [anon_sym___declspec] = ACTIONS(2942),
    [anon_sym___based] = ACTIONS(2942),
    [anon_sym___cdecl] = ACTIONS(2942),
    [anon_sym___clrcall] = ACTIONS(2942),
    [anon_sym___stdcall] = ACTIONS(2942),
    [anon_sym___fastcall] = ACTIONS(2942),
    [anon_sym___thiscall] = ACTIONS(2942),
    [anon_sym___vectorcall] = ACTIONS(2942),
    [anon_sym_LBRACE] = ACTIONS(2940),
    [anon_sym_signed] = ACTIONS(2942),
    [anon_sym_unsigned] = ACTIONS(2942),
    [anon_sym_long] = ACTIONS(2942),
    [anon_sym_short] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(2942),
    [anon_sym_static] = ACTIONS(2942),
    [anon_sym_register] = ACTIONS(2942),
    [anon_sym_inline] = ACTIONS(2942),
    [anon_sym___inline] = ACTIONS(2942),
    [anon_sym___inline__] = ACTIONS(2942),
    [anon_sym___forceinline] = ACTIONS(2942),
    [anon_sym_thread_local] = ACTIONS(2942),
    [anon_sym___thread] = ACTIONS(2942),
    [anon_sym_const] = ACTIONS(2942),
    [anon_sym_constexpr] = ACTIONS(2942),
    [anon_sym_volatile] = ACTIONS(2942),
    [anon_sym_restrict] = ACTIONS(2942),
    [anon_sym___restrict__] = ACTIONS(2942),
    [anon_sym__Atomic] = ACTIONS(2942),
    [anon_sym__Noreturn] = ACTIONS(2942),
    [anon_sym_noreturn] = ACTIONS(2942),
    [anon_sym__Nonnull] = ACTIONS(2942),
    [anon_sym_mutable] = ACTIONS(2942),
    [anon_sym_constinit] = ACTIONS(2942),
    [anon_sym_consteval] = ACTIONS(2942),
    [anon_sym_alignas] = ACTIONS(2942),
    [anon_sym__Alignas] = ACTIONS(2942),
    [sym_primitive_type] = ACTIONS(2942),
    [anon_sym_enum] = ACTIONS(2942),
    [anon_sym_class] = ACTIONS(2942),
    [anon_sym_struct] = ACTIONS(2942),
    [anon_sym_union] = ACTIONS(2942),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_switch] = ACTIONS(2942),
    [anon_sym_case] = ACTIONS(2942),
    [anon_sym_default] = ACTIONS(2942),
    [anon_sym_while] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(2942),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_return] = ACTIONS(2942),
    [anon_sym_break] = ACTIONS(2942),
    [anon_sym_continue] = ACTIONS(2942),
    [anon_sym_goto] = ACTIONS(2942),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_compl] = ACTIONS(2942),
    [anon_sym_DASH_DASH] = ACTIONS(2940),
    [anon_sym_PLUS_PLUS] = ACTIONS(2940),
    [anon_sym_sizeof] = ACTIONS(2942),
    [anon_sym___alignof__] = ACTIONS(2942),
    [anon_sym___alignof] = ACTIONS(2942),
    [anon_sym__alignof] = ACTIONS(2942),
    [anon_sym_alignof] = ACTIONS(2942),
    [anon_sym__Alignof] = ACTIONS(2942),
    [anon_sym_offsetof] = ACTIONS(2942),
    [anon_sym__Generic] = ACTIONS(2942),
    [anon_sym_asm] = ACTIONS(2942),
    [anon_sym___asm__] = ACTIONS(2942),
    [anon_sym___asm] = ACTIONS(2942),
    [anon_sym_DOT] = ACTIONS(2942),
    [sym_number_literal] = ACTIONS(2940),
    [anon_sym_L_SQUOTE] = ACTIONS(2940),
    [anon_sym_u_SQUOTE] = ACTIONS(2940),
    [anon_sym_U_SQUOTE] = ACTIONS(2940),
    [anon_sym_u8_SQUOTE] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(2940),
    [anon_sym_L_DQUOTE] = ACTIONS(2940),
    [anon_sym_u_DQUOTE] = ACTIONS(2940),
    [anon_sym_U_DQUOTE] = ACTIONS(2940),
    [anon_sym_u8_DQUOTE] = ACTIONS(2940),
    [anon_sym_DQUOTE] = ACTIONS(2940),
    [sym_true] = ACTIONS(2942),
    [sym_false] = ACTIONS(2942),
    [anon_sym_NULL] = ACTIONS(2942),
    [anon_sym_nullptr] = ACTIONS(2942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2942),
    [anon_sym_let] = ACTIONS(2942),
    [anon_sym_This] = ACTIONS(2942),
    [anon_sym_decltype] = ACTIONS(2942),
    [anon_sym_final] = ACTIONS(2942),
    [anon_sym_override] = ACTIONS(2942),
    [anon_sym_explicit] = ACTIONS(2942),
    [anon_sym_typename] = ACTIONS(2942),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_module] = ACTIONS(2942),
    [anon_sym_import] = ACTIONS(2942),
    [anon_sym_template] = ACTIONS(2942),
    [anon_sym_GT2] = ACTIONS(2940),
    [anon_sym_operator] = ACTIONS(2942),
    [anon_sym_try] = ACTIONS(2942),
    [anon_sym_delete] = ACTIONS(2942),
    [anon_sym_throw] = ACTIONS(2942),
    [anon_sym_namespace] = ACTIONS(2942),
    [anon_sym_static_assert] = ACTIONS(2942),
    [anon_sym_concept] = ACTIONS(2942),
    [anon_sym_co_return] = ACTIONS(2942),
    [anon_sym_co_yield] = ACTIONS(2942),
    [anon_sym_R_DQUOTE] = ACTIONS(2940),
    [anon_sym_LR_DQUOTE] = ACTIONS(2940),
    [anon_sym_uR_DQUOTE] = ACTIONS(2940),
    [anon_sym_UR_DQUOTE] = ACTIONS(2940),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2940),
    [anon_sym_co_await] = ACTIONS(2942),
    [anon_sym_new] = ACTIONS(2942),
    [anon_sym_requires] = ACTIONS(2942),
    [sym_this] = ACTIONS(2942),
    [anon_sym_precise] = ACTIONS(2942),
    [anon_sym_shared] = ACTIONS(2942),
    [anon_sym_groupshared] = ACTIONS(2942),
    [anon_sym_uniform] = ACTIONS(2942),
    [anon_sym_row_major] = ACTIONS(2942),
    [anon_sym_column_major] = ACTIONS(2942),
    [anon_sym_globallycoherent] = ACTIONS(2942),
    [anon_sym_centroid] = ACTIONS(2942),
    [anon_sym_noperspective] = ACTIONS(2942),
    [anon_sym_nointerpolation] = ACTIONS(2942),
    [anon_sym_sample] = ACTIONS(2942),
    [anon_sym_linear] = ACTIONS(2942),
    [anon_sym_snorm] = ACTIONS(2942),
    [anon_sym_unorm] = ACTIONS(2942),
    [anon_sym_point] = ACTIONS(2942),
    [anon_sym_line] = ACTIONS(2942),
    [anon_sym_triangleadj] = ACTIONS(2942),
    [anon_sym_lineadj] = ACTIONS(2942),
    [anon_sym_triangle] = ACTIONS(2942),
    [anon_sym_interface] = ACTIONS(2942),
    [anon_sym_extension] = ACTIONS(2942),
    [anon_sym_where] = ACTIONS(2942),
    [anon_sym___exported] = ACTIONS(2942),
  },
  [291] = {
    [sym_field_declaration_list] = STATE(718),
    [sym_virtual_specifier] = STATE(9551),
    [sym_base_class_clause] = STATE(10557),
    [sym_identifier] = ACTIONS(2566),
    [aux_sym_preproc_include_token1] = ACTIONS(2566),
    [aux_sym_preproc_def_token1] = ACTIONS(2566),
    [aux_sym_preproc_if_token1] = ACTIONS(2566),
    [aux_sym_preproc_if_token2] = ACTIONS(2566),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2566),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2566),
    [sym_preproc_directive] = ACTIONS(2566),
    [anon_sym_LPAREN2] = ACTIONS(2568),
    [anon_sym_BANG] = ACTIONS(2568),
    [anon_sym_TILDE] = ACTIONS(2568),
    [anon_sym_DASH] = ACTIONS(2566),
    [anon_sym_PLUS] = ACTIONS(2566),
    [anon_sym_STAR] = ACTIONS(2568),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2566),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2568),
    [anon_sym___extension__] = ACTIONS(2566),
    [anon_sym_typedef] = ACTIONS(2566),
    [anon_sym_in] = ACTIONS(2566),
    [anon_sym_out] = ACTIONS(2566),
    [anon_sym_inout] = ACTIONS(2566),
    [anon_sym_virtual] = ACTIONS(2566),
    [anon_sym_extern] = ACTIONS(2566),
    [anon_sym___attribute__] = ACTIONS(2566),
    [anon_sym___attribute] = ACTIONS(2566),
    [anon_sym_using] = ACTIONS(2566),
    [anon_sym_COLON_COLON] = ACTIONS(2568),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2568),
    [anon_sym___declspec] = ACTIONS(2566),
    [anon_sym___based] = ACTIONS(2566),
    [anon_sym___cdecl] = ACTIONS(2566),
    [anon_sym___clrcall] = ACTIONS(2566),
    [anon_sym___stdcall] = ACTIONS(2566),
    [anon_sym___fastcall] = ACTIONS(2566),
    [anon_sym___thiscall] = ACTIONS(2566),
    [anon_sym___vectorcall] = ACTIONS(2566),
    [anon_sym_LBRACE] = ACTIONS(2944),
    [anon_sym_signed] = ACTIONS(2566),
    [anon_sym_unsigned] = ACTIONS(2566),
    [anon_sym_long] = ACTIONS(2566),
    [anon_sym_short] = ACTIONS(2566),
    [anon_sym_LBRACK] = ACTIONS(2566),
    [anon_sym_static] = ACTIONS(2566),
    [anon_sym_register] = ACTIONS(2566),
    [anon_sym_inline] = ACTIONS(2566),
    [anon_sym___inline] = ACTIONS(2566),
    [anon_sym___inline__] = ACTIONS(2566),
    [anon_sym___forceinline] = ACTIONS(2566),
    [anon_sym_thread_local] = ACTIONS(2566),
    [anon_sym___thread] = ACTIONS(2566),
    [anon_sym_const] = ACTIONS(2566),
    [anon_sym_constexpr] = ACTIONS(2566),
    [anon_sym_volatile] = ACTIONS(2566),
    [anon_sym_restrict] = ACTIONS(2566),
    [anon_sym___restrict__] = ACTIONS(2566),
    [anon_sym__Atomic] = ACTIONS(2566),
    [anon_sym__Noreturn] = ACTIONS(2566),
    [anon_sym_noreturn] = ACTIONS(2566),
    [anon_sym__Nonnull] = ACTIONS(2566),
    [anon_sym_mutable] = ACTIONS(2566),
    [anon_sym_constinit] = ACTIONS(2566),
    [anon_sym_consteval] = ACTIONS(2566),
    [anon_sym_alignas] = ACTIONS(2566),
    [anon_sym__Alignas] = ACTIONS(2566),
    [sym_primitive_type] = ACTIONS(2566),
    [anon_sym_enum] = ACTIONS(2566),
    [anon_sym_class] = ACTIONS(2566),
    [anon_sym_struct] = ACTIONS(2566),
    [anon_sym_union] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2566),
    [anon_sym_else] = ACTIONS(2566),
    [anon_sym_switch] = ACTIONS(2566),
    [anon_sym_case] = ACTIONS(2566),
    [anon_sym_default] = ACTIONS(2566),
    [anon_sym_while] = ACTIONS(2566),
    [anon_sym_do] = ACTIONS(2566),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_break] = ACTIONS(2566),
    [anon_sym_continue] = ACTIONS(2566),
    [anon_sym_goto] = ACTIONS(2566),
    [anon_sym___try] = ACTIONS(2566),
    [anon_sym___leave] = ACTIONS(2566),
    [anon_sym_not] = ACTIONS(2566),
    [anon_sym_compl] = ACTIONS(2566),
    [anon_sym_DASH_DASH] = ACTIONS(2568),
    [anon_sym_PLUS_PLUS] = ACTIONS(2568),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2566),
    [anon_sym___alignof] = ACTIONS(2566),
    [anon_sym__alignof] = ACTIONS(2566),
    [anon_sym_alignof] = ACTIONS(2566),
    [anon_sym__Alignof] = ACTIONS(2566),
    [anon_sym_offsetof] = ACTIONS(2566),
    [anon_sym__Generic] = ACTIONS(2566),
    [anon_sym_asm] = ACTIONS(2566),
    [anon_sym___asm__] = ACTIONS(2566),
    [anon_sym___asm] = ACTIONS(2566),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2568),
    [anon_sym_u_SQUOTE] = ACTIONS(2568),
    [anon_sym_U_SQUOTE] = ACTIONS(2568),
    [anon_sym_u8_SQUOTE] = ACTIONS(2568),
    [anon_sym_SQUOTE] = ACTIONS(2568),
    [anon_sym_L_DQUOTE] = ACTIONS(2568),
    [anon_sym_u_DQUOTE] = ACTIONS(2568),
    [anon_sym_U_DQUOTE] = ACTIONS(2568),
    [anon_sym_u8_DQUOTE] = ACTIONS(2568),
    [anon_sym_DQUOTE] = ACTIONS(2568),
    [sym_true] = ACTIONS(2566),
    [sym_false] = ACTIONS(2566),
    [anon_sym_NULL] = ACTIONS(2566),
    [anon_sym_nullptr] = ACTIONS(2566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2566),
    [anon_sym_let] = ACTIONS(2566),
    [anon_sym_This] = ACTIONS(2566),
    [anon_sym_decltype] = ACTIONS(2566),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_explicit] = ACTIONS(2566),
    [anon_sym_typename] = ACTIONS(2566),
    [anon_sym_template] = ACTIONS(2566),
    [anon_sym_operator] = ACTIONS(2566),
    [anon_sym_try] = ACTIONS(2566),
    [anon_sym_delete] = ACTIONS(2566),
    [anon_sym_throw] = ACTIONS(2566),
    [anon_sym_namespace] = ACTIONS(2566),
    [anon_sym_static_assert] = ACTIONS(2566),
    [anon_sym_concept] = ACTIONS(2566),
    [anon_sym_co_return] = ACTIONS(2566),
    [anon_sym_co_yield] = ACTIONS(2566),
    [anon_sym_R_DQUOTE] = ACTIONS(2568),
    [anon_sym_LR_DQUOTE] = ACTIONS(2568),
    [anon_sym_uR_DQUOTE] = ACTIONS(2568),
    [anon_sym_UR_DQUOTE] = ACTIONS(2568),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2568),
    [anon_sym_co_await] = ACTIONS(2566),
    [anon_sym_new] = ACTIONS(2566),
    [anon_sym_requires] = ACTIONS(2566),
    [sym_this] = ACTIONS(2566),
    [anon_sym_discard] = ACTIONS(2566),
    [anon_sym_precise] = ACTIONS(2566),
    [anon_sym_shared] = ACTIONS(2566),
    [anon_sym_groupshared] = ACTIONS(2566),
    [anon_sym_uniform] = ACTIONS(2566),
    [anon_sym_row_major] = ACTIONS(2566),
    [anon_sym_column_major] = ACTIONS(2566),
    [anon_sym_globallycoherent] = ACTIONS(2566),
    [anon_sym_centroid] = ACTIONS(2566),
    [anon_sym_noperspective] = ACTIONS(2566),
    [anon_sym_nointerpolation] = ACTIONS(2566),
    [anon_sym_sample] = ACTIONS(2566),
    [anon_sym_linear] = ACTIONS(2566),
    [anon_sym_snorm] = ACTIONS(2566),
    [anon_sym_unorm] = ACTIONS(2566),
    [anon_sym_point] = ACTIONS(2566),
    [anon_sym_line] = ACTIONS(2566),
    [anon_sym_triangleadj] = ACTIONS(2566),
    [anon_sym_lineadj] = ACTIONS(2566),
    [anon_sym_triangle] = ACTIONS(2566),
    [anon_sym_cbuffer] = ACTIONS(2566),
    [anon_sym_interface] = ACTIONS(2566),
    [anon_sym_extension] = ACTIONS(2566),
  },
  [292] = {
    [sym_field_declaration_list] = STATE(725),
    [sym_virtual_specifier] = STATE(9568),
    [sym_base_class_clause] = STATE(10627),
    [sym_identifier] = ACTIONS(2556),
    [aux_sym_preproc_include_token1] = ACTIONS(2556),
    [aux_sym_preproc_def_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token2] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2556),
    [sym_preproc_directive] = ACTIONS(2556),
    [anon_sym_LPAREN2] = ACTIONS(2558),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_TILDE] = ACTIONS(2558),
    [anon_sym_DASH] = ACTIONS(2556),
    [anon_sym_PLUS] = ACTIONS(2556),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym___extension__] = ACTIONS(2556),
    [anon_sym_typedef] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2556),
    [anon_sym_out] = ACTIONS(2556),
    [anon_sym_inout] = ACTIONS(2556),
    [anon_sym_virtual] = ACTIONS(2556),
    [anon_sym_extern] = ACTIONS(2556),
    [anon_sym___attribute__] = ACTIONS(2556),
    [anon_sym___attribute] = ACTIONS(2556),
    [anon_sym_using] = ACTIONS(2556),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2558),
    [anon_sym___declspec] = ACTIONS(2556),
    [anon_sym___based] = ACTIONS(2556),
    [anon_sym___cdecl] = ACTIONS(2556),
    [anon_sym___clrcall] = ACTIONS(2556),
    [anon_sym___stdcall] = ACTIONS(2556),
    [anon_sym___fastcall] = ACTIONS(2556),
    [anon_sym___thiscall] = ACTIONS(2556),
    [anon_sym___vectorcall] = ACTIONS(2556),
    [anon_sym_LBRACE] = ACTIONS(2944),
    [anon_sym_signed] = ACTIONS(2556),
    [anon_sym_unsigned] = ACTIONS(2556),
    [anon_sym_long] = ACTIONS(2556),
    [anon_sym_short] = ACTIONS(2556),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_static] = ACTIONS(2556),
    [anon_sym_register] = ACTIONS(2556),
    [anon_sym_inline] = ACTIONS(2556),
    [anon_sym___inline] = ACTIONS(2556),
    [anon_sym___inline__] = ACTIONS(2556),
    [anon_sym___forceinline] = ACTIONS(2556),
    [anon_sym_thread_local] = ACTIONS(2556),
    [anon_sym___thread] = ACTIONS(2556),
    [anon_sym_const] = ACTIONS(2556),
    [anon_sym_constexpr] = ACTIONS(2556),
    [anon_sym_volatile] = ACTIONS(2556),
    [anon_sym_restrict] = ACTIONS(2556),
    [anon_sym___restrict__] = ACTIONS(2556),
    [anon_sym__Atomic] = ACTIONS(2556),
    [anon_sym__Noreturn] = ACTIONS(2556),
    [anon_sym_noreturn] = ACTIONS(2556),
    [anon_sym__Nonnull] = ACTIONS(2556),
    [anon_sym_mutable] = ACTIONS(2556),
    [anon_sym_constinit] = ACTIONS(2556),
    [anon_sym_consteval] = ACTIONS(2556),
    [anon_sym_alignas] = ACTIONS(2556),
    [anon_sym__Alignas] = ACTIONS(2556),
    [sym_primitive_type] = ACTIONS(2556),
    [anon_sym_enum] = ACTIONS(2556),
    [anon_sym_class] = ACTIONS(2556),
    [anon_sym_struct] = ACTIONS(2556),
    [anon_sym_union] = ACTIONS(2556),
    [anon_sym_if] = ACTIONS(2556),
    [anon_sym_else] = ACTIONS(2556),
    [anon_sym_switch] = ACTIONS(2556),
    [anon_sym_case] = ACTIONS(2556),
    [anon_sym_default] = ACTIONS(2556),
    [anon_sym_while] = ACTIONS(2556),
    [anon_sym_do] = ACTIONS(2556),
    [anon_sym_for] = ACTIONS(2556),
    [anon_sym_return] = ACTIONS(2556),
    [anon_sym_break] = ACTIONS(2556),
    [anon_sym_continue] = ACTIONS(2556),
    [anon_sym_goto] = ACTIONS(2556),
    [anon_sym___try] = ACTIONS(2556),
    [anon_sym___leave] = ACTIONS(2556),
    [anon_sym_not] = ACTIONS(2556),
    [anon_sym_compl] = ACTIONS(2556),
    [anon_sym_DASH_DASH] = ACTIONS(2558),
    [anon_sym_PLUS_PLUS] = ACTIONS(2558),
    [anon_sym_sizeof] = ACTIONS(2556),
    [anon_sym___alignof__] = ACTIONS(2556),
    [anon_sym___alignof] = ACTIONS(2556),
    [anon_sym__alignof] = ACTIONS(2556),
    [anon_sym_alignof] = ACTIONS(2556),
    [anon_sym__Alignof] = ACTIONS(2556),
    [anon_sym_offsetof] = ACTIONS(2556),
    [anon_sym__Generic] = ACTIONS(2556),
    [anon_sym_asm] = ACTIONS(2556),
    [anon_sym___asm__] = ACTIONS(2556),
    [anon_sym___asm] = ACTIONS(2556),
    [sym_number_literal] = ACTIONS(2558),
    [anon_sym_L_SQUOTE] = ACTIONS(2558),
    [anon_sym_u_SQUOTE] = ACTIONS(2558),
    [anon_sym_U_SQUOTE] = ACTIONS(2558),
    [anon_sym_u8_SQUOTE] = ACTIONS(2558),
    [anon_sym_SQUOTE] = ACTIONS(2558),
    [anon_sym_L_DQUOTE] = ACTIONS(2558),
    [anon_sym_u_DQUOTE] = ACTIONS(2558),
    [anon_sym_U_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8_DQUOTE] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2558),
    [sym_true] = ACTIONS(2556),
    [sym_false] = ACTIONS(2556),
    [anon_sym_NULL] = ACTIONS(2556),
    [anon_sym_nullptr] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2556),
    [anon_sym_let] = ACTIONS(2556),
    [anon_sym_This] = ACTIONS(2556),
    [anon_sym_decltype] = ACTIONS(2556),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_explicit] = ACTIONS(2556),
    [anon_sym_typename] = ACTIONS(2556),
    [anon_sym_template] = ACTIONS(2556),
    [anon_sym_operator] = ACTIONS(2556),
    [anon_sym_try] = ACTIONS(2556),
    [anon_sym_delete] = ACTIONS(2556),
    [anon_sym_throw] = ACTIONS(2556),
    [anon_sym_namespace] = ACTIONS(2556),
    [anon_sym_static_assert] = ACTIONS(2556),
    [anon_sym_concept] = ACTIONS(2556),
    [anon_sym_co_return] = ACTIONS(2556),
    [anon_sym_co_yield] = ACTIONS(2556),
    [anon_sym_R_DQUOTE] = ACTIONS(2558),
    [anon_sym_LR_DQUOTE] = ACTIONS(2558),
    [anon_sym_uR_DQUOTE] = ACTIONS(2558),
    [anon_sym_UR_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2558),
    [anon_sym_co_await] = ACTIONS(2556),
    [anon_sym_new] = ACTIONS(2556),
    [anon_sym_requires] = ACTIONS(2556),
    [sym_this] = ACTIONS(2556),
    [anon_sym_discard] = ACTIONS(2556),
    [anon_sym_precise] = ACTIONS(2556),
    [anon_sym_shared] = ACTIONS(2556),
    [anon_sym_groupshared] = ACTIONS(2556),
    [anon_sym_uniform] = ACTIONS(2556),
    [anon_sym_row_major] = ACTIONS(2556),
    [anon_sym_column_major] = ACTIONS(2556),
    [anon_sym_globallycoherent] = ACTIONS(2556),
    [anon_sym_centroid] = ACTIONS(2556),
    [anon_sym_noperspective] = ACTIONS(2556),
    [anon_sym_nointerpolation] = ACTIONS(2556),
    [anon_sym_sample] = ACTIONS(2556),
    [anon_sym_linear] = ACTIONS(2556),
    [anon_sym_snorm] = ACTIONS(2556),
    [anon_sym_unorm] = ACTIONS(2556),
    [anon_sym_point] = ACTIONS(2556),
    [anon_sym_line] = ACTIONS(2556),
    [anon_sym_triangleadj] = ACTIONS(2556),
    [anon_sym_lineadj] = ACTIONS(2556),
    [anon_sym_triangle] = ACTIONS(2556),
    [anon_sym_cbuffer] = ACTIONS(2556),
    [anon_sym_interface] = ACTIONS(2556),
    [anon_sym_extension] = ACTIONS(2556),
  },
  [293] = {
    [ts_builtin_sym_end] = ACTIONS(2946),
    [sym_identifier] = ACTIONS(2948),
    [aux_sym_preproc_include_token1] = ACTIONS(2948),
    [aux_sym_preproc_def_token1] = ACTIONS(2948),
    [anon_sym_COMMA] = ACTIONS(2946),
    [anon_sym_RPAREN] = ACTIONS(2946),
    [aux_sym_preproc_if_token1] = ACTIONS(2948),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2948),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2948),
    [sym_preproc_directive] = ACTIONS(2948),
    [anon_sym_LPAREN2] = ACTIONS(2946),
    [anon_sym_BANG] = ACTIONS(2946),
    [anon_sym_TILDE] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2948),
    [anon_sym_PLUS] = ACTIONS(2948),
    [anon_sym_STAR] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym___extension__] = ACTIONS(2948),
    [anon_sym_typedef] = ACTIONS(2948),
    [anon_sym_in] = ACTIONS(2948),
    [anon_sym_out] = ACTIONS(2948),
    [anon_sym_inout] = ACTIONS(2948),
    [anon_sym_virtual] = ACTIONS(2948),
    [anon_sym_extern] = ACTIONS(2948),
    [anon_sym___attribute__] = ACTIONS(2948),
    [anon_sym___attribute] = ACTIONS(2948),
    [anon_sym_using] = ACTIONS(2948),
    [anon_sym_COLON_COLON] = ACTIONS(2946),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2946),
    [anon_sym___declspec] = ACTIONS(2948),
    [anon_sym___based] = ACTIONS(2948),
    [anon_sym___cdecl] = ACTIONS(2948),
    [anon_sym___clrcall] = ACTIONS(2948),
    [anon_sym___stdcall] = ACTIONS(2948),
    [anon_sym___fastcall] = ACTIONS(2948),
    [anon_sym___thiscall] = ACTIONS(2948),
    [anon_sym___vectorcall] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_signed] = ACTIONS(2948),
    [anon_sym_unsigned] = ACTIONS(2948),
    [anon_sym_long] = ACTIONS(2948),
    [anon_sym_short] = ACTIONS(2948),
    [anon_sym_LBRACK] = ACTIONS(2948),
    [anon_sym_static] = ACTIONS(2948),
    [anon_sym_register] = ACTIONS(2948),
    [anon_sym_inline] = ACTIONS(2948),
    [anon_sym___inline] = ACTIONS(2948),
    [anon_sym___inline__] = ACTIONS(2948),
    [anon_sym___forceinline] = ACTIONS(2948),
    [anon_sym_thread_local] = ACTIONS(2948),
    [anon_sym___thread] = ACTIONS(2948),
    [anon_sym_const] = ACTIONS(2948),
    [anon_sym_constexpr] = ACTIONS(2948),
    [anon_sym_volatile] = ACTIONS(2948),
    [anon_sym_restrict] = ACTIONS(2948),
    [anon_sym___restrict__] = ACTIONS(2948),
    [anon_sym__Atomic] = ACTIONS(2948),
    [anon_sym__Noreturn] = ACTIONS(2948),
    [anon_sym_noreturn] = ACTIONS(2948),
    [anon_sym__Nonnull] = ACTIONS(2948),
    [anon_sym_mutable] = ACTIONS(2948),
    [anon_sym_constinit] = ACTIONS(2948),
    [anon_sym_consteval] = ACTIONS(2948),
    [anon_sym_alignas] = ACTIONS(2948),
    [anon_sym__Alignas] = ACTIONS(2948),
    [sym_primitive_type] = ACTIONS(2948),
    [anon_sym_enum] = ACTIONS(2948),
    [anon_sym_class] = ACTIONS(2948),
    [anon_sym_struct] = ACTIONS(2948),
    [anon_sym_union] = ACTIONS(2948),
    [anon_sym_if] = ACTIONS(2948),
    [anon_sym_switch] = ACTIONS(2948),
    [anon_sym_case] = ACTIONS(2948),
    [anon_sym_default] = ACTIONS(2948),
    [anon_sym_while] = ACTIONS(2948),
    [anon_sym_do] = ACTIONS(2948),
    [anon_sym_for] = ACTIONS(2948),
    [anon_sym_return] = ACTIONS(2948),
    [anon_sym_break] = ACTIONS(2948),
    [anon_sym_continue] = ACTIONS(2948),
    [anon_sym_goto] = ACTIONS(2948),
    [anon_sym_not] = ACTIONS(2948),
    [anon_sym_compl] = ACTIONS(2948),
    [anon_sym_DASH_DASH] = ACTIONS(2946),
    [anon_sym_PLUS_PLUS] = ACTIONS(2946),
    [anon_sym_sizeof] = ACTIONS(2948),
    [anon_sym___alignof__] = ACTIONS(2948),
    [anon_sym___alignof] = ACTIONS(2948),
    [anon_sym__alignof] = ACTIONS(2948),
    [anon_sym_alignof] = ACTIONS(2948),
    [anon_sym__Alignof] = ACTIONS(2948),
    [anon_sym_offsetof] = ACTIONS(2948),
    [anon_sym__Generic] = ACTIONS(2948),
    [anon_sym_asm] = ACTIONS(2948),
    [anon_sym___asm__] = ACTIONS(2948),
    [anon_sym___asm] = ACTIONS(2948),
    [anon_sym_DOT] = ACTIONS(2948),
    [sym_number_literal] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2946),
    [anon_sym_u_SQUOTE] = ACTIONS(2946),
    [anon_sym_U_SQUOTE] = ACTIONS(2946),
    [anon_sym_u8_SQUOTE] = ACTIONS(2946),
    [anon_sym_SQUOTE] = ACTIONS(2946),
    [anon_sym_L_DQUOTE] = ACTIONS(2946),
    [anon_sym_u_DQUOTE] = ACTIONS(2946),
    [anon_sym_U_DQUOTE] = ACTIONS(2946),
    [anon_sym_u8_DQUOTE] = ACTIONS(2946),
    [anon_sym_DQUOTE] = ACTIONS(2946),
    [sym_true] = ACTIONS(2948),
    [sym_false] = ACTIONS(2948),
    [anon_sym_NULL] = ACTIONS(2948),
    [anon_sym_nullptr] = ACTIONS(2948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2948),
    [anon_sym_let] = ACTIONS(2948),
    [anon_sym_This] = ACTIONS(2948),
    [anon_sym_decltype] = ACTIONS(2948),
    [anon_sym_final] = ACTIONS(2948),
    [anon_sym_override] = ACTIONS(2948),
    [anon_sym_explicit] = ACTIONS(2948),
    [anon_sym_typename] = ACTIONS(2948),
    [anon_sym_export] = ACTIONS(2948),
    [anon_sym_module] = ACTIONS(2948),
    [anon_sym_import] = ACTIONS(2948),
    [anon_sym_template] = ACTIONS(2948),
    [anon_sym_GT2] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2948),
    [anon_sym_try] = ACTIONS(2948),
    [anon_sym_delete] = ACTIONS(2948),
    [anon_sym_throw] = ACTIONS(2948),
    [anon_sym_namespace] = ACTIONS(2948),
    [anon_sym_static_assert] = ACTIONS(2948),
    [anon_sym_concept] = ACTIONS(2948),
    [anon_sym_co_return] = ACTIONS(2948),
    [anon_sym_co_yield] = ACTIONS(2948),
    [anon_sym_R_DQUOTE] = ACTIONS(2946),
    [anon_sym_LR_DQUOTE] = ACTIONS(2946),
    [anon_sym_uR_DQUOTE] = ACTIONS(2946),
    [anon_sym_UR_DQUOTE] = ACTIONS(2946),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2946),
    [anon_sym_co_await] = ACTIONS(2948),
    [anon_sym_new] = ACTIONS(2948),
    [anon_sym_requires] = ACTIONS(2948),
    [sym_this] = ACTIONS(2948),
    [anon_sym_precise] = ACTIONS(2948),
    [anon_sym_shared] = ACTIONS(2948),
    [anon_sym_groupshared] = ACTIONS(2948),
    [anon_sym_uniform] = ACTIONS(2948),
    [anon_sym_row_major] = ACTIONS(2948),
    [anon_sym_column_major] = ACTIONS(2948),
    [anon_sym_globallycoherent] = ACTIONS(2948),
    [anon_sym_centroid] = ACTIONS(2948),
    [anon_sym_noperspective] = ACTIONS(2948),
    [anon_sym_nointerpolation] = ACTIONS(2948),
    [anon_sym_sample] = ACTIONS(2948),
    [anon_sym_linear] = ACTIONS(2948),
    [anon_sym_snorm] = ACTIONS(2948),
    [anon_sym_unorm] = ACTIONS(2948),
    [anon_sym_point] = ACTIONS(2948),
    [anon_sym_line] = ACTIONS(2948),
    [anon_sym_triangleadj] = ACTIONS(2948),
    [anon_sym_lineadj] = ACTIONS(2948),
    [anon_sym_triangle] = ACTIONS(2948),
    [anon_sym_interface] = ACTIONS(2948),
    [anon_sym_extension] = ACTIONS(2948),
    [anon_sym_where] = ACTIONS(2948),
    [anon_sym___exported] = ACTIONS(2948),
  },
  [294] = {
    [ts_builtin_sym_end] = ACTIONS(2950),
    [sym_identifier] = ACTIONS(2952),
    [aux_sym_preproc_include_token1] = ACTIONS(2952),
    [aux_sym_preproc_def_token1] = ACTIONS(2952),
    [anon_sym_COMMA] = ACTIONS(2950),
    [anon_sym_RPAREN] = ACTIONS(2950),
    [aux_sym_preproc_if_token1] = ACTIONS(2952),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2952),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2952),
    [sym_preproc_directive] = ACTIONS(2952),
    [anon_sym_LPAREN2] = ACTIONS(2950),
    [anon_sym_BANG] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2952),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_STAR] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_AMP] = ACTIONS(2952),
    [anon_sym_SEMI] = ACTIONS(2950),
    [anon_sym___extension__] = ACTIONS(2952),
    [anon_sym_typedef] = ACTIONS(2952),
    [anon_sym_in] = ACTIONS(2952),
    [anon_sym_out] = ACTIONS(2952),
    [anon_sym_inout] = ACTIONS(2952),
    [anon_sym_virtual] = ACTIONS(2952),
    [anon_sym_extern] = ACTIONS(2952),
    [anon_sym___attribute__] = ACTIONS(2952),
    [anon_sym___attribute] = ACTIONS(2952),
    [anon_sym_using] = ACTIONS(2952),
    [anon_sym_COLON_COLON] = ACTIONS(2950),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2950),
    [anon_sym___declspec] = ACTIONS(2952),
    [anon_sym___based] = ACTIONS(2952),
    [anon_sym___cdecl] = ACTIONS(2952),
    [anon_sym___clrcall] = ACTIONS(2952),
    [anon_sym___stdcall] = ACTIONS(2952),
    [anon_sym___fastcall] = ACTIONS(2952),
    [anon_sym___thiscall] = ACTIONS(2952),
    [anon_sym___vectorcall] = ACTIONS(2952),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_signed] = ACTIONS(2952),
    [anon_sym_unsigned] = ACTIONS(2952),
    [anon_sym_long] = ACTIONS(2952),
    [anon_sym_short] = ACTIONS(2952),
    [anon_sym_LBRACK] = ACTIONS(2952),
    [anon_sym_static] = ACTIONS(2952),
    [anon_sym_register] = ACTIONS(2952),
    [anon_sym_inline] = ACTIONS(2952),
    [anon_sym___inline] = ACTIONS(2952),
    [anon_sym___inline__] = ACTIONS(2952),
    [anon_sym___forceinline] = ACTIONS(2952),
    [anon_sym_thread_local] = ACTIONS(2952),
    [anon_sym___thread] = ACTIONS(2952),
    [anon_sym_const] = ACTIONS(2952),
    [anon_sym_constexpr] = ACTIONS(2952),
    [anon_sym_volatile] = ACTIONS(2952),
    [anon_sym_restrict] = ACTIONS(2952),
    [anon_sym___restrict__] = ACTIONS(2952),
    [anon_sym__Atomic] = ACTIONS(2952),
    [anon_sym__Noreturn] = ACTIONS(2952),
    [anon_sym_noreturn] = ACTIONS(2952),
    [anon_sym__Nonnull] = ACTIONS(2952),
    [anon_sym_mutable] = ACTIONS(2952),
    [anon_sym_constinit] = ACTIONS(2952),
    [anon_sym_consteval] = ACTIONS(2952),
    [anon_sym_alignas] = ACTIONS(2952),
    [anon_sym__Alignas] = ACTIONS(2952),
    [sym_primitive_type] = ACTIONS(2952),
    [anon_sym_enum] = ACTIONS(2952),
    [anon_sym_class] = ACTIONS(2952),
    [anon_sym_struct] = ACTIONS(2952),
    [anon_sym_union] = ACTIONS(2952),
    [anon_sym_if] = ACTIONS(2952),
    [anon_sym_switch] = ACTIONS(2952),
    [anon_sym_case] = ACTIONS(2952),
    [anon_sym_default] = ACTIONS(2952),
    [anon_sym_while] = ACTIONS(2952),
    [anon_sym_do] = ACTIONS(2952),
    [anon_sym_for] = ACTIONS(2952),
    [anon_sym_return] = ACTIONS(2952),
    [anon_sym_break] = ACTIONS(2952),
    [anon_sym_continue] = ACTIONS(2952),
    [anon_sym_goto] = ACTIONS(2952),
    [anon_sym_not] = ACTIONS(2952),
    [anon_sym_compl] = ACTIONS(2952),
    [anon_sym_DASH_DASH] = ACTIONS(2950),
    [anon_sym_PLUS_PLUS] = ACTIONS(2950),
    [anon_sym_sizeof] = ACTIONS(2952),
    [anon_sym___alignof__] = ACTIONS(2952),
    [anon_sym___alignof] = ACTIONS(2952),
    [anon_sym__alignof] = ACTIONS(2952),
    [anon_sym_alignof] = ACTIONS(2952),
    [anon_sym__Alignof] = ACTIONS(2952),
    [anon_sym_offsetof] = ACTIONS(2952),
    [anon_sym__Generic] = ACTIONS(2952),
    [anon_sym_asm] = ACTIONS(2952),
    [anon_sym___asm__] = ACTIONS(2952),
    [anon_sym___asm] = ACTIONS(2952),
    [anon_sym_DOT] = ACTIONS(2952),
    [sym_number_literal] = ACTIONS(2950),
    [anon_sym_L_SQUOTE] = ACTIONS(2950),
    [anon_sym_u_SQUOTE] = ACTIONS(2950),
    [anon_sym_U_SQUOTE] = ACTIONS(2950),
    [anon_sym_u8_SQUOTE] = ACTIONS(2950),
    [anon_sym_SQUOTE] = ACTIONS(2950),
    [anon_sym_L_DQUOTE] = ACTIONS(2950),
    [anon_sym_u_DQUOTE] = ACTIONS(2950),
    [anon_sym_U_DQUOTE] = ACTIONS(2950),
    [anon_sym_u8_DQUOTE] = ACTIONS(2950),
    [anon_sym_DQUOTE] = ACTIONS(2950),
    [sym_true] = ACTIONS(2952),
    [sym_false] = ACTIONS(2952),
    [anon_sym_NULL] = ACTIONS(2952),
    [anon_sym_nullptr] = ACTIONS(2952),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2952),
    [anon_sym_let] = ACTIONS(2952),
    [anon_sym_This] = ACTIONS(2952),
    [anon_sym_decltype] = ACTIONS(2952),
    [anon_sym_final] = ACTIONS(2952),
    [anon_sym_override] = ACTIONS(2952),
    [anon_sym_explicit] = ACTIONS(2952),
    [anon_sym_typename] = ACTIONS(2952),
    [anon_sym_export] = ACTIONS(2952),
    [anon_sym_module] = ACTIONS(2952),
    [anon_sym_import] = ACTIONS(2952),
    [anon_sym_template] = ACTIONS(2952),
    [anon_sym_GT2] = ACTIONS(2950),
    [anon_sym_operator] = ACTIONS(2952),
    [anon_sym_try] = ACTIONS(2952),
    [anon_sym_delete] = ACTIONS(2952),
    [anon_sym_throw] = ACTIONS(2952),
    [anon_sym_namespace] = ACTIONS(2952),
    [anon_sym_static_assert] = ACTIONS(2952),
    [anon_sym_concept] = ACTIONS(2952),
    [anon_sym_co_return] = ACTIONS(2952),
    [anon_sym_co_yield] = ACTIONS(2952),
    [anon_sym_R_DQUOTE] = ACTIONS(2950),
    [anon_sym_LR_DQUOTE] = ACTIONS(2950),
    [anon_sym_uR_DQUOTE] = ACTIONS(2950),
    [anon_sym_UR_DQUOTE] = ACTIONS(2950),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2950),
    [anon_sym_co_await] = ACTIONS(2952),
    [anon_sym_new] = ACTIONS(2952),
    [anon_sym_requires] = ACTIONS(2952),
    [sym_this] = ACTIONS(2952),
    [anon_sym_precise] = ACTIONS(2952),
    [anon_sym_shared] = ACTIONS(2952),
    [anon_sym_groupshared] = ACTIONS(2952),
    [anon_sym_uniform] = ACTIONS(2952),
    [anon_sym_row_major] = ACTIONS(2952),
    [anon_sym_column_major] = ACTIONS(2952),
    [anon_sym_globallycoherent] = ACTIONS(2952),
    [anon_sym_centroid] = ACTIONS(2952),
    [anon_sym_noperspective] = ACTIONS(2952),
    [anon_sym_nointerpolation] = ACTIONS(2952),
    [anon_sym_sample] = ACTIONS(2952),
    [anon_sym_linear] = ACTIONS(2952),
    [anon_sym_snorm] = ACTIONS(2952),
    [anon_sym_unorm] = ACTIONS(2952),
    [anon_sym_point] = ACTIONS(2952),
    [anon_sym_line] = ACTIONS(2952),
    [anon_sym_triangleadj] = ACTIONS(2952),
    [anon_sym_lineadj] = ACTIONS(2952),
    [anon_sym_triangle] = ACTIONS(2952),
    [anon_sym_interface] = ACTIONS(2952),
    [anon_sym_extension] = ACTIONS(2952),
    [anon_sym_where] = ACTIONS(2952),
    [anon_sym___exported] = ACTIONS(2952),
  },
  [295] = {
    [sym_field_declaration_list] = STATE(828),
    [sym_virtual_specifier] = STATE(9595),
    [sym_base_class_clause] = STATE(10738),
    [sym_identifier] = ACTIONS(2556),
    [aux_sym_preproc_include_token1] = ACTIONS(2556),
    [aux_sym_preproc_def_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2556),
    [sym_preproc_directive] = ACTIONS(2556),
    [anon_sym_LPAREN2] = ACTIONS(2558),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_TILDE] = ACTIONS(2558),
    [anon_sym_DASH] = ACTIONS(2556),
    [anon_sym_PLUS] = ACTIONS(2556),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym___extension__] = ACTIONS(2556),
    [anon_sym_typedef] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2556),
    [anon_sym_out] = ACTIONS(2556),
    [anon_sym_inout] = ACTIONS(2556),
    [anon_sym_virtual] = ACTIONS(2556),
    [anon_sym_extern] = ACTIONS(2556),
    [anon_sym___attribute__] = ACTIONS(2556),
    [anon_sym___attribute] = ACTIONS(2556),
    [anon_sym_using] = ACTIONS(2556),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2558),
    [anon_sym___declspec] = ACTIONS(2556),
    [anon_sym___based] = ACTIONS(2556),
    [anon_sym___cdecl] = ACTIONS(2556),
    [anon_sym___clrcall] = ACTIONS(2556),
    [anon_sym___stdcall] = ACTIONS(2556),
    [anon_sym___fastcall] = ACTIONS(2556),
    [anon_sym___thiscall] = ACTIONS(2556),
    [anon_sym___vectorcall] = ACTIONS(2556),
    [anon_sym_LBRACE] = ACTIONS(2899),
    [anon_sym_RBRACE] = ACTIONS(2558),
    [anon_sym_signed] = ACTIONS(2556),
    [anon_sym_unsigned] = ACTIONS(2556),
    [anon_sym_long] = ACTIONS(2556),
    [anon_sym_short] = ACTIONS(2556),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_static] = ACTIONS(2556),
    [anon_sym_register] = ACTIONS(2556),
    [anon_sym_inline] = ACTIONS(2556),
    [anon_sym___inline] = ACTIONS(2556),
    [anon_sym___inline__] = ACTIONS(2556),
    [anon_sym___forceinline] = ACTIONS(2556),
    [anon_sym_thread_local] = ACTIONS(2556),
    [anon_sym___thread] = ACTIONS(2556),
    [anon_sym_const] = ACTIONS(2556),
    [anon_sym_constexpr] = ACTIONS(2556),
    [anon_sym_volatile] = ACTIONS(2556),
    [anon_sym_restrict] = ACTIONS(2556),
    [anon_sym___restrict__] = ACTIONS(2556),
    [anon_sym__Atomic] = ACTIONS(2556),
    [anon_sym__Noreturn] = ACTIONS(2556),
    [anon_sym_noreturn] = ACTIONS(2556),
    [anon_sym__Nonnull] = ACTIONS(2556),
    [anon_sym_mutable] = ACTIONS(2556),
    [anon_sym_constinit] = ACTIONS(2556),
    [anon_sym_consteval] = ACTIONS(2556),
    [anon_sym_alignas] = ACTIONS(2556),
    [anon_sym__Alignas] = ACTIONS(2556),
    [sym_primitive_type] = ACTIONS(2556),
    [anon_sym_enum] = ACTIONS(2556),
    [anon_sym_class] = ACTIONS(2556),
    [anon_sym_struct] = ACTIONS(2556),
    [anon_sym_union] = ACTIONS(2556),
    [anon_sym_if] = ACTIONS(2556),
    [anon_sym_else] = ACTIONS(2556),
    [anon_sym_switch] = ACTIONS(2556),
    [anon_sym_case] = ACTIONS(2556),
    [anon_sym_default] = ACTIONS(2556),
    [anon_sym_while] = ACTIONS(2556),
    [anon_sym_do] = ACTIONS(2556),
    [anon_sym_for] = ACTIONS(2556),
    [anon_sym_return] = ACTIONS(2556),
    [anon_sym_break] = ACTIONS(2556),
    [anon_sym_continue] = ACTIONS(2556),
    [anon_sym_goto] = ACTIONS(2556),
    [anon_sym___try] = ACTIONS(2556),
    [anon_sym___leave] = ACTIONS(2556),
    [anon_sym_not] = ACTIONS(2556),
    [anon_sym_compl] = ACTIONS(2556),
    [anon_sym_DASH_DASH] = ACTIONS(2558),
    [anon_sym_PLUS_PLUS] = ACTIONS(2558),
    [anon_sym_sizeof] = ACTIONS(2556),
    [anon_sym___alignof__] = ACTIONS(2556),
    [anon_sym___alignof] = ACTIONS(2556),
    [anon_sym__alignof] = ACTIONS(2556),
    [anon_sym_alignof] = ACTIONS(2556),
    [anon_sym__Alignof] = ACTIONS(2556),
    [anon_sym_offsetof] = ACTIONS(2556),
    [anon_sym__Generic] = ACTIONS(2556),
    [anon_sym_asm] = ACTIONS(2556),
    [anon_sym___asm__] = ACTIONS(2556),
    [anon_sym___asm] = ACTIONS(2556),
    [sym_number_literal] = ACTIONS(2558),
    [anon_sym_L_SQUOTE] = ACTIONS(2558),
    [anon_sym_u_SQUOTE] = ACTIONS(2558),
    [anon_sym_U_SQUOTE] = ACTIONS(2558),
    [anon_sym_u8_SQUOTE] = ACTIONS(2558),
    [anon_sym_SQUOTE] = ACTIONS(2558),
    [anon_sym_L_DQUOTE] = ACTIONS(2558),
    [anon_sym_u_DQUOTE] = ACTIONS(2558),
    [anon_sym_U_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8_DQUOTE] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2558),
    [sym_true] = ACTIONS(2556),
    [sym_false] = ACTIONS(2556),
    [anon_sym_NULL] = ACTIONS(2556),
    [anon_sym_nullptr] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2556),
    [anon_sym_let] = ACTIONS(2556),
    [anon_sym_This] = ACTIONS(2556),
    [anon_sym_decltype] = ACTIONS(2556),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_explicit] = ACTIONS(2556),
    [anon_sym_typename] = ACTIONS(2556),
    [anon_sym_template] = ACTIONS(2556),
    [anon_sym_operator] = ACTIONS(2556),
    [anon_sym_try] = ACTIONS(2556),
    [anon_sym_delete] = ACTIONS(2556),
    [anon_sym_throw] = ACTIONS(2556),
    [anon_sym_namespace] = ACTIONS(2556),
    [anon_sym_static_assert] = ACTIONS(2556),
    [anon_sym_concept] = ACTIONS(2556),
    [anon_sym_co_return] = ACTIONS(2556),
    [anon_sym_co_yield] = ACTIONS(2556),
    [anon_sym_R_DQUOTE] = ACTIONS(2558),
    [anon_sym_LR_DQUOTE] = ACTIONS(2558),
    [anon_sym_uR_DQUOTE] = ACTIONS(2558),
    [anon_sym_UR_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2558),
    [anon_sym_co_await] = ACTIONS(2556),
    [anon_sym_new] = ACTIONS(2556),
    [anon_sym_requires] = ACTIONS(2556),
    [sym_this] = ACTIONS(2556),
    [anon_sym_discard] = ACTIONS(2556),
    [anon_sym_precise] = ACTIONS(2556),
    [anon_sym_shared] = ACTIONS(2556),
    [anon_sym_groupshared] = ACTIONS(2556),
    [anon_sym_uniform] = ACTIONS(2556),
    [anon_sym_row_major] = ACTIONS(2556),
    [anon_sym_column_major] = ACTIONS(2556),
    [anon_sym_globallycoherent] = ACTIONS(2556),
    [anon_sym_centroid] = ACTIONS(2556),
    [anon_sym_noperspective] = ACTIONS(2556),
    [anon_sym_nointerpolation] = ACTIONS(2556),
    [anon_sym_sample] = ACTIONS(2556),
    [anon_sym_linear] = ACTIONS(2556),
    [anon_sym_snorm] = ACTIONS(2556),
    [anon_sym_unorm] = ACTIONS(2556),
    [anon_sym_point] = ACTIONS(2556),
    [anon_sym_line] = ACTIONS(2556),
    [anon_sym_triangleadj] = ACTIONS(2556),
    [anon_sym_lineadj] = ACTIONS(2556),
    [anon_sym_triangle] = ACTIONS(2556),
    [anon_sym_cbuffer] = ACTIONS(2556),
    [anon_sym_interface] = ACTIONS(2556),
    [anon_sym_extension] = ACTIONS(2556),
  },
  [296] = {
    [ts_builtin_sym_end] = ACTIONS(2954),
    [sym_identifier] = ACTIONS(2956),
    [aux_sym_preproc_include_token1] = ACTIONS(2956),
    [aux_sym_preproc_def_token1] = ACTIONS(2956),
    [anon_sym_COMMA] = ACTIONS(2954),
    [anon_sym_RPAREN] = ACTIONS(2954),
    [aux_sym_preproc_if_token1] = ACTIONS(2956),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2956),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2956),
    [sym_preproc_directive] = ACTIONS(2956),
    [anon_sym_LPAREN2] = ACTIONS(2954),
    [anon_sym_BANG] = ACTIONS(2954),
    [anon_sym_TILDE] = ACTIONS(2954),
    [anon_sym_DASH] = ACTIONS(2956),
    [anon_sym_PLUS] = ACTIONS(2956),
    [anon_sym_STAR] = ACTIONS(2954),
    [anon_sym_AMP_AMP] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(2956),
    [anon_sym_SEMI] = ACTIONS(2954),
    [anon_sym___extension__] = ACTIONS(2956),
    [anon_sym_typedef] = ACTIONS(2956),
    [anon_sym_in] = ACTIONS(2956),
    [anon_sym_out] = ACTIONS(2956),
    [anon_sym_inout] = ACTIONS(2956),
    [anon_sym_virtual] = ACTIONS(2956),
    [anon_sym_extern] = ACTIONS(2956),
    [anon_sym___attribute__] = ACTIONS(2956),
    [anon_sym___attribute] = ACTIONS(2956),
    [anon_sym_using] = ACTIONS(2956),
    [anon_sym_COLON_COLON] = ACTIONS(2954),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2954),
    [anon_sym___declspec] = ACTIONS(2956),
    [anon_sym___based] = ACTIONS(2956),
    [anon_sym___cdecl] = ACTIONS(2956),
    [anon_sym___clrcall] = ACTIONS(2956),
    [anon_sym___stdcall] = ACTIONS(2956),
    [anon_sym___fastcall] = ACTIONS(2956),
    [anon_sym___thiscall] = ACTIONS(2956),
    [anon_sym___vectorcall] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2954),
    [anon_sym_signed] = ACTIONS(2956),
    [anon_sym_unsigned] = ACTIONS(2956),
    [anon_sym_long] = ACTIONS(2956),
    [anon_sym_short] = ACTIONS(2956),
    [anon_sym_LBRACK] = ACTIONS(2956),
    [anon_sym_static] = ACTIONS(2956),
    [anon_sym_register] = ACTIONS(2956),
    [anon_sym_inline] = ACTIONS(2956),
    [anon_sym___inline] = ACTIONS(2956),
    [anon_sym___inline__] = ACTIONS(2956),
    [anon_sym___forceinline] = ACTIONS(2956),
    [anon_sym_thread_local] = ACTIONS(2956),
    [anon_sym___thread] = ACTIONS(2956),
    [anon_sym_const] = ACTIONS(2956),
    [anon_sym_constexpr] = ACTIONS(2956),
    [anon_sym_volatile] = ACTIONS(2956),
    [anon_sym_restrict] = ACTIONS(2956),
    [anon_sym___restrict__] = ACTIONS(2956),
    [anon_sym__Atomic] = ACTIONS(2956),
    [anon_sym__Noreturn] = ACTIONS(2956),
    [anon_sym_noreturn] = ACTIONS(2956),
    [anon_sym__Nonnull] = ACTIONS(2956),
    [anon_sym_mutable] = ACTIONS(2956),
    [anon_sym_constinit] = ACTIONS(2956),
    [anon_sym_consteval] = ACTIONS(2956),
    [anon_sym_alignas] = ACTIONS(2956),
    [anon_sym__Alignas] = ACTIONS(2956),
    [sym_primitive_type] = ACTIONS(2956),
    [anon_sym_enum] = ACTIONS(2956),
    [anon_sym_class] = ACTIONS(2956),
    [anon_sym_struct] = ACTIONS(2956),
    [anon_sym_union] = ACTIONS(2956),
    [anon_sym_if] = ACTIONS(2956),
    [anon_sym_switch] = ACTIONS(2956),
    [anon_sym_case] = ACTIONS(2956),
    [anon_sym_default] = ACTIONS(2956),
    [anon_sym_while] = ACTIONS(2956),
    [anon_sym_do] = ACTIONS(2956),
    [anon_sym_for] = ACTIONS(2956),
    [anon_sym_return] = ACTIONS(2956),
    [anon_sym_break] = ACTIONS(2956),
    [anon_sym_continue] = ACTIONS(2956),
    [anon_sym_goto] = ACTIONS(2956),
    [anon_sym_not] = ACTIONS(2956),
    [anon_sym_compl] = ACTIONS(2956),
    [anon_sym_DASH_DASH] = ACTIONS(2954),
    [anon_sym_PLUS_PLUS] = ACTIONS(2954),
    [anon_sym_sizeof] = ACTIONS(2956),
    [anon_sym___alignof__] = ACTIONS(2956),
    [anon_sym___alignof] = ACTIONS(2956),
    [anon_sym__alignof] = ACTIONS(2956),
    [anon_sym_alignof] = ACTIONS(2956),
    [anon_sym__Alignof] = ACTIONS(2956),
    [anon_sym_offsetof] = ACTIONS(2956),
    [anon_sym__Generic] = ACTIONS(2956),
    [anon_sym_asm] = ACTIONS(2956),
    [anon_sym___asm__] = ACTIONS(2956),
    [anon_sym___asm] = ACTIONS(2956),
    [anon_sym_DOT] = ACTIONS(2956),
    [sym_number_literal] = ACTIONS(2954),
    [anon_sym_L_SQUOTE] = ACTIONS(2954),
    [anon_sym_u_SQUOTE] = ACTIONS(2954),
    [anon_sym_U_SQUOTE] = ACTIONS(2954),
    [anon_sym_u8_SQUOTE] = ACTIONS(2954),
    [anon_sym_SQUOTE] = ACTIONS(2954),
    [anon_sym_L_DQUOTE] = ACTIONS(2954),
    [anon_sym_u_DQUOTE] = ACTIONS(2954),
    [anon_sym_U_DQUOTE] = ACTIONS(2954),
    [anon_sym_u8_DQUOTE] = ACTIONS(2954),
    [anon_sym_DQUOTE] = ACTIONS(2954),
    [sym_true] = ACTIONS(2956),
    [sym_false] = ACTIONS(2956),
    [anon_sym_NULL] = ACTIONS(2956),
    [anon_sym_nullptr] = ACTIONS(2956),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2956),
    [anon_sym_let] = ACTIONS(2956),
    [anon_sym_This] = ACTIONS(2956),
    [anon_sym_decltype] = ACTIONS(2956),
    [anon_sym_final] = ACTIONS(2956),
    [anon_sym_override] = ACTIONS(2956),
    [anon_sym_explicit] = ACTIONS(2956),
    [anon_sym_typename] = ACTIONS(2956),
    [anon_sym_export] = ACTIONS(2956),
    [anon_sym_module] = ACTIONS(2956),
    [anon_sym_import] = ACTIONS(2956),
    [anon_sym_template] = ACTIONS(2956),
    [anon_sym_GT2] = ACTIONS(2954),
    [anon_sym_operator] = ACTIONS(2956),
    [anon_sym_try] = ACTIONS(2956),
    [anon_sym_delete] = ACTIONS(2956),
    [anon_sym_throw] = ACTIONS(2956),
    [anon_sym_namespace] = ACTIONS(2956),
    [anon_sym_static_assert] = ACTIONS(2956),
    [anon_sym_concept] = ACTIONS(2956),
    [anon_sym_co_return] = ACTIONS(2956),
    [anon_sym_co_yield] = ACTIONS(2956),
    [anon_sym_R_DQUOTE] = ACTIONS(2954),
    [anon_sym_LR_DQUOTE] = ACTIONS(2954),
    [anon_sym_uR_DQUOTE] = ACTIONS(2954),
    [anon_sym_UR_DQUOTE] = ACTIONS(2954),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2954),
    [anon_sym_co_await] = ACTIONS(2956),
    [anon_sym_new] = ACTIONS(2956),
    [anon_sym_requires] = ACTIONS(2956),
    [sym_this] = ACTIONS(2956),
    [anon_sym_precise] = ACTIONS(2956),
    [anon_sym_shared] = ACTIONS(2956),
    [anon_sym_groupshared] = ACTIONS(2956),
    [anon_sym_uniform] = ACTIONS(2956),
    [anon_sym_row_major] = ACTIONS(2956),
    [anon_sym_column_major] = ACTIONS(2956),
    [anon_sym_globallycoherent] = ACTIONS(2956),
    [anon_sym_centroid] = ACTIONS(2956),
    [anon_sym_noperspective] = ACTIONS(2956),
    [anon_sym_nointerpolation] = ACTIONS(2956),
    [anon_sym_sample] = ACTIONS(2956),
    [anon_sym_linear] = ACTIONS(2956),
    [anon_sym_snorm] = ACTIONS(2956),
    [anon_sym_unorm] = ACTIONS(2956),
    [anon_sym_point] = ACTIONS(2956),
    [anon_sym_line] = ACTIONS(2956),
    [anon_sym_triangleadj] = ACTIONS(2956),
    [anon_sym_lineadj] = ACTIONS(2956),
    [anon_sym_triangle] = ACTIONS(2956),
    [anon_sym_interface] = ACTIONS(2956),
    [anon_sym_extension] = ACTIONS(2956),
    [anon_sym_where] = ACTIONS(2956),
    [anon_sym___exported] = ACTIONS(2956),
  },
  [297] = {
    [ts_builtin_sym_end] = ACTIONS(2958),
    [sym_identifier] = ACTIONS(2960),
    [aux_sym_preproc_include_token1] = ACTIONS(2960),
    [aux_sym_preproc_def_token1] = ACTIONS(2960),
    [anon_sym_COMMA] = ACTIONS(2958),
    [anon_sym_RPAREN] = ACTIONS(2958),
    [aux_sym_preproc_if_token1] = ACTIONS(2960),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2960),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2960),
    [sym_preproc_directive] = ACTIONS(2960),
    [anon_sym_LPAREN2] = ACTIONS(2958),
    [anon_sym_BANG] = ACTIONS(2958),
    [anon_sym_TILDE] = ACTIONS(2958),
    [anon_sym_DASH] = ACTIONS(2960),
    [anon_sym_PLUS] = ACTIONS(2960),
    [anon_sym_STAR] = ACTIONS(2958),
    [anon_sym_AMP_AMP] = ACTIONS(2958),
    [anon_sym_AMP] = ACTIONS(2960),
    [anon_sym_SEMI] = ACTIONS(2958),
    [anon_sym___extension__] = ACTIONS(2960),
    [anon_sym_typedef] = ACTIONS(2960),
    [anon_sym_in] = ACTIONS(2960),
    [anon_sym_out] = ACTIONS(2960),
    [anon_sym_inout] = ACTIONS(2960),
    [anon_sym_virtual] = ACTIONS(2960),
    [anon_sym_extern] = ACTIONS(2960),
    [anon_sym___attribute__] = ACTIONS(2960),
    [anon_sym___attribute] = ACTIONS(2960),
    [anon_sym_using] = ACTIONS(2960),
    [anon_sym_COLON_COLON] = ACTIONS(2958),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2958),
    [anon_sym___declspec] = ACTIONS(2960),
    [anon_sym___based] = ACTIONS(2960),
    [anon_sym___cdecl] = ACTIONS(2960),
    [anon_sym___clrcall] = ACTIONS(2960),
    [anon_sym___stdcall] = ACTIONS(2960),
    [anon_sym___fastcall] = ACTIONS(2960),
    [anon_sym___thiscall] = ACTIONS(2960),
    [anon_sym___vectorcall] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2958),
    [anon_sym_signed] = ACTIONS(2960),
    [anon_sym_unsigned] = ACTIONS(2960),
    [anon_sym_long] = ACTIONS(2960),
    [anon_sym_short] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_static] = ACTIONS(2960),
    [anon_sym_register] = ACTIONS(2960),
    [anon_sym_inline] = ACTIONS(2960),
    [anon_sym___inline] = ACTIONS(2960),
    [anon_sym___inline__] = ACTIONS(2960),
    [anon_sym___forceinline] = ACTIONS(2960),
    [anon_sym_thread_local] = ACTIONS(2960),
    [anon_sym___thread] = ACTIONS(2960),
    [anon_sym_const] = ACTIONS(2960),
    [anon_sym_constexpr] = ACTIONS(2960),
    [anon_sym_volatile] = ACTIONS(2960),
    [anon_sym_restrict] = ACTIONS(2960),
    [anon_sym___restrict__] = ACTIONS(2960),
    [anon_sym__Atomic] = ACTIONS(2960),
    [anon_sym__Noreturn] = ACTIONS(2960),
    [anon_sym_noreturn] = ACTIONS(2960),
    [anon_sym__Nonnull] = ACTIONS(2960),
    [anon_sym_mutable] = ACTIONS(2960),
    [anon_sym_constinit] = ACTIONS(2960),
    [anon_sym_consteval] = ACTIONS(2960),
    [anon_sym_alignas] = ACTIONS(2960),
    [anon_sym__Alignas] = ACTIONS(2960),
    [sym_primitive_type] = ACTIONS(2960),
    [anon_sym_enum] = ACTIONS(2960),
    [anon_sym_class] = ACTIONS(2960),
    [anon_sym_struct] = ACTIONS(2960),
    [anon_sym_union] = ACTIONS(2960),
    [anon_sym_if] = ACTIONS(2960),
    [anon_sym_switch] = ACTIONS(2960),
    [anon_sym_case] = ACTIONS(2960),
    [anon_sym_default] = ACTIONS(2960),
    [anon_sym_while] = ACTIONS(2960),
    [anon_sym_do] = ACTIONS(2960),
    [anon_sym_for] = ACTIONS(2960),
    [anon_sym_return] = ACTIONS(2960),
    [anon_sym_break] = ACTIONS(2960),
    [anon_sym_continue] = ACTIONS(2960),
    [anon_sym_goto] = ACTIONS(2960),
    [anon_sym_not] = ACTIONS(2960),
    [anon_sym_compl] = ACTIONS(2960),
    [anon_sym_DASH_DASH] = ACTIONS(2958),
    [anon_sym_PLUS_PLUS] = ACTIONS(2958),
    [anon_sym_sizeof] = ACTIONS(2960),
    [anon_sym___alignof__] = ACTIONS(2960),
    [anon_sym___alignof] = ACTIONS(2960),
    [anon_sym__alignof] = ACTIONS(2960),
    [anon_sym_alignof] = ACTIONS(2960),
    [anon_sym__Alignof] = ACTIONS(2960),
    [anon_sym_offsetof] = ACTIONS(2960),
    [anon_sym__Generic] = ACTIONS(2960),
    [anon_sym_asm] = ACTIONS(2960),
    [anon_sym___asm__] = ACTIONS(2960),
    [anon_sym___asm] = ACTIONS(2960),
    [anon_sym_DOT] = ACTIONS(2960),
    [sym_number_literal] = ACTIONS(2958),
    [anon_sym_L_SQUOTE] = ACTIONS(2958),
    [anon_sym_u_SQUOTE] = ACTIONS(2958),
    [anon_sym_U_SQUOTE] = ACTIONS(2958),
    [anon_sym_u8_SQUOTE] = ACTIONS(2958),
    [anon_sym_SQUOTE] = ACTIONS(2958),
    [anon_sym_L_DQUOTE] = ACTIONS(2958),
    [anon_sym_u_DQUOTE] = ACTIONS(2958),
    [anon_sym_U_DQUOTE] = ACTIONS(2958),
    [anon_sym_u8_DQUOTE] = ACTIONS(2958),
    [anon_sym_DQUOTE] = ACTIONS(2958),
    [sym_true] = ACTIONS(2960),
    [sym_false] = ACTIONS(2960),
    [anon_sym_NULL] = ACTIONS(2960),
    [anon_sym_nullptr] = ACTIONS(2960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2960),
    [anon_sym_let] = ACTIONS(2960),
    [anon_sym_This] = ACTIONS(2960),
    [anon_sym_decltype] = ACTIONS(2960),
    [anon_sym_final] = ACTIONS(2960),
    [anon_sym_override] = ACTIONS(2960),
    [anon_sym_explicit] = ACTIONS(2960),
    [anon_sym_typename] = ACTIONS(2960),
    [anon_sym_export] = ACTIONS(2960),
    [anon_sym_module] = ACTIONS(2960),
    [anon_sym_import] = ACTIONS(2960),
    [anon_sym_template] = ACTIONS(2960),
    [anon_sym_GT2] = ACTIONS(2958),
    [anon_sym_operator] = ACTIONS(2960),
    [anon_sym_try] = ACTIONS(2960),
    [anon_sym_delete] = ACTIONS(2960),
    [anon_sym_throw] = ACTIONS(2960),
    [anon_sym_namespace] = ACTIONS(2960),
    [anon_sym_static_assert] = ACTIONS(2960),
    [anon_sym_concept] = ACTIONS(2960),
    [anon_sym_co_return] = ACTIONS(2960),
    [anon_sym_co_yield] = ACTIONS(2960),
    [anon_sym_R_DQUOTE] = ACTIONS(2958),
    [anon_sym_LR_DQUOTE] = ACTIONS(2958),
    [anon_sym_uR_DQUOTE] = ACTIONS(2958),
    [anon_sym_UR_DQUOTE] = ACTIONS(2958),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2958),
    [anon_sym_co_await] = ACTIONS(2960),
    [anon_sym_new] = ACTIONS(2960),
    [anon_sym_requires] = ACTIONS(2960),
    [sym_this] = ACTIONS(2960),
    [anon_sym_precise] = ACTIONS(2960),
    [anon_sym_shared] = ACTIONS(2960),
    [anon_sym_groupshared] = ACTIONS(2960),
    [anon_sym_uniform] = ACTIONS(2960),
    [anon_sym_row_major] = ACTIONS(2960),
    [anon_sym_column_major] = ACTIONS(2960),
    [anon_sym_globallycoherent] = ACTIONS(2960),
    [anon_sym_centroid] = ACTIONS(2960),
    [anon_sym_noperspective] = ACTIONS(2960),
    [anon_sym_nointerpolation] = ACTIONS(2960),
    [anon_sym_sample] = ACTIONS(2960),
    [anon_sym_linear] = ACTIONS(2960),
    [anon_sym_snorm] = ACTIONS(2960),
    [anon_sym_unorm] = ACTIONS(2960),
    [anon_sym_point] = ACTIONS(2960),
    [anon_sym_line] = ACTIONS(2960),
    [anon_sym_triangleadj] = ACTIONS(2960),
    [anon_sym_lineadj] = ACTIONS(2960),
    [anon_sym_triangle] = ACTIONS(2960),
    [anon_sym_interface] = ACTIONS(2960),
    [anon_sym_extension] = ACTIONS(2960),
    [anon_sym_where] = ACTIONS(2960),
    [anon_sym___exported] = ACTIONS(2960),
  },
  [298] = {
    [ts_builtin_sym_end] = ACTIONS(2962),
    [sym_identifier] = ACTIONS(2964),
    [aux_sym_preproc_include_token1] = ACTIONS(2964),
    [aux_sym_preproc_def_token1] = ACTIONS(2964),
    [anon_sym_COMMA] = ACTIONS(2962),
    [anon_sym_RPAREN] = ACTIONS(2962),
    [aux_sym_preproc_if_token1] = ACTIONS(2964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2964),
    [sym_preproc_directive] = ACTIONS(2964),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_BANG] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2964),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_STAR] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym___extension__] = ACTIONS(2964),
    [anon_sym_typedef] = ACTIONS(2964),
    [anon_sym_in] = ACTIONS(2964),
    [anon_sym_out] = ACTIONS(2964),
    [anon_sym_inout] = ACTIONS(2964),
    [anon_sym_virtual] = ACTIONS(2964),
    [anon_sym_extern] = ACTIONS(2964),
    [anon_sym___attribute__] = ACTIONS(2964),
    [anon_sym___attribute] = ACTIONS(2964),
    [anon_sym_using] = ACTIONS(2964),
    [anon_sym_COLON_COLON] = ACTIONS(2962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2962),
    [anon_sym___declspec] = ACTIONS(2964),
    [anon_sym___based] = ACTIONS(2964),
    [anon_sym___cdecl] = ACTIONS(2964),
    [anon_sym___clrcall] = ACTIONS(2964),
    [anon_sym___stdcall] = ACTIONS(2964),
    [anon_sym___fastcall] = ACTIONS(2964),
    [anon_sym___thiscall] = ACTIONS(2964),
    [anon_sym___vectorcall] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_signed] = ACTIONS(2964),
    [anon_sym_unsigned] = ACTIONS(2964),
    [anon_sym_long] = ACTIONS(2964),
    [anon_sym_short] = ACTIONS(2964),
    [anon_sym_LBRACK] = ACTIONS(2964),
    [anon_sym_static] = ACTIONS(2964),
    [anon_sym_register] = ACTIONS(2964),
    [anon_sym_inline] = ACTIONS(2964),
    [anon_sym___inline] = ACTIONS(2964),
    [anon_sym___inline__] = ACTIONS(2964),
    [anon_sym___forceinline] = ACTIONS(2964),
    [anon_sym_thread_local] = ACTIONS(2964),
    [anon_sym___thread] = ACTIONS(2964),
    [anon_sym_const] = ACTIONS(2964),
    [anon_sym_constexpr] = ACTIONS(2964),
    [anon_sym_volatile] = ACTIONS(2964),
    [anon_sym_restrict] = ACTIONS(2964),
    [anon_sym___restrict__] = ACTIONS(2964),
    [anon_sym__Atomic] = ACTIONS(2964),
    [anon_sym__Noreturn] = ACTIONS(2964),
    [anon_sym_noreturn] = ACTIONS(2964),
    [anon_sym__Nonnull] = ACTIONS(2964),
    [anon_sym_mutable] = ACTIONS(2964),
    [anon_sym_constinit] = ACTIONS(2964),
    [anon_sym_consteval] = ACTIONS(2964),
    [anon_sym_alignas] = ACTIONS(2964),
    [anon_sym__Alignas] = ACTIONS(2964),
    [sym_primitive_type] = ACTIONS(2964),
    [anon_sym_enum] = ACTIONS(2964),
    [anon_sym_class] = ACTIONS(2964),
    [anon_sym_struct] = ACTIONS(2964),
    [anon_sym_union] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2964),
    [anon_sym_switch] = ACTIONS(2964),
    [anon_sym_case] = ACTIONS(2964),
    [anon_sym_default] = ACTIONS(2964),
    [anon_sym_while] = ACTIONS(2964),
    [anon_sym_do] = ACTIONS(2964),
    [anon_sym_for] = ACTIONS(2964),
    [anon_sym_return] = ACTIONS(2964),
    [anon_sym_break] = ACTIONS(2964),
    [anon_sym_continue] = ACTIONS(2964),
    [anon_sym_goto] = ACTIONS(2964),
    [anon_sym_not] = ACTIONS(2964),
    [anon_sym_compl] = ACTIONS(2964),
    [anon_sym_DASH_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_PLUS] = ACTIONS(2962),
    [anon_sym_sizeof] = ACTIONS(2964),
    [anon_sym___alignof__] = ACTIONS(2964),
    [anon_sym___alignof] = ACTIONS(2964),
    [anon_sym__alignof] = ACTIONS(2964),
    [anon_sym_alignof] = ACTIONS(2964),
    [anon_sym__Alignof] = ACTIONS(2964),
    [anon_sym_offsetof] = ACTIONS(2964),
    [anon_sym__Generic] = ACTIONS(2964),
    [anon_sym_asm] = ACTIONS(2964),
    [anon_sym___asm__] = ACTIONS(2964),
    [anon_sym___asm] = ACTIONS(2964),
    [anon_sym_DOT] = ACTIONS(2964),
    [sym_number_literal] = ACTIONS(2962),
    [anon_sym_L_SQUOTE] = ACTIONS(2962),
    [anon_sym_u_SQUOTE] = ACTIONS(2962),
    [anon_sym_U_SQUOTE] = ACTIONS(2962),
    [anon_sym_u8_SQUOTE] = ACTIONS(2962),
    [anon_sym_SQUOTE] = ACTIONS(2962),
    [anon_sym_L_DQUOTE] = ACTIONS(2962),
    [anon_sym_u_DQUOTE] = ACTIONS(2962),
    [anon_sym_U_DQUOTE] = ACTIONS(2962),
    [anon_sym_u8_DQUOTE] = ACTIONS(2962),
    [anon_sym_DQUOTE] = ACTIONS(2962),
    [sym_true] = ACTIONS(2964),
    [sym_false] = ACTIONS(2964),
    [anon_sym_NULL] = ACTIONS(2964),
    [anon_sym_nullptr] = ACTIONS(2964),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2964),
    [anon_sym_let] = ACTIONS(2964),
    [anon_sym_This] = ACTIONS(2964),
    [anon_sym_decltype] = ACTIONS(2964),
    [anon_sym_final] = ACTIONS(2964),
    [anon_sym_override] = ACTIONS(2964),
    [anon_sym_explicit] = ACTIONS(2964),
    [anon_sym_typename] = ACTIONS(2964),
    [anon_sym_export] = ACTIONS(2964),
    [anon_sym_module] = ACTIONS(2964),
    [anon_sym_import] = ACTIONS(2964),
    [anon_sym_template] = ACTIONS(2964),
    [anon_sym_GT2] = ACTIONS(2962),
    [anon_sym_operator] = ACTIONS(2964),
    [anon_sym_try] = ACTIONS(2964),
    [anon_sym_delete] = ACTIONS(2964),
    [anon_sym_throw] = ACTIONS(2964),
    [anon_sym_namespace] = ACTIONS(2964),
    [anon_sym_static_assert] = ACTIONS(2964),
    [anon_sym_concept] = ACTIONS(2964),
    [anon_sym_co_return] = ACTIONS(2964),
    [anon_sym_co_yield] = ACTIONS(2964),
    [anon_sym_R_DQUOTE] = ACTIONS(2962),
    [anon_sym_LR_DQUOTE] = ACTIONS(2962),
    [anon_sym_uR_DQUOTE] = ACTIONS(2962),
    [anon_sym_UR_DQUOTE] = ACTIONS(2962),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2962),
    [anon_sym_co_await] = ACTIONS(2964),
    [anon_sym_new] = ACTIONS(2964),
    [anon_sym_requires] = ACTIONS(2964),
    [sym_this] = ACTIONS(2964),
    [anon_sym_precise] = ACTIONS(2964),
    [anon_sym_shared] = ACTIONS(2964),
    [anon_sym_groupshared] = ACTIONS(2964),
    [anon_sym_uniform] = ACTIONS(2964),
    [anon_sym_row_major] = ACTIONS(2964),
    [anon_sym_column_major] = ACTIONS(2964),
    [anon_sym_globallycoherent] = ACTIONS(2964),
    [anon_sym_centroid] = ACTIONS(2964),
    [anon_sym_noperspective] = ACTIONS(2964),
    [anon_sym_nointerpolation] = ACTIONS(2964),
    [anon_sym_sample] = ACTIONS(2964),
    [anon_sym_linear] = ACTIONS(2964),
    [anon_sym_snorm] = ACTIONS(2964),
    [anon_sym_unorm] = ACTIONS(2964),
    [anon_sym_point] = ACTIONS(2964),
    [anon_sym_line] = ACTIONS(2964),
    [anon_sym_triangleadj] = ACTIONS(2964),
    [anon_sym_lineadj] = ACTIONS(2964),
    [anon_sym_triangle] = ACTIONS(2964),
    [anon_sym_interface] = ACTIONS(2964),
    [anon_sym_extension] = ACTIONS(2964),
    [anon_sym_where] = ACTIONS(2964),
    [anon_sym___exported] = ACTIONS(2964),
  },
  [299] = {
    [sym_template_argument_list] = STATE(403),
    [sym_identifier] = ACTIONS(2410),
    [aux_sym_preproc_include_token1] = ACTIONS(2410),
    [aux_sym_preproc_def_token1] = ACTIONS(2410),
    [aux_sym_preproc_if_token1] = ACTIONS(2410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2410),
    [sym_preproc_directive] = ACTIONS(2410),
    [anon_sym_LPAREN2] = ACTIONS(2408),
    [anon_sym_BANG] = ACTIONS(2408),
    [anon_sym_TILDE] = ACTIONS(2408),
    [anon_sym_DASH] = ACTIONS(2410),
    [anon_sym_PLUS] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(2408),
    [anon_sym_AMP_AMP] = ACTIONS(2408),
    [anon_sym_AMP] = ACTIONS(2410),
    [anon_sym_LT] = ACTIONS(2966),
    [anon_sym_COLON] = ACTIONS(2410),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym___extension__] = ACTIONS(2410),
    [anon_sym_typedef] = ACTIONS(2410),
    [anon_sym_in] = ACTIONS(2410),
    [anon_sym_out] = ACTIONS(2410),
    [anon_sym_inout] = ACTIONS(2410),
    [anon_sym_virtual] = ACTIONS(2410),
    [anon_sym_extern] = ACTIONS(2410),
    [anon_sym___attribute__] = ACTIONS(2410),
    [anon_sym___attribute] = ACTIONS(2410),
    [anon_sym_using] = ACTIONS(2410),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2408),
    [anon_sym___declspec] = ACTIONS(2410),
    [anon_sym___based] = ACTIONS(2410),
    [anon_sym___cdecl] = ACTIONS(2410),
    [anon_sym___clrcall] = ACTIONS(2410),
    [anon_sym___stdcall] = ACTIONS(2410),
    [anon_sym___fastcall] = ACTIONS(2410),
    [anon_sym___thiscall] = ACTIONS(2410),
    [anon_sym___vectorcall] = ACTIONS(2410),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_RBRACE] = ACTIONS(2408),
    [anon_sym_signed] = ACTIONS(2410),
    [anon_sym_unsigned] = ACTIONS(2410),
    [anon_sym_long] = ACTIONS(2410),
    [anon_sym_short] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_static] = ACTIONS(2410),
    [anon_sym_register] = ACTIONS(2410),
    [anon_sym_inline] = ACTIONS(2410),
    [anon_sym___inline] = ACTIONS(2410),
    [anon_sym___inline__] = ACTIONS(2410),
    [anon_sym___forceinline] = ACTIONS(2410),
    [anon_sym_thread_local] = ACTIONS(2410),
    [anon_sym___thread] = ACTIONS(2410),
    [anon_sym_const] = ACTIONS(2410),
    [anon_sym_constexpr] = ACTIONS(2410),
    [anon_sym_volatile] = ACTIONS(2410),
    [anon_sym_restrict] = ACTIONS(2410),
    [anon_sym___restrict__] = ACTIONS(2410),
    [anon_sym__Atomic] = ACTIONS(2410),
    [anon_sym__Noreturn] = ACTIONS(2410),
    [anon_sym_noreturn] = ACTIONS(2410),
    [anon_sym__Nonnull] = ACTIONS(2410),
    [anon_sym_mutable] = ACTIONS(2410),
    [anon_sym_constinit] = ACTIONS(2410),
    [anon_sym_consteval] = ACTIONS(2410),
    [anon_sym_alignas] = ACTIONS(2410),
    [anon_sym__Alignas] = ACTIONS(2410),
    [sym_primitive_type] = ACTIONS(2410),
    [anon_sym_enum] = ACTIONS(2410),
    [anon_sym_class] = ACTIONS(2410),
    [anon_sym_struct] = ACTIONS(2410),
    [anon_sym_union] = ACTIONS(2410),
    [anon_sym_if] = ACTIONS(2410),
    [anon_sym_else] = ACTIONS(2410),
    [anon_sym_switch] = ACTIONS(2410),
    [anon_sym_case] = ACTIONS(2410),
    [anon_sym_default] = ACTIONS(2410),
    [anon_sym_while] = ACTIONS(2410),
    [anon_sym_do] = ACTIONS(2410),
    [anon_sym_for] = ACTIONS(2410),
    [anon_sym_return] = ACTIONS(2410),
    [anon_sym_break] = ACTIONS(2410),
    [anon_sym_continue] = ACTIONS(2410),
    [anon_sym_goto] = ACTIONS(2410),
    [anon_sym___try] = ACTIONS(2410),
    [anon_sym___leave] = ACTIONS(2410),
    [anon_sym_not] = ACTIONS(2410),
    [anon_sym_compl] = ACTIONS(2410),
    [anon_sym_DASH_DASH] = ACTIONS(2408),
    [anon_sym_PLUS_PLUS] = ACTIONS(2408),
    [anon_sym_sizeof] = ACTIONS(2410),
    [anon_sym___alignof__] = ACTIONS(2410),
    [anon_sym___alignof] = ACTIONS(2410),
    [anon_sym__alignof] = ACTIONS(2410),
    [anon_sym_alignof] = ACTIONS(2410),
    [anon_sym__Alignof] = ACTIONS(2410),
    [anon_sym_offsetof] = ACTIONS(2410),
    [anon_sym__Generic] = ACTIONS(2410),
    [anon_sym_asm] = ACTIONS(2410),
    [anon_sym___asm__] = ACTIONS(2410),
    [anon_sym___asm] = ACTIONS(2410),
    [anon_sym_DOT] = ACTIONS(2410),
    [sym_number_literal] = ACTIONS(2408),
    [anon_sym_L_SQUOTE] = ACTIONS(2408),
    [anon_sym_u_SQUOTE] = ACTIONS(2408),
    [anon_sym_U_SQUOTE] = ACTIONS(2408),
    [anon_sym_u8_SQUOTE] = ACTIONS(2408),
    [anon_sym_SQUOTE] = ACTIONS(2408),
    [anon_sym_L_DQUOTE] = ACTIONS(2408),
    [anon_sym_u_DQUOTE] = ACTIONS(2408),
    [anon_sym_U_DQUOTE] = ACTIONS(2408),
    [anon_sym_u8_DQUOTE] = ACTIONS(2408),
    [anon_sym_DQUOTE] = ACTIONS(2408),
    [sym_true] = ACTIONS(2410),
    [sym_false] = ACTIONS(2410),
    [anon_sym_NULL] = ACTIONS(2410),
    [anon_sym_nullptr] = ACTIONS(2410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2410),
    [anon_sym_let] = ACTIONS(2410),
    [anon_sym_This] = ACTIONS(2410),
    [anon_sym_decltype] = ACTIONS(2410),
    [anon_sym_final] = ACTIONS(2410),
    [anon_sym_override] = ACTIONS(2410),
    [anon_sym_explicit] = ACTIONS(2410),
    [anon_sym_typename] = ACTIONS(2410),
    [anon_sym_template] = ACTIONS(2410),
    [anon_sym_operator] = ACTIONS(2410),
    [anon_sym_try] = ACTIONS(2410),
    [anon_sym_delete] = ACTIONS(2410),
    [anon_sym_throw] = ACTIONS(2410),
    [anon_sym_namespace] = ACTIONS(2410),
    [anon_sym_static_assert] = ACTIONS(2410),
    [anon_sym_concept] = ACTIONS(2410),
    [anon_sym_co_return] = ACTIONS(2410),
    [anon_sym_co_yield] = ACTIONS(2410),
    [anon_sym_R_DQUOTE] = ACTIONS(2408),
    [anon_sym_LR_DQUOTE] = ACTIONS(2408),
    [anon_sym_uR_DQUOTE] = ACTIONS(2408),
    [anon_sym_UR_DQUOTE] = ACTIONS(2408),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2408),
    [anon_sym_co_await] = ACTIONS(2410),
    [anon_sym_new] = ACTIONS(2410),
    [anon_sym_requires] = ACTIONS(2410),
    [sym_this] = ACTIONS(2410),
    [anon_sym_discard] = ACTIONS(2410),
    [anon_sym_precise] = ACTIONS(2410),
    [anon_sym_shared] = ACTIONS(2410),
    [anon_sym_groupshared] = ACTIONS(2410),
    [anon_sym_uniform] = ACTIONS(2410),
    [anon_sym_row_major] = ACTIONS(2410),
    [anon_sym_column_major] = ACTIONS(2410),
    [anon_sym_globallycoherent] = ACTIONS(2410),
    [anon_sym_centroid] = ACTIONS(2410),
    [anon_sym_noperspective] = ACTIONS(2410),
    [anon_sym_nointerpolation] = ACTIONS(2410),
    [anon_sym_sample] = ACTIONS(2410),
    [anon_sym_linear] = ACTIONS(2410),
    [anon_sym_snorm] = ACTIONS(2410),
    [anon_sym_unorm] = ACTIONS(2410),
    [anon_sym_point] = ACTIONS(2410),
    [anon_sym_line] = ACTIONS(2410),
    [anon_sym_triangleadj] = ACTIONS(2410),
    [anon_sym_lineadj] = ACTIONS(2410),
    [anon_sym_triangle] = ACTIONS(2410),
    [anon_sym_cbuffer] = ACTIONS(2410),
    [anon_sym_interface] = ACTIONS(2410),
    [anon_sym_extension] = ACTIONS(2410),
  },
  [300] = {
    [sym_catch_clause] = STATE(262),
    [aux_sym_constructor_try_statement_repeat1] = STATE(262),
    [sym_identifier] = ACTIONS(2968),
    [aux_sym_preproc_include_token1] = ACTIONS(2968),
    [aux_sym_preproc_def_token1] = ACTIONS(2968),
    [aux_sym_preproc_if_token1] = ACTIONS(2968),
    [aux_sym_preproc_if_token2] = ACTIONS(2968),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2968),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2968),
    [aux_sym_preproc_else_token1] = ACTIONS(2968),
    [aux_sym_preproc_elif_token1] = ACTIONS(2968),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2968),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2968),
    [sym_preproc_directive] = ACTIONS(2968),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_BANG] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2968),
    [anon_sym_PLUS] = ACTIONS(2968),
    [anon_sym_STAR] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_AMP] = ACTIONS(2968),
    [anon_sym_SEMI] = ACTIONS(2970),
    [anon_sym___extension__] = ACTIONS(2968),
    [anon_sym_typedef] = ACTIONS(2968),
    [anon_sym_in] = ACTIONS(2968),
    [anon_sym_out] = ACTIONS(2968),
    [anon_sym_inout] = ACTIONS(2968),
    [anon_sym_virtual] = ACTIONS(2968),
    [anon_sym_extern] = ACTIONS(2968),
    [anon_sym___attribute__] = ACTIONS(2968),
    [anon_sym___attribute] = ACTIONS(2968),
    [anon_sym_using] = ACTIONS(2968),
    [anon_sym_COLON_COLON] = ACTIONS(2970),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2970),
    [anon_sym___declspec] = ACTIONS(2968),
    [anon_sym___based] = ACTIONS(2968),
    [anon_sym___cdecl] = ACTIONS(2968),
    [anon_sym___clrcall] = ACTIONS(2968),
    [anon_sym___stdcall] = ACTIONS(2968),
    [anon_sym___fastcall] = ACTIONS(2968),
    [anon_sym___thiscall] = ACTIONS(2968),
    [anon_sym___vectorcall] = ACTIONS(2968),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_signed] = ACTIONS(2968),
    [anon_sym_unsigned] = ACTIONS(2968),
    [anon_sym_long] = ACTIONS(2968),
    [anon_sym_short] = ACTIONS(2968),
    [anon_sym_LBRACK] = ACTIONS(2968),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_register] = ACTIONS(2968),
    [anon_sym_inline] = ACTIONS(2968),
    [anon_sym___inline] = ACTIONS(2968),
    [anon_sym___inline__] = ACTIONS(2968),
    [anon_sym___forceinline] = ACTIONS(2968),
    [anon_sym_thread_local] = ACTIONS(2968),
    [anon_sym___thread] = ACTIONS(2968),
    [anon_sym_const] = ACTIONS(2968),
    [anon_sym_constexpr] = ACTIONS(2968),
    [anon_sym_volatile] = ACTIONS(2968),
    [anon_sym_restrict] = ACTIONS(2968),
    [anon_sym___restrict__] = ACTIONS(2968),
    [anon_sym__Atomic] = ACTIONS(2968),
    [anon_sym__Noreturn] = ACTIONS(2968),
    [anon_sym_noreturn] = ACTIONS(2968),
    [anon_sym__Nonnull] = ACTIONS(2968),
    [anon_sym_mutable] = ACTIONS(2968),
    [anon_sym_constinit] = ACTIONS(2968),
    [anon_sym_consteval] = ACTIONS(2968),
    [anon_sym_alignas] = ACTIONS(2968),
    [anon_sym__Alignas] = ACTIONS(2968),
    [sym_primitive_type] = ACTIONS(2968),
    [anon_sym_enum] = ACTIONS(2968),
    [anon_sym_class] = ACTIONS(2968),
    [anon_sym_struct] = ACTIONS(2968),
    [anon_sym_union] = ACTIONS(2968),
    [anon_sym_if] = ACTIONS(2968),
    [anon_sym_switch] = ACTIONS(2968),
    [anon_sym_case] = ACTIONS(2968),
    [anon_sym_default] = ACTIONS(2968),
    [anon_sym_while] = ACTIONS(2968),
    [anon_sym_do] = ACTIONS(2968),
    [anon_sym_for] = ACTIONS(2968),
    [anon_sym_return] = ACTIONS(2968),
    [anon_sym_break] = ACTIONS(2968),
    [anon_sym_continue] = ACTIONS(2968),
    [anon_sym_goto] = ACTIONS(2968),
    [anon_sym___try] = ACTIONS(2968),
    [anon_sym___leave] = ACTIONS(2968),
    [anon_sym_not] = ACTIONS(2968),
    [anon_sym_compl] = ACTIONS(2968),
    [anon_sym_DASH_DASH] = ACTIONS(2970),
    [anon_sym_PLUS_PLUS] = ACTIONS(2970),
    [anon_sym_sizeof] = ACTIONS(2968),
    [anon_sym___alignof__] = ACTIONS(2968),
    [anon_sym___alignof] = ACTIONS(2968),
    [anon_sym__alignof] = ACTIONS(2968),
    [anon_sym_alignof] = ACTIONS(2968),
    [anon_sym__Alignof] = ACTIONS(2968),
    [anon_sym_offsetof] = ACTIONS(2968),
    [anon_sym__Generic] = ACTIONS(2968),
    [anon_sym_asm] = ACTIONS(2968),
    [anon_sym___asm__] = ACTIONS(2968),
    [anon_sym___asm] = ACTIONS(2968),
    [sym_number_literal] = ACTIONS(2970),
    [anon_sym_L_SQUOTE] = ACTIONS(2970),
    [anon_sym_u_SQUOTE] = ACTIONS(2970),
    [anon_sym_U_SQUOTE] = ACTIONS(2970),
    [anon_sym_u8_SQUOTE] = ACTIONS(2970),
    [anon_sym_SQUOTE] = ACTIONS(2970),
    [anon_sym_L_DQUOTE] = ACTIONS(2970),
    [anon_sym_u_DQUOTE] = ACTIONS(2970),
    [anon_sym_U_DQUOTE] = ACTIONS(2970),
    [anon_sym_u8_DQUOTE] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(2970),
    [sym_true] = ACTIONS(2968),
    [sym_false] = ACTIONS(2968),
    [anon_sym_NULL] = ACTIONS(2968),
    [anon_sym_nullptr] = ACTIONS(2968),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2968),
    [anon_sym_let] = ACTIONS(2968),
    [anon_sym_This] = ACTIONS(2968),
    [anon_sym_decltype] = ACTIONS(2968),
    [anon_sym_explicit] = ACTIONS(2968),
    [anon_sym_typename] = ACTIONS(2968),
    [anon_sym_template] = ACTIONS(2968),
    [anon_sym_operator] = ACTIONS(2968),
    [anon_sym_try] = ACTIONS(2968),
    [anon_sym_delete] = ACTIONS(2968),
    [anon_sym_throw] = ACTIONS(2968),
    [anon_sym_namespace] = ACTIONS(2968),
    [anon_sym_static_assert] = ACTIONS(2968),
    [anon_sym_concept] = ACTIONS(2968),
    [anon_sym_co_return] = ACTIONS(2968),
    [anon_sym_co_yield] = ACTIONS(2968),
    [anon_sym_catch] = ACTIONS(2889),
    [anon_sym_R_DQUOTE] = ACTIONS(2970),
    [anon_sym_LR_DQUOTE] = ACTIONS(2970),
    [anon_sym_uR_DQUOTE] = ACTIONS(2970),
    [anon_sym_UR_DQUOTE] = ACTIONS(2970),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2970),
    [anon_sym_co_await] = ACTIONS(2968),
    [anon_sym_new] = ACTIONS(2968),
    [anon_sym_requires] = ACTIONS(2968),
    [sym_this] = ACTIONS(2968),
    [anon_sym_discard] = ACTIONS(2968),
    [anon_sym_precise] = ACTIONS(2968),
    [anon_sym_shared] = ACTIONS(2968),
    [anon_sym_groupshared] = ACTIONS(2968),
    [anon_sym_uniform] = ACTIONS(2968),
    [anon_sym_row_major] = ACTIONS(2968),
    [anon_sym_column_major] = ACTIONS(2968),
    [anon_sym_globallycoherent] = ACTIONS(2968),
    [anon_sym_centroid] = ACTIONS(2968),
    [anon_sym_noperspective] = ACTIONS(2968),
    [anon_sym_nointerpolation] = ACTIONS(2968),
    [anon_sym_sample] = ACTIONS(2968),
    [anon_sym_linear] = ACTIONS(2968),
    [anon_sym_snorm] = ACTIONS(2968),
    [anon_sym_unorm] = ACTIONS(2968),
    [anon_sym_point] = ACTIONS(2968),
    [anon_sym_line] = ACTIONS(2968),
    [anon_sym_triangleadj] = ACTIONS(2968),
    [anon_sym_lineadj] = ACTIONS(2968),
    [anon_sym_triangle] = ACTIONS(2968),
    [anon_sym_cbuffer] = ACTIONS(2968),
    [anon_sym_interface] = ACTIONS(2968),
    [anon_sym_extension] = ACTIONS(2968),
  },
  [301] = {
    [sym_template_argument_list] = STATE(403),
    [sym_identifier] = ACTIONS(2222),
    [aux_sym_preproc_include_token1] = ACTIONS(2222),
    [aux_sym_preproc_def_token1] = ACTIONS(2222),
    [aux_sym_preproc_if_token1] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2222),
    [sym_preproc_directive] = ACTIONS(2222),
    [anon_sym_LPAREN2] = ACTIONS(2229),
    [anon_sym_BANG] = ACTIONS(2229),
    [anon_sym_TILDE] = ACTIONS(2229),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2229),
    [anon_sym_AMP_AMP] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2966),
    [anon_sym_COLON] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(2229),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_typedef] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_virtual] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym___attribute] = ACTIONS(2222),
    [anon_sym_using] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2229),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym___based] = ACTIONS(2222),
    [anon_sym___cdecl] = ACTIONS(2222),
    [anon_sym___clrcall] = ACTIONS(2222),
    [anon_sym___stdcall] = ACTIONS(2222),
    [anon_sym___fastcall] = ACTIONS(2222),
    [anon_sym___thiscall] = ACTIONS(2222),
    [anon_sym___vectorcall] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_RBRACE] = ACTIONS(2229),
    [anon_sym_signed] = ACTIONS(2222),
    [anon_sym_unsigned] = ACTIONS(2222),
    [anon_sym_long] = ACTIONS(2222),
    [anon_sym_short] = ACTIONS(2222),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym__Nonnull] = ACTIONS(2222),
    [anon_sym_mutable] = ACTIONS(2222),
    [anon_sym_constinit] = ACTIONS(2222),
    [anon_sym_consteval] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [sym_primitive_type] = ACTIONS(2222),
    [anon_sym_enum] = ACTIONS(2222),
    [anon_sym_class] = ACTIONS(2222),
    [anon_sym_struct] = ACTIONS(2222),
    [anon_sym_union] = ACTIONS(2222),
    [anon_sym_if] = ACTIONS(2222),
    [anon_sym_else] = ACTIONS(2222),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2222),
    [anon_sym_default] = ACTIONS(2222),
    [anon_sym_while] = ACTIONS(2222),
    [anon_sym_do] = ACTIONS(2222),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_return] = ACTIONS(2222),
    [anon_sym_break] = ACTIONS(2222),
    [anon_sym_continue] = ACTIONS(2222),
    [anon_sym_goto] = ACTIONS(2222),
    [anon_sym___try] = ACTIONS(2222),
    [anon_sym___leave] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_compl] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2229),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(2222),
    [anon_sym___alignof] = ACTIONS(2222),
    [anon_sym__alignof] = ACTIONS(2222),
    [anon_sym_alignof] = ACTIONS(2222),
    [anon_sym__Alignof] = ACTIONS(2222),
    [anon_sym_offsetof] = ACTIONS(2222),
    [anon_sym__Generic] = ACTIONS(2222),
    [anon_sym_asm] = ACTIONS(2222),
    [anon_sym___asm__] = ACTIONS(2222),
    [anon_sym___asm] = ACTIONS(2222),
    [anon_sym_DOT] = ACTIONS(2222),
    [sym_number_literal] = ACTIONS(2229),
    [anon_sym_L_SQUOTE] = ACTIONS(2229),
    [anon_sym_u_SQUOTE] = ACTIONS(2229),
    [anon_sym_U_SQUOTE] = ACTIONS(2229),
    [anon_sym_u8_SQUOTE] = ACTIONS(2229),
    [anon_sym_SQUOTE] = ACTIONS(2229),
    [anon_sym_L_DQUOTE] = ACTIONS(2229),
    [anon_sym_u_DQUOTE] = ACTIONS(2229),
    [anon_sym_U_DQUOTE] = ACTIONS(2229),
    [anon_sym_u8_DQUOTE] = ACTIONS(2229),
    [anon_sym_DQUOTE] = ACTIONS(2229),
    [sym_true] = ACTIONS(2222),
    [sym_false] = ACTIONS(2222),
    [anon_sym_NULL] = ACTIONS(2222),
    [anon_sym_nullptr] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2222),
    [anon_sym_let] = ACTIONS(2222),
    [anon_sym_This] = ACTIONS(2222),
    [anon_sym_decltype] = ACTIONS(2222),
    [anon_sym_final] = ACTIONS(2222),
    [anon_sym_override] = ACTIONS(2222),
    [anon_sym_explicit] = ACTIONS(2222),
    [anon_sym_typename] = ACTIONS(2222),
    [anon_sym_template] = ACTIONS(2222),
    [anon_sym_operator] = ACTIONS(2222),
    [anon_sym_try] = ACTIONS(2222),
    [anon_sym_delete] = ACTIONS(2222),
    [anon_sym_throw] = ACTIONS(2222),
    [anon_sym_namespace] = ACTIONS(2222),
    [anon_sym_static_assert] = ACTIONS(2222),
    [anon_sym_concept] = ACTIONS(2222),
    [anon_sym_co_return] = ACTIONS(2222),
    [anon_sym_co_yield] = ACTIONS(2222),
    [anon_sym_R_DQUOTE] = ACTIONS(2229),
    [anon_sym_LR_DQUOTE] = ACTIONS(2229),
    [anon_sym_uR_DQUOTE] = ACTIONS(2229),
    [anon_sym_UR_DQUOTE] = ACTIONS(2229),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2229),
    [anon_sym_co_await] = ACTIONS(2222),
    [anon_sym_new] = ACTIONS(2222),
    [anon_sym_requires] = ACTIONS(2222),
    [sym_this] = ACTIONS(2222),
    [anon_sym_discard] = ACTIONS(2222),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_groupshared] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_row_major] = ACTIONS(2222),
    [anon_sym_column_major] = ACTIONS(2222),
    [anon_sym_globallycoherent] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym_nointerpolation] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_linear] = ACTIONS(2222),
    [anon_sym_snorm] = ACTIONS(2222),
    [anon_sym_unorm] = ACTIONS(2222),
    [anon_sym_point] = ACTIONS(2222),
    [anon_sym_line] = ACTIONS(2222),
    [anon_sym_triangleadj] = ACTIONS(2222),
    [anon_sym_lineadj] = ACTIONS(2222),
    [anon_sym_triangle] = ACTIONS(2222),
    [anon_sym_cbuffer] = ACTIONS(2222),
    [anon_sym_interface] = ACTIONS(2222),
    [anon_sym_extension] = ACTIONS(2222),
  },
  [302] = {
    [ts_builtin_sym_end] = ACTIONS(2972),
    [sym_identifier] = ACTIONS(2974),
    [aux_sym_preproc_include_token1] = ACTIONS(2974),
    [aux_sym_preproc_def_token1] = ACTIONS(2974),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_RPAREN] = ACTIONS(2972),
    [aux_sym_preproc_if_token1] = ACTIONS(2974),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2974),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2974),
    [sym_preproc_directive] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_BANG] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym___extension__] = ACTIONS(2974),
    [anon_sym_typedef] = ACTIONS(2974),
    [anon_sym_in] = ACTIONS(2974),
    [anon_sym_out] = ACTIONS(2974),
    [anon_sym_inout] = ACTIONS(2974),
    [anon_sym_virtual] = ACTIONS(2974),
    [anon_sym_extern] = ACTIONS(2974),
    [anon_sym___attribute__] = ACTIONS(2974),
    [anon_sym___attribute] = ACTIONS(2974),
    [anon_sym_using] = ACTIONS(2974),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2974),
    [anon_sym___based] = ACTIONS(2974),
    [anon_sym___cdecl] = ACTIONS(2974),
    [anon_sym___clrcall] = ACTIONS(2974),
    [anon_sym___stdcall] = ACTIONS(2974),
    [anon_sym___fastcall] = ACTIONS(2974),
    [anon_sym___thiscall] = ACTIONS(2974),
    [anon_sym___vectorcall] = ACTIONS(2974),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_signed] = ACTIONS(2974),
    [anon_sym_unsigned] = ACTIONS(2974),
    [anon_sym_long] = ACTIONS(2974),
    [anon_sym_short] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [anon_sym_static] = ACTIONS(2974),
    [anon_sym_register] = ACTIONS(2974),
    [anon_sym_inline] = ACTIONS(2974),
    [anon_sym___inline] = ACTIONS(2974),
    [anon_sym___inline__] = ACTIONS(2974),
    [anon_sym___forceinline] = ACTIONS(2974),
    [anon_sym_thread_local] = ACTIONS(2974),
    [anon_sym___thread] = ACTIONS(2974),
    [anon_sym_const] = ACTIONS(2974),
    [anon_sym_constexpr] = ACTIONS(2974),
    [anon_sym_volatile] = ACTIONS(2974),
    [anon_sym_restrict] = ACTIONS(2974),
    [anon_sym___restrict__] = ACTIONS(2974),
    [anon_sym__Atomic] = ACTIONS(2974),
    [anon_sym__Noreturn] = ACTIONS(2974),
    [anon_sym_noreturn] = ACTIONS(2974),
    [anon_sym__Nonnull] = ACTIONS(2974),
    [anon_sym_mutable] = ACTIONS(2974),
    [anon_sym_constinit] = ACTIONS(2974),
    [anon_sym_consteval] = ACTIONS(2974),
    [anon_sym_alignas] = ACTIONS(2974),
    [anon_sym__Alignas] = ACTIONS(2974),
    [sym_primitive_type] = ACTIONS(2974),
    [anon_sym_enum] = ACTIONS(2974),
    [anon_sym_class] = ACTIONS(2974),
    [anon_sym_struct] = ACTIONS(2974),
    [anon_sym_union] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2974),
    [anon_sym_switch] = ACTIONS(2974),
    [anon_sym_case] = ACTIONS(2974),
    [anon_sym_default] = ACTIONS(2974),
    [anon_sym_while] = ACTIONS(2974),
    [anon_sym_do] = ACTIONS(2974),
    [anon_sym_for] = ACTIONS(2974),
    [anon_sym_return] = ACTIONS(2974),
    [anon_sym_break] = ACTIONS(2974),
    [anon_sym_continue] = ACTIONS(2974),
    [anon_sym_goto] = ACTIONS(2974),
    [anon_sym_not] = ACTIONS(2974),
    [anon_sym_compl] = ACTIONS(2974),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_sizeof] = ACTIONS(2974),
    [anon_sym___alignof__] = ACTIONS(2974),
    [anon_sym___alignof] = ACTIONS(2974),
    [anon_sym__alignof] = ACTIONS(2974),
    [anon_sym_alignof] = ACTIONS(2974),
    [anon_sym__Alignof] = ACTIONS(2974),
    [anon_sym_offsetof] = ACTIONS(2974),
    [anon_sym__Generic] = ACTIONS(2974),
    [anon_sym_asm] = ACTIONS(2974),
    [anon_sym___asm__] = ACTIONS(2974),
    [anon_sym___asm] = ACTIONS(2974),
    [anon_sym_DOT] = ACTIONS(2974),
    [sym_number_literal] = ACTIONS(2972),
    [anon_sym_L_SQUOTE] = ACTIONS(2972),
    [anon_sym_u_SQUOTE] = ACTIONS(2972),
    [anon_sym_U_SQUOTE] = ACTIONS(2972),
    [anon_sym_u8_SQUOTE] = ACTIONS(2972),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [anon_sym_L_DQUOTE] = ACTIONS(2972),
    [anon_sym_u_DQUOTE] = ACTIONS(2972),
    [anon_sym_U_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE] = ACTIONS(2972),
    [sym_true] = ACTIONS(2974),
    [sym_false] = ACTIONS(2974),
    [anon_sym_NULL] = ACTIONS(2974),
    [anon_sym_nullptr] = ACTIONS(2974),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_This] = ACTIONS(2974),
    [anon_sym_decltype] = ACTIONS(2974),
    [anon_sym_final] = ACTIONS(2974),
    [anon_sym_override] = ACTIONS(2974),
    [anon_sym_explicit] = ACTIONS(2974),
    [anon_sym_typename] = ACTIONS(2974),
    [anon_sym_export] = ACTIONS(2974),
    [anon_sym_module] = ACTIONS(2974),
    [anon_sym_import] = ACTIONS(2974),
    [anon_sym_template] = ACTIONS(2974),
    [anon_sym_GT2] = ACTIONS(2972),
    [anon_sym_operator] = ACTIONS(2974),
    [anon_sym_try] = ACTIONS(2974),
    [anon_sym_delete] = ACTIONS(2974),
    [anon_sym_throw] = ACTIONS(2974),
    [anon_sym_namespace] = ACTIONS(2974),
    [anon_sym_static_assert] = ACTIONS(2974),
    [anon_sym_concept] = ACTIONS(2974),
    [anon_sym_co_return] = ACTIONS(2974),
    [anon_sym_co_yield] = ACTIONS(2974),
    [anon_sym_R_DQUOTE] = ACTIONS(2972),
    [anon_sym_LR_DQUOTE] = ACTIONS(2972),
    [anon_sym_uR_DQUOTE] = ACTIONS(2972),
    [anon_sym_UR_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2972),
    [anon_sym_co_await] = ACTIONS(2974),
    [anon_sym_new] = ACTIONS(2974),
    [anon_sym_requires] = ACTIONS(2974),
    [sym_this] = ACTIONS(2974),
    [anon_sym_precise] = ACTIONS(2974),
    [anon_sym_shared] = ACTIONS(2974),
    [anon_sym_groupshared] = ACTIONS(2974),
    [anon_sym_uniform] = ACTIONS(2974),
    [anon_sym_row_major] = ACTIONS(2974),
    [anon_sym_column_major] = ACTIONS(2974),
    [anon_sym_globallycoherent] = ACTIONS(2974),
    [anon_sym_centroid] = ACTIONS(2974),
    [anon_sym_noperspective] = ACTIONS(2974),
    [anon_sym_nointerpolation] = ACTIONS(2974),
    [anon_sym_sample] = ACTIONS(2974),
    [anon_sym_linear] = ACTIONS(2974),
    [anon_sym_snorm] = ACTIONS(2974),
    [anon_sym_unorm] = ACTIONS(2974),
    [anon_sym_point] = ACTIONS(2974),
    [anon_sym_line] = ACTIONS(2974),
    [anon_sym_triangleadj] = ACTIONS(2974),
    [anon_sym_lineadj] = ACTIONS(2974),
    [anon_sym_triangle] = ACTIONS(2974),
    [anon_sym_interface] = ACTIONS(2974),
    [anon_sym_extension] = ACTIONS(2974),
    [anon_sym_where] = ACTIONS(2974),
    [anon_sym___exported] = ACTIONS(2974),
  },
  [303] = {
    [ts_builtin_sym_end] = ACTIONS(2976),
    [sym_identifier] = ACTIONS(2978),
    [aux_sym_preproc_include_token1] = ACTIONS(2978),
    [aux_sym_preproc_def_token1] = ACTIONS(2978),
    [anon_sym_COMMA] = ACTIONS(2976),
    [anon_sym_RPAREN] = ACTIONS(2976),
    [aux_sym_preproc_if_token1] = ACTIONS(2978),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2978),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2978),
    [sym_preproc_directive] = ACTIONS(2978),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2976),
    [anon_sym_TILDE] = ACTIONS(2976),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_STAR] = ACTIONS(2976),
    [anon_sym_AMP_AMP] = ACTIONS(2976),
    [anon_sym_AMP] = ACTIONS(2978),
    [anon_sym_SEMI] = ACTIONS(2976),
    [anon_sym___extension__] = ACTIONS(2978),
    [anon_sym_typedef] = ACTIONS(2978),
    [anon_sym_in] = ACTIONS(2978),
    [anon_sym_out] = ACTIONS(2978),
    [anon_sym_inout] = ACTIONS(2978),
    [anon_sym_virtual] = ACTIONS(2978),
    [anon_sym_extern] = ACTIONS(2978),
    [anon_sym___attribute__] = ACTIONS(2978),
    [anon_sym___attribute] = ACTIONS(2978),
    [anon_sym_using] = ACTIONS(2978),
    [anon_sym_COLON_COLON] = ACTIONS(2976),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2976),
    [anon_sym___declspec] = ACTIONS(2978),
    [anon_sym___based] = ACTIONS(2978),
    [anon_sym___cdecl] = ACTIONS(2978),
    [anon_sym___clrcall] = ACTIONS(2978),
    [anon_sym___stdcall] = ACTIONS(2978),
    [anon_sym___fastcall] = ACTIONS(2978),
    [anon_sym___thiscall] = ACTIONS(2978),
    [anon_sym___vectorcall] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(2976),
    [anon_sym_signed] = ACTIONS(2978),
    [anon_sym_unsigned] = ACTIONS(2978),
    [anon_sym_long] = ACTIONS(2978),
    [anon_sym_short] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_static] = ACTIONS(2978),
    [anon_sym_register] = ACTIONS(2978),
    [anon_sym_inline] = ACTIONS(2978),
    [anon_sym___inline] = ACTIONS(2978),
    [anon_sym___inline__] = ACTIONS(2978),
    [anon_sym___forceinline] = ACTIONS(2978),
    [anon_sym_thread_local] = ACTIONS(2978),
    [anon_sym___thread] = ACTIONS(2978),
    [anon_sym_const] = ACTIONS(2978),
    [anon_sym_constexpr] = ACTIONS(2978),
    [anon_sym_volatile] = ACTIONS(2978),
    [anon_sym_restrict] = ACTIONS(2978),
    [anon_sym___restrict__] = ACTIONS(2978),
    [anon_sym__Atomic] = ACTIONS(2978),
    [anon_sym__Noreturn] = ACTIONS(2978),
    [anon_sym_noreturn] = ACTIONS(2978),
    [anon_sym__Nonnull] = ACTIONS(2978),
    [anon_sym_mutable] = ACTIONS(2978),
    [anon_sym_constinit] = ACTIONS(2978),
    [anon_sym_consteval] = ACTIONS(2978),
    [anon_sym_alignas] = ACTIONS(2978),
    [anon_sym__Alignas] = ACTIONS(2978),
    [sym_primitive_type] = ACTIONS(2978),
    [anon_sym_enum] = ACTIONS(2978),
    [anon_sym_class] = ACTIONS(2978),
    [anon_sym_struct] = ACTIONS(2978),
    [anon_sym_union] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_switch] = ACTIONS(2978),
    [anon_sym_case] = ACTIONS(2978),
    [anon_sym_default] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_do] = ACTIONS(2978),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_break] = ACTIONS(2978),
    [anon_sym_continue] = ACTIONS(2978),
    [anon_sym_goto] = ACTIONS(2978),
    [anon_sym_not] = ACTIONS(2978),
    [anon_sym_compl] = ACTIONS(2978),
    [anon_sym_DASH_DASH] = ACTIONS(2976),
    [anon_sym_PLUS_PLUS] = ACTIONS(2976),
    [anon_sym_sizeof] = ACTIONS(2978),
    [anon_sym___alignof__] = ACTIONS(2978),
    [anon_sym___alignof] = ACTIONS(2978),
    [anon_sym__alignof] = ACTIONS(2978),
    [anon_sym_alignof] = ACTIONS(2978),
    [anon_sym__Alignof] = ACTIONS(2978),
    [anon_sym_offsetof] = ACTIONS(2978),
    [anon_sym__Generic] = ACTIONS(2978),
    [anon_sym_asm] = ACTIONS(2978),
    [anon_sym___asm__] = ACTIONS(2978),
    [anon_sym___asm] = ACTIONS(2978),
    [anon_sym_DOT] = ACTIONS(2978),
    [sym_number_literal] = ACTIONS(2976),
    [anon_sym_L_SQUOTE] = ACTIONS(2976),
    [anon_sym_u_SQUOTE] = ACTIONS(2976),
    [anon_sym_U_SQUOTE] = ACTIONS(2976),
    [anon_sym_u8_SQUOTE] = ACTIONS(2976),
    [anon_sym_SQUOTE] = ACTIONS(2976),
    [anon_sym_L_DQUOTE] = ACTIONS(2976),
    [anon_sym_u_DQUOTE] = ACTIONS(2976),
    [anon_sym_U_DQUOTE] = ACTIONS(2976),
    [anon_sym_u8_DQUOTE] = ACTIONS(2976),
    [anon_sym_DQUOTE] = ACTIONS(2976),
    [sym_true] = ACTIONS(2978),
    [sym_false] = ACTIONS(2978),
    [anon_sym_NULL] = ACTIONS(2978),
    [anon_sym_nullptr] = ACTIONS(2978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_This] = ACTIONS(2978),
    [anon_sym_decltype] = ACTIONS(2978),
    [anon_sym_final] = ACTIONS(2978),
    [anon_sym_override] = ACTIONS(2978),
    [anon_sym_explicit] = ACTIONS(2978),
    [anon_sym_typename] = ACTIONS(2978),
    [anon_sym_export] = ACTIONS(2978),
    [anon_sym_module] = ACTIONS(2978),
    [anon_sym_import] = ACTIONS(2978),
    [anon_sym_template] = ACTIONS(2978),
    [anon_sym_GT2] = ACTIONS(2976),
    [anon_sym_operator] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2978),
    [anon_sym_delete] = ACTIONS(2978),
    [anon_sym_throw] = ACTIONS(2978),
    [anon_sym_namespace] = ACTIONS(2978),
    [anon_sym_static_assert] = ACTIONS(2978),
    [anon_sym_concept] = ACTIONS(2978),
    [anon_sym_co_return] = ACTIONS(2978),
    [anon_sym_co_yield] = ACTIONS(2978),
    [anon_sym_R_DQUOTE] = ACTIONS(2976),
    [anon_sym_LR_DQUOTE] = ACTIONS(2976),
    [anon_sym_uR_DQUOTE] = ACTIONS(2976),
    [anon_sym_UR_DQUOTE] = ACTIONS(2976),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2976),
    [anon_sym_co_await] = ACTIONS(2978),
    [anon_sym_new] = ACTIONS(2978),
    [anon_sym_requires] = ACTIONS(2978),
    [sym_this] = ACTIONS(2978),
    [anon_sym_precise] = ACTIONS(2978),
    [anon_sym_shared] = ACTIONS(2978),
    [anon_sym_groupshared] = ACTIONS(2978),
    [anon_sym_uniform] = ACTIONS(2978),
    [anon_sym_row_major] = ACTIONS(2978),
    [anon_sym_column_major] = ACTIONS(2978),
    [anon_sym_globallycoherent] = ACTIONS(2978),
    [anon_sym_centroid] = ACTIONS(2978),
    [anon_sym_noperspective] = ACTIONS(2978),
    [anon_sym_nointerpolation] = ACTIONS(2978),
    [anon_sym_sample] = ACTIONS(2978),
    [anon_sym_linear] = ACTIONS(2978),
    [anon_sym_snorm] = ACTIONS(2978),
    [anon_sym_unorm] = ACTIONS(2978),
    [anon_sym_point] = ACTIONS(2978),
    [anon_sym_line] = ACTIONS(2978),
    [anon_sym_triangleadj] = ACTIONS(2978),
    [anon_sym_lineadj] = ACTIONS(2978),
    [anon_sym_triangle] = ACTIONS(2978),
    [anon_sym_interface] = ACTIONS(2978),
    [anon_sym_extension] = ACTIONS(2978),
    [anon_sym_where] = ACTIONS(2978),
    [anon_sym___exported] = ACTIONS(2978),
  },
  [304] = {
    [ts_builtin_sym_end] = ACTIONS(2980),
    [sym_identifier] = ACTIONS(2982),
    [aux_sym_preproc_include_token1] = ACTIONS(2982),
    [aux_sym_preproc_def_token1] = ACTIONS(2982),
    [anon_sym_COMMA] = ACTIONS(2980),
    [anon_sym_RPAREN] = ACTIONS(2980),
    [aux_sym_preproc_if_token1] = ACTIONS(2982),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2982),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2982),
    [sym_preproc_directive] = ACTIONS(2982),
    [anon_sym_LPAREN2] = ACTIONS(2980),
    [anon_sym_BANG] = ACTIONS(2980),
    [anon_sym_TILDE] = ACTIONS(2980),
    [anon_sym_DASH] = ACTIONS(2982),
    [anon_sym_PLUS] = ACTIONS(2982),
    [anon_sym_STAR] = ACTIONS(2980),
    [anon_sym_AMP_AMP] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_SEMI] = ACTIONS(2980),
    [anon_sym___extension__] = ACTIONS(2982),
    [anon_sym_typedef] = ACTIONS(2982),
    [anon_sym_in] = ACTIONS(2982),
    [anon_sym_out] = ACTIONS(2982),
    [anon_sym_inout] = ACTIONS(2982),
    [anon_sym_virtual] = ACTIONS(2982),
    [anon_sym_extern] = ACTIONS(2982),
    [anon_sym___attribute__] = ACTIONS(2982),
    [anon_sym___attribute] = ACTIONS(2982),
    [anon_sym_using] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2980),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2980),
    [anon_sym___declspec] = ACTIONS(2982),
    [anon_sym___based] = ACTIONS(2982),
    [anon_sym___cdecl] = ACTIONS(2982),
    [anon_sym___clrcall] = ACTIONS(2982),
    [anon_sym___stdcall] = ACTIONS(2982),
    [anon_sym___fastcall] = ACTIONS(2982),
    [anon_sym___thiscall] = ACTIONS(2982),
    [anon_sym___vectorcall] = ACTIONS(2982),
    [anon_sym_LBRACE] = ACTIONS(2980),
    [anon_sym_signed] = ACTIONS(2982),
    [anon_sym_unsigned] = ACTIONS(2982),
    [anon_sym_long] = ACTIONS(2982),
    [anon_sym_short] = ACTIONS(2982),
    [anon_sym_LBRACK] = ACTIONS(2982),
    [anon_sym_static] = ACTIONS(2982),
    [anon_sym_register] = ACTIONS(2982),
    [anon_sym_inline] = ACTIONS(2982),
    [anon_sym___inline] = ACTIONS(2982),
    [anon_sym___inline__] = ACTIONS(2982),
    [anon_sym___forceinline] = ACTIONS(2982),
    [anon_sym_thread_local] = ACTIONS(2982),
    [anon_sym___thread] = ACTIONS(2982),
    [anon_sym_const] = ACTIONS(2982),
    [anon_sym_constexpr] = ACTIONS(2982),
    [anon_sym_volatile] = ACTIONS(2982),
    [anon_sym_restrict] = ACTIONS(2982),
    [anon_sym___restrict__] = ACTIONS(2982),
    [anon_sym__Atomic] = ACTIONS(2982),
    [anon_sym__Noreturn] = ACTIONS(2982),
    [anon_sym_noreturn] = ACTIONS(2982),
    [anon_sym__Nonnull] = ACTIONS(2982),
    [anon_sym_mutable] = ACTIONS(2982),
    [anon_sym_constinit] = ACTIONS(2982),
    [anon_sym_consteval] = ACTIONS(2982),
    [anon_sym_alignas] = ACTIONS(2982),
    [anon_sym__Alignas] = ACTIONS(2982),
    [sym_primitive_type] = ACTIONS(2982),
    [anon_sym_enum] = ACTIONS(2982),
    [anon_sym_class] = ACTIONS(2982),
    [anon_sym_struct] = ACTIONS(2982),
    [anon_sym_union] = ACTIONS(2982),
    [anon_sym_if] = ACTIONS(2982),
    [anon_sym_switch] = ACTIONS(2982),
    [anon_sym_case] = ACTIONS(2982),
    [anon_sym_default] = ACTIONS(2982),
    [anon_sym_while] = ACTIONS(2982),
    [anon_sym_do] = ACTIONS(2982),
    [anon_sym_for] = ACTIONS(2982),
    [anon_sym_return] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2982),
    [anon_sym_continue] = ACTIONS(2982),
    [anon_sym_goto] = ACTIONS(2982),
    [anon_sym_not] = ACTIONS(2982),
    [anon_sym_compl] = ACTIONS(2982),
    [anon_sym_DASH_DASH] = ACTIONS(2980),
    [anon_sym_PLUS_PLUS] = ACTIONS(2980),
    [anon_sym_sizeof] = ACTIONS(2982),
    [anon_sym___alignof__] = ACTIONS(2982),
    [anon_sym___alignof] = ACTIONS(2982),
    [anon_sym__alignof] = ACTIONS(2982),
    [anon_sym_alignof] = ACTIONS(2982),
    [anon_sym__Alignof] = ACTIONS(2982),
    [anon_sym_offsetof] = ACTIONS(2982),
    [anon_sym__Generic] = ACTIONS(2982),
    [anon_sym_asm] = ACTIONS(2982),
    [anon_sym___asm__] = ACTIONS(2982),
    [anon_sym___asm] = ACTIONS(2982),
    [anon_sym_DOT] = ACTIONS(2982),
    [sym_number_literal] = ACTIONS(2980),
    [anon_sym_L_SQUOTE] = ACTIONS(2980),
    [anon_sym_u_SQUOTE] = ACTIONS(2980),
    [anon_sym_U_SQUOTE] = ACTIONS(2980),
    [anon_sym_u8_SQUOTE] = ACTIONS(2980),
    [anon_sym_SQUOTE] = ACTIONS(2980),
    [anon_sym_L_DQUOTE] = ACTIONS(2980),
    [anon_sym_u_DQUOTE] = ACTIONS(2980),
    [anon_sym_U_DQUOTE] = ACTIONS(2980),
    [anon_sym_u8_DQUOTE] = ACTIONS(2980),
    [anon_sym_DQUOTE] = ACTIONS(2980),
    [sym_true] = ACTIONS(2982),
    [sym_false] = ACTIONS(2982),
    [anon_sym_NULL] = ACTIONS(2982),
    [anon_sym_nullptr] = ACTIONS(2982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2982),
    [anon_sym_let] = ACTIONS(2982),
    [anon_sym_This] = ACTIONS(2982),
    [anon_sym_decltype] = ACTIONS(2982),
    [anon_sym_final] = ACTIONS(2982),
    [anon_sym_override] = ACTIONS(2982),
    [anon_sym_explicit] = ACTIONS(2982),
    [anon_sym_typename] = ACTIONS(2982),
    [anon_sym_export] = ACTIONS(2982),
    [anon_sym_module] = ACTIONS(2982),
    [anon_sym_import] = ACTIONS(2982),
    [anon_sym_template] = ACTIONS(2982),
    [anon_sym_GT2] = ACTIONS(2980),
    [anon_sym_operator] = ACTIONS(2982),
    [anon_sym_try] = ACTIONS(2982),
    [anon_sym_delete] = ACTIONS(2982),
    [anon_sym_throw] = ACTIONS(2982),
    [anon_sym_namespace] = ACTIONS(2982),
    [anon_sym_static_assert] = ACTIONS(2982),
    [anon_sym_concept] = ACTIONS(2982),
    [anon_sym_co_return] = ACTIONS(2982),
    [anon_sym_co_yield] = ACTIONS(2982),
    [anon_sym_R_DQUOTE] = ACTIONS(2980),
    [anon_sym_LR_DQUOTE] = ACTIONS(2980),
    [anon_sym_uR_DQUOTE] = ACTIONS(2980),
    [anon_sym_UR_DQUOTE] = ACTIONS(2980),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2980),
    [anon_sym_co_await] = ACTIONS(2982),
    [anon_sym_new] = ACTIONS(2982),
    [anon_sym_requires] = ACTIONS(2982),
    [sym_this] = ACTIONS(2982),
    [anon_sym_precise] = ACTIONS(2982),
    [anon_sym_shared] = ACTIONS(2982),
    [anon_sym_groupshared] = ACTIONS(2982),
    [anon_sym_uniform] = ACTIONS(2982),
    [anon_sym_row_major] = ACTIONS(2982),
    [anon_sym_column_major] = ACTIONS(2982),
    [anon_sym_globallycoherent] = ACTIONS(2982),
    [anon_sym_centroid] = ACTIONS(2982),
    [anon_sym_noperspective] = ACTIONS(2982),
    [anon_sym_nointerpolation] = ACTIONS(2982),
    [anon_sym_sample] = ACTIONS(2982),
    [anon_sym_linear] = ACTIONS(2982),
    [anon_sym_snorm] = ACTIONS(2982),
    [anon_sym_unorm] = ACTIONS(2982),
    [anon_sym_point] = ACTIONS(2982),
    [anon_sym_line] = ACTIONS(2982),
    [anon_sym_triangleadj] = ACTIONS(2982),
    [anon_sym_lineadj] = ACTIONS(2982),
    [anon_sym_triangle] = ACTIONS(2982),
    [anon_sym_interface] = ACTIONS(2982),
    [anon_sym_extension] = ACTIONS(2982),
    [anon_sym_where] = ACTIONS(2982),
    [anon_sym___exported] = ACTIONS(2982),
  },
  [305] = {
    [ts_builtin_sym_end] = ACTIONS(2932),
    [sym_identifier] = ACTIONS(2934),
    [aux_sym_preproc_include_token1] = ACTIONS(2934),
    [aux_sym_preproc_def_token1] = ACTIONS(2934),
    [anon_sym_COMMA] = ACTIONS(2932),
    [anon_sym_RPAREN] = ACTIONS(2932),
    [aux_sym_preproc_if_token1] = ACTIONS(2934),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2934),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2934),
    [sym_preproc_directive] = ACTIONS(2934),
    [anon_sym_LPAREN2] = ACTIONS(2932),
    [anon_sym_BANG] = ACTIONS(2932),
    [anon_sym_TILDE] = ACTIONS(2932),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_STAR] = ACTIONS(2932),
    [anon_sym_AMP_AMP] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym___extension__] = ACTIONS(2934),
    [anon_sym_typedef] = ACTIONS(2934),
    [anon_sym_in] = ACTIONS(2934),
    [anon_sym_out] = ACTIONS(2934),
    [anon_sym_inout] = ACTIONS(2934),
    [anon_sym_virtual] = ACTIONS(2934),
    [anon_sym_extern] = ACTIONS(2934),
    [anon_sym___attribute__] = ACTIONS(2934),
    [anon_sym___attribute] = ACTIONS(2934),
    [anon_sym_using] = ACTIONS(2934),
    [anon_sym_COLON_COLON] = ACTIONS(2932),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2932),
    [anon_sym___declspec] = ACTIONS(2934),
    [anon_sym___based] = ACTIONS(2934),
    [anon_sym___cdecl] = ACTIONS(2934),
    [anon_sym___clrcall] = ACTIONS(2934),
    [anon_sym___stdcall] = ACTIONS(2934),
    [anon_sym___fastcall] = ACTIONS(2934),
    [anon_sym___thiscall] = ACTIONS(2934),
    [anon_sym___vectorcall] = ACTIONS(2934),
    [anon_sym_LBRACE] = ACTIONS(2932),
    [anon_sym_signed] = ACTIONS(2934),
    [anon_sym_unsigned] = ACTIONS(2934),
    [anon_sym_long] = ACTIONS(2934),
    [anon_sym_short] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [anon_sym_static] = ACTIONS(2934),
    [anon_sym_register] = ACTIONS(2934),
    [anon_sym_inline] = ACTIONS(2934),
    [anon_sym___inline] = ACTIONS(2934),
    [anon_sym___inline__] = ACTIONS(2934),
    [anon_sym___forceinline] = ACTIONS(2934),
    [anon_sym_thread_local] = ACTIONS(2934),
    [anon_sym___thread] = ACTIONS(2934),
    [anon_sym_const] = ACTIONS(2934),
    [anon_sym_constexpr] = ACTIONS(2934),
    [anon_sym_volatile] = ACTIONS(2934),
    [anon_sym_restrict] = ACTIONS(2934),
    [anon_sym___restrict__] = ACTIONS(2934),
    [anon_sym__Atomic] = ACTIONS(2934),
    [anon_sym__Noreturn] = ACTIONS(2934),
    [anon_sym_noreturn] = ACTIONS(2934),
    [anon_sym__Nonnull] = ACTIONS(2934),
    [anon_sym_mutable] = ACTIONS(2934),
    [anon_sym_constinit] = ACTIONS(2934),
    [anon_sym_consteval] = ACTIONS(2934),
    [anon_sym_alignas] = ACTIONS(2934),
    [anon_sym__Alignas] = ACTIONS(2934),
    [sym_primitive_type] = ACTIONS(2934),
    [anon_sym_enum] = ACTIONS(2934),
    [anon_sym_class] = ACTIONS(2934),
    [anon_sym_struct] = ACTIONS(2934),
    [anon_sym_union] = ACTIONS(2934),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_switch] = ACTIONS(2934),
    [anon_sym_case] = ACTIONS(2934),
    [anon_sym_default] = ACTIONS(2934),
    [anon_sym_while] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2934),
    [anon_sym_for] = ACTIONS(2934),
    [anon_sym_return] = ACTIONS(2934),
    [anon_sym_break] = ACTIONS(2934),
    [anon_sym_continue] = ACTIONS(2934),
    [anon_sym_goto] = ACTIONS(2934),
    [anon_sym_not] = ACTIONS(2934),
    [anon_sym_compl] = ACTIONS(2934),
    [anon_sym_DASH_DASH] = ACTIONS(2932),
    [anon_sym_PLUS_PLUS] = ACTIONS(2932),
    [anon_sym_sizeof] = ACTIONS(2934),
    [anon_sym___alignof__] = ACTIONS(2934),
    [anon_sym___alignof] = ACTIONS(2934),
    [anon_sym__alignof] = ACTIONS(2934),
    [anon_sym_alignof] = ACTIONS(2934),
    [anon_sym__Alignof] = ACTIONS(2934),
    [anon_sym_offsetof] = ACTIONS(2934),
    [anon_sym__Generic] = ACTIONS(2934),
    [anon_sym_asm] = ACTIONS(2934),
    [anon_sym___asm__] = ACTIONS(2934),
    [anon_sym___asm] = ACTIONS(2934),
    [anon_sym_DOT] = ACTIONS(2934),
    [sym_number_literal] = ACTIONS(2932),
    [anon_sym_L_SQUOTE] = ACTIONS(2932),
    [anon_sym_u_SQUOTE] = ACTIONS(2932),
    [anon_sym_U_SQUOTE] = ACTIONS(2932),
    [anon_sym_u8_SQUOTE] = ACTIONS(2932),
    [anon_sym_SQUOTE] = ACTIONS(2932),
    [anon_sym_L_DQUOTE] = ACTIONS(2932),
    [anon_sym_u_DQUOTE] = ACTIONS(2932),
    [anon_sym_U_DQUOTE] = ACTIONS(2932),
    [anon_sym_u8_DQUOTE] = ACTIONS(2932),
    [anon_sym_DQUOTE] = ACTIONS(2932),
    [sym_true] = ACTIONS(2934),
    [sym_false] = ACTIONS(2934),
    [anon_sym_NULL] = ACTIONS(2934),
    [anon_sym_nullptr] = ACTIONS(2934),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_This] = ACTIONS(2934),
    [anon_sym_decltype] = ACTIONS(2934),
    [anon_sym_final] = ACTIONS(2934),
    [anon_sym_override] = ACTIONS(2934),
    [anon_sym_explicit] = ACTIONS(2934),
    [anon_sym_typename] = ACTIONS(2934),
    [anon_sym_export] = ACTIONS(2934),
    [anon_sym_module] = ACTIONS(2934),
    [anon_sym_import] = ACTIONS(2934),
    [anon_sym_template] = ACTIONS(2934),
    [anon_sym_GT2] = ACTIONS(2932),
    [anon_sym_operator] = ACTIONS(2934),
    [anon_sym_try] = ACTIONS(2934),
    [anon_sym_delete] = ACTIONS(2934),
    [anon_sym_throw] = ACTIONS(2934),
    [anon_sym_namespace] = ACTIONS(2934),
    [anon_sym_static_assert] = ACTIONS(2934),
    [anon_sym_concept] = ACTIONS(2934),
    [anon_sym_co_return] = ACTIONS(2934),
    [anon_sym_co_yield] = ACTIONS(2934),
    [anon_sym_R_DQUOTE] = ACTIONS(2932),
    [anon_sym_LR_DQUOTE] = ACTIONS(2932),
    [anon_sym_uR_DQUOTE] = ACTIONS(2932),
    [anon_sym_UR_DQUOTE] = ACTIONS(2932),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2932),
    [anon_sym_co_await] = ACTIONS(2934),
    [anon_sym_new] = ACTIONS(2934),
    [anon_sym_requires] = ACTIONS(2934),
    [sym_this] = ACTIONS(2934),
    [anon_sym_precise] = ACTIONS(2934),
    [anon_sym_shared] = ACTIONS(2934),
    [anon_sym_groupshared] = ACTIONS(2934),
    [anon_sym_uniform] = ACTIONS(2934),
    [anon_sym_row_major] = ACTIONS(2934),
    [anon_sym_column_major] = ACTIONS(2934),
    [anon_sym_globallycoherent] = ACTIONS(2934),
    [anon_sym_centroid] = ACTIONS(2934),
    [anon_sym_noperspective] = ACTIONS(2934),
    [anon_sym_nointerpolation] = ACTIONS(2934),
    [anon_sym_sample] = ACTIONS(2934),
    [anon_sym_linear] = ACTIONS(2934),
    [anon_sym_snorm] = ACTIONS(2934),
    [anon_sym_unorm] = ACTIONS(2934),
    [anon_sym_point] = ACTIONS(2934),
    [anon_sym_line] = ACTIONS(2934),
    [anon_sym_triangleadj] = ACTIONS(2934),
    [anon_sym_lineadj] = ACTIONS(2934),
    [anon_sym_triangle] = ACTIONS(2934),
    [anon_sym_interface] = ACTIONS(2934),
    [anon_sym_extension] = ACTIONS(2934),
    [anon_sym_where] = ACTIONS(2934),
    [anon_sym___exported] = ACTIONS(2934),
  },
  [306] = {
    [ts_builtin_sym_end] = ACTIONS(2984),
    [sym_identifier] = ACTIONS(2986),
    [aux_sym_preproc_include_token1] = ACTIONS(2986),
    [aux_sym_preproc_def_token1] = ACTIONS(2986),
    [anon_sym_COMMA] = ACTIONS(2984),
    [anon_sym_RPAREN] = ACTIONS(2984),
    [aux_sym_preproc_if_token1] = ACTIONS(2986),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2986),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2986),
    [sym_preproc_directive] = ACTIONS(2986),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_BANG] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2984),
    [anon_sym_DASH] = ACTIONS(2986),
    [anon_sym_PLUS] = ACTIONS(2986),
    [anon_sym_STAR] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_AMP] = ACTIONS(2986),
    [anon_sym_SEMI] = ACTIONS(2984),
    [anon_sym___extension__] = ACTIONS(2986),
    [anon_sym_typedef] = ACTIONS(2986),
    [anon_sym_in] = ACTIONS(2986),
    [anon_sym_out] = ACTIONS(2986),
    [anon_sym_inout] = ACTIONS(2986),
    [anon_sym_virtual] = ACTIONS(2986),
    [anon_sym_extern] = ACTIONS(2986),
    [anon_sym___attribute__] = ACTIONS(2986),
    [anon_sym___attribute] = ACTIONS(2986),
    [anon_sym_using] = ACTIONS(2986),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2984),
    [anon_sym___declspec] = ACTIONS(2986),
    [anon_sym___based] = ACTIONS(2986),
    [anon_sym___cdecl] = ACTIONS(2986),
    [anon_sym___clrcall] = ACTIONS(2986),
    [anon_sym___stdcall] = ACTIONS(2986),
    [anon_sym___fastcall] = ACTIONS(2986),
    [anon_sym___thiscall] = ACTIONS(2986),
    [anon_sym___vectorcall] = ACTIONS(2986),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2986),
    [anon_sym_unsigned] = ACTIONS(2986),
    [anon_sym_long] = ACTIONS(2986),
    [anon_sym_short] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2986),
    [anon_sym_static] = ACTIONS(2986),
    [anon_sym_register] = ACTIONS(2986),
    [anon_sym_inline] = ACTIONS(2986),
    [anon_sym___inline] = ACTIONS(2986),
    [anon_sym___inline__] = ACTIONS(2986),
    [anon_sym___forceinline] = ACTIONS(2986),
    [anon_sym_thread_local] = ACTIONS(2986),
    [anon_sym___thread] = ACTIONS(2986),
    [anon_sym_const] = ACTIONS(2986),
    [anon_sym_constexpr] = ACTIONS(2986),
    [anon_sym_volatile] = ACTIONS(2986),
    [anon_sym_restrict] = ACTIONS(2986),
    [anon_sym___restrict__] = ACTIONS(2986),
    [anon_sym__Atomic] = ACTIONS(2986),
    [anon_sym__Noreturn] = ACTIONS(2986),
    [anon_sym_noreturn] = ACTIONS(2986),
    [anon_sym__Nonnull] = ACTIONS(2986),
    [anon_sym_mutable] = ACTIONS(2986),
    [anon_sym_constinit] = ACTIONS(2986),
    [anon_sym_consteval] = ACTIONS(2986),
    [anon_sym_alignas] = ACTIONS(2986),
    [anon_sym__Alignas] = ACTIONS(2986),
    [sym_primitive_type] = ACTIONS(2986),
    [anon_sym_enum] = ACTIONS(2986),
    [anon_sym_class] = ACTIONS(2986),
    [anon_sym_struct] = ACTIONS(2986),
    [anon_sym_union] = ACTIONS(2986),
    [anon_sym_if] = ACTIONS(2986),
    [anon_sym_switch] = ACTIONS(2986),
    [anon_sym_case] = ACTIONS(2986),
    [anon_sym_default] = ACTIONS(2986),
    [anon_sym_while] = ACTIONS(2986),
    [anon_sym_do] = ACTIONS(2986),
    [anon_sym_for] = ACTIONS(2986),
    [anon_sym_return] = ACTIONS(2986),
    [anon_sym_break] = ACTIONS(2986),
    [anon_sym_continue] = ACTIONS(2986),
    [anon_sym_goto] = ACTIONS(2986),
    [anon_sym_not] = ACTIONS(2986),
    [anon_sym_compl] = ACTIONS(2986),
    [anon_sym_DASH_DASH] = ACTIONS(2984),
    [anon_sym_PLUS_PLUS] = ACTIONS(2984),
    [anon_sym_sizeof] = ACTIONS(2986),
    [anon_sym___alignof__] = ACTIONS(2986),
    [anon_sym___alignof] = ACTIONS(2986),
    [anon_sym__alignof] = ACTIONS(2986),
    [anon_sym_alignof] = ACTIONS(2986),
    [anon_sym__Alignof] = ACTIONS(2986),
    [anon_sym_offsetof] = ACTIONS(2986),
    [anon_sym__Generic] = ACTIONS(2986),
    [anon_sym_asm] = ACTIONS(2986),
    [anon_sym___asm__] = ACTIONS(2986),
    [anon_sym___asm] = ACTIONS(2986),
    [anon_sym_DOT] = ACTIONS(2986),
    [sym_number_literal] = ACTIONS(2984),
    [anon_sym_L_SQUOTE] = ACTIONS(2984),
    [anon_sym_u_SQUOTE] = ACTIONS(2984),
    [anon_sym_U_SQUOTE] = ACTIONS(2984),
    [anon_sym_u8_SQUOTE] = ACTIONS(2984),
    [anon_sym_SQUOTE] = ACTIONS(2984),
    [anon_sym_L_DQUOTE] = ACTIONS(2984),
    [anon_sym_u_DQUOTE] = ACTIONS(2984),
    [anon_sym_U_DQUOTE] = ACTIONS(2984),
    [anon_sym_u8_DQUOTE] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(2984),
    [sym_true] = ACTIONS(2986),
    [sym_false] = ACTIONS(2986),
    [anon_sym_NULL] = ACTIONS(2986),
    [anon_sym_nullptr] = ACTIONS(2986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2986),
    [anon_sym_let] = ACTIONS(2986),
    [anon_sym_This] = ACTIONS(2986),
    [anon_sym_decltype] = ACTIONS(2986),
    [anon_sym_final] = ACTIONS(2986),
    [anon_sym_override] = ACTIONS(2986),
    [anon_sym_explicit] = ACTIONS(2986),
    [anon_sym_typename] = ACTIONS(2986),
    [anon_sym_export] = ACTIONS(2986),
    [anon_sym_module] = ACTIONS(2986),
    [anon_sym_import] = ACTIONS(2986),
    [anon_sym_template] = ACTIONS(2986),
    [anon_sym_GT2] = ACTIONS(2984),
    [anon_sym_operator] = ACTIONS(2986),
    [anon_sym_try] = ACTIONS(2986),
    [anon_sym_delete] = ACTIONS(2986),
    [anon_sym_throw] = ACTIONS(2986),
    [anon_sym_namespace] = ACTIONS(2986),
    [anon_sym_static_assert] = ACTIONS(2986),
    [anon_sym_concept] = ACTIONS(2986),
    [anon_sym_co_return] = ACTIONS(2986),
    [anon_sym_co_yield] = ACTIONS(2986),
    [anon_sym_R_DQUOTE] = ACTIONS(2984),
    [anon_sym_LR_DQUOTE] = ACTIONS(2984),
    [anon_sym_uR_DQUOTE] = ACTIONS(2984),
    [anon_sym_UR_DQUOTE] = ACTIONS(2984),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2984),
    [anon_sym_co_await] = ACTIONS(2986),
    [anon_sym_new] = ACTIONS(2986),
    [anon_sym_requires] = ACTIONS(2986),
    [sym_this] = ACTIONS(2986),
    [anon_sym_precise] = ACTIONS(2986),
    [anon_sym_shared] = ACTIONS(2986),
    [anon_sym_groupshared] = ACTIONS(2986),
    [anon_sym_uniform] = ACTIONS(2986),
    [anon_sym_row_major] = ACTIONS(2986),
    [anon_sym_column_major] = ACTIONS(2986),
    [anon_sym_globallycoherent] = ACTIONS(2986),
    [anon_sym_centroid] = ACTIONS(2986),
    [anon_sym_noperspective] = ACTIONS(2986),
    [anon_sym_nointerpolation] = ACTIONS(2986),
    [anon_sym_sample] = ACTIONS(2986),
    [anon_sym_linear] = ACTIONS(2986),
    [anon_sym_snorm] = ACTIONS(2986),
    [anon_sym_unorm] = ACTIONS(2986),
    [anon_sym_point] = ACTIONS(2986),
    [anon_sym_line] = ACTIONS(2986),
    [anon_sym_triangleadj] = ACTIONS(2986),
    [anon_sym_lineadj] = ACTIONS(2986),
    [anon_sym_triangle] = ACTIONS(2986),
    [anon_sym_interface] = ACTIONS(2986),
    [anon_sym_extension] = ACTIONS(2986),
    [anon_sym_where] = ACTIONS(2986),
    [anon_sym___exported] = ACTIONS(2986),
  },
  [307] = {
    [ts_builtin_sym_end] = ACTIONS(2988),
    [sym_identifier] = ACTIONS(2990),
    [aux_sym_preproc_include_token1] = ACTIONS(2990),
    [aux_sym_preproc_def_token1] = ACTIONS(2990),
    [anon_sym_COMMA] = ACTIONS(2988),
    [anon_sym_RPAREN] = ACTIONS(2988),
    [aux_sym_preproc_if_token1] = ACTIONS(2990),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2990),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2990),
    [sym_preproc_directive] = ACTIONS(2990),
    [anon_sym_LPAREN2] = ACTIONS(2988),
    [anon_sym_BANG] = ACTIONS(2988),
    [anon_sym_TILDE] = ACTIONS(2988),
    [anon_sym_DASH] = ACTIONS(2990),
    [anon_sym_PLUS] = ACTIONS(2990),
    [anon_sym_STAR] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_AMP] = ACTIONS(2990),
    [anon_sym_SEMI] = ACTIONS(2988),
    [anon_sym___extension__] = ACTIONS(2990),
    [anon_sym_typedef] = ACTIONS(2990),
    [anon_sym_in] = ACTIONS(2990),
    [anon_sym_out] = ACTIONS(2990),
    [anon_sym_inout] = ACTIONS(2990),
    [anon_sym_virtual] = ACTIONS(2990),
    [anon_sym_extern] = ACTIONS(2990),
    [anon_sym___attribute__] = ACTIONS(2990),
    [anon_sym___attribute] = ACTIONS(2990),
    [anon_sym_using] = ACTIONS(2990),
    [anon_sym_COLON_COLON] = ACTIONS(2988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2988),
    [anon_sym___declspec] = ACTIONS(2990),
    [anon_sym___based] = ACTIONS(2990),
    [anon_sym___cdecl] = ACTIONS(2990),
    [anon_sym___clrcall] = ACTIONS(2990),
    [anon_sym___stdcall] = ACTIONS(2990),
    [anon_sym___fastcall] = ACTIONS(2990),
    [anon_sym___thiscall] = ACTIONS(2990),
    [anon_sym___vectorcall] = ACTIONS(2990),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_signed] = ACTIONS(2990),
    [anon_sym_unsigned] = ACTIONS(2990),
    [anon_sym_long] = ACTIONS(2990),
    [anon_sym_short] = ACTIONS(2990),
    [anon_sym_LBRACK] = ACTIONS(2990),
    [anon_sym_static] = ACTIONS(2990),
    [anon_sym_register] = ACTIONS(2990),
    [anon_sym_inline] = ACTIONS(2990),
    [anon_sym___inline] = ACTIONS(2990),
    [anon_sym___inline__] = ACTIONS(2990),
    [anon_sym___forceinline] = ACTIONS(2990),
    [anon_sym_thread_local] = ACTIONS(2990),
    [anon_sym___thread] = ACTIONS(2990),
    [anon_sym_const] = ACTIONS(2990),
    [anon_sym_constexpr] = ACTIONS(2990),
    [anon_sym_volatile] = ACTIONS(2990),
    [anon_sym_restrict] = ACTIONS(2990),
    [anon_sym___restrict__] = ACTIONS(2990),
    [anon_sym__Atomic] = ACTIONS(2990),
    [anon_sym__Noreturn] = ACTIONS(2990),
    [anon_sym_noreturn] = ACTIONS(2990),
    [anon_sym__Nonnull] = ACTIONS(2990),
    [anon_sym_mutable] = ACTIONS(2990),
    [anon_sym_constinit] = ACTIONS(2990),
    [anon_sym_consteval] = ACTIONS(2990),
    [anon_sym_alignas] = ACTIONS(2990),
    [anon_sym__Alignas] = ACTIONS(2990),
    [sym_primitive_type] = ACTIONS(2990),
    [anon_sym_enum] = ACTIONS(2990),
    [anon_sym_class] = ACTIONS(2990),
    [anon_sym_struct] = ACTIONS(2990),
    [anon_sym_union] = ACTIONS(2990),
    [anon_sym_if] = ACTIONS(2990),
    [anon_sym_switch] = ACTIONS(2990),
    [anon_sym_case] = ACTIONS(2990),
    [anon_sym_default] = ACTIONS(2990),
    [anon_sym_while] = ACTIONS(2990),
    [anon_sym_do] = ACTIONS(2990),
    [anon_sym_for] = ACTIONS(2990),
    [anon_sym_return] = ACTIONS(2990),
    [anon_sym_break] = ACTIONS(2990),
    [anon_sym_continue] = ACTIONS(2990),
    [anon_sym_goto] = ACTIONS(2990),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_compl] = ACTIONS(2990),
    [anon_sym_DASH_DASH] = ACTIONS(2988),
    [anon_sym_PLUS_PLUS] = ACTIONS(2988),
    [anon_sym_sizeof] = ACTIONS(2990),
    [anon_sym___alignof__] = ACTIONS(2990),
    [anon_sym___alignof] = ACTIONS(2990),
    [anon_sym__alignof] = ACTIONS(2990),
    [anon_sym_alignof] = ACTIONS(2990),
    [anon_sym__Alignof] = ACTIONS(2990),
    [anon_sym_offsetof] = ACTIONS(2990),
    [anon_sym__Generic] = ACTIONS(2990),
    [anon_sym_asm] = ACTIONS(2990),
    [anon_sym___asm__] = ACTIONS(2990),
    [anon_sym___asm] = ACTIONS(2990),
    [anon_sym_DOT] = ACTIONS(2990),
    [sym_number_literal] = ACTIONS(2988),
    [anon_sym_L_SQUOTE] = ACTIONS(2988),
    [anon_sym_u_SQUOTE] = ACTIONS(2988),
    [anon_sym_U_SQUOTE] = ACTIONS(2988),
    [anon_sym_u8_SQUOTE] = ACTIONS(2988),
    [anon_sym_SQUOTE] = ACTIONS(2988),
    [anon_sym_L_DQUOTE] = ACTIONS(2988),
    [anon_sym_u_DQUOTE] = ACTIONS(2988),
    [anon_sym_U_DQUOTE] = ACTIONS(2988),
    [anon_sym_u8_DQUOTE] = ACTIONS(2988),
    [anon_sym_DQUOTE] = ACTIONS(2988),
    [sym_true] = ACTIONS(2990),
    [sym_false] = ACTIONS(2990),
    [anon_sym_NULL] = ACTIONS(2990),
    [anon_sym_nullptr] = ACTIONS(2990),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2990),
    [anon_sym_let] = ACTIONS(2990),
    [anon_sym_This] = ACTIONS(2990),
    [anon_sym_decltype] = ACTIONS(2990),
    [anon_sym_final] = ACTIONS(2990),
    [anon_sym_override] = ACTIONS(2990),
    [anon_sym_explicit] = ACTIONS(2990),
    [anon_sym_typename] = ACTIONS(2990),
    [anon_sym_export] = ACTIONS(2990),
    [anon_sym_module] = ACTIONS(2990),
    [anon_sym_import] = ACTIONS(2990),
    [anon_sym_template] = ACTIONS(2990),
    [anon_sym_GT2] = ACTIONS(2988),
    [anon_sym_operator] = ACTIONS(2990),
    [anon_sym_try] = ACTIONS(2990),
    [anon_sym_delete] = ACTIONS(2990),
    [anon_sym_throw] = ACTIONS(2990),
    [anon_sym_namespace] = ACTIONS(2990),
    [anon_sym_static_assert] = ACTIONS(2990),
    [anon_sym_concept] = ACTIONS(2990),
    [anon_sym_co_return] = ACTIONS(2990),
    [anon_sym_co_yield] = ACTIONS(2990),
    [anon_sym_R_DQUOTE] = ACTIONS(2988),
    [anon_sym_LR_DQUOTE] = ACTIONS(2988),
    [anon_sym_uR_DQUOTE] = ACTIONS(2988),
    [anon_sym_UR_DQUOTE] = ACTIONS(2988),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2988),
    [anon_sym_co_await] = ACTIONS(2990),
    [anon_sym_new] = ACTIONS(2990),
    [anon_sym_requires] = ACTIONS(2990),
    [sym_this] = ACTIONS(2990),
    [anon_sym_precise] = ACTIONS(2990),
    [anon_sym_shared] = ACTIONS(2990),
    [anon_sym_groupshared] = ACTIONS(2990),
    [anon_sym_uniform] = ACTIONS(2990),
    [anon_sym_row_major] = ACTIONS(2990),
    [anon_sym_column_major] = ACTIONS(2990),
    [anon_sym_globallycoherent] = ACTIONS(2990),
    [anon_sym_centroid] = ACTIONS(2990),
    [anon_sym_noperspective] = ACTIONS(2990),
    [anon_sym_nointerpolation] = ACTIONS(2990),
    [anon_sym_sample] = ACTIONS(2990),
    [anon_sym_linear] = ACTIONS(2990),
    [anon_sym_snorm] = ACTIONS(2990),
    [anon_sym_unorm] = ACTIONS(2990),
    [anon_sym_point] = ACTIONS(2990),
    [anon_sym_line] = ACTIONS(2990),
    [anon_sym_triangleadj] = ACTIONS(2990),
    [anon_sym_lineadj] = ACTIONS(2990),
    [anon_sym_triangle] = ACTIONS(2990),
    [anon_sym_interface] = ACTIONS(2990),
    [anon_sym_extension] = ACTIONS(2990),
    [anon_sym_where] = ACTIONS(2990),
    [anon_sym___exported] = ACTIONS(2990),
  },
  [308] = {
    [ts_builtin_sym_end] = ACTIONS(2992),
    [sym_identifier] = ACTIONS(2994),
    [aux_sym_preproc_include_token1] = ACTIONS(2994),
    [aux_sym_preproc_def_token1] = ACTIONS(2994),
    [anon_sym_COMMA] = ACTIONS(2992),
    [anon_sym_RPAREN] = ACTIONS(2992),
    [aux_sym_preproc_if_token1] = ACTIONS(2994),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2994),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2994),
    [sym_preproc_directive] = ACTIONS(2994),
    [anon_sym_LPAREN2] = ACTIONS(2992),
    [anon_sym_BANG] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2992),
    [anon_sym_DASH] = ACTIONS(2994),
    [anon_sym_PLUS] = ACTIONS(2994),
    [anon_sym_STAR] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_AMP] = ACTIONS(2994),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym___extension__] = ACTIONS(2994),
    [anon_sym_typedef] = ACTIONS(2994),
    [anon_sym_in] = ACTIONS(2994),
    [anon_sym_out] = ACTIONS(2994),
    [anon_sym_inout] = ACTIONS(2994),
    [anon_sym_virtual] = ACTIONS(2994),
    [anon_sym_extern] = ACTIONS(2994),
    [anon_sym___attribute__] = ACTIONS(2994),
    [anon_sym___attribute] = ACTIONS(2994),
    [anon_sym_using] = ACTIONS(2994),
    [anon_sym_COLON_COLON] = ACTIONS(2992),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2992),
    [anon_sym___declspec] = ACTIONS(2994),
    [anon_sym___based] = ACTIONS(2994),
    [anon_sym___cdecl] = ACTIONS(2994),
    [anon_sym___clrcall] = ACTIONS(2994),
    [anon_sym___stdcall] = ACTIONS(2994),
    [anon_sym___fastcall] = ACTIONS(2994),
    [anon_sym___thiscall] = ACTIONS(2994),
    [anon_sym___vectorcall] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_signed] = ACTIONS(2994),
    [anon_sym_unsigned] = ACTIONS(2994),
    [anon_sym_long] = ACTIONS(2994),
    [anon_sym_short] = ACTIONS(2994),
    [anon_sym_LBRACK] = ACTIONS(2994),
    [anon_sym_static] = ACTIONS(2994),
    [anon_sym_register] = ACTIONS(2994),
    [anon_sym_inline] = ACTIONS(2994),
    [anon_sym___inline] = ACTIONS(2994),
    [anon_sym___inline__] = ACTIONS(2994),
    [anon_sym___forceinline] = ACTIONS(2994),
    [anon_sym_thread_local] = ACTIONS(2994),
    [anon_sym___thread] = ACTIONS(2994),
    [anon_sym_const] = ACTIONS(2994),
    [anon_sym_constexpr] = ACTIONS(2994),
    [anon_sym_volatile] = ACTIONS(2994),
    [anon_sym_restrict] = ACTIONS(2994),
    [anon_sym___restrict__] = ACTIONS(2994),
    [anon_sym__Atomic] = ACTIONS(2994),
    [anon_sym__Noreturn] = ACTIONS(2994),
    [anon_sym_noreturn] = ACTIONS(2994),
    [anon_sym__Nonnull] = ACTIONS(2994),
    [anon_sym_mutable] = ACTIONS(2994),
    [anon_sym_constinit] = ACTIONS(2994),
    [anon_sym_consteval] = ACTIONS(2994),
    [anon_sym_alignas] = ACTIONS(2994),
    [anon_sym__Alignas] = ACTIONS(2994),
    [sym_primitive_type] = ACTIONS(2994),
    [anon_sym_enum] = ACTIONS(2994),
    [anon_sym_class] = ACTIONS(2994),
    [anon_sym_struct] = ACTIONS(2994),
    [anon_sym_union] = ACTIONS(2994),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_switch] = ACTIONS(2994),
    [anon_sym_case] = ACTIONS(2994),
    [anon_sym_default] = ACTIONS(2994),
    [anon_sym_while] = ACTIONS(2994),
    [anon_sym_do] = ACTIONS(2994),
    [anon_sym_for] = ACTIONS(2994),
    [anon_sym_return] = ACTIONS(2994),
    [anon_sym_break] = ACTIONS(2994),
    [anon_sym_continue] = ACTIONS(2994),
    [anon_sym_goto] = ACTIONS(2994),
    [anon_sym_not] = ACTIONS(2994),
    [anon_sym_compl] = ACTIONS(2994),
    [anon_sym_DASH_DASH] = ACTIONS(2992),
    [anon_sym_PLUS_PLUS] = ACTIONS(2992),
    [anon_sym_sizeof] = ACTIONS(2994),
    [anon_sym___alignof__] = ACTIONS(2994),
    [anon_sym___alignof] = ACTIONS(2994),
    [anon_sym__alignof] = ACTIONS(2994),
    [anon_sym_alignof] = ACTIONS(2994),
    [anon_sym__Alignof] = ACTIONS(2994),
    [anon_sym_offsetof] = ACTIONS(2994),
    [anon_sym__Generic] = ACTIONS(2994),
    [anon_sym_asm] = ACTIONS(2994),
    [anon_sym___asm__] = ACTIONS(2994),
    [anon_sym___asm] = ACTIONS(2994),
    [anon_sym_DOT] = ACTIONS(2994),
    [sym_number_literal] = ACTIONS(2992),
    [anon_sym_L_SQUOTE] = ACTIONS(2992),
    [anon_sym_u_SQUOTE] = ACTIONS(2992),
    [anon_sym_U_SQUOTE] = ACTIONS(2992),
    [anon_sym_u8_SQUOTE] = ACTIONS(2992),
    [anon_sym_SQUOTE] = ACTIONS(2992),
    [anon_sym_L_DQUOTE] = ACTIONS(2992),
    [anon_sym_u_DQUOTE] = ACTIONS(2992),
    [anon_sym_U_DQUOTE] = ACTIONS(2992),
    [anon_sym_u8_DQUOTE] = ACTIONS(2992),
    [anon_sym_DQUOTE] = ACTIONS(2992),
    [sym_true] = ACTIONS(2994),
    [sym_false] = ACTIONS(2994),
    [anon_sym_NULL] = ACTIONS(2994),
    [anon_sym_nullptr] = ACTIONS(2994),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2994),
    [anon_sym_let] = ACTIONS(2994),
    [anon_sym_This] = ACTIONS(2994),
    [anon_sym_decltype] = ACTIONS(2994),
    [anon_sym_final] = ACTIONS(2994),
    [anon_sym_override] = ACTIONS(2994),
    [anon_sym_explicit] = ACTIONS(2994),
    [anon_sym_typename] = ACTIONS(2994),
    [anon_sym_export] = ACTIONS(2994),
    [anon_sym_module] = ACTIONS(2994),
    [anon_sym_import] = ACTIONS(2994),
    [anon_sym_template] = ACTIONS(2994),
    [anon_sym_GT2] = ACTIONS(2992),
    [anon_sym_operator] = ACTIONS(2994),
    [anon_sym_try] = ACTIONS(2994),
    [anon_sym_delete] = ACTIONS(2994),
    [anon_sym_throw] = ACTIONS(2994),
    [anon_sym_namespace] = ACTIONS(2994),
    [anon_sym_static_assert] = ACTIONS(2994),
    [anon_sym_concept] = ACTIONS(2994),
    [anon_sym_co_return] = ACTIONS(2994),
    [anon_sym_co_yield] = ACTIONS(2994),
    [anon_sym_R_DQUOTE] = ACTIONS(2992),
    [anon_sym_LR_DQUOTE] = ACTIONS(2992),
    [anon_sym_uR_DQUOTE] = ACTIONS(2992),
    [anon_sym_UR_DQUOTE] = ACTIONS(2992),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2992),
    [anon_sym_co_await] = ACTIONS(2994),
    [anon_sym_new] = ACTIONS(2994),
    [anon_sym_requires] = ACTIONS(2994),
    [sym_this] = ACTIONS(2994),
    [anon_sym_precise] = ACTIONS(2994),
    [anon_sym_shared] = ACTIONS(2994),
    [anon_sym_groupshared] = ACTIONS(2994),
    [anon_sym_uniform] = ACTIONS(2994),
    [anon_sym_row_major] = ACTIONS(2994),
    [anon_sym_column_major] = ACTIONS(2994),
    [anon_sym_globallycoherent] = ACTIONS(2994),
    [anon_sym_centroid] = ACTIONS(2994),
    [anon_sym_noperspective] = ACTIONS(2994),
    [anon_sym_nointerpolation] = ACTIONS(2994),
    [anon_sym_sample] = ACTIONS(2994),
    [anon_sym_linear] = ACTIONS(2994),
    [anon_sym_snorm] = ACTIONS(2994),
    [anon_sym_unorm] = ACTIONS(2994),
    [anon_sym_point] = ACTIONS(2994),
    [anon_sym_line] = ACTIONS(2994),
    [anon_sym_triangleadj] = ACTIONS(2994),
    [anon_sym_lineadj] = ACTIONS(2994),
    [anon_sym_triangle] = ACTIONS(2994),
    [anon_sym_interface] = ACTIONS(2994),
    [anon_sym_extension] = ACTIONS(2994),
    [anon_sym_where] = ACTIONS(2994),
    [anon_sym___exported] = ACTIONS(2994),
  },
  [309] = {
    [ts_builtin_sym_end] = ACTIONS(2996),
    [sym_identifier] = ACTIONS(2998),
    [aux_sym_preproc_include_token1] = ACTIONS(2998),
    [aux_sym_preproc_def_token1] = ACTIONS(2998),
    [anon_sym_COMMA] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(2996),
    [aux_sym_preproc_if_token1] = ACTIONS(2998),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2998),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2998),
    [sym_preproc_directive] = ACTIONS(2998),
    [anon_sym_LPAREN2] = ACTIONS(2996),
    [anon_sym_BANG] = ACTIONS(2996),
    [anon_sym_TILDE] = ACTIONS(2996),
    [anon_sym_DASH] = ACTIONS(2998),
    [anon_sym_PLUS] = ACTIONS(2998),
    [anon_sym_STAR] = ACTIONS(2996),
    [anon_sym_AMP_AMP] = ACTIONS(2996),
    [anon_sym_AMP] = ACTIONS(2998),
    [anon_sym_SEMI] = ACTIONS(2996),
    [anon_sym___extension__] = ACTIONS(2998),
    [anon_sym_typedef] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(2998),
    [anon_sym_out] = ACTIONS(2998),
    [anon_sym_inout] = ACTIONS(2998),
    [anon_sym_virtual] = ACTIONS(2998),
    [anon_sym_extern] = ACTIONS(2998),
    [anon_sym___attribute__] = ACTIONS(2998),
    [anon_sym___attribute] = ACTIONS(2998),
    [anon_sym_using] = ACTIONS(2998),
    [anon_sym_COLON_COLON] = ACTIONS(2996),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2996),
    [anon_sym___declspec] = ACTIONS(2998),
    [anon_sym___based] = ACTIONS(2998),
    [anon_sym___cdecl] = ACTIONS(2998),
    [anon_sym___clrcall] = ACTIONS(2998),
    [anon_sym___stdcall] = ACTIONS(2998),
    [anon_sym___fastcall] = ACTIONS(2998),
    [anon_sym___thiscall] = ACTIONS(2998),
    [anon_sym___vectorcall] = ACTIONS(2998),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_signed] = ACTIONS(2998),
    [anon_sym_unsigned] = ACTIONS(2998),
    [anon_sym_long] = ACTIONS(2998),
    [anon_sym_short] = ACTIONS(2998),
    [anon_sym_LBRACK] = ACTIONS(2998),
    [anon_sym_static] = ACTIONS(2998),
    [anon_sym_register] = ACTIONS(2998),
    [anon_sym_inline] = ACTIONS(2998),
    [anon_sym___inline] = ACTIONS(2998),
    [anon_sym___inline__] = ACTIONS(2998),
    [anon_sym___forceinline] = ACTIONS(2998),
    [anon_sym_thread_local] = ACTIONS(2998),
    [anon_sym___thread] = ACTIONS(2998),
    [anon_sym_const] = ACTIONS(2998),
    [anon_sym_constexpr] = ACTIONS(2998),
    [anon_sym_volatile] = ACTIONS(2998),
    [anon_sym_restrict] = ACTIONS(2998),
    [anon_sym___restrict__] = ACTIONS(2998),
    [anon_sym__Atomic] = ACTIONS(2998),
    [anon_sym__Noreturn] = ACTIONS(2998),
    [anon_sym_noreturn] = ACTIONS(2998),
    [anon_sym__Nonnull] = ACTIONS(2998),
    [anon_sym_mutable] = ACTIONS(2998),
    [anon_sym_constinit] = ACTIONS(2998),
    [anon_sym_consteval] = ACTIONS(2998),
    [anon_sym_alignas] = ACTIONS(2998),
    [anon_sym__Alignas] = ACTIONS(2998),
    [sym_primitive_type] = ACTIONS(2998),
    [anon_sym_enum] = ACTIONS(2998),
    [anon_sym_class] = ACTIONS(2998),
    [anon_sym_struct] = ACTIONS(2998),
    [anon_sym_union] = ACTIONS(2998),
    [anon_sym_if] = ACTIONS(2998),
    [anon_sym_switch] = ACTIONS(2998),
    [anon_sym_case] = ACTIONS(2998),
    [anon_sym_default] = ACTIONS(2998),
    [anon_sym_while] = ACTIONS(2998),
    [anon_sym_do] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2998),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_break] = ACTIONS(2998),
    [anon_sym_continue] = ACTIONS(2998),
    [anon_sym_goto] = ACTIONS(2998),
    [anon_sym_not] = ACTIONS(2998),
    [anon_sym_compl] = ACTIONS(2998),
    [anon_sym_DASH_DASH] = ACTIONS(2996),
    [anon_sym_PLUS_PLUS] = ACTIONS(2996),
    [anon_sym_sizeof] = ACTIONS(2998),
    [anon_sym___alignof__] = ACTIONS(2998),
    [anon_sym___alignof] = ACTIONS(2998),
    [anon_sym__alignof] = ACTIONS(2998),
    [anon_sym_alignof] = ACTIONS(2998),
    [anon_sym__Alignof] = ACTIONS(2998),
    [anon_sym_offsetof] = ACTIONS(2998),
    [anon_sym__Generic] = ACTIONS(2998),
    [anon_sym_asm] = ACTIONS(2998),
    [anon_sym___asm__] = ACTIONS(2998),
    [anon_sym___asm] = ACTIONS(2998),
    [anon_sym_DOT] = ACTIONS(2998),
    [sym_number_literal] = ACTIONS(2996),
    [anon_sym_L_SQUOTE] = ACTIONS(2996),
    [anon_sym_u_SQUOTE] = ACTIONS(2996),
    [anon_sym_U_SQUOTE] = ACTIONS(2996),
    [anon_sym_u8_SQUOTE] = ACTIONS(2996),
    [anon_sym_SQUOTE] = ACTIONS(2996),
    [anon_sym_L_DQUOTE] = ACTIONS(2996),
    [anon_sym_u_DQUOTE] = ACTIONS(2996),
    [anon_sym_U_DQUOTE] = ACTIONS(2996),
    [anon_sym_u8_DQUOTE] = ACTIONS(2996),
    [anon_sym_DQUOTE] = ACTIONS(2996),
    [sym_true] = ACTIONS(2998),
    [sym_false] = ACTIONS(2998),
    [anon_sym_NULL] = ACTIONS(2998),
    [anon_sym_nullptr] = ACTIONS(2998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2998),
    [anon_sym_let] = ACTIONS(2998),
    [anon_sym_This] = ACTIONS(2998),
    [anon_sym_decltype] = ACTIONS(2998),
    [anon_sym_final] = ACTIONS(2998),
    [anon_sym_override] = ACTIONS(2998),
    [anon_sym_explicit] = ACTIONS(2998),
    [anon_sym_typename] = ACTIONS(2998),
    [anon_sym_export] = ACTIONS(2998),
    [anon_sym_module] = ACTIONS(2998),
    [anon_sym_import] = ACTIONS(2998),
    [anon_sym_template] = ACTIONS(2998),
    [anon_sym_GT2] = ACTIONS(2996),
    [anon_sym_operator] = ACTIONS(2998),
    [anon_sym_try] = ACTIONS(2998),
    [anon_sym_delete] = ACTIONS(2998),
    [anon_sym_throw] = ACTIONS(2998),
    [anon_sym_namespace] = ACTIONS(2998),
    [anon_sym_static_assert] = ACTIONS(2998),
    [anon_sym_concept] = ACTIONS(2998),
    [anon_sym_co_return] = ACTIONS(2998),
    [anon_sym_co_yield] = ACTIONS(2998),
    [anon_sym_R_DQUOTE] = ACTIONS(2996),
    [anon_sym_LR_DQUOTE] = ACTIONS(2996),
    [anon_sym_uR_DQUOTE] = ACTIONS(2996),
    [anon_sym_UR_DQUOTE] = ACTIONS(2996),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2996),
    [anon_sym_co_await] = ACTIONS(2998),
    [anon_sym_new] = ACTIONS(2998),
    [anon_sym_requires] = ACTIONS(2998),
    [sym_this] = ACTIONS(2998),
    [anon_sym_precise] = ACTIONS(2998),
    [anon_sym_shared] = ACTIONS(2998),
    [anon_sym_groupshared] = ACTIONS(2998),
    [anon_sym_uniform] = ACTIONS(2998),
    [anon_sym_row_major] = ACTIONS(2998),
    [anon_sym_column_major] = ACTIONS(2998),
    [anon_sym_globallycoherent] = ACTIONS(2998),
    [anon_sym_centroid] = ACTIONS(2998),
    [anon_sym_noperspective] = ACTIONS(2998),
    [anon_sym_nointerpolation] = ACTIONS(2998),
    [anon_sym_sample] = ACTIONS(2998),
    [anon_sym_linear] = ACTIONS(2998),
    [anon_sym_snorm] = ACTIONS(2998),
    [anon_sym_unorm] = ACTIONS(2998),
    [anon_sym_point] = ACTIONS(2998),
    [anon_sym_line] = ACTIONS(2998),
    [anon_sym_triangleadj] = ACTIONS(2998),
    [anon_sym_lineadj] = ACTIONS(2998),
    [anon_sym_triangle] = ACTIONS(2998),
    [anon_sym_interface] = ACTIONS(2998),
    [anon_sym_extension] = ACTIONS(2998),
    [anon_sym_where] = ACTIONS(2998),
    [anon_sym___exported] = ACTIONS(2998),
  },
  [310] = {
    [ts_builtin_sym_end] = ACTIONS(3000),
    [sym_identifier] = ACTIONS(3002),
    [aux_sym_preproc_include_token1] = ACTIONS(3002),
    [aux_sym_preproc_def_token1] = ACTIONS(3002),
    [anon_sym_COMMA] = ACTIONS(3000),
    [anon_sym_RPAREN] = ACTIONS(3000),
    [aux_sym_preproc_if_token1] = ACTIONS(3002),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3002),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3002),
    [sym_preproc_directive] = ACTIONS(3002),
    [anon_sym_LPAREN2] = ACTIONS(3000),
    [anon_sym_BANG] = ACTIONS(3000),
    [anon_sym_TILDE] = ACTIONS(3000),
    [anon_sym_DASH] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(3000),
    [anon_sym_AMP_AMP] = ACTIONS(3000),
    [anon_sym_AMP] = ACTIONS(3002),
    [anon_sym_SEMI] = ACTIONS(3000),
    [anon_sym___extension__] = ACTIONS(3002),
    [anon_sym_typedef] = ACTIONS(3002),
    [anon_sym_in] = ACTIONS(3002),
    [anon_sym_out] = ACTIONS(3002),
    [anon_sym_inout] = ACTIONS(3002),
    [anon_sym_virtual] = ACTIONS(3002),
    [anon_sym_extern] = ACTIONS(3002),
    [anon_sym___attribute__] = ACTIONS(3002),
    [anon_sym___attribute] = ACTIONS(3002),
    [anon_sym_using] = ACTIONS(3002),
    [anon_sym_COLON_COLON] = ACTIONS(3000),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3000),
    [anon_sym___declspec] = ACTIONS(3002),
    [anon_sym___based] = ACTIONS(3002),
    [anon_sym___cdecl] = ACTIONS(3002),
    [anon_sym___clrcall] = ACTIONS(3002),
    [anon_sym___stdcall] = ACTIONS(3002),
    [anon_sym___fastcall] = ACTIONS(3002),
    [anon_sym___thiscall] = ACTIONS(3002),
    [anon_sym___vectorcall] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3000),
    [anon_sym_signed] = ACTIONS(3002),
    [anon_sym_unsigned] = ACTIONS(3002),
    [anon_sym_long] = ACTIONS(3002),
    [anon_sym_short] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_static] = ACTIONS(3002),
    [anon_sym_register] = ACTIONS(3002),
    [anon_sym_inline] = ACTIONS(3002),
    [anon_sym___inline] = ACTIONS(3002),
    [anon_sym___inline__] = ACTIONS(3002),
    [anon_sym___forceinline] = ACTIONS(3002),
    [anon_sym_thread_local] = ACTIONS(3002),
    [anon_sym___thread] = ACTIONS(3002),
    [anon_sym_const] = ACTIONS(3002),
    [anon_sym_constexpr] = ACTIONS(3002),
    [anon_sym_volatile] = ACTIONS(3002),
    [anon_sym_restrict] = ACTIONS(3002),
    [anon_sym___restrict__] = ACTIONS(3002),
    [anon_sym__Atomic] = ACTIONS(3002),
    [anon_sym__Noreturn] = ACTIONS(3002),
    [anon_sym_noreturn] = ACTIONS(3002),
    [anon_sym__Nonnull] = ACTIONS(3002),
    [anon_sym_mutable] = ACTIONS(3002),
    [anon_sym_constinit] = ACTIONS(3002),
    [anon_sym_consteval] = ACTIONS(3002),
    [anon_sym_alignas] = ACTIONS(3002),
    [anon_sym__Alignas] = ACTIONS(3002),
    [sym_primitive_type] = ACTIONS(3002),
    [anon_sym_enum] = ACTIONS(3002),
    [anon_sym_class] = ACTIONS(3002),
    [anon_sym_struct] = ACTIONS(3002),
    [anon_sym_union] = ACTIONS(3002),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_switch] = ACTIONS(3002),
    [anon_sym_case] = ACTIONS(3002),
    [anon_sym_default] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(3002),
    [anon_sym_for] = ACTIONS(3002),
    [anon_sym_return] = ACTIONS(3002),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_continue] = ACTIONS(3002),
    [anon_sym_goto] = ACTIONS(3002),
    [anon_sym_not] = ACTIONS(3002),
    [anon_sym_compl] = ACTIONS(3002),
    [anon_sym_DASH_DASH] = ACTIONS(3000),
    [anon_sym_PLUS_PLUS] = ACTIONS(3000),
    [anon_sym_sizeof] = ACTIONS(3002),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3002),
    [anon_sym__Generic] = ACTIONS(3002),
    [anon_sym_asm] = ACTIONS(3002),
    [anon_sym___asm__] = ACTIONS(3002),
    [anon_sym___asm] = ACTIONS(3002),
    [anon_sym_DOT] = ACTIONS(3002),
    [sym_number_literal] = ACTIONS(3000),
    [anon_sym_L_SQUOTE] = ACTIONS(3000),
    [anon_sym_u_SQUOTE] = ACTIONS(3000),
    [anon_sym_U_SQUOTE] = ACTIONS(3000),
    [anon_sym_u8_SQUOTE] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(3000),
    [anon_sym_L_DQUOTE] = ACTIONS(3000),
    [anon_sym_u_DQUOTE] = ACTIONS(3000),
    [anon_sym_U_DQUOTE] = ACTIONS(3000),
    [anon_sym_u8_DQUOTE] = ACTIONS(3000),
    [anon_sym_DQUOTE] = ACTIONS(3000),
    [sym_true] = ACTIONS(3002),
    [sym_false] = ACTIONS(3002),
    [anon_sym_NULL] = ACTIONS(3002),
    [anon_sym_nullptr] = ACTIONS(3002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3002),
    [anon_sym_let] = ACTIONS(3002),
    [anon_sym_This] = ACTIONS(3002),
    [anon_sym_decltype] = ACTIONS(3002),
    [anon_sym_final] = ACTIONS(3002),
    [anon_sym_override] = ACTIONS(3002),
    [anon_sym_explicit] = ACTIONS(3002),
    [anon_sym_typename] = ACTIONS(3002),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_module] = ACTIONS(3002),
    [anon_sym_import] = ACTIONS(3002),
    [anon_sym_template] = ACTIONS(3002),
    [anon_sym_GT2] = ACTIONS(3000),
    [anon_sym_operator] = ACTIONS(3002),
    [anon_sym_try] = ACTIONS(3002),
    [anon_sym_delete] = ACTIONS(3002),
    [anon_sym_throw] = ACTIONS(3002),
    [anon_sym_namespace] = ACTIONS(3002),
    [anon_sym_static_assert] = ACTIONS(3002),
    [anon_sym_concept] = ACTIONS(3002),
    [anon_sym_co_return] = ACTIONS(3002),
    [anon_sym_co_yield] = ACTIONS(3002),
    [anon_sym_R_DQUOTE] = ACTIONS(3000),
    [anon_sym_LR_DQUOTE] = ACTIONS(3000),
    [anon_sym_uR_DQUOTE] = ACTIONS(3000),
    [anon_sym_UR_DQUOTE] = ACTIONS(3000),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3000),
    [anon_sym_co_await] = ACTIONS(3002),
    [anon_sym_new] = ACTIONS(3002),
    [anon_sym_requires] = ACTIONS(3002),
    [sym_this] = ACTIONS(3002),
    [anon_sym_precise] = ACTIONS(3002),
    [anon_sym_shared] = ACTIONS(3002),
    [anon_sym_groupshared] = ACTIONS(3002),
    [anon_sym_uniform] = ACTIONS(3002),
    [anon_sym_row_major] = ACTIONS(3002),
    [anon_sym_column_major] = ACTIONS(3002),
    [anon_sym_globallycoherent] = ACTIONS(3002),
    [anon_sym_centroid] = ACTIONS(3002),
    [anon_sym_noperspective] = ACTIONS(3002),
    [anon_sym_nointerpolation] = ACTIONS(3002),
    [anon_sym_sample] = ACTIONS(3002),
    [anon_sym_linear] = ACTIONS(3002),
    [anon_sym_snorm] = ACTIONS(3002),
    [anon_sym_unorm] = ACTIONS(3002),
    [anon_sym_point] = ACTIONS(3002),
    [anon_sym_line] = ACTIONS(3002),
    [anon_sym_triangleadj] = ACTIONS(3002),
    [anon_sym_lineadj] = ACTIONS(3002),
    [anon_sym_triangle] = ACTIONS(3002),
    [anon_sym_interface] = ACTIONS(3002),
    [anon_sym_extension] = ACTIONS(3002),
    [anon_sym_where] = ACTIONS(3002),
    [anon_sym___exported] = ACTIONS(3002),
  },
  [311] = {
    [ts_builtin_sym_end] = ACTIONS(3004),
    [sym_identifier] = ACTIONS(3006),
    [aux_sym_preproc_include_token1] = ACTIONS(3006),
    [aux_sym_preproc_def_token1] = ACTIONS(3006),
    [anon_sym_COMMA] = ACTIONS(3004),
    [anon_sym_RPAREN] = ACTIONS(3004),
    [aux_sym_preproc_if_token1] = ACTIONS(3006),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3006),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3006),
    [sym_preproc_directive] = ACTIONS(3006),
    [anon_sym_LPAREN2] = ACTIONS(3004),
    [anon_sym_BANG] = ACTIONS(3004),
    [anon_sym_TILDE] = ACTIONS(3004),
    [anon_sym_DASH] = ACTIONS(3006),
    [anon_sym_PLUS] = ACTIONS(3006),
    [anon_sym_STAR] = ACTIONS(3004),
    [anon_sym_AMP_AMP] = ACTIONS(3004),
    [anon_sym_AMP] = ACTIONS(3006),
    [anon_sym_SEMI] = ACTIONS(3004),
    [anon_sym___extension__] = ACTIONS(3006),
    [anon_sym_typedef] = ACTIONS(3006),
    [anon_sym_in] = ACTIONS(3006),
    [anon_sym_out] = ACTIONS(3006),
    [anon_sym_inout] = ACTIONS(3006),
    [anon_sym_virtual] = ACTIONS(3006),
    [anon_sym_extern] = ACTIONS(3006),
    [anon_sym___attribute__] = ACTIONS(3006),
    [anon_sym___attribute] = ACTIONS(3006),
    [anon_sym_using] = ACTIONS(3006),
    [anon_sym_COLON_COLON] = ACTIONS(3004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3004),
    [anon_sym___declspec] = ACTIONS(3006),
    [anon_sym___based] = ACTIONS(3006),
    [anon_sym___cdecl] = ACTIONS(3006),
    [anon_sym___clrcall] = ACTIONS(3006),
    [anon_sym___stdcall] = ACTIONS(3006),
    [anon_sym___fastcall] = ACTIONS(3006),
    [anon_sym___thiscall] = ACTIONS(3006),
    [anon_sym___vectorcall] = ACTIONS(3006),
    [anon_sym_LBRACE] = ACTIONS(3004),
    [anon_sym_signed] = ACTIONS(3006),
    [anon_sym_unsigned] = ACTIONS(3006),
    [anon_sym_long] = ACTIONS(3006),
    [anon_sym_short] = ACTIONS(3006),
    [anon_sym_LBRACK] = ACTIONS(3006),
    [anon_sym_static] = ACTIONS(3006),
    [anon_sym_register] = ACTIONS(3006),
    [anon_sym_inline] = ACTIONS(3006),
    [anon_sym___inline] = ACTIONS(3006),
    [anon_sym___inline__] = ACTIONS(3006),
    [anon_sym___forceinline] = ACTIONS(3006),
    [anon_sym_thread_local] = ACTIONS(3006),
    [anon_sym___thread] = ACTIONS(3006),
    [anon_sym_const] = ACTIONS(3006),
    [anon_sym_constexpr] = ACTIONS(3006),
    [anon_sym_volatile] = ACTIONS(3006),
    [anon_sym_restrict] = ACTIONS(3006),
    [anon_sym___restrict__] = ACTIONS(3006),
    [anon_sym__Atomic] = ACTIONS(3006),
    [anon_sym__Noreturn] = ACTIONS(3006),
    [anon_sym_noreturn] = ACTIONS(3006),
    [anon_sym__Nonnull] = ACTIONS(3006),
    [anon_sym_mutable] = ACTIONS(3006),
    [anon_sym_constinit] = ACTIONS(3006),
    [anon_sym_consteval] = ACTIONS(3006),
    [anon_sym_alignas] = ACTIONS(3006),
    [anon_sym__Alignas] = ACTIONS(3006),
    [sym_primitive_type] = ACTIONS(3006),
    [anon_sym_enum] = ACTIONS(3006),
    [anon_sym_class] = ACTIONS(3006),
    [anon_sym_struct] = ACTIONS(3006),
    [anon_sym_union] = ACTIONS(3006),
    [anon_sym_if] = ACTIONS(3006),
    [anon_sym_switch] = ACTIONS(3006),
    [anon_sym_case] = ACTIONS(3006),
    [anon_sym_default] = ACTIONS(3006),
    [anon_sym_while] = ACTIONS(3006),
    [anon_sym_do] = ACTIONS(3006),
    [anon_sym_for] = ACTIONS(3006),
    [anon_sym_return] = ACTIONS(3006),
    [anon_sym_break] = ACTIONS(3006),
    [anon_sym_continue] = ACTIONS(3006),
    [anon_sym_goto] = ACTIONS(3006),
    [anon_sym_not] = ACTIONS(3006),
    [anon_sym_compl] = ACTIONS(3006),
    [anon_sym_DASH_DASH] = ACTIONS(3004),
    [anon_sym_PLUS_PLUS] = ACTIONS(3004),
    [anon_sym_sizeof] = ACTIONS(3006),
    [anon_sym___alignof__] = ACTIONS(3006),
    [anon_sym___alignof] = ACTIONS(3006),
    [anon_sym__alignof] = ACTIONS(3006),
    [anon_sym_alignof] = ACTIONS(3006),
    [anon_sym__Alignof] = ACTIONS(3006),
    [anon_sym_offsetof] = ACTIONS(3006),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3006),
    [anon_sym___asm__] = ACTIONS(3006),
    [anon_sym___asm] = ACTIONS(3006),
    [anon_sym_DOT] = ACTIONS(3006),
    [sym_number_literal] = ACTIONS(3004),
    [anon_sym_L_SQUOTE] = ACTIONS(3004),
    [anon_sym_u_SQUOTE] = ACTIONS(3004),
    [anon_sym_U_SQUOTE] = ACTIONS(3004),
    [anon_sym_u8_SQUOTE] = ACTIONS(3004),
    [anon_sym_SQUOTE] = ACTIONS(3004),
    [anon_sym_L_DQUOTE] = ACTIONS(3004),
    [anon_sym_u_DQUOTE] = ACTIONS(3004),
    [anon_sym_U_DQUOTE] = ACTIONS(3004),
    [anon_sym_u8_DQUOTE] = ACTIONS(3004),
    [anon_sym_DQUOTE] = ACTIONS(3004),
    [sym_true] = ACTIONS(3006),
    [sym_false] = ACTIONS(3006),
    [anon_sym_NULL] = ACTIONS(3006),
    [anon_sym_nullptr] = ACTIONS(3006),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3006),
    [anon_sym_let] = ACTIONS(3006),
    [anon_sym_This] = ACTIONS(3006),
    [anon_sym_decltype] = ACTIONS(3006),
    [anon_sym_final] = ACTIONS(3006),
    [anon_sym_override] = ACTIONS(3006),
    [anon_sym_explicit] = ACTIONS(3006),
    [anon_sym_typename] = ACTIONS(3006),
    [anon_sym_export] = ACTIONS(3006),
    [anon_sym_module] = ACTIONS(3006),
    [anon_sym_import] = ACTIONS(3006),
    [anon_sym_template] = ACTIONS(3006),
    [anon_sym_GT2] = ACTIONS(3004),
    [anon_sym_operator] = ACTIONS(3006),
    [anon_sym_try] = ACTIONS(3006),
    [anon_sym_delete] = ACTIONS(3006),
    [anon_sym_throw] = ACTIONS(3006),
    [anon_sym_namespace] = ACTIONS(3006),
    [anon_sym_static_assert] = ACTIONS(3006),
    [anon_sym_concept] = ACTIONS(3006),
    [anon_sym_co_return] = ACTIONS(3006),
    [anon_sym_co_yield] = ACTIONS(3006),
    [anon_sym_R_DQUOTE] = ACTIONS(3004),
    [anon_sym_LR_DQUOTE] = ACTIONS(3004),
    [anon_sym_uR_DQUOTE] = ACTIONS(3004),
    [anon_sym_UR_DQUOTE] = ACTIONS(3004),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3004),
    [anon_sym_co_await] = ACTIONS(3006),
    [anon_sym_new] = ACTIONS(3006),
    [anon_sym_requires] = ACTIONS(3006),
    [sym_this] = ACTIONS(3006),
    [anon_sym_precise] = ACTIONS(3006),
    [anon_sym_shared] = ACTIONS(3006),
    [anon_sym_groupshared] = ACTIONS(3006),
    [anon_sym_uniform] = ACTIONS(3006),
    [anon_sym_row_major] = ACTIONS(3006),
    [anon_sym_column_major] = ACTIONS(3006),
    [anon_sym_globallycoherent] = ACTIONS(3006),
    [anon_sym_centroid] = ACTIONS(3006),
    [anon_sym_noperspective] = ACTIONS(3006),
    [anon_sym_nointerpolation] = ACTIONS(3006),
    [anon_sym_sample] = ACTIONS(3006),
    [anon_sym_linear] = ACTIONS(3006),
    [anon_sym_snorm] = ACTIONS(3006),
    [anon_sym_unorm] = ACTIONS(3006),
    [anon_sym_point] = ACTIONS(3006),
    [anon_sym_line] = ACTIONS(3006),
    [anon_sym_triangleadj] = ACTIONS(3006),
    [anon_sym_lineadj] = ACTIONS(3006),
    [anon_sym_triangle] = ACTIONS(3006),
    [anon_sym_interface] = ACTIONS(3006),
    [anon_sym_extension] = ACTIONS(3006),
    [anon_sym_where] = ACTIONS(3006),
    [anon_sym___exported] = ACTIONS(3006),
  },
  [312] = {
    [ts_builtin_sym_end] = ACTIONS(3008),
    [sym_identifier] = ACTIONS(3010),
    [aux_sym_preproc_include_token1] = ACTIONS(3010),
    [aux_sym_preproc_def_token1] = ACTIONS(3010),
    [anon_sym_COMMA] = ACTIONS(3008),
    [anon_sym_RPAREN] = ACTIONS(3008),
    [aux_sym_preproc_if_token1] = ACTIONS(3010),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3010),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3010),
    [sym_preproc_directive] = ACTIONS(3010),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_BANG] = ACTIONS(3008),
    [anon_sym_TILDE] = ACTIONS(3008),
    [anon_sym_DASH] = ACTIONS(3010),
    [anon_sym_PLUS] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(3008),
    [anon_sym_AMP_AMP] = ACTIONS(3008),
    [anon_sym_AMP] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(3008),
    [anon_sym___extension__] = ACTIONS(3010),
    [anon_sym_typedef] = ACTIONS(3010),
    [anon_sym_in] = ACTIONS(3010),
    [anon_sym_out] = ACTIONS(3010),
    [anon_sym_inout] = ACTIONS(3010),
    [anon_sym_virtual] = ACTIONS(3010),
    [anon_sym_extern] = ACTIONS(3010),
    [anon_sym___attribute__] = ACTIONS(3010),
    [anon_sym___attribute] = ACTIONS(3010),
    [anon_sym_using] = ACTIONS(3010),
    [anon_sym_COLON_COLON] = ACTIONS(3008),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3008),
    [anon_sym___declspec] = ACTIONS(3010),
    [anon_sym___based] = ACTIONS(3010),
    [anon_sym___cdecl] = ACTIONS(3010),
    [anon_sym___clrcall] = ACTIONS(3010),
    [anon_sym___stdcall] = ACTIONS(3010),
    [anon_sym___fastcall] = ACTIONS(3010),
    [anon_sym___thiscall] = ACTIONS(3010),
    [anon_sym___vectorcall] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3008),
    [anon_sym_signed] = ACTIONS(3010),
    [anon_sym_unsigned] = ACTIONS(3010),
    [anon_sym_long] = ACTIONS(3010),
    [anon_sym_short] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3010),
    [anon_sym_static] = ACTIONS(3010),
    [anon_sym_register] = ACTIONS(3010),
    [anon_sym_inline] = ACTIONS(3010),
    [anon_sym___inline] = ACTIONS(3010),
    [anon_sym___inline__] = ACTIONS(3010),
    [anon_sym___forceinline] = ACTIONS(3010),
    [anon_sym_thread_local] = ACTIONS(3010),
    [anon_sym___thread] = ACTIONS(3010),
    [anon_sym_const] = ACTIONS(3010),
    [anon_sym_constexpr] = ACTIONS(3010),
    [anon_sym_volatile] = ACTIONS(3010),
    [anon_sym_restrict] = ACTIONS(3010),
    [anon_sym___restrict__] = ACTIONS(3010),
    [anon_sym__Atomic] = ACTIONS(3010),
    [anon_sym__Noreturn] = ACTIONS(3010),
    [anon_sym_noreturn] = ACTIONS(3010),
    [anon_sym__Nonnull] = ACTIONS(3010),
    [anon_sym_mutable] = ACTIONS(3010),
    [anon_sym_constinit] = ACTIONS(3010),
    [anon_sym_consteval] = ACTIONS(3010),
    [anon_sym_alignas] = ACTIONS(3010),
    [anon_sym__Alignas] = ACTIONS(3010),
    [sym_primitive_type] = ACTIONS(3010),
    [anon_sym_enum] = ACTIONS(3010),
    [anon_sym_class] = ACTIONS(3010),
    [anon_sym_struct] = ACTIONS(3010),
    [anon_sym_union] = ACTIONS(3010),
    [anon_sym_if] = ACTIONS(3010),
    [anon_sym_switch] = ACTIONS(3010),
    [anon_sym_case] = ACTIONS(3010),
    [anon_sym_default] = ACTIONS(3010),
    [anon_sym_while] = ACTIONS(3010),
    [anon_sym_do] = ACTIONS(3010),
    [anon_sym_for] = ACTIONS(3010),
    [anon_sym_return] = ACTIONS(3010),
    [anon_sym_break] = ACTIONS(3010),
    [anon_sym_continue] = ACTIONS(3010),
    [anon_sym_goto] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3010),
    [anon_sym_compl] = ACTIONS(3010),
    [anon_sym_DASH_DASH] = ACTIONS(3008),
    [anon_sym_PLUS_PLUS] = ACTIONS(3008),
    [anon_sym_sizeof] = ACTIONS(3010),
    [anon_sym___alignof__] = ACTIONS(3010),
    [anon_sym___alignof] = ACTIONS(3010),
    [anon_sym__alignof] = ACTIONS(3010),
    [anon_sym_alignof] = ACTIONS(3010),
    [anon_sym__Alignof] = ACTIONS(3010),
    [anon_sym_offsetof] = ACTIONS(3010),
    [anon_sym__Generic] = ACTIONS(3010),
    [anon_sym_asm] = ACTIONS(3010),
    [anon_sym___asm__] = ACTIONS(3010),
    [anon_sym___asm] = ACTIONS(3010),
    [anon_sym_DOT] = ACTIONS(3010),
    [sym_number_literal] = ACTIONS(3008),
    [anon_sym_L_SQUOTE] = ACTIONS(3008),
    [anon_sym_u_SQUOTE] = ACTIONS(3008),
    [anon_sym_U_SQUOTE] = ACTIONS(3008),
    [anon_sym_u8_SQUOTE] = ACTIONS(3008),
    [anon_sym_SQUOTE] = ACTIONS(3008),
    [anon_sym_L_DQUOTE] = ACTIONS(3008),
    [anon_sym_u_DQUOTE] = ACTIONS(3008),
    [anon_sym_U_DQUOTE] = ACTIONS(3008),
    [anon_sym_u8_DQUOTE] = ACTIONS(3008),
    [anon_sym_DQUOTE] = ACTIONS(3008),
    [sym_true] = ACTIONS(3010),
    [sym_false] = ACTIONS(3010),
    [anon_sym_NULL] = ACTIONS(3010),
    [anon_sym_nullptr] = ACTIONS(3010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3010),
    [anon_sym_let] = ACTIONS(3010),
    [anon_sym_This] = ACTIONS(3010),
    [anon_sym_decltype] = ACTIONS(3010),
    [anon_sym_final] = ACTIONS(3010),
    [anon_sym_override] = ACTIONS(3010),
    [anon_sym_explicit] = ACTIONS(3010),
    [anon_sym_typename] = ACTIONS(3010),
    [anon_sym_export] = ACTIONS(3010),
    [anon_sym_module] = ACTIONS(3010),
    [anon_sym_import] = ACTIONS(3010),
    [anon_sym_template] = ACTIONS(3010),
    [anon_sym_GT2] = ACTIONS(3008),
    [anon_sym_operator] = ACTIONS(3010),
    [anon_sym_try] = ACTIONS(3010),
    [anon_sym_delete] = ACTIONS(3010),
    [anon_sym_throw] = ACTIONS(3010),
    [anon_sym_namespace] = ACTIONS(3010),
    [anon_sym_static_assert] = ACTIONS(3010),
    [anon_sym_concept] = ACTIONS(3010),
    [anon_sym_co_return] = ACTIONS(3010),
    [anon_sym_co_yield] = ACTIONS(3010),
    [anon_sym_R_DQUOTE] = ACTIONS(3008),
    [anon_sym_LR_DQUOTE] = ACTIONS(3008),
    [anon_sym_uR_DQUOTE] = ACTIONS(3008),
    [anon_sym_UR_DQUOTE] = ACTIONS(3008),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3008),
    [anon_sym_co_await] = ACTIONS(3010),
    [anon_sym_new] = ACTIONS(3010),
    [anon_sym_requires] = ACTIONS(3010),
    [sym_this] = ACTIONS(3010),
    [anon_sym_precise] = ACTIONS(3010),
    [anon_sym_shared] = ACTIONS(3010),
    [anon_sym_groupshared] = ACTIONS(3010),
    [anon_sym_uniform] = ACTIONS(3010),
    [anon_sym_row_major] = ACTIONS(3010),
    [anon_sym_column_major] = ACTIONS(3010),
    [anon_sym_globallycoherent] = ACTIONS(3010),
    [anon_sym_centroid] = ACTIONS(3010),
    [anon_sym_noperspective] = ACTIONS(3010),
    [anon_sym_nointerpolation] = ACTIONS(3010),
    [anon_sym_sample] = ACTIONS(3010),
    [anon_sym_linear] = ACTIONS(3010),
    [anon_sym_snorm] = ACTIONS(3010),
    [anon_sym_unorm] = ACTIONS(3010),
    [anon_sym_point] = ACTIONS(3010),
    [anon_sym_line] = ACTIONS(3010),
    [anon_sym_triangleadj] = ACTIONS(3010),
    [anon_sym_lineadj] = ACTIONS(3010),
    [anon_sym_triangle] = ACTIONS(3010),
    [anon_sym_interface] = ACTIONS(3010),
    [anon_sym_extension] = ACTIONS(3010),
    [anon_sym_where] = ACTIONS(3010),
    [anon_sym___exported] = ACTIONS(3010),
  },
  [313] = {
    [ts_builtin_sym_end] = ACTIONS(3012),
    [sym_identifier] = ACTIONS(3014),
    [aux_sym_preproc_include_token1] = ACTIONS(3014),
    [aux_sym_preproc_def_token1] = ACTIONS(3014),
    [anon_sym_COMMA] = ACTIONS(3012),
    [anon_sym_RPAREN] = ACTIONS(3012),
    [aux_sym_preproc_if_token1] = ACTIONS(3014),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3014),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3014),
    [sym_preproc_directive] = ACTIONS(3014),
    [anon_sym_LPAREN2] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3012),
    [anon_sym_TILDE] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_STAR] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym___extension__] = ACTIONS(3014),
    [anon_sym_typedef] = ACTIONS(3014),
    [anon_sym_in] = ACTIONS(3014),
    [anon_sym_out] = ACTIONS(3014),
    [anon_sym_inout] = ACTIONS(3014),
    [anon_sym_virtual] = ACTIONS(3014),
    [anon_sym_extern] = ACTIONS(3014),
    [anon_sym___attribute__] = ACTIONS(3014),
    [anon_sym___attribute] = ACTIONS(3014),
    [anon_sym_using] = ACTIONS(3014),
    [anon_sym_COLON_COLON] = ACTIONS(3012),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3012),
    [anon_sym___declspec] = ACTIONS(3014),
    [anon_sym___based] = ACTIONS(3014),
    [anon_sym___cdecl] = ACTIONS(3014),
    [anon_sym___clrcall] = ACTIONS(3014),
    [anon_sym___stdcall] = ACTIONS(3014),
    [anon_sym___fastcall] = ACTIONS(3014),
    [anon_sym___thiscall] = ACTIONS(3014),
    [anon_sym___vectorcall] = ACTIONS(3014),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_signed] = ACTIONS(3014),
    [anon_sym_unsigned] = ACTIONS(3014),
    [anon_sym_long] = ACTIONS(3014),
    [anon_sym_short] = ACTIONS(3014),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_static] = ACTIONS(3014),
    [anon_sym_register] = ACTIONS(3014),
    [anon_sym_inline] = ACTIONS(3014),
    [anon_sym___inline] = ACTIONS(3014),
    [anon_sym___inline__] = ACTIONS(3014),
    [anon_sym___forceinline] = ACTIONS(3014),
    [anon_sym_thread_local] = ACTIONS(3014),
    [anon_sym___thread] = ACTIONS(3014),
    [anon_sym_const] = ACTIONS(3014),
    [anon_sym_constexpr] = ACTIONS(3014),
    [anon_sym_volatile] = ACTIONS(3014),
    [anon_sym_restrict] = ACTIONS(3014),
    [anon_sym___restrict__] = ACTIONS(3014),
    [anon_sym__Atomic] = ACTIONS(3014),
    [anon_sym__Noreturn] = ACTIONS(3014),
    [anon_sym_noreturn] = ACTIONS(3014),
    [anon_sym__Nonnull] = ACTIONS(3014),
    [anon_sym_mutable] = ACTIONS(3014),
    [anon_sym_constinit] = ACTIONS(3014),
    [anon_sym_consteval] = ACTIONS(3014),
    [anon_sym_alignas] = ACTIONS(3014),
    [anon_sym__Alignas] = ACTIONS(3014),
    [sym_primitive_type] = ACTIONS(3014),
    [anon_sym_enum] = ACTIONS(3014),
    [anon_sym_class] = ACTIONS(3014),
    [anon_sym_struct] = ACTIONS(3014),
    [anon_sym_union] = ACTIONS(3014),
    [anon_sym_if] = ACTIONS(3014),
    [anon_sym_switch] = ACTIONS(3014),
    [anon_sym_case] = ACTIONS(3014),
    [anon_sym_default] = ACTIONS(3014),
    [anon_sym_while] = ACTIONS(3014),
    [anon_sym_do] = ACTIONS(3014),
    [anon_sym_for] = ACTIONS(3014),
    [anon_sym_return] = ACTIONS(3014),
    [anon_sym_break] = ACTIONS(3014),
    [anon_sym_continue] = ACTIONS(3014),
    [anon_sym_goto] = ACTIONS(3014),
    [anon_sym_not] = ACTIONS(3014),
    [anon_sym_compl] = ACTIONS(3014),
    [anon_sym_DASH_DASH] = ACTIONS(3012),
    [anon_sym_PLUS_PLUS] = ACTIONS(3012),
    [anon_sym_sizeof] = ACTIONS(3014),
    [anon_sym___alignof__] = ACTIONS(3014),
    [anon_sym___alignof] = ACTIONS(3014),
    [anon_sym__alignof] = ACTIONS(3014),
    [anon_sym_alignof] = ACTIONS(3014),
    [anon_sym__Alignof] = ACTIONS(3014),
    [anon_sym_offsetof] = ACTIONS(3014),
    [anon_sym__Generic] = ACTIONS(3014),
    [anon_sym_asm] = ACTIONS(3014),
    [anon_sym___asm__] = ACTIONS(3014),
    [anon_sym___asm] = ACTIONS(3014),
    [anon_sym_DOT] = ACTIONS(3014),
    [sym_number_literal] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3012),
    [anon_sym_u_SQUOTE] = ACTIONS(3012),
    [anon_sym_U_SQUOTE] = ACTIONS(3012),
    [anon_sym_u8_SQUOTE] = ACTIONS(3012),
    [anon_sym_SQUOTE] = ACTIONS(3012),
    [anon_sym_L_DQUOTE] = ACTIONS(3012),
    [anon_sym_u_DQUOTE] = ACTIONS(3012),
    [anon_sym_U_DQUOTE] = ACTIONS(3012),
    [anon_sym_u8_DQUOTE] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [sym_true] = ACTIONS(3014),
    [sym_false] = ACTIONS(3014),
    [anon_sym_NULL] = ACTIONS(3014),
    [anon_sym_nullptr] = ACTIONS(3014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3014),
    [anon_sym_let] = ACTIONS(3014),
    [anon_sym_This] = ACTIONS(3014),
    [anon_sym_decltype] = ACTIONS(3014),
    [anon_sym_final] = ACTIONS(3014),
    [anon_sym_override] = ACTIONS(3014),
    [anon_sym_explicit] = ACTIONS(3014),
    [anon_sym_typename] = ACTIONS(3014),
    [anon_sym_export] = ACTIONS(3014),
    [anon_sym_module] = ACTIONS(3014),
    [anon_sym_import] = ACTIONS(3014),
    [anon_sym_template] = ACTIONS(3014),
    [anon_sym_GT2] = ACTIONS(3012),
    [anon_sym_operator] = ACTIONS(3014),
    [anon_sym_try] = ACTIONS(3014),
    [anon_sym_delete] = ACTIONS(3014),
    [anon_sym_throw] = ACTIONS(3014),
    [anon_sym_namespace] = ACTIONS(3014),
    [anon_sym_static_assert] = ACTIONS(3014),
    [anon_sym_concept] = ACTIONS(3014),
    [anon_sym_co_return] = ACTIONS(3014),
    [anon_sym_co_yield] = ACTIONS(3014),
    [anon_sym_R_DQUOTE] = ACTIONS(3012),
    [anon_sym_LR_DQUOTE] = ACTIONS(3012),
    [anon_sym_uR_DQUOTE] = ACTIONS(3012),
    [anon_sym_UR_DQUOTE] = ACTIONS(3012),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3012),
    [anon_sym_co_await] = ACTIONS(3014),
    [anon_sym_new] = ACTIONS(3014),
    [anon_sym_requires] = ACTIONS(3014),
    [sym_this] = ACTIONS(3014),
    [anon_sym_precise] = ACTIONS(3014),
    [anon_sym_shared] = ACTIONS(3014),
    [anon_sym_groupshared] = ACTIONS(3014),
    [anon_sym_uniform] = ACTIONS(3014),
    [anon_sym_row_major] = ACTIONS(3014),
    [anon_sym_column_major] = ACTIONS(3014),
    [anon_sym_globallycoherent] = ACTIONS(3014),
    [anon_sym_centroid] = ACTIONS(3014),
    [anon_sym_noperspective] = ACTIONS(3014),
    [anon_sym_nointerpolation] = ACTIONS(3014),
    [anon_sym_sample] = ACTIONS(3014),
    [anon_sym_linear] = ACTIONS(3014),
    [anon_sym_snorm] = ACTIONS(3014),
    [anon_sym_unorm] = ACTIONS(3014),
    [anon_sym_point] = ACTIONS(3014),
    [anon_sym_line] = ACTIONS(3014),
    [anon_sym_triangleadj] = ACTIONS(3014),
    [anon_sym_lineadj] = ACTIONS(3014),
    [anon_sym_triangle] = ACTIONS(3014),
    [anon_sym_interface] = ACTIONS(3014),
    [anon_sym_extension] = ACTIONS(3014),
    [anon_sym_where] = ACTIONS(3014),
    [anon_sym___exported] = ACTIONS(3014),
  },
  [314] = {
    [sym_field_declaration_list] = STATE(835),
    [sym_virtual_specifier] = STATE(9342),
    [sym_base_class_clause] = STATE(10424),
    [sym_identifier] = ACTIONS(2566),
    [aux_sym_preproc_include_token1] = ACTIONS(2566),
    [aux_sym_preproc_def_token1] = ACTIONS(2566),
    [aux_sym_preproc_if_token1] = ACTIONS(2566),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2566),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2566),
    [sym_preproc_directive] = ACTIONS(2566),
    [anon_sym_LPAREN2] = ACTIONS(2568),
    [anon_sym_BANG] = ACTIONS(2568),
    [anon_sym_TILDE] = ACTIONS(2568),
    [anon_sym_DASH] = ACTIONS(2566),
    [anon_sym_PLUS] = ACTIONS(2566),
    [anon_sym_STAR] = ACTIONS(2568),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2566),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2568),
    [anon_sym___extension__] = ACTIONS(2566),
    [anon_sym_typedef] = ACTIONS(2566),
    [anon_sym_in] = ACTIONS(2566),
    [anon_sym_out] = ACTIONS(2566),
    [anon_sym_inout] = ACTIONS(2566),
    [anon_sym_virtual] = ACTIONS(2566),
    [anon_sym_extern] = ACTIONS(2566),
    [anon_sym___attribute__] = ACTIONS(2566),
    [anon_sym___attribute] = ACTIONS(2566),
    [anon_sym_using] = ACTIONS(2566),
    [anon_sym_COLON_COLON] = ACTIONS(2568),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2568),
    [anon_sym___declspec] = ACTIONS(2566),
    [anon_sym___based] = ACTIONS(2566),
    [anon_sym___cdecl] = ACTIONS(2566),
    [anon_sym___clrcall] = ACTIONS(2566),
    [anon_sym___stdcall] = ACTIONS(2566),
    [anon_sym___fastcall] = ACTIONS(2566),
    [anon_sym___thiscall] = ACTIONS(2566),
    [anon_sym___vectorcall] = ACTIONS(2566),
    [anon_sym_LBRACE] = ACTIONS(2899),
    [anon_sym_RBRACE] = ACTIONS(2568),
    [anon_sym_signed] = ACTIONS(2566),
    [anon_sym_unsigned] = ACTIONS(2566),
    [anon_sym_long] = ACTIONS(2566),
    [anon_sym_short] = ACTIONS(2566),
    [anon_sym_LBRACK] = ACTIONS(2566),
    [anon_sym_static] = ACTIONS(2566),
    [anon_sym_register] = ACTIONS(2566),
    [anon_sym_inline] = ACTIONS(2566),
    [anon_sym___inline] = ACTIONS(2566),
    [anon_sym___inline__] = ACTIONS(2566),
    [anon_sym___forceinline] = ACTIONS(2566),
    [anon_sym_thread_local] = ACTIONS(2566),
    [anon_sym___thread] = ACTIONS(2566),
    [anon_sym_const] = ACTIONS(2566),
    [anon_sym_constexpr] = ACTIONS(2566),
    [anon_sym_volatile] = ACTIONS(2566),
    [anon_sym_restrict] = ACTIONS(2566),
    [anon_sym___restrict__] = ACTIONS(2566),
    [anon_sym__Atomic] = ACTIONS(2566),
    [anon_sym__Noreturn] = ACTIONS(2566),
    [anon_sym_noreturn] = ACTIONS(2566),
    [anon_sym__Nonnull] = ACTIONS(2566),
    [anon_sym_mutable] = ACTIONS(2566),
    [anon_sym_constinit] = ACTIONS(2566),
    [anon_sym_consteval] = ACTIONS(2566),
    [anon_sym_alignas] = ACTIONS(2566),
    [anon_sym__Alignas] = ACTIONS(2566),
    [sym_primitive_type] = ACTIONS(2566),
    [anon_sym_enum] = ACTIONS(2566),
    [anon_sym_class] = ACTIONS(2566),
    [anon_sym_struct] = ACTIONS(2566),
    [anon_sym_union] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2566),
    [anon_sym_else] = ACTIONS(2566),
    [anon_sym_switch] = ACTIONS(2566),
    [anon_sym_case] = ACTIONS(2566),
    [anon_sym_default] = ACTIONS(2566),
    [anon_sym_while] = ACTIONS(2566),
    [anon_sym_do] = ACTIONS(2566),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_break] = ACTIONS(2566),
    [anon_sym_continue] = ACTIONS(2566),
    [anon_sym_goto] = ACTIONS(2566),
    [anon_sym___try] = ACTIONS(2566),
    [anon_sym___leave] = ACTIONS(2566),
    [anon_sym_not] = ACTIONS(2566),
    [anon_sym_compl] = ACTIONS(2566),
    [anon_sym_DASH_DASH] = ACTIONS(2568),
    [anon_sym_PLUS_PLUS] = ACTIONS(2568),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2566),
    [anon_sym___alignof] = ACTIONS(2566),
    [anon_sym__alignof] = ACTIONS(2566),
    [anon_sym_alignof] = ACTIONS(2566),
    [anon_sym__Alignof] = ACTIONS(2566),
    [anon_sym_offsetof] = ACTIONS(2566),
    [anon_sym__Generic] = ACTIONS(2566),
    [anon_sym_asm] = ACTIONS(2566),
    [anon_sym___asm__] = ACTIONS(2566),
    [anon_sym___asm] = ACTIONS(2566),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2568),
    [anon_sym_u_SQUOTE] = ACTIONS(2568),
    [anon_sym_U_SQUOTE] = ACTIONS(2568),
    [anon_sym_u8_SQUOTE] = ACTIONS(2568),
    [anon_sym_SQUOTE] = ACTIONS(2568),
    [anon_sym_L_DQUOTE] = ACTIONS(2568),
    [anon_sym_u_DQUOTE] = ACTIONS(2568),
    [anon_sym_U_DQUOTE] = ACTIONS(2568),
    [anon_sym_u8_DQUOTE] = ACTIONS(2568),
    [anon_sym_DQUOTE] = ACTIONS(2568),
    [sym_true] = ACTIONS(2566),
    [sym_false] = ACTIONS(2566),
    [anon_sym_NULL] = ACTIONS(2566),
    [anon_sym_nullptr] = ACTIONS(2566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2566),
    [anon_sym_let] = ACTIONS(2566),
    [anon_sym_This] = ACTIONS(2566),
    [anon_sym_decltype] = ACTIONS(2566),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_explicit] = ACTIONS(2566),
    [anon_sym_typename] = ACTIONS(2566),
    [anon_sym_template] = ACTIONS(2566),
    [anon_sym_operator] = ACTIONS(2566),
    [anon_sym_try] = ACTIONS(2566),
    [anon_sym_delete] = ACTIONS(2566),
    [anon_sym_throw] = ACTIONS(2566),
    [anon_sym_namespace] = ACTIONS(2566),
    [anon_sym_static_assert] = ACTIONS(2566),
    [anon_sym_concept] = ACTIONS(2566),
    [anon_sym_co_return] = ACTIONS(2566),
    [anon_sym_co_yield] = ACTIONS(2566),
    [anon_sym_R_DQUOTE] = ACTIONS(2568),
    [anon_sym_LR_DQUOTE] = ACTIONS(2568),
    [anon_sym_uR_DQUOTE] = ACTIONS(2568),
    [anon_sym_UR_DQUOTE] = ACTIONS(2568),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2568),
    [anon_sym_co_await] = ACTIONS(2566),
    [anon_sym_new] = ACTIONS(2566),
    [anon_sym_requires] = ACTIONS(2566),
    [sym_this] = ACTIONS(2566),
    [anon_sym_discard] = ACTIONS(2566),
    [anon_sym_precise] = ACTIONS(2566),
    [anon_sym_shared] = ACTIONS(2566),
    [anon_sym_groupshared] = ACTIONS(2566),
    [anon_sym_uniform] = ACTIONS(2566),
    [anon_sym_row_major] = ACTIONS(2566),
    [anon_sym_column_major] = ACTIONS(2566),
    [anon_sym_globallycoherent] = ACTIONS(2566),
    [anon_sym_centroid] = ACTIONS(2566),
    [anon_sym_noperspective] = ACTIONS(2566),
    [anon_sym_nointerpolation] = ACTIONS(2566),
    [anon_sym_sample] = ACTIONS(2566),
    [anon_sym_linear] = ACTIONS(2566),
    [anon_sym_snorm] = ACTIONS(2566),
    [anon_sym_unorm] = ACTIONS(2566),
    [anon_sym_point] = ACTIONS(2566),
    [anon_sym_line] = ACTIONS(2566),
    [anon_sym_triangleadj] = ACTIONS(2566),
    [anon_sym_lineadj] = ACTIONS(2566),
    [anon_sym_triangle] = ACTIONS(2566),
    [anon_sym_cbuffer] = ACTIONS(2566),
    [anon_sym_interface] = ACTIONS(2566),
    [anon_sym_extension] = ACTIONS(2566),
  },
  [315] = {
    [ts_builtin_sym_end] = ACTIONS(2881),
    [sym_identifier] = ACTIONS(2883),
    [aux_sym_preproc_include_token1] = ACTIONS(2883),
    [aux_sym_preproc_def_token1] = ACTIONS(2883),
    [anon_sym_COMMA] = ACTIONS(2881),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [aux_sym_preproc_if_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2883),
    [sym_preproc_directive] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_typedef] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_using] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2881),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_signed] = ACTIONS(2883),
    [anon_sym_unsigned] = ACTIONS(2883),
    [anon_sym_long] = ACTIONS(2883),
    [anon_sym_short] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [sym_primitive_type] = ACTIONS(2883),
    [anon_sym_enum] = ACTIONS(2883),
    [anon_sym_class] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2883),
    [anon_sym_union] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_switch] = ACTIONS(2883),
    [anon_sym_case] = ACTIONS(2883),
    [anon_sym_default] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_break] = ACTIONS(2883),
    [anon_sym_continue] = ACTIONS(2883),
    [anon_sym_goto] = ACTIONS(2883),
    [anon_sym_not] = ACTIONS(2883),
    [anon_sym_compl] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_sizeof] = ACTIONS(2883),
    [anon_sym___alignof__] = ACTIONS(2883),
    [anon_sym___alignof] = ACTIONS(2883),
    [anon_sym__alignof] = ACTIONS(2883),
    [anon_sym_alignof] = ACTIONS(2883),
    [anon_sym__Alignof] = ACTIONS(2883),
    [anon_sym_offsetof] = ACTIONS(2883),
    [anon_sym__Generic] = ACTIONS(2883),
    [anon_sym_asm] = ACTIONS(2883),
    [anon_sym___asm__] = ACTIONS(2883),
    [anon_sym___asm] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [sym_number_literal] = ACTIONS(2881),
    [anon_sym_L_SQUOTE] = ACTIONS(2881),
    [anon_sym_u_SQUOTE] = ACTIONS(2881),
    [anon_sym_U_SQUOTE] = ACTIONS(2881),
    [anon_sym_u8_SQUOTE] = ACTIONS(2881),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_L_DQUOTE] = ACTIONS(2881),
    [anon_sym_u_DQUOTE] = ACTIONS(2881),
    [anon_sym_U_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [sym_true] = ACTIONS(2883),
    [sym_false] = ACTIONS(2883),
    [anon_sym_NULL] = ACTIONS(2883),
    [anon_sym_nullptr] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_final] = ACTIONS(2883),
    [anon_sym_override] = ACTIONS(2883),
    [anon_sym_explicit] = ACTIONS(2883),
    [anon_sym_typename] = ACTIONS(2883),
    [anon_sym_export] = ACTIONS(2883),
    [anon_sym_module] = ACTIONS(2883),
    [anon_sym_import] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_GT2] = ACTIONS(2881),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_delete] = ACTIONS(2883),
    [anon_sym_throw] = ACTIONS(2883),
    [anon_sym_namespace] = ACTIONS(2883),
    [anon_sym_static_assert] = ACTIONS(2883),
    [anon_sym_concept] = ACTIONS(2883),
    [anon_sym_co_return] = ACTIONS(2883),
    [anon_sym_co_yield] = ACTIONS(2883),
    [anon_sym_R_DQUOTE] = ACTIONS(2881),
    [anon_sym_LR_DQUOTE] = ACTIONS(2881),
    [anon_sym_uR_DQUOTE] = ACTIONS(2881),
    [anon_sym_UR_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2881),
    [anon_sym_co_await] = ACTIONS(2883),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_requires] = ACTIONS(2883),
    [sym_this] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
    [anon_sym_interface] = ACTIONS(2883),
    [anon_sym_extension] = ACTIONS(2883),
    [anon_sym_where] = ACTIONS(2883),
    [anon_sym___exported] = ACTIONS(2883),
  },
  [316] = {
    [ts_builtin_sym_end] = ACTIONS(3016),
    [sym_identifier] = ACTIONS(3018),
    [aux_sym_preproc_include_token1] = ACTIONS(3018),
    [aux_sym_preproc_def_token1] = ACTIONS(3018),
    [anon_sym_COMMA] = ACTIONS(3016),
    [anon_sym_RPAREN] = ACTIONS(3016),
    [aux_sym_preproc_if_token1] = ACTIONS(3018),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3018),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3018),
    [sym_preproc_directive] = ACTIONS(3018),
    [anon_sym_LPAREN2] = ACTIONS(3016),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [anon_sym_DASH] = ACTIONS(3018),
    [anon_sym_PLUS] = ACTIONS(3018),
    [anon_sym_STAR] = ACTIONS(3016),
    [anon_sym_AMP_AMP] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(3016),
    [anon_sym___extension__] = ACTIONS(3018),
    [anon_sym_typedef] = ACTIONS(3018),
    [anon_sym_in] = ACTIONS(3018),
    [anon_sym_out] = ACTIONS(3018),
    [anon_sym_inout] = ACTIONS(3018),
    [anon_sym_virtual] = ACTIONS(3018),
    [anon_sym_extern] = ACTIONS(3018),
    [anon_sym___attribute__] = ACTIONS(3018),
    [anon_sym___attribute] = ACTIONS(3018),
    [anon_sym_using] = ACTIONS(3018),
    [anon_sym_COLON_COLON] = ACTIONS(3016),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3016),
    [anon_sym___declspec] = ACTIONS(3018),
    [anon_sym___based] = ACTIONS(3018),
    [anon_sym___cdecl] = ACTIONS(3018),
    [anon_sym___clrcall] = ACTIONS(3018),
    [anon_sym___stdcall] = ACTIONS(3018),
    [anon_sym___fastcall] = ACTIONS(3018),
    [anon_sym___thiscall] = ACTIONS(3018),
    [anon_sym___vectorcall] = ACTIONS(3018),
    [anon_sym_LBRACE] = ACTIONS(3016),
    [anon_sym_signed] = ACTIONS(3018),
    [anon_sym_unsigned] = ACTIONS(3018),
    [anon_sym_long] = ACTIONS(3018),
    [anon_sym_short] = ACTIONS(3018),
    [anon_sym_LBRACK] = ACTIONS(3018),
    [anon_sym_static] = ACTIONS(3018),
    [anon_sym_register] = ACTIONS(3018),
    [anon_sym_inline] = ACTIONS(3018),
    [anon_sym___inline] = ACTIONS(3018),
    [anon_sym___inline__] = ACTIONS(3018),
    [anon_sym___forceinline] = ACTIONS(3018),
    [anon_sym_thread_local] = ACTIONS(3018),
    [anon_sym___thread] = ACTIONS(3018),
    [anon_sym_const] = ACTIONS(3018),
    [anon_sym_constexpr] = ACTIONS(3018),
    [anon_sym_volatile] = ACTIONS(3018),
    [anon_sym_restrict] = ACTIONS(3018),
    [anon_sym___restrict__] = ACTIONS(3018),
    [anon_sym__Atomic] = ACTIONS(3018),
    [anon_sym__Noreturn] = ACTIONS(3018),
    [anon_sym_noreturn] = ACTIONS(3018),
    [anon_sym__Nonnull] = ACTIONS(3018),
    [anon_sym_mutable] = ACTIONS(3018),
    [anon_sym_constinit] = ACTIONS(3018),
    [anon_sym_consteval] = ACTIONS(3018),
    [anon_sym_alignas] = ACTIONS(3018),
    [anon_sym__Alignas] = ACTIONS(3018),
    [sym_primitive_type] = ACTIONS(3018),
    [anon_sym_enum] = ACTIONS(3018),
    [anon_sym_class] = ACTIONS(3018),
    [anon_sym_struct] = ACTIONS(3018),
    [anon_sym_union] = ACTIONS(3018),
    [anon_sym_if] = ACTIONS(3018),
    [anon_sym_switch] = ACTIONS(3018),
    [anon_sym_case] = ACTIONS(3018),
    [anon_sym_default] = ACTIONS(3018),
    [anon_sym_while] = ACTIONS(3018),
    [anon_sym_do] = ACTIONS(3018),
    [anon_sym_for] = ACTIONS(3018),
    [anon_sym_return] = ACTIONS(3018),
    [anon_sym_break] = ACTIONS(3018),
    [anon_sym_continue] = ACTIONS(3018),
    [anon_sym_goto] = ACTIONS(3018),
    [anon_sym_not] = ACTIONS(3018),
    [anon_sym_compl] = ACTIONS(3018),
    [anon_sym_DASH_DASH] = ACTIONS(3016),
    [anon_sym_PLUS_PLUS] = ACTIONS(3016),
    [anon_sym_sizeof] = ACTIONS(3018),
    [anon_sym___alignof__] = ACTIONS(3018),
    [anon_sym___alignof] = ACTIONS(3018),
    [anon_sym__alignof] = ACTIONS(3018),
    [anon_sym_alignof] = ACTIONS(3018),
    [anon_sym__Alignof] = ACTIONS(3018),
    [anon_sym_offsetof] = ACTIONS(3018),
    [anon_sym__Generic] = ACTIONS(3018),
    [anon_sym_asm] = ACTIONS(3018),
    [anon_sym___asm__] = ACTIONS(3018),
    [anon_sym___asm] = ACTIONS(3018),
    [anon_sym_DOT] = ACTIONS(3018),
    [sym_number_literal] = ACTIONS(3016),
    [anon_sym_L_SQUOTE] = ACTIONS(3016),
    [anon_sym_u_SQUOTE] = ACTIONS(3016),
    [anon_sym_U_SQUOTE] = ACTIONS(3016),
    [anon_sym_u8_SQUOTE] = ACTIONS(3016),
    [anon_sym_SQUOTE] = ACTIONS(3016),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3018),
    [anon_sym_nullptr] = ACTIONS(3018),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3018),
    [anon_sym_let] = ACTIONS(3018),
    [anon_sym_This] = ACTIONS(3018),
    [anon_sym_decltype] = ACTIONS(3018),
    [anon_sym_final] = ACTIONS(3018),
    [anon_sym_override] = ACTIONS(3018),
    [anon_sym_explicit] = ACTIONS(3018),
    [anon_sym_typename] = ACTIONS(3018),
    [anon_sym_export] = ACTIONS(3018),
    [anon_sym_module] = ACTIONS(3018),
    [anon_sym_import] = ACTIONS(3018),
    [anon_sym_template] = ACTIONS(3018),
    [anon_sym_GT2] = ACTIONS(3016),
    [anon_sym_operator] = ACTIONS(3018),
    [anon_sym_try] = ACTIONS(3018),
    [anon_sym_delete] = ACTIONS(3018),
    [anon_sym_throw] = ACTIONS(3018),
    [anon_sym_namespace] = ACTIONS(3018),
    [anon_sym_static_assert] = ACTIONS(3018),
    [anon_sym_concept] = ACTIONS(3018),
    [anon_sym_co_return] = ACTIONS(3018),
    [anon_sym_co_yield] = ACTIONS(3018),
    [anon_sym_R_DQUOTE] = ACTIONS(3016),
    [anon_sym_LR_DQUOTE] = ACTIONS(3016),
    [anon_sym_uR_DQUOTE] = ACTIONS(3016),
    [anon_sym_UR_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3016),
    [anon_sym_co_await] = ACTIONS(3018),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_requires] = ACTIONS(3018),
    [sym_this] = ACTIONS(3018),
    [anon_sym_precise] = ACTIONS(3018),
    [anon_sym_shared] = ACTIONS(3018),
    [anon_sym_groupshared] = ACTIONS(3018),
    [anon_sym_uniform] = ACTIONS(3018),
    [anon_sym_row_major] = ACTIONS(3018),
    [anon_sym_column_major] = ACTIONS(3018),
    [anon_sym_globallycoherent] = ACTIONS(3018),
    [anon_sym_centroid] = ACTIONS(3018),
    [anon_sym_noperspective] = ACTIONS(3018),
    [anon_sym_nointerpolation] = ACTIONS(3018),
    [anon_sym_sample] = ACTIONS(3018),
    [anon_sym_linear] = ACTIONS(3018),
    [anon_sym_snorm] = ACTIONS(3018),
    [anon_sym_unorm] = ACTIONS(3018),
    [anon_sym_point] = ACTIONS(3018),
    [anon_sym_line] = ACTIONS(3018),
    [anon_sym_triangleadj] = ACTIONS(3018),
    [anon_sym_lineadj] = ACTIONS(3018),
    [anon_sym_triangle] = ACTIONS(3018),
    [anon_sym_interface] = ACTIONS(3018),
    [anon_sym_extension] = ACTIONS(3018),
    [anon_sym_where] = ACTIONS(3018),
    [anon_sym___exported] = ACTIONS(3018),
  },
  [317] = {
    [ts_builtin_sym_end] = ACTIONS(3020),
    [sym_identifier] = ACTIONS(3022),
    [aux_sym_preproc_include_token1] = ACTIONS(3022),
    [aux_sym_preproc_def_token1] = ACTIONS(3022),
    [anon_sym_COMMA] = ACTIONS(3020),
    [anon_sym_RPAREN] = ACTIONS(3020),
    [aux_sym_preproc_if_token1] = ACTIONS(3022),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3022),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3022),
    [sym_preproc_directive] = ACTIONS(3022),
    [anon_sym_LPAREN2] = ACTIONS(3020),
    [anon_sym_BANG] = ACTIONS(3020),
    [anon_sym_TILDE] = ACTIONS(3020),
    [anon_sym_DASH] = ACTIONS(3022),
    [anon_sym_PLUS] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3020),
    [anon_sym_AMP_AMP] = ACTIONS(3020),
    [anon_sym_AMP] = ACTIONS(3022),
    [anon_sym_SEMI] = ACTIONS(3020),
    [anon_sym___extension__] = ACTIONS(3022),
    [anon_sym_typedef] = ACTIONS(3022),
    [anon_sym_in] = ACTIONS(3022),
    [anon_sym_out] = ACTIONS(3022),
    [anon_sym_inout] = ACTIONS(3022),
    [anon_sym_virtual] = ACTIONS(3022),
    [anon_sym_extern] = ACTIONS(3022),
    [anon_sym___attribute__] = ACTIONS(3022),
    [anon_sym___attribute] = ACTIONS(3022),
    [anon_sym_using] = ACTIONS(3022),
    [anon_sym_COLON_COLON] = ACTIONS(3020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3020),
    [anon_sym___declspec] = ACTIONS(3022),
    [anon_sym___based] = ACTIONS(3022),
    [anon_sym___cdecl] = ACTIONS(3022),
    [anon_sym___clrcall] = ACTIONS(3022),
    [anon_sym___stdcall] = ACTIONS(3022),
    [anon_sym___fastcall] = ACTIONS(3022),
    [anon_sym___thiscall] = ACTIONS(3022),
    [anon_sym___vectorcall] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3020),
    [anon_sym_signed] = ACTIONS(3022),
    [anon_sym_unsigned] = ACTIONS(3022),
    [anon_sym_long] = ACTIONS(3022),
    [anon_sym_short] = ACTIONS(3022),
    [anon_sym_LBRACK] = ACTIONS(3022),
    [anon_sym_static] = ACTIONS(3022),
    [anon_sym_register] = ACTIONS(3022),
    [anon_sym_inline] = ACTIONS(3022),
    [anon_sym___inline] = ACTIONS(3022),
    [anon_sym___inline__] = ACTIONS(3022),
    [anon_sym___forceinline] = ACTIONS(3022),
    [anon_sym_thread_local] = ACTIONS(3022),
    [anon_sym___thread] = ACTIONS(3022),
    [anon_sym_const] = ACTIONS(3022),
    [anon_sym_constexpr] = ACTIONS(3022),
    [anon_sym_volatile] = ACTIONS(3022),
    [anon_sym_restrict] = ACTIONS(3022),
    [anon_sym___restrict__] = ACTIONS(3022),
    [anon_sym__Atomic] = ACTIONS(3022),
    [anon_sym__Noreturn] = ACTIONS(3022),
    [anon_sym_noreturn] = ACTIONS(3022),
    [anon_sym__Nonnull] = ACTIONS(3022),
    [anon_sym_mutable] = ACTIONS(3022),
    [anon_sym_constinit] = ACTIONS(3022),
    [anon_sym_consteval] = ACTIONS(3022),
    [anon_sym_alignas] = ACTIONS(3022),
    [anon_sym__Alignas] = ACTIONS(3022),
    [sym_primitive_type] = ACTIONS(3022),
    [anon_sym_enum] = ACTIONS(3022),
    [anon_sym_class] = ACTIONS(3022),
    [anon_sym_struct] = ACTIONS(3022),
    [anon_sym_union] = ACTIONS(3022),
    [anon_sym_if] = ACTIONS(3022),
    [anon_sym_switch] = ACTIONS(3022),
    [anon_sym_case] = ACTIONS(3022),
    [anon_sym_default] = ACTIONS(3022),
    [anon_sym_while] = ACTIONS(3022),
    [anon_sym_do] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(3022),
    [anon_sym_return] = ACTIONS(3022),
    [anon_sym_break] = ACTIONS(3022),
    [anon_sym_continue] = ACTIONS(3022),
    [anon_sym_goto] = ACTIONS(3022),
    [anon_sym_not] = ACTIONS(3022),
    [anon_sym_compl] = ACTIONS(3022),
    [anon_sym_DASH_DASH] = ACTIONS(3020),
    [anon_sym_PLUS_PLUS] = ACTIONS(3020),
    [anon_sym_sizeof] = ACTIONS(3022),
    [anon_sym___alignof__] = ACTIONS(3022),
    [anon_sym___alignof] = ACTIONS(3022),
    [anon_sym__alignof] = ACTIONS(3022),
    [anon_sym_alignof] = ACTIONS(3022),
    [anon_sym__Alignof] = ACTIONS(3022),
    [anon_sym_offsetof] = ACTIONS(3022),
    [anon_sym__Generic] = ACTIONS(3022),
    [anon_sym_asm] = ACTIONS(3022),
    [anon_sym___asm__] = ACTIONS(3022),
    [anon_sym___asm] = ACTIONS(3022),
    [anon_sym_DOT] = ACTIONS(3022),
    [sym_number_literal] = ACTIONS(3020),
    [anon_sym_L_SQUOTE] = ACTIONS(3020),
    [anon_sym_u_SQUOTE] = ACTIONS(3020),
    [anon_sym_U_SQUOTE] = ACTIONS(3020),
    [anon_sym_u8_SQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3020),
    [anon_sym_L_DQUOTE] = ACTIONS(3020),
    [anon_sym_u_DQUOTE] = ACTIONS(3020),
    [anon_sym_U_DQUOTE] = ACTIONS(3020),
    [anon_sym_u8_DQUOTE] = ACTIONS(3020),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [sym_true] = ACTIONS(3022),
    [sym_false] = ACTIONS(3022),
    [anon_sym_NULL] = ACTIONS(3022),
    [anon_sym_nullptr] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3022),
    [anon_sym_let] = ACTIONS(3022),
    [anon_sym_This] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3022),
    [anon_sym_final] = ACTIONS(3022),
    [anon_sym_override] = ACTIONS(3022),
    [anon_sym_explicit] = ACTIONS(3022),
    [anon_sym_typename] = ACTIONS(3022),
    [anon_sym_export] = ACTIONS(3022),
    [anon_sym_module] = ACTIONS(3022),
    [anon_sym_import] = ACTIONS(3022),
    [anon_sym_template] = ACTIONS(3022),
    [anon_sym_GT2] = ACTIONS(3020),
    [anon_sym_operator] = ACTIONS(3022),
    [anon_sym_try] = ACTIONS(3022),
    [anon_sym_delete] = ACTIONS(3022),
    [anon_sym_throw] = ACTIONS(3022),
    [anon_sym_namespace] = ACTIONS(3022),
    [anon_sym_static_assert] = ACTIONS(3022),
    [anon_sym_concept] = ACTIONS(3022),
    [anon_sym_co_return] = ACTIONS(3022),
    [anon_sym_co_yield] = ACTIONS(3022),
    [anon_sym_R_DQUOTE] = ACTIONS(3020),
    [anon_sym_LR_DQUOTE] = ACTIONS(3020),
    [anon_sym_uR_DQUOTE] = ACTIONS(3020),
    [anon_sym_UR_DQUOTE] = ACTIONS(3020),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3020),
    [anon_sym_co_await] = ACTIONS(3022),
    [anon_sym_new] = ACTIONS(3022),
    [anon_sym_requires] = ACTIONS(3022),
    [sym_this] = ACTIONS(3022),
    [anon_sym_precise] = ACTIONS(3022),
    [anon_sym_shared] = ACTIONS(3022),
    [anon_sym_groupshared] = ACTIONS(3022),
    [anon_sym_uniform] = ACTIONS(3022),
    [anon_sym_row_major] = ACTIONS(3022),
    [anon_sym_column_major] = ACTIONS(3022),
    [anon_sym_globallycoherent] = ACTIONS(3022),
    [anon_sym_centroid] = ACTIONS(3022),
    [anon_sym_noperspective] = ACTIONS(3022),
    [anon_sym_nointerpolation] = ACTIONS(3022),
    [anon_sym_sample] = ACTIONS(3022),
    [anon_sym_linear] = ACTIONS(3022),
    [anon_sym_snorm] = ACTIONS(3022),
    [anon_sym_unorm] = ACTIONS(3022),
    [anon_sym_point] = ACTIONS(3022),
    [anon_sym_line] = ACTIONS(3022),
    [anon_sym_triangleadj] = ACTIONS(3022),
    [anon_sym_lineadj] = ACTIONS(3022),
    [anon_sym_triangle] = ACTIONS(3022),
    [anon_sym_interface] = ACTIONS(3022),
    [anon_sym_extension] = ACTIONS(3022),
    [anon_sym_where] = ACTIONS(3022),
    [anon_sym___exported] = ACTIONS(3022),
  },
  [318] = {
    [ts_builtin_sym_end] = ACTIONS(3024),
    [sym_identifier] = ACTIONS(3026),
    [aux_sym_preproc_include_token1] = ACTIONS(3026),
    [aux_sym_preproc_def_token1] = ACTIONS(3026),
    [anon_sym_COMMA] = ACTIONS(3024),
    [anon_sym_RPAREN] = ACTIONS(3024),
    [aux_sym_preproc_if_token1] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3026),
    [sym_preproc_directive] = ACTIONS(3026),
    [anon_sym_LPAREN2] = ACTIONS(3024),
    [anon_sym_BANG] = ACTIONS(3024),
    [anon_sym_TILDE] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3026),
    [anon_sym_PLUS] = ACTIONS(3026),
    [anon_sym_STAR] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_AMP] = ACTIONS(3026),
    [anon_sym_SEMI] = ACTIONS(3024),
    [anon_sym___extension__] = ACTIONS(3026),
    [anon_sym_typedef] = ACTIONS(3026),
    [anon_sym_in] = ACTIONS(3026),
    [anon_sym_out] = ACTIONS(3026),
    [anon_sym_inout] = ACTIONS(3026),
    [anon_sym_virtual] = ACTIONS(3026),
    [anon_sym_extern] = ACTIONS(3026),
    [anon_sym___attribute__] = ACTIONS(3026),
    [anon_sym___attribute] = ACTIONS(3026),
    [anon_sym_using] = ACTIONS(3026),
    [anon_sym_COLON_COLON] = ACTIONS(3024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3024),
    [anon_sym___declspec] = ACTIONS(3026),
    [anon_sym___based] = ACTIONS(3026),
    [anon_sym___cdecl] = ACTIONS(3026),
    [anon_sym___clrcall] = ACTIONS(3026),
    [anon_sym___stdcall] = ACTIONS(3026),
    [anon_sym___fastcall] = ACTIONS(3026),
    [anon_sym___thiscall] = ACTIONS(3026),
    [anon_sym___vectorcall] = ACTIONS(3026),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_signed] = ACTIONS(3026),
    [anon_sym_unsigned] = ACTIONS(3026),
    [anon_sym_long] = ACTIONS(3026),
    [anon_sym_short] = ACTIONS(3026),
    [anon_sym_LBRACK] = ACTIONS(3026),
    [anon_sym_static] = ACTIONS(3026),
    [anon_sym_register] = ACTIONS(3026),
    [anon_sym_inline] = ACTIONS(3026),
    [anon_sym___inline] = ACTIONS(3026),
    [anon_sym___inline__] = ACTIONS(3026),
    [anon_sym___forceinline] = ACTIONS(3026),
    [anon_sym_thread_local] = ACTIONS(3026),
    [anon_sym___thread] = ACTIONS(3026),
    [anon_sym_const] = ACTIONS(3026),
    [anon_sym_constexpr] = ACTIONS(3026),
    [anon_sym_volatile] = ACTIONS(3026),
    [anon_sym_restrict] = ACTIONS(3026),
    [anon_sym___restrict__] = ACTIONS(3026),
    [anon_sym__Atomic] = ACTIONS(3026),
    [anon_sym__Noreturn] = ACTIONS(3026),
    [anon_sym_noreturn] = ACTIONS(3026),
    [anon_sym__Nonnull] = ACTIONS(3026),
    [anon_sym_mutable] = ACTIONS(3026),
    [anon_sym_constinit] = ACTIONS(3026),
    [anon_sym_consteval] = ACTIONS(3026),
    [anon_sym_alignas] = ACTIONS(3026),
    [anon_sym__Alignas] = ACTIONS(3026),
    [sym_primitive_type] = ACTIONS(3026),
    [anon_sym_enum] = ACTIONS(3026),
    [anon_sym_class] = ACTIONS(3026),
    [anon_sym_struct] = ACTIONS(3026),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_if] = ACTIONS(3026),
    [anon_sym_switch] = ACTIONS(3026),
    [anon_sym_case] = ACTIONS(3026),
    [anon_sym_default] = ACTIONS(3026),
    [anon_sym_while] = ACTIONS(3026),
    [anon_sym_do] = ACTIONS(3026),
    [anon_sym_for] = ACTIONS(3026),
    [anon_sym_return] = ACTIONS(3026),
    [anon_sym_break] = ACTIONS(3026),
    [anon_sym_continue] = ACTIONS(3026),
    [anon_sym_goto] = ACTIONS(3026),
    [anon_sym_not] = ACTIONS(3026),
    [anon_sym_compl] = ACTIONS(3026),
    [anon_sym_DASH_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_PLUS] = ACTIONS(3024),
    [anon_sym_sizeof] = ACTIONS(3026),
    [anon_sym___alignof__] = ACTIONS(3026),
    [anon_sym___alignof] = ACTIONS(3026),
    [anon_sym__alignof] = ACTIONS(3026),
    [anon_sym_alignof] = ACTIONS(3026),
    [anon_sym__Alignof] = ACTIONS(3026),
    [anon_sym_offsetof] = ACTIONS(3026),
    [anon_sym__Generic] = ACTIONS(3026),
    [anon_sym_asm] = ACTIONS(3026),
    [anon_sym___asm__] = ACTIONS(3026),
    [anon_sym___asm] = ACTIONS(3026),
    [anon_sym_DOT] = ACTIONS(3026),
    [sym_number_literal] = ACTIONS(3024),
    [anon_sym_L_SQUOTE] = ACTIONS(3024),
    [anon_sym_u_SQUOTE] = ACTIONS(3024),
    [anon_sym_U_SQUOTE] = ACTIONS(3024),
    [anon_sym_u8_SQUOTE] = ACTIONS(3024),
    [anon_sym_SQUOTE] = ACTIONS(3024),
    [anon_sym_L_DQUOTE] = ACTIONS(3024),
    [anon_sym_u_DQUOTE] = ACTIONS(3024),
    [anon_sym_U_DQUOTE] = ACTIONS(3024),
    [anon_sym_u8_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [sym_true] = ACTIONS(3026),
    [sym_false] = ACTIONS(3026),
    [anon_sym_NULL] = ACTIONS(3026),
    [anon_sym_nullptr] = ACTIONS(3026),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3026),
    [anon_sym_let] = ACTIONS(3026),
    [anon_sym_This] = ACTIONS(3026),
    [anon_sym_decltype] = ACTIONS(3026),
    [anon_sym_final] = ACTIONS(3026),
    [anon_sym_override] = ACTIONS(3026),
    [anon_sym_explicit] = ACTIONS(3026),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_export] = ACTIONS(3026),
    [anon_sym_module] = ACTIONS(3026),
    [anon_sym_import] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(3026),
    [anon_sym_GT2] = ACTIONS(3024),
    [anon_sym_operator] = ACTIONS(3026),
    [anon_sym_try] = ACTIONS(3026),
    [anon_sym_delete] = ACTIONS(3026),
    [anon_sym_throw] = ACTIONS(3026),
    [anon_sym_namespace] = ACTIONS(3026),
    [anon_sym_static_assert] = ACTIONS(3026),
    [anon_sym_concept] = ACTIONS(3026),
    [anon_sym_co_return] = ACTIONS(3026),
    [anon_sym_co_yield] = ACTIONS(3026),
    [anon_sym_R_DQUOTE] = ACTIONS(3024),
    [anon_sym_LR_DQUOTE] = ACTIONS(3024),
    [anon_sym_uR_DQUOTE] = ACTIONS(3024),
    [anon_sym_UR_DQUOTE] = ACTIONS(3024),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3024),
    [anon_sym_co_await] = ACTIONS(3026),
    [anon_sym_new] = ACTIONS(3026),
    [anon_sym_requires] = ACTIONS(3026),
    [sym_this] = ACTIONS(3026),
    [anon_sym_precise] = ACTIONS(3026),
    [anon_sym_shared] = ACTIONS(3026),
    [anon_sym_groupshared] = ACTIONS(3026),
    [anon_sym_uniform] = ACTIONS(3026),
    [anon_sym_row_major] = ACTIONS(3026),
    [anon_sym_column_major] = ACTIONS(3026),
    [anon_sym_globallycoherent] = ACTIONS(3026),
    [anon_sym_centroid] = ACTIONS(3026),
    [anon_sym_noperspective] = ACTIONS(3026),
    [anon_sym_nointerpolation] = ACTIONS(3026),
    [anon_sym_sample] = ACTIONS(3026),
    [anon_sym_linear] = ACTIONS(3026),
    [anon_sym_snorm] = ACTIONS(3026),
    [anon_sym_unorm] = ACTIONS(3026),
    [anon_sym_point] = ACTIONS(3026),
    [anon_sym_line] = ACTIONS(3026),
    [anon_sym_triangleadj] = ACTIONS(3026),
    [anon_sym_lineadj] = ACTIONS(3026),
    [anon_sym_triangle] = ACTIONS(3026),
    [anon_sym_interface] = ACTIONS(3026),
    [anon_sym_extension] = ACTIONS(3026),
    [anon_sym_where] = ACTIONS(3026),
    [anon_sym___exported] = ACTIONS(3026),
  },
  [319] = {
    [ts_builtin_sym_end] = ACTIONS(3028),
    [sym_identifier] = ACTIONS(3030),
    [aux_sym_preproc_include_token1] = ACTIONS(3030),
    [aux_sym_preproc_def_token1] = ACTIONS(3030),
    [anon_sym_COMMA] = ACTIONS(3028),
    [anon_sym_RPAREN] = ACTIONS(3028),
    [aux_sym_preproc_if_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3030),
    [sym_preproc_directive] = ACTIONS(3030),
    [anon_sym_LPAREN2] = ACTIONS(3028),
    [anon_sym_BANG] = ACTIONS(3028),
    [anon_sym_TILDE] = ACTIONS(3028),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3028),
    [anon_sym_AMP_AMP] = ACTIONS(3028),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym___extension__] = ACTIONS(3030),
    [anon_sym_typedef] = ACTIONS(3030),
    [anon_sym_in] = ACTIONS(3030),
    [anon_sym_out] = ACTIONS(3030),
    [anon_sym_inout] = ACTIONS(3030),
    [anon_sym_virtual] = ACTIONS(3030),
    [anon_sym_extern] = ACTIONS(3030),
    [anon_sym___attribute__] = ACTIONS(3030),
    [anon_sym___attribute] = ACTIONS(3030),
    [anon_sym_using] = ACTIONS(3030),
    [anon_sym_COLON_COLON] = ACTIONS(3028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3028),
    [anon_sym___declspec] = ACTIONS(3030),
    [anon_sym___based] = ACTIONS(3030),
    [anon_sym___cdecl] = ACTIONS(3030),
    [anon_sym___clrcall] = ACTIONS(3030),
    [anon_sym___stdcall] = ACTIONS(3030),
    [anon_sym___fastcall] = ACTIONS(3030),
    [anon_sym___thiscall] = ACTIONS(3030),
    [anon_sym___vectorcall] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3028),
    [anon_sym_signed] = ACTIONS(3030),
    [anon_sym_unsigned] = ACTIONS(3030),
    [anon_sym_long] = ACTIONS(3030),
    [anon_sym_short] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_register] = ACTIONS(3030),
    [anon_sym_inline] = ACTIONS(3030),
    [anon_sym___inline] = ACTIONS(3030),
    [anon_sym___inline__] = ACTIONS(3030),
    [anon_sym___forceinline] = ACTIONS(3030),
    [anon_sym_thread_local] = ACTIONS(3030),
    [anon_sym___thread] = ACTIONS(3030),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_constexpr] = ACTIONS(3030),
    [anon_sym_volatile] = ACTIONS(3030),
    [anon_sym_restrict] = ACTIONS(3030),
    [anon_sym___restrict__] = ACTIONS(3030),
    [anon_sym__Atomic] = ACTIONS(3030),
    [anon_sym__Noreturn] = ACTIONS(3030),
    [anon_sym_noreturn] = ACTIONS(3030),
    [anon_sym__Nonnull] = ACTIONS(3030),
    [anon_sym_mutable] = ACTIONS(3030),
    [anon_sym_constinit] = ACTIONS(3030),
    [anon_sym_consteval] = ACTIONS(3030),
    [anon_sym_alignas] = ACTIONS(3030),
    [anon_sym__Alignas] = ACTIONS(3030),
    [sym_primitive_type] = ACTIONS(3030),
    [anon_sym_enum] = ACTIONS(3030),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_struct] = ACTIONS(3030),
    [anon_sym_union] = ACTIONS(3030),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_switch] = ACTIONS(3030),
    [anon_sym_case] = ACTIONS(3030),
    [anon_sym_default] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3030),
    [anon_sym_break] = ACTIONS(3030),
    [anon_sym_continue] = ACTIONS(3030),
    [anon_sym_goto] = ACTIONS(3030),
    [anon_sym_not] = ACTIONS(3030),
    [anon_sym_compl] = ACTIONS(3030),
    [anon_sym_DASH_DASH] = ACTIONS(3028),
    [anon_sym_PLUS_PLUS] = ACTIONS(3028),
    [anon_sym_sizeof] = ACTIONS(3030),
    [anon_sym___alignof__] = ACTIONS(3030),
    [anon_sym___alignof] = ACTIONS(3030),
    [anon_sym__alignof] = ACTIONS(3030),
    [anon_sym_alignof] = ACTIONS(3030),
    [anon_sym__Alignof] = ACTIONS(3030),
    [anon_sym_offsetof] = ACTIONS(3030),
    [anon_sym__Generic] = ACTIONS(3030),
    [anon_sym_asm] = ACTIONS(3030),
    [anon_sym___asm__] = ACTIONS(3030),
    [anon_sym___asm] = ACTIONS(3030),
    [anon_sym_DOT] = ACTIONS(3030),
    [sym_number_literal] = ACTIONS(3028),
    [anon_sym_L_SQUOTE] = ACTIONS(3028),
    [anon_sym_u_SQUOTE] = ACTIONS(3028),
    [anon_sym_U_SQUOTE] = ACTIONS(3028),
    [anon_sym_u8_SQUOTE] = ACTIONS(3028),
    [anon_sym_SQUOTE] = ACTIONS(3028),
    [anon_sym_L_DQUOTE] = ACTIONS(3028),
    [anon_sym_u_DQUOTE] = ACTIONS(3028),
    [anon_sym_U_DQUOTE] = ACTIONS(3028),
    [anon_sym_u8_DQUOTE] = ACTIONS(3028),
    [anon_sym_DQUOTE] = ACTIONS(3028),
    [sym_true] = ACTIONS(3030),
    [sym_false] = ACTIONS(3030),
    [anon_sym_NULL] = ACTIONS(3030),
    [anon_sym_nullptr] = ACTIONS(3030),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3030),
    [anon_sym_let] = ACTIONS(3030),
    [anon_sym_This] = ACTIONS(3030),
    [anon_sym_decltype] = ACTIONS(3030),
    [anon_sym_final] = ACTIONS(3030),
    [anon_sym_override] = ACTIONS(3030),
    [anon_sym_explicit] = ACTIONS(3030),
    [anon_sym_typename] = ACTIONS(3030),
    [anon_sym_export] = ACTIONS(3030),
    [anon_sym_module] = ACTIONS(3030),
    [anon_sym_import] = ACTIONS(3030),
    [anon_sym_template] = ACTIONS(3030),
    [anon_sym_GT2] = ACTIONS(3028),
    [anon_sym_operator] = ACTIONS(3030),
    [anon_sym_try] = ACTIONS(3030),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_throw] = ACTIONS(3030),
    [anon_sym_namespace] = ACTIONS(3030),
    [anon_sym_static_assert] = ACTIONS(3030),
    [anon_sym_concept] = ACTIONS(3030),
    [anon_sym_co_return] = ACTIONS(3030),
    [anon_sym_co_yield] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3028),
    [anon_sym_LR_DQUOTE] = ACTIONS(3028),
    [anon_sym_uR_DQUOTE] = ACTIONS(3028),
    [anon_sym_UR_DQUOTE] = ACTIONS(3028),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3028),
    [anon_sym_co_await] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3030),
    [anon_sym_requires] = ACTIONS(3030),
    [sym_this] = ACTIONS(3030),
    [anon_sym_precise] = ACTIONS(3030),
    [anon_sym_shared] = ACTIONS(3030),
    [anon_sym_groupshared] = ACTIONS(3030),
    [anon_sym_uniform] = ACTIONS(3030),
    [anon_sym_row_major] = ACTIONS(3030),
    [anon_sym_column_major] = ACTIONS(3030),
    [anon_sym_globallycoherent] = ACTIONS(3030),
    [anon_sym_centroid] = ACTIONS(3030),
    [anon_sym_noperspective] = ACTIONS(3030),
    [anon_sym_nointerpolation] = ACTIONS(3030),
    [anon_sym_sample] = ACTIONS(3030),
    [anon_sym_linear] = ACTIONS(3030),
    [anon_sym_snorm] = ACTIONS(3030),
    [anon_sym_unorm] = ACTIONS(3030),
    [anon_sym_point] = ACTIONS(3030),
    [anon_sym_line] = ACTIONS(3030),
    [anon_sym_triangleadj] = ACTIONS(3030),
    [anon_sym_lineadj] = ACTIONS(3030),
    [anon_sym_triangle] = ACTIONS(3030),
    [anon_sym_interface] = ACTIONS(3030),
    [anon_sym_extension] = ACTIONS(3030),
    [anon_sym_where] = ACTIONS(3030),
    [anon_sym___exported] = ACTIONS(3030),
  },
  [320] = {
    [ts_builtin_sym_end] = ACTIONS(3032),
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_include_token1] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [anon_sym_COMMA] = ACTIONS(3032),
    [anon_sym_RPAREN] = ACTIONS(3032),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3032),
    [anon_sym_BANG] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_virtual] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym___attribute] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3032),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym___cdecl] = ACTIONS(3034),
    [anon_sym___clrcall] = ACTIONS(3034),
    [anon_sym___stdcall] = ACTIONS(3034),
    [anon_sym___fastcall] = ACTIONS(3034),
    [anon_sym___thiscall] = ACTIONS(3034),
    [anon_sym___vectorcall] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym__Nonnull] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_case] = ACTIONS(3034),
    [anon_sym_default] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3034),
    [anon_sym_not] = ACTIONS(3034),
    [anon_sym_compl] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_PLUS] = ACTIONS(3032),
    [anon_sym_sizeof] = ACTIONS(3034),
    [anon_sym___alignof__] = ACTIONS(3034),
    [anon_sym___alignof] = ACTIONS(3034),
    [anon_sym__alignof] = ACTIONS(3034),
    [anon_sym_alignof] = ACTIONS(3034),
    [anon_sym__Alignof] = ACTIONS(3034),
    [anon_sym_offsetof] = ACTIONS(3034),
    [anon_sym__Generic] = ACTIONS(3034),
    [anon_sym_asm] = ACTIONS(3034),
    [anon_sym___asm__] = ACTIONS(3034),
    [anon_sym___asm] = ACTIONS(3034),
    [anon_sym_DOT] = ACTIONS(3034),
    [sym_number_literal] = ACTIONS(3032),
    [anon_sym_L_SQUOTE] = ACTIONS(3032),
    [anon_sym_u_SQUOTE] = ACTIONS(3032),
    [anon_sym_U_SQUOTE] = ACTIONS(3032),
    [anon_sym_u8_SQUOTE] = ACTIONS(3032),
    [anon_sym_SQUOTE] = ACTIONS(3032),
    [anon_sym_L_DQUOTE] = ACTIONS(3032),
    [anon_sym_u_DQUOTE] = ACTIONS(3032),
    [anon_sym_U_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [anon_sym_NULL] = ACTIONS(3034),
    [anon_sym_nullptr] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [anon_sym_final] = ACTIONS(3034),
    [anon_sym_override] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_export] = ACTIONS(3034),
    [anon_sym_module] = ACTIONS(3034),
    [anon_sym_import] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_GT2] = ACTIONS(3032),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_try] = ACTIONS(3034),
    [anon_sym_delete] = ACTIONS(3034),
    [anon_sym_throw] = ACTIONS(3034),
    [anon_sym_namespace] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_concept] = ACTIONS(3034),
    [anon_sym_co_return] = ACTIONS(3034),
    [anon_sym_co_yield] = ACTIONS(3034),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3034),
    [anon_sym_requires] = ACTIONS(3034),
    [sym_this] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
    [anon_sym_where] = ACTIONS(3034),
    [anon_sym___exported] = ACTIONS(3034),
  },
  [321] = {
    [ts_builtin_sym_end] = ACTIONS(3036),
    [sym_identifier] = ACTIONS(3038),
    [aux_sym_preproc_include_token1] = ACTIONS(3038),
    [aux_sym_preproc_def_token1] = ACTIONS(3038),
    [anon_sym_COMMA] = ACTIONS(3036),
    [anon_sym_RPAREN] = ACTIONS(3036),
    [aux_sym_preproc_if_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3038),
    [sym_preproc_directive] = ACTIONS(3038),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3038),
    [anon_sym_typedef] = ACTIONS(3038),
    [anon_sym_in] = ACTIONS(3038),
    [anon_sym_out] = ACTIONS(3038),
    [anon_sym_inout] = ACTIONS(3038),
    [anon_sym_virtual] = ACTIONS(3038),
    [anon_sym_extern] = ACTIONS(3038),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym___attribute] = ACTIONS(3038),
    [anon_sym_using] = ACTIONS(3038),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3038),
    [anon_sym___based] = ACTIONS(3038),
    [anon_sym___cdecl] = ACTIONS(3038),
    [anon_sym___clrcall] = ACTIONS(3038),
    [anon_sym___stdcall] = ACTIONS(3038),
    [anon_sym___fastcall] = ACTIONS(3038),
    [anon_sym___thiscall] = ACTIONS(3038),
    [anon_sym___vectorcall] = ACTIONS(3038),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3038),
    [anon_sym_unsigned] = ACTIONS(3038),
    [anon_sym_long] = ACTIONS(3038),
    [anon_sym_short] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_register] = ACTIONS(3038),
    [anon_sym_inline] = ACTIONS(3038),
    [anon_sym___inline] = ACTIONS(3038),
    [anon_sym___inline__] = ACTIONS(3038),
    [anon_sym___forceinline] = ACTIONS(3038),
    [anon_sym_thread_local] = ACTIONS(3038),
    [anon_sym___thread] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_constexpr] = ACTIONS(3038),
    [anon_sym_volatile] = ACTIONS(3038),
    [anon_sym_restrict] = ACTIONS(3038),
    [anon_sym___restrict__] = ACTIONS(3038),
    [anon_sym__Atomic] = ACTIONS(3038),
    [anon_sym__Noreturn] = ACTIONS(3038),
    [anon_sym_noreturn] = ACTIONS(3038),
    [anon_sym__Nonnull] = ACTIONS(3038),
    [anon_sym_mutable] = ACTIONS(3038),
    [anon_sym_constinit] = ACTIONS(3038),
    [anon_sym_consteval] = ACTIONS(3038),
    [anon_sym_alignas] = ACTIONS(3038),
    [anon_sym__Alignas] = ACTIONS(3038),
    [sym_primitive_type] = ACTIONS(3038),
    [anon_sym_enum] = ACTIONS(3038),
    [anon_sym_class] = ACTIONS(3038),
    [anon_sym_struct] = ACTIONS(3038),
    [anon_sym_union] = ACTIONS(3038),
    [anon_sym_if] = ACTIONS(3038),
    [anon_sym_switch] = ACTIONS(3038),
    [anon_sym_case] = ACTIONS(3038),
    [anon_sym_default] = ACTIONS(3038),
    [anon_sym_while] = ACTIONS(3038),
    [anon_sym_do] = ACTIONS(3038),
    [anon_sym_for] = ACTIONS(3038),
    [anon_sym_return] = ACTIONS(3038),
    [anon_sym_break] = ACTIONS(3038),
    [anon_sym_continue] = ACTIONS(3038),
    [anon_sym_goto] = ACTIONS(3038),
    [anon_sym_not] = ACTIONS(3038),
    [anon_sym_compl] = ACTIONS(3038),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_sizeof] = ACTIONS(3038),
    [anon_sym___alignof__] = ACTIONS(3038),
    [anon_sym___alignof] = ACTIONS(3038),
    [anon_sym__alignof] = ACTIONS(3038),
    [anon_sym_alignof] = ACTIONS(3038),
    [anon_sym__Alignof] = ACTIONS(3038),
    [anon_sym_offsetof] = ACTIONS(3038),
    [anon_sym__Generic] = ACTIONS(3038),
    [anon_sym_asm] = ACTIONS(3038),
    [anon_sym___asm__] = ACTIONS(3038),
    [anon_sym___asm] = ACTIONS(3038),
    [anon_sym_DOT] = ACTIONS(3038),
    [sym_number_literal] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3036),
    [anon_sym_u_SQUOTE] = ACTIONS(3036),
    [anon_sym_U_SQUOTE] = ACTIONS(3036),
    [anon_sym_u8_SQUOTE] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3036),
    [anon_sym_L_DQUOTE] = ACTIONS(3036),
    [anon_sym_u_DQUOTE] = ACTIONS(3036),
    [anon_sym_U_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8_DQUOTE] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [sym_true] = ACTIONS(3038),
    [sym_false] = ACTIONS(3038),
    [anon_sym_NULL] = ACTIONS(3038),
    [anon_sym_nullptr] = ACTIONS(3038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3038),
    [anon_sym_let] = ACTIONS(3038),
    [anon_sym_This] = ACTIONS(3038),
    [anon_sym_decltype] = ACTIONS(3038),
    [anon_sym_final] = ACTIONS(3038),
    [anon_sym_override] = ACTIONS(3038),
    [anon_sym_explicit] = ACTIONS(3038),
    [anon_sym_typename] = ACTIONS(3038),
    [anon_sym_export] = ACTIONS(3038),
    [anon_sym_module] = ACTIONS(3038),
    [anon_sym_import] = ACTIONS(3038),
    [anon_sym_template] = ACTIONS(3038),
    [anon_sym_GT2] = ACTIONS(3036),
    [anon_sym_operator] = ACTIONS(3038),
    [anon_sym_try] = ACTIONS(3038),
    [anon_sym_delete] = ACTIONS(3038),
    [anon_sym_throw] = ACTIONS(3038),
    [anon_sym_namespace] = ACTIONS(3038),
    [anon_sym_static_assert] = ACTIONS(3038),
    [anon_sym_concept] = ACTIONS(3038),
    [anon_sym_co_return] = ACTIONS(3038),
    [anon_sym_co_yield] = ACTIONS(3038),
    [anon_sym_R_DQUOTE] = ACTIONS(3036),
    [anon_sym_LR_DQUOTE] = ACTIONS(3036),
    [anon_sym_uR_DQUOTE] = ACTIONS(3036),
    [anon_sym_UR_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3036),
    [anon_sym_co_await] = ACTIONS(3038),
    [anon_sym_new] = ACTIONS(3038),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3038),
    [anon_sym_precise] = ACTIONS(3038),
    [anon_sym_shared] = ACTIONS(3038),
    [anon_sym_groupshared] = ACTIONS(3038),
    [anon_sym_uniform] = ACTIONS(3038),
    [anon_sym_row_major] = ACTIONS(3038),
    [anon_sym_column_major] = ACTIONS(3038),
    [anon_sym_globallycoherent] = ACTIONS(3038),
    [anon_sym_centroid] = ACTIONS(3038),
    [anon_sym_noperspective] = ACTIONS(3038),
    [anon_sym_nointerpolation] = ACTIONS(3038),
    [anon_sym_sample] = ACTIONS(3038),
    [anon_sym_linear] = ACTIONS(3038),
    [anon_sym_snorm] = ACTIONS(3038),
    [anon_sym_unorm] = ACTIONS(3038),
    [anon_sym_point] = ACTIONS(3038),
    [anon_sym_line] = ACTIONS(3038),
    [anon_sym_triangleadj] = ACTIONS(3038),
    [anon_sym_lineadj] = ACTIONS(3038),
    [anon_sym_triangle] = ACTIONS(3038),
    [anon_sym_interface] = ACTIONS(3038),
    [anon_sym_extension] = ACTIONS(3038),
    [anon_sym_where] = ACTIONS(3038),
    [anon_sym___exported] = ACTIONS(3038),
  },
  [322] = {
    [ts_builtin_sym_end] = ACTIONS(3040),
    [sym_identifier] = ACTIONS(3042),
    [aux_sym_preproc_include_token1] = ACTIONS(3042),
    [aux_sym_preproc_def_token1] = ACTIONS(3042),
    [anon_sym_COMMA] = ACTIONS(3040),
    [anon_sym_RPAREN] = ACTIONS(3040),
    [aux_sym_preproc_if_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3042),
    [sym_preproc_directive] = ACTIONS(3042),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym_typedef] = ACTIONS(3042),
    [anon_sym_in] = ACTIONS(3042),
    [anon_sym_out] = ACTIONS(3042),
    [anon_sym_inout] = ACTIONS(3042),
    [anon_sym_virtual] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_using] = ACTIONS(3042),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym___cdecl] = ACTIONS(3042),
    [anon_sym___clrcall] = ACTIONS(3042),
    [anon_sym___stdcall] = ACTIONS(3042),
    [anon_sym___fastcall] = ACTIONS(3042),
    [anon_sym___thiscall] = ACTIONS(3042),
    [anon_sym___vectorcall] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym___inline] = ACTIONS(3042),
    [anon_sym___inline__] = ACTIONS(3042),
    [anon_sym___forceinline] = ACTIONS(3042),
    [anon_sym_thread_local] = ACTIONS(3042),
    [anon_sym___thread] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_enum] = ACTIONS(3042),
    [anon_sym_class] = ACTIONS(3042),
    [anon_sym_struct] = ACTIONS(3042),
    [anon_sym_union] = ACTIONS(3042),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_switch] = ACTIONS(3042),
    [anon_sym_case] = ACTIONS(3042),
    [anon_sym_default] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_for] = ACTIONS(3042),
    [anon_sym_return] = ACTIONS(3042),
    [anon_sym_break] = ACTIONS(3042),
    [anon_sym_continue] = ACTIONS(3042),
    [anon_sym_goto] = ACTIONS(3042),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_compl] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_sizeof] = ACTIONS(3042),
    [anon_sym___alignof__] = ACTIONS(3042),
    [anon_sym___alignof] = ACTIONS(3042),
    [anon_sym__alignof] = ACTIONS(3042),
    [anon_sym_alignof] = ACTIONS(3042),
    [anon_sym__Alignof] = ACTIONS(3042),
    [anon_sym_offsetof] = ACTIONS(3042),
    [anon_sym__Generic] = ACTIONS(3042),
    [anon_sym_asm] = ACTIONS(3042),
    [anon_sym___asm__] = ACTIONS(3042),
    [anon_sym___asm] = ACTIONS(3042),
    [anon_sym_DOT] = ACTIONS(3042),
    [sym_number_literal] = ACTIONS(3040),
    [anon_sym_L_SQUOTE] = ACTIONS(3040),
    [anon_sym_u_SQUOTE] = ACTIONS(3040),
    [anon_sym_U_SQUOTE] = ACTIONS(3040),
    [anon_sym_u8_SQUOTE] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(3040),
    [anon_sym_L_DQUOTE] = ACTIONS(3040),
    [anon_sym_u_DQUOTE] = ACTIONS(3040),
    [anon_sym_U_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8_DQUOTE] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [sym_true] = ACTIONS(3042),
    [sym_false] = ACTIONS(3042),
    [anon_sym_NULL] = ACTIONS(3042),
    [anon_sym_nullptr] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3042),
    [anon_sym_let] = ACTIONS(3042),
    [anon_sym_This] = ACTIONS(3042),
    [anon_sym_decltype] = ACTIONS(3042),
    [anon_sym_final] = ACTIONS(3042),
    [anon_sym_override] = ACTIONS(3042),
    [anon_sym_explicit] = ACTIONS(3042),
    [anon_sym_typename] = ACTIONS(3042),
    [anon_sym_export] = ACTIONS(3042),
    [anon_sym_module] = ACTIONS(3042),
    [anon_sym_import] = ACTIONS(3042),
    [anon_sym_template] = ACTIONS(3042),
    [anon_sym_GT2] = ACTIONS(3040),
    [anon_sym_operator] = ACTIONS(3042),
    [anon_sym_try] = ACTIONS(3042),
    [anon_sym_delete] = ACTIONS(3042),
    [anon_sym_throw] = ACTIONS(3042),
    [anon_sym_namespace] = ACTIONS(3042),
    [anon_sym_static_assert] = ACTIONS(3042),
    [anon_sym_concept] = ACTIONS(3042),
    [anon_sym_co_return] = ACTIONS(3042),
    [anon_sym_co_yield] = ACTIONS(3042),
    [anon_sym_R_DQUOTE] = ACTIONS(3040),
    [anon_sym_LR_DQUOTE] = ACTIONS(3040),
    [anon_sym_uR_DQUOTE] = ACTIONS(3040),
    [anon_sym_UR_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3040),
    [anon_sym_co_await] = ACTIONS(3042),
    [anon_sym_new] = ACTIONS(3042),
    [anon_sym_requires] = ACTIONS(3042),
    [sym_this] = ACTIONS(3042),
    [anon_sym_precise] = ACTIONS(3042),
    [anon_sym_shared] = ACTIONS(3042),
    [anon_sym_groupshared] = ACTIONS(3042),
    [anon_sym_uniform] = ACTIONS(3042),
    [anon_sym_row_major] = ACTIONS(3042),
    [anon_sym_column_major] = ACTIONS(3042),
    [anon_sym_globallycoherent] = ACTIONS(3042),
    [anon_sym_centroid] = ACTIONS(3042),
    [anon_sym_noperspective] = ACTIONS(3042),
    [anon_sym_nointerpolation] = ACTIONS(3042),
    [anon_sym_sample] = ACTIONS(3042),
    [anon_sym_linear] = ACTIONS(3042),
    [anon_sym_snorm] = ACTIONS(3042),
    [anon_sym_unorm] = ACTIONS(3042),
    [anon_sym_point] = ACTIONS(3042),
    [anon_sym_line] = ACTIONS(3042),
    [anon_sym_triangleadj] = ACTIONS(3042),
    [anon_sym_lineadj] = ACTIONS(3042),
    [anon_sym_triangle] = ACTIONS(3042),
    [anon_sym_interface] = ACTIONS(3042),
    [anon_sym_extension] = ACTIONS(3042),
    [anon_sym_where] = ACTIONS(3042),
    [anon_sym___exported] = ACTIONS(3042),
  },
  [323] = {
    [ts_builtin_sym_end] = ACTIONS(3044),
    [sym_identifier] = ACTIONS(3046),
    [aux_sym_preproc_include_token1] = ACTIONS(3046),
    [aux_sym_preproc_def_token1] = ACTIONS(3046),
    [anon_sym_COMMA] = ACTIONS(3044),
    [anon_sym_RPAREN] = ACTIONS(3044),
    [aux_sym_preproc_if_token1] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3046),
    [sym_preproc_directive] = ACTIONS(3046),
    [anon_sym_LPAREN2] = ACTIONS(3044),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3044),
    [anon_sym_DASH] = ACTIONS(3046),
    [anon_sym_PLUS] = ACTIONS(3046),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3046),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym___extension__] = ACTIONS(3046),
    [anon_sym_typedef] = ACTIONS(3046),
    [anon_sym_in] = ACTIONS(3046),
    [anon_sym_out] = ACTIONS(3046),
    [anon_sym_inout] = ACTIONS(3046),
    [anon_sym_virtual] = ACTIONS(3046),
    [anon_sym_extern] = ACTIONS(3046),
    [anon_sym___attribute__] = ACTIONS(3046),
    [anon_sym___attribute] = ACTIONS(3046),
    [anon_sym_using] = ACTIONS(3046),
    [anon_sym_COLON_COLON] = ACTIONS(3044),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3044),
    [anon_sym___declspec] = ACTIONS(3046),
    [anon_sym___based] = ACTIONS(3046),
    [anon_sym___cdecl] = ACTIONS(3046),
    [anon_sym___clrcall] = ACTIONS(3046),
    [anon_sym___stdcall] = ACTIONS(3046),
    [anon_sym___fastcall] = ACTIONS(3046),
    [anon_sym___thiscall] = ACTIONS(3046),
    [anon_sym___vectorcall] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3044),
    [anon_sym_signed] = ACTIONS(3046),
    [anon_sym_unsigned] = ACTIONS(3046),
    [anon_sym_long] = ACTIONS(3046),
    [anon_sym_short] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_static] = ACTIONS(3046),
    [anon_sym_register] = ACTIONS(3046),
    [anon_sym_inline] = ACTIONS(3046),
    [anon_sym___inline] = ACTIONS(3046),
    [anon_sym___inline__] = ACTIONS(3046),
    [anon_sym___forceinline] = ACTIONS(3046),
    [anon_sym_thread_local] = ACTIONS(3046),
    [anon_sym___thread] = ACTIONS(3046),
    [anon_sym_const] = ACTIONS(3046),
    [anon_sym_constexpr] = ACTIONS(3046),
    [anon_sym_volatile] = ACTIONS(3046),
    [anon_sym_restrict] = ACTIONS(3046),
    [anon_sym___restrict__] = ACTIONS(3046),
    [anon_sym__Atomic] = ACTIONS(3046),
    [anon_sym__Noreturn] = ACTIONS(3046),
    [anon_sym_noreturn] = ACTIONS(3046),
    [anon_sym__Nonnull] = ACTIONS(3046),
    [anon_sym_mutable] = ACTIONS(3046),
    [anon_sym_constinit] = ACTIONS(3046),
    [anon_sym_consteval] = ACTIONS(3046),
    [anon_sym_alignas] = ACTIONS(3046),
    [anon_sym__Alignas] = ACTIONS(3046),
    [sym_primitive_type] = ACTIONS(3046),
    [anon_sym_enum] = ACTIONS(3046),
    [anon_sym_class] = ACTIONS(3046),
    [anon_sym_struct] = ACTIONS(3046),
    [anon_sym_union] = ACTIONS(3046),
    [anon_sym_if] = ACTIONS(3046),
    [anon_sym_switch] = ACTIONS(3046),
    [anon_sym_case] = ACTIONS(3046),
    [anon_sym_default] = ACTIONS(3046),
    [anon_sym_while] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_for] = ACTIONS(3046),
    [anon_sym_return] = ACTIONS(3046),
    [anon_sym_break] = ACTIONS(3046),
    [anon_sym_continue] = ACTIONS(3046),
    [anon_sym_goto] = ACTIONS(3046),
    [anon_sym_not] = ACTIONS(3046),
    [anon_sym_compl] = ACTIONS(3046),
    [anon_sym_DASH_DASH] = ACTIONS(3044),
    [anon_sym_PLUS_PLUS] = ACTIONS(3044),
    [anon_sym_sizeof] = ACTIONS(3046),
    [anon_sym___alignof__] = ACTIONS(3046),
    [anon_sym___alignof] = ACTIONS(3046),
    [anon_sym__alignof] = ACTIONS(3046),
    [anon_sym_alignof] = ACTIONS(3046),
    [anon_sym__Alignof] = ACTIONS(3046),
    [anon_sym_offsetof] = ACTIONS(3046),
    [anon_sym__Generic] = ACTIONS(3046),
    [anon_sym_asm] = ACTIONS(3046),
    [anon_sym___asm__] = ACTIONS(3046),
    [anon_sym___asm] = ACTIONS(3046),
    [anon_sym_DOT] = ACTIONS(3046),
    [sym_number_literal] = ACTIONS(3044),
    [anon_sym_L_SQUOTE] = ACTIONS(3044),
    [anon_sym_u_SQUOTE] = ACTIONS(3044),
    [anon_sym_U_SQUOTE] = ACTIONS(3044),
    [anon_sym_u8_SQUOTE] = ACTIONS(3044),
    [anon_sym_SQUOTE] = ACTIONS(3044),
    [anon_sym_L_DQUOTE] = ACTIONS(3044),
    [anon_sym_u_DQUOTE] = ACTIONS(3044),
    [anon_sym_U_DQUOTE] = ACTIONS(3044),
    [anon_sym_u8_DQUOTE] = ACTIONS(3044),
    [anon_sym_DQUOTE] = ACTIONS(3044),
    [sym_true] = ACTIONS(3046),
    [sym_false] = ACTIONS(3046),
    [anon_sym_NULL] = ACTIONS(3046),
    [anon_sym_nullptr] = ACTIONS(3046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3046),
    [anon_sym_let] = ACTIONS(3046),
    [anon_sym_This] = ACTIONS(3046),
    [anon_sym_decltype] = ACTIONS(3046),
    [anon_sym_final] = ACTIONS(3046),
    [anon_sym_override] = ACTIONS(3046),
    [anon_sym_explicit] = ACTIONS(3046),
    [anon_sym_typename] = ACTIONS(3046),
    [anon_sym_export] = ACTIONS(3046),
    [anon_sym_module] = ACTIONS(3046),
    [anon_sym_import] = ACTIONS(3046),
    [anon_sym_template] = ACTIONS(3046),
    [anon_sym_GT2] = ACTIONS(3044),
    [anon_sym_operator] = ACTIONS(3046),
    [anon_sym_try] = ACTIONS(3046),
    [anon_sym_delete] = ACTIONS(3046),
    [anon_sym_throw] = ACTIONS(3046),
    [anon_sym_namespace] = ACTIONS(3046),
    [anon_sym_static_assert] = ACTIONS(3046),
    [anon_sym_concept] = ACTIONS(3046),
    [anon_sym_co_return] = ACTIONS(3046),
    [anon_sym_co_yield] = ACTIONS(3046),
    [anon_sym_R_DQUOTE] = ACTIONS(3044),
    [anon_sym_LR_DQUOTE] = ACTIONS(3044),
    [anon_sym_uR_DQUOTE] = ACTIONS(3044),
    [anon_sym_UR_DQUOTE] = ACTIONS(3044),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3044),
    [anon_sym_co_await] = ACTIONS(3046),
    [anon_sym_new] = ACTIONS(3046),
    [anon_sym_requires] = ACTIONS(3046),
    [sym_this] = ACTIONS(3046),
    [anon_sym_precise] = ACTIONS(3046),
    [anon_sym_shared] = ACTIONS(3046),
    [anon_sym_groupshared] = ACTIONS(3046),
    [anon_sym_uniform] = ACTIONS(3046),
    [anon_sym_row_major] = ACTIONS(3046),
    [anon_sym_column_major] = ACTIONS(3046),
    [anon_sym_globallycoherent] = ACTIONS(3046),
    [anon_sym_centroid] = ACTIONS(3046),
    [anon_sym_noperspective] = ACTIONS(3046),
    [anon_sym_nointerpolation] = ACTIONS(3046),
    [anon_sym_sample] = ACTIONS(3046),
    [anon_sym_linear] = ACTIONS(3046),
    [anon_sym_snorm] = ACTIONS(3046),
    [anon_sym_unorm] = ACTIONS(3046),
    [anon_sym_point] = ACTIONS(3046),
    [anon_sym_line] = ACTIONS(3046),
    [anon_sym_triangleadj] = ACTIONS(3046),
    [anon_sym_lineadj] = ACTIONS(3046),
    [anon_sym_triangle] = ACTIONS(3046),
    [anon_sym_interface] = ACTIONS(3046),
    [anon_sym_extension] = ACTIONS(3046),
    [anon_sym_where] = ACTIONS(3046),
    [anon_sym___exported] = ACTIONS(3046),
  },
  [324] = {
    [ts_builtin_sym_end] = ACTIONS(2881),
    [sym_identifier] = ACTIONS(2883),
    [aux_sym_preproc_include_token1] = ACTIONS(2883),
    [aux_sym_preproc_def_token1] = ACTIONS(2883),
    [anon_sym_COMMA] = ACTIONS(2881),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [aux_sym_preproc_if_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2883),
    [sym_preproc_directive] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_typedef] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_using] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2881),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_signed] = ACTIONS(2883),
    [anon_sym_unsigned] = ACTIONS(2883),
    [anon_sym_long] = ACTIONS(2883),
    [anon_sym_short] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [sym_primitive_type] = ACTIONS(2883),
    [anon_sym_enum] = ACTIONS(2883),
    [anon_sym_class] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2883),
    [anon_sym_union] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_switch] = ACTIONS(2883),
    [anon_sym_case] = ACTIONS(2883),
    [anon_sym_default] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_break] = ACTIONS(2883),
    [anon_sym_continue] = ACTIONS(2883),
    [anon_sym_goto] = ACTIONS(2883),
    [anon_sym_not] = ACTIONS(2883),
    [anon_sym_compl] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_sizeof] = ACTIONS(2883),
    [anon_sym___alignof__] = ACTIONS(2883),
    [anon_sym___alignof] = ACTIONS(2883),
    [anon_sym__alignof] = ACTIONS(2883),
    [anon_sym_alignof] = ACTIONS(2883),
    [anon_sym__Alignof] = ACTIONS(2883),
    [anon_sym_offsetof] = ACTIONS(2883),
    [anon_sym__Generic] = ACTIONS(2883),
    [anon_sym_asm] = ACTIONS(2883),
    [anon_sym___asm__] = ACTIONS(2883),
    [anon_sym___asm] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [sym_number_literal] = ACTIONS(2881),
    [anon_sym_L_SQUOTE] = ACTIONS(2881),
    [anon_sym_u_SQUOTE] = ACTIONS(2881),
    [anon_sym_U_SQUOTE] = ACTIONS(2881),
    [anon_sym_u8_SQUOTE] = ACTIONS(2881),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_L_DQUOTE] = ACTIONS(2881),
    [anon_sym_u_DQUOTE] = ACTIONS(2881),
    [anon_sym_U_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [sym_true] = ACTIONS(2883),
    [sym_false] = ACTIONS(2883),
    [anon_sym_NULL] = ACTIONS(2883),
    [anon_sym_nullptr] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_final] = ACTIONS(2883),
    [anon_sym_override] = ACTIONS(2883),
    [anon_sym_explicit] = ACTIONS(2883),
    [anon_sym_typename] = ACTIONS(2883),
    [anon_sym_export] = ACTIONS(2883),
    [anon_sym_module] = ACTIONS(2883),
    [anon_sym_import] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_GT2] = ACTIONS(2881),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_delete] = ACTIONS(2883),
    [anon_sym_throw] = ACTIONS(2883),
    [anon_sym_namespace] = ACTIONS(2883),
    [anon_sym_static_assert] = ACTIONS(2883),
    [anon_sym_concept] = ACTIONS(2883),
    [anon_sym_co_return] = ACTIONS(2883),
    [anon_sym_co_yield] = ACTIONS(2883),
    [anon_sym_R_DQUOTE] = ACTIONS(2881),
    [anon_sym_LR_DQUOTE] = ACTIONS(2881),
    [anon_sym_uR_DQUOTE] = ACTIONS(2881),
    [anon_sym_UR_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2881),
    [anon_sym_co_await] = ACTIONS(2883),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_requires] = ACTIONS(2883),
    [sym_this] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
    [anon_sym_interface] = ACTIONS(2883),
    [anon_sym_extension] = ACTIONS(2883),
    [anon_sym_where] = ACTIONS(2883),
    [anon_sym___exported] = ACTIONS(2883),
  },
  [325] = {
    [ts_builtin_sym_end] = ACTIONS(3048),
    [sym_identifier] = ACTIONS(3050),
    [aux_sym_preproc_include_token1] = ACTIONS(3050),
    [aux_sym_preproc_def_token1] = ACTIONS(3050),
    [anon_sym_COMMA] = ACTIONS(3048),
    [anon_sym_RPAREN] = ACTIONS(3048),
    [aux_sym_preproc_if_token1] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3050),
    [sym_preproc_directive] = ACTIONS(3050),
    [anon_sym_LPAREN2] = ACTIONS(3048),
    [anon_sym_BANG] = ACTIONS(3048),
    [anon_sym_TILDE] = ACTIONS(3048),
    [anon_sym_DASH] = ACTIONS(3050),
    [anon_sym_PLUS] = ACTIONS(3050),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_AMP_AMP] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3050),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym___extension__] = ACTIONS(3050),
    [anon_sym_typedef] = ACTIONS(3050),
    [anon_sym_in] = ACTIONS(3050),
    [anon_sym_out] = ACTIONS(3050),
    [anon_sym_inout] = ACTIONS(3050),
    [anon_sym_virtual] = ACTIONS(3050),
    [anon_sym_extern] = ACTIONS(3050),
    [anon_sym___attribute__] = ACTIONS(3050),
    [anon_sym___attribute] = ACTIONS(3050),
    [anon_sym_using] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3048),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3048),
    [anon_sym___declspec] = ACTIONS(3050),
    [anon_sym___based] = ACTIONS(3050),
    [anon_sym___cdecl] = ACTIONS(3050),
    [anon_sym___clrcall] = ACTIONS(3050),
    [anon_sym___stdcall] = ACTIONS(3050),
    [anon_sym___fastcall] = ACTIONS(3050),
    [anon_sym___thiscall] = ACTIONS(3050),
    [anon_sym___vectorcall] = ACTIONS(3050),
    [anon_sym_LBRACE] = ACTIONS(3048),
    [anon_sym_signed] = ACTIONS(3050),
    [anon_sym_unsigned] = ACTIONS(3050),
    [anon_sym_long] = ACTIONS(3050),
    [anon_sym_short] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_static] = ACTIONS(3050),
    [anon_sym_register] = ACTIONS(3050),
    [anon_sym_inline] = ACTIONS(3050),
    [anon_sym___inline] = ACTIONS(3050),
    [anon_sym___inline__] = ACTIONS(3050),
    [anon_sym___forceinline] = ACTIONS(3050),
    [anon_sym_thread_local] = ACTIONS(3050),
    [anon_sym___thread] = ACTIONS(3050),
    [anon_sym_const] = ACTIONS(3050),
    [anon_sym_constexpr] = ACTIONS(3050),
    [anon_sym_volatile] = ACTIONS(3050),
    [anon_sym_restrict] = ACTIONS(3050),
    [anon_sym___restrict__] = ACTIONS(3050),
    [anon_sym__Atomic] = ACTIONS(3050),
    [anon_sym__Noreturn] = ACTIONS(3050),
    [anon_sym_noreturn] = ACTIONS(3050),
    [anon_sym__Nonnull] = ACTIONS(3050),
    [anon_sym_mutable] = ACTIONS(3050),
    [anon_sym_constinit] = ACTIONS(3050),
    [anon_sym_consteval] = ACTIONS(3050),
    [anon_sym_alignas] = ACTIONS(3050),
    [anon_sym__Alignas] = ACTIONS(3050),
    [sym_primitive_type] = ACTIONS(3050),
    [anon_sym_enum] = ACTIONS(3050),
    [anon_sym_class] = ACTIONS(3050),
    [anon_sym_struct] = ACTIONS(3050),
    [anon_sym_union] = ACTIONS(3050),
    [anon_sym_if] = ACTIONS(3050),
    [anon_sym_switch] = ACTIONS(3050),
    [anon_sym_case] = ACTIONS(3050),
    [anon_sym_default] = ACTIONS(3050),
    [anon_sym_while] = ACTIONS(3050),
    [anon_sym_do] = ACTIONS(3050),
    [anon_sym_for] = ACTIONS(3050),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_break] = ACTIONS(3050),
    [anon_sym_continue] = ACTIONS(3050),
    [anon_sym_goto] = ACTIONS(3050),
    [anon_sym_not] = ACTIONS(3050),
    [anon_sym_compl] = ACTIONS(3050),
    [anon_sym_DASH_DASH] = ACTIONS(3048),
    [anon_sym_PLUS_PLUS] = ACTIONS(3048),
    [anon_sym_sizeof] = ACTIONS(3050),
    [anon_sym___alignof__] = ACTIONS(3050),
    [anon_sym___alignof] = ACTIONS(3050),
    [anon_sym__alignof] = ACTIONS(3050),
    [anon_sym_alignof] = ACTIONS(3050),
    [anon_sym__Alignof] = ACTIONS(3050),
    [anon_sym_offsetof] = ACTIONS(3050),
    [anon_sym__Generic] = ACTIONS(3050),
    [anon_sym_asm] = ACTIONS(3050),
    [anon_sym___asm__] = ACTIONS(3050),
    [anon_sym___asm] = ACTIONS(3050),
    [anon_sym_DOT] = ACTIONS(3050),
    [sym_number_literal] = ACTIONS(3048),
    [anon_sym_L_SQUOTE] = ACTIONS(3048),
    [anon_sym_u_SQUOTE] = ACTIONS(3048),
    [anon_sym_U_SQUOTE] = ACTIONS(3048),
    [anon_sym_u8_SQUOTE] = ACTIONS(3048),
    [anon_sym_SQUOTE] = ACTIONS(3048),
    [anon_sym_L_DQUOTE] = ACTIONS(3048),
    [anon_sym_u_DQUOTE] = ACTIONS(3048),
    [anon_sym_U_DQUOTE] = ACTIONS(3048),
    [anon_sym_u8_DQUOTE] = ACTIONS(3048),
    [anon_sym_DQUOTE] = ACTIONS(3048),
    [sym_true] = ACTIONS(3050),
    [sym_false] = ACTIONS(3050),
    [anon_sym_NULL] = ACTIONS(3050),
    [anon_sym_nullptr] = ACTIONS(3050),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3050),
    [anon_sym_let] = ACTIONS(3050),
    [anon_sym_This] = ACTIONS(3050),
    [anon_sym_decltype] = ACTIONS(3050),
    [anon_sym_final] = ACTIONS(3050),
    [anon_sym_override] = ACTIONS(3050),
    [anon_sym_explicit] = ACTIONS(3050),
    [anon_sym_typename] = ACTIONS(3050),
    [anon_sym_export] = ACTIONS(3050),
    [anon_sym_module] = ACTIONS(3050),
    [anon_sym_import] = ACTIONS(3050),
    [anon_sym_template] = ACTIONS(3050),
    [anon_sym_GT2] = ACTIONS(3048),
    [anon_sym_operator] = ACTIONS(3050),
    [anon_sym_try] = ACTIONS(3050),
    [anon_sym_delete] = ACTIONS(3050),
    [anon_sym_throw] = ACTIONS(3050),
    [anon_sym_namespace] = ACTIONS(3050),
    [anon_sym_static_assert] = ACTIONS(3050),
    [anon_sym_concept] = ACTIONS(3050),
    [anon_sym_co_return] = ACTIONS(3050),
    [anon_sym_co_yield] = ACTIONS(3050),
    [anon_sym_R_DQUOTE] = ACTIONS(3048),
    [anon_sym_LR_DQUOTE] = ACTIONS(3048),
    [anon_sym_uR_DQUOTE] = ACTIONS(3048),
    [anon_sym_UR_DQUOTE] = ACTIONS(3048),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3048),
    [anon_sym_co_await] = ACTIONS(3050),
    [anon_sym_new] = ACTIONS(3050),
    [anon_sym_requires] = ACTIONS(3050),
    [sym_this] = ACTIONS(3050),
    [anon_sym_precise] = ACTIONS(3050),
    [anon_sym_shared] = ACTIONS(3050),
    [anon_sym_groupshared] = ACTIONS(3050),
    [anon_sym_uniform] = ACTIONS(3050),
    [anon_sym_row_major] = ACTIONS(3050),
    [anon_sym_column_major] = ACTIONS(3050),
    [anon_sym_globallycoherent] = ACTIONS(3050),
    [anon_sym_centroid] = ACTIONS(3050),
    [anon_sym_noperspective] = ACTIONS(3050),
    [anon_sym_nointerpolation] = ACTIONS(3050),
    [anon_sym_sample] = ACTIONS(3050),
    [anon_sym_linear] = ACTIONS(3050),
    [anon_sym_snorm] = ACTIONS(3050),
    [anon_sym_unorm] = ACTIONS(3050),
    [anon_sym_point] = ACTIONS(3050),
    [anon_sym_line] = ACTIONS(3050),
    [anon_sym_triangleadj] = ACTIONS(3050),
    [anon_sym_lineadj] = ACTIONS(3050),
    [anon_sym_triangle] = ACTIONS(3050),
    [anon_sym_interface] = ACTIONS(3050),
    [anon_sym_extension] = ACTIONS(3050),
    [anon_sym_where] = ACTIONS(3050),
    [anon_sym___exported] = ACTIONS(3050),
  },
  [326] = {
    [ts_builtin_sym_end] = ACTIONS(3040),
    [sym_identifier] = ACTIONS(3042),
    [aux_sym_preproc_include_token1] = ACTIONS(3042),
    [aux_sym_preproc_def_token1] = ACTIONS(3042),
    [anon_sym_COMMA] = ACTIONS(3040),
    [anon_sym_RPAREN] = ACTIONS(3040),
    [aux_sym_preproc_if_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3042),
    [sym_preproc_directive] = ACTIONS(3042),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym_typedef] = ACTIONS(3042),
    [anon_sym_in] = ACTIONS(3042),
    [anon_sym_out] = ACTIONS(3042),
    [anon_sym_inout] = ACTIONS(3042),
    [anon_sym_virtual] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_using] = ACTIONS(3042),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym___cdecl] = ACTIONS(3042),
    [anon_sym___clrcall] = ACTIONS(3042),
    [anon_sym___stdcall] = ACTIONS(3042),
    [anon_sym___fastcall] = ACTIONS(3042),
    [anon_sym___thiscall] = ACTIONS(3042),
    [anon_sym___vectorcall] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym___inline] = ACTIONS(3042),
    [anon_sym___inline__] = ACTIONS(3042),
    [anon_sym___forceinline] = ACTIONS(3042),
    [anon_sym_thread_local] = ACTIONS(3042),
    [anon_sym___thread] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_enum] = ACTIONS(3042),
    [anon_sym_class] = ACTIONS(3042),
    [anon_sym_struct] = ACTIONS(3042),
    [anon_sym_union] = ACTIONS(3042),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_switch] = ACTIONS(3042),
    [anon_sym_case] = ACTIONS(3042),
    [anon_sym_default] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_for] = ACTIONS(3042),
    [anon_sym_return] = ACTIONS(3042),
    [anon_sym_break] = ACTIONS(3042),
    [anon_sym_continue] = ACTIONS(3042),
    [anon_sym_goto] = ACTIONS(3042),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_compl] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_sizeof] = ACTIONS(3042),
    [anon_sym___alignof__] = ACTIONS(3042),
    [anon_sym___alignof] = ACTIONS(3042),
    [anon_sym__alignof] = ACTIONS(3042),
    [anon_sym_alignof] = ACTIONS(3042),
    [anon_sym__Alignof] = ACTIONS(3042),
    [anon_sym_offsetof] = ACTIONS(3042),
    [anon_sym__Generic] = ACTIONS(3042),
    [anon_sym_asm] = ACTIONS(3042),
    [anon_sym___asm__] = ACTIONS(3042),
    [anon_sym___asm] = ACTIONS(3042),
    [anon_sym_DOT] = ACTIONS(3042),
    [sym_number_literal] = ACTIONS(3040),
    [anon_sym_L_SQUOTE] = ACTIONS(3040),
    [anon_sym_u_SQUOTE] = ACTIONS(3040),
    [anon_sym_U_SQUOTE] = ACTIONS(3040),
    [anon_sym_u8_SQUOTE] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(3040),
    [anon_sym_L_DQUOTE] = ACTIONS(3040),
    [anon_sym_u_DQUOTE] = ACTIONS(3040),
    [anon_sym_U_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8_DQUOTE] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [sym_true] = ACTIONS(3042),
    [sym_false] = ACTIONS(3042),
    [anon_sym_NULL] = ACTIONS(3042),
    [anon_sym_nullptr] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3042),
    [anon_sym_let] = ACTIONS(3042),
    [anon_sym_This] = ACTIONS(3042),
    [anon_sym_decltype] = ACTIONS(3042),
    [anon_sym_final] = ACTIONS(3042),
    [anon_sym_override] = ACTIONS(3042),
    [anon_sym_explicit] = ACTIONS(3042),
    [anon_sym_typename] = ACTIONS(3042),
    [anon_sym_export] = ACTIONS(3042),
    [anon_sym_module] = ACTIONS(3042),
    [anon_sym_import] = ACTIONS(3042),
    [anon_sym_template] = ACTIONS(3042),
    [anon_sym_GT2] = ACTIONS(3040),
    [anon_sym_operator] = ACTIONS(3042),
    [anon_sym_try] = ACTIONS(3042),
    [anon_sym_delete] = ACTIONS(3042),
    [anon_sym_throw] = ACTIONS(3042),
    [anon_sym_namespace] = ACTIONS(3042),
    [anon_sym_static_assert] = ACTIONS(3042),
    [anon_sym_concept] = ACTIONS(3042),
    [anon_sym_co_return] = ACTIONS(3042),
    [anon_sym_co_yield] = ACTIONS(3042),
    [anon_sym_R_DQUOTE] = ACTIONS(3040),
    [anon_sym_LR_DQUOTE] = ACTIONS(3040),
    [anon_sym_uR_DQUOTE] = ACTIONS(3040),
    [anon_sym_UR_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3040),
    [anon_sym_co_await] = ACTIONS(3042),
    [anon_sym_new] = ACTIONS(3042),
    [anon_sym_requires] = ACTIONS(3042),
    [sym_this] = ACTIONS(3042),
    [anon_sym_precise] = ACTIONS(3042),
    [anon_sym_shared] = ACTIONS(3042),
    [anon_sym_groupshared] = ACTIONS(3042),
    [anon_sym_uniform] = ACTIONS(3042),
    [anon_sym_row_major] = ACTIONS(3042),
    [anon_sym_column_major] = ACTIONS(3042),
    [anon_sym_globallycoherent] = ACTIONS(3042),
    [anon_sym_centroid] = ACTIONS(3042),
    [anon_sym_noperspective] = ACTIONS(3042),
    [anon_sym_nointerpolation] = ACTIONS(3042),
    [anon_sym_sample] = ACTIONS(3042),
    [anon_sym_linear] = ACTIONS(3042),
    [anon_sym_snorm] = ACTIONS(3042),
    [anon_sym_unorm] = ACTIONS(3042),
    [anon_sym_point] = ACTIONS(3042),
    [anon_sym_line] = ACTIONS(3042),
    [anon_sym_triangleadj] = ACTIONS(3042),
    [anon_sym_lineadj] = ACTIONS(3042),
    [anon_sym_triangle] = ACTIONS(3042),
    [anon_sym_interface] = ACTIONS(3042),
    [anon_sym_extension] = ACTIONS(3042),
    [anon_sym_where] = ACTIONS(3042),
    [anon_sym___exported] = ACTIONS(3042),
  },
  [327] = {
    [ts_builtin_sym_end] = ACTIONS(3040),
    [sym_identifier] = ACTIONS(3042),
    [aux_sym_preproc_include_token1] = ACTIONS(3042),
    [aux_sym_preproc_def_token1] = ACTIONS(3042),
    [anon_sym_COMMA] = ACTIONS(3040),
    [anon_sym_RPAREN] = ACTIONS(3040),
    [aux_sym_preproc_if_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3042),
    [sym_preproc_directive] = ACTIONS(3042),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym_typedef] = ACTIONS(3042),
    [anon_sym_in] = ACTIONS(3042),
    [anon_sym_out] = ACTIONS(3042),
    [anon_sym_inout] = ACTIONS(3042),
    [anon_sym_virtual] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_using] = ACTIONS(3042),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym___cdecl] = ACTIONS(3042),
    [anon_sym___clrcall] = ACTIONS(3042),
    [anon_sym___stdcall] = ACTIONS(3042),
    [anon_sym___fastcall] = ACTIONS(3042),
    [anon_sym___thiscall] = ACTIONS(3042),
    [anon_sym___vectorcall] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym___inline] = ACTIONS(3042),
    [anon_sym___inline__] = ACTIONS(3042),
    [anon_sym___forceinline] = ACTIONS(3042),
    [anon_sym_thread_local] = ACTIONS(3042),
    [anon_sym___thread] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_enum] = ACTIONS(3042),
    [anon_sym_class] = ACTIONS(3042),
    [anon_sym_struct] = ACTIONS(3042),
    [anon_sym_union] = ACTIONS(3042),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_switch] = ACTIONS(3042),
    [anon_sym_case] = ACTIONS(3042),
    [anon_sym_default] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_for] = ACTIONS(3042),
    [anon_sym_return] = ACTIONS(3042),
    [anon_sym_break] = ACTIONS(3042),
    [anon_sym_continue] = ACTIONS(3042),
    [anon_sym_goto] = ACTIONS(3042),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_compl] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_sizeof] = ACTIONS(3042),
    [anon_sym___alignof__] = ACTIONS(3042),
    [anon_sym___alignof] = ACTIONS(3042),
    [anon_sym__alignof] = ACTIONS(3042),
    [anon_sym_alignof] = ACTIONS(3042),
    [anon_sym__Alignof] = ACTIONS(3042),
    [anon_sym_offsetof] = ACTIONS(3042),
    [anon_sym__Generic] = ACTIONS(3042),
    [anon_sym_asm] = ACTIONS(3042),
    [anon_sym___asm__] = ACTIONS(3042),
    [anon_sym___asm] = ACTIONS(3042),
    [anon_sym_DOT] = ACTIONS(3042),
    [sym_number_literal] = ACTIONS(3040),
    [anon_sym_L_SQUOTE] = ACTIONS(3040),
    [anon_sym_u_SQUOTE] = ACTIONS(3040),
    [anon_sym_U_SQUOTE] = ACTIONS(3040),
    [anon_sym_u8_SQUOTE] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(3040),
    [anon_sym_L_DQUOTE] = ACTIONS(3040),
    [anon_sym_u_DQUOTE] = ACTIONS(3040),
    [anon_sym_U_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8_DQUOTE] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [sym_true] = ACTIONS(3042),
    [sym_false] = ACTIONS(3042),
    [anon_sym_NULL] = ACTIONS(3042),
    [anon_sym_nullptr] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3042),
    [anon_sym_let] = ACTIONS(3042),
    [anon_sym_This] = ACTIONS(3042),
    [anon_sym_decltype] = ACTIONS(3042),
    [anon_sym_final] = ACTIONS(3042),
    [anon_sym_override] = ACTIONS(3042),
    [anon_sym_explicit] = ACTIONS(3042),
    [anon_sym_typename] = ACTIONS(3042),
    [anon_sym_export] = ACTIONS(3042),
    [anon_sym_module] = ACTIONS(3042),
    [anon_sym_import] = ACTIONS(3042),
    [anon_sym_template] = ACTIONS(3042),
    [anon_sym_GT2] = ACTIONS(3040),
    [anon_sym_operator] = ACTIONS(3042),
    [anon_sym_try] = ACTIONS(3042),
    [anon_sym_delete] = ACTIONS(3042),
    [anon_sym_throw] = ACTIONS(3042),
    [anon_sym_namespace] = ACTIONS(3042),
    [anon_sym_static_assert] = ACTIONS(3042),
    [anon_sym_concept] = ACTIONS(3042),
    [anon_sym_co_return] = ACTIONS(3042),
    [anon_sym_co_yield] = ACTIONS(3042),
    [anon_sym_R_DQUOTE] = ACTIONS(3040),
    [anon_sym_LR_DQUOTE] = ACTIONS(3040),
    [anon_sym_uR_DQUOTE] = ACTIONS(3040),
    [anon_sym_UR_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3040),
    [anon_sym_co_await] = ACTIONS(3042),
    [anon_sym_new] = ACTIONS(3042),
    [anon_sym_requires] = ACTIONS(3042),
    [sym_this] = ACTIONS(3042),
    [anon_sym_precise] = ACTIONS(3042),
    [anon_sym_shared] = ACTIONS(3042),
    [anon_sym_groupshared] = ACTIONS(3042),
    [anon_sym_uniform] = ACTIONS(3042),
    [anon_sym_row_major] = ACTIONS(3042),
    [anon_sym_column_major] = ACTIONS(3042),
    [anon_sym_globallycoherent] = ACTIONS(3042),
    [anon_sym_centroid] = ACTIONS(3042),
    [anon_sym_noperspective] = ACTIONS(3042),
    [anon_sym_nointerpolation] = ACTIONS(3042),
    [anon_sym_sample] = ACTIONS(3042),
    [anon_sym_linear] = ACTIONS(3042),
    [anon_sym_snorm] = ACTIONS(3042),
    [anon_sym_unorm] = ACTIONS(3042),
    [anon_sym_point] = ACTIONS(3042),
    [anon_sym_line] = ACTIONS(3042),
    [anon_sym_triangleadj] = ACTIONS(3042),
    [anon_sym_lineadj] = ACTIONS(3042),
    [anon_sym_triangle] = ACTIONS(3042),
    [anon_sym_interface] = ACTIONS(3042),
    [anon_sym_extension] = ACTIONS(3042),
    [anon_sym_where] = ACTIONS(3042),
    [anon_sym___exported] = ACTIONS(3042),
  },
  [328] = {
    [ts_builtin_sym_end] = ACTIONS(3052),
    [sym_identifier] = ACTIONS(3054),
    [aux_sym_preproc_include_token1] = ACTIONS(3054),
    [aux_sym_preproc_def_token1] = ACTIONS(3054),
    [anon_sym_COMMA] = ACTIONS(3052),
    [anon_sym_RPAREN] = ACTIONS(3052),
    [aux_sym_preproc_if_token1] = ACTIONS(3054),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3054),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3054),
    [sym_preproc_directive] = ACTIONS(3054),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3054),
    [anon_sym_typedef] = ACTIONS(3054),
    [anon_sym_in] = ACTIONS(3054),
    [anon_sym_out] = ACTIONS(3054),
    [anon_sym_inout] = ACTIONS(3054),
    [anon_sym_virtual] = ACTIONS(3054),
    [anon_sym_extern] = ACTIONS(3054),
    [anon_sym___attribute__] = ACTIONS(3054),
    [anon_sym___attribute] = ACTIONS(3054),
    [anon_sym_using] = ACTIONS(3054),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3052),
    [anon_sym___declspec] = ACTIONS(3054),
    [anon_sym___based] = ACTIONS(3054),
    [anon_sym___cdecl] = ACTIONS(3054),
    [anon_sym___clrcall] = ACTIONS(3054),
    [anon_sym___stdcall] = ACTIONS(3054),
    [anon_sym___fastcall] = ACTIONS(3054),
    [anon_sym___thiscall] = ACTIONS(3054),
    [anon_sym___vectorcall] = ACTIONS(3054),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_signed] = ACTIONS(3054),
    [anon_sym_unsigned] = ACTIONS(3054),
    [anon_sym_long] = ACTIONS(3054),
    [anon_sym_short] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3054),
    [anon_sym_static] = ACTIONS(3054),
    [anon_sym_register] = ACTIONS(3054),
    [anon_sym_inline] = ACTIONS(3054),
    [anon_sym___inline] = ACTIONS(3054),
    [anon_sym___inline__] = ACTIONS(3054),
    [anon_sym___forceinline] = ACTIONS(3054),
    [anon_sym_thread_local] = ACTIONS(3054),
    [anon_sym___thread] = ACTIONS(3054),
    [anon_sym_const] = ACTIONS(3054),
    [anon_sym_constexpr] = ACTIONS(3054),
    [anon_sym_volatile] = ACTIONS(3054),
    [anon_sym_restrict] = ACTIONS(3054),
    [anon_sym___restrict__] = ACTIONS(3054),
    [anon_sym__Atomic] = ACTIONS(3054),
    [anon_sym__Noreturn] = ACTIONS(3054),
    [anon_sym_noreturn] = ACTIONS(3054),
    [anon_sym__Nonnull] = ACTIONS(3054),
    [anon_sym_mutable] = ACTIONS(3054),
    [anon_sym_constinit] = ACTIONS(3054),
    [anon_sym_consteval] = ACTIONS(3054),
    [anon_sym_alignas] = ACTIONS(3054),
    [anon_sym__Alignas] = ACTIONS(3054),
    [sym_primitive_type] = ACTIONS(3054),
    [anon_sym_enum] = ACTIONS(3054),
    [anon_sym_class] = ACTIONS(3054),
    [anon_sym_struct] = ACTIONS(3054),
    [anon_sym_union] = ACTIONS(3054),
    [anon_sym_if] = ACTIONS(3054),
    [anon_sym_switch] = ACTIONS(3054),
    [anon_sym_case] = ACTIONS(3054),
    [anon_sym_default] = ACTIONS(3054),
    [anon_sym_while] = ACTIONS(3054),
    [anon_sym_do] = ACTIONS(3054),
    [anon_sym_for] = ACTIONS(3054),
    [anon_sym_return] = ACTIONS(3054),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_continue] = ACTIONS(3054),
    [anon_sym_goto] = ACTIONS(3054),
    [anon_sym_not] = ACTIONS(3054),
    [anon_sym_compl] = ACTIONS(3054),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_sizeof] = ACTIONS(3054),
    [anon_sym___alignof__] = ACTIONS(3054),
    [anon_sym___alignof] = ACTIONS(3054),
    [anon_sym__alignof] = ACTIONS(3054),
    [anon_sym_alignof] = ACTIONS(3054),
    [anon_sym__Alignof] = ACTIONS(3054),
    [anon_sym_offsetof] = ACTIONS(3054),
    [anon_sym__Generic] = ACTIONS(3054),
    [anon_sym_asm] = ACTIONS(3054),
    [anon_sym___asm__] = ACTIONS(3054),
    [anon_sym___asm] = ACTIONS(3054),
    [anon_sym_DOT] = ACTIONS(3054),
    [sym_number_literal] = ACTIONS(3052),
    [anon_sym_L_SQUOTE] = ACTIONS(3052),
    [anon_sym_u_SQUOTE] = ACTIONS(3052),
    [anon_sym_U_SQUOTE] = ACTIONS(3052),
    [anon_sym_u8_SQUOTE] = ACTIONS(3052),
    [anon_sym_SQUOTE] = ACTIONS(3052),
    [anon_sym_L_DQUOTE] = ACTIONS(3052),
    [anon_sym_u_DQUOTE] = ACTIONS(3052),
    [anon_sym_U_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8_DQUOTE] = ACTIONS(3052),
    [anon_sym_DQUOTE] = ACTIONS(3052),
    [sym_true] = ACTIONS(3054),
    [sym_false] = ACTIONS(3054),
    [anon_sym_NULL] = ACTIONS(3054),
    [anon_sym_nullptr] = ACTIONS(3054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3054),
    [anon_sym_let] = ACTIONS(3054),
    [anon_sym_This] = ACTIONS(3054),
    [anon_sym_decltype] = ACTIONS(3054),
    [anon_sym_final] = ACTIONS(3054),
    [anon_sym_override] = ACTIONS(3054),
    [anon_sym_explicit] = ACTIONS(3054),
    [anon_sym_typename] = ACTIONS(3054),
    [anon_sym_export] = ACTIONS(3054),
    [anon_sym_module] = ACTIONS(3054),
    [anon_sym_import] = ACTIONS(3054),
    [anon_sym_template] = ACTIONS(3054),
    [anon_sym_GT2] = ACTIONS(3052),
    [anon_sym_operator] = ACTIONS(3054),
    [anon_sym_try] = ACTIONS(3054),
    [anon_sym_delete] = ACTIONS(3054),
    [anon_sym_throw] = ACTIONS(3054),
    [anon_sym_namespace] = ACTIONS(3054),
    [anon_sym_static_assert] = ACTIONS(3054),
    [anon_sym_concept] = ACTIONS(3054),
    [anon_sym_co_return] = ACTIONS(3054),
    [anon_sym_co_yield] = ACTIONS(3054),
    [anon_sym_R_DQUOTE] = ACTIONS(3052),
    [anon_sym_LR_DQUOTE] = ACTIONS(3052),
    [anon_sym_uR_DQUOTE] = ACTIONS(3052),
    [anon_sym_UR_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3052),
    [anon_sym_co_await] = ACTIONS(3054),
    [anon_sym_new] = ACTIONS(3054),
    [anon_sym_requires] = ACTIONS(3054),
    [sym_this] = ACTIONS(3054),
    [anon_sym_precise] = ACTIONS(3054),
    [anon_sym_shared] = ACTIONS(3054),
    [anon_sym_groupshared] = ACTIONS(3054),
    [anon_sym_uniform] = ACTIONS(3054),
    [anon_sym_row_major] = ACTIONS(3054),
    [anon_sym_column_major] = ACTIONS(3054),
    [anon_sym_globallycoherent] = ACTIONS(3054),
    [anon_sym_centroid] = ACTIONS(3054),
    [anon_sym_noperspective] = ACTIONS(3054),
    [anon_sym_nointerpolation] = ACTIONS(3054),
    [anon_sym_sample] = ACTIONS(3054),
    [anon_sym_linear] = ACTIONS(3054),
    [anon_sym_snorm] = ACTIONS(3054),
    [anon_sym_unorm] = ACTIONS(3054),
    [anon_sym_point] = ACTIONS(3054),
    [anon_sym_line] = ACTIONS(3054),
    [anon_sym_triangleadj] = ACTIONS(3054),
    [anon_sym_lineadj] = ACTIONS(3054),
    [anon_sym_triangle] = ACTIONS(3054),
    [anon_sym_interface] = ACTIONS(3054),
    [anon_sym_extension] = ACTIONS(3054),
    [anon_sym_where] = ACTIONS(3054),
    [anon_sym___exported] = ACTIONS(3054),
  },
  [329] = {
    [ts_builtin_sym_end] = ACTIONS(3056),
    [sym_identifier] = ACTIONS(3058),
    [aux_sym_preproc_include_token1] = ACTIONS(3058),
    [aux_sym_preproc_def_token1] = ACTIONS(3058),
    [anon_sym_COMMA] = ACTIONS(3056),
    [anon_sym_RPAREN] = ACTIONS(3056),
    [aux_sym_preproc_if_token1] = ACTIONS(3058),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3058),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3058),
    [sym_preproc_directive] = ACTIONS(3058),
    [anon_sym_LPAREN2] = ACTIONS(3056),
    [anon_sym_BANG] = ACTIONS(3056),
    [anon_sym_TILDE] = ACTIONS(3056),
    [anon_sym_DASH] = ACTIONS(3058),
    [anon_sym_PLUS] = ACTIONS(3058),
    [anon_sym_STAR] = ACTIONS(3056),
    [anon_sym_AMP_AMP] = ACTIONS(3056),
    [anon_sym_AMP] = ACTIONS(3058),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym___extension__] = ACTIONS(3058),
    [anon_sym_typedef] = ACTIONS(3058),
    [anon_sym_in] = ACTIONS(3058),
    [anon_sym_out] = ACTIONS(3058),
    [anon_sym_inout] = ACTIONS(3058),
    [anon_sym_virtual] = ACTIONS(3058),
    [anon_sym_extern] = ACTIONS(3058),
    [anon_sym___attribute__] = ACTIONS(3058),
    [anon_sym___attribute] = ACTIONS(3058),
    [anon_sym_using] = ACTIONS(3058),
    [anon_sym_COLON_COLON] = ACTIONS(3056),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3056),
    [anon_sym___declspec] = ACTIONS(3058),
    [anon_sym___based] = ACTIONS(3058),
    [anon_sym___cdecl] = ACTIONS(3058),
    [anon_sym___clrcall] = ACTIONS(3058),
    [anon_sym___stdcall] = ACTIONS(3058),
    [anon_sym___fastcall] = ACTIONS(3058),
    [anon_sym___thiscall] = ACTIONS(3058),
    [anon_sym___vectorcall] = ACTIONS(3058),
    [anon_sym_LBRACE] = ACTIONS(3056),
    [anon_sym_signed] = ACTIONS(3058),
    [anon_sym_unsigned] = ACTIONS(3058),
    [anon_sym_long] = ACTIONS(3058),
    [anon_sym_short] = ACTIONS(3058),
    [anon_sym_LBRACK] = ACTIONS(3058),
    [anon_sym_static] = ACTIONS(3058),
    [anon_sym_register] = ACTIONS(3058),
    [anon_sym_inline] = ACTIONS(3058),
    [anon_sym___inline] = ACTIONS(3058),
    [anon_sym___inline__] = ACTIONS(3058),
    [anon_sym___forceinline] = ACTIONS(3058),
    [anon_sym_thread_local] = ACTIONS(3058),
    [anon_sym___thread] = ACTIONS(3058),
    [anon_sym_const] = ACTIONS(3058),
    [anon_sym_constexpr] = ACTIONS(3058),
    [anon_sym_volatile] = ACTIONS(3058),
    [anon_sym_restrict] = ACTIONS(3058),
    [anon_sym___restrict__] = ACTIONS(3058),
    [anon_sym__Atomic] = ACTIONS(3058),
    [anon_sym__Noreturn] = ACTIONS(3058),
    [anon_sym_noreturn] = ACTIONS(3058),
    [anon_sym__Nonnull] = ACTIONS(3058),
    [anon_sym_mutable] = ACTIONS(3058),
    [anon_sym_constinit] = ACTIONS(3058),
    [anon_sym_consteval] = ACTIONS(3058),
    [anon_sym_alignas] = ACTIONS(3058),
    [anon_sym__Alignas] = ACTIONS(3058),
    [sym_primitive_type] = ACTIONS(3058),
    [anon_sym_enum] = ACTIONS(3058),
    [anon_sym_class] = ACTIONS(3058),
    [anon_sym_struct] = ACTIONS(3058),
    [anon_sym_union] = ACTIONS(3058),
    [anon_sym_if] = ACTIONS(3058),
    [anon_sym_switch] = ACTIONS(3058),
    [anon_sym_case] = ACTIONS(3058),
    [anon_sym_default] = ACTIONS(3058),
    [anon_sym_while] = ACTIONS(3058),
    [anon_sym_do] = ACTIONS(3058),
    [anon_sym_for] = ACTIONS(3058),
    [anon_sym_return] = ACTIONS(3058),
    [anon_sym_break] = ACTIONS(3058),
    [anon_sym_continue] = ACTIONS(3058),
    [anon_sym_goto] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3058),
    [anon_sym_compl] = ACTIONS(3058),
    [anon_sym_DASH_DASH] = ACTIONS(3056),
    [anon_sym_PLUS_PLUS] = ACTIONS(3056),
    [anon_sym_sizeof] = ACTIONS(3058),
    [anon_sym___alignof__] = ACTIONS(3058),
    [anon_sym___alignof] = ACTIONS(3058),
    [anon_sym__alignof] = ACTIONS(3058),
    [anon_sym_alignof] = ACTIONS(3058),
    [anon_sym__Alignof] = ACTIONS(3058),
    [anon_sym_offsetof] = ACTIONS(3058),
    [anon_sym__Generic] = ACTIONS(3058),
    [anon_sym_asm] = ACTIONS(3058),
    [anon_sym___asm__] = ACTIONS(3058),
    [anon_sym___asm] = ACTIONS(3058),
    [anon_sym_DOT] = ACTIONS(3058),
    [sym_number_literal] = ACTIONS(3056),
    [anon_sym_L_SQUOTE] = ACTIONS(3056),
    [anon_sym_u_SQUOTE] = ACTIONS(3056),
    [anon_sym_U_SQUOTE] = ACTIONS(3056),
    [anon_sym_u8_SQUOTE] = ACTIONS(3056),
    [anon_sym_SQUOTE] = ACTIONS(3056),
    [anon_sym_L_DQUOTE] = ACTIONS(3056),
    [anon_sym_u_DQUOTE] = ACTIONS(3056),
    [anon_sym_U_DQUOTE] = ACTIONS(3056),
    [anon_sym_u8_DQUOTE] = ACTIONS(3056),
    [anon_sym_DQUOTE] = ACTIONS(3056),
    [sym_true] = ACTIONS(3058),
    [sym_false] = ACTIONS(3058),
    [anon_sym_NULL] = ACTIONS(3058),
    [anon_sym_nullptr] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3058),
    [anon_sym_let] = ACTIONS(3058),
    [anon_sym_This] = ACTIONS(3058),
    [anon_sym_decltype] = ACTIONS(3058),
    [anon_sym_final] = ACTIONS(3058),
    [anon_sym_override] = ACTIONS(3058),
    [anon_sym_explicit] = ACTIONS(3058),
    [anon_sym_typename] = ACTIONS(3058),
    [anon_sym_export] = ACTIONS(3058),
    [anon_sym_module] = ACTIONS(3058),
    [anon_sym_import] = ACTIONS(3058),
    [anon_sym_template] = ACTIONS(3058),
    [anon_sym_GT2] = ACTIONS(3056),
    [anon_sym_operator] = ACTIONS(3058),
    [anon_sym_try] = ACTIONS(3058),
    [anon_sym_delete] = ACTIONS(3058),
    [anon_sym_throw] = ACTIONS(3058),
    [anon_sym_namespace] = ACTIONS(3058),
    [anon_sym_static_assert] = ACTIONS(3058),
    [anon_sym_concept] = ACTIONS(3058),
    [anon_sym_co_return] = ACTIONS(3058),
    [anon_sym_co_yield] = ACTIONS(3058),
    [anon_sym_R_DQUOTE] = ACTIONS(3056),
    [anon_sym_LR_DQUOTE] = ACTIONS(3056),
    [anon_sym_uR_DQUOTE] = ACTIONS(3056),
    [anon_sym_UR_DQUOTE] = ACTIONS(3056),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3056),
    [anon_sym_co_await] = ACTIONS(3058),
    [anon_sym_new] = ACTIONS(3058),
    [anon_sym_requires] = ACTIONS(3058),
    [sym_this] = ACTIONS(3058),
    [anon_sym_precise] = ACTIONS(3058),
    [anon_sym_shared] = ACTIONS(3058),
    [anon_sym_groupshared] = ACTIONS(3058),
    [anon_sym_uniform] = ACTIONS(3058),
    [anon_sym_row_major] = ACTIONS(3058),
    [anon_sym_column_major] = ACTIONS(3058),
    [anon_sym_globallycoherent] = ACTIONS(3058),
    [anon_sym_centroid] = ACTIONS(3058),
    [anon_sym_noperspective] = ACTIONS(3058),
    [anon_sym_nointerpolation] = ACTIONS(3058),
    [anon_sym_sample] = ACTIONS(3058),
    [anon_sym_linear] = ACTIONS(3058),
    [anon_sym_snorm] = ACTIONS(3058),
    [anon_sym_unorm] = ACTIONS(3058),
    [anon_sym_point] = ACTIONS(3058),
    [anon_sym_line] = ACTIONS(3058),
    [anon_sym_triangleadj] = ACTIONS(3058),
    [anon_sym_lineadj] = ACTIONS(3058),
    [anon_sym_triangle] = ACTIONS(3058),
    [anon_sym_interface] = ACTIONS(3058),
    [anon_sym_extension] = ACTIONS(3058),
    [anon_sym_where] = ACTIONS(3058),
    [anon_sym___exported] = ACTIONS(3058),
  },
  [330] = {
    [sym_preproc_def] = STATE(367),
    [sym_preproc_function_def] = STATE(367),
    [sym_preproc_call] = STATE(367),
    [sym_preproc_if_in_field_declaration_list] = STATE(367),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(367),
    [sym_type_definition] = STATE(367),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(367),
    [sym_field_declaration] = STATE(367),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(367),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(367),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(367),
    [sym_operator_cast_declaration] = STATE(367),
    [sym_constructor_or_destructor_definition] = STATE(367),
    [sym_constructor_or_destructor_declaration] = STATE(367),
    [sym_friend_declaration] = STATE(367),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(367),
    [sym_alias_declaration] = STATE(367),
    [sym_static_assert_declaration] = STATE(367),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(367),
    [sym_subscript_declaration] = STATE(367),
    [sym_property_declaration] = STATE(367),
    [sym_associatedtype_declaration] = STATE(367),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(367),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3068),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3076),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [331] = {
    [sym_else_clause] = STATE(475),
    [ts_builtin_sym_end] = ACTIONS(3094),
    [sym_identifier] = ACTIONS(3096),
    [aux_sym_preproc_include_token1] = ACTIONS(3096),
    [aux_sym_preproc_def_token1] = ACTIONS(3096),
    [aux_sym_preproc_if_token1] = ACTIONS(3096),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3096),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3096),
    [sym_preproc_directive] = ACTIONS(3096),
    [anon_sym_LPAREN2] = ACTIONS(3094),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_TILDE] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3096),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_STAR] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_AMP] = ACTIONS(3096),
    [anon_sym_SEMI] = ACTIONS(3094),
    [anon_sym___extension__] = ACTIONS(3096),
    [anon_sym_typedef] = ACTIONS(3096),
    [anon_sym_in] = ACTIONS(3096),
    [anon_sym_out] = ACTIONS(3096),
    [anon_sym_inout] = ACTIONS(3096),
    [anon_sym_virtual] = ACTIONS(3096),
    [anon_sym_extern] = ACTIONS(3096),
    [anon_sym___attribute__] = ACTIONS(3096),
    [anon_sym___attribute] = ACTIONS(3096),
    [anon_sym_using] = ACTIONS(3096),
    [anon_sym_COLON_COLON] = ACTIONS(3094),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3094),
    [anon_sym___declspec] = ACTIONS(3096),
    [anon_sym___based] = ACTIONS(3096),
    [anon_sym___cdecl] = ACTIONS(3096),
    [anon_sym___clrcall] = ACTIONS(3096),
    [anon_sym___stdcall] = ACTIONS(3096),
    [anon_sym___fastcall] = ACTIONS(3096),
    [anon_sym___thiscall] = ACTIONS(3096),
    [anon_sym___vectorcall] = ACTIONS(3096),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_signed] = ACTIONS(3096),
    [anon_sym_unsigned] = ACTIONS(3096),
    [anon_sym_long] = ACTIONS(3096),
    [anon_sym_short] = ACTIONS(3096),
    [anon_sym_LBRACK] = ACTIONS(3096),
    [anon_sym_static] = ACTIONS(3096),
    [anon_sym_register] = ACTIONS(3096),
    [anon_sym_inline] = ACTIONS(3096),
    [anon_sym___inline] = ACTIONS(3096),
    [anon_sym___inline__] = ACTIONS(3096),
    [anon_sym___forceinline] = ACTIONS(3096),
    [anon_sym_thread_local] = ACTIONS(3096),
    [anon_sym___thread] = ACTIONS(3096),
    [anon_sym_const] = ACTIONS(3096),
    [anon_sym_constexpr] = ACTIONS(3096),
    [anon_sym_volatile] = ACTIONS(3096),
    [anon_sym_restrict] = ACTIONS(3096),
    [anon_sym___restrict__] = ACTIONS(3096),
    [anon_sym__Atomic] = ACTIONS(3096),
    [anon_sym__Noreturn] = ACTIONS(3096),
    [anon_sym_noreturn] = ACTIONS(3096),
    [anon_sym__Nonnull] = ACTIONS(3096),
    [anon_sym_mutable] = ACTIONS(3096),
    [anon_sym_constinit] = ACTIONS(3096),
    [anon_sym_consteval] = ACTIONS(3096),
    [anon_sym_alignas] = ACTIONS(3096),
    [anon_sym__Alignas] = ACTIONS(3096),
    [sym_primitive_type] = ACTIONS(3096),
    [anon_sym_enum] = ACTIONS(3096),
    [anon_sym_class] = ACTIONS(3096),
    [anon_sym_struct] = ACTIONS(3096),
    [anon_sym_union] = ACTIONS(3096),
    [anon_sym_if] = ACTIONS(3096),
    [anon_sym_else] = ACTIONS(3098),
    [anon_sym_switch] = ACTIONS(3096),
    [anon_sym_case] = ACTIONS(3096),
    [anon_sym_default] = ACTIONS(3096),
    [anon_sym_while] = ACTIONS(3096),
    [anon_sym_do] = ACTIONS(3096),
    [anon_sym_for] = ACTIONS(3096),
    [anon_sym_return] = ACTIONS(3096),
    [anon_sym_break] = ACTIONS(3096),
    [anon_sym_continue] = ACTIONS(3096),
    [anon_sym_goto] = ACTIONS(3096),
    [anon_sym___try] = ACTIONS(3096),
    [anon_sym___leave] = ACTIONS(3096),
    [anon_sym_not] = ACTIONS(3096),
    [anon_sym_compl] = ACTIONS(3096),
    [anon_sym_DASH_DASH] = ACTIONS(3094),
    [anon_sym_PLUS_PLUS] = ACTIONS(3094),
    [anon_sym_sizeof] = ACTIONS(3096),
    [anon_sym___alignof__] = ACTIONS(3096),
    [anon_sym___alignof] = ACTIONS(3096),
    [anon_sym__alignof] = ACTIONS(3096),
    [anon_sym_alignof] = ACTIONS(3096),
    [anon_sym__Alignof] = ACTIONS(3096),
    [anon_sym_offsetof] = ACTIONS(3096),
    [anon_sym__Generic] = ACTIONS(3096),
    [anon_sym_asm] = ACTIONS(3096),
    [anon_sym___asm__] = ACTIONS(3096),
    [anon_sym___asm] = ACTIONS(3096),
    [sym_number_literal] = ACTIONS(3094),
    [anon_sym_L_SQUOTE] = ACTIONS(3094),
    [anon_sym_u_SQUOTE] = ACTIONS(3094),
    [anon_sym_U_SQUOTE] = ACTIONS(3094),
    [anon_sym_u8_SQUOTE] = ACTIONS(3094),
    [anon_sym_SQUOTE] = ACTIONS(3094),
    [anon_sym_L_DQUOTE] = ACTIONS(3094),
    [anon_sym_u_DQUOTE] = ACTIONS(3094),
    [anon_sym_U_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8_DQUOTE] = ACTIONS(3094),
    [anon_sym_DQUOTE] = ACTIONS(3094),
    [sym_true] = ACTIONS(3096),
    [sym_false] = ACTIONS(3096),
    [anon_sym_NULL] = ACTIONS(3096),
    [anon_sym_nullptr] = ACTIONS(3096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3096),
    [anon_sym_let] = ACTIONS(3096),
    [anon_sym_This] = ACTIONS(3096),
    [anon_sym_decltype] = ACTIONS(3096),
    [anon_sym_explicit] = ACTIONS(3096),
    [anon_sym_typename] = ACTIONS(3096),
    [anon_sym_export] = ACTIONS(3096),
    [anon_sym_module] = ACTIONS(3096),
    [anon_sym_import] = ACTIONS(3096),
    [anon_sym_template] = ACTIONS(3096),
    [anon_sym_operator] = ACTIONS(3096),
    [anon_sym_try] = ACTIONS(3096),
    [anon_sym_delete] = ACTIONS(3096),
    [anon_sym_throw] = ACTIONS(3096),
    [anon_sym_namespace] = ACTIONS(3096),
    [anon_sym_static_assert] = ACTIONS(3096),
    [anon_sym_concept] = ACTIONS(3096),
    [anon_sym_co_return] = ACTIONS(3096),
    [anon_sym_co_yield] = ACTIONS(3096),
    [anon_sym_R_DQUOTE] = ACTIONS(3094),
    [anon_sym_LR_DQUOTE] = ACTIONS(3094),
    [anon_sym_uR_DQUOTE] = ACTIONS(3094),
    [anon_sym_UR_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3094),
    [anon_sym_co_await] = ACTIONS(3096),
    [anon_sym_new] = ACTIONS(3096),
    [anon_sym_requires] = ACTIONS(3096),
    [sym_this] = ACTIONS(3096),
    [anon_sym_discard] = ACTIONS(3096),
    [anon_sym_precise] = ACTIONS(3096),
    [anon_sym_shared] = ACTIONS(3096),
    [anon_sym_groupshared] = ACTIONS(3096),
    [anon_sym_uniform] = ACTIONS(3096),
    [anon_sym_row_major] = ACTIONS(3096),
    [anon_sym_column_major] = ACTIONS(3096),
    [anon_sym_globallycoherent] = ACTIONS(3096),
    [anon_sym_centroid] = ACTIONS(3096),
    [anon_sym_noperspective] = ACTIONS(3096),
    [anon_sym_nointerpolation] = ACTIONS(3096),
    [anon_sym_sample] = ACTIONS(3096),
    [anon_sym_linear] = ACTIONS(3096),
    [anon_sym_snorm] = ACTIONS(3096),
    [anon_sym_unorm] = ACTIONS(3096),
    [anon_sym_point] = ACTIONS(3096),
    [anon_sym_line] = ACTIONS(3096),
    [anon_sym_triangleadj] = ACTIONS(3096),
    [anon_sym_lineadj] = ACTIONS(3096),
    [anon_sym_triangle] = ACTIONS(3096),
    [anon_sym_cbuffer] = ACTIONS(3096),
    [anon_sym_interface] = ACTIONS(3096),
    [anon_sym_extension] = ACTIONS(3096),
    [anon_sym___exported] = ACTIONS(3096),
  },
  [332] = {
    [sym_preproc_def] = STATE(332),
    [sym_preproc_function_def] = STATE(332),
    [sym_preproc_call] = STATE(332),
    [sym_preproc_if_in_field_declaration_list] = STATE(332),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(332),
    [sym_type_definition] = STATE(332),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7130),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7985),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(332),
    [sym_field_declaration] = STATE(332),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2676),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(332),
    [sym_operator_cast] = STATE(9196),
    [sym_inline_method_definition] = STATE(332),
    [sym__constructor_specifiers] = STATE(2676),
    [sym_operator_cast_definition] = STATE(332),
    [sym_operator_cast_declaration] = STATE(332),
    [sym_constructor_or_destructor_definition] = STATE(332),
    [sym_constructor_or_destructor_declaration] = STATE(332),
    [sym_friend_declaration] = STATE(332),
    [sym_access_specifier] = STATE(11528),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(332),
    [sym_alias_declaration] = STATE(332),
    [sym_static_assert_declaration] = STATE(332),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9196),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(332),
    [sym_subscript_declaration] = STATE(332),
    [sym_property_declaration] = STATE(332),
    [sym_associatedtype_declaration] = STATE(332),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(332),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9547),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2676),
    [sym_identifier] = ACTIONS(2654),
    [aux_sym_preproc_def_token1] = ACTIONS(3100),
    [aux_sym_preproc_if_token1] = ACTIONS(3103),
    [aux_sym_preproc_if_token2] = ACTIONS(2663),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3106),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3106),
    [sym_preproc_directive] = ACTIONS(3109),
    [anon_sym_LPAREN2] = ACTIONS(2671),
    [anon_sym_TILDE] = ACTIONS(2674),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_AMP_AMP] = ACTIONS(2680),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_SEMI] = ACTIONS(3112),
    [anon_sym___extension__] = ACTIONS(3115),
    [anon_sym_typedef] = ACTIONS(3118),
    [anon_sym_in] = ACTIONS(2695),
    [anon_sym_out] = ACTIONS(2695),
    [anon_sym_inout] = ACTIONS(2695),
    [anon_sym_virtual] = ACTIONS(2695),
    [anon_sym_extern] = ACTIONS(2698),
    [anon_sym___attribute__] = ACTIONS(2701),
    [anon_sym___attribute] = ACTIONS(2701),
    [anon_sym_using] = ACTIONS(3121),
    [anon_sym_COLON_COLON] = ACTIONS(2707),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2710),
    [anon_sym___declspec] = ACTIONS(2713),
    [anon_sym___based] = ACTIONS(2716),
    [anon_sym_signed] = ACTIONS(2719),
    [anon_sym_unsigned] = ACTIONS(2719),
    [anon_sym_long] = ACTIONS(2719),
    [anon_sym_short] = ACTIONS(2719),
    [anon_sym_LBRACK] = ACTIONS(2722),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_register] = ACTIONS(2698),
    [anon_sym_inline] = ACTIONS(2698),
    [anon_sym___inline] = ACTIONS(2698),
    [anon_sym___inline__] = ACTIONS(2698),
    [anon_sym___forceinline] = ACTIONS(2698),
    [anon_sym_thread_local] = ACTIONS(2698),
    [anon_sym___thread] = ACTIONS(2698),
    [anon_sym_const] = ACTIONS(2725),
    [anon_sym_constexpr] = ACTIONS(3124),
    [anon_sym_volatile] = ACTIONS(2725),
    [anon_sym_restrict] = ACTIONS(2725),
    [anon_sym___restrict__] = ACTIONS(2725),
    [anon_sym__Atomic] = ACTIONS(2725),
    [anon_sym__Noreturn] = ACTIONS(2725),
    [anon_sym_noreturn] = ACTIONS(2725),
    [anon_sym__Nonnull] = ACTIONS(2725),
    [anon_sym_mutable] = ACTIONS(2725),
    [anon_sym_constinit] = ACTIONS(2725),
    [anon_sym_consteval] = ACTIONS(2725),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2734),
    [anon_sym_enum] = ACTIONS(2737),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2743),
    [anon_sym_union] = ACTIONS(2746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2749),
    [anon_sym_let] = ACTIONS(2749),
    [anon_sym_This] = ACTIONS(2749),
    [anon_sym_decltype] = ACTIONS(2752),
    [anon_sym_explicit] = ACTIONS(2755),
    [anon_sym_typename] = ACTIONS(2758),
    [anon_sym_private] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(3127),
    [anon_sym_operator] = ACTIONS(2767),
    [anon_sym_friend] = ACTIONS(3130),
    [anon_sym_public] = ACTIONS(2761),
    [anon_sym_protected] = ACTIONS(2761),
    [anon_sym_static_assert] = ACTIONS(3133),
    [anon_sym_precise] = ACTIONS(2776),
    [anon_sym_shared] = ACTIONS(2776),
    [anon_sym_groupshared] = ACTIONS(2776),
    [anon_sym_uniform] = ACTIONS(2776),
    [anon_sym_row_major] = ACTIONS(2776),
    [anon_sym_column_major] = ACTIONS(2776),
    [anon_sym_globallycoherent] = ACTIONS(2776),
    [anon_sym_centroid] = ACTIONS(2776),
    [anon_sym_noperspective] = ACTIONS(2776),
    [anon_sym_nointerpolation] = ACTIONS(2776),
    [anon_sym_sample] = ACTIONS(2776),
    [anon_sym_linear] = ACTIONS(2776),
    [anon_sym_snorm] = ACTIONS(2776),
    [anon_sym_unorm] = ACTIONS(2776),
    [anon_sym_point] = ACTIONS(2776),
    [anon_sym_line] = ACTIONS(2776),
    [anon_sym_triangleadj] = ACTIONS(2776),
    [anon_sym_lineadj] = ACTIONS(2776),
    [anon_sym_triangle] = ACTIONS(2776),
    [anon_sym_interface] = ACTIONS(2779),
    [anon_sym_extension] = ACTIONS(2782),
    [anon_sym___init] = ACTIONS(3136),
    [anon_sym___subscript] = ACTIONS(3139),
    [anon_sym_property] = ACTIONS(3142),
    [anon_sym_associatedtype] = ACTIONS(3145),
  },
  [333] = {
    [sym_identifier] = ACTIONS(3148),
    [aux_sym_preproc_include_token1] = ACTIONS(3148),
    [aux_sym_preproc_def_token1] = ACTIONS(3148),
    [aux_sym_preproc_if_token1] = ACTIONS(3148),
    [aux_sym_preproc_if_token2] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3148),
    [aux_sym_preproc_else_token1] = ACTIONS(3148),
    [aux_sym_preproc_elif_token1] = ACTIONS(3148),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3148),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3148),
    [sym_preproc_directive] = ACTIONS(3148),
    [anon_sym_LPAREN2] = ACTIONS(3150),
    [anon_sym_BANG] = ACTIONS(3150),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_DASH] = ACTIONS(3148),
    [anon_sym_PLUS] = ACTIONS(3148),
    [anon_sym_STAR] = ACTIONS(3150),
    [anon_sym_AMP_AMP] = ACTIONS(3150),
    [anon_sym_AMP] = ACTIONS(3148),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym___extension__] = ACTIONS(3148),
    [anon_sym_typedef] = ACTIONS(3148),
    [anon_sym_in] = ACTIONS(3148),
    [anon_sym_out] = ACTIONS(3148),
    [anon_sym_inout] = ACTIONS(3148),
    [anon_sym_virtual] = ACTIONS(3148),
    [anon_sym_extern] = ACTIONS(3148),
    [anon_sym___attribute__] = ACTIONS(3148),
    [anon_sym___attribute] = ACTIONS(3148),
    [anon_sym_using] = ACTIONS(3148),
    [anon_sym_COLON_COLON] = ACTIONS(3150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3150),
    [anon_sym___declspec] = ACTIONS(3148),
    [anon_sym___based] = ACTIONS(3148),
    [anon_sym___cdecl] = ACTIONS(3148),
    [anon_sym___clrcall] = ACTIONS(3148),
    [anon_sym___stdcall] = ACTIONS(3148),
    [anon_sym___fastcall] = ACTIONS(3148),
    [anon_sym___thiscall] = ACTIONS(3148),
    [anon_sym___vectorcall] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3150),
    [anon_sym_signed] = ACTIONS(3148),
    [anon_sym_unsigned] = ACTIONS(3148),
    [anon_sym_long] = ACTIONS(3148),
    [anon_sym_short] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_static] = ACTIONS(3148),
    [anon_sym_register] = ACTIONS(3148),
    [anon_sym_inline] = ACTIONS(3148),
    [anon_sym___inline] = ACTIONS(3148),
    [anon_sym___inline__] = ACTIONS(3148),
    [anon_sym___forceinline] = ACTIONS(3148),
    [anon_sym_thread_local] = ACTIONS(3148),
    [anon_sym___thread] = ACTIONS(3148),
    [anon_sym_const] = ACTIONS(3148),
    [anon_sym_constexpr] = ACTIONS(3148),
    [anon_sym_volatile] = ACTIONS(3148),
    [anon_sym_restrict] = ACTIONS(3148),
    [anon_sym___restrict__] = ACTIONS(3148),
    [anon_sym__Atomic] = ACTIONS(3148),
    [anon_sym__Noreturn] = ACTIONS(3148),
    [anon_sym_noreturn] = ACTIONS(3148),
    [anon_sym__Nonnull] = ACTIONS(3148),
    [anon_sym_mutable] = ACTIONS(3148),
    [anon_sym_constinit] = ACTIONS(3148),
    [anon_sym_consteval] = ACTIONS(3148),
    [anon_sym_alignas] = ACTIONS(3148),
    [anon_sym__Alignas] = ACTIONS(3148),
    [sym_primitive_type] = ACTIONS(3148),
    [anon_sym_enum] = ACTIONS(3148),
    [anon_sym_class] = ACTIONS(3148),
    [anon_sym_struct] = ACTIONS(3148),
    [anon_sym_union] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_switch] = ACTIONS(3148),
    [anon_sym_case] = ACTIONS(3148),
    [anon_sym_default] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_for] = ACTIONS(3148),
    [anon_sym_return] = ACTIONS(3148),
    [anon_sym_break] = ACTIONS(3148),
    [anon_sym_continue] = ACTIONS(3148),
    [anon_sym_goto] = ACTIONS(3148),
    [anon_sym___try] = ACTIONS(3148),
    [anon_sym___leave] = ACTIONS(3148),
    [anon_sym_not] = ACTIONS(3148),
    [anon_sym_compl] = ACTIONS(3148),
    [anon_sym_DASH_DASH] = ACTIONS(3150),
    [anon_sym_PLUS_PLUS] = ACTIONS(3150),
    [anon_sym_sizeof] = ACTIONS(3148),
    [anon_sym___alignof__] = ACTIONS(3148),
    [anon_sym___alignof] = ACTIONS(3148),
    [anon_sym__alignof] = ACTIONS(3148),
    [anon_sym_alignof] = ACTIONS(3148),
    [anon_sym__Alignof] = ACTIONS(3148),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3148),
    [anon_sym_asm] = ACTIONS(3148),
    [anon_sym___asm__] = ACTIONS(3148),
    [anon_sym___asm] = ACTIONS(3148),
    [sym_number_literal] = ACTIONS(3150),
    [anon_sym_L_SQUOTE] = ACTIONS(3150),
    [anon_sym_u_SQUOTE] = ACTIONS(3150),
    [anon_sym_U_SQUOTE] = ACTIONS(3150),
    [anon_sym_u8_SQUOTE] = ACTIONS(3150),
    [anon_sym_SQUOTE] = ACTIONS(3150),
    [anon_sym_L_DQUOTE] = ACTIONS(3150),
    [anon_sym_u_DQUOTE] = ACTIONS(3150),
    [anon_sym_U_DQUOTE] = ACTIONS(3150),
    [anon_sym_u8_DQUOTE] = ACTIONS(3150),
    [anon_sym_DQUOTE] = ACTIONS(3150),
    [sym_true] = ACTIONS(3148),
    [sym_false] = ACTIONS(3148),
    [anon_sym_NULL] = ACTIONS(3148),
    [anon_sym_nullptr] = ACTIONS(3148),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3148),
    [anon_sym_let] = ACTIONS(3148),
    [anon_sym_This] = ACTIONS(3148),
    [anon_sym_decltype] = ACTIONS(3148),
    [anon_sym_explicit] = ACTIONS(3148),
    [anon_sym_typename] = ACTIONS(3148),
    [anon_sym_template] = ACTIONS(3148),
    [anon_sym_operator] = ACTIONS(3148),
    [anon_sym_try] = ACTIONS(3148),
    [anon_sym_delete] = ACTIONS(3148),
    [anon_sym_throw] = ACTIONS(3148),
    [anon_sym_namespace] = ACTIONS(3148),
    [anon_sym_static_assert] = ACTIONS(3148),
    [anon_sym_concept] = ACTIONS(3148),
    [anon_sym_co_return] = ACTIONS(3148),
    [anon_sym_co_yield] = ACTIONS(3148),
    [anon_sym_catch] = ACTIONS(3148),
    [anon_sym_R_DQUOTE] = ACTIONS(3150),
    [anon_sym_LR_DQUOTE] = ACTIONS(3150),
    [anon_sym_uR_DQUOTE] = ACTIONS(3150),
    [anon_sym_UR_DQUOTE] = ACTIONS(3150),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3150),
    [anon_sym_co_await] = ACTIONS(3148),
    [anon_sym_new] = ACTIONS(3148),
    [anon_sym_requires] = ACTIONS(3148),
    [sym_this] = ACTIONS(3148),
    [anon_sym_discard] = ACTIONS(3148),
    [anon_sym_precise] = ACTIONS(3148),
    [anon_sym_shared] = ACTIONS(3148),
    [anon_sym_groupshared] = ACTIONS(3148),
    [anon_sym_uniform] = ACTIONS(3148),
    [anon_sym_row_major] = ACTIONS(3148),
    [anon_sym_column_major] = ACTIONS(3148),
    [anon_sym_globallycoherent] = ACTIONS(3148),
    [anon_sym_centroid] = ACTIONS(3148),
    [anon_sym_noperspective] = ACTIONS(3148),
    [anon_sym_nointerpolation] = ACTIONS(3148),
    [anon_sym_sample] = ACTIONS(3148),
    [anon_sym_linear] = ACTIONS(3148),
    [anon_sym_snorm] = ACTIONS(3148),
    [anon_sym_unorm] = ACTIONS(3148),
    [anon_sym_point] = ACTIONS(3148),
    [anon_sym_line] = ACTIONS(3148),
    [anon_sym_triangleadj] = ACTIONS(3148),
    [anon_sym_lineadj] = ACTIONS(3148),
    [anon_sym_triangle] = ACTIONS(3148),
    [anon_sym_cbuffer] = ACTIONS(3148),
    [anon_sym_interface] = ACTIONS(3148),
    [anon_sym_extension] = ACTIONS(3148),
  },
  [334] = {
    [sym_preproc_def] = STATE(332),
    [sym_preproc_function_def] = STATE(332),
    [sym_preproc_call] = STATE(332),
    [sym_preproc_if_in_field_declaration_list] = STATE(332),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(332),
    [sym_type_definition] = STATE(332),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7130),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7985),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(332),
    [sym_field_declaration] = STATE(332),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2676),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(332),
    [sym_operator_cast] = STATE(9196),
    [sym_inline_method_definition] = STATE(332),
    [sym__constructor_specifiers] = STATE(2676),
    [sym_operator_cast_definition] = STATE(332),
    [sym_operator_cast_declaration] = STATE(332),
    [sym_constructor_or_destructor_definition] = STATE(332),
    [sym_constructor_or_destructor_declaration] = STATE(332),
    [sym_friend_declaration] = STATE(332),
    [sym_access_specifier] = STATE(11528),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(332),
    [sym_alias_declaration] = STATE(332),
    [sym_static_assert_declaration] = STATE(332),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9196),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(332),
    [sym_subscript_declaration] = STATE(332),
    [sym_property_declaration] = STATE(332),
    [sym_associatedtype_declaration] = STATE(332),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(332),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9547),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2676),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3152),
    [aux_sym_preproc_if_token1] = ACTIONS(3154),
    [aux_sym_preproc_if_token2] = ACTIONS(3156),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3158),
    [sym_preproc_directive] = ACTIONS(3160),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3162),
    [anon_sym___extension__] = ACTIONS(3164),
    [anon_sym_typedef] = ACTIONS(3166),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3168),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3170),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3172),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3174),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3176),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3178),
    [anon_sym___subscript] = ACTIONS(3180),
    [anon_sym_property] = ACTIONS(3182),
    [anon_sym_associatedtype] = ACTIONS(3184),
  },
  [335] = {
    [sym_identifier] = ACTIONS(2404),
    [aux_sym_preproc_include_token1] = ACTIONS(2404),
    [aux_sym_preproc_def_token1] = ACTIONS(2404),
    [aux_sym_preproc_if_token1] = ACTIONS(2404),
    [aux_sym_preproc_if_token2] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2404),
    [aux_sym_preproc_else_token1] = ACTIONS(2404),
    [aux_sym_preproc_elif_token1] = ACTIONS(2404),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2404),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2404),
    [sym_preproc_directive] = ACTIONS(2404),
    [anon_sym_LPAREN2] = ACTIONS(2402),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_TILDE] = ACTIONS(2402),
    [anon_sym_DASH] = ACTIONS(2404),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_STAR] = ACTIONS(2402),
    [anon_sym_AMP_AMP] = ACTIONS(2402),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2402),
    [anon_sym___extension__] = ACTIONS(2404),
    [anon_sym_typedef] = ACTIONS(2404),
    [anon_sym_in] = ACTIONS(2404),
    [anon_sym_out] = ACTIONS(2404),
    [anon_sym_inout] = ACTIONS(2404),
    [anon_sym_virtual] = ACTIONS(2404),
    [anon_sym_extern] = ACTIONS(2404),
    [anon_sym___attribute__] = ACTIONS(2404),
    [anon_sym___attribute] = ACTIONS(2404),
    [anon_sym_using] = ACTIONS(2404),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2402),
    [anon_sym___declspec] = ACTIONS(2404),
    [anon_sym___based] = ACTIONS(2404),
    [anon_sym___cdecl] = ACTIONS(2404),
    [anon_sym___clrcall] = ACTIONS(2404),
    [anon_sym___stdcall] = ACTIONS(2404),
    [anon_sym___fastcall] = ACTIONS(2404),
    [anon_sym___thiscall] = ACTIONS(2404),
    [anon_sym___vectorcall] = ACTIONS(2404),
    [anon_sym_LBRACE] = ACTIONS(2402),
    [anon_sym_signed] = ACTIONS(2404),
    [anon_sym_unsigned] = ACTIONS(2404),
    [anon_sym_long] = ACTIONS(2404),
    [anon_sym_short] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_register] = ACTIONS(2404),
    [anon_sym_inline] = ACTIONS(2404),
    [anon_sym___inline] = ACTIONS(2404),
    [anon_sym___inline__] = ACTIONS(2404),
    [anon_sym___forceinline] = ACTIONS(2404),
    [anon_sym_thread_local] = ACTIONS(2404),
    [anon_sym___thread] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [anon_sym_constexpr] = ACTIONS(2404),
    [anon_sym_volatile] = ACTIONS(2404),
    [anon_sym_restrict] = ACTIONS(2404),
    [anon_sym___restrict__] = ACTIONS(2404),
    [anon_sym__Atomic] = ACTIONS(2404),
    [anon_sym__Noreturn] = ACTIONS(2404),
    [anon_sym_noreturn] = ACTIONS(2404),
    [anon_sym__Nonnull] = ACTIONS(2404),
    [anon_sym_mutable] = ACTIONS(2404),
    [anon_sym_constinit] = ACTIONS(2404),
    [anon_sym_consteval] = ACTIONS(2404),
    [anon_sym_alignas] = ACTIONS(2404),
    [anon_sym__Alignas] = ACTIONS(2404),
    [sym_primitive_type] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
    [anon_sym_class] = ACTIONS(2404),
    [anon_sym_struct] = ACTIONS(2404),
    [anon_sym_union] = ACTIONS(2404),
    [anon_sym_if] = ACTIONS(2404),
    [anon_sym_else] = ACTIONS(2404),
    [anon_sym_switch] = ACTIONS(2404),
    [anon_sym_case] = ACTIONS(2404),
    [anon_sym_default] = ACTIONS(2404),
    [anon_sym_while] = ACTIONS(2404),
    [anon_sym_do] = ACTIONS(2404),
    [anon_sym_for] = ACTIONS(2404),
    [anon_sym_return] = ACTIONS(2404),
    [anon_sym_break] = ACTIONS(2404),
    [anon_sym_continue] = ACTIONS(2404),
    [anon_sym_goto] = ACTIONS(2404),
    [anon_sym___try] = ACTIONS(2404),
    [anon_sym___leave] = ACTIONS(2404),
    [anon_sym_not] = ACTIONS(2404),
    [anon_sym_compl] = ACTIONS(2404),
    [anon_sym_DASH_DASH] = ACTIONS(2402),
    [anon_sym_PLUS_PLUS] = ACTIONS(2402),
    [anon_sym_sizeof] = ACTIONS(2404),
    [anon_sym___alignof__] = ACTIONS(2404),
    [anon_sym___alignof] = ACTIONS(2404),
    [anon_sym__alignof] = ACTIONS(2404),
    [anon_sym_alignof] = ACTIONS(2404),
    [anon_sym__Alignof] = ACTIONS(2404),
    [anon_sym_offsetof] = ACTIONS(2404),
    [anon_sym__Generic] = ACTIONS(2404),
    [anon_sym_asm] = ACTIONS(2404),
    [anon_sym___asm__] = ACTIONS(2404),
    [anon_sym___asm] = ACTIONS(2404),
    [sym_number_literal] = ACTIONS(2402),
    [anon_sym_L_SQUOTE] = ACTIONS(2402),
    [anon_sym_u_SQUOTE] = ACTIONS(2402),
    [anon_sym_U_SQUOTE] = ACTIONS(2402),
    [anon_sym_u8_SQUOTE] = ACTIONS(2402),
    [anon_sym_SQUOTE] = ACTIONS(2402),
    [anon_sym_L_DQUOTE] = ACTIONS(2402),
    [anon_sym_u_DQUOTE] = ACTIONS(2402),
    [anon_sym_U_DQUOTE] = ACTIONS(2402),
    [anon_sym_u8_DQUOTE] = ACTIONS(2402),
    [anon_sym_DQUOTE] = ACTIONS(2402),
    [sym_true] = ACTIONS(2404),
    [sym_false] = ACTIONS(2404),
    [anon_sym_NULL] = ACTIONS(2404),
    [anon_sym_nullptr] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2404),
    [anon_sym_let] = ACTIONS(2404),
    [anon_sym_This] = ACTIONS(2404),
    [anon_sym_decltype] = ACTIONS(2404),
    [anon_sym_explicit] = ACTIONS(2404),
    [anon_sym_typename] = ACTIONS(2404),
    [anon_sym_template] = ACTIONS(2404),
    [anon_sym_operator] = ACTIONS(2404),
    [anon_sym_try] = ACTIONS(2404),
    [anon_sym_delete] = ACTIONS(2404),
    [anon_sym_throw] = ACTIONS(2404),
    [anon_sym_namespace] = ACTIONS(2404),
    [anon_sym_static_assert] = ACTIONS(2404),
    [anon_sym_concept] = ACTIONS(2404),
    [anon_sym_co_return] = ACTIONS(2404),
    [anon_sym_co_yield] = ACTIONS(2404),
    [anon_sym_catch] = ACTIONS(2404),
    [anon_sym_R_DQUOTE] = ACTIONS(2402),
    [anon_sym_LR_DQUOTE] = ACTIONS(2402),
    [anon_sym_uR_DQUOTE] = ACTIONS(2402),
    [anon_sym_UR_DQUOTE] = ACTIONS(2402),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2402),
    [anon_sym_co_await] = ACTIONS(2404),
    [anon_sym_new] = ACTIONS(2404),
    [anon_sym_requires] = ACTIONS(2404),
    [sym_this] = ACTIONS(2404),
    [anon_sym_discard] = ACTIONS(2404),
    [anon_sym_precise] = ACTIONS(2404),
    [anon_sym_shared] = ACTIONS(2404),
    [anon_sym_groupshared] = ACTIONS(2404),
    [anon_sym_uniform] = ACTIONS(2404),
    [anon_sym_row_major] = ACTIONS(2404),
    [anon_sym_column_major] = ACTIONS(2404),
    [anon_sym_globallycoherent] = ACTIONS(2404),
    [anon_sym_centroid] = ACTIONS(2404),
    [anon_sym_noperspective] = ACTIONS(2404),
    [anon_sym_nointerpolation] = ACTIONS(2404),
    [anon_sym_sample] = ACTIONS(2404),
    [anon_sym_linear] = ACTIONS(2404),
    [anon_sym_snorm] = ACTIONS(2404),
    [anon_sym_unorm] = ACTIONS(2404),
    [anon_sym_point] = ACTIONS(2404),
    [anon_sym_line] = ACTIONS(2404),
    [anon_sym_triangleadj] = ACTIONS(2404),
    [anon_sym_lineadj] = ACTIONS(2404),
    [anon_sym_triangle] = ACTIONS(2404),
    [anon_sym_cbuffer] = ACTIONS(2404),
    [anon_sym_interface] = ACTIONS(2404),
    [anon_sym_extension] = ACTIONS(2404),
  },
  [336] = {
    [sym_preproc_def] = STATE(334),
    [sym_preproc_function_def] = STATE(334),
    [sym_preproc_call] = STATE(334),
    [sym_preproc_if_in_field_declaration_list] = STATE(334),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(334),
    [sym_type_definition] = STATE(334),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7130),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7985),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(334),
    [sym_field_declaration] = STATE(334),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2676),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(334),
    [sym_operator_cast] = STATE(9196),
    [sym_inline_method_definition] = STATE(334),
    [sym__constructor_specifiers] = STATE(2676),
    [sym_operator_cast_definition] = STATE(334),
    [sym_operator_cast_declaration] = STATE(334),
    [sym_constructor_or_destructor_definition] = STATE(334),
    [sym_constructor_or_destructor_declaration] = STATE(334),
    [sym_friend_declaration] = STATE(334),
    [sym_access_specifier] = STATE(11528),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(334),
    [sym_alias_declaration] = STATE(334),
    [sym_static_assert_declaration] = STATE(334),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9196),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(334),
    [sym_subscript_declaration] = STATE(334),
    [sym_property_declaration] = STATE(334),
    [sym_associatedtype_declaration] = STATE(334),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(334),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9547),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2676),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3152),
    [aux_sym_preproc_if_token1] = ACTIONS(3154),
    [aux_sym_preproc_if_token2] = ACTIONS(3186),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3158),
    [sym_preproc_directive] = ACTIONS(3160),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3188),
    [anon_sym___extension__] = ACTIONS(3164),
    [anon_sym_typedef] = ACTIONS(3166),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3168),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3170),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3172),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3174),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3176),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3178),
    [anon_sym___subscript] = ACTIONS(3180),
    [anon_sym_property] = ACTIONS(3182),
    [anon_sym_associatedtype] = ACTIONS(3184),
  },
  [337] = {
    [sym_preproc_def] = STATE(338),
    [sym_preproc_function_def] = STATE(338),
    [sym_preproc_call] = STATE(338),
    [sym_preproc_if_in_field_declaration_list] = STATE(338),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(338),
    [sym_type_definition] = STATE(338),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(338),
    [sym_field_declaration] = STATE(338),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(338),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(338),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(338),
    [sym_operator_cast_declaration] = STATE(338),
    [sym_constructor_or_destructor_definition] = STATE(338),
    [sym_constructor_or_destructor_declaration] = STATE(338),
    [sym_friend_declaration] = STATE(338),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(338),
    [sym_alias_declaration] = STATE(338),
    [sym_static_assert_declaration] = STATE(338),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(338),
    [sym_subscript_declaration] = STATE(338),
    [sym_property_declaration] = STATE(338),
    [sym_associatedtype_declaration] = STATE(338),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(338),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3190),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3192),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [338] = {
    [sym_preproc_def] = STATE(374),
    [sym_preproc_function_def] = STATE(374),
    [sym_preproc_call] = STATE(374),
    [sym_preproc_if_in_field_declaration_list] = STATE(374),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(374),
    [sym_type_definition] = STATE(374),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(374),
    [sym_field_declaration] = STATE(374),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(374),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(374),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(374),
    [sym_operator_cast_declaration] = STATE(374),
    [sym_constructor_or_destructor_definition] = STATE(374),
    [sym_constructor_or_destructor_declaration] = STATE(374),
    [sym_friend_declaration] = STATE(374),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(374),
    [sym_alias_declaration] = STATE(374),
    [sym_static_assert_declaration] = STATE(374),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(374),
    [sym_subscript_declaration] = STATE(374),
    [sym_property_declaration] = STATE(374),
    [sym_associatedtype_declaration] = STATE(374),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3196),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [339] = {
    [sym_else_clause] = STATE(384),
    [sym_identifier] = ACTIONS(3096),
    [aux_sym_preproc_include_token1] = ACTIONS(3096),
    [aux_sym_preproc_def_token1] = ACTIONS(3096),
    [aux_sym_preproc_if_token1] = ACTIONS(3096),
    [aux_sym_preproc_if_token2] = ACTIONS(3096),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3096),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3096),
    [aux_sym_preproc_else_token1] = ACTIONS(3096),
    [aux_sym_preproc_elif_token1] = ACTIONS(3096),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3096),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3096),
    [sym_preproc_directive] = ACTIONS(3096),
    [anon_sym_LPAREN2] = ACTIONS(3094),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_TILDE] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3096),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_STAR] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_AMP] = ACTIONS(3096),
    [anon_sym_SEMI] = ACTIONS(3094),
    [anon_sym___extension__] = ACTIONS(3096),
    [anon_sym_typedef] = ACTIONS(3096),
    [anon_sym_in] = ACTIONS(3096),
    [anon_sym_out] = ACTIONS(3096),
    [anon_sym_inout] = ACTIONS(3096),
    [anon_sym_virtual] = ACTIONS(3096),
    [anon_sym_extern] = ACTIONS(3096),
    [anon_sym___attribute__] = ACTIONS(3096),
    [anon_sym___attribute] = ACTIONS(3096),
    [anon_sym_using] = ACTIONS(3096),
    [anon_sym_COLON_COLON] = ACTIONS(3094),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3094),
    [anon_sym___declspec] = ACTIONS(3096),
    [anon_sym___based] = ACTIONS(3096),
    [anon_sym___cdecl] = ACTIONS(3096),
    [anon_sym___clrcall] = ACTIONS(3096),
    [anon_sym___stdcall] = ACTIONS(3096),
    [anon_sym___fastcall] = ACTIONS(3096),
    [anon_sym___thiscall] = ACTIONS(3096),
    [anon_sym___vectorcall] = ACTIONS(3096),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_signed] = ACTIONS(3096),
    [anon_sym_unsigned] = ACTIONS(3096),
    [anon_sym_long] = ACTIONS(3096),
    [anon_sym_short] = ACTIONS(3096),
    [anon_sym_LBRACK] = ACTIONS(3096),
    [anon_sym_static] = ACTIONS(3096),
    [anon_sym_register] = ACTIONS(3096),
    [anon_sym_inline] = ACTIONS(3096),
    [anon_sym___inline] = ACTIONS(3096),
    [anon_sym___inline__] = ACTIONS(3096),
    [anon_sym___forceinline] = ACTIONS(3096),
    [anon_sym_thread_local] = ACTIONS(3096),
    [anon_sym___thread] = ACTIONS(3096),
    [anon_sym_const] = ACTIONS(3096),
    [anon_sym_constexpr] = ACTIONS(3096),
    [anon_sym_volatile] = ACTIONS(3096),
    [anon_sym_restrict] = ACTIONS(3096),
    [anon_sym___restrict__] = ACTIONS(3096),
    [anon_sym__Atomic] = ACTIONS(3096),
    [anon_sym__Noreturn] = ACTIONS(3096),
    [anon_sym_noreturn] = ACTIONS(3096),
    [anon_sym__Nonnull] = ACTIONS(3096),
    [anon_sym_mutable] = ACTIONS(3096),
    [anon_sym_constinit] = ACTIONS(3096),
    [anon_sym_consteval] = ACTIONS(3096),
    [anon_sym_alignas] = ACTIONS(3096),
    [anon_sym__Alignas] = ACTIONS(3096),
    [sym_primitive_type] = ACTIONS(3096),
    [anon_sym_enum] = ACTIONS(3096),
    [anon_sym_class] = ACTIONS(3096),
    [anon_sym_struct] = ACTIONS(3096),
    [anon_sym_union] = ACTIONS(3096),
    [anon_sym_if] = ACTIONS(3096),
    [anon_sym_else] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3096),
    [anon_sym_case] = ACTIONS(3096),
    [anon_sym_default] = ACTIONS(3096),
    [anon_sym_while] = ACTIONS(3096),
    [anon_sym_do] = ACTIONS(3096),
    [anon_sym_for] = ACTIONS(3096),
    [anon_sym_return] = ACTIONS(3096),
    [anon_sym_break] = ACTIONS(3096),
    [anon_sym_continue] = ACTIONS(3096),
    [anon_sym_goto] = ACTIONS(3096),
    [anon_sym___try] = ACTIONS(3096),
    [anon_sym___leave] = ACTIONS(3096),
    [anon_sym_not] = ACTIONS(3096),
    [anon_sym_compl] = ACTIONS(3096),
    [anon_sym_DASH_DASH] = ACTIONS(3094),
    [anon_sym_PLUS_PLUS] = ACTIONS(3094),
    [anon_sym_sizeof] = ACTIONS(3096),
    [anon_sym___alignof__] = ACTIONS(3096),
    [anon_sym___alignof] = ACTIONS(3096),
    [anon_sym__alignof] = ACTIONS(3096),
    [anon_sym_alignof] = ACTIONS(3096),
    [anon_sym__Alignof] = ACTIONS(3096),
    [anon_sym_offsetof] = ACTIONS(3096),
    [anon_sym__Generic] = ACTIONS(3096),
    [anon_sym_asm] = ACTIONS(3096),
    [anon_sym___asm__] = ACTIONS(3096),
    [anon_sym___asm] = ACTIONS(3096),
    [sym_number_literal] = ACTIONS(3094),
    [anon_sym_L_SQUOTE] = ACTIONS(3094),
    [anon_sym_u_SQUOTE] = ACTIONS(3094),
    [anon_sym_U_SQUOTE] = ACTIONS(3094),
    [anon_sym_u8_SQUOTE] = ACTIONS(3094),
    [anon_sym_SQUOTE] = ACTIONS(3094),
    [anon_sym_L_DQUOTE] = ACTIONS(3094),
    [anon_sym_u_DQUOTE] = ACTIONS(3094),
    [anon_sym_U_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8_DQUOTE] = ACTIONS(3094),
    [anon_sym_DQUOTE] = ACTIONS(3094),
    [sym_true] = ACTIONS(3096),
    [sym_false] = ACTIONS(3096),
    [anon_sym_NULL] = ACTIONS(3096),
    [anon_sym_nullptr] = ACTIONS(3096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3096),
    [anon_sym_let] = ACTIONS(3096),
    [anon_sym_This] = ACTIONS(3096),
    [anon_sym_decltype] = ACTIONS(3096),
    [anon_sym_explicit] = ACTIONS(3096),
    [anon_sym_typename] = ACTIONS(3096),
    [anon_sym_template] = ACTIONS(3096),
    [anon_sym_operator] = ACTIONS(3096),
    [anon_sym_try] = ACTIONS(3096),
    [anon_sym_delete] = ACTIONS(3096),
    [anon_sym_throw] = ACTIONS(3096),
    [anon_sym_namespace] = ACTIONS(3096),
    [anon_sym_static_assert] = ACTIONS(3096),
    [anon_sym_concept] = ACTIONS(3096),
    [anon_sym_co_return] = ACTIONS(3096),
    [anon_sym_co_yield] = ACTIONS(3096),
    [anon_sym_R_DQUOTE] = ACTIONS(3094),
    [anon_sym_LR_DQUOTE] = ACTIONS(3094),
    [anon_sym_uR_DQUOTE] = ACTIONS(3094),
    [anon_sym_UR_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3094),
    [anon_sym_co_await] = ACTIONS(3096),
    [anon_sym_new] = ACTIONS(3096),
    [anon_sym_requires] = ACTIONS(3096),
    [sym_this] = ACTIONS(3096),
    [anon_sym_discard] = ACTIONS(3096),
    [anon_sym_precise] = ACTIONS(3096),
    [anon_sym_shared] = ACTIONS(3096),
    [anon_sym_groupshared] = ACTIONS(3096),
    [anon_sym_uniform] = ACTIONS(3096),
    [anon_sym_row_major] = ACTIONS(3096),
    [anon_sym_column_major] = ACTIONS(3096),
    [anon_sym_globallycoherent] = ACTIONS(3096),
    [anon_sym_centroid] = ACTIONS(3096),
    [anon_sym_noperspective] = ACTIONS(3096),
    [anon_sym_nointerpolation] = ACTIONS(3096),
    [anon_sym_sample] = ACTIONS(3096),
    [anon_sym_linear] = ACTIONS(3096),
    [anon_sym_snorm] = ACTIONS(3096),
    [anon_sym_unorm] = ACTIONS(3096),
    [anon_sym_point] = ACTIONS(3096),
    [anon_sym_line] = ACTIONS(3096),
    [anon_sym_triangleadj] = ACTIONS(3096),
    [anon_sym_lineadj] = ACTIONS(3096),
    [anon_sym_triangle] = ACTIONS(3096),
    [anon_sym_cbuffer] = ACTIONS(3096),
    [anon_sym_interface] = ACTIONS(3096),
    [anon_sym_extension] = ACTIONS(3096),
  },
  [340] = {
    [sym_identifier] = ACTIONS(2414),
    [aux_sym_preproc_include_token1] = ACTIONS(2414),
    [aux_sym_preproc_def_token1] = ACTIONS(2414),
    [aux_sym_preproc_if_token1] = ACTIONS(2414),
    [aux_sym_preproc_if_token2] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2414),
    [aux_sym_preproc_else_token1] = ACTIONS(2414),
    [aux_sym_preproc_elif_token1] = ACTIONS(2414),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2414),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2414),
    [sym_preproc_directive] = ACTIONS(2414),
    [anon_sym_LPAREN2] = ACTIONS(2412),
    [anon_sym_BANG] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym___extension__] = ACTIONS(2414),
    [anon_sym_typedef] = ACTIONS(2414),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_out] = ACTIONS(2414),
    [anon_sym_inout] = ACTIONS(2414),
    [anon_sym_virtual] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym___attribute__] = ACTIONS(2414),
    [anon_sym___attribute] = ACTIONS(2414),
    [anon_sym_using] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2412),
    [anon_sym___declspec] = ACTIONS(2414),
    [anon_sym___based] = ACTIONS(2414),
    [anon_sym___cdecl] = ACTIONS(2414),
    [anon_sym___clrcall] = ACTIONS(2414),
    [anon_sym___stdcall] = ACTIONS(2414),
    [anon_sym___fastcall] = ACTIONS(2414),
    [anon_sym___thiscall] = ACTIONS(2414),
    [anon_sym___vectorcall] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(2412),
    [anon_sym_signed] = ACTIONS(2414),
    [anon_sym_unsigned] = ACTIONS(2414),
    [anon_sym_long] = ACTIONS(2414),
    [anon_sym_short] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_register] = ACTIONS(2414),
    [anon_sym_inline] = ACTIONS(2414),
    [anon_sym___inline] = ACTIONS(2414),
    [anon_sym___inline__] = ACTIONS(2414),
    [anon_sym___forceinline] = ACTIONS(2414),
    [anon_sym_thread_local] = ACTIONS(2414),
    [anon_sym___thread] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_constexpr] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym_restrict] = ACTIONS(2414),
    [anon_sym___restrict__] = ACTIONS(2414),
    [anon_sym__Atomic] = ACTIONS(2414),
    [anon_sym__Noreturn] = ACTIONS(2414),
    [anon_sym_noreturn] = ACTIONS(2414),
    [anon_sym__Nonnull] = ACTIONS(2414),
    [anon_sym_mutable] = ACTIONS(2414),
    [anon_sym_constinit] = ACTIONS(2414),
    [anon_sym_consteval] = ACTIONS(2414),
    [anon_sym_alignas] = ACTIONS(2414),
    [anon_sym__Alignas] = ACTIONS(2414),
    [sym_primitive_type] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [anon_sym_if] = ACTIONS(2414),
    [anon_sym_else] = ACTIONS(2414),
    [anon_sym_switch] = ACTIONS(2414),
    [anon_sym_case] = ACTIONS(2414),
    [anon_sym_default] = ACTIONS(2414),
    [anon_sym_while] = ACTIONS(2414),
    [anon_sym_do] = ACTIONS(2414),
    [anon_sym_for] = ACTIONS(2414),
    [anon_sym_return] = ACTIONS(2414),
    [anon_sym_break] = ACTIONS(2414),
    [anon_sym_continue] = ACTIONS(2414),
    [anon_sym_goto] = ACTIONS(2414),
    [anon_sym___try] = ACTIONS(2414),
    [anon_sym___leave] = ACTIONS(2414),
    [anon_sym_not] = ACTIONS(2414),
    [anon_sym_compl] = ACTIONS(2414),
    [anon_sym_DASH_DASH] = ACTIONS(2412),
    [anon_sym_PLUS_PLUS] = ACTIONS(2412),
    [anon_sym_sizeof] = ACTIONS(2414),
    [anon_sym___alignof__] = ACTIONS(2414),
    [anon_sym___alignof] = ACTIONS(2414),
    [anon_sym__alignof] = ACTIONS(2414),
    [anon_sym_alignof] = ACTIONS(2414),
    [anon_sym__Alignof] = ACTIONS(2414),
    [anon_sym_offsetof] = ACTIONS(2414),
    [anon_sym__Generic] = ACTIONS(2414),
    [anon_sym_asm] = ACTIONS(2414),
    [anon_sym___asm__] = ACTIONS(2414),
    [anon_sym___asm] = ACTIONS(2414),
    [sym_number_literal] = ACTIONS(2412),
    [anon_sym_L_SQUOTE] = ACTIONS(2412),
    [anon_sym_u_SQUOTE] = ACTIONS(2412),
    [anon_sym_U_SQUOTE] = ACTIONS(2412),
    [anon_sym_u8_SQUOTE] = ACTIONS(2412),
    [anon_sym_SQUOTE] = ACTIONS(2412),
    [anon_sym_L_DQUOTE] = ACTIONS(2412),
    [anon_sym_u_DQUOTE] = ACTIONS(2412),
    [anon_sym_U_DQUOTE] = ACTIONS(2412),
    [anon_sym_u8_DQUOTE] = ACTIONS(2412),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [sym_true] = ACTIONS(2414),
    [sym_false] = ACTIONS(2414),
    [anon_sym_NULL] = ACTIONS(2414),
    [anon_sym_nullptr] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2414),
    [anon_sym_let] = ACTIONS(2414),
    [anon_sym_This] = ACTIONS(2414),
    [anon_sym_decltype] = ACTIONS(2414),
    [anon_sym_explicit] = ACTIONS(2414),
    [anon_sym_typename] = ACTIONS(2414),
    [anon_sym_template] = ACTIONS(2414),
    [anon_sym_operator] = ACTIONS(2414),
    [anon_sym_try] = ACTIONS(2414),
    [anon_sym_delete] = ACTIONS(2414),
    [anon_sym_throw] = ACTIONS(2414),
    [anon_sym_namespace] = ACTIONS(2414),
    [anon_sym_static_assert] = ACTIONS(2414),
    [anon_sym_concept] = ACTIONS(2414),
    [anon_sym_co_return] = ACTIONS(2414),
    [anon_sym_co_yield] = ACTIONS(2414),
    [anon_sym_catch] = ACTIONS(2414),
    [anon_sym_R_DQUOTE] = ACTIONS(2412),
    [anon_sym_LR_DQUOTE] = ACTIONS(2412),
    [anon_sym_uR_DQUOTE] = ACTIONS(2412),
    [anon_sym_UR_DQUOTE] = ACTIONS(2412),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2412),
    [anon_sym_co_await] = ACTIONS(2414),
    [anon_sym_new] = ACTIONS(2414),
    [anon_sym_requires] = ACTIONS(2414),
    [sym_this] = ACTIONS(2414),
    [anon_sym_discard] = ACTIONS(2414),
    [anon_sym_precise] = ACTIONS(2414),
    [anon_sym_shared] = ACTIONS(2414),
    [anon_sym_groupshared] = ACTIONS(2414),
    [anon_sym_uniform] = ACTIONS(2414),
    [anon_sym_row_major] = ACTIONS(2414),
    [anon_sym_column_major] = ACTIONS(2414),
    [anon_sym_globallycoherent] = ACTIONS(2414),
    [anon_sym_centroid] = ACTIONS(2414),
    [anon_sym_noperspective] = ACTIONS(2414),
    [anon_sym_nointerpolation] = ACTIONS(2414),
    [anon_sym_sample] = ACTIONS(2414),
    [anon_sym_linear] = ACTIONS(2414),
    [anon_sym_snorm] = ACTIONS(2414),
    [anon_sym_unorm] = ACTIONS(2414),
    [anon_sym_point] = ACTIONS(2414),
    [anon_sym_line] = ACTIONS(2414),
    [anon_sym_triangleadj] = ACTIONS(2414),
    [anon_sym_lineadj] = ACTIONS(2414),
    [anon_sym_triangle] = ACTIONS(2414),
    [anon_sym_cbuffer] = ACTIONS(2414),
    [anon_sym_interface] = ACTIONS(2414),
    [anon_sym_extension] = ACTIONS(2414),
  },
  [341] = {
    [sym_preproc_def] = STATE(374),
    [sym_preproc_function_def] = STATE(374),
    [sym_preproc_call] = STATE(374),
    [sym_preproc_if_in_field_declaration_list] = STATE(374),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(374),
    [sym_type_definition] = STATE(374),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(374),
    [sym_field_declaration] = STATE(374),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(374),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(374),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(374),
    [sym_operator_cast_declaration] = STATE(374),
    [sym_constructor_or_destructor_definition] = STATE(374),
    [sym_constructor_or_destructor_declaration] = STATE(374),
    [sym_friend_declaration] = STATE(374),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(374),
    [sym_alias_declaration] = STATE(374),
    [sym_static_assert_declaration] = STATE(374),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(374),
    [sym_subscript_declaration] = STATE(374),
    [sym_property_declaration] = STATE(374),
    [sym_associatedtype_declaration] = STATE(374),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3200),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [342] = {
    [sym_template_argument_list] = STATE(527),
    [sym_identifier] = ACTIONS(2410),
    [aux_sym_preproc_include_token1] = ACTIONS(2410),
    [aux_sym_preproc_def_token1] = ACTIONS(2410),
    [aux_sym_preproc_if_token1] = ACTIONS(2410),
    [aux_sym_preproc_if_token2] = ACTIONS(2410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2410),
    [sym_preproc_directive] = ACTIONS(2410),
    [anon_sym_LPAREN2] = ACTIONS(2408),
    [anon_sym_BANG] = ACTIONS(2408),
    [anon_sym_TILDE] = ACTIONS(2408),
    [anon_sym_DASH] = ACTIONS(2410),
    [anon_sym_PLUS] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(2408),
    [anon_sym_AMP_AMP] = ACTIONS(2408),
    [anon_sym_AMP] = ACTIONS(2410),
    [anon_sym_LT] = ACTIONS(3202),
    [anon_sym_COLON] = ACTIONS(2410),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym___extension__] = ACTIONS(2410),
    [anon_sym_typedef] = ACTIONS(2410),
    [anon_sym_in] = ACTIONS(2410),
    [anon_sym_out] = ACTIONS(2410),
    [anon_sym_inout] = ACTIONS(2410),
    [anon_sym_virtual] = ACTIONS(2410),
    [anon_sym_extern] = ACTIONS(2410),
    [anon_sym___attribute__] = ACTIONS(2410),
    [anon_sym___attribute] = ACTIONS(2410),
    [anon_sym_using] = ACTIONS(2410),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2408),
    [anon_sym___declspec] = ACTIONS(2410),
    [anon_sym___based] = ACTIONS(2410),
    [anon_sym___cdecl] = ACTIONS(2410),
    [anon_sym___clrcall] = ACTIONS(2410),
    [anon_sym___stdcall] = ACTIONS(2410),
    [anon_sym___fastcall] = ACTIONS(2410),
    [anon_sym___thiscall] = ACTIONS(2410),
    [anon_sym___vectorcall] = ACTIONS(2410),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_signed] = ACTIONS(2410),
    [anon_sym_unsigned] = ACTIONS(2410),
    [anon_sym_long] = ACTIONS(2410),
    [anon_sym_short] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_static] = ACTIONS(2410),
    [anon_sym_register] = ACTIONS(2410),
    [anon_sym_inline] = ACTIONS(2410),
    [anon_sym___inline] = ACTIONS(2410),
    [anon_sym___inline__] = ACTIONS(2410),
    [anon_sym___forceinline] = ACTIONS(2410),
    [anon_sym_thread_local] = ACTIONS(2410),
    [anon_sym___thread] = ACTIONS(2410),
    [anon_sym_const] = ACTIONS(2410),
    [anon_sym_constexpr] = ACTIONS(2410),
    [anon_sym_volatile] = ACTIONS(2410),
    [anon_sym_restrict] = ACTIONS(2410),
    [anon_sym___restrict__] = ACTIONS(2410),
    [anon_sym__Atomic] = ACTIONS(2410),
    [anon_sym__Noreturn] = ACTIONS(2410),
    [anon_sym_noreturn] = ACTIONS(2410),
    [anon_sym__Nonnull] = ACTIONS(2410),
    [anon_sym_mutable] = ACTIONS(2410),
    [anon_sym_constinit] = ACTIONS(2410),
    [anon_sym_consteval] = ACTIONS(2410),
    [anon_sym_alignas] = ACTIONS(2410),
    [anon_sym__Alignas] = ACTIONS(2410),
    [sym_primitive_type] = ACTIONS(2410),
    [anon_sym_enum] = ACTIONS(2410),
    [anon_sym_class] = ACTIONS(2410),
    [anon_sym_struct] = ACTIONS(2410),
    [anon_sym_union] = ACTIONS(2410),
    [anon_sym_if] = ACTIONS(2410),
    [anon_sym_else] = ACTIONS(2410),
    [anon_sym_switch] = ACTIONS(2410),
    [anon_sym_case] = ACTIONS(2410),
    [anon_sym_default] = ACTIONS(2410),
    [anon_sym_while] = ACTIONS(2410),
    [anon_sym_do] = ACTIONS(2410),
    [anon_sym_for] = ACTIONS(2410),
    [anon_sym_return] = ACTIONS(2410),
    [anon_sym_break] = ACTIONS(2410),
    [anon_sym_continue] = ACTIONS(2410),
    [anon_sym_goto] = ACTIONS(2410),
    [anon_sym___try] = ACTIONS(2410),
    [anon_sym___leave] = ACTIONS(2410),
    [anon_sym_not] = ACTIONS(2410),
    [anon_sym_compl] = ACTIONS(2410),
    [anon_sym_DASH_DASH] = ACTIONS(2408),
    [anon_sym_PLUS_PLUS] = ACTIONS(2408),
    [anon_sym_sizeof] = ACTIONS(2410),
    [anon_sym___alignof__] = ACTIONS(2410),
    [anon_sym___alignof] = ACTIONS(2410),
    [anon_sym__alignof] = ACTIONS(2410),
    [anon_sym_alignof] = ACTIONS(2410),
    [anon_sym__Alignof] = ACTIONS(2410),
    [anon_sym_offsetof] = ACTIONS(2410),
    [anon_sym__Generic] = ACTIONS(2410),
    [anon_sym_asm] = ACTIONS(2410),
    [anon_sym___asm__] = ACTIONS(2410),
    [anon_sym___asm] = ACTIONS(2410),
    [sym_number_literal] = ACTIONS(2408),
    [anon_sym_L_SQUOTE] = ACTIONS(2408),
    [anon_sym_u_SQUOTE] = ACTIONS(2408),
    [anon_sym_U_SQUOTE] = ACTIONS(2408),
    [anon_sym_u8_SQUOTE] = ACTIONS(2408),
    [anon_sym_SQUOTE] = ACTIONS(2408),
    [anon_sym_L_DQUOTE] = ACTIONS(2408),
    [anon_sym_u_DQUOTE] = ACTIONS(2408),
    [anon_sym_U_DQUOTE] = ACTIONS(2408),
    [anon_sym_u8_DQUOTE] = ACTIONS(2408),
    [anon_sym_DQUOTE] = ACTIONS(2408),
    [sym_true] = ACTIONS(2410),
    [sym_false] = ACTIONS(2410),
    [anon_sym_NULL] = ACTIONS(2410),
    [anon_sym_nullptr] = ACTIONS(2410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2410),
    [anon_sym_let] = ACTIONS(2410),
    [anon_sym_This] = ACTIONS(2410),
    [anon_sym_decltype] = ACTIONS(2410),
    [anon_sym_final] = ACTIONS(2410),
    [anon_sym_override] = ACTIONS(2410),
    [anon_sym_explicit] = ACTIONS(2410),
    [anon_sym_typename] = ACTIONS(2410),
    [anon_sym_template] = ACTIONS(2410),
    [anon_sym_operator] = ACTIONS(2410),
    [anon_sym_try] = ACTIONS(2410),
    [anon_sym_delete] = ACTIONS(2410),
    [anon_sym_throw] = ACTIONS(2410),
    [anon_sym_namespace] = ACTIONS(2410),
    [anon_sym_static_assert] = ACTIONS(2410),
    [anon_sym_concept] = ACTIONS(2410),
    [anon_sym_co_return] = ACTIONS(2410),
    [anon_sym_co_yield] = ACTIONS(2410),
    [anon_sym_R_DQUOTE] = ACTIONS(2408),
    [anon_sym_LR_DQUOTE] = ACTIONS(2408),
    [anon_sym_uR_DQUOTE] = ACTIONS(2408),
    [anon_sym_UR_DQUOTE] = ACTIONS(2408),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2408),
    [anon_sym_co_await] = ACTIONS(2410),
    [anon_sym_new] = ACTIONS(2410),
    [anon_sym_requires] = ACTIONS(2410),
    [sym_this] = ACTIONS(2410),
    [anon_sym_discard] = ACTIONS(2410),
    [anon_sym_precise] = ACTIONS(2410),
    [anon_sym_shared] = ACTIONS(2410),
    [anon_sym_groupshared] = ACTIONS(2410),
    [anon_sym_uniform] = ACTIONS(2410),
    [anon_sym_row_major] = ACTIONS(2410),
    [anon_sym_column_major] = ACTIONS(2410),
    [anon_sym_globallycoherent] = ACTIONS(2410),
    [anon_sym_centroid] = ACTIONS(2410),
    [anon_sym_noperspective] = ACTIONS(2410),
    [anon_sym_nointerpolation] = ACTIONS(2410),
    [anon_sym_sample] = ACTIONS(2410),
    [anon_sym_linear] = ACTIONS(2410),
    [anon_sym_snorm] = ACTIONS(2410),
    [anon_sym_unorm] = ACTIONS(2410),
    [anon_sym_point] = ACTIONS(2410),
    [anon_sym_line] = ACTIONS(2410),
    [anon_sym_triangleadj] = ACTIONS(2410),
    [anon_sym_lineadj] = ACTIONS(2410),
    [anon_sym_triangle] = ACTIONS(2410),
    [anon_sym_cbuffer] = ACTIONS(2410),
    [anon_sym_interface] = ACTIONS(2410),
    [anon_sym_extension] = ACTIONS(2410),
  },
  [343] = {
    [sym_template_argument_list] = STATE(527),
    [sym_identifier] = ACTIONS(2222),
    [aux_sym_preproc_include_token1] = ACTIONS(2222),
    [aux_sym_preproc_def_token1] = ACTIONS(2222),
    [aux_sym_preproc_if_token1] = ACTIONS(2222),
    [aux_sym_preproc_if_token2] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2222),
    [sym_preproc_directive] = ACTIONS(2222),
    [anon_sym_LPAREN2] = ACTIONS(2229),
    [anon_sym_BANG] = ACTIONS(2229),
    [anon_sym_TILDE] = ACTIONS(2229),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2229),
    [anon_sym_AMP_AMP] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(3202),
    [anon_sym_COLON] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(2229),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_typedef] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_virtual] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym___attribute] = ACTIONS(2222),
    [anon_sym_using] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2229),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym___based] = ACTIONS(2222),
    [anon_sym___cdecl] = ACTIONS(2222),
    [anon_sym___clrcall] = ACTIONS(2222),
    [anon_sym___stdcall] = ACTIONS(2222),
    [anon_sym___fastcall] = ACTIONS(2222),
    [anon_sym___thiscall] = ACTIONS(2222),
    [anon_sym___vectorcall] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_signed] = ACTIONS(2222),
    [anon_sym_unsigned] = ACTIONS(2222),
    [anon_sym_long] = ACTIONS(2222),
    [anon_sym_short] = ACTIONS(2222),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym__Nonnull] = ACTIONS(2222),
    [anon_sym_mutable] = ACTIONS(2222),
    [anon_sym_constinit] = ACTIONS(2222),
    [anon_sym_consteval] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [sym_primitive_type] = ACTIONS(2222),
    [anon_sym_enum] = ACTIONS(2222),
    [anon_sym_class] = ACTIONS(2222),
    [anon_sym_struct] = ACTIONS(2222),
    [anon_sym_union] = ACTIONS(2222),
    [anon_sym_if] = ACTIONS(2222),
    [anon_sym_else] = ACTIONS(2222),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2222),
    [anon_sym_default] = ACTIONS(2222),
    [anon_sym_while] = ACTIONS(2222),
    [anon_sym_do] = ACTIONS(2222),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_return] = ACTIONS(2222),
    [anon_sym_break] = ACTIONS(2222),
    [anon_sym_continue] = ACTIONS(2222),
    [anon_sym_goto] = ACTIONS(2222),
    [anon_sym___try] = ACTIONS(2222),
    [anon_sym___leave] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_compl] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2229),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(2222),
    [anon_sym___alignof] = ACTIONS(2222),
    [anon_sym__alignof] = ACTIONS(2222),
    [anon_sym_alignof] = ACTIONS(2222),
    [anon_sym__Alignof] = ACTIONS(2222),
    [anon_sym_offsetof] = ACTIONS(2222),
    [anon_sym__Generic] = ACTIONS(2222),
    [anon_sym_asm] = ACTIONS(2222),
    [anon_sym___asm__] = ACTIONS(2222),
    [anon_sym___asm] = ACTIONS(2222),
    [sym_number_literal] = ACTIONS(2229),
    [anon_sym_L_SQUOTE] = ACTIONS(2229),
    [anon_sym_u_SQUOTE] = ACTIONS(2229),
    [anon_sym_U_SQUOTE] = ACTIONS(2229),
    [anon_sym_u8_SQUOTE] = ACTIONS(2229),
    [anon_sym_SQUOTE] = ACTIONS(2229),
    [anon_sym_L_DQUOTE] = ACTIONS(2229),
    [anon_sym_u_DQUOTE] = ACTIONS(2229),
    [anon_sym_U_DQUOTE] = ACTIONS(2229),
    [anon_sym_u8_DQUOTE] = ACTIONS(2229),
    [anon_sym_DQUOTE] = ACTIONS(2229),
    [sym_true] = ACTIONS(2222),
    [sym_false] = ACTIONS(2222),
    [anon_sym_NULL] = ACTIONS(2222),
    [anon_sym_nullptr] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2222),
    [anon_sym_let] = ACTIONS(2222),
    [anon_sym_This] = ACTIONS(2222),
    [anon_sym_decltype] = ACTIONS(2222),
    [anon_sym_final] = ACTIONS(2222),
    [anon_sym_override] = ACTIONS(2222),
    [anon_sym_explicit] = ACTIONS(2222),
    [anon_sym_typename] = ACTIONS(2222),
    [anon_sym_template] = ACTIONS(2222),
    [anon_sym_operator] = ACTIONS(2222),
    [anon_sym_try] = ACTIONS(2222),
    [anon_sym_delete] = ACTIONS(2222),
    [anon_sym_throw] = ACTIONS(2222),
    [anon_sym_namespace] = ACTIONS(2222),
    [anon_sym_static_assert] = ACTIONS(2222),
    [anon_sym_concept] = ACTIONS(2222),
    [anon_sym_co_return] = ACTIONS(2222),
    [anon_sym_co_yield] = ACTIONS(2222),
    [anon_sym_R_DQUOTE] = ACTIONS(2229),
    [anon_sym_LR_DQUOTE] = ACTIONS(2229),
    [anon_sym_uR_DQUOTE] = ACTIONS(2229),
    [anon_sym_UR_DQUOTE] = ACTIONS(2229),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2229),
    [anon_sym_co_await] = ACTIONS(2222),
    [anon_sym_new] = ACTIONS(2222),
    [anon_sym_requires] = ACTIONS(2222),
    [sym_this] = ACTIONS(2222),
    [anon_sym_discard] = ACTIONS(2222),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_groupshared] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_row_major] = ACTIONS(2222),
    [anon_sym_column_major] = ACTIONS(2222),
    [anon_sym_globallycoherent] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym_nointerpolation] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_linear] = ACTIONS(2222),
    [anon_sym_snorm] = ACTIONS(2222),
    [anon_sym_unorm] = ACTIONS(2222),
    [anon_sym_point] = ACTIONS(2222),
    [anon_sym_line] = ACTIONS(2222),
    [anon_sym_triangleadj] = ACTIONS(2222),
    [anon_sym_lineadj] = ACTIONS(2222),
    [anon_sym_triangle] = ACTIONS(2222),
    [anon_sym_cbuffer] = ACTIONS(2222),
    [anon_sym_interface] = ACTIONS(2222),
    [anon_sym_extension] = ACTIONS(2222),
  },
  [344] = {
    [sym_preproc_def] = STATE(347),
    [sym_preproc_function_def] = STATE(347),
    [sym_preproc_call] = STATE(347),
    [sym_preproc_if_in_field_declaration_list] = STATE(347),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(347),
    [sym_type_definition] = STATE(347),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(347),
    [sym_field_declaration] = STATE(347),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(347),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(347),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(347),
    [sym_operator_cast_declaration] = STATE(347),
    [sym_constructor_or_destructor_definition] = STATE(347),
    [sym_constructor_or_destructor_declaration] = STATE(347),
    [sym_friend_declaration] = STATE(347),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(347),
    [sym_alias_declaration] = STATE(347),
    [sym_static_assert_declaration] = STATE(347),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(347),
    [sym_subscript_declaration] = STATE(347),
    [sym_property_declaration] = STATE(347),
    [sym_associatedtype_declaration] = STATE(347),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(347),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3206),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [345] = {
    [sym_preproc_def] = STATE(350),
    [sym_preproc_function_def] = STATE(350),
    [sym_preproc_call] = STATE(350),
    [sym_preproc_if_in_field_declaration_list] = STATE(350),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(350),
    [sym_type_definition] = STATE(350),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(350),
    [sym_field_declaration] = STATE(350),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(350),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(350),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(350),
    [sym_operator_cast_declaration] = STATE(350),
    [sym_constructor_or_destructor_definition] = STATE(350),
    [sym_constructor_or_destructor_declaration] = STATE(350),
    [sym_friend_declaration] = STATE(350),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(350),
    [sym_alias_declaration] = STATE(350),
    [sym_static_assert_declaration] = STATE(350),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(350),
    [sym_subscript_declaration] = STATE(350),
    [sym_property_declaration] = STATE(350),
    [sym_associatedtype_declaration] = STATE(350),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(350),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3208),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3210),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [346] = {
    [sym_else_clause] = STATE(460),
    [ts_builtin_sym_end] = ACTIONS(3212),
    [sym_identifier] = ACTIONS(3214),
    [aux_sym_preproc_include_token1] = ACTIONS(3214),
    [aux_sym_preproc_def_token1] = ACTIONS(3214),
    [aux_sym_preproc_if_token1] = ACTIONS(3214),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3214),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3214),
    [sym_preproc_directive] = ACTIONS(3214),
    [anon_sym_LPAREN2] = ACTIONS(3212),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3214),
    [anon_sym_STAR] = ACTIONS(3212),
    [anon_sym_AMP_AMP] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3214),
    [anon_sym_SEMI] = ACTIONS(3212),
    [anon_sym___extension__] = ACTIONS(3214),
    [anon_sym_typedef] = ACTIONS(3214),
    [anon_sym_in] = ACTIONS(3214),
    [anon_sym_out] = ACTIONS(3214),
    [anon_sym_inout] = ACTIONS(3214),
    [anon_sym_virtual] = ACTIONS(3214),
    [anon_sym_extern] = ACTIONS(3214),
    [anon_sym___attribute__] = ACTIONS(3214),
    [anon_sym___attribute] = ACTIONS(3214),
    [anon_sym_using] = ACTIONS(3214),
    [anon_sym_COLON_COLON] = ACTIONS(3212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3212),
    [anon_sym___declspec] = ACTIONS(3214),
    [anon_sym___based] = ACTIONS(3214),
    [anon_sym___cdecl] = ACTIONS(3214),
    [anon_sym___clrcall] = ACTIONS(3214),
    [anon_sym___stdcall] = ACTIONS(3214),
    [anon_sym___fastcall] = ACTIONS(3214),
    [anon_sym___thiscall] = ACTIONS(3214),
    [anon_sym___vectorcall] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_signed] = ACTIONS(3214),
    [anon_sym_unsigned] = ACTIONS(3214),
    [anon_sym_long] = ACTIONS(3214),
    [anon_sym_short] = ACTIONS(3214),
    [anon_sym_LBRACK] = ACTIONS(3214),
    [anon_sym_static] = ACTIONS(3214),
    [anon_sym_register] = ACTIONS(3214),
    [anon_sym_inline] = ACTIONS(3214),
    [anon_sym___inline] = ACTIONS(3214),
    [anon_sym___inline__] = ACTIONS(3214),
    [anon_sym___forceinline] = ACTIONS(3214),
    [anon_sym_thread_local] = ACTIONS(3214),
    [anon_sym___thread] = ACTIONS(3214),
    [anon_sym_const] = ACTIONS(3214),
    [anon_sym_constexpr] = ACTIONS(3214),
    [anon_sym_volatile] = ACTIONS(3214),
    [anon_sym_restrict] = ACTIONS(3214),
    [anon_sym___restrict__] = ACTIONS(3214),
    [anon_sym__Atomic] = ACTIONS(3214),
    [anon_sym__Noreturn] = ACTIONS(3214),
    [anon_sym_noreturn] = ACTIONS(3214),
    [anon_sym__Nonnull] = ACTIONS(3214),
    [anon_sym_mutable] = ACTIONS(3214),
    [anon_sym_constinit] = ACTIONS(3214),
    [anon_sym_consteval] = ACTIONS(3214),
    [anon_sym_alignas] = ACTIONS(3214),
    [anon_sym__Alignas] = ACTIONS(3214),
    [sym_primitive_type] = ACTIONS(3214),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3214),
    [anon_sym_struct] = ACTIONS(3214),
    [anon_sym_union] = ACTIONS(3214),
    [anon_sym_if] = ACTIONS(3214),
    [anon_sym_else] = ACTIONS(3098),
    [anon_sym_switch] = ACTIONS(3214),
    [anon_sym_case] = ACTIONS(3214),
    [anon_sym_default] = ACTIONS(3214),
    [anon_sym_while] = ACTIONS(3214),
    [anon_sym_do] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3214),
    [anon_sym_return] = ACTIONS(3214),
    [anon_sym_break] = ACTIONS(3214),
    [anon_sym_continue] = ACTIONS(3214),
    [anon_sym_goto] = ACTIONS(3214),
    [anon_sym___try] = ACTIONS(3214),
    [anon_sym___leave] = ACTIONS(3214),
    [anon_sym_not] = ACTIONS(3214),
    [anon_sym_compl] = ACTIONS(3214),
    [anon_sym_DASH_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_PLUS] = ACTIONS(3212),
    [anon_sym_sizeof] = ACTIONS(3214),
    [anon_sym___alignof__] = ACTIONS(3214),
    [anon_sym___alignof] = ACTIONS(3214),
    [anon_sym__alignof] = ACTIONS(3214),
    [anon_sym_alignof] = ACTIONS(3214),
    [anon_sym__Alignof] = ACTIONS(3214),
    [anon_sym_offsetof] = ACTIONS(3214),
    [anon_sym__Generic] = ACTIONS(3214),
    [anon_sym_asm] = ACTIONS(3214),
    [anon_sym___asm__] = ACTIONS(3214),
    [anon_sym___asm] = ACTIONS(3214),
    [sym_number_literal] = ACTIONS(3212),
    [anon_sym_L_SQUOTE] = ACTIONS(3212),
    [anon_sym_u_SQUOTE] = ACTIONS(3212),
    [anon_sym_U_SQUOTE] = ACTIONS(3212),
    [anon_sym_u8_SQUOTE] = ACTIONS(3212),
    [anon_sym_SQUOTE] = ACTIONS(3212),
    [anon_sym_L_DQUOTE] = ACTIONS(3212),
    [anon_sym_u_DQUOTE] = ACTIONS(3212),
    [anon_sym_U_DQUOTE] = ACTIONS(3212),
    [anon_sym_u8_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [sym_true] = ACTIONS(3214),
    [sym_false] = ACTIONS(3214),
    [anon_sym_NULL] = ACTIONS(3214),
    [anon_sym_nullptr] = ACTIONS(3214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3214),
    [anon_sym_let] = ACTIONS(3214),
    [anon_sym_This] = ACTIONS(3214),
    [anon_sym_decltype] = ACTIONS(3214),
    [anon_sym_explicit] = ACTIONS(3214),
    [anon_sym_typename] = ACTIONS(3214),
    [anon_sym_export] = ACTIONS(3214),
    [anon_sym_module] = ACTIONS(3214),
    [anon_sym_import] = ACTIONS(3214),
    [anon_sym_template] = ACTIONS(3214),
    [anon_sym_operator] = ACTIONS(3214),
    [anon_sym_try] = ACTIONS(3214),
    [anon_sym_delete] = ACTIONS(3214),
    [anon_sym_throw] = ACTIONS(3214),
    [anon_sym_namespace] = ACTIONS(3214),
    [anon_sym_static_assert] = ACTIONS(3214),
    [anon_sym_concept] = ACTIONS(3214),
    [anon_sym_co_return] = ACTIONS(3214),
    [anon_sym_co_yield] = ACTIONS(3214),
    [anon_sym_R_DQUOTE] = ACTIONS(3212),
    [anon_sym_LR_DQUOTE] = ACTIONS(3212),
    [anon_sym_uR_DQUOTE] = ACTIONS(3212),
    [anon_sym_UR_DQUOTE] = ACTIONS(3212),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3212),
    [anon_sym_co_await] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3214),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(3214),
    [anon_sym_discard] = ACTIONS(3214),
    [anon_sym_precise] = ACTIONS(3214),
    [anon_sym_shared] = ACTIONS(3214),
    [anon_sym_groupshared] = ACTIONS(3214),
    [anon_sym_uniform] = ACTIONS(3214),
    [anon_sym_row_major] = ACTIONS(3214),
    [anon_sym_column_major] = ACTIONS(3214),
    [anon_sym_globallycoherent] = ACTIONS(3214),
    [anon_sym_centroid] = ACTIONS(3214),
    [anon_sym_noperspective] = ACTIONS(3214),
    [anon_sym_nointerpolation] = ACTIONS(3214),
    [anon_sym_sample] = ACTIONS(3214),
    [anon_sym_linear] = ACTIONS(3214),
    [anon_sym_snorm] = ACTIONS(3214),
    [anon_sym_unorm] = ACTIONS(3214),
    [anon_sym_point] = ACTIONS(3214),
    [anon_sym_line] = ACTIONS(3214),
    [anon_sym_triangleadj] = ACTIONS(3214),
    [anon_sym_lineadj] = ACTIONS(3214),
    [anon_sym_triangle] = ACTIONS(3214),
    [anon_sym_cbuffer] = ACTIONS(3214),
    [anon_sym_interface] = ACTIONS(3214),
    [anon_sym_extension] = ACTIONS(3214),
    [anon_sym___exported] = ACTIONS(3214),
  },
  [347] = {
    [sym_preproc_def] = STATE(374),
    [sym_preproc_function_def] = STATE(374),
    [sym_preproc_call] = STATE(374),
    [sym_preproc_if_in_field_declaration_list] = STATE(374),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(374),
    [sym_type_definition] = STATE(374),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(374),
    [sym_field_declaration] = STATE(374),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(374),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(374),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(374),
    [sym_operator_cast_declaration] = STATE(374),
    [sym_constructor_or_destructor_definition] = STATE(374),
    [sym_constructor_or_destructor_declaration] = STATE(374),
    [sym_friend_declaration] = STATE(374),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(374),
    [sym_alias_declaration] = STATE(374),
    [sym_static_assert_declaration] = STATE(374),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(374),
    [sym_subscript_declaration] = STATE(374),
    [sym_property_declaration] = STATE(374),
    [sym_associatedtype_declaration] = STATE(374),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3216),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [348] = {
    [sym_else_clause] = STATE(491),
    [sym_identifier] = ACTIONS(3214),
    [aux_sym_preproc_include_token1] = ACTIONS(3214),
    [aux_sym_preproc_def_token1] = ACTIONS(3214),
    [aux_sym_preproc_if_token1] = ACTIONS(3214),
    [aux_sym_preproc_if_token2] = ACTIONS(3214),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3214),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3214),
    [aux_sym_preproc_else_token1] = ACTIONS(3214),
    [aux_sym_preproc_elif_token1] = ACTIONS(3214),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3214),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3214),
    [sym_preproc_directive] = ACTIONS(3214),
    [anon_sym_LPAREN2] = ACTIONS(3212),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3214),
    [anon_sym_STAR] = ACTIONS(3212),
    [anon_sym_AMP_AMP] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3214),
    [anon_sym_SEMI] = ACTIONS(3212),
    [anon_sym___extension__] = ACTIONS(3214),
    [anon_sym_typedef] = ACTIONS(3214),
    [anon_sym_in] = ACTIONS(3214),
    [anon_sym_out] = ACTIONS(3214),
    [anon_sym_inout] = ACTIONS(3214),
    [anon_sym_virtual] = ACTIONS(3214),
    [anon_sym_extern] = ACTIONS(3214),
    [anon_sym___attribute__] = ACTIONS(3214),
    [anon_sym___attribute] = ACTIONS(3214),
    [anon_sym_using] = ACTIONS(3214),
    [anon_sym_COLON_COLON] = ACTIONS(3212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3212),
    [anon_sym___declspec] = ACTIONS(3214),
    [anon_sym___based] = ACTIONS(3214),
    [anon_sym___cdecl] = ACTIONS(3214),
    [anon_sym___clrcall] = ACTIONS(3214),
    [anon_sym___stdcall] = ACTIONS(3214),
    [anon_sym___fastcall] = ACTIONS(3214),
    [anon_sym___thiscall] = ACTIONS(3214),
    [anon_sym___vectorcall] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_signed] = ACTIONS(3214),
    [anon_sym_unsigned] = ACTIONS(3214),
    [anon_sym_long] = ACTIONS(3214),
    [anon_sym_short] = ACTIONS(3214),
    [anon_sym_LBRACK] = ACTIONS(3214),
    [anon_sym_static] = ACTIONS(3214),
    [anon_sym_register] = ACTIONS(3214),
    [anon_sym_inline] = ACTIONS(3214),
    [anon_sym___inline] = ACTIONS(3214),
    [anon_sym___inline__] = ACTIONS(3214),
    [anon_sym___forceinline] = ACTIONS(3214),
    [anon_sym_thread_local] = ACTIONS(3214),
    [anon_sym___thread] = ACTIONS(3214),
    [anon_sym_const] = ACTIONS(3214),
    [anon_sym_constexpr] = ACTIONS(3214),
    [anon_sym_volatile] = ACTIONS(3214),
    [anon_sym_restrict] = ACTIONS(3214),
    [anon_sym___restrict__] = ACTIONS(3214),
    [anon_sym__Atomic] = ACTIONS(3214),
    [anon_sym__Noreturn] = ACTIONS(3214),
    [anon_sym_noreturn] = ACTIONS(3214),
    [anon_sym__Nonnull] = ACTIONS(3214),
    [anon_sym_mutable] = ACTIONS(3214),
    [anon_sym_constinit] = ACTIONS(3214),
    [anon_sym_consteval] = ACTIONS(3214),
    [anon_sym_alignas] = ACTIONS(3214),
    [anon_sym__Alignas] = ACTIONS(3214),
    [sym_primitive_type] = ACTIONS(3214),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3214),
    [anon_sym_struct] = ACTIONS(3214),
    [anon_sym_union] = ACTIONS(3214),
    [anon_sym_if] = ACTIONS(3214),
    [anon_sym_else] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3214),
    [anon_sym_case] = ACTIONS(3214),
    [anon_sym_default] = ACTIONS(3214),
    [anon_sym_while] = ACTIONS(3214),
    [anon_sym_do] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3214),
    [anon_sym_return] = ACTIONS(3214),
    [anon_sym_break] = ACTIONS(3214),
    [anon_sym_continue] = ACTIONS(3214),
    [anon_sym_goto] = ACTIONS(3214),
    [anon_sym___try] = ACTIONS(3214),
    [anon_sym___leave] = ACTIONS(3214),
    [anon_sym_not] = ACTIONS(3214),
    [anon_sym_compl] = ACTIONS(3214),
    [anon_sym_DASH_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_PLUS] = ACTIONS(3212),
    [anon_sym_sizeof] = ACTIONS(3214),
    [anon_sym___alignof__] = ACTIONS(3214),
    [anon_sym___alignof] = ACTIONS(3214),
    [anon_sym__alignof] = ACTIONS(3214),
    [anon_sym_alignof] = ACTIONS(3214),
    [anon_sym__Alignof] = ACTIONS(3214),
    [anon_sym_offsetof] = ACTIONS(3214),
    [anon_sym__Generic] = ACTIONS(3214),
    [anon_sym_asm] = ACTIONS(3214),
    [anon_sym___asm__] = ACTIONS(3214),
    [anon_sym___asm] = ACTIONS(3214),
    [sym_number_literal] = ACTIONS(3212),
    [anon_sym_L_SQUOTE] = ACTIONS(3212),
    [anon_sym_u_SQUOTE] = ACTIONS(3212),
    [anon_sym_U_SQUOTE] = ACTIONS(3212),
    [anon_sym_u8_SQUOTE] = ACTIONS(3212),
    [anon_sym_SQUOTE] = ACTIONS(3212),
    [anon_sym_L_DQUOTE] = ACTIONS(3212),
    [anon_sym_u_DQUOTE] = ACTIONS(3212),
    [anon_sym_U_DQUOTE] = ACTIONS(3212),
    [anon_sym_u8_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [sym_true] = ACTIONS(3214),
    [sym_false] = ACTIONS(3214),
    [anon_sym_NULL] = ACTIONS(3214),
    [anon_sym_nullptr] = ACTIONS(3214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3214),
    [anon_sym_let] = ACTIONS(3214),
    [anon_sym_This] = ACTIONS(3214),
    [anon_sym_decltype] = ACTIONS(3214),
    [anon_sym_explicit] = ACTIONS(3214),
    [anon_sym_typename] = ACTIONS(3214),
    [anon_sym_template] = ACTIONS(3214),
    [anon_sym_operator] = ACTIONS(3214),
    [anon_sym_try] = ACTIONS(3214),
    [anon_sym_delete] = ACTIONS(3214),
    [anon_sym_throw] = ACTIONS(3214),
    [anon_sym_namespace] = ACTIONS(3214),
    [anon_sym_static_assert] = ACTIONS(3214),
    [anon_sym_concept] = ACTIONS(3214),
    [anon_sym_co_return] = ACTIONS(3214),
    [anon_sym_co_yield] = ACTIONS(3214),
    [anon_sym_R_DQUOTE] = ACTIONS(3212),
    [anon_sym_LR_DQUOTE] = ACTIONS(3212),
    [anon_sym_uR_DQUOTE] = ACTIONS(3212),
    [anon_sym_UR_DQUOTE] = ACTIONS(3212),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3212),
    [anon_sym_co_await] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3214),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(3214),
    [anon_sym_discard] = ACTIONS(3214),
    [anon_sym_precise] = ACTIONS(3214),
    [anon_sym_shared] = ACTIONS(3214),
    [anon_sym_groupshared] = ACTIONS(3214),
    [anon_sym_uniform] = ACTIONS(3214),
    [anon_sym_row_major] = ACTIONS(3214),
    [anon_sym_column_major] = ACTIONS(3214),
    [anon_sym_globallycoherent] = ACTIONS(3214),
    [anon_sym_centroid] = ACTIONS(3214),
    [anon_sym_noperspective] = ACTIONS(3214),
    [anon_sym_nointerpolation] = ACTIONS(3214),
    [anon_sym_sample] = ACTIONS(3214),
    [anon_sym_linear] = ACTIONS(3214),
    [anon_sym_snorm] = ACTIONS(3214),
    [anon_sym_unorm] = ACTIONS(3214),
    [anon_sym_point] = ACTIONS(3214),
    [anon_sym_line] = ACTIONS(3214),
    [anon_sym_triangleadj] = ACTIONS(3214),
    [anon_sym_lineadj] = ACTIONS(3214),
    [anon_sym_triangle] = ACTIONS(3214),
    [anon_sym_cbuffer] = ACTIONS(3214),
    [anon_sym_interface] = ACTIONS(3214),
    [anon_sym_extension] = ACTIONS(3214),
  },
  [349] = {
    [sym_preproc_def] = STATE(341),
    [sym_preproc_function_def] = STATE(341),
    [sym_preproc_call] = STATE(341),
    [sym_preproc_if_in_field_declaration_list] = STATE(341),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(341),
    [sym_type_definition] = STATE(341),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(341),
    [sym_field_declaration] = STATE(341),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(341),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(341),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(341),
    [sym_operator_cast_declaration] = STATE(341),
    [sym_constructor_or_destructor_definition] = STATE(341),
    [sym_constructor_or_destructor_declaration] = STATE(341),
    [sym_friend_declaration] = STATE(341),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(341),
    [sym_alias_declaration] = STATE(341),
    [sym_static_assert_declaration] = STATE(341),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(341),
    [sym_subscript_declaration] = STATE(341),
    [sym_property_declaration] = STATE(341),
    [sym_associatedtype_declaration] = STATE(341),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(341),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3218),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3220),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [350] = {
    [sym_preproc_def] = STATE(374),
    [sym_preproc_function_def] = STATE(374),
    [sym_preproc_call] = STATE(374),
    [sym_preproc_if_in_field_declaration_list] = STATE(374),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(374),
    [sym_type_definition] = STATE(374),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(374),
    [sym_field_declaration] = STATE(374),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(374),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(374),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(374),
    [sym_operator_cast_declaration] = STATE(374),
    [sym_constructor_or_destructor_definition] = STATE(374),
    [sym_constructor_or_destructor_declaration] = STATE(374),
    [sym_friend_declaration] = STATE(374),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(374),
    [sym_alias_declaration] = STATE(374),
    [sym_static_assert_declaration] = STATE(374),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(374),
    [sym_subscript_declaration] = STATE(374),
    [sym_property_declaration] = STATE(374),
    [sym_associatedtype_declaration] = STATE(374),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3222),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [351] = {
    [sym_preproc_def] = STATE(374),
    [sym_preproc_function_def] = STATE(374),
    [sym_preproc_call] = STATE(374),
    [sym_preproc_if_in_field_declaration_list] = STATE(374),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(374),
    [sym_type_definition] = STATE(374),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(374),
    [sym_field_declaration] = STATE(374),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(374),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(374),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(374),
    [sym_operator_cast_declaration] = STATE(374),
    [sym_constructor_or_destructor_definition] = STATE(374),
    [sym_constructor_or_destructor_declaration] = STATE(374),
    [sym_friend_declaration] = STATE(374),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(374),
    [sym_alias_declaration] = STATE(374),
    [sym_static_assert_declaration] = STATE(374),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(374),
    [sym_subscript_declaration] = STATE(374),
    [sym_property_declaration] = STATE(374),
    [sym_associatedtype_declaration] = STATE(374),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3224),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [352] = {
    [sym_preproc_def] = STATE(353),
    [sym_preproc_function_def] = STATE(353),
    [sym_preproc_call] = STATE(353),
    [sym_preproc_if_in_field_declaration_list] = STATE(353),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(353),
    [sym_type_definition] = STATE(353),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(353),
    [sym_field_declaration] = STATE(353),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(353),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(353),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(353),
    [sym_operator_cast_declaration] = STATE(353),
    [sym_constructor_or_destructor_definition] = STATE(353),
    [sym_constructor_or_destructor_declaration] = STATE(353),
    [sym_friend_declaration] = STATE(353),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(353),
    [sym_alias_declaration] = STATE(353),
    [sym_static_assert_declaration] = STATE(353),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(353),
    [sym_subscript_declaration] = STATE(353),
    [sym_property_declaration] = STATE(353),
    [sym_associatedtype_declaration] = STATE(353),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(353),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3226),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3228),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [353] = {
    [sym_preproc_def] = STATE(374),
    [sym_preproc_function_def] = STATE(374),
    [sym_preproc_call] = STATE(374),
    [sym_preproc_if_in_field_declaration_list] = STATE(374),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(374),
    [sym_type_definition] = STATE(374),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(374),
    [sym_field_declaration] = STATE(374),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(374),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(374),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(374),
    [sym_operator_cast_declaration] = STATE(374),
    [sym_constructor_or_destructor_definition] = STATE(374),
    [sym_constructor_or_destructor_declaration] = STATE(374),
    [sym_friend_declaration] = STATE(374),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(374),
    [sym_alias_declaration] = STATE(374),
    [sym_static_assert_declaration] = STATE(374),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(374),
    [sym_subscript_declaration] = STATE(374),
    [sym_property_declaration] = STATE(374),
    [sym_associatedtype_declaration] = STATE(374),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3230),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [354] = {
    [sym_preproc_def] = STATE(355),
    [sym_preproc_function_def] = STATE(355),
    [sym_preproc_call] = STATE(355),
    [sym_preproc_if_in_field_declaration_list] = STATE(355),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(355),
    [sym_type_definition] = STATE(355),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(355),
    [sym_field_declaration] = STATE(355),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(355),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(355),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(355),
    [sym_operator_cast_declaration] = STATE(355),
    [sym_constructor_or_destructor_definition] = STATE(355),
    [sym_constructor_or_destructor_declaration] = STATE(355),
    [sym_friend_declaration] = STATE(355),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(355),
    [sym_alias_declaration] = STATE(355),
    [sym_static_assert_declaration] = STATE(355),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(355),
    [sym_subscript_declaration] = STATE(355),
    [sym_property_declaration] = STATE(355),
    [sym_associatedtype_declaration] = STATE(355),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(355),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3232),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3234),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [355] = {
    [sym_preproc_def] = STATE(374),
    [sym_preproc_function_def] = STATE(374),
    [sym_preproc_call] = STATE(374),
    [sym_preproc_if_in_field_declaration_list] = STATE(374),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(374),
    [sym_type_definition] = STATE(374),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(374),
    [sym_field_declaration] = STATE(374),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(374),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(374),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(374),
    [sym_operator_cast_declaration] = STATE(374),
    [sym_constructor_or_destructor_definition] = STATE(374),
    [sym_constructor_or_destructor_declaration] = STATE(374),
    [sym_friend_declaration] = STATE(374),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(374),
    [sym_alias_declaration] = STATE(374),
    [sym_static_assert_declaration] = STATE(374),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(374),
    [sym_subscript_declaration] = STATE(374),
    [sym_property_declaration] = STATE(374),
    [sym_associatedtype_declaration] = STATE(374),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3236),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [356] = {
    [sym_else_clause] = STATE(422),
    [ts_builtin_sym_end] = ACTIONS(3238),
    [sym_identifier] = ACTIONS(3240),
    [aux_sym_preproc_include_token1] = ACTIONS(3240),
    [aux_sym_preproc_def_token1] = ACTIONS(3240),
    [aux_sym_preproc_if_token1] = ACTIONS(3240),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3240),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3240),
    [sym_preproc_directive] = ACTIONS(3240),
    [anon_sym_LPAREN2] = ACTIONS(3238),
    [anon_sym_BANG] = ACTIONS(3238),
    [anon_sym_TILDE] = ACTIONS(3238),
    [anon_sym_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3240),
    [anon_sym_STAR] = ACTIONS(3238),
    [anon_sym_AMP_AMP] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_SEMI] = ACTIONS(3238),
    [anon_sym___extension__] = ACTIONS(3240),
    [anon_sym_typedef] = ACTIONS(3240),
    [anon_sym_in] = ACTIONS(3240),
    [anon_sym_out] = ACTIONS(3240),
    [anon_sym_inout] = ACTIONS(3240),
    [anon_sym_virtual] = ACTIONS(3240),
    [anon_sym_extern] = ACTIONS(3240),
    [anon_sym___attribute__] = ACTIONS(3240),
    [anon_sym___attribute] = ACTIONS(3240),
    [anon_sym_using] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3238),
    [anon_sym___declspec] = ACTIONS(3240),
    [anon_sym___based] = ACTIONS(3240),
    [anon_sym___cdecl] = ACTIONS(3240),
    [anon_sym___clrcall] = ACTIONS(3240),
    [anon_sym___stdcall] = ACTIONS(3240),
    [anon_sym___fastcall] = ACTIONS(3240),
    [anon_sym___thiscall] = ACTIONS(3240),
    [anon_sym___vectorcall] = ACTIONS(3240),
    [anon_sym_LBRACE] = ACTIONS(3238),
    [anon_sym_signed] = ACTIONS(3240),
    [anon_sym_unsigned] = ACTIONS(3240),
    [anon_sym_long] = ACTIONS(3240),
    [anon_sym_short] = ACTIONS(3240),
    [anon_sym_LBRACK] = ACTIONS(3240),
    [anon_sym_static] = ACTIONS(3240),
    [anon_sym_register] = ACTIONS(3240),
    [anon_sym_inline] = ACTIONS(3240),
    [anon_sym___inline] = ACTIONS(3240),
    [anon_sym___inline__] = ACTIONS(3240),
    [anon_sym___forceinline] = ACTIONS(3240),
    [anon_sym_thread_local] = ACTIONS(3240),
    [anon_sym___thread] = ACTIONS(3240),
    [anon_sym_const] = ACTIONS(3240),
    [anon_sym_constexpr] = ACTIONS(3240),
    [anon_sym_volatile] = ACTIONS(3240),
    [anon_sym_restrict] = ACTIONS(3240),
    [anon_sym___restrict__] = ACTIONS(3240),
    [anon_sym__Atomic] = ACTIONS(3240),
    [anon_sym__Noreturn] = ACTIONS(3240),
    [anon_sym_noreturn] = ACTIONS(3240),
    [anon_sym__Nonnull] = ACTIONS(3240),
    [anon_sym_mutable] = ACTIONS(3240),
    [anon_sym_constinit] = ACTIONS(3240),
    [anon_sym_consteval] = ACTIONS(3240),
    [anon_sym_alignas] = ACTIONS(3240),
    [anon_sym__Alignas] = ACTIONS(3240),
    [sym_primitive_type] = ACTIONS(3240),
    [anon_sym_enum] = ACTIONS(3240),
    [anon_sym_class] = ACTIONS(3240),
    [anon_sym_struct] = ACTIONS(3240),
    [anon_sym_union] = ACTIONS(3240),
    [anon_sym_if] = ACTIONS(3240),
    [anon_sym_else] = ACTIONS(3098),
    [anon_sym_switch] = ACTIONS(3240),
    [anon_sym_case] = ACTIONS(3240),
    [anon_sym_default] = ACTIONS(3240),
    [anon_sym_while] = ACTIONS(3240),
    [anon_sym_do] = ACTIONS(3240),
    [anon_sym_for] = ACTIONS(3240),
    [anon_sym_return] = ACTIONS(3240),
    [anon_sym_break] = ACTIONS(3240),
    [anon_sym_continue] = ACTIONS(3240),
    [anon_sym_goto] = ACTIONS(3240),
    [anon_sym___try] = ACTIONS(3240),
    [anon_sym___leave] = ACTIONS(3240),
    [anon_sym_not] = ACTIONS(3240),
    [anon_sym_compl] = ACTIONS(3240),
    [anon_sym_DASH_DASH] = ACTIONS(3238),
    [anon_sym_PLUS_PLUS] = ACTIONS(3238),
    [anon_sym_sizeof] = ACTIONS(3240),
    [anon_sym___alignof__] = ACTIONS(3240),
    [anon_sym___alignof] = ACTIONS(3240),
    [anon_sym__alignof] = ACTIONS(3240),
    [anon_sym_alignof] = ACTIONS(3240),
    [anon_sym__Alignof] = ACTIONS(3240),
    [anon_sym_offsetof] = ACTIONS(3240),
    [anon_sym__Generic] = ACTIONS(3240),
    [anon_sym_asm] = ACTIONS(3240),
    [anon_sym___asm__] = ACTIONS(3240),
    [anon_sym___asm] = ACTIONS(3240),
    [sym_number_literal] = ACTIONS(3238),
    [anon_sym_L_SQUOTE] = ACTIONS(3238),
    [anon_sym_u_SQUOTE] = ACTIONS(3238),
    [anon_sym_U_SQUOTE] = ACTIONS(3238),
    [anon_sym_u8_SQUOTE] = ACTIONS(3238),
    [anon_sym_SQUOTE] = ACTIONS(3238),
    [anon_sym_L_DQUOTE] = ACTIONS(3238),
    [anon_sym_u_DQUOTE] = ACTIONS(3238),
    [anon_sym_U_DQUOTE] = ACTIONS(3238),
    [anon_sym_u8_DQUOTE] = ACTIONS(3238),
    [anon_sym_DQUOTE] = ACTIONS(3238),
    [sym_true] = ACTIONS(3240),
    [sym_false] = ACTIONS(3240),
    [anon_sym_NULL] = ACTIONS(3240),
    [anon_sym_nullptr] = ACTIONS(3240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3240),
    [anon_sym_let] = ACTIONS(3240),
    [anon_sym_This] = ACTIONS(3240),
    [anon_sym_decltype] = ACTIONS(3240),
    [anon_sym_explicit] = ACTIONS(3240),
    [anon_sym_typename] = ACTIONS(3240),
    [anon_sym_export] = ACTIONS(3240),
    [anon_sym_module] = ACTIONS(3240),
    [anon_sym_import] = ACTIONS(3240),
    [anon_sym_template] = ACTIONS(3240),
    [anon_sym_operator] = ACTIONS(3240),
    [anon_sym_try] = ACTIONS(3240),
    [anon_sym_delete] = ACTIONS(3240),
    [anon_sym_throw] = ACTIONS(3240),
    [anon_sym_namespace] = ACTIONS(3240),
    [anon_sym_static_assert] = ACTIONS(3240),
    [anon_sym_concept] = ACTIONS(3240),
    [anon_sym_co_return] = ACTIONS(3240),
    [anon_sym_co_yield] = ACTIONS(3240),
    [anon_sym_R_DQUOTE] = ACTIONS(3238),
    [anon_sym_LR_DQUOTE] = ACTIONS(3238),
    [anon_sym_uR_DQUOTE] = ACTIONS(3238),
    [anon_sym_UR_DQUOTE] = ACTIONS(3238),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3238),
    [anon_sym_co_await] = ACTIONS(3240),
    [anon_sym_new] = ACTIONS(3240),
    [anon_sym_requires] = ACTIONS(3240),
    [sym_this] = ACTIONS(3240),
    [anon_sym_discard] = ACTIONS(3240),
    [anon_sym_precise] = ACTIONS(3240),
    [anon_sym_shared] = ACTIONS(3240),
    [anon_sym_groupshared] = ACTIONS(3240),
    [anon_sym_uniform] = ACTIONS(3240),
    [anon_sym_row_major] = ACTIONS(3240),
    [anon_sym_column_major] = ACTIONS(3240),
    [anon_sym_globallycoherent] = ACTIONS(3240),
    [anon_sym_centroid] = ACTIONS(3240),
    [anon_sym_noperspective] = ACTIONS(3240),
    [anon_sym_nointerpolation] = ACTIONS(3240),
    [anon_sym_sample] = ACTIONS(3240),
    [anon_sym_linear] = ACTIONS(3240),
    [anon_sym_snorm] = ACTIONS(3240),
    [anon_sym_unorm] = ACTIONS(3240),
    [anon_sym_point] = ACTIONS(3240),
    [anon_sym_line] = ACTIONS(3240),
    [anon_sym_triangleadj] = ACTIONS(3240),
    [anon_sym_lineadj] = ACTIONS(3240),
    [anon_sym_triangle] = ACTIONS(3240),
    [anon_sym_cbuffer] = ACTIONS(3240),
    [anon_sym_interface] = ACTIONS(3240),
    [anon_sym_extension] = ACTIONS(3240),
    [anon_sym___exported] = ACTIONS(3240),
  },
  [357] = {
    [sym_preproc_def] = STATE(358),
    [sym_preproc_function_def] = STATE(358),
    [sym_preproc_call] = STATE(358),
    [sym_preproc_if_in_field_declaration_list] = STATE(358),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(358),
    [sym_type_definition] = STATE(358),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(358),
    [sym_field_declaration] = STATE(358),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(358),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(358),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(358),
    [sym_operator_cast_declaration] = STATE(358),
    [sym_constructor_or_destructor_definition] = STATE(358),
    [sym_constructor_or_destructor_declaration] = STATE(358),
    [sym_friend_declaration] = STATE(358),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(358),
    [sym_alias_declaration] = STATE(358),
    [sym_static_assert_declaration] = STATE(358),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(358),
    [sym_subscript_declaration] = STATE(358),
    [sym_property_declaration] = STATE(358),
    [sym_associatedtype_declaration] = STATE(358),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(358),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3242),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3244),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [358] = {
    [sym_preproc_def] = STATE(374),
    [sym_preproc_function_def] = STATE(374),
    [sym_preproc_call] = STATE(374),
    [sym_preproc_if_in_field_declaration_list] = STATE(374),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(374),
    [sym_type_definition] = STATE(374),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(374),
    [sym_field_declaration] = STATE(374),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(374),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(374),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(374),
    [sym_operator_cast_declaration] = STATE(374),
    [sym_constructor_or_destructor_definition] = STATE(374),
    [sym_constructor_or_destructor_declaration] = STATE(374),
    [sym_friend_declaration] = STATE(374),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(374),
    [sym_alias_declaration] = STATE(374),
    [sym_static_assert_declaration] = STATE(374),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(374),
    [sym_subscript_declaration] = STATE(374),
    [sym_property_declaration] = STATE(374),
    [sym_associatedtype_declaration] = STATE(374),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3246),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [359] = {
    [sym_preproc_def] = STATE(360),
    [sym_preproc_function_def] = STATE(360),
    [sym_preproc_call] = STATE(360),
    [sym_preproc_if_in_field_declaration_list] = STATE(360),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(360),
    [sym_type_definition] = STATE(360),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(360),
    [sym_field_declaration] = STATE(360),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(360),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(360),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(360),
    [sym_operator_cast_declaration] = STATE(360),
    [sym_constructor_or_destructor_definition] = STATE(360),
    [sym_constructor_or_destructor_declaration] = STATE(360),
    [sym_friend_declaration] = STATE(360),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(360),
    [sym_alias_declaration] = STATE(360),
    [sym_static_assert_declaration] = STATE(360),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(360),
    [sym_subscript_declaration] = STATE(360),
    [sym_property_declaration] = STATE(360),
    [sym_associatedtype_declaration] = STATE(360),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(360),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3248),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3250),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [360] = {
    [sym_preproc_def] = STATE(374),
    [sym_preproc_function_def] = STATE(374),
    [sym_preproc_call] = STATE(374),
    [sym_preproc_if_in_field_declaration_list] = STATE(374),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(374),
    [sym_type_definition] = STATE(374),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(374),
    [sym_field_declaration] = STATE(374),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(374),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(374),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(374),
    [sym_operator_cast_declaration] = STATE(374),
    [sym_constructor_or_destructor_definition] = STATE(374),
    [sym_constructor_or_destructor_declaration] = STATE(374),
    [sym_friend_declaration] = STATE(374),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(374),
    [sym_alias_declaration] = STATE(374),
    [sym_static_assert_declaration] = STATE(374),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(374),
    [sym_subscript_declaration] = STATE(374),
    [sym_property_declaration] = STATE(374),
    [sym_associatedtype_declaration] = STATE(374),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3252),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [361] = {
    [sym_preproc_def] = STATE(362),
    [sym_preproc_function_def] = STATE(362),
    [sym_preproc_call] = STATE(362),
    [sym_preproc_if_in_field_declaration_list] = STATE(362),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(362),
    [sym_type_definition] = STATE(362),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(362),
    [sym_field_declaration] = STATE(362),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(362),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(362),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(362),
    [sym_operator_cast_declaration] = STATE(362),
    [sym_constructor_or_destructor_definition] = STATE(362),
    [sym_constructor_or_destructor_declaration] = STATE(362),
    [sym_friend_declaration] = STATE(362),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(362),
    [sym_alias_declaration] = STATE(362),
    [sym_static_assert_declaration] = STATE(362),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(362),
    [sym_subscript_declaration] = STATE(362),
    [sym_property_declaration] = STATE(362),
    [sym_associatedtype_declaration] = STATE(362),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(362),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3254),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3256),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [362] = {
    [sym_preproc_def] = STATE(374),
    [sym_preproc_function_def] = STATE(374),
    [sym_preproc_call] = STATE(374),
    [sym_preproc_if_in_field_declaration_list] = STATE(374),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(374),
    [sym_type_definition] = STATE(374),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(374),
    [sym_field_declaration] = STATE(374),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(374),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(374),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(374),
    [sym_operator_cast_declaration] = STATE(374),
    [sym_constructor_or_destructor_definition] = STATE(374),
    [sym_constructor_or_destructor_declaration] = STATE(374),
    [sym_friend_declaration] = STATE(374),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(374),
    [sym_alias_declaration] = STATE(374),
    [sym_static_assert_declaration] = STATE(374),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(374),
    [sym_subscript_declaration] = STATE(374),
    [sym_property_declaration] = STATE(374),
    [sym_associatedtype_declaration] = STATE(374),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3258),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [363] = {
    [ts_builtin_sym_end] = ACTIONS(3150),
    [sym_identifier] = ACTIONS(3148),
    [aux_sym_preproc_include_token1] = ACTIONS(3148),
    [aux_sym_preproc_def_token1] = ACTIONS(3148),
    [aux_sym_preproc_if_token1] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3148),
    [sym_preproc_directive] = ACTIONS(3148),
    [anon_sym_LPAREN2] = ACTIONS(3150),
    [anon_sym_BANG] = ACTIONS(3150),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_DASH] = ACTIONS(3148),
    [anon_sym_PLUS] = ACTIONS(3148),
    [anon_sym_STAR] = ACTIONS(3150),
    [anon_sym_AMP_AMP] = ACTIONS(3150),
    [anon_sym_AMP] = ACTIONS(3148),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym___extension__] = ACTIONS(3148),
    [anon_sym_typedef] = ACTIONS(3148),
    [anon_sym_in] = ACTIONS(3148),
    [anon_sym_out] = ACTIONS(3148),
    [anon_sym_inout] = ACTIONS(3148),
    [anon_sym_virtual] = ACTIONS(3148),
    [anon_sym_extern] = ACTIONS(3148),
    [anon_sym___attribute__] = ACTIONS(3148),
    [anon_sym___attribute] = ACTIONS(3148),
    [anon_sym_using] = ACTIONS(3148),
    [anon_sym_COLON_COLON] = ACTIONS(3150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3150),
    [anon_sym___declspec] = ACTIONS(3148),
    [anon_sym___based] = ACTIONS(3148),
    [anon_sym___cdecl] = ACTIONS(3148),
    [anon_sym___clrcall] = ACTIONS(3148),
    [anon_sym___stdcall] = ACTIONS(3148),
    [anon_sym___fastcall] = ACTIONS(3148),
    [anon_sym___thiscall] = ACTIONS(3148),
    [anon_sym___vectorcall] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3150),
    [anon_sym_signed] = ACTIONS(3148),
    [anon_sym_unsigned] = ACTIONS(3148),
    [anon_sym_long] = ACTIONS(3148),
    [anon_sym_short] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_static] = ACTIONS(3148),
    [anon_sym_register] = ACTIONS(3148),
    [anon_sym_inline] = ACTIONS(3148),
    [anon_sym___inline] = ACTIONS(3148),
    [anon_sym___inline__] = ACTIONS(3148),
    [anon_sym___forceinline] = ACTIONS(3148),
    [anon_sym_thread_local] = ACTIONS(3148),
    [anon_sym___thread] = ACTIONS(3148),
    [anon_sym_const] = ACTIONS(3148),
    [anon_sym_constexpr] = ACTIONS(3148),
    [anon_sym_volatile] = ACTIONS(3148),
    [anon_sym_restrict] = ACTIONS(3148),
    [anon_sym___restrict__] = ACTIONS(3148),
    [anon_sym__Atomic] = ACTIONS(3148),
    [anon_sym__Noreturn] = ACTIONS(3148),
    [anon_sym_noreturn] = ACTIONS(3148),
    [anon_sym__Nonnull] = ACTIONS(3148),
    [anon_sym_mutable] = ACTIONS(3148),
    [anon_sym_constinit] = ACTIONS(3148),
    [anon_sym_consteval] = ACTIONS(3148),
    [anon_sym_alignas] = ACTIONS(3148),
    [anon_sym__Alignas] = ACTIONS(3148),
    [sym_primitive_type] = ACTIONS(3148),
    [anon_sym_enum] = ACTIONS(3148),
    [anon_sym_class] = ACTIONS(3148),
    [anon_sym_struct] = ACTIONS(3148),
    [anon_sym_union] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_switch] = ACTIONS(3148),
    [anon_sym_case] = ACTIONS(3148),
    [anon_sym_default] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_for] = ACTIONS(3148),
    [anon_sym_return] = ACTIONS(3148),
    [anon_sym_break] = ACTIONS(3148),
    [anon_sym_continue] = ACTIONS(3148),
    [anon_sym_goto] = ACTIONS(3148),
    [anon_sym___try] = ACTIONS(3148),
    [anon_sym___leave] = ACTIONS(3148),
    [anon_sym_not] = ACTIONS(3148),
    [anon_sym_compl] = ACTIONS(3148),
    [anon_sym_DASH_DASH] = ACTIONS(3150),
    [anon_sym_PLUS_PLUS] = ACTIONS(3150),
    [anon_sym_sizeof] = ACTIONS(3148),
    [anon_sym___alignof__] = ACTIONS(3148),
    [anon_sym___alignof] = ACTIONS(3148),
    [anon_sym__alignof] = ACTIONS(3148),
    [anon_sym_alignof] = ACTIONS(3148),
    [anon_sym__Alignof] = ACTIONS(3148),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3148),
    [anon_sym_asm] = ACTIONS(3148),
    [anon_sym___asm__] = ACTIONS(3148),
    [anon_sym___asm] = ACTIONS(3148),
    [sym_number_literal] = ACTIONS(3150),
    [anon_sym_L_SQUOTE] = ACTIONS(3150),
    [anon_sym_u_SQUOTE] = ACTIONS(3150),
    [anon_sym_U_SQUOTE] = ACTIONS(3150),
    [anon_sym_u8_SQUOTE] = ACTIONS(3150),
    [anon_sym_SQUOTE] = ACTIONS(3150),
    [anon_sym_L_DQUOTE] = ACTIONS(3150),
    [anon_sym_u_DQUOTE] = ACTIONS(3150),
    [anon_sym_U_DQUOTE] = ACTIONS(3150),
    [anon_sym_u8_DQUOTE] = ACTIONS(3150),
    [anon_sym_DQUOTE] = ACTIONS(3150),
    [sym_true] = ACTIONS(3148),
    [sym_false] = ACTIONS(3148),
    [anon_sym_NULL] = ACTIONS(3148),
    [anon_sym_nullptr] = ACTIONS(3148),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3148),
    [anon_sym_let] = ACTIONS(3148),
    [anon_sym_This] = ACTIONS(3148),
    [anon_sym_decltype] = ACTIONS(3148),
    [anon_sym_explicit] = ACTIONS(3148),
    [anon_sym_typename] = ACTIONS(3148),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_module] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3148),
    [anon_sym_template] = ACTIONS(3148),
    [anon_sym_operator] = ACTIONS(3148),
    [anon_sym_try] = ACTIONS(3148),
    [anon_sym_delete] = ACTIONS(3148),
    [anon_sym_throw] = ACTIONS(3148),
    [anon_sym_namespace] = ACTIONS(3148),
    [anon_sym_static_assert] = ACTIONS(3148),
    [anon_sym_concept] = ACTIONS(3148),
    [anon_sym_co_return] = ACTIONS(3148),
    [anon_sym_co_yield] = ACTIONS(3148),
    [anon_sym_catch] = ACTIONS(3148),
    [anon_sym_R_DQUOTE] = ACTIONS(3150),
    [anon_sym_LR_DQUOTE] = ACTIONS(3150),
    [anon_sym_uR_DQUOTE] = ACTIONS(3150),
    [anon_sym_UR_DQUOTE] = ACTIONS(3150),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3150),
    [anon_sym_co_await] = ACTIONS(3148),
    [anon_sym_new] = ACTIONS(3148),
    [anon_sym_requires] = ACTIONS(3148),
    [sym_this] = ACTIONS(3148),
    [anon_sym_discard] = ACTIONS(3148),
    [anon_sym_precise] = ACTIONS(3148),
    [anon_sym_shared] = ACTIONS(3148),
    [anon_sym_groupshared] = ACTIONS(3148),
    [anon_sym_uniform] = ACTIONS(3148),
    [anon_sym_row_major] = ACTIONS(3148),
    [anon_sym_column_major] = ACTIONS(3148),
    [anon_sym_globallycoherent] = ACTIONS(3148),
    [anon_sym_centroid] = ACTIONS(3148),
    [anon_sym_noperspective] = ACTIONS(3148),
    [anon_sym_nointerpolation] = ACTIONS(3148),
    [anon_sym_sample] = ACTIONS(3148),
    [anon_sym_linear] = ACTIONS(3148),
    [anon_sym_snorm] = ACTIONS(3148),
    [anon_sym_unorm] = ACTIONS(3148),
    [anon_sym_point] = ACTIONS(3148),
    [anon_sym_line] = ACTIONS(3148),
    [anon_sym_triangleadj] = ACTIONS(3148),
    [anon_sym_lineadj] = ACTIONS(3148),
    [anon_sym_triangle] = ACTIONS(3148),
    [anon_sym_cbuffer] = ACTIONS(3148),
    [anon_sym_interface] = ACTIONS(3148),
    [anon_sym_extension] = ACTIONS(3148),
    [anon_sym___exported] = ACTIONS(3148),
  },
  [364] = {
    [sym_preproc_def] = STATE(365),
    [sym_preproc_function_def] = STATE(365),
    [sym_preproc_call] = STATE(365),
    [sym_preproc_if_in_field_declaration_list] = STATE(365),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(365),
    [sym_type_definition] = STATE(365),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(365),
    [sym_field_declaration] = STATE(365),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(365),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(365),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(365),
    [sym_operator_cast_declaration] = STATE(365),
    [sym_constructor_or_destructor_definition] = STATE(365),
    [sym_constructor_or_destructor_declaration] = STATE(365),
    [sym_friend_declaration] = STATE(365),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(365),
    [sym_alias_declaration] = STATE(365),
    [sym_static_assert_declaration] = STATE(365),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(365),
    [sym_subscript_declaration] = STATE(365),
    [sym_property_declaration] = STATE(365),
    [sym_associatedtype_declaration] = STATE(365),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(365),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3260),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3262),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [365] = {
    [sym_preproc_def] = STATE(374),
    [sym_preproc_function_def] = STATE(374),
    [sym_preproc_call] = STATE(374),
    [sym_preproc_if_in_field_declaration_list] = STATE(374),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(374),
    [sym_type_definition] = STATE(374),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(374),
    [sym_field_declaration] = STATE(374),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(374),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(374),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(374),
    [sym_operator_cast_declaration] = STATE(374),
    [sym_constructor_or_destructor_definition] = STATE(374),
    [sym_constructor_or_destructor_declaration] = STATE(374),
    [sym_friend_declaration] = STATE(374),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(374),
    [sym_alias_declaration] = STATE(374),
    [sym_static_assert_declaration] = STATE(374),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(374),
    [sym_subscript_declaration] = STATE(374),
    [sym_property_declaration] = STATE(374),
    [sym_associatedtype_declaration] = STATE(374),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3264),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [366] = {
    [sym_else_clause] = STATE(458),
    [sym_identifier] = ACTIONS(3240),
    [aux_sym_preproc_include_token1] = ACTIONS(3240),
    [aux_sym_preproc_def_token1] = ACTIONS(3240),
    [aux_sym_preproc_if_token1] = ACTIONS(3240),
    [aux_sym_preproc_if_token2] = ACTIONS(3240),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3240),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3240),
    [aux_sym_preproc_else_token1] = ACTIONS(3240),
    [aux_sym_preproc_elif_token1] = ACTIONS(3240),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3240),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3240),
    [sym_preproc_directive] = ACTIONS(3240),
    [anon_sym_LPAREN2] = ACTIONS(3238),
    [anon_sym_BANG] = ACTIONS(3238),
    [anon_sym_TILDE] = ACTIONS(3238),
    [anon_sym_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3240),
    [anon_sym_STAR] = ACTIONS(3238),
    [anon_sym_AMP_AMP] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_SEMI] = ACTIONS(3238),
    [anon_sym___extension__] = ACTIONS(3240),
    [anon_sym_typedef] = ACTIONS(3240),
    [anon_sym_in] = ACTIONS(3240),
    [anon_sym_out] = ACTIONS(3240),
    [anon_sym_inout] = ACTIONS(3240),
    [anon_sym_virtual] = ACTIONS(3240),
    [anon_sym_extern] = ACTIONS(3240),
    [anon_sym___attribute__] = ACTIONS(3240),
    [anon_sym___attribute] = ACTIONS(3240),
    [anon_sym_using] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3238),
    [anon_sym___declspec] = ACTIONS(3240),
    [anon_sym___based] = ACTIONS(3240),
    [anon_sym___cdecl] = ACTIONS(3240),
    [anon_sym___clrcall] = ACTIONS(3240),
    [anon_sym___stdcall] = ACTIONS(3240),
    [anon_sym___fastcall] = ACTIONS(3240),
    [anon_sym___thiscall] = ACTIONS(3240),
    [anon_sym___vectorcall] = ACTIONS(3240),
    [anon_sym_LBRACE] = ACTIONS(3238),
    [anon_sym_signed] = ACTIONS(3240),
    [anon_sym_unsigned] = ACTIONS(3240),
    [anon_sym_long] = ACTIONS(3240),
    [anon_sym_short] = ACTIONS(3240),
    [anon_sym_LBRACK] = ACTIONS(3240),
    [anon_sym_static] = ACTIONS(3240),
    [anon_sym_register] = ACTIONS(3240),
    [anon_sym_inline] = ACTIONS(3240),
    [anon_sym___inline] = ACTIONS(3240),
    [anon_sym___inline__] = ACTIONS(3240),
    [anon_sym___forceinline] = ACTIONS(3240),
    [anon_sym_thread_local] = ACTIONS(3240),
    [anon_sym___thread] = ACTIONS(3240),
    [anon_sym_const] = ACTIONS(3240),
    [anon_sym_constexpr] = ACTIONS(3240),
    [anon_sym_volatile] = ACTIONS(3240),
    [anon_sym_restrict] = ACTIONS(3240),
    [anon_sym___restrict__] = ACTIONS(3240),
    [anon_sym__Atomic] = ACTIONS(3240),
    [anon_sym__Noreturn] = ACTIONS(3240),
    [anon_sym_noreturn] = ACTIONS(3240),
    [anon_sym__Nonnull] = ACTIONS(3240),
    [anon_sym_mutable] = ACTIONS(3240),
    [anon_sym_constinit] = ACTIONS(3240),
    [anon_sym_consteval] = ACTIONS(3240),
    [anon_sym_alignas] = ACTIONS(3240),
    [anon_sym__Alignas] = ACTIONS(3240),
    [sym_primitive_type] = ACTIONS(3240),
    [anon_sym_enum] = ACTIONS(3240),
    [anon_sym_class] = ACTIONS(3240),
    [anon_sym_struct] = ACTIONS(3240),
    [anon_sym_union] = ACTIONS(3240),
    [anon_sym_if] = ACTIONS(3240),
    [anon_sym_else] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3240),
    [anon_sym_case] = ACTIONS(3240),
    [anon_sym_default] = ACTIONS(3240),
    [anon_sym_while] = ACTIONS(3240),
    [anon_sym_do] = ACTIONS(3240),
    [anon_sym_for] = ACTIONS(3240),
    [anon_sym_return] = ACTIONS(3240),
    [anon_sym_break] = ACTIONS(3240),
    [anon_sym_continue] = ACTIONS(3240),
    [anon_sym_goto] = ACTIONS(3240),
    [anon_sym___try] = ACTIONS(3240),
    [anon_sym___leave] = ACTIONS(3240),
    [anon_sym_not] = ACTIONS(3240),
    [anon_sym_compl] = ACTIONS(3240),
    [anon_sym_DASH_DASH] = ACTIONS(3238),
    [anon_sym_PLUS_PLUS] = ACTIONS(3238),
    [anon_sym_sizeof] = ACTIONS(3240),
    [anon_sym___alignof__] = ACTIONS(3240),
    [anon_sym___alignof] = ACTIONS(3240),
    [anon_sym__alignof] = ACTIONS(3240),
    [anon_sym_alignof] = ACTIONS(3240),
    [anon_sym__Alignof] = ACTIONS(3240),
    [anon_sym_offsetof] = ACTIONS(3240),
    [anon_sym__Generic] = ACTIONS(3240),
    [anon_sym_asm] = ACTIONS(3240),
    [anon_sym___asm__] = ACTIONS(3240),
    [anon_sym___asm] = ACTIONS(3240),
    [sym_number_literal] = ACTIONS(3238),
    [anon_sym_L_SQUOTE] = ACTIONS(3238),
    [anon_sym_u_SQUOTE] = ACTIONS(3238),
    [anon_sym_U_SQUOTE] = ACTIONS(3238),
    [anon_sym_u8_SQUOTE] = ACTIONS(3238),
    [anon_sym_SQUOTE] = ACTIONS(3238),
    [anon_sym_L_DQUOTE] = ACTIONS(3238),
    [anon_sym_u_DQUOTE] = ACTIONS(3238),
    [anon_sym_U_DQUOTE] = ACTIONS(3238),
    [anon_sym_u8_DQUOTE] = ACTIONS(3238),
    [anon_sym_DQUOTE] = ACTIONS(3238),
    [sym_true] = ACTIONS(3240),
    [sym_false] = ACTIONS(3240),
    [anon_sym_NULL] = ACTIONS(3240),
    [anon_sym_nullptr] = ACTIONS(3240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3240),
    [anon_sym_let] = ACTIONS(3240),
    [anon_sym_This] = ACTIONS(3240),
    [anon_sym_decltype] = ACTIONS(3240),
    [anon_sym_explicit] = ACTIONS(3240),
    [anon_sym_typename] = ACTIONS(3240),
    [anon_sym_template] = ACTIONS(3240),
    [anon_sym_operator] = ACTIONS(3240),
    [anon_sym_try] = ACTIONS(3240),
    [anon_sym_delete] = ACTIONS(3240),
    [anon_sym_throw] = ACTIONS(3240),
    [anon_sym_namespace] = ACTIONS(3240),
    [anon_sym_static_assert] = ACTIONS(3240),
    [anon_sym_concept] = ACTIONS(3240),
    [anon_sym_co_return] = ACTIONS(3240),
    [anon_sym_co_yield] = ACTIONS(3240),
    [anon_sym_R_DQUOTE] = ACTIONS(3238),
    [anon_sym_LR_DQUOTE] = ACTIONS(3238),
    [anon_sym_uR_DQUOTE] = ACTIONS(3238),
    [anon_sym_UR_DQUOTE] = ACTIONS(3238),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3238),
    [anon_sym_co_await] = ACTIONS(3240),
    [anon_sym_new] = ACTIONS(3240),
    [anon_sym_requires] = ACTIONS(3240),
    [sym_this] = ACTIONS(3240),
    [anon_sym_discard] = ACTIONS(3240),
    [anon_sym_precise] = ACTIONS(3240),
    [anon_sym_shared] = ACTIONS(3240),
    [anon_sym_groupshared] = ACTIONS(3240),
    [anon_sym_uniform] = ACTIONS(3240),
    [anon_sym_row_major] = ACTIONS(3240),
    [anon_sym_column_major] = ACTIONS(3240),
    [anon_sym_globallycoherent] = ACTIONS(3240),
    [anon_sym_centroid] = ACTIONS(3240),
    [anon_sym_noperspective] = ACTIONS(3240),
    [anon_sym_nointerpolation] = ACTIONS(3240),
    [anon_sym_sample] = ACTIONS(3240),
    [anon_sym_linear] = ACTIONS(3240),
    [anon_sym_snorm] = ACTIONS(3240),
    [anon_sym_unorm] = ACTIONS(3240),
    [anon_sym_point] = ACTIONS(3240),
    [anon_sym_line] = ACTIONS(3240),
    [anon_sym_triangleadj] = ACTIONS(3240),
    [anon_sym_lineadj] = ACTIONS(3240),
    [anon_sym_triangle] = ACTIONS(3240),
    [anon_sym_cbuffer] = ACTIONS(3240),
    [anon_sym_interface] = ACTIONS(3240),
    [anon_sym_extension] = ACTIONS(3240),
  },
  [367] = {
    [sym_preproc_def] = STATE(374),
    [sym_preproc_function_def] = STATE(374),
    [sym_preproc_call] = STATE(374),
    [sym_preproc_if_in_field_declaration_list] = STATE(374),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(374),
    [sym_type_definition] = STATE(374),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(374),
    [sym_field_declaration] = STATE(374),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(374),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(374),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(374),
    [sym_operator_cast_declaration] = STATE(374),
    [sym_constructor_or_destructor_definition] = STATE(374),
    [sym_constructor_or_destructor_declaration] = STATE(374),
    [sym_friend_declaration] = STATE(374),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(374),
    [sym_alias_declaration] = STATE(374),
    [sym_static_assert_declaration] = STATE(374),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(374),
    [sym_subscript_declaration] = STATE(374),
    [sym_property_declaration] = STATE(374),
    [sym_associatedtype_declaration] = STATE(374),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3266),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [368] = {
    [sym_preproc_def] = STATE(369),
    [sym_preproc_function_def] = STATE(369),
    [sym_preproc_call] = STATE(369),
    [sym_preproc_if_in_field_declaration_list] = STATE(369),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(369),
    [sym_type_definition] = STATE(369),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(369),
    [sym_field_declaration] = STATE(369),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(369),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(369),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(369),
    [sym_operator_cast_declaration] = STATE(369),
    [sym_constructor_or_destructor_definition] = STATE(369),
    [sym_constructor_or_destructor_declaration] = STATE(369),
    [sym_friend_declaration] = STATE(369),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(369),
    [sym_alias_declaration] = STATE(369),
    [sym_static_assert_declaration] = STATE(369),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(369),
    [sym_subscript_declaration] = STATE(369),
    [sym_property_declaration] = STATE(369),
    [sym_associatedtype_declaration] = STATE(369),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(369),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3268),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3270),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [369] = {
    [sym_preproc_def] = STATE(374),
    [sym_preproc_function_def] = STATE(374),
    [sym_preproc_call] = STATE(374),
    [sym_preproc_if_in_field_declaration_list] = STATE(374),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(374),
    [sym_type_definition] = STATE(374),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(374),
    [sym_field_declaration] = STATE(374),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(374),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(374),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(374),
    [sym_operator_cast_declaration] = STATE(374),
    [sym_constructor_or_destructor_definition] = STATE(374),
    [sym_constructor_or_destructor_declaration] = STATE(374),
    [sym_friend_declaration] = STATE(374),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(374),
    [sym_alias_declaration] = STATE(374),
    [sym_static_assert_declaration] = STATE(374),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(374),
    [sym_subscript_declaration] = STATE(374),
    [sym_property_declaration] = STATE(374),
    [sym_associatedtype_declaration] = STATE(374),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3272),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [370] = {
    [sym_preproc_def] = STATE(371),
    [sym_preproc_function_def] = STATE(371),
    [sym_preproc_call] = STATE(371),
    [sym_preproc_if_in_field_declaration_list] = STATE(371),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(371),
    [sym_type_definition] = STATE(371),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(371),
    [sym_field_declaration] = STATE(371),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(371),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(371),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(371),
    [sym_operator_cast_declaration] = STATE(371),
    [sym_constructor_or_destructor_definition] = STATE(371),
    [sym_constructor_or_destructor_declaration] = STATE(371),
    [sym_friend_declaration] = STATE(371),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(371),
    [sym_alias_declaration] = STATE(371),
    [sym_static_assert_declaration] = STATE(371),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(371),
    [sym_subscript_declaration] = STATE(371),
    [sym_property_declaration] = STATE(371),
    [sym_associatedtype_declaration] = STATE(371),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(371),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3274),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3276),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [371] = {
    [sym_preproc_def] = STATE(374),
    [sym_preproc_function_def] = STATE(374),
    [sym_preproc_call] = STATE(374),
    [sym_preproc_if_in_field_declaration_list] = STATE(374),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(374),
    [sym_type_definition] = STATE(374),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(374),
    [sym_field_declaration] = STATE(374),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(374),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(374),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(374),
    [sym_operator_cast_declaration] = STATE(374),
    [sym_constructor_or_destructor_definition] = STATE(374),
    [sym_constructor_or_destructor_declaration] = STATE(374),
    [sym_friend_declaration] = STATE(374),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(374),
    [sym_alias_declaration] = STATE(374),
    [sym_static_assert_declaration] = STATE(374),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(374),
    [sym_subscript_declaration] = STATE(374),
    [sym_property_declaration] = STATE(374),
    [sym_associatedtype_declaration] = STATE(374),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3278),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [372] = {
    [sym_preproc_def] = STATE(373),
    [sym_preproc_function_def] = STATE(373),
    [sym_preproc_call] = STATE(373),
    [sym_preproc_if_in_field_declaration_list] = STATE(373),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(373),
    [sym_type_definition] = STATE(373),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(373),
    [sym_field_declaration] = STATE(373),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(373),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(373),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(373),
    [sym_operator_cast_declaration] = STATE(373),
    [sym_constructor_or_destructor_definition] = STATE(373),
    [sym_constructor_or_destructor_declaration] = STATE(373),
    [sym_friend_declaration] = STATE(373),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(373),
    [sym_alias_declaration] = STATE(373),
    [sym_static_assert_declaration] = STATE(373),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(373),
    [sym_subscript_declaration] = STATE(373),
    [sym_property_declaration] = STATE(373),
    [sym_associatedtype_declaration] = STATE(373),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(373),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3280),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3282),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [373] = {
    [sym_preproc_def] = STATE(374),
    [sym_preproc_function_def] = STATE(374),
    [sym_preproc_call] = STATE(374),
    [sym_preproc_if_in_field_declaration_list] = STATE(374),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(374),
    [sym_type_definition] = STATE(374),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(374),
    [sym_field_declaration] = STATE(374),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(374),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(374),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(374),
    [sym_operator_cast_declaration] = STATE(374),
    [sym_constructor_or_destructor_definition] = STATE(374),
    [sym_constructor_or_destructor_declaration] = STATE(374),
    [sym_friend_declaration] = STATE(374),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(374),
    [sym_alias_declaration] = STATE(374),
    [sym_static_assert_declaration] = STATE(374),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(374),
    [sym_subscript_declaration] = STATE(374),
    [sym_property_declaration] = STATE(374),
    [sym_associatedtype_declaration] = STATE(374),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3284),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [374] = {
    [sym_preproc_def] = STATE(374),
    [sym_preproc_function_def] = STATE(374),
    [sym_preproc_call] = STATE(374),
    [sym_preproc_if_in_field_declaration_list] = STATE(374),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(374),
    [sym_type_definition] = STATE(374),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(374),
    [sym_field_declaration] = STATE(374),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(374),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(374),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(374),
    [sym_operator_cast_declaration] = STATE(374),
    [sym_constructor_or_destructor_definition] = STATE(374),
    [sym_constructor_or_destructor_declaration] = STATE(374),
    [sym_friend_declaration] = STATE(374),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(374),
    [sym_alias_declaration] = STATE(374),
    [sym_static_assert_declaration] = STATE(374),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(374),
    [sym_subscript_declaration] = STATE(374),
    [sym_property_declaration] = STATE(374),
    [sym_associatedtype_declaration] = STATE(374),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2654),
    [aux_sym_preproc_def_token1] = ACTIONS(3286),
    [aux_sym_preproc_if_token1] = ACTIONS(3289),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3292),
    [sym_preproc_directive] = ACTIONS(3295),
    [anon_sym_LPAREN2] = ACTIONS(2671),
    [anon_sym_TILDE] = ACTIONS(2674),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_AMP_AMP] = ACTIONS(2680),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_SEMI] = ACTIONS(3298),
    [anon_sym___extension__] = ACTIONS(3301),
    [anon_sym_typedef] = ACTIONS(3304),
    [anon_sym_in] = ACTIONS(2695),
    [anon_sym_out] = ACTIONS(2695),
    [anon_sym_inout] = ACTIONS(2695),
    [anon_sym_virtual] = ACTIONS(2695),
    [anon_sym_extern] = ACTIONS(2698),
    [anon_sym___attribute__] = ACTIONS(2701),
    [anon_sym___attribute] = ACTIONS(2701),
    [anon_sym_using] = ACTIONS(3307),
    [anon_sym_COLON_COLON] = ACTIONS(2707),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2710),
    [anon_sym___declspec] = ACTIONS(2713),
    [anon_sym___based] = ACTIONS(2716),
    [anon_sym_RBRACE] = ACTIONS(3310),
    [anon_sym_signed] = ACTIONS(2719),
    [anon_sym_unsigned] = ACTIONS(2719),
    [anon_sym_long] = ACTIONS(2719),
    [anon_sym_short] = ACTIONS(2719),
    [anon_sym_LBRACK] = ACTIONS(2722),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_register] = ACTIONS(2698),
    [anon_sym_inline] = ACTIONS(2698),
    [anon_sym___inline] = ACTIONS(2698),
    [anon_sym___inline__] = ACTIONS(2698),
    [anon_sym___forceinline] = ACTIONS(2698),
    [anon_sym_thread_local] = ACTIONS(2698),
    [anon_sym___thread] = ACTIONS(2698),
    [anon_sym_const] = ACTIONS(2725),
    [anon_sym_constexpr] = ACTIONS(3312),
    [anon_sym_volatile] = ACTIONS(2725),
    [anon_sym_restrict] = ACTIONS(2725),
    [anon_sym___restrict__] = ACTIONS(2725),
    [anon_sym__Atomic] = ACTIONS(2725),
    [anon_sym__Noreturn] = ACTIONS(2725),
    [anon_sym_noreturn] = ACTIONS(2725),
    [anon_sym__Nonnull] = ACTIONS(2725),
    [anon_sym_mutable] = ACTIONS(2725),
    [anon_sym_constinit] = ACTIONS(2725),
    [anon_sym_consteval] = ACTIONS(2725),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2734),
    [anon_sym_enum] = ACTIONS(2737),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2743),
    [anon_sym_union] = ACTIONS(2746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2749),
    [anon_sym_let] = ACTIONS(2749),
    [anon_sym_This] = ACTIONS(2749),
    [anon_sym_decltype] = ACTIONS(2752),
    [anon_sym_explicit] = ACTIONS(2755),
    [anon_sym_typename] = ACTIONS(2758),
    [anon_sym_private] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(3315),
    [anon_sym_operator] = ACTIONS(2767),
    [anon_sym_friend] = ACTIONS(3318),
    [anon_sym_public] = ACTIONS(2761),
    [anon_sym_protected] = ACTIONS(2761),
    [anon_sym_static_assert] = ACTIONS(3321),
    [anon_sym_precise] = ACTIONS(2776),
    [anon_sym_shared] = ACTIONS(2776),
    [anon_sym_groupshared] = ACTIONS(2776),
    [anon_sym_uniform] = ACTIONS(2776),
    [anon_sym_row_major] = ACTIONS(2776),
    [anon_sym_column_major] = ACTIONS(2776),
    [anon_sym_globallycoherent] = ACTIONS(2776),
    [anon_sym_centroid] = ACTIONS(2776),
    [anon_sym_noperspective] = ACTIONS(2776),
    [anon_sym_nointerpolation] = ACTIONS(2776),
    [anon_sym_sample] = ACTIONS(2776),
    [anon_sym_linear] = ACTIONS(2776),
    [anon_sym_snorm] = ACTIONS(2776),
    [anon_sym_unorm] = ACTIONS(2776),
    [anon_sym_point] = ACTIONS(2776),
    [anon_sym_line] = ACTIONS(2776),
    [anon_sym_triangleadj] = ACTIONS(2776),
    [anon_sym_lineadj] = ACTIONS(2776),
    [anon_sym_triangle] = ACTIONS(2776),
    [anon_sym_interface] = ACTIONS(2779),
    [anon_sym_extension] = ACTIONS(2782),
    [anon_sym___init] = ACTIONS(3324),
    [anon_sym___subscript] = ACTIONS(3327),
    [anon_sym_property] = ACTIONS(3330),
    [anon_sym_associatedtype] = ACTIONS(3333),
  },
  [375] = {
    [sym_preproc_def] = STATE(351),
    [sym_preproc_function_def] = STATE(351),
    [sym_preproc_call] = STATE(351),
    [sym_preproc_if_in_field_declaration_list] = STATE(351),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(351),
    [sym_type_definition] = STATE(351),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(7112),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2837),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3088),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__field_declaration_list_item] = STATE(351),
    [sym_field_declaration] = STATE(351),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(351),
    [sym_operator_cast] = STATE(9099),
    [sym_inline_method_definition] = STATE(351),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(351),
    [sym_operator_cast_declaration] = STATE(351),
    [sym_constructor_or_destructor_definition] = STATE(351),
    [sym_constructor_or_destructor_declaration] = STATE(351),
    [sym_friend_declaration] = STATE(351),
    [sym_access_specifier] = STATE(11045),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_using_declaration] = STATE(351),
    [sym_alias_declaration] = STATE(351),
    [sym_static_assert_declaration] = STATE(351),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7049),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_init_declaration] = STATE(351),
    [sym_subscript_declaration] = STATE(351),
    [sym_property_declaration] = STATE(351),
    [sym_associatedtype_declaration] = STATE(351),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(351),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2665),
    [aux_sym_attributed_declarator_repeat1] = STATE(9416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(2430),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3066),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(3336),
    [anon_sym___extension__] = ACTIONS(3070),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3338),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(3084),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
    [anon_sym___init] = ACTIONS(3086),
    [anon_sym___subscript] = ACTIONS(3088),
    [anon_sym_property] = ACTIONS(3090),
    [anon_sym_associatedtype] = ACTIONS(3092),
  },
  [376] = {
    [sym_expression] = STATE(5382),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(3343),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(3349),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3354),
    [anon_sym___extension__] = ACTIONS(3357),
    [anon_sym_typedef] = ACTIONS(3360),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3370),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3373),
    [anon_sym_explicit] = ACTIONS(3362),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3376),
    [anon_sym_operator] = ACTIONS(3362),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [377] = {
    [sym_identifier] = ACTIONS(3379),
    [aux_sym_preproc_include_token1] = ACTIONS(3379),
    [aux_sym_preproc_def_token1] = ACTIONS(3379),
    [aux_sym_preproc_if_token1] = ACTIONS(3379),
    [aux_sym_preproc_if_token2] = ACTIONS(3379),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3379),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3379),
    [aux_sym_preproc_else_token1] = ACTIONS(3379),
    [aux_sym_preproc_elif_token1] = ACTIONS(3379),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3379),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3379),
    [sym_preproc_directive] = ACTIONS(3379),
    [anon_sym_LPAREN2] = ACTIONS(3381),
    [anon_sym_BANG] = ACTIONS(3381),
    [anon_sym_TILDE] = ACTIONS(3381),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_STAR] = ACTIONS(3381),
    [anon_sym_AMP_AMP] = ACTIONS(3381),
    [anon_sym_AMP] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3381),
    [anon_sym___extension__] = ACTIONS(3379),
    [anon_sym_typedef] = ACTIONS(3379),
    [anon_sym_in] = ACTIONS(3379),
    [anon_sym_out] = ACTIONS(3379),
    [anon_sym_inout] = ACTIONS(3379),
    [anon_sym_virtual] = ACTIONS(3379),
    [anon_sym_extern] = ACTIONS(3379),
    [anon_sym___attribute__] = ACTIONS(3379),
    [anon_sym___attribute] = ACTIONS(3379),
    [anon_sym_using] = ACTIONS(3379),
    [anon_sym_COLON_COLON] = ACTIONS(3381),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3381),
    [anon_sym___declspec] = ACTIONS(3379),
    [anon_sym___based] = ACTIONS(3379),
    [anon_sym___cdecl] = ACTIONS(3379),
    [anon_sym___clrcall] = ACTIONS(3379),
    [anon_sym___stdcall] = ACTIONS(3379),
    [anon_sym___fastcall] = ACTIONS(3379),
    [anon_sym___thiscall] = ACTIONS(3379),
    [anon_sym___vectorcall] = ACTIONS(3379),
    [anon_sym_LBRACE] = ACTIONS(3381),
    [anon_sym_signed] = ACTIONS(3379),
    [anon_sym_unsigned] = ACTIONS(3379),
    [anon_sym_long] = ACTIONS(3379),
    [anon_sym_short] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_register] = ACTIONS(3379),
    [anon_sym_inline] = ACTIONS(3379),
    [anon_sym___inline] = ACTIONS(3379),
    [anon_sym___inline__] = ACTIONS(3379),
    [anon_sym___forceinline] = ACTIONS(3379),
    [anon_sym_thread_local] = ACTIONS(3379),
    [anon_sym___thread] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_constexpr] = ACTIONS(3379),
    [anon_sym_volatile] = ACTIONS(3379),
    [anon_sym_restrict] = ACTIONS(3379),
    [anon_sym___restrict__] = ACTIONS(3379),
    [anon_sym__Atomic] = ACTIONS(3379),
    [anon_sym__Noreturn] = ACTIONS(3379),
    [anon_sym_noreturn] = ACTIONS(3379),
    [anon_sym__Nonnull] = ACTIONS(3379),
    [anon_sym_mutable] = ACTIONS(3379),
    [anon_sym_constinit] = ACTIONS(3379),
    [anon_sym_consteval] = ACTIONS(3379),
    [anon_sym_alignas] = ACTIONS(3379),
    [anon_sym__Alignas] = ACTIONS(3379),
    [sym_primitive_type] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_struct] = ACTIONS(3379),
    [anon_sym_union] = ACTIONS(3379),
    [anon_sym_if] = ACTIONS(3379),
    [anon_sym_else] = ACTIONS(3379),
    [anon_sym_switch] = ACTIONS(3379),
    [anon_sym_case] = ACTIONS(3379),
    [anon_sym_default] = ACTIONS(3379),
    [anon_sym_while] = ACTIONS(3379),
    [anon_sym_do] = ACTIONS(3379),
    [anon_sym_for] = ACTIONS(3379),
    [anon_sym_return] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(3379),
    [anon_sym_continue] = ACTIONS(3379),
    [anon_sym_goto] = ACTIONS(3379),
    [anon_sym___try] = ACTIONS(3379),
    [anon_sym___leave] = ACTIONS(3379),
    [anon_sym_not] = ACTIONS(3379),
    [anon_sym_compl] = ACTIONS(3379),
    [anon_sym_DASH_DASH] = ACTIONS(3381),
    [anon_sym_PLUS_PLUS] = ACTIONS(3381),
    [anon_sym_sizeof] = ACTIONS(3379),
    [anon_sym___alignof__] = ACTIONS(3379),
    [anon_sym___alignof] = ACTIONS(3379),
    [anon_sym__alignof] = ACTIONS(3379),
    [anon_sym_alignof] = ACTIONS(3379),
    [anon_sym__Alignof] = ACTIONS(3379),
    [anon_sym_offsetof] = ACTIONS(3379),
    [anon_sym__Generic] = ACTIONS(3379),
    [anon_sym_asm] = ACTIONS(3379),
    [anon_sym___asm__] = ACTIONS(3379),
    [anon_sym___asm] = ACTIONS(3379),
    [sym_number_literal] = ACTIONS(3381),
    [anon_sym_L_SQUOTE] = ACTIONS(3381),
    [anon_sym_u_SQUOTE] = ACTIONS(3381),
    [anon_sym_U_SQUOTE] = ACTIONS(3381),
    [anon_sym_u8_SQUOTE] = ACTIONS(3381),
    [anon_sym_SQUOTE] = ACTIONS(3381),
    [anon_sym_L_DQUOTE] = ACTIONS(3381),
    [anon_sym_u_DQUOTE] = ACTIONS(3381),
    [anon_sym_U_DQUOTE] = ACTIONS(3381),
    [anon_sym_u8_DQUOTE] = ACTIONS(3381),
    [anon_sym_DQUOTE] = ACTIONS(3381),
    [sym_true] = ACTIONS(3379),
    [sym_false] = ACTIONS(3379),
    [anon_sym_NULL] = ACTIONS(3379),
    [anon_sym_nullptr] = ACTIONS(3379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3379),
    [anon_sym_let] = ACTIONS(3379),
    [anon_sym_This] = ACTIONS(3379),
    [anon_sym_decltype] = ACTIONS(3379),
    [anon_sym_explicit] = ACTIONS(3379),
    [anon_sym_typename] = ACTIONS(3379),
    [anon_sym_template] = ACTIONS(3379),
    [anon_sym_operator] = ACTIONS(3379),
    [anon_sym_try] = ACTIONS(3379),
    [anon_sym_delete] = ACTIONS(3379),
    [anon_sym_throw] = ACTIONS(3379),
    [anon_sym_namespace] = ACTIONS(3379),
    [anon_sym_static_assert] = ACTIONS(3379),
    [anon_sym_concept] = ACTIONS(3379),
    [anon_sym_co_return] = ACTIONS(3379),
    [anon_sym_co_yield] = ACTIONS(3379),
    [anon_sym_R_DQUOTE] = ACTIONS(3381),
    [anon_sym_LR_DQUOTE] = ACTIONS(3381),
    [anon_sym_uR_DQUOTE] = ACTIONS(3381),
    [anon_sym_UR_DQUOTE] = ACTIONS(3381),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3381),
    [anon_sym_co_await] = ACTIONS(3379),
    [anon_sym_new] = ACTIONS(3379),
    [anon_sym_requires] = ACTIONS(3379),
    [sym_this] = ACTIONS(3379),
    [anon_sym_discard] = ACTIONS(3379),
    [anon_sym_precise] = ACTIONS(3379),
    [anon_sym_shared] = ACTIONS(3379),
    [anon_sym_groupshared] = ACTIONS(3379),
    [anon_sym_uniform] = ACTIONS(3379),
    [anon_sym_row_major] = ACTIONS(3379),
    [anon_sym_column_major] = ACTIONS(3379),
    [anon_sym_globallycoherent] = ACTIONS(3379),
    [anon_sym_centroid] = ACTIONS(3379),
    [anon_sym_noperspective] = ACTIONS(3379),
    [anon_sym_nointerpolation] = ACTIONS(3379),
    [anon_sym_sample] = ACTIONS(3379),
    [anon_sym_linear] = ACTIONS(3379),
    [anon_sym_snorm] = ACTIONS(3379),
    [anon_sym_unorm] = ACTIONS(3379),
    [anon_sym_point] = ACTIONS(3379),
    [anon_sym_line] = ACTIONS(3379),
    [anon_sym_triangleadj] = ACTIONS(3379),
    [anon_sym_lineadj] = ACTIONS(3379),
    [anon_sym_triangle] = ACTIONS(3379),
    [anon_sym_cbuffer] = ACTIONS(3379),
    [anon_sym_interface] = ACTIONS(3379),
    [anon_sym_extension] = ACTIONS(3379),
  },
  [378] = {
    [sym_identifier] = ACTIONS(3383),
    [aux_sym_preproc_include_token1] = ACTIONS(3383),
    [aux_sym_preproc_def_token1] = ACTIONS(3383),
    [aux_sym_preproc_if_token1] = ACTIONS(3383),
    [aux_sym_preproc_if_token2] = ACTIONS(3383),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3383),
    [aux_sym_preproc_else_token1] = ACTIONS(3383),
    [aux_sym_preproc_elif_token1] = ACTIONS(3383),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3383),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3383),
    [sym_preproc_directive] = ACTIONS(3383),
    [anon_sym_LPAREN2] = ACTIONS(3385),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_TILDE] = ACTIONS(3385),
    [anon_sym_DASH] = ACTIONS(3383),
    [anon_sym_PLUS] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(3385),
    [anon_sym_AMP_AMP] = ACTIONS(3385),
    [anon_sym_AMP] = ACTIONS(3383),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym___extension__] = ACTIONS(3383),
    [anon_sym_typedef] = ACTIONS(3383),
    [anon_sym_in] = ACTIONS(3383),
    [anon_sym_out] = ACTIONS(3383),
    [anon_sym_inout] = ACTIONS(3383),
    [anon_sym_virtual] = ACTIONS(3383),
    [anon_sym_extern] = ACTIONS(3383),
    [anon_sym___attribute__] = ACTIONS(3383),
    [anon_sym___attribute] = ACTIONS(3383),
    [anon_sym_using] = ACTIONS(3383),
    [anon_sym_COLON_COLON] = ACTIONS(3385),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3385),
    [anon_sym___declspec] = ACTIONS(3383),
    [anon_sym___based] = ACTIONS(3383),
    [anon_sym___cdecl] = ACTIONS(3383),
    [anon_sym___clrcall] = ACTIONS(3383),
    [anon_sym___stdcall] = ACTIONS(3383),
    [anon_sym___fastcall] = ACTIONS(3383),
    [anon_sym___thiscall] = ACTIONS(3383),
    [anon_sym___vectorcall] = ACTIONS(3383),
    [anon_sym_LBRACE] = ACTIONS(3385),
    [anon_sym_signed] = ACTIONS(3383),
    [anon_sym_unsigned] = ACTIONS(3383),
    [anon_sym_long] = ACTIONS(3383),
    [anon_sym_short] = ACTIONS(3383),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_static] = ACTIONS(3383),
    [anon_sym_register] = ACTIONS(3383),
    [anon_sym_inline] = ACTIONS(3383),
    [anon_sym___inline] = ACTIONS(3383),
    [anon_sym___inline__] = ACTIONS(3383),
    [anon_sym___forceinline] = ACTIONS(3383),
    [anon_sym_thread_local] = ACTIONS(3383),
    [anon_sym___thread] = ACTIONS(3383),
    [anon_sym_const] = ACTIONS(3383),
    [anon_sym_constexpr] = ACTIONS(3383),
    [anon_sym_volatile] = ACTIONS(3383),
    [anon_sym_restrict] = ACTIONS(3383),
    [anon_sym___restrict__] = ACTIONS(3383),
    [anon_sym__Atomic] = ACTIONS(3383),
    [anon_sym__Noreturn] = ACTIONS(3383),
    [anon_sym_noreturn] = ACTIONS(3383),
    [anon_sym__Nonnull] = ACTIONS(3383),
    [anon_sym_mutable] = ACTIONS(3383),
    [anon_sym_constinit] = ACTIONS(3383),
    [anon_sym_consteval] = ACTIONS(3383),
    [anon_sym_alignas] = ACTIONS(3383),
    [anon_sym__Alignas] = ACTIONS(3383),
    [sym_primitive_type] = ACTIONS(3383),
    [anon_sym_enum] = ACTIONS(3383),
    [anon_sym_class] = ACTIONS(3383),
    [anon_sym_struct] = ACTIONS(3383),
    [anon_sym_union] = ACTIONS(3383),
    [anon_sym_if] = ACTIONS(3383),
    [anon_sym_else] = ACTIONS(3383),
    [anon_sym_switch] = ACTIONS(3383),
    [anon_sym_case] = ACTIONS(3383),
    [anon_sym_default] = ACTIONS(3383),
    [anon_sym_while] = ACTIONS(3383),
    [anon_sym_do] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3383),
    [anon_sym_return] = ACTIONS(3383),
    [anon_sym_break] = ACTIONS(3383),
    [anon_sym_continue] = ACTIONS(3383),
    [anon_sym_goto] = ACTIONS(3383),
    [anon_sym___try] = ACTIONS(3383),
    [anon_sym___leave] = ACTIONS(3383),
    [anon_sym_not] = ACTIONS(3383),
    [anon_sym_compl] = ACTIONS(3383),
    [anon_sym_DASH_DASH] = ACTIONS(3385),
    [anon_sym_PLUS_PLUS] = ACTIONS(3385),
    [anon_sym_sizeof] = ACTIONS(3383),
    [anon_sym___alignof__] = ACTIONS(3383),
    [anon_sym___alignof] = ACTIONS(3383),
    [anon_sym__alignof] = ACTIONS(3383),
    [anon_sym_alignof] = ACTIONS(3383),
    [anon_sym__Alignof] = ACTIONS(3383),
    [anon_sym_offsetof] = ACTIONS(3383),
    [anon_sym__Generic] = ACTIONS(3383),
    [anon_sym_asm] = ACTIONS(3383),
    [anon_sym___asm__] = ACTIONS(3383),
    [anon_sym___asm] = ACTIONS(3383),
    [sym_number_literal] = ACTIONS(3385),
    [anon_sym_L_SQUOTE] = ACTIONS(3385),
    [anon_sym_u_SQUOTE] = ACTIONS(3385),
    [anon_sym_U_SQUOTE] = ACTIONS(3385),
    [anon_sym_u8_SQUOTE] = ACTIONS(3385),
    [anon_sym_SQUOTE] = ACTIONS(3385),
    [anon_sym_L_DQUOTE] = ACTIONS(3385),
    [anon_sym_u_DQUOTE] = ACTIONS(3385),
    [anon_sym_U_DQUOTE] = ACTIONS(3385),
    [anon_sym_u8_DQUOTE] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(3385),
    [sym_true] = ACTIONS(3383),
    [sym_false] = ACTIONS(3383),
    [anon_sym_NULL] = ACTIONS(3383),
    [anon_sym_nullptr] = ACTIONS(3383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3383),
    [anon_sym_let] = ACTIONS(3383),
    [anon_sym_This] = ACTIONS(3383),
    [anon_sym_decltype] = ACTIONS(3383),
    [anon_sym_explicit] = ACTIONS(3383),
    [anon_sym_typename] = ACTIONS(3383),
    [anon_sym_template] = ACTIONS(3383),
    [anon_sym_operator] = ACTIONS(3383),
    [anon_sym_try] = ACTIONS(3383),
    [anon_sym_delete] = ACTIONS(3383),
    [anon_sym_throw] = ACTIONS(3383),
    [anon_sym_namespace] = ACTIONS(3383),
    [anon_sym_static_assert] = ACTIONS(3383),
    [anon_sym_concept] = ACTIONS(3383),
    [anon_sym_co_return] = ACTIONS(3383),
    [anon_sym_co_yield] = ACTIONS(3383),
    [anon_sym_R_DQUOTE] = ACTIONS(3385),
    [anon_sym_LR_DQUOTE] = ACTIONS(3385),
    [anon_sym_uR_DQUOTE] = ACTIONS(3385),
    [anon_sym_UR_DQUOTE] = ACTIONS(3385),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3385),
    [anon_sym_co_await] = ACTIONS(3383),
    [anon_sym_new] = ACTIONS(3383),
    [anon_sym_requires] = ACTIONS(3383),
    [sym_this] = ACTIONS(3383),
    [anon_sym_discard] = ACTIONS(3383),
    [anon_sym_precise] = ACTIONS(3383),
    [anon_sym_shared] = ACTIONS(3383),
    [anon_sym_groupshared] = ACTIONS(3383),
    [anon_sym_uniform] = ACTIONS(3383),
    [anon_sym_row_major] = ACTIONS(3383),
    [anon_sym_column_major] = ACTIONS(3383),
    [anon_sym_globallycoherent] = ACTIONS(3383),
    [anon_sym_centroid] = ACTIONS(3383),
    [anon_sym_noperspective] = ACTIONS(3383),
    [anon_sym_nointerpolation] = ACTIONS(3383),
    [anon_sym_sample] = ACTIONS(3383),
    [anon_sym_linear] = ACTIONS(3383),
    [anon_sym_snorm] = ACTIONS(3383),
    [anon_sym_unorm] = ACTIONS(3383),
    [anon_sym_point] = ACTIONS(3383),
    [anon_sym_line] = ACTIONS(3383),
    [anon_sym_triangleadj] = ACTIONS(3383),
    [anon_sym_lineadj] = ACTIONS(3383),
    [anon_sym_triangle] = ACTIONS(3383),
    [anon_sym_cbuffer] = ACTIONS(3383),
    [anon_sym_interface] = ACTIONS(3383),
    [anon_sym_extension] = ACTIONS(3383),
  },
  [379] = {
    [sym_identifier] = ACTIONS(3387),
    [aux_sym_preproc_include_token1] = ACTIONS(3387),
    [aux_sym_preproc_def_token1] = ACTIONS(3387),
    [aux_sym_preproc_if_token1] = ACTIONS(3387),
    [aux_sym_preproc_if_token2] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3387),
    [aux_sym_preproc_else_token1] = ACTIONS(3387),
    [aux_sym_preproc_elif_token1] = ACTIONS(3387),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3387),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3387),
    [sym_preproc_directive] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_BANG] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_STAR] = ACTIONS(3389),
    [anon_sym_AMP_AMP] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_SEMI] = ACTIONS(3389),
    [anon_sym___extension__] = ACTIONS(3387),
    [anon_sym_typedef] = ACTIONS(3387),
    [anon_sym_in] = ACTIONS(3387),
    [anon_sym_out] = ACTIONS(3387),
    [anon_sym_inout] = ACTIONS(3387),
    [anon_sym_virtual] = ACTIONS(3387),
    [anon_sym_extern] = ACTIONS(3387),
    [anon_sym___attribute__] = ACTIONS(3387),
    [anon_sym___attribute] = ACTIONS(3387),
    [anon_sym_using] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3389),
    [anon_sym___declspec] = ACTIONS(3387),
    [anon_sym___based] = ACTIONS(3387),
    [anon_sym___cdecl] = ACTIONS(3387),
    [anon_sym___clrcall] = ACTIONS(3387),
    [anon_sym___stdcall] = ACTIONS(3387),
    [anon_sym___fastcall] = ACTIONS(3387),
    [anon_sym___thiscall] = ACTIONS(3387),
    [anon_sym___vectorcall] = ACTIONS(3387),
    [anon_sym_LBRACE] = ACTIONS(3389),
    [anon_sym_signed] = ACTIONS(3387),
    [anon_sym_unsigned] = ACTIONS(3387),
    [anon_sym_long] = ACTIONS(3387),
    [anon_sym_short] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_register] = ACTIONS(3387),
    [anon_sym_inline] = ACTIONS(3387),
    [anon_sym___inline] = ACTIONS(3387),
    [anon_sym___inline__] = ACTIONS(3387),
    [anon_sym___forceinline] = ACTIONS(3387),
    [anon_sym_thread_local] = ACTIONS(3387),
    [anon_sym___thread] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_constexpr] = ACTIONS(3387),
    [anon_sym_volatile] = ACTIONS(3387),
    [anon_sym_restrict] = ACTIONS(3387),
    [anon_sym___restrict__] = ACTIONS(3387),
    [anon_sym__Atomic] = ACTIONS(3387),
    [anon_sym__Noreturn] = ACTIONS(3387),
    [anon_sym_noreturn] = ACTIONS(3387),
    [anon_sym__Nonnull] = ACTIONS(3387),
    [anon_sym_mutable] = ACTIONS(3387),
    [anon_sym_constinit] = ACTIONS(3387),
    [anon_sym_consteval] = ACTIONS(3387),
    [anon_sym_alignas] = ACTIONS(3387),
    [anon_sym__Alignas] = ACTIONS(3387),
    [sym_primitive_type] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [anon_sym_class] = ACTIONS(3387),
    [anon_sym_struct] = ACTIONS(3387),
    [anon_sym_union] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_else] = ACTIONS(3387),
    [anon_sym_switch] = ACTIONS(3387),
    [anon_sym_case] = ACTIONS(3387),
    [anon_sym_default] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_break] = ACTIONS(3387),
    [anon_sym_continue] = ACTIONS(3387),
    [anon_sym_goto] = ACTIONS(3387),
    [anon_sym___try] = ACTIONS(3387),
    [anon_sym___leave] = ACTIONS(3387),
    [anon_sym_not] = ACTIONS(3387),
    [anon_sym_compl] = ACTIONS(3387),
    [anon_sym_DASH_DASH] = ACTIONS(3389),
    [anon_sym_PLUS_PLUS] = ACTIONS(3389),
    [anon_sym_sizeof] = ACTIONS(3387),
    [anon_sym___alignof__] = ACTIONS(3387),
    [anon_sym___alignof] = ACTIONS(3387),
    [anon_sym__alignof] = ACTIONS(3387),
    [anon_sym_alignof] = ACTIONS(3387),
    [anon_sym__Alignof] = ACTIONS(3387),
    [anon_sym_offsetof] = ACTIONS(3387),
    [anon_sym__Generic] = ACTIONS(3387),
    [anon_sym_asm] = ACTIONS(3387),
    [anon_sym___asm__] = ACTIONS(3387),
    [anon_sym___asm] = ACTIONS(3387),
    [sym_number_literal] = ACTIONS(3389),
    [anon_sym_L_SQUOTE] = ACTIONS(3389),
    [anon_sym_u_SQUOTE] = ACTIONS(3389),
    [anon_sym_U_SQUOTE] = ACTIONS(3389),
    [anon_sym_u8_SQUOTE] = ACTIONS(3389),
    [anon_sym_SQUOTE] = ACTIONS(3389),
    [anon_sym_L_DQUOTE] = ACTIONS(3389),
    [anon_sym_u_DQUOTE] = ACTIONS(3389),
    [anon_sym_U_DQUOTE] = ACTIONS(3389),
    [anon_sym_u8_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE] = ACTIONS(3389),
    [sym_true] = ACTIONS(3387),
    [sym_false] = ACTIONS(3387),
    [anon_sym_NULL] = ACTIONS(3387),
    [anon_sym_nullptr] = ACTIONS(3387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_This] = ACTIONS(3387),
    [anon_sym_decltype] = ACTIONS(3387),
    [anon_sym_explicit] = ACTIONS(3387),
    [anon_sym_typename] = ACTIONS(3387),
    [anon_sym_template] = ACTIONS(3387),
    [anon_sym_operator] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_delete] = ACTIONS(3387),
    [anon_sym_throw] = ACTIONS(3387),
    [anon_sym_namespace] = ACTIONS(3387),
    [anon_sym_static_assert] = ACTIONS(3387),
    [anon_sym_concept] = ACTIONS(3387),
    [anon_sym_co_return] = ACTIONS(3387),
    [anon_sym_co_yield] = ACTIONS(3387),
    [anon_sym_R_DQUOTE] = ACTIONS(3389),
    [anon_sym_LR_DQUOTE] = ACTIONS(3389),
    [anon_sym_uR_DQUOTE] = ACTIONS(3389),
    [anon_sym_UR_DQUOTE] = ACTIONS(3389),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3389),
    [anon_sym_co_await] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_requires] = ACTIONS(3387),
    [sym_this] = ACTIONS(3387),
    [anon_sym_discard] = ACTIONS(3387),
    [anon_sym_precise] = ACTIONS(3387),
    [anon_sym_shared] = ACTIONS(3387),
    [anon_sym_groupshared] = ACTIONS(3387),
    [anon_sym_uniform] = ACTIONS(3387),
    [anon_sym_row_major] = ACTIONS(3387),
    [anon_sym_column_major] = ACTIONS(3387),
    [anon_sym_globallycoherent] = ACTIONS(3387),
    [anon_sym_centroid] = ACTIONS(3387),
    [anon_sym_noperspective] = ACTIONS(3387),
    [anon_sym_nointerpolation] = ACTIONS(3387),
    [anon_sym_sample] = ACTIONS(3387),
    [anon_sym_linear] = ACTIONS(3387),
    [anon_sym_snorm] = ACTIONS(3387),
    [anon_sym_unorm] = ACTIONS(3387),
    [anon_sym_point] = ACTIONS(3387),
    [anon_sym_line] = ACTIONS(3387),
    [anon_sym_triangleadj] = ACTIONS(3387),
    [anon_sym_lineadj] = ACTIONS(3387),
    [anon_sym_triangle] = ACTIONS(3387),
    [anon_sym_cbuffer] = ACTIONS(3387),
    [anon_sym_interface] = ACTIONS(3387),
    [anon_sym_extension] = ACTIONS(3387),
  },
  [380] = {
    [sym_identifier] = ACTIONS(3391),
    [aux_sym_preproc_include_token1] = ACTIONS(3391),
    [aux_sym_preproc_def_token1] = ACTIONS(3391),
    [aux_sym_preproc_if_token1] = ACTIONS(3391),
    [aux_sym_preproc_if_token2] = ACTIONS(3391),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3391),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3391),
    [aux_sym_preproc_else_token1] = ACTIONS(3391),
    [aux_sym_preproc_elif_token1] = ACTIONS(3391),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3391),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3391),
    [sym_preproc_directive] = ACTIONS(3391),
    [anon_sym_LPAREN2] = ACTIONS(3393),
    [anon_sym_BANG] = ACTIONS(3393),
    [anon_sym_TILDE] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_STAR] = ACTIONS(3393),
    [anon_sym_AMP_AMP] = ACTIONS(3393),
    [anon_sym_AMP] = ACTIONS(3391),
    [anon_sym_SEMI] = ACTIONS(3393),
    [anon_sym___extension__] = ACTIONS(3391),
    [anon_sym_typedef] = ACTIONS(3391),
    [anon_sym_in] = ACTIONS(3391),
    [anon_sym_out] = ACTIONS(3391),
    [anon_sym_inout] = ACTIONS(3391),
    [anon_sym_virtual] = ACTIONS(3391),
    [anon_sym_extern] = ACTIONS(3391),
    [anon_sym___attribute__] = ACTIONS(3391),
    [anon_sym___attribute] = ACTIONS(3391),
    [anon_sym_using] = ACTIONS(3391),
    [anon_sym_COLON_COLON] = ACTIONS(3393),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3393),
    [anon_sym___declspec] = ACTIONS(3391),
    [anon_sym___based] = ACTIONS(3391),
    [anon_sym___cdecl] = ACTIONS(3391),
    [anon_sym___clrcall] = ACTIONS(3391),
    [anon_sym___stdcall] = ACTIONS(3391),
    [anon_sym___fastcall] = ACTIONS(3391),
    [anon_sym___thiscall] = ACTIONS(3391),
    [anon_sym___vectorcall] = ACTIONS(3391),
    [anon_sym_LBRACE] = ACTIONS(3393),
    [anon_sym_signed] = ACTIONS(3391),
    [anon_sym_unsigned] = ACTIONS(3391),
    [anon_sym_long] = ACTIONS(3391),
    [anon_sym_short] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(3391),
    [anon_sym_static] = ACTIONS(3391),
    [anon_sym_register] = ACTIONS(3391),
    [anon_sym_inline] = ACTIONS(3391),
    [anon_sym___inline] = ACTIONS(3391),
    [anon_sym___inline__] = ACTIONS(3391),
    [anon_sym___forceinline] = ACTIONS(3391),
    [anon_sym_thread_local] = ACTIONS(3391),
    [anon_sym___thread] = ACTIONS(3391),
    [anon_sym_const] = ACTIONS(3391),
    [anon_sym_constexpr] = ACTIONS(3391),
    [anon_sym_volatile] = ACTIONS(3391),
    [anon_sym_restrict] = ACTIONS(3391),
    [anon_sym___restrict__] = ACTIONS(3391),
    [anon_sym__Atomic] = ACTIONS(3391),
    [anon_sym__Noreturn] = ACTIONS(3391),
    [anon_sym_noreturn] = ACTIONS(3391),
    [anon_sym__Nonnull] = ACTIONS(3391),
    [anon_sym_mutable] = ACTIONS(3391),
    [anon_sym_constinit] = ACTIONS(3391),
    [anon_sym_consteval] = ACTIONS(3391),
    [anon_sym_alignas] = ACTIONS(3391),
    [anon_sym__Alignas] = ACTIONS(3391),
    [sym_primitive_type] = ACTIONS(3391),
    [anon_sym_enum] = ACTIONS(3391),
    [anon_sym_class] = ACTIONS(3391),
    [anon_sym_struct] = ACTIONS(3391),
    [anon_sym_union] = ACTIONS(3391),
    [anon_sym_if] = ACTIONS(3391),
    [anon_sym_else] = ACTIONS(3391),
    [anon_sym_switch] = ACTIONS(3391),
    [anon_sym_case] = ACTIONS(3391),
    [anon_sym_default] = ACTIONS(3391),
    [anon_sym_while] = ACTIONS(3391),
    [anon_sym_do] = ACTIONS(3391),
    [anon_sym_for] = ACTIONS(3391),
    [anon_sym_return] = ACTIONS(3391),
    [anon_sym_break] = ACTIONS(3391),
    [anon_sym_continue] = ACTIONS(3391),
    [anon_sym_goto] = ACTIONS(3391),
    [anon_sym___try] = ACTIONS(3391),
    [anon_sym___leave] = ACTIONS(3391),
    [anon_sym_not] = ACTIONS(3391),
    [anon_sym_compl] = ACTIONS(3391),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_sizeof] = ACTIONS(3391),
    [anon_sym___alignof__] = ACTIONS(3391),
    [anon_sym___alignof] = ACTIONS(3391),
    [anon_sym__alignof] = ACTIONS(3391),
    [anon_sym_alignof] = ACTIONS(3391),
    [anon_sym__Alignof] = ACTIONS(3391),
    [anon_sym_offsetof] = ACTIONS(3391),
    [anon_sym__Generic] = ACTIONS(3391),
    [anon_sym_asm] = ACTIONS(3391),
    [anon_sym___asm__] = ACTIONS(3391),
    [anon_sym___asm] = ACTIONS(3391),
    [sym_number_literal] = ACTIONS(3393),
    [anon_sym_L_SQUOTE] = ACTIONS(3393),
    [anon_sym_u_SQUOTE] = ACTIONS(3393),
    [anon_sym_U_SQUOTE] = ACTIONS(3393),
    [anon_sym_u8_SQUOTE] = ACTIONS(3393),
    [anon_sym_SQUOTE] = ACTIONS(3393),
    [anon_sym_L_DQUOTE] = ACTIONS(3393),
    [anon_sym_u_DQUOTE] = ACTIONS(3393),
    [anon_sym_U_DQUOTE] = ACTIONS(3393),
    [anon_sym_u8_DQUOTE] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3393),
    [sym_true] = ACTIONS(3391),
    [sym_false] = ACTIONS(3391),
    [anon_sym_NULL] = ACTIONS(3391),
    [anon_sym_nullptr] = ACTIONS(3391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3391),
    [anon_sym_let] = ACTIONS(3391),
    [anon_sym_This] = ACTIONS(3391),
    [anon_sym_decltype] = ACTIONS(3391),
    [anon_sym_explicit] = ACTIONS(3391),
    [anon_sym_typename] = ACTIONS(3391),
    [anon_sym_template] = ACTIONS(3391),
    [anon_sym_operator] = ACTIONS(3391),
    [anon_sym_try] = ACTIONS(3391),
    [anon_sym_delete] = ACTIONS(3391),
    [anon_sym_throw] = ACTIONS(3391),
    [anon_sym_namespace] = ACTIONS(3391),
    [anon_sym_static_assert] = ACTIONS(3391),
    [anon_sym_concept] = ACTIONS(3391),
    [anon_sym_co_return] = ACTIONS(3391),
    [anon_sym_co_yield] = ACTIONS(3391),
    [anon_sym_R_DQUOTE] = ACTIONS(3393),
    [anon_sym_LR_DQUOTE] = ACTIONS(3393),
    [anon_sym_uR_DQUOTE] = ACTIONS(3393),
    [anon_sym_UR_DQUOTE] = ACTIONS(3393),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3393),
    [anon_sym_co_await] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(3391),
    [anon_sym_requires] = ACTIONS(3391),
    [sym_this] = ACTIONS(3391),
    [anon_sym_discard] = ACTIONS(3391),
    [anon_sym_precise] = ACTIONS(3391),
    [anon_sym_shared] = ACTIONS(3391),
    [anon_sym_groupshared] = ACTIONS(3391),
    [anon_sym_uniform] = ACTIONS(3391),
    [anon_sym_row_major] = ACTIONS(3391),
    [anon_sym_column_major] = ACTIONS(3391),
    [anon_sym_globallycoherent] = ACTIONS(3391),
    [anon_sym_centroid] = ACTIONS(3391),
    [anon_sym_noperspective] = ACTIONS(3391),
    [anon_sym_nointerpolation] = ACTIONS(3391),
    [anon_sym_sample] = ACTIONS(3391),
    [anon_sym_linear] = ACTIONS(3391),
    [anon_sym_snorm] = ACTIONS(3391),
    [anon_sym_unorm] = ACTIONS(3391),
    [anon_sym_point] = ACTIONS(3391),
    [anon_sym_line] = ACTIONS(3391),
    [anon_sym_triangleadj] = ACTIONS(3391),
    [anon_sym_lineadj] = ACTIONS(3391),
    [anon_sym_triangle] = ACTIONS(3391),
    [anon_sym_cbuffer] = ACTIONS(3391),
    [anon_sym_interface] = ACTIONS(3391),
    [anon_sym_extension] = ACTIONS(3391),
  },
  [381] = {
    [sym_identifier] = ACTIONS(3395),
    [aux_sym_preproc_include_token1] = ACTIONS(3395),
    [aux_sym_preproc_def_token1] = ACTIONS(3395),
    [aux_sym_preproc_if_token1] = ACTIONS(3395),
    [aux_sym_preproc_if_token2] = ACTIONS(3395),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3395),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3395),
    [aux_sym_preproc_else_token1] = ACTIONS(3395),
    [aux_sym_preproc_elif_token1] = ACTIONS(3395),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3395),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3395),
    [sym_preproc_directive] = ACTIONS(3395),
    [anon_sym_LPAREN2] = ACTIONS(3397),
    [anon_sym_BANG] = ACTIONS(3397),
    [anon_sym_TILDE] = ACTIONS(3397),
    [anon_sym_DASH] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3395),
    [anon_sym_STAR] = ACTIONS(3397),
    [anon_sym_AMP_AMP] = ACTIONS(3397),
    [anon_sym_AMP] = ACTIONS(3395),
    [anon_sym_SEMI] = ACTIONS(3397),
    [anon_sym___extension__] = ACTIONS(3395),
    [anon_sym_typedef] = ACTIONS(3395),
    [anon_sym_in] = ACTIONS(3395),
    [anon_sym_out] = ACTIONS(3395),
    [anon_sym_inout] = ACTIONS(3395),
    [anon_sym_virtual] = ACTIONS(3395),
    [anon_sym_extern] = ACTIONS(3395),
    [anon_sym___attribute__] = ACTIONS(3395),
    [anon_sym___attribute] = ACTIONS(3395),
    [anon_sym_using] = ACTIONS(3395),
    [anon_sym_COLON_COLON] = ACTIONS(3397),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3397),
    [anon_sym___declspec] = ACTIONS(3395),
    [anon_sym___based] = ACTIONS(3395),
    [anon_sym___cdecl] = ACTIONS(3395),
    [anon_sym___clrcall] = ACTIONS(3395),
    [anon_sym___stdcall] = ACTIONS(3395),
    [anon_sym___fastcall] = ACTIONS(3395),
    [anon_sym___thiscall] = ACTIONS(3395),
    [anon_sym___vectorcall] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3397),
    [anon_sym_signed] = ACTIONS(3395),
    [anon_sym_unsigned] = ACTIONS(3395),
    [anon_sym_long] = ACTIONS(3395),
    [anon_sym_short] = ACTIONS(3395),
    [anon_sym_LBRACK] = ACTIONS(3395),
    [anon_sym_static] = ACTIONS(3395),
    [anon_sym_register] = ACTIONS(3395),
    [anon_sym_inline] = ACTIONS(3395),
    [anon_sym___inline] = ACTIONS(3395),
    [anon_sym___inline__] = ACTIONS(3395),
    [anon_sym___forceinline] = ACTIONS(3395),
    [anon_sym_thread_local] = ACTIONS(3395),
    [anon_sym___thread] = ACTIONS(3395),
    [anon_sym_const] = ACTIONS(3395),
    [anon_sym_constexpr] = ACTIONS(3395),
    [anon_sym_volatile] = ACTIONS(3395),
    [anon_sym_restrict] = ACTIONS(3395),
    [anon_sym___restrict__] = ACTIONS(3395),
    [anon_sym__Atomic] = ACTIONS(3395),
    [anon_sym__Noreturn] = ACTIONS(3395),
    [anon_sym_noreturn] = ACTIONS(3395),
    [anon_sym__Nonnull] = ACTIONS(3395),
    [anon_sym_mutable] = ACTIONS(3395),
    [anon_sym_constinit] = ACTIONS(3395),
    [anon_sym_consteval] = ACTIONS(3395),
    [anon_sym_alignas] = ACTIONS(3395),
    [anon_sym__Alignas] = ACTIONS(3395),
    [sym_primitive_type] = ACTIONS(3395),
    [anon_sym_enum] = ACTIONS(3395),
    [anon_sym_class] = ACTIONS(3395),
    [anon_sym_struct] = ACTIONS(3395),
    [anon_sym_union] = ACTIONS(3395),
    [anon_sym_if] = ACTIONS(3395),
    [anon_sym_else] = ACTIONS(3395),
    [anon_sym_switch] = ACTIONS(3395),
    [anon_sym_case] = ACTIONS(3395),
    [anon_sym_default] = ACTIONS(3395),
    [anon_sym_while] = ACTIONS(3395),
    [anon_sym_do] = ACTIONS(3395),
    [anon_sym_for] = ACTIONS(3395),
    [anon_sym_return] = ACTIONS(3395),
    [anon_sym_break] = ACTIONS(3395),
    [anon_sym_continue] = ACTIONS(3395),
    [anon_sym_goto] = ACTIONS(3395),
    [anon_sym___try] = ACTIONS(3395),
    [anon_sym___leave] = ACTIONS(3395),
    [anon_sym_not] = ACTIONS(3395),
    [anon_sym_compl] = ACTIONS(3395),
    [anon_sym_DASH_DASH] = ACTIONS(3397),
    [anon_sym_PLUS_PLUS] = ACTIONS(3397),
    [anon_sym_sizeof] = ACTIONS(3395),
    [anon_sym___alignof__] = ACTIONS(3395),
    [anon_sym___alignof] = ACTIONS(3395),
    [anon_sym__alignof] = ACTIONS(3395),
    [anon_sym_alignof] = ACTIONS(3395),
    [anon_sym__Alignof] = ACTIONS(3395),
    [anon_sym_offsetof] = ACTIONS(3395),
    [anon_sym__Generic] = ACTIONS(3395),
    [anon_sym_asm] = ACTIONS(3395),
    [anon_sym___asm__] = ACTIONS(3395),
    [anon_sym___asm] = ACTIONS(3395),
    [sym_number_literal] = ACTIONS(3397),
    [anon_sym_L_SQUOTE] = ACTIONS(3397),
    [anon_sym_u_SQUOTE] = ACTIONS(3397),
    [anon_sym_U_SQUOTE] = ACTIONS(3397),
    [anon_sym_u8_SQUOTE] = ACTIONS(3397),
    [anon_sym_SQUOTE] = ACTIONS(3397),
    [anon_sym_L_DQUOTE] = ACTIONS(3397),
    [anon_sym_u_DQUOTE] = ACTIONS(3397),
    [anon_sym_U_DQUOTE] = ACTIONS(3397),
    [anon_sym_u8_DQUOTE] = ACTIONS(3397),
    [anon_sym_DQUOTE] = ACTIONS(3397),
    [sym_true] = ACTIONS(3395),
    [sym_false] = ACTIONS(3395),
    [anon_sym_NULL] = ACTIONS(3395),
    [anon_sym_nullptr] = ACTIONS(3395),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3395),
    [anon_sym_let] = ACTIONS(3395),
    [anon_sym_This] = ACTIONS(3395),
    [anon_sym_decltype] = ACTIONS(3395),
    [anon_sym_explicit] = ACTIONS(3395),
    [anon_sym_typename] = ACTIONS(3395),
    [anon_sym_template] = ACTIONS(3395),
    [anon_sym_operator] = ACTIONS(3395),
    [anon_sym_try] = ACTIONS(3395),
    [anon_sym_delete] = ACTIONS(3395),
    [anon_sym_throw] = ACTIONS(3395),
    [anon_sym_namespace] = ACTIONS(3395),
    [anon_sym_static_assert] = ACTIONS(3395),
    [anon_sym_concept] = ACTIONS(3395),
    [anon_sym_co_return] = ACTIONS(3395),
    [anon_sym_co_yield] = ACTIONS(3395),
    [anon_sym_R_DQUOTE] = ACTIONS(3397),
    [anon_sym_LR_DQUOTE] = ACTIONS(3397),
    [anon_sym_uR_DQUOTE] = ACTIONS(3397),
    [anon_sym_UR_DQUOTE] = ACTIONS(3397),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3397),
    [anon_sym_co_await] = ACTIONS(3395),
    [anon_sym_new] = ACTIONS(3395),
    [anon_sym_requires] = ACTIONS(3395),
    [sym_this] = ACTIONS(3395),
    [anon_sym_discard] = ACTIONS(3395),
    [anon_sym_precise] = ACTIONS(3395),
    [anon_sym_shared] = ACTIONS(3395),
    [anon_sym_groupshared] = ACTIONS(3395),
    [anon_sym_uniform] = ACTIONS(3395),
    [anon_sym_row_major] = ACTIONS(3395),
    [anon_sym_column_major] = ACTIONS(3395),
    [anon_sym_globallycoherent] = ACTIONS(3395),
    [anon_sym_centroid] = ACTIONS(3395),
    [anon_sym_noperspective] = ACTIONS(3395),
    [anon_sym_nointerpolation] = ACTIONS(3395),
    [anon_sym_sample] = ACTIONS(3395),
    [anon_sym_linear] = ACTIONS(3395),
    [anon_sym_snorm] = ACTIONS(3395),
    [anon_sym_unorm] = ACTIONS(3395),
    [anon_sym_point] = ACTIONS(3395),
    [anon_sym_line] = ACTIONS(3395),
    [anon_sym_triangleadj] = ACTIONS(3395),
    [anon_sym_lineadj] = ACTIONS(3395),
    [anon_sym_triangle] = ACTIONS(3395),
    [anon_sym_cbuffer] = ACTIONS(3395),
    [anon_sym_interface] = ACTIONS(3395),
    [anon_sym_extension] = ACTIONS(3395),
  },
  [382] = {
    [sym_identifier] = ACTIONS(3399),
    [aux_sym_preproc_include_token1] = ACTIONS(3399),
    [aux_sym_preproc_def_token1] = ACTIONS(3399),
    [aux_sym_preproc_if_token1] = ACTIONS(3399),
    [aux_sym_preproc_if_token2] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3399),
    [aux_sym_preproc_else_token1] = ACTIONS(3399),
    [aux_sym_preproc_elif_token1] = ACTIONS(3399),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3399),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3399),
    [sym_preproc_directive] = ACTIONS(3399),
    [anon_sym_LPAREN2] = ACTIONS(3401),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_STAR] = ACTIONS(3401),
    [anon_sym_AMP_AMP] = ACTIONS(3401),
    [anon_sym_AMP] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym___extension__] = ACTIONS(3399),
    [anon_sym_typedef] = ACTIONS(3399),
    [anon_sym_in] = ACTIONS(3399),
    [anon_sym_out] = ACTIONS(3399),
    [anon_sym_inout] = ACTIONS(3399),
    [anon_sym_virtual] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym___attribute__] = ACTIONS(3399),
    [anon_sym___attribute] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_COLON_COLON] = ACTIONS(3401),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3401),
    [anon_sym___declspec] = ACTIONS(3399),
    [anon_sym___based] = ACTIONS(3399),
    [anon_sym___cdecl] = ACTIONS(3399),
    [anon_sym___clrcall] = ACTIONS(3399),
    [anon_sym___stdcall] = ACTIONS(3399),
    [anon_sym___fastcall] = ACTIONS(3399),
    [anon_sym___thiscall] = ACTIONS(3399),
    [anon_sym___vectorcall] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_signed] = ACTIONS(3399),
    [anon_sym_unsigned] = ACTIONS(3399),
    [anon_sym_long] = ACTIONS(3399),
    [anon_sym_short] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_register] = ACTIONS(3399),
    [anon_sym_inline] = ACTIONS(3399),
    [anon_sym___inline] = ACTIONS(3399),
    [anon_sym___inline__] = ACTIONS(3399),
    [anon_sym___forceinline] = ACTIONS(3399),
    [anon_sym_thread_local] = ACTIONS(3399),
    [anon_sym___thread] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_constexpr] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym_restrict] = ACTIONS(3399),
    [anon_sym___restrict__] = ACTIONS(3399),
    [anon_sym__Atomic] = ACTIONS(3399),
    [anon_sym__Noreturn] = ACTIONS(3399),
    [anon_sym_noreturn] = ACTIONS(3399),
    [anon_sym__Nonnull] = ACTIONS(3399),
    [anon_sym_mutable] = ACTIONS(3399),
    [anon_sym_constinit] = ACTIONS(3399),
    [anon_sym_consteval] = ACTIONS(3399),
    [anon_sym_alignas] = ACTIONS(3399),
    [anon_sym__Alignas] = ACTIONS(3399),
    [sym_primitive_type] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_union] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_else] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_case] = ACTIONS(3399),
    [anon_sym_default] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_goto] = ACTIONS(3399),
    [anon_sym___try] = ACTIONS(3399),
    [anon_sym___leave] = ACTIONS(3399),
    [anon_sym_not] = ACTIONS(3399),
    [anon_sym_compl] = ACTIONS(3399),
    [anon_sym_DASH_DASH] = ACTIONS(3401),
    [anon_sym_PLUS_PLUS] = ACTIONS(3401),
    [anon_sym_sizeof] = ACTIONS(3399),
    [anon_sym___alignof__] = ACTIONS(3399),
    [anon_sym___alignof] = ACTIONS(3399),
    [anon_sym__alignof] = ACTIONS(3399),
    [anon_sym_alignof] = ACTIONS(3399),
    [anon_sym__Alignof] = ACTIONS(3399),
    [anon_sym_offsetof] = ACTIONS(3399),
    [anon_sym__Generic] = ACTIONS(3399),
    [anon_sym_asm] = ACTIONS(3399),
    [anon_sym___asm__] = ACTIONS(3399),
    [anon_sym___asm] = ACTIONS(3399),
    [sym_number_literal] = ACTIONS(3401),
    [anon_sym_L_SQUOTE] = ACTIONS(3401),
    [anon_sym_u_SQUOTE] = ACTIONS(3401),
    [anon_sym_U_SQUOTE] = ACTIONS(3401),
    [anon_sym_u8_SQUOTE] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(3401),
    [anon_sym_L_DQUOTE] = ACTIONS(3401),
    [anon_sym_u_DQUOTE] = ACTIONS(3401),
    [anon_sym_U_DQUOTE] = ACTIONS(3401),
    [anon_sym_u8_DQUOTE] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [sym_true] = ACTIONS(3399),
    [sym_false] = ACTIONS(3399),
    [anon_sym_NULL] = ACTIONS(3399),
    [anon_sym_nullptr] = ACTIONS(3399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_This] = ACTIONS(3399),
    [anon_sym_decltype] = ACTIONS(3399),
    [anon_sym_explicit] = ACTIONS(3399),
    [anon_sym_typename] = ACTIONS(3399),
    [anon_sym_template] = ACTIONS(3399),
    [anon_sym_operator] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_delete] = ACTIONS(3399),
    [anon_sym_throw] = ACTIONS(3399),
    [anon_sym_namespace] = ACTIONS(3399),
    [anon_sym_static_assert] = ACTIONS(3399),
    [anon_sym_concept] = ACTIONS(3399),
    [anon_sym_co_return] = ACTIONS(3399),
    [anon_sym_co_yield] = ACTIONS(3399),
    [anon_sym_R_DQUOTE] = ACTIONS(3401),
    [anon_sym_LR_DQUOTE] = ACTIONS(3401),
    [anon_sym_uR_DQUOTE] = ACTIONS(3401),
    [anon_sym_UR_DQUOTE] = ACTIONS(3401),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3401),
    [anon_sym_co_await] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_requires] = ACTIONS(3399),
    [sym_this] = ACTIONS(3399),
    [anon_sym_discard] = ACTIONS(3399),
    [anon_sym_precise] = ACTIONS(3399),
    [anon_sym_shared] = ACTIONS(3399),
    [anon_sym_groupshared] = ACTIONS(3399),
    [anon_sym_uniform] = ACTIONS(3399),
    [anon_sym_row_major] = ACTIONS(3399),
    [anon_sym_column_major] = ACTIONS(3399),
    [anon_sym_globallycoherent] = ACTIONS(3399),
    [anon_sym_centroid] = ACTIONS(3399),
    [anon_sym_noperspective] = ACTIONS(3399),
    [anon_sym_nointerpolation] = ACTIONS(3399),
    [anon_sym_sample] = ACTIONS(3399),
    [anon_sym_linear] = ACTIONS(3399),
    [anon_sym_snorm] = ACTIONS(3399),
    [anon_sym_unorm] = ACTIONS(3399),
    [anon_sym_point] = ACTIONS(3399),
    [anon_sym_line] = ACTIONS(3399),
    [anon_sym_triangleadj] = ACTIONS(3399),
    [anon_sym_lineadj] = ACTIONS(3399),
    [anon_sym_triangle] = ACTIONS(3399),
    [anon_sym_cbuffer] = ACTIONS(3399),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_extension] = ACTIONS(3399),
  },
  [383] = {
    [sym_identifier] = ACTIONS(3399),
    [aux_sym_preproc_include_token1] = ACTIONS(3399),
    [aux_sym_preproc_def_token1] = ACTIONS(3399),
    [aux_sym_preproc_if_token1] = ACTIONS(3399),
    [aux_sym_preproc_if_token2] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3399),
    [aux_sym_preproc_else_token1] = ACTIONS(3399),
    [aux_sym_preproc_elif_token1] = ACTIONS(3399),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3399),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3399),
    [sym_preproc_directive] = ACTIONS(3399),
    [anon_sym_LPAREN2] = ACTIONS(3401),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_STAR] = ACTIONS(3401),
    [anon_sym_AMP_AMP] = ACTIONS(3401),
    [anon_sym_AMP] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym___extension__] = ACTIONS(3399),
    [anon_sym_typedef] = ACTIONS(3399),
    [anon_sym_in] = ACTIONS(3399),
    [anon_sym_out] = ACTIONS(3399),
    [anon_sym_inout] = ACTIONS(3399),
    [anon_sym_virtual] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym___attribute__] = ACTIONS(3399),
    [anon_sym___attribute] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_COLON_COLON] = ACTIONS(3401),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3401),
    [anon_sym___declspec] = ACTIONS(3399),
    [anon_sym___based] = ACTIONS(3399),
    [anon_sym___cdecl] = ACTIONS(3399),
    [anon_sym___clrcall] = ACTIONS(3399),
    [anon_sym___stdcall] = ACTIONS(3399),
    [anon_sym___fastcall] = ACTIONS(3399),
    [anon_sym___thiscall] = ACTIONS(3399),
    [anon_sym___vectorcall] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_signed] = ACTIONS(3399),
    [anon_sym_unsigned] = ACTIONS(3399),
    [anon_sym_long] = ACTIONS(3399),
    [anon_sym_short] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_register] = ACTIONS(3399),
    [anon_sym_inline] = ACTIONS(3399),
    [anon_sym___inline] = ACTIONS(3399),
    [anon_sym___inline__] = ACTIONS(3399),
    [anon_sym___forceinline] = ACTIONS(3399),
    [anon_sym_thread_local] = ACTIONS(3399),
    [anon_sym___thread] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_constexpr] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym_restrict] = ACTIONS(3399),
    [anon_sym___restrict__] = ACTIONS(3399),
    [anon_sym__Atomic] = ACTIONS(3399),
    [anon_sym__Noreturn] = ACTIONS(3399),
    [anon_sym_noreturn] = ACTIONS(3399),
    [anon_sym__Nonnull] = ACTIONS(3399),
    [anon_sym_mutable] = ACTIONS(3399),
    [anon_sym_constinit] = ACTIONS(3399),
    [anon_sym_consteval] = ACTIONS(3399),
    [anon_sym_alignas] = ACTIONS(3399),
    [anon_sym__Alignas] = ACTIONS(3399),
    [sym_primitive_type] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_union] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_else] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_case] = ACTIONS(3399),
    [anon_sym_default] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_goto] = ACTIONS(3399),
    [anon_sym___try] = ACTIONS(3399),
    [anon_sym___leave] = ACTIONS(3399),
    [anon_sym_not] = ACTIONS(3399),
    [anon_sym_compl] = ACTIONS(3399),
    [anon_sym_DASH_DASH] = ACTIONS(3401),
    [anon_sym_PLUS_PLUS] = ACTIONS(3401),
    [anon_sym_sizeof] = ACTIONS(3399),
    [anon_sym___alignof__] = ACTIONS(3399),
    [anon_sym___alignof] = ACTIONS(3399),
    [anon_sym__alignof] = ACTIONS(3399),
    [anon_sym_alignof] = ACTIONS(3399),
    [anon_sym__Alignof] = ACTIONS(3399),
    [anon_sym_offsetof] = ACTIONS(3399),
    [anon_sym__Generic] = ACTIONS(3399),
    [anon_sym_asm] = ACTIONS(3399),
    [anon_sym___asm__] = ACTIONS(3399),
    [anon_sym___asm] = ACTIONS(3399),
    [sym_number_literal] = ACTIONS(3401),
    [anon_sym_L_SQUOTE] = ACTIONS(3401),
    [anon_sym_u_SQUOTE] = ACTIONS(3401),
    [anon_sym_U_SQUOTE] = ACTIONS(3401),
    [anon_sym_u8_SQUOTE] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(3401),
    [anon_sym_L_DQUOTE] = ACTIONS(3401),
    [anon_sym_u_DQUOTE] = ACTIONS(3401),
    [anon_sym_U_DQUOTE] = ACTIONS(3401),
    [anon_sym_u8_DQUOTE] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [sym_true] = ACTIONS(3399),
    [sym_false] = ACTIONS(3399),
    [anon_sym_NULL] = ACTIONS(3399),
    [anon_sym_nullptr] = ACTIONS(3399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_This] = ACTIONS(3399),
    [anon_sym_decltype] = ACTIONS(3399),
    [anon_sym_explicit] = ACTIONS(3399),
    [anon_sym_typename] = ACTIONS(3399),
    [anon_sym_template] = ACTIONS(3399),
    [anon_sym_operator] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_delete] = ACTIONS(3399),
    [anon_sym_throw] = ACTIONS(3399),
    [anon_sym_namespace] = ACTIONS(3399),
    [anon_sym_static_assert] = ACTIONS(3399),
    [anon_sym_concept] = ACTIONS(3399),
    [anon_sym_co_return] = ACTIONS(3399),
    [anon_sym_co_yield] = ACTIONS(3399),
    [anon_sym_R_DQUOTE] = ACTIONS(3401),
    [anon_sym_LR_DQUOTE] = ACTIONS(3401),
    [anon_sym_uR_DQUOTE] = ACTIONS(3401),
    [anon_sym_UR_DQUOTE] = ACTIONS(3401),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3401),
    [anon_sym_co_await] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_requires] = ACTIONS(3399),
    [sym_this] = ACTIONS(3399),
    [anon_sym_discard] = ACTIONS(3399),
    [anon_sym_precise] = ACTIONS(3399),
    [anon_sym_shared] = ACTIONS(3399),
    [anon_sym_groupshared] = ACTIONS(3399),
    [anon_sym_uniform] = ACTIONS(3399),
    [anon_sym_row_major] = ACTIONS(3399),
    [anon_sym_column_major] = ACTIONS(3399),
    [anon_sym_globallycoherent] = ACTIONS(3399),
    [anon_sym_centroid] = ACTIONS(3399),
    [anon_sym_noperspective] = ACTIONS(3399),
    [anon_sym_nointerpolation] = ACTIONS(3399),
    [anon_sym_sample] = ACTIONS(3399),
    [anon_sym_linear] = ACTIONS(3399),
    [anon_sym_snorm] = ACTIONS(3399),
    [anon_sym_unorm] = ACTIONS(3399),
    [anon_sym_point] = ACTIONS(3399),
    [anon_sym_line] = ACTIONS(3399),
    [anon_sym_triangleadj] = ACTIONS(3399),
    [anon_sym_lineadj] = ACTIONS(3399),
    [anon_sym_triangle] = ACTIONS(3399),
    [anon_sym_cbuffer] = ACTIONS(3399),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_extension] = ACTIONS(3399),
  },
  [384] = {
    [sym_identifier] = ACTIONS(3403),
    [aux_sym_preproc_include_token1] = ACTIONS(3403),
    [aux_sym_preproc_def_token1] = ACTIONS(3403),
    [aux_sym_preproc_if_token1] = ACTIONS(3403),
    [aux_sym_preproc_if_token2] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3403),
    [aux_sym_preproc_else_token1] = ACTIONS(3403),
    [aux_sym_preproc_elif_token1] = ACTIONS(3403),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3403),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3403),
    [sym_preproc_directive] = ACTIONS(3403),
    [anon_sym_LPAREN2] = ACTIONS(3405),
    [anon_sym_BANG] = ACTIONS(3405),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_DASH] = ACTIONS(3403),
    [anon_sym_PLUS] = ACTIONS(3403),
    [anon_sym_STAR] = ACTIONS(3405),
    [anon_sym_AMP_AMP] = ACTIONS(3405),
    [anon_sym_AMP] = ACTIONS(3403),
    [anon_sym_SEMI] = ACTIONS(3405),
    [anon_sym___extension__] = ACTIONS(3403),
    [anon_sym_typedef] = ACTIONS(3403),
    [anon_sym_in] = ACTIONS(3403),
    [anon_sym_out] = ACTIONS(3403),
    [anon_sym_inout] = ACTIONS(3403),
    [anon_sym_virtual] = ACTIONS(3403),
    [anon_sym_extern] = ACTIONS(3403),
    [anon_sym___attribute__] = ACTIONS(3403),
    [anon_sym___attribute] = ACTIONS(3403),
    [anon_sym_using] = ACTIONS(3403),
    [anon_sym_COLON_COLON] = ACTIONS(3405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3405),
    [anon_sym___declspec] = ACTIONS(3403),
    [anon_sym___based] = ACTIONS(3403),
    [anon_sym___cdecl] = ACTIONS(3403),
    [anon_sym___clrcall] = ACTIONS(3403),
    [anon_sym___stdcall] = ACTIONS(3403),
    [anon_sym___fastcall] = ACTIONS(3403),
    [anon_sym___thiscall] = ACTIONS(3403),
    [anon_sym___vectorcall] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3405),
    [anon_sym_signed] = ACTIONS(3403),
    [anon_sym_unsigned] = ACTIONS(3403),
    [anon_sym_long] = ACTIONS(3403),
    [anon_sym_short] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3403),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_register] = ACTIONS(3403),
    [anon_sym_inline] = ACTIONS(3403),
    [anon_sym___inline] = ACTIONS(3403),
    [anon_sym___inline__] = ACTIONS(3403),
    [anon_sym___forceinline] = ACTIONS(3403),
    [anon_sym_thread_local] = ACTIONS(3403),
    [anon_sym___thread] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_constexpr] = ACTIONS(3403),
    [anon_sym_volatile] = ACTIONS(3403),
    [anon_sym_restrict] = ACTIONS(3403),
    [anon_sym___restrict__] = ACTIONS(3403),
    [anon_sym__Atomic] = ACTIONS(3403),
    [anon_sym__Noreturn] = ACTIONS(3403),
    [anon_sym_noreturn] = ACTIONS(3403),
    [anon_sym__Nonnull] = ACTIONS(3403),
    [anon_sym_mutable] = ACTIONS(3403),
    [anon_sym_constinit] = ACTIONS(3403),
    [anon_sym_consteval] = ACTIONS(3403),
    [anon_sym_alignas] = ACTIONS(3403),
    [anon_sym__Alignas] = ACTIONS(3403),
    [sym_primitive_type] = ACTIONS(3403),
    [anon_sym_enum] = ACTIONS(3403),
    [anon_sym_class] = ACTIONS(3403),
    [anon_sym_struct] = ACTIONS(3403),
    [anon_sym_union] = ACTIONS(3403),
    [anon_sym_if] = ACTIONS(3403),
    [anon_sym_else] = ACTIONS(3403),
    [anon_sym_switch] = ACTIONS(3403),
    [anon_sym_case] = ACTIONS(3403),
    [anon_sym_default] = ACTIONS(3403),
    [anon_sym_while] = ACTIONS(3403),
    [anon_sym_do] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3403),
    [anon_sym_return] = ACTIONS(3403),
    [anon_sym_break] = ACTIONS(3403),
    [anon_sym_continue] = ACTIONS(3403),
    [anon_sym_goto] = ACTIONS(3403),
    [anon_sym___try] = ACTIONS(3403),
    [anon_sym___leave] = ACTIONS(3403),
    [anon_sym_not] = ACTIONS(3403),
    [anon_sym_compl] = ACTIONS(3403),
    [anon_sym_DASH_DASH] = ACTIONS(3405),
    [anon_sym_PLUS_PLUS] = ACTIONS(3405),
    [anon_sym_sizeof] = ACTIONS(3403),
    [anon_sym___alignof__] = ACTIONS(3403),
    [anon_sym___alignof] = ACTIONS(3403),
    [anon_sym__alignof] = ACTIONS(3403),
    [anon_sym_alignof] = ACTIONS(3403),
    [anon_sym__Alignof] = ACTIONS(3403),
    [anon_sym_offsetof] = ACTIONS(3403),
    [anon_sym__Generic] = ACTIONS(3403),
    [anon_sym_asm] = ACTIONS(3403),
    [anon_sym___asm__] = ACTIONS(3403),
    [anon_sym___asm] = ACTIONS(3403),
    [sym_number_literal] = ACTIONS(3405),
    [anon_sym_L_SQUOTE] = ACTIONS(3405),
    [anon_sym_u_SQUOTE] = ACTIONS(3405),
    [anon_sym_U_SQUOTE] = ACTIONS(3405),
    [anon_sym_u8_SQUOTE] = ACTIONS(3405),
    [anon_sym_SQUOTE] = ACTIONS(3405),
    [anon_sym_L_DQUOTE] = ACTIONS(3405),
    [anon_sym_u_DQUOTE] = ACTIONS(3405),
    [anon_sym_U_DQUOTE] = ACTIONS(3405),
    [anon_sym_u8_DQUOTE] = ACTIONS(3405),
    [anon_sym_DQUOTE] = ACTIONS(3405),
    [sym_true] = ACTIONS(3403),
    [sym_false] = ACTIONS(3403),
    [anon_sym_NULL] = ACTIONS(3403),
    [anon_sym_nullptr] = ACTIONS(3403),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3403),
    [anon_sym_let] = ACTIONS(3403),
    [anon_sym_This] = ACTIONS(3403),
    [anon_sym_decltype] = ACTIONS(3403),
    [anon_sym_explicit] = ACTIONS(3403),
    [anon_sym_typename] = ACTIONS(3403),
    [anon_sym_template] = ACTIONS(3403),
    [anon_sym_operator] = ACTIONS(3403),
    [anon_sym_try] = ACTIONS(3403),
    [anon_sym_delete] = ACTIONS(3403),
    [anon_sym_throw] = ACTIONS(3403),
    [anon_sym_namespace] = ACTIONS(3403),
    [anon_sym_static_assert] = ACTIONS(3403),
    [anon_sym_concept] = ACTIONS(3403),
    [anon_sym_co_return] = ACTIONS(3403),
    [anon_sym_co_yield] = ACTIONS(3403),
    [anon_sym_R_DQUOTE] = ACTIONS(3405),
    [anon_sym_LR_DQUOTE] = ACTIONS(3405),
    [anon_sym_uR_DQUOTE] = ACTIONS(3405),
    [anon_sym_UR_DQUOTE] = ACTIONS(3405),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3405),
    [anon_sym_co_await] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3403),
    [anon_sym_requires] = ACTIONS(3403),
    [sym_this] = ACTIONS(3403),
    [anon_sym_discard] = ACTIONS(3403),
    [anon_sym_precise] = ACTIONS(3403),
    [anon_sym_shared] = ACTIONS(3403),
    [anon_sym_groupshared] = ACTIONS(3403),
    [anon_sym_uniform] = ACTIONS(3403),
    [anon_sym_row_major] = ACTIONS(3403),
    [anon_sym_column_major] = ACTIONS(3403),
    [anon_sym_globallycoherent] = ACTIONS(3403),
    [anon_sym_centroid] = ACTIONS(3403),
    [anon_sym_noperspective] = ACTIONS(3403),
    [anon_sym_nointerpolation] = ACTIONS(3403),
    [anon_sym_sample] = ACTIONS(3403),
    [anon_sym_linear] = ACTIONS(3403),
    [anon_sym_snorm] = ACTIONS(3403),
    [anon_sym_unorm] = ACTIONS(3403),
    [anon_sym_point] = ACTIONS(3403),
    [anon_sym_line] = ACTIONS(3403),
    [anon_sym_triangleadj] = ACTIONS(3403),
    [anon_sym_lineadj] = ACTIONS(3403),
    [anon_sym_triangle] = ACTIONS(3403),
    [anon_sym_cbuffer] = ACTIONS(3403),
    [anon_sym_interface] = ACTIONS(3403),
    [anon_sym_extension] = ACTIONS(3403),
  },
  [385] = {
    [sym_identifier] = ACTIONS(3407),
    [aux_sym_preproc_include_token1] = ACTIONS(3407),
    [aux_sym_preproc_def_token1] = ACTIONS(3407),
    [aux_sym_preproc_if_token1] = ACTIONS(3407),
    [aux_sym_preproc_if_token2] = ACTIONS(3407),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3407),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3407),
    [aux_sym_preproc_else_token1] = ACTIONS(3407),
    [aux_sym_preproc_elif_token1] = ACTIONS(3407),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3407),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3407),
    [sym_preproc_directive] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3409),
    [anon_sym_TILDE] = ACTIONS(3409),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_AMP_AMP] = ACTIONS(3409),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_SEMI] = ACTIONS(3409),
    [anon_sym___extension__] = ACTIONS(3407),
    [anon_sym_typedef] = ACTIONS(3407),
    [anon_sym_in] = ACTIONS(3407),
    [anon_sym_out] = ACTIONS(3407),
    [anon_sym_inout] = ACTIONS(3407),
    [anon_sym_virtual] = ACTIONS(3407),
    [anon_sym_extern] = ACTIONS(3407),
    [anon_sym___attribute__] = ACTIONS(3407),
    [anon_sym___attribute] = ACTIONS(3407),
    [anon_sym_using] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3409),
    [anon_sym___declspec] = ACTIONS(3407),
    [anon_sym___based] = ACTIONS(3407),
    [anon_sym___cdecl] = ACTIONS(3407),
    [anon_sym___clrcall] = ACTIONS(3407),
    [anon_sym___stdcall] = ACTIONS(3407),
    [anon_sym___fastcall] = ACTIONS(3407),
    [anon_sym___thiscall] = ACTIONS(3407),
    [anon_sym___vectorcall] = ACTIONS(3407),
    [anon_sym_LBRACE] = ACTIONS(3409),
    [anon_sym_signed] = ACTIONS(3407),
    [anon_sym_unsigned] = ACTIONS(3407),
    [anon_sym_long] = ACTIONS(3407),
    [anon_sym_short] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_register] = ACTIONS(3407),
    [anon_sym_inline] = ACTIONS(3407),
    [anon_sym___inline] = ACTIONS(3407),
    [anon_sym___inline__] = ACTIONS(3407),
    [anon_sym___forceinline] = ACTIONS(3407),
    [anon_sym_thread_local] = ACTIONS(3407),
    [anon_sym___thread] = ACTIONS(3407),
    [anon_sym_const] = ACTIONS(3407),
    [anon_sym_constexpr] = ACTIONS(3407),
    [anon_sym_volatile] = ACTIONS(3407),
    [anon_sym_restrict] = ACTIONS(3407),
    [anon_sym___restrict__] = ACTIONS(3407),
    [anon_sym__Atomic] = ACTIONS(3407),
    [anon_sym__Noreturn] = ACTIONS(3407),
    [anon_sym_noreturn] = ACTIONS(3407),
    [anon_sym__Nonnull] = ACTIONS(3407),
    [anon_sym_mutable] = ACTIONS(3407),
    [anon_sym_constinit] = ACTIONS(3407),
    [anon_sym_consteval] = ACTIONS(3407),
    [anon_sym_alignas] = ACTIONS(3407),
    [anon_sym__Alignas] = ACTIONS(3407),
    [sym_primitive_type] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3407),
    [anon_sym_class] = ACTIONS(3407),
    [anon_sym_struct] = ACTIONS(3407),
    [anon_sym_union] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_else] = ACTIONS(3407),
    [anon_sym_switch] = ACTIONS(3407),
    [anon_sym_case] = ACTIONS(3407),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_break] = ACTIONS(3407),
    [anon_sym_continue] = ACTIONS(3407),
    [anon_sym_goto] = ACTIONS(3407),
    [anon_sym___try] = ACTIONS(3407),
    [anon_sym___leave] = ACTIONS(3407),
    [anon_sym_not] = ACTIONS(3407),
    [anon_sym_compl] = ACTIONS(3407),
    [anon_sym_DASH_DASH] = ACTIONS(3409),
    [anon_sym_PLUS_PLUS] = ACTIONS(3409),
    [anon_sym_sizeof] = ACTIONS(3407),
    [anon_sym___alignof__] = ACTIONS(3407),
    [anon_sym___alignof] = ACTIONS(3407),
    [anon_sym__alignof] = ACTIONS(3407),
    [anon_sym_alignof] = ACTIONS(3407),
    [anon_sym__Alignof] = ACTIONS(3407),
    [anon_sym_offsetof] = ACTIONS(3407),
    [anon_sym__Generic] = ACTIONS(3407),
    [anon_sym_asm] = ACTIONS(3407),
    [anon_sym___asm__] = ACTIONS(3407),
    [anon_sym___asm] = ACTIONS(3407),
    [sym_number_literal] = ACTIONS(3409),
    [anon_sym_L_SQUOTE] = ACTIONS(3409),
    [anon_sym_u_SQUOTE] = ACTIONS(3409),
    [anon_sym_U_SQUOTE] = ACTIONS(3409),
    [anon_sym_u8_SQUOTE] = ACTIONS(3409),
    [anon_sym_SQUOTE] = ACTIONS(3409),
    [anon_sym_L_DQUOTE] = ACTIONS(3409),
    [anon_sym_u_DQUOTE] = ACTIONS(3409),
    [anon_sym_U_DQUOTE] = ACTIONS(3409),
    [anon_sym_u8_DQUOTE] = ACTIONS(3409),
    [anon_sym_DQUOTE] = ACTIONS(3409),
    [sym_true] = ACTIONS(3407),
    [sym_false] = ACTIONS(3407),
    [anon_sym_NULL] = ACTIONS(3407),
    [anon_sym_nullptr] = ACTIONS(3407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_This] = ACTIONS(3407),
    [anon_sym_decltype] = ACTIONS(3407),
    [anon_sym_explicit] = ACTIONS(3407),
    [anon_sym_typename] = ACTIONS(3407),
    [anon_sym_template] = ACTIONS(3407),
    [anon_sym_operator] = ACTIONS(3407),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_delete] = ACTIONS(3407),
    [anon_sym_throw] = ACTIONS(3407),
    [anon_sym_namespace] = ACTIONS(3407),
    [anon_sym_static_assert] = ACTIONS(3407),
    [anon_sym_concept] = ACTIONS(3407),
    [anon_sym_co_return] = ACTIONS(3407),
    [anon_sym_co_yield] = ACTIONS(3407),
    [anon_sym_R_DQUOTE] = ACTIONS(3409),
    [anon_sym_LR_DQUOTE] = ACTIONS(3409),
    [anon_sym_uR_DQUOTE] = ACTIONS(3409),
    [anon_sym_UR_DQUOTE] = ACTIONS(3409),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3409),
    [anon_sym_co_await] = ACTIONS(3407),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_requires] = ACTIONS(3407),
    [sym_this] = ACTIONS(3407),
    [anon_sym_discard] = ACTIONS(3407),
    [anon_sym_precise] = ACTIONS(3407),
    [anon_sym_shared] = ACTIONS(3407),
    [anon_sym_groupshared] = ACTIONS(3407),
    [anon_sym_uniform] = ACTIONS(3407),
    [anon_sym_row_major] = ACTIONS(3407),
    [anon_sym_column_major] = ACTIONS(3407),
    [anon_sym_globallycoherent] = ACTIONS(3407),
    [anon_sym_centroid] = ACTIONS(3407),
    [anon_sym_noperspective] = ACTIONS(3407),
    [anon_sym_nointerpolation] = ACTIONS(3407),
    [anon_sym_sample] = ACTIONS(3407),
    [anon_sym_linear] = ACTIONS(3407),
    [anon_sym_snorm] = ACTIONS(3407),
    [anon_sym_unorm] = ACTIONS(3407),
    [anon_sym_point] = ACTIONS(3407),
    [anon_sym_line] = ACTIONS(3407),
    [anon_sym_triangleadj] = ACTIONS(3407),
    [anon_sym_lineadj] = ACTIONS(3407),
    [anon_sym_triangle] = ACTIONS(3407),
    [anon_sym_cbuffer] = ACTIONS(3407),
    [anon_sym_interface] = ACTIONS(3407),
    [anon_sym_extension] = ACTIONS(3407),
  },
  [386] = {
    [sym_identifier] = ACTIONS(3411),
    [aux_sym_preproc_include_token1] = ACTIONS(3411),
    [aux_sym_preproc_def_token1] = ACTIONS(3411),
    [aux_sym_preproc_if_token1] = ACTIONS(3411),
    [aux_sym_preproc_if_token2] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3411),
    [aux_sym_preproc_else_token1] = ACTIONS(3411),
    [aux_sym_preproc_elif_token1] = ACTIONS(3411),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3411),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3411),
    [sym_preproc_directive] = ACTIONS(3411),
    [anon_sym_LPAREN2] = ACTIONS(3413),
    [anon_sym_BANG] = ACTIONS(3413),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_DASH] = ACTIONS(3411),
    [anon_sym_PLUS] = ACTIONS(3411),
    [anon_sym_STAR] = ACTIONS(3413),
    [anon_sym_AMP_AMP] = ACTIONS(3413),
    [anon_sym_AMP] = ACTIONS(3411),
    [anon_sym_SEMI] = ACTIONS(3413),
    [anon_sym___extension__] = ACTIONS(3411),
    [anon_sym_typedef] = ACTIONS(3411),
    [anon_sym_in] = ACTIONS(3411),
    [anon_sym_out] = ACTIONS(3411),
    [anon_sym_inout] = ACTIONS(3411),
    [anon_sym_virtual] = ACTIONS(3411),
    [anon_sym_extern] = ACTIONS(3411),
    [anon_sym___attribute__] = ACTIONS(3411),
    [anon_sym___attribute] = ACTIONS(3411),
    [anon_sym_using] = ACTIONS(3411),
    [anon_sym_COLON_COLON] = ACTIONS(3413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3413),
    [anon_sym___declspec] = ACTIONS(3411),
    [anon_sym___based] = ACTIONS(3411),
    [anon_sym___cdecl] = ACTIONS(3411),
    [anon_sym___clrcall] = ACTIONS(3411),
    [anon_sym___stdcall] = ACTIONS(3411),
    [anon_sym___fastcall] = ACTIONS(3411),
    [anon_sym___thiscall] = ACTIONS(3411),
    [anon_sym___vectorcall] = ACTIONS(3411),
    [anon_sym_LBRACE] = ACTIONS(3413),
    [anon_sym_signed] = ACTIONS(3411),
    [anon_sym_unsigned] = ACTIONS(3411),
    [anon_sym_long] = ACTIONS(3411),
    [anon_sym_short] = ACTIONS(3411),
    [anon_sym_LBRACK] = ACTIONS(3411),
    [anon_sym_static] = ACTIONS(3411),
    [anon_sym_register] = ACTIONS(3411),
    [anon_sym_inline] = ACTIONS(3411),
    [anon_sym___inline] = ACTIONS(3411),
    [anon_sym___inline__] = ACTIONS(3411),
    [anon_sym___forceinline] = ACTIONS(3411),
    [anon_sym_thread_local] = ACTIONS(3411),
    [anon_sym___thread] = ACTIONS(3411),
    [anon_sym_const] = ACTIONS(3411),
    [anon_sym_constexpr] = ACTIONS(3411),
    [anon_sym_volatile] = ACTIONS(3411),
    [anon_sym_restrict] = ACTIONS(3411),
    [anon_sym___restrict__] = ACTIONS(3411),
    [anon_sym__Atomic] = ACTIONS(3411),
    [anon_sym__Noreturn] = ACTIONS(3411),
    [anon_sym_noreturn] = ACTIONS(3411),
    [anon_sym__Nonnull] = ACTIONS(3411),
    [anon_sym_mutable] = ACTIONS(3411),
    [anon_sym_constinit] = ACTIONS(3411),
    [anon_sym_consteval] = ACTIONS(3411),
    [anon_sym_alignas] = ACTIONS(3411),
    [anon_sym__Alignas] = ACTIONS(3411),
    [sym_primitive_type] = ACTIONS(3411),
    [anon_sym_enum] = ACTIONS(3411),
    [anon_sym_class] = ACTIONS(3411),
    [anon_sym_struct] = ACTIONS(3411),
    [anon_sym_union] = ACTIONS(3411),
    [anon_sym_if] = ACTIONS(3411),
    [anon_sym_else] = ACTIONS(3411),
    [anon_sym_switch] = ACTIONS(3411),
    [anon_sym_case] = ACTIONS(3411),
    [anon_sym_default] = ACTIONS(3411),
    [anon_sym_while] = ACTIONS(3411),
    [anon_sym_do] = ACTIONS(3411),
    [anon_sym_for] = ACTIONS(3411),
    [anon_sym_return] = ACTIONS(3411),
    [anon_sym_break] = ACTIONS(3411),
    [anon_sym_continue] = ACTIONS(3411),
    [anon_sym_goto] = ACTIONS(3411),
    [anon_sym___try] = ACTIONS(3411),
    [anon_sym___leave] = ACTIONS(3411),
    [anon_sym_not] = ACTIONS(3411),
    [anon_sym_compl] = ACTIONS(3411),
    [anon_sym_DASH_DASH] = ACTIONS(3413),
    [anon_sym_PLUS_PLUS] = ACTIONS(3413),
    [anon_sym_sizeof] = ACTIONS(3411),
    [anon_sym___alignof__] = ACTIONS(3411),
    [anon_sym___alignof] = ACTIONS(3411),
    [anon_sym__alignof] = ACTIONS(3411),
    [anon_sym_alignof] = ACTIONS(3411),
    [anon_sym__Alignof] = ACTIONS(3411),
    [anon_sym_offsetof] = ACTIONS(3411),
    [anon_sym__Generic] = ACTIONS(3411),
    [anon_sym_asm] = ACTIONS(3411),
    [anon_sym___asm__] = ACTIONS(3411),
    [anon_sym___asm] = ACTIONS(3411),
    [sym_number_literal] = ACTIONS(3413),
    [anon_sym_L_SQUOTE] = ACTIONS(3413),
    [anon_sym_u_SQUOTE] = ACTIONS(3413),
    [anon_sym_U_SQUOTE] = ACTIONS(3413),
    [anon_sym_u8_SQUOTE] = ACTIONS(3413),
    [anon_sym_SQUOTE] = ACTIONS(3413),
    [anon_sym_L_DQUOTE] = ACTIONS(3413),
    [anon_sym_u_DQUOTE] = ACTIONS(3413),
    [anon_sym_U_DQUOTE] = ACTIONS(3413),
    [anon_sym_u8_DQUOTE] = ACTIONS(3413),
    [anon_sym_DQUOTE] = ACTIONS(3413),
    [sym_true] = ACTIONS(3411),
    [sym_false] = ACTIONS(3411),
    [anon_sym_NULL] = ACTIONS(3411),
    [anon_sym_nullptr] = ACTIONS(3411),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3411),
    [anon_sym_let] = ACTIONS(3411),
    [anon_sym_This] = ACTIONS(3411),
    [anon_sym_decltype] = ACTIONS(3411),
    [anon_sym_explicit] = ACTIONS(3411),
    [anon_sym_typename] = ACTIONS(3411),
    [anon_sym_template] = ACTIONS(3411),
    [anon_sym_operator] = ACTIONS(3411),
    [anon_sym_try] = ACTIONS(3411),
    [anon_sym_delete] = ACTIONS(3411),
    [anon_sym_throw] = ACTIONS(3411),
    [anon_sym_namespace] = ACTIONS(3411),
    [anon_sym_static_assert] = ACTIONS(3411),
    [anon_sym_concept] = ACTIONS(3411),
    [anon_sym_co_return] = ACTIONS(3411),
    [anon_sym_co_yield] = ACTIONS(3411),
    [anon_sym_R_DQUOTE] = ACTIONS(3413),
    [anon_sym_LR_DQUOTE] = ACTIONS(3413),
    [anon_sym_uR_DQUOTE] = ACTIONS(3413),
    [anon_sym_UR_DQUOTE] = ACTIONS(3413),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3413),
    [anon_sym_co_await] = ACTIONS(3411),
    [anon_sym_new] = ACTIONS(3411),
    [anon_sym_requires] = ACTIONS(3411),
    [sym_this] = ACTIONS(3411),
    [anon_sym_discard] = ACTIONS(3411),
    [anon_sym_precise] = ACTIONS(3411),
    [anon_sym_shared] = ACTIONS(3411),
    [anon_sym_groupshared] = ACTIONS(3411),
    [anon_sym_uniform] = ACTIONS(3411),
    [anon_sym_row_major] = ACTIONS(3411),
    [anon_sym_column_major] = ACTIONS(3411),
    [anon_sym_globallycoherent] = ACTIONS(3411),
    [anon_sym_centroid] = ACTIONS(3411),
    [anon_sym_noperspective] = ACTIONS(3411),
    [anon_sym_nointerpolation] = ACTIONS(3411),
    [anon_sym_sample] = ACTIONS(3411),
    [anon_sym_linear] = ACTIONS(3411),
    [anon_sym_snorm] = ACTIONS(3411),
    [anon_sym_unorm] = ACTIONS(3411),
    [anon_sym_point] = ACTIONS(3411),
    [anon_sym_line] = ACTIONS(3411),
    [anon_sym_triangleadj] = ACTIONS(3411),
    [anon_sym_lineadj] = ACTIONS(3411),
    [anon_sym_triangle] = ACTIONS(3411),
    [anon_sym_cbuffer] = ACTIONS(3411),
    [anon_sym_interface] = ACTIONS(3411),
    [anon_sym_extension] = ACTIONS(3411),
  },
  [387] = {
    [ts_builtin_sym_end] = ACTIONS(3415),
    [sym_identifier] = ACTIONS(3417),
    [aux_sym_preproc_include_token1] = ACTIONS(3417),
    [aux_sym_preproc_def_token1] = ACTIONS(3417),
    [aux_sym_preproc_if_token1] = ACTIONS(3417),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3417),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3417),
    [sym_preproc_directive] = ACTIONS(3417),
    [anon_sym_LPAREN2] = ACTIONS(3415),
    [anon_sym_BANG] = ACTIONS(3415),
    [anon_sym_TILDE] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_STAR] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3415),
    [anon_sym_AMP] = ACTIONS(3417),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym___extension__] = ACTIONS(3417),
    [anon_sym_typedef] = ACTIONS(3417),
    [anon_sym_in] = ACTIONS(3417),
    [anon_sym_out] = ACTIONS(3417),
    [anon_sym_inout] = ACTIONS(3417),
    [anon_sym_virtual] = ACTIONS(3417),
    [anon_sym_extern] = ACTIONS(3417),
    [anon_sym___attribute__] = ACTIONS(3417),
    [anon_sym___attribute] = ACTIONS(3417),
    [anon_sym_using] = ACTIONS(3417),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3415),
    [anon_sym___declspec] = ACTIONS(3417),
    [anon_sym___based] = ACTIONS(3417),
    [anon_sym___cdecl] = ACTIONS(3417),
    [anon_sym___clrcall] = ACTIONS(3417),
    [anon_sym___stdcall] = ACTIONS(3417),
    [anon_sym___fastcall] = ACTIONS(3417),
    [anon_sym___thiscall] = ACTIONS(3417),
    [anon_sym___vectorcall] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3415),
    [anon_sym_signed] = ACTIONS(3417),
    [anon_sym_unsigned] = ACTIONS(3417),
    [anon_sym_long] = ACTIONS(3417),
    [anon_sym_short] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_static] = ACTIONS(3417),
    [anon_sym_register] = ACTIONS(3417),
    [anon_sym_inline] = ACTIONS(3417),
    [anon_sym___inline] = ACTIONS(3417),
    [anon_sym___inline__] = ACTIONS(3417),
    [anon_sym___forceinline] = ACTIONS(3417),
    [anon_sym_thread_local] = ACTIONS(3417),
    [anon_sym___thread] = ACTIONS(3417),
    [anon_sym_const] = ACTIONS(3417),
    [anon_sym_constexpr] = ACTIONS(3417),
    [anon_sym_volatile] = ACTIONS(3417),
    [anon_sym_restrict] = ACTIONS(3417),
    [anon_sym___restrict__] = ACTIONS(3417),
    [anon_sym__Atomic] = ACTIONS(3417),
    [anon_sym__Noreturn] = ACTIONS(3417),
    [anon_sym_noreturn] = ACTIONS(3417),
    [anon_sym__Nonnull] = ACTIONS(3417),
    [anon_sym_mutable] = ACTIONS(3417),
    [anon_sym_constinit] = ACTIONS(3417),
    [anon_sym_consteval] = ACTIONS(3417),
    [anon_sym_alignas] = ACTIONS(3417),
    [anon_sym__Alignas] = ACTIONS(3417),
    [sym_primitive_type] = ACTIONS(3417),
    [anon_sym_enum] = ACTIONS(3417),
    [anon_sym_class] = ACTIONS(3417),
    [anon_sym_struct] = ACTIONS(3417),
    [anon_sym_union] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_else] = ACTIONS(3417),
    [anon_sym_switch] = ACTIONS(3417),
    [anon_sym_case] = ACTIONS(3417),
    [anon_sym_default] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_break] = ACTIONS(3417),
    [anon_sym_continue] = ACTIONS(3417),
    [anon_sym_goto] = ACTIONS(3417),
    [anon_sym___try] = ACTIONS(3417),
    [anon_sym___leave] = ACTIONS(3417),
    [anon_sym_not] = ACTIONS(3417),
    [anon_sym_compl] = ACTIONS(3417),
    [anon_sym_DASH_DASH] = ACTIONS(3415),
    [anon_sym_PLUS_PLUS] = ACTIONS(3415),
    [anon_sym_sizeof] = ACTIONS(3417),
    [anon_sym___alignof__] = ACTIONS(3417),
    [anon_sym___alignof] = ACTIONS(3417),
    [anon_sym__alignof] = ACTIONS(3417),
    [anon_sym_alignof] = ACTIONS(3417),
    [anon_sym__Alignof] = ACTIONS(3417),
    [anon_sym_offsetof] = ACTIONS(3417),
    [anon_sym__Generic] = ACTIONS(3417),
    [anon_sym_asm] = ACTIONS(3417),
    [anon_sym___asm__] = ACTIONS(3417),
    [anon_sym___asm] = ACTIONS(3417),
    [sym_number_literal] = ACTIONS(3415),
    [anon_sym_L_SQUOTE] = ACTIONS(3415),
    [anon_sym_u_SQUOTE] = ACTIONS(3415),
    [anon_sym_U_SQUOTE] = ACTIONS(3415),
    [anon_sym_u8_SQUOTE] = ACTIONS(3415),
    [anon_sym_SQUOTE] = ACTIONS(3415),
    [anon_sym_L_DQUOTE] = ACTIONS(3415),
    [anon_sym_u_DQUOTE] = ACTIONS(3415),
    [anon_sym_U_DQUOTE] = ACTIONS(3415),
    [anon_sym_u8_DQUOTE] = ACTIONS(3415),
    [anon_sym_DQUOTE] = ACTIONS(3415),
    [sym_true] = ACTIONS(3417),
    [sym_false] = ACTIONS(3417),
    [anon_sym_NULL] = ACTIONS(3417),
    [anon_sym_nullptr] = ACTIONS(3417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_This] = ACTIONS(3417),
    [anon_sym_decltype] = ACTIONS(3417),
    [anon_sym_explicit] = ACTIONS(3417),
    [anon_sym_typename] = ACTIONS(3417),
    [anon_sym_export] = ACTIONS(3417),
    [anon_sym_module] = ACTIONS(3417),
    [anon_sym_import] = ACTIONS(3417),
    [anon_sym_template] = ACTIONS(3417),
    [anon_sym_operator] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_delete] = ACTIONS(3417),
    [anon_sym_throw] = ACTIONS(3417),
    [anon_sym_namespace] = ACTIONS(3417),
    [anon_sym_static_assert] = ACTIONS(3417),
    [anon_sym_concept] = ACTIONS(3417),
    [anon_sym_co_return] = ACTIONS(3417),
    [anon_sym_co_yield] = ACTIONS(3417),
    [anon_sym_R_DQUOTE] = ACTIONS(3415),
    [anon_sym_LR_DQUOTE] = ACTIONS(3415),
    [anon_sym_uR_DQUOTE] = ACTIONS(3415),
    [anon_sym_UR_DQUOTE] = ACTIONS(3415),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3415),
    [anon_sym_co_await] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_requires] = ACTIONS(3417),
    [sym_this] = ACTIONS(3417),
    [anon_sym_discard] = ACTIONS(3417),
    [anon_sym_precise] = ACTIONS(3417),
    [anon_sym_shared] = ACTIONS(3417),
    [anon_sym_groupshared] = ACTIONS(3417),
    [anon_sym_uniform] = ACTIONS(3417),
    [anon_sym_row_major] = ACTIONS(3417),
    [anon_sym_column_major] = ACTIONS(3417),
    [anon_sym_globallycoherent] = ACTIONS(3417),
    [anon_sym_centroid] = ACTIONS(3417),
    [anon_sym_noperspective] = ACTIONS(3417),
    [anon_sym_nointerpolation] = ACTIONS(3417),
    [anon_sym_sample] = ACTIONS(3417),
    [anon_sym_linear] = ACTIONS(3417),
    [anon_sym_snorm] = ACTIONS(3417),
    [anon_sym_unorm] = ACTIONS(3417),
    [anon_sym_point] = ACTIONS(3417),
    [anon_sym_line] = ACTIONS(3417),
    [anon_sym_triangleadj] = ACTIONS(3417),
    [anon_sym_lineadj] = ACTIONS(3417),
    [anon_sym_triangle] = ACTIONS(3417),
    [anon_sym_cbuffer] = ACTIONS(3417),
    [anon_sym_interface] = ACTIONS(3417),
    [anon_sym_extension] = ACTIONS(3417),
    [anon_sym___exported] = ACTIONS(3417),
  },
  [388] = {
    [ts_builtin_sym_end] = ACTIONS(3419),
    [sym_identifier] = ACTIONS(3421),
    [aux_sym_preproc_include_token1] = ACTIONS(3421),
    [aux_sym_preproc_def_token1] = ACTIONS(3421),
    [aux_sym_preproc_if_token1] = ACTIONS(3421),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3421),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3421),
    [sym_preproc_directive] = ACTIONS(3421),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_BANG] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_SEMI] = ACTIONS(3419),
    [anon_sym___extension__] = ACTIONS(3421),
    [anon_sym_typedef] = ACTIONS(3421),
    [anon_sym_in] = ACTIONS(3421),
    [anon_sym_out] = ACTIONS(3421),
    [anon_sym_inout] = ACTIONS(3421),
    [anon_sym_virtual] = ACTIONS(3421),
    [anon_sym_extern] = ACTIONS(3421),
    [anon_sym___attribute__] = ACTIONS(3421),
    [anon_sym___attribute] = ACTIONS(3421),
    [anon_sym_using] = ACTIONS(3421),
    [anon_sym_COLON_COLON] = ACTIONS(3419),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3419),
    [anon_sym___declspec] = ACTIONS(3421),
    [anon_sym___based] = ACTIONS(3421),
    [anon_sym___cdecl] = ACTIONS(3421),
    [anon_sym___clrcall] = ACTIONS(3421),
    [anon_sym___stdcall] = ACTIONS(3421),
    [anon_sym___fastcall] = ACTIONS(3421),
    [anon_sym___thiscall] = ACTIONS(3421),
    [anon_sym___vectorcall] = ACTIONS(3421),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_signed] = ACTIONS(3421),
    [anon_sym_unsigned] = ACTIONS(3421),
    [anon_sym_long] = ACTIONS(3421),
    [anon_sym_short] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3421),
    [anon_sym_static] = ACTIONS(3421),
    [anon_sym_register] = ACTIONS(3421),
    [anon_sym_inline] = ACTIONS(3421),
    [anon_sym___inline] = ACTIONS(3421),
    [anon_sym___inline__] = ACTIONS(3421),
    [anon_sym___forceinline] = ACTIONS(3421),
    [anon_sym_thread_local] = ACTIONS(3421),
    [anon_sym___thread] = ACTIONS(3421),
    [anon_sym_const] = ACTIONS(3421),
    [anon_sym_constexpr] = ACTIONS(3421),
    [anon_sym_volatile] = ACTIONS(3421),
    [anon_sym_restrict] = ACTIONS(3421),
    [anon_sym___restrict__] = ACTIONS(3421),
    [anon_sym__Atomic] = ACTIONS(3421),
    [anon_sym__Noreturn] = ACTIONS(3421),
    [anon_sym_noreturn] = ACTIONS(3421),
    [anon_sym__Nonnull] = ACTIONS(3421),
    [anon_sym_mutable] = ACTIONS(3421),
    [anon_sym_constinit] = ACTIONS(3421),
    [anon_sym_consteval] = ACTIONS(3421),
    [anon_sym_alignas] = ACTIONS(3421),
    [anon_sym__Alignas] = ACTIONS(3421),
    [sym_primitive_type] = ACTIONS(3421),
    [anon_sym_enum] = ACTIONS(3421),
    [anon_sym_class] = ACTIONS(3421),
    [anon_sym_struct] = ACTIONS(3421),
    [anon_sym_union] = ACTIONS(3421),
    [anon_sym_if] = ACTIONS(3421),
    [anon_sym_else] = ACTIONS(3421),
    [anon_sym_switch] = ACTIONS(3421),
    [anon_sym_case] = ACTIONS(3421),
    [anon_sym_default] = ACTIONS(3421),
    [anon_sym_while] = ACTIONS(3421),
    [anon_sym_do] = ACTIONS(3421),
    [anon_sym_for] = ACTIONS(3421),
    [anon_sym_return] = ACTIONS(3421),
    [anon_sym_break] = ACTIONS(3421),
    [anon_sym_continue] = ACTIONS(3421),
    [anon_sym_goto] = ACTIONS(3421),
    [anon_sym___try] = ACTIONS(3421),
    [anon_sym___leave] = ACTIONS(3421),
    [anon_sym_not] = ACTIONS(3421),
    [anon_sym_compl] = ACTIONS(3421),
    [anon_sym_DASH_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_PLUS] = ACTIONS(3419),
    [anon_sym_sizeof] = ACTIONS(3421),
    [anon_sym___alignof__] = ACTIONS(3421),
    [anon_sym___alignof] = ACTIONS(3421),
    [anon_sym__alignof] = ACTIONS(3421),
    [anon_sym_alignof] = ACTIONS(3421),
    [anon_sym__Alignof] = ACTIONS(3421),
    [anon_sym_offsetof] = ACTIONS(3421),
    [anon_sym__Generic] = ACTIONS(3421),
    [anon_sym_asm] = ACTIONS(3421),
    [anon_sym___asm__] = ACTIONS(3421),
    [anon_sym___asm] = ACTIONS(3421),
    [sym_number_literal] = ACTIONS(3419),
    [anon_sym_L_SQUOTE] = ACTIONS(3419),
    [anon_sym_u_SQUOTE] = ACTIONS(3419),
    [anon_sym_U_SQUOTE] = ACTIONS(3419),
    [anon_sym_u8_SQUOTE] = ACTIONS(3419),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym_L_DQUOTE] = ACTIONS(3419),
    [anon_sym_u_DQUOTE] = ACTIONS(3419),
    [anon_sym_U_DQUOTE] = ACTIONS(3419),
    [anon_sym_u8_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [sym_true] = ACTIONS(3421),
    [sym_false] = ACTIONS(3421),
    [anon_sym_NULL] = ACTIONS(3421),
    [anon_sym_nullptr] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3421),
    [anon_sym_let] = ACTIONS(3421),
    [anon_sym_This] = ACTIONS(3421),
    [anon_sym_decltype] = ACTIONS(3421),
    [anon_sym_explicit] = ACTIONS(3421),
    [anon_sym_typename] = ACTIONS(3421),
    [anon_sym_export] = ACTIONS(3421),
    [anon_sym_module] = ACTIONS(3421),
    [anon_sym_import] = ACTIONS(3421),
    [anon_sym_template] = ACTIONS(3421),
    [anon_sym_operator] = ACTIONS(3421),
    [anon_sym_try] = ACTIONS(3421),
    [anon_sym_delete] = ACTIONS(3421),
    [anon_sym_throw] = ACTIONS(3421),
    [anon_sym_namespace] = ACTIONS(3421),
    [anon_sym_static_assert] = ACTIONS(3421),
    [anon_sym_concept] = ACTIONS(3421),
    [anon_sym_co_return] = ACTIONS(3421),
    [anon_sym_co_yield] = ACTIONS(3421),
    [anon_sym_R_DQUOTE] = ACTIONS(3419),
    [anon_sym_LR_DQUOTE] = ACTIONS(3419),
    [anon_sym_uR_DQUOTE] = ACTIONS(3419),
    [anon_sym_UR_DQUOTE] = ACTIONS(3419),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3419),
    [anon_sym_co_await] = ACTIONS(3421),
    [anon_sym_new] = ACTIONS(3421),
    [anon_sym_requires] = ACTIONS(3421),
    [sym_this] = ACTIONS(3421),
    [anon_sym_discard] = ACTIONS(3421),
    [anon_sym_precise] = ACTIONS(3421),
    [anon_sym_shared] = ACTIONS(3421),
    [anon_sym_groupshared] = ACTIONS(3421),
    [anon_sym_uniform] = ACTIONS(3421),
    [anon_sym_row_major] = ACTIONS(3421),
    [anon_sym_column_major] = ACTIONS(3421),
    [anon_sym_globallycoherent] = ACTIONS(3421),
    [anon_sym_centroid] = ACTIONS(3421),
    [anon_sym_noperspective] = ACTIONS(3421),
    [anon_sym_nointerpolation] = ACTIONS(3421),
    [anon_sym_sample] = ACTIONS(3421),
    [anon_sym_linear] = ACTIONS(3421),
    [anon_sym_snorm] = ACTIONS(3421),
    [anon_sym_unorm] = ACTIONS(3421),
    [anon_sym_point] = ACTIONS(3421),
    [anon_sym_line] = ACTIONS(3421),
    [anon_sym_triangleadj] = ACTIONS(3421),
    [anon_sym_lineadj] = ACTIONS(3421),
    [anon_sym_triangle] = ACTIONS(3421),
    [anon_sym_cbuffer] = ACTIONS(3421),
    [anon_sym_interface] = ACTIONS(3421),
    [anon_sym_extension] = ACTIONS(3421),
    [anon_sym___exported] = ACTIONS(3421),
  },
  [389] = {
    [sym_type_qualifier] = STATE(448),
    [sym_alignas_qualifier] = STATE(854),
    [aux_sym__type_definition_type_repeat1] = STATE(448),
    [aux_sym_sized_type_specifier_repeat1] = STATE(670),
    [ts_builtin_sym_end] = ACTIONS(3423),
    [sym_identifier] = ACTIONS(3425),
    [aux_sym_preproc_include_token1] = ACTIONS(3428),
    [aux_sym_preproc_def_token1] = ACTIONS(3428),
    [aux_sym_preproc_if_token1] = ACTIONS(3428),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3428),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3428),
    [sym_preproc_directive] = ACTIONS(3428),
    [anon_sym_LPAREN2] = ACTIONS(3423),
    [anon_sym_BANG] = ACTIONS(3423),
    [anon_sym_TILDE] = ACTIONS(3423),
    [anon_sym_DASH] = ACTIONS(3428),
    [anon_sym_PLUS] = ACTIONS(3428),
    [anon_sym_STAR] = ACTIONS(3423),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3428),
    [anon_sym_SEMI] = ACTIONS(3423),
    [anon_sym___extension__] = ACTIONS(3430),
    [anon_sym_typedef] = ACTIONS(3428),
    [anon_sym_in] = ACTIONS(3428),
    [anon_sym_out] = ACTIONS(3428),
    [anon_sym_inout] = ACTIONS(3428),
    [anon_sym_virtual] = ACTIONS(3428),
    [anon_sym_extern] = ACTIONS(3428),
    [anon_sym___attribute__] = ACTIONS(3428),
    [anon_sym___attribute] = ACTIONS(3428),
    [anon_sym_using] = ACTIONS(3428),
    [anon_sym_COLON_COLON] = ACTIONS(3423),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3423),
    [anon_sym___declspec] = ACTIONS(3428),
    [anon_sym___based] = ACTIONS(3428),
    [anon_sym___cdecl] = ACTIONS(3428),
    [anon_sym___clrcall] = ACTIONS(3428),
    [anon_sym___stdcall] = ACTIONS(3428),
    [anon_sym___fastcall] = ACTIONS(3428),
    [anon_sym___thiscall] = ACTIONS(3428),
    [anon_sym___vectorcall] = ACTIONS(3428),
    [anon_sym_LBRACE] = ACTIONS(3423),
    [anon_sym_signed] = ACTIONS(3433),
    [anon_sym_unsigned] = ACTIONS(3433),
    [anon_sym_long] = ACTIONS(3433),
    [anon_sym_short] = ACTIONS(3433),
    [anon_sym_LBRACK] = ACTIONS(3428),
    [anon_sym_static] = ACTIONS(3428),
    [anon_sym_register] = ACTIONS(3428),
    [anon_sym_inline] = ACTIONS(3428),
    [anon_sym___inline] = ACTIONS(3428),
    [anon_sym___inline__] = ACTIONS(3428),
    [anon_sym___forceinline] = ACTIONS(3428),
    [anon_sym_thread_local] = ACTIONS(3428),
    [anon_sym___thread] = ACTIONS(3428),
    [anon_sym_const] = ACTIONS(3430),
    [anon_sym_constexpr] = ACTIONS(3430),
    [anon_sym_volatile] = ACTIONS(3430),
    [anon_sym_restrict] = ACTIONS(3430),
    [anon_sym___restrict__] = ACTIONS(3430),
    [anon_sym__Atomic] = ACTIONS(3430),
    [anon_sym__Noreturn] = ACTIONS(3430),
    [anon_sym_noreturn] = ACTIONS(3430),
    [anon_sym__Nonnull] = ACTIONS(3430),
    [anon_sym_mutable] = ACTIONS(3430),
    [anon_sym_constinit] = ACTIONS(3430),
    [anon_sym_consteval] = ACTIONS(3430),
    [anon_sym_alignas] = ACTIONS(3436),
    [anon_sym__Alignas] = ACTIONS(3436),
    [sym_primitive_type] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3428),
    [anon_sym_class] = ACTIONS(3428),
    [anon_sym_struct] = ACTIONS(3428),
    [anon_sym_union] = ACTIONS(3428),
    [anon_sym_if] = ACTIONS(3428),
    [anon_sym_switch] = ACTIONS(3428),
    [anon_sym_case] = ACTIONS(3428),
    [anon_sym_default] = ACTIONS(3428),
    [anon_sym_while] = ACTIONS(3428),
    [anon_sym_do] = ACTIONS(3428),
    [anon_sym_for] = ACTIONS(3428),
    [anon_sym_return] = ACTIONS(3428),
    [anon_sym_break] = ACTIONS(3428),
    [anon_sym_continue] = ACTIONS(3428),
    [anon_sym_goto] = ACTIONS(3428),
    [anon_sym_not] = ACTIONS(3428),
    [anon_sym_compl] = ACTIONS(3428),
    [anon_sym_DASH_DASH] = ACTIONS(3423),
    [anon_sym_PLUS_PLUS] = ACTIONS(3423),
    [anon_sym_sizeof] = ACTIONS(3428),
    [anon_sym___alignof__] = ACTIONS(3428),
    [anon_sym___alignof] = ACTIONS(3428),
    [anon_sym__alignof] = ACTIONS(3428),
    [anon_sym_alignof] = ACTIONS(3428),
    [anon_sym__Alignof] = ACTIONS(3428),
    [anon_sym_offsetof] = ACTIONS(3428),
    [anon_sym__Generic] = ACTIONS(3428),
    [anon_sym_asm] = ACTIONS(3428),
    [anon_sym___asm__] = ACTIONS(3428),
    [anon_sym___asm] = ACTIONS(3428),
    [anon_sym_DOT] = ACTIONS(3428),
    [sym_number_literal] = ACTIONS(3423),
    [anon_sym_L_SQUOTE] = ACTIONS(3423),
    [anon_sym_u_SQUOTE] = ACTIONS(3423),
    [anon_sym_U_SQUOTE] = ACTIONS(3423),
    [anon_sym_u8_SQUOTE] = ACTIONS(3423),
    [anon_sym_SQUOTE] = ACTIONS(3423),
    [anon_sym_L_DQUOTE] = ACTIONS(3423),
    [anon_sym_u_DQUOTE] = ACTIONS(3423),
    [anon_sym_U_DQUOTE] = ACTIONS(3423),
    [anon_sym_u8_DQUOTE] = ACTIONS(3423),
    [anon_sym_DQUOTE] = ACTIONS(3423),
    [sym_true] = ACTIONS(3428),
    [sym_false] = ACTIONS(3428),
    [anon_sym_NULL] = ACTIONS(3428),
    [anon_sym_nullptr] = ACTIONS(3428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3428),
    [anon_sym_let] = ACTIONS(3428),
    [anon_sym_This] = ACTIONS(3428),
    [anon_sym_decltype] = ACTIONS(3428),
    [anon_sym_explicit] = ACTIONS(3428),
    [anon_sym_typename] = ACTIONS(3428),
    [anon_sym_export] = ACTIONS(3428),
    [anon_sym_module] = ACTIONS(3428),
    [anon_sym_import] = ACTIONS(3428),
    [anon_sym_template] = ACTIONS(3428),
    [anon_sym_operator] = ACTIONS(3428),
    [anon_sym_try] = ACTIONS(3428),
    [anon_sym_delete] = ACTIONS(3428),
    [anon_sym_throw] = ACTIONS(3428),
    [anon_sym_namespace] = ACTIONS(3428),
    [anon_sym_static_assert] = ACTIONS(3428),
    [anon_sym_concept] = ACTIONS(3428),
    [anon_sym_co_return] = ACTIONS(3428),
    [anon_sym_co_yield] = ACTIONS(3428),
    [anon_sym_R_DQUOTE] = ACTIONS(3423),
    [anon_sym_LR_DQUOTE] = ACTIONS(3423),
    [anon_sym_uR_DQUOTE] = ACTIONS(3423),
    [anon_sym_UR_DQUOTE] = ACTIONS(3423),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3423),
    [anon_sym_co_await] = ACTIONS(3428),
    [anon_sym_new] = ACTIONS(3428),
    [anon_sym_requires] = ACTIONS(3428),
    [sym_this] = ACTIONS(3428),
    [anon_sym_precise] = ACTIONS(3428),
    [anon_sym_shared] = ACTIONS(3428),
    [anon_sym_groupshared] = ACTIONS(3428),
    [anon_sym_uniform] = ACTIONS(3428),
    [anon_sym_row_major] = ACTIONS(3428),
    [anon_sym_column_major] = ACTIONS(3428),
    [anon_sym_globallycoherent] = ACTIONS(3428),
    [anon_sym_centroid] = ACTIONS(3428),
    [anon_sym_noperspective] = ACTIONS(3428),
    [anon_sym_nointerpolation] = ACTIONS(3428),
    [anon_sym_sample] = ACTIONS(3428),
    [anon_sym_linear] = ACTIONS(3428),
    [anon_sym_snorm] = ACTIONS(3428),
    [anon_sym_unorm] = ACTIONS(3428),
    [anon_sym_point] = ACTIONS(3428),
    [anon_sym_line] = ACTIONS(3428),
    [anon_sym_triangleadj] = ACTIONS(3428),
    [anon_sym_lineadj] = ACTIONS(3428),
    [anon_sym_triangle] = ACTIONS(3428),
    [anon_sym_interface] = ACTIONS(3428),
    [anon_sym_extension] = ACTIONS(3428),
    [anon_sym___exported] = ACTIONS(3428),
  },
  [390] = {
    [ts_builtin_sym_end] = ACTIONS(3442),
    [sym_identifier] = ACTIONS(3444),
    [aux_sym_preproc_include_token1] = ACTIONS(3444),
    [aux_sym_preproc_def_token1] = ACTIONS(3444),
    [aux_sym_preproc_if_token1] = ACTIONS(3444),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3444),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3444),
    [sym_preproc_directive] = ACTIONS(3444),
    [anon_sym_LPAREN2] = ACTIONS(3442),
    [anon_sym_BANG] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3444),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_STAR] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_AMP] = ACTIONS(3444),
    [anon_sym_SEMI] = ACTIONS(3442),
    [anon_sym___extension__] = ACTIONS(3444),
    [anon_sym_typedef] = ACTIONS(3444),
    [anon_sym_in] = ACTIONS(3444),
    [anon_sym_out] = ACTIONS(3444),
    [anon_sym_inout] = ACTIONS(3444),
    [anon_sym_virtual] = ACTIONS(3444),
    [anon_sym_extern] = ACTIONS(3444),
    [anon_sym___attribute__] = ACTIONS(3444),
    [anon_sym___attribute] = ACTIONS(3444),
    [anon_sym_using] = ACTIONS(3444),
    [anon_sym_COLON_COLON] = ACTIONS(3442),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3442),
    [anon_sym___declspec] = ACTIONS(3444),
    [anon_sym___based] = ACTIONS(3444),
    [anon_sym___cdecl] = ACTIONS(3444),
    [anon_sym___clrcall] = ACTIONS(3444),
    [anon_sym___stdcall] = ACTIONS(3444),
    [anon_sym___fastcall] = ACTIONS(3444),
    [anon_sym___thiscall] = ACTIONS(3444),
    [anon_sym___vectorcall] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_signed] = ACTIONS(3444),
    [anon_sym_unsigned] = ACTIONS(3444),
    [anon_sym_long] = ACTIONS(3444),
    [anon_sym_short] = ACTIONS(3444),
    [anon_sym_LBRACK] = ACTIONS(3444),
    [anon_sym_static] = ACTIONS(3444),
    [anon_sym_register] = ACTIONS(3444),
    [anon_sym_inline] = ACTIONS(3444),
    [anon_sym___inline] = ACTIONS(3444),
    [anon_sym___inline__] = ACTIONS(3444),
    [anon_sym___forceinline] = ACTIONS(3444),
    [anon_sym_thread_local] = ACTIONS(3444),
    [anon_sym___thread] = ACTIONS(3444),
    [anon_sym_const] = ACTIONS(3444),
    [anon_sym_constexpr] = ACTIONS(3444),
    [anon_sym_volatile] = ACTIONS(3444),
    [anon_sym_restrict] = ACTIONS(3444),
    [anon_sym___restrict__] = ACTIONS(3444),
    [anon_sym__Atomic] = ACTIONS(3444),
    [anon_sym__Noreturn] = ACTIONS(3444),
    [anon_sym_noreturn] = ACTIONS(3444),
    [anon_sym__Nonnull] = ACTIONS(3444),
    [anon_sym_mutable] = ACTIONS(3444),
    [anon_sym_constinit] = ACTIONS(3444),
    [anon_sym_consteval] = ACTIONS(3444),
    [anon_sym_alignas] = ACTIONS(3444),
    [anon_sym__Alignas] = ACTIONS(3444),
    [sym_primitive_type] = ACTIONS(3444),
    [anon_sym_enum] = ACTIONS(3444),
    [anon_sym_class] = ACTIONS(3444),
    [anon_sym_struct] = ACTIONS(3444),
    [anon_sym_union] = ACTIONS(3444),
    [anon_sym_if] = ACTIONS(3444),
    [anon_sym_else] = ACTIONS(3444),
    [anon_sym_switch] = ACTIONS(3444),
    [anon_sym_case] = ACTIONS(3444),
    [anon_sym_default] = ACTIONS(3444),
    [anon_sym_while] = ACTIONS(3444),
    [anon_sym_do] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3444),
    [anon_sym_return] = ACTIONS(3444),
    [anon_sym_break] = ACTIONS(3444),
    [anon_sym_continue] = ACTIONS(3444),
    [anon_sym_goto] = ACTIONS(3444),
    [anon_sym___try] = ACTIONS(3444),
    [anon_sym___leave] = ACTIONS(3444),
    [anon_sym_not] = ACTIONS(3444),
    [anon_sym_compl] = ACTIONS(3444),
    [anon_sym_DASH_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_PLUS] = ACTIONS(3442),
    [anon_sym_sizeof] = ACTIONS(3444),
    [anon_sym___alignof__] = ACTIONS(3444),
    [anon_sym___alignof] = ACTIONS(3444),
    [anon_sym__alignof] = ACTIONS(3444),
    [anon_sym_alignof] = ACTIONS(3444),
    [anon_sym__Alignof] = ACTIONS(3444),
    [anon_sym_offsetof] = ACTIONS(3444),
    [anon_sym__Generic] = ACTIONS(3444),
    [anon_sym_asm] = ACTIONS(3444),
    [anon_sym___asm__] = ACTIONS(3444),
    [anon_sym___asm] = ACTIONS(3444),
    [sym_number_literal] = ACTIONS(3442),
    [anon_sym_L_SQUOTE] = ACTIONS(3442),
    [anon_sym_u_SQUOTE] = ACTIONS(3442),
    [anon_sym_U_SQUOTE] = ACTIONS(3442),
    [anon_sym_u8_SQUOTE] = ACTIONS(3442),
    [anon_sym_SQUOTE] = ACTIONS(3442),
    [anon_sym_L_DQUOTE] = ACTIONS(3442),
    [anon_sym_u_DQUOTE] = ACTIONS(3442),
    [anon_sym_U_DQUOTE] = ACTIONS(3442),
    [anon_sym_u8_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [sym_true] = ACTIONS(3444),
    [sym_false] = ACTIONS(3444),
    [anon_sym_NULL] = ACTIONS(3444),
    [anon_sym_nullptr] = ACTIONS(3444),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3444),
    [anon_sym_let] = ACTIONS(3444),
    [anon_sym_This] = ACTIONS(3444),
    [anon_sym_decltype] = ACTIONS(3444),
    [anon_sym_explicit] = ACTIONS(3444),
    [anon_sym_typename] = ACTIONS(3444),
    [anon_sym_export] = ACTIONS(3444),
    [anon_sym_module] = ACTIONS(3444),
    [anon_sym_import] = ACTIONS(3444),
    [anon_sym_template] = ACTIONS(3444),
    [anon_sym_operator] = ACTIONS(3444),
    [anon_sym_try] = ACTIONS(3444),
    [anon_sym_delete] = ACTIONS(3444),
    [anon_sym_throw] = ACTIONS(3444),
    [anon_sym_namespace] = ACTIONS(3444),
    [anon_sym_static_assert] = ACTIONS(3444),
    [anon_sym_concept] = ACTIONS(3444),
    [anon_sym_co_return] = ACTIONS(3444),
    [anon_sym_co_yield] = ACTIONS(3444),
    [anon_sym_R_DQUOTE] = ACTIONS(3442),
    [anon_sym_LR_DQUOTE] = ACTIONS(3442),
    [anon_sym_uR_DQUOTE] = ACTIONS(3442),
    [anon_sym_UR_DQUOTE] = ACTIONS(3442),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3442),
    [anon_sym_co_await] = ACTIONS(3444),
    [anon_sym_new] = ACTIONS(3444),
    [anon_sym_requires] = ACTIONS(3444),
    [sym_this] = ACTIONS(3444),
    [anon_sym_discard] = ACTIONS(3444),
    [anon_sym_precise] = ACTIONS(3444),
    [anon_sym_shared] = ACTIONS(3444),
    [anon_sym_groupshared] = ACTIONS(3444),
    [anon_sym_uniform] = ACTIONS(3444),
    [anon_sym_row_major] = ACTIONS(3444),
    [anon_sym_column_major] = ACTIONS(3444),
    [anon_sym_globallycoherent] = ACTIONS(3444),
    [anon_sym_centroid] = ACTIONS(3444),
    [anon_sym_noperspective] = ACTIONS(3444),
    [anon_sym_nointerpolation] = ACTIONS(3444),
    [anon_sym_sample] = ACTIONS(3444),
    [anon_sym_linear] = ACTIONS(3444),
    [anon_sym_snorm] = ACTIONS(3444),
    [anon_sym_unorm] = ACTIONS(3444),
    [anon_sym_point] = ACTIONS(3444),
    [anon_sym_line] = ACTIONS(3444),
    [anon_sym_triangleadj] = ACTIONS(3444),
    [anon_sym_lineadj] = ACTIONS(3444),
    [anon_sym_triangle] = ACTIONS(3444),
    [anon_sym_cbuffer] = ACTIONS(3444),
    [anon_sym_interface] = ACTIONS(3444),
    [anon_sym_extension] = ACTIONS(3444),
    [anon_sym___exported] = ACTIONS(3444),
  },
  [391] = {
    [ts_builtin_sym_end] = ACTIONS(3446),
    [sym_identifier] = ACTIONS(3448),
    [aux_sym_preproc_include_token1] = ACTIONS(3448),
    [aux_sym_preproc_def_token1] = ACTIONS(3448),
    [aux_sym_preproc_if_token1] = ACTIONS(3448),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3448),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3448),
    [sym_preproc_directive] = ACTIONS(3448),
    [anon_sym_LPAREN2] = ACTIONS(3446),
    [anon_sym_BANG] = ACTIONS(3446),
    [anon_sym_TILDE] = ACTIONS(3446),
    [anon_sym_DASH] = ACTIONS(3448),
    [anon_sym_PLUS] = ACTIONS(3448),
    [anon_sym_STAR] = ACTIONS(3446),
    [anon_sym_AMP_AMP] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3448),
    [anon_sym_SEMI] = ACTIONS(3446),
    [anon_sym___extension__] = ACTIONS(3448),
    [anon_sym_typedef] = ACTIONS(3448),
    [anon_sym_in] = ACTIONS(3448),
    [anon_sym_out] = ACTIONS(3448),
    [anon_sym_inout] = ACTIONS(3448),
    [anon_sym_virtual] = ACTIONS(3448),
    [anon_sym_extern] = ACTIONS(3448),
    [anon_sym___attribute__] = ACTIONS(3448),
    [anon_sym___attribute] = ACTIONS(3448),
    [anon_sym_using] = ACTIONS(3448),
    [anon_sym_COLON_COLON] = ACTIONS(3446),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3446),
    [anon_sym___declspec] = ACTIONS(3448),
    [anon_sym___based] = ACTIONS(3448),
    [anon_sym___cdecl] = ACTIONS(3448),
    [anon_sym___clrcall] = ACTIONS(3448),
    [anon_sym___stdcall] = ACTIONS(3448),
    [anon_sym___fastcall] = ACTIONS(3448),
    [anon_sym___thiscall] = ACTIONS(3448),
    [anon_sym___vectorcall] = ACTIONS(3448),
    [anon_sym_LBRACE] = ACTIONS(3446),
    [anon_sym_signed] = ACTIONS(3448),
    [anon_sym_unsigned] = ACTIONS(3448),
    [anon_sym_long] = ACTIONS(3448),
    [anon_sym_short] = ACTIONS(3448),
    [anon_sym_LBRACK] = ACTIONS(3448),
    [anon_sym_static] = ACTIONS(3448),
    [anon_sym_register] = ACTIONS(3448),
    [anon_sym_inline] = ACTIONS(3448),
    [anon_sym___inline] = ACTIONS(3448),
    [anon_sym___inline__] = ACTIONS(3448),
    [anon_sym___forceinline] = ACTIONS(3448),
    [anon_sym_thread_local] = ACTIONS(3448),
    [anon_sym___thread] = ACTIONS(3448),
    [anon_sym_const] = ACTIONS(3448),
    [anon_sym_constexpr] = ACTIONS(3448),
    [anon_sym_volatile] = ACTIONS(3448),
    [anon_sym_restrict] = ACTIONS(3448),
    [anon_sym___restrict__] = ACTIONS(3448),
    [anon_sym__Atomic] = ACTIONS(3448),
    [anon_sym__Noreturn] = ACTIONS(3448),
    [anon_sym_noreturn] = ACTIONS(3448),
    [anon_sym__Nonnull] = ACTIONS(3448),
    [anon_sym_mutable] = ACTIONS(3448),
    [anon_sym_constinit] = ACTIONS(3448),
    [anon_sym_consteval] = ACTIONS(3448),
    [anon_sym_alignas] = ACTIONS(3448),
    [anon_sym__Alignas] = ACTIONS(3448),
    [sym_primitive_type] = ACTIONS(3448),
    [anon_sym_enum] = ACTIONS(3448),
    [anon_sym_class] = ACTIONS(3448),
    [anon_sym_struct] = ACTIONS(3448),
    [anon_sym_union] = ACTIONS(3448),
    [anon_sym_if] = ACTIONS(3448),
    [anon_sym_else] = ACTIONS(3448),
    [anon_sym_switch] = ACTIONS(3448),
    [anon_sym_case] = ACTIONS(3448),
    [anon_sym_default] = ACTIONS(3448),
    [anon_sym_while] = ACTIONS(3448),
    [anon_sym_do] = ACTIONS(3448),
    [anon_sym_for] = ACTIONS(3448),
    [anon_sym_return] = ACTIONS(3448),
    [anon_sym_break] = ACTIONS(3448),
    [anon_sym_continue] = ACTIONS(3448),
    [anon_sym_goto] = ACTIONS(3448),
    [anon_sym___try] = ACTIONS(3448),
    [anon_sym___leave] = ACTIONS(3448),
    [anon_sym_not] = ACTIONS(3448),
    [anon_sym_compl] = ACTIONS(3448),
    [anon_sym_DASH_DASH] = ACTIONS(3446),
    [anon_sym_PLUS_PLUS] = ACTIONS(3446),
    [anon_sym_sizeof] = ACTIONS(3448),
    [anon_sym___alignof__] = ACTIONS(3448),
    [anon_sym___alignof] = ACTIONS(3448),
    [anon_sym__alignof] = ACTIONS(3448),
    [anon_sym_alignof] = ACTIONS(3448),
    [anon_sym__Alignof] = ACTIONS(3448),
    [anon_sym_offsetof] = ACTIONS(3448),
    [anon_sym__Generic] = ACTIONS(3448),
    [anon_sym_asm] = ACTIONS(3448),
    [anon_sym___asm__] = ACTIONS(3448),
    [anon_sym___asm] = ACTIONS(3448),
    [sym_number_literal] = ACTIONS(3446),
    [anon_sym_L_SQUOTE] = ACTIONS(3446),
    [anon_sym_u_SQUOTE] = ACTIONS(3446),
    [anon_sym_U_SQUOTE] = ACTIONS(3446),
    [anon_sym_u8_SQUOTE] = ACTIONS(3446),
    [anon_sym_SQUOTE] = ACTIONS(3446),
    [anon_sym_L_DQUOTE] = ACTIONS(3446),
    [anon_sym_u_DQUOTE] = ACTIONS(3446),
    [anon_sym_U_DQUOTE] = ACTIONS(3446),
    [anon_sym_u8_DQUOTE] = ACTIONS(3446),
    [anon_sym_DQUOTE] = ACTIONS(3446),
    [sym_true] = ACTIONS(3448),
    [sym_false] = ACTIONS(3448),
    [anon_sym_NULL] = ACTIONS(3448),
    [anon_sym_nullptr] = ACTIONS(3448),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3448),
    [anon_sym_let] = ACTIONS(3448),
    [anon_sym_This] = ACTIONS(3448),
    [anon_sym_decltype] = ACTIONS(3448),
    [anon_sym_explicit] = ACTIONS(3448),
    [anon_sym_typename] = ACTIONS(3448),
    [anon_sym_export] = ACTIONS(3448),
    [anon_sym_module] = ACTIONS(3448),
    [anon_sym_import] = ACTIONS(3448),
    [anon_sym_template] = ACTIONS(3448),
    [anon_sym_operator] = ACTIONS(3448),
    [anon_sym_try] = ACTIONS(3448),
    [anon_sym_delete] = ACTIONS(3448),
    [anon_sym_throw] = ACTIONS(3448),
    [anon_sym_namespace] = ACTIONS(3448),
    [anon_sym_static_assert] = ACTIONS(3448),
    [anon_sym_concept] = ACTIONS(3448),
    [anon_sym_co_return] = ACTIONS(3448),
    [anon_sym_co_yield] = ACTIONS(3448),
    [anon_sym_R_DQUOTE] = ACTIONS(3446),
    [anon_sym_LR_DQUOTE] = ACTIONS(3446),
    [anon_sym_uR_DQUOTE] = ACTIONS(3446),
    [anon_sym_UR_DQUOTE] = ACTIONS(3446),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3446),
    [anon_sym_co_await] = ACTIONS(3448),
    [anon_sym_new] = ACTIONS(3448),
    [anon_sym_requires] = ACTIONS(3448),
    [sym_this] = ACTIONS(3448),
    [anon_sym_discard] = ACTIONS(3448),
    [anon_sym_precise] = ACTIONS(3448),
    [anon_sym_shared] = ACTIONS(3448),
    [anon_sym_groupshared] = ACTIONS(3448),
    [anon_sym_uniform] = ACTIONS(3448),
    [anon_sym_row_major] = ACTIONS(3448),
    [anon_sym_column_major] = ACTIONS(3448),
    [anon_sym_globallycoherent] = ACTIONS(3448),
    [anon_sym_centroid] = ACTIONS(3448),
    [anon_sym_noperspective] = ACTIONS(3448),
    [anon_sym_nointerpolation] = ACTIONS(3448),
    [anon_sym_sample] = ACTIONS(3448),
    [anon_sym_linear] = ACTIONS(3448),
    [anon_sym_snorm] = ACTIONS(3448),
    [anon_sym_unorm] = ACTIONS(3448),
    [anon_sym_point] = ACTIONS(3448),
    [anon_sym_line] = ACTIONS(3448),
    [anon_sym_triangleadj] = ACTIONS(3448),
    [anon_sym_lineadj] = ACTIONS(3448),
    [anon_sym_triangle] = ACTIONS(3448),
    [anon_sym_cbuffer] = ACTIONS(3448),
    [anon_sym_interface] = ACTIONS(3448),
    [anon_sym_extension] = ACTIONS(3448),
    [anon_sym___exported] = ACTIONS(3448),
  },
  [392] = {
    [ts_builtin_sym_end] = ACTIONS(3450),
    [sym_identifier] = ACTIONS(3452),
    [aux_sym_preproc_include_token1] = ACTIONS(3452),
    [aux_sym_preproc_def_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3452),
    [sym_preproc_directive] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(3450),
    [anon_sym_BANG] = ACTIONS(3450),
    [anon_sym_TILDE] = ACTIONS(3450),
    [anon_sym_DASH] = ACTIONS(3452),
    [anon_sym_PLUS] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_AMP_AMP] = ACTIONS(3450),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym___extension__] = ACTIONS(3452),
    [anon_sym_typedef] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_out] = ACTIONS(3452),
    [anon_sym_inout] = ACTIONS(3452),
    [anon_sym_virtual] = ACTIONS(3452),
    [anon_sym_extern] = ACTIONS(3452),
    [anon_sym___attribute__] = ACTIONS(3452),
    [anon_sym___attribute] = ACTIONS(3452),
    [anon_sym_using] = ACTIONS(3452),
    [anon_sym_COLON_COLON] = ACTIONS(3450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3450),
    [anon_sym___declspec] = ACTIONS(3452),
    [anon_sym___based] = ACTIONS(3452),
    [anon_sym___cdecl] = ACTIONS(3452),
    [anon_sym___clrcall] = ACTIONS(3452),
    [anon_sym___stdcall] = ACTIONS(3452),
    [anon_sym___fastcall] = ACTIONS(3452),
    [anon_sym___thiscall] = ACTIONS(3452),
    [anon_sym___vectorcall] = ACTIONS(3452),
    [anon_sym_LBRACE] = ACTIONS(3450),
    [anon_sym_signed] = ACTIONS(3452),
    [anon_sym_unsigned] = ACTIONS(3452),
    [anon_sym_long] = ACTIONS(3452),
    [anon_sym_short] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3452),
    [anon_sym_static] = ACTIONS(3452),
    [anon_sym_register] = ACTIONS(3452),
    [anon_sym_inline] = ACTIONS(3452),
    [anon_sym___inline] = ACTIONS(3452),
    [anon_sym___inline__] = ACTIONS(3452),
    [anon_sym___forceinline] = ACTIONS(3452),
    [anon_sym_thread_local] = ACTIONS(3452),
    [anon_sym___thread] = ACTIONS(3452),
    [anon_sym_const] = ACTIONS(3452),
    [anon_sym_constexpr] = ACTIONS(3452),
    [anon_sym_volatile] = ACTIONS(3452),
    [anon_sym_restrict] = ACTIONS(3452),
    [anon_sym___restrict__] = ACTIONS(3452),
    [anon_sym__Atomic] = ACTIONS(3452),
    [anon_sym__Noreturn] = ACTIONS(3452),
    [anon_sym_noreturn] = ACTIONS(3452),
    [anon_sym__Nonnull] = ACTIONS(3452),
    [anon_sym_mutable] = ACTIONS(3452),
    [anon_sym_constinit] = ACTIONS(3452),
    [anon_sym_consteval] = ACTIONS(3452),
    [anon_sym_alignas] = ACTIONS(3452),
    [anon_sym__Alignas] = ACTIONS(3452),
    [sym_primitive_type] = ACTIONS(3452),
    [anon_sym_enum] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(3452),
    [anon_sym_union] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_else] = ACTIONS(3452),
    [anon_sym_switch] = ACTIONS(3452),
    [anon_sym_case] = ACTIONS(3452),
    [anon_sym_default] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_do] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3452),
    [anon_sym_return] = ACTIONS(3452),
    [anon_sym_break] = ACTIONS(3452),
    [anon_sym_continue] = ACTIONS(3452),
    [anon_sym_goto] = ACTIONS(3452),
    [anon_sym___try] = ACTIONS(3452),
    [anon_sym___leave] = ACTIONS(3452),
    [anon_sym_not] = ACTIONS(3452),
    [anon_sym_compl] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3450),
    [anon_sym_PLUS_PLUS] = ACTIONS(3450),
    [anon_sym_sizeof] = ACTIONS(3452),
    [anon_sym___alignof__] = ACTIONS(3452),
    [anon_sym___alignof] = ACTIONS(3452),
    [anon_sym__alignof] = ACTIONS(3452),
    [anon_sym_alignof] = ACTIONS(3452),
    [anon_sym__Alignof] = ACTIONS(3452),
    [anon_sym_offsetof] = ACTIONS(3452),
    [anon_sym__Generic] = ACTIONS(3452),
    [anon_sym_asm] = ACTIONS(3452),
    [anon_sym___asm__] = ACTIONS(3452),
    [anon_sym___asm] = ACTIONS(3452),
    [sym_number_literal] = ACTIONS(3450),
    [anon_sym_L_SQUOTE] = ACTIONS(3450),
    [anon_sym_u_SQUOTE] = ACTIONS(3450),
    [anon_sym_U_SQUOTE] = ACTIONS(3450),
    [anon_sym_u8_SQUOTE] = ACTIONS(3450),
    [anon_sym_SQUOTE] = ACTIONS(3450),
    [anon_sym_L_DQUOTE] = ACTIONS(3450),
    [anon_sym_u_DQUOTE] = ACTIONS(3450),
    [anon_sym_U_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8_DQUOTE] = ACTIONS(3450),
    [anon_sym_DQUOTE] = ACTIONS(3450),
    [sym_true] = ACTIONS(3452),
    [sym_false] = ACTIONS(3452),
    [anon_sym_NULL] = ACTIONS(3452),
    [anon_sym_nullptr] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3452),
    [anon_sym_let] = ACTIONS(3452),
    [anon_sym_This] = ACTIONS(3452),
    [anon_sym_decltype] = ACTIONS(3452),
    [anon_sym_explicit] = ACTIONS(3452),
    [anon_sym_typename] = ACTIONS(3452),
    [anon_sym_export] = ACTIONS(3452),
    [anon_sym_module] = ACTIONS(3452),
    [anon_sym_import] = ACTIONS(3452),
    [anon_sym_template] = ACTIONS(3452),
    [anon_sym_operator] = ACTIONS(3452),
    [anon_sym_try] = ACTIONS(3452),
    [anon_sym_delete] = ACTIONS(3452),
    [anon_sym_throw] = ACTIONS(3452),
    [anon_sym_namespace] = ACTIONS(3452),
    [anon_sym_static_assert] = ACTIONS(3452),
    [anon_sym_concept] = ACTIONS(3452),
    [anon_sym_co_return] = ACTIONS(3452),
    [anon_sym_co_yield] = ACTIONS(3452),
    [anon_sym_R_DQUOTE] = ACTIONS(3450),
    [anon_sym_LR_DQUOTE] = ACTIONS(3450),
    [anon_sym_uR_DQUOTE] = ACTIONS(3450),
    [anon_sym_UR_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3450),
    [anon_sym_co_await] = ACTIONS(3452),
    [anon_sym_new] = ACTIONS(3452),
    [anon_sym_requires] = ACTIONS(3452),
    [sym_this] = ACTIONS(3452),
    [anon_sym_discard] = ACTIONS(3452),
    [anon_sym_precise] = ACTIONS(3452),
    [anon_sym_shared] = ACTIONS(3452),
    [anon_sym_groupshared] = ACTIONS(3452),
    [anon_sym_uniform] = ACTIONS(3452),
    [anon_sym_row_major] = ACTIONS(3452),
    [anon_sym_column_major] = ACTIONS(3452),
    [anon_sym_globallycoherent] = ACTIONS(3452),
    [anon_sym_centroid] = ACTIONS(3452),
    [anon_sym_noperspective] = ACTIONS(3452),
    [anon_sym_nointerpolation] = ACTIONS(3452),
    [anon_sym_sample] = ACTIONS(3452),
    [anon_sym_linear] = ACTIONS(3452),
    [anon_sym_snorm] = ACTIONS(3452),
    [anon_sym_unorm] = ACTIONS(3452),
    [anon_sym_point] = ACTIONS(3452),
    [anon_sym_line] = ACTIONS(3452),
    [anon_sym_triangleadj] = ACTIONS(3452),
    [anon_sym_lineadj] = ACTIONS(3452),
    [anon_sym_triangle] = ACTIONS(3452),
    [anon_sym_cbuffer] = ACTIONS(3452),
    [anon_sym_interface] = ACTIONS(3452),
    [anon_sym_extension] = ACTIONS(3452),
    [anon_sym___exported] = ACTIONS(3452),
  },
  [393] = {
    [ts_builtin_sym_end] = ACTIONS(3450),
    [sym_identifier] = ACTIONS(3452),
    [aux_sym_preproc_include_token1] = ACTIONS(3452),
    [aux_sym_preproc_def_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3452),
    [sym_preproc_directive] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(3450),
    [anon_sym_BANG] = ACTIONS(3450),
    [anon_sym_TILDE] = ACTIONS(3450),
    [anon_sym_DASH] = ACTIONS(3452),
    [anon_sym_PLUS] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_AMP_AMP] = ACTIONS(3450),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym___extension__] = ACTIONS(3452),
    [anon_sym_typedef] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_out] = ACTIONS(3452),
    [anon_sym_inout] = ACTIONS(3452),
    [anon_sym_virtual] = ACTIONS(3452),
    [anon_sym_extern] = ACTIONS(3452),
    [anon_sym___attribute__] = ACTIONS(3452),
    [anon_sym___attribute] = ACTIONS(3452),
    [anon_sym_using] = ACTIONS(3452),
    [anon_sym_COLON_COLON] = ACTIONS(3450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3450),
    [anon_sym___declspec] = ACTIONS(3452),
    [anon_sym___based] = ACTIONS(3452),
    [anon_sym___cdecl] = ACTIONS(3452),
    [anon_sym___clrcall] = ACTIONS(3452),
    [anon_sym___stdcall] = ACTIONS(3452),
    [anon_sym___fastcall] = ACTIONS(3452),
    [anon_sym___thiscall] = ACTIONS(3452),
    [anon_sym___vectorcall] = ACTIONS(3452),
    [anon_sym_LBRACE] = ACTIONS(3450),
    [anon_sym_signed] = ACTIONS(3452),
    [anon_sym_unsigned] = ACTIONS(3452),
    [anon_sym_long] = ACTIONS(3452),
    [anon_sym_short] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3452),
    [anon_sym_static] = ACTIONS(3452),
    [anon_sym_register] = ACTIONS(3452),
    [anon_sym_inline] = ACTIONS(3452),
    [anon_sym___inline] = ACTIONS(3452),
    [anon_sym___inline__] = ACTIONS(3452),
    [anon_sym___forceinline] = ACTIONS(3452),
    [anon_sym_thread_local] = ACTIONS(3452),
    [anon_sym___thread] = ACTIONS(3452),
    [anon_sym_const] = ACTIONS(3452),
    [anon_sym_constexpr] = ACTIONS(3452),
    [anon_sym_volatile] = ACTIONS(3452),
    [anon_sym_restrict] = ACTIONS(3452),
    [anon_sym___restrict__] = ACTIONS(3452),
    [anon_sym__Atomic] = ACTIONS(3452),
    [anon_sym__Noreturn] = ACTIONS(3452),
    [anon_sym_noreturn] = ACTIONS(3452),
    [anon_sym__Nonnull] = ACTIONS(3452),
    [anon_sym_mutable] = ACTIONS(3452),
    [anon_sym_constinit] = ACTIONS(3452),
    [anon_sym_consteval] = ACTIONS(3452),
    [anon_sym_alignas] = ACTIONS(3452),
    [anon_sym__Alignas] = ACTIONS(3452),
    [sym_primitive_type] = ACTIONS(3452),
    [anon_sym_enum] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(3452),
    [anon_sym_union] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_else] = ACTIONS(3452),
    [anon_sym_switch] = ACTIONS(3452),
    [anon_sym_case] = ACTIONS(3452),
    [anon_sym_default] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_do] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3452),
    [anon_sym_return] = ACTIONS(3452),
    [anon_sym_break] = ACTIONS(3452),
    [anon_sym_continue] = ACTIONS(3452),
    [anon_sym_goto] = ACTIONS(3452),
    [anon_sym___try] = ACTIONS(3452),
    [anon_sym___leave] = ACTIONS(3452),
    [anon_sym_not] = ACTIONS(3452),
    [anon_sym_compl] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3450),
    [anon_sym_PLUS_PLUS] = ACTIONS(3450),
    [anon_sym_sizeof] = ACTIONS(3452),
    [anon_sym___alignof__] = ACTIONS(3452),
    [anon_sym___alignof] = ACTIONS(3452),
    [anon_sym__alignof] = ACTIONS(3452),
    [anon_sym_alignof] = ACTIONS(3452),
    [anon_sym__Alignof] = ACTIONS(3452),
    [anon_sym_offsetof] = ACTIONS(3452),
    [anon_sym__Generic] = ACTIONS(3452),
    [anon_sym_asm] = ACTIONS(3452),
    [anon_sym___asm__] = ACTIONS(3452),
    [anon_sym___asm] = ACTIONS(3452),
    [sym_number_literal] = ACTIONS(3450),
    [anon_sym_L_SQUOTE] = ACTIONS(3450),
    [anon_sym_u_SQUOTE] = ACTIONS(3450),
    [anon_sym_U_SQUOTE] = ACTIONS(3450),
    [anon_sym_u8_SQUOTE] = ACTIONS(3450),
    [anon_sym_SQUOTE] = ACTIONS(3450),
    [anon_sym_L_DQUOTE] = ACTIONS(3450),
    [anon_sym_u_DQUOTE] = ACTIONS(3450),
    [anon_sym_U_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8_DQUOTE] = ACTIONS(3450),
    [anon_sym_DQUOTE] = ACTIONS(3450),
    [sym_true] = ACTIONS(3452),
    [sym_false] = ACTIONS(3452),
    [anon_sym_NULL] = ACTIONS(3452),
    [anon_sym_nullptr] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3452),
    [anon_sym_let] = ACTIONS(3452),
    [anon_sym_This] = ACTIONS(3452),
    [anon_sym_decltype] = ACTIONS(3452),
    [anon_sym_explicit] = ACTIONS(3452),
    [anon_sym_typename] = ACTIONS(3452),
    [anon_sym_export] = ACTIONS(3452),
    [anon_sym_module] = ACTIONS(3452),
    [anon_sym_import] = ACTIONS(3452),
    [anon_sym_template] = ACTIONS(3452),
    [anon_sym_operator] = ACTIONS(3452),
    [anon_sym_try] = ACTIONS(3452),
    [anon_sym_delete] = ACTIONS(3452),
    [anon_sym_throw] = ACTIONS(3452),
    [anon_sym_namespace] = ACTIONS(3452),
    [anon_sym_static_assert] = ACTIONS(3452),
    [anon_sym_concept] = ACTIONS(3452),
    [anon_sym_co_return] = ACTIONS(3452),
    [anon_sym_co_yield] = ACTIONS(3452),
    [anon_sym_R_DQUOTE] = ACTIONS(3450),
    [anon_sym_LR_DQUOTE] = ACTIONS(3450),
    [anon_sym_uR_DQUOTE] = ACTIONS(3450),
    [anon_sym_UR_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3450),
    [anon_sym_co_await] = ACTIONS(3452),
    [anon_sym_new] = ACTIONS(3452),
    [anon_sym_requires] = ACTIONS(3452),
    [sym_this] = ACTIONS(3452),
    [anon_sym_discard] = ACTIONS(3452),
    [anon_sym_precise] = ACTIONS(3452),
    [anon_sym_shared] = ACTIONS(3452),
    [anon_sym_groupshared] = ACTIONS(3452),
    [anon_sym_uniform] = ACTIONS(3452),
    [anon_sym_row_major] = ACTIONS(3452),
    [anon_sym_column_major] = ACTIONS(3452),
    [anon_sym_globallycoherent] = ACTIONS(3452),
    [anon_sym_centroid] = ACTIONS(3452),
    [anon_sym_noperspective] = ACTIONS(3452),
    [anon_sym_nointerpolation] = ACTIONS(3452),
    [anon_sym_sample] = ACTIONS(3452),
    [anon_sym_linear] = ACTIONS(3452),
    [anon_sym_snorm] = ACTIONS(3452),
    [anon_sym_unorm] = ACTIONS(3452),
    [anon_sym_point] = ACTIONS(3452),
    [anon_sym_line] = ACTIONS(3452),
    [anon_sym_triangleadj] = ACTIONS(3452),
    [anon_sym_lineadj] = ACTIONS(3452),
    [anon_sym_triangle] = ACTIONS(3452),
    [anon_sym_cbuffer] = ACTIONS(3452),
    [anon_sym_interface] = ACTIONS(3452),
    [anon_sym_extension] = ACTIONS(3452),
    [anon_sym___exported] = ACTIONS(3452),
  },
  [394] = {
    [ts_builtin_sym_end] = ACTIONS(3450),
    [sym_identifier] = ACTIONS(3452),
    [aux_sym_preproc_include_token1] = ACTIONS(3452),
    [aux_sym_preproc_def_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3452),
    [sym_preproc_directive] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(3450),
    [anon_sym_BANG] = ACTIONS(3450),
    [anon_sym_TILDE] = ACTIONS(3450),
    [anon_sym_DASH] = ACTIONS(3452),
    [anon_sym_PLUS] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_AMP_AMP] = ACTIONS(3450),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym___extension__] = ACTIONS(3452),
    [anon_sym_typedef] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_out] = ACTIONS(3452),
    [anon_sym_inout] = ACTIONS(3452),
    [anon_sym_virtual] = ACTIONS(3452),
    [anon_sym_extern] = ACTIONS(3452),
    [anon_sym___attribute__] = ACTIONS(3452),
    [anon_sym___attribute] = ACTIONS(3452),
    [anon_sym_using] = ACTIONS(3452),
    [anon_sym_COLON_COLON] = ACTIONS(3450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3450),
    [anon_sym___declspec] = ACTIONS(3452),
    [anon_sym___based] = ACTIONS(3452),
    [anon_sym___cdecl] = ACTIONS(3452),
    [anon_sym___clrcall] = ACTIONS(3452),
    [anon_sym___stdcall] = ACTIONS(3452),
    [anon_sym___fastcall] = ACTIONS(3452),
    [anon_sym___thiscall] = ACTIONS(3452),
    [anon_sym___vectorcall] = ACTIONS(3452),
    [anon_sym_LBRACE] = ACTIONS(3450),
    [anon_sym_signed] = ACTIONS(3452),
    [anon_sym_unsigned] = ACTIONS(3452),
    [anon_sym_long] = ACTIONS(3452),
    [anon_sym_short] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3452),
    [anon_sym_static] = ACTIONS(3452),
    [anon_sym_register] = ACTIONS(3452),
    [anon_sym_inline] = ACTIONS(3452),
    [anon_sym___inline] = ACTIONS(3452),
    [anon_sym___inline__] = ACTIONS(3452),
    [anon_sym___forceinline] = ACTIONS(3452),
    [anon_sym_thread_local] = ACTIONS(3452),
    [anon_sym___thread] = ACTIONS(3452),
    [anon_sym_const] = ACTIONS(3452),
    [anon_sym_constexpr] = ACTIONS(3452),
    [anon_sym_volatile] = ACTIONS(3452),
    [anon_sym_restrict] = ACTIONS(3452),
    [anon_sym___restrict__] = ACTIONS(3452),
    [anon_sym__Atomic] = ACTIONS(3452),
    [anon_sym__Noreturn] = ACTIONS(3452),
    [anon_sym_noreturn] = ACTIONS(3452),
    [anon_sym__Nonnull] = ACTIONS(3452),
    [anon_sym_mutable] = ACTIONS(3452),
    [anon_sym_constinit] = ACTIONS(3452),
    [anon_sym_consteval] = ACTIONS(3452),
    [anon_sym_alignas] = ACTIONS(3452),
    [anon_sym__Alignas] = ACTIONS(3452),
    [sym_primitive_type] = ACTIONS(3452),
    [anon_sym_enum] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(3452),
    [anon_sym_union] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_else] = ACTIONS(3452),
    [anon_sym_switch] = ACTIONS(3452),
    [anon_sym_case] = ACTIONS(3452),
    [anon_sym_default] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_do] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3452),
    [anon_sym_return] = ACTIONS(3452),
    [anon_sym_break] = ACTIONS(3452),
    [anon_sym_continue] = ACTIONS(3452),
    [anon_sym_goto] = ACTIONS(3452),
    [anon_sym___try] = ACTIONS(3452),
    [anon_sym___leave] = ACTIONS(3452),
    [anon_sym_not] = ACTIONS(3452),
    [anon_sym_compl] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3450),
    [anon_sym_PLUS_PLUS] = ACTIONS(3450),
    [anon_sym_sizeof] = ACTIONS(3452),
    [anon_sym___alignof__] = ACTIONS(3452),
    [anon_sym___alignof] = ACTIONS(3452),
    [anon_sym__alignof] = ACTIONS(3452),
    [anon_sym_alignof] = ACTIONS(3452),
    [anon_sym__Alignof] = ACTIONS(3452),
    [anon_sym_offsetof] = ACTIONS(3452),
    [anon_sym__Generic] = ACTIONS(3452),
    [anon_sym_asm] = ACTIONS(3452),
    [anon_sym___asm__] = ACTIONS(3452),
    [anon_sym___asm] = ACTIONS(3452),
    [sym_number_literal] = ACTIONS(3450),
    [anon_sym_L_SQUOTE] = ACTIONS(3450),
    [anon_sym_u_SQUOTE] = ACTIONS(3450),
    [anon_sym_U_SQUOTE] = ACTIONS(3450),
    [anon_sym_u8_SQUOTE] = ACTIONS(3450),
    [anon_sym_SQUOTE] = ACTIONS(3450),
    [anon_sym_L_DQUOTE] = ACTIONS(3450),
    [anon_sym_u_DQUOTE] = ACTIONS(3450),
    [anon_sym_U_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8_DQUOTE] = ACTIONS(3450),
    [anon_sym_DQUOTE] = ACTIONS(3450),
    [sym_true] = ACTIONS(3452),
    [sym_false] = ACTIONS(3452),
    [anon_sym_NULL] = ACTIONS(3452),
    [anon_sym_nullptr] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3452),
    [anon_sym_let] = ACTIONS(3452),
    [anon_sym_This] = ACTIONS(3452),
    [anon_sym_decltype] = ACTIONS(3452),
    [anon_sym_explicit] = ACTIONS(3452),
    [anon_sym_typename] = ACTIONS(3452),
    [anon_sym_export] = ACTIONS(3452),
    [anon_sym_module] = ACTIONS(3452),
    [anon_sym_import] = ACTIONS(3452),
    [anon_sym_template] = ACTIONS(3452),
    [anon_sym_operator] = ACTIONS(3452),
    [anon_sym_try] = ACTIONS(3452),
    [anon_sym_delete] = ACTIONS(3452),
    [anon_sym_throw] = ACTIONS(3452),
    [anon_sym_namespace] = ACTIONS(3452),
    [anon_sym_static_assert] = ACTIONS(3452),
    [anon_sym_concept] = ACTIONS(3452),
    [anon_sym_co_return] = ACTIONS(3452),
    [anon_sym_co_yield] = ACTIONS(3452),
    [anon_sym_R_DQUOTE] = ACTIONS(3450),
    [anon_sym_LR_DQUOTE] = ACTIONS(3450),
    [anon_sym_uR_DQUOTE] = ACTIONS(3450),
    [anon_sym_UR_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3450),
    [anon_sym_co_await] = ACTIONS(3452),
    [anon_sym_new] = ACTIONS(3452),
    [anon_sym_requires] = ACTIONS(3452),
    [sym_this] = ACTIONS(3452),
    [anon_sym_discard] = ACTIONS(3452),
    [anon_sym_precise] = ACTIONS(3452),
    [anon_sym_shared] = ACTIONS(3452),
    [anon_sym_groupshared] = ACTIONS(3452),
    [anon_sym_uniform] = ACTIONS(3452),
    [anon_sym_row_major] = ACTIONS(3452),
    [anon_sym_column_major] = ACTIONS(3452),
    [anon_sym_globallycoherent] = ACTIONS(3452),
    [anon_sym_centroid] = ACTIONS(3452),
    [anon_sym_noperspective] = ACTIONS(3452),
    [anon_sym_nointerpolation] = ACTIONS(3452),
    [anon_sym_sample] = ACTIONS(3452),
    [anon_sym_linear] = ACTIONS(3452),
    [anon_sym_snorm] = ACTIONS(3452),
    [anon_sym_unorm] = ACTIONS(3452),
    [anon_sym_point] = ACTIONS(3452),
    [anon_sym_line] = ACTIONS(3452),
    [anon_sym_triangleadj] = ACTIONS(3452),
    [anon_sym_lineadj] = ACTIONS(3452),
    [anon_sym_triangle] = ACTIONS(3452),
    [anon_sym_cbuffer] = ACTIONS(3452),
    [anon_sym_interface] = ACTIONS(3452),
    [anon_sym_extension] = ACTIONS(3452),
    [anon_sym___exported] = ACTIONS(3452),
  },
  [395] = {
    [sym_identifier] = ACTIONS(2550),
    [aux_sym_preproc_include_token1] = ACTIONS(2550),
    [aux_sym_preproc_def_token1] = ACTIONS(2550),
    [aux_sym_preproc_if_token1] = ACTIONS(2550),
    [aux_sym_preproc_if_token2] = ACTIONS(2550),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2550),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2550),
    [aux_sym_preproc_else_token1] = ACTIONS(2550),
    [aux_sym_preproc_elif_token1] = ACTIONS(2550),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2550),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2550),
    [sym_preproc_directive] = ACTIONS(2550),
    [anon_sym_LPAREN2] = ACTIONS(2548),
    [anon_sym_BANG] = ACTIONS(2548),
    [anon_sym_TILDE] = ACTIONS(2548),
    [anon_sym_DASH] = ACTIONS(2550),
    [anon_sym_PLUS] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(2548),
    [anon_sym_AMP_AMP] = ACTIONS(2548),
    [anon_sym_AMP] = ACTIONS(2550),
    [anon_sym_SEMI] = ACTIONS(2548),
    [anon_sym___extension__] = ACTIONS(2550),
    [anon_sym_typedef] = ACTIONS(2550),
    [anon_sym_in] = ACTIONS(2550),
    [anon_sym_out] = ACTIONS(2550),
    [anon_sym_inout] = ACTIONS(2550),
    [anon_sym_virtual] = ACTIONS(2550),
    [anon_sym_extern] = ACTIONS(2550),
    [anon_sym___attribute__] = ACTIONS(2550),
    [anon_sym___attribute] = ACTIONS(2550),
    [anon_sym_using] = ACTIONS(2550),
    [anon_sym_COLON_COLON] = ACTIONS(2548),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2548),
    [anon_sym___declspec] = ACTIONS(2550),
    [anon_sym___based] = ACTIONS(2550),
    [anon_sym___cdecl] = ACTIONS(2550),
    [anon_sym___clrcall] = ACTIONS(2550),
    [anon_sym___stdcall] = ACTIONS(2550),
    [anon_sym___fastcall] = ACTIONS(2550),
    [anon_sym___thiscall] = ACTIONS(2550),
    [anon_sym___vectorcall] = ACTIONS(2550),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_signed] = ACTIONS(2550),
    [anon_sym_unsigned] = ACTIONS(2550),
    [anon_sym_long] = ACTIONS(2550),
    [anon_sym_short] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_static] = ACTIONS(2550),
    [anon_sym_register] = ACTIONS(2550),
    [anon_sym_inline] = ACTIONS(2550),
    [anon_sym___inline] = ACTIONS(2550),
    [anon_sym___inline__] = ACTIONS(2550),
    [anon_sym___forceinline] = ACTIONS(2550),
    [anon_sym_thread_local] = ACTIONS(2550),
    [anon_sym___thread] = ACTIONS(2550),
    [anon_sym_const] = ACTIONS(2550),
    [anon_sym_constexpr] = ACTIONS(2550),
    [anon_sym_volatile] = ACTIONS(2550),
    [anon_sym_restrict] = ACTIONS(2550),
    [anon_sym___restrict__] = ACTIONS(2550),
    [anon_sym__Atomic] = ACTIONS(2550),
    [anon_sym__Noreturn] = ACTIONS(2550),
    [anon_sym_noreturn] = ACTIONS(2550),
    [anon_sym__Nonnull] = ACTIONS(2550),
    [anon_sym_mutable] = ACTIONS(2550),
    [anon_sym_constinit] = ACTIONS(2550),
    [anon_sym_consteval] = ACTIONS(2550),
    [anon_sym_alignas] = ACTIONS(2550),
    [anon_sym__Alignas] = ACTIONS(2550),
    [sym_primitive_type] = ACTIONS(2550),
    [anon_sym_enum] = ACTIONS(2550),
    [anon_sym_class] = ACTIONS(2550),
    [anon_sym_struct] = ACTIONS(2550),
    [anon_sym_union] = ACTIONS(2550),
    [anon_sym_if] = ACTIONS(2550),
    [anon_sym_else] = ACTIONS(2550),
    [anon_sym_switch] = ACTIONS(2550),
    [anon_sym_case] = ACTIONS(2550),
    [anon_sym_default] = ACTIONS(2550),
    [anon_sym_while] = ACTIONS(2550),
    [anon_sym_do] = ACTIONS(2550),
    [anon_sym_for] = ACTIONS(2550),
    [anon_sym_return] = ACTIONS(2550),
    [anon_sym_break] = ACTIONS(2550),
    [anon_sym_continue] = ACTIONS(2550),
    [anon_sym_goto] = ACTIONS(2550),
    [anon_sym___try] = ACTIONS(2550),
    [anon_sym___leave] = ACTIONS(2550),
    [anon_sym_not] = ACTIONS(2550),
    [anon_sym_compl] = ACTIONS(2550),
    [anon_sym_DASH_DASH] = ACTIONS(2548),
    [anon_sym_PLUS_PLUS] = ACTIONS(2548),
    [anon_sym_sizeof] = ACTIONS(2550),
    [anon_sym___alignof__] = ACTIONS(2550),
    [anon_sym___alignof] = ACTIONS(2550),
    [anon_sym__alignof] = ACTIONS(2550),
    [anon_sym_alignof] = ACTIONS(2550),
    [anon_sym__Alignof] = ACTIONS(2550),
    [anon_sym_offsetof] = ACTIONS(2550),
    [anon_sym__Generic] = ACTIONS(2550),
    [anon_sym_asm] = ACTIONS(2550),
    [anon_sym___asm__] = ACTIONS(2550),
    [anon_sym___asm] = ACTIONS(2550),
    [sym_number_literal] = ACTIONS(2548),
    [anon_sym_L_SQUOTE] = ACTIONS(2548),
    [anon_sym_u_SQUOTE] = ACTIONS(2548),
    [anon_sym_U_SQUOTE] = ACTIONS(2548),
    [anon_sym_u8_SQUOTE] = ACTIONS(2548),
    [anon_sym_SQUOTE] = ACTIONS(2548),
    [anon_sym_L_DQUOTE] = ACTIONS(2548),
    [anon_sym_u_DQUOTE] = ACTIONS(2548),
    [anon_sym_U_DQUOTE] = ACTIONS(2548),
    [anon_sym_u8_DQUOTE] = ACTIONS(2548),
    [anon_sym_DQUOTE] = ACTIONS(2548),
    [sym_true] = ACTIONS(2550),
    [sym_false] = ACTIONS(2550),
    [anon_sym_NULL] = ACTIONS(2550),
    [anon_sym_nullptr] = ACTIONS(2550),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(2550),
    [anon_sym_This] = ACTIONS(2550),
    [anon_sym_decltype] = ACTIONS(2550),
    [anon_sym_explicit] = ACTIONS(2550),
    [anon_sym_typename] = ACTIONS(2550),
    [anon_sym_template] = ACTIONS(2550),
    [anon_sym_operator] = ACTIONS(2550),
    [anon_sym_try] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(2550),
    [anon_sym_throw] = ACTIONS(2550),
    [anon_sym_namespace] = ACTIONS(2550),
    [anon_sym_static_assert] = ACTIONS(2550),
    [anon_sym_concept] = ACTIONS(2550),
    [anon_sym_co_return] = ACTIONS(2550),
    [anon_sym_co_yield] = ACTIONS(2550),
    [anon_sym_R_DQUOTE] = ACTIONS(2548),
    [anon_sym_LR_DQUOTE] = ACTIONS(2548),
    [anon_sym_uR_DQUOTE] = ACTIONS(2548),
    [anon_sym_UR_DQUOTE] = ACTIONS(2548),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2548),
    [anon_sym_co_await] = ACTIONS(2550),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2550),
    [sym_this] = ACTIONS(2550),
    [anon_sym_discard] = ACTIONS(2550),
    [anon_sym_precise] = ACTIONS(2550),
    [anon_sym_shared] = ACTIONS(2550),
    [anon_sym_groupshared] = ACTIONS(2550),
    [anon_sym_uniform] = ACTIONS(2550),
    [anon_sym_row_major] = ACTIONS(2550),
    [anon_sym_column_major] = ACTIONS(2550),
    [anon_sym_globallycoherent] = ACTIONS(2550),
    [anon_sym_centroid] = ACTIONS(2550),
    [anon_sym_noperspective] = ACTIONS(2550),
    [anon_sym_nointerpolation] = ACTIONS(2550),
    [anon_sym_sample] = ACTIONS(2550),
    [anon_sym_linear] = ACTIONS(2550),
    [anon_sym_snorm] = ACTIONS(2550),
    [anon_sym_unorm] = ACTIONS(2550),
    [anon_sym_point] = ACTIONS(2550),
    [anon_sym_line] = ACTIONS(2550),
    [anon_sym_triangleadj] = ACTIONS(2550),
    [anon_sym_lineadj] = ACTIONS(2550),
    [anon_sym_triangle] = ACTIONS(2550),
    [anon_sym_cbuffer] = ACTIONS(2550),
    [anon_sym_interface] = ACTIONS(2550),
    [anon_sym_extension] = ACTIONS(2550),
  },
  [396] = {
    [ts_builtin_sym_end] = ACTIONS(3454),
    [sym_identifier] = ACTIONS(3456),
    [aux_sym_preproc_include_token1] = ACTIONS(3456),
    [aux_sym_preproc_def_token1] = ACTIONS(3456),
    [aux_sym_preproc_if_token1] = ACTIONS(3456),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3456),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3456),
    [sym_preproc_directive] = ACTIONS(3456),
    [anon_sym_LPAREN2] = ACTIONS(3454),
    [anon_sym_BANG] = ACTIONS(3454),
    [anon_sym_TILDE] = ACTIONS(3454),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3454),
    [anon_sym_AMP_AMP] = ACTIONS(3454),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_SEMI] = ACTIONS(3454),
    [anon_sym___extension__] = ACTIONS(3456),
    [anon_sym_typedef] = ACTIONS(3456),
    [anon_sym_in] = ACTIONS(3456),
    [anon_sym_out] = ACTIONS(3456),
    [anon_sym_inout] = ACTIONS(3456),
    [anon_sym_virtual] = ACTIONS(3456),
    [anon_sym_extern] = ACTIONS(3456),
    [anon_sym___attribute__] = ACTIONS(3456),
    [anon_sym___attribute] = ACTIONS(3456),
    [anon_sym_using] = ACTIONS(3456),
    [anon_sym_COLON_COLON] = ACTIONS(3454),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3454),
    [anon_sym___declspec] = ACTIONS(3456),
    [anon_sym___based] = ACTIONS(3456),
    [anon_sym___cdecl] = ACTIONS(3456),
    [anon_sym___clrcall] = ACTIONS(3456),
    [anon_sym___stdcall] = ACTIONS(3456),
    [anon_sym___fastcall] = ACTIONS(3456),
    [anon_sym___thiscall] = ACTIONS(3456),
    [anon_sym___vectorcall] = ACTIONS(3456),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_signed] = ACTIONS(3456),
    [anon_sym_unsigned] = ACTIONS(3456),
    [anon_sym_long] = ACTIONS(3456),
    [anon_sym_short] = ACTIONS(3456),
    [anon_sym_LBRACK] = ACTIONS(3456),
    [anon_sym_static] = ACTIONS(3456),
    [anon_sym_register] = ACTIONS(3456),
    [anon_sym_inline] = ACTIONS(3456),
    [anon_sym___inline] = ACTIONS(3456),
    [anon_sym___inline__] = ACTIONS(3456),
    [anon_sym___forceinline] = ACTIONS(3456),
    [anon_sym_thread_local] = ACTIONS(3456),
    [anon_sym___thread] = ACTIONS(3456),
    [anon_sym_const] = ACTIONS(3456),
    [anon_sym_constexpr] = ACTIONS(3456),
    [anon_sym_volatile] = ACTIONS(3456),
    [anon_sym_restrict] = ACTIONS(3456),
    [anon_sym___restrict__] = ACTIONS(3456),
    [anon_sym__Atomic] = ACTIONS(3456),
    [anon_sym__Noreturn] = ACTIONS(3456),
    [anon_sym_noreturn] = ACTIONS(3456),
    [anon_sym__Nonnull] = ACTIONS(3456),
    [anon_sym_mutable] = ACTIONS(3456),
    [anon_sym_constinit] = ACTIONS(3456),
    [anon_sym_consteval] = ACTIONS(3456),
    [anon_sym_alignas] = ACTIONS(3456),
    [anon_sym__Alignas] = ACTIONS(3456),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_enum] = ACTIONS(3456),
    [anon_sym_class] = ACTIONS(3456),
    [anon_sym_struct] = ACTIONS(3456),
    [anon_sym_union] = ACTIONS(3456),
    [anon_sym_if] = ACTIONS(3456),
    [anon_sym_else] = ACTIONS(3456),
    [anon_sym_switch] = ACTIONS(3456),
    [anon_sym_case] = ACTIONS(3456),
    [anon_sym_default] = ACTIONS(3456),
    [anon_sym_while] = ACTIONS(3456),
    [anon_sym_do] = ACTIONS(3456),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_return] = ACTIONS(3456),
    [anon_sym_break] = ACTIONS(3456),
    [anon_sym_continue] = ACTIONS(3456),
    [anon_sym_goto] = ACTIONS(3456),
    [anon_sym___try] = ACTIONS(3456),
    [anon_sym___leave] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(3456),
    [anon_sym_compl] = ACTIONS(3456),
    [anon_sym_DASH_DASH] = ACTIONS(3454),
    [anon_sym_PLUS_PLUS] = ACTIONS(3454),
    [anon_sym_sizeof] = ACTIONS(3456),
    [anon_sym___alignof__] = ACTIONS(3456),
    [anon_sym___alignof] = ACTIONS(3456),
    [anon_sym__alignof] = ACTIONS(3456),
    [anon_sym_alignof] = ACTIONS(3456),
    [anon_sym__Alignof] = ACTIONS(3456),
    [anon_sym_offsetof] = ACTIONS(3456),
    [anon_sym__Generic] = ACTIONS(3456),
    [anon_sym_asm] = ACTIONS(3456),
    [anon_sym___asm__] = ACTIONS(3456),
    [anon_sym___asm] = ACTIONS(3456),
    [sym_number_literal] = ACTIONS(3454),
    [anon_sym_L_SQUOTE] = ACTIONS(3454),
    [anon_sym_u_SQUOTE] = ACTIONS(3454),
    [anon_sym_U_SQUOTE] = ACTIONS(3454),
    [anon_sym_u8_SQUOTE] = ACTIONS(3454),
    [anon_sym_SQUOTE] = ACTIONS(3454),
    [anon_sym_L_DQUOTE] = ACTIONS(3454),
    [anon_sym_u_DQUOTE] = ACTIONS(3454),
    [anon_sym_U_DQUOTE] = ACTIONS(3454),
    [anon_sym_u8_DQUOTE] = ACTIONS(3454),
    [anon_sym_DQUOTE] = ACTIONS(3454),
    [sym_true] = ACTIONS(3456),
    [sym_false] = ACTIONS(3456),
    [anon_sym_NULL] = ACTIONS(3456),
    [anon_sym_nullptr] = ACTIONS(3456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3456),
    [anon_sym_let] = ACTIONS(3456),
    [anon_sym_This] = ACTIONS(3456),
    [anon_sym_decltype] = ACTIONS(3456),
    [anon_sym_explicit] = ACTIONS(3456),
    [anon_sym_typename] = ACTIONS(3456),
    [anon_sym_export] = ACTIONS(3456),
    [anon_sym_module] = ACTIONS(3456),
    [anon_sym_import] = ACTIONS(3456),
    [anon_sym_template] = ACTIONS(3456),
    [anon_sym_operator] = ACTIONS(3456),
    [anon_sym_try] = ACTIONS(3456),
    [anon_sym_delete] = ACTIONS(3456),
    [anon_sym_throw] = ACTIONS(3456),
    [anon_sym_namespace] = ACTIONS(3456),
    [anon_sym_static_assert] = ACTIONS(3456),
    [anon_sym_concept] = ACTIONS(3456),
    [anon_sym_co_return] = ACTIONS(3456),
    [anon_sym_co_yield] = ACTIONS(3456),
    [anon_sym_R_DQUOTE] = ACTIONS(3454),
    [anon_sym_LR_DQUOTE] = ACTIONS(3454),
    [anon_sym_uR_DQUOTE] = ACTIONS(3454),
    [anon_sym_UR_DQUOTE] = ACTIONS(3454),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3454),
    [anon_sym_co_await] = ACTIONS(3456),
    [anon_sym_new] = ACTIONS(3456),
    [anon_sym_requires] = ACTIONS(3456),
    [sym_this] = ACTIONS(3456),
    [anon_sym_discard] = ACTIONS(3456),
    [anon_sym_precise] = ACTIONS(3456),
    [anon_sym_shared] = ACTIONS(3456),
    [anon_sym_groupshared] = ACTIONS(3456),
    [anon_sym_uniform] = ACTIONS(3456),
    [anon_sym_row_major] = ACTIONS(3456),
    [anon_sym_column_major] = ACTIONS(3456),
    [anon_sym_globallycoherent] = ACTIONS(3456),
    [anon_sym_centroid] = ACTIONS(3456),
    [anon_sym_noperspective] = ACTIONS(3456),
    [anon_sym_nointerpolation] = ACTIONS(3456),
    [anon_sym_sample] = ACTIONS(3456),
    [anon_sym_linear] = ACTIONS(3456),
    [anon_sym_snorm] = ACTIONS(3456),
    [anon_sym_unorm] = ACTIONS(3456),
    [anon_sym_point] = ACTIONS(3456),
    [anon_sym_line] = ACTIONS(3456),
    [anon_sym_triangleadj] = ACTIONS(3456),
    [anon_sym_lineadj] = ACTIONS(3456),
    [anon_sym_triangle] = ACTIONS(3456),
    [anon_sym_cbuffer] = ACTIONS(3456),
    [anon_sym_interface] = ACTIONS(3456),
    [anon_sym_extension] = ACTIONS(3456),
    [anon_sym___exported] = ACTIONS(3456),
  },
  [397] = {
    [sym_identifier] = ACTIONS(2554),
    [aux_sym_preproc_include_token1] = ACTIONS(2554),
    [aux_sym_preproc_def_token1] = ACTIONS(2554),
    [aux_sym_preproc_if_token1] = ACTIONS(2554),
    [aux_sym_preproc_if_token2] = ACTIONS(2554),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2554),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2554),
    [aux_sym_preproc_else_token1] = ACTIONS(2554),
    [aux_sym_preproc_elif_token1] = ACTIONS(2554),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2554),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2554),
    [sym_preproc_directive] = ACTIONS(2554),
    [anon_sym_LPAREN2] = ACTIONS(2552),
    [anon_sym_BANG] = ACTIONS(2552),
    [anon_sym_TILDE] = ACTIONS(2552),
    [anon_sym_DASH] = ACTIONS(2554),
    [anon_sym_PLUS] = ACTIONS(2554),
    [anon_sym_STAR] = ACTIONS(2552),
    [anon_sym_AMP_AMP] = ACTIONS(2552),
    [anon_sym_AMP] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym___extension__] = ACTIONS(2554),
    [anon_sym_typedef] = ACTIONS(2554),
    [anon_sym_in] = ACTIONS(2554),
    [anon_sym_out] = ACTIONS(2554),
    [anon_sym_inout] = ACTIONS(2554),
    [anon_sym_virtual] = ACTIONS(2554),
    [anon_sym_extern] = ACTIONS(2554),
    [anon_sym___attribute__] = ACTIONS(2554),
    [anon_sym___attribute] = ACTIONS(2554),
    [anon_sym_using] = ACTIONS(2554),
    [anon_sym_COLON_COLON] = ACTIONS(2552),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2552),
    [anon_sym___declspec] = ACTIONS(2554),
    [anon_sym___based] = ACTIONS(2554),
    [anon_sym___cdecl] = ACTIONS(2554),
    [anon_sym___clrcall] = ACTIONS(2554),
    [anon_sym___stdcall] = ACTIONS(2554),
    [anon_sym___fastcall] = ACTIONS(2554),
    [anon_sym___thiscall] = ACTIONS(2554),
    [anon_sym___vectorcall] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(2552),
    [anon_sym_signed] = ACTIONS(2554),
    [anon_sym_unsigned] = ACTIONS(2554),
    [anon_sym_long] = ACTIONS(2554),
    [anon_sym_short] = ACTIONS(2554),
    [anon_sym_LBRACK] = ACTIONS(2554),
    [anon_sym_static] = ACTIONS(2554),
    [anon_sym_register] = ACTIONS(2554),
    [anon_sym_inline] = ACTIONS(2554),
    [anon_sym___inline] = ACTIONS(2554),
    [anon_sym___inline__] = ACTIONS(2554),
    [anon_sym___forceinline] = ACTIONS(2554),
    [anon_sym_thread_local] = ACTIONS(2554),
    [anon_sym___thread] = ACTIONS(2554),
    [anon_sym_const] = ACTIONS(2554),
    [anon_sym_constexpr] = ACTIONS(2554),
    [anon_sym_volatile] = ACTIONS(2554),
    [anon_sym_restrict] = ACTIONS(2554),
    [anon_sym___restrict__] = ACTIONS(2554),
    [anon_sym__Atomic] = ACTIONS(2554),
    [anon_sym__Noreturn] = ACTIONS(2554),
    [anon_sym_noreturn] = ACTIONS(2554),
    [anon_sym__Nonnull] = ACTIONS(2554),
    [anon_sym_mutable] = ACTIONS(2554),
    [anon_sym_constinit] = ACTIONS(2554),
    [anon_sym_consteval] = ACTIONS(2554),
    [anon_sym_alignas] = ACTIONS(2554),
    [anon_sym__Alignas] = ACTIONS(2554),
    [sym_primitive_type] = ACTIONS(2554),
    [anon_sym_enum] = ACTIONS(2554),
    [anon_sym_class] = ACTIONS(2554),
    [anon_sym_struct] = ACTIONS(2554),
    [anon_sym_union] = ACTIONS(2554),
    [anon_sym_if] = ACTIONS(2554),
    [anon_sym_else] = ACTIONS(2554),
    [anon_sym_switch] = ACTIONS(2554),
    [anon_sym_case] = ACTIONS(2554),
    [anon_sym_default] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2554),
    [anon_sym_do] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2554),
    [anon_sym_return] = ACTIONS(2554),
    [anon_sym_break] = ACTIONS(2554),
    [anon_sym_continue] = ACTIONS(2554),
    [anon_sym_goto] = ACTIONS(2554),
    [anon_sym___try] = ACTIONS(2554),
    [anon_sym___leave] = ACTIONS(2554),
    [anon_sym_not] = ACTIONS(2554),
    [anon_sym_compl] = ACTIONS(2554),
    [anon_sym_DASH_DASH] = ACTIONS(2552),
    [anon_sym_PLUS_PLUS] = ACTIONS(2552),
    [anon_sym_sizeof] = ACTIONS(2554),
    [anon_sym___alignof__] = ACTIONS(2554),
    [anon_sym___alignof] = ACTIONS(2554),
    [anon_sym__alignof] = ACTIONS(2554),
    [anon_sym_alignof] = ACTIONS(2554),
    [anon_sym__Alignof] = ACTIONS(2554),
    [anon_sym_offsetof] = ACTIONS(2554),
    [anon_sym__Generic] = ACTIONS(2554),
    [anon_sym_asm] = ACTIONS(2554),
    [anon_sym___asm__] = ACTIONS(2554),
    [anon_sym___asm] = ACTIONS(2554),
    [sym_number_literal] = ACTIONS(2552),
    [anon_sym_L_SQUOTE] = ACTIONS(2552),
    [anon_sym_u_SQUOTE] = ACTIONS(2552),
    [anon_sym_U_SQUOTE] = ACTIONS(2552),
    [anon_sym_u8_SQUOTE] = ACTIONS(2552),
    [anon_sym_SQUOTE] = ACTIONS(2552),
    [anon_sym_L_DQUOTE] = ACTIONS(2552),
    [anon_sym_u_DQUOTE] = ACTIONS(2552),
    [anon_sym_U_DQUOTE] = ACTIONS(2552),
    [anon_sym_u8_DQUOTE] = ACTIONS(2552),
    [anon_sym_DQUOTE] = ACTIONS(2552),
    [sym_true] = ACTIONS(2554),
    [sym_false] = ACTIONS(2554),
    [anon_sym_NULL] = ACTIONS(2554),
    [anon_sym_nullptr] = ACTIONS(2554),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2554),
    [anon_sym_let] = ACTIONS(2554),
    [anon_sym_This] = ACTIONS(2554),
    [anon_sym_decltype] = ACTIONS(2554),
    [anon_sym_explicit] = ACTIONS(2554),
    [anon_sym_typename] = ACTIONS(2554),
    [anon_sym_template] = ACTIONS(2554),
    [anon_sym_operator] = ACTIONS(2554),
    [anon_sym_try] = ACTIONS(2554),
    [anon_sym_delete] = ACTIONS(2554),
    [anon_sym_throw] = ACTIONS(2554),
    [anon_sym_namespace] = ACTIONS(2554),
    [anon_sym_static_assert] = ACTIONS(2554),
    [anon_sym_concept] = ACTIONS(2554),
    [anon_sym_co_return] = ACTIONS(2554),
    [anon_sym_co_yield] = ACTIONS(2554),
    [anon_sym_R_DQUOTE] = ACTIONS(2552),
    [anon_sym_LR_DQUOTE] = ACTIONS(2552),
    [anon_sym_uR_DQUOTE] = ACTIONS(2552),
    [anon_sym_UR_DQUOTE] = ACTIONS(2552),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2552),
    [anon_sym_co_await] = ACTIONS(2554),
    [anon_sym_new] = ACTIONS(2554),
    [anon_sym_requires] = ACTIONS(2554),
    [sym_this] = ACTIONS(2554),
    [anon_sym_discard] = ACTIONS(2554),
    [anon_sym_precise] = ACTIONS(2554),
    [anon_sym_shared] = ACTIONS(2554),
    [anon_sym_groupshared] = ACTIONS(2554),
    [anon_sym_uniform] = ACTIONS(2554),
    [anon_sym_row_major] = ACTIONS(2554),
    [anon_sym_column_major] = ACTIONS(2554),
    [anon_sym_globallycoherent] = ACTIONS(2554),
    [anon_sym_centroid] = ACTIONS(2554),
    [anon_sym_noperspective] = ACTIONS(2554),
    [anon_sym_nointerpolation] = ACTIONS(2554),
    [anon_sym_sample] = ACTIONS(2554),
    [anon_sym_linear] = ACTIONS(2554),
    [anon_sym_snorm] = ACTIONS(2554),
    [anon_sym_unorm] = ACTIONS(2554),
    [anon_sym_point] = ACTIONS(2554),
    [anon_sym_line] = ACTIONS(2554),
    [anon_sym_triangleadj] = ACTIONS(2554),
    [anon_sym_lineadj] = ACTIONS(2554),
    [anon_sym_triangle] = ACTIONS(2554),
    [anon_sym_cbuffer] = ACTIONS(2554),
    [anon_sym_interface] = ACTIONS(2554),
    [anon_sym_extension] = ACTIONS(2554),
  },
  [398] = {
    [sym_identifier] = ACTIONS(2428),
    [aux_sym_preproc_include_token1] = ACTIONS(2428),
    [aux_sym_preproc_def_token1] = ACTIONS(2428),
    [aux_sym_preproc_if_token1] = ACTIONS(2428),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2428),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2428),
    [sym_preproc_directive] = ACTIONS(2428),
    [anon_sym_LPAREN2] = ACTIONS(2426),
    [anon_sym_BANG] = ACTIONS(2426),
    [anon_sym_TILDE] = ACTIONS(2426),
    [anon_sym_DASH] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2428),
    [anon_sym_STAR] = ACTIONS(2426),
    [anon_sym_AMP_AMP] = ACTIONS(2426),
    [anon_sym_AMP] = ACTIONS(2428),
    [anon_sym_COLON] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2426),
    [anon_sym___extension__] = ACTIONS(2428),
    [anon_sym_typedef] = ACTIONS(2428),
    [anon_sym_in] = ACTIONS(2428),
    [anon_sym_out] = ACTIONS(2428),
    [anon_sym_inout] = ACTIONS(2428),
    [anon_sym_virtual] = ACTIONS(2428),
    [anon_sym_extern] = ACTIONS(2428),
    [anon_sym___attribute__] = ACTIONS(2428),
    [anon_sym___attribute] = ACTIONS(2428),
    [anon_sym_using] = ACTIONS(2428),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2426),
    [anon_sym___declspec] = ACTIONS(2428),
    [anon_sym___based] = ACTIONS(2428),
    [anon_sym___cdecl] = ACTIONS(2428),
    [anon_sym___clrcall] = ACTIONS(2428),
    [anon_sym___stdcall] = ACTIONS(2428),
    [anon_sym___fastcall] = ACTIONS(2428),
    [anon_sym___thiscall] = ACTIONS(2428),
    [anon_sym___vectorcall] = ACTIONS(2428),
    [anon_sym_LBRACE] = ACTIONS(2426),
    [anon_sym_RBRACE] = ACTIONS(2426),
    [anon_sym_signed] = ACTIONS(2428),
    [anon_sym_unsigned] = ACTIONS(2428),
    [anon_sym_long] = ACTIONS(2428),
    [anon_sym_short] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_static] = ACTIONS(2428),
    [anon_sym_register] = ACTIONS(2428),
    [anon_sym_inline] = ACTIONS(2428),
    [anon_sym___inline] = ACTIONS(2428),
    [anon_sym___inline__] = ACTIONS(2428),
    [anon_sym___forceinline] = ACTIONS(2428),
    [anon_sym_thread_local] = ACTIONS(2428),
    [anon_sym___thread] = ACTIONS(2428),
    [anon_sym_const] = ACTIONS(2428),
    [anon_sym_constexpr] = ACTIONS(2428),
    [anon_sym_volatile] = ACTIONS(2428),
    [anon_sym_restrict] = ACTIONS(2428),
    [anon_sym___restrict__] = ACTIONS(2428),
    [anon_sym__Atomic] = ACTIONS(2428),
    [anon_sym__Noreturn] = ACTIONS(2428),
    [anon_sym_noreturn] = ACTIONS(2428),
    [anon_sym__Nonnull] = ACTIONS(2428),
    [anon_sym_mutable] = ACTIONS(2428),
    [anon_sym_constinit] = ACTIONS(2428),
    [anon_sym_consteval] = ACTIONS(2428),
    [anon_sym_alignas] = ACTIONS(2428),
    [anon_sym__Alignas] = ACTIONS(2428),
    [sym_primitive_type] = ACTIONS(2428),
    [anon_sym_enum] = ACTIONS(2428),
    [anon_sym_class] = ACTIONS(2428),
    [anon_sym_struct] = ACTIONS(2428),
    [anon_sym_union] = ACTIONS(2428),
    [anon_sym_if] = ACTIONS(2428),
    [anon_sym_else] = ACTIONS(2428),
    [anon_sym_switch] = ACTIONS(2428),
    [anon_sym_case] = ACTIONS(2428),
    [anon_sym_default] = ACTIONS(2428),
    [anon_sym_while] = ACTIONS(2428),
    [anon_sym_do] = ACTIONS(2428),
    [anon_sym_for] = ACTIONS(2428),
    [anon_sym_return] = ACTIONS(2428),
    [anon_sym_break] = ACTIONS(2428),
    [anon_sym_continue] = ACTIONS(2428),
    [anon_sym_goto] = ACTIONS(2428),
    [anon_sym___try] = ACTIONS(2428),
    [anon_sym___leave] = ACTIONS(2428),
    [anon_sym_not] = ACTIONS(2428),
    [anon_sym_compl] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2426),
    [anon_sym_PLUS_PLUS] = ACTIONS(2426),
    [anon_sym_sizeof] = ACTIONS(2428),
    [anon_sym___alignof__] = ACTIONS(2428),
    [anon_sym___alignof] = ACTIONS(2428),
    [anon_sym__alignof] = ACTIONS(2428),
    [anon_sym_alignof] = ACTIONS(2428),
    [anon_sym__Alignof] = ACTIONS(2428),
    [anon_sym_offsetof] = ACTIONS(2428),
    [anon_sym__Generic] = ACTIONS(2428),
    [anon_sym_asm] = ACTIONS(2428),
    [anon_sym___asm__] = ACTIONS(2428),
    [anon_sym___asm] = ACTIONS(2428),
    [anon_sym_DOT] = ACTIONS(2428),
    [sym_number_literal] = ACTIONS(2426),
    [anon_sym_L_SQUOTE] = ACTIONS(2426),
    [anon_sym_u_SQUOTE] = ACTIONS(2426),
    [anon_sym_U_SQUOTE] = ACTIONS(2426),
    [anon_sym_u8_SQUOTE] = ACTIONS(2426),
    [anon_sym_SQUOTE] = ACTIONS(2426),
    [anon_sym_L_DQUOTE] = ACTIONS(2426),
    [anon_sym_u_DQUOTE] = ACTIONS(2426),
    [anon_sym_U_DQUOTE] = ACTIONS(2426),
    [anon_sym_u8_DQUOTE] = ACTIONS(2426),
    [anon_sym_DQUOTE] = ACTIONS(2426),
    [sym_true] = ACTIONS(2428),
    [sym_false] = ACTIONS(2428),
    [anon_sym_NULL] = ACTIONS(2428),
    [anon_sym_nullptr] = ACTIONS(2428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2428),
    [anon_sym_let] = ACTIONS(2428),
    [anon_sym_This] = ACTIONS(2428),
    [anon_sym_decltype] = ACTIONS(2428),
    [anon_sym_final] = ACTIONS(2428),
    [anon_sym_override] = ACTIONS(2428),
    [anon_sym_explicit] = ACTIONS(2428),
    [anon_sym_typename] = ACTIONS(2428),
    [anon_sym_template] = ACTIONS(2428),
    [anon_sym_operator] = ACTIONS(2428),
    [anon_sym_try] = ACTIONS(2428),
    [anon_sym_delete] = ACTIONS(2428),
    [anon_sym_throw] = ACTIONS(2428),
    [anon_sym_namespace] = ACTIONS(2428),
    [anon_sym_static_assert] = ACTIONS(2428),
    [anon_sym_concept] = ACTIONS(2428),
    [anon_sym_co_return] = ACTIONS(2428),
    [anon_sym_co_yield] = ACTIONS(2428),
    [anon_sym_R_DQUOTE] = ACTIONS(2426),
    [anon_sym_LR_DQUOTE] = ACTIONS(2426),
    [anon_sym_uR_DQUOTE] = ACTIONS(2426),
    [anon_sym_UR_DQUOTE] = ACTIONS(2426),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2426),
    [anon_sym_co_await] = ACTIONS(2428),
    [anon_sym_new] = ACTIONS(2428),
    [anon_sym_requires] = ACTIONS(2428),
    [sym_this] = ACTIONS(2428),
    [anon_sym_discard] = ACTIONS(2428),
    [anon_sym_precise] = ACTIONS(2428),
    [anon_sym_shared] = ACTIONS(2428),
    [anon_sym_groupshared] = ACTIONS(2428),
    [anon_sym_uniform] = ACTIONS(2428),
    [anon_sym_row_major] = ACTIONS(2428),
    [anon_sym_column_major] = ACTIONS(2428),
    [anon_sym_globallycoherent] = ACTIONS(2428),
    [anon_sym_centroid] = ACTIONS(2428),
    [anon_sym_noperspective] = ACTIONS(2428),
    [anon_sym_nointerpolation] = ACTIONS(2428),
    [anon_sym_sample] = ACTIONS(2428),
    [anon_sym_linear] = ACTIONS(2428),
    [anon_sym_snorm] = ACTIONS(2428),
    [anon_sym_unorm] = ACTIONS(2428),
    [anon_sym_point] = ACTIONS(2428),
    [anon_sym_line] = ACTIONS(2428),
    [anon_sym_triangleadj] = ACTIONS(2428),
    [anon_sym_lineadj] = ACTIONS(2428),
    [anon_sym_triangle] = ACTIONS(2428),
    [anon_sym_cbuffer] = ACTIONS(2428),
    [anon_sym_interface] = ACTIONS(2428),
    [anon_sym_extension] = ACTIONS(2428),
  },
  [399] = {
    [sym_identifier] = ACTIONS(2422),
    [aux_sym_preproc_include_token1] = ACTIONS(2422),
    [aux_sym_preproc_def_token1] = ACTIONS(2422),
    [aux_sym_preproc_if_token1] = ACTIONS(2422),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2422),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2422),
    [sym_preproc_directive] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym_typedef] = ACTIONS(2422),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_out] = ACTIONS(2422),
    [anon_sym_inout] = ACTIONS(2422),
    [anon_sym_virtual] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_using] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2422),
    [anon_sym___based] = ACTIONS(2422),
    [anon_sym___cdecl] = ACTIONS(2422),
    [anon_sym___clrcall] = ACTIONS(2422),
    [anon_sym___stdcall] = ACTIONS(2422),
    [anon_sym___fastcall] = ACTIONS(2422),
    [anon_sym___thiscall] = ACTIONS(2422),
    [anon_sym___vectorcall] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2422),
    [anon_sym_unsigned] = ACTIONS(2422),
    [anon_sym_long] = ACTIONS(2422),
    [anon_sym_short] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_register] = ACTIONS(2422),
    [anon_sym_inline] = ACTIONS(2422),
    [anon_sym___inline] = ACTIONS(2422),
    [anon_sym___inline__] = ACTIONS(2422),
    [anon_sym___forceinline] = ACTIONS(2422),
    [anon_sym_thread_local] = ACTIONS(2422),
    [anon_sym___thread] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [sym_primitive_type] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
    [anon_sym_class] = ACTIONS(2422),
    [anon_sym_struct] = ACTIONS(2422),
    [anon_sym_union] = ACTIONS(2422),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(2422),
    [anon_sym_switch] = ACTIONS(2422),
    [anon_sym_case] = ACTIONS(2422),
    [anon_sym_default] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_break] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(2422),
    [anon_sym_goto] = ACTIONS(2422),
    [anon_sym___try] = ACTIONS(2422),
    [anon_sym___leave] = ACTIONS(2422),
    [anon_sym_not] = ACTIONS(2422),
    [anon_sym_compl] = ACTIONS(2422),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_sizeof] = ACTIONS(2422),
    [anon_sym___alignof__] = ACTIONS(2422),
    [anon_sym___alignof] = ACTIONS(2422),
    [anon_sym__alignof] = ACTIONS(2422),
    [anon_sym_alignof] = ACTIONS(2422),
    [anon_sym__Alignof] = ACTIONS(2422),
    [anon_sym_offsetof] = ACTIONS(2422),
    [anon_sym__Generic] = ACTIONS(2422),
    [anon_sym_asm] = ACTIONS(2422),
    [anon_sym___asm__] = ACTIONS(2422),
    [anon_sym___asm] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2422),
    [sym_number_literal] = ACTIONS(2420),
    [anon_sym_L_SQUOTE] = ACTIONS(2420),
    [anon_sym_u_SQUOTE] = ACTIONS(2420),
    [anon_sym_U_SQUOTE] = ACTIONS(2420),
    [anon_sym_u8_SQUOTE] = ACTIONS(2420),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [anon_sym_L_DQUOTE] = ACTIONS(2420),
    [anon_sym_u_DQUOTE] = ACTIONS(2420),
    [anon_sym_U_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [sym_true] = ACTIONS(2422),
    [sym_false] = ACTIONS(2422),
    [anon_sym_NULL] = ACTIONS(2422),
    [anon_sym_nullptr] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_decltype] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_explicit] = ACTIONS(2422),
    [anon_sym_typename] = ACTIONS(2422),
    [anon_sym_template] = ACTIONS(2422),
    [anon_sym_operator] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_delete] = ACTIONS(2422),
    [anon_sym_throw] = ACTIONS(2422),
    [anon_sym_namespace] = ACTIONS(2422),
    [anon_sym_static_assert] = ACTIONS(2422),
    [anon_sym_concept] = ACTIONS(2422),
    [anon_sym_co_return] = ACTIONS(2422),
    [anon_sym_co_yield] = ACTIONS(2422),
    [anon_sym_R_DQUOTE] = ACTIONS(2420),
    [anon_sym_LR_DQUOTE] = ACTIONS(2420),
    [anon_sym_uR_DQUOTE] = ACTIONS(2420),
    [anon_sym_UR_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2420),
    [anon_sym_co_await] = ACTIONS(2422),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_requires] = ACTIONS(2422),
    [sym_this] = ACTIONS(2422),
    [anon_sym_discard] = ACTIONS(2422),
    [anon_sym_precise] = ACTIONS(2422),
    [anon_sym_shared] = ACTIONS(2422),
    [anon_sym_groupshared] = ACTIONS(2422),
    [anon_sym_uniform] = ACTIONS(2422),
    [anon_sym_row_major] = ACTIONS(2422),
    [anon_sym_column_major] = ACTIONS(2422),
    [anon_sym_globallycoherent] = ACTIONS(2422),
    [anon_sym_centroid] = ACTIONS(2422),
    [anon_sym_noperspective] = ACTIONS(2422),
    [anon_sym_nointerpolation] = ACTIONS(2422),
    [anon_sym_sample] = ACTIONS(2422),
    [anon_sym_linear] = ACTIONS(2422),
    [anon_sym_snorm] = ACTIONS(2422),
    [anon_sym_unorm] = ACTIONS(2422),
    [anon_sym_point] = ACTIONS(2422),
    [anon_sym_line] = ACTIONS(2422),
    [anon_sym_triangleadj] = ACTIONS(2422),
    [anon_sym_lineadj] = ACTIONS(2422),
    [anon_sym_triangle] = ACTIONS(2422),
    [anon_sym_cbuffer] = ACTIONS(2422),
    [anon_sym_interface] = ACTIONS(2422),
    [anon_sym_extension] = ACTIONS(2422),
  },
  [400] = {
    [sym_identifier] = ACTIONS(2422),
    [aux_sym_preproc_include_token1] = ACTIONS(2422),
    [aux_sym_preproc_def_token1] = ACTIONS(2422),
    [aux_sym_preproc_if_token1] = ACTIONS(2422),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2422),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2422),
    [sym_preproc_directive] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym_typedef] = ACTIONS(2422),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_out] = ACTIONS(2422),
    [anon_sym_inout] = ACTIONS(2422),
    [anon_sym_virtual] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_using] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2422),
    [anon_sym___based] = ACTIONS(2422),
    [anon_sym___cdecl] = ACTIONS(2422),
    [anon_sym___clrcall] = ACTIONS(2422),
    [anon_sym___stdcall] = ACTIONS(2422),
    [anon_sym___fastcall] = ACTIONS(2422),
    [anon_sym___thiscall] = ACTIONS(2422),
    [anon_sym___vectorcall] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2422),
    [anon_sym_unsigned] = ACTIONS(2422),
    [anon_sym_long] = ACTIONS(2422),
    [anon_sym_short] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_register] = ACTIONS(2422),
    [anon_sym_inline] = ACTIONS(2422),
    [anon_sym___inline] = ACTIONS(2422),
    [anon_sym___inline__] = ACTIONS(2422),
    [anon_sym___forceinline] = ACTIONS(2422),
    [anon_sym_thread_local] = ACTIONS(2422),
    [anon_sym___thread] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [sym_primitive_type] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
    [anon_sym_class] = ACTIONS(2422),
    [anon_sym_struct] = ACTIONS(2422),
    [anon_sym_union] = ACTIONS(2422),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(2422),
    [anon_sym_switch] = ACTIONS(2422),
    [anon_sym_case] = ACTIONS(2422),
    [anon_sym_default] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_break] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(2422),
    [anon_sym_goto] = ACTIONS(2422),
    [anon_sym___try] = ACTIONS(2422),
    [anon_sym___leave] = ACTIONS(2422),
    [anon_sym_not] = ACTIONS(2422),
    [anon_sym_compl] = ACTIONS(2422),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_sizeof] = ACTIONS(2422),
    [anon_sym___alignof__] = ACTIONS(2422),
    [anon_sym___alignof] = ACTIONS(2422),
    [anon_sym__alignof] = ACTIONS(2422),
    [anon_sym_alignof] = ACTIONS(2422),
    [anon_sym__Alignof] = ACTIONS(2422),
    [anon_sym_offsetof] = ACTIONS(2422),
    [anon_sym__Generic] = ACTIONS(2422),
    [anon_sym_asm] = ACTIONS(2422),
    [anon_sym___asm__] = ACTIONS(2422),
    [anon_sym___asm] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2422),
    [sym_number_literal] = ACTIONS(2420),
    [anon_sym_L_SQUOTE] = ACTIONS(2420),
    [anon_sym_u_SQUOTE] = ACTIONS(2420),
    [anon_sym_U_SQUOTE] = ACTIONS(2420),
    [anon_sym_u8_SQUOTE] = ACTIONS(2420),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [anon_sym_L_DQUOTE] = ACTIONS(2420),
    [anon_sym_u_DQUOTE] = ACTIONS(2420),
    [anon_sym_U_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [sym_true] = ACTIONS(2422),
    [sym_false] = ACTIONS(2422),
    [anon_sym_NULL] = ACTIONS(2422),
    [anon_sym_nullptr] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_decltype] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_explicit] = ACTIONS(2422),
    [anon_sym_typename] = ACTIONS(2422),
    [anon_sym_template] = ACTIONS(2422),
    [anon_sym_operator] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_delete] = ACTIONS(2422),
    [anon_sym_throw] = ACTIONS(2422),
    [anon_sym_namespace] = ACTIONS(2422),
    [anon_sym_static_assert] = ACTIONS(2422),
    [anon_sym_concept] = ACTIONS(2422),
    [anon_sym_co_return] = ACTIONS(2422),
    [anon_sym_co_yield] = ACTIONS(2422),
    [anon_sym_R_DQUOTE] = ACTIONS(2420),
    [anon_sym_LR_DQUOTE] = ACTIONS(2420),
    [anon_sym_uR_DQUOTE] = ACTIONS(2420),
    [anon_sym_UR_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2420),
    [anon_sym_co_await] = ACTIONS(2422),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_requires] = ACTIONS(2422),
    [sym_this] = ACTIONS(2422),
    [anon_sym_discard] = ACTIONS(2422),
    [anon_sym_precise] = ACTIONS(2422),
    [anon_sym_shared] = ACTIONS(2422),
    [anon_sym_groupshared] = ACTIONS(2422),
    [anon_sym_uniform] = ACTIONS(2422),
    [anon_sym_row_major] = ACTIONS(2422),
    [anon_sym_column_major] = ACTIONS(2422),
    [anon_sym_globallycoherent] = ACTIONS(2422),
    [anon_sym_centroid] = ACTIONS(2422),
    [anon_sym_noperspective] = ACTIONS(2422),
    [anon_sym_nointerpolation] = ACTIONS(2422),
    [anon_sym_sample] = ACTIONS(2422),
    [anon_sym_linear] = ACTIONS(2422),
    [anon_sym_snorm] = ACTIONS(2422),
    [anon_sym_unorm] = ACTIONS(2422),
    [anon_sym_point] = ACTIONS(2422),
    [anon_sym_line] = ACTIONS(2422),
    [anon_sym_triangleadj] = ACTIONS(2422),
    [anon_sym_lineadj] = ACTIONS(2422),
    [anon_sym_triangle] = ACTIONS(2422),
    [anon_sym_cbuffer] = ACTIONS(2422),
    [anon_sym_interface] = ACTIONS(2422),
    [anon_sym_extension] = ACTIONS(2422),
  },
  [401] = {
    [sym_identifier] = ACTIONS(2422),
    [aux_sym_preproc_include_token1] = ACTIONS(2422),
    [aux_sym_preproc_def_token1] = ACTIONS(2422),
    [aux_sym_preproc_if_token1] = ACTIONS(2422),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2422),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2422),
    [sym_preproc_directive] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym_typedef] = ACTIONS(2422),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_out] = ACTIONS(2422),
    [anon_sym_inout] = ACTIONS(2422),
    [anon_sym_virtual] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_using] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2422),
    [anon_sym___based] = ACTIONS(2422),
    [anon_sym___cdecl] = ACTIONS(2422),
    [anon_sym___clrcall] = ACTIONS(2422),
    [anon_sym___stdcall] = ACTIONS(2422),
    [anon_sym___fastcall] = ACTIONS(2422),
    [anon_sym___thiscall] = ACTIONS(2422),
    [anon_sym___vectorcall] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2422),
    [anon_sym_unsigned] = ACTIONS(2422),
    [anon_sym_long] = ACTIONS(2422),
    [anon_sym_short] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_register] = ACTIONS(2422),
    [anon_sym_inline] = ACTIONS(2422),
    [anon_sym___inline] = ACTIONS(2422),
    [anon_sym___inline__] = ACTIONS(2422),
    [anon_sym___forceinline] = ACTIONS(2422),
    [anon_sym_thread_local] = ACTIONS(2422),
    [anon_sym___thread] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [sym_primitive_type] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
    [anon_sym_class] = ACTIONS(2422),
    [anon_sym_struct] = ACTIONS(2422),
    [anon_sym_union] = ACTIONS(2422),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(2422),
    [anon_sym_switch] = ACTIONS(2422),
    [anon_sym_case] = ACTIONS(2422),
    [anon_sym_default] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_break] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(2422),
    [anon_sym_goto] = ACTIONS(2422),
    [anon_sym___try] = ACTIONS(2422),
    [anon_sym___leave] = ACTIONS(2422),
    [anon_sym_not] = ACTIONS(2422),
    [anon_sym_compl] = ACTIONS(2422),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_sizeof] = ACTIONS(2422),
    [anon_sym___alignof__] = ACTIONS(2422),
    [anon_sym___alignof] = ACTIONS(2422),
    [anon_sym__alignof] = ACTIONS(2422),
    [anon_sym_alignof] = ACTIONS(2422),
    [anon_sym__Alignof] = ACTIONS(2422),
    [anon_sym_offsetof] = ACTIONS(2422),
    [anon_sym__Generic] = ACTIONS(2422),
    [anon_sym_asm] = ACTIONS(2422),
    [anon_sym___asm__] = ACTIONS(2422),
    [anon_sym___asm] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2422),
    [sym_number_literal] = ACTIONS(2420),
    [anon_sym_L_SQUOTE] = ACTIONS(2420),
    [anon_sym_u_SQUOTE] = ACTIONS(2420),
    [anon_sym_U_SQUOTE] = ACTIONS(2420),
    [anon_sym_u8_SQUOTE] = ACTIONS(2420),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [anon_sym_L_DQUOTE] = ACTIONS(2420),
    [anon_sym_u_DQUOTE] = ACTIONS(2420),
    [anon_sym_U_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [sym_true] = ACTIONS(2422),
    [sym_false] = ACTIONS(2422),
    [anon_sym_NULL] = ACTIONS(2422),
    [anon_sym_nullptr] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_decltype] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_explicit] = ACTIONS(2422),
    [anon_sym_typename] = ACTIONS(2422),
    [anon_sym_template] = ACTIONS(2422),
    [anon_sym_operator] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_delete] = ACTIONS(2422),
    [anon_sym_throw] = ACTIONS(2422),
    [anon_sym_namespace] = ACTIONS(2422),
    [anon_sym_static_assert] = ACTIONS(2422),
    [anon_sym_concept] = ACTIONS(2422),
    [anon_sym_co_return] = ACTIONS(2422),
    [anon_sym_co_yield] = ACTIONS(2422),
    [anon_sym_R_DQUOTE] = ACTIONS(2420),
    [anon_sym_LR_DQUOTE] = ACTIONS(2420),
    [anon_sym_uR_DQUOTE] = ACTIONS(2420),
    [anon_sym_UR_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2420),
    [anon_sym_co_await] = ACTIONS(2422),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_requires] = ACTIONS(2422),
    [sym_this] = ACTIONS(2422),
    [anon_sym_discard] = ACTIONS(2422),
    [anon_sym_precise] = ACTIONS(2422),
    [anon_sym_shared] = ACTIONS(2422),
    [anon_sym_groupshared] = ACTIONS(2422),
    [anon_sym_uniform] = ACTIONS(2422),
    [anon_sym_row_major] = ACTIONS(2422),
    [anon_sym_column_major] = ACTIONS(2422),
    [anon_sym_globallycoherent] = ACTIONS(2422),
    [anon_sym_centroid] = ACTIONS(2422),
    [anon_sym_noperspective] = ACTIONS(2422),
    [anon_sym_nointerpolation] = ACTIONS(2422),
    [anon_sym_sample] = ACTIONS(2422),
    [anon_sym_linear] = ACTIONS(2422),
    [anon_sym_snorm] = ACTIONS(2422),
    [anon_sym_unorm] = ACTIONS(2422),
    [anon_sym_point] = ACTIONS(2422),
    [anon_sym_line] = ACTIONS(2422),
    [anon_sym_triangleadj] = ACTIONS(2422),
    [anon_sym_lineadj] = ACTIONS(2422),
    [anon_sym_triangle] = ACTIONS(2422),
    [anon_sym_cbuffer] = ACTIONS(2422),
    [anon_sym_interface] = ACTIONS(2422),
    [anon_sym_extension] = ACTIONS(2422),
  },
  [402] = {
    [sym_identifier] = ACTIONS(2418),
    [aux_sym_preproc_include_token1] = ACTIONS(2418),
    [aux_sym_preproc_def_token1] = ACTIONS(2418),
    [aux_sym_preproc_if_token1] = ACTIONS(2418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2418),
    [sym_preproc_directive] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2416),
    [anon_sym_TILDE] = ACTIONS(2416),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym___extension__] = ACTIONS(2418),
    [anon_sym_typedef] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(2418),
    [anon_sym_out] = ACTIONS(2418),
    [anon_sym_inout] = ACTIONS(2418),
    [anon_sym_virtual] = ACTIONS(2418),
    [anon_sym_extern] = ACTIONS(2418),
    [anon_sym___attribute__] = ACTIONS(2418),
    [anon_sym___attribute] = ACTIONS(2418),
    [anon_sym_using] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2416),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2416),
    [anon_sym___declspec] = ACTIONS(2418),
    [anon_sym___based] = ACTIONS(2418),
    [anon_sym___cdecl] = ACTIONS(2418),
    [anon_sym___clrcall] = ACTIONS(2418),
    [anon_sym___stdcall] = ACTIONS(2418),
    [anon_sym___fastcall] = ACTIONS(2418),
    [anon_sym___thiscall] = ACTIONS(2418),
    [anon_sym___vectorcall] = ACTIONS(2418),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_RBRACE] = ACTIONS(2416),
    [anon_sym_signed] = ACTIONS(2418),
    [anon_sym_unsigned] = ACTIONS(2418),
    [anon_sym_long] = ACTIONS(2418),
    [anon_sym_short] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2418),
    [anon_sym_register] = ACTIONS(2418),
    [anon_sym_inline] = ACTIONS(2418),
    [anon_sym___inline] = ACTIONS(2418),
    [anon_sym___inline__] = ACTIONS(2418),
    [anon_sym___forceinline] = ACTIONS(2418),
    [anon_sym_thread_local] = ACTIONS(2418),
    [anon_sym___thread] = ACTIONS(2418),
    [anon_sym_const] = ACTIONS(2418),
    [anon_sym_constexpr] = ACTIONS(2418),
    [anon_sym_volatile] = ACTIONS(2418),
    [anon_sym_restrict] = ACTIONS(2418),
    [anon_sym___restrict__] = ACTIONS(2418),
    [anon_sym__Atomic] = ACTIONS(2418),
    [anon_sym__Noreturn] = ACTIONS(2418),
    [anon_sym_noreturn] = ACTIONS(2418),
    [anon_sym__Nonnull] = ACTIONS(2418),
    [anon_sym_mutable] = ACTIONS(2418),
    [anon_sym_constinit] = ACTIONS(2418),
    [anon_sym_consteval] = ACTIONS(2418),
    [anon_sym_alignas] = ACTIONS(2418),
    [anon_sym__Alignas] = ACTIONS(2418),
    [sym_primitive_type] = ACTIONS(2418),
    [anon_sym_enum] = ACTIONS(2418),
    [anon_sym_class] = ACTIONS(2418),
    [anon_sym_struct] = ACTIONS(2418),
    [anon_sym_union] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_else] = ACTIONS(2418),
    [anon_sym_switch] = ACTIONS(2418),
    [anon_sym_case] = ACTIONS(2418),
    [anon_sym_default] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_break] = ACTIONS(2418),
    [anon_sym_continue] = ACTIONS(2418),
    [anon_sym_goto] = ACTIONS(2418),
    [anon_sym___try] = ACTIONS(2418),
    [anon_sym___leave] = ACTIONS(2418),
    [anon_sym_not] = ACTIONS(2418),
    [anon_sym_compl] = ACTIONS(2418),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_sizeof] = ACTIONS(2418),
    [anon_sym___alignof__] = ACTIONS(2418),
    [anon_sym___alignof] = ACTIONS(2418),
    [anon_sym__alignof] = ACTIONS(2418),
    [anon_sym_alignof] = ACTIONS(2418),
    [anon_sym__Alignof] = ACTIONS(2418),
    [anon_sym_offsetof] = ACTIONS(2418),
    [anon_sym__Generic] = ACTIONS(2418),
    [anon_sym_asm] = ACTIONS(2418),
    [anon_sym___asm__] = ACTIONS(2418),
    [anon_sym___asm] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(2418),
    [sym_number_literal] = ACTIONS(2416),
    [anon_sym_L_SQUOTE] = ACTIONS(2416),
    [anon_sym_u_SQUOTE] = ACTIONS(2416),
    [anon_sym_U_SQUOTE] = ACTIONS(2416),
    [anon_sym_u8_SQUOTE] = ACTIONS(2416),
    [anon_sym_SQUOTE] = ACTIONS(2416),
    [anon_sym_L_DQUOTE] = ACTIONS(2416),
    [anon_sym_u_DQUOTE] = ACTIONS(2416),
    [anon_sym_U_DQUOTE] = ACTIONS(2416),
    [anon_sym_u8_DQUOTE] = ACTIONS(2416),
    [anon_sym_DQUOTE] = ACTIONS(2416),
    [sym_true] = ACTIONS(2418),
    [sym_false] = ACTIONS(2418),
    [anon_sym_NULL] = ACTIONS(2418),
    [anon_sym_nullptr] = ACTIONS(2418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_This] = ACTIONS(2418),
    [anon_sym_decltype] = ACTIONS(2418),
    [anon_sym_final] = ACTIONS(2418),
    [anon_sym_override] = ACTIONS(2418),
    [anon_sym_explicit] = ACTIONS(2418),
    [anon_sym_typename] = ACTIONS(2418),
    [anon_sym_template] = ACTIONS(2418),
    [anon_sym_operator] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_delete] = ACTIONS(2418),
    [anon_sym_throw] = ACTIONS(2418),
    [anon_sym_namespace] = ACTIONS(2418),
    [anon_sym_static_assert] = ACTIONS(2418),
    [anon_sym_concept] = ACTIONS(2418),
    [anon_sym_co_return] = ACTIONS(2418),
    [anon_sym_co_yield] = ACTIONS(2418),
    [anon_sym_R_DQUOTE] = ACTIONS(2416),
    [anon_sym_LR_DQUOTE] = ACTIONS(2416),
    [anon_sym_uR_DQUOTE] = ACTIONS(2416),
    [anon_sym_UR_DQUOTE] = ACTIONS(2416),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2416),
    [anon_sym_co_await] = ACTIONS(2418),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_requires] = ACTIONS(2418),
    [sym_this] = ACTIONS(2418),
    [anon_sym_discard] = ACTIONS(2418),
    [anon_sym_precise] = ACTIONS(2418),
    [anon_sym_shared] = ACTIONS(2418),
    [anon_sym_groupshared] = ACTIONS(2418),
    [anon_sym_uniform] = ACTIONS(2418),
    [anon_sym_row_major] = ACTIONS(2418),
    [anon_sym_column_major] = ACTIONS(2418),
    [anon_sym_globallycoherent] = ACTIONS(2418),
    [anon_sym_centroid] = ACTIONS(2418),
    [anon_sym_noperspective] = ACTIONS(2418),
    [anon_sym_nointerpolation] = ACTIONS(2418),
    [anon_sym_sample] = ACTIONS(2418),
    [anon_sym_linear] = ACTIONS(2418),
    [anon_sym_snorm] = ACTIONS(2418),
    [anon_sym_unorm] = ACTIONS(2418),
    [anon_sym_point] = ACTIONS(2418),
    [anon_sym_line] = ACTIONS(2418),
    [anon_sym_triangleadj] = ACTIONS(2418),
    [anon_sym_lineadj] = ACTIONS(2418),
    [anon_sym_triangle] = ACTIONS(2418),
    [anon_sym_cbuffer] = ACTIONS(2418),
    [anon_sym_interface] = ACTIONS(2418),
    [anon_sym_extension] = ACTIONS(2418),
  },
  [403] = {
    [sym_identifier] = ACTIONS(2243),
    [aux_sym_preproc_include_token1] = ACTIONS(2243),
    [aux_sym_preproc_def_token1] = ACTIONS(2243),
    [aux_sym_preproc_if_token1] = ACTIONS(2243),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2243),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2243),
    [sym_preproc_directive] = ACTIONS(2243),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2243),
    [anon_sym_PLUS] = ACTIONS(2243),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_COLON] = ACTIONS(2243),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym_typedef] = ACTIONS(2243),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_out] = ACTIONS(2243),
    [anon_sym_inout] = ACTIONS(2243),
    [anon_sym_virtual] = ACTIONS(2243),
    [anon_sym_extern] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym___attribute] = ACTIONS(2243),
    [anon_sym_using] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2243),
    [anon_sym___based] = ACTIONS(2243),
    [anon_sym___cdecl] = ACTIONS(2243),
    [anon_sym___clrcall] = ACTIONS(2243),
    [anon_sym___stdcall] = ACTIONS(2243),
    [anon_sym___fastcall] = ACTIONS(2243),
    [anon_sym___thiscall] = ACTIONS(2243),
    [anon_sym___vectorcall] = ACTIONS(2243),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_signed] = ACTIONS(2243),
    [anon_sym_unsigned] = ACTIONS(2243),
    [anon_sym_long] = ACTIONS(2243),
    [anon_sym_short] = ACTIONS(2243),
    [anon_sym_LBRACK] = ACTIONS(2243),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_register] = ACTIONS(2243),
    [anon_sym_inline] = ACTIONS(2243),
    [anon_sym___inline] = ACTIONS(2243),
    [anon_sym___inline__] = ACTIONS(2243),
    [anon_sym___forceinline] = ACTIONS(2243),
    [anon_sym_thread_local] = ACTIONS(2243),
    [anon_sym___thread] = ACTIONS(2243),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym__Nonnull] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [sym_primitive_type] = ACTIONS(2243),
    [anon_sym_enum] = ACTIONS(2243),
    [anon_sym_class] = ACTIONS(2243),
    [anon_sym_struct] = ACTIONS(2243),
    [anon_sym_union] = ACTIONS(2243),
    [anon_sym_if] = ACTIONS(2243),
    [anon_sym_else] = ACTIONS(2243),
    [anon_sym_switch] = ACTIONS(2243),
    [anon_sym_case] = ACTIONS(2243),
    [anon_sym_default] = ACTIONS(2243),
    [anon_sym_while] = ACTIONS(2243),
    [anon_sym_do] = ACTIONS(2243),
    [anon_sym_for] = ACTIONS(2243),
    [anon_sym_return] = ACTIONS(2243),
    [anon_sym_break] = ACTIONS(2243),
    [anon_sym_continue] = ACTIONS(2243),
    [anon_sym_goto] = ACTIONS(2243),
    [anon_sym___try] = ACTIONS(2243),
    [anon_sym___leave] = ACTIONS(2243),
    [anon_sym_not] = ACTIONS(2243),
    [anon_sym_compl] = ACTIONS(2243),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_sizeof] = ACTIONS(2243),
    [anon_sym___alignof__] = ACTIONS(2243),
    [anon_sym___alignof] = ACTIONS(2243),
    [anon_sym__alignof] = ACTIONS(2243),
    [anon_sym_alignof] = ACTIONS(2243),
    [anon_sym__Alignof] = ACTIONS(2243),
    [anon_sym_offsetof] = ACTIONS(2243),
    [anon_sym__Generic] = ACTIONS(2243),
    [anon_sym_asm] = ACTIONS(2243),
    [anon_sym___asm__] = ACTIONS(2243),
    [anon_sym___asm] = ACTIONS(2243),
    [anon_sym_DOT] = ACTIONS(2243),
    [sym_number_literal] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2250),
    [anon_sym_u_SQUOTE] = ACTIONS(2250),
    [anon_sym_U_SQUOTE] = ACTIONS(2250),
    [anon_sym_u8_SQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_L_DQUOTE] = ACTIONS(2250),
    [anon_sym_u_DQUOTE] = ACTIONS(2250),
    [anon_sym_U_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [sym_true] = ACTIONS(2243),
    [sym_false] = ACTIONS(2243),
    [anon_sym_NULL] = ACTIONS(2243),
    [anon_sym_nullptr] = ACTIONS(2243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2243),
    [anon_sym_let] = ACTIONS(2243),
    [anon_sym_This] = ACTIONS(2243),
    [anon_sym_decltype] = ACTIONS(2243),
    [anon_sym_final] = ACTIONS(2243),
    [anon_sym_override] = ACTIONS(2243),
    [anon_sym_explicit] = ACTIONS(2243),
    [anon_sym_typename] = ACTIONS(2243),
    [anon_sym_template] = ACTIONS(2243),
    [anon_sym_operator] = ACTIONS(2243),
    [anon_sym_try] = ACTIONS(2243),
    [anon_sym_delete] = ACTIONS(2243),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_namespace] = ACTIONS(2243),
    [anon_sym_static_assert] = ACTIONS(2243),
    [anon_sym_concept] = ACTIONS(2243),
    [anon_sym_co_return] = ACTIONS(2243),
    [anon_sym_co_yield] = ACTIONS(2243),
    [anon_sym_R_DQUOTE] = ACTIONS(2250),
    [anon_sym_LR_DQUOTE] = ACTIONS(2250),
    [anon_sym_uR_DQUOTE] = ACTIONS(2250),
    [anon_sym_UR_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2250),
    [anon_sym_co_await] = ACTIONS(2243),
    [anon_sym_new] = ACTIONS(2243),
    [anon_sym_requires] = ACTIONS(2243),
    [sym_this] = ACTIONS(2243),
    [anon_sym_discard] = ACTIONS(2243),
    [anon_sym_precise] = ACTIONS(2243),
    [anon_sym_shared] = ACTIONS(2243),
    [anon_sym_groupshared] = ACTIONS(2243),
    [anon_sym_uniform] = ACTIONS(2243),
    [anon_sym_row_major] = ACTIONS(2243),
    [anon_sym_column_major] = ACTIONS(2243),
    [anon_sym_globallycoherent] = ACTIONS(2243),
    [anon_sym_centroid] = ACTIONS(2243),
    [anon_sym_noperspective] = ACTIONS(2243),
    [anon_sym_nointerpolation] = ACTIONS(2243),
    [anon_sym_sample] = ACTIONS(2243),
    [anon_sym_linear] = ACTIONS(2243),
    [anon_sym_snorm] = ACTIONS(2243),
    [anon_sym_unorm] = ACTIONS(2243),
    [anon_sym_point] = ACTIONS(2243),
    [anon_sym_line] = ACTIONS(2243),
    [anon_sym_triangleadj] = ACTIONS(2243),
    [anon_sym_lineadj] = ACTIONS(2243),
    [anon_sym_triangle] = ACTIONS(2243),
    [anon_sym_cbuffer] = ACTIONS(2243),
    [anon_sym_interface] = ACTIONS(2243),
    [anon_sym_extension] = ACTIONS(2243),
  },
  [404] = {
    [ts_builtin_sym_end] = ACTIONS(3458),
    [sym_identifier] = ACTIONS(3460),
    [aux_sym_preproc_include_token1] = ACTIONS(3460),
    [aux_sym_preproc_def_token1] = ACTIONS(3460),
    [aux_sym_preproc_if_token1] = ACTIONS(3460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3460),
    [sym_preproc_directive] = ACTIONS(3460),
    [anon_sym_LPAREN2] = ACTIONS(3458),
    [anon_sym_BANG] = ACTIONS(3458),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3460),
    [anon_sym_PLUS] = ACTIONS(3460),
    [anon_sym_STAR] = ACTIONS(3458),
    [anon_sym_AMP_AMP] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3460),
    [anon_sym_SEMI] = ACTIONS(3458),
    [anon_sym___extension__] = ACTIONS(3460),
    [anon_sym_typedef] = ACTIONS(3460),
    [anon_sym_in] = ACTIONS(3460),
    [anon_sym_out] = ACTIONS(3460),
    [anon_sym_inout] = ACTIONS(3460),
    [anon_sym_virtual] = ACTIONS(3460),
    [anon_sym_extern] = ACTIONS(3460),
    [anon_sym___attribute__] = ACTIONS(3460),
    [anon_sym___attribute] = ACTIONS(3460),
    [anon_sym_using] = ACTIONS(3460),
    [anon_sym_COLON_COLON] = ACTIONS(3458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3458),
    [anon_sym___declspec] = ACTIONS(3460),
    [anon_sym___based] = ACTIONS(3460),
    [anon_sym___cdecl] = ACTIONS(3460),
    [anon_sym___clrcall] = ACTIONS(3460),
    [anon_sym___stdcall] = ACTIONS(3460),
    [anon_sym___fastcall] = ACTIONS(3460),
    [anon_sym___thiscall] = ACTIONS(3460),
    [anon_sym___vectorcall] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(3458),
    [anon_sym_signed] = ACTIONS(3460),
    [anon_sym_unsigned] = ACTIONS(3460),
    [anon_sym_long] = ACTIONS(3460),
    [anon_sym_short] = ACTIONS(3460),
    [anon_sym_LBRACK] = ACTIONS(3460),
    [anon_sym_static] = ACTIONS(3460),
    [anon_sym_register] = ACTIONS(3460),
    [anon_sym_inline] = ACTIONS(3460),
    [anon_sym___inline] = ACTIONS(3460),
    [anon_sym___inline__] = ACTIONS(3460),
    [anon_sym___forceinline] = ACTIONS(3460),
    [anon_sym_thread_local] = ACTIONS(3460),
    [anon_sym___thread] = ACTIONS(3460),
    [anon_sym_const] = ACTIONS(3460),
    [anon_sym_constexpr] = ACTIONS(3460),
    [anon_sym_volatile] = ACTIONS(3460),
    [anon_sym_restrict] = ACTIONS(3460),
    [anon_sym___restrict__] = ACTIONS(3460),
    [anon_sym__Atomic] = ACTIONS(3460),
    [anon_sym__Noreturn] = ACTIONS(3460),
    [anon_sym_noreturn] = ACTIONS(3460),
    [anon_sym__Nonnull] = ACTIONS(3460),
    [anon_sym_mutable] = ACTIONS(3460),
    [anon_sym_constinit] = ACTIONS(3460),
    [anon_sym_consteval] = ACTIONS(3460),
    [anon_sym_alignas] = ACTIONS(3460),
    [anon_sym__Alignas] = ACTIONS(3460),
    [sym_primitive_type] = ACTIONS(3460),
    [anon_sym_enum] = ACTIONS(3460),
    [anon_sym_class] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(3460),
    [anon_sym_union] = ACTIONS(3460),
    [anon_sym_if] = ACTIONS(3460),
    [anon_sym_else] = ACTIONS(3460),
    [anon_sym_switch] = ACTIONS(3460),
    [anon_sym_case] = ACTIONS(3460),
    [anon_sym_default] = ACTIONS(3460),
    [anon_sym_while] = ACTIONS(3460),
    [anon_sym_do] = ACTIONS(3460),
    [anon_sym_for] = ACTIONS(3460),
    [anon_sym_return] = ACTIONS(3460),
    [anon_sym_break] = ACTIONS(3460),
    [anon_sym_continue] = ACTIONS(3460),
    [anon_sym_goto] = ACTIONS(3460),
    [anon_sym___try] = ACTIONS(3460),
    [anon_sym___leave] = ACTIONS(3460),
    [anon_sym_not] = ACTIONS(3460),
    [anon_sym_compl] = ACTIONS(3460),
    [anon_sym_DASH_DASH] = ACTIONS(3458),
    [anon_sym_PLUS_PLUS] = ACTIONS(3458),
    [anon_sym_sizeof] = ACTIONS(3460),
    [anon_sym___alignof__] = ACTIONS(3460),
    [anon_sym___alignof] = ACTIONS(3460),
    [anon_sym__alignof] = ACTIONS(3460),
    [anon_sym_alignof] = ACTIONS(3460),
    [anon_sym__Alignof] = ACTIONS(3460),
    [anon_sym_offsetof] = ACTIONS(3460),
    [anon_sym__Generic] = ACTIONS(3460),
    [anon_sym_asm] = ACTIONS(3460),
    [anon_sym___asm__] = ACTIONS(3460),
    [anon_sym___asm] = ACTIONS(3460),
    [sym_number_literal] = ACTIONS(3458),
    [anon_sym_L_SQUOTE] = ACTIONS(3458),
    [anon_sym_u_SQUOTE] = ACTIONS(3458),
    [anon_sym_U_SQUOTE] = ACTIONS(3458),
    [anon_sym_u8_SQUOTE] = ACTIONS(3458),
    [anon_sym_SQUOTE] = ACTIONS(3458),
    [anon_sym_L_DQUOTE] = ACTIONS(3458),
    [anon_sym_u_DQUOTE] = ACTIONS(3458),
    [anon_sym_U_DQUOTE] = ACTIONS(3458),
    [anon_sym_u8_DQUOTE] = ACTIONS(3458),
    [anon_sym_DQUOTE] = ACTIONS(3458),
    [sym_true] = ACTIONS(3460),
    [sym_false] = ACTIONS(3460),
    [anon_sym_NULL] = ACTIONS(3460),
    [anon_sym_nullptr] = ACTIONS(3460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3460),
    [anon_sym_let] = ACTIONS(3460),
    [anon_sym_This] = ACTIONS(3460),
    [anon_sym_decltype] = ACTIONS(3460),
    [anon_sym_explicit] = ACTIONS(3460),
    [anon_sym_typename] = ACTIONS(3460),
    [anon_sym_export] = ACTIONS(3460),
    [anon_sym_module] = ACTIONS(3460),
    [anon_sym_import] = ACTIONS(3460),
    [anon_sym_template] = ACTIONS(3460),
    [anon_sym_operator] = ACTIONS(3460),
    [anon_sym_try] = ACTIONS(3460),
    [anon_sym_delete] = ACTIONS(3460),
    [anon_sym_throw] = ACTIONS(3460),
    [anon_sym_namespace] = ACTIONS(3460),
    [anon_sym_static_assert] = ACTIONS(3460),
    [anon_sym_concept] = ACTIONS(3460),
    [anon_sym_co_return] = ACTIONS(3460),
    [anon_sym_co_yield] = ACTIONS(3460),
    [anon_sym_R_DQUOTE] = ACTIONS(3458),
    [anon_sym_LR_DQUOTE] = ACTIONS(3458),
    [anon_sym_uR_DQUOTE] = ACTIONS(3458),
    [anon_sym_UR_DQUOTE] = ACTIONS(3458),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3458),
    [anon_sym_co_await] = ACTIONS(3460),
    [anon_sym_new] = ACTIONS(3460),
    [anon_sym_requires] = ACTIONS(3460),
    [sym_this] = ACTIONS(3460),
    [anon_sym_discard] = ACTIONS(3460),
    [anon_sym_precise] = ACTIONS(3460),
    [anon_sym_shared] = ACTIONS(3460),
    [anon_sym_groupshared] = ACTIONS(3460),
    [anon_sym_uniform] = ACTIONS(3460),
    [anon_sym_row_major] = ACTIONS(3460),
    [anon_sym_column_major] = ACTIONS(3460),
    [anon_sym_globallycoherent] = ACTIONS(3460),
    [anon_sym_centroid] = ACTIONS(3460),
    [anon_sym_noperspective] = ACTIONS(3460),
    [anon_sym_nointerpolation] = ACTIONS(3460),
    [anon_sym_sample] = ACTIONS(3460),
    [anon_sym_linear] = ACTIONS(3460),
    [anon_sym_snorm] = ACTIONS(3460),
    [anon_sym_unorm] = ACTIONS(3460),
    [anon_sym_point] = ACTIONS(3460),
    [anon_sym_line] = ACTIONS(3460),
    [anon_sym_triangleadj] = ACTIONS(3460),
    [anon_sym_lineadj] = ACTIONS(3460),
    [anon_sym_triangle] = ACTIONS(3460),
    [anon_sym_cbuffer] = ACTIONS(3460),
    [anon_sym_interface] = ACTIONS(3460),
    [anon_sym_extension] = ACTIONS(3460),
    [anon_sym___exported] = ACTIONS(3460),
  },
  [405] = {
    [sym_identifier] = ACTIONS(3462),
    [aux_sym_preproc_include_token1] = ACTIONS(3462),
    [aux_sym_preproc_def_token1] = ACTIONS(3462),
    [aux_sym_preproc_if_token1] = ACTIONS(3462),
    [aux_sym_preproc_if_token2] = ACTIONS(3462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3462),
    [aux_sym_preproc_else_token1] = ACTIONS(3462),
    [aux_sym_preproc_elif_token1] = ACTIONS(3462),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3462),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3462),
    [sym_preproc_directive] = ACTIONS(3462),
    [anon_sym_LPAREN2] = ACTIONS(3464),
    [anon_sym_BANG] = ACTIONS(3464),
    [anon_sym_TILDE] = ACTIONS(3464),
    [anon_sym_DASH] = ACTIONS(3462),
    [anon_sym_PLUS] = ACTIONS(3462),
    [anon_sym_STAR] = ACTIONS(3464),
    [anon_sym_AMP_AMP] = ACTIONS(3464),
    [anon_sym_AMP] = ACTIONS(3462),
    [anon_sym_SEMI] = ACTIONS(3464),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_typedef] = ACTIONS(3462),
    [anon_sym_in] = ACTIONS(3462),
    [anon_sym_out] = ACTIONS(3462),
    [anon_sym_inout] = ACTIONS(3462),
    [anon_sym_virtual] = ACTIONS(3462),
    [anon_sym_extern] = ACTIONS(3462),
    [anon_sym___attribute__] = ACTIONS(3462),
    [anon_sym___attribute] = ACTIONS(3462),
    [anon_sym_using] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3464),
    [anon_sym___declspec] = ACTIONS(3462),
    [anon_sym___based] = ACTIONS(3462),
    [anon_sym___cdecl] = ACTIONS(3462),
    [anon_sym___clrcall] = ACTIONS(3462),
    [anon_sym___stdcall] = ACTIONS(3462),
    [anon_sym___fastcall] = ACTIONS(3462),
    [anon_sym___thiscall] = ACTIONS(3462),
    [anon_sym___vectorcall] = ACTIONS(3462),
    [anon_sym_LBRACE] = ACTIONS(3464),
    [anon_sym_signed] = ACTIONS(3462),
    [anon_sym_unsigned] = ACTIONS(3462),
    [anon_sym_long] = ACTIONS(3462),
    [anon_sym_short] = ACTIONS(3462),
    [anon_sym_LBRACK] = ACTIONS(3462),
    [anon_sym_static] = ACTIONS(3462),
    [anon_sym_register] = ACTIONS(3462),
    [anon_sym_inline] = ACTIONS(3462),
    [anon_sym___inline] = ACTIONS(3462),
    [anon_sym___inline__] = ACTIONS(3462),
    [anon_sym___forceinline] = ACTIONS(3462),
    [anon_sym_thread_local] = ACTIONS(3462),
    [anon_sym___thread] = ACTIONS(3462),
    [anon_sym_const] = ACTIONS(3462),
    [anon_sym_constexpr] = ACTIONS(3462),
    [anon_sym_volatile] = ACTIONS(3462),
    [anon_sym_restrict] = ACTIONS(3462),
    [anon_sym___restrict__] = ACTIONS(3462),
    [anon_sym__Atomic] = ACTIONS(3462),
    [anon_sym__Noreturn] = ACTIONS(3462),
    [anon_sym_noreturn] = ACTIONS(3462),
    [anon_sym__Nonnull] = ACTIONS(3462),
    [anon_sym_mutable] = ACTIONS(3462),
    [anon_sym_constinit] = ACTIONS(3462),
    [anon_sym_consteval] = ACTIONS(3462),
    [anon_sym_alignas] = ACTIONS(3462),
    [anon_sym__Alignas] = ACTIONS(3462),
    [sym_primitive_type] = ACTIONS(3462),
    [anon_sym_enum] = ACTIONS(3462),
    [anon_sym_class] = ACTIONS(3462),
    [anon_sym_struct] = ACTIONS(3462),
    [anon_sym_union] = ACTIONS(3462),
    [anon_sym_if] = ACTIONS(3462),
    [anon_sym_else] = ACTIONS(3462),
    [anon_sym_switch] = ACTIONS(3462),
    [anon_sym_case] = ACTIONS(3462),
    [anon_sym_default] = ACTIONS(3462),
    [anon_sym_while] = ACTIONS(3462),
    [anon_sym_do] = ACTIONS(3462),
    [anon_sym_for] = ACTIONS(3462),
    [anon_sym_return] = ACTIONS(3462),
    [anon_sym_break] = ACTIONS(3462),
    [anon_sym_continue] = ACTIONS(3462),
    [anon_sym_goto] = ACTIONS(3462),
    [anon_sym___try] = ACTIONS(3462),
    [anon_sym___leave] = ACTIONS(3462),
    [anon_sym_not] = ACTIONS(3462),
    [anon_sym_compl] = ACTIONS(3462),
    [anon_sym_DASH_DASH] = ACTIONS(3464),
    [anon_sym_PLUS_PLUS] = ACTIONS(3464),
    [anon_sym_sizeof] = ACTIONS(3462),
    [anon_sym___alignof__] = ACTIONS(3462),
    [anon_sym___alignof] = ACTIONS(3462),
    [anon_sym__alignof] = ACTIONS(3462),
    [anon_sym_alignof] = ACTIONS(3462),
    [anon_sym__Alignof] = ACTIONS(3462),
    [anon_sym_offsetof] = ACTIONS(3462),
    [anon_sym__Generic] = ACTIONS(3462),
    [anon_sym_asm] = ACTIONS(3462),
    [anon_sym___asm__] = ACTIONS(3462),
    [anon_sym___asm] = ACTIONS(3462),
    [sym_number_literal] = ACTIONS(3464),
    [anon_sym_L_SQUOTE] = ACTIONS(3464),
    [anon_sym_u_SQUOTE] = ACTIONS(3464),
    [anon_sym_U_SQUOTE] = ACTIONS(3464),
    [anon_sym_u8_SQUOTE] = ACTIONS(3464),
    [anon_sym_SQUOTE] = ACTIONS(3464),
    [anon_sym_L_DQUOTE] = ACTIONS(3464),
    [anon_sym_u_DQUOTE] = ACTIONS(3464),
    [anon_sym_U_DQUOTE] = ACTIONS(3464),
    [anon_sym_u8_DQUOTE] = ACTIONS(3464),
    [anon_sym_DQUOTE] = ACTIONS(3464),
    [sym_true] = ACTIONS(3462),
    [sym_false] = ACTIONS(3462),
    [anon_sym_NULL] = ACTIONS(3462),
    [anon_sym_nullptr] = ACTIONS(3462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3462),
    [anon_sym_let] = ACTIONS(3462),
    [anon_sym_This] = ACTIONS(3462),
    [anon_sym_decltype] = ACTIONS(3462),
    [anon_sym_explicit] = ACTIONS(3462),
    [anon_sym_typename] = ACTIONS(3462),
    [anon_sym_template] = ACTIONS(3462),
    [anon_sym_operator] = ACTIONS(3462),
    [anon_sym_try] = ACTIONS(3462),
    [anon_sym_delete] = ACTIONS(3462),
    [anon_sym_throw] = ACTIONS(3462),
    [anon_sym_namespace] = ACTIONS(3462),
    [anon_sym_static_assert] = ACTIONS(3462),
    [anon_sym_concept] = ACTIONS(3462),
    [anon_sym_co_return] = ACTIONS(3462),
    [anon_sym_co_yield] = ACTIONS(3462),
    [anon_sym_R_DQUOTE] = ACTIONS(3464),
    [anon_sym_LR_DQUOTE] = ACTIONS(3464),
    [anon_sym_uR_DQUOTE] = ACTIONS(3464),
    [anon_sym_UR_DQUOTE] = ACTIONS(3464),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3464),
    [anon_sym_co_await] = ACTIONS(3462),
    [anon_sym_new] = ACTIONS(3462),
    [anon_sym_requires] = ACTIONS(3462),
    [sym_this] = ACTIONS(3462),
    [anon_sym_discard] = ACTIONS(3462),
    [anon_sym_precise] = ACTIONS(3462),
    [anon_sym_shared] = ACTIONS(3462),
    [anon_sym_groupshared] = ACTIONS(3462),
    [anon_sym_uniform] = ACTIONS(3462),
    [anon_sym_row_major] = ACTIONS(3462),
    [anon_sym_column_major] = ACTIONS(3462),
    [anon_sym_globallycoherent] = ACTIONS(3462),
    [anon_sym_centroid] = ACTIONS(3462),
    [anon_sym_noperspective] = ACTIONS(3462),
    [anon_sym_nointerpolation] = ACTIONS(3462),
    [anon_sym_sample] = ACTIONS(3462),
    [anon_sym_linear] = ACTIONS(3462),
    [anon_sym_snorm] = ACTIONS(3462),
    [anon_sym_unorm] = ACTIONS(3462),
    [anon_sym_point] = ACTIONS(3462),
    [anon_sym_line] = ACTIONS(3462),
    [anon_sym_triangleadj] = ACTIONS(3462),
    [anon_sym_lineadj] = ACTIONS(3462),
    [anon_sym_triangle] = ACTIONS(3462),
    [anon_sym_cbuffer] = ACTIONS(3462),
    [anon_sym_interface] = ACTIONS(3462),
    [anon_sym_extension] = ACTIONS(3462),
  },
  [406] = {
    [sym_identifier] = ACTIONS(3466),
    [aux_sym_preproc_include_token1] = ACTIONS(3466),
    [aux_sym_preproc_def_token1] = ACTIONS(3466),
    [aux_sym_preproc_if_token1] = ACTIONS(3466),
    [aux_sym_preproc_if_token2] = ACTIONS(3466),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3466),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3466),
    [aux_sym_preproc_else_token1] = ACTIONS(3466),
    [aux_sym_preproc_elif_token1] = ACTIONS(3466),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3466),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3466),
    [sym_preproc_directive] = ACTIONS(3466),
    [anon_sym_LPAREN2] = ACTIONS(3468),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3466),
    [anon_sym_PLUS] = ACTIONS(3466),
    [anon_sym_STAR] = ACTIONS(3468),
    [anon_sym_AMP_AMP] = ACTIONS(3468),
    [anon_sym_AMP] = ACTIONS(3466),
    [anon_sym_SEMI] = ACTIONS(3468),
    [anon_sym___extension__] = ACTIONS(3466),
    [anon_sym_typedef] = ACTIONS(3466),
    [anon_sym_in] = ACTIONS(3466),
    [anon_sym_out] = ACTIONS(3466),
    [anon_sym_inout] = ACTIONS(3466),
    [anon_sym_virtual] = ACTIONS(3466),
    [anon_sym_extern] = ACTIONS(3466),
    [anon_sym___attribute__] = ACTIONS(3466),
    [anon_sym___attribute] = ACTIONS(3466),
    [anon_sym_using] = ACTIONS(3466),
    [anon_sym_COLON_COLON] = ACTIONS(3468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3468),
    [anon_sym___declspec] = ACTIONS(3466),
    [anon_sym___based] = ACTIONS(3466),
    [anon_sym___cdecl] = ACTIONS(3466),
    [anon_sym___clrcall] = ACTIONS(3466),
    [anon_sym___stdcall] = ACTIONS(3466),
    [anon_sym___fastcall] = ACTIONS(3466),
    [anon_sym___thiscall] = ACTIONS(3466),
    [anon_sym___vectorcall] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_signed] = ACTIONS(3466),
    [anon_sym_unsigned] = ACTIONS(3466),
    [anon_sym_long] = ACTIONS(3466),
    [anon_sym_short] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(3466),
    [anon_sym_static] = ACTIONS(3466),
    [anon_sym_register] = ACTIONS(3466),
    [anon_sym_inline] = ACTIONS(3466),
    [anon_sym___inline] = ACTIONS(3466),
    [anon_sym___inline__] = ACTIONS(3466),
    [anon_sym___forceinline] = ACTIONS(3466),
    [anon_sym_thread_local] = ACTIONS(3466),
    [anon_sym___thread] = ACTIONS(3466),
    [anon_sym_const] = ACTIONS(3466),
    [anon_sym_constexpr] = ACTIONS(3466),
    [anon_sym_volatile] = ACTIONS(3466),
    [anon_sym_restrict] = ACTIONS(3466),
    [anon_sym___restrict__] = ACTIONS(3466),
    [anon_sym__Atomic] = ACTIONS(3466),
    [anon_sym__Noreturn] = ACTIONS(3466),
    [anon_sym_noreturn] = ACTIONS(3466),
    [anon_sym__Nonnull] = ACTIONS(3466),
    [anon_sym_mutable] = ACTIONS(3466),
    [anon_sym_constinit] = ACTIONS(3466),
    [anon_sym_consteval] = ACTIONS(3466),
    [anon_sym_alignas] = ACTIONS(3466),
    [anon_sym__Alignas] = ACTIONS(3466),
    [sym_primitive_type] = ACTIONS(3466),
    [anon_sym_enum] = ACTIONS(3466),
    [anon_sym_class] = ACTIONS(3466),
    [anon_sym_struct] = ACTIONS(3466),
    [anon_sym_union] = ACTIONS(3466),
    [anon_sym_if] = ACTIONS(3466),
    [anon_sym_else] = ACTIONS(3466),
    [anon_sym_switch] = ACTIONS(3466),
    [anon_sym_case] = ACTIONS(3466),
    [anon_sym_default] = ACTIONS(3466),
    [anon_sym_while] = ACTIONS(3466),
    [anon_sym_do] = ACTIONS(3466),
    [anon_sym_for] = ACTIONS(3466),
    [anon_sym_return] = ACTIONS(3466),
    [anon_sym_break] = ACTIONS(3466),
    [anon_sym_continue] = ACTIONS(3466),
    [anon_sym_goto] = ACTIONS(3466),
    [anon_sym___try] = ACTIONS(3466),
    [anon_sym___leave] = ACTIONS(3466),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_compl] = ACTIONS(3466),
    [anon_sym_DASH_DASH] = ACTIONS(3468),
    [anon_sym_PLUS_PLUS] = ACTIONS(3468),
    [anon_sym_sizeof] = ACTIONS(3466),
    [anon_sym___alignof__] = ACTIONS(3466),
    [anon_sym___alignof] = ACTIONS(3466),
    [anon_sym__alignof] = ACTIONS(3466),
    [anon_sym_alignof] = ACTIONS(3466),
    [anon_sym__Alignof] = ACTIONS(3466),
    [anon_sym_offsetof] = ACTIONS(3466),
    [anon_sym__Generic] = ACTIONS(3466),
    [anon_sym_asm] = ACTIONS(3466),
    [anon_sym___asm__] = ACTIONS(3466),
    [anon_sym___asm] = ACTIONS(3466),
    [sym_number_literal] = ACTIONS(3468),
    [anon_sym_L_SQUOTE] = ACTIONS(3468),
    [anon_sym_u_SQUOTE] = ACTIONS(3468),
    [anon_sym_U_SQUOTE] = ACTIONS(3468),
    [anon_sym_u8_SQUOTE] = ACTIONS(3468),
    [anon_sym_SQUOTE] = ACTIONS(3468),
    [anon_sym_L_DQUOTE] = ACTIONS(3468),
    [anon_sym_u_DQUOTE] = ACTIONS(3468),
    [anon_sym_U_DQUOTE] = ACTIONS(3468),
    [anon_sym_u8_DQUOTE] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3468),
    [sym_true] = ACTIONS(3466),
    [sym_false] = ACTIONS(3466),
    [anon_sym_NULL] = ACTIONS(3466),
    [anon_sym_nullptr] = ACTIONS(3466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3466),
    [anon_sym_let] = ACTIONS(3466),
    [anon_sym_This] = ACTIONS(3466),
    [anon_sym_decltype] = ACTIONS(3466),
    [anon_sym_explicit] = ACTIONS(3466),
    [anon_sym_typename] = ACTIONS(3466),
    [anon_sym_template] = ACTIONS(3466),
    [anon_sym_operator] = ACTIONS(3466),
    [anon_sym_try] = ACTIONS(3466),
    [anon_sym_delete] = ACTIONS(3466),
    [anon_sym_throw] = ACTIONS(3466),
    [anon_sym_namespace] = ACTIONS(3466),
    [anon_sym_static_assert] = ACTIONS(3466),
    [anon_sym_concept] = ACTIONS(3466),
    [anon_sym_co_return] = ACTIONS(3466),
    [anon_sym_co_yield] = ACTIONS(3466),
    [anon_sym_R_DQUOTE] = ACTIONS(3468),
    [anon_sym_LR_DQUOTE] = ACTIONS(3468),
    [anon_sym_uR_DQUOTE] = ACTIONS(3468),
    [anon_sym_UR_DQUOTE] = ACTIONS(3468),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3468),
    [anon_sym_co_await] = ACTIONS(3466),
    [anon_sym_new] = ACTIONS(3466),
    [anon_sym_requires] = ACTIONS(3466),
    [sym_this] = ACTIONS(3466),
    [anon_sym_discard] = ACTIONS(3466),
    [anon_sym_precise] = ACTIONS(3466),
    [anon_sym_shared] = ACTIONS(3466),
    [anon_sym_groupshared] = ACTIONS(3466),
    [anon_sym_uniform] = ACTIONS(3466),
    [anon_sym_row_major] = ACTIONS(3466),
    [anon_sym_column_major] = ACTIONS(3466),
    [anon_sym_globallycoherent] = ACTIONS(3466),
    [anon_sym_centroid] = ACTIONS(3466),
    [anon_sym_noperspective] = ACTIONS(3466),
    [anon_sym_nointerpolation] = ACTIONS(3466),
    [anon_sym_sample] = ACTIONS(3466),
    [anon_sym_linear] = ACTIONS(3466),
    [anon_sym_snorm] = ACTIONS(3466),
    [anon_sym_unorm] = ACTIONS(3466),
    [anon_sym_point] = ACTIONS(3466),
    [anon_sym_line] = ACTIONS(3466),
    [anon_sym_triangleadj] = ACTIONS(3466),
    [anon_sym_lineadj] = ACTIONS(3466),
    [anon_sym_triangle] = ACTIONS(3466),
    [anon_sym_cbuffer] = ACTIONS(3466),
    [anon_sym_interface] = ACTIONS(3466),
    [anon_sym_extension] = ACTIONS(3466),
  },
  [407] = {
    [sym_identifier] = ACTIONS(3470),
    [aux_sym_preproc_include_token1] = ACTIONS(3470),
    [aux_sym_preproc_def_token1] = ACTIONS(3470),
    [aux_sym_preproc_if_token1] = ACTIONS(3470),
    [aux_sym_preproc_if_token2] = ACTIONS(3470),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3470),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3470),
    [aux_sym_preproc_else_token1] = ACTIONS(3470),
    [aux_sym_preproc_elif_token1] = ACTIONS(3470),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3470),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3470),
    [sym_preproc_directive] = ACTIONS(3470),
    [anon_sym_LPAREN2] = ACTIONS(3472),
    [anon_sym_BANG] = ACTIONS(3472),
    [anon_sym_TILDE] = ACTIONS(3472),
    [anon_sym_DASH] = ACTIONS(3470),
    [anon_sym_PLUS] = ACTIONS(3470),
    [anon_sym_STAR] = ACTIONS(3472),
    [anon_sym_AMP_AMP] = ACTIONS(3472),
    [anon_sym_AMP] = ACTIONS(3470),
    [anon_sym_SEMI] = ACTIONS(3472),
    [anon_sym___extension__] = ACTIONS(3470),
    [anon_sym_typedef] = ACTIONS(3470),
    [anon_sym_in] = ACTIONS(3470),
    [anon_sym_out] = ACTIONS(3470),
    [anon_sym_inout] = ACTIONS(3470),
    [anon_sym_virtual] = ACTIONS(3470),
    [anon_sym_extern] = ACTIONS(3470),
    [anon_sym___attribute__] = ACTIONS(3470),
    [anon_sym___attribute] = ACTIONS(3470),
    [anon_sym_using] = ACTIONS(3470),
    [anon_sym_COLON_COLON] = ACTIONS(3472),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3472),
    [anon_sym___declspec] = ACTIONS(3470),
    [anon_sym___based] = ACTIONS(3470),
    [anon_sym___cdecl] = ACTIONS(3470),
    [anon_sym___clrcall] = ACTIONS(3470),
    [anon_sym___stdcall] = ACTIONS(3470),
    [anon_sym___fastcall] = ACTIONS(3470),
    [anon_sym___thiscall] = ACTIONS(3470),
    [anon_sym___vectorcall] = ACTIONS(3470),
    [anon_sym_LBRACE] = ACTIONS(3472),
    [anon_sym_signed] = ACTIONS(3470),
    [anon_sym_unsigned] = ACTIONS(3470),
    [anon_sym_long] = ACTIONS(3470),
    [anon_sym_short] = ACTIONS(3470),
    [anon_sym_LBRACK] = ACTIONS(3470),
    [anon_sym_static] = ACTIONS(3470),
    [anon_sym_register] = ACTIONS(3470),
    [anon_sym_inline] = ACTIONS(3470),
    [anon_sym___inline] = ACTIONS(3470),
    [anon_sym___inline__] = ACTIONS(3470),
    [anon_sym___forceinline] = ACTIONS(3470),
    [anon_sym_thread_local] = ACTIONS(3470),
    [anon_sym___thread] = ACTIONS(3470),
    [anon_sym_const] = ACTIONS(3470),
    [anon_sym_constexpr] = ACTIONS(3470),
    [anon_sym_volatile] = ACTIONS(3470),
    [anon_sym_restrict] = ACTIONS(3470),
    [anon_sym___restrict__] = ACTIONS(3470),
    [anon_sym__Atomic] = ACTIONS(3470),
    [anon_sym__Noreturn] = ACTIONS(3470),
    [anon_sym_noreturn] = ACTIONS(3470),
    [anon_sym__Nonnull] = ACTIONS(3470),
    [anon_sym_mutable] = ACTIONS(3470),
    [anon_sym_constinit] = ACTIONS(3470),
    [anon_sym_consteval] = ACTIONS(3470),
    [anon_sym_alignas] = ACTIONS(3470),
    [anon_sym__Alignas] = ACTIONS(3470),
    [sym_primitive_type] = ACTIONS(3470),
    [anon_sym_enum] = ACTIONS(3470),
    [anon_sym_class] = ACTIONS(3470),
    [anon_sym_struct] = ACTIONS(3470),
    [anon_sym_union] = ACTIONS(3470),
    [anon_sym_if] = ACTIONS(3470),
    [anon_sym_else] = ACTIONS(3470),
    [anon_sym_switch] = ACTIONS(3470),
    [anon_sym_case] = ACTIONS(3470),
    [anon_sym_default] = ACTIONS(3470),
    [anon_sym_while] = ACTIONS(3470),
    [anon_sym_do] = ACTIONS(3470),
    [anon_sym_for] = ACTIONS(3470),
    [anon_sym_return] = ACTIONS(3470),
    [anon_sym_break] = ACTIONS(3470),
    [anon_sym_continue] = ACTIONS(3470),
    [anon_sym_goto] = ACTIONS(3470),
    [anon_sym___try] = ACTIONS(3470),
    [anon_sym___leave] = ACTIONS(3470),
    [anon_sym_not] = ACTIONS(3470),
    [anon_sym_compl] = ACTIONS(3470),
    [anon_sym_DASH_DASH] = ACTIONS(3472),
    [anon_sym_PLUS_PLUS] = ACTIONS(3472),
    [anon_sym_sizeof] = ACTIONS(3470),
    [anon_sym___alignof__] = ACTIONS(3470),
    [anon_sym___alignof] = ACTIONS(3470),
    [anon_sym__alignof] = ACTIONS(3470),
    [anon_sym_alignof] = ACTIONS(3470),
    [anon_sym__Alignof] = ACTIONS(3470),
    [anon_sym_offsetof] = ACTIONS(3470),
    [anon_sym__Generic] = ACTIONS(3470),
    [anon_sym_asm] = ACTIONS(3470),
    [anon_sym___asm__] = ACTIONS(3470),
    [anon_sym___asm] = ACTIONS(3470),
    [sym_number_literal] = ACTIONS(3472),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3472),
    [anon_sym_u_DQUOTE] = ACTIONS(3472),
    [anon_sym_U_DQUOTE] = ACTIONS(3472),
    [anon_sym_u8_DQUOTE] = ACTIONS(3472),
    [anon_sym_DQUOTE] = ACTIONS(3472),
    [sym_true] = ACTIONS(3470),
    [sym_false] = ACTIONS(3470),
    [anon_sym_NULL] = ACTIONS(3470),
    [anon_sym_nullptr] = ACTIONS(3470),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3470),
    [anon_sym_let] = ACTIONS(3470),
    [anon_sym_This] = ACTIONS(3470),
    [anon_sym_decltype] = ACTIONS(3470),
    [anon_sym_explicit] = ACTIONS(3470),
    [anon_sym_typename] = ACTIONS(3470),
    [anon_sym_template] = ACTIONS(3470),
    [anon_sym_operator] = ACTIONS(3470),
    [anon_sym_try] = ACTIONS(3470),
    [anon_sym_delete] = ACTIONS(3470),
    [anon_sym_throw] = ACTIONS(3470),
    [anon_sym_namespace] = ACTIONS(3470),
    [anon_sym_static_assert] = ACTIONS(3470),
    [anon_sym_concept] = ACTIONS(3470),
    [anon_sym_co_return] = ACTIONS(3470),
    [anon_sym_co_yield] = ACTIONS(3470),
    [anon_sym_R_DQUOTE] = ACTIONS(3472),
    [anon_sym_LR_DQUOTE] = ACTIONS(3472),
    [anon_sym_uR_DQUOTE] = ACTIONS(3472),
    [anon_sym_UR_DQUOTE] = ACTIONS(3472),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3472),
    [anon_sym_co_await] = ACTIONS(3470),
    [anon_sym_new] = ACTIONS(3470),
    [anon_sym_requires] = ACTIONS(3470),
    [sym_this] = ACTIONS(3470),
    [anon_sym_discard] = ACTIONS(3470),
    [anon_sym_precise] = ACTIONS(3470),
    [anon_sym_shared] = ACTIONS(3470),
    [anon_sym_groupshared] = ACTIONS(3470),
    [anon_sym_uniform] = ACTIONS(3470),
    [anon_sym_row_major] = ACTIONS(3470),
    [anon_sym_column_major] = ACTIONS(3470),
    [anon_sym_globallycoherent] = ACTIONS(3470),
    [anon_sym_centroid] = ACTIONS(3470),
    [anon_sym_noperspective] = ACTIONS(3470),
    [anon_sym_nointerpolation] = ACTIONS(3470),
    [anon_sym_sample] = ACTIONS(3470),
    [anon_sym_linear] = ACTIONS(3470),
    [anon_sym_snorm] = ACTIONS(3470),
    [anon_sym_unorm] = ACTIONS(3470),
    [anon_sym_point] = ACTIONS(3470),
    [anon_sym_line] = ACTIONS(3470),
    [anon_sym_triangleadj] = ACTIONS(3470),
    [anon_sym_lineadj] = ACTIONS(3470),
    [anon_sym_triangle] = ACTIONS(3470),
    [anon_sym_cbuffer] = ACTIONS(3470),
    [anon_sym_interface] = ACTIONS(3470),
    [anon_sym_extension] = ACTIONS(3470),
  },
  [408] = {
    [sym_identifier] = ACTIONS(3474),
    [aux_sym_preproc_include_token1] = ACTIONS(3474),
    [aux_sym_preproc_def_token1] = ACTIONS(3474),
    [aux_sym_preproc_if_token1] = ACTIONS(3474),
    [aux_sym_preproc_if_token2] = ACTIONS(3474),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3474),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3474),
    [aux_sym_preproc_else_token1] = ACTIONS(3474),
    [aux_sym_preproc_elif_token1] = ACTIONS(3474),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3474),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3474),
    [sym_preproc_directive] = ACTIONS(3474),
    [anon_sym_LPAREN2] = ACTIONS(3476),
    [anon_sym_BANG] = ACTIONS(3476),
    [anon_sym_TILDE] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3474),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_AMP_AMP] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3474),
    [anon_sym_SEMI] = ACTIONS(3476),
    [anon_sym___extension__] = ACTIONS(3474),
    [anon_sym_typedef] = ACTIONS(3474),
    [anon_sym_in] = ACTIONS(3474),
    [anon_sym_out] = ACTIONS(3474),
    [anon_sym_inout] = ACTIONS(3474),
    [anon_sym_virtual] = ACTIONS(3474),
    [anon_sym_extern] = ACTIONS(3474),
    [anon_sym___attribute__] = ACTIONS(3474),
    [anon_sym___attribute] = ACTIONS(3474),
    [anon_sym_using] = ACTIONS(3474),
    [anon_sym_COLON_COLON] = ACTIONS(3476),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3476),
    [anon_sym___declspec] = ACTIONS(3474),
    [anon_sym___based] = ACTIONS(3474),
    [anon_sym___cdecl] = ACTIONS(3474),
    [anon_sym___clrcall] = ACTIONS(3474),
    [anon_sym___stdcall] = ACTIONS(3474),
    [anon_sym___fastcall] = ACTIONS(3474),
    [anon_sym___thiscall] = ACTIONS(3474),
    [anon_sym___vectorcall] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_signed] = ACTIONS(3474),
    [anon_sym_unsigned] = ACTIONS(3474),
    [anon_sym_long] = ACTIONS(3474),
    [anon_sym_short] = ACTIONS(3474),
    [anon_sym_LBRACK] = ACTIONS(3474),
    [anon_sym_static] = ACTIONS(3474),
    [anon_sym_register] = ACTIONS(3474),
    [anon_sym_inline] = ACTIONS(3474),
    [anon_sym___inline] = ACTIONS(3474),
    [anon_sym___inline__] = ACTIONS(3474),
    [anon_sym___forceinline] = ACTIONS(3474),
    [anon_sym_thread_local] = ACTIONS(3474),
    [anon_sym___thread] = ACTIONS(3474),
    [anon_sym_const] = ACTIONS(3474),
    [anon_sym_constexpr] = ACTIONS(3474),
    [anon_sym_volatile] = ACTIONS(3474),
    [anon_sym_restrict] = ACTIONS(3474),
    [anon_sym___restrict__] = ACTIONS(3474),
    [anon_sym__Atomic] = ACTIONS(3474),
    [anon_sym__Noreturn] = ACTIONS(3474),
    [anon_sym_noreturn] = ACTIONS(3474),
    [anon_sym__Nonnull] = ACTIONS(3474),
    [anon_sym_mutable] = ACTIONS(3474),
    [anon_sym_constinit] = ACTIONS(3474),
    [anon_sym_consteval] = ACTIONS(3474),
    [anon_sym_alignas] = ACTIONS(3474),
    [anon_sym__Alignas] = ACTIONS(3474),
    [sym_primitive_type] = ACTIONS(3474),
    [anon_sym_enum] = ACTIONS(3474),
    [anon_sym_class] = ACTIONS(3474),
    [anon_sym_struct] = ACTIONS(3474),
    [anon_sym_union] = ACTIONS(3474),
    [anon_sym_if] = ACTIONS(3474),
    [anon_sym_else] = ACTIONS(3474),
    [anon_sym_switch] = ACTIONS(3474),
    [anon_sym_case] = ACTIONS(3474),
    [anon_sym_default] = ACTIONS(3474),
    [anon_sym_while] = ACTIONS(3474),
    [anon_sym_do] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3474),
    [anon_sym_return] = ACTIONS(3474),
    [anon_sym_break] = ACTIONS(3474),
    [anon_sym_continue] = ACTIONS(3474),
    [anon_sym_goto] = ACTIONS(3474),
    [anon_sym___try] = ACTIONS(3474),
    [anon_sym___leave] = ACTIONS(3474),
    [anon_sym_not] = ACTIONS(3474),
    [anon_sym_compl] = ACTIONS(3474),
    [anon_sym_DASH_DASH] = ACTIONS(3476),
    [anon_sym_PLUS_PLUS] = ACTIONS(3476),
    [anon_sym_sizeof] = ACTIONS(3474),
    [anon_sym___alignof__] = ACTIONS(3474),
    [anon_sym___alignof] = ACTIONS(3474),
    [anon_sym__alignof] = ACTIONS(3474),
    [anon_sym_alignof] = ACTIONS(3474),
    [anon_sym__Alignof] = ACTIONS(3474),
    [anon_sym_offsetof] = ACTIONS(3474),
    [anon_sym__Generic] = ACTIONS(3474),
    [anon_sym_asm] = ACTIONS(3474),
    [anon_sym___asm__] = ACTIONS(3474),
    [anon_sym___asm] = ACTIONS(3474),
    [sym_number_literal] = ACTIONS(3476),
    [anon_sym_L_SQUOTE] = ACTIONS(3476),
    [anon_sym_u_SQUOTE] = ACTIONS(3476),
    [anon_sym_U_SQUOTE] = ACTIONS(3476),
    [anon_sym_u8_SQUOTE] = ACTIONS(3476),
    [anon_sym_SQUOTE] = ACTIONS(3476),
    [anon_sym_L_DQUOTE] = ACTIONS(3476),
    [anon_sym_u_DQUOTE] = ACTIONS(3476),
    [anon_sym_U_DQUOTE] = ACTIONS(3476),
    [anon_sym_u8_DQUOTE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [sym_true] = ACTIONS(3474),
    [sym_false] = ACTIONS(3474),
    [anon_sym_NULL] = ACTIONS(3474),
    [anon_sym_nullptr] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3474),
    [anon_sym_let] = ACTIONS(3474),
    [anon_sym_This] = ACTIONS(3474),
    [anon_sym_decltype] = ACTIONS(3474),
    [anon_sym_explicit] = ACTIONS(3474),
    [anon_sym_typename] = ACTIONS(3474),
    [anon_sym_template] = ACTIONS(3474),
    [anon_sym_operator] = ACTIONS(3474),
    [anon_sym_try] = ACTIONS(3474),
    [anon_sym_delete] = ACTIONS(3474),
    [anon_sym_throw] = ACTIONS(3474),
    [anon_sym_namespace] = ACTIONS(3474),
    [anon_sym_static_assert] = ACTIONS(3474),
    [anon_sym_concept] = ACTIONS(3474),
    [anon_sym_co_return] = ACTIONS(3474),
    [anon_sym_co_yield] = ACTIONS(3474),
    [anon_sym_R_DQUOTE] = ACTIONS(3476),
    [anon_sym_LR_DQUOTE] = ACTIONS(3476),
    [anon_sym_uR_DQUOTE] = ACTIONS(3476),
    [anon_sym_UR_DQUOTE] = ACTIONS(3476),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3476),
    [anon_sym_co_await] = ACTIONS(3474),
    [anon_sym_new] = ACTIONS(3474),
    [anon_sym_requires] = ACTIONS(3474),
    [sym_this] = ACTIONS(3474),
    [anon_sym_discard] = ACTIONS(3474),
    [anon_sym_precise] = ACTIONS(3474),
    [anon_sym_shared] = ACTIONS(3474),
    [anon_sym_groupshared] = ACTIONS(3474),
    [anon_sym_uniform] = ACTIONS(3474),
    [anon_sym_row_major] = ACTIONS(3474),
    [anon_sym_column_major] = ACTIONS(3474),
    [anon_sym_globallycoherent] = ACTIONS(3474),
    [anon_sym_centroid] = ACTIONS(3474),
    [anon_sym_noperspective] = ACTIONS(3474),
    [anon_sym_nointerpolation] = ACTIONS(3474),
    [anon_sym_sample] = ACTIONS(3474),
    [anon_sym_linear] = ACTIONS(3474),
    [anon_sym_snorm] = ACTIONS(3474),
    [anon_sym_unorm] = ACTIONS(3474),
    [anon_sym_point] = ACTIONS(3474),
    [anon_sym_line] = ACTIONS(3474),
    [anon_sym_triangleadj] = ACTIONS(3474),
    [anon_sym_lineadj] = ACTIONS(3474),
    [anon_sym_triangle] = ACTIONS(3474),
    [anon_sym_cbuffer] = ACTIONS(3474),
    [anon_sym_interface] = ACTIONS(3474),
    [anon_sym_extension] = ACTIONS(3474),
  },
  [409] = {
    [sym_attribute_specifier] = STATE(769),
    [sym_enumerator_list] = STATE(667),
    [sym__enum_base_clause] = STATE(634),
    [sym_identifier] = ACTIONS(3478),
    [aux_sym_preproc_include_token1] = ACTIONS(3478),
    [aux_sym_preproc_def_token1] = ACTIONS(3478),
    [aux_sym_preproc_if_token1] = ACTIONS(3478),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3478),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3478),
    [sym_preproc_directive] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_BANG] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3478),
    [anon_sym_PLUS] = ACTIONS(3478),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3482),
    [anon_sym_SEMI] = ACTIONS(3480),
    [anon_sym___extension__] = ACTIONS(3478),
    [anon_sym_typedef] = ACTIONS(3478),
    [anon_sym_in] = ACTIONS(3478),
    [anon_sym_out] = ACTIONS(3478),
    [anon_sym_inout] = ACTIONS(3478),
    [anon_sym_virtual] = ACTIONS(3478),
    [anon_sym_extern] = ACTIONS(3478),
    [anon_sym___attribute__] = ACTIONS(2897),
    [anon_sym___attribute] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(3478),
    [anon_sym_COLON_COLON] = ACTIONS(3480),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3480),
    [anon_sym___declspec] = ACTIONS(3478),
    [anon_sym___based] = ACTIONS(3478),
    [anon_sym___cdecl] = ACTIONS(3478),
    [anon_sym___clrcall] = ACTIONS(3478),
    [anon_sym___stdcall] = ACTIONS(3478),
    [anon_sym___fastcall] = ACTIONS(3478),
    [anon_sym___thiscall] = ACTIONS(3478),
    [anon_sym___vectorcall] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3484),
    [anon_sym_RBRACE] = ACTIONS(3480),
    [anon_sym_signed] = ACTIONS(3478),
    [anon_sym_unsigned] = ACTIONS(3478),
    [anon_sym_long] = ACTIONS(3478),
    [anon_sym_short] = ACTIONS(3478),
    [anon_sym_LBRACK] = ACTIONS(3478),
    [anon_sym_static] = ACTIONS(3478),
    [anon_sym_register] = ACTIONS(3478),
    [anon_sym_inline] = ACTIONS(3478),
    [anon_sym___inline] = ACTIONS(3478),
    [anon_sym___inline__] = ACTIONS(3478),
    [anon_sym___forceinline] = ACTIONS(3478),
    [anon_sym_thread_local] = ACTIONS(3478),
    [anon_sym___thread] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(3478),
    [anon_sym_constexpr] = ACTIONS(3478),
    [anon_sym_volatile] = ACTIONS(3478),
    [anon_sym_restrict] = ACTIONS(3478),
    [anon_sym___restrict__] = ACTIONS(3478),
    [anon_sym__Atomic] = ACTIONS(3478),
    [anon_sym__Noreturn] = ACTIONS(3478),
    [anon_sym_noreturn] = ACTIONS(3478),
    [anon_sym__Nonnull] = ACTIONS(3478),
    [anon_sym_mutable] = ACTIONS(3478),
    [anon_sym_constinit] = ACTIONS(3478),
    [anon_sym_consteval] = ACTIONS(3478),
    [anon_sym_alignas] = ACTIONS(3478),
    [anon_sym__Alignas] = ACTIONS(3478),
    [sym_primitive_type] = ACTIONS(3478),
    [anon_sym_enum] = ACTIONS(3478),
    [anon_sym_class] = ACTIONS(3478),
    [anon_sym_struct] = ACTIONS(3478),
    [anon_sym_union] = ACTIONS(3478),
    [anon_sym_if] = ACTIONS(3478),
    [anon_sym_switch] = ACTIONS(3478),
    [anon_sym_case] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3478),
    [anon_sym_while] = ACTIONS(3478),
    [anon_sym_do] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3478),
    [anon_sym_return] = ACTIONS(3478),
    [anon_sym_break] = ACTIONS(3478),
    [anon_sym_continue] = ACTIONS(3478),
    [anon_sym_goto] = ACTIONS(3478),
    [anon_sym___try] = ACTIONS(3478),
    [anon_sym___leave] = ACTIONS(3478),
    [anon_sym_not] = ACTIONS(3478),
    [anon_sym_compl] = ACTIONS(3478),
    [anon_sym_DASH_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_PLUS] = ACTIONS(3480),
    [anon_sym_sizeof] = ACTIONS(3478),
    [anon_sym___alignof__] = ACTIONS(3478),
    [anon_sym___alignof] = ACTIONS(3478),
    [anon_sym__alignof] = ACTIONS(3478),
    [anon_sym_alignof] = ACTIONS(3478),
    [anon_sym__Alignof] = ACTIONS(3478),
    [anon_sym_offsetof] = ACTIONS(3478),
    [anon_sym__Generic] = ACTIONS(3478),
    [anon_sym_asm] = ACTIONS(3478),
    [anon_sym___asm__] = ACTIONS(3478),
    [anon_sym___asm] = ACTIONS(3478),
    [anon_sym_DOT] = ACTIONS(3478),
    [sym_number_literal] = ACTIONS(3480),
    [anon_sym_L_SQUOTE] = ACTIONS(3480),
    [anon_sym_u_SQUOTE] = ACTIONS(3480),
    [anon_sym_U_SQUOTE] = ACTIONS(3480),
    [anon_sym_u8_SQUOTE] = ACTIONS(3480),
    [anon_sym_SQUOTE] = ACTIONS(3480),
    [anon_sym_L_DQUOTE] = ACTIONS(3480),
    [anon_sym_u_DQUOTE] = ACTIONS(3480),
    [anon_sym_U_DQUOTE] = ACTIONS(3480),
    [anon_sym_u8_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [sym_true] = ACTIONS(3478),
    [sym_false] = ACTIONS(3478),
    [anon_sym_NULL] = ACTIONS(3478),
    [anon_sym_nullptr] = ACTIONS(3478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3478),
    [anon_sym_let] = ACTIONS(3478),
    [anon_sym_This] = ACTIONS(3478),
    [anon_sym_decltype] = ACTIONS(3478),
    [anon_sym_explicit] = ACTIONS(3478),
    [anon_sym_typename] = ACTIONS(3478),
    [anon_sym_template] = ACTIONS(3478),
    [anon_sym_operator] = ACTIONS(3478),
    [anon_sym_try] = ACTIONS(3478),
    [anon_sym_delete] = ACTIONS(3478),
    [anon_sym_throw] = ACTIONS(3478),
    [anon_sym_namespace] = ACTIONS(3478),
    [anon_sym_static_assert] = ACTIONS(3478),
    [anon_sym_concept] = ACTIONS(3478),
    [anon_sym_co_return] = ACTIONS(3478),
    [anon_sym_co_yield] = ACTIONS(3478),
    [anon_sym_R_DQUOTE] = ACTIONS(3480),
    [anon_sym_LR_DQUOTE] = ACTIONS(3480),
    [anon_sym_uR_DQUOTE] = ACTIONS(3480),
    [anon_sym_UR_DQUOTE] = ACTIONS(3480),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3480),
    [anon_sym_co_await] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3478),
    [anon_sym_requires] = ACTIONS(3478),
    [sym_this] = ACTIONS(3478),
    [anon_sym_discard] = ACTIONS(3478),
    [anon_sym_precise] = ACTIONS(3478),
    [anon_sym_shared] = ACTIONS(3478),
    [anon_sym_groupshared] = ACTIONS(3478),
    [anon_sym_uniform] = ACTIONS(3478),
    [anon_sym_row_major] = ACTIONS(3478),
    [anon_sym_column_major] = ACTIONS(3478),
    [anon_sym_globallycoherent] = ACTIONS(3478),
    [anon_sym_centroid] = ACTIONS(3478),
    [anon_sym_noperspective] = ACTIONS(3478),
    [anon_sym_nointerpolation] = ACTIONS(3478),
    [anon_sym_sample] = ACTIONS(3478),
    [anon_sym_linear] = ACTIONS(3478),
    [anon_sym_snorm] = ACTIONS(3478),
    [anon_sym_unorm] = ACTIONS(3478),
    [anon_sym_point] = ACTIONS(3478),
    [anon_sym_line] = ACTIONS(3478),
    [anon_sym_triangleadj] = ACTIONS(3478),
    [anon_sym_lineadj] = ACTIONS(3478),
    [anon_sym_triangle] = ACTIONS(3478),
    [anon_sym_cbuffer] = ACTIONS(3478),
    [anon_sym_interface] = ACTIONS(3478),
    [anon_sym_extension] = ACTIONS(3478),
  },
  [410] = {
    [ts_builtin_sym_end] = ACTIONS(3486),
    [sym_identifier] = ACTIONS(3488),
    [aux_sym_preproc_include_token1] = ACTIONS(3488),
    [aux_sym_preproc_def_token1] = ACTIONS(3488),
    [aux_sym_preproc_if_token1] = ACTIONS(3488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3488),
    [sym_preproc_directive] = ACTIONS(3488),
    [anon_sym_LPAREN2] = ACTIONS(3486),
    [anon_sym_BANG] = ACTIONS(3486),
    [anon_sym_TILDE] = ACTIONS(3486),
    [anon_sym_DASH] = ACTIONS(3488),
    [anon_sym_PLUS] = ACTIONS(3488),
    [anon_sym_STAR] = ACTIONS(3486),
    [anon_sym_AMP_AMP] = ACTIONS(3486),
    [anon_sym_AMP] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3486),
    [anon_sym___extension__] = ACTIONS(3488),
    [anon_sym_typedef] = ACTIONS(3488),
    [anon_sym_in] = ACTIONS(3488),
    [anon_sym_out] = ACTIONS(3488),
    [anon_sym_inout] = ACTIONS(3488),
    [anon_sym_virtual] = ACTIONS(3488),
    [anon_sym_extern] = ACTIONS(3488),
    [anon_sym___attribute__] = ACTIONS(3488),
    [anon_sym___attribute] = ACTIONS(3488),
    [anon_sym_using] = ACTIONS(3488),
    [anon_sym_COLON_COLON] = ACTIONS(3486),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3486),
    [anon_sym___declspec] = ACTIONS(3488),
    [anon_sym___based] = ACTIONS(3488),
    [anon_sym___cdecl] = ACTIONS(3488),
    [anon_sym___clrcall] = ACTIONS(3488),
    [anon_sym___stdcall] = ACTIONS(3488),
    [anon_sym___fastcall] = ACTIONS(3488),
    [anon_sym___thiscall] = ACTIONS(3488),
    [anon_sym___vectorcall] = ACTIONS(3488),
    [anon_sym_LBRACE] = ACTIONS(3486),
    [anon_sym_signed] = ACTIONS(3488),
    [anon_sym_unsigned] = ACTIONS(3488),
    [anon_sym_long] = ACTIONS(3488),
    [anon_sym_short] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(3488),
    [anon_sym_static] = ACTIONS(3488),
    [anon_sym_register] = ACTIONS(3488),
    [anon_sym_inline] = ACTIONS(3488),
    [anon_sym___inline] = ACTIONS(3488),
    [anon_sym___inline__] = ACTIONS(3488),
    [anon_sym___forceinline] = ACTIONS(3488),
    [anon_sym_thread_local] = ACTIONS(3488),
    [anon_sym___thread] = ACTIONS(3488),
    [anon_sym_const] = ACTIONS(3488),
    [anon_sym_constexpr] = ACTIONS(3488),
    [anon_sym_volatile] = ACTIONS(3488),
    [anon_sym_restrict] = ACTIONS(3488),
    [anon_sym___restrict__] = ACTIONS(3488),
    [anon_sym__Atomic] = ACTIONS(3488),
    [anon_sym__Noreturn] = ACTIONS(3488),
    [anon_sym_noreturn] = ACTIONS(3488),
    [anon_sym__Nonnull] = ACTIONS(3488),
    [anon_sym_mutable] = ACTIONS(3488),
    [anon_sym_constinit] = ACTIONS(3488),
    [anon_sym_consteval] = ACTIONS(3488),
    [anon_sym_alignas] = ACTIONS(3488),
    [anon_sym__Alignas] = ACTIONS(3488),
    [sym_primitive_type] = ACTIONS(3488),
    [anon_sym_enum] = ACTIONS(3488),
    [anon_sym_class] = ACTIONS(3488),
    [anon_sym_struct] = ACTIONS(3488),
    [anon_sym_union] = ACTIONS(3488),
    [anon_sym_if] = ACTIONS(3488),
    [anon_sym_else] = ACTIONS(3488),
    [anon_sym_switch] = ACTIONS(3488),
    [anon_sym_case] = ACTIONS(3488),
    [anon_sym_default] = ACTIONS(3488),
    [anon_sym_while] = ACTIONS(3488),
    [anon_sym_do] = ACTIONS(3488),
    [anon_sym_for] = ACTIONS(3488),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_break] = ACTIONS(3488),
    [anon_sym_continue] = ACTIONS(3488),
    [anon_sym_goto] = ACTIONS(3488),
    [anon_sym___try] = ACTIONS(3488),
    [anon_sym___leave] = ACTIONS(3488),
    [anon_sym_not] = ACTIONS(3488),
    [anon_sym_compl] = ACTIONS(3488),
    [anon_sym_DASH_DASH] = ACTIONS(3486),
    [anon_sym_PLUS_PLUS] = ACTIONS(3486),
    [anon_sym_sizeof] = ACTIONS(3488),
    [anon_sym___alignof__] = ACTIONS(3488),
    [anon_sym___alignof] = ACTIONS(3488),
    [anon_sym__alignof] = ACTIONS(3488),
    [anon_sym_alignof] = ACTIONS(3488),
    [anon_sym__Alignof] = ACTIONS(3488),
    [anon_sym_offsetof] = ACTIONS(3488),
    [anon_sym__Generic] = ACTIONS(3488),
    [anon_sym_asm] = ACTIONS(3488),
    [anon_sym___asm__] = ACTIONS(3488),
    [anon_sym___asm] = ACTIONS(3488),
    [sym_number_literal] = ACTIONS(3486),
    [anon_sym_L_SQUOTE] = ACTIONS(3486),
    [anon_sym_u_SQUOTE] = ACTIONS(3486),
    [anon_sym_U_SQUOTE] = ACTIONS(3486),
    [anon_sym_u8_SQUOTE] = ACTIONS(3486),
    [anon_sym_SQUOTE] = ACTIONS(3486),
    [anon_sym_L_DQUOTE] = ACTIONS(3486),
    [anon_sym_u_DQUOTE] = ACTIONS(3486),
    [anon_sym_U_DQUOTE] = ACTIONS(3486),
    [anon_sym_u8_DQUOTE] = ACTIONS(3486),
    [anon_sym_DQUOTE] = ACTIONS(3486),
    [sym_true] = ACTIONS(3488),
    [sym_false] = ACTIONS(3488),
    [anon_sym_NULL] = ACTIONS(3488),
    [anon_sym_nullptr] = ACTIONS(3488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3488),
    [anon_sym_let] = ACTIONS(3488),
    [anon_sym_This] = ACTIONS(3488),
    [anon_sym_decltype] = ACTIONS(3488),
    [anon_sym_explicit] = ACTIONS(3488),
    [anon_sym_typename] = ACTIONS(3488),
    [anon_sym_export] = ACTIONS(3488),
    [anon_sym_module] = ACTIONS(3488),
    [anon_sym_import] = ACTIONS(3488),
    [anon_sym_template] = ACTIONS(3488),
    [anon_sym_operator] = ACTIONS(3488),
    [anon_sym_try] = ACTIONS(3488),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_throw] = ACTIONS(3488),
    [anon_sym_namespace] = ACTIONS(3488),
    [anon_sym_static_assert] = ACTIONS(3488),
    [anon_sym_concept] = ACTIONS(3488),
    [anon_sym_co_return] = ACTIONS(3488),
    [anon_sym_co_yield] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(3486),
    [anon_sym_LR_DQUOTE] = ACTIONS(3486),
    [anon_sym_uR_DQUOTE] = ACTIONS(3486),
    [anon_sym_UR_DQUOTE] = ACTIONS(3486),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3486),
    [anon_sym_co_await] = ACTIONS(3488),
    [anon_sym_new] = ACTIONS(3488),
    [anon_sym_requires] = ACTIONS(3488),
    [sym_this] = ACTIONS(3488),
    [anon_sym_discard] = ACTIONS(3488),
    [anon_sym_precise] = ACTIONS(3488),
    [anon_sym_shared] = ACTIONS(3488),
    [anon_sym_groupshared] = ACTIONS(3488),
    [anon_sym_uniform] = ACTIONS(3488),
    [anon_sym_row_major] = ACTIONS(3488),
    [anon_sym_column_major] = ACTIONS(3488),
    [anon_sym_globallycoherent] = ACTIONS(3488),
    [anon_sym_centroid] = ACTIONS(3488),
    [anon_sym_noperspective] = ACTIONS(3488),
    [anon_sym_nointerpolation] = ACTIONS(3488),
    [anon_sym_sample] = ACTIONS(3488),
    [anon_sym_linear] = ACTIONS(3488),
    [anon_sym_snorm] = ACTIONS(3488),
    [anon_sym_unorm] = ACTIONS(3488),
    [anon_sym_point] = ACTIONS(3488),
    [anon_sym_line] = ACTIONS(3488),
    [anon_sym_triangleadj] = ACTIONS(3488),
    [anon_sym_lineadj] = ACTIONS(3488),
    [anon_sym_triangle] = ACTIONS(3488),
    [anon_sym_cbuffer] = ACTIONS(3488),
    [anon_sym_interface] = ACTIONS(3488),
    [anon_sym_extension] = ACTIONS(3488),
    [anon_sym___exported] = ACTIONS(3488),
  },
  [411] = {
    [sym_identifier] = ACTIONS(3490),
    [aux_sym_preproc_include_token1] = ACTIONS(3490),
    [aux_sym_preproc_def_token1] = ACTIONS(3490),
    [aux_sym_preproc_if_token1] = ACTIONS(3490),
    [aux_sym_preproc_if_token2] = ACTIONS(3490),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3490),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3490),
    [aux_sym_preproc_else_token1] = ACTIONS(3490),
    [aux_sym_preproc_elif_token1] = ACTIONS(3490),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3490),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3490),
    [sym_preproc_directive] = ACTIONS(3490),
    [anon_sym_LPAREN2] = ACTIONS(3492),
    [anon_sym_BANG] = ACTIONS(3492),
    [anon_sym_TILDE] = ACTIONS(3492),
    [anon_sym_DASH] = ACTIONS(3490),
    [anon_sym_PLUS] = ACTIONS(3490),
    [anon_sym_STAR] = ACTIONS(3492),
    [anon_sym_AMP_AMP] = ACTIONS(3492),
    [anon_sym_AMP] = ACTIONS(3490),
    [anon_sym_SEMI] = ACTIONS(3492),
    [anon_sym___extension__] = ACTIONS(3490),
    [anon_sym_typedef] = ACTIONS(3490),
    [anon_sym_in] = ACTIONS(3490),
    [anon_sym_out] = ACTIONS(3490),
    [anon_sym_inout] = ACTIONS(3490),
    [anon_sym_virtual] = ACTIONS(3490),
    [anon_sym_extern] = ACTIONS(3490),
    [anon_sym___attribute__] = ACTIONS(3490),
    [anon_sym___attribute] = ACTIONS(3490),
    [anon_sym_using] = ACTIONS(3490),
    [anon_sym_COLON_COLON] = ACTIONS(3492),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3492),
    [anon_sym___declspec] = ACTIONS(3490),
    [anon_sym___based] = ACTIONS(3490),
    [anon_sym___cdecl] = ACTIONS(3490),
    [anon_sym___clrcall] = ACTIONS(3490),
    [anon_sym___stdcall] = ACTIONS(3490),
    [anon_sym___fastcall] = ACTIONS(3490),
    [anon_sym___thiscall] = ACTIONS(3490),
    [anon_sym___vectorcall] = ACTIONS(3490),
    [anon_sym_LBRACE] = ACTIONS(3492),
    [anon_sym_signed] = ACTIONS(3490),
    [anon_sym_unsigned] = ACTIONS(3490),
    [anon_sym_long] = ACTIONS(3490),
    [anon_sym_short] = ACTIONS(3490),
    [anon_sym_LBRACK] = ACTIONS(3490),
    [anon_sym_static] = ACTIONS(3490),
    [anon_sym_register] = ACTIONS(3490),
    [anon_sym_inline] = ACTIONS(3490),
    [anon_sym___inline] = ACTIONS(3490),
    [anon_sym___inline__] = ACTIONS(3490),
    [anon_sym___forceinline] = ACTIONS(3490),
    [anon_sym_thread_local] = ACTIONS(3490),
    [anon_sym___thread] = ACTIONS(3490),
    [anon_sym_const] = ACTIONS(3490),
    [anon_sym_constexpr] = ACTIONS(3490),
    [anon_sym_volatile] = ACTIONS(3490),
    [anon_sym_restrict] = ACTIONS(3490),
    [anon_sym___restrict__] = ACTIONS(3490),
    [anon_sym__Atomic] = ACTIONS(3490),
    [anon_sym__Noreturn] = ACTIONS(3490),
    [anon_sym_noreturn] = ACTIONS(3490),
    [anon_sym__Nonnull] = ACTIONS(3490),
    [anon_sym_mutable] = ACTIONS(3490),
    [anon_sym_constinit] = ACTIONS(3490),
    [anon_sym_consteval] = ACTIONS(3490),
    [anon_sym_alignas] = ACTIONS(3490),
    [anon_sym__Alignas] = ACTIONS(3490),
    [sym_primitive_type] = ACTIONS(3490),
    [anon_sym_enum] = ACTIONS(3490),
    [anon_sym_class] = ACTIONS(3490),
    [anon_sym_struct] = ACTIONS(3490),
    [anon_sym_union] = ACTIONS(3490),
    [anon_sym_if] = ACTIONS(3490),
    [anon_sym_else] = ACTIONS(3490),
    [anon_sym_switch] = ACTIONS(3490),
    [anon_sym_case] = ACTIONS(3490),
    [anon_sym_default] = ACTIONS(3490),
    [anon_sym_while] = ACTIONS(3490),
    [anon_sym_do] = ACTIONS(3490),
    [anon_sym_for] = ACTIONS(3490),
    [anon_sym_return] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3490),
    [anon_sym_continue] = ACTIONS(3490),
    [anon_sym_goto] = ACTIONS(3490),
    [anon_sym___try] = ACTIONS(3490),
    [anon_sym___leave] = ACTIONS(3490),
    [anon_sym_not] = ACTIONS(3490),
    [anon_sym_compl] = ACTIONS(3490),
    [anon_sym_DASH_DASH] = ACTIONS(3492),
    [anon_sym_PLUS_PLUS] = ACTIONS(3492),
    [anon_sym_sizeof] = ACTIONS(3490),
    [anon_sym___alignof__] = ACTIONS(3490),
    [anon_sym___alignof] = ACTIONS(3490),
    [anon_sym__alignof] = ACTIONS(3490),
    [anon_sym_alignof] = ACTIONS(3490),
    [anon_sym__Alignof] = ACTIONS(3490),
    [anon_sym_offsetof] = ACTIONS(3490),
    [anon_sym__Generic] = ACTIONS(3490),
    [anon_sym_asm] = ACTIONS(3490),
    [anon_sym___asm__] = ACTIONS(3490),
    [anon_sym___asm] = ACTIONS(3490),
    [sym_number_literal] = ACTIONS(3492),
    [anon_sym_L_SQUOTE] = ACTIONS(3492),
    [anon_sym_u_SQUOTE] = ACTIONS(3492),
    [anon_sym_U_SQUOTE] = ACTIONS(3492),
    [anon_sym_u8_SQUOTE] = ACTIONS(3492),
    [anon_sym_SQUOTE] = ACTIONS(3492),
    [anon_sym_L_DQUOTE] = ACTIONS(3492),
    [anon_sym_u_DQUOTE] = ACTIONS(3492),
    [anon_sym_U_DQUOTE] = ACTIONS(3492),
    [anon_sym_u8_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE] = ACTIONS(3492),
    [sym_true] = ACTIONS(3490),
    [sym_false] = ACTIONS(3490),
    [anon_sym_NULL] = ACTIONS(3490),
    [anon_sym_nullptr] = ACTIONS(3490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3490),
    [anon_sym_let] = ACTIONS(3490),
    [anon_sym_This] = ACTIONS(3490),
    [anon_sym_decltype] = ACTIONS(3490),
    [anon_sym_explicit] = ACTIONS(3490),
    [anon_sym_typename] = ACTIONS(3490),
    [anon_sym_template] = ACTIONS(3490),
    [anon_sym_operator] = ACTIONS(3490),
    [anon_sym_try] = ACTIONS(3490),
    [anon_sym_delete] = ACTIONS(3490),
    [anon_sym_throw] = ACTIONS(3490),
    [anon_sym_namespace] = ACTIONS(3490),
    [anon_sym_static_assert] = ACTIONS(3490),
    [anon_sym_concept] = ACTIONS(3490),
    [anon_sym_co_return] = ACTIONS(3490),
    [anon_sym_co_yield] = ACTIONS(3490),
    [anon_sym_R_DQUOTE] = ACTIONS(3492),
    [anon_sym_LR_DQUOTE] = ACTIONS(3492),
    [anon_sym_uR_DQUOTE] = ACTIONS(3492),
    [anon_sym_UR_DQUOTE] = ACTIONS(3492),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3492),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3490),
    [anon_sym_requires] = ACTIONS(3490),
    [sym_this] = ACTIONS(3490),
    [anon_sym_discard] = ACTIONS(3490),
    [anon_sym_precise] = ACTIONS(3490),
    [anon_sym_shared] = ACTIONS(3490),
    [anon_sym_groupshared] = ACTIONS(3490),
    [anon_sym_uniform] = ACTIONS(3490),
    [anon_sym_row_major] = ACTIONS(3490),
    [anon_sym_column_major] = ACTIONS(3490),
    [anon_sym_globallycoherent] = ACTIONS(3490),
    [anon_sym_centroid] = ACTIONS(3490),
    [anon_sym_noperspective] = ACTIONS(3490),
    [anon_sym_nointerpolation] = ACTIONS(3490),
    [anon_sym_sample] = ACTIONS(3490),
    [anon_sym_linear] = ACTIONS(3490),
    [anon_sym_snorm] = ACTIONS(3490),
    [anon_sym_unorm] = ACTIONS(3490),
    [anon_sym_point] = ACTIONS(3490),
    [anon_sym_line] = ACTIONS(3490),
    [anon_sym_triangleadj] = ACTIONS(3490),
    [anon_sym_lineadj] = ACTIONS(3490),
    [anon_sym_triangle] = ACTIONS(3490),
    [anon_sym_cbuffer] = ACTIONS(3490),
    [anon_sym_interface] = ACTIONS(3490),
    [anon_sym_extension] = ACTIONS(3490),
  },
  [412] = {
    [sym_identifier] = ACTIONS(3494),
    [aux_sym_preproc_include_token1] = ACTIONS(3494),
    [aux_sym_preproc_def_token1] = ACTIONS(3494),
    [aux_sym_preproc_if_token1] = ACTIONS(3494),
    [aux_sym_preproc_if_token2] = ACTIONS(3494),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3494),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3494),
    [aux_sym_preproc_else_token1] = ACTIONS(3494),
    [aux_sym_preproc_elif_token1] = ACTIONS(3494),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3494),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3494),
    [sym_preproc_directive] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(3496),
    [anon_sym_BANG] = ACTIONS(3496),
    [anon_sym_TILDE] = ACTIONS(3496),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3496),
    [anon_sym_AMP_AMP] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_SEMI] = ACTIONS(3496),
    [anon_sym___extension__] = ACTIONS(3494),
    [anon_sym_typedef] = ACTIONS(3494),
    [anon_sym_in] = ACTIONS(3494),
    [anon_sym_out] = ACTIONS(3494),
    [anon_sym_inout] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym___attribute__] = ACTIONS(3494),
    [anon_sym___attribute] = ACTIONS(3494),
    [anon_sym_using] = ACTIONS(3494),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3496),
    [anon_sym___declspec] = ACTIONS(3494),
    [anon_sym___based] = ACTIONS(3494),
    [anon_sym___cdecl] = ACTIONS(3494),
    [anon_sym___clrcall] = ACTIONS(3494),
    [anon_sym___stdcall] = ACTIONS(3494),
    [anon_sym___fastcall] = ACTIONS(3494),
    [anon_sym___thiscall] = ACTIONS(3494),
    [anon_sym___vectorcall] = ACTIONS(3494),
    [anon_sym_LBRACE] = ACTIONS(3496),
    [anon_sym_signed] = ACTIONS(3494),
    [anon_sym_unsigned] = ACTIONS(3494),
    [anon_sym_long] = ACTIONS(3494),
    [anon_sym_short] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_register] = ACTIONS(3494),
    [anon_sym_inline] = ACTIONS(3494),
    [anon_sym___inline] = ACTIONS(3494),
    [anon_sym___inline__] = ACTIONS(3494),
    [anon_sym___forceinline] = ACTIONS(3494),
    [anon_sym_thread_local] = ACTIONS(3494),
    [anon_sym___thread] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_constexpr] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_restrict] = ACTIONS(3494),
    [anon_sym___restrict__] = ACTIONS(3494),
    [anon_sym__Atomic] = ACTIONS(3494),
    [anon_sym__Noreturn] = ACTIONS(3494),
    [anon_sym_noreturn] = ACTIONS(3494),
    [anon_sym__Nonnull] = ACTIONS(3494),
    [anon_sym_mutable] = ACTIONS(3494),
    [anon_sym_constinit] = ACTIONS(3494),
    [anon_sym_consteval] = ACTIONS(3494),
    [anon_sym_alignas] = ACTIONS(3494),
    [anon_sym__Alignas] = ACTIONS(3494),
    [sym_primitive_type] = ACTIONS(3494),
    [anon_sym_enum] = ACTIONS(3494),
    [anon_sym_class] = ACTIONS(3494),
    [anon_sym_struct] = ACTIONS(3494),
    [anon_sym_union] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_else] = ACTIONS(3494),
    [anon_sym_switch] = ACTIONS(3494),
    [anon_sym_case] = ACTIONS(3494),
    [anon_sym_default] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_break] = ACTIONS(3494),
    [anon_sym_continue] = ACTIONS(3494),
    [anon_sym_goto] = ACTIONS(3494),
    [anon_sym___try] = ACTIONS(3494),
    [anon_sym___leave] = ACTIONS(3494),
    [anon_sym_not] = ACTIONS(3494),
    [anon_sym_compl] = ACTIONS(3494),
    [anon_sym_DASH_DASH] = ACTIONS(3496),
    [anon_sym_PLUS_PLUS] = ACTIONS(3496),
    [anon_sym_sizeof] = ACTIONS(3494),
    [anon_sym___alignof__] = ACTIONS(3494),
    [anon_sym___alignof] = ACTIONS(3494),
    [anon_sym__alignof] = ACTIONS(3494),
    [anon_sym_alignof] = ACTIONS(3494),
    [anon_sym__Alignof] = ACTIONS(3494),
    [anon_sym_offsetof] = ACTIONS(3494),
    [anon_sym__Generic] = ACTIONS(3494),
    [anon_sym_asm] = ACTIONS(3494),
    [anon_sym___asm__] = ACTIONS(3494),
    [anon_sym___asm] = ACTIONS(3494),
    [sym_number_literal] = ACTIONS(3496),
    [anon_sym_L_SQUOTE] = ACTIONS(3496),
    [anon_sym_u_SQUOTE] = ACTIONS(3496),
    [anon_sym_U_SQUOTE] = ACTIONS(3496),
    [anon_sym_u8_SQUOTE] = ACTIONS(3496),
    [anon_sym_SQUOTE] = ACTIONS(3496),
    [anon_sym_L_DQUOTE] = ACTIONS(3496),
    [anon_sym_u_DQUOTE] = ACTIONS(3496),
    [anon_sym_U_DQUOTE] = ACTIONS(3496),
    [anon_sym_u8_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE] = ACTIONS(3496),
    [sym_true] = ACTIONS(3494),
    [sym_false] = ACTIONS(3494),
    [anon_sym_NULL] = ACTIONS(3494),
    [anon_sym_nullptr] = ACTIONS(3494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_This] = ACTIONS(3494),
    [anon_sym_decltype] = ACTIONS(3494),
    [anon_sym_explicit] = ACTIONS(3494),
    [anon_sym_typename] = ACTIONS(3494),
    [anon_sym_template] = ACTIONS(3494),
    [anon_sym_operator] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_delete] = ACTIONS(3494),
    [anon_sym_throw] = ACTIONS(3494),
    [anon_sym_namespace] = ACTIONS(3494),
    [anon_sym_static_assert] = ACTIONS(3494),
    [anon_sym_concept] = ACTIONS(3494),
    [anon_sym_co_return] = ACTIONS(3494),
    [anon_sym_co_yield] = ACTIONS(3494),
    [anon_sym_R_DQUOTE] = ACTIONS(3496),
    [anon_sym_LR_DQUOTE] = ACTIONS(3496),
    [anon_sym_uR_DQUOTE] = ACTIONS(3496),
    [anon_sym_UR_DQUOTE] = ACTIONS(3496),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3496),
    [anon_sym_co_await] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_requires] = ACTIONS(3494),
    [sym_this] = ACTIONS(3494),
    [anon_sym_discard] = ACTIONS(3494),
    [anon_sym_precise] = ACTIONS(3494),
    [anon_sym_shared] = ACTIONS(3494),
    [anon_sym_groupshared] = ACTIONS(3494),
    [anon_sym_uniform] = ACTIONS(3494),
    [anon_sym_row_major] = ACTIONS(3494),
    [anon_sym_column_major] = ACTIONS(3494),
    [anon_sym_globallycoherent] = ACTIONS(3494),
    [anon_sym_centroid] = ACTIONS(3494),
    [anon_sym_noperspective] = ACTIONS(3494),
    [anon_sym_nointerpolation] = ACTIONS(3494),
    [anon_sym_sample] = ACTIONS(3494),
    [anon_sym_linear] = ACTIONS(3494),
    [anon_sym_snorm] = ACTIONS(3494),
    [anon_sym_unorm] = ACTIONS(3494),
    [anon_sym_point] = ACTIONS(3494),
    [anon_sym_line] = ACTIONS(3494),
    [anon_sym_triangleadj] = ACTIONS(3494),
    [anon_sym_lineadj] = ACTIONS(3494),
    [anon_sym_triangle] = ACTIONS(3494),
    [anon_sym_cbuffer] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_extension] = ACTIONS(3494),
  },
  [413] = {
    [ts_builtin_sym_end] = ACTIONS(3498),
    [sym_identifier] = ACTIONS(3500),
    [aux_sym_preproc_include_token1] = ACTIONS(3500),
    [aux_sym_preproc_def_token1] = ACTIONS(3500),
    [aux_sym_preproc_if_token1] = ACTIONS(3500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3500),
    [sym_preproc_directive] = ACTIONS(3500),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3500),
    [anon_sym_PLUS] = ACTIONS(3500),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_AMP] = ACTIONS(3500),
    [anon_sym_SEMI] = ACTIONS(3498),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_typedef] = ACTIONS(3500),
    [anon_sym_in] = ACTIONS(3500),
    [anon_sym_out] = ACTIONS(3500),
    [anon_sym_inout] = ACTIONS(3500),
    [anon_sym_virtual] = ACTIONS(3500),
    [anon_sym_extern] = ACTIONS(3500),
    [anon_sym___attribute__] = ACTIONS(3500),
    [anon_sym___attribute] = ACTIONS(3500),
    [anon_sym_using] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3498),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3498),
    [anon_sym___declspec] = ACTIONS(3500),
    [anon_sym___based] = ACTIONS(3500),
    [anon_sym___cdecl] = ACTIONS(3500),
    [anon_sym___clrcall] = ACTIONS(3500),
    [anon_sym___stdcall] = ACTIONS(3500),
    [anon_sym___fastcall] = ACTIONS(3500),
    [anon_sym___thiscall] = ACTIONS(3500),
    [anon_sym___vectorcall] = ACTIONS(3500),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_signed] = ACTIONS(3500),
    [anon_sym_unsigned] = ACTIONS(3500),
    [anon_sym_long] = ACTIONS(3500),
    [anon_sym_short] = ACTIONS(3500),
    [anon_sym_LBRACK] = ACTIONS(3500),
    [anon_sym_static] = ACTIONS(3500),
    [anon_sym_register] = ACTIONS(3500),
    [anon_sym_inline] = ACTIONS(3500),
    [anon_sym___inline] = ACTIONS(3500),
    [anon_sym___inline__] = ACTIONS(3500),
    [anon_sym___forceinline] = ACTIONS(3500),
    [anon_sym_thread_local] = ACTIONS(3500),
    [anon_sym___thread] = ACTIONS(3500),
    [anon_sym_const] = ACTIONS(3500),
    [anon_sym_constexpr] = ACTIONS(3500),
    [anon_sym_volatile] = ACTIONS(3500),
    [anon_sym_restrict] = ACTIONS(3500),
    [anon_sym___restrict__] = ACTIONS(3500),
    [anon_sym__Atomic] = ACTIONS(3500),
    [anon_sym__Noreturn] = ACTIONS(3500),
    [anon_sym_noreturn] = ACTIONS(3500),
    [anon_sym__Nonnull] = ACTIONS(3500),
    [anon_sym_mutable] = ACTIONS(3500),
    [anon_sym_constinit] = ACTIONS(3500),
    [anon_sym_consteval] = ACTIONS(3500),
    [anon_sym_alignas] = ACTIONS(3500),
    [anon_sym__Alignas] = ACTIONS(3500),
    [sym_primitive_type] = ACTIONS(3500),
    [anon_sym_enum] = ACTIONS(3500),
    [anon_sym_class] = ACTIONS(3500),
    [anon_sym_struct] = ACTIONS(3500),
    [anon_sym_union] = ACTIONS(3500),
    [anon_sym_if] = ACTIONS(3500),
    [anon_sym_else] = ACTIONS(3500),
    [anon_sym_switch] = ACTIONS(3500),
    [anon_sym_case] = ACTIONS(3500),
    [anon_sym_default] = ACTIONS(3500),
    [anon_sym_while] = ACTIONS(3500),
    [anon_sym_do] = ACTIONS(3500),
    [anon_sym_for] = ACTIONS(3500),
    [anon_sym_return] = ACTIONS(3500),
    [anon_sym_break] = ACTIONS(3500),
    [anon_sym_continue] = ACTIONS(3500),
    [anon_sym_goto] = ACTIONS(3500),
    [anon_sym___try] = ACTIONS(3500),
    [anon_sym___leave] = ACTIONS(3500),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_compl] = ACTIONS(3500),
    [anon_sym_DASH_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_PLUS] = ACTIONS(3498),
    [anon_sym_sizeof] = ACTIONS(3500),
    [anon_sym___alignof__] = ACTIONS(3500),
    [anon_sym___alignof] = ACTIONS(3500),
    [anon_sym__alignof] = ACTIONS(3500),
    [anon_sym_alignof] = ACTIONS(3500),
    [anon_sym__Alignof] = ACTIONS(3500),
    [anon_sym_offsetof] = ACTIONS(3500),
    [anon_sym__Generic] = ACTIONS(3500),
    [anon_sym_asm] = ACTIONS(3500),
    [anon_sym___asm__] = ACTIONS(3500),
    [anon_sym___asm] = ACTIONS(3500),
    [sym_number_literal] = ACTIONS(3498),
    [anon_sym_L_SQUOTE] = ACTIONS(3498),
    [anon_sym_u_SQUOTE] = ACTIONS(3498),
    [anon_sym_U_SQUOTE] = ACTIONS(3498),
    [anon_sym_u8_SQUOTE] = ACTIONS(3498),
    [anon_sym_SQUOTE] = ACTIONS(3498),
    [anon_sym_L_DQUOTE] = ACTIONS(3498),
    [anon_sym_u_DQUOTE] = ACTIONS(3498),
    [anon_sym_U_DQUOTE] = ACTIONS(3498),
    [anon_sym_u8_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [sym_true] = ACTIONS(3500),
    [sym_false] = ACTIONS(3500),
    [anon_sym_NULL] = ACTIONS(3500),
    [anon_sym_nullptr] = ACTIONS(3500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3500),
    [anon_sym_let] = ACTIONS(3500),
    [anon_sym_This] = ACTIONS(3500),
    [anon_sym_decltype] = ACTIONS(3500),
    [anon_sym_explicit] = ACTIONS(3500),
    [anon_sym_typename] = ACTIONS(3500),
    [anon_sym_export] = ACTIONS(3500),
    [anon_sym_module] = ACTIONS(3500),
    [anon_sym_import] = ACTIONS(3500),
    [anon_sym_template] = ACTIONS(3500),
    [anon_sym_operator] = ACTIONS(3500),
    [anon_sym_try] = ACTIONS(3500),
    [anon_sym_delete] = ACTIONS(3500),
    [anon_sym_throw] = ACTIONS(3500),
    [anon_sym_namespace] = ACTIONS(3500),
    [anon_sym_static_assert] = ACTIONS(3500),
    [anon_sym_concept] = ACTIONS(3500),
    [anon_sym_co_return] = ACTIONS(3500),
    [anon_sym_co_yield] = ACTIONS(3500),
    [anon_sym_R_DQUOTE] = ACTIONS(3498),
    [anon_sym_LR_DQUOTE] = ACTIONS(3498),
    [anon_sym_uR_DQUOTE] = ACTIONS(3498),
    [anon_sym_UR_DQUOTE] = ACTIONS(3498),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3498),
    [anon_sym_co_await] = ACTIONS(3500),
    [anon_sym_new] = ACTIONS(3500),
    [anon_sym_requires] = ACTIONS(3500),
    [sym_this] = ACTIONS(3500),
    [anon_sym_discard] = ACTIONS(3500),
    [anon_sym_precise] = ACTIONS(3500),
    [anon_sym_shared] = ACTIONS(3500),
    [anon_sym_groupshared] = ACTIONS(3500),
    [anon_sym_uniform] = ACTIONS(3500),
    [anon_sym_row_major] = ACTIONS(3500),
    [anon_sym_column_major] = ACTIONS(3500),
    [anon_sym_globallycoherent] = ACTIONS(3500),
    [anon_sym_centroid] = ACTIONS(3500),
    [anon_sym_noperspective] = ACTIONS(3500),
    [anon_sym_nointerpolation] = ACTIONS(3500),
    [anon_sym_sample] = ACTIONS(3500),
    [anon_sym_linear] = ACTIONS(3500),
    [anon_sym_snorm] = ACTIONS(3500),
    [anon_sym_unorm] = ACTIONS(3500),
    [anon_sym_point] = ACTIONS(3500),
    [anon_sym_line] = ACTIONS(3500),
    [anon_sym_triangleadj] = ACTIONS(3500),
    [anon_sym_lineadj] = ACTIONS(3500),
    [anon_sym_triangle] = ACTIONS(3500),
    [anon_sym_cbuffer] = ACTIONS(3500),
    [anon_sym_interface] = ACTIONS(3500),
    [anon_sym_extension] = ACTIONS(3500),
    [anon_sym___exported] = ACTIONS(3500),
  },
  [414] = {
    [sym_attribute_specifier] = STATE(778),
    [sym_enumerator_list] = STATE(707),
    [sym__enum_base_clause] = STATE(641),
    [sym_identifier] = ACTIONS(3502),
    [aux_sym_preproc_include_token1] = ACTIONS(3502),
    [aux_sym_preproc_def_token1] = ACTIONS(3502),
    [aux_sym_preproc_if_token1] = ACTIONS(3502),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3502),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3502),
    [sym_preproc_directive] = ACTIONS(3502),
    [anon_sym_LPAREN2] = ACTIONS(3504),
    [anon_sym_BANG] = ACTIONS(3504),
    [anon_sym_TILDE] = ACTIONS(3504),
    [anon_sym_DASH] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(3502),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_AMP_AMP] = ACTIONS(3504),
    [anon_sym_AMP] = ACTIONS(3502),
    [anon_sym_COLON] = ACTIONS(3482),
    [anon_sym_SEMI] = ACTIONS(3504),
    [anon_sym___extension__] = ACTIONS(3502),
    [anon_sym_typedef] = ACTIONS(3502),
    [anon_sym_in] = ACTIONS(3502),
    [anon_sym_out] = ACTIONS(3502),
    [anon_sym_inout] = ACTIONS(3502),
    [anon_sym_virtual] = ACTIONS(3502),
    [anon_sym_extern] = ACTIONS(3502),
    [anon_sym___attribute__] = ACTIONS(2897),
    [anon_sym___attribute] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(3502),
    [anon_sym_COLON_COLON] = ACTIONS(3504),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3504),
    [anon_sym___declspec] = ACTIONS(3502),
    [anon_sym___based] = ACTIONS(3502),
    [anon_sym___cdecl] = ACTIONS(3502),
    [anon_sym___clrcall] = ACTIONS(3502),
    [anon_sym___stdcall] = ACTIONS(3502),
    [anon_sym___fastcall] = ACTIONS(3502),
    [anon_sym___thiscall] = ACTIONS(3502),
    [anon_sym___vectorcall] = ACTIONS(3502),
    [anon_sym_LBRACE] = ACTIONS(3484),
    [anon_sym_RBRACE] = ACTIONS(3504),
    [anon_sym_signed] = ACTIONS(3502),
    [anon_sym_unsigned] = ACTIONS(3502),
    [anon_sym_long] = ACTIONS(3502),
    [anon_sym_short] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(3502),
    [anon_sym_static] = ACTIONS(3502),
    [anon_sym_register] = ACTIONS(3502),
    [anon_sym_inline] = ACTIONS(3502),
    [anon_sym___inline] = ACTIONS(3502),
    [anon_sym___inline__] = ACTIONS(3502),
    [anon_sym___forceinline] = ACTIONS(3502),
    [anon_sym_thread_local] = ACTIONS(3502),
    [anon_sym___thread] = ACTIONS(3502),
    [anon_sym_const] = ACTIONS(3502),
    [anon_sym_constexpr] = ACTIONS(3502),
    [anon_sym_volatile] = ACTIONS(3502),
    [anon_sym_restrict] = ACTIONS(3502),
    [anon_sym___restrict__] = ACTIONS(3502),
    [anon_sym__Atomic] = ACTIONS(3502),
    [anon_sym__Noreturn] = ACTIONS(3502),
    [anon_sym_noreturn] = ACTIONS(3502),
    [anon_sym__Nonnull] = ACTIONS(3502),
    [anon_sym_mutable] = ACTIONS(3502),
    [anon_sym_constinit] = ACTIONS(3502),
    [anon_sym_consteval] = ACTIONS(3502),
    [anon_sym_alignas] = ACTIONS(3502),
    [anon_sym__Alignas] = ACTIONS(3502),
    [sym_primitive_type] = ACTIONS(3502),
    [anon_sym_enum] = ACTIONS(3502),
    [anon_sym_class] = ACTIONS(3502),
    [anon_sym_struct] = ACTIONS(3502),
    [anon_sym_union] = ACTIONS(3502),
    [anon_sym_if] = ACTIONS(3502),
    [anon_sym_switch] = ACTIONS(3502),
    [anon_sym_case] = ACTIONS(3502),
    [anon_sym_default] = ACTIONS(3502),
    [anon_sym_while] = ACTIONS(3502),
    [anon_sym_do] = ACTIONS(3502),
    [anon_sym_for] = ACTIONS(3502),
    [anon_sym_return] = ACTIONS(3502),
    [anon_sym_break] = ACTIONS(3502),
    [anon_sym_continue] = ACTIONS(3502),
    [anon_sym_goto] = ACTIONS(3502),
    [anon_sym___try] = ACTIONS(3502),
    [anon_sym___leave] = ACTIONS(3502),
    [anon_sym_not] = ACTIONS(3502),
    [anon_sym_compl] = ACTIONS(3502),
    [anon_sym_DASH_DASH] = ACTIONS(3504),
    [anon_sym_PLUS_PLUS] = ACTIONS(3504),
    [anon_sym_sizeof] = ACTIONS(3502),
    [anon_sym___alignof__] = ACTIONS(3502),
    [anon_sym___alignof] = ACTIONS(3502),
    [anon_sym__alignof] = ACTIONS(3502),
    [anon_sym_alignof] = ACTIONS(3502),
    [anon_sym__Alignof] = ACTIONS(3502),
    [anon_sym_offsetof] = ACTIONS(3502),
    [anon_sym__Generic] = ACTIONS(3502),
    [anon_sym_asm] = ACTIONS(3502),
    [anon_sym___asm__] = ACTIONS(3502),
    [anon_sym___asm] = ACTIONS(3502),
    [anon_sym_DOT] = ACTIONS(3502),
    [sym_number_literal] = ACTIONS(3504),
    [anon_sym_L_SQUOTE] = ACTIONS(3504),
    [anon_sym_u_SQUOTE] = ACTIONS(3504),
    [anon_sym_U_SQUOTE] = ACTIONS(3504),
    [anon_sym_u8_SQUOTE] = ACTIONS(3504),
    [anon_sym_SQUOTE] = ACTIONS(3504),
    [anon_sym_L_DQUOTE] = ACTIONS(3504),
    [anon_sym_u_DQUOTE] = ACTIONS(3504),
    [anon_sym_U_DQUOTE] = ACTIONS(3504),
    [anon_sym_u8_DQUOTE] = ACTIONS(3504),
    [anon_sym_DQUOTE] = ACTIONS(3504),
    [sym_true] = ACTIONS(3502),
    [sym_false] = ACTIONS(3502),
    [anon_sym_NULL] = ACTIONS(3502),
    [anon_sym_nullptr] = ACTIONS(3502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3502),
    [anon_sym_let] = ACTIONS(3502),
    [anon_sym_This] = ACTIONS(3502),
    [anon_sym_decltype] = ACTIONS(3502),
    [anon_sym_explicit] = ACTIONS(3502),
    [anon_sym_typename] = ACTIONS(3502),
    [anon_sym_template] = ACTIONS(3502),
    [anon_sym_operator] = ACTIONS(3502),
    [anon_sym_try] = ACTIONS(3502),
    [anon_sym_delete] = ACTIONS(3502),
    [anon_sym_throw] = ACTIONS(3502),
    [anon_sym_namespace] = ACTIONS(3502),
    [anon_sym_static_assert] = ACTIONS(3502),
    [anon_sym_concept] = ACTIONS(3502),
    [anon_sym_co_return] = ACTIONS(3502),
    [anon_sym_co_yield] = ACTIONS(3502),
    [anon_sym_R_DQUOTE] = ACTIONS(3504),
    [anon_sym_LR_DQUOTE] = ACTIONS(3504),
    [anon_sym_uR_DQUOTE] = ACTIONS(3504),
    [anon_sym_UR_DQUOTE] = ACTIONS(3504),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3504),
    [anon_sym_co_await] = ACTIONS(3502),
    [anon_sym_new] = ACTIONS(3502),
    [anon_sym_requires] = ACTIONS(3502),
    [sym_this] = ACTIONS(3502),
    [anon_sym_discard] = ACTIONS(3502),
    [anon_sym_precise] = ACTIONS(3502),
    [anon_sym_shared] = ACTIONS(3502),
    [anon_sym_groupshared] = ACTIONS(3502),
    [anon_sym_uniform] = ACTIONS(3502),
    [anon_sym_row_major] = ACTIONS(3502),
    [anon_sym_column_major] = ACTIONS(3502),
    [anon_sym_globallycoherent] = ACTIONS(3502),
    [anon_sym_centroid] = ACTIONS(3502),
    [anon_sym_noperspective] = ACTIONS(3502),
    [anon_sym_nointerpolation] = ACTIONS(3502),
    [anon_sym_sample] = ACTIONS(3502),
    [anon_sym_linear] = ACTIONS(3502),
    [anon_sym_snorm] = ACTIONS(3502),
    [anon_sym_unorm] = ACTIONS(3502),
    [anon_sym_point] = ACTIONS(3502),
    [anon_sym_line] = ACTIONS(3502),
    [anon_sym_triangleadj] = ACTIONS(3502),
    [anon_sym_lineadj] = ACTIONS(3502),
    [anon_sym_triangle] = ACTIONS(3502),
    [anon_sym_cbuffer] = ACTIONS(3502),
    [anon_sym_interface] = ACTIONS(3502),
    [anon_sym_extension] = ACTIONS(3502),
  },
  [415] = {
    [sym_identifier] = ACTIONS(3506),
    [aux_sym_preproc_include_token1] = ACTIONS(3506),
    [aux_sym_preproc_def_token1] = ACTIONS(3506),
    [aux_sym_preproc_if_token1] = ACTIONS(3506),
    [aux_sym_preproc_if_token2] = ACTIONS(3506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3506),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3506),
    [aux_sym_preproc_else_token1] = ACTIONS(3506),
    [aux_sym_preproc_elif_token1] = ACTIONS(3506),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3506),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3506),
    [sym_preproc_directive] = ACTIONS(3506),
    [anon_sym_LPAREN2] = ACTIONS(3508),
    [anon_sym_BANG] = ACTIONS(3508),
    [anon_sym_TILDE] = ACTIONS(3508),
    [anon_sym_DASH] = ACTIONS(3506),
    [anon_sym_PLUS] = ACTIONS(3506),
    [anon_sym_STAR] = ACTIONS(3508),
    [anon_sym_AMP_AMP] = ACTIONS(3508),
    [anon_sym_AMP] = ACTIONS(3506),
    [anon_sym_SEMI] = ACTIONS(3508),
    [anon_sym___extension__] = ACTIONS(3506),
    [anon_sym_typedef] = ACTIONS(3506),
    [anon_sym_in] = ACTIONS(3506),
    [anon_sym_out] = ACTIONS(3506),
    [anon_sym_inout] = ACTIONS(3506),
    [anon_sym_virtual] = ACTIONS(3506),
    [anon_sym_extern] = ACTIONS(3506),
    [anon_sym___attribute__] = ACTIONS(3506),
    [anon_sym___attribute] = ACTIONS(3506),
    [anon_sym_using] = ACTIONS(3506),
    [anon_sym_COLON_COLON] = ACTIONS(3508),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3508),
    [anon_sym___declspec] = ACTIONS(3506),
    [anon_sym___based] = ACTIONS(3506),
    [anon_sym___cdecl] = ACTIONS(3506),
    [anon_sym___clrcall] = ACTIONS(3506),
    [anon_sym___stdcall] = ACTIONS(3506),
    [anon_sym___fastcall] = ACTIONS(3506),
    [anon_sym___thiscall] = ACTIONS(3506),
    [anon_sym___vectorcall] = ACTIONS(3506),
    [anon_sym_LBRACE] = ACTIONS(3508),
    [anon_sym_signed] = ACTIONS(3506),
    [anon_sym_unsigned] = ACTIONS(3506),
    [anon_sym_long] = ACTIONS(3506),
    [anon_sym_short] = ACTIONS(3506),
    [anon_sym_LBRACK] = ACTIONS(3506),
    [anon_sym_static] = ACTIONS(3506),
    [anon_sym_register] = ACTIONS(3506),
    [anon_sym_inline] = ACTIONS(3506),
    [anon_sym___inline] = ACTIONS(3506),
    [anon_sym___inline__] = ACTIONS(3506),
    [anon_sym___forceinline] = ACTIONS(3506),
    [anon_sym_thread_local] = ACTIONS(3506),
    [anon_sym___thread] = ACTIONS(3506),
    [anon_sym_const] = ACTIONS(3506),
    [anon_sym_constexpr] = ACTIONS(3506),
    [anon_sym_volatile] = ACTIONS(3506),
    [anon_sym_restrict] = ACTIONS(3506),
    [anon_sym___restrict__] = ACTIONS(3506),
    [anon_sym__Atomic] = ACTIONS(3506),
    [anon_sym__Noreturn] = ACTIONS(3506),
    [anon_sym_noreturn] = ACTIONS(3506),
    [anon_sym__Nonnull] = ACTIONS(3506),
    [anon_sym_mutable] = ACTIONS(3506),
    [anon_sym_constinit] = ACTIONS(3506),
    [anon_sym_consteval] = ACTIONS(3506),
    [anon_sym_alignas] = ACTIONS(3506),
    [anon_sym__Alignas] = ACTIONS(3506),
    [sym_primitive_type] = ACTIONS(3506),
    [anon_sym_enum] = ACTIONS(3506),
    [anon_sym_class] = ACTIONS(3506),
    [anon_sym_struct] = ACTIONS(3506),
    [anon_sym_union] = ACTIONS(3506),
    [anon_sym_if] = ACTIONS(3506),
    [anon_sym_else] = ACTIONS(3506),
    [anon_sym_switch] = ACTIONS(3506),
    [anon_sym_case] = ACTIONS(3506),
    [anon_sym_default] = ACTIONS(3506),
    [anon_sym_while] = ACTIONS(3506),
    [anon_sym_do] = ACTIONS(3506),
    [anon_sym_for] = ACTIONS(3506),
    [anon_sym_return] = ACTIONS(3506),
    [anon_sym_break] = ACTIONS(3506),
    [anon_sym_continue] = ACTIONS(3506),
    [anon_sym_goto] = ACTIONS(3506),
    [anon_sym___try] = ACTIONS(3506),
    [anon_sym___leave] = ACTIONS(3506),
    [anon_sym_not] = ACTIONS(3506),
    [anon_sym_compl] = ACTIONS(3506),
    [anon_sym_DASH_DASH] = ACTIONS(3508),
    [anon_sym_PLUS_PLUS] = ACTIONS(3508),
    [anon_sym_sizeof] = ACTIONS(3506),
    [anon_sym___alignof__] = ACTIONS(3506),
    [anon_sym___alignof] = ACTIONS(3506),
    [anon_sym__alignof] = ACTIONS(3506),
    [anon_sym_alignof] = ACTIONS(3506),
    [anon_sym__Alignof] = ACTIONS(3506),
    [anon_sym_offsetof] = ACTIONS(3506),
    [anon_sym__Generic] = ACTIONS(3506),
    [anon_sym_asm] = ACTIONS(3506),
    [anon_sym___asm__] = ACTIONS(3506),
    [anon_sym___asm] = ACTIONS(3506),
    [sym_number_literal] = ACTIONS(3508),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3508),
    [anon_sym_u_DQUOTE] = ACTIONS(3508),
    [anon_sym_U_DQUOTE] = ACTIONS(3508),
    [anon_sym_u8_DQUOTE] = ACTIONS(3508),
    [anon_sym_DQUOTE] = ACTIONS(3508),
    [sym_true] = ACTIONS(3506),
    [sym_false] = ACTIONS(3506),
    [anon_sym_NULL] = ACTIONS(3506),
    [anon_sym_nullptr] = ACTIONS(3506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3506),
    [anon_sym_let] = ACTIONS(3506),
    [anon_sym_This] = ACTIONS(3506),
    [anon_sym_decltype] = ACTIONS(3506),
    [anon_sym_explicit] = ACTIONS(3506),
    [anon_sym_typename] = ACTIONS(3506),
    [anon_sym_template] = ACTIONS(3506),
    [anon_sym_operator] = ACTIONS(3506),
    [anon_sym_try] = ACTIONS(3506),
    [anon_sym_delete] = ACTIONS(3506),
    [anon_sym_throw] = ACTIONS(3506),
    [anon_sym_namespace] = ACTIONS(3506),
    [anon_sym_static_assert] = ACTIONS(3506),
    [anon_sym_concept] = ACTIONS(3506),
    [anon_sym_co_return] = ACTIONS(3506),
    [anon_sym_co_yield] = ACTIONS(3506),
    [anon_sym_R_DQUOTE] = ACTIONS(3508),
    [anon_sym_LR_DQUOTE] = ACTIONS(3508),
    [anon_sym_uR_DQUOTE] = ACTIONS(3508),
    [anon_sym_UR_DQUOTE] = ACTIONS(3508),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3508),
    [anon_sym_co_await] = ACTIONS(3506),
    [anon_sym_new] = ACTIONS(3506),
    [anon_sym_requires] = ACTIONS(3506),
    [sym_this] = ACTIONS(3506),
    [anon_sym_discard] = ACTIONS(3506),
    [anon_sym_precise] = ACTIONS(3506),
    [anon_sym_shared] = ACTIONS(3506),
    [anon_sym_groupshared] = ACTIONS(3506),
    [anon_sym_uniform] = ACTIONS(3506),
    [anon_sym_row_major] = ACTIONS(3506),
    [anon_sym_column_major] = ACTIONS(3506),
    [anon_sym_globallycoherent] = ACTIONS(3506),
    [anon_sym_centroid] = ACTIONS(3506),
    [anon_sym_noperspective] = ACTIONS(3506),
    [anon_sym_nointerpolation] = ACTIONS(3506),
    [anon_sym_sample] = ACTIONS(3506),
    [anon_sym_linear] = ACTIONS(3506),
    [anon_sym_snorm] = ACTIONS(3506),
    [anon_sym_unorm] = ACTIONS(3506),
    [anon_sym_point] = ACTIONS(3506),
    [anon_sym_line] = ACTIONS(3506),
    [anon_sym_triangleadj] = ACTIONS(3506),
    [anon_sym_lineadj] = ACTIONS(3506),
    [anon_sym_triangle] = ACTIONS(3506),
    [anon_sym_cbuffer] = ACTIONS(3506),
    [anon_sym_interface] = ACTIONS(3506),
    [anon_sym_extension] = ACTIONS(3506),
  },
  [416] = {
    [sym_identifier] = ACTIONS(3488),
    [aux_sym_preproc_include_token1] = ACTIONS(3488),
    [aux_sym_preproc_def_token1] = ACTIONS(3488),
    [aux_sym_preproc_if_token1] = ACTIONS(3488),
    [aux_sym_preproc_if_token2] = ACTIONS(3488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3488),
    [aux_sym_preproc_else_token1] = ACTIONS(3488),
    [aux_sym_preproc_elif_token1] = ACTIONS(3488),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3488),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3488),
    [sym_preproc_directive] = ACTIONS(3488),
    [anon_sym_LPAREN2] = ACTIONS(3486),
    [anon_sym_BANG] = ACTIONS(3486),
    [anon_sym_TILDE] = ACTIONS(3486),
    [anon_sym_DASH] = ACTIONS(3488),
    [anon_sym_PLUS] = ACTIONS(3488),
    [anon_sym_STAR] = ACTIONS(3486),
    [anon_sym_AMP_AMP] = ACTIONS(3486),
    [anon_sym_AMP] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3486),
    [anon_sym___extension__] = ACTIONS(3488),
    [anon_sym_typedef] = ACTIONS(3488),
    [anon_sym_in] = ACTIONS(3488),
    [anon_sym_out] = ACTIONS(3488),
    [anon_sym_inout] = ACTIONS(3488),
    [anon_sym_virtual] = ACTIONS(3488),
    [anon_sym_extern] = ACTIONS(3488),
    [anon_sym___attribute__] = ACTIONS(3488),
    [anon_sym___attribute] = ACTIONS(3488),
    [anon_sym_using] = ACTIONS(3488),
    [anon_sym_COLON_COLON] = ACTIONS(3486),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3486),
    [anon_sym___declspec] = ACTIONS(3488),
    [anon_sym___based] = ACTIONS(3488),
    [anon_sym___cdecl] = ACTIONS(3488),
    [anon_sym___clrcall] = ACTIONS(3488),
    [anon_sym___stdcall] = ACTIONS(3488),
    [anon_sym___fastcall] = ACTIONS(3488),
    [anon_sym___thiscall] = ACTIONS(3488),
    [anon_sym___vectorcall] = ACTIONS(3488),
    [anon_sym_LBRACE] = ACTIONS(3486),
    [anon_sym_signed] = ACTIONS(3488),
    [anon_sym_unsigned] = ACTIONS(3488),
    [anon_sym_long] = ACTIONS(3488),
    [anon_sym_short] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(3488),
    [anon_sym_static] = ACTIONS(3488),
    [anon_sym_register] = ACTIONS(3488),
    [anon_sym_inline] = ACTIONS(3488),
    [anon_sym___inline] = ACTIONS(3488),
    [anon_sym___inline__] = ACTIONS(3488),
    [anon_sym___forceinline] = ACTIONS(3488),
    [anon_sym_thread_local] = ACTIONS(3488),
    [anon_sym___thread] = ACTIONS(3488),
    [anon_sym_const] = ACTIONS(3488),
    [anon_sym_constexpr] = ACTIONS(3488),
    [anon_sym_volatile] = ACTIONS(3488),
    [anon_sym_restrict] = ACTIONS(3488),
    [anon_sym___restrict__] = ACTIONS(3488),
    [anon_sym__Atomic] = ACTIONS(3488),
    [anon_sym__Noreturn] = ACTIONS(3488),
    [anon_sym_noreturn] = ACTIONS(3488),
    [anon_sym__Nonnull] = ACTIONS(3488),
    [anon_sym_mutable] = ACTIONS(3488),
    [anon_sym_constinit] = ACTIONS(3488),
    [anon_sym_consteval] = ACTIONS(3488),
    [anon_sym_alignas] = ACTIONS(3488),
    [anon_sym__Alignas] = ACTIONS(3488),
    [sym_primitive_type] = ACTIONS(3488),
    [anon_sym_enum] = ACTIONS(3488),
    [anon_sym_class] = ACTIONS(3488),
    [anon_sym_struct] = ACTIONS(3488),
    [anon_sym_union] = ACTIONS(3488),
    [anon_sym_if] = ACTIONS(3488),
    [anon_sym_else] = ACTIONS(3488),
    [anon_sym_switch] = ACTIONS(3488),
    [anon_sym_case] = ACTIONS(3488),
    [anon_sym_default] = ACTIONS(3488),
    [anon_sym_while] = ACTIONS(3488),
    [anon_sym_do] = ACTIONS(3488),
    [anon_sym_for] = ACTIONS(3488),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_break] = ACTIONS(3488),
    [anon_sym_continue] = ACTIONS(3488),
    [anon_sym_goto] = ACTIONS(3488),
    [anon_sym___try] = ACTIONS(3488),
    [anon_sym___leave] = ACTIONS(3488),
    [anon_sym_not] = ACTIONS(3488),
    [anon_sym_compl] = ACTIONS(3488),
    [anon_sym_DASH_DASH] = ACTIONS(3486),
    [anon_sym_PLUS_PLUS] = ACTIONS(3486),
    [anon_sym_sizeof] = ACTIONS(3488),
    [anon_sym___alignof__] = ACTIONS(3488),
    [anon_sym___alignof] = ACTIONS(3488),
    [anon_sym__alignof] = ACTIONS(3488),
    [anon_sym_alignof] = ACTIONS(3488),
    [anon_sym__Alignof] = ACTIONS(3488),
    [anon_sym_offsetof] = ACTIONS(3488),
    [anon_sym__Generic] = ACTIONS(3488),
    [anon_sym_asm] = ACTIONS(3488),
    [anon_sym___asm__] = ACTIONS(3488),
    [anon_sym___asm] = ACTIONS(3488),
    [sym_number_literal] = ACTIONS(3486),
    [anon_sym_L_SQUOTE] = ACTIONS(3486),
    [anon_sym_u_SQUOTE] = ACTIONS(3486),
    [anon_sym_U_SQUOTE] = ACTIONS(3486),
    [anon_sym_u8_SQUOTE] = ACTIONS(3486),
    [anon_sym_SQUOTE] = ACTIONS(3486),
    [anon_sym_L_DQUOTE] = ACTIONS(3486),
    [anon_sym_u_DQUOTE] = ACTIONS(3486),
    [anon_sym_U_DQUOTE] = ACTIONS(3486),
    [anon_sym_u8_DQUOTE] = ACTIONS(3486),
    [anon_sym_DQUOTE] = ACTIONS(3486),
    [sym_true] = ACTIONS(3488),
    [sym_false] = ACTIONS(3488),
    [anon_sym_NULL] = ACTIONS(3488),
    [anon_sym_nullptr] = ACTIONS(3488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3488),
    [anon_sym_let] = ACTIONS(3488),
    [anon_sym_This] = ACTIONS(3488),
    [anon_sym_decltype] = ACTIONS(3488),
    [anon_sym_explicit] = ACTIONS(3488),
    [anon_sym_typename] = ACTIONS(3488),
    [anon_sym_template] = ACTIONS(3488),
    [anon_sym_operator] = ACTIONS(3488),
    [anon_sym_try] = ACTIONS(3488),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_throw] = ACTIONS(3488),
    [anon_sym_namespace] = ACTIONS(3488),
    [anon_sym_static_assert] = ACTIONS(3488),
    [anon_sym_concept] = ACTIONS(3488),
    [anon_sym_co_return] = ACTIONS(3488),
    [anon_sym_co_yield] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(3486),
    [anon_sym_LR_DQUOTE] = ACTIONS(3486),
    [anon_sym_uR_DQUOTE] = ACTIONS(3486),
    [anon_sym_UR_DQUOTE] = ACTIONS(3486),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3486),
    [anon_sym_co_await] = ACTIONS(3488),
    [anon_sym_new] = ACTIONS(3488),
    [anon_sym_requires] = ACTIONS(3488),
    [sym_this] = ACTIONS(3488),
    [anon_sym_discard] = ACTIONS(3488),
    [anon_sym_precise] = ACTIONS(3488),
    [anon_sym_shared] = ACTIONS(3488),
    [anon_sym_groupshared] = ACTIONS(3488),
    [anon_sym_uniform] = ACTIONS(3488),
    [anon_sym_row_major] = ACTIONS(3488),
    [anon_sym_column_major] = ACTIONS(3488),
    [anon_sym_globallycoherent] = ACTIONS(3488),
    [anon_sym_centroid] = ACTIONS(3488),
    [anon_sym_noperspective] = ACTIONS(3488),
    [anon_sym_nointerpolation] = ACTIONS(3488),
    [anon_sym_sample] = ACTIONS(3488),
    [anon_sym_linear] = ACTIONS(3488),
    [anon_sym_snorm] = ACTIONS(3488),
    [anon_sym_unorm] = ACTIONS(3488),
    [anon_sym_point] = ACTIONS(3488),
    [anon_sym_line] = ACTIONS(3488),
    [anon_sym_triangleadj] = ACTIONS(3488),
    [anon_sym_lineadj] = ACTIONS(3488),
    [anon_sym_triangle] = ACTIONS(3488),
    [anon_sym_cbuffer] = ACTIONS(3488),
    [anon_sym_interface] = ACTIONS(3488),
    [anon_sym_extension] = ACTIONS(3488),
  },
  [417] = {
    [sym_identifier] = ACTIONS(3500),
    [aux_sym_preproc_include_token1] = ACTIONS(3500),
    [aux_sym_preproc_def_token1] = ACTIONS(3500),
    [aux_sym_preproc_if_token1] = ACTIONS(3500),
    [aux_sym_preproc_if_token2] = ACTIONS(3500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3500),
    [aux_sym_preproc_else_token1] = ACTIONS(3500),
    [aux_sym_preproc_elif_token1] = ACTIONS(3500),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3500),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3500),
    [sym_preproc_directive] = ACTIONS(3500),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3500),
    [anon_sym_PLUS] = ACTIONS(3500),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_AMP] = ACTIONS(3500),
    [anon_sym_SEMI] = ACTIONS(3498),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_typedef] = ACTIONS(3500),
    [anon_sym_in] = ACTIONS(3500),
    [anon_sym_out] = ACTIONS(3500),
    [anon_sym_inout] = ACTIONS(3500),
    [anon_sym_virtual] = ACTIONS(3500),
    [anon_sym_extern] = ACTIONS(3500),
    [anon_sym___attribute__] = ACTIONS(3500),
    [anon_sym___attribute] = ACTIONS(3500),
    [anon_sym_using] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3498),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3498),
    [anon_sym___declspec] = ACTIONS(3500),
    [anon_sym___based] = ACTIONS(3500),
    [anon_sym___cdecl] = ACTIONS(3500),
    [anon_sym___clrcall] = ACTIONS(3500),
    [anon_sym___stdcall] = ACTIONS(3500),
    [anon_sym___fastcall] = ACTIONS(3500),
    [anon_sym___thiscall] = ACTIONS(3500),
    [anon_sym___vectorcall] = ACTIONS(3500),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_signed] = ACTIONS(3500),
    [anon_sym_unsigned] = ACTIONS(3500),
    [anon_sym_long] = ACTIONS(3500),
    [anon_sym_short] = ACTIONS(3500),
    [anon_sym_LBRACK] = ACTIONS(3500),
    [anon_sym_static] = ACTIONS(3500),
    [anon_sym_register] = ACTIONS(3500),
    [anon_sym_inline] = ACTIONS(3500),
    [anon_sym___inline] = ACTIONS(3500),
    [anon_sym___inline__] = ACTIONS(3500),
    [anon_sym___forceinline] = ACTIONS(3500),
    [anon_sym_thread_local] = ACTIONS(3500),
    [anon_sym___thread] = ACTIONS(3500),
    [anon_sym_const] = ACTIONS(3500),
    [anon_sym_constexpr] = ACTIONS(3500),
    [anon_sym_volatile] = ACTIONS(3500),
    [anon_sym_restrict] = ACTIONS(3500),
    [anon_sym___restrict__] = ACTIONS(3500),
    [anon_sym__Atomic] = ACTIONS(3500),
    [anon_sym__Noreturn] = ACTIONS(3500),
    [anon_sym_noreturn] = ACTIONS(3500),
    [anon_sym__Nonnull] = ACTIONS(3500),
    [anon_sym_mutable] = ACTIONS(3500),
    [anon_sym_constinit] = ACTIONS(3500),
    [anon_sym_consteval] = ACTIONS(3500),
    [anon_sym_alignas] = ACTIONS(3500),
    [anon_sym__Alignas] = ACTIONS(3500),
    [sym_primitive_type] = ACTIONS(3500),
    [anon_sym_enum] = ACTIONS(3500),
    [anon_sym_class] = ACTIONS(3500),
    [anon_sym_struct] = ACTIONS(3500),
    [anon_sym_union] = ACTIONS(3500),
    [anon_sym_if] = ACTIONS(3500),
    [anon_sym_else] = ACTIONS(3500),
    [anon_sym_switch] = ACTIONS(3500),
    [anon_sym_case] = ACTIONS(3500),
    [anon_sym_default] = ACTIONS(3500),
    [anon_sym_while] = ACTIONS(3500),
    [anon_sym_do] = ACTIONS(3500),
    [anon_sym_for] = ACTIONS(3500),
    [anon_sym_return] = ACTIONS(3500),
    [anon_sym_break] = ACTIONS(3500),
    [anon_sym_continue] = ACTIONS(3500),
    [anon_sym_goto] = ACTIONS(3500),
    [anon_sym___try] = ACTIONS(3500),
    [anon_sym___leave] = ACTIONS(3500),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_compl] = ACTIONS(3500),
    [anon_sym_DASH_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_PLUS] = ACTIONS(3498),
    [anon_sym_sizeof] = ACTIONS(3500),
    [anon_sym___alignof__] = ACTIONS(3500),
    [anon_sym___alignof] = ACTIONS(3500),
    [anon_sym__alignof] = ACTIONS(3500),
    [anon_sym_alignof] = ACTIONS(3500),
    [anon_sym__Alignof] = ACTIONS(3500),
    [anon_sym_offsetof] = ACTIONS(3500),
    [anon_sym__Generic] = ACTIONS(3500),
    [anon_sym_asm] = ACTIONS(3500),
    [anon_sym___asm__] = ACTIONS(3500),
    [anon_sym___asm] = ACTIONS(3500),
    [sym_number_literal] = ACTIONS(3498),
    [anon_sym_L_SQUOTE] = ACTIONS(3498),
    [anon_sym_u_SQUOTE] = ACTIONS(3498),
    [anon_sym_U_SQUOTE] = ACTIONS(3498),
    [anon_sym_u8_SQUOTE] = ACTIONS(3498),
    [anon_sym_SQUOTE] = ACTIONS(3498),
    [anon_sym_L_DQUOTE] = ACTIONS(3498),
    [anon_sym_u_DQUOTE] = ACTIONS(3498),
    [anon_sym_U_DQUOTE] = ACTIONS(3498),
    [anon_sym_u8_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [sym_true] = ACTIONS(3500),
    [sym_false] = ACTIONS(3500),
    [anon_sym_NULL] = ACTIONS(3500),
    [anon_sym_nullptr] = ACTIONS(3500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3500),
    [anon_sym_let] = ACTIONS(3500),
    [anon_sym_This] = ACTIONS(3500),
    [anon_sym_decltype] = ACTIONS(3500),
    [anon_sym_explicit] = ACTIONS(3500),
    [anon_sym_typename] = ACTIONS(3500),
    [anon_sym_template] = ACTIONS(3500),
    [anon_sym_operator] = ACTIONS(3500),
    [anon_sym_try] = ACTIONS(3500),
    [anon_sym_delete] = ACTIONS(3500),
    [anon_sym_throw] = ACTIONS(3500),
    [anon_sym_namespace] = ACTIONS(3500),
    [anon_sym_static_assert] = ACTIONS(3500),
    [anon_sym_concept] = ACTIONS(3500),
    [anon_sym_co_return] = ACTIONS(3500),
    [anon_sym_co_yield] = ACTIONS(3500),
    [anon_sym_R_DQUOTE] = ACTIONS(3498),
    [anon_sym_LR_DQUOTE] = ACTIONS(3498),
    [anon_sym_uR_DQUOTE] = ACTIONS(3498),
    [anon_sym_UR_DQUOTE] = ACTIONS(3498),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3498),
    [anon_sym_co_await] = ACTIONS(3500),
    [anon_sym_new] = ACTIONS(3500),
    [anon_sym_requires] = ACTIONS(3500),
    [sym_this] = ACTIONS(3500),
    [anon_sym_discard] = ACTIONS(3500),
    [anon_sym_precise] = ACTIONS(3500),
    [anon_sym_shared] = ACTIONS(3500),
    [anon_sym_groupshared] = ACTIONS(3500),
    [anon_sym_uniform] = ACTIONS(3500),
    [anon_sym_row_major] = ACTIONS(3500),
    [anon_sym_column_major] = ACTIONS(3500),
    [anon_sym_globallycoherent] = ACTIONS(3500),
    [anon_sym_centroid] = ACTIONS(3500),
    [anon_sym_noperspective] = ACTIONS(3500),
    [anon_sym_nointerpolation] = ACTIONS(3500),
    [anon_sym_sample] = ACTIONS(3500),
    [anon_sym_linear] = ACTIONS(3500),
    [anon_sym_snorm] = ACTIONS(3500),
    [anon_sym_unorm] = ACTIONS(3500),
    [anon_sym_point] = ACTIONS(3500),
    [anon_sym_line] = ACTIONS(3500),
    [anon_sym_triangleadj] = ACTIONS(3500),
    [anon_sym_lineadj] = ACTIONS(3500),
    [anon_sym_triangle] = ACTIONS(3500),
    [anon_sym_cbuffer] = ACTIONS(3500),
    [anon_sym_interface] = ACTIONS(3500),
    [anon_sym_extension] = ACTIONS(3500),
  },
  [418] = {
    [sym_identifier] = ACTIONS(3510),
    [aux_sym_preproc_include_token1] = ACTIONS(3510),
    [aux_sym_preproc_def_token1] = ACTIONS(3510),
    [aux_sym_preproc_if_token1] = ACTIONS(3510),
    [aux_sym_preproc_if_token2] = ACTIONS(3510),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3510),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3510),
    [aux_sym_preproc_else_token1] = ACTIONS(3510),
    [aux_sym_preproc_elif_token1] = ACTIONS(3510),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3510),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3510),
    [sym_preproc_directive] = ACTIONS(3510),
    [anon_sym_LPAREN2] = ACTIONS(3512),
    [anon_sym_BANG] = ACTIONS(3512),
    [anon_sym_TILDE] = ACTIONS(3512),
    [anon_sym_DASH] = ACTIONS(3510),
    [anon_sym_PLUS] = ACTIONS(3510),
    [anon_sym_STAR] = ACTIONS(3512),
    [anon_sym_AMP_AMP] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3510),
    [anon_sym_SEMI] = ACTIONS(3512),
    [anon_sym___extension__] = ACTIONS(3510),
    [anon_sym_typedef] = ACTIONS(3510),
    [anon_sym_in] = ACTIONS(3510),
    [anon_sym_out] = ACTIONS(3510),
    [anon_sym_inout] = ACTIONS(3510),
    [anon_sym_virtual] = ACTIONS(3510),
    [anon_sym_extern] = ACTIONS(3510),
    [anon_sym___attribute__] = ACTIONS(3510),
    [anon_sym___attribute] = ACTIONS(3510),
    [anon_sym_using] = ACTIONS(3510),
    [anon_sym_COLON_COLON] = ACTIONS(3512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3512),
    [anon_sym___declspec] = ACTIONS(3510),
    [anon_sym___based] = ACTIONS(3510),
    [anon_sym___cdecl] = ACTIONS(3510),
    [anon_sym___clrcall] = ACTIONS(3510),
    [anon_sym___stdcall] = ACTIONS(3510),
    [anon_sym___fastcall] = ACTIONS(3510),
    [anon_sym___thiscall] = ACTIONS(3510),
    [anon_sym___vectorcall] = ACTIONS(3510),
    [anon_sym_LBRACE] = ACTIONS(3512),
    [anon_sym_signed] = ACTIONS(3510),
    [anon_sym_unsigned] = ACTIONS(3510),
    [anon_sym_long] = ACTIONS(3510),
    [anon_sym_short] = ACTIONS(3510),
    [anon_sym_LBRACK] = ACTIONS(3510),
    [anon_sym_static] = ACTIONS(3510),
    [anon_sym_register] = ACTIONS(3510),
    [anon_sym_inline] = ACTIONS(3510),
    [anon_sym___inline] = ACTIONS(3510),
    [anon_sym___inline__] = ACTIONS(3510),
    [anon_sym___forceinline] = ACTIONS(3510),
    [anon_sym_thread_local] = ACTIONS(3510),
    [anon_sym___thread] = ACTIONS(3510),
    [anon_sym_const] = ACTIONS(3510),
    [anon_sym_constexpr] = ACTIONS(3510),
    [anon_sym_volatile] = ACTIONS(3510),
    [anon_sym_restrict] = ACTIONS(3510),
    [anon_sym___restrict__] = ACTIONS(3510),
    [anon_sym__Atomic] = ACTIONS(3510),
    [anon_sym__Noreturn] = ACTIONS(3510),
    [anon_sym_noreturn] = ACTIONS(3510),
    [anon_sym__Nonnull] = ACTIONS(3510),
    [anon_sym_mutable] = ACTIONS(3510),
    [anon_sym_constinit] = ACTIONS(3510),
    [anon_sym_consteval] = ACTIONS(3510),
    [anon_sym_alignas] = ACTIONS(3510),
    [anon_sym__Alignas] = ACTIONS(3510),
    [sym_primitive_type] = ACTIONS(3510),
    [anon_sym_enum] = ACTIONS(3510),
    [anon_sym_class] = ACTIONS(3510),
    [anon_sym_struct] = ACTIONS(3510),
    [anon_sym_union] = ACTIONS(3510),
    [anon_sym_if] = ACTIONS(3510),
    [anon_sym_else] = ACTIONS(3510),
    [anon_sym_switch] = ACTIONS(3510),
    [anon_sym_case] = ACTIONS(3510),
    [anon_sym_default] = ACTIONS(3510),
    [anon_sym_while] = ACTIONS(3510),
    [anon_sym_do] = ACTIONS(3510),
    [anon_sym_for] = ACTIONS(3510),
    [anon_sym_return] = ACTIONS(3510),
    [anon_sym_break] = ACTIONS(3510),
    [anon_sym_continue] = ACTIONS(3510),
    [anon_sym_goto] = ACTIONS(3510),
    [anon_sym___try] = ACTIONS(3510),
    [anon_sym___leave] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3510),
    [anon_sym_compl] = ACTIONS(3510),
    [anon_sym_DASH_DASH] = ACTIONS(3512),
    [anon_sym_PLUS_PLUS] = ACTIONS(3512),
    [anon_sym_sizeof] = ACTIONS(3510),
    [anon_sym___alignof__] = ACTIONS(3510),
    [anon_sym___alignof] = ACTIONS(3510),
    [anon_sym__alignof] = ACTIONS(3510),
    [anon_sym_alignof] = ACTIONS(3510),
    [anon_sym__Alignof] = ACTIONS(3510),
    [anon_sym_offsetof] = ACTIONS(3510),
    [anon_sym__Generic] = ACTIONS(3510),
    [anon_sym_asm] = ACTIONS(3510),
    [anon_sym___asm__] = ACTIONS(3510),
    [anon_sym___asm] = ACTIONS(3510),
    [sym_number_literal] = ACTIONS(3512),
    [anon_sym_L_SQUOTE] = ACTIONS(3512),
    [anon_sym_u_SQUOTE] = ACTIONS(3512),
    [anon_sym_U_SQUOTE] = ACTIONS(3512),
    [anon_sym_u8_SQUOTE] = ACTIONS(3512),
    [anon_sym_SQUOTE] = ACTIONS(3512),
    [anon_sym_L_DQUOTE] = ACTIONS(3512),
    [anon_sym_u_DQUOTE] = ACTIONS(3512),
    [anon_sym_U_DQUOTE] = ACTIONS(3512),
    [anon_sym_u8_DQUOTE] = ACTIONS(3512),
    [anon_sym_DQUOTE] = ACTIONS(3512),
    [sym_true] = ACTIONS(3510),
    [sym_false] = ACTIONS(3510),
    [anon_sym_NULL] = ACTIONS(3510),
    [anon_sym_nullptr] = ACTIONS(3510),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3510),
    [anon_sym_let] = ACTIONS(3510),
    [anon_sym_This] = ACTIONS(3510),
    [anon_sym_decltype] = ACTIONS(3510),
    [anon_sym_explicit] = ACTIONS(3510),
    [anon_sym_typename] = ACTIONS(3510),
    [anon_sym_template] = ACTIONS(3510),
    [anon_sym_operator] = ACTIONS(3510),
    [anon_sym_try] = ACTIONS(3510),
    [anon_sym_delete] = ACTIONS(3510),
    [anon_sym_throw] = ACTIONS(3510),
    [anon_sym_namespace] = ACTIONS(3510),
    [anon_sym_static_assert] = ACTIONS(3510),
    [anon_sym_concept] = ACTIONS(3510),
    [anon_sym_co_return] = ACTIONS(3510),
    [anon_sym_co_yield] = ACTIONS(3510),
    [anon_sym_R_DQUOTE] = ACTIONS(3512),
    [anon_sym_LR_DQUOTE] = ACTIONS(3512),
    [anon_sym_uR_DQUOTE] = ACTIONS(3512),
    [anon_sym_UR_DQUOTE] = ACTIONS(3512),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3512),
    [anon_sym_co_await] = ACTIONS(3510),
    [anon_sym_new] = ACTIONS(3510),
    [anon_sym_requires] = ACTIONS(3510),
    [sym_this] = ACTIONS(3510),
    [anon_sym_discard] = ACTIONS(3510),
    [anon_sym_precise] = ACTIONS(3510),
    [anon_sym_shared] = ACTIONS(3510),
    [anon_sym_groupshared] = ACTIONS(3510),
    [anon_sym_uniform] = ACTIONS(3510),
    [anon_sym_row_major] = ACTIONS(3510),
    [anon_sym_column_major] = ACTIONS(3510),
    [anon_sym_globallycoherent] = ACTIONS(3510),
    [anon_sym_centroid] = ACTIONS(3510),
    [anon_sym_noperspective] = ACTIONS(3510),
    [anon_sym_nointerpolation] = ACTIONS(3510),
    [anon_sym_sample] = ACTIONS(3510),
    [anon_sym_linear] = ACTIONS(3510),
    [anon_sym_snorm] = ACTIONS(3510),
    [anon_sym_unorm] = ACTIONS(3510),
    [anon_sym_point] = ACTIONS(3510),
    [anon_sym_line] = ACTIONS(3510),
    [anon_sym_triangleadj] = ACTIONS(3510),
    [anon_sym_lineadj] = ACTIONS(3510),
    [anon_sym_triangle] = ACTIONS(3510),
    [anon_sym_cbuffer] = ACTIONS(3510),
    [anon_sym_interface] = ACTIONS(3510),
    [anon_sym_extension] = ACTIONS(3510),
  },
  [419] = {
    [sym_attribute_specifier] = STATE(321),
    [sym_enumerator_list] = STATE(678),
    [sym__enum_base_clause] = STATE(632),
    [ts_builtin_sym_end] = ACTIONS(3480),
    [sym_identifier] = ACTIONS(3478),
    [aux_sym_preproc_include_token1] = ACTIONS(3478),
    [aux_sym_preproc_def_token1] = ACTIONS(3478),
    [aux_sym_preproc_if_token1] = ACTIONS(3478),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3478),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3478),
    [sym_preproc_directive] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_BANG] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3478),
    [anon_sym_PLUS] = ACTIONS(3478),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3514),
    [anon_sym_SEMI] = ACTIONS(3480),
    [anon_sym___extension__] = ACTIONS(3478),
    [anon_sym_typedef] = ACTIONS(3478),
    [anon_sym_in] = ACTIONS(3478),
    [anon_sym_out] = ACTIONS(3478),
    [anon_sym_inout] = ACTIONS(3478),
    [anon_sym_virtual] = ACTIONS(3478),
    [anon_sym_extern] = ACTIONS(3478),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(3478),
    [anon_sym_COLON_COLON] = ACTIONS(3480),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3480),
    [anon_sym___declspec] = ACTIONS(3478),
    [anon_sym___based] = ACTIONS(3478),
    [anon_sym___cdecl] = ACTIONS(3478),
    [anon_sym___clrcall] = ACTIONS(3478),
    [anon_sym___stdcall] = ACTIONS(3478),
    [anon_sym___fastcall] = ACTIONS(3478),
    [anon_sym___thiscall] = ACTIONS(3478),
    [anon_sym___vectorcall] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3516),
    [anon_sym_signed] = ACTIONS(3478),
    [anon_sym_unsigned] = ACTIONS(3478),
    [anon_sym_long] = ACTIONS(3478),
    [anon_sym_short] = ACTIONS(3478),
    [anon_sym_LBRACK] = ACTIONS(3478),
    [anon_sym_static] = ACTIONS(3478),
    [anon_sym_register] = ACTIONS(3478),
    [anon_sym_inline] = ACTIONS(3478),
    [anon_sym___inline] = ACTIONS(3478),
    [anon_sym___inline__] = ACTIONS(3478),
    [anon_sym___forceinline] = ACTIONS(3478),
    [anon_sym_thread_local] = ACTIONS(3478),
    [anon_sym___thread] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(3478),
    [anon_sym_constexpr] = ACTIONS(3478),
    [anon_sym_volatile] = ACTIONS(3478),
    [anon_sym_restrict] = ACTIONS(3478),
    [anon_sym___restrict__] = ACTIONS(3478),
    [anon_sym__Atomic] = ACTIONS(3478),
    [anon_sym__Noreturn] = ACTIONS(3478),
    [anon_sym_noreturn] = ACTIONS(3478),
    [anon_sym__Nonnull] = ACTIONS(3478),
    [anon_sym_mutable] = ACTIONS(3478),
    [anon_sym_constinit] = ACTIONS(3478),
    [anon_sym_consteval] = ACTIONS(3478),
    [anon_sym_alignas] = ACTIONS(3478),
    [anon_sym__Alignas] = ACTIONS(3478),
    [sym_primitive_type] = ACTIONS(3478),
    [anon_sym_enum] = ACTIONS(3478),
    [anon_sym_class] = ACTIONS(3478),
    [anon_sym_struct] = ACTIONS(3478),
    [anon_sym_union] = ACTIONS(3478),
    [anon_sym_if] = ACTIONS(3478),
    [anon_sym_switch] = ACTIONS(3478),
    [anon_sym_case] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3478),
    [anon_sym_while] = ACTIONS(3478),
    [anon_sym_do] = ACTIONS(3478),
    [anon_sym_for] = ACTIONS(3478),
    [anon_sym_return] = ACTIONS(3478),
    [anon_sym_break] = ACTIONS(3478),
    [anon_sym_continue] = ACTIONS(3478),
    [anon_sym_goto] = ACTIONS(3478),
    [anon_sym_not] = ACTIONS(3478),
    [anon_sym_compl] = ACTIONS(3478),
    [anon_sym_DASH_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_PLUS] = ACTIONS(3480),
    [anon_sym_sizeof] = ACTIONS(3478),
    [anon_sym___alignof__] = ACTIONS(3478),
    [anon_sym___alignof] = ACTIONS(3478),
    [anon_sym__alignof] = ACTIONS(3478),
    [anon_sym_alignof] = ACTIONS(3478),
    [anon_sym__Alignof] = ACTIONS(3478),
    [anon_sym_offsetof] = ACTIONS(3478),
    [anon_sym__Generic] = ACTIONS(3478),
    [anon_sym_asm] = ACTIONS(3478),
    [anon_sym___asm__] = ACTIONS(3478),
    [anon_sym___asm] = ACTIONS(3478),
    [anon_sym_DOT] = ACTIONS(3478),
    [sym_number_literal] = ACTIONS(3480),
    [anon_sym_L_SQUOTE] = ACTIONS(3480),
    [anon_sym_u_SQUOTE] = ACTIONS(3480),
    [anon_sym_U_SQUOTE] = ACTIONS(3480),
    [anon_sym_u8_SQUOTE] = ACTIONS(3480),
    [anon_sym_SQUOTE] = ACTIONS(3480),
    [anon_sym_L_DQUOTE] = ACTIONS(3480),
    [anon_sym_u_DQUOTE] = ACTIONS(3480),
    [anon_sym_U_DQUOTE] = ACTIONS(3480),
    [anon_sym_u8_DQUOTE] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [sym_true] = ACTIONS(3478),
    [sym_false] = ACTIONS(3478),
    [anon_sym_NULL] = ACTIONS(3478),
    [anon_sym_nullptr] = ACTIONS(3478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3478),
    [anon_sym_let] = ACTIONS(3478),
    [anon_sym_This] = ACTIONS(3478),
    [anon_sym_decltype] = ACTIONS(3478),
    [anon_sym_explicit] = ACTIONS(3478),
    [anon_sym_typename] = ACTIONS(3478),
    [anon_sym_export] = ACTIONS(3478),
    [anon_sym_module] = ACTIONS(3478),
    [anon_sym_import] = ACTIONS(3478),
    [anon_sym_template] = ACTIONS(3478),
    [anon_sym_operator] = ACTIONS(3478),
    [anon_sym_try] = ACTIONS(3478),
    [anon_sym_delete] = ACTIONS(3478),
    [anon_sym_throw] = ACTIONS(3478),
    [anon_sym_namespace] = ACTIONS(3478),
    [anon_sym_static_assert] = ACTIONS(3478),
    [anon_sym_concept] = ACTIONS(3478),
    [anon_sym_co_return] = ACTIONS(3478),
    [anon_sym_co_yield] = ACTIONS(3478),
    [anon_sym_R_DQUOTE] = ACTIONS(3480),
    [anon_sym_LR_DQUOTE] = ACTIONS(3480),
    [anon_sym_uR_DQUOTE] = ACTIONS(3480),
    [anon_sym_UR_DQUOTE] = ACTIONS(3480),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3480),
    [anon_sym_co_await] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3478),
    [anon_sym_requires] = ACTIONS(3478),
    [sym_this] = ACTIONS(3478),
    [anon_sym_precise] = ACTIONS(3478),
    [anon_sym_shared] = ACTIONS(3478),
    [anon_sym_groupshared] = ACTIONS(3478),
    [anon_sym_uniform] = ACTIONS(3478),
    [anon_sym_row_major] = ACTIONS(3478),
    [anon_sym_column_major] = ACTIONS(3478),
    [anon_sym_globallycoherent] = ACTIONS(3478),
    [anon_sym_centroid] = ACTIONS(3478),
    [anon_sym_noperspective] = ACTIONS(3478),
    [anon_sym_nointerpolation] = ACTIONS(3478),
    [anon_sym_sample] = ACTIONS(3478),
    [anon_sym_linear] = ACTIONS(3478),
    [anon_sym_snorm] = ACTIONS(3478),
    [anon_sym_unorm] = ACTIONS(3478),
    [anon_sym_point] = ACTIONS(3478),
    [anon_sym_line] = ACTIONS(3478),
    [anon_sym_triangleadj] = ACTIONS(3478),
    [anon_sym_lineadj] = ACTIONS(3478),
    [anon_sym_triangle] = ACTIONS(3478),
    [anon_sym_interface] = ACTIONS(3478),
    [anon_sym_extension] = ACTIONS(3478),
    [anon_sym___exported] = ACTIONS(3478),
  },
  [420] = {
    [sym_identifier] = ACTIONS(3421),
    [aux_sym_preproc_include_token1] = ACTIONS(3421),
    [aux_sym_preproc_def_token1] = ACTIONS(3421),
    [aux_sym_preproc_if_token1] = ACTIONS(3421),
    [aux_sym_preproc_if_token2] = ACTIONS(3421),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3421),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3421),
    [aux_sym_preproc_else_token1] = ACTIONS(3421),
    [aux_sym_preproc_elif_token1] = ACTIONS(3421),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3421),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3421),
    [sym_preproc_directive] = ACTIONS(3421),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_BANG] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_SEMI] = ACTIONS(3419),
    [anon_sym___extension__] = ACTIONS(3421),
    [anon_sym_typedef] = ACTIONS(3421),
    [anon_sym_in] = ACTIONS(3421),
    [anon_sym_out] = ACTIONS(3421),
    [anon_sym_inout] = ACTIONS(3421),
    [anon_sym_virtual] = ACTIONS(3421),
    [anon_sym_extern] = ACTIONS(3421),
    [anon_sym___attribute__] = ACTIONS(3421),
    [anon_sym___attribute] = ACTIONS(3421),
    [anon_sym_using] = ACTIONS(3421),
    [anon_sym_COLON_COLON] = ACTIONS(3419),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3419),
    [anon_sym___declspec] = ACTIONS(3421),
    [anon_sym___based] = ACTIONS(3421),
    [anon_sym___cdecl] = ACTIONS(3421),
    [anon_sym___clrcall] = ACTIONS(3421),
    [anon_sym___stdcall] = ACTIONS(3421),
    [anon_sym___fastcall] = ACTIONS(3421),
    [anon_sym___thiscall] = ACTIONS(3421),
    [anon_sym___vectorcall] = ACTIONS(3421),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_signed] = ACTIONS(3421),
    [anon_sym_unsigned] = ACTIONS(3421),
    [anon_sym_long] = ACTIONS(3421),
    [anon_sym_short] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3421),
    [anon_sym_static] = ACTIONS(3421),
    [anon_sym_register] = ACTIONS(3421),
    [anon_sym_inline] = ACTIONS(3421),
    [anon_sym___inline] = ACTIONS(3421),
    [anon_sym___inline__] = ACTIONS(3421),
    [anon_sym___forceinline] = ACTIONS(3421),
    [anon_sym_thread_local] = ACTIONS(3421),
    [anon_sym___thread] = ACTIONS(3421),
    [anon_sym_const] = ACTIONS(3421),
    [anon_sym_constexpr] = ACTIONS(3421),
    [anon_sym_volatile] = ACTIONS(3421),
    [anon_sym_restrict] = ACTIONS(3421),
    [anon_sym___restrict__] = ACTIONS(3421),
    [anon_sym__Atomic] = ACTIONS(3421),
    [anon_sym__Noreturn] = ACTIONS(3421),
    [anon_sym_noreturn] = ACTIONS(3421),
    [anon_sym__Nonnull] = ACTIONS(3421),
    [anon_sym_mutable] = ACTIONS(3421),
    [anon_sym_constinit] = ACTIONS(3421),
    [anon_sym_consteval] = ACTIONS(3421),
    [anon_sym_alignas] = ACTIONS(3421),
    [anon_sym__Alignas] = ACTIONS(3421),
    [sym_primitive_type] = ACTIONS(3421),
    [anon_sym_enum] = ACTIONS(3421),
    [anon_sym_class] = ACTIONS(3421),
    [anon_sym_struct] = ACTIONS(3421),
    [anon_sym_union] = ACTIONS(3421),
    [anon_sym_if] = ACTIONS(3421),
    [anon_sym_else] = ACTIONS(3421),
    [anon_sym_switch] = ACTIONS(3421),
    [anon_sym_case] = ACTIONS(3421),
    [anon_sym_default] = ACTIONS(3421),
    [anon_sym_while] = ACTIONS(3421),
    [anon_sym_do] = ACTIONS(3421),
    [anon_sym_for] = ACTIONS(3421),
    [anon_sym_return] = ACTIONS(3421),
    [anon_sym_break] = ACTIONS(3421),
    [anon_sym_continue] = ACTIONS(3421),
    [anon_sym_goto] = ACTIONS(3421),
    [anon_sym___try] = ACTIONS(3421),
    [anon_sym___leave] = ACTIONS(3421),
    [anon_sym_not] = ACTIONS(3421),
    [anon_sym_compl] = ACTIONS(3421),
    [anon_sym_DASH_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_PLUS] = ACTIONS(3419),
    [anon_sym_sizeof] = ACTIONS(3421),
    [anon_sym___alignof__] = ACTIONS(3421),
    [anon_sym___alignof] = ACTIONS(3421),
    [anon_sym__alignof] = ACTIONS(3421),
    [anon_sym_alignof] = ACTIONS(3421),
    [anon_sym__Alignof] = ACTIONS(3421),
    [anon_sym_offsetof] = ACTIONS(3421),
    [anon_sym__Generic] = ACTIONS(3421),
    [anon_sym_asm] = ACTIONS(3421),
    [anon_sym___asm__] = ACTIONS(3421),
    [anon_sym___asm] = ACTIONS(3421),
    [sym_number_literal] = ACTIONS(3419),
    [anon_sym_L_SQUOTE] = ACTIONS(3419),
    [anon_sym_u_SQUOTE] = ACTIONS(3419),
    [anon_sym_U_SQUOTE] = ACTIONS(3419),
    [anon_sym_u8_SQUOTE] = ACTIONS(3419),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym_L_DQUOTE] = ACTIONS(3419),
    [anon_sym_u_DQUOTE] = ACTIONS(3419),
    [anon_sym_U_DQUOTE] = ACTIONS(3419),
    [anon_sym_u8_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [sym_true] = ACTIONS(3421),
    [sym_false] = ACTIONS(3421),
    [anon_sym_NULL] = ACTIONS(3421),
    [anon_sym_nullptr] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3421),
    [anon_sym_let] = ACTIONS(3421),
    [anon_sym_This] = ACTIONS(3421),
    [anon_sym_decltype] = ACTIONS(3421),
    [anon_sym_explicit] = ACTIONS(3421),
    [anon_sym_typename] = ACTIONS(3421),
    [anon_sym_template] = ACTIONS(3421),
    [anon_sym_operator] = ACTIONS(3421),
    [anon_sym_try] = ACTIONS(3421),
    [anon_sym_delete] = ACTIONS(3421),
    [anon_sym_throw] = ACTIONS(3421),
    [anon_sym_namespace] = ACTIONS(3421),
    [anon_sym_static_assert] = ACTIONS(3421),
    [anon_sym_concept] = ACTIONS(3421),
    [anon_sym_co_return] = ACTIONS(3421),
    [anon_sym_co_yield] = ACTIONS(3421),
    [anon_sym_R_DQUOTE] = ACTIONS(3419),
    [anon_sym_LR_DQUOTE] = ACTIONS(3419),
    [anon_sym_uR_DQUOTE] = ACTIONS(3419),
    [anon_sym_UR_DQUOTE] = ACTIONS(3419),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3419),
    [anon_sym_co_await] = ACTIONS(3421),
    [anon_sym_new] = ACTIONS(3421),
    [anon_sym_requires] = ACTIONS(3421),
    [sym_this] = ACTIONS(3421),
    [anon_sym_discard] = ACTIONS(3421),
    [anon_sym_precise] = ACTIONS(3421),
    [anon_sym_shared] = ACTIONS(3421),
    [anon_sym_groupshared] = ACTIONS(3421),
    [anon_sym_uniform] = ACTIONS(3421),
    [anon_sym_row_major] = ACTIONS(3421),
    [anon_sym_column_major] = ACTIONS(3421),
    [anon_sym_globallycoherent] = ACTIONS(3421),
    [anon_sym_centroid] = ACTIONS(3421),
    [anon_sym_noperspective] = ACTIONS(3421),
    [anon_sym_nointerpolation] = ACTIONS(3421),
    [anon_sym_sample] = ACTIONS(3421),
    [anon_sym_linear] = ACTIONS(3421),
    [anon_sym_snorm] = ACTIONS(3421),
    [anon_sym_unorm] = ACTIONS(3421),
    [anon_sym_point] = ACTIONS(3421),
    [anon_sym_line] = ACTIONS(3421),
    [anon_sym_triangleadj] = ACTIONS(3421),
    [anon_sym_lineadj] = ACTIONS(3421),
    [anon_sym_triangle] = ACTIONS(3421),
    [anon_sym_cbuffer] = ACTIONS(3421),
    [anon_sym_interface] = ACTIONS(3421),
    [anon_sym_extension] = ACTIONS(3421),
  },
  [421] = {
    [sym_identifier] = ACTIONS(3417),
    [aux_sym_preproc_include_token1] = ACTIONS(3417),
    [aux_sym_preproc_def_token1] = ACTIONS(3417),
    [aux_sym_preproc_if_token1] = ACTIONS(3417),
    [aux_sym_preproc_if_token2] = ACTIONS(3417),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3417),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3417),
    [aux_sym_preproc_else_token1] = ACTIONS(3417),
    [aux_sym_preproc_elif_token1] = ACTIONS(3417),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3417),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3417),
    [sym_preproc_directive] = ACTIONS(3417),
    [anon_sym_LPAREN2] = ACTIONS(3415),
    [anon_sym_BANG] = ACTIONS(3415),
    [anon_sym_TILDE] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_STAR] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3415),
    [anon_sym_AMP] = ACTIONS(3417),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym___extension__] = ACTIONS(3417),
    [anon_sym_typedef] = ACTIONS(3417),
    [anon_sym_in] = ACTIONS(3417),
    [anon_sym_out] = ACTIONS(3417),
    [anon_sym_inout] = ACTIONS(3417),
    [anon_sym_virtual] = ACTIONS(3417),
    [anon_sym_extern] = ACTIONS(3417),
    [anon_sym___attribute__] = ACTIONS(3417),
    [anon_sym___attribute] = ACTIONS(3417),
    [anon_sym_using] = ACTIONS(3417),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3415),
    [anon_sym___declspec] = ACTIONS(3417),
    [anon_sym___based] = ACTIONS(3417),
    [anon_sym___cdecl] = ACTIONS(3417),
    [anon_sym___clrcall] = ACTIONS(3417),
    [anon_sym___stdcall] = ACTIONS(3417),
    [anon_sym___fastcall] = ACTIONS(3417),
    [anon_sym___thiscall] = ACTIONS(3417),
    [anon_sym___vectorcall] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3415),
    [anon_sym_signed] = ACTIONS(3417),
    [anon_sym_unsigned] = ACTIONS(3417),
    [anon_sym_long] = ACTIONS(3417),
    [anon_sym_short] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_static] = ACTIONS(3417),
    [anon_sym_register] = ACTIONS(3417),
    [anon_sym_inline] = ACTIONS(3417),
    [anon_sym___inline] = ACTIONS(3417),
    [anon_sym___inline__] = ACTIONS(3417),
    [anon_sym___forceinline] = ACTIONS(3417),
    [anon_sym_thread_local] = ACTIONS(3417),
    [anon_sym___thread] = ACTIONS(3417),
    [anon_sym_const] = ACTIONS(3417),
    [anon_sym_constexpr] = ACTIONS(3417),
    [anon_sym_volatile] = ACTIONS(3417),
    [anon_sym_restrict] = ACTIONS(3417),
    [anon_sym___restrict__] = ACTIONS(3417),
    [anon_sym__Atomic] = ACTIONS(3417),
    [anon_sym__Noreturn] = ACTIONS(3417),
    [anon_sym_noreturn] = ACTIONS(3417),
    [anon_sym__Nonnull] = ACTIONS(3417),
    [anon_sym_mutable] = ACTIONS(3417),
    [anon_sym_constinit] = ACTIONS(3417),
    [anon_sym_consteval] = ACTIONS(3417),
    [anon_sym_alignas] = ACTIONS(3417),
    [anon_sym__Alignas] = ACTIONS(3417),
    [sym_primitive_type] = ACTIONS(3417),
    [anon_sym_enum] = ACTIONS(3417),
    [anon_sym_class] = ACTIONS(3417),
    [anon_sym_struct] = ACTIONS(3417),
    [anon_sym_union] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_else] = ACTIONS(3417),
    [anon_sym_switch] = ACTIONS(3417),
    [anon_sym_case] = ACTIONS(3417),
    [anon_sym_default] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_break] = ACTIONS(3417),
    [anon_sym_continue] = ACTIONS(3417),
    [anon_sym_goto] = ACTIONS(3417),
    [anon_sym___try] = ACTIONS(3417),
    [anon_sym___leave] = ACTIONS(3417),
    [anon_sym_not] = ACTIONS(3417),
    [anon_sym_compl] = ACTIONS(3417),
    [anon_sym_DASH_DASH] = ACTIONS(3415),
    [anon_sym_PLUS_PLUS] = ACTIONS(3415),
    [anon_sym_sizeof] = ACTIONS(3417),
    [anon_sym___alignof__] = ACTIONS(3417),
    [anon_sym___alignof] = ACTIONS(3417),
    [anon_sym__alignof] = ACTIONS(3417),
    [anon_sym_alignof] = ACTIONS(3417),
    [anon_sym__Alignof] = ACTIONS(3417),
    [anon_sym_offsetof] = ACTIONS(3417),
    [anon_sym__Generic] = ACTIONS(3417),
    [anon_sym_asm] = ACTIONS(3417),
    [anon_sym___asm__] = ACTIONS(3417),
    [anon_sym___asm] = ACTIONS(3417),
    [sym_number_literal] = ACTIONS(3415),
    [anon_sym_L_SQUOTE] = ACTIONS(3415),
    [anon_sym_u_SQUOTE] = ACTIONS(3415),
    [anon_sym_U_SQUOTE] = ACTIONS(3415),
    [anon_sym_u8_SQUOTE] = ACTIONS(3415),
    [anon_sym_SQUOTE] = ACTIONS(3415),
    [anon_sym_L_DQUOTE] = ACTIONS(3415),
    [anon_sym_u_DQUOTE] = ACTIONS(3415),
    [anon_sym_U_DQUOTE] = ACTIONS(3415),
    [anon_sym_u8_DQUOTE] = ACTIONS(3415),
    [anon_sym_DQUOTE] = ACTIONS(3415),
    [sym_true] = ACTIONS(3417),
    [sym_false] = ACTIONS(3417),
    [anon_sym_NULL] = ACTIONS(3417),
    [anon_sym_nullptr] = ACTIONS(3417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_This] = ACTIONS(3417),
    [anon_sym_decltype] = ACTIONS(3417),
    [anon_sym_explicit] = ACTIONS(3417),
    [anon_sym_typename] = ACTIONS(3417),
    [anon_sym_template] = ACTIONS(3417),
    [anon_sym_operator] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_delete] = ACTIONS(3417),
    [anon_sym_throw] = ACTIONS(3417),
    [anon_sym_namespace] = ACTIONS(3417),
    [anon_sym_static_assert] = ACTIONS(3417),
    [anon_sym_concept] = ACTIONS(3417),
    [anon_sym_co_return] = ACTIONS(3417),
    [anon_sym_co_yield] = ACTIONS(3417),
    [anon_sym_R_DQUOTE] = ACTIONS(3415),
    [anon_sym_LR_DQUOTE] = ACTIONS(3415),
    [anon_sym_uR_DQUOTE] = ACTIONS(3415),
    [anon_sym_UR_DQUOTE] = ACTIONS(3415),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3415),
    [anon_sym_co_await] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_requires] = ACTIONS(3417),
    [sym_this] = ACTIONS(3417),
    [anon_sym_discard] = ACTIONS(3417),
    [anon_sym_precise] = ACTIONS(3417),
    [anon_sym_shared] = ACTIONS(3417),
    [anon_sym_groupshared] = ACTIONS(3417),
    [anon_sym_uniform] = ACTIONS(3417),
    [anon_sym_row_major] = ACTIONS(3417),
    [anon_sym_column_major] = ACTIONS(3417),
    [anon_sym_globallycoherent] = ACTIONS(3417),
    [anon_sym_centroid] = ACTIONS(3417),
    [anon_sym_noperspective] = ACTIONS(3417),
    [anon_sym_nointerpolation] = ACTIONS(3417),
    [anon_sym_sample] = ACTIONS(3417),
    [anon_sym_linear] = ACTIONS(3417),
    [anon_sym_snorm] = ACTIONS(3417),
    [anon_sym_unorm] = ACTIONS(3417),
    [anon_sym_point] = ACTIONS(3417),
    [anon_sym_line] = ACTIONS(3417),
    [anon_sym_triangleadj] = ACTIONS(3417),
    [anon_sym_lineadj] = ACTIONS(3417),
    [anon_sym_triangle] = ACTIONS(3417),
    [anon_sym_cbuffer] = ACTIONS(3417),
    [anon_sym_interface] = ACTIONS(3417),
    [anon_sym_extension] = ACTIONS(3417),
  },
  [422] = {
    [ts_builtin_sym_end] = ACTIONS(3518),
    [sym_identifier] = ACTIONS(3520),
    [aux_sym_preproc_include_token1] = ACTIONS(3520),
    [aux_sym_preproc_def_token1] = ACTIONS(3520),
    [aux_sym_preproc_if_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3520),
    [sym_preproc_directive] = ACTIONS(3520),
    [anon_sym_LPAREN2] = ACTIONS(3518),
    [anon_sym_BANG] = ACTIONS(3518),
    [anon_sym_TILDE] = ACTIONS(3518),
    [anon_sym_DASH] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3520),
    [anon_sym_STAR] = ACTIONS(3518),
    [anon_sym_AMP_AMP] = ACTIONS(3518),
    [anon_sym_AMP] = ACTIONS(3520),
    [anon_sym_SEMI] = ACTIONS(3518),
    [anon_sym___extension__] = ACTIONS(3520),
    [anon_sym_typedef] = ACTIONS(3520),
    [anon_sym_in] = ACTIONS(3520),
    [anon_sym_out] = ACTIONS(3520),
    [anon_sym_inout] = ACTIONS(3520),
    [anon_sym_virtual] = ACTIONS(3520),
    [anon_sym_extern] = ACTIONS(3520),
    [anon_sym___attribute__] = ACTIONS(3520),
    [anon_sym___attribute] = ACTIONS(3520),
    [anon_sym_using] = ACTIONS(3520),
    [anon_sym_COLON_COLON] = ACTIONS(3518),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3518),
    [anon_sym___declspec] = ACTIONS(3520),
    [anon_sym___based] = ACTIONS(3520),
    [anon_sym___cdecl] = ACTIONS(3520),
    [anon_sym___clrcall] = ACTIONS(3520),
    [anon_sym___stdcall] = ACTIONS(3520),
    [anon_sym___fastcall] = ACTIONS(3520),
    [anon_sym___thiscall] = ACTIONS(3520),
    [anon_sym___vectorcall] = ACTIONS(3520),
    [anon_sym_LBRACE] = ACTIONS(3518),
    [anon_sym_signed] = ACTIONS(3520),
    [anon_sym_unsigned] = ACTIONS(3520),
    [anon_sym_long] = ACTIONS(3520),
    [anon_sym_short] = ACTIONS(3520),
    [anon_sym_LBRACK] = ACTIONS(3520),
    [anon_sym_static] = ACTIONS(3520),
    [anon_sym_register] = ACTIONS(3520),
    [anon_sym_inline] = ACTIONS(3520),
    [anon_sym___inline] = ACTIONS(3520),
    [anon_sym___inline__] = ACTIONS(3520),
    [anon_sym___forceinline] = ACTIONS(3520),
    [anon_sym_thread_local] = ACTIONS(3520),
    [anon_sym___thread] = ACTIONS(3520),
    [anon_sym_const] = ACTIONS(3520),
    [anon_sym_constexpr] = ACTIONS(3520),
    [anon_sym_volatile] = ACTIONS(3520),
    [anon_sym_restrict] = ACTIONS(3520),
    [anon_sym___restrict__] = ACTIONS(3520),
    [anon_sym__Atomic] = ACTIONS(3520),
    [anon_sym__Noreturn] = ACTIONS(3520),
    [anon_sym_noreturn] = ACTIONS(3520),
    [anon_sym__Nonnull] = ACTIONS(3520),
    [anon_sym_mutable] = ACTIONS(3520),
    [anon_sym_constinit] = ACTIONS(3520),
    [anon_sym_consteval] = ACTIONS(3520),
    [anon_sym_alignas] = ACTIONS(3520),
    [anon_sym__Alignas] = ACTIONS(3520),
    [sym_primitive_type] = ACTIONS(3520),
    [anon_sym_enum] = ACTIONS(3520),
    [anon_sym_class] = ACTIONS(3520),
    [anon_sym_struct] = ACTIONS(3520),
    [anon_sym_union] = ACTIONS(3520),
    [anon_sym_if] = ACTIONS(3520),
    [anon_sym_else] = ACTIONS(3520),
    [anon_sym_switch] = ACTIONS(3520),
    [anon_sym_case] = ACTIONS(3520),
    [anon_sym_default] = ACTIONS(3520),
    [anon_sym_while] = ACTIONS(3520),
    [anon_sym_do] = ACTIONS(3520),
    [anon_sym_for] = ACTIONS(3520),
    [anon_sym_return] = ACTIONS(3520),
    [anon_sym_break] = ACTIONS(3520),
    [anon_sym_continue] = ACTIONS(3520),
    [anon_sym_goto] = ACTIONS(3520),
    [anon_sym___try] = ACTIONS(3520),
    [anon_sym___leave] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3520),
    [anon_sym_compl] = ACTIONS(3520),
    [anon_sym_DASH_DASH] = ACTIONS(3518),
    [anon_sym_PLUS_PLUS] = ACTIONS(3518),
    [anon_sym_sizeof] = ACTIONS(3520),
    [anon_sym___alignof__] = ACTIONS(3520),
    [anon_sym___alignof] = ACTIONS(3520),
    [anon_sym__alignof] = ACTIONS(3520),
    [anon_sym_alignof] = ACTIONS(3520),
    [anon_sym__Alignof] = ACTIONS(3520),
    [anon_sym_offsetof] = ACTIONS(3520),
    [anon_sym__Generic] = ACTIONS(3520),
    [anon_sym_asm] = ACTIONS(3520),
    [anon_sym___asm__] = ACTIONS(3520),
    [anon_sym___asm] = ACTIONS(3520),
    [sym_number_literal] = ACTIONS(3518),
    [anon_sym_L_SQUOTE] = ACTIONS(3518),
    [anon_sym_u_SQUOTE] = ACTIONS(3518),
    [anon_sym_U_SQUOTE] = ACTIONS(3518),
    [anon_sym_u8_SQUOTE] = ACTIONS(3518),
    [anon_sym_SQUOTE] = ACTIONS(3518),
    [anon_sym_L_DQUOTE] = ACTIONS(3518),
    [anon_sym_u_DQUOTE] = ACTIONS(3518),
    [anon_sym_U_DQUOTE] = ACTIONS(3518),
    [anon_sym_u8_DQUOTE] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(3518),
    [sym_true] = ACTIONS(3520),
    [sym_false] = ACTIONS(3520),
    [anon_sym_NULL] = ACTIONS(3520),
    [anon_sym_nullptr] = ACTIONS(3520),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3520),
    [anon_sym_let] = ACTIONS(3520),
    [anon_sym_This] = ACTIONS(3520),
    [anon_sym_decltype] = ACTIONS(3520),
    [anon_sym_explicit] = ACTIONS(3520),
    [anon_sym_typename] = ACTIONS(3520),
    [anon_sym_export] = ACTIONS(3520),
    [anon_sym_module] = ACTIONS(3520),
    [anon_sym_import] = ACTIONS(3520),
    [anon_sym_template] = ACTIONS(3520),
    [anon_sym_operator] = ACTIONS(3520),
    [anon_sym_try] = ACTIONS(3520),
    [anon_sym_delete] = ACTIONS(3520),
    [anon_sym_throw] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3520),
    [anon_sym_static_assert] = ACTIONS(3520),
    [anon_sym_concept] = ACTIONS(3520),
    [anon_sym_co_return] = ACTIONS(3520),
    [anon_sym_co_yield] = ACTIONS(3520),
    [anon_sym_R_DQUOTE] = ACTIONS(3518),
    [anon_sym_LR_DQUOTE] = ACTIONS(3518),
    [anon_sym_uR_DQUOTE] = ACTIONS(3518),
    [anon_sym_UR_DQUOTE] = ACTIONS(3518),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3518),
    [anon_sym_co_await] = ACTIONS(3520),
    [anon_sym_new] = ACTIONS(3520),
    [anon_sym_requires] = ACTIONS(3520),
    [sym_this] = ACTIONS(3520),
    [anon_sym_discard] = ACTIONS(3520),
    [anon_sym_precise] = ACTIONS(3520),
    [anon_sym_shared] = ACTIONS(3520),
    [anon_sym_groupshared] = ACTIONS(3520),
    [anon_sym_uniform] = ACTIONS(3520),
    [anon_sym_row_major] = ACTIONS(3520),
    [anon_sym_column_major] = ACTIONS(3520),
    [anon_sym_globallycoherent] = ACTIONS(3520),
    [anon_sym_centroid] = ACTIONS(3520),
    [anon_sym_noperspective] = ACTIONS(3520),
    [anon_sym_nointerpolation] = ACTIONS(3520),
    [anon_sym_sample] = ACTIONS(3520),
    [anon_sym_linear] = ACTIONS(3520),
    [anon_sym_snorm] = ACTIONS(3520),
    [anon_sym_unorm] = ACTIONS(3520),
    [anon_sym_point] = ACTIONS(3520),
    [anon_sym_line] = ACTIONS(3520),
    [anon_sym_triangleadj] = ACTIONS(3520),
    [anon_sym_lineadj] = ACTIONS(3520),
    [anon_sym_triangle] = ACTIONS(3520),
    [anon_sym_cbuffer] = ACTIONS(3520),
    [anon_sym_interface] = ACTIONS(3520),
    [anon_sym_extension] = ACTIONS(3520),
    [anon_sym___exported] = ACTIONS(3520),
  },
  [423] = {
    [sym_identifier] = ACTIONS(3444),
    [aux_sym_preproc_include_token1] = ACTIONS(3444),
    [aux_sym_preproc_def_token1] = ACTIONS(3444),
    [aux_sym_preproc_if_token1] = ACTIONS(3444),
    [aux_sym_preproc_if_token2] = ACTIONS(3444),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3444),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3444),
    [aux_sym_preproc_else_token1] = ACTIONS(3444),
    [aux_sym_preproc_elif_token1] = ACTIONS(3444),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3444),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3444),
    [sym_preproc_directive] = ACTIONS(3444),
    [anon_sym_LPAREN2] = ACTIONS(3442),
    [anon_sym_BANG] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3444),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_STAR] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_AMP] = ACTIONS(3444),
    [anon_sym_SEMI] = ACTIONS(3442),
    [anon_sym___extension__] = ACTIONS(3444),
    [anon_sym_typedef] = ACTIONS(3444),
    [anon_sym_in] = ACTIONS(3444),
    [anon_sym_out] = ACTIONS(3444),
    [anon_sym_inout] = ACTIONS(3444),
    [anon_sym_virtual] = ACTIONS(3444),
    [anon_sym_extern] = ACTIONS(3444),
    [anon_sym___attribute__] = ACTIONS(3444),
    [anon_sym___attribute] = ACTIONS(3444),
    [anon_sym_using] = ACTIONS(3444),
    [anon_sym_COLON_COLON] = ACTIONS(3442),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3442),
    [anon_sym___declspec] = ACTIONS(3444),
    [anon_sym___based] = ACTIONS(3444),
    [anon_sym___cdecl] = ACTIONS(3444),
    [anon_sym___clrcall] = ACTIONS(3444),
    [anon_sym___stdcall] = ACTIONS(3444),
    [anon_sym___fastcall] = ACTIONS(3444),
    [anon_sym___thiscall] = ACTIONS(3444),
    [anon_sym___vectorcall] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_signed] = ACTIONS(3444),
    [anon_sym_unsigned] = ACTIONS(3444),
    [anon_sym_long] = ACTIONS(3444),
    [anon_sym_short] = ACTIONS(3444),
    [anon_sym_LBRACK] = ACTIONS(3444),
    [anon_sym_static] = ACTIONS(3444),
    [anon_sym_register] = ACTIONS(3444),
    [anon_sym_inline] = ACTIONS(3444),
    [anon_sym___inline] = ACTIONS(3444),
    [anon_sym___inline__] = ACTIONS(3444),
    [anon_sym___forceinline] = ACTIONS(3444),
    [anon_sym_thread_local] = ACTIONS(3444),
    [anon_sym___thread] = ACTIONS(3444),
    [anon_sym_const] = ACTIONS(3444),
    [anon_sym_constexpr] = ACTIONS(3444),
    [anon_sym_volatile] = ACTIONS(3444),
    [anon_sym_restrict] = ACTIONS(3444),
    [anon_sym___restrict__] = ACTIONS(3444),
    [anon_sym__Atomic] = ACTIONS(3444),
    [anon_sym__Noreturn] = ACTIONS(3444),
    [anon_sym_noreturn] = ACTIONS(3444),
    [anon_sym__Nonnull] = ACTIONS(3444),
    [anon_sym_mutable] = ACTIONS(3444),
    [anon_sym_constinit] = ACTIONS(3444),
    [anon_sym_consteval] = ACTIONS(3444),
    [anon_sym_alignas] = ACTIONS(3444),
    [anon_sym__Alignas] = ACTIONS(3444),
    [sym_primitive_type] = ACTIONS(3444),
    [anon_sym_enum] = ACTIONS(3444),
    [anon_sym_class] = ACTIONS(3444),
    [anon_sym_struct] = ACTIONS(3444),
    [anon_sym_union] = ACTIONS(3444),
    [anon_sym_if] = ACTIONS(3444),
    [anon_sym_else] = ACTIONS(3444),
    [anon_sym_switch] = ACTIONS(3444),
    [anon_sym_case] = ACTIONS(3444),
    [anon_sym_default] = ACTIONS(3444),
    [anon_sym_while] = ACTIONS(3444),
    [anon_sym_do] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3444),
    [anon_sym_return] = ACTIONS(3444),
    [anon_sym_break] = ACTIONS(3444),
    [anon_sym_continue] = ACTIONS(3444),
    [anon_sym_goto] = ACTIONS(3444),
    [anon_sym___try] = ACTIONS(3444),
    [anon_sym___leave] = ACTIONS(3444),
    [anon_sym_not] = ACTIONS(3444),
    [anon_sym_compl] = ACTIONS(3444),
    [anon_sym_DASH_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_PLUS] = ACTIONS(3442),
    [anon_sym_sizeof] = ACTIONS(3444),
    [anon_sym___alignof__] = ACTIONS(3444),
    [anon_sym___alignof] = ACTIONS(3444),
    [anon_sym__alignof] = ACTIONS(3444),
    [anon_sym_alignof] = ACTIONS(3444),
    [anon_sym__Alignof] = ACTIONS(3444),
    [anon_sym_offsetof] = ACTIONS(3444),
    [anon_sym__Generic] = ACTIONS(3444),
    [anon_sym_asm] = ACTIONS(3444),
    [anon_sym___asm__] = ACTIONS(3444),
    [anon_sym___asm] = ACTIONS(3444),
    [sym_number_literal] = ACTIONS(3442),
    [anon_sym_L_SQUOTE] = ACTIONS(3442),
    [anon_sym_u_SQUOTE] = ACTIONS(3442),
    [anon_sym_U_SQUOTE] = ACTIONS(3442),
    [anon_sym_u8_SQUOTE] = ACTIONS(3442),
    [anon_sym_SQUOTE] = ACTIONS(3442),
    [anon_sym_L_DQUOTE] = ACTIONS(3442),
    [anon_sym_u_DQUOTE] = ACTIONS(3442),
    [anon_sym_U_DQUOTE] = ACTIONS(3442),
    [anon_sym_u8_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [sym_true] = ACTIONS(3444),
    [sym_false] = ACTIONS(3444),
    [anon_sym_NULL] = ACTIONS(3444),
    [anon_sym_nullptr] = ACTIONS(3444),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3444),
    [anon_sym_let] = ACTIONS(3444),
    [anon_sym_This] = ACTIONS(3444),
    [anon_sym_decltype] = ACTIONS(3444),
    [anon_sym_explicit] = ACTIONS(3444),
    [anon_sym_typename] = ACTIONS(3444),
    [anon_sym_template] = ACTIONS(3444),
    [anon_sym_operator] = ACTIONS(3444),
    [anon_sym_try] = ACTIONS(3444),
    [anon_sym_delete] = ACTIONS(3444),
    [anon_sym_throw] = ACTIONS(3444),
    [anon_sym_namespace] = ACTIONS(3444),
    [anon_sym_static_assert] = ACTIONS(3444),
    [anon_sym_concept] = ACTIONS(3444),
    [anon_sym_co_return] = ACTIONS(3444),
    [anon_sym_co_yield] = ACTIONS(3444),
    [anon_sym_R_DQUOTE] = ACTIONS(3442),
    [anon_sym_LR_DQUOTE] = ACTIONS(3442),
    [anon_sym_uR_DQUOTE] = ACTIONS(3442),
    [anon_sym_UR_DQUOTE] = ACTIONS(3442),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3442),
    [anon_sym_co_await] = ACTIONS(3444),
    [anon_sym_new] = ACTIONS(3444),
    [anon_sym_requires] = ACTIONS(3444),
    [sym_this] = ACTIONS(3444),
    [anon_sym_discard] = ACTIONS(3444),
    [anon_sym_precise] = ACTIONS(3444),
    [anon_sym_shared] = ACTIONS(3444),
    [anon_sym_groupshared] = ACTIONS(3444),
    [anon_sym_uniform] = ACTIONS(3444),
    [anon_sym_row_major] = ACTIONS(3444),
    [anon_sym_column_major] = ACTIONS(3444),
    [anon_sym_globallycoherent] = ACTIONS(3444),
    [anon_sym_centroid] = ACTIONS(3444),
    [anon_sym_noperspective] = ACTIONS(3444),
    [anon_sym_nointerpolation] = ACTIONS(3444),
    [anon_sym_sample] = ACTIONS(3444),
    [anon_sym_linear] = ACTIONS(3444),
    [anon_sym_snorm] = ACTIONS(3444),
    [anon_sym_unorm] = ACTIONS(3444),
    [anon_sym_point] = ACTIONS(3444),
    [anon_sym_line] = ACTIONS(3444),
    [anon_sym_triangleadj] = ACTIONS(3444),
    [anon_sym_lineadj] = ACTIONS(3444),
    [anon_sym_triangle] = ACTIONS(3444),
    [anon_sym_cbuffer] = ACTIONS(3444),
    [anon_sym_interface] = ACTIONS(3444),
    [anon_sym_extension] = ACTIONS(3444),
  },
  [424] = {
    [sym_type_qualifier] = STATE(425),
    [sym_alignas_qualifier] = STATE(824),
    [aux_sym__type_definition_type_repeat1] = STATE(425),
    [aux_sym_sized_type_specifier_repeat1] = STATE(704),
    [sym_identifier] = ACTIONS(3522),
    [aux_sym_preproc_include_token1] = ACTIONS(3428),
    [aux_sym_preproc_def_token1] = ACTIONS(3428),
    [aux_sym_preproc_if_token1] = ACTIONS(3428),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3428),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3428),
    [sym_preproc_directive] = ACTIONS(3428),
    [anon_sym_LPAREN2] = ACTIONS(3423),
    [anon_sym_BANG] = ACTIONS(3423),
    [anon_sym_TILDE] = ACTIONS(3423),
    [anon_sym_DASH] = ACTIONS(3428),
    [anon_sym_PLUS] = ACTIONS(3428),
    [anon_sym_STAR] = ACTIONS(3423),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3428),
    [anon_sym_SEMI] = ACTIONS(3423),
    [anon_sym___extension__] = ACTIONS(3525),
    [anon_sym_typedef] = ACTIONS(3428),
    [anon_sym_in] = ACTIONS(3428),
    [anon_sym_out] = ACTIONS(3428),
    [anon_sym_inout] = ACTIONS(3428),
    [anon_sym_virtual] = ACTIONS(3428),
    [anon_sym_extern] = ACTIONS(3428),
    [anon_sym___attribute__] = ACTIONS(3428),
    [anon_sym___attribute] = ACTIONS(3428),
    [anon_sym_using] = ACTIONS(3428),
    [anon_sym_COLON_COLON] = ACTIONS(3423),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3423),
    [anon_sym___declspec] = ACTIONS(3428),
    [anon_sym___based] = ACTIONS(3428),
    [anon_sym___cdecl] = ACTIONS(3428),
    [anon_sym___clrcall] = ACTIONS(3428),
    [anon_sym___stdcall] = ACTIONS(3428),
    [anon_sym___fastcall] = ACTIONS(3428),
    [anon_sym___thiscall] = ACTIONS(3428),
    [anon_sym___vectorcall] = ACTIONS(3428),
    [anon_sym_LBRACE] = ACTIONS(3423),
    [anon_sym_RBRACE] = ACTIONS(3423),
    [anon_sym_signed] = ACTIONS(3528),
    [anon_sym_unsigned] = ACTIONS(3528),
    [anon_sym_long] = ACTIONS(3528),
    [anon_sym_short] = ACTIONS(3528),
    [anon_sym_LBRACK] = ACTIONS(3428),
    [anon_sym_static] = ACTIONS(3428),
    [anon_sym_register] = ACTIONS(3428),
    [anon_sym_inline] = ACTIONS(3428),
    [anon_sym___inline] = ACTIONS(3428),
    [anon_sym___inline__] = ACTIONS(3428),
    [anon_sym___forceinline] = ACTIONS(3428),
    [anon_sym_thread_local] = ACTIONS(3428),
    [anon_sym___thread] = ACTIONS(3428),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_constexpr] = ACTIONS(3525),
    [anon_sym_volatile] = ACTIONS(3525),
    [anon_sym_restrict] = ACTIONS(3525),
    [anon_sym___restrict__] = ACTIONS(3525),
    [anon_sym__Atomic] = ACTIONS(3525),
    [anon_sym__Noreturn] = ACTIONS(3525),
    [anon_sym_noreturn] = ACTIONS(3525),
    [anon_sym__Nonnull] = ACTIONS(3525),
    [anon_sym_mutable] = ACTIONS(3525),
    [anon_sym_constinit] = ACTIONS(3525),
    [anon_sym_consteval] = ACTIONS(3525),
    [anon_sym_alignas] = ACTIONS(3531),
    [anon_sym__Alignas] = ACTIONS(3531),
    [sym_primitive_type] = ACTIONS(3534),
    [anon_sym_enum] = ACTIONS(3428),
    [anon_sym_class] = ACTIONS(3428),
    [anon_sym_struct] = ACTIONS(3428),
    [anon_sym_union] = ACTIONS(3428),
    [anon_sym_if] = ACTIONS(3428),
    [anon_sym_switch] = ACTIONS(3428),
    [anon_sym_case] = ACTIONS(3428),
    [anon_sym_default] = ACTIONS(3428),
    [anon_sym_while] = ACTIONS(3428),
    [anon_sym_do] = ACTIONS(3428),
    [anon_sym_for] = ACTIONS(3428),
    [anon_sym_return] = ACTIONS(3428),
    [anon_sym_break] = ACTIONS(3428),
    [anon_sym_continue] = ACTIONS(3428),
    [anon_sym_goto] = ACTIONS(3428),
    [anon_sym___try] = ACTIONS(3428),
    [anon_sym___leave] = ACTIONS(3428),
    [anon_sym_not] = ACTIONS(3428),
    [anon_sym_compl] = ACTIONS(3428),
    [anon_sym_DASH_DASH] = ACTIONS(3423),
    [anon_sym_PLUS_PLUS] = ACTIONS(3423),
    [anon_sym_sizeof] = ACTIONS(3428),
    [anon_sym___alignof__] = ACTIONS(3428),
    [anon_sym___alignof] = ACTIONS(3428),
    [anon_sym__alignof] = ACTIONS(3428),
    [anon_sym_alignof] = ACTIONS(3428),
    [anon_sym__Alignof] = ACTIONS(3428),
    [anon_sym_offsetof] = ACTIONS(3428),
    [anon_sym__Generic] = ACTIONS(3428),
    [anon_sym_asm] = ACTIONS(3428),
    [anon_sym___asm__] = ACTIONS(3428),
    [anon_sym___asm] = ACTIONS(3428),
    [anon_sym_DOT] = ACTIONS(3428),
    [sym_number_literal] = ACTIONS(3423),
    [anon_sym_L_SQUOTE] = ACTIONS(3423),
    [anon_sym_u_SQUOTE] = ACTIONS(3423),
    [anon_sym_U_SQUOTE] = ACTIONS(3423),
    [anon_sym_u8_SQUOTE] = ACTIONS(3423),
    [anon_sym_SQUOTE] = ACTIONS(3423),
    [anon_sym_L_DQUOTE] = ACTIONS(3423),
    [anon_sym_u_DQUOTE] = ACTIONS(3423),
    [anon_sym_U_DQUOTE] = ACTIONS(3423),
    [anon_sym_u8_DQUOTE] = ACTIONS(3423),
    [anon_sym_DQUOTE] = ACTIONS(3423),
    [sym_true] = ACTIONS(3428),
    [sym_false] = ACTIONS(3428),
    [anon_sym_NULL] = ACTIONS(3428),
    [anon_sym_nullptr] = ACTIONS(3428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3428),
    [anon_sym_let] = ACTIONS(3428),
    [anon_sym_This] = ACTIONS(3428),
    [anon_sym_decltype] = ACTIONS(3428),
    [anon_sym_explicit] = ACTIONS(3428),
    [anon_sym_typename] = ACTIONS(3428),
    [anon_sym_template] = ACTIONS(3428),
    [anon_sym_operator] = ACTIONS(3428),
    [anon_sym_try] = ACTIONS(3428),
    [anon_sym_delete] = ACTIONS(3428),
    [anon_sym_throw] = ACTIONS(3428),
    [anon_sym_namespace] = ACTIONS(3428),
    [anon_sym_static_assert] = ACTIONS(3428),
    [anon_sym_concept] = ACTIONS(3428),
    [anon_sym_co_return] = ACTIONS(3428),
    [anon_sym_co_yield] = ACTIONS(3428),
    [anon_sym_R_DQUOTE] = ACTIONS(3423),
    [anon_sym_LR_DQUOTE] = ACTIONS(3423),
    [anon_sym_uR_DQUOTE] = ACTIONS(3423),
    [anon_sym_UR_DQUOTE] = ACTIONS(3423),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3423),
    [anon_sym_co_await] = ACTIONS(3428),
    [anon_sym_new] = ACTIONS(3428),
    [anon_sym_requires] = ACTIONS(3428),
    [sym_this] = ACTIONS(3428),
    [anon_sym_discard] = ACTIONS(3428),
    [anon_sym_precise] = ACTIONS(3428),
    [anon_sym_shared] = ACTIONS(3428),
    [anon_sym_groupshared] = ACTIONS(3428),
    [anon_sym_uniform] = ACTIONS(3428),
    [anon_sym_row_major] = ACTIONS(3428),
    [anon_sym_column_major] = ACTIONS(3428),
    [anon_sym_globallycoherent] = ACTIONS(3428),
    [anon_sym_centroid] = ACTIONS(3428),
    [anon_sym_noperspective] = ACTIONS(3428),
    [anon_sym_nointerpolation] = ACTIONS(3428),
    [anon_sym_sample] = ACTIONS(3428),
    [anon_sym_linear] = ACTIONS(3428),
    [anon_sym_snorm] = ACTIONS(3428),
    [anon_sym_unorm] = ACTIONS(3428),
    [anon_sym_point] = ACTIONS(3428),
    [anon_sym_line] = ACTIONS(3428),
    [anon_sym_triangleadj] = ACTIONS(3428),
    [anon_sym_lineadj] = ACTIONS(3428),
    [anon_sym_triangle] = ACTIONS(3428),
    [anon_sym_cbuffer] = ACTIONS(3428),
    [anon_sym_interface] = ACTIONS(3428),
    [anon_sym_extension] = ACTIONS(3428),
  },
  [425] = {
    [sym_type_qualifier] = STATE(622),
    [sym_alignas_qualifier] = STATE(824),
    [aux_sym__type_definition_type_repeat1] = STATE(622),
    [aux_sym_sized_type_specifier_repeat1] = STATE(688),
    [sym_identifier] = ACTIONS(3537),
    [aux_sym_preproc_include_token1] = ACTIONS(3540),
    [aux_sym_preproc_def_token1] = ACTIONS(3540),
    [aux_sym_preproc_if_token1] = ACTIONS(3540),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3540),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3540),
    [sym_preproc_directive] = ACTIONS(3540),
    [anon_sym_LPAREN2] = ACTIONS(3542),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_AMP] = ACTIONS(3540),
    [anon_sym_SEMI] = ACTIONS(3542),
    [anon_sym___extension__] = ACTIONS(3544),
    [anon_sym_typedef] = ACTIONS(3540),
    [anon_sym_in] = ACTIONS(3540),
    [anon_sym_out] = ACTIONS(3540),
    [anon_sym_inout] = ACTIONS(3540),
    [anon_sym_virtual] = ACTIONS(3540),
    [anon_sym_extern] = ACTIONS(3540),
    [anon_sym___attribute__] = ACTIONS(3540),
    [anon_sym___attribute] = ACTIONS(3540),
    [anon_sym_using] = ACTIONS(3540),
    [anon_sym_COLON_COLON] = ACTIONS(3542),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3542),
    [anon_sym___declspec] = ACTIONS(3540),
    [anon_sym___based] = ACTIONS(3540),
    [anon_sym___cdecl] = ACTIONS(3540),
    [anon_sym___clrcall] = ACTIONS(3540),
    [anon_sym___stdcall] = ACTIONS(3540),
    [anon_sym___fastcall] = ACTIONS(3540),
    [anon_sym___thiscall] = ACTIONS(3540),
    [anon_sym___vectorcall] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_RBRACE] = ACTIONS(3542),
    [anon_sym_signed] = ACTIONS(3547),
    [anon_sym_unsigned] = ACTIONS(3547),
    [anon_sym_long] = ACTIONS(3547),
    [anon_sym_short] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3540),
    [anon_sym_static] = ACTIONS(3540),
    [anon_sym_register] = ACTIONS(3540),
    [anon_sym_inline] = ACTIONS(3540),
    [anon_sym___inline] = ACTIONS(3540),
    [anon_sym___inline__] = ACTIONS(3540),
    [anon_sym___forceinline] = ACTIONS(3540),
    [anon_sym_thread_local] = ACTIONS(3540),
    [anon_sym___thread] = ACTIONS(3540),
    [anon_sym_const] = ACTIONS(3544),
    [anon_sym_constexpr] = ACTIONS(3544),
    [anon_sym_volatile] = ACTIONS(3544),
    [anon_sym_restrict] = ACTIONS(3544),
    [anon_sym___restrict__] = ACTIONS(3544),
    [anon_sym__Atomic] = ACTIONS(3544),
    [anon_sym__Noreturn] = ACTIONS(3544),
    [anon_sym_noreturn] = ACTIONS(3544),
    [anon_sym__Nonnull] = ACTIONS(3544),
    [anon_sym_mutable] = ACTIONS(3544),
    [anon_sym_constinit] = ACTIONS(3544),
    [anon_sym_consteval] = ACTIONS(3544),
    [anon_sym_alignas] = ACTIONS(3550),
    [anon_sym__Alignas] = ACTIONS(3550),
    [sym_primitive_type] = ACTIONS(3553),
    [anon_sym_enum] = ACTIONS(3540),
    [anon_sym_class] = ACTIONS(3540),
    [anon_sym_struct] = ACTIONS(3540),
    [anon_sym_union] = ACTIONS(3540),
    [anon_sym_if] = ACTIONS(3540),
    [anon_sym_switch] = ACTIONS(3540),
    [anon_sym_case] = ACTIONS(3540),
    [anon_sym_default] = ACTIONS(3540),
    [anon_sym_while] = ACTIONS(3540),
    [anon_sym_do] = ACTIONS(3540),
    [anon_sym_for] = ACTIONS(3540),
    [anon_sym_return] = ACTIONS(3540),
    [anon_sym_break] = ACTIONS(3540),
    [anon_sym_continue] = ACTIONS(3540),
    [anon_sym_goto] = ACTIONS(3540),
    [anon_sym___try] = ACTIONS(3540),
    [anon_sym___leave] = ACTIONS(3540),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(3542),
    [anon_sym_PLUS_PLUS] = ACTIONS(3542),
    [anon_sym_sizeof] = ACTIONS(3540),
    [anon_sym___alignof__] = ACTIONS(3540),
    [anon_sym___alignof] = ACTIONS(3540),
    [anon_sym__alignof] = ACTIONS(3540),
    [anon_sym_alignof] = ACTIONS(3540),
    [anon_sym__Alignof] = ACTIONS(3540),
    [anon_sym_offsetof] = ACTIONS(3540),
    [anon_sym__Generic] = ACTIONS(3540),
    [anon_sym_asm] = ACTIONS(3540),
    [anon_sym___asm__] = ACTIONS(3540),
    [anon_sym___asm] = ACTIONS(3540),
    [anon_sym_DOT] = ACTIONS(3540),
    [sym_number_literal] = ACTIONS(3542),
    [anon_sym_L_SQUOTE] = ACTIONS(3542),
    [anon_sym_u_SQUOTE] = ACTIONS(3542),
    [anon_sym_U_SQUOTE] = ACTIONS(3542),
    [anon_sym_u8_SQUOTE] = ACTIONS(3542),
    [anon_sym_SQUOTE] = ACTIONS(3542),
    [anon_sym_L_DQUOTE] = ACTIONS(3542),
    [anon_sym_u_DQUOTE] = ACTIONS(3542),
    [anon_sym_U_DQUOTE] = ACTIONS(3542),
    [anon_sym_u8_DQUOTE] = ACTIONS(3542),
    [anon_sym_DQUOTE] = ACTIONS(3542),
    [sym_true] = ACTIONS(3540),
    [sym_false] = ACTIONS(3540),
    [anon_sym_NULL] = ACTIONS(3540),
    [anon_sym_nullptr] = ACTIONS(3540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3540),
    [anon_sym_let] = ACTIONS(3540),
    [anon_sym_This] = ACTIONS(3540),
    [anon_sym_decltype] = ACTIONS(3540),
    [anon_sym_explicit] = ACTIONS(3540),
    [anon_sym_typename] = ACTIONS(3540),
    [anon_sym_template] = ACTIONS(3540),
    [anon_sym_operator] = ACTIONS(3540),
    [anon_sym_try] = ACTIONS(3540),
    [anon_sym_delete] = ACTIONS(3540),
    [anon_sym_throw] = ACTIONS(3540),
    [anon_sym_namespace] = ACTIONS(3540),
    [anon_sym_static_assert] = ACTIONS(3540),
    [anon_sym_concept] = ACTIONS(3540),
    [anon_sym_co_return] = ACTIONS(3540),
    [anon_sym_co_yield] = ACTIONS(3540),
    [anon_sym_R_DQUOTE] = ACTIONS(3542),
    [anon_sym_LR_DQUOTE] = ACTIONS(3542),
    [anon_sym_uR_DQUOTE] = ACTIONS(3542),
    [anon_sym_UR_DQUOTE] = ACTIONS(3542),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3542),
    [anon_sym_co_await] = ACTIONS(3540),
    [anon_sym_new] = ACTIONS(3540),
    [anon_sym_requires] = ACTIONS(3540),
    [sym_this] = ACTIONS(3540),
    [anon_sym_discard] = ACTIONS(3540),
    [anon_sym_precise] = ACTIONS(3540),
    [anon_sym_shared] = ACTIONS(3540),
    [anon_sym_groupshared] = ACTIONS(3540),
    [anon_sym_uniform] = ACTIONS(3540),
    [anon_sym_row_major] = ACTIONS(3540),
    [anon_sym_column_major] = ACTIONS(3540),
    [anon_sym_globallycoherent] = ACTIONS(3540),
    [anon_sym_centroid] = ACTIONS(3540),
    [anon_sym_noperspective] = ACTIONS(3540),
    [anon_sym_nointerpolation] = ACTIONS(3540),
    [anon_sym_sample] = ACTIONS(3540),
    [anon_sym_linear] = ACTIONS(3540),
    [anon_sym_snorm] = ACTIONS(3540),
    [anon_sym_unorm] = ACTIONS(3540),
    [anon_sym_point] = ACTIONS(3540),
    [anon_sym_line] = ACTIONS(3540),
    [anon_sym_triangleadj] = ACTIONS(3540),
    [anon_sym_lineadj] = ACTIONS(3540),
    [anon_sym_triangle] = ACTIONS(3540),
    [anon_sym_cbuffer] = ACTIONS(3540),
    [anon_sym_interface] = ACTIONS(3540),
    [anon_sym_extension] = ACTIONS(3540),
  },
  [426] = {
    [sym_identifier] = ACTIONS(2268),
    [aux_sym_preproc_include_token1] = ACTIONS(2268),
    [aux_sym_preproc_def_token1] = ACTIONS(2268),
    [aux_sym_preproc_if_token1] = ACTIONS(2268),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2268),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2268),
    [sym_preproc_directive] = ACTIONS(2268),
    [anon_sym_LPAREN2] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2270),
    [anon_sym_TILDE] = ACTIONS(2270),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2270),
    [anon_sym_AMP_AMP] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(2268),
    [anon_sym_COLON] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym___extension__] = ACTIONS(2268),
    [anon_sym_typedef] = ACTIONS(2268),
    [anon_sym_in] = ACTIONS(2268),
    [anon_sym_out] = ACTIONS(2268),
    [anon_sym_inout] = ACTIONS(2268),
    [anon_sym_virtual] = ACTIONS(2268),
    [anon_sym_extern] = ACTIONS(2268),
    [anon_sym___attribute__] = ACTIONS(2268),
    [anon_sym___attribute] = ACTIONS(2268),
    [anon_sym_using] = ACTIONS(2268),
    [anon_sym_COLON_COLON] = ACTIONS(2270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2270),
    [anon_sym___declspec] = ACTIONS(2268),
    [anon_sym___based] = ACTIONS(2268),
    [anon_sym___cdecl] = ACTIONS(2268),
    [anon_sym___clrcall] = ACTIONS(2268),
    [anon_sym___stdcall] = ACTIONS(2268),
    [anon_sym___fastcall] = ACTIONS(2268),
    [anon_sym___thiscall] = ACTIONS(2268),
    [anon_sym___vectorcall] = ACTIONS(2268),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_RBRACE] = ACTIONS(2270),
    [anon_sym_signed] = ACTIONS(2268),
    [anon_sym_unsigned] = ACTIONS(2268),
    [anon_sym_long] = ACTIONS(2268),
    [anon_sym_short] = ACTIONS(2268),
    [anon_sym_LBRACK] = ACTIONS(2268),
    [anon_sym_static] = ACTIONS(2268),
    [anon_sym_register] = ACTIONS(2268),
    [anon_sym_inline] = ACTIONS(2268),
    [anon_sym___inline] = ACTIONS(2268),
    [anon_sym___inline__] = ACTIONS(2268),
    [anon_sym___forceinline] = ACTIONS(2268),
    [anon_sym_thread_local] = ACTIONS(2268),
    [anon_sym___thread] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_constexpr] = ACTIONS(2268),
    [anon_sym_volatile] = ACTIONS(2268),
    [anon_sym_restrict] = ACTIONS(2268),
    [anon_sym___restrict__] = ACTIONS(2268),
    [anon_sym__Atomic] = ACTIONS(2268),
    [anon_sym__Noreturn] = ACTIONS(2268),
    [anon_sym_noreturn] = ACTIONS(2268),
    [anon_sym__Nonnull] = ACTIONS(2268),
    [anon_sym_mutable] = ACTIONS(2268),
    [anon_sym_constinit] = ACTIONS(2268),
    [anon_sym_consteval] = ACTIONS(2268),
    [anon_sym_alignas] = ACTIONS(2268),
    [anon_sym__Alignas] = ACTIONS(2268),
    [sym_primitive_type] = ACTIONS(2268),
    [anon_sym_enum] = ACTIONS(2268),
    [anon_sym_class] = ACTIONS(2268),
    [anon_sym_struct] = ACTIONS(2268),
    [anon_sym_union] = ACTIONS(2268),
    [anon_sym_if] = ACTIONS(2268),
    [anon_sym_else] = ACTIONS(2268),
    [anon_sym_switch] = ACTIONS(2268),
    [anon_sym_case] = ACTIONS(2268),
    [anon_sym_default] = ACTIONS(2268),
    [anon_sym_while] = ACTIONS(2268),
    [anon_sym_do] = ACTIONS(2268),
    [anon_sym_for] = ACTIONS(2268),
    [anon_sym_return] = ACTIONS(2268),
    [anon_sym_break] = ACTIONS(2268),
    [anon_sym_continue] = ACTIONS(2268),
    [anon_sym_goto] = ACTIONS(2268),
    [anon_sym___try] = ACTIONS(2268),
    [anon_sym___leave] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2268),
    [anon_sym_compl] = ACTIONS(2268),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_sizeof] = ACTIONS(2268),
    [anon_sym___alignof__] = ACTIONS(2268),
    [anon_sym___alignof] = ACTIONS(2268),
    [anon_sym__alignof] = ACTIONS(2268),
    [anon_sym_alignof] = ACTIONS(2268),
    [anon_sym__Alignof] = ACTIONS(2268),
    [anon_sym_offsetof] = ACTIONS(2268),
    [anon_sym__Generic] = ACTIONS(2268),
    [anon_sym_asm] = ACTIONS(2268),
    [anon_sym___asm__] = ACTIONS(2268),
    [anon_sym___asm] = ACTIONS(2268),
    [anon_sym_DOT] = ACTIONS(2268),
    [sym_number_literal] = ACTIONS(2270),
    [anon_sym_L_SQUOTE] = ACTIONS(2270),
    [anon_sym_u_SQUOTE] = ACTIONS(2270),
    [anon_sym_U_SQUOTE] = ACTIONS(2270),
    [anon_sym_u8_SQUOTE] = ACTIONS(2270),
    [anon_sym_SQUOTE] = ACTIONS(2270),
    [anon_sym_L_DQUOTE] = ACTIONS(2270),
    [anon_sym_u_DQUOTE] = ACTIONS(2270),
    [anon_sym_U_DQUOTE] = ACTIONS(2270),
    [anon_sym_u8_DQUOTE] = ACTIONS(2270),
    [anon_sym_DQUOTE] = ACTIONS(2270),
    [sym_true] = ACTIONS(2268),
    [sym_false] = ACTIONS(2268),
    [anon_sym_NULL] = ACTIONS(2268),
    [anon_sym_nullptr] = ACTIONS(2268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_This] = ACTIONS(2268),
    [anon_sym_decltype] = ACTIONS(2268),
    [anon_sym_final] = ACTIONS(2268),
    [anon_sym_override] = ACTIONS(2268),
    [anon_sym_explicit] = ACTIONS(2268),
    [anon_sym_typename] = ACTIONS(2268),
    [anon_sym_template] = ACTIONS(2268),
    [anon_sym_operator] = ACTIONS(2268),
    [anon_sym_try] = ACTIONS(2268),
    [anon_sym_delete] = ACTIONS(2268),
    [anon_sym_throw] = ACTIONS(2268),
    [anon_sym_namespace] = ACTIONS(2268),
    [anon_sym_static_assert] = ACTIONS(2268),
    [anon_sym_concept] = ACTIONS(2268),
    [anon_sym_co_return] = ACTIONS(2268),
    [anon_sym_co_yield] = ACTIONS(2268),
    [anon_sym_R_DQUOTE] = ACTIONS(2270),
    [anon_sym_LR_DQUOTE] = ACTIONS(2270),
    [anon_sym_uR_DQUOTE] = ACTIONS(2270),
    [anon_sym_UR_DQUOTE] = ACTIONS(2270),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2270),
    [anon_sym_co_await] = ACTIONS(2268),
    [anon_sym_new] = ACTIONS(2268),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2268),
    [anon_sym_discard] = ACTIONS(2268),
    [anon_sym_precise] = ACTIONS(2268),
    [anon_sym_shared] = ACTIONS(2268),
    [anon_sym_groupshared] = ACTIONS(2268),
    [anon_sym_uniform] = ACTIONS(2268),
    [anon_sym_row_major] = ACTIONS(2268),
    [anon_sym_column_major] = ACTIONS(2268),
    [anon_sym_globallycoherent] = ACTIONS(2268),
    [anon_sym_centroid] = ACTIONS(2268),
    [anon_sym_noperspective] = ACTIONS(2268),
    [anon_sym_nointerpolation] = ACTIONS(2268),
    [anon_sym_sample] = ACTIONS(2268),
    [anon_sym_linear] = ACTIONS(2268),
    [anon_sym_snorm] = ACTIONS(2268),
    [anon_sym_unorm] = ACTIONS(2268),
    [anon_sym_point] = ACTIONS(2268),
    [anon_sym_line] = ACTIONS(2268),
    [anon_sym_triangleadj] = ACTIONS(2268),
    [anon_sym_lineadj] = ACTIONS(2268),
    [anon_sym_triangle] = ACTIONS(2268),
    [anon_sym_cbuffer] = ACTIONS(2268),
    [anon_sym_interface] = ACTIONS(2268),
    [anon_sym_extension] = ACTIONS(2268),
  },
  [427] = {
    [sym_identifier] = ACTIONS(2272),
    [aux_sym_preproc_include_token1] = ACTIONS(2272),
    [aux_sym_preproc_def_token1] = ACTIONS(2272),
    [aux_sym_preproc_if_token1] = ACTIONS(2272),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2272),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2272),
    [sym_preproc_directive] = ACTIONS(2272),
    [anon_sym_LPAREN2] = ACTIONS(2274),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2274),
    [anon_sym_AMP_AMP] = ACTIONS(2274),
    [anon_sym_AMP] = ACTIONS(2272),
    [anon_sym_COLON] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym___extension__] = ACTIONS(2272),
    [anon_sym_typedef] = ACTIONS(2272),
    [anon_sym_in] = ACTIONS(2272),
    [anon_sym_out] = ACTIONS(2272),
    [anon_sym_inout] = ACTIONS(2272),
    [anon_sym_virtual] = ACTIONS(2272),
    [anon_sym_extern] = ACTIONS(2272),
    [anon_sym___attribute__] = ACTIONS(2272),
    [anon_sym___attribute] = ACTIONS(2272),
    [anon_sym_using] = ACTIONS(2272),
    [anon_sym_COLON_COLON] = ACTIONS(2274),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2274),
    [anon_sym___declspec] = ACTIONS(2272),
    [anon_sym___based] = ACTIONS(2272),
    [anon_sym___cdecl] = ACTIONS(2272),
    [anon_sym___clrcall] = ACTIONS(2272),
    [anon_sym___stdcall] = ACTIONS(2272),
    [anon_sym___fastcall] = ACTIONS(2272),
    [anon_sym___thiscall] = ACTIONS(2272),
    [anon_sym___vectorcall] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_RBRACE] = ACTIONS(2274),
    [anon_sym_signed] = ACTIONS(2272),
    [anon_sym_unsigned] = ACTIONS(2272),
    [anon_sym_long] = ACTIONS(2272),
    [anon_sym_short] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_register] = ACTIONS(2272),
    [anon_sym_inline] = ACTIONS(2272),
    [anon_sym___inline] = ACTIONS(2272),
    [anon_sym___inline__] = ACTIONS(2272),
    [anon_sym___forceinline] = ACTIONS(2272),
    [anon_sym_thread_local] = ACTIONS(2272),
    [anon_sym___thread] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_constexpr] = ACTIONS(2272),
    [anon_sym_volatile] = ACTIONS(2272),
    [anon_sym_restrict] = ACTIONS(2272),
    [anon_sym___restrict__] = ACTIONS(2272),
    [anon_sym__Atomic] = ACTIONS(2272),
    [anon_sym__Noreturn] = ACTIONS(2272),
    [anon_sym_noreturn] = ACTIONS(2272),
    [anon_sym__Nonnull] = ACTIONS(2272),
    [anon_sym_mutable] = ACTIONS(2272),
    [anon_sym_constinit] = ACTIONS(2272),
    [anon_sym_consteval] = ACTIONS(2272),
    [anon_sym_alignas] = ACTIONS(2272),
    [anon_sym__Alignas] = ACTIONS(2272),
    [sym_primitive_type] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_struct] = ACTIONS(2272),
    [anon_sym_union] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_else] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_case] = ACTIONS(2272),
    [anon_sym_default] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_goto] = ACTIONS(2272),
    [anon_sym___try] = ACTIONS(2272),
    [anon_sym___leave] = ACTIONS(2272),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_compl] = ACTIONS(2272),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_sizeof] = ACTIONS(2272),
    [anon_sym___alignof__] = ACTIONS(2272),
    [anon_sym___alignof] = ACTIONS(2272),
    [anon_sym__alignof] = ACTIONS(2272),
    [anon_sym_alignof] = ACTIONS(2272),
    [anon_sym__Alignof] = ACTIONS(2272),
    [anon_sym_offsetof] = ACTIONS(2272),
    [anon_sym__Generic] = ACTIONS(2272),
    [anon_sym_asm] = ACTIONS(2272),
    [anon_sym___asm__] = ACTIONS(2272),
    [anon_sym___asm] = ACTIONS(2272),
    [anon_sym_DOT] = ACTIONS(2272),
    [sym_number_literal] = ACTIONS(2274),
    [anon_sym_L_SQUOTE] = ACTIONS(2274),
    [anon_sym_u_SQUOTE] = ACTIONS(2274),
    [anon_sym_U_SQUOTE] = ACTIONS(2274),
    [anon_sym_u8_SQUOTE] = ACTIONS(2274),
    [anon_sym_SQUOTE] = ACTIONS(2274),
    [anon_sym_L_DQUOTE] = ACTIONS(2274),
    [anon_sym_u_DQUOTE] = ACTIONS(2274),
    [anon_sym_U_DQUOTE] = ACTIONS(2274),
    [anon_sym_u8_DQUOTE] = ACTIONS(2274),
    [anon_sym_DQUOTE] = ACTIONS(2274),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [anon_sym_NULL] = ACTIONS(2272),
    [anon_sym_nullptr] = ACTIONS(2272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_This] = ACTIONS(2272),
    [anon_sym_decltype] = ACTIONS(2272),
    [anon_sym_final] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_explicit] = ACTIONS(2272),
    [anon_sym_typename] = ACTIONS(2272),
    [anon_sym_template] = ACTIONS(2272),
    [anon_sym_operator] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_namespace] = ACTIONS(2272),
    [anon_sym_static_assert] = ACTIONS(2272),
    [anon_sym_concept] = ACTIONS(2272),
    [anon_sym_co_return] = ACTIONS(2272),
    [anon_sym_co_yield] = ACTIONS(2272),
    [anon_sym_R_DQUOTE] = ACTIONS(2274),
    [anon_sym_LR_DQUOTE] = ACTIONS(2274),
    [anon_sym_uR_DQUOTE] = ACTIONS(2274),
    [anon_sym_UR_DQUOTE] = ACTIONS(2274),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2274),
    [anon_sym_co_await] = ACTIONS(2272),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_requires] = ACTIONS(2272),
    [sym_this] = ACTIONS(2272),
    [anon_sym_discard] = ACTIONS(2272),
    [anon_sym_precise] = ACTIONS(2272),
    [anon_sym_shared] = ACTIONS(2272),
    [anon_sym_groupshared] = ACTIONS(2272),
    [anon_sym_uniform] = ACTIONS(2272),
    [anon_sym_row_major] = ACTIONS(2272),
    [anon_sym_column_major] = ACTIONS(2272),
    [anon_sym_globallycoherent] = ACTIONS(2272),
    [anon_sym_centroid] = ACTIONS(2272),
    [anon_sym_noperspective] = ACTIONS(2272),
    [anon_sym_nointerpolation] = ACTIONS(2272),
    [anon_sym_sample] = ACTIONS(2272),
    [anon_sym_linear] = ACTIONS(2272),
    [anon_sym_snorm] = ACTIONS(2272),
    [anon_sym_unorm] = ACTIONS(2272),
    [anon_sym_point] = ACTIONS(2272),
    [anon_sym_line] = ACTIONS(2272),
    [anon_sym_triangleadj] = ACTIONS(2272),
    [anon_sym_lineadj] = ACTIONS(2272),
    [anon_sym_triangle] = ACTIONS(2272),
    [anon_sym_cbuffer] = ACTIONS(2272),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_extension] = ACTIONS(2272),
  },
  [428] = {
    [sym_identifier] = ACTIONS(2276),
    [aux_sym_preproc_include_token1] = ACTIONS(2276),
    [aux_sym_preproc_def_token1] = ACTIONS(2276),
    [aux_sym_preproc_if_token1] = ACTIONS(2276),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2276),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2276),
    [sym_preproc_directive] = ACTIONS(2276),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_PLUS] = ACTIONS(2276),
    [anon_sym_STAR] = ACTIONS(2278),
    [anon_sym_AMP_AMP] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_COLON] = ACTIONS(2276),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym___extension__] = ACTIONS(2276),
    [anon_sym_typedef] = ACTIONS(2276),
    [anon_sym_in] = ACTIONS(2276),
    [anon_sym_out] = ACTIONS(2276),
    [anon_sym_inout] = ACTIONS(2276),
    [anon_sym_virtual] = ACTIONS(2276),
    [anon_sym_extern] = ACTIONS(2276),
    [anon_sym___attribute__] = ACTIONS(2276),
    [anon_sym___attribute] = ACTIONS(2276),
    [anon_sym_using] = ACTIONS(2276),
    [anon_sym_COLON_COLON] = ACTIONS(2278),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2278),
    [anon_sym___declspec] = ACTIONS(2276),
    [anon_sym___based] = ACTIONS(2276),
    [anon_sym___cdecl] = ACTIONS(2276),
    [anon_sym___clrcall] = ACTIONS(2276),
    [anon_sym___stdcall] = ACTIONS(2276),
    [anon_sym___fastcall] = ACTIONS(2276),
    [anon_sym___thiscall] = ACTIONS(2276),
    [anon_sym___vectorcall] = ACTIONS(2276),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_signed] = ACTIONS(2276),
    [anon_sym_unsigned] = ACTIONS(2276),
    [anon_sym_long] = ACTIONS(2276),
    [anon_sym_short] = ACTIONS(2276),
    [anon_sym_LBRACK] = ACTIONS(2276),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_register] = ACTIONS(2276),
    [anon_sym_inline] = ACTIONS(2276),
    [anon_sym___inline] = ACTIONS(2276),
    [anon_sym___inline__] = ACTIONS(2276),
    [anon_sym___forceinline] = ACTIONS(2276),
    [anon_sym_thread_local] = ACTIONS(2276),
    [anon_sym___thread] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_constexpr] = ACTIONS(2276),
    [anon_sym_volatile] = ACTIONS(2276),
    [anon_sym_restrict] = ACTIONS(2276),
    [anon_sym___restrict__] = ACTIONS(2276),
    [anon_sym__Atomic] = ACTIONS(2276),
    [anon_sym__Noreturn] = ACTIONS(2276),
    [anon_sym_noreturn] = ACTIONS(2276),
    [anon_sym__Nonnull] = ACTIONS(2276),
    [anon_sym_mutable] = ACTIONS(2276),
    [anon_sym_constinit] = ACTIONS(2276),
    [anon_sym_consteval] = ACTIONS(2276),
    [anon_sym_alignas] = ACTIONS(2276),
    [anon_sym__Alignas] = ACTIONS(2276),
    [sym_primitive_type] = ACTIONS(2276),
    [anon_sym_enum] = ACTIONS(2276),
    [anon_sym_class] = ACTIONS(2276),
    [anon_sym_struct] = ACTIONS(2276),
    [anon_sym_union] = ACTIONS(2276),
    [anon_sym_if] = ACTIONS(2276),
    [anon_sym_else] = ACTIONS(2276),
    [anon_sym_switch] = ACTIONS(2276),
    [anon_sym_case] = ACTIONS(2276),
    [anon_sym_default] = ACTIONS(2276),
    [anon_sym_while] = ACTIONS(2276),
    [anon_sym_do] = ACTIONS(2276),
    [anon_sym_for] = ACTIONS(2276),
    [anon_sym_return] = ACTIONS(2276),
    [anon_sym_break] = ACTIONS(2276),
    [anon_sym_continue] = ACTIONS(2276),
    [anon_sym_goto] = ACTIONS(2276),
    [anon_sym___try] = ACTIONS(2276),
    [anon_sym___leave] = ACTIONS(2276),
    [anon_sym_not] = ACTIONS(2276),
    [anon_sym_compl] = ACTIONS(2276),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_sizeof] = ACTIONS(2276),
    [anon_sym___alignof__] = ACTIONS(2276),
    [anon_sym___alignof] = ACTIONS(2276),
    [anon_sym__alignof] = ACTIONS(2276),
    [anon_sym_alignof] = ACTIONS(2276),
    [anon_sym__Alignof] = ACTIONS(2276),
    [anon_sym_offsetof] = ACTIONS(2276),
    [anon_sym__Generic] = ACTIONS(2276),
    [anon_sym_asm] = ACTIONS(2276),
    [anon_sym___asm__] = ACTIONS(2276),
    [anon_sym___asm] = ACTIONS(2276),
    [anon_sym_DOT] = ACTIONS(2276),
    [sym_number_literal] = ACTIONS(2278),
    [anon_sym_L_SQUOTE] = ACTIONS(2278),
    [anon_sym_u_SQUOTE] = ACTIONS(2278),
    [anon_sym_U_SQUOTE] = ACTIONS(2278),
    [anon_sym_u8_SQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_L_DQUOTE] = ACTIONS(2278),
    [anon_sym_u_DQUOTE] = ACTIONS(2278),
    [anon_sym_U_DQUOTE] = ACTIONS(2278),
    [anon_sym_u8_DQUOTE] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [sym_true] = ACTIONS(2276),
    [sym_false] = ACTIONS(2276),
    [anon_sym_NULL] = ACTIONS(2276),
    [anon_sym_nullptr] = ACTIONS(2276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_This] = ACTIONS(2276),
    [anon_sym_decltype] = ACTIONS(2276),
    [anon_sym_final] = ACTIONS(2276),
    [anon_sym_override] = ACTIONS(2276),
    [anon_sym_explicit] = ACTIONS(2276),
    [anon_sym_typename] = ACTIONS(2276),
    [anon_sym_template] = ACTIONS(2276),
    [anon_sym_operator] = ACTIONS(2276),
    [anon_sym_try] = ACTIONS(2276),
    [anon_sym_delete] = ACTIONS(2276),
    [anon_sym_throw] = ACTIONS(2276),
    [anon_sym_namespace] = ACTIONS(2276),
    [anon_sym_static_assert] = ACTIONS(2276),
    [anon_sym_concept] = ACTIONS(2276),
    [anon_sym_co_return] = ACTIONS(2276),
    [anon_sym_co_yield] = ACTIONS(2276),
    [anon_sym_R_DQUOTE] = ACTIONS(2278),
    [anon_sym_LR_DQUOTE] = ACTIONS(2278),
    [anon_sym_uR_DQUOTE] = ACTIONS(2278),
    [anon_sym_UR_DQUOTE] = ACTIONS(2278),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2278),
    [anon_sym_co_await] = ACTIONS(2276),
    [anon_sym_new] = ACTIONS(2276),
    [anon_sym_requires] = ACTIONS(2276),
    [sym_this] = ACTIONS(2276),
    [anon_sym_discard] = ACTIONS(2276),
    [anon_sym_precise] = ACTIONS(2276),
    [anon_sym_shared] = ACTIONS(2276),
    [anon_sym_groupshared] = ACTIONS(2276),
    [anon_sym_uniform] = ACTIONS(2276),
    [anon_sym_row_major] = ACTIONS(2276),
    [anon_sym_column_major] = ACTIONS(2276),
    [anon_sym_globallycoherent] = ACTIONS(2276),
    [anon_sym_centroid] = ACTIONS(2276),
    [anon_sym_noperspective] = ACTIONS(2276),
    [anon_sym_nointerpolation] = ACTIONS(2276),
    [anon_sym_sample] = ACTIONS(2276),
    [anon_sym_linear] = ACTIONS(2276),
    [anon_sym_snorm] = ACTIONS(2276),
    [anon_sym_unorm] = ACTIONS(2276),
    [anon_sym_point] = ACTIONS(2276),
    [anon_sym_line] = ACTIONS(2276),
    [anon_sym_triangleadj] = ACTIONS(2276),
    [anon_sym_lineadj] = ACTIONS(2276),
    [anon_sym_triangle] = ACTIONS(2276),
    [anon_sym_cbuffer] = ACTIONS(2276),
    [anon_sym_interface] = ACTIONS(2276),
    [anon_sym_extension] = ACTIONS(2276),
  },
  [429] = {
    [sym_identifier] = ACTIONS(2239),
    [aux_sym_preproc_include_token1] = ACTIONS(2239),
    [aux_sym_preproc_def_token1] = ACTIONS(2239),
    [aux_sym_preproc_if_token1] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2239),
    [sym_preproc_directive] = ACTIONS(2239),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2239),
    [anon_sym_PLUS] = ACTIONS(2239),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_COLON] = ACTIONS(2239),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym_typedef] = ACTIONS(2239),
    [anon_sym_in] = ACTIONS(2239),
    [anon_sym_out] = ACTIONS(2239),
    [anon_sym_inout] = ACTIONS(2239),
    [anon_sym_virtual] = ACTIONS(2239),
    [anon_sym_extern] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym___attribute] = ACTIONS(2239),
    [anon_sym_using] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2241),
    [anon_sym___declspec] = ACTIONS(2239),
    [anon_sym___based] = ACTIONS(2239),
    [anon_sym___cdecl] = ACTIONS(2239),
    [anon_sym___clrcall] = ACTIONS(2239),
    [anon_sym___stdcall] = ACTIONS(2239),
    [anon_sym___fastcall] = ACTIONS(2239),
    [anon_sym___thiscall] = ACTIONS(2239),
    [anon_sym___vectorcall] = ACTIONS(2239),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_RBRACE] = ACTIONS(2241),
    [anon_sym_signed] = ACTIONS(2239),
    [anon_sym_unsigned] = ACTIONS(2239),
    [anon_sym_long] = ACTIONS(2239),
    [anon_sym_short] = ACTIONS(2239),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2239),
    [anon_sym_register] = ACTIONS(2239),
    [anon_sym_inline] = ACTIONS(2239),
    [anon_sym___inline] = ACTIONS(2239),
    [anon_sym___inline__] = ACTIONS(2239),
    [anon_sym___forceinline] = ACTIONS(2239),
    [anon_sym_thread_local] = ACTIONS(2239),
    [anon_sym___thread] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym__Nonnull] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [sym_primitive_type] = ACTIONS(2239),
    [anon_sym_enum] = ACTIONS(2239),
    [anon_sym_class] = ACTIONS(2239),
    [anon_sym_struct] = ACTIONS(2239),
    [anon_sym_union] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(2239),
    [anon_sym_else] = ACTIONS(2239),
    [anon_sym_switch] = ACTIONS(2239),
    [anon_sym_case] = ACTIONS(2239),
    [anon_sym_default] = ACTIONS(2239),
    [anon_sym_while] = ACTIONS(2239),
    [anon_sym_do] = ACTIONS(2239),
    [anon_sym_for] = ACTIONS(2239),
    [anon_sym_return] = ACTIONS(2239),
    [anon_sym_break] = ACTIONS(2239),
    [anon_sym_continue] = ACTIONS(2239),
    [anon_sym_goto] = ACTIONS(2239),
    [anon_sym___try] = ACTIONS(2239),
    [anon_sym___leave] = ACTIONS(2239),
    [anon_sym_not] = ACTIONS(2239),
    [anon_sym_compl] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_sizeof] = ACTIONS(2239),
    [anon_sym___alignof__] = ACTIONS(2239),
    [anon_sym___alignof] = ACTIONS(2239),
    [anon_sym__alignof] = ACTIONS(2239),
    [anon_sym_alignof] = ACTIONS(2239),
    [anon_sym__Alignof] = ACTIONS(2239),
    [anon_sym_offsetof] = ACTIONS(2239),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2239),
    [anon_sym___asm__] = ACTIONS(2239),
    [anon_sym___asm] = ACTIONS(2239),
    [anon_sym_DOT] = ACTIONS(2239),
    [sym_number_literal] = ACTIONS(2241),
    [anon_sym_L_SQUOTE] = ACTIONS(2241),
    [anon_sym_u_SQUOTE] = ACTIONS(2241),
    [anon_sym_U_SQUOTE] = ACTIONS(2241),
    [anon_sym_u8_SQUOTE] = ACTIONS(2241),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_L_DQUOTE] = ACTIONS(2241),
    [anon_sym_u_DQUOTE] = ACTIONS(2241),
    [anon_sym_U_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8_DQUOTE] = ACTIONS(2241),
    [anon_sym_DQUOTE] = ACTIONS(2241),
    [sym_true] = ACTIONS(2239),
    [sym_false] = ACTIONS(2239),
    [anon_sym_NULL] = ACTIONS(2239),
    [anon_sym_nullptr] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2239),
    [anon_sym_let] = ACTIONS(2239),
    [anon_sym_This] = ACTIONS(2239),
    [anon_sym_decltype] = ACTIONS(2239),
    [anon_sym_final] = ACTIONS(2239),
    [anon_sym_override] = ACTIONS(2239),
    [anon_sym_explicit] = ACTIONS(2239),
    [anon_sym_typename] = ACTIONS(2239),
    [anon_sym_template] = ACTIONS(2239),
    [anon_sym_operator] = ACTIONS(2239),
    [anon_sym_try] = ACTIONS(2239),
    [anon_sym_delete] = ACTIONS(2239),
    [anon_sym_throw] = ACTIONS(2239),
    [anon_sym_namespace] = ACTIONS(2239),
    [anon_sym_static_assert] = ACTIONS(2239),
    [anon_sym_concept] = ACTIONS(2239),
    [anon_sym_co_return] = ACTIONS(2239),
    [anon_sym_co_yield] = ACTIONS(2239),
    [anon_sym_R_DQUOTE] = ACTIONS(2241),
    [anon_sym_LR_DQUOTE] = ACTIONS(2241),
    [anon_sym_uR_DQUOTE] = ACTIONS(2241),
    [anon_sym_UR_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2241),
    [anon_sym_co_await] = ACTIONS(2239),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_requires] = ACTIONS(2239),
    [sym_this] = ACTIONS(2239),
    [anon_sym_discard] = ACTIONS(2239),
    [anon_sym_precise] = ACTIONS(2239),
    [anon_sym_shared] = ACTIONS(2239),
    [anon_sym_groupshared] = ACTIONS(2239),
    [anon_sym_uniform] = ACTIONS(2239),
    [anon_sym_row_major] = ACTIONS(2239),
    [anon_sym_column_major] = ACTIONS(2239),
    [anon_sym_globallycoherent] = ACTIONS(2239),
    [anon_sym_centroid] = ACTIONS(2239),
    [anon_sym_noperspective] = ACTIONS(2239),
    [anon_sym_nointerpolation] = ACTIONS(2239),
    [anon_sym_sample] = ACTIONS(2239),
    [anon_sym_linear] = ACTIONS(2239),
    [anon_sym_snorm] = ACTIONS(2239),
    [anon_sym_unorm] = ACTIONS(2239),
    [anon_sym_point] = ACTIONS(2239),
    [anon_sym_line] = ACTIONS(2239),
    [anon_sym_triangleadj] = ACTIONS(2239),
    [anon_sym_lineadj] = ACTIONS(2239),
    [anon_sym_triangle] = ACTIONS(2239),
    [anon_sym_cbuffer] = ACTIONS(2239),
    [anon_sym_interface] = ACTIONS(2239),
    [anon_sym_extension] = ACTIONS(2239),
  },
  [430] = {
    [sym_identifier] = ACTIONS(2280),
    [aux_sym_preproc_include_token1] = ACTIONS(2280),
    [aux_sym_preproc_def_token1] = ACTIONS(2280),
    [aux_sym_preproc_if_token1] = ACTIONS(2280),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2280),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2280),
    [sym_preproc_directive] = ACTIONS(2280),
    [anon_sym_LPAREN2] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(2282),
    [anon_sym_TILDE] = ACTIONS(2282),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2282),
    [anon_sym_AMP_AMP] = ACTIONS(2282),
    [anon_sym_AMP] = ACTIONS(2280),
    [anon_sym_COLON] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(2280),
    [anon_sym_typedef] = ACTIONS(2280),
    [anon_sym_in] = ACTIONS(2280),
    [anon_sym_out] = ACTIONS(2280),
    [anon_sym_inout] = ACTIONS(2280),
    [anon_sym_virtual] = ACTIONS(2280),
    [anon_sym_extern] = ACTIONS(2280),
    [anon_sym___attribute__] = ACTIONS(2280),
    [anon_sym___attribute] = ACTIONS(2280),
    [anon_sym_using] = ACTIONS(2280),
    [anon_sym_COLON_COLON] = ACTIONS(2282),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2282),
    [anon_sym___declspec] = ACTIONS(2280),
    [anon_sym___based] = ACTIONS(2280),
    [anon_sym___cdecl] = ACTIONS(2280),
    [anon_sym___clrcall] = ACTIONS(2280),
    [anon_sym___stdcall] = ACTIONS(2280),
    [anon_sym___fastcall] = ACTIONS(2280),
    [anon_sym___thiscall] = ACTIONS(2280),
    [anon_sym___vectorcall] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_RBRACE] = ACTIONS(2282),
    [anon_sym_signed] = ACTIONS(2280),
    [anon_sym_unsigned] = ACTIONS(2280),
    [anon_sym_long] = ACTIONS(2280),
    [anon_sym_short] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_register] = ACTIONS(2280),
    [anon_sym_inline] = ACTIONS(2280),
    [anon_sym___inline] = ACTIONS(2280),
    [anon_sym___inline__] = ACTIONS(2280),
    [anon_sym___forceinline] = ACTIONS(2280),
    [anon_sym_thread_local] = ACTIONS(2280),
    [anon_sym___thread] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_constexpr] = ACTIONS(2280),
    [anon_sym_volatile] = ACTIONS(2280),
    [anon_sym_restrict] = ACTIONS(2280),
    [anon_sym___restrict__] = ACTIONS(2280),
    [anon_sym__Atomic] = ACTIONS(2280),
    [anon_sym__Noreturn] = ACTIONS(2280),
    [anon_sym_noreturn] = ACTIONS(2280),
    [anon_sym__Nonnull] = ACTIONS(2280),
    [anon_sym_mutable] = ACTIONS(2280),
    [anon_sym_constinit] = ACTIONS(2280),
    [anon_sym_consteval] = ACTIONS(2280),
    [anon_sym_alignas] = ACTIONS(2280),
    [anon_sym__Alignas] = ACTIONS(2280),
    [sym_primitive_type] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_struct] = ACTIONS(2280),
    [anon_sym_union] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_goto] = ACTIONS(2280),
    [anon_sym___try] = ACTIONS(2280),
    [anon_sym___leave] = ACTIONS(2280),
    [anon_sym_not] = ACTIONS(2280),
    [anon_sym_compl] = ACTIONS(2280),
    [anon_sym_DASH_DASH] = ACTIONS(2282),
    [anon_sym_PLUS_PLUS] = ACTIONS(2282),
    [anon_sym_sizeof] = ACTIONS(2280),
    [anon_sym___alignof__] = ACTIONS(2280),
    [anon_sym___alignof] = ACTIONS(2280),
    [anon_sym__alignof] = ACTIONS(2280),
    [anon_sym_alignof] = ACTIONS(2280),
    [anon_sym__Alignof] = ACTIONS(2280),
    [anon_sym_offsetof] = ACTIONS(2280),
    [anon_sym__Generic] = ACTIONS(2280),
    [anon_sym_asm] = ACTIONS(2280),
    [anon_sym___asm__] = ACTIONS(2280),
    [anon_sym___asm] = ACTIONS(2280),
    [anon_sym_DOT] = ACTIONS(2280),
    [sym_number_literal] = ACTIONS(2282),
    [anon_sym_L_SQUOTE] = ACTIONS(2282),
    [anon_sym_u_SQUOTE] = ACTIONS(2282),
    [anon_sym_U_SQUOTE] = ACTIONS(2282),
    [anon_sym_u8_SQUOTE] = ACTIONS(2282),
    [anon_sym_SQUOTE] = ACTIONS(2282),
    [anon_sym_L_DQUOTE] = ACTIONS(2282),
    [anon_sym_u_DQUOTE] = ACTIONS(2282),
    [anon_sym_U_DQUOTE] = ACTIONS(2282),
    [anon_sym_u8_DQUOTE] = ACTIONS(2282),
    [anon_sym_DQUOTE] = ACTIONS(2282),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [anon_sym_NULL] = ACTIONS(2280),
    [anon_sym_nullptr] = ACTIONS(2280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_This] = ACTIONS(2280),
    [anon_sym_decltype] = ACTIONS(2280),
    [anon_sym_final] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_explicit] = ACTIONS(2280),
    [anon_sym_typename] = ACTIONS(2280),
    [anon_sym_template] = ACTIONS(2280),
    [anon_sym_operator] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_static_assert] = ACTIONS(2280),
    [anon_sym_concept] = ACTIONS(2280),
    [anon_sym_co_return] = ACTIONS(2280),
    [anon_sym_co_yield] = ACTIONS(2280),
    [anon_sym_R_DQUOTE] = ACTIONS(2282),
    [anon_sym_LR_DQUOTE] = ACTIONS(2282),
    [anon_sym_uR_DQUOTE] = ACTIONS(2282),
    [anon_sym_UR_DQUOTE] = ACTIONS(2282),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2282),
    [anon_sym_co_await] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_requires] = ACTIONS(2280),
    [sym_this] = ACTIONS(2280),
    [anon_sym_discard] = ACTIONS(2280),
    [anon_sym_precise] = ACTIONS(2280),
    [anon_sym_shared] = ACTIONS(2280),
    [anon_sym_groupshared] = ACTIONS(2280),
    [anon_sym_uniform] = ACTIONS(2280),
    [anon_sym_row_major] = ACTIONS(2280),
    [anon_sym_column_major] = ACTIONS(2280),
    [anon_sym_globallycoherent] = ACTIONS(2280),
    [anon_sym_centroid] = ACTIONS(2280),
    [anon_sym_noperspective] = ACTIONS(2280),
    [anon_sym_nointerpolation] = ACTIONS(2280),
    [anon_sym_sample] = ACTIONS(2280),
    [anon_sym_linear] = ACTIONS(2280),
    [anon_sym_snorm] = ACTIONS(2280),
    [anon_sym_unorm] = ACTIONS(2280),
    [anon_sym_point] = ACTIONS(2280),
    [anon_sym_line] = ACTIONS(2280),
    [anon_sym_triangleadj] = ACTIONS(2280),
    [anon_sym_lineadj] = ACTIONS(2280),
    [anon_sym_triangle] = ACTIONS(2280),
    [anon_sym_cbuffer] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_extension] = ACTIONS(2280),
  },
  [431] = {
    [sym_identifier] = ACTIONS(2284),
    [aux_sym_preproc_include_token1] = ACTIONS(2284),
    [aux_sym_preproc_def_token1] = ACTIONS(2284),
    [aux_sym_preproc_if_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2284),
    [sym_preproc_directive] = ACTIONS(2284),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_COLON] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_typedef] = ACTIONS(2284),
    [anon_sym_in] = ACTIONS(2284),
    [anon_sym_out] = ACTIONS(2284),
    [anon_sym_inout] = ACTIONS(2284),
    [anon_sym_virtual] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_using] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym___cdecl] = ACTIONS(2284),
    [anon_sym___clrcall] = ACTIONS(2284),
    [anon_sym___stdcall] = ACTIONS(2284),
    [anon_sym___fastcall] = ACTIONS(2284),
    [anon_sym___thiscall] = ACTIONS(2284),
    [anon_sym___vectorcall] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_signed] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_else] = ACTIONS(2284),
    [anon_sym_switch] = ACTIONS(2284),
    [anon_sym_case] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_goto] = ACTIONS(2284),
    [anon_sym___try] = ACTIONS(2284),
    [anon_sym___leave] = ACTIONS(2284),
    [anon_sym_not] = ACTIONS(2284),
    [anon_sym_compl] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_sizeof] = ACTIONS(2284),
    [anon_sym___alignof__] = ACTIONS(2284),
    [anon_sym___alignof] = ACTIONS(2284),
    [anon_sym__alignof] = ACTIONS(2284),
    [anon_sym_alignof] = ACTIONS(2284),
    [anon_sym__Alignof] = ACTIONS(2284),
    [anon_sym_offsetof] = ACTIONS(2284),
    [anon_sym__Generic] = ACTIONS(2284),
    [anon_sym_asm] = ACTIONS(2284),
    [anon_sym___asm__] = ACTIONS(2284),
    [anon_sym___asm] = ACTIONS(2284),
    [anon_sym_DOT] = ACTIONS(2284),
    [sym_number_literal] = ACTIONS(2286),
    [anon_sym_L_SQUOTE] = ACTIONS(2286),
    [anon_sym_u_SQUOTE] = ACTIONS(2286),
    [anon_sym_U_SQUOTE] = ACTIONS(2286),
    [anon_sym_u8_SQUOTE] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_L_DQUOTE] = ACTIONS(2286),
    [anon_sym_u_DQUOTE] = ACTIONS(2286),
    [anon_sym_U_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8_DQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [sym_true] = ACTIONS(2284),
    [sym_false] = ACTIONS(2284),
    [anon_sym_NULL] = ACTIONS(2284),
    [anon_sym_nullptr] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_This] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [anon_sym_final] = ACTIONS(2284),
    [anon_sym_override] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_typename] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_delete] = ACTIONS(2284),
    [anon_sym_throw] = ACTIONS(2284),
    [anon_sym_namespace] = ACTIONS(2284),
    [anon_sym_static_assert] = ACTIONS(2284),
    [anon_sym_concept] = ACTIONS(2284),
    [anon_sym_co_return] = ACTIONS(2284),
    [anon_sym_co_yield] = ACTIONS(2284),
    [anon_sym_R_DQUOTE] = ACTIONS(2286),
    [anon_sym_LR_DQUOTE] = ACTIONS(2286),
    [anon_sym_uR_DQUOTE] = ACTIONS(2286),
    [anon_sym_UR_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2286),
    [anon_sym_co_await] = ACTIONS(2284),
    [anon_sym_new] = ACTIONS(2284),
    [anon_sym_requires] = ACTIONS(2284),
    [sym_this] = ACTIONS(2284),
    [anon_sym_discard] = ACTIONS(2284),
    [anon_sym_precise] = ACTIONS(2284),
    [anon_sym_shared] = ACTIONS(2284),
    [anon_sym_groupshared] = ACTIONS(2284),
    [anon_sym_uniform] = ACTIONS(2284),
    [anon_sym_row_major] = ACTIONS(2284),
    [anon_sym_column_major] = ACTIONS(2284),
    [anon_sym_globallycoherent] = ACTIONS(2284),
    [anon_sym_centroid] = ACTIONS(2284),
    [anon_sym_noperspective] = ACTIONS(2284),
    [anon_sym_nointerpolation] = ACTIONS(2284),
    [anon_sym_sample] = ACTIONS(2284),
    [anon_sym_linear] = ACTIONS(2284),
    [anon_sym_snorm] = ACTIONS(2284),
    [anon_sym_unorm] = ACTIONS(2284),
    [anon_sym_point] = ACTIONS(2284),
    [anon_sym_line] = ACTIONS(2284),
    [anon_sym_triangleadj] = ACTIONS(2284),
    [anon_sym_lineadj] = ACTIONS(2284),
    [anon_sym_triangle] = ACTIONS(2284),
    [anon_sym_cbuffer] = ACTIONS(2284),
    [anon_sym_interface] = ACTIONS(2284),
    [anon_sym_extension] = ACTIONS(2284),
  },
  [432] = {
    [sym_identifier] = ACTIONS(2288),
    [aux_sym_preproc_include_token1] = ACTIONS(2288),
    [aux_sym_preproc_def_token1] = ACTIONS(2288),
    [aux_sym_preproc_if_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_COLON] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_out] = ACTIONS(2288),
    [anon_sym_inout] = ACTIONS(2288),
    [anon_sym_virtual] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym___cdecl] = ACTIONS(2288),
    [anon_sym___clrcall] = ACTIONS(2288),
    [anon_sym___stdcall] = ACTIONS(2288),
    [anon_sym___fastcall] = ACTIONS(2288),
    [anon_sym___thiscall] = ACTIONS(2288),
    [anon_sym___vectorcall] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_RBRACE] = ACTIONS(2290),
    [anon_sym_signed] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym___try] = ACTIONS(2288),
    [anon_sym___leave] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2288),
    [anon_sym_compl] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_sizeof] = ACTIONS(2288),
    [anon_sym___alignof__] = ACTIONS(2288),
    [anon_sym___alignof] = ACTIONS(2288),
    [anon_sym__alignof] = ACTIONS(2288),
    [anon_sym_alignof] = ACTIONS(2288),
    [anon_sym__Alignof] = ACTIONS(2288),
    [anon_sym_offsetof] = ACTIONS(2288),
    [anon_sym__Generic] = ACTIONS(2288),
    [anon_sym_asm] = ACTIONS(2288),
    [anon_sym___asm__] = ACTIONS(2288),
    [anon_sym___asm] = ACTIONS(2288),
    [anon_sym_DOT] = ACTIONS(2288),
    [sym_number_literal] = ACTIONS(2290),
    [anon_sym_L_SQUOTE] = ACTIONS(2290),
    [anon_sym_u_SQUOTE] = ACTIONS(2290),
    [anon_sym_U_SQUOTE] = ACTIONS(2290),
    [anon_sym_u8_SQUOTE] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [anon_sym_L_DQUOTE] = ACTIONS(2290),
    [anon_sym_u_DQUOTE] = ACTIONS(2290),
    [anon_sym_U_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8_DQUOTE] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [anon_sym_NULL] = ACTIONS(2288),
    [anon_sym_nullptr] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_This] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [anon_sym_final] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_static_assert] = ACTIONS(2288),
    [anon_sym_concept] = ACTIONS(2288),
    [anon_sym_co_return] = ACTIONS(2288),
    [anon_sym_co_yield] = ACTIONS(2288),
    [anon_sym_R_DQUOTE] = ACTIONS(2290),
    [anon_sym_LR_DQUOTE] = ACTIONS(2290),
    [anon_sym_uR_DQUOTE] = ACTIONS(2290),
    [anon_sym_UR_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2290),
    [anon_sym_co_await] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_requires] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [anon_sym_discard] = ACTIONS(2288),
    [anon_sym_precise] = ACTIONS(2288),
    [anon_sym_shared] = ACTIONS(2288),
    [anon_sym_groupshared] = ACTIONS(2288),
    [anon_sym_uniform] = ACTIONS(2288),
    [anon_sym_row_major] = ACTIONS(2288),
    [anon_sym_column_major] = ACTIONS(2288),
    [anon_sym_globallycoherent] = ACTIONS(2288),
    [anon_sym_centroid] = ACTIONS(2288),
    [anon_sym_noperspective] = ACTIONS(2288),
    [anon_sym_nointerpolation] = ACTIONS(2288),
    [anon_sym_sample] = ACTIONS(2288),
    [anon_sym_linear] = ACTIONS(2288),
    [anon_sym_snorm] = ACTIONS(2288),
    [anon_sym_unorm] = ACTIONS(2288),
    [anon_sym_point] = ACTIONS(2288),
    [anon_sym_line] = ACTIONS(2288),
    [anon_sym_triangleadj] = ACTIONS(2288),
    [anon_sym_lineadj] = ACTIONS(2288),
    [anon_sym_triangle] = ACTIONS(2288),
    [anon_sym_cbuffer] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_extension] = ACTIONS(2288),
  },
  [433] = {
    [sym_identifier] = ACTIONS(2292),
    [aux_sym_preproc_include_token1] = ACTIONS(2292),
    [aux_sym_preproc_def_token1] = ACTIONS(2292),
    [aux_sym_preproc_if_token1] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2292),
    [sym_preproc_directive] = ACTIONS(2292),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_COLON] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym_typedef] = ACTIONS(2292),
    [anon_sym_in] = ACTIONS(2292),
    [anon_sym_out] = ACTIONS(2292),
    [anon_sym_inout] = ACTIONS(2292),
    [anon_sym_virtual] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym___attribute] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2294),
    [anon_sym___declspec] = ACTIONS(2292),
    [anon_sym___based] = ACTIONS(2292),
    [anon_sym___cdecl] = ACTIONS(2292),
    [anon_sym___clrcall] = ACTIONS(2292),
    [anon_sym___stdcall] = ACTIONS(2292),
    [anon_sym___fastcall] = ACTIONS(2292),
    [anon_sym___thiscall] = ACTIONS(2292),
    [anon_sym___vectorcall] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_signed] = ACTIONS(2292),
    [anon_sym_unsigned] = ACTIONS(2292),
    [anon_sym_long] = ACTIONS(2292),
    [anon_sym_short] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym___inline] = ACTIONS(2292),
    [anon_sym___inline__] = ACTIONS(2292),
    [anon_sym___forceinline] = ACTIONS(2292),
    [anon_sym_thread_local] = ACTIONS(2292),
    [anon_sym___thread] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym__Nonnull] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [sym_primitive_type] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_struct] = ACTIONS(2292),
    [anon_sym_union] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_else] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_case] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_goto] = ACTIONS(2292),
    [anon_sym___try] = ACTIONS(2292),
    [anon_sym___leave] = ACTIONS(2292),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_compl] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_sizeof] = ACTIONS(2292),
    [anon_sym___alignof__] = ACTIONS(2292),
    [anon_sym___alignof] = ACTIONS(2292),
    [anon_sym__alignof] = ACTIONS(2292),
    [anon_sym_alignof] = ACTIONS(2292),
    [anon_sym__Alignof] = ACTIONS(2292),
    [anon_sym_offsetof] = ACTIONS(2292),
    [anon_sym__Generic] = ACTIONS(2292),
    [anon_sym_asm] = ACTIONS(2292),
    [anon_sym___asm__] = ACTIONS(2292),
    [anon_sym___asm] = ACTIONS(2292),
    [anon_sym_DOT] = ACTIONS(2292),
    [sym_number_literal] = ACTIONS(2294),
    [anon_sym_L_SQUOTE] = ACTIONS(2294),
    [anon_sym_u_SQUOTE] = ACTIONS(2294),
    [anon_sym_U_SQUOTE] = ACTIONS(2294),
    [anon_sym_u8_SQUOTE] = ACTIONS(2294),
    [anon_sym_SQUOTE] = ACTIONS(2294),
    [anon_sym_L_DQUOTE] = ACTIONS(2294),
    [anon_sym_u_DQUOTE] = ACTIONS(2294),
    [anon_sym_U_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8_DQUOTE] = ACTIONS(2294),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [anon_sym_NULL] = ACTIONS(2292),
    [anon_sym_nullptr] = ACTIONS(2292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_This] = ACTIONS(2292),
    [anon_sym_decltype] = ACTIONS(2292),
    [anon_sym_final] = ACTIONS(2292),
    [anon_sym_override] = ACTIONS(2292),
    [anon_sym_explicit] = ACTIONS(2292),
    [anon_sym_typename] = ACTIONS(2292),
    [anon_sym_template] = ACTIONS(2292),
    [anon_sym_operator] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_static_assert] = ACTIONS(2292),
    [anon_sym_concept] = ACTIONS(2292),
    [anon_sym_co_return] = ACTIONS(2292),
    [anon_sym_co_yield] = ACTIONS(2292),
    [anon_sym_R_DQUOTE] = ACTIONS(2294),
    [anon_sym_LR_DQUOTE] = ACTIONS(2294),
    [anon_sym_uR_DQUOTE] = ACTIONS(2294),
    [anon_sym_UR_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2294),
    [anon_sym_co_await] = ACTIONS(2292),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_requires] = ACTIONS(2292),
    [sym_this] = ACTIONS(2292),
    [anon_sym_discard] = ACTIONS(2292),
    [anon_sym_precise] = ACTIONS(2292),
    [anon_sym_shared] = ACTIONS(2292),
    [anon_sym_groupshared] = ACTIONS(2292),
    [anon_sym_uniform] = ACTIONS(2292),
    [anon_sym_row_major] = ACTIONS(2292),
    [anon_sym_column_major] = ACTIONS(2292),
    [anon_sym_globallycoherent] = ACTIONS(2292),
    [anon_sym_centroid] = ACTIONS(2292),
    [anon_sym_noperspective] = ACTIONS(2292),
    [anon_sym_nointerpolation] = ACTIONS(2292),
    [anon_sym_sample] = ACTIONS(2292),
    [anon_sym_linear] = ACTIONS(2292),
    [anon_sym_snorm] = ACTIONS(2292),
    [anon_sym_unorm] = ACTIONS(2292),
    [anon_sym_point] = ACTIONS(2292),
    [anon_sym_line] = ACTIONS(2292),
    [anon_sym_triangleadj] = ACTIONS(2292),
    [anon_sym_lineadj] = ACTIONS(2292),
    [anon_sym_triangle] = ACTIONS(2292),
    [anon_sym_cbuffer] = ACTIONS(2292),
    [anon_sym_interface] = ACTIONS(2292),
    [anon_sym_extension] = ACTIONS(2292),
  },
  [434] = {
    [sym_identifier] = ACTIONS(2296),
    [aux_sym_preproc_include_token1] = ACTIONS(2296),
    [aux_sym_preproc_def_token1] = ACTIONS(2296),
    [aux_sym_preproc_if_token1] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2296),
    [sym_preproc_directive] = ACTIONS(2296),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_BANG] = ACTIONS(2298),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_COLON] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2298),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym_typedef] = ACTIONS(2296),
    [anon_sym_in] = ACTIONS(2296),
    [anon_sym_out] = ACTIONS(2296),
    [anon_sym_inout] = ACTIONS(2296),
    [anon_sym_virtual] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym___attribute] = ACTIONS(2296),
    [anon_sym_using] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2298),
    [anon_sym___declspec] = ACTIONS(2296),
    [anon_sym___based] = ACTIONS(2296),
    [anon_sym___cdecl] = ACTIONS(2296),
    [anon_sym___clrcall] = ACTIONS(2296),
    [anon_sym___stdcall] = ACTIONS(2296),
    [anon_sym___fastcall] = ACTIONS(2296),
    [anon_sym___thiscall] = ACTIONS(2296),
    [anon_sym___vectorcall] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_RBRACE] = ACTIONS(2298),
    [anon_sym_signed] = ACTIONS(2296),
    [anon_sym_unsigned] = ACTIONS(2296),
    [anon_sym_long] = ACTIONS(2296),
    [anon_sym_short] = ACTIONS(2296),
    [anon_sym_LBRACK] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_register] = ACTIONS(2296),
    [anon_sym_inline] = ACTIONS(2296),
    [anon_sym___inline] = ACTIONS(2296),
    [anon_sym___inline__] = ACTIONS(2296),
    [anon_sym___forceinline] = ACTIONS(2296),
    [anon_sym_thread_local] = ACTIONS(2296),
    [anon_sym___thread] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym__Nonnull] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [sym_primitive_type] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2296),
    [anon_sym_class] = ACTIONS(2296),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_union] = ACTIONS(2296),
    [anon_sym_if] = ACTIONS(2296),
    [anon_sym_else] = ACTIONS(2296),
    [anon_sym_switch] = ACTIONS(2296),
    [anon_sym_case] = ACTIONS(2296),
    [anon_sym_default] = ACTIONS(2296),
    [anon_sym_while] = ACTIONS(2296),
    [anon_sym_do] = ACTIONS(2296),
    [anon_sym_for] = ACTIONS(2296),
    [anon_sym_return] = ACTIONS(2296),
    [anon_sym_break] = ACTIONS(2296),
    [anon_sym_continue] = ACTIONS(2296),
    [anon_sym_goto] = ACTIONS(2296),
    [anon_sym___try] = ACTIONS(2296),
    [anon_sym___leave] = ACTIONS(2296),
    [anon_sym_not] = ACTIONS(2296),
    [anon_sym_compl] = ACTIONS(2296),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_sizeof] = ACTIONS(2296),
    [anon_sym___alignof__] = ACTIONS(2296),
    [anon_sym___alignof] = ACTIONS(2296),
    [anon_sym__alignof] = ACTIONS(2296),
    [anon_sym_alignof] = ACTIONS(2296),
    [anon_sym__Alignof] = ACTIONS(2296),
    [anon_sym_offsetof] = ACTIONS(2296),
    [anon_sym__Generic] = ACTIONS(2296),
    [anon_sym_asm] = ACTIONS(2296),
    [anon_sym___asm__] = ACTIONS(2296),
    [anon_sym___asm] = ACTIONS(2296),
    [anon_sym_DOT] = ACTIONS(2296),
    [sym_number_literal] = ACTIONS(2298),
    [anon_sym_L_SQUOTE] = ACTIONS(2298),
    [anon_sym_u_SQUOTE] = ACTIONS(2298),
    [anon_sym_U_SQUOTE] = ACTIONS(2298),
    [anon_sym_u8_SQUOTE] = ACTIONS(2298),
    [anon_sym_SQUOTE] = ACTIONS(2298),
    [anon_sym_L_DQUOTE] = ACTIONS(2298),
    [anon_sym_u_DQUOTE] = ACTIONS(2298),
    [anon_sym_U_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8_DQUOTE] = ACTIONS(2298),
    [anon_sym_DQUOTE] = ACTIONS(2298),
    [sym_true] = ACTIONS(2296),
    [sym_false] = ACTIONS(2296),
    [anon_sym_NULL] = ACTIONS(2296),
    [anon_sym_nullptr] = ACTIONS(2296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_This] = ACTIONS(2296),
    [anon_sym_decltype] = ACTIONS(2296),
    [anon_sym_final] = ACTIONS(2296),
    [anon_sym_override] = ACTIONS(2296),
    [anon_sym_explicit] = ACTIONS(2296),
    [anon_sym_typename] = ACTIONS(2296),
    [anon_sym_template] = ACTIONS(2296),
    [anon_sym_operator] = ACTIONS(2296),
    [anon_sym_try] = ACTIONS(2296),
    [anon_sym_delete] = ACTIONS(2296),
    [anon_sym_throw] = ACTIONS(2296),
    [anon_sym_namespace] = ACTIONS(2296),
    [anon_sym_static_assert] = ACTIONS(2296),
    [anon_sym_concept] = ACTIONS(2296),
    [anon_sym_co_return] = ACTIONS(2296),
    [anon_sym_co_yield] = ACTIONS(2296),
    [anon_sym_R_DQUOTE] = ACTIONS(2298),
    [anon_sym_LR_DQUOTE] = ACTIONS(2298),
    [anon_sym_uR_DQUOTE] = ACTIONS(2298),
    [anon_sym_UR_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2298),
    [anon_sym_co_await] = ACTIONS(2296),
    [anon_sym_new] = ACTIONS(2296),
    [anon_sym_requires] = ACTIONS(2296),
    [sym_this] = ACTIONS(2296),
    [anon_sym_discard] = ACTIONS(2296),
    [anon_sym_precise] = ACTIONS(2296),
    [anon_sym_shared] = ACTIONS(2296),
    [anon_sym_groupshared] = ACTIONS(2296),
    [anon_sym_uniform] = ACTIONS(2296),
    [anon_sym_row_major] = ACTIONS(2296),
    [anon_sym_column_major] = ACTIONS(2296),
    [anon_sym_globallycoherent] = ACTIONS(2296),
    [anon_sym_centroid] = ACTIONS(2296),
    [anon_sym_noperspective] = ACTIONS(2296),
    [anon_sym_nointerpolation] = ACTIONS(2296),
    [anon_sym_sample] = ACTIONS(2296),
    [anon_sym_linear] = ACTIONS(2296),
    [anon_sym_snorm] = ACTIONS(2296),
    [anon_sym_unorm] = ACTIONS(2296),
    [anon_sym_point] = ACTIONS(2296),
    [anon_sym_line] = ACTIONS(2296),
    [anon_sym_triangleadj] = ACTIONS(2296),
    [anon_sym_lineadj] = ACTIONS(2296),
    [anon_sym_triangle] = ACTIONS(2296),
    [anon_sym_cbuffer] = ACTIONS(2296),
    [anon_sym_interface] = ACTIONS(2296),
    [anon_sym_extension] = ACTIONS(2296),
  },
  [435] = {
    [sym_identifier] = ACTIONS(2264),
    [aux_sym_preproc_include_token1] = ACTIONS(2264),
    [aux_sym_preproc_def_token1] = ACTIONS(2264),
    [aux_sym_preproc_if_token1] = ACTIONS(2264),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2264),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2264),
    [sym_preproc_directive] = ACTIONS(2264),
    [anon_sym_LPAREN2] = ACTIONS(2266),
    [anon_sym_BANG] = ACTIONS(2266),
    [anon_sym_TILDE] = ACTIONS(2266),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2266),
    [anon_sym_AMP] = ACTIONS(2264),
    [anon_sym_COLON] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2266),
    [anon_sym___extension__] = ACTIONS(2264),
    [anon_sym_typedef] = ACTIONS(2264),
    [anon_sym_in] = ACTIONS(2264),
    [anon_sym_out] = ACTIONS(2264),
    [anon_sym_inout] = ACTIONS(2264),
    [anon_sym_virtual] = ACTIONS(2264),
    [anon_sym_extern] = ACTIONS(2264),
    [anon_sym___attribute__] = ACTIONS(2264),
    [anon_sym___attribute] = ACTIONS(2264),
    [anon_sym_using] = ACTIONS(2264),
    [anon_sym_COLON_COLON] = ACTIONS(2266),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2266),
    [anon_sym___declspec] = ACTIONS(2264),
    [anon_sym___based] = ACTIONS(2264),
    [anon_sym___cdecl] = ACTIONS(2264),
    [anon_sym___clrcall] = ACTIONS(2264),
    [anon_sym___stdcall] = ACTIONS(2264),
    [anon_sym___fastcall] = ACTIONS(2264),
    [anon_sym___thiscall] = ACTIONS(2264),
    [anon_sym___vectorcall] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_RBRACE] = ACTIONS(2266),
    [anon_sym_signed] = ACTIONS(2264),
    [anon_sym_unsigned] = ACTIONS(2264),
    [anon_sym_long] = ACTIONS(2264),
    [anon_sym_short] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_register] = ACTIONS(2264),
    [anon_sym_inline] = ACTIONS(2264),
    [anon_sym___inline] = ACTIONS(2264),
    [anon_sym___inline__] = ACTIONS(2264),
    [anon_sym___forceinline] = ACTIONS(2264),
    [anon_sym_thread_local] = ACTIONS(2264),
    [anon_sym___thread] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_constexpr] = ACTIONS(2264),
    [anon_sym_volatile] = ACTIONS(2264),
    [anon_sym_restrict] = ACTIONS(2264),
    [anon_sym___restrict__] = ACTIONS(2264),
    [anon_sym__Atomic] = ACTIONS(2264),
    [anon_sym__Noreturn] = ACTIONS(2264),
    [anon_sym_noreturn] = ACTIONS(2264),
    [anon_sym__Nonnull] = ACTIONS(2264),
    [anon_sym_mutable] = ACTIONS(2264),
    [anon_sym_constinit] = ACTIONS(2264),
    [anon_sym_consteval] = ACTIONS(2264),
    [anon_sym_alignas] = ACTIONS(2264),
    [anon_sym__Alignas] = ACTIONS(2264),
    [sym_primitive_type] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
    [anon_sym_class] = ACTIONS(2264),
    [anon_sym_struct] = ACTIONS(2264),
    [anon_sym_union] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_else] = ACTIONS(2264),
    [anon_sym_switch] = ACTIONS(2264),
    [anon_sym_case] = ACTIONS(2264),
    [anon_sym_default] = ACTIONS(2264),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_do] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_goto] = ACTIONS(2264),
    [anon_sym___try] = ACTIONS(2264),
    [anon_sym___leave] = ACTIONS(2264),
    [anon_sym_not] = ACTIONS(2264),
    [anon_sym_compl] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2266),
    [anon_sym_PLUS_PLUS] = ACTIONS(2266),
    [anon_sym_sizeof] = ACTIONS(2264),
    [anon_sym___alignof__] = ACTIONS(2264),
    [anon_sym___alignof] = ACTIONS(2264),
    [anon_sym__alignof] = ACTIONS(2264),
    [anon_sym_alignof] = ACTIONS(2264),
    [anon_sym__Alignof] = ACTIONS(2264),
    [anon_sym_offsetof] = ACTIONS(2264),
    [anon_sym__Generic] = ACTIONS(2264),
    [anon_sym_asm] = ACTIONS(2264),
    [anon_sym___asm__] = ACTIONS(2264),
    [anon_sym___asm] = ACTIONS(2264),
    [anon_sym_DOT] = ACTIONS(2264),
    [sym_number_literal] = ACTIONS(2266),
    [anon_sym_L_SQUOTE] = ACTIONS(2266),
    [anon_sym_u_SQUOTE] = ACTIONS(2266),
    [anon_sym_U_SQUOTE] = ACTIONS(2266),
    [anon_sym_u8_SQUOTE] = ACTIONS(2266),
    [anon_sym_SQUOTE] = ACTIONS(2266),
    [anon_sym_L_DQUOTE] = ACTIONS(2266),
    [anon_sym_u_DQUOTE] = ACTIONS(2266),
    [anon_sym_U_DQUOTE] = ACTIONS(2266),
    [anon_sym_u8_DQUOTE] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(2266),
    [sym_true] = ACTIONS(2264),
    [sym_false] = ACTIONS(2264),
    [anon_sym_NULL] = ACTIONS(2264),
    [anon_sym_nullptr] = ACTIONS(2264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_This] = ACTIONS(2264),
    [anon_sym_decltype] = ACTIONS(2264),
    [anon_sym_final] = ACTIONS(2264),
    [anon_sym_override] = ACTIONS(2264),
    [anon_sym_explicit] = ACTIONS(2264),
    [anon_sym_typename] = ACTIONS(2264),
    [anon_sym_template] = ACTIONS(2264),
    [anon_sym_operator] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [anon_sym_delete] = ACTIONS(2264),
    [anon_sym_throw] = ACTIONS(2264),
    [anon_sym_namespace] = ACTIONS(2264),
    [anon_sym_static_assert] = ACTIONS(2264),
    [anon_sym_concept] = ACTIONS(2264),
    [anon_sym_co_return] = ACTIONS(2264),
    [anon_sym_co_yield] = ACTIONS(2264),
    [anon_sym_R_DQUOTE] = ACTIONS(2266),
    [anon_sym_LR_DQUOTE] = ACTIONS(2266),
    [anon_sym_uR_DQUOTE] = ACTIONS(2266),
    [anon_sym_UR_DQUOTE] = ACTIONS(2266),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2266),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2264),
    [anon_sym_requires] = ACTIONS(2264),
    [sym_this] = ACTIONS(2264),
    [anon_sym_discard] = ACTIONS(2264),
    [anon_sym_precise] = ACTIONS(2264),
    [anon_sym_shared] = ACTIONS(2264),
    [anon_sym_groupshared] = ACTIONS(2264),
    [anon_sym_uniform] = ACTIONS(2264),
    [anon_sym_row_major] = ACTIONS(2264),
    [anon_sym_column_major] = ACTIONS(2264),
    [anon_sym_globallycoherent] = ACTIONS(2264),
    [anon_sym_centroid] = ACTIONS(2264),
    [anon_sym_noperspective] = ACTIONS(2264),
    [anon_sym_nointerpolation] = ACTIONS(2264),
    [anon_sym_sample] = ACTIONS(2264),
    [anon_sym_linear] = ACTIONS(2264),
    [anon_sym_snorm] = ACTIONS(2264),
    [anon_sym_unorm] = ACTIONS(2264),
    [anon_sym_point] = ACTIONS(2264),
    [anon_sym_line] = ACTIONS(2264),
    [anon_sym_triangleadj] = ACTIONS(2264),
    [anon_sym_lineadj] = ACTIONS(2264),
    [anon_sym_triangle] = ACTIONS(2264),
    [anon_sym_cbuffer] = ACTIONS(2264),
    [anon_sym_interface] = ACTIONS(2264),
    [anon_sym_extension] = ACTIONS(2264),
  },
  [436] = {
    [sym_identifier] = ACTIONS(2300),
    [aux_sym_preproc_include_token1] = ACTIONS(2300),
    [aux_sym_preproc_def_token1] = ACTIONS(2300),
    [aux_sym_preproc_if_token1] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2300),
    [sym_preproc_directive] = ACTIONS(2300),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_BANG] = ACTIONS(2302),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_COLON] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym_typedef] = ACTIONS(2300),
    [anon_sym_in] = ACTIONS(2300),
    [anon_sym_out] = ACTIONS(2300),
    [anon_sym_inout] = ACTIONS(2300),
    [anon_sym_virtual] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym___attribute] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2302),
    [anon_sym___declspec] = ACTIONS(2300),
    [anon_sym___based] = ACTIONS(2300),
    [anon_sym___cdecl] = ACTIONS(2300),
    [anon_sym___clrcall] = ACTIONS(2300),
    [anon_sym___stdcall] = ACTIONS(2300),
    [anon_sym___fastcall] = ACTIONS(2300),
    [anon_sym___thiscall] = ACTIONS(2300),
    [anon_sym___vectorcall] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_RBRACE] = ACTIONS(2302),
    [anon_sym_signed] = ACTIONS(2300),
    [anon_sym_unsigned] = ACTIONS(2300),
    [anon_sym_long] = ACTIONS(2300),
    [anon_sym_short] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_register] = ACTIONS(2300),
    [anon_sym_inline] = ACTIONS(2300),
    [anon_sym___inline] = ACTIONS(2300),
    [anon_sym___inline__] = ACTIONS(2300),
    [anon_sym___forceinline] = ACTIONS(2300),
    [anon_sym_thread_local] = ACTIONS(2300),
    [anon_sym___thread] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym__Nonnull] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [sym_primitive_type] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_struct] = ACTIONS(2300),
    [anon_sym_union] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_else] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_case] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_goto] = ACTIONS(2300),
    [anon_sym___try] = ACTIONS(2300),
    [anon_sym___leave] = ACTIONS(2300),
    [anon_sym_not] = ACTIONS(2300),
    [anon_sym_compl] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_sizeof] = ACTIONS(2300),
    [anon_sym___alignof__] = ACTIONS(2300),
    [anon_sym___alignof] = ACTIONS(2300),
    [anon_sym__alignof] = ACTIONS(2300),
    [anon_sym_alignof] = ACTIONS(2300),
    [anon_sym__Alignof] = ACTIONS(2300),
    [anon_sym_offsetof] = ACTIONS(2300),
    [anon_sym__Generic] = ACTIONS(2300),
    [anon_sym_asm] = ACTIONS(2300),
    [anon_sym___asm__] = ACTIONS(2300),
    [anon_sym___asm] = ACTIONS(2300),
    [anon_sym_DOT] = ACTIONS(2300),
    [sym_number_literal] = ACTIONS(2302),
    [anon_sym_L_SQUOTE] = ACTIONS(2302),
    [anon_sym_u_SQUOTE] = ACTIONS(2302),
    [anon_sym_U_SQUOTE] = ACTIONS(2302),
    [anon_sym_u8_SQUOTE] = ACTIONS(2302),
    [anon_sym_SQUOTE] = ACTIONS(2302),
    [anon_sym_L_DQUOTE] = ACTIONS(2302),
    [anon_sym_u_DQUOTE] = ACTIONS(2302),
    [anon_sym_U_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8_DQUOTE] = ACTIONS(2302),
    [anon_sym_DQUOTE] = ACTIONS(2302),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [anon_sym_NULL] = ACTIONS(2300),
    [anon_sym_nullptr] = ACTIONS(2300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_This] = ACTIONS(2300),
    [anon_sym_decltype] = ACTIONS(2300),
    [anon_sym_final] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_explicit] = ACTIONS(2300),
    [anon_sym_typename] = ACTIONS(2300),
    [anon_sym_template] = ACTIONS(2300),
    [anon_sym_operator] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_static_assert] = ACTIONS(2300),
    [anon_sym_concept] = ACTIONS(2300),
    [anon_sym_co_return] = ACTIONS(2300),
    [anon_sym_co_yield] = ACTIONS(2300),
    [anon_sym_R_DQUOTE] = ACTIONS(2302),
    [anon_sym_LR_DQUOTE] = ACTIONS(2302),
    [anon_sym_uR_DQUOTE] = ACTIONS(2302),
    [anon_sym_UR_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2302),
    [anon_sym_co_await] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_requires] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [anon_sym_discard] = ACTIONS(2300),
    [anon_sym_precise] = ACTIONS(2300),
    [anon_sym_shared] = ACTIONS(2300),
    [anon_sym_groupshared] = ACTIONS(2300),
    [anon_sym_uniform] = ACTIONS(2300),
    [anon_sym_row_major] = ACTIONS(2300),
    [anon_sym_column_major] = ACTIONS(2300),
    [anon_sym_globallycoherent] = ACTIONS(2300),
    [anon_sym_centroid] = ACTIONS(2300),
    [anon_sym_noperspective] = ACTIONS(2300),
    [anon_sym_nointerpolation] = ACTIONS(2300),
    [anon_sym_sample] = ACTIONS(2300),
    [anon_sym_linear] = ACTIONS(2300),
    [anon_sym_snorm] = ACTIONS(2300),
    [anon_sym_unorm] = ACTIONS(2300),
    [anon_sym_point] = ACTIONS(2300),
    [anon_sym_line] = ACTIONS(2300),
    [anon_sym_triangleadj] = ACTIONS(2300),
    [anon_sym_lineadj] = ACTIONS(2300),
    [anon_sym_triangle] = ACTIONS(2300),
    [anon_sym_cbuffer] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_extension] = ACTIONS(2300),
  },
  [437] = {
    [sym_identifier] = ACTIONS(2260),
    [aux_sym_preproc_include_token1] = ACTIONS(2260),
    [aux_sym_preproc_def_token1] = ACTIONS(2260),
    [aux_sym_preproc_if_token1] = ACTIONS(2260),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2260),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2260),
    [sym_preproc_directive] = ACTIONS(2260),
    [anon_sym_LPAREN2] = ACTIONS(2262),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2262),
    [anon_sym_AMP_AMP] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_COLON] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym___extension__] = ACTIONS(2260),
    [anon_sym_typedef] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(2260),
    [anon_sym_out] = ACTIONS(2260),
    [anon_sym_inout] = ACTIONS(2260),
    [anon_sym_virtual] = ACTIONS(2260),
    [anon_sym_extern] = ACTIONS(2260),
    [anon_sym___attribute__] = ACTIONS(2260),
    [anon_sym___attribute] = ACTIONS(2260),
    [anon_sym_using] = ACTIONS(2260),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2262),
    [anon_sym___declspec] = ACTIONS(2260),
    [anon_sym___based] = ACTIONS(2260),
    [anon_sym___cdecl] = ACTIONS(2260),
    [anon_sym___clrcall] = ACTIONS(2260),
    [anon_sym___stdcall] = ACTIONS(2260),
    [anon_sym___fastcall] = ACTIONS(2260),
    [anon_sym___thiscall] = ACTIONS(2260),
    [anon_sym___vectorcall] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_RBRACE] = ACTIONS(2262),
    [anon_sym_signed] = ACTIONS(2260),
    [anon_sym_unsigned] = ACTIONS(2260),
    [anon_sym_long] = ACTIONS(2260),
    [anon_sym_short] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_register] = ACTIONS(2260),
    [anon_sym_inline] = ACTIONS(2260),
    [anon_sym___inline] = ACTIONS(2260),
    [anon_sym___inline__] = ACTIONS(2260),
    [anon_sym___forceinline] = ACTIONS(2260),
    [anon_sym_thread_local] = ACTIONS(2260),
    [anon_sym___thread] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_constexpr] = ACTIONS(2260),
    [anon_sym_volatile] = ACTIONS(2260),
    [anon_sym_restrict] = ACTIONS(2260),
    [anon_sym___restrict__] = ACTIONS(2260),
    [anon_sym__Atomic] = ACTIONS(2260),
    [anon_sym__Noreturn] = ACTIONS(2260),
    [anon_sym_noreturn] = ACTIONS(2260),
    [anon_sym__Nonnull] = ACTIONS(2260),
    [anon_sym_mutable] = ACTIONS(2260),
    [anon_sym_constinit] = ACTIONS(2260),
    [anon_sym_consteval] = ACTIONS(2260),
    [anon_sym_alignas] = ACTIONS(2260),
    [anon_sym__Alignas] = ACTIONS(2260),
    [sym_primitive_type] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
    [anon_sym_class] = ACTIONS(2260),
    [anon_sym_struct] = ACTIONS(2260),
    [anon_sym_union] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_else] = ACTIONS(2260),
    [anon_sym_switch] = ACTIONS(2260),
    [anon_sym_case] = ACTIONS(2260),
    [anon_sym_default] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_do] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_goto] = ACTIONS(2260),
    [anon_sym___try] = ACTIONS(2260),
    [anon_sym___leave] = ACTIONS(2260),
    [anon_sym_not] = ACTIONS(2260),
    [anon_sym_compl] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_sizeof] = ACTIONS(2260),
    [anon_sym___alignof__] = ACTIONS(2260),
    [anon_sym___alignof] = ACTIONS(2260),
    [anon_sym__alignof] = ACTIONS(2260),
    [anon_sym_alignof] = ACTIONS(2260),
    [anon_sym__Alignof] = ACTIONS(2260),
    [anon_sym_offsetof] = ACTIONS(2260),
    [anon_sym__Generic] = ACTIONS(2260),
    [anon_sym_asm] = ACTIONS(2260),
    [anon_sym___asm__] = ACTIONS(2260),
    [anon_sym___asm] = ACTIONS(2260),
    [anon_sym_DOT] = ACTIONS(2260),
    [sym_number_literal] = ACTIONS(2262),
    [anon_sym_L_SQUOTE] = ACTIONS(2262),
    [anon_sym_u_SQUOTE] = ACTIONS(2262),
    [anon_sym_U_SQUOTE] = ACTIONS(2262),
    [anon_sym_u8_SQUOTE] = ACTIONS(2262),
    [anon_sym_SQUOTE] = ACTIONS(2262),
    [anon_sym_L_DQUOTE] = ACTIONS(2262),
    [anon_sym_u_DQUOTE] = ACTIONS(2262),
    [anon_sym_U_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8_DQUOTE] = ACTIONS(2262),
    [anon_sym_DQUOTE] = ACTIONS(2262),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [anon_sym_NULL] = ACTIONS(2260),
    [anon_sym_nullptr] = ACTIONS(2260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_This] = ACTIONS(2260),
    [anon_sym_decltype] = ACTIONS(2260),
    [anon_sym_final] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
    [anon_sym_explicit] = ACTIONS(2260),
    [anon_sym_typename] = ACTIONS(2260),
    [anon_sym_template] = ACTIONS(2260),
    [anon_sym_operator] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_throw] = ACTIONS(2260),
    [anon_sym_namespace] = ACTIONS(2260),
    [anon_sym_static_assert] = ACTIONS(2260),
    [anon_sym_concept] = ACTIONS(2260),
    [anon_sym_co_return] = ACTIONS(2260),
    [anon_sym_co_yield] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2260),
    [anon_sym_new] = ACTIONS(2260),
    [anon_sym_requires] = ACTIONS(2260),
    [sym_this] = ACTIONS(2260),
    [anon_sym_discard] = ACTIONS(2260),
    [anon_sym_precise] = ACTIONS(2260),
    [anon_sym_shared] = ACTIONS(2260),
    [anon_sym_groupshared] = ACTIONS(2260),
    [anon_sym_uniform] = ACTIONS(2260),
    [anon_sym_row_major] = ACTIONS(2260),
    [anon_sym_column_major] = ACTIONS(2260),
    [anon_sym_globallycoherent] = ACTIONS(2260),
    [anon_sym_centroid] = ACTIONS(2260),
    [anon_sym_noperspective] = ACTIONS(2260),
    [anon_sym_nointerpolation] = ACTIONS(2260),
    [anon_sym_sample] = ACTIONS(2260),
    [anon_sym_linear] = ACTIONS(2260),
    [anon_sym_snorm] = ACTIONS(2260),
    [anon_sym_unorm] = ACTIONS(2260),
    [anon_sym_point] = ACTIONS(2260),
    [anon_sym_line] = ACTIONS(2260),
    [anon_sym_triangleadj] = ACTIONS(2260),
    [anon_sym_lineadj] = ACTIONS(2260),
    [anon_sym_triangle] = ACTIONS(2260),
    [anon_sym_cbuffer] = ACTIONS(2260),
    [anon_sym_interface] = ACTIONS(2260),
    [anon_sym_extension] = ACTIONS(2260),
  },
  [438] = {
    [sym_identifier] = ACTIONS(2304),
    [aux_sym_preproc_include_token1] = ACTIONS(2304),
    [aux_sym_preproc_def_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2304),
    [sym_preproc_directive] = ACTIONS(2304),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_BANG] = ACTIONS(2306),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_COLON] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2306),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym_typedef] = ACTIONS(2304),
    [anon_sym_in] = ACTIONS(2304),
    [anon_sym_out] = ACTIONS(2304),
    [anon_sym_inout] = ACTIONS(2304),
    [anon_sym_virtual] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym___attribute] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2306),
    [anon_sym___declspec] = ACTIONS(2304),
    [anon_sym___based] = ACTIONS(2304),
    [anon_sym___cdecl] = ACTIONS(2304),
    [anon_sym___clrcall] = ACTIONS(2304),
    [anon_sym___stdcall] = ACTIONS(2304),
    [anon_sym___fastcall] = ACTIONS(2304),
    [anon_sym___thiscall] = ACTIONS(2304),
    [anon_sym___vectorcall] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_signed] = ACTIONS(2304),
    [anon_sym_unsigned] = ACTIONS(2304),
    [anon_sym_long] = ACTIONS(2304),
    [anon_sym_short] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_register] = ACTIONS(2304),
    [anon_sym_inline] = ACTIONS(2304),
    [anon_sym___inline] = ACTIONS(2304),
    [anon_sym___inline__] = ACTIONS(2304),
    [anon_sym___forceinline] = ACTIONS(2304),
    [anon_sym_thread_local] = ACTIONS(2304),
    [anon_sym___thread] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym__Nonnull] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [sym_primitive_type] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_struct] = ACTIONS(2304),
    [anon_sym_union] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_else] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_case] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_goto] = ACTIONS(2304),
    [anon_sym___try] = ACTIONS(2304),
    [anon_sym___leave] = ACTIONS(2304),
    [anon_sym_not] = ACTIONS(2304),
    [anon_sym_compl] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_sizeof] = ACTIONS(2304),
    [anon_sym___alignof__] = ACTIONS(2304),
    [anon_sym___alignof] = ACTIONS(2304),
    [anon_sym__alignof] = ACTIONS(2304),
    [anon_sym_alignof] = ACTIONS(2304),
    [anon_sym__Alignof] = ACTIONS(2304),
    [anon_sym_offsetof] = ACTIONS(2304),
    [anon_sym__Generic] = ACTIONS(2304),
    [anon_sym_asm] = ACTIONS(2304),
    [anon_sym___asm__] = ACTIONS(2304),
    [anon_sym___asm] = ACTIONS(2304),
    [anon_sym_DOT] = ACTIONS(2304),
    [sym_number_literal] = ACTIONS(2306),
    [anon_sym_L_SQUOTE] = ACTIONS(2306),
    [anon_sym_u_SQUOTE] = ACTIONS(2306),
    [anon_sym_U_SQUOTE] = ACTIONS(2306),
    [anon_sym_u8_SQUOTE] = ACTIONS(2306),
    [anon_sym_SQUOTE] = ACTIONS(2306),
    [anon_sym_L_DQUOTE] = ACTIONS(2306),
    [anon_sym_u_DQUOTE] = ACTIONS(2306),
    [anon_sym_U_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8_DQUOTE] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [anon_sym_NULL] = ACTIONS(2304),
    [anon_sym_nullptr] = ACTIONS(2304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_This] = ACTIONS(2304),
    [anon_sym_decltype] = ACTIONS(2304),
    [anon_sym_final] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_explicit] = ACTIONS(2304),
    [anon_sym_typename] = ACTIONS(2304),
    [anon_sym_template] = ACTIONS(2304),
    [anon_sym_operator] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_static_assert] = ACTIONS(2304),
    [anon_sym_concept] = ACTIONS(2304),
    [anon_sym_co_return] = ACTIONS(2304),
    [anon_sym_co_yield] = ACTIONS(2304),
    [anon_sym_R_DQUOTE] = ACTIONS(2306),
    [anon_sym_LR_DQUOTE] = ACTIONS(2306),
    [anon_sym_uR_DQUOTE] = ACTIONS(2306),
    [anon_sym_UR_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2306),
    [anon_sym_co_await] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_requires] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [anon_sym_discard] = ACTIONS(2304),
    [anon_sym_precise] = ACTIONS(2304),
    [anon_sym_shared] = ACTIONS(2304),
    [anon_sym_groupshared] = ACTIONS(2304),
    [anon_sym_uniform] = ACTIONS(2304),
    [anon_sym_row_major] = ACTIONS(2304),
    [anon_sym_column_major] = ACTIONS(2304),
    [anon_sym_globallycoherent] = ACTIONS(2304),
    [anon_sym_centroid] = ACTIONS(2304),
    [anon_sym_noperspective] = ACTIONS(2304),
    [anon_sym_nointerpolation] = ACTIONS(2304),
    [anon_sym_sample] = ACTIONS(2304),
    [anon_sym_linear] = ACTIONS(2304),
    [anon_sym_snorm] = ACTIONS(2304),
    [anon_sym_unorm] = ACTIONS(2304),
    [anon_sym_point] = ACTIONS(2304),
    [anon_sym_line] = ACTIONS(2304),
    [anon_sym_triangleadj] = ACTIONS(2304),
    [anon_sym_lineadj] = ACTIONS(2304),
    [anon_sym_triangle] = ACTIONS(2304),
    [anon_sym_cbuffer] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_extension] = ACTIONS(2304),
  },
  [439] = {
    [sym_identifier] = ACTIONS(2308),
    [aux_sym_preproc_include_token1] = ACTIONS(2308),
    [aux_sym_preproc_def_token1] = ACTIONS(2308),
    [aux_sym_preproc_if_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2308),
    [sym_preproc_directive] = ACTIONS(2308),
    [anon_sym_LPAREN2] = ACTIONS(2310),
    [anon_sym_BANG] = ACTIONS(2310),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_COLON] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(2308),
    [anon_sym_typedef] = ACTIONS(2308),
    [anon_sym_in] = ACTIONS(2308),
    [anon_sym_out] = ACTIONS(2308),
    [anon_sym_inout] = ACTIONS(2308),
    [anon_sym_virtual] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2308),
    [anon_sym___attribute__] = ACTIONS(2308),
    [anon_sym___attribute] = ACTIONS(2308),
    [anon_sym_using] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2310),
    [anon_sym___declspec] = ACTIONS(2308),
    [anon_sym___based] = ACTIONS(2308),
    [anon_sym___cdecl] = ACTIONS(2308),
    [anon_sym___clrcall] = ACTIONS(2308),
    [anon_sym___stdcall] = ACTIONS(2308),
    [anon_sym___fastcall] = ACTIONS(2308),
    [anon_sym___thiscall] = ACTIONS(2308),
    [anon_sym___vectorcall] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_RBRACE] = ACTIONS(2310),
    [anon_sym_signed] = ACTIONS(2308),
    [anon_sym_unsigned] = ACTIONS(2308),
    [anon_sym_long] = ACTIONS(2308),
    [anon_sym_short] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_register] = ACTIONS(2308),
    [anon_sym_inline] = ACTIONS(2308),
    [anon_sym___inline] = ACTIONS(2308),
    [anon_sym___inline__] = ACTIONS(2308),
    [anon_sym___forceinline] = ACTIONS(2308),
    [anon_sym_thread_local] = ACTIONS(2308),
    [anon_sym___thread] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_constexpr] = ACTIONS(2308),
    [anon_sym_volatile] = ACTIONS(2308),
    [anon_sym_restrict] = ACTIONS(2308),
    [anon_sym___restrict__] = ACTIONS(2308),
    [anon_sym__Atomic] = ACTIONS(2308),
    [anon_sym__Noreturn] = ACTIONS(2308),
    [anon_sym_noreturn] = ACTIONS(2308),
    [anon_sym__Nonnull] = ACTIONS(2308),
    [anon_sym_mutable] = ACTIONS(2308),
    [anon_sym_constinit] = ACTIONS(2308),
    [anon_sym_consteval] = ACTIONS(2308),
    [anon_sym_alignas] = ACTIONS(2308),
    [anon_sym__Alignas] = ACTIONS(2308),
    [sym_primitive_type] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_struct] = ACTIONS(2308),
    [anon_sym_union] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_else] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_case] = ACTIONS(2308),
    [anon_sym_default] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_goto] = ACTIONS(2308),
    [anon_sym___try] = ACTIONS(2308),
    [anon_sym___leave] = ACTIONS(2308),
    [anon_sym_not] = ACTIONS(2308),
    [anon_sym_compl] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_sizeof] = ACTIONS(2308),
    [anon_sym___alignof__] = ACTIONS(2308),
    [anon_sym___alignof] = ACTIONS(2308),
    [anon_sym__alignof] = ACTIONS(2308),
    [anon_sym_alignof] = ACTIONS(2308),
    [anon_sym__Alignof] = ACTIONS(2308),
    [anon_sym_offsetof] = ACTIONS(2308),
    [anon_sym__Generic] = ACTIONS(2308),
    [anon_sym_asm] = ACTIONS(2308),
    [anon_sym___asm__] = ACTIONS(2308),
    [anon_sym___asm] = ACTIONS(2308),
    [anon_sym_DOT] = ACTIONS(2308),
    [sym_number_literal] = ACTIONS(2310),
    [anon_sym_L_SQUOTE] = ACTIONS(2310),
    [anon_sym_u_SQUOTE] = ACTIONS(2310),
    [anon_sym_U_SQUOTE] = ACTIONS(2310),
    [anon_sym_u8_SQUOTE] = ACTIONS(2310),
    [anon_sym_SQUOTE] = ACTIONS(2310),
    [anon_sym_L_DQUOTE] = ACTIONS(2310),
    [anon_sym_u_DQUOTE] = ACTIONS(2310),
    [anon_sym_U_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8_DQUOTE] = ACTIONS(2310),
    [anon_sym_DQUOTE] = ACTIONS(2310),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [anon_sym_NULL] = ACTIONS(2308),
    [anon_sym_nullptr] = ACTIONS(2308),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_This] = ACTIONS(2308),
    [anon_sym_decltype] = ACTIONS(2308),
    [anon_sym_final] = ACTIONS(2308),
    [anon_sym_override] = ACTIONS(2308),
    [anon_sym_explicit] = ACTIONS(2308),
    [anon_sym_typename] = ACTIONS(2308),
    [anon_sym_template] = ACTIONS(2308),
    [anon_sym_operator] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_delete] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_namespace] = ACTIONS(2308),
    [anon_sym_static_assert] = ACTIONS(2308),
    [anon_sym_concept] = ACTIONS(2308),
    [anon_sym_co_return] = ACTIONS(2308),
    [anon_sym_co_yield] = ACTIONS(2308),
    [anon_sym_R_DQUOTE] = ACTIONS(2310),
    [anon_sym_LR_DQUOTE] = ACTIONS(2310),
    [anon_sym_uR_DQUOTE] = ACTIONS(2310),
    [anon_sym_UR_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2310),
    [anon_sym_co_await] = ACTIONS(2308),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_requires] = ACTIONS(2308),
    [sym_this] = ACTIONS(2308),
    [anon_sym_discard] = ACTIONS(2308),
    [anon_sym_precise] = ACTIONS(2308),
    [anon_sym_shared] = ACTIONS(2308),
    [anon_sym_groupshared] = ACTIONS(2308),
    [anon_sym_uniform] = ACTIONS(2308),
    [anon_sym_row_major] = ACTIONS(2308),
    [anon_sym_column_major] = ACTIONS(2308),
    [anon_sym_globallycoherent] = ACTIONS(2308),
    [anon_sym_centroid] = ACTIONS(2308),
    [anon_sym_noperspective] = ACTIONS(2308),
    [anon_sym_nointerpolation] = ACTIONS(2308),
    [anon_sym_sample] = ACTIONS(2308),
    [anon_sym_linear] = ACTIONS(2308),
    [anon_sym_snorm] = ACTIONS(2308),
    [anon_sym_unorm] = ACTIONS(2308),
    [anon_sym_point] = ACTIONS(2308),
    [anon_sym_line] = ACTIONS(2308),
    [anon_sym_triangleadj] = ACTIONS(2308),
    [anon_sym_lineadj] = ACTIONS(2308),
    [anon_sym_triangle] = ACTIONS(2308),
    [anon_sym_cbuffer] = ACTIONS(2308),
    [anon_sym_interface] = ACTIONS(2308),
    [anon_sym_extension] = ACTIONS(2308),
  },
  [440] = {
    [sym_identifier] = ACTIONS(2312),
    [aux_sym_preproc_include_token1] = ACTIONS(2312),
    [aux_sym_preproc_def_token1] = ACTIONS(2312),
    [aux_sym_preproc_if_token1] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2312),
    [sym_preproc_directive] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2314),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym___extension__] = ACTIONS(2312),
    [anon_sym_typedef] = ACTIONS(2312),
    [anon_sym_in] = ACTIONS(2312),
    [anon_sym_out] = ACTIONS(2312),
    [anon_sym_inout] = ACTIONS(2312),
    [anon_sym_virtual] = ACTIONS(2312),
    [anon_sym_extern] = ACTIONS(2312),
    [anon_sym___attribute__] = ACTIONS(2312),
    [anon_sym___attribute] = ACTIONS(2312),
    [anon_sym_using] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2314),
    [anon_sym___declspec] = ACTIONS(2312),
    [anon_sym___based] = ACTIONS(2312),
    [anon_sym___cdecl] = ACTIONS(2312),
    [anon_sym___clrcall] = ACTIONS(2312),
    [anon_sym___stdcall] = ACTIONS(2312),
    [anon_sym___fastcall] = ACTIONS(2312),
    [anon_sym___thiscall] = ACTIONS(2312),
    [anon_sym___vectorcall] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_RBRACE] = ACTIONS(2314),
    [anon_sym_signed] = ACTIONS(2312),
    [anon_sym_unsigned] = ACTIONS(2312),
    [anon_sym_long] = ACTIONS(2312),
    [anon_sym_short] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_register] = ACTIONS(2312),
    [anon_sym_inline] = ACTIONS(2312),
    [anon_sym___inline] = ACTIONS(2312),
    [anon_sym___inline__] = ACTIONS(2312),
    [anon_sym___forceinline] = ACTIONS(2312),
    [anon_sym_thread_local] = ACTIONS(2312),
    [anon_sym___thread] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_constexpr] = ACTIONS(2312),
    [anon_sym_volatile] = ACTIONS(2312),
    [anon_sym_restrict] = ACTIONS(2312),
    [anon_sym___restrict__] = ACTIONS(2312),
    [anon_sym__Atomic] = ACTIONS(2312),
    [anon_sym__Noreturn] = ACTIONS(2312),
    [anon_sym_noreturn] = ACTIONS(2312),
    [anon_sym__Nonnull] = ACTIONS(2312),
    [anon_sym_mutable] = ACTIONS(2312),
    [anon_sym_constinit] = ACTIONS(2312),
    [anon_sym_consteval] = ACTIONS(2312),
    [anon_sym_alignas] = ACTIONS(2312),
    [anon_sym__Alignas] = ACTIONS(2312),
    [sym_primitive_type] = ACTIONS(2312),
    [anon_sym_enum] = ACTIONS(2312),
    [anon_sym_class] = ACTIONS(2312),
    [anon_sym_struct] = ACTIONS(2312),
    [anon_sym_union] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_else] = ACTIONS(2312),
    [anon_sym_switch] = ACTIONS(2312),
    [anon_sym_case] = ACTIONS(2312),
    [anon_sym_default] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_break] = ACTIONS(2312),
    [anon_sym_continue] = ACTIONS(2312),
    [anon_sym_goto] = ACTIONS(2312),
    [anon_sym___try] = ACTIONS(2312),
    [anon_sym___leave] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2312),
    [anon_sym_compl] = ACTIONS(2312),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_sizeof] = ACTIONS(2312),
    [anon_sym___alignof__] = ACTIONS(2312),
    [anon_sym___alignof] = ACTIONS(2312),
    [anon_sym__alignof] = ACTIONS(2312),
    [anon_sym_alignof] = ACTIONS(2312),
    [anon_sym__Alignof] = ACTIONS(2312),
    [anon_sym_offsetof] = ACTIONS(2312),
    [anon_sym__Generic] = ACTIONS(2312),
    [anon_sym_asm] = ACTIONS(2312),
    [anon_sym___asm__] = ACTIONS(2312),
    [anon_sym___asm] = ACTIONS(2312),
    [anon_sym_DOT] = ACTIONS(2312),
    [sym_number_literal] = ACTIONS(2314),
    [anon_sym_L_SQUOTE] = ACTIONS(2314),
    [anon_sym_u_SQUOTE] = ACTIONS(2314),
    [anon_sym_U_SQUOTE] = ACTIONS(2314),
    [anon_sym_u8_SQUOTE] = ACTIONS(2314),
    [anon_sym_SQUOTE] = ACTIONS(2314),
    [anon_sym_L_DQUOTE] = ACTIONS(2314),
    [anon_sym_u_DQUOTE] = ACTIONS(2314),
    [anon_sym_U_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE] = ACTIONS(2314),
    [sym_true] = ACTIONS(2312),
    [sym_false] = ACTIONS(2312),
    [anon_sym_NULL] = ACTIONS(2312),
    [anon_sym_nullptr] = ACTIONS(2312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_This] = ACTIONS(2312),
    [anon_sym_decltype] = ACTIONS(2312),
    [anon_sym_final] = ACTIONS(2312),
    [anon_sym_override] = ACTIONS(2312),
    [anon_sym_explicit] = ACTIONS(2312),
    [anon_sym_typename] = ACTIONS(2312),
    [anon_sym_template] = ACTIONS(2312),
    [anon_sym_operator] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_delete] = ACTIONS(2312),
    [anon_sym_throw] = ACTIONS(2312),
    [anon_sym_namespace] = ACTIONS(2312),
    [anon_sym_static_assert] = ACTIONS(2312),
    [anon_sym_concept] = ACTIONS(2312),
    [anon_sym_co_return] = ACTIONS(2312),
    [anon_sym_co_yield] = ACTIONS(2312),
    [anon_sym_R_DQUOTE] = ACTIONS(2314),
    [anon_sym_LR_DQUOTE] = ACTIONS(2314),
    [anon_sym_uR_DQUOTE] = ACTIONS(2314),
    [anon_sym_UR_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2314),
    [anon_sym_co_await] = ACTIONS(2312),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_requires] = ACTIONS(2312),
    [sym_this] = ACTIONS(2312),
    [anon_sym_discard] = ACTIONS(2312),
    [anon_sym_precise] = ACTIONS(2312),
    [anon_sym_shared] = ACTIONS(2312),
    [anon_sym_groupshared] = ACTIONS(2312),
    [anon_sym_uniform] = ACTIONS(2312),
    [anon_sym_row_major] = ACTIONS(2312),
    [anon_sym_column_major] = ACTIONS(2312),
    [anon_sym_globallycoherent] = ACTIONS(2312),
    [anon_sym_centroid] = ACTIONS(2312),
    [anon_sym_noperspective] = ACTIONS(2312),
    [anon_sym_nointerpolation] = ACTIONS(2312),
    [anon_sym_sample] = ACTIONS(2312),
    [anon_sym_linear] = ACTIONS(2312),
    [anon_sym_snorm] = ACTIONS(2312),
    [anon_sym_unorm] = ACTIONS(2312),
    [anon_sym_point] = ACTIONS(2312),
    [anon_sym_line] = ACTIONS(2312),
    [anon_sym_triangleadj] = ACTIONS(2312),
    [anon_sym_lineadj] = ACTIONS(2312),
    [anon_sym_triangle] = ACTIONS(2312),
    [anon_sym_cbuffer] = ACTIONS(2312),
    [anon_sym_interface] = ACTIONS(2312),
    [anon_sym_extension] = ACTIONS(2312),
  },
  [441] = {
    [sym_identifier] = ACTIONS(3448),
    [aux_sym_preproc_include_token1] = ACTIONS(3448),
    [aux_sym_preproc_def_token1] = ACTIONS(3448),
    [aux_sym_preproc_if_token1] = ACTIONS(3448),
    [aux_sym_preproc_if_token2] = ACTIONS(3448),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3448),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3448),
    [aux_sym_preproc_else_token1] = ACTIONS(3448),
    [aux_sym_preproc_elif_token1] = ACTIONS(3448),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3448),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3448),
    [sym_preproc_directive] = ACTIONS(3448),
    [anon_sym_LPAREN2] = ACTIONS(3446),
    [anon_sym_BANG] = ACTIONS(3446),
    [anon_sym_TILDE] = ACTIONS(3446),
    [anon_sym_DASH] = ACTIONS(3448),
    [anon_sym_PLUS] = ACTIONS(3448),
    [anon_sym_STAR] = ACTIONS(3446),
    [anon_sym_AMP_AMP] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3448),
    [anon_sym_SEMI] = ACTIONS(3446),
    [anon_sym___extension__] = ACTIONS(3448),
    [anon_sym_typedef] = ACTIONS(3448),
    [anon_sym_in] = ACTIONS(3448),
    [anon_sym_out] = ACTIONS(3448),
    [anon_sym_inout] = ACTIONS(3448),
    [anon_sym_virtual] = ACTIONS(3448),
    [anon_sym_extern] = ACTIONS(3448),
    [anon_sym___attribute__] = ACTIONS(3448),
    [anon_sym___attribute] = ACTIONS(3448),
    [anon_sym_using] = ACTIONS(3448),
    [anon_sym_COLON_COLON] = ACTIONS(3446),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3446),
    [anon_sym___declspec] = ACTIONS(3448),
    [anon_sym___based] = ACTIONS(3448),
    [anon_sym___cdecl] = ACTIONS(3448),
    [anon_sym___clrcall] = ACTIONS(3448),
    [anon_sym___stdcall] = ACTIONS(3448),
    [anon_sym___fastcall] = ACTIONS(3448),
    [anon_sym___thiscall] = ACTIONS(3448),
    [anon_sym___vectorcall] = ACTIONS(3448),
    [anon_sym_LBRACE] = ACTIONS(3446),
    [anon_sym_signed] = ACTIONS(3448),
    [anon_sym_unsigned] = ACTIONS(3448),
    [anon_sym_long] = ACTIONS(3448),
    [anon_sym_short] = ACTIONS(3448),
    [anon_sym_LBRACK] = ACTIONS(3448),
    [anon_sym_static] = ACTIONS(3448),
    [anon_sym_register] = ACTIONS(3448),
    [anon_sym_inline] = ACTIONS(3448),
    [anon_sym___inline] = ACTIONS(3448),
    [anon_sym___inline__] = ACTIONS(3448),
    [anon_sym___forceinline] = ACTIONS(3448),
    [anon_sym_thread_local] = ACTIONS(3448),
    [anon_sym___thread] = ACTIONS(3448),
    [anon_sym_const] = ACTIONS(3448),
    [anon_sym_constexpr] = ACTIONS(3448),
    [anon_sym_volatile] = ACTIONS(3448),
    [anon_sym_restrict] = ACTIONS(3448),
    [anon_sym___restrict__] = ACTIONS(3448),
    [anon_sym__Atomic] = ACTIONS(3448),
    [anon_sym__Noreturn] = ACTIONS(3448),
    [anon_sym_noreturn] = ACTIONS(3448),
    [anon_sym__Nonnull] = ACTIONS(3448),
    [anon_sym_mutable] = ACTIONS(3448),
    [anon_sym_constinit] = ACTIONS(3448),
    [anon_sym_consteval] = ACTIONS(3448),
    [anon_sym_alignas] = ACTIONS(3448),
    [anon_sym__Alignas] = ACTIONS(3448),
    [sym_primitive_type] = ACTIONS(3448),
    [anon_sym_enum] = ACTIONS(3448),
    [anon_sym_class] = ACTIONS(3448),
    [anon_sym_struct] = ACTIONS(3448),
    [anon_sym_union] = ACTIONS(3448),
    [anon_sym_if] = ACTIONS(3448),
    [anon_sym_else] = ACTIONS(3448),
    [anon_sym_switch] = ACTIONS(3448),
    [anon_sym_case] = ACTIONS(3448),
    [anon_sym_default] = ACTIONS(3448),
    [anon_sym_while] = ACTIONS(3448),
    [anon_sym_do] = ACTIONS(3448),
    [anon_sym_for] = ACTIONS(3448),
    [anon_sym_return] = ACTIONS(3448),
    [anon_sym_break] = ACTIONS(3448),
    [anon_sym_continue] = ACTIONS(3448),
    [anon_sym_goto] = ACTIONS(3448),
    [anon_sym___try] = ACTIONS(3448),
    [anon_sym___leave] = ACTIONS(3448),
    [anon_sym_not] = ACTIONS(3448),
    [anon_sym_compl] = ACTIONS(3448),
    [anon_sym_DASH_DASH] = ACTIONS(3446),
    [anon_sym_PLUS_PLUS] = ACTIONS(3446),
    [anon_sym_sizeof] = ACTIONS(3448),
    [anon_sym___alignof__] = ACTIONS(3448),
    [anon_sym___alignof] = ACTIONS(3448),
    [anon_sym__alignof] = ACTIONS(3448),
    [anon_sym_alignof] = ACTIONS(3448),
    [anon_sym__Alignof] = ACTIONS(3448),
    [anon_sym_offsetof] = ACTIONS(3448),
    [anon_sym__Generic] = ACTIONS(3448),
    [anon_sym_asm] = ACTIONS(3448),
    [anon_sym___asm__] = ACTIONS(3448),
    [anon_sym___asm] = ACTIONS(3448),
    [sym_number_literal] = ACTIONS(3446),
    [anon_sym_L_SQUOTE] = ACTIONS(3446),
    [anon_sym_u_SQUOTE] = ACTIONS(3446),
    [anon_sym_U_SQUOTE] = ACTIONS(3446),
    [anon_sym_u8_SQUOTE] = ACTIONS(3446),
    [anon_sym_SQUOTE] = ACTIONS(3446),
    [anon_sym_L_DQUOTE] = ACTIONS(3446),
    [anon_sym_u_DQUOTE] = ACTIONS(3446),
    [anon_sym_U_DQUOTE] = ACTIONS(3446),
    [anon_sym_u8_DQUOTE] = ACTIONS(3446),
    [anon_sym_DQUOTE] = ACTIONS(3446),
    [sym_true] = ACTIONS(3448),
    [sym_false] = ACTIONS(3448),
    [anon_sym_NULL] = ACTIONS(3448),
    [anon_sym_nullptr] = ACTIONS(3448),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3448),
    [anon_sym_let] = ACTIONS(3448),
    [anon_sym_This] = ACTIONS(3448),
    [anon_sym_decltype] = ACTIONS(3448),
    [anon_sym_explicit] = ACTIONS(3448),
    [anon_sym_typename] = ACTIONS(3448),
    [anon_sym_template] = ACTIONS(3448),
    [anon_sym_operator] = ACTIONS(3448),
    [anon_sym_try] = ACTIONS(3448),
    [anon_sym_delete] = ACTIONS(3448),
    [anon_sym_throw] = ACTIONS(3448),
    [anon_sym_namespace] = ACTIONS(3448),
    [anon_sym_static_assert] = ACTIONS(3448),
    [anon_sym_concept] = ACTIONS(3448),
    [anon_sym_co_return] = ACTIONS(3448),
    [anon_sym_co_yield] = ACTIONS(3448),
    [anon_sym_R_DQUOTE] = ACTIONS(3446),
    [anon_sym_LR_DQUOTE] = ACTIONS(3446),
    [anon_sym_uR_DQUOTE] = ACTIONS(3446),
    [anon_sym_UR_DQUOTE] = ACTIONS(3446),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3446),
    [anon_sym_co_await] = ACTIONS(3448),
    [anon_sym_new] = ACTIONS(3448),
    [anon_sym_requires] = ACTIONS(3448),
    [sym_this] = ACTIONS(3448),
    [anon_sym_discard] = ACTIONS(3448),
    [anon_sym_precise] = ACTIONS(3448),
    [anon_sym_shared] = ACTIONS(3448),
    [anon_sym_groupshared] = ACTIONS(3448),
    [anon_sym_uniform] = ACTIONS(3448),
    [anon_sym_row_major] = ACTIONS(3448),
    [anon_sym_column_major] = ACTIONS(3448),
    [anon_sym_globallycoherent] = ACTIONS(3448),
    [anon_sym_centroid] = ACTIONS(3448),
    [anon_sym_noperspective] = ACTIONS(3448),
    [anon_sym_nointerpolation] = ACTIONS(3448),
    [anon_sym_sample] = ACTIONS(3448),
    [anon_sym_linear] = ACTIONS(3448),
    [anon_sym_snorm] = ACTIONS(3448),
    [anon_sym_unorm] = ACTIONS(3448),
    [anon_sym_point] = ACTIONS(3448),
    [anon_sym_line] = ACTIONS(3448),
    [anon_sym_triangleadj] = ACTIONS(3448),
    [anon_sym_lineadj] = ACTIONS(3448),
    [anon_sym_triangle] = ACTIONS(3448),
    [anon_sym_cbuffer] = ACTIONS(3448),
    [anon_sym_interface] = ACTIONS(3448),
    [anon_sym_extension] = ACTIONS(3448),
  },
  [442] = {
    [sym_identifier] = ACTIONS(3452),
    [aux_sym_preproc_include_token1] = ACTIONS(3452),
    [aux_sym_preproc_def_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token2] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3452),
    [aux_sym_preproc_else_token1] = ACTIONS(3452),
    [aux_sym_preproc_elif_token1] = ACTIONS(3452),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3452),
    [sym_preproc_directive] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(3450),
    [anon_sym_BANG] = ACTIONS(3450),
    [anon_sym_TILDE] = ACTIONS(3450),
    [anon_sym_DASH] = ACTIONS(3452),
    [anon_sym_PLUS] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_AMP_AMP] = ACTIONS(3450),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym___extension__] = ACTIONS(3452),
    [anon_sym_typedef] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_out] = ACTIONS(3452),
    [anon_sym_inout] = ACTIONS(3452),
    [anon_sym_virtual] = ACTIONS(3452),
    [anon_sym_extern] = ACTIONS(3452),
    [anon_sym___attribute__] = ACTIONS(3452),
    [anon_sym___attribute] = ACTIONS(3452),
    [anon_sym_using] = ACTIONS(3452),
    [anon_sym_COLON_COLON] = ACTIONS(3450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3450),
    [anon_sym___declspec] = ACTIONS(3452),
    [anon_sym___based] = ACTIONS(3452),
    [anon_sym___cdecl] = ACTIONS(3452),
    [anon_sym___clrcall] = ACTIONS(3452),
    [anon_sym___stdcall] = ACTIONS(3452),
    [anon_sym___fastcall] = ACTIONS(3452),
    [anon_sym___thiscall] = ACTIONS(3452),
    [anon_sym___vectorcall] = ACTIONS(3452),
    [anon_sym_LBRACE] = ACTIONS(3450),
    [anon_sym_signed] = ACTIONS(3452),
    [anon_sym_unsigned] = ACTIONS(3452),
    [anon_sym_long] = ACTIONS(3452),
    [anon_sym_short] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3452),
    [anon_sym_static] = ACTIONS(3452),
    [anon_sym_register] = ACTIONS(3452),
    [anon_sym_inline] = ACTIONS(3452),
    [anon_sym___inline] = ACTIONS(3452),
    [anon_sym___inline__] = ACTIONS(3452),
    [anon_sym___forceinline] = ACTIONS(3452),
    [anon_sym_thread_local] = ACTIONS(3452),
    [anon_sym___thread] = ACTIONS(3452),
    [anon_sym_const] = ACTIONS(3452),
    [anon_sym_constexpr] = ACTIONS(3452),
    [anon_sym_volatile] = ACTIONS(3452),
    [anon_sym_restrict] = ACTIONS(3452),
    [anon_sym___restrict__] = ACTIONS(3452),
    [anon_sym__Atomic] = ACTIONS(3452),
    [anon_sym__Noreturn] = ACTIONS(3452),
    [anon_sym_noreturn] = ACTIONS(3452),
    [anon_sym__Nonnull] = ACTIONS(3452),
    [anon_sym_mutable] = ACTIONS(3452),
    [anon_sym_constinit] = ACTIONS(3452),
    [anon_sym_consteval] = ACTIONS(3452),
    [anon_sym_alignas] = ACTIONS(3452),
    [anon_sym__Alignas] = ACTIONS(3452),
    [sym_primitive_type] = ACTIONS(3452),
    [anon_sym_enum] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(3452),
    [anon_sym_union] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_else] = ACTIONS(3452),
    [anon_sym_switch] = ACTIONS(3452),
    [anon_sym_case] = ACTIONS(3452),
    [anon_sym_default] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_do] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3452),
    [anon_sym_return] = ACTIONS(3452),
    [anon_sym_break] = ACTIONS(3452),
    [anon_sym_continue] = ACTIONS(3452),
    [anon_sym_goto] = ACTIONS(3452),
    [anon_sym___try] = ACTIONS(3452),
    [anon_sym___leave] = ACTIONS(3452),
    [anon_sym_not] = ACTIONS(3452),
    [anon_sym_compl] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3450),
    [anon_sym_PLUS_PLUS] = ACTIONS(3450),
    [anon_sym_sizeof] = ACTIONS(3452),
    [anon_sym___alignof__] = ACTIONS(3452),
    [anon_sym___alignof] = ACTIONS(3452),
    [anon_sym__alignof] = ACTIONS(3452),
    [anon_sym_alignof] = ACTIONS(3452),
    [anon_sym__Alignof] = ACTIONS(3452),
    [anon_sym_offsetof] = ACTIONS(3452),
    [anon_sym__Generic] = ACTIONS(3452),
    [anon_sym_asm] = ACTIONS(3452),
    [anon_sym___asm__] = ACTIONS(3452),
    [anon_sym___asm] = ACTIONS(3452),
    [sym_number_literal] = ACTIONS(3450),
    [anon_sym_L_SQUOTE] = ACTIONS(3450),
    [anon_sym_u_SQUOTE] = ACTIONS(3450),
    [anon_sym_U_SQUOTE] = ACTIONS(3450),
    [anon_sym_u8_SQUOTE] = ACTIONS(3450),
    [anon_sym_SQUOTE] = ACTIONS(3450),
    [anon_sym_L_DQUOTE] = ACTIONS(3450),
    [anon_sym_u_DQUOTE] = ACTIONS(3450),
    [anon_sym_U_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8_DQUOTE] = ACTIONS(3450),
    [anon_sym_DQUOTE] = ACTIONS(3450),
    [sym_true] = ACTIONS(3452),
    [sym_false] = ACTIONS(3452),
    [anon_sym_NULL] = ACTIONS(3452),
    [anon_sym_nullptr] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3452),
    [anon_sym_let] = ACTIONS(3452),
    [anon_sym_This] = ACTIONS(3452),
    [anon_sym_decltype] = ACTIONS(3452),
    [anon_sym_explicit] = ACTIONS(3452),
    [anon_sym_typename] = ACTIONS(3452),
    [anon_sym_template] = ACTIONS(3452),
    [anon_sym_operator] = ACTIONS(3452),
    [anon_sym_try] = ACTIONS(3452),
    [anon_sym_delete] = ACTIONS(3452),
    [anon_sym_throw] = ACTIONS(3452),
    [anon_sym_namespace] = ACTIONS(3452),
    [anon_sym_static_assert] = ACTIONS(3452),
    [anon_sym_concept] = ACTIONS(3452),
    [anon_sym_co_return] = ACTIONS(3452),
    [anon_sym_co_yield] = ACTIONS(3452),
    [anon_sym_R_DQUOTE] = ACTIONS(3450),
    [anon_sym_LR_DQUOTE] = ACTIONS(3450),
    [anon_sym_uR_DQUOTE] = ACTIONS(3450),
    [anon_sym_UR_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3450),
    [anon_sym_co_await] = ACTIONS(3452),
    [anon_sym_new] = ACTIONS(3452),
    [anon_sym_requires] = ACTIONS(3452),
    [sym_this] = ACTIONS(3452),
    [anon_sym_discard] = ACTIONS(3452),
    [anon_sym_precise] = ACTIONS(3452),
    [anon_sym_shared] = ACTIONS(3452),
    [anon_sym_groupshared] = ACTIONS(3452),
    [anon_sym_uniform] = ACTIONS(3452),
    [anon_sym_row_major] = ACTIONS(3452),
    [anon_sym_column_major] = ACTIONS(3452),
    [anon_sym_globallycoherent] = ACTIONS(3452),
    [anon_sym_centroid] = ACTIONS(3452),
    [anon_sym_noperspective] = ACTIONS(3452),
    [anon_sym_nointerpolation] = ACTIONS(3452),
    [anon_sym_sample] = ACTIONS(3452),
    [anon_sym_linear] = ACTIONS(3452),
    [anon_sym_snorm] = ACTIONS(3452),
    [anon_sym_unorm] = ACTIONS(3452),
    [anon_sym_point] = ACTIONS(3452),
    [anon_sym_line] = ACTIONS(3452),
    [anon_sym_triangleadj] = ACTIONS(3452),
    [anon_sym_lineadj] = ACTIONS(3452),
    [anon_sym_triangle] = ACTIONS(3452),
    [anon_sym_cbuffer] = ACTIONS(3452),
    [anon_sym_interface] = ACTIONS(3452),
    [anon_sym_extension] = ACTIONS(3452),
  },
  [443] = {
    [ts_builtin_sym_end] = ACTIONS(3556),
    [sym_identifier] = ACTIONS(3558),
    [aux_sym_preproc_include_token1] = ACTIONS(3558),
    [aux_sym_preproc_def_token1] = ACTIONS(3558),
    [aux_sym_preproc_if_token1] = ACTIONS(3558),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3558),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3558),
    [sym_preproc_directive] = ACTIONS(3558),
    [anon_sym_LPAREN2] = ACTIONS(3556),
    [anon_sym_BANG] = ACTIONS(3556),
    [anon_sym_TILDE] = ACTIONS(3556),
    [anon_sym_DASH] = ACTIONS(3558),
    [anon_sym_PLUS] = ACTIONS(3558),
    [anon_sym_STAR] = ACTIONS(3556),
    [anon_sym_AMP_AMP] = ACTIONS(3556),
    [anon_sym_AMP] = ACTIONS(3558),
    [anon_sym_SEMI] = ACTIONS(3556),
    [anon_sym___extension__] = ACTIONS(3558),
    [anon_sym_typedef] = ACTIONS(3558),
    [anon_sym_in] = ACTIONS(3558),
    [anon_sym_out] = ACTIONS(3558),
    [anon_sym_inout] = ACTIONS(3558),
    [anon_sym_virtual] = ACTIONS(3558),
    [anon_sym_extern] = ACTIONS(3558),
    [anon_sym___attribute__] = ACTIONS(3558),
    [anon_sym___attribute] = ACTIONS(3558),
    [anon_sym_using] = ACTIONS(3558),
    [anon_sym_COLON_COLON] = ACTIONS(3556),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3556),
    [anon_sym___declspec] = ACTIONS(3558),
    [anon_sym___based] = ACTIONS(3558),
    [anon_sym___cdecl] = ACTIONS(3558),
    [anon_sym___clrcall] = ACTIONS(3558),
    [anon_sym___stdcall] = ACTIONS(3558),
    [anon_sym___fastcall] = ACTIONS(3558),
    [anon_sym___thiscall] = ACTIONS(3558),
    [anon_sym___vectorcall] = ACTIONS(3558),
    [anon_sym_LBRACE] = ACTIONS(3556),
    [anon_sym_signed] = ACTIONS(3558),
    [anon_sym_unsigned] = ACTIONS(3558),
    [anon_sym_long] = ACTIONS(3558),
    [anon_sym_short] = ACTIONS(3558),
    [anon_sym_LBRACK] = ACTIONS(3558),
    [anon_sym_static] = ACTIONS(3558),
    [anon_sym_register] = ACTIONS(3558),
    [anon_sym_inline] = ACTIONS(3558),
    [anon_sym___inline] = ACTIONS(3558),
    [anon_sym___inline__] = ACTIONS(3558),
    [anon_sym___forceinline] = ACTIONS(3558),
    [anon_sym_thread_local] = ACTIONS(3558),
    [anon_sym___thread] = ACTIONS(3558),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_constexpr] = ACTIONS(3558),
    [anon_sym_volatile] = ACTIONS(3558),
    [anon_sym_restrict] = ACTIONS(3558),
    [anon_sym___restrict__] = ACTIONS(3558),
    [anon_sym__Atomic] = ACTIONS(3558),
    [anon_sym__Noreturn] = ACTIONS(3558),
    [anon_sym_noreturn] = ACTIONS(3558),
    [anon_sym__Nonnull] = ACTIONS(3558),
    [anon_sym_mutable] = ACTIONS(3558),
    [anon_sym_constinit] = ACTIONS(3558),
    [anon_sym_consteval] = ACTIONS(3558),
    [anon_sym_alignas] = ACTIONS(3558),
    [anon_sym__Alignas] = ACTIONS(3558),
    [sym_primitive_type] = ACTIONS(3558),
    [anon_sym_enum] = ACTIONS(3558),
    [anon_sym_class] = ACTIONS(3558),
    [anon_sym_struct] = ACTIONS(3558),
    [anon_sym_union] = ACTIONS(3558),
    [anon_sym_if] = ACTIONS(3558),
    [anon_sym_else] = ACTIONS(3558),
    [anon_sym_switch] = ACTIONS(3558),
    [anon_sym_case] = ACTIONS(3558),
    [anon_sym_default] = ACTIONS(3558),
    [anon_sym_while] = ACTIONS(3558),
    [anon_sym_do] = ACTIONS(3558),
    [anon_sym_for] = ACTIONS(3558),
    [anon_sym_return] = ACTIONS(3558),
    [anon_sym_break] = ACTIONS(3558),
    [anon_sym_continue] = ACTIONS(3558),
    [anon_sym_goto] = ACTIONS(3558),
    [anon_sym___try] = ACTIONS(3558),
    [anon_sym___leave] = ACTIONS(3558),
    [anon_sym_not] = ACTIONS(3558),
    [anon_sym_compl] = ACTIONS(3558),
    [anon_sym_DASH_DASH] = ACTIONS(3556),
    [anon_sym_PLUS_PLUS] = ACTIONS(3556),
    [anon_sym_sizeof] = ACTIONS(3558),
    [anon_sym___alignof__] = ACTIONS(3558),
    [anon_sym___alignof] = ACTIONS(3558),
    [anon_sym__alignof] = ACTIONS(3558),
    [anon_sym_alignof] = ACTIONS(3558),
    [anon_sym__Alignof] = ACTIONS(3558),
    [anon_sym_offsetof] = ACTIONS(3558),
    [anon_sym__Generic] = ACTIONS(3558),
    [anon_sym_asm] = ACTIONS(3558),
    [anon_sym___asm__] = ACTIONS(3558),
    [anon_sym___asm] = ACTIONS(3558),
    [sym_number_literal] = ACTIONS(3556),
    [anon_sym_L_SQUOTE] = ACTIONS(3556),
    [anon_sym_u_SQUOTE] = ACTIONS(3556),
    [anon_sym_U_SQUOTE] = ACTIONS(3556),
    [anon_sym_u8_SQUOTE] = ACTIONS(3556),
    [anon_sym_SQUOTE] = ACTIONS(3556),
    [anon_sym_L_DQUOTE] = ACTIONS(3556),
    [anon_sym_u_DQUOTE] = ACTIONS(3556),
    [anon_sym_U_DQUOTE] = ACTIONS(3556),
    [anon_sym_u8_DQUOTE] = ACTIONS(3556),
    [anon_sym_DQUOTE] = ACTIONS(3556),
    [sym_true] = ACTIONS(3558),
    [sym_false] = ACTIONS(3558),
    [anon_sym_NULL] = ACTIONS(3558),
    [anon_sym_nullptr] = ACTIONS(3558),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3558),
    [anon_sym_let] = ACTIONS(3558),
    [anon_sym_This] = ACTIONS(3558),
    [anon_sym_decltype] = ACTIONS(3558),
    [anon_sym_explicit] = ACTIONS(3558),
    [anon_sym_typename] = ACTIONS(3558),
    [anon_sym_export] = ACTIONS(3558),
    [anon_sym_module] = ACTIONS(3558),
    [anon_sym_import] = ACTIONS(3558),
    [anon_sym_template] = ACTIONS(3558),
    [anon_sym_operator] = ACTIONS(3558),
    [anon_sym_try] = ACTIONS(3558),
    [anon_sym_delete] = ACTIONS(3558),
    [anon_sym_throw] = ACTIONS(3558),
    [anon_sym_namespace] = ACTIONS(3558),
    [anon_sym_static_assert] = ACTIONS(3558),
    [anon_sym_concept] = ACTIONS(3558),
    [anon_sym_co_return] = ACTIONS(3558),
    [anon_sym_co_yield] = ACTIONS(3558),
    [anon_sym_R_DQUOTE] = ACTIONS(3556),
    [anon_sym_LR_DQUOTE] = ACTIONS(3556),
    [anon_sym_uR_DQUOTE] = ACTIONS(3556),
    [anon_sym_UR_DQUOTE] = ACTIONS(3556),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3556),
    [anon_sym_co_await] = ACTIONS(3558),
    [anon_sym_new] = ACTIONS(3558),
    [anon_sym_requires] = ACTIONS(3558),
    [sym_this] = ACTIONS(3558),
    [anon_sym_discard] = ACTIONS(3558),
    [anon_sym_precise] = ACTIONS(3558),
    [anon_sym_shared] = ACTIONS(3558),
    [anon_sym_groupshared] = ACTIONS(3558),
    [anon_sym_uniform] = ACTIONS(3558),
    [anon_sym_row_major] = ACTIONS(3558),
    [anon_sym_column_major] = ACTIONS(3558),
    [anon_sym_globallycoherent] = ACTIONS(3558),
    [anon_sym_centroid] = ACTIONS(3558),
    [anon_sym_noperspective] = ACTIONS(3558),
    [anon_sym_nointerpolation] = ACTIONS(3558),
    [anon_sym_sample] = ACTIONS(3558),
    [anon_sym_linear] = ACTIONS(3558),
    [anon_sym_snorm] = ACTIONS(3558),
    [anon_sym_unorm] = ACTIONS(3558),
    [anon_sym_point] = ACTIONS(3558),
    [anon_sym_line] = ACTIONS(3558),
    [anon_sym_triangleadj] = ACTIONS(3558),
    [anon_sym_lineadj] = ACTIONS(3558),
    [anon_sym_triangle] = ACTIONS(3558),
    [anon_sym_cbuffer] = ACTIONS(3558),
    [anon_sym_interface] = ACTIONS(3558),
    [anon_sym_extension] = ACTIONS(3558),
    [anon_sym___exported] = ACTIONS(3558),
  },
  [444] = {
    [sym_identifier] = ACTIONS(3452),
    [aux_sym_preproc_include_token1] = ACTIONS(3452),
    [aux_sym_preproc_def_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token2] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3452),
    [aux_sym_preproc_else_token1] = ACTIONS(3452),
    [aux_sym_preproc_elif_token1] = ACTIONS(3452),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3452),
    [sym_preproc_directive] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(3450),
    [anon_sym_BANG] = ACTIONS(3450),
    [anon_sym_TILDE] = ACTIONS(3450),
    [anon_sym_DASH] = ACTIONS(3452),
    [anon_sym_PLUS] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_AMP_AMP] = ACTIONS(3450),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym___extension__] = ACTIONS(3452),
    [anon_sym_typedef] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_out] = ACTIONS(3452),
    [anon_sym_inout] = ACTIONS(3452),
    [anon_sym_virtual] = ACTIONS(3452),
    [anon_sym_extern] = ACTIONS(3452),
    [anon_sym___attribute__] = ACTIONS(3452),
    [anon_sym___attribute] = ACTIONS(3452),
    [anon_sym_using] = ACTIONS(3452),
    [anon_sym_COLON_COLON] = ACTIONS(3450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3450),
    [anon_sym___declspec] = ACTIONS(3452),
    [anon_sym___based] = ACTIONS(3452),
    [anon_sym___cdecl] = ACTIONS(3452),
    [anon_sym___clrcall] = ACTIONS(3452),
    [anon_sym___stdcall] = ACTIONS(3452),
    [anon_sym___fastcall] = ACTIONS(3452),
    [anon_sym___thiscall] = ACTIONS(3452),
    [anon_sym___vectorcall] = ACTIONS(3452),
    [anon_sym_LBRACE] = ACTIONS(3450),
    [anon_sym_signed] = ACTIONS(3452),
    [anon_sym_unsigned] = ACTIONS(3452),
    [anon_sym_long] = ACTIONS(3452),
    [anon_sym_short] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3452),
    [anon_sym_static] = ACTIONS(3452),
    [anon_sym_register] = ACTIONS(3452),
    [anon_sym_inline] = ACTIONS(3452),
    [anon_sym___inline] = ACTIONS(3452),
    [anon_sym___inline__] = ACTIONS(3452),
    [anon_sym___forceinline] = ACTIONS(3452),
    [anon_sym_thread_local] = ACTIONS(3452),
    [anon_sym___thread] = ACTIONS(3452),
    [anon_sym_const] = ACTIONS(3452),
    [anon_sym_constexpr] = ACTIONS(3452),
    [anon_sym_volatile] = ACTIONS(3452),
    [anon_sym_restrict] = ACTIONS(3452),
    [anon_sym___restrict__] = ACTIONS(3452),
    [anon_sym__Atomic] = ACTIONS(3452),
    [anon_sym__Noreturn] = ACTIONS(3452),
    [anon_sym_noreturn] = ACTIONS(3452),
    [anon_sym__Nonnull] = ACTIONS(3452),
    [anon_sym_mutable] = ACTIONS(3452),
    [anon_sym_constinit] = ACTIONS(3452),
    [anon_sym_consteval] = ACTIONS(3452),
    [anon_sym_alignas] = ACTIONS(3452),
    [anon_sym__Alignas] = ACTIONS(3452),
    [sym_primitive_type] = ACTIONS(3452),
    [anon_sym_enum] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(3452),
    [anon_sym_union] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_else] = ACTIONS(3452),
    [anon_sym_switch] = ACTIONS(3452),
    [anon_sym_case] = ACTIONS(3452),
    [anon_sym_default] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_do] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3452),
    [anon_sym_return] = ACTIONS(3452),
    [anon_sym_break] = ACTIONS(3452),
    [anon_sym_continue] = ACTIONS(3452),
    [anon_sym_goto] = ACTIONS(3452),
    [anon_sym___try] = ACTIONS(3452),
    [anon_sym___leave] = ACTIONS(3452),
    [anon_sym_not] = ACTIONS(3452),
    [anon_sym_compl] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3450),
    [anon_sym_PLUS_PLUS] = ACTIONS(3450),
    [anon_sym_sizeof] = ACTIONS(3452),
    [anon_sym___alignof__] = ACTIONS(3452),
    [anon_sym___alignof] = ACTIONS(3452),
    [anon_sym__alignof] = ACTIONS(3452),
    [anon_sym_alignof] = ACTIONS(3452),
    [anon_sym__Alignof] = ACTIONS(3452),
    [anon_sym_offsetof] = ACTIONS(3452),
    [anon_sym__Generic] = ACTIONS(3452),
    [anon_sym_asm] = ACTIONS(3452),
    [anon_sym___asm__] = ACTIONS(3452),
    [anon_sym___asm] = ACTIONS(3452),
    [sym_number_literal] = ACTIONS(3450),
    [anon_sym_L_SQUOTE] = ACTIONS(3450),
    [anon_sym_u_SQUOTE] = ACTIONS(3450),
    [anon_sym_U_SQUOTE] = ACTIONS(3450),
    [anon_sym_u8_SQUOTE] = ACTIONS(3450),
    [anon_sym_SQUOTE] = ACTIONS(3450),
    [anon_sym_L_DQUOTE] = ACTIONS(3450),
    [anon_sym_u_DQUOTE] = ACTIONS(3450),
    [anon_sym_U_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8_DQUOTE] = ACTIONS(3450),
    [anon_sym_DQUOTE] = ACTIONS(3450),
    [sym_true] = ACTIONS(3452),
    [sym_false] = ACTIONS(3452),
    [anon_sym_NULL] = ACTIONS(3452),
    [anon_sym_nullptr] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3452),
    [anon_sym_let] = ACTIONS(3452),
    [anon_sym_This] = ACTIONS(3452),
    [anon_sym_decltype] = ACTIONS(3452),
    [anon_sym_explicit] = ACTIONS(3452),
    [anon_sym_typename] = ACTIONS(3452),
    [anon_sym_template] = ACTIONS(3452),
    [anon_sym_operator] = ACTIONS(3452),
    [anon_sym_try] = ACTIONS(3452),
    [anon_sym_delete] = ACTIONS(3452),
    [anon_sym_throw] = ACTIONS(3452),
    [anon_sym_namespace] = ACTIONS(3452),
    [anon_sym_static_assert] = ACTIONS(3452),
    [anon_sym_concept] = ACTIONS(3452),
    [anon_sym_co_return] = ACTIONS(3452),
    [anon_sym_co_yield] = ACTIONS(3452),
    [anon_sym_R_DQUOTE] = ACTIONS(3450),
    [anon_sym_LR_DQUOTE] = ACTIONS(3450),
    [anon_sym_uR_DQUOTE] = ACTIONS(3450),
    [anon_sym_UR_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3450),
    [anon_sym_co_await] = ACTIONS(3452),
    [anon_sym_new] = ACTIONS(3452),
    [anon_sym_requires] = ACTIONS(3452),
    [sym_this] = ACTIONS(3452),
    [anon_sym_discard] = ACTIONS(3452),
    [anon_sym_precise] = ACTIONS(3452),
    [anon_sym_shared] = ACTIONS(3452),
    [anon_sym_groupshared] = ACTIONS(3452),
    [anon_sym_uniform] = ACTIONS(3452),
    [anon_sym_row_major] = ACTIONS(3452),
    [anon_sym_column_major] = ACTIONS(3452),
    [anon_sym_globallycoherent] = ACTIONS(3452),
    [anon_sym_centroid] = ACTIONS(3452),
    [anon_sym_noperspective] = ACTIONS(3452),
    [anon_sym_nointerpolation] = ACTIONS(3452),
    [anon_sym_sample] = ACTIONS(3452),
    [anon_sym_linear] = ACTIONS(3452),
    [anon_sym_snorm] = ACTIONS(3452),
    [anon_sym_unorm] = ACTIONS(3452),
    [anon_sym_point] = ACTIONS(3452),
    [anon_sym_line] = ACTIONS(3452),
    [anon_sym_triangleadj] = ACTIONS(3452),
    [anon_sym_lineadj] = ACTIONS(3452),
    [anon_sym_triangle] = ACTIONS(3452),
    [anon_sym_cbuffer] = ACTIONS(3452),
    [anon_sym_interface] = ACTIONS(3452),
    [anon_sym_extension] = ACTIONS(3452),
  },
  [445] = {
    [ts_builtin_sym_end] = ACTIONS(3560),
    [sym_identifier] = ACTIONS(3562),
    [aux_sym_preproc_include_token1] = ACTIONS(3562),
    [aux_sym_preproc_def_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3562),
    [sym_preproc_directive] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym___extension__] = ACTIONS(3562),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_in] = ACTIONS(3562),
    [anon_sym_out] = ACTIONS(3562),
    [anon_sym_inout] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym___attribute__] = ACTIONS(3562),
    [anon_sym___attribute] = ACTIONS(3562),
    [anon_sym_using] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3560),
    [anon_sym___declspec] = ACTIONS(3562),
    [anon_sym___based] = ACTIONS(3562),
    [anon_sym___cdecl] = ACTIONS(3562),
    [anon_sym___clrcall] = ACTIONS(3562),
    [anon_sym___stdcall] = ACTIONS(3562),
    [anon_sym___fastcall] = ACTIONS(3562),
    [anon_sym___thiscall] = ACTIONS(3562),
    [anon_sym___vectorcall] = ACTIONS(3562),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_signed] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym___inline] = ACTIONS(3562),
    [anon_sym___inline__] = ACTIONS(3562),
    [anon_sym___forceinline] = ACTIONS(3562),
    [anon_sym_thread_local] = ACTIONS(3562),
    [anon_sym___thread] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_constexpr] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym___restrict__] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym__Noreturn] = ACTIONS(3562),
    [anon_sym_noreturn] = ACTIONS(3562),
    [anon_sym__Nonnull] = ACTIONS(3562),
    [anon_sym_mutable] = ACTIONS(3562),
    [anon_sym_constinit] = ACTIONS(3562),
    [anon_sym_consteval] = ACTIONS(3562),
    [anon_sym_alignas] = ACTIONS(3562),
    [anon_sym__Alignas] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_else] = ACTIONS(3562),
    [anon_sym_switch] = ACTIONS(3562),
    [anon_sym_case] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_goto] = ACTIONS(3562),
    [anon_sym___try] = ACTIONS(3562),
    [anon_sym___leave] = ACTIONS(3562),
    [anon_sym_not] = ACTIONS(3562),
    [anon_sym_compl] = ACTIONS(3562),
    [anon_sym_DASH_DASH] = ACTIONS(3560),
    [anon_sym_PLUS_PLUS] = ACTIONS(3560),
    [anon_sym_sizeof] = ACTIONS(3562),
    [anon_sym___alignof__] = ACTIONS(3562),
    [anon_sym___alignof] = ACTIONS(3562),
    [anon_sym__alignof] = ACTIONS(3562),
    [anon_sym_alignof] = ACTIONS(3562),
    [anon_sym__Alignof] = ACTIONS(3562),
    [anon_sym_offsetof] = ACTIONS(3562),
    [anon_sym__Generic] = ACTIONS(3562),
    [anon_sym_asm] = ACTIONS(3562),
    [anon_sym___asm__] = ACTIONS(3562),
    [anon_sym___asm] = ACTIONS(3562),
    [sym_number_literal] = ACTIONS(3560),
    [anon_sym_L_SQUOTE] = ACTIONS(3560),
    [anon_sym_u_SQUOTE] = ACTIONS(3560),
    [anon_sym_U_SQUOTE] = ACTIONS(3560),
    [anon_sym_u8_SQUOTE] = ACTIONS(3560),
    [anon_sym_SQUOTE] = ACTIONS(3560),
    [anon_sym_L_DQUOTE] = ACTIONS(3560),
    [anon_sym_u_DQUOTE] = ACTIONS(3560),
    [anon_sym_U_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE] = ACTIONS(3560),
    [sym_true] = ACTIONS(3562),
    [sym_false] = ACTIONS(3562),
    [anon_sym_NULL] = ACTIONS(3562),
    [anon_sym_nullptr] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_This] = ACTIONS(3562),
    [anon_sym_decltype] = ACTIONS(3562),
    [anon_sym_explicit] = ACTIONS(3562),
    [anon_sym_typename] = ACTIONS(3562),
    [anon_sym_export] = ACTIONS(3562),
    [anon_sym_module] = ACTIONS(3562),
    [anon_sym_import] = ACTIONS(3562),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_delete] = ACTIONS(3562),
    [anon_sym_throw] = ACTIONS(3562),
    [anon_sym_namespace] = ACTIONS(3562),
    [anon_sym_static_assert] = ACTIONS(3562),
    [anon_sym_concept] = ACTIONS(3562),
    [anon_sym_co_return] = ACTIONS(3562),
    [anon_sym_co_yield] = ACTIONS(3562),
    [anon_sym_R_DQUOTE] = ACTIONS(3560),
    [anon_sym_LR_DQUOTE] = ACTIONS(3560),
    [anon_sym_uR_DQUOTE] = ACTIONS(3560),
    [anon_sym_UR_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3560),
    [anon_sym_co_await] = ACTIONS(3562),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_requires] = ACTIONS(3562),
    [sym_this] = ACTIONS(3562),
    [anon_sym_discard] = ACTIONS(3562),
    [anon_sym_precise] = ACTIONS(3562),
    [anon_sym_shared] = ACTIONS(3562),
    [anon_sym_groupshared] = ACTIONS(3562),
    [anon_sym_uniform] = ACTIONS(3562),
    [anon_sym_row_major] = ACTIONS(3562),
    [anon_sym_column_major] = ACTIONS(3562),
    [anon_sym_globallycoherent] = ACTIONS(3562),
    [anon_sym_centroid] = ACTIONS(3562),
    [anon_sym_noperspective] = ACTIONS(3562),
    [anon_sym_nointerpolation] = ACTIONS(3562),
    [anon_sym_sample] = ACTIONS(3562),
    [anon_sym_linear] = ACTIONS(3562),
    [anon_sym_snorm] = ACTIONS(3562),
    [anon_sym_unorm] = ACTIONS(3562),
    [anon_sym_point] = ACTIONS(3562),
    [anon_sym_line] = ACTIONS(3562),
    [anon_sym_triangleadj] = ACTIONS(3562),
    [anon_sym_lineadj] = ACTIONS(3562),
    [anon_sym_triangle] = ACTIONS(3562),
    [anon_sym_cbuffer] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_extension] = ACTIONS(3562),
    [anon_sym___exported] = ACTIONS(3562),
  },
  [446] = {
    [ts_builtin_sym_end] = ACTIONS(3560),
    [sym_identifier] = ACTIONS(3562),
    [aux_sym_preproc_include_token1] = ACTIONS(3562),
    [aux_sym_preproc_def_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3562),
    [sym_preproc_directive] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym___extension__] = ACTIONS(3562),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_in] = ACTIONS(3562),
    [anon_sym_out] = ACTIONS(3562),
    [anon_sym_inout] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym___attribute__] = ACTIONS(3562),
    [anon_sym___attribute] = ACTIONS(3562),
    [anon_sym_using] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3560),
    [anon_sym___declspec] = ACTIONS(3562),
    [anon_sym___based] = ACTIONS(3562),
    [anon_sym___cdecl] = ACTIONS(3562),
    [anon_sym___clrcall] = ACTIONS(3562),
    [anon_sym___stdcall] = ACTIONS(3562),
    [anon_sym___fastcall] = ACTIONS(3562),
    [anon_sym___thiscall] = ACTIONS(3562),
    [anon_sym___vectorcall] = ACTIONS(3562),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_signed] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym___inline] = ACTIONS(3562),
    [anon_sym___inline__] = ACTIONS(3562),
    [anon_sym___forceinline] = ACTIONS(3562),
    [anon_sym_thread_local] = ACTIONS(3562),
    [anon_sym___thread] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_constexpr] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym___restrict__] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym__Noreturn] = ACTIONS(3562),
    [anon_sym_noreturn] = ACTIONS(3562),
    [anon_sym__Nonnull] = ACTIONS(3562),
    [anon_sym_mutable] = ACTIONS(3562),
    [anon_sym_constinit] = ACTIONS(3562),
    [anon_sym_consteval] = ACTIONS(3562),
    [anon_sym_alignas] = ACTIONS(3562),
    [anon_sym__Alignas] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_else] = ACTIONS(3562),
    [anon_sym_switch] = ACTIONS(3562),
    [anon_sym_case] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_goto] = ACTIONS(3562),
    [anon_sym___try] = ACTIONS(3562),
    [anon_sym___leave] = ACTIONS(3562),
    [anon_sym_not] = ACTIONS(3562),
    [anon_sym_compl] = ACTIONS(3562),
    [anon_sym_DASH_DASH] = ACTIONS(3560),
    [anon_sym_PLUS_PLUS] = ACTIONS(3560),
    [anon_sym_sizeof] = ACTIONS(3562),
    [anon_sym___alignof__] = ACTIONS(3562),
    [anon_sym___alignof] = ACTIONS(3562),
    [anon_sym__alignof] = ACTIONS(3562),
    [anon_sym_alignof] = ACTIONS(3562),
    [anon_sym__Alignof] = ACTIONS(3562),
    [anon_sym_offsetof] = ACTIONS(3562),
    [anon_sym__Generic] = ACTIONS(3562),
    [anon_sym_asm] = ACTIONS(3562),
    [anon_sym___asm__] = ACTIONS(3562),
    [anon_sym___asm] = ACTIONS(3562),
    [sym_number_literal] = ACTIONS(3560),
    [anon_sym_L_SQUOTE] = ACTIONS(3560),
    [anon_sym_u_SQUOTE] = ACTIONS(3560),
    [anon_sym_U_SQUOTE] = ACTIONS(3560),
    [anon_sym_u8_SQUOTE] = ACTIONS(3560),
    [anon_sym_SQUOTE] = ACTIONS(3560),
    [anon_sym_L_DQUOTE] = ACTIONS(3560),
    [anon_sym_u_DQUOTE] = ACTIONS(3560),
    [anon_sym_U_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE] = ACTIONS(3560),
    [sym_true] = ACTIONS(3562),
    [sym_false] = ACTIONS(3562),
    [anon_sym_NULL] = ACTIONS(3562),
    [anon_sym_nullptr] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_This] = ACTIONS(3562),
    [anon_sym_decltype] = ACTIONS(3562),
    [anon_sym_explicit] = ACTIONS(3562),
    [anon_sym_typename] = ACTIONS(3562),
    [anon_sym_export] = ACTIONS(3562),
    [anon_sym_module] = ACTIONS(3562),
    [anon_sym_import] = ACTIONS(3562),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_delete] = ACTIONS(3562),
    [anon_sym_throw] = ACTIONS(3562),
    [anon_sym_namespace] = ACTIONS(3562),
    [anon_sym_static_assert] = ACTIONS(3562),
    [anon_sym_concept] = ACTIONS(3562),
    [anon_sym_co_return] = ACTIONS(3562),
    [anon_sym_co_yield] = ACTIONS(3562),
    [anon_sym_R_DQUOTE] = ACTIONS(3560),
    [anon_sym_LR_DQUOTE] = ACTIONS(3560),
    [anon_sym_uR_DQUOTE] = ACTIONS(3560),
    [anon_sym_UR_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3560),
    [anon_sym_co_await] = ACTIONS(3562),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_requires] = ACTIONS(3562),
    [sym_this] = ACTIONS(3562),
    [anon_sym_discard] = ACTIONS(3562),
    [anon_sym_precise] = ACTIONS(3562),
    [anon_sym_shared] = ACTIONS(3562),
    [anon_sym_groupshared] = ACTIONS(3562),
    [anon_sym_uniform] = ACTIONS(3562),
    [anon_sym_row_major] = ACTIONS(3562),
    [anon_sym_column_major] = ACTIONS(3562),
    [anon_sym_globallycoherent] = ACTIONS(3562),
    [anon_sym_centroid] = ACTIONS(3562),
    [anon_sym_noperspective] = ACTIONS(3562),
    [anon_sym_nointerpolation] = ACTIONS(3562),
    [anon_sym_sample] = ACTIONS(3562),
    [anon_sym_linear] = ACTIONS(3562),
    [anon_sym_snorm] = ACTIONS(3562),
    [anon_sym_unorm] = ACTIONS(3562),
    [anon_sym_point] = ACTIONS(3562),
    [anon_sym_line] = ACTIONS(3562),
    [anon_sym_triangleadj] = ACTIONS(3562),
    [anon_sym_lineadj] = ACTIONS(3562),
    [anon_sym_triangle] = ACTIONS(3562),
    [anon_sym_cbuffer] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_extension] = ACTIONS(3562),
    [anon_sym___exported] = ACTIONS(3562),
  },
  [447] = {
    [ts_builtin_sym_end] = ACTIONS(3560),
    [sym_identifier] = ACTIONS(3562),
    [aux_sym_preproc_include_token1] = ACTIONS(3562),
    [aux_sym_preproc_def_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3562),
    [sym_preproc_directive] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym___extension__] = ACTIONS(3562),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_in] = ACTIONS(3562),
    [anon_sym_out] = ACTIONS(3562),
    [anon_sym_inout] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym___attribute__] = ACTIONS(3562),
    [anon_sym___attribute] = ACTIONS(3562),
    [anon_sym_using] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3560),
    [anon_sym___declspec] = ACTIONS(3562),
    [anon_sym___based] = ACTIONS(3562),
    [anon_sym___cdecl] = ACTIONS(3562),
    [anon_sym___clrcall] = ACTIONS(3562),
    [anon_sym___stdcall] = ACTIONS(3562),
    [anon_sym___fastcall] = ACTIONS(3562),
    [anon_sym___thiscall] = ACTIONS(3562),
    [anon_sym___vectorcall] = ACTIONS(3562),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_signed] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym___inline] = ACTIONS(3562),
    [anon_sym___inline__] = ACTIONS(3562),
    [anon_sym___forceinline] = ACTIONS(3562),
    [anon_sym_thread_local] = ACTIONS(3562),
    [anon_sym___thread] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_constexpr] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym___restrict__] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym__Noreturn] = ACTIONS(3562),
    [anon_sym_noreturn] = ACTIONS(3562),
    [anon_sym__Nonnull] = ACTIONS(3562),
    [anon_sym_mutable] = ACTIONS(3562),
    [anon_sym_constinit] = ACTIONS(3562),
    [anon_sym_consteval] = ACTIONS(3562),
    [anon_sym_alignas] = ACTIONS(3562),
    [anon_sym__Alignas] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_else] = ACTIONS(3562),
    [anon_sym_switch] = ACTIONS(3562),
    [anon_sym_case] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_goto] = ACTIONS(3562),
    [anon_sym___try] = ACTIONS(3562),
    [anon_sym___leave] = ACTIONS(3562),
    [anon_sym_not] = ACTIONS(3562),
    [anon_sym_compl] = ACTIONS(3562),
    [anon_sym_DASH_DASH] = ACTIONS(3560),
    [anon_sym_PLUS_PLUS] = ACTIONS(3560),
    [anon_sym_sizeof] = ACTIONS(3562),
    [anon_sym___alignof__] = ACTIONS(3562),
    [anon_sym___alignof] = ACTIONS(3562),
    [anon_sym__alignof] = ACTIONS(3562),
    [anon_sym_alignof] = ACTIONS(3562),
    [anon_sym__Alignof] = ACTIONS(3562),
    [anon_sym_offsetof] = ACTIONS(3562),
    [anon_sym__Generic] = ACTIONS(3562),
    [anon_sym_asm] = ACTIONS(3562),
    [anon_sym___asm__] = ACTIONS(3562),
    [anon_sym___asm] = ACTIONS(3562),
    [sym_number_literal] = ACTIONS(3560),
    [anon_sym_L_SQUOTE] = ACTIONS(3560),
    [anon_sym_u_SQUOTE] = ACTIONS(3560),
    [anon_sym_U_SQUOTE] = ACTIONS(3560),
    [anon_sym_u8_SQUOTE] = ACTIONS(3560),
    [anon_sym_SQUOTE] = ACTIONS(3560),
    [anon_sym_L_DQUOTE] = ACTIONS(3560),
    [anon_sym_u_DQUOTE] = ACTIONS(3560),
    [anon_sym_U_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE] = ACTIONS(3560),
    [sym_true] = ACTIONS(3562),
    [sym_false] = ACTIONS(3562),
    [anon_sym_NULL] = ACTIONS(3562),
    [anon_sym_nullptr] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_This] = ACTIONS(3562),
    [anon_sym_decltype] = ACTIONS(3562),
    [anon_sym_explicit] = ACTIONS(3562),
    [anon_sym_typename] = ACTIONS(3562),
    [anon_sym_export] = ACTIONS(3562),
    [anon_sym_module] = ACTIONS(3562),
    [anon_sym_import] = ACTIONS(3562),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_delete] = ACTIONS(3562),
    [anon_sym_throw] = ACTIONS(3562),
    [anon_sym_namespace] = ACTIONS(3562),
    [anon_sym_static_assert] = ACTIONS(3562),
    [anon_sym_concept] = ACTIONS(3562),
    [anon_sym_co_return] = ACTIONS(3562),
    [anon_sym_co_yield] = ACTIONS(3562),
    [anon_sym_R_DQUOTE] = ACTIONS(3560),
    [anon_sym_LR_DQUOTE] = ACTIONS(3560),
    [anon_sym_uR_DQUOTE] = ACTIONS(3560),
    [anon_sym_UR_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3560),
    [anon_sym_co_await] = ACTIONS(3562),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_requires] = ACTIONS(3562),
    [sym_this] = ACTIONS(3562),
    [anon_sym_discard] = ACTIONS(3562),
    [anon_sym_precise] = ACTIONS(3562),
    [anon_sym_shared] = ACTIONS(3562),
    [anon_sym_groupshared] = ACTIONS(3562),
    [anon_sym_uniform] = ACTIONS(3562),
    [anon_sym_row_major] = ACTIONS(3562),
    [anon_sym_column_major] = ACTIONS(3562),
    [anon_sym_globallycoherent] = ACTIONS(3562),
    [anon_sym_centroid] = ACTIONS(3562),
    [anon_sym_noperspective] = ACTIONS(3562),
    [anon_sym_nointerpolation] = ACTIONS(3562),
    [anon_sym_sample] = ACTIONS(3562),
    [anon_sym_linear] = ACTIONS(3562),
    [anon_sym_snorm] = ACTIONS(3562),
    [anon_sym_unorm] = ACTIONS(3562),
    [anon_sym_point] = ACTIONS(3562),
    [anon_sym_line] = ACTIONS(3562),
    [anon_sym_triangleadj] = ACTIONS(3562),
    [anon_sym_lineadj] = ACTIONS(3562),
    [anon_sym_triangle] = ACTIONS(3562),
    [anon_sym_cbuffer] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_extension] = ACTIONS(3562),
    [anon_sym___exported] = ACTIONS(3562),
  },
  [448] = {
    [sym_type_qualifier] = STATE(531),
    [sym_alignas_qualifier] = STATE(854),
    [aux_sym__type_definition_type_repeat1] = STATE(531),
    [aux_sym_sized_type_specifier_repeat1] = STATE(703),
    [ts_builtin_sym_end] = ACTIONS(3542),
    [sym_identifier] = ACTIONS(3564),
    [aux_sym_preproc_include_token1] = ACTIONS(3540),
    [aux_sym_preproc_def_token1] = ACTIONS(3540),
    [aux_sym_preproc_if_token1] = ACTIONS(3540),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3540),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3540),
    [sym_preproc_directive] = ACTIONS(3540),
    [anon_sym_LPAREN2] = ACTIONS(3542),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_AMP] = ACTIONS(3540),
    [anon_sym_SEMI] = ACTIONS(3542),
    [anon_sym___extension__] = ACTIONS(3567),
    [anon_sym_typedef] = ACTIONS(3540),
    [anon_sym_in] = ACTIONS(3540),
    [anon_sym_out] = ACTIONS(3540),
    [anon_sym_inout] = ACTIONS(3540),
    [anon_sym_virtual] = ACTIONS(3540),
    [anon_sym_extern] = ACTIONS(3540),
    [anon_sym___attribute__] = ACTIONS(3540),
    [anon_sym___attribute] = ACTIONS(3540),
    [anon_sym_using] = ACTIONS(3540),
    [anon_sym_COLON_COLON] = ACTIONS(3542),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3542),
    [anon_sym___declspec] = ACTIONS(3540),
    [anon_sym___based] = ACTIONS(3540),
    [anon_sym___cdecl] = ACTIONS(3540),
    [anon_sym___clrcall] = ACTIONS(3540),
    [anon_sym___stdcall] = ACTIONS(3540),
    [anon_sym___fastcall] = ACTIONS(3540),
    [anon_sym___thiscall] = ACTIONS(3540),
    [anon_sym___vectorcall] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_signed] = ACTIONS(3570),
    [anon_sym_unsigned] = ACTIONS(3570),
    [anon_sym_long] = ACTIONS(3570),
    [anon_sym_short] = ACTIONS(3570),
    [anon_sym_LBRACK] = ACTIONS(3540),
    [anon_sym_static] = ACTIONS(3540),
    [anon_sym_register] = ACTIONS(3540),
    [anon_sym_inline] = ACTIONS(3540),
    [anon_sym___inline] = ACTIONS(3540),
    [anon_sym___inline__] = ACTIONS(3540),
    [anon_sym___forceinline] = ACTIONS(3540),
    [anon_sym_thread_local] = ACTIONS(3540),
    [anon_sym___thread] = ACTIONS(3540),
    [anon_sym_const] = ACTIONS(3567),
    [anon_sym_constexpr] = ACTIONS(3567),
    [anon_sym_volatile] = ACTIONS(3567),
    [anon_sym_restrict] = ACTIONS(3567),
    [anon_sym___restrict__] = ACTIONS(3567),
    [anon_sym__Atomic] = ACTIONS(3567),
    [anon_sym__Noreturn] = ACTIONS(3567),
    [anon_sym_noreturn] = ACTIONS(3567),
    [anon_sym__Nonnull] = ACTIONS(3567),
    [anon_sym_mutable] = ACTIONS(3567),
    [anon_sym_constinit] = ACTIONS(3567),
    [anon_sym_consteval] = ACTIONS(3567),
    [anon_sym_alignas] = ACTIONS(3573),
    [anon_sym__Alignas] = ACTIONS(3573),
    [sym_primitive_type] = ACTIONS(3576),
    [anon_sym_enum] = ACTIONS(3540),
    [anon_sym_class] = ACTIONS(3540),
    [anon_sym_struct] = ACTIONS(3540),
    [anon_sym_union] = ACTIONS(3540),
    [anon_sym_if] = ACTIONS(3540),
    [anon_sym_switch] = ACTIONS(3540),
    [anon_sym_case] = ACTIONS(3540),
    [anon_sym_default] = ACTIONS(3540),
    [anon_sym_while] = ACTIONS(3540),
    [anon_sym_do] = ACTIONS(3540),
    [anon_sym_for] = ACTIONS(3540),
    [anon_sym_return] = ACTIONS(3540),
    [anon_sym_break] = ACTIONS(3540),
    [anon_sym_continue] = ACTIONS(3540),
    [anon_sym_goto] = ACTIONS(3540),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(3542),
    [anon_sym_PLUS_PLUS] = ACTIONS(3542),
    [anon_sym_sizeof] = ACTIONS(3540),
    [anon_sym___alignof__] = ACTIONS(3540),
    [anon_sym___alignof] = ACTIONS(3540),
    [anon_sym__alignof] = ACTIONS(3540),
    [anon_sym_alignof] = ACTIONS(3540),
    [anon_sym__Alignof] = ACTIONS(3540),
    [anon_sym_offsetof] = ACTIONS(3540),
    [anon_sym__Generic] = ACTIONS(3540),
    [anon_sym_asm] = ACTIONS(3540),
    [anon_sym___asm__] = ACTIONS(3540),
    [anon_sym___asm] = ACTIONS(3540),
    [anon_sym_DOT] = ACTIONS(3540),
    [sym_number_literal] = ACTIONS(3542),
    [anon_sym_L_SQUOTE] = ACTIONS(3542),
    [anon_sym_u_SQUOTE] = ACTIONS(3542),
    [anon_sym_U_SQUOTE] = ACTIONS(3542),
    [anon_sym_u8_SQUOTE] = ACTIONS(3542),
    [anon_sym_SQUOTE] = ACTIONS(3542),
    [anon_sym_L_DQUOTE] = ACTIONS(3542),
    [anon_sym_u_DQUOTE] = ACTIONS(3542),
    [anon_sym_U_DQUOTE] = ACTIONS(3542),
    [anon_sym_u8_DQUOTE] = ACTIONS(3542),
    [anon_sym_DQUOTE] = ACTIONS(3542),
    [sym_true] = ACTIONS(3540),
    [sym_false] = ACTIONS(3540),
    [anon_sym_NULL] = ACTIONS(3540),
    [anon_sym_nullptr] = ACTIONS(3540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3540),
    [anon_sym_let] = ACTIONS(3540),
    [anon_sym_This] = ACTIONS(3540),
    [anon_sym_decltype] = ACTIONS(3540),
    [anon_sym_explicit] = ACTIONS(3540),
    [anon_sym_typename] = ACTIONS(3540),
    [anon_sym_export] = ACTIONS(3540),
    [anon_sym_module] = ACTIONS(3540),
    [anon_sym_import] = ACTIONS(3540),
    [anon_sym_template] = ACTIONS(3540),
    [anon_sym_operator] = ACTIONS(3540),
    [anon_sym_try] = ACTIONS(3540),
    [anon_sym_delete] = ACTIONS(3540),
    [anon_sym_throw] = ACTIONS(3540),
    [anon_sym_namespace] = ACTIONS(3540),
    [anon_sym_static_assert] = ACTIONS(3540),
    [anon_sym_concept] = ACTIONS(3540),
    [anon_sym_co_return] = ACTIONS(3540),
    [anon_sym_co_yield] = ACTIONS(3540),
    [anon_sym_R_DQUOTE] = ACTIONS(3542),
    [anon_sym_LR_DQUOTE] = ACTIONS(3542),
    [anon_sym_uR_DQUOTE] = ACTIONS(3542),
    [anon_sym_UR_DQUOTE] = ACTIONS(3542),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3542),
    [anon_sym_co_await] = ACTIONS(3540),
    [anon_sym_new] = ACTIONS(3540),
    [anon_sym_requires] = ACTIONS(3540),
    [sym_this] = ACTIONS(3540),
    [anon_sym_precise] = ACTIONS(3540),
    [anon_sym_shared] = ACTIONS(3540),
    [anon_sym_groupshared] = ACTIONS(3540),
    [anon_sym_uniform] = ACTIONS(3540),
    [anon_sym_row_major] = ACTIONS(3540),
    [anon_sym_column_major] = ACTIONS(3540),
    [anon_sym_globallycoherent] = ACTIONS(3540),
    [anon_sym_centroid] = ACTIONS(3540),
    [anon_sym_noperspective] = ACTIONS(3540),
    [anon_sym_nointerpolation] = ACTIONS(3540),
    [anon_sym_sample] = ACTIONS(3540),
    [anon_sym_linear] = ACTIONS(3540),
    [anon_sym_snorm] = ACTIONS(3540),
    [anon_sym_unorm] = ACTIONS(3540),
    [anon_sym_point] = ACTIONS(3540),
    [anon_sym_line] = ACTIONS(3540),
    [anon_sym_triangleadj] = ACTIONS(3540),
    [anon_sym_lineadj] = ACTIONS(3540),
    [anon_sym_triangle] = ACTIONS(3540),
    [anon_sym_interface] = ACTIONS(3540),
    [anon_sym_extension] = ACTIONS(3540),
    [anon_sym___exported] = ACTIONS(3540),
  },
  [449] = {
    [sym_identifier] = ACTIONS(3452),
    [aux_sym_preproc_include_token1] = ACTIONS(3452),
    [aux_sym_preproc_def_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token2] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3452),
    [aux_sym_preproc_else_token1] = ACTIONS(3452),
    [aux_sym_preproc_elif_token1] = ACTIONS(3452),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3452),
    [sym_preproc_directive] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(3450),
    [anon_sym_BANG] = ACTIONS(3450),
    [anon_sym_TILDE] = ACTIONS(3450),
    [anon_sym_DASH] = ACTIONS(3452),
    [anon_sym_PLUS] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_AMP_AMP] = ACTIONS(3450),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym___extension__] = ACTIONS(3452),
    [anon_sym_typedef] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_out] = ACTIONS(3452),
    [anon_sym_inout] = ACTIONS(3452),
    [anon_sym_virtual] = ACTIONS(3452),
    [anon_sym_extern] = ACTIONS(3452),
    [anon_sym___attribute__] = ACTIONS(3452),
    [anon_sym___attribute] = ACTIONS(3452),
    [anon_sym_using] = ACTIONS(3452),
    [anon_sym_COLON_COLON] = ACTIONS(3450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3450),
    [anon_sym___declspec] = ACTIONS(3452),
    [anon_sym___based] = ACTIONS(3452),
    [anon_sym___cdecl] = ACTIONS(3452),
    [anon_sym___clrcall] = ACTIONS(3452),
    [anon_sym___stdcall] = ACTIONS(3452),
    [anon_sym___fastcall] = ACTIONS(3452),
    [anon_sym___thiscall] = ACTIONS(3452),
    [anon_sym___vectorcall] = ACTIONS(3452),
    [anon_sym_LBRACE] = ACTIONS(3450),
    [anon_sym_signed] = ACTIONS(3452),
    [anon_sym_unsigned] = ACTIONS(3452),
    [anon_sym_long] = ACTIONS(3452),
    [anon_sym_short] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3452),
    [anon_sym_static] = ACTIONS(3452),
    [anon_sym_register] = ACTIONS(3452),
    [anon_sym_inline] = ACTIONS(3452),
    [anon_sym___inline] = ACTIONS(3452),
    [anon_sym___inline__] = ACTIONS(3452),
    [anon_sym___forceinline] = ACTIONS(3452),
    [anon_sym_thread_local] = ACTIONS(3452),
    [anon_sym___thread] = ACTIONS(3452),
    [anon_sym_const] = ACTIONS(3452),
    [anon_sym_constexpr] = ACTIONS(3452),
    [anon_sym_volatile] = ACTIONS(3452),
    [anon_sym_restrict] = ACTIONS(3452),
    [anon_sym___restrict__] = ACTIONS(3452),
    [anon_sym__Atomic] = ACTIONS(3452),
    [anon_sym__Noreturn] = ACTIONS(3452),
    [anon_sym_noreturn] = ACTIONS(3452),
    [anon_sym__Nonnull] = ACTIONS(3452),
    [anon_sym_mutable] = ACTIONS(3452),
    [anon_sym_constinit] = ACTIONS(3452),
    [anon_sym_consteval] = ACTIONS(3452),
    [anon_sym_alignas] = ACTIONS(3452),
    [anon_sym__Alignas] = ACTIONS(3452),
    [sym_primitive_type] = ACTIONS(3452),
    [anon_sym_enum] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(3452),
    [anon_sym_union] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_else] = ACTIONS(3452),
    [anon_sym_switch] = ACTIONS(3452),
    [anon_sym_case] = ACTIONS(3452),
    [anon_sym_default] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_do] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3452),
    [anon_sym_return] = ACTIONS(3452),
    [anon_sym_break] = ACTIONS(3452),
    [anon_sym_continue] = ACTIONS(3452),
    [anon_sym_goto] = ACTIONS(3452),
    [anon_sym___try] = ACTIONS(3452),
    [anon_sym___leave] = ACTIONS(3452),
    [anon_sym_not] = ACTIONS(3452),
    [anon_sym_compl] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3450),
    [anon_sym_PLUS_PLUS] = ACTIONS(3450),
    [anon_sym_sizeof] = ACTIONS(3452),
    [anon_sym___alignof__] = ACTIONS(3452),
    [anon_sym___alignof] = ACTIONS(3452),
    [anon_sym__alignof] = ACTIONS(3452),
    [anon_sym_alignof] = ACTIONS(3452),
    [anon_sym__Alignof] = ACTIONS(3452),
    [anon_sym_offsetof] = ACTIONS(3452),
    [anon_sym__Generic] = ACTIONS(3452),
    [anon_sym_asm] = ACTIONS(3452),
    [anon_sym___asm__] = ACTIONS(3452),
    [anon_sym___asm] = ACTIONS(3452),
    [sym_number_literal] = ACTIONS(3450),
    [anon_sym_L_SQUOTE] = ACTIONS(3450),
    [anon_sym_u_SQUOTE] = ACTIONS(3450),
    [anon_sym_U_SQUOTE] = ACTIONS(3450),
    [anon_sym_u8_SQUOTE] = ACTIONS(3450),
    [anon_sym_SQUOTE] = ACTIONS(3450),
    [anon_sym_L_DQUOTE] = ACTIONS(3450),
    [anon_sym_u_DQUOTE] = ACTIONS(3450),
    [anon_sym_U_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8_DQUOTE] = ACTIONS(3450),
    [anon_sym_DQUOTE] = ACTIONS(3450),
    [sym_true] = ACTIONS(3452),
    [sym_false] = ACTIONS(3452),
    [anon_sym_NULL] = ACTIONS(3452),
    [anon_sym_nullptr] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3452),
    [anon_sym_let] = ACTIONS(3452),
    [anon_sym_This] = ACTIONS(3452),
    [anon_sym_decltype] = ACTIONS(3452),
    [anon_sym_explicit] = ACTIONS(3452),
    [anon_sym_typename] = ACTIONS(3452),
    [anon_sym_template] = ACTIONS(3452),
    [anon_sym_operator] = ACTIONS(3452),
    [anon_sym_try] = ACTIONS(3452),
    [anon_sym_delete] = ACTIONS(3452),
    [anon_sym_throw] = ACTIONS(3452),
    [anon_sym_namespace] = ACTIONS(3452),
    [anon_sym_static_assert] = ACTIONS(3452),
    [anon_sym_concept] = ACTIONS(3452),
    [anon_sym_co_return] = ACTIONS(3452),
    [anon_sym_co_yield] = ACTIONS(3452),
    [anon_sym_R_DQUOTE] = ACTIONS(3450),
    [anon_sym_LR_DQUOTE] = ACTIONS(3450),
    [anon_sym_uR_DQUOTE] = ACTIONS(3450),
    [anon_sym_UR_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3450),
    [anon_sym_co_await] = ACTIONS(3452),
    [anon_sym_new] = ACTIONS(3452),
    [anon_sym_requires] = ACTIONS(3452),
    [sym_this] = ACTIONS(3452),
    [anon_sym_discard] = ACTIONS(3452),
    [anon_sym_precise] = ACTIONS(3452),
    [anon_sym_shared] = ACTIONS(3452),
    [anon_sym_groupshared] = ACTIONS(3452),
    [anon_sym_uniform] = ACTIONS(3452),
    [anon_sym_row_major] = ACTIONS(3452),
    [anon_sym_column_major] = ACTIONS(3452),
    [anon_sym_globallycoherent] = ACTIONS(3452),
    [anon_sym_centroid] = ACTIONS(3452),
    [anon_sym_noperspective] = ACTIONS(3452),
    [anon_sym_nointerpolation] = ACTIONS(3452),
    [anon_sym_sample] = ACTIONS(3452),
    [anon_sym_linear] = ACTIONS(3452),
    [anon_sym_snorm] = ACTIONS(3452),
    [anon_sym_unorm] = ACTIONS(3452),
    [anon_sym_point] = ACTIONS(3452),
    [anon_sym_line] = ACTIONS(3452),
    [anon_sym_triangleadj] = ACTIONS(3452),
    [anon_sym_lineadj] = ACTIONS(3452),
    [anon_sym_triangle] = ACTIONS(3452),
    [anon_sym_cbuffer] = ACTIONS(3452),
    [anon_sym_interface] = ACTIONS(3452),
    [anon_sym_extension] = ACTIONS(3452),
  },
  [450] = {
    [ts_builtin_sym_end] = ACTIONS(3579),
    [sym_identifier] = ACTIONS(3581),
    [aux_sym_preproc_include_token1] = ACTIONS(3581),
    [aux_sym_preproc_def_token1] = ACTIONS(3581),
    [aux_sym_preproc_if_token1] = ACTIONS(3581),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3581),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3581),
    [sym_preproc_directive] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(3579),
    [anon_sym_BANG] = ACTIONS(3579),
    [anon_sym_TILDE] = ACTIONS(3579),
    [anon_sym_DASH] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3581),
    [anon_sym_STAR] = ACTIONS(3579),
    [anon_sym_AMP_AMP] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3581),
    [anon_sym_SEMI] = ACTIONS(3579),
    [anon_sym___extension__] = ACTIONS(3581),
    [anon_sym_typedef] = ACTIONS(3581),
    [anon_sym_in] = ACTIONS(3581),
    [anon_sym_out] = ACTIONS(3581),
    [anon_sym_inout] = ACTIONS(3581),
    [anon_sym_virtual] = ACTIONS(3581),
    [anon_sym_extern] = ACTIONS(3581),
    [anon_sym___attribute__] = ACTIONS(3581),
    [anon_sym___attribute] = ACTIONS(3581),
    [anon_sym_using] = ACTIONS(3581),
    [anon_sym_COLON_COLON] = ACTIONS(3579),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3579),
    [anon_sym___declspec] = ACTIONS(3581),
    [anon_sym___based] = ACTIONS(3581),
    [anon_sym___cdecl] = ACTIONS(3581),
    [anon_sym___clrcall] = ACTIONS(3581),
    [anon_sym___stdcall] = ACTIONS(3581),
    [anon_sym___fastcall] = ACTIONS(3581),
    [anon_sym___thiscall] = ACTIONS(3581),
    [anon_sym___vectorcall] = ACTIONS(3581),
    [anon_sym_LBRACE] = ACTIONS(3579),
    [anon_sym_signed] = ACTIONS(3581),
    [anon_sym_unsigned] = ACTIONS(3581),
    [anon_sym_long] = ACTIONS(3581),
    [anon_sym_short] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_static] = ACTIONS(3581),
    [anon_sym_register] = ACTIONS(3581),
    [anon_sym_inline] = ACTIONS(3581),
    [anon_sym___inline] = ACTIONS(3581),
    [anon_sym___inline__] = ACTIONS(3581),
    [anon_sym___forceinline] = ACTIONS(3581),
    [anon_sym_thread_local] = ACTIONS(3581),
    [anon_sym___thread] = ACTIONS(3581),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_constexpr] = ACTIONS(3581),
    [anon_sym_volatile] = ACTIONS(3581),
    [anon_sym_restrict] = ACTIONS(3581),
    [anon_sym___restrict__] = ACTIONS(3581),
    [anon_sym__Atomic] = ACTIONS(3581),
    [anon_sym__Noreturn] = ACTIONS(3581),
    [anon_sym_noreturn] = ACTIONS(3581),
    [anon_sym__Nonnull] = ACTIONS(3581),
    [anon_sym_mutable] = ACTIONS(3581),
    [anon_sym_constinit] = ACTIONS(3581),
    [anon_sym_consteval] = ACTIONS(3581),
    [anon_sym_alignas] = ACTIONS(3581),
    [anon_sym__Alignas] = ACTIONS(3581),
    [sym_primitive_type] = ACTIONS(3581),
    [anon_sym_enum] = ACTIONS(3581),
    [anon_sym_class] = ACTIONS(3581),
    [anon_sym_struct] = ACTIONS(3581),
    [anon_sym_union] = ACTIONS(3581),
    [anon_sym_if] = ACTIONS(3581),
    [anon_sym_else] = ACTIONS(3581),
    [anon_sym_switch] = ACTIONS(3581),
    [anon_sym_case] = ACTIONS(3581),
    [anon_sym_default] = ACTIONS(3581),
    [anon_sym_while] = ACTIONS(3581),
    [anon_sym_do] = ACTIONS(3581),
    [anon_sym_for] = ACTIONS(3581),
    [anon_sym_return] = ACTIONS(3581),
    [anon_sym_break] = ACTIONS(3581),
    [anon_sym_continue] = ACTIONS(3581),
    [anon_sym_goto] = ACTIONS(3581),
    [anon_sym___try] = ACTIONS(3581),
    [anon_sym___leave] = ACTIONS(3581),
    [anon_sym_not] = ACTIONS(3581),
    [anon_sym_compl] = ACTIONS(3581),
    [anon_sym_DASH_DASH] = ACTIONS(3579),
    [anon_sym_PLUS_PLUS] = ACTIONS(3579),
    [anon_sym_sizeof] = ACTIONS(3581),
    [anon_sym___alignof__] = ACTIONS(3581),
    [anon_sym___alignof] = ACTIONS(3581),
    [anon_sym__alignof] = ACTIONS(3581),
    [anon_sym_alignof] = ACTIONS(3581),
    [anon_sym__Alignof] = ACTIONS(3581),
    [anon_sym_offsetof] = ACTIONS(3581),
    [anon_sym__Generic] = ACTIONS(3581),
    [anon_sym_asm] = ACTIONS(3581),
    [anon_sym___asm__] = ACTIONS(3581),
    [anon_sym___asm] = ACTIONS(3581),
    [sym_number_literal] = ACTIONS(3579),
    [anon_sym_L_SQUOTE] = ACTIONS(3579),
    [anon_sym_u_SQUOTE] = ACTIONS(3579),
    [anon_sym_U_SQUOTE] = ACTIONS(3579),
    [anon_sym_u8_SQUOTE] = ACTIONS(3579),
    [anon_sym_SQUOTE] = ACTIONS(3579),
    [anon_sym_L_DQUOTE] = ACTIONS(3579),
    [anon_sym_u_DQUOTE] = ACTIONS(3579),
    [anon_sym_U_DQUOTE] = ACTIONS(3579),
    [anon_sym_u8_DQUOTE] = ACTIONS(3579),
    [anon_sym_DQUOTE] = ACTIONS(3579),
    [sym_true] = ACTIONS(3581),
    [sym_false] = ACTIONS(3581),
    [anon_sym_NULL] = ACTIONS(3581),
    [anon_sym_nullptr] = ACTIONS(3581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_This] = ACTIONS(3581),
    [anon_sym_decltype] = ACTIONS(3581),
    [anon_sym_explicit] = ACTIONS(3581),
    [anon_sym_typename] = ACTIONS(3581),
    [anon_sym_export] = ACTIONS(3581),
    [anon_sym_module] = ACTIONS(3581),
    [anon_sym_import] = ACTIONS(3581),
    [anon_sym_template] = ACTIONS(3581),
    [anon_sym_operator] = ACTIONS(3581),
    [anon_sym_try] = ACTIONS(3581),
    [anon_sym_delete] = ACTIONS(3581),
    [anon_sym_throw] = ACTIONS(3581),
    [anon_sym_namespace] = ACTIONS(3581),
    [anon_sym_static_assert] = ACTIONS(3581),
    [anon_sym_concept] = ACTIONS(3581),
    [anon_sym_co_return] = ACTIONS(3581),
    [anon_sym_co_yield] = ACTIONS(3581),
    [anon_sym_R_DQUOTE] = ACTIONS(3579),
    [anon_sym_LR_DQUOTE] = ACTIONS(3579),
    [anon_sym_uR_DQUOTE] = ACTIONS(3579),
    [anon_sym_UR_DQUOTE] = ACTIONS(3579),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3579),
    [anon_sym_co_await] = ACTIONS(3581),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_requires] = ACTIONS(3581),
    [sym_this] = ACTIONS(3581),
    [anon_sym_discard] = ACTIONS(3581),
    [anon_sym_precise] = ACTIONS(3581),
    [anon_sym_shared] = ACTIONS(3581),
    [anon_sym_groupshared] = ACTIONS(3581),
    [anon_sym_uniform] = ACTIONS(3581),
    [anon_sym_row_major] = ACTIONS(3581),
    [anon_sym_column_major] = ACTIONS(3581),
    [anon_sym_globallycoherent] = ACTIONS(3581),
    [anon_sym_centroid] = ACTIONS(3581),
    [anon_sym_noperspective] = ACTIONS(3581),
    [anon_sym_nointerpolation] = ACTIONS(3581),
    [anon_sym_sample] = ACTIONS(3581),
    [anon_sym_linear] = ACTIONS(3581),
    [anon_sym_snorm] = ACTIONS(3581),
    [anon_sym_unorm] = ACTIONS(3581),
    [anon_sym_point] = ACTIONS(3581),
    [anon_sym_line] = ACTIONS(3581),
    [anon_sym_triangleadj] = ACTIONS(3581),
    [anon_sym_lineadj] = ACTIONS(3581),
    [anon_sym_triangle] = ACTIONS(3581),
    [anon_sym_cbuffer] = ACTIONS(3581),
    [anon_sym_interface] = ACTIONS(3581),
    [anon_sym_extension] = ACTIONS(3581),
    [anon_sym___exported] = ACTIONS(3581),
  },
  [451] = {
    [sym_identifier] = ACTIONS(3460),
    [aux_sym_preproc_include_token1] = ACTIONS(3460),
    [aux_sym_preproc_def_token1] = ACTIONS(3460),
    [aux_sym_preproc_if_token1] = ACTIONS(3460),
    [aux_sym_preproc_if_token2] = ACTIONS(3460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3460),
    [aux_sym_preproc_else_token1] = ACTIONS(3460),
    [aux_sym_preproc_elif_token1] = ACTIONS(3460),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3460),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3460),
    [sym_preproc_directive] = ACTIONS(3460),
    [anon_sym_LPAREN2] = ACTIONS(3458),
    [anon_sym_BANG] = ACTIONS(3458),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3460),
    [anon_sym_PLUS] = ACTIONS(3460),
    [anon_sym_STAR] = ACTIONS(3458),
    [anon_sym_AMP_AMP] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3460),
    [anon_sym_SEMI] = ACTIONS(3458),
    [anon_sym___extension__] = ACTIONS(3460),
    [anon_sym_typedef] = ACTIONS(3460),
    [anon_sym_in] = ACTIONS(3460),
    [anon_sym_out] = ACTIONS(3460),
    [anon_sym_inout] = ACTIONS(3460),
    [anon_sym_virtual] = ACTIONS(3460),
    [anon_sym_extern] = ACTIONS(3460),
    [anon_sym___attribute__] = ACTIONS(3460),
    [anon_sym___attribute] = ACTIONS(3460),
    [anon_sym_using] = ACTIONS(3460),
    [anon_sym_COLON_COLON] = ACTIONS(3458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3458),
    [anon_sym___declspec] = ACTIONS(3460),
    [anon_sym___based] = ACTIONS(3460),
    [anon_sym___cdecl] = ACTIONS(3460),
    [anon_sym___clrcall] = ACTIONS(3460),
    [anon_sym___stdcall] = ACTIONS(3460),
    [anon_sym___fastcall] = ACTIONS(3460),
    [anon_sym___thiscall] = ACTIONS(3460),
    [anon_sym___vectorcall] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(3458),
    [anon_sym_signed] = ACTIONS(3460),
    [anon_sym_unsigned] = ACTIONS(3460),
    [anon_sym_long] = ACTIONS(3460),
    [anon_sym_short] = ACTIONS(3460),
    [anon_sym_LBRACK] = ACTIONS(3460),
    [anon_sym_static] = ACTIONS(3460),
    [anon_sym_register] = ACTIONS(3460),
    [anon_sym_inline] = ACTIONS(3460),
    [anon_sym___inline] = ACTIONS(3460),
    [anon_sym___inline__] = ACTIONS(3460),
    [anon_sym___forceinline] = ACTIONS(3460),
    [anon_sym_thread_local] = ACTIONS(3460),
    [anon_sym___thread] = ACTIONS(3460),
    [anon_sym_const] = ACTIONS(3460),
    [anon_sym_constexpr] = ACTIONS(3460),
    [anon_sym_volatile] = ACTIONS(3460),
    [anon_sym_restrict] = ACTIONS(3460),
    [anon_sym___restrict__] = ACTIONS(3460),
    [anon_sym__Atomic] = ACTIONS(3460),
    [anon_sym__Noreturn] = ACTIONS(3460),
    [anon_sym_noreturn] = ACTIONS(3460),
    [anon_sym__Nonnull] = ACTIONS(3460),
    [anon_sym_mutable] = ACTIONS(3460),
    [anon_sym_constinit] = ACTIONS(3460),
    [anon_sym_consteval] = ACTIONS(3460),
    [anon_sym_alignas] = ACTIONS(3460),
    [anon_sym__Alignas] = ACTIONS(3460),
    [sym_primitive_type] = ACTIONS(3460),
    [anon_sym_enum] = ACTIONS(3460),
    [anon_sym_class] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(3460),
    [anon_sym_union] = ACTIONS(3460),
    [anon_sym_if] = ACTIONS(3460),
    [anon_sym_else] = ACTIONS(3460),
    [anon_sym_switch] = ACTIONS(3460),
    [anon_sym_case] = ACTIONS(3460),
    [anon_sym_default] = ACTIONS(3460),
    [anon_sym_while] = ACTIONS(3460),
    [anon_sym_do] = ACTIONS(3460),
    [anon_sym_for] = ACTIONS(3460),
    [anon_sym_return] = ACTIONS(3460),
    [anon_sym_break] = ACTIONS(3460),
    [anon_sym_continue] = ACTIONS(3460),
    [anon_sym_goto] = ACTIONS(3460),
    [anon_sym___try] = ACTIONS(3460),
    [anon_sym___leave] = ACTIONS(3460),
    [anon_sym_not] = ACTIONS(3460),
    [anon_sym_compl] = ACTIONS(3460),
    [anon_sym_DASH_DASH] = ACTIONS(3458),
    [anon_sym_PLUS_PLUS] = ACTIONS(3458),
    [anon_sym_sizeof] = ACTIONS(3460),
    [anon_sym___alignof__] = ACTIONS(3460),
    [anon_sym___alignof] = ACTIONS(3460),
    [anon_sym__alignof] = ACTIONS(3460),
    [anon_sym_alignof] = ACTIONS(3460),
    [anon_sym__Alignof] = ACTIONS(3460),
    [anon_sym_offsetof] = ACTIONS(3460),
    [anon_sym__Generic] = ACTIONS(3460),
    [anon_sym_asm] = ACTIONS(3460),
    [anon_sym___asm__] = ACTIONS(3460),
    [anon_sym___asm] = ACTIONS(3460),
    [sym_number_literal] = ACTIONS(3458),
    [anon_sym_L_SQUOTE] = ACTIONS(3458),
    [anon_sym_u_SQUOTE] = ACTIONS(3458),
    [anon_sym_U_SQUOTE] = ACTIONS(3458),
    [anon_sym_u8_SQUOTE] = ACTIONS(3458),
    [anon_sym_SQUOTE] = ACTIONS(3458),
    [anon_sym_L_DQUOTE] = ACTIONS(3458),
    [anon_sym_u_DQUOTE] = ACTIONS(3458),
    [anon_sym_U_DQUOTE] = ACTIONS(3458),
    [anon_sym_u8_DQUOTE] = ACTIONS(3458),
    [anon_sym_DQUOTE] = ACTIONS(3458),
    [sym_true] = ACTIONS(3460),
    [sym_false] = ACTIONS(3460),
    [anon_sym_NULL] = ACTIONS(3460),
    [anon_sym_nullptr] = ACTIONS(3460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3460),
    [anon_sym_let] = ACTIONS(3460),
    [anon_sym_This] = ACTIONS(3460),
    [anon_sym_decltype] = ACTIONS(3460),
    [anon_sym_explicit] = ACTIONS(3460),
    [anon_sym_typename] = ACTIONS(3460),
    [anon_sym_template] = ACTIONS(3460),
    [anon_sym_operator] = ACTIONS(3460),
    [anon_sym_try] = ACTIONS(3460),
    [anon_sym_delete] = ACTIONS(3460),
    [anon_sym_throw] = ACTIONS(3460),
    [anon_sym_namespace] = ACTIONS(3460),
    [anon_sym_static_assert] = ACTIONS(3460),
    [anon_sym_concept] = ACTIONS(3460),
    [anon_sym_co_return] = ACTIONS(3460),
    [anon_sym_co_yield] = ACTIONS(3460),
    [anon_sym_R_DQUOTE] = ACTIONS(3458),
    [anon_sym_LR_DQUOTE] = ACTIONS(3458),
    [anon_sym_uR_DQUOTE] = ACTIONS(3458),
    [anon_sym_UR_DQUOTE] = ACTIONS(3458),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3458),
    [anon_sym_co_await] = ACTIONS(3460),
    [anon_sym_new] = ACTIONS(3460),
    [anon_sym_requires] = ACTIONS(3460),
    [sym_this] = ACTIONS(3460),
    [anon_sym_discard] = ACTIONS(3460),
    [anon_sym_precise] = ACTIONS(3460),
    [anon_sym_shared] = ACTIONS(3460),
    [anon_sym_groupshared] = ACTIONS(3460),
    [anon_sym_uniform] = ACTIONS(3460),
    [anon_sym_row_major] = ACTIONS(3460),
    [anon_sym_column_major] = ACTIONS(3460),
    [anon_sym_globallycoherent] = ACTIONS(3460),
    [anon_sym_centroid] = ACTIONS(3460),
    [anon_sym_noperspective] = ACTIONS(3460),
    [anon_sym_nointerpolation] = ACTIONS(3460),
    [anon_sym_sample] = ACTIONS(3460),
    [anon_sym_linear] = ACTIONS(3460),
    [anon_sym_snorm] = ACTIONS(3460),
    [anon_sym_unorm] = ACTIONS(3460),
    [anon_sym_point] = ACTIONS(3460),
    [anon_sym_line] = ACTIONS(3460),
    [anon_sym_triangleadj] = ACTIONS(3460),
    [anon_sym_lineadj] = ACTIONS(3460),
    [anon_sym_triangle] = ACTIONS(3460),
    [anon_sym_cbuffer] = ACTIONS(3460),
    [anon_sym_interface] = ACTIONS(3460),
    [anon_sym_extension] = ACTIONS(3460),
  },
  [452] = {
    [sym_expression] = STATE(5382),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(3343),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(3349),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3354),
    [anon_sym___extension__] = ACTIONS(3357),
    [anon_sym_typedef] = ACTIONS(3583),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3370),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3373),
    [anon_sym_explicit] = ACTIONS(3362),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3376),
    [anon_sym_operator] = ACTIONS(3362),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [453] = {
    [sym_identifier] = ACTIONS(3585),
    [aux_sym_preproc_include_token1] = ACTIONS(3585),
    [aux_sym_preproc_def_token1] = ACTIONS(3585),
    [aux_sym_preproc_if_token1] = ACTIONS(3585),
    [aux_sym_preproc_if_token2] = ACTIONS(3585),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3585),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3585),
    [aux_sym_preproc_else_token1] = ACTIONS(3585),
    [aux_sym_preproc_elif_token1] = ACTIONS(3585),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3585),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3585),
    [sym_preproc_directive] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(3587),
    [anon_sym_BANG] = ACTIONS(3587),
    [anon_sym_TILDE] = ACTIONS(3587),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_STAR] = ACTIONS(3587),
    [anon_sym_AMP_AMP] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_SEMI] = ACTIONS(3587),
    [anon_sym___extension__] = ACTIONS(3585),
    [anon_sym_typedef] = ACTIONS(3585),
    [anon_sym_in] = ACTIONS(3585),
    [anon_sym_out] = ACTIONS(3585),
    [anon_sym_inout] = ACTIONS(3585),
    [anon_sym_virtual] = ACTIONS(3585),
    [anon_sym_extern] = ACTIONS(3585),
    [anon_sym___attribute__] = ACTIONS(3585),
    [anon_sym___attribute] = ACTIONS(3585),
    [anon_sym_using] = ACTIONS(3585),
    [anon_sym_COLON_COLON] = ACTIONS(3587),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3587),
    [anon_sym___declspec] = ACTIONS(3585),
    [anon_sym___based] = ACTIONS(3585),
    [anon_sym___cdecl] = ACTIONS(3585),
    [anon_sym___clrcall] = ACTIONS(3585),
    [anon_sym___stdcall] = ACTIONS(3585),
    [anon_sym___fastcall] = ACTIONS(3585),
    [anon_sym___thiscall] = ACTIONS(3585),
    [anon_sym___vectorcall] = ACTIONS(3585),
    [anon_sym_LBRACE] = ACTIONS(3587),
    [anon_sym_signed] = ACTIONS(3585),
    [anon_sym_unsigned] = ACTIONS(3585),
    [anon_sym_long] = ACTIONS(3585),
    [anon_sym_short] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(3585),
    [anon_sym_static] = ACTIONS(3585),
    [anon_sym_register] = ACTIONS(3585),
    [anon_sym_inline] = ACTIONS(3585),
    [anon_sym___inline] = ACTIONS(3585),
    [anon_sym___inline__] = ACTIONS(3585),
    [anon_sym___forceinline] = ACTIONS(3585),
    [anon_sym_thread_local] = ACTIONS(3585),
    [anon_sym___thread] = ACTIONS(3585),
    [anon_sym_const] = ACTIONS(3585),
    [anon_sym_constexpr] = ACTIONS(3585),
    [anon_sym_volatile] = ACTIONS(3585),
    [anon_sym_restrict] = ACTIONS(3585),
    [anon_sym___restrict__] = ACTIONS(3585),
    [anon_sym__Atomic] = ACTIONS(3585),
    [anon_sym__Noreturn] = ACTIONS(3585),
    [anon_sym_noreturn] = ACTIONS(3585),
    [anon_sym__Nonnull] = ACTIONS(3585),
    [anon_sym_mutable] = ACTIONS(3585),
    [anon_sym_constinit] = ACTIONS(3585),
    [anon_sym_consteval] = ACTIONS(3585),
    [anon_sym_alignas] = ACTIONS(3585),
    [anon_sym__Alignas] = ACTIONS(3585),
    [sym_primitive_type] = ACTIONS(3585),
    [anon_sym_enum] = ACTIONS(3585),
    [anon_sym_class] = ACTIONS(3585),
    [anon_sym_struct] = ACTIONS(3585),
    [anon_sym_union] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_else] = ACTIONS(3585),
    [anon_sym_switch] = ACTIONS(3585),
    [anon_sym_case] = ACTIONS(3585),
    [anon_sym_default] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_do] = ACTIONS(3585),
    [anon_sym_for] = ACTIONS(3585),
    [anon_sym_return] = ACTIONS(3585),
    [anon_sym_break] = ACTIONS(3585),
    [anon_sym_continue] = ACTIONS(3585),
    [anon_sym_goto] = ACTIONS(3585),
    [anon_sym___try] = ACTIONS(3585),
    [anon_sym___leave] = ACTIONS(3585),
    [anon_sym_not] = ACTIONS(3585),
    [anon_sym_compl] = ACTIONS(3585),
    [anon_sym_DASH_DASH] = ACTIONS(3587),
    [anon_sym_PLUS_PLUS] = ACTIONS(3587),
    [anon_sym_sizeof] = ACTIONS(3585),
    [anon_sym___alignof__] = ACTIONS(3585),
    [anon_sym___alignof] = ACTIONS(3585),
    [anon_sym__alignof] = ACTIONS(3585),
    [anon_sym_alignof] = ACTIONS(3585),
    [anon_sym__Alignof] = ACTIONS(3585),
    [anon_sym_offsetof] = ACTIONS(3585),
    [anon_sym__Generic] = ACTIONS(3585),
    [anon_sym_asm] = ACTIONS(3585),
    [anon_sym___asm__] = ACTIONS(3585),
    [anon_sym___asm] = ACTIONS(3585),
    [sym_number_literal] = ACTIONS(3587),
    [anon_sym_L_SQUOTE] = ACTIONS(3587),
    [anon_sym_u_SQUOTE] = ACTIONS(3587),
    [anon_sym_U_SQUOTE] = ACTIONS(3587),
    [anon_sym_u8_SQUOTE] = ACTIONS(3587),
    [anon_sym_SQUOTE] = ACTIONS(3587),
    [anon_sym_L_DQUOTE] = ACTIONS(3587),
    [anon_sym_u_DQUOTE] = ACTIONS(3587),
    [anon_sym_U_DQUOTE] = ACTIONS(3587),
    [anon_sym_u8_DQUOTE] = ACTIONS(3587),
    [anon_sym_DQUOTE] = ACTIONS(3587),
    [sym_true] = ACTIONS(3585),
    [sym_false] = ACTIONS(3585),
    [anon_sym_NULL] = ACTIONS(3585),
    [anon_sym_nullptr] = ACTIONS(3585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3585),
    [anon_sym_let] = ACTIONS(3585),
    [anon_sym_This] = ACTIONS(3585),
    [anon_sym_decltype] = ACTIONS(3585),
    [anon_sym_explicit] = ACTIONS(3585),
    [anon_sym_typename] = ACTIONS(3585),
    [anon_sym_template] = ACTIONS(3585),
    [anon_sym_operator] = ACTIONS(3585),
    [anon_sym_try] = ACTIONS(3585),
    [anon_sym_delete] = ACTIONS(3585),
    [anon_sym_throw] = ACTIONS(3585),
    [anon_sym_namespace] = ACTIONS(3585),
    [anon_sym_static_assert] = ACTIONS(3585),
    [anon_sym_concept] = ACTIONS(3585),
    [anon_sym_co_return] = ACTIONS(3585),
    [anon_sym_co_yield] = ACTIONS(3585),
    [anon_sym_R_DQUOTE] = ACTIONS(3587),
    [anon_sym_LR_DQUOTE] = ACTIONS(3587),
    [anon_sym_uR_DQUOTE] = ACTIONS(3587),
    [anon_sym_UR_DQUOTE] = ACTIONS(3587),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3587),
    [anon_sym_co_await] = ACTIONS(3585),
    [anon_sym_new] = ACTIONS(3585),
    [anon_sym_requires] = ACTIONS(3585),
    [sym_this] = ACTIONS(3585),
    [anon_sym_discard] = ACTIONS(3585),
    [anon_sym_precise] = ACTIONS(3585),
    [anon_sym_shared] = ACTIONS(3585),
    [anon_sym_groupshared] = ACTIONS(3585),
    [anon_sym_uniform] = ACTIONS(3585),
    [anon_sym_row_major] = ACTIONS(3585),
    [anon_sym_column_major] = ACTIONS(3585),
    [anon_sym_globallycoherent] = ACTIONS(3585),
    [anon_sym_centroid] = ACTIONS(3585),
    [anon_sym_noperspective] = ACTIONS(3585),
    [anon_sym_nointerpolation] = ACTIONS(3585),
    [anon_sym_sample] = ACTIONS(3585),
    [anon_sym_linear] = ACTIONS(3585),
    [anon_sym_snorm] = ACTIONS(3585),
    [anon_sym_unorm] = ACTIONS(3585),
    [anon_sym_point] = ACTIONS(3585),
    [anon_sym_line] = ACTIONS(3585),
    [anon_sym_triangleadj] = ACTIONS(3585),
    [anon_sym_lineadj] = ACTIONS(3585),
    [anon_sym_triangle] = ACTIONS(3585),
    [anon_sym_cbuffer] = ACTIONS(3585),
    [anon_sym_interface] = ACTIONS(3585),
    [anon_sym_extension] = ACTIONS(3585),
  },
  [454] = {
    [ts_builtin_sym_end] = ACTIONS(3512),
    [sym_identifier] = ACTIONS(3510),
    [aux_sym_preproc_include_token1] = ACTIONS(3510),
    [aux_sym_preproc_def_token1] = ACTIONS(3510),
    [aux_sym_preproc_if_token1] = ACTIONS(3510),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3510),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3510),
    [sym_preproc_directive] = ACTIONS(3510),
    [anon_sym_LPAREN2] = ACTIONS(3512),
    [anon_sym_BANG] = ACTIONS(3512),
    [anon_sym_TILDE] = ACTIONS(3512),
    [anon_sym_DASH] = ACTIONS(3510),
    [anon_sym_PLUS] = ACTIONS(3510),
    [anon_sym_STAR] = ACTIONS(3512),
    [anon_sym_AMP_AMP] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3510),
    [anon_sym_SEMI] = ACTIONS(3512),
    [anon_sym___extension__] = ACTIONS(3510),
    [anon_sym_typedef] = ACTIONS(3510),
    [anon_sym_in] = ACTIONS(3510),
    [anon_sym_out] = ACTIONS(3510),
    [anon_sym_inout] = ACTIONS(3510),
    [anon_sym_virtual] = ACTIONS(3510),
    [anon_sym_extern] = ACTIONS(3510),
    [anon_sym___attribute__] = ACTIONS(3510),
    [anon_sym___attribute] = ACTIONS(3510),
    [anon_sym_using] = ACTIONS(3510),
    [anon_sym_COLON_COLON] = ACTIONS(3512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3512),
    [anon_sym___declspec] = ACTIONS(3510),
    [anon_sym___based] = ACTIONS(3510),
    [anon_sym___cdecl] = ACTIONS(3510),
    [anon_sym___clrcall] = ACTIONS(3510),
    [anon_sym___stdcall] = ACTIONS(3510),
    [anon_sym___fastcall] = ACTIONS(3510),
    [anon_sym___thiscall] = ACTIONS(3510),
    [anon_sym___vectorcall] = ACTIONS(3510),
    [anon_sym_LBRACE] = ACTIONS(3512),
    [anon_sym_signed] = ACTIONS(3510),
    [anon_sym_unsigned] = ACTIONS(3510),
    [anon_sym_long] = ACTIONS(3510),
    [anon_sym_short] = ACTIONS(3510),
    [anon_sym_LBRACK] = ACTIONS(3510),
    [anon_sym_static] = ACTIONS(3510),
    [anon_sym_register] = ACTIONS(3510),
    [anon_sym_inline] = ACTIONS(3510),
    [anon_sym___inline] = ACTIONS(3510),
    [anon_sym___inline__] = ACTIONS(3510),
    [anon_sym___forceinline] = ACTIONS(3510),
    [anon_sym_thread_local] = ACTIONS(3510),
    [anon_sym___thread] = ACTIONS(3510),
    [anon_sym_const] = ACTIONS(3510),
    [anon_sym_constexpr] = ACTIONS(3510),
    [anon_sym_volatile] = ACTIONS(3510),
    [anon_sym_restrict] = ACTIONS(3510),
    [anon_sym___restrict__] = ACTIONS(3510),
    [anon_sym__Atomic] = ACTIONS(3510),
    [anon_sym__Noreturn] = ACTIONS(3510),
    [anon_sym_noreturn] = ACTIONS(3510),
    [anon_sym__Nonnull] = ACTIONS(3510),
    [anon_sym_mutable] = ACTIONS(3510),
    [anon_sym_constinit] = ACTIONS(3510),
    [anon_sym_consteval] = ACTIONS(3510),
    [anon_sym_alignas] = ACTIONS(3510),
    [anon_sym__Alignas] = ACTIONS(3510),
    [sym_primitive_type] = ACTIONS(3510),
    [anon_sym_enum] = ACTIONS(3510),
    [anon_sym_class] = ACTIONS(3510),
    [anon_sym_struct] = ACTIONS(3510),
    [anon_sym_union] = ACTIONS(3510),
    [anon_sym_if] = ACTIONS(3510),
    [anon_sym_else] = ACTIONS(3510),
    [anon_sym_switch] = ACTIONS(3510),
    [anon_sym_case] = ACTIONS(3510),
    [anon_sym_default] = ACTIONS(3510),
    [anon_sym_while] = ACTIONS(3510),
    [anon_sym_do] = ACTIONS(3510),
    [anon_sym_for] = ACTIONS(3510),
    [anon_sym_return] = ACTIONS(3510),
    [anon_sym_break] = ACTIONS(3510),
    [anon_sym_continue] = ACTIONS(3510),
    [anon_sym_goto] = ACTIONS(3510),
    [anon_sym___try] = ACTIONS(3510),
    [anon_sym___leave] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3510),
    [anon_sym_compl] = ACTIONS(3510),
    [anon_sym_DASH_DASH] = ACTIONS(3512),
    [anon_sym_PLUS_PLUS] = ACTIONS(3512),
    [anon_sym_sizeof] = ACTIONS(3510),
    [anon_sym___alignof__] = ACTIONS(3510),
    [anon_sym___alignof] = ACTIONS(3510),
    [anon_sym__alignof] = ACTIONS(3510),
    [anon_sym_alignof] = ACTIONS(3510),
    [anon_sym__Alignof] = ACTIONS(3510),
    [anon_sym_offsetof] = ACTIONS(3510),
    [anon_sym__Generic] = ACTIONS(3510),
    [anon_sym_asm] = ACTIONS(3510),
    [anon_sym___asm__] = ACTIONS(3510),
    [anon_sym___asm] = ACTIONS(3510),
    [sym_number_literal] = ACTIONS(3512),
    [anon_sym_L_SQUOTE] = ACTIONS(3512),
    [anon_sym_u_SQUOTE] = ACTIONS(3512),
    [anon_sym_U_SQUOTE] = ACTIONS(3512),
    [anon_sym_u8_SQUOTE] = ACTIONS(3512),
    [anon_sym_SQUOTE] = ACTIONS(3512),
    [anon_sym_L_DQUOTE] = ACTIONS(3512),
    [anon_sym_u_DQUOTE] = ACTIONS(3512),
    [anon_sym_U_DQUOTE] = ACTIONS(3512),
    [anon_sym_u8_DQUOTE] = ACTIONS(3512),
    [anon_sym_DQUOTE] = ACTIONS(3512),
    [sym_true] = ACTIONS(3510),
    [sym_false] = ACTIONS(3510),
    [anon_sym_NULL] = ACTIONS(3510),
    [anon_sym_nullptr] = ACTIONS(3510),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3510),
    [anon_sym_let] = ACTIONS(3510),
    [anon_sym_This] = ACTIONS(3510),
    [anon_sym_decltype] = ACTIONS(3510),
    [anon_sym_explicit] = ACTIONS(3510),
    [anon_sym_typename] = ACTIONS(3510),
    [anon_sym_export] = ACTIONS(3510),
    [anon_sym_module] = ACTIONS(3510),
    [anon_sym_import] = ACTIONS(3510),
    [anon_sym_template] = ACTIONS(3510),
    [anon_sym_operator] = ACTIONS(3510),
    [anon_sym_try] = ACTIONS(3510),
    [anon_sym_delete] = ACTIONS(3510),
    [anon_sym_throw] = ACTIONS(3510),
    [anon_sym_namespace] = ACTIONS(3510),
    [anon_sym_static_assert] = ACTIONS(3510),
    [anon_sym_concept] = ACTIONS(3510),
    [anon_sym_co_return] = ACTIONS(3510),
    [anon_sym_co_yield] = ACTIONS(3510),
    [anon_sym_R_DQUOTE] = ACTIONS(3512),
    [anon_sym_LR_DQUOTE] = ACTIONS(3512),
    [anon_sym_uR_DQUOTE] = ACTIONS(3512),
    [anon_sym_UR_DQUOTE] = ACTIONS(3512),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3512),
    [anon_sym_co_await] = ACTIONS(3510),
    [anon_sym_new] = ACTIONS(3510),
    [anon_sym_requires] = ACTIONS(3510),
    [sym_this] = ACTIONS(3510),
    [anon_sym_discard] = ACTIONS(3510),
    [anon_sym_precise] = ACTIONS(3510),
    [anon_sym_shared] = ACTIONS(3510),
    [anon_sym_groupshared] = ACTIONS(3510),
    [anon_sym_uniform] = ACTIONS(3510),
    [anon_sym_row_major] = ACTIONS(3510),
    [anon_sym_column_major] = ACTIONS(3510),
    [anon_sym_globallycoherent] = ACTIONS(3510),
    [anon_sym_centroid] = ACTIONS(3510),
    [anon_sym_noperspective] = ACTIONS(3510),
    [anon_sym_nointerpolation] = ACTIONS(3510),
    [anon_sym_sample] = ACTIONS(3510),
    [anon_sym_linear] = ACTIONS(3510),
    [anon_sym_snorm] = ACTIONS(3510),
    [anon_sym_unorm] = ACTIONS(3510),
    [anon_sym_point] = ACTIONS(3510),
    [anon_sym_line] = ACTIONS(3510),
    [anon_sym_triangleadj] = ACTIONS(3510),
    [anon_sym_lineadj] = ACTIONS(3510),
    [anon_sym_triangle] = ACTIONS(3510),
    [anon_sym_cbuffer] = ACTIONS(3510),
    [anon_sym_interface] = ACTIONS(3510),
    [anon_sym_extension] = ACTIONS(3510),
    [anon_sym___exported] = ACTIONS(3510),
  },
  [455] = {
    [ts_builtin_sym_end] = ACTIONS(3589),
    [sym_identifier] = ACTIONS(3591),
    [aux_sym_preproc_include_token1] = ACTIONS(3591),
    [aux_sym_preproc_def_token1] = ACTIONS(3591),
    [aux_sym_preproc_if_token1] = ACTIONS(3591),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3591),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3591),
    [sym_preproc_directive] = ACTIONS(3591),
    [anon_sym_LPAREN2] = ACTIONS(3589),
    [anon_sym_BANG] = ACTIONS(3589),
    [anon_sym_TILDE] = ACTIONS(3589),
    [anon_sym_DASH] = ACTIONS(3591),
    [anon_sym_PLUS] = ACTIONS(3591),
    [anon_sym_STAR] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(3589),
    [anon_sym___extension__] = ACTIONS(3591),
    [anon_sym_typedef] = ACTIONS(3591),
    [anon_sym_in] = ACTIONS(3591),
    [anon_sym_out] = ACTIONS(3591),
    [anon_sym_inout] = ACTIONS(3591),
    [anon_sym_virtual] = ACTIONS(3591),
    [anon_sym_extern] = ACTIONS(3591),
    [anon_sym___attribute__] = ACTIONS(3591),
    [anon_sym___attribute] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3591),
    [anon_sym_COLON_COLON] = ACTIONS(3589),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3589),
    [anon_sym___declspec] = ACTIONS(3591),
    [anon_sym___based] = ACTIONS(3591),
    [anon_sym___cdecl] = ACTIONS(3591),
    [anon_sym___clrcall] = ACTIONS(3591),
    [anon_sym___stdcall] = ACTIONS(3591),
    [anon_sym___fastcall] = ACTIONS(3591),
    [anon_sym___thiscall] = ACTIONS(3591),
    [anon_sym___vectorcall] = ACTIONS(3591),
    [anon_sym_LBRACE] = ACTIONS(3589),
    [anon_sym_signed] = ACTIONS(3591),
    [anon_sym_unsigned] = ACTIONS(3591),
    [anon_sym_long] = ACTIONS(3591),
    [anon_sym_short] = ACTIONS(3591),
    [anon_sym_LBRACK] = ACTIONS(3591),
    [anon_sym_static] = ACTIONS(3591),
    [anon_sym_register] = ACTIONS(3591),
    [anon_sym_inline] = ACTIONS(3591),
    [anon_sym___inline] = ACTIONS(3591),
    [anon_sym___inline__] = ACTIONS(3591),
    [anon_sym___forceinline] = ACTIONS(3591),
    [anon_sym_thread_local] = ACTIONS(3591),
    [anon_sym___thread] = ACTIONS(3591),
    [anon_sym_const] = ACTIONS(3591),
    [anon_sym_constexpr] = ACTIONS(3591),
    [anon_sym_volatile] = ACTIONS(3591),
    [anon_sym_restrict] = ACTIONS(3591),
    [anon_sym___restrict__] = ACTIONS(3591),
    [anon_sym__Atomic] = ACTIONS(3591),
    [anon_sym__Noreturn] = ACTIONS(3591),
    [anon_sym_noreturn] = ACTIONS(3591),
    [anon_sym__Nonnull] = ACTIONS(3591),
    [anon_sym_mutable] = ACTIONS(3591),
    [anon_sym_constinit] = ACTIONS(3591),
    [anon_sym_consteval] = ACTIONS(3591),
    [anon_sym_alignas] = ACTIONS(3591),
    [anon_sym__Alignas] = ACTIONS(3591),
    [sym_primitive_type] = ACTIONS(3591),
    [anon_sym_enum] = ACTIONS(3591),
    [anon_sym_class] = ACTIONS(3591),
    [anon_sym_struct] = ACTIONS(3591),
    [anon_sym_union] = ACTIONS(3591),
    [anon_sym_if] = ACTIONS(3591),
    [anon_sym_else] = ACTIONS(3591),
    [anon_sym_switch] = ACTIONS(3591),
    [anon_sym_case] = ACTIONS(3591),
    [anon_sym_default] = ACTIONS(3591),
    [anon_sym_while] = ACTIONS(3591),
    [anon_sym_do] = ACTIONS(3591),
    [anon_sym_for] = ACTIONS(3591),
    [anon_sym_return] = ACTIONS(3591),
    [anon_sym_break] = ACTIONS(3591),
    [anon_sym_continue] = ACTIONS(3591),
    [anon_sym_goto] = ACTIONS(3591),
    [anon_sym___try] = ACTIONS(3591),
    [anon_sym___leave] = ACTIONS(3591),
    [anon_sym_not] = ACTIONS(3591),
    [anon_sym_compl] = ACTIONS(3591),
    [anon_sym_DASH_DASH] = ACTIONS(3589),
    [anon_sym_PLUS_PLUS] = ACTIONS(3589),
    [anon_sym_sizeof] = ACTIONS(3591),
    [anon_sym___alignof__] = ACTIONS(3591),
    [anon_sym___alignof] = ACTIONS(3591),
    [anon_sym__alignof] = ACTIONS(3591),
    [anon_sym_alignof] = ACTIONS(3591),
    [anon_sym__Alignof] = ACTIONS(3591),
    [anon_sym_offsetof] = ACTIONS(3591),
    [anon_sym__Generic] = ACTIONS(3591),
    [anon_sym_asm] = ACTIONS(3591),
    [anon_sym___asm__] = ACTIONS(3591),
    [anon_sym___asm] = ACTIONS(3591),
    [sym_number_literal] = ACTIONS(3589),
    [anon_sym_L_SQUOTE] = ACTIONS(3589),
    [anon_sym_u_SQUOTE] = ACTIONS(3589),
    [anon_sym_U_SQUOTE] = ACTIONS(3589),
    [anon_sym_u8_SQUOTE] = ACTIONS(3589),
    [anon_sym_SQUOTE] = ACTIONS(3589),
    [anon_sym_L_DQUOTE] = ACTIONS(3589),
    [anon_sym_u_DQUOTE] = ACTIONS(3589),
    [anon_sym_U_DQUOTE] = ACTIONS(3589),
    [anon_sym_u8_DQUOTE] = ACTIONS(3589),
    [anon_sym_DQUOTE] = ACTIONS(3589),
    [sym_true] = ACTIONS(3591),
    [sym_false] = ACTIONS(3591),
    [anon_sym_NULL] = ACTIONS(3591),
    [anon_sym_nullptr] = ACTIONS(3591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3591),
    [anon_sym_let] = ACTIONS(3591),
    [anon_sym_This] = ACTIONS(3591),
    [anon_sym_decltype] = ACTIONS(3591),
    [anon_sym_explicit] = ACTIONS(3591),
    [anon_sym_typename] = ACTIONS(3591),
    [anon_sym_export] = ACTIONS(3591),
    [anon_sym_module] = ACTIONS(3591),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_template] = ACTIONS(3591),
    [anon_sym_operator] = ACTIONS(3591),
    [anon_sym_try] = ACTIONS(3591),
    [anon_sym_delete] = ACTIONS(3591),
    [anon_sym_throw] = ACTIONS(3591),
    [anon_sym_namespace] = ACTIONS(3591),
    [anon_sym_static_assert] = ACTIONS(3591),
    [anon_sym_concept] = ACTIONS(3591),
    [anon_sym_co_return] = ACTIONS(3591),
    [anon_sym_co_yield] = ACTIONS(3591),
    [anon_sym_R_DQUOTE] = ACTIONS(3589),
    [anon_sym_LR_DQUOTE] = ACTIONS(3589),
    [anon_sym_uR_DQUOTE] = ACTIONS(3589),
    [anon_sym_UR_DQUOTE] = ACTIONS(3589),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3589),
    [anon_sym_co_await] = ACTIONS(3591),
    [anon_sym_new] = ACTIONS(3591),
    [anon_sym_requires] = ACTIONS(3591),
    [sym_this] = ACTIONS(3591),
    [anon_sym_discard] = ACTIONS(3591),
    [anon_sym_precise] = ACTIONS(3591),
    [anon_sym_shared] = ACTIONS(3591),
    [anon_sym_groupshared] = ACTIONS(3591),
    [anon_sym_uniform] = ACTIONS(3591),
    [anon_sym_row_major] = ACTIONS(3591),
    [anon_sym_column_major] = ACTIONS(3591),
    [anon_sym_globallycoherent] = ACTIONS(3591),
    [anon_sym_centroid] = ACTIONS(3591),
    [anon_sym_noperspective] = ACTIONS(3591),
    [anon_sym_nointerpolation] = ACTIONS(3591),
    [anon_sym_sample] = ACTIONS(3591),
    [anon_sym_linear] = ACTIONS(3591),
    [anon_sym_snorm] = ACTIONS(3591),
    [anon_sym_unorm] = ACTIONS(3591),
    [anon_sym_point] = ACTIONS(3591),
    [anon_sym_line] = ACTIONS(3591),
    [anon_sym_triangleadj] = ACTIONS(3591),
    [anon_sym_lineadj] = ACTIONS(3591),
    [anon_sym_triangle] = ACTIONS(3591),
    [anon_sym_cbuffer] = ACTIONS(3591),
    [anon_sym_interface] = ACTIONS(3591),
    [anon_sym_extension] = ACTIONS(3591),
    [anon_sym___exported] = ACTIONS(3591),
  },
  [456] = {
    [sym_identifier] = ACTIONS(3593),
    [aux_sym_preproc_include_token1] = ACTIONS(3593),
    [aux_sym_preproc_def_token1] = ACTIONS(3593),
    [aux_sym_preproc_if_token1] = ACTIONS(3593),
    [aux_sym_preproc_if_token2] = ACTIONS(3593),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3593),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3593),
    [aux_sym_preproc_else_token1] = ACTIONS(3593),
    [aux_sym_preproc_elif_token1] = ACTIONS(3593),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3593),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3593),
    [sym_preproc_directive] = ACTIONS(3593),
    [anon_sym_LPAREN2] = ACTIONS(3595),
    [anon_sym_BANG] = ACTIONS(3595),
    [anon_sym_TILDE] = ACTIONS(3595),
    [anon_sym_DASH] = ACTIONS(3593),
    [anon_sym_PLUS] = ACTIONS(3593),
    [anon_sym_STAR] = ACTIONS(3595),
    [anon_sym_AMP_AMP] = ACTIONS(3595),
    [anon_sym_AMP] = ACTIONS(3593),
    [anon_sym_SEMI] = ACTIONS(3595),
    [anon_sym___extension__] = ACTIONS(3593),
    [anon_sym_typedef] = ACTIONS(3593),
    [anon_sym_in] = ACTIONS(3593),
    [anon_sym_out] = ACTIONS(3593),
    [anon_sym_inout] = ACTIONS(3593),
    [anon_sym_virtual] = ACTIONS(3593),
    [anon_sym_extern] = ACTIONS(3593),
    [anon_sym___attribute__] = ACTIONS(3593),
    [anon_sym___attribute] = ACTIONS(3593),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_COLON_COLON] = ACTIONS(3595),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3595),
    [anon_sym___declspec] = ACTIONS(3593),
    [anon_sym___based] = ACTIONS(3593),
    [anon_sym___cdecl] = ACTIONS(3593),
    [anon_sym___clrcall] = ACTIONS(3593),
    [anon_sym___stdcall] = ACTIONS(3593),
    [anon_sym___fastcall] = ACTIONS(3593),
    [anon_sym___thiscall] = ACTIONS(3593),
    [anon_sym___vectorcall] = ACTIONS(3593),
    [anon_sym_LBRACE] = ACTIONS(3595),
    [anon_sym_signed] = ACTIONS(3593),
    [anon_sym_unsigned] = ACTIONS(3593),
    [anon_sym_long] = ACTIONS(3593),
    [anon_sym_short] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(3593),
    [anon_sym_static] = ACTIONS(3593),
    [anon_sym_register] = ACTIONS(3593),
    [anon_sym_inline] = ACTIONS(3593),
    [anon_sym___inline] = ACTIONS(3593),
    [anon_sym___inline__] = ACTIONS(3593),
    [anon_sym___forceinline] = ACTIONS(3593),
    [anon_sym_thread_local] = ACTIONS(3593),
    [anon_sym___thread] = ACTIONS(3593),
    [anon_sym_const] = ACTIONS(3593),
    [anon_sym_constexpr] = ACTIONS(3593),
    [anon_sym_volatile] = ACTIONS(3593),
    [anon_sym_restrict] = ACTIONS(3593),
    [anon_sym___restrict__] = ACTIONS(3593),
    [anon_sym__Atomic] = ACTIONS(3593),
    [anon_sym__Noreturn] = ACTIONS(3593),
    [anon_sym_noreturn] = ACTIONS(3593),
    [anon_sym__Nonnull] = ACTIONS(3593),
    [anon_sym_mutable] = ACTIONS(3593),
    [anon_sym_constinit] = ACTIONS(3593),
    [anon_sym_consteval] = ACTIONS(3593),
    [anon_sym_alignas] = ACTIONS(3593),
    [anon_sym__Alignas] = ACTIONS(3593),
    [sym_primitive_type] = ACTIONS(3593),
    [anon_sym_enum] = ACTIONS(3593),
    [anon_sym_class] = ACTIONS(3593),
    [anon_sym_struct] = ACTIONS(3593),
    [anon_sym_union] = ACTIONS(3593),
    [anon_sym_if] = ACTIONS(3593),
    [anon_sym_else] = ACTIONS(3593),
    [anon_sym_switch] = ACTIONS(3593),
    [anon_sym_case] = ACTIONS(3593),
    [anon_sym_default] = ACTIONS(3593),
    [anon_sym_while] = ACTIONS(3593),
    [anon_sym_do] = ACTIONS(3593),
    [anon_sym_for] = ACTIONS(3593),
    [anon_sym_return] = ACTIONS(3593),
    [anon_sym_break] = ACTIONS(3593),
    [anon_sym_continue] = ACTIONS(3593),
    [anon_sym_goto] = ACTIONS(3593),
    [anon_sym___try] = ACTIONS(3593),
    [anon_sym___leave] = ACTIONS(3593),
    [anon_sym_not] = ACTIONS(3593),
    [anon_sym_compl] = ACTIONS(3593),
    [anon_sym_DASH_DASH] = ACTIONS(3595),
    [anon_sym_PLUS_PLUS] = ACTIONS(3595),
    [anon_sym_sizeof] = ACTIONS(3593),
    [anon_sym___alignof__] = ACTIONS(3593),
    [anon_sym___alignof] = ACTIONS(3593),
    [anon_sym__alignof] = ACTIONS(3593),
    [anon_sym_alignof] = ACTIONS(3593),
    [anon_sym__Alignof] = ACTIONS(3593),
    [anon_sym_offsetof] = ACTIONS(3593),
    [anon_sym__Generic] = ACTIONS(3593),
    [anon_sym_asm] = ACTIONS(3593),
    [anon_sym___asm__] = ACTIONS(3593),
    [anon_sym___asm] = ACTIONS(3593),
    [sym_number_literal] = ACTIONS(3595),
    [anon_sym_L_SQUOTE] = ACTIONS(3595),
    [anon_sym_u_SQUOTE] = ACTIONS(3595),
    [anon_sym_U_SQUOTE] = ACTIONS(3595),
    [anon_sym_u8_SQUOTE] = ACTIONS(3595),
    [anon_sym_SQUOTE] = ACTIONS(3595),
    [anon_sym_L_DQUOTE] = ACTIONS(3595),
    [anon_sym_u_DQUOTE] = ACTIONS(3595),
    [anon_sym_U_DQUOTE] = ACTIONS(3595),
    [anon_sym_u8_DQUOTE] = ACTIONS(3595),
    [anon_sym_DQUOTE] = ACTIONS(3595),
    [sym_true] = ACTIONS(3593),
    [sym_false] = ACTIONS(3593),
    [anon_sym_NULL] = ACTIONS(3593),
    [anon_sym_nullptr] = ACTIONS(3593),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3593),
    [anon_sym_let] = ACTIONS(3593),
    [anon_sym_This] = ACTIONS(3593),
    [anon_sym_decltype] = ACTIONS(3593),
    [anon_sym_explicit] = ACTIONS(3593),
    [anon_sym_typename] = ACTIONS(3593),
    [anon_sym_template] = ACTIONS(3593),
    [anon_sym_operator] = ACTIONS(3593),
    [anon_sym_try] = ACTIONS(3593),
    [anon_sym_delete] = ACTIONS(3593),
    [anon_sym_throw] = ACTIONS(3593),
    [anon_sym_namespace] = ACTIONS(3593),
    [anon_sym_static_assert] = ACTIONS(3593),
    [anon_sym_concept] = ACTIONS(3593),
    [anon_sym_co_return] = ACTIONS(3593),
    [anon_sym_co_yield] = ACTIONS(3593),
    [anon_sym_R_DQUOTE] = ACTIONS(3595),
    [anon_sym_LR_DQUOTE] = ACTIONS(3595),
    [anon_sym_uR_DQUOTE] = ACTIONS(3595),
    [anon_sym_UR_DQUOTE] = ACTIONS(3595),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3595),
    [anon_sym_co_await] = ACTIONS(3593),
    [anon_sym_new] = ACTIONS(3593),
    [anon_sym_requires] = ACTIONS(3593),
    [sym_this] = ACTIONS(3593),
    [anon_sym_discard] = ACTIONS(3593),
    [anon_sym_precise] = ACTIONS(3593),
    [anon_sym_shared] = ACTIONS(3593),
    [anon_sym_groupshared] = ACTIONS(3593),
    [anon_sym_uniform] = ACTIONS(3593),
    [anon_sym_row_major] = ACTIONS(3593),
    [anon_sym_column_major] = ACTIONS(3593),
    [anon_sym_globallycoherent] = ACTIONS(3593),
    [anon_sym_centroid] = ACTIONS(3593),
    [anon_sym_noperspective] = ACTIONS(3593),
    [anon_sym_nointerpolation] = ACTIONS(3593),
    [anon_sym_sample] = ACTIONS(3593),
    [anon_sym_linear] = ACTIONS(3593),
    [anon_sym_snorm] = ACTIONS(3593),
    [anon_sym_unorm] = ACTIONS(3593),
    [anon_sym_point] = ACTIONS(3593),
    [anon_sym_line] = ACTIONS(3593),
    [anon_sym_triangleadj] = ACTIONS(3593),
    [anon_sym_lineadj] = ACTIONS(3593),
    [anon_sym_triangle] = ACTIONS(3593),
    [anon_sym_cbuffer] = ACTIONS(3593),
    [anon_sym_interface] = ACTIONS(3593),
    [anon_sym_extension] = ACTIONS(3593),
  },
  [457] = {
    [sym_identifier] = ACTIONS(3456),
    [aux_sym_preproc_include_token1] = ACTIONS(3456),
    [aux_sym_preproc_def_token1] = ACTIONS(3456),
    [aux_sym_preproc_if_token1] = ACTIONS(3456),
    [aux_sym_preproc_if_token2] = ACTIONS(3456),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3456),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3456),
    [aux_sym_preproc_else_token1] = ACTIONS(3456),
    [aux_sym_preproc_elif_token1] = ACTIONS(3456),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3456),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3456),
    [sym_preproc_directive] = ACTIONS(3456),
    [anon_sym_LPAREN2] = ACTIONS(3454),
    [anon_sym_BANG] = ACTIONS(3454),
    [anon_sym_TILDE] = ACTIONS(3454),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3454),
    [anon_sym_AMP_AMP] = ACTIONS(3454),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_SEMI] = ACTIONS(3454),
    [anon_sym___extension__] = ACTIONS(3456),
    [anon_sym_typedef] = ACTIONS(3456),
    [anon_sym_in] = ACTIONS(3456),
    [anon_sym_out] = ACTIONS(3456),
    [anon_sym_inout] = ACTIONS(3456),
    [anon_sym_virtual] = ACTIONS(3456),
    [anon_sym_extern] = ACTIONS(3456),
    [anon_sym___attribute__] = ACTIONS(3456),
    [anon_sym___attribute] = ACTIONS(3456),
    [anon_sym_using] = ACTIONS(3456),
    [anon_sym_COLON_COLON] = ACTIONS(3454),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3454),
    [anon_sym___declspec] = ACTIONS(3456),
    [anon_sym___based] = ACTIONS(3456),
    [anon_sym___cdecl] = ACTIONS(3456),
    [anon_sym___clrcall] = ACTIONS(3456),
    [anon_sym___stdcall] = ACTIONS(3456),
    [anon_sym___fastcall] = ACTIONS(3456),
    [anon_sym___thiscall] = ACTIONS(3456),
    [anon_sym___vectorcall] = ACTIONS(3456),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_signed] = ACTIONS(3456),
    [anon_sym_unsigned] = ACTIONS(3456),
    [anon_sym_long] = ACTIONS(3456),
    [anon_sym_short] = ACTIONS(3456),
    [anon_sym_LBRACK] = ACTIONS(3456),
    [anon_sym_static] = ACTIONS(3456),
    [anon_sym_register] = ACTIONS(3456),
    [anon_sym_inline] = ACTIONS(3456),
    [anon_sym___inline] = ACTIONS(3456),
    [anon_sym___inline__] = ACTIONS(3456),
    [anon_sym___forceinline] = ACTIONS(3456),
    [anon_sym_thread_local] = ACTIONS(3456),
    [anon_sym___thread] = ACTIONS(3456),
    [anon_sym_const] = ACTIONS(3456),
    [anon_sym_constexpr] = ACTIONS(3456),
    [anon_sym_volatile] = ACTIONS(3456),
    [anon_sym_restrict] = ACTIONS(3456),
    [anon_sym___restrict__] = ACTIONS(3456),
    [anon_sym__Atomic] = ACTIONS(3456),
    [anon_sym__Noreturn] = ACTIONS(3456),
    [anon_sym_noreturn] = ACTIONS(3456),
    [anon_sym__Nonnull] = ACTIONS(3456),
    [anon_sym_mutable] = ACTIONS(3456),
    [anon_sym_constinit] = ACTIONS(3456),
    [anon_sym_consteval] = ACTIONS(3456),
    [anon_sym_alignas] = ACTIONS(3456),
    [anon_sym__Alignas] = ACTIONS(3456),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_enum] = ACTIONS(3456),
    [anon_sym_class] = ACTIONS(3456),
    [anon_sym_struct] = ACTIONS(3456),
    [anon_sym_union] = ACTIONS(3456),
    [anon_sym_if] = ACTIONS(3456),
    [anon_sym_else] = ACTIONS(3456),
    [anon_sym_switch] = ACTIONS(3456),
    [anon_sym_case] = ACTIONS(3456),
    [anon_sym_default] = ACTIONS(3456),
    [anon_sym_while] = ACTIONS(3456),
    [anon_sym_do] = ACTIONS(3456),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_return] = ACTIONS(3456),
    [anon_sym_break] = ACTIONS(3456),
    [anon_sym_continue] = ACTIONS(3456),
    [anon_sym_goto] = ACTIONS(3456),
    [anon_sym___try] = ACTIONS(3456),
    [anon_sym___leave] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(3456),
    [anon_sym_compl] = ACTIONS(3456),
    [anon_sym_DASH_DASH] = ACTIONS(3454),
    [anon_sym_PLUS_PLUS] = ACTIONS(3454),
    [anon_sym_sizeof] = ACTIONS(3456),
    [anon_sym___alignof__] = ACTIONS(3456),
    [anon_sym___alignof] = ACTIONS(3456),
    [anon_sym__alignof] = ACTIONS(3456),
    [anon_sym_alignof] = ACTIONS(3456),
    [anon_sym__Alignof] = ACTIONS(3456),
    [anon_sym_offsetof] = ACTIONS(3456),
    [anon_sym__Generic] = ACTIONS(3456),
    [anon_sym_asm] = ACTIONS(3456),
    [anon_sym___asm__] = ACTIONS(3456),
    [anon_sym___asm] = ACTIONS(3456),
    [sym_number_literal] = ACTIONS(3454),
    [anon_sym_L_SQUOTE] = ACTIONS(3454),
    [anon_sym_u_SQUOTE] = ACTIONS(3454),
    [anon_sym_U_SQUOTE] = ACTIONS(3454),
    [anon_sym_u8_SQUOTE] = ACTIONS(3454),
    [anon_sym_SQUOTE] = ACTIONS(3454),
    [anon_sym_L_DQUOTE] = ACTIONS(3454),
    [anon_sym_u_DQUOTE] = ACTIONS(3454),
    [anon_sym_U_DQUOTE] = ACTIONS(3454),
    [anon_sym_u8_DQUOTE] = ACTIONS(3454),
    [anon_sym_DQUOTE] = ACTIONS(3454),
    [sym_true] = ACTIONS(3456),
    [sym_false] = ACTIONS(3456),
    [anon_sym_NULL] = ACTIONS(3456),
    [anon_sym_nullptr] = ACTIONS(3456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3456),
    [anon_sym_let] = ACTIONS(3456),
    [anon_sym_This] = ACTIONS(3456),
    [anon_sym_decltype] = ACTIONS(3456),
    [anon_sym_explicit] = ACTIONS(3456),
    [anon_sym_typename] = ACTIONS(3456),
    [anon_sym_template] = ACTIONS(3456),
    [anon_sym_operator] = ACTIONS(3456),
    [anon_sym_try] = ACTIONS(3456),
    [anon_sym_delete] = ACTIONS(3456),
    [anon_sym_throw] = ACTIONS(3456),
    [anon_sym_namespace] = ACTIONS(3456),
    [anon_sym_static_assert] = ACTIONS(3456),
    [anon_sym_concept] = ACTIONS(3456),
    [anon_sym_co_return] = ACTIONS(3456),
    [anon_sym_co_yield] = ACTIONS(3456),
    [anon_sym_R_DQUOTE] = ACTIONS(3454),
    [anon_sym_LR_DQUOTE] = ACTIONS(3454),
    [anon_sym_uR_DQUOTE] = ACTIONS(3454),
    [anon_sym_UR_DQUOTE] = ACTIONS(3454),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3454),
    [anon_sym_co_await] = ACTIONS(3456),
    [anon_sym_new] = ACTIONS(3456),
    [anon_sym_requires] = ACTIONS(3456),
    [sym_this] = ACTIONS(3456),
    [anon_sym_discard] = ACTIONS(3456),
    [anon_sym_precise] = ACTIONS(3456),
    [anon_sym_shared] = ACTIONS(3456),
    [anon_sym_groupshared] = ACTIONS(3456),
    [anon_sym_uniform] = ACTIONS(3456),
    [anon_sym_row_major] = ACTIONS(3456),
    [anon_sym_column_major] = ACTIONS(3456),
    [anon_sym_globallycoherent] = ACTIONS(3456),
    [anon_sym_centroid] = ACTIONS(3456),
    [anon_sym_noperspective] = ACTIONS(3456),
    [anon_sym_nointerpolation] = ACTIONS(3456),
    [anon_sym_sample] = ACTIONS(3456),
    [anon_sym_linear] = ACTIONS(3456),
    [anon_sym_snorm] = ACTIONS(3456),
    [anon_sym_unorm] = ACTIONS(3456),
    [anon_sym_point] = ACTIONS(3456),
    [anon_sym_line] = ACTIONS(3456),
    [anon_sym_triangleadj] = ACTIONS(3456),
    [anon_sym_lineadj] = ACTIONS(3456),
    [anon_sym_triangle] = ACTIONS(3456),
    [anon_sym_cbuffer] = ACTIONS(3456),
    [anon_sym_interface] = ACTIONS(3456),
    [anon_sym_extension] = ACTIONS(3456),
  },
  [458] = {
    [sym_identifier] = ACTIONS(3520),
    [aux_sym_preproc_include_token1] = ACTIONS(3520),
    [aux_sym_preproc_def_token1] = ACTIONS(3520),
    [aux_sym_preproc_if_token1] = ACTIONS(3520),
    [aux_sym_preproc_if_token2] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3520),
    [aux_sym_preproc_else_token1] = ACTIONS(3520),
    [aux_sym_preproc_elif_token1] = ACTIONS(3520),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3520),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3520),
    [sym_preproc_directive] = ACTIONS(3520),
    [anon_sym_LPAREN2] = ACTIONS(3518),
    [anon_sym_BANG] = ACTIONS(3518),
    [anon_sym_TILDE] = ACTIONS(3518),
    [anon_sym_DASH] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3520),
    [anon_sym_STAR] = ACTIONS(3518),
    [anon_sym_AMP_AMP] = ACTIONS(3518),
    [anon_sym_AMP] = ACTIONS(3520),
    [anon_sym_SEMI] = ACTIONS(3518),
    [anon_sym___extension__] = ACTIONS(3520),
    [anon_sym_typedef] = ACTIONS(3520),
    [anon_sym_in] = ACTIONS(3520),
    [anon_sym_out] = ACTIONS(3520),
    [anon_sym_inout] = ACTIONS(3520),
    [anon_sym_virtual] = ACTIONS(3520),
    [anon_sym_extern] = ACTIONS(3520),
    [anon_sym___attribute__] = ACTIONS(3520),
    [anon_sym___attribute] = ACTIONS(3520),
    [anon_sym_using] = ACTIONS(3520),
    [anon_sym_COLON_COLON] = ACTIONS(3518),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3518),
    [anon_sym___declspec] = ACTIONS(3520),
    [anon_sym___based] = ACTIONS(3520),
    [anon_sym___cdecl] = ACTIONS(3520),
    [anon_sym___clrcall] = ACTIONS(3520),
    [anon_sym___stdcall] = ACTIONS(3520),
    [anon_sym___fastcall] = ACTIONS(3520),
    [anon_sym___thiscall] = ACTIONS(3520),
    [anon_sym___vectorcall] = ACTIONS(3520),
    [anon_sym_LBRACE] = ACTIONS(3518),
    [anon_sym_signed] = ACTIONS(3520),
    [anon_sym_unsigned] = ACTIONS(3520),
    [anon_sym_long] = ACTIONS(3520),
    [anon_sym_short] = ACTIONS(3520),
    [anon_sym_LBRACK] = ACTIONS(3520),
    [anon_sym_static] = ACTIONS(3520),
    [anon_sym_register] = ACTIONS(3520),
    [anon_sym_inline] = ACTIONS(3520),
    [anon_sym___inline] = ACTIONS(3520),
    [anon_sym___inline__] = ACTIONS(3520),
    [anon_sym___forceinline] = ACTIONS(3520),
    [anon_sym_thread_local] = ACTIONS(3520),
    [anon_sym___thread] = ACTIONS(3520),
    [anon_sym_const] = ACTIONS(3520),
    [anon_sym_constexpr] = ACTIONS(3520),
    [anon_sym_volatile] = ACTIONS(3520),
    [anon_sym_restrict] = ACTIONS(3520),
    [anon_sym___restrict__] = ACTIONS(3520),
    [anon_sym__Atomic] = ACTIONS(3520),
    [anon_sym__Noreturn] = ACTIONS(3520),
    [anon_sym_noreturn] = ACTIONS(3520),
    [anon_sym__Nonnull] = ACTIONS(3520),
    [anon_sym_mutable] = ACTIONS(3520),
    [anon_sym_constinit] = ACTIONS(3520),
    [anon_sym_consteval] = ACTIONS(3520),
    [anon_sym_alignas] = ACTIONS(3520),
    [anon_sym__Alignas] = ACTIONS(3520),
    [sym_primitive_type] = ACTIONS(3520),
    [anon_sym_enum] = ACTIONS(3520),
    [anon_sym_class] = ACTIONS(3520),
    [anon_sym_struct] = ACTIONS(3520),
    [anon_sym_union] = ACTIONS(3520),
    [anon_sym_if] = ACTIONS(3520),
    [anon_sym_else] = ACTIONS(3520),
    [anon_sym_switch] = ACTIONS(3520),
    [anon_sym_case] = ACTIONS(3520),
    [anon_sym_default] = ACTIONS(3520),
    [anon_sym_while] = ACTIONS(3520),
    [anon_sym_do] = ACTIONS(3520),
    [anon_sym_for] = ACTIONS(3520),
    [anon_sym_return] = ACTIONS(3520),
    [anon_sym_break] = ACTIONS(3520),
    [anon_sym_continue] = ACTIONS(3520),
    [anon_sym_goto] = ACTIONS(3520),
    [anon_sym___try] = ACTIONS(3520),
    [anon_sym___leave] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3520),
    [anon_sym_compl] = ACTIONS(3520),
    [anon_sym_DASH_DASH] = ACTIONS(3518),
    [anon_sym_PLUS_PLUS] = ACTIONS(3518),
    [anon_sym_sizeof] = ACTIONS(3520),
    [anon_sym___alignof__] = ACTIONS(3520),
    [anon_sym___alignof] = ACTIONS(3520),
    [anon_sym__alignof] = ACTIONS(3520),
    [anon_sym_alignof] = ACTIONS(3520),
    [anon_sym__Alignof] = ACTIONS(3520),
    [anon_sym_offsetof] = ACTIONS(3520),
    [anon_sym__Generic] = ACTIONS(3520),
    [anon_sym_asm] = ACTIONS(3520),
    [anon_sym___asm__] = ACTIONS(3520),
    [anon_sym___asm] = ACTIONS(3520),
    [sym_number_literal] = ACTIONS(3518),
    [anon_sym_L_SQUOTE] = ACTIONS(3518),
    [anon_sym_u_SQUOTE] = ACTIONS(3518),
    [anon_sym_U_SQUOTE] = ACTIONS(3518),
    [anon_sym_u8_SQUOTE] = ACTIONS(3518),
    [anon_sym_SQUOTE] = ACTIONS(3518),
    [anon_sym_L_DQUOTE] = ACTIONS(3518),
    [anon_sym_u_DQUOTE] = ACTIONS(3518),
    [anon_sym_U_DQUOTE] = ACTIONS(3518),
    [anon_sym_u8_DQUOTE] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(3518),
    [sym_true] = ACTIONS(3520),
    [sym_false] = ACTIONS(3520),
    [anon_sym_NULL] = ACTIONS(3520),
    [anon_sym_nullptr] = ACTIONS(3520),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3520),
    [anon_sym_let] = ACTIONS(3520),
    [anon_sym_This] = ACTIONS(3520),
    [anon_sym_decltype] = ACTIONS(3520),
    [anon_sym_explicit] = ACTIONS(3520),
    [anon_sym_typename] = ACTIONS(3520),
    [anon_sym_template] = ACTIONS(3520),
    [anon_sym_operator] = ACTIONS(3520),
    [anon_sym_try] = ACTIONS(3520),
    [anon_sym_delete] = ACTIONS(3520),
    [anon_sym_throw] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3520),
    [anon_sym_static_assert] = ACTIONS(3520),
    [anon_sym_concept] = ACTIONS(3520),
    [anon_sym_co_return] = ACTIONS(3520),
    [anon_sym_co_yield] = ACTIONS(3520),
    [anon_sym_R_DQUOTE] = ACTIONS(3518),
    [anon_sym_LR_DQUOTE] = ACTIONS(3518),
    [anon_sym_uR_DQUOTE] = ACTIONS(3518),
    [anon_sym_UR_DQUOTE] = ACTIONS(3518),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3518),
    [anon_sym_co_await] = ACTIONS(3520),
    [anon_sym_new] = ACTIONS(3520),
    [anon_sym_requires] = ACTIONS(3520),
    [sym_this] = ACTIONS(3520),
    [anon_sym_discard] = ACTIONS(3520),
    [anon_sym_precise] = ACTIONS(3520),
    [anon_sym_shared] = ACTIONS(3520),
    [anon_sym_groupshared] = ACTIONS(3520),
    [anon_sym_uniform] = ACTIONS(3520),
    [anon_sym_row_major] = ACTIONS(3520),
    [anon_sym_column_major] = ACTIONS(3520),
    [anon_sym_globallycoherent] = ACTIONS(3520),
    [anon_sym_centroid] = ACTIONS(3520),
    [anon_sym_noperspective] = ACTIONS(3520),
    [anon_sym_nointerpolation] = ACTIONS(3520),
    [anon_sym_sample] = ACTIONS(3520),
    [anon_sym_linear] = ACTIONS(3520),
    [anon_sym_snorm] = ACTIONS(3520),
    [anon_sym_unorm] = ACTIONS(3520),
    [anon_sym_point] = ACTIONS(3520),
    [anon_sym_line] = ACTIONS(3520),
    [anon_sym_triangleadj] = ACTIONS(3520),
    [anon_sym_lineadj] = ACTIONS(3520),
    [anon_sym_triangle] = ACTIONS(3520),
    [anon_sym_cbuffer] = ACTIONS(3520),
    [anon_sym_interface] = ACTIONS(3520),
    [anon_sym_extension] = ACTIONS(3520),
  },
  [459] = {
    [sym_identifier] = ACTIONS(3597),
    [aux_sym_preproc_include_token1] = ACTIONS(3597),
    [aux_sym_preproc_def_token1] = ACTIONS(3597),
    [aux_sym_preproc_if_token1] = ACTIONS(3597),
    [aux_sym_preproc_if_token2] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3597),
    [aux_sym_preproc_else_token1] = ACTIONS(3597),
    [aux_sym_preproc_elif_token1] = ACTIONS(3597),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3597),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3597),
    [sym_preproc_directive] = ACTIONS(3597),
    [anon_sym_LPAREN2] = ACTIONS(3599),
    [anon_sym_BANG] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3599),
    [anon_sym_DASH] = ACTIONS(3597),
    [anon_sym_PLUS] = ACTIONS(3597),
    [anon_sym_STAR] = ACTIONS(3599),
    [anon_sym_AMP_AMP] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3597),
    [anon_sym_SEMI] = ACTIONS(3599),
    [anon_sym___extension__] = ACTIONS(3597),
    [anon_sym_typedef] = ACTIONS(3597),
    [anon_sym_in] = ACTIONS(3597),
    [anon_sym_out] = ACTIONS(3597),
    [anon_sym_inout] = ACTIONS(3597),
    [anon_sym_virtual] = ACTIONS(3597),
    [anon_sym_extern] = ACTIONS(3597),
    [anon_sym___attribute__] = ACTIONS(3597),
    [anon_sym___attribute] = ACTIONS(3597),
    [anon_sym_using] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3599),
    [anon_sym___declspec] = ACTIONS(3597),
    [anon_sym___based] = ACTIONS(3597),
    [anon_sym___cdecl] = ACTIONS(3597),
    [anon_sym___clrcall] = ACTIONS(3597),
    [anon_sym___stdcall] = ACTIONS(3597),
    [anon_sym___fastcall] = ACTIONS(3597),
    [anon_sym___thiscall] = ACTIONS(3597),
    [anon_sym___vectorcall] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(3599),
    [anon_sym_signed] = ACTIONS(3597),
    [anon_sym_unsigned] = ACTIONS(3597),
    [anon_sym_long] = ACTIONS(3597),
    [anon_sym_short] = ACTIONS(3597),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_static] = ACTIONS(3597),
    [anon_sym_register] = ACTIONS(3597),
    [anon_sym_inline] = ACTIONS(3597),
    [anon_sym___inline] = ACTIONS(3597),
    [anon_sym___inline__] = ACTIONS(3597),
    [anon_sym___forceinline] = ACTIONS(3597),
    [anon_sym_thread_local] = ACTIONS(3597),
    [anon_sym___thread] = ACTIONS(3597),
    [anon_sym_const] = ACTIONS(3597),
    [anon_sym_constexpr] = ACTIONS(3597),
    [anon_sym_volatile] = ACTIONS(3597),
    [anon_sym_restrict] = ACTIONS(3597),
    [anon_sym___restrict__] = ACTIONS(3597),
    [anon_sym__Atomic] = ACTIONS(3597),
    [anon_sym__Noreturn] = ACTIONS(3597),
    [anon_sym_noreturn] = ACTIONS(3597),
    [anon_sym__Nonnull] = ACTIONS(3597),
    [anon_sym_mutable] = ACTIONS(3597),
    [anon_sym_constinit] = ACTIONS(3597),
    [anon_sym_consteval] = ACTIONS(3597),
    [anon_sym_alignas] = ACTIONS(3597),
    [anon_sym__Alignas] = ACTIONS(3597),
    [sym_primitive_type] = ACTIONS(3597),
    [anon_sym_enum] = ACTIONS(3597),
    [anon_sym_class] = ACTIONS(3597),
    [anon_sym_struct] = ACTIONS(3597),
    [anon_sym_union] = ACTIONS(3597),
    [anon_sym_if] = ACTIONS(3597),
    [anon_sym_else] = ACTIONS(3597),
    [anon_sym_switch] = ACTIONS(3597),
    [anon_sym_case] = ACTIONS(3597),
    [anon_sym_default] = ACTIONS(3597),
    [anon_sym_while] = ACTIONS(3597),
    [anon_sym_do] = ACTIONS(3597),
    [anon_sym_for] = ACTIONS(3597),
    [anon_sym_return] = ACTIONS(3597),
    [anon_sym_break] = ACTIONS(3597),
    [anon_sym_continue] = ACTIONS(3597),
    [anon_sym_goto] = ACTIONS(3597),
    [anon_sym___try] = ACTIONS(3597),
    [anon_sym___leave] = ACTIONS(3597),
    [anon_sym_not] = ACTIONS(3597),
    [anon_sym_compl] = ACTIONS(3597),
    [anon_sym_DASH_DASH] = ACTIONS(3599),
    [anon_sym_PLUS_PLUS] = ACTIONS(3599),
    [anon_sym_sizeof] = ACTIONS(3597),
    [anon_sym___alignof__] = ACTIONS(3597),
    [anon_sym___alignof] = ACTIONS(3597),
    [anon_sym__alignof] = ACTIONS(3597),
    [anon_sym_alignof] = ACTIONS(3597),
    [anon_sym__Alignof] = ACTIONS(3597),
    [anon_sym_offsetof] = ACTIONS(3597),
    [anon_sym__Generic] = ACTIONS(3597),
    [anon_sym_asm] = ACTIONS(3597),
    [anon_sym___asm__] = ACTIONS(3597),
    [anon_sym___asm] = ACTIONS(3597),
    [sym_number_literal] = ACTIONS(3599),
    [anon_sym_L_SQUOTE] = ACTIONS(3599),
    [anon_sym_u_SQUOTE] = ACTIONS(3599),
    [anon_sym_U_SQUOTE] = ACTIONS(3599),
    [anon_sym_u8_SQUOTE] = ACTIONS(3599),
    [anon_sym_SQUOTE] = ACTIONS(3599),
    [anon_sym_L_DQUOTE] = ACTIONS(3599),
    [anon_sym_u_DQUOTE] = ACTIONS(3599),
    [anon_sym_U_DQUOTE] = ACTIONS(3599),
    [anon_sym_u8_DQUOTE] = ACTIONS(3599),
    [anon_sym_DQUOTE] = ACTIONS(3599),
    [sym_true] = ACTIONS(3597),
    [sym_false] = ACTIONS(3597),
    [anon_sym_NULL] = ACTIONS(3597),
    [anon_sym_nullptr] = ACTIONS(3597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3597),
    [anon_sym_let] = ACTIONS(3597),
    [anon_sym_This] = ACTIONS(3597),
    [anon_sym_decltype] = ACTIONS(3597),
    [anon_sym_explicit] = ACTIONS(3597),
    [anon_sym_typename] = ACTIONS(3597),
    [anon_sym_template] = ACTIONS(3597),
    [anon_sym_operator] = ACTIONS(3597),
    [anon_sym_try] = ACTIONS(3597),
    [anon_sym_delete] = ACTIONS(3597),
    [anon_sym_throw] = ACTIONS(3597),
    [anon_sym_namespace] = ACTIONS(3597),
    [anon_sym_static_assert] = ACTIONS(3597),
    [anon_sym_concept] = ACTIONS(3597),
    [anon_sym_co_return] = ACTIONS(3597),
    [anon_sym_co_yield] = ACTIONS(3597),
    [anon_sym_R_DQUOTE] = ACTIONS(3599),
    [anon_sym_LR_DQUOTE] = ACTIONS(3599),
    [anon_sym_uR_DQUOTE] = ACTIONS(3599),
    [anon_sym_UR_DQUOTE] = ACTIONS(3599),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3599),
    [anon_sym_co_await] = ACTIONS(3597),
    [anon_sym_new] = ACTIONS(3597),
    [anon_sym_requires] = ACTIONS(3597),
    [sym_this] = ACTIONS(3597),
    [anon_sym_discard] = ACTIONS(3597),
    [anon_sym_precise] = ACTIONS(3597),
    [anon_sym_shared] = ACTIONS(3597),
    [anon_sym_groupshared] = ACTIONS(3597),
    [anon_sym_uniform] = ACTIONS(3597),
    [anon_sym_row_major] = ACTIONS(3597),
    [anon_sym_column_major] = ACTIONS(3597),
    [anon_sym_globallycoherent] = ACTIONS(3597),
    [anon_sym_centroid] = ACTIONS(3597),
    [anon_sym_noperspective] = ACTIONS(3597),
    [anon_sym_nointerpolation] = ACTIONS(3597),
    [anon_sym_sample] = ACTIONS(3597),
    [anon_sym_linear] = ACTIONS(3597),
    [anon_sym_snorm] = ACTIONS(3597),
    [anon_sym_unorm] = ACTIONS(3597),
    [anon_sym_point] = ACTIONS(3597),
    [anon_sym_line] = ACTIONS(3597),
    [anon_sym_triangleadj] = ACTIONS(3597),
    [anon_sym_lineadj] = ACTIONS(3597),
    [anon_sym_triangle] = ACTIONS(3597),
    [anon_sym_cbuffer] = ACTIONS(3597),
    [anon_sym_interface] = ACTIONS(3597),
    [anon_sym_extension] = ACTIONS(3597),
  },
  [460] = {
    [ts_builtin_sym_end] = ACTIONS(3601),
    [sym_identifier] = ACTIONS(3603),
    [aux_sym_preproc_include_token1] = ACTIONS(3603),
    [aux_sym_preproc_def_token1] = ACTIONS(3603),
    [aux_sym_preproc_if_token1] = ACTIONS(3603),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3603),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3603),
    [sym_preproc_directive] = ACTIONS(3603),
    [anon_sym_LPAREN2] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3601),
    [anon_sym_TILDE] = ACTIONS(3601),
    [anon_sym_DASH] = ACTIONS(3603),
    [anon_sym_PLUS] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(3601),
    [anon_sym_AMP_AMP] = ACTIONS(3601),
    [anon_sym_AMP] = ACTIONS(3603),
    [anon_sym_SEMI] = ACTIONS(3601),
    [anon_sym___extension__] = ACTIONS(3603),
    [anon_sym_typedef] = ACTIONS(3603),
    [anon_sym_in] = ACTIONS(3603),
    [anon_sym_out] = ACTIONS(3603),
    [anon_sym_inout] = ACTIONS(3603),
    [anon_sym_virtual] = ACTIONS(3603),
    [anon_sym_extern] = ACTIONS(3603),
    [anon_sym___attribute__] = ACTIONS(3603),
    [anon_sym___attribute] = ACTIONS(3603),
    [anon_sym_using] = ACTIONS(3603),
    [anon_sym_COLON_COLON] = ACTIONS(3601),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3601),
    [anon_sym___declspec] = ACTIONS(3603),
    [anon_sym___based] = ACTIONS(3603),
    [anon_sym___cdecl] = ACTIONS(3603),
    [anon_sym___clrcall] = ACTIONS(3603),
    [anon_sym___stdcall] = ACTIONS(3603),
    [anon_sym___fastcall] = ACTIONS(3603),
    [anon_sym___thiscall] = ACTIONS(3603),
    [anon_sym___vectorcall] = ACTIONS(3603),
    [anon_sym_LBRACE] = ACTIONS(3601),
    [anon_sym_signed] = ACTIONS(3603),
    [anon_sym_unsigned] = ACTIONS(3603),
    [anon_sym_long] = ACTIONS(3603),
    [anon_sym_short] = ACTIONS(3603),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_static] = ACTIONS(3603),
    [anon_sym_register] = ACTIONS(3603),
    [anon_sym_inline] = ACTIONS(3603),
    [anon_sym___inline] = ACTIONS(3603),
    [anon_sym___inline__] = ACTIONS(3603),
    [anon_sym___forceinline] = ACTIONS(3603),
    [anon_sym_thread_local] = ACTIONS(3603),
    [anon_sym___thread] = ACTIONS(3603),
    [anon_sym_const] = ACTIONS(3603),
    [anon_sym_constexpr] = ACTIONS(3603),
    [anon_sym_volatile] = ACTIONS(3603),
    [anon_sym_restrict] = ACTIONS(3603),
    [anon_sym___restrict__] = ACTIONS(3603),
    [anon_sym__Atomic] = ACTIONS(3603),
    [anon_sym__Noreturn] = ACTIONS(3603),
    [anon_sym_noreturn] = ACTIONS(3603),
    [anon_sym__Nonnull] = ACTIONS(3603),
    [anon_sym_mutable] = ACTIONS(3603),
    [anon_sym_constinit] = ACTIONS(3603),
    [anon_sym_consteval] = ACTIONS(3603),
    [anon_sym_alignas] = ACTIONS(3603),
    [anon_sym__Alignas] = ACTIONS(3603),
    [sym_primitive_type] = ACTIONS(3603),
    [anon_sym_enum] = ACTIONS(3603),
    [anon_sym_class] = ACTIONS(3603),
    [anon_sym_struct] = ACTIONS(3603),
    [anon_sym_union] = ACTIONS(3603),
    [anon_sym_if] = ACTIONS(3603),
    [anon_sym_else] = ACTIONS(3603),
    [anon_sym_switch] = ACTIONS(3603),
    [anon_sym_case] = ACTIONS(3603),
    [anon_sym_default] = ACTIONS(3603),
    [anon_sym_while] = ACTIONS(3603),
    [anon_sym_do] = ACTIONS(3603),
    [anon_sym_for] = ACTIONS(3603),
    [anon_sym_return] = ACTIONS(3603),
    [anon_sym_break] = ACTIONS(3603),
    [anon_sym_continue] = ACTIONS(3603),
    [anon_sym_goto] = ACTIONS(3603),
    [anon_sym___try] = ACTIONS(3603),
    [anon_sym___leave] = ACTIONS(3603),
    [anon_sym_not] = ACTIONS(3603),
    [anon_sym_compl] = ACTIONS(3603),
    [anon_sym_DASH_DASH] = ACTIONS(3601),
    [anon_sym_PLUS_PLUS] = ACTIONS(3601),
    [anon_sym_sizeof] = ACTIONS(3603),
    [anon_sym___alignof__] = ACTIONS(3603),
    [anon_sym___alignof] = ACTIONS(3603),
    [anon_sym__alignof] = ACTIONS(3603),
    [anon_sym_alignof] = ACTIONS(3603),
    [anon_sym__Alignof] = ACTIONS(3603),
    [anon_sym_offsetof] = ACTIONS(3603),
    [anon_sym__Generic] = ACTIONS(3603),
    [anon_sym_asm] = ACTIONS(3603),
    [anon_sym___asm__] = ACTIONS(3603),
    [anon_sym___asm] = ACTIONS(3603),
    [sym_number_literal] = ACTIONS(3601),
    [anon_sym_L_SQUOTE] = ACTIONS(3601),
    [anon_sym_u_SQUOTE] = ACTIONS(3601),
    [anon_sym_U_SQUOTE] = ACTIONS(3601),
    [anon_sym_u8_SQUOTE] = ACTIONS(3601),
    [anon_sym_SQUOTE] = ACTIONS(3601),
    [anon_sym_L_DQUOTE] = ACTIONS(3601),
    [anon_sym_u_DQUOTE] = ACTIONS(3601),
    [anon_sym_U_DQUOTE] = ACTIONS(3601),
    [anon_sym_u8_DQUOTE] = ACTIONS(3601),
    [anon_sym_DQUOTE] = ACTIONS(3601),
    [sym_true] = ACTIONS(3603),
    [sym_false] = ACTIONS(3603),
    [anon_sym_NULL] = ACTIONS(3603),
    [anon_sym_nullptr] = ACTIONS(3603),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3603),
    [anon_sym_let] = ACTIONS(3603),
    [anon_sym_This] = ACTIONS(3603),
    [anon_sym_decltype] = ACTIONS(3603),
    [anon_sym_explicit] = ACTIONS(3603),
    [anon_sym_typename] = ACTIONS(3603),
    [anon_sym_export] = ACTIONS(3603),
    [anon_sym_module] = ACTIONS(3603),
    [anon_sym_import] = ACTIONS(3603),
    [anon_sym_template] = ACTIONS(3603),
    [anon_sym_operator] = ACTIONS(3603),
    [anon_sym_try] = ACTIONS(3603),
    [anon_sym_delete] = ACTIONS(3603),
    [anon_sym_throw] = ACTIONS(3603),
    [anon_sym_namespace] = ACTIONS(3603),
    [anon_sym_static_assert] = ACTIONS(3603),
    [anon_sym_concept] = ACTIONS(3603),
    [anon_sym_co_return] = ACTIONS(3603),
    [anon_sym_co_yield] = ACTIONS(3603),
    [anon_sym_R_DQUOTE] = ACTIONS(3601),
    [anon_sym_LR_DQUOTE] = ACTIONS(3601),
    [anon_sym_uR_DQUOTE] = ACTIONS(3601),
    [anon_sym_UR_DQUOTE] = ACTIONS(3601),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3601),
    [anon_sym_co_await] = ACTIONS(3603),
    [anon_sym_new] = ACTIONS(3603),
    [anon_sym_requires] = ACTIONS(3603),
    [sym_this] = ACTIONS(3603),
    [anon_sym_discard] = ACTIONS(3603),
    [anon_sym_precise] = ACTIONS(3603),
    [anon_sym_shared] = ACTIONS(3603),
    [anon_sym_groupshared] = ACTIONS(3603),
    [anon_sym_uniform] = ACTIONS(3603),
    [anon_sym_row_major] = ACTIONS(3603),
    [anon_sym_column_major] = ACTIONS(3603),
    [anon_sym_globallycoherent] = ACTIONS(3603),
    [anon_sym_centroid] = ACTIONS(3603),
    [anon_sym_noperspective] = ACTIONS(3603),
    [anon_sym_nointerpolation] = ACTIONS(3603),
    [anon_sym_sample] = ACTIONS(3603),
    [anon_sym_linear] = ACTIONS(3603),
    [anon_sym_snorm] = ACTIONS(3603),
    [anon_sym_unorm] = ACTIONS(3603),
    [anon_sym_point] = ACTIONS(3603),
    [anon_sym_line] = ACTIONS(3603),
    [anon_sym_triangleadj] = ACTIONS(3603),
    [anon_sym_lineadj] = ACTIONS(3603),
    [anon_sym_triangle] = ACTIONS(3603),
    [anon_sym_cbuffer] = ACTIONS(3603),
    [anon_sym_interface] = ACTIONS(3603),
    [anon_sym_extension] = ACTIONS(3603),
    [anon_sym___exported] = ACTIONS(3603),
  },
  [461] = {
    [ts_builtin_sym_end] = ACTIONS(3605),
    [sym_identifier] = ACTIONS(3607),
    [aux_sym_preproc_include_token1] = ACTIONS(3607),
    [aux_sym_preproc_def_token1] = ACTIONS(3607),
    [aux_sym_preproc_if_token1] = ACTIONS(3607),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3607),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3607),
    [sym_preproc_directive] = ACTIONS(3607),
    [anon_sym_LPAREN2] = ACTIONS(3605),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(3605),
    [anon_sym_AMP_AMP] = ACTIONS(3605),
    [anon_sym_AMP] = ACTIONS(3607),
    [anon_sym_SEMI] = ACTIONS(3605),
    [anon_sym___extension__] = ACTIONS(3607),
    [anon_sym_typedef] = ACTIONS(3607),
    [anon_sym_in] = ACTIONS(3607),
    [anon_sym_out] = ACTIONS(3607),
    [anon_sym_inout] = ACTIONS(3607),
    [anon_sym_virtual] = ACTIONS(3607),
    [anon_sym_extern] = ACTIONS(3607),
    [anon_sym___attribute__] = ACTIONS(3607),
    [anon_sym___attribute] = ACTIONS(3607),
    [anon_sym_using] = ACTIONS(3607),
    [anon_sym_COLON_COLON] = ACTIONS(3605),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3605),
    [anon_sym___declspec] = ACTIONS(3607),
    [anon_sym___based] = ACTIONS(3607),
    [anon_sym___cdecl] = ACTIONS(3607),
    [anon_sym___clrcall] = ACTIONS(3607),
    [anon_sym___stdcall] = ACTIONS(3607),
    [anon_sym___fastcall] = ACTIONS(3607),
    [anon_sym___thiscall] = ACTIONS(3607),
    [anon_sym___vectorcall] = ACTIONS(3607),
    [anon_sym_LBRACE] = ACTIONS(3605),
    [anon_sym_signed] = ACTIONS(3607),
    [anon_sym_unsigned] = ACTIONS(3607),
    [anon_sym_long] = ACTIONS(3607),
    [anon_sym_short] = ACTIONS(3607),
    [anon_sym_LBRACK] = ACTIONS(3607),
    [anon_sym_static] = ACTIONS(3607),
    [anon_sym_register] = ACTIONS(3607),
    [anon_sym_inline] = ACTIONS(3607),
    [anon_sym___inline] = ACTIONS(3607),
    [anon_sym___inline__] = ACTIONS(3607),
    [anon_sym___forceinline] = ACTIONS(3607),
    [anon_sym_thread_local] = ACTIONS(3607),
    [anon_sym___thread] = ACTIONS(3607),
    [anon_sym_const] = ACTIONS(3607),
    [anon_sym_constexpr] = ACTIONS(3607),
    [anon_sym_volatile] = ACTIONS(3607),
    [anon_sym_restrict] = ACTIONS(3607),
    [anon_sym___restrict__] = ACTIONS(3607),
    [anon_sym__Atomic] = ACTIONS(3607),
    [anon_sym__Noreturn] = ACTIONS(3607),
    [anon_sym_noreturn] = ACTIONS(3607),
    [anon_sym__Nonnull] = ACTIONS(3607),
    [anon_sym_mutable] = ACTIONS(3607),
    [anon_sym_constinit] = ACTIONS(3607),
    [anon_sym_consteval] = ACTIONS(3607),
    [anon_sym_alignas] = ACTIONS(3607),
    [anon_sym__Alignas] = ACTIONS(3607),
    [sym_primitive_type] = ACTIONS(3607),
    [anon_sym_enum] = ACTIONS(3607),
    [anon_sym_class] = ACTIONS(3607),
    [anon_sym_struct] = ACTIONS(3607),
    [anon_sym_union] = ACTIONS(3607),
    [anon_sym_if] = ACTIONS(3607),
    [anon_sym_else] = ACTIONS(3607),
    [anon_sym_switch] = ACTIONS(3607),
    [anon_sym_case] = ACTIONS(3607),
    [anon_sym_default] = ACTIONS(3607),
    [anon_sym_while] = ACTIONS(3607),
    [anon_sym_do] = ACTIONS(3607),
    [anon_sym_for] = ACTIONS(3607),
    [anon_sym_return] = ACTIONS(3607),
    [anon_sym_break] = ACTIONS(3607),
    [anon_sym_continue] = ACTIONS(3607),
    [anon_sym_goto] = ACTIONS(3607),
    [anon_sym___try] = ACTIONS(3607),
    [anon_sym___leave] = ACTIONS(3607),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(3605),
    [anon_sym_PLUS_PLUS] = ACTIONS(3605),
    [anon_sym_sizeof] = ACTIONS(3607),
    [anon_sym___alignof__] = ACTIONS(3607),
    [anon_sym___alignof] = ACTIONS(3607),
    [anon_sym__alignof] = ACTIONS(3607),
    [anon_sym_alignof] = ACTIONS(3607),
    [anon_sym__Alignof] = ACTIONS(3607),
    [anon_sym_offsetof] = ACTIONS(3607),
    [anon_sym__Generic] = ACTIONS(3607),
    [anon_sym_asm] = ACTIONS(3607),
    [anon_sym___asm__] = ACTIONS(3607),
    [anon_sym___asm] = ACTIONS(3607),
    [sym_number_literal] = ACTIONS(3605),
    [anon_sym_L_SQUOTE] = ACTIONS(3605),
    [anon_sym_u_SQUOTE] = ACTIONS(3605),
    [anon_sym_U_SQUOTE] = ACTIONS(3605),
    [anon_sym_u8_SQUOTE] = ACTIONS(3605),
    [anon_sym_SQUOTE] = ACTIONS(3605),
    [anon_sym_L_DQUOTE] = ACTIONS(3605),
    [anon_sym_u_DQUOTE] = ACTIONS(3605),
    [anon_sym_U_DQUOTE] = ACTIONS(3605),
    [anon_sym_u8_DQUOTE] = ACTIONS(3605),
    [anon_sym_DQUOTE] = ACTIONS(3605),
    [sym_true] = ACTIONS(3607),
    [sym_false] = ACTIONS(3607),
    [anon_sym_NULL] = ACTIONS(3607),
    [anon_sym_nullptr] = ACTIONS(3607),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3607),
    [anon_sym_let] = ACTIONS(3607),
    [anon_sym_This] = ACTIONS(3607),
    [anon_sym_decltype] = ACTIONS(3607),
    [anon_sym_explicit] = ACTIONS(3607),
    [anon_sym_typename] = ACTIONS(3607),
    [anon_sym_export] = ACTIONS(3607),
    [anon_sym_module] = ACTIONS(3607),
    [anon_sym_import] = ACTIONS(3607),
    [anon_sym_template] = ACTIONS(3607),
    [anon_sym_operator] = ACTIONS(3607),
    [anon_sym_try] = ACTIONS(3607),
    [anon_sym_delete] = ACTIONS(3607),
    [anon_sym_throw] = ACTIONS(3607),
    [anon_sym_namespace] = ACTIONS(3607),
    [anon_sym_static_assert] = ACTIONS(3607),
    [anon_sym_concept] = ACTIONS(3607),
    [anon_sym_co_return] = ACTIONS(3607),
    [anon_sym_co_yield] = ACTIONS(3607),
    [anon_sym_R_DQUOTE] = ACTIONS(3605),
    [anon_sym_LR_DQUOTE] = ACTIONS(3605),
    [anon_sym_uR_DQUOTE] = ACTIONS(3605),
    [anon_sym_UR_DQUOTE] = ACTIONS(3605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3605),
    [anon_sym_co_await] = ACTIONS(3607),
    [anon_sym_new] = ACTIONS(3607),
    [anon_sym_requires] = ACTIONS(3607),
    [sym_this] = ACTIONS(3607),
    [anon_sym_discard] = ACTIONS(3607),
    [anon_sym_precise] = ACTIONS(3607),
    [anon_sym_shared] = ACTIONS(3607),
    [anon_sym_groupshared] = ACTIONS(3607),
    [anon_sym_uniform] = ACTIONS(3607),
    [anon_sym_row_major] = ACTIONS(3607),
    [anon_sym_column_major] = ACTIONS(3607),
    [anon_sym_globallycoherent] = ACTIONS(3607),
    [anon_sym_centroid] = ACTIONS(3607),
    [anon_sym_noperspective] = ACTIONS(3607),
    [anon_sym_nointerpolation] = ACTIONS(3607),
    [anon_sym_sample] = ACTIONS(3607),
    [anon_sym_linear] = ACTIONS(3607),
    [anon_sym_snorm] = ACTIONS(3607),
    [anon_sym_unorm] = ACTIONS(3607),
    [anon_sym_point] = ACTIONS(3607),
    [anon_sym_line] = ACTIONS(3607),
    [anon_sym_triangleadj] = ACTIONS(3607),
    [anon_sym_lineadj] = ACTIONS(3607),
    [anon_sym_triangle] = ACTIONS(3607),
    [anon_sym_cbuffer] = ACTIONS(3607),
    [anon_sym_interface] = ACTIONS(3607),
    [anon_sym_extension] = ACTIONS(3607),
    [anon_sym___exported] = ACTIONS(3607),
  },
  [462] = {
    [ts_builtin_sym_end] = ACTIONS(3609),
    [sym_identifier] = ACTIONS(3611),
    [aux_sym_preproc_include_token1] = ACTIONS(3611),
    [aux_sym_preproc_def_token1] = ACTIONS(3611),
    [aux_sym_preproc_if_token1] = ACTIONS(3611),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3611),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3611),
    [sym_preproc_directive] = ACTIONS(3611),
    [anon_sym_LPAREN2] = ACTIONS(3609),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3611),
    [anon_sym_PLUS] = ACTIONS(3611),
    [anon_sym_STAR] = ACTIONS(3609),
    [anon_sym_AMP_AMP] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(3611),
    [anon_sym_SEMI] = ACTIONS(3609),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_typedef] = ACTIONS(3611),
    [anon_sym_in] = ACTIONS(3611),
    [anon_sym_out] = ACTIONS(3611),
    [anon_sym_inout] = ACTIONS(3611),
    [anon_sym_virtual] = ACTIONS(3611),
    [anon_sym_extern] = ACTIONS(3611),
    [anon_sym___attribute__] = ACTIONS(3611),
    [anon_sym___attribute] = ACTIONS(3611),
    [anon_sym_using] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3609),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3609),
    [anon_sym___declspec] = ACTIONS(3611),
    [anon_sym___based] = ACTIONS(3611),
    [anon_sym___cdecl] = ACTIONS(3611),
    [anon_sym___clrcall] = ACTIONS(3611),
    [anon_sym___stdcall] = ACTIONS(3611),
    [anon_sym___fastcall] = ACTIONS(3611),
    [anon_sym___thiscall] = ACTIONS(3611),
    [anon_sym___vectorcall] = ACTIONS(3611),
    [anon_sym_LBRACE] = ACTIONS(3609),
    [anon_sym_signed] = ACTIONS(3611),
    [anon_sym_unsigned] = ACTIONS(3611),
    [anon_sym_long] = ACTIONS(3611),
    [anon_sym_short] = ACTIONS(3611),
    [anon_sym_LBRACK] = ACTIONS(3611),
    [anon_sym_static] = ACTIONS(3611),
    [anon_sym_register] = ACTIONS(3611),
    [anon_sym_inline] = ACTIONS(3611),
    [anon_sym___inline] = ACTIONS(3611),
    [anon_sym___inline__] = ACTIONS(3611),
    [anon_sym___forceinline] = ACTIONS(3611),
    [anon_sym_thread_local] = ACTIONS(3611),
    [anon_sym___thread] = ACTIONS(3611),
    [anon_sym_const] = ACTIONS(3611),
    [anon_sym_constexpr] = ACTIONS(3611),
    [anon_sym_volatile] = ACTIONS(3611),
    [anon_sym_restrict] = ACTIONS(3611),
    [anon_sym___restrict__] = ACTIONS(3611),
    [anon_sym__Atomic] = ACTIONS(3611),
    [anon_sym__Noreturn] = ACTIONS(3611),
    [anon_sym_noreturn] = ACTIONS(3611),
    [anon_sym__Nonnull] = ACTIONS(3611),
    [anon_sym_mutable] = ACTIONS(3611),
    [anon_sym_constinit] = ACTIONS(3611),
    [anon_sym_consteval] = ACTIONS(3611),
    [anon_sym_alignas] = ACTIONS(3611),
    [anon_sym__Alignas] = ACTIONS(3611),
    [sym_primitive_type] = ACTIONS(3611),
    [anon_sym_enum] = ACTIONS(3611),
    [anon_sym_class] = ACTIONS(3611),
    [anon_sym_struct] = ACTIONS(3611),
    [anon_sym_union] = ACTIONS(3611),
    [anon_sym_if] = ACTIONS(3611),
    [anon_sym_else] = ACTIONS(3611),
    [anon_sym_switch] = ACTIONS(3611),
    [anon_sym_case] = ACTIONS(3611),
    [anon_sym_default] = ACTIONS(3611),
    [anon_sym_while] = ACTIONS(3611),
    [anon_sym_do] = ACTIONS(3611),
    [anon_sym_for] = ACTIONS(3611),
    [anon_sym_return] = ACTIONS(3611),
    [anon_sym_break] = ACTIONS(3611),
    [anon_sym_continue] = ACTIONS(3611),
    [anon_sym_goto] = ACTIONS(3611),
    [anon_sym___try] = ACTIONS(3611),
    [anon_sym___leave] = ACTIONS(3611),
    [anon_sym_not] = ACTIONS(3611),
    [anon_sym_compl] = ACTIONS(3611),
    [anon_sym_DASH_DASH] = ACTIONS(3609),
    [anon_sym_PLUS_PLUS] = ACTIONS(3609),
    [anon_sym_sizeof] = ACTIONS(3611),
    [anon_sym___alignof__] = ACTIONS(3611),
    [anon_sym___alignof] = ACTIONS(3611),
    [anon_sym__alignof] = ACTIONS(3611),
    [anon_sym_alignof] = ACTIONS(3611),
    [anon_sym__Alignof] = ACTIONS(3611),
    [anon_sym_offsetof] = ACTIONS(3611),
    [anon_sym__Generic] = ACTIONS(3611),
    [anon_sym_asm] = ACTIONS(3611),
    [anon_sym___asm__] = ACTIONS(3611),
    [anon_sym___asm] = ACTIONS(3611),
    [sym_number_literal] = ACTIONS(3609),
    [anon_sym_L_SQUOTE] = ACTIONS(3609),
    [anon_sym_u_SQUOTE] = ACTIONS(3609),
    [anon_sym_U_SQUOTE] = ACTIONS(3609),
    [anon_sym_u8_SQUOTE] = ACTIONS(3609),
    [anon_sym_SQUOTE] = ACTIONS(3609),
    [anon_sym_L_DQUOTE] = ACTIONS(3609),
    [anon_sym_u_DQUOTE] = ACTIONS(3609),
    [anon_sym_U_DQUOTE] = ACTIONS(3609),
    [anon_sym_u8_DQUOTE] = ACTIONS(3609),
    [anon_sym_DQUOTE] = ACTIONS(3609),
    [sym_true] = ACTIONS(3611),
    [sym_false] = ACTIONS(3611),
    [anon_sym_NULL] = ACTIONS(3611),
    [anon_sym_nullptr] = ACTIONS(3611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3611),
    [anon_sym_let] = ACTIONS(3611),
    [anon_sym_This] = ACTIONS(3611),
    [anon_sym_decltype] = ACTIONS(3611),
    [anon_sym_explicit] = ACTIONS(3611),
    [anon_sym_typename] = ACTIONS(3611),
    [anon_sym_export] = ACTIONS(3611),
    [anon_sym_module] = ACTIONS(3611),
    [anon_sym_import] = ACTIONS(3611),
    [anon_sym_template] = ACTIONS(3611),
    [anon_sym_operator] = ACTIONS(3611),
    [anon_sym_try] = ACTIONS(3611),
    [anon_sym_delete] = ACTIONS(3611),
    [anon_sym_throw] = ACTIONS(3611),
    [anon_sym_namespace] = ACTIONS(3611),
    [anon_sym_static_assert] = ACTIONS(3611),
    [anon_sym_concept] = ACTIONS(3611),
    [anon_sym_co_return] = ACTIONS(3611),
    [anon_sym_co_yield] = ACTIONS(3611),
    [anon_sym_R_DQUOTE] = ACTIONS(3609),
    [anon_sym_LR_DQUOTE] = ACTIONS(3609),
    [anon_sym_uR_DQUOTE] = ACTIONS(3609),
    [anon_sym_UR_DQUOTE] = ACTIONS(3609),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3609),
    [anon_sym_co_await] = ACTIONS(3611),
    [anon_sym_new] = ACTIONS(3611),
    [anon_sym_requires] = ACTIONS(3611),
    [sym_this] = ACTIONS(3611),
    [anon_sym_discard] = ACTIONS(3611),
    [anon_sym_precise] = ACTIONS(3611),
    [anon_sym_shared] = ACTIONS(3611),
    [anon_sym_groupshared] = ACTIONS(3611),
    [anon_sym_uniform] = ACTIONS(3611),
    [anon_sym_row_major] = ACTIONS(3611),
    [anon_sym_column_major] = ACTIONS(3611),
    [anon_sym_globallycoherent] = ACTIONS(3611),
    [anon_sym_centroid] = ACTIONS(3611),
    [anon_sym_noperspective] = ACTIONS(3611),
    [anon_sym_nointerpolation] = ACTIONS(3611),
    [anon_sym_sample] = ACTIONS(3611),
    [anon_sym_linear] = ACTIONS(3611),
    [anon_sym_snorm] = ACTIONS(3611),
    [anon_sym_unorm] = ACTIONS(3611),
    [anon_sym_point] = ACTIONS(3611),
    [anon_sym_line] = ACTIONS(3611),
    [anon_sym_triangleadj] = ACTIONS(3611),
    [anon_sym_lineadj] = ACTIONS(3611),
    [anon_sym_triangle] = ACTIONS(3611),
    [anon_sym_cbuffer] = ACTIONS(3611),
    [anon_sym_interface] = ACTIONS(3611),
    [anon_sym_extension] = ACTIONS(3611),
    [anon_sym___exported] = ACTIONS(3611),
  },
  [463] = {
    [ts_builtin_sym_end] = ACTIONS(3613),
    [sym_identifier] = ACTIONS(3615),
    [aux_sym_preproc_include_token1] = ACTIONS(3615),
    [aux_sym_preproc_def_token1] = ACTIONS(3615),
    [aux_sym_preproc_if_token1] = ACTIONS(3615),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3615),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3615),
    [sym_preproc_directive] = ACTIONS(3615),
    [anon_sym_LPAREN2] = ACTIONS(3613),
    [anon_sym_BANG] = ACTIONS(3613),
    [anon_sym_TILDE] = ACTIONS(3613),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3613),
    [anon_sym_AMP_AMP] = ACTIONS(3613),
    [anon_sym_AMP] = ACTIONS(3615),
    [anon_sym_SEMI] = ACTIONS(3613),
    [anon_sym___extension__] = ACTIONS(3615),
    [anon_sym_typedef] = ACTIONS(3615),
    [anon_sym_in] = ACTIONS(3615),
    [anon_sym_out] = ACTIONS(3615),
    [anon_sym_inout] = ACTIONS(3615),
    [anon_sym_virtual] = ACTIONS(3615),
    [anon_sym_extern] = ACTIONS(3615),
    [anon_sym___attribute__] = ACTIONS(3615),
    [anon_sym___attribute] = ACTIONS(3615),
    [anon_sym_using] = ACTIONS(3615),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3613),
    [anon_sym___declspec] = ACTIONS(3615),
    [anon_sym___based] = ACTIONS(3615),
    [anon_sym___cdecl] = ACTIONS(3615),
    [anon_sym___clrcall] = ACTIONS(3615),
    [anon_sym___stdcall] = ACTIONS(3615),
    [anon_sym___fastcall] = ACTIONS(3615),
    [anon_sym___thiscall] = ACTIONS(3615),
    [anon_sym___vectorcall] = ACTIONS(3615),
    [anon_sym_LBRACE] = ACTIONS(3613),
    [anon_sym_signed] = ACTIONS(3615),
    [anon_sym_unsigned] = ACTIONS(3615),
    [anon_sym_long] = ACTIONS(3615),
    [anon_sym_short] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(3615),
    [anon_sym_static] = ACTIONS(3615),
    [anon_sym_register] = ACTIONS(3615),
    [anon_sym_inline] = ACTIONS(3615),
    [anon_sym___inline] = ACTIONS(3615),
    [anon_sym___inline__] = ACTIONS(3615),
    [anon_sym___forceinline] = ACTIONS(3615),
    [anon_sym_thread_local] = ACTIONS(3615),
    [anon_sym___thread] = ACTIONS(3615),
    [anon_sym_const] = ACTIONS(3615),
    [anon_sym_constexpr] = ACTIONS(3615),
    [anon_sym_volatile] = ACTIONS(3615),
    [anon_sym_restrict] = ACTIONS(3615),
    [anon_sym___restrict__] = ACTIONS(3615),
    [anon_sym__Atomic] = ACTIONS(3615),
    [anon_sym__Noreturn] = ACTIONS(3615),
    [anon_sym_noreturn] = ACTIONS(3615),
    [anon_sym__Nonnull] = ACTIONS(3615),
    [anon_sym_mutable] = ACTIONS(3615),
    [anon_sym_constinit] = ACTIONS(3615),
    [anon_sym_consteval] = ACTIONS(3615),
    [anon_sym_alignas] = ACTIONS(3615),
    [anon_sym__Alignas] = ACTIONS(3615),
    [sym_primitive_type] = ACTIONS(3615),
    [anon_sym_enum] = ACTIONS(3615),
    [anon_sym_class] = ACTIONS(3615),
    [anon_sym_struct] = ACTIONS(3615),
    [anon_sym_union] = ACTIONS(3615),
    [anon_sym_if] = ACTIONS(3615),
    [anon_sym_else] = ACTIONS(3615),
    [anon_sym_switch] = ACTIONS(3615),
    [anon_sym_case] = ACTIONS(3615),
    [anon_sym_default] = ACTIONS(3615),
    [anon_sym_while] = ACTIONS(3615),
    [anon_sym_do] = ACTIONS(3615),
    [anon_sym_for] = ACTIONS(3615),
    [anon_sym_return] = ACTIONS(3615),
    [anon_sym_break] = ACTIONS(3615),
    [anon_sym_continue] = ACTIONS(3615),
    [anon_sym_goto] = ACTIONS(3615),
    [anon_sym___try] = ACTIONS(3615),
    [anon_sym___leave] = ACTIONS(3615),
    [anon_sym_not] = ACTIONS(3615),
    [anon_sym_compl] = ACTIONS(3615),
    [anon_sym_DASH_DASH] = ACTIONS(3613),
    [anon_sym_PLUS_PLUS] = ACTIONS(3613),
    [anon_sym_sizeof] = ACTIONS(3615),
    [anon_sym___alignof__] = ACTIONS(3615),
    [anon_sym___alignof] = ACTIONS(3615),
    [anon_sym__alignof] = ACTIONS(3615),
    [anon_sym_alignof] = ACTIONS(3615),
    [anon_sym__Alignof] = ACTIONS(3615),
    [anon_sym_offsetof] = ACTIONS(3615),
    [anon_sym__Generic] = ACTIONS(3615),
    [anon_sym_asm] = ACTIONS(3615),
    [anon_sym___asm__] = ACTIONS(3615),
    [anon_sym___asm] = ACTIONS(3615),
    [sym_number_literal] = ACTIONS(3613),
    [anon_sym_L_SQUOTE] = ACTIONS(3613),
    [anon_sym_u_SQUOTE] = ACTIONS(3613),
    [anon_sym_U_SQUOTE] = ACTIONS(3613),
    [anon_sym_u8_SQUOTE] = ACTIONS(3613),
    [anon_sym_SQUOTE] = ACTIONS(3613),
    [anon_sym_L_DQUOTE] = ACTIONS(3613),
    [anon_sym_u_DQUOTE] = ACTIONS(3613),
    [anon_sym_U_DQUOTE] = ACTIONS(3613),
    [anon_sym_u8_DQUOTE] = ACTIONS(3613),
    [anon_sym_DQUOTE] = ACTIONS(3613),
    [sym_true] = ACTIONS(3615),
    [sym_false] = ACTIONS(3615),
    [anon_sym_NULL] = ACTIONS(3615),
    [anon_sym_nullptr] = ACTIONS(3615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3615),
    [anon_sym_let] = ACTIONS(3615),
    [anon_sym_This] = ACTIONS(3615),
    [anon_sym_decltype] = ACTIONS(3615),
    [anon_sym_explicit] = ACTIONS(3615),
    [anon_sym_typename] = ACTIONS(3615),
    [anon_sym_export] = ACTIONS(3615),
    [anon_sym_module] = ACTIONS(3615),
    [anon_sym_import] = ACTIONS(3615),
    [anon_sym_template] = ACTIONS(3615),
    [anon_sym_operator] = ACTIONS(3615),
    [anon_sym_try] = ACTIONS(3615),
    [anon_sym_delete] = ACTIONS(3615),
    [anon_sym_throw] = ACTIONS(3615),
    [anon_sym_namespace] = ACTIONS(3615),
    [anon_sym_static_assert] = ACTIONS(3615),
    [anon_sym_concept] = ACTIONS(3615),
    [anon_sym_co_return] = ACTIONS(3615),
    [anon_sym_co_yield] = ACTIONS(3615),
    [anon_sym_R_DQUOTE] = ACTIONS(3613),
    [anon_sym_LR_DQUOTE] = ACTIONS(3613),
    [anon_sym_uR_DQUOTE] = ACTIONS(3613),
    [anon_sym_UR_DQUOTE] = ACTIONS(3613),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3613),
    [anon_sym_co_await] = ACTIONS(3615),
    [anon_sym_new] = ACTIONS(3615),
    [anon_sym_requires] = ACTIONS(3615),
    [sym_this] = ACTIONS(3615),
    [anon_sym_discard] = ACTIONS(3615),
    [anon_sym_precise] = ACTIONS(3615),
    [anon_sym_shared] = ACTIONS(3615),
    [anon_sym_groupshared] = ACTIONS(3615),
    [anon_sym_uniform] = ACTIONS(3615),
    [anon_sym_row_major] = ACTIONS(3615),
    [anon_sym_column_major] = ACTIONS(3615),
    [anon_sym_globallycoherent] = ACTIONS(3615),
    [anon_sym_centroid] = ACTIONS(3615),
    [anon_sym_noperspective] = ACTIONS(3615),
    [anon_sym_nointerpolation] = ACTIONS(3615),
    [anon_sym_sample] = ACTIONS(3615),
    [anon_sym_linear] = ACTIONS(3615),
    [anon_sym_snorm] = ACTIONS(3615),
    [anon_sym_unorm] = ACTIONS(3615),
    [anon_sym_point] = ACTIONS(3615),
    [anon_sym_line] = ACTIONS(3615),
    [anon_sym_triangleadj] = ACTIONS(3615),
    [anon_sym_lineadj] = ACTIONS(3615),
    [anon_sym_triangle] = ACTIONS(3615),
    [anon_sym_cbuffer] = ACTIONS(3615),
    [anon_sym_interface] = ACTIONS(3615),
    [anon_sym_extension] = ACTIONS(3615),
    [anon_sym___exported] = ACTIONS(3615),
  },
  [464] = {
    [ts_builtin_sym_end] = ACTIONS(3617),
    [sym_identifier] = ACTIONS(3619),
    [aux_sym_preproc_include_token1] = ACTIONS(3619),
    [aux_sym_preproc_def_token1] = ACTIONS(3619),
    [aux_sym_preproc_if_token1] = ACTIONS(3619),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3619),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3619),
    [sym_preproc_directive] = ACTIONS(3619),
    [anon_sym_LPAREN2] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_DASH] = ACTIONS(3619),
    [anon_sym_PLUS] = ACTIONS(3619),
    [anon_sym_STAR] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP] = ACTIONS(3619),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym___extension__] = ACTIONS(3619),
    [anon_sym_typedef] = ACTIONS(3619),
    [anon_sym_in] = ACTIONS(3619),
    [anon_sym_out] = ACTIONS(3619),
    [anon_sym_inout] = ACTIONS(3619),
    [anon_sym_virtual] = ACTIONS(3619),
    [anon_sym_extern] = ACTIONS(3619),
    [anon_sym___attribute__] = ACTIONS(3619),
    [anon_sym___attribute] = ACTIONS(3619),
    [anon_sym_using] = ACTIONS(3619),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3617),
    [anon_sym___declspec] = ACTIONS(3619),
    [anon_sym___based] = ACTIONS(3619),
    [anon_sym___cdecl] = ACTIONS(3619),
    [anon_sym___clrcall] = ACTIONS(3619),
    [anon_sym___stdcall] = ACTIONS(3619),
    [anon_sym___fastcall] = ACTIONS(3619),
    [anon_sym___thiscall] = ACTIONS(3619),
    [anon_sym___vectorcall] = ACTIONS(3619),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_signed] = ACTIONS(3619),
    [anon_sym_unsigned] = ACTIONS(3619),
    [anon_sym_long] = ACTIONS(3619),
    [anon_sym_short] = ACTIONS(3619),
    [anon_sym_LBRACK] = ACTIONS(3619),
    [anon_sym_static] = ACTIONS(3619),
    [anon_sym_register] = ACTIONS(3619),
    [anon_sym_inline] = ACTIONS(3619),
    [anon_sym___inline] = ACTIONS(3619),
    [anon_sym___inline__] = ACTIONS(3619),
    [anon_sym___forceinline] = ACTIONS(3619),
    [anon_sym_thread_local] = ACTIONS(3619),
    [anon_sym___thread] = ACTIONS(3619),
    [anon_sym_const] = ACTIONS(3619),
    [anon_sym_constexpr] = ACTIONS(3619),
    [anon_sym_volatile] = ACTIONS(3619),
    [anon_sym_restrict] = ACTIONS(3619),
    [anon_sym___restrict__] = ACTIONS(3619),
    [anon_sym__Atomic] = ACTIONS(3619),
    [anon_sym__Noreturn] = ACTIONS(3619),
    [anon_sym_noreturn] = ACTIONS(3619),
    [anon_sym__Nonnull] = ACTIONS(3619),
    [anon_sym_mutable] = ACTIONS(3619),
    [anon_sym_constinit] = ACTIONS(3619),
    [anon_sym_consteval] = ACTIONS(3619),
    [anon_sym_alignas] = ACTIONS(3619),
    [anon_sym__Alignas] = ACTIONS(3619),
    [sym_primitive_type] = ACTIONS(3619),
    [anon_sym_enum] = ACTIONS(3619),
    [anon_sym_class] = ACTIONS(3619),
    [anon_sym_struct] = ACTIONS(3619),
    [anon_sym_union] = ACTIONS(3619),
    [anon_sym_if] = ACTIONS(3619),
    [anon_sym_else] = ACTIONS(3619),
    [anon_sym_switch] = ACTIONS(3619),
    [anon_sym_case] = ACTIONS(3619),
    [anon_sym_default] = ACTIONS(3619),
    [anon_sym_while] = ACTIONS(3619),
    [anon_sym_do] = ACTIONS(3619),
    [anon_sym_for] = ACTIONS(3619),
    [anon_sym_return] = ACTIONS(3619),
    [anon_sym_break] = ACTIONS(3619),
    [anon_sym_continue] = ACTIONS(3619),
    [anon_sym_goto] = ACTIONS(3619),
    [anon_sym___try] = ACTIONS(3619),
    [anon_sym___leave] = ACTIONS(3619),
    [anon_sym_not] = ACTIONS(3619),
    [anon_sym_compl] = ACTIONS(3619),
    [anon_sym_DASH_DASH] = ACTIONS(3617),
    [anon_sym_PLUS_PLUS] = ACTIONS(3617),
    [anon_sym_sizeof] = ACTIONS(3619),
    [anon_sym___alignof__] = ACTIONS(3619),
    [anon_sym___alignof] = ACTIONS(3619),
    [anon_sym__alignof] = ACTIONS(3619),
    [anon_sym_alignof] = ACTIONS(3619),
    [anon_sym__Alignof] = ACTIONS(3619),
    [anon_sym_offsetof] = ACTIONS(3619),
    [anon_sym__Generic] = ACTIONS(3619),
    [anon_sym_asm] = ACTIONS(3619),
    [anon_sym___asm__] = ACTIONS(3619),
    [anon_sym___asm] = ACTIONS(3619),
    [sym_number_literal] = ACTIONS(3617),
    [anon_sym_L_SQUOTE] = ACTIONS(3617),
    [anon_sym_u_SQUOTE] = ACTIONS(3617),
    [anon_sym_U_SQUOTE] = ACTIONS(3617),
    [anon_sym_u8_SQUOTE] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3617),
    [anon_sym_L_DQUOTE] = ACTIONS(3617),
    [anon_sym_u_DQUOTE] = ACTIONS(3617),
    [anon_sym_U_DQUOTE] = ACTIONS(3617),
    [anon_sym_u8_DQUOTE] = ACTIONS(3617),
    [anon_sym_DQUOTE] = ACTIONS(3617),
    [sym_true] = ACTIONS(3619),
    [sym_false] = ACTIONS(3619),
    [anon_sym_NULL] = ACTIONS(3619),
    [anon_sym_nullptr] = ACTIONS(3619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3619),
    [anon_sym_let] = ACTIONS(3619),
    [anon_sym_This] = ACTIONS(3619),
    [anon_sym_decltype] = ACTIONS(3619),
    [anon_sym_explicit] = ACTIONS(3619),
    [anon_sym_typename] = ACTIONS(3619),
    [anon_sym_export] = ACTIONS(3619),
    [anon_sym_module] = ACTIONS(3619),
    [anon_sym_import] = ACTIONS(3619),
    [anon_sym_template] = ACTIONS(3619),
    [anon_sym_operator] = ACTIONS(3619),
    [anon_sym_try] = ACTIONS(3619),
    [anon_sym_delete] = ACTIONS(3619),
    [anon_sym_throw] = ACTIONS(3619),
    [anon_sym_namespace] = ACTIONS(3619),
    [anon_sym_static_assert] = ACTIONS(3619),
    [anon_sym_concept] = ACTIONS(3619),
    [anon_sym_co_return] = ACTIONS(3619),
    [anon_sym_co_yield] = ACTIONS(3619),
    [anon_sym_R_DQUOTE] = ACTIONS(3617),
    [anon_sym_LR_DQUOTE] = ACTIONS(3617),
    [anon_sym_uR_DQUOTE] = ACTIONS(3617),
    [anon_sym_UR_DQUOTE] = ACTIONS(3617),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3617),
    [anon_sym_co_await] = ACTIONS(3619),
    [anon_sym_new] = ACTIONS(3619),
    [anon_sym_requires] = ACTIONS(3619),
    [sym_this] = ACTIONS(3619),
    [anon_sym_discard] = ACTIONS(3619),
    [anon_sym_precise] = ACTIONS(3619),
    [anon_sym_shared] = ACTIONS(3619),
    [anon_sym_groupshared] = ACTIONS(3619),
    [anon_sym_uniform] = ACTIONS(3619),
    [anon_sym_row_major] = ACTIONS(3619),
    [anon_sym_column_major] = ACTIONS(3619),
    [anon_sym_globallycoherent] = ACTIONS(3619),
    [anon_sym_centroid] = ACTIONS(3619),
    [anon_sym_noperspective] = ACTIONS(3619),
    [anon_sym_nointerpolation] = ACTIONS(3619),
    [anon_sym_sample] = ACTIONS(3619),
    [anon_sym_linear] = ACTIONS(3619),
    [anon_sym_snorm] = ACTIONS(3619),
    [anon_sym_unorm] = ACTIONS(3619),
    [anon_sym_point] = ACTIONS(3619),
    [anon_sym_line] = ACTIONS(3619),
    [anon_sym_triangleadj] = ACTIONS(3619),
    [anon_sym_lineadj] = ACTIONS(3619),
    [anon_sym_triangle] = ACTIONS(3619),
    [anon_sym_cbuffer] = ACTIONS(3619),
    [anon_sym_interface] = ACTIONS(3619),
    [anon_sym_extension] = ACTIONS(3619),
    [anon_sym___exported] = ACTIONS(3619),
  },
  [465] = {
    [sym_identifier] = ACTIONS(3562),
    [aux_sym_preproc_include_token1] = ACTIONS(3562),
    [aux_sym_preproc_def_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token2] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3562),
    [aux_sym_preproc_else_token1] = ACTIONS(3562),
    [aux_sym_preproc_elif_token1] = ACTIONS(3562),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3562),
    [sym_preproc_directive] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym___extension__] = ACTIONS(3562),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_in] = ACTIONS(3562),
    [anon_sym_out] = ACTIONS(3562),
    [anon_sym_inout] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym___attribute__] = ACTIONS(3562),
    [anon_sym___attribute] = ACTIONS(3562),
    [anon_sym_using] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3560),
    [anon_sym___declspec] = ACTIONS(3562),
    [anon_sym___based] = ACTIONS(3562),
    [anon_sym___cdecl] = ACTIONS(3562),
    [anon_sym___clrcall] = ACTIONS(3562),
    [anon_sym___stdcall] = ACTIONS(3562),
    [anon_sym___fastcall] = ACTIONS(3562),
    [anon_sym___thiscall] = ACTIONS(3562),
    [anon_sym___vectorcall] = ACTIONS(3562),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_signed] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym___inline] = ACTIONS(3562),
    [anon_sym___inline__] = ACTIONS(3562),
    [anon_sym___forceinline] = ACTIONS(3562),
    [anon_sym_thread_local] = ACTIONS(3562),
    [anon_sym___thread] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_constexpr] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym___restrict__] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym__Noreturn] = ACTIONS(3562),
    [anon_sym_noreturn] = ACTIONS(3562),
    [anon_sym__Nonnull] = ACTIONS(3562),
    [anon_sym_mutable] = ACTIONS(3562),
    [anon_sym_constinit] = ACTIONS(3562),
    [anon_sym_consteval] = ACTIONS(3562),
    [anon_sym_alignas] = ACTIONS(3562),
    [anon_sym__Alignas] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_else] = ACTIONS(3562),
    [anon_sym_switch] = ACTIONS(3562),
    [anon_sym_case] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_goto] = ACTIONS(3562),
    [anon_sym___try] = ACTIONS(3562),
    [anon_sym___leave] = ACTIONS(3562),
    [anon_sym_not] = ACTIONS(3562),
    [anon_sym_compl] = ACTIONS(3562),
    [anon_sym_DASH_DASH] = ACTIONS(3560),
    [anon_sym_PLUS_PLUS] = ACTIONS(3560),
    [anon_sym_sizeof] = ACTIONS(3562),
    [anon_sym___alignof__] = ACTIONS(3562),
    [anon_sym___alignof] = ACTIONS(3562),
    [anon_sym__alignof] = ACTIONS(3562),
    [anon_sym_alignof] = ACTIONS(3562),
    [anon_sym__Alignof] = ACTIONS(3562),
    [anon_sym_offsetof] = ACTIONS(3562),
    [anon_sym__Generic] = ACTIONS(3562),
    [anon_sym_asm] = ACTIONS(3562),
    [anon_sym___asm__] = ACTIONS(3562),
    [anon_sym___asm] = ACTIONS(3562),
    [sym_number_literal] = ACTIONS(3560),
    [anon_sym_L_SQUOTE] = ACTIONS(3560),
    [anon_sym_u_SQUOTE] = ACTIONS(3560),
    [anon_sym_U_SQUOTE] = ACTIONS(3560),
    [anon_sym_u8_SQUOTE] = ACTIONS(3560),
    [anon_sym_SQUOTE] = ACTIONS(3560),
    [anon_sym_L_DQUOTE] = ACTIONS(3560),
    [anon_sym_u_DQUOTE] = ACTIONS(3560),
    [anon_sym_U_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE] = ACTIONS(3560),
    [sym_true] = ACTIONS(3562),
    [sym_false] = ACTIONS(3562),
    [anon_sym_NULL] = ACTIONS(3562),
    [anon_sym_nullptr] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_This] = ACTIONS(3562),
    [anon_sym_decltype] = ACTIONS(3562),
    [anon_sym_explicit] = ACTIONS(3562),
    [anon_sym_typename] = ACTIONS(3562),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_delete] = ACTIONS(3562),
    [anon_sym_throw] = ACTIONS(3562),
    [anon_sym_namespace] = ACTIONS(3562),
    [anon_sym_static_assert] = ACTIONS(3562),
    [anon_sym_concept] = ACTIONS(3562),
    [anon_sym_co_return] = ACTIONS(3562),
    [anon_sym_co_yield] = ACTIONS(3562),
    [anon_sym_R_DQUOTE] = ACTIONS(3560),
    [anon_sym_LR_DQUOTE] = ACTIONS(3560),
    [anon_sym_uR_DQUOTE] = ACTIONS(3560),
    [anon_sym_UR_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3560),
    [anon_sym_co_await] = ACTIONS(3562),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_requires] = ACTIONS(3562),
    [sym_this] = ACTIONS(3562),
    [anon_sym_discard] = ACTIONS(3562),
    [anon_sym_precise] = ACTIONS(3562),
    [anon_sym_shared] = ACTIONS(3562),
    [anon_sym_groupshared] = ACTIONS(3562),
    [anon_sym_uniform] = ACTIONS(3562),
    [anon_sym_row_major] = ACTIONS(3562),
    [anon_sym_column_major] = ACTIONS(3562),
    [anon_sym_globallycoherent] = ACTIONS(3562),
    [anon_sym_centroid] = ACTIONS(3562),
    [anon_sym_noperspective] = ACTIONS(3562),
    [anon_sym_nointerpolation] = ACTIONS(3562),
    [anon_sym_sample] = ACTIONS(3562),
    [anon_sym_linear] = ACTIONS(3562),
    [anon_sym_snorm] = ACTIONS(3562),
    [anon_sym_unorm] = ACTIONS(3562),
    [anon_sym_point] = ACTIONS(3562),
    [anon_sym_line] = ACTIONS(3562),
    [anon_sym_triangleadj] = ACTIONS(3562),
    [anon_sym_lineadj] = ACTIONS(3562),
    [anon_sym_triangle] = ACTIONS(3562),
    [anon_sym_cbuffer] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_extension] = ACTIONS(3562),
  },
  [466] = {
    [ts_builtin_sym_end] = ACTIONS(3621),
    [sym_identifier] = ACTIONS(3623),
    [aux_sym_preproc_include_token1] = ACTIONS(3623),
    [aux_sym_preproc_def_token1] = ACTIONS(3623),
    [aux_sym_preproc_if_token1] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3623),
    [sym_preproc_directive] = ACTIONS(3623),
    [anon_sym_LPAREN2] = ACTIONS(3621),
    [anon_sym_BANG] = ACTIONS(3621),
    [anon_sym_TILDE] = ACTIONS(3621),
    [anon_sym_DASH] = ACTIONS(3623),
    [anon_sym_PLUS] = ACTIONS(3623),
    [anon_sym_STAR] = ACTIONS(3621),
    [anon_sym_AMP_AMP] = ACTIONS(3621),
    [anon_sym_AMP] = ACTIONS(3623),
    [anon_sym_SEMI] = ACTIONS(3621),
    [anon_sym___extension__] = ACTIONS(3623),
    [anon_sym_typedef] = ACTIONS(3623),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_out] = ACTIONS(3623),
    [anon_sym_inout] = ACTIONS(3623),
    [anon_sym_virtual] = ACTIONS(3623),
    [anon_sym_extern] = ACTIONS(3623),
    [anon_sym___attribute__] = ACTIONS(3623),
    [anon_sym___attribute] = ACTIONS(3623),
    [anon_sym_using] = ACTIONS(3623),
    [anon_sym_COLON_COLON] = ACTIONS(3621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3621),
    [anon_sym___declspec] = ACTIONS(3623),
    [anon_sym___based] = ACTIONS(3623),
    [anon_sym___cdecl] = ACTIONS(3623),
    [anon_sym___clrcall] = ACTIONS(3623),
    [anon_sym___stdcall] = ACTIONS(3623),
    [anon_sym___fastcall] = ACTIONS(3623),
    [anon_sym___thiscall] = ACTIONS(3623),
    [anon_sym___vectorcall] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3621),
    [anon_sym_signed] = ACTIONS(3623),
    [anon_sym_unsigned] = ACTIONS(3623),
    [anon_sym_long] = ACTIONS(3623),
    [anon_sym_short] = ACTIONS(3623),
    [anon_sym_LBRACK] = ACTIONS(3623),
    [anon_sym_static] = ACTIONS(3623),
    [anon_sym_register] = ACTIONS(3623),
    [anon_sym_inline] = ACTIONS(3623),
    [anon_sym___inline] = ACTIONS(3623),
    [anon_sym___inline__] = ACTIONS(3623),
    [anon_sym___forceinline] = ACTIONS(3623),
    [anon_sym_thread_local] = ACTIONS(3623),
    [anon_sym___thread] = ACTIONS(3623),
    [anon_sym_const] = ACTIONS(3623),
    [anon_sym_constexpr] = ACTIONS(3623),
    [anon_sym_volatile] = ACTIONS(3623),
    [anon_sym_restrict] = ACTIONS(3623),
    [anon_sym___restrict__] = ACTIONS(3623),
    [anon_sym__Atomic] = ACTIONS(3623),
    [anon_sym__Noreturn] = ACTIONS(3623),
    [anon_sym_noreturn] = ACTIONS(3623),
    [anon_sym__Nonnull] = ACTIONS(3623),
    [anon_sym_mutable] = ACTIONS(3623),
    [anon_sym_constinit] = ACTIONS(3623),
    [anon_sym_consteval] = ACTIONS(3623),
    [anon_sym_alignas] = ACTIONS(3623),
    [anon_sym__Alignas] = ACTIONS(3623),
    [sym_primitive_type] = ACTIONS(3623),
    [anon_sym_enum] = ACTIONS(3623),
    [anon_sym_class] = ACTIONS(3623),
    [anon_sym_struct] = ACTIONS(3623),
    [anon_sym_union] = ACTIONS(3623),
    [anon_sym_if] = ACTIONS(3623),
    [anon_sym_else] = ACTIONS(3623),
    [anon_sym_switch] = ACTIONS(3623),
    [anon_sym_case] = ACTIONS(3623),
    [anon_sym_default] = ACTIONS(3623),
    [anon_sym_while] = ACTIONS(3623),
    [anon_sym_do] = ACTIONS(3623),
    [anon_sym_for] = ACTIONS(3623),
    [anon_sym_return] = ACTIONS(3623),
    [anon_sym_break] = ACTIONS(3623),
    [anon_sym_continue] = ACTIONS(3623),
    [anon_sym_goto] = ACTIONS(3623),
    [anon_sym___try] = ACTIONS(3623),
    [anon_sym___leave] = ACTIONS(3623),
    [anon_sym_not] = ACTIONS(3623),
    [anon_sym_compl] = ACTIONS(3623),
    [anon_sym_DASH_DASH] = ACTIONS(3621),
    [anon_sym_PLUS_PLUS] = ACTIONS(3621),
    [anon_sym_sizeof] = ACTIONS(3623),
    [anon_sym___alignof__] = ACTIONS(3623),
    [anon_sym___alignof] = ACTIONS(3623),
    [anon_sym__alignof] = ACTIONS(3623),
    [anon_sym_alignof] = ACTIONS(3623),
    [anon_sym__Alignof] = ACTIONS(3623),
    [anon_sym_offsetof] = ACTIONS(3623),
    [anon_sym__Generic] = ACTIONS(3623),
    [anon_sym_asm] = ACTIONS(3623),
    [anon_sym___asm__] = ACTIONS(3623),
    [anon_sym___asm] = ACTIONS(3623),
    [sym_number_literal] = ACTIONS(3621),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3621),
    [anon_sym_u_DQUOTE] = ACTIONS(3621),
    [anon_sym_U_DQUOTE] = ACTIONS(3621),
    [anon_sym_u8_DQUOTE] = ACTIONS(3621),
    [anon_sym_DQUOTE] = ACTIONS(3621),
    [sym_true] = ACTIONS(3623),
    [sym_false] = ACTIONS(3623),
    [anon_sym_NULL] = ACTIONS(3623),
    [anon_sym_nullptr] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3623),
    [anon_sym_let] = ACTIONS(3623),
    [anon_sym_This] = ACTIONS(3623),
    [anon_sym_decltype] = ACTIONS(3623),
    [anon_sym_explicit] = ACTIONS(3623),
    [anon_sym_typename] = ACTIONS(3623),
    [anon_sym_export] = ACTIONS(3623),
    [anon_sym_module] = ACTIONS(3623),
    [anon_sym_import] = ACTIONS(3623),
    [anon_sym_template] = ACTIONS(3623),
    [anon_sym_operator] = ACTIONS(3623),
    [anon_sym_try] = ACTIONS(3623),
    [anon_sym_delete] = ACTIONS(3623),
    [anon_sym_throw] = ACTIONS(3623),
    [anon_sym_namespace] = ACTIONS(3623),
    [anon_sym_static_assert] = ACTIONS(3623),
    [anon_sym_concept] = ACTIONS(3623),
    [anon_sym_co_return] = ACTIONS(3623),
    [anon_sym_co_yield] = ACTIONS(3623),
    [anon_sym_R_DQUOTE] = ACTIONS(3621),
    [anon_sym_LR_DQUOTE] = ACTIONS(3621),
    [anon_sym_uR_DQUOTE] = ACTIONS(3621),
    [anon_sym_UR_DQUOTE] = ACTIONS(3621),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3621),
    [anon_sym_co_await] = ACTIONS(3623),
    [anon_sym_new] = ACTIONS(3623),
    [anon_sym_requires] = ACTIONS(3623),
    [sym_this] = ACTIONS(3623),
    [anon_sym_discard] = ACTIONS(3623),
    [anon_sym_precise] = ACTIONS(3623),
    [anon_sym_shared] = ACTIONS(3623),
    [anon_sym_groupshared] = ACTIONS(3623),
    [anon_sym_uniform] = ACTIONS(3623),
    [anon_sym_row_major] = ACTIONS(3623),
    [anon_sym_column_major] = ACTIONS(3623),
    [anon_sym_globallycoherent] = ACTIONS(3623),
    [anon_sym_centroid] = ACTIONS(3623),
    [anon_sym_noperspective] = ACTIONS(3623),
    [anon_sym_nointerpolation] = ACTIONS(3623),
    [anon_sym_sample] = ACTIONS(3623),
    [anon_sym_linear] = ACTIONS(3623),
    [anon_sym_snorm] = ACTIONS(3623),
    [anon_sym_unorm] = ACTIONS(3623),
    [anon_sym_point] = ACTIONS(3623),
    [anon_sym_line] = ACTIONS(3623),
    [anon_sym_triangleadj] = ACTIONS(3623),
    [anon_sym_lineadj] = ACTIONS(3623),
    [anon_sym_triangle] = ACTIONS(3623),
    [anon_sym_cbuffer] = ACTIONS(3623),
    [anon_sym_interface] = ACTIONS(3623),
    [anon_sym_extension] = ACTIONS(3623),
    [anon_sym___exported] = ACTIONS(3623),
  },
  [467] = {
    [sym_identifier] = ACTIONS(3562),
    [aux_sym_preproc_include_token1] = ACTIONS(3562),
    [aux_sym_preproc_def_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token2] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3562),
    [aux_sym_preproc_else_token1] = ACTIONS(3562),
    [aux_sym_preproc_elif_token1] = ACTIONS(3562),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3562),
    [sym_preproc_directive] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym___extension__] = ACTIONS(3562),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_in] = ACTIONS(3562),
    [anon_sym_out] = ACTIONS(3562),
    [anon_sym_inout] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym___attribute__] = ACTIONS(3562),
    [anon_sym___attribute] = ACTIONS(3562),
    [anon_sym_using] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3560),
    [anon_sym___declspec] = ACTIONS(3562),
    [anon_sym___based] = ACTIONS(3562),
    [anon_sym___cdecl] = ACTIONS(3562),
    [anon_sym___clrcall] = ACTIONS(3562),
    [anon_sym___stdcall] = ACTIONS(3562),
    [anon_sym___fastcall] = ACTIONS(3562),
    [anon_sym___thiscall] = ACTIONS(3562),
    [anon_sym___vectorcall] = ACTIONS(3562),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_signed] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym___inline] = ACTIONS(3562),
    [anon_sym___inline__] = ACTIONS(3562),
    [anon_sym___forceinline] = ACTIONS(3562),
    [anon_sym_thread_local] = ACTIONS(3562),
    [anon_sym___thread] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_constexpr] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym___restrict__] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym__Noreturn] = ACTIONS(3562),
    [anon_sym_noreturn] = ACTIONS(3562),
    [anon_sym__Nonnull] = ACTIONS(3562),
    [anon_sym_mutable] = ACTIONS(3562),
    [anon_sym_constinit] = ACTIONS(3562),
    [anon_sym_consteval] = ACTIONS(3562),
    [anon_sym_alignas] = ACTIONS(3562),
    [anon_sym__Alignas] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_else] = ACTIONS(3562),
    [anon_sym_switch] = ACTIONS(3562),
    [anon_sym_case] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_goto] = ACTIONS(3562),
    [anon_sym___try] = ACTIONS(3562),
    [anon_sym___leave] = ACTIONS(3562),
    [anon_sym_not] = ACTIONS(3562),
    [anon_sym_compl] = ACTIONS(3562),
    [anon_sym_DASH_DASH] = ACTIONS(3560),
    [anon_sym_PLUS_PLUS] = ACTIONS(3560),
    [anon_sym_sizeof] = ACTIONS(3562),
    [anon_sym___alignof__] = ACTIONS(3562),
    [anon_sym___alignof] = ACTIONS(3562),
    [anon_sym__alignof] = ACTIONS(3562),
    [anon_sym_alignof] = ACTIONS(3562),
    [anon_sym__Alignof] = ACTIONS(3562),
    [anon_sym_offsetof] = ACTIONS(3562),
    [anon_sym__Generic] = ACTIONS(3562),
    [anon_sym_asm] = ACTIONS(3562),
    [anon_sym___asm__] = ACTIONS(3562),
    [anon_sym___asm] = ACTIONS(3562),
    [sym_number_literal] = ACTIONS(3560),
    [anon_sym_L_SQUOTE] = ACTIONS(3560),
    [anon_sym_u_SQUOTE] = ACTIONS(3560),
    [anon_sym_U_SQUOTE] = ACTIONS(3560),
    [anon_sym_u8_SQUOTE] = ACTIONS(3560),
    [anon_sym_SQUOTE] = ACTIONS(3560),
    [anon_sym_L_DQUOTE] = ACTIONS(3560),
    [anon_sym_u_DQUOTE] = ACTIONS(3560),
    [anon_sym_U_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE] = ACTIONS(3560),
    [sym_true] = ACTIONS(3562),
    [sym_false] = ACTIONS(3562),
    [anon_sym_NULL] = ACTIONS(3562),
    [anon_sym_nullptr] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_This] = ACTIONS(3562),
    [anon_sym_decltype] = ACTIONS(3562),
    [anon_sym_explicit] = ACTIONS(3562),
    [anon_sym_typename] = ACTIONS(3562),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_delete] = ACTIONS(3562),
    [anon_sym_throw] = ACTIONS(3562),
    [anon_sym_namespace] = ACTIONS(3562),
    [anon_sym_static_assert] = ACTIONS(3562),
    [anon_sym_concept] = ACTIONS(3562),
    [anon_sym_co_return] = ACTIONS(3562),
    [anon_sym_co_yield] = ACTIONS(3562),
    [anon_sym_R_DQUOTE] = ACTIONS(3560),
    [anon_sym_LR_DQUOTE] = ACTIONS(3560),
    [anon_sym_uR_DQUOTE] = ACTIONS(3560),
    [anon_sym_UR_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3560),
    [anon_sym_co_await] = ACTIONS(3562),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_requires] = ACTIONS(3562),
    [sym_this] = ACTIONS(3562),
    [anon_sym_discard] = ACTIONS(3562),
    [anon_sym_precise] = ACTIONS(3562),
    [anon_sym_shared] = ACTIONS(3562),
    [anon_sym_groupshared] = ACTIONS(3562),
    [anon_sym_uniform] = ACTIONS(3562),
    [anon_sym_row_major] = ACTIONS(3562),
    [anon_sym_column_major] = ACTIONS(3562),
    [anon_sym_globallycoherent] = ACTIONS(3562),
    [anon_sym_centroid] = ACTIONS(3562),
    [anon_sym_noperspective] = ACTIONS(3562),
    [anon_sym_nointerpolation] = ACTIONS(3562),
    [anon_sym_sample] = ACTIONS(3562),
    [anon_sym_linear] = ACTIONS(3562),
    [anon_sym_snorm] = ACTIONS(3562),
    [anon_sym_unorm] = ACTIONS(3562),
    [anon_sym_point] = ACTIONS(3562),
    [anon_sym_line] = ACTIONS(3562),
    [anon_sym_triangleadj] = ACTIONS(3562),
    [anon_sym_lineadj] = ACTIONS(3562),
    [anon_sym_triangle] = ACTIONS(3562),
    [anon_sym_cbuffer] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_extension] = ACTIONS(3562),
  },
  [468] = {
    [ts_builtin_sym_end] = ACTIONS(3621),
    [sym_identifier] = ACTIONS(3623),
    [aux_sym_preproc_include_token1] = ACTIONS(3623),
    [aux_sym_preproc_def_token1] = ACTIONS(3623),
    [aux_sym_preproc_if_token1] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3623),
    [sym_preproc_directive] = ACTIONS(3623),
    [anon_sym_LPAREN2] = ACTIONS(3621),
    [anon_sym_BANG] = ACTIONS(3621),
    [anon_sym_TILDE] = ACTIONS(3621),
    [anon_sym_DASH] = ACTIONS(3623),
    [anon_sym_PLUS] = ACTIONS(3623),
    [anon_sym_STAR] = ACTIONS(3621),
    [anon_sym_AMP_AMP] = ACTIONS(3621),
    [anon_sym_AMP] = ACTIONS(3623),
    [anon_sym_SEMI] = ACTIONS(3621),
    [anon_sym___extension__] = ACTIONS(3623),
    [anon_sym_typedef] = ACTIONS(3623),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_out] = ACTIONS(3623),
    [anon_sym_inout] = ACTIONS(3623),
    [anon_sym_virtual] = ACTIONS(3623),
    [anon_sym_extern] = ACTIONS(3623),
    [anon_sym___attribute__] = ACTIONS(3623),
    [anon_sym___attribute] = ACTIONS(3623),
    [anon_sym_using] = ACTIONS(3623),
    [anon_sym_COLON_COLON] = ACTIONS(3621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3621),
    [anon_sym___declspec] = ACTIONS(3623),
    [anon_sym___based] = ACTIONS(3623),
    [anon_sym___cdecl] = ACTIONS(3623),
    [anon_sym___clrcall] = ACTIONS(3623),
    [anon_sym___stdcall] = ACTIONS(3623),
    [anon_sym___fastcall] = ACTIONS(3623),
    [anon_sym___thiscall] = ACTIONS(3623),
    [anon_sym___vectorcall] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3621),
    [anon_sym_signed] = ACTIONS(3623),
    [anon_sym_unsigned] = ACTIONS(3623),
    [anon_sym_long] = ACTIONS(3623),
    [anon_sym_short] = ACTIONS(3623),
    [anon_sym_LBRACK] = ACTIONS(3623),
    [anon_sym_static] = ACTIONS(3623),
    [anon_sym_register] = ACTIONS(3623),
    [anon_sym_inline] = ACTIONS(3623),
    [anon_sym___inline] = ACTIONS(3623),
    [anon_sym___inline__] = ACTIONS(3623),
    [anon_sym___forceinline] = ACTIONS(3623),
    [anon_sym_thread_local] = ACTIONS(3623),
    [anon_sym___thread] = ACTIONS(3623),
    [anon_sym_const] = ACTIONS(3623),
    [anon_sym_constexpr] = ACTIONS(3623),
    [anon_sym_volatile] = ACTIONS(3623),
    [anon_sym_restrict] = ACTIONS(3623),
    [anon_sym___restrict__] = ACTIONS(3623),
    [anon_sym__Atomic] = ACTIONS(3623),
    [anon_sym__Noreturn] = ACTIONS(3623),
    [anon_sym_noreturn] = ACTIONS(3623),
    [anon_sym__Nonnull] = ACTIONS(3623),
    [anon_sym_mutable] = ACTIONS(3623),
    [anon_sym_constinit] = ACTIONS(3623),
    [anon_sym_consteval] = ACTIONS(3623),
    [anon_sym_alignas] = ACTIONS(3623),
    [anon_sym__Alignas] = ACTIONS(3623),
    [sym_primitive_type] = ACTIONS(3623),
    [anon_sym_enum] = ACTIONS(3623),
    [anon_sym_class] = ACTIONS(3623),
    [anon_sym_struct] = ACTIONS(3623),
    [anon_sym_union] = ACTIONS(3623),
    [anon_sym_if] = ACTIONS(3623),
    [anon_sym_else] = ACTIONS(3623),
    [anon_sym_switch] = ACTIONS(3623),
    [anon_sym_case] = ACTIONS(3623),
    [anon_sym_default] = ACTIONS(3623),
    [anon_sym_while] = ACTIONS(3623),
    [anon_sym_do] = ACTIONS(3623),
    [anon_sym_for] = ACTIONS(3623),
    [anon_sym_return] = ACTIONS(3623),
    [anon_sym_break] = ACTIONS(3623),
    [anon_sym_continue] = ACTIONS(3623),
    [anon_sym_goto] = ACTIONS(3623),
    [anon_sym___try] = ACTIONS(3623),
    [anon_sym___leave] = ACTIONS(3623),
    [anon_sym_not] = ACTIONS(3623),
    [anon_sym_compl] = ACTIONS(3623),
    [anon_sym_DASH_DASH] = ACTIONS(3621),
    [anon_sym_PLUS_PLUS] = ACTIONS(3621),
    [anon_sym_sizeof] = ACTIONS(3623),
    [anon_sym___alignof__] = ACTIONS(3623),
    [anon_sym___alignof] = ACTIONS(3623),
    [anon_sym__alignof] = ACTIONS(3623),
    [anon_sym_alignof] = ACTIONS(3623),
    [anon_sym__Alignof] = ACTIONS(3623),
    [anon_sym_offsetof] = ACTIONS(3623),
    [anon_sym__Generic] = ACTIONS(3623),
    [anon_sym_asm] = ACTIONS(3623),
    [anon_sym___asm__] = ACTIONS(3623),
    [anon_sym___asm] = ACTIONS(3623),
    [sym_number_literal] = ACTIONS(3621),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3621),
    [anon_sym_u_DQUOTE] = ACTIONS(3621),
    [anon_sym_U_DQUOTE] = ACTIONS(3621),
    [anon_sym_u8_DQUOTE] = ACTIONS(3621),
    [anon_sym_DQUOTE] = ACTIONS(3621),
    [sym_true] = ACTIONS(3623),
    [sym_false] = ACTIONS(3623),
    [anon_sym_NULL] = ACTIONS(3623),
    [anon_sym_nullptr] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3623),
    [anon_sym_let] = ACTIONS(3623),
    [anon_sym_This] = ACTIONS(3623),
    [anon_sym_decltype] = ACTIONS(3623),
    [anon_sym_explicit] = ACTIONS(3623),
    [anon_sym_typename] = ACTIONS(3623),
    [anon_sym_export] = ACTIONS(3623),
    [anon_sym_module] = ACTIONS(3623),
    [anon_sym_import] = ACTIONS(3623),
    [anon_sym_template] = ACTIONS(3623),
    [anon_sym_operator] = ACTIONS(3623),
    [anon_sym_try] = ACTIONS(3623),
    [anon_sym_delete] = ACTIONS(3623),
    [anon_sym_throw] = ACTIONS(3623),
    [anon_sym_namespace] = ACTIONS(3623),
    [anon_sym_static_assert] = ACTIONS(3623),
    [anon_sym_concept] = ACTIONS(3623),
    [anon_sym_co_return] = ACTIONS(3623),
    [anon_sym_co_yield] = ACTIONS(3623),
    [anon_sym_R_DQUOTE] = ACTIONS(3621),
    [anon_sym_LR_DQUOTE] = ACTIONS(3621),
    [anon_sym_uR_DQUOTE] = ACTIONS(3621),
    [anon_sym_UR_DQUOTE] = ACTIONS(3621),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3621),
    [anon_sym_co_await] = ACTIONS(3623),
    [anon_sym_new] = ACTIONS(3623),
    [anon_sym_requires] = ACTIONS(3623),
    [sym_this] = ACTIONS(3623),
    [anon_sym_discard] = ACTIONS(3623),
    [anon_sym_precise] = ACTIONS(3623),
    [anon_sym_shared] = ACTIONS(3623),
    [anon_sym_groupshared] = ACTIONS(3623),
    [anon_sym_uniform] = ACTIONS(3623),
    [anon_sym_row_major] = ACTIONS(3623),
    [anon_sym_column_major] = ACTIONS(3623),
    [anon_sym_globallycoherent] = ACTIONS(3623),
    [anon_sym_centroid] = ACTIONS(3623),
    [anon_sym_noperspective] = ACTIONS(3623),
    [anon_sym_nointerpolation] = ACTIONS(3623),
    [anon_sym_sample] = ACTIONS(3623),
    [anon_sym_linear] = ACTIONS(3623),
    [anon_sym_snorm] = ACTIONS(3623),
    [anon_sym_unorm] = ACTIONS(3623),
    [anon_sym_point] = ACTIONS(3623),
    [anon_sym_line] = ACTIONS(3623),
    [anon_sym_triangleadj] = ACTIONS(3623),
    [anon_sym_lineadj] = ACTIONS(3623),
    [anon_sym_triangle] = ACTIONS(3623),
    [anon_sym_cbuffer] = ACTIONS(3623),
    [anon_sym_interface] = ACTIONS(3623),
    [anon_sym_extension] = ACTIONS(3623),
    [anon_sym___exported] = ACTIONS(3623),
  },
  [469] = {
    [sym_identifier] = ACTIONS(3562),
    [aux_sym_preproc_include_token1] = ACTIONS(3562),
    [aux_sym_preproc_def_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token2] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3562),
    [aux_sym_preproc_else_token1] = ACTIONS(3562),
    [aux_sym_preproc_elif_token1] = ACTIONS(3562),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3562),
    [sym_preproc_directive] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym___extension__] = ACTIONS(3562),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_in] = ACTIONS(3562),
    [anon_sym_out] = ACTIONS(3562),
    [anon_sym_inout] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym___attribute__] = ACTIONS(3562),
    [anon_sym___attribute] = ACTIONS(3562),
    [anon_sym_using] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3560),
    [anon_sym___declspec] = ACTIONS(3562),
    [anon_sym___based] = ACTIONS(3562),
    [anon_sym___cdecl] = ACTIONS(3562),
    [anon_sym___clrcall] = ACTIONS(3562),
    [anon_sym___stdcall] = ACTIONS(3562),
    [anon_sym___fastcall] = ACTIONS(3562),
    [anon_sym___thiscall] = ACTIONS(3562),
    [anon_sym___vectorcall] = ACTIONS(3562),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_signed] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym___inline] = ACTIONS(3562),
    [anon_sym___inline__] = ACTIONS(3562),
    [anon_sym___forceinline] = ACTIONS(3562),
    [anon_sym_thread_local] = ACTIONS(3562),
    [anon_sym___thread] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_constexpr] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym___restrict__] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym__Noreturn] = ACTIONS(3562),
    [anon_sym_noreturn] = ACTIONS(3562),
    [anon_sym__Nonnull] = ACTIONS(3562),
    [anon_sym_mutable] = ACTIONS(3562),
    [anon_sym_constinit] = ACTIONS(3562),
    [anon_sym_consteval] = ACTIONS(3562),
    [anon_sym_alignas] = ACTIONS(3562),
    [anon_sym__Alignas] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_else] = ACTIONS(3562),
    [anon_sym_switch] = ACTIONS(3562),
    [anon_sym_case] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_goto] = ACTIONS(3562),
    [anon_sym___try] = ACTIONS(3562),
    [anon_sym___leave] = ACTIONS(3562),
    [anon_sym_not] = ACTIONS(3562),
    [anon_sym_compl] = ACTIONS(3562),
    [anon_sym_DASH_DASH] = ACTIONS(3560),
    [anon_sym_PLUS_PLUS] = ACTIONS(3560),
    [anon_sym_sizeof] = ACTIONS(3562),
    [anon_sym___alignof__] = ACTIONS(3562),
    [anon_sym___alignof] = ACTIONS(3562),
    [anon_sym__alignof] = ACTIONS(3562),
    [anon_sym_alignof] = ACTIONS(3562),
    [anon_sym__Alignof] = ACTIONS(3562),
    [anon_sym_offsetof] = ACTIONS(3562),
    [anon_sym__Generic] = ACTIONS(3562),
    [anon_sym_asm] = ACTIONS(3562),
    [anon_sym___asm__] = ACTIONS(3562),
    [anon_sym___asm] = ACTIONS(3562),
    [sym_number_literal] = ACTIONS(3560),
    [anon_sym_L_SQUOTE] = ACTIONS(3560),
    [anon_sym_u_SQUOTE] = ACTIONS(3560),
    [anon_sym_U_SQUOTE] = ACTIONS(3560),
    [anon_sym_u8_SQUOTE] = ACTIONS(3560),
    [anon_sym_SQUOTE] = ACTIONS(3560),
    [anon_sym_L_DQUOTE] = ACTIONS(3560),
    [anon_sym_u_DQUOTE] = ACTIONS(3560),
    [anon_sym_U_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE] = ACTIONS(3560),
    [sym_true] = ACTIONS(3562),
    [sym_false] = ACTIONS(3562),
    [anon_sym_NULL] = ACTIONS(3562),
    [anon_sym_nullptr] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_This] = ACTIONS(3562),
    [anon_sym_decltype] = ACTIONS(3562),
    [anon_sym_explicit] = ACTIONS(3562),
    [anon_sym_typename] = ACTIONS(3562),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_delete] = ACTIONS(3562),
    [anon_sym_throw] = ACTIONS(3562),
    [anon_sym_namespace] = ACTIONS(3562),
    [anon_sym_static_assert] = ACTIONS(3562),
    [anon_sym_concept] = ACTIONS(3562),
    [anon_sym_co_return] = ACTIONS(3562),
    [anon_sym_co_yield] = ACTIONS(3562),
    [anon_sym_R_DQUOTE] = ACTIONS(3560),
    [anon_sym_LR_DQUOTE] = ACTIONS(3560),
    [anon_sym_uR_DQUOTE] = ACTIONS(3560),
    [anon_sym_UR_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3560),
    [anon_sym_co_await] = ACTIONS(3562),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_requires] = ACTIONS(3562),
    [sym_this] = ACTIONS(3562),
    [anon_sym_discard] = ACTIONS(3562),
    [anon_sym_precise] = ACTIONS(3562),
    [anon_sym_shared] = ACTIONS(3562),
    [anon_sym_groupshared] = ACTIONS(3562),
    [anon_sym_uniform] = ACTIONS(3562),
    [anon_sym_row_major] = ACTIONS(3562),
    [anon_sym_column_major] = ACTIONS(3562),
    [anon_sym_globallycoherent] = ACTIONS(3562),
    [anon_sym_centroid] = ACTIONS(3562),
    [anon_sym_noperspective] = ACTIONS(3562),
    [anon_sym_nointerpolation] = ACTIONS(3562),
    [anon_sym_sample] = ACTIONS(3562),
    [anon_sym_linear] = ACTIONS(3562),
    [anon_sym_snorm] = ACTIONS(3562),
    [anon_sym_unorm] = ACTIONS(3562),
    [anon_sym_point] = ACTIONS(3562),
    [anon_sym_line] = ACTIONS(3562),
    [anon_sym_triangleadj] = ACTIONS(3562),
    [anon_sym_lineadj] = ACTIONS(3562),
    [anon_sym_triangle] = ACTIONS(3562),
    [anon_sym_cbuffer] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_extension] = ACTIONS(3562),
  },
  [470] = {
    [ts_builtin_sym_end] = ACTIONS(3625),
    [sym_identifier] = ACTIONS(3627),
    [aux_sym_preproc_include_token1] = ACTIONS(3627),
    [aux_sym_preproc_def_token1] = ACTIONS(3627),
    [aux_sym_preproc_if_token1] = ACTIONS(3627),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3627),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3627),
    [sym_preproc_directive] = ACTIONS(3627),
    [anon_sym_LPAREN2] = ACTIONS(3625),
    [anon_sym_BANG] = ACTIONS(3625),
    [anon_sym_TILDE] = ACTIONS(3625),
    [anon_sym_DASH] = ACTIONS(3627),
    [anon_sym_PLUS] = ACTIONS(3627),
    [anon_sym_STAR] = ACTIONS(3625),
    [anon_sym_AMP_AMP] = ACTIONS(3625),
    [anon_sym_AMP] = ACTIONS(3627),
    [anon_sym_SEMI] = ACTIONS(3625),
    [anon_sym___extension__] = ACTIONS(3627),
    [anon_sym_typedef] = ACTIONS(3627),
    [anon_sym_in] = ACTIONS(3627),
    [anon_sym_out] = ACTIONS(3627),
    [anon_sym_inout] = ACTIONS(3627),
    [anon_sym_virtual] = ACTIONS(3627),
    [anon_sym_extern] = ACTIONS(3627),
    [anon_sym___attribute__] = ACTIONS(3627),
    [anon_sym___attribute] = ACTIONS(3627),
    [anon_sym_using] = ACTIONS(3627),
    [anon_sym_COLON_COLON] = ACTIONS(3625),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3625),
    [anon_sym___declspec] = ACTIONS(3627),
    [anon_sym___based] = ACTIONS(3627),
    [anon_sym___cdecl] = ACTIONS(3627),
    [anon_sym___clrcall] = ACTIONS(3627),
    [anon_sym___stdcall] = ACTIONS(3627),
    [anon_sym___fastcall] = ACTIONS(3627),
    [anon_sym___thiscall] = ACTIONS(3627),
    [anon_sym___vectorcall] = ACTIONS(3627),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_signed] = ACTIONS(3627),
    [anon_sym_unsigned] = ACTIONS(3627),
    [anon_sym_long] = ACTIONS(3627),
    [anon_sym_short] = ACTIONS(3627),
    [anon_sym_LBRACK] = ACTIONS(3627),
    [anon_sym_static] = ACTIONS(3627),
    [anon_sym_register] = ACTIONS(3627),
    [anon_sym_inline] = ACTIONS(3627),
    [anon_sym___inline] = ACTIONS(3627),
    [anon_sym___inline__] = ACTIONS(3627),
    [anon_sym___forceinline] = ACTIONS(3627),
    [anon_sym_thread_local] = ACTIONS(3627),
    [anon_sym___thread] = ACTIONS(3627),
    [anon_sym_const] = ACTIONS(3627),
    [anon_sym_constexpr] = ACTIONS(3627),
    [anon_sym_volatile] = ACTIONS(3627),
    [anon_sym_restrict] = ACTIONS(3627),
    [anon_sym___restrict__] = ACTIONS(3627),
    [anon_sym__Atomic] = ACTIONS(3627),
    [anon_sym__Noreturn] = ACTIONS(3627),
    [anon_sym_noreturn] = ACTIONS(3627),
    [anon_sym__Nonnull] = ACTIONS(3627),
    [anon_sym_mutable] = ACTIONS(3627),
    [anon_sym_constinit] = ACTIONS(3627),
    [anon_sym_consteval] = ACTIONS(3627),
    [anon_sym_alignas] = ACTIONS(3627),
    [anon_sym__Alignas] = ACTIONS(3627),
    [sym_primitive_type] = ACTIONS(3627),
    [anon_sym_enum] = ACTIONS(3627),
    [anon_sym_class] = ACTIONS(3627),
    [anon_sym_struct] = ACTIONS(3627),
    [anon_sym_union] = ACTIONS(3627),
    [anon_sym_if] = ACTIONS(3627),
    [anon_sym_else] = ACTIONS(3627),
    [anon_sym_switch] = ACTIONS(3627),
    [anon_sym_case] = ACTIONS(3627),
    [anon_sym_default] = ACTIONS(3627),
    [anon_sym_while] = ACTIONS(3627),
    [anon_sym_do] = ACTIONS(3627),
    [anon_sym_for] = ACTIONS(3627),
    [anon_sym_return] = ACTIONS(3627),
    [anon_sym_break] = ACTIONS(3627),
    [anon_sym_continue] = ACTIONS(3627),
    [anon_sym_goto] = ACTIONS(3627),
    [anon_sym___try] = ACTIONS(3627),
    [anon_sym___leave] = ACTIONS(3627),
    [anon_sym_not] = ACTIONS(3627),
    [anon_sym_compl] = ACTIONS(3627),
    [anon_sym_DASH_DASH] = ACTIONS(3625),
    [anon_sym_PLUS_PLUS] = ACTIONS(3625),
    [anon_sym_sizeof] = ACTIONS(3627),
    [anon_sym___alignof__] = ACTIONS(3627),
    [anon_sym___alignof] = ACTIONS(3627),
    [anon_sym__alignof] = ACTIONS(3627),
    [anon_sym_alignof] = ACTIONS(3627),
    [anon_sym__Alignof] = ACTIONS(3627),
    [anon_sym_offsetof] = ACTIONS(3627),
    [anon_sym__Generic] = ACTIONS(3627),
    [anon_sym_asm] = ACTIONS(3627),
    [anon_sym___asm__] = ACTIONS(3627),
    [anon_sym___asm] = ACTIONS(3627),
    [sym_number_literal] = ACTIONS(3625),
    [anon_sym_L_SQUOTE] = ACTIONS(3625),
    [anon_sym_u_SQUOTE] = ACTIONS(3625),
    [anon_sym_U_SQUOTE] = ACTIONS(3625),
    [anon_sym_u8_SQUOTE] = ACTIONS(3625),
    [anon_sym_SQUOTE] = ACTIONS(3625),
    [anon_sym_L_DQUOTE] = ACTIONS(3625),
    [anon_sym_u_DQUOTE] = ACTIONS(3625),
    [anon_sym_U_DQUOTE] = ACTIONS(3625),
    [anon_sym_u8_DQUOTE] = ACTIONS(3625),
    [anon_sym_DQUOTE] = ACTIONS(3625),
    [sym_true] = ACTIONS(3627),
    [sym_false] = ACTIONS(3627),
    [anon_sym_NULL] = ACTIONS(3627),
    [anon_sym_nullptr] = ACTIONS(3627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3627),
    [anon_sym_let] = ACTIONS(3627),
    [anon_sym_This] = ACTIONS(3627),
    [anon_sym_decltype] = ACTIONS(3627),
    [anon_sym_explicit] = ACTIONS(3627),
    [anon_sym_typename] = ACTIONS(3627),
    [anon_sym_export] = ACTIONS(3627),
    [anon_sym_module] = ACTIONS(3627),
    [anon_sym_import] = ACTIONS(3627),
    [anon_sym_template] = ACTIONS(3627),
    [anon_sym_operator] = ACTIONS(3627),
    [anon_sym_try] = ACTIONS(3627),
    [anon_sym_delete] = ACTIONS(3627),
    [anon_sym_throw] = ACTIONS(3627),
    [anon_sym_namespace] = ACTIONS(3627),
    [anon_sym_static_assert] = ACTIONS(3627),
    [anon_sym_concept] = ACTIONS(3627),
    [anon_sym_co_return] = ACTIONS(3627),
    [anon_sym_co_yield] = ACTIONS(3627),
    [anon_sym_R_DQUOTE] = ACTIONS(3625),
    [anon_sym_LR_DQUOTE] = ACTIONS(3625),
    [anon_sym_uR_DQUOTE] = ACTIONS(3625),
    [anon_sym_UR_DQUOTE] = ACTIONS(3625),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3625),
    [anon_sym_co_await] = ACTIONS(3627),
    [anon_sym_new] = ACTIONS(3627),
    [anon_sym_requires] = ACTIONS(3627),
    [sym_this] = ACTIONS(3627),
    [anon_sym_discard] = ACTIONS(3627),
    [anon_sym_precise] = ACTIONS(3627),
    [anon_sym_shared] = ACTIONS(3627),
    [anon_sym_groupshared] = ACTIONS(3627),
    [anon_sym_uniform] = ACTIONS(3627),
    [anon_sym_row_major] = ACTIONS(3627),
    [anon_sym_column_major] = ACTIONS(3627),
    [anon_sym_globallycoherent] = ACTIONS(3627),
    [anon_sym_centroid] = ACTIONS(3627),
    [anon_sym_noperspective] = ACTIONS(3627),
    [anon_sym_nointerpolation] = ACTIONS(3627),
    [anon_sym_sample] = ACTIONS(3627),
    [anon_sym_linear] = ACTIONS(3627),
    [anon_sym_snorm] = ACTIONS(3627),
    [anon_sym_unorm] = ACTIONS(3627),
    [anon_sym_point] = ACTIONS(3627),
    [anon_sym_line] = ACTIONS(3627),
    [anon_sym_triangleadj] = ACTIONS(3627),
    [anon_sym_lineadj] = ACTIONS(3627),
    [anon_sym_triangle] = ACTIONS(3627),
    [anon_sym_cbuffer] = ACTIONS(3627),
    [anon_sym_interface] = ACTIONS(3627),
    [anon_sym_extension] = ACTIONS(3627),
    [anon_sym___exported] = ACTIONS(3627),
  },
  [471] = {
    [ts_builtin_sym_end] = ACTIONS(3381),
    [sym_identifier] = ACTIONS(3379),
    [aux_sym_preproc_include_token1] = ACTIONS(3379),
    [aux_sym_preproc_def_token1] = ACTIONS(3379),
    [aux_sym_preproc_if_token1] = ACTIONS(3379),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3379),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3379),
    [sym_preproc_directive] = ACTIONS(3379),
    [anon_sym_LPAREN2] = ACTIONS(3381),
    [anon_sym_BANG] = ACTIONS(3381),
    [anon_sym_TILDE] = ACTIONS(3381),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_STAR] = ACTIONS(3381),
    [anon_sym_AMP_AMP] = ACTIONS(3381),
    [anon_sym_AMP] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3381),
    [anon_sym___extension__] = ACTIONS(3379),
    [anon_sym_typedef] = ACTIONS(3379),
    [anon_sym_in] = ACTIONS(3379),
    [anon_sym_out] = ACTIONS(3379),
    [anon_sym_inout] = ACTIONS(3379),
    [anon_sym_virtual] = ACTIONS(3379),
    [anon_sym_extern] = ACTIONS(3379),
    [anon_sym___attribute__] = ACTIONS(3379),
    [anon_sym___attribute] = ACTIONS(3379),
    [anon_sym_using] = ACTIONS(3379),
    [anon_sym_COLON_COLON] = ACTIONS(3381),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3381),
    [anon_sym___declspec] = ACTIONS(3379),
    [anon_sym___based] = ACTIONS(3379),
    [anon_sym___cdecl] = ACTIONS(3379),
    [anon_sym___clrcall] = ACTIONS(3379),
    [anon_sym___stdcall] = ACTIONS(3379),
    [anon_sym___fastcall] = ACTIONS(3379),
    [anon_sym___thiscall] = ACTIONS(3379),
    [anon_sym___vectorcall] = ACTIONS(3379),
    [anon_sym_LBRACE] = ACTIONS(3381),
    [anon_sym_signed] = ACTIONS(3379),
    [anon_sym_unsigned] = ACTIONS(3379),
    [anon_sym_long] = ACTIONS(3379),
    [anon_sym_short] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_register] = ACTIONS(3379),
    [anon_sym_inline] = ACTIONS(3379),
    [anon_sym___inline] = ACTIONS(3379),
    [anon_sym___inline__] = ACTIONS(3379),
    [anon_sym___forceinline] = ACTIONS(3379),
    [anon_sym_thread_local] = ACTIONS(3379),
    [anon_sym___thread] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_constexpr] = ACTIONS(3379),
    [anon_sym_volatile] = ACTIONS(3379),
    [anon_sym_restrict] = ACTIONS(3379),
    [anon_sym___restrict__] = ACTIONS(3379),
    [anon_sym__Atomic] = ACTIONS(3379),
    [anon_sym__Noreturn] = ACTIONS(3379),
    [anon_sym_noreturn] = ACTIONS(3379),
    [anon_sym__Nonnull] = ACTIONS(3379),
    [anon_sym_mutable] = ACTIONS(3379),
    [anon_sym_constinit] = ACTIONS(3379),
    [anon_sym_consteval] = ACTIONS(3379),
    [anon_sym_alignas] = ACTIONS(3379),
    [anon_sym__Alignas] = ACTIONS(3379),
    [sym_primitive_type] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_struct] = ACTIONS(3379),
    [anon_sym_union] = ACTIONS(3379),
    [anon_sym_if] = ACTIONS(3379),
    [anon_sym_else] = ACTIONS(3379),
    [anon_sym_switch] = ACTIONS(3379),
    [anon_sym_case] = ACTIONS(3379),
    [anon_sym_default] = ACTIONS(3379),
    [anon_sym_while] = ACTIONS(3379),
    [anon_sym_do] = ACTIONS(3379),
    [anon_sym_for] = ACTIONS(3379),
    [anon_sym_return] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(3379),
    [anon_sym_continue] = ACTIONS(3379),
    [anon_sym_goto] = ACTIONS(3379),
    [anon_sym___try] = ACTIONS(3379),
    [anon_sym___leave] = ACTIONS(3379),
    [anon_sym_not] = ACTIONS(3379),
    [anon_sym_compl] = ACTIONS(3379),
    [anon_sym_DASH_DASH] = ACTIONS(3381),
    [anon_sym_PLUS_PLUS] = ACTIONS(3381),
    [anon_sym_sizeof] = ACTIONS(3379),
    [anon_sym___alignof__] = ACTIONS(3379),
    [anon_sym___alignof] = ACTIONS(3379),
    [anon_sym__alignof] = ACTIONS(3379),
    [anon_sym_alignof] = ACTIONS(3379),
    [anon_sym__Alignof] = ACTIONS(3379),
    [anon_sym_offsetof] = ACTIONS(3379),
    [anon_sym__Generic] = ACTIONS(3379),
    [anon_sym_asm] = ACTIONS(3379),
    [anon_sym___asm__] = ACTIONS(3379),
    [anon_sym___asm] = ACTIONS(3379),
    [sym_number_literal] = ACTIONS(3381),
    [anon_sym_L_SQUOTE] = ACTIONS(3381),
    [anon_sym_u_SQUOTE] = ACTIONS(3381),
    [anon_sym_U_SQUOTE] = ACTIONS(3381),
    [anon_sym_u8_SQUOTE] = ACTIONS(3381),
    [anon_sym_SQUOTE] = ACTIONS(3381),
    [anon_sym_L_DQUOTE] = ACTIONS(3381),
    [anon_sym_u_DQUOTE] = ACTIONS(3381),
    [anon_sym_U_DQUOTE] = ACTIONS(3381),
    [anon_sym_u8_DQUOTE] = ACTIONS(3381),
    [anon_sym_DQUOTE] = ACTIONS(3381),
    [sym_true] = ACTIONS(3379),
    [sym_false] = ACTIONS(3379),
    [anon_sym_NULL] = ACTIONS(3379),
    [anon_sym_nullptr] = ACTIONS(3379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3379),
    [anon_sym_let] = ACTIONS(3379),
    [anon_sym_This] = ACTIONS(3379),
    [anon_sym_decltype] = ACTIONS(3379),
    [anon_sym_explicit] = ACTIONS(3379),
    [anon_sym_typename] = ACTIONS(3379),
    [anon_sym_export] = ACTIONS(3379),
    [anon_sym_module] = ACTIONS(3379),
    [anon_sym_import] = ACTIONS(3379),
    [anon_sym_template] = ACTIONS(3379),
    [anon_sym_operator] = ACTIONS(3379),
    [anon_sym_try] = ACTIONS(3379),
    [anon_sym_delete] = ACTIONS(3379),
    [anon_sym_throw] = ACTIONS(3379),
    [anon_sym_namespace] = ACTIONS(3379),
    [anon_sym_static_assert] = ACTIONS(3379),
    [anon_sym_concept] = ACTIONS(3379),
    [anon_sym_co_return] = ACTIONS(3379),
    [anon_sym_co_yield] = ACTIONS(3379),
    [anon_sym_R_DQUOTE] = ACTIONS(3381),
    [anon_sym_LR_DQUOTE] = ACTIONS(3381),
    [anon_sym_uR_DQUOTE] = ACTIONS(3381),
    [anon_sym_UR_DQUOTE] = ACTIONS(3381),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3381),
    [anon_sym_co_await] = ACTIONS(3379),
    [anon_sym_new] = ACTIONS(3379),
    [anon_sym_requires] = ACTIONS(3379),
    [sym_this] = ACTIONS(3379),
    [anon_sym_discard] = ACTIONS(3379),
    [anon_sym_precise] = ACTIONS(3379),
    [anon_sym_shared] = ACTIONS(3379),
    [anon_sym_groupshared] = ACTIONS(3379),
    [anon_sym_uniform] = ACTIONS(3379),
    [anon_sym_row_major] = ACTIONS(3379),
    [anon_sym_column_major] = ACTIONS(3379),
    [anon_sym_globallycoherent] = ACTIONS(3379),
    [anon_sym_centroid] = ACTIONS(3379),
    [anon_sym_noperspective] = ACTIONS(3379),
    [anon_sym_nointerpolation] = ACTIONS(3379),
    [anon_sym_sample] = ACTIONS(3379),
    [anon_sym_linear] = ACTIONS(3379),
    [anon_sym_snorm] = ACTIONS(3379),
    [anon_sym_unorm] = ACTIONS(3379),
    [anon_sym_point] = ACTIONS(3379),
    [anon_sym_line] = ACTIONS(3379),
    [anon_sym_triangleadj] = ACTIONS(3379),
    [anon_sym_lineadj] = ACTIONS(3379),
    [anon_sym_triangle] = ACTIONS(3379),
    [anon_sym_cbuffer] = ACTIONS(3379),
    [anon_sym_interface] = ACTIONS(3379),
    [anon_sym_extension] = ACTIONS(3379),
    [anon_sym___exported] = ACTIONS(3379),
  },
  [472] = {
    [sym_attribute_specifier] = STATE(298),
    [sym_enumerator_list] = STATE(673),
    [sym__enum_base_clause] = STATE(637),
    [ts_builtin_sym_end] = ACTIONS(3504),
    [sym_identifier] = ACTIONS(3502),
    [aux_sym_preproc_include_token1] = ACTIONS(3502),
    [aux_sym_preproc_def_token1] = ACTIONS(3502),
    [aux_sym_preproc_if_token1] = ACTIONS(3502),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3502),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3502),
    [sym_preproc_directive] = ACTIONS(3502),
    [anon_sym_LPAREN2] = ACTIONS(3504),
    [anon_sym_BANG] = ACTIONS(3504),
    [anon_sym_TILDE] = ACTIONS(3504),
    [anon_sym_DASH] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(3502),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_AMP_AMP] = ACTIONS(3504),
    [anon_sym_AMP] = ACTIONS(3502),
    [anon_sym_COLON] = ACTIONS(3514),
    [anon_sym_SEMI] = ACTIONS(3504),
    [anon_sym___extension__] = ACTIONS(3502),
    [anon_sym_typedef] = ACTIONS(3502),
    [anon_sym_in] = ACTIONS(3502),
    [anon_sym_out] = ACTIONS(3502),
    [anon_sym_inout] = ACTIONS(3502),
    [anon_sym_virtual] = ACTIONS(3502),
    [anon_sym_extern] = ACTIONS(3502),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(3502),
    [anon_sym_COLON_COLON] = ACTIONS(3504),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3504),
    [anon_sym___declspec] = ACTIONS(3502),
    [anon_sym___based] = ACTIONS(3502),
    [anon_sym___cdecl] = ACTIONS(3502),
    [anon_sym___clrcall] = ACTIONS(3502),
    [anon_sym___stdcall] = ACTIONS(3502),
    [anon_sym___fastcall] = ACTIONS(3502),
    [anon_sym___thiscall] = ACTIONS(3502),
    [anon_sym___vectorcall] = ACTIONS(3502),
    [anon_sym_LBRACE] = ACTIONS(3516),
    [anon_sym_signed] = ACTIONS(3502),
    [anon_sym_unsigned] = ACTIONS(3502),
    [anon_sym_long] = ACTIONS(3502),
    [anon_sym_short] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(3502),
    [anon_sym_static] = ACTIONS(3502),
    [anon_sym_register] = ACTIONS(3502),
    [anon_sym_inline] = ACTIONS(3502),
    [anon_sym___inline] = ACTIONS(3502),
    [anon_sym___inline__] = ACTIONS(3502),
    [anon_sym___forceinline] = ACTIONS(3502),
    [anon_sym_thread_local] = ACTIONS(3502),
    [anon_sym___thread] = ACTIONS(3502),
    [anon_sym_const] = ACTIONS(3502),
    [anon_sym_constexpr] = ACTIONS(3502),
    [anon_sym_volatile] = ACTIONS(3502),
    [anon_sym_restrict] = ACTIONS(3502),
    [anon_sym___restrict__] = ACTIONS(3502),
    [anon_sym__Atomic] = ACTIONS(3502),
    [anon_sym__Noreturn] = ACTIONS(3502),
    [anon_sym_noreturn] = ACTIONS(3502),
    [anon_sym__Nonnull] = ACTIONS(3502),
    [anon_sym_mutable] = ACTIONS(3502),
    [anon_sym_constinit] = ACTIONS(3502),
    [anon_sym_consteval] = ACTIONS(3502),
    [anon_sym_alignas] = ACTIONS(3502),
    [anon_sym__Alignas] = ACTIONS(3502),
    [sym_primitive_type] = ACTIONS(3502),
    [anon_sym_enum] = ACTIONS(3502),
    [anon_sym_class] = ACTIONS(3502),
    [anon_sym_struct] = ACTIONS(3502),
    [anon_sym_union] = ACTIONS(3502),
    [anon_sym_if] = ACTIONS(3502),
    [anon_sym_switch] = ACTIONS(3502),
    [anon_sym_case] = ACTIONS(3502),
    [anon_sym_default] = ACTIONS(3502),
    [anon_sym_while] = ACTIONS(3502),
    [anon_sym_do] = ACTIONS(3502),
    [anon_sym_for] = ACTIONS(3502),
    [anon_sym_return] = ACTIONS(3502),
    [anon_sym_break] = ACTIONS(3502),
    [anon_sym_continue] = ACTIONS(3502),
    [anon_sym_goto] = ACTIONS(3502),
    [anon_sym_not] = ACTIONS(3502),
    [anon_sym_compl] = ACTIONS(3502),
    [anon_sym_DASH_DASH] = ACTIONS(3504),
    [anon_sym_PLUS_PLUS] = ACTIONS(3504),
    [anon_sym_sizeof] = ACTIONS(3502),
    [anon_sym___alignof__] = ACTIONS(3502),
    [anon_sym___alignof] = ACTIONS(3502),
    [anon_sym__alignof] = ACTIONS(3502),
    [anon_sym_alignof] = ACTIONS(3502),
    [anon_sym__Alignof] = ACTIONS(3502),
    [anon_sym_offsetof] = ACTIONS(3502),
    [anon_sym__Generic] = ACTIONS(3502),
    [anon_sym_asm] = ACTIONS(3502),
    [anon_sym___asm__] = ACTIONS(3502),
    [anon_sym___asm] = ACTIONS(3502),
    [anon_sym_DOT] = ACTIONS(3502),
    [sym_number_literal] = ACTIONS(3504),
    [anon_sym_L_SQUOTE] = ACTIONS(3504),
    [anon_sym_u_SQUOTE] = ACTIONS(3504),
    [anon_sym_U_SQUOTE] = ACTIONS(3504),
    [anon_sym_u8_SQUOTE] = ACTIONS(3504),
    [anon_sym_SQUOTE] = ACTIONS(3504),
    [anon_sym_L_DQUOTE] = ACTIONS(3504),
    [anon_sym_u_DQUOTE] = ACTIONS(3504),
    [anon_sym_U_DQUOTE] = ACTIONS(3504),
    [anon_sym_u8_DQUOTE] = ACTIONS(3504),
    [anon_sym_DQUOTE] = ACTIONS(3504),
    [sym_true] = ACTIONS(3502),
    [sym_false] = ACTIONS(3502),
    [anon_sym_NULL] = ACTIONS(3502),
    [anon_sym_nullptr] = ACTIONS(3502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3502),
    [anon_sym_let] = ACTIONS(3502),
    [anon_sym_This] = ACTIONS(3502),
    [anon_sym_decltype] = ACTIONS(3502),
    [anon_sym_explicit] = ACTIONS(3502),
    [anon_sym_typename] = ACTIONS(3502),
    [anon_sym_export] = ACTIONS(3502),
    [anon_sym_module] = ACTIONS(3502),
    [anon_sym_import] = ACTIONS(3502),
    [anon_sym_template] = ACTIONS(3502),
    [anon_sym_operator] = ACTIONS(3502),
    [anon_sym_try] = ACTIONS(3502),
    [anon_sym_delete] = ACTIONS(3502),
    [anon_sym_throw] = ACTIONS(3502),
    [anon_sym_namespace] = ACTIONS(3502),
    [anon_sym_static_assert] = ACTIONS(3502),
    [anon_sym_concept] = ACTIONS(3502),
    [anon_sym_co_return] = ACTIONS(3502),
    [anon_sym_co_yield] = ACTIONS(3502),
    [anon_sym_R_DQUOTE] = ACTIONS(3504),
    [anon_sym_LR_DQUOTE] = ACTIONS(3504),
    [anon_sym_uR_DQUOTE] = ACTIONS(3504),
    [anon_sym_UR_DQUOTE] = ACTIONS(3504),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3504),
    [anon_sym_co_await] = ACTIONS(3502),
    [anon_sym_new] = ACTIONS(3502),
    [anon_sym_requires] = ACTIONS(3502),
    [sym_this] = ACTIONS(3502),
    [anon_sym_precise] = ACTIONS(3502),
    [anon_sym_shared] = ACTIONS(3502),
    [anon_sym_groupshared] = ACTIONS(3502),
    [anon_sym_uniform] = ACTIONS(3502),
    [anon_sym_row_major] = ACTIONS(3502),
    [anon_sym_column_major] = ACTIONS(3502),
    [anon_sym_globallycoherent] = ACTIONS(3502),
    [anon_sym_centroid] = ACTIONS(3502),
    [anon_sym_noperspective] = ACTIONS(3502),
    [anon_sym_nointerpolation] = ACTIONS(3502),
    [anon_sym_sample] = ACTIONS(3502),
    [anon_sym_linear] = ACTIONS(3502),
    [anon_sym_snorm] = ACTIONS(3502),
    [anon_sym_unorm] = ACTIONS(3502),
    [anon_sym_point] = ACTIONS(3502),
    [anon_sym_line] = ACTIONS(3502),
    [anon_sym_triangleadj] = ACTIONS(3502),
    [anon_sym_lineadj] = ACTIONS(3502),
    [anon_sym_triangle] = ACTIONS(3502),
    [anon_sym_interface] = ACTIONS(3502),
    [anon_sym_extension] = ACTIONS(3502),
    [anon_sym___exported] = ACTIONS(3502),
  },
  [473] = {
    [ts_builtin_sym_end] = ACTIONS(3401),
    [sym_identifier] = ACTIONS(3399),
    [aux_sym_preproc_include_token1] = ACTIONS(3399),
    [aux_sym_preproc_def_token1] = ACTIONS(3399),
    [aux_sym_preproc_if_token1] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3399),
    [sym_preproc_directive] = ACTIONS(3399),
    [anon_sym_LPAREN2] = ACTIONS(3401),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_STAR] = ACTIONS(3401),
    [anon_sym_AMP_AMP] = ACTIONS(3401),
    [anon_sym_AMP] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym___extension__] = ACTIONS(3399),
    [anon_sym_typedef] = ACTIONS(3399),
    [anon_sym_in] = ACTIONS(3399),
    [anon_sym_out] = ACTIONS(3399),
    [anon_sym_inout] = ACTIONS(3399),
    [anon_sym_virtual] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym___attribute__] = ACTIONS(3399),
    [anon_sym___attribute] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_COLON_COLON] = ACTIONS(3401),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3401),
    [anon_sym___declspec] = ACTIONS(3399),
    [anon_sym___based] = ACTIONS(3399),
    [anon_sym___cdecl] = ACTIONS(3399),
    [anon_sym___clrcall] = ACTIONS(3399),
    [anon_sym___stdcall] = ACTIONS(3399),
    [anon_sym___fastcall] = ACTIONS(3399),
    [anon_sym___thiscall] = ACTIONS(3399),
    [anon_sym___vectorcall] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_signed] = ACTIONS(3399),
    [anon_sym_unsigned] = ACTIONS(3399),
    [anon_sym_long] = ACTIONS(3399),
    [anon_sym_short] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_register] = ACTIONS(3399),
    [anon_sym_inline] = ACTIONS(3399),
    [anon_sym___inline] = ACTIONS(3399),
    [anon_sym___inline__] = ACTIONS(3399),
    [anon_sym___forceinline] = ACTIONS(3399),
    [anon_sym_thread_local] = ACTIONS(3399),
    [anon_sym___thread] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_constexpr] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym_restrict] = ACTIONS(3399),
    [anon_sym___restrict__] = ACTIONS(3399),
    [anon_sym__Atomic] = ACTIONS(3399),
    [anon_sym__Noreturn] = ACTIONS(3399),
    [anon_sym_noreturn] = ACTIONS(3399),
    [anon_sym__Nonnull] = ACTIONS(3399),
    [anon_sym_mutable] = ACTIONS(3399),
    [anon_sym_constinit] = ACTIONS(3399),
    [anon_sym_consteval] = ACTIONS(3399),
    [anon_sym_alignas] = ACTIONS(3399),
    [anon_sym__Alignas] = ACTIONS(3399),
    [sym_primitive_type] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_union] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_else] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_case] = ACTIONS(3399),
    [anon_sym_default] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_goto] = ACTIONS(3399),
    [anon_sym___try] = ACTIONS(3399),
    [anon_sym___leave] = ACTIONS(3399),
    [anon_sym_not] = ACTIONS(3399),
    [anon_sym_compl] = ACTIONS(3399),
    [anon_sym_DASH_DASH] = ACTIONS(3401),
    [anon_sym_PLUS_PLUS] = ACTIONS(3401),
    [anon_sym_sizeof] = ACTIONS(3399),
    [anon_sym___alignof__] = ACTIONS(3399),
    [anon_sym___alignof] = ACTIONS(3399),
    [anon_sym__alignof] = ACTIONS(3399),
    [anon_sym_alignof] = ACTIONS(3399),
    [anon_sym__Alignof] = ACTIONS(3399),
    [anon_sym_offsetof] = ACTIONS(3399),
    [anon_sym__Generic] = ACTIONS(3399),
    [anon_sym_asm] = ACTIONS(3399),
    [anon_sym___asm__] = ACTIONS(3399),
    [anon_sym___asm] = ACTIONS(3399),
    [sym_number_literal] = ACTIONS(3401),
    [anon_sym_L_SQUOTE] = ACTIONS(3401),
    [anon_sym_u_SQUOTE] = ACTIONS(3401),
    [anon_sym_U_SQUOTE] = ACTIONS(3401),
    [anon_sym_u8_SQUOTE] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(3401),
    [anon_sym_L_DQUOTE] = ACTIONS(3401),
    [anon_sym_u_DQUOTE] = ACTIONS(3401),
    [anon_sym_U_DQUOTE] = ACTIONS(3401),
    [anon_sym_u8_DQUOTE] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [sym_true] = ACTIONS(3399),
    [sym_false] = ACTIONS(3399),
    [anon_sym_NULL] = ACTIONS(3399),
    [anon_sym_nullptr] = ACTIONS(3399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_This] = ACTIONS(3399),
    [anon_sym_decltype] = ACTIONS(3399),
    [anon_sym_explicit] = ACTIONS(3399),
    [anon_sym_typename] = ACTIONS(3399),
    [anon_sym_export] = ACTIONS(3399),
    [anon_sym_module] = ACTIONS(3399),
    [anon_sym_import] = ACTIONS(3399),
    [anon_sym_template] = ACTIONS(3399),
    [anon_sym_operator] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_delete] = ACTIONS(3399),
    [anon_sym_throw] = ACTIONS(3399),
    [anon_sym_namespace] = ACTIONS(3399),
    [anon_sym_static_assert] = ACTIONS(3399),
    [anon_sym_concept] = ACTIONS(3399),
    [anon_sym_co_return] = ACTIONS(3399),
    [anon_sym_co_yield] = ACTIONS(3399),
    [anon_sym_R_DQUOTE] = ACTIONS(3401),
    [anon_sym_LR_DQUOTE] = ACTIONS(3401),
    [anon_sym_uR_DQUOTE] = ACTIONS(3401),
    [anon_sym_UR_DQUOTE] = ACTIONS(3401),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3401),
    [anon_sym_co_await] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_requires] = ACTIONS(3399),
    [sym_this] = ACTIONS(3399),
    [anon_sym_discard] = ACTIONS(3399),
    [anon_sym_precise] = ACTIONS(3399),
    [anon_sym_shared] = ACTIONS(3399),
    [anon_sym_groupshared] = ACTIONS(3399),
    [anon_sym_uniform] = ACTIONS(3399),
    [anon_sym_row_major] = ACTIONS(3399),
    [anon_sym_column_major] = ACTIONS(3399),
    [anon_sym_globallycoherent] = ACTIONS(3399),
    [anon_sym_centroid] = ACTIONS(3399),
    [anon_sym_noperspective] = ACTIONS(3399),
    [anon_sym_nointerpolation] = ACTIONS(3399),
    [anon_sym_sample] = ACTIONS(3399),
    [anon_sym_linear] = ACTIONS(3399),
    [anon_sym_snorm] = ACTIONS(3399),
    [anon_sym_unorm] = ACTIONS(3399),
    [anon_sym_point] = ACTIONS(3399),
    [anon_sym_line] = ACTIONS(3399),
    [anon_sym_triangleadj] = ACTIONS(3399),
    [anon_sym_lineadj] = ACTIONS(3399),
    [anon_sym_triangle] = ACTIONS(3399),
    [anon_sym_cbuffer] = ACTIONS(3399),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_extension] = ACTIONS(3399),
    [anon_sym___exported] = ACTIONS(3399),
  },
  [474] = {
    [ts_builtin_sym_end] = ACTIONS(3401),
    [sym_identifier] = ACTIONS(3399),
    [aux_sym_preproc_include_token1] = ACTIONS(3399),
    [aux_sym_preproc_def_token1] = ACTIONS(3399),
    [aux_sym_preproc_if_token1] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3399),
    [sym_preproc_directive] = ACTIONS(3399),
    [anon_sym_LPAREN2] = ACTIONS(3401),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_STAR] = ACTIONS(3401),
    [anon_sym_AMP_AMP] = ACTIONS(3401),
    [anon_sym_AMP] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym___extension__] = ACTIONS(3399),
    [anon_sym_typedef] = ACTIONS(3399),
    [anon_sym_in] = ACTIONS(3399),
    [anon_sym_out] = ACTIONS(3399),
    [anon_sym_inout] = ACTIONS(3399),
    [anon_sym_virtual] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym___attribute__] = ACTIONS(3399),
    [anon_sym___attribute] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_COLON_COLON] = ACTIONS(3401),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3401),
    [anon_sym___declspec] = ACTIONS(3399),
    [anon_sym___based] = ACTIONS(3399),
    [anon_sym___cdecl] = ACTIONS(3399),
    [anon_sym___clrcall] = ACTIONS(3399),
    [anon_sym___stdcall] = ACTIONS(3399),
    [anon_sym___fastcall] = ACTIONS(3399),
    [anon_sym___thiscall] = ACTIONS(3399),
    [anon_sym___vectorcall] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_signed] = ACTIONS(3399),
    [anon_sym_unsigned] = ACTIONS(3399),
    [anon_sym_long] = ACTIONS(3399),
    [anon_sym_short] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_register] = ACTIONS(3399),
    [anon_sym_inline] = ACTIONS(3399),
    [anon_sym___inline] = ACTIONS(3399),
    [anon_sym___inline__] = ACTIONS(3399),
    [anon_sym___forceinline] = ACTIONS(3399),
    [anon_sym_thread_local] = ACTIONS(3399),
    [anon_sym___thread] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_constexpr] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym_restrict] = ACTIONS(3399),
    [anon_sym___restrict__] = ACTIONS(3399),
    [anon_sym__Atomic] = ACTIONS(3399),
    [anon_sym__Noreturn] = ACTIONS(3399),
    [anon_sym_noreturn] = ACTIONS(3399),
    [anon_sym__Nonnull] = ACTIONS(3399),
    [anon_sym_mutable] = ACTIONS(3399),
    [anon_sym_constinit] = ACTIONS(3399),
    [anon_sym_consteval] = ACTIONS(3399),
    [anon_sym_alignas] = ACTIONS(3399),
    [anon_sym__Alignas] = ACTIONS(3399),
    [sym_primitive_type] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_union] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_else] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_case] = ACTIONS(3399),
    [anon_sym_default] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_goto] = ACTIONS(3399),
    [anon_sym___try] = ACTIONS(3399),
    [anon_sym___leave] = ACTIONS(3399),
    [anon_sym_not] = ACTIONS(3399),
    [anon_sym_compl] = ACTIONS(3399),
    [anon_sym_DASH_DASH] = ACTIONS(3401),
    [anon_sym_PLUS_PLUS] = ACTIONS(3401),
    [anon_sym_sizeof] = ACTIONS(3399),
    [anon_sym___alignof__] = ACTIONS(3399),
    [anon_sym___alignof] = ACTIONS(3399),
    [anon_sym__alignof] = ACTIONS(3399),
    [anon_sym_alignof] = ACTIONS(3399),
    [anon_sym__Alignof] = ACTIONS(3399),
    [anon_sym_offsetof] = ACTIONS(3399),
    [anon_sym__Generic] = ACTIONS(3399),
    [anon_sym_asm] = ACTIONS(3399),
    [anon_sym___asm__] = ACTIONS(3399),
    [anon_sym___asm] = ACTIONS(3399),
    [sym_number_literal] = ACTIONS(3401),
    [anon_sym_L_SQUOTE] = ACTIONS(3401),
    [anon_sym_u_SQUOTE] = ACTIONS(3401),
    [anon_sym_U_SQUOTE] = ACTIONS(3401),
    [anon_sym_u8_SQUOTE] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(3401),
    [anon_sym_L_DQUOTE] = ACTIONS(3401),
    [anon_sym_u_DQUOTE] = ACTIONS(3401),
    [anon_sym_U_DQUOTE] = ACTIONS(3401),
    [anon_sym_u8_DQUOTE] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [sym_true] = ACTIONS(3399),
    [sym_false] = ACTIONS(3399),
    [anon_sym_NULL] = ACTIONS(3399),
    [anon_sym_nullptr] = ACTIONS(3399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_This] = ACTIONS(3399),
    [anon_sym_decltype] = ACTIONS(3399),
    [anon_sym_explicit] = ACTIONS(3399),
    [anon_sym_typename] = ACTIONS(3399),
    [anon_sym_export] = ACTIONS(3399),
    [anon_sym_module] = ACTIONS(3399),
    [anon_sym_import] = ACTIONS(3399),
    [anon_sym_template] = ACTIONS(3399),
    [anon_sym_operator] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_delete] = ACTIONS(3399),
    [anon_sym_throw] = ACTIONS(3399),
    [anon_sym_namespace] = ACTIONS(3399),
    [anon_sym_static_assert] = ACTIONS(3399),
    [anon_sym_concept] = ACTIONS(3399),
    [anon_sym_co_return] = ACTIONS(3399),
    [anon_sym_co_yield] = ACTIONS(3399),
    [anon_sym_R_DQUOTE] = ACTIONS(3401),
    [anon_sym_LR_DQUOTE] = ACTIONS(3401),
    [anon_sym_uR_DQUOTE] = ACTIONS(3401),
    [anon_sym_UR_DQUOTE] = ACTIONS(3401),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3401),
    [anon_sym_co_await] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_requires] = ACTIONS(3399),
    [sym_this] = ACTIONS(3399),
    [anon_sym_discard] = ACTIONS(3399),
    [anon_sym_precise] = ACTIONS(3399),
    [anon_sym_shared] = ACTIONS(3399),
    [anon_sym_groupshared] = ACTIONS(3399),
    [anon_sym_uniform] = ACTIONS(3399),
    [anon_sym_row_major] = ACTIONS(3399),
    [anon_sym_column_major] = ACTIONS(3399),
    [anon_sym_globallycoherent] = ACTIONS(3399),
    [anon_sym_centroid] = ACTIONS(3399),
    [anon_sym_noperspective] = ACTIONS(3399),
    [anon_sym_nointerpolation] = ACTIONS(3399),
    [anon_sym_sample] = ACTIONS(3399),
    [anon_sym_linear] = ACTIONS(3399),
    [anon_sym_snorm] = ACTIONS(3399),
    [anon_sym_unorm] = ACTIONS(3399),
    [anon_sym_point] = ACTIONS(3399),
    [anon_sym_line] = ACTIONS(3399),
    [anon_sym_triangleadj] = ACTIONS(3399),
    [anon_sym_lineadj] = ACTIONS(3399),
    [anon_sym_triangle] = ACTIONS(3399),
    [anon_sym_cbuffer] = ACTIONS(3399),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_extension] = ACTIONS(3399),
    [anon_sym___exported] = ACTIONS(3399),
  },
  [475] = {
    [ts_builtin_sym_end] = ACTIONS(3405),
    [sym_identifier] = ACTIONS(3403),
    [aux_sym_preproc_include_token1] = ACTIONS(3403),
    [aux_sym_preproc_def_token1] = ACTIONS(3403),
    [aux_sym_preproc_if_token1] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3403),
    [sym_preproc_directive] = ACTIONS(3403),
    [anon_sym_LPAREN2] = ACTIONS(3405),
    [anon_sym_BANG] = ACTIONS(3405),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_DASH] = ACTIONS(3403),
    [anon_sym_PLUS] = ACTIONS(3403),
    [anon_sym_STAR] = ACTIONS(3405),
    [anon_sym_AMP_AMP] = ACTIONS(3405),
    [anon_sym_AMP] = ACTIONS(3403),
    [anon_sym_SEMI] = ACTIONS(3405),
    [anon_sym___extension__] = ACTIONS(3403),
    [anon_sym_typedef] = ACTIONS(3403),
    [anon_sym_in] = ACTIONS(3403),
    [anon_sym_out] = ACTIONS(3403),
    [anon_sym_inout] = ACTIONS(3403),
    [anon_sym_virtual] = ACTIONS(3403),
    [anon_sym_extern] = ACTIONS(3403),
    [anon_sym___attribute__] = ACTIONS(3403),
    [anon_sym___attribute] = ACTIONS(3403),
    [anon_sym_using] = ACTIONS(3403),
    [anon_sym_COLON_COLON] = ACTIONS(3405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3405),
    [anon_sym___declspec] = ACTIONS(3403),
    [anon_sym___based] = ACTIONS(3403),
    [anon_sym___cdecl] = ACTIONS(3403),
    [anon_sym___clrcall] = ACTIONS(3403),
    [anon_sym___stdcall] = ACTIONS(3403),
    [anon_sym___fastcall] = ACTIONS(3403),
    [anon_sym___thiscall] = ACTIONS(3403),
    [anon_sym___vectorcall] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3405),
    [anon_sym_signed] = ACTIONS(3403),
    [anon_sym_unsigned] = ACTIONS(3403),
    [anon_sym_long] = ACTIONS(3403),
    [anon_sym_short] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3403),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_register] = ACTIONS(3403),
    [anon_sym_inline] = ACTIONS(3403),
    [anon_sym___inline] = ACTIONS(3403),
    [anon_sym___inline__] = ACTIONS(3403),
    [anon_sym___forceinline] = ACTIONS(3403),
    [anon_sym_thread_local] = ACTIONS(3403),
    [anon_sym___thread] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_constexpr] = ACTIONS(3403),
    [anon_sym_volatile] = ACTIONS(3403),
    [anon_sym_restrict] = ACTIONS(3403),
    [anon_sym___restrict__] = ACTIONS(3403),
    [anon_sym__Atomic] = ACTIONS(3403),
    [anon_sym__Noreturn] = ACTIONS(3403),
    [anon_sym_noreturn] = ACTIONS(3403),
    [anon_sym__Nonnull] = ACTIONS(3403),
    [anon_sym_mutable] = ACTIONS(3403),
    [anon_sym_constinit] = ACTIONS(3403),
    [anon_sym_consteval] = ACTIONS(3403),
    [anon_sym_alignas] = ACTIONS(3403),
    [anon_sym__Alignas] = ACTIONS(3403),
    [sym_primitive_type] = ACTIONS(3403),
    [anon_sym_enum] = ACTIONS(3403),
    [anon_sym_class] = ACTIONS(3403),
    [anon_sym_struct] = ACTIONS(3403),
    [anon_sym_union] = ACTIONS(3403),
    [anon_sym_if] = ACTIONS(3403),
    [anon_sym_else] = ACTIONS(3403),
    [anon_sym_switch] = ACTIONS(3403),
    [anon_sym_case] = ACTIONS(3403),
    [anon_sym_default] = ACTIONS(3403),
    [anon_sym_while] = ACTIONS(3403),
    [anon_sym_do] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3403),
    [anon_sym_return] = ACTIONS(3403),
    [anon_sym_break] = ACTIONS(3403),
    [anon_sym_continue] = ACTIONS(3403),
    [anon_sym_goto] = ACTIONS(3403),
    [anon_sym___try] = ACTIONS(3403),
    [anon_sym___leave] = ACTIONS(3403),
    [anon_sym_not] = ACTIONS(3403),
    [anon_sym_compl] = ACTIONS(3403),
    [anon_sym_DASH_DASH] = ACTIONS(3405),
    [anon_sym_PLUS_PLUS] = ACTIONS(3405),
    [anon_sym_sizeof] = ACTIONS(3403),
    [anon_sym___alignof__] = ACTIONS(3403),
    [anon_sym___alignof] = ACTIONS(3403),
    [anon_sym__alignof] = ACTIONS(3403),
    [anon_sym_alignof] = ACTIONS(3403),
    [anon_sym__Alignof] = ACTIONS(3403),
    [anon_sym_offsetof] = ACTIONS(3403),
    [anon_sym__Generic] = ACTIONS(3403),
    [anon_sym_asm] = ACTIONS(3403),
    [anon_sym___asm__] = ACTIONS(3403),
    [anon_sym___asm] = ACTIONS(3403),
    [sym_number_literal] = ACTIONS(3405),
    [anon_sym_L_SQUOTE] = ACTIONS(3405),
    [anon_sym_u_SQUOTE] = ACTIONS(3405),
    [anon_sym_U_SQUOTE] = ACTIONS(3405),
    [anon_sym_u8_SQUOTE] = ACTIONS(3405),
    [anon_sym_SQUOTE] = ACTIONS(3405),
    [anon_sym_L_DQUOTE] = ACTIONS(3405),
    [anon_sym_u_DQUOTE] = ACTIONS(3405),
    [anon_sym_U_DQUOTE] = ACTIONS(3405),
    [anon_sym_u8_DQUOTE] = ACTIONS(3405),
    [anon_sym_DQUOTE] = ACTIONS(3405),
    [sym_true] = ACTIONS(3403),
    [sym_false] = ACTIONS(3403),
    [anon_sym_NULL] = ACTIONS(3403),
    [anon_sym_nullptr] = ACTIONS(3403),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3403),
    [anon_sym_let] = ACTIONS(3403),
    [anon_sym_This] = ACTIONS(3403),
    [anon_sym_decltype] = ACTIONS(3403),
    [anon_sym_explicit] = ACTIONS(3403),
    [anon_sym_typename] = ACTIONS(3403),
    [anon_sym_export] = ACTIONS(3403),
    [anon_sym_module] = ACTIONS(3403),
    [anon_sym_import] = ACTIONS(3403),
    [anon_sym_template] = ACTIONS(3403),
    [anon_sym_operator] = ACTIONS(3403),
    [anon_sym_try] = ACTIONS(3403),
    [anon_sym_delete] = ACTIONS(3403),
    [anon_sym_throw] = ACTIONS(3403),
    [anon_sym_namespace] = ACTIONS(3403),
    [anon_sym_static_assert] = ACTIONS(3403),
    [anon_sym_concept] = ACTIONS(3403),
    [anon_sym_co_return] = ACTIONS(3403),
    [anon_sym_co_yield] = ACTIONS(3403),
    [anon_sym_R_DQUOTE] = ACTIONS(3405),
    [anon_sym_LR_DQUOTE] = ACTIONS(3405),
    [anon_sym_uR_DQUOTE] = ACTIONS(3405),
    [anon_sym_UR_DQUOTE] = ACTIONS(3405),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3405),
    [anon_sym_co_await] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3403),
    [anon_sym_requires] = ACTIONS(3403),
    [sym_this] = ACTIONS(3403),
    [anon_sym_discard] = ACTIONS(3403),
    [anon_sym_precise] = ACTIONS(3403),
    [anon_sym_shared] = ACTIONS(3403),
    [anon_sym_groupshared] = ACTIONS(3403),
    [anon_sym_uniform] = ACTIONS(3403),
    [anon_sym_row_major] = ACTIONS(3403),
    [anon_sym_column_major] = ACTIONS(3403),
    [anon_sym_globallycoherent] = ACTIONS(3403),
    [anon_sym_centroid] = ACTIONS(3403),
    [anon_sym_noperspective] = ACTIONS(3403),
    [anon_sym_nointerpolation] = ACTIONS(3403),
    [anon_sym_sample] = ACTIONS(3403),
    [anon_sym_linear] = ACTIONS(3403),
    [anon_sym_snorm] = ACTIONS(3403),
    [anon_sym_unorm] = ACTIONS(3403),
    [anon_sym_point] = ACTIONS(3403),
    [anon_sym_line] = ACTIONS(3403),
    [anon_sym_triangleadj] = ACTIONS(3403),
    [anon_sym_lineadj] = ACTIONS(3403),
    [anon_sym_triangle] = ACTIONS(3403),
    [anon_sym_cbuffer] = ACTIONS(3403),
    [anon_sym_interface] = ACTIONS(3403),
    [anon_sym_extension] = ACTIONS(3403),
    [anon_sym___exported] = ACTIONS(3403),
  },
  [476] = {
    [ts_builtin_sym_end] = ACTIONS(3409),
    [sym_identifier] = ACTIONS(3407),
    [aux_sym_preproc_include_token1] = ACTIONS(3407),
    [aux_sym_preproc_def_token1] = ACTIONS(3407),
    [aux_sym_preproc_if_token1] = ACTIONS(3407),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3407),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3407),
    [sym_preproc_directive] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3409),
    [anon_sym_TILDE] = ACTIONS(3409),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_AMP_AMP] = ACTIONS(3409),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_SEMI] = ACTIONS(3409),
    [anon_sym___extension__] = ACTIONS(3407),
    [anon_sym_typedef] = ACTIONS(3407),
    [anon_sym_in] = ACTIONS(3407),
    [anon_sym_out] = ACTIONS(3407),
    [anon_sym_inout] = ACTIONS(3407),
    [anon_sym_virtual] = ACTIONS(3407),
    [anon_sym_extern] = ACTIONS(3407),
    [anon_sym___attribute__] = ACTIONS(3407),
    [anon_sym___attribute] = ACTIONS(3407),
    [anon_sym_using] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3409),
    [anon_sym___declspec] = ACTIONS(3407),
    [anon_sym___based] = ACTIONS(3407),
    [anon_sym___cdecl] = ACTIONS(3407),
    [anon_sym___clrcall] = ACTIONS(3407),
    [anon_sym___stdcall] = ACTIONS(3407),
    [anon_sym___fastcall] = ACTIONS(3407),
    [anon_sym___thiscall] = ACTIONS(3407),
    [anon_sym___vectorcall] = ACTIONS(3407),
    [anon_sym_LBRACE] = ACTIONS(3409),
    [anon_sym_signed] = ACTIONS(3407),
    [anon_sym_unsigned] = ACTIONS(3407),
    [anon_sym_long] = ACTIONS(3407),
    [anon_sym_short] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_register] = ACTIONS(3407),
    [anon_sym_inline] = ACTIONS(3407),
    [anon_sym___inline] = ACTIONS(3407),
    [anon_sym___inline__] = ACTIONS(3407),
    [anon_sym___forceinline] = ACTIONS(3407),
    [anon_sym_thread_local] = ACTIONS(3407),
    [anon_sym___thread] = ACTIONS(3407),
    [anon_sym_const] = ACTIONS(3407),
    [anon_sym_constexpr] = ACTIONS(3407),
    [anon_sym_volatile] = ACTIONS(3407),
    [anon_sym_restrict] = ACTIONS(3407),
    [anon_sym___restrict__] = ACTIONS(3407),
    [anon_sym__Atomic] = ACTIONS(3407),
    [anon_sym__Noreturn] = ACTIONS(3407),
    [anon_sym_noreturn] = ACTIONS(3407),
    [anon_sym__Nonnull] = ACTIONS(3407),
    [anon_sym_mutable] = ACTIONS(3407),
    [anon_sym_constinit] = ACTIONS(3407),
    [anon_sym_consteval] = ACTIONS(3407),
    [anon_sym_alignas] = ACTIONS(3407),
    [anon_sym__Alignas] = ACTIONS(3407),
    [sym_primitive_type] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3407),
    [anon_sym_class] = ACTIONS(3407),
    [anon_sym_struct] = ACTIONS(3407),
    [anon_sym_union] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_else] = ACTIONS(3407),
    [anon_sym_switch] = ACTIONS(3407),
    [anon_sym_case] = ACTIONS(3407),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_break] = ACTIONS(3407),
    [anon_sym_continue] = ACTIONS(3407),
    [anon_sym_goto] = ACTIONS(3407),
    [anon_sym___try] = ACTIONS(3407),
    [anon_sym___leave] = ACTIONS(3407),
    [anon_sym_not] = ACTIONS(3407),
    [anon_sym_compl] = ACTIONS(3407),
    [anon_sym_DASH_DASH] = ACTIONS(3409),
    [anon_sym_PLUS_PLUS] = ACTIONS(3409),
    [anon_sym_sizeof] = ACTIONS(3407),
    [anon_sym___alignof__] = ACTIONS(3407),
    [anon_sym___alignof] = ACTIONS(3407),
    [anon_sym__alignof] = ACTIONS(3407),
    [anon_sym_alignof] = ACTIONS(3407),
    [anon_sym__Alignof] = ACTIONS(3407),
    [anon_sym_offsetof] = ACTIONS(3407),
    [anon_sym__Generic] = ACTIONS(3407),
    [anon_sym_asm] = ACTIONS(3407),
    [anon_sym___asm__] = ACTIONS(3407),
    [anon_sym___asm] = ACTIONS(3407),
    [sym_number_literal] = ACTIONS(3409),
    [anon_sym_L_SQUOTE] = ACTIONS(3409),
    [anon_sym_u_SQUOTE] = ACTIONS(3409),
    [anon_sym_U_SQUOTE] = ACTIONS(3409),
    [anon_sym_u8_SQUOTE] = ACTIONS(3409),
    [anon_sym_SQUOTE] = ACTIONS(3409),
    [anon_sym_L_DQUOTE] = ACTIONS(3409),
    [anon_sym_u_DQUOTE] = ACTIONS(3409),
    [anon_sym_U_DQUOTE] = ACTIONS(3409),
    [anon_sym_u8_DQUOTE] = ACTIONS(3409),
    [anon_sym_DQUOTE] = ACTIONS(3409),
    [sym_true] = ACTIONS(3407),
    [sym_false] = ACTIONS(3407),
    [anon_sym_NULL] = ACTIONS(3407),
    [anon_sym_nullptr] = ACTIONS(3407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_This] = ACTIONS(3407),
    [anon_sym_decltype] = ACTIONS(3407),
    [anon_sym_explicit] = ACTIONS(3407),
    [anon_sym_typename] = ACTIONS(3407),
    [anon_sym_export] = ACTIONS(3407),
    [anon_sym_module] = ACTIONS(3407),
    [anon_sym_import] = ACTIONS(3407),
    [anon_sym_template] = ACTIONS(3407),
    [anon_sym_operator] = ACTIONS(3407),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_delete] = ACTIONS(3407),
    [anon_sym_throw] = ACTIONS(3407),
    [anon_sym_namespace] = ACTIONS(3407),
    [anon_sym_static_assert] = ACTIONS(3407),
    [anon_sym_concept] = ACTIONS(3407),
    [anon_sym_co_return] = ACTIONS(3407),
    [anon_sym_co_yield] = ACTIONS(3407),
    [anon_sym_R_DQUOTE] = ACTIONS(3409),
    [anon_sym_LR_DQUOTE] = ACTIONS(3409),
    [anon_sym_uR_DQUOTE] = ACTIONS(3409),
    [anon_sym_UR_DQUOTE] = ACTIONS(3409),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3409),
    [anon_sym_co_await] = ACTIONS(3407),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_requires] = ACTIONS(3407),
    [sym_this] = ACTIONS(3407),
    [anon_sym_discard] = ACTIONS(3407),
    [anon_sym_precise] = ACTIONS(3407),
    [anon_sym_shared] = ACTIONS(3407),
    [anon_sym_groupshared] = ACTIONS(3407),
    [anon_sym_uniform] = ACTIONS(3407),
    [anon_sym_row_major] = ACTIONS(3407),
    [anon_sym_column_major] = ACTIONS(3407),
    [anon_sym_globallycoherent] = ACTIONS(3407),
    [anon_sym_centroid] = ACTIONS(3407),
    [anon_sym_noperspective] = ACTIONS(3407),
    [anon_sym_nointerpolation] = ACTIONS(3407),
    [anon_sym_sample] = ACTIONS(3407),
    [anon_sym_linear] = ACTIONS(3407),
    [anon_sym_snorm] = ACTIONS(3407),
    [anon_sym_unorm] = ACTIONS(3407),
    [anon_sym_point] = ACTIONS(3407),
    [anon_sym_line] = ACTIONS(3407),
    [anon_sym_triangleadj] = ACTIONS(3407),
    [anon_sym_lineadj] = ACTIONS(3407),
    [anon_sym_triangle] = ACTIONS(3407),
    [anon_sym_cbuffer] = ACTIONS(3407),
    [anon_sym_interface] = ACTIONS(3407),
    [anon_sym_extension] = ACTIONS(3407),
    [anon_sym___exported] = ACTIONS(3407),
  },
  [477] = {
    [ts_builtin_sym_end] = ACTIONS(3599),
    [sym_identifier] = ACTIONS(3597),
    [aux_sym_preproc_include_token1] = ACTIONS(3597),
    [aux_sym_preproc_def_token1] = ACTIONS(3597),
    [aux_sym_preproc_if_token1] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3597),
    [sym_preproc_directive] = ACTIONS(3597),
    [anon_sym_LPAREN2] = ACTIONS(3599),
    [anon_sym_BANG] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3599),
    [anon_sym_DASH] = ACTIONS(3597),
    [anon_sym_PLUS] = ACTIONS(3597),
    [anon_sym_STAR] = ACTIONS(3599),
    [anon_sym_AMP_AMP] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3597),
    [anon_sym_SEMI] = ACTIONS(3599),
    [anon_sym___extension__] = ACTIONS(3597),
    [anon_sym_typedef] = ACTIONS(3597),
    [anon_sym_in] = ACTIONS(3597),
    [anon_sym_out] = ACTIONS(3597),
    [anon_sym_inout] = ACTIONS(3597),
    [anon_sym_virtual] = ACTIONS(3597),
    [anon_sym_extern] = ACTIONS(3597),
    [anon_sym___attribute__] = ACTIONS(3597),
    [anon_sym___attribute] = ACTIONS(3597),
    [anon_sym_using] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3599),
    [anon_sym___declspec] = ACTIONS(3597),
    [anon_sym___based] = ACTIONS(3597),
    [anon_sym___cdecl] = ACTIONS(3597),
    [anon_sym___clrcall] = ACTIONS(3597),
    [anon_sym___stdcall] = ACTIONS(3597),
    [anon_sym___fastcall] = ACTIONS(3597),
    [anon_sym___thiscall] = ACTIONS(3597),
    [anon_sym___vectorcall] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(3599),
    [anon_sym_signed] = ACTIONS(3597),
    [anon_sym_unsigned] = ACTIONS(3597),
    [anon_sym_long] = ACTIONS(3597),
    [anon_sym_short] = ACTIONS(3597),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_static] = ACTIONS(3597),
    [anon_sym_register] = ACTIONS(3597),
    [anon_sym_inline] = ACTIONS(3597),
    [anon_sym___inline] = ACTIONS(3597),
    [anon_sym___inline__] = ACTIONS(3597),
    [anon_sym___forceinline] = ACTIONS(3597),
    [anon_sym_thread_local] = ACTIONS(3597),
    [anon_sym___thread] = ACTIONS(3597),
    [anon_sym_const] = ACTIONS(3597),
    [anon_sym_constexpr] = ACTIONS(3597),
    [anon_sym_volatile] = ACTIONS(3597),
    [anon_sym_restrict] = ACTIONS(3597),
    [anon_sym___restrict__] = ACTIONS(3597),
    [anon_sym__Atomic] = ACTIONS(3597),
    [anon_sym__Noreturn] = ACTIONS(3597),
    [anon_sym_noreturn] = ACTIONS(3597),
    [anon_sym__Nonnull] = ACTIONS(3597),
    [anon_sym_mutable] = ACTIONS(3597),
    [anon_sym_constinit] = ACTIONS(3597),
    [anon_sym_consteval] = ACTIONS(3597),
    [anon_sym_alignas] = ACTIONS(3597),
    [anon_sym__Alignas] = ACTIONS(3597),
    [sym_primitive_type] = ACTIONS(3597),
    [anon_sym_enum] = ACTIONS(3597),
    [anon_sym_class] = ACTIONS(3597),
    [anon_sym_struct] = ACTIONS(3597),
    [anon_sym_union] = ACTIONS(3597),
    [anon_sym_if] = ACTIONS(3597),
    [anon_sym_else] = ACTIONS(3597),
    [anon_sym_switch] = ACTIONS(3597),
    [anon_sym_case] = ACTIONS(3597),
    [anon_sym_default] = ACTIONS(3597),
    [anon_sym_while] = ACTIONS(3597),
    [anon_sym_do] = ACTIONS(3597),
    [anon_sym_for] = ACTIONS(3597),
    [anon_sym_return] = ACTIONS(3597),
    [anon_sym_break] = ACTIONS(3597),
    [anon_sym_continue] = ACTIONS(3597),
    [anon_sym_goto] = ACTIONS(3597),
    [anon_sym___try] = ACTIONS(3597),
    [anon_sym___leave] = ACTIONS(3597),
    [anon_sym_not] = ACTIONS(3597),
    [anon_sym_compl] = ACTIONS(3597),
    [anon_sym_DASH_DASH] = ACTIONS(3599),
    [anon_sym_PLUS_PLUS] = ACTIONS(3599),
    [anon_sym_sizeof] = ACTIONS(3597),
    [anon_sym___alignof__] = ACTIONS(3597),
    [anon_sym___alignof] = ACTIONS(3597),
    [anon_sym__alignof] = ACTIONS(3597),
    [anon_sym_alignof] = ACTIONS(3597),
    [anon_sym__Alignof] = ACTIONS(3597),
    [anon_sym_offsetof] = ACTIONS(3597),
    [anon_sym__Generic] = ACTIONS(3597),
    [anon_sym_asm] = ACTIONS(3597),
    [anon_sym___asm__] = ACTIONS(3597),
    [anon_sym___asm] = ACTIONS(3597),
    [sym_number_literal] = ACTIONS(3599),
    [anon_sym_L_SQUOTE] = ACTIONS(3599),
    [anon_sym_u_SQUOTE] = ACTIONS(3599),
    [anon_sym_U_SQUOTE] = ACTIONS(3599),
    [anon_sym_u8_SQUOTE] = ACTIONS(3599),
    [anon_sym_SQUOTE] = ACTIONS(3599),
    [anon_sym_L_DQUOTE] = ACTIONS(3599),
    [anon_sym_u_DQUOTE] = ACTIONS(3599),
    [anon_sym_U_DQUOTE] = ACTIONS(3599),
    [anon_sym_u8_DQUOTE] = ACTIONS(3599),
    [anon_sym_DQUOTE] = ACTIONS(3599),
    [sym_true] = ACTIONS(3597),
    [sym_false] = ACTIONS(3597),
    [anon_sym_NULL] = ACTIONS(3597),
    [anon_sym_nullptr] = ACTIONS(3597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3597),
    [anon_sym_let] = ACTIONS(3597),
    [anon_sym_This] = ACTIONS(3597),
    [anon_sym_decltype] = ACTIONS(3597),
    [anon_sym_explicit] = ACTIONS(3597),
    [anon_sym_typename] = ACTIONS(3597),
    [anon_sym_export] = ACTIONS(3597),
    [anon_sym_module] = ACTIONS(3597),
    [anon_sym_import] = ACTIONS(3597),
    [anon_sym_template] = ACTIONS(3597),
    [anon_sym_operator] = ACTIONS(3597),
    [anon_sym_try] = ACTIONS(3597),
    [anon_sym_delete] = ACTIONS(3597),
    [anon_sym_throw] = ACTIONS(3597),
    [anon_sym_namespace] = ACTIONS(3597),
    [anon_sym_static_assert] = ACTIONS(3597),
    [anon_sym_concept] = ACTIONS(3597),
    [anon_sym_co_return] = ACTIONS(3597),
    [anon_sym_co_yield] = ACTIONS(3597),
    [anon_sym_R_DQUOTE] = ACTIONS(3599),
    [anon_sym_LR_DQUOTE] = ACTIONS(3599),
    [anon_sym_uR_DQUOTE] = ACTIONS(3599),
    [anon_sym_UR_DQUOTE] = ACTIONS(3599),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3599),
    [anon_sym_co_await] = ACTIONS(3597),
    [anon_sym_new] = ACTIONS(3597),
    [anon_sym_requires] = ACTIONS(3597),
    [sym_this] = ACTIONS(3597),
    [anon_sym_discard] = ACTIONS(3597),
    [anon_sym_precise] = ACTIONS(3597),
    [anon_sym_shared] = ACTIONS(3597),
    [anon_sym_groupshared] = ACTIONS(3597),
    [anon_sym_uniform] = ACTIONS(3597),
    [anon_sym_row_major] = ACTIONS(3597),
    [anon_sym_column_major] = ACTIONS(3597),
    [anon_sym_globallycoherent] = ACTIONS(3597),
    [anon_sym_centroid] = ACTIONS(3597),
    [anon_sym_noperspective] = ACTIONS(3597),
    [anon_sym_nointerpolation] = ACTIONS(3597),
    [anon_sym_sample] = ACTIONS(3597),
    [anon_sym_linear] = ACTIONS(3597),
    [anon_sym_snorm] = ACTIONS(3597),
    [anon_sym_unorm] = ACTIONS(3597),
    [anon_sym_point] = ACTIONS(3597),
    [anon_sym_line] = ACTIONS(3597),
    [anon_sym_triangleadj] = ACTIONS(3597),
    [anon_sym_lineadj] = ACTIONS(3597),
    [anon_sym_triangle] = ACTIONS(3597),
    [anon_sym_cbuffer] = ACTIONS(3597),
    [anon_sym_interface] = ACTIONS(3597),
    [anon_sym_extension] = ACTIONS(3597),
    [anon_sym___exported] = ACTIONS(3597),
  },
  [478] = {
    [ts_builtin_sym_end] = ACTIONS(3629),
    [sym_identifier] = ACTIONS(3631),
    [aux_sym_preproc_include_token1] = ACTIONS(3631),
    [aux_sym_preproc_def_token1] = ACTIONS(3631),
    [aux_sym_preproc_if_token1] = ACTIONS(3631),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3631),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3631),
    [sym_preproc_directive] = ACTIONS(3631),
    [anon_sym_LPAREN2] = ACTIONS(3629),
    [anon_sym_BANG] = ACTIONS(3629),
    [anon_sym_TILDE] = ACTIONS(3629),
    [anon_sym_DASH] = ACTIONS(3631),
    [anon_sym_PLUS] = ACTIONS(3631),
    [anon_sym_STAR] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_AMP] = ACTIONS(3631),
    [anon_sym_SEMI] = ACTIONS(3629),
    [anon_sym___extension__] = ACTIONS(3631),
    [anon_sym_typedef] = ACTIONS(3631),
    [anon_sym_in] = ACTIONS(3631),
    [anon_sym_out] = ACTIONS(3631),
    [anon_sym_inout] = ACTIONS(3631),
    [anon_sym_virtual] = ACTIONS(3631),
    [anon_sym_extern] = ACTIONS(3631),
    [anon_sym___attribute__] = ACTIONS(3631),
    [anon_sym___attribute] = ACTIONS(3631),
    [anon_sym_using] = ACTIONS(3631),
    [anon_sym_COLON_COLON] = ACTIONS(3629),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3629),
    [anon_sym___declspec] = ACTIONS(3631),
    [anon_sym___based] = ACTIONS(3631),
    [anon_sym___cdecl] = ACTIONS(3631),
    [anon_sym___clrcall] = ACTIONS(3631),
    [anon_sym___stdcall] = ACTIONS(3631),
    [anon_sym___fastcall] = ACTIONS(3631),
    [anon_sym___thiscall] = ACTIONS(3631),
    [anon_sym___vectorcall] = ACTIONS(3631),
    [anon_sym_LBRACE] = ACTIONS(3629),
    [anon_sym_signed] = ACTIONS(3631),
    [anon_sym_unsigned] = ACTIONS(3631),
    [anon_sym_long] = ACTIONS(3631),
    [anon_sym_short] = ACTIONS(3631),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_static] = ACTIONS(3631),
    [anon_sym_register] = ACTIONS(3631),
    [anon_sym_inline] = ACTIONS(3631),
    [anon_sym___inline] = ACTIONS(3631),
    [anon_sym___inline__] = ACTIONS(3631),
    [anon_sym___forceinline] = ACTIONS(3631),
    [anon_sym_thread_local] = ACTIONS(3631),
    [anon_sym___thread] = ACTIONS(3631),
    [anon_sym_const] = ACTIONS(3631),
    [anon_sym_constexpr] = ACTIONS(3631),
    [anon_sym_volatile] = ACTIONS(3631),
    [anon_sym_restrict] = ACTIONS(3631),
    [anon_sym___restrict__] = ACTIONS(3631),
    [anon_sym__Atomic] = ACTIONS(3631),
    [anon_sym__Noreturn] = ACTIONS(3631),
    [anon_sym_noreturn] = ACTIONS(3631),
    [anon_sym__Nonnull] = ACTIONS(3631),
    [anon_sym_mutable] = ACTIONS(3631),
    [anon_sym_constinit] = ACTIONS(3631),
    [anon_sym_consteval] = ACTIONS(3631),
    [anon_sym_alignas] = ACTIONS(3631),
    [anon_sym__Alignas] = ACTIONS(3631),
    [sym_primitive_type] = ACTIONS(3631),
    [anon_sym_enum] = ACTIONS(3631),
    [anon_sym_class] = ACTIONS(3631),
    [anon_sym_struct] = ACTIONS(3631),
    [anon_sym_union] = ACTIONS(3631),
    [anon_sym_if] = ACTIONS(3631),
    [anon_sym_else] = ACTIONS(3631),
    [anon_sym_switch] = ACTIONS(3631),
    [anon_sym_case] = ACTIONS(3631),
    [anon_sym_default] = ACTIONS(3631),
    [anon_sym_while] = ACTIONS(3631),
    [anon_sym_do] = ACTIONS(3631),
    [anon_sym_for] = ACTIONS(3631),
    [anon_sym_return] = ACTIONS(3631),
    [anon_sym_break] = ACTIONS(3631),
    [anon_sym_continue] = ACTIONS(3631),
    [anon_sym_goto] = ACTIONS(3631),
    [anon_sym___try] = ACTIONS(3631),
    [anon_sym___leave] = ACTIONS(3631),
    [anon_sym_not] = ACTIONS(3631),
    [anon_sym_compl] = ACTIONS(3631),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_sizeof] = ACTIONS(3631),
    [anon_sym___alignof__] = ACTIONS(3631),
    [anon_sym___alignof] = ACTIONS(3631),
    [anon_sym__alignof] = ACTIONS(3631),
    [anon_sym_alignof] = ACTIONS(3631),
    [anon_sym__Alignof] = ACTIONS(3631),
    [anon_sym_offsetof] = ACTIONS(3631),
    [anon_sym__Generic] = ACTIONS(3631),
    [anon_sym_asm] = ACTIONS(3631),
    [anon_sym___asm__] = ACTIONS(3631),
    [anon_sym___asm] = ACTIONS(3631),
    [sym_number_literal] = ACTIONS(3629),
    [anon_sym_L_SQUOTE] = ACTIONS(3629),
    [anon_sym_u_SQUOTE] = ACTIONS(3629),
    [anon_sym_U_SQUOTE] = ACTIONS(3629),
    [anon_sym_u8_SQUOTE] = ACTIONS(3629),
    [anon_sym_SQUOTE] = ACTIONS(3629),
    [anon_sym_L_DQUOTE] = ACTIONS(3629),
    [anon_sym_u_DQUOTE] = ACTIONS(3629),
    [anon_sym_U_DQUOTE] = ACTIONS(3629),
    [anon_sym_u8_DQUOTE] = ACTIONS(3629),
    [anon_sym_DQUOTE] = ACTIONS(3629),
    [sym_true] = ACTIONS(3631),
    [sym_false] = ACTIONS(3631),
    [anon_sym_NULL] = ACTIONS(3631),
    [anon_sym_nullptr] = ACTIONS(3631),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3631),
    [anon_sym_let] = ACTIONS(3631),
    [anon_sym_This] = ACTIONS(3631),
    [anon_sym_decltype] = ACTIONS(3631),
    [anon_sym_explicit] = ACTIONS(3631),
    [anon_sym_typename] = ACTIONS(3631),
    [anon_sym_export] = ACTIONS(3631),
    [anon_sym_module] = ACTIONS(3631),
    [anon_sym_import] = ACTIONS(3631),
    [anon_sym_template] = ACTIONS(3631),
    [anon_sym_operator] = ACTIONS(3631),
    [anon_sym_try] = ACTIONS(3631),
    [anon_sym_delete] = ACTIONS(3631),
    [anon_sym_throw] = ACTIONS(3631),
    [anon_sym_namespace] = ACTIONS(3631),
    [anon_sym_static_assert] = ACTIONS(3631),
    [anon_sym_concept] = ACTIONS(3631),
    [anon_sym_co_return] = ACTIONS(3631),
    [anon_sym_co_yield] = ACTIONS(3631),
    [anon_sym_R_DQUOTE] = ACTIONS(3629),
    [anon_sym_LR_DQUOTE] = ACTIONS(3629),
    [anon_sym_uR_DQUOTE] = ACTIONS(3629),
    [anon_sym_UR_DQUOTE] = ACTIONS(3629),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3629),
    [anon_sym_co_await] = ACTIONS(3631),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3631),
    [sym_this] = ACTIONS(3631),
    [anon_sym_discard] = ACTIONS(3631),
    [anon_sym_precise] = ACTIONS(3631),
    [anon_sym_shared] = ACTIONS(3631),
    [anon_sym_groupshared] = ACTIONS(3631),
    [anon_sym_uniform] = ACTIONS(3631),
    [anon_sym_row_major] = ACTIONS(3631),
    [anon_sym_column_major] = ACTIONS(3631),
    [anon_sym_globallycoherent] = ACTIONS(3631),
    [anon_sym_centroid] = ACTIONS(3631),
    [anon_sym_noperspective] = ACTIONS(3631),
    [anon_sym_nointerpolation] = ACTIONS(3631),
    [anon_sym_sample] = ACTIONS(3631),
    [anon_sym_linear] = ACTIONS(3631),
    [anon_sym_snorm] = ACTIONS(3631),
    [anon_sym_unorm] = ACTIONS(3631),
    [anon_sym_point] = ACTIONS(3631),
    [anon_sym_line] = ACTIONS(3631),
    [anon_sym_triangleadj] = ACTIONS(3631),
    [anon_sym_lineadj] = ACTIONS(3631),
    [anon_sym_triangle] = ACTIONS(3631),
    [anon_sym_cbuffer] = ACTIONS(3631),
    [anon_sym_interface] = ACTIONS(3631),
    [anon_sym_extension] = ACTIONS(3631),
    [anon_sym___exported] = ACTIONS(3631),
  },
  [479] = {
    [sym_identifier] = ACTIONS(3581),
    [aux_sym_preproc_include_token1] = ACTIONS(3581),
    [aux_sym_preproc_def_token1] = ACTIONS(3581),
    [aux_sym_preproc_if_token1] = ACTIONS(3581),
    [aux_sym_preproc_if_token2] = ACTIONS(3581),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3581),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3581),
    [aux_sym_preproc_else_token1] = ACTIONS(3581),
    [aux_sym_preproc_elif_token1] = ACTIONS(3581),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3581),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3581),
    [sym_preproc_directive] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(3579),
    [anon_sym_BANG] = ACTIONS(3579),
    [anon_sym_TILDE] = ACTIONS(3579),
    [anon_sym_DASH] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3581),
    [anon_sym_STAR] = ACTIONS(3579),
    [anon_sym_AMP_AMP] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3581),
    [anon_sym_SEMI] = ACTIONS(3579),
    [anon_sym___extension__] = ACTIONS(3581),
    [anon_sym_typedef] = ACTIONS(3581),
    [anon_sym_in] = ACTIONS(3581),
    [anon_sym_out] = ACTIONS(3581),
    [anon_sym_inout] = ACTIONS(3581),
    [anon_sym_virtual] = ACTIONS(3581),
    [anon_sym_extern] = ACTIONS(3581),
    [anon_sym___attribute__] = ACTIONS(3581),
    [anon_sym___attribute] = ACTIONS(3581),
    [anon_sym_using] = ACTIONS(3581),
    [anon_sym_COLON_COLON] = ACTIONS(3579),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3579),
    [anon_sym___declspec] = ACTIONS(3581),
    [anon_sym___based] = ACTIONS(3581),
    [anon_sym___cdecl] = ACTIONS(3581),
    [anon_sym___clrcall] = ACTIONS(3581),
    [anon_sym___stdcall] = ACTIONS(3581),
    [anon_sym___fastcall] = ACTIONS(3581),
    [anon_sym___thiscall] = ACTIONS(3581),
    [anon_sym___vectorcall] = ACTIONS(3581),
    [anon_sym_LBRACE] = ACTIONS(3579),
    [anon_sym_signed] = ACTIONS(3581),
    [anon_sym_unsigned] = ACTIONS(3581),
    [anon_sym_long] = ACTIONS(3581),
    [anon_sym_short] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_static] = ACTIONS(3581),
    [anon_sym_register] = ACTIONS(3581),
    [anon_sym_inline] = ACTIONS(3581),
    [anon_sym___inline] = ACTIONS(3581),
    [anon_sym___inline__] = ACTIONS(3581),
    [anon_sym___forceinline] = ACTIONS(3581),
    [anon_sym_thread_local] = ACTIONS(3581),
    [anon_sym___thread] = ACTIONS(3581),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_constexpr] = ACTIONS(3581),
    [anon_sym_volatile] = ACTIONS(3581),
    [anon_sym_restrict] = ACTIONS(3581),
    [anon_sym___restrict__] = ACTIONS(3581),
    [anon_sym__Atomic] = ACTIONS(3581),
    [anon_sym__Noreturn] = ACTIONS(3581),
    [anon_sym_noreturn] = ACTIONS(3581),
    [anon_sym__Nonnull] = ACTIONS(3581),
    [anon_sym_mutable] = ACTIONS(3581),
    [anon_sym_constinit] = ACTIONS(3581),
    [anon_sym_consteval] = ACTIONS(3581),
    [anon_sym_alignas] = ACTIONS(3581),
    [anon_sym__Alignas] = ACTIONS(3581),
    [sym_primitive_type] = ACTIONS(3581),
    [anon_sym_enum] = ACTIONS(3581),
    [anon_sym_class] = ACTIONS(3581),
    [anon_sym_struct] = ACTIONS(3581),
    [anon_sym_union] = ACTIONS(3581),
    [anon_sym_if] = ACTIONS(3581),
    [anon_sym_else] = ACTIONS(3581),
    [anon_sym_switch] = ACTIONS(3581),
    [anon_sym_case] = ACTIONS(3581),
    [anon_sym_default] = ACTIONS(3581),
    [anon_sym_while] = ACTIONS(3581),
    [anon_sym_do] = ACTIONS(3581),
    [anon_sym_for] = ACTIONS(3581),
    [anon_sym_return] = ACTIONS(3581),
    [anon_sym_break] = ACTIONS(3581),
    [anon_sym_continue] = ACTIONS(3581),
    [anon_sym_goto] = ACTIONS(3581),
    [anon_sym___try] = ACTIONS(3581),
    [anon_sym___leave] = ACTIONS(3581),
    [anon_sym_not] = ACTIONS(3581),
    [anon_sym_compl] = ACTIONS(3581),
    [anon_sym_DASH_DASH] = ACTIONS(3579),
    [anon_sym_PLUS_PLUS] = ACTIONS(3579),
    [anon_sym_sizeof] = ACTIONS(3581),
    [anon_sym___alignof__] = ACTIONS(3581),
    [anon_sym___alignof] = ACTIONS(3581),
    [anon_sym__alignof] = ACTIONS(3581),
    [anon_sym_alignof] = ACTIONS(3581),
    [anon_sym__Alignof] = ACTIONS(3581),
    [anon_sym_offsetof] = ACTIONS(3581),
    [anon_sym__Generic] = ACTIONS(3581),
    [anon_sym_asm] = ACTIONS(3581),
    [anon_sym___asm__] = ACTIONS(3581),
    [anon_sym___asm] = ACTIONS(3581),
    [sym_number_literal] = ACTIONS(3579),
    [anon_sym_L_SQUOTE] = ACTIONS(3579),
    [anon_sym_u_SQUOTE] = ACTIONS(3579),
    [anon_sym_U_SQUOTE] = ACTIONS(3579),
    [anon_sym_u8_SQUOTE] = ACTIONS(3579),
    [anon_sym_SQUOTE] = ACTIONS(3579),
    [anon_sym_L_DQUOTE] = ACTIONS(3579),
    [anon_sym_u_DQUOTE] = ACTIONS(3579),
    [anon_sym_U_DQUOTE] = ACTIONS(3579),
    [anon_sym_u8_DQUOTE] = ACTIONS(3579),
    [anon_sym_DQUOTE] = ACTIONS(3579),
    [sym_true] = ACTIONS(3581),
    [sym_false] = ACTIONS(3581),
    [anon_sym_NULL] = ACTIONS(3581),
    [anon_sym_nullptr] = ACTIONS(3581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_This] = ACTIONS(3581),
    [anon_sym_decltype] = ACTIONS(3581),
    [anon_sym_explicit] = ACTIONS(3581),
    [anon_sym_typename] = ACTIONS(3581),
    [anon_sym_template] = ACTIONS(3581),
    [anon_sym_operator] = ACTIONS(3581),
    [anon_sym_try] = ACTIONS(3581),
    [anon_sym_delete] = ACTIONS(3581),
    [anon_sym_throw] = ACTIONS(3581),
    [anon_sym_namespace] = ACTIONS(3581),
    [anon_sym_static_assert] = ACTIONS(3581),
    [anon_sym_concept] = ACTIONS(3581),
    [anon_sym_co_return] = ACTIONS(3581),
    [anon_sym_co_yield] = ACTIONS(3581),
    [anon_sym_R_DQUOTE] = ACTIONS(3579),
    [anon_sym_LR_DQUOTE] = ACTIONS(3579),
    [anon_sym_uR_DQUOTE] = ACTIONS(3579),
    [anon_sym_UR_DQUOTE] = ACTIONS(3579),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3579),
    [anon_sym_co_await] = ACTIONS(3581),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_requires] = ACTIONS(3581),
    [sym_this] = ACTIONS(3581),
    [anon_sym_discard] = ACTIONS(3581),
    [anon_sym_precise] = ACTIONS(3581),
    [anon_sym_shared] = ACTIONS(3581),
    [anon_sym_groupshared] = ACTIONS(3581),
    [anon_sym_uniform] = ACTIONS(3581),
    [anon_sym_row_major] = ACTIONS(3581),
    [anon_sym_column_major] = ACTIONS(3581),
    [anon_sym_globallycoherent] = ACTIONS(3581),
    [anon_sym_centroid] = ACTIONS(3581),
    [anon_sym_noperspective] = ACTIONS(3581),
    [anon_sym_nointerpolation] = ACTIONS(3581),
    [anon_sym_sample] = ACTIONS(3581),
    [anon_sym_linear] = ACTIONS(3581),
    [anon_sym_snorm] = ACTIONS(3581),
    [anon_sym_unorm] = ACTIONS(3581),
    [anon_sym_point] = ACTIONS(3581),
    [anon_sym_line] = ACTIONS(3581),
    [anon_sym_triangleadj] = ACTIONS(3581),
    [anon_sym_lineadj] = ACTIONS(3581),
    [anon_sym_triangle] = ACTIONS(3581),
    [anon_sym_cbuffer] = ACTIONS(3581),
    [anon_sym_interface] = ACTIONS(3581),
    [anon_sym_extension] = ACTIONS(3581),
  },
  [480] = {
    [ts_builtin_sym_end] = ACTIONS(3633),
    [sym_identifier] = ACTIONS(3635),
    [aux_sym_preproc_include_token1] = ACTIONS(3635),
    [aux_sym_preproc_def_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3635),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3635),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3635),
    [sym_preproc_directive] = ACTIONS(3635),
    [anon_sym_LPAREN2] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_TILDE] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3635),
    [anon_sym_PLUS] = ACTIONS(3635),
    [anon_sym_STAR] = ACTIONS(3633),
    [anon_sym_AMP_AMP] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_SEMI] = ACTIONS(3633),
    [anon_sym___extension__] = ACTIONS(3635),
    [anon_sym_typedef] = ACTIONS(3635),
    [anon_sym_in] = ACTIONS(3635),
    [anon_sym_out] = ACTIONS(3635),
    [anon_sym_inout] = ACTIONS(3635),
    [anon_sym_virtual] = ACTIONS(3635),
    [anon_sym_extern] = ACTIONS(3635),
    [anon_sym___attribute__] = ACTIONS(3635),
    [anon_sym___attribute] = ACTIONS(3635),
    [anon_sym_using] = ACTIONS(3635),
    [anon_sym_COLON_COLON] = ACTIONS(3633),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3633),
    [anon_sym___declspec] = ACTIONS(3635),
    [anon_sym___based] = ACTIONS(3635),
    [anon_sym___cdecl] = ACTIONS(3635),
    [anon_sym___clrcall] = ACTIONS(3635),
    [anon_sym___stdcall] = ACTIONS(3635),
    [anon_sym___fastcall] = ACTIONS(3635),
    [anon_sym___thiscall] = ACTIONS(3635),
    [anon_sym___vectorcall] = ACTIONS(3635),
    [anon_sym_LBRACE] = ACTIONS(3633),
    [anon_sym_signed] = ACTIONS(3635),
    [anon_sym_unsigned] = ACTIONS(3635),
    [anon_sym_long] = ACTIONS(3635),
    [anon_sym_short] = ACTIONS(3635),
    [anon_sym_LBRACK] = ACTIONS(3635),
    [anon_sym_static] = ACTIONS(3635),
    [anon_sym_register] = ACTIONS(3635),
    [anon_sym_inline] = ACTIONS(3635),
    [anon_sym___inline] = ACTIONS(3635),
    [anon_sym___inline__] = ACTIONS(3635),
    [anon_sym___forceinline] = ACTIONS(3635),
    [anon_sym_thread_local] = ACTIONS(3635),
    [anon_sym___thread] = ACTIONS(3635),
    [anon_sym_const] = ACTIONS(3635),
    [anon_sym_constexpr] = ACTIONS(3635),
    [anon_sym_volatile] = ACTIONS(3635),
    [anon_sym_restrict] = ACTIONS(3635),
    [anon_sym___restrict__] = ACTIONS(3635),
    [anon_sym__Atomic] = ACTIONS(3635),
    [anon_sym__Noreturn] = ACTIONS(3635),
    [anon_sym_noreturn] = ACTIONS(3635),
    [anon_sym__Nonnull] = ACTIONS(3635),
    [anon_sym_mutable] = ACTIONS(3635),
    [anon_sym_constinit] = ACTIONS(3635),
    [anon_sym_consteval] = ACTIONS(3635),
    [anon_sym_alignas] = ACTIONS(3635),
    [anon_sym__Alignas] = ACTIONS(3635),
    [sym_primitive_type] = ACTIONS(3635),
    [anon_sym_enum] = ACTIONS(3635),
    [anon_sym_class] = ACTIONS(3635),
    [anon_sym_struct] = ACTIONS(3635),
    [anon_sym_union] = ACTIONS(3635),
    [anon_sym_if] = ACTIONS(3635),
    [anon_sym_else] = ACTIONS(3635),
    [anon_sym_switch] = ACTIONS(3635),
    [anon_sym_case] = ACTIONS(3635),
    [anon_sym_default] = ACTIONS(3635),
    [anon_sym_while] = ACTIONS(3635),
    [anon_sym_do] = ACTIONS(3635),
    [anon_sym_for] = ACTIONS(3635),
    [anon_sym_return] = ACTIONS(3635),
    [anon_sym_break] = ACTIONS(3635),
    [anon_sym_continue] = ACTIONS(3635),
    [anon_sym_goto] = ACTIONS(3635),
    [anon_sym___try] = ACTIONS(3635),
    [anon_sym___leave] = ACTIONS(3635),
    [anon_sym_not] = ACTIONS(3635),
    [anon_sym_compl] = ACTIONS(3635),
    [anon_sym_DASH_DASH] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3633),
    [anon_sym_sizeof] = ACTIONS(3635),
    [anon_sym___alignof__] = ACTIONS(3635),
    [anon_sym___alignof] = ACTIONS(3635),
    [anon_sym__alignof] = ACTIONS(3635),
    [anon_sym_alignof] = ACTIONS(3635),
    [anon_sym__Alignof] = ACTIONS(3635),
    [anon_sym_offsetof] = ACTIONS(3635),
    [anon_sym__Generic] = ACTIONS(3635),
    [anon_sym_asm] = ACTIONS(3635),
    [anon_sym___asm__] = ACTIONS(3635),
    [anon_sym___asm] = ACTIONS(3635),
    [sym_number_literal] = ACTIONS(3633),
    [anon_sym_L_SQUOTE] = ACTIONS(3633),
    [anon_sym_u_SQUOTE] = ACTIONS(3633),
    [anon_sym_U_SQUOTE] = ACTIONS(3633),
    [anon_sym_u8_SQUOTE] = ACTIONS(3633),
    [anon_sym_SQUOTE] = ACTIONS(3633),
    [anon_sym_L_DQUOTE] = ACTIONS(3633),
    [anon_sym_u_DQUOTE] = ACTIONS(3633),
    [anon_sym_U_DQUOTE] = ACTIONS(3633),
    [anon_sym_u8_DQUOTE] = ACTIONS(3633),
    [anon_sym_DQUOTE] = ACTIONS(3633),
    [sym_true] = ACTIONS(3635),
    [sym_false] = ACTIONS(3635),
    [anon_sym_NULL] = ACTIONS(3635),
    [anon_sym_nullptr] = ACTIONS(3635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3635),
    [anon_sym_let] = ACTIONS(3635),
    [anon_sym_This] = ACTIONS(3635),
    [anon_sym_decltype] = ACTIONS(3635),
    [anon_sym_explicit] = ACTIONS(3635),
    [anon_sym_typename] = ACTIONS(3635),
    [anon_sym_export] = ACTIONS(3635),
    [anon_sym_module] = ACTIONS(3635),
    [anon_sym_import] = ACTIONS(3635),
    [anon_sym_template] = ACTIONS(3635),
    [anon_sym_operator] = ACTIONS(3635),
    [anon_sym_try] = ACTIONS(3635),
    [anon_sym_delete] = ACTIONS(3635),
    [anon_sym_throw] = ACTIONS(3635),
    [anon_sym_namespace] = ACTIONS(3635),
    [anon_sym_static_assert] = ACTIONS(3635),
    [anon_sym_concept] = ACTIONS(3635),
    [anon_sym_co_return] = ACTIONS(3635),
    [anon_sym_co_yield] = ACTIONS(3635),
    [anon_sym_R_DQUOTE] = ACTIONS(3633),
    [anon_sym_LR_DQUOTE] = ACTIONS(3633),
    [anon_sym_uR_DQUOTE] = ACTIONS(3633),
    [anon_sym_UR_DQUOTE] = ACTIONS(3633),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3633),
    [anon_sym_co_await] = ACTIONS(3635),
    [anon_sym_new] = ACTIONS(3635),
    [anon_sym_requires] = ACTIONS(3635),
    [sym_this] = ACTIONS(3635),
    [anon_sym_discard] = ACTIONS(3635),
    [anon_sym_precise] = ACTIONS(3635),
    [anon_sym_shared] = ACTIONS(3635),
    [anon_sym_groupshared] = ACTIONS(3635),
    [anon_sym_uniform] = ACTIONS(3635),
    [anon_sym_row_major] = ACTIONS(3635),
    [anon_sym_column_major] = ACTIONS(3635),
    [anon_sym_globallycoherent] = ACTIONS(3635),
    [anon_sym_centroid] = ACTIONS(3635),
    [anon_sym_noperspective] = ACTIONS(3635),
    [anon_sym_nointerpolation] = ACTIONS(3635),
    [anon_sym_sample] = ACTIONS(3635),
    [anon_sym_linear] = ACTIONS(3635),
    [anon_sym_snorm] = ACTIONS(3635),
    [anon_sym_unorm] = ACTIONS(3635),
    [anon_sym_point] = ACTIONS(3635),
    [anon_sym_line] = ACTIONS(3635),
    [anon_sym_triangleadj] = ACTIONS(3635),
    [anon_sym_lineadj] = ACTIONS(3635),
    [anon_sym_triangle] = ACTIONS(3635),
    [anon_sym_cbuffer] = ACTIONS(3635),
    [anon_sym_interface] = ACTIONS(3635),
    [anon_sym_extension] = ACTIONS(3635),
    [anon_sym___exported] = ACTIONS(3635),
  },
  [481] = {
    [sym_identifier] = ACTIONS(3591),
    [aux_sym_preproc_include_token1] = ACTIONS(3591),
    [aux_sym_preproc_def_token1] = ACTIONS(3591),
    [aux_sym_preproc_if_token1] = ACTIONS(3591),
    [aux_sym_preproc_if_token2] = ACTIONS(3591),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3591),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3591),
    [aux_sym_preproc_else_token1] = ACTIONS(3591),
    [aux_sym_preproc_elif_token1] = ACTIONS(3591),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3591),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3591),
    [sym_preproc_directive] = ACTIONS(3591),
    [anon_sym_LPAREN2] = ACTIONS(3589),
    [anon_sym_BANG] = ACTIONS(3589),
    [anon_sym_TILDE] = ACTIONS(3589),
    [anon_sym_DASH] = ACTIONS(3591),
    [anon_sym_PLUS] = ACTIONS(3591),
    [anon_sym_STAR] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(3589),
    [anon_sym___extension__] = ACTIONS(3591),
    [anon_sym_typedef] = ACTIONS(3591),
    [anon_sym_in] = ACTIONS(3591),
    [anon_sym_out] = ACTIONS(3591),
    [anon_sym_inout] = ACTIONS(3591),
    [anon_sym_virtual] = ACTIONS(3591),
    [anon_sym_extern] = ACTIONS(3591),
    [anon_sym___attribute__] = ACTIONS(3591),
    [anon_sym___attribute] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3591),
    [anon_sym_COLON_COLON] = ACTIONS(3589),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3589),
    [anon_sym___declspec] = ACTIONS(3591),
    [anon_sym___based] = ACTIONS(3591),
    [anon_sym___cdecl] = ACTIONS(3591),
    [anon_sym___clrcall] = ACTIONS(3591),
    [anon_sym___stdcall] = ACTIONS(3591),
    [anon_sym___fastcall] = ACTIONS(3591),
    [anon_sym___thiscall] = ACTIONS(3591),
    [anon_sym___vectorcall] = ACTIONS(3591),
    [anon_sym_LBRACE] = ACTIONS(3589),
    [anon_sym_signed] = ACTIONS(3591),
    [anon_sym_unsigned] = ACTIONS(3591),
    [anon_sym_long] = ACTIONS(3591),
    [anon_sym_short] = ACTIONS(3591),
    [anon_sym_LBRACK] = ACTIONS(3591),
    [anon_sym_static] = ACTIONS(3591),
    [anon_sym_register] = ACTIONS(3591),
    [anon_sym_inline] = ACTIONS(3591),
    [anon_sym___inline] = ACTIONS(3591),
    [anon_sym___inline__] = ACTIONS(3591),
    [anon_sym___forceinline] = ACTIONS(3591),
    [anon_sym_thread_local] = ACTIONS(3591),
    [anon_sym___thread] = ACTIONS(3591),
    [anon_sym_const] = ACTIONS(3591),
    [anon_sym_constexpr] = ACTIONS(3591),
    [anon_sym_volatile] = ACTIONS(3591),
    [anon_sym_restrict] = ACTIONS(3591),
    [anon_sym___restrict__] = ACTIONS(3591),
    [anon_sym__Atomic] = ACTIONS(3591),
    [anon_sym__Noreturn] = ACTIONS(3591),
    [anon_sym_noreturn] = ACTIONS(3591),
    [anon_sym__Nonnull] = ACTIONS(3591),
    [anon_sym_mutable] = ACTIONS(3591),
    [anon_sym_constinit] = ACTIONS(3591),
    [anon_sym_consteval] = ACTIONS(3591),
    [anon_sym_alignas] = ACTIONS(3591),
    [anon_sym__Alignas] = ACTIONS(3591),
    [sym_primitive_type] = ACTIONS(3591),
    [anon_sym_enum] = ACTIONS(3591),
    [anon_sym_class] = ACTIONS(3591),
    [anon_sym_struct] = ACTIONS(3591),
    [anon_sym_union] = ACTIONS(3591),
    [anon_sym_if] = ACTIONS(3591),
    [anon_sym_else] = ACTIONS(3591),
    [anon_sym_switch] = ACTIONS(3591),
    [anon_sym_case] = ACTIONS(3591),
    [anon_sym_default] = ACTIONS(3591),
    [anon_sym_while] = ACTIONS(3591),
    [anon_sym_do] = ACTIONS(3591),
    [anon_sym_for] = ACTIONS(3591),
    [anon_sym_return] = ACTIONS(3591),
    [anon_sym_break] = ACTIONS(3591),
    [anon_sym_continue] = ACTIONS(3591),
    [anon_sym_goto] = ACTIONS(3591),
    [anon_sym___try] = ACTIONS(3591),
    [anon_sym___leave] = ACTIONS(3591),
    [anon_sym_not] = ACTIONS(3591),
    [anon_sym_compl] = ACTIONS(3591),
    [anon_sym_DASH_DASH] = ACTIONS(3589),
    [anon_sym_PLUS_PLUS] = ACTIONS(3589),
    [anon_sym_sizeof] = ACTIONS(3591),
    [anon_sym___alignof__] = ACTIONS(3591),
    [anon_sym___alignof] = ACTIONS(3591),
    [anon_sym__alignof] = ACTIONS(3591),
    [anon_sym_alignof] = ACTIONS(3591),
    [anon_sym__Alignof] = ACTIONS(3591),
    [anon_sym_offsetof] = ACTIONS(3591),
    [anon_sym__Generic] = ACTIONS(3591),
    [anon_sym_asm] = ACTIONS(3591),
    [anon_sym___asm__] = ACTIONS(3591),
    [anon_sym___asm] = ACTIONS(3591),
    [sym_number_literal] = ACTIONS(3589),
    [anon_sym_L_SQUOTE] = ACTIONS(3589),
    [anon_sym_u_SQUOTE] = ACTIONS(3589),
    [anon_sym_U_SQUOTE] = ACTIONS(3589),
    [anon_sym_u8_SQUOTE] = ACTIONS(3589),
    [anon_sym_SQUOTE] = ACTIONS(3589),
    [anon_sym_L_DQUOTE] = ACTIONS(3589),
    [anon_sym_u_DQUOTE] = ACTIONS(3589),
    [anon_sym_U_DQUOTE] = ACTIONS(3589),
    [anon_sym_u8_DQUOTE] = ACTIONS(3589),
    [anon_sym_DQUOTE] = ACTIONS(3589),
    [sym_true] = ACTIONS(3591),
    [sym_false] = ACTIONS(3591),
    [anon_sym_NULL] = ACTIONS(3591),
    [anon_sym_nullptr] = ACTIONS(3591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3591),
    [anon_sym_let] = ACTIONS(3591),
    [anon_sym_This] = ACTIONS(3591),
    [anon_sym_decltype] = ACTIONS(3591),
    [anon_sym_explicit] = ACTIONS(3591),
    [anon_sym_typename] = ACTIONS(3591),
    [anon_sym_template] = ACTIONS(3591),
    [anon_sym_operator] = ACTIONS(3591),
    [anon_sym_try] = ACTIONS(3591),
    [anon_sym_delete] = ACTIONS(3591),
    [anon_sym_throw] = ACTIONS(3591),
    [anon_sym_namespace] = ACTIONS(3591),
    [anon_sym_static_assert] = ACTIONS(3591),
    [anon_sym_concept] = ACTIONS(3591),
    [anon_sym_co_return] = ACTIONS(3591),
    [anon_sym_co_yield] = ACTIONS(3591),
    [anon_sym_R_DQUOTE] = ACTIONS(3589),
    [anon_sym_LR_DQUOTE] = ACTIONS(3589),
    [anon_sym_uR_DQUOTE] = ACTIONS(3589),
    [anon_sym_UR_DQUOTE] = ACTIONS(3589),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3589),
    [anon_sym_co_await] = ACTIONS(3591),
    [anon_sym_new] = ACTIONS(3591),
    [anon_sym_requires] = ACTIONS(3591),
    [sym_this] = ACTIONS(3591),
    [anon_sym_discard] = ACTIONS(3591),
    [anon_sym_precise] = ACTIONS(3591),
    [anon_sym_shared] = ACTIONS(3591),
    [anon_sym_groupshared] = ACTIONS(3591),
    [anon_sym_uniform] = ACTIONS(3591),
    [anon_sym_row_major] = ACTIONS(3591),
    [anon_sym_column_major] = ACTIONS(3591),
    [anon_sym_globallycoherent] = ACTIONS(3591),
    [anon_sym_centroid] = ACTIONS(3591),
    [anon_sym_noperspective] = ACTIONS(3591),
    [anon_sym_nointerpolation] = ACTIONS(3591),
    [anon_sym_sample] = ACTIONS(3591),
    [anon_sym_linear] = ACTIONS(3591),
    [anon_sym_snorm] = ACTIONS(3591),
    [anon_sym_unorm] = ACTIONS(3591),
    [anon_sym_point] = ACTIONS(3591),
    [anon_sym_line] = ACTIONS(3591),
    [anon_sym_triangleadj] = ACTIONS(3591),
    [anon_sym_lineadj] = ACTIONS(3591),
    [anon_sym_triangle] = ACTIONS(3591),
    [anon_sym_cbuffer] = ACTIONS(3591),
    [anon_sym_interface] = ACTIONS(3591),
    [anon_sym_extension] = ACTIONS(3591),
  },
  [482] = {
    [sym_identifier] = ACTIONS(3637),
    [aux_sym_preproc_include_token1] = ACTIONS(3637),
    [aux_sym_preproc_def_token1] = ACTIONS(3637),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_if_token2] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3637),
    [aux_sym_preproc_else_token1] = ACTIONS(3637),
    [aux_sym_preproc_elif_token1] = ACTIONS(3637),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3637),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3637),
    [sym_preproc_directive] = ACTIONS(3637),
    [anon_sym_LPAREN2] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(3639),
    [anon_sym_TILDE] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3637),
    [anon_sym_STAR] = ACTIONS(3639),
    [anon_sym_AMP_AMP] = ACTIONS(3639),
    [anon_sym_AMP] = ACTIONS(3637),
    [anon_sym_SEMI] = ACTIONS(3639),
    [anon_sym___extension__] = ACTIONS(3637),
    [anon_sym_typedef] = ACTIONS(3637),
    [anon_sym_in] = ACTIONS(3637),
    [anon_sym_out] = ACTIONS(3637),
    [anon_sym_inout] = ACTIONS(3637),
    [anon_sym_virtual] = ACTIONS(3637),
    [anon_sym_extern] = ACTIONS(3637),
    [anon_sym___attribute__] = ACTIONS(3637),
    [anon_sym___attribute] = ACTIONS(3637),
    [anon_sym_using] = ACTIONS(3637),
    [anon_sym_COLON_COLON] = ACTIONS(3639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3639),
    [anon_sym___declspec] = ACTIONS(3637),
    [anon_sym___based] = ACTIONS(3637),
    [anon_sym___cdecl] = ACTIONS(3637),
    [anon_sym___clrcall] = ACTIONS(3637),
    [anon_sym___stdcall] = ACTIONS(3637),
    [anon_sym___fastcall] = ACTIONS(3637),
    [anon_sym___thiscall] = ACTIONS(3637),
    [anon_sym___vectorcall] = ACTIONS(3637),
    [anon_sym_LBRACE] = ACTIONS(3639),
    [anon_sym_signed] = ACTIONS(3637),
    [anon_sym_unsigned] = ACTIONS(3637),
    [anon_sym_long] = ACTIONS(3637),
    [anon_sym_short] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(3637),
    [anon_sym_static] = ACTIONS(3637),
    [anon_sym_register] = ACTIONS(3637),
    [anon_sym_inline] = ACTIONS(3637),
    [anon_sym___inline] = ACTIONS(3637),
    [anon_sym___inline__] = ACTIONS(3637),
    [anon_sym___forceinline] = ACTIONS(3637),
    [anon_sym_thread_local] = ACTIONS(3637),
    [anon_sym___thread] = ACTIONS(3637),
    [anon_sym_const] = ACTIONS(3637),
    [anon_sym_constexpr] = ACTIONS(3637),
    [anon_sym_volatile] = ACTIONS(3637),
    [anon_sym_restrict] = ACTIONS(3637),
    [anon_sym___restrict__] = ACTIONS(3637),
    [anon_sym__Atomic] = ACTIONS(3637),
    [anon_sym__Noreturn] = ACTIONS(3637),
    [anon_sym_noreturn] = ACTIONS(3637),
    [anon_sym__Nonnull] = ACTIONS(3637),
    [anon_sym_mutable] = ACTIONS(3637),
    [anon_sym_constinit] = ACTIONS(3637),
    [anon_sym_consteval] = ACTIONS(3637),
    [anon_sym_alignas] = ACTIONS(3637),
    [anon_sym__Alignas] = ACTIONS(3637),
    [sym_primitive_type] = ACTIONS(3637),
    [anon_sym_enum] = ACTIONS(3637),
    [anon_sym_class] = ACTIONS(3637),
    [anon_sym_struct] = ACTIONS(3637),
    [anon_sym_union] = ACTIONS(3637),
    [anon_sym_if] = ACTIONS(3637),
    [anon_sym_else] = ACTIONS(3637),
    [anon_sym_switch] = ACTIONS(3637),
    [anon_sym_case] = ACTIONS(3637),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3637),
    [anon_sym_do] = ACTIONS(3637),
    [anon_sym_for] = ACTIONS(3637),
    [anon_sym_return] = ACTIONS(3637),
    [anon_sym_break] = ACTIONS(3637),
    [anon_sym_continue] = ACTIONS(3637),
    [anon_sym_goto] = ACTIONS(3637),
    [anon_sym___try] = ACTIONS(3637),
    [anon_sym___leave] = ACTIONS(3637),
    [anon_sym_not] = ACTIONS(3637),
    [anon_sym_compl] = ACTIONS(3637),
    [anon_sym_DASH_DASH] = ACTIONS(3639),
    [anon_sym_PLUS_PLUS] = ACTIONS(3639),
    [anon_sym_sizeof] = ACTIONS(3637),
    [anon_sym___alignof__] = ACTIONS(3637),
    [anon_sym___alignof] = ACTIONS(3637),
    [anon_sym__alignof] = ACTIONS(3637),
    [anon_sym_alignof] = ACTIONS(3637),
    [anon_sym__Alignof] = ACTIONS(3637),
    [anon_sym_offsetof] = ACTIONS(3637),
    [anon_sym__Generic] = ACTIONS(3637),
    [anon_sym_asm] = ACTIONS(3637),
    [anon_sym___asm__] = ACTIONS(3637),
    [anon_sym___asm] = ACTIONS(3637),
    [sym_number_literal] = ACTIONS(3639),
    [anon_sym_L_SQUOTE] = ACTIONS(3639),
    [anon_sym_u_SQUOTE] = ACTIONS(3639),
    [anon_sym_U_SQUOTE] = ACTIONS(3639),
    [anon_sym_u8_SQUOTE] = ACTIONS(3639),
    [anon_sym_SQUOTE] = ACTIONS(3639),
    [anon_sym_L_DQUOTE] = ACTIONS(3639),
    [anon_sym_u_DQUOTE] = ACTIONS(3639),
    [anon_sym_U_DQUOTE] = ACTIONS(3639),
    [anon_sym_u8_DQUOTE] = ACTIONS(3639),
    [anon_sym_DQUOTE] = ACTIONS(3639),
    [sym_true] = ACTIONS(3637),
    [sym_false] = ACTIONS(3637),
    [anon_sym_NULL] = ACTIONS(3637),
    [anon_sym_nullptr] = ACTIONS(3637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3637),
    [anon_sym_let] = ACTIONS(3637),
    [anon_sym_This] = ACTIONS(3637),
    [anon_sym_decltype] = ACTIONS(3637),
    [anon_sym_explicit] = ACTIONS(3637),
    [anon_sym_typename] = ACTIONS(3637),
    [anon_sym_template] = ACTIONS(3637),
    [anon_sym_operator] = ACTIONS(3637),
    [anon_sym_try] = ACTIONS(3637),
    [anon_sym_delete] = ACTIONS(3637),
    [anon_sym_throw] = ACTIONS(3637),
    [anon_sym_namespace] = ACTIONS(3637),
    [anon_sym_static_assert] = ACTIONS(3637),
    [anon_sym_concept] = ACTIONS(3637),
    [anon_sym_co_return] = ACTIONS(3637),
    [anon_sym_co_yield] = ACTIONS(3637),
    [anon_sym_R_DQUOTE] = ACTIONS(3639),
    [anon_sym_LR_DQUOTE] = ACTIONS(3639),
    [anon_sym_uR_DQUOTE] = ACTIONS(3639),
    [anon_sym_UR_DQUOTE] = ACTIONS(3639),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3639),
    [anon_sym_co_await] = ACTIONS(3637),
    [anon_sym_new] = ACTIONS(3637),
    [anon_sym_requires] = ACTIONS(3637),
    [sym_this] = ACTIONS(3637),
    [anon_sym_discard] = ACTIONS(3637),
    [anon_sym_precise] = ACTIONS(3637),
    [anon_sym_shared] = ACTIONS(3637),
    [anon_sym_groupshared] = ACTIONS(3637),
    [anon_sym_uniform] = ACTIONS(3637),
    [anon_sym_row_major] = ACTIONS(3637),
    [anon_sym_column_major] = ACTIONS(3637),
    [anon_sym_globallycoherent] = ACTIONS(3637),
    [anon_sym_centroid] = ACTIONS(3637),
    [anon_sym_noperspective] = ACTIONS(3637),
    [anon_sym_nointerpolation] = ACTIONS(3637),
    [anon_sym_sample] = ACTIONS(3637),
    [anon_sym_linear] = ACTIONS(3637),
    [anon_sym_snorm] = ACTIONS(3637),
    [anon_sym_unorm] = ACTIONS(3637),
    [anon_sym_point] = ACTIONS(3637),
    [anon_sym_line] = ACTIONS(3637),
    [anon_sym_triangleadj] = ACTIONS(3637),
    [anon_sym_lineadj] = ACTIONS(3637),
    [anon_sym_triangle] = ACTIONS(3637),
    [anon_sym_cbuffer] = ACTIONS(3637),
    [anon_sym_interface] = ACTIONS(3637),
    [anon_sym_extension] = ACTIONS(3637),
  },
  [483] = {
    [sym_identifier] = ACTIONS(3641),
    [aux_sym_preproc_include_token1] = ACTIONS(3641),
    [aux_sym_preproc_def_token1] = ACTIONS(3641),
    [aux_sym_preproc_if_token1] = ACTIONS(3641),
    [aux_sym_preproc_if_token2] = ACTIONS(3641),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3641),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3641),
    [aux_sym_preproc_else_token1] = ACTIONS(3641),
    [aux_sym_preproc_elif_token1] = ACTIONS(3641),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3641),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3641),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(3643),
    [anon_sym_BANG] = ACTIONS(3643),
    [anon_sym_TILDE] = ACTIONS(3643),
    [anon_sym_DASH] = ACTIONS(3641),
    [anon_sym_PLUS] = ACTIONS(3641),
    [anon_sym_STAR] = ACTIONS(3643),
    [anon_sym_AMP_AMP] = ACTIONS(3643),
    [anon_sym_AMP] = ACTIONS(3641),
    [anon_sym_SEMI] = ACTIONS(3643),
    [anon_sym___extension__] = ACTIONS(3641),
    [anon_sym_typedef] = ACTIONS(3641),
    [anon_sym_in] = ACTIONS(3641),
    [anon_sym_out] = ACTIONS(3641),
    [anon_sym_inout] = ACTIONS(3641),
    [anon_sym_virtual] = ACTIONS(3641),
    [anon_sym_extern] = ACTIONS(3641),
    [anon_sym___attribute__] = ACTIONS(3641),
    [anon_sym___attribute] = ACTIONS(3641),
    [anon_sym_using] = ACTIONS(3641),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3643),
    [anon_sym___declspec] = ACTIONS(3641),
    [anon_sym___based] = ACTIONS(3641),
    [anon_sym___cdecl] = ACTIONS(3641),
    [anon_sym___clrcall] = ACTIONS(3641),
    [anon_sym___stdcall] = ACTIONS(3641),
    [anon_sym___fastcall] = ACTIONS(3641),
    [anon_sym___thiscall] = ACTIONS(3641),
    [anon_sym___vectorcall] = ACTIONS(3641),
    [anon_sym_LBRACE] = ACTIONS(3643),
    [anon_sym_signed] = ACTIONS(3641),
    [anon_sym_unsigned] = ACTIONS(3641),
    [anon_sym_long] = ACTIONS(3641),
    [anon_sym_short] = ACTIONS(3641),
    [anon_sym_LBRACK] = ACTIONS(3641),
    [anon_sym_static] = ACTIONS(3641),
    [anon_sym_register] = ACTIONS(3641),
    [anon_sym_inline] = ACTIONS(3641),
    [anon_sym___inline] = ACTIONS(3641),
    [anon_sym___inline__] = ACTIONS(3641),
    [anon_sym___forceinline] = ACTIONS(3641),
    [anon_sym_thread_local] = ACTIONS(3641),
    [anon_sym___thread] = ACTIONS(3641),
    [anon_sym_const] = ACTIONS(3641),
    [anon_sym_constexpr] = ACTIONS(3641),
    [anon_sym_volatile] = ACTIONS(3641),
    [anon_sym_restrict] = ACTIONS(3641),
    [anon_sym___restrict__] = ACTIONS(3641),
    [anon_sym__Atomic] = ACTIONS(3641),
    [anon_sym__Noreturn] = ACTIONS(3641),
    [anon_sym_noreturn] = ACTIONS(3641),
    [anon_sym__Nonnull] = ACTIONS(3641),
    [anon_sym_mutable] = ACTIONS(3641),
    [anon_sym_constinit] = ACTIONS(3641),
    [anon_sym_consteval] = ACTIONS(3641),
    [anon_sym_alignas] = ACTIONS(3641),
    [anon_sym__Alignas] = ACTIONS(3641),
    [sym_primitive_type] = ACTIONS(3641),
    [anon_sym_enum] = ACTIONS(3641),
    [anon_sym_class] = ACTIONS(3641),
    [anon_sym_struct] = ACTIONS(3641),
    [anon_sym_union] = ACTIONS(3641),
    [anon_sym_if] = ACTIONS(3641),
    [anon_sym_else] = ACTIONS(3641),
    [anon_sym_switch] = ACTIONS(3641),
    [anon_sym_case] = ACTIONS(3641),
    [anon_sym_default] = ACTIONS(3641),
    [anon_sym_while] = ACTIONS(3641),
    [anon_sym_do] = ACTIONS(3641),
    [anon_sym_for] = ACTIONS(3641),
    [anon_sym_return] = ACTIONS(3641),
    [anon_sym_break] = ACTIONS(3641),
    [anon_sym_continue] = ACTIONS(3641),
    [anon_sym_goto] = ACTIONS(3641),
    [anon_sym___try] = ACTIONS(3641),
    [anon_sym___leave] = ACTIONS(3641),
    [anon_sym_not] = ACTIONS(3641),
    [anon_sym_compl] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3643),
    [anon_sym_PLUS_PLUS] = ACTIONS(3643),
    [anon_sym_sizeof] = ACTIONS(3641),
    [anon_sym___alignof__] = ACTIONS(3641),
    [anon_sym___alignof] = ACTIONS(3641),
    [anon_sym__alignof] = ACTIONS(3641),
    [anon_sym_alignof] = ACTIONS(3641),
    [anon_sym__Alignof] = ACTIONS(3641),
    [anon_sym_offsetof] = ACTIONS(3641),
    [anon_sym__Generic] = ACTIONS(3641),
    [anon_sym_asm] = ACTIONS(3641),
    [anon_sym___asm__] = ACTIONS(3641),
    [anon_sym___asm] = ACTIONS(3641),
    [sym_number_literal] = ACTIONS(3643),
    [anon_sym_L_SQUOTE] = ACTIONS(3643),
    [anon_sym_u_SQUOTE] = ACTIONS(3643),
    [anon_sym_U_SQUOTE] = ACTIONS(3643),
    [anon_sym_u8_SQUOTE] = ACTIONS(3643),
    [anon_sym_SQUOTE] = ACTIONS(3643),
    [anon_sym_L_DQUOTE] = ACTIONS(3643),
    [anon_sym_u_DQUOTE] = ACTIONS(3643),
    [anon_sym_U_DQUOTE] = ACTIONS(3643),
    [anon_sym_u8_DQUOTE] = ACTIONS(3643),
    [anon_sym_DQUOTE] = ACTIONS(3643),
    [sym_true] = ACTIONS(3641),
    [sym_false] = ACTIONS(3641),
    [anon_sym_NULL] = ACTIONS(3641),
    [anon_sym_nullptr] = ACTIONS(3641),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3641),
    [anon_sym_let] = ACTIONS(3641),
    [anon_sym_This] = ACTIONS(3641),
    [anon_sym_decltype] = ACTIONS(3641),
    [anon_sym_explicit] = ACTIONS(3641),
    [anon_sym_typename] = ACTIONS(3641),
    [anon_sym_template] = ACTIONS(3641),
    [anon_sym_operator] = ACTIONS(3641),
    [anon_sym_try] = ACTIONS(3641),
    [anon_sym_delete] = ACTIONS(3641),
    [anon_sym_throw] = ACTIONS(3641),
    [anon_sym_namespace] = ACTIONS(3641),
    [anon_sym_static_assert] = ACTIONS(3641),
    [anon_sym_concept] = ACTIONS(3641),
    [anon_sym_co_return] = ACTIONS(3641),
    [anon_sym_co_yield] = ACTIONS(3641),
    [anon_sym_R_DQUOTE] = ACTIONS(3643),
    [anon_sym_LR_DQUOTE] = ACTIONS(3643),
    [anon_sym_uR_DQUOTE] = ACTIONS(3643),
    [anon_sym_UR_DQUOTE] = ACTIONS(3643),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3643),
    [anon_sym_co_await] = ACTIONS(3641),
    [anon_sym_new] = ACTIONS(3641),
    [anon_sym_requires] = ACTIONS(3641),
    [sym_this] = ACTIONS(3641),
    [anon_sym_discard] = ACTIONS(3641),
    [anon_sym_precise] = ACTIONS(3641),
    [anon_sym_shared] = ACTIONS(3641),
    [anon_sym_groupshared] = ACTIONS(3641),
    [anon_sym_uniform] = ACTIONS(3641),
    [anon_sym_row_major] = ACTIONS(3641),
    [anon_sym_column_major] = ACTIONS(3641),
    [anon_sym_globallycoherent] = ACTIONS(3641),
    [anon_sym_centroid] = ACTIONS(3641),
    [anon_sym_noperspective] = ACTIONS(3641),
    [anon_sym_nointerpolation] = ACTIONS(3641),
    [anon_sym_sample] = ACTIONS(3641),
    [anon_sym_linear] = ACTIONS(3641),
    [anon_sym_snorm] = ACTIONS(3641),
    [anon_sym_unorm] = ACTIONS(3641),
    [anon_sym_point] = ACTIONS(3641),
    [anon_sym_line] = ACTIONS(3641),
    [anon_sym_triangleadj] = ACTIONS(3641),
    [anon_sym_lineadj] = ACTIONS(3641),
    [anon_sym_triangle] = ACTIONS(3641),
    [anon_sym_cbuffer] = ACTIONS(3641),
    [anon_sym_interface] = ACTIONS(3641),
    [anon_sym_extension] = ACTIONS(3641),
  },
  [484] = {
    [ts_builtin_sym_end] = ACTIONS(3464),
    [sym_identifier] = ACTIONS(3462),
    [aux_sym_preproc_include_token1] = ACTIONS(3462),
    [aux_sym_preproc_def_token1] = ACTIONS(3462),
    [aux_sym_preproc_if_token1] = ACTIONS(3462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3462),
    [sym_preproc_directive] = ACTIONS(3462),
    [anon_sym_LPAREN2] = ACTIONS(3464),
    [anon_sym_BANG] = ACTIONS(3464),
    [anon_sym_TILDE] = ACTIONS(3464),
    [anon_sym_DASH] = ACTIONS(3462),
    [anon_sym_PLUS] = ACTIONS(3462),
    [anon_sym_STAR] = ACTIONS(3464),
    [anon_sym_AMP_AMP] = ACTIONS(3464),
    [anon_sym_AMP] = ACTIONS(3462),
    [anon_sym_SEMI] = ACTIONS(3464),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_typedef] = ACTIONS(3462),
    [anon_sym_in] = ACTIONS(3462),
    [anon_sym_out] = ACTIONS(3462),
    [anon_sym_inout] = ACTIONS(3462),
    [anon_sym_virtual] = ACTIONS(3462),
    [anon_sym_extern] = ACTIONS(3462),
    [anon_sym___attribute__] = ACTIONS(3462),
    [anon_sym___attribute] = ACTIONS(3462),
    [anon_sym_using] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3464),
    [anon_sym___declspec] = ACTIONS(3462),
    [anon_sym___based] = ACTIONS(3462),
    [anon_sym___cdecl] = ACTIONS(3462),
    [anon_sym___clrcall] = ACTIONS(3462),
    [anon_sym___stdcall] = ACTIONS(3462),
    [anon_sym___fastcall] = ACTIONS(3462),
    [anon_sym___thiscall] = ACTIONS(3462),
    [anon_sym___vectorcall] = ACTIONS(3462),
    [anon_sym_LBRACE] = ACTIONS(3464),
    [anon_sym_signed] = ACTIONS(3462),
    [anon_sym_unsigned] = ACTIONS(3462),
    [anon_sym_long] = ACTIONS(3462),
    [anon_sym_short] = ACTIONS(3462),
    [anon_sym_LBRACK] = ACTIONS(3462),
    [anon_sym_static] = ACTIONS(3462),
    [anon_sym_register] = ACTIONS(3462),
    [anon_sym_inline] = ACTIONS(3462),
    [anon_sym___inline] = ACTIONS(3462),
    [anon_sym___inline__] = ACTIONS(3462),
    [anon_sym___forceinline] = ACTIONS(3462),
    [anon_sym_thread_local] = ACTIONS(3462),
    [anon_sym___thread] = ACTIONS(3462),
    [anon_sym_const] = ACTIONS(3462),
    [anon_sym_constexpr] = ACTIONS(3462),
    [anon_sym_volatile] = ACTIONS(3462),
    [anon_sym_restrict] = ACTIONS(3462),
    [anon_sym___restrict__] = ACTIONS(3462),
    [anon_sym__Atomic] = ACTIONS(3462),
    [anon_sym__Noreturn] = ACTIONS(3462),
    [anon_sym_noreturn] = ACTIONS(3462),
    [anon_sym__Nonnull] = ACTIONS(3462),
    [anon_sym_mutable] = ACTIONS(3462),
    [anon_sym_constinit] = ACTIONS(3462),
    [anon_sym_consteval] = ACTIONS(3462),
    [anon_sym_alignas] = ACTIONS(3462),
    [anon_sym__Alignas] = ACTIONS(3462),
    [sym_primitive_type] = ACTIONS(3462),
    [anon_sym_enum] = ACTIONS(3462),
    [anon_sym_class] = ACTIONS(3462),
    [anon_sym_struct] = ACTIONS(3462),
    [anon_sym_union] = ACTIONS(3462),
    [anon_sym_if] = ACTIONS(3462),
    [anon_sym_else] = ACTIONS(3462),
    [anon_sym_switch] = ACTIONS(3462),
    [anon_sym_case] = ACTIONS(3462),
    [anon_sym_default] = ACTIONS(3462),
    [anon_sym_while] = ACTIONS(3462),
    [anon_sym_do] = ACTIONS(3462),
    [anon_sym_for] = ACTIONS(3462),
    [anon_sym_return] = ACTIONS(3462),
    [anon_sym_break] = ACTIONS(3462),
    [anon_sym_continue] = ACTIONS(3462),
    [anon_sym_goto] = ACTIONS(3462),
    [anon_sym___try] = ACTIONS(3462),
    [anon_sym___leave] = ACTIONS(3462),
    [anon_sym_not] = ACTIONS(3462),
    [anon_sym_compl] = ACTIONS(3462),
    [anon_sym_DASH_DASH] = ACTIONS(3464),
    [anon_sym_PLUS_PLUS] = ACTIONS(3464),
    [anon_sym_sizeof] = ACTIONS(3462),
    [anon_sym___alignof__] = ACTIONS(3462),
    [anon_sym___alignof] = ACTIONS(3462),
    [anon_sym__alignof] = ACTIONS(3462),
    [anon_sym_alignof] = ACTIONS(3462),
    [anon_sym__Alignof] = ACTIONS(3462),
    [anon_sym_offsetof] = ACTIONS(3462),
    [anon_sym__Generic] = ACTIONS(3462),
    [anon_sym_asm] = ACTIONS(3462),
    [anon_sym___asm__] = ACTIONS(3462),
    [anon_sym___asm] = ACTIONS(3462),
    [sym_number_literal] = ACTIONS(3464),
    [anon_sym_L_SQUOTE] = ACTIONS(3464),
    [anon_sym_u_SQUOTE] = ACTIONS(3464),
    [anon_sym_U_SQUOTE] = ACTIONS(3464),
    [anon_sym_u8_SQUOTE] = ACTIONS(3464),
    [anon_sym_SQUOTE] = ACTIONS(3464),
    [anon_sym_L_DQUOTE] = ACTIONS(3464),
    [anon_sym_u_DQUOTE] = ACTIONS(3464),
    [anon_sym_U_DQUOTE] = ACTIONS(3464),
    [anon_sym_u8_DQUOTE] = ACTIONS(3464),
    [anon_sym_DQUOTE] = ACTIONS(3464),
    [sym_true] = ACTIONS(3462),
    [sym_false] = ACTIONS(3462),
    [anon_sym_NULL] = ACTIONS(3462),
    [anon_sym_nullptr] = ACTIONS(3462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3462),
    [anon_sym_let] = ACTIONS(3462),
    [anon_sym_This] = ACTIONS(3462),
    [anon_sym_decltype] = ACTIONS(3462),
    [anon_sym_explicit] = ACTIONS(3462),
    [anon_sym_typename] = ACTIONS(3462),
    [anon_sym_export] = ACTIONS(3462),
    [anon_sym_module] = ACTIONS(3462),
    [anon_sym_import] = ACTIONS(3462),
    [anon_sym_template] = ACTIONS(3462),
    [anon_sym_operator] = ACTIONS(3462),
    [anon_sym_try] = ACTIONS(3462),
    [anon_sym_delete] = ACTIONS(3462),
    [anon_sym_throw] = ACTIONS(3462),
    [anon_sym_namespace] = ACTIONS(3462),
    [anon_sym_static_assert] = ACTIONS(3462),
    [anon_sym_concept] = ACTIONS(3462),
    [anon_sym_co_return] = ACTIONS(3462),
    [anon_sym_co_yield] = ACTIONS(3462),
    [anon_sym_R_DQUOTE] = ACTIONS(3464),
    [anon_sym_LR_DQUOTE] = ACTIONS(3464),
    [anon_sym_uR_DQUOTE] = ACTIONS(3464),
    [anon_sym_UR_DQUOTE] = ACTIONS(3464),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3464),
    [anon_sym_co_await] = ACTIONS(3462),
    [anon_sym_new] = ACTIONS(3462),
    [anon_sym_requires] = ACTIONS(3462),
    [sym_this] = ACTIONS(3462),
    [anon_sym_discard] = ACTIONS(3462),
    [anon_sym_precise] = ACTIONS(3462),
    [anon_sym_shared] = ACTIONS(3462),
    [anon_sym_groupshared] = ACTIONS(3462),
    [anon_sym_uniform] = ACTIONS(3462),
    [anon_sym_row_major] = ACTIONS(3462),
    [anon_sym_column_major] = ACTIONS(3462),
    [anon_sym_globallycoherent] = ACTIONS(3462),
    [anon_sym_centroid] = ACTIONS(3462),
    [anon_sym_noperspective] = ACTIONS(3462),
    [anon_sym_nointerpolation] = ACTIONS(3462),
    [anon_sym_sample] = ACTIONS(3462),
    [anon_sym_linear] = ACTIONS(3462),
    [anon_sym_snorm] = ACTIONS(3462),
    [anon_sym_unorm] = ACTIONS(3462),
    [anon_sym_point] = ACTIONS(3462),
    [anon_sym_line] = ACTIONS(3462),
    [anon_sym_triangleadj] = ACTIONS(3462),
    [anon_sym_lineadj] = ACTIONS(3462),
    [anon_sym_triangle] = ACTIONS(3462),
    [anon_sym_cbuffer] = ACTIONS(3462),
    [anon_sym_interface] = ACTIONS(3462),
    [anon_sym_extension] = ACTIONS(3462),
    [anon_sym___exported] = ACTIONS(3462),
  },
  [485] = {
    [ts_builtin_sym_end] = ACTIONS(3468),
    [sym_identifier] = ACTIONS(3466),
    [aux_sym_preproc_include_token1] = ACTIONS(3466),
    [aux_sym_preproc_def_token1] = ACTIONS(3466),
    [aux_sym_preproc_if_token1] = ACTIONS(3466),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3466),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3466),
    [sym_preproc_directive] = ACTIONS(3466),
    [anon_sym_LPAREN2] = ACTIONS(3468),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3466),
    [anon_sym_PLUS] = ACTIONS(3466),
    [anon_sym_STAR] = ACTIONS(3468),
    [anon_sym_AMP_AMP] = ACTIONS(3468),
    [anon_sym_AMP] = ACTIONS(3466),
    [anon_sym_SEMI] = ACTIONS(3468),
    [anon_sym___extension__] = ACTIONS(3466),
    [anon_sym_typedef] = ACTIONS(3466),
    [anon_sym_in] = ACTIONS(3466),
    [anon_sym_out] = ACTIONS(3466),
    [anon_sym_inout] = ACTIONS(3466),
    [anon_sym_virtual] = ACTIONS(3466),
    [anon_sym_extern] = ACTIONS(3466),
    [anon_sym___attribute__] = ACTIONS(3466),
    [anon_sym___attribute] = ACTIONS(3466),
    [anon_sym_using] = ACTIONS(3466),
    [anon_sym_COLON_COLON] = ACTIONS(3468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3468),
    [anon_sym___declspec] = ACTIONS(3466),
    [anon_sym___based] = ACTIONS(3466),
    [anon_sym___cdecl] = ACTIONS(3466),
    [anon_sym___clrcall] = ACTIONS(3466),
    [anon_sym___stdcall] = ACTIONS(3466),
    [anon_sym___fastcall] = ACTIONS(3466),
    [anon_sym___thiscall] = ACTIONS(3466),
    [anon_sym___vectorcall] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_signed] = ACTIONS(3466),
    [anon_sym_unsigned] = ACTIONS(3466),
    [anon_sym_long] = ACTIONS(3466),
    [anon_sym_short] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(3466),
    [anon_sym_static] = ACTIONS(3466),
    [anon_sym_register] = ACTIONS(3466),
    [anon_sym_inline] = ACTIONS(3466),
    [anon_sym___inline] = ACTIONS(3466),
    [anon_sym___inline__] = ACTIONS(3466),
    [anon_sym___forceinline] = ACTIONS(3466),
    [anon_sym_thread_local] = ACTIONS(3466),
    [anon_sym___thread] = ACTIONS(3466),
    [anon_sym_const] = ACTIONS(3466),
    [anon_sym_constexpr] = ACTIONS(3466),
    [anon_sym_volatile] = ACTIONS(3466),
    [anon_sym_restrict] = ACTIONS(3466),
    [anon_sym___restrict__] = ACTIONS(3466),
    [anon_sym__Atomic] = ACTIONS(3466),
    [anon_sym__Noreturn] = ACTIONS(3466),
    [anon_sym_noreturn] = ACTIONS(3466),
    [anon_sym__Nonnull] = ACTIONS(3466),
    [anon_sym_mutable] = ACTIONS(3466),
    [anon_sym_constinit] = ACTIONS(3466),
    [anon_sym_consteval] = ACTIONS(3466),
    [anon_sym_alignas] = ACTIONS(3466),
    [anon_sym__Alignas] = ACTIONS(3466),
    [sym_primitive_type] = ACTIONS(3466),
    [anon_sym_enum] = ACTIONS(3466),
    [anon_sym_class] = ACTIONS(3466),
    [anon_sym_struct] = ACTIONS(3466),
    [anon_sym_union] = ACTIONS(3466),
    [anon_sym_if] = ACTIONS(3466),
    [anon_sym_else] = ACTIONS(3466),
    [anon_sym_switch] = ACTIONS(3466),
    [anon_sym_case] = ACTIONS(3466),
    [anon_sym_default] = ACTIONS(3466),
    [anon_sym_while] = ACTIONS(3466),
    [anon_sym_do] = ACTIONS(3466),
    [anon_sym_for] = ACTIONS(3466),
    [anon_sym_return] = ACTIONS(3466),
    [anon_sym_break] = ACTIONS(3466),
    [anon_sym_continue] = ACTIONS(3466),
    [anon_sym_goto] = ACTIONS(3466),
    [anon_sym___try] = ACTIONS(3466),
    [anon_sym___leave] = ACTIONS(3466),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_compl] = ACTIONS(3466),
    [anon_sym_DASH_DASH] = ACTIONS(3468),
    [anon_sym_PLUS_PLUS] = ACTIONS(3468),
    [anon_sym_sizeof] = ACTIONS(3466),
    [anon_sym___alignof__] = ACTIONS(3466),
    [anon_sym___alignof] = ACTIONS(3466),
    [anon_sym__alignof] = ACTIONS(3466),
    [anon_sym_alignof] = ACTIONS(3466),
    [anon_sym__Alignof] = ACTIONS(3466),
    [anon_sym_offsetof] = ACTIONS(3466),
    [anon_sym__Generic] = ACTIONS(3466),
    [anon_sym_asm] = ACTIONS(3466),
    [anon_sym___asm__] = ACTIONS(3466),
    [anon_sym___asm] = ACTIONS(3466),
    [sym_number_literal] = ACTIONS(3468),
    [anon_sym_L_SQUOTE] = ACTIONS(3468),
    [anon_sym_u_SQUOTE] = ACTIONS(3468),
    [anon_sym_U_SQUOTE] = ACTIONS(3468),
    [anon_sym_u8_SQUOTE] = ACTIONS(3468),
    [anon_sym_SQUOTE] = ACTIONS(3468),
    [anon_sym_L_DQUOTE] = ACTIONS(3468),
    [anon_sym_u_DQUOTE] = ACTIONS(3468),
    [anon_sym_U_DQUOTE] = ACTIONS(3468),
    [anon_sym_u8_DQUOTE] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3468),
    [sym_true] = ACTIONS(3466),
    [sym_false] = ACTIONS(3466),
    [anon_sym_NULL] = ACTIONS(3466),
    [anon_sym_nullptr] = ACTIONS(3466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3466),
    [anon_sym_let] = ACTIONS(3466),
    [anon_sym_This] = ACTIONS(3466),
    [anon_sym_decltype] = ACTIONS(3466),
    [anon_sym_explicit] = ACTIONS(3466),
    [anon_sym_typename] = ACTIONS(3466),
    [anon_sym_export] = ACTIONS(3466),
    [anon_sym_module] = ACTIONS(3466),
    [anon_sym_import] = ACTIONS(3466),
    [anon_sym_template] = ACTIONS(3466),
    [anon_sym_operator] = ACTIONS(3466),
    [anon_sym_try] = ACTIONS(3466),
    [anon_sym_delete] = ACTIONS(3466),
    [anon_sym_throw] = ACTIONS(3466),
    [anon_sym_namespace] = ACTIONS(3466),
    [anon_sym_static_assert] = ACTIONS(3466),
    [anon_sym_concept] = ACTIONS(3466),
    [anon_sym_co_return] = ACTIONS(3466),
    [anon_sym_co_yield] = ACTIONS(3466),
    [anon_sym_R_DQUOTE] = ACTIONS(3468),
    [anon_sym_LR_DQUOTE] = ACTIONS(3468),
    [anon_sym_uR_DQUOTE] = ACTIONS(3468),
    [anon_sym_UR_DQUOTE] = ACTIONS(3468),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3468),
    [anon_sym_co_await] = ACTIONS(3466),
    [anon_sym_new] = ACTIONS(3466),
    [anon_sym_requires] = ACTIONS(3466),
    [sym_this] = ACTIONS(3466),
    [anon_sym_discard] = ACTIONS(3466),
    [anon_sym_precise] = ACTIONS(3466),
    [anon_sym_shared] = ACTIONS(3466),
    [anon_sym_groupshared] = ACTIONS(3466),
    [anon_sym_uniform] = ACTIONS(3466),
    [anon_sym_row_major] = ACTIONS(3466),
    [anon_sym_column_major] = ACTIONS(3466),
    [anon_sym_globallycoherent] = ACTIONS(3466),
    [anon_sym_centroid] = ACTIONS(3466),
    [anon_sym_noperspective] = ACTIONS(3466),
    [anon_sym_nointerpolation] = ACTIONS(3466),
    [anon_sym_sample] = ACTIONS(3466),
    [anon_sym_linear] = ACTIONS(3466),
    [anon_sym_snorm] = ACTIONS(3466),
    [anon_sym_unorm] = ACTIONS(3466),
    [anon_sym_point] = ACTIONS(3466),
    [anon_sym_line] = ACTIONS(3466),
    [anon_sym_triangleadj] = ACTIONS(3466),
    [anon_sym_lineadj] = ACTIONS(3466),
    [anon_sym_triangle] = ACTIONS(3466),
    [anon_sym_cbuffer] = ACTIONS(3466),
    [anon_sym_interface] = ACTIONS(3466),
    [anon_sym_extension] = ACTIONS(3466),
    [anon_sym___exported] = ACTIONS(3466),
  },
  [486] = {
    [sym_identifier] = ACTIONS(3645),
    [aux_sym_preproc_include_token1] = ACTIONS(3645),
    [aux_sym_preproc_def_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token2] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3645),
    [aux_sym_preproc_else_token1] = ACTIONS(3645),
    [aux_sym_preproc_elif_token1] = ACTIONS(3645),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3645),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3645),
    [sym_preproc_directive] = ACTIONS(3645),
    [anon_sym_LPAREN2] = ACTIONS(3647),
    [anon_sym_BANG] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3647),
    [anon_sym_DASH] = ACTIONS(3645),
    [anon_sym_PLUS] = ACTIONS(3645),
    [anon_sym_STAR] = ACTIONS(3647),
    [anon_sym_AMP_AMP] = ACTIONS(3647),
    [anon_sym_AMP] = ACTIONS(3645),
    [anon_sym_SEMI] = ACTIONS(3647),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3645),
    [anon_sym_in] = ACTIONS(3645),
    [anon_sym_out] = ACTIONS(3645),
    [anon_sym_inout] = ACTIONS(3645),
    [anon_sym_virtual] = ACTIONS(3645),
    [anon_sym_extern] = ACTIONS(3645),
    [anon_sym___attribute__] = ACTIONS(3645),
    [anon_sym___attribute] = ACTIONS(3645),
    [anon_sym_using] = ACTIONS(3645),
    [anon_sym_COLON_COLON] = ACTIONS(3647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3647),
    [anon_sym___declspec] = ACTIONS(3645),
    [anon_sym___based] = ACTIONS(3645),
    [anon_sym___cdecl] = ACTIONS(3645),
    [anon_sym___clrcall] = ACTIONS(3645),
    [anon_sym___stdcall] = ACTIONS(3645),
    [anon_sym___fastcall] = ACTIONS(3645),
    [anon_sym___thiscall] = ACTIONS(3645),
    [anon_sym___vectorcall] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(3647),
    [anon_sym_signed] = ACTIONS(3645),
    [anon_sym_unsigned] = ACTIONS(3645),
    [anon_sym_long] = ACTIONS(3645),
    [anon_sym_short] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_static] = ACTIONS(3645),
    [anon_sym_register] = ACTIONS(3645),
    [anon_sym_inline] = ACTIONS(3645),
    [anon_sym___inline] = ACTIONS(3645),
    [anon_sym___inline__] = ACTIONS(3645),
    [anon_sym___forceinline] = ACTIONS(3645),
    [anon_sym_thread_local] = ACTIONS(3645),
    [anon_sym___thread] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(3645),
    [anon_sym_constexpr] = ACTIONS(3645),
    [anon_sym_volatile] = ACTIONS(3645),
    [anon_sym_restrict] = ACTIONS(3645),
    [anon_sym___restrict__] = ACTIONS(3645),
    [anon_sym__Atomic] = ACTIONS(3645),
    [anon_sym__Noreturn] = ACTIONS(3645),
    [anon_sym_noreturn] = ACTIONS(3645),
    [anon_sym__Nonnull] = ACTIONS(3645),
    [anon_sym_mutable] = ACTIONS(3645),
    [anon_sym_constinit] = ACTIONS(3645),
    [anon_sym_consteval] = ACTIONS(3645),
    [anon_sym_alignas] = ACTIONS(3645),
    [anon_sym__Alignas] = ACTIONS(3645),
    [sym_primitive_type] = ACTIONS(3645),
    [anon_sym_enum] = ACTIONS(3645),
    [anon_sym_class] = ACTIONS(3645),
    [anon_sym_struct] = ACTIONS(3645),
    [anon_sym_union] = ACTIONS(3645),
    [anon_sym_if] = ACTIONS(3645),
    [anon_sym_else] = ACTIONS(3645),
    [anon_sym_switch] = ACTIONS(3645),
    [anon_sym_case] = ACTIONS(3645),
    [anon_sym_default] = ACTIONS(3645),
    [anon_sym_while] = ACTIONS(3645),
    [anon_sym_do] = ACTIONS(3645),
    [anon_sym_for] = ACTIONS(3645),
    [anon_sym_return] = ACTIONS(3645),
    [anon_sym_break] = ACTIONS(3645),
    [anon_sym_continue] = ACTIONS(3645),
    [anon_sym_goto] = ACTIONS(3645),
    [anon_sym___try] = ACTIONS(3645),
    [anon_sym___leave] = ACTIONS(3645),
    [anon_sym_not] = ACTIONS(3645),
    [anon_sym_compl] = ACTIONS(3645),
    [anon_sym_DASH_DASH] = ACTIONS(3647),
    [anon_sym_PLUS_PLUS] = ACTIONS(3647),
    [anon_sym_sizeof] = ACTIONS(3645),
    [anon_sym___alignof__] = ACTIONS(3645),
    [anon_sym___alignof] = ACTIONS(3645),
    [anon_sym__alignof] = ACTIONS(3645),
    [anon_sym_alignof] = ACTIONS(3645),
    [anon_sym__Alignof] = ACTIONS(3645),
    [anon_sym_offsetof] = ACTIONS(3645),
    [anon_sym__Generic] = ACTIONS(3645),
    [anon_sym_asm] = ACTIONS(3645),
    [anon_sym___asm__] = ACTIONS(3645),
    [anon_sym___asm] = ACTIONS(3645),
    [sym_number_literal] = ACTIONS(3647),
    [anon_sym_L_SQUOTE] = ACTIONS(3647),
    [anon_sym_u_SQUOTE] = ACTIONS(3647),
    [anon_sym_U_SQUOTE] = ACTIONS(3647),
    [anon_sym_u8_SQUOTE] = ACTIONS(3647),
    [anon_sym_SQUOTE] = ACTIONS(3647),
    [anon_sym_L_DQUOTE] = ACTIONS(3647),
    [anon_sym_u_DQUOTE] = ACTIONS(3647),
    [anon_sym_U_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8_DQUOTE] = ACTIONS(3647),
    [anon_sym_DQUOTE] = ACTIONS(3647),
    [sym_true] = ACTIONS(3645),
    [sym_false] = ACTIONS(3645),
    [anon_sym_NULL] = ACTIONS(3645),
    [anon_sym_nullptr] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3645),
    [anon_sym_let] = ACTIONS(3645),
    [anon_sym_This] = ACTIONS(3645),
    [anon_sym_decltype] = ACTIONS(3645),
    [anon_sym_explicit] = ACTIONS(3645),
    [anon_sym_typename] = ACTIONS(3645),
    [anon_sym_template] = ACTIONS(3645),
    [anon_sym_operator] = ACTIONS(3645),
    [anon_sym_try] = ACTIONS(3645),
    [anon_sym_delete] = ACTIONS(3645),
    [anon_sym_throw] = ACTIONS(3645),
    [anon_sym_namespace] = ACTIONS(3645),
    [anon_sym_static_assert] = ACTIONS(3645),
    [anon_sym_concept] = ACTIONS(3645),
    [anon_sym_co_return] = ACTIONS(3645),
    [anon_sym_co_yield] = ACTIONS(3645),
    [anon_sym_R_DQUOTE] = ACTIONS(3647),
    [anon_sym_LR_DQUOTE] = ACTIONS(3647),
    [anon_sym_uR_DQUOTE] = ACTIONS(3647),
    [anon_sym_UR_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3647),
    [anon_sym_co_await] = ACTIONS(3645),
    [anon_sym_new] = ACTIONS(3645),
    [anon_sym_requires] = ACTIONS(3645),
    [sym_this] = ACTIONS(3645),
    [anon_sym_discard] = ACTIONS(3645),
    [anon_sym_precise] = ACTIONS(3645),
    [anon_sym_shared] = ACTIONS(3645),
    [anon_sym_groupshared] = ACTIONS(3645),
    [anon_sym_uniform] = ACTIONS(3645),
    [anon_sym_row_major] = ACTIONS(3645),
    [anon_sym_column_major] = ACTIONS(3645),
    [anon_sym_globallycoherent] = ACTIONS(3645),
    [anon_sym_centroid] = ACTIONS(3645),
    [anon_sym_noperspective] = ACTIONS(3645),
    [anon_sym_nointerpolation] = ACTIONS(3645),
    [anon_sym_sample] = ACTIONS(3645),
    [anon_sym_linear] = ACTIONS(3645),
    [anon_sym_snorm] = ACTIONS(3645),
    [anon_sym_unorm] = ACTIONS(3645),
    [anon_sym_point] = ACTIONS(3645),
    [anon_sym_line] = ACTIONS(3645),
    [anon_sym_triangleadj] = ACTIONS(3645),
    [anon_sym_lineadj] = ACTIONS(3645),
    [anon_sym_triangle] = ACTIONS(3645),
    [anon_sym_cbuffer] = ACTIONS(3645),
    [anon_sym_interface] = ACTIONS(3645),
    [anon_sym_extension] = ACTIONS(3645),
  },
  [487] = {
    [ts_builtin_sym_end] = ACTIONS(3472),
    [sym_identifier] = ACTIONS(3470),
    [aux_sym_preproc_include_token1] = ACTIONS(3470),
    [aux_sym_preproc_def_token1] = ACTIONS(3470),
    [aux_sym_preproc_if_token1] = ACTIONS(3470),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3470),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3470),
    [sym_preproc_directive] = ACTIONS(3470),
    [anon_sym_LPAREN2] = ACTIONS(3472),
    [anon_sym_BANG] = ACTIONS(3472),
    [anon_sym_TILDE] = ACTIONS(3472),
    [anon_sym_DASH] = ACTIONS(3470),
    [anon_sym_PLUS] = ACTIONS(3470),
    [anon_sym_STAR] = ACTIONS(3472),
    [anon_sym_AMP_AMP] = ACTIONS(3472),
    [anon_sym_AMP] = ACTIONS(3470),
    [anon_sym_SEMI] = ACTIONS(3472),
    [anon_sym___extension__] = ACTIONS(3470),
    [anon_sym_typedef] = ACTIONS(3470),
    [anon_sym_in] = ACTIONS(3470),
    [anon_sym_out] = ACTIONS(3470),
    [anon_sym_inout] = ACTIONS(3470),
    [anon_sym_virtual] = ACTIONS(3470),
    [anon_sym_extern] = ACTIONS(3470),
    [anon_sym___attribute__] = ACTIONS(3470),
    [anon_sym___attribute] = ACTIONS(3470),
    [anon_sym_using] = ACTIONS(3470),
    [anon_sym_COLON_COLON] = ACTIONS(3472),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3472),
    [anon_sym___declspec] = ACTIONS(3470),
    [anon_sym___based] = ACTIONS(3470),
    [anon_sym___cdecl] = ACTIONS(3470),
    [anon_sym___clrcall] = ACTIONS(3470),
    [anon_sym___stdcall] = ACTIONS(3470),
    [anon_sym___fastcall] = ACTIONS(3470),
    [anon_sym___thiscall] = ACTIONS(3470),
    [anon_sym___vectorcall] = ACTIONS(3470),
    [anon_sym_LBRACE] = ACTIONS(3472),
    [anon_sym_signed] = ACTIONS(3470),
    [anon_sym_unsigned] = ACTIONS(3470),
    [anon_sym_long] = ACTIONS(3470),
    [anon_sym_short] = ACTIONS(3470),
    [anon_sym_LBRACK] = ACTIONS(3470),
    [anon_sym_static] = ACTIONS(3470),
    [anon_sym_register] = ACTIONS(3470),
    [anon_sym_inline] = ACTIONS(3470),
    [anon_sym___inline] = ACTIONS(3470),
    [anon_sym___inline__] = ACTIONS(3470),
    [anon_sym___forceinline] = ACTIONS(3470),
    [anon_sym_thread_local] = ACTIONS(3470),
    [anon_sym___thread] = ACTIONS(3470),
    [anon_sym_const] = ACTIONS(3470),
    [anon_sym_constexpr] = ACTIONS(3470),
    [anon_sym_volatile] = ACTIONS(3470),
    [anon_sym_restrict] = ACTIONS(3470),
    [anon_sym___restrict__] = ACTIONS(3470),
    [anon_sym__Atomic] = ACTIONS(3470),
    [anon_sym__Noreturn] = ACTIONS(3470),
    [anon_sym_noreturn] = ACTIONS(3470),
    [anon_sym__Nonnull] = ACTIONS(3470),
    [anon_sym_mutable] = ACTIONS(3470),
    [anon_sym_constinit] = ACTIONS(3470),
    [anon_sym_consteval] = ACTIONS(3470),
    [anon_sym_alignas] = ACTIONS(3470),
    [anon_sym__Alignas] = ACTIONS(3470),
    [sym_primitive_type] = ACTIONS(3470),
    [anon_sym_enum] = ACTIONS(3470),
    [anon_sym_class] = ACTIONS(3470),
    [anon_sym_struct] = ACTIONS(3470),
    [anon_sym_union] = ACTIONS(3470),
    [anon_sym_if] = ACTIONS(3470),
    [anon_sym_else] = ACTIONS(3470),
    [anon_sym_switch] = ACTIONS(3470),
    [anon_sym_case] = ACTIONS(3470),
    [anon_sym_default] = ACTIONS(3470),
    [anon_sym_while] = ACTIONS(3470),
    [anon_sym_do] = ACTIONS(3470),
    [anon_sym_for] = ACTIONS(3470),
    [anon_sym_return] = ACTIONS(3470),
    [anon_sym_break] = ACTIONS(3470),
    [anon_sym_continue] = ACTIONS(3470),
    [anon_sym_goto] = ACTIONS(3470),
    [anon_sym___try] = ACTIONS(3470),
    [anon_sym___leave] = ACTIONS(3470),
    [anon_sym_not] = ACTIONS(3470),
    [anon_sym_compl] = ACTIONS(3470),
    [anon_sym_DASH_DASH] = ACTIONS(3472),
    [anon_sym_PLUS_PLUS] = ACTIONS(3472),
    [anon_sym_sizeof] = ACTIONS(3470),
    [anon_sym___alignof__] = ACTIONS(3470),
    [anon_sym___alignof] = ACTIONS(3470),
    [anon_sym__alignof] = ACTIONS(3470),
    [anon_sym_alignof] = ACTIONS(3470),
    [anon_sym__Alignof] = ACTIONS(3470),
    [anon_sym_offsetof] = ACTIONS(3470),
    [anon_sym__Generic] = ACTIONS(3470),
    [anon_sym_asm] = ACTIONS(3470),
    [anon_sym___asm__] = ACTIONS(3470),
    [anon_sym___asm] = ACTIONS(3470),
    [sym_number_literal] = ACTIONS(3472),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3472),
    [anon_sym_u_DQUOTE] = ACTIONS(3472),
    [anon_sym_U_DQUOTE] = ACTIONS(3472),
    [anon_sym_u8_DQUOTE] = ACTIONS(3472),
    [anon_sym_DQUOTE] = ACTIONS(3472),
    [sym_true] = ACTIONS(3470),
    [sym_false] = ACTIONS(3470),
    [anon_sym_NULL] = ACTIONS(3470),
    [anon_sym_nullptr] = ACTIONS(3470),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3470),
    [anon_sym_let] = ACTIONS(3470),
    [anon_sym_This] = ACTIONS(3470),
    [anon_sym_decltype] = ACTIONS(3470),
    [anon_sym_explicit] = ACTIONS(3470),
    [anon_sym_typename] = ACTIONS(3470),
    [anon_sym_export] = ACTIONS(3470),
    [anon_sym_module] = ACTIONS(3470),
    [anon_sym_import] = ACTIONS(3470),
    [anon_sym_template] = ACTIONS(3470),
    [anon_sym_operator] = ACTIONS(3470),
    [anon_sym_try] = ACTIONS(3470),
    [anon_sym_delete] = ACTIONS(3470),
    [anon_sym_throw] = ACTIONS(3470),
    [anon_sym_namespace] = ACTIONS(3470),
    [anon_sym_static_assert] = ACTIONS(3470),
    [anon_sym_concept] = ACTIONS(3470),
    [anon_sym_co_return] = ACTIONS(3470),
    [anon_sym_co_yield] = ACTIONS(3470),
    [anon_sym_R_DQUOTE] = ACTIONS(3472),
    [anon_sym_LR_DQUOTE] = ACTIONS(3472),
    [anon_sym_uR_DQUOTE] = ACTIONS(3472),
    [anon_sym_UR_DQUOTE] = ACTIONS(3472),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3472),
    [anon_sym_co_await] = ACTIONS(3470),
    [anon_sym_new] = ACTIONS(3470),
    [anon_sym_requires] = ACTIONS(3470),
    [sym_this] = ACTIONS(3470),
    [anon_sym_discard] = ACTIONS(3470),
    [anon_sym_precise] = ACTIONS(3470),
    [anon_sym_shared] = ACTIONS(3470),
    [anon_sym_groupshared] = ACTIONS(3470),
    [anon_sym_uniform] = ACTIONS(3470),
    [anon_sym_row_major] = ACTIONS(3470),
    [anon_sym_column_major] = ACTIONS(3470),
    [anon_sym_globallycoherent] = ACTIONS(3470),
    [anon_sym_centroid] = ACTIONS(3470),
    [anon_sym_noperspective] = ACTIONS(3470),
    [anon_sym_nointerpolation] = ACTIONS(3470),
    [anon_sym_sample] = ACTIONS(3470),
    [anon_sym_linear] = ACTIONS(3470),
    [anon_sym_snorm] = ACTIONS(3470),
    [anon_sym_unorm] = ACTIONS(3470),
    [anon_sym_point] = ACTIONS(3470),
    [anon_sym_line] = ACTIONS(3470),
    [anon_sym_triangleadj] = ACTIONS(3470),
    [anon_sym_lineadj] = ACTIONS(3470),
    [anon_sym_triangle] = ACTIONS(3470),
    [anon_sym_cbuffer] = ACTIONS(3470),
    [anon_sym_interface] = ACTIONS(3470),
    [anon_sym_extension] = ACTIONS(3470),
    [anon_sym___exported] = ACTIONS(3470),
  },
  [488] = {
    [ts_builtin_sym_end] = ACTIONS(3476),
    [sym_identifier] = ACTIONS(3474),
    [aux_sym_preproc_include_token1] = ACTIONS(3474),
    [aux_sym_preproc_def_token1] = ACTIONS(3474),
    [aux_sym_preproc_if_token1] = ACTIONS(3474),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3474),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3474),
    [sym_preproc_directive] = ACTIONS(3474),
    [anon_sym_LPAREN2] = ACTIONS(3476),
    [anon_sym_BANG] = ACTIONS(3476),
    [anon_sym_TILDE] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3474),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_AMP_AMP] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3474),
    [anon_sym_SEMI] = ACTIONS(3476),
    [anon_sym___extension__] = ACTIONS(3474),
    [anon_sym_typedef] = ACTIONS(3474),
    [anon_sym_in] = ACTIONS(3474),
    [anon_sym_out] = ACTIONS(3474),
    [anon_sym_inout] = ACTIONS(3474),
    [anon_sym_virtual] = ACTIONS(3474),
    [anon_sym_extern] = ACTIONS(3474),
    [anon_sym___attribute__] = ACTIONS(3474),
    [anon_sym___attribute] = ACTIONS(3474),
    [anon_sym_using] = ACTIONS(3474),
    [anon_sym_COLON_COLON] = ACTIONS(3476),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3476),
    [anon_sym___declspec] = ACTIONS(3474),
    [anon_sym___based] = ACTIONS(3474),
    [anon_sym___cdecl] = ACTIONS(3474),
    [anon_sym___clrcall] = ACTIONS(3474),
    [anon_sym___stdcall] = ACTIONS(3474),
    [anon_sym___fastcall] = ACTIONS(3474),
    [anon_sym___thiscall] = ACTIONS(3474),
    [anon_sym___vectorcall] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_signed] = ACTIONS(3474),
    [anon_sym_unsigned] = ACTIONS(3474),
    [anon_sym_long] = ACTIONS(3474),
    [anon_sym_short] = ACTIONS(3474),
    [anon_sym_LBRACK] = ACTIONS(3474),
    [anon_sym_static] = ACTIONS(3474),
    [anon_sym_register] = ACTIONS(3474),
    [anon_sym_inline] = ACTIONS(3474),
    [anon_sym___inline] = ACTIONS(3474),
    [anon_sym___inline__] = ACTIONS(3474),
    [anon_sym___forceinline] = ACTIONS(3474),
    [anon_sym_thread_local] = ACTIONS(3474),
    [anon_sym___thread] = ACTIONS(3474),
    [anon_sym_const] = ACTIONS(3474),
    [anon_sym_constexpr] = ACTIONS(3474),
    [anon_sym_volatile] = ACTIONS(3474),
    [anon_sym_restrict] = ACTIONS(3474),
    [anon_sym___restrict__] = ACTIONS(3474),
    [anon_sym__Atomic] = ACTIONS(3474),
    [anon_sym__Noreturn] = ACTIONS(3474),
    [anon_sym_noreturn] = ACTIONS(3474),
    [anon_sym__Nonnull] = ACTIONS(3474),
    [anon_sym_mutable] = ACTIONS(3474),
    [anon_sym_constinit] = ACTIONS(3474),
    [anon_sym_consteval] = ACTIONS(3474),
    [anon_sym_alignas] = ACTIONS(3474),
    [anon_sym__Alignas] = ACTIONS(3474),
    [sym_primitive_type] = ACTIONS(3474),
    [anon_sym_enum] = ACTIONS(3474),
    [anon_sym_class] = ACTIONS(3474),
    [anon_sym_struct] = ACTIONS(3474),
    [anon_sym_union] = ACTIONS(3474),
    [anon_sym_if] = ACTIONS(3474),
    [anon_sym_else] = ACTIONS(3474),
    [anon_sym_switch] = ACTIONS(3474),
    [anon_sym_case] = ACTIONS(3474),
    [anon_sym_default] = ACTIONS(3474),
    [anon_sym_while] = ACTIONS(3474),
    [anon_sym_do] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3474),
    [anon_sym_return] = ACTIONS(3474),
    [anon_sym_break] = ACTIONS(3474),
    [anon_sym_continue] = ACTIONS(3474),
    [anon_sym_goto] = ACTIONS(3474),
    [anon_sym___try] = ACTIONS(3474),
    [anon_sym___leave] = ACTIONS(3474),
    [anon_sym_not] = ACTIONS(3474),
    [anon_sym_compl] = ACTIONS(3474),
    [anon_sym_DASH_DASH] = ACTIONS(3476),
    [anon_sym_PLUS_PLUS] = ACTIONS(3476),
    [anon_sym_sizeof] = ACTIONS(3474),
    [anon_sym___alignof__] = ACTIONS(3474),
    [anon_sym___alignof] = ACTIONS(3474),
    [anon_sym__alignof] = ACTIONS(3474),
    [anon_sym_alignof] = ACTIONS(3474),
    [anon_sym__Alignof] = ACTIONS(3474),
    [anon_sym_offsetof] = ACTIONS(3474),
    [anon_sym__Generic] = ACTIONS(3474),
    [anon_sym_asm] = ACTIONS(3474),
    [anon_sym___asm__] = ACTIONS(3474),
    [anon_sym___asm] = ACTIONS(3474),
    [sym_number_literal] = ACTIONS(3476),
    [anon_sym_L_SQUOTE] = ACTIONS(3476),
    [anon_sym_u_SQUOTE] = ACTIONS(3476),
    [anon_sym_U_SQUOTE] = ACTIONS(3476),
    [anon_sym_u8_SQUOTE] = ACTIONS(3476),
    [anon_sym_SQUOTE] = ACTIONS(3476),
    [anon_sym_L_DQUOTE] = ACTIONS(3476),
    [anon_sym_u_DQUOTE] = ACTIONS(3476),
    [anon_sym_U_DQUOTE] = ACTIONS(3476),
    [anon_sym_u8_DQUOTE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [sym_true] = ACTIONS(3474),
    [sym_false] = ACTIONS(3474),
    [anon_sym_NULL] = ACTIONS(3474),
    [anon_sym_nullptr] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3474),
    [anon_sym_let] = ACTIONS(3474),
    [anon_sym_This] = ACTIONS(3474),
    [anon_sym_decltype] = ACTIONS(3474),
    [anon_sym_explicit] = ACTIONS(3474),
    [anon_sym_typename] = ACTIONS(3474),
    [anon_sym_export] = ACTIONS(3474),
    [anon_sym_module] = ACTIONS(3474),
    [anon_sym_import] = ACTIONS(3474),
    [anon_sym_template] = ACTIONS(3474),
    [anon_sym_operator] = ACTIONS(3474),
    [anon_sym_try] = ACTIONS(3474),
    [anon_sym_delete] = ACTIONS(3474),
    [anon_sym_throw] = ACTIONS(3474),
    [anon_sym_namespace] = ACTIONS(3474),
    [anon_sym_static_assert] = ACTIONS(3474),
    [anon_sym_concept] = ACTIONS(3474),
    [anon_sym_co_return] = ACTIONS(3474),
    [anon_sym_co_yield] = ACTIONS(3474),
    [anon_sym_R_DQUOTE] = ACTIONS(3476),
    [anon_sym_LR_DQUOTE] = ACTIONS(3476),
    [anon_sym_uR_DQUOTE] = ACTIONS(3476),
    [anon_sym_UR_DQUOTE] = ACTIONS(3476),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3476),
    [anon_sym_co_await] = ACTIONS(3474),
    [anon_sym_new] = ACTIONS(3474),
    [anon_sym_requires] = ACTIONS(3474),
    [sym_this] = ACTIONS(3474),
    [anon_sym_discard] = ACTIONS(3474),
    [anon_sym_precise] = ACTIONS(3474),
    [anon_sym_shared] = ACTIONS(3474),
    [anon_sym_groupshared] = ACTIONS(3474),
    [anon_sym_uniform] = ACTIONS(3474),
    [anon_sym_row_major] = ACTIONS(3474),
    [anon_sym_column_major] = ACTIONS(3474),
    [anon_sym_globallycoherent] = ACTIONS(3474),
    [anon_sym_centroid] = ACTIONS(3474),
    [anon_sym_noperspective] = ACTIONS(3474),
    [anon_sym_nointerpolation] = ACTIONS(3474),
    [anon_sym_sample] = ACTIONS(3474),
    [anon_sym_linear] = ACTIONS(3474),
    [anon_sym_snorm] = ACTIONS(3474),
    [anon_sym_unorm] = ACTIONS(3474),
    [anon_sym_point] = ACTIONS(3474),
    [anon_sym_line] = ACTIONS(3474),
    [anon_sym_triangleadj] = ACTIONS(3474),
    [anon_sym_lineadj] = ACTIONS(3474),
    [anon_sym_triangle] = ACTIONS(3474),
    [anon_sym_cbuffer] = ACTIONS(3474),
    [anon_sym_interface] = ACTIONS(3474),
    [anon_sym_extension] = ACTIONS(3474),
    [anon_sym___exported] = ACTIONS(3474),
  },
  [489] = {
    [sym_identifier] = ACTIONS(3649),
    [aux_sym_preproc_include_token1] = ACTIONS(3649),
    [aux_sym_preproc_def_token1] = ACTIONS(3649),
    [aux_sym_preproc_if_token1] = ACTIONS(3649),
    [aux_sym_preproc_if_token2] = ACTIONS(3649),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3649),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3649),
    [aux_sym_preproc_else_token1] = ACTIONS(3649),
    [aux_sym_preproc_elif_token1] = ACTIONS(3649),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3649),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3649),
    [sym_preproc_directive] = ACTIONS(3649),
    [anon_sym_LPAREN2] = ACTIONS(3651),
    [anon_sym_BANG] = ACTIONS(3651),
    [anon_sym_TILDE] = ACTIONS(3651),
    [anon_sym_DASH] = ACTIONS(3649),
    [anon_sym_PLUS] = ACTIONS(3649),
    [anon_sym_STAR] = ACTIONS(3651),
    [anon_sym_AMP_AMP] = ACTIONS(3651),
    [anon_sym_AMP] = ACTIONS(3649),
    [anon_sym_SEMI] = ACTIONS(3651),
    [anon_sym___extension__] = ACTIONS(3649),
    [anon_sym_typedef] = ACTIONS(3649),
    [anon_sym_in] = ACTIONS(3649),
    [anon_sym_out] = ACTIONS(3649),
    [anon_sym_inout] = ACTIONS(3649),
    [anon_sym_virtual] = ACTIONS(3649),
    [anon_sym_extern] = ACTIONS(3649),
    [anon_sym___attribute__] = ACTIONS(3649),
    [anon_sym___attribute] = ACTIONS(3649),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(3651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3651),
    [anon_sym___declspec] = ACTIONS(3649),
    [anon_sym___based] = ACTIONS(3649),
    [anon_sym___cdecl] = ACTIONS(3649),
    [anon_sym___clrcall] = ACTIONS(3649),
    [anon_sym___stdcall] = ACTIONS(3649),
    [anon_sym___fastcall] = ACTIONS(3649),
    [anon_sym___thiscall] = ACTIONS(3649),
    [anon_sym___vectorcall] = ACTIONS(3649),
    [anon_sym_LBRACE] = ACTIONS(3651),
    [anon_sym_signed] = ACTIONS(3649),
    [anon_sym_unsigned] = ACTIONS(3649),
    [anon_sym_long] = ACTIONS(3649),
    [anon_sym_short] = ACTIONS(3649),
    [anon_sym_LBRACK] = ACTIONS(3649),
    [anon_sym_static] = ACTIONS(3649),
    [anon_sym_register] = ACTIONS(3649),
    [anon_sym_inline] = ACTIONS(3649),
    [anon_sym___inline] = ACTIONS(3649),
    [anon_sym___inline__] = ACTIONS(3649),
    [anon_sym___forceinline] = ACTIONS(3649),
    [anon_sym_thread_local] = ACTIONS(3649),
    [anon_sym___thread] = ACTIONS(3649),
    [anon_sym_const] = ACTIONS(3649),
    [anon_sym_constexpr] = ACTIONS(3649),
    [anon_sym_volatile] = ACTIONS(3649),
    [anon_sym_restrict] = ACTIONS(3649),
    [anon_sym___restrict__] = ACTIONS(3649),
    [anon_sym__Atomic] = ACTIONS(3649),
    [anon_sym__Noreturn] = ACTIONS(3649),
    [anon_sym_noreturn] = ACTIONS(3649),
    [anon_sym__Nonnull] = ACTIONS(3649),
    [anon_sym_mutable] = ACTIONS(3649),
    [anon_sym_constinit] = ACTIONS(3649),
    [anon_sym_consteval] = ACTIONS(3649),
    [anon_sym_alignas] = ACTIONS(3649),
    [anon_sym__Alignas] = ACTIONS(3649),
    [sym_primitive_type] = ACTIONS(3649),
    [anon_sym_enum] = ACTIONS(3649),
    [anon_sym_class] = ACTIONS(3649),
    [anon_sym_struct] = ACTIONS(3649),
    [anon_sym_union] = ACTIONS(3649),
    [anon_sym_if] = ACTIONS(3649),
    [anon_sym_else] = ACTIONS(3649),
    [anon_sym_switch] = ACTIONS(3649),
    [anon_sym_case] = ACTIONS(3649),
    [anon_sym_default] = ACTIONS(3649),
    [anon_sym_while] = ACTIONS(3649),
    [anon_sym_do] = ACTIONS(3649),
    [anon_sym_for] = ACTIONS(3649),
    [anon_sym_return] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3649),
    [anon_sym_continue] = ACTIONS(3649),
    [anon_sym_goto] = ACTIONS(3649),
    [anon_sym___try] = ACTIONS(3649),
    [anon_sym___leave] = ACTIONS(3649),
    [anon_sym_not] = ACTIONS(3649),
    [anon_sym_compl] = ACTIONS(3649),
    [anon_sym_DASH_DASH] = ACTIONS(3651),
    [anon_sym_PLUS_PLUS] = ACTIONS(3651),
    [anon_sym_sizeof] = ACTIONS(3649),
    [anon_sym___alignof__] = ACTIONS(3649),
    [anon_sym___alignof] = ACTIONS(3649),
    [anon_sym__alignof] = ACTIONS(3649),
    [anon_sym_alignof] = ACTIONS(3649),
    [anon_sym__Alignof] = ACTIONS(3649),
    [anon_sym_offsetof] = ACTIONS(3649),
    [anon_sym__Generic] = ACTIONS(3649),
    [anon_sym_asm] = ACTIONS(3649),
    [anon_sym___asm__] = ACTIONS(3649),
    [anon_sym___asm] = ACTIONS(3649),
    [sym_number_literal] = ACTIONS(3651),
    [anon_sym_L_SQUOTE] = ACTIONS(3651),
    [anon_sym_u_SQUOTE] = ACTIONS(3651),
    [anon_sym_U_SQUOTE] = ACTIONS(3651),
    [anon_sym_u8_SQUOTE] = ACTIONS(3651),
    [anon_sym_SQUOTE] = ACTIONS(3651),
    [anon_sym_L_DQUOTE] = ACTIONS(3651),
    [anon_sym_u_DQUOTE] = ACTIONS(3651),
    [anon_sym_U_DQUOTE] = ACTIONS(3651),
    [anon_sym_u8_DQUOTE] = ACTIONS(3651),
    [anon_sym_DQUOTE] = ACTIONS(3651),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [anon_sym_NULL] = ACTIONS(3649),
    [anon_sym_nullptr] = ACTIONS(3649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3649),
    [anon_sym_let] = ACTIONS(3649),
    [anon_sym_This] = ACTIONS(3649),
    [anon_sym_decltype] = ACTIONS(3649),
    [anon_sym_explicit] = ACTIONS(3649),
    [anon_sym_typename] = ACTIONS(3649),
    [anon_sym_template] = ACTIONS(3649),
    [anon_sym_operator] = ACTIONS(3649),
    [anon_sym_try] = ACTIONS(3649),
    [anon_sym_delete] = ACTIONS(3649),
    [anon_sym_throw] = ACTIONS(3649),
    [anon_sym_namespace] = ACTIONS(3649),
    [anon_sym_static_assert] = ACTIONS(3649),
    [anon_sym_concept] = ACTIONS(3649),
    [anon_sym_co_return] = ACTIONS(3649),
    [anon_sym_co_yield] = ACTIONS(3649),
    [anon_sym_R_DQUOTE] = ACTIONS(3651),
    [anon_sym_LR_DQUOTE] = ACTIONS(3651),
    [anon_sym_uR_DQUOTE] = ACTIONS(3651),
    [anon_sym_UR_DQUOTE] = ACTIONS(3651),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3651),
    [anon_sym_co_await] = ACTIONS(3649),
    [anon_sym_new] = ACTIONS(3649),
    [anon_sym_requires] = ACTIONS(3649),
    [sym_this] = ACTIONS(3649),
    [anon_sym_discard] = ACTIONS(3649),
    [anon_sym_precise] = ACTIONS(3649),
    [anon_sym_shared] = ACTIONS(3649),
    [anon_sym_groupshared] = ACTIONS(3649),
    [anon_sym_uniform] = ACTIONS(3649),
    [anon_sym_row_major] = ACTIONS(3649),
    [anon_sym_column_major] = ACTIONS(3649),
    [anon_sym_globallycoherent] = ACTIONS(3649),
    [anon_sym_centroid] = ACTIONS(3649),
    [anon_sym_noperspective] = ACTIONS(3649),
    [anon_sym_nointerpolation] = ACTIONS(3649),
    [anon_sym_sample] = ACTIONS(3649),
    [anon_sym_linear] = ACTIONS(3649),
    [anon_sym_snorm] = ACTIONS(3649),
    [anon_sym_unorm] = ACTIONS(3649),
    [anon_sym_point] = ACTIONS(3649),
    [anon_sym_line] = ACTIONS(3649),
    [anon_sym_triangleadj] = ACTIONS(3649),
    [anon_sym_lineadj] = ACTIONS(3649),
    [anon_sym_triangle] = ACTIONS(3649),
    [anon_sym_cbuffer] = ACTIONS(3649),
    [anon_sym_interface] = ACTIONS(3649),
    [anon_sym_extension] = ACTIONS(3649),
  },
  [490] = {
    [ts_builtin_sym_end] = ACTIONS(3492),
    [sym_identifier] = ACTIONS(3490),
    [aux_sym_preproc_include_token1] = ACTIONS(3490),
    [aux_sym_preproc_def_token1] = ACTIONS(3490),
    [aux_sym_preproc_if_token1] = ACTIONS(3490),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3490),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3490),
    [sym_preproc_directive] = ACTIONS(3490),
    [anon_sym_LPAREN2] = ACTIONS(3492),
    [anon_sym_BANG] = ACTIONS(3492),
    [anon_sym_TILDE] = ACTIONS(3492),
    [anon_sym_DASH] = ACTIONS(3490),
    [anon_sym_PLUS] = ACTIONS(3490),
    [anon_sym_STAR] = ACTIONS(3492),
    [anon_sym_AMP_AMP] = ACTIONS(3492),
    [anon_sym_AMP] = ACTIONS(3490),
    [anon_sym_SEMI] = ACTIONS(3492),
    [anon_sym___extension__] = ACTIONS(3490),
    [anon_sym_typedef] = ACTIONS(3490),
    [anon_sym_in] = ACTIONS(3490),
    [anon_sym_out] = ACTIONS(3490),
    [anon_sym_inout] = ACTIONS(3490),
    [anon_sym_virtual] = ACTIONS(3490),
    [anon_sym_extern] = ACTIONS(3490),
    [anon_sym___attribute__] = ACTIONS(3490),
    [anon_sym___attribute] = ACTIONS(3490),
    [anon_sym_using] = ACTIONS(3490),
    [anon_sym_COLON_COLON] = ACTIONS(3492),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3492),
    [anon_sym___declspec] = ACTIONS(3490),
    [anon_sym___based] = ACTIONS(3490),
    [anon_sym___cdecl] = ACTIONS(3490),
    [anon_sym___clrcall] = ACTIONS(3490),
    [anon_sym___stdcall] = ACTIONS(3490),
    [anon_sym___fastcall] = ACTIONS(3490),
    [anon_sym___thiscall] = ACTIONS(3490),
    [anon_sym___vectorcall] = ACTIONS(3490),
    [anon_sym_LBRACE] = ACTIONS(3492),
    [anon_sym_signed] = ACTIONS(3490),
    [anon_sym_unsigned] = ACTIONS(3490),
    [anon_sym_long] = ACTIONS(3490),
    [anon_sym_short] = ACTIONS(3490),
    [anon_sym_LBRACK] = ACTIONS(3490),
    [anon_sym_static] = ACTIONS(3490),
    [anon_sym_register] = ACTIONS(3490),
    [anon_sym_inline] = ACTIONS(3490),
    [anon_sym___inline] = ACTIONS(3490),
    [anon_sym___inline__] = ACTIONS(3490),
    [anon_sym___forceinline] = ACTIONS(3490),
    [anon_sym_thread_local] = ACTIONS(3490),
    [anon_sym___thread] = ACTIONS(3490),
    [anon_sym_const] = ACTIONS(3490),
    [anon_sym_constexpr] = ACTIONS(3490),
    [anon_sym_volatile] = ACTIONS(3490),
    [anon_sym_restrict] = ACTIONS(3490),
    [anon_sym___restrict__] = ACTIONS(3490),
    [anon_sym__Atomic] = ACTIONS(3490),
    [anon_sym__Noreturn] = ACTIONS(3490),
    [anon_sym_noreturn] = ACTIONS(3490),
    [anon_sym__Nonnull] = ACTIONS(3490),
    [anon_sym_mutable] = ACTIONS(3490),
    [anon_sym_constinit] = ACTIONS(3490),
    [anon_sym_consteval] = ACTIONS(3490),
    [anon_sym_alignas] = ACTIONS(3490),
    [anon_sym__Alignas] = ACTIONS(3490),
    [sym_primitive_type] = ACTIONS(3490),
    [anon_sym_enum] = ACTIONS(3490),
    [anon_sym_class] = ACTIONS(3490),
    [anon_sym_struct] = ACTIONS(3490),
    [anon_sym_union] = ACTIONS(3490),
    [anon_sym_if] = ACTIONS(3490),
    [anon_sym_else] = ACTIONS(3490),
    [anon_sym_switch] = ACTIONS(3490),
    [anon_sym_case] = ACTIONS(3490),
    [anon_sym_default] = ACTIONS(3490),
    [anon_sym_while] = ACTIONS(3490),
    [anon_sym_do] = ACTIONS(3490),
    [anon_sym_for] = ACTIONS(3490),
    [anon_sym_return] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3490),
    [anon_sym_continue] = ACTIONS(3490),
    [anon_sym_goto] = ACTIONS(3490),
    [anon_sym___try] = ACTIONS(3490),
    [anon_sym___leave] = ACTIONS(3490),
    [anon_sym_not] = ACTIONS(3490),
    [anon_sym_compl] = ACTIONS(3490),
    [anon_sym_DASH_DASH] = ACTIONS(3492),
    [anon_sym_PLUS_PLUS] = ACTIONS(3492),
    [anon_sym_sizeof] = ACTIONS(3490),
    [anon_sym___alignof__] = ACTIONS(3490),
    [anon_sym___alignof] = ACTIONS(3490),
    [anon_sym__alignof] = ACTIONS(3490),
    [anon_sym_alignof] = ACTIONS(3490),
    [anon_sym__Alignof] = ACTIONS(3490),
    [anon_sym_offsetof] = ACTIONS(3490),
    [anon_sym__Generic] = ACTIONS(3490),
    [anon_sym_asm] = ACTIONS(3490),
    [anon_sym___asm__] = ACTIONS(3490),
    [anon_sym___asm] = ACTIONS(3490),
    [sym_number_literal] = ACTIONS(3492),
    [anon_sym_L_SQUOTE] = ACTIONS(3492),
    [anon_sym_u_SQUOTE] = ACTIONS(3492),
    [anon_sym_U_SQUOTE] = ACTIONS(3492),
    [anon_sym_u8_SQUOTE] = ACTIONS(3492),
    [anon_sym_SQUOTE] = ACTIONS(3492),
    [anon_sym_L_DQUOTE] = ACTIONS(3492),
    [anon_sym_u_DQUOTE] = ACTIONS(3492),
    [anon_sym_U_DQUOTE] = ACTIONS(3492),
    [anon_sym_u8_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE] = ACTIONS(3492),
    [sym_true] = ACTIONS(3490),
    [sym_false] = ACTIONS(3490),
    [anon_sym_NULL] = ACTIONS(3490),
    [anon_sym_nullptr] = ACTIONS(3490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3490),
    [anon_sym_let] = ACTIONS(3490),
    [anon_sym_This] = ACTIONS(3490),
    [anon_sym_decltype] = ACTIONS(3490),
    [anon_sym_explicit] = ACTIONS(3490),
    [anon_sym_typename] = ACTIONS(3490),
    [anon_sym_export] = ACTIONS(3490),
    [anon_sym_module] = ACTIONS(3490),
    [anon_sym_import] = ACTIONS(3490),
    [anon_sym_template] = ACTIONS(3490),
    [anon_sym_operator] = ACTIONS(3490),
    [anon_sym_try] = ACTIONS(3490),
    [anon_sym_delete] = ACTIONS(3490),
    [anon_sym_throw] = ACTIONS(3490),
    [anon_sym_namespace] = ACTIONS(3490),
    [anon_sym_static_assert] = ACTIONS(3490),
    [anon_sym_concept] = ACTIONS(3490),
    [anon_sym_co_return] = ACTIONS(3490),
    [anon_sym_co_yield] = ACTIONS(3490),
    [anon_sym_R_DQUOTE] = ACTIONS(3492),
    [anon_sym_LR_DQUOTE] = ACTIONS(3492),
    [anon_sym_uR_DQUOTE] = ACTIONS(3492),
    [anon_sym_UR_DQUOTE] = ACTIONS(3492),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3492),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3490),
    [anon_sym_requires] = ACTIONS(3490),
    [sym_this] = ACTIONS(3490),
    [anon_sym_discard] = ACTIONS(3490),
    [anon_sym_precise] = ACTIONS(3490),
    [anon_sym_shared] = ACTIONS(3490),
    [anon_sym_groupshared] = ACTIONS(3490),
    [anon_sym_uniform] = ACTIONS(3490),
    [anon_sym_row_major] = ACTIONS(3490),
    [anon_sym_column_major] = ACTIONS(3490),
    [anon_sym_globallycoherent] = ACTIONS(3490),
    [anon_sym_centroid] = ACTIONS(3490),
    [anon_sym_noperspective] = ACTIONS(3490),
    [anon_sym_nointerpolation] = ACTIONS(3490),
    [anon_sym_sample] = ACTIONS(3490),
    [anon_sym_linear] = ACTIONS(3490),
    [anon_sym_snorm] = ACTIONS(3490),
    [anon_sym_unorm] = ACTIONS(3490),
    [anon_sym_point] = ACTIONS(3490),
    [anon_sym_line] = ACTIONS(3490),
    [anon_sym_triangleadj] = ACTIONS(3490),
    [anon_sym_lineadj] = ACTIONS(3490),
    [anon_sym_triangle] = ACTIONS(3490),
    [anon_sym_cbuffer] = ACTIONS(3490),
    [anon_sym_interface] = ACTIONS(3490),
    [anon_sym_extension] = ACTIONS(3490),
    [anon_sym___exported] = ACTIONS(3490),
  },
  [491] = {
    [sym_identifier] = ACTIONS(3603),
    [aux_sym_preproc_include_token1] = ACTIONS(3603),
    [aux_sym_preproc_def_token1] = ACTIONS(3603),
    [aux_sym_preproc_if_token1] = ACTIONS(3603),
    [aux_sym_preproc_if_token2] = ACTIONS(3603),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3603),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3603),
    [aux_sym_preproc_else_token1] = ACTIONS(3603),
    [aux_sym_preproc_elif_token1] = ACTIONS(3603),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3603),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3603),
    [sym_preproc_directive] = ACTIONS(3603),
    [anon_sym_LPAREN2] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3601),
    [anon_sym_TILDE] = ACTIONS(3601),
    [anon_sym_DASH] = ACTIONS(3603),
    [anon_sym_PLUS] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(3601),
    [anon_sym_AMP_AMP] = ACTIONS(3601),
    [anon_sym_AMP] = ACTIONS(3603),
    [anon_sym_SEMI] = ACTIONS(3601),
    [anon_sym___extension__] = ACTIONS(3603),
    [anon_sym_typedef] = ACTIONS(3603),
    [anon_sym_in] = ACTIONS(3603),
    [anon_sym_out] = ACTIONS(3603),
    [anon_sym_inout] = ACTIONS(3603),
    [anon_sym_virtual] = ACTIONS(3603),
    [anon_sym_extern] = ACTIONS(3603),
    [anon_sym___attribute__] = ACTIONS(3603),
    [anon_sym___attribute] = ACTIONS(3603),
    [anon_sym_using] = ACTIONS(3603),
    [anon_sym_COLON_COLON] = ACTIONS(3601),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3601),
    [anon_sym___declspec] = ACTIONS(3603),
    [anon_sym___based] = ACTIONS(3603),
    [anon_sym___cdecl] = ACTIONS(3603),
    [anon_sym___clrcall] = ACTIONS(3603),
    [anon_sym___stdcall] = ACTIONS(3603),
    [anon_sym___fastcall] = ACTIONS(3603),
    [anon_sym___thiscall] = ACTIONS(3603),
    [anon_sym___vectorcall] = ACTIONS(3603),
    [anon_sym_LBRACE] = ACTIONS(3601),
    [anon_sym_signed] = ACTIONS(3603),
    [anon_sym_unsigned] = ACTIONS(3603),
    [anon_sym_long] = ACTIONS(3603),
    [anon_sym_short] = ACTIONS(3603),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_static] = ACTIONS(3603),
    [anon_sym_register] = ACTIONS(3603),
    [anon_sym_inline] = ACTIONS(3603),
    [anon_sym___inline] = ACTIONS(3603),
    [anon_sym___inline__] = ACTIONS(3603),
    [anon_sym___forceinline] = ACTIONS(3603),
    [anon_sym_thread_local] = ACTIONS(3603),
    [anon_sym___thread] = ACTIONS(3603),
    [anon_sym_const] = ACTIONS(3603),
    [anon_sym_constexpr] = ACTIONS(3603),
    [anon_sym_volatile] = ACTIONS(3603),
    [anon_sym_restrict] = ACTIONS(3603),
    [anon_sym___restrict__] = ACTIONS(3603),
    [anon_sym__Atomic] = ACTIONS(3603),
    [anon_sym__Noreturn] = ACTIONS(3603),
    [anon_sym_noreturn] = ACTIONS(3603),
    [anon_sym__Nonnull] = ACTIONS(3603),
    [anon_sym_mutable] = ACTIONS(3603),
    [anon_sym_constinit] = ACTIONS(3603),
    [anon_sym_consteval] = ACTIONS(3603),
    [anon_sym_alignas] = ACTIONS(3603),
    [anon_sym__Alignas] = ACTIONS(3603),
    [sym_primitive_type] = ACTIONS(3603),
    [anon_sym_enum] = ACTIONS(3603),
    [anon_sym_class] = ACTIONS(3603),
    [anon_sym_struct] = ACTIONS(3603),
    [anon_sym_union] = ACTIONS(3603),
    [anon_sym_if] = ACTIONS(3603),
    [anon_sym_else] = ACTIONS(3603),
    [anon_sym_switch] = ACTIONS(3603),
    [anon_sym_case] = ACTIONS(3603),
    [anon_sym_default] = ACTIONS(3603),
    [anon_sym_while] = ACTIONS(3603),
    [anon_sym_do] = ACTIONS(3603),
    [anon_sym_for] = ACTIONS(3603),
    [anon_sym_return] = ACTIONS(3603),
    [anon_sym_break] = ACTIONS(3603),
    [anon_sym_continue] = ACTIONS(3603),
    [anon_sym_goto] = ACTIONS(3603),
    [anon_sym___try] = ACTIONS(3603),
    [anon_sym___leave] = ACTIONS(3603),
    [anon_sym_not] = ACTIONS(3603),
    [anon_sym_compl] = ACTIONS(3603),
    [anon_sym_DASH_DASH] = ACTIONS(3601),
    [anon_sym_PLUS_PLUS] = ACTIONS(3601),
    [anon_sym_sizeof] = ACTIONS(3603),
    [anon_sym___alignof__] = ACTIONS(3603),
    [anon_sym___alignof] = ACTIONS(3603),
    [anon_sym__alignof] = ACTIONS(3603),
    [anon_sym_alignof] = ACTIONS(3603),
    [anon_sym__Alignof] = ACTIONS(3603),
    [anon_sym_offsetof] = ACTIONS(3603),
    [anon_sym__Generic] = ACTIONS(3603),
    [anon_sym_asm] = ACTIONS(3603),
    [anon_sym___asm__] = ACTIONS(3603),
    [anon_sym___asm] = ACTIONS(3603),
    [sym_number_literal] = ACTIONS(3601),
    [anon_sym_L_SQUOTE] = ACTIONS(3601),
    [anon_sym_u_SQUOTE] = ACTIONS(3601),
    [anon_sym_U_SQUOTE] = ACTIONS(3601),
    [anon_sym_u8_SQUOTE] = ACTIONS(3601),
    [anon_sym_SQUOTE] = ACTIONS(3601),
    [anon_sym_L_DQUOTE] = ACTIONS(3601),
    [anon_sym_u_DQUOTE] = ACTIONS(3601),
    [anon_sym_U_DQUOTE] = ACTIONS(3601),
    [anon_sym_u8_DQUOTE] = ACTIONS(3601),
    [anon_sym_DQUOTE] = ACTIONS(3601),
    [sym_true] = ACTIONS(3603),
    [sym_false] = ACTIONS(3603),
    [anon_sym_NULL] = ACTIONS(3603),
    [anon_sym_nullptr] = ACTIONS(3603),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3603),
    [anon_sym_let] = ACTIONS(3603),
    [anon_sym_This] = ACTIONS(3603),
    [anon_sym_decltype] = ACTIONS(3603),
    [anon_sym_explicit] = ACTIONS(3603),
    [anon_sym_typename] = ACTIONS(3603),
    [anon_sym_template] = ACTIONS(3603),
    [anon_sym_operator] = ACTIONS(3603),
    [anon_sym_try] = ACTIONS(3603),
    [anon_sym_delete] = ACTIONS(3603),
    [anon_sym_throw] = ACTIONS(3603),
    [anon_sym_namespace] = ACTIONS(3603),
    [anon_sym_static_assert] = ACTIONS(3603),
    [anon_sym_concept] = ACTIONS(3603),
    [anon_sym_co_return] = ACTIONS(3603),
    [anon_sym_co_yield] = ACTIONS(3603),
    [anon_sym_R_DQUOTE] = ACTIONS(3601),
    [anon_sym_LR_DQUOTE] = ACTIONS(3601),
    [anon_sym_uR_DQUOTE] = ACTIONS(3601),
    [anon_sym_UR_DQUOTE] = ACTIONS(3601),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3601),
    [anon_sym_co_await] = ACTIONS(3603),
    [anon_sym_new] = ACTIONS(3603),
    [anon_sym_requires] = ACTIONS(3603),
    [sym_this] = ACTIONS(3603),
    [anon_sym_discard] = ACTIONS(3603),
    [anon_sym_precise] = ACTIONS(3603),
    [anon_sym_shared] = ACTIONS(3603),
    [anon_sym_groupshared] = ACTIONS(3603),
    [anon_sym_uniform] = ACTIONS(3603),
    [anon_sym_row_major] = ACTIONS(3603),
    [anon_sym_column_major] = ACTIONS(3603),
    [anon_sym_globallycoherent] = ACTIONS(3603),
    [anon_sym_centroid] = ACTIONS(3603),
    [anon_sym_noperspective] = ACTIONS(3603),
    [anon_sym_nointerpolation] = ACTIONS(3603),
    [anon_sym_sample] = ACTIONS(3603),
    [anon_sym_linear] = ACTIONS(3603),
    [anon_sym_snorm] = ACTIONS(3603),
    [anon_sym_unorm] = ACTIONS(3603),
    [anon_sym_point] = ACTIONS(3603),
    [anon_sym_line] = ACTIONS(3603),
    [anon_sym_triangleadj] = ACTIONS(3603),
    [anon_sym_lineadj] = ACTIONS(3603),
    [anon_sym_triangle] = ACTIONS(3603),
    [anon_sym_cbuffer] = ACTIONS(3603),
    [anon_sym_interface] = ACTIONS(3603),
    [anon_sym_extension] = ACTIONS(3603),
  },
  [492] = {
    [sym_identifier] = ACTIONS(3607),
    [aux_sym_preproc_include_token1] = ACTIONS(3607),
    [aux_sym_preproc_def_token1] = ACTIONS(3607),
    [aux_sym_preproc_if_token1] = ACTIONS(3607),
    [aux_sym_preproc_if_token2] = ACTIONS(3607),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3607),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3607),
    [aux_sym_preproc_else_token1] = ACTIONS(3607),
    [aux_sym_preproc_elif_token1] = ACTIONS(3607),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3607),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3607),
    [sym_preproc_directive] = ACTIONS(3607),
    [anon_sym_LPAREN2] = ACTIONS(3605),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(3605),
    [anon_sym_AMP_AMP] = ACTIONS(3605),
    [anon_sym_AMP] = ACTIONS(3607),
    [anon_sym_SEMI] = ACTIONS(3605),
    [anon_sym___extension__] = ACTIONS(3607),
    [anon_sym_typedef] = ACTIONS(3607),
    [anon_sym_in] = ACTIONS(3607),
    [anon_sym_out] = ACTIONS(3607),
    [anon_sym_inout] = ACTIONS(3607),
    [anon_sym_virtual] = ACTIONS(3607),
    [anon_sym_extern] = ACTIONS(3607),
    [anon_sym___attribute__] = ACTIONS(3607),
    [anon_sym___attribute] = ACTIONS(3607),
    [anon_sym_using] = ACTIONS(3607),
    [anon_sym_COLON_COLON] = ACTIONS(3605),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3605),
    [anon_sym___declspec] = ACTIONS(3607),
    [anon_sym___based] = ACTIONS(3607),
    [anon_sym___cdecl] = ACTIONS(3607),
    [anon_sym___clrcall] = ACTIONS(3607),
    [anon_sym___stdcall] = ACTIONS(3607),
    [anon_sym___fastcall] = ACTIONS(3607),
    [anon_sym___thiscall] = ACTIONS(3607),
    [anon_sym___vectorcall] = ACTIONS(3607),
    [anon_sym_LBRACE] = ACTIONS(3605),
    [anon_sym_signed] = ACTIONS(3607),
    [anon_sym_unsigned] = ACTIONS(3607),
    [anon_sym_long] = ACTIONS(3607),
    [anon_sym_short] = ACTIONS(3607),
    [anon_sym_LBRACK] = ACTIONS(3607),
    [anon_sym_static] = ACTIONS(3607),
    [anon_sym_register] = ACTIONS(3607),
    [anon_sym_inline] = ACTIONS(3607),
    [anon_sym___inline] = ACTIONS(3607),
    [anon_sym___inline__] = ACTIONS(3607),
    [anon_sym___forceinline] = ACTIONS(3607),
    [anon_sym_thread_local] = ACTIONS(3607),
    [anon_sym___thread] = ACTIONS(3607),
    [anon_sym_const] = ACTIONS(3607),
    [anon_sym_constexpr] = ACTIONS(3607),
    [anon_sym_volatile] = ACTIONS(3607),
    [anon_sym_restrict] = ACTIONS(3607),
    [anon_sym___restrict__] = ACTIONS(3607),
    [anon_sym__Atomic] = ACTIONS(3607),
    [anon_sym__Noreturn] = ACTIONS(3607),
    [anon_sym_noreturn] = ACTIONS(3607),
    [anon_sym__Nonnull] = ACTIONS(3607),
    [anon_sym_mutable] = ACTIONS(3607),
    [anon_sym_constinit] = ACTIONS(3607),
    [anon_sym_consteval] = ACTIONS(3607),
    [anon_sym_alignas] = ACTIONS(3607),
    [anon_sym__Alignas] = ACTIONS(3607),
    [sym_primitive_type] = ACTIONS(3607),
    [anon_sym_enum] = ACTIONS(3607),
    [anon_sym_class] = ACTIONS(3607),
    [anon_sym_struct] = ACTIONS(3607),
    [anon_sym_union] = ACTIONS(3607),
    [anon_sym_if] = ACTIONS(3607),
    [anon_sym_else] = ACTIONS(3607),
    [anon_sym_switch] = ACTIONS(3607),
    [anon_sym_case] = ACTIONS(3607),
    [anon_sym_default] = ACTIONS(3607),
    [anon_sym_while] = ACTIONS(3607),
    [anon_sym_do] = ACTIONS(3607),
    [anon_sym_for] = ACTIONS(3607),
    [anon_sym_return] = ACTIONS(3607),
    [anon_sym_break] = ACTIONS(3607),
    [anon_sym_continue] = ACTIONS(3607),
    [anon_sym_goto] = ACTIONS(3607),
    [anon_sym___try] = ACTIONS(3607),
    [anon_sym___leave] = ACTIONS(3607),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(3605),
    [anon_sym_PLUS_PLUS] = ACTIONS(3605),
    [anon_sym_sizeof] = ACTIONS(3607),
    [anon_sym___alignof__] = ACTIONS(3607),
    [anon_sym___alignof] = ACTIONS(3607),
    [anon_sym__alignof] = ACTIONS(3607),
    [anon_sym_alignof] = ACTIONS(3607),
    [anon_sym__Alignof] = ACTIONS(3607),
    [anon_sym_offsetof] = ACTIONS(3607),
    [anon_sym__Generic] = ACTIONS(3607),
    [anon_sym_asm] = ACTIONS(3607),
    [anon_sym___asm__] = ACTIONS(3607),
    [anon_sym___asm] = ACTIONS(3607),
    [sym_number_literal] = ACTIONS(3605),
    [anon_sym_L_SQUOTE] = ACTIONS(3605),
    [anon_sym_u_SQUOTE] = ACTIONS(3605),
    [anon_sym_U_SQUOTE] = ACTIONS(3605),
    [anon_sym_u8_SQUOTE] = ACTIONS(3605),
    [anon_sym_SQUOTE] = ACTIONS(3605),
    [anon_sym_L_DQUOTE] = ACTIONS(3605),
    [anon_sym_u_DQUOTE] = ACTIONS(3605),
    [anon_sym_U_DQUOTE] = ACTIONS(3605),
    [anon_sym_u8_DQUOTE] = ACTIONS(3605),
    [anon_sym_DQUOTE] = ACTIONS(3605),
    [sym_true] = ACTIONS(3607),
    [sym_false] = ACTIONS(3607),
    [anon_sym_NULL] = ACTIONS(3607),
    [anon_sym_nullptr] = ACTIONS(3607),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3607),
    [anon_sym_let] = ACTIONS(3607),
    [anon_sym_This] = ACTIONS(3607),
    [anon_sym_decltype] = ACTIONS(3607),
    [anon_sym_explicit] = ACTIONS(3607),
    [anon_sym_typename] = ACTIONS(3607),
    [anon_sym_template] = ACTIONS(3607),
    [anon_sym_operator] = ACTIONS(3607),
    [anon_sym_try] = ACTIONS(3607),
    [anon_sym_delete] = ACTIONS(3607),
    [anon_sym_throw] = ACTIONS(3607),
    [anon_sym_namespace] = ACTIONS(3607),
    [anon_sym_static_assert] = ACTIONS(3607),
    [anon_sym_concept] = ACTIONS(3607),
    [anon_sym_co_return] = ACTIONS(3607),
    [anon_sym_co_yield] = ACTIONS(3607),
    [anon_sym_R_DQUOTE] = ACTIONS(3605),
    [anon_sym_LR_DQUOTE] = ACTIONS(3605),
    [anon_sym_uR_DQUOTE] = ACTIONS(3605),
    [anon_sym_UR_DQUOTE] = ACTIONS(3605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3605),
    [anon_sym_co_await] = ACTIONS(3607),
    [anon_sym_new] = ACTIONS(3607),
    [anon_sym_requires] = ACTIONS(3607),
    [sym_this] = ACTIONS(3607),
    [anon_sym_discard] = ACTIONS(3607),
    [anon_sym_precise] = ACTIONS(3607),
    [anon_sym_shared] = ACTIONS(3607),
    [anon_sym_groupshared] = ACTIONS(3607),
    [anon_sym_uniform] = ACTIONS(3607),
    [anon_sym_row_major] = ACTIONS(3607),
    [anon_sym_column_major] = ACTIONS(3607),
    [anon_sym_globallycoherent] = ACTIONS(3607),
    [anon_sym_centroid] = ACTIONS(3607),
    [anon_sym_noperspective] = ACTIONS(3607),
    [anon_sym_nointerpolation] = ACTIONS(3607),
    [anon_sym_sample] = ACTIONS(3607),
    [anon_sym_linear] = ACTIONS(3607),
    [anon_sym_snorm] = ACTIONS(3607),
    [anon_sym_unorm] = ACTIONS(3607),
    [anon_sym_point] = ACTIONS(3607),
    [anon_sym_line] = ACTIONS(3607),
    [anon_sym_triangleadj] = ACTIONS(3607),
    [anon_sym_lineadj] = ACTIONS(3607),
    [anon_sym_triangle] = ACTIONS(3607),
    [anon_sym_cbuffer] = ACTIONS(3607),
    [anon_sym_interface] = ACTIONS(3607),
    [anon_sym_extension] = ACTIONS(3607),
  },
  [493] = {
    [ts_builtin_sym_end] = ACTIONS(3496),
    [sym_identifier] = ACTIONS(3494),
    [aux_sym_preproc_include_token1] = ACTIONS(3494),
    [aux_sym_preproc_def_token1] = ACTIONS(3494),
    [aux_sym_preproc_if_token1] = ACTIONS(3494),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3494),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3494),
    [sym_preproc_directive] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(3496),
    [anon_sym_BANG] = ACTIONS(3496),
    [anon_sym_TILDE] = ACTIONS(3496),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3496),
    [anon_sym_AMP_AMP] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_SEMI] = ACTIONS(3496),
    [anon_sym___extension__] = ACTIONS(3494),
    [anon_sym_typedef] = ACTIONS(3494),
    [anon_sym_in] = ACTIONS(3494),
    [anon_sym_out] = ACTIONS(3494),
    [anon_sym_inout] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym___attribute__] = ACTIONS(3494),
    [anon_sym___attribute] = ACTIONS(3494),
    [anon_sym_using] = ACTIONS(3494),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3496),
    [anon_sym___declspec] = ACTIONS(3494),
    [anon_sym___based] = ACTIONS(3494),
    [anon_sym___cdecl] = ACTIONS(3494),
    [anon_sym___clrcall] = ACTIONS(3494),
    [anon_sym___stdcall] = ACTIONS(3494),
    [anon_sym___fastcall] = ACTIONS(3494),
    [anon_sym___thiscall] = ACTIONS(3494),
    [anon_sym___vectorcall] = ACTIONS(3494),
    [anon_sym_LBRACE] = ACTIONS(3496),
    [anon_sym_signed] = ACTIONS(3494),
    [anon_sym_unsigned] = ACTIONS(3494),
    [anon_sym_long] = ACTIONS(3494),
    [anon_sym_short] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_register] = ACTIONS(3494),
    [anon_sym_inline] = ACTIONS(3494),
    [anon_sym___inline] = ACTIONS(3494),
    [anon_sym___inline__] = ACTIONS(3494),
    [anon_sym___forceinline] = ACTIONS(3494),
    [anon_sym_thread_local] = ACTIONS(3494),
    [anon_sym___thread] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_constexpr] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_restrict] = ACTIONS(3494),
    [anon_sym___restrict__] = ACTIONS(3494),
    [anon_sym__Atomic] = ACTIONS(3494),
    [anon_sym__Noreturn] = ACTIONS(3494),
    [anon_sym_noreturn] = ACTIONS(3494),
    [anon_sym__Nonnull] = ACTIONS(3494),
    [anon_sym_mutable] = ACTIONS(3494),
    [anon_sym_constinit] = ACTIONS(3494),
    [anon_sym_consteval] = ACTIONS(3494),
    [anon_sym_alignas] = ACTIONS(3494),
    [anon_sym__Alignas] = ACTIONS(3494),
    [sym_primitive_type] = ACTIONS(3494),
    [anon_sym_enum] = ACTIONS(3494),
    [anon_sym_class] = ACTIONS(3494),
    [anon_sym_struct] = ACTIONS(3494),
    [anon_sym_union] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_else] = ACTIONS(3494),
    [anon_sym_switch] = ACTIONS(3494),
    [anon_sym_case] = ACTIONS(3494),
    [anon_sym_default] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_break] = ACTIONS(3494),
    [anon_sym_continue] = ACTIONS(3494),
    [anon_sym_goto] = ACTIONS(3494),
    [anon_sym___try] = ACTIONS(3494),
    [anon_sym___leave] = ACTIONS(3494),
    [anon_sym_not] = ACTIONS(3494),
    [anon_sym_compl] = ACTIONS(3494),
    [anon_sym_DASH_DASH] = ACTIONS(3496),
    [anon_sym_PLUS_PLUS] = ACTIONS(3496),
    [anon_sym_sizeof] = ACTIONS(3494),
    [anon_sym___alignof__] = ACTIONS(3494),
    [anon_sym___alignof] = ACTIONS(3494),
    [anon_sym__alignof] = ACTIONS(3494),
    [anon_sym_alignof] = ACTIONS(3494),
    [anon_sym__Alignof] = ACTIONS(3494),
    [anon_sym_offsetof] = ACTIONS(3494),
    [anon_sym__Generic] = ACTIONS(3494),
    [anon_sym_asm] = ACTIONS(3494),
    [anon_sym___asm__] = ACTIONS(3494),
    [anon_sym___asm] = ACTIONS(3494),
    [sym_number_literal] = ACTIONS(3496),
    [anon_sym_L_SQUOTE] = ACTIONS(3496),
    [anon_sym_u_SQUOTE] = ACTIONS(3496),
    [anon_sym_U_SQUOTE] = ACTIONS(3496),
    [anon_sym_u8_SQUOTE] = ACTIONS(3496),
    [anon_sym_SQUOTE] = ACTIONS(3496),
    [anon_sym_L_DQUOTE] = ACTIONS(3496),
    [anon_sym_u_DQUOTE] = ACTIONS(3496),
    [anon_sym_U_DQUOTE] = ACTIONS(3496),
    [anon_sym_u8_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE] = ACTIONS(3496),
    [sym_true] = ACTIONS(3494),
    [sym_false] = ACTIONS(3494),
    [anon_sym_NULL] = ACTIONS(3494),
    [anon_sym_nullptr] = ACTIONS(3494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_This] = ACTIONS(3494),
    [anon_sym_decltype] = ACTIONS(3494),
    [anon_sym_explicit] = ACTIONS(3494),
    [anon_sym_typename] = ACTIONS(3494),
    [anon_sym_export] = ACTIONS(3494),
    [anon_sym_module] = ACTIONS(3494),
    [anon_sym_import] = ACTIONS(3494),
    [anon_sym_template] = ACTIONS(3494),
    [anon_sym_operator] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_delete] = ACTIONS(3494),
    [anon_sym_throw] = ACTIONS(3494),
    [anon_sym_namespace] = ACTIONS(3494),
    [anon_sym_static_assert] = ACTIONS(3494),
    [anon_sym_concept] = ACTIONS(3494),
    [anon_sym_co_return] = ACTIONS(3494),
    [anon_sym_co_yield] = ACTIONS(3494),
    [anon_sym_R_DQUOTE] = ACTIONS(3496),
    [anon_sym_LR_DQUOTE] = ACTIONS(3496),
    [anon_sym_uR_DQUOTE] = ACTIONS(3496),
    [anon_sym_UR_DQUOTE] = ACTIONS(3496),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3496),
    [anon_sym_co_await] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_requires] = ACTIONS(3494),
    [sym_this] = ACTIONS(3494),
    [anon_sym_discard] = ACTIONS(3494),
    [anon_sym_precise] = ACTIONS(3494),
    [anon_sym_shared] = ACTIONS(3494),
    [anon_sym_groupshared] = ACTIONS(3494),
    [anon_sym_uniform] = ACTIONS(3494),
    [anon_sym_row_major] = ACTIONS(3494),
    [anon_sym_column_major] = ACTIONS(3494),
    [anon_sym_globallycoherent] = ACTIONS(3494),
    [anon_sym_centroid] = ACTIONS(3494),
    [anon_sym_noperspective] = ACTIONS(3494),
    [anon_sym_nointerpolation] = ACTIONS(3494),
    [anon_sym_sample] = ACTIONS(3494),
    [anon_sym_linear] = ACTIONS(3494),
    [anon_sym_snorm] = ACTIONS(3494),
    [anon_sym_unorm] = ACTIONS(3494),
    [anon_sym_point] = ACTIONS(3494),
    [anon_sym_line] = ACTIONS(3494),
    [anon_sym_triangleadj] = ACTIONS(3494),
    [anon_sym_lineadj] = ACTIONS(3494),
    [anon_sym_triangle] = ACTIONS(3494),
    [anon_sym_cbuffer] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_extension] = ACTIONS(3494),
    [anon_sym___exported] = ACTIONS(3494),
  },
  [494] = {
    [sym_identifier] = ACTIONS(3611),
    [aux_sym_preproc_include_token1] = ACTIONS(3611),
    [aux_sym_preproc_def_token1] = ACTIONS(3611),
    [aux_sym_preproc_if_token1] = ACTIONS(3611),
    [aux_sym_preproc_if_token2] = ACTIONS(3611),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3611),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3611),
    [aux_sym_preproc_else_token1] = ACTIONS(3611),
    [aux_sym_preproc_elif_token1] = ACTIONS(3611),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3611),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3611),
    [sym_preproc_directive] = ACTIONS(3611),
    [anon_sym_LPAREN2] = ACTIONS(3609),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3611),
    [anon_sym_PLUS] = ACTIONS(3611),
    [anon_sym_STAR] = ACTIONS(3609),
    [anon_sym_AMP_AMP] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(3611),
    [anon_sym_SEMI] = ACTIONS(3609),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_typedef] = ACTIONS(3611),
    [anon_sym_in] = ACTIONS(3611),
    [anon_sym_out] = ACTIONS(3611),
    [anon_sym_inout] = ACTIONS(3611),
    [anon_sym_virtual] = ACTIONS(3611),
    [anon_sym_extern] = ACTIONS(3611),
    [anon_sym___attribute__] = ACTIONS(3611),
    [anon_sym___attribute] = ACTIONS(3611),
    [anon_sym_using] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3609),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3609),
    [anon_sym___declspec] = ACTIONS(3611),
    [anon_sym___based] = ACTIONS(3611),
    [anon_sym___cdecl] = ACTIONS(3611),
    [anon_sym___clrcall] = ACTIONS(3611),
    [anon_sym___stdcall] = ACTIONS(3611),
    [anon_sym___fastcall] = ACTIONS(3611),
    [anon_sym___thiscall] = ACTIONS(3611),
    [anon_sym___vectorcall] = ACTIONS(3611),
    [anon_sym_LBRACE] = ACTIONS(3609),
    [anon_sym_signed] = ACTIONS(3611),
    [anon_sym_unsigned] = ACTIONS(3611),
    [anon_sym_long] = ACTIONS(3611),
    [anon_sym_short] = ACTIONS(3611),
    [anon_sym_LBRACK] = ACTIONS(3611),
    [anon_sym_static] = ACTIONS(3611),
    [anon_sym_register] = ACTIONS(3611),
    [anon_sym_inline] = ACTIONS(3611),
    [anon_sym___inline] = ACTIONS(3611),
    [anon_sym___inline__] = ACTIONS(3611),
    [anon_sym___forceinline] = ACTIONS(3611),
    [anon_sym_thread_local] = ACTIONS(3611),
    [anon_sym___thread] = ACTIONS(3611),
    [anon_sym_const] = ACTIONS(3611),
    [anon_sym_constexpr] = ACTIONS(3611),
    [anon_sym_volatile] = ACTIONS(3611),
    [anon_sym_restrict] = ACTIONS(3611),
    [anon_sym___restrict__] = ACTIONS(3611),
    [anon_sym__Atomic] = ACTIONS(3611),
    [anon_sym__Noreturn] = ACTIONS(3611),
    [anon_sym_noreturn] = ACTIONS(3611),
    [anon_sym__Nonnull] = ACTIONS(3611),
    [anon_sym_mutable] = ACTIONS(3611),
    [anon_sym_constinit] = ACTIONS(3611),
    [anon_sym_consteval] = ACTIONS(3611),
    [anon_sym_alignas] = ACTIONS(3611),
    [anon_sym__Alignas] = ACTIONS(3611),
    [sym_primitive_type] = ACTIONS(3611),
    [anon_sym_enum] = ACTIONS(3611),
    [anon_sym_class] = ACTIONS(3611),
    [anon_sym_struct] = ACTIONS(3611),
    [anon_sym_union] = ACTIONS(3611),
    [anon_sym_if] = ACTIONS(3611),
    [anon_sym_else] = ACTIONS(3611),
    [anon_sym_switch] = ACTIONS(3611),
    [anon_sym_case] = ACTIONS(3611),
    [anon_sym_default] = ACTIONS(3611),
    [anon_sym_while] = ACTIONS(3611),
    [anon_sym_do] = ACTIONS(3611),
    [anon_sym_for] = ACTIONS(3611),
    [anon_sym_return] = ACTIONS(3611),
    [anon_sym_break] = ACTIONS(3611),
    [anon_sym_continue] = ACTIONS(3611),
    [anon_sym_goto] = ACTIONS(3611),
    [anon_sym___try] = ACTIONS(3611),
    [anon_sym___leave] = ACTIONS(3611),
    [anon_sym_not] = ACTIONS(3611),
    [anon_sym_compl] = ACTIONS(3611),
    [anon_sym_DASH_DASH] = ACTIONS(3609),
    [anon_sym_PLUS_PLUS] = ACTIONS(3609),
    [anon_sym_sizeof] = ACTIONS(3611),
    [anon_sym___alignof__] = ACTIONS(3611),
    [anon_sym___alignof] = ACTIONS(3611),
    [anon_sym__alignof] = ACTIONS(3611),
    [anon_sym_alignof] = ACTIONS(3611),
    [anon_sym__Alignof] = ACTIONS(3611),
    [anon_sym_offsetof] = ACTIONS(3611),
    [anon_sym__Generic] = ACTIONS(3611),
    [anon_sym_asm] = ACTIONS(3611),
    [anon_sym___asm__] = ACTIONS(3611),
    [anon_sym___asm] = ACTIONS(3611),
    [sym_number_literal] = ACTIONS(3609),
    [anon_sym_L_SQUOTE] = ACTIONS(3609),
    [anon_sym_u_SQUOTE] = ACTIONS(3609),
    [anon_sym_U_SQUOTE] = ACTIONS(3609),
    [anon_sym_u8_SQUOTE] = ACTIONS(3609),
    [anon_sym_SQUOTE] = ACTIONS(3609),
    [anon_sym_L_DQUOTE] = ACTIONS(3609),
    [anon_sym_u_DQUOTE] = ACTIONS(3609),
    [anon_sym_U_DQUOTE] = ACTIONS(3609),
    [anon_sym_u8_DQUOTE] = ACTIONS(3609),
    [anon_sym_DQUOTE] = ACTIONS(3609),
    [sym_true] = ACTIONS(3611),
    [sym_false] = ACTIONS(3611),
    [anon_sym_NULL] = ACTIONS(3611),
    [anon_sym_nullptr] = ACTIONS(3611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3611),
    [anon_sym_let] = ACTIONS(3611),
    [anon_sym_This] = ACTIONS(3611),
    [anon_sym_decltype] = ACTIONS(3611),
    [anon_sym_explicit] = ACTIONS(3611),
    [anon_sym_typename] = ACTIONS(3611),
    [anon_sym_template] = ACTIONS(3611),
    [anon_sym_operator] = ACTIONS(3611),
    [anon_sym_try] = ACTIONS(3611),
    [anon_sym_delete] = ACTIONS(3611),
    [anon_sym_throw] = ACTIONS(3611),
    [anon_sym_namespace] = ACTIONS(3611),
    [anon_sym_static_assert] = ACTIONS(3611),
    [anon_sym_concept] = ACTIONS(3611),
    [anon_sym_co_return] = ACTIONS(3611),
    [anon_sym_co_yield] = ACTIONS(3611),
    [anon_sym_R_DQUOTE] = ACTIONS(3609),
    [anon_sym_LR_DQUOTE] = ACTIONS(3609),
    [anon_sym_uR_DQUOTE] = ACTIONS(3609),
    [anon_sym_UR_DQUOTE] = ACTIONS(3609),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3609),
    [anon_sym_co_await] = ACTIONS(3611),
    [anon_sym_new] = ACTIONS(3611),
    [anon_sym_requires] = ACTIONS(3611),
    [sym_this] = ACTIONS(3611),
    [anon_sym_discard] = ACTIONS(3611),
    [anon_sym_precise] = ACTIONS(3611),
    [anon_sym_shared] = ACTIONS(3611),
    [anon_sym_groupshared] = ACTIONS(3611),
    [anon_sym_uniform] = ACTIONS(3611),
    [anon_sym_row_major] = ACTIONS(3611),
    [anon_sym_column_major] = ACTIONS(3611),
    [anon_sym_globallycoherent] = ACTIONS(3611),
    [anon_sym_centroid] = ACTIONS(3611),
    [anon_sym_noperspective] = ACTIONS(3611),
    [anon_sym_nointerpolation] = ACTIONS(3611),
    [anon_sym_sample] = ACTIONS(3611),
    [anon_sym_linear] = ACTIONS(3611),
    [anon_sym_snorm] = ACTIONS(3611),
    [anon_sym_unorm] = ACTIONS(3611),
    [anon_sym_point] = ACTIONS(3611),
    [anon_sym_line] = ACTIONS(3611),
    [anon_sym_triangleadj] = ACTIONS(3611),
    [anon_sym_lineadj] = ACTIONS(3611),
    [anon_sym_triangle] = ACTIONS(3611),
    [anon_sym_cbuffer] = ACTIONS(3611),
    [anon_sym_interface] = ACTIONS(3611),
    [anon_sym_extension] = ACTIONS(3611),
  },
  [495] = {
    [sym_identifier] = ACTIONS(3615),
    [aux_sym_preproc_include_token1] = ACTIONS(3615),
    [aux_sym_preproc_def_token1] = ACTIONS(3615),
    [aux_sym_preproc_if_token1] = ACTIONS(3615),
    [aux_sym_preproc_if_token2] = ACTIONS(3615),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3615),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3615),
    [aux_sym_preproc_else_token1] = ACTIONS(3615),
    [aux_sym_preproc_elif_token1] = ACTIONS(3615),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3615),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3615),
    [sym_preproc_directive] = ACTIONS(3615),
    [anon_sym_LPAREN2] = ACTIONS(3613),
    [anon_sym_BANG] = ACTIONS(3613),
    [anon_sym_TILDE] = ACTIONS(3613),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3613),
    [anon_sym_AMP_AMP] = ACTIONS(3613),
    [anon_sym_AMP] = ACTIONS(3615),
    [anon_sym_SEMI] = ACTIONS(3613),
    [anon_sym___extension__] = ACTIONS(3615),
    [anon_sym_typedef] = ACTIONS(3615),
    [anon_sym_in] = ACTIONS(3615),
    [anon_sym_out] = ACTIONS(3615),
    [anon_sym_inout] = ACTIONS(3615),
    [anon_sym_virtual] = ACTIONS(3615),
    [anon_sym_extern] = ACTIONS(3615),
    [anon_sym___attribute__] = ACTIONS(3615),
    [anon_sym___attribute] = ACTIONS(3615),
    [anon_sym_using] = ACTIONS(3615),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3613),
    [anon_sym___declspec] = ACTIONS(3615),
    [anon_sym___based] = ACTIONS(3615),
    [anon_sym___cdecl] = ACTIONS(3615),
    [anon_sym___clrcall] = ACTIONS(3615),
    [anon_sym___stdcall] = ACTIONS(3615),
    [anon_sym___fastcall] = ACTIONS(3615),
    [anon_sym___thiscall] = ACTIONS(3615),
    [anon_sym___vectorcall] = ACTIONS(3615),
    [anon_sym_LBRACE] = ACTIONS(3613),
    [anon_sym_signed] = ACTIONS(3615),
    [anon_sym_unsigned] = ACTIONS(3615),
    [anon_sym_long] = ACTIONS(3615),
    [anon_sym_short] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(3615),
    [anon_sym_static] = ACTIONS(3615),
    [anon_sym_register] = ACTIONS(3615),
    [anon_sym_inline] = ACTIONS(3615),
    [anon_sym___inline] = ACTIONS(3615),
    [anon_sym___inline__] = ACTIONS(3615),
    [anon_sym___forceinline] = ACTIONS(3615),
    [anon_sym_thread_local] = ACTIONS(3615),
    [anon_sym___thread] = ACTIONS(3615),
    [anon_sym_const] = ACTIONS(3615),
    [anon_sym_constexpr] = ACTIONS(3615),
    [anon_sym_volatile] = ACTIONS(3615),
    [anon_sym_restrict] = ACTIONS(3615),
    [anon_sym___restrict__] = ACTIONS(3615),
    [anon_sym__Atomic] = ACTIONS(3615),
    [anon_sym__Noreturn] = ACTIONS(3615),
    [anon_sym_noreturn] = ACTIONS(3615),
    [anon_sym__Nonnull] = ACTIONS(3615),
    [anon_sym_mutable] = ACTIONS(3615),
    [anon_sym_constinit] = ACTIONS(3615),
    [anon_sym_consteval] = ACTIONS(3615),
    [anon_sym_alignas] = ACTIONS(3615),
    [anon_sym__Alignas] = ACTIONS(3615),
    [sym_primitive_type] = ACTIONS(3615),
    [anon_sym_enum] = ACTIONS(3615),
    [anon_sym_class] = ACTIONS(3615),
    [anon_sym_struct] = ACTIONS(3615),
    [anon_sym_union] = ACTIONS(3615),
    [anon_sym_if] = ACTIONS(3615),
    [anon_sym_else] = ACTIONS(3615),
    [anon_sym_switch] = ACTIONS(3615),
    [anon_sym_case] = ACTIONS(3615),
    [anon_sym_default] = ACTIONS(3615),
    [anon_sym_while] = ACTIONS(3615),
    [anon_sym_do] = ACTIONS(3615),
    [anon_sym_for] = ACTIONS(3615),
    [anon_sym_return] = ACTIONS(3615),
    [anon_sym_break] = ACTIONS(3615),
    [anon_sym_continue] = ACTIONS(3615),
    [anon_sym_goto] = ACTIONS(3615),
    [anon_sym___try] = ACTIONS(3615),
    [anon_sym___leave] = ACTIONS(3615),
    [anon_sym_not] = ACTIONS(3615),
    [anon_sym_compl] = ACTIONS(3615),
    [anon_sym_DASH_DASH] = ACTIONS(3613),
    [anon_sym_PLUS_PLUS] = ACTIONS(3613),
    [anon_sym_sizeof] = ACTIONS(3615),
    [anon_sym___alignof__] = ACTIONS(3615),
    [anon_sym___alignof] = ACTIONS(3615),
    [anon_sym__alignof] = ACTIONS(3615),
    [anon_sym_alignof] = ACTIONS(3615),
    [anon_sym__Alignof] = ACTIONS(3615),
    [anon_sym_offsetof] = ACTIONS(3615),
    [anon_sym__Generic] = ACTIONS(3615),
    [anon_sym_asm] = ACTIONS(3615),
    [anon_sym___asm__] = ACTIONS(3615),
    [anon_sym___asm] = ACTIONS(3615),
    [sym_number_literal] = ACTIONS(3613),
    [anon_sym_L_SQUOTE] = ACTIONS(3613),
    [anon_sym_u_SQUOTE] = ACTIONS(3613),
    [anon_sym_U_SQUOTE] = ACTIONS(3613),
    [anon_sym_u8_SQUOTE] = ACTIONS(3613),
    [anon_sym_SQUOTE] = ACTIONS(3613),
    [anon_sym_L_DQUOTE] = ACTIONS(3613),
    [anon_sym_u_DQUOTE] = ACTIONS(3613),
    [anon_sym_U_DQUOTE] = ACTIONS(3613),
    [anon_sym_u8_DQUOTE] = ACTIONS(3613),
    [anon_sym_DQUOTE] = ACTIONS(3613),
    [sym_true] = ACTIONS(3615),
    [sym_false] = ACTIONS(3615),
    [anon_sym_NULL] = ACTIONS(3615),
    [anon_sym_nullptr] = ACTIONS(3615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3615),
    [anon_sym_let] = ACTIONS(3615),
    [anon_sym_This] = ACTIONS(3615),
    [anon_sym_decltype] = ACTIONS(3615),
    [anon_sym_explicit] = ACTIONS(3615),
    [anon_sym_typename] = ACTIONS(3615),
    [anon_sym_template] = ACTIONS(3615),
    [anon_sym_operator] = ACTIONS(3615),
    [anon_sym_try] = ACTIONS(3615),
    [anon_sym_delete] = ACTIONS(3615),
    [anon_sym_throw] = ACTIONS(3615),
    [anon_sym_namespace] = ACTIONS(3615),
    [anon_sym_static_assert] = ACTIONS(3615),
    [anon_sym_concept] = ACTIONS(3615),
    [anon_sym_co_return] = ACTIONS(3615),
    [anon_sym_co_yield] = ACTIONS(3615),
    [anon_sym_R_DQUOTE] = ACTIONS(3613),
    [anon_sym_LR_DQUOTE] = ACTIONS(3613),
    [anon_sym_uR_DQUOTE] = ACTIONS(3613),
    [anon_sym_UR_DQUOTE] = ACTIONS(3613),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3613),
    [anon_sym_co_await] = ACTIONS(3615),
    [anon_sym_new] = ACTIONS(3615),
    [anon_sym_requires] = ACTIONS(3615),
    [sym_this] = ACTIONS(3615),
    [anon_sym_discard] = ACTIONS(3615),
    [anon_sym_precise] = ACTIONS(3615),
    [anon_sym_shared] = ACTIONS(3615),
    [anon_sym_groupshared] = ACTIONS(3615),
    [anon_sym_uniform] = ACTIONS(3615),
    [anon_sym_row_major] = ACTIONS(3615),
    [anon_sym_column_major] = ACTIONS(3615),
    [anon_sym_globallycoherent] = ACTIONS(3615),
    [anon_sym_centroid] = ACTIONS(3615),
    [anon_sym_noperspective] = ACTIONS(3615),
    [anon_sym_nointerpolation] = ACTIONS(3615),
    [anon_sym_sample] = ACTIONS(3615),
    [anon_sym_linear] = ACTIONS(3615),
    [anon_sym_snorm] = ACTIONS(3615),
    [anon_sym_unorm] = ACTIONS(3615),
    [anon_sym_point] = ACTIONS(3615),
    [anon_sym_line] = ACTIONS(3615),
    [anon_sym_triangleadj] = ACTIONS(3615),
    [anon_sym_lineadj] = ACTIONS(3615),
    [anon_sym_triangle] = ACTIONS(3615),
    [anon_sym_cbuffer] = ACTIONS(3615),
    [anon_sym_interface] = ACTIONS(3615),
    [anon_sym_extension] = ACTIONS(3615),
  },
  [496] = {
    [ts_builtin_sym_end] = ACTIONS(3653),
    [sym_identifier] = ACTIONS(3655),
    [aux_sym_preproc_include_token1] = ACTIONS(3655),
    [aux_sym_preproc_def_token1] = ACTIONS(3655),
    [aux_sym_preproc_if_token1] = ACTIONS(3655),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3655),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3655),
    [sym_preproc_directive] = ACTIONS(3655),
    [anon_sym_LPAREN2] = ACTIONS(3653),
    [anon_sym_BANG] = ACTIONS(3653),
    [anon_sym_TILDE] = ACTIONS(3653),
    [anon_sym_DASH] = ACTIONS(3655),
    [anon_sym_PLUS] = ACTIONS(3655),
    [anon_sym_STAR] = ACTIONS(3653),
    [anon_sym_AMP_AMP] = ACTIONS(3653),
    [anon_sym_AMP] = ACTIONS(3655),
    [anon_sym_SEMI] = ACTIONS(3653),
    [anon_sym___extension__] = ACTIONS(3655),
    [anon_sym_typedef] = ACTIONS(3655),
    [anon_sym_in] = ACTIONS(3655),
    [anon_sym_out] = ACTIONS(3655),
    [anon_sym_inout] = ACTIONS(3655),
    [anon_sym_virtual] = ACTIONS(3655),
    [anon_sym_extern] = ACTIONS(3655),
    [anon_sym___attribute__] = ACTIONS(3655),
    [anon_sym___attribute] = ACTIONS(3655),
    [anon_sym_using] = ACTIONS(3655),
    [anon_sym_COLON_COLON] = ACTIONS(3653),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3653),
    [anon_sym___declspec] = ACTIONS(3655),
    [anon_sym___based] = ACTIONS(3655),
    [anon_sym___cdecl] = ACTIONS(3655),
    [anon_sym___clrcall] = ACTIONS(3655),
    [anon_sym___stdcall] = ACTIONS(3655),
    [anon_sym___fastcall] = ACTIONS(3655),
    [anon_sym___thiscall] = ACTIONS(3655),
    [anon_sym___vectorcall] = ACTIONS(3655),
    [anon_sym_LBRACE] = ACTIONS(3653),
    [anon_sym_signed] = ACTIONS(3655),
    [anon_sym_unsigned] = ACTIONS(3655),
    [anon_sym_long] = ACTIONS(3655),
    [anon_sym_short] = ACTIONS(3655),
    [anon_sym_LBRACK] = ACTIONS(3655),
    [anon_sym_static] = ACTIONS(3655),
    [anon_sym_register] = ACTIONS(3655),
    [anon_sym_inline] = ACTIONS(3655),
    [anon_sym___inline] = ACTIONS(3655),
    [anon_sym___inline__] = ACTIONS(3655),
    [anon_sym___forceinline] = ACTIONS(3655),
    [anon_sym_thread_local] = ACTIONS(3655),
    [anon_sym___thread] = ACTIONS(3655),
    [anon_sym_const] = ACTIONS(3655),
    [anon_sym_constexpr] = ACTIONS(3655),
    [anon_sym_volatile] = ACTIONS(3655),
    [anon_sym_restrict] = ACTIONS(3655),
    [anon_sym___restrict__] = ACTIONS(3655),
    [anon_sym__Atomic] = ACTIONS(3655),
    [anon_sym__Noreturn] = ACTIONS(3655),
    [anon_sym_noreturn] = ACTIONS(3655),
    [anon_sym__Nonnull] = ACTIONS(3655),
    [anon_sym_mutable] = ACTIONS(3655),
    [anon_sym_constinit] = ACTIONS(3655),
    [anon_sym_consteval] = ACTIONS(3655),
    [anon_sym_alignas] = ACTIONS(3655),
    [anon_sym__Alignas] = ACTIONS(3655),
    [sym_primitive_type] = ACTIONS(3655),
    [anon_sym_enum] = ACTIONS(3655),
    [anon_sym_class] = ACTIONS(3655),
    [anon_sym_struct] = ACTIONS(3655),
    [anon_sym_union] = ACTIONS(3655),
    [anon_sym_if] = ACTIONS(3655),
    [anon_sym_else] = ACTIONS(3655),
    [anon_sym_switch] = ACTIONS(3655),
    [anon_sym_case] = ACTIONS(3655),
    [anon_sym_default] = ACTIONS(3655),
    [anon_sym_while] = ACTIONS(3655),
    [anon_sym_do] = ACTIONS(3655),
    [anon_sym_for] = ACTIONS(3655),
    [anon_sym_return] = ACTIONS(3655),
    [anon_sym_break] = ACTIONS(3655),
    [anon_sym_continue] = ACTIONS(3655),
    [anon_sym_goto] = ACTIONS(3655),
    [anon_sym___try] = ACTIONS(3655),
    [anon_sym___leave] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3655),
    [anon_sym_compl] = ACTIONS(3655),
    [anon_sym_DASH_DASH] = ACTIONS(3653),
    [anon_sym_PLUS_PLUS] = ACTIONS(3653),
    [anon_sym_sizeof] = ACTIONS(3655),
    [anon_sym___alignof__] = ACTIONS(3655),
    [anon_sym___alignof] = ACTIONS(3655),
    [anon_sym__alignof] = ACTIONS(3655),
    [anon_sym_alignof] = ACTIONS(3655),
    [anon_sym__Alignof] = ACTIONS(3655),
    [anon_sym_offsetof] = ACTIONS(3655),
    [anon_sym__Generic] = ACTIONS(3655),
    [anon_sym_asm] = ACTIONS(3655),
    [anon_sym___asm__] = ACTIONS(3655),
    [anon_sym___asm] = ACTIONS(3655),
    [sym_number_literal] = ACTIONS(3653),
    [anon_sym_L_SQUOTE] = ACTIONS(3653),
    [anon_sym_u_SQUOTE] = ACTIONS(3653),
    [anon_sym_U_SQUOTE] = ACTIONS(3653),
    [anon_sym_u8_SQUOTE] = ACTIONS(3653),
    [anon_sym_SQUOTE] = ACTIONS(3653),
    [anon_sym_L_DQUOTE] = ACTIONS(3653),
    [anon_sym_u_DQUOTE] = ACTIONS(3653),
    [anon_sym_U_DQUOTE] = ACTIONS(3653),
    [anon_sym_u8_DQUOTE] = ACTIONS(3653),
    [anon_sym_DQUOTE] = ACTIONS(3653),
    [sym_true] = ACTIONS(3655),
    [sym_false] = ACTIONS(3655),
    [anon_sym_NULL] = ACTIONS(3655),
    [anon_sym_nullptr] = ACTIONS(3655),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3655),
    [anon_sym_let] = ACTIONS(3655),
    [anon_sym_This] = ACTIONS(3655),
    [anon_sym_decltype] = ACTIONS(3655),
    [anon_sym_explicit] = ACTIONS(3655),
    [anon_sym_typename] = ACTIONS(3655),
    [anon_sym_export] = ACTIONS(3655),
    [anon_sym_module] = ACTIONS(3655),
    [anon_sym_import] = ACTIONS(3655),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(3655),
    [anon_sym_try] = ACTIONS(3655),
    [anon_sym_delete] = ACTIONS(3655),
    [anon_sym_throw] = ACTIONS(3655),
    [anon_sym_namespace] = ACTIONS(3655),
    [anon_sym_static_assert] = ACTIONS(3655),
    [anon_sym_concept] = ACTIONS(3655),
    [anon_sym_co_return] = ACTIONS(3655),
    [anon_sym_co_yield] = ACTIONS(3655),
    [anon_sym_R_DQUOTE] = ACTIONS(3653),
    [anon_sym_LR_DQUOTE] = ACTIONS(3653),
    [anon_sym_uR_DQUOTE] = ACTIONS(3653),
    [anon_sym_UR_DQUOTE] = ACTIONS(3653),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3653),
    [anon_sym_co_await] = ACTIONS(3655),
    [anon_sym_new] = ACTIONS(3655),
    [anon_sym_requires] = ACTIONS(3655),
    [sym_this] = ACTIONS(3655),
    [anon_sym_discard] = ACTIONS(3655),
    [anon_sym_precise] = ACTIONS(3655),
    [anon_sym_shared] = ACTIONS(3655),
    [anon_sym_groupshared] = ACTIONS(3655),
    [anon_sym_uniform] = ACTIONS(3655),
    [anon_sym_row_major] = ACTIONS(3655),
    [anon_sym_column_major] = ACTIONS(3655),
    [anon_sym_globallycoherent] = ACTIONS(3655),
    [anon_sym_centroid] = ACTIONS(3655),
    [anon_sym_noperspective] = ACTIONS(3655),
    [anon_sym_nointerpolation] = ACTIONS(3655),
    [anon_sym_sample] = ACTIONS(3655),
    [anon_sym_linear] = ACTIONS(3655),
    [anon_sym_snorm] = ACTIONS(3655),
    [anon_sym_unorm] = ACTIONS(3655),
    [anon_sym_point] = ACTIONS(3655),
    [anon_sym_line] = ACTIONS(3655),
    [anon_sym_triangleadj] = ACTIONS(3655),
    [anon_sym_lineadj] = ACTIONS(3655),
    [anon_sym_triangle] = ACTIONS(3655),
    [anon_sym_cbuffer] = ACTIONS(3655),
    [anon_sym_interface] = ACTIONS(3655),
    [anon_sym_extension] = ACTIONS(3655),
    [anon_sym___exported] = ACTIONS(3655),
  },
  [497] = {
    [sym_identifier] = ACTIONS(3619),
    [aux_sym_preproc_include_token1] = ACTIONS(3619),
    [aux_sym_preproc_def_token1] = ACTIONS(3619),
    [aux_sym_preproc_if_token1] = ACTIONS(3619),
    [aux_sym_preproc_if_token2] = ACTIONS(3619),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3619),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3619),
    [aux_sym_preproc_else_token1] = ACTIONS(3619),
    [aux_sym_preproc_elif_token1] = ACTIONS(3619),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3619),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3619),
    [sym_preproc_directive] = ACTIONS(3619),
    [anon_sym_LPAREN2] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_DASH] = ACTIONS(3619),
    [anon_sym_PLUS] = ACTIONS(3619),
    [anon_sym_STAR] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP] = ACTIONS(3619),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym___extension__] = ACTIONS(3619),
    [anon_sym_typedef] = ACTIONS(3619),
    [anon_sym_in] = ACTIONS(3619),
    [anon_sym_out] = ACTIONS(3619),
    [anon_sym_inout] = ACTIONS(3619),
    [anon_sym_virtual] = ACTIONS(3619),
    [anon_sym_extern] = ACTIONS(3619),
    [anon_sym___attribute__] = ACTIONS(3619),
    [anon_sym___attribute] = ACTIONS(3619),
    [anon_sym_using] = ACTIONS(3619),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3617),
    [anon_sym___declspec] = ACTIONS(3619),
    [anon_sym___based] = ACTIONS(3619),
    [anon_sym___cdecl] = ACTIONS(3619),
    [anon_sym___clrcall] = ACTIONS(3619),
    [anon_sym___stdcall] = ACTIONS(3619),
    [anon_sym___fastcall] = ACTIONS(3619),
    [anon_sym___thiscall] = ACTIONS(3619),
    [anon_sym___vectorcall] = ACTIONS(3619),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_signed] = ACTIONS(3619),
    [anon_sym_unsigned] = ACTIONS(3619),
    [anon_sym_long] = ACTIONS(3619),
    [anon_sym_short] = ACTIONS(3619),
    [anon_sym_LBRACK] = ACTIONS(3619),
    [anon_sym_static] = ACTIONS(3619),
    [anon_sym_register] = ACTIONS(3619),
    [anon_sym_inline] = ACTIONS(3619),
    [anon_sym___inline] = ACTIONS(3619),
    [anon_sym___inline__] = ACTIONS(3619),
    [anon_sym___forceinline] = ACTIONS(3619),
    [anon_sym_thread_local] = ACTIONS(3619),
    [anon_sym___thread] = ACTIONS(3619),
    [anon_sym_const] = ACTIONS(3619),
    [anon_sym_constexpr] = ACTIONS(3619),
    [anon_sym_volatile] = ACTIONS(3619),
    [anon_sym_restrict] = ACTIONS(3619),
    [anon_sym___restrict__] = ACTIONS(3619),
    [anon_sym__Atomic] = ACTIONS(3619),
    [anon_sym__Noreturn] = ACTIONS(3619),
    [anon_sym_noreturn] = ACTIONS(3619),
    [anon_sym__Nonnull] = ACTIONS(3619),
    [anon_sym_mutable] = ACTIONS(3619),
    [anon_sym_constinit] = ACTIONS(3619),
    [anon_sym_consteval] = ACTIONS(3619),
    [anon_sym_alignas] = ACTIONS(3619),
    [anon_sym__Alignas] = ACTIONS(3619),
    [sym_primitive_type] = ACTIONS(3619),
    [anon_sym_enum] = ACTIONS(3619),
    [anon_sym_class] = ACTIONS(3619),
    [anon_sym_struct] = ACTIONS(3619),
    [anon_sym_union] = ACTIONS(3619),
    [anon_sym_if] = ACTIONS(3619),
    [anon_sym_else] = ACTIONS(3619),
    [anon_sym_switch] = ACTIONS(3619),
    [anon_sym_case] = ACTIONS(3619),
    [anon_sym_default] = ACTIONS(3619),
    [anon_sym_while] = ACTIONS(3619),
    [anon_sym_do] = ACTIONS(3619),
    [anon_sym_for] = ACTIONS(3619),
    [anon_sym_return] = ACTIONS(3619),
    [anon_sym_break] = ACTIONS(3619),
    [anon_sym_continue] = ACTIONS(3619),
    [anon_sym_goto] = ACTIONS(3619),
    [anon_sym___try] = ACTIONS(3619),
    [anon_sym___leave] = ACTIONS(3619),
    [anon_sym_not] = ACTIONS(3619),
    [anon_sym_compl] = ACTIONS(3619),
    [anon_sym_DASH_DASH] = ACTIONS(3617),
    [anon_sym_PLUS_PLUS] = ACTIONS(3617),
    [anon_sym_sizeof] = ACTIONS(3619),
    [anon_sym___alignof__] = ACTIONS(3619),
    [anon_sym___alignof] = ACTIONS(3619),
    [anon_sym__alignof] = ACTIONS(3619),
    [anon_sym_alignof] = ACTIONS(3619),
    [anon_sym__Alignof] = ACTIONS(3619),
    [anon_sym_offsetof] = ACTIONS(3619),
    [anon_sym__Generic] = ACTIONS(3619),
    [anon_sym_asm] = ACTIONS(3619),
    [anon_sym___asm__] = ACTIONS(3619),
    [anon_sym___asm] = ACTIONS(3619),
    [sym_number_literal] = ACTIONS(3617),
    [anon_sym_L_SQUOTE] = ACTIONS(3617),
    [anon_sym_u_SQUOTE] = ACTIONS(3617),
    [anon_sym_U_SQUOTE] = ACTIONS(3617),
    [anon_sym_u8_SQUOTE] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3617),
    [anon_sym_L_DQUOTE] = ACTIONS(3617),
    [anon_sym_u_DQUOTE] = ACTIONS(3617),
    [anon_sym_U_DQUOTE] = ACTIONS(3617),
    [anon_sym_u8_DQUOTE] = ACTIONS(3617),
    [anon_sym_DQUOTE] = ACTIONS(3617),
    [sym_true] = ACTIONS(3619),
    [sym_false] = ACTIONS(3619),
    [anon_sym_NULL] = ACTIONS(3619),
    [anon_sym_nullptr] = ACTIONS(3619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3619),
    [anon_sym_let] = ACTIONS(3619),
    [anon_sym_This] = ACTIONS(3619),
    [anon_sym_decltype] = ACTIONS(3619),
    [anon_sym_explicit] = ACTIONS(3619),
    [anon_sym_typename] = ACTIONS(3619),
    [anon_sym_template] = ACTIONS(3619),
    [anon_sym_operator] = ACTIONS(3619),
    [anon_sym_try] = ACTIONS(3619),
    [anon_sym_delete] = ACTIONS(3619),
    [anon_sym_throw] = ACTIONS(3619),
    [anon_sym_namespace] = ACTIONS(3619),
    [anon_sym_static_assert] = ACTIONS(3619),
    [anon_sym_concept] = ACTIONS(3619),
    [anon_sym_co_return] = ACTIONS(3619),
    [anon_sym_co_yield] = ACTIONS(3619),
    [anon_sym_R_DQUOTE] = ACTIONS(3617),
    [anon_sym_LR_DQUOTE] = ACTIONS(3617),
    [anon_sym_uR_DQUOTE] = ACTIONS(3617),
    [anon_sym_UR_DQUOTE] = ACTIONS(3617),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3617),
    [anon_sym_co_await] = ACTIONS(3619),
    [anon_sym_new] = ACTIONS(3619),
    [anon_sym_requires] = ACTIONS(3619),
    [sym_this] = ACTIONS(3619),
    [anon_sym_discard] = ACTIONS(3619),
    [anon_sym_precise] = ACTIONS(3619),
    [anon_sym_shared] = ACTIONS(3619),
    [anon_sym_groupshared] = ACTIONS(3619),
    [anon_sym_uniform] = ACTIONS(3619),
    [anon_sym_row_major] = ACTIONS(3619),
    [anon_sym_column_major] = ACTIONS(3619),
    [anon_sym_globallycoherent] = ACTIONS(3619),
    [anon_sym_centroid] = ACTIONS(3619),
    [anon_sym_noperspective] = ACTIONS(3619),
    [anon_sym_nointerpolation] = ACTIONS(3619),
    [anon_sym_sample] = ACTIONS(3619),
    [anon_sym_linear] = ACTIONS(3619),
    [anon_sym_snorm] = ACTIONS(3619),
    [anon_sym_unorm] = ACTIONS(3619),
    [anon_sym_point] = ACTIONS(3619),
    [anon_sym_line] = ACTIONS(3619),
    [anon_sym_triangleadj] = ACTIONS(3619),
    [anon_sym_lineadj] = ACTIONS(3619),
    [anon_sym_triangle] = ACTIONS(3619),
    [anon_sym_cbuffer] = ACTIONS(3619),
    [anon_sym_interface] = ACTIONS(3619),
    [anon_sym_extension] = ACTIONS(3619),
  },
  [498] = {
    [ts_builtin_sym_end] = ACTIONS(3587),
    [sym_identifier] = ACTIONS(3585),
    [aux_sym_preproc_include_token1] = ACTIONS(3585),
    [aux_sym_preproc_def_token1] = ACTIONS(3585),
    [aux_sym_preproc_if_token1] = ACTIONS(3585),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3585),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3585),
    [sym_preproc_directive] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(3587),
    [anon_sym_BANG] = ACTIONS(3587),
    [anon_sym_TILDE] = ACTIONS(3587),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_STAR] = ACTIONS(3587),
    [anon_sym_AMP_AMP] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_SEMI] = ACTIONS(3587),
    [anon_sym___extension__] = ACTIONS(3585),
    [anon_sym_typedef] = ACTIONS(3585),
    [anon_sym_in] = ACTIONS(3585),
    [anon_sym_out] = ACTIONS(3585),
    [anon_sym_inout] = ACTIONS(3585),
    [anon_sym_virtual] = ACTIONS(3585),
    [anon_sym_extern] = ACTIONS(3585),
    [anon_sym___attribute__] = ACTIONS(3585),
    [anon_sym___attribute] = ACTIONS(3585),
    [anon_sym_using] = ACTIONS(3585),
    [anon_sym_COLON_COLON] = ACTIONS(3587),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3587),
    [anon_sym___declspec] = ACTIONS(3585),
    [anon_sym___based] = ACTIONS(3585),
    [anon_sym___cdecl] = ACTIONS(3585),
    [anon_sym___clrcall] = ACTIONS(3585),
    [anon_sym___stdcall] = ACTIONS(3585),
    [anon_sym___fastcall] = ACTIONS(3585),
    [anon_sym___thiscall] = ACTIONS(3585),
    [anon_sym___vectorcall] = ACTIONS(3585),
    [anon_sym_LBRACE] = ACTIONS(3587),
    [anon_sym_signed] = ACTIONS(3585),
    [anon_sym_unsigned] = ACTIONS(3585),
    [anon_sym_long] = ACTIONS(3585),
    [anon_sym_short] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(3585),
    [anon_sym_static] = ACTIONS(3585),
    [anon_sym_register] = ACTIONS(3585),
    [anon_sym_inline] = ACTIONS(3585),
    [anon_sym___inline] = ACTIONS(3585),
    [anon_sym___inline__] = ACTIONS(3585),
    [anon_sym___forceinline] = ACTIONS(3585),
    [anon_sym_thread_local] = ACTIONS(3585),
    [anon_sym___thread] = ACTIONS(3585),
    [anon_sym_const] = ACTIONS(3585),
    [anon_sym_constexpr] = ACTIONS(3585),
    [anon_sym_volatile] = ACTIONS(3585),
    [anon_sym_restrict] = ACTIONS(3585),
    [anon_sym___restrict__] = ACTIONS(3585),
    [anon_sym__Atomic] = ACTIONS(3585),
    [anon_sym__Noreturn] = ACTIONS(3585),
    [anon_sym_noreturn] = ACTIONS(3585),
    [anon_sym__Nonnull] = ACTIONS(3585),
    [anon_sym_mutable] = ACTIONS(3585),
    [anon_sym_constinit] = ACTIONS(3585),
    [anon_sym_consteval] = ACTIONS(3585),
    [anon_sym_alignas] = ACTIONS(3585),
    [anon_sym__Alignas] = ACTIONS(3585),
    [sym_primitive_type] = ACTIONS(3585),
    [anon_sym_enum] = ACTIONS(3585),
    [anon_sym_class] = ACTIONS(3585),
    [anon_sym_struct] = ACTIONS(3585),
    [anon_sym_union] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_else] = ACTIONS(3585),
    [anon_sym_switch] = ACTIONS(3585),
    [anon_sym_case] = ACTIONS(3585),
    [anon_sym_default] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_do] = ACTIONS(3585),
    [anon_sym_for] = ACTIONS(3585),
    [anon_sym_return] = ACTIONS(3585),
    [anon_sym_break] = ACTIONS(3585),
    [anon_sym_continue] = ACTIONS(3585),
    [anon_sym_goto] = ACTIONS(3585),
    [anon_sym___try] = ACTIONS(3585),
    [anon_sym___leave] = ACTIONS(3585),
    [anon_sym_not] = ACTIONS(3585),
    [anon_sym_compl] = ACTIONS(3585),
    [anon_sym_DASH_DASH] = ACTIONS(3587),
    [anon_sym_PLUS_PLUS] = ACTIONS(3587),
    [anon_sym_sizeof] = ACTIONS(3585),
    [anon_sym___alignof__] = ACTIONS(3585),
    [anon_sym___alignof] = ACTIONS(3585),
    [anon_sym__alignof] = ACTIONS(3585),
    [anon_sym_alignof] = ACTIONS(3585),
    [anon_sym__Alignof] = ACTIONS(3585),
    [anon_sym_offsetof] = ACTIONS(3585),
    [anon_sym__Generic] = ACTIONS(3585),
    [anon_sym_asm] = ACTIONS(3585),
    [anon_sym___asm__] = ACTIONS(3585),
    [anon_sym___asm] = ACTIONS(3585),
    [sym_number_literal] = ACTIONS(3587),
    [anon_sym_L_SQUOTE] = ACTIONS(3587),
    [anon_sym_u_SQUOTE] = ACTIONS(3587),
    [anon_sym_U_SQUOTE] = ACTIONS(3587),
    [anon_sym_u8_SQUOTE] = ACTIONS(3587),
    [anon_sym_SQUOTE] = ACTIONS(3587),
    [anon_sym_L_DQUOTE] = ACTIONS(3587),
    [anon_sym_u_DQUOTE] = ACTIONS(3587),
    [anon_sym_U_DQUOTE] = ACTIONS(3587),
    [anon_sym_u8_DQUOTE] = ACTIONS(3587),
    [anon_sym_DQUOTE] = ACTIONS(3587),
    [sym_true] = ACTIONS(3585),
    [sym_false] = ACTIONS(3585),
    [anon_sym_NULL] = ACTIONS(3585),
    [anon_sym_nullptr] = ACTIONS(3585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3585),
    [anon_sym_let] = ACTIONS(3585),
    [anon_sym_This] = ACTIONS(3585),
    [anon_sym_decltype] = ACTIONS(3585),
    [anon_sym_explicit] = ACTIONS(3585),
    [anon_sym_typename] = ACTIONS(3585),
    [anon_sym_export] = ACTIONS(3585),
    [anon_sym_module] = ACTIONS(3585),
    [anon_sym_import] = ACTIONS(3585),
    [anon_sym_template] = ACTIONS(3585),
    [anon_sym_operator] = ACTIONS(3585),
    [anon_sym_try] = ACTIONS(3585),
    [anon_sym_delete] = ACTIONS(3585),
    [anon_sym_throw] = ACTIONS(3585),
    [anon_sym_namespace] = ACTIONS(3585),
    [anon_sym_static_assert] = ACTIONS(3585),
    [anon_sym_concept] = ACTIONS(3585),
    [anon_sym_co_return] = ACTIONS(3585),
    [anon_sym_co_yield] = ACTIONS(3585),
    [anon_sym_R_DQUOTE] = ACTIONS(3587),
    [anon_sym_LR_DQUOTE] = ACTIONS(3587),
    [anon_sym_uR_DQUOTE] = ACTIONS(3587),
    [anon_sym_UR_DQUOTE] = ACTIONS(3587),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3587),
    [anon_sym_co_await] = ACTIONS(3585),
    [anon_sym_new] = ACTIONS(3585),
    [anon_sym_requires] = ACTIONS(3585),
    [sym_this] = ACTIONS(3585),
    [anon_sym_discard] = ACTIONS(3585),
    [anon_sym_precise] = ACTIONS(3585),
    [anon_sym_shared] = ACTIONS(3585),
    [anon_sym_groupshared] = ACTIONS(3585),
    [anon_sym_uniform] = ACTIONS(3585),
    [anon_sym_row_major] = ACTIONS(3585),
    [anon_sym_column_major] = ACTIONS(3585),
    [anon_sym_globallycoherent] = ACTIONS(3585),
    [anon_sym_centroid] = ACTIONS(3585),
    [anon_sym_noperspective] = ACTIONS(3585),
    [anon_sym_nointerpolation] = ACTIONS(3585),
    [anon_sym_sample] = ACTIONS(3585),
    [anon_sym_linear] = ACTIONS(3585),
    [anon_sym_snorm] = ACTIONS(3585),
    [anon_sym_unorm] = ACTIONS(3585),
    [anon_sym_point] = ACTIONS(3585),
    [anon_sym_line] = ACTIONS(3585),
    [anon_sym_triangleadj] = ACTIONS(3585),
    [anon_sym_lineadj] = ACTIONS(3585),
    [anon_sym_triangle] = ACTIONS(3585),
    [anon_sym_cbuffer] = ACTIONS(3585),
    [anon_sym_interface] = ACTIONS(3585),
    [anon_sym_extension] = ACTIONS(3585),
    [anon_sym___exported] = ACTIONS(3585),
  },
  [499] = {
    [ts_builtin_sym_end] = ACTIONS(3595),
    [sym_identifier] = ACTIONS(3593),
    [aux_sym_preproc_include_token1] = ACTIONS(3593),
    [aux_sym_preproc_def_token1] = ACTIONS(3593),
    [aux_sym_preproc_if_token1] = ACTIONS(3593),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3593),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3593),
    [sym_preproc_directive] = ACTIONS(3593),
    [anon_sym_LPAREN2] = ACTIONS(3595),
    [anon_sym_BANG] = ACTIONS(3595),
    [anon_sym_TILDE] = ACTIONS(3595),
    [anon_sym_DASH] = ACTIONS(3593),
    [anon_sym_PLUS] = ACTIONS(3593),
    [anon_sym_STAR] = ACTIONS(3595),
    [anon_sym_AMP_AMP] = ACTIONS(3595),
    [anon_sym_AMP] = ACTIONS(3593),
    [anon_sym_SEMI] = ACTIONS(3595),
    [anon_sym___extension__] = ACTIONS(3593),
    [anon_sym_typedef] = ACTIONS(3593),
    [anon_sym_in] = ACTIONS(3593),
    [anon_sym_out] = ACTIONS(3593),
    [anon_sym_inout] = ACTIONS(3593),
    [anon_sym_virtual] = ACTIONS(3593),
    [anon_sym_extern] = ACTIONS(3593),
    [anon_sym___attribute__] = ACTIONS(3593),
    [anon_sym___attribute] = ACTIONS(3593),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_COLON_COLON] = ACTIONS(3595),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3595),
    [anon_sym___declspec] = ACTIONS(3593),
    [anon_sym___based] = ACTIONS(3593),
    [anon_sym___cdecl] = ACTIONS(3593),
    [anon_sym___clrcall] = ACTIONS(3593),
    [anon_sym___stdcall] = ACTIONS(3593),
    [anon_sym___fastcall] = ACTIONS(3593),
    [anon_sym___thiscall] = ACTIONS(3593),
    [anon_sym___vectorcall] = ACTIONS(3593),
    [anon_sym_LBRACE] = ACTIONS(3595),
    [anon_sym_signed] = ACTIONS(3593),
    [anon_sym_unsigned] = ACTIONS(3593),
    [anon_sym_long] = ACTIONS(3593),
    [anon_sym_short] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(3593),
    [anon_sym_static] = ACTIONS(3593),
    [anon_sym_register] = ACTIONS(3593),
    [anon_sym_inline] = ACTIONS(3593),
    [anon_sym___inline] = ACTIONS(3593),
    [anon_sym___inline__] = ACTIONS(3593),
    [anon_sym___forceinline] = ACTIONS(3593),
    [anon_sym_thread_local] = ACTIONS(3593),
    [anon_sym___thread] = ACTIONS(3593),
    [anon_sym_const] = ACTIONS(3593),
    [anon_sym_constexpr] = ACTIONS(3593),
    [anon_sym_volatile] = ACTIONS(3593),
    [anon_sym_restrict] = ACTIONS(3593),
    [anon_sym___restrict__] = ACTIONS(3593),
    [anon_sym__Atomic] = ACTIONS(3593),
    [anon_sym__Noreturn] = ACTIONS(3593),
    [anon_sym_noreturn] = ACTIONS(3593),
    [anon_sym__Nonnull] = ACTIONS(3593),
    [anon_sym_mutable] = ACTIONS(3593),
    [anon_sym_constinit] = ACTIONS(3593),
    [anon_sym_consteval] = ACTIONS(3593),
    [anon_sym_alignas] = ACTIONS(3593),
    [anon_sym__Alignas] = ACTIONS(3593),
    [sym_primitive_type] = ACTIONS(3593),
    [anon_sym_enum] = ACTIONS(3593),
    [anon_sym_class] = ACTIONS(3593),
    [anon_sym_struct] = ACTIONS(3593),
    [anon_sym_union] = ACTIONS(3593),
    [anon_sym_if] = ACTIONS(3593),
    [anon_sym_else] = ACTIONS(3593),
    [anon_sym_switch] = ACTIONS(3593),
    [anon_sym_case] = ACTIONS(3593),
    [anon_sym_default] = ACTIONS(3593),
    [anon_sym_while] = ACTIONS(3593),
    [anon_sym_do] = ACTIONS(3593),
    [anon_sym_for] = ACTIONS(3593),
    [anon_sym_return] = ACTIONS(3593),
    [anon_sym_break] = ACTIONS(3593),
    [anon_sym_continue] = ACTIONS(3593),
    [anon_sym_goto] = ACTIONS(3593),
    [anon_sym___try] = ACTIONS(3593),
    [anon_sym___leave] = ACTIONS(3593),
    [anon_sym_not] = ACTIONS(3593),
    [anon_sym_compl] = ACTIONS(3593),
    [anon_sym_DASH_DASH] = ACTIONS(3595),
    [anon_sym_PLUS_PLUS] = ACTIONS(3595),
    [anon_sym_sizeof] = ACTIONS(3593),
    [anon_sym___alignof__] = ACTIONS(3593),
    [anon_sym___alignof] = ACTIONS(3593),
    [anon_sym__alignof] = ACTIONS(3593),
    [anon_sym_alignof] = ACTIONS(3593),
    [anon_sym__Alignof] = ACTIONS(3593),
    [anon_sym_offsetof] = ACTIONS(3593),
    [anon_sym__Generic] = ACTIONS(3593),
    [anon_sym_asm] = ACTIONS(3593),
    [anon_sym___asm__] = ACTIONS(3593),
    [anon_sym___asm] = ACTIONS(3593),
    [sym_number_literal] = ACTIONS(3595),
    [anon_sym_L_SQUOTE] = ACTIONS(3595),
    [anon_sym_u_SQUOTE] = ACTIONS(3595),
    [anon_sym_U_SQUOTE] = ACTIONS(3595),
    [anon_sym_u8_SQUOTE] = ACTIONS(3595),
    [anon_sym_SQUOTE] = ACTIONS(3595),
    [anon_sym_L_DQUOTE] = ACTIONS(3595),
    [anon_sym_u_DQUOTE] = ACTIONS(3595),
    [anon_sym_U_DQUOTE] = ACTIONS(3595),
    [anon_sym_u8_DQUOTE] = ACTIONS(3595),
    [anon_sym_DQUOTE] = ACTIONS(3595),
    [sym_true] = ACTIONS(3593),
    [sym_false] = ACTIONS(3593),
    [anon_sym_NULL] = ACTIONS(3593),
    [anon_sym_nullptr] = ACTIONS(3593),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3593),
    [anon_sym_let] = ACTIONS(3593),
    [anon_sym_This] = ACTIONS(3593),
    [anon_sym_decltype] = ACTIONS(3593),
    [anon_sym_explicit] = ACTIONS(3593),
    [anon_sym_typename] = ACTIONS(3593),
    [anon_sym_export] = ACTIONS(3593),
    [anon_sym_module] = ACTIONS(3593),
    [anon_sym_import] = ACTIONS(3593),
    [anon_sym_template] = ACTIONS(3593),
    [anon_sym_operator] = ACTIONS(3593),
    [anon_sym_try] = ACTIONS(3593),
    [anon_sym_delete] = ACTIONS(3593),
    [anon_sym_throw] = ACTIONS(3593),
    [anon_sym_namespace] = ACTIONS(3593),
    [anon_sym_static_assert] = ACTIONS(3593),
    [anon_sym_concept] = ACTIONS(3593),
    [anon_sym_co_return] = ACTIONS(3593),
    [anon_sym_co_yield] = ACTIONS(3593),
    [anon_sym_R_DQUOTE] = ACTIONS(3595),
    [anon_sym_LR_DQUOTE] = ACTIONS(3595),
    [anon_sym_uR_DQUOTE] = ACTIONS(3595),
    [anon_sym_UR_DQUOTE] = ACTIONS(3595),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3595),
    [anon_sym_co_await] = ACTIONS(3593),
    [anon_sym_new] = ACTIONS(3593),
    [anon_sym_requires] = ACTIONS(3593),
    [sym_this] = ACTIONS(3593),
    [anon_sym_discard] = ACTIONS(3593),
    [anon_sym_precise] = ACTIONS(3593),
    [anon_sym_shared] = ACTIONS(3593),
    [anon_sym_groupshared] = ACTIONS(3593),
    [anon_sym_uniform] = ACTIONS(3593),
    [anon_sym_row_major] = ACTIONS(3593),
    [anon_sym_column_major] = ACTIONS(3593),
    [anon_sym_globallycoherent] = ACTIONS(3593),
    [anon_sym_centroid] = ACTIONS(3593),
    [anon_sym_noperspective] = ACTIONS(3593),
    [anon_sym_nointerpolation] = ACTIONS(3593),
    [anon_sym_sample] = ACTIONS(3593),
    [anon_sym_linear] = ACTIONS(3593),
    [anon_sym_snorm] = ACTIONS(3593),
    [anon_sym_unorm] = ACTIONS(3593),
    [anon_sym_point] = ACTIONS(3593),
    [anon_sym_line] = ACTIONS(3593),
    [anon_sym_triangleadj] = ACTIONS(3593),
    [anon_sym_lineadj] = ACTIONS(3593),
    [anon_sym_triangle] = ACTIONS(3593),
    [anon_sym_cbuffer] = ACTIONS(3593),
    [anon_sym_interface] = ACTIONS(3593),
    [anon_sym_extension] = ACTIONS(3593),
    [anon_sym___exported] = ACTIONS(3593),
  },
  [500] = {
    [sym_identifier] = ACTIONS(3623),
    [aux_sym_preproc_include_token1] = ACTIONS(3623),
    [aux_sym_preproc_def_token1] = ACTIONS(3623),
    [aux_sym_preproc_if_token1] = ACTIONS(3623),
    [aux_sym_preproc_if_token2] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3623),
    [aux_sym_preproc_else_token1] = ACTIONS(3623),
    [aux_sym_preproc_elif_token1] = ACTIONS(3623),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3623),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3623),
    [sym_preproc_directive] = ACTIONS(3623),
    [anon_sym_LPAREN2] = ACTIONS(3621),
    [anon_sym_BANG] = ACTIONS(3621),
    [anon_sym_TILDE] = ACTIONS(3621),
    [anon_sym_DASH] = ACTIONS(3623),
    [anon_sym_PLUS] = ACTIONS(3623),
    [anon_sym_STAR] = ACTIONS(3621),
    [anon_sym_AMP_AMP] = ACTIONS(3621),
    [anon_sym_AMP] = ACTIONS(3623),
    [anon_sym_SEMI] = ACTIONS(3621),
    [anon_sym___extension__] = ACTIONS(3623),
    [anon_sym_typedef] = ACTIONS(3623),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_out] = ACTIONS(3623),
    [anon_sym_inout] = ACTIONS(3623),
    [anon_sym_virtual] = ACTIONS(3623),
    [anon_sym_extern] = ACTIONS(3623),
    [anon_sym___attribute__] = ACTIONS(3623),
    [anon_sym___attribute] = ACTIONS(3623),
    [anon_sym_using] = ACTIONS(3623),
    [anon_sym_COLON_COLON] = ACTIONS(3621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3621),
    [anon_sym___declspec] = ACTIONS(3623),
    [anon_sym___based] = ACTIONS(3623),
    [anon_sym___cdecl] = ACTIONS(3623),
    [anon_sym___clrcall] = ACTIONS(3623),
    [anon_sym___stdcall] = ACTIONS(3623),
    [anon_sym___fastcall] = ACTIONS(3623),
    [anon_sym___thiscall] = ACTIONS(3623),
    [anon_sym___vectorcall] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3621),
    [anon_sym_signed] = ACTIONS(3623),
    [anon_sym_unsigned] = ACTIONS(3623),
    [anon_sym_long] = ACTIONS(3623),
    [anon_sym_short] = ACTIONS(3623),
    [anon_sym_LBRACK] = ACTIONS(3623),
    [anon_sym_static] = ACTIONS(3623),
    [anon_sym_register] = ACTIONS(3623),
    [anon_sym_inline] = ACTIONS(3623),
    [anon_sym___inline] = ACTIONS(3623),
    [anon_sym___inline__] = ACTIONS(3623),
    [anon_sym___forceinline] = ACTIONS(3623),
    [anon_sym_thread_local] = ACTIONS(3623),
    [anon_sym___thread] = ACTIONS(3623),
    [anon_sym_const] = ACTIONS(3623),
    [anon_sym_constexpr] = ACTIONS(3623),
    [anon_sym_volatile] = ACTIONS(3623),
    [anon_sym_restrict] = ACTIONS(3623),
    [anon_sym___restrict__] = ACTIONS(3623),
    [anon_sym__Atomic] = ACTIONS(3623),
    [anon_sym__Noreturn] = ACTIONS(3623),
    [anon_sym_noreturn] = ACTIONS(3623),
    [anon_sym__Nonnull] = ACTIONS(3623),
    [anon_sym_mutable] = ACTIONS(3623),
    [anon_sym_constinit] = ACTIONS(3623),
    [anon_sym_consteval] = ACTIONS(3623),
    [anon_sym_alignas] = ACTIONS(3623),
    [anon_sym__Alignas] = ACTIONS(3623),
    [sym_primitive_type] = ACTIONS(3623),
    [anon_sym_enum] = ACTIONS(3623),
    [anon_sym_class] = ACTIONS(3623),
    [anon_sym_struct] = ACTIONS(3623),
    [anon_sym_union] = ACTIONS(3623),
    [anon_sym_if] = ACTIONS(3623),
    [anon_sym_else] = ACTIONS(3623),
    [anon_sym_switch] = ACTIONS(3623),
    [anon_sym_case] = ACTIONS(3623),
    [anon_sym_default] = ACTIONS(3623),
    [anon_sym_while] = ACTIONS(3623),
    [anon_sym_do] = ACTIONS(3623),
    [anon_sym_for] = ACTIONS(3623),
    [anon_sym_return] = ACTIONS(3623),
    [anon_sym_break] = ACTIONS(3623),
    [anon_sym_continue] = ACTIONS(3623),
    [anon_sym_goto] = ACTIONS(3623),
    [anon_sym___try] = ACTIONS(3623),
    [anon_sym___leave] = ACTIONS(3623),
    [anon_sym_not] = ACTIONS(3623),
    [anon_sym_compl] = ACTIONS(3623),
    [anon_sym_DASH_DASH] = ACTIONS(3621),
    [anon_sym_PLUS_PLUS] = ACTIONS(3621),
    [anon_sym_sizeof] = ACTIONS(3623),
    [anon_sym___alignof__] = ACTIONS(3623),
    [anon_sym___alignof] = ACTIONS(3623),
    [anon_sym__alignof] = ACTIONS(3623),
    [anon_sym_alignof] = ACTIONS(3623),
    [anon_sym__Alignof] = ACTIONS(3623),
    [anon_sym_offsetof] = ACTIONS(3623),
    [anon_sym__Generic] = ACTIONS(3623),
    [anon_sym_asm] = ACTIONS(3623),
    [anon_sym___asm__] = ACTIONS(3623),
    [anon_sym___asm] = ACTIONS(3623),
    [sym_number_literal] = ACTIONS(3621),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3621),
    [anon_sym_u_DQUOTE] = ACTIONS(3621),
    [anon_sym_U_DQUOTE] = ACTIONS(3621),
    [anon_sym_u8_DQUOTE] = ACTIONS(3621),
    [anon_sym_DQUOTE] = ACTIONS(3621),
    [sym_true] = ACTIONS(3623),
    [sym_false] = ACTIONS(3623),
    [anon_sym_NULL] = ACTIONS(3623),
    [anon_sym_nullptr] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3623),
    [anon_sym_let] = ACTIONS(3623),
    [anon_sym_This] = ACTIONS(3623),
    [anon_sym_decltype] = ACTIONS(3623),
    [anon_sym_explicit] = ACTIONS(3623),
    [anon_sym_typename] = ACTIONS(3623),
    [anon_sym_template] = ACTIONS(3623),
    [anon_sym_operator] = ACTIONS(3623),
    [anon_sym_try] = ACTIONS(3623),
    [anon_sym_delete] = ACTIONS(3623),
    [anon_sym_throw] = ACTIONS(3623),
    [anon_sym_namespace] = ACTIONS(3623),
    [anon_sym_static_assert] = ACTIONS(3623),
    [anon_sym_concept] = ACTIONS(3623),
    [anon_sym_co_return] = ACTIONS(3623),
    [anon_sym_co_yield] = ACTIONS(3623),
    [anon_sym_R_DQUOTE] = ACTIONS(3621),
    [anon_sym_LR_DQUOTE] = ACTIONS(3621),
    [anon_sym_uR_DQUOTE] = ACTIONS(3621),
    [anon_sym_UR_DQUOTE] = ACTIONS(3621),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3621),
    [anon_sym_co_await] = ACTIONS(3623),
    [anon_sym_new] = ACTIONS(3623),
    [anon_sym_requires] = ACTIONS(3623),
    [sym_this] = ACTIONS(3623),
    [anon_sym_discard] = ACTIONS(3623),
    [anon_sym_precise] = ACTIONS(3623),
    [anon_sym_shared] = ACTIONS(3623),
    [anon_sym_groupshared] = ACTIONS(3623),
    [anon_sym_uniform] = ACTIONS(3623),
    [anon_sym_row_major] = ACTIONS(3623),
    [anon_sym_column_major] = ACTIONS(3623),
    [anon_sym_globallycoherent] = ACTIONS(3623),
    [anon_sym_centroid] = ACTIONS(3623),
    [anon_sym_noperspective] = ACTIONS(3623),
    [anon_sym_nointerpolation] = ACTIONS(3623),
    [anon_sym_sample] = ACTIONS(3623),
    [anon_sym_linear] = ACTIONS(3623),
    [anon_sym_snorm] = ACTIONS(3623),
    [anon_sym_unorm] = ACTIONS(3623),
    [anon_sym_point] = ACTIONS(3623),
    [anon_sym_line] = ACTIONS(3623),
    [anon_sym_triangleadj] = ACTIONS(3623),
    [anon_sym_lineadj] = ACTIONS(3623),
    [anon_sym_triangle] = ACTIONS(3623),
    [anon_sym_cbuffer] = ACTIONS(3623),
    [anon_sym_interface] = ACTIONS(3623),
    [anon_sym_extension] = ACTIONS(3623),
  },
  [501] = {
    [ts_builtin_sym_end] = ACTIONS(3508),
    [sym_identifier] = ACTIONS(3506),
    [aux_sym_preproc_include_token1] = ACTIONS(3506),
    [aux_sym_preproc_def_token1] = ACTIONS(3506),
    [aux_sym_preproc_if_token1] = ACTIONS(3506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3506),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3506),
    [sym_preproc_directive] = ACTIONS(3506),
    [anon_sym_LPAREN2] = ACTIONS(3508),
    [anon_sym_BANG] = ACTIONS(3508),
    [anon_sym_TILDE] = ACTIONS(3508),
    [anon_sym_DASH] = ACTIONS(3506),
    [anon_sym_PLUS] = ACTIONS(3506),
    [anon_sym_STAR] = ACTIONS(3508),
    [anon_sym_AMP_AMP] = ACTIONS(3508),
    [anon_sym_AMP] = ACTIONS(3506),
    [anon_sym_SEMI] = ACTIONS(3508),
    [anon_sym___extension__] = ACTIONS(3506),
    [anon_sym_typedef] = ACTIONS(3506),
    [anon_sym_in] = ACTIONS(3506),
    [anon_sym_out] = ACTIONS(3506),
    [anon_sym_inout] = ACTIONS(3506),
    [anon_sym_virtual] = ACTIONS(3506),
    [anon_sym_extern] = ACTIONS(3506),
    [anon_sym___attribute__] = ACTIONS(3506),
    [anon_sym___attribute] = ACTIONS(3506),
    [anon_sym_using] = ACTIONS(3506),
    [anon_sym_COLON_COLON] = ACTIONS(3508),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3508),
    [anon_sym___declspec] = ACTIONS(3506),
    [anon_sym___based] = ACTIONS(3506),
    [anon_sym___cdecl] = ACTIONS(3506),
    [anon_sym___clrcall] = ACTIONS(3506),
    [anon_sym___stdcall] = ACTIONS(3506),
    [anon_sym___fastcall] = ACTIONS(3506),
    [anon_sym___thiscall] = ACTIONS(3506),
    [anon_sym___vectorcall] = ACTIONS(3506),
    [anon_sym_LBRACE] = ACTIONS(3508),
    [anon_sym_signed] = ACTIONS(3506),
    [anon_sym_unsigned] = ACTIONS(3506),
    [anon_sym_long] = ACTIONS(3506),
    [anon_sym_short] = ACTIONS(3506),
    [anon_sym_LBRACK] = ACTIONS(3506),
    [anon_sym_static] = ACTIONS(3506),
    [anon_sym_register] = ACTIONS(3506),
    [anon_sym_inline] = ACTIONS(3506),
    [anon_sym___inline] = ACTIONS(3506),
    [anon_sym___inline__] = ACTIONS(3506),
    [anon_sym___forceinline] = ACTIONS(3506),
    [anon_sym_thread_local] = ACTIONS(3506),
    [anon_sym___thread] = ACTIONS(3506),
    [anon_sym_const] = ACTIONS(3506),
    [anon_sym_constexpr] = ACTIONS(3506),
    [anon_sym_volatile] = ACTIONS(3506),
    [anon_sym_restrict] = ACTIONS(3506),
    [anon_sym___restrict__] = ACTIONS(3506),
    [anon_sym__Atomic] = ACTIONS(3506),
    [anon_sym__Noreturn] = ACTIONS(3506),
    [anon_sym_noreturn] = ACTIONS(3506),
    [anon_sym__Nonnull] = ACTIONS(3506),
    [anon_sym_mutable] = ACTIONS(3506),
    [anon_sym_constinit] = ACTIONS(3506),
    [anon_sym_consteval] = ACTIONS(3506),
    [anon_sym_alignas] = ACTIONS(3506),
    [anon_sym__Alignas] = ACTIONS(3506),
    [sym_primitive_type] = ACTIONS(3506),
    [anon_sym_enum] = ACTIONS(3506),
    [anon_sym_class] = ACTIONS(3506),
    [anon_sym_struct] = ACTIONS(3506),
    [anon_sym_union] = ACTIONS(3506),
    [anon_sym_if] = ACTIONS(3506),
    [anon_sym_else] = ACTIONS(3506),
    [anon_sym_switch] = ACTIONS(3506),
    [anon_sym_case] = ACTIONS(3506),
    [anon_sym_default] = ACTIONS(3506),
    [anon_sym_while] = ACTIONS(3506),
    [anon_sym_do] = ACTIONS(3506),
    [anon_sym_for] = ACTIONS(3506),
    [anon_sym_return] = ACTIONS(3506),
    [anon_sym_break] = ACTIONS(3506),
    [anon_sym_continue] = ACTIONS(3506),
    [anon_sym_goto] = ACTIONS(3506),
    [anon_sym___try] = ACTIONS(3506),
    [anon_sym___leave] = ACTIONS(3506),
    [anon_sym_not] = ACTIONS(3506),
    [anon_sym_compl] = ACTIONS(3506),
    [anon_sym_DASH_DASH] = ACTIONS(3508),
    [anon_sym_PLUS_PLUS] = ACTIONS(3508),
    [anon_sym_sizeof] = ACTIONS(3506),
    [anon_sym___alignof__] = ACTIONS(3506),
    [anon_sym___alignof] = ACTIONS(3506),
    [anon_sym__alignof] = ACTIONS(3506),
    [anon_sym_alignof] = ACTIONS(3506),
    [anon_sym__Alignof] = ACTIONS(3506),
    [anon_sym_offsetof] = ACTIONS(3506),
    [anon_sym__Generic] = ACTIONS(3506),
    [anon_sym_asm] = ACTIONS(3506),
    [anon_sym___asm__] = ACTIONS(3506),
    [anon_sym___asm] = ACTIONS(3506),
    [sym_number_literal] = ACTIONS(3508),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3508),
    [anon_sym_u_DQUOTE] = ACTIONS(3508),
    [anon_sym_U_DQUOTE] = ACTIONS(3508),
    [anon_sym_u8_DQUOTE] = ACTIONS(3508),
    [anon_sym_DQUOTE] = ACTIONS(3508),
    [sym_true] = ACTIONS(3506),
    [sym_false] = ACTIONS(3506),
    [anon_sym_NULL] = ACTIONS(3506),
    [anon_sym_nullptr] = ACTIONS(3506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3506),
    [anon_sym_let] = ACTIONS(3506),
    [anon_sym_This] = ACTIONS(3506),
    [anon_sym_decltype] = ACTIONS(3506),
    [anon_sym_explicit] = ACTIONS(3506),
    [anon_sym_typename] = ACTIONS(3506),
    [anon_sym_export] = ACTIONS(3506),
    [anon_sym_module] = ACTIONS(3506),
    [anon_sym_import] = ACTIONS(3506),
    [anon_sym_template] = ACTIONS(3506),
    [anon_sym_operator] = ACTIONS(3506),
    [anon_sym_try] = ACTIONS(3506),
    [anon_sym_delete] = ACTIONS(3506),
    [anon_sym_throw] = ACTIONS(3506),
    [anon_sym_namespace] = ACTIONS(3506),
    [anon_sym_static_assert] = ACTIONS(3506),
    [anon_sym_concept] = ACTIONS(3506),
    [anon_sym_co_return] = ACTIONS(3506),
    [anon_sym_co_yield] = ACTIONS(3506),
    [anon_sym_R_DQUOTE] = ACTIONS(3508),
    [anon_sym_LR_DQUOTE] = ACTIONS(3508),
    [anon_sym_uR_DQUOTE] = ACTIONS(3508),
    [anon_sym_UR_DQUOTE] = ACTIONS(3508),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3508),
    [anon_sym_co_await] = ACTIONS(3506),
    [anon_sym_new] = ACTIONS(3506),
    [anon_sym_requires] = ACTIONS(3506),
    [sym_this] = ACTIONS(3506),
    [anon_sym_discard] = ACTIONS(3506),
    [anon_sym_precise] = ACTIONS(3506),
    [anon_sym_shared] = ACTIONS(3506),
    [anon_sym_groupshared] = ACTIONS(3506),
    [anon_sym_uniform] = ACTIONS(3506),
    [anon_sym_row_major] = ACTIONS(3506),
    [anon_sym_column_major] = ACTIONS(3506),
    [anon_sym_globallycoherent] = ACTIONS(3506),
    [anon_sym_centroid] = ACTIONS(3506),
    [anon_sym_noperspective] = ACTIONS(3506),
    [anon_sym_nointerpolation] = ACTIONS(3506),
    [anon_sym_sample] = ACTIONS(3506),
    [anon_sym_linear] = ACTIONS(3506),
    [anon_sym_snorm] = ACTIONS(3506),
    [anon_sym_unorm] = ACTIONS(3506),
    [anon_sym_point] = ACTIONS(3506),
    [anon_sym_line] = ACTIONS(3506),
    [anon_sym_triangleadj] = ACTIONS(3506),
    [anon_sym_lineadj] = ACTIONS(3506),
    [anon_sym_triangle] = ACTIONS(3506),
    [anon_sym_cbuffer] = ACTIONS(3506),
    [anon_sym_interface] = ACTIONS(3506),
    [anon_sym_extension] = ACTIONS(3506),
    [anon_sym___exported] = ACTIONS(3506),
  },
  [502] = {
    [sym_identifier] = ACTIONS(3623),
    [aux_sym_preproc_include_token1] = ACTIONS(3623),
    [aux_sym_preproc_def_token1] = ACTIONS(3623),
    [aux_sym_preproc_if_token1] = ACTIONS(3623),
    [aux_sym_preproc_if_token2] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3623),
    [aux_sym_preproc_else_token1] = ACTIONS(3623),
    [aux_sym_preproc_elif_token1] = ACTIONS(3623),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3623),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3623),
    [sym_preproc_directive] = ACTIONS(3623),
    [anon_sym_LPAREN2] = ACTIONS(3621),
    [anon_sym_BANG] = ACTIONS(3621),
    [anon_sym_TILDE] = ACTIONS(3621),
    [anon_sym_DASH] = ACTIONS(3623),
    [anon_sym_PLUS] = ACTIONS(3623),
    [anon_sym_STAR] = ACTIONS(3621),
    [anon_sym_AMP_AMP] = ACTIONS(3621),
    [anon_sym_AMP] = ACTIONS(3623),
    [anon_sym_SEMI] = ACTIONS(3621),
    [anon_sym___extension__] = ACTIONS(3623),
    [anon_sym_typedef] = ACTIONS(3623),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_out] = ACTIONS(3623),
    [anon_sym_inout] = ACTIONS(3623),
    [anon_sym_virtual] = ACTIONS(3623),
    [anon_sym_extern] = ACTIONS(3623),
    [anon_sym___attribute__] = ACTIONS(3623),
    [anon_sym___attribute] = ACTIONS(3623),
    [anon_sym_using] = ACTIONS(3623),
    [anon_sym_COLON_COLON] = ACTIONS(3621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3621),
    [anon_sym___declspec] = ACTIONS(3623),
    [anon_sym___based] = ACTIONS(3623),
    [anon_sym___cdecl] = ACTIONS(3623),
    [anon_sym___clrcall] = ACTIONS(3623),
    [anon_sym___stdcall] = ACTIONS(3623),
    [anon_sym___fastcall] = ACTIONS(3623),
    [anon_sym___thiscall] = ACTIONS(3623),
    [anon_sym___vectorcall] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3621),
    [anon_sym_signed] = ACTIONS(3623),
    [anon_sym_unsigned] = ACTIONS(3623),
    [anon_sym_long] = ACTIONS(3623),
    [anon_sym_short] = ACTIONS(3623),
    [anon_sym_LBRACK] = ACTIONS(3623),
    [anon_sym_static] = ACTIONS(3623),
    [anon_sym_register] = ACTIONS(3623),
    [anon_sym_inline] = ACTIONS(3623),
    [anon_sym___inline] = ACTIONS(3623),
    [anon_sym___inline__] = ACTIONS(3623),
    [anon_sym___forceinline] = ACTIONS(3623),
    [anon_sym_thread_local] = ACTIONS(3623),
    [anon_sym___thread] = ACTIONS(3623),
    [anon_sym_const] = ACTIONS(3623),
    [anon_sym_constexpr] = ACTIONS(3623),
    [anon_sym_volatile] = ACTIONS(3623),
    [anon_sym_restrict] = ACTIONS(3623),
    [anon_sym___restrict__] = ACTIONS(3623),
    [anon_sym__Atomic] = ACTIONS(3623),
    [anon_sym__Noreturn] = ACTIONS(3623),
    [anon_sym_noreturn] = ACTIONS(3623),
    [anon_sym__Nonnull] = ACTIONS(3623),
    [anon_sym_mutable] = ACTIONS(3623),
    [anon_sym_constinit] = ACTIONS(3623),
    [anon_sym_consteval] = ACTIONS(3623),
    [anon_sym_alignas] = ACTIONS(3623),
    [anon_sym__Alignas] = ACTIONS(3623),
    [sym_primitive_type] = ACTIONS(3623),
    [anon_sym_enum] = ACTIONS(3623),
    [anon_sym_class] = ACTIONS(3623),
    [anon_sym_struct] = ACTIONS(3623),
    [anon_sym_union] = ACTIONS(3623),
    [anon_sym_if] = ACTIONS(3623),
    [anon_sym_else] = ACTIONS(3623),
    [anon_sym_switch] = ACTIONS(3623),
    [anon_sym_case] = ACTIONS(3623),
    [anon_sym_default] = ACTIONS(3623),
    [anon_sym_while] = ACTIONS(3623),
    [anon_sym_do] = ACTIONS(3623),
    [anon_sym_for] = ACTIONS(3623),
    [anon_sym_return] = ACTIONS(3623),
    [anon_sym_break] = ACTIONS(3623),
    [anon_sym_continue] = ACTIONS(3623),
    [anon_sym_goto] = ACTIONS(3623),
    [anon_sym___try] = ACTIONS(3623),
    [anon_sym___leave] = ACTIONS(3623),
    [anon_sym_not] = ACTIONS(3623),
    [anon_sym_compl] = ACTIONS(3623),
    [anon_sym_DASH_DASH] = ACTIONS(3621),
    [anon_sym_PLUS_PLUS] = ACTIONS(3621),
    [anon_sym_sizeof] = ACTIONS(3623),
    [anon_sym___alignof__] = ACTIONS(3623),
    [anon_sym___alignof] = ACTIONS(3623),
    [anon_sym__alignof] = ACTIONS(3623),
    [anon_sym_alignof] = ACTIONS(3623),
    [anon_sym__Alignof] = ACTIONS(3623),
    [anon_sym_offsetof] = ACTIONS(3623),
    [anon_sym__Generic] = ACTIONS(3623),
    [anon_sym_asm] = ACTIONS(3623),
    [anon_sym___asm__] = ACTIONS(3623),
    [anon_sym___asm] = ACTIONS(3623),
    [sym_number_literal] = ACTIONS(3621),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3621),
    [anon_sym_u_DQUOTE] = ACTIONS(3621),
    [anon_sym_U_DQUOTE] = ACTIONS(3621),
    [anon_sym_u8_DQUOTE] = ACTIONS(3621),
    [anon_sym_DQUOTE] = ACTIONS(3621),
    [sym_true] = ACTIONS(3623),
    [sym_false] = ACTIONS(3623),
    [anon_sym_NULL] = ACTIONS(3623),
    [anon_sym_nullptr] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3623),
    [anon_sym_let] = ACTIONS(3623),
    [anon_sym_This] = ACTIONS(3623),
    [anon_sym_decltype] = ACTIONS(3623),
    [anon_sym_explicit] = ACTIONS(3623),
    [anon_sym_typename] = ACTIONS(3623),
    [anon_sym_template] = ACTIONS(3623),
    [anon_sym_operator] = ACTIONS(3623),
    [anon_sym_try] = ACTIONS(3623),
    [anon_sym_delete] = ACTIONS(3623),
    [anon_sym_throw] = ACTIONS(3623),
    [anon_sym_namespace] = ACTIONS(3623),
    [anon_sym_static_assert] = ACTIONS(3623),
    [anon_sym_concept] = ACTIONS(3623),
    [anon_sym_co_return] = ACTIONS(3623),
    [anon_sym_co_yield] = ACTIONS(3623),
    [anon_sym_R_DQUOTE] = ACTIONS(3621),
    [anon_sym_LR_DQUOTE] = ACTIONS(3621),
    [anon_sym_uR_DQUOTE] = ACTIONS(3621),
    [anon_sym_UR_DQUOTE] = ACTIONS(3621),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3621),
    [anon_sym_co_await] = ACTIONS(3623),
    [anon_sym_new] = ACTIONS(3623),
    [anon_sym_requires] = ACTIONS(3623),
    [sym_this] = ACTIONS(3623),
    [anon_sym_discard] = ACTIONS(3623),
    [anon_sym_precise] = ACTIONS(3623),
    [anon_sym_shared] = ACTIONS(3623),
    [anon_sym_groupshared] = ACTIONS(3623),
    [anon_sym_uniform] = ACTIONS(3623),
    [anon_sym_row_major] = ACTIONS(3623),
    [anon_sym_column_major] = ACTIONS(3623),
    [anon_sym_globallycoherent] = ACTIONS(3623),
    [anon_sym_centroid] = ACTIONS(3623),
    [anon_sym_noperspective] = ACTIONS(3623),
    [anon_sym_nointerpolation] = ACTIONS(3623),
    [anon_sym_sample] = ACTIONS(3623),
    [anon_sym_linear] = ACTIONS(3623),
    [anon_sym_snorm] = ACTIONS(3623),
    [anon_sym_unorm] = ACTIONS(3623),
    [anon_sym_point] = ACTIONS(3623),
    [anon_sym_line] = ACTIONS(3623),
    [anon_sym_triangleadj] = ACTIONS(3623),
    [anon_sym_lineadj] = ACTIONS(3623),
    [anon_sym_triangle] = ACTIONS(3623),
    [anon_sym_cbuffer] = ACTIONS(3623),
    [anon_sym_interface] = ACTIONS(3623),
    [anon_sym_extension] = ACTIONS(3623),
  },
  [503] = {
    [ts_builtin_sym_end] = ACTIONS(3639),
    [sym_identifier] = ACTIONS(3637),
    [aux_sym_preproc_include_token1] = ACTIONS(3637),
    [aux_sym_preproc_def_token1] = ACTIONS(3637),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3637),
    [sym_preproc_directive] = ACTIONS(3637),
    [anon_sym_LPAREN2] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(3639),
    [anon_sym_TILDE] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3637),
    [anon_sym_STAR] = ACTIONS(3639),
    [anon_sym_AMP_AMP] = ACTIONS(3639),
    [anon_sym_AMP] = ACTIONS(3637),
    [anon_sym_SEMI] = ACTIONS(3639),
    [anon_sym___extension__] = ACTIONS(3637),
    [anon_sym_typedef] = ACTIONS(3637),
    [anon_sym_in] = ACTIONS(3637),
    [anon_sym_out] = ACTIONS(3637),
    [anon_sym_inout] = ACTIONS(3637),
    [anon_sym_virtual] = ACTIONS(3637),
    [anon_sym_extern] = ACTIONS(3637),
    [anon_sym___attribute__] = ACTIONS(3637),
    [anon_sym___attribute] = ACTIONS(3637),
    [anon_sym_using] = ACTIONS(3637),
    [anon_sym_COLON_COLON] = ACTIONS(3639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3639),
    [anon_sym___declspec] = ACTIONS(3637),
    [anon_sym___based] = ACTIONS(3637),
    [anon_sym___cdecl] = ACTIONS(3637),
    [anon_sym___clrcall] = ACTIONS(3637),
    [anon_sym___stdcall] = ACTIONS(3637),
    [anon_sym___fastcall] = ACTIONS(3637),
    [anon_sym___thiscall] = ACTIONS(3637),
    [anon_sym___vectorcall] = ACTIONS(3637),
    [anon_sym_LBRACE] = ACTIONS(3639),
    [anon_sym_signed] = ACTIONS(3637),
    [anon_sym_unsigned] = ACTIONS(3637),
    [anon_sym_long] = ACTIONS(3637),
    [anon_sym_short] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(3637),
    [anon_sym_static] = ACTIONS(3637),
    [anon_sym_register] = ACTIONS(3637),
    [anon_sym_inline] = ACTIONS(3637),
    [anon_sym___inline] = ACTIONS(3637),
    [anon_sym___inline__] = ACTIONS(3637),
    [anon_sym___forceinline] = ACTIONS(3637),
    [anon_sym_thread_local] = ACTIONS(3637),
    [anon_sym___thread] = ACTIONS(3637),
    [anon_sym_const] = ACTIONS(3637),
    [anon_sym_constexpr] = ACTIONS(3637),
    [anon_sym_volatile] = ACTIONS(3637),
    [anon_sym_restrict] = ACTIONS(3637),
    [anon_sym___restrict__] = ACTIONS(3637),
    [anon_sym__Atomic] = ACTIONS(3637),
    [anon_sym__Noreturn] = ACTIONS(3637),
    [anon_sym_noreturn] = ACTIONS(3637),
    [anon_sym__Nonnull] = ACTIONS(3637),
    [anon_sym_mutable] = ACTIONS(3637),
    [anon_sym_constinit] = ACTIONS(3637),
    [anon_sym_consteval] = ACTIONS(3637),
    [anon_sym_alignas] = ACTIONS(3637),
    [anon_sym__Alignas] = ACTIONS(3637),
    [sym_primitive_type] = ACTIONS(3637),
    [anon_sym_enum] = ACTIONS(3637),
    [anon_sym_class] = ACTIONS(3637),
    [anon_sym_struct] = ACTIONS(3637),
    [anon_sym_union] = ACTIONS(3637),
    [anon_sym_if] = ACTIONS(3637),
    [anon_sym_else] = ACTIONS(3637),
    [anon_sym_switch] = ACTIONS(3637),
    [anon_sym_case] = ACTIONS(3637),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3637),
    [anon_sym_do] = ACTIONS(3637),
    [anon_sym_for] = ACTIONS(3637),
    [anon_sym_return] = ACTIONS(3637),
    [anon_sym_break] = ACTIONS(3637),
    [anon_sym_continue] = ACTIONS(3637),
    [anon_sym_goto] = ACTIONS(3637),
    [anon_sym___try] = ACTIONS(3637),
    [anon_sym___leave] = ACTIONS(3637),
    [anon_sym_not] = ACTIONS(3637),
    [anon_sym_compl] = ACTIONS(3637),
    [anon_sym_DASH_DASH] = ACTIONS(3639),
    [anon_sym_PLUS_PLUS] = ACTIONS(3639),
    [anon_sym_sizeof] = ACTIONS(3637),
    [anon_sym___alignof__] = ACTIONS(3637),
    [anon_sym___alignof] = ACTIONS(3637),
    [anon_sym__alignof] = ACTIONS(3637),
    [anon_sym_alignof] = ACTIONS(3637),
    [anon_sym__Alignof] = ACTIONS(3637),
    [anon_sym_offsetof] = ACTIONS(3637),
    [anon_sym__Generic] = ACTIONS(3637),
    [anon_sym_asm] = ACTIONS(3637),
    [anon_sym___asm__] = ACTIONS(3637),
    [anon_sym___asm] = ACTIONS(3637),
    [sym_number_literal] = ACTIONS(3639),
    [anon_sym_L_SQUOTE] = ACTIONS(3639),
    [anon_sym_u_SQUOTE] = ACTIONS(3639),
    [anon_sym_U_SQUOTE] = ACTIONS(3639),
    [anon_sym_u8_SQUOTE] = ACTIONS(3639),
    [anon_sym_SQUOTE] = ACTIONS(3639),
    [anon_sym_L_DQUOTE] = ACTIONS(3639),
    [anon_sym_u_DQUOTE] = ACTIONS(3639),
    [anon_sym_U_DQUOTE] = ACTIONS(3639),
    [anon_sym_u8_DQUOTE] = ACTIONS(3639),
    [anon_sym_DQUOTE] = ACTIONS(3639),
    [sym_true] = ACTIONS(3637),
    [sym_false] = ACTIONS(3637),
    [anon_sym_NULL] = ACTIONS(3637),
    [anon_sym_nullptr] = ACTIONS(3637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3637),
    [anon_sym_let] = ACTIONS(3637),
    [anon_sym_This] = ACTIONS(3637),
    [anon_sym_decltype] = ACTIONS(3637),
    [anon_sym_explicit] = ACTIONS(3637),
    [anon_sym_typename] = ACTIONS(3637),
    [anon_sym_export] = ACTIONS(3637),
    [anon_sym_module] = ACTIONS(3637),
    [anon_sym_import] = ACTIONS(3637),
    [anon_sym_template] = ACTIONS(3637),
    [anon_sym_operator] = ACTIONS(3637),
    [anon_sym_try] = ACTIONS(3637),
    [anon_sym_delete] = ACTIONS(3637),
    [anon_sym_throw] = ACTIONS(3637),
    [anon_sym_namespace] = ACTIONS(3637),
    [anon_sym_static_assert] = ACTIONS(3637),
    [anon_sym_concept] = ACTIONS(3637),
    [anon_sym_co_return] = ACTIONS(3637),
    [anon_sym_co_yield] = ACTIONS(3637),
    [anon_sym_R_DQUOTE] = ACTIONS(3639),
    [anon_sym_LR_DQUOTE] = ACTIONS(3639),
    [anon_sym_uR_DQUOTE] = ACTIONS(3639),
    [anon_sym_UR_DQUOTE] = ACTIONS(3639),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3639),
    [anon_sym_co_await] = ACTIONS(3637),
    [anon_sym_new] = ACTIONS(3637),
    [anon_sym_requires] = ACTIONS(3637),
    [sym_this] = ACTIONS(3637),
    [anon_sym_discard] = ACTIONS(3637),
    [anon_sym_precise] = ACTIONS(3637),
    [anon_sym_shared] = ACTIONS(3637),
    [anon_sym_groupshared] = ACTIONS(3637),
    [anon_sym_uniform] = ACTIONS(3637),
    [anon_sym_row_major] = ACTIONS(3637),
    [anon_sym_column_major] = ACTIONS(3637),
    [anon_sym_globallycoherent] = ACTIONS(3637),
    [anon_sym_centroid] = ACTIONS(3637),
    [anon_sym_noperspective] = ACTIONS(3637),
    [anon_sym_nointerpolation] = ACTIONS(3637),
    [anon_sym_sample] = ACTIONS(3637),
    [anon_sym_linear] = ACTIONS(3637),
    [anon_sym_snorm] = ACTIONS(3637),
    [anon_sym_unorm] = ACTIONS(3637),
    [anon_sym_point] = ACTIONS(3637),
    [anon_sym_line] = ACTIONS(3637),
    [anon_sym_triangleadj] = ACTIONS(3637),
    [anon_sym_lineadj] = ACTIONS(3637),
    [anon_sym_triangle] = ACTIONS(3637),
    [anon_sym_cbuffer] = ACTIONS(3637),
    [anon_sym_interface] = ACTIONS(3637),
    [anon_sym_extension] = ACTIONS(3637),
    [anon_sym___exported] = ACTIONS(3637),
  },
  [504] = {
    [ts_builtin_sym_end] = ACTIONS(3643),
    [sym_identifier] = ACTIONS(3641),
    [aux_sym_preproc_include_token1] = ACTIONS(3641),
    [aux_sym_preproc_def_token1] = ACTIONS(3641),
    [aux_sym_preproc_if_token1] = ACTIONS(3641),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3641),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3641),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(3643),
    [anon_sym_BANG] = ACTIONS(3643),
    [anon_sym_TILDE] = ACTIONS(3643),
    [anon_sym_DASH] = ACTIONS(3641),
    [anon_sym_PLUS] = ACTIONS(3641),
    [anon_sym_STAR] = ACTIONS(3643),
    [anon_sym_AMP_AMP] = ACTIONS(3643),
    [anon_sym_AMP] = ACTIONS(3641),
    [anon_sym_SEMI] = ACTIONS(3643),
    [anon_sym___extension__] = ACTIONS(3641),
    [anon_sym_typedef] = ACTIONS(3641),
    [anon_sym_in] = ACTIONS(3641),
    [anon_sym_out] = ACTIONS(3641),
    [anon_sym_inout] = ACTIONS(3641),
    [anon_sym_virtual] = ACTIONS(3641),
    [anon_sym_extern] = ACTIONS(3641),
    [anon_sym___attribute__] = ACTIONS(3641),
    [anon_sym___attribute] = ACTIONS(3641),
    [anon_sym_using] = ACTIONS(3641),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3643),
    [anon_sym___declspec] = ACTIONS(3641),
    [anon_sym___based] = ACTIONS(3641),
    [anon_sym___cdecl] = ACTIONS(3641),
    [anon_sym___clrcall] = ACTIONS(3641),
    [anon_sym___stdcall] = ACTIONS(3641),
    [anon_sym___fastcall] = ACTIONS(3641),
    [anon_sym___thiscall] = ACTIONS(3641),
    [anon_sym___vectorcall] = ACTIONS(3641),
    [anon_sym_LBRACE] = ACTIONS(3643),
    [anon_sym_signed] = ACTIONS(3641),
    [anon_sym_unsigned] = ACTIONS(3641),
    [anon_sym_long] = ACTIONS(3641),
    [anon_sym_short] = ACTIONS(3641),
    [anon_sym_LBRACK] = ACTIONS(3641),
    [anon_sym_static] = ACTIONS(3641),
    [anon_sym_register] = ACTIONS(3641),
    [anon_sym_inline] = ACTIONS(3641),
    [anon_sym___inline] = ACTIONS(3641),
    [anon_sym___inline__] = ACTIONS(3641),
    [anon_sym___forceinline] = ACTIONS(3641),
    [anon_sym_thread_local] = ACTIONS(3641),
    [anon_sym___thread] = ACTIONS(3641),
    [anon_sym_const] = ACTIONS(3641),
    [anon_sym_constexpr] = ACTIONS(3641),
    [anon_sym_volatile] = ACTIONS(3641),
    [anon_sym_restrict] = ACTIONS(3641),
    [anon_sym___restrict__] = ACTIONS(3641),
    [anon_sym__Atomic] = ACTIONS(3641),
    [anon_sym__Noreturn] = ACTIONS(3641),
    [anon_sym_noreturn] = ACTIONS(3641),
    [anon_sym__Nonnull] = ACTIONS(3641),
    [anon_sym_mutable] = ACTIONS(3641),
    [anon_sym_constinit] = ACTIONS(3641),
    [anon_sym_consteval] = ACTIONS(3641),
    [anon_sym_alignas] = ACTIONS(3641),
    [anon_sym__Alignas] = ACTIONS(3641),
    [sym_primitive_type] = ACTIONS(3641),
    [anon_sym_enum] = ACTIONS(3641),
    [anon_sym_class] = ACTIONS(3641),
    [anon_sym_struct] = ACTIONS(3641),
    [anon_sym_union] = ACTIONS(3641),
    [anon_sym_if] = ACTIONS(3641),
    [anon_sym_else] = ACTIONS(3641),
    [anon_sym_switch] = ACTIONS(3641),
    [anon_sym_case] = ACTIONS(3641),
    [anon_sym_default] = ACTIONS(3641),
    [anon_sym_while] = ACTIONS(3641),
    [anon_sym_do] = ACTIONS(3641),
    [anon_sym_for] = ACTIONS(3641),
    [anon_sym_return] = ACTIONS(3641),
    [anon_sym_break] = ACTIONS(3641),
    [anon_sym_continue] = ACTIONS(3641),
    [anon_sym_goto] = ACTIONS(3641),
    [anon_sym___try] = ACTIONS(3641),
    [anon_sym___leave] = ACTIONS(3641),
    [anon_sym_not] = ACTIONS(3641),
    [anon_sym_compl] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3643),
    [anon_sym_PLUS_PLUS] = ACTIONS(3643),
    [anon_sym_sizeof] = ACTIONS(3641),
    [anon_sym___alignof__] = ACTIONS(3641),
    [anon_sym___alignof] = ACTIONS(3641),
    [anon_sym__alignof] = ACTIONS(3641),
    [anon_sym_alignof] = ACTIONS(3641),
    [anon_sym__Alignof] = ACTIONS(3641),
    [anon_sym_offsetof] = ACTIONS(3641),
    [anon_sym__Generic] = ACTIONS(3641),
    [anon_sym_asm] = ACTIONS(3641),
    [anon_sym___asm__] = ACTIONS(3641),
    [anon_sym___asm] = ACTIONS(3641),
    [sym_number_literal] = ACTIONS(3643),
    [anon_sym_L_SQUOTE] = ACTIONS(3643),
    [anon_sym_u_SQUOTE] = ACTIONS(3643),
    [anon_sym_U_SQUOTE] = ACTIONS(3643),
    [anon_sym_u8_SQUOTE] = ACTIONS(3643),
    [anon_sym_SQUOTE] = ACTIONS(3643),
    [anon_sym_L_DQUOTE] = ACTIONS(3643),
    [anon_sym_u_DQUOTE] = ACTIONS(3643),
    [anon_sym_U_DQUOTE] = ACTIONS(3643),
    [anon_sym_u8_DQUOTE] = ACTIONS(3643),
    [anon_sym_DQUOTE] = ACTIONS(3643),
    [sym_true] = ACTIONS(3641),
    [sym_false] = ACTIONS(3641),
    [anon_sym_NULL] = ACTIONS(3641),
    [anon_sym_nullptr] = ACTIONS(3641),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3641),
    [anon_sym_let] = ACTIONS(3641),
    [anon_sym_This] = ACTIONS(3641),
    [anon_sym_decltype] = ACTIONS(3641),
    [anon_sym_explicit] = ACTIONS(3641),
    [anon_sym_typename] = ACTIONS(3641),
    [anon_sym_export] = ACTIONS(3641),
    [anon_sym_module] = ACTIONS(3641),
    [anon_sym_import] = ACTIONS(3641),
    [anon_sym_template] = ACTIONS(3641),
    [anon_sym_operator] = ACTIONS(3641),
    [anon_sym_try] = ACTIONS(3641),
    [anon_sym_delete] = ACTIONS(3641),
    [anon_sym_throw] = ACTIONS(3641),
    [anon_sym_namespace] = ACTIONS(3641),
    [anon_sym_static_assert] = ACTIONS(3641),
    [anon_sym_concept] = ACTIONS(3641),
    [anon_sym_co_return] = ACTIONS(3641),
    [anon_sym_co_yield] = ACTIONS(3641),
    [anon_sym_R_DQUOTE] = ACTIONS(3643),
    [anon_sym_LR_DQUOTE] = ACTIONS(3643),
    [anon_sym_uR_DQUOTE] = ACTIONS(3643),
    [anon_sym_UR_DQUOTE] = ACTIONS(3643),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3643),
    [anon_sym_co_await] = ACTIONS(3641),
    [anon_sym_new] = ACTIONS(3641),
    [anon_sym_requires] = ACTIONS(3641),
    [sym_this] = ACTIONS(3641),
    [anon_sym_discard] = ACTIONS(3641),
    [anon_sym_precise] = ACTIONS(3641),
    [anon_sym_shared] = ACTIONS(3641),
    [anon_sym_groupshared] = ACTIONS(3641),
    [anon_sym_uniform] = ACTIONS(3641),
    [anon_sym_row_major] = ACTIONS(3641),
    [anon_sym_column_major] = ACTIONS(3641),
    [anon_sym_globallycoherent] = ACTIONS(3641),
    [anon_sym_centroid] = ACTIONS(3641),
    [anon_sym_noperspective] = ACTIONS(3641),
    [anon_sym_nointerpolation] = ACTIONS(3641),
    [anon_sym_sample] = ACTIONS(3641),
    [anon_sym_linear] = ACTIONS(3641),
    [anon_sym_snorm] = ACTIONS(3641),
    [anon_sym_unorm] = ACTIONS(3641),
    [anon_sym_point] = ACTIONS(3641),
    [anon_sym_line] = ACTIONS(3641),
    [anon_sym_triangleadj] = ACTIONS(3641),
    [anon_sym_lineadj] = ACTIONS(3641),
    [anon_sym_triangle] = ACTIONS(3641),
    [anon_sym_cbuffer] = ACTIONS(3641),
    [anon_sym_interface] = ACTIONS(3641),
    [anon_sym_extension] = ACTIONS(3641),
    [anon_sym___exported] = ACTIONS(3641),
  },
  [505] = {
    [sym_identifier] = ACTIONS(3558),
    [aux_sym_preproc_include_token1] = ACTIONS(3558),
    [aux_sym_preproc_def_token1] = ACTIONS(3558),
    [aux_sym_preproc_if_token1] = ACTIONS(3558),
    [aux_sym_preproc_if_token2] = ACTIONS(3558),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3558),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3558),
    [aux_sym_preproc_else_token1] = ACTIONS(3558),
    [aux_sym_preproc_elif_token1] = ACTIONS(3558),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3558),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3558),
    [sym_preproc_directive] = ACTIONS(3558),
    [anon_sym_LPAREN2] = ACTIONS(3556),
    [anon_sym_BANG] = ACTIONS(3556),
    [anon_sym_TILDE] = ACTIONS(3556),
    [anon_sym_DASH] = ACTIONS(3558),
    [anon_sym_PLUS] = ACTIONS(3558),
    [anon_sym_STAR] = ACTIONS(3556),
    [anon_sym_AMP_AMP] = ACTIONS(3556),
    [anon_sym_AMP] = ACTIONS(3558),
    [anon_sym_SEMI] = ACTIONS(3556),
    [anon_sym___extension__] = ACTIONS(3558),
    [anon_sym_typedef] = ACTIONS(3558),
    [anon_sym_in] = ACTIONS(3558),
    [anon_sym_out] = ACTIONS(3558),
    [anon_sym_inout] = ACTIONS(3558),
    [anon_sym_virtual] = ACTIONS(3558),
    [anon_sym_extern] = ACTIONS(3558),
    [anon_sym___attribute__] = ACTIONS(3558),
    [anon_sym___attribute] = ACTIONS(3558),
    [anon_sym_using] = ACTIONS(3558),
    [anon_sym_COLON_COLON] = ACTIONS(3556),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3556),
    [anon_sym___declspec] = ACTIONS(3558),
    [anon_sym___based] = ACTIONS(3558),
    [anon_sym___cdecl] = ACTIONS(3558),
    [anon_sym___clrcall] = ACTIONS(3558),
    [anon_sym___stdcall] = ACTIONS(3558),
    [anon_sym___fastcall] = ACTIONS(3558),
    [anon_sym___thiscall] = ACTIONS(3558),
    [anon_sym___vectorcall] = ACTIONS(3558),
    [anon_sym_LBRACE] = ACTIONS(3556),
    [anon_sym_signed] = ACTIONS(3558),
    [anon_sym_unsigned] = ACTIONS(3558),
    [anon_sym_long] = ACTIONS(3558),
    [anon_sym_short] = ACTIONS(3558),
    [anon_sym_LBRACK] = ACTIONS(3558),
    [anon_sym_static] = ACTIONS(3558),
    [anon_sym_register] = ACTIONS(3558),
    [anon_sym_inline] = ACTIONS(3558),
    [anon_sym___inline] = ACTIONS(3558),
    [anon_sym___inline__] = ACTIONS(3558),
    [anon_sym___forceinline] = ACTIONS(3558),
    [anon_sym_thread_local] = ACTIONS(3558),
    [anon_sym___thread] = ACTIONS(3558),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_constexpr] = ACTIONS(3558),
    [anon_sym_volatile] = ACTIONS(3558),
    [anon_sym_restrict] = ACTIONS(3558),
    [anon_sym___restrict__] = ACTIONS(3558),
    [anon_sym__Atomic] = ACTIONS(3558),
    [anon_sym__Noreturn] = ACTIONS(3558),
    [anon_sym_noreturn] = ACTIONS(3558),
    [anon_sym__Nonnull] = ACTIONS(3558),
    [anon_sym_mutable] = ACTIONS(3558),
    [anon_sym_constinit] = ACTIONS(3558),
    [anon_sym_consteval] = ACTIONS(3558),
    [anon_sym_alignas] = ACTIONS(3558),
    [anon_sym__Alignas] = ACTIONS(3558),
    [sym_primitive_type] = ACTIONS(3558),
    [anon_sym_enum] = ACTIONS(3558),
    [anon_sym_class] = ACTIONS(3558),
    [anon_sym_struct] = ACTIONS(3558),
    [anon_sym_union] = ACTIONS(3558),
    [anon_sym_if] = ACTIONS(3558),
    [anon_sym_else] = ACTIONS(3558),
    [anon_sym_switch] = ACTIONS(3558),
    [anon_sym_case] = ACTIONS(3558),
    [anon_sym_default] = ACTIONS(3558),
    [anon_sym_while] = ACTIONS(3558),
    [anon_sym_do] = ACTIONS(3558),
    [anon_sym_for] = ACTIONS(3558),
    [anon_sym_return] = ACTIONS(3558),
    [anon_sym_break] = ACTIONS(3558),
    [anon_sym_continue] = ACTIONS(3558),
    [anon_sym_goto] = ACTIONS(3558),
    [anon_sym___try] = ACTIONS(3558),
    [anon_sym___leave] = ACTIONS(3558),
    [anon_sym_not] = ACTIONS(3558),
    [anon_sym_compl] = ACTIONS(3558),
    [anon_sym_DASH_DASH] = ACTIONS(3556),
    [anon_sym_PLUS_PLUS] = ACTIONS(3556),
    [anon_sym_sizeof] = ACTIONS(3558),
    [anon_sym___alignof__] = ACTIONS(3558),
    [anon_sym___alignof] = ACTIONS(3558),
    [anon_sym__alignof] = ACTIONS(3558),
    [anon_sym_alignof] = ACTIONS(3558),
    [anon_sym__Alignof] = ACTIONS(3558),
    [anon_sym_offsetof] = ACTIONS(3558),
    [anon_sym__Generic] = ACTIONS(3558),
    [anon_sym_asm] = ACTIONS(3558),
    [anon_sym___asm__] = ACTIONS(3558),
    [anon_sym___asm] = ACTIONS(3558),
    [sym_number_literal] = ACTIONS(3556),
    [anon_sym_L_SQUOTE] = ACTIONS(3556),
    [anon_sym_u_SQUOTE] = ACTIONS(3556),
    [anon_sym_U_SQUOTE] = ACTIONS(3556),
    [anon_sym_u8_SQUOTE] = ACTIONS(3556),
    [anon_sym_SQUOTE] = ACTIONS(3556),
    [anon_sym_L_DQUOTE] = ACTIONS(3556),
    [anon_sym_u_DQUOTE] = ACTIONS(3556),
    [anon_sym_U_DQUOTE] = ACTIONS(3556),
    [anon_sym_u8_DQUOTE] = ACTIONS(3556),
    [anon_sym_DQUOTE] = ACTIONS(3556),
    [sym_true] = ACTIONS(3558),
    [sym_false] = ACTIONS(3558),
    [anon_sym_NULL] = ACTIONS(3558),
    [anon_sym_nullptr] = ACTIONS(3558),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3558),
    [anon_sym_let] = ACTIONS(3558),
    [anon_sym_This] = ACTIONS(3558),
    [anon_sym_decltype] = ACTIONS(3558),
    [anon_sym_explicit] = ACTIONS(3558),
    [anon_sym_typename] = ACTIONS(3558),
    [anon_sym_template] = ACTIONS(3558),
    [anon_sym_operator] = ACTIONS(3558),
    [anon_sym_try] = ACTIONS(3558),
    [anon_sym_delete] = ACTIONS(3558),
    [anon_sym_throw] = ACTIONS(3558),
    [anon_sym_namespace] = ACTIONS(3558),
    [anon_sym_static_assert] = ACTIONS(3558),
    [anon_sym_concept] = ACTIONS(3558),
    [anon_sym_co_return] = ACTIONS(3558),
    [anon_sym_co_yield] = ACTIONS(3558),
    [anon_sym_R_DQUOTE] = ACTIONS(3556),
    [anon_sym_LR_DQUOTE] = ACTIONS(3556),
    [anon_sym_uR_DQUOTE] = ACTIONS(3556),
    [anon_sym_UR_DQUOTE] = ACTIONS(3556),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3556),
    [anon_sym_co_await] = ACTIONS(3558),
    [anon_sym_new] = ACTIONS(3558),
    [anon_sym_requires] = ACTIONS(3558),
    [sym_this] = ACTIONS(3558),
    [anon_sym_discard] = ACTIONS(3558),
    [anon_sym_precise] = ACTIONS(3558),
    [anon_sym_shared] = ACTIONS(3558),
    [anon_sym_groupshared] = ACTIONS(3558),
    [anon_sym_uniform] = ACTIONS(3558),
    [anon_sym_row_major] = ACTIONS(3558),
    [anon_sym_column_major] = ACTIONS(3558),
    [anon_sym_globallycoherent] = ACTIONS(3558),
    [anon_sym_centroid] = ACTIONS(3558),
    [anon_sym_noperspective] = ACTIONS(3558),
    [anon_sym_nointerpolation] = ACTIONS(3558),
    [anon_sym_sample] = ACTIONS(3558),
    [anon_sym_linear] = ACTIONS(3558),
    [anon_sym_snorm] = ACTIONS(3558),
    [anon_sym_unorm] = ACTIONS(3558),
    [anon_sym_point] = ACTIONS(3558),
    [anon_sym_line] = ACTIONS(3558),
    [anon_sym_triangleadj] = ACTIONS(3558),
    [anon_sym_lineadj] = ACTIONS(3558),
    [anon_sym_triangle] = ACTIONS(3558),
    [anon_sym_cbuffer] = ACTIONS(3558),
    [anon_sym_interface] = ACTIONS(3558),
    [anon_sym_extension] = ACTIONS(3558),
  },
  [506] = {
    [ts_builtin_sym_end] = ACTIONS(3647),
    [sym_identifier] = ACTIONS(3645),
    [aux_sym_preproc_include_token1] = ACTIONS(3645),
    [aux_sym_preproc_def_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3645),
    [sym_preproc_directive] = ACTIONS(3645),
    [anon_sym_LPAREN2] = ACTIONS(3647),
    [anon_sym_BANG] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3647),
    [anon_sym_DASH] = ACTIONS(3645),
    [anon_sym_PLUS] = ACTIONS(3645),
    [anon_sym_STAR] = ACTIONS(3647),
    [anon_sym_AMP_AMP] = ACTIONS(3647),
    [anon_sym_AMP] = ACTIONS(3645),
    [anon_sym_SEMI] = ACTIONS(3647),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3645),
    [anon_sym_in] = ACTIONS(3645),
    [anon_sym_out] = ACTIONS(3645),
    [anon_sym_inout] = ACTIONS(3645),
    [anon_sym_virtual] = ACTIONS(3645),
    [anon_sym_extern] = ACTIONS(3645),
    [anon_sym___attribute__] = ACTIONS(3645),
    [anon_sym___attribute] = ACTIONS(3645),
    [anon_sym_using] = ACTIONS(3645),
    [anon_sym_COLON_COLON] = ACTIONS(3647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3647),
    [anon_sym___declspec] = ACTIONS(3645),
    [anon_sym___based] = ACTIONS(3645),
    [anon_sym___cdecl] = ACTIONS(3645),
    [anon_sym___clrcall] = ACTIONS(3645),
    [anon_sym___stdcall] = ACTIONS(3645),
    [anon_sym___fastcall] = ACTIONS(3645),
    [anon_sym___thiscall] = ACTIONS(3645),
    [anon_sym___vectorcall] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(3647),
    [anon_sym_signed] = ACTIONS(3645),
    [anon_sym_unsigned] = ACTIONS(3645),
    [anon_sym_long] = ACTIONS(3645),
    [anon_sym_short] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_static] = ACTIONS(3645),
    [anon_sym_register] = ACTIONS(3645),
    [anon_sym_inline] = ACTIONS(3645),
    [anon_sym___inline] = ACTIONS(3645),
    [anon_sym___inline__] = ACTIONS(3645),
    [anon_sym___forceinline] = ACTIONS(3645),
    [anon_sym_thread_local] = ACTIONS(3645),
    [anon_sym___thread] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(3645),
    [anon_sym_constexpr] = ACTIONS(3645),
    [anon_sym_volatile] = ACTIONS(3645),
    [anon_sym_restrict] = ACTIONS(3645),
    [anon_sym___restrict__] = ACTIONS(3645),
    [anon_sym__Atomic] = ACTIONS(3645),
    [anon_sym__Noreturn] = ACTIONS(3645),
    [anon_sym_noreturn] = ACTIONS(3645),
    [anon_sym__Nonnull] = ACTIONS(3645),
    [anon_sym_mutable] = ACTIONS(3645),
    [anon_sym_constinit] = ACTIONS(3645),
    [anon_sym_consteval] = ACTIONS(3645),
    [anon_sym_alignas] = ACTIONS(3645),
    [anon_sym__Alignas] = ACTIONS(3645),
    [sym_primitive_type] = ACTIONS(3645),
    [anon_sym_enum] = ACTIONS(3645),
    [anon_sym_class] = ACTIONS(3645),
    [anon_sym_struct] = ACTIONS(3645),
    [anon_sym_union] = ACTIONS(3645),
    [anon_sym_if] = ACTIONS(3645),
    [anon_sym_else] = ACTIONS(3645),
    [anon_sym_switch] = ACTIONS(3645),
    [anon_sym_case] = ACTIONS(3645),
    [anon_sym_default] = ACTIONS(3645),
    [anon_sym_while] = ACTIONS(3645),
    [anon_sym_do] = ACTIONS(3645),
    [anon_sym_for] = ACTIONS(3645),
    [anon_sym_return] = ACTIONS(3645),
    [anon_sym_break] = ACTIONS(3645),
    [anon_sym_continue] = ACTIONS(3645),
    [anon_sym_goto] = ACTIONS(3645),
    [anon_sym___try] = ACTIONS(3645),
    [anon_sym___leave] = ACTIONS(3645),
    [anon_sym_not] = ACTIONS(3645),
    [anon_sym_compl] = ACTIONS(3645),
    [anon_sym_DASH_DASH] = ACTIONS(3647),
    [anon_sym_PLUS_PLUS] = ACTIONS(3647),
    [anon_sym_sizeof] = ACTIONS(3645),
    [anon_sym___alignof__] = ACTIONS(3645),
    [anon_sym___alignof] = ACTIONS(3645),
    [anon_sym__alignof] = ACTIONS(3645),
    [anon_sym_alignof] = ACTIONS(3645),
    [anon_sym__Alignof] = ACTIONS(3645),
    [anon_sym_offsetof] = ACTIONS(3645),
    [anon_sym__Generic] = ACTIONS(3645),
    [anon_sym_asm] = ACTIONS(3645),
    [anon_sym___asm__] = ACTIONS(3645),
    [anon_sym___asm] = ACTIONS(3645),
    [sym_number_literal] = ACTIONS(3647),
    [anon_sym_L_SQUOTE] = ACTIONS(3647),
    [anon_sym_u_SQUOTE] = ACTIONS(3647),
    [anon_sym_U_SQUOTE] = ACTIONS(3647),
    [anon_sym_u8_SQUOTE] = ACTIONS(3647),
    [anon_sym_SQUOTE] = ACTIONS(3647),
    [anon_sym_L_DQUOTE] = ACTIONS(3647),
    [anon_sym_u_DQUOTE] = ACTIONS(3647),
    [anon_sym_U_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8_DQUOTE] = ACTIONS(3647),
    [anon_sym_DQUOTE] = ACTIONS(3647),
    [sym_true] = ACTIONS(3645),
    [sym_false] = ACTIONS(3645),
    [anon_sym_NULL] = ACTIONS(3645),
    [anon_sym_nullptr] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3645),
    [anon_sym_let] = ACTIONS(3645),
    [anon_sym_This] = ACTIONS(3645),
    [anon_sym_decltype] = ACTIONS(3645),
    [anon_sym_explicit] = ACTIONS(3645),
    [anon_sym_typename] = ACTIONS(3645),
    [anon_sym_export] = ACTIONS(3645),
    [anon_sym_module] = ACTIONS(3645),
    [anon_sym_import] = ACTIONS(3645),
    [anon_sym_template] = ACTIONS(3645),
    [anon_sym_operator] = ACTIONS(3645),
    [anon_sym_try] = ACTIONS(3645),
    [anon_sym_delete] = ACTIONS(3645),
    [anon_sym_throw] = ACTIONS(3645),
    [anon_sym_namespace] = ACTIONS(3645),
    [anon_sym_static_assert] = ACTIONS(3645),
    [anon_sym_concept] = ACTIONS(3645),
    [anon_sym_co_return] = ACTIONS(3645),
    [anon_sym_co_yield] = ACTIONS(3645),
    [anon_sym_R_DQUOTE] = ACTIONS(3647),
    [anon_sym_LR_DQUOTE] = ACTIONS(3647),
    [anon_sym_uR_DQUOTE] = ACTIONS(3647),
    [anon_sym_UR_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3647),
    [anon_sym_co_await] = ACTIONS(3645),
    [anon_sym_new] = ACTIONS(3645),
    [anon_sym_requires] = ACTIONS(3645),
    [sym_this] = ACTIONS(3645),
    [anon_sym_discard] = ACTIONS(3645),
    [anon_sym_precise] = ACTIONS(3645),
    [anon_sym_shared] = ACTIONS(3645),
    [anon_sym_groupshared] = ACTIONS(3645),
    [anon_sym_uniform] = ACTIONS(3645),
    [anon_sym_row_major] = ACTIONS(3645),
    [anon_sym_column_major] = ACTIONS(3645),
    [anon_sym_globallycoherent] = ACTIONS(3645),
    [anon_sym_centroid] = ACTIONS(3645),
    [anon_sym_noperspective] = ACTIONS(3645),
    [anon_sym_nointerpolation] = ACTIONS(3645),
    [anon_sym_sample] = ACTIONS(3645),
    [anon_sym_linear] = ACTIONS(3645),
    [anon_sym_snorm] = ACTIONS(3645),
    [anon_sym_unorm] = ACTIONS(3645),
    [anon_sym_point] = ACTIONS(3645),
    [anon_sym_line] = ACTIONS(3645),
    [anon_sym_triangleadj] = ACTIONS(3645),
    [anon_sym_lineadj] = ACTIONS(3645),
    [anon_sym_triangle] = ACTIONS(3645),
    [anon_sym_cbuffer] = ACTIONS(3645),
    [anon_sym_interface] = ACTIONS(3645),
    [anon_sym_extension] = ACTIONS(3645),
    [anon_sym___exported] = ACTIONS(3645),
  },
  [507] = {
    [ts_builtin_sym_end] = ACTIONS(3651),
    [sym_identifier] = ACTIONS(3649),
    [aux_sym_preproc_include_token1] = ACTIONS(3649),
    [aux_sym_preproc_def_token1] = ACTIONS(3649),
    [aux_sym_preproc_if_token1] = ACTIONS(3649),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3649),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3649),
    [sym_preproc_directive] = ACTIONS(3649),
    [anon_sym_LPAREN2] = ACTIONS(3651),
    [anon_sym_BANG] = ACTIONS(3651),
    [anon_sym_TILDE] = ACTIONS(3651),
    [anon_sym_DASH] = ACTIONS(3649),
    [anon_sym_PLUS] = ACTIONS(3649),
    [anon_sym_STAR] = ACTIONS(3651),
    [anon_sym_AMP_AMP] = ACTIONS(3651),
    [anon_sym_AMP] = ACTIONS(3649),
    [anon_sym_SEMI] = ACTIONS(3651),
    [anon_sym___extension__] = ACTIONS(3649),
    [anon_sym_typedef] = ACTIONS(3649),
    [anon_sym_in] = ACTIONS(3649),
    [anon_sym_out] = ACTIONS(3649),
    [anon_sym_inout] = ACTIONS(3649),
    [anon_sym_virtual] = ACTIONS(3649),
    [anon_sym_extern] = ACTIONS(3649),
    [anon_sym___attribute__] = ACTIONS(3649),
    [anon_sym___attribute] = ACTIONS(3649),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(3651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3651),
    [anon_sym___declspec] = ACTIONS(3649),
    [anon_sym___based] = ACTIONS(3649),
    [anon_sym___cdecl] = ACTIONS(3649),
    [anon_sym___clrcall] = ACTIONS(3649),
    [anon_sym___stdcall] = ACTIONS(3649),
    [anon_sym___fastcall] = ACTIONS(3649),
    [anon_sym___thiscall] = ACTIONS(3649),
    [anon_sym___vectorcall] = ACTIONS(3649),
    [anon_sym_LBRACE] = ACTIONS(3651),
    [anon_sym_signed] = ACTIONS(3649),
    [anon_sym_unsigned] = ACTIONS(3649),
    [anon_sym_long] = ACTIONS(3649),
    [anon_sym_short] = ACTIONS(3649),
    [anon_sym_LBRACK] = ACTIONS(3649),
    [anon_sym_static] = ACTIONS(3649),
    [anon_sym_register] = ACTIONS(3649),
    [anon_sym_inline] = ACTIONS(3649),
    [anon_sym___inline] = ACTIONS(3649),
    [anon_sym___inline__] = ACTIONS(3649),
    [anon_sym___forceinline] = ACTIONS(3649),
    [anon_sym_thread_local] = ACTIONS(3649),
    [anon_sym___thread] = ACTIONS(3649),
    [anon_sym_const] = ACTIONS(3649),
    [anon_sym_constexpr] = ACTIONS(3649),
    [anon_sym_volatile] = ACTIONS(3649),
    [anon_sym_restrict] = ACTIONS(3649),
    [anon_sym___restrict__] = ACTIONS(3649),
    [anon_sym__Atomic] = ACTIONS(3649),
    [anon_sym__Noreturn] = ACTIONS(3649),
    [anon_sym_noreturn] = ACTIONS(3649),
    [anon_sym__Nonnull] = ACTIONS(3649),
    [anon_sym_mutable] = ACTIONS(3649),
    [anon_sym_constinit] = ACTIONS(3649),
    [anon_sym_consteval] = ACTIONS(3649),
    [anon_sym_alignas] = ACTIONS(3649),
    [anon_sym__Alignas] = ACTIONS(3649),
    [sym_primitive_type] = ACTIONS(3649),
    [anon_sym_enum] = ACTIONS(3649),
    [anon_sym_class] = ACTIONS(3649),
    [anon_sym_struct] = ACTIONS(3649),
    [anon_sym_union] = ACTIONS(3649),
    [anon_sym_if] = ACTIONS(3649),
    [anon_sym_else] = ACTIONS(3649),
    [anon_sym_switch] = ACTIONS(3649),
    [anon_sym_case] = ACTIONS(3649),
    [anon_sym_default] = ACTIONS(3649),
    [anon_sym_while] = ACTIONS(3649),
    [anon_sym_do] = ACTIONS(3649),
    [anon_sym_for] = ACTIONS(3649),
    [anon_sym_return] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3649),
    [anon_sym_continue] = ACTIONS(3649),
    [anon_sym_goto] = ACTIONS(3649),
    [anon_sym___try] = ACTIONS(3649),
    [anon_sym___leave] = ACTIONS(3649),
    [anon_sym_not] = ACTIONS(3649),
    [anon_sym_compl] = ACTIONS(3649),
    [anon_sym_DASH_DASH] = ACTIONS(3651),
    [anon_sym_PLUS_PLUS] = ACTIONS(3651),
    [anon_sym_sizeof] = ACTIONS(3649),
    [anon_sym___alignof__] = ACTIONS(3649),
    [anon_sym___alignof] = ACTIONS(3649),
    [anon_sym__alignof] = ACTIONS(3649),
    [anon_sym_alignof] = ACTIONS(3649),
    [anon_sym__Alignof] = ACTIONS(3649),
    [anon_sym_offsetof] = ACTIONS(3649),
    [anon_sym__Generic] = ACTIONS(3649),
    [anon_sym_asm] = ACTIONS(3649),
    [anon_sym___asm__] = ACTIONS(3649),
    [anon_sym___asm] = ACTIONS(3649),
    [sym_number_literal] = ACTIONS(3651),
    [anon_sym_L_SQUOTE] = ACTIONS(3651),
    [anon_sym_u_SQUOTE] = ACTIONS(3651),
    [anon_sym_U_SQUOTE] = ACTIONS(3651),
    [anon_sym_u8_SQUOTE] = ACTIONS(3651),
    [anon_sym_SQUOTE] = ACTIONS(3651),
    [anon_sym_L_DQUOTE] = ACTIONS(3651),
    [anon_sym_u_DQUOTE] = ACTIONS(3651),
    [anon_sym_U_DQUOTE] = ACTIONS(3651),
    [anon_sym_u8_DQUOTE] = ACTIONS(3651),
    [anon_sym_DQUOTE] = ACTIONS(3651),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [anon_sym_NULL] = ACTIONS(3649),
    [anon_sym_nullptr] = ACTIONS(3649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3649),
    [anon_sym_let] = ACTIONS(3649),
    [anon_sym_This] = ACTIONS(3649),
    [anon_sym_decltype] = ACTIONS(3649),
    [anon_sym_explicit] = ACTIONS(3649),
    [anon_sym_typename] = ACTIONS(3649),
    [anon_sym_export] = ACTIONS(3649),
    [anon_sym_module] = ACTIONS(3649),
    [anon_sym_import] = ACTIONS(3649),
    [anon_sym_template] = ACTIONS(3649),
    [anon_sym_operator] = ACTIONS(3649),
    [anon_sym_try] = ACTIONS(3649),
    [anon_sym_delete] = ACTIONS(3649),
    [anon_sym_throw] = ACTIONS(3649),
    [anon_sym_namespace] = ACTIONS(3649),
    [anon_sym_static_assert] = ACTIONS(3649),
    [anon_sym_concept] = ACTIONS(3649),
    [anon_sym_co_return] = ACTIONS(3649),
    [anon_sym_co_yield] = ACTIONS(3649),
    [anon_sym_R_DQUOTE] = ACTIONS(3651),
    [anon_sym_LR_DQUOTE] = ACTIONS(3651),
    [anon_sym_uR_DQUOTE] = ACTIONS(3651),
    [anon_sym_UR_DQUOTE] = ACTIONS(3651),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3651),
    [anon_sym_co_await] = ACTIONS(3649),
    [anon_sym_new] = ACTIONS(3649),
    [anon_sym_requires] = ACTIONS(3649),
    [sym_this] = ACTIONS(3649),
    [anon_sym_discard] = ACTIONS(3649),
    [anon_sym_precise] = ACTIONS(3649),
    [anon_sym_shared] = ACTIONS(3649),
    [anon_sym_groupshared] = ACTIONS(3649),
    [anon_sym_uniform] = ACTIONS(3649),
    [anon_sym_row_major] = ACTIONS(3649),
    [anon_sym_column_major] = ACTIONS(3649),
    [anon_sym_globallycoherent] = ACTIONS(3649),
    [anon_sym_centroid] = ACTIONS(3649),
    [anon_sym_noperspective] = ACTIONS(3649),
    [anon_sym_nointerpolation] = ACTIONS(3649),
    [anon_sym_sample] = ACTIONS(3649),
    [anon_sym_linear] = ACTIONS(3649),
    [anon_sym_snorm] = ACTIONS(3649),
    [anon_sym_unorm] = ACTIONS(3649),
    [anon_sym_point] = ACTIONS(3649),
    [anon_sym_line] = ACTIONS(3649),
    [anon_sym_triangleadj] = ACTIONS(3649),
    [anon_sym_lineadj] = ACTIONS(3649),
    [anon_sym_triangle] = ACTIONS(3649),
    [anon_sym_cbuffer] = ACTIONS(3649),
    [anon_sym_interface] = ACTIONS(3649),
    [anon_sym_extension] = ACTIONS(3649),
    [anon_sym___exported] = ACTIONS(3649),
  },
  [508] = {
    [ts_builtin_sym_end] = ACTIONS(3385),
    [sym_identifier] = ACTIONS(3383),
    [aux_sym_preproc_include_token1] = ACTIONS(3383),
    [aux_sym_preproc_def_token1] = ACTIONS(3383),
    [aux_sym_preproc_if_token1] = ACTIONS(3383),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3383),
    [sym_preproc_directive] = ACTIONS(3383),
    [anon_sym_LPAREN2] = ACTIONS(3385),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_TILDE] = ACTIONS(3385),
    [anon_sym_DASH] = ACTIONS(3383),
    [anon_sym_PLUS] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(3385),
    [anon_sym_AMP_AMP] = ACTIONS(3385),
    [anon_sym_AMP] = ACTIONS(3383),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym___extension__] = ACTIONS(3383),
    [anon_sym_typedef] = ACTIONS(3383),
    [anon_sym_in] = ACTIONS(3383),
    [anon_sym_out] = ACTIONS(3383),
    [anon_sym_inout] = ACTIONS(3383),
    [anon_sym_virtual] = ACTIONS(3383),
    [anon_sym_extern] = ACTIONS(3383),
    [anon_sym___attribute__] = ACTIONS(3383),
    [anon_sym___attribute] = ACTIONS(3383),
    [anon_sym_using] = ACTIONS(3383),
    [anon_sym_COLON_COLON] = ACTIONS(3385),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3385),
    [anon_sym___declspec] = ACTIONS(3383),
    [anon_sym___based] = ACTIONS(3383),
    [anon_sym___cdecl] = ACTIONS(3383),
    [anon_sym___clrcall] = ACTIONS(3383),
    [anon_sym___stdcall] = ACTIONS(3383),
    [anon_sym___fastcall] = ACTIONS(3383),
    [anon_sym___thiscall] = ACTIONS(3383),
    [anon_sym___vectorcall] = ACTIONS(3383),
    [anon_sym_LBRACE] = ACTIONS(3385),
    [anon_sym_signed] = ACTIONS(3383),
    [anon_sym_unsigned] = ACTIONS(3383),
    [anon_sym_long] = ACTIONS(3383),
    [anon_sym_short] = ACTIONS(3383),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_static] = ACTIONS(3383),
    [anon_sym_register] = ACTIONS(3383),
    [anon_sym_inline] = ACTIONS(3383),
    [anon_sym___inline] = ACTIONS(3383),
    [anon_sym___inline__] = ACTIONS(3383),
    [anon_sym___forceinline] = ACTIONS(3383),
    [anon_sym_thread_local] = ACTIONS(3383),
    [anon_sym___thread] = ACTIONS(3383),
    [anon_sym_const] = ACTIONS(3383),
    [anon_sym_constexpr] = ACTIONS(3383),
    [anon_sym_volatile] = ACTIONS(3383),
    [anon_sym_restrict] = ACTIONS(3383),
    [anon_sym___restrict__] = ACTIONS(3383),
    [anon_sym__Atomic] = ACTIONS(3383),
    [anon_sym__Noreturn] = ACTIONS(3383),
    [anon_sym_noreturn] = ACTIONS(3383),
    [anon_sym__Nonnull] = ACTIONS(3383),
    [anon_sym_mutable] = ACTIONS(3383),
    [anon_sym_constinit] = ACTIONS(3383),
    [anon_sym_consteval] = ACTIONS(3383),
    [anon_sym_alignas] = ACTIONS(3383),
    [anon_sym__Alignas] = ACTIONS(3383),
    [sym_primitive_type] = ACTIONS(3383),
    [anon_sym_enum] = ACTIONS(3383),
    [anon_sym_class] = ACTIONS(3383),
    [anon_sym_struct] = ACTIONS(3383),
    [anon_sym_union] = ACTIONS(3383),
    [anon_sym_if] = ACTIONS(3383),
    [anon_sym_else] = ACTIONS(3383),
    [anon_sym_switch] = ACTIONS(3383),
    [anon_sym_case] = ACTIONS(3383),
    [anon_sym_default] = ACTIONS(3383),
    [anon_sym_while] = ACTIONS(3383),
    [anon_sym_do] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3383),
    [anon_sym_return] = ACTIONS(3383),
    [anon_sym_break] = ACTIONS(3383),
    [anon_sym_continue] = ACTIONS(3383),
    [anon_sym_goto] = ACTIONS(3383),
    [anon_sym___try] = ACTIONS(3383),
    [anon_sym___leave] = ACTIONS(3383),
    [anon_sym_not] = ACTIONS(3383),
    [anon_sym_compl] = ACTIONS(3383),
    [anon_sym_DASH_DASH] = ACTIONS(3385),
    [anon_sym_PLUS_PLUS] = ACTIONS(3385),
    [anon_sym_sizeof] = ACTIONS(3383),
    [anon_sym___alignof__] = ACTIONS(3383),
    [anon_sym___alignof] = ACTIONS(3383),
    [anon_sym__alignof] = ACTIONS(3383),
    [anon_sym_alignof] = ACTIONS(3383),
    [anon_sym__Alignof] = ACTIONS(3383),
    [anon_sym_offsetof] = ACTIONS(3383),
    [anon_sym__Generic] = ACTIONS(3383),
    [anon_sym_asm] = ACTIONS(3383),
    [anon_sym___asm__] = ACTIONS(3383),
    [anon_sym___asm] = ACTIONS(3383),
    [sym_number_literal] = ACTIONS(3385),
    [anon_sym_L_SQUOTE] = ACTIONS(3385),
    [anon_sym_u_SQUOTE] = ACTIONS(3385),
    [anon_sym_U_SQUOTE] = ACTIONS(3385),
    [anon_sym_u8_SQUOTE] = ACTIONS(3385),
    [anon_sym_SQUOTE] = ACTIONS(3385),
    [anon_sym_L_DQUOTE] = ACTIONS(3385),
    [anon_sym_u_DQUOTE] = ACTIONS(3385),
    [anon_sym_U_DQUOTE] = ACTIONS(3385),
    [anon_sym_u8_DQUOTE] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(3385),
    [sym_true] = ACTIONS(3383),
    [sym_false] = ACTIONS(3383),
    [anon_sym_NULL] = ACTIONS(3383),
    [anon_sym_nullptr] = ACTIONS(3383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3383),
    [anon_sym_let] = ACTIONS(3383),
    [anon_sym_This] = ACTIONS(3383),
    [anon_sym_decltype] = ACTIONS(3383),
    [anon_sym_explicit] = ACTIONS(3383),
    [anon_sym_typename] = ACTIONS(3383),
    [anon_sym_export] = ACTIONS(3383),
    [anon_sym_module] = ACTIONS(3383),
    [anon_sym_import] = ACTIONS(3383),
    [anon_sym_template] = ACTIONS(3383),
    [anon_sym_operator] = ACTIONS(3383),
    [anon_sym_try] = ACTIONS(3383),
    [anon_sym_delete] = ACTIONS(3383),
    [anon_sym_throw] = ACTIONS(3383),
    [anon_sym_namespace] = ACTIONS(3383),
    [anon_sym_static_assert] = ACTIONS(3383),
    [anon_sym_concept] = ACTIONS(3383),
    [anon_sym_co_return] = ACTIONS(3383),
    [anon_sym_co_yield] = ACTIONS(3383),
    [anon_sym_R_DQUOTE] = ACTIONS(3385),
    [anon_sym_LR_DQUOTE] = ACTIONS(3385),
    [anon_sym_uR_DQUOTE] = ACTIONS(3385),
    [anon_sym_UR_DQUOTE] = ACTIONS(3385),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3385),
    [anon_sym_co_await] = ACTIONS(3383),
    [anon_sym_new] = ACTIONS(3383),
    [anon_sym_requires] = ACTIONS(3383),
    [sym_this] = ACTIONS(3383),
    [anon_sym_discard] = ACTIONS(3383),
    [anon_sym_precise] = ACTIONS(3383),
    [anon_sym_shared] = ACTIONS(3383),
    [anon_sym_groupshared] = ACTIONS(3383),
    [anon_sym_uniform] = ACTIONS(3383),
    [anon_sym_row_major] = ACTIONS(3383),
    [anon_sym_column_major] = ACTIONS(3383),
    [anon_sym_globallycoherent] = ACTIONS(3383),
    [anon_sym_centroid] = ACTIONS(3383),
    [anon_sym_noperspective] = ACTIONS(3383),
    [anon_sym_nointerpolation] = ACTIONS(3383),
    [anon_sym_sample] = ACTIONS(3383),
    [anon_sym_linear] = ACTIONS(3383),
    [anon_sym_snorm] = ACTIONS(3383),
    [anon_sym_unorm] = ACTIONS(3383),
    [anon_sym_point] = ACTIONS(3383),
    [anon_sym_line] = ACTIONS(3383),
    [anon_sym_triangleadj] = ACTIONS(3383),
    [anon_sym_lineadj] = ACTIONS(3383),
    [anon_sym_triangle] = ACTIONS(3383),
    [anon_sym_cbuffer] = ACTIONS(3383),
    [anon_sym_interface] = ACTIONS(3383),
    [anon_sym_extension] = ACTIONS(3383),
    [anon_sym___exported] = ACTIONS(3383),
  },
  [509] = {
    [ts_builtin_sym_end] = ACTIONS(3389),
    [sym_identifier] = ACTIONS(3387),
    [aux_sym_preproc_include_token1] = ACTIONS(3387),
    [aux_sym_preproc_def_token1] = ACTIONS(3387),
    [aux_sym_preproc_if_token1] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3387),
    [sym_preproc_directive] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_BANG] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_STAR] = ACTIONS(3389),
    [anon_sym_AMP_AMP] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_SEMI] = ACTIONS(3389),
    [anon_sym___extension__] = ACTIONS(3387),
    [anon_sym_typedef] = ACTIONS(3387),
    [anon_sym_in] = ACTIONS(3387),
    [anon_sym_out] = ACTIONS(3387),
    [anon_sym_inout] = ACTIONS(3387),
    [anon_sym_virtual] = ACTIONS(3387),
    [anon_sym_extern] = ACTIONS(3387),
    [anon_sym___attribute__] = ACTIONS(3387),
    [anon_sym___attribute] = ACTIONS(3387),
    [anon_sym_using] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3389),
    [anon_sym___declspec] = ACTIONS(3387),
    [anon_sym___based] = ACTIONS(3387),
    [anon_sym___cdecl] = ACTIONS(3387),
    [anon_sym___clrcall] = ACTIONS(3387),
    [anon_sym___stdcall] = ACTIONS(3387),
    [anon_sym___fastcall] = ACTIONS(3387),
    [anon_sym___thiscall] = ACTIONS(3387),
    [anon_sym___vectorcall] = ACTIONS(3387),
    [anon_sym_LBRACE] = ACTIONS(3389),
    [anon_sym_signed] = ACTIONS(3387),
    [anon_sym_unsigned] = ACTIONS(3387),
    [anon_sym_long] = ACTIONS(3387),
    [anon_sym_short] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_register] = ACTIONS(3387),
    [anon_sym_inline] = ACTIONS(3387),
    [anon_sym___inline] = ACTIONS(3387),
    [anon_sym___inline__] = ACTIONS(3387),
    [anon_sym___forceinline] = ACTIONS(3387),
    [anon_sym_thread_local] = ACTIONS(3387),
    [anon_sym___thread] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_constexpr] = ACTIONS(3387),
    [anon_sym_volatile] = ACTIONS(3387),
    [anon_sym_restrict] = ACTIONS(3387),
    [anon_sym___restrict__] = ACTIONS(3387),
    [anon_sym__Atomic] = ACTIONS(3387),
    [anon_sym__Noreturn] = ACTIONS(3387),
    [anon_sym_noreturn] = ACTIONS(3387),
    [anon_sym__Nonnull] = ACTIONS(3387),
    [anon_sym_mutable] = ACTIONS(3387),
    [anon_sym_constinit] = ACTIONS(3387),
    [anon_sym_consteval] = ACTIONS(3387),
    [anon_sym_alignas] = ACTIONS(3387),
    [anon_sym__Alignas] = ACTIONS(3387),
    [sym_primitive_type] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [anon_sym_class] = ACTIONS(3387),
    [anon_sym_struct] = ACTIONS(3387),
    [anon_sym_union] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_else] = ACTIONS(3387),
    [anon_sym_switch] = ACTIONS(3387),
    [anon_sym_case] = ACTIONS(3387),
    [anon_sym_default] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_break] = ACTIONS(3387),
    [anon_sym_continue] = ACTIONS(3387),
    [anon_sym_goto] = ACTIONS(3387),
    [anon_sym___try] = ACTIONS(3387),
    [anon_sym___leave] = ACTIONS(3387),
    [anon_sym_not] = ACTIONS(3387),
    [anon_sym_compl] = ACTIONS(3387),
    [anon_sym_DASH_DASH] = ACTIONS(3389),
    [anon_sym_PLUS_PLUS] = ACTIONS(3389),
    [anon_sym_sizeof] = ACTIONS(3387),
    [anon_sym___alignof__] = ACTIONS(3387),
    [anon_sym___alignof] = ACTIONS(3387),
    [anon_sym__alignof] = ACTIONS(3387),
    [anon_sym_alignof] = ACTIONS(3387),
    [anon_sym__Alignof] = ACTIONS(3387),
    [anon_sym_offsetof] = ACTIONS(3387),
    [anon_sym__Generic] = ACTIONS(3387),
    [anon_sym_asm] = ACTIONS(3387),
    [anon_sym___asm__] = ACTIONS(3387),
    [anon_sym___asm] = ACTIONS(3387),
    [sym_number_literal] = ACTIONS(3389),
    [anon_sym_L_SQUOTE] = ACTIONS(3389),
    [anon_sym_u_SQUOTE] = ACTIONS(3389),
    [anon_sym_U_SQUOTE] = ACTIONS(3389),
    [anon_sym_u8_SQUOTE] = ACTIONS(3389),
    [anon_sym_SQUOTE] = ACTIONS(3389),
    [anon_sym_L_DQUOTE] = ACTIONS(3389),
    [anon_sym_u_DQUOTE] = ACTIONS(3389),
    [anon_sym_U_DQUOTE] = ACTIONS(3389),
    [anon_sym_u8_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE] = ACTIONS(3389),
    [sym_true] = ACTIONS(3387),
    [sym_false] = ACTIONS(3387),
    [anon_sym_NULL] = ACTIONS(3387),
    [anon_sym_nullptr] = ACTIONS(3387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_This] = ACTIONS(3387),
    [anon_sym_decltype] = ACTIONS(3387),
    [anon_sym_explicit] = ACTIONS(3387),
    [anon_sym_typename] = ACTIONS(3387),
    [anon_sym_export] = ACTIONS(3387),
    [anon_sym_module] = ACTIONS(3387),
    [anon_sym_import] = ACTIONS(3387),
    [anon_sym_template] = ACTIONS(3387),
    [anon_sym_operator] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_delete] = ACTIONS(3387),
    [anon_sym_throw] = ACTIONS(3387),
    [anon_sym_namespace] = ACTIONS(3387),
    [anon_sym_static_assert] = ACTIONS(3387),
    [anon_sym_concept] = ACTIONS(3387),
    [anon_sym_co_return] = ACTIONS(3387),
    [anon_sym_co_yield] = ACTIONS(3387),
    [anon_sym_R_DQUOTE] = ACTIONS(3389),
    [anon_sym_LR_DQUOTE] = ACTIONS(3389),
    [anon_sym_uR_DQUOTE] = ACTIONS(3389),
    [anon_sym_UR_DQUOTE] = ACTIONS(3389),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3389),
    [anon_sym_co_await] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_requires] = ACTIONS(3387),
    [sym_this] = ACTIONS(3387),
    [anon_sym_discard] = ACTIONS(3387),
    [anon_sym_precise] = ACTIONS(3387),
    [anon_sym_shared] = ACTIONS(3387),
    [anon_sym_groupshared] = ACTIONS(3387),
    [anon_sym_uniform] = ACTIONS(3387),
    [anon_sym_row_major] = ACTIONS(3387),
    [anon_sym_column_major] = ACTIONS(3387),
    [anon_sym_globallycoherent] = ACTIONS(3387),
    [anon_sym_centroid] = ACTIONS(3387),
    [anon_sym_noperspective] = ACTIONS(3387),
    [anon_sym_nointerpolation] = ACTIONS(3387),
    [anon_sym_sample] = ACTIONS(3387),
    [anon_sym_linear] = ACTIONS(3387),
    [anon_sym_snorm] = ACTIONS(3387),
    [anon_sym_unorm] = ACTIONS(3387),
    [anon_sym_point] = ACTIONS(3387),
    [anon_sym_line] = ACTIONS(3387),
    [anon_sym_triangleadj] = ACTIONS(3387),
    [anon_sym_lineadj] = ACTIONS(3387),
    [anon_sym_triangle] = ACTIONS(3387),
    [anon_sym_cbuffer] = ACTIONS(3387),
    [anon_sym_interface] = ACTIONS(3387),
    [anon_sym_extension] = ACTIONS(3387),
    [anon_sym___exported] = ACTIONS(3387),
  },
  [510] = {
    [ts_builtin_sym_end] = ACTIONS(3393),
    [sym_identifier] = ACTIONS(3391),
    [aux_sym_preproc_include_token1] = ACTIONS(3391),
    [aux_sym_preproc_def_token1] = ACTIONS(3391),
    [aux_sym_preproc_if_token1] = ACTIONS(3391),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3391),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3391),
    [sym_preproc_directive] = ACTIONS(3391),
    [anon_sym_LPAREN2] = ACTIONS(3393),
    [anon_sym_BANG] = ACTIONS(3393),
    [anon_sym_TILDE] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_STAR] = ACTIONS(3393),
    [anon_sym_AMP_AMP] = ACTIONS(3393),
    [anon_sym_AMP] = ACTIONS(3391),
    [anon_sym_SEMI] = ACTIONS(3393),
    [anon_sym___extension__] = ACTIONS(3391),
    [anon_sym_typedef] = ACTIONS(3391),
    [anon_sym_in] = ACTIONS(3391),
    [anon_sym_out] = ACTIONS(3391),
    [anon_sym_inout] = ACTIONS(3391),
    [anon_sym_virtual] = ACTIONS(3391),
    [anon_sym_extern] = ACTIONS(3391),
    [anon_sym___attribute__] = ACTIONS(3391),
    [anon_sym___attribute] = ACTIONS(3391),
    [anon_sym_using] = ACTIONS(3391),
    [anon_sym_COLON_COLON] = ACTIONS(3393),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3393),
    [anon_sym___declspec] = ACTIONS(3391),
    [anon_sym___based] = ACTIONS(3391),
    [anon_sym___cdecl] = ACTIONS(3391),
    [anon_sym___clrcall] = ACTIONS(3391),
    [anon_sym___stdcall] = ACTIONS(3391),
    [anon_sym___fastcall] = ACTIONS(3391),
    [anon_sym___thiscall] = ACTIONS(3391),
    [anon_sym___vectorcall] = ACTIONS(3391),
    [anon_sym_LBRACE] = ACTIONS(3393),
    [anon_sym_signed] = ACTIONS(3391),
    [anon_sym_unsigned] = ACTIONS(3391),
    [anon_sym_long] = ACTIONS(3391),
    [anon_sym_short] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(3391),
    [anon_sym_static] = ACTIONS(3391),
    [anon_sym_register] = ACTIONS(3391),
    [anon_sym_inline] = ACTIONS(3391),
    [anon_sym___inline] = ACTIONS(3391),
    [anon_sym___inline__] = ACTIONS(3391),
    [anon_sym___forceinline] = ACTIONS(3391),
    [anon_sym_thread_local] = ACTIONS(3391),
    [anon_sym___thread] = ACTIONS(3391),
    [anon_sym_const] = ACTIONS(3391),
    [anon_sym_constexpr] = ACTIONS(3391),
    [anon_sym_volatile] = ACTIONS(3391),
    [anon_sym_restrict] = ACTIONS(3391),
    [anon_sym___restrict__] = ACTIONS(3391),
    [anon_sym__Atomic] = ACTIONS(3391),
    [anon_sym__Noreturn] = ACTIONS(3391),
    [anon_sym_noreturn] = ACTIONS(3391),
    [anon_sym__Nonnull] = ACTIONS(3391),
    [anon_sym_mutable] = ACTIONS(3391),
    [anon_sym_constinit] = ACTIONS(3391),
    [anon_sym_consteval] = ACTIONS(3391),
    [anon_sym_alignas] = ACTIONS(3391),
    [anon_sym__Alignas] = ACTIONS(3391),
    [sym_primitive_type] = ACTIONS(3391),
    [anon_sym_enum] = ACTIONS(3391),
    [anon_sym_class] = ACTIONS(3391),
    [anon_sym_struct] = ACTIONS(3391),
    [anon_sym_union] = ACTIONS(3391),
    [anon_sym_if] = ACTIONS(3391),
    [anon_sym_else] = ACTIONS(3391),
    [anon_sym_switch] = ACTIONS(3391),
    [anon_sym_case] = ACTIONS(3391),
    [anon_sym_default] = ACTIONS(3391),
    [anon_sym_while] = ACTIONS(3391),
    [anon_sym_do] = ACTIONS(3391),
    [anon_sym_for] = ACTIONS(3391),
    [anon_sym_return] = ACTIONS(3391),
    [anon_sym_break] = ACTIONS(3391),
    [anon_sym_continue] = ACTIONS(3391),
    [anon_sym_goto] = ACTIONS(3391),
    [anon_sym___try] = ACTIONS(3391),
    [anon_sym___leave] = ACTIONS(3391),
    [anon_sym_not] = ACTIONS(3391),
    [anon_sym_compl] = ACTIONS(3391),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_sizeof] = ACTIONS(3391),
    [anon_sym___alignof__] = ACTIONS(3391),
    [anon_sym___alignof] = ACTIONS(3391),
    [anon_sym__alignof] = ACTIONS(3391),
    [anon_sym_alignof] = ACTIONS(3391),
    [anon_sym__Alignof] = ACTIONS(3391),
    [anon_sym_offsetof] = ACTIONS(3391),
    [anon_sym__Generic] = ACTIONS(3391),
    [anon_sym_asm] = ACTIONS(3391),
    [anon_sym___asm__] = ACTIONS(3391),
    [anon_sym___asm] = ACTIONS(3391),
    [sym_number_literal] = ACTIONS(3393),
    [anon_sym_L_SQUOTE] = ACTIONS(3393),
    [anon_sym_u_SQUOTE] = ACTIONS(3393),
    [anon_sym_U_SQUOTE] = ACTIONS(3393),
    [anon_sym_u8_SQUOTE] = ACTIONS(3393),
    [anon_sym_SQUOTE] = ACTIONS(3393),
    [anon_sym_L_DQUOTE] = ACTIONS(3393),
    [anon_sym_u_DQUOTE] = ACTIONS(3393),
    [anon_sym_U_DQUOTE] = ACTIONS(3393),
    [anon_sym_u8_DQUOTE] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3393),
    [sym_true] = ACTIONS(3391),
    [sym_false] = ACTIONS(3391),
    [anon_sym_NULL] = ACTIONS(3391),
    [anon_sym_nullptr] = ACTIONS(3391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3391),
    [anon_sym_let] = ACTIONS(3391),
    [anon_sym_This] = ACTIONS(3391),
    [anon_sym_decltype] = ACTIONS(3391),
    [anon_sym_explicit] = ACTIONS(3391),
    [anon_sym_typename] = ACTIONS(3391),
    [anon_sym_export] = ACTIONS(3391),
    [anon_sym_module] = ACTIONS(3391),
    [anon_sym_import] = ACTIONS(3391),
    [anon_sym_template] = ACTIONS(3391),
    [anon_sym_operator] = ACTIONS(3391),
    [anon_sym_try] = ACTIONS(3391),
    [anon_sym_delete] = ACTIONS(3391),
    [anon_sym_throw] = ACTIONS(3391),
    [anon_sym_namespace] = ACTIONS(3391),
    [anon_sym_static_assert] = ACTIONS(3391),
    [anon_sym_concept] = ACTIONS(3391),
    [anon_sym_co_return] = ACTIONS(3391),
    [anon_sym_co_yield] = ACTIONS(3391),
    [anon_sym_R_DQUOTE] = ACTIONS(3393),
    [anon_sym_LR_DQUOTE] = ACTIONS(3393),
    [anon_sym_uR_DQUOTE] = ACTIONS(3393),
    [anon_sym_UR_DQUOTE] = ACTIONS(3393),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3393),
    [anon_sym_co_await] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(3391),
    [anon_sym_requires] = ACTIONS(3391),
    [sym_this] = ACTIONS(3391),
    [anon_sym_discard] = ACTIONS(3391),
    [anon_sym_precise] = ACTIONS(3391),
    [anon_sym_shared] = ACTIONS(3391),
    [anon_sym_groupshared] = ACTIONS(3391),
    [anon_sym_uniform] = ACTIONS(3391),
    [anon_sym_row_major] = ACTIONS(3391),
    [anon_sym_column_major] = ACTIONS(3391),
    [anon_sym_globallycoherent] = ACTIONS(3391),
    [anon_sym_centroid] = ACTIONS(3391),
    [anon_sym_noperspective] = ACTIONS(3391),
    [anon_sym_nointerpolation] = ACTIONS(3391),
    [anon_sym_sample] = ACTIONS(3391),
    [anon_sym_linear] = ACTIONS(3391),
    [anon_sym_snorm] = ACTIONS(3391),
    [anon_sym_unorm] = ACTIONS(3391),
    [anon_sym_point] = ACTIONS(3391),
    [anon_sym_line] = ACTIONS(3391),
    [anon_sym_triangleadj] = ACTIONS(3391),
    [anon_sym_lineadj] = ACTIONS(3391),
    [anon_sym_triangle] = ACTIONS(3391),
    [anon_sym_cbuffer] = ACTIONS(3391),
    [anon_sym_interface] = ACTIONS(3391),
    [anon_sym_extension] = ACTIONS(3391),
    [anon_sym___exported] = ACTIONS(3391),
  },
  [511] = {
    [sym_expression] = STATE(5382),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(3343),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(3349),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3354),
    [anon_sym___extension__] = ACTIONS(3357),
    [anon_sym_typedef] = ACTIONS(3657),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3370),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3373),
    [anon_sym_explicit] = ACTIONS(3362),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3376),
    [anon_sym_operator] = ACTIONS(3362),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [512] = {
    [ts_builtin_sym_end] = ACTIONS(3397),
    [sym_identifier] = ACTIONS(3395),
    [aux_sym_preproc_include_token1] = ACTIONS(3395),
    [aux_sym_preproc_def_token1] = ACTIONS(3395),
    [aux_sym_preproc_if_token1] = ACTIONS(3395),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3395),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3395),
    [sym_preproc_directive] = ACTIONS(3395),
    [anon_sym_LPAREN2] = ACTIONS(3397),
    [anon_sym_BANG] = ACTIONS(3397),
    [anon_sym_TILDE] = ACTIONS(3397),
    [anon_sym_DASH] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3395),
    [anon_sym_STAR] = ACTIONS(3397),
    [anon_sym_AMP_AMP] = ACTIONS(3397),
    [anon_sym_AMP] = ACTIONS(3395),
    [anon_sym_SEMI] = ACTIONS(3397),
    [anon_sym___extension__] = ACTIONS(3395),
    [anon_sym_typedef] = ACTIONS(3395),
    [anon_sym_in] = ACTIONS(3395),
    [anon_sym_out] = ACTIONS(3395),
    [anon_sym_inout] = ACTIONS(3395),
    [anon_sym_virtual] = ACTIONS(3395),
    [anon_sym_extern] = ACTIONS(3395),
    [anon_sym___attribute__] = ACTIONS(3395),
    [anon_sym___attribute] = ACTIONS(3395),
    [anon_sym_using] = ACTIONS(3395),
    [anon_sym_COLON_COLON] = ACTIONS(3397),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3397),
    [anon_sym___declspec] = ACTIONS(3395),
    [anon_sym___based] = ACTIONS(3395),
    [anon_sym___cdecl] = ACTIONS(3395),
    [anon_sym___clrcall] = ACTIONS(3395),
    [anon_sym___stdcall] = ACTIONS(3395),
    [anon_sym___fastcall] = ACTIONS(3395),
    [anon_sym___thiscall] = ACTIONS(3395),
    [anon_sym___vectorcall] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3397),
    [anon_sym_signed] = ACTIONS(3395),
    [anon_sym_unsigned] = ACTIONS(3395),
    [anon_sym_long] = ACTIONS(3395),
    [anon_sym_short] = ACTIONS(3395),
    [anon_sym_LBRACK] = ACTIONS(3395),
    [anon_sym_static] = ACTIONS(3395),
    [anon_sym_register] = ACTIONS(3395),
    [anon_sym_inline] = ACTIONS(3395),
    [anon_sym___inline] = ACTIONS(3395),
    [anon_sym___inline__] = ACTIONS(3395),
    [anon_sym___forceinline] = ACTIONS(3395),
    [anon_sym_thread_local] = ACTIONS(3395),
    [anon_sym___thread] = ACTIONS(3395),
    [anon_sym_const] = ACTIONS(3395),
    [anon_sym_constexpr] = ACTIONS(3395),
    [anon_sym_volatile] = ACTIONS(3395),
    [anon_sym_restrict] = ACTIONS(3395),
    [anon_sym___restrict__] = ACTIONS(3395),
    [anon_sym__Atomic] = ACTIONS(3395),
    [anon_sym__Noreturn] = ACTIONS(3395),
    [anon_sym_noreturn] = ACTIONS(3395),
    [anon_sym__Nonnull] = ACTIONS(3395),
    [anon_sym_mutable] = ACTIONS(3395),
    [anon_sym_constinit] = ACTIONS(3395),
    [anon_sym_consteval] = ACTIONS(3395),
    [anon_sym_alignas] = ACTIONS(3395),
    [anon_sym__Alignas] = ACTIONS(3395),
    [sym_primitive_type] = ACTIONS(3395),
    [anon_sym_enum] = ACTIONS(3395),
    [anon_sym_class] = ACTIONS(3395),
    [anon_sym_struct] = ACTIONS(3395),
    [anon_sym_union] = ACTIONS(3395),
    [anon_sym_if] = ACTIONS(3395),
    [anon_sym_else] = ACTIONS(3395),
    [anon_sym_switch] = ACTIONS(3395),
    [anon_sym_case] = ACTIONS(3395),
    [anon_sym_default] = ACTIONS(3395),
    [anon_sym_while] = ACTIONS(3395),
    [anon_sym_do] = ACTIONS(3395),
    [anon_sym_for] = ACTIONS(3395),
    [anon_sym_return] = ACTIONS(3395),
    [anon_sym_break] = ACTIONS(3395),
    [anon_sym_continue] = ACTIONS(3395),
    [anon_sym_goto] = ACTIONS(3395),
    [anon_sym___try] = ACTIONS(3395),
    [anon_sym___leave] = ACTIONS(3395),
    [anon_sym_not] = ACTIONS(3395),
    [anon_sym_compl] = ACTIONS(3395),
    [anon_sym_DASH_DASH] = ACTIONS(3397),
    [anon_sym_PLUS_PLUS] = ACTIONS(3397),
    [anon_sym_sizeof] = ACTIONS(3395),
    [anon_sym___alignof__] = ACTIONS(3395),
    [anon_sym___alignof] = ACTIONS(3395),
    [anon_sym__alignof] = ACTIONS(3395),
    [anon_sym_alignof] = ACTIONS(3395),
    [anon_sym__Alignof] = ACTIONS(3395),
    [anon_sym_offsetof] = ACTIONS(3395),
    [anon_sym__Generic] = ACTIONS(3395),
    [anon_sym_asm] = ACTIONS(3395),
    [anon_sym___asm__] = ACTIONS(3395),
    [anon_sym___asm] = ACTIONS(3395),
    [sym_number_literal] = ACTIONS(3397),
    [anon_sym_L_SQUOTE] = ACTIONS(3397),
    [anon_sym_u_SQUOTE] = ACTIONS(3397),
    [anon_sym_U_SQUOTE] = ACTIONS(3397),
    [anon_sym_u8_SQUOTE] = ACTIONS(3397),
    [anon_sym_SQUOTE] = ACTIONS(3397),
    [anon_sym_L_DQUOTE] = ACTIONS(3397),
    [anon_sym_u_DQUOTE] = ACTIONS(3397),
    [anon_sym_U_DQUOTE] = ACTIONS(3397),
    [anon_sym_u8_DQUOTE] = ACTIONS(3397),
    [anon_sym_DQUOTE] = ACTIONS(3397),
    [sym_true] = ACTIONS(3395),
    [sym_false] = ACTIONS(3395),
    [anon_sym_NULL] = ACTIONS(3395),
    [anon_sym_nullptr] = ACTIONS(3395),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3395),
    [anon_sym_let] = ACTIONS(3395),
    [anon_sym_This] = ACTIONS(3395),
    [anon_sym_decltype] = ACTIONS(3395),
    [anon_sym_explicit] = ACTIONS(3395),
    [anon_sym_typename] = ACTIONS(3395),
    [anon_sym_export] = ACTIONS(3395),
    [anon_sym_module] = ACTIONS(3395),
    [anon_sym_import] = ACTIONS(3395),
    [anon_sym_template] = ACTIONS(3395),
    [anon_sym_operator] = ACTIONS(3395),
    [anon_sym_try] = ACTIONS(3395),
    [anon_sym_delete] = ACTIONS(3395),
    [anon_sym_throw] = ACTIONS(3395),
    [anon_sym_namespace] = ACTIONS(3395),
    [anon_sym_static_assert] = ACTIONS(3395),
    [anon_sym_concept] = ACTIONS(3395),
    [anon_sym_co_return] = ACTIONS(3395),
    [anon_sym_co_yield] = ACTIONS(3395),
    [anon_sym_R_DQUOTE] = ACTIONS(3397),
    [anon_sym_LR_DQUOTE] = ACTIONS(3397),
    [anon_sym_uR_DQUOTE] = ACTIONS(3397),
    [anon_sym_UR_DQUOTE] = ACTIONS(3397),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3397),
    [anon_sym_co_await] = ACTIONS(3395),
    [anon_sym_new] = ACTIONS(3395),
    [anon_sym_requires] = ACTIONS(3395),
    [sym_this] = ACTIONS(3395),
    [anon_sym_discard] = ACTIONS(3395),
    [anon_sym_precise] = ACTIONS(3395),
    [anon_sym_shared] = ACTIONS(3395),
    [anon_sym_groupshared] = ACTIONS(3395),
    [anon_sym_uniform] = ACTIONS(3395),
    [anon_sym_row_major] = ACTIONS(3395),
    [anon_sym_column_major] = ACTIONS(3395),
    [anon_sym_globallycoherent] = ACTIONS(3395),
    [anon_sym_centroid] = ACTIONS(3395),
    [anon_sym_noperspective] = ACTIONS(3395),
    [anon_sym_nointerpolation] = ACTIONS(3395),
    [anon_sym_sample] = ACTIONS(3395),
    [anon_sym_linear] = ACTIONS(3395),
    [anon_sym_snorm] = ACTIONS(3395),
    [anon_sym_unorm] = ACTIONS(3395),
    [anon_sym_point] = ACTIONS(3395),
    [anon_sym_line] = ACTIONS(3395),
    [anon_sym_triangleadj] = ACTIONS(3395),
    [anon_sym_lineadj] = ACTIONS(3395),
    [anon_sym_triangle] = ACTIONS(3395),
    [anon_sym_cbuffer] = ACTIONS(3395),
    [anon_sym_interface] = ACTIONS(3395),
    [anon_sym_extension] = ACTIONS(3395),
    [anon_sym___exported] = ACTIONS(3395),
  },
  [513] = {
    [ts_builtin_sym_end] = ACTIONS(3413),
    [sym_identifier] = ACTIONS(3411),
    [aux_sym_preproc_include_token1] = ACTIONS(3411),
    [aux_sym_preproc_def_token1] = ACTIONS(3411),
    [aux_sym_preproc_if_token1] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3411),
    [sym_preproc_directive] = ACTIONS(3411),
    [anon_sym_LPAREN2] = ACTIONS(3413),
    [anon_sym_BANG] = ACTIONS(3413),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_DASH] = ACTIONS(3411),
    [anon_sym_PLUS] = ACTIONS(3411),
    [anon_sym_STAR] = ACTIONS(3413),
    [anon_sym_AMP_AMP] = ACTIONS(3413),
    [anon_sym_AMP] = ACTIONS(3411),
    [anon_sym_SEMI] = ACTIONS(3413),
    [anon_sym___extension__] = ACTIONS(3411),
    [anon_sym_typedef] = ACTIONS(3411),
    [anon_sym_in] = ACTIONS(3411),
    [anon_sym_out] = ACTIONS(3411),
    [anon_sym_inout] = ACTIONS(3411),
    [anon_sym_virtual] = ACTIONS(3411),
    [anon_sym_extern] = ACTIONS(3411),
    [anon_sym___attribute__] = ACTIONS(3411),
    [anon_sym___attribute] = ACTIONS(3411),
    [anon_sym_using] = ACTIONS(3411),
    [anon_sym_COLON_COLON] = ACTIONS(3413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3413),
    [anon_sym___declspec] = ACTIONS(3411),
    [anon_sym___based] = ACTIONS(3411),
    [anon_sym___cdecl] = ACTIONS(3411),
    [anon_sym___clrcall] = ACTIONS(3411),
    [anon_sym___stdcall] = ACTIONS(3411),
    [anon_sym___fastcall] = ACTIONS(3411),
    [anon_sym___thiscall] = ACTIONS(3411),
    [anon_sym___vectorcall] = ACTIONS(3411),
    [anon_sym_LBRACE] = ACTIONS(3413),
    [anon_sym_signed] = ACTIONS(3411),
    [anon_sym_unsigned] = ACTIONS(3411),
    [anon_sym_long] = ACTIONS(3411),
    [anon_sym_short] = ACTIONS(3411),
    [anon_sym_LBRACK] = ACTIONS(3411),
    [anon_sym_static] = ACTIONS(3411),
    [anon_sym_register] = ACTIONS(3411),
    [anon_sym_inline] = ACTIONS(3411),
    [anon_sym___inline] = ACTIONS(3411),
    [anon_sym___inline__] = ACTIONS(3411),
    [anon_sym___forceinline] = ACTIONS(3411),
    [anon_sym_thread_local] = ACTIONS(3411),
    [anon_sym___thread] = ACTIONS(3411),
    [anon_sym_const] = ACTIONS(3411),
    [anon_sym_constexpr] = ACTIONS(3411),
    [anon_sym_volatile] = ACTIONS(3411),
    [anon_sym_restrict] = ACTIONS(3411),
    [anon_sym___restrict__] = ACTIONS(3411),
    [anon_sym__Atomic] = ACTIONS(3411),
    [anon_sym__Noreturn] = ACTIONS(3411),
    [anon_sym_noreturn] = ACTIONS(3411),
    [anon_sym__Nonnull] = ACTIONS(3411),
    [anon_sym_mutable] = ACTIONS(3411),
    [anon_sym_constinit] = ACTIONS(3411),
    [anon_sym_consteval] = ACTIONS(3411),
    [anon_sym_alignas] = ACTIONS(3411),
    [anon_sym__Alignas] = ACTIONS(3411),
    [sym_primitive_type] = ACTIONS(3411),
    [anon_sym_enum] = ACTIONS(3411),
    [anon_sym_class] = ACTIONS(3411),
    [anon_sym_struct] = ACTIONS(3411),
    [anon_sym_union] = ACTIONS(3411),
    [anon_sym_if] = ACTIONS(3411),
    [anon_sym_else] = ACTIONS(3411),
    [anon_sym_switch] = ACTIONS(3411),
    [anon_sym_case] = ACTIONS(3411),
    [anon_sym_default] = ACTIONS(3411),
    [anon_sym_while] = ACTIONS(3411),
    [anon_sym_do] = ACTIONS(3411),
    [anon_sym_for] = ACTIONS(3411),
    [anon_sym_return] = ACTIONS(3411),
    [anon_sym_break] = ACTIONS(3411),
    [anon_sym_continue] = ACTIONS(3411),
    [anon_sym_goto] = ACTIONS(3411),
    [anon_sym___try] = ACTIONS(3411),
    [anon_sym___leave] = ACTIONS(3411),
    [anon_sym_not] = ACTIONS(3411),
    [anon_sym_compl] = ACTIONS(3411),
    [anon_sym_DASH_DASH] = ACTIONS(3413),
    [anon_sym_PLUS_PLUS] = ACTIONS(3413),
    [anon_sym_sizeof] = ACTIONS(3411),
    [anon_sym___alignof__] = ACTIONS(3411),
    [anon_sym___alignof] = ACTIONS(3411),
    [anon_sym__alignof] = ACTIONS(3411),
    [anon_sym_alignof] = ACTIONS(3411),
    [anon_sym__Alignof] = ACTIONS(3411),
    [anon_sym_offsetof] = ACTIONS(3411),
    [anon_sym__Generic] = ACTIONS(3411),
    [anon_sym_asm] = ACTIONS(3411),
    [anon_sym___asm__] = ACTIONS(3411),
    [anon_sym___asm] = ACTIONS(3411),
    [sym_number_literal] = ACTIONS(3413),
    [anon_sym_L_SQUOTE] = ACTIONS(3413),
    [anon_sym_u_SQUOTE] = ACTIONS(3413),
    [anon_sym_U_SQUOTE] = ACTIONS(3413),
    [anon_sym_u8_SQUOTE] = ACTIONS(3413),
    [anon_sym_SQUOTE] = ACTIONS(3413),
    [anon_sym_L_DQUOTE] = ACTIONS(3413),
    [anon_sym_u_DQUOTE] = ACTIONS(3413),
    [anon_sym_U_DQUOTE] = ACTIONS(3413),
    [anon_sym_u8_DQUOTE] = ACTIONS(3413),
    [anon_sym_DQUOTE] = ACTIONS(3413),
    [sym_true] = ACTIONS(3411),
    [sym_false] = ACTIONS(3411),
    [anon_sym_NULL] = ACTIONS(3411),
    [anon_sym_nullptr] = ACTIONS(3411),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3411),
    [anon_sym_let] = ACTIONS(3411),
    [anon_sym_This] = ACTIONS(3411),
    [anon_sym_decltype] = ACTIONS(3411),
    [anon_sym_explicit] = ACTIONS(3411),
    [anon_sym_typename] = ACTIONS(3411),
    [anon_sym_export] = ACTIONS(3411),
    [anon_sym_module] = ACTIONS(3411),
    [anon_sym_import] = ACTIONS(3411),
    [anon_sym_template] = ACTIONS(3411),
    [anon_sym_operator] = ACTIONS(3411),
    [anon_sym_try] = ACTIONS(3411),
    [anon_sym_delete] = ACTIONS(3411),
    [anon_sym_throw] = ACTIONS(3411),
    [anon_sym_namespace] = ACTIONS(3411),
    [anon_sym_static_assert] = ACTIONS(3411),
    [anon_sym_concept] = ACTIONS(3411),
    [anon_sym_co_return] = ACTIONS(3411),
    [anon_sym_co_yield] = ACTIONS(3411),
    [anon_sym_R_DQUOTE] = ACTIONS(3413),
    [anon_sym_LR_DQUOTE] = ACTIONS(3413),
    [anon_sym_uR_DQUOTE] = ACTIONS(3413),
    [anon_sym_UR_DQUOTE] = ACTIONS(3413),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3413),
    [anon_sym_co_await] = ACTIONS(3411),
    [anon_sym_new] = ACTIONS(3411),
    [anon_sym_requires] = ACTIONS(3411),
    [sym_this] = ACTIONS(3411),
    [anon_sym_discard] = ACTIONS(3411),
    [anon_sym_precise] = ACTIONS(3411),
    [anon_sym_shared] = ACTIONS(3411),
    [anon_sym_groupshared] = ACTIONS(3411),
    [anon_sym_uniform] = ACTIONS(3411),
    [anon_sym_row_major] = ACTIONS(3411),
    [anon_sym_column_major] = ACTIONS(3411),
    [anon_sym_globallycoherent] = ACTIONS(3411),
    [anon_sym_centroid] = ACTIONS(3411),
    [anon_sym_noperspective] = ACTIONS(3411),
    [anon_sym_nointerpolation] = ACTIONS(3411),
    [anon_sym_sample] = ACTIONS(3411),
    [anon_sym_linear] = ACTIONS(3411),
    [anon_sym_snorm] = ACTIONS(3411),
    [anon_sym_unorm] = ACTIONS(3411),
    [anon_sym_point] = ACTIONS(3411),
    [anon_sym_line] = ACTIONS(3411),
    [anon_sym_triangleadj] = ACTIONS(3411),
    [anon_sym_lineadj] = ACTIONS(3411),
    [anon_sym_triangle] = ACTIONS(3411),
    [anon_sym_cbuffer] = ACTIONS(3411),
    [anon_sym_interface] = ACTIONS(3411),
    [anon_sym_extension] = ACTIONS(3411),
    [anon_sym___exported] = ACTIONS(3411),
  },
  [514] = {
    [sym_identifier] = ACTIONS(3631),
    [aux_sym_preproc_include_token1] = ACTIONS(3631),
    [aux_sym_preproc_def_token1] = ACTIONS(3631),
    [aux_sym_preproc_if_token1] = ACTIONS(3631),
    [aux_sym_preproc_if_token2] = ACTIONS(3631),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3631),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3631),
    [aux_sym_preproc_else_token1] = ACTIONS(3631),
    [aux_sym_preproc_elif_token1] = ACTIONS(3631),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3631),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3631),
    [sym_preproc_directive] = ACTIONS(3631),
    [anon_sym_LPAREN2] = ACTIONS(3629),
    [anon_sym_BANG] = ACTIONS(3629),
    [anon_sym_TILDE] = ACTIONS(3629),
    [anon_sym_DASH] = ACTIONS(3631),
    [anon_sym_PLUS] = ACTIONS(3631),
    [anon_sym_STAR] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_AMP] = ACTIONS(3631),
    [anon_sym_SEMI] = ACTIONS(3629),
    [anon_sym___extension__] = ACTIONS(3631),
    [anon_sym_typedef] = ACTIONS(3631),
    [anon_sym_in] = ACTIONS(3631),
    [anon_sym_out] = ACTIONS(3631),
    [anon_sym_inout] = ACTIONS(3631),
    [anon_sym_virtual] = ACTIONS(3631),
    [anon_sym_extern] = ACTIONS(3631),
    [anon_sym___attribute__] = ACTIONS(3631),
    [anon_sym___attribute] = ACTIONS(3631),
    [anon_sym_using] = ACTIONS(3631),
    [anon_sym_COLON_COLON] = ACTIONS(3629),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3629),
    [anon_sym___declspec] = ACTIONS(3631),
    [anon_sym___based] = ACTIONS(3631),
    [anon_sym___cdecl] = ACTIONS(3631),
    [anon_sym___clrcall] = ACTIONS(3631),
    [anon_sym___stdcall] = ACTIONS(3631),
    [anon_sym___fastcall] = ACTIONS(3631),
    [anon_sym___thiscall] = ACTIONS(3631),
    [anon_sym___vectorcall] = ACTIONS(3631),
    [anon_sym_LBRACE] = ACTIONS(3629),
    [anon_sym_signed] = ACTIONS(3631),
    [anon_sym_unsigned] = ACTIONS(3631),
    [anon_sym_long] = ACTIONS(3631),
    [anon_sym_short] = ACTIONS(3631),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_static] = ACTIONS(3631),
    [anon_sym_register] = ACTIONS(3631),
    [anon_sym_inline] = ACTIONS(3631),
    [anon_sym___inline] = ACTIONS(3631),
    [anon_sym___inline__] = ACTIONS(3631),
    [anon_sym___forceinline] = ACTIONS(3631),
    [anon_sym_thread_local] = ACTIONS(3631),
    [anon_sym___thread] = ACTIONS(3631),
    [anon_sym_const] = ACTIONS(3631),
    [anon_sym_constexpr] = ACTIONS(3631),
    [anon_sym_volatile] = ACTIONS(3631),
    [anon_sym_restrict] = ACTIONS(3631),
    [anon_sym___restrict__] = ACTIONS(3631),
    [anon_sym__Atomic] = ACTIONS(3631),
    [anon_sym__Noreturn] = ACTIONS(3631),
    [anon_sym_noreturn] = ACTIONS(3631),
    [anon_sym__Nonnull] = ACTIONS(3631),
    [anon_sym_mutable] = ACTIONS(3631),
    [anon_sym_constinit] = ACTIONS(3631),
    [anon_sym_consteval] = ACTIONS(3631),
    [anon_sym_alignas] = ACTIONS(3631),
    [anon_sym__Alignas] = ACTIONS(3631),
    [sym_primitive_type] = ACTIONS(3631),
    [anon_sym_enum] = ACTIONS(3631),
    [anon_sym_class] = ACTIONS(3631),
    [anon_sym_struct] = ACTIONS(3631),
    [anon_sym_union] = ACTIONS(3631),
    [anon_sym_if] = ACTIONS(3631),
    [anon_sym_else] = ACTIONS(3631),
    [anon_sym_switch] = ACTIONS(3631),
    [anon_sym_case] = ACTIONS(3631),
    [anon_sym_default] = ACTIONS(3631),
    [anon_sym_while] = ACTIONS(3631),
    [anon_sym_do] = ACTIONS(3631),
    [anon_sym_for] = ACTIONS(3631),
    [anon_sym_return] = ACTIONS(3631),
    [anon_sym_break] = ACTIONS(3631),
    [anon_sym_continue] = ACTIONS(3631),
    [anon_sym_goto] = ACTIONS(3631),
    [anon_sym___try] = ACTIONS(3631),
    [anon_sym___leave] = ACTIONS(3631),
    [anon_sym_not] = ACTIONS(3631),
    [anon_sym_compl] = ACTIONS(3631),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_sizeof] = ACTIONS(3631),
    [anon_sym___alignof__] = ACTIONS(3631),
    [anon_sym___alignof] = ACTIONS(3631),
    [anon_sym__alignof] = ACTIONS(3631),
    [anon_sym_alignof] = ACTIONS(3631),
    [anon_sym__Alignof] = ACTIONS(3631),
    [anon_sym_offsetof] = ACTIONS(3631),
    [anon_sym__Generic] = ACTIONS(3631),
    [anon_sym_asm] = ACTIONS(3631),
    [anon_sym___asm__] = ACTIONS(3631),
    [anon_sym___asm] = ACTIONS(3631),
    [sym_number_literal] = ACTIONS(3629),
    [anon_sym_L_SQUOTE] = ACTIONS(3629),
    [anon_sym_u_SQUOTE] = ACTIONS(3629),
    [anon_sym_U_SQUOTE] = ACTIONS(3629),
    [anon_sym_u8_SQUOTE] = ACTIONS(3629),
    [anon_sym_SQUOTE] = ACTIONS(3629),
    [anon_sym_L_DQUOTE] = ACTIONS(3629),
    [anon_sym_u_DQUOTE] = ACTIONS(3629),
    [anon_sym_U_DQUOTE] = ACTIONS(3629),
    [anon_sym_u8_DQUOTE] = ACTIONS(3629),
    [anon_sym_DQUOTE] = ACTIONS(3629),
    [sym_true] = ACTIONS(3631),
    [sym_false] = ACTIONS(3631),
    [anon_sym_NULL] = ACTIONS(3631),
    [anon_sym_nullptr] = ACTIONS(3631),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3631),
    [anon_sym_let] = ACTIONS(3631),
    [anon_sym_This] = ACTIONS(3631),
    [anon_sym_decltype] = ACTIONS(3631),
    [anon_sym_explicit] = ACTIONS(3631),
    [anon_sym_typename] = ACTIONS(3631),
    [anon_sym_template] = ACTIONS(3631),
    [anon_sym_operator] = ACTIONS(3631),
    [anon_sym_try] = ACTIONS(3631),
    [anon_sym_delete] = ACTIONS(3631),
    [anon_sym_throw] = ACTIONS(3631),
    [anon_sym_namespace] = ACTIONS(3631),
    [anon_sym_static_assert] = ACTIONS(3631),
    [anon_sym_concept] = ACTIONS(3631),
    [anon_sym_co_return] = ACTIONS(3631),
    [anon_sym_co_yield] = ACTIONS(3631),
    [anon_sym_R_DQUOTE] = ACTIONS(3629),
    [anon_sym_LR_DQUOTE] = ACTIONS(3629),
    [anon_sym_uR_DQUOTE] = ACTIONS(3629),
    [anon_sym_UR_DQUOTE] = ACTIONS(3629),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3629),
    [anon_sym_co_await] = ACTIONS(3631),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3631),
    [sym_this] = ACTIONS(3631),
    [anon_sym_discard] = ACTIONS(3631),
    [anon_sym_precise] = ACTIONS(3631),
    [anon_sym_shared] = ACTIONS(3631),
    [anon_sym_groupshared] = ACTIONS(3631),
    [anon_sym_uniform] = ACTIONS(3631),
    [anon_sym_row_major] = ACTIONS(3631),
    [anon_sym_column_major] = ACTIONS(3631),
    [anon_sym_globallycoherent] = ACTIONS(3631),
    [anon_sym_centroid] = ACTIONS(3631),
    [anon_sym_noperspective] = ACTIONS(3631),
    [anon_sym_nointerpolation] = ACTIONS(3631),
    [anon_sym_sample] = ACTIONS(3631),
    [anon_sym_linear] = ACTIONS(3631),
    [anon_sym_snorm] = ACTIONS(3631),
    [anon_sym_unorm] = ACTIONS(3631),
    [anon_sym_point] = ACTIONS(3631),
    [anon_sym_line] = ACTIONS(3631),
    [anon_sym_triangleadj] = ACTIONS(3631),
    [anon_sym_lineadj] = ACTIONS(3631),
    [anon_sym_triangle] = ACTIONS(3631),
    [anon_sym_cbuffer] = ACTIONS(3631),
    [anon_sym_interface] = ACTIONS(3631),
    [anon_sym_extension] = ACTIONS(3631),
  },
  [515] = {
    [sym_identifier] = ACTIONS(3635),
    [aux_sym_preproc_include_token1] = ACTIONS(3635),
    [aux_sym_preproc_def_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token2] = ACTIONS(3635),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3635),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3635),
    [aux_sym_preproc_else_token1] = ACTIONS(3635),
    [aux_sym_preproc_elif_token1] = ACTIONS(3635),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3635),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3635),
    [sym_preproc_directive] = ACTIONS(3635),
    [anon_sym_LPAREN2] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_TILDE] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3635),
    [anon_sym_PLUS] = ACTIONS(3635),
    [anon_sym_STAR] = ACTIONS(3633),
    [anon_sym_AMP_AMP] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_SEMI] = ACTIONS(3633),
    [anon_sym___extension__] = ACTIONS(3635),
    [anon_sym_typedef] = ACTIONS(3635),
    [anon_sym_in] = ACTIONS(3635),
    [anon_sym_out] = ACTIONS(3635),
    [anon_sym_inout] = ACTIONS(3635),
    [anon_sym_virtual] = ACTIONS(3635),
    [anon_sym_extern] = ACTIONS(3635),
    [anon_sym___attribute__] = ACTIONS(3635),
    [anon_sym___attribute] = ACTIONS(3635),
    [anon_sym_using] = ACTIONS(3635),
    [anon_sym_COLON_COLON] = ACTIONS(3633),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3633),
    [anon_sym___declspec] = ACTIONS(3635),
    [anon_sym___based] = ACTIONS(3635),
    [anon_sym___cdecl] = ACTIONS(3635),
    [anon_sym___clrcall] = ACTIONS(3635),
    [anon_sym___stdcall] = ACTIONS(3635),
    [anon_sym___fastcall] = ACTIONS(3635),
    [anon_sym___thiscall] = ACTIONS(3635),
    [anon_sym___vectorcall] = ACTIONS(3635),
    [anon_sym_LBRACE] = ACTIONS(3633),
    [anon_sym_signed] = ACTIONS(3635),
    [anon_sym_unsigned] = ACTIONS(3635),
    [anon_sym_long] = ACTIONS(3635),
    [anon_sym_short] = ACTIONS(3635),
    [anon_sym_LBRACK] = ACTIONS(3635),
    [anon_sym_static] = ACTIONS(3635),
    [anon_sym_register] = ACTIONS(3635),
    [anon_sym_inline] = ACTIONS(3635),
    [anon_sym___inline] = ACTIONS(3635),
    [anon_sym___inline__] = ACTIONS(3635),
    [anon_sym___forceinline] = ACTIONS(3635),
    [anon_sym_thread_local] = ACTIONS(3635),
    [anon_sym___thread] = ACTIONS(3635),
    [anon_sym_const] = ACTIONS(3635),
    [anon_sym_constexpr] = ACTIONS(3635),
    [anon_sym_volatile] = ACTIONS(3635),
    [anon_sym_restrict] = ACTIONS(3635),
    [anon_sym___restrict__] = ACTIONS(3635),
    [anon_sym__Atomic] = ACTIONS(3635),
    [anon_sym__Noreturn] = ACTIONS(3635),
    [anon_sym_noreturn] = ACTIONS(3635),
    [anon_sym__Nonnull] = ACTIONS(3635),
    [anon_sym_mutable] = ACTIONS(3635),
    [anon_sym_constinit] = ACTIONS(3635),
    [anon_sym_consteval] = ACTIONS(3635),
    [anon_sym_alignas] = ACTIONS(3635),
    [anon_sym__Alignas] = ACTIONS(3635),
    [sym_primitive_type] = ACTIONS(3635),
    [anon_sym_enum] = ACTIONS(3635),
    [anon_sym_class] = ACTIONS(3635),
    [anon_sym_struct] = ACTIONS(3635),
    [anon_sym_union] = ACTIONS(3635),
    [anon_sym_if] = ACTIONS(3635),
    [anon_sym_else] = ACTIONS(3635),
    [anon_sym_switch] = ACTIONS(3635),
    [anon_sym_case] = ACTIONS(3635),
    [anon_sym_default] = ACTIONS(3635),
    [anon_sym_while] = ACTIONS(3635),
    [anon_sym_do] = ACTIONS(3635),
    [anon_sym_for] = ACTIONS(3635),
    [anon_sym_return] = ACTIONS(3635),
    [anon_sym_break] = ACTIONS(3635),
    [anon_sym_continue] = ACTIONS(3635),
    [anon_sym_goto] = ACTIONS(3635),
    [anon_sym___try] = ACTIONS(3635),
    [anon_sym___leave] = ACTIONS(3635),
    [anon_sym_not] = ACTIONS(3635),
    [anon_sym_compl] = ACTIONS(3635),
    [anon_sym_DASH_DASH] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3633),
    [anon_sym_sizeof] = ACTIONS(3635),
    [anon_sym___alignof__] = ACTIONS(3635),
    [anon_sym___alignof] = ACTIONS(3635),
    [anon_sym__alignof] = ACTIONS(3635),
    [anon_sym_alignof] = ACTIONS(3635),
    [anon_sym__Alignof] = ACTIONS(3635),
    [anon_sym_offsetof] = ACTIONS(3635),
    [anon_sym__Generic] = ACTIONS(3635),
    [anon_sym_asm] = ACTIONS(3635),
    [anon_sym___asm__] = ACTIONS(3635),
    [anon_sym___asm] = ACTIONS(3635),
    [sym_number_literal] = ACTIONS(3633),
    [anon_sym_L_SQUOTE] = ACTIONS(3633),
    [anon_sym_u_SQUOTE] = ACTIONS(3633),
    [anon_sym_U_SQUOTE] = ACTIONS(3633),
    [anon_sym_u8_SQUOTE] = ACTIONS(3633),
    [anon_sym_SQUOTE] = ACTIONS(3633),
    [anon_sym_L_DQUOTE] = ACTIONS(3633),
    [anon_sym_u_DQUOTE] = ACTIONS(3633),
    [anon_sym_U_DQUOTE] = ACTIONS(3633),
    [anon_sym_u8_DQUOTE] = ACTIONS(3633),
    [anon_sym_DQUOTE] = ACTIONS(3633),
    [sym_true] = ACTIONS(3635),
    [sym_false] = ACTIONS(3635),
    [anon_sym_NULL] = ACTIONS(3635),
    [anon_sym_nullptr] = ACTIONS(3635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3635),
    [anon_sym_let] = ACTIONS(3635),
    [anon_sym_This] = ACTIONS(3635),
    [anon_sym_decltype] = ACTIONS(3635),
    [anon_sym_explicit] = ACTIONS(3635),
    [anon_sym_typename] = ACTIONS(3635),
    [anon_sym_template] = ACTIONS(3635),
    [anon_sym_operator] = ACTIONS(3635),
    [anon_sym_try] = ACTIONS(3635),
    [anon_sym_delete] = ACTIONS(3635),
    [anon_sym_throw] = ACTIONS(3635),
    [anon_sym_namespace] = ACTIONS(3635),
    [anon_sym_static_assert] = ACTIONS(3635),
    [anon_sym_concept] = ACTIONS(3635),
    [anon_sym_co_return] = ACTIONS(3635),
    [anon_sym_co_yield] = ACTIONS(3635),
    [anon_sym_R_DQUOTE] = ACTIONS(3633),
    [anon_sym_LR_DQUOTE] = ACTIONS(3633),
    [anon_sym_uR_DQUOTE] = ACTIONS(3633),
    [anon_sym_UR_DQUOTE] = ACTIONS(3633),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3633),
    [anon_sym_co_await] = ACTIONS(3635),
    [anon_sym_new] = ACTIONS(3635),
    [anon_sym_requires] = ACTIONS(3635),
    [sym_this] = ACTIONS(3635),
    [anon_sym_discard] = ACTIONS(3635),
    [anon_sym_precise] = ACTIONS(3635),
    [anon_sym_shared] = ACTIONS(3635),
    [anon_sym_groupshared] = ACTIONS(3635),
    [anon_sym_uniform] = ACTIONS(3635),
    [anon_sym_row_major] = ACTIONS(3635),
    [anon_sym_column_major] = ACTIONS(3635),
    [anon_sym_globallycoherent] = ACTIONS(3635),
    [anon_sym_centroid] = ACTIONS(3635),
    [anon_sym_noperspective] = ACTIONS(3635),
    [anon_sym_nointerpolation] = ACTIONS(3635),
    [anon_sym_sample] = ACTIONS(3635),
    [anon_sym_linear] = ACTIONS(3635),
    [anon_sym_snorm] = ACTIONS(3635),
    [anon_sym_unorm] = ACTIONS(3635),
    [anon_sym_point] = ACTIONS(3635),
    [anon_sym_line] = ACTIONS(3635),
    [anon_sym_triangleadj] = ACTIONS(3635),
    [anon_sym_lineadj] = ACTIONS(3635),
    [anon_sym_triangle] = ACTIONS(3635),
    [anon_sym_cbuffer] = ACTIONS(3635),
    [anon_sym_interface] = ACTIONS(3635),
    [anon_sym_extension] = ACTIONS(3635),
  },
  [516] = {
    [sym_identifier] = ACTIONS(3627),
    [aux_sym_preproc_include_token1] = ACTIONS(3627),
    [aux_sym_preproc_def_token1] = ACTIONS(3627),
    [aux_sym_preproc_if_token1] = ACTIONS(3627),
    [aux_sym_preproc_if_token2] = ACTIONS(3627),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3627),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3627),
    [aux_sym_preproc_else_token1] = ACTIONS(3627),
    [aux_sym_preproc_elif_token1] = ACTIONS(3627),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3627),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3627),
    [sym_preproc_directive] = ACTIONS(3627),
    [anon_sym_LPAREN2] = ACTIONS(3625),
    [anon_sym_BANG] = ACTIONS(3625),
    [anon_sym_TILDE] = ACTIONS(3625),
    [anon_sym_DASH] = ACTIONS(3627),
    [anon_sym_PLUS] = ACTIONS(3627),
    [anon_sym_STAR] = ACTIONS(3625),
    [anon_sym_AMP_AMP] = ACTIONS(3625),
    [anon_sym_AMP] = ACTIONS(3627),
    [anon_sym_SEMI] = ACTIONS(3625),
    [anon_sym___extension__] = ACTIONS(3627),
    [anon_sym_typedef] = ACTIONS(3627),
    [anon_sym_in] = ACTIONS(3627),
    [anon_sym_out] = ACTIONS(3627),
    [anon_sym_inout] = ACTIONS(3627),
    [anon_sym_virtual] = ACTIONS(3627),
    [anon_sym_extern] = ACTIONS(3627),
    [anon_sym___attribute__] = ACTIONS(3627),
    [anon_sym___attribute] = ACTIONS(3627),
    [anon_sym_using] = ACTIONS(3627),
    [anon_sym_COLON_COLON] = ACTIONS(3625),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3625),
    [anon_sym___declspec] = ACTIONS(3627),
    [anon_sym___based] = ACTIONS(3627),
    [anon_sym___cdecl] = ACTIONS(3627),
    [anon_sym___clrcall] = ACTIONS(3627),
    [anon_sym___stdcall] = ACTIONS(3627),
    [anon_sym___fastcall] = ACTIONS(3627),
    [anon_sym___thiscall] = ACTIONS(3627),
    [anon_sym___vectorcall] = ACTIONS(3627),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_signed] = ACTIONS(3627),
    [anon_sym_unsigned] = ACTIONS(3627),
    [anon_sym_long] = ACTIONS(3627),
    [anon_sym_short] = ACTIONS(3627),
    [anon_sym_LBRACK] = ACTIONS(3627),
    [anon_sym_static] = ACTIONS(3627),
    [anon_sym_register] = ACTIONS(3627),
    [anon_sym_inline] = ACTIONS(3627),
    [anon_sym___inline] = ACTIONS(3627),
    [anon_sym___inline__] = ACTIONS(3627),
    [anon_sym___forceinline] = ACTIONS(3627),
    [anon_sym_thread_local] = ACTIONS(3627),
    [anon_sym___thread] = ACTIONS(3627),
    [anon_sym_const] = ACTIONS(3627),
    [anon_sym_constexpr] = ACTIONS(3627),
    [anon_sym_volatile] = ACTIONS(3627),
    [anon_sym_restrict] = ACTIONS(3627),
    [anon_sym___restrict__] = ACTIONS(3627),
    [anon_sym__Atomic] = ACTIONS(3627),
    [anon_sym__Noreturn] = ACTIONS(3627),
    [anon_sym_noreturn] = ACTIONS(3627),
    [anon_sym__Nonnull] = ACTIONS(3627),
    [anon_sym_mutable] = ACTIONS(3627),
    [anon_sym_constinit] = ACTIONS(3627),
    [anon_sym_consteval] = ACTIONS(3627),
    [anon_sym_alignas] = ACTIONS(3627),
    [anon_sym__Alignas] = ACTIONS(3627),
    [sym_primitive_type] = ACTIONS(3627),
    [anon_sym_enum] = ACTIONS(3627),
    [anon_sym_class] = ACTIONS(3627),
    [anon_sym_struct] = ACTIONS(3627),
    [anon_sym_union] = ACTIONS(3627),
    [anon_sym_if] = ACTIONS(3627),
    [anon_sym_else] = ACTIONS(3627),
    [anon_sym_switch] = ACTIONS(3627),
    [anon_sym_case] = ACTIONS(3627),
    [anon_sym_default] = ACTIONS(3627),
    [anon_sym_while] = ACTIONS(3627),
    [anon_sym_do] = ACTIONS(3627),
    [anon_sym_for] = ACTIONS(3627),
    [anon_sym_return] = ACTIONS(3627),
    [anon_sym_break] = ACTIONS(3627),
    [anon_sym_continue] = ACTIONS(3627),
    [anon_sym_goto] = ACTIONS(3627),
    [anon_sym___try] = ACTIONS(3627),
    [anon_sym___leave] = ACTIONS(3627),
    [anon_sym_not] = ACTIONS(3627),
    [anon_sym_compl] = ACTIONS(3627),
    [anon_sym_DASH_DASH] = ACTIONS(3625),
    [anon_sym_PLUS_PLUS] = ACTIONS(3625),
    [anon_sym_sizeof] = ACTIONS(3627),
    [anon_sym___alignof__] = ACTIONS(3627),
    [anon_sym___alignof] = ACTIONS(3627),
    [anon_sym__alignof] = ACTIONS(3627),
    [anon_sym_alignof] = ACTIONS(3627),
    [anon_sym__Alignof] = ACTIONS(3627),
    [anon_sym_offsetof] = ACTIONS(3627),
    [anon_sym__Generic] = ACTIONS(3627),
    [anon_sym_asm] = ACTIONS(3627),
    [anon_sym___asm__] = ACTIONS(3627),
    [anon_sym___asm] = ACTIONS(3627),
    [sym_number_literal] = ACTIONS(3625),
    [anon_sym_L_SQUOTE] = ACTIONS(3625),
    [anon_sym_u_SQUOTE] = ACTIONS(3625),
    [anon_sym_U_SQUOTE] = ACTIONS(3625),
    [anon_sym_u8_SQUOTE] = ACTIONS(3625),
    [anon_sym_SQUOTE] = ACTIONS(3625),
    [anon_sym_L_DQUOTE] = ACTIONS(3625),
    [anon_sym_u_DQUOTE] = ACTIONS(3625),
    [anon_sym_U_DQUOTE] = ACTIONS(3625),
    [anon_sym_u8_DQUOTE] = ACTIONS(3625),
    [anon_sym_DQUOTE] = ACTIONS(3625),
    [sym_true] = ACTIONS(3627),
    [sym_false] = ACTIONS(3627),
    [anon_sym_NULL] = ACTIONS(3627),
    [anon_sym_nullptr] = ACTIONS(3627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3627),
    [anon_sym_let] = ACTIONS(3627),
    [anon_sym_This] = ACTIONS(3627),
    [anon_sym_decltype] = ACTIONS(3627),
    [anon_sym_explicit] = ACTIONS(3627),
    [anon_sym_typename] = ACTIONS(3627),
    [anon_sym_template] = ACTIONS(3627),
    [anon_sym_operator] = ACTIONS(3627),
    [anon_sym_try] = ACTIONS(3627),
    [anon_sym_delete] = ACTIONS(3627),
    [anon_sym_throw] = ACTIONS(3627),
    [anon_sym_namespace] = ACTIONS(3627),
    [anon_sym_static_assert] = ACTIONS(3627),
    [anon_sym_concept] = ACTIONS(3627),
    [anon_sym_co_return] = ACTIONS(3627),
    [anon_sym_co_yield] = ACTIONS(3627),
    [anon_sym_R_DQUOTE] = ACTIONS(3625),
    [anon_sym_LR_DQUOTE] = ACTIONS(3625),
    [anon_sym_uR_DQUOTE] = ACTIONS(3625),
    [anon_sym_UR_DQUOTE] = ACTIONS(3625),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3625),
    [anon_sym_co_await] = ACTIONS(3627),
    [anon_sym_new] = ACTIONS(3627),
    [anon_sym_requires] = ACTIONS(3627),
    [sym_this] = ACTIONS(3627),
    [anon_sym_discard] = ACTIONS(3627),
    [anon_sym_precise] = ACTIONS(3627),
    [anon_sym_shared] = ACTIONS(3627),
    [anon_sym_groupshared] = ACTIONS(3627),
    [anon_sym_uniform] = ACTIONS(3627),
    [anon_sym_row_major] = ACTIONS(3627),
    [anon_sym_column_major] = ACTIONS(3627),
    [anon_sym_globallycoherent] = ACTIONS(3627),
    [anon_sym_centroid] = ACTIONS(3627),
    [anon_sym_noperspective] = ACTIONS(3627),
    [anon_sym_nointerpolation] = ACTIONS(3627),
    [anon_sym_sample] = ACTIONS(3627),
    [anon_sym_linear] = ACTIONS(3627),
    [anon_sym_snorm] = ACTIONS(3627),
    [anon_sym_unorm] = ACTIONS(3627),
    [anon_sym_point] = ACTIONS(3627),
    [anon_sym_line] = ACTIONS(3627),
    [anon_sym_triangleadj] = ACTIONS(3627),
    [anon_sym_lineadj] = ACTIONS(3627),
    [anon_sym_triangle] = ACTIONS(3627),
    [anon_sym_cbuffer] = ACTIONS(3627),
    [anon_sym_interface] = ACTIONS(3627),
    [anon_sym_extension] = ACTIONS(3627),
  },
  [517] = {
    [sym_expression] = STATE(5382),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(3343),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(3349),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3354),
    [anon_sym___extension__] = ACTIONS(3357),
    [anon_sym_typedef] = ACTIONS(3659),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3370),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3373),
    [anon_sym_explicit] = ACTIONS(3362),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3376),
    [anon_sym_operator] = ACTIONS(3362),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [518] = {
    [sym_identifier] = ACTIONS(3655),
    [aux_sym_preproc_include_token1] = ACTIONS(3655),
    [aux_sym_preproc_def_token1] = ACTIONS(3655),
    [aux_sym_preproc_if_token1] = ACTIONS(3655),
    [aux_sym_preproc_if_token2] = ACTIONS(3655),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3655),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3655),
    [aux_sym_preproc_else_token1] = ACTIONS(3655),
    [aux_sym_preproc_elif_token1] = ACTIONS(3655),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3655),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3655),
    [sym_preproc_directive] = ACTIONS(3655),
    [anon_sym_LPAREN2] = ACTIONS(3653),
    [anon_sym_BANG] = ACTIONS(3653),
    [anon_sym_TILDE] = ACTIONS(3653),
    [anon_sym_DASH] = ACTIONS(3655),
    [anon_sym_PLUS] = ACTIONS(3655),
    [anon_sym_STAR] = ACTIONS(3653),
    [anon_sym_AMP_AMP] = ACTIONS(3653),
    [anon_sym_AMP] = ACTIONS(3655),
    [anon_sym_SEMI] = ACTIONS(3653),
    [anon_sym___extension__] = ACTIONS(3655),
    [anon_sym_typedef] = ACTIONS(3655),
    [anon_sym_in] = ACTIONS(3655),
    [anon_sym_out] = ACTIONS(3655),
    [anon_sym_inout] = ACTIONS(3655),
    [anon_sym_virtual] = ACTIONS(3655),
    [anon_sym_extern] = ACTIONS(3655),
    [anon_sym___attribute__] = ACTIONS(3655),
    [anon_sym___attribute] = ACTIONS(3655),
    [anon_sym_using] = ACTIONS(3655),
    [anon_sym_COLON_COLON] = ACTIONS(3653),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3653),
    [anon_sym___declspec] = ACTIONS(3655),
    [anon_sym___based] = ACTIONS(3655),
    [anon_sym___cdecl] = ACTIONS(3655),
    [anon_sym___clrcall] = ACTIONS(3655),
    [anon_sym___stdcall] = ACTIONS(3655),
    [anon_sym___fastcall] = ACTIONS(3655),
    [anon_sym___thiscall] = ACTIONS(3655),
    [anon_sym___vectorcall] = ACTIONS(3655),
    [anon_sym_LBRACE] = ACTIONS(3653),
    [anon_sym_signed] = ACTIONS(3655),
    [anon_sym_unsigned] = ACTIONS(3655),
    [anon_sym_long] = ACTIONS(3655),
    [anon_sym_short] = ACTIONS(3655),
    [anon_sym_LBRACK] = ACTIONS(3655),
    [anon_sym_static] = ACTIONS(3655),
    [anon_sym_register] = ACTIONS(3655),
    [anon_sym_inline] = ACTIONS(3655),
    [anon_sym___inline] = ACTIONS(3655),
    [anon_sym___inline__] = ACTIONS(3655),
    [anon_sym___forceinline] = ACTIONS(3655),
    [anon_sym_thread_local] = ACTIONS(3655),
    [anon_sym___thread] = ACTIONS(3655),
    [anon_sym_const] = ACTIONS(3655),
    [anon_sym_constexpr] = ACTIONS(3655),
    [anon_sym_volatile] = ACTIONS(3655),
    [anon_sym_restrict] = ACTIONS(3655),
    [anon_sym___restrict__] = ACTIONS(3655),
    [anon_sym__Atomic] = ACTIONS(3655),
    [anon_sym__Noreturn] = ACTIONS(3655),
    [anon_sym_noreturn] = ACTIONS(3655),
    [anon_sym__Nonnull] = ACTIONS(3655),
    [anon_sym_mutable] = ACTIONS(3655),
    [anon_sym_constinit] = ACTIONS(3655),
    [anon_sym_consteval] = ACTIONS(3655),
    [anon_sym_alignas] = ACTIONS(3655),
    [anon_sym__Alignas] = ACTIONS(3655),
    [sym_primitive_type] = ACTIONS(3655),
    [anon_sym_enum] = ACTIONS(3655),
    [anon_sym_class] = ACTIONS(3655),
    [anon_sym_struct] = ACTIONS(3655),
    [anon_sym_union] = ACTIONS(3655),
    [anon_sym_if] = ACTIONS(3655),
    [anon_sym_else] = ACTIONS(3655),
    [anon_sym_switch] = ACTIONS(3655),
    [anon_sym_case] = ACTIONS(3655),
    [anon_sym_default] = ACTIONS(3655),
    [anon_sym_while] = ACTIONS(3655),
    [anon_sym_do] = ACTIONS(3655),
    [anon_sym_for] = ACTIONS(3655),
    [anon_sym_return] = ACTIONS(3655),
    [anon_sym_break] = ACTIONS(3655),
    [anon_sym_continue] = ACTIONS(3655),
    [anon_sym_goto] = ACTIONS(3655),
    [anon_sym___try] = ACTIONS(3655),
    [anon_sym___leave] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3655),
    [anon_sym_compl] = ACTIONS(3655),
    [anon_sym_DASH_DASH] = ACTIONS(3653),
    [anon_sym_PLUS_PLUS] = ACTIONS(3653),
    [anon_sym_sizeof] = ACTIONS(3655),
    [anon_sym___alignof__] = ACTIONS(3655),
    [anon_sym___alignof] = ACTIONS(3655),
    [anon_sym__alignof] = ACTIONS(3655),
    [anon_sym_alignof] = ACTIONS(3655),
    [anon_sym__Alignof] = ACTIONS(3655),
    [anon_sym_offsetof] = ACTIONS(3655),
    [anon_sym__Generic] = ACTIONS(3655),
    [anon_sym_asm] = ACTIONS(3655),
    [anon_sym___asm__] = ACTIONS(3655),
    [anon_sym___asm] = ACTIONS(3655),
    [sym_number_literal] = ACTIONS(3653),
    [anon_sym_L_SQUOTE] = ACTIONS(3653),
    [anon_sym_u_SQUOTE] = ACTIONS(3653),
    [anon_sym_U_SQUOTE] = ACTIONS(3653),
    [anon_sym_u8_SQUOTE] = ACTIONS(3653),
    [anon_sym_SQUOTE] = ACTIONS(3653),
    [anon_sym_L_DQUOTE] = ACTIONS(3653),
    [anon_sym_u_DQUOTE] = ACTIONS(3653),
    [anon_sym_U_DQUOTE] = ACTIONS(3653),
    [anon_sym_u8_DQUOTE] = ACTIONS(3653),
    [anon_sym_DQUOTE] = ACTIONS(3653),
    [sym_true] = ACTIONS(3655),
    [sym_false] = ACTIONS(3655),
    [anon_sym_NULL] = ACTIONS(3655),
    [anon_sym_nullptr] = ACTIONS(3655),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3655),
    [anon_sym_let] = ACTIONS(3655),
    [anon_sym_This] = ACTIONS(3655),
    [anon_sym_decltype] = ACTIONS(3655),
    [anon_sym_explicit] = ACTIONS(3655),
    [anon_sym_typename] = ACTIONS(3655),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(3655),
    [anon_sym_try] = ACTIONS(3655),
    [anon_sym_delete] = ACTIONS(3655),
    [anon_sym_throw] = ACTIONS(3655),
    [anon_sym_namespace] = ACTIONS(3655),
    [anon_sym_static_assert] = ACTIONS(3655),
    [anon_sym_concept] = ACTIONS(3655),
    [anon_sym_co_return] = ACTIONS(3655),
    [anon_sym_co_yield] = ACTIONS(3655),
    [anon_sym_R_DQUOTE] = ACTIONS(3653),
    [anon_sym_LR_DQUOTE] = ACTIONS(3653),
    [anon_sym_uR_DQUOTE] = ACTIONS(3653),
    [anon_sym_UR_DQUOTE] = ACTIONS(3653),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3653),
    [anon_sym_co_await] = ACTIONS(3655),
    [anon_sym_new] = ACTIONS(3655),
    [anon_sym_requires] = ACTIONS(3655),
    [sym_this] = ACTIONS(3655),
    [anon_sym_discard] = ACTIONS(3655),
    [anon_sym_precise] = ACTIONS(3655),
    [anon_sym_shared] = ACTIONS(3655),
    [anon_sym_groupshared] = ACTIONS(3655),
    [anon_sym_uniform] = ACTIONS(3655),
    [anon_sym_row_major] = ACTIONS(3655),
    [anon_sym_column_major] = ACTIONS(3655),
    [anon_sym_globallycoherent] = ACTIONS(3655),
    [anon_sym_centroid] = ACTIONS(3655),
    [anon_sym_noperspective] = ACTIONS(3655),
    [anon_sym_nointerpolation] = ACTIONS(3655),
    [anon_sym_sample] = ACTIONS(3655),
    [anon_sym_linear] = ACTIONS(3655),
    [anon_sym_snorm] = ACTIONS(3655),
    [anon_sym_unorm] = ACTIONS(3655),
    [anon_sym_point] = ACTIONS(3655),
    [anon_sym_line] = ACTIONS(3655),
    [anon_sym_triangleadj] = ACTIONS(3655),
    [anon_sym_lineadj] = ACTIONS(3655),
    [anon_sym_triangle] = ACTIONS(3655),
    [anon_sym_cbuffer] = ACTIONS(3655),
    [anon_sym_interface] = ACTIONS(3655),
    [anon_sym_extension] = ACTIONS(3655),
  },
  [519] = {
    [sym_identifier] = ACTIONS(3661),
    [aux_sym_preproc_include_token1] = ACTIONS(3661),
    [aux_sym_preproc_def_token1] = ACTIONS(3661),
    [aux_sym_preproc_if_token1] = ACTIONS(3661),
    [aux_sym_preproc_if_token2] = ACTIONS(3661),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3661),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3661),
    [aux_sym_preproc_else_token1] = ACTIONS(3661),
    [aux_sym_preproc_elif_token1] = ACTIONS(3661),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3661),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3661),
    [sym_preproc_directive] = ACTIONS(3661),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_BANG] = ACTIONS(3663),
    [anon_sym_TILDE] = ACTIONS(3663),
    [anon_sym_DASH] = ACTIONS(3661),
    [anon_sym_PLUS] = ACTIONS(3661),
    [anon_sym_STAR] = ACTIONS(3663),
    [anon_sym_AMP_AMP] = ACTIONS(3663),
    [anon_sym_AMP] = ACTIONS(3661),
    [anon_sym_SEMI] = ACTIONS(3663),
    [anon_sym___extension__] = ACTIONS(3661),
    [anon_sym_typedef] = ACTIONS(3661),
    [anon_sym_in] = ACTIONS(3661),
    [anon_sym_out] = ACTIONS(3661),
    [anon_sym_inout] = ACTIONS(3661),
    [anon_sym_virtual] = ACTIONS(3661),
    [anon_sym_extern] = ACTIONS(3661),
    [anon_sym___attribute__] = ACTIONS(3661),
    [anon_sym___attribute] = ACTIONS(3661),
    [anon_sym_using] = ACTIONS(3661),
    [anon_sym_COLON_COLON] = ACTIONS(3663),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3663),
    [anon_sym___declspec] = ACTIONS(3661),
    [anon_sym___based] = ACTIONS(3661),
    [anon_sym___cdecl] = ACTIONS(3661),
    [anon_sym___clrcall] = ACTIONS(3661),
    [anon_sym___stdcall] = ACTIONS(3661),
    [anon_sym___fastcall] = ACTIONS(3661),
    [anon_sym___thiscall] = ACTIONS(3661),
    [anon_sym___vectorcall] = ACTIONS(3661),
    [anon_sym_LBRACE] = ACTIONS(3663),
    [anon_sym_signed] = ACTIONS(3661),
    [anon_sym_unsigned] = ACTIONS(3661),
    [anon_sym_long] = ACTIONS(3661),
    [anon_sym_short] = ACTIONS(3661),
    [anon_sym_LBRACK] = ACTIONS(3661),
    [anon_sym_static] = ACTIONS(3661),
    [anon_sym_register] = ACTIONS(3661),
    [anon_sym_inline] = ACTIONS(3661),
    [anon_sym___inline] = ACTIONS(3661),
    [anon_sym___inline__] = ACTIONS(3661),
    [anon_sym___forceinline] = ACTIONS(3661),
    [anon_sym_thread_local] = ACTIONS(3661),
    [anon_sym___thread] = ACTIONS(3661),
    [anon_sym_const] = ACTIONS(3661),
    [anon_sym_constexpr] = ACTIONS(3661),
    [anon_sym_volatile] = ACTIONS(3661),
    [anon_sym_restrict] = ACTIONS(3661),
    [anon_sym___restrict__] = ACTIONS(3661),
    [anon_sym__Atomic] = ACTIONS(3661),
    [anon_sym__Noreturn] = ACTIONS(3661),
    [anon_sym_noreturn] = ACTIONS(3661),
    [anon_sym__Nonnull] = ACTIONS(3661),
    [anon_sym_mutable] = ACTIONS(3661),
    [anon_sym_constinit] = ACTIONS(3661),
    [anon_sym_consteval] = ACTIONS(3661),
    [anon_sym_alignas] = ACTIONS(3661),
    [anon_sym__Alignas] = ACTIONS(3661),
    [sym_primitive_type] = ACTIONS(3661),
    [anon_sym_enum] = ACTIONS(3661),
    [anon_sym_class] = ACTIONS(3661),
    [anon_sym_struct] = ACTIONS(3661),
    [anon_sym_union] = ACTIONS(3661),
    [anon_sym_if] = ACTIONS(3661),
    [anon_sym_switch] = ACTIONS(3661),
    [anon_sym_case] = ACTIONS(3661),
    [anon_sym_default] = ACTIONS(3661),
    [anon_sym_while] = ACTIONS(3661),
    [anon_sym_do] = ACTIONS(3661),
    [anon_sym_for] = ACTIONS(3661),
    [anon_sym_return] = ACTIONS(3661),
    [anon_sym_break] = ACTIONS(3661),
    [anon_sym_continue] = ACTIONS(3661),
    [anon_sym_goto] = ACTIONS(3661),
    [anon_sym___try] = ACTIONS(3661),
    [anon_sym___leave] = ACTIONS(3661),
    [anon_sym_not] = ACTIONS(3661),
    [anon_sym_compl] = ACTIONS(3661),
    [anon_sym_DASH_DASH] = ACTIONS(3663),
    [anon_sym_PLUS_PLUS] = ACTIONS(3663),
    [anon_sym_sizeof] = ACTIONS(3661),
    [anon_sym___alignof__] = ACTIONS(3661),
    [anon_sym___alignof] = ACTIONS(3661),
    [anon_sym__alignof] = ACTIONS(3661),
    [anon_sym_alignof] = ACTIONS(3661),
    [anon_sym__Alignof] = ACTIONS(3661),
    [anon_sym_offsetof] = ACTIONS(3661),
    [anon_sym__Generic] = ACTIONS(3661),
    [anon_sym_asm] = ACTIONS(3661),
    [anon_sym___asm__] = ACTIONS(3661),
    [anon_sym___asm] = ACTIONS(3661),
    [sym_number_literal] = ACTIONS(3663),
    [anon_sym_L_SQUOTE] = ACTIONS(3663),
    [anon_sym_u_SQUOTE] = ACTIONS(3663),
    [anon_sym_U_SQUOTE] = ACTIONS(3663),
    [anon_sym_u8_SQUOTE] = ACTIONS(3663),
    [anon_sym_SQUOTE] = ACTIONS(3663),
    [anon_sym_L_DQUOTE] = ACTIONS(3663),
    [anon_sym_u_DQUOTE] = ACTIONS(3663),
    [anon_sym_U_DQUOTE] = ACTIONS(3663),
    [anon_sym_u8_DQUOTE] = ACTIONS(3663),
    [anon_sym_DQUOTE] = ACTIONS(3663),
    [sym_true] = ACTIONS(3661),
    [sym_false] = ACTIONS(3661),
    [anon_sym_NULL] = ACTIONS(3661),
    [anon_sym_nullptr] = ACTIONS(3661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3661),
    [anon_sym_let] = ACTIONS(3661),
    [anon_sym_This] = ACTIONS(3661),
    [anon_sym_decltype] = ACTIONS(3661),
    [anon_sym_explicit] = ACTIONS(3661),
    [anon_sym_typename] = ACTIONS(3661),
    [anon_sym_template] = ACTIONS(3661),
    [anon_sym_operator] = ACTIONS(3661),
    [anon_sym_try] = ACTIONS(3661),
    [anon_sym_delete] = ACTIONS(3661),
    [anon_sym_throw] = ACTIONS(3661),
    [anon_sym_namespace] = ACTIONS(3661),
    [anon_sym_static_assert] = ACTIONS(3661),
    [anon_sym_concept] = ACTIONS(3661),
    [anon_sym_co_return] = ACTIONS(3661),
    [anon_sym_co_yield] = ACTIONS(3661),
    [anon_sym_R_DQUOTE] = ACTIONS(3663),
    [anon_sym_LR_DQUOTE] = ACTIONS(3663),
    [anon_sym_uR_DQUOTE] = ACTIONS(3663),
    [anon_sym_UR_DQUOTE] = ACTIONS(3663),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3663),
    [anon_sym_co_await] = ACTIONS(3661),
    [anon_sym_new] = ACTIONS(3661),
    [anon_sym_requires] = ACTIONS(3661),
    [sym_this] = ACTIONS(3661),
    [anon_sym_discard] = ACTIONS(3661),
    [anon_sym_precise] = ACTIONS(3661),
    [anon_sym_shared] = ACTIONS(3661),
    [anon_sym_groupshared] = ACTIONS(3661),
    [anon_sym_uniform] = ACTIONS(3661),
    [anon_sym_row_major] = ACTIONS(3661),
    [anon_sym_column_major] = ACTIONS(3661),
    [anon_sym_globallycoherent] = ACTIONS(3661),
    [anon_sym_centroid] = ACTIONS(3661),
    [anon_sym_noperspective] = ACTIONS(3661),
    [anon_sym_nointerpolation] = ACTIONS(3661),
    [anon_sym_sample] = ACTIONS(3661),
    [anon_sym_linear] = ACTIONS(3661),
    [anon_sym_snorm] = ACTIONS(3661),
    [anon_sym_unorm] = ACTIONS(3661),
    [anon_sym_point] = ACTIONS(3661),
    [anon_sym_line] = ACTIONS(3661),
    [anon_sym_triangleadj] = ACTIONS(3661),
    [anon_sym_lineadj] = ACTIONS(3661),
    [anon_sym_triangle] = ACTIONS(3661),
    [anon_sym_cbuffer] = ACTIONS(3661),
    [anon_sym_interface] = ACTIONS(3661),
    [anon_sym_extension] = ACTIONS(3661),
  },
  [520] = {
    [sym_identifier] = ACTIONS(3665),
    [aux_sym_preproc_include_token1] = ACTIONS(3665),
    [aux_sym_preproc_def_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token2] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3665),
    [aux_sym_preproc_else_token1] = ACTIONS(3665),
    [aux_sym_preproc_elif_token1] = ACTIONS(3665),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3665),
    [sym_preproc_directive] = ACTIONS(3665),
    [anon_sym_LPAREN2] = ACTIONS(3667),
    [anon_sym_BANG] = ACTIONS(3667),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_DASH] = ACTIONS(3665),
    [anon_sym_PLUS] = ACTIONS(3665),
    [anon_sym_STAR] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_SEMI] = ACTIONS(3667),
    [anon_sym___extension__] = ACTIONS(3665),
    [anon_sym_typedef] = ACTIONS(3665),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_out] = ACTIONS(3665),
    [anon_sym_inout] = ACTIONS(3665),
    [anon_sym_virtual] = ACTIONS(3665),
    [anon_sym_extern] = ACTIONS(3665),
    [anon_sym___attribute__] = ACTIONS(3665),
    [anon_sym___attribute] = ACTIONS(3665),
    [anon_sym_using] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(3667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3667),
    [anon_sym___declspec] = ACTIONS(3665),
    [anon_sym___based] = ACTIONS(3665),
    [anon_sym___cdecl] = ACTIONS(3665),
    [anon_sym___clrcall] = ACTIONS(3665),
    [anon_sym___stdcall] = ACTIONS(3665),
    [anon_sym___fastcall] = ACTIONS(3665),
    [anon_sym___thiscall] = ACTIONS(3665),
    [anon_sym___vectorcall] = ACTIONS(3665),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_signed] = ACTIONS(3665),
    [anon_sym_unsigned] = ACTIONS(3665),
    [anon_sym_long] = ACTIONS(3665),
    [anon_sym_short] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3665),
    [anon_sym_static] = ACTIONS(3665),
    [anon_sym_register] = ACTIONS(3665),
    [anon_sym_inline] = ACTIONS(3665),
    [anon_sym___inline] = ACTIONS(3665),
    [anon_sym___inline__] = ACTIONS(3665),
    [anon_sym___forceinline] = ACTIONS(3665),
    [anon_sym_thread_local] = ACTIONS(3665),
    [anon_sym___thread] = ACTIONS(3665),
    [anon_sym_const] = ACTIONS(3665),
    [anon_sym_constexpr] = ACTIONS(3665),
    [anon_sym_volatile] = ACTIONS(3665),
    [anon_sym_restrict] = ACTIONS(3665),
    [anon_sym___restrict__] = ACTIONS(3665),
    [anon_sym__Atomic] = ACTIONS(3665),
    [anon_sym__Noreturn] = ACTIONS(3665),
    [anon_sym_noreturn] = ACTIONS(3665),
    [anon_sym__Nonnull] = ACTIONS(3665),
    [anon_sym_mutable] = ACTIONS(3665),
    [anon_sym_constinit] = ACTIONS(3665),
    [anon_sym_consteval] = ACTIONS(3665),
    [anon_sym_alignas] = ACTIONS(3665),
    [anon_sym__Alignas] = ACTIONS(3665),
    [sym_primitive_type] = ACTIONS(3665),
    [anon_sym_enum] = ACTIONS(3665),
    [anon_sym_class] = ACTIONS(3665),
    [anon_sym_struct] = ACTIONS(3665),
    [anon_sym_union] = ACTIONS(3665),
    [anon_sym_if] = ACTIONS(3665),
    [anon_sym_switch] = ACTIONS(3665),
    [anon_sym_case] = ACTIONS(3665),
    [anon_sym_default] = ACTIONS(3665),
    [anon_sym_while] = ACTIONS(3665),
    [anon_sym_do] = ACTIONS(3665),
    [anon_sym_for] = ACTIONS(3665),
    [anon_sym_return] = ACTIONS(3665),
    [anon_sym_break] = ACTIONS(3665),
    [anon_sym_continue] = ACTIONS(3665),
    [anon_sym_goto] = ACTIONS(3665),
    [anon_sym___try] = ACTIONS(3665),
    [anon_sym___leave] = ACTIONS(3665),
    [anon_sym_not] = ACTIONS(3665),
    [anon_sym_compl] = ACTIONS(3665),
    [anon_sym_DASH_DASH] = ACTIONS(3667),
    [anon_sym_PLUS_PLUS] = ACTIONS(3667),
    [anon_sym_sizeof] = ACTIONS(3665),
    [anon_sym___alignof__] = ACTIONS(3665),
    [anon_sym___alignof] = ACTIONS(3665),
    [anon_sym__alignof] = ACTIONS(3665),
    [anon_sym_alignof] = ACTIONS(3665),
    [anon_sym__Alignof] = ACTIONS(3665),
    [anon_sym_offsetof] = ACTIONS(3665),
    [anon_sym__Generic] = ACTIONS(3665),
    [anon_sym_asm] = ACTIONS(3665),
    [anon_sym___asm__] = ACTIONS(3665),
    [anon_sym___asm] = ACTIONS(3665),
    [sym_number_literal] = ACTIONS(3667),
    [anon_sym_L_SQUOTE] = ACTIONS(3667),
    [anon_sym_u_SQUOTE] = ACTIONS(3667),
    [anon_sym_U_SQUOTE] = ACTIONS(3667),
    [anon_sym_u8_SQUOTE] = ACTIONS(3667),
    [anon_sym_SQUOTE] = ACTIONS(3667),
    [anon_sym_L_DQUOTE] = ACTIONS(3667),
    [anon_sym_u_DQUOTE] = ACTIONS(3667),
    [anon_sym_U_DQUOTE] = ACTIONS(3667),
    [anon_sym_u8_DQUOTE] = ACTIONS(3667),
    [anon_sym_DQUOTE] = ACTIONS(3667),
    [sym_true] = ACTIONS(3665),
    [sym_false] = ACTIONS(3665),
    [anon_sym_NULL] = ACTIONS(3665),
    [anon_sym_nullptr] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3665),
    [anon_sym_let] = ACTIONS(3665),
    [anon_sym_This] = ACTIONS(3665),
    [anon_sym_decltype] = ACTIONS(3665),
    [anon_sym_explicit] = ACTIONS(3665),
    [anon_sym_typename] = ACTIONS(3665),
    [anon_sym_template] = ACTIONS(3665),
    [anon_sym_operator] = ACTIONS(3665),
    [anon_sym_try] = ACTIONS(3665),
    [anon_sym_delete] = ACTIONS(3665),
    [anon_sym_throw] = ACTIONS(3665),
    [anon_sym_namespace] = ACTIONS(3665),
    [anon_sym_static_assert] = ACTIONS(3665),
    [anon_sym_concept] = ACTIONS(3665),
    [anon_sym_co_return] = ACTIONS(3665),
    [anon_sym_co_yield] = ACTIONS(3665),
    [anon_sym_R_DQUOTE] = ACTIONS(3667),
    [anon_sym_LR_DQUOTE] = ACTIONS(3667),
    [anon_sym_uR_DQUOTE] = ACTIONS(3667),
    [anon_sym_UR_DQUOTE] = ACTIONS(3667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3667),
    [anon_sym_co_await] = ACTIONS(3665),
    [anon_sym_new] = ACTIONS(3665),
    [anon_sym_requires] = ACTIONS(3665),
    [sym_this] = ACTIONS(3665),
    [anon_sym_discard] = ACTIONS(3665),
    [anon_sym_precise] = ACTIONS(3665),
    [anon_sym_shared] = ACTIONS(3665),
    [anon_sym_groupshared] = ACTIONS(3665),
    [anon_sym_uniform] = ACTIONS(3665),
    [anon_sym_row_major] = ACTIONS(3665),
    [anon_sym_column_major] = ACTIONS(3665),
    [anon_sym_globallycoherent] = ACTIONS(3665),
    [anon_sym_centroid] = ACTIONS(3665),
    [anon_sym_noperspective] = ACTIONS(3665),
    [anon_sym_nointerpolation] = ACTIONS(3665),
    [anon_sym_sample] = ACTIONS(3665),
    [anon_sym_linear] = ACTIONS(3665),
    [anon_sym_snorm] = ACTIONS(3665),
    [anon_sym_unorm] = ACTIONS(3665),
    [anon_sym_point] = ACTIONS(3665),
    [anon_sym_line] = ACTIONS(3665),
    [anon_sym_triangleadj] = ACTIONS(3665),
    [anon_sym_lineadj] = ACTIONS(3665),
    [anon_sym_triangle] = ACTIONS(3665),
    [anon_sym_cbuffer] = ACTIONS(3665),
    [anon_sym_interface] = ACTIONS(3665),
    [anon_sym_extension] = ACTIONS(3665),
  },
  [521] = {
    [sym_identifier] = ACTIONS(3669),
    [aux_sym_preproc_include_token1] = ACTIONS(3669),
    [aux_sym_preproc_def_token1] = ACTIONS(3669),
    [aux_sym_preproc_if_token1] = ACTIONS(3669),
    [aux_sym_preproc_if_token2] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3669),
    [aux_sym_preproc_else_token1] = ACTIONS(3669),
    [aux_sym_preproc_elif_token1] = ACTIONS(3669),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3669),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3669),
    [sym_preproc_directive] = ACTIONS(3669),
    [anon_sym_LPAREN2] = ACTIONS(3671),
    [anon_sym_BANG] = ACTIONS(3671),
    [anon_sym_TILDE] = ACTIONS(3671),
    [anon_sym_DASH] = ACTIONS(3669),
    [anon_sym_PLUS] = ACTIONS(3669),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3671),
    [anon_sym_AMP] = ACTIONS(3669),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym___extension__] = ACTIONS(3669),
    [anon_sym_typedef] = ACTIONS(3669),
    [anon_sym_in] = ACTIONS(3669),
    [anon_sym_out] = ACTIONS(3669),
    [anon_sym_inout] = ACTIONS(3669),
    [anon_sym_virtual] = ACTIONS(3669),
    [anon_sym_extern] = ACTIONS(3669),
    [anon_sym___attribute__] = ACTIONS(3669),
    [anon_sym___attribute] = ACTIONS(3669),
    [anon_sym_using] = ACTIONS(3669),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3671),
    [anon_sym___declspec] = ACTIONS(3669),
    [anon_sym___based] = ACTIONS(3669),
    [anon_sym___cdecl] = ACTIONS(3669),
    [anon_sym___clrcall] = ACTIONS(3669),
    [anon_sym___stdcall] = ACTIONS(3669),
    [anon_sym___fastcall] = ACTIONS(3669),
    [anon_sym___thiscall] = ACTIONS(3669),
    [anon_sym___vectorcall] = ACTIONS(3669),
    [anon_sym_LBRACE] = ACTIONS(3671),
    [anon_sym_signed] = ACTIONS(3669),
    [anon_sym_unsigned] = ACTIONS(3669),
    [anon_sym_long] = ACTIONS(3669),
    [anon_sym_short] = ACTIONS(3669),
    [anon_sym_LBRACK] = ACTIONS(3669),
    [anon_sym_static] = ACTIONS(3669),
    [anon_sym_register] = ACTIONS(3669),
    [anon_sym_inline] = ACTIONS(3669),
    [anon_sym___inline] = ACTIONS(3669),
    [anon_sym___inline__] = ACTIONS(3669),
    [anon_sym___forceinline] = ACTIONS(3669),
    [anon_sym_thread_local] = ACTIONS(3669),
    [anon_sym___thread] = ACTIONS(3669),
    [anon_sym_const] = ACTIONS(3669),
    [anon_sym_constexpr] = ACTIONS(3669),
    [anon_sym_volatile] = ACTIONS(3669),
    [anon_sym_restrict] = ACTIONS(3669),
    [anon_sym___restrict__] = ACTIONS(3669),
    [anon_sym__Atomic] = ACTIONS(3669),
    [anon_sym__Noreturn] = ACTIONS(3669),
    [anon_sym_noreturn] = ACTIONS(3669),
    [anon_sym__Nonnull] = ACTIONS(3669),
    [anon_sym_mutable] = ACTIONS(3669),
    [anon_sym_constinit] = ACTIONS(3669),
    [anon_sym_consteval] = ACTIONS(3669),
    [anon_sym_alignas] = ACTIONS(3669),
    [anon_sym__Alignas] = ACTIONS(3669),
    [sym_primitive_type] = ACTIONS(3669),
    [anon_sym_enum] = ACTIONS(3669),
    [anon_sym_class] = ACTIONS(3669),
    [anon_sym_struct] = ACTIONS(3669),
    [anon_sym_union] = ACTIONS(3669),
    [anon_sym_if] = ACTIONS(3669),
    [anon_sym_switch] = ACTIONS(3669),
    [anon_sym_case] = ACTIONS(3669),
    [anon_sym_default] = ACTIONS(3669),
    [anon_sym_while] = ACTIONS(3669),
    [anon_sym_do] = ACTIONS(3669),
    [anon_sym_for] = ACTIONS(3669),
    [anon_sym_return] = ACTIONS(3669),
    [anon_sym_break] = ACTIONS(3669),
    [anon_sym_continue] = ACTIONS(3669),
    [anon_sym_goto] = ACTIONS(3669),
    [anon_sym___try] = ACTIONS(3669),
    [anon_sym___leave] = ACTIONS(3669),
    [anon_sym_not] = ACTIONS(3669),
    [anon_sym_compl] = ACTIONS(3669),
    [anon_sym_DASH_DASH] = ACTIONS(3671),
    [anon_sym_PLUS_PLUS] = ACTIONS(3671),
    [anon_sym_sizeof] = ACTIONS(3669),
    [anon_sym___alignof__] = ACTIONS(3669),
    [anon_sym___alignof] = ACTIONS(3669),
    [anon_sym__alignof] = ACTIONS(3669),
    [anon_sym_alignof] = ACTIONS(3669),
    [anon_sym__Alignof] = ACTIONS(3669),
    [anon_sym_offsetof] = ACTIONS(3669),
    [anon_sym__Generic] = ACTIONS(3669),
    [anon_sym_asm] = ACTIONS(3669),
    [anon_sym___asm__] = ACTIONS(3669),
    [anon_sym___asm] = ACTIONS(3669),
    [sym_number_literal] = ACTIONS(3671),
    [anon_sym_L_SQUOTE] = ACTIONS(3671),
    [anon_sym_u_SQUOTE] = ACTIONS(3671),
    [anon_sym_U_SQUOTE] = ACTIONS(3671),
    [anon_sym_u8_SQUOTE] = ACTIONS(3671),
    [anon_sym_SQUOTE] = ACTIONS(3671),
    [anon_sym_L_DQUOTE] = ACTIONS(3671),
    [anon_sym_u_DQUOTE] = ACTIONS(3671),
    [anon_sym_U_DQUOTE] = ACTIONS(3671),
    [anon_sym_u8_DQUOTE] = ACTIONS(3671),
    [anon_sym_DQUOTE] = ACTIONS(3671),
    [sym_true] = ACTIONS(3669),
    [sym_false] = ACTIONS(3669),
    [anon_sym_NULL] = ACTIONS(3669),
    [anon_sym_nullptr] = ACTIONS(3669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3669),
    [anon_sym_let] = ACTIONS(3669),
    [anon_sym_This] = ACTIONS(3669),
    [anon_sym_decltype] = ACTIONS(3669),
    [anon_sym_explicit] = ACTIONS(3669),
    [anon_sym_typename] = ACTIONS(3669),
    [anon_sym_template] = ACTIONS(3669),
    [anon_sym_operator] = ACTIONS(3669),
    [anon_sym_try] = ACTIONS(3669),
    [anon_sym_delete] = ACTIONS(3669),
    [anon_sym_throw] = ACTIONS(3669),
    [anon_sym_namespace] = ACTIONS(3669),
    [anon_sym_static_assert] = ACTIONS(3669),
    [anon_sym_concept] = ACTIONS(3669),
    [anon_sym_co_return] = ACTIONS(3669),
    [anon_sym_co_yield] = ACTIONS(3669),
    [anon_sym_R_DQUOTE] = ACTIONS(3671),
    [anon_sym_LR_DQUOTE] = ACTIONS(3671),
    [anon_sym_uR_DQUOTE] = ACTIONS(3671),
    [anon_sym_UR_DQUOTE] = ACTIONS(3671),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3671),
    [anon_sym_co_await] = ACTIONS(3669),
    [anon_sym_new] = ACTIONS(3669),
    [anon_sym_requires] = ACTIONS(3669),
    [sym_this] = ACTIONS(3669),
    [anon_sym_discard] = ACTIONS(3669),
    [anon_sym_precise] = ACTIONS(3669),
    [anon_sym_shared] = ACTIONS(3669),
    [anon_sym_groupshared] = ACTIONS(3669),
    [anon_sym_uniform] = ACTIONS(3669),
    [anon_sym_row_major] = ACTIONS(3669),
    [anon_sym_column_major] = ACTIONS(3669),
    [anon_sym_globallycoherent] = ACTIONS(3669),
    [anon_sym_centroid] = ACTIONS(3669),
    [anon_sym_noperspective] = ACTIONS(3669),
    [anon_sym_nointerpolation] = ACTIONS(3669),
    [anon_sym_sample] = ACTIONS(3669),
    [anon_sym_linear] = ACTIONS(3669),
    [anon_sym_snorm] = ACTIONS(3669),
    [anon_sym_unorm] = ACTIONS(3669),
    [anon_sym_point] = ACTIONS(3669),
    [anon_sym_line] = ACTIONS(3669),
    [anon_sym_triangleadj] = ACTIONS(3669),
    [anon_sym_lineadj] = ACTIONS(3669),
    [anon_sym_triangle] = ACTIONS(3669),
    [anon_sym_cbuffer] = ACTIONS(3669),
    [anon_sym_interface] = ACTIONS(3669),
    [anon_sym_extension] = ACTIONS(3669),
  },
  [522] = {
    [sym_identifier] = ACTIONS(3673),
    [aux_sym_preproc_include_token1] = ACTIONS(3673),
    [aux_sym_preproc_def_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token2] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3673),
    [aux_sym_preproc_else_token1] = ACTIONS(3673),
    [aux_sym_preproc_elif_token1] = ACTIONS(3673),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3673),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3673),
    [sym_preproc_directive] = ACTIONS(3673),
    [anon_sym_LPAREN2] = ACTIONS(3675),
    [anon_sym_BANG] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3673),
    [anon_sym_PLUS] = ACTIONS(3673),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3673),
    [anon_sym_SEMI] = ACTIONS(3675),
    [anon_sym___extension__] = ACTIONS(3673),
    [anon_sym_typedef] = ACTIONS(3673),
    [anon_sym_in] = ACTIONS(3673),
    [anon_sym_out] = ACTIONS(3673),
    [anon_sym_inout] = ACTIONS(3673),
    [anon_sym_virtual] = ACTIONS(3673),
    [anon_sym_extern] = ACTIONS(3673),
    [anon_sym___attribute__] = ACTIONS(3673),
    [anon_sym___attribute] = ACTIONS(3673),
    [anon_sym_using] = ACTIONS(3673),
    [anon_sym_COLON_COLON] = ACTIONS(3675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3675),
    [anon_sym___declspec] = ACTIONS(3673),
    [anon_sym___based] = ACTIONS(3673),
    [anon_sym___cdecl] = ACTIONS(3673),
    [anon_sym___clrcall] = ACTIONS(3673),
    [anon_sym___stdcall] = ACTIONS(3673),
    [anon_sym___fastcall] = ACTIONS(3673),
    [anon_sym___thiscall] = ACTIONS(3673),
    [anon_sym___vectorcall] = ACTIONS(3673),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_signed] = ACTIONS(3673),
    [anon_sym_unsigned] = ACTIONS(3673),
    [anon_sym_long] = ACTIONS(3673),
    [anon_sym_short] = ACTIONS(3673),
    [anon_sym_LBRACK] = ACTIONS(3673),
    [anon_sym_static] = ACTIONS(3673),
    [anon_sym_register] = ACTIONS(3673),
    [anon_sym_inline] = ACTIONS(3673),
    [anon_sym___inline] = ACTIONS(3673),
    [anon_sym___inline__] = ACTIONS(3673),
    [anon_sym___forceinline] = ACTIONS(3673),
    [anon_sym_thread_local] = ACTIONS(3673),
    [anon_sym___thread] = ACTIONS(3673),
    [anon_sym_const] = ACTIONS(3673),
    [anon_sym_constexpr] = ACTIONS(3673),
    [anon_sym_volatile] = ACTIONS(3673),
    [anon_sym_restrict] = ACTIONS(3673),
    [anon_sym___restrict__] = ACTIONS(3673),
    [anon_sym__Atomic] = ACTIONS(3673),
    [anon_sym__Noreturn] = ACTIONS(3673),
    [anon_sym_noreturn] = ACTIONS(3673),
    [anon_sym__Nonnull] = ACTIONS(3673),
    [anon_sym_mutable] = ACTIONS(3673),
    [anon_sym_constinit] = ACTIONS(3673),
    [anon_sym_consteval] = ACTIONS(3673),
    [anon_sym_alignas] = ACTIONS(3673),
    [anon_sym__Alignas] = ACTIONS(3673),
    [sym_primitive_type] = ACTIONS(3673),
    [anon_sym_enum] = ACTIONS(3673),
    [anon_sym_class] = ACTIONS(3673),
    [anon_sym_struct] = ACTIONS(3673),
    [anon_sym_union] = ACTIONS(3673),
    [anon_sym_if] = ACTIONS(3673),
    [anon_sym_switch] = ACTIONS(3673),
    [anon_sym_case] = ACTIONS(3673),
    [anon_sym_default] = ACTIONS(3673),
    [anon_sym_while] = ACTIONS(3673),
    [anon_sym_do] = ACTIONS(3673),
    [anon_sym_for] = ACTIONS(3673),
    [anon_sym_return] = ACTIONS(3673),
    [anon_sym_break] = ACTIONS(3673),
    [anon_sym_continue] = ACTIONS(3673),
    [anon_sym_goto] = ACTIONS(3673),
    [anon_sym___try] = ACTIONS(3673),
    [anon_sym___leave] = ACTIONS(3673),
    [anon_sym_not] = ACTIONS(3673),
    [anon_sym_compl] = ACTIONS(3673),
    [anon_sym_DASH_DASH] = ACTIONS(3675),
    [anon_sym_PLUS_PLUS] = ACTIONS(3675),
    [anon_sym_sizeof] = ACTIONS(3673),
    [anon_sym___alignof__] = ACTIONS(3673),
    [anon_sym___alignof] = ACTIONS(3673),
    [anon_sym__alignof] = ACTIONS(3673),
    [anon_sym_alignof] = ACTIONS(3673),
    [anon_sym__Alignof] = ACTIONS(3673),
    [anon_sym_offsetof] = ACTIONS(3673),
    [anon_sym__Generic] = ACTIONS(3673),
    [anon_sym_asm] = ACTIONS(3673),
    [anon_sym___asm__] = ACTIONS(3673),
    [anon_sym___asm] = ACTIONS(3673),
    [sym_number_literal] = ACTIONS(3675),
    [anon_sym_L_SQUOTE] = ACTIONS(3675),
    [anon_sym_u_SQUOTE] = ACTIONS(3675),
    [anon_sym_U_SQUOTE] = ACTIONS(3675),
    [anon_sym_u8_SQUOTE] = ACTIONS(3675),
    [anon_sym_SQUOTE] = ACTIONS(3675),
    [anon_sym_L_DQUOTE] = ACTIONS(3675),
    [anon_sym_u_DQUOTE] = ACTIONS(3675),
    [anon_sym_U_DQUOTE] = ACTIONS(3675),
    [anon_sym_u8_DQUOTE] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(3675),
    [sym_true] = ACTIONS(3673),
    [sym_false] = ACTIONS(3673),
    [anon_sym_NULL] = ACTIONS(3673),
    [anon_sym_nullptr] = ACTIONS(3673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3673),
    [anon_sym_let] = ACTIONS(3673),
    [anon_sym_This] = ACTIONS(3673),
    [anon_sym_decltype] = ACTIONS(3673),
    [anon_sym_explicit] = ACTIONS(3673),
    [anon_sym_typename] = ACTIONS(3673),
    [anon_sym_template] = ACTIONS(3673),
    [anon_sym_operator] = ACTIONS(3673),
    [anon_sym_try] = ACTIONS(3673),
    [anon_sym_delete] = ACTIONS(3673),
    [anon_sym_throw] = ACTIONS(3673),
    [anon_sym_namespace] = ACTIONS(3673),
    [anon_sym_static_assert] = ACTIONS(3673),
    [anon_sym_concept] = ACTIONS(3673),
    [anon_sym_co_return] = ACTIONS(3673),
    [anon_sym_co_yield] = ACTIONS(3673),
    [anon_sym_R_DQUOTE] = ACTIONS(3675),
    [anon_sym_LR_DQUOTE] = ACTIONS(3675),
    [anon_sym_uR_DQUOTE] = ACTIONS(3675),
    [anon_sym_UR_DQUOTE] = ACTIONS(3675),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3675),
    [anon_sym_co_await] = ACTIONS(3673),
    [anon_sym_new] = ACTIONS(3673),
    [anon_sym_requires] = ACTIONS(3673),
    [sym_this] = ACTIONS(3673),
    [anon_sym_discard] = ACTIONS(3673),
    [anon_sym_precise] = ACTIONS(3673),
    [anon_sym_shared] = ACTIONS(3673),
    [anon_sym_groupshared] = ACTIONS(3673),
    [anon_sym_uniform] = ACTIONS(3673),
    [anon_sym_row_major] = ACTIONS(3673),
    [anon_sym_column_major] = ACTIONS(3673),
    [anon_sym_globallycoherent] = ACTIONS(3673),
    [anon_sym_centroid] = ACTIONS(3673),
    [anon_sym_noperspective] = ACTIONS(3673),
    [anon_sym_nointerpolation] = ACTIONS(3673),
    [anon_sym_sample] = ACTIONS(3673),
    [anon_sym_linear] = ACTIONS(3673),
    [anon_sym_snorm] = ACTIONS(3673),
    [anon_sym_unorm] = ACTIONS(3673),
    [anon_sym_point] = ACTIONS(3673),
    [anon_sym_line] = ACTIONS(3673),
    [anon_sym_triangleadj] = ACTIONS(3673),
    [anon_sym_lineadj] = ACTIONS(3673),
    [anon_sym_triangle] = ACTIONS(3673),
    [anon_sym_cbuffer] = ACTIONS(3673),
    [anon_sym_interface] = ACTIONS(3673),
    [anon_sym_extension] = ACTIONS(3673),
  },
  [523] = {
    [sym_identifier] = ACTIONS(2422),
    [aux_sym_preproc_include_token1] = ACTIONS(2422),
    [aux_sym_preproc_def_token1] = ACTIONS(2422),
    [aux_sym_preproc_if_token1] = ACTIONS(2422),
    [aux_sym_preproc_if_token2] = ACTIONS(2422),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2422),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2422),
    [sym_preproc_directive] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym_typedef] = ACTIONS(2422),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_out] = ACTIONS(2422),
    [anon_sym_inout] = ACTIONS(2422),
    [anon_sym_virtual] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_using] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2422),
    [anon_sym___based] = ACTIONS(2422),
    [anon_sym___cdecl] = ACTIONS(2422),
    [anon_sym___clrcall] = ACTIONS(2422),
    [anon_sym___stdcall] = ACTIONS(2422),
    [anon_sym___fastcall] = ACTIONS(2422),
    [anon_sym___thiscall] = ACTIONS(2422),
    [anon_sym___vectorcall] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2422),
    [anon_sym_unsigned] = ACTIONS(2422),
    [anon_sym_long] = ACTIONS(2422),
    [anon_sym_short] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_register] = ACTIONS(2422),
    [anon_sym_inline] = ACTIONS(2422),
    [anon_sym___inline] = ACTIONS(2422),
    [anon_sym___inline__] = ACTIONS(2422),
    [anon_sym___forceinline] = ACTIONS(2422),
    [anon_sym_thread_local] = ACTIONS(2422),
    [anon_sym___thread] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [sym_primitive_type] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
    [anon_sym_class] = ACTIONS(2422),
    [anon_sym_struct] = ACTIONS(2422),
    [anon_sym_union] = ACTIONS(2422),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(2422),
    [anon_sym_switch] = ACTIONS(2422),
    [anon_sym_case] = ACTIONS(2422),
    [anon_sym_default] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_break] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(2422),
    [anon_sym_goto] = ACTIONS(2422),
    [anon_sym___try] = ACTIONS(2422),
    [anon_sym___leave] = ACTIONS(2422),
    [anon_sym_not] = ACTIONS(2422),
    [anon_sym_compl] = ACTIONS(2422),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_sizeof] = ACTIONS(2422),
    [anon_sym___alignof__] = ACTIONS(2422),
    [anon_sym___alignof] = ACTIONS(2422),
    [anon_sym__alignof] = ACTIONS(2422),
    [anon_sym_alignof] = ACTIONS(2422),
    [anon_sym__Alignof] = ACTIONS(2422),
    [anon_sym_offsetof] = ACTIONS(2422),
    [anon_sym__Generic] = ACTIONS(2422),
    [anon_sym_asm] = ACTIONS(2422),
    [anon_sym___asm__] = ACTIONS(2422),
    [anon_sym___asm] = ACTIONS(2422),
    [sym_number_literal] = ACTIONS(2420),
    [anon_sym_L_SQUOTE] = ACTIONS(2420),
    [anon_sym_u_SQUOTE] = ACTIONS(2420),
    [anon_sym_U_SQUOTE] = ACTIONS(2420),
    [anon_sym_u8_SQUOTE] = ACTIONS(2420),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [anon_sym_L_DQUOTE] = ACTIONS(2420),
    [anon_sym_u_DQUOTE] = ACTIONS(2420),
    [anon_sym_U_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [sym_true] = ACTIONS(2422),
    [sym_false] = ACTIONS(2422),
    [anon_sym_NULL] = ACTIONS(2422),
    [anon_sym_nullptr] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_decltype] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_explicit] = ACTIONS(2422),
    [anon_sym_typename] = ACTIONS(2422),
    [anon_sym_template] = ACTIONS(2422),
    [anon_sym_operator] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_delete] = ACTIONS(2422),
    [anon_sym_throw] = ACTIONS(2422),
    [anon_sym_namespace] = ACTIONS(2422),
    [anon_sym_static_assert] = ACTIONS(2422),
    [anon_sym_concept] = ACTIONS(2422),
    [anon_sym_co_return] = ACTIONS(2422),
    [anon_sym_co_yield] = ACTIONS(2422),
    [anon_sym_R_DQUOTE] = ACTIONS(2420),
    [anon_sym_LR_DQUOTE] = ACTIONS(2420),
    [anon_sym_uR_DQUOTE] = ACTIONS(2420),
    [anon_sym_UR_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2420),
    [anon_sym_co_await] = ACTIONS(2422),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_requires] = ACTIONS(2422),
    [sym_this] = ACTIONS(2422),
    [anon_sym_discard] = ACTIONS(2422),
    [anon_sym_precise] = ACTIONS(2422),
    [anon_sym_shared] = ACTIONS(2422),
    [anon_sym_groupshared] = ACTIONS(2422),
    [anon_sym_uniform] = ACTIONS(2422),
    [anon_sym_row_major] = ACTIONS(2422),
    [anon_sym_column_major] = ACTIONS(2422),
    [anon_sym_globallycoherent] = ACTIONS(2422),
    [anon_sym_centroid] = ACTIONS(2422),
    [anon_sym_noperspective] = ACTIONS(2422),
    [anon_sym_nointerpolation] = ACTIONS(2422),
    [anon_sym_sample] = ACTIONS(2422),
    [anon_sym_linear] = ACTIONS(2422),
    [anon_sym_snorm] = ACTIONS(2422),
    [anon_sym_unorm] = ACTIONS(2422),
    [anon_sym_point] = ACTIONS(2422),
    [anon_sym_line] = ACTIONS(2422),
    [anon_sym_triangleadj] = ACTIONS(2422),
    [anon_sym_lineadj] = ACTIONS(2422),
    [anon_sym_triangle] = ACTIONS(2422),
    [anon_sym_cbuffer] = ACTIONS(2422),
    [anon_sym_interface] = ACTIONS(2422),
    [anon_sym_extension] = ACTIONS(2422),
  },
  [524] = {
    [sym_identifier] = ACTIONS(2422),
    [aux_sym_preproc_include_token1] = ACTIONS(2422),
    [aux_sym_preproc_def_token1] = ACTIONS(2422),
    [aux_sym_preproc_if_token1] = ACTIONS(2422),
    [aux_sym_preproc_if_token2] = ACTIONS(2422),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2422),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2422),
    [sym_preproc_directive] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym_typedef] = ACTIONS(2422),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_out] = ACTIONS(2422),
    [anon_sym_inout] = ACTIONS(2422),
    [anon_sym_virtual] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_using] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2422),
    [anon_sym___based] = ACTIONS(2422),
    [anon_sym___cdecl] = ACTIONS(2422),
    [anon_sym___clrcall] = ACTIONS(2422),
    [anon_sym___stdcall] = ACTIONS(2422),
    [anon_sym___fastcall] = ACTIONS(2422),
    [anon_sym___thiscall] = ACTIONS(2422),
    [anon_sym___vectorcall] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2422),
    [anon_sym_unsigned] = ACTIONS(2422),
    [anon_sym_long] = ACTIONS(2422),
    [anon_sym_short] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_register] = ACTIONS(2422),
    [anon_sym_inline] = ACTIONS(2422),
    [anon_sym___inline] = ACTIONS(2422),
    [anon_sym___inline__] = ACTIONS(2422),
    [anon_sym___forceinline] = ACTIONS(2422),
    [anon_sym_thread_local] = ACTIONS(2422),
    [anon_sym___thread] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [sym_primitive_type] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
    [anon_sym_class] = ACTIONS(2422),
    [anon_sym_struct] = ACTIONS(2422),
    [anon_sym_union] = ACTIONS(2422),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(2422),
    [anon_sym_switch] = ACTIONS(2422),
    [anon_sym_case] = ACTIONS(2422),
    [anon_sym_default] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_break] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(2422),
    [anon_sym_goto] = ACTIONS(2422),
    [anon_sym___try] = ACTIONS(2422),
    [anon_sym___leave] = ACTIONS(2422),
    [anon_sym_not] = ACTIONS(2422),
    [anon_sym_compl] = ACTIONS(2422),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_sizeof] = ACTIONS(2422),
    [anon_sym___alignof__] = ACTIONS(2422),
    [anon_sym___alignof] = ACTIONS(2422),
    [anon_sym__alignof] = ACTIONS(2422),
    [anon_sym_alignof] = ACTIONS(2422),
    [anon_sym__Alignof] = ACTIONS(2422),
    [anon_sym_offsetof] = ACTIONS(2422),
    [anon_sym__Generic] = ACTIONS(2422),
    [anon_sym_asm] = ACTIONS(2422),
    [anon_sym___asm__] = ACTIONS(2422),
    [anon_sym___asm] = ACTIONS(2422),
    [sym_number_literal] = ACTIONS(2420),
    [anon_sym_L_SQUOTE] = ACTIONS(2420),
    [anon_sym_u_SQUOTE] = ACTIONS(2420),
    [anon_sym_U_SQUOTE] = ACTIONS(2420),
    [anon_sym_u8_SQUOTE] = ACTIONS(2420),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [anon_sym_L_DQUOTE] = ACTIONS(2420),
    [anon_sym_u_DQUOTE] = ACTIONS(2420),
    [anon_sym_U_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [sym_true] = ACTIONS(2422),
    [sym_false] = ACTIONS(2422),
    [anon_sym_NULL] = ACTIONS(2422),
    [anon_sym_nullptr] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_decltype] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_explicit] = ACTIONS(2422),
    [anon_sym_typename] = ACTIONS(2422),
    [anon_sym_template] = ACTIONS(2422),
    [anon_sym_operator] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_delete] = ACTIONS(2422),
    [anon_sym_throw] = ACTIONS(2422),
    [anon_sym_namespace] = ACTIONS(2422),
    [anon_sym_static_assert] = ACTIONS(2422),
    [anon_sym_concept] = ACTIONS(2422),
    [anon_sym_co_return] = ACTIONS(2422),
    [anon_sym_co_yield] = ACTIONS(2422),
    [anon_sym_R_DQUOTE] = ACTIONS(2420),
    [anon_sym_LR_DQUOTE] = ACTIONS(2420),
    [anon_sym_uR_DQUOTE] = ACTIONS(2420),
    [anon_sym_UR_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2420),
    [anon_sym_co_await] = ACTIONS(2422),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_requires] = ACTIONS(2422),
    [sym_this] = ACTIONS(2422),
    [anon_sym_discard] = ACTIONS(2422),
    [anon_sym_precise] = ACTIONS(2422),
    [anon_sym_shared] = ACTIONS(2422),
    [anon_sym_groupshared] = ACTIONS(2422),
    [anon_sym_uniform] = ACTIONS(2422),
    [anon_sym_row_major] = ACTIONS(2422),
    [anon_sym_column_major] = ACTIONS(2422),
    [anon_sym_globallycoherent] = ACTIONS(2422),
    [anon_sym_centroid] = ACTIONS(2422),
    [anon_sym_noperspective] = ACTIONS(2422),
    [anon_sym_nointerpolation] = ACTIONS(2422),
    [anon_sym_sample] = ACTIONS(2422),
    [anon_sym_linear] = ACTIONS(2422),
    [anon_sym_snorm] = ACTIONS(2422),
    [anon_sym_unorm] = ACTIONS(2422),
    [anon_sym_point] = ACTIONS(2422),
    [anon_sym_line] = ACTIONS(2422),
    [anon_sym_triangleadj] = ACTIONS(2422),
    [anon_sym_lineadj] = ACTIONS(2422),
    [anon_sym_triangle] = ACTIONS(2422),
    [anon_sym_cbuffer] = ACTIONS(2422),
    [anon_sym_interface] = ACTIONS(2422),
    [anon_sym_extension] = ACTIONS(2422),
  },
  [525] = {
    [sym_identifier] = ACTIONS(2418),
    [aux_sym_preproc_include_token1] = ACTIONS(2418),
    [aux_sym_preproc_def_token1] = ACTIONS(2418),
    [aux_sym_preproc_if_token1] = ACTIONS(2418),
    [aux_sym_preproc_if_token2] = ACTIONS(2418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2418),
    [sym_preproc_directive] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2416),
    [anon_sym_TILDE] = ACTIONS(2416),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym___extension__] = ACTIONS(2418),
    [anon_sym_typedef] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(2418),
    [anon_sym_out] = ACTIONS(2418),
    [anon_sym_inout] = ACTIONS(2418),
    [anon_sym_virtual] = ACTIONS(2418),
    [anon_sym_extern] = ACTIONS(2418),
    [anon_sym___attribute__] = ACTIONS(2418),
    [anon_sym___attribute] = ACTIONS(2418),
    [anon_sym_using] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2416),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2416),
    [anon_sym___declspec] = ACTIONS(2418),
    [anon_sym___based] = ACTIONS(2418),
    [anon_sym___cdecl] = ACTIONS(2418),
    [anon_sym___clrcall] = ACTIONS(2418),
    [anon_sym___stdcall] = ACTIONS(2418),
    [anon_sym___fastcall] = ACTIONS(2418),
    [anon_sym___thiscall] = ACTIONS(2418),
    [anon_sym___vectorcall] = ACTIONS(2418),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_signed] = ACTIONS(2418),
    [anon_sym_unsigned] = ACTIONS(2418),
    [anon_sym_long] = ACTIONS(2418),
    [anon_sym_short] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2418),
    [anon_sym_register] = ACTIONS(2418),
    [anon_sym_inline] = ACTIONS(2418),
    [anon_sym___inline] = ACTIONS(2418),
    [anon_sym___inline__] = ACTIONS(2418),
    [anon_sym___forceinline] = ACTIONS(2418),
    [anon_sym_thread_local] = ACTIONS(2418),
    [anon_sym___thread] = ACTIONS(2418),
    [anon_sym_const] = ACTIONS(2418),
    [anon_sym_constexpr] = ACTIONS(2418),
    [anon_sym_volatile] = ACTIONS(2418),
    [anon_sym_restrict] = ACTIONS(2418),
    [anon_sym___restrict__] = ACTIONS(2418),
    [anon_sym__Atomic] = ACTIONS(2418),
    [anon_sym__Noreturn] = ACTIONS(2418),
    [anon_sym_noreturn] = ACTIONS(2418),
    [anon_sym__Nonnull] = ACTIONS(2418),
    [anon_sym_mutable] = ACTIONS(2418),
    [anon_sym_constinit] = ACTIONS(2418),
    [anon_sym_consteval] = ACTIONS(2418),
    [anon_sym_alignas] = ACTIONS(2418),
    [anon_sym__Alignas] = ACTIONS(2418),
    [sym_primitive_type] = ACTIONS(2418),
    [anon_sym_enum] = ACTIONS(2418),
    [anon_sym_class] = ACTIONS(2418),
    [anon_sym_struct] = ACTIONS(2418),
    [anon_sym_union] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_else] = ACTIONS(2418),
    [anon_sym_switch] = ACTIONS(2418),
    [anon_sym_case] = ACTIONS(2418),
    [anon_sym_default] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_break] = ACTIONS(2418),
    [anon_sym_continue] = ACTIONS(2418),
    [anon_sym_goto] = ACTIONS(2418),
    [anon_sym___try] = ACTIONS(2418),
    [anon_sym___leave] = ACTIONS(2418),
    [anon_sym_not] = ACTIONS(2418),
    [anon_sym_compl] = ACTIONS(2418),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_sizeof] = ACTIONS(2418),
    [anon_sym___alignof__] = ACTIONS(2418),
    [anon_sym___alignof] = ACTIONS(2418),
    [anon_sym__alignof] = ACTIONS(2418),
    [anon_sym_alignof] = ACTIONS(2418),
    [anon_sym__Alignof] = ACTIONS(2418),
    [anon_sym_offsetof] = ACTIONS(2418),
    [anon_sym__Generic] = ACTIONS(2418),
    [anon_sym_asm] = ACTIONS(2418),
    [anon_sym___asm__] = ACTIONS(2418),
    [anon_sym___asm] = ACTIONS(2418),
    [sym_number_literal] = ACTIONS(2416),
    [anon_sym_L_SQUOTE] = ACTIONS(2416),
    [anon_sym_u_SQUOTE] = ACTIONS(2416),
    [anon_sym_U_SQUOTE] = ACTIONS(2416),
    [anon_sym_u8_SQUOTE] = ACTIONS(2416),
    [anon_sym_SQUOTE] = ACTIONS(2416),
    [anon_sym_L_DQUOTE] = ACTIONS(2416),
    [anon_sym_u_DQUOTE] = ACTIONS(2416),
    [anon_sym_U_DQUOTE] = ACTIONS(2416),
    [anon_sym_u8_DQUOTE] = ACTIONS(2416),
    [anon_sym_DQUOTE] = ACTIONS(2416),
    [sym_true] = ACTIONS(2418),
    [sym_false] = ACTIONS(2418),
    [anon_sym_NULL] = ACTIONS(2418),
    [anon_sym_nullptr] = ACTIONS(2418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_This] = ACTIONS(2418),
    [anon_sym_decltype] = ACTIONS(2418),
    [anon_sym_final] = ACTIONS(2418),
    [anon_sym_override] = ACTIONS(2418),
    [anon_sym_explicit] = ACTIONS(2418),
    [anon_sym_typename] = ACTIONS(2418),
    [anon_sym_template] = ACTIONS(2418),
    [anon_sym_operator] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_delete] = ACTIONS(2418),
    [anon_sym_throw] = ACTIONS(2418),
    [anon_sym_namespace] = ACTIONS(2418),
    [anon_sym_static_assert] = ACTIONS(2418),
    [anon_sym_concept] = ACTIONS(2418),
    [anon_sym_co_return] = ACTIONS(2418),
    [anon_sym_co_yield] = ACTIONS(2418),
    [anon_sym_R_DQUOTE] = ACTIONS(2416),
    [anon_sym_LR_DQUOTE] = ACTIONS(2416),
    [anon_sym_uR_DQUOTE] = ACTIONS(2416),
    [anon_sym_UR_DQUOTE] = ACTIONS(2416),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2416),
    [anon_sym_co_await] = ACTIONS(2418),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_requires] = ACTIONS(2418),
    [sym_this] = ACTIONS(2418),
    [anon_sym_discard] = ACTIONS(2418),
    [anon_sym_precise] = ACTIONS(2418),
    [anon_sym_shared] = ACTIONS(2418),
    [anon_sym_groupshared] = ACTIONS(2418),
    [anon_sym_uniform] = ACTIONS(2418),
    [anon_sym_row_major] = ACTIONS(2418),
    [anon_sym_column_major] = ACTIONS(2418),
    [anon_sym_globallycoherent] = ACTIONS(2418),
    [anon_sym_centroid] = ACTIONS(2418),
    [anon_sym_noperspective] = ACTIONS(2418),
    [anon_sym_nointerpolation] = ACTIONS(2418),
    [anon_sym_sample] = ACTIONS(2418),
    [anon_sym_linear] = ACTIONS(2418),
    [anon_sym_snorm] = ACTIONS(2418),
    [anon_sym_unorm] = ACTIONS(2418),
    [anon_sym_point] = ACTIONS(2418),
    [anon_sym_line] = ACTIONS(2418),
    [anon_sym_triangleadj] = ACTIONS(2418),
    [anon_sym_lineadj] = ACTIONS(2418),
    [anon_sym_triangle] = ACTIONS(2418),
    [anon_sym_cbuffer] = ACTIONS(2418),
    [anon_sym_interface] = ACTIONS(2418),
    [anon_sym_extension] = ACTIONS(2418),
  },
  [526] = {
    [sym_identifier] = ACTIONS(2422),
    [aux_sym_preproc_include_token1] = ACTIONS(2422),
    [aux_sym_preproc_def_token1] = ACTIONS(2422),
    [aux_sym_preproc_if_token1] = ACTIONS(2422),
    [aux_sym_preproc_if_token2] = ACTIONS(2422),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2422),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2422),
    [sym_preproc_directive] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym_typedef] = ACTIONS(2422),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_out] = ACTIONS(2422),
    [anon_sym_inout] = ACTIONS(2422),
    [anon_sym_virtual] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_using] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2422),
    [anon_sym___based] = ACTIONS(2422),
    [anon_sym___cdecl] = ACTIONS(2422),
    [anon_sym___clrcall] = ACTIONS(2422),
    [anon_sym___stdcall] = ACTIONS(2422),
    [anon_sym___fastcall] = ACTIONS(2422),
    [anon_sym___thiscall] = ACTIONS(2422),
    [anon_sym___vectorcall] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2422),
    [anon_sym_unsigned] = ACTIONS(2422),
    [anon_sym_long] = ACTIONS(2422),
    [anon_sym_short] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_register] = ACTIONS(2422),
    [anon_sym_inline] = ACTIONS(2422),
    [anon_sym___inline] = ACTIONS(2422),
    [anon_sym___inline__] = ACTIONS(2422),
    [anon_sym___forceinline] = ACTIONS(2422),
    [anon_sym_thread_local] = ACTIONS(2422),
    [anon_sym___thread] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [sym_primitive_type] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
    [anon_sym_class] = ACTIONS(2422),
    [anon_sym_struct] = ACTIONS(2422),
    [anon_sym_union] = ACTIONS(2422),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(2422),
    [anon_sym_switch] = ACTIONS(2422),
    [anon_sym_case] = ACTIONS(2422),
    [anon_sym_default] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_break] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(2422),
    [anon_sym_goto] = ACTIONS(2422),
    [anon_sym___try] = ACTIONS(2422),
    [anon_sym___leave] = ACTIONS(2422),
    [anon_sym_not] = ACTIONS(2422),
    [anon_sym_compl] = ACTIONS(2422),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_sizeof] = ACTIONS(2422),
    [anon_sym___alignof__] = ACTIONS(2422),
    [anon_sym___alignof] = ACTIONS(2422),
    [anon_sym__alignof] = ACTIONS(2422),
    [anon_sym_alignof] = ACTIONS(2422),
    [anon_sym__Alignof] = ACTIONS(2422),
    [anon_sym_offsetof] = ACTIONS(2422),
    [anon_sym__Generic] = ACTIONS(2422),
    [anon_sym_asm] = ACTIONS(2422),
    [anon_sym___asm__] = ACTIONS(2422),
    [anon_sym___asm] = ACTIONS(2422),
    [sym_number_literal] = ACTIONS(2420),
    [anon_sym_L_SQUOTE] = ACTIONS(2420),
    [anon_sym_u_SQUOTE] = ACTIONS(2420),
    [anon_sym_U_SQUOTE] = ACTIONS(2420),
    [anon_sym_u8_SQUOTE] = ACTIONS(2420),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [anon_sym_L_DQUOTE] = ACTIONS(2420),
    [anon_sym_u_DQUOTE] = ACTIONS(2420),
    [anon_sym_U_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [sym_true] = ACTIONS(2422),
    [sym_false] = ACTIONS(2422),
    [anon_sym_NULL] = ACTIONS(2422),
    [anon_sym_nullptr] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_decltype] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_explicit] = ACTIONS(2422),
    [anon_sym_typename] = ACTIONS(2422),
    [anon_sym_template] = ACTIONS(2422),
    [anon_sym_operator] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_delete] = ACTIONS(2422),
    [anon_sym_throw] = ACTIONS(2422),
    [anon_sym_namespace] = ACTIONS(2422),
    [anon_sym_static_assert] = ACTIONS(2422),
    [anon_sym_concept] = ACTIONS(2422),
    [anon_sym_co_return] = ACTIONS(2422),
    [anon_sym_co_yield] = ACTIONS(2422),
    [anon_sym_R_DQUOTE] = ACTIONS(2420),
    [anon_sym_LR_DQUOTE] = ACTIONS(2420),
    [anon_sym_uR_DQUOTE] = ACTIONS(2420),
    [anon_sym_UR_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2420),
    [anon_sym_co_await] = ACTIONS(2422),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_requires] = ACTIONS(2422),
    [sym_this] = ACTIONS(2422),
    [anon_sym_discard] = ACTIONS(2422),
    [anon_sym_precise] = ACTIONS(2422),
    [anon_sym_shared] = ACTIONS(2422),
    [anon_sym_groupshared] = ACTIONS(2422),
    [anon_sym_uniform] = ACTIONS(2422),
    [anon_sym_row_major] = ACTIONS(2422),
    [anon_sym_column_major] = ACTIONS(2422),
    [anon_sym_globallycoherent] = ACTIONS(2422),
    [anon_sym_centroid] = ACTIONS(2422),
    [anon_sym_noperspective] = ACTIONS(2422),
    [anon_sym_nointerpolation] = ACTIONS(2422),
    [anon_sym_sample] = ACTIONS(2422),
    [anon_sym_linear] = ACTIONS(2422),
    [anon_sym_snorm] = ACTIONS(2422),
    [anon_sym_unorm] = ACTIONS(2422),
    [anon_sym_point] = ACTIONS(2422),
    [anon_sym_line] = ACTIONS(2422),
    [anon_sym_triangleadj] = ACTIONS(2422),
    [anon_sym_lineadj] = ACTIONS(2422),
    [anon_sym_triangle] = ACTIONS(2422),
    [anon_sym_cbuffer] = ACTIONS(2422),
    [anon_sym_interface] = ACTIONS(2422),
    [anon_sym_extension] = ACTIONS(2422),
  },
  [527] = {
    [sym_identifier] = ACTIONS(2243),
    [aux_sym_preproc_include_token1] = ACTIONS(2243),
    [aux_sym_preproc_def_token1] = ACTIONS(2243),
    [aux_sym_preproc_if_token1] = ACTIONS(2243),
    [aux_sym_preproc_if_token2] = ACTIONS(2243),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2243),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2243),
    [sym_preproc_directive] = ACTIONS(2243),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2243),
    [anon_sym_PLUS] = ACTIONS(2243),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_COLON] = ACTIONS(2243),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym_typedef] = ACTIONS(2243),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_out] = ACTIONS(2243),
    [anon_sym_inout] = ACTIONS(2243),
    [anon_sym_virtual] = ACTIONS(2243),
    [anon_sym_extern] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym___attribute] = ACTIONS(2243),
    [anon_sym_using] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2243),
    [anon_sym___based] = ACTIONS(2243),
    [anon_sym___cdecl] = ACTIONS(2243),
    [anon_sym___clrcall] = ACTIONS(2243),
    [anon_sym___stdcall] = ACTIONS(2243),
    [anon_sym___fastcall] = ACTIONS(2243),
    [anon_sym___thiscall] = ACTIONS(2243),
    [anon_sym___vectorcall] = ACTIONS(2243),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_signed] = ACTIONS(2243),
    [anon_sym_unsigned] = ACTIONS(2243),
    [anon_sym_long] = ACTIONS(2243),
    [anon_sym_short] = ACTIONS(2243),
    [anon_sym_LBRACK] = ACTIONS(2243),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_register] = ACTIONS(2243),
    [anon_sym_inline] = ACTIONS(2243),
    [anon_sym___inline] = ACTIONS(2243),
    [anon_sym___inline__] = ACTIONS(2243),
    [anon_sym___forceinline] = ACTIONS(2243),
    [anon_sym_thread_local] = ACTIONS(2243),
    [anon_sym___thread] = ACTIONS(2243),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym__Nonnull] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [sym_primitive_type] = ACTIONS(2243),
    [anon_sym_enum] = ACTIONS(2243),
    [anon_sym_class] = ACTIONS(2243),
    [anon_sym_struct] = ACTIONS(2243),
    [anon_sym_union] = ACTIONS(2243),
    [anon_sym_if] = ACTIONS(2243),
    [anon_sym_else] = ACTIONS(2243),
    [anon_sym_switch] = ACTIONS(2243),
    [anon_sym_case] = ACTIONS(2243),
    [anon_sym_default] = ACTIONS(2243),
    [anon_sym_while] = ACTIONS(2243),
    [anon_sym_do] = ACTIONS(2243),
    [anon_sym_for] = ACTIONS(2243),
    [anon_sym_return] = ACTIONS(2243),
    [anon_sym_break] = ACTIONS(2243),
    [anon_sym_continue] = ACTIONS(2243),
    [anon_sym_goto] = ACTIONS(2243),
    [anon_sym___try] = ACTIONS(2243),
    [anon_sym___leave] = ACTIONS(2243),
    [anon_sym_not] = ACTIONS(2243),
    [anon_sym_compl] = ACTIONS(2243),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_sizeof] = ACTIONS(2243),
    [anon_sym___alignof__] = ACTIONS(2243),
    [anon_sym___alignof] = ACTIONS(2243),
    [anon_sym__alignof] = ACTIONS(2243),
    [anon_sym_alignof] = ACTIONS(2243),
    [anon_sym__Alignof] = ACTIONS(2243),
    [anon_sym_offsetof] = ACTIONS(2243),
    [anon_sym__Generic] = ACTIONS(2243),
    [anon_sym_asm] = ACTIONS(2243),
    [anon_sym___asm__] = ACTIONS(2243),
    [anon_sym___asm] = ACTIONS(2243),
    [sym_number_literal] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2250),
    [anon_sym_u_SQUOTE] = ACTIONS(2250),
    [anon_sym_U_SQUOTE] = ACTIONS(2250),
    [anon_sym_u8_SQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_L_DQUOTE] = ACTIONS(2250),
    [anon_sym_u_DQUOTE] = ACTIONS(2250),
    [anon_sym_U_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [sym_true] = ACTIONS(2243),
    [sym_false] = ACTIONS(2243),
    [anon_sym_NULL] = ACTIONS(2243),
    [anon_sym_nullptr] = ACTIONS(2243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2243),
    [anon_sym_let] = ACTIONS(2243),
    [anon_sym_This] = ACTIONS(2243),
    [anon_sym_decltype] = ACTIONS(2243),
    [anon_sym_final] = ACTIONS(2243),
    [anon_sym_override] = ACTIONS(2243),
    [anon_sym_explicit] = ACTIONS(2243),
    [anon_sym_typename] = ACTIONS(2243),
    [anon_sym_template] = ACTIONS(2243),
    [anon_sym_operator] = ACTIONS(2243),
    [anon_sym_try] = ACTIONS(2243),
    [anon_sym_delete] = ACTIONS(2243),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_namespace] = ACTIONS(2243),
    [anon_sym_static_assert] = ACTIONS(2243),
    [anon_sym_concept] = ACTIONS(2243),
    [anon_sym_co_return] = ACTIONS(2243),
    [anon_sym_co_yield] = ACTIONS(2243),
    [anon_sym_R_DQUOTE] = ACTIONS(2250),
    [anon_sym_LR_DQUOTE] = ACTIONS(2250),
    [anon_sym_uR_DQUOTE] = ACTIONS(2250),
    [anon_sym_UR_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2250),
    [anon_sym_co_await] = ACTIONS(2243),
    [anon_sym_new] = ACTIONS(2243),
    [anon_sym_requires] = ACTIONS(2243),
    [sym_this] = ACTIONS(2243),
    [anon_sym_discard] = ACTIONS(2243),
    [anon_sym_precise] = ACTIONS(2243),
    [anon_sym_shared] = ACTIONS(2243),
    [anon_sym_groupshared] = ACTIONS(2243),
    [anon_sym_uniform] = ACTIONS(2243),
    [anon_sym_row_major] = ACTIONS(2243),
    [anon_sym_column_major] = ACTIONS(2243),
    [anon_sym_globallycoherent] = ACTIONS(2243),
    [anon_sym_centroid] = ACTIONS(2243),
    [anon_sym_noperspective] = ACTIONS(2243),
    [anon_sym_nointerpolation] = ACTIONS(2243),
    [anon_sym_sample] = ACTIONS(2243),
    [anon_sym_linear] = ACTIONS(2243),
    [anon_sym_snorm] = ACTIONS(2243),
    [anon_sym_unorm] = ACTIONS(2243),
    [anon_sym_point] = ACTIONS(2243),
    [anon_sym_line] = ACTIONS(2243),
    [anon_sym_triangleadj] = ACTIONS(2243),
    [anon_sym_lineadj] = ACTIONS(2243),
    [anon_sym_triangle] = ACTIONS(2243),
    [anon_sym_cbuffer] = ACTIONS(2243),
    [anon_sym_interface] = ACTIONS(2243),
    [anon_sym_extension] = ACTIONS(2243),
  },
  [528] = {
    [sym_identifier] = ACTIONS(2428),
    [aux_sym_preproc_include_token1] = ACTIONS(2428),
    [aux_sym_preproc_def_token1] = ACTIONS(2428),
    [aux_sym_preproc_if_token1] = ACTIONS(2428),
    [aux_sym_preproc_if_token2] = ACTIONS(2428),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2428),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2428),
    [sym_preproc_directive] = ACTIONS(2428),
    [anon_sym_LPAREN2] = ACTIONS(2426),
    [anon_sym_BANG] = ACTIONS(2426),
    [anon_sym_TILDE] = ACTIONS(2426),
    [anon_sym_DASH] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2428),
    [anon_sym_STAR] = ACTIONS(2426),
    [anon_sym_AMP_AMP] = ACTIONS(2426),
    [anon_sym_AMP] = ACTIONS(2428),
    [anon_sym_COLON] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2426),
    [anon_sym___extension__] = ACTIONS(2428),
    [anon_sym_typedef] = ACTIONS(2428),
    [anon_sym_in] = ACTIONS(2428),
    [anon_sym_out] = ACTIONS(2428),
    [anon_sym_inout] = ACTIONS(2428),
    [anon_sym_virtual] = ACTIONS(2428),
    [anon_sym_extern] = ACTIONS(2428),
    [anon_sym___attribute__] = ACTIONS(2428),
    [anon_sym___attribute] = ACTIONS(2428),
    [anon_sym_using] = ACTIONS(2428),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2426),
    [anon_sym___declspec] = ACTIONS(2428),
    [anon_sym___based] = ACTIONS(2428),
    [anon_sym___cdecl] = ACTIONS(2428),
    [anon_sym___clrcall] = ACTIONS(2428),
    [anon_sym___stdcall] = ACTIONS(2428),
    [anon_sym___fastcall] = ACTIONS(2428),
    [anon_sym___thiscall] = ACTIONS(2428),
    [anon_sym___vectorcall] = ACTIONS(2428),
    [anon_sym_LBRACE] = ACTIONS(2426),
    [anon_sym_signed] = ACTIONS(2428),
    [anon_sym_unsigned] = ACTIONS(2428),
    [anon_sym_long] = ACTIONS(2428),
    [anon_sym_short] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_static] = ACTIONS(2428),
    [anon_sym_register] = ACTIONS(2428),
    [anon_sym_inline] = ACTIONS(2428),
    [anon_sym___inline] = ACTIONS(2428),
    [anon_sym___inline__] = ACTIONS(2428),
    [anon_sym___forceinline] = ACTIONS(2428),
    [anon_sym_thread_local] = ACTIONS(2428),
    [anon_sym___thread] = ACTIONS(2428),
    [anon_sym_const] = ACTIONS(2428),
    [anon_sym_constexpr] = ACTIONS(2428),
    [anon_sym_volatile] = ACTIONS(2428),
    [anon_sym_restrict] = ACTIONS(2428),
    [anon_sym___restrict__] = ACTIONS(2428),
    [anon_sym__Atomic] = ACTIONS(2428),
    [anon_sym__Noreturn] = ACTIONS(2428),
    [anon_sym_noreturn] = ACTIONS(2428),
    [anon_sym__Nonnull] = ACTIONS(2428),
    [anon_sym_mutable] = ACTIONS(2428),
    [anon_sym_constinit] = ACTIONS(2428),
    [anon_sym_consteval] = ACTIONS(2428),
    [anon_sym_alignas] = ACTIONS(2428),
    [anon_sym__Alignas] = ACTIONS(2428),
    [sym_primitive_type] = ACTIONS(2428),
    [anon_sym_enum] = ACTIONS(2428),
    [anon_sym_class] = ACTIONS(2428),
    [anon_sym_struct] = ACTIONS(2428),
    [anon_sym_union] = ACTIONS(2428),
    [anon_sym_if] = ACTIONS(2428),
    [anon_sym_else] = ACTIONS(2428),
    [anon_sym_switch] = ACTIONS(2428),
    [anon_sym_case] = ACTIONS(2428),
    [anon_sym_default] = ACTIONS(2428),
    [anon_sym_while] = ACTIONS(2428),
    [anon_sym_do] = ACTIONS(2428),
    [anon_sym_for] = ACTIONS(2428),
    [anon_sym_return] = ACTIONS(2428),
    [anon_sym_break] = ACTIONS(2428),
    [anon_sym_continue] = ACTIONS(2428),
    [anon_sym_goto] = ACTIONS(2428),
    [anon_sym___try] = ACTIONS(2428),
    [anon_sym___leave] = ACTIONS(2428),
    [anon_sym_not] = ACTIONS(2428),
    [anon_sym_compl] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2426),
    [anon_sym_PLUS_PLUS] = ACTIONS(2426),
    [anon_sym_sizeof] = ACTIONS(2428),
    [anon_sym___alignof__] = ACTIONS(2428),
    [anon_sym___alignof] = ACTIONS(2428),
    [anon_sym__alignof] = ACTIONS(2428),
    [anon_sym_alignof] = ACTIONS(2428),
    [anon_sym__Alignof] = ACTIONS(2428),
    [anon_sym_offsetof] = ACTIONS(2428),
    [anon_sym__Generic] = ACTIONS(2428),
    [anon_sym_asm] = ACTIONS(2428),
    [anon_sym___asm__] = ACTIONS(2428),
    [anon_sym___asm] = ACTIONS(2428),
    [sym_number_literal] = ACTIONS(2426),
    [anon_sym_L_SQUOTE] = ACTIONS(2426),
    [anon_sym_u_SQUOTE] = ACTIONS(2426),
    [anon_sym_U_SQUOTE] = ACTIONS(2426),
    [anon_sym_u8_SQUOTE] = ACTIONS(2426),
    [anon_sym_SQUOTE] = ACTIONS(2426),
    [anon_sym_L_DQUOTE] = ACTIONS(2426),
    [anon_sym_u_DQUOTE] = ACTIONS(2426),
    [anon_sym_U_DQUOTE] = ACTIONS(2426),
    [anon_sym_u8_DQUOTE] = ACTIONS(2426),
    [anon_sym_DQUOTE] = ACTIONS(2426),
    [sym_true] = ACTIONS(2428),
    [sym_false] = ACTIONS(2428),
    [anon_sym_NULL] = ACTIONS(2428),
    [anon_sym_nullptr] = ACTIONS(2428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2428),
    [anon_sym_let] = ACTIONS(2428),
    [anon_sym_This] = ACTIONS(2428),
    [anon_sym_decltype] = ACTIONS(2428),
    [anon_sym_final] = ACTIONS(2428),
    [anon_sym_override] = ACTIONS(2428),
    [anon_sym_explicit] = ACTIONS(2428),
    [anon_sym_typename] = ACTIONS(2428),
    [anon_sym_template] = ACTIONS(2428),
    [anon_sym_operator] = ACTIONS(2428),
    [anon_sym_try] = ACTIONS(2428),
    [anon_sym_delete] = ACTIONS(2428),
    [anon_sym_throw] = ACTIONS(2428),
    [anon_sym_namespace] = ACTIONS(2428),
    [anon_sym_static_assert] = ACTIONS(2428),
    [anon_sym_concept] = ACTIONS(2428),
    [anon_sym_co_return] = ACTIONS(2428),
    [anon_sym_co_yield] = ACTIONS(2428),
    [anon_sym_R_DQUOTE] = ACTIONS(2426),
    [anon_sym_LR_DQUOTE] = ACTIONS(2426),
    [anon_sym_uR_DQUOTE] = ACTIONS(2426),
    [anon_sym_UR_DQUOTE] = ACTIONS(2426),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2426),
    [anon_sym_co_await] = ACTIONS(2428),
    [anon_sym_new] = ACTIONS(2428),
    [anon_sym_requires] = ACTIONS(2428),
    [sym_this] = ACTIONS(2428),
    [anon_sym_discard] = ACTIONS(2428),
    [anon_sym_precise] = ACTIONS(2428),
    [anon_sym_shared] = ACTIONS(2428),
    [anon_sym_groupshared] = ACTIONS(2428),
    [anon_sym_uniform] = ACTIONS(2428),
    [anon_sym_row_major] = ACTIONS(2428),
    [anon_sym_column_major] = ACTIONS(2428),
    [anon_sym_globallycoherent] = ACTIONS(2428),
    [anon_sym_centroid] = ACTIONS(2428),
    [anon_sym_noperspective] = ACTIONS(2428),
    [anon_sym_nointerpolation] = ACTIONS(2428),
    [anon_sym_sample] = ACTIONS(2428),
    [anon_sym_linear] = ACTIONS(2428),
    [anon_sym_snorm] = ACTIONS(2428),
    [anon_sym_unorm] = ACTIONS(2428),
    [anon_sym_point] = ACTIONS(2428),
    [anon_sym_line] = ACTIONS(2428),
    [anon_sym_triangleadj] = ACTIONS(2428),
    [anon_sym_lineadj] = ACTIONS(2428),
    [anon_sym_triangle] = ACTIONS(2428),
    [anon_sym_cbuffer] = ACTIONS(2428),
    [anon_sym_interface] = ACTIONS(2428),
    [anon_sym_extension] = ACTIONS(2428),
  },
  [529] = {
    [sym_identifier] = ACTIONS(3677),
    [aux_sym_preproc_include_token1] = ACTIONS(3677),
    [aux_sym_preproc_def_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token2] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3677),
    [aux_sym_preproc_else_token1] = ACTIONS(3677),
    [aux_sym_preproc_elif_token1] = ACTIONS(3677),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3677),
    [sym_preproc_directive] = ACTIONS(3677),
    [anon_sym_LPAREN2] = ACTIONS(3679),
    [anon_sym_BANG] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3677),
    [anon_sym_PLUS] = ACTIONS(3677),
    [anon_sym_STAR] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_AMP] = ACTIONS(3677),
    [anon_sym_SEMI] = ACTIONS(3679),
    [anon_sym___extension__] = ACTIONS(3677),
    [anon_sym_typedef] = ACTIONS(3677),
    [anon_sym_in] = ACTIONS(3677),
    [anon_sym_out] = ACTIONS(3677),
    [anon_sym_inout] = ACTIONS(3677),
    [anon_sym_virtual] = ACTIONS(3677),
    [anon_sym_extern] = ACTIONS(3677),
    [anon_sym___attribute__] = ACTIONS(3677),
    [anon_sym___attribute] = ACTIONS(3677),
    [anon_sym_using] = ACTIONS(3677),
    [anon_sym_COLON_COLON] = ACTIONS(3679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3679),
    [anon_sym___declspec] = ACTIONS(3677),
    [anon_sym___based] = ACTIONS(3677),
    [anon_sym___cdecl] = ACTIONS(3677),
    [anon_sym___clrcall] = ACTIONS(3677),
    [anon_sym___stdcall] = ACTIONS(3677),
    [anon_sym___fastcall] = ACTIONS(3677),
    [anon_sym___thiscall] = ACTIONS(3677),
    [anon_sym___vectorcall] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_signed] = ACTIONS(3677),
    [anon_sym_unsigned] = ACTIONS(3677),
    [anon_sym_long] = ACTIONS(3677),
    [anon_sym_short] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3677),
    [anon_sym_static] = ACTIONS(3677),
    [anon_sym_register] = ACTIONS(3677),
    [anon_sym_inline] = ACTIONS(3677),
    [anon_sym___inline] = ACTIONS(3677),
    [anon_sym___inline__] = ACTIONS(3677),
    [anon_sym___forceinline] = ACTIONS(3677),
    [anon_sym_thread_local] = ACTIONS(3677),
    [anon_sym___thread] = ACTIONS(3677),
    [anon_sym_const] = ACTIONS(3677),
    [anon_sym_constexpr] = ACTIONS(3677),
    [anon_sym_volatile] = ACTIONS(3677),
    [anon_sym_restrict] = ACTIONS(3677),
    [anon_sym___restrict__] = ACTIONS(3677),
    [anon_sym__Atomic] = ACTIONS(3677),
    [anon_sym__Noreturn] = ACTIONS(3677),
    [anon_sym_noreturn] = ACTIONS(3677),
    [anon_sym__Nonnull] = ACTIONS(3677),
    [anon_sym_mutable] = ACTIONS(3677),
    [anon_sym_constinit] = ACTIONS(3677),
    [anon_sym_consteval] = ACTIONS(3677),
    [anon_sym_alignas] = ACTIONS(3677),
    [anon_sym__Alignas] = ACTIONS(3677),
    [sym_primitive_type] = ACTIONS(3677),
    [anon_sym_enum] = ACTIONS(3677),
    [anon_sym_class] = ACTIONS(3677),
    [anon_sym_struct] = ACTIONS(3677),
    [anon_sym_union] = ACTIONS(3677),
    [anon_sym_if] = ACTIONS(3677),
    [anon_sym_switch] = ACTIONS(3677),
    [anon_sym_case] = ACTIONS(3677),
    [anon_sym_default] = ACTIONS(3677),
    [anon_sym_while] = ACTIONS(3677),
    [anon_sym_do] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3677),
    [anon_sym_return] = ACTIONS(3677),
    [anon_sym_break] = ACTIONS(3677),
    [anon_sym_continue] = ACTIONS(3677),
    [anon_sym_goto] = ACTIONS(3677),
    [anon_sym___try] = ACTIONS(3677),
    [anon_sym___leave] = ACTIONS(3677),
    [anon_sym_not] = ACTIONS(3677),
    [anon_sym_compl] = ACTIONS(3677),
    [anon_sym_DASH_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_PLUS] = ACTIONS(3679),
    [anon_sym_sizeof] = ACTIONS(3677),
    [anon_sym___alignof__] = ACTIONS(3677),
    [anon_sym___alignof] = ACTIONS(3677),
    [anon_sym__alignof] = ACTIONS(3677),
    [anon_sym_alignof] = ACTIONS(3677),
    [anon_sym__Alignof] = ACTIONS(3677),
    [anon_sym_offsetof] = ACTIONS(3677),
    [anon_sym__Generic] = ACTIONS(3677),
    [anon_sym_asm] = ACTIONS(3677),
    [anon_sym___asm__] = ACTIONS(3677),
    [anon_sym___asm] = ACTIONS(3677),
    [sym_number_literal] = ACTIONS(3679),
    [anon_sym_L_SQUOTE] = ACTIONS(3679),
    [anon_sym_u_SQUOTE] = ACTIONS(3679),
    [anon_sym_U_SQUOTE] = ACTIONS(3679),
    [anon_sym_u8_SQUOTE] = ACTIONS(3679),
    [anon_sym_SQUOTE] = ACTIONS(3679),
    [anon_sym_L_DQUOTE] = ACTIONS(3679),
    [anon_sym_u_DQUOTE] = ACTIONS(3679),
    [anon_sym_U_DQUOTE] = ACTIONS(3679),
    [anon_sym_u8_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [sym_true] = ACTIONS(3677),
    [sym_false] = ACTIONS(3677),
    [anon_sym_NULL] = ACTIONS(3677),
    [anon_sym_nullptr] = ACTIONS(3677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3677),
    [anon_sym_let] = ACTIONS(3677),
    [anon_sym_This] = ACTIONS(3677),
    [anon_sym_decltype] = ACTIONS(3677),
    [anon_sym_explicit] = ACTIONS(3677),
    [anon_sym_typename] = ACTIONS(3677),
    [anon_sym_template] = ACTIONS(3677),
    [anon_sym_operator] = ACTIONS(3677),
    [anon_sym_try] = ACTIONS(3677),
    [anon_sym_delete] = ACTIONS(3677),
    [anon_sym_throw] = ACTIONS(3677),
    [anon_sym_namespace] = ACTIONS(3677),
    [anon_sym_static_assert] = ACTIONS(3677),
    [anon_sym_concept] = ACTIONS(3677),
    [anon_sym_co_return] = ACTIONS(3677),
    [anon_sym_co_yield] = ACTIONS(3677),
    [anon_sym_R_DQUOTE] = ACTIONS(3679),
    [anon_sym_LR_DQUOTE] = ACTIONS(3679),
    [anon_sym_uR_DQUOTE] = ACTIONS(3679),
    [anon_sym_UR_DQUOTE] = ACTIONS(3679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3679),
    [anon_sym_co_await] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3677),
    [anon_sym_requires] = ACTIONS(3677),
    [sym_this] = ACTIONS(3677),
    [anon_sym_discard] = ACTIONS(3677),
    [anon_sym_precise] = ACTIONS(3677),
    [anon_sym_shared] = ACTIONS(3677),
    [anon_sym_groupshared] = ACTIONS(3677),
    [anon_sym_uniform] = ACTIONS(3677),
    [anon_sym_row_major] = ACTIONS(3677),
    [anon_sym_column_major] = ACTIONS(3677),
    [anon_sym_globallycoherent] = ACTIONS(3677),
    [anon_sym_centroid] = ACTIONS(3677),
    [anon_sym_noperspective] = ACTIONS(3677),
    [anon_sym_nointerpolation] = ACTIONS(3677),
    [anon_sym_sample] = ACTIONS(3677),
    [anon_sym_linear] = ACTIONS(3677),
    [anon_sym_snorm] = ACTIONS(3677),
    [anon_sym_unorm] = ACTIONS(3677),
    [anon_sym_point] = ACTIONS(3677),
    [anon_sym_line] = ACTIONS(3677),
    [anon_sym_triangleadj] = ACTIONS(3677),
    [anon_sym_lineadj] = ACTIONS(3677),
    [anon_sym_triangle] = ACTIONS(3677),
    [anon_sym_cbuffer] = ACTIONS(3677),
    [anon_sym_interface] = ACTIONS(3677),
    [anon_sym_extension] = ACTIONS(3677),
  },
  [530] = {
    [sym_identifier] = ACTIONS(3677),
    [aux_sym_preproc_include_token1] = ACTIONS(3677),
    [aux_sym_preproc_def_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token2] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3677),
    [aux_sym_preproc_else_token1] = ACTIONS(3677),
    [aux_sym_preproc_elif_token1] = ACTIONS(3677),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3677),
    [sym_preproc_directive] = ACTIONS(3677),
    [anon_sym_LPAREN2] = ACTIONS(3679),
    [anon_sym_BANG] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3677),
    [anon_sym_PLUS] = ACTIONS(3677),
    [anon_sym_STAR] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_AMP] = ACTIONS(3677),
    [anon_sym_SEMI] = ACTIONS(3679),
    [anon_sym___extension__] = ACTIONS(3677),
    [anon_sym_typedef] = ACTIONS(3677),
    [anon_sym_in] = ACTIONS(3677),
    [anon_sym_out] = ACTIONS(3677),
    [anon_sym_inout] = ACTIONS(3677),
    [anon_sym_virtual] = ACTIONS(3677),
    [anon_sym_extern] = ACTIONS(3677),
    [anon_sym___attribute__] = ACTIONS(3677),
    [anon_sym___attribute] = ACTIONS(3677),
    [anon_sym_using] = ACTIONS(3677),
    [anon_sym_COLON_COLON] = ACTIONS(3679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3679),
    [anon_sym___declspec] = ACTIONS(3677),
    [anon_sym___based] = ACTIONS(3677),
    [anon_sym___cdecl] = ACTIONS(3677),
    [anon_sym___clrcall] = ACTIONS(3677),
    [anon_sym___stdcall] = ACTIONS(3677),
    [anon_sym___fastcall] = ACTIONS(3677),
    [anon_sym___thiscall] = ACTIONS(3677),
    [anon_sym___vectorcall] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_signed] = ACTIONS(3677),
    [anon_sym_unsigned] = ACTIONS(3677),
    [anon_sym_long] = ACTIONS(3677),
    [anon_sym_short] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3677),
    [anon_sym_static] = ACTIONS(3677),
    [anon_sym_register] = ACTIONS(3677),
    [anon_sym_inline] = ACTIONS(3677),
    [anon_sym___inline] = ACTIONS(3677),
    [anon_sym___inline__] = ACTIONS(3677),
    [anon_sym___forceinline] = ACTIONS(3677),
    [anon_sym_thread_local] = ACTIONS(3677),
    [anon_sym___thread] = ACTIONS(3677),
    [anon_sym_const] = ACTIONS(3677),
    [anon_sym_constexpr] = ACTIONS(3677),
    [anon_sym_volatile] = ACTIONS(3677),
    [anon_sym_restrict] = ACTIONS(3677),
    [anon_sym___restrict__] = ACTIONS(3677),
    [anon_sym__Atomic] = ACTIONS(3677),
    [anon_sym__Noreturn] = ACTIONS(3677),
    [anon_sym_noreturn] = ACTIONS(3677),
    [anon_sym__Nonnull] = ACTIONS(3677),
    [anon_sym_mutable] = ACTIONS(3677),
    [anon_sym_constinit] = ACTIONS(3677),
    [anon_sym_consteval] = ACTIONS(3677),
    [anon_sym_alignas] = ACTIONS(3677),
    [anon_sym__Alignas] = ACTIONS(3677),
    [sym_primitive_type] = ACTIONS(3677),
    [anon_sym_enum] = ACTIONS(3677),
    [anon_sym_class] = ACTIONS(3677),
    [anon_sym_struct] = ACTIONS(3677),
    [anon_sym_union] = ACTIONS(3677),
    [anon_sym_if] = ACTIONS(3677),
    [anon_sym_switch] = ACTIONS(3677),
    [anon_sym_case] = ACTIONS(3677),
    [anon_sym_default] = ACTIONS(3677),
    [anon_sym_while] = ACTIONS(3677),
    [anon_sym_do] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3677),
    [anon_sym_return] = ACTIONS(3677),
    [anon_sym_break] = ACTIONS(3677),
    [anon_sym_continue] = ACTIONS(3677),
    [anon_sym_goto] = ACTIONS(3677),
    [anon_sym___try] = ACTIONS(3677),
    [anon_sym___leave] = ACTIONS(3677),
    [anon_sym_not] = ACTIONS(3677),
    [anon_sym_compl] = ACTIONS(3677),
    [anon_sym_DASH_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_PLUS] = ACTIONS(3679),
    [anon_sym_sizeof] = ACTIONS(3677),
    [anon_sym___alignof__] = ACTIONS(3677),
    [anon_sym___alignof] = ACTIONS(3677),
    [anon_sym__alignof] = ACTIONS(3677),
    [anon_sym_alignof] = ACTIONS(3677),
    [anon_sym__Alignof] = ACTIONS(3677),
    [anon_sym_offsetof] = ACTIONS(3677),
    [anon_sym__Generic] = ACTIONS(3677),
    [anon_sym_asm] = ACTIONS(3677),
    [anon_sym___asm__] = ACTIONS(3677),
    [anon_sym___asm] = ACTIONS(3677),
    [sym_number_literal] = ACTIONS(3679),
    [anon_sym_L_SQUOTE] = ACTIONS(3679),
    [anon_sym_u_SQUOTE] = ACTIONS(3679),
    [anon_sym_U_SQUOTE] = ACTIONS(3679),
    [anon_sym_u8_SQUOTE] = ACTIONS(3679),
    [anon_sym_SQUOTE] = ACTIONS(3679),
    [anon_sym_L_DQUOTE] = ACTIONS(3679),
    [anon_sym_u_DQUOTE] = ACTIONS(3679),
    [anon_sym_U_DQUOTE] = ACTIONS(3679),
    [anon_sym_u8_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [sym_true] = ACTIONS(3677),
    [sym_false] = ACTIONS(3677),
    [anon_sym_NULL] = ACTIONS(3677),
    [anon_sym_nullptr] = ACTIONS(3677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3677),
    [anon_sym_let] = ACTIONS(3677),
    [anon_sym_This] = ACTIONS(3677),
    [anon_sym_decltype] = ACTIONS(3677),
    [anon_sym_explicit] = ACTIONS(3677),
    [anon_sym_typename] = ACTIONS(3677),
    [anon_sym_template] = ACTIONS(3677),
    [anon_sym_operator] = ACTIONS(3677),
    [anon_sym_try] = ACTIONS(3677),
    [anon_sym_delete] = ACTIONS(3677),
    [anon_sym_throw] = ACTIONS(3677),
    [anon_sym_namespace] = ACTIONS(3677),
    [anon_sym_static_assert] = ACTIONS(3677),
    [anon_sym_concept] = ACTIONS(3677),
    [anon_sym_co_return] = ACTIONS(3677),
    [anon_sym_co_yield] = ACTIONS(3677),
    [anon_sym_R_DQUOTE] = ACTIONS(3679),
    [anon_sym_LR_DQUOTE] = ACTIONS(3679),
    [anon_sym_uR_DQUOTE] = ACTIONS(3679),
    [anon_sym_UR_DQUOTE] = ACTIONS(3679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3679),
    [anon_sym_co_await] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3677),
    [anon_sym_requires] = ACTIONS(3677),
    [sym_this] = ACTIONS(3677),
    [anon_sym_discard] = ACTIONS(3677),
    [anon_sym_precise] = ACTIONS(3677),
    [anon_sym_shared] = ACTIONS(3677),
    [anon_sym_groupshared] = ACTIONS(3677),
    [anon_sym_uniform] = ACTIONS(3677),
    [anon_sym_row_major] = ACTIONS(3677),
    [anon_sym_column_major] = ACTIONS(3677),
    [anon_sym_globallycoherent] = ACTIONS(3677),
    [anon_sym_centroid] = ACTIONS(3677),
    [anon_sym_noperspective] = ACTIONS(3677),
    [anon_sym_nointerpolation] = ACTIONS(3677),
    [anon_sym_sample] = ACTIONS(3677),
    [anon_sym_linear] = ACTIONS(3677),
    [anon_sym_snorm] = ACTIONS(3677),
    [anon_sym_unorm] = ACTIONS(3677),
    [anon_sym_point] = ACTIONS(3677),
    [anon_sym_line] = ACTIONS(3677),
    [anon_sym_triangleadj] = ACTIONS(3677),
    [anon_sym_lineadj] = ACTIONS(3677),
    [anon_sym_triangle] = ACTIONS(3677),
    [anon_sym_cbuffer] = ACTIONS(3677),
    [anon_sym_interface] = ACTIONS(3677),
    [anon_sym_extension] = ACTIONS(3677),
  },
  [531] = {
    [sym_type_qualifier] = STATE(531),
    [sym_alignas_qualifier] = STATE(854),
    [aux_sym__type_definition_type_repeat1] = STATE(531),
    [ts_builtin_sym_end] = ACTIONS(3681),
    [sym_identifier] = ACTIONS(3683),
    [aux_sym_preproc_include_token1] = ACTIONS(3683),
    [aux_sym_preproc_def_token1] = ACTIONS(3683),
    [aux_sym_preproc_if_token1] = ACTIONS(3683),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3683),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3683),
    [sym_preproc_directive] = ACTIONS(3683),
    [anon_sym_LPAREN2] = ACTIONS(3681),
    [anon_sym_BANG] = ACTIONS(3681),
    [anon_sym_TILDE] = ACTIONS(3681),
    [anon_sym_DASH] = ACTIONS(3683),
    [anon_sym_PLUS] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(3681),
    [anon_sym_AMP_AMP] = ACTIONS(3681),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_SEMI] = ACTIONS(3681),
    [anon_sym___extension__] = ACTIONS(3685),
    [anon_sym_typedef] = ACTIONS(3683),
    [anon_sym_in] = ACTIONS(3683),
    [anon_sym_out] = ACTIONS(3683),
    [anon_sym_inout] = ACTIONS(3683),
    [anon_sym_virtual] = ACTIONS(3683),
    [anon_sym_extern] = ACTIONS(3683),
    [anon_sym___attribute__] = ACTIONS(3683),
    [anon_sym___attribute] = ACTIONS(3683),
    [anon_sym_using] = ACTIONS(3683),
    [anon_sym_COLON_COLON] = ACTIONS(3681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3681),
    [anon_sym___declspec] = ACTIONS(3683),
    [anon_sym___based] = ACTIONS(3683),
    [anon_sym___cdecl] = ACTIONS(3683),
    [anon_sym___clrcall] = ACTIONS(3683),
    [anon_sym___stdcall] = ACTIONS(3683),
    [anon_sym___fastcall] = ACTIONS(3683),
    [anon_sym___thiscall] = ACTIONS(3683),
    [anon_sym___vectorcall] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3681),
    [anon_sym_signed] = ACTIONS(3683),
    [anon_sym_unsigned] = ACTIONS(3683),
    [anon_sym_long] = ACTIONS(3683),
    [anon_sym_short] = ACTIONS(3683),
    [anon_sym_LBRACK] = ACTIONS(3683),
    [anon_sym_static] = ACTIONS(3683),
    [anon_sym_register] = ACTIONS(3683),
    [anon_sym_inline] = ACTIONS(3683),
    [anon_sym___inline] = ACTIONS(3683),
    [anon_sym___inline__] = ACTIONS(3683),
    [anon_sym___forceinline] = ACTIONS(3683),
    [anon_sym_thread_local] = ACTIONS(3683),
    [anon_sym___thread] = ACTIONS(3683),
    [anon_sym_const] = ACTIONS(3685),
    [anon_sym_constexpr] = ACTIONS(3685),
    [anon_sym_volatile] = ACTIONS(3685),
    [anon_sym_restrict] = ACTIONS(3685),
    [anon_sym___restrict__] = ACTIONS(3685),
    [anon_sym__Atomic] = ACTIONS(3685),
    [anon_sym__Noreturn] = ACTIONS(3685),
    [anon_sym_noreturn] = ACTIONS(3685),
    [anon_sym__Nonnull] = ACTIONS(3685),
    [anon_sym_mutable] = ACTIONS(3685),
    [anon_sym_constinit] = ACTIONS(3685),
    [anon_sym_consteval] = ACTIONS(3685),
    [anon_sym_alignas] = ACTIONS(3688),
    [anon_sym__Alignas] = ACTIONS(3688),
    [sym_primitive_type] = ACTIONS(3683),
    [anon_sym_enum] = ACTIONS(3683),
    [anon_sym_class] = ACTIONS(3683),
    [anon_sym_struct] = ACTIONS(3683),
    [anon_sym_union] = ACTIONS(3683),
    [anon_sym_if] = ACTIONS(3683),
    [anon_sym_switch] = ACTIONS(3683),
    [anon_sym_case] = ACTIONS(3683),
    [anon_sym_default] = ACTIONS(3683),
    [anon_sym_while] = ACTIONS(3683),
    [anon_sym_do] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3683),
    [anon_sym_return] = ACTIONS(3683),
    [anon_sym_break] = ACTIONS(3683),
    [anon_sym_continue] = ACTIONS(3683),
    [anon_sym_goto] = ACTIONS(3683),
    [anon_sym_not] = ACTIONS(3683),
    [anon_sym_compl] = ACTIONS(3683),
    [anon_sym_DASH_DASH] = ACTIONS(3681),
    [anon_sym_PLUS_PLUS] = ACTIONS(3681),
    [anon_sym_sizeof] = ACTIONS(3683),
    [anon_sym___alignof__] = ACTIONS(3683),
    [anon_sym___alignof] = ACTIONS(3683),
    [anon_sym__alignof] = ACTIONS(3683),
    [anon_sym_alignof] = ACTIONS(3683),
    [anon_sym__Alignof] = ACTIONS(3683),
    [anon_sym_offsetof] = ACTIONS(3683),
    [anon_sym__Generic] = ACTIONS(3683),
    [anon_sym_asm] = ACTIONS(3683),
    [anon_sym___asm__] = ACTIONS(3683),
    [anon_sym___asm] = ACTIONS(3683),
    [anon_sym_DOT] = ACTIONS(3683),
    [sym_number_literal] = ACTIONS(3681),
    [anon_sym_L_SQUOTE] = ACTIONS(3681),
    [anon_sym_u_SQUOTE] = ACTIONS(3681),
    [anon_sym_U_SQUOTE] = ACTIONS(3681),
    [anon_sym_u8_SQUOTE] = ACTIONS(3681),
    [anon_sym_SQUOTE] = ACTIONS(3681),
    [anon_sym_L_DQUOTE] = ACTIONS(3681),
    [anon_sym_u_DQUOTE] = ACTIONS(3681),
    [anon_sym_U_DQUOTE] = ACTIONS(3681),
    [anon_sym_u8_DQUOTE] = ACTIONS(3681),
    [anon_sym_DQUOTE] = ACTIONS(3681),
    [sym_true] = ACTIONS(3683),
    [sym_false] = ACTIONS(3683),
    [anon_sym_NULL] = ACTIONS(3683),
    [anon_sym_nullptr] = ACTIONS(3683),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3683),
    [anon_sym_let] = ACTIONS(3683),
    [anon_sym_This] = ACTIONS(3683),
    [anon_sym_decltype] = ACTIONS(3683),
    [anon_sym_explicit] = ACTIONS(3683),
    [anon_sym_typename] = ACTIONS(3683),
    [anon_sym_export] = ACTIONS(3683),
    [anon_sym_module] = ACTIONS(3683),
    [anon_sym_import] = ACTIONS(3683),
    [anon_sym_template] = ACTIONS(3683),
    [anon_sym_operator] = ACTIONS(3683),
    [anon_sym_try] = ACTIONS(3683),
    [anon_sym_delete] = ACTIONS(3683),
    [anon_sym_throw] = ACTIONS(3683),
    [anon_sym_namespace] = ACTIONS(3683),
    [anon_sym_static_assert] = ACTIONS(3683),
    [anon_sym_concept] = ACTIONS(3683),
    [anon_sym_co_return] = ACTIONS(3683),
    [anon_sym_co_yield] = ACTIONS(3683),
    [anon_sym_R_DQUOTE] = ACTIONS(3681),
    [anon_sym_LR_DQUOTE] = ACTIONS(3681),
    [anon_sym_uR_DQUOTE] = ACTIONS(3681),
    [anon_sym_UR_DQUOTE] = ACTIONS(3681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3681),
    [anon_sym_co_await] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3683),
    [anon_sym_requires] = ACTIONS(3683),
    [sym_this] = ACTIONS(3683),
    [anon_sym_precise] = ACTIONS(3683),
    [anon_sym_shared] = ACTIONS(3683),
    [anon_sym_groupshared] = ACTIONS(3683),
    [anon_sym_uniform] = ACTIONS(3683),
    [anon_sym_row_major] = ACTIONS(3683),
    [anon_sym_column_major] = ACTIONS(3683),
    [anon_sym_globallycoherent] = ACTIONS(3683),
    [anon_sym_centroid] = ACTIONS(3683),
    [anon_sym_noperspective] = ACTIONS(3683),
    [anon_sym_nointerpolation] = ACTIONS(3683),
    [anon_sym_sample] = ACTIONS(3683),
    [anon_sym_linear] = ACTIONS(3683),
    [anon_sym_snorm] = ACTIONS(3683),
    [anon_sym_unorm] = ACTIONS(3683),
    [anon_sym_point] = ACTIONS(3683),
    [anon_sym_line] = ACTIONS(3683),
    [anon_sym_triangleadj] = ACTIONS(3683),
    [anon_sym_lineadj] = ACTIONS(3683),
    [anon_sym_triangle] = ACTIONS(3683),
    [anon_sym_interface] = ACTIONS(3683),
    [anon_sym_extension] = ACTIONS(3683),
    [anon_sym___exported] = ACTIONS(3683),
  },
  [532] = {
    [sym_identifier] = ACTIONS(3691),
    [aux_sym_preproc_include_token1] = ACTIONS(3691),
    [aux_sym_preproc_def_token1] = ACTIONS(3691),
    [aux_sym_preproc_if_token1] = ACTIONS(3691),
    [aux_sym_preproc_if_token2] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3691),
    [aux_sym_preproc_else_token1] = ACTIONS(3691),
    [aux_sym_preproc_elif_token1] = ACTIONS(3691),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3691),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3691),
    [sym_preproc_directive] = ACTIONS(3691),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_BANG] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_PLUS] = ACTIONS(3691),
    [anon_sym_STAR] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_AMP] = ACTIONS(3691),
    [anon_sym_SEMI] = ACTIONS(3693),
    [anon_sym___extension__] = ACTIONS(3691),
    [anon_sym_typedef] = ACTIONS(3691),
    [anon_sym_in] = ACTIONS(3691),
    [anon_sym_out] = ACTIONS(3691),
    [anon_sym_inout] = ACTIONS(3691),
    [anon_sym_virtual] = ACTIONS(3691),
    [anon_sym_extern] = ACTIONS(3691),
    [anon_sym___attribute__] = ACTIONS(3691),
    [anon_sym___attribute] = ACTIONS(3691),
    [anon_sym_using] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3693),
    [anon_sym___declspec] = ACTIONS(3691),
    [anon_sym___based] = ACTIONS(3691),
    [anon_sym___cdecl] = ACTIONS(3691),
    [anon_sym___clrcall] = ACTIONS(3691),
    [anon_sym___stdcall] = ACTIONS(3691),
    [anon_sym___fastcall] = ACTIONS(3691),
    [anon_sym___thiscall] = ACTIONS(3691),
    [anon_sym___vectorcall] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_signed] = ACTIONS(3691),
    [anon_sym_unsigned] = ACTIONS(3691),
    [anon_sym_long] = ACTIONS(3691),
    [anon_sym_short] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(3691),
    [anon_sym_static] = ACTIONS(3691),
    [anon_sym_register] = ACTIONS(3691),
    [anon_sym_inline] = ACTIONS(3691),
    [anon_sym___inline] = ACTIONS(3691),
    [anon_sym___inline__] = ACTIONS(3691),
    [anon_sym___forceinline] = ACTIONS(3691),
    [anon_sym_thread_local] = ACTIONS(3691),
    [anon_sym___thread] = ACTIONS(3691),
    [anon_sym_const] = ACTIONS(3691),
    [anon_sym_constexpr] = ACTIONS(3691),
    [anon_sym_volatile] = ACTIONS(3691),
    [anon_sym_restrict] = ACTIONS(3691),
    [anon_sym___restrict__] = ACTIONS(3691),
    [anon_sym__Atomic] = ACTIONS(3691),
    [anon_sym__Noreturn] = ACTIONS(3691),
    [anon_sym_noreturn] = ACTIONS(3691),
    [anon_sym__Nonnull] = ACTIONS(3691),
    [anon_sym_mutable] = ACTIONS(3691),
    [anon_sym_constinit] = ACTIONS(3691),
    [anon_sym_consteval] = ACTIONS(3691),
    [anon_sym_alignas] = ACTIONS(3691),
    [anon_sym__Alignas] = ACTIONS(3691),
    [sym_primitive_type] = ACTIONS(3691),
    [anon_sym_enum] = ACTIONS(3691),
    [anon_sym_class] = ACTIONS(3691),
    [anon_sym_struct] = ACTIONS(3691),
    [anon_sym_union] = ACTIONS(3691),
    [anon_sym_if] = ACTIONS(3691),
    [anon_sym_switch] = ACTIONS(3691),
    [anon_sym_case] = ACTIONS(3691),
    [anon_sym_default] = ACTIONS(3691),
    [anon_sym_while] = ACTIONS(3691),
    [anon_sym_do] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3691),
    [anon_sym_return] = ACTIONS(3691),
    [anon_sym_break] = ACTIONS(3691),
    [anon_sym_continue] = ACTIONS(3691),
    [anon_sym_goto] = ACTIONS(3691),
    [anon_sym___try] = ACTIONS(3691),
    [anon_sym___leave] = ACTIONS(3691),
    [anon_sym_not] = ACTIONS(3691),
    [anon_sym_compl] = ACTIONS(3691),
    [anon_sym_DASH_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_PLUS] = ACTIONS(3693),
    [anon_sym_sizeof] = ACTIONS(3691),
    [anon_sym___alignof__] = ACTIONS(3691),
    [anon_sym___alignof] = ACTIONS(3691),
    [anon_sym__alignof] = ACTIONS(3691),
    [anon_sym_alignof] = ACTIONS(3691),
    [anon_sym__Alignof] = ACTIONS(3691),
    [anon_sym_offsetof] = ACTIONS(3691),
    [anon_sym__Generic] = ACTIONS(3691),
    [anon_sym_asm] = ACTIONS(3691),
    [anon_sym___asm__] = ACTIONS(3691),
    [anon_sym___asm] = ACTIONS(3691),
    [sym_number_literal] = ACTIONS(3693),
    [anon_sym_L_SQUOTE] = ACTIONS(3693),
    [anon_sym_u_SQUOTE] = ACTIONS(3693),
    [anon_sym_U_SQUOTE] = ACTIONS(3693),
    [anon_sym_u8_SQUOTE] = ACTIONS(3693),
    [anon_sym_SQUOTE] = ACTIONS(3693),
    [anon_sym_L_DQUOTE] = ACTIONS(3693),
    [anon_sym_u_DQUOTE] = ACTIONS(3693),
    [anon_sym_U_DQUOTE] = ACTIONS(3693),
    [anon_sym_u8_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [sym_true] = ACTIONS(3691),
    [sym_false] = ACTIONS(3691),
    [anon_sym_NULL] = ACTIONS(3691),
    [anon_sym_nullptr] = ACTIONS(3691),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3691),
    [anon_sym_let] = ACTIONS(3691),
    [anon_sym_This] = ACTIONS(3691),
    [anon_sym_decltype] = ACTIONS(3691),
    [anon_sym_explicit] = ACTIONS(3691),
    [anon_sym_typename] = ACTIONS(3691),
    [anon_sym_template] = ACTIONS(3691),
    [anon_sym_operator] = ACTIONS(3691),
    [anon_sym_try] = ACTIONS(3691),
    [anon_sym_delete] = ACTIONS(3691),
    [anon_sym_throw] = ACTIONS(3691),
    [anon_sym_namespace] = ACTIONS(3691),
    [anon_sym_static_assert] = ACTIONS(3691),
    [anon_sym_concept] = ACTIONS(3691),
    [anon_sym_co_return] = ACTIONS(3691),
    [anon_sym_co_yield] = ACTIONS(3691),
    [anon_sym_R_DQUOTE] = ACTIONS(3693),
    [anon_sym_LR_DQUOTE] = ACTIONS(3693),
    [anon_sym_uR_DQUOTE] = ACTIONS(3693),
    [anon_sym_UR_DQUOTE] = ACTIONS(3693),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3693),
    [anon_sym_co_await] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3691),
    [anon_sym_requires] = ACTIONS(3691),
    [sym_this] = ACTIONS(3691),
    [anon_sym_discard] = ACTIONS(3691),
    [anon_sym_precise] = ACTIONS(3691),
    [anon_sym_shared] = ACTIONS(3691),
    [anon_sym_groupshared] = ACTIONS(3691),
    [anon_sym_uniform] = ACTIONS(3691),
    [anon_sym_row_major] = ACTIONS(3691),
    [anon_sym_column_major] = ACTIONS(3691),
    [anon_sym_globallycoherent] = ACTIONS(3691),
    [anon_sym_centroid] = ACTIONS(3691),
    [anon_sym_noperspective] = ACTIONS(3691),
    [anon_sym_nointerpolation] = ACTIONS(3691),
    [anon_sym_sample] = ACTIONS(3691),
    [anon_sym_linear] = ACTIONS(3691),
    [anon_sym_snorm] = ACTIONS(3691),
    [anon_sym_unorm] = ACTIONS(3691),
    [anon_sym_point] = ACTIONS(3691),
    [anon_sym_line] = ACTIONS(3691),
    [anon_sym_triangleadj] = ACTIONS(3691),
    [anon_sym_lineadj] = ACTIONS(3691),
    [anon_sym_triangle] = ACTIONS(3691),
    [anon_sym_cbuffer] = ACTIONS(3691),
    [anon_sym_interface] = ACTIONS(3691),
    [anon_sym_extension] = ACTIONS(3691),
  },
  [533] = {
    [sym_identifier] = ACTIONS(3695),
    [aux_sym_preproc_include_token1] = ACTIONS(3695),
    [aux_sym_preproc_def_token1] = ACTIONS(3695),
    [aux_sym_preproc_if_token1] = ACTIONS(3695),
    [aux_sym_preproc_if_token2] = ACTIONS(3695),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3695),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3695),
    [aux_sym_preproc_else_token1] = ACTIONS(3695),
    [aux_sym_preproc_elif_token1] = ACTIONS(3695),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3695),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3695),
    [sym_preproc_directive] = ACTIONS(3695),
    [anon_sym_LPAREN2] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3695),
    [anon_sym_PLUS] = ACTIONS(3695),
    [anon_sym_STAR] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3695),
    [anon_sym_SEMI] = ACTIONS(3697),
    [anon_sym___extension__] = ACTIONS(3695),
    [anon_sym_typedef] = ACTIONS(3695),
    [anon_sym_in] = ACTIONS(3695),
    [anon_sym_out] = ACTIONS(3695),
    [anon_sym_inout] = ACTIONS(3695),
    [anon_sym_virtual] = ACTIONS(3695),
    [anon_sym_extern] = ACTIONS(3695),
    [anon_sym___attribute__] = ACTIONS(3695),
    [anon_sym___attribute] = ACTIONS(3695),
    [anon_sym_using] = ACTIONS(3695),
    [anon_sym_COLON_COLON] = ACTIONS(3697),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3697),
    [anon_sym___declspec] = ACTIONS(3695),
    [anon_sym___based] = ACTIONS(3695),
    [anon_sym___cdecl] = ACTIONS(3695),
    [anon_sym___clrcall] = ACTIONS(3695),
    [anon_sym___stdcall] = ACTIONS(3695),
    [anon_sym___fastcall] = ACTIONS(3695),
    [anon_sym___thiscall] = ACTIONS(3695),
    [anon_sym___vectorcall] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_signed] = ACTIONS(3695),
    [anon_sym_unsigned] = ACTIONS(3695),
    [anon_sym_long] = ACTIONS(3695),
    [anon_sym_short] = ACTIONS(3695),
    [anon_sym_LBRACK] = ACTIONS(3695),
    [anon_sym_static] = ACTIONS(3695),
    [anon_sym_register] = ACTIONS(3695),
    [anon_sym_inline] = ACTIONS(3695),
    [anon_sym___inline] = ACTIONS(3695),
    [anon_sym___inline__] = ACTIONS(3695),
    [anon_sym___forceinline] = ACTIONS(3695),
    [anon_sym_thread_local] = ACTIONS(3695),
    [anon_sym___thread] = ACTIONS(3695),
    [anon_sym_const] = ACTIONS(3695),
    [anon_sym_constexpr] = ACTIONS(3695),
    [anon_sym_volatile] = ACTIONS(3695),
    [anon_sym_restrict] = ACTIONS(3695),
    [anon_sym___restrict__] = ACTIONS(3695),
    [anon_sym__Atomic] = ACTIONS(3695),
    [anon_sym__Noreturn] = ACTIONS(3695),
    [anon_sym_noreturn] = ACTIONS(3695),
    [anon_sym__Nonnull] = ACTIONS(3695),
    [anon_sym_mutable] = ACTIONS(3695),
    [anon_sym_constinit] = ACTIONS(3695),
    [anon_sym_consteval] = ACTIONS(3695),
    [anon_sym_alignas] = ACTIONS(3695),
    [anon_sym__Alignas] = ACTIONS(3695),
    [sym_primitive_type] = ACTIONS(3695),
    [anon_sym_enum] = ACTIONS(3695),
    [anon_sym_class] = ACTIONS(3695),
    [anon_sym_struct] = ACTIONS(3695),
    [anon_sym_union] = ACTIONS(3695),
    [anon_sym_if] = ACTIONS(3695),
    [anon_sym_switch] = ACTIONS(3695),
    [anon_sym_case] = ACTIONS(3695),
    [anon_sym_default] = ACTIONS(3695),
    [anon_sym_while] = ACTIONS(3695),
    [anon_sym_do] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3695),
    [anon_sym_return] = ACTIONS(3695),
    [anon_sym_break] = ACTIONS(3695),
    [anon_sym_continue] = ACTIONS(3695),
    [anon_sym_goto] = ACTIONS(3695),
    [anon_sym___try] = ACTIONS(3695),
    [anon_sym___leave] = ACTIONS(3695),
    [anon_sym_not] = ACTIONS(3695),
    [anon_sym_compl] = ACTIONS(3695),
    [anon_sym_DASH_DASH] = ACTIONS(3697),
    [anon_sym_PLUS_PLUS] = ACTIONS(3697),
    [anon_sym_sizeof] = ACTIONS(3695),
    [anon_sym___alignof__] = ACTIONS(3695),
    [anon_sym___alignof] = ACTIONS(3695),
    [anon_sym__alignof] = ACTIONS(3695),
    [anon_sym_alignof] = ACTIONS(3695),
    [anon_sym__Alignof] = ACTIONS(3695),
    [anon_sym_offsetof] = ACTIONS(3695),
    [anon_sym__Generic] = ACTIONS(3695),
    [anon_sym_asm] = ACTIONS(3695),
    [anon_sym___asm__] = ACTIONS(3695),
    [anon_sym___asm] = ACTIONS(3695),
    [sym_number_literal] = ACTIONS(3697),
    [anon_sym_L_SQUOTE] = ACTIONS(3697),
    [anon_sym_u_SQUOTE] = ACTIONS(3697),
    [anon_sym_U_SQUOTE] = ACTIONS(3697),
    [anon_sym_u8_SQUOTE] = ACTIONS(3697),
    [anon_sym_SQUOTE] = ACTIONS(3697),
    [anon_sym_L_DQUOTE] = ACTIONS(3697),
    [anon_sym_u_DQUOTE] = ACTIONS(3697),
    [anon_sym_U_DQUOTE] = ACTIONS(3697),
    [anon_sym_u8_DQUOTE] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [sym_true] = ACTIONS(3695),
    [sym_false] = ACTIONS(3695),
    [anon_sym_NULL] = ACTIONS(3695),
    [anon_sym_nullptr] = ACTIONS(3695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3695),
    [anon_sym_let] = ACTIONS(3695),
    [anon_sym_This] = ACTIONS(3695),
    [anon_sym_decltype] = ACTIONS(3695),
    [anon_sym_explicit] = ACTIONS(3695),
    [anon_sym_typename] = ACTIONS(3695),
    [anon_sym_template] = ACTIONS(3695),
    [anon_sym_operator] = ACTIONS(3695),
    [anon_sym_try] = ACTIONS(3695),
    [anon_sym_delete] = ACTIONS(3695),
    [anon_sym_throw] = ACTIONS(3695),
    [anon_sym_namespace] = ACTIONS(3695),
    [anon_sym_static_assert] = ACTIONS(3695),
    [anon_sym_concept] = ACTIONS(3695),
    [anon_sym_co_return] = ACTIONS(3695),
    [anon_sym_co_yield] = ACTIONS(3695),
    [anon_sym_R_DQUOTE] = ACTIONS(3697),
    [anon_sym_LR_DQUOTE] = ACTIONS(3697),
    [anon_sym_uR_DQUOTE] = ACTIONS(3697),
    [anon_sym_UR_DQUOTE] = ACTIONS(3697),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3697),
    [anon_sym_co_await] = ACTIONS(3695),
    [anon_sym_new] = ACTIONS(3695),
    [anon_sym_requires] = ACTIONS(3695),
    [sym_this] = ACTIONS(3695),
    [anon_sym_discard] = ACTIONS(3695),
    [anon_sym_precise] = ACTIONS(3695),
    [anon_sym_shared] = ACTIONS(3695),
    [anon_sym_groupshared] = ACTIONS(3695),
    [anon_sym_uniform] = ACTIONS(3695),
    [anon_sym_row_major] = ACTIONS(3695),
    [anon_sym_column_major] = ACTIONS(3695),
    [anon_sym_globallycoherent] = ACTIONS(3695),
    [anon_sym_centroid] = ACTIONS(3695),
    [anon_sym_noperspective] = ACTIONS(3695),
    [anon_sym_nointerpolation] = ACTIONS(3695),
    [anon_sym_sample] = ACTIONS(3695),
    [anon_sym_linear] = ACTIONS(3695),
    [anon_sym_snorm] = ACTIONS(3695),
    [anon_sym_unorm] = ACTIONS(3695),
    [anon_sym_point] = ACTIONS(3695),
    [anon_sym_line] = ACTIONS(3695),
    [anon_sym_triangleadj] = ACTIONS(3695),
    [anon_sym_lineadj] = ACTIONS(3695),
    [anon_sym_triangle] = ACTIONS(3695),
    [anon_sym_cbuffer] = ACTIONS(3695),
    [anon_sym_interface] = ACTIONS(3695),
    [anon_sym_extension] = ACTIONS(3695),
  },
  [534] = {
    [sym_identifier] = ACTIONS(3699),
    [aux_sym_preproc_include_token1] = ACTIONS(3699),
    [aux_sym_preproc_def_token1] = ACTIONS(3699),
    [aux_sym_preproc_if_token1] = ACTIONS(3699),
    [aux_sym_preproc_if_token2] = ACTIONS(3699),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3699),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3699),
    [aux_sym_preproc_else_token1] = ACTIONS(3699),
    [aux_sym_preproc_elif_token1] = ACTIONS(3699),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3699),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3699),
    [sym_preproc_directive] = ACTIONS(3699),
    [anon_sym_LPAREN2] = ACTIONS(3701),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_STAR] = ACTIONS(3701),
    [anon_sym_AMP_AMP] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(3701),
    [anon_sym___extension__] = ACTIONS(3699),
    [anon_sym_typedef] = ACTIONS(3699),
    [anon_sym_in] = ACTIONS(3699),
    [anon_sym_out] = ACTIONS(3699),
    [anon_sym_inout] = ACTIONS(3699),
    [anon_sym_virtual] = ACTIONS(3699),
    [anon_sym_extern] = ACTIONS(3699),
    [anon_sym___attribute__] = ACTIONS(3699),
    [anon_sym___attribute] = ACTIONS(3699),
    [anon_sym_using] = ACTIONS(3699),
    [anon_sym_COLON_COLON] = ACTIONS(3701),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3701),
    [anon_sym___declspec] = ACTIONS(3699),
    [anon_sym___based] = ACTIONS(3699),
    [anon_sym___cdecl] = ACTIONS(3699),
    [anon_sym___clrcall] = ACTIONS(3699),
    [anon_sym___stdcall] = ACTIONS(3699),
    [anon_sym___fastcall] = ACTIONS(3699),
    [anon_sym___thiscall] = ACTIONS(3699),
    [anon_sym___vectorcall] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3701),
    [anon_sym_signed] = ACTIONS(3699),
    [anon_sym_unsigned] = ACTIONS(3699),
    [anon_sym_long] = ACTIONS(3699),
    [anon_sym_short] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(3699),
    [anon_sym_static] = ACTIONS(3699),
    [anon_sym_register] = ACTIONS(3699),
    [anon_sym_inline] = ACTIONS(3699),
    [anon_sym___inline] = ACTIONS(3699),
    [anon_sym___inline__] = ACTIONS(3699),
    [anon_sym___forceinline] = ACTIONS(3699),
    [anon_sym_thread_local] = ACTIONS(3699),
    [anon_sym___thread] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3699),
    [anon_sym_constexpr] = ACTIONS(3699),
    [anon_sym_volatile] = ACTIONS(3699),
    [anon_sym_restrict] = ACTIONS(3699),
    [anon_sym___restrict__] = ACTIONS(3699),
    [anon_sym__Atomic] = ACTIONS(3699),
    [anon_sym__Noreturn] = ACTIONS(3699),
    [anon_sym_noreturn] = ACTIONS(3699),
    [anon_sym__Nonnull] = ACTIONS(3699),
    [anon_sym_mutable] = ACTIONS(3699),
    [anon_sym_constinit] = ACTIONS(3699),
    [anon_sym_consteval] = ACTIONS(3699),
    [anon_sym_alignas] = ACTIONS(3699),
    [anon_sym__Alignas] = ACTIONS(3699),
    [sym_primitive_type] = ACTIONS(3699),
    [anon_sym_enum] = ACTIONS(3699),
    [anon_sym_class] = ACTIONS(3699),
    [anon_sym_struct] = ACTIONS(3699),
    [anon_sym_union] = ACTIONS(3699),
    [anon_sym_if] = ACTIONS(3699),
    [anon_sym_switch] = ACTIONS(3699),
    [anon_sym_case] = ACTIONS(3699),
    [anon_sym_default] = ACTIONS(3699),
    [anon_sym_while] = ACTIONS(3699),
    [anon_sym_do] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3699),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_break] = ACTIONS(3699),
    [anon_sym_continue] = ACTIONS(3699),
    [anon_sym_goto] = ACTIONS(3699),
    [anon_sym___try] = ACTIONS(3699),
    [anon_sym___leave] = ACTIONS(3699),
    [anon_sym_not] = ACTIONS(3699),
    [anon_sym_compl] = ACTIONS(3699),
    [anon_sym_DASH_DASH] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3701),
    [anon_sym_sizeof] = ACTIONS(3699),
    [anon_sym___alignof__] = ACTIONS(3699),
    [anon_sym___alignof] = ACTIONS(3699),
    [anon_sym__alignof] = ACTIONS(3699),
    [anon_sym_alignof] = ACTIONS(3699),
    [anon_sym__Alignof] = ACTIONS(3699),
    [anon_sym_offsetof] = ACTIONS(3699),
    [anon_sym__Generic] = ACTIONS(3699),
    [anon_sym_asm] = ACTIONS(3699),
    [anon_sym___asm__] = ACTIONS(3699),
    [anon_sym___asm] = ACTIONS(3699),
    [sym_number_literal] = ACTIONS(3701),
    [anon_sym_L_SQUOTE] = ACTIONS(3701),
    [anon_sym_u_SQUOTE] = ACTIONS(3701),
    [anon_sym_U_SQUOTE] = ACTIONS(3701),
    [anon_sym_u8_SQUOTE] = ACTIONS(3701),
    [anon_sym_SQUOTE] = ACTIONS(3701),
    [anon_sym_L_DQUOTE] = ACTIONS(3701),
    [anon_sym_u_DQUOTE] = ACTIONS(3701),
    [anon_sym_U_DQUOTE] = ACTIONS(3701),
    [anon_sym_u8_DQUOTE] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [sym_true] = ACTIONS(3699),
    [sym_false] = ACTIONS(3699),
    [anon_sym_NULL] = ACTIONS(3699),
    [anon_sym_nullptr] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3699),
    [anon_sym_let] = ACTIONS(3699),
    [anon_sym_This] = ACTIONS(3699),
    [anon_sym_decltype] = ACTIONS(3699),
    [anon_sym_explicit] = ACTIONS(3699),
    [anon_sym_typename] = ACTIONS(3699),
    [anon_sym_template] = ACTIONS(3699),
    [anon_sym_operator] = ACTIONS(3699),
    [anon_sym_try] = ACTIONS(3699),
    [anon_sym_delete] = ACTIONS(3699),
    [anon_sym_throw] = ACTIONS(3699),
    [anon_sym_namespace] = ACTIONS(3699),
    [anon_sym_static_assert] = ACTIONS(3699),
    [anon_sym_concept] = ACTIONS(3699),
    [anon_sym_co_return] = ACTIONS(3699),
    [anon_sym_co_yield] = ACTIONS(3699),
    [anon_sym_R_DQUOTE] = ACTIONS(3701),
    [anon_sym_LR_DQUOTE] = ACTIONS(3701),
    [anon_sym_uR_DQUOTE] = ACTIONS(3701),
    [anon_sym_UR_DQUOTE] = ACTIONS(3701),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3701),
    [anon_sym_co_await] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3699),
    [anon_sym_requires] = ACTIONS(3699),
    [sym_this] = ACTIONS(3699),
    [anon_sym_discard] = ACTIONS(3699),
    [anon_sym_precise] = ACTIONS(3699),
    [anon_sym_shared] = ACTIONS(3699),
    [anon_sym_groupshared] = ACTIONS(3699),
    [anon_sym_uniform] = ACTIONS(3699),
    [anon_sym_row_major] = ACTIONS(3699),
    [anon_sym_column_major] = ACTIONS(3699),
    [anon_sym_globallycoherent] = ACTIONS(3699),
    [anon_sym_centroid] = ACTIONS(3699),
    [anon_sym_noperspective] = ACTIONS(3699),
    [anon_sym_nointerpolation] = ACTIONS(3699),
    [anon_sym_sample] = ACTIONS(3699),
    [anon_sym_linear] = ACTIONS(3699),
    [anon_sym_snorm] = ACTIONS(3699),
    [anon_sym_unorm] = ACTIONS(3699),
    [anon_sym_point] = ACTIONS(3699),
    [anon_sym_line] = ACTIONS(3699),
    [anon_sym_triangleadj] = ACTIONS(3699),
    [anon_sym_lineadj] = ACTIONS(3699),
    [anon_sym_triangle] = ACTIONS(3699),
    [anon_sym_cbuffer] = ACTIONS(3699),
    [anon_sym_interface] = ACTIONS(3699),
    [anon_sym_extension] = ACTIONS(3699),
  },
  [535] = {
    [sym_identifier] = ACTIONS(3703),
    [aux_sym_preproc_include_token1] = ACTIONS(3703),
    [aux_sym_preproc_def_token1] = ACTIONS(3703),
    [aux_sym_preproc_if_token1] = ACTIONS(3703),
    [aux_sym_preproc_if_token2] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3703),
    [aux_sym_preproc_else_token1] = ACTIONS(3703),
    [aux_sym_preproc_elif_token1] = ACTIONS(3703),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3703),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3703),
    [sym_preproc_directive] = ACTIONS(3703),
    [anon_sym_LPAREN2] = ACTIONS(3705),
    [anon_sym_BANG] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3703),
    [anon_sym_STAR] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_AMP] = ACTIONS(3703),
    [anon_sym_SEMI] = ACTIONS(3705),
    [anon_sym___extension__] = ACTIONS(3703),
    [anon_sym_typedef] = ACTIONS(3703),
    [anon_sym_in] = ACTIONS(3703),
    [anon_sym_out] = ACTIONS(3703),
    [anon_sym_inout] = ACTIONS(3703),
    [anon_sym_virtual] = ACTIONS(3703),
    [anon_sym_extern] = ACTIONS(3703),
    [anon_sym___attribute__] = ACTIONS(3703),
    [anon_sym___attribute] = ACTIONS(3703),
    [anon_sym_using] = ACTIONS(3703),
    [anon_sym_COLON_COLON] = ACTIONS(3705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3705),
    [anon_sym___declspec] = ACTIONS(3703),
    [anon_sym___based] = ACTIONS(3703),
    [anon_sym___cdecl] = ACTIONS(3703),
    [anon_sym___clrcall] = ACTIONS(3703),
    [anon_sym___stdcall] = ACTIONS(3703),
    [anon_sym___fastcall] = ACTIONS(3703),
    [anon_sym___thiscall] = ACTIONS(3703),
    [anon_sym___vectorcall] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_signed] = ACTIONS(3703),
    [anon_sym_unsigned] = ACTIONS(3703),
    [anon_sym_long] = ACTIONS(3703),
    [anon_sym_short] = ACTIONS(3703),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_static] = ACTIONS(3703),
    [anon_sym_register] = ACTIONS(3703),
    [anon_sym_inline] = ACTIONS(3703),
    [anon_sym___inline] = ACTIONS(3703),
    [anon_sym___inline__] = ACTIONS(3703),
    [anon_sym___forceinline] = ACTIONS(3703),
    [anon_sym_thread_local] = ACTIONS(3703),
    [anon_sym___thread] = ACTIONS(3703),
    [anon_sym_const] = ACTIONS(3703),
    [anon_sym_constexpr] = ACTIONS(3703),
    [anon_sym_volatile] = ACTIONS(3703),
    [anon_sym_restrict] = ACTIONS(3703),
    [anon_sym___restrict__] = ACTIONS(3703),
    [anon_sym__Atomic] = ACTIONS(3703),
    [anon_sym__Noreturn] = ACTIONS(3703),
    [anon_sym_noreturn] = ACTIONS(3703),
    [anon_sym__Nonnull] = ACTIONS(3703),
    [anon_sym_mutable] = ACTIONS(3703),
    [anon_sym_constinit] = ACTIONS(3703),
    [anon_sym_consteval] = ACTIONS(3703),
    [anon_sym_alignas] = ACTIONS(3703),
    [anon_sym__Alignas] = ACTIONS(3703),
    [sym_primitive_type] = ACTIONS(3703),
    [anon_sym_enum] = ACTIONS(3703),
    [anon_sym_class] = ACTIONS(3703),
    [anon_sym_struct] = ACTIONS(3703),
    [anon_sym_union] = ACTIONS(3703),
    [anon_sym_if] = ACTIONS(3703),
    [anon_sym_switch] = ACTIONS(3703),
    [anon_sym_case] = ACTIONS(3703),
    [anon_sym_default] = ACTIONS(3703),
    [anon_sym_while] = ACTIONS(3703),
    [anon_sym_do] = ACTIONS(3703),
    [anon_sym_for] = ACTIONS(3703),
    [anon_sym_return] = ACTIONS(3703),
    [anon_sym_break] = ACTIONS(3703),
    [anon_sym_continue] = ACTIONS(3703),
    [anon_sym_goto] = ACTIONS(3703),
    [anon_sym___try] = ACTIONS(3703),
    [anon_sym___leave] = ACTIONS(3703),
    [anon_sym_not] = ACTIONS(3703),
    [anon_sym_compl] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3705),
    [anon_sym_PLUS_PLUS] = ACTIONS(3705),
    [anon_sym_sizeof] = ACTIONS(3703),
    [anon_sym___alignof__] = ACTIONS(3703),
    [anon_sym___alignof] = ACTIONS(3703),
    [anon_sym__alignof] = ACTIONS(3703),
    [anon_sym_alignof] = ACTIONS(3703),
    [anon_sym__Alignof] = ACTIONS(3703),
    [anon_sym_offsetof] = ACTIONS(3703),
    [anon_sym__Generic] = ACTIONS(3703),
    [anon_sym_asm] = ACTIONS(3703),
    [anon_sym___asm__] = ACTIONS(3703),
    [anon_sym___asm] = ACTIONS(3703),
    [sym_number_literal] = ACTIONS(3705),
    [anon_sym_L_SQUOTE] = ACTIONS(3705),
    [anon_sym_u_SQUOTE] = ACTIONS(3705),
    [anon_sym_U_SQUOTE] = ACTIONS(3705),
    [anon_sym_u8_SQUOTE] = ACTIONS(3705),
    [anon_sym_SQUOTE] = ACTIONS(3705),
    [anon_sym_L_DQUOTE] = ACTIONS(3705),
    [anon_sym_u_DQUOTE] = ACTIONS(3705),
    [anon_sym_U_DQUOTE] = ACTIONS(3705),
    [anon_sym_u8_DQUOTE] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [sym_true] = ACTIONS(3703),
    [sym_false] = ACTIONS(3703),
    [anon_sym_NULL] = ACTIONS(3703),
    [anon_sym_nullptr] = ACTIONS(3703),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3703),
    [anon_sym_let] = ACTIONS(3703),
    [anon_sym_This] = ACTIONS(3703),
    [anon_sym_decltype] = ACTIONS(3703),
    [anon_sym_explicit] = ACTIONS(3703),
    [anon_sym_typename] = ACTIONS(3703),
    [anon_sym_template] = ACTIONS(3703),
    [anon_sym_operator] = ACTIONS(3703),
    [anon_sym_try] = ACTIONS(3703),
    [anon_sym_delete] = ACTIONS(3703),
    [anon_sym_throw] = ACTIONS(3703),
    [anon_sym_namespace] = ACTIONS(3703),
    [anon_sym_static_assert] = ACTIONS(3703),
    [anon_sym_concept] = ACTIONS(3703),
    [anon_sym_co_return] = ACTIONS(3703),
    [anon_sym_co_yield] = ACTIONS(3703),
    [anon_sym_R_DQUOTE] = ACTIONS(3705),
    [anon_sym_LR_DQUOTE] = ACTIONS(3705),
    [anon_sym_uR_DQUOTE] = ACTIONS(3705),
    [anon_sym_UR_DQUOTE] = ACTIONS(3705),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3705),
    [anon_sym_co_await] = ACTIONS(3703),
    [anon_sym_new] = ACTIONS(3703),
    [anon_sym_requires] = ACTIONS(3703),
    [sym_this] = ACTIONS(3703),
    [anon_sym_discard] = ACTIONS(3703),
    [anon_sym_precise] = ACTIONS(3703),
    [anon_sym_shared] = ACTIONS(3703),
    [anon_sym_groupshared] = ACTIONS(3703),
    [anon_sym_uniform] = ACTIONS(3703),
    [anon_sym_row_major] = ACTIONS(3703),
    [anon_sym_column_major] = ACTIONS(3703),
    [anon_sym_globallycoherent] = ACTIONS(3703),
    [anon_sym_centroid] = ACTIONS(3703),
    [anon_sym_noperspective] = ACTIONS(3703),
    [anon_sym_nointerpolation] = ACTIONS(3703),
    [anon_sym_sample] = ACTIONS(3703),
    [anon_sym_linear] = ACTIONS(3703),
    [anon_sym_snorm] = ACTIONS(3703),
    [anon_sym_unorm] = ACTIONS(3703),
    [anon_sym_point] = ACTIONS(3703),
    [anon_sym_line] = ACTIONS(3703),
    [anon_sym_triangleadj] = ACTIONS(3703),
    [anon_sym_lineadj] = ACTIONS(3703),
    [anon_sym_triangle] = ACTIONS(3703),
    [anon_sym_cbuffer] = ACTIONS(3703),
    [anon_sym_interface] = ACTIONS(3703),
    [anon_sym_extension] = ACTIONS(3703),
  },
  [536] = {
    [sym_identifier] = ACTIONS(3707),
    [aux_sym_preproc_include_token1] = ACTIONS(3707),
    [aux_sym_preproc_def_token1] = ACTIONS(3707),
    [aux_sym_preproc_if_token1] = ACTIONS(3707),
    [aux_sym_preproc_if_token2] = ACTIONS(3707),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3707),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3707),
    [aux_sym_preproc_else_token1] = ACTIONS(3707),
    [aux_sym_preproc_elif_token1] = ACTIONS(3707),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3707),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3707),
    [sym_preproc_directive] = ACTIONS(3707),
    [anon_sym_LPAREN2] = ACTIONS(3709),
    [anon_sym_BANG] = ACTIONS(3709),
    [anon_sym_TILDE] = ACTIONS(3709),
    [anon_sym_DASH] = ACTIONS(3707),
    [anon_sym_PLUS] = ACTIONS(3707),
    [anon_sym_STAR] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(3707),
    [anon_sym_SEMI] = ACTIONS(3709),
    [anon_sym___extension__] = ACTIONS(3707),
    [anon_sym_typedef] = ACTIONS(3707),
    [anon_sym_in] = ACTIONS(3707),
    [anon_sym_out] = ACTIONS(3707),
    [anon_sym_inout] = ACTIONS(3707),
    [anon_sym_virtual] = ACTIONS(3707),
    [anon_sym_extern] = ACTIONS(3707),
    [anon_sym___attribute__] = ACTIONS(3707),
    [anon_sym___attribute] = ACTIONS(3707),
    [anon_sym_using] = ACTIONS(3707),
    [anon_sym_COLON_COLON] = ACTIONS(3709),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3709),
    [anon_sym___declspec] = ACTIONS(3707),
    [anon_sym___based] = ACTIONS(3707),
    [anon_sym___cdecl] = ACTIONS(3707),
    [anon_sym___clrcall] = ACTIONS(3707),
    [anon_sym___stdcall] = ACTIONS(3707),
    [anon_sym___fastcall] = ACTIONS(3707),
    [anon_sym___thiscall] = ACTIONS(3707),
    [anon_sym___vectorcall] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3709),
    [anon_sym_signed] = ACTIONS(3707),
    [anon_sym_unsigned] = ACTIONS(3707),
    [anon_sym_long] = ACTIONS(3707),
    [anon_sym_short] = ACTIONS(3707),
    [anon_sym_LBRACK] = ACTIONS(3707),
    [anon_sym_static] = ACTIONS(3707),
    [anon_sym_register] = ACTIONS(3707),
    [anon_sym_inline] = ACTIONS(3707),
    [anon_sym___inline] = ACTIONS(3707),
    [anon_sym___inline__] = ACTIONS(3707),
    [anon_sym___forceinline] = ACTIONS(3707),
    [anon_sym_thread_local] = ACTIONS(3707),
    [anon_sym___thread] = ACTIONS(3707),
    [anon_sym_const] = ACTIONS(3707),
    [anon_sym_constexpr] = ACTIONS(3707),
    [anon_sym_volatile] = ACTIONS(3707),
    [anon_sym_restrict] = ACTIONS(3707),
    [anon_sym___restrict__] = ACTIONS(3707),
    [anon_sym__Atomic] = ACTIONS(3707),
    [anon_sym__Noreturn] = ACTIONS(3707),
    [anon_sym_noreturn] = ACTIONS(3707),
    [anon_sym__Nonnull] = ACTIONS(3707),
    [anon_sym_mutable] = ACTIONS(3707),
    [anon_sym_constinit] = ACTIONS(3707),
    [anon_sym_consteval] = ACTIONS(3707),
    [anon_sym_alignas] = ACTIONS(3707),
    [anon_sym__Alignas] = ACTIONS(3707),
    [sym_primitive_type] = ACTIONS(3707),
    [anon_sym_enum] = ACTIONS(3707),
    [anon_sym_class] = ACTIONS(3707),
    [anon_sym_struct] = ACTIONS(3707),
    [anon_sym_union] = ACTIONS(3707),
    [anon_sym_if] = ACTIONS(3707),
    [anon_sym_switch] = ACTIONS(3707),
    [anon_sym_case] = ACTIONS(3707),
    [anon_sym_default] = ACTIONS(3707),
    [anon_sym_while] = ACTIONS(3707),
    [anon_sym_do] = ACTIONS(3707),
    [anon_sym_for] = ACTIONS(3707),
    [anon_sym_return] = ACTIONS(3707),
    [anon_sym_break] = ACTIONS(3707),
    [anon_sym_continue] = ACTIONS(3707),
    [anon_sym_goto] = ACTIONS(3707),
    [anon_sym___try] = ACTIONS(3707),
    [anon_sym___leave] = ACTIONS(3707),
    [anon_sym_not] = ACTIONS(3707),
    [anon_sym_compl] = ACTIONS(3707),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_sizeof] = ACTIONS(3707),
    [anon_sym___alignof__] = ACTIONS(3707),
    [anon_sym___alignof] = ACTIONS(3707),
    [anon_sym__alignof] = ACTIONS(3707),
    [anon_sym_alignof] = ACTIONS(3707),
    [anon_sym__Alignof] = ACTIONS(3707),
    [anon_sym_offsetof] = ACTIONS(3707),
    [anon_sym__Generic] = ACTIONS(3707),
    [anon_sym_asm] = ACTIONS(3707),
    [anon_sym___asm__] = ACTIONS(3707),
    [anon_sym___asm] = ACTIONS(3707),
    [sym_number_literal] = ACTIONS(3709),
    [anon_sym_L_SQUOTE] = ACTIONS(3709),
    [anon_sym_u_SQUOTE] = ACTIONS(3709),
    [anon_sym_U_SQUOTE] = ACTIONS(3709),
    [anon_sym_u8_SQUOTE] = ACTIONS(3709),
    [anon_sym_SQUOTE] = ACTIONS(3709),
    [anon_sym_L_DQUOTE] = ACTIONS(3709),
    [anon_sym_u_DQUOTE] = ACTIONS(3709),
    [anon_sym_U_DQUOTE] = ACTIONS(3709),
    [anon_sym_u8_DQUOTE] = ACTIONS(3709),
    [anon_sym_DQUOTE] = ACTIONS(3709),
    [sym_true] = ACTIONS(3707),
    [sym_false] = ACTIONS(3707),
    [anon_sym_NULL] = ACTIONS(3707),
    [anon_sym_nullptr] = ACTIONS(3707),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3707),
    [anon_sym_let] = ACTIONS(3707),
    [anon_sym_This] = ACTIONS(3707),
    [anon_sym_decltype] = ACTIONS(3707),
    [anon_sym_explicit] = ACTIONS(3707),
    [anon_sym_typename] = ACTIONS(3707),
    [anon_sym_template] = ACTIONS(3707),
    [anon_sym_operator] = ACTIONS(3707),
    [anon_sym_try] = ACTIONS(3707),
    [anon_sym_delete] = ACTIONS(3707),
    [anon_sym_throw] = ACTIONS(3707),
    [anon_sym_namespace] = ACTIONS(3707),
    [anon_sym_static_assert] = ACTIONS(3707),
    [anon_sym_concept] = ACTIONS(3707),
    [anon_sym_co_return] = ACTIONS(3707),
    [anon_sym_co_yield] = ACTIONS(3707),
    [anon_sym_R_DQUOTE] = ACTIONS(3709),
    [anon_sym_LR_DQUOTE] = ACTIONS(3709),
    [anon_sym_uR_DQUOTE] = ACTIONS(3709),
    [anon_sym_UR_DQUOTE] = ACTIONS(3709),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3709),
    [anon_sym_co_await] = ACTIONS(3707),
    [anon_sym_new] = ACTIONS(3707),
    [anon_sym_requires] = ACTIONS(3707),
    [sym_this] = ACTIONS(3707),
    [anon_sym_discard] = ACTIONS(3707),
    [anon_sym_precise] = ACTIONS(3707),
    [anon_sym_shared] = ACTIONS(3707),
    [anon_sym_groupshared] = ACTIONS(3707),
    [anon_sym_uniform] = ACTIONS(3707),
    [anon_sym_row_major] = ACTIONS(3707),
    [anon_sym_column_major] = ACTIONS(3707),
    [anon_sym_globallycoherent] = ACTIONS(3707),
    [anon_sym_centroid] = ACTIONS(3707),
    [anon_sym_noperspective] = ACTIONS(3707),
    [anon_sym_nointerpolation] = ACTIONS(3707),
    [anon_sym_sample] = ACTIONS(3707),
    [anon_sym_linear] = ACTIONS(3707),
    [anon_sym_snorm] = ACTIONS(3707),
    [anon_sym_unorm] = ACTIONS(3707),
    [anon_sym_point] = ACTIONS(3707),
    [anon_sym_line] = ACTIONS(3707),
    [anon_sym_triangleadj] = ACTIONS(3707),
    [anon_sym_lineadj] = ACTIONS(3707),
    [anon_sym_triangle] = ACTIONS(3707),
    [anon_sym_cbuffer] = ACTIONS(3707),
    [anon_sym_interface] = ACTIONS(3707),
    [anon_sym_extension] = ACTIONS(3707),
  },
  [537] = {
    [sym_identifier] = ACTIONS(3711),
    [aux_sym_preproc_include_token1] = ACTIONS(3711),
    [aux_sym_preproc_def_token1] = ACTIONS(3711),
    [aux_sym_preproc_if_token1] = ACTIONS(3711),
    [aux_sym_preproc_if_token2] = ACTIONS(3711),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3711),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3711),
    [aux_sym_preproc_else_token1] = ACTIONS(3711),
    [aux_sym_preproc_elif_token1] = ACTIONS(3711),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3711),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3711),
    [sym_preproc_directive] = ACTIONS(3711),
    [anon_sym_LPAREN2] = ACTIONS(3713),
    [anon_sym_BANG] = ACTIONS(3713),
    [anon_sym_TILDE] = ACTIONS(3713),
    [anon_sym_DASH] = ACTIONS(3711),
    [anon_sym_PLUS] = ACTIONS(3711),
    [anon_sym_STAR] = ACTIONS(3713),
    [anon_sym_AMP_AMP] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(3711),
    [anon_sym_SEMI] = ACTIONS(3713),
    [anon_sym___extension__] = ACTIONS(3711),
    [anon_sym_typedef] = ACTIONS(3711),
    [anon_sym_in] = ACTIONS(3711),
    [anon_sym_out] = ACTIONS(3711),
    [anon_sym_inout] = ACTIONS(3711),
    [anon_sym_virtual] = ACTIONS(3711),
    [anon_sym_extern] = ACTIONS(3711),
    [anon_sym___attribute__] = ACTIONS(3711),
    [anon_sym___attribute] = ACTIONS(3711),
    [anon_sym_using] = ACTIONS(3711),
    [anon_sym_COLON_COLON] = ACTIONS(3713),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3713),
    [anon_sym___declspec] = ACTIONS(3711),
    [anon_sym___based] = ACTIONS(3711),
    [anon_sym___cdecl] = ACTIONS(3711),
    [anon_sym___clrcall] = ACTIONS(3711),
    [anon_sym___stdcall] = ACTIONS(3711),
    [anon_sym___fastcall] = ACTIONS(3711),
    [anon_sym___thiscall] = ACTIONS(3711),
    [anon_sym___vectorcall] = ACTIONS(3711),
    [anon_sym_LBRACE] = ACTIONS(3713),
    [anon_sym_signed] = ACTIONS(3711),
    [anon_sym_unsigned] = ACTIONS(3711),
    [anon_sym_long] = ACTIONS(3711),
    [anon_sym_short] = ACTIONS(3711),
    [anon_sym_LBRACK] = ACTIONS(3711),
    [anon_sym_static] = ACTIONS(3711),
    [anon_sym_register] = ACTIONS(3711),
    [anon_sym_inline] = ACTIONS(3711),
    [anon_sym___inline] = ACTIONS(3711),
    [anon_sym___inline__] = ACTIONS(3711),
    [anon_sym___forceinline] = ACTIONS(3711),
    [anon_sym_thread_local] = ACTIONS(3711),
    [anon_sym___thread] = ACTIONS(3711),
    [anon_sym_const] = ACTIONS(3711),
    [anon_sym_constexpr] = ACTIONS(3711),
    [anon_sym_volatile] = ACTIONS(3711),
    [anon_sym_restrict] = ACTIONS(3711),
    [anon_sym___restrict__] = ACTIONS(3711),
    [anon_sym__Atomic] = ACTIONS(3711),
    [anon_sym__Noreturn] = ACTIONS(3711),
    [anon_sym_noreturn] = ACTIONS(3711),
    [anon_sym__Nonnull] = ACTIONS(3711),
    [anon_sym_mutable] = ACTIONS(3711),
    [anon_sym_constinit] = ACTIONS(3711),
    [anon_sym_consteval] = ACTIONS(3711),
    [anon_sym_alignas] = ACTIONS(3711),
    [anon_sym__Alignas] = ACTIONS(3711),
    [sym_primitive_type] = ACTIONS(3711),
    [anon_sym_enum] = ACTIONS(3711),
    [anon_sym_class] = ACTIONS(3711),
    [anon_sym_struct] = ACTIONS(3711),
    [anon_sym_union] = ACTIONS(3711),
    [anon_sym_if] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3711),
    [anon_sym_case] = ACTIONS(3711),
    [anon_sym_default] = ACTIONS(3711),
    [anon_sym_while] = ACTIONS(3711),
    [anon_sym_do] = ACTIONS(3711),
    [anon_sym_for] = ACTIONS(3711),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_break] = ACTIONS(3711),
    [anon_sym_continue] = ACTIONS(3711),
    [anon_sym_goto] = ACTIONS(3711),
    [anon_sym___try] = ACTIONS(3711),
    [anon_sym___leave] = ACTIONS(3711),
    [anon_sym_not] = ACTIONS(3711),
    [anon_sym_compl] = ACTIONS(3711),
    [anon_sym_DASH_DASH] = ACTIONS(3713),
    [anon_sym_PLUS_PLUS] = ACTIONS(3713),
    [anon_sym_sizeof] = ACTIONS(3711),
    [anon_sym___alignof__] = ACTIONS(3711),
    [anon_sym___alignof] = ACTIONS(3711),
    [anon_sym__alignof] = ACTIONS(3711),
    [anon_sym_alignof] = ACTIONS(3711),
    [anon_sym__Alignof] = ACTIONS(3711),
    [anon_sym_offsetof] = ACTIONS(3711),
    [anon_sym__Generic] = ACTIONS(3711),
    [anon_sym_asm] = ACTIONS(3711),
    [anon_sym___asm__] = ACTIONS(3711),
    [anon_sym___asm] = ACTIONS(3711),
    [sym_number_literal] = ACTIONS(3713),
    [anon_sym_L_SQUOTE] = ACTIONS(3713),
    [anon_sym_u_SQUOTE] = ACTIONS(3713),
    [anon_sym_U_SQUOTE] = ACTIONS(3713),
    [anon_sym_u8_SQUOTE] = ACTIONS(3713),
    [anon_sym_SQUOTE] = ACTIONS(3713),
    [anon_sym_L_DQUOTE] = ACTIONS(3713),
    [anon_sym_u_DQUOTE] = ACTIONS(3713),
    [anon_sym_U_DQUOTE] = ACTIONS(3713),
    [anon_sym_u8_DQUOTE] = ACTIONS(3713),
    [anon_sym_DQUOTE] = ACTIONS(3713),
    [sym_true] = ACTIONS(3711),
    [sym_false] = ACTIONS(3711),
    [anon_sym_NULL] = ACTIONS(3711),
    [anon_sym_nullptr] = ACTIONS(3711),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_This] = ACTIONS(3711),
    [anon_sym_decltype] = ACTIONS(3711),
    [anon_sym_explicit] = ACTIONS(3711),
    [anon_sym_typename] = ACTIONS(3711),
    [anon_sym_template] = ACTIONS(3711),
    [anon_sym_operator] = ACTIONS(3711),
    [anon_sym_try] = ACTIONS(3711),
    [anon_sym_delete] = ACTIONS(3711),
    [anon_sym_throw] = ACTIONS(3711),
    [anon_sym_namespace] = ACTIONS(3711),
    [anon_sym_static_assert] = ACTIONS(3711),
    [anon_sym_concept] = ACTIONS(3711),
    [anon_sym_co_return] = ACTIONS(3711),
    [anon_sym_co_yield] = ACTIONS(3711),
    [anon_sym_R_DQUOTE] = ACTIONS(3713),
    [anon_sym_LR_DQUOTE] = ACTIONS(3713),
    [anon_sym_uR_DQUOTE] = ACTIONS(3713),
    [anon_sym_UR_DQUOTE] = ACTIONS(3713),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3713),
    [anon_sym_co_await] = ACTIONS(3711),
    [anon_sym_new] = ACTIONS(3711),
    [anon_sym_requires] = ACTIONS(3711),
    [sym_this] = ACTIONS(3711),
    [anon_sym_discard] = ACTIONS(3711),
    [anon_sym_precise] = ACTIONS(3711),
    [anon_sym_shared] = ACTIONS(3711),
    [anon_sym_groupshared] = ACTIONS(3711),
    [anon_sym_uniform] = ACTIONS(3711),
    [anon_sym_row_major] = ACTIONS(3711),
    [anon_sym_column_major] = ACTIONS(3711),
    [anon_sym_globallycoherent] = ACTIONS(3711),
    [anon_sym_centroid] = ACTIONS(3711),
    [anon_sym_noperspective] = ACTIONS(3711),
    [anon_sym_nointerpolation] = ACTIONS(3711),
    [anon_sym_sample] = ACTIONS(3711),
    [anon_sym_linear] = ACTIONS(3711),
    [anon_sym_snorm] = ACTIONS(3711),
    [anon_sym_unorm] = ACTIONS(3711),
    [anon_sym_point] = ACTIONS(3711),
    [anon_sym_line] = ACTIONS(3711),
    [anon_sym_triangleadj] = ACTIONS(3711),
    [anon_sym_lineadj] = ACTIONS(3711),
    [anon_sym_triangle] = ACTIONS(3711),
    [anon_sym_cbuffer] = ACTIONS(3711),
    [anon_sym_interface] = ACTIONS(3711),
    [anon_sym_extension] = ACTIONS(3711),
  },
  [538] = {
    [sym_identifier] = ACTIONS(3715),
    [aux_sym_preproc_include_token1] = ACTIONS(3715),
    [aux_sym_preproc_def_token1] = ACTIONS(3715),
    [aux_sym_preproc_if_token1] = ACTIONS(3715),
    [aux_sym_preproc_if_token2] = ACTIONS(3715),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3715),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3715),
    [aux_sym_preproc_else_token1] = ACTIONS(3715),
    [aux_sym_preproc_elif_token1] = ACTIONS(3715),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3715),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3715),
    [sym_preproc_directive] = ACTIONS(3715),
    [anon_sym_LPAREN2] = ACTIONS(3717),
    [anon_sym_BANG] = ACTIONS(3717),
    [anon_sym_TILDE] = ACTIONS(3717),
    [anon_sym_DASH] = ACTIONS(3715),
    [anon_sym_PLUS] = ACTIONS(3715),
    [anon_sym_STAR] = ACTIONS(3717),
    [anon_sym_AMP_AMP] = ACTIONS(3717),
    [anon_sym_AMP] = ACTIONS(3715),
    [anon_sym_SEMI] = ACTIONS(3717),
    [anon_sym___extension__] = ACTIONS(3715),
    [anon_sym_typedef] = ACTIONS(3715),
    [anon_sym_in] = ACTIONS(3715),
    [anon_sym_out] = ACTIONS(3715),
    [anon_sym_inout] = ACTIONS(3715),
    [anon_sym_virtual] = ACTIONS(3715),
    [anon_sym_extern] = ACTIONS(3715),
    [anon_sym___attribute__] = ACTIONS(3715),
    [anon_sym___attribute] = ACTIONS(3715),
    [anon_sym_using] = ACTIONS(3715),
    [anon_sym_COLON_COLON] = ACTIONS(3717),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3717),
    [anon_sym___declspec] = ACTIONS(3715),
    [anon_sym___based] = ACTIONS(3715),
    [anon_sym___cdecl] = ACTIONS(3715),
    [anon_sym___clrcall] = ACTIONS(3715),
    [anon_sym___stdcall] = ACTIONS(3715),
    [anon_sym___fastcall] = ACTIONS(3715),
    [anon_sym___thiscall] = ACTIONS(3715),
    [anon_sym___vectorcall] = ACTIONS(3715),
    [anon_sym_LBRACE] = ACTIONS(3717),
    [anon_sym_signed] = ACTIONS(3715),
    [anon_sym_unsigned] = ACTIONS(3715),
    [anon_sym_long] = ACTIONS(3715),
    [anon_sym_short] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_static] = ACTIONS(3715),
    [anon_sym_register] = ACTIONS(3715),
    [anon_sym_inline] = ACTIONS(3715),
    [anon_sym___inline] = ACTIONS(3715),
    [anon_sym___inline__] = ACTIONS(3715),
    [anon_sym___forceinline] = ACTIONS(3715),
    [anon_sym_thread_local] = ACTIONS(3715),
    [anon_sym___thread] = ACTIONS(3715),
    [anon_sym_const] = ACTIONS(3715),
    [anon_sym_constexpr] = ACTIONS(3715),
    [anon_sym_volatile] = ACTIONS(3715),
    [anon_sym_restrict] = ACTIONS(3715),
    [anon_sym___restrict__] = ACTIONS(3715),
    [anon_sym__Atomic] = ACTIONS(3715),
    [anon_sym__Noreturn] = ACTIONS(3715),
    [anon_sym_noreturn] = ACTIONS(3715),
    [anon_sym__Nonnull] = ACTIONS(3715),
    [anon_sym_mutable] = ACTIONS(3715),
    [anon_sym_constinit] = ACTIONS(3715),
    [anon_sym_consteval] = ACTIONS(3715),
    [anon_sym_alignas] = ACTIONS(3715),
    [anon_sym__Alignas] = ACTIONS(3715),
    [sym_primitive_type] = ACTIONS(3715),
    [anon_sym_enum] = ACTIONS(3715),
    [anon_sym_class] = ACTIONS(3715),
    [anon_sym_struct] = ACTIONS(3715),
    [anon_sym_union] = ACTIONS(3715),
    [anon_sym_if] = ACTIONS(3715),
    [anon_sym_switch] = ACTIONS(3715),
    [anon_sym_case] = ACTIONS(3715),
    [anon_sym_default] = ACTIONS(3715),
    [anon_sym_while] = ACTIONS(3715),
    [anon_sym_do] = ACTIONS(3715),
    [anon_sym_for] = ACTIONS(3715),
    [anon_sym_return] = ACTIONS(3715),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_continue] = ACTIONS(3715),
    [anon_sym_goto] = ACTIONS(3715),
    [anon_sym___try] = ACTIONS(3715),
    [anon_sym___leave] = ACTIONS(3715),
    [anon_sym_not] = ACTIONS(3715),
    [anon_sym_compl] = ACTIONS(3715),
    [anon_sym_DASH_DASH] = ACTIONS(3717),
    [anon_sym_PLUS_PLUS] = ACTIONS(3717),
    [anon_sym_sizeof] = ACTIONS(3715),
    [anon_sym___alignof__] = ACTIONS(3715),
    [anon_sym___alignof] = ACTIONS(3715),
    [anon_sym__alignof] = ACTIONS(3715),
    [anon_sym_alignof] = ACTIONS(3715),
    [anon_sym__Alignof] = ACTIONS(3715),
    [anon_sym_offsetof] = ACTIONS(3715),
    [anon_sym__Generic] = ACTIONS(3715),
    [anon_sym_asm] = ACTIONS(3715),
    [anon_sym___asm__] = ACTIONS(3715),
    [anon_sym___asm] = ACTIONS(3715),
    [sym_number_literal] = ACTIONS(3717),
    [anon_sym_L_SQUOTE] = ACTIONS(3717),
    [anon_sym_u_SQUOTE] = ACTIONS(3717),
    [anon_sym_U_SQUOTE] = ACTIONS(3717),
    [anon_sym_u8_SQUOTE] = ACTIONS(3717),
    [anon_sym_SQUOTE] = ACTIONS(3717),
    [anon_sym_L_DQUOTE] = ACTIONS(3717),
    [anon_sym_u_DQUOTE] = ACTIONS(3717),
    [anon_sym_U_DQUOTE] = ACTIONS(3717),
    [anon_sym_u8_DQUOTE] = ACTIONS(3717),
    [anon_sym_DQUOTE] = ACTIONS(3717),
    [sym_true] = ACTIONS(3715),
    [sym_false] = ACTIONS(3715),
    [anon_sym_NULL] = ACTIONS(3715),
    [anon_sym_nullptr] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3715),
    [anon_sym_let] = ACTIONS(3715),
    [anon_sym_This] = ACTIONS(3715),
    [anon_sym_decltype] = ACTIONS(3715),
    [anon_sym_explicit] = ACTIONS(3715),
    [anon_sym_typename] = ACTIONS(3715),
    [anon_sym_template] = ACTIONS(3715),
    [anon_sym_operator] = ACTIONS(3715),
    [anon_sym_try] = ACTIONS(3715),
    [anon_sym_delete] = ACTIONS(3715),
    [anon_sym_throw] = ACTIONS(3715),
    [anon_sym_namespace] = ACTIONS(3715),
    [anon_sym_static_assert] = ACTIONS(3715),
    [anon_sym_concept] = ACTIONS(3715),
    [anon_sym_co_return] = ACTIONS(3715),
    [anon_sym_co_yield] = ACTIONS(3715),
    [anon_sym_R_DQUOTE] = ACTIONS(3717),
    [anon_sym_LR_DQUOTE] = ACTIONS(3717),
    [anon_sym_uR_DQUOTE] = ACTIONS(3717),
    [anon_sym_UR_DQUOTE] = ACTIONS(3717),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3717),
    [anon_sym_co_await] = ACTIONS(3715),
    [anon_sym_new] = ACTIONS(3715),
    [anon_sym_requires] = ACTIONS(3715),
    [sym_this] = ACTIONS(3715),
    [anon_sym_discard] = ACTIONS(3715),
    [anon_sym_precise] = ACTIONS(3715),
    [anon_sym_shared] = ACTIONS(3715),
    [anon_sym_groupshared] = ACTIONS(3715),
    [anon_sym_uniform] = ACTIONS(3715),
    [anon_sym_row_major] = ACTIONS(3715),
    [anon_sym_column_major] = ACTIONS(3715),
    [anon_sym_globallycoherent] = ACTIONS(3715),
    [anon_sym_centroid] = ACTIONS(3715),
    [anon_sym_noperspective] = ACTIONS(3715),
    [anon_sym_nointerpolation] = ACTIONS(3715),
    [anon_sym_sample] = ACTIONS(3715),
    [anon_sym_linear] = ACTIONS(3715),
    [anon_sym_snorm] = ACTIONS(3715),
    [anon_sym_unorm] = ACTIONS(3715),
    [anon_sym_point] = ACTIONS(3715),
    [anon_sym_line] = ACTIONS(3715),
    [anon_sym_triangleadj] = ACTIONS(3715),
    [anon_sym_lineadj] = ACTIONS(3715),
    [anon_sym_triangle] = ACTIONS(3715),
    [anon_sym_cbuffer] = ACTIONS(3715),
    [anon_sym_interface] = ACTIONS(3715),
    [anon_sym_extension] = ACTIONS(3715),
  },
  [539] = {
    [sym_identifier] = ACTIONS(3719),
    [aux_sym_preproc_include_token1] = ACTIONS(3719),
    [aux_sym_preproc_def_token1] = ACTIONS(3719),
    [aux_sym_preproc_if_token1] = ACTIONS(3719),
    [aux_sym_preproc_if_token2] = ACTIONS(3719),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3719),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3719),
    [aux_sym_preproc_else_token1] = ACTIONS(3719),
    [aux_sym_preproc_elif_token1] = ACTIONS(3719),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3719),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3719),
    [sym_preproc_directive] = ACTIONS(3719),
    [anon_sym_LPAREN2] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_TILDE] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3719),
    [anon_sym_SEMI] = ACTIONS(3721),
    [anon_sym___extension__] = ACTIONS(3719),
    [anon_sym_typedef] = ACTIONS(3719),
    [anon_sym_in] = ACTIONS(3719),
    [anon_sym_out] = ACTIONS(3719),
    [anon_sym_inout] = ACTIONS(3719),
    [anon_sym_virtual] = ACTIONS(3719),
    [anon_sym_extern] = ACTIONS(3719),
    [anon_sym___attribute__] = ACTIONS(3719),
    [anon_sym___attribute] = ACTIONS(3719),
    [anon_sym_using] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3721),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3721),
    [anon_sym___declspec] = ACTIONS(3719),
    [anon_sym___based] = ACTIONS(3719),
    [anon_sym___cdecl] = ACTIONS(3719),
    [anon_sym___clrcall] = ACTIONS(3719),
    [anon_sym___stdcall] = ACTIONS(3719),
    [anon_sym___fastcall] = ACTIONS(3719),
    [anon_sym___thiscall] = ACTIONS(3719),
    [anon_sym___vectorcall] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(3721),
    [anon_sym_signed] = ACTIONS(3719),
    [anon_sym_unsigned] = ACTIONS(3719),
    [anon_sym_long] = ACTIONS(3719),
    [anon_sym_short] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_static] = ACTIONS(3719),
    [anon_sym_register] = ACTIONS(3719),
    [anon_sym_inline] = ACTIONS(3719),
    [anon_sym___inline] = ACTIONS(3719),
    [anon_sym___inline__] = ACTIONS(3719),
    [anon_sym___forceinline] = ACTIONS(3719),
    [anon_sym_thread_local] = ACTIONS(3719),
    [anon_sym___thread] = ACTIONS(3719),
    [anon_sym_const] = ACTIONS(3719),
    [anon_sym_constexpr] = ACTIONS(3719),
    [anon_sym_volatile] = ACTIONS(3719),
    [anon_sym_restrict] = ACTIONS(3719),
    [anon_sym___restrict__] = ACTIONS(3719),
    [anon_sym__Atomic] = ACTIONS(3719),
    [anon_sym__Noreturn] = ACTIONS(3719),
    [anon_sym_noreturn] = ACTIONS(3719),
    [anon_sym__Nonnull] = ACTIONS(3719),
    [anon_sym_mutable] = ACTIONS(3719),
    [anon_sym_constinit] = ACTIONS(3719),
    [anon_sym_consteval] = ACTIONS(3719),
    [anon_sym_alignas] = ACTIONS(3719),
    [anon_sym__Alignas] = ACTIONS(3719),
    [sym_primitive_type] = ACTIONS(3719),
    [anon_sym_enum] = ACTIONS(3719),
    [anon_sym_class] = ACTIONS(3719),
    [anon_sym_struct] = ACTIONS(3719),
    [anon_sym_union] = ACTIONS(3719),
    [anon_sym_if] = ACTIONS(3719),
    [anon_sym_switch] = ACTIONS(3719),
    [anon_sym_case] = ACTIONS(3719),
    [anon_sym_default] = ACTIONS(3719),
    [anon_sym_while] = ACTIONS(3719),
    [anon_sym_do] = ACTIONS(3719),
    [anon_sym_for] = ACTIONS(3719),
    [anon_sym_return] = ACTIONS(3719),
    [anon_sym_break] = ACTIONS(3719),
    [anon_sym_continue] = ACTIONS(3719),
    [anon_sym_goto] = ACTIONS(3719),
    [anon_sym___try] = ACTIONS(3719),
    [anon_sym___leave] = ACTIONS(3719),
    [anon_sym_not] = ACTIONS(3719),
    [anon_sym_compl] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3721),
    [anon_sym_sizeof] = ACTIONS(3719),
    [anon_sym___alignof__] = ACTIONS(3719),
    [anon_sym___alignof] = ACTIONS(3719),
    [anon_sym__alignof] = ACTIONS(3719),
    [anon_sym_alignof] = ACTIONS(3719),
    [anon_sym__Alignof] = ACTIONS(3719),
    [anon_sym_offsetof] = ACTIONS(3719),
    [anon_sym__Generic] = ACTIONS(3719),
    [anon_sym_asm] = ACTIONS(3719),
    [anon_sym___asm__] = ACTIONS(3719),
    [anon_sym___asm] = ACTIONS(3719),
    [sym_number_literal] = ACTIONS(3721),
    [anon_sym_L_SQUOTE] = ACTIONS(3721),
    [anon_sym_u_SQUOTE] = ACTIONS(3721),
    [anon_sym_U_SQUOTE] = ACTIONS(3721),
    [anon_sym_u8_SQUOTE] = ACTIONS(3721),
    [anon_sym_SQUOTE] = ACTIONS(3721),
    [anon_sym_L_DQUOTE] = ACTIONS(3721),
    [anon_sym_u_DQUOTE] = ACTIONS(3721),
    [anon_sym_U_DQUOTE] = ACTIONS(3721),
    [anon_sym_u8_DQUOTE] = ACTIONS(3721),
    [anon_sym_DQUOTE] = ACTIONS(3721),
    [sym_true] = ACTIONS(3719),
    [sym_false] = ACTIONS(3719),
    [anon_sym_NULL] = ACTIONS(3719),
    [anon_sym_nullptr] = ACTIONS(3719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3719),
    [anon_sym_let] = ACTIONS(3719),
    [anon_sym_This] = ACTIONS(3719),
    [anon_sym_decltype] = ACTIONS(3719),
    [anon_sym_explicit] = ACTIONS(3719),
    [anon_sym_typename] = ACTIONS(3719),
    [anon_sym_template] = ACTIONS(3719),
    [anon_sym_operator] = ACTIONS(3719),
    [anon_sym_try] = ACTIONS(3719),
    [anon_sym_delete] = ACTIONS(3719),
    [anon_sym_throw] = ACTIONS(3719),
    [anon_sym_namespace] = ACTIONS(3719),
    [anon_sym_static_assert] = ACTIONS(3719),
    [anon_sym_concept] = ACTIONS(3719),
    [anon_sym_co_return] = ACTIONS(3719),
    [anon_sym_co_yield] = ACTIONS(3719),
    [anon_sym_R_DQUOTE] = ACTIONS(3721),
    [anon_sym_LR_DQUOTE] = ACTIONS(3721),
    [anon_sym_uR_DQUOTE] = ACTIONS(3721),
    [anon_sym_UR_DQUOTE] = ACTIONS(3721),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3721),
    [anon_sym_co_await] = ACTIONS(3719),
    [anon_sym_new] = ACTIONS(3719),
    [anon_sym_requires] = ACTIONS(3719),
    [sym_this] = ACTIONS(3719),
    [anon_sym_discard] = ACTIONS(3719),
    [anon_sym_precise] = ACTIONS(3719),
    [anon_sym_shared] = ACTIONS(3719),
    [anon_sym_groupshared] = ACTIONS(3719),
    [anon_sym_uniform] = ACTIONS(3719),
    [anon_sym_row_major] = ACTIONS(3719),
    [anon_sym_column_major] = ACTIONS(3719),
    [anon_sym_globallycoherent] = ACTIONS(3719),
    [anon_sym_centroid] = ACTIONS(3719),
    [anon_sym_noperspective] = ACTIONS(3719),
    [anon_sym_nointerpolation] = ACTIONS(3719),
    [anon_sym_sample] = ACTIONS(3719),
    [anon_sym_linear] = ACTIONS(3719),
    [anon_sym_snorm] = ACTIONS(3719),
    [anon_sym_unorm] = ACTIONS(3719),
    [anon_sym_point] = ACTIONS(3719),
    [anon_sym_line] = ACTIONS(3719),
    [anon_sym_triangleadj] = ACTIONS(3719),
    [anon_sym_lineadj] = ACTIONS(3719),
    [anon_sym_triangle] = ACTIONS(3719),
    [anon_sym_cbuffer] = ACTIONS(3719),
    [anon_sym_interface] = ACTIONS(3719),
    [anon_sym_extension] = ACTIONS(3719),
  },
  [540] = {
    [sym_identifier] = ACTIONS(3723),
    [aux_sym_preproc_include_token1] = ACTIONS(3723),
    [aux_sym_preproc_def_token1] = ACTIONS(3723),
    [aux_sym_preproc_if_token1] = ACTIONS(3723),
    [aux_sym_preproc_if_token2] = ACTIONS(3723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3723),
    [aux_sym_preproc_else_token1] = ACTIONS(3723),
    [aux_sym_preproc_elif_token1] = ACTIONS(3723),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3723),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3723),
    [sym_preproc_directive] = ACTIONS(3723),
    [anon_sym_LPAREN2] = ACTIONS(3725),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(3725),
    [anon_sym_AMP_AMP] = ACTIONS(3725),
    [anon_sym_AMP] = ACTIONS(3723),
    [anon_sym_SEMI] = ACTIONS(3725),
    [anon_sym___extension__] = ACTIONS(3723),
    [anon_sym_typedef] = ACTIONS(3723),
    [anon_sym_in] = ACTIONS(3723),
    [anon_sym_out] = ACTIONS(3723),
    [anon_sym_inout] = ACTIONS(3723),
    [anon_sym_virtual] = ACTIONS(3723),
    [anon_sym_extern] = ACTIONS(3723),
    [anon_sym___attribute__] = ACTIONS(3723),
    [anon_sym___attribute] = ACTIONS(3723),
    [anon_sym_using] = ACTIONS(3723),
    [anon_sym_COLON_COLON] = ACTIONS(3725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3725),
    [anon_sym___declspec] = ACTIONS(3723),
    [anon_sym___based] = ACTIONS(3723),
    [anon_sym___cdecl] = ACTIONS(3723),
    [anon_sym___clrcall] = ACTIONS(3723),
    [anon_sym___stdcall] = ACTIONS(3723),
    [anon_sym___fastcall] = ACTIONS(3723),
    [anon_sym___thiscall] = ACTIONS(3723),
    [anon_sym___vectorcall] = ACTIONS(3723),
    [anon_sym_LBRACE] = ACTIONS(3725),
    [anon_sym_signed] = ACTIONS(3723),
    [anon_sym_unsigned] = ACTIONS(3723),
    [anon_sym_long] = ACTIONS(3723),
    [anon_sym_short] = ACTIONS(3723),
    [anon_sym_LBRACK] = ACTIONS(3723),
    [anon_sym_static] = ACTIONS(3723),
    [anon_sym_register] = ACTIONS(3723),
    [anon_sym_inline] = ACTIONS(3723),
    [anon_sym___inline] = ACTIONS(3723),
    [anon_sym___inline__] = ACTIONS(3723),
    [anon_sym___forceinline] = ACTIONS(3723),
    [anon_sym_thread_local] = ACTIONS(3723),
    [anon_sym___thread] = ACTIONS(3723),
    [anon_sym_const] = ACTIONS(3723),
    [anon_sym_constexpr] = ACTIONS(3723),
    [anon_sym_volatile] = ACTIONS(3723),
    [anon_sym_restrict] = ACTIONS(3723),
    [anon_sym___restrict__] = ACTIONS(3723),
    [anon_sym__Atomic] = ACTIONS(3723),
    [anon_sym__Noreturn] = ACTIONS(3723),
    [anon_sym_noreturn] = ACTIONS(3723),
    [anon_sym__Nonnull] = ACTIONS(3723),
    [anon_sym_mutable] = ACTIONS(3723),
    [anon_sym_constinit] = ACTIONS(3723),
    [anon_sym_consteval] = ACTIONS(3723),
    [anon_sym_alignas] = ACTIONS(3723),
    [anon_sym__Alignas] = ACTIONS(3723),
    [sym_primitive_type] = ACTIONS(3723),
    [anon_sym_enum] = ACTIONS(3723),
    [anon_sym_class] = ACTIONS(3723),
    [anon_sym_struct] = ACTIONS(3723),
    [anon_sym_union] = ACTIONS(3723),
    [anon_sym_if] = ACTIONS(3723),
    [anon_sym_switch] = ACTIONS(3723),
    [anon_sym_case] = ACTIONS(3723),
    [anon_sym_default] = ACTIONS(3723),
    [anon_sym_while] = ACTIONS(3723),
    [anon_sym_do] = ACTIONS(3723),
    [anon_sym_for] = ACTIONS(3723),
    [anon_sym_return] = ACTIONS(3723),
    [anon_sym_break] = ACTIONS(3723),
    [anon_sym_continue] = ACTIONS(3723),
    [anon_sym_goto] = ACTIONS(3723),
    [anon_sym___try] = ACTIONS(3723),
    [anon_sym___leave] = ACTIONS(3723),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(3725),
    [anon_sym_PLUS_PLUS] = ACTIONS(3725),
    [anon_sym_sizeof] = ACTIONS(3723),
    [anon_sym___alignof__] = ACTIONS(3723),
    [anon_sym___alignof] = ACTIONS(3723),
    [anon_sym__alignof] = ACTIONS(3723),
    [anon_sym_alignof] = ACTIONS(3723),
    [anon_sym__Alignof] = ACTIONS(3723),
    [anon_sym_offsetof] = ACTIONS(3723),
    [anon_sym__Generic] = ACTIONS(3723),
    [anon_sym_asm] = ACTIONS(3723),
    [anon_sym___asm__] = ACTIONS(3723),
    [anon_sym___asm] = ACTIONS(3723),
    [sym_number_literal] = ACTIONS(3725),
    [anon_sym_L_SQUOTE] = ACTIONS(3725),
    [anon_sym_u_SQUOTE] = ACTIONS(3725),
    [anon_sym_U_SQUOTE] = ACTIONS(3725),
    [anon_sym_u8_SQUOTE] = ACTIONS(3725),
    [anon_sym_SQUOTE] = ACTIONS(3725),
    [anon_sym_L_DQUOTE] = ACTIONS(3725),
    [anon_sym_u_DQUOTE] = ACTIONS(3725),
    [anon_sym_U_DQUOTE] = ACTIONS(3725),
    [anon_sym_u8_DQUOTE] = ACTIONS(3725),
    [anon_sym_DQUOTE] = ACTIONS(3725),
    [sym_true] = ACTIONS(3723),
    [sym_false] = ACTIONS(3723),
    [anon_sym_NULL] = ACTIONS(3723),
    [anon_sym_nullptr] = ACTIONS(3723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3723),
    [anon_sym_let] = ACTIONS(3723),
    [anon_sym_This] = ACTIONS(3723),
    [anon_sym_decltype] = ACTIONS(3723),
    [anon_sym_explicit] = ACTIONS(3723),
    [anon_sym_typename] = ACTIONS(3723),
    [anon_sym_template] = ACTIONS(3723),
    [anon_sym_operator] = ACTIONS(3723),
    [anon_sym_try] = ACTIONS(3723),
    [anon_sym_delete] = ACTIONS(3723),
    [anon_sym_throw] = ACTIONS(3723),
    [anon_sym_namespace] = ACTIONS(3723),
    [anon_sym_static_assert] = ACTIONS(3723),
    [anon_sym_concept] = ACTIONS(3723),
    [anon_sym_co_return] = ACTIONS(3723),
    [anon_sym_co_yield] = ACTIONS(3723),
    [anon_sym_R_DQUOTE] = ACTIONS(3725),
    [anon_sym_LR_DQUOTE] = ACTIONS(3725),
    [anon_sym_uR_DQUOTE] = ACTIONS(3725),
    [anon_sym_UR_DQUOTE] = ACTIONS(3725),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3725),
    [anon_sym_co_await] = ACTIONS(3723),
    [anon_sym_new] = ACTIONS(3723),
    [anon_sym_requires] = ACTIONS(3723),
    [sym_this] = ACTIONS(3723),
    [anon_sym_discard] = ACTIONS(3723),
    [anon_sym_precise] = ACTIONS(3723),
    [anon_sym_shared] = ACTIONS(3723),
    [anon_sym_groupshared] = ACTIONS(3723),
    [anon_sym_uniform] = ACTIONS(3723),
    [anon_sym_row_major] = ACTIONS(3723),
    [anon_sym_column_major] = ACTIONS(3723),
    [anon_sym_globallycoherent] = ACTIONS(3723),
    [anon_sym_centroid] = ACTIONS(3723),
    [anon_sym_noperspective] = ACTIONS(3723),
    [anon_sym_nointerpolation] = ACTIONS(3723),
    [anon_sym_sample] = ACTIONS(3723),
    [anon_sym_linear] = ACTIONS(3723),
    [anon_sym_snorm] = ACTIONS(3723),
    [anon_sym_unorm] = ACTIONS(3723),
    [anon_sym_point] = ACTIONS(3723),
    [anon_sym_line] = ACTIONS(3723),
    [anon_sym_triangleadj] = ACTIONS(3723),
    [anon_sym_lineadj] = ACTIONS(3723),
    [anon_sym_triangle] = ACTIONS(3723),
    [anon_sym_cbuffer] = ACTIONS(3723),
    [anon_sym_interface] = ACTIONS(3723),
    [anon_sym_extension] = ACTIONS(3723),
  },
  [541] = {
    [sym_identifier] = ACTIONS(3727),
    [aux_sym_preproc_include_token1] = ACTIONS(3727),
    [aux_sym_preproc_def_token1] = ACTIONS(3727),
    [aux_sym_preproc_if_token1] = ACTIONS(3727),
    [aux_sym_preproc_if_token2] = ACTIONS(3727),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3727),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3727),
    [aux_sym_preproc_else_token1] = ACTIONS(3727),
    [aux_sym_preproc_elif_token1] = ACTIONS(3727),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3727),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3727),
    [sym_preproc_directive] = ACTIONS(3727),
    [anon_sym_LPAREN2] = ACTIONS(3729),
    [anon_sym_BANG] = ACTIONS(3729),
    [anon_sym_TILDE] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3727),
    [anon_sym_PLUS] = ACTIONS(3727),
    [anon_sym_STAR] = ACTIONS(3729),
    [anon_sym_AMP_AMP] = ACTIONS(3729),
    [anon_sym_AMP] = ACTIONS(3727),
    [anon_sym_SEMI] = ACTIONS(3729),
    [anon_sym___extension__] = ACTIONS(3727),
    [anon_sym_typedef] = ACTIONS(3727),
    [anon_sym_in] = ACTIONS(3727),
    [anon_sym_out] = ACTIONS(3727),
    [anon_sym_inout] = ACTIONS(3727),
    [anon_sym_virtual] = ACTIONS(3727),
    [anon_sym_extern] = ACTIONS(3727),
    [anon_sym___attribute__] = ACTIONS(3727),
    [anon_sym___attribute] = ACTIONS(3727),
    [anon_sym_using] = ACTIONS(3727),
    [anon_sym_COLON_COLON] = ACTIONS(3729),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3729),
    [anon_sym___declspec] = ACTIONS(3727),
    [anon_sym___based] = ACTIONS(3727),
    [anon_sym___cdecl] = ACTIONS(3727),
    [anon_sym___clrcall] = ACTIONS(3727),
    [anon_sym___stdcall] = ACTIONS(3727),
    [anon_sym___fastcall] = ACTIONS(3727),
    [anon_sym___thiscall] = ACTIONS(3727),
    [anon_sym___vectorcall] = ACTIONS(3727),
    [anon_sym_LBRACE] = ACTIONS(3729),
    [anon_sym_signed] = ACTIONS(3727),
    [anon_sym_unsigned] = ACTIONS(3727),
    [anon_sym_long] = ACTIONS(3727),
    [anon_sym_short] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(3727),
    [anon_sym_static] = ACTIONS(3727),
    [anon_sym_register] = ACTIONS(3727),
    [anon_sym_inline] = ACTIONS(3727),
    [anon_sym___inline] = ACTIONS(3727),
    [anon_sym___inline__] = ACTIONS(3727),
    [anon_sym___forceinline] = ACTIONS(3727),
    [anon_sym_thread_local] = ACTIONS(3727),
    [anon_sym___thread] = ACTIONS(3727),
    [anon_sym_const] = ACTIONS(3727),
    [anon_sym_constexpr] = ACTIONS(3727),
    [anon_sym_volatile] = ACTIONS(3727),
    [anon_sym_restrict] = ACTIONS(3727),
    [anon_sym___restrict__] = ACTIONS(3727),
    [anon_sym__Atomic] = ACTIONS(3727),
    [anon_sym__Noreturn] = ACTIONS(3727),
    [anon_sym_noreturn] = ACTIONS(3727),
    [anon_sym__Nonnull] = ACTIONS(3727),
    [anon_sym_mutable] = ACTIONS(3727),
    [anon_sym_constinit] = ACTIONS(3727),
    [anon_sym_consteval] = ACTIONS(3727),
    [anon_sym_alignas] = ACTIONS(3727),
    [anon_sym__Alignas] = ACTIONS(3727),
    [sym_primitive_type] = ACTIONS(3727),
    [anon_sym_enum] = ACTIONS(3727),
    [anon_sym_class] = ACTIONS(3727),
    [anon_sym_struct] = ACTIONS(3727),
    [anon_sym_union] = ACTIONS(3727),
    [anon_sym_if] = ACTIONS(3727),
    [anon_sym_switch] = ACTIONS(3727),
    [anon_sym_case] = ACTIONS(3727),
    [anon_sym_default] = ACTIONS(3727),
    [anon_sym_while] = ACTIONS(3727),
    [anon_sym_do] = ACTIONS(3727),
    [anon_sym_for] = ACTIONS(3727),
    [anon_sym_return] = ACTIONS(3727),
    [anon_sym_break] = ACTIONS(3727),
    [anon_sym_continue] = ACTIONS(3727),
    [anon_sym_goto] = ACTIONS(3727),
    [anon_sym___try] = ACTIONS(3727),
    [anon_sym___leave] = ACTIONS(3727),
    [anon_sym_not] = ACTIONS(3727),
    [anon_sym_compl] = ACTIONS(3727),
    [anon_sym_DASH_DASH] = ACTIONS(3729),
    [anon_sym_PLUS_PLUS] = ACTIONS(3729),
    [anon_sym_sizeof] = ACTIONS(3727),
    [anon_sym___alignof__] = ACTIONS(3727),
    [anon_sym___alignof] = ACTIONS(3727),
    [anon_sym__alignof] = ACTIONS(3727),
    [anon_sym_alignof] = ACTIONS(3727),
    [anon_sym__Alignof] = ACTIONS(3727),
    [anon_sym_offsetof] = ACTIONS(3727),
    [anon_sym__Generic] = ACTIONS(3727),
    [anon_sym_asm] = ACTIONS(3727),
    [anon_sym___asm__] = ACTIONS(3727),
    [anon_sym___asm] = ACTIONS(3727),
    [sym_number_literal] = ACTIONS(3729),
    [anon_sym_L_SQUOTE] = ACTIONS(3729),
    [anon_sym_u_SQUOTE] = ACTIONS(3729),
    [anon_sym_U_SQUOTE] = ACTIONS(3729),
    [anon_sym_u8_SQUOTE] = ACTIONS(3729),
    [anon_sym_SQUOTE] = ACTIONS(3729),
    [anon_sym_L_DQUOTE] = ACTIONS(3729),
    [anon_sym_u_DQUOTE] = ACTIONS(3729),
    [anon_sym_U_DQUOTE] = ACTIONS(3729),
    [anon_sym_u8_DQUOTE] = ACTIONS(3729),
    [anon_sym_DQUOTE] = ACTIONS(3729),
    [sym_true] = ACTIONS(3727),
    [sym_false] = ACTIONS(3727),
    [anon_sym_NULL] = ACTIONS(3727),
    [anon_sym_nullptr] = ACTIONS(3727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3727),
    [anon_sym_let] = ACTIONS(3727),
    [anon_sym_This] = ACTIONS(3727),
    [anon_sym_decltype] = ACTIONS(3727),
    [anon_sym_explicit] = ACTIONS(3727),
    [anon_sym_typename] = ACTIONS(3727),
    [anon_sym_template] = ACTIONS(3727),
    [anon_sym_operator] = ACTIONS(3727),
    [anon_sym_try] = ACTIONS(3727),
    [anon_sym_delete] = ACTIONS(3727),
    [anon_sym_throw] = ACTIONS(3727),
    [anon_sym_namespace] = ACTIONS(3727),
    [anon_sym_static_assert] = ACTIONS(3727),
    [anon_sym_concept] = ACTIONS(3727),
    [anon_sym_co_return] = ACTIONS(3727),
    [anon_sym_co_yield] = ACTIONS(3727),
    [anon_sym_R_DQUOTE] = ACTIONS(3729),
    [anon_sym_LR_DQUOTE] = ACTIONS(3729),
    [anon_sym_uR_DQUOTE] = ACTIONS(3729),
    [anon_sym_UR_DQUOTE] = ACTIONS(3729),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3729),
    [anon_sym_co_await] = ACTIONS(3727),
    [anon_sym_new] = ACTIONS(3727),
    [anon_sym_requires] = ACTIONS(3727),
    [sym_this] = ACTIONS(3727),
    [anon_sym_discard] = ACTIONS(3727),
    [anon_sym_precise] = ACTIONS(3727),
    [anon_sym_shared] = ACTIONS(3727),
    [anon_sym_groupshared] = ACTIONS(3727),
    [anon_sym_uniform] = ACTIONS(3727),
    [anon_sym_row_major] = ACTIONS(3727),
    [anon_sym_column_major] = ACTIONS(3727),
    [anon_sym_globallycoherent] = ACTIONS(3727),
    [anon_sym_centroid] = ACTIONS(3727),
    [anon_sym_noperspective] = ACTIONS(3727),
    [anon_sym_nointerpolation] = ACTIONS(3727),
    [anon_sym_sample] = ACTIONS(3727),
    [anon_sym_linear] = ACTIONS(3727),
    [anon_sym_snorm] = ACTIONS(3727),
    [anon_sym_unorm] = ACTIONS(3727),
    [anon_sym_point] = ACTIONS(3727),
    [anon_sym_line] = ACTIONS(3727),
    [anon_sym_triangleadj] = ACTIONS(3727),
    [anon_sym_lineadj] = ACTIONS(3727),
    [anon_sym_triangle] = ACTIONS(3727),
    [anon_sym_cbuffer] = ACTIONS(3727),
    [anon_sym_interface] = ACTIONS(3727),
    [anon_sym_extension] = ACTIONS(3727),
  },
  [542] = {
    [sym_identifier] = ACTIONS(3731),
    [aux_sym_preproc_include_token1] = ACTIONS(3731),
    [aux_sym_preproc_def_token1] = ACTIONS(3731),
    [aux_sym_preproc_if_token1] = ACTIONS(3731),
    [aux_sym_preproc_if_token2] = ACTIONS(3731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3731),
    [aux_sym_preproc_else_token1] = ACTIONS(3731),
    [aux_sym_preproc_elif_token1] = ACTIONS(3731),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3731),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3731),
    [sym_preproc_directive] = ACTIONS(3731),
    [anon_sym_LPAREN2] = ACTIONS(3733),
    [anon_sym_BANG] = ACTIONS(3733),
    [anon_sym_TILDE] = ACTIONS(3733),
    [anon_sym_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3731),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_AMP_AMP] = ACTIONS(3733),
    [anon_sym_AMP] = ACTIONS(3731),
    [anon_sym_SEMI] = ACTIONS(3733),
    [anon_sym___extension__] = ACTIONS(3731),
    [anon_sym_typedef] = ACTIONS(3731),
    [anon_sym_in] = ACTIONS(3731),
    [anon_sym_out] = ACTIONS(3731),
    [anon_sym_inout] = ACTIONS(3731),
    [anon_sym_virtual] = ACTIONS(3731),
    [anon_sym_extern] = ACTIONS(3731),
    [anon_sym___attribute__] = ACTIONS(3731),
    [anon_sym___attribute] = ACTIONS(3731),
    [anon_sym_using] = ACTIONS(3731),
    [anon_sym_COLON_COLON] = ACTIONS(3733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3733),
    [anon_sym___declspec] = ACTIONS(3731),
    [anon_sym___based] = ACTIONS(3731),
    [anon_sym___cdecl] = ACTIONS(3731),
    [anon_sym___clrcall] = ACTIONS(3731),
    [anon_sym___stdcall] = ACTIONS(3731),
    [anon_sym___fastcall] = ACTIONS(3731),
    [anon_sym___thiscall] = ACTIONS(3731),
    [anon_sym___vectorcall] = ACTIONS(3731),
    [anon_sym_LBRACE] = ACTIONS(3733),
    [anon_sym_signed] = ACTIONS(3731),
    [anon_sym_unsigned] = ACTIONS(3731),
    [anon_sym_long] = ACTIONS(3731),
    [anon_sym_short] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3731),
    [anon_sym_static] = ACTIONS(3731),
    [anon_sym_register] = ACTIONS(3731),
    [anon_sym_inline] = ACTIONS(3731),
    [anon_sym___inline] = ACTIONS(3731),
    [anon_sym___inline__] = ACTIONS(3731),
    [anon_sym___forceinline] = ACTIONS(3731),
    [anon_sym_thread_local] = ACTIONS(3731),
    [anon_sym___thread] = ACTIONS(3731),
    [anon_sym_const] = ACTIONS(3731),
    [anon_sym_constexpr] = ACTIONS(3731),
    [anon_sym_volatile] = ACTIONS(3731),
    [anon_sym_restrict] = ACTIONS(3731),
    [anon_sym___restrict__] = ACTIONS(3731),
    [anon_sym__Atomic] = ACTIONS(3731),
    [anon_sym__Noreturn] = ACTIONS(3731),
    [anon_sym_noreturn] = ACTIONS(3731),
    [anon_sym__Nonnull] = ACTIONS(3731),
    [anon_sym_mutable] = ACTIONS(3731),
    [anon_sym_constinit] = ACTIONS(3731),
    [anon_sym_consteval] = ACTIONS(3731),
    [anon_sym_alignas] = ACTIONS(3731),
    [anon_sym__Alignas] = ACTIONS(3731),
    [sym_primitive_type] = ACTIONS(3731),
    [anon_sym_enum] = ACTIONS(3731),
    [anon_sym_class] = ACTIONS(3731),
    [anon_sym_struct] = ACTIONS(3731),
    [anon_sym_union] = ACTIONS(3731),
    [anon_sym_if] = ACTIONS(3731),
    [anon_sym_switch] = ACTIONS(3731),
    [anon_sym_case] = ACTIONS(3731),
    [anon_sym_default] = ACTIONS(3731),
    [anon_sym_while] = ACTIONS(3731),
    [anon_sym_do] = ACTIONS(3731),
    [anon_sym_for] = ACTIONS(3731),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_break] = ACTIONS(3731),
    [anon_sym_continue] = ACTIONS(3731),
    [anon_sym_goto] = ACTIONS(3731),
    [anon_sym___try] = ACTIONS(3731),
    [anon_sym___leave] = ACTIONS(3731),
    [anon_sym_not] = ACTIONS(3731),
    [anon_sym_compl] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3733),
    [anon_sym_PLUS_PLUS] = ACTIONS(3733),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3731),
    [anon_sym___alignof] = ACTIONS(3731),
    [anon_sym__alignof] = ACTIONS(3731),
    [anon_sym_alignof] = ACTIONS(3731),
    [anon_sym__Alignof] = ACTIONS(3731),
    [anon_sym_offsetof] = ACTIONS(3731),
    [anon_sym__Generic] = ACTIONS(3731),
    [anon_sym_asm] = ACTIONS(3731),
    [anon_sym___asm__] = ACTIONS(3731),
    [anon_sym___asm] = ACTIONS(3731),
    [sym_number_literal] = ACTIONS(3733),
    [anon_sym_L_SQUOTE] = ACTIONS(3733),
    [anon_sym_u_SQUOTE] = ACTIONS(3733),
    [anon_sym_U_SQUOTE] = ACTIONS(3733),
    [anon_sym_u8_SQUOTE] = ACTIONS(3733),
    [anon_sym_SQUOTE] = ACTIONS(3733),
    [anon_sym_L_DQUOTE] = ACTIONS(3733),
    [anon_sym_u_DQUOTE] = ACTIONS(3733),
    [anon_sym_U_DQUOTE] = ACTIONS(3733),
    [anon_sym_u8_DQUOTE] = ACTIONS(3733),
    [anon_sym_DQUOTE] = ACTIONS(3733),
    [sym_true] = ACTIONS(3731),
    [sym_false] = ACTIONS(3731),
    [anon_sym_NULL] = ACTIONS(3731),
    [anon_sym_nullptr] = ACTIONS(3731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3731),
    [anon_sym_let] = ACTIONS(3731),
    [anon_sym_This] = ACTIONS(3731),
    [anon_sym_decltype] = ACTIONS(3731),
    [anon_sym_explicit] = ACTIONS(3731),
    [anon_sym_typename] = ACTIONS(3731),
    [anon_sym_template] = ACTIONS(3731),
    [anon_sym_operator] = ACTIONS(3731),
    [anon_sym_try] = ACTIONS(3731),
    [anon_sym_delete] = ACTIONS(3731),
    [anon_sym_throw] = ACTIONS(3731),
    [anon_sym_namespace] = ACTIONS(3731),
    [anon_sym_static_assert] = ACTIONS(3731),
    [anon_sym_concept] = ACTIONS(3731),
    [anon_sym_co_return] = ACTIONS(3731),
    [anon_sym_co_yield] = ACTIONS(3731),
    [anon_sym_R_DQUOTE] = ACTIONS(3733),
    [anon_sym_LR_DQUOTE] = ACTIONS(3733),
    [anon_sym_uR_DQUOTE] = ACTIONS(3733),
    [anon_sym_UR_DQUOTE] = ACTIONS(3733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3733),
    [anon_sym_co_await] = ACTIONS(3731),
    [anon_sym_new] = ACTIONS(3731),
    [anon_sym_requires] = ACTIONS(3731),
    [sym_this] = ACTIONS(3731),
    [anon_sym_discard] = ACTIONS(3731),
    [anon_sym_precise] = ACTIONS(3731),
    [anon_sym_shared] = ACTIONS(3731),
    [anon_sym_groupshared] = ACTIONS(3731),
    [anon_sym_uniform] = ACTIONS(3731),
    [anon_sym_row_major] = ACTIONS(3731),
    [anon_sym_column_major] = ACTIONS(3731),
    [anon_sym_globallycoherent] = ACTIONS(3731),
    [anon_sym_centroid] = ACTIONS(3731),
    [anon_sym_noperspective] = ACTIONS(3731),
    [anon_sym_nointerpolation] = ACTIONS(3731),
    [anon_sym_sample] = ACTIONS(3731),
    [anon_sym_linear] = ACTIONS(3731),
    [anon_sym_snorm] = ACTIONS(3731),
    [anon_sym_unorm] = ACTIONS(3731),
    [anon_sym_point] = ACTIONS(3731),
    [anon_sym_line] = ACTIONS(3731),
    [anon_sym_triangleadj] = ACTIONS(3731),
    [anon_sym_lineadj] = ACTIONS(3731),
    [anon_sym_triangle] = ACTIONS(3731),
    [anon_sym_cbuffer] = ACTIONS(3731),
    [anon_sym_interface] = ACTIONS(3731),
    [anon_sym_extension] = ACTIONS(3731),
  },
  [543] = {
    [sym_identifier] = ACTIONS(3735),
    [aux_sym_preproc_include_token1] = ACTIONS(3735),
    [aux_sym_preproc_def_token1] = ACTIONS(3735),
    [aux_sym_preproc_if_token1] = ACTIONS(3735),
    [aux_sym_preproc_if_token2] = ACTIONS(3735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3735),
    [aux_sym_preproc_else_token1] = ACTIONS(3735),
    [aux_sym_preproc_elif_token1] = ACTIONS(3735),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3735),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3735),
    [sym_preproc_directive] = ACTIONS(3735),
    [anon_sym_LPAREN2] = ACTIONS(3737),
    [anon_sym_BANG] = ACTIONS(3737),
    [anon_sym_TILDE] = ACTIONS(3737),
    [anon_sym_DASH] = ACTIONS(3735),
    [anon_sym_PLUS] = ACTIONS(3735),
    [anon_sym_STAR] = ACTIONS(3737),
    [anon_sym_AMP_AMP] = ACTIONS(3737),
    [anon_sym_AMP] = ACTIONS(3735),
    [anon_sym_SEMI] = ACTIONS(3737),
    [anon_sym___extension__] = ACTIONS(3735),
    [anon_sym_typedef] = ACTIONS(3735),
    [anon_sym_in] = ACTIONS(3735),
    [anon_sym_out] = ACTIONS(3735),
    [anon_sym_inout] = ACTIONS(3735),
    [anon_sym_virtual] = ACTIONS(3735),
    [anon_sym_extern] = ACTIONS(3735),
    [anon_sym___attribute__] = ACTIONS(3735),
    [anon_sym___attribute] = ACTIONS(3735),
    [anon_sym_using] = ACTIONS(3735),
    [anon_sym_COLON_COLON] = ACTIONS(3737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3737),
    [anon_sym___declspec] = ACTIONS(3735),
    [anon_sym___based] = ACTIONS(3735),
    [anon_sym___cdecl] = ACTIONS(3735),
    [anon_sym___clrcall] = ACTIONS(3735),
    [anon_sym___stdcall] = ACTIONS(3735),
    [anon_sym___fastcall] = ACTIONS(3735),
    [anon_sym___thiscall] = ACTIONS(3735),
    [anon_sym___vectorcall] = ACTIONS(3735),
    [anon_sym_LBRACE] = ACTIONS(3737),
    [anon_sym_signed] = ACTIONS(3735),
    [anon_sym_unsigned] = ACTIONS(3735),
    [anon_sym_long] = ACTIONS(3735),
    [anon_sym_short] = ACTIONS(3735),
    [anon_sym_LBRACK] = ACTIONS(3735),
    [anon_sym_static] = ACTIONS(3735),
    [anon_sym_register] = ACTIONS(3735),
    [anon_sym_inline] = ACTIONS(3735),
    [anon_sym___inline] = ACTIONS(3735),
    [anon_sym___inline__] = ACTIONS(3735),
    [anon_sym___forceinline] = ACTIONS(3735),
    [anon_sym_thread_local] = ACTIONS(3735),
    [anon_sym___thread] = ACTIONS(3735),
    [anon_sym_const] = ACTIONS(3735),
    [anon_sym_constexpr] = ACTIONS(3735),
    [anon_sym_volatile] = ACTIONS(3735),
    [anon_sym_restrict] = ACTIONS(3735),
    [anon_sym___restrict__] = ACTIONS(3735),
    [anon_sym__Atomic] = ACTIONS(3735),
    [anon_sym__Noreturn] = ACTIONS(3735),
    [anon_sym_noreturn] = ACTIONS(3735),
    [anon_sym__Nonnull] = ACTIONS(3735),
    [anon_sym_mutable] = ACTIONS(3735),
    [anon_sym_constinit] = ACTIONS(3735),
    [anon_sym_consteval] = ACTIONS(3735),
    [anon_sym_alignas] = ACTIONS(3735),
    [anon_sym__Alignas] = ACTIONS(3735),
    [sym_primitive_type] = ACTIONS(3735),
    [anon_sym_enum] = ACTIONS(3735),
    [anon_sym_class] = ACTIONS(3735),
    [anon_sym_struct] = ACTIONS(3735),
    [anon_sym_union] = ACTIONS(3735),
    [anon_sym_if] = ACTIONS(3735),
    [anon_sym_switch] = ACTIONS(3735),
    [anon_sym_case] = ACTIONS(3735),
    [anon_sym_default] = ACTIONS(3735),
    [anon_sym_while] = ACTIONS(3735),
    [anon_sym_do] = ACTIONS(3735),
    [anon_sym_for] = ACTIONS(3735),
    [anon_sym_return] = ACTIONS(3735),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_continue] = ACTIONS(3735),
    [anon_sym_goto] = ACTIONS(3735),
    [anon_sym___try] = ACTIONS(3735),
    [anon_sym___leave] = ACTIONS(3735),
    [anon_sym_not] = ACTIONS(3735),
    [anon_sym_compl] = ACTIONS(3735),
    [anon_sym_DASH_DASH] = ACTIONS(3737),
    [anon_sym_PLUS_PLUS] = ACTIONS(3737),
    [anon_sym_sizeof] = ACTIONS(3735),
    [anon_sym___alignof__] = ACTIONS(3735),
    [anon_sym___alignof] = ACTIONS(3735),
    [anon_sym__alignof] = ACTIONS(3735),
    [anon_sym_alignof] = ACTIONS(3735),
    [anon_sym__Alignof] = ACTIONS(3735),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3735),
    [anon_sym_asm] = ACTIONS(3735),
    [anon_sym___asm__] = ACTIONS(3735),
    [anon_sym___asm] = ACTIONS(3735),
    [sym_number_literal] = ACTIONS(3737),
    [anon_sym_L_SQUOTE] = ACTIONS(3737),
    [anon_sym_u_SQUOTE] = ACTIONS(3737),
    [anon_sym_U_SQUOTE] = ACTIONS(3737),
    [anon_sym_u8_SQUOTE] = ACTIONS(3737),
    [anon_sym_SQUOTE] = ACTIONS(3737),
    [anon_sym_L_DQUOTE] = ACTIONS(3737),
    [anon_sym_u_DQUOTE] = ACTIONS(3737),
    [anon_sym_U_DQUOTE] = ACTIONS(3737),
    [anon_sym_u8_DQUOTE] = ACTIONS(3737),
    [anon_sym_DQUOTE] = ACTIONS(3737),
    [sym_true] = ACTIONS(3735),
    [sym_false] = ACTIONS(3735),
    [anon_sym_NULL] = ACTIONS(3735),
    [anon_sym_nullptr] = ACTIONS(3735),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3735),
    [anon_sym_let] = ACTIONS(3735),
    [anon_sym_This] = ACTIONS(3735),
    [anon_sym_decltype] = ACTIONS(3735),
    [anon_sym_explicit] = ACTIONS(3735),
    [anon_sym_typename] = ACTIONS(3735),
    [anon_sym_template] = ACTIONS(3735),
    [anon_sym_operator] = ACTIONS(3735),
    [anon_sym_try] = ACTIONS(3735),
    [anon_sym_delete] = ACTIONS(3735),
    [anon_sym_throw] = ACTIONS(3735),
    [anon_sym_namespace] = ACTIONS(3735),
    [anon_sym_static_assert] = ACTIONS(3735),
    [anon_sym_concept] = ACTIONS(3735),
    [anon_sym_co_return] = ACTIONS(3735),
    [anon_sym_co_yield] = ACTIONS(3735),
    [anon_sym_R_DQUOTE] = ACTIONS(3737),
    [anon_sym_LR_DQUOTE] = ACTIONS(3737),
    [anon_sym_uR_DQUOTE] = ACTIONS(3737),
    [anon_sym_UR_DQUOTE] = ACTIONS(3737),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3737),
    [anon_sym_co_await] = ACTIONS(3735),
    [anon_sym_new] = ACTIONS(3735),
    [anon_sym_requires] = ACTIONS(3735),
    [sym_this] = ACTIONS(3735),
    [anon_sym_discard] = ACTIONS(3735),
    [anon_sym_precise] = ACTIONS(3735),
    [anon_sym_shared] = ACTIONS(3735),
    [anon_sym_groupshared] = ACTIONS(3735),
    [anon_sym_uniform] = ACTIONS(3735),
    [anon_sym_row_major] = ACTIONS(3735),
    [anon_sym_column_major] = ACTIONS(3735),
    [anon_sym_globallycoherent] = ACTIONS(3735),
    [anon_sym_centroid] = ACTIONS(3735),
    [anon_sym_noperspective] = ACTIONS(3735),
    [anon_sym_nointerpolation] = ACTIONS(3735),
    [anon_sym_sample] = ACTIONS(3735),
    [anon_sym_linear] = ACTIONS(3735),
    [anon_sym_snorm] = ACTIONS(3735),
    [anon_sym_unorm] = ACTIONS(3735),
    [anon_sym_point] = ACTIONS(3735),
    [anon_sym_line] = ACTIONS(3735),
    [anon_sym_triangleadj] = ACTIONS(3735),
    [anon_sym_lineadj] = ACTIONS(3735),
    [anon_sym_triangle] = ACTIONS(3735),
    [anon_sym_cbuffer] = ACTIONS(3735),
    [anon_sym_interface] = ACTIONS(3735),
    [anon_sym_extension] = ACTIONS(3735),
  },
  [544] = {
    [sym_identifier] = ACTIONS(3739),
    [aux_sym_preproc_include_token1] = ACTIONS(3739),
    [aux_sym_preproc_def_token1] = ACTIONS(3739),
    [aux_sym_preproc_if_token1] = ACTIONS(3739),
    [aux_sym_preproc_if_token2] = ACTIONS(3739),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3739),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3739),
    [aux_sym_preproc_else_token1] = ACTIONS(3739),
    [aux_sym_preproc_elif_token1] = ACTIONS(3739),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3739),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3739),
    [sym_preproc_directive] = ACTIONS(3739),
    [anon_sym_LPAREN2] = ACTIONS(3741),
    [anon_sym_BANG] = ACTIONS(3741),
    [anon_sym_TILDE] = ACTIONS(3741),
    [anon_sym_DASH] = ACTIONS(3739),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_STAR] = ACTIONS(3741),
    [anon_sym_AMP_AMP] = ACTIONS(3741),
    [anon_sym_AMP] = ACTIONS(3739),
    [anon_sym_SEMI] = ACTIONS(3741),
    [anon_sym___extension__] = ACTIONS(3739),
    [anon_sym_typedef] = ACTIONS(3739),
    [anon_sym_in] = ACTIONS(3739),
    [anon_sym_out] = ACTIONS(3739),
    [anon_sym_inout] = ACTIONS(3739),
    [anon_sym_virtual] = ACTIONS(3739),
    [anon_sym_extern] = ACTIONS(3739),
    [anon_sym___attribute__] = ACTIONS(3739),
    [anon_sym___attribute] = ACTIONS(3739),
    [anon_sym_using] = ACTIONS(3739),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3741),
    [anon_sym___declspec] = ACTIONS(3739),
    [anon_sym___based] = ACTIONS(3739),
    [anon_sym___cdecl] = ACTIONS(3739),
    [anon_sym___clrcall] = ACTIONS(3739),
    [anon_sym___stdcall] = ACTIONS(3739),
    [anon_sym___fastcall] = ACTIONS(3739),
    [anon_sym___thiscall] = ACTIONS(3739),
    [anon_sym___vectorcall] = ACTIONS(3739),
    [anon_sym_LBRACE] = ACTIONS(3741),
    [anon_sym_signed] = ACTIONS(3739),
    [anon_sym_unsigned] = ACTIONS(3739),
    [anon_sym_long] = ACTIONS(3739),
    [anon_sym_short] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3739),
    [anon_sym_static] = ACTIONS(3739),
    [anon_sym_register] = ACTIONS(3739),
    [anon_sym_inline] = ACTIONS(3739),
    [anon_sym___inline] = ACTIONS(3739),
    [anon_sym___inline__] = ACTIONS(3739),
    [anon_sym___forceinline] = ACTIONS(3739),
    [anon_sym_thread_local] = ACTIONS(3739),
    [anon_sym___thread] = ACTIONS(3739),
    [anon_sym_const] = ACTIONS(3739),
    [anon_sym_constexpr] = ACTIONS(3739),
    [anon_sym_volatile] = ACTIONS(3739),
    [anon_sym_restrict] = ACTIONS(3739),
    [anon_sym___restrict__] = ACTIONS(3739),
    [anon_sym__Atomic] = ACTIONS(3739),
    [anon_sym__Noreturn] = ACTIONS(3739),
    [anon_sym_noreturn] = ACTIONS(3739),
    [anon_sym__Nonnull] = ACTIONS(3739),
    [anon_sym_mutable] = ACTIONS(3739),
    [anon_sym_constinit] = ACTIONS(3739),
    [anon_sym_consteval] = ACTIONS(3739),
    [anon_sym_alignas] = ACTIONS(3739),
    [anon_sym__Alignas] = ACTIONS(3739),
    [sym_primitive_type] = ACTIONS(3739),
    [anon_sym_enum] = ACTIONS(3739),
    [anon_sym_class] = ACTIONS(3739),
    [anon_sym_struct] = ACTIONS(3739),
    [anon_sym_union] = ACTIONS(3739),
    [anon_sym_if] = ACTIONS(3739),
    [anon_sym_switch] = ACTIONS(3739),
    [anon_sym_case] = ACTIONS(3739),
    [anon_sym_default] = ACTIONS(3739),
    [anon_sym_while] = ACTIONS(3739),
    [anon_sym_do] = ACTIONS(3739),
    [anon_sym_for] = ACTIONS(3739),
    [anon_sym_return] = ACTIONS(3739),
    [anon_sym_break] = ACTIONS(3739),
    [anon_sym_continue] = ACTIONS(3739),
    [anon_sym_goto] = ACTIONS(3739),
    [anon_sym___try] = ACTIONS(3739),
    [anon_sym___leave] = ACTIONS(3739),
    [anon_sym_not] = ACTIONS(3739),
    [anon_sym_compl] = ACTIONS(3739),
    [anon_sym_DASH_DASH] = ACTIONS(3741),
    [anon_sym_PLUS_PLUS] = ACTIONS(3741),
    [anon_sym_sizeof] = ACTIONS(3739),
    [anon_sym___alignof__] = ACTIONS(3739),
    [anon_sym___alignof] = ACTIONS(3739),
    [anon_sym__alignof] = ACTIONS(3739),
    [anon_sym_alignof] = ACTIONS(3739),
    [anon_sym__Alignof] = ACTIONS(3739),
    [anon_sym_offsetof] = ACTIONS(3739),
    [anon_sym__Generic] = ACTIONS(3739),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [anon_sym___asm] = ACTIONS(3739),
    [sym_number_literal] = ACTIONS(3741),
    [anon_sym_L_SQUOTE] = ACTIONS(3741),
    [anon_sym_u_SQUOTE] = ACTIONS(3741),
    [anon_sym_U_SQUOTE] = ACTIONS(3741),
    [anon_sym_u8_SQUOTE] = ACTIONS(3741),
    [anon_sym_SQUOTE] = ACTIONS(3741),
    [anon_sym_L_DQUOTE] = ACTIONS(3741),
    [anon_sym_u_DQUOTE] = ACTIONS(3741),
    [anon_sym_U_DQUOTE] = ACTIONS(3741),
    [anon_sym_u8_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE] = ACTIONS(3741),
    [sym_true] = ACTIONS(3739),
    [sym_false] = ACTIONS(3739),
    [anon_sym_NULL] = ACTIONS(3739),
    [anon_sym_nullptr] = ACTIONS(3739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3739),
    [anon_sym_let] = ACTIONS(3739),
    [anon_sym_This] = ACTIONS(3739),
    [anon_sym_decltype] = ACTIONS(3739),
    [anon_sym_explicit] = ACTIONS(3739),
    [anon_sym_typename] = ACTIONS(3739),
    [anon_sym_template] = ACTIONS(3739),
    [anon_sym_operator] = ACTIONS(3739),
    [anon_sym_try] = ACTIONS(3739),
    [anon_sym_delete] = ACTIONS(3739),
    [anon_sym_throw] = ACTIONS(3739),
    [anon_sym_namespace] = ACTIONS(3739),
    [anon_sym_static_assert] = ACTIONS(3739),
    [anon_sym_concept] = ACTIONS(3739),
    [anon_sym_co_return] = ACTIONS(3739),
    [anon_sym_co_yield] = ACTIONS(3739),
    [anon_sym_R_DQUOTE] = ACTIONS(3741),
    [anon_sym_LR_DQUOTE] = ACTIONS(3741),
    [anon_sym_uR_DQUOTE] = ACTIONS(3741),
    [anon_sym_UR_DQUOTE] = ACTIONS(3741),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3741),
    [anon_sym_co_await] = ACTIONS(3739),
    [anon_sym_new] = ACTIONS(3739),
    [anon_sym_requires] = ACTIONS(3739),
    [sym_this] = ACTIONS(3739),
    [anon_sym_discard] = ACTIONS(3739),
    [anon_sym_precise] = ACTIONS(3739),
    [anon_sym_shared] = ACTIONS(3739),
    [anon_sym_groupshared] = ACTIONS(3739),
    [anon_sym_uniform] = ACTIONS(3739),
    [anon_sym_row_major] = ACTIONS(3739),
    [anon_sym_column_major] = ACTIONS(3739),
    [anon_sym_globallycoherent] = ACTIONS(3739),
    [anon_sym_centroid] = ACTIONS(3739),
    [anon_sym_noperspective] = ACTIONS(3739),
    [anon_sym_nointerpolation] = ACTIONS(3739),
    [anon_sym_sample] = ACTIONS(3739),
    [anon_sym_linear] = ACTIONS(3739),
    [anon_sym_snorm] = ACTIONS(3739),
    [anon_sym_unorm] = ACTIONS(3739),
    [anon_sym_point] = ACTIONS(3739),
    [anon_sym_line] = ACTIONS(3739),
    [anon_sym_triangleadj] = ACTIONS(3739),
    [anon_sym_lineadj] = ACTIONS(3739),
    [anon_sym_triangle] = ACTIONS(3739),
    [anon_sym_cbuffer] = ACTIONS(3739),
    [anon_sym_interface] = ACTIONS(3739),
    [anon_sym_extension] = ACTIONS(3739),
  },
  [545] = {
    [sym_identifier] = ACTIONS(3743),
    [aux_sym_preproc_include_token1] = ACTIONS(3743),
    [aux_sym_preproc_def_token1] = ACTIONS(3743),
    [aux_sym_preproc_if_token1] = ACTIONS(3743),
    [aux_sym_preproc_if_token2] = ACTIONS(3743),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3743),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3743),
    [aux_sym_preproc_else_token1] = ACTIONS(3743),
    [aux_sym_preproc_elif_token1] = ACTIONS(3743),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3743),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3743),
    [sym_preproc_directive] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3745),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_STAR] = ACTIONS(3745),
    [anon_sym_AMP_AMP] = ACTIONS(3745),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_SEMI] = ACTIONS(3745),
    [anon_sym___extension__] = ACTIONS(3743),
    [anon_sym_typedef] = ACTIONS(3743),
    [anon_sym_in] = ACTIONS(3743),
    [anon_sym_out] = ACTIONS(3743),
    [anon_sym_inout] = ACTIONS(3743),
    [anon_sym_virtual] = ACTIONS(3743),
    [anon_sym_extern] = ACTIONS(3743),
    [anon_sym___attribute__] = ACTIONS(3743),
    [anon_sym___attribute] = ACTIONS(3743),
    [anon_sym_using] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3745),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3745),
    [anon_sym___declspec] = ACTIONS(3743),
    [anon_sym___based] = ACTIONS(3743),
    [anon_sym___cdecl] = ACTIONS(3743),
    [anon_sym___clrcall] = ACTIONS(3743),
    [anon_sym___stdcall] = ACTIONS(3743),
    [anon_sym___fastcall] = ACTIONS(3743),
    [anon_sym___thiscall] = ACTIONS(3743),
    [anon_sym___vectorcall] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_signed] = ACTIONS(3743),
    [anon_sym_unsigned] = ACTIONS(3743),
    [anon_sym_long] = ACTIONS(3743),
    [anon_sym_short] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_static] = ACTIONS(3743),
    [anon_sym_register] = ACTIONS(3743),
    [anon_sym_inline] = ACTIONS(3743),
    [anon_sym___inline] = ACTIONS(3743),
    [anon_sym___inline__] = ACTIONS(3743),
    [anon_sym___forceinline] = ACTIONS(3743),
    [anon_sym_thread_local] = ACTIONS(3743),
    [anon_sym___thread] = ACTIONS(3743),
    [anon_sym_const] = ACTIONS(3743),
    [anon_sym_constexpr] = ACTIONS(3743),
    [anon_sym_volatile] = ACTIONS(3743),
    [anon_sym_restrict] = ACTIONS(3743),
    [anon_sym___restrict__] = ACTIONS(3743),
    [anon_sym__Atomic] = ACTIONS(3743),
    [anon_sym__Noreturn] = ACTIONS(3743),
    [anon_sym_noreturn] = ACTIONS(3743),
    [anon_sym__Nonnull] = ACTIONS(3743),
    [anon_sym_mutable] = ACTIONS(3743),
    [anon_sym_constinit] = ACTIONS(3743),
    [anon_sym_consteval] = ACTIONS(3743),
    [anon_sym_alignas] = ACTIONS(3743),
    [anon_sym__Alignas] = ACTIONS(3743),
    [sym_primitive_type] = ACTIONS(3743),
    [anon_sym_enum] = ACTIONS(3743),
    [anon_sym_class] = ACTIONS(3743),
    [anon_sym_struct] = ACTIONS(3743),
    [anon_sym_union] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_switch] = ACTIONS(3743),
    [anon_sym_case] = ACTIONS(3743),
    [anon_sym_default] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_break] = ACTIONS(3743),
    [anon_sym_continue] = ACTIONS(3743),
    [anon_sym_goto] = ACTIONS(3743),
    [anon_sym___try] = ACTIONS(3743),
    [anon_sym___leave] = ACTIONS(3743),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_compl] = ACTIONS(3743),
    [anon_sym_DASH_DASH] = ACTIONS(3745),
    [anon_sym_PLUS_PLUS] = ACTIONS(3745),
    [anon_sym_sizeof] = ACTIONS(3743),
    [anon_sym___alignof__] = ACTIONS(3743),
    [anon_sym___alignof] = ACTIONS(3743),
    [anon_sym__alignof] = ACTIONS(3743),
    [anon_sym_alignof] = ACTIONS(3743),
    [anon_sym__Alignof] = ACTIONS(3743),
    [anon_sym_offsetof] = ACTIONS(3743),
    [anon_sym__Generic] = ACTIONS(3743),
    [anon_sym_asm] = ACTIONS(3743),
    [anon_sym___asm__] = ACTIONS(3743),
    [anon_sym___asm] = ACTIONS(3743),
    [sym_number_literal] = ACTIONS(3745),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3745),
    [anon_sym_u_DQUOTE] = ACTIONS(3745),
    [anon_sym_U_DQUOTE] = ACTIONS(3745),
    [anon_sym_u8_DQUOTE] = ACTIONS(3745),
    [anon_sym_DQUOTE] = ACTIONS(3745),
    [sym_true] = ACTIONS(3743),
    [sym_false] = ACTIONS(3743),
    [anon_sym_NULL] = ACTIONS(3743),
    [anon_sym_nullptr] = ACTIONS(3743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_This] = ACTIONS(3743),
    [anon_sym_decltype] = ACTIONS(3743),
    [anon_sym_explicit] = ACTIONS(3743),
    [anon_sym_typename] = ACTIONS(3743),
    [anon_sym_template] = ACTIONS(3743),
    [anon_sym_operator] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_delete] = ACTIONS(3743),
    [anon_sym_throw] = ACTIONS(3743),
    [anon_sym_namespace] = ACTIONS(3743),
    [anon_sym_static_assert] = ACTIONS(3743),
    [anon_sym_concept] = ACTIONS(3743),
    [anon_sym_co_return] = ACTIONS(3743),
    [anon_sym_co_yield] = ACTIONS(3743),
    [anon_sym_R_DQUOTE] = ACTIONS(3745),
    [anon_sym_LR_DQUOTE] = ACTIONS(3745),
    [anon_sym_uR_DQUOTE] = ACTIONS(3745),
    [anon_sym_UR_DQUOTE] = ACTIONS(3745),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3745),
    [anon_sym_co_await] = ACTIONS(3743),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_requires] = ACTIONS(3743),
    [sym_this] = ACTIONS(3743),
    [anon_sym_discard] = ACTIONS(3743),
    [anon_sym_precise] = ACTIONS(3743),
    [anon_sym_shared] = ACTIONS(3743),
    [anon_sym_groupshared] = ACTIONS(3743),
    [anon_sym_uniform] = ACTIONS(3743),
    [anon_sym_row_major] = ACTIONS(3743),
    [anon_sym_column_major] = ACTIONS(3743),
    [anon_sym_globallycoherent] = ACTIONS(3743),
    [anon_sym_centroid] = ACTIONS(3743),
    [anon_sym_noperspective] = ACTIONS(3743),
    [anon_sym_nointerpolation] = ACTIONS(3743),
    [anon_sym_sample] = ACTIONS(3743),
    [anon_sym_linear] = ACTIONS(3743),
    [anon_sym_snorm] = ACTIONS(3743),
    [anon_sym_unorm] = ACTIONS(3743),
    [anon_sym_point] = ACTIONS(3743),
    [anon_sym_line] = ACTIONS(3743),
    [anon_sym_triangleadj] = ACTIONS(3743),
    [anon_sym_lineadj] = ACTIONS(3743),
    [anon_sym_triangle] = ACTIONS(3743),
    [anon_sym_cbuffer] = ACTIONS(3743),
    [anon_sym_interface] = ACTIONS(3743),
    [anon_sym_extension] = ACTIONS(3743),
  },
  [546] = {
    [sym_identifier] = ACTIONS(3747),
    [aux_sym_preproc_include_token1] = ACTIONS(3747),
    [aux_sym_preproc_def_token1] = ACTIONS(3747),
    [aux_sym_preproc_if_token1] = ACTIONS(3747),
    [aux_sym_preproc_if_token2] = ACTIONS(3747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3747),
    [aux_sym_preproc_else_token1] = ACTIONS(3747),
    [aux_sym_preproc_elif_token1] = ACTIONS(3747),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3747),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3747),
    [sym_preproc_directive] = ACTIONS(3747),
    [anon_sym_LPAREN2] = ACTIONS(3749),
    [anon_sym_BANG] = ACTIONS(3749),
    [anon_sym_TILDE] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_STAR] = ACTIONS(3749),
    [anon_sym_AMP_AMP] = ACTIONS(3749),
    [anon_sym_AMP] = ACTIONS(3747),
    [anon_sym_SEMI] = ACTIONS(3749),
    [anon_sym___extension__] = ACTIONS(3747),
    [anon_sym_typedef] = ACTIONS(3747),
    [anon_sym_in] = ACTIONS(3747),
    [anon_sym_out] = ACTIONS(3747),
    [anon_sym_inout] = ACTIONS(3747),
    [anon_sym_virtual] = ACTIONS(3747),
    [anon_sym_extern] = ACTIONS(3747),
    [anon_sym___attribute__] = ACTIONS(3747),
    [anon_sym___attribute] = ACTIONS(3747),
    [anon_sym_using] = ACTIONS(3747),
    [anon_sym_COLON_COLON] = ACTIONS(3749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3749),
    [anon_sym___declspec] = ACTIONS(3747),
    [anon_sym___based] = ACTIONS(3747),
    [anon_sym___cdecl] = ACTIONS(3747),
    [anon_sym___clrcall] = ACTIONS(3747),
    [anon_sym___stdcall] = ACTIONS(3747),
    [anon_sym___fastcall] = ACTIONS(3747),
    [anon_sym___thiscall] = ACTIONS(3747),
    [anon_sym___vectorcall] = ACTIONS(3747),
    [anon_sym_LBRACE] = ACTIONS(3749),
    [anon_sym_signed] = ACTIONS(3747),
    [anon_sym_unsigned] = ACTIONS(3747),
    [anon_sym_long] = ACTIONS(3747),
    [anon_sym_short] = ACTIONS(3747),
    [anon_sym_LBRACK] = ACTIONS(3747),
    [anon_sym_static] = ACTIONS(3747),
    [anon_sym_register] = ACTIONS(3747),
    [anon_sym_inline] = ACTIONS(3747),
    [anon_sym___inline] = ACTIONS(3747),
    [anon_sym___inline__] = ACTIONS(3747),
    [anon_sym___forceinline] = ACTIONS(3747),
    [anon_sym_thread_local] = ACTIONS(3747),
    [anon_sym___thread] = ACTIONS(3747),
    [anon_sym_const] = ACTIONS(3747),
    [anon_sym_constexpr] = ACTIONS(3747),
    [anon_sym_volatile] = ACTIONS(3747),
    [anon_sym_restrict] = ACTIONS(3747),
    [anon_sym___restrict__] = ACTIONS(3747),
    [anon_sym__Atomic] = ACTIONS(3747),
    [anon_sym__Noreturn] = ACTIONS(3747),
    [anon_sym_noreturn] = ACTIONS(3747),
    [anon_sym__Nonnull] = ACTIONS(3747),
    [anon_sym_mutable] = ACTIONS(3747),
    [anon_sym_constinit] = ACTIONS(3747),
    [anon_sym_consteval] = ACTIONS(3747),
    [anon_sym_alignas] = ACTIONS(3747),
    [anon_sym__Alignas] = ACTIONS(3747),
    [sym_primitive_type] = ACTIONS(3747),
    [anon_sym_enum] = ACTIONS(3747),
    [anon_sym_class] = ACTIONS(3747),
    [anon_sym_struct] = ACTIONS(3747),
    [anon_sym_union] = ACTIONS(3747),
    [anon_sym_if] = ACTIONS(3747),
    [anon_sym_switch] = ACTIONS(3747),
    [anon_sym_case] = ACTIONS(3747),
    [anon_sym_default] = ACTIONS(3747),
    [anon_sym_while] = ACTIONS(3747),
    [anon_sym_do] = ACTIONS(3747),
    [anon_sym_for] = ACTIONS(3747),
    [anon_sym_return] = ACTIONS(3747),
    [anon_sym_break] = ACTIONS(3747),
    [anon_sym_continue] = ACTIONS(3747),
    [anon_sym_goto] = ACTIONS(3747),
    [anon_sym___try] = ACTIONS(3747),
    [anon_sym___leave] = ACTIONS(3747),
    [anon_sym_not] = ACTIONS(3747),
    [anon_sym_compl] = ACTIONS(3747),
    [anon_sym_DASH_DASH] = ACTIONS(3749),
    [anon_sym_PLUS_PLUS] = ACTIONS(3749),
    [anon_sym_sizeof] = ACTIONS(3747),
    [anon_sym___alignof__] = ACTIONS(3747),
    [anon_sym___alignof] = ACTIONS(3747),
    [anon_sym__alignof] = ACTIONS(3747),
    [anon_sym_alignof] = ACTIONS(3747),
    [anon_sym__Alignof] = ACTIONS(3747),
    [anon_sym_offsetof] = ACTIONS(3747),
    [anon_sym__Generic] = ACTIONS(3747),
    [anon_sym_asm] = ACTIONS(3747),
    [anon_sym___asm__] = ACTIONS(3747),
    [anon_sym___asm] = ACTIONS(3747),
    [sym_number_literal] = ACTIONS(3749),
    [anon_sym_L_SQUOTE] = ACTIONS(3749),
    [anon_sym_u_SQUOTE] = ACTIONS(3749),
    [anon_sym_U_SQUOTE] = ACTIONS(3749),
    [anon_sym_u8_SQUOTE] = ACTIONS(3749),
    [anon_sym_SQUOTE] = ACTIONS(3749),
    [anon_sym_L_DQUOTE] = ACTIONS(3749),
    [anon_sym_u_DQUOTE] = ACTIONS(3749),
    [anon_sym_U_DQUOTE] = ACTIONS(3749),
    [anon_sym_u8_DQUOTE] = ACTIONS(3749),
    [anon_sym_DQUOTE] = ACTIONS(3749),
    [sym_true] = ACTIONS(3747),
    [sym_false] = ACTIONS(3747),
    [anon_sym_NULL] = ACTIONS(3747),
    [anon_sym_nullptr] = ACTIONS(3747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3747),
    [anon_sym_let] = ACTIONS(3747),
    [anon_sym_This] = ACTIONS(3747),
    [anon_sym_decltype] = ACTIONS(3747),
    [anon_sym_explicit] = ACTIONS(3747),
    [anon_sym_typename] = ACTIONS(3747),
    [anon_sym_template] = ACTIONS(3747),
    [anon_sym_operator] = ACTIONS(3747),
    [anon_sym_try] = ACTIONS(3747),
    [anon_sym_delete] = ACTIONS(3747),
    [anon_sym_throw] = ACTIONS(3747),
    [anon_sym_namespace] = ACTIONS(3747),
    [anon_sym_static_assert] = ACTIONS(3747),
    [anon_sym_concept] = ACTIONS(3747),
    [anon_sym_co_return] = ACTIONS(3747),
    [anon_sym_co_yield] = ACTIONS(3747),
    [anon_sym_R_DQUOTE] = ACTIONS(3749),
    [anon_sym_LR_DQUOTE] = ACTIONS(3749),
    [anon_sym_uR_DQUOTE] = ACTIONS(3749),
    [anon_sym_UR_DQUOTE] = ACTIONS(3749),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3749),
    [anon_sym_co_await] = ACTIONS(3747),
    [anon_sym_new] = ACTIONS(3747),
    [anon_sym_requires] = ACTIONS(3747),
    [sym_this] = ACTIONS(3747),
    [anon_sym_discard] = ACTIONS(3747),
    [anon_sym_precise] = ACTIONS(3747),
    [anon_sym_shared] = ACTIONS(3747),
    [anon_sym_groupshared] = ACTIONS(3747),
    [anon_sym_uniform] = ACTIONS(3747),
    [anon_sym_row_major] = ACTIONS(3747),
    [anon_sym_column_major] = ACTIONS(3747),
    [anon_sym_globallycoherent] = ACTIONS(3747),
    [anon_sym_centroid] = ACTIONS(3747),
    [anon_sym_noperspective] = ACTIONS(3747),
    [anon_sym_nointerpolation] = ACTIONS(3747),
    [anon_sym_sample] = ACTIONS(3747),
    [anon_sym_linear] = ACTIONS(3747),
    [anon_sym_snorm] = ACTIONS(3747),
    [anon_sym_unorm] = ACTIONS(3747),
    [anon_sym_point] = ACTIONS(3747),
    [anon_sym_line] = ACTIONS(3747),
    [anon_sym_triangleadj] = ACTIONS(3747),
    [anon_sym_lineadj] = ACTIONS(3747),
    [anon_sym_triangle] = ACTIONS(3747),
    [anon_sym_cbuffer] = ACTIONS(3747),
    [anon_sym_interface] = ACTIONS(3747),
    [anon_sym_extension] = ACTIONS(3747),
  },
  [547] = {
    [sym_identifier] = ACTIONS(3751),
    [aux_sym_preproc_include_token1] = ACTIONS(3751),
    [aux_sym_preproc_def_token1] = ACTIONS(3751),
    [aux_sym_preproc_if_token1] = ACTIONS(3751),
    [aux_sym_preproc_if_token2] = ACTIONS(3751),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3751),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3751),
    [aux_sym_preproc_else_token1] = ACTIONS(3751),
    [aux_sym_preproc_elif_token1] = ACTIONS(3751),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3751),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3751),
    [sym_preproc_directive] = ACTIONS(3751),
    [anon_sym_LPAREN2] = ACTIONS(3753),
    [anon_sym_BANG] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3751),
    [anon_sym_PLUS] = ACTIONS(3751),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_AMP] = ACTIONS(3751),
    [anon_sym_SEMI] = ACTIONS(3753),
    [anon_sym___extension__] = ACTIONS(3751),
    [anon_sym_typedef] = ACTIONS(3751),
    [anon_sym_in] = ACTIONS(3751),
    [anon_sym_out] = ACTIONS(3751),
    [anon_sym_inout] = ACTIONS(3751),
    [anon_sym_virtual] = ACTIONS(3751),
    [anon_sym_extern] = ACTIONS(3751),
    [anon_sym___attribute__] = ACTIONS(3751),
    [anon_sym___attribute] = ACTIONS(3751),
    [anon_sym_using] = ACTIONS(3751),
    [anon_sym_COLON_COLON] = ACTIONS(3753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3753),
    [anon_sym___declspec] = ACTIONS(3751),
    [anon_sym___based] = ACTIONS(3751),
    [anon_sym___cdecl] = ACTIONS(3751),
    [anon_sym___clrcall] = ACTIONS(3751),
    [anon_sym___stdcall] = ACTIONS(3751),
    [anon_sym___fastcall] = ACTIONS(3751),
    [anon_sym___thiscall] = ACTIONS(3751),
    [anon_sym___vectorcall] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_signed] = ACTIONS(3751),
    [anon_sym_unsigned] = ACTIONS(3751),
    [anon_sym_long] = ACTIONS(3751),
    [anon_sym_short] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3751),
    [anon_sym_static] = ACTIONS(3751),
    [anon_sym_register] = ACTIONS(3751),
    [anon_sym_inline] = ACTIONS(3751),
    [anon_sym___inline] = ACTIONS(3751),
    [anon_sym___inline__] = ACTIONS(3751),
    [anon_sym___forceinline] = ACTIONS(3751),
    [anon_sym_thread_local] = ACTIONS(3751),
    [anon_sym___thread] = ACTIONS(3751),
    [anon_sym_const] = ACTIONS(3751),
    [anon_sym_constexpr] = ACTIONS(3751),
    [anon_sym_volatile] = ACTIONS(3751),
    [anon_sym_restrict] = ACTIONS(3751),
    [anon_sym___restrict__] = ACTIONS(3751),
    [anon_sym__Atomic] = ACTIONS(3751),
    [anon_sym__Noreturn] = ACTIONS(3751),
    [anon_sym_noreturn] = ACTIONS(3751),
    [anon_sym__Nonnull] = ACTIONS(3751),
    [anon_sym_mutable] = ACTIONS(3751),
    [anon_sym_constinit] = ACTIONS(3751),
    [anon_sym_consteval] = ACTIONS(3751),
    [anon_sym_alignas] = ACTIONS(3751),
    [anon_sym__Alignas] = ACTIONS(3751),
    [sym_primitive_type] = ACTIONS(3751),
    [anon_sym_enum] = ACTIONS(3751),
    [anon_sym_class] = ACTIONS(3751),
    [anon_sym_struct] = ACTIONS(3751),
    [anon_sym_union] = ACTIONS(3751),
    [anon_sym_if] = ACTIONS(3751),
    [anon_sym_switch] = ACTIONS(3751),
    [anon_sym_case] = ACTIONS(3751),
    [anon_sym_default] = ACTIONS(3751),
    [anon_sym_while] = ACTIONS(3751),
    [anon_sym_do] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3751),
    [anon_sym_return] = ACTIONS(3751),
    [anon_sym_break] = ACTIONS(3751),
    [anon_sym_continue] = ACTIONS(3751),
    [anon_sym_goto] = ACTIONS(3751),
    [anon_sym___try] = ACTIONS(3751),
    [anon_sym___leave] = ACTIONS(3751),
    [anon_sym_not] = ACTIONS(3751),
    [anon_sym_compl] = ACTIONS(3751),
    [anon_sym_DASH_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_PLUS] = ACTIONS(3753),
    [anon_sym_sizeof] = ACTIONS(3751),
    [anon_sym___alignof__] = ACTIONS(3751),
    [anon_sym___alignof] = ACTIONS(3751),
    [anon_sym__alignof] = ACTIONS(3751),
    [anon_sym_alignof] = ACTIONS(3751),
    [anon_sym__Alignof] = ACTIONS(3751),
    [anon_sym_offsetof] = ACTIONS(3751),
    [anon_sym__Generic] = ACTIONS(3751),
    [anon_sym_asm] = ACTIONS(3751),
    [anon_sym___asm__] = ACTIONS(3751),
    [anon_sym___asm] = ACTIONS(3751),
    [sym_number_literal] = ACTIONS(3753),
    [anon_sym_L_SQUOTE] = ACTIONS(3753),
    [anon_sym_u_SQUOTE] = ACTIONS(3753),
    [anon_sym_U_SQUOTE] = ACTIONS(3753),
    [anon_sym_u8_SQUOTE] = ACTIONS(3753),
    [anon_sym_SQUOTE] = ACTIONS(3753),
    [anon_sym_L_DQUOTE] = ACTIONS(3753),
    [anon_sym_u_DQUOTE] = ACTIONS(3753),
    [anon_sym_U_DQUOTE] = ACTIONS(3753),
    [anon_sym_u8_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [sym_true] = ACTIONS(3751),
    [sym_false] = ACTIONS(3751),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3751),
    [anon_sym_let] = ACTIONS(3751),
    [anon_sym_This] = ACTIONS(3751),
    [anon_sym_decltype] = ACTIONS(3751),
    [anon_sym_explicit] = ACTIONS(3751),
    [anon_sym_typename] = ACTIONS(3751),
    [anon_sym_template] = ACTIONS(3751),
    [anon_sym_operator] = ACTIONS(3751),
    [anon_sym_try] = ACTIONS(3751),
    [anon_sym_delete] = ACTIONS(3751),
    [anon_sym_throw] = ACTIONS(3751),
    [anon_sym_namespace] = ACTIONS(3751),
    [anon_sym_static_assert] = ACTIONS(3751),
    [anon_sym_concept] = ACTIONS(3751),
    [anon_sym_co_return] = ACTIONS(3751),
    [anon_sym_co_yield] = ACTIONS(3751),
    [anon_sym_R_DQUOTE] = ACTIONS(3753),
    [anon_sym_LR_DQUOTE] = ACTIONS(3753),
    [anon_sym_uR_DQUOTE] = ACTIONS(3753),
    [anon_sym_UR_DQUOTE] = ACTIONS(3753),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3753),
    [anon_sym_co_await] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3751),
    [anon_sym_requires] = ACTIONS(3751),
    [sym_this] = ACTIONS(3751),
    [anon_sym_discard] = ACTIONS(3751),
    [anon_sym_precise] = ACTIONS(3751),
    [anon_sym_shared] = ACTIONS(3751),
    [anon_sym_groupshared] = ACTIONS(3751),
    [anon_sym_uniform] = ACTIONS(3751),
    [anon_sym_row_major] = ACTIONS(3751),
    [anon_sym_column_major] = ACTIONS(3751),
    [anon_sym_globallycoherent] = ACTIONS(3751),
    [anon_sym_centroid] = ACTIONS(3751),
    [anon_sym_noperspective] = ACTIONS(3751),
    [anon_sym_nointerpolation] = ACTIONS(3751),
    [anon_sym_sample] = ACTIONS(3751),
    [anon_sym_linear] = ACTIONS(3751),
    [anon_sym_snorm] = ACTIONS(3751),
    [anon_sym_unorm] = ACTIONS(3751),
    [anon_sym_point] = ACTIONS(3751),
    [anon_sym_line] = ACTIONS(3751),
    [anon_sym_triangleadj] = ACTIONS(3751),
    [anon_sym_lineadj] = ACTIONS(3751),
    [anon_sym_triangle] = ACTIONS(3751),
    [anon_sym_cbuffer] = ACTIONS(3751),
    [anon_sym_interface] = ACTIONS(3751),
    [anon_sym_extension] = ACTIONS(3751),
  },
  [548] = {
    [sym_identifier] = ACTIONS(3755),
    [aux_sym_preproc_include_token1] = ACTIONS(3755),
    [aux_sym_preproc_def_token1] = ACTIONS(3755),
    [aux_sym_preproc_if_token1] = ACTIONS(3755),
    [aux_sym_preproc_if_token2] = ACTIONS(3755),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3755),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3755),
    [aux_sym_preproc_else_token1] = ACTIONS(3755),
    [aux_sym_preproc_elif_token1] = ACTIONS(3755),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3755),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3755),
    [sym_preproc_directive] = ACTIONS(3755),
    [anon_sym_LPAREN2] = ACTIONS(3757),
    [anon_sym_BANG] = ACTIONS(3757),
    [anon_sym_TILDE] = ACTIONS(3757),
    [anon_sym_DASH] = ACTIONS(3755),
    [anon_sym_PLUS] = ACTIONS(3755),
    [anon_sym_STAR] = ACTIONS(3757),
    [anon_sym_AMP_AMP] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3755),
    [anon_sym_SEMI] = ACTIONS(3757),
    [anon_sym___extension__] = ACTIONS(3755),
    [anon_sym_typedef] = ACTIONS(3755),
    [anon_sym_in] = ACTIONS(3755),
    [anon_sym_out] = ACTIONS(3755),
    [anon_sym_inout] = ACTIONS(3755),
    [anon_sym_virtual] = ACTIONS(3755),
    [anon_sym_extern] = ACTIONS(3755),
    [anon_sym___attribute__] = ACTIONS(3755),
    [anon_sym___attribute] = ACTIONS(3755),
    [anon_sym_using] = ACTIONS(3755),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3757),
    [anon_sym___declspec] = ACTIONS(3755),
    [anon_sym___based] = ACTIONS(3755),
    [anon_sym___cdecl] = ACTIONS(3755),
    [anon_sym___clrcall] = ACTIONS(3755),
    [anon_sym___stdcall] = ACTIONS(3755),
    [anon_sym___fastcall] = ACTIONS(3755),
    [anon_sym___thiscall] = ACTIONS(3755),
    [anon_sym___vectorcall] = ACTIONS(3755),
    [anon_sym_LBRACE] = ACTIONS(3757),
    [anon_sym_signed] = ACTIONS(3755),
    [anon_sym_unsigned] = ACTIONS(3755),
    [anon_sym_long] = ACTIONS(3755),
    [anon_sym_short] = ACTIONS(3755),
    [anon_sym_LBRACK] = ACTIONS(3755),
    [anon_sym_static] = ACTIONS(3755),
    [anon_sym_register] = ACTIONS(3755),
    [anon_sym_inline] = ACTIONS(3755),
    [anon_sym___inline] = ACTIONS(3755),
    [anon_sym___inline__] = ACTIONS(3755),
    [anon_sym___forceinline] = ACTIONS(3755),
    [anon_sym_thread_local] = ACTIONS(3755),
    [anon_sym___thread] = ACTIONS(3755),
    [anon_sym_const] = ACTIONS(3755),
    [anon_sym_constexpr] = ACTIONS(3755),
    [anon_sym_volatile] = ACTIONS(3755),
    [anon_sym_restrict] = ACTIONS(3755),
    [anon_sym___restrict__] = ACTIONS(3755),
    [anon_sym__Atomic] = ACTIONS(3755),
    [anon_sym__Noreturn] = ACTIONS(3755),
    [anon_sym_noreturn] = ACTIONS(3755),
    [anon_sym__Nonnull] = ACTIONS(3755),
    [anon_sym_mutable] = ACTIONS(3755),
    [anon_sym_constinit] = ACTIONS(3755),
    [anon_sym_consteval] = ACTIONS(3755),
    [anon_sym_alignas] = ACTIONS(3755),
    [anon_sym__Alignas] = ACTIONS(3755),
    [sym_primitive_type] = ACTIONS(3755),
    [anon_sym_enum] = ACTIONS(3755),
    [anon_sym_class] = ACTIONS(3755),
    [anon_sym_struct] = ACTIONS(3755),
    [anon_sym_union] = ACTIONS(3755),
    [anon_sym_if] = ACTIONS(3755),
    [anon_sym_switch] = ACTIONS(3755),
    [anon_sym_case] = ACTIONS(3755),
    [anon_sym_default] = ACTIONS(3755),
    [anon_sym_while] = ACTIONS(3755),
    [anon_sym_do] = ACTIONS(3755),
    [anon_sym_for] = ACTIONS(3755),
    [anon_sym_return] = ACTIONS(3755),
    [anon_sym_break] = ACTIONS(3755),
    [anon_sym_continue] = ACTIONS(3755),
    [anon_sym_goto] = ACTIONS(3755),
    [anon_sym___try] = ACTIONS(3755),
    [anon_sym___leave] = ACTIONS(3755),
    [anon_sym_not] = ACTIONS(3755),
    [anon_sym_compl] = ACTIONS(3755),
    [anon_sym_DASH_DASH] = ACTIONS(3757),
    [anon_sym_PLUS_PLUS] = ACTIONS(3757),
    [anon_sym_sizeof] = ACTIONS(3755),
    [anon_sym___alignof__] = ACTIONS(3755),
    [anon_sym___alignof] = ACTIONS(3755),
    [anon_sym__alignof] = ACTIONS(3755),
    [anon_sym_alignof] = ACTIONS(3755),
    [anon_sym__Alignof] = ACTIONS(3755),
    [anon_sym_offsetof] = ACTIONS(3755),
    [anon_sym__Generic] = ACTIONS(3755),
    [anon_sym_asm] = ACTIONS(3755),
    [anon_sym___asm__] = ACTIONS(3755),
    [anon_sym___asm] = ACTIONS(3755),
    [sym_number_literal] = ACTIONS(3757),
    [anon_sym_L_SQUOTE] = ACTIONS(3757),
    [anon_sym_u_SQUOTE] = ACTIONS(3757),
    [anon_sym_U_SQUOTE] = ACTIONS(3757),
    [anon_sym_u8_SQUOTE] = ACTIONS(3757),
    [anon_sym_SQUOTE] = ACTIONS(3757),
    [anon_sym_L_DQUOTE] = ACTIONS(3757),
    [anon_sym_u_DQUOTE] = ACTIONS(3757),
    [anon_sym_U_DQUOTE] = ACTIONS(3757),
    [anon_sym_u8_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE] = ACTIONS(3757),
    [sym_true] = ACTIONS(3755),
    [sym_false] = ACTIONS(3755),
    [anon_sym_NULL] = ACTIONS(3755),
    [anon_sym_nullptr] = ACTIONS(3755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3755),
    [anon_sym_let] = ACTIONS(3755),
    [anon_sym_This] = ACTIONS(3755),
    [anon_sym_decltype] = ACTIONS(3755),
    [anon_sym_explicit] = ACTIONS(3755),
    [anon_sym_typename] = ACTIONS(3755),
    [anon_sym_template] = ACTIONS(3755),
    [anon_sym_operator] = ACTIONS(3755),
    [anon_sym_try] = ACTIONS(3755),
    [anon_sym_delete] = ACTIONS(3755),
    [anon_sym_throw] = ACTIONS(3755),
    [anon_sym_namespace] = ACTIONS(3755),
    [anon_sym_static_assert] = ACTIONS(3755),
    [anon_sym_concept] = ACTIONS(3755),
    [anon_sym_co_return] = ACTIONS(3755),
    [anon_sym_co_yield] = ACTIONS(3755),
    [anon_sym_R_DQUOTE] = ACTIONS(3757),
    [anon_sym_LR_DQUOTE] = ACTIONS(3757),
    [anon_sym_uR_DQUOTE] = ACTIONS(3757),
    [anon_sym_UR_DQUOTE] = ACTIONS(3757),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3757),
    [anon_sym_co_await] = ACTIONS(3755),
    [anon_sym_new] = ACTIONS(3755),
    [anon_sym_requires] = ACTIONS(3755),
    [sym_this] = ACTIONS(3755),
    [anon_sym_discard] = ACTIONS(3755),
    [anon_sym_precise] = ACTIONS(3755),
    [anon_sym_shared] = ACTIONS(3755),
    [anon_sym_groupshared] = ACTIONS(3755),
    [anon_sym_uniform] = ACTIONS(3755),
    [anon_sym_row_major] = ACTIONS(3755),
    [anon_sym_column_major] = ACTIONS(3755),
    [anon_sym_globallycoherent] = ACTIONS(3755),
    [anon_sym_centroid] = ACTIONS(3755),
    [anon_sym_noperspective] = ACTIONS(3755),
    [anon_sym_nointerpolation] = ACTIONS(3755),
    [anon_sym_sample] = ACTIONS(3755),
    [anon_sym_linear] = ACTIONS(3755),
    [anon_sym_snorm] = ACTIONS(3755),
    [anon_sym_unorm] = ACTIONS(3755),
    [anon_sym_point] = ACTIONS(3755),
    [anon_sym_line] = ACTIONS(3755),
    [anon_sym_triangleadj] = ACTIONS(3755),
    [anon_sym_lineadj] = ACTIONS(3755),
    [anon_sym_triangle] = ACTIONS(3755),
    [anon_sym_cbuffer] = ACTIONS(3755),
    [anon_sym_interface] = ACTIONS(3755),
    [anon_sym_extension] = ACTIONS(3755),
  },
  [549] = {
    [sym_identifier] = ACTIONS(3759),
    [aux_sym_preproc_include_token1] = ACTIONS(3759),
    [aux_sym_preproc_def_token1] = ACTIONS(3759),
    [aux_sym_preproc_if_token1] = ACTIONS(3759),
    [aux_sym_preproc_if_token2] = ACTIONS(3759),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3759),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3759),
    [aux_sym_preproc_else_token1] = ACTIONS(3759),
    [aux_sym_preproc_elif_token1] = ACTIONS(3759),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3759),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3759),
    [sym_preproc_directive] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_BANG] = ACTIONS(3761),
    [anon_sym_TILDE] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_STAR] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym___extension__] = ACTIONS(3759),
    [anon_sym_typedef] = ACTIONS(3759),
    [anon_sym_in] = ACTIONS(3759),
    [anon_sym_out] = ACTIONS(3759),
    [anon_sym_inout] = ACTIONS(3759),
    [anon_sym_virtual] = ACTIONS(3759),
    [anon_sym_extern] = ACTIONS(3759),
    [anon_sym___attribute__] = ACTIONS(3759),
    [anon_sym___attribute] = ACTIONS(3759),
    [anon_sym_using] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3761),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3761),
    [anon_sym___declspec] = ACTIONS(3759),
    [anon_sym___based] = ACTIONS(3759),
    [anon_sym___cdecl] = ACTIONS(3759),
    [anon_sym___clrcall] = ACTIONS(3759),
    [anon_sym___stdcall] = ACTIONS(3759),
    [anon_sym___fastcall] = ACTIONS(3759),
    [anon_sym___thiscall] = ACTIONS(3759),
    [anon_sym___vectorcall] = ACTIONS(3759),
    [anon_sym_LBRACE] = ACTIONS(3761),
    [anon_sym_signed] = ACTIONS(3759),
    [anon_sym_unsigned] = ACTIONS(3759),
    [anon_sym_long] = ACTIONS(3759),
    [anon_sym_short] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_register] = ACTIONS(3759),
    [anon_sym_inline] = ACTIONS(3759),
    [anon_sym___inline] = ACTIONS(3759),
    [anon_sym___inline__] = ACTIONS(3759),
    [anon_sym___forceinline] = ACTIONS(3759),
    [anon_sym_thread_local] = ACTIONS(3759),
    [anon_sym___thread] = ACTIONS(3759),
    [anon_sym_const] = ACTIONS(3759),
    [anon_sym_constexpr] = ACTIONS(3759),
    [anon_sym_volatile] = ACTIONS(3759),
    [anon_sym_restrict] = ACTIONS(3759),
    [anon_sym___restrict__] = ACTIONS(3759),
    [anon_sym__Atomic] = ACTIONS(3759),
    [anon_sym__Noreturn] = ACTIONS(3759),
    [anon_sym_noreturn] = ACTIONS(3759),
    [anon_sym__Nonnull] = ACTIONS(3759),
    [anon_sym_mutable] = ACTIONS(3759),
    [anon_sym_constinit] = ACTIONS(3759),
    [anon_sym_consteval] = ACTIONS(3759),
    [anon_sym_alignas] = ACTIONS(3759),
    [anon_sym__Alignas] = ACTIONS(3759),
    [sym_primitive_type] = ACTIONS(3759),
    [anon_sym_enum] = ACTIONS(3759),
    [anon_sym_class] = ACTIONS(3759),
    [anon_sym_struct] = ACTIONS(3759),
    [anon_sym_union] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_switch] = ACTIONS(3759),
    [anon_sym_case] = ACTIONS(3759),
    [anon_sym_default] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_break] = ACTIONS(3759),
    [anon_sym_continue] = ACTIONS(3759),
    [anon_sym_goto] = ACTIONS(3759),
    [anon_sym___try] = ACTIONS(3759),
    [anon_sym___leave] = ACTIONS(3759),
    [anon_sym_not] = ACTIONS(3759),
    [anon_sym_compl] = ACTIONS(3759),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_sizeof] = ACTIONS(3759),
    [anon_sym___alignof__] = ACTIONS(3759),
    [anon_sym___alignof] = ACTIONS(3759),
    [anon_sym__alignof] = ACTIONS(3759),
    [anon_sym_alignof] = ACTIONS(3759),
    [anon_sym__Alignof] = ACTIONS(3759),
    [anon_sym_offsetof] = ACTIONS(3759),
    [anon_sym__Generic] = ACTIONS(3759),
    [anon_sym_asm] = ACTIONS(3759),
    [anon_sym___asm__] = ACTIONS(3759),
    [anon_sym___asm] = ACTIONS(3759),
    [sym_number_literal] = ACTIONS(3761),
    [anon_sym_L_SQUOTE] = ACTIONS(3761),
    [anon_sym_u_SQUOTE] = ACTIONS(3761),
    [anon_sym_U_SQUOTE] = ACTIONS(3761),
    [anon_sym_u8_SQUOTE] = ACTIONS(3761),
    [anon_sym_SQUOTE] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3761),
    [anon_sym_u_DQUOTE] = ACTIONS(3761),
    [anon_sym_U_DQUOTE] = ACTIONS(3761),
    [anon_sym_u8_DQUOTE] = ACTIONS(3761),
    [anon_sym_DQUOTE] = ACTIONS(3761),
    [sym_true] = ACTIONS(3759),
    [sym_false] = ACTIONS(3759),
    [anon_sym_NULL] = ACTIONS(3759),
    [anon_sym_nullptr] = ACTIONS(3759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_This] = ACTIONS(3759),
    [anon_sym_decltype] = ACTIONS(3759),
    [anon_sym_explicit] = ACTIONS(3759),
    [anon_sym_typename] = ACTIONS(3759),
    [anon_sym_template] = ACTIONS(3759),
    [anon_sym_operator] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_delete] = ACTIONS(3759),
    [anon_sym_throw] = ACTIONS(3759),
    [anon_sym_namespace] = ACTIONS(3759),
    [anon_sym_static_assert] = ACTIONS(3759),
    [anon_sym_concept] = ACTIONS(3759),
    [anon_sym_co_return] = ACTIONS(3759),
    [anon_sym_co_yield] = ACTIONS(3759),
    [anon_sym_R_DQUOTE] = ACTIONS(3761),
    [anon_sym_LR_DQUOTE] = ACTIONS(3761),
    [anon_sym_uR_DQUOTE] = ACTIONS(3761),
    [anon_sym_UR_DQUOTE] = ACTIONS(3761),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3761),
    [anon_sym_co_await] = ACTIONS(3759),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3759),
    [sym_this] = ACTIONS(3759),
    [anon_sym_discard] = ACTIONS(3759),
    [anon_sym_precise] = ACTIONS(3759),
    [anon_sym_shared] = ACTIONS(3759),
    [anon_sym_groupshared] = ACTIONS(3759),
    [anon_sym_uniform] = ACTIONS(3759),
    [anon_sym_row_major] = ACTIONS(3759),
    [anon_sym_column_major] = ACTIONS(3759),
    [anon_sym_globallycoherent] = ACTIONS(3759),
    [anon_sym_centroid] = ACTIONS(3759),
    [anon_sym_noperspective] = ACTIONS(3759),
    [anon_sym_nointerpolation] = ACTIONS(3759),
    [anon_sym_sample] = ACTIONS(3759),
    [anon_sym_linear] = ACTIONS(3759),
    [anon_sym_snorm] = ACTIONS(3759),
    [anon_sym_unorm] = ACTIONS(3759),
    [anon_sym_point] = ACTIONS(3759),
    [anon_sym_line] = ACTIONS(3759),
    [anon_sym_triangleadj] = ACTIONS(3759),
    [anon_sym_lineadj] = ACTIONS(3759),
    [anon_sym_triangle] = ACTIONS(3759),
    [anon_sym_cbuffer] = ACTIONS(3759),
    [anon_sym_interface] = ACTIONS(3759),
    [anon_sym_extension] = ACTIONS(3759),
  },
  [550] = {
    [sym_identifier] = ACTIONS(3763),
    [aux_sym_preproc_include_token1] = ACTIONS(3763),
    [aux_sym_preproc_def_token1] = ACTIONS(3763),
    [aux_sym_preproc_if_token1] = ACTIONS(3763),
    [aux_sym_preproc_if_token2] = ACTIONS(3763),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3763),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3763),
    [aux_sym_preproc_else_token1] = ACTIONS(3763),
    [aux_sym_preproc_elif_token1] = ACTIONS(3763),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3763),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3763),
    [sym_preproc_directive] = ACTIONS(3763),
    [anon_sym_LPAREN2] = ACTIONS(3765),
    [anon_sym_BANG] = ACTIONS(3765),
    [anon_sym_TILDE] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3763),
    [anon_sym_STAR] = ACTIONS(3765),
    [anon_sym_AMP_AMP] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3763),
    [anon_sym_SEMI] = ACTIONS(3765),
    [anon_sym___extension__] = ACTIONS(3763),
    [anon_sym_typedef] = ACTIONS(3763),
    [anon_sym_in] = ACTIONS(3763),
    [anon_sym_out] = ACTIONS(3763),
    [anon_sym_inout] = ACTIONS(3763),
    [anon_sym_virtual] = ACTIONS(3763),
    [anon_sym_extern] = ACTIONS(3763),
    [anon_sym___attribute__] = ACTIONS(3763),
    [anon_sym___attribute] = ACTIONS(3763),
    [anon_sym_using] = ACTIONS(3763),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3765),
    [anon_sym___declspec] = ACTIONS(3763),
    [anon_sym___based] = ACTIONS(3763),
    [anon_sym___cdecl] = ACTIONS(3763),
    [anon_sym___clrcall] = ACTIONS(3763),
    [anon_sym___stdcall] = ACTIONS(3763),
    [anon_sym___fastcall] = ACTIONS(3763),
    [anon_sym___thiscall] = ACTIONS(3763),
    [anon_sym___vectorcall] = ACTIONS(3763),
    [anon_sym_LBRACE] = ACTIONS(3765),
    [anon_sym_signed] = ACTIONS(3763),
    [anon_sym_unsigned] = ACTIONS(3763),
    [anon_sym_long] = ACTIONS(3763),
    [anon_sym_short] = ACTIONS(3763),
    [anon_sym_LBRACK] = ACTIONS(3763),
    [anon_sym_static] = ACTIONS(3763),
    [anon_sym_register] = ACTIONS(3763),
    [anon_sym_inline] = ACTIONS(3763),
    [anon_sym___inline] = ACTIONS(3763),
    [anon_sym___inline__] = ACTIONS(3763),
    [anon_sym___forceinline] = ACTIONS(3763),
    [anon_sym_thread_local] = ACTIONS(3763),
    [anon_sym___thread] = ACTIONS(3763),
    [anon_sym_const] = ACTIONS(3763),
    [anon_sym_constexpr] = ACTIONS(3763),
    [anon_sym_volatile] = ACTIONS(3763),
    [anon_sym_restrict] = ACTIONS(3763),
    [anon_sym___restrict__] = ACTIONS(3763),
    [anon_sym__Atomic] = ACTIONS(3763),
    [anon_sym__Noreturn] = ACTIONS(3763),
    [anon_sym_noreturn] = ACTIONS(3763),
    [anon_sym__Nonnull] = ACTIONS(3763),
    [anon_sym_mutable] = ACTIONS(3763),
    [anon_sym_constinit] = ACTIONS(3763),
    [anon_sym_consteval] = ACTIONS(3763),
    [anon_sym_alignas] = ACTIONS(3763),
    [anon_sym__Alignas] = ACTIONS(3763),
    [sym_primitive_type] = ACTIONS(3763),
    [anon_sym_enum] = ACTIONS(3763),
    [anon_sym_class] = ACTIONS(3763),
    [anon_sym_struct] = ACTIONS(3763),
    [anon_sym_union] = ACTIONS(3763),
    [anon_sym_if] = ACTIONS(3763),
    [anon_sym_switch] = ACTIONS(3763),
    [anon_sym_case] = ACTIONS(3763),
    [anon_sym_default] = ACTIONS(3763),
    [anon_sym_while] = ACTIONS(3763),
    [anon_sym_do] = ACTIONS(3763),
    [anon_sym_for] = ACTIONS(3763),
    [anon_sym_return] = ACTIONS(3763),
    [anon_sym_break] = ACTIONS(3763),
    [anon_sym_continue] = ACTIONS(3763),
    [anon_sym_goto] = ACTIONS(3763),
    [anon_sym___try] = ACTIONS(3763),
    [anon_sym___leave] = ACTIONS(3763),
    [anon_sym_not] = ACTIONS(3763),
    [anon_sym_compl] = ACTIONS(3763),
    [anon_sym_DASH_DASH] = ACTIONS(3765),
    [anon_sym_PLUS_PLUS] = ACTIONS(3765),
    [anon_sym_sizeof] = ACTIONS(3763),
    [anon_sym___alignof__] = ACTIONS(3763),
    [anon_sym___alignof] = ACTIONS(3763),
    [anon_sym__alignof] = ACTIONS(3763),
    [anon_sym_alignof] = ACTIONS(3763),
    [anon_sym__Alignof] = ACTIONS(3763),
    [anon_sym_offsetof] = ACTIONS(3763),
    [anon_sym__Generic] = ACTIONS(3763),
    [anon_sym_asm] = ACTIONS(3763),
    [anon_sym___asm__] = ACTIONS(3763),
    [anon_sym___asm] = ACTIONS(3763),
    [sym_number_literal] = ACTIONS(3765),
    [anon_sym_L_SQUOTE] = ACTIONS(3765),
    [anon_sym_u_SQUOTE] = ACTIONS(3765),
    [anon_sym_U_SQUOTE] = ACTIONS(3765),
    [anon_sym_u8_SQUOTE] = ACTIONS(3765),
    [anon_sym_SQUOTE] = ACTIONS(3765),
    [anon_sym_L_DQUOTE] = ACTIONS(3765),
    [anon_sym_u_DQUOTE] = ACTIONS(3765),
    [anon_sym_U_DQUOTE] = ACTIONS(3765),
    [anon_sym_u8_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE] = ACTIONS(3765),
    [sym_true] = ACTIONS(3763),
    [sym_false] = ACTIONS(3763),
    [anon_sym_NULL] = ACTIONS(3763),
    [anon_sym_nullptr] = ACTIONS(3763),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3763),
    [anon_sym_let] = ACTIONS(3763),
    [anon_sym_This] = ACTIONS(3763),
    [anon_sym_decltype] = ACTIONS(3763),
    [anon_sym_explicit] = ACTIONS(3763),
    [anon_sym_typename] = ACTIONS(3763),
    [anon_sym_template] = ACTIONS(3763),
    [anon_sym_operator] = ACTIONS(3763),
    [anon_sym_try] = ACTIONS(3763),
    [anon_sym_delete] = ACTIONS(3763),
    [anon_sym_throw] = ACTIONS(3763),
    [anon_sym_namespace] = ACTIONS(3763),
    [anon_sym_static_assert] = ACTIONS(3763),
    [anon_sym_concept] = ACTIONS(3763),
    [anon_sym_co_return] = ACTIONS(3763),
    [anon_sym_co_yield] = ACTIONS(3763),
    [anon_sym_R_DQUOTE] = ACTIONS(3765),
    [anon_sym_LR_DQUOTE] = ACTIONS(3765),
    [anon_sym_uR_DQUOTE] = ACTIONS(3765),
    [anon_sym_UR_DQUOTE] = ACTIONS(3765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3765),
    [anon_sym_co_await] = ACTIONS(3763),
    [anon_sym_new] = ACTIONS(3763),
    [anon_sym_requires] = ACTIONS(3763),
    [sym_this] = ACTIONS(3763),
    [anon_sym_discard] = ACTIONS(3763),
    [anon_sym_precise] = ACTIONS(3763),
    [anon_sym_shared] = ACTIONS(3763),
    [anon_sym_groupshared] = ACTIONS(3763),
    [anon_sym_uniform] = ACTIONS(3763),
    [anon_sym_row_major] = ACTIONS(3763),
    [anon_sym_column_major] = ACTIONS(3763),
    [anon_sym_globallycoherent] = ACTIONS(3763),
    [anon_sym_centroid] = ACTIONS(3763),
    [anon_sym_noperspective] = ACTIONS(3763),
    [anon_sym_nointerpolation] = ACTIONS(3763),
    [anon_sym_sample] = ACTIONS(3763),
    [anon_sym_linear] = ACTIONS(3763),
    [anon_sym_snorm] = ACTIONS(3763),
    [anon_sym_unorm] = ACTIONS(3763),
    [anon_sym_point] = ACTIONS(3763),
    [anon_sym_line] = ACTIONS(3763),
    [anon_sym_triangleadj] = ACTIONS(3763),
    [anon_sym_lineadj] = ACTIONS(3763),
    [anon_sym_triangle] = ACTIONS(3763),
    [anon_sym_cbuffer] = ACTIONS(3763),
    [anon_sym_interface] = ACTIONS(3763),
    [anon_sym_extension] = ACTIONS(3763),
  },
  [551] = {
    [sym_identifier] = ACTIONS(3767),
    [aux_sym_preproc_include_token1] = ACTIONS(3767),
    [aux_sym_preproc_def_token1] = ACTIONS(3767),
    [aux_sym_preproc_if_token1] = ACTIONS(3767),
    [aux_sym_preproc_if_token2] = ACTIONS(3767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3767),
    [aux_sym_preproc_else_token1] = ACTIONS(3767),
    [aux_sym_preproc_elif_token1] = ACTIONS(3767),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3767),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3767),
    [sym_preproc_directive] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3769),
    [anon_sym_BANG] = ACTIONS(3769),
    [anon_sym_TILDE] = ACTIONS(3769),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_AMP_AMP] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_SEMI] = ACTIONS(3769),
    [anon_sym___extension__] = ACTIONS(3767),
    [anon_sym_typedef] = ACTIONS(3767),
    [anon_sym_in] = ACTIONS(3767),
    [anon_sym_out] = ACTIONS(3767),
    [anon_sym_inout] = ACTIONS(3767),
    [anon_sym_virtual] = ACTIONS(3767),
    [anon_sym_extern] = ACTIONS(3767),
    [anon_sym___attribute__] = ACTIONS(3767),
    [anon_sym___attribute] = ACTIONS(3767),
    [anon_sym_using] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3769),
    [anon_sym___declspec] = ACTIONS(3767),
    [anon_sym___based] = ACTIONS(3767),
    [anon_sym___cdecl] = ACTIONS(3767),
    [anon_sym___clrcall] = ACTIONS(3767),
    [anon_sym___stdcall] = ACTIONS(3767),
    [anon_sym___fastcall] = ACTIONS(3767),
    [anon_sym___thiscall] = ACTIONS(3767),
    [anon_sym___vectorcall] = ACTIONS(3767),
    [anon_sym_LBRACE] = ACTIONS(3769),
    [anon_sym_signed] = ACTIONS(3767),
    [anon_sym_unsigned] = ACTIONS(3767),
    [anon_sym_long] = ACTIONS(3767),
    [anon_sym_short] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_static] = ACTIONS(3767),
    [anon_sym_register] = ACTIONS(3767),
    [anon_sym_inline] = ACTIONS(3767),
    [anon_sym___inline] = ACTIONS(3767),
    [anon_sym___inline__] = ACTIONS(3767),
    [anon_sym___forceinline] = ACTIONS(3767),
    [anon_sym_thread_local] = ACTIONS(3767),
    [anon_sym___thread] = ACTIONS(3767),
    [anon_sym_const] = ACTIONS(3767),
    [anon_sym_constexpr] = ACTIONS(3767),
    [anon_sym_volatile] = ACTIONS(3767),
    [anon_sym_restrict] = ACTIONS(3767),
    [anon_sym___restrict__] = ACTIONS(3767),
    [anon_sym__Atomic] = ACTIONS(3767),
    [anon_sym__Noreturn] = ACTIONS(3767),
    [anon_sym_noreturn] = ACTIONS(3767),
    [anon_sym__Nonnull] = ACTIONS(3767),
    [anon_sym_mutable] = ACTIONS(3767),
    [anon_sym_constinit] = ACTIONS(3767),
    [anon_sym_consteval] = ACTIONS(3767),
    [anon_sym_alignas] = ACTIONS(3767),
    [anon_sym__Alignas] = ACTIONS(3767),
    [sym_primitive_type] = ACTIONS(3767),
    [anon_sym_enum] = ACTIONS(3767),
    [anon_sym_class] = ACTIONS(3767),
    [anon_sym_struct] = ACTIONS(3767),
    [anon_sym_union] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_switch] = ACTIONS(3767),
    [anon_sym_case] = ACTIONS(3767),
    [anon_sym_default] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_break] = ACTIONS(3767),
    [anon_sym_continue] = ACTIONS(3767),
    [anon_sym_goto] = ACTIONS(3767),
    [anon_sym___try] = ACTIONS(3767),
    [anon_sym___leave] = ACTIONS(3767),
    [anon_sym_not] = ACTIONS(3767),
    [anon_sym_compl] = ACTIONS(3767),
    [anon_sym_DASH_DASH] = ACTIONS(3769),
    [anon_sym_PLUS_PLUS] = ACTIONS(3769),
    [anon_sym_sizeof] = ACTIONS(3767),
    [anon_sym___alignof__] = ACTIONS(3767),
    [anon_sym___alignof] = ACTIONS(3767),
    [anon_sym__alignof] = ACTIONS(3767),
    [anon_sym_alignof] = ACTIONS(3767),
    [anon_sym__Alignof] = ACTIONS(3767),
    [anon_sym_offsetof] = ACTIONS(3767),
    [anon_sym__Generic] = ACTIONS(3767),
    [anon_sym_asm] = ACTIONS(3767),
    [anon_sym___asm__] = ACTIONS(3767),
    [anon_sym___asm] = ACTIONS(3767),
    [sym_number_literal] = ACTIONS(3769),
    [anon_sym_L_SQUOTE] = ACTIONS(3769),
    [anon_sym_u_SQUOTE] = ACTIONS(3769),
    [anon_sym_U_SQUOTE] = ACTIONS(3769),
    [anon_sym_u8_SQUOTE] = ACTIONS(3769),
    [anon_sym_SQUOTE] = ACTIONS(3769),
    [anon_sym_L_DQUOTE] = ACTIONS(3769),
    [anon_sym_u_DQUOTE] = ACTIONS(3769),
    [anon_sym_U_DQUOTE] = ACTIONS(3769),
    [anon_sym_u8_DQUOTE] = ACTIONS(3769),
    [anon_sym_DQUOTE] = ACTIONS(3769),
    [sym_true] = ACTIONS(3767),
    [sym_false] = ACTIONS(3767),
    [anon_sym_NULL] = ACTIONS(3767),
    [anon_sym_nullptr] = ACTIONS(3767),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_This] = ACTIONS(3767),
    [anon_sym_decltype] = ACTIONS(3767),
    [anon_sym_explicit] = ACTIONS(3767),
    [anon_sym_typename] = ACTIONS(3767),
    [anon_sym_template] = ACTIONS(3767),
    [anon_sym_operator] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_delete] = ACTIONS(3767),
    [anon_sym_throw] = ACTIONS(3767),
    [anon_sym_namespace] = ACTIONS(3767),
    [anon_sym_static_assert] = ACTIONS(3767),
    [anon_sym_concept] = ACTIONS(3767),
    [anon_sym_co_return] = ACTIONS(3767),
    [anon_sym_co_yield] = ACTIONS(3767),
    [anon_sym_R_DQUOTE] = ACTIONS(3769),
    [anon_sym_LR_DQUOTE] = ACTIONS(3769),
    [anon_sym_uR_DQUOTE] = ACTIONS(3769),
    [anon_sym_UR_DQUOTE] = ACTIONS(3769),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3769),
    [anon_sym_co_await] = ACTIONS(3767),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_requires] = ACTIONS(3767),
    [sym_this] = ACTIONS(3767),
    [anon_sym_discard] = ACTIONS(3767),
    [anon_sym_precise] = ACTIONS(3767),
    [anon_sym_shared] = ACTIONS(3767),
    [anon_sym_groupshared] = ACTIONS(3767),
    [anon_sym_uniform] = ACTIONS(3767),
    [anon_sym_row_major] = ACTIONS(3767),
    [anon_sym_column_major] = ACTIONS(3767),
    [anon_sym_globallycoherent] = ACTIONS(3767),
    [anon_sym_centroid] = ACTIONS(3767),
    [anon_sym_noperspective] = ACTIONS(3767),
    [anon_sym_nointerpolation] = ACTIONS(3767),
    [anon_sym_sample] = ACTIONS(3767),
    [anon_sym_linear] = ACTIONS(3767),
    [anon_sym_snorm] = ACTIONS(3767),
    [anon_sym_unorm] = ACTIONS(3767),
    [anon_sym_point] = ACTIONS(3767),
    [anon_sym_line] = ACTIONS(3767),
    [anon_sym_triangleadj] = ACTIONS(3767),
    [anon_sym_lineadj] = ACTIONS(3767),
    [anon_sym_triangle] = ACTIONS(3767),
    [anon_sym_cbuffer] = ACTIONS(3767),
    [anon_sym_interface] = ACTIONS(3767),
    [anon_sym_extension] = ACTIONS(3767),
  },
  [552] = {
    [sym_identifier] = ACTIONS(3771),
    [aux_sym_preproc_include_token1] = ACTIONS(3771),
    [aux_sym_preproc_def_token1] = ACTIONS(3771),
    [aux_sym_preproc_if_token1] = ACTIONS(3771),
    [aux_sym_preproc_if_token2] = ACTIONS(3771),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3771),
    [aux_sym_preproc_else_token1] = ACTIONS(3771),
    [aux_sym_preproc_elif_token1] = ACTIONS(3771),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3771),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3771),
    [sym_preproc_directive] = ACTIONS(3771),
    [anon_sym_LPAREN2] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(3773),
    [anon_sym_TILDE] = ACTIONS(3773),
    [anon_sym_DASH] = ACTIONS(3771),
    [anon_sym_PLUS] = ACTIONS(3771),
    [anon_sym_STAR] = ACTIONS(3773),
    [anon_sym_AMP_AMP] = ACTIONS(3773),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_SEMI] = ACTIONS(3773),
    [anon_sym___extension__] = ACTIONS(3771),
    [anon_sym_typedef] = ACTIONS(3771),
    [anon_sym_in] = ACTIONS(3771),
    [anon_sym_out] = ACTIONS(3771),
    [anon_sym_inout] = ACTIONS(3771),
    [anon_sym_virtual] = ACTIONS(3771),
    [anon_sym_extern] = ACTIONS(3771),
    [anon_sym___attribute__] = ACTIONS(3771),
    [anon_sym___attribute] = ACTIONS(3771),
    [anon_sym_using] = ACTIONS(3771),
    [anon_sym_COLON_COLON] = ACTIONS(3773),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3773),
    [anon_sym___declspec] = ACTIONS(3771),
    [anon_sym___based] = ACTIONS(3771),
    [anon_sym___cdecl] = ACTIONS(3771),
    [anon_sym___clrcall] = ACTIONS(3771),
    [anon_sym___stdcall] = ACTIONS(3771),
    [anon_sym___fastcall] = ACTIONS(3771),
    [anon_sym___thiscall] = ACTIONS(3771),
    [anon_sym___vectorcall] = ACTIONS(3771),
    [anon_sym_LBRACE] = ACTIONS(3773),
    [anon_sym_signed] = ACTIONS(3771),
    [anon_sym_unsigned] = ACTIONS(3771),
    [anon_sym_long] = ACTIONS(3771),
    [anon_sym_short] = ACTIONS(3771),
    [anon_sym_LBRACK] = ACTIONS(3771),
    [anon_sym_static] = ACTIONS(3771),
    [anon_sym_register] = ACTIONS(3771),
    [anon_sym_inline] = ACTIONS(3771),
    [anon_sym___inline] = ACTIONS(3771),
    [anon_sym___inline__] = ACTIONS(3771),
    [anon_sym___forceinline] = ACTIONS(3771),
    [anon_sym_thread_local] = ACTIONS(3771),
    [anon_sym___thread] = ACTIONS(3771),
    [anon_sym_const] = ACTIONS(3771),
    [anon_sym_constexpr] = ACTIONS(3771),
    [anon_sym_volatile] = ACTIONS(3771),
    [anon_sym_restrict] = ACTIONS(3771),
    [anon_sym___restrict__] = ACTIONS(3771),
    [anon_sym__Atomic] = ACTIONS(3771),
    [anon_sym__Noreturn] = ACTIONS(3771),
    [anon_sym_noreturn] = ACTIONS(3771),
    [anon_sym__Nonnull] = ACTIONS(3771),
    [anon_sym_mutable] = ACTIONS(3771),
    [anon_sym_constinit] = ACTIONS(3771),
    [anon_sym_consteval] = ACTIONS(3771),
    [anon_sym_alignas] = ACTIONS(3771),
    [anon_sym__Alignas] = ACTIONS(3771),
    [sym_primitive_type] = ACTIONS(3771),
    [anon_sym_enum] = ACTIONS(3771),
    [anon_sym_class] = ACTIONS(3771),
    [anon_sym_struct] = ACTIONS(3771),
    [anon_sym_union] = ACTIONS(3771),
    [anon_sym_if] = ACTIONS(3771),
    [anon_sym_switch] = ACTIONS(3771),
    [anon_sym_case] = ACTIONS(3771),
    [anon_sym_default] = ACTIONS(3771),
    [anon_sym_while] = ACTIONS(3771),
    [anon_sym_do] = ACTIONS(3771),
    [anon_sym_for] = ACTIONS(3771),
    [anon_sym_return] = ACTIONS(3771),
    [anon_sym_break] = ACTIONS(3771),
    [anon_sym_continue] = ACTIONS(3771),
    [anon_sym_goto] = ACTIONS(3771),
    [anon_sym___try] = ACTIONS(3771),
    [anon_sym___leave] = ACTIONS(3771),
    [anon_sym_not] = ACTIONS(3771),
    [anon_sym_compl] = ACTIONS(3771),
    [anon_sym_DASH_DASH] = ACTIONS(3773),
    [anon_sym_PLUS_PLUS] = ACTIONS(3773),
    [anon_sym_sizeof] = ACTIONS(3771),
    [anon_sym___alignof__] = ACTIONS(3771),
    [anon_sym___alignof] = ACTIONS(3771),
    [anon_sym__alignof] = ACTIONS(3771),
    [anon_sym_alignof] = ACTIONS(3771),
    [anon_sym__Alignof] = ACTIONS(3771),
    [anon_sym_offsetof] = ACTIONS(3771),
    [anon_sym__Generic] = ACTIONS(3771),
    [anon_sym_asm] = ACTIONS(3771),
    [anon_sym___asm__] = ACTIONS(3771),
    [anon_sym___asm] = ACTIONS(3771),
    [sym_number_literal] = ACTIONS(3773),
    [anon_sym_L_SQUOTE] = ACTIONS(3773),
    [anon_sym_u_SQUOTE] = ACTIONS(3773),
    [anon_sym_U_SQUOTE] = ACTIONS(3773),
    [anon_sym_u8_SQUOTE] = ACTIONS(3773),
    [anon_sym_SQUOTE] = ACTIONS(3773),
    [anon_sym_L_DQUOTE] = ACTIONS(3773),
    [anon_sym_u_DQUOTE] = ACTIONS(3773),
    [anon_sym_U_DQUOTE] = ACTIONS(3773),
    [anon_sym_u8_DQUOTE] = ACTIONS(3773),
    [anon_sym_DQUOTE] = ACTIONS(3773),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [anon_sym_NULL] = ACTIONS(3771),
    [anon_sym_nullptr] = ACTIONS(3771),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3771),
    [anon_sym_let] = ACTIONS(3771),
    [anon_sym_This] = ACTIONS(3771),
    [anon_sym_decltype] = ACTIONS(3771),
    [anon_sym_explicit] = ACTIONS(3771),
    [anon_sym_typename] = ACTIONS(3771),
    [anon_sym_template] = ACTIONS(3771),
    [anon_sym_operator] = ACTIONS(3771),
    [anon_sym_try] = ACTIONS(3771),
    [anon_sym_delete] = ACTIONS(3771),
    [anon_sym_throw] = ACTIONS(3771),
    [anon_sym_namespace] = ACTIONS(3771),
    [anon_sym_static_assert] = ACTIONS(3771),
    [anon_sym_concept] = ACTIONS(3771),
    [anon_sym_co_return] = ACTIONS(3771),
    [anon_sym_co_yield] = ACTIONS(3771),
    [anon_sym_R_DQUOTE] = ACTIONS(3773),
    [anon_sym_LR_DQUOTE] = ACTIONS(3773),
    [anon_sym_uR_DQUOTE] = ACTIONS(3773),
    [anon_sym_UR_DQUOTE] = ACTIONS(3773),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3773),
    [anon_sym_co_await] = ACTIONS(3771),
    [anon_sym_new] = ACTIONS(3771),
    [anon_sym_requires] = ACTIONS(3771),
    [sym_this] = ACTIONS(3771),
    [anon_sym_discard] = ACTIONS(3771),
    [anon_sym_precise] = ACTIONS(3771),
    [anon_sym_shared] = ACTIONS(3771),
    [anon_sym_groupshared] = ACTIONS(3771),
    [anon_sym_uniform] = ACTIONS(3771),
    [anon_sym_row_major] = ACTIONS(3771),
    [anon_sym_column_major] = ACTIONS(3771),
    [anon_sym_globallycoherent] = ACTIONS(3771),
    [anon_sym_centroid] = ACTIONS(3771),
    [anon_sym_noperspective] = ACTIONS(3771),
    [anon_sym_nointerpolation] = ACTIONS(3771),
    [anon_sym_sample] = ACTIONS(3771),
    [anon_sym_linear] = ACTIONS(3771),
    [anon_sym_snorm] = ACTIONS(3771),
    [anon_sym_unorm] = ACTIONS(3771),
    [anon_sym_point] = ACTIONS(3771),
    [anon_sym_line] = ACTIONS(3771),
    [anon_sym_triangleadj] = ACTIONS(3771),
    [anon_sym_lineadj] = ACTIONS(3771),
    [anon_sym_triangle] = ACTIONS(3771),
    [anon_sym_cbuffer] = ACTIONS(3771),
    [anon_sym_interface] = ACTIONS(3771),
    [anon_sym_extension] = ACTIONS(3771),
  },
  [553] = {
    [sym_identifier] = ACTIONS(2268),
    [aux_sym_preproc_include_token1] = ACTIONS(2268),
    [aux_sym_preproc_def_token1] = ACTIONS(2268),
    [aux_sym_preproc_if_token1] = ACTIONS(2268),
    [aux_sym_preproc_if_token2] = ACTIONS(2268),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2268),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2268),
    [sym_preproc_directive] = ACTIONS(2268),
    [anon_sym_LPAREN2] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2270),
    [anon_sym_TILDE] = ACTIONS(2270),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2270),
    [anon_sym_AMP_AMP] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(2268),
    [anon_sym_COLON] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym___extension__] = ACTIONS(2268),
    [anon_sym_typedef] = ACTIONS(2268),
    [anon_sym_in] = ACTIONS(2268),
    [anon_sym_out] = ACTIONS(2268),
    [anon_sym_inout] = ACTIONS(2268),
    [anon_sym_virtual] = ACTIONS(2268),
    [anon_sym_extern] = ACTIONS(2268),
    [anon_sym___attribute__] = ACTIONS(2268),
    [anon_sym___attribute] = ACTIONS(2268),
    [anon_sym_using] = ACTIONS(2268),
    [anon_sym_COLON_COLON] = ACTIONS(2270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2270),
    [anon_sym___declspec] = ACTIONS(2268),
    [anon_sym___based] = ACTIONS(2268),
    [anon_sym___cdecl] = ACTIONS(2268),
    [anon_sym___clrcall] = ACTIONS(2268),
    [anon_sym___stdcall] = ACTIONS(2268),
    [anon_sym___fastcall] = ACTIONS(2268),
    [anon_sym___thiscall] = ACTIONS(2268),
    [anon_sym___vectorcall] = ACTIONS(2268),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_signed] = ACTIONS(2268),
    [anon_sym_unsigned] = ACTIONS(2268),
    [anon_sym_long] = ACTIONS(2268),
    [anon_sym_short] = ACTIONS(2268),
    [anon_sym_LBRACK] = ACTIONS(2268),
    [anon_sym_static] = ACTIONS(2268),
    [anon_sym_register] = ACTIONS(2268),
    [anon_sym_inline] = ACTIONS(2268),
    [anon_sym___inline] = ACTIONS(2268),
    [anon_sym___inline__] = ACTIONS(2268),
    [anon_sym___forceinline] = ACTIONS(2268),
    [anon_sym_thread_local] = ACTIONS(2268),
    [anon_sym___thread] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_constexpr] = ACTIONS(2268),
    [anon_sym_volatile] = ACTIONS(2268),
    [anon_sym_restrict] = ACTIONS(2268),
    [anon_sym___restrict__] = ACTIONS(2268),
    [anon_sym__Atomic] = ACTIONS(2268),
    [anon_sym__Noreturn] = ACTIONS(2268),
    [anon_sym_noreturn] = ACTIONS(2268),
    [anon_sym__Nonnull] = ACTIONS(2268),
    [anon_sym_mutable] = ACTIONS(2268),
    [anon_sym_constinit] = ACTIONS(2268),
    [anon_sym_consteval] = ACTIONS(2268),
    [anon_sym_alignas] = ACTIONS(2268),
    [anon_sym__Alignas] = ACTIONS(2268),
    [sym_primitive_type] = ACTIONS(2268),
    [anon_sym_enum] = ACTIONS(2268),
    [anon_sym_class] = ACTIONS(2268),
    [anon_sym_struct] = ACTIONS(2268),
    [anon_sym_union] = ACTIONS(2268),
    [anon_sym_if] = ACTIONS(2268),
    [anon_sym_else] = ACTIONS(2268),
    [anon_sym_switch] = ACTIONS(2268),
    [anon_sym_case] = ACTIONS(2268),
    [anon_sym_default] = ACTIONS(2268),
    [anon_sym_while] = ACTIONS(2268),
    [anon_sym_do] = ACTIONS(2268),
    [anon_sym_for] = ACTIONS(2268),
    [anon_sym_return] = ACTIONS(2268),
    [anon_sym_break] = ACTIONS(2268),
    [anon_sym_continue] = ACTIONS(2268),
    [anon_sym_goto] = ACTIONS(2268),
    [anon_sym___try] = ACTIONS(2268),
    [anon_sym___leave] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2268),
    [anon_sym_compl] = ACTIONS(2268),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_sizeof] = ACTIONS(2268),
    [anon_sym___alignof__] = ACTIONS(2268),
    [anon_sym___alignof] = ACTIONS(2268),
    [anon_sym__alignof] = ACTIONS(2268),
    [anon_sym_alignof] = ACTIONS(2268),
    [anon_sym__Alignof] = ACTIONS(2268),
    [anon_sym_offsetof] = ACTIONS(2268),
    [anon_sym__Generic] = ACTIONS(2268),
    [anon_sym_asm] = ACTIONS(2268),
    [anon_sym___asm__] = ACTIONS(2268),
    [anon_sym___asm] = ACTIONS(2268),
    [sym_number_literal] = ACTIONS(2270),
    [anon_sym_L_SQUOTE] = ACTIONS(2270),
    [anon_sym_u_SQUOTE] = ACTIONS(2270),
    [anon_sym_U_SQUOTE] = ACTIONS(2270),
    [anon_sym_u8_SQUOTE] = ACTIONS(2270),
    [anon_sym_SQUOTE] = ACTIONS(2270),
    [anon_sym_L_DQUOTE] = ACTIONS(2270),
    [anon_sym_u_DQUOTE] = ACTIONS(2270),
    [anon_sym_U_DQUOTE] = ACTIONS(2270),
    [anon_sym_u8_DQUOTE] = ACTIONS(2270),
    [anon_sym_DQUOTE] = ACTIONS(2270),
    [sym_true] = ACTIONS(2268),
    [sym_false] = ACTIONS(2268),
    [anon_sym_NULL] = ACTIONS(2268),
    [anon_sym_nullptr] = ACTIONS(2268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_This] = ACTIONS(2268),
    [anon_sym_decltype] = ACTIONS(2268),
    [anon_sym_final] = ACTIONS(2268),
    [anon_sym_override] = ACTIONS(2268),
    [anon_sym_explicit] = ACTIONS(2268),
    [anon_sym_typename] = ACTIONS(2268),
    [anon_sym_template] = ACTIONS(2268),
    [anon_sym_operator] = ACTIONS(2268),
    [anon_sym_try] = ACTIONS(2268),
    [anon_sym_delete] = ACTIONS(2268),
    [anon_sym_throw] = ACTIONS(2268),
    [anon_sym_namespace] = ACTIONS(2268),
    [anon_sym_static_assert] = ACTIONS(2268),
    [anon_sym_concept] = ACTIONS(2268),
    [anon_sym_co_return] = ACTIONS(2268),
    [anon_sym_co_yield] = ACTIONS(2268),
    [anon_sym_R_DQUOTE] = ACTIONS(2270),
    [anon_sym_LR_DQUOTE] = ACTIONS(2270),
    [anon_sym_uR_DQUOTE] = ACTIONS(2270),
    [anon_sym_UR_DQUOTE] = ACTIONS(2270),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2270),
    [anon_sym_co_await] = ACTIONS(2268),
    [anon_sym_new] = ACTIONS(2268),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2268),
    [anon_sym_discard] = ACTIONS(2268),
    [anon_sym_precise] = ACTIONS(2268),
    [anon_sym_shared] = ACTIONS(2268),
    [anon_sym_groupshared] = ACTIONS(2268),
    [anon_sym_uniform] = ACTIONS(2268),
    [anon_sym_row_major] = ACTIONS(2268),
    [anon_sym_column_major] = ACTIONS(2268),
    [anon_sym_globallycoherent] = ACTIONS(2268),
    [anon_sym_centroid] = ACTIONS(2268),
    [anon_sym_noperspective] = ACTIONS(2268),
    [anon_sym_nointerpolation] = ACTIONS(2268),
    [anon_sym_sample] = ACTIONS(2268),
    [anon_sym_linear] = ACTIONS(2268),
    [anon_sym_snorm] = ACTIONS(2268),
    [anon_sym_unorm] = ACTIONS(2268),
    [anon_sym_point] = ACTIONS(2268),
    [anon_sym_line] = ACTIONS(2268),
    [anon_sym_triangleadj] = ACTIONS(2268),
    [anon_sym_lineadj] = ACTIONS(2268),
    [anon_sym_triangle] = ACTIONS(2268),
    [anon_sym_cbuffer] = ACTIONS(2268),
    [anon_sym_interface] = ACTIONS(2268),
    [anon_sym_extension] = ACTIONS(2268),
  },
  [554] = {
    [sym_identifier] = ACTIONS(2272),
    [aux_sym_preproc_include_token1] = ACTIONS(2272),
    [aux_sym_preproc_def_token1] = ACTIONS(2272),
    [aux_sym_preproc_if_token1] = ACTIONS(2272),
    [aux_sym_preproc_if_token2] = ACTIONS(2272),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2272),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2272),
    [sym_preproc_directive] = ACTIONS(2272),
    [anon_sym_LPAREN2] = ACTIONS(2274),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2274),
    [anon_sym_AMP_AMP] = ACTIONS(2274),
    [anon_sym_AMP] = ACTIONS(2272),
    [anon_sym_COLON] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym___extension__] = ACTIONS(2272),
    [anon_sym_typedef] = ACTIONS(2272),
    [anon_sym_in] = ACTIONS(2272),
    [anon_sym_out] = ACTIONS(2272),
    [anon_sym_inout] = ACTIONS(2272),
    [anon_sym_virtual] = ACTIONS(2272),
    [anon_sym_extern] = ACTIONS(2272),
    [anon_sym___attribute__] = ACTIONS(2272),
    [anon_sym___attribute] = ACTIONS(2272),
    [anon_sym_using] = ACTIONS(2272),
    [anon_sym_COLON_COLON] = ACTIONS(2274),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2274),
    [anon_sym___declspec] = ACTIONS(2272),
    [anon_sym___based] = ACTIONS(2272),
    [anon_sym___cdecl] = ACTIONS(2272),
    [anon_sym___clrcall] = ACTIONS(2272),
    [anon_sym___stdcall] = ACTIONS(2272),
    [anon_sym___fastcall] = ACTIONS(2272),
    [anon_sym___thiscall] = ACTIONS(2272),
    [anon_sym___vectorcall] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_signed] = ACTIONS(2272),
    [anon_sym_unsigned] = ACTIONS(2272),
    [anon_sym_long] = ACTIONS(2272),
    [anon_sym_short] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_register] = ACTIONS(2272),
    [anon_sym_inline] = ACTIONS(2272),
    [anon_sym___inline] = ACTIONS(2272),
    [anon_sym___inline__] = ACTIONS(2272),
    [anon_sym___forceinline] = ACTIONS(2272),
    [anon_sym_thread_local] = ACTIONS(2272),
    [anon_sym___thread] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_constexpr] = ACTIONS(2272),
    [anon_sym_volatile] = ACTIONS(2272),
    [anon_sym_restrict] = ACTIONS(2272),
    [anon_sym___restrict__] = ACTIONS(2272),
    [anon_sym__Atomic] = ACTIONS(2272),
    [anon_sym__Noreturn] = ACTIONS(2272),
    [anon_sym_noreturn] = ACTIONS(2272),
    [anon_sym__Nonnull] = ACTIONS(2272),
    [anon_sym_mutable] = ACTIONS(2272),
    [anon_sym_constinit] = ACTIONS(2272),
    [anon_sym_consteval] = ACTIONS(2272),
    [anon_sym_alignas] = ACTIONS(2272),
    [anon_sym__Alignas] = ACTIONS(2272),
    [sym_primitive_type] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_struct] = ACTIONS(2272),
    [anon_sym_union] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_else] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_case] = ACTIONS(2272),
    [anon_sym_default] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_goto] = ACTIONS(2272),
    [anon_sym___try] = ACTIONS(2272),
    [anon_sym___leave] = ACTIONS(2272),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_compl] = ACTIONS(2272),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_sizeof] = ACTIONS(2272),
    [anon_sym___alignof__] = ACTIONS(2272),
    [anon_sym___alignof] = ACTIONS(2272),
    [anon_sym__alignof] = ACTIONS(2272),
    [anon_sym_alignof] = ACTIONS(2272),
    [anon_sym__Alignof] = ACTIONS(2272),
    [anon_sym_offsetof] = ACTIONS(2272),
    [anon_sym__Generic] = ACTIONS(2272),
    [anon_sym_asm] = ACTIONS(2272),
    [anon_sym___asm__] = ACTIONS(2272),
    [anon_sym___asm] = ACTIONS(2272),
    [sym_number_literal] = ACTIONS(2274),
    [anon_sym_L_SQUOTE] = ACTIONS(2274),
    [anon_sym_u_SQUOTE] = ACTIONS(2274),
    [anon_sym_U_SQUOTE] = ACTIONS(2274),
    [anon_sym_u8_SQUOTE] = ACTIONS(2274),
    [anon_sym_SQUOTE] = ACTIONS(2274),
    [anon_sym_L_DQUOTE] = ACTIONS(2274),
    [anon_sym_u_DQUOTE] = ACTIONS(2274),
    [anon_sym_U_DQUOTE] = ACTIONS(2274),
    [anon_sym_u8_DQUOTE] = ACTIONS(2274),
    [anon_sym_DQUOTE] = ACTIONS(2274),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [anon_sym_NULL] = ACTIONS(2272),
    [anon_sym_nullptr] = ACTIONS(2272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_This] = ACTIONS(2272),
    [anon_sym_decltype] = ACTIONS(2272),
    [anon_sym_final] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_explicit] = ACTIONS(2272),
    [anon_sym_typename] = ACTIONS(2272),
    [anon_sym_template] = ACTIONS(2272),
    [anon_sym_operator] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_namespace] = ACTIONS(2272),
    [anon_sym_static_assert] = ACTIONS(2272),
    [anon_sym_concept] = ACTIONS(2272),
    [anon_sym_co_return] = ACTIONS(2272),
    [anon_sym_co_yield] = ACTIONS(2272),
    [anon_sym_R_DQUOTE] = ACTIONS(2274),
    [anon_sym_LR_DQUOTE] = ACTIONS(2274),
    [anon_sym_uR_DQUOTE] = ACTIONS(2274),
    [anon_sym_UR_DQUOTE] = ACTIONS(2274),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2274),
    [anon_sym_co_await] = ACTIONS(2272),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_requires] = ACTIONS(2272),
    [sym_this] = ACTIONS(2272),
    [anon_sym_discard] = ACTIONS(2272),
    [anon_sym_precise] = ACTIONS(2272),
    [anon_sym_shared] = ACTIONS(2272),
    [anon_sym_groupshared] = ACTIONS(2272),
    [anon_sym_uniform] = ACTIONS(2272),
    [anon_sym_row_major] = ACTIONS(2272),
    [anon_sym_column_major] = ACTIONS(2272),
    [anon_sym_globallycoherent] = ACTIONS(2272),
    [anon_sym_centroid] = ACTIONS(2272),
    [anon_sym_noperspective] = ACTIONS(2272),
    [anon_sym_nointerpolation] = ACTIONS(2272),
    [anon_sym_sample] = ACTIONS(2272),
    [anon_sym_linear] = ACTIONS(2272),
    [anon_sym_snorm] = ACTIONS(2272),
    [anon_sym_unorm] = ACTIONS(2272),
    [anon_sym_point] = ACTIONS(2272),
    [anon_sym_line] = ACTIONS(2272),
    [anon_sym_triangleadj] = ACTIONS(2272),
    [anon_sym_lineadj] = ACTIONS(2272),
    [anon_sym_triangle] = ACTIONS(2272),
    [anon_sym_cbuffer] = ACTIONS(2272),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_extension] = ACTIONS(2272),
  },
  [555] = {
    [sym_identifier] = ACTIONS(2276),
    [aux_sym_preproc_include_token1] = ACTIONS(2276),
    [aux_sym_preproc_def_token1] = ACTIONS(2276),
    [aux_sym_preproc_if_token1] = ACTIONS(2276),
    [aux_sym_preproc_if_token2] = ACTIONS(2276),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2276),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2276),
    [sym_preproc_directive] = ACTIONS(2276),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_PLUS] = ACTIONS(2276),
    [anon_sym_STAR] = ACTIONS(2278),
    [anon_sym_AMP_AMP] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_COLON] = ACTIONS(2276),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym___extension__] = ACTIONS(2276),
    [anon_sym_typedef] = ACTIONS(2276),
    [anon_sym_in] = ACTIONS(2276),
    [anon_sym_out] = ACTIONS(2276),
    [anon_sym_inout] = ACTIONS(2276),
    [anon_sym_virtual] = ACTIONS(2276),
    [anon_sym_extern] = ACTIONS(2276),
    [anon_sym___attribute__] = ACTIONS(2276),
    [anon_sym___attribute] = ACTIONS(2276),
    [anon_sym_using] = ACTIONS(2276),
    [anon_sym_COLON_COLON] = ACTIONS(2278),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2278),
    [anon_sym___declspec] = ACTIONS(2276),
    [anon_sym___based] = ACTIONS(2276),
    [anon_sym___cdecl] = ACTIONS(2276),
    [anon_sym___clrcall] = ACTIONS(2276),
    [anon_sym___stdcall] = ACTIONS(2276),
    [anon_sym___fastcall] = ACTIONS(2276),
    [anon_sym___thiscall] = ACTIONS(2276),
    [anon_sym___vectorcall] = ACTIONS(2276),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_signed] = ACTIONS(2276),
    [anon_sym_unsigned] = ACTIONS(2276),
    [anon_sym_long] = ACTIONS(2276),
    [anon_sym_short] = ACTIONS(2276),
    [anon_sym_LBRACK] = ACTIONS(2276),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_register] = ACTIONS(2276),
    [anon_sym_inline] = ACTIONS(2276),
    [anon_sym___inline] = ACTIONS(2276),
    [anon_sym___inline__] = ACTIONS(2276),
    [anon_sym___forceinline] = ACTIONS(2276),
    [anon_sym_thread_local] = ACTIONS(2276),
    [anon_sym___thread] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_constexpr] = ACTIONS(2276),
    [anon_sym_volatile] = ACTIONS(2276),
    [anon_sym_restrict] = ACTIONS(2276),
    [anon_sym___restrict__] = ACTIONS(2276),
    [anon_sym__Atomic] = ACTIONS(2276),
    [anon_sym__Noreturn] = ACTIONS(2276),
    [anon_sym_noreturn] = ACTIONS(2276),
    [anon_sym__Nonnull] = ACTIONS(2276),
    [anon_sym_mutable] = ACTIONS(2276),
    [anon_sym_constinit] = ACTIONS(2276),
    [anon_sym_consteval] = ACTIONS(2276),
    [anon_sym_alignas] = ACTIONS(2276),
    [anon_sym__Alignas] = ACTIONS(2276),
    [sym_primitive_type] = ACTIONS(2276),
    [anon_sym_enum] = ACTIONS(2276),
    [anon_sym_class] = ACTIONS(2276),
    [anon_sym_struct] = ACTIONS(2276),
    [anon_sym_union] = ACTIONS(2276),
    [anon_sym_if] = ACTIONS(2276),
    [anon_sym_else] = ACTIONS(2276),
    [anon_sym_switch] = ACTIONS(2276),
    [anon_sym_case] = ACTIONS(2276),
    [anon_sym_default] = ACTIONS(2276),
    [anon_sym_while] = ACTIONS(2276),
    [anon_sym_do] = ACTIONS(2276),
    [anon_sym_for] = ACTIONS(2276),
    [anon_sym_return] = ACTIONS(2276),
    [anon_sym_break] = ACTIONS(2276),
    [anon_sym_continue] = ACTIONS(2276),
    [anon_sym_goto] = ACTIONS(2276),
    [anon_sym___try] = ACTIONS(2276),
    [anon_sym___leave] = ACTIONS(2276),
    [anon_sym_not] = ACTIONS(2276),
    [anon_sym_compl] = ACTIONS(2276),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_sizeof] = ACTIONS(2276),
    [anon_sym___alignof__] = ACTIONS(2276),
    [anon_sym___alignof] = ACTIONS(2276),
    [anon_sym__alignof] = ACTIONS(2276),
    [anon_sym_alignof] = ACTIONS(2276),
    [anon_sym__Alignof] = ACTIONS(2276),
    [anon_sym_offsetof] = ACTIONS(2276),
    [anon_sym__Generic] = ACTIONS(2276),
    [anon_sym_asm] = ACTIONS(2276),
    [anon_sym___asm__] = ACTIONS(2276),
    [anon_sym___asm] = ACTIONS(2276),
    [sym_number_literal] = ACTIONS(2278),
    [anon_sym_L_SQUOTE] = ACTIONS(2278),
    [anon_sym_u_SQUOTE] = ACTIONS(2278),
    [anon_sym_U_SQUOTE] = ACTIONS(2278),
    [anon_sym_u8_SQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_L_DQUOTE] = ACTIONS(2278),
    [anon_sym_u_DQUOTE] = ACTIONS(2278),
    [anon_sym_U_DQUOTE] = ACTIONS(2278),
    [anon_sym_u8_DQUOTE] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [sym_true] = ACTIONS(2276),
    [sym_false] = ACTIONS(2276),
    [anon_sym_NULL] = ACTIONS(2276),
    [anon_sym_nullptr] = ACTIONS(2276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_This] = ACTIONS(2276),
    [anon_sym_decltype] = ACTIONS(2276),
    [anon_sym_final] = ACTIONS(2276),
    [anon_sym_override] = ACTIONS(2276),
    [anon_sym_explicit] = ACTIONS(2276),
    [anon_sym_typename] = ACTIONS(2276),
    [anon_sym_template] = ACTIONS(2276),
    [anon_sym_operator] = ACTIONS(2276),
    [anon_sym_try] = ACTIONS(2276),
    [anon_sym_delete] = ACTIONS(2276),
    [anon_sym_throw] = ACTIONS(2276),
    [anon_sym_namespace] = ACTIONS(2276),
    [anon_sym_static_assert] = ACTIONS(2276),
    [anon_sym_concept] = ACTIONS(2276),
    [anon_sym_co_return] = ACTIONS(2276),
    [anon_sym_co_yield] = ACTIONS(2276),
    [anon_sym_R_DQUOTE] = ACTIONS(2278),
    [anon_sym_LR_DQUOTE] = ACTIONS(2278),
    [anon_sym_uR_DQUOTE] = ACTIONS(2278),
    [anon_sym_UR_DQUOTE] = ACTIONS(2278),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2278),
    [anon_sym_co_await] = ACTIONS(2276),
    [anon_sym_new] = ACTIONS(2276),
    [anon_sym_requires] = ACTIONS(2276),
    [sym_this] = ACTIONS(2276),
    [anon_sym_discard] = ACTIONS(2276),
    [anon_sym_precise] = ACTIONS(2276),
    [anon_sym_shared] = ACTIONS(2276),
    [anon_sym_groupshared] = ACTIONS(2276),
    [anon_sym_uniform] = ACTIONS(2276),
    [anon_sym_row_major] = ACTIONS(2276),
    [anon_sym_column_major] = ACTIONS(2276),
    [anon_sym_globallycoherent] = ACTIONS(2276),
    [anon_sym_centroid] = ACTIONS(2276),
    [anon_sym_noperspective] = ACTIONS(2276),
    [anon_sym_nointerpolation] = ACTIONS(2276),
    [anon_sym_sample] = ACTIONS(2276),
    [anon_sym_linear] = ACTIONS(2276),
    [anon_sym_snorm] = ACTIONS(2276),
    [anon_sym_unorm] = ACTIONS(2276),
    [anon_sym_point] = ACTIONS(2276),
    [anon_sym_line] = ACTIONS(2276),
    [anon_sym_triangleadj] = ACTIONS(2276),
    [anon_sym_lineadj] = ACTIONS(2276),
    [anon_sym_triangle] = ACTIONS(2276),
    [anon_sym_cbuffer] = ACTIONS(2276),
    [anon_sym_interface] = ACTIONS(2276),
    [anon_sym_extension] = ACTIONS(2276),
  },
  [556] = {
    [sym_identifier] = ACTIONS(2239),
    [aux_sym_preproc_include_token1] = ACTIONS(2239),
    [aux_sym_preproc_def_token1] = ACTIONS(2239),
    [aux_sym_preproc_if_token1] = ACTIONS(2239),
    [aux_sym_preproc_if_token2] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2239),
    [sym_preproc_directive] = ACTIONS(2239),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2239),
    [anon_sym_PLUS] = ACTIONS(2239),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_COLON] = ACTIONS(2239),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym_typedef] = ACTIONS(2239),
    [anon_sym_in] = ACTIONS(2239),
    [anon_sym_out] = ACTIONS(2239),
    [anon_sym_inout] = ACTIONS(2239),
    [anon_sym_virtual] = ACTIONS(2239),
    [anon_sym_extern] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym___attribute] = ACTIONS(2239),
    [anon_sym_using] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2241),
    [anon_sym___declspec] = ACTIONS(2239),
    [anon_sym___based] = ACTIONS(2239),
    [anon_sym___cdecl] = ACTIONS(2239),
    [anon_sym___clrcall] = ACTIONS(2239),
    [anon_sym___stdcall] = ACTIONS(2239),
    [anon_sym___fastcall] = ACTIONS(2239),
    [anon_sym___thiscall] = ACTIONS(2239),
    [anon_sym___vectorcall] = ACTIONS(2239),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_signed] = ACTIONS(2239),
    [anon_sym_unsigned] = ACTIONS(2239),
    [anon_sym_long] = ACTIONS(2239),
    [anon_sym_short] = ACTIONS(2239),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2239),
    [anon_sym_register] = ACTIONS(2239),
    [anon_sym_inline] = ACTIONS(2239),
    [anon_sym___inline] = ACTIONS(2239),
    [anon_sym___inline__] = ACTIONS(2239),
    [anon_sym___forceinline] = ACTIONS(2239),
    [anon_sym_thread_local] = ACTIONS(2239),
    [anon_sym___thread] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym__Nonnull] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [sym_primitive_type] = ACTIONS(2239),
    [anon_sym_enum] = ACTIONS(2239),
    [anon_sym_class] = ACTIONS(2239),
    [anon_sym_struct] = ACTIONS(2239),
    [anon_sym_union] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(2239),
    [anon_sym_else] = ACTIONS(2239),
    [anon_sym_switch] = ACTIONS(2239),
    [anon_sym_case] = ACTIONS(2239),
    [anon_sym_default] = ACTIONS(2239),
    [anon_sym_while] = ACTIONS(2239),
    [anon_sym_do] = ACTIONS(2239),
    [anon_sym_for] = ACTIONS(2239),
    [anon_sym_return] = ACTIONS(2239),
    [anon_sym_break] = ACTIONS(2239),
    [anon_sym_continue] = ACTIONS(2239),
    [anon_sym_goto] = ACTIONS(2239),
    [anon_sym___try] = ACTIONS(2239),
    [anon_sym___leave] = ACTIONS(2239),
    [anon_sym_not] = ACTIONS(2239),
    [anon_sym_compl] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_sizeof] = ACTIONS(2239),
    [anon_sym___alignof__] = ACTIONS(2239),
    [anon_sym___alignof] = ACTIONS(2239),
    [anon_sym__alignof] = ACTIONS(2239),
    [anon_sym_alignof] = ACTIONS(2239),
    [anon_sym__Alignof] = ACTIONS(2239),
    [anon_sym_offsetof] = ACTIONS(2239),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2239),
    [anon_sym___asm__] = ACTIONS(2239),
    [anon_sym___asm] = ACTIONS(2239),
    [sym_number_literal] = ACTIONS(2241),
    [anon_sym_L_SQUOTE] = ACTIONS(2241),
    [anon_sym_u_SQUOTE] = ACTIONS(2241),
    [anon_sym_U_SQUOTE] = ACTIONS(2241),
    [anon_sym_u8_SQUOTE] = ACTIONS(2241),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_L_DQUOTE] = ACTIONS(2241),
    [anon_sym_u_DQUOTE] = ACTIONS(2241),
    [anon_sym_U_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8_DQUOTE] = ACTIONS(2241),
    [anon_sym_DQUOTE] = ACTIONS(2241),
    [sym_true] = ACTIONS(2239),
    [sym_false] = ACTIONS(2239),
    [anon_sym_NULL] = ACTIONS(2239),
    [anon_sym_nullptr] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2239),
    [anon_sym_let] = ACTIONS(2239),
    [anon_sym_This] = ACTIONS(2239),
    [anon_sym_decltype] = ACTIONS(2239),
    [anon_sym_final] = ACTIONS(2239),
    [anon_sym_override] = ACTIONS(2239),
    [anon_sym_explicit] = ACTIONS(2239),
    [anon_sym_typename] = ACTIONS(2239),
    [anon_sym_template] = ACTIONS(2239),
    [anon_sym_operator] = ACTIONS(2239),
    [anon_sym_try] = ACTIONS(2239),
    [anon_sym_delete] = ACTIONS(2239),
    [anon_sym_throw] = ACTIONS(2239),
    [anon_sym_namespace] = ACTIONS(2239),
    [anon_sym_static_assert] = ACTIONS(2239),
    [anon_sym_concept] = ACTIONS(2239),
    [anon_sym_co_return] = ACTIONS(2239),
    [anon_sym_co_yield] = ACTIONS(2239),
    [anon_sym_R_DQUOTE] = ACTIONS(2241),
    [anon_sym_LR_DQUOTE] = ACTIONS(2241),
    [anon_sym_uR_DQUOTE] = ACTIONS(2241),
    [anon_sym_UR_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2241),
    [anon_sym_co_await] = ACTIONS(2239),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_requires] = ACTIONS(2239),
    [sym_this] = ACTIONS(2239),
    [anon_sym_discard] = ACTIONS(2239),
    [anon_sym_precise] = ACTIONS(2239),
    [anon_sym_shared] = ACTIONS(2239),
    [anon_sym_groupshared] = ACTIONS(2239),
    [anon_sym_uniform] = ACTIONS(2239),
    [anon_sym_row_major] = ACTIONS(2239),
    [anon_sym_column_major] = ACTIONS(2239),
    [anon_sym_globallycoherent] = ACTIONS(2239),
    [anon_sym_centroid] = ACTIONS(2239),
    [anon_sym_noperspective] = ACTIONS(2239),
    [anon_sym_nointerpolation] = ACTIONS(2239),
    [anon_sym_sample] = ACTIONS(2239),
    [anon_sym_linear] = ACTIONS(2239),
    [anon_sym_snorm] = ACTIONS(2239),
    [anon_sym_unorm] = ACTIONS(2239),
    [anon_sym_point] = ACTIONS(2239),
    [anon_sym_line] = ACTIONS(2239),
    [anon_sym_triangleadj] = ACTIONS(2239),
    [anon_sym_lineadj] = ACTIONS(2239),
    [anon_sym_triangle] = ACTIONS(2239),
    [anon_sym_cbuffer] = ACTIONS(2239),
    [anon_sym_interface] = ACTIONS(2239),
    [anon_sym_extension] = ACTIONS(2239),
  },
  [557] = {
    [sym_identifier] = ACTIONS(2280),
    [aux_sym_preproc_include_token1] = ACTIONS(2280),
    [aux_sym_preproc_def_token1] = ACTIONS(2280),
    [aux_sym_preproc_if_token1] = ACTIONS(2280),
    [aux_sym_preproc_if_token2] = ACTIONS(2280),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2280),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2280),
    [sym_preproc_directive] = ACTIONS(2280),
    [anon_sym_LPAREN2] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(2282),
    [anon_sym_TILDE] = ACTIONS(2282),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2282),
    [anon_sym_AMP_AMP] = ACTIONS(2282),
    [anon_sym_AMP] = ACTIONS(2280),
    [anon_sym_COLON] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(2280),
    [anon_sym_typedef] = ACTIONS(2280),
    [anon_sym_in] = ACTIONS(2280),
    [anon_sym_out] = ACTIONS(2280),
    [anon_sym_inout] = ACTIONS(2280),
    [anon_sym_virtual] = ACTIONS(2280),
    [anon_sym_extern] = ACTIONS(2280),
    [anon_sym___attribute__] = ACTIONS(2280),
    [anon_sym___attribute] = ACTIONS(2280),
    [anon_sym_using] = ACTIONS(2280),
    [anon_sym_COLON_COLON] = ACTIONS(2282),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2282),
    [anon_sym___declspec] = ACTIONS(2280),
    [anon_sym___based] = ACTIONS(2280),
    [anon_sym___cdecl] = ACTIONS(2280),
    [anon_sym___clrcall] = ACTIONS(2280),
    [anon_sym___stdcall] = ACTIONS(2280),
    [anon_sym___fastcall] = ACTIONS(2280),
    [anon_sym___thiscall] = ACTIONS(2280),
    [anon_sym___vectorcall] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_signed] = ACTIONS(2280),
    [anon_sym_unsigned] = ACTIONS(2280),
    [anon_sym_long] = ACTIONS(2280),
    [anon_sym_short] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_register] = ACTIONS(2280),
    [anon_sym_inline] = ACTIONS(2280),
    [anon_sym___inline] = ACTIONS(2280),
    [anon_sym___inline__] = ACTIONS(2280),
    [anon_sym___forceinline] = ACTIONS(2280),
    [anon_sym_thread_local] = ACTIONS(2280),
    [anon_sym___thread] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_constexpr] = ACTIONS(2280),
    [anon_sym_volatile] = ACTIONS(2280),
    [anon_sym_restrict] = ACTIONS(2280),
    [anon_sym___restrict__] = ACTIONS(2280),
    [anon_sym__Atomic] = ACTIONS(2280),
    [anon_sym__Noreturn] = ACTIONS(2280),
    [anon_sym_noreturn] = ACTIONS(2280),
    [anon_sym__Nonnull] = ACTIONS(2280),
    [anon_sym_mutable] = ACTIONS(2280),
    [anon_sym_constinit] = ACTIONS(2280),
    [anon_sym_consteval] = ACTIONS(2280),
    [anon_sym_alignas] = ACTIONS(2280),
    [anon_sym__Alignas] = ACTIONS(2280),
    [sym_primitive_type] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_struct] = ACTIONS(2280),
    [anon_sym_union] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_goto] = ACTIONS(2280),
    [anon_sym___try] = ACTIONS(2280),
    [anon_sym___leave] = ACTIONS(2280),
    [anon_sym_not] = ACTIONS(2280),
    [anon_sym_compl] = ACTIONS(2280),
    [anon_sym_DASH_DASH] = ACTIONS(2282),
    [anon_sym_PLUS_PLUS] = ACTIONS(2282),
    [anon_sym_sizeof] = ACTIONS(2280),
    [anon_sym___alignof__] = ACTIONS(2280),
    [anon_sym___alignof] = ACTIONS(2280),
    [anon_sym__alignof] = ACTIONS(2280),
    [anon_sym_alignof] = ACTIONS(2280),
    [anon_sym__Alignof] = ACTIONS(2280),
    [anon_sym_offsetof] = ACTIONS(2280),
    [anon_sym__Generic] = ACTIONS(2280),
    [anon_sym_asm] = ACTIONS(2280),
    [anon_sym___asm__] = ACTIONS(2280),
    [anon_sym___asm] = ACTIONS(2280),
    [sym_number_literal] = ACTIONS(2282),
    [anon_sym_L_SQUOTE] = ACTIONS(2282),
    [anon_sym_u_SQUOTE] = ACTIONS(2282),
    [anon_sym_U_SQUOTE] = ACTIONS(2282),
    [anon_sym_u8_SQUOTE] = ACTIONS(2282),
    [anon_sym_SQUOTE] = ACTIONS(2282),
    [anon_sym_L_DQUOTE] = ACTIONS(2282),
    [anon_sym_u_DQUOTE] = ACTIONS(2282),
    [anon_sym_U_DQUOTE] = ACTIONS(2282),
    [anon_sym_u8_DQUOTE] = ACTIONS(2282),
    [anon_sym_DQUOTE] = ACTIONS(2282),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [anon_sym_NULL] = ACTIONS(2280),
    [anon_sym_nullptr] = ACTIONS(2280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_This] = ACTIONS(2280),
    [anon_sym_decltype] = ACTIONS(2280),
    [anon_sym_final] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_explicit] = ACTIONS(2280),
    [anon_sym_typename] = ACTIONS(2280),
    [anon_sym_template] = ACTIONS(2280),
    [anon_sym_operator] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_static_assert] = ACTIONS(2280),
    [anon_sym_concept] = ACTIONS(2280),
    [anon_sym_co_return] = ACTIONS(2280),
    [anon_sym_co_yield] = ACTIONS(2280),
    [anon_sym_R_DQUOTE] = ACTIONS(2282),
    [anon_sym_LR_DQUOTE] = ACTIONS(2282),
    [anon_sym_uR_DQUOTE] = ACTIONS(2282),
    [anon_sym_UR_DQUOTE] = ACTIONS(2282),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2282),
    [anon_sym_co_await] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_requires] = ACTIONS(2280),
    [sym_this] = ACTIONS(2280),
    [anon_sym_discard] = ACTIONS(2280),
    [anon_sym_precise] = ACTIONS(2280),
    [anon_sym_shared] = ACTIONS(2280),
    [anon_sym_groupshared] = ACTIONS(2280),
    [anon_sym_uniform] = ACTIONS(2280),
    [anon_sym_row_major] = ACTIONS(2280),
    [anon_sym_column_major] = ACTIONS(2280),
    [anon_sym_globallycoherent] = ACTIONS(2280),
    [anon_sym_centroid] = ACTIONS(2280),
    [anon_sym_noperspective] = ACTIONS(2280),
    [anon_sym_nointerpolation] = ACTIONS(2280),
    [anon_sym_sample] = ACTIONS(2280),
    [anon_sym_linear] = ACTIONS(2280),
    [anon_sym_snorm] = ACTIONS(2280),
    [anon_sym_unorm] = ACTIONS(2280),
    [anon_sym_point] = ACTIONS(2280),
    [anon_sym_line] = ACTIONS(2280),
    [anon_sym_triangleadj] = ACTIONS(2280),
    [anon_sym_lineadj] = ACTIONS(2280),
    [anon_sym_triangle] = ACTIONS(2280),
    [anon_sym_cbuffer] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_extension] = ACTIONS(2280),
  },
  [558] = {
    [sym_identifier] = ACTIONS(2284),
    [aux_sym_preproc_include_token1] = ACTIONS(2284),
    [aux_sym_preproc_def_token1] = ACTIONS(2284),
    [aux_sym_preproc_if_token1] = ACTIONS(2284),
    [aux_sym_preproc_if_token2] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2284),
    [sym_preproc_directive] = ACTIONS(2284),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_COLON] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_typedef] = ACTIONS(2284),
    [anon_sym_in] = ACTIONS(2284),
    [anon_sym_out] = ACTIONS(2284),
    [anon_sym_inout] = ACTIONS(2284),
    [anon_sym_virtual] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_using] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym___cdecl] = ACTIONS(2284),
    [anon_sym___clrcall] = ACTIONS(2284),
    [anon_sym___stdcall] = ACTIONS(2284),
    [anon_sym___fastcall] = ACTIONS(2284),
    [anon_sym___thiscall] = ACTIONS(2284),
    [anon_sym___vectorcall] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_signed] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_else] = ACTIONS(2284),
    [anon_sym_switch] = ACTIONS(2284),
    [anon_sym_case] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_goto] = ACTIONS(2284),
    [anon_sym___try] = ACTIONS(2284),
    [anon_sym___leave] = ACTIONS(2284),
    [anon_sym_not] = ACTIONS(2284),
    [anon_sym_compl] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_sizeof] = ACTIONS(2284),
    [anon_sym___alignof__] = ACTIONS(2284),
    [anon_sym___alignof] = ACTIONS(2284),
    [anon_sym__alignof] = ACTIONS(2284),
    [anon_sym_alignof] = ACTIONS(2284),
    [anon_sym__Alignof] = ACTIONS(2284),
    [anon_sym_offsetof] = ACTIONS(2284),
    [anon_sym__Generic] = ACTIONS(2284),
    [anon_sym_asm] = ACTIONS(2284),
    [anon_sym___asm__] = ACTIONS(2284),
    [anon_sym___asm] = ACTIONS(2284),
    [sym_number_literal] = ACTIONS(2286),
    [anon_sym_L_SQUOTE] = ACTIONS(2286),
    [anon_sym_u_SQUOTE] = ACTIONS(2286),
    [anon_sym_U_SQUOTE] = ACTIONS(2286),
    [anon_sym_u8_SQUOTE] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_L_DQUOTE] = ACTIONS(2286),
    [anon_sym_u_DQUOTE] = ACTIONS(2286),
    [anon_sym_U_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8_DQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [sym_true] = ACTIONS(2284),
    [sym_false] = ACTIONS(2284),
    [anon_sym_NULL] = ACTIONS(2284),
    [anon_sym_nullptr] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_This] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [anon_sym_final] = ACTIONS(2284),
    [anon_sym_override] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_typename] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_delete] = ACTIONS(2284),
    [anon_sym_throw] = ACTIONS(2284),
    [anon_sym_namespace] = ACTIONS(2284),
    [anon_sym_static_assert] = ACTIONS(2284),
    [anon_sym_concept] = ACTIONS(2284),
    [anon_sym_co_return] = ACTIONS(2284),
    [anon_sym_co_yield] = ACTIONS(2284),
    [anon_sym_R_DQUOTE] = ACTIONS(2286),
    [anon_sym_LR_DQUOTE] = ACTIONS(2286),
    [anon_sym_uR_DQUOTE] = ACTIONS(2286),
    [anon_sym_UR_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2286),
    [anon_sym_co_await] = ACTIONS(2284),
    [anon_sym_new] = ACTIONS(2284),
    [anon_sym_requires] = ACTIONS(2284),
    [sym_this] = ACTIONS(2284),
    [anon_sym_discard] = ACTIONS(2284),
    [anon_sym_precise] = ACTIONS(2284),
    [anon_sym_shared] = ACTIONS(2284),
    [anon_sym_groupshared] = ACTIONS(2284),
    [anon_sym_uniform] = ACTIONS(2284),
    [anon_sym_row_major] = ACTIONS(2284),
    [anon_sym_column_major] = ACTIONS(2284),
    [anon_sym_globallycoherent] = ACTIONS(2284),
    [anon_sym_centroid] = ACTIONS(2284),
    [anon_sym_noperspective] = ACTIONS(2284),
    [anon_sym_nointerpolation] = ACTIONS(2284),
    [anon_sym_sample] = ACTIONS(2284),
    [anon_sym_linear] = ACTIONS(2284),
    [anon_sym_snorm] = ACTIONS(2284),
    [anon_sym_unorm] = ACTIONS(2284),
    [anon_sym_point] = ACTIONS(2284),
    [anon_sym_line] = ACTIONS(2284),
    [anon_sym_triangleadj] = ACTIONS(2284),
    [anon_sym_lineadj] = ACTIONS(2284),
    [anon_sym_triangle] = ACTIONS(2284),
    [anon_sym_cbuffer] = ACTIONS(2284),
    [anon_sym_interface] = ACTIONS(2284),
    [anon_sym_extension] = ACTIONS(2284),
  },
  [559] = {
    [sym_identifier] = ACTIONS(2288),
    [aux_sym_preproc_include_token1] = ACTIONS(2288),
    [aux_sym_preproc_def_token1] = ACTIONS(2288),
    [aux_sym_preproc_if_token1] = ACTIONS(2288),
    [aux_sym_preproc_if_token2] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_COLON] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_out] = ACTIONS(2288),
    [anon_sym_inout] = ACTIONS(2288),
    [anon_sym_virtual] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym___cdecl] = ACTIONS(2288),
    [anon_sym___clrcall] = ACTIONS(2288),
    [anon_sym___stdcall] = ACTIONS(2288),
    [anon_sym___fastcall] = ACTIONS(2288),
    [anon_sym___thiscall] = ACTIONS(2288),
    [anon_sym___vectorcall] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_signed] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym___try] = ACTIONS(2288),
    [anon_sym___leave] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2288),
    [anon_sym_compl] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_sizeof] = ACTIONS(2288),
    [anon_sym___alignof__] = ACTIONS(2288),
    [anon_sym___alignof] = ACTIONS(2288),
    [anon_sym__alignof] = ACTIONS(2288),
    [anon_sym_alignof] = ACTIONS(2288),
    [anon_sym__Alignof] = ACTIONS(2288),
    [anon_sym_offsetof] = ACTIONS(2288),
    [anon_sym__Generic] = ACTIONS(2288),
    [anon_sym_asm] = ACTIONS(2288),
    [anon_sym___asm__] = ACTIONS(2288),
    [anon_sym___asm] = ACTIONS(2288),
    [sym_number_literal] = ACTIONS(2290),
    [anon_sym_L_SQUOTE] = ACTIONS(2290),
    [anon_sym_u_SQUOTE] = ACTIONS(2290),
    [anon_sym_U_SQUOTE] = ACTIONS(2290),
    [anon_sym_u8_SQUOTE] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [anon_sym_L_DQUOTE] = ACTIONS(2290),
    [anon_sym_u_DQUOTE] = ACTIONS(2290),
    [anon_sym_U_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8_DQUOTE] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [anon_sym_NULL] = ACTIONS(2288),
    [anon_sym_nullptr] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_This] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [anon_sym_final] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_static_assert] = ACTIONS(2288),
    [anon_sym_concept] = ACTIONS(2288),
    [anon_sym_co_return] = ACTIONS(2288),
    [anon_sym_co_yield] = ACTIONS(2288),
    [anon_sym_R_DQUOTE] = ACTIONS(2290),
    [anon_sym_LR_DQUOTE] = ACTIONS(2290),
    [anon_sym_uR_DQUOTE] = ACTIONS(2290),
    [anon_sym_UR_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2290),
    [anon_sym_co_await] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_requires] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [anon_sym_discard] = ACTIONS(2288),
    [anon_sym_precise] = ACTIONS(2288),
    [anon_sym_shared] = ACTIONS(2288),
    [anon_sym_groupshared] = ACTIONS(2288),
    [anon_sym_uniform] = ACTIONS(2288),
    [anon_sym_row_major] = ACTIONS(2288),
    [anon_sym_column_major] = ACTIONS(2288),
    [anon_sym_globallycoherent] = ACTIONS(2288),
    [anon_sym_centroid] = ACTIONS(2288),
    [anon_sym_noperspective] = ACTIONS(2288),
    [anon_sym_nointerpolation] = ACTIONS(2288),
    [anon_sym_sample] = ACTIONS(2288),
    [anon_sym_linear] = ACTIONS(2288),
    [anon_sym_snorm] = ACTIONS(2288),
    [anon_sym_unorm] = ACTIONS(2288),
    [anon_sym_point] = ACTIONS(2288),
    [anon_sym_line] = ACTIONS(2288),
    [anon_sym_triangleadj] = ACTIONS(2288),
    [anon_sym_lineadj] = ACTIONS(2288),
    [anon_sym_triangle] = ACTIONS(2288),
    [anon_sym_cbuffer] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_extension] = ACTIONS(2288),
  },
  [560] = {
    [sym_identifier] = ACTIONS(2292),
    [aux_sym_preproc_include_token1] = ACTIONS(2292),
    [aux_sym_preproc_def_token1] = ACTIONS(2292),
    [aux_sym_preproc_if_token1] = ACTIONS(2292),
    [aux_sym_preproc_if_token2] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2292),
    [sym_preproc_directive] = ACTIONS(2292),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_COLON] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym_typedef] = ACTIONS(2292),
    [anon_sym_in] = ACTIONS(2292),
    [anon_sym_out] = ACTIONS(2292),
    [anon_sym_inout] = ACTIONS(2292),
    [anon_sym_virtual] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym___attribute] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2294),
    [anon_sym___declspec] = ACTIONS(2292),
    [anon_sym___based] = ACTIONS(2292),
    [anon_sym___cdecl] = ACTIONS(2292),
    [anon_sym___clrcall] = ACTIONS(2292),
    [anon_sym___stdcall] = ACTIONS(2292),
    [anon_sym___fastcall] = ACTIONS(2292),
    [anon_sym___thiscall] = ACTIONS(2292),
    [anon_sym___vectorcall] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_signed] = ACTIONS(2292),
    [anon_sym_unsigned] = ACTIONS(2292),
    [anon_sym_long] = ACTIONS(2292),
    [anon_sym_short] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym___inline] = ACTIONS(2292),
    [anon_sym___inline__] = ACTIONS(2292),
    [anon_sym___forceinline] = ACTIONS(2292),
    [anon_sym_thread_local] = ACTIONS(2292),
    [anon_sym___thread] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym__Nonnull] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [sym_primitive_type] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_struct] = ACTIONS(2292),
    [anon_sym_union] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_else] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_case] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_goto] = ACTIONS(2292),
    [anon_sym___try] = ACTIONS(2292),
    [anon_sym___leave] = ACTIONS(2292),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_compl] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_sizeof] = ACTIONS(2292),
    [anon_sym___alignof__] = ACTIONS(2292),
    [anon_sym___alignof] = ACTIONS(2292),
    [anon_sym__alignof] = ACTIONS(2292),
    [anon_sym_alignof] = ACTIONS(2292),
    [anon_sym__Alignof] = ACTIONS(2292),
    [anon_sym_offsetof] = ACTIONS(2292),
    [anon_sym__Generic] = ACTIONS(2292),
    [anon_sym_asm] = ACTIONS(2292),
    [anon_sym___asm__] = ACTIONS(2292),
    [anon_sym___asm] = ACTIONS(2292),
    [sym_number_literal] = ACTIONS(2294),
    [anon_sym_L_SQUOTE] = ACTIONS(2294),
    [anon_sym_u_SQUOTE] = ACTIONS(2294),
    [anon_sym_U_SQUOTE] = ACTIONS(2294),
    [anon_sym_u8_SQUOTE] = ACTIONS(2294),
    [anon_sym_SQUOTE] = ACTIONS(2294),
    [anon_sym_L_DQUOTE] = ACTIONS(2294),
    [anon_sym_u_DQUOTE] = ACTIONS(2294),
    [anon_sym_U_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8_DQUOTE] = ACTIONS(2294),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [anon_sym_NULL] = ACTIONS(2292),
    [anon_sym_nullptr] = ACTIONS(2292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_This] = ACTIONS(2292),
    [anon_sym_decltype] = ACTIONS(2292),
    [anon_sym_final] = ACTIONS(2292),
    [anon_sym_override] = ACTIONS(2292),
    [anon_sym_explicit] = ACTIONS(2292),
    [anon_sym_typename] = ACTIONS(2292),
    [anon_sym_template] = ACTIONS(2292),
    [anon_sym_operator] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_static_assert] = ACTIONS(2292),
    [anon_sym_concept] = ACTIONS(2292),
    [anon_sym_co_return] = ACTIONS(2292),
    [anon_sym_co_yield] = ACTIONS(2292),
    [anon_sym_R_DQUOTE] = ACTIONS(2294),
    [anon_sym_LR_DQUOTE] = ACTIONS(2294),
    [anon_sym_uR_DQUOTE] = ACTIONS(2294),
    [anon_sym_UR_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2294),
    [anon_sym_co_await] = ACTIONS(2292),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_requires] = ACTIONS(2292),
    [sym_this] = ACTIONS(2292),
    [anon_sym_discard] = ACTIONS(2292),
    [anon_sym_precise] = ACTIONS(2292),
    [anon_sym_shared] = ACTIONS(2292),
    [anon_sym_groupshared] = ACTIONS(2292),
    [anon_sym_uniform] = ACTIONS(2292),
    [anon_sym_row_major] = ACTIONS(2292),
    [anon_sym_column_major] = ACTIONS(2292),
    [anon_sym_globallycoherent] = ACTIONS(2292),
    [anon_sym_centroid] = ACTIONS(2292),
    [anon_sym_noperspective] = ACTIONS(2292),
    [anon_sym_nointerpolation] = ACTIONS(2292),
    [anon_sym_sample] = ACTIONS(2292),
    [anon_sym_linear] = ACTIONS(2292),
    [anon_sym_snorm] = ACTIONS(2292),
    [anon_sym_unorm] = ACTIONS(2292),
    [anon_sym_point] = ACTIONS(2292),
    [anon_sym_line] = ACTIONS(2292),
    [anon_sym_triangleadj] = ACTIONS(2292),
    [anon_sym_lineadj] = ACTIONS(2292),
    [anon_sym_triangle] = ACTIONS(2292),
    [anon_sym_cbuffer] = ACTIONS(2292),
    [anon_sym_interface] = ACTIONS(2292),
    [anon_sym_extension] = ACTIONS(2292),
  },
  [561] = {
    [sym_identifier] = ACTIONS(2296),
    [aux_sym_preproc_include_token1] = ACTIONS(2296),
    [aux_sym_preproc_def_token1] = ACTIONS(2296),
    [aux_sym_preproc_if_token1] = ACTIONS(2296),
    [aux_sym_preproc_if_token2] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2296),
    [sym_preproc_directive] = ACTIONS(2296),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_BANG] = ACTIONS(2298),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_COLON] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2298),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym_typedef] = ACTIONS(2296),
    [anon_sym_in] = ACTIONS(2296),
    [anon_sym_out] = ACTIONS(2296),
    [anon_sym_inout] = ACTIONS(2296),
    [anon_sym_virtual] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym___attribute] = ACTIONS(2296),
    [anon_sym_using] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2298),
    [anon_sym___declspec] = ACTIONS(2296),
    [anon_sym___based] = ACTIONS(2296),
    [anon_sym___cdecl] = ACTIONS(2296),
    [anon_sym___clrcall] = ACTIONS(2296),
    [anon_sym___stdcall] = ACTIONS(2296),
    [anon_sym___fastcall] = ACTIONS(2296),
    [anon_sym___thiscall] = ACTIONS(2296),
    [anon_sym___vectorcall] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_signed] = ACTIONS(2296),
    [anon_sym_unsigned] = ACTIONS(2296),
    [anon_sym_long] = ACTIONS(2296),
    [anon_sym_short] = ACTIONS(2296),
    [anon_sym_LBRACK] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_register] = ACTIONS(2296),
    [anon_sym_inline] = ACTIONS(2296),
    [anon_sym___inline] = ACTIONS(2296),
    [anon_sym___inline__] = ACTIONS(2296),
    [anon_sym___forceinline] = ACTIONS(2296),
    [anon_sym_thread_local] = ACTIONS(2296),
    [anon_sym___thread] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym__Nonnull] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [sym_primitive_type] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2296),
    [anon_sym_class] = ACTIONS(2296),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_union] = ACTIONS(2296),
    [anon_sym_if] = ACTIONS(2296),
    [anon_sym_else] = ACTIONS(2296),
    [anon_sym_switch] = ACTIONS(2296),
    [anon_sym_case] = ACTIONS(2296),
    [anon_sym_default] = ACTIONS(2296),
    [anon_sym_while] = ACTIONS(2296),
    [anon_sym_do] = ACTIONS(2296),
    [anon_sym_for] = ACTIONS(2296),
    [anon_sym_return] = ACTIONS(2296),
    [anon_sym_break] = ACTIONS(2296),
    [anon_sym_continue] = ACTIONS(2296),
    [anon_sym_goto] = ACTIONS(2296),
    [anon_sym___try] = ACTIONS(2296),
    [anon_sym___leave] = ACTIONS(2296),
    [anon_sym_not] = ACTIONS(2296),
    [anon_sym_compl] = ACTIONS(2296),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_sizeof] = ACTIONS(2296),
    [anon_sym___alignof__] = ACTIONS(2296),
    [anon_sym___alignof] = ACTIONS(2296),
    [anon_sym__alignof] = ACTIONS(2296),
    [anon_sym_alignof] = ACTIONS(2296),
    [anon_sym__Alignof] = ACTIONS(2296),
    [anon_sym_offsetof] = ACTIONS(2296),
    [anon_sym__Generic] = ACTIONS(2296),
    [anon_sym_asm] = ACTIONS(2296),
    [anon_sym___asm__] = ACTIONS(2296),
    [anon_sym___asm] = ACTIONS(2296),
    [sym_number_literal] = ACTIONS(2298),
    [anon_sym_L_SQUOTE] = ACTIONS(2298),
    [anon_sym_u_SQUOTE] = ACTIONS(2298),
    [anon_sym_U_SQUOTE] = ACTIONS(2298),
    [anon_sym_u8_SQUOTE] = ACTIONS(2298),
    [anon_sym_SQUOTE] = ACTIONS(2298),
    [anon_sym_L_DQUOTE] = ACTIONS(2298),
    [anon_sym_u_DQUOTE] = ACTIONS(2298),
    [anon_sym_U_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8_DQUOTE] = ACTIONS(2298),
    [anon_sym_DQUOTE] = ACTIONS(2298),
    [sym_true] = ACTIONS(2296),
    [sym_false] = ACTIONS(2296),
    [anon_sym_NULL] = ACTIONS(2296),
    [anon_sym_nullptr] = ACTIONS(2296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_This] = ACTIONS(2296),
    [anon_sym_decltype] = ACTIONS(2296),
    [anon_sym_final] = ACTIONS(2296),
    [anon_sym_override] = ACTIONS(2296),
    [anon_sym_explicit] = ACTIONS(2296),
    [anon_sym_typename] = ACTIONS(2296),
    [anon_sym_template] = ACTIONS(2296),
    [anon_sym_operator] = ACTIONS(2296),
    [anon_sym_try] = ACTIONS(2296),
    [anon_sym_delete] = ACTIONS(2296),
    [anon_sym_throw] = ACTIONS(2296),
    [anon_sym_namespace] = ACTIONS(2296),
    [anon_sym_static_assert] = ACTIONS(2296),
    [anon_sym_concept] = ACTIONS(2296),
    [anon_sym_co_return] = ACTIONS(2296),
    [anon_sym_co_yield] = ACTIONS(2296),
    [anon_sym_R_DQUOTE] = ACTIONS(2298),
    [anon_sym_LR_DQUOTE] = ACTIONS(2298),
    [anon_sym_uR_DQUOTE] = ACTIONS(2298),
    [anon_sym_UR_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2298),
    [anon_sym_co_await] = ACTIONS(2296),
    [anon_sym_new] = ACTIONS(2296),
    [anon_sym_requires] = ACTIONS(2296),
    [sym_this] = ACTIONS(2296),
    [anon_sym_discard] = ACTIONS(2296),
    [anon_sym_precise] = ACTIONS(2296),
    [anon_sym_shared] = ACTIONS(2296),
    [anon_sym_groupshared] = ACTIONS(2296),
    [anon_sym_uniform] = ACTIONS(2296),
    [anon_sym_row_major] = ACTIONS(2296),
    [anon_sym_column_major] = ACTIONS(2296),
    [anon_sym_globallycoherent] = ACTIONS(2296),
    [anon_sym_centroid] = ACTIONS(2296),
    [anon_sym_noperspective] = ACTIONS(2296),
    [anon_sym_nointerpolation] = ACTIONS(2296),
    [anon_sym_sample] = ACTIONS(2296),
    [anon_sym_linear] = ACTIONS(2296),
    [anon_sym_snorm] = ACTIONS(2296),
    [anon_sym_unorm] = ACTIONS(2296),
    [anon_sym_point] = ACTIONS(2296),
    [anon_sym_line] = ACTIONS(2296),
    [anon_sym_triangleadj] = ACTIONS(2296),
    [anon_sym_lineadj] = ACTIONS(2296),
    [anon_sym_triangle] = ACTIONS(2296),
    [anon_sym_cbuffer] = ACTIONS(2296),
    [anon_sym_interface] = ACTIONS(2296),
    [anon_sym_extension] = ACTIONS(2296),
  },
  [562] = {
    [sym_identifier] = ACTIONS(2264),
    [aux_sym_preproc_include_token1] = ACTIONS(2264),
    [aux_sym_preproc_def_token1] = ACTIONS(2264),
    [aux_sym_preproc_if_token1] = ACTIONS(2264),
    [aux_sym_preproc_if_token2] = ACTIONS(2264),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2264),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2264),
    [sym_preproc_directive] = ACTIONS(2264),
    [anon_sym_LPAREN2] = ACTIONS(2266),
    [anon_sym_BANG] = ACTIONS(2266),
    [anon_sym_TILDE] = ACTIONS(2266),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2266),
    [anon_sym_AMP] = ACTIONS(2264),
    [anon_sym_COLON] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2266),
    [anon_sym___extension__] = ACTIONS(2264),
    [anon_sym_typedef] = ACTIONS(2264),
    [anon_sym_in] = ACTIONS(2264),
    [anon_sym_out] = ACTIONS(2264),
    [anon_sym_inout] = ACTIONS(2264),
    [anon_sym_virtual] = ACTIONS(2264),
    [anon_sym_extern] = ACTIONS(2264),
    [anon_sym___attribute__] = ACTIONS(2264),
    [anon_sym___attribute] = ACTIONS(2264),
    [anon_sym_using] = ACTIONS(2264),
    [anon_sym_COLON_COLON] = ACTIONS(2266),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2266),
    [anon_sym___declspec] = ACTIONS(2264),
    [anon_sym___based] = ACTIONS(2264),
    [anon_sym___cdecl] = ACTIONS(2264),
    [anon_sym___clrcall] = ACTIONS(2264),
    [anon_sym___stdcall] = ACTIONS(2264),
    [anon_sym___fastcall] = ACTIONS(2264),
    [anon_sym___thiscall] = ACTIONS(2264),
    [anon_sym___vectorcall] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_signed] = ACTIONS(2264),
    [anon_sym_unsigned] = ACTIONS(2264),
    [anon_sym_long] = ACTIONS(2264),
    [anon_sym_short] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_register] = ACTIONS(2264),
    [anon_sym_inline] = ACTIONS(2264),
    [anon_sym___inline] = ACTIONS(2264),
    [anon_sym___inline__] = ACTIONS(2264),
    [anon_sym___forceinline] = ACTIONS(2264),
    [anon_sym_thread_local] = ACTIONS(2264),
    [anon_sym___thread] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_constexpr] = ACTIONS(2264),
    [anon_sym_volatile] = ACTIONS(2264),
    [anon_sym_restrict] = ACTIONS(2264),
    [anon_sym___restrict__] = ACTIONS(2264),
    [anon_sym__Atomic] = ACTIONS(2264),
    [anon_sym__Noreturn] = ACTIONS(2264),
    [anon_sym_noreturn] = ACTIONS(2264),
    [anon_sym__Nonnull] = ACTIONS(2264),
    [anon_sym_mutable] = ACTIONS(2264),
    [anon_sym_constinit] = ACTIONS(2264),
    [anon_sym_consteval] = ACTIONS(2264),
    [anon_sym_alignas] = ACTIONS(2264),
    [anon_sym__Alignas] = ACTIONS(2264),
    [sym_primitive_type] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
    [anon_sym_class] = ACTIONS(2264),
    [anon_sym_struct] = ACTIONS(2264),
    [anon_sym_union] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_else] = ACTIONS(2264),
    [anon_sym_switch] = ACTIONS(2264),
    [anon_sym_case] = ACTIONS(2264),
    [anon_sym_default] = ACTIONS(2264),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_do] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_goto] = ACTIONS(2264),
    [anon_sym___try] = ACTIONS(2264),
    [anon_sym___leave] = ACTIONS(2264),
    [anon_sym_not] = ACTIONS(2264),
    [anon_sym_compl] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2266),
    [anon_sym_PLUS_PLUS] = ACTIONS(2266),
    [anon_sym_sizeof] = ACTIONS(2264),
    [anon_sym___alignof__] = ACTIONS(2264),
    [anon_sym___alignof] = ACTIONS(2264),
    [anon_sym__alignof] = ACTIONS(2264),
    [anon_sym_alignof] = ACTIONS(2264),
    [anon_sym__Alignof] = ACTIONS(2264),
    [anon_sym_offsetof] = ACTIONS(2264),
    [anon_sym__Generic] = ACTIONS(2264),
    [anon_sym_asm] = ACTIONS(2264),
    [anon_sym___asm__] = ACTIONS(2264),
    [anon_sym___asm] = ACTIONS(2264),
    [sym_number_literal] = ACTIONS(2266),
    [anon_sym_L_SQUOTE] = ACTIONS(2266),
    [anon_sym_u_SQUOTE] = ACTIONS(2266),
    [anon_sym_U_SQUOTE] = ACTIONS(2266),
    [anon_sym_u8_SQUOTE] = ACTIONS(2266),
    [anon_sym_SQUOTE] = ACTIONS(2266),
    [anon_sym_L_DQUOTE] = ACTIONS(2266),
    [anon_sym_u_DQUOTE] = ACTIONS(2266),
    [anon_sym_U_DQUOTE] = ACTIONS(2266),
    [anon_sym_u8_DQUOTE] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(2266),
    [sym_true] = ACTIONS(2264),
    [sym_false] = ACTIONS(2264),
    [anon_sym_NULL] = ACTIONS(2264),
    [anon_sym_nullptr] = ACTIONS(2264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_This] = ACTIONS(2264),
    [anon_sym_decltype] = ACTIONS(2264),
    [anon_sym_final] = ACTIONS(2264),
    [anon_sym_override] = ACTIONS(2264),
    [anon_sym_explicit] = ACTIONS(2264),
    [anon_sym_typename] = ACTIONS(2264),
    [anon_sym_template] = ACTIONS(2264),
    [anon_sym_operator] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [anon_sym_delete] = ACTIONS(2264),
    [anon_sym_throw] = ACTIONS(2264),
    [anon_sym_namespace] = ACTIONS(2264),
    [anon_sym_static_assert] = ACTIONS(2264),
    [anon_sym_concept] = ACTIONS(2264),
    [anon_sym_co_return] = ACTIONS(2264),
    [anon_sym_co_yield] = ACTIONS(2264),
    [anon_sym_R_DQUOTE] = ACTIONS(2266),
    [anon_sym_LR_DQUOTE] = ACTIONS(2266),
    [anon_sym_uR_DQUOTE] = ACTIONS(2266),
    [anon_sym_UR_DQUOTE] = ACTIONS(2266),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2266),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2264),
    [anon_sym_requires] = ACTIONS(2264),
    [sym_this] = ACTIONS(2264),
    [anon_sym_discard] = ACTIONS(2264),
    [anon_sym_precise] = ACTIONS(2264),
    [anon_sym_shared] = ACTIONS(2264),
    [anon_sym_groupshared] = ACTIONS(2264),
    [anon_sym_uniform] = ACTIONS(2264),
    [anon_sym_row_major] = ACTIONS(2264),
    [anon_sym_column_major] = ACTIONS(2264),
    [anon_sym_globallycoherent] = ACTIONS(2264),
    [anon_sym_centroid] = ACTIONS(2264),
    [anon_sym_noperspective] = ACTIONS(2264),
    [anon_sym_nointerpolation] = ACTIONS(2264),
    [anon_sym_sample] = ACTIONS(2264),
    [anon_sym_linear] = ACTIONS(2264),
    [anon_sym_snorm] = ACTIONS(2264),
    [anon_sym_unorm] = ACTIONS(2264),
    [anon_sym_point] = ACTIONS(2264),
    [anon_sym_line] = ACTIONS(2264),
    [anon_sym_triangleadj] = ACTIONS(2264),
    [anon_sym_lineadj] = ACTIONS(2264),
    [anon_sym_triangle] = ACTIONS(2264),
    [anon_sym_cbuffer] = ACTIONS(2264),
    [anon_sym_interface] = ACTIONS(2264),
    [anon_sym_extension] = ACTIONS(2264),
  },
  [563] = {
    [sym_identifier] = ACTIONS(2300),
    [aux_sym_preproc_include_token1] = ACTIONS(2300),
    [aux_sym_preproc_def_token1] = ACTIONS(2300),
    [aux_sym_preproc_if_token1] = ACTIONS(2300),
    [aux_sym_preproc_if_token2] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2300),
    [sym_preproc_directive] = ACTIONS(2300),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_BANG] = ACTIONS(2302),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_COLON] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym_typedef] = ACTIONS(2300),
    [anon_sym_in] = ACTIONS(2300),
    [anon_sym_out] = ACTIONS(2300),
    [anon_sym_inout] = ACTIONS(2300),
    [anon_sym_virtual] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym___attribute] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2302),
    [anon_sym___declspec] = ACTIONS(2300),
    [anon_sym___based] = ACTIONS(2300),
    [anon_sym___cdecl] = ACTIONS(2300),
    [anon_sym___clrcall] = ACTIONS(2300),
    [anon_sym___stdcall] = ACTIONS(2300),
    [anon_sym___fastcall] = ACTIONS(2300),
    [anon_sym___thiscall] = ACTIONS(2300),
    [anon_sym___vectorcall] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_signed] = ACTIONS(2300),
    [anon_sym_unsigned] = ACTIONS(2300),
    [anon_sym_long] = ACTIONS(2300),
    [anon_sym_short] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_register] = ACTIONS(2300),
    [anon_sym_inline] = ACTIONS(2300),
    [anon_sym___inline] = ACTIONS(2300),
    [anon_sym___inline__] = ACTIONS(2300),
    [anon_sym___forceinline] = ACTIONS(2300),
    [anon_sym_thread_local] = ACTIONS(2300),
    [anon_sym___thread] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym__Nonnull] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [sym_primitive_type] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_struct] = ACTIONS(2300),
    [anon_sym_union] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_else] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_case] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_goto] = ACTIONS(2300),
    [anon_sym___try] = ACTIONS(2300),
    [anon_sym___leave] = ACTIONS(2300),
    [anon_sym_not] = ACTIONS(2300),
    [anon_sym_compl] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_sizeof] = ACTIONS(2300),
    [anon_sym___alignof__] = ACTIONS(2300),
    [anon_sym___alignof] = ACTIONS(2300),
    [anon_sym__alignof] = ACTIONS(2300),
    [anon_sym_alignof] = ACTIONS(2300),
    [anon_sym__Alignof] = ACTIONS(2300),
    [anon_sym_offsetof] = ACTIONS(2300),
    [anon_sym__Generic] = ACTIONS(2300),
    [anon_sym_asm] = ACTIONS(2300),
    [anon_sym___asm__] = ACTIONS(2300),
    [anon_sym___asm] = ACTIONS(2300),
    [sym_number_literal] = ACTIONS(2302),
    [anon_sym_L_SQUOTE] = ACTIONS(2302),
    [anon_sym_u_SQUOTE] = ACTIONS(2302),
    [anon_sym_U_SQUOTE] = ACTIONS(2302),
    [anon_sym_u8_SQUOTE] = ACTIONS(2302),
    [anon_sym_SQUOTE] = ACTIONS(2302),
    [anon_sym_L_DQUOTE] = ACTIONS(2302),
    [anon_sym_u_DQUOTE] = ACTIONS(2302),
    [anon_sym_U_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8_DQUOTE] = ACTIONS(2302),
    [anon_sym_DQUOTE] = ACTIONS(2302),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [anon_sym_NULL] = ACTIONS(2300),
    [anon_sym_nullptr] = ACTIONS(2300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_This] = ACTIONS(2300),
    [anon_sym_decltype] = ACTIONS(2300),
    [anon_sym_final] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_explicit] = ACTIONS(2300),
    [anon_sym_typename] = ACTIONS(2300),
    [anon_sym_template] = ACTIONS(2300),
    [anon_sym_operator] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_static_assert] = ACTIONS(2300),
    [anon_sym_concept] = ACTIONS(2300),
    [anon_sym_co_return] = ACTIONS(2300),
    [anon_sym_co_yield] = ACTIONS(2300),
    [anon_sym_R_DQUOTE] = ACTIONS(2302),
    [anon_sym_LR_DQUOTE] = ACTIONS(2302),
    [anon_sym_uR_DQUOTE] = ACTIONS(2302),
    [anon_sym_UR_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2302),
    [anon_sym_co_await] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_requires] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [anon_sym_discard] = ACTIONS(2300),
    [anon_sym_precise] = ACTIONS(2300),
    [anon_sym_shared] = ACTIONS(2300),
    [anon_sym_groupshared] = ACTIONS(2300),
    [anon_sym_uniform] = ACTIONS(2300),
    [anon_sym_row_major] = ACTIONS(2300),
    [anon_sym_column_major] = ACTIONS(2300),
    [anon_sym_globallycoherent] = ACTIONS(2300),
    [anon_sym_centroid] = ACTIONS(2300),
    [anon_sym_noperspective] = ACTIONS(2300),
    [anon_sym_nointerpolation] = ACTIONS(2300),
    [anon_sym_sample] = ACTIONS(2300),
    [anon_sym_linear] = ACTIONS(2300),
    [anon_sym_snorm] = ACTIONS(2300),
    [anon_sym_unorm] = ACTIONS(2300),
    [anon_sym_point] = ACTIONS(2300),
    [anon_sym_line] = ACTIONS(2300),
    [anon_sym_triangleadj] = ACTIONS(2300),
    [anon_sym_lineadj] = ACTIONS(2300),
    [anon_sym_triangle] = ACTIONS(2300),
    [anon_sym_cbuffer] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_extension] = ACTIONS(2300),
  },
  [564] = {
    [sym_identifier] = ACTIONS(2260),
    [aux_sym_preproc_include_token1] = ACTIONS(2260),
    [aux_sym_preproc_def_token1] = ACTIONS(2260),
    [aux_sym_preproc_if_token1] = ACTIONS(2260),
    [aux_sym_preproc_if_token2] = ACTIONS(2260),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2260),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2260),
    [sym_preproc_directive] = ACTIONS(2260),
    [anon_sym_LPAREN2] = ACTIONS(2262),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2262),
    [anon_sym_AMP_AMP] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_COLON] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym___extension__] = ACTIONS(2260),
    [anon_sym_typedef] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(2260),
    [anon_sym_out] = ACTIONS(2260),
    [anon_sym_inout] = ACTIONS(2260),
    [anon_sym_virtual] = ACTIONS(2260),
    [anon_sym_extern] = ACTIONS(2260),
    [anon_sym___attribute__] = ACTIONS(2260),
    [anon_sym___attribute] = ACTIONS(2260),
    [anon_sym_using] = ACTIONS(2260),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2262),
    [anon_sym___declspec] = ACTIONS(2260),
    [anon_sym___based] = ACTIONS(2260),
    [anon_sym___cdecl] = ACTIONS(2260),
    [anon_sym___clrcall] = ACTIONS(2260),
    [anon_sym___stdcall] = ACTIONS(2260),
    [anon_sym___fastcall] = ACTIONS(2260),
    [anon_sym___thiscall] = ACTIONS(2260),
    [anon_sym___vectorcall] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_signed] = ACTIONS(2260),
    [anon_sym_unsigned] = ACTIONS(2260),
    [anon_sym_long] = ACTIONS(2260),
    [anon_sym_short] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_register] = ACTIONS(2260),
    [anon_sym_inline] = ACTIONS(2260),
    [anon_sym___inline] = ACTIONS(2260),
    [anon_sym___inline__] = ACTIONS(2260),
    [anon_sym___forceinline] = ACTIONS(2260),
    [anon_sym_thread_local] = ACTIONS(2260),
    [anon_sym___thread] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_constexpr] = ACTIONS(2260),
    [anon_sym_volatile] = ACTIONS(2260),
    [anon_sym_restrict] = ACTIONS(2260),
    [anon_sym___restrict__] = ACTIONS(2260),
    [anon_sym__Atomic] = ACTIONS(2260),
    [anon_sym__Noreturn] = ACTIONS(2260),
    [anon_sym_noreturn] = ACTIONS(2260),
    [anon_sym__Nonnull] = ACTIONS(2260),
    [anon_sym_mutable] = ACTIONS(2260),
    [anon_sym_constinit] = ACTIONS(2260),
    [anon_sym_consteval] = ACTIONS(2260),
    [anon_sym_alignas] = ACTIONS(2260),
    [anon_sym__Alignas] = ACTIONS(2260),
    [sym_primitive_type] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
    [anon_sym_class] = ACTIONS(2260),
    [anon_sym_struct] = ACTIONS(2260),
    [anon_sym_union] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_else] = ACTIONS(2260),
    [anon_sym_switch] = ACTIONS(2260),
    [anon_sym_case] = ACTIONS(2260),
    [anon_sym_default] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_do] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_goto] = ACTIONS(2260),
    [anon_sym___try] = ACTIONS(2260),
    [anon_sym___leave] = ACTIONS(2260),
    [anon_sym_not] = ACTIONS(2260),
    [anon_sym_compl] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_sizeof] = ACTIONS(2260),
    [anon_sym___alignof__] = ACTIONS(2260),
    [anon_sym___alignof] = ACTIONS(2260),
    [anon_sym__alignof] = ACTIONS(2260),
    [anon_sym_alignof] = ACTIONS(2260),
    [anon_sym__Alignof] = ACTIONS(2260),
    [anon_sym_offsetof] = ACTIONS(2260),
    [anon_sym__Generic] = ACTIONS(2260),
    [anon_sym_asm] = ACTIONS(2260),
    [anon_sym___asm__] = ACTIONS(2260),
    [anon_sym___asm] = ACTIONS(2260),
    [sym_number_literal] = ACTIONS(2262),
    [anon_sym_L_SQUOTE] = ACTIONS(2262),
    [anon_sym_u_SQUOTE] = ACTIONS(2262),
    [anon_sym_U_SQUOTE] = ACTIONS(2262),
    [anon_sym_u8_SQUOTE] = ACTIONS(2262),
    [anon_sym_SQUOTE] = ACTIONS(2262),
    [anon_sym_L_DQUOTE] = ACTIONS(2262),
    [anon_sym_u_DQUOTE] = ACTIONS(2262),
    [anon_sym_U_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8_DQUOTE] = ACTIONS(2262),
    [anon_sym_DQUOTE] = ACTIONS(2262),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [anon_sym_NULL] = ACTIONS(2260),
    [anon_sym_nullptr] = ACTIONS(2260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_This] = ACTIONS(2260),
    [anon_sym_decltype] = ACTIONS(2260),
    [anon_sym_final] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
    [anon_sym_explicit] = ACTIONS(2260),
    [anon_sym_typename] = ACTIONS(2260),
    [anon_sym_template] = ACTIONS(2260),
    [anon_sym_operator] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_throw] = ACTIONS(2260),
    [anon_sym_namespace] = ACTIONS(2260),
    [anon_sym_static_assert] = ACTIONS(2260),
    [anon_sym_concept] = ACTIONS(2260),
    [anon_sym_co_return] = ACTIONS(2260),
    [anon_sym_co_yield] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2260),
    [anon_sym_new] = ACTIONS(2260),
    [anon_sym_requires] = ACTIONS(2260),
    [sym_this] = ACTIONS(2260),
    [anon_sym_discard] = ACTIONS(2260),
    [anon_sym_precise] = ACTIONS(2260),
    [anon_sym_shared] = ACTIONS(2260),
    [anon_sym_groupshared] = ACTIONS(2260),
    [anon_sym_uniform] = ACTIONS(2260),
    [anon_sym_row_major] = ACTIONS(2260),
    [anon_sym_column_major] = ACTIONS(2260),
    [anon_sym_globallycoherent] = ACTIONS(2260),
    [anon_sym_centroid] = ACTIONS(2260),
    [anon_sym_noperspective] = ACTIONS(2260),
    [anon_sym_nointerpolation] = ACTIONS(2260),
    [anon_sym_sample] = ACTIONS(2260),
    [anon_sym_linear] = ACTIONS(2260),
    [anon_sym_snorm] = ACTIONS(2260),
    [anon_sym_unorm] = ACTIONS(2260),
    [anon_sym_point] = ACTIONS(2260),
    [anon_sym_line] = ACTIONS(2260),
    [anon_sym_triangleadj] = ACTIONS(2260),
    [anon_sym_lineadj] = ACTIONS(2260),
    [anon_sym_triangle] = ACTIONS(2260),
    [anon_sym_cbuffer] = ACTIONS(2260),
    [anon_sym_interface] = ACTIONS(2260),
    [anon_sym_extension] = ACTIONS(2260),
  },
  [565] = {
    [sym_identifier] = ACTIONS(2304),
    [aux_sym_preproc_include_token1] = ACTIONS(2304),
    [aux_sym_preproc_def_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token2] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2304),
    [sym_preproc_directive] = ACTIONS(2304),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_BANG] = ACTIONS(2306),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_COLON] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2306),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym_typedef] = ACTIONS(2304),
    [anon_sym_in] = ACTIONS(2304),
    [anon_sym_out] = ACTIONS(2304),
    [anon_sym_inout] = ACTIONS(2304),
    [anon_sym_virtual] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym___attribute] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2306),
    [anon_sym___declspec] = ACTIONS(2304),
    [anon_sym___based] = ACTIONS(2304),
    [anon_sym___cdecl] = ACTIONS(2304),
    [anon_sym___clrcall] = ACTIONS(2304),
    [anon_sym___stdcall] = ACTIONS(2304),
    [anon_sym___fastcall] = ACTIONS(2304),
    [anon_sym___thiscall] = ACTIONS(2304),
    [anon_sym___vectorcall] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_signed] = ACTIONS(2304),
    [anon_sym_unsigned] = ACTIONS(2304),
    [anon_sym_long] = ACTIONS(2304),
    [anon_sym_short] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_register] = ACTIONS(2304),
    [anon_sym_inline] = ACTIONS(2304),
    [anon_sym___inline] = ACTIONS(2304),
    [anon_sym___inline__] = ACTIONS(2304),
    [anon_sym___forceinline] = ACTIONS(2304),
    [anon_sym_thread_local] = ACTIONS(2304),
    [anon_sym___thread] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym__Nonnull] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [sym_primitive_type] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_struct] = ACTIONS(2304),
    [anon_sym_union] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_else] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_case] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_goto] = ACTIONS(2304),
    [anon_sym___try] = ACTIONS(2304),
    [anon_sym___leave] = ACTIONS(2304),
    [anon_sym_not] = ACTIONS(2304),
    [anon_sym_compl] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_sizeof] = ACTIONS(2304),
    [anon_sym___alignof__] = ACTIONS(2304),
    [anon_sym___alignof] = ACTIONS(2304),
    [anon_sym__alignof] = ACTIONS(2304),
    [anon_sym_alignof] = ACTIONS(2304),
    [anon_sym__Alignof] = ACTIONS(2304),
    [anon_sym_offsetof] = ACTIONS(2304),
    [anon_sym__Generic] = ACTIONS(2304),
    [anon_sym_asm] = ACTIONS(2304),
    [anon_sym___asm__] = ACTIONS(2304),
    [anon_sym___asm] = ACTIONS(2304),
    [sym_number_literal] = ACTIONS(2306),
    [anon_sym_L_SQUOTE] = ACTIONS(2306),
    [anon_sym_u_SQUOTE] = ACTIONS(2306),
    [anon_sym_U_SQUOTE] = ACTIONS(2306),
    [anon_sym_u8_SQUOTE] = ACTIONS(2306),
    [anon_sym_SQUOTE] = ACTIONS(2306),
    [anon_sym_L_DQUOTE] = ACTIONS(2306),
    [anon_sym_u_DQUOTE] = ACTIONS(2306),
    [anon_sym_U_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8_DQUOTE] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [anon_sym_NULL] = ACTIONS(2304),
    [anon_sym_nullptr] = ACTIONS(2304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_This] = ACTIONS(2304),
    [anon_sym_decltype] = ACTIONS(2304),
    [anon_sym_final] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_explicit] = ACTIONS(2304),
    [anon_sym_typename] = ACTIONS(2304),
    [anon_sym_template] = ACTIONS(2304),
    [anon_sym_operator] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_static_assert] = ACTIONS(2304),
    [anon_sym_concept] = ACTIONS(2304),
    [anon_sym_co_return] = ACTIONS(2304),
    [anon_sym_co_yield] = ACTIONS(2304),
    [anon_sym_R_DQUOTE] = ACTIONS(2306),
    [anon_sym_LR_DQUOTE] = ACTIONS(2306),
    [anon_sym_uR_DQUOTE] = ACTIONS(2306),
    [anon_sym_UR_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2306),
    [anon_sym_co_await] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_requires] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [anon_sym_discard] = ACTIONS(2304),
    [anon_sym_precise] = ACTIONS(2304),
    [anon_sym_shared] = ACTIONS(2304),
    [anon_sym_groupshared] = ACTIONS(2304),
    [anon_sym_uniform] = ACTIONS(2304),
    [anon_sym_row_major] = ACTIONS(2304),
    [anon_sym_column_major] = ACTIONS(2304),
    [anon_sym_globallycoherent] = ACTIONS(2304),
    [anon_sym_centroid] = ACTIONS(2304),
    [anon_sym_noperspective] = ACTIONS(2304),
    [anon_sym_nointerpolation] = ACTIONS(2304),
    [anon_sym_sample] = ACTIONS(2304),
    [anon_sym_linear] = ACTIONS(2304),
    [anon_sym_snorm] = ACTIONS(2304),
    [anon_sym_unorm] = ACTIONS(2304),
    [anon_sym_point] = ACTIONS(2304),
    [anon_sym_line] = ACTIONS(2304),
    [anon_sym_triangleadj] = ACTIONS(2304),
    [anon_sym_lineadj] = ACTIONS(2304),
    [anon_sym_triangle] = ACTIONS(2304),
    [anon_sym_cbuffer] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_extension] = ACTIONS(2304),
  },
  [566] = {
    [sym_identifier] = ACTIONS(2308),
    [aux_sym_preproc_include_token1] = ACTIONS(2308),
    [aux_sym_preproc_def_token1] = ACTIONS(2308),
    [aux_sym_preproc_if_token1] = ACTIONS(2308),
    [aux_sym_preproc_if_token2] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2308),
    [sym_preproc_directive] = ACTIONS(2308),
    [anon_sym_LPAREN2] = ACTIONS(2310),
    [anon_sym_BANG] = ACTIONS(2310),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_COLON] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(2308),
    [anon_sym_typedef] = ACTIONS(2308),
    [anon_sym_in] = ACTIONS(2308),
    [anon_sym_out] = ACTIONS(2308),
    [anon_sym_inout] = ACTIONS(2308),
    [anon_sym_virtual] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2308),
    [anon_sym___attribute__] = ACTIONS(2308),
    [anon_sym___attribute] = ACTIONS(2308),
    [anon_sym_using] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2310),
    [anon_sym___declspec] = ACTIONS(2308),
    [anon_sym___based] = ACTIONS(2308),
    [anon_sym___cdecl] = ACTIONS(2308),
    [anon_sym___clrcall] = ACTIONS(2308),
    [anon_sym___stdcall] = ACTIONS(2308),
    [anon_sym___fastcall] = ACTIONS(2308),
    [anon_sym___thiscall] = ACTIONS(2308),
    [anon_sym___vectorcall] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_signed] = ACTIONS(2308),
    [anon_sym_unsigned] = ACTIONS(2308),
    [anon_sym_long] = ACTIONS(2308),
    [anon_sym_short] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_register] = ACTIONS(2308),
    [anon_sym_inline] = ACTIONS(2308),
    [anon_sym___inline] = ACTIONS(2308),
    [anon_sym___inline__] = ACTIONS(2308),
    [anon_sym___forceinline] = ACTIONS(2308),
    [anon_sym_thread_local] = ACTIONS(2308),
    [anon_sym___thread] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_constexpr] = ACTIONS(2308),
    [anon_sym_volatile] = ACTIONS(2308),
    [anon_sym_restrict] = ACTIONS(2308),
    [anon_sym___restrict__] = ACTIONS(2308),
    [anon_sym__Atomic] = ACTIONS(2308),
    [anon_sym__Noreturn] = ACTIONS(2308),
    [anon_sym_noreturn] = ACTIONS(2308),
    [anon_sym__Nonnull] = ACTIONS(2308),
    [anon_sym_mutable] = ACTIONS(2308),
    [anon_sym_constinit] = ACTIONS(2308),
    [anon_sym_consteval] = ACTIONS(2308),
    [anon_sym_alignas] = ACTIONS(2308),
    [anon_sym__Alignas] = ACTIONS(2308),
    [sym_primitive_type] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_struct] = ACTIONS(2308),
    [anon_sym_union] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_else] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_case] = ACTIONS(2308),
    [anon_sym_default] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_goto] = ACTIONS(2308),
    [anon_sym___try] = ACTIONS(2308),
    [anon_sym___leave] = ACTIONS(2308),
    [anon_sym_not] = ACTIONS(2308),
    [anon_sym_compl] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_sizeof] = ACTIONS(2308),
    [anon_sym___alignof__] = ACTIONS(2308),
    [anon_sym___alignof] = ACTIONS(2308),
    [anon_sym__alignof] = ACTIONS(2308),
    [anon_sym_alignof] = ACTIONS(2308),
    [anon_sym__Alignof] = ACTIONS(2308),
    [anon_sym_offsetof] = ACTIONS(2308),
    [anon_sym__Generic] = ACTIONS(2308),
    [anon_sym_asm] = ACTIONS(2308),
    [anon_sym___asm__] = ACTIONS(2308),
    [anon_sym___asm] = ACTIONS(2308),
    [sym_number_literal] = ACTIONS(2310),
    [anon_sym_L_SQUOTE] = ACTIONS(2310),
    [anon_sym_u_SQUOTE] = ACTIONS(2310),
    [anon_sym_U_SQUOTE] = ACTIONS(2310),
    [anon_sym_u8_SQUOTE] = ACTIONS(2310),
    [anon_sym_SQUOTE] = ACTIONS(2310),
    [anon_sym_L_DQUOTE] = ACTIONS(2310),
    [anon_sym_u_DQUOTE] = ACTIONS(2310),
    [anon_sym_U_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8_DQUOTE] = ACTIONS(2310),
    [anon_sym_DQUOTE] = ACTIONS(2310),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [anon_sym_NULL] = ACTIONS(2308),
    [anon_sym_nullptr] = ACTIONS(2308),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_This] = ACTIONS(2308),
    [anon_sym_decltype] = ACTIONS(2308),
    [anon_sym_final] = ACTIONS(2308),
    [anon_sym_override] = ACTIONS(2308),
    [anon_sym_explicit] = ACTIONS(2308),
    [anon_sym_typename] = ACTIONS(2308),
    [anon_sym_template] = ACTIONS(2308),
    [anon_sym_operator] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_delete] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_namespace] = ACTIONS(2308),
    [anon_sym_static_assert] = ACTIONS(2308),
    [anon_sym_concept] = ACTIONS(2308),
    [anon_sym_co_return] = ACTIONS(2308),
    [anon_sym_co_yield] = ACTIONS(2308),
    [anon_sym_R_DQUOTE] = ACTIONS(2310),
    [anon_sym_LR_DQUOTE] = ACTIONS(2310),
    [anon_sym_uR_DQUOTE] = ACTIONS(2310),
    [anon_sym_UR_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2310),
    [anon_sym_co_await] = ACTIONS(2308),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_requires] = ACTIONS(2308),
    [sym_this] = ACTIONS(2308),
    [anon_sym_discard] = ACTIONS(2308),
    [anon_sym_precise] = ACTIONS(2308),
    [anon_sym_shared] = ACTIONS(2308),
    [anon_sym_groupshared] = ACTIONS(2308),
    [anon_sym_uniform] = ACTIONS(2308),
    [anon_sym_row_major] = ACTIONS(2308),
    [anon_sym_column_major] = ACTIONS(2308),
    [anon_sym_globallycoherent] = ACTIONS(2308),
    [anon_sym_centroid] = ACTIONS(2308),
    [anon_sym_noperspective] = ACTIONS(2308),
    [anon_sym_nointerpolation] = ACTIONS(2308),
    [anon_sym_sample] = ACTIONS(2308),
    [anon_sym_linear] = ACTIONS(2308),
    [anon_sym_snorm] = ACTIONS(2308),
    [anon_sym_unorm] = ACTIONS(2308),
    [anon_sym_point] = ACTIONS(2308),
    [anon_sym_line] = ACTIONS(2308),
    [anon_sym_triangleadj] = ACTIONS(2308),
    [anon_sym_lineadj] = ACTIONS(2308),
    [anon_sym_triangle] = ACTIONS(2308),
    [anon_sym_cbuffer] = ACTIONS(2308),
    [anon_sym_interface] = ACTIONS(2308),
    [anon_sym_extension] = ACTIONS(2308),
  },
  [567] = {
    [sym_identifier] = ACTIONS(2312),
    [aux_sym_preproc_include_token1] = ACTIONS(2312),
    [aux_sym_preproc_def_token1] = ACTIONS(2312),
    [aux_sym_preproc_if_token1] = ACTIONS(2312),
    [aux_sym_preproc_if_token2] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2312),
    [sym_preproc_directive] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2314),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym___extension__] = ACTIONS(2312),
    [anon_sym_typedef] = ACTIONS(2312),
    [anon_sym_in] = ACTIONS(2312),
    [anon_sym_out] = ACTIONS(2312),
    [anon_sym_inout] = ACTIONS(2312),
    [anon_sym_virtual] = ACTIONS(2312),
    [anon_sym_extern] = ACTIONS(2312),
    [anon_sym___attribute__] = ACTIONS(2312),
    [anon_sym___attribute] = ACTIONS(2312),
    [anon_sym_using] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2314),
    [anon_sym___declspec] = ACTIONS(2312),
    [anon_sym___based] = ACTIONS(2312),
    [anon_sym___cdecl] = ACTIONS(2312),
    [anon_sym___clrcall] = ACTIONS(2312),
    [anon_sym___stdcall] = ACTIONS(2312),
    [anon_sym___fastcall] = ACTIONS(2312),
    [anon_sym___thiscall] = ACTIONS(2312),
    [anon_sym___vectorcall] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_signed] = ACTIONS(2312),
    [anon_sym_unsigned] = ACTIONS(2312),
    [anon_sym_long] = ACTIONS(2312),
    [anon_sym_short] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_register] = ACTIONS(2312),
    [anon_sym_inline] = ACTIONS(2312),
    [anon_sym___inline] = ACTIONS(2312),
    [anon_sym___inline__] = ACTIONS(2312),
    [anon_sym___forceinline] = ACTIONS(2312),
    [anon_sym_thread_local] = ACTIONS(2312),
    [anon_sym___thread] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_constexpr] = ACTIONS(2312),
    [anon_sym_volatile] = ACTIONS(2312),
    [anon_sym_restrict] = ACTIONS(2312),
    [anon_sym___restrict__] = ACTIONS(2312),
    [anon_sym__Atomic] = ACTIONS(2312),
    [anon_sym__Noreturn] = ACTIONS(2312),
    [anon_sym_noreturn] = ACTIONS(2312),
    [anon_sym__Nonnull] = ACTIONS(2312),
    [anon_sym_mutable] = ACTIONS(2312),
    [anon_sym_constinit] = ACTIONS(2312),
    [anon_sym_consteval] = ACTIONS(2312),
    [anon_sym_alignas] = ACTIONS(2312),
    [anon_sym__Alignas] = ACTIONS(2312),
    [sym_primitive_type] = ACTIONS(2312),
    [anon_sym_enum] = ACTIONS(2312),
    [anon_sym_class] = ACTIONS(2312),
    [anon_sym_struct] = ACTIONS(2312),
    [anon_sym_union] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_else] = ACTIONS(2312),
    [anon_sym_switch] = ACTIONS(2312),
    [anon_sym_case] = ACTIONS(2312),
    [anon_sym_default] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_break] = ACTIONS(2312),
    [anon_sym_continue] = ACTIONS(2312),
    [anon_sym_goto] = ACTIONS(2312),
    [anon_sym___try] = ACTIONS(2312),
    [anon_sym___leave] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2312),
    [anon_sym_compl] = ACTIONS(2312),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_sizeof] = ACTIONS(2312),
    [anon_sym___alignof__] = ACTIONS(2312),
    [anon_sym___alignof] = ACTIONS(2312),
    [anon_sym__alignof] = ACTIONS(2312),
    [anon_sym_alignof] = ACTIONS(2312),
    [anon_sym__Alignof] = ACTIONS(2312),
    [anon_sym_offsetof] = ACTIONS(2312),
    [anon_sym__Generic] = ACTIONS(2312),
    [anon_sym_asm] = ACTIONS(2312),
    [anon_sym___asm__] = ACTIONS(2312),
    [anon_sym___asm] = ACTIONS(2312),
    [sym_number_literal] = ACTIONS(2314),
    [anon_sym_L_SQUOTE] = ACTIONS(2314),
    [anon_sym_u_SQUOTE] = ACTIONS(2314),
    [anon_sym_U_SQUOTE] = ACTIONS(2314),
    [anon_sym_u8_SQUOTE] = ACTIONS(2314),
    [anon_sym_SQUOTE] = ACTIONS(2314),
    [anon_sym_L_DQUOTE] = ACTIONS(2314),
    [anon_sym_u_DQUOTE] = ACTIONS(2314),
    [anon_sym_U_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE] = ACTIONS(2314),
    [sym_true] = ACTIONS(2312),
    [sym_false] = ACTIONS(2312),
    [anon_sym_NULL] = ACTIONS(2312),
    [anon_sym_nullptr] = ACTIONS(2312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_This] = ACTIONS(2312),
    [anon_sym_decltype] = ACTIONS(2312),
    [anon_sym_final] = ACTIONS(2312),
    [anon_sym_override] = ACTIONS(2312),
    [anon_sym_explicit] = ACTIONS(2312),
    [anon_sym_typename] = ACTIONS(2312),
    [anon_sym_template] = ACTIONS(2312),
    [anon_sym_operator] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_delete] = ACTIONS(2312),
    [anon_sym_throw] = ACTIONS(2312),
    [anon_sym_namespace] = ACTIONS(2312),
    [anon_sym_static_assert] = ACTIONS(2312),
    [anon_sym_concept] = ACTIONS(2312),
    [anon_sym_co_return] = ACTIONS(2312),
    [anon_sym_co_yield] = ACTIONS(2312),
    [anon_sym_R_DQUOTE] = ACTIONS(2314),
    [anon_sym_LR_DQUOTE] = ACTIONS(2314),
    [anon_sym_uR_DQUOTE] = ACTIONS(2314),
    [anon_sym_UR_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2314),
    [anon_sym_co_await] = ACTIONS(2312),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_requires] = ACTIONS(2312),
    [sym_this] = ACTIONS(2312),
    [anon_sym_discard] = ACTIONS(2312),
    [anon_sym_precise] = ACTIONS(2312),
    [anon_sym_shared] = ACTIONS(2312),
    [anon_sym_groupshared] = ACTIONS(2312),
    [anon_sym_uniform] = ACTIONS(2312),
    [anon_sym_row_major] = ACTIONS(2312),
    [anon_sym_column_major] = ACTIONS(2312),
    [anon_sym_globallycoherent] = ACTIONS(2312),
    [anon_sym_centroid] = ACTIONS(2312),
    [anon_sym_noperspective] = ACTIONS(2312),
    [anon_sym_nointerpolation] = ACTIONS(2312),
    [anon_sym_sample] = ACTIONS(2312),
    [anon_sym_linear] = ACTIONS(2312),
    [anon_sym_snorm] = ACTIONS(2312),
    [anon_sym_unorm] = ACTIONS(2312),
    [anon_sym_point] = ACTIONS(2312),
    [anon_sym_line] = ACTIONS(2312),
    [anon_sym_triangleadj] = ACTIONS(2312),
    [anon_sym_lineadj] = ACTIONS(2312),
    [anon_sym_triangle] = ACTIONS(2312),
    [anon_sym_cbuffer] = ACTIONS(2312),
    [anon_sym_interface] = ACTIONS(2312),
    [anon_sym_extension] = ACTIONS(2312),
  },
  [568] = {
    [sym_template_argument_list] = STATE(2953),
    [aux_sym_sized_type_specifier_repeat1] = STATE(714),
    [ts_builtin_sym_end] = ACTIONS(3775),
    [sym_identifier] = ACTIONS(3777),
    [aux_sym_preproc_include_token1] = ACTIONS(3777),
    [aux_sym_preproc_def_token1] = ACTIONS(3777),
    [aux_sym_preproc_if_token1] = ACTIONS(3777),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3777),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3777),
    [sym_preproc_directive] = ACTIONS(3777),
    [anon_sym_LPAREN2] = ACTIONS(3775),
    [anon_sym_BANG] = ACTIONS(3775),
    [anon_sym_TILDE] = ACTIONS(3775),
    [anon_sym_DASH] = ACTIONS(3777),
    [anon_sym_PLUS] = ACTIONS(3777),
    [anon_sym_STAR] = ACTIONS(3775),
    [anon_sym_AMP_AMP] = ACTIONS(3775),
    [anon_sym_AMP] = ACTIONS(3777),
    [anon_sym_LT] = ACTIONS(3779),
    [anon_sym_SEMI] = ACTIONS(3775),
    [anon_sym___extension__] = ACTIONS(3777),
    [anon_sym_typedef] = ACTIONS(3777),
    [anon_sym_in] = ACTIONS(3777),
    [anon_sym_out] = ACTIONS(3777),
    [anon_sym_inout] = ACTIONS(3777),
    [anon_sym_virtual] = ACTIONS(3777),
    [anon_sym_extern] = ACTIONS(3777),
    [anon_sym___attribute__] = ACTIONS(3777),
    [anon_sym___attribute] = ACTIONS(3777),
    [anon_sym_using] = ACTIONS(3777),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3775),
    [anon_sym___declspec] = ACTIONS(3777),
    [anon_sym___based] = ACTIONS(3777),
    [anon_sym___cdecl] = ACTIONS(3777),
    [anon_sym___clrcall] = ACTIONS(3777),
    [anon_sym___stdcall] = ACTIONS(3777),
    [anon_sym___fastcall] = ACTIONS(3777),
    [anon_sym___thiscall] = ACTIONS(3777),
    [anon_sym___vectorcall] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3775),
    [anon_sym_signed] = ACTIONS(3777),
    [anon_sym_unsigned] = ACTIONS(3777),
    [anon_sym_long] = ACTIONS(3777),
    [anon_sym_short] = ACTIONS(3777),
    [anon_sym_LBRACK] = ACTIONS(3777),
    [anon_sym_static] = ACTIONS(3777),
    [anon_sym_register] = ACTIONS(3777),
    [anon_sym_inline] = ACTIONS(3777),
    [anon_sym___inline] = ACTIONS(3777),
    [anon_sym___inline__] = ACTIONS(3777),
    [anon_sym___forceinline] = ACTIONS(3777),
    [anon_sym_thread_local] = ACTIONS(3777),
    [anon_sym___thread] = ACTIONS(3777),
    [anon_sym_const] = ACTIONS(3777),
    [anon_sym_constexpr] = ACTIONS(3777),
    [anon_sym_volatile] = ACTIONS(3777),
    [anon_sym_restrict] = ACTIONS(3777),
    [anon_sym___restrict__] = ACTIONS(3777),
    [anon_sym__Atomic] = ACTIONS(3777),
    [anon_sym__Noreturn] = ACTIONS(3777),
    [anon_sym_noreturn] = ACTIONS(3777),
    [anon_sym__Nonnull] = ACTIONS(3777),
    [anon_sym_mutable] = ACTIONS(3777),
    [anon_sym_constinit] = ACTIONS(3777),
    [anon_sym_consteval] = ACTIONS(3777),
    [anon_sym_alignas] = ACTIONS(3777),
    [anon_sym__Alignas] = ACTIONS(3777),
    [sym_primitive_type] = ACTIONS(3777),
    [anon_sym_enum] = ACTIONS(3777),
    [anon_sym_class] = ACTIONS(3777),
    [anon_sym_struct] = ACTIONS(3777),
    [anon_sym_union] = ACTIONS(3777),
    [anon_sym_if] = ACTIONS(3777),
    [anon_sym_switch] = ACTIONS(3777),
    [anon_sym_case] = ACTIONS(3777),
    [anon_sym_default] = ACTIONS(3777),
    [anon_sym_while] = ACTIONS(3777),
    [anon_sym_do] = ACTIONS(3777),
    [anon_sym_for] = ACTIONS(3777),
    [anon_sym_return] = ACTIONS(3777),
    [anon_sym_break] = ACTIONS(3777),
    [anon_sym_continue] = ACTIONS(3777),
    [anon_sym_goto] = ACTIONS(3777),
    [anon_sym_not] = ACTIONS(3777),
    [anon_sym_compl] = ACTIONS(3777),
    [anon_sym_DASH_DASH] = ACTIONS(3775),
    [anon_sym_PLUS_PLUS] = ACTIONS(3775),
    [anon_sym_sizeof] = ACTIONS(3777),
    [anon_sym___alignof__] = ACTIONS(3777),
    [anon_sym___alignof] = ACTIONS(3777),
    [anon_sym__alignof] = ACTIONS(3777),
    [anon_sym_alignof] = ACTIONS(3777),
    [anon_sym__Alignof] = ACTIONS(3777),
    [anon_sym_offsetof] = ACTIONS(3777),
    [anon_sym__Generic] = ACTIONS(3777),
    [anon_sym_asm] = ACTIONS(3777),
    [anon_sym___asm__] = ACTIONS(3777),
    [anon_sym___asm] = ACTIONS(3777),
    [anon_sym_DOT] = ACTIONS(3777),
    [sym_number_literal] = ACTIONS(3775),
    [anon_sym_L_SQUOTE] = ACTIONS(3775),
    [anon_sym_u_SQUOTE] = ACTIONS(3775),
    [anon_sym_U_SQUOTE] = ACTIONS(3775),
    [anon_sym_u8_SQUOTE] = ACTIONS(3775),
    [anon_sym_SQUOTE] = ACTIONS(3775),
    [anon_sym_L_DQUOTE] = ACTIONS(3775),
    [anon_sym_u_DQUOTE] = ACTIONS(3775),
    [anon_sym_U_DQUOTE] = ACTIONS(3775),
    [anon_sym_u8_DQUOTE] = ACTIONS(3775),
    [anon_sym_DQUOTE] = ACTIONS(3775),
    [sym_true] = ACTIONS(3777),
    [sym_false] = ACTIONS(3777),
    [anon_sym_NULL] = ACTIONS(3777),
    [anon_sym_nullptr] = ACTIONS(3777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3777),
    [anon_sym_let] = ACTIONS(3777),
    [anon_sym_This] = ACTIONS(3777),
    [anon_sym_decltype] = ACTIONS(3777),
    [anon_sym_explicit] = ACTIONS(3777),
    [anon_sym_typename] = ACTIONS(3777),
    [anon_sym_export] = ACTIONS(3777),
    [anon_sym_module] = ACTIONS(3777),
    [anon_sym_import] = ACTIONS(3777),
    [anon_sym_template] = ACTIONS(3777),
    [anon_sym_operator] = ACTIONS(3777),
    [anon_sym_try] = ACTIONS(3777),
    [anon_sym_delete] = ACTIONS(3777),
    [anon_sym_throw] = ACTIONS(3777),
    [anon_sym_namespace] = ACTIONS(3777),
    [anon_sym_static_assert] = ACTIONS(3777),
    [anon_sym_concept] = ACTIONS(3777),
    [anon_sym_co_return] = ACTIONS(3777),
    [anon_sym_co_yield] = ACTIONS(3777),
    [anon_sym_R_DQUOTE] = ACTIONS(3775),
    [anon_sym_LR_DQUOTE] = ACTIONS(3775),
    [anon_sym_uR_DQUOTE] = ACTIONS(3775),
    [anon_sym_UR_DQUOTE] = ACTIONS(3775),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3775),
    [anon_sym_co_await] = ACTIONS(3777),
    [anon_sym_new] = ACTIONS(3777),
    [anon_sym_requires] = ACTIONS(3777),
    [sym_this] = ACTIONS(3777),
    [anon_sym_precise] = ACTIONS(3777),
    [anon_sym_shared] = ACTIONS(3777),
    [anon_sym_groupshared] = ACTIONS(3777),
    [anon_sym_uniform] = ACTIONS(3777),
    [anon_sym_row_major] = ACTIONS(3777),
    [anon_sym_column_major] = ACTIONS(3777),
    [anon_sym_globallycoherent] = ACTIONS(3777),
    [anon_sym_centroid] = ACTIONS(3777),
    [anon_sym_noperspective] = ACTIONS(3777),
    [anon_sym_nointerpolation] = ACTIONS(3777),
    [anon_sym_sample] = ACTIONS(3777),
    [anon_sym_linear] = ACTIONS(3777),
    [anon_sym_snorm] = ACTIONS(3777),
    [anon_sym_unorm] = ACTIONS(3777),
    [anon_sym_point] = ACTIONS(3777),
    [anon_sym_line] = ACTIONS(3777),
    [anon_sym_triangleadj] = ACTIONS(3777),
    [anon_sym_lineadj] = ACTIONS(3777),
    [anon_sym_triangle] = ACTIONS(3777),
    [anon_sym_interface] = ACTIONS(3777),
    [anon_sym_extension] = ACTIONS(3777),
    [anon_sym___exported] = ACTIONS(3777),
  },
  [569] = {
    [sym_catch_clause] = STATE(569),
    [aux_sym_constructor_try_statement_repeat1] = STATE(569),
    [sym_identifier] = ACTIONS(2901),
    [aux_sym_preproc_include_token1] = ACTIONS(2901),
    [aux_sym_preproc_def_token1] = ACTIONS(2901),
    [aux_sym_preproc_if_token1] = ACTIONS(2901),
    [aux_sym_preproc_if_token2] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2901),
    [sym_preproc_directive] = ACTIONS(2901),
    [anon_sym_LPAREN2] = ACTIONS(2903),
    [anon_sym_BANG] = ACTIONS(2903),
    [anon_sym_TILDE] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2901),
    [anon_sym_STAR] = ACTIONS(2903),
    [anon_sym_AMP_AMP] = ACTIONS(2903),
    [anon_sym_AMP] = ACTIONS(2901),
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym___extension__] = ACTIONS(2901),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_in] = ACTIONS(2901),
    [anon_sym_out] = ACTIONS(2901),
    [anon_sym_inout] = ACTIONS(2901),
    [anon_sym_virtual] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(2901),
    [anon_sym___attribute__] = ACTIONS(2901),
    [anon_sym___attribute] = ACTIONS(2901),
    [anon_sym_using] = ACTIONS(2901),
    [anon_sym_COLON_COLON] = ACTIONS(2903),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2903),
    [anon_sym___declspec] = ACTIONS(2901),
    [anon_sym___based] = ACTIONS(2901),
    [anon_sym___cdecl] = ACTIONS(2901),
    [anon_sym___clrcall] = ACTIONS(2901),
    [anon_sym___stdcall] = ACTIONS(2901),
    [anon_sym___fastcall] = ACTIONS(2901),
    [anon_sym___thiscall] = ACTIONS(2901),
    [anon_sym___vectorcall] = ACTIONS(2901),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_signed] = ACTIONS(2901),
    [anon_sym_unsigned] = ACTIONS(2901),
    [anon_sym_long] = ACTIONS(2901),
    [anon_sym_short] = ACTIONS(2901),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_static] = ACTIONS(2901),
    [anon_sym_register] = ACTIONS(2901),
    [anon_sym_inline] = ACTIONS(2901),
    [anon_sym___inline] = ACTIONS(2901),
    [anon_sym___inline__] = ACTIONS(2901),
    [anon_sym___forceinline] = ACTIONS(2901),
    [anon_sym_thread_local] = ACTIONS(2901),
    [anon_sym___thread] = ACTIONS(2901),
    [anon_sym_const] = ACTIONS(2901),
    [anon_sym_constexpr] = ACTIONS(2901),
    [anon_sym_volatile] = ACTIONS(2901),
    [anon_sym_restrict] = ACTIONS(2901),
    [anon_sym___restrict__] = ACTIONS(2901),
    [anon_sym__Atomic] = ACTIONS(2901),
    [anon_sym__Noreturn] = ACTIONS(2901),
    [anon_sym_noreturn] = ACTIONS(2901),
    [anon_sym__Nonnull] = ACTIONS(2901),
    [anon_sym_mutable] = ACTIONS(2901),
    [anon_sym_constinit] = ACTIONS(2901),
    [anon_sym_consteval] = ACTIONS(2901),
    [anon_sym_alignas] = ACTIONS(2901),
    [anon_sym__Alignas] = ACTIONS(2901),
    [sym_primitive_type] = ACTIONS(2901),
    [anon_sym_enum] = ACTIONS(2901),
    [anon_sym_class] = ACTIONS(2901),
    [anon_sym_struct] = ACTIONS(2901),
    [anon_sym_union] = ACTIONS(2901),
    [anon_sym_if] = ACTIONS(2901),
    [anon_sym_else] = ACTIONS(2901),
    [anon_sym_switch] = ACTIONS(2901),
    [anon_sym_case] = ACTIONS(2901),
    [anon_sym_default] = ACTIONS(2901),
    [anon_sym_while] = ACTIONS(2901),
    [anon_sym_do] = ACTIONS(2901),
    [anon_sym_for] = ACTIONS(2901),
    [anon_sym_return] = ACTIONS(2901),
    [anon_sym_break] = ACTIONS(2901),
    [anon_sym_continue] = ACTIONS(2901),
    [anon_sym_goto] = ACTIONS(2901),
    [anon_sym___try] = ACTIONS(2901),
    [anon_sym___leave] = ACTIONS(2901),
    [anon_sym_not] = ACTIONS(2901),
    [anon_sym_compl] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2903),
    [anon_sym_PLUS_PLUS] = ACTIONS(2903),
    [anon_sym_sizeof] = ACTIONS(2901),
    [anon_sym___alignof__] = ACTIONS(2901),
    [anon_sym___alignof] = ACTIONS(2901),
    [anon_sym__alignof] = ACTIONS(2901),
    [anon_sym_alignof] = ACTIONS(2901),
    [anon_sym__Alignof] = ACTIONS(2901),
    [anon_sym_offsetof] = ACTIONS(2901),
    [anon_sym__Generic] = ACTIONS(2901),
    [anon_sym_asm] = ACTIONS(2901),
    [anon_sym___asm__] = ACTIONS(2901),
    [anon_sym___asm] = ACTIONS(2901),
    [sym_number_literal] = ACTIONS(2903),
    [anon_sym_L_SQUOTE] = ACTIONS(2903),
    [anon_sym_u_SQUOTE] = ACTIONS(2903),
    [anon_sym_U_SQUOTE] = ACTIONS(2903),
    [anon_sym_u8_SQUOTE] = ACTIONS(2903),
    [anon_sym_SQUOTE] = ACTIONS(2903),
    [anon_sym_L_DQUOTE] = ACTIONS(2903),
    [anon_sym_u_DQUOTE] = ACTIONS(2903),
    [anon_sym_U_DQUOTE] = ACTIONS(2903),
    [anon_sym_u8_DQUOTE] = ACTIONS(2903),
    [anon_sym_DQUOTE] = ACTIONS(2903),
    [sym_true] = ACTIONS(2901),
    [sym_false] = ACTIONS(2901),
    [anon_sym_NULL] = ACTIONS(2901),
    [anon_sym_nullptr] = ACTIONS(2901),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2901),
    [anon_sym_let] = ACTIONS(2901),
    [anon_sym_This] = ACTIONS(2901),
    [anon_sym_decltype] = ACTIONS(2901),
    [anon_sym_explicit] = ACTIONS(2901),
    [anon_sym_typename] = ACTIONS(2901),
    [anon_sym_template] = ACTIONS(2901),
    [anon_sym_operator] = ACTIONS(2901),
    [anon_sym_try] = ACTIONS(2901),
    [anon_sym_delete] = ACTIONS(2901),
    [anon_sym_throw] = ACTIONS(2901),
    [anon_sym_namespace] = ACTIONS(2901),
    [anon_sym_static_assert] = ACTIONS(2901),
    [anon_sym_concept] = ACTIONS(2901),
    [anon_sym_co_return] = ACTIONS(2901),
    [anon_sym_co_yield] = ACTIONS(2901),
    [anon_sym_catch] = ACTIONS(3781),
    [anon_sym_R_DQUOTE] = ACTIONS(2903),
    [anon_sym_LR_DQUOTE] = ACTIONS(2903),
    [anon_sym_uR_DQUOTE] = ACTIONS(2903),
    [anon_sym_UR_DQUOTE] = ACTIONS(2903),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2903),
    [anon_sym_co_await] = ACTIONS(2901),
    [anon_sym_new] = ACTIONS(2901),
    [anon_sym_requires] = ACTIONS(2901),
    [sym_this] = ACTIONS(2901),
    [anon_sym_discard] = ACTIONS(2901),
    [anon_sym_precise] = ACTIONS(2901),
    [anon_sym_shared] = ACTIONS(2901),
    [anon_sym_groupshared] = ACTIONS(2901),
    [anon_sym_uniform] = ACTIONS(2901),
    [anon_sym_row_major] = ACTIONS(2901),
    [anon_sym_column_major] = ACTIONS(2901),
    [anon_sym_globallycoherent] = ACTIONS(2901),
    [anon_sym_centroid] = ACTIONS(2901),
    [anon_sym_noperspective] = ACTIONS(2901),
    [anon_sym_nointerpolation] = ACTIONS(2901),
    [anon_sym_sample] = ACTIONS(2901),
    [anon_sym_linear] = ACTIONS(2901),
    [anon_sym_snorm] = ACTIONS(2901),
    [anon_sym_unorm] = ACTIONS(2901),
    [anon_sym_point] = ACTIONS(2901),
    [anon_sym_line] = ACTIONS(2901),
    [anon_sym_triangleadj] = ACTIONS(2901),
    [anon_sym_lineadj] = ACTIONS(2901),
    [anon_sym_triangle] = ACTIONS(2901),
    [anon_sym_cbuffer] = ACTIONS(2901),
    [anon_sym_interface] = ACTIONS(2901),
    [anon_sym_extension] = ACTIONS(2901),
  },
  [570] = {
    [sym_identifier] = ACTIONS(3784),
    [aux_sym_preproc_include_token1] = ACTIONS(3784),
    [aux_sym_preproc_def_token1] = ACTIONS(3784),
    [aux_sym_preproc_if_token1] = ACTIONS(3784),
    [aux_sym_preproc_if_token2] = ACTIONS(3784),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3784),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3784),
    [aux_sym_preproc_else_token1] = ACTIONS(3784),
    [aux_sym_preproc_elif_token1] = ACTIONS(3784),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3784),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3784),
    [sym_preproc_directive] = ACTIONS(3784),
    [anon_sym_LPAREN2] = ACTIONS(3786),
    [anon_sym_BANG] = ACTIONS(3786),
    [anon_sym_TILDE] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3784),
    [anon_sym_PLUS] = ACTIONS(3784),
    [anon_sym_STAR] = ACTIONS(3786),
    [anon_sym_AMP_AMP] = ACTIONS(3786),
    [anon_sym_AMP] = ACTIONS(3784),
    [anon_sym_SEMI] = ACTIONS(3786),
    [anon_sym___extension__] = ACTIONS(3784),
    [anon_sym_typedef] = ACTIONS(3784),
    [anon_sym_in] = ACTIONS(3784),
    [anon_sym_out] = ACTIONS(3784),
    [anon_sym_inout] = ACTIONS(3784),
    [anon_sym_virtual] = ACTIONS(3784),
    [anon_sym_extern] = ACTIONS(3784),
    [anon_sym___attribute__] = ACTIONS(3784),
    [anon_sym___attribute] = ACTIONS(3784),
    [anon_sym_using] = ACTIONS(3784),
    [anon_sym_COLON_COLON] = ACTIONS(3786),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3786),
    [anon_sym___declspec] = ACTIONS(3784),
    [anon_sym___based] = ACTIONS(3784),
    [anon_sym___cdecl] = ACTIONS(3784),
    [anon_sym___clrcall] = ACTIONS(3784),
    [anon_sym___stdcall] = ACTIONS(3784),
    [anon_sym___fastcall] = ACTIONS(3784),
    [anon_sym___thiscall] = ACTIONS(3784),
    [anon_sym___vectorcall] = ACTIONS(3784),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3784),
    [anon_sym_static] = ACTIONS(3784),
    [anon_sym_register] = ACTIONS(3784),
    [anon_sym_inline] = ACTIONS(3784),
    [anon_sym___inline] = ACTIONS(3784),
    [anon_sym___inline__] = ACTIONS(3784),
    [anon_sym___forceinline] = ACTIONS(3784),
    [anon_sym_thread_local] = ACTIONS(3784),
    [anon_sym___thread] = ACTIONS(3784),
    [anon_sym_const] = ACTIONS(3784),
    [anon_sym_constexpr] = ACTIONS(3784),
    [anon_sym_volatile] = ACTIONS(3784),
    [anon_sym_restrict] = ACTIONS(3784),
    [anon_sym___restrict__] = ACTIONS(3784),
    [anon_sym__Atomic] = ACTIONS(3784),
    [anon_sym__Noreturn] = ACTIONS(3784),
    [anon_sym_noreturn] = ACTIONS(3784),
    [anon_sym__Nonnull] = ACTIONS(3784),
    [anon_sym_mutable] = ACTIONS(3784),
    [anon_sym_constinit] = ACTIONS(3784),
    [anon_sym_consteval] = ACTIONS(3784),
    [anon_sym_alignas] = ACTIONS(3784),
    [anon_sym__Alignas] = ACTIONS(3784),
    [sym_primitive_type] = ACTIONS(3784),
    [anon_sym_enum] = ACTIONS(3784),
    [anon_sym_class] = ACTIONS(3784),
    [anon_sym_struct] = ACTIONS(3784),
    [anon_sym_union] = ACTIONS(3784),
    [anon_sym_if] = ACTIONS(3784),
    [anon_sym_switch] = ACTIONS(3784),
    [anon_sym_case] = ACTIONS(3784),
    [anon_sym_default] = ACTIONS(3784),
    [anon_sym_while] = ACTIONS(3784),
    [anon_sym_do] = ACTIONS(3784),
    [anon_sym_for] = ACTIONS(3784),
    [anon_sym_return] = ACTIONS(3784),
    [anon_sym_break] = ACTIONS(3784),
    [anon_sym_continue] = ACTIONS(3784),
    [anon_sym_goto] = ACTIONS(3784),
    [anon_sym___try] = ACTIONS(3784),
    [anon_sym___leave] = ACTIONS(3784),
    [anon_sym_not] = ACTIONS(3784),
    [anon_sym_compl] = ACTIONS(3784),
    [anon_sym_DASH_DASH] = ACTIONS(3786),
    [anon_sym_PLUS_PLUS] = ACTIONS(3786),
    [anon_sym_sizeof] = ACTIONS(3784),
    [anon_sym___alignof__] = ACTIONS(3784),
    [anon_sym___alignof] = ACTIONS(3784),
    [anon_sym__alignof] = ACTIONS(3784),
    [anon_sym_alignof] = ACTIONS(3784),
    [anon_sym__Alignof] = ACTIONS(3784),
    [anon_sym_offsetof] = ACTIONS(3784),
    [anon_sym__Generic] = ACTIONS(3784),
    [anon_sym_asm] = ACTIONS(3784),
    [anon_sym___asm__] = ACTIONS(3784),
    [anon_sym___asm] = ACTIONS(3784),
    [sym_number_literal] = ACTIONS(3786),
    [anon_sym_L_SQUOTE] = ACTIONS(3786),
    [anon_sym_u_SQUOTE] = ACTIONS(3786),
    [anon_sym_U_SQUOTE] = ACTIONS(3786),
    [anon_sym_u8_SQUOTE] = ACTIONS(3786),
    [anon_sym_SQUOTE] = ACTIONS(3786),
    [anon_sym_L_DQUOTE] = ACTIONS(3786),
    [anon_sym_u_DQUOTE] = ACTIONS(3786),
    [anon_sym_U_DQUOTE] = ACTIONS(3786),
    [anon_sym_u8_DQUOTE] = ACTIONS(3786),
    [anon_sym_DQUOTE] = ACTIONS(3786),
    [sym_true] = ACTIONS(3784),
    [sym_false] = ACTIONS(3784),
    [anon_sym_NULL] = ACTIONS(3784),
    [anon_sym_nullptr] = ACTIONS(3784),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3784),
    [anon_sym_let] = ACTIONS(3784),
    [anon_sym_This] = ACTIONS(3784),
    [anon_sym_decltype] = ACTIONS(3784),
    [anon_sym_explicit] = ACTIONS(3784),
    [anon_sym_typename] = ACTIONS(3784),
    [anon_sym_template] = ACTIONS(3784),
    [anon_sym_operator] = ACTIONS(3784),
    [anon_sym_try] = ACTIONS(3784),
    [anon_sym_delete] = ACTIONS(3784),
    [anon_sym_throw] = ACTIONS(3784),
    [anon_sym_namespace] = ACTIONS(3784),
    [anon_sym_static_assert] = ACTIONS(3784),
    [anon_sym_concept] = ACTIONS(3784),
    [anon_sym_co_return] = ACTIONS(3784),
    [anon_sym_co_yield] = ACTIONS(3784),
    [anon_sym_R_DQUOTE] = ACTIONS(3786),
    [anon_sym_LR_DQUOTE] = ACTIONS(3786),
    [anon_sym_uR_DQUOTE] = ACTIONS(3786),
    [anon_sym_UR_DQUOTE] = ACTIONS(3786),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3786),
    [anon_sym_co_await] = ACTIONS(3784),
    [anon_sym_new] = ACTIONS(3784),
    [anon_sym_requires] = ACTIONS(3784),
    [sym_this] = ACTIONS(3784),
    [anon_sym_discard] = ACTIONS(3784),
    [anon_sym_precise] = ACTIONS(3784),
    [anon_sym_shared] = ACTIONS(3784),
    [anon_sym_groupshared] = ACTIONS(3784),
    [anon_sym_uniform] = ACTIONS(3784),
    [anon_sym_row_major] = ACTIONS(3784),
    [anon_sym_column_major] = ACTIONS(3784),
    [anon_sym_globallycoherent] = ACTIONS(3784),
    [anon_sym_centroid] = ACTIONS(3784),
    [anon_sym_noperspective] = ACTIONS(3784),
    [anon_sym_nointerpolation] = ACTIONS(3784),
    [anon_sym_sample] = ACTIONS(3784),
    [anon_sym_linear] = ACTIONS(3784),
    [anon_sym_snorm] = ACTIONS(3784),
    [anon_sym_unorm] = ACTIONS(3784),
    [anon_sym_point] = ACTIONS(3784),
    [anon_sym_line] = ACTIONS(3784),
    [anon_sym_triangleadj] = ACTIONS(3784),
    [anon_sym_lineadj] = ACTIONS(3784),
    [anon_sym_triangle] = ACTIONS(3784),
    [anon_sym_cbuffer] = ACTIONS(3784),
    [anon_sym_interface] = ACTIONS(3784),
    [anon_sym_extension] = ACTIONS(3784),
  },
  [571] = {
    [sym_identifier] = ACTIONS(3788),
    [aux_sym_preproc_include_token1] = ACTIONS(3788),
    [aux_sym_preproc_def_token1] = ACTIONS(3788),
    [aux_sym_preproc_if_token1] = ACTIONS(3788),
    [aux_sym_preproc_if_token2] = ACTIONS(3788),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3788),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3788),
    [aux_sym_preproc_else_token1] = ACTIONS(3788),
    [aux_sym_preproc_elif_token1] = ACTIONS(3788),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3788),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3788),
    [sym_preproc_directive] = ACTIONS(3788),
    [anon_sym_LPAREN2] = ACTIONS(3790),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_DASH] = ACTIONS(3788),
    [anon_sym_PLUS] = ACTIONS(3788),
    [anon_sym_STAR] = ACTIONS(3790),
    [anon_sym_AMP_AMP] = ACTIONS(3790),
    [anon_sym_AMP] = ACTIONS(3788),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym___extension__] = ACTIONS(3788),
    [anon_sym_typedef] = ACTIONS(3788),
    [anon_sym_in] = ACTIONS(3788),
    [anon_sym_out] = ACTIONS(3788),
    [anon_sym_inout] = ACTIONS(3788),
    [anon_sym_virtual] = ACTIONS(3788),
    [anon_sym_extern] = ACTIONS(3788),
    [anon_sym___attribute__] = ACTIONS(3788),
    [anon_sym___attribute] = ACTIONS(3788),
    [anon_sym_using] = ACTIONS(3788),
    [anon_sym_COLON_COLON] = ACTIONS(3790),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3790),
    [anon_sym___declspec] = ACTIONS(3788),
    [anon_sym___based] = ACTIONS(3788),
    [anon_sym___cdecl] = ACTIONS(3788),
    [anon_sym___clrcall] = ACTIONS(3788),
    [anon_sym___stdcall] = ACTIONS(3788),
    [anon_sym___fastcall] = ACTIONS(3788),
    [anon_sym___thiscall] = ACTIONS(3788),
    [anon_sym___vectorcall] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_signed] = ACTIONS(3788),
    [anon_sym_unsigned] = ACTIONS(3788),
    [anon_sym_long] = ACTIONS(3788),
    [anon_sym_short] = ACTIONS(3788),
    [anon_sym_LBRACK] = ACTIONS(3788),
    [anon_sym_static] = ACTIONS(3788),
    [anon_sym_register] = ACTIONS(3788),
    [anon_sym_inline] = ACTIONS(3788),
    [anon_sym___inline] = ACTIONS(3788),
    [anon_sym___inline__] = ACTIONS(3788),
    [anon_sym___forceinline] = ACTIONS(3788),
    [anon_sym_thread_local] = ACTIONS(3788),
    [anon_sym___thread] = ACTIONS(3788),
    [anon_sym_const] = ACTIONS(3788),
    [anon_sym_constexpr] = ACTIONS(3788),
    [anon_sym_volatile] = ACTIONS(3788),
    [anon_sym_restrict] = ACTIONS(3788),
    [anon_sym___restrict__] = ACTIONS(3788),
    [anon_sym__Atomic] = ACTIONS(3788),
    [anon_sym__Noreturn] = ACTIONS(3788),
    [anon_sym_noreturn] = ACTIONS(3788),
    [anon_sym__Nonnull] = ACTIONS(3788),
    [anon_sym_mutable] = ACTIONS(3788),
    [anon_sym_constinit] = ACTIONS(3788),
    [anon_sym_consteval] = ACTIONS(3788),
    [anon_sym_alignas] = ACTIONS(3788),
    [anon_sym__Alignas] = ACTIONS(3788),
    [sym_primitive_type] = ACTIONS(3788),
    [anon_sym_enum] = ACTIONS(3788),
    [anon_sym_class] = ACTIONS(3788),
    [anon_sym_struct] = ACTIONS(3788),
    [anon_sym_union] = ACTIONS(3788),
    [anon_sym_if] = ACTIONS(3788),
    [anon_sym_switch] = ACTIONS(3788),
    [anon_sym_case] = ACTIONS(3788),
    [anon_sym_default] = ACTIONS(3788),
    [anon_sym_while] = ACTIONS(3788),
    [anon_sym_do] = ACTIONS(3788),
    [anon_sym_for] = ACTIONS(3788),
    [anon_sym_return] = ACTIONS(3788),
    [anon_sym_break] = ACTIONS(3788),
    [anon_sym_continue] = ACTIONS(3788),
    [anon_sym_goto] = ACTIONS(3788),
    [anon_sym___try] = ACTIONS(3788),
    [anon_sym___leave] = ACTIONS(3788),
    [anon_sym_not] = ACTIONS(3788),
    [anon_sym_compl] = ACTIONS(3788),
    [anon_sym_DASH_DASH] = ACTIONS(3790),
    [anon_sym_PLUS_PLUS] = ACTIONS(3790),
    [anon_sym_sizeof] = ACTIONS(3788),
    [anon_sym___alignof__] = ACTIONS(3788),
    [anon_sym___alignof] = ACTIONS(3788),
    [anon_sym__alignof] = ACTIONS(3788),
    [anon_sym_alignof] = ACTIONS(3788),
    [anon_sym__Alignof] = ACTIONS(3788),
    [anon_sym_offsetof] = ACTIONS(3788),
    [anon_sym__Generic] = ACTIONS(3788),
    [anon_sym_asm] = ACTIONS(3788),
    [anon_sym___asm__] = ACTIONS(3788),
    [anon_sym___asm] = ACTIONS(3788),
    [sym_number_literal] = ACTIONS(3790),
    [anon_sym_L_SQUOTE] = ACTIONS(3790),
    [anon_sym_u_SQUOTE] = ACTIONS(3790),
    [anon_sym_U_SQUOTE] = ACTIONS(3790),
    [anon_sym_u8_SQUOTE] = ACTIONS(3790),
    [anon_sym_SQUOTE] = ACTIONS(3790),
    [anon_sym_L_DQUOTE] = ACTIONS(3790),
    [anon_sym_u_DQUOTE] = ACTIONS(3790),
    [anon_sym_U_DQUOTE] = ACTIONS(3790),
    [anon_sym_u8_DQUOTE] = ACTIONS(3790),
    [anon_sym_DQUOTE] = ACTIONS(3790),
    [sym_true] = ACTIONS(3788),
    [sym_false] = ACTIONS(3788),
    [anon_sym_NULL] = ACTIONS(3788),
    [anon_sym_nullptr] = ACTIONS(3788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3788),
    [anon_sym_let] = ACTIONS(3788),
    [anon_sym_This] = ACTIONS(3788),
    [anon_sym_decltype] = ACTIONS(3788),
    [anon_sym_explicit] = ACTIONS(3788),
    [anon_sym_typename] = ACTIONS(3788),
    [anon_sym_template] = ACTIONS(3788),
    [anon_sym_operator] = ACTIONS(3788),
    [anon_sym_try] = ACTIONS(3788),
    [anon_sym_delete] = ACTIONS(3788),
    [anon_sym_throw] = ACTIONS(3788),
    [anon_sym_namespace] = ACTIONS(3788),
    [anon_sym_static_assert] = ACTIONS(3788),
    [anon_sym_concept] = ACTIONS(3788),
    [anon_sym_co_return] = ACTIONS(3788),
    [anon_sym_co_yield] = ACTIONS(3788),
    [anon_sym_R_DQUOTE] = ACTIONS(3790),
    [anon_sym_LR_DQUOTE] = ACTIONS(3790),
    [anon_sym_uR_DQUOTE] = ACTIONS(3790),
    [anon_sym_UR_DQUOTE] = ACTIONS(3790),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3790),
    [anon_sym_co_await] = ACTIONS(3788),
    [anon_sym_new] = ACTIONS(3788),
    [anon_sym_requires] = ACTIONS(3788),
    [sym_this] = ACTIONS(3788),
    [anon_sym_discard] = ACTIONS(3788),
    [anon_sym_precise] = ACTIONS(3788),
    [anon_sym_shared] = ACTIONS(3788),
    [anon_sym_groupshared] = ACTIONS(3788),
    [anon_sym_uniform] = ACTIONS(3788),
    [anon_sym_row_major] = ACTIONS(3788),
    [anon_sym_column_major] = ACTIONS(3788),
    [anon_sym_globallycoherent] = ACTIONS(3788),
    [anon_sym_centroid] = ACTIONS(3788),
    [anon_sym_noperspective] = ACTIONS(3788),
    [anon_sym_nointerpolation] = ACTIONS(3788),
    [anon_sym_sample] = ACTIONS(3788),
    [anon_sym_linear] = ACTIONS(3788),
    [anon_sym_snorm] = ACTIONS(3788),
    [anon_sym_unorm] = ACTIONS(3788),
    [anon_sym_point] = ACTIONS(3788),
    [anon_sym_line] = ACTIONS(3788),
    [anon_sym_triangleadj] = ACTIONS(3788),
    [anon_sym_lineadj] = ACTIONS(3788),
    [anon_sym_triangle] = ACTIONS(3788),
    [anon_sym_cbuffer] = ACTIONS(3788),
    [anon_sym_interface] = ACTIONS(3788),
    [anon_sym_extension] = ACTIONS(3788),
  },
  [572] = {
    [sym_identifier] = ACTIONS(3792),
    [aux_sym_preproc_include_token1] = ACTIONS(3792),
    [aux_sym_preproc_def_token1] = ACTIONS(3792),
    [aux_sym_preproc_if_token1] = ACTIONS(3792),
    [aux_sym_preproc_if_token2] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3792),
    [aux_sym_preproc_else_token1] = ACTIONS(3792),
    [aux_sym_preproc_elif_token1] = ACTIONS(3792),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3792),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3792),
    [sym_preproc_directive] = ACTIONS(3792),
    [anon_sym_LPAREN2] = ACTIONS(3794),
    [anon_sym_BANG] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3794),
    [anon_sym_DASH] = ACTIONS(3792),
    [anon_sym_PLUS] = ACTIONS(3792),
    [anon_sym_STAR] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_AMP] = ACTIONS(3792),
    [anon_sym_SEMI] = ACTIONS(3794),
    [anon_sym___extension__] = ACTIONS(3792),
    [anon_sym_typedef] = ACTIONS(3792),
    [anon_sym_in] = ACTIONS(3792),
    [anon_sym_out] = ACTIONS(3792),
    [anon_sym_inout] = ACTIONS(3792),
    [anon_sym_virtual] = ACTIONS(3792),
    [anon_sym_extern] = ACTIONS(3792),
    [anon_sym___attribute__] = ACTIONS(3792),
    [anon_sym___attribute] = ACTIONS(3792),
    [anon_sym_using] = ACTIONS(3792),
    [anon_sym_COLON_COLON] = ACTIONS(3794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3794),
    [anon_sym___declspec] = ACTIONS(3792),
    [anon_sym___based] = ACTIONS(3792),
    [anon_sym___cdecl] = ACTIONS(3792),
    [anon_sym___clrcall] = ACTIONS(3792),
    [anon_sym___stdcall] = ACTIONS(3792),
    [anon_sym___fastcall] = ACTIONS(3792),
    [anon_sym___thiscall] = ACTIONS(3792),
    [anon_sym___vectorcall] = ACTIONS(3792),
    [anon_sym_LBRACE] = ACTIONS(3794),
    [anon_sym_signed] = ACTIONS(3792),
    [anon_sym_unsigned] = ACTIONS(3792),
    [anon_sym_long] = ACTIONS(3792),
    [anon_sym_short] = ACTIONS(3792),
    [anon_sym_LBRACK] = ACTIONS(3792),
    [anon_sym_static] = ACTIONS(3792),
    [anon_sym_register] = ACTIONS(3792),
    [anon_sym_inline] = ACTIONS(3792),
    [anon_sym___inline] = ACTIONS(3792),
    [anon_sym___inline__] = ACTIONS(3792),
    [anon_sym___forceinline] = ACTIONS(3792),
    [anon_sym_thread_local] = ACTIONS(3792),
    [anon_sym___thread] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3792),
    [anon_sym_constexpr] = ACTIONS(3792),
    [anon_sym_volatile] = ACTIONS(3792),
    [anon_sym_restrict] = ACTIONS(3792),
    [anon_sym___restrict__] = ACTIONS(3792),
    [anon_sym__Atomic] = ACTIONS(3792),
    [anon_sym__Noreturn] = ACTIONS(3792),
    [anon_sym_noreturn] = ACTIONS(3792),
    [anon_sym__Nonnull] = ACTIONS(3792),
    [anon_sym_mutable] = ACTIONS(3792),
    [anon_sym_constinit] = ACTIONS(3792),
    [anon_sym_consteval] = ACTIONS(3792),
    [anon_sym_alignas] = ACTIONS(3792),
    [anon_sym__Alignas] = ACTIONS(3792),
    [sym_primitive_type] = ACTIONS(3792),
    [anon_sym_enum] = ACTIONS(3792),
    [anon_sym_class] = ACTIONS(3792),
    [anon_sym_struct] = ACTIONS(3792),
    [anon_sym_union] = ACTIONS(3792),
    [anon_sym_if] = ACTIONS(3792),
    [anon_sym_switch] = ACTIONS(3792),
    [anon_sym_case] = ACTIONS(3792),
    [anon_sym_default] = ACTIONS(3792),
    [anon_sym_while] = ACTIONS(3792),
    [anon_sym_do] = ACTIONS(3792),
    [anon_sym_for] = ACTIONS(3792),
    [anon_sym_return] = ACTIONS(3792),
    [anon_sym_break] = ACTIONS(3792),
    [anon_sym_continue] = ACTIONS(3792),
    [anon_sym_goto] = ACTIONS(3792),
    [anon_sym___try] = ACTIONS(3792),
    [anon_sym___leave] = ACTIONS(3792),
    [anon_sym_not] = ACTIONS(3792),
    [anon_sym_compl] = ACTIONS(3792),
    [anon_sym_DASH_DASH] = ACTIONS(3794),
    [anon_sym_PLUS_PLUS] = ACTIONS(3794),
    [anon_sym_sizeof] = ACTIONS(3792),
    [anon_sym___alignof__] = ACTIONS(3792),
    [anon_sym___alignof] = ACTIONS(3792),
    [anon_sym__alignof] = ACTIONS(3792),
    [anon_sym_alignof] = ACTIONS(3792),
    [anon_sym__Alignof] = ACTIONS(3792),
    [anon_sym_offsetof] = ACTIONS(3792),
    [anon_sym__Generic] = ACTIONS(3792),
    [anon_sym_asm] = ACTIONS(3792),
    [anon_sym___asm__] = ACTIONS(3792),
    [anon_sym___asm] = ACTIONS(3792),
    [sym_number_literal] = ACTIONS(3794),
    [anon_sym_L_SQUOTE] = ACTIONS(3794),
    [anon_sym_u_SQUOTE] = ACTIONS(3794),
    [anon_sym_U_SQUOTE] = ACTIONS(3794),
    [anon_sym_u8_SQUOTE] = ACTIONS(3794),
    [anon_sym_SQUOTE] = ACTIONS(3794),
    [anon_sym_L_DQUOTE] = ACTIONS(3794),
    [anon_sym_u_DQUOTE] = ACTIONS(3794),
    [anon_sym_U_DQUOTE] = ACTIONS(3794),
    [anon_sym_u8_DQUOTE] = ACTIONS(3794),
    [anon_sym_DQUOTE] = ACTIONS(3794),
    [sym_true] = ACTIONS(3792),
    [sym_false] = ACTIONS(3792),
    [anon_sym_NULL] = ACTIONS(3792),
    [anon_sym_nullptr] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3792),
    [anon_sym_let] = ACTIONS(3792),
    [anon_sym_This] = ACTIONS(3792),
    [anon_sym_decltype] = ACTIONS(3792),
    [anon_sym_explicit] = ACTIONS(3792),
    [anon_sym_typename] = ACTIONS(3792),
    [anon_sym_template] = ACTIONS(3792),
    [anon_sym_operator] = ACTIONS(3792),
    [anon_sym_try] = ACTIONS(3792),
    [anon_sym_delete] = ACTIONS(3792),
    [anon_sym_throw] = ACTIONS(3792),
    [anon_sym_namespace] = ACTIONS(3792),
    [anon_sym_static_assert] = ACTIONS(3792),
    [anon_sym_concept] = ACTIONS(3792),
    [anon_sym_co_return] = ACTIONS(3792),
    [anon_sym_co_yield] = ACTIONS(3792),
    [anon_sym_R_DQUOTE] = ACTIONS(3794),
    [anon_sym_LR_DQUOTE] = ACTIONS(3794),
    [anon_sym_uR_DQUOTE] = ACTIONS(3794),
    [anon_sym_UR_DQUOTE] = ACTIONS(3794),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3794),
    [anon_sym_co_await] = ACTIONS(3792),
    [anon_sym_new] = ACTIONS(3792),
    [anon_sym_requires] = ACTIONS(3792),
    [sym_this] = ACTIONS(3792),
    [anon_sym_discard] = ACTIONS(3792),
    [anon_sym_precise] = ACTIONS(3792),
    [anon_sym_shared] = ACTIONS(3792),
    [anon_sym_groupshared] = ACTIONS(3792),
    [anon_sym_uniform] = ACTIONS(3792),
    [anon_sym_row_major] = ACTIONS(3792),
    [anon_sym_column_major] = ACTIONS(3792),
    [anon_sym_globallycoherent] = ACTIONS(3792),
    [anon_sym_centroid] = ACTIONS(3792),
    [anon_sym_noperspective] = ACTIONS(3792),
    [anon_sym_nointerpolation] = ACTIONS(3792),
    [anon_sym_sample] = ACTIONS(3792),
    [anon_sym_linear] = ACTIONS(3792),
    [anon_sym_snorm] = ACTIONS(3792),
    [anon_sym_unorm] = ACTIONS(3792),
    [anon_sym_point] = ACTIONS(3792),
    [anon_sym_line] = ACTIONS(3792),
    [anon_sym_triangleadj] = ACTIONS(3792),
    [anon_sym_lineadj] = ACTIONS(3792),
    [anon_sym_triangle] = ACTIONS(3792),
    [anon_sym_cbuffer] = ACTIONS(3792),
    [anon_sym_interface] = ACTIONS(3792),
    [anon_sym_extension] = ACTIONS(3792),
  },
  [573] = {
    [sym_identifier] = ACTIONS(3792),
    [aux_sym_preproc_include_token1] = ACTIONS(3792),
    [aux_sym_preproc_def_token1] = ACTIONS(3792),
    [aux_sym_preproc_if_token1] = ACTIONS(3792),
    [aux_sym_preproc_if_token2] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3792),
    [aux_sym_preproc_else_token1] = ACTIONS(3792),
    [aux_sym_preproc_elif_token1] = ACTIONS(3792),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3792),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3792),
    [sym_preproc_directive] = ACTIONS(3792),
    [anon_sym_LPAREN2] = ACTIONS(3794),
    [anon_sym_BANG] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3794),
    [anon_sym_DASH] = ACTIONS(3792),
    [anon_sym_PLUS] = ACTIONS(3792),
    [anon_sym_STAR] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_AMP] = ACTIONS(3792),
    [anon_sym_SEMI] = ACTIONS(3794),
    [anon_sym___extension__] = ACTIONS(3792),
    [anon_sym_typedef] = ACTIONS(3792),
    [anon_sym_in] = ACTIONS(3792),
    [anon_sym_out] = ACTIONS(3792),
    [anon_sym_inout] = ACTIONS(3792),
    [anon_sym_virtual] = ACTIONS(3792),
    [anon_sym_extern] = ACTIONS(3792),
    [anon_sym___attribute__] = ACTIONS(3792),
    [anon_sym___attribute] = ACTIONS(3792),
    [anon_sym_using] = ACTIONS(3792),
    [anon_sym_COLON_COLON] = ACTIONS(3794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3794),
    [anon_sym___declspec] = ACTIONS(3792),
    [anon_sym___based] = ACTIONS(3792),
    [anon_sym___cdecl] = ACTIONS(3792),
    [anon_sym___clrcall] = ACTIONS(3792),
    [anon_sym___stdcall] = ACTIONS(3792),
    [anon_sym___fastcall] = ACTIONS(3792),
    [anon_sym___thiscall] = ACTIONS(3792),
    [anon_sym___vectorcall] = ACTIONS(3792),
    [anon_sym_LBRACE] = ACTIONS(3794),
    [anon_sym_signed] = ACTIONS(3792),
    [anon_sym_unsigned] = ACTIONS(3792),
    [anon_sym_long] = ACTIONS(3792),
    [anon_sym_short] = ACTIONS(3792),
    [anon_sym_LBRACK] = ACTIONS(3792),
    [anon_sym_static] = ACTIONS(3792),
    [anon_sym_register] = ACTIONS(3792),
    [anon_sym_inline] = ACTIONS(3792),
    [anon_sym___inline] = ACTIONS(3792),
    [anon_sym___inline__] = ACTIONS(3792),
    [anon_sym___forceinline] = ACTIONS(3792),
    [anon_sym_thread_local] = ACTIONS(3792),
    [anon_sym___thread] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3792),
    [anon_sym_constexpr] = ACTIONS(3792),
    [anon_sym_volatile] = ACTIONS(3792),
    [anon_sym_restrict] = ACTIONS(3792),
    [anon_sym___restrict__] = ACTIONS(3792),
    [anon_sym__Atomic] = ACTIONS(3792),
    [anon_sym__Noreturn] = ACTIONS(3792),
    [anon_sym_noreturn] = ACTIONS(3792),
    [anon_sym__Nonnull] = ACTIONS(3792),
    [anon_sym_mutable] = ACTIONS(3792),
    [anon_sym_constinit] = ACTIONS(3792),
    [anon_sym_consteval] = ACTIONS(3792),
    [anon_sym_alignas] = ACTIONS(3792),
    [anon_sym__Alignas] = ACTIONS(3792),
    [sym_primitive_type] = ACTIONS(3792),
    [anon_sym_enum] = ACTIONS(3792),
    [anon_sym_class] = ACTIONS(3792),
    [anon_sym_struct] = ACTIONS(3792),
    [anon_sym_union] = ACTIONS(3792),
    [anon_sym_if] = ACTIONS(3792),
    [anon_sym_switch] = ACTIONS(3792),
    [anon_sym_case] = ACTIONS(3792),
    [anon_sym_default] = ACTIONS(3792),
    [anon_sym_while] = ACTIONS(3792),
    [anon_sym_do] = ACTIONS(3792),
    [anon_sym_for] = ACTIONS(3792),
    [anon_sym_return] = ACTIONS(3792),
    [anon_sym_break] = ACTIONS(3792),
    [anon_sym_continue] = ACTIONS(3792),
    [anon_sym_goto] = ACTIONS(3792),
    [anon_sym___try] = ACTIONS(3792),
    [anon_sym___leave] = ACTIONS(3792),
    [anon_sym_not] = ACTIONS(3792),
    [anon_sym_compl] = ACTIONS(3792),
    [anon_sym_DASH_DASH] = ACTIONS(3794),
    [anon_sym_PLUS_PLUS] = ACTIONS(3794),
    [anon_sym_sizeof] = ACTIONS(3792),
    [anon_sym___alignof__] = ACTIONS(3792),
    [anon_sym___alignof] = ACTIONS(3792),
    [anon_sym__alignof] = ACTIONS(3792),
    [anon_sym_alignof] = ACTIONS(3792),
    [anon_sym__Alignof] = ACTIONS(3792),
    [anon_sym_offsetof] = ACTIONS(3792),
    [anon_sym__Generic] = ACTIONS(3792),
    [anon_sym_asm] = ACTIONS(3792),
    [anon_sym___asm__] = ACTIONS(3792),
    [anon_sym___asm] = ACTIONS(3792),
    [sym_number_literal] = ACTIONS(3794),
    [anon_sym_L_SQUOTE] = ACTIONS(3794),
    [anon_sym_u_SQUOTE] = ACTIONS(3794),
    [anon_sym_U_SQUOTE] = ACTIONS(3794),
    [anon_sym_u8_SQUOTE] = ACTIONS(3794),
    [anon_sym_SQUOTE] = ACTIONS(3794),
    [anon_sym_L_DQUOTE] = ACTIONS(3794),
    [anon_sym_u_DQUOTE] = ACTIONS(3794),
    [anon_sym_U_DQUOTE] = ACTIONS(3794),
    [anon_sym_u8_DQUOTE] = ACTIONS(3794),
    [anon_sym_DQUOTE] = ACTIONS(3794),
    [sym_true] = ACTIONS(3792),
    [sym_false] = ACTIONS(3792),
    [anon_sym_NULL] = ACTIONS(3792),
    [anon_sym_nullptr] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3792),
    [anon_sym_let] = ACTIONS(3792),
    [anon_sym_This] = ACTIONS(3792),
    [anon_sym_decltype] = ACTIONS(3792),
    [anon_sym_explicit] = ACTIONS(3792),
    [anon_sym_typename] = ACTIONS(3792),
    [anon_sym_template] = ACTIONS(3792),
    [anon_sym_operator] = ACTIONS(3792),
    [anon_sym_try] = ACTIONS(3792),
    [anon_sym_delete] = ACTIONS(3792),
    [anon_sym_throw] = ACTIONS(3792),
    [anon_sym_namespace] = ACTIONS(3792),
    [anon_sym_static_assert] = ACTIONS(3792),
    [anon_sym_concept] = ACTIONS(3792),
    [anon_sym_co_return] = ACTIONS(3792),
    [anon_sym_co_yield] = ACTIONS(3792),
    [anon_sym_R_DQUOTE] = ACTIONS(3794),
    [anon_sym_LR_DQUOTE] = ACTIONS(3794),
    [anon_sym_uR_DQUOTE] = ACTIONS(3794),
    [anon_sym_UR_DQUOTE] = ACTIONS(3794),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3794),
    [anon_sym_co_await] = ACTIONS(3792),
    [anon_sym_new] = ACTIONS(3792),
    [anon_sym_requires] = ACTIONS(3792),
    [sym_this] = ACTIONS(3792),
    [anon_sym_discard] = ACTIONS(3792),
    [anon_sym_precise] = ACTIONS(3792),
    [anon_sym_shared] = ACTIONS(3792),
    [anon_sym_groupshared] = ACTIONS(3792),
    [anon_sym_uniform] = ACTIONS(3792),
    [anon_sym_row_major] = ACTIONS(3792),
    [anon_sym_column_major] = ACTIONS(3792),
    [anon_sym_globallycoherent] = ACTIONS(3792),
    [anon_sym_centroid] = ACTIONS(3792),
    [anon_sym_noperspective] = ACTIONS(3792),
    [anon_sym_nointerpolation] = ACTIONS(3792),
    [anon_sym_sample] = ACTIONS(3792),
    [anon_sym_linear] = ACTIONS(3792),
    [anon_sym_snorm] = ACTIONS(3792),
    [anon_sym_unorm] = ACTIONS(3792),
    [anon_sym_point] = ACTIONS(3792),
    [anon_sym_line] = ACTIONS(3792),
    [anon_sym_triangleadj] = ACTIONS(3792),
    [anon_sym_lineadj] = ACTIONS(3792),
    [anon_sym_triangle] = ACTIONS(3792),
    [anon_sym_cbuffer] = ACTIONS(3792),
    [anon_sym_interface] = ACTIONS(3792),
    [anon_sym_extension] = ACTIONS(3792),
  },
  [574] = {
    [sym_identifier] = ACTIONS(3796),
    [aux_sym_preproc_include_token1] = ACTIONS(3796),
    [aux_sym_preproc_def_token1] = ACTIONS(3796),
    [aux_sym_preproc_if_token1] = ACTIONS(3796),
    [aux_sym_preproc_if_token2] = ACTIONS(3796),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3796),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3796),
    [aux_sym_preproc_else_token1] = ACTIONS(3796),
    [aux_sym_preproc_elif_token1] = ACTIONS(3796),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3796),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3796),
    [sym_preproc_directive] = ACTIONS(3796),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3798),
    [anon_sym_TILDE] = ACTIONS(3798),
    [anon_sym_DASH] = ACTIONS(3796),
    [anon_sym_PLUS] = ACTIONS(3796),
    [anon_sym_STAR] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_AMP] = ACTIONS(3796),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym___extension__] = ACTIONS(3796),
    [anon_sym_typedef] = ACTIONS(3796),
    [anon_sym_in] = ACTIONS(3796),
    [anon_sym_out] = ACTIONS(3796),
    [anon_sym_inout] = ACTIONS(3796),
    [anon_sym_virtual] = ACTIONS(3796),
    [anon_sym_extern] = ACTIONS(3796),
    [anon_sym___attribute__] = ACTIONS(3796),
    [anon_sym___attribute] = ACTIONS(3796),
    [anon_sym_using] = ACTIONS(3796),
    [anon_sym_COLON_COLON] = ACTIONS(3798),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3798),
    [anon_sym___declspec] = ACTIONS(3796),
    [anon_sym___based] = ACTIONS(3796),
    [anon_sym___cdecl] = ACTIONS(3796),
    [anon_sym___clrcall] = ACTIONS(3796),
    [anon_sym___stdcall] = ACTIONS(3796),
    [anon_sym___fastcall] = ACTIONS(3796),
    [anon_sym___thiscall] = ACTIONS(3796),
    [anon_sym___vectorcall] = ACTIONS(3796),
    [anon_sym_LBRACE] = ACTIONS(3798),
    [anon_sym_signed] = ACTIONS(3796),
    [anon_sym_unsigned] = ACTIONS(3796),
    [anon_sym_long] = ACTIONS(3796),
    [anon_sym_short] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3796),
    [anon_sym_static] = ACTIONS(3796),
    [anon_sym_register] = ACTIONS(3796),
    [anon_sym_inline] = ACTIONS(3796),
    [anon_sym___inline] = ACTIONS(3796),
    [anon_sym___inline__] = ACTIONS(3796),
    [anon_sym___forceinline] = ACTIONS(3796),
    [anon_sym_thread_local] = ACTIONS(3796),
    [anon_sym___thread] = ACTIONS(3796),
    [anon_sym_const] = ACTIONS(3796),
    [anon_sym_constexpr] = ACTIONS(3796),
    [anon_sym_volatile] = ACTIONS(3796),
    [anon_sym_restrict] = ACTIONS(3796),
    [anon_sym___restrict__] = ACTIONS(3796),
    [anon_sym__Atomic] = ACTIONS(3796),
    [anon_sym__Noreturn] = ACTIONS(3796),
    [anon_sym_noreturn] = ACTIONS(3796),
    [anon_sym__Nonnull] = ACTIONS(3796),
    [anon_sym_mutable] = ACTIONS(3796),
    [anon_sym_constinit] = ACTIONS(3796),
    [anon_sym_consteval] = ACTIONS(3796),
    [anon_sym_alignas] = ACTIONS(3796),
    [anon_sym__Alignas] = ACTIONS(3796),
    [sym_primitive_type] = ACTIONS(3796),
    [anon_sym_enum] = ACTIONS(3796),
    [anon_sym_class] = ACTIONS(3796),
    [anon_sym_struct] = ACTIONS(3796),
    [anon_sym_union] = ACTIONS(3796),
    [anon_sym_if] = ACTIONS(3796),
    [anon_sym_switch] = ACTIONS(3796),
    [anon_sym_case] = ACTIONS(3796),
    [anon_sym_default] = ACTIONS(3796),
    [anon_sym_while] = ACTIONS(3796),
    [anon_sym_do] = ACTIONS(3796),
    [anon_sym_for] = ACTIONS(3796),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_continue] = ACTIONS(3796),
    [anon_sym_goto] = ACTIONS(3796),
    [anon_sym___try] = ACTIONS(3796),
    [anon_sym___leave] = ACTIONS(3796),
    [anon_sym_not] = ACTIONS(3796),
    [anon_sym_compl] = ACTIONS(3796),
    [anon_sym_DASH_DASH] = ACTIONS(3798),
    [anon_sym_PLUS_PLUS] = ACTIONS(3798),
    [anon_sym_sizeof] = ACTIONS(3796),
    [anon_sym___alignof__] = ACTIONS(3796),
    [anon_sym___alignof] = ACTIONS(3796),
    [anon_sym__alignof] = ACTIONS(3796),
    [anon_sym_alignof] = ACTIONS(3796),
    [anon_sym__Alignof] = ACTIONS(3796),
    [anon_sym_offsetof] = ACTIONS(3796),
    [anon_sym__Generic] = ACTIONS(3796),
    [anon_sym_asm] = ACTIONS(3796),
    [anon_sym___asm__] = ACTIONS(3796),
    [anon_sym___asm] = ACTIONS(3796),
    [sym_number_literal] = ACTIONS(3798),
    [anon_sym_L_SQUOTE] = ACTIONS(3798),
    [anon_sym_u_SQUOTE] = ACTIONS(3798),
    [anon_sym_U_SQUOTE] = ACTIONS(3798),
    [anon_sym_u8_SQUOTE] = ACTIONS(3798),
    [anon_sym_SQUOTE] = ACTIONS(3798),
    [anon_sym_L_DQUOTE] = ACTIONS(3798),
    [anon_sym_u_DQUOTE] = ACTIONS(3798),
    [anon_sym_U_DQUOTE] = ACTIONS(3798),
    [anon_sym_u8_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(3798),
    [sym_true] = ACTIONS(3796),
    [sym_false] = ACTIONS(3796),
    [anon_sym_NULL] = ACTIONS(3796),
    [anon_sym_nullptr] = ACTIONS(3796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3796),
    [anon_sym_let] = ACTIONS(3796),
    [anon_sym_This] = ACTIONS(3796),
    [anon_sym_decltype] = ACTIONS(3796),
    [anon_sym_explicit] = ACTIONS(3796),
    [anon_sym_typename] = ACTIONS(3796),
    [anon_sym_template] = ACTIONS(3796),
    [anon_sym_operator] = ACTIONS(3796),
    [anon_sym_try] = ACTIONS(3796),
    [anon_sym_delete] = ACTIONS(3796),
    [anon_sym_throw] = ACTIONS(3796),
    [anon_sym_namespace] = ACTIONS(3796),
    [anon_sym_static_assert] = ACTIONS(3796),
    [anon_sym_concept] = ACTIONS(3796),
    [anon_sym_co_return] = ACTIONS(3796),
    [anon_sym_co_yield] = ACTIONS(3796),
    [anon_sym_R_DQUOTE] = ACTIONS(3798),
    [anon_sym_LR_DQUOTE] = ACTIONS(3798),
    [anon_sym_uR_DQUOTE] = ACTIONS(3798),
    [anon_sym_UR_DQUOTE] = ACTIONS(3798),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3798),
    [anon_sym_co_await] = ACTIONS(3796),
    [anon_sym_new] = ACTIONS(3796),
    [anon_sym_requires] = ACTIONS(3796),
    [sym_this] = ACTIONS(3796),
    [anon_sym_discard] = ACTIONS(3796),
    [anon_sym_precise] = ACTIONS(3796),
    [anon_sym_shared] = ACTIONS(3796),
    [anon_sym_groupshared] = ACTIONS(3796),
    [anon_sym_uniform] = ACTIONS(3796),
    [anon_sym_row_major] = ACTIONS(3796),
    [anon_sym_column_major] = ACTIONS(3796),
    [anon_sym_globallycoherent] = ACTIONS(3796),
    [anon_sym_centroid] = ACTIONS(3796),
    [anon_sym_noperspective] = ACTIONS(3796),
    [anon_sym_nointerpolation] = ACTIONS(3796),
    [anon_sym_sample] = ACTIONS(3796),
    [anon_sym_linear] = ACTIONS(3796),
    [anon_sym_snorm] = ACTIONS(3796),
    [anon_sym_unorm] = ACTIONS(3796),
    [anon_sym_point] = ACTIONS(3796),
    [anon_sym_line] = ACTIONS(3796),
    [anon_sym_triangleadj] = ACTIONS(3796),
    [anon_sym_lineadj] = ACTIONS(3796),
    [anon_sym_triangle] = ACTIONS(3796),
    [anon_sym_cbuffer] = ACTIONS(3796),
    [anon_sym_interface] = ACTIONS(3796),
    [anon_sym_extension] = ACTIONS(3796),
  },
  [575] = {
    [sym_identifier] = ACTIONS(3800),
    [aux_sym_preproc_include_token1] = ACTIONS(3800),
    [aux_sym_preproc_def_token1] = ACTIONS(3800),
    [aux_sym_preproc_if_token1] = ACTIONS(3800),
    [aux_sym_preproc_if_token2] = ACTIONS(3800),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3800),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3800),
    [aux_sym_preproc_else_token1] = ACTIONS(3800),
    [aux_sym_preproc_elif_token1] = ACTIONS(3800),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3800),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3800),
    [sym_preproc_directive] = ACTIONS(3800),
    [anon_sym_LPAREN2] = ACTIONS(3802),
    [anon_sym_BANG] = ACTIONS(3802),
    [anon_sym_TILDE] = ACTIONS(3802),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_STAR] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_SEMI] = ACTIONS(3802),
    [anon_sym___extension__] = ACTIONS(3800),
    [anon_sym_typedef] = ACTIONS(3800),
    [anon_sym_in] = ACTIONS(3800),
    [anon_sym_out] = ACTIONS(3800),
    [anon_sym_inout] = ACTIONS(3800),
    [anon_sym_virtual] = ACTIONS(3800),
    [anon_sym_extern] = ACTIONS(3800),
    [anon_sym___attribute__] = ACTIONS(3800),
    [anon_sym___attribute] = ACTIONS(3800),
    [anon_sym_using] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3802),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3802),
    [anon_sym___declspec] = ACTIONS(3800),
    [anon_sym___based] = ACTIONS(3800),
    [anon_sym___cdecl] = ACTIONS(3800),
    [anon_sym___clrcall] = ACTIONS(3800),
    [anon_sym___stdcall] = ACTIONS(3800),
    [anon_sym___fastcall] = ACTIONS(3800),
    [anon_sym___thiscall] = ACTIONS(3800),
    [anon_sym___vectorcall] = ACTIONS(3800),
    [anon_sym_LBRACE] = ACTIONS(3802),
    [anon_sym_signed] = ACTIONS(3800),
    [anon_sym_unsigned] = ACTIONS(3800),
    [anon_sym_long] = ACTIONS(3800),
    [anon_sym_short] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3800),
    [anon_sym_static] = ACTIONS(3800),
    [anon_sym_register] = ACTIONS(3800),
    [anon_sym_inline] = ACTIONS(3800),
    [anon_sym___inline] = ACTIONS(3800),
    [anon_sym___inline__] = ACTIONS(3800),
    [anon_sym___forceinline] = ACTIONS(3800),
    [anon_sym_thread_local] = ACTIONS(3800),
    [anon_sym___thread] = ACTIONS(3800),
    [anon_sym_const] = ACTIONS(3800),
    [anon_sym_constexpr] = ACTIONS(3800),
    [anon_sym_volatile] = ACTIONS(3800),
    [anon_sym_restrict] = ACTIONS(3800),
    [anon_sym___restrict__] = ACTIONS(3800),
    [anon_sym__Atomic] = ACTIONS(3800),
    [anon_sym__Noreturn] = ACTIONS(3800),
    [anon_sym_noreturn] = ACTIONS(3800),
    [anon_sym__Nonnull] = ACTIONS(3800),
    [anon_sym_mutable] = ACTIONS(3800),
    [anon_sym_constinit] = ACTIONS(3800),
    [anon_sym_consteval] = ACTIONS(3800),
    [anon_sym_alignas] = ACTIONS(3800),
    [anon_sym__Alignas] = ACTIONS(3800),
    [sym_primitive_type] = ACTIONS(3800),
    [anon_sym_enum] = ACTIONS(3800),
    [anon_sym_class] = ACTIONS(3800),
    [anon_sym_struct] = ACTIONS(3800),
    [anon_sym_union] = ACTIONS(3800),
    [anon_sym_if] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(3800),
    [anon_sym_case] = ACTIONS(3800),
    [anon_sym_default] = ACTIONS(3800),
    [anon_sym_while] = ACTIONS(3800),
    [anon_sym_do] = ACTIONS(3800),
    [anon_sym_for] = ACTIONS(3800),
    [anon_sym_return] = ACTIONS(3800),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_continue] = ACTIONS(3800),
    [anon_sym_goto] = ACTIONS(3800),
    [anon_sym___try] = ACTIONS(3800),
    [anon_sym___leave] = ACTIONS(3800),
    [anon_sym_not] = ACTIONS(3800),
    [anon_sym_compl] = ACTIONS(3800),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3800),
    [anon_sym___alignof__] = ACTIONS(3800),
    [anon_sym___alignof] = ACTIONS(3800),
    [anon_sym__alignof] = ACTIONS(3800),
    [anon_sym_alignof] = ACTIONS(3800),
    [anon_sym__Alignof] = ACTIONS(3800),
    [anon_sym_offsetof] = ACTIONS(3800),
    [anon_sym__Generic] = ACTIONS(3800),
    [anon_sym_asm] = ACTIONS(3800),
    [anon_sym___asm__] = ACTIONS(3800),
    [anon_sym___asm] = ACTIONS(3800),
    [sym_number_literal] = ACTIONS(3802),
    [anon_sym_L_SQUOTE] = ACTIONS(3802),
    [anon_sym_u_SQUOTE] = ACTIONS(3802),
    [anon_sym_U_SQUOTE] = ACTIONS(3802),
    [anon_sym_u8_SQUOTE] = ACTIONS(3802),
    [anon_sym_SQUOTE] = ACTIONS(3802),
    [anon_sym_L_DQUOTE] = ACTIONS(3802),
    [anon_sym_u_DQUOTE] = ACTIONS(3802),
    [anon_sym_U_DQUOTE] = ACTIONS(3802),
    [anon_sym_u8_DQUOTE] = ACTIONS(3802),
    [anon_sym_DQUOTE] = ACTIONS(3802),
    [sym_true] = ACTIONS(3800),
    [sym_false] = ACTIONS(3800),
    [anon_sym_NULL] = ACTIONS(3800),
    [anon_sym_nullptr] = ACTIONS(3800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_This] = ACTIONS(3800),
    [anon_sym_decltype] = ACTIONS(3800),
    [anon_sym_explicit] = ACTIONS(3800),
    [anon_sym_typename] = ACTIONS(3800),
    [anon_sym_template] = ACTIONS(3800),
    [anon_sym_operator] = ACTIONS(3800),
    [anon_sym_try] = ACTIONS(3800),
    [anon_sym_delete] = ACTIONS(3800),
    [anon_sym_throw] = ACTIONS(3800),
    [anon_sym_namespace] = ACTIONS(3800),
    [anon_sym_static_assert] = ACTIONS(3800),
    [anon_sym_concept] = ACTIONS(3800),
    [anon_sym_co_return] = ACTIONS(3800),
    [anon_sym_co_yield] = ACTIONS(3800),
    [anon_sym_R_DQUOTE] = ACTIONS(3802),
    [anon_sym_LR_DQUOTE] = ACTIONS(3802),
    [anon_sym_uR_DQUOTE] = ACTIONS(3802),
    [anon_sym_UR_DQUOTE] = ACTIONS(3802),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3802),
    [anon_sym_co_await] = ACTIONS(3800),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_requires] = ACTIONS(3800),
    [sym_this] = ACTIONS(3800),
    [anon_sym_discard] = ACTIONS(3800),
    [anon_sym_precise] = ACTIONS(3800),
    [anon_sym_shared] = ACTIONS(3800),
    [anon_sym_groupshared] = ACTIONS(3800),
    [anon_sym_uniform] = ACTIONS(3800),
    [anon_sym_row_major] = ACTIONS(3800),
    [anon_sym_column_major] = ACTIONS(3800),
    [anon_sym_globallycoherent] = ACTIONS(3800),
    [anon_sym_centroid] = ACTIONS(3800),
    [anon_sym_noperspective] = ACTIONS(3800),
    [anon_sym_nointerpolation] = ACTIONS(3800),
    [anon_sym_sample] = ACTIONS(3800),
    [anon_sym_linear] = ACTIONS(3800),
    [anon_sym_snorm] = ACTIONS(3800),
    [anon_sym_unorm] = ACTIONS(3800),
    [anon_sym_point] = ACTIONS(3800),
    [anon_sym_line] = ACTIONS(3800),
    [anon_sym_triangleadj] = ACTIONS(3800),
    [anon_sym_lineadj] = ACTIONS(3800),
    [anon_sym_triangle] = ACTIONS(3800),
    [anon_sym_cbuffer] = ACTIONS(3800),
    [anon_sym_interface] = ACTIONS(3800),
    [anon_sym_extension] = ACTIONS(3800),
  },
  [576] = {
    [sym_identifier] = ACTIONS(3804),
    [aux_sym_preproc_include_token1] = ACTIONS(3804),
    [aux_sym_preproc_def_token1] = ACTIONS(3804),
    [aux_sym_preproc_if_token1] = ACTIONS(3804),
    [aux_sym_preproc_if_token2] = ACTIONS(3804),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3804),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3804),
    [aux_sym_preproc_else_token1] = ACTIONS(3804),
    [aux_sym_preproc_elif_token1] = ACTIONS(3804),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3804),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3804),
    [sym_preproc_directive] = ACTIONS(3804),
    [anon_sym_LPAREN2] = ACTIONS(3806),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(3806),
    [anon_sym_AMP_AMP] = ACTIONS(3806),
    [anon_sym_AMP] = ACTIONS(3804),
    [anon_sym_SEMI] = ACTIONS(3806),
    [anon_sym___extension__] = ACTIONS(3804),
    [anon_sym_typedef] = ACTIONS(3804),
    [anon_sym_in] = ACTIONS(3804),
    [anon_sym_out] = ACTIONS(3804),
    [anon_sym_inout] = ACTIONS(3804),
    [anon_sym_virtual] = ACTIONS(3804),
    [anon_sym_extern] = ACTIONS(3804),
    [anon_sym___attribute__] = ACTIONS(3804),
    [anon_sym___attribute] = ACTIONS(3804),
    [anon_sym_using] = ACTIONS(3804),
    [anon_sym_COLON_COLON] = ACTIONS(3806),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3806),
    [anon_sym___declspec] = ACTIONS(3804),
    [anon_sym___based] = ACTIONS(3804),
    [anon_sym___cdecl] = ACTIONS(3804),
    [anon_sym___clrcall] = ACTIONS(3804),
    [anon_sym___stdcall] = ACTIONS(3804),
    [anon_sym___fastcall] = ACTIONS(3804),
    [anon_sym___thiscall] = ACTIONS(3804),
    [anon_sym___vectorcall] = ACTIONS(3804),
    [anon_sym_LBRACE] = ACTIONS(3806),
    [anon_sym_signed] = ACTIONS(3804),
    [anon_sym_unsigned] = ACTIONS(3804),
    [anon_sym_long] = ACTIONS(3804),
    [anon_sym_short] = ACTIONS(3804),
    [anon_sym_LBRACK] = ACTIONS(3804),
    [anon_sym_static] = ACTIONS(3804),
    [anon_sym_register] = ACTIONS(3804),
    [anon_sym_inline] = ACTIONS(3804),
    [anon_sym___inline] = ACTIONS(3804),
    [anon_sym___inline__] = ACTIONS(3804),
    [anon_sym___forceinline] = ACTIONS(3804),
    [anon_sym_thread_local] = ACTIONS(3804),
    [anon_sym___thread] = ACTIONS(3804),
    [anon_sym_const] = ACTIONS(3804),
    [anon_sym_constexpr] = ACTIONS(3804),
    [anon_sym_volatile] = ACTIONS(3804),
    [anon_sym_restrict] = ACTIONS(3804),
    [anon_sym___restrict__] = ACTIONS(3804),
    [anon_sym__Atomic] = ACTIONS(3804),
    [anon_sym__Noreturn] = ACTIONS(3804),
    [anon_sym_noreturn] = ACTIONS(3804),
    [anon_sym__Nonnull] = ACTIONS(3804),
    [anon_sym_mutable] = ACTIONS(3804),
    [anon_sym_constinit] = ACTIONS(3804),
    [anon_sym_consteval] = ACTIONS(3804),
    [anon_sym_alignas] = ACTIONS(3804),
    [anon_sym__Alignas] = ACTIONS(3804),
    [sym_primitive_type] = ACTIONS(3804),
    [anon_sym_enum] = ACTIONS(3804),
    [anon_sym_class] = ACTIONS(3804),
    [anon_sym_struct] = ACTIONS(3804),
    [anon_sym_union] = ACTIONS(3804),
    [anon_sym_if] = ACTIONS(3804),
    [anon_sym_switch] = ACTIONS(3804),
    [anon_sym_case] = ACTIONS(3804),
    [anon_sym_default] = ACTIONS(3804),
    [anon_sym_while] = ACTIONS(3804),
    [anon_sym_do] = ACTIONS(3804),
    [anon_sym_for] = ACTIONS(3804),
    [anon_sym_return] = ACTIONS(3804),
    [anon_sym_break] = ACTIONS(3804),
    [anon_sym_continue] = ACTIONS(3804),
    [anon_sym_goto] = ACTIONS(3804),
    [anon_sym___try] = ACTIONS(3804),
    [anon_sym___leave] = ACTIONS(3804),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(3806),
    [anon_sym_PLUS_PLUS] = ACTIONS(3806),
    [anon_sym_sizeof] = ACTIONS(3804),
    [anon_sym___alignof__] = ACTIONS(3804),
    [anon_sym___alignof] = ACTIONS(3804),
    [anon_sym__alignof] = ACTIONS(3804),
    [anon_sym_alignof] = ACTIONS(3804),
    [anon_sym__Alignof] = ACTIONS(3804),
    [anon_sym_offsetof] = ACTIONS(3804),
    [anon_sym__Generic] = ACTIONS(3804),
    [anon_sym_asm] = ACTIONS(3804),
    [anon_sym___asm__] = ACTIONS(3804),
    [anon_sym___asm] = ACTIONS(3804),
    [sym_number_literal] = ACTIONS(3806),
    [anon_sym_L_SQUOTE] = ACTIONS(3806),
    [anon_sym_u_SQUOTE] = ACTIONS(3806),
    [anon_sym_U_SQUOTE] = ACTIONS(3806),
    [anon_sym_u8_SQUOTE] = ACTIONS(3806),
    [anon_sym_SQUOTE] = ACTIONS(3806),
    [anon_sym_L_DQUOTE] = ACTIONS(3806),
    [anon_sym_u_DQUOTE] = ACTIONS(3806),
    [anon_sym_U_DQUOTE] = ACTIONS(3806),
    [anon_sym_u8_DQUOTE] = ACTIONS(3806),
    [anon_sym_DQUOTE] = ACTIONS(3806),
    [sym_true] = ACTIONS(3804),
    [sym_false] = ACTIONS(3804),
    [anon_sym_NULL] = ACTIONS(3804),
    [anon_sym_nullptr] = ACTIONS(3804),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3804),
    [anon_sym_let] = ACTIONS(3804),
    [anon_sym_This] = ACTIONS(3804),
    [anon_sym_decltype] = ACTIONS(3804),
    [anon_sym_explicit] = ACTIONS(3804),
    [anon_sym_typename] = ACTIONS(3804),
    [anon_sym_template] = ACTIONS(3804),
    [anon_sym_operator] = ACTIONS(3804),
    [anon_sym_try] = ACTIONS(3804),
    [anon_sym_delete] = ACTIONS(3804),
    [anon_sym_throw] = ACTIONS(3804),
    [anon_sym_namespace] = ACTIONS(3804),
    [anon_sym_static_assert] = ACTIONS(3804),
    [anon_sym_concept] = ACTIONS(3804),
    [anon_sym_co_return] = ACTIONS(3804),
    [anon_sym_co_yield] = ACTIONS(3804),
    [anon_sym_R_DQUOTE] = ACTIONS(3806),
    [anon_sym_LR_DQUOTE] = ACTIONS(3806),
    [anon_sym_uR_DQUOTE] = ACTIONS(3806),
    [anon_sym_UR_DQUOTE] = ACTIONS(3806),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3806),
    [anon_sym_co_await] = ACTIONS(3804),
    [anon_sym_new] = ACTIONS(3804),
    [anon_sym_requires] = ACTIONS(3804),
    [sym_this] = ACTIONS(3804),
    [anon_sym_discard] = ACTIONS(3804),
    [anon_sym_precise] = ACTIONS(3804),
    [anon_sym_shared] = ACTIONS(3804),
    [anon_sym_groupshared] = ACTIONS(3804),
    [anon_sym_uniform] = ACTIONS(3804),
    [anon_sym_row_major] = ACTIONS(3804),
    [anon_sym_column_major] = ACTIONS(3804),
    [anon_sym_globallycoherent] = ACTIONS(3804),
    [anon_sym_centroid] = ACTIONS(3804),
    [anon_sym_noperspective] = ACTIONS(3804),
    [anon_sym_nointerpolation] = ACTIONS(3804),
    [anon_sym_sample] = ACTIONS(3804),
    [anon_sym_linear] = ACTIONS(3804),
    [anon_sym_snorm] = ACTIONS(3804),
    [anon_sym_unorm] = ACTIONS(3804),
    [anon_sym_point] = ACTIONS(3804),
    [anon_sym_line] = ACTIONS(3804),
    [anon_sym_triangleadj] = ACTIONS(3804),
    [anon_sym_lineadj] = ACTIONS(3804),
    [anon_sym_triangle] = ACTIONS(3804),
    [anon_sym_cbuffer] = ACTIONS(3804),
    [anon_sym_interface] = ACTIONS(3804),
    [anon_sym_extension] = ACTIONS(3804),
  },
  [577] = {
    [sym_identifier] = ACTIONS(3808),
    [aux_sym_preproc_include_token1] = ACTIONS(3808),
    [aux_sym_preproc_def_token1] = ACTIONS(3808),
    [aux_sym_preproc_if_token1] = ACTIONS(3808),
    [aux_sym_preproc_if_token2] = ACTIONS(3808),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3808),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3808),
    [aux_sym_preproc_else_token1] = ACTIONS(3808),
    [aux_sym_preproc_elif_token1] = ACTIONS(3808),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3808),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3808),
    [sym_preproc_directive] = ACTIONS(3808),
    [anon_sym_LPAREN2] = ACTIONS(3810),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [anon_sym_DASH] = ACTIONS(3808),
    [anon_sym_PLUS] = ACTIONS(3808),
    [anon_sym_STAR] = ACTIONS(3810),
    [anon_sym_AMP_AMP] = ACTIONS(3810),
    [anon_sym_AMP] = ACTIONS(3808),
    [anon_sym_SEMI] = ACTIONS(3810),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_typedef] = ACTIONS(3808),
    [anon_sym_in] = ACTIONS(3808),
    [anon_sym_out] = ACTIONS(3808),
    [anon_sym_inout] = ACTIONS(3808),
    [anon_sym_virtual] = ACTIONS(3808),
    [anon_sym_extern] = ACTIONS(3808),
    [anon_sym___attribute__] = ACTIONS(3808),
    [anon_sym___attribute] = ACTIONS(3808),
    [anon_sym_using] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3810),
    [anon_sym___declspec] = ACTIONS(3808),
    [anon_sym___based] = ACTIONS(3808),
    [anon_sym___cdecl] = ACTIONS(3808),
    [anon_sym___clrcall] = ACTIONS(3808),
    [anon_sym___stdcall] = ACTIONS(3808),
    [anon_sym___fastcall] = ACTIONS(3808),
    [anon_sym___thiscall] = ACTIONS(3808),
    [anon_sym___vectorcall] = ACTIONS(3808),
    [anon_sym_LBRACE] = ACTIONS(3810),
    [anon_sym_signed] = ACTIONS(3808),
    [anon_sym_unsigned] = ACTIONS(3808),
    [anon_sym_long] = ACTIONS(3808),
    [anon_sym_short] = ACTIONS(3808),
    [anon_sym_LBRACK] = ACTIONS(3808),
    [anon_sym_static] = ACTIONS(3808),
    [anon_sym_register] = ACTIONS(3808),
    [anon_sym_inline] = ACTIONS(3808),
    [anon_sym___inline] = ACTIONS(3808),
    [anon_sym___inline__] = ACTIONS(3808),
    [anon_sym___forceinline] = ACTIONS(3808),
    [anon_sym_thread_local] = ACTIONS(3808),
    [anon_sym___thread] = ACTIONS(3808),
    [anon_sym_const] = ACTIONS(3808),
    [anon_sym_constexpr] = ACTIONS(3808),
    [anon_sym_volatile] = ACTIONS(3808),
    [anon_sym_restrict] = ACTIONS(3808),
    [anon_sym___restrict__] = ACTIONS(3808),
    [anon_sym__Atomic] = ACTIONS(3808),
    [anon_sym__Noreturn] = ACTIONS(3808),
    [anon_sym_noreturn] = ACTIONS(3808),
    [anon_sym__Nonnull] = ACTIONS(3808),
    [anon_sym_mutable] = ACTIONS(3808),
    [anon_sym_constinit] = ACTIONS(3808),
    [anon_sym_consteval] = ACTIONS(3808),
    [anon_sym_alignas] = ACTIONS(3808),
    [anon_sym__Alignas] = ACTIONS(3808),
    [sym_primitive_type] = ACTIONS(3808),
    [anon_sym_enum] = ACTIONS(3808),
    [anon_sym_class] = ACTIONS(3808),
    [anon_sym_struct] = ACTIONS(3808),
    [anon_sym_union] = ACTIONS(3808),
    [anon_sym_if] = ACTIONS(3808),
    [anon_sym_switch] = ACTIONS(3808),
    [anon_sym_case] = ACTIONS(3808),
    [anon_sym_default] = ACTIONS(3808),
    [anon_sym_while] = ACTIONS(3808),
    [anon_sym_do] = ACTIONS(3808),
    [anon_sym_for] = ACTIONS(3808),
    [anon_sym_return] = ACTIONS(3808),
    [anon_sym_break] = ACTIONS(3808),
    [anon_sym_continue] = ACTIONS(3808),
    [anon_sym_goto] = ACTIONS(3808),
    [anon_sym___try] = ACTIONS(3808),
    [anon_sym___leave] = ACTIONS(3808),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_compl] = ACTIONS(3808),
    [anon_sym_DASH_DASH] = ACTIONS(3810),
    [anon_sym_PLUS_PLUS] = ACTIONS(3810),
    [anon_sym_sizeof] = ACTIONS(3808),
    [anon_sym___alignof__] = ACTIONS(3808),
    [anon_sym___alignof] = ACTIONS(3808),
    [anon_sym__alignof] = ACTIONS(3808),
    [anon_sym_alignof] = ACTIONS(3808),
    [anon_sym__Alignof] = ACTIONS(3808),
    [anon_sym_offsetof] = ACTIONS(3808),
    [anon_sym__Generic] = ACTIONS(3808),
    [anon_sym_asm] = ACTIONS(3808),
    [anon_sym___asm__] = ACTIONS(3808),
    [anon_sym___asm] = ACTIONS(3808),
    [sym_number_literal] = ACTIONS(3810),
    [anon_sym_L_SQUOTE] = ACTIONS(3810),
    [anon_sym_u_SQUOTE] = ACTIONS(3810),
    [anon_sym_U_SQUOTE] = ACTIONS(3810),
    [anon_sym_u8_SQUOTE] = ACTIONS(3810),
    [anon_sym_SQUOTE] = ACTIONS(3810),
    [anon_sym_L_DQUOTE] = ACTIONS(3810),
    [anon_sym_u_DQUOTE] = ACTIONS(3810),
    [anon_sym_U_DQUOTE] = ACTIONS(3810),
    [anon_sym_u8_DQUOTE] = ACTIONS(3810),
    [anon_sym_DQUOTE] = ACTIONS(3810),
    [sym_true] = ACTIONS(3808),
    [sym_false] = ACTIONS(3808),
    [anon_sym_NULL] = ACTIONS(3808),
    [anon_sym_nullptr] = ACTIONS(3808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3808),
    [anon_sym_let] = ACTIONS(3808),
    [anon_sym_This] = ACTIONS(3808),
    [anon_sym_decltype] = ACTIONS(3808),
    [anon_sym_explicit] = ACTIONS(3808),
    [anon_sym_typename] = ACTIONS(3808),
    [anon_sym_template] = ACTIONS(3808),
    [anon_sym_operator] = ACTIONS(3808),
    [anon_sym_try] = ACTIONS(3808),
    [anon_sym_delete] = ACTIONS(3808),
    [anon_sym_throw] = ACTIONS(3808),
    [anon_sym_namespace] = ACTIONS(3808),
    [anon_sym_static_assert] = ACTIONS(3808),
    [anon_sym_concept] = ACTIONS(3808),
    [anon_sym_co_return] = ACTIONS(3808),
    [anon_sym_co_yield] = ACTIONS(3808),
    [anon_sym_R_DQUOTE] = ACTIONS(3810),
    [anon_sym_LR_DQUOTE] = ACTIONS(3810),
    [anon_sym_uR_DQUOTE] = ACTIONS(3810),
    [anon_sym_UR_DQUOTE] = ACTIONS(3810),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3810),
    [anon_sym_co_await] = ACTIONS(3808),
    [anon_sym_new] = ACTIONS(3808),
    [anon_sym_requires] = ACTIONS(3808),
    [sym_this] = ACTIONS(3808),
    [anon_sym_discard] = ACTIONS(3808),
    [anon_sym_precise] = ACTIONS(3808),
    [anon_sym_shared] = ACTIONS(3808),
    [anon_sym_groupshared] = ACTIONS(3808),
    [anon_sym_uniform] = ACTIONS(3808),
    [anon_sym_row_major] = ACTIONS(3808),
    [anon_sym_column_major] = ACTIONS(3808),
    [anon_sym_globallycoherent] = ACTIONS(3808),
    [anon_sym_centroid] = ACTIONS(3808),
    [anon_sym_noperspective] = ACTIONS(3808),
    [anon_sym_nointerpolation] = ACTIONS(3808),
    [anon_sym_sample] = ACTIONS(3808),
    [anon_sym_linear] = ACTIONS(3808),
    [anon_sym_snorm] = ACTIONS(3808),
    [anon_sym_unorm] = ACTIONS(3808),
    [anon_sym_point] = ACTIONS(3808),
    [anon_sym_line] = ACTIONS(3808),
    [anon_sym_triangleadj] = ACTIONS(3808),
    [anon_sym_lineadj] = ACTIONS(3808),
    [anon_sym_triangle] = ACTIONS(3808),
    [anon_sym_cbuffer] = ACTIONS(3808),
    [anon_sym_interface] = ACTIONS(3808),
    [anon_sym_extension] = ACTIONS(3808),
  },
  [578] = {
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_include_token1] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token2] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [aux_sym_preproc_else_token1] = ACTIONS(3812),
    [aux_sym_preproc_elif_token1] = ACTIONS(3812),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_BANG] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3812),
    [anon_sym_PLUS] = ACTIONS(3812),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym___cdecl] = ACTIONS(3812),
    [anon_sym___clrcall] = ACTIONS(3812),
    [anon_sym___stdcall] = ACTIONS(3812),
    [anon_sym___fastcall] = ACTIONS(3812),
    [anon_sym___thiscall] = ACTIONS(3812),
    [anon_sym___vectorcall] = ACTIONS(3812),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [anon_sym_if] = ACTIONS(3812),
    [anon_sym_switch] = ACTIONS(3812),
    [anon_sym_case] = ACTIONS(3812),
    [anon_sym_default] = ACTIONS(3812),
    [anon_sym_while] = ACTIONS(3812),
    [anon_sym_do] = ACTIONS(3812),
    [anon_sym_for] = ACTIONS(3812),
    [anon_sym_return] = ACTIONS(3812),
    [anon_sym_break] = ACTIONS(3812),
    [anon_sym_continue] = ACTIONS(3812),
    [anon_sym_goto] = ACTIONS(3812),
    [anon_sym___try] = ACTIONS(3812),
    [anon_sym___leave] = ACTIONS(3812),
    [anon_sym_not] = ACTIONS(3812),
    [anon_sym_compl] = ACTIONS(3812),
    [anon_sym_DASH_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_PLUS] = ACTIONS(3814),
    [anon_sym_sizeof] = ACTIONS(3812),
    [anon_sym___alignof__] = ACTIONS(3812),
    [anon_sym___alignof] = ACTIONS(3812),
    [anon_sym__alignof] = ACTIONS(3812),
    [anon_sym_alignof] = ACTIONS(3812),
    [anon_sym__Alignof] = ACTIONS(3812),
    [anon_sym_offsetof] = ACTIONS(3812),
    [anon_sym__Generic] = ACTIONS(3812),
    [anon_sym_asm] = ACTIONS(3812),
    [anon_sym___asm__] = ACTIONS(3812),
    [anon_sym___asm] = ACTIONS(3812),
    [sym_number_literal] = ACTIONS(3814),
    [anon_sym_L_SQUOTE] = ACTIONS(3814),
    [anon_sym_u_SQUOTE] = ACTIONS(3814),
    [anon_sym_U_SQUOTE] = ACTIONS(3814),
    [anon_sym_u8_SQUOTE] = ACTIONS(3814),
    [anon_sym_SQUOTE] = ACTIONS(3814),
    [anon_sym_L_DQUOTE] = ACTIONS(3814),
    [anon_sym_u_DQUOTE] = ACTIONS(3814),
    [anon_sym_U_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [anon_sym_NULL] = ACTIONS(3812),
    [anon_sym_nullptr] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_try] = ACTIONS(3812),
    [anon_sym_delete] = ACTIONS(3812),
    [anon_sym_throw] = ACTIONS(3812),
    [anon_sym_namespace] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_concept] = ACTIONS(3812),
    [anon_sym_co_return] = ACTIONS(3812),
    [anon_sym_co_yield] = ACTIONS(3812),
    [anon_sym_R_DQUOTE] = ACTIONS(3814),
    [anon_sym_LR_DQUOTE] = ACTIONS(3814),
    [anon_sym_uR_DQUOTE] = ACTIONS(3814),
    [anon_sym_UR_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3814),
    [anon_sym_co_await] = ACTIONS(3812),
    [anon_sym_new] = ACTIONS(3812),
    [anon_sym_requires] = ACTIONS(3812),
    [sym_this] = ACTIONS(3812),
    [anon_sym_discard] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_cbuffer] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
  },
  [579] = {
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_include_token1] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token2] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [aux_sym_preproc_else_token1] = ACTIONS(3812),
    [aux_sym_preproc_elif_token1] = ACTIONS(3812),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_BANG] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3812),
    [anon_sym_PLUS] = ACTIONS(3812),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym___cdecl] = ACTIONS(3812),
    [anon_sym___clrcall] = ACTIONS(3812),
    [anon_sym___stdcall] = ACTIONS(3812),
    [anon_sym___fastcall] = ACTIONS(3812),
    [anon_sym___thiscall] = ACTIONS(3812),
    [anon_sym___vectorcall] = ACTIONS(3812),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [anon_sym_if] = ACTIONS(3812),
    [anon_sym_switch] = ACTIONS(3812),
    [anon_sym_case] = ACTIONS(3812),
    [anon_sym_default] = ACTIONS(3812),
    [anon_sym_while] = ACTIONS(3812),
    [anon_sym_do] = ACTIONS(3812),
    [anon_sym_for] = ACTIONS(3812),
    [anon_sym_return] = ACTIONS(3812),
    [anon_sym_break] = ACTIONS(3812),
    [anon_sym_continue] = ACTIONS(3812),
    [anon_sym_goto] = ACTIONS(3812),
    [anon_sym___try] = ACTIONS(3812),
    [anon_sym___leave] = ACTIONS(3812),
    [anon_sym_not] = ACTIONS(3812),
    [anon_sym_compl] = ACTIONS(3812),
    [anon_sym_DASH_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_PLUS] = ACTIONS(3814),
    [anon_sym_sizeof] = ACTIONS(3812),
    [anon_sym___alignof__] = ACTIONS(3812),
    [anon_sym___alignof] = ACTIONS(3812),
    [anon_sym__alignof] = ACTIONS(3812),
    [anon_sym_alignof] = ACTIONS(3812),
    [anon_sym__Alignof] = ACTIONS(3812),
    [anon_sym_offsetof] = ACTIONS(3812),
    [anon_sym__Generic] = ACTIONS(3812),
    [anon_sym_asm] = ACTIONS(3812),
    [anon_sym___asm__] = ACTIONS(3812),
    [anon_sym___asm] = ACTIONS(3812),
    [sym_number_literal] = ACTIONS(3814),
    [anon_sym_L_SQUOTE] = ACTIONS(3814),
    [anon_sym_u_SQUOTE] = ACTIONS(3814),
    [anon_sym_U_SQUOTE] = ACTIONS(3814),
    [anon_sym_u8_SQUOTE] = ACTIONS(3814),
    [anon_sym_SQUOTE] = ACTIONS(3814),
    [anon_sym_L_DQUOTE] = ACTIONS(3814),
    [anon_sym_u_DQUOTE] = ACTIONS(3814),
    [anon_sym_U_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [anon_sym_NULL] = ACTIONS(3812),
    [anon_sym_nullptr] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_try] = ACTIONS(3812),
    [anon_sym_delete] = ACTIONS(3812),
    [anon_sym_throw] = ACTIONS(3812),
    [anon_sym_namespace] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_concept] = ACTIONS(3812),
    [anon_sym_co_return] = ACTIONS(3812),
    [anon_sym_co_yield] = ACTIONS(3812),
    [anon_sym_R_DQUOTE] = ACTIONS(3814),
    [anon_sym_LR_DQUOTE] = ACTIONS(3814),
    [anon_sym_uR_DQUOTE] = ACTIONS(3814),
    [anon_sym_UR_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3814),
    [anon_sym_co_await] = ACTIONS(3812),
    [anon_sym_new] = ACTIONS(3812),
    [anon_sym_requires] = ACTIONS(3812),
    [sym_this] = ACTIONS(3812),
    [anon_sym_discard] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_cbuffer] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
  },
  [580] = {
    [sym_identifier] = ACTIONS(3816),
    [aux_sym_preproc_include_token1] = ACTIONS(3816),
    [aux_sym_preproc_def_token1] = ACTIONS(3816),
    [aux_sym_preproc_if_token1] = ACTIONS(3816),
    [aux_sym_preproc_if_token2] = ACTIONS(3816),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3816),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3816),
    [aux_sym_preproc_else_token1] = ACTIONS(3816),
    [aux_sym_preproc_elif_token1] = ACTIONS(3816),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3816),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3816),
    [sym_preproc_directive] = ACTIONS(3816),
    [anon_sym_LPAREN2] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3818),
    [anon_sym_TILDE] = ACTIONS(3818),
    [anon_sym_DASH] = ACTIONS(3816),
    [anon_sym_PLUS] = ACTIONS(3816),
    [anon_sym_STAR] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_SEMI] = ACTIONS(3818),
    [anon_sym___extension__] = ACTIONS(3816),
    [anon_sym_typedef] = ACTIONS(3816),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_out] = ACTIONS(3816),
    [anon_sym_inout] = ACTIONS(3816),
    [anon_sym_virtual] = ACTIONS(3816),
    [anon_sym_extern] = ACTIONS(3816),
    [anon_sym___attribute__] = ACTIONS(3816),
    [anon_sym___attribute] = ACTIONS(3816),
    [anon_sym_using] = ACTIONS(3816),
    [anon_sym_COLON_COLON] = ACTIONS(3818),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3818),
    [anon_sym___declspec] = ACTIONS(3816),
    [anon_sym___based] = ACTIONS(3816),
    [anon_sym___cdecl] = ACTIONS(3816),
    [anon_sym___clrcall] = ACTIONS(3816),
    [anon_sym___stdcall] = ACTIONS(3816),
    [anon_sym___fastcall] = ACTIONS(3816),
    [anon_sym___thiscall] = ACTIONS(3816),
    [anon_sym___vectorcall] = ACTIONS(3816),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_signed] = ACTIONS(3816),
    [anon_sym_unsigned] = ACTIONS(3816),
    [anon_sym_long] = ACTIONS(3816),
    [anon_sym_short] = ACTIONS(3816),
    [anon_sym_LBRACK] = ACTIONS(3816),
    [anon_sym_static] = ACTIONS(3816),
    [anon_sym_register] = ACTIONS(3816),
    [anon_sym_inline] = ACTIONS(3816),
    [anon_sym___inline] = ACTIONS(3816),
    [anon_sym___inline__] = ACTIONS(3816),
    [anon_sym___forceinline] = ACTIONS(3816),
    [anon_sym_thread_local] = ACTIONS(3816),
    [anon_sym___thread] = ACTIONS(3816),
    [anon_sym_const] = ACTIONS(3816),
    [anon_sym_constexpr] = ACTIONS(3816),
    [anon_sym_volatile] = ACTIONS(3816),
    [anon_sym_restrict] = ACTIONS(3816),
    [anon_sym___restrict__] = ACTIONS(3816),
    [anon_sym__Atomic] = ACTIONS(3816),
    [anon_sym__Noreturn] = ACTIONS(3816),
    [anon_sym_noreturn] = ACTIONS(3816),
    [anon_sym__Nonnull] = ACTIONS(3816),
    [anon_sym_mutable] = ACTIONS(3816),
    [anon_sym_constinit] = ACTIONS(3816),
    [anon_sym_consteval] = ACTIONS(3816),
    [anon_sym_alignas] = ACTIONS(3816),
    [anon_sym__Alignas] = ACTIONS(3816),
    [sym_primitive_type] = ACTIONS(3816),
    [anon_sym_enum] = ACTIONS(3816),
    [anon_sym_class] = ACTIONS(3816),
    [anon_sym_struct] = ACTIONS(3816),
    [anon_sym_union] = ACTIONS(3816),
    [anon_sym_if] = ACTIONS(3816),
    [anon_sym_switch] = ACTIONS(3816),
    [anon_sym_case] = ACTIONS(3816),
    [anon_sym_default] = ACTIONS(3816),
    [anon_sym_while] = ACTIONS(3816),
    [anon_sym_do] = ACTIONS(3816),
    [anon_sym_for] = ACTIONS(3816),
    [anon_sym_return] = ACTIONS(3816),
    [anon_sym_break] = ACTIONS(3816),
    [anon_sym_continue] = ACTIONS(3816),
    [anon_sym_goto] = ACTIONS(3816),
    [anon_sym___try] = ACTIONS(3816),
    [anon_sym___leave] = ACTIONS(3816),
    [anon_sym_not] = ACTIONS(3816),
    [anon_sym_compl] = ACTIONS(3816),
    [anon_sym_DASH_DASH] = ACTIONS(3818),
    [anon_sym_PLUS_PLUS] = ACTIONS(3818),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3816),
    [anon_sym___alignof] = ACTIONS(3816),
    [anon_sym__alignof] = ACTIONS(3816),
    [anon_sym_alignof] = ACTIONS(3816),
    [anon_sym__Alignof] = ACTIONS(3816),
    [anon_sym_offsetof] = ACTIONS(3816),
    [anon_sym__Generic] = ACTIONS(3816),
    [anon_sym_asm] = ACTIONS(3816),
    [anon_sym___asm__] = ACTIONS(3816),
    [anon_sym___asm] = ACTIONS(3816),
    [sym_number_literal] = ACTIONS(3818),
    [anon_sym_L_SQUOTE] = ACTIONS(3818),
    [anon_sym_u_SQUOTE] = ACTIONS(3818),
    [anon_sym_U_SQUOTE] = ACTIONS(3818),
    [anon_sym_u8_SQUOTE] = ACTIONS(3818),
    [anon_sym_SQUOTE] = ACTIONS(3818),
    [anon_sym_L_DQUOTE] = ACTIONS(3818),
    [anon_sym_u_DQUOTE] = ACTIONS(3818),
    [anon_sym_U_DQUOTE] = ACTIONS(3818),
    [anon_sym_u8_DQUOTE] = ACTIONS(3818),
    [anon_sym_DQUOTE] = ACTIONS(3818),
    [sym_true] = ACTIONS(3816),
    [sym_false] = ACTIONS(3816),
    [anon_sym_NULL] = ACTIONS(3816),
    [anon_sym_nullptr] = ACTIONS(3816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3816),
    [anon_sym_let] = ACTIONS(3816),
    [anon_sym_This] = ACTIONS(3816),
    [anon_sym_decltype] = ACTIONS(3816),
    [anon_sym_explicit] = ACTIONS(3816),
    [anon_sym_typename] = ACTIONS(3816),
    [anon_sym_template] = ACTIONS(3816),
    [anon_sym_operator] = ACTIONS(3816),
    [anon_sym_try] = ACTIONS(3816),
    [anon_sym_delete] = ACTIONS(3816),
    [anon_sym_throw] = ACTIONS(3816),
    [anon_sym_namespace] = ACTIONS(3816),
    [anon_sym_static_assert] = ACTIONS(3816),
    [anon_sym_concept] = ACTIONS(3816),
    [anon_sym_co_return] = ACTIONS(3816),
    [anon_sym_co_yield] = ACTIONS(3816),
    [anon_sym_R_DQUOTE] = ACTIONS(3818),
    [anon_sym_LR_DQUOTE] = ACTIONS(3818),
    [anon_sym_uR_DQUOTE] = ACTIONS(3818),
    [anon_sym_UR_DQUOTE] = ACTIONS(3818),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3818),
    [anon_sym_co_await] = ACTIONS(3816),
    [anon_sym_new] = ACTIONS(3816),
    [anon_sym_requires] = ACTIONS(3816),
    [sym_this] = ACTIONS(3816),
    [anon_sym_discard] = ACTIONS(3816),
    [anon_sym_precise] = ACTIONS(3816),
    [anon_sym_shared] = ACTIONS(3816),
    [anon_sym_groupshared] = ACTIONS(3816),
    [anon_sym_uniform] = ACTIONS(3816),
    [anon_sym_row_major] = ACTIONS(3816),
    [anon_sym_column_major] = ACTIONS(3816),
    [anon_sym_globallycoherent] = ACTIONS(3816),
    [anon_sym_centroid] = ACTIONS(3816),
    [anon_sym_noperspective] = ACTIONS(3816),
    [anon_sym_nointerpolation] = ACTIONS(3816),
    [anon_sym_sample] = ACTIONS(3816),
    [anon_sym_linear] = ACTIONS(3816),
    [anon_sym_snorm] = ACTIONS(3816),
    [anon_sym_unorm] = ACTIONS(3816),
    [anon_sym_point] = ACTIONS(3816),
    [anon_sym_line] = ACTIONS(3816),
    [anon_sym_triangleadj] = ACTIONS(3816),
    [anon_sym_lineadj] = ACTIONS(3816),
    [anon_sym_triangle] = ACTIONS(3816),
    [anon_sym_cbuffer] = ACTIONS(3816),
    [anon_sym_interface] = ACTIONS(3816),
    [anon_sym_extension] = ACTIONS(3816),
  },
  [581] = {
    [sym_identifier] = ACTIONS(3820),
    [aux_sym_preproc_include_token1] = ACTIONS(3820),
    [aux_sym_preproc_def_token1] = ACTIONS(3820),
    [aux_sym_preproc_if_token1] = ACTIONS(3820),
    [aux_sym_preproc_if_token2] = ACTIONS(3820),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3820),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3820),
    [aux_sym_preproc_else_token1] = ACTIONS(3820),
    [aux_sym_preproc_elif_token1] = ACTIONS(3820),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3820),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3820),
    [sym_preproc_directive] = ACTIONS(3820),
    [anon_sym_LPAREN2] = ACTIONS(3822),
    [anon_sym_BANG] = ACTIONS(3822),
    [anon_sym_TILDE] = ACTIONS(3822),
    [anon_sym_DASH] = ACTIONS(3820),
    [anon_sym_PLUS] = ACTIONS(3820),
    [anon_sym_STAR] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3822),
    [anon_sym_AMP] = ACTIONS(3820),
    [anon_sym_SEMI] = ACTIONS(3822),
    [anon_sym___extension__] = ACTIONS(3820),
    [anon_sym_typedef] = ACTIONS(3820),
    [anon_sym_in] = ACTIONS(3820),
    [anon_sym_out] = ACTIONS(3820),
    [anon_sym_inout] = ACTIONS(3820),
    [anon_sym_virtual] = ACTIONS(3820),
    [anon_sym_extern] = ACTIONS(3820),
    [anon_sym___attribute__] = ACTIONS(3820),
    [anon_sym___attribute] = ACTIONS(3820),
    [anon_sym_using] = ACTIONS(3820),
    [anon_sym_COLON_COLON] = ACTIONS(3822),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3822),
    [anon_sym___declspec] = ACTIONS(3820),
    [anon_sym___based] = ACTIONS(3820),
    [anon_sym___cdecl] = ACTIONS(3820),
    [anon_sym___clrcall] = ACTIONS(3820),
    [anon_sym___stdcall] = ACTIONS(3820),
    [anon_sym___fastcall] = ACTIONS(3820),
    [anon_sym___thiscall] = ACTIONS(3820),
    [anon_sym___vectorcall] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3822),
    [anon_sym_signed] = ACTIONS(3820),
    [anon_sym_unsigned] = ACTIONS(3820),
    [anon_sym_long] = ACTIONS(3820),
    [anon_sym_short] = ACTIONS(3820),
    [anon_sym_LBRACK] = ACTIONS(3820),
    [anon_sym_static] = ACTIONS(3820),
    [anon_sym_register] = ACTIONS(3820),
    [anon_sym_inline] = ACTIONS(3820),
    [anon_sym___inline] = ACTIONS(3820),
    [anon_sym___inline__] = ACTIONS(3820),
    [anon_sym___forceinline] = ACTIONS(3820),
    [anon_sym_thread_local] = ACTIONS(3820),
    [anon_sym___thread] = ACTIONS(3820),
    [anon_sym_const] = ACTIONS(3820),
    [anon_sym_constexpr] = ACTIONS(3820),
    [anon_sym_volatile] = ACTIONS(3820),
    [anon_sym_restrict] = ACTIONS(3820),
    [anon_sym___restrict__] = ACTIONS(3820),
    [anon_sym__Atomic] = ACTIONS(3820),
    [anon_sym__Noreturn] = ACTIONS(3820),
    [anon_sym_noreturn] = ACTIONS(3820),
    [anon_sym__Nonnull] = ACTIONS(3820),
    [anon_sym_mutable] = ACTIONS(3820),
    [anon_sym_constinit] = ACTIONS(3820),
    [anon_sym_consteval] = ACTIONS(3820),
    [anon_sym_alignas] = ACTIONS(3820),
    [anon_sym__Alignas] = ACTIONS(3820),
    [sym_primitive_type] = ACTIONS(3820),
    [anon_sym_enum] = ACTIONS(3820),
    [anon_sym_class] = ACTIONS(3820),
    [anon_sym_struct] = ACTIONS(3820),
    [anon_sym_union] = ACTIONS(3820),
    [anon_sym_if] = ACTIONS(3820),
    [anon_sym_switch] = ACTIONS(3820),
    [anon_sym_case] = ACTIONS(3820),
    [anon_sym_default] = ACTIONS(3820),
    [anon_sym_while] = ACTIONS(3820),
    [anon_sym_do] = ACTIONS(3820),
    [anon_sym_for] = ACTIONS(3820),
    [anon_sym_return] = ACTIONS(3820),
    [anon_sym_break] = ACTIONS(3820),
    [anon_sym_continue] = ACTIONS(3820),
    [anon_sym_goto] = ACTIONS(3820),
    [anon_sym___try] = ACTIONS(3820),
    [anon_sym___leave] = ACTIONS(3820),
    [anon_sym_not] = ACTIONS(3820),
    [anon_sym_compl] = ACTIONS(3820),
    [anon_sym_DASH_DASH] = ACTIONS(3822),
    [anon_sym_PLUS_PLUS] = ACTIONS(3822),
    [anon_sym_sizeof] = ACTIONS(3820),
    [anon_sym___alignof__] = ACTIONS(3820),
    [anon_sym___alignof] = ACTIONS(3820),
    [anon_sym__alignof] = ACTIONS(3820),
    [anon_sym_alignof] = ACTIONS(3820),
    [anon_sym__Alignof] = ACTIONS(3820),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3820),
    [anon_sym_asm] = ACTIONS(3820),
    [anon_sym___asm__] = ACTIONS(3820),
    [anon_sym___asm] = ACTIONS(3820),
    [sym_number_literal] = ACTIONS(3822),
    [anon_sym_L_SQUOTE] = ACTIONS(3822),
    [anon_sym_u_SQUOTE] = ACTIONS(3822),
    [anon_sym_U_SQUOTE] = ACTIONS(3822),
    [anon_sym_u8_SQUOTE] = ACTIONS(3822),
    [anon_sym_SQUOTE] = ACTIONS(3822),
    [anon_sym_L_DQUOTE] = ACTIONS(3822),
    [anon_sym_u_DQUOTE] = ACTIONS(3822),
    [anon_sym_U_DQUOTE] = ACTIONS(3822),
    [anon_sym_u8_DQUOTE] = ACTIONS(3822),
    [anon_sym_DQUOTE] = ACTIONS(3822),
    [sym_true] = ACTIONS(3820),
    [sym_false] = ACTIONS(3820),
    [anon_sym_NULL] = ACTIONS(3820),
    [anon_sym_nullptr] = ACTIONS(3820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3820),
    [anon_sym_let] = ACTIONS(3820),
    [anon_sym_This] = ACTIONS(3820),
    [anon_sym_decltype] = ACTIONS(3820),
    [anon_sym_explicit] = ACTIONS(3820),
    [anon_sym_typename] = ACTIONS(3820),
    [anon_sym_template] = ACTIONS(3820),
    [anon_sym_operator] = ACTIONS(3820),
    [anon_sym_try] = ACTIONS(3820),
    [anon_sym_delete] = ACTIONS(3820),
    [anon_sym_throw] = ACTIONS(3820),
    [anon_sym_namespace] = ACTIONS(3820),
    [anon_sym_static_assert] = ACTIONS(3820),
    [anon_sym_concept] = ACTIONS(3820),
    [anon_sym_co_return] = ACTIONS(3820),
    [anon_sym_co_yield] = ACTIONS(3820),
    [anon_sym_R_DQUOTE] = ACTIONS(3822),
    [anon_sym_LR_DQUOTE] = ACTIONS(3822),
    [anon_sym_uR_DQUOTE] = ACTIONS(3822),
    [anon_sym_UR_DQUOTE] = ACTIONS(3822),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3822),
    [anon_sym_co_await] = ACTIONS(3820),
    [anon_sym_new] = ACTIONS(3820),
    [anon_sym_requires] = ACTIONS(3820),
    [sym_this] = ACTIONS(3820),
    [anon_sym_discard] = ACTIONS(3820),
    [anon_sym_precise] = ACTIONS(3820),
    [anon_sym_shared] = ACTIONS(3820),
    [anon_sym_groupshared] = ACTIONS(3820),
    [anon_sym_uniform] = ACTIONS(3820),
    [anon_sym_row_major] = ACTIONS(3820),
    [anon_sym_column_major] = ACTIONS(3820),
    [anon_sym_globallycoherent] = ACTIONS(3820),
    [anon_sym_centroid] = ACTIONS(3820),
    [anon_sym_noperspective] = ACTIONS(3820),
    [anon_sym_nointerpolation] = ACTIONS(3820),
    [anon_sym_sample] = ACTIONS(3820),
    [anon_sym_linear] = ACTIONS(3820),
    [anon_sym_snorm] = ACTIONS(3820),
    [anon_sym_unorm] = ACTIONS(3820),
    [anon_sym_point] = ACTIONS(3820),
    [anon_sym_line] = ACTIONS(3820),
    [anon_sym_triangleadj] = ACTIONS(3820),
    [anon_sym_lineadj] = ACTIONS(3820),
    [anon_sym_triangle] = ACTIONS(3820),
    [anon_sym_cbuffer] = ACTIONS(3820),
    [anon_sym_interface] = ACTIONS(3820),
    [anon_sym_extension] = ACTIONS(3820),
  },
  [582] = {
    [sym_identifier] = ACTIONS(3824),
    [aux_sym_preproc_include_token1] = ACTIONS(3824),
    [aux_sym_preproc_def_token1] = ACTIONS(3824),
    [aux_sym_preproc_if_token1] = ACTIONS(3824),
    [aux_sym_preproc_if_token2] = ACTIONS(3824),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3824),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3824),
    [aux_sym_preproc_else_token1] = ACTIONS(3824),
    [aux_sym_preproc_elif_token1] = ACTIONS(3824),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3824),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3824),
    [sym_preproc_directive] = ACTIONS(3824),
    [anon_sym_LPAREN2] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3826),
    [anon_sym_TILDE] = ACTIONS(3826),
    [anon_sym_DASH] = ACTIONS(3824),
    [anon_sym_PLUS] = ACTIONS(3824),
    [anon_sym_STAR] = ACTIONS(3826),
    [anon_sym_AMP_AMP] = ACTIONS(3826),
    [anon_sym_AMP] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(3826),
    [anon_sym___extension__] = ACTIONS(3824),
    [anon_sym_typedef] = ACTIONS(3824),
    [anon_sym_in] = ACTIONS(3824),
    [anon_sym_out] = ACTIONS(3824),
    [anon_sym_inout] = ACTIONS(3824),
    [anon_sym_virtual] = ACTIONS(3824),
    [anon_sym_extern] = ACTIONS(3824),
    [anon_sym___attribute__] = ACTIONS(3824),
    [anon_sym___attribute] = ACTIONS(3824),
    [anon_sym_using] = ACTIONS(3824),
    [anon_sym_COLON_COLON] = ACTIONS(3826),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3826),
    [anon_sym___declspec] = ACTIONS(3824),
    [anon_sym___based] = ACTIONS(3824),
    [anon_sym___cdecl] = ACTIONS(3824),
    [anon_sym___clrcall] = ACTIONS(3824),
    [anon_sym___stdcall] = ACTIONS(3824),
    [anon_sym___fastcall] = ACTIONS(3824),
    [anon_sym___thiscall] = ACTIONS(3824),
    [anon_sym___vectorcall] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(3826),
    [anon_sym_signed] = ACTIONS(3824),
    [anon_sym_unsigned] = ACTIONS(3824),
    [anon_sym_long] = ACTIONS(3824),
    [anon_sym_short] = ACTIONS(3824),
    [anon_sym_LBRACK] = ACTIONS(3824),
    [anon_sym_static] = ACTIONS(3824),
    [anon_sym_register] = ACTIONS(3824),
    [anon_sym_inline] = ACTIONS(3824),
    [anon_sym___inline] = ACTIONS(3824),
    [anon_sym___inline__] = ACTIONS(3824),
    [anon_sym___forceinline] = ACTIONS(3824),
    [anon_sym_thread_local] = ACTIONS(3824),
    [anon_sym___thread] = ACTIONS(3824),
    [anon_sym_const] = ACTIONS(3824),
    [anon_sym_constexpr] = ACTIONS(3824),
    [anon_sym_volatile] = ACTIONS(3824),
    [anon_sym_restrict] = ACTIONS(3824),
    [anon_sym___restrict__] = ACTIONS(3824),
    [anon_sym__Atomic] = ACTIONS(3824),
    [anon_sym__Noreturn] = ACTIONS(3824),
    [anon_sym_noreturn] = ACTIONS(3824),
    [anon_sym__Nonnull] = ACTIONS(3824),
    [anon_sym_mutable] = ACTIONS(3824),
    [anon_sym_constinit] = ACTIONS(3824),
    [anon_sym_consteval] = ACTIONS(3824),
    [anon_sym_alignas] = ACTIONS(3824),
    [anon_sym__Alignas] = ACTIONS(3824),
    [sym_primitive_type] = ACTIONS(3824),
    [anon_sym_enum] = ACTIONS(3824),
    [anon_sym_class] = ACTIONS(3824),
    [anon_sym_struct] = ACTIONS(3824),
    [anon_sym_union] = ACTIONS(3824),
    [anon_sym_if] = ACTIONS(3824),
    [anon_sym_switch] = ACTIONS(3824),
    [anon_sym_case] = ACTIONS(3824),
    [anon_sym_default] = ACTIONS(3824),
    [anon_sym_while] = ACTIONS(3824),
    [anon_sym_do] = ACTIONS(3824),
    [anon_sym_for] = ACTIONS(3824),
    [anon_sym_return] = ACTIONS(3824),
    [anon_sym_break] = ACTIONS(3824),
    [anon_sym_continue] = ACTIONS(3824),
    [anon_sym_goto] = ACTIONS(3824),
    [anon_sym___try] = ACTIONS(3824),
    [anon_sym___leave] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3824),
    [anon_sym_compl] = ACTIONS(3824),
    [anon_sym_DASH_DASH] = ACTIONS(3826),
    [anon_sym_PLUS_PLUS] = ACTIONS(3826),
    [anon_sym_sizeof] = ACTIONS(3824),
    [anon_sym___alignof__] = ACTIONS(3824),
    [anon_sym___alignof] = ACTIONS(3824),
    [anon_sym__alignof] = ACTIONS(3824),
    [anon_sym_alignof] = ACTIONS(3824),
    [anon_sym__Alignof] = ACTIONS(3824),
    [anon_sym_offsetof] = ACTIONS(3824),
    [anon_sym__Generic] = ACTIONS(3824),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3826),
    [anon_sym_u_SQUOTE] = ACTIONS(3826),
    [anon_sym_U_SQUOTE] = ACTIONS(3826),
    [anon_sym_u8_SQUOTE] = ACTIONS(3826),
    [anon_sym_SQUOTE] = ACTIONS(3826),
    [anon_sym_L_DQUOTE] = ACTIONS(3826),
    [anon_sym_u_DQUOTE] = ACTIONS(3826),
    [anon_sym_U_DQUOTE] = ACTIONS(3826),
    [anon_sym_u8_DQUOTE] = ACTIONS(3826),
    [anon_sym_DQUOTE] = ACTIONS(3826),
    [sym_true] = ACTIONS(3824),
    [sym_false] = ACTIONS(3824),
    [anon_sym_NULL] = ACTIONS(3824),
    [anon_sym_nullptr] = ACTIONS(3824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3824),
    [anon_sym_let] = ACTIONS(3824),
    [anon_sym_This] = ACTIONS(3824),
    [anon_sym_decltype] = ACTIONS(3824),
    [anon_sym_explicit] = ACTIONS(3824),
    [anon_sym_typename] = ACTIONS(3824),
    [anon_sym_template] = ACTIONS(3824),
    [anon_sym_operator] = ACTIONS(3824),
    [anon_sym_try] = ACTIONS(3824),
    [anon_sym_delete] = ACTIONS(3824),
    [anon_sym_throw] = ACTIONS(3824),
    [anon_sym_namespace] = ACTIONS(3824),
    [anon_sym_static_assert] = ACTIONS(3824),
    [anon_sym_concept] = ACTIONS(3824),
    [anon_sym_co_return] = ACTIONS(3824),
    [anon_sym_co_yield] = ACTIONS(3824),
    [anon_sym_R_DQUOTE] = ACTIONS(3826),
    [anon_sym_LR_DQUOTE] = ACTIONS(3826),
    [anon_sym_uR_DQUOTE] = ACTIONS(3826),
    [anon_sym_UR_DQUOTE] = ACTIONS(3826),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3826),
    [anon_sym_co_await] = ACTIONS(3824),
    [anon_sym_new] = ACTIONS(3824),
    [anon_sym_requires] = ACTIONS(3824),
    [sym_this] = ACTIONS(3824),
    [anon_sym_discard] = ACTIONS(3824),
    [anon_sym_precise] = ACTIONS(3824),
    [anon_sym_shared] = ACTIONS(3824),
    [anon_sym_groupshared] = ACTIONS(3824),
    [anon_sym_uniform] = ACTIONS(3824),
    [anon_sym_row_major] = ACTIONS(3824),
    [anon_sym_column_major] = ACTIONS(3824),
    [anon_sym_globallycoherent] = ACTIONS(3824),
    [anon_sym_centroid] = ACTIONS(3824),
    [anon_sym_noperspective] = ACTIONS(3824),
    [anon_sym_nointerpolation] = ACTIONS(3824),
    [anon_sym_sample] = ACTIONS(3824),
    [anon_sym_linear] = ACTIONS(3824),
    [anon_sym_snorm] = ACTIONS(3824),
    [anon_sym_unorm] = ACTIONS(3824),
    [anon_sym_point] = ACTIONS(3824),
    [anon_sym_line] = ACTIONS(3824),
    [anon_sym_triangleadj] = ACTIONS(3824),
    [anon_sym_lineadj] = ACTIONS(3824),
    [anon_sym_triangle] = ACTIONS(3824),
    [anon_sym_cbuffer] = ACTIONS(3824),
    [anon_sym_interface] = ACTIONS(3824),
    [anon_sym_extension] = ACTIONS(3824),
  },
  [583] = {
    [sym_identifier] = ACTIONS(3828),
    [aux_sym_preproc_include_token1] = ACTIONS(3828),
    [aux_sym_preproc_def_token1] = ACTIONS(3828),
    [aux_sym_preproc_if_token1] = ACTIONS(3828),
    [aux_sym_preproc_if_token2] = ACTIONS(3828),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3828),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3828),
    [aux_sym_preproc_else_token1] = ACTIONS(3828),
    [aux_sym_preproc_elif_token1] = ACTIONS(3828),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3828),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3828),
    [sym_preproc_directive] = ACTIONS(3828),
    [anon_sym_LPAREN2] = ACTIONS(3830),
    [anon_sym_BANG] = ACTIONS(3830),
    [anon_sym_TILDE] = ACTIONS(3830),
    [anon_sym_DASH] = ACTIONS(3828),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_SEMI] = ACTIONS(3830),
    [anon_sym___extension__] = ACTIONS(3828),
    [anon_sym_typedef] = ACTIONS(3828),
    [anon_sym_in] = ACTIONS(3828),
    [anon_sym_out] = ACTIONS(3828),
    [anon_sym_inout] = ACTIONS(3828),
    [anon_sym_virtual] = ACTIONS(3828),
    [anon_sym_extern] = ACTIONS(3828),
    [anon_sym___attribute__] = ACTIONS(3828),
    [anon_sym___attribute] = ACTIONS(3828),
    [anon_sym_using] = ACTIONS(3828),
    [anon_sym_COLON_COLON] = ACTIONS(3830),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3830),
    [anon_sym___declspec] = ACTIONS(3828),
    [anon_sym___based] = ACTIONS(3828),
    [anon_sym___cdecl] = ACTIONS(3828),
    [anon_sym___clrcall] = ACTIONS(3828),
    [anon_sym___stdcall] = ACTIONS(3828),
    [anon_sym___fastcall] = ACTIONS(3828),
    [anon_sym___thiscall] = ACTIONS(3828),
    [anon_sym___vectorcall] = ACTIONS(3828),
    [anon_sym_LBRACE] = ACTIONS(3830),
    [anon_sym_signed] = ACTIONS(3828),
    [anon_sym_unsigned] = ACTIONS(3828),
    [anon_sym_long] = ACTIONS(3828),
    [anon_sym_short] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_static] = ACTIONS(3828),
    [anon_sym_register] = ACTIONS(3828),
    [anon_sym_inline] = ACTIONS(3828),
    [anon_sym___inline] = ACTIONS(3828),
    [anon_sym___inline__] = ACTIONS(3828),
    [anon_sym___forceinline] = ACTIONS(3828),
    [anon_sym_thread_local] = ACTIONS(3828),
    [anon_sym___thread] = ACTIONS(3828),
    [anon_sym_const] = ACTIONS(3828),
    [anon_sym_constexpr] = ACTIONS(3828),
    [anon_sym_volatile] = ACTIONS(3828),
    [anon_sym_restrict] = ACTIONS(3828),
    [anon_sym___restrict__] = ACTIONS(3828),
    [anon_sym__Atomic] = ACTIONS(3828),
    [anon_sym__Noreturn] = ACTIONS(3828),
    [anon_sym_noreturn] = ACTIONS(3828),
    [anon_sym__Nonnull] = ACTIONS(3828),
    [anon_sym_mutable] = ACTIONS(3828),
    [anon_sym_constinit] = ACTIONS(3828),
    [anon_sym_consteval] = ACTIONS(3828),
    [anon_sym_alignas] = ACTIONS(3828),
    [anon_sym__Alignas] = ACTIONS(3828),
    [sym_primitive_type] = ACTIONS(3828),
    [anon_sym_enum] = ACTIONS(3828),
    [anon_sym_class] = ACTIONS(3828),
    [anon_sym_struct] = ACTIONS(3828),
    [anon_sym_union] = ACTIONS(3828),
    [anon_sym_if] = ACTIONS(3828),
    [anon_sym_switch] = ACTIONS(3828),
    [anon_sym_case] = ACTIONS(3828),
    [anon_sym_default] = ACTIONS(3828),
    [anon_sym_while] = ACTIONS(3828),
    [anon_sym_do] = ACTIONS(3828),
    [anon_sym_for] = ACTIONS(3828),
    [anon_sym_return] = ACTIONS(3828),
    [anon_sym_break] = ACTIONS(3828),
    [anon_sym_continue] = ACTIONS(3828),
    [anon_sym_goto] = ACTIONS(3828),
    [anon_sym___try] = ACTIONS(3828),
    [anon_sym___leave] = ACTIONS(3828),
    [anon_sym_not] = ACTIONS(3828),
    [anon_sym_compl] = ACTIONS(3828),
    [anon_sym_DASH_DASH] = ACTIONS(3830),
    [anon_sym_PLUS_PLUS] = ACTIONS(3830),
    [anon_sym_sizeof] = ACTIONS(3828),
    [anon_sym___alignof__] = ACTIONS(3828),
    [anon_sym___alignof] = ACTIONS(3828),
    [anon_sym__alignof] = ACTIONS(3828),
    [anon_sym_alignof] = ACTIONS(3828),
    [anon_sym__Alignof] = ACTIONS(3828),
    [anon_sym_offsetof] = ACTIONS(3828),
    [anon_sym__Generic] = ACTIONS(3828),
    [anon_sym_asm] = ACTIONS(3828),
    [anon_sym___asm__] = ACTIONS(3828),
    [anon_sym___asm] = ACTIONS(3828),
    [sym_number_literal] = ACTIONS(3830),
    [anon_sym_L_SQUOTE] = ACTIONS(3830),
    [anon_sym_u_SQUOTE] = ACTIONS(3830),
    [anon_sym_U_SQUOTE] = ACTIONS(3830),
    [anon_sym_u8_SQUOTE] = ACTIONS(3830),
    [anon_sym_SQUOTE] = ACTIONS(3830),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3828),
    [sym_false] = ACTIONS(3828),
    [anon_sym_NULL] = ACTIONS(3828),
    [anon_sym_nullptr] = ACTIONS(3828),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_This] = ACTIONS(3828),
    [anon_sym_decltype] = ACTIONS(3828),
    [anon_sym_explicit] = ACTIONS(3828),
    [anon_sym_typename] = ACTIONS(3828),
    [anon_sym_template] = ACTIONS(3828),
    [anon_sym_operator] = ACTIONS(3828),
    [anon_sym_try] = ACTIONS(3828),
    [anon_sym_delete] = ACTIONS(3828),
    [anon_sym_throw] = ACTIONS(3828),
    [anon_sym_namespace] = ACTIONS(3828),
    [anon_sym_static_assert] = ACTIONS(3828),
    [anon_sym_concept] = ACTIONS(3828),
    [anon_sym_co_return] = ACTIONS(3828),
    [anon_sym_co_yield] = ACTIONS(3828),
    [anon_sym_R_DQUOTE] = ACTIONS(3830),
    [anon_sym_LR_DQUOTE] = ACTIONS(3830),
    [anon_sym_uR_DQUOTE] = ACTIONS(3830),
    [anon_sym_UR_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3830),
    [anon_sym_co_await] = ACTIONS(3828),
    [anon_sym_new] = ACTIONS(3828),
    [anon_sym_requires] = ACTIONS(3828),
    [sym_this] = ACTIONS(3828),
    [anon_sym_discard] = ACTIONS(3828),
    [anon_sym_precise] = ACTIONS(3828),
    [anon_sym_shared] = ACTIONS(3828),
    [anon_sym_groupshared] = ACTIONS(3828),
    [anon_sym_uniform] = ACTIONS(3828),
    [anon_sym_row_major] = ACTIONS(3828),
    [anon_sym_column_major] = ACTIONS(3828),
    [anon_sym_globallycoherent] = ACTIONS(3828),
    [anon_sym_centroid] = ACTIONS(3828),
    [anon_sym_noperspective] = ACTIONS(3828),
    [anon_sym_nointerpolation] = ACTIONS(3828),
    [anon_sym_sample] = ACTIONS(3828),
    [anon_sym_linear] = ACTIONS(3828),
    [anon_sym_snorm] = ACTIONS(3828),
    [anon_sym_unorm] = ACTIONS(3828),
    [anon_sym_point] = ACTIONS(3828),
    [anon_sym_line] = ACTIONS(3828),
    [anon_sym_triangleadj] = ACTIONS(3828),
    [anon_sym_lineadj] = ACTIONS(3828),
    [anon_sym_triangle] = ACTIONS(3828),
    [anon_sym_cbuffer] = ACTIONS(3828),
    [anon_sym_interface] = ACTIONS(3828),
    [anon_sym_extension] = ACTIONS(3828),
  },
  [584] = {
    [sym_identifier] = ACTIONS(3832),
    [aux_sym_preproc_include_token1] = ACTIONS(3832),
    [aux_sym_preproc_def_token1] = ACTIONS(3832),
    [aux_sym_preproc_if_token1] = ACTIONS(3832),
    [aux_sym_preproc_if_token2] = ACTIONS(3832),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3832),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3832),
    [aux_sym_preproc_else_token1] = ACTIONS(3832),
    [aux_sym_preproc_elif_token1] = ACTIONS(3832),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3832),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3832),
    [sym_preproc_directive] = ACTIONS(3832),
    [anon_sym_LPAREN2] = ACTIONS(3834),
    [anon_sym_BANG] = ACTIONS(3834),
    [anon_sym_TILDE] = ACTIONS(3834),
    [anon_sym_DASH] = ACTIONS(3832),
    [anon_sym_PLUS] = ACTIONS(3832),
    [anon_sym_STAR] = ACTIONS(3834),
    [anon_sym_AMP_AMP] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3834),
    [anon_sym___extension__] = ACTIONS(3832),
    [anon_sym_typedef] = ACTIONS(3832),
    [anon_sym_in] = ACTIONS(3832),
    [anon_sym_out] = ACTIONS(3832),
    [anon_sym_inout] = ACTIONS(3832),
    [anon_sym_virtual] = ACTIONS(3832),
    [anon_sym_extern] = ACTIONS(3832),
    [anon_sym___attribute__] = ACTIONS(3832),
    [anon_sym___attribute] = ACTIONS(3832),
    [anon_sym_using] = ACTIONS(3832),
    [anon_sym_COLON_COLON] = ACTIONS(3834),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3834),
    [anon_sym___declspec] = ACTIONS(3832),
    [anon_sym___based] = ACTIONS(3832),
    [anon_sym___cdecl] = ACTIONS(3832),
    [anon_sym___clrcall] = ACTIONS(3832),
    [anon_sym___stdcall] = ACTIONS(3832),
    [anon_sym___fastcall] = ACTIONS(3832),
    [anon_sym___thiscall] = ACTIONS(3832),
    [anon_sym___vectorcall] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_signed] = ACTIONS(3832),
    [anon_sym_unsigned] = ACTIONS(3832),
    [anon_sym_long] = ACTIONS(3832),
    [anon_sym_short] = ACTIONS(3832),
    [anon_sym_LBRACK] = ACTIONS(3832),
    [anon_sym_static] = ACTIONS(3832),
    [anon_sym_register] = ACTIONS(3832),
    [anon_sym_inline] = ACTIONS(3832),
    [anon_sym___inline] = ACTIONS(3832),
    [anon_sym___inline__] = ACTIONS(3832),
    [anon_sym___forceinline] = ACTIONS(3832),
    [anon_sym_thread_local] = ACTIONS(3832),
    [anon_sym___thread] = ACTIONS(3832),
    [anon_sym_const] = ACTIONS(3832),
    [anon_sym_constexpr] = ACTIONS(3832),
    [anon_sym_volatile] = ACTIONS(3832),
    [anon_sym_restrict] = ACTIONS(3832),
    [anon_sym___restrict__] = ACTIONS(3832),
    [anon_sym__Atomic] = ACTIONS(3832),
    [anon_sym__Noreturn] = ACTIONS(3832),
    [anon_sym_noreturn] = ACTIONS(3832),
    [anon_sym__Nonnull] = ACTIONS(3832),
    [anon_sym_mutable] = ACTIONS(3832),
    [anon_sym_constinit] = ACTIONS(3832),
    [anon_sym_consteval] = ACTIONS(3832),
    [anon_sym_alignas] = ACTIONS(3832),
    [anon_sym__Alignas] = ACTIONS(3832),
    [sym_primitive_type] = ACTIONS(3832),
    [anon_sym_enum] = ACTIONS(3832),
    [anon_sym_class] = ACTIONS(3832),
    [anon_sym_struct] = ACTIONS(3832),
    [anon_sym_union] = ACTIONS(3832),
    [anon_sym_if] = ACTIONS(3832),
    [anon_sym_switch] = ACTIONS(3832),
    [anon_sym_case] = ACTIONS(3832),
    [anon_sym_default] = ACTIONS(3832),
    [anon_sym_while] = ACTIONS(3832),
    [anon_sym_do] = ACTIONS(3832),
    [anon_sym_for] = ACTIONS(3832),
    [anon_sym_return] = ACTIONS(3832),
    [anon_sym_break] = ACTIONS(3832),
    [anon_sym_continue] = ACTIONS(3832),
    [anon_sym_goto] = ACTIONS(3832),
    [anon_sym___try] = ACTIONS(3832),
    [anon_sym___leave] = ACTIONS(3832),
    [anon_sym_not] = ACTIONS(3832),
    [anon_sym_compl] = ACTIONS(3832),
    [anon_sym_DASH_DASH] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(3834),
    [anon_sym_sizeof] = ACTIONS(3832),
    [anon_sym___alignof__] = ACTIONS(3832),
    [anon_sym___alignof] = ACTIONS(3832),
    [anon_sym__alignof] = ACTIONS(3832),
    [anon_sym_alignof] = ACTIONS(3832),
    [anon_sym__Alignof] = ACTIONS(3832),
    [anon_sym_offsetof] = ACTIONS(3832),
    [anon_sym__Generic] = ACTIONS(3832),
    [anon_sym_asm] = ACTIONS(3832),
    [anon_sym___asm__] = ACTIONS(3832),
    [anon_sym___asm] = ACTIONS(3832),
    [sym_number_literal] = ACTIONS(3834),
    [anon_sym_L_SQUOTE] = ACTIONS(3834),
    [anon_sym_u_SQUOTE] = ACTIONS(3834),
    [anon_sym_U_SQUOTE] = ACTIONS(3834),
    [anon_sym_u8_SQUOTE] = ACTIONS(3834),
    [anon_sym_SQUOTE] = ACTIONS(3834),
    [anon_sym_L_DQUOTE] = ACTIONS(3834),
    [anon_sym_u_DQUOTE] = ACTIONS(3834),
    [anon_sym_U_DQUOTE] = ACTIONS(3834),
    [anon_sym_u8_DQUOTE] = ACTIONS(3834),
    [anon_sym_DQUOTE] = ACTIONS(3834),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3832),
    [anon_sym_nullptr] = ACTIONS(3832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3832),
    [anon_sym_let] = ACTIONS(3832),
    [anon_sym_This] = ACTIONS(3832),
    [anon_sym_decltype] = ACTIONS(3832),
    [anon_sym_explicit] = ACTIONS(3832),
    [anon_sym_typename] = ACTIONS(3832),
    [anon_sym_template] = ACTIONS(3832),
    [anon_sym_operator] = ACTIONS(3832),
    [anon_sym_try] = ACTIONS(3832),
    [anon_sym_delete] = ACTIONS(3832),
    [anon_sym_throw] = ACTIONS(3832),
    [anon_sym_namespace] = ACTIONS(3832),
    [anon_sym_static_assert] = ACTIONS(3832),
    [anon_sym_concept] = ACTIONS(3832),
    [anon_sym_co_return] = ACTIONS(3832),
    [anon_sym_co_yield] = ACTIONS(3832),
    [anon_sym_R_DQUOTE] = ACTIONS(3834),
    [anon_sym_LR_DQUOTE] = ACTIONS(3834),
    [anon_sym_uR_DQUOTE] = ACTIONS(3834),
    [anon_sym_UR_DQUOTE] = ACTIONS(3834),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3834),
    [anon_sym_co_await] = ACTIONS(3832),
    [anon_sym_new] = ACTIONS(3832),
    [anon_sym_requires] = ACTIONS(3832),
    [sym_this] = ACTIONS(3832),
    [anon_sym_discard] = ACTIONS(3832),
    [anon_sym_precise] = ACTIONS(3832),
    [anon_sym_shared] = ACTIONS(3832),
    [anon_sym_groupshared] = ACTIONS(3832),
    [anon_sym_uniform] = ACTIONS(3832),
    [anon_sym_row_major] = ACTIONS(3832),
    [anon_sym_column_major] = ACTIONS(3832),
    [anon_sym_globallycoherent] = ACTIONS(3832),
    [anon_sym_centroid] = ACTIONS(3832),
    [anon_sym_noperspective] = ACTIONS(3832),
    [anon_sym_nointerpolation] = ACTIONS(3832),
    [anon_sym_sample] = ACTIONS(3832),
    [anon_sym_linear] = ACTIONS(3832),
    [anon_sym_snorm] = ACTIONS(3832),
    [anon_sym_unorm] = ACTIONS(3832),
    [anon_sym_point] = ACTIONS(3832),
    [anon_sym_line] = ACTIONS(3832),
    [anon_sym_triangleadj] = ACTIONS(3832),
    [anon_sym_lineadj] = ACTIONS(3832),
    [anon_sym_triangle] = ACTIONS(3832),
    [anon_sym_cbuffer] = ACTIONS(3832),
    [anon_sym_interface] = ACTIONS(3832),
    [anon_sym_extension] = ACTIONS(3832),
  },
  [585] = {
    [sym_argument_list] = STATE(3418),
    [sym_initializer_list] = STATE(4856),
    [aux_sym_sized_type_specifier_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(2883),
    [aux_sym_preproc_include_token1] = ACTIONS(2883),
    [aux_sym_preproc_def_token1] = ACTIONS(2883),
    [aux_sym_preproc_if_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2883),
    [sym_preproc_directive] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(3836),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_typedef] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_using] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2881),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(3839),
    [anon_sym_RBRACE] = ACTIONS(2881),
    [anon_sym_signed] = ACTIONS(3842),
    [anon_sym_unsigned] = ACTIONS(3842),
    [anon_sym_long] = ACTIONS(3842),
    [anon_sym_short] = ACTIONS(3842),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [sym_primitive_type] = ACTIONS(2883),
    [anon_sym_enum] = ACTIONS(2883),
    [anon_sym_class] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2883),
    [anon_sym_union] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_switch] = ACTIONS(2883),
    [anon_sym_case] = ACTIONS(2883),
    [anon_sym_default] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_break] = ACTIONS(2883),
    [anon_sym_continue] = ACTIONS(2883),
    [anon_sym_goto] = ACTIONS(2883),
    [anon_sym___try] = ACTIONS(2883),
    [anon_sym___leave] = ACTIONS(2883),
    [anon_sym_not] = ACTIONS(2883),
    [anon_sym_compl] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_sizeof] = ACTIONS(2883),
    [anon_sym___alignof__] = ACTIONS(2883),
    [anon_sym___alignof] = ACTIONS(2883),
    [anon_sym__alignof] = ACTIONS(2883),
    [anon_sym_alignof] = ACTIONS(2883),
    [anon_sym__Alignof] = ACTIONS(2883),
    [anon_sym_offsetof] = ACTIONS(2883),
    [anon_sym__Generic] = ACTIONS(2883),
    [anon_sym_asm] = ACTIONS(2883),
    [anon_sym___asm__] = ACTIONS(2883),
    [anon_sym___asm] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [sym_number_literal] = ACTIONS(2881),
    [anon_sym_L_SQUOTE] = ACTIONS(2881),
    [anon_sym_u_SQUOTE] = ACTIONS(2881),
    [anon_sym_U_SQUOTE] = ACTIONS(2881),
    [anon_sym_u8_SQUOTE] = ACTIONS(2881),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_L_DQUOTE] = ACTIONS(2881),
    [anon_sym_u_DQUOTE] = ACTIONS(2881),
    [anon_sym_U_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [sym_true] = ACTIONS(2883),
    [sym_false] = ACTIONS(2883),
    [anon_sym_NULL] = ACTIONS(2883),
    [anon_sym_nullptr] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_explicit] = ACTIONS(2883),
    [anon_sym_typename] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_delete] = ACTIONS(2883),
    [anon_sym_throw] = ACTIONS(2883),
    [anon_sym_namespace] = ACTIONS(2883),
    [anon_sym_static_assert] = ACTIONS(2883),
    [anon_sym_concept] = ACTIONS(2883),
    [anon_sym_co_return] = ACTIONS(2883),
    [anon_sym_co_yield] = ACTIONS(2883),
    [anon_sym_R_DQUOTE] = ACTIONS(2881),
    [anon_sym_LR_DQUOTE] = ACTIONS(2881),
    [anon_sym_uR_DQUOTE] = ACTIONS(2881),
    [anon_sym_UR_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2881),
    [anon_sym_co_await] = ACTIONS(2883),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_requires] = ACTIONS(2883),
    [sym_this] = ACTIONS(2883),
    [anon_sym_discard] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
    [anon_sym_cbuffer] = ACTIONS(2883),
    [anon_sym_interface] = ACTIONS(2883),
    [anon_sym_extension] = ACTIONS(2883),
  },
  [586] = {
    [sym_identifier] = ACTIONS(3845),
    [aux_sym_preproc_include_token1] = ACTIONS(3845),
    [aux_sym_preproc_def_token1] = ACTIONS(3845),
    [aux_sym_preproc_if_token1] = ACTIONS(3845),
    [aux_sym_preproc_if_token2] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3845),
    [aux_sym_preproc_else_token1] = ACTIONS(3845),
    [aux_sym_preproc_elif_token1] = ACTIONS(3845),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3845),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3845),
    [sym_preproc_directive] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3847),
    [anon_sym_BANG] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_STAR] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_SEMI] = ACTIONS(3847),
    [anon_sym___extension__] = ACTIONS(3845),
    [anon_sym_typedef] = ACTIONS(3845),
    [anon_sym_in] = ACTIONS(3845),
    [anon_sym_out] = ACTIONS(3845),
    [anon_sym_inout] = ACTIONS(3845),
    [anon_sym_virtual] = ACTIONS(3845),
    [anon_sym_extern] = ACTIONS(3845),
    [anon_sym___attribute__] = ACTIONS(3845),
    [anon_sym___attribute] = ACTIONS(3845),
    [anon_sym_using] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3847),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3847),
    [anon_sym___declspec] = ACTIONS(3845),
    [anon_sym___based] = ACTIONS(3845),
    [anon_sym___cdecl] = ACTIONS(3845),
    [anon_sym___clrcall] = ACTIONS(3845),
    [anon_sym___stdcall] = ACTIONS(3845),
    [anon_sym___fastcall] = ACTIONS(3845),
    [anon_sym___thiscall] = ACTIONS(3845),
    [anon_sym___vectorcall] = ACTIONS(3845),
    [anon_sym_LBRACE] = ACTIONS(3847),
    [anon_sym_signed] = ACTIONS(3845),
    [anon_sym_unsigned] = ACTIONS(3845),
    [anon_sym_long] = ACTIONS(3845),
    [anon_sym_short] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_static] = ACTIONS(3845),
    [anon_sym_register] = ACTIONS(3845),
    [anon_sym_inline] = ACTIONS(3845),
    [anon_sym___inline] = ACTIONS(3845),
    [anon_sym___inline__] = ACTIONS(3845),
    [anon_sym___forceinline] = ACTIONS(3845),
    [anon_sym_thread_local] = ACTIONS(3845),
    [anon_sym___thread] = ACTIONS(3845),
    [anon_sym_const] = ACTIONS(3845),
    [anon_sym_constexpr] = ACTIONS(3845),
    [anon_sym_volatile] = ACTIONS(3845),
    [anon_sym_restrict] = ACTIONS(3845),
    [anon_sym___restrict__] = ACTIONS(3845),
    [anon_sym__Atomic] = ACTIONS(3845),
    [anon_sym__Noreturn] = ACTIONS(3845),
    [anon_sym_noreturn] = ACTIONS(3845),
    [anon_sym__Nonnull] = ACTIONS(3845),
    [anon_sym_mutable] = ACTIONS(3845),
    [anon_sym_constinit] = ACTIONS(3845),
    [anon_sym_consteval] = ACTIONS(3845),
    [anon_sym_alignas] = ACTIONS(3845),
    [anon_sym__Alignas] = ACTIONS(3845),
    [sym_primitive_type] = ACTIONS(3845),
    [anon_sym_enum] = ACTIONS(3845),
    [anon_sym_class] = ACTIONS(3845),
    [anon_sym_struct] = ACTIONS(3845),
    [anon_sym_union] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_switch] = ACTIONS(3845),
    [anon_sym_case] = ACTIONS(3845),
    [anon_sym_default] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_break] = ACTIONS(3845),
    [anon_sym_continue] = ACTIONS(3845),
    [anon_sym_goto] = ACTIONS(3845),
    [anon_sym___try] = ACTIONS(3845),
    [anon_sym___leave] = ACTIONS(3845),
    [anon_sym_not] = ACTIONS(3845),
    [anon_sym_compl] = ACTIONS(3845),
    [anon_sym_DASH_DASH] = ACTIONS(3847),
    [anon_sym_PLUS_PLUS] = ACTIONS(3847),
    [anon_sym_sizeof] = ACTIONS(3845),
    [anon_sym___alignof__] = ACTIONS(3845),
    [anon_sym___alignof] = ACTIONS(3845),
    [anon_sym__alignof] = ACTIONS(3845),
    [anon_sym_alignof] = ACTIONS(3845),
    [anon_sym__Alignof] = ACTIONS(3845),
    [anon_sym_offsetof] = ACTIONS(3845),
    [anon_sym__Generic] = ACTIONS(3845),
    [anon_sym_asm] = ACTIONS(3845),
    [anon_sym___asm__] = ACTIONS(3845),
    [anon_sym___asm] = ACTIONS(3845),
    [sym_number_literal] = ACTIONS(3847),
    [anon_sym_L_SQUOTE] = ACTIONS(3847),
    [anon_sym_u_SQUOTE] = ACTIONS(3847),
    [anon_sym_U_SQUOTE] = ACTIONS(3847),
    [anon_sym_u8_SQUOTE] = ACTIONS(3847),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [anon_sym_L_DQUOTE] = ACTIONS(3847),
    [anon_sym_u_DQUOTE] = ACTIONS(3847),
    [anon_sym_U_DQUOTE] = ACTIONS(3847),
    [anon_sym_u8_DQUOTE] = ACTIONS(3847),
    [anon_sym_DQUOTE] = ACTIONS(3847),
    [sym_true] = ACTIONS(3845),
    [sym_false] = ACTIONS(3845),
    [anon_sym_NULL] = ACTIONS(3845),
    [anon_sym_nullptr] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_This] = ACTIONS(3845),
    [anon_sym_decltype] = ACTIONS(3845),
    [anon_sym_explicit] = ACTIONS(3845),
    [anon_sym_typename] = ACTIONS(3845),
    [anon_sym_template] = ACTIONS(3845),
    [anon_sym_operator] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_delete] = ACTIONS(3845),
    [anon_sym_throw] = ACTIONS(3845),
    [anon_sym_namespace] = ACTIONS(3845),
    [anon_sym_static_assert] = ACTIONS(3845),
    [anon_sym_concept] = ACTIONS(3845),
    [anon_sym_co_return] = ACTIONS(3845),
    [anon_sym_co_yield] = ACTIONS(3845),
    [anon_sym_R_DQUOTE] = ACTIONS(3847),
    [anon_sym_LR_DQUOTE] = ACTIONS(3847),
    [anon_sym_uR_DQUOTE] = ACTIONS(3847),
    [anon_sym_UR_DQUOTE] = ACTIONS(3847),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3847),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_requires] = ACTIONS(3845),
    [sym_this] = ACTIONS(3845),
    [anon_sym_discard] = ACTIONS(3845),
    [anon_sym_precise] = ACTIONS(3845),
    [anon_sym_shared] = ACTIONS(3845),
    [anon_sym_groupshared] = ACTIONS(3845),
    [anon_sym_uniform] = ACTIONS(3845),
    [anon_sym_row_major] = ACTIONS(3845),
    [anon_sym_column_major] = ACTIONS(3845),
    [anon_sym_globallycoherent] = ACTIONS(3845),
    [anon_sym_centroid] = ACTIONS(3845),
    [anon_sym_noperspective] = ACTIONS(3845),
    [anon_sym_nointerpolation] = ACTIONS(3845),
    [anon_sym_sample] = ACTIONS(3845),
    [anon_sym_linear] = ACTIONS(3845),
    [anon_sym_snorm] = ACTIONS(3845),
    [anon_sym_unorm] = ACTIONS(3845),
    [anon_sym_point] = ACTIONS(3845),
    [anon_sym_line] = ACTIONS(3845),
    [anon_sym_triangleadj] = ACTIONS(3845),
    [anon_sym_lineadj] = ACTIONS(3845),
    [anon_sym_triangle] = ACTIONS(3845),
    [anon_sym_cbuffer] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3845),
    [anon_sym_extension] = ACTIONS(3845),
  },
  [587] = {
    [sym_identifier] = ACTIONS(3849),
    [aux_sym_preproc_include_token1] = ACTIONS(3849),
    [aux_sym_preproc_def_token1] = ACTIONS(3849),
    [aux_sym_preproc_if_token1] = ACTIONS(3849),
    [aux_sym_preproc_if_token2] = ACTIONS(3849),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3849),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3849),
    [aux_sym_preproc_else_token1] = ACTIONS(3849),
    [aux_sym_preproc_elif_token1] = ACTIONS(3849),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3849),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3849),
    [sym_preproc_directive] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3851),
    [anon_sym_BANG] = ACTIONS(3851),
    [anon_sym_TILDE] = ACTIONS(3851),
    [anon_sym_DASH] = ACTIONS(3849),
    [anon_sym_PLUS] = ACTIONS(3849),
    [anon_sym_STAR] = ACTIONS(3851),
    [anon_sym_AMP_AMP] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3849),
    [anon_sym_SEMI] = ACTIONS(3851),
    [anon_sym___extension__] = ACTIONS(3849),
    [anon_sym_typedef] = ACTIONS(3849),
    [anon_sym_in] = ACTIONS(3849),
    [anon_sym_out] = ACTIONS(3849),
    [anon_sym_inout] = ACTIONS(3849),
    [anon_sym_virtual] = ACTIONS(3849),
    [anon_sym_extern] = ACTIONS(3849),
    [anon_sym___attribute__] = ACTIONS(3849),
    [anon_sym___attribute] = ACTIONS(3849),
    [anon_sym_using] = ACTIONS(3849),
    [anon_sym_COLON_COLON] = ACTIONS(3851),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3851),
    [anon_sym___declspec] = ACTIONS(3849),
    [anon_sym___based] = ACTIONS(3849),
    [anon_sym___cdecl] = ACTIONS(3849),
    [anon_sym___clrcall] = ACTIONS(3849),
    [anon_sym___stdcall] = ACTIONS(3849),
    [anon_sym___fastcall] = ACTIONS(3849),
    [anon_sym___thiscall] = ACTIONS(3849),
    [anon_sym___vectorcall] = ACTIONS(3849),
    [anon_sym_LBRACE] = ACTIONS(3851),
    [anon_sym_signed] = ACTIONS(3849),
    [anon_sym_unsigned] = ACTIONS(3849),
    [anon_sym_long] = ACTIONS(3849),
    [anon_sym_short] = ACTIONS(3849),
    [anon_sym_LBRACK] = ACTIONS(3849),
    [anon_sym_static] = ACTIONS(3849),
    [anon_sym_register] = ACTIONS(3849),
    [anon_sym_inline] = ACTIONS(3849),
    [anon_sym___inline] = ACTIONS(3849),
    [anon_sym___inline__] = ACTIONS(3849),
    [anon_sym___forceinline] = ACTIONS(3849),
    [anon_sym_thread_local] = ACTIONS(3849),
    [anon_sym___thread] = ACTIONS(3849),
    [anon_sym_const] = ACTIONS(3849),
    [anon_sym_constexpr] = ACTIONS(3849),
    [anon_sym_volatile] = ACTIONS(3849),
    [anon_sym_restrict] = ACTIONS(3849),
    [anon_sym___restrict__] = ACTIONS(3849),
    [anon_sym__Atomic] = ACTIONS(3849),
    [anon_sym__Noreturn] = ACTIONS(3849),
    [anon_sym_noreturn] = ACTIONS(3849),
    [anon_sym__Nonnull] = ACTIONS(3849),
    [anon_sym_mutable] = ACTIONS(3849),
    [anon_sym_constinit] = ACTIONS(3849),
    [anon_sym_consteval] = ACTIONS(3849),
    [anon_sym_alignas] = ACTIONS(3849),
    [anon_sym__Alignas] = ACTIONS(3849),
    [sym_primitive_type] = ACTIONS(3849),
    [anon_sym_enum] = ACTIONS(3849),
    [anon_sym_class] = ACTIONS(3849),
    [anon_sym_struct] = ACTIONS(3849),
    [anon_sym_union] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3849),
    [anon_sym_switch] = ACTIONS(3849),
    [anon_sym_case] = ACTIONS(3849),
    [anon_sym_default] = ACTIONS(3849),
    [anon_sym_while] = ACTIONS(3849),
    [anon_sym_do] = ACTIONS(3849),
    [anon_sym_for] = ACTIONS(3849),
    [anon_sym_return] = ACTIONS(3849),
    [anon_sym_break] = ACTIONS(3849),
    [anon_sym_continue] = ACTIONS(3849),
    [anon_sym_goto] = ACTIONS(3849),
    [anon_sym___try] = ACTIONS(3849),
    [anon_sym___leave] = ACTIONS(3849),
    [anon_sym_not] = ACTIONS(3849),
    [anon_sym_compl] = ACTIONS(3849),
    [anon_sym_DASH_DASH] = ACTIONS(3851),
    [anon_sym_PLUS_PLUS] = ACTIONS(3851),
    [anon_sym_sizeof] = ACTIONS(3849),
    [anon_sym___alignof__] = ACTIONS(3849),
    [anon_sym___alignof] = ACTIONS(3849),
    [anon_sym__alignof] = ACTIONS(3849),
    [anon_sym_alignof] = ACTIONS(3849),
    [anon_sym__Alignof] = ACTIONS(3849),
    [anon_sym_offsetof] = ACTIONS(3849),
    [anon_sym__Generic] = ACTIONS(3849),
    [anon_sym_asm] = ACTIONS(3849),
    [anon_sym___asm__] = ACTIONS(3849),
    [anon_sym___asm] = ACTIONS(3849),
    [sym_number_literal] = ACTIONS(3851),
    [anon_sym_L_SQUOTE] = ACTIONS(3851),
    [anon_sym_u_SQUOTE] = ACTIONS(3851),
    [anon_sym_U_SQUOTE] = ACTIONS(3851),
    [anon_sym_u8_SQUOTE] = ACTIONS(3851),
    [anon_sym_SQUOTE] = ACTIONS(3851),
    [anon_sym_L_DQUOTE] = ACTIONS(3851),
    [anon_sym_u_DQUOTE] = ACTIONS(3851),
    [anon_sym_U_DQUOTE] = ACTIONS(3851),
    [anon_sym_u8_DQUOTE] = ACTIONS(3851),
    [anon_sym_DQUOTE] = ACTIONS(3851),
    [sym_true] = ACTIONS(3849),
    [sym_false] = ACTIONS(3849),
    [anon_sym_NULL] = ACTIONS(3849),
    [anon_sym_nullptr] = ACTIONS(3849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3849),
    [anon_sym_let] = ACTIONS(3849),
    [anon_sym_This] = ACTIONS(3849),
    [anon_sym_decltype] = ACTIONS(3849),
    [anon_sym_explicit] = ACTIONS(3849),
    [anon_sym_typename] = ACTIONS(3849),
    [anon_sym_template] = ACTIONS(3849),
    [anon_sym_operator] = ACTIONS(3849),
    [anon_sym_try] = ACTIONS(3849),
    [anon_sym_delete] = ACTIONS(3849),
    [anon_sym_throw] = ACTIONS(3849),
    [anon_sym_namespace] = ACTIONS(3849),
    [anon_sym_static_assert] = ACTIONS(3849),
    [anon_sym_concept] = ACTIONS(3849),
    [anon_sym_co_return] = ACTIONS(3849),
    [anon_sym_co_yield] = ACTIONS(3849),
    [anon_sym_R_DQUOTE] = ACTIONS(3851),
    [anon_sym_LR_DQUOTE] = ACTIONS(3851),
    [anon_sym_uR_DQUOTE] = ACTIONS(3851),
    [anon_sym_UR_DQUOTE] = ACTIONS(3851),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3851),
    [anon_sym_co_await] = ACTIONS(3849),
    [anon_sym_new] = ACTIONS(3849),
    [anon_sym_requires] = ACTIONS(3849),
    [sym_this] = ACTIONS(3849),
    [anon_sym_discard] = ACTIONS(3849),
    [anon_sym_precise] = ACTIONS(3849),
    [anon_sym_shared] = ACTIONS(3849),
    [anon_sym_groupshared] = ACTIONS(3849),
    [anon_sym_uniform] = ACTIONS(3849),
    [anon_sym_row_major] = ACTIONS(3849),
    [anon_sym_column_major] = ACTIONS(3849),
    [anon_sym_globallycoherent] = ACTIONS(3849),
    [anon_sym_centroid] = ACTIONS(3849),
    [anon_sym_noperspective] = ACTIONS(3849),
    [anon_sym_nointerpolation] = ACTIONS(3849),
    [anon_sym_sample] = ACTIONS(3849),
    [anon_sym_linear] = ACTIONS(3849),
    [anon_sym_snorm] = ACTIONS(3849),
    [anon_sym_unorm] = ACTIONS(3849),
    [anon_sym_point] = ACTIONS(3849),
    [anon_sym_line] = ACTIONS(3849),
    [anon_sym_triangleadj] = ACTIONS(3849),
    [anon_sym_lineadj] = ACTIONS(3849),
    [anon_sym_triangle] = ACTIONS(3849),
    [anon_sym_cbuffer] = ACTIONS(3849),
    [anon_sym_interface] = ACTIONS(3849),
    [anon_sym_extension] = ACTIONS(3849),
  },
  [588] = {
    [sym_identifier] = ACTIONS(3853),
    [aux_sym_preproc_include_token1] = ACTIONS(3853),
    [aux_sym_preproc_def_token1] = ACTIONS(3853),
    [aux_sym_preproc_if_token1] = ACTIONS(3853),
    [aux_sym_preproc_if_token2] = ACTIONS(3853),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3853),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3853),
    [aux_sym_preproc_else_token1] = ACTIONS(3853),
    [aux_sym_preproc_elif_token1] = ACTIONS(3853),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3853),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3853),
    [sym_preproc_directive] = ACTIONS(3853),
    [anon_sym_LPAREN2] = ACTIONS(3855),
    [anon_sym_BANG] = ACTIONS(3855),
    [anon_sym_TILDE] = ACTIONS(3855),
    [anon_sym_DASH] = ACTIONS(3853),
    [anon_sym_PLUS] = ACTIONS(3853),
    [anon_sym_STAR] = ACTIONS(3855),
    [anon_sym_AMP_AMP] = ACTIONS(3855),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_SEMI] = ACTIONS(3855),
    [anon_sym___extension__] = ACTIONS(3853),
    [anon_sym_typedef] = ACTIONS(3853),
    [anon_sym_in] = ACTIONS(3853),
    [anon_sym_out] = ACTIONS(3853),
    [anon_sym_inout] = ACTIONS(3853),
    [anon_sym_virtual] = ACTIONS(3853),
    [anon_sym_extern] = ACTIONS(3853),
    [anon_sym___attribute__] = ACTIONS(3853),
    [anon_sym___attribute] = ACTIONS(3853),
    [anon_sym_using] = ACTIONS(3853),
    [anon_sym_COLON_COLON] = ACTIONS(3855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3855),
    [anon_sym___declspec] = ACTIONS(3853),
    [anon_sym___based] = ACTIONS(3853),
    [anon_sym___cdecl] = ACTIONS(3853),
    [anon_sym___clrcall] = ACTIONS(3853),
    [anon_sym___stdcall] = ACTIONS(3853),
    [anon_sym___fastcall] = ACTIONS(3853),
    [anon_sym___thiscall] = ACTIONS(3853),
    [anon_sym___vectorcall] = ACTIONS(3853),
    [anon_sym_LBRACE] = ACTIONS(3855),
    [anon_sym_signed] = ACTIONS(3853),
    [anon_sym_unsigned] = ACTIONS(3853),
    [anon_sym_long] = ACTIONS(3853),
    [anon_sym_short] = ACTIONS(3853),
    [anon_sym_LBRACK] = ACTIONS(3853),
    [anon_sym_static] = ACTIONS(3853),
    [anon_sym_register] = ACTIONS(3853),
    [anon_sym_inline] = ACTIONS(3853),
    [anon_sym___inline] = ACTIONS(3853),
    [anon_sym___inline__] = ACTIONS(3853),
    [anon_sym___forceinline] = ACTIONS(3853),
    [anon_sym_thread_local] = ACTIONS(3853),
    [anon_sym___thread] = ACTIONS(3853),
    [anon_sym_const] = ACTIONS(3853),
    [anon_sym_constexpr] = ACTIONS(3853),
    [anon_sym_volatile] = ACTIONS(3853),
    [anon_sym_restrict] = ACTIONS(3853),
    [anon_sym___restrict__] = ACTIONS(3853),
    [anon_sym__Atomic] = ACTIONS(3853),
    [anon_sym__Noreturn] = ACTIONS(3853),
    [anon_sym_noreturn] = ACTIONS(3853),
    [anon_sym__Nonnull] = ACTIONS(3853),
    [anon_sym_mutable] = ACTIONS(3853),
    [anon_sym_constinit] = ACTIONS(3853),
    [anon_sym_consteval] = ACTIONS(3853),
    [anon_sym_alignas] = ACTIONS(3853),
    [anon_sym__Alignas] = ACTIONS(3853),
    [sym_primitive_type] = ACTIONS(3853),
    [anon_sym_enum] = ACTIONS(3853),
    [anon_sym_class] = ACTIONS(3853),
    [anon_sym_struct] = ACTIONS(3853),
    [anon_sym_union] = ACTIONS(3853),
    [anon_sym_if] = ACTIONS(3853),
    [anon_sym_switch] = ACTIONS(3853),
    [anon_sym_case] = ACTIONS(3853),
    [anon_sym_default] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3853),
    [anon_sym_do] = ACTIONS(3853),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_return] = ACTIONS(3853),
    [anon_sym_break] = ACTIONS(3853),
    [anon_sym_continue] = ACTIONS(3853),
    [anon_sym_goto] = ACTIONS(3853),
    [anon_sym___try] = ACTIONS(3853),
    [anon_sym___leave] = ACTIONS(3853),
    [anon_sym_not] = ACTIONS(3853),
    [anon_sym_compl] = ACTIONS(3853),
    [anon_sym_DASH_DASH] = ACTIONS(3855),
    [anon_sym_PLUS_PLUS] = ACTIONS(3855),
    [anon_sym_sizeof] = ACTIONS(3853),
    [anon_sym___alignof__] = ACTIONS(3853),
    [anon_sym___alignof] = ACTIONS(3853),
    [anon_sym__alignof] = ACTIONS(3853),
    [anon_sym_alignof] = ACTIONS(3853),
    [anon_sym__Alignof] = ACTIONS(3853),
    [anon_sym_offsetof] = ACTIONS(3853),
    [anon_sym__Generic] = ACTIONS(3853),
    [anon_sym_asm] = ACTIONS(3853),
    [anon_sym___asm__] = ACTIONS(3853),
    [anon_sym___asm] = ACTIONS(3853),
    [sym_number_literal] = ACTIONS(3855),
    [anon_sym_L_SQUOTE] = ACTIONS(3855),
    [anon_sym_u_SQUOTE] = ACTIONS(3855),
    [anon_sym_U_SQUOTE] = ACTIONS(3855),
    [anon_sym_u8_SQUOTE] = ACTIONS(3855),
    [anon_sym_SQUOTE] = ACTIONS(3855),
    [anon_sym_L_DQUOTE] = ACTIONS(3855),
    [anon_sym_u_DQUOTE] = ACTIONS(3855),
    [anon_sym_U_DQUOTE] = ACTIONS(3855),
    [anon_sym_u8_DQUOTE] = ACTIONS(3855),
    [anon_sym_DQUOTE] = ACTIONS(3855),
    [sym_true] = ACTIONS(3853),
    [sym_false] = ACTIONS(3853),
    [anon_sym_NULL] = ACTIONS(3853),
    [anon_sym_nullptr] = ACTIONS(3853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3853),
    [anon_sym_let] = ACTIONS(3853),
    [anon_sym_This] = ACTIONS(3853),
    [anon_sym_decltype] = ACTIONS(3853),
    [anon_sym_explicit] = ACTIONS(3853),
    [anon_sym_typename] = ACTIONS(3853),
    [anon_sym_template] = ACTIONS(3853),
    [anon_sym_operator] = ACTIONS(3853),
    [anon_sym_try] = ACTIONS(3853),
    [anon_sym_delete] = ACTIONS(3853),
    [anon_sym_throw] = ACTIONS(3853),
    [anon_sym_namespace] = ACTIONS(3853),
    [anon_sym_static_assert] = ACTIONS(3853),
    [anon_sym_concept] = ACTIONS(3853),
    [anon_sym_co_return] = ACTIONS(3853),
    [anon_sym_co_yield] = ACTIONS(3853),
    [anon_sym_R_DQUOTE] = ACTIONS(3855),
    [anon_sym_LR_DQUOTE] = ACTIONS(3855),
    [anon_sym_uR_DQUOTE] = ACTIONS(3855),
    [anon_sym_UR_DQUOTE] = ACTIONS(3855),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3855),
    [anon_sym_co_await] = ACTIONS(3853),
    [anon_sym_new] = ACTIONS(3853),
    [anon_sym_requires] = ACTIONS(3853),
    [sym_this] = ACTIONS(3853),
    [anon_sym_discard] = ACTIONS(3853),
    [anon_sym_precise] = ACTIONS(3853),
    [anon_sym_shared] = ACTIONS(3853),
    [anon_sym_groupshared] = ACTIONS(3853),
    [anon_sym_uniform] = ACTIONS(3853),
    [anon_sym_row_major] = ACTIONS(3853),
    [anon_sym_column_major] = ACTIONS(3853),
    [anon_sym_globallycoherent] = ACTIONS(3853),
    [anon_sym_centroid] = ACTIONS(3853),
    [anon_sym_noperspective] = ACTIONS(3853),
    [anon_sym_nointerpolation] = ACTIONS(3853),
    [anon_sym_sample] = ACTIONS(3853),
    [anon_sym_linear] = ACTIONS(3853),
    [anon_sym_snorm] = ACTIONS(3853),
    [anon_sym_unorm] = ACTIONS(3853),
    [anon_sym_point] = ACTIONS(3853),
    [anon_sym_line] = ACTIONS(3853),
    [anon_sym_triangleadj] = ACTIONS(3853),
    [anon_sym_lineadj] = ACTIONS(3853),
    [anon_sym_triangle] = ACTIONS(3853),
    [anon_sym_cbuffer] = ACTIONS(3853),
    [anon_sym_interface] = ACTIONS(3853),
    [anon_sym_extension] = ACTIONS(3853),
  },
  [589] = {
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_include_token1] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token2] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [aux_sym_preproc_else_token1] = ACTIONS(3812),
    [aux_sym_preproc_elif_token1] = ACTIONS(3812),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_BANG] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3812),
    [anon_sym_PLUS] = ACTIONS(3812),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym___cdecl] = ACTIONS(3812),
    [anon_sym___clrcall] = ACTIONS(3812),
    [anon_sym___stdcall] = ACTIONS(3812),
    [anon_sym___fastcall] = ACTIONS(3812),
    [anon_sym___thiscall] = ACTIONS(3812),
    [anon_sym___vectorcall] = ACTIONS(3812),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [anon_sym_if] = ACTIONS(3812),
    [anon_sym_switch] = ACTIONS(3812),
    [anon_sym_case] = ACTIONS(3812),
    [anon_sym_default] = ACTIONS(3812),
    [anon_sym_while] = ACTIONS(3812),
    [anon_sym_do] = ACTIONS(3812),
    [anon_sym_for] = ACTIONS(3812),
    [anon_sym_return] = ACTIONS(3812),
    [anon_sym_break] = ACTIONS(3812),
    [anon_sym_continue] = ACTIONS(3812),
    [anon_sym_goto] = ACTIONS(3812),
    [anon_sym___try] = ACTIONS(3812),
    [anon_sym___leave] = ACTIONS(3812),
    [anon_sym_not] = ACTIONS(3812),
    [anon_sym_compl] = ACTIONS(3812),
    [anon_sym_DASH_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_PLUS] = ACTIONS(3814),
    [anon_sym_sizeof] = ACTIONS(3812),
    [anon_sym___alignof__] = ACTIONS(3812),
    [anon_sym___alignof] = ACTIONS(3812),
    [anon_sym__alignof] = ACTIONS(3812),
    [anon_sym_alignof] = ACTIONS(3812),
    [anon_sym__Alignof] = ACTIONS(3812),
    [anon_sym_offsetof] = ACTIONS(3812),
    [anon_sym__Generic] = ACTIONS(3812),
    [anon_sym_asm] = ACTIONS(3812),
    [anon_sym___asm__] = ACTIONS(3812),
    [anon_sym___asm] = ACTIONS(3812),
    [sym_number_literal] = ACTIONS(3814),
    [anon_sym_L_SQUOTE] = ACTIONS(3814),
    [anon_sym_u_SQUOTE] = ACTIONS(3814),
    [anon_sym_U_SQUOTE] = ACTIONS(3814),
    [anon_sym_u8_SQUOTE] = ACTIONS(3814),
    [anon_sym_SQUOTE] = ACTIONS(3814),
    [anon_sym_L_DQUOTE] = ACTIONS(3814),
    [anon_sym_u_DQUOTE] = ACTIONS(3814),
    [anon_sym_U_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [anon_sym_NULL] = ACTIONS(3812),
    [anon_sym_nullptr] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_try] = ACTIONS(3812),
    [anon_sym_delete] = ACTIONS(3812),
    [anon_sym_throw] = ACTIONS(3812),
    [anon_sym_namespace] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_concept] = ACTIONS(3812),
    [anon_sym_co_return] = ACTIONS(3812),
    [anon_sym_co_yield] = ACTIONS(3812),
    [anon_sym_R_DQUOTE] = ACTIONS(3814),
    [anon_sym_LR_DQUOTE] = ACTIONS(3814),
    [anon_sym_uR_DQUOTE] = ACTIONS(3814),
    [anon_sym_UR_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3814),
    [anon_sym_co_await] = ACTIONS(3812),
    [anon_sym_new] = ACTIONS(3812),
    [anon_sym_requires] = ACTIONS(3812),
    [sym_this] = ACTIONS(3812),
    [anon_sym_discard] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_cbuffer] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
  },
  [590] = {
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_include_token1] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token2] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [aux_sym_preproc_else_token1] = ACTIONS(3812),
    [aux_sym_preproc_elif_token1] = ACTIONS(3812),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_BANG] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3812),
    [anon_sym_PLUS] = ACTIONS(3812),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym___cdecl] = ACTIONS(3812),
    [anon_sym___clrcall] = ACTIONS(3812),
    [anon_sym___stdcall] = ACTIONS(3812),
    [anon_sym___fastcall] = ACTIONS(3812),
    [anon_sym___thiscall] = ACTIONS(3812),
    [anon_sym___vectorcall] = ACTIONS(3812),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [anon_sym_if] = ACTIONS(3812),
    [anon_sym_switch] = ACTIONS(3812),
    [anon_sym_case] = ACTIONS(3812),
    [anon_sym_default] = ACTIONS(3812),
    [anon_sym_while] = ACTIONS(3812),
    [anon_sym_do] = ACTIONS(3812),
    [anon_sym_for] = ACTIONS(3812),
    [anon_sym_return] = ACTIONS(3812),
    [anon_sym_break] = ACTIONS(3812),
    [anon_sym_continue] = ACTIONS(3812),
    [anon_sym_goto] = ACTIONS(3812),
    [anon_sym___try] = ACTIONS(3812),
    [anon_sym___leave] = ACTIONS(3812),
    [anon_sym_not] = ACTIONS(3812),
    [anon_sym_compl] = ACTIONS(3812),
    [anon_sym_DASH_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_PLUS] = ACTIONS(3814),
    [anon_sym_sizeof] = ACTIONS(3812),
    [anon_sym___alignof__] = ACTIONS(3812),
    [anon_sym___alignof] = ACTIONS(3812),
    [anon_sym__alignof] = ACTIONS(3812),
    [anon_sym_alignof] = ACTIONS(3812),
    [anon_sym__Alignof] = ACTIONS(3812),
    [anon_sym_offsetof] = ACTIONS(3812),
    [anon_sym__Generic] = ACTIONS(3812),
    [anon_sym_asm] = ACTIONS(3812),
    [anon_sym___asm__] = ACTIONS(3812),
    [anon_sym___asm] = ACTIONS(3812),
    [sym_number_literal] = ACTIONS(3814),
    [anon_sym_L_SQUOTE] = ACTIONS(3814),
    [anon_sym_u_SQUOTE] = ACTIONS(3814),
    [anon_sym_U_SQUOTE] = ACTIONS(3814),
    [anon_sym_u8_SQUOTE] = ACTIONS(3814),
    [anon_sym_SQUOTE] = ACTIONS(3814),
    [anon_sym_L_DQUOTE] = ACTIONS(3814),
    [anon_sym_u_DQUOTE] = ACTIONS(3814),
    [anon_sym_U_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [anon_sym_NULL] = ACTIONS(3812),
    [anon_sym_nullptr] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_try] = ACTIONS(3812),
    [anon_sym_delete] = ACTIONS(3812),
    [anon_sym_throw] = ACTIONS(3812),
    [anon_sym_namespace] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_concept] = ACTIONS(3812),
    [anon_sym_co_return] = ACTIONS(3812),
    [anon_sym_co_yield] = ACTIONS(3812),
    [anon_sym_R_DQUOTE] = ACTIONS(3814),
    [anon_sym_LR_DQUOTE] = ACTIONS(3814),
    [anon_sym_uR_DQUOTE] = ACTIONS(3814),
    [anon_sym_UR_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3814),
    [anon_sym_co_await] = ACTIONS(3812),
    [anon_sym_new] = ACTIONS(3812),
    [anon_sym_requires] = ACTIONS(3812),
    [sym_this] = ACTIONS(3812),
    [anon_sym_discard] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_cbuffer] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
  },
  [591] = {
    [sym_identifier] = ACTIONS(3857),
    [aux_sym_preproc_include_token1] = ACTIONS(3857),
    [aux_sym_preproc_def_token1] = ACTIONS(3857),
    [aux_sym_preproc_if_token1] = ACTIONS(3857),
    [aux_sym_preproc_if_token2] = ACTIONS(3857),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3857),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3857),
    [aux_sym_preproc_else_token1] = ACTIONS(3857),
    [aux_sym_preproc_elif_token1] = ACTIONS(3857),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3857),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3857),
    [sym_preproc_directive] = ACTIONS(3857),
    [anon_sym_LPAREN2] = ACTIONS(3859),
    [anon_sym_BANG] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3859),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_STAR] = ACTIONS(3859),
    [anon_sym_AMP_AMP] = ACTIONS(3859),
    [anon_sym_AMP] = ACTIONS(3857),
    [anon_sym_SEMI] = ACTIONS(3859),
    [anon_sym___extension__] = ACTIONS(3857),
    [anon_sym_typedef] = ACTIONS(3857),
    [anon_sym_in] = ACTIONS(3857),
    [anon_sym_out] = ACTIONS(3857),
    [anon_sym_inout] = ACTIONS(3857),
    [anon_sym_virtual] = ACTIONS(3857),
    [anon_sym_extern] = ACTIONS(3857),
    [anon_sym___attribute__] = ACTIONS(3857),
    [anon_sym___attribute] = ACTIONS(3857),
    [anon_sym_using] = ACTIONS(3857),
    [anon_sym_COLON_COLON] = ACTIONS(3859),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3859),
    [anon_sym___declspec] = ACTIONS(3857),
    [anon_sym___based] = ACTIONS(3857),
    [anon_sym___cdecl] = ACTIONS(3857),
    [anon_sym___clrcall] = ACTIONS(3857),
    [anon_sym___stdcall] = ACTIONS(3857),
    [anon_sym___fastcall] = ACTIONS(3857),
    [anon_sym___thiscall] = ACTIONS(3857),
    [anon_sym___vectorcall] = ACTIONS(3857),
    [anon_sym_LBRACE] = ACTIONS(3859),
    [anon_sym_signed] = ACTIONS(3857),
    [anon_sym_unsigned] = ACTIONS(3857),
    [anon_sym_long] = ACTIONS(3857),
    [anon_sym_short] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(3857),
    [anon_sym_static] = ACTIONS(3857),
    [anon_sym_register] = ACTIONS(3857),
    [anon_sym_inline] = ACTIONS(3857),
    [anon_sym___inline] = ACTIONS(3857),
    [anon_sym___inline__] = ACTIONS(3857),
    [anon_sym___forceinline] = ACTIONS(3857),
    [anon_sym_thread_local] = ACTIONS(3857),
    [anon_sym___thread] = ACTIONS(3857),
    [anon_sym_const] = ACTIONS(3857),
    [anon_sym_constexpr] = ACTIONS(3857),
    [anon_sym_volatile] = ACTIONS(3857),
    [anon_sym_restrict] = ACTIONS(3857),
    [anon_sym___restrict__] = ACTIONS(3857),
    [anon_sym__Atomic] = ACTIONS(3857),
    [anon_sym__Noreturn] = ACTIONS(3857),
    [anon_sym_noreturn] = ACTIONS(3857),
    [anon_sym__Nonnull] = ACTIONS(3857),
    [anon_sym_mutable] = ACTIONS(3857),
    [anon_sym_constinit] = ACTIONS(3857),
    [anon_sym_consteval] = ACTIONS(3857),
    [anon_sym_alignas] = ACTIONS(3857),
    [anon_sym__Alignas] = ACTIONS(3857),
    [sym_primitive_type] = ACTIONS(3857),
    [anon_sym_enum] = ACTIONS(3857),
    [anon_sym_class] = ACTIONS(3857),
    [anon_sym_struct] = ACTIONS(3857),
    [anon_sym_union] = ACTIONS(3857),
    [anon_sym_if] = ACTIONS(3857),
    [anon_sym_switch] = ACTIONS(3857),
    [anon_sym_case] = ACTIONS(3857),
    [anon_sym_default] = ACTIONS(3857),
    [anon_sym_while] = ACTIONS(3857),
    [anon_sym_do] = ACTIONS(3857),
    [anon_sym_for] = ACTIONS(3857),
    [anon_sym_return] = ACTIONS(3857),
    [anon_sym_break] = ACTIONS(3857),
    [anon_sym_continue] = ACTIONS(3857),
    [anon_sym_goto] = ACTIONS(3857),
    [anon_sym___try] = ACTIONS(3857),
    [anon_sym___leave] = ACTIONS(3857),
    [anon_sym_not] = ACTIONS(3857),
    [anon_sym_compl] = ACTIONS(3857),
    [anon_sym_DASH_DASH] = ACTIONS(3859),
    [anon_sym_PLUS_PLUS] = ACTIONS(3859),
    [anon_sym_sizeof] = ACTIONS(3857),
    [anon_sym___alignof__] = ACTIONS(3857),
    [anon_sym___alignof] = ACTIONS(3857),
    [anon_sym__alignof] = ACTIONS(3857),
    [anon_sym_alignof] = ACTIONS(3857),
    [anon_sym__Alignof] = ACTIONS(3857),
    [anon_sym_offsetof] = ACTIONS(3857),
    [anon_sym__Generic] = ACTIONS(3857),
    [anon_sym_asm] = ACTIONS(3857),
    [anon_sym___asm__] = ACTIONS(3857),
    [anon_sym___asm] = ACTIONS(3857),
    [sym_number_literal] = ACTIONS(3859),
    [anon_sym_L_SQUOTE] = ACTIONS(3859),
    [anon_sym_u_SQUOTE] = ACTIONS(3859),
    [anon_sym_U_SQUOTE] = ACTIONS(3859),
    [anon_sym_u8_SQUOTE] = ACTIONS(3859),
    [anon_sym_SQUOTE] = ACTIONS(3859),
    [anon_sym_L_DQUOTE] = ACTIONS(3859),
    [anon_sym_u_DQUOTE] = ACTIONS(3859),
    [anon_sym_U_DQUOTE] = ACTIONS(3859),
    [anon_sym_u8_DQUOTE] = ACTIONS(3859),
    [anon_sym_DQUOTE] = ACTIONS(3859),
    [sym_true] = ACTIONS(3857),
    [sym_false] = ACTIONS(3857),
    [anon_sym_NULL] = ACTIONS(3857),
    [anon_sym_nullptr] = ACTIONS(3857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3857),
    [anon_sym_let] = ACTIONS(3857),
    [anon_sym_This] = ACTIONS(3857),
    [anon_sym_decltype] = ACTIONS(3857),
    [anon_sym_explicit] = ACTIONS(3857),
    [anon_sym_typename] = ACTIONS(3857),
    [anon_sym_template] = ACTIONS(3857),
    [anon_sym_operator] = ACTIONS(3857),
    [anon_sym_try] = ACTIONS(3857),
    [anon_sym_delete] = ACTIONS(3857),
    [anon_sym_throw] = ACTIONS(3857),
    [anon_sym_namespace] = ACTIONS(3857),
    [anon_sym_static_assert] = ACTIONS(3857),
    [anon_sym_concept] = ACTIONS(3857),
    [anon_sym_co_return] = ACTIONS(3857),
    [anon_sym_co_yield] = ACTIONS(3857),
    [anon_sym_R_DQUOTE] = ACTIONS(3859),
    [anon_sym_LR_DQUOTE] = ACTIONS(3859),
    [anon_sym_uR_DQUOTE] = ACTIONS(3859),
    [anon_sym_UR_DQUOTE] = ACTIONS(3859),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3859),
    [anon_sym_co_await] = ACTIONS(3857),
    [anon_sym_new] = ACTIONS(3857),
    [anon_sym_requires] = ACTIONS(3857),
    [sym_this] = ACTIONS(3857),
    [anon_sym_discard] = ACTIONS(3857),
    [anon_sym_precise] = ACTIONS(3857),
    [anon_sym_shared] = ACTIONS(3857),
    [anon_sym_groupshared] = ACTIONS(3857),
    [anon_sym_uniform] = ACTIONS(3857),
    [anon_sym_row_major] = ACTIONS(3857),
    [anon_sym_column_major] = ACTIONS(3857),
    [anon_sym_globallycoherent] = ACTIONS(3857),
    [anon_sym_centroid] = ACTIONS(3857),
    [anon_sym_noperspective] = ACTIONS(3857),
    [anon_sym_nointerpolation] = ACTIONS(3857),
    [anon_sym_sample] = ACTIONS(3857),
    [anon_sym_linear] = ACTIONS(3857),
    [anon_sym_snorm] = ACTIONS(3857),
    [anon_sym_unorm] = ACTIONS(3857),
    [anon_sym_point] = ACTIONS(3857),
    [anon_sym_line] = ACTIONS(3857),
    [anon_sym_triangleadj] = ACTIONS(3857),
    [anon_sym_lineadj] = ACTIONS(3857),
    [anon_sym_triangle] = ACTIONS(3857),
    [anon_sym_cbuffer] = ACTIONS(3857),
    [anon_sym_interface] = ACTIONS(3857),
    [anon_sym_extension] = ACTIONS(3857),
  },
  [592] = {
    [sym_identifier] = ACTIONS(3861),
    [aux_sym_preproc_include_token1] = ACTIONS(3861),
    [aux_sym_preproc_def_token1] = ACTIONS(3861),
    [aux_sym_preproc_if_token1] = ACTIONS(3861),
    [aux_sym_preproc_if_token2] = ACTIONS(3861),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3861),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3861),
    [aux_sym_preproc_else_token1] = ACTIONS(3861),
    [aux_sym_preproc_elif_token1] = ACTIONS(3861),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3861),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3861),
    [sym_preproc_directive] = ACTIONS(3861),
    [anon_sym_LPAREN2] = ACTIONS(3863),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3861),
    [anon_sym_PLUS] = ACTIONS(3861),
    [anon_sym_STAR] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_AMP] = ACTIONS(3861),
    [anon_sym_SEMI] = ACTIONS(3863),
    [anon_sym___extension__] = ACTIONS(3861),
    [anon_sym_typedef] = ACTIONS(3861),
    [anon_sym_in] = ACTIONS(3861),
    [anon_sym_out] = ACTIONS(3861),
    [anon_sym_inout] = ACTIONS(3861),
    [anon_sym_virtual] = ACTIONS(3861),
    [anon_sym_extern] = ACTIONS(3861),
    [anon_sym___attribute__] = ACTIONS(3861),
    [anon_sym___attribute] = ACTIONS(3861),
    [anon_sym_using] = ACTIONS(3861),
    [anon_sym_COLON_COLON] = ACTIONS(3863),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3863),
    [anon_sym___declspec] = ACTIONS(3861),
    [anon_sym___based] = ACTIONS(3861),
    [anon_sym___cdecl] = ACTIONS(3861),
    [anon_sym___clrcall] = ACTIONS(3861),
    [anon_sym___stdcall] = ACTIONS(3861),
    [anon_sym___fastcall] = ACTIONS(3861),
    [anon_sym___thiscall] = ACTIONS(3861),
    [anon_sym___vectorcall] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_signed] = ACTIONS(3861),
    [anon_sym_unsigned] = ACTIONS(3861),
    [anon_sym_long] = ACTIONS(3861),
    [anon_sym_short] = ACTIONS(3861),
    [anon_sym_LBRACK] = ACTIONS(3861),
    [anon_sym_static] = ACTIONS(3861),
    [anon_sym_register] = ACTIONS(3861),
    [anon_sym_inline] = ACTIONS(3861),
    [anon_sym___inline] = ACTIONS(3861),
    [anon_sym___inline__] = ACTIONS(3861),
    [anon_sym___forceinline] = ACTIONS(3861),
    [anon_sym_thread_local] = ACTIONS(3861),
    [anon_sym___thread] = ACTIONS(3861),
    [anon_sym_const] = ACTIONS(3861),
    [anon_sym_constexpr] = ACTIONS(3861),
    [anon_sym_volatile] = ACTIONS(3861),
    [anon_sym_restrict] = ACTIONS(3861),
    [anon_sym___restrict__] = ACTIONS(3861),
    [anon_sym__Atomic] = ACTIONS(3861),
    [anon_sym__Noreturn] = ACTIONS(3861),
    [anon_sym_noreturn] = ACTIONS(3861),
    [anon_sym__Nonnull] = ACTIONS(3861),
    [anon_sym_mutable] = ACTIONS(3861),
    [anon_sym_constinit] = ACTIONS(3861),
    [anon_sym_consteval] = ACTIONS(3861),
    [anon_sym_alignas] = ACTIONS(3861),
    [anon_sym__Alignas] = ACTIONS(3861),
    [sym_primitive_type] = ACTIONS(3861),
    [anon_sym_enum] = ACTIONS(3861),
    [anon_sym_class] = ACTIONS(3861),
    [anon_sym_struct] = ACTIONS(3861),
    [anon_sym_union] = ACTIONS(3861),
    [anon_sym_if] = ACTIONS(3861),
    [anon_sym_switch] = ACTIONS(3861),
    [anon_sym_case] = ACTIONS(3861),
    [anon_sym_default] = ACTIONS(3861),
    [anon_sym_while] = ACTIONS(3861),
    [anon_sym_do] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3861),
    [anon_sym_return] = ACTIONS(3861),
    [anon_sym_break] = ACTIONS(3861),
    [anon_sym_continue] = ACTIONS(3861),
    [anon_sym_goto] = ACTIONS(3861),
    [anon_sym___try] = ACTIONS(3861),
    [anon_sym___leave] = ACTIONS(3861),
    [anon_sym_not] = ACTIONS(3861),
    [anon_sym_compl] = ACTIONS(3861),
    [anon_sym_DASH_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3863),
    [anon_sym_sizeof] = ACTIONS(3861),
    [anon_sym___alignof__] = ACTIONS(3861),
    [anon_sym___alignof] = ACTIONS(3861),
    [anon_sym__alignof] = ACTIONS(3861),
    [anon_sym_alignof] = ACTIONS(3861),
    [anon_sym__Alignof] = ACTIONS(3861),
    [anon_sym_offsetof] = ACTIONS(3861),
    [anon_sym__Generic] = ACTIONS(3861),
    [anon_sym_asm] = ACTIONS(3861),
    [anon_sym___asm__] = ACTIONS(3861),
    [anon_sym___asm] = ACTIONS(3861),
    [sym_number_literal] = ACTIONS(3863),
    [anon_sym_L_SQUOTE] = ACTIONS(3863),
    [anon_sym_u_SQUOTE] = ACTIONS(3863),
    [anon_sym_U_SQUOTE] = ACTIONS(3863),
    [anon_sym_u8_SQUOTE] = ACTIONS(3863),
    [anon_sym_SQUOTE] = ACTIONS(3863),
    [anon_sym_L_DQUOTE] = ACTIONS(3863),
    [anon_sym_u_DQUOTE] = ACTIONS(3863),
    [anon_sym_U_DQUOTE] = ACTIONS(3863),
    [anon_sym_u8_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [sym_true] = ACTIONS(3861),
    [sym_false] = ACTIONS(3861),
    [anon_sym_NULL] = ACTIONS(3861),
    [anon_sym_nullptr] = ACTIONS(3861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3861),
    [anon_sym_let] = ACTIONS(3861),
    [anon_sym_This] = ACTIONS(3861),
    [anon_sym_decltype] = ACTIONS(3861),
    [anon_sym_explicit] = ACTIONS(3861),
    [anon_sym_typename] = ACTIONS(3861),
    [anon_sym_template] = ACTIONS(3861),
    [anon_sym_operator] = ACTIONS(3861),
    [anon_sym_try] = ACTIONS(3861),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_throw] = ACTIONS(3861),
    [anon_sym_namespace] = ACTIONS(3861),
    [anon_sym_static_assert] = ACTIONS(3861),
    [anon_sym_concept] = ACTIONS(3861),
    [anon_sym_co_return] = ACTIONS(3861),
    [anon_sym_co_yield] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(3863),
    [anon_sym_LR_DQUOTE] = ACTIONS(3863),
    [anon_sym_uR_DQUOTE] = ACTIONS(3863),
    [anon_sym_UR_DQUOTE] = ACTIONS(3863),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3863),
    [anon_sym_co_await] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3861),
    [anon_sym_requires] = ACTIONS(3861),
    [sym_this] = ACTIONS(3861),
    [anon_sym_discard] = ACTIONS(3861),
    [anon_sym_precise] = ACTIONS(3861),
    [anon_sym_shared] = ACTIONS(3861),
    [anon_sym_groupshared] = ACTIONS(3861),
    [anon_sym_uniform] = ACTIONS(3861),
    [anon_sym_row_major] = ACTIONS(3861),
    [anon_sym_column_major] = ACTIONS(3861),
    [anon_sym_globallycoherent] = ACTIONS(3861),
    [anon_sym_centroid] = ACTIONS(3861),
    [anon_sym_noperspective] = ACTIONS(3861),
    [anon_sym_nointerpolation] = ACTIONS(3861),
    [anon_sym_sample] = ACTIONS(3861),
    [anon_sym_linear] = ACTIONS(3861),
    [anon_sym_snorm] = ACTIONS(3861),
    [anon_sym_unorm] = ACTIONS(3861),
    [anon_sym_point] = ACTIONS(3861),
    [anon_sym_line] = ACTIONS(3861),
    [anon_sym_triangleadj] = ACTIONS(3861),
    [anon_sym_lineadj] = ACTIONS(3861),
    [anon_sym_triangle] = ACTIONS(3861),
    [anon_sym_cbuffer] = ACTIONS(3861),
    [anon_sym_interface] = ACTIONS(3861),
    [anon_sym_extension] = ACTIONS(3861),
  },
  [593] = {
    [sym_identifier] = ACTIONS(3865),
    [aux_sym_preproc_include_token1] = ACTIONS(3865),
    [aux_sym_preproc_def_token1] = ACTIONS(3865),
    [aux_sym_preproc_if_token1] = ACTIONS(3865),
    [aux_sym_preproc_if_token2] = ACTIONS(3865),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3865),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3865),
    [aux_sym_preproc_else_token1] = ACTIONS(3865),
    [aux_sym_preproc_elif_token1] = ACTIONS(3865),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3865),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3865),
    [sym_preproc_directive] = ACTIONS(3865),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_BANG] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_STAR] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_AMP] = ACTIONS(3865),
    [anon_sym_SEMI] = ACTIONS(3867),
    [anon_sym___extension__] = ACTIONS(3865),
    [anon_sym_typedef] = ACTIONS(3865),
    [anon_sym_in] = ACTIONS(3865),
    [anon_sym_out] = ACTIONS(3865),
    [anon_sym_inout] = ACTIONS(3865),
    [anon_sym_virtual] = ACTIONS(3865),
    [anon_sym_extern] = ACTIONS(3865),
    [anon_sym___attribute__] = ACTIONS(3865),
    [anon_sym___attribute] = ACTIONS(3865),
    [anon_sym_using] = ACTIONS(3865),
    [anon_sym_COLON_COLON] = ACTIONS(3867),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3867),
    [anon_sym___declspec] = ACTIONS(3865),
    [anon_sym___based] = ACTIONS(3865),
    [anon_sym___cdecl] = ACTIONS(3865),
    [anon_sym___clrcall] = ACTIONS(3865),
    [anon_sym___stdcall] = ACTIONS(3865),
    [anon_sym___fastcall] = ACTIONS(3865),
    [anon_sym___thiscall] = ACTIONS(3865),
    [anon_sym___vectorcall] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3867),
    [anon_sym_signed] = ACTIONS(3865),
    [anon_sym_unsigned] = ACTIONS(3865),
    [anon_sym_long] = ACTIONS(3865),
    [anon_sym_short] = ACTIONS(3865),
    [anon_sym_LBRACK] = ACTIONS(3865),
    [anon_sym_static] = ACTIONS(3865),
    [anon_sym_register] = ACTIONS(3865),
    [anon_sym_inline] = ACTIONS(3865),
    [anon_sym___inline] = ACTIONS(3865),
    [anon_sym___inline__] = ACTIONS(3865),
    [anon_sym___forceinline] = ACTIONS(3865),
    [anon_sym_thread_local] = ACTIONS(3865),
    [anon_sym___thread] = ACTIONS(3865),
    [anon_sym_const] = ACTIONS(3865),
    [anon_sym_constexpr] = ACTIONS(3865),
    [anon_sym_volatile] = ACTIONS(3865),
    [anon_sym_restrict] = ACTIONS(3865),
    [anon_sym___restrict__] = ACTIONS(3865),
    [anon_sym__Atomic] = ACTIONS(3865),
    [anon_sym__Noreturn] = ACTIONS(3865),
    [anon_sym_noreturn] = ACTIONS(3865),
    [anon_sym__Nonnull] = ACTIONS(3865),
    [anon_sym_mutable] = ACTIONS(3865),
    [anon_sym_constinit] = ACTIONS(3865),
    [anon_sym_consteval] = ACTIONS(3865),
    [anon_sym_alignas] = ACTIONS(3865),
    [anon_sym__Alignas] = ACTIONS(3865),
    [sym_primitive_type] = ACTIONS(3865),
    [anon_sym_enum] = ACTIONS(3865),
    [anon_sym_class] = ACTIONS(3865),
    [anon_sym_struct] = ACTIONS(3865),
    [anon_sym_union] = ACTIONS(3865),
    [anon_sym_if] = ACTIONS(3865),
    [anon_sym_switch] = ACTIONS(3865),
    [anon_sym_case] = ACTIONS(3865),
    [anon_sym_default] = ACTIONS(3865),
    [anon_sym_while] = ACTIONS(3865),
    [anon_sym_do] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3865),
    [anon_sym_return] = ACTIONS(3865),
    [anon_sym_break] = ACTIONS(3865),
    [anon_sym_continue] = ACTIONS(3865),
    [anon_sym_goto] = ACTIONS(3865),
    [anon_sym___try] = ACTIONS(3865),
    [anon_sym___leave] = ACTIONS(3865),
    [anon_sym_not] = ACTIONS(3865),
    [anon_sym_compl] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3867),
    [anon_sym_PLUS_PLUS] = ACTIONS(3867),
    [anon_sym_sizeof] = ACTIONS(3865),
    [anon_sym___alignof__] = ACTIONS(3865),
    [anon_sym___alignof] = ACTIONS(3865),
    [anon_sym__alignof] = ACTIONS(3865),
    [anon_sym_alignof] = ACTIONS(3865),
    [anon_sym__Alignof] = ACTIONS(3865),
    [anon_sym_offsetof] = ACTIONS(3865),
    [anon_sym__Generic] = ACTIONS(3865),
    [anon_sym_asm] = ACTIONS(3865),
    [anon_sym___asm__] = ACTIONS(3865),
    [anon_sym___asm] = ACTIONS(3865),
    [sym_number_literal] = ACTIONS(3867),
    [anon_sym_L_SQUOTE] = ACTIONS(3867),
    [anon_sym_u_SQUOTE] = ACTIONS(3867),
    [anon_sym_U_SQUOTE] = ACTIONS(3867),
    [anon_sym_u8_SQUOTE] = ACTIONS(3867),
    [anon_sym_SQUOTE] = ACTIONS(3867),
    [anon_sym_L_DQUOTE] = ACTIONS(3867),
    [anon_sym_u_DQUOTE] = ACTIONS(3867),
    [anon_sym_U_DQUOTE] = ACTIONS(3867),
    [anon_sym_u8_DQUOTE] = ACTIONS(3867),
    [anon_sym_DQUOTE] = ACTIONS(3867),
    [sym_true] = ACTIONS(3865),
    [sym_false] = ACTIONS(3865),
    [anon_sym_NULL] = ACTIONS(3865),
    [anon_sym_nullptr] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3865),
    [anon_sym_let] = ACTIONS(3865),
    [anon_sym_This] = ACTIONS(3865),
    [anon_sym_decltype] = ACTIONS(3865),
    [anon_sym_explicit] = ACTIONS(3865),
    [anon_sym_typename] = ACTIONS(3865),
    [anon_sym_template] = ACTIONS(3865),
    [anon_sym_operator] = ACTIONS(3865),
    [anon_sym_try] = ACTIONS(3865),
    [anon_sym_delete] = ACTIONS(3865),
    [anon_sym_throw] = ACTIONS(3865),
    [anon_sym_namespace] = ACTIONS(3865),
    [anon_sym_static_assert] = ACTIONS(3865),
    [anon_sym_concept] = ACTIONS(3865),
    [anon_sym_co_return] = ACTIONS(3865),
    [anon_sym_co_yield] = ACTIONS(3865),
    [anon_sym_R_DQUOTE] = ACTIONS(3867),
    [anon_sym_LR_DQUOTE] = ACTIONS(3867),
    [anon_sym_uR_DQUOTE] = ACTIONS(3867),
    [anon_sym_UR_DQUOTE] = ACTIONS(3867),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3867),
    [anon_sym_co_await] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(3865),
    [sym_this] = ACTIONS(3865),
    [anon_sym_discard] = ACTIONS(3865),
    [anon_sym_precise] = ACTIONS(3865),
    [anon_sym_shared] = ACTIONS(3865),
    [anon_sym_groupshared] = ACTIONS(3865),
    [anon_sym_uniform] = ACTIONS(3865),
    [anon_sym_row_major] = ACTIONS(3865),
    [anon_sym_column_major] = ACTIONS(3865),
    [anon_sym_globallycoherent] = ACTIONS(3865),
    [anon_sym_centroid] = ACTIONS(3865),
    [anon_sym_noperspective] = ACTIONS(3865),
    [anon_sym_nointerpolation] = ACTIONS(3865),
    [anon_sym_sample] = ACTIONS(3865),
    [anon_sym_linear] = ACTIONS(3865),
    [anon_sym_snorm] = ACTIONS(3865),
    [anon_sym_unorm] = ACTIONS(3865),
    [anon_sym_point] = ACTIONS(3865),
    [anon_sym_line] = ACTIONS(3865),
    [anon_sym_triangleadj] = ACTIONS(3865),
    [anon_sym_lineadj] = ACTIONS(3865),
    [anon_sym_triangle] = ACTIONS(3865),
    [anon_sym_cbuffer] = ACTIONS(3865),
    [anon_sym_interface] = ACTIONS(3865),
    [anon_sym_extension] = ACTIONS(3865),
  },
  [594] = {
    [sym_identifier] = ACTIONS(3869),
    [aux_sym_preproc_include_token1] = ACTIONS(3869),
    [aux_sym_preproc_def_token1] = ACTIONS(3869),
    [aux_sym_preproc_if_token1] = ACTIONS(3869),
    [aux_sym_preproc_if_token2] = ACTIONS(3869),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3869),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3869),
    [aux_sym_preproc_else_token1] = ACTIONS(3869),
    [aux_sym_preproc_elif_token1] = ACTIONS(3869),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3869),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3869),
    [sym_preproc_directive] = ACTIONS(3869),
    [anon_sym_LPAREN2] = ACTIONS(3871),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(3871),
    [anon_sym_AMP_AMP] = ACTIONS(3871),
    [anon_sym_AMP] = ACTIONS(3869),
    [anon_sym_SEMI] = ACTIONS(3871),
    [anon_sym___extension__] = ACTIONS(3869),
    [anon_sym_typedef] = ACTIONS(3869),
    [anon_sym_in] = ACTIONS(3869),
    [anon_sym_out] = ACTIONS(3869),
    [anon_sym_inout] = ACTIONS(3869),
    [anon_sym_virtual] = ACTIONS(3869),
    [anon_sym_extern] = ACTIONS(3869),
    [anon_sym___attribute__] = ACTIONS(3869),
    [anon_sym___attribute] = ACTIONS(3869),
    [anon_sym_using] = ACTIONS(3869),
    [anon_sym_COLON_COLON] = ACTIONS(3871),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3871),
    [anon_sym___declspec] = ACTIONS(3869),
    [anon_sym___based] = ACTIONS(3869),
    [anon_sym___cdecl] = ACTIONS(3869),
    [anon_sym___clrcall] = ACTIONS(3869),
    [anon_sym___stdcall] = ACTIONS(3869),
    [anon_sym___fastcall] = ACTIONS(3869),
    [anon_sym___thiscall] = ACTIONS(3869),
    [anon_sym___vectorcall] = ACTIONS(3869),
    [anon_sym_LBRACE] = ACTIONS(3871),
    [anon_sym_signed] = ACTIONS(3869),
    [anon_sym_unsigned] = ACTIONS(3869),
    [anon_sym_long] = ACTIONS(3869),
    [anon_sym_short] = ACTIONS(3869),
    [anon_sym_LBRACK] = ACTIONS(3869),
    [anon_sym_static] = ACTIONS(3869),
    [anon_sym_register] = ACTIONS(3869),
    [anon_sym_inline] = ACTIONS(3869),
    [anon_sym___inline] = ACTIONS(3869),
    [anon_sym___inline__] = ACTIONS(3869),
    [anon_sym___forceinline] = ACTIONS(3869),
    [anon_sym_thread_local] = ACTIONS(3869),
    [anon_sym___thread] = ACTIONS(3869),
    [anon_sym_const] = ACTIONS(3869),
    [anon_sym_constexpr] = ACTIONS(3869),
    [anon_sym_volatile] = ACTIONS(3869),
    [anon_sym_restrict] = ACTIONS(3869),
    [anon_sym___restrict__] = ACTIONS(3869),
    [anon_sym__Atomic] = ACTIONS(3869),
    [anon_sym__Noreturn] = ACTIONS(3869),
    [anon_sym_noreturn] = ACTIONS(3869),
    [anon_sym__Nonnull] = ACTIONS(3869),
    [anon_sym_mutable] = ACTIONS(3869),
    [anon_sym_constinit] = ACTIONS(3869),
    [anon_sym_consteval] = ACTIONS(3869),
    [anon_sym_alignas] = ACTIONS(3869),
    [anon_sym__Alignas] = ACTIONS(3869),
    [sym_primitive_type] = ACTIONS(3869),
    [anon_sym_enum] = ACTIONS(3869),
    [anon_sym_class] = ACTIONS(3869),
    [anon_sym_struct] = ACTIONS(3869),
    [anon_sym_union] = ACTIONS(3869),
    [anon_sym_if] = ACTIONS(3869),
    [anon_sym_switch] = ACTIONS(3869),
    [anon_sym_case] = ACTIONS(3869),
    [anon_sym_default] = ACTIONS(3869),
    [anon_sym_while] = ACTIONS(3869),
    [anon_sym_do] = ACTIONS(3869),
    [anon_sym_for] = ACTIONS(3869),
    [anon_sym_return] = ACTIONS(3869),
    [anon_sym_break] = ACTIONS(3869),
    [anon_sym_continue] = ACTIONS(3869),
    [anon_sym_goto] = ACTIONS(3869),
    [anon_sym___try] = ACTIONS(3869),
    [anon_sym___leave] = ACTIONS(3869),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(3871),
    [anon_sym_PLUS_PLUS] = ACTIONS(3871),
    [anon_sym_sizeof] = ACTIONS(3869),
    [anon_sym___alignof__] = ACTIONS(3869),
    [anon_sym___alignof] = ACTIONS(3869),
    [anon_sym__alignof] = ACTIONS(3869),
    [anon_sym_alignof] = ACTIONS(3869),
    [anon_sym__Alignof] = ACTIONS(3869),
    [anon_sym_offsetof] = ACTIONS(3869),
    [anon_sym__Generic] = ACTIONS(3869),
    [anon_sym_asm] = ACTIONS(3869),
    [anon_sym___asm__] = ACTIONS(3869),
    [anon_sym___asm] = ACTIONS(3869),
    [sym_number_literal] = ACTIONS(3871),
    [anon_sym_L_SQUOTE] = ACTIONS(3871),
    [anon_sym_u_SQUOTE] = ACTIONS(3871),
    [anon_sym_U_SQUOTE] = ACTIONS(3871),
    [anon_sym_u8_SQUOTE] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3871),
    [anon_sym_L_DQUOTE] = ACTIONS(3871),
    [anon_sym_u_DQUOTE] = ACTIONS(3871),
    [anon_sym_U_DQUOTE] = ACTIONS(3871),
    [anon_sym_u8_DQUOTE] = ACTIONS(3871),
    [anon_sym_DQUOTE] = ACTIONS(3871),
    [sym_true] = ACTIONS(3869),
    [sym_false] = ACTIONS(3869),
    [anon_sym_NULL] = ACTIONS(3869),
    [anon_sym_nullptr] = ACTIONS(3869),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3869),
    [anon_sym_let] = ACTIONS(3869),
    [anon_sym_This] = ACTIONS(3869),
    [anon_sym_decltype] = ACTIONS(3869),
    [anon_sym_explicit] = ACTIONS(3869),
    [anon_sym_typename] = ACTIONS(3869),
    [anon_sym_template] = ACTIONS(3869),
    [anon_sym_operator] = ACTIONS(3869),
    [anon_sym_try] = ACTIONS(3869),
    [anon_sym_delete] = ACTIONS(3869),
    [anon_sym_throw] = ACTIONS(3869),
    [anon_sym_namespace] = ACTIONS(3869),
    [anon_sym_static_assert] = ACTIONS(3869),
    [anon_sym_concept] = ACTIONS(3869),
    [anon_sym_co_return] = ACTIONS(3869),
    [anon_sym_co_yield] = ACTIONS(3869),
    [anon_sym_R_DQUOTE] = ACTIONS(3871),
    [anon_sym_LR_DQUOTE] = ACTIONS(3871),
    [anon_sym_uR_DQUOTE] = ACTIONS(3871),
    [anon_sym_UR_DQUOTE] = ACTIONS(3871),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3871),
    [anon_sym_co_await] = ACTIONS(3869),
    [anon_sym_new] = ACTIONS(3869),
    [anon_sym_requires] = ACTIONS(3869),
    [sym_this] = ACTIONS(3869),
    [anon_sym_discard] = ACTIONS(3869),
    [anon_sym_precise] = ACTIONS(3869),
    [anon_sym_shared] = ACTIONS(3869),
    [anon_sym_groupshared] = ACTIONS(3869),
    [anon_sym_uniform] = ACTIONS(3869),
    [anon_sym_row_major] = ACTIONS(3869),
    [anon_sym_column_major] = ACTIONS(3869),
    [anon_sym_globallycoherent] = ACTIONS(3869),
    [anon_sym_centroid] = ACTIONS(3869),
    [anon_sym_noperspective] = ACTIONS(3869),
    [anon_sym_nointerpolation] = ACTIONS(3869),
    [anon_sym_sample] = ACTIONS(3869),
    [anon_sym_linear] = ACTIONS(3869),
    [anon_sym_snorm] = ACTIONS(3869),
    [anon_sym_unorm] = ACTIONS(3869),
    [anon_sym_point] = ACTIONS(3869),
    [anon_sym_line] = ACTIONS(3869),
    [anon_sym_triangleadj] = ACTIONS(3869),
    [anon_sym_lineadj] = ACTIONS(3869),
    [anon_sym_triangle] = ACTIONS(3869),
    [anon_sym_cbuffer] = ACTIONS(3869),
    [anon_sym_interface] = ACTIONS(3869),
    [anon_sym_extension] = ACTIONS(3869),
  },
  [595] = {
    [sym_template_argument_list] = STATE(210),
    [aux_sym_sized_type_specifier_repeat1] = STATE(714),
    [ts_builtin_sym_end] = ACTIONS(2176),
    [sym_identifier] = ACTIONS(2168),
    [aux_sym_preproc_include_token1] = ACTIONS(2168),
    [aux_sym_preproc_def_token1] = ACTIONS(2168),
    [aux_sym_preproc_if_token1] = ACTIONS(2168),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2168),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2168),
    [sym_preproc_directive] = ACTIONS(2168),
    [anon_sym_LPAREN2] = ACTIONS(2176),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2168),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2168),
    [anon_sym_LT] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2176),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_typedef] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_using] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2176),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym___cdecl] = ACTIONS(2168),
    [anon_sym___clrcall] = ACTIONS(2168),
    [anon_sym___stdcall] = ACTIONS(2168),
    [anon_sym___fastcall] = ACTIONS(2168),
    [anon_sym___thiscall] = ACTIONS(2168),
    [anon_sym___vectorcall] = ACTIONS(2168),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_signed] = ACTIONS(2220),
    [anon_sym_unsigned] = ACTIONS(2220),
    [anon_sym_long] = ACTIONS(2220),
    [anon_sym_short] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2168),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [sym_primitive_type] = ACTIONS(2168),
    [anon_sym_enum] = ACTIONS(2168),
    [anon_sym_class] = ACTIONS(2168),
    [anon_sym_struct] = ACTIONS(2168),
    [anon_sym_union] = ACTIONS(2168),
    [anon_sym_if] = ACTIONS(2168),
    [anon_sym_switch] = ACTIONS(2168),
    [anon_sym_case] = ACTIONS(2168),
    [anon_sym_default] = ACTIONS(2168),
    [anon_sym_while] = ACTIONS(2168),
    [anon_sym_do] = ACTIONS(2168),
    [anon_sym_for] = ACTIONS(2168),
    [anon_sym_return] = ACTIONS(2168),
    [anon_sym_break] = ACTIONS(2168),
    [anon_sym_continue] = ACTIONS(2168),
    [anon_sym_goto] = ACTIONS(2168),
    [anon_sym_not] = ACTIONS(2168),
    [anon_sym_compl] = ACTIONS(2168),
    [anon_sym_DASH_DASH] = ACTIONS(2176),
    [anon_sym_PLUS_PLUS] = ACTIONS(2176),
    [anon_sym_sizeof] = ACTIONS(2168),
    [anon_sym___alignof__] = ACTIONS(2168),
    [anon_sym___alignof] = ACTIONS(2168),
    [anon_sym__alignof] = ACTIONS(2168),
    [anon_sym_alignof] = ACTIONS(2168),
    [anon_sym__Alignof] = ACTIONS(2168),
    [anon_sym_offsetof] = ACTIONS(2168),
    [anon_sym__Generic] = ACTIONS(2168),
    [anon_sym_asm] = ACTIONS(2168),
    [anon_sym___asm__] = ACTIONS(2168),
    [anon_sym___asm] = ACTIONS(2168),
    [anon_sym_DOT] = ACTIONS(2168),
    [sym_number_literal] = ACTIONS(2176),
    [anon_sym_L_SQUOTE] = ACTIONS(2176),
    [anon_sym_u_SQUOTE] = ACTIONS(2176),
    [anon_sym_U_SQUOTE] = ACTIONS(2176),
    [anon_sym_u8_SQUOTE] = ACTIONS(2176),
    [anon_sym_SQUOTE] = ACTIONS(2176),
    [anon_sym_L_DQUOTE] = ACTIONS(2176),
    [anon_sym_u_DQUOTE] = ACTIONS(2176),
    [anon_sym_U_DQUOTE] = ACTIONS(2176),
    [anon_sym_u8_DQUOTE] = ACTIONS(2176),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_true] = ACTIONS(2168),
    [sym_false] = ACTIONS(2168),
    [anon_sym_NULL] = ACTIONS(2168),
    [anon_sym_nullptr] = ACTIONS(2168),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_decltype] = ACTIONS(2168),
    [anon_sym_explicit] = ACTIONS(2168),
    [anon_sym_typename] = ACTIONS(2168),
    [anon_sym_export] = ACTIONS(2168),
    [anon_sym_module] = ACTIONS(2168),
    [anon_sym_import] = ACTIONS(2168),
    [anon_sym_template] = ACTIONS(2168),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_try] = ACTIONS(2168),
    [anon_sym_delete] = ACTIONS(2168),
    [anon_sym_throw] = ACTIONS(2168),
    [anon_sym_namespace] = ACTIONS(2168),
    [anon_sym_static_assert] = ACTIONS(2168),
    [anon_sym_concept] = ACTIONS(2168),
    [anon_sym_co_return] = ACTIONS(2168),
    [anon_sym_co_yield] = ACTIONS(2168),
    [anon_sym_R_DQUOTE] = ACTIONS(2176),
    [anon_sym_LR_DQUOTE] = ACTIONS(2176),
    [anon_sym_uR_DQUOTE] = ACTIONS(2176),
    [anon_sym_UR_DQUOTE] = ACTIONS(2176),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2176),
    [anon_sym_co_await] = ACTIONS(2168),
    [anon_sym_new] = ACTIONS(2168),
    [anon_sym_requires] = ACTIONS(2168),
    [sym_this] = ACTIONS(2168),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
    [anon_sym_interface] = ACTIONS(2168),
    [anon_sym_extension] = ACTIONS(2168),
    [anon_sym___exported] = ACTIONS(2168),
  },
  [596] = {
    [sym_identifier] = ACTIONS(3873),
    [aux_sym_preproc_include_token1] = ACTIONS(3873),
    [aux_sym_preproc_def_token1] = ACTIONS(3873),
    [aux_sym_preproc_if_token1] = ACTIONS(3873),
    [aux_sym_preproc_if_token2] = ACTIONS(3873),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3873),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3873),
    [aux_sym_preproc_else_token1] = ACTIONS(3873),
    [aux_sym_preproc_elif_token1] = ACTIONS(3873),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3873),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3873),
    [sym_preproc_directive] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(3875),
    [anon_sym_BANG] = ACTIONS(3875),
    [anon_sym_TILDE] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3873),
    [anon_sym_PLUS] = ACTIONS(3873),
    [anon_sym_STAR] = ACTIONS(3875),
    [anon_sym_AMP_AMP] = ACTIONS(3875),
    [anon_sym_AMP] = ACTIONS(3873),
    [anon_sym_SEMI] = ACTIONS(3875),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_typedef] = ACTIONS(3873),
    [anon_sym_in] = ACTIONS(3873),
    [anon_sym_out] = ACTIONS(3873),
    [anon_sym_inout] = ACTIONS(3873),
    [anon_sym_virtual] = ACTIONS(3873),
    [anon_sym_extern] = ACTIONS(3873),
    [anon_sym___attribute__] = ACTIONS(3873),
    [anon_sym___attribute] = ACTIONS(3873),
    [anon_sym_using] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3875),
    [anon_sym___declspec] = ACTIONS(3873),
    [anon_sym___based] = ACTIONS(3873),
    [anon_sym___cdecl] = ACTIONS(3873),
    [anon_sym___clrcall] = ACTIONS(3873),
    [anon_sym___stdcall] = ACTIONS(3873),
    [anon_sym___fastcall] = ACTIONS(3873),
    [anon_sym___thiscall] = ACTIONS(3873),
    [anon_sym___vectorcall] = ACTIONS(3873),
    [anon_sym_LBRACE] = ACTIONS(3875),
    [anon_sym_signed] = ACTIONS(3873),
    [anon_sym_unsigned] = ACTIONS(3873),
    [anon_sym_long] = ACTIONS(3873),
    [anon_sym_short] = ACTIONS(3873),
    [anon_sym_LBRACK] = ACTIONS(3873),
    [anon_sym_static] = ACTIONS(3873),
    [anon_sym_register] = ACTIONS(3873),
    [anon_sym_inline] = ACTIONS(3873),
    [anon_sym___inline] = ACTIONS(3873),
    [anon_sym___inline__] = ACTIONS(3873),
    [anon_sym___forceinline] = ACTIONS(3873),
    [anon_sym_thread_local] = ACTIONS(3873),
    [anon_sym___thread] = ACTIONS(3873),
    [anon_sym_const] = ACTIONS(3873),
    [anon_sym_constexpr] = ACTIONS(3873),
    [anon_sym_volatile] = ACTIONS(3873),
    [anon_sym_restrict] = ACTIONS(3873),
    [anon_sym___restrict__] = ACTIONS(3873),
    [anon_sym__Atomic] = ACTIONS(3873),
    [anon_sym__Noreturn] = ACTIONS(3873),
    [anon_sym_noreturn] = ACTIONS(3873),
    [anon_sym__Nonnull] = ACTIONS(3873),
    [anon_sym_mutable] = ACTIONS(3873),
    [anon_sym_constinit] = ACTIONS(3873),
    [anon_sym_consteval] = ACTIONS(3873),
    [anon_sym_alignas] = ACTIONS(3873),
    [anon_sym__Alignas] = ACTIONS(3873),
    [sym_primitive_type] = ACTIONS(3873),
    [anon_sym_enum] = ACTIONS(3873),
    [anon_sym_class] = ACTIONS(3873),
    [anon_sym_struct] = ACTIONS(3873),
    [anon_sym_union] = ACTIONS(3873),
    [anon_sym_if] = ACTIONS(3873),
    [anon_sym_switch] = ACTIONS(3873),
    [anon_sym_case] = ACTIONS(3873),
    [anon_sym_default] = ACTIONS(3873),
    [anon_sym_while] = ACTIONS(3873),
    [anon_sym_do] = ACTIONS(3873),
    [anon_sym_for] = ACTIONS(3873),
    [anon_sym_return] = ACTIONS(3873),
    [anon_sym_break] = ACTIONS(3873),
    [anon_sym_continue] = ACTIONS(3873),
    [anon_sym_goto] = ACTIONS(3873),
    [anon_sym___try] = ACTIONS(3873),
    [anon_sym___leave] = ACTIONS(3873),
    [anon_sym_not] = ACTIONS(3873),
    [anon_sym_compl] = ACTIONS(3873),
    [anon_sym_DASH_DASH] = ACTIONS(3875),
    [anon_sym_PLUS_PLUS] = ACTIONS(3875),
    [anon_sym_sizeof] = ACTIONS(3873),
    [anon_sym___alignof__] = ACTIONS(3873),
    [anon_sym___alignof] = ACTIONS(3873),
    [anon_sym__alignof] = ACTIONS(3873),
    [anon_sym_alignof] = ACTIONS(3873),
    [anon_sym__Alignof] = ACTIONS(3873),
    [anon_sym_offsetof] = ACTIONS(3873),
    [anon_sym__Generic] = ACTIONS(3873),
    [anon_sym_asm] = ACTIONS(3873),
    [anon_sym___asm__] = ACTIONS(3873),
    [anon_sym___asm] = ACTIONS(3873),
    [sym_number_literal] = ACTIONS(3875),
    [anon_sym_L_SQUOTE] = ACTIONS(3875),
    [anon_sym_u_SQUOTE] = ACTIONS(3875),
    [anon_sym_U_SQUOTE] = ACTIONS(3875),
    [anon_sym_u8_SQUOTE] = ACTIONS(3875),
    [anon_sym_SQUOTE] = ACTIONS(3875),
    [anon_sym_L_DQUOTE] = ACTIONS(3875),
    [anon_sym_u_DQUOTE] = ACTIONS(3875),
    [anon_sym_U_DQUOTE] = ACTIONS(3875),
    [anon_sym_u8_DQUOTE] = ACTIONS(3875),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_true] = ACTIONS(3873),
    [sym_false] = ACTIONS(3873),
    [anon_sym_NULL] = ACTIONS(3873),
    [anon_sym_nullptr] = ACTIONS(3873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3873),
    [anon_sym_let] = ACTIONS(3873),
    [anon_sym_This] = ACTIONS(3873),
    [anon_sym_decltype] = ACTIONS(3873),
    [anon_sym_explicit] = ACTIONS(3873),
    [anon_sym_typename] = ACTIONS(3873),
    [anon_sym_template] = ACTIONS(3873),
    [anon_sym_operator] = ACTIONS(3873),
    [anon_sym_try] = ACTIONS(3873),
    [anon_sym_delete] = ACTIONS(3873),
    [anon_sym_throw] = ACTIONS(3873),
    [anon_sym_namespace] = ACTIONS(3873),
    [anon_sym_static_assert] = ACTIONS(3873),
    [anon_sym_concept] = ACTIONS(3873),
    [anon_sym_co_return] = ACTIONS(3873),
    [anon_sym_co_yield] = ACTIONS(3873),
    [anon_sym_R_DQUOTE] = ACTIONS(3875),
    [anon_sym_LR_DQUOTE] = ACTIONS(3875),
    [anon_sym_uR_DQUOTE] = ACTIONS(3875),
    [anon_sym_UR_DQUOTE] = ACTIONS(3875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3875),
    [anon_sym_co_await] = ACTIONS(3873),
    [anon_sym_new] = ACTIONS(3873),
    [anon_sym_requires] = ACTIONS(3873),
    [sym_this] = ACTIONS(3873),
    [anon_sym_discard] = ACTIONS(3873),
    [anon_sym_precise] = ACTIONS(3873),
    [anon_sym_shared] = ACTIONS(3873),
    [anon_sym_groupshared] = ACTIONS(3873),
    [anon_sym_uniform] = ACTIONS(3873),
    [anon_sym_row_major] = ACTIONS(3873),
    [anon_sym_column_major] = ACTIONS(3873),
    [anon_sym_globallycoherent] = ACTIONS(3873),
    [anon_sym_centroid] = ACTIONS(3873),
    [anon_sym_noperspective] = ACTIONS(3873),
    [anon_sym_nointerpolation] = ACTIONS(3873),
    [anon_sym_sample] = ACTIONS(3873),
    [anon_sym_linear] = ACTIONS(3873),
    [anon_sym_snorm] = ACTIONS(3873),
    [anon_sym_unorm] = ACTIONS(3873),
    [anon_sym_point] = ACTIONS(3873),
    [anon_sym_line] = ACTIONS(3873),
    [anon_sym_triangleadj] = ACTIONS(3873),
    [anon_sym_lineadj] = ACTIONS(3873),
    [anon_sym_triangle] = ACTIONS(3873),
    [anon_sym_cbuffer] = ACTIONS(3873),
    [anon_sym_interface] = ACTIONS(3873),
    [anon_sym_extension] = ACTIONS(3873),
  },
  [597] = {
    [sym_identifier] = ACTIONS(3877),
    [aux_sym_preproc_include_token1] = ACTIONS(3877),
    [aux_sym_preproc_def_token1] = ACTIONS(3877),
    [aux_sym_preproc_if_token1] = ACTIONS(3877),
    [aux_sym_preproc_if_token2] = ACTIONS(3877),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3877),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3877),
    [aux_sym_preproc_else_token1] = ACTIONS(3877),
    [aux_sym_preproc_elif_token1] = ACTIONS(3877),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3877),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3877),
    [sym_preproc_directive] = ACTIONS(3877),
    [anon_sym_LPAREN2] = ACTIONS(3879),
    [anon_sym_BANG] = ACTIONS(3879),
    [anon_sym_TILDE] = ACTIONS(3879),
    [anon_sym_DASH] = ACTIONS(3877),
    [anon_sym_PLUS] = ACTIONS(3877),
    [anon_sym_STAR] = ACTIONS(3879),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3877),
    [anon_sym_SEMI] = ACTIONS(3879),
    [anon_sym___extension__] = ACTIONS(3877),
    [anon_sym_typedef] = ACTIONS(3877),
    [anon_sym_in] = ACTIONS(3877),
    [anon_sym_out] = ACTIONS(3877),
    [anon_sym_inout] = ACTIONS(3877),
    [anon_sym_virtual] = ACTIONS(3877),
    [anon_sym_extern] = ACTIONS(3877),
    [anon_sym___attribute__] = ACTIONS(3877),
    [anon_sym___attribute] = ACTIONS(3877),
    [anon_sym_using] = ACTIONS(3877),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3879),
    [anon_sym___declspec] = ACTIONS(3877),
    [anon_sym___based] = ACTIONS(3877),
    [anon_sym___cdecl] = ACTIONS(3877),
    [anon_sym___clrcall] = ACTIONS(3877),
    [anon_sym___stdcall] = ACTIONS(3877),
    [anon_sym___fastcall] = ACTIONS(3877),
    [anon_sym___thiscall] = ACTIONS(3877),
    [anon_sym___vectorcall] = ACTIONS(3877),
    [anon_sym_LBRACE] = ACTIONS(3879),
    [anon_sym_signed] = ACTIONS(3877),
    [anon_sym_unsigned] = ACTIONS(3877),
    [anon_sym_long] = ACTIONS(3877),
    [anon_sym_short] = ACTIONS(3877),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_static] = ACTIONS(3877),
    [anon_sym_register] = ACTIONS(3877),
    [anon_sym_inline] = ACTIONS(3877),
    [anon_sym___inline] = ACTIONS(3877),
    [anon_sym___inline__] = ACTIONS(3877),
    [anon_sym___forceinline] = ACTIONS(3877),
    [anon_sym_thread_local] = ACTIONS(3877),
    [anon_sym___thread] = ACTIONS(3877),
    [anon_sym_const] = ACTIONS(3877),
    [anon_sym_constexpr] = ACTIONS(3877),
    [anon_sym_volatile] = ACTIONS(3877),
    [anon_sym_restrict] = ACTIONS(3877),
    [anon_sym___restrict__] = ACTIONS(3877),
    [anon_sym__Atomic] = ACTIONS(3877),
    [anon_sym__Noreturn] = ACTIONS(3877),
    [anon_sym_noreturn] = ACTIONS(3877),
    [anon_sym__Nonnull] = ACTIONS(3877),
    [anon_sym_mutable] = ACTIONS(3877),
    [anon_sym_constinit] = ACTIONS(3877),
    [anon_sym_consteval] = ACTIONS(3877),
    [anon_sym_alignas] = ACTIONS(3877),
    [anon_sym__Alignas] = ACTIONS(3877),
    [sym_primitive_type] = ACTIONS(3877),
    [anon_sym_enum] = ACTIONS(3877),
    [anon_sym_class] = ACTIONS(3877),
    [anon_sym_struct] = ACTIONS(3877),
    [anon_sym_union] = ACTIONS(3877),
    [anon_sym_if] = ACTIONS(3877),
    [anon_sym_switch] = ACTIONS(3877),
    [anon_sym_case] = ACTIONS(3877),
    [anon_sym_default] = ACTIONS(3877),
    [anon_sym_while] = ACTIONS(3877),
    [anon_sym_do] = ACTIONS(3877),
    [anon_sym_for] = ACTIONS(3877),
    [anon_sym_return] = ACTIONS(3877),
    [anon_sym_break] = ACTIONS(3877),
    [anon_sym_continue] = ACTIONS(3877),
    [anon_sym_goto] = ACTIONS(3877),
    [anon_sym___try] = ACTIONS(3877),
    [anon_sym___leave] = ACTIONS(3877),
    [anon_sym_not] = ACTIONS(3877),
    [anon_sym_compl] = ACTIONS(3877),
    [anon_sym_DASH_DASH] = ACTIONS(3879),
    [anon_sym_PLUS_PLUS] = ACTIONS(3879),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(3877),
    [anon_sym___alignof] = ACTIONS(3877),
    [anon_sym__alignof] = ACTIONS(3877),
    [anon_sym_alignof] = ACTIONS(3877),
    [anon_sym__Alignof] = ACTIONS(3877),
    [anon_sym_offsetof] = ACTIONS(3877),
    [anon_sym__Generic] = ACTIONS(3877),
    [anon_sym_asm] = ACTIONS(3877),
    [anon_sym___asm__] = ACTIONS(3877),
    [anon_sym___asm] = ACTIONS(3877),
    [sym_number_literal] = ACTIONS(3879),
    [anon_sym_L_SQUOTE] = ACTIONS(3879),
    [anon_sym_u_SQUOTE] = ACTIONS(3879),
    [anon_sym_U_SQUOTE] = ACTIONS(3879),
    [anon_sym_u8_SQUOTE] = ACTIONS(3879),
    [anon_sym_SQUOTE] = ACTIONS(3879),
    [anon_sym_L_DQUOTE] = ACTIONS(3879),
    [anon_sym_u_DQUOTE] = ACTIONS(3879),
    [anon_sym_U_DQUOTE] = ACTIONS(3879),
    [anon_sym_u8_DQUOTE] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [sym_true] = ACTIONS(3877),
    [sym_false] = ACTIONS(3877),
    [anon_sym_NULL] = ACTIONS(3877),
    [anon_sym_nullptr] = ACTIONS(3877),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3877),
    [anon_sym_let] = ACTIONS(3877),
    [anon_sym_This] = ACTIONS(3877),
    [anon_sym_decltype] = ACTIONS(3877),
    [anon_sym_explicit] = ACTIONS(3877),
    [anon_sym_typename] = ACTIONS(3877),
    [anon_sym_template] = ACTIONS(3877),
    [anon_sym_operator] = ACTIONS(3877),
    [anon_sym_try] = ACTIONS(3877),
    [anon_sym_delete] = ACTIONS(3877),
    [anon_sym_throw] = ACTIONS(3877),
    [anon_sym_namespace] = ACTIONS(3877),
    [anon_sym_static_assert] = ACTIONS(3877),
    [anon_sym_concept] = ACTIONS(3877),
    [anon_sym_co_return] = ACTIONS(3877),
    [anon_sym_co_yield] = ACTIONS(3877),
    [anon_sym_R_DQUOTE] = ACTIONS(3879),
    [anon_sym_LR_DQUOTE] = ACTIONS(3879),
    [anon_sym_uR_DQUOTE] = ACTIONS(3879),
    [anon_sym_UR_DQUOTE] = ACTIONS(3879),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3879),
    [anon_sym_co_await] = ACTIONS(3877),
    [anon_sym_new] = ACTIONS(3877),
    [anon_sym_requires] = ACTIONS(3877),
    [sym_this] = ACTIONS(3877),
    [anon_sym_discard] = ACTIONS(3877),
    [anon_sym_precise] = ACTIONS(3877),
    [anon_sym_shared] = ACTIONS(3877),
    [anon_sym_groupshared] = ACTIONS(3877),
    [anon_sym_uniform] = ACTIONS(3877),
    [anon_sym_row_major] = ACTIONS(3877),
    [anon_sym_column_major] = ACTIONS(3877),
    [anon_sym_globallycoherent] = ACTIONS(3877),
    [anon_sym_centroid] = ACTIONS(3877),
    [anon_sym_noperspective] = ACTIONS(3877),
    [anon_sym_nointerpolation] = ACTIONS(3877),
    [anon_sym_sample] = ACTIONS(3877),
    [anon_sym_linear] = ACTIONS(3877),
    [anon_sym_snorm] = ACTIONS(3877),
    [anon_sym_unorm] = ACTIONS(3877),
    [anon_sym_point] = ACTIONS(3877),
    [anon_sym_line] = ACTIONS(3877),
    [anon_sym_triangleadj] = ACTIONS(3877),
    [anon_sym_lineadj] = ACTIONS(3877),
    [anon_sym_triangle] = ACTIONS(3877),
    [anon_sym_cbuffer] = ACTIONS(3877),
    [anon_sym_interface] = ACTIONS(3877),
    [anon_sym_extension] = ACTIONS(3877),
  },
  [598] = {
    [sym_identifier] = ACTIONS(3881),
    [aux_sym_preproc_include_token1] = ACTIONS(3881),
    [aux_sym_preproc_def_token1] = ACTIONS(3881),
    [aux_sym_preproc_if_token1] = ACTIONS(3881),
    [aux_sym_preproc_if_token2] = ACTIONS(3881),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3881),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3881),
    [aux_sym_preproc_else_token1] = ACTIONS(3881),
    [aux_sym_preproc_elif_token1] = ACTIONS(3881),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3881),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3881),
    [sym_preproc_directive] = ACTIONS(3881),
    [anon_sym_LPAREN2] = ACTIONS(3883),
    [anon_sym_BANG] = ACTIONS(3883),
    [anon_sym_TILDE] = ACTIONS(3883),
    [anon_sym_DASH] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(3881),
    [anon_sym_STAR] = ACTIONS(3883),
    [anon_sym_AMP_AMP] = ACTIONS(3883),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3883),
    [anon_sym___extension__] = ACTIONS(3881),
    [anon_sym_typedef] = ACTIONS(3881),
    [anon_sym_in] = ACTIONS(3881),
    [anon_sym_out] = ACTIONS(3881),
    [anon_sym_inout] = ACTIONS(3881),
    [anon_sym_virtual] = ACTIONS(3881),
    [anon_sym_extern] = ACTIONS(3881),
    [anon_sym___attribute__] = ACTIONS(3881),
    [anon_sym___attribute] = ACTIONS(3881),
    [anon_sym_using] = ACTIONS(3881),
    [anon_sym_COLON_COLON] = ACTIONS(3883),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3883),
    [anon_sym___declspec] = ACTIONS(3881),
    [anon_sym___based] = ACTIONS(3881),
    [anon_sym___cdecl] = ACTIONS(3881),
    [anon_sym___clrcall] = ACTIONS(3881),
    [anon_sym___stdcall] = ACTIONS(3881),
    [anon_sym___fastcall] = ACTIONS(3881),
    [anon_sym___thiscall] = ACTIONS(3881),
    [anon_sym___vectorcall] = ACTIONS(3881),
    [anon_sym_LBRACE] = ACTIONS(3883),
    [anon_sym_signed] = ACTIONS(3881),
    [anon_sym_unsigned] = ACTIONS(3881),
    [anon_sym_long] = ACTIONS(3881),
    [anon_sym_short] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_static] = ACTIONS(3881),
    [anon_sym_register] = ACTIONS(3881),
    [anon_sym_inline] = ACTIONS(3881),
    [anon_sym___inline] = ACTIONS(3881),
    [anon_sym___inline__] = ACTIONS(3881),
    [anon_sym___forceinline] = ACTIONS(3881),
    [anon_sym_thread_local] = ACTIONS(3881),
    [anon_sym___thread] = ACTIONS(3881),
    [anon_sym_const] = ACTIONS(3881),
    [anon_sym_constexpr] = ACTIONS(3881),
    [anon_sym_volatile] = ACTIONS(3881),
    [anon_sym_restrict] = ACTIONS(3881),
    [anon_sym___restrict__] = ACTIONS(3881),
    [anon_sym__Atomic] = ACTIONS(3881),
    [anon_sym__Noreturn] = ACTIONS(3881),
    [anon_sym_noreturn] = ACTIONS(3881),
    [anon_sym__Nonnull] = ACTIONS(3881),
    [anon_sym_mutable] = ACTIONS(3881),
    [anon_sym_constinit] = ACTIONS(3881),
    [anon_sym_consteval] = ACTIONS(3881),
    [anon_sym_alignas] = ACTIONS(3881),
    [anon_sym__Alignas] = ACTIONS(3881),
    [sym_primitive_type] = ACTIONS(3881),
    [anon_sym_enum] = ACTIONS(3881),
    [anon_sym_class] = ACTIONS(3881),
    [anon_sym_struct] = ACTIONS(3881),
    [anon_sym_union] = ACTIONS(3881),
    [anon_sym_if] = ACTIONS(3881),
    [anon_sym_switch] = ACTIONS(3881),
    [anon_sym_case] = ACTIONS(3881),
    [anon_sym_default] = ACTIONS(3881),
    [anon_sym_while] = ACTIONS(3881),
    [anon_sym_do] = ACTIONS(3881),
    [anon_sym_for] = ACTIONS(3881),
    [anon_sym_return] = ACTIONS(3881),
    [anon_sym_break] = ACTIONS(3881),
    [anon_sym_continue] = ACTIONS(3881),
    [anon_sym_goto] = ACTIONS(3881),
    [anon_sym___try] = ACTIONS(3881),
    [anon_sym___leave] = ACTIONS(3881),
    [anon_sym_not] = ACTIONS(3881),
    [anon_sym_compl] = ACTIONS(3881),
    [anon_sym_DASH_DASH] = ACTIONS(3883),
    [anon_sym_PLUS_PLUS] = ACTIONS(3883),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(3881),
    [anon_sym___alignof] = ACTIONS(3881),
    [anon_sym__alignof] = ACTIONS(3881),
    [anon_sym_alignof] = ACTIONS(3881),
    [anon_sym__Alignof] = ACTIONS(3881),
    [anon_sym_offsetof] = ACTIONS(3881),
    [anon_sym__Generic] = ACTIONS(3881),
    [anon_sym_asm] = ACTIONS(3881),
    [anon_sym___asm__] = ACTIONS(3881),
    [anon_sym___asm] = ACTIONS(3881),
    [sym_number_literal] = ACTIONS(3883),
    [anon_sym_L_SQUOTE] = ACTIONS(3883),
    [anon_sym_u_SQUOTE] = ACTIONS(3883),
    [anon_sym_U_SQUOTE] = ACTIONS(3883),
    [anon_sym_u8_SQUOTE] = ACTIONS(3883),
    [anon_sym_SQUOTE] = ACTIONS(3883),
    [anon_sym_L_DQUOTE] = ACTIONS(3883),
    [anon_sym_u_DQUOTE] = ACTIONS(3883),
    [anon_sym_U_DQUOTE] = ACTIONS(3883),
    [anon_sym_u8_DQUOTE] = ACTIONS(3883),
    [anon_sym_DQUOTE] = ACTIONS(3883),
    [sym_true] = ACTIONS(3881),
    [sym_false] = ACTIONS(3881),
    [anon_sym_NULL] = ACTIONS(3881),
    [anon_sym_nullptr] = ACTIONS(3881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3881),
    [anon_sym_let] = ACTIONS(3881),
    [anon_sym_This] = ACTIONS(3881),
    [anon_sym_decltype] = ACTIONS(3881),
    [anon_sym_explicit] = ACTIONS(3881),
    [anon_sym_typename] = ACTIONS(3881),
    [anon_sym_template] = ACTIONS(3881),
    [anon_sym_operator] = ACTIONS(3881),
    [anon_sym_try] = ACTIONS(3881),
    [anon_sym_delete] = ACTIONS(3881),
    [anon_sym_throw] = ACTIONS(3881),
    [anon_sym_namespace] = ACTIONS(3881),
    [anon_sym_static_assert] = ACTIONS(3881),
    [anon_sym_concept] = ACTIONS(3881),
    [anon_sym_co_return] = ACTIONS(3881),
    [anon_sym_co_yield] = ACTIONS(3881),
    [anon_sym_R_DQUOTE] = ACTIONS(3883),
    [anon_sym_LR_DQUOTE] = ACTIONS(3883),
    [anon_sym_uR_DQUOTE] = ACTIONS(3883),
    [anon_sym_UR_DQUOTE] = ACTIONS(3883),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3883),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3881),
    [anon_sym_requires] = ACTIONS(3881),
    [sym_this] = ACTIONS(3881),
    [anon_sym_discard] = ACTIONS(3881),
    [anon_sym_precise] = ACTIONS(3881),
    [anon_sym_shared] = ACTIONS(3881),
    [anon_sym_groupshared] = ACTIONS(3881),
    [anon_sym_uniform] = ACTIONS(3881),
    [anon_sym_row_major] = ACTIONS(3881),
    [anon_sym_column_major] = ACTIONS(3881),
    [anon_sym_globallycoherent] = ACTIONS(3881),
    [anon_sym_centroid] = ACTIONS(3881),
    [anon_sym_noperspective] = ACTIONS(3881),
    [anon_sym_nointerpolation] = ACTIONS(3881),
    [anon_sym_sample] = ACTIONS(3881),
    [anon_sym_linear] = ACTIONS(3881),
    [anon_sym_snorm] = ACTIONS(3881),
    [anon_sym_unorm] = ACTIONS(3881),
    [anon_sym_point] = ACTIONS(3881),
    [anon_sym_line] = ACTIONS(3881),
    [anon_sym_triangleadj] = ACTIONS(3881),
    [anon_sym_lineadj] = ACTIONS(3881),
    [anon_sym_triangle] = ACTIONS(3881),
    [anon_sym_cbuffer] = ACTIONS(3881),
    [anon_sym_interface] = ACTIONS(3881),
    [anon_sym_extension] = ACTIONS(3881),
  },
  [599] = {
    [sym_identifier] = ACTIONS(3885),
    [aux_sym_preproc_include_token1] = ACTIONS(3885),
    [aux_sym_preproc_def_token1] = ACTIONS(3885),
    [aux_sym_preproc_if_token1] = ACTIONS(3885),
    [aux_sym_preproc_if_token2] = ACTIONS(3885),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3885),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3885),
    [aux_sym_preproc_else_token1] = ACTIONS(3885),
    [aux_sym_preproc_elif_token1] = ACTIONS(3885),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3885),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3885),
    [sym_preproc_directive] = ACTIONS(3885),
    [anon_sym_LPAREN2] = ACTIONS(3887),
    [anon_sym_BANG] = ACTIONS(3887),
    [anon_sym_TILDE] = ACTIONS(3887),
    [anon_sym_DASH] = ACTIONS(3885),
    [anon_sym_PLUS] = ACTIONS(3885),
    [anon_sym_STAR] = ACTIONS(3887),
    [anon_sym_AMP_AMP] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3885),
    [anon_sym_SEMI] = ACTIONS(3887),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_typedef] = ACTIONS(3885),
    [anon_sym_in] = ACTIONS(3885),
    [anon_sym_out] = ACTIONS(3885),
    [anon_sym_inout] = ACTIONS(3885),
    [anon_sym_virtual] = ACTIONS(3885),
    [anon_sym_extern] = ACTIONS(3885),
    [anon_sym___attribute__] = ACTIONS(3885),
    [anon_sym___attribute] = ACTIONS(3885),
    [anon_sym_using] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3887),
    [anon_sym___declspec] = ACTIONS(3885),
    [anon_sym___based] = ACTIONS(3885),
    [anon_sym___cdecl] = ACTIONS(3885),
    [anon_sym___clrcall] = ACTIONS(3885),
    [anon_sym___stdcall] = ACTIONS(3885),
    [anon_sym___fastcall] = ACTIONS(3885),
    [anon_sym___thiscall] = ACTIONS(3885),
    [anon_sym___vectorcall] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_signed] = ACTIONS(3885),
    [anon_sym_unsigned] = ACTIONS(3885),
    [anon_sym_long] = ACTIONS(3885),
    [anon_sym_short] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_static] = ACTIONS(3885),
    [anon_sym_register] = ACTIONS(3885),
    [anon_sym_inline] = ACTIONS(3885),
    [anon_sym___inline] = ACTIONS(3885),
    [anon_sym___inline__] = ACTIONS(3885),
    [anon_sym___forceinline] = ACTIONS(3885),
    [anon_sym_thread_local] = ACTIONS(3885),
    [anon_sym___thread] = ACTIONS(3885),
    [anon_sym_const] = ACTIONS(3885),
    [anon_sym_constexpr] = ACTIONS(3885),
    [anon_sym_volatile] = ACTIONS(3885),
    [anon_sym_restrict] = ACTIONS(3885),
    [anon_sym___restrict__] = ACTIONS(3885),
    [anon_sym__Atomic] = ACTIONS(3885),
    [anon_sym__Noreturn] = ACTIONS(3885),
    [anon_sym_noreturn] = ACTIONS(3885),
    [anon_sym__Nonnull] = ACTIONS(3885),
    [anon_sym_mutable] = ACTIONS(3885),
    [anon_sym_constinit] = ACTIONS(3885),
    [anon_sym_consteval] = ACTIONS(3885),
    [anon_sym_alignas] = ACTIONS(3885),
    [anon_sym__Alignas] = ACTIONS(3885),
    [sym_primitive_type] = ACTIONS(3885),
    [anon_sym_enum] = ACTIONS(3885),
    [anon_sym_class] = ACTIONS(3885),
    [anon_sym_struct] = ACTIONS(3885),
    [anon_sym_union] = ACTIONS(3885),
    [anon_sym_if] = ACTIONS(3885),
    [anon_sym_switch] = ACTIONS(3885),
    [anon_sym_case] = ACTIONS(3885),
    [anon_sym_default] = ACTIONS(3885),
    [anon_sym_while] = ACTIONS(3885),
    [anon_sym_do] = ACTIONS(3885),
    [anon_sym_for] = ACTIONS(3885),
    [anon_sym_return] = ACTIONS(3885),
    [anon_sym_break] = ACTIONS(3885),
    [anon_sym_continue] = ACTIONS(3885),
    [anon_sym_goto] = ACTIONS(3885),
    [anon_sym___try] = ACTIONS(3885),
    [anon_sym___leave] = ACTIONS(3885),
    [anon_sym_not] = ACTIONS(3885),
    [anon_sym_compl] = ACTIONS(3885),
    [anon_sym_DASH_DASH] = ACTIONS(3887),
    [anon_sym_PLUS_PLUS] = ACTIONS(3887),
    [anon_sym_sizeof] = ACTIONS(3885),
    [anon_sym___alignof__] = ACTIONS(3885),
    [anon_sym___alignof] = ACTIONS(3885),
    [anon_sym__alignof] = ACTIONS(3885),
    [anon_sym_alignof] = ACTIONS(3885),
    [anon_sym__Alignof] = ACTIONS(3885),
    [anon_sym_offsetof] = ACTIONS(3885),
    [anon_sym__Generic] = ACTIONS(3885),
    [anon_sym_asm] = ACTIONS(3885),
    [anon_sym___asm__] = ACTIONS(3885),
    [anon_sym___asm] = ACTIONS(3885),
    [sym_number_literal] = ACTIONS(3887),
    [anon_sym_L_SQUOTE] = ACTIONS(3887),
    [anon_sym_u_SQUOTE] = ACTIONS(3887),
    [anon_sym_U_SQUOTE] = ACTIONS(3887),
    [anon_sym_u8_SQUOTE] = ACTIONS(3887),
    [anon_sym_SQUOTE] = ACTIONS(3887),
    [anon_sym_L_DQUOTE] = ACTIONS(3887),
    [anon_sym_u_DQUOTE] = ACTIONS(3887),
    [anon_sym_U_DQUOTE] = ACTIONS(3887),
    [anon_sym_u8_DQUOTE] = ACTIONS(3887),
    [anon_sym_DQUOTE] = ACTIONS(3887),
    [sym_true] = ACTIONS(3885),
    [sym_false] = ACTIONS(3885),
    [anon_sym_NULL] = ACTIONS(3885),
    [anon_sym_nullptr] = ACTIONS(3885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3885),
    [anon_sym_let] = ACTIONS(3885),
    [anon_sym_This] = ACTIONS(3885),
    [anon_sym_decltype] = ACTIONS(3885),
    [anon_sym_explicit] = ACTIONS(3885),
    [anon_sym_typename] = ACTIONS(3885),
    [anon_sym_template] = ACTIONS(3885),
    [anon_sym_operator] = ACTIONS(3885),
    [anon_sym_try] = ACTIONS(3885),
    [anon_sym_delete] = ACTIONS(3885),
    [anon_sym_throw] = ACTIONS(3885),
    [anon_sym_namespace] = ACTIONS(3885),
    [anon_sym_static_assert] = ACTIONS(3885),
    [anon_sym_concept] = ACTIONS(3885),
    [anon_sym_co_return] = ACTIONS(3885),
    [anon_sym_co_yield] = ACTIONS(3885),
    [anon_sym_R_DQUOTE] = ACTIONS(3887),
    [anon_sym_LR_DQUOTE] = ACTIONS(3887),
    [anon_sym_uR_DQUOTE] = ACTIONS(3887),
    [anon_sym_UR_DQUOTE] = ACTIONS(3887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3887),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3885),
    [anon_sym_requires] = ACTIONS(3885),
    [sym_this] = ACTIONS(3885),
    [anon_sym_discard] = ACTIONS(3885),
    [anon_sym_precise] = ACTIONS(3885),
    [anon_sym_shared] = ACTIONS(3885),
    [anon_sym_groupshared] = ACTIONS(3885),
    [anon_sym_uniform] = ACTIONS(3885),
    [anon_sym_row_major] = ACTIONS(3885),
    [anon_sym_column_major] = ACTIONS(3885),
    [anon_sym_globallycoherent] = ACTIONS(3885),
    [anon_sym_centroid] = ACTIONS(3885),
    [anon_sym_noperspective] = ACTIONS(3885),
    [anon_sym_nointerpolation] = ACTIONS(3885),
    [anon_sym_sample] = ACTIONS(3885),
    [anon_sym_linear] = ACTIONS(3885),
    [anon_sym_snorm] = ACTIONS(3885),
    [anon_sym_unorm] = ACTIONS(3885),
    [anon_sym_point] = ACTIONS(3885),
    [anon_sym_line] = ACTIONS(3885),
    [anon_sym_triangleadj] = ACTIONS(3885),
    [anon_sym_lineadj] = ACTIONS(3885),
    [anon_sym_triangle] = ACTIONS(3885),
    [anon_sym_cbuffer] = ACTIONS(3885),
    [anon_sym_interface] = ACTIONS(3885),
    [anon_sym_extension] = ACTIONS(3885),
  },
  [600] = {
    [sym_identifier] = ACTIONS(3889),
    [aux_sym_preproc_include_token1] = ACTIONS(3889),
    [aux_sym_preproc_def_token1] = ACTIONS(3889),
    [aux_sym_preproc_if_token1] = ACTIONS(3889),
    [aux_sym_preproc_if_token2] = ACTIONS(3889),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3889),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3889),
    [aux_sym_preproc_else_token1] = ACTIONS(3889),
    [aux_sym_preproc_elif_token1] = ACTIONS(3889),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3889),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3889),
    [sym_preproc_directive] = ACTIONS(3889),
    [anon_sym_LPAREN2] = ACTIONS(3891),
    [anon_sym_BANG] = ACTIONS(3891),
    [anon_sym_TILDE] = ACTIONS(3891),
    [anon_sym_DASH] = ACTIONS(3889),
    [anon_sym_PLUS] = ACTIONS(3889),
    [anon_sym_STAR] = ACTIONS(3891),
    [anon_sym_AMP_AMP] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3889),
    [anon_sym_SEMI] = ACTIONS(3891),
    [anon_sym___extension__] = ACTIONS(3889),
    [anon_sym_typedef] = ACTIONS(3889),
    [anon_sym_in] = ACTIONS(3889),
    [anon_sym_out] = ACTIONS(3889),
    [anon_sym_inout] = ACTIONS(3889),
    [anon_sym_virtual] = ACTIONS(3889),
    [anon_sym_extern] = ACTIONS(3889),
    [anon_sym___attribute__] = ACTIONS(3889),
    [anon_sym___attribute] = ACTIONS(3889),
    [anon_sym_using] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3891),
    [anon_sym___declspec] = ACTIONS(3889),
    [anon_sym___based] = ACTIONS(3889),
    [anon_sym___cdecl] = ACTIONS(3889),
    [anon_sym___clrcall] = ACTIONS(3889),
    [anon_sym___stdcall] = ACTIONS(3889),
    [anon_sym___fastcall] = ACTIONS(3889),
    [anon_sym___thiscall] = ACTIONS(3889),
    [anon_sym___vectorcall] = ACTIONS(3889),
    [anon_sym_LBRACE] = ACTIONS(3891),
    [anon_sym_signed] = ACTIONS(3889),
    [anon_sym_unsigned] = ACTIONS(3889),
    [anon_sym_long] = ACTIONS(3889),
    [anon_sym_short] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_static] = ACTIONS(3889),
    [anon_sym_register] = ACTIONS(3889),
    [anon_sym_inline] = ACTIONS(3889),
    [anon_sym___inline] = ACTIONS(3889),
    [anon_sym___inline__] = ACTIONS(3889),
    [anon_sym___forceinline] = ACTIONS(3889),
    [anon_sym_thread_local] = ACTIONS(3889),
    [anon_sym___thread] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3889),
    [anon_sym_constexpr] = ACTIONS(3889),
    [anon_sym_volatile] = ACTIONS(3889),
    [anon_sym_restrict] = ACTIONS(3889),
    [anon_sym___restrict__] = ACTIONS(3889),
    [anon_sym__Atomic] = ACTIONS(3889),
    [anon_sym__Noreturn] = ACTIONS(3889),
    [anon_sym_noreturn] = ACTIONS(3889),
    [anon_sym__Nonnull] = ACTIONS(3889),
    [anon_sym_mutable] = ACTIONS(3889),
    [anon_sym_constinit] = ACTIONS(3889),
    [anon_sym_consteval] = ACTIONS(3889),
    [anon_sym_alignas] = ACTIONS(3889),
    [anon_sym__Alignas] = ACTIONS(3889),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_enum] = ACTIONS(3889),
    [anon_sym_class] = ACTIONS(3889),
    [anon_sym_struct] = ACTIONS(3889),
    [anon_sym_union] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_switch] = ACTIONS(3889),
    [anon_sym_case] = ACTIONS(3889),
    [anon_sym_default] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_break] = ACTIONS(3889),
    [anon_sym_continue] = ACTIONS(3889),
    [anon_sym_goto] = ACTIONS(3889),
    [anon_sym___try] = ACTIONS(3889),
    [anon_sym___leave] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3889),
    [anon_sym_compl] = ACTIONS(3889),
    [anon_sym_DASH_DASH] = ACTIONS(3891),
    [anon_sym_PLUS_PLUS] = ACTIONS(3891),
    [anon_sym_sizeof] = ACTIONS(3889),
    [anon_sym___alignof__] = ACTIONS(3889),
    [anon_sym___alignof] = ACTIONS(3889),
    [anon_sym__alignof] = ACTIONS(3889),
    [anon_sym_alignof] = ACTIONS(3889),
    [anon_sym__Alignof] = ACTIONS(3889),
    [anon_sym_offsetof] = ACTIONS(3889),
    [anon_sym__Generic] = ACTIONS(3889),
    [anon_sym_asm] = ACTIONS(3889),
    [anon_sym___asm__] = ACTIONS(3889),
    [anon_sym___asm] = ACTIONS(3889),
    [sym_number_literal] = ACTIONS(3891),
    [anon_sym_L_SQUOTE] = ACTIONS(3891),
    [anon_sym_u_SQUOTE] = ACTIONS(3891),
    [anon_sym_U_SQUOTE] = ACTIONS(3891),
    [anon_sym_u8_SQUOTE] = ACTIONS(3891),
    [anon_sym_SQUOTE] = ACTIONS(3891),
    [anon_sym_L_DQUOTE] = ACTIONS(3891),
    [anon_sym_u_DQUOTE] = ACTIONS(3891),
    [anon_sym_U_DQUOTE] = ACTIONS(3891),
    [anon_sym_u8_DQUOTE] = ACTIONS(3891),
    [anon_sym_DQUOTE] = ACTIONS(3891),
    [sym_true] = ACTIONS(3889),
    [sym_false] = ACTIONS(3889),
    [anon_sym_NULL] = ACTIONS(3889),
    [anon_sym_nullptr] = ACTIONS(3889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_This] = ACTIONS(3889),
    [anon_sym_decltype] = ACTIONS(3889),
    [anon_sym_explicit] = ACTIONS(3889),
    [anon_sym_typename] = ACTIONS(3889),
    [anon_sym_template] = ACTIONS(3889),
    [anon_sym_operator] = ACTIONS(3889),
    [anon_sym_try] = ACTIONS(3889),
    [anon_sym_delete] = ACTIONS(3889),
    [anon_sym_throw] = ACTIONS(3889),
    [anon_sym_namespace] = ACTIONS(3889),
    [anon_sym_static_assert] = ACTIONS(3889),
    [anon_sym_concept] = ACTIONS(3889),
    [anon_sym_co_return] = ACTIONS(3889),
    [anon_sym_co_yield] = ACTIONS(3889),
    [anon_sym_R_DQUOTE] = ACTIONS(3891),
    [anon_sym_LR_DQUOTE] = ACTIONS(3891),
    [anon_sym_uR_DQUOTE] = ACTIONS(3891),
    [anon_sym_UR_DQUOTE] = ACTIONS(3891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3891),
    [anon_sym_co_await] = ACTIONS(3889),
    [anon_sym_new] = ACTIONS(3889),
    [anon_sym_requires] = ACTIONS(3889),
    [sym_this] = ACTIONS(3889),
    [anon_sym_discard] = ACTIONS(3889),
    [anon_sym_precise] = ACTIONS(3889),
    [anon_sym_shared] = ACTIONS(3889),
    [anon_sym_groupshared] = ACTIONS(3889),
    [anon_sym_uniform] = ACTIONS(3889),
    [anon_sym_row_major] = ACTIONS(3889),
    [anon_sym_column_major] = ACTIONS(3889),
    [anon_sym_globallycoherent] = ACTIONS(3889),
    [anon_sym_centroid] = ACTIONS(3889),
    [anon_sym_noperspective] = ACTIONS(3889),
    [anon_sym_nointerpolation] = ACTIONS(3889),
    [anon_sym_sample] = ACTIONS(3889),
    [anon_sym_linear] = ACTIONS(3889),
    [anon_sym_snorm] = ACTIONS(3889),
    [anon_sym_unorm] = ACTIONS(3889),
    [anon_sym_point] = ACTIONS(3889),
    [anon_sym_line] = ACTIONS(3889),
    [anon_sym_triangleadj] = ACTIONS(3889),
    [anon_sym_lineadj] = ACTIONS(3889),
    [anon_sym_triangle] = ACTIONS(3889),
    [anon_sym_cbuffer] = ACTIONS(3889),
    [anon_sym_interface] = ACTIONS(3889),
    [anon_sym_extension] = ACTIONS(3889),
  },
  [601] = {
    [sym_identifier] = ACTIONS(3893),
    [aux_sym_preproc_include_token1] = ACTIONS(3893),
    [aux_sym_preproc_def_token1] = ACTIONS(3893),
    [aux_sym_preproc_if_token1] = ACTIONS(3893),
    [aux_sym_preproc_if_token2] = ACTIONS(3893),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3893),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3893),
    [aux_sym_preproc_else_token1] = ACTIONS(3893),
    [aux_sym_preproc_elif_token1] = ACTIONS(3893),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3893),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3893),
    [sym_preproc_directive] = ACTIONS(3893),
    [anon_sym_LPAREN2] = ACTIONS(3895),
    [anon_sym_BANG] = ACTIONS(3895),
    [anon_sym_TILDE] = ACTIONS(3895),
    [anon_sym_DASH] = ACTIONS(3893),
    [anon_sym_PLUS] = ACTIONS(3893),
    [anon_sym_STAR] = ACTIONS(3895),
    [anon_sym_AMP_AMP] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3893),
    [anon_sym_SEMI] = ACTIONS(3895),
    [anon_sym___extension__] = ACTIONS(3893),
    [anon_sym_typedef] = ACTIONS(3893),
    [anon_sym_in] = ACTIONS(3893),
    [anon_sym_out] = ACTIONS(3893),
    [anon_sym_inout] = ACTIONS(3893),
    [anon_sym_virtual] = ACTIONS(3893),
    [anon_sym_extern] = ACTIONS(3893),
    [anon_sym___attribute__] = ACTIONS(3893),
    [anon_sym___attribute] = ACTIONS(3893),
    [anon_sym_using] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3895),
    [anon_sym___declspec] = ACTIONS(3893),
    [anon_sym___based] = ACTIONS(3893),
    [anon_sym___cdecl] = ACTIONS(3893),
    [anon_sym___clrcall] = ACTIONS(3893),
    [anon_sym___stdcall] = ACTIONS(3893),
    [anon_sym___fastcall] = ACTIONS(3893),
    [anon_sym___thiscall] = ACTIONS(3893),
    [anon_sym___vectorcall] = ACTIONS(3893),
    [anon_sym_LBRACE] = ACTIONS(3895),
    [anon_sym_signed] = ACTIONS(3893),
    [anon_sym_unsigned] = ACTIONS(3893),
    [anon_sym_long] = ACTIONS(3893),
    [anon_sym_short] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_static] = ACTIONS(3893),
    [anon_sym_register] = ACTIONS(3893),
    [anon_sym_inline] = ACTIONS(3893),
    [anon_sym___inline] = ACTIONS(3893),
    [anon_sym___inline__] = ACTIONS(3893),
    [anon_sym___forceinline] = ACTIONS(3893),
    [anon_sym_thread_local] = ACTIONS(3893),
    [anon_sym___thread] = ACTIONS(3893),
    [anon_sym_const] = ACTIONS(3893),
    [anon_sym_constexpr] = ACTIONS(3893),
    [anon_sym_volatile] = ACTIONS(3893),
    [anon_sym_restrict] = ACTIONS(3893),
    [anon_sym___restrict__] = ACTIONS(3893),
    [anon_sym__Atomic] = ACTIONS(3893),
    [anon_sym__Noreturn] = ACTIONS(3893),
    [anon_sym_noreturn] = ACTIONS(3893),
    [anon_sym__Nonnull] = ACTIONS(3893),
    [anon_sym_mutable] = ACTIONS(3893),
    [anon_sym_constinit] = ACTIONS(3893),
    [anon_sym_consteval] = ACTIONS(3893),
    [anon_sym_alignas] = ACTIONS(3893),
    [anon_sym__Alignas] = ACTIONS(3893),
    [sym_primitive_type] = ACTIONS(3893),
    [anon_sym_enum] = ACTIONS(3893),
    [anon_sym_class] = ACTIONS(3893),
    [anon_sym_struct] = ACTIONS(3893),
    [anon_sym_union] = ACTIONS(3893),
    [anon_sym_if] = ACTIONS(3893),
    [anon_sym_switch] = ACTIONS(3893),
    [anon_sym_case] = ACTIONS(3893),
    [anon_sym_default] = ACTIONS(3893),
    [anon_sym_while] = ACTIONS(3893),
    [anon_sym_do] = ACTIONS(3893),
    [anon_sym_for] = ACTIONS(3893),
    [anon_sym_return] = ACTIONS(3893),
    [anon_sym_break] = ACTIONS(3893),
    [anon_sym_continue] = ACTIONS(3893),
    [anon_sym_goto] = ACTIONS(3893),
    [anon_sym___try] = ACTIONS(3893),
    [anon_sym___leave] = ACTIONS(3893),
    [anon_sym_not] = ACTIONS(3893),
    [anon_sym_compl] = ACTIONS(3893),
    [anon_sym_DASH_DASH] = ACTIONS(3895),
    [anon_sym_PLUS_PLUS] = ACTIONS(3895),
    [anon_sym_sizeof] = ACTIONS(3893),
    [anon_sym___alignof__] = ACTIONS(3893),
    [anon_sym___alignof] = ACTIONS(3893),
    [anon_sym__alignof] = ACTIONS(3893),
    [anon_sym_alignof] = ACTIONS(3893),
    [anon_sym__Alignof] = ACTIONS(3893),
    [anon_sym_offsetof] = ACTIONS(3893),
    [anon_sym__Generic] = ACTIONS(3893),
    [anon_sym_asm] = ACTIONS(3893),
    [anon_sym___asm__] = ACTIONS(3893),
    [anon_sym___asm] = ACTIONS(3893),
    [sym_number_literal] = ACTIONS(3895),
    [anon_sym_L_SQUOTE] = ACTIONS(3895),
    [anon_sym_u_SQUOTE] = ACTIONS(3895),
    [anon_sym_U_SQUOTE] = ACTIONS(3895),
    [anon_sym_u8_SQUOTE] = ACTIONS(3895),
    [anon_sym_SQUOTE] = ACTIONS(3895),
    [anon_sym_L_DQUOTE] = ACTIONS(3895),
    [anon_sym_u_DQUOTE] = ACTIONS(3895),
    [anon_sym_U_DQUOTE] = ACTIONS(3895),
    [anon_sym_u8_DQUOTE] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(3895),
    [sym_true] = ACTIONS(3893),
    [sym_false] = ACTIONS(3893),
    [anon_sym_NULL] = ACTIONS(3893),
    [anon_sym_nullptr] = ACTIONS(3893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_This] = ACTIONS(3893),
    [anon_sym_decltype] = ACTIONS(3893),
    [anon_sym_explicit] = ACTIONS(3893),
    [anon_sym_typename] = ACTIONS(3893),
    [anon_sym_template] = ACTIONS(3893),
    [anon_sym_operator] = ACTIONS(3893),
    [anon_sym_try] = ACTIONS(3893),
    [anon_sym_delete] = ACTIONS(3893),
    [anon_sym_throw] = ACTIONS(3893),
    [anon_sym_namespace] = ACTIONS(3893),
    [anon_sym_static_assert] = ACTIONS(3893),
    [anon_sym_concept] = ACTIONS(3893),
    [anon_sym_co_return] = ACTIONS(3893),
    [anon_sym_co_yield] = ACTIONS(3893),
    [anon_sym_R_DQUOTE] = ACTIONS(3895),
    [anon_sym_LR_DQUOTE] = ACTIONS(3895),
    [anon_sym_uR_DQUOTE] = ACTIONS(3895),
    [anon_sym_UR_DQUOTE] = ACTIONS(3895),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3895),
    [anon_sym_co_await] = ACTIONS(3893),
    [anon_sym_new] = ACTIONS(3893),
    [anon_sym_requires] = ACTIONS(3893),
    [sym_this] = ACTIONS(3893),
    [anon_sym_discard] = ACTIONS(3893),
    [anon_sym_precise] = ACTIONS(3893),
    [anon_sym_shared] = ACTIONS(3893),
    [anon_sym_groupshared] = ACTIONS(3893),
    [anon_sym_uniform] = ACTIONS(3893),
    [anon_sym_row_major] = ACTIONS(3893),
    [anon_sym_column_major] = ACTIONS(3893),
    [anon_sym_globallycoherent] = ACTIONS(3893),
    [anon_sym_centroid] = ACTIONS(3893),
    [anon_sym_noperspective] = ACTIONS(3893),
    [anon_sym_nointerpolation] = ACTIONS(3893),
    [anon_sym_sample] = ACTIONS(3893),
    [anon_sym_linear] = ACTIONS(3893),
    [anon_sym_snorm] = ACTIONS(3893),
    [anon_sym_unorm] = ACTIONS(3893),
    [anon_sym_point] = ACTIONS(3893),
    [anon_sym_line] = ACTIONS(3893),
    [anon_sym_triangleadj] = ACTIONS(3893),
    [anon_sym_lineadj] = ACTIONS(3893),
    [anon_sym_triangle] = ACTIONS(3893),
    [anon_sym_cbuffer] = ACTIONS(3893),
    [anon_sym_interface] = ACTIONS(3893),
    [anon_sym_extension] = ACTIONS(3893),
  },
  [602] = {
    [sym_identifier] = ACTIONS(3897),
    [aux_sym_preproc_include_token1] = ACTIONS(3897),
    [aux_sym_preproc_def_token1] = ACTIONS(3897),
    [aux_sym_preproc_if_token1] = ACTIONS(3897),
    [aux_sym_preproc_if_token2] = ACTIONS(3897),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3897),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3897),
    [aux_sym_preproc_else_token1] = ACTIONS(3897),
    [aux_sym_preproc_elif_token1] = ACTIONS(3897),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3897),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3897),
    [sym_preproc_directive] = ACTIONS(3897),
    [anon_sym_LPAREN2] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3899),
    [anon_sym_TILDE] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3897),
    [anon_sym_PLUS] = ACTIONS(3897),
    [anon_sym_STAR] = ACTIONS(3899),
    [anon_sym_AMP_AMP] = ACTIONS(3899),
    [anon_sym_AMP] = ACTIONS(3897),
    [anon_sym_SEMI] = ACTIONS(3899),
    [anon_sym___extension__] = ACTIONS(3897),
    [anon_sym_typedef] = ACTIONS(3897),
    [anon_sym_in] = ACTIONS(3897),
    [anon_sym_out] = ACTIONS(3897),
    [anon_sym_inout] = ACTIONS(3897),
    [anon_sym_virtual] = ACTIONS(3897),
    [anon_sym_extern] = ACTIONS(3897),
    [anon_sym___attribute__] = ACTIONS(3897),
    [anon_sym___attribute] = ACTIONS(3897),
    [anon_sym_using] = ACTIONS(3897),
    [anon_sym_COLON_COLON] = ACTIONS(3899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3899),
    [anon_sym___declspec] = ACTIONS(3897),
    [anon_sym___based] = ACTIONS(3897),
    [anon_sym___cdecl] = ACTIONS(3897),
    [anon_sym___clrcall] = ACTIONS(3897),
    [anon_sym___stdcall] = ACTIONS(3897),
    [anon_sym___fastcall] = ACTIONS(3897),
    [anon_sym___thiscall] = ACTIONS(3897),
    [anon_sym___vectorcall] = ACTIONS(3897),
    [anon_sym_LBRACE] = ACTIONS(3899),
    [anon_sym_signed] = ACTIONS(3897),
    [anon_sym_unsigned] = ACTIONS(3897),
    [anon_sym_long] = ACTIONS(3897),
    [anon_sym_short] = ACTIONS(3897),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_static] = ACTIONS(3897),
    [anon_sym_register] = ACTIONS(3897),
    [anon_sym_inline] = ACTIONS(3897),
    [anon_sym___inline] = ACTIONS(3897),
    [anon_sym___inline__] = ACTIONS(3897),
    [anon_sym___forceinline] = ACTIONS(3897),
    [anon_sym_thread_local] = ACTIONS(3897),
    [anon_sym___thread] = ACTIONS(3897),
    [anon_sym_const] = ACTIONS(3897),
    [anon_sym_constexpr] = ACTIONS(3897),
    [anon_sym_volatile] = ACTIONS(3897),
    [anon_sym_restrict] = ACTIONS(3897),
    [anon_sym___restrict__] = ACTIONS(3897),
    [anon_sym__Atomic] = ACTIONS(3897),
    [anon_sym__Noreturn] = ACTIONS(3897),
    [anon_sym_noreturn] = ACTIONS(3897),
    [anon_sym__Nonnull] = ACTIONS(3897),
    [anon_sym_mutable] = ACTIONS(3897),
    [anon_sym_constinit] = ACTIONS(3897),
    [anon_sym_consteval] = ACTIONS(3897),
    [anon_sym_alignas] = ACTIONS(3897),
    [anon_sym__Alignas] = ACTIONS(3897),
    [sym_primitive_type] = ACTIONS(3897),
    [anon_sym_enum] = ACTIONS(3897),
    [anon_sym_class] = ACTIONS(3897),
    [anon_sym_struct] = ACTIONS(3897),
    [anon_sym_union] = ACTIONS(3897),
    [anon_sym_if] = ACTIONS(3897),
    [anon_sym_switch] = ACTIONS(3897),
    [anon_sym_case] = ACTIONS(3897),
    [anon_sym_default] = ACTIONS(3897),
    [anon_sym_while] = ACTIONS(3897),
    [anon_sym_do] = ACTIONS(3897),
    [anon_sym_for] = ACTIONS(3897),
    [anon_sym_return] = ACTIONS(3897),
    [anon_sym_break] = ACTIONS(3897),
    [anon_sym_continue] = ACTIONS(3897),
    [anon_sym_goto] = ACTIONS(3897),
    [anon_sym___try] = ACTIONS(3897),
    [anon_sym___leave] = ACTIONS(3897),
    [anon_sym_not] = ACTIONS(3897),
    [anon_sym_compl] = ACTIONS(3897),
    [anon_sym_DASH_DASH] = ACTIONS(3899),
    [anon_sym_PLUS_PLUS] = ACTIONS(3899),
    [anon_sym_sizeof] = ACTIONS(3897),
    [anon_sym___alignof__] = ACTIONS(3897),
    [anon_sym___alignof] = ACTIONS(3897),
    [anon_sym__alignof] = ACTIONS(3897),
    [anon_sym_alignof] = ACTIONS(3897),
    [anon_sym__Alignof] = ACTIONS(3897),
    [anon_sym_offsetof] = ACTIONS(3897),
    [anon_sym__Generic] = ACTIONS(3897),
    [anon_sym_asm] = ACTIONS(3897),
    [anon_sym___asm__] = ACTIONS(3897),
    [anon_sym___asm] = ACTIONS(3897),
    [sym_number_literal] = ACTIONS(3899),
    [anon_sym_L_SQUOTE] = ACTIONS(3899),
    [anon_sym_u_SQUOTE] = ACTIONS(3899),
    [anon_sym_U_SQUOTE] = ACTIONS(3899),
    [anon_sym_u8_SQUOTE] = ACTIONS(3899),
    [anon_sym_SQUOTE] = ACTIONS(3899),
    [anon_sym_L_DQUOTE] = ACTIONS(3899),
    [anon_sym_u_DQUOTE] = ACTIONS(3899),
    [anon_sym_U_DQUOTE] = ACTIONS(3899),
    [anon_sym_u8_DQUOTE] = ACTIONS(3899),
    [anon_sym_DQUOTE] = ACTIONS(3899),
    [sym_true] = ACTIONS(3897),
    [sym_false] = ACTIONS(3897),
    [anon_sym_NULL] = ACTIONS(3897),
    [anon_sym_nullptr] = ACTIONS(3897),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3897),
    [anon_sym_let] = ACTIONS(3897),
    [anon_sym_This] = ACTIONS(3897),
    [anon_sym_decltype] = ACTIONS(3897),
    [anon_sym_explicit] = ACTIONS(3897),
    [anon_sym_typename] = ACTIONS(3897),
    [anon_sym_template] = ACTIONS(3897),
    [anon_sym_operator] = ACTIONS(3897),
    [anon_sym_try] = ACTIONS(3897),
    [anon_sym_delete] = ACTIONS(3897),
    [anon_sym_throw] = ACTIONS(3897),
    [anon_sym_namespace] = ACTIONS(3897),
    [anon_sym_static_assert] = ACTIONS(3897),
    [anon_sym_concept] = ACTIONS(3897),
    [anon_sym_co_return] = ACTIONS(3897),
    [anon_sym_co_yield] = ACTIONS(3897),
    [anon_sym_R_DQUOTE] = ACTIONS(3899),
    [anon_sym_LR_DQUOTE] = ACTIONS(3899),
    [anon_sym_uR_DQUOTE] = ACTIONS(3899),
    [anon_sym_UR_DQUOTE] = ACTIONS(3899),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3899),
    [anon_sym_co_await] = ACTIONS(3897),
    [anon_sym_new] = ACTIONS(3897),
    [anon_sym_requires] = ACTIONS(3897),
    [sym_this] = ACTIONS(3897),
    [anon_sym_discard] = ACTIONS(3897),
    [anon_sym_precise] = ACTIONS(3897),
    [anon_sym_shared] = ACTIONS(3897),
    [anon_sym_groupshared] = ACTIONS(3897),
    [anon_sym_uniform] = ACTIONS(3897),
    [anon_sym_row_major] = ACTIONS(3897),
    [anon_sym_column_major] = ACTIONS(3897),
    [anon_sym_globallycoherent] = ACTIONS(3897),
    [anon_sym_centroid] = ACTIONS(3897),
    [anon_sym_noperspective] = ACTIONS(3897),
    [anon_sym_nointerpolation] = ACTIONS(3897),
    [anon_sym_sample] = ACTIONS(3897),
    [anon_sym_linear] = ACTIONS(3897),
    [anon_sym_snorm] = ACTIONS(3897),
    [anon_sym_unorm] = ACTIONS(3897),
    [anon_sym_point] = ACTIONS(3897),
    [anon_sym_line] = ACTIONS(3897),
    [anon_sym_triangleadj] = ACTIONS(3897),
    [anon_sym_lineadj] = ACTIONS(3897),
    [anon_sym_triangle] = ACTIONS(3897),
    [anon_sym_cbuffer] = ACTIONS(3897),
    [anon_sym_interface] = ACTIONS(3897),
    [anon_sym_extension] = ACTIONS(3897),
  },
  [603] = {
    [sym_identifier] = ACTIONS(3901),
    [aux_sym_preproc_include_token1] = ACTIONS(3901),
    [aux_sym_preproc_def_token1] = ACTIONS(3901),
    [aux_sym_preproc_if_token1] = ACTIONS(3901),
    [aux_sym_preproc_if_token2] = ACTIONS(3901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3901),
    [aux_sym_preproc_else_token1] = ACTIONS(3901),
    [aux_sym_preproc_elif_token1] = ACTIONS(3901),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3901),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3901),
    [sym_preproc_directive] = ACTIONS(3901),
    [anon_sym_LPAREN2] = ACTIONS(3903),
    [anon_sym_BANG] = ACTIONS(3903),
    [anon_sym_TILDE] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3901),
    [anon_sym_STAR] = ACTIONS(3903),
    [anon_sym_AMP_AMP] = ACTIONS(3903),
    [anon_sym_AMP] = ACTIONS(3901),
    [anon_sym_SEMI] = ACTIONS(3903),
    [anon_sym___extension__] = ACTIONS(3901),
    [anon_sym_typedef] = ACTIONS(3901),
    [anon_sym_in] = ACTIONS(3901),
    [anon_sym_out] = ACTIONS(3901),
    [anon_sym_inout] = ACTIONS(3901),
    [anon_sym_virtual] = ACTIONS(3901),
    [anon_sym_extern] = ACTIONS(3901),
    [anon_sym___attribute__] = ACTIONS(3901),
    [anon_sym___attribute] = ACTIONS(3901),
    [anon_sym_using] = ACTIONS(3901),
    [anon_sym_COLON_COLON] = ACTIONS(3903),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3903),
    [anon_sym___declspec] = ACTIONS(3901),
    [anon_sym___based] = ACTIONS(3901),
    [anon_sym___cdecl] = ACTIONS(3901),
    [anon_sym___clrcall] = ACTIONS(3901),
    [anon_sym___stdcall] = ACTIONS(3901),
    [anon_sym___fastcall] = ACTIONS(3901),
    [anon_sym___thiscall] = ACTIONS(3901),
    [anon_sym___vectorcall] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_signed] = ACTIONS(3901),
    [anon_sym_unsigned] = ACTIONS(3901),
    [anon_sym_long] = ACTIONS(3901),
    [anon_sym_short] = ACTIONS(3901),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_static] = ACTIONS(3901),
    [anon_sym_register] = ACTIONS(3901),
    [anon_sym_inline] = ACTIONS(3901),
    [anon_sym___inline] = ACTIONS(3901),
    [anon_sym___inline__] = ACTIONS(3901),
    [anon_sym___forceinline] = ACTIONS(3901),
    [anon_sym_thread_local] = ACTIONS(3901),
    [anon_sym___thread] = ACTIONS(3901),
    [anon_sym_const] = ACTIONS(3901),
    [anon_sym_constexpr] = ACTIONS(3901),
    [anon_sym_volatile] = ACTIONS(3901),
    [anon_sym_restrict] = ACTIONS(3901),
    [anon_sym___restrict__] = ACTIONS(3901),
    [anon_sym__Atomic] = ACTIONS(3901),
    [anon_sym__Noreturn] = ACTIONS(3901),
    [anon_sym_noreturn] = ACTIONS(3901),
    [anon_sym__Nonnull] = ACTIONS(3901),
    [anon_sym_mutable] = ACTIONS(3901),
    [anon_sym_constinit] = ACTIONS(3901),
    [anon_sym_consteval] = ACTIONS(3901),
    [anon_sym_alignas] = ACTIONS(3901),
    [anon_sym__Alignas] = ACTIONS(3901),
    [sym_primitive_type] = ACTIONS(3901),
    [anon_sym_enum] = ACTIONS(3901),
    [anon_sym_class] = ACTIONS(3901),
    [anon_sym_struct] = ACTIONS(3901),
    [anon_sym_union] = ACTIONS(3901),
    [anon_sym_if] = ACTIONS(3901),
    [anon_sym_switch] = ACTIONS(3901),
    [anon_sym_case] = ACTIONS(3901),
    [anon_sym_default] = ACTIONS(3901),
    [anon_sym_while] = ACTIONS(3901),
    [anon_sym_do] = ACTIONS(3901),
    [anon_sym_for] = ACTIONS(3901),
    [anon_sym_return] = ACTIONS(3901),
    [anon_sym_break] = ACTIONS(3901),
    [anon_sym_continue] = ACTIONS(3901),
    [anon_sym_goto] = ACTIONS(3901),
    [anon_sym___try] = ACTIONS(3901),
    [anon_sym___leave] = ACTIONS(3901),
    [anon_sym_not] = ACTIONS(3901),
    [anon_sym_compl] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3903),
    [anon_sym_PLUS_PLUS] = ACTIONS(3903),
    [anon_sym_sizeof] = ACTIONS(3901),
    [anon_sym___alignof__] = ACTIONS(3901),
    [anon_sym___alignof] = ACTIONS(3901),
    [anon_sym__alignof] = ACTIONS(3901),
    [anon_sym_alignof] = ACTIONS(3901),
    [anon_sym__Alignof] = ACTIONS(3901),
    [anon_sym_offsetof] = ACTIONS(3901),
    [anon_sym__Generic] = ACTIONS(3901),
    [anon_sym_asm] = ACTIONS(3901),
    [anon_sym___asm__] = ACTIONS(3901),
    [anon_sym___asm] = ACTIONS(3901),
    [sym_number_literal] = ACTIONS(3903),
    [anon_sym_L_SQUOTE] = ACTIONS(3903),
    [anon_sym_u_SQUOTE] = ACTIONS(3903),
    [anon_sym_U_SQUOTE] = ACTIONS(3903),
    [anon_sym_u8_SQUOTE] = ACTIONS(3903),
    [anon_sym_SQUOTE] = ACTIONS(3903),
    [anon_sym_L_DQUOTE] = ACTIONS(3903),
    [anon_sym_u_DQUOTE] = ACTIONS(3903),
    [anon_sym_U_DQUOTE] = ACTIONS(3903),
    [anon_sym_u8_DQUOTE] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(3903),
    [sym_true] = ACTIONS(3901),
    [sym_false] = ACTIONS(3901),
    [anon_sym_NULL] = ACTIONS(3901),
    [anon_sym_nullptr] = ACTIONS(3901),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3901),
    [anon_sym_let] = ACTIONS(3901),
    [anon_sym_This] = ACTIONS(3901),
    [anon_sym_decltype] = ACTIONS(3901),
    [anon_sym_explicit] = ACTIONS(3901),
    [anon_sym_typename] = ACTIONS(3901),
    [anon_sym_template] = ACTIONS(3901),
    [anon_sym_operator] = ACTIONS(3901),
    [anon_sym_try] = ACTIONS(3901),
    [anon_sym_delete] = ACTIONS(3901),
    [anon_sym_throw] = ACTIONS(3901),
    [anon_sym_namespace] = ACTIONS(3901),
    [anon_sym_static_assert] = ACTIONS(3901),
    [anon_sym_concept] = ACTIONS(3901),
    [anon_sym_co_return] = ACTIONS(3901),
    [anon_sym_co_yield] = ACTIONS(3901),
    [anon_sym_R_DQUOTE] = ACTIONS(3903),
    [anon_sym_LR_DQUOTE] = ACTIONS(3903),
    [anon_sym_uR_DQUOTE] = ACTIONS(3903),
    [anon_sym_UR_DQUOTE] = ACTIONS(3903),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3903),
    [anon_sym_co_await] = ACTIONS(3901),
    [anon_sym_new] = ACTIONS(3901),
    [anon_sym_requires] = ACTIONS(3901),
    [sym_this] = ACTIONS(3901),
    [anon_sym_discard] = ACTIONS(3901),
    [anon_sym_precise] = ACTIONS(3901),
    [anon_sym_shared] = ACTIONS(3901),
    [anon_sym_groupshared] = ACTIONS(3901),
    [anon_sym_uniform] = ACTIONS(3901),
    [anon_sym_row_major] = ACTIONS(3901),
    [anon_sym_column_major] = ACTIONS(3901),
    [anon_sym_globallycoherent] = ACTIONS(3901),
    [anon_sym_centroid] = ACTIONS(3901),
    [anon_sym_noperspective] = ACTIONS(3901),
    [anon_sym_nointerpolation] = ACTIONS(3901),
    [anon_sym_sample] = ACTIONS(3901),
    [anon_sym_linear] = ACTIONS(3901),
    [anon_sym_snorm] = ACTIONS(3901),
    [anon_sym_unorm] = ACTIONS(3901),
    [anon_sym_point] = ACTIONS(3901),
    [anon_sym_line] = ACTIONS(3901),
    [anon_sym_triangleadj] = ACTIONS(3901),
    [anon_sym_lineadj] = ACTIONS(3901),
    [anon_sym_triangle] = ACTIONS(3901),
    [anon_sym_cbuffer] = ACTIONS(3901),
    [anon_sym_interface] = ACTIONS(3901),
    [anon_sym_extension] = ACTIONS(3901),
  },
  [604] = {
    [sym_identifier] = ACTIONS(3905),
    [aux_sym_preproc_include_token1] = ACTIONS(3905),
    [aux_sym_preproc_def_token1] = ACTIONS(3905),
    [aux_sym_preproc_if_token1] = ACTIONS(3905),
    [aux_sym_preproc_if_token2] = ACTIONS(3905),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3905),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3905),
    [aux_sym_preproc_else_token1] = ACTIONS(3905),
    [aux_sym_preproc_elif_token1] = ACTIONS(3905),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3905),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3905),
    [sym_preproc_directive] = ACTIONS(3905),
    [anon_sym_LPAREN2] = ACTIONS(3907),
    [anon_sym_BANG] = ACTIONS(3907),
    [anon_sym_TILDE] = ACTIONS(3907),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3907),
    [anon_sym_AMP_AMP] = ACTIONS(3907),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_SEMI] = ACTIONS(3907),
    [anon_sym___extension__] = ACTIONS(3905),
    [anon_sym_typedef] = ACTIONS(3905),
    [anon_sym_in] = ACTIONS(3905),
    [anon_sym_out] = ACTIONS(3905),
    [anon_sym_inout] = ACTIONS(3905),
    [anon_sym_virtual] = ACTIONS(3905),
    [anon_sym_extern] = ACTIONS(3905),
    [anon_sym___attribute__] = ACTIONS(3905),
    [anon_sym___attribute] = ACTIONS(3905),
    [anon_sym_using] = ACTIONS(3905),
    [anon_sym_COLON_COLON] = ACTIONS(3907),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3907),
    [anon_sym___declspec] = ACTIONS(3905),
    [anon_sym___based] = ACTIONS(3905),
    [anon_sym___cdecl] = ACTIONS(3905),
    [anon_sym___clrcall] = ACTIONS(3905),
    [anon_sym___stdcall] = ACTIONS(3905),
    [anon_sym___fastcall] = ACTIONS(3905),
    [anon_sym___thiscall] = ACTIONS(3905),
    [anon_sym___vectorcall] = ACTIONS(3905),
    [anon_sym_LBRACE] = ACTIONS(3907),
    [anon_sym_signed] = ACTIONS(3905),
    [anon_sym_unsigned] = ACTIONS(3905),
    [anon_sym_long] = ACTIONS(3905),
    [anon_sym_short] = ACTIONS(3905),
    [anon_sym_LBRACK] = ACTIONS(3905),
    [anon_sym_static] = ACTIONS(3905),
    [anon_sym_register] = ACTIONS(3905),
    [anon_sym_inline] = ACTIONS(3905),
    [anon_sym___inline] = ACTIONS(3905),
    [anon_sym___inline__] = ACTIONS(3905),
    [anon_sym___forceinline] = ACTIONS(3905),
    [anon_sym_thread_local] = ACTIONS(3905),
    [anon_sym___thread] = ACTIONS(3905),
    [anon_sym_const] = ACTIONS(3905),
    [anon_sym_constexpr] = ACTIONS(3905),
    [anon_sym_volatile] = ACTIONS(3905),
    [anon_sym_restrict] = ACTIONS(3905),
    [anon_sym___restrict__] = ACTIONS(3905),
    [anon_sym__Atomic] = ACTIONS(3905),
    [anon_sym__Noreturn] = ACTIONS(3905),
    [anon_sym_noreturn] = ACTIONS(3905),
    [anon_sym__Nonnull] = ACTIONS(3905),
    [anon_sym_mutable] = ACTIONS(3905),
    [anon_sym_constinit] = ACTIONS(3905),
    [anon_sym_consteval] = ACTIONS(3905),
    [anon_sym_alignas] = ACTIONS(3905),
    [anon_sym__Alignas] = ACTIONS(3905),
    [sym_primitive_type] = ACTIONS(3905),
    [anon_sym_enum] = ACTIONS(3905),
    [anon_sym_class] = ACTIONS(3905),
    [anon_sym_struct] = ACTIONS(3905),
    [anon_sym_union] = ACTIONS(3905),
    [anon_sym_if] = ACTIONS(3905),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_case] = ACTIONS(3905),
    [anon_sym_default] = ACTIONS(3905),
    [anon_sym_while] = ACTIONS(3905),
    [anon_sym_do] = ACTIONS(3905),
    [anon_sym_for] = ACTIONS(3905),
    [anon_sym_return] = ACTIONS(3905),
    [anon_sym_break] = ACTIONS(3905),
    [anon_sym_continue] = ACTIONS(3905),
    [anon_sym_goto] = ACTIONS(3905),
    [anon_sym___try] = ACTIONS(3905),
    [anon_sym___leave] = ACTIONS(3905),
    [anon_sym_not] = ACTIONS(3905),
    [anon_sym_compl] = ACTIONS(3905),
    [anon_sym_DASH_DASH] = ACTIONS(3907),
    [anon_sym_PLUS_PLUS] = ACTIONS(3907),
    [anon_sym_sizeof] = ACTIONS(3905),
    [anon_sym___alignof__] = ACTIONS(3905),
    [anon_sym___alignof] = ACTIONS(3905),
    [anon_sym__alignof] = ACTIONS(3905),
    [anon_sym_alignof] = ACTIONS(3905),
    [anon_sym__Alignof] = ACTIONS(3905),
    [anon_sym_offsetof] = ACTIONS(3905),
    [anon_sym__Generic] = ACTIONS(3905),
    [anon_sym_asm] = ACTIONS(3905),
    [anon_sym___asm__] = ACTIONS(3905),
    [anon_sym___asm] = ACTIONS(3905),
    [sym_number_literal] = ACTIONS(3907),
    [anon_sym_L_SQUOTE] = ACTIONS(3907),
    [anon_sym_u_SQUOTE] = ACTIONS(3907),
    [anon_sym_U_SQUOTE] = ACTIONS(3907),
    [anon_sym_u8_SQUOTE] = ACTIONS(3907),
    [anon_sym_SQUOTE] = ACTIONS(3907),
    [anon_sym_L_DQUOTE] = ACTIONS(3907),
    [anon_sym_u_DQUOTE] = ACTIONS(3907),
    [anon_sym_U_DQUOTE] = ACTIONS(3907),
    [anon_sym_u8_DQUOTE] = ACTIONS(3907),
    [anon_sym_DQUOTE] = ACTIONS(3907),
    [sym_true] = ACTIONS(3905),
    [sym_false] = ACTIONS(3905),
    [anon_sym_NULL] = ACTIONS(3905),
    [anon_sym_nullptr] = ACTIONS(3905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3905),
    [anon_sym_let] = ACTIONS(3905),
    [anon_sym_This] = ACTIONS(3905),
    [anon_sym_decltype] = ACTIONS(3905),
    [anon_sym_explicit] = ACTIONS(3905),
    [anon_sym_typename] = ACTIONS(3905),
    [anon_sym_template] = ACTIONS(3905),
    [anon_sym_operator] = ACTIONS(3905),
    [anon_sym_try] = ACTIONS(3905),
    [anon_sym_delete] = ACTIONS(3905),
    [anon_sym_throw] = ACTIONS(3905),
    [anon_sym_namespace] = ACTIONS(3905),
    [anon_sym_static_assert] = ACTIONS(3905),
    [anon_sym_concept] = ACTIONS(3905),
    [anon_sym_co_return] = ACTIONS(3905),
    [anon_sym_co_yield] = ACTIONS(3905),
    [anon_sym_R_DQUOTE] = ACTIONS(3907),
    [anon_sym_LR_DQUOTE] = ACTIONS(3907),
    [anon_sym_uR_DQUOTE] = ACTIONS(3907),
    [anon_sym_UR_DQUOTE] = ACTIONS(3907),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3907),
    [anon_sym_co_await] = ACTIONS(3905),
    [anon_sym_new] = ACTIONS(3905),
    [anon_sym_requires] = ACTIONS(3905),
    [sym_this] = ACTIONS(3905),
    [anon_sym_discard] = ACTIONS(3905),
    [anon_sym_precise] = ACTIONS(3905),
    [anon_sym_shared] = ACTIONS(3905),
    [anon_sym_groupshared] = ACTIONS(3905),
    [anon_sym_uniform] = ACTIONS(3905),
    [anon_sym_row_major] = ACTIONS(3905),
    [anon_sym_column_major] = ACTIONS(3905),
    [anon_sym_globallycoherent] = ACTIONS(3905),
    [anon_sym_centroid] = ACTIONS(3905),
    [anon_sym_noperspective] = ACTIONS(3905),
    [anon_sym_nointerpolation] = ACTIONS(3905),
    [anon_sym_sample] = ACTIONS(3905),
    [anon_sym_linear] = ACTIONS(3905),
    [anon_sym_snorm] = ACTIONS(3905),
    [anon_sym_unorm] = ACTIONS(3905),
    [anon_sym_point] = ACTIONS(3905),
    [anon_sym_line] = ACTIONS(3905),
    [anon_sym_triangleadj] = ACTIONS(3905),
    [anon_sym_lineadj] = ACTIONS(3905),
    [anon_sym_triangle] = ACTIONS(3905),
    [anon_sym_cbuffer] = ACTIONS(3905),
    [anon_sym_interface] = ACTIONS(3905),
    [anon_sym_extension] = ACTIONS(3905),
  },
  [605] = {
    [sym_template_argument_list] = STATE(403),
    [aux_sym_sized_type_specifier_repeat1] = STATE(665),
    [sym_identifier] = ACTIONS(2168),
    [aux_sym_preproc_include_token1] = ACTIONS(2168),
    [aux_sym_preproc_def_token1] = ACTIONS(2168),
    [aux_sym_preproc_if_token1] = ACTIONS(2168),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2168),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2168),
    [sym_preproc_directive] = ACTIONS(2168),
    [anon_sym_LPAREN2] = ACTIONS(2176),
    [anon_sym_BANG] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2168),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2168),
    [anon_sym_LT] = ACTIONS(2966),
    [anon_sym_SEMI] = ACTIONS(2176),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_typedef] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_using] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2176),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym___cdecl] = ACTIONS(2168),
    [anon_sym___clrcall] = ACTIONS(2168),
    [anon_sym___stdcall] = ACTIONS(2168),
    [anon_sym___fastcall] = ACTIONS(2168),
    [anon_sym___thiscall] = ACTIONS(2168),
    [anon_sym___vectorcall] = ACTIONS(2168),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_RBRACE] = ACTIONS(2176),
    [anon_sym_signed] = ACTIONS(2199),
    [anon_sym_unsigned] = ACTIONS(2199),
    [anon_sym_long] = ACTIONS(2199),
    [anon_sym_short] = ACTIONS(2199),
    [anon_sym_LBRACK] = ACTIONS(2168),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [sym_primitive_type] = ACTIONS(2168),
    [anon_sym_enum] = ACTIONS(2168),
    [anon_sym_class] = ACTIONS(2168),
    [anon_sym_struct] = ACTIONS(2168),
    [anon_sym_union] = ACTIONS(2168),
    [anon_sym_if] = ACTIONS(2168),
    [anon_sym_switch] = ACTIONS(2168),
    [anon_sym_case] = ACTIONS(2168),
    [anon_sym_default] = ACTIONS(2168),
    [anon_sym_while] = ACTIONS(2168),
    [anon_sym_do] = ACTIONS(2168),
    [anon_sym_for] = ACTIONS(2168),
    [anon_sym_return] = ACTIONS(2168),
    [anon_sym_break] = ACTIONS(2168),
    [anon_sym_continue] = ACTIONS(2168),
    [anon_sym_goto] = ACTIONS(2168),
    [anon_sym___try] = ACTIONS(2168),
    [anon_sym___leave] = ACTIONS(2168),
    [anon_sym_not] = ACTIONS(2168),
    [anon_sym_compl] = ACTIONS(2168),
    [anon_sym_DASH_DASH] = ACTIONS(2176),
    [anon_sym_PLUS_PLUS] = ACTIONS(2176),
    [anon_sym_sizeof] = ACTIONS(2168),
    [anon_sym___alignof__] = ACTIONS(2168),
    [anon_sym___alignof] = ACTIONS(2168),
    [anon_sym__alignof] = ACTIONS(2168),
    [anon_sym_alignof] = ACTIONS(2168),
    [anon_sym__Alignof] = ACTIONS(2168),
    [anon_sym_offsetof] = ACTIONS(2168),
    [anon_sym__Generic] = ACTIONS(2168),
    [anon_sym_asm] = ACTIONS(2168),
    [anon_sym___asm__] = ACTIONS(2168),
    [anon_sym___asm] = ACTIONS(2168),
    [anon_sym_DOT] = ACTIONS(2168),
    [sym_number_literal] = ACTIONS(2176),
    [anon_sym_L_SQUOTE] = ACTIONS(2176),
    [anon_sym_u_SQUOTE] = ACTIONS(2176),
    [anon_sym_U_SQUOTE] = ACTIONS(2176),
    [anon_sym_u8_SQUOTE] = ACTIONS(2176),
    [anon_sym_SQUOTE] = ACTIONS(2176),
    [anon_sym_L_DQUOTE] = ACTIONS(2176),
    [anon_sym_u_DQUOTE] = ACTIONS(2176),
    [anon_sym_U_DQUOTE] = ACTIONS(2176),
    [anon_sym_u8_DQUOTE] = ACTIONS(2176),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [sym_true] = ACTIONS(2168),
    [sym_false] = ACTIONS(2168),
    [anon_sym_NULL] = ACTIONS(2168),
    [anon_sym_nullptr] = ACTIONS(2168),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_decltype] = ACTIONS(2168),
    [anon_sym_explicit] = ACTIONS(2168),
    [anon_sym_typename] = ACTIONS(2168),
    [anon_sym_template] = ACTIONS(2168),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_try] = ACTIONS(2168),
    [anon_sym_delete] = ACTIONS(2168),
    [anon_sym_throw] = ACTIONS(2168),
    [anon_sym_namespace] = ACTIONS(2168),
    [anon_sym_static_assert] = ACTIONS(2168),
    [anon_sym_concept] = ACTIONS(2168),
    [anon_sym_co_return] = ACTIONS(2168),
    [anon_sym_co_yield] = ACTIONS(2168),
    [anon_sym_R_DQUOTE] = ACTIONS(2176),
    [anon_sym_LR_DQUOTE] = ACTIONS(2176),
    [anon_sym_uR_DQUOTE] = ACTIONS(2176),
    [anon_sym_UR_DQUOTE] = ACTIONS(2176),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2176),
    [anon_sym_co_await] = ACTIONS(2168),
    [anon_sym_new] = ACTIONS(2168),
    [anon_sym_requires] = ACTIONS(2168),
    [sym_this] = ACTIONS(2168),
    [anon_sym_discard] = ACTIONS(2168),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
    [anon_sym_cbuffer] = ACTIONS(2168),
    [anon_sym_interface] = ACTIONS(2168),
    [anon_sym_extension] = ACTIONS(2168),
  },
  [606] = {
    [sym_identifier] = ACTIONS(3909),
    [aux_sym_preproc_include_token1] = ACTIONS(3909),
    [aux_sym_preproc_def_token1] = ACTIONS(3909),
    [aux_sym_preproc_if_token1] = ACTIONS(3909),
    [aux_sym_preproc_if_token2] = ACTIONS(3909),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3909),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3909),
    [aux_sym_preproc_else_token1] = ACTIONS(3909),
    [aux_sym_preproc_elif_token1] = ACTIONS(3909),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3909),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3909),
    [sym_preproc_directive] = ACTIONS(3909),
    [anon_sym_LPAREN2] = ACTIONS(3911),
    [anon_sym_BANG] = ACTIONS(3911),
    [anon_sym_TILDE] = ACTIONS(3911),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_SEMI] = ACTIONS(3911),
    [anon_sym___extension__] = ACTIONS(3909),
    [anon_sym_typedef] = ACTIONS(3909),
    [anon_sym_in] = ACTIONS(3909),
    [anon_sym_out] = ACTIONS(3909),
    [anon_sym_inout] = ACTIONS(3909),
    [anon_sym_virtual] = ACTIONS(3909),
    [anon_sym_extern] = ACTIONS(3909),
    [anon_sym___attribute__] = ACTIONS(3909),
    [anon_sym___attribute] = ACTIONS(3909),
    [anon_sym_using] = ACTIONS(3909),
    [anon_sym_COLON_COLON] = ACTIONS(3911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3911),
    [anon_sym___declspec] = ACTIONS(3909),
    [anon_sym___based] = ACTIONS(3909),
    [anon_sym___cdecl] = ACTIONS(3909),
    [anon_sym___clrcall] = ACTIONS(3909),
    [anon_sym___stdcall] = ACTIONS(3909),
    [anon_sym___fastcall] = ACTIONS(3909),
    [anon_sym___thiscall] = ACTIONS(3909),
    [anon_sym___vectorcall] = ACTIONS(3909),
    [anon_sym_LBRACE] = ACTIONS(3911),
    [anon_sym_signed] = ACTIONS(3909),
    [anon_sym_unsigned] = ACTIONS(3909),
    [anon_sym_long] = ACTIONS(3909),
    [anon_sym_short] = ACTIONS(3909),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_static] = ACTIONS(3909),
    [anon_sym_register] = ACTIONS(3909),
    [anon_sym_inline] = ACTIONS(3909),
    [anon_sym___inline] = ACTIONS(3909),
    [anon_sym___inline__] = ACTIONS(3909),
    [anon_sym___forceinline] = ACTIONS(3909),
    [anon_sym_thread_local] = ACTIONS(3909),
    [anon_sym___thread] = ACTIONS(3909),
    [anon_sym_const] = ACTIONS(3909),
    [anon_sym_constexpr] = ACTIONS(3909),
    [anon_sym_volatile] = ACTIONS(3909),
    [anon_sym_restrict] = ACTIONS(3909),
    [anon_sym___restrict__] = ACTIONS(3909),
    [anon_sym__Atomic] = ACTIONS(3909),
    [anon_sym__Noreturn] = ACTIONS(3909),
    [anon_sym_noreturn] = ACTIONS(3909),
    [anon_sym__Nonnull] = ACTIONS(3909),
    [anon_sym_mutable] = ACTIONS(3909),
    [anon_sym_constinit] = ACTIONS(3909),
    [anon_sym_consteval] = ACTIONS(3909),
    [anon_sym_alignas] = ACTIONS(3909),
    [anon_sym__Alignas] = ACTIONS(3909),
    [sym_primitive_type] = ACTIONS(3909),
    [anon_sym_enum] = ACTIONS(3909),
    [anon_sym_class] = ACTIONS(3909),
    [anon_sym_struct] = ACTIONS(3909),
    [anon_sym_union] = ACTIONS(3909),
    [anon_sym_if] = ACTIONS(3909),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_case] = ACTIONS(3909),
    [anon_sym_default] = ACTIONS(3909),
    [anon_sym_while] = ACTIONS(3909),
    [anon_sym_do] = ACTIONS(3909),
    [anon_sym_for] = ACTIONS(3909),
    [anon_sym_return] = ACTIONS(3909),
    [anon_sym_break] = ACTIONS(3909),
    [anon_sym_continue] = ACTIONS(3909),
    [anon_sym_goto] = ACTIONS(3909),
    [anon_sym___try] = ACTIONS(3909),
    [anon_sym___leave] = ACTIONS(3909),
    [anon_sym_not] = ACTIONS(3909),
    [anon_sym_compl] = ACTIONS(3909),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_sizeof] = ACTIONS(3909),
    [anon_sym___alignof__] = ACTIONS(3909),
    [anon_sym___alignof] = ACTIONS(3909),
    [anon_sym__alignof] = ACTIONS(3909),
    [anon_sym_alignof] = ACTIONS(3909),
    [anon_sym__Alignof] = ACTIONS(3909),
    [anon_sym_offsetof] = ACTIONS(3909),
    [anon_sym__Generic] = ACTIONS(3909),
    [anon_sym_asm] = ACTIONS(3909),
    [anon_sym___asm__] = ACTIONS(3909),
    [anon_sym___asm] = ACTIONS(3909),
    [sym_number_literal] = ACTIONS(3911),
    [anon_sym_L_SQUOTE] = ACTIONS(3911),
    [anon_sym_u_SQUOTE] = ACTIONS(3911),
    [anon_sym_U_SQUOTE] = ACTIONS(3911),
    [anon_sym_u8_SQUOTE] = ACTIONS(3911),
    [anon_sym_SQUOTE] = ACTIONS(3911),
    [anon_sym_L_DQUOTE] = ACTIONS(3911),
    [anon_sym_u_DQUOTE] = ACTIONS(3911),
    [anon_sym_U_DQUOTE] = ACTIONS(3911),
    [anon_sym_u8_DQUOTE] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [sym_true] = ACTIONS(3909),
    [sym_false] = ACTIONS(3909),
    [anon_sym_NULL] = ACTIONS(3909),
    [anon_sym_nullptr] = ACTIONS(3909),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3909),
    [anon_sym_let] = ACTIONS(3909),
    [anon_sym_This] = ACTIONS(3909),
    [anon_sym_decltype] = ACTIONS(3909),
    [anon_sym_explicit] = ACTIONS(3909),
    [anon_sym_typename] = ACTIONS(3909),
    [anon_sym_template] = ACTIONS(3909),
    [anon_sym_operator] = ACTIONS(3909),
    [anon_sym_try] = ACTIONS(3909),
    [anon_sym_delete] = ACTIONS(3909),
    [anon_sym_throw] = ACTIONS(3909),
    [anon_sym_namespace] = ACTIONS(3909),
    [anon_sym_static_assert] = ACTIONS(3909),
    [anon_sym_concept] = ACTIONS(3909),
    [anon_sym_co_return] = ACTIONS(3909),
    [anon_sym_co_yield] = ACTIONS(3909),
    [anon_sym_R_DQUOTE] = ACTIONS(3911),
    [anon_sym_LR_DQUOTE] = ACTIONS(3911),
    [anon_sym_uR_DQUOTE] = ACTIONS(3911),
    [anon_sym_UR_DQUOTE] = ACTIONS(3911),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3911),
    [anon_sym_co_await] = ACTIONS(3909),
    [anon_sym_new] = ACTIONS(3909),
    [anon_sym_requires] = ACTIONS(3909),
    [sym_this] = ACTIONS(3909),
    [anon_sym_discard] = ACTIONS(3909),
    [anon_sym_precise] = ACTIONS(3909),
    [anon_sym_shared] = ACTIONS(3909),
    [anon_sym_groupshared] = ACTIONS(3909),
    [anon_sym_uniform] = ACTIONS(3909),
    [anon_sym_row_major] = ACTIONS(3909),
    [anon_sym_column_major] = ACTIONS(3909),
    [anon_sym_globallycoherent] = ACTIONS(3909),
    [anon_sym_centroid] = ACTIONS(3909),
    [anon_sym_noperspective] = ACTIONS(3909),
    [anon_sym_nointerpolation] = ACTIONS(3909),
    [anon_sym_sample] = ACTIONS(3909),
    [anon_sym_linear] = ACTIONS(3909),
    [anon_sym_snorm] = ACTIONS(3909),
    [anon_sym_unorm] = ACTIONS(3909),
    [anon_sym_point] = ACTIONS(3909),
    [anon_sym_line] = ACTIONS(3909),
    [anon_sym_triangleadj] = ACTIONS(3909),
    [anon_sym_lineadj] = ACTIONS(3909),
    [anon_sym_triangle] = ACTIONS(3909),
    [anon_sym_cbuffer] = ACTIONS(3909),
    [anon_sym_interface] = ACTIONS(3909),
    [anon_sym_extension] = ACTIONS(3909),
  },
  [607] = {
    [sym_identifier] = ACTIONS(3913),
    [aux_sym_preproc_include_token1] = ACTIONS(3913),
    [aux_sym_preproc_def_token1] = ACTIONS(3913),
    [aux_sym_preproc_if_token1] = ACTIONS(3913),
    [aux_sym_preproc_if_token2] = ACTIONS(3913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3913),
    [aux_sym_preproc_else_token1] = ACTIONS(3913),
    [aux_sym_preproc_elif_token1] = ACTIONS(3913),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3913),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3913),
    [sym_preproc_directive] = ACTIONS(3913),
    [anon_sym_LPAREN2] = ACTIONS(3915),
    [anon_sym_BANG] = ACTIONS(3915),
    [anon_sym_TILDE] = ACTIONS(3915),
    [anon_sym_DASH] = ACTIONS(3913),
    [anon_sym_PLUS] = ACTIONS(3913),
    [anon_sym_STAR] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3913),
    [anon_sym_SEMI] = ACTIONS(3915),
    [anon_sym___extension__] = ACTIONS(3913),
    [anon_sym_typedef] = ACTIONS(3913),
    [anon_sym_in] = ACTIONS(3913),
    [anon_sym_out] = ACTIONS(3913),
    [anon_sym_inout] = ACTIONS(3913),
    [anon_sym_virtual] = ACTIONS(3913),
    [anon_sym_extern] = ACTIONS(3913),
    [anon_sym___attribute__] = ACTIONS(3913),
    [anon_sym___attribute] = ACTIONS(3913),
    [anon_sym_using] = ACTIONS(3913),
    [anon_sym_COLON_COLON] = ACTIONS(3915),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3915),
    [anon_sym___declspec] = ACTIONS(3913),
    [anon_sym___based] = ACTIONS(3913),
    [anon_sym___cdecl] = ACTIONS(3913),
    [anon_sym___clrcall] = ACTIONS(3913),
    [anon_sym___stdcall] = ACTIONS(3913),
    [anon_sym___fastcall] = ACTIONS(3913),
    [anon_sym___thiscall] = ACTIONS(3913),
    [anon_sym___vectorcall] = ACTIONS(3913),
    [anon_sym_LBRACE] = ACTIONS(3915),
    [anon_sym_signed] = ACTIONS(3913),
    [anon_sym_unsigned] = ACTIONS(3913),
    [anon_sym_long] = ACTIONS(3913),
    [anon_sym_short] = ACTIONS(3913),
    [anon_sym_LBRACK] = ACTIONS(3913),
    [anon_sym_static] = ACTIONS(3913),
    [anon_sym_register] = ACTIONS(3913),
    [anon_sym_inline] = ACTIONS(3913),
    [anon_sym___inline] = ACTIONS(3913),
    [anon_sym___inline__] = ACTIONS(3913),
    [anon_sym___forceinline] = ACTIONS(3913),
    [anon_sym_thread_local] = ACTIONS(3913),
    [anon_sym___thread] = ACTIONS(3913),
    [anon_sym_const] = ACTIONS(3913),
    [anon_sym_constexpr] = ACTIONS(3913),
    [anon_sym_volatile] = ACTIONS(3913),
    [anon_sym_restrict] = ACTIONS(3913),
    [anon_sym___restrict__] = ACTIONS(3913),
    [anon_sym__Atomic] = ACTIONS(3913),
    [anon_sym__Noreturn] = ACTIONS(3913),
    [anon_sym_noreturn] = ACTIONS(3913),
    [anon_sym__Nonnull] = ACTIONS(3913),
    [anon_sym_mutable] = ACTIONS(3913),
    [anon_sym_constinit] = ACTIONS(3913),
    [anon_sym_consteval] = ACTIONS(3913),
    [anon_sym_alignas] = ACTIONS(3913),
    [anon_sym__Alignas] = ACTIONS(3913),
    [sym_primitive_type] = ACTIONS(3913),
    [anon_sym_enum] = ACTIONS(3913),
    [anon_sym_class] = ACTIONS(3913),
    [anon_sym_struct] = ACTIONS(3913),
    [anon_sym_union] = ACTIONS(3913),
    [anon_sym_if] = ACTIONS(3913),
    [anon_sym_switch] = ACTIONS(3913),
    [anon_sym_case] = ACTIONS(3913),
    [anon_sym_default] = ACTIONS(3913),
    [anon_sym_while] = ACTIONS(3913),
    [anon_sym_do] = ACTIONS(3913),
    [anon_sym_for] = ACTIONS(3913),
    [anon_sym_return] = ACTIONS(3913),
    [anon_sym_break] = ACTIONS(3913),
    [anon_sym_continue] = ACTIONS(3913),
    [anon_sym_goto] = ACTIONS(3913),
    [anon_sym___try] = ACTIONS(3913),
    [anon_sym___leave] = ACTIONS(3913),
    [anon_sym_not] = ACTIONS(3913),
    [anon_sym_compl] = ACTIONS(3913),
    [anon_sym_DASH_DASH] = ACTIONS(3915),
    [anon_sym_PLUS_PLUS] = ACTIONS(3915),
    [anon_sym_sizeof] = ACTIONS(3913),
    [anon_sym___alignof__] = ACTIONS(3913),
    [anon_sym___alignof] = ACTIONS(3913),
    [anon_sym__alignof] = ACTIONS(3913),
    [anon_sym_alignof] = ACTIONS(3913),
    [anon_sym__Alignof] = ACTIONS(3913),
    [anon_sym_offsetof] = ACTIONS(3913),
    [anon_sym__Generic] = ACTIONS(3913),
    [anon_sym_asm] = ACTIONS(3913),
    [anon_sym___asm__] = ACTIONS(3913),
    [anon_sym___asm] = ACTIONS(3913),
    [sym_number_literal] = ACTIONS(3915),
    [anon_sym_L_SQUOTE] = ACTIONS(3915),
    [anon_sym_u_SQUOTE] = ACTIONS(3915),
    [anon_sym_U_SQUOTE] = ACTIONS(3915),
    [anon_sym_u8_SQUOTE] = ACTIONS(3915),
    [anon_sym_SQUOTE] = ACTIONS(3915),
    [anon_sym_L_DQUOTE] = ACTIONS(3915),
    [anon_sym_u_DQUOTE] = ACTIONS(3915),
    [anon_sym_U_DQUOTE] = ACTIONS(3915),
    [anon_sym_u8_DQUOTE] = ACTIONS(3915),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [sym_true] = ACTIONS(3913),
    [sym_false] = ACTIONS(3913),
    [anon_sym_NULL] = ACTIONS(3913),
    [anon_sym_nullptr] = ACTIONS(3913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3913),
    [anon_sym_let] = ACTIONS(3913),
    [anon_sym_This] = ACTIONS(3913),
    [anon_sym_decltype] = ACTIONS(3913),
    [anon_sym_explicit] = ACTIONS(3913),
    [anon_sym_typename] = ACTIONS(3913),
    [anon_sym_template] = ACTIONS(3913),
    [anon_sym_operator] = ACTIONS(3913),
    [anon_sym_try] = ACTIONS(3913),
    [anon_sym_delete] = ACTIONS(3913),
    [anon_sym_throw] = ACTIONS(3913),
    [anon_sym_namespace] = ACTIONS(3913),
    [anon_sym_static_assert] = ACTIONS(3913),
    [anon_sym_concept] = ACTIONS(3913),
    [anon_sym_co_return] = ACTIONS(3913),
    [anon_sym_co_yield] = ACTIONS(3913),
    [anon_sym_R_DQUOTE] = ACTIONS(3915),
    [anon_sym_LR_DQUOTE] = ACTIONS(3915),
    [anon_sym_uR_DQUOTE] = ACTIONS(3915),
    [anon_sym_UR_DQUOTE] = ACTIONS(3915),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3915),
    [anon_sym_co_await] = ACTIONS(3913),
    [anon_sym_new] = ACTIONS(3913),
    [anon_sym_requires] = ACTIONS(3913),
    [sym_this] = ACTIONS(3913),
    [anon_sym_discard] = ACTIONS(3913),
    [anon_sym_precise] = ACTIONS(3913),
    [anon_sym_shared] = ACTIONS(3913),
    [anon_sym_groupshared] = ACTIONS(3913),
    [anon_sym_uniform] = ACTIONS(3913),
    [anon_sym_row_major] = ACTIONS(3913),
    [anon_sym_column_major] = ACTIONS(3913),
    [anon_sym_globallycoherent] = ACTIONS(3913),
    [anon_sym_centroid] = ACTIONS(3913),
    [anon_sym_noperspective] = ACTIONS(3913),
    [anon_sym_nointerpolation] = ACTIONS(3913),
    [anon_sym_sample] = ACTIONS(3913),
    [anon_sym_linear] = ACTIONS(3913),
    [anon_sym_snorm] = ACTIONS(3913),
    [anon_sym_unorm] = ACTIONS(3913),
    [anon_sym_point] = ACTIONS(3913),
    [anon_sym_line] = ACTIONS(3913),
    [anon_sym_triangleadj] = ACTIONS(3913),
    [anon_sym_lineadj] = ACTIONS(3913),
    [anon_sym_triangle] = ACTIONS(3913),
    [anon_sym_cbuffer] = ACTIONS(3913),
    [anon_sym_interface] = ACTIONS(3913),
    [anon_sym_extension] = ACTIONS(3913),
  },
  [608] = {
    [sym_catch_clause] = STATE(616),
    [aux_sym_constructor_try_statement_repeat1] = STATE(616),
    [sym_identifier] = ACTIONS(2885),
    [aux_sym_preproc_include_token1] = ACTIONS(2885),
    [aux_sym_preproc_def_token1] = ACTIONS(2885),
    [aux_sym_preproc_if_token1] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2885),
    [sym_preproc_directive] = ACTIONS(2885),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_BANG] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2887),
    [anon_sym_DASH] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym___extension__] = ACTIONS(2885),
    [anon_sym_typedef] = ACTIONS(2885),
    [anon_sym_in] = ACTIONS(2885),
    [anon_sym_out] = ACTIONS(2885),
    [anon_sym_inout] = ACTIONS(2885),
    [anon_sym_virtual] = ACTIONS(2885),
    [anon_sym_extern] = ACTIONS(2885),
    [anon_sym___attribute__] = ACTIONS(2885),
    [anon_sym___attribute] = ACTIONS(2885),
    [anon_sym_using] = ACTIONS(2885),
    [anon_sym_COLON_COLON] = ACTIONS(2887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2887),
    [anon_sym___declspec] = ACTIONS(2885),
    [anon_sym___based] = ACTIONS(2885),
    [anon_sym___cdecl] = ACTIONS(2885),
    [anon_sym___clrcall] = ACTIONS(2885),
    [anon_sym___stdcall] = ACTIONS(2885),
    [anon_sym___fastcall] = ACTIONS(2885),
    [anon_sym___thiscall] = ACTIONS(2885),
    [anon_sym___vectorcall] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_RBRACE] = ACTIONS(2887),
    [anon_sym_signed] = ACTIONS(2885),
    [anon_sym_unsigned] = ACTIONS(2885),
    [anon_sym_long] = ACTIONS(2885),
    [anon_sym_short] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_static] = ACTIONS(2885),
    [anon_sym_register] = ACTIONS(2885),
    [anon_sym_inline] = ACTIONS(2885),
    [anon_sym___inline] = ACTIONS(2885),
    [anon_sym___inline__] = ACTIONS(2885),
    [anon_sym___forceinline] = ACTIONS(2885),
    [anon_sym_thread_local] = ACTIONS(2885),
    [anon_sym___thread] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_constexpr] = ACTIONS(2885),
    [anon_sym_volatile] = ACTIONS(2885),
    [anon_sym_restrict] = ACTIONS(2885),
    [anon_sym___restrict__] = ACTIONS(2885),
    [anon_sym__Atomic] = ACTIONS(2885),
    [anon_sym__Noreturn] = ACTIONS(2885),
    [anon_sym_noreturn] = ACTIONS(2885),
    [anon_sym__Nonnull] = ACTIONS(2885),
    [anon_sym_mutable] = ACTIONS(2885),
    [anon_sym_constinit] = ACTIONS(2885),
    [anon_sym_consteval] = ACTIONS(2885),
    [anon_sym_alignas] = ACTIONS(2885),
    [anon_sym__Alignas] = ACTIONS(2885),
    [sym_primitive_type] = ACTIONS(2885),
    [anon_sym_enum] = ACTIONS(2885),
    [anon_sym_class] = ACTIONS(2885),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_union] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_else] = ACTIONS(2885),
    [anon_sym_switch] = ACTIONS(2885),
    [anon_sym_case] = ACTIONS(2885),
    [anon_sym_default] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [anon_sym_do] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_break] = ACTIONS(2885),
    [anon_sym_continue] = ACTIONS(2885),
    [anon_sym_goto] = ACTIONS(2885),
    [anon_sym___try] = ACTIONS(2885),
    [anon_sym___leave] = ACTIONS(2885),
    [anon_sym_not] = ACTIONS(2885),
    [anon_sym_compl] = ACTIONS(2885),
    [anon_sym_DASH_DASH] = ACTIONS(2887),
    [anon_sym_PLUS_PLUS] = ACTIONS(2887),
    [anon_sym_sizeof] = ACTIONS(2885),
    [anon_sym___alignof__] = ACTIONS(2885),
    [anon_sym___alignof] = ACTIONS(2885),
    [anon_sym__alignof] = ACTIONS(2885),
    [anon_sym_alignof] = ACTIONS(2885),
    [anon_sym__Alignof] = ACTIONS(2885),
    [anon_sym_offsetof] = ACTIONS(2885),
    [anon_sym__Generic] = ACTIONS(2885),
    [anon_sym_asm] = ACTIONS(2885),
    [anon_sym___asm__] = ACTIONS(2885),
    [anon_sym___asm] = ACTIONS(2885),
    [sym_number_literal] = ACTIONS(2887),
    [anon_sym_L_SQUOTE] = ACTIONS(2887),
    [anon_sym_u_SQUOTE] = ACTIONS(2887),
    [anon_sym_U_SQUOTE] = ACTIONS(2887),
    [anon_sym_u8_SQUOTE] = ACTIONS(2887),
    [anon_sym_SQUOTE] = ACTIONS(2887),
    [anon_sym_L_DQUOTE] = ACTIONS(2887),
    [anon_sym_u_DQUOTE] = ACTIONS(2887),
    [anon_sym_U_DQUOTE] = ACTIONS(2887),
    [anon_sym_u8_DQUOTE] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [sym_true] = ACTIONS(2885),
    [sym_false] = ACTIONS(2885),
    [anon_sym_NULL] = ACTIONS(2885),
    [anon_sym_nullptr] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2885),
    [anon_sym_let] = ACTIONS(2885),
    [anon_sym_This] = ACTIONS(2885),
    [anon_sym_decltype] = ACTIONS(2885),
    [anon_sym_explicit] = ACTIONS(2885),
    [anon_sym_typename] = ACTIONS(2885),
    [anon_sym_template] = ACTIONS(2885),
    [anon_sym_operator] = ACTIONS(2885),
    [anon_sym_try] = ACTIONS(2885),
    [anon_sym_delete] = ACTIONS(2885),
    [anon_sym_throw] = ACTIONS(2885),
    [anon_sym_namespace] = ACTIONS(2885),
    [anon_sym_static_assert] = ACTIONS(2885),
    [anon_sym_concept] = ACTIONS(2885),
    [anon_sym_co_return] = ACTIONS(2885),
    [anon_sym_co_yield] = ACTIONS(2885),
    [anon_sym_catch] = ACTIONS(3917),
    [anon_sym_R_DQUOTE] = ACTIONS(2887),
    [anon_sym_LR_DQUOTE] = ACTIONS(2887),
    [anon_sym_uR_DQUOTE] = ACTIONS(2887),
    [anon_sym_UR_DQUOTE] = ACTIONS(2887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2887),
    [anon_sym_co_await] = ACTIONS(2885),
    [anon_sym_new] = ACTIONS(2885),
    [anon_sym_requires] = ACTIONS(2885),
    [sym_this] = ACTIONS(2885),
    [anon_sym_discard] = ACTIONS(2885),
    [anon_sym_precise] = ACTIONS(2885),
    [anon_sym_shared] = ACTIONS(2885),
    [anon_sym_groupshared] = ACTIONS(2885),
    [anon_sym_uniform] = ACTIONS(2885),
    [anon_sym_row_major] = ACTIONS(2885),
    [anon_sym_column_major] = ACTIONS(2885),
    [anon_sym_globallycoherent] = ACTIONS(2885),
    [anon_sym_centroid] = ACTIONS(2885),
    [anon_sym_noperspective] = ACTIONS(2885),
    [anon_sym_nointerpolation] = ACTIONS(2885),
    [anon_sym_sample] = ACTIONS(2885),
    [anon_sym_linear] = ACTIONS(2885),
    [anon_sym_snorm] = ACTIONS(2885),
    [anon_sym_unorm] = ACTIONS(2885),
    [anon_sym_point] = ACTIONS(2885),
    [anon_sym_line] = ACTIONS(2885),
    [anon_sym_triangleadj] = ACTIONS(2885),
    [anon_sym_lineadj] = ACTIONS(2885),
    [anon_sym_triangle] = ACTIONS(2885),
    [anon_sym_cbuffer] = ACTIONS(2885),
    [anon_sym_interface] = ACTIONS(2885),
    [anon_sym_extension] = ACTIONS(2885),
  },
  [609] = {
    [sym_identifier] = ACTIONS(3919),
    [aux_sym_preproc_include_token1] = ACTIONS(3919),
    [aux_sym_preproc_def_token1] = ACTIONS(3919),
    [aux_sym_preproc_if_token1] = ACTIONS(3919),
    [aux_sym_preproc_if_token2] = ACTIONS(3919),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3919),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3919),
    [aux_sym_preproc_else_token1] = ACTIONS(3919),
    [aux_sym_preproc_elif_token1] = ACTIONS(3919),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3919),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3919),
    [sym_preproc_directive] = ACTIONS(3919),
    [anon_sym_LPAREN2] = ACTIONS(3921),
    [anon_sym_BANG] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3919),
    [anon_sym_PLUS] = ACTIONS(3919),
    [anon_sym_STAR] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_AMP] = ACTIONS(3919),
    [anon_sym_SEMI] = ACTIONS(3921),
    [anon_sym___extension__] = ACTIONS(3919),
    [anon_sym_typedef] = ACTIONS(3919),
    [anon_sym_in] = ACTIONS(3919),
    [anon_sym_out] = ACTIONS(3919),
    [anon_sym_inout] = ACTIONS(3919),
    [anon_sym_virtual] = ACTIONS(3919),
    [anon_sym_extern] = ACTIONS(3919),
    [anon_sym___attribute__] = ACTIONS(3919),
    [anon_sym___attribute] = ACTIONS(3919),
    [anon_sym_using] = ACTIONS(3919),
    [anon_sym_COLON_COLON] = ACTIONS(3921),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3921),
    [anon_sym___declspec] = ACTIONS(3919),
    [anon_sym___based] = ACTIONS(3919),
    [anon_sym___cdecl] = ACTIONS(3919),
    [anon_sym___clrcall] = ACTIONS(3919),
    [anon_sym___stdcall] = ACTIONS(3919),
    [anon_sym___fastcall] = ACTIONS(3919),
    [anon_sym___thiscall] = ACTIONS(3919),
    [anon_sym___vectorcall] = ACTIONS(3919),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_signed] = ACTIONS(3919),
    [anon_sym_unsigned] = ACTIONS(3919),
    [anon_sym_long] = ACTIONS(3919),
    [anon_sym_short] = ACTIONS(3919),
    [anon_sym_LBRACK] = ACTIONS(3919),
    [anon_sym_static] = ACTIONS(3919),
    [anon_sym_register] = ACTIONS(3919),
    [anon_sym_inline] = ACTIONS(3919),
    [anon_sym___inline] = ACTIONS(3919),
    [anon_sym___inline__] = ACTIONS(3919),
    [anon_sym___forceinline] = ACTIONS(3919),
    [anon_sym_thread_local] = ACTIONS(3919),
    [anon_sym___thread] = ACTIONS(3919),
    [anon_sym_const] = ACTIONS(3919),
    [anon_sym_constexpr] = ACTIONS(3919),
    [anon_sym_volatile] = ACTIONS(3919),
    [anon_sym_restrict] = ACTIONS(3919),
    [anon_sym___restrict__] = ACTIONS(3919),
    [anon_sym__Atomic] = ACTIONS(3919),
    [anon_sym__Noreturn] = ACTIONS(3919),
    [anon_sym_noreturn] = ACTIONS(3919),
    [anon_sym__Nonnull] = ACTIONS(3919),
    [anon_sym_mutable] = ACTIONS(3919),
    [anon_sym_constinit] = ACTIONS(3919),
    [anon_sym_consteval] = ACTIONS(3919),
    [anon_sym_alignas] = ACTIONS(3919),
    [anon_sym__Alignas] = ACTIONS(3919),
    [sym_primitive_type] = ACTIONS(3919),
    [anon_sym_enum] = ACTIONS(3919),
    [anon_sym_class] = ACTIONS(3919),
    [anon_sym_struct] = ACTIONS(3919),
    [anon_sym_union] = ACTIONS(3919),
    [anon_sym_if] = ACTIONS(3919),
    [anon_sym_switch] = ACTIONS(3919),
    [anon_sym_case] = ACTIONS(3919),
    [anon_sym_default] = ACTIONS(3919),
    [anon_sym_while] = ACTIONS(3919),
    [anon_sym_do] = ACTIONS(3919),
    [anon_sym_for] = ACTIONS(3919),
    [anon_sym_return] = ACTIONS(3919),
    [anon_sym_break] = ACTIONS(3919),
    [anon_sym_continue] = ACTIONS(3919),
    [anon_sym_goto] = ACTIONS(3919),
    [anon_sym___try] = ACTIONS(3919),
    [anon_sym___leave] = ACTIONS(3919),
    [anon_sym_not] = ACTIONS(3919),
    [anon_sym_compl] = ACTIONS(3919),
    [anon_sym_DASH_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_PLUS] = ACTIONS(3921),
    [anon_sym_sizeof] = ACTIONS(3919),
    [anon_sym___alignof__] = ACTIONS(3919),
    [anon_sym___alignof] = ACTIONS(3919),
    [anon_sym__alignof] = ACTIONS(3919),
    [anon_sym_alignof] = ACTIONS(3919),
    [anon_sym__Alignof] = ACTIONS(3919),
    [anon_sym_offsetof] = ACTIONS(3919),
    [anon_sym__Generic] = ACTIONS(3919),
    [anon_sym_asm] = ACTIONS(3919),
    [anon_sym___asm__] = ACTIONS(3919),
    [anon_sym___asm] = ACTIONS(3919),
    [sym_number_literal] = ACTIONS(3921),
    [anon_sym_L_SQUOTE] = ACTIONS(3921),
    [anon_sym_u_SQUOTE] = ACTIONS(3921),
    [anon_sym_U_SQUOTE] = ACTIONS(3921),
    [anon_sym_u8_SQUOTE] = ACTIONS(3921),
    [anon_sym_SQUOTE] = ACTIONS(3921),
    [anon_sym_L_DQUOTE] = ACTIONS(3921),
    [anon_sym_u_DQUOTE] = ACTIONS(3921),
    [anon_sym_U_DQUOTE] = ACTIONS(3921),
    [anon_sym_u8_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [sym_true] = ACTIONS(3919),
    [sym_false] = ACTIONS(3919),
    [anon_sym_NULL] = ACTIONS(3919),
    [anon_sym_nullptr] = ACTIONS(3919),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3919),
    [anon_sym_let] = ACTIONS(3919),
    [anon_sym_This] = ACTIONS(3919),
    [anon_sym_decltype] = ACTIONS(3919),
    [anon_sym_explicit] = ACTIONS(3919),
    [anon_sym_typename] = ACTIONS(3919),
    [anon_sym_template] = ACTIONS(3919),
    [anon_sym_operator] = ACTIONS(3919),
    [anon_sym_try] = ACTIONS(3919),
    [anon_sym_delete] = ACTIONS(3919),
    [anon_sym_throw] = ACTIONS(3919),
    [anon_sym_namespace] = ACTIONS(3919),
    [anon_sym_static_assert] = ACTIONS(3919),
    [anon_sym_concept] = ACTIONS(3919),
    [anon_sym_co_return] = ACTIONS(3919),
    [anon_sym_co_yield] = ACTIONS(3919),
    [anon_sym_R_DQUOTE] = ACTIONS(3921),
    [anon_sym_LR_DQUOTE] = ACTIONS(3921),
    [anon_sym_uR_DQUOTE] = ACTIONS(3921),
    [anon_sym_UR_DQUOTE] = ACTIONS(3921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3921),
    [anon_sym_co_await] = ACTIONS(3919),
    [anon_sym_new] = ACTIONS(3919),
    [anon_sym_requires] = ACTIONS(3919),
    [sym_this] = ACTIONS(3919),
    [anon_sym_discard] = ACTIONS(3919),
    [anon_sym_precise] = ACTIONS(3919),
    [anon_sym_shared] = ACTIONS(3919),
    [anon_sym_groupshared] = ACTIONS(3919),
    [anon_sym_uniform] = ACTIONS(3919),
    [anon_sym_row_major] = ACTIONS(3919),
    [anon_sym_column_major] = ACTIONS(3919),
    [anon_sym_globallycoherent] = ACTIONS(3919),
    [anon_sym_centroid] = ACTIONS(3919),
    [anon_sym_noperspective] = ACTIONS(3919),
    [anon_sym_nointerpolation] = ACTIONS(3919),
    [anon_sym_sample] = ACTIONS(3919),
    [anon_sym_linear] = ACTIONS(3919),
    [anon_sym_snorm] = ACTIONS(3919),
    [anon_sym_unorm] = ACTIONS(3919),
    [anon_sym_point] = ACTIONS(3919),
    [anon_sym_line] = ACTIONS(3919),
    [anon_sym_triangleadj] = ACTIONS(3919),
    [anon_sym_lineadj] = ACTIONS(3919),
    [anon_sym_triangle] = ACTIONS(3919),
    [anon_sym_cbuffer] = ACTIONS(3919),
    [anon_sym_interface] = ACTIONS(3919),
    [anon_sym_extension] = ACTIONS(3919),
  },
  [610] = {
    [sym_identifier] = ACTIONS(3923),
    [aux_sym_preproc_include_token1] = ACTIONS(3923),
    [aux_sym_preproc_def_token1] = ACTIONS(3923),
    [aux_sym_preproc_if_token1] = ACTIONS(3923),
    [aux_sym_preproc_if_token2] = ACTIONS(3923),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3923),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3923),
    [aux_sym_preproc_else_token1] = ACTIONS(3923),
    [aux_sym_preproc_elif_token1] = ACTIONS(3923),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3923),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3923),
    [sym_preproc_directive] = ACTIONS(3923),
    [anon_sym_LPAREN2] = ACTIONS(3925),
    [anon_sym_BANG] = ACTIONS(3925),
    [anon_sym_TILDE] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_STAR] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_AMP] = ACTIONS(3923),
    [anon_sym_SEMI] = ACTIONS(3925),
    [anon_sym___extension__] = ACTIONS(3923),
    [anon_sym_typedef] = ACTIONS(3923),
    [anon_sym_in] = ACTIONS(3923),
    [anon_sym_out] = ACTIONS(3923),
    [anon_sym_inout] = ACTIONS(3923),
    [anon_sym_virtual] = ACTIONS(3923),
    [anon_sym_extern] = ACTIONS(3923),
    [anon_sym___attribute__] = ACTIONS(3923),
    [anon_sym___attribute] = ACTIONS(3923),
    [anon_sym_using] = ACTIONS(3923),
    [anon_sym_COLON_COLON] = ACTIONS(3925),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3925),
    [anon_sym___declspec] = ACTIONS(3923),
    [anon_sym___based] = ACTIONS(3923),
    [anon_sym___cdecl] = ACTIONS(3923),
    [anon_sym___clrcall] = ACTIONS(3923),
    [anon_sym___stdcall] = ACTIONS(3923),
    [anon_sym___fastcall] = ACTIONS(3923),
    [anon_sym___thiscall] = ACTIONS(3923),
    [anon_sym___vectorcall] = ACTIONS(3923),
    [anon_sym_LBRACE] = ACTIONS(3925),
    [anon_sym_signed] = ACTIONS(3923),
    [anon_sym_unsigned] = ACTIONS(3923),
    [anon_sym_long] = ACTIONS(3923),
    [anon_sym_short] = ACTIONS(3923),
    [anon_sym_LBRACK] = ACTIONS(3923),
    [anon_sym_static] = ACTIONS(3923),
    [anon_sym_register] = ACTIONS(3923),
    [anon_sym_inline] = ACTIONS(3923),
    [anon_sym___inline] = ACTIONS(3923),
    [anon_sym___inline__] = ACTIONS(3923),
    [anon_sym___forceinline] = ACTIONS(3923),
    [anon_sym_thread_local] = ACTIONS(3923),
    [anon_sym___thread] = ACTIONS(3923),
    [anon_sym_const] = ACTIONS(3923),
    [anon_sym_constexpr] = ACTIONS(3923),
    [anon_sym_volatile] = ACTIONS(3923),
    [anon_sym_restrict] = ACTIONS(3923),
    [anon_sym___restrict__] = ACTIONS(3923),
    [anon_sym__Atomic] = ACTIONS(3923),
    [anon_sym__Noreturn] = ACTIONS(3923),
    [anon_sym_noreturn] = ACTIONS(3923),
    [anon_sym__Nonnull] = ACTIONS(3923),
    [anon_sym_mutable] = ACTIONS(3923),
    [anon_sym_constinit] = ACTIONS(3923),
    [anon_sym_consteval] = ACTIONS(3923),
    [anon_sym_alignas] = ACTIONS(3923),
    [anon_sym__Alignas] = ACTIONS(3923),
    [sym_primitive_type] = ACTIONS(3923),
    [anon_sym_enum] = ACTIONS(3923),
    [anon_sym_class] = ACTIONS(3923),
    [anon_sym_struct] = ACTIONS(3923),
    [anon_sym_union] = ACTIONS(3923),
    [anon_sym_if] = ACTIONS(3923),
    [anon_sym_switch] = ACTIONS(3923),
    [anon_sym_case] = ACTIONS(3923),
    [anon_sym_default] = ACTIONS(3923),
    [anon_sym_while] = ACTIONS(3923),
    [anon_sym_do] = ACTIONS(3923),
    [anon_sym_for] = ACTIONS(3923),
    [anon_sym_return] = ACTIONS(3923),
    [anon_sym_break] = ACTIONS(3923),
    [anon_sym_continue] = ACTIONS(3923),
    [anon_sym_goto] = ACTIONS(3923),
    [anon_sym___try] = ACTIONS(3923),
    [anon_sym___leave] = ACTIONS(3923),
    [anon_sym_not] = ACTIONS(3923),
    [anon_sym_compl] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3923),
    [anon_sym___alignof__] = ACTIONS(3923),
    [anon_sym___alignof] = ACTIONS(3923),
    [anon_sym__alignof] = ACTIONS(3923),
    [anon_sym_alignof] = ACTIONS(3923),
    [anon_sym__Alignof] = ACTIONS(3923),
    [anon_sym_offsetof] = ACTIONS(3923),
    [anon_sym__Generic] = ACTIONS(3923),
    [anon_sym_asm] = ACTIONS(3923),
    [anon_sym___asm__] = ACTIONS(3923),
    [anon_sym___asm] = ACTIONS(3923),
    [sym_number_literal] = ACTIONS(3925),
    [anon_sym_L_SQUOTE] = ACTIONS(3925),
    [anon_sym_u_SQUOTE] = ACTIONS(3925),
    [anon_sym_U_SQUOTE] = ACTIONS(3925),
    [anon_sym_u8_SQUOTE] = ACTIONS(3925),
    [anon_sym_SQUOTE] = ACTIONS(3925),
    [anon_sym_L_DQUOTE] = ACTIONS(3925),
    [anon_sym_u_DQUOTE] = ACTIONS(3925),
    [anon_sym_U_DQUOTE] = ACTIONS(3925),
    [anon_sym_u8_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [sym_true] = ACTIONS(3923),
    [sym_false] = ACTIONS(3923),
    [anon_sym_NULL] = ACTIONS(3923),
    [anon_sym_nullptr] = ACTIONS(3923),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3923),
    [anon_sym_let] = ACTIONS(3923),
    [anon_sym_This] = ACTIONS(3923),
    [anon_sym_decltype] = ACTIONS(3923),
    [anon_sym_explicit] = ACTIONS(3923),
    [anon_sym_typename] = ACTIONS(3923),
    [anon_sym_template] = ACTIONS(3923),
    [anon_sym_operator] = ACTIONS(3923),
    [anon_sym_try] = ACTIONS(3923),
    [anon_sym_delete] = ACTIONS(3923),
    [anon_sym_throw] = ACTIONS(3923),
    [anon_sym_namespace] = ACTIONS(3923),
    [anon_sym_static_assert] = ACTIONS(3923),
    [anon_sym_concept] = ACTIONS(3923),
    [anon_sym_co_return] = ACTIONS(3923),
    [anon_sym_co_yield] = ACTIONS(3923),
    [anon_sym_R_DQUOTE] = ACTIONS(3925),
    [anon_sym_LR_DQUOTE] = ACTIONS(3925),
    [anon_sym_uR_DQUOTE] = ACTIONS(3925),
    [anon_sym_UR_DQUOTE] = ACTIONS(3925),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3925),
    [anon_sym_co_await] = ACTIONS(3923),
    [anon_sym_new] = ACTIONS(3923),
    [anon_sym_requires] = ACTIONS(3923),
    [sym_this] = ACTIONS(3923),
    [anon_sym_discard] = ACTIONS(3923),
    [anon_sym_precise] = ACTIONS(3923),
    [anon_sym_shared] = ACTIONS(3923),
    [anon_sym_groupshared] = ACTIONS(3923),
    [anon_sym_uniform] = ACTIONS(3923),
    [anon_sym_row_major] = ACTIONS(3923),
    [anon_sym_column_major] = ACTIONS(3923),
    [anon_sym_globallycoherent] = ACTIONS(3923),
    [anon_sym_centroid] = ACTIONS(3923),
    [anon_sym_noperspective] = ACTIONS(3923),
    [anon_sym_nointerpolation] = ACTIONS(3923),
    [anon_sym_sample] = ACTIONS(3923),
    [anon_sym_linear] = ACTIONS(3923),
    [anon_sym_snorm] = ACTIONS(3923),
    [anon_sym_unorm] = ACTIONS(3923),
    [anon_sym_point] = ACTIONS(3923),
    [anon_sym_line] = ACTIONS(3923),
    [anon_sym_triangleadj] = ACTIONS(3923),
    [anon_sym_lineadj] = ACTIONS(3923),
    [anon_sym_triangle] = ACTIONS(3923),
    [anon_sym_cbuffer] = ACTIONS(3923),
    [anon_sym_interface] = ACTIONS(3923),
    [anon_sym_extension] = ACTIONS(3923),
  },
  [611] = {
    [sym_identifier] = ACTIONS(3927),
    [aux_sym_preproc_include_token1] = ACTIONS(3927),
    [aux_sym_preproc_def_token1] = ACTIONS(3927),
    [aux_sym_preproc_if_token1] = ACTIONS(3927),
    [aux_sym_preproc_if_token2] = ACTIONS(3927),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3927),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3927),
    [aux_sym_preproc_else_token1] = ACTIONS(3927),
    [aux_sym_preproc_elif_token1] = ACTIONS(3927),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3927),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3927),
    [sym_preproc_directive] = ACTIONS(3927),
    [anon_sym_LPAREN2] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_TILDE] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_SEMI] = ACTIONS(3929),
    [anon_sym___extension__] = ACTIONS(3927),
    [anon_sym_typedef] = ACTIONS(3927),
    [anon_sym_in] = ACTIONS(3927),
    [anon_sym_out] = ACTIONS(3927),
    [anon_sym_inout] = ACTIONS(3927),
    [anon_sym_virtual] = ACTIONS(3927),
    [anon_sym_extern] = ACTIONS(3927),
    [anon_sym___attribute__] = ACTIONS(3927),
    [anon_sym___attribute] = ACTIONS(3927),
    [anon_sym_using] = ACTIONS(3927),
    [anon_sym_COLON_COLON] = ACTIONS(3929),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3929),
    [anon_sym___declspec] = ACTIONS(3927),
    [anon_sym___based] = ACTIONS(3927),
    [anon_sym___cdecl] = ACTIONS(3927),
    [anon_sym___clrcall] = ACTIONS(3927),
    [anon_sym___stdcall] = ACTIONS(3927),
    [anon_sym___fastcall] = ACTIONS(3927),
    [anon_sym___thiscall] = ACTIONS(3927),
    [anon_sym___vectorcall] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3929),
    [anon_sym_signed] = ACTIONS(3927),
    [anon_sym_unsigned] = ACTIONS(3927),
    [anon_sym_long] = ACTIONS(3927),
    [anon_sym_short] = ACTIONS(3927),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_static] = ACTIONS(3927),
    [anon_sym_register] = ACTIONS(3927),
    [anon_sym_inline] = ACTIONS(3927),
    [anon_sym___inline] = ACTIONS(3927),
    [anon_sym___inline__] = ACTIONS(3927),
    [anon_sym___forceinline] = ACTIONS(3927),
    [anon_sym_thread_local] = ACTIONS(3927),
    [anon_sym___thread] = ACTIONS(3927),
    [anon_sym_const] = ACTIONS(3927),
    [anon_sym_constexpr] = ACTIONS(3927),
    [anon_sym_volatile] = ACTIONS(3927),
    [anon_sym_restrict] = ACTIONS(3927),
    [anon_sym___restrict__] = ACTIONS(3927),
    [anon_sym__Atomic] = ACTIONS(3927),
    [anon_sym__Noreturn] = ACTIONS(3927),
    [anon_sym_noreturn] = ACTIONS(3927),
    [anon_sym__Nonnull] = ACTIONS(3927),
    [anon_sym_mutable] = ACTIONS(3927),
    [anon_sym_constinit] = ACTIONS(3927),
    [anon_sym_consteval] = ACTIONS(3927),
    [anon_sym_alignas] = ACTIONS(3927),
    [anon_sym__Alignas] = ACTIONS(3927),
    [sym_primitive_type] = ACTIONS(3927),
    [anon_sym_enum] = ACTIONS(3927),
    [anon_sym_class] = ACTIONS(3927),
    [anon_sym_struct] = ACTIONS(3927),
    [anon_sym_union] = ACTIONS(3927),
    [anon_sym_if] = ACTIONS(3927),
    [anon_sym_switch] = ACTIONS(3927),
    [anon_sym_case] = ACTIONS(3927),
    [anon_sym_default] = ACTIONS(3927),
    [anon_sym_while] = ACTIONS(3927),
    [anon_sym_do] = ACTIONS(3927),
    [anon_sym_for] = ACTIONS(3927),
    [anon_sym_return] = ACTIONS(3927),
    [anon_sym_break] = ACTIONS(3927),
    [anon_sym_continue] = ACTIONS(3927),
    [anon_sym_goto] = ACTIONS(3927),
    [anon_sym___try] = ACTIONS(3927),
    [anon_sym___leave] = ACTIONS(3927),
    [anon_sym_not] = ACTIONS(3927),
    [anon_sym_compl] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3929),
    [anon_sym_sizeof] = ACTIONS(3927),
    [anon_sym___alignof__] = ACTIONS(3927),
    [anon_sym___alignof] = ACTIONS(3927),
    [anon_sym__alignof] = ACTIONS(3927),
    [anon_sym_alignof] = ACTIONS(3927),
    [anon_sym__Alignof] = ACTIONS(3927),
    [anon_sym_offsetof] = ACTIONS(3927),
    [anon_sym__Generic] = ACTIONS(3927),
    [anon_sym_asm] = ACTIONS(3927),
    [anon_sym___asm__] = ACTIONS(3927),
    [anon_sym___asm] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(3929),
    [anon_sym_L_SQUOTE] = ACTIONS(3929),
    [anon_sym_u_SQUOTE] = ACTIONS(3929),
    [anon_sym_U_SQUOTE] = ACTIONS(3929),
    [anon_sym_u8_SQUOTE] = ACTIONS(3929),
    [anon_sym_SQUOTE] = ACTIONS(3929),
    [anon_sym_L_DQUOTE] = ACTIONS(3929),
    [anon_sym_u_DQUOTE] = ACTIONS(3929),
    [anon_sym_U_DQUOTE] = ACTIONS(3929),
    [anon_sym_u8_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [sym_true] = ACTIONS(3927),
    [sym_false] = ACTIONS(3927),
    [anon_sym_NULL] = ACTIONS(3927),
    [anon_sym_nullptr] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3927),
    [anon_sym_let] = ACTIONS(3927),
    [anon_sym_This] = ACTIONS(3927),
    [anon_sym_decltype] = ACTIONS(3927),
    [anon_sym_explicit] = ACTIONS(3927),
    [anon_sym_typename] = ACTIONS(3927),
    [anon_sym_template] = ACTIONS(3927),
    [anon_sym_operator] = ACTIONS(3927),
    [anon_sym_try] = ACTIONS(3927),
    [anon_sym_delete] = ACTIONS(3927),
    [anon_sym_throw] = ACTIONS(3927),
    [anon_sym_namespace] = ACTIONS(3927),
    [anon_sym_static_assert] = ACTIONS(3927),
    [anon_sym_concept] = ACTIONS(3927),
    [anon_sym_co_return] = ACTIONS(3927),
    [anon_sym_co_yield] = ACTIONS(3927),
    [anon_sym_R_DQUOTE] = ACTIONS(3929),
    [anon_sym_LR_DQUOTE] = ACTIONS(3929),
    [anon_sym_uR_DQUOTE] = ACTIONS(3929),
    [anon_sym_UR_DQUOTE] = ACTIONS(3929),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3929),
    [anon_sym_co_await] = ACTIONS(3927),
    [anon_sym_new] = ACTIONS(3927),
    [anon_sym_requires] = ACTIONS(3927),
    [sym_this] = ACTIONS(3927),
    [anon_sym_discard] = ACTIONS(3927),
    [anon_sym_precise] = ACTIONS(3927),
    [anon_sym_shared] = ACTIONS(3927),
    [anon_sym_groupshared] = ACTIONS(3927),
    [anon_sym_uniform] = ACTIONS(3927),
    [anon_sym_row_major] = ACTIONS(3927),
    [anon_sym_column_major] = ACTIONS(3927),
    [anon_sym_globallycoherent] = ACTIONS(3927),
    [anon_sym_centroid] = ACTIONS(3927),
    [anon_sym_noperspective] = ACTIONS(3927),
    [anon_sym_nointerpolation] = ACTIONS(3927),
    [anon_sym_sample] = ACTIONS(3927),
    [anon_sym_linear] = ACTIONS(3927),
    [anon_sym_snorm] = ACTIONS(3927),
    [anon_sym_unorm] = ACTIONS(3927),
    [anon_sym_point] = ACTIONS(3927),
    [anon_sym_line] = ACTIONS(3927),
    [anon_sym_triangleadj] = ACTIONS(3927),
    [anon_sym_lineadj] = ACTIONS(3927),
    [anon_sym_triangle] = ACTIONS(3927),
    [anon_sym_cbuffer] = ACTIONS(3927),
    [anon_sym_interface] = ACTIONS(3927),
    [anon_sym_extension] = ACTIONS(3927),
  },
  [612] = {
    [sym_identifier] = ACTIONS(3931),
    [aux_sym_preproc_include_token1] = ACTIONS(3931),
    [aux_sym_preproc_def_token1] = ACTIONS(3931),
    [aux_sym_preproc_if_token1] = ACTIONS(3931),
    [aux_sym_preproc_if_token2] = ACTIONS(3931),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3931),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3931),
    [aux_sym_preproc_else_token1] = ACTIONS(3931),
    [aux_sym_preproc_elif_token1] = ACTIONS(3931),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3931),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3931),
    [sym_preproc_directive] = ACTIONS(3931),
    [anon_sym_LPAREN2] = ACTIONS(3933),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_TILDE] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_STAR] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_SEMI] = ACTIONS(3933),
    [anon_sym___extension__] = ACTIONS(3931),
    [anon_sym_typedef] = ACTIONS(3931),
    [anon_sym_in] = ACTIONS(3931),
    [anon_sym_out] = ACTIONS(3931),
    [anon_sym_inout] = ACTIONS(3931),
    [anon_sym_virtual] = ACTIONS(3931),
    [anon_sym_extern] = ACTIONS(3931),
    [anon_sym___attribute__] = ACTIONS(3931),
    [anon_sym___attribute] = ACTIONS(3931),
    [anon_sym_using] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3933),
    [anon_sym___declspec] = ACTIONS(3931),
    [anon_sym___based] = ACTIONS(3931),
    [anon_sym___cdecl] = ACTIONS(3931),
    [anon_sym___clrcall] = ACTIONS(3931),
    [anon_sym___stdcall] = ACTIONS(3931),
    [anon_sym___fastcall] = ACTIONS(3931),
    [anon_sym___thiscall] = ACTIONS(3931),
    [anon_sym___vectorcall] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3933),
    [anon_sym_signed] = ACTIONS(3931),
    [anon_sym_unsigned] = ACTIONS(3931),
    [anon_sym_long] = ACTIONS(3931),
    [anon_sym_short] = ACTIONS(3931),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_static] = ACTIONS(3931),
    [anon_sym_register] = ACTIONS(3931),
    [anon_sym_inline] = ACTIONS(3931),
    [anon_sym___inline] = ACTIONS(3931),
    [anon_sym___inline__] = ACTIONS(3931),
    [anon_sym___forceinline] = ACTIONS(3931),
    [anon_sym_thread_local] = ACTIONS(3931),
    [anon_sym___thread] = ACTIONS(3931),
    [anon_sym_const] = ACTIONS(3931),
    [anon_sym_constexpr] = ACTIONS(3931),
    [anon_sym_volatile] = ACTIONS(3931),
    [anon_sym_restrict] = ACTIONS(3931),
    [anon_sym___restrict__] = ACTIONS(3931),
    [anon_sym__Atomic] = ACTIONS(3931),
    [anon_sym__Noreturn] = ACTIONS(3931),
    [anon_sym_noreturn] = ACTIONS(3931),
    [anon_sym__Nonnull] = ACTIONS(3931),
    [anon_sym_mutable] = ACTIONS(3931),
    [anon_sym_constinit] = ACTIONS(3931),
    [anon_sym_consteval] = ACTIONS(3931),
    [anon_sym_alignas] = ACTIONS(3931),
    [anon_sym__Alignas] = ACTIONS(3931),
    [sym_primitive_type] = ACTIONS(3931),
    [anon_sym_enum] = ACTIONS(3931),
    [anon_sym_class] = ACTIONS(3931),
    [anon_sym_struct] = ACTIONS(3931),
    [anon_sym_union] = ACTIONS(3931),
    [anon_sym_if] = ACTIONS(3931),
    [anon_sym_switch] = ACTIONS(3931),
    [anon_sym_case] = ACTIONS(3931),
    [anon_sym_default] = ACTIONS(3931),
    [anon_sym_while] = ACTIONS(3931),
    [anon_sym_do] = ACTIONS(3931),
    [anon_sym_for] = ACTIONS(3931),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_break] = ACTIONS(3931),
    [anon_sym_continue] = ACTIONS(3931),
    [anon_sym_goto] = ACTIONS(3931),
    [anon_sym___try] = ACTIONS(3931),
    [anon_sym___leave] = ACTIONS(3931),
    [anon_sym_not] = ACTIONS(3931),
    [anon_sym_compl] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_sizeof] = ACTIONS(3931),
    [anon_sym___alignof__] = ACTIONS(3931),
    [anon_sym___alignof] = ACTIONS(3931),
    [anon_sym__alignof] = ACTIONS(3931),
    [anon_sym_alignof] = ACTIONS(3931),
    [anon_sym__Alignof] = ACTIONS(3931),
    [anon_sym_offsetof] = ACTIONS(3931),
    [anon_sym__Generic] = ACTIONS(3931),
    [anon_sym_asm] = ACTIONS(3931),
    [anon_sym___asm__] = ACTIONS(3931),
    [anon_sym___asm] = ACTIONS(3931),
    [sym_number_literal] = ACTIONS(3933),
    [anon_sym_L_SQUOTE] = ACTIONS(3933),
    [anon_sym_u_SQUOTE] = ACTIONS(3933),
    [anon_sym_U_SQUOTE] = ACTIONS(3933),
    [anon_sym_u8_SQUOTE] = ACTIONS(3933),
    [anon_sym_SQUOTE] = ACTIONS(3933),
    [anon_sym_L_DQUOTE] = ACTIONS(3933),
    [anon_sym_u_DQUOTE] = ACTIONS(3933),
    [anon_sym_U_DQUOTE] = ACTIONS(3933),
    [anon_sym_u8_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE] = ACTIONS(3933),
    [sym_true] = ACTIONS(3931),
    [sym_false] = ACTIONS(3931),
    [anon_sym_NULL] = ACTIONS(3931),
    [anon_sym_nullptr] = ACTIONS(3931),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3931),
    [anon_sym_let] = ACTIONS(3931),
    [anon_sym_This] = ACTIONS(3931),
    [anon_sym_decltype] = ACTIONS(3931),
    [anon_sym_explicit] = ACTIONS(3931),
    [anon_sym_typename] = ACTIONS(3931),
    [anon_sym_template] = ACTIONS(3931),
    [anon_sym_operator] = ACTIONS(3931),
    [anon_sym_try] = ACTIONS(3931),
    [anon_sym_delete] = ACTIONS(3931),
    [anon_sym_throw] = ACTIONS(3931),
    [anon_sym_namespace] = ACTIONS(3931),
    [anon_sym_static_assert] = ACTIONS(3931),
    [anon_sym_concept] = ACTIONS(3931),
    [anon_sym_co_return] = ACTIONS(3931),
    [anon_sym_co_yield] = ACTIONS(3931),
    [anon_sym_R_DQUOTE] = ACTIONS(3933),
    [anon_sym_LR_DQUOTE] = ACTIONS(3933),
    [anon_sym_uR_DQUOTE] = ACTIONS(3933),
    [anon_sym_UR_DQUOTE] = ACTIONS(3933),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3933),
    [anon_sym_co_await] = ACTIONS(3931),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_requires] = ACTIONS(3931),
    [sym_this] = ACTIONS(3931),
    [anon_sym_discard] = ACTIONS(3931),
    [anon_sym_precise] = ACTIONS(3931),
    [anon_sym_shared] = ACTIONS(3931),
    [anon_sym_groupshared] = ACTIONS(3931),
    [anon_sym_uniform] = ACTIONS(3931),
    [anon_sym_row_major] = ACTIONS(3931),
    [anon_sym_column_major] = ACTIONS(3931),
    [anon_sym_globallycoherent] = ACTIONS(3931),
    [anon_sym_centroid] = ACTIONS(3931),
    [anon_sym_noperspective] = ACTIONS(3931),
    [anon_sym_nointerpolation] = ACTIONS(3931),
    [anon_sym_sample] = ACTIONS(3931),
    [anon_sym_linear] = ACTIONS(3931),
    [anon_sym_snorm] = ACTIONS(3931),
    [anon_sym_unorm] = ACTIONS(3931),
    [anon_sym_point] = ACTIONS(3931),
    [anon_sym_line] = ACTIONS(3931),
    [anon_sym_triangleadj] = ACTIONS(3931),
    [anon_sym_lineadj] = ACTIONS(3931),
    [anon_sym_triangle] = ACTIONS(3931),
    [anon_sym_cbuffer] = ACTIONS(3931),
    [anon_sym_interface] = ACTIONS(3931),
    [anon_sym_extension] = ACTIONS(3931),
  },
  [613] = {
    [sym_identifier] = ACTIONS(3935),
    [aux_sym_preproc_include_token1] = ACTIONS(3935),
    [aux_sym_preproc_def_token1] = ACTIONS(3935),
    [aux_sym_preproc_if_token1] = ACTIONS(3935),
    [aux_sym_preproc_if_token2] = ACTIONS(3935),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3935),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3935),
    [aux_sym_preproc_else_token1] = ACTIONS(3935),
    [aux_sym_preproc_elif_token1] = ACTIONS(3935),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3935),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3935),
    [sym_preproc_directive] = ACTIONS(3935),
    [anon_sym_LPAREN2] = ACTIONS(3937),
    [anon_sym_BANG] = ACTIONS(3937),
    [anon_sym_TILDE] = ACTIONS(3937),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3935),
    [anon_sym_STAR] = ACTIONS(3937),
    [anon_sym_AMP_AMP] = ACTIONS(3937),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_SEMI] = ACTIONS(3937),
    [anon_sym___extension__] = ACTIONS(3935),
    [anon_sym_typedef] = ACTIONS(3935),
    [anon_sym_in] = ACTIONS(3935),
    [anon_sym_out] = ACTIONS(3935),
    [anon_sym_inout] = ACTIONS(3935),
    [anon_sym_virtual] = ACTIONS(3935),
    [anon_sym_extern] = ACTIONS(3935),
    [anon_sym___attribute__] = ACTIONS(3935),
    [anon_sym___attribute] = ACTIONS(3935),
    [anon_sym_using] = ACTIONS(3935),
    [anon_sym_COLON_COLON] = ACTIONS(3937),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3937),
    [anon_sym___declspec] = ACTIONS(3935),
    [anon_sym___based] = ACTIONS(3935),
    [anon_sym___cdecl] = ACTIONS(3935),
    [anon_sym___clrcall] = ACTIONS(3935),
    [anon_sym___stdcall] = ACTIONS(3935),
    [anon_sym___fastcall] = ACTIONS(3935),
    [anon_sym___thiscall] = ACTIONS(3935),
    [anon_sym___vectorcall] = ACTIONS(3935),
    [anon_sym_LBRACE] = ACTIONS(3937),
    [anon_sym_signed] = ACTIONS(3935),
    [anon_sym_unsigned] = ACTIONS(3935),
    [anon_sym_long] = ACTIONS(3935),
    [anon_sym_short] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3935),
    [anon_sym_static] = ACTIONS(3935),
    [anon_sym_register] = ACTIONS(3935),
    [anon_sym_inline] = ACTIONS(3935),
    [anon_sym___inline] = ACTIONS(3935),
    [anon_sym___inline__] = ACTIONS(3935),
    [anon_sym___forceinline] = ACTIONS(3935),
    [anon_sym_thread_local] = ACTIONS(3935),
    [anon_sym___thread] = ACTIONS(3935),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_constexpr] = ACTIONS(3935),
    [anon_sym_volatile] = ACTIONS(3935),
    [anon_sym_restrict] = ACTIONS(3935),
    [anon_sym___restrict__] = ACTIONS(3935),
    [anon_sym__Atomic] = ACTIONS(3935),
    [anon_sym__Noreturn] = ACTIONS(3935),
    [anon_sym_noreturn] = ACTIONS(3935),
    [anon_sym__Nonnull] = ACTIONS(3935),
    [anon_sym_mutable] = ACTIONS(3935),
    [anon_sym_constinit] = ACTIONS(3935),
    [anon_sym_consteval] = ACTIONS(3935),
    [anon_sym_alignas] = ACTIONS(3935),
    [anon_sym__Alignas] = ACTIONS(3935),
    [sym_primitive_type] = ACTIONS(3935),
    [anon_sym_enum] = ACTIONS(3935),
    [anon_sym_class] = ACTIONS(3935),
    [anon_sym_struct] = ACTIONS(3935),
    [anon_sym_union] = ACTIONS(3935),
    [anon_sym_if] = ACTIONS(3935),
    [anon_sym_switch] = ACTIONS(3935),
    [anon_sym_case] = ACTIONS(3935),
    [anon_sym_default] = ACTIONS(3935),
    [anon_sym_while] = ACTIONS(3935),
    [anon_sym_do] = ACTIONS(3935),
    [anon_sym_for] = ACTIONS(3935),
    [anon_sym_return] = ACTIONS(3935),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_continue] = ACTIONS(3935),
    [anon_sym_goto] = ACTIONS(3935),
    [anon_sym___try] = ACTIONS(3935),
    [anon_sym___leave] = ACTIONS(3935),
    [anon_sym_not] = ACTIONS(3935),
    [anon_sym_compl] = ACTIONS(3935),
    [anon_sym_DASH_DASH] = ACTIONS(3937),
    [anon_sym_PLUS_PLUS] = ACTIONS(3937),
    [anon_sym_sizeof] = ACTIONS(3935),
    [anon_sym___alignof__] = ACTIONS(3935),
    [anon_sym___alignof] = ACTIONS(3935),
    [anon_sym__alignof] = ACTIONS(3935),
    [anon_sym_alignof] = ACTIONS(3935),
    [anon_sym__Alignof] = ACTIONS(3935),
    [anon_sym_offsetof] = ACTIONS(3935),
    [anon_sym__Generic] = ACTIONS(3935),
    [anon_sym_asm] = ACTIONS(3935),
    [anon_sym___asm__] = ACTIONS(3935),
    [anon_sym___asm] = ACTIONS(3935),
    [sym_number_literal] = ACTIONS(3937),
    [anon_sym_L_SQUOTE] = ACTIONS(3937),
    [anon_sym_u_SQUOTE] = ACTIONS(3937),
    [anon_sym_U_SQUOTE] = ACTIONS(3937),
    [anon_sym_u8_SQUOTE] = ACTIONS(3937),
    [anon_sym_SQUOTE] = ACTIONS(3937),
    [anon_sym_L_DQUOTE] = ACTIONS(3937),
    [anon_sym_u_DQUOTE] = ACTIONS(3937),
    [anon_sym_U_DQUOTE] = ACTIONS(3937),
    [anon_sym_u8_DQUOTE] = ACTIONS(3937),
    [anon_sym_DQUOTE] = ACTIONS(3937),
    [sym_true] = ACTIONS(3935),
    [sym_false] = ACTIONS(3935),
    [anon_sym_NULL] = ACTIONS(3935),
    [anon_sym_nullptr] = ACTIONS(3935),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3935),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_This] = ACTIONS(3935),
    [anon_sym_decltype] = ACTIONS(3935),
    [anon_sym_explicit] = ACTIONS(3935),
    [anon_sym_typename] = ACTIONS(3935),
    [anon_sym_template] = ACTIONS(3935),
    [anon_sym_operator] = ACTIONS(3935),
    [anon_sym_try] = ACTIONS(3935),
    [anon_sym_delete] = ACTIONS(3935),
    [anon_sym_throw] = ACTIONS(3935),
    [anon_sym_namespace] = ACTIONS(3935),
    [anon_sym_static_assert] = ACTIONS(3935),
    [anon_sym_concept] = ACTIONS(3935),
    [anon_sym_co_return] = ACTIONS(3935),
    [anon_sym_co_yield] = ACTIONS(3935),
    [anon_sym_R_DQUOTE] = ACTIONS(3937),
    [anon_sym_LR_DQUOTE] = ACTIONS(3937),
    [anon_sym_uR_DQUOTE] = ACTIONS(3937),
    [anon_sym_UR_DQUOTE] = ACTIONS(3937),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3937),
    [anon_sym_co_await] = ACTIONS(3935),
    [anon_sym_new] = ACTIONS(3935),
    [anon_sym_requires] = ACTIONS(3935),
    [sym_this] = ACTIONS(3935),
    [anon_sym_discard] = ACTIONS(3935),
    [anon_sym_precise] = ACTIONS(3935),
    [anon_sym_shared] = ACTIONS(3935),
    [anon_sym_groupshared] = ACTIONS(3935),
    [anon_sym_uniform] = ACTIONS(3935),
    [anon_sym_row_major] = ACTIONS(3935),
    [anon_sym_column_major] = ACTIONS(3935),
    [anon_sym_globallycoherent] = ACTIONS(3935),
    [anon_sym_centroid] = ACTIONS(3935),
    [anon_sym_noperspective] = ACTIONS(3935),
    [anon_sym_nointerpolation] = ACTIONS(3935),
    [anon_sym_sample] = ACTIONS(3935),
    [anon_sym_linear] = ACTIONS(3935),
    [anon_sym_snorm] = ACTIONS(3935),
    [anon_sym_unorm] = ACTIONS(3935),
    [anon_sym_point] = ACTIONS(3935),
    [anon_sym_line] = ACTIONS(3935),
    [anon_sym_triangleadj] = ACTIONS(3935),
    [anon_sym_lineadj] = ACTIONS(3935),
    [anon_sym_triangle] = ACTIONS(3935),
    [anon_sym_cbuffer] = ACTIONS(3935),
    [anon_sym_interface] = ACTIONS(3935),
    [anon_sym_extension] = ACTIONS(3935),
  },
  [614] = {
    [sym_argument_list] = STATE(3418),
    [sym_initializer_list] = STATE(4856),
    [aux_sym_sized_type_specifier_repeat1] = STATE(679),
    [ts_builtin_sym_end] = ACTIONS(2881),
    [sym_identifier] = ACTIONS(2883),
    [aux_sym_preproc_include_token1] = ACTIONS(2883),
    [aux_sym_preproc_def_token1] = ACTIONS(2883),
    [aux_sym_preproc_if_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2883),
    [sym_preproc_directive] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(3836),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_typedef] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_using] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2881),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(3839),
    [anon_sym_signed] = ACTIONS(3939),
    [anon_sym_unsigned] = ACTIONS(3939),
    [anon_sym_long] = ACTIONS(3939),
    [anon_sym_short] = ACTIONS(3939),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [sym_primitive_type] = ACTIONS(2883),
    [anon_sym_enum] = ACTIONS(2883),
    [anon_sym_class] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2883),
    [anon_sym_union] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_switch] = ACTIONS(2883),
    [anon_sym_case] = ACTIONS(2883),
    [anon_sym_default] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_break] = ACTIONS(2883),
    [anon_sym_continue] = ACTIONS(2883),
    [anon_sym_goto] = ACTIONS(2883),
    [anon_sym_not] = ACTIONS(2883),
    [anon_sym_compl] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_sizeof] = ACTIONS(2883),
    [anon_sym___alignof__] = ACTIONS(2883),
    [anon_sym___alignof] = ACTIONS(2883),
    [anon_sym__alignof] = ACTIONS(2883),
    [anon_sym_alignof] = ACTIONS(2883),
    [anon_sym__Alignof] = ACTIONS(2883),
    [anon_sym_offsetof] = ACTIONS(2883),
    [anon_sym__Generic] = ACTIONS(2883),
    [anon_sym_asm] = ACTIONS(2883),
    [anon_sym___asm__] = ACTIONS(2883),
    [anon_sym___asm] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [sym_number_literal] = ACTIONS(2881),
    [anon_sym_L_SQUOTE] = ACTIONS(2881),
    [anon_sym_u_SQUOTE] = ACTIONS(2881),
    [anon_sym_U_SQUOTE] = ACTIONS(2881),
    [anon_sym_u8_SQUOTE] = ACTIONS(2881),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_L_DQUOTE] = ACTIONS(2881),
    [anon_sym_u_DQUOTE] = ACTIONS(2881),
    [anon_sym_U_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [sym_true] = ACTIONS(2883),
    [sym_false] = ACTIONS(2883),
    [anon_sym_NULL] = ACTIONS(2883),
    [anon_sym_nullptr] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_explicit] = ACTIONS(2883),
    [anon_sym_typename] = ACTIONS(2883),
    [anon_sym_export] = ACTIONS(2883),
    [anon_sym_module] = ACTIONS(2883),
    [anon_sym_import] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_delete] = ACTIONS(2883),
    [anon_sym_throw] = ACTIONS(2883),
    [anon_sym_namespace] = ACTIONS(2883),
    [anon_sym_static_assert] = ACTIONS(2883),
    [anon_sym_concept] = ACTIONS(2883),
    [anon_sym_co_return] = ACTIONS(2883),
    [anon_sym_co_yield] = ACTIONS(2883),
    [anon_sym_R_DQUOTE] = ACTIONS(2881),
    [anon_sym_LR_DQUOTE] = ACTIONS(2881),
    [anon_sym_uR_DQUOTE] = ACTIONS(2881),
    [anon_sym_UR_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2881),
    [anon_sym_co_await] = ACTIONS(2883),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_requires] = ACTIONS(2883),
    [sym_this] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
    [anon_sym_interface] = ACTIONS(2883),
    [anon_sym_extension] = ACTIONS(2883),
    [anon_sym___exported] = ACTIONS(2883),
  },
  [615] = {
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_include_token1] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token2] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [aux_sym_preproc_else_token1] = ACTIONS(3942),
    [aux_sym_preproc_elif_token1] = ACTIONS(3942),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_BANG] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym___cdecl] = ACTIONS(3942),
    [anon_sym___clrcall] = ACTIONS(3942),
    [anon_sym___stdcall] = ACTIONS(3942),
    [anon_sym___fastcall] = ACTIONS(3942),
    [anon_sym___thiscall] = ACTIONS(3942),
    [anon_sym___vectorcall] = ACTIONS(3942),
    [anon_sym_LBRACE] = ACTIONS(3944),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_switch] = ACTIONS(3942),
    [anon_sym_case] = ACTIONS(3942),
    [anon_sym_default] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_break] = ACTIONS(3942),
    [anon_sym_continue] = ACTIONS(3942),
    [anon_sym_goto] = ACTIONS(3942),
    [anon_sym___try] = ACTIONS(3942),
    [anon_sym___leave] = ACTIONS(3942),
    [anon_sym_not] = ACTIONS(3942),
    [anon_sym_compl] = ACTIONS(3942),
    [anon_sym_DASH_DASH] = ACTIONS(3944),
    [anon_sym_PLUS_PLUS] = ACTIONS(3944),
    [anon_sym_sizeof] = ACTIONS(3942),
    [anon_sym___alignof__] = ACTIONS(3942),
    [anon_sym___alignof] = ACTIONS(3942),
    [anon_sym__alignof] = ACTIONS(3942),
    [anon_sym_alignof] = ACTIONS(3942),
    [anon_sym__Alignof] = ACTIONS(3942),
    [anon_sym_offsetof] = ACTIONS(3942),
    [anon_sym__Generic] = ACTIONS(3942),
    [anon_sym_asm] = ACTIONS(3942),
    [anon_sym___asm__] = ACTIONS(3942),
    [anon_sym___asm] = ACTIONS(3942),
    [sym_number_literal] = ACTIONS(3944),
    [anon_sym_L_SQUOTE] = ACTIONS(3944),
    [anon_sym_u_SQUOTE] = ACTIONS(3944),
    [anon_sym_U_SQUOTE] = ACTIONS(3944),
    [anon_sym_u8_SQUOTE] = ACTIONS(3944),
    [anon_sym_SQUOTE] = ACTIONS(3944),
    [anon_sym_L_DQUOTE] = ACTIONS(3944),
    [anon_sym_u_DQUOTE] = ACTIONS(3944),
    [anon_sym_U_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE] = ACTIONS(3944),
    [sym_true] = ACTIONS(3942),
    [sym_false] = ACTIONS(3942),
    [anon_sym_NULL] = ACTIONS(3942),
    [anon_sym_nullptr] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_delete] = ACTIONS(3942),
    [anon_sym_throw] = ACTIONS(3942),
    [anon_sym_namespace] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_concept] = ACTIONS(3942),
    [anon_sym_co_return] = ACTIONS(3942),
    [anon_sym_co_yield] = ACTIONS(3942),
    [anon_sym_R_DQUOTE] = ACTIONS(3944),
    [anon_sym_LR_DQUOTE] = ACTIONS(3944),
    [anon_sym_uR_DQUOTE] = ACTIONS(3944),
    [anon_sym_UR_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3944),
    [anon_sym_co_await] = ACTIONS(3942),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_requires] = ACTIONS(3942),
    [sym_this] = ACTIONS(3942),
    [anon_sym_discard] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_cbuffer] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
  },
  [616] = {
    [sym_catch_clause] = STATE(616),
    [aux_sym_constructor_try_statement_repeat1] = STATE(616),
    [sym_identifier] = ACTIONS(2901),
    [aux_sym_preproc_include_token1] = ACTIONS(2901),
    [aux_sym_preproc_def_token1] = ACTIONS(2901),
    [aux_sym_preproc_if_token1] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2901),
    [sym_preproc_directive] = ACTIONS(2901),
    [anon_sym_LPAREN2] = ACTIONS(2903),
    [anon_sym_BANG] = ACTIONS(2903),
    [anon_sym_TILDE] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2901),
    [anon_sym_STAR] = ACTIONS(2903),
    [anon_sym_AMP_AMP] = ACTIONS(2903),
    [anon_sym_AMP] = ACTIONS(2901),
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym___extension__] = ACTIONS(2901),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_in] = ACTIONS(2901),
    [anon_sym_out] = ACTIONS(2901),
    [anon_sym_inout] = ACTIONS(2901),
    [anon_sym_virtual] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(2901),
    [anon_sym___attribute__] = ACTIONS(2901),
    [anon_sym___attribute] = ACTIONS(2901),
    [anon_sym_using] = ACTIONS(2901),
    [anon_sym_COLON_COLON] = ACTIONS(2903),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2903),
    [anon_sym___declspec] = ACTIONS(2901),
    [anon_sym___based] = ACTIONS(2901),
    [anon_sym___cdecl] = ACTIONS(2901),
    [anon_sym___clrcall] = ACTIONS(2901),
    [anon_sym___stdcall] = ACTIONS(2901),
    [anon_sym___fastcall] = ACTIONS(2901),
    [anon_sym___thiscall] = ACTIONS(2901),
    [anon_sym___vectorcall] = ACTIONS(2901),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_RBRACE] = ACTIONS(2903),
    [anon_sym_signed] = ACTIONS(2901),
    [anon_sym_unsigned] = ACTIONS(2901),
    [anon_sym_long] = ACTIONS(2901),
    [anon_sym_short] = ACTIONS(2901),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_static] = ACTIONS(2901),
    [anon_sym_register] = ACTIONS(2901),
    [anon_sym_inline] = ACTIONS(2901),
    [anon_sym___inline] = ACTIONS(2901),
    [anon_sym___inline__] = ACTIONS(2901),
    [anon_sym___forceinline] = ACTIONS(2901),
    [anon_sym_thread_local] = ACTIONS(2901),
    [anon_sym___thread] = ACTIONS(2901),
    [anon_sym_const] = ACTIONS(2901),
    [anon_sym_constexpr] = ACTIONS(2901),
    [anon_sym_volatile] = ACTIONS(2901),
    [anon_sym_restrict] = ACTIONS(2901),
    [anon_sym___restrict__] = ACTIONS(2901),
    [anon_sym__Atomic] = ACTIONS(2901),
    [anon_sym__Noreturn] = ACTIONS(2901),
    [anon_sym_noreturn] = ACTIONS(2901),
    [anon_sym__Nonnull] = ACTIONS(2901),
    [anon_sym_mutable] = ACTIONS(2901),
    [anon_sym_constinit] = ACTIONS(2901),
    [anon_sym_consteval] = ACTIONS(2901),
    [anon_sym_alignas] = ACTIONS(2901),
    [anon_sym__Alignas] = ACTIONS(2901),
    [sym_primitive_type] = ACTIONS(2901),
    [anon_sym_enum] = ACTIONS(2901),
    [anon_sym_class] = ACTIONS(2901),
    [anon_sym_struct] = ACTIONS(2901),
    [anon_sym_union] = ACTIONS(2901),
    [anon_sym_if] = ACTIONS(2901),
    [anon_sym_else] = ACTIONS(2901),
    [anon_sym_switch] = ACTIONS(2901),
    [anon_sym_case] = ACTIONS(2901),
    [anon_sym_default] = ACTIONS(2901),
    [anon_sym_while] = ACTIONS(2901),
    [anon_sym_do] = ACTIONS(2901),
    [anon_sym_for] = ACTIONS(2901),
    [anon_sym_return] = ACTIONS(2901),
    [anon_sym_break] = ACTIONS(2901),
    [anon_sym_continue] = ACTIONS(2901),
    [anon_sym_goto] = ACTIONS(2901),
    [anon_sym___try] = ACTIONS(2901),
    [anon_sym___leave] = ACTIONS(2901),
    [anon_sym_not] = ACTIONS(2901),
    [anon_sym_compl] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2903),
    [anon_sym_PLUS_PLUS] = ACTIONS(2903),
    [anon_sym_sizeof] = ACTIONS(2901),
    [anon_sym___alignof__] = ACTIONS(2901),
    [anon_sym___alignof] = ACTIONS(2901),
    [anon_sym__alignof] = ACTIONS(2901),
    [anon_sym_alignof] = ACTIONS(2901),
    [anon_sym__Alignof] = ACTIONS(2901),
    [anon_sym_offsetof] = ACTIONS(2901),
    [anon_sym__Generic] = ACTIONS(2901),
    [anon_sym_asm] = ACTIONS(2901),
    [anon_sym___asm__] = ACTIONS(2901),
    [anon_sym___asm] = ACTIONS(2901),
    [sym_number_literal] = ACTIONS(2903),
    [anon_sym_L_SQUOTE] = ACTIONS(2903),
    [anon_sym_u_SQUOTE] = ACTIONS(2903),
    [anon_sym_U_SQUOTE] = ACTIONS(2903),
    [anon_sym_u8_SQUOTE] = ACTIONS(2903),
    [anon_sym_SQUOTE] = ACTIONS(2903),
    [anon_sym_L_DQUOTE] = ACTIONS(2903),
    [anon_sym_u_DQUOTE] = ACTIONS(2903),
    [anon_sym_U_DQUOTE] = ACTIONS(2903),
    [anon_sym_u8_DQUOTE] = ACTIONS(2903),
    [anon_sym_DQUOTE] = ACTIONS(2903),
    [sym_true] = ACTIONS(2901),
    [sym_false] = ACTIONS(2901),
    [anon_sym_NULL] = ACTIONS(2901),
    [anon_sym_nullptr] = ACTIONS(2901),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2901),
    [anon_sym_let] = ACTIONS(2901),
    [anon_sym_This] = ACTIONS(2901),
    [anon_sym_decltype] = ACTIONS(2901),
    [anon_sym_explicit] = ACTIONS(2901),
    [anon_sym_typename] = ACTIONS(2901),
    [anon_sym_template] = ACTIONS(2901),
    [anon_sym_operator] = ACTIONS(2901),
    [anon_sym_try] = ACTIONS(2901),
    [anon_sym_delete] = ACTIONS(2901),
    [anon_sym_throw] = ACTIONS(2901),
    [anon_sym_namespace] = ACTIONS(2901),
    [anon_sym_static_assert] = ACTIONS(2901),
    [anon_sym_concept] = ACTIONS(2901),
    [anon_sym_co_return] = ACTIONS(2901),
    [anon_sym_co_yield] = ACTIONS(2901),
    [anon_sym_catch] = ACTIONS(3946),
    [anon_sym_R_DQUOTE] = ACTIONS(2903),
    [anon_sym_LR_DQUOTE] = ACTIONS(2903),
    [anon_sym_uR_DQUOTE] = ACTIONS(2903),
    [anon_sym_UR_DQUOTE] = ACTIONS(2903),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2903),
    [anon_sym_co_await] = ACTIONS(2901),
    [anon_sym_new] = ACTIONS(2901),
    [anon_sym_requires] = ACTIONS(2901),
    [sym_this] = ACTIONS(2901),
    [anon_sym_discard] = ACTIONS(2901),
    [anon_sym_precise] = ACTIONS(2901),
    [anon_sym_shared] = ACTIONS(2901),
    [anon_sym_groupshared] = ACTIONS(2901),
    [anon_sym_uniform] = ACTIONS(2901),
    [anon_sym_row_major] = ACTIONS(2901),
    [anon_sym_column_major] = ACTIONS(2901),
    [anon_sym_globallycoherent] = ACTIONS(2901),
    [anon_sym_centroid] = ACTIONS(2901),
    [anon_sym_noperspective] = ACTIONS(2901),
    [anon_sym_nointerpolation] = ACTIONS(2901),
    [anon_sym_sample] = ACTIONS(2901),
    [anon_sym_linear] = ACTIONS(2901),
    [anon_sym_snorm] = ACTIONS(2901),
    [anon_sym_unorm] = ACTIONS(2901),
    [anon_sym_point] = ACTIONS(2901),
    [anon_sym_line] = ACTIONS(2901),
    [anon_sym_triangleadj] = ACTIONS(2901),
    [anon_sym_lineadj] = ACTIONS(2901),
    [anon_sym_triangle] = ACTIONS(2901),
    [anon_sym_cbuffer] = ACTIONS(2901),
    [anon_sym_interface] = ACTIONS(2901),
    [anon_sym_extension] = ACTIONS(2901),
  },
  [617] = {
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_include_token1] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token2] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [aux_sym_preproc_else_token1] = ACTIONS(3942),
    [aux_sym_preproc_elif_token1] = ACTIONS(3942),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_BANG] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym___cdecl] = ACTIONS(3942),
    [anon_sym___clrcall] = ACTIONS(3942),
    [anon_sym___stdcall] = ACTIONS(3942),
    [anon_sym___fastcall] = ACTIONS(3942),
    [anon_sym___thiscall] = ACTIONS(3942),
    [anon_sym___vectorcall] = ACTIONS(3942),
    [anon_sym_LBRACE] = ACTIONS(3944),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_switch] = ACTIONS(3942),
    [anon_sym_case] = ACTIONS(3942),
    [anon_sym_default] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_break] = ACTIONS(3942),
    [anon_sym_continue] = ACTIONS(3942),
    [anon_sym_goto] = ACTIONS(3942),
    [anon_sym___try] = ACTIONS(3942),
    [anon_sym___leave] = ACTIONS(3942),
    [anon_sym_not] = ACTIONS(3942),
    [anon_sym_compl] = ACTIONS(3942),
    [anon_sym_DASH_DASH] = ACTIONS(3944),
    [anon_sym_PLUS_PLUS] = ACTIONS(3944),
    [anon_sym_sizeof] = ACTIONS(3942),
    [anon_sym___alignof__] = ACTIONS(3942),
    [anon_sym___alignof] = ACTIONS(3942),
    [anon_sym__alignof] = ACTIONS(3942),
    [anon_sym_alignof] = ACTIONS(3942),
    [anon_sym__Alignof] = ACTIONS(3942),
    [anon_sym_offsetof] = ACTIONS(3942),
    [anon_sym__Generic] = ACTIONS(3942),
    [anon_sym_asm] = ACTIONS(3942),
    [anon_sym___asm__] = ACTIONS(3942),
    [anon_sym___asm] = ACTIONS(3942),
    [sym_number_literal] = ACTIONS(3944),
    [anon_sym_L_SQUOTE] = ACTIONS(3944),
    [anon_sym_u_SQUOTE] = ACTIONS(3944),
    [anon_sym_U_SQUOTE] = ACTIONS(3944),
    [anon_sym_u8_SQUOTE] = ACTIONS(3944),
    [anon_sym_SQUOTE] = ACTIONS(3944),
    [anon_sym_L_DQUOTE] = ACTIONS(3944),
    [anon_sym_u_DQUOTE] = ACTIONS(3944),
    [anon_sym_U_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE] = ACTIONS(3944),
    [sym_true] = ACTIONS(3942),
    [sym_false] = ACTIONS(3942),
    [anon_sym_NULL] = ACTIONS(3942),
    [anon_sym_nullptr] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_delete] = ACTIONS(3942),
    [anon_sym_throw] = ACTIONS(3942),
    [anon_sym_namespace] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_concept] = ACTIONS(3942),
    [anon_sym_co_return] = ACTIONS(3942),
    [anon_sym_co_yield] = ACTIONS(3942),
    [anon_sym_R_DQUOTE] = ACTIONS(3944),
    [anon_sym_LR_DQUOTE] = ACTIONS(3944),
    [anon_sym_uR_DQUOTE] = ACTIONS(3944),
    [anon_sym_UR_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3944),
    [anon_sym_co_await] = ACTIONS(3942),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_requires] = ACTIONS(3942),
    [sym_this] = ACTIONS(3942),
    [anon_sym_discard] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_cbuffer] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
  },
  [618] = {
    [sym_identifier] = ACTIONS(3949),
    [aux_sym_preproc_include_token1] = ACTIONS(3949),
    [aux_sym_preproc_def_token1] = ACTIONS(3949),
    [aux_sym_preproc_if_token1] = ACTIONS(3949),
    [aux_sym_preproc_if_token2] = ACTIONS(3949),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3949),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3949),
    [aux_sym_preproc_else_token1] = ACTIONS(3949),
    [aux_sym_preproc_elif_token1] = ACTIONS(3949),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3949),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3949),
    [sym_preproc_directive] = ACTIONS(3949),
    [anon_sym_LPAREN2] = ACTIONS(3951),
    [anon_sym_BANG] = ACTIONS(3951),
    [anon_sym_TILDE] = ACTIONS(3951),
    [anon_sym_DASH] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3949),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3949),
    [anon_sym_SEMI] = ACTIONS(3951),
    [anon_sym___extension__] = ACTIONS(3949),
    [anon_sym_typedef] = ACTIONS(3949),
    [anon_sym_in] = ACTIONS(3949),
    [anon_sym_out] = ACTIONS(3949),
    [anon_sym_inout] = ACTIONS(3949),
    [anon_sym_virtual] = ACTIONS(3949),
    [anon_sym_extern] = ACTIONS(3949),
    [anon_sym___attribute__] = ACTIONS(3949),
    [anon_sym___attribute] = ACTIONS(3949),
    [anon_sym_using] = ACTIONS(3949),
    [anon_sym_COLON_COLON] = ACTIONS(3951),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3951),
    [anon_sym___declspec] = ACTIONS(3949),
    [anon_sym___based] = ACTIONS(3949),
    [anon_sym___cdecl] = ACTIONS(3949),
    [anon_sym___clrcall] = ACTIONS(3949),
    [anon_sym___stdcall] = ACTIONS(3949),
    [anon_sym___fastcall] = ACTIONS(3949),
    [anon_sym___thiscall] = ACTIONS(3949),
    [anon_sym___vectorcall] = ACTIONS(3949),
    [anon_sym_LBRACE] = ACTIONS(3951),
    [anon_sym_signed] = ACTIONS(3949),
    [anon_sym_unsigned] = ACTIONS(3949),
    [anon_sym_long] = ACTIONS(3949),
    [anon_sym_short] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_static] = ACTIONS(3949),
    [anon_sym_register] = ACTIONS(3949),
    [anon_sym_inline] = ACTIONS(3949),
    [anon_sym___inline] = ACTIONS(3949),
    [anon_sym___inline__] = ACTIONS(3949),
    [anon_sym___forceinline] = ACTIONS(3949),
    [anon_sym_thread_local] = ACTIONS(3949),
    [anon_sym___thread] = ACTIONS(3949),
    [anon_sym_const] = ACTIONS(3949),
    [anon_sym_constexpr] = ACTIONS(3949),
    [anon_sym_volatile] = ACTIONS(3949),
    [anon_sym_restrict] = ACTIONS(3949),
    [anon_sym___restrict__] = ACTIONS(3949),
    [anon_sym__Atomic] = ACTIONS(3949),
    [anon_sym__Noreturn] = ACTIONS(3949),
    [anon_sym_noreturn] = ACTIONS(3949),
    [anon_sym__Nonnull] = ACTIONS(3949),
    [anon_sym_mutable] = ACTIONS(3949),
    [anon_sym_constinit] = ACTIONS(3949),
    [anon_sym_consteval] = ACTIONS(3949),
    [anon_sym_alignas] = ACTIONS(3949),
    [anon_sym__Alignas] = ACTIONS(3949),
    [sym_primitive_type] = ACTIONS(3949),
    [anon_sym_enum] = ACTIONS(3949),
    [anon_sym_class] = ACTIONS(3949),
    [anon_sym_struct] = ACTIONS(3949),
    [anon_sym_union] = ACTIONS(3949),
    [anon_sym_if] = ACTIONS(3949),
    [anon_sym_switch] = ACTIONS(3949),
    [anon_sym_case] = ACTIONS(3949),
    [anon_sym_default] = ACTIONS(3949),
    [anon_sym_while] = ACTIONS(3949),
    [anon_sym_do] = ACTIONS(3949),
    [anon_sym_for] = ACTIONS(3949),
    [anon_sym_return] = ACTIONS(3949),
    [anon_sym_break] = ACTIONS(3949),
    [anon_sym_continue] = ACTIONS(3949),
    [anon_sym_goto] = ACTIONS(3949),
    [anon_sym___try] = ACTIONS(3949),
    [anon_sym___leave] = ACTIONS(3949),
    [anon_sym_not] = ACTIONS(3949),
    [anon_sym_compl] = ACTIONS(3949),
    [anon_sym_DASH_DASH] = ACTIONS(3951),
    [anon_sym_PLUS_PLUS] = ACTIONS(3951),
    [anon_sym_sizeof] = ACTIONS(3949),
    [anon_sym___alignof__] = ACTIONS(3949),
    [anon_sym___alignof] = ACTIONS(3949),
    [anon_sym__alignof] = ACTIONS(3949),
    [anon_sym_alignof] = ACTIONS(3949),
    [anon_sym__Alignof] = ACTIONS(3949),
    [anon_sym_offsetof] = ACTIONS(3949),
    [anon_sym__Generic] = ACTIONS(3949),
    [anon_sym_asm] = ACTIONS(3949),
    [anon_sym___asm__] = ACTIONS(3949),
    [anon_sym___asm] = ACTIONS(3949),
    [sym_number_literal] = ACTIONS(3951),
    [anon_sym_L_SQUOTE] = ACTIONS(3951),
    [anon_sym_u_SQUOTE] = ACTIONS(3951),
    [anon_sym_U_SQUOTE] = ACTIONS(3951),
    [anon_sym_u8_SQUOTE] = ACTIONS(3951),
    [anon_sym_SQUOTE] = ACTIONS(3951),
    [anon_sym_L_DQUOTE] = ACTIONS(3951),
    [anon_sym_u_DQUOTE] = ACTIONS(3951),
    [anon_sym_U_DQUOTE] = ACTIONS(3951),
    [anon_sym_u8_DQUOTE] = ACTIONS(3951),
    [anon_sym_DQUOTE] = ACTIONS(3951),
    [sym_true] = ACTIONS(3949),
    [sym_false] = ACTIONS(3949),
    [anon_sym_NULL] = ACTIONS(3949),
    [anon_sym_nullptr] = ACTIONS(3949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_This] = ACTIONS(3949),
    [anon_sym_decltype] = ACTIONS(3949),
    [anon_sym_explicit] = ACTIONS(3949),
    [anon_sym_typename] = ACTIONS(3949),
    [anon_sym_template] = ACTIONS(3949),
    [anon_sym_operator] = ACTIONS(3949),
    [anon_sym_try] = ACTIONS(3949),
    [anon_sym_delete] = ACTIONS(3949),
    [anon_sym_throw] = ACTIONS(3949),
    [anon_sym_namespace] = ACTIONS(3949),
    [anon_sym_static_assert] = ACTIONS(3949),
    [anon_sym_concept] = ACTIONS(3949),
    [anon_sym_co_return] = ACTIONS(3949),
    [anon_sym_co_yield] = ACTIONS(3949),
    [anon_sym_R_DQUOTE] = ACTIONS(3951),
    [anon_sym_LR_DQUOTE] = ACTIONS(3951),
    [anon_sym_uR_DQUOTE] = ACTIONS(3951),
    [anon_sym_UR_DQUOTE] = ACTIONS(3951),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3951),
    [anon_sym_co_await] = ACTIONS(3949),
    [anon_sym_new] = ACTIONS(3949),
    [anon_sym_requires] = ACTIONS(3949),
    [sym_this] = ACTIONS(3949),
    [anon_sym_discard] = ACTIONS(3949),
    [anon_sym_precise] = ACTIONS(3949),
    [anon_sym_shared] = ACTIONS(3949),
    [anon_sym_groupshared] = ACTIONS(3949),
    [anon_sym_uniform] = ACTIONS(3949),
    [anon_sym_row_major] = ACTIONS(3949),
    [anon_sym_column_major] = ACTIONS(3949),
    [anon_sym_globallycoherent] = ACTIONS(3949),
    [anon_sym_centroid] = ACTIONS(3949),
    [anon_sym_noperspective] = ACTIONS(3949),
    [anon_sym_nointerpolation] = ACTIONS(3949),
    [anon_sym_sample] = ACTIONS(3949),
    [anon_sym_linear] = ACTIONS(3949),
    [anon_sym_snorm] = ACTIONS(3949),
    [anon_sym_unorm] = ACTIONS(3949),
    [anon_sym_point] = ACTIONS(3949),
    [anon_sym_line] = ACTIONS(3949),
    [anon_sym_triangleadj] = ACTIONS(3949),
    [anon_sym_lineadj] = ACTIONS(3949),
    [anon_sym_triangle] = ACTIONS(3949),
    [anon_sym_cbuffer] = ACTIONS(3949),
    [anon_sym_interface] = ACTIONS(3949),
    [anon_sym_extension] = ACTIONS(3949),
  },
  [619] = {
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_include_token1] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token2] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [aux_sym_preproc_else_token1] = ACTIONS(3942),
    [aux_sym_preproc_elif_token1] = ACTIONS(3942),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_BANG] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym___cdecl] = ACTIONS(3942),
    [anon_sym___clrcall] = ACTIONS(3942),
    [anon_sym___stdcall] = ACTIONS(3942),
    [anon_sym___fastcall] = ACTIONS(3942),
    [anon_sym___thiscall] = ACTIONS(3942),
    [anon_sym___vectorcall] = ACTIONS(3942),
    [anon_sym_LBRACE] = ACTIONS(3944),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_switch] = ACTIONS(3942),
    [anon_sym_case] = ACTIONS(3942),
    [anon_sym_default] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_break] = ACTIONS(3942),
    [anon_sym_continue] = ACTIONS(3942),
    [anon_sym_goto] = ACTIONS(3942),
    [anon_sym___try] = ACTIONS(3942),
    [anon_sym___leave] = ACTIONS(3942),
    [anon_sym_not] = ACTIONS(3942),
    [anon_sym_compl] = ACTIONS(3942),
    [anon_sym_DASH_DASH] = ACTIONS(3944),
    [anon_sym_PLUS_PLUS] = ACTIONS(3944),
    [anon_sym_sizeof] = ACTIONS(3942),
    [anon_sym___alignof__] = ACTIONS(3942),
    [anon_sym___alignof] = ACTIONS(3942),
    [anon_sym__alignof] = ACTIONS(3942),
    [anon_sym_alignof] = ACTIONS(3942),
    [anon_sym__Alignof] = ACTIONS(3942),
    [anon_sym_offsetof] = ACTIONS(3942),
    [anon_sym__Generic] = ACTIONS(3942),
    [anon_sym_asm] = ACTIONS(3942),
    [anon_sym___asm__] = ACTIONS(3942),
    [anon_sym___asm] = ACTIONS(3942),
    [sym_number_literal] = ACTIONS(3944),
    [anon_sym_L_SQUOTE] = ACTIONS(3944),
    [anon_sym_u_SQUOTE] = ACTIONS(3944),
    [anon_sym_U_SQUOTE] = ACTIONS(3944),
    [anon_sym_u8_SQUOTE] = ACTIONS(3944),
    [anon_sym_SQUOTE] = ACTIONS(3944),
    [anon_sym_L_DQUOTE] = ACTIONS(3944),
    [anon_sym_u_DQUOTE] = ACTIONS(3944),
    [anon_sym_U_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE] = ACTIONS(3944),
    [sym_true] = ACTIONS(3942),
    [sym_false] = ACTIONS(3942),
    [anon_sym_NULL] = ACTIONS(3942),
    [anon_sym_nullptr] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_delete] = ACTIONS(3942),
    [anon_sym_throw] = ACTIONS(3942),
    [anon_sym_namespace] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_concept] = ACTIONS(3942),
    [anon_sym_co_return] = ACTIONS(3942),
    [anon_sym_co_yield] = ACTIONS(3942),
    [anon_sym_R_DQUOTE] = ACTIONS(3944),
    [anon_sym_LR_DQUOTE] = ACTIONS(3944),
    [anon_sym_uR_DQUOTE] = ACTIONS(3944),
    [anon_sym_UR_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3944),
    [anon_sym_co_await] = ACTIONS(3942),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_requires] = ACTIONS(3942),
    [sym_this] = ACTIONS(3942),
    [anon_sym_discard] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_cbuffer] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
  },
  [620] = {
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_include_token1] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token2] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [aux_sym_preproc_else_token1] = ACTIONS(3942),
    [aux_sym_preproc_elif_token1] = ACTIONS(3942),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_BANG] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym___cdecl] = ACTIONS(3942),
    [anon_sym___clrcall] = ACTIONS(3942),
    [anon_sym___stdcall] = ACTIONS(3942),
    [anon_sym___fastcall] = ACTIONS(3942),
    [anon_sym___thiscall] = ACTIONS(3942),
    [anon_sym___vectorcall] = ACTIONS(3942),
    [anon_sym_LBRACE] = ACTIONS(3944),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_switch] = ACTIONS(3942),
    [anon_sym_case] = ACTIONS(3942),
    [anon_sym_default] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_break] = ACTIONS(3942),
    [anon_sym_continue] = ACTIONS(3942),
    [anon_sym_goto] = ACTIONS(3942),
    [anon_sym___try] = ACTIONS(3942),
    [anon_sym___leave] = ACTIONS(3942),
    [anon_sym_not] = ACTIONS(3942),
    [anon_sym_compl] = ACTIONS(3942),
    [anon_sym_DASH_DASH] = ACTIONS(3944),
    [anon_sym_PLUS_PLUS] = ACTIONS(3944),
    [anon_sym_sizeof] = ACTIONS(3942),
    [anon_sym___alignof__] = ACTIONS(3942),
    [anon_sym___alignof] = ACTIONS(3942),
    [anon_sym__alignof] = ACTIONS(3942),
    [anon_sym_alignof] = ACTIONS(3942),
    [anon_sym__Alignof] = ACTIONS(3942),
    [anon_sym_offsetof] = ACTIONS(3942),
    [anon_sym__Generic] = ACTIONS(3942),
    [anon_sym_asm] = ACTIONS(3942),
    [anon_sym___asm__] = ACTIONS(3942),
    [anon_sym___asm] = ACTIONS(3942),
    [sym_number_literal] = ACTIONS(3944),
    [anon_sym_L_SQUOTE] = ACTIONS(3944),
    [anon_sym_u_SQUOTE] = ACTIONS(3944),
    [anon_sym_U_SQUOTE] = ACTIONS(3944),
    [anon_sym_u8_SQUOTE] = ACTIONS(3944),
    [anon_sym_SQUOTE] = ACTIONS(3944),
    [anon_sym_L_DQUOTE] = ACTIONS(3944),
    [anon_sym_u_DQUOTE] = ACTIONS(3944),
    [anon_sym_U_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE] = ACTIONS(3944),
    [sym_true] = ACTIONS(3942),
    [sym_false] = ACTIONS(3942),
    [anon_sym_NULL] = ACTIONS(3942),
    [anon_sym_nullptr] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_delete] = ACTIONS(3942),
    [anon_sym_throw] = ACTIONS(3942),
    [anon_sym_namespace] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_concept] = ACTIONS(3942),
    [anon_sym_co_return] = ACTIONS(3942),
    [anon_sym_co_yield] = ACTIONS(3942),
    [anon_sym_R_DQUOTE] = ACTIONS(3944),
    [anon_sym_LR_DQUOTE] = ACTIONS(3944),
    [anon_sym_uR_DQUOTE] = ACTIONS(3944),
    [anon_sym_UR_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3944),
    [anon_sym_co_await] = ACTIONS(3942),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_requires] = ACTIONS(3942),
    [sym_this] = ACTIONS(3942),
    [anon_sym_discard] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_cbuffer] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
  },
  [621] = {
    [sym_identifier] = ACTIONS(3953),
    [aux_sym_preproc_include_token1] = ACTIONS(3953),
    [aux_sym_preproc_def_token1] = ACTIONS(3953),
    [aux_sym_preproc_if_token1] = ACTIONS(3953),
    [aux_sym_preproc_if_token2] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3953),
    [aux_sym_preproc_else_token1] = ACTIONS(3953),
    [aux_sym_preproc_elif_token1] = ACTIONS(3953),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3953),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3953),
    [sym_preproc_directive] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_BANG] = ACTIONS(3955),
    [anon_sym_TILDE] = ACTIONS(3955),
    [anon_sym_DASH] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3953),
    [anon_sym_STAR] = ACTIONS(3955),
    [anon_sym_AMP_AMP] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_SEMI] = ACTIONS(3955),
    [anon_sym___extension__] = ACTIONS(3953),
    [anon_sym_typedef] = ACTIONS(3953),
    [anon_sym_in] = ACTIONS(3953),
    [anon_sym_out] = ACTIONS(3953),
    [anon_sym_inout] = ACTIONS(3953),
    [anon_sym_virtual] = ACTIONS(3953),
    [anon_sym_extern] = ACTIONS(3953),
    [anon_sym___attribute__] = ACTIONS(3953),
    [anon_sym___attribute] = ACTIONS(3953),
    [anon_sym_using] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3955),
    [anon_sym___declspec] = ACTIONS(3953),
    [anon_sym___based] = ACTIONS(3953),
    [anon_sym___cdecl] = ACTIONS(3953),
    [anon_sym___clrcall] = ACTIONS(3953),
    [anon_sym___stdcall] = ACTIONS(3953),
    [anon_sym___fastcall] = ACTIONS(3953),
    [anon_sym___thiscall] = ACTIONS(3953),
    [anon_sym___vectorcall] = ACTIONS(3953),
    [anon_sym_LBRACE] = ACTIONS(3955),
    [anon_sym_signed] = ACTIONS(3953),
    [anon_sym_unsigned] = ACTIONS(3953),
    [anon_sym_long] = ACTIONS(3953),
    [anon_sym_short] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_static] = ACTIONS(3953),
    [anon_sym_register] = ACTIONS(3953),
    [anon_sym_inline] = ACTIONS(3953),
    [anon_sym___inline] = ACTIONS(3953),
    [anon_sym___inline__] = ACTIONS(3953),
    [anon_sym___forceinline] = ACTIONS(3953),
    [anon_sym_thread_local] = ACTIONS(3953),
    [anon_sym___thread] = ACTIONS(3953),
    [anon_sym_const] = ACTIONS(3953),
    [anon_sym_constexpr] = ACTIONS(3953),
    [anon_sym_volatile] = ACTIONS(3953),
    [anon_sym_restrict] = ACTIONS(3953),
    [anon_sym___restrict__] = ACTIONS(3953),
    [anon_sym__Atomic] = ACTIONS(3953),
    [anon_sym__Noreturn] = ACTIONS(3953),
    [anon_sym_noreturn] = ACTIONS(3953),
    [anon_sym__Nonnull] = ACTIONS(3953),
    [anon_sym_mutable] = ACTIONS(3953),
    [anon_sym_constinit] = ACTIONS(3953),
    [anon_sym_consteval] = ACTIONS(3953),
    [anon_sym_alignas] = ACTIONS(3953),
    [anon_sym__Alignas] = ACTIONS(3953),
    [sym_primitive_type] = ACTIONS(3953),
    [anon_sym_enum] = ACTIONS(3953),
    [anon_sym_class] = ACTIONS(3953),
    [anon_sym_struct] = ACTIONS(3953),
    [anon_sym_union] = ACTIONS(3953),
    [anon_sym_if] = ACTIONS(3953),
    [anon_sym_switch] = ACTIONS(3953),
    [anon_sym_case] = ACTIONS(3953),
    [anon_sym_default] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3953),
    [anon_sym_do] = ACTIONS(3953),
    [anon_sym_for] = ACTIONS(3953),
    [anon_sym_return] = ACTIONS(3953),
    [anon_sym_break] = ACTIONS(3953),
    [anon_sym_continue] = ACTIONS(3953),
    [anon_sym_goto] = ACTIONS(3953),
    [anon_sym___try] = ACTIONS(3953),
    [anon_sym___leave] = ACTIONS(3953),
    [anon_sym_not] = ACTIONS(3953),
    [anon_sym_compl] = ACTIONS(3953),
    [anon_sym_DASH_DASH] = ACTIONS(3955),
    [anon_sym_PLUS_PLUS] = ACTIONS(3955),
    [anon_sym_sizeof] = ACTIONS(3953),
    [anon_sym___alignof__] = ACTIONS(3953),
    [anon_sym___alignof] = ACTIONS(3953),
    [anon_sym__alignof] = ACTIONS(3953),
    [anon_sym_alignof] = ACTIONS(3953),
    [anon_sym__Alignof] = ACTIONS(3953),
    [anon_sym_offsetof] = ACTIONS(3953),
    [anon_sym__Generic] = ACTIONS(3953),
    [anon_sym_asm] = ACTIONS(3953),
    [anon_sym___asm__] = ACTIONS(3953),
    [anon_sym___asm] = ACTIONS(3953),
    [sym_number_literal] = ACTIONS(3955),
    [anon_sym_L_SQUOTE] = ACTIONS(3955),
    [anon_sym_u_SQUOTE] = ACTIONS(3955),
    [anon_sym_U_SQUOTE] = ACTIONS(3955),
    [anon_sym_u8_SQUOTE] = ACTIONS(3955),
    [anon_sym_SQUOTE] = ACTIONS(3955),
    [anon_sym_L_DQUOTE] = ACTIONS(3955),
    [anon_sym_u_DQUOTE] = ACTIONS(3955),
    [anon_sym_U_DQUOTE] = ACTIONS(3955),
    [anon_sym_u8_DQUOTE] = ACTIONS(3955),
    [anon_sym_DQUOTE] = ACTIONS(3955),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [anon_sym_NULL] = ACTIONS(3953),
    [anon_sym_nullptr] = ACTIONS(3953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_This] = ACTIONS(3953),
    [anon_sym_decltype] = ACTIONS(3953),
    [anon_sym_explicit] = ACTIONS(3953),
    [anon_sym_typename] = ACTIONS(3953),
    [anon_sym_template] = ACTIONS(3953),
    [anon_sym_operator] = ACTIONS(3953),
    [anon_sym_try] = ACTIONS(3953),
    [anon_sym_delete] = ACTIONS(3953),
    [anon_sym_throw] = ACTIONS(3953),
    [anon_sym_namespace] = ACTIONS(3953),
    [anon_sym_static_assert] = ACTIONS(3953),
    [anon_sym_concept] = ACTIONS(3953),
    [anon_sym_co_return] = ACTIONS(3953),
    [anon_sym_co_yield] = ACTIONS(3953),
    [anon_sym_R_DQUOTE] = ACTIONS(3955),
    [anon_sym_LR_DQUOTE] = ACTIONS(3955),
    [anon_sym_uR_DQUOTE] = ACTIONS(3955),
    [anon_sym_UR_DQUOTE] = ACTIONS(3955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3955),
    [anon_sym_co_await] = ACTIONS(3953),
    [anon_sym_new] = ACTIONS(3953),
    [anon_sym_requires] = ACTIONS(3953),
    [sym_this] = ACTIONS(3953),
    [anon_sym_discard] = ACTIONS(3953),
    [anon_sym_precise] = ACTIONS(3953),
    [anon_sym_shared] = ACTIONS(3953),
    [anon_sym_groupshared] = ACTIONS(3953),
    [anon_sym_uniform] = ACTIONS(3953),
    [anon_sym_row_major] = ACTIONS(3953),
    [anon_sym_column_major] = ACTIONS(3953),
    [anon_sym_globallycoherent] = ACTIONS(3953),
    [anon_sym_centroid] = ACTIONS(3953),
    [anon_sym_noperspective] = ACTIONS(3953),
    [anon_sym_nointerpolation] = ACTIONS(3953),
    [anon_sym_sample] = ACTIONS(3953),
    [anon_sym_linear] = ACTIONS(3953),
    [anon_sym_snorm] = ACTIONS(3953),
    [anon_sym_unorm] = ACTIONS(3953),
    [anon_sym_point] = ACTIONS(3953),
    [anon_sym_line] = ACTIONS(3953),
    [anon_sym_triangleadj] = ACTIONS(3953),
    [anon_sym_lineadj] = ACTIONS(3953),
    [anon_sym_triangle] = ACTIONS(3953),
    [anon_sym_cbuffer] = ACTIONS(3953),
    [anon_sym_interface] = ACTIONS(3953),
    [anon_sym_extension] = ACTIONS(3953),
  },
  [622] = {
    [sym_type_qualifier] = STATE(622),
    [sym_alignas_qualifier] = STATE(824),
    [aux_sym__type_definition_type_repeat1] = STATE(622),
    [sym_identifier] = ACTIONS(3683),
    [aux_sym_preproc_include_token1] = ACTIONS(3683),
    [aux_sym_preproc_def_token1] = ACTIONS(3683),
    [aux_sym_preproc_if_token1] = ACTIONS(3683),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3683),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3683),
    [sym_preproc_directive] = ACTIONS(3683),
    [anon_sym_LPAREN2] = ACTIONS(3681),
    [anon_sym_BANG] = ACTIONS(3681),
    [anon_sym_TILDE] = ACTIONS(3681),
    [anon_sym_DASH] = ACTIONS(3683),
    [anon_sym_PLUS] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(3681),
    [anon_sym_AMP_AMP] = ACTIONS(3681),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_SEMI] = ACTIONS(3681),
    [anon_sym___extension__] = ACTIONS(3957),
    [anon_sym_typedef] = ACTIONS(3683),
    [anon_sym_in] = ACTIONS(3683),
    [anon_sym_out] = ACTIONS(3683),
    [anon_sym_inout] = ACTIONS(3683),
    [anon_sym_virtual] = ACTIONS(3683),
    [anon_sym_extern] = ACTIONS(3683),
    [anon_sym___attribute__] = ACTIONS(3683),
    [anon_sym___attribute] = ACTIONS(3683),
    [anon_sym_using] = ACTIONS(3683),
    [anon_sym_COLON_COLON] = ACTIONS(3681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3681),
    [anon_sym___declspec] = ACTIONS(3683),
    [anon_sym___based] = ACTIONS(3683),
    [anon_sym___cdecl] = ACTIONS(3683),
    [anon_sym___clrcall] = ACTIONS(3683),
    [anon_sym___stdcall] = ACTIONS(3683),
    [anon_sym___fastcall] = ACTIONS(3683),
    [anon_sym___thiscall] = ACTIONS(3683),
    [anon_sym___vectorcall] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3681),
    [anon_sym_RBRACE] = ACTIONS(3681),
    [anon_sym_signed] = ACTIONS(3683),
    [anon_sym_unsigned] = ACTIONS(3683),
    [anon_sym_long] = ACTIONS(3683),
    [anon_sym_short] = ACTIONS(3683),
    [anon_sym_LBRACK] = ACTIONS(3683),
    [anon_sym_static] = ACTIONS(3683),
    [anon_sym_register] = ACTIONS(3683),
    [anon_sym_inline] = ACTIONS(3683),
    [anon_sym___inline] = ACTIONS(3683),
    [anon_sym___inline__] = ACTIONS(3683),
    [anon_sym___forceinline] = ACTIONS(3683),
    [anon_sym_thread_local] = ACTIONS(3683),
    [anon_sym___thread] = ACTIONS(3683),
    [anon_sym_const] = ACTIONS(3957),
    [anon_sym_constexpr] = ACTIONS(3957),
    [anon_sym_volatile] = ACTIONS(3957),
    [anon_sym_restrict] = ACTIONS(3957),
    [anon_sym___restrict__] = ACTIONS(3957),
    [anon_sym__Atomic] = ACTIONS(3957),
    [anon_sym__Noreturn] = ACTIONS(3957),
    [anon_sym_noreturn] = ACTIONS(3957),
    [anon_sym__Nonnull] = ACTIONS(3957),
    [anon_sym_mutable] = ACTIONS(3957),
    [anon_sym_constinit] = ACTIONS(3957),
    [anon_sym_consteval] = ACTIONS(3957),
    [anon_sym_alignas] = ACTIONS(3960),
    [anon_sym__Alignas] = ACTIONS(3960),
    [sym_primitive_type] = ACTIONS(3683),
    [anon_sym_enum] = ACTIONS(3683),
    [anon_sym_class] = ACTIONS(3683),
    [anon_sym_struct] = ACTIONS(3683),
    [anon_sym_union] = ACTIONS(3683),
    [anon_sym_if] = ACTIONS(3683),
    [anon_sym_switch] = ACTIONS(3683),
    [anon_sym_case] = ACTIONS(3683),
    [anon_sym_default] = ACTIONS(3683),
    [anon_sym_while] = ACTIONS(3683),
    [anon_sym_do] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3683),
    [anon_sym_return] = ACTIONS(3683),
    [anon_sym_break] = ACTIONS(3683),
    [anon_sym_continue] = ACTIONS(3683),
    [anon_sym_goto] = ACTIONS(3683),
    [anon_sym___try] = ACTIONS(3683),
    [anon_sym___leave] = ACTIONS(3683),
    [anon_sym_not] = ACTIONS(3683),
    [anon_sym_compl] = ACTIONS(3683),
    [anon_sym_DASH_DASH] = ACTIONS(3681),
    [anon_sym_PLUS_PLUS] = ACTIONS(3681),
    [anon_sym_sizeof] = ACTIONS(3683),
    [anon_sym___alignof__] = ACTIONS(3683),
    [anon_sym___alignof] = ACTIONS(3683),
    [anon_sym__alignof] = ACTIONS(3683),
    [anon_sym_alignof] = ACTIONS(3683),
    [anon_sym__Alignof] = ACTIONS(3683),
    [anon_sym_offsetof] = ACTIONS(3683),
    [anon_sym__Generic] = ACTIONS(3683),
    [anon_sym_asm] = ACTIONS(3683),
    [anon_sym___asm__] = ACTIONS(3683),
    [anon_sym___asm] = ACTIONS(3683),
    [anon_sym_DOT] = ACTIONS(3683),
    [sym_number_literal] = ACTIONS(3681),
    [anon_sym_L_SQUOTE] = ACTIONS(3681),
    [anon_sym_u_SQUOTE] = ACTIONS(3681),
    [anon_sym_U_SQUOTE] = ACTIONS(3681),
    [anon_sym_u8_SQUOTE] = ACTIONS(3681),
    [anon_sym_SQUOTE] = ACTIONS(3681),
    [anon_sym_L_DQUOTE] = ACTIONS(3681),
    [anon_sym_u_DQUOTE] = ACTIONS(3681),
    [anon_sym_U_DQUOTE] = ACTIONS(3681),
    [anon_sym_u8_DQUOTE] = ACTIONS(3681),
    [anon_sym_DQUOTE] = ACTIONS(3681),
    [sym_true] = ACTIONS(3683),
    [sym_false] = ACTIONS(3683),
    [anon_sym_NULL] = ACTIONS(3683),
    [anon_sym_nullptr] = ACTIONS(3683),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3683),
    [anon_sym_let] = ACTIONS(3683),
    [anon_sym_This] = ACTIONS(3683),
    [anon_sym_decltype] = ACTIONS(3683),
    [anon_sym_explicit] = ACTIONS(3683),
    [anon_sym_typename] = ACTIONS(3683),
    [anon_sym_template] = ACTIONS(3683),
    [anon_sym_operator] = ACTIONS(3683),
    [anon_sym_try] = ACTIONS(3683),
    [anon_sym_delete] = ACTIONS(3683),
    [anon_sym_throw] = ACTIONS(3683),
    [anon_sym_namespace] = ACTIONS(3683),
    [anon_sym_static_assert] = ACTIONS(3683),
    [anon_sym_concept] = ACTIONS(3683),
    [anon_sym_co_return] = ACTIONS(3683),
    [anon_sym_co_yield] = ACTIONS(3683),
    [anon_sym_R_DQUOTE] = ACTIONS(3681),
    [anon_sym_LR_DQUOTE] = ACTIONS(3681),
    [anon_sym_uR_DQUOTE] = ACTIONS(3681),
    [anon_sym_UR_DQUOTE] = ACTIONS(3681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3681),
    [anon_sym_co_await] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3683),
    [anon_sym_requires] = ACTIONS(3683),
    [sym_this] = ACTIONS(3683),
    [anon_sym_discard] = ACTIONS(3683),
    [anon_sym_precise] = ACTIONS(3683),
    [anon_sym_shared] = ACTIONS(3683),
    [anon_sym_groupshared] = ACTIONS(3683),
    [anon_sym_uniform] = ACTIONS(3683),
    [anon_sym_row_major] = ACTIONS(3683),
    [anon_sym_column_major] = ACTIONS(3683),
    [anon_sym_globallycoherent] = ACTIONS(3683),
    [anon_sym_centroid] = ACTIONS(3683),
    [anon_sym_noperspective] = ACTIONS(3683),
    [anon_sym_nointerpolation] = ACTIONS(3683),
    [anon_sym_sample] = ACTIONS(3683),
    [anon_sym_linear] = ACTIONS(3683),
    [anon_sym_snorm] = ACTIONS(3683),
    [anon_sym_unorm] = ACTIONS(3683),
    [anon_sym_point] = ACTIONS(3683),
    [anon_sym_line] = ACTIONS(3683),
    [anon_sym_triangleadj] = ACTIONS(3683),
    [anon_sym_lineadj] = ACTIONS(3683),
    [anon_sym_triangle] = ACTIONS(3683),
    [anon_sym_cbuffer] = ACTIONS(3683),
    [anon_sym_interface] = ACTIONS(3683),
    [anon_sym_extension] = ACTIONS(3683),
  },
  [623] = {
    [sym_identifier] = ACTIONS(3953),
    [aux_sym_preproc_include_token1] = ACTIONS(3953),
    [aux_sym_preproc_def_token1] = ACTIONS(3953),
    [aux_sym_preproc_if_token1] = ACTIONS(3953),
    [aux_sym_preproc_if_token2] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3953),
    [aux_sym_preproc_else_token1] = ACTIONS(3953),
    [aux_sym_preproc_elif_token1] = ACTIONS(3953),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3953),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3953),
    [sym_preproc_directive] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_BANG] = ACTIONS(3955),
    [anon_sym_TILDE] = ACTIONS(3955),
    [anon_sym_DASH] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3953),
    [anon_sym_STAR] = ACTIONS(3955),
    [anon_sym_AMP_AMP] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_SEMI] = ACTIONS(3955),
    [anon_sym___extension__] = ACTIONS(3953),
    [anon_sym_typedef] = ACTIONS(3953),
    [anon_sym_in] = ACTIONS(3953),
    [anon_sym_out] = ACTIONS(3953),
    [anon_sym_inout] = ACTIONS(3953),
    [anon_sym_virtual] = ACTIONS(3953),
    [anon_sym_extern] = ACTIONS(3953),
    [anon_sym___attribute__] = ACTIONS(3953),
    [anon_sym___attribute] = ACTIONS(3953),
    [anon_sym_using] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3955),
    [anon_sym___declspec] = ACTIONS(3953),
    [anon_sym___based] = ACTIONS(3953),
    [anon_sym___cdecl] = ACTIONS(3953),
    [anon_sym___clrcall] = ACTIONS(3953),
    [anon_sym___stdcall] = ACTIONS(3953),
    [anon_sym___fastcall] = ACTIONS(3953),
    [anon_sym___thiscall] = ACTIONS(3953),
    [anon_sym___vectorcall] = ACTIONS(3953),
    [anon_sym_LBRACE] = ACTIONS(3955),
    [anon_sym_signed] = ACTIONS(3953),
    [anon_sym_unsigned] = ACTIONS(3953),
    [anon_sym_long] = ACTIONS(3953),
    [anon_sym_short] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_static] = ACTIONS(3953),
    [anon_sym_register] = ACTIONS(3953),
    [anon_sym_inline] = ACTIONS(3953),
    [anon_sym___inline] = ACTIONS(3953),
    [anon_sym___inline__] = ACTIONS(3953),
    [anon_sym___forceinline] = ACTIONS(3953),
    [anon_sym_thread_local] = ACTIONS(3953),
    [anon_sym___thread] = ACTIONS(3953),
    [anon_sym_const] = ACTIONS(3953),
    [anon_sym_constexpr] = ACTIONS(3953),
    [anon_sym_volatile] = ACTIONS(3953),
    [anon_sym_restrict] = ACTIONS(3953),
    [anon_sym___restrict__] = ACTIONS(3953),
    [anon_sym__Atomic] = ACTIONS(3953),
    [anon_sym__Noreturn] = ACTIONS(3953),
    [anon_sym_noreturn] = ACTIONS(3953),
    [anon_sym__Nonnull] = ACTIONS(3953),
    [anon_sym_mutable] = ACTIONS(3953),
    [anon_sym_constinit] = ACTIONS(3953),
    [anon_sym_consteval] = ACTIONS(3953),
    [anon_sym_alignas] = ACTIONS(3953),
    [anon_sym__Alignas] = ACTIONS(3953),
    [sym_primitive_type] = ACTIONS(3953),
    [anon_sym_enum] = ACTIONS(3953),
    [anon_sym_class] = ACTIONS(3953),
    [anon_sym_struct] = ACTIONS(3953),
    [anon_sym_union] = ACTIONS(3953),
    [anon_sym_if] = ACTIONS(3953),
    [anon_sym_switch] = ACTIONS(3953),
    [anon_sym_case] = ACTIONS(3953),
    [anon_sym_default] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3953),
    [anon_sym_do] = ACTIONS(3953),
    [anon_sym_for] = ACTIONS(3953),
    [anon_sym_return] = ACTIONS(3953),
    [anon_sym_break] = ACTIONS(3953),
    [anon_sym_continue] = ACTIONS(3953),
    [anon_sym_goto] = ACTIONS(3953),
    [anon_sym___try] = ACTIONS(3953),
    [anon_sym___leave] = ACTIONS(3953),
    [anon_sym_not] = ACTIONS(3953),
    [anon_sym_compl] = ACTIONS(3953),
    [anon_sym_DASH_DASH] = ACTIONS(3955),
    [anon_sym_PLUS_PLUS] = ACTIONS(3955),
    [anon_sym_sizeof] = ACTIONS(3953),
    [anon_sym___alignof__] = ACTIONS(3953),
    [anon_sym___alignof] = ACTIONS(3953),
    [anon_sym__alignof] = ACTIONS(3953),
    [anon_sym_alignof] = ACTIONS(3953),
    [anon_sym__Alignof] = ACTIONS(3953),
    [anon_sym_offsetof] = ACTIONS(3953),
    [anon_sym__Generic] = ACTIONS(3953),
    [anon_sym_asm] = ACTIONS(3953),
    [anon_sym___asm__] = ACTIONS(3953),
    [anon_sym___asm] = ACTIONS(3953),
    [sym_number_literal] = ACTIONS(3955),
    [anon_sym_L_SQUOTE] = ACTIONS(3955),
    [anon_sym_u_SQUOTE] = ACTIONS(3955),
    [anon_sym_U_SQUOTE] = ACTIONS(3955),
    [anon_sym_u8_SQUOTE] = ACTIONS(3955),
    [anon_sym_SQUOTE] = ACTIONS(3955),
    [anon_sym_L_DQUOTE] = ACTIONS(3955),
    [anon_sym_u_DQUOTE] = ACTIONS(3955),
    [anon_sym_U_DQUOTE] = ACTIONS(3955),
    [anon_sym_u8_DQUOTE] = ACTIONS(3955),
    [anon_sym_DQUOTE] = ACTIONS(3955),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [anon_sym_NULL] = ACTIONS(3953),
    [anon_sym_nullptr] = ACTIONS(3953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_This] = ACTIONS(3953),
    [anon_sym_decltype] = ACTIONS(3953),
    [anon_sym_explicit] = ACTIONS(3953),
    [anon_sym_typename] = ACTIONS(3953),
    [anon_sym_template] = ACTIONS(3953),
    [anon_sym_operator] = ACTIONS(3953),
    [anon_sym_try] = ACTIONS(3953),
    [anon_sym_delete] = ACTIONS(3953),
    [anon_sym_throw] = ACTIONS(3953),
    [anon_sym_namespace] = ACTIONS(3953),
    [anon_sym_static_assert] = ACTIONS(3953),
    [anon_sym_concept] = ACTIONS(3953),
    [anon_sym_co_return] = ACTIONS(3953),
    [anon_sym_co_yield] = ACTIONS(3953),
    [anon_sym_R_DQUOTE] = ACTIONS(3955),
    [anon_sym_LR_DQUOTE] = ACTIONS(3955),
    [anon_sym_uR_DQUOTE] = ACTIONS(3955),
    [anon_sym_UR_DQUOTE] = ACTIONS(3955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3955),
    [anon_sym_co_await] = ACTIONS(3953),
    [anon_sym_new] = ACTIONS(3953),
    [anon_sym_requires] = ACTIONS(3953),
    [sym_this] = ACTIONS(3953),
    [anon_sym_discard] = ACTIONS(3953),
    [anon_sym_precise] = ACTIONS(3953),
    [anon_sym_shared] = ACTIONS(3953),
    [anon_sym_groupshared] = ACTIONS(3953),
    [anon_sym_uniform] = ACTIONS(3953),
    [anon_sym_row_major] = ACTIONS(3953),
    [anon_sym_column_major] = ACTIONS(3953),
    [anon_sym_globallycoherent] = ACTIONS(3953),
    [anon_sym_centroid] = ACTIONS(3953),
    [anon_sym_noperspective] = ACTIONS(3953),
    [anon_sym_nointerpolation] = ACTIONS(3953),
    [anon_sym_sample] = ACTIONS(3953),
    [anon_sym_linear] = ACTIONS(3953),
    [anon_sym_snorm] = ACTIONS(3953),
    [anon_sym_unorm] = ACTIONS(3953),
    [anon_sym_point] = ACTIONS(3953),
    [anon_sym_line] = ACTIONS(3953),
    [anon_sym_triangleadj] = ACTIONS(3953),
    [anon_sym_lineadj] = ACTIONS(3953),
    [anon_sym_triangle] = ACTIONS(3953),
    [anon_sym_cbuffer] = ACTIONS(3953),
    [anon_sym_interface] = ACTIONS(3953),
    [anon_sym_extension] = ACTIONS(3953),
  },
  [624] = {
    [sym_identifier] = ACTIONS(3963),
    [aux_sym_preproc_include_token1] = ACTIONS(3963),
    [aux_sym_preproc_def_token1] = ACTIONS(3963),
    [aux_sym_preproc_if_token1] = ACTIONS(3963),
    [aux_sym_preproc_if_token2] = ACTIONS(3963),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3963),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3963),
    [aux_sym_preproc_else_token1] = ACTIONS(3963),
    [aux_sym_preproc_elif_token1] = ACTIONS(3963),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3963),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3963),
    [sym_preproc_directive] = ACTIONS(3963),
    [anon_sym_LPAREN2] = ACTIONS(3965),
    [anon_sym_BANG] = ACTIONS(3965),
    [anon_sym_TILDE] = ACTIONS(3965),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_STAR] = ACTIONS(3965),
    [anon_sym_AMP_AMP] = ACTIONS(3965),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_SEMI] = ACTIONS(3965),
    [anon_sym___extension__] = ACTIONS(3963),
    [anon_sym_typedef] = ACTIONS(3963),
    [anon_sym_in] = ACTIONS(3963),
    [anon_sym_out] = ACTIONS(3963),
    [anon_sym_inout] = ACTIONS(3963),
    [anon_sym_virtual] = ACTIONS(3963),
    [anon_sym_extern] = ACTIONS(3963),
    [anon_sym___attribute__] = ACTIONS(3963),
    [anon_sym___attribute] = ACTIONS(3963),
    [anon_sym_using] = ACTIONS(3963),
    [anon_sym_COLON_COLON] = ACTIONS(3965),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3965),
    [anon_sym___declspec] = ACTIONS(3963),
    [anon_sym___based] = ACTIONS(3963),
    [anon_sym___cdecl] = ACTIONS(3963),
    [anon_sym___clrcall] = ACTIONS(3963),
    [anon_sym___stdcall] = ACTIONS(3963),
    [anon_sym___fastcall] = ACTIONS(3963),
    [anon_sym___thiscall] = ACTIONS(3963),
    [anon_sym___vectorcall] = ACTIONS(3963),
    [anon_sym_LBRACE] = ACTIONS(3965),
    [anon_sym_signed] = ACTIONS(3963),
    [anon_sym_unsigned] = ACTIONS(3963),
    [anon_sym_long] = ACTIONS(3963),
    [anon_sym_short] = ACTIONS(3963),
    [anon_sym_LBRACK] = ACTIONS(3963),
    [anon_sym_static] = ACTIONS(3963),
    [anon_sym_register] = ACTIONS(3963),
    [anon_sym_inline] = ACTIONS(3963),
    [anon_sym___inline] = ACTIONS(3963),
    [anon_sym___inline__] = ACTIONS(3963),
    [anon_sym___forceinline] = ACTIONS(3963),
    [anon_sym_thread_local] = ACTIONS(3963),
    [anon_sym___thread] = ACTIONS(3963),
    [anon_sym_const] = ACTIONS(3963),
    [anon_sym_constexpr] = ACTIONS(3963),
    [anon_sym_volatile] = ACTIONS(3963),
    [anon_sym_restrict] = ACTIONS(3963),
    [anon_sym___restrict__] = ACTIONS(3963),
    [anon_sym__Atomic] = ACTIONS(3963),
    [anon_sym__Noreturn] = ACTIONS(3963),
    [anon_sym_noreturn] = ACTIONS(3963),
    [anon_sym__Nonnull] = ACTIONS(3963),
    [anon_sym_mutable] = ACTIONS(3963),
    [anon_sym_constinit] = ACTIONS(3963),
    [anon_sym_consteval] = ACTIONS(3963),
    [anon_sym_alignas] = ACTIONS(3963),
    [anon_sym__Alignas] = ACTIONS(3963),
    [sym_primitive_type] = ACTIONS(3963),
    [anon_sym_enum] = ACTIONS(3963),
    [anon_sym_class] = ACTIONS(3963),
    [anon_sym_struct] = ACTIONS(3963),
    [anon_sym_union] = ACTIONS(3963),
    [anon_sym_if] = ACTIONS(3963),
    [anon_sym_switch] = ACTIONS(3963),
    [anon_sym_case] = ACTIONS(3963),
    [anon_sym_default] = ACTIONS(3963),
    [anon_sym_while] = ACTIONS(3963),
    [anon_sym_do] = ACTIONS(3963),
    [anon_sym_for] = ACTIONS(3963),
    [anon_sym_return] = ACTIONS(3963),
    [anon_sym_break] = ACTIONS(3963),
    [anon_sym_continue] = ACTIONS(3963),
    [anon_sym_goto] = ACTIONS(3963),
    [anon_sym___try] = ACTIONS(3963),
    [anon_sym___leave] = ACTIONS(3963),
    [anon_sym_not] = ACTIONS(3963),
    [anon_sym_compl] = ACTIONS(3963),
    [anon_sym_DASH_DASH] = ACTIONS(3965),
    [anon_sym_PLUS_PLUS] = ACTIONS(3965),
    [anon_sym_sizeof] = ACTIONS(3963),
    [anon_sym___alignof__] = ACTIONS(3963),
    [anon_sym___alignof] = ACTIONS(3963),
    [anon_sym__alignof] = ACTIONS(3963),
    [anon_sym_alignof] = ACTIONS(3963),
    [anon_sym__Alignof] = ACTIONS(3963),
    [anon_sym_offsetof] = ACTIONS(3963),
    [anon_sym__Generic] = ACTIONS(3963),
    [anon_sym_asm] = ACTIONS(3963),
    [anon_sym___asm__] = ACTIONS(3963),
    [anon_sym___asm] = ACTIONS(3963),
    [sym_number_literal] = ACTIONS(3965),
    [anon_sym_L_SQUOTE] = ACTIONS(3965),
    [anon_sym_u_SQUOTE] = ACTIONS(3965),
    [anon_sym_U_SQUOTE] = ACTIONS(3965),
    [anon_sym_u8_SQUOTE] = ACTIONS(3965),
    [anon_sym_SQUOTE] = ACTIONS(3965),
    [anon_sym_L_DQUOTE] = ACTIONS(3965),
    [anon_sym_u_DQUOTE] = ACTIONS(3965),
    [anon_sym_U_DQUOTE] = ACTIONS(3965),
    [anon_sym_u8_DQUOTE] = ACTIONS(3965),
    [anon_sym_DQUOTE] = ACTIONS(3965),
    [sym_true] = ACTIONS(3963),
    [sym_false] = ACTIONS(3963),
    [anon_sym_NULL] = ACTIONS(3963),
    [anon_sym_nullptr] = ACTIONS(3963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3963),
    [anon_sym_let] = ACTIONS(3963),
    [anon_sym_This] = ACTIONS(3963),
    [anon_sym_decltype] = ACTIONS(3963),
    [anon_sym_explicit] = ACTIONS(3963),
    [anon_sym_typename] = ACTIONS(3963),
    [anon_sym_template] = ACTIONS(3963),
    [anon_sym_operator] = ACTIONS(3963),
    [anon_sym_try] = ACTIONS(3963),
    [anon_sym_delete] = ACTIONS(3963),
    [anon_sym_throw] = ACTIONS(3963),
    [anon_sym_namespace] = ACTIONS(3963),
    [anon_sym_static_assert] = ACTIONS(3963),
    [anon_sym_concept] = ACTIONS(3963),
    [anon_sym_co_return] = ACTIONS(3963),
    [anon_sym_co_yield] = ACTIONS(3963),
    [anon_sym_R_DQUOTE] = ACTIONS(3965),
    [anon_sym_LR_DQUOTE] = ACTIONS(3965),
    [anon_sym_uR_DQUOTE] = ACTIONS(3965),
    [anon_sym_UR_DQUOTE] = ACTIONS(3965),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3965),
    [anon_sym_co_await] = ACTIONS(3963),
    [anon_sym_new] = ACTIONS(3963),
    [anon_sym_requires] = ACTIONS(3963),
    [sym_this] = ACTIONS(3963),
    [anon_sym_discard] = ACTIONS(3963),
    [anon_sym_precise] = ACTIONS(3963),
    [anon_sym_shared] = ACTIONS(3963),
    [anon_sym_groupshared] = ACTIONS(3963),
    [anon_sym_uniform] = ACTIONS(3963),
    [anon_sym_row_major] = ACTIONS(3963),
    [anon_sym_column_major] = ACTIONS(3963),
    [anon_sym_globallycoherent] = ACTIONS(3963),
    [anon_sym_centroid] = ACTIONS(3963),
    [anon_sym_noperspective] = ACTIONS(3963),
    [anon_sym_nointerpolation] = ACTIONS(3963),
    [anon_sym_sample] = ACTIONS(3963),
    [anon_sym_linear] = ACTIONS(3963),
    [anon_sym_snorm] = ACTIONS(3963),
    [anon_sym_unorm] = ACTIONS(3963),
    [anon_sym_point] = ACTIONS(3963),
    [anon_sym_line] = ACTIONS(3963),
    [anon_sym_triangleadj] = ACTIONS(3963),
    [anon_sym_lineadj] = ACTIONS(3963),
    [anon_sym_triangle] = ACTIONS(3963),
    [anon_sym_cbuffer] = ACTIONS(3963),
    [anon_sym_interface] = ACTIONS(3963),
    [anon_sym_extension] = ACTIONS(3963),
  },
  [625] = {
    [sym_template_argument_list] = STATE(2953),
    [aux_sym_sized_type_specifier_repeat1] = STATE(665),
    [sym_identifier] = ACTIONS(3777),
    [aux_sym_preproc_include_token1] = ACTIONS(3777),
    [aux_sym_preproc_def_token1] = ACTIONS(3777),
    [aux_sym_preproc_if_token1] = ACTIONS(3777),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3777),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3777),
    [sym_preproc_directive] = ACTIONS(3777),
    [anon_sym_LPAREN2] = ACTIONS(3775),
    [anon_sym_BANG] = ACTIONS(3775),
    [anon_sym_TILDE] = ACTIONS(3775),
    [anon_sym_DASH] = ACTIONS(3777),
    [anon_sym_PLUS] = ACTIONS(3777),
    [anon_sym_STAR] = ACTIONS(3775),
    [anon_sym_AMP_AMP] = ACTIONS(3775),
    [anon_sym_AMP] = ACTIONS(3777),
    [anon_sym_LT] = ACTIONS(3779),
    [anon_sym_SEMI] = ACTIONS(3775),
    [anon_sym___extension__] = ACTIONS(3777),
    [anon_sym_typedef] = ACTIONS(3777),
    [anon_sym_in] = ACTIONS(3777),
    [anon_sym_out] = ACTIONS(3777),
    [anon_sym_inout] = ACTIONS(3777),
    [anon_sym_virtual] = ACTIONS(3777),
    [anon_sym_extern] = ACTIONS(3777),
    [anon_sym___attribute__] = ACTIONS(3777),
    [anon_sym___attribute] = ACTIONS(3777),
    [anon_sym_using] = ACTIONS(3777),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3775),
    [anon_sym___declspec] = ACTIONS(3777),
    [anon_sym___based] = ACTIONS(3777),
    [anon_sym___cdecl] = ACTIONS(3777),
    [anon_sym___clrcall] = ACTIONS(3777),
    [anon_sym___stdcall] = ACTIONS(3777),
    [anon_sym___fastcall] = ACTIONS(3777),
    [anon_sym___thiscall] = ACTIONS(3777),
    [anon_sym___vectorcall] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3775),
    [anon_sym_RBRACE] = ACTIONS(3775),
    [anon_sym_signed] = ACTIONS(3777),
    [anon_sym_unsigned] = ACTIONS(3777),
    [anon_sym_long] = ACTIONS(3777),
    [anon_sym_short] = ACTIONS(3777),
    [anon_sym_LBRACK] = ACTIONS(3777),
    [anon_sym_static] = ACTIONS(3777),
    [anon_sym_register] = ACTIONS(3777),
    [anon_sym_inline] = ACTIONS(3777),
    [anon_sym___inline] = ACTIONS(3777),
    [anon_sym___inline__] = ACTIONS(3777),
    [anon_sym___forceinline] = ACTIONS(3777),
    [anon_sym_thread_local] = ACTIONS(3777),
    [anon_sym___thread] = ACTIONS(3777),
    [anon_sym_const] = ACTIONS(3777),
    [anon_sym_constexpr] = ACTIONS(3777),
    [anon_sym_volatile] = ACTIONS(3777),
    [anon_sym_restrict] = ACTIONS(3777),
    [anon_sym___restrict__] = ACTIONS(3777),
    [anon_sym__Atomic] = ACTIONS(3777),
    [anon_sym__Noreturn] = ACTIONS(3777),
    [anon_sym_noreturn] = ACTIONS(3777),
    [anon_sym__Nonnull] = ACTIONS(3777),
    [anon_sym_mutable] = ACTIONS(3777),
    [anon_sym_constinit] = ACTIONS(3777),
    [anon_sym_consteval] = ACTIONS(3777),
    [anon_sym_alignas] = ACTIONS(3777),
    [anon_sym__Alignas] = ACTIONS(3777),
    [sym_primitive_type] = ACTIONS(3777),
    [anon_sym_enum] = ACTIONS(3777),
    [anon_sym_class] = ACTIONS(3777),
    [anon_sym_struct] = ACTIONS(3777),
    [anon_sym_union] = ACTIONS(3777),
    [anon_sym_if] = ACTIONS(3777),
    [anon_sym_switch] = ACTIONS(3777),
    [anon_sym_case] = ACTIONS(3777),
    [anon_sym_default] = ACTIONS(3777),
    [anon_sym_while] = ACTIONS(3777),
    [anon_sym_do] = ACTIONS(3777),
    [anon_sym_for] = ACTIONS(3777),
    [anon_sym_return] = ACTIONS(3777),
    [anon_sym_break] = ACTIONS(3777),
    [anon_sym_continue] = ACTIONS(3777),
    [anon_sym_goto] = ACTIONS(3777),
    [anon_sym___try] = ACTIONS(3777),
    [anon_sym___leave] = ACTIONS(3777),
    [anon_sym_not] = ACTIONS(3777),
    [anon_sym_compl] = ACTIONS(3777),
    [anon_sym_DASH_DASH] = ACTIONS(3775),
    [anon_sym_PLUS_PLUS] = ACTIONS(3775),
    [anon_sym_sizeof] = ACTIONS(3777),
    [anon_sym___alignof__] = ACTIONS(3777),
    [anon_sym___alignof] = ACTIONS(3777),
    [anon_sym__alignof] = ACTIONS(3777),
    [anon_sym_alignof] = ACTIONS(3777),
    [anon_sym__Alignof] = ACTIONS(3777),
    [anon_sym_offsetof] = ACTIONS(3777),
    [anon_sym__Generic] = ACTIONS(3777),
    [anon_sym_asm] = ACTIONS(3777),
    [anon_sym___asm__] = ACTIONS(3777),
    [anon_sym___asm] = ACTIONS(3777),
    [anon_sym_DOT] = ACTIONS(3777),
    [sym_number_literal] = ACTIONS(3775),
    [anon_sym_L_SQUOTE] = ACTIONS(3775),
    [anon_sym_u_SQUOTE] = ACTIONS(3775),
    [anon_sym_U_SQUOTE] = ACTIONS(3775),
    [anon_sym_u8_SQUOTE] = ACTIONS(3775),
    [anon_sym_SQUOTE] = ACTIONS(3775),
    [anon_sym_L_DQUOTE] = ACTIONS(3775),
    [anon_sym_u_DQUOTE] = ACTIONS(3775),
    [anon_sym_U_DQUOTE] = ACTIONS(3775),
    [anon_sym_u8_DQUOTE] = ACTIONS(3775),
    [anon_sym_DQUOTE] = ACTIONS(3775),
    [sym_true] = ACTIONS(3777),
    [sym_false] = ACTIONS(3777),
    [anon_sym_NULL] = ACTIONS(3777),
    [anon_sym_nullptr] = ACTIONS(3777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3777),
    [anon_sym_let] = ACTIONS(3777),
    [anon_sym_This] = ACTIONS(3777),
    [anon_sym_decltype] = ACTIONS(3777),
    [anon_sym_explicit] = ACTIONS(3777),
    [anon_sym_typename] = ACTIONS(3777),
    [anon_sym_template] = ACTIONS(3777),
    [anon_sym_operator] = ACTIONS(3777),
    [anon_sym_try] = ACTIONS(3777),
    [anon_sym_delete] = ACTIONS(3777),
    [anon_sym_throw] = ACTIONS(3777),
    [anon_sym_namespace] = ACTIONS(3777),
    [anon_sym_static_assert] = ACTIONS(3777),
    [anon_sym_concept] = ACTIONS(3777),
    [anon_sym_co_return] = ACTIONS(3777),
    [anon_sym_co_yield] = ACTIONS(3777),
    [anon_sym_R_DQUOTE] = ACTIONS(3775),
    [anon_sym_LR_DQUOTE] = ACTIONS(3775),
    [anon_sym_uR_DQUOTE] = ACTIONS(3775),
    [anon_sym_UR_DQUOTE] = ACTIONS(3775),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3775),
    [anon_sym_co_await] = ACTIONS(3777),
    [anon_sym_new] = ACTIONS(3777),
    [anon_sym_requires] = ACTIONS(3777),
    [sym_this] = ACTIONS(3777),
    [anon_sym_discard] = ACTIONS(3777),
    [anon_sym_precise] = ACTIONS(3777),
    [anon_sym_shared] = ACTIONS(3777),
    [anon_sym_groupshared] = ACTIONS(3777),
    [anon_sym_uniform] = ACTIONS(3777),
    [anon_sym_row_major] = ACTIONS(3777),
    [anon_sym_column_major] = ACTIONS(3777),
    [anon_sym_globallycoherent] = ACTIONS(3777),
    [anon_sym_centroid] = ACTIONS(3777),
    [anon_sym_noperspective] = ACTIONS(3777),
    [anon_sym_nointerpolation] = ACTIONS(3777),
    [anon_sym_sample] = ACTIONS(3777),
    [anon_sym_linear] = ACTIONS(3777),
    [anon_sym_snorm] = ACTIONS(3777),
    [anon_sym_unorm] = ACTIONS(3777),
    [anon_sym_point] = ACTIONS(3777),
    [anon_sym_line] = ACTIONS(3777),
    [anon_sym_triangleadj] = ACTIONS(3777),
    [anon_sym_lineadj] = ACTIONS(3777),
    [anon_sym_triangle] = ACTIONS(3777),
    [anon_sym_cbuffer] = ACTIONS(3777),
    [anon_sym_interface] = ACTIONS(3777),
    [anon_sym_extension] = ACTIONS(3777),
  },
  [626] = {
    [sym_identifier] = ACTIONS(3967),
    [aux_sym_preproc_include_token1] = ACTIONS(3967),
    [aux_sym_preproc_def_token1] = ACTIONS(3967),
    [aux_sym_preproc_if_token1] = ACTIONS(3967),
    [aux_sym_preproc_if_token2] = ACTIONS(3967),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3967),
    [aux_sym_preproc_else_token1] = ACTIONS(3967),
    [aux_sym_preproc_elif_token1] = ACTIONS(3967),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3967),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3967),
    [sym_preproc_directive] = ACTIONS(3967),
    [anon_sym_LPAREN2] = ACTIONS(3969),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_TILDE] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_STAR] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_AMP] = ACTIONS(3967),
    [anon_sym_SEMI] = ACTIONS(3969),
    [anon_sym___extension__] = ACTIONS(3967),
    [anon_sym_typedef] = ACTIONS(3967),
    [anon_sym_in] = ACTIONS(3967),
    [anon_sym_out] = ACTIONS(3967),
    [anon_sym_inout] = ACTIONS(3967),
    [anon_sym_virtual] = ACTIONS(3967),
    [anon_sym_extern] = ACTIONS(3967),
    [anon_sym___attribute__] = ACTIONS(3967),
    [anon_sym___attribute] = ACTIONS(3967),
    [anon_sym_using] = ACTIONS(3967),
    [anon_sym_COLON_COLON] = ACTIONS(3969),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3969),
    [anon_sym___declspec] = ACTIONS(3967),
    [anon_sym___based] = ACTIONS(3967),
    [anon_sym___cdecl] = ACTIONS(3967),
    [anon_sym___clrcall] = ACTIONS(3967),
    [anon_sym___stdcall] = ACTIONS(3967),
    [anon_sym___fastcall] = ACTIONS(3967),
    [anon_sym___thiscall] = ACTIONS(3967),
    [anon_sym___vectorcall] = ACTIONS(3967),
    [anon_sym_LBRACE] = ACTIONS(3969),
    [anon_sym_signed] = ACTIONS(3967),
    [anon_sym_unsigned] = ACTIONS(3967),
    [anon_sym_long] = ACTIONS(3967),
    [anon_sym_short] = ACTIONS(3967),
    [anon_sym_LBRACK] = ACTIONS(3967),
    [anon_sym_static] = ACTIONS(3967),
    [anon_sym_register] = ACTIONS(3967),
    [anon_sym_inline] = ACTIONS(3967),
    [anon_sym___inline] = ACTIONS(3967),
    [anon_sym___inline__] = ACTIONS(3967),
    [anon_sym___forceinline] = ACTIONS(3967),
    [anon_sym_thread_local] = ACTIONS(3967),
    [anon_sym___thread] = ACTIONS(3967),
    [anon_sym_const] = ACTIONS(3967),
    [anon_sym_constexpr] = ACTIONS(3967),
    [anon_sym_volatile] = ACTIONS(3967),
    [anon_sym_restrict] = ACTIONS(3967),
    [anon_sym___restrict__] = ACTIONS(3967),
    [anon_sym__Atomic] = ACTIONS(3967),
    [anon_sym__Noreturn] = ACTIONS(3967),
    [anon_sym_noreturn] = ACTIONS(3967),
    [anon_sym__Nonnull] = ACTIONS(3967),
    [anon_sym_mutable] = ACTIONS(3967),
    [anon_sym_constinit] = ACTIONS(3967),
    [anon_sym_consteval] = ACTIONS(3967),
    [anon_sym_alignas] = ACTIONS(3967),
    [anon_sym__Alignas] = ACTIONS(3967),
    [sym_primitive_type] = ACTIONS(3967),
    [anon_sym_enum] = ACTIONS(3967),
    [anon_sym_class] = ACTIONS(3967),
    [anon_sym_struct] = ACTIONS(3967),
    [anon_sym_union] = ACTIONS(3967),
    [anon_sym_if] = ACTIONS(3967),
    [anon_sym_switch] = ACTIONS(3967),
    [anon_sym_case] = ACTIONS(3967),
    [anon_sym_default] = ACTIONS(3967),
    [anon_sym_while] = ACTIONS(3967),
    [anon_sym_do] = ACTIONS(3967),
    [anon_sym_for] = ACTIONS(3967),
    [anon_sym_return] = ACTIONS(3967),
    [anon_sym_break] = ACTIONS(3967),
    [anon_sym_continue] = ACTIONS(3967),
    [anon_sym_goto] = ACTIONS(3967),
    [anon_sym___try] = ACTIONS(3967),
    [anon_sym___leave] = ACTIONS(3967),
    [anon_sym_not] = ACTIONS(3967),
    [anon_sym_compl] = ACTIONS(3967),
    [anon_sym_DASH_DASH] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3969),
    [anon_sym_sizeof] = ACTIONS(3967),
    [anon_sym___alignof__] = ACTIONS(3967),
    [anon_sym___alignof] = ACTIONS(3967),
    [anon_sym__alignof] = ACTIONS(3967),
    [anon_sym_alignof] = ACTIONS(3967),
    [anon_sym__Alignof] = ACTIONS(3967),
    [anon_sym_offsetof] = ACTIONS(3967),
    [anon_sym__Generic] = ACTIONS(3967),
    [anon_sym_asm] = ACTIONS(3967),
    [anon_sym___asm__] = ACTIONS(3967),
    [anon_sym___asm] = ACTIONS(3967),
    [sym_number_literal] = ACTIONS(3969),
    [anon_sym_L_SQUOTE] = ACTIONS(3969),
    [anon_sym_u_SQUOTE] = ACTIONS(3969),
    [anon_sym_U_SQUOTE] = ACTIONS(3969),
    [anon_sym_u8_SQUOTE] = ACTIONS(3969),
    [anon_sym_SQUOTE] = ACTIONS(3969),
    [anon_sym_L_DQUOTE] = ACTIONS(3969),
    [anon_sym_u_DQUOTE] = ACTIONS(3969),
    [anon_sym_U_DQUOTE] = ACTIONS(3969),
    [anon_sym_u8_DQUOTE] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(3969),
    [sym_true] = ACTIONS(3967),
    [sym_false] = ACTIONS(3967),
    [anon_sym_NULL] = ACTIONS(3967),
    [anon_sym_nullptr] = ACTIONS(3967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3967),
    [anon_sym_let] = ACTIONS(3967),
    [anon_sym_This] = ACTIONS(3967),
    [anon_sym_decltype] = ACTIONS(3967),
    [anon_sym_explicit] = ACTIONS(3967),
    [anon_sym_typename] = ACTIONS(3967),
    [anon_sym_template] = ACTIONS(3967),
    [anon_sym_operator] = ACTIONS(3967),
    [anon_sym_try] = ACTIONS(3967),
    [anon_sym_delete] = ACTIONS(3967),
    [anon_sym_throw] = ACTIONS(3967),
    [anon_sym_namespace] = ACTIONS(3967),
    [anon_sym_static_assert] = ACTIONS(3967),
    [anon_sym_concept] = ACTIONS(3967),
    [anon_sym_co_return] = ACTIONS(3967),
    [anon_sym_co_yield] = ACTIONS(3967),
    [anon_sym_R_DQUOTE] = ACTIONS(3969),
    [anon_sym_LR_DQUOTE] = ACTIONS(3969),
    [anon_sym_uR_DQUOTE] = ACTIONS(3969),
    [anon_sym_UR_DQUOTE] = ACTIONS(3969),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3969),
    [anon_sym_co_await] = ACTIONS(3967),
    [anon_sym_new] = ACTIONS(3967),
    [anon_sym_requires] = ACTIONS(3967),
    [sym_this] = ACTIONS(3967),
    [anon_sym_discard] = ACTIONS(3967),
    [anon_sym_precise] = ACTIONS(3967),
    [anon_sym_shared] = ACTIONS(3967),
    [anon_sym_groupshared] = ACTIONS(3967),
    [anon_sym_uniform] = ACTIONS(3967),
    [anon_sym_row_major] = ACTIONS(3967),
    [anon_sym_column_major] = ACTIONS(3967),
    [anon_sym_globallycoherent] = ACTIONS(3967),
    [anon_sym_centroid] = ACTIONS(3967),
    [anon_sym_noperspective] = ACTIONS(3967),
    [anon_sym_nointerpolation] = ACTIONS(3967),
    [anon_sym_sample] = ACTIONS(3967),
    [anon_sym_linear] = ACTIONS(3967),
    [anon_sym_snorm] = ACTIONS(3967),
    [anon_sym_unorm] = ACTIONS(3967),
    [anon_sym_point] = ACTIONS(3967),
    [anon_sym_line] = ACTIONS(3967),
    [anon_sym_triangleadj] = ACTIONS(3967),
    [anon_sym_lineadj] = ACTIONS(3967),
    [anon_sym_triangle] = ACTIONS(3967),
    [anon_sym_cbuffer] = ACTIONS(3967),
    [anon_sym_interface] = ACTIONS(3967),
    [anon_sym_extension] = ACTIONS(3967),
  },
  [627] = {
    [sym_identifier] = ACTIONS(3845),
    [aux_sym_preproc_include_token1] = ACTIONS(3845),
    [aux_sym_preproc_def_token1] = ACTIONS(3845),
    [aux_sym_preproc_if_token1] = ACTIONS(3845),
    [aux_sym_preproc_if_token2] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3845),
    [aux_sym_preproc_else_token1] = ACTIONS(3845),
    [aux_sym_preproc_elif_token1] = ACTIONS(3845),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3845),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3845),
    [sym_preproc_directive] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3847),
    [anon_sym_BANG] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_STAR] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_SEMI] = ACTIONS(3847),
    [anon_sym___extension__] = ACTIONS(3845),
    [anon_sym_typedef] = ACTIONS(3845),
    [anon_sym_in] = ACTIONS(3845),
    [anon_sym_out] = ACTIONS(3845),
    [anon_sym_inout] = ACTIONS(3845),
    [anon_sym_virtual] = ACTIONS(3845),
    [anon_sym_extern] = ACTIONS(3845),
    [anon_sym___attribute__] = ACTIONS(3845),
    [anon_sym___attribute] = ACTIONS(3845),
    [anon_sym_using] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3847),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3847),
    [anon_sym___declspec] = ACTIONS(3845),
    [anon_sym___based] = ACTIONS(3845),
    [anon_sym___cdecl] = ACTIONS(3845),
    [anon_sym___clrcall] = ACTIONS(3845),
    [anon_sym___stdcall] = ACTIONS(3845),
    [anon_sym___fastcall] = ACTIONS(3845),
    [anon_sym___thiscall] = ACTIONS(3845),
    [anon_sym___vectorcall] = ACTIONS(3845),
    [anon_sym_LBRACE] = ACTIONS(3847),
    [anon_sym_signed] = ACTIONS(3845),
    [anon_sym_unsigned] = ACTIONS(3845),
    [anon_sym_long] = ACTIONS(3845),
    [anon_sym_short] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_static] = ACTIONS(3845),
    [anon_sym_register] = ACTIONS(3845),
    [anon_sym_inline] = ACTIONS(3845),
    [anon_sym___inline] = ACTIONS(3845),
    [anon_sym___inline__] = ACTIONS(3845),
    [anon_sym___forceinline] = ACTIONS(3845),
    [anon_sym_thread_local] = ACTIONS(3845),
    [anon_sym___thread] = ACTIONS(3845),
    [anon_sym_const] = ACTIONS(3845),
    [anon_sym_constexpr] = ACTIONS(3845),
    [anon_sym_volatile] = ACTIONS(3845),
    [anon_sym_restrict] = ACTIONS(3845),
    [anon_sym___restrict__] = ACTIONS(3845),
    [anon_sym__Atomic] = ACTIONS(3845),
    [anon_sym__Noreturn] = ACTIONS(3845),
    [anon_sym_noreturn] = ACTIONS(3845),
    [anon_sym__Nonnull] = ACTIONS(3845),
    [anon_sym_mutable] = ACTIONS(3845),
    [anon_sym_constinit] = ACTIONS(3845),
    [anon_sym_consteval] = ACTIONS(3845),
    [anon_sym_alignas] = ACTIONS(3845),
    [anon_sym__Alignas] = ACTIONS(3845),
    [sym_primitive_type] = ACTIONS(3845),
    [anon_sym_enum] = ACTIONS(3845),
    [anon_sym_class] = ACTIONS(3845),
    [anon_sym_struct] = ACTIONS(3845),
    [anon_sym_union] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_switch] = ACTIONS(3845),
    [anon_sym_case] = ACTIONS(3845),
    [anon_sym_default] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_break] = ACTIONS(3845),
    [anon_sym_continue] = ACTIONS(3845),
    [anon_sym_goto] = ACTIONS(3845),
    [anon_sym___try] = ACTIONS(3845),
    [anon_sym___leave] = ACTIONS(3845),
    [anon_sym_not] = ACTIONS(3845),
    [anon_sym_compl] = ACTIONS(3845),
    [anon_sym_DASH_DASH] = ACTIONS(3847),
    [anon_sym_PLUS_PLUS] = ACTIONS(3847),
    [anon_sym_sizeof] = ACTIONS(3845),
    [anon_sym___alignof__] = ACTIONS(3845),
    [anon_sym___alignof] = ACTIONS(3845),
    [anon_sym__alignof] = ACTIONS(3845),
    [anon_sym_alignof] = ACTIONS(3845),
    [anon_sym__Alignof] = ACTIONS(3845),
    [anon_sym_offsetof] = ACTIONS(3845),
    [anon_sym__Generic] = ACTIONS(3845),
    [anon_sym_asm] = ACTIONS(3845),
    [anon_sym___asm__] = ACTIONS(3845),
    [anon_sym___asm] = ACTIONS(3845),
    [sym_number_literal] = ACTIONS(3847),
    [anon_sym_L_SQUOTE] = ACTIONS(3847),
    [anon_sym_u_SQUOTE] = ACTIONS(3847),
    [anon_sym_U_SQUOTE] = ACTIONS(3847),
    [anon_sym_u8_SQUOTE] = ACTIONS(3847),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [anon_sym_L_DQUOTE] = ACTIONS(3847),
    [anon_sym_u_DQUOTE] = ACTIONS(3847),
    [anon_sym_U_DQUOTE] = ACTIONS(3847),
    [anon_sym_u8_DQUOTE] = ACTIONS(3847),
    [anon_sym_DQUOTE] = ACTIONS(3847),
    [sym_true] = ACTIONS(3845),
    [sym_false] = ACTIONS(3845),
    [anon_sym_NULL] = ACTIONS(3845),
    [anon_sym_nullptr] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_This] = ACTIONS(3845),
    [anon_sym_decltype] = ACTIONS(3845),
    [anon_sym_explicit] = ACTIONS(3845),
    [anon_sym_typename] = ACTIONS(3845),
    [anon_sym_template] = ACTIONS(3845),
    [anon_sym_operator] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_delete] = ACTIONS(3845),
    [anon_sym_throw] = ACTIONS(3845),
    [anon_sym_namespace] = ACTIONS(3845),
    [anon_sym_static_assert] = ACTIONS(3845),
    [anon_sym_concept] = ACTIONS(3845),
    [anon_sym_co_return] = ACTIONS(3845),
    [anon_sym_co_yield] = ACTIONS(3845),
    [anon_sym_R_DQUOTE] = ACTIONS(3847),
    [anon_sym_LR_DQUOTE] = ACTIONS(3847),
    [anon_sym_uR_DQUOTE] = ACTIONS(3847),
    [anon_sym_UR_DQUOTE] = ACTIONS(3847),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3847),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_requires] = ACTIONS(3845),
    [sym_this] = ACTIONS(3845),
    [anon_sym_discard] = ACTIONS(3845),
    [anon_sym_precise] = ACTIONS(3845),
    [anon_sym_shared] = ACTIONS(3845),
    [anon_sym_groupshared] = ACTIONS(3845),
    [anon_sym_uniform] = ACTIONS(3845),
    [anon_sym_row_major] = ACTIONS(3845),
    [anon_sym_column_major] = ACTIONS(3845),
    [anon_sym_globallycoherent] = ACTIONS(3845),
    [anon_sym_centroid] = ACTIONS(3845),
    [anon_sym_noperspective] = ACTIONS(3845),
    [anon_sym_nointerpolation] = ACTIONS(3845),
    [anon_sym_sample] = ACTIONS(3845),
    [anon_sym_linear] = ACTIONS(3845),
    [anon_sym_snorm] = ACTIONS(3845),
    [anon_sym_unorm] = ACTIONS(3845),
    [anon_sym_point] = ACTIONS(3845),
    [anon_sym_line] = ACTIONS(3845),
    [anon_sym_triangleadj] = ACTIONS(3845),
    [anon_sym_lineadj] = ACTIONS(3845),
    [anon_sym_triangle] = ACTIONS(3845),
    [anon_sym_cbuffer] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3845),
    [anon_sym_extension] = ACTIONS(3845),
  },
  [628] = {
    [sym_identifier] = ACTIONS(3971),
    [aux_sym_preproc_include_token1] = ACTIONS(3971),
    [aux_sym_preproc_def_token1] = ACTIONS(3971),
    [aux_sym_preproc_if_token1] = ACTIONS(3971),
    [aux_sym_preproc_if_token2] = ACTIONS(3971),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3971),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3971),
    [aux_sym_preproc_else_token1] = ACTIONS(3971),
    [aux_sym_preproc_elif_token1] = ACTIONS(3971),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3971),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3971),
    [sym_preproc_directive] = ACTIONS(3971),
    [anon_sym_LPAREN2] = ACTIONS(3974),
    [anon_sym_BANG] = ACTIONS(3974),
    [anon_sym_TILDE] = ACTIONS(3974),
    [anon_sym_DASH] = ACTIONS(3971),
    [anon_sym_PLUS] = ACTIONS(3971),
    [anon_sym_STAR] = ACTIONS(3974),
    [anon_sym_AMP_AMP] = ACTIONS(3974),
    [anon_sym_AMP] = ACTIONS(3971),
    [anon_sym_SEMI] = ACTIONS(3974),
    [anon_sym___extension__] = ACTIONS(3971),
    [anon_sym_typedef] = ACTIONS(3971),
    [anon_sym_in] = ACTIONS(3971),
    [anon_sym_out] = ACTIONS(3971),
    [anon_sym_inout] = ACTIONS(3971),
    [anon_sym_virtual] = ACTIONS(3971),
    [anon_sym_extern] = ACTIONS(3971),
    [anon_sym___attribute__] = ACTIONS(3971),
    [anon_sym___attribute] = ACTIONS(3971),
    [anon_sym_using] = ACTIONS(3971),
    [anon_sym_COLON_COLON] = ACTIONS(3974),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3974),
    [anon_sym___declspec] = ACTIONS(3971),
    [anon_sym___based] = ACTIONS(3971),
    [anon_sym___cdecl] = ACTIONS(3971),
    [anon_sym___clrcall] = ACTIONS(3971),
    [anon_sym___stdcall] = ACTIONS(3971),
    [anon_sym___fastcall] = ACTIONS(3971),
    [anon_sym___thiscall] = ACTIONS(3971),
    [anon_sym___vectorcall] = ACTIONS(3971),
    [anon_sym_LBRACE] = ACTIONS(3974),
    [anon_sym_signed] = ACTIONS(3971),
    [anon_sym_unsigned] = ACTIONS(3971),
    [anon_sym_long] = ACTIONS(3971),
    [anon_sym_short] = ACTIONS(3971),
    [anon_sym_LBRACK] = ACTIONS(3971),
    [anon_sym_static] = ACTIONS(3971),
    [anon_sym_register] = ACTIONS(3971),
    [anon_sym_inline] = ACTIONS(3971),
    [anon_sym___inline] = ACTIONS(3971),
    [anon_sym___inline__] = ACTIONS(3971),
    [anon_sym___forceinline] = ACTIONS(3971),
    [anon_sym_thread_local] = ACTIONS(3971),
    [anon_sym___thread] = ACTIONS(3971),
    [anon_sym_const] = ACTIONS(3971),
    [anon_sym_constexpr] = ACTIONS(3971),
    [anon_sym_volatile] = ACTIONS(3971),
    [anon_sym_restrict] = ACTIONS(3971),
    [anon_sym___restrict__] = ACTIONS(3971),
    [anon_sym__Atomic] = ACTIONS(3971),
    [anon_sym__Noreturn] = ACTIONS(3971),
    [anon_sym_noreturn] = ACTIONS(3971),
    [anon_sym__Nonnull] = ACTIONS(3971),
    [anon_sym_mutable] = ACTIONS(3971),
    [anon_sym_constinit] = ACTIONS(3971),
    [anon_sym_consteval] = ACTIONS(3971),
    [anon_sym_alignas] = ACTIONS(3971),
    [anon_sym__Alignas] = ACTIONS(3971),
    [sym_primitive_type] = ACTIONS(3971),
    [anon_sym_enum] = ACTIONS(3971),
    [anon_sym_class] = ACTIONS(3971),
    [anon_sym_struct] = ACTIONS(3971),
    [anon_sym_union] = ACTIONS(3971),
    [anon_sym_if] = ACTIONS(3971),
    [anon_sym_switch] = ACTIONS(3971),
    [anon_sym_case] = ACTIONS(3971),
    [anon_sym_default] = ACTIONS(3971),
    [anon_sym_while] = ACTIONS(3971),
    [anon_sym_do] = ACTIONS(3971),
    [anon_sym_for] = ACTIONS(3971),
    [anon_sym_return] = ACTIONS(3971),
    [anon_sym_break] = ACTIONS(3971),
    [anon_sym_continue] = ACTIONS(3971),
    [anon_sym_goto] = ACTIONS(3971),
    [anon_sym___try] = ACTIONS(3971),
    [anon_sym___leave] = ACTIONS(3971),
    [anon_sym_not] = ACTIONS(3971),
    [anon_sym_compl] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3974),
    [anon_sym_PLUS_PLUS] = ACTIONS(3974),
    [anon_sym_sizeof] = ACTIONS(3971),
    [anon_sym___alignof__] = ACTIONS(3971),
    [anon_sym___alignof] = ACTIONS(3971),
    [anon_sym__alignof] = ACTIONS(3971),
    [anon_sym_alignof] = ACTIONS(3971),
    [anon_sym__Alignof] = ACTIONS(3971),
    [anon_sym_offsetof] = ACTIONS(3971),
    [anon_sym__Generic] = ACTIONS(3971),
    [anon_sym_asm] = ACTIONS(3971),
    [anon_sym___asm__] = ACTIONS(3971),
    [anon_sym___asm] = ACTIONS(3971),
    [sym_number_literal] = ACTIONS(3974),
    [anon_sym_L_SQUOTE] = ACTIONS(3974),
    [anon_sym_u_SQUOTE] = ACTIONS(3974),
    [anon_sym_U_SQUOTE] = ACTIONS(3974),
    [anon_sym_u8_SQUOTE] = ACTIONS(3974),
    [anon_sym_SQUOTE] = ACTIONS(3974),
    [anon_sym_L_DQUOTE] = ACTIONS(3974),
    [anon_sym_u_DQUOTE] = ACTIONS(3974),
    [anon_sym_U_DQUOTE] = ACTIONS(3974),
    [anon_sym_u8_DQUOTE] = ACTIONS(3974),
    [anon_sym_DQUOTE] = ACTIONS(3974),
    [sym_true] = ACTIONS(3971),
    [sym_false] = ACTIONS(3971),
    [anon_sym_NULL] = ACTIONS(3971),
    [anon_sym_nullptr] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3971),
    [anon_sym_let] = ACTIONS(3971),
    [anon_sym_This] = ACTIONS(3971),
    [anon_sym_decltype] = ACTIONS(3971),
    [anon_sym_explicit] = ACTIONS(3971),
    [anon_sym_typename] = ACTIONS(3971),
    [anon_sym_template] = ACTIONS(3971),
    [anon_sym_operator] = ACTIONS(3971),
    [anon_sym_try] = ACTIONS(3971),
    [anon_sym_delete] = ACTIONS(3971),
    [anon_sym_throw] = ACTIONS(3971),
    [anon_sym_namespace] = ACTIONS(3971),
    [anon_sym_static_assert] = ACTIONS(3971),
    [anon_sym_concept] = ACTIONS(3971),
    [anon_sym_co_return] = ACTIONS(3971),
    [anon_sym_co_yield] = ACTIONS(3971),
    [anon_sym_R_DQUOTE] = ACTIONS(3974),
    [anon_sym_LR_DQUOTE] = ACTIONS(3974),
    [anon_sym_uR_DQUOTE] = ACTIONS(3974),
    [anon_sym_UR_DQUOTE] = ACTIONS(3974),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3974),
    [anon_sym_co_await] = ACTIONS(3971),
    [anon_sym_new] = ACTIONS(3971),
    [anon_sym_requires] = ACTIONS(3971),
    [sym_this] = ACTIONS(3971),
    [anon_sym_discard] = ACTIONS(3971),
    [anon_sym_precise] = ACTIONS(3971),
    [anon_sym_shared] = ACTIONS(3971),
    [anon_sym_groupshared] = ACTIONS(3971),
    [anon_sym_uniform] = ACTIONS(3971),
    [anon_sym_row_major] = ACTIONS(3971),
    [anon_sym_column_major] = ACTIONS(3971),
    [anon_sym_globallycoherent] = ACTIONS(3971),
    [anon_sym_centroid] = ACTIONS(3971),
    [anon_sym_noperspective] = ACTIONS(3971),
    [anon_sym_nointerpolation] = ACTIONS(3971),
    [anon_sym_sample] = ACTIONS(3971),
    [anon_sym_linear] = ACTIONS(3971),
    [anon_sym_snorm] = ACTIONS(3971),
    [anon_sym_unorm] = ACTIONS(3971),
    [anon_sym_point] = ACTIONS(3971),
    [anon_sym_line] = ACTIONS(3971),
    [anon_sym_triangleadj] = ACTIONS(3971),
    [anon_sym_lineadj] = ACTIONS(3971),
    [anon_sym_triangle] = ACTIONS(3971),
    [anon_sym_cbuffer] = ACTIONS(3971),
    [anon_sym_interface] = ACTIONS(3971),
    [anon_sym_extension] = ACTIONS(3971),
  },
  [629] = {
    [sym_identifier] = ACTIONS(3977),
    [aux_sym_preproc_include_token1] = ACTIONS(3977),
    [aux_sym_preproc_def_token1] = ACTIONS(3977),
    [aux_sym_preproc_if_token1] = ACTIONS(3977),
    [aux_sym_preproc_if_token2] = ACTIONS(3977),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3977),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3977),
    [aux_sym_preproc_else_token1] = ACTIONS(3977),
    [aux_sym_preproc_elif_token1] = ACTIONS(3977),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3977),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3977),
    [sym_preproc_directive] = ACTIONS(3977),
    [anon_sym_LPAREN2] = ACTIONS(3979),
    [anon_sym_BANG] = ACTIONS(3979),
    [anon_sym_TILDE] = ACTIONS(3979),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_PLUS] = ACTIONS(3977),
    [anon_sym_STAR] = ACTIONS(3979),
    [anon_sym_AMP_AMP] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3977),
    [anon_sym_SEMI] = ACTIONS(3979),
    [anon_sym___extension__] = ACTIONS(3977),
    [anon_sym_typedef] = ACTIONS(3977),
    [anon_sym_in] = ACTIONS(3977),
    [anon_sym_out] = ACTIONS(3977),
    [anon_sym_inout] = ACTIONS(3977),
    [anon_sym_virtual] = ACTIONS(3977),
    [anon_sym_extern] = ACTIONS(3977),
    [anon_sym___attribute__] = ACTIONS(3977),
    [anon_sym___attribute] = ACTIONS(3977),
    [anon_sym_using] = ACTIONS(3977),
    [anon_sym_COLON_COLON] = ACTIONS(3979),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3979),
    [anon_sym___declspec] = ACTIONS(3977),
    [anon_sym___based] = ACTIONS(3977),
    [anon_sym___cdecl] = ACTIONS(3977),
    [anon_sym___clrcall] = ACTIONS(3977),
    [anon_sym___stdcall] = ACTIONS(3977),
    [anon_sym___fastcall] = ACTIONS(3977),
    [anon_sym___thiscall] = ACTIONS(3977),
    [anon_sym___vectorcall] = ACTIONS(3977),
    [anon_sym_LBRACE] = ACTIONS(3979),
    [anon_sym_signed] = ACTIONS(3977),
    [anon_sym_unsigned] = ACTIONS(3977),
    [anon_sym_long] = ACTIONS(3977),
    [anon_sym_short] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3977),
    [anon_sym_static] = ACTIONS(3977),
    [anon_sym_register] = ACTIONS(3977),
    [anon_sym_inline] = ACTIONS(3977),
    [anon_sym___inline] = ACTIONS(3977),
    [anon_sym___inline__] = ACTIONS(3977),
    [anon_sym___forceinline] = ACTIONS(3977),
    [anon_sym_thread_local] = ACTIONS(3977),
    [anon_sym___thread] = ACTIONS(3977),
    [anon_sym_const] = ACTIONS(3977),
    [anon_sym_constexpr] = ACTIONS(3977),
    [anon_sym_volatile] = ACTIONS(3977),
    [anon_sym_restrict] = ACTIONS(3977),
    [anon_sym___restrict__] = ACTIONS(3977),
    [anon_sym__Atomic] = ACTIONS(3977),
    [anon_sym__Noreturn] = ACTIONS(3977),
    [anon_sym_noreturn] = ACTIONS(3977),
    [anon_sym__Nonnull] = ACTIONS(3977),
    [anon_sym_mutable] = ACTIONS(3977),
    [anon_sym_constinit] = ACTIONS(3977),
    [anon_sym_consteval] = ACTIONS(3977),
    [anon_sym_alignas] = ACTIONS(3977),
    [anon_sym__Alignas] = ACTIONS(3977),
    [sym_primitive_type] = ACTIONS(3977),
    [anon_sym_enum] = ACTIONS(3977),
    [anon_sym_class] = ACTIONS(3977),
    [anon_sym_struct] = ACTIONS(3977),
    [anon_sym_union] = ACTIONS(3977),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_switch] = ACTIONS(3977),
    [anon_sym_case] = ACTIONS(3977),
    [anon_sym_default] = ACTIONS(3977),
    [anon_sym_while] = ACTIONS(3977),
    [anon_sym_do] = ACTIONS(3977),
    [anon_sym_for] = ACTIONS(3977),
    [anon_sym_return] = ACTIONS(3977),
    [anon_sym_break] = ACTIONS(3977),
    [anon_sym_continue] = ACTIONS(3977),
    [anon_sym_goto] = ACTIONS(3977),
    [anon_sym___try] = ACTIONS(3977),
    [anon_sym___leave] = ACTIONS(3977),
    [anon_sym_not] = ACTIONS(3977),
    [anon_sym_compl] = ACTIONS(3977),
    [anon_sym_DASH_DASH] = ACTIONS(3979),
    [anon_sym_PLUS_PLUS] = ACTIONS(3979),
    [anon_sym_sizeof] = ACTIONS(3977),
    [anon_sym___alignof__] = ACTIONS(3977),
    [anon_sym___alignof] = ACTIONS(3977),
    [anon_sym__alignof] = ACTIONS(3977),
    [anon_sym_alignof] = ACTIONS(3977),
    [anon_sym__Alignof] = ACTIONS(3977),
    [anon_sym_offsetof] = ACTIONS(3977),
    [anon_sym__Generic] = ACTIONS(3977),
    [anon_sym_asm] = ACTIONS(3977),
    [anon_sym___asm__] = ACTIONS(3977),
    [anon_sym___asm] = ACTIONS(3977),
    [sym_number_literal] = ACTIONS(3979),
    [anon_sym_L_SQUOTE] = ACTIONS(3979),
    [anon_sym_u_SQUOTE] = ACTIONS(3979),
    [anon_sym_U_SQUOTE] = ACTIONS(3979),
    [anon_sym_u8_SQUOTE] = ACTIONS(3979),
    [anon_sym_SQUOTE] = ACTIONS(3979),
    [anon_sym_L_DQUOTE] = ACTIONS(3979),
    [anon_sym_u_DQUOTE] = ACTIONS(3979),
    [anon_sym_U_DQUOTE] = ACTIONS(3979),
    [anon_sym_u8_DQUOTE] = ACTIONS(3979),
    [anon_sym_DQUOTE] = ACTIONS(3979),
    [sym_true] = ACTIONS(3977),
    [sym_false] = ACTIONS(3977),
    [anon_sym_NULL] = ACTIONS(3977),
    [anon_sym_nullptr] = ACTIONS(3977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3977),
    [anon_sym_let] = ACTIONS(3977),
    [anon_sym_This] = ACTIONS(3977),
    [anon_sym_decltype] = ACTIONS(3977),
    [anon_sym_explicit] = ACTIONS(3977),
    [anon_sym_typename] = ACTIONS(3977),
    [anon_sym_template] = ACTIONS(3977),
    [anon_sym_operator] = ACTIONS(3977),
    [anon_sym_try] = ACTIONS(3977),
    [anon_sym_delete] = ACTIONS(3977),
    [anon_sym_throw] = ACTIONS(3977),
    [anon_sym_namespace] = ACTIONS(3977),
    [anon_sym_static_assert] = ACTIONS(3977),
    [anon_sym_concept] = ACTIONS(3977),
    [anon_sym_co_return] = ACTIONS(3977),
    [anon_sym_co_yield] = ACTIONS(3977),
    [anon_sym_R_DQUOTE] = ACTIONS(3979),
    [anon_sym_LR_DQUOTE] = ACTIONS(3979),
    [anon_sym_uR_DQUOTE] = ACTIONS(3979),
    [anon_sym_UR_DQUOTE] = ACTIONS(3979),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3979),
    [anon_sym_co_await] = ACTIONS(3977),
    [anon_sym_new] = ACTIONS(3977),
    [anon_sym_requires] = ACTIONS(3977),
    [sym_this] = ACTIONS(3977),
    [anon_sym_discard] = ACTIONS(3977),
    [anon_sym_precise] = ACTIONS(3977),
    [anon_sym_shared] = ACTIONS(3977),
    [anon_sym_groupshared] = ACTIONS(3977),
    [anon_sym_uniform] = ACTIONS(3977),
    [anon_sym_row_major] = ACTIONS(3977),
    [anon_sym_column_major] = ACTIONS(3977),
    [anon_sym_globallycoherent] = ACTIONS(3977),
    [anon_sym_centroid] = ACTIONS(3977),
    [anon_sym_noperspective] = ACTIONS(3977),
    [anon_sym_nointerpolation] = ACTIONS(3977),
    [anon_sym_sample] = ACTIONS(3977),
    [anon_sym_linear] = ACTIONS(3977),
    [anon_sym_snorm] = ACTIONS(3977),
    [anon_sym_unorm] = ACTIONS(3977),
    [anon_sym_point] = ACTIONS(3977),
    [anon_sym_line] = ACTIONS(3977),
    [anon_sym_triangleadj] = ACTIONS(3977),
    [anon_sym_lineadj] = ACTIONS(3977),
    [anon_sym_triangle] = ACTIONS(3977),
    [anon_sym_cbuffer] = ACTIONS(3977),
    [anon_sym_interface] = ACTIONS(3977),
    [anon_sym_extension] = ACTIONS(3977),
  },
  [630] = {
    [sym_catch_clause] = STATE(569),
    [aux_sym_constructor_try_statement_repeat1] = STATE(569),
    [sym_identifier] = ACTIONS(2885),
    [aux_sym_preproc_include_token1] = ACTIONS(2885),
    [aux_sym_preproc_def_token1] = ACTIONS(2885),
    [aux_sym_preproc_if_token1] = ACTIONS(2885),
    [aux_sym_preproc_if_token2] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2885),
    [sym_preproc_directive] = ACTIONS(2885),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_BANG] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2887),
    [anon_sym_DASH] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym___extension__] = ACTIONS(2885),
    [anon_sym_typedef] = ACTIONS(2885),
    [anon_sym_in] = ACTIONS(2885),
    [anon_sym_out] = ACTIONS(2885),
    [anon_sym_inout] = ACTIONS(2885),
    [anon_sym_virtual] = ACTIONS(2885),
    [anon_sym_extern] = ACTIONS(2885),
    [anon_sym___attribute__] = ACTIONS(2885),
    [anon_sym___attribute] = ACTIONS(2885),
    [anon_sym_using] = ACTIONS(2885),
    [anon_sym_COLON_COLON] = ACTIONS(2887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2887),
    [anon_sym___declspec] = ACTIONS(2885),
    [anon_sym___based] = ACTIONS(2885),
    [anon_sym___cdecl] = ACTIONS(2885),
    [anon_sym___clrcall] = ACTIONS(2885),
    [anon_sym___stdcall] = ACTIONS(2885),
    [anon_sym___fastcall] = ACTIONS(2885),
    [anon_sym___thiscall] = ACTIONS(2885),
    [anon_sym___vectorcall] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_signed] = ACTIONS(2885),
    [anon_sym_unsigned] = ACTIONS(2885),
    [anon_sym_long] = ACTIONS(2885),
    [anon_sym_short] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_static] = ACTIONS(2885),
    [anon_sym_register] = ACTIONS(2885),
    [anon_sym_inline] = ACTIONS(2885),
    [anon_sym___inline] = ACTIONS(2885),
    [anon_sym___inline__] = ACTIONS(2885),
    [anon_sym___forceinline] = ACTIONS(2885),
    [anon_sym_thread_local] = ACTIONS(2885),
    [anon_sym___thread] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_constexpr] = ACTIONS(2885),
    [anon_sym_volatile] = ACTIONS(2885),
    [anon_sym_restrict] = ACTIONS(2885),
    [anon_sym___restrict__] = ACTIONS(2885),
    [anon_sym__Atomic] = ACTIONS(2885),
    [anon_sym__Noreturn] = ACTIONS(2885),
    [anon_sym_noreturn] = ACTIONS(2885),
    [anon_sym__Nonnull] = ACTIONS(2885),
    [anon_sym_mutable] = ACTIONS(2885),
    [anon_sym_constinit] = ACTIONS(2885),
    [anon_sym_consteval] = ACTIONS(2885),
    [anon_sym_alignas] = ACTIONS(2885),
    [anon_sym__Alignas] = ACTIONS(2885),
    [sym_primitive_type] = ACTIONS(2885),
    [anon_sym_enum] = ACTIONS(2885),
    [anon_sym_class] = ACTIONS(2885),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_union] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_else] = ACTIONS(2885),
    [anon_sym_switch] = ACTIONS(2885),
    [anon_sym_case] = ACTIONS(2885),
    [anon_sym_default] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [anon_sym_do] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_break] = ACTIONS(2885),
    [anon_sym_continue] = ACTIONS(2885),
    [anon_sym_goto] = ACTIONS(2885),
    [anon_sym___try] = ACTIONS(2885),
    [anon_sym___leave] = ACTIONS(2885),
    [anon_sym_not] = ACTIONS(2885),
    [anon_sym_compl] = ACTIONS(2885),
    [anon_sym_DASH_DASH] = ACTIONS(2887),
    [anon_sym_PLUS_PLUS] = ACTIONS(2887),
    [anon_sym_sizeof] = ACTIONS(2885),
    [anon_sym___alignof__] = ACTIONS(2885),
    [anon_sym___alignof] = ACTIONS(2885),
    [anon_sym__alignof] = ACTIONS(2885),
    [anon_sym_alignof] = ACTIONS(2885),
    [anon_sym__Alignof] = ACTIONS(2885),
    [anon_sym_offsetof] = ACTIONS(2885),
    [anon_sym__Generic] = ACTIONS(2885),
    [anon_sym_asm] = ACTIONS(2885),
    [anon_sym___asm__] = ACTIONS(2885),
    [anon_sym___asm] = ACTIONS(2885),
    [sym_number_literal] = ACTIONS(2887),
    [anon_sym_L_SQUOTE] = ACTIONS(2887),
    [anon_sym_u_SQUOTE] = ACTIONS(2887),
    [anon_sym_U_SQUOTE] = ACTIONS(2887),
    [anon_sym_u8_SQUOTE] = ACTIONS(2887),
    [anon_sym_SQUOTE] = ACTIONS(2887),
    [anon_sym_L_DQUOTE] = ACTIONS(2887),
    [anon_sym_u_DQUOTE] = ACTIONS(2887),
    [anon_sym_U_DQUOTE] = ACTIONS(2887),
    [anon_sym_u8_DQUOTE] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [sym_true] = ACTIONS(2885),
    [sym_false] = ACTIONS(2885),
    [anon_sym_NULL] = ACTIONS(2885),
    [anon_sym_nullptr] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2885),
    [anon_sym_let] = ACTIONS(2885),
    [anon_sym_This] = ACTIONS(2885),
    [anon_sym_decltype] = ACTIONS(2885),
    [anon_sym_explicit] = ACTIONS(2885),
    [anon_sym_typename] = ACTIONS(2885),
    [anon_sym_template] = ACTIONS(2885),
    [anon_sym_operator] = ACTIONS(2885),
    [anon_sym_try] = ACTIONS(2885),
    [anon_sym_delete] = ACTIONS(2885),
    [anon_sym_throw] = ACTIONS(2885),
    [anon_sym_namespace] = ACTIONS(2885),
    [anon_sym_static_assert] = ACTIONS(2885),
    [anon_sym_concept] = ACTIONS(2885),
    [anon_sym_co_return] = ACTIONS(2885),
    [anon_sym_co_yield] = ACTIONS(2885),
    [anon_sym_catch] = ACTIONS(3981),
    [anon_sym_R_DQUOTE] = ACTIONS(2887),
    [anon_sym_LR_DQUOTE] = ACTIONS(2887),
    [anon_sym_uR_DQUOTE] = ACTIONS(2887),
    [anon_sym_UR_DQUOTE] = ACTIONS(2887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2887),
    [anon_sym_co_await] = ACTIONS(2885),
    [anon_sym_new] = ACTIONS(2885),
    [anon_sym_requires] = ACTIONS(2885),
    [sym_this] = ACTIONS(2885),
    [anon_sym_discard] = ACTIONS(2885),
    [anon_sym_precise] = ACTIONS(2885),
    [anon_sym_shared] = ACTIONS(2885),
    [anon_sym_groupshared] = ACTIONS(2885),
    [anon_sym_uniform] = ACTIONS(2885),
    [anon_sym_row_major] = ACTIONS(2885),
    [anon_sym_column_major] = ACTIONS(2885),
    [anon_sym_globallycoherent] = ACTIONS(2885),
    [anon_sym_centroid] = ACTIONS(2885),
    [anon_sym_noperspective] = ACTIONS(2885),
    [anon_sym_nointerpolation] = ACTIONS(2885),
    [anon_sym_sample] = ACTIONS(2885),
    [anon_sym_linear] = ACTIONS(2885),
    [anon_sym_snorm] = ACTIONS(2885),
    [anon_sym_unorm] = ACTIONS(2885),
    [anon_sym_point] = ACTIONS(2885),
    [anon_sym_line] = ACTIONS(2885),
    [anon_sym_triangleadj] = ACTIONS(2885),
    [anon_sym_lineadj] = ACTIONS(2885),
    [anon_sym_triangle] = ACTIONS(2885),
    [anon_sym_cbuffer] = ACTIONS(2885),
    [anon_sym_interface] = ACTIONS(2885),
    [anon_sym_extension] = ACTIONS(2885),
  },
  [631] = {
    [sym_identifier] = ACTIONS(3983),
    [aux_sym_preproc_include_token1] = ACTIONS(3983),
    [aux_sym_preproc_def_token1] = ACTIONS(3983),
    [aux_sym_preproc_if_token1] = ACTIONS(3983),
    [aux_sym_preproc_if_token2] = ACTIONS(3983),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3983),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3983),
    [aux_sym_preproc_else_token1] = ACTIONS(3983),
    [aux_sym_preproc_elif_token1] = ACTIONS(3983),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3983),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3983),
    [sym_preproc_directive] = ACTIONS(3983),
    [anon_sym_LPAREN2] = ACTIONS(3985),
    [anon_sym_BANG] = ACTIONS(3985),
    [anon_sym_TILDE] = ACTIONS(3985),
    [anon_sym_DASH] = ACTIONS(3983),
    [anon_sym_PLUS] = ACTIONS(3983),
    [anon_sym_STAR] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3983),
    [anon_sym_SEMI] = ACTIONS(3985),
    [anon_sym___extension__] = ACTIONS(3983),
    [anon_sym_typedef] = ACTIONS(3983),
    [anon_sym_in] = ACTIONS(3983),
    [anon_sym_out] = ACTIONS(3983),
    [anon_sym_inout] = ACTIONS(3983),
    [anon_sym_virtual] = ACTIONS(3983),
    [anon_sym_extern] = ACTIONS(3983),
    [anon_sym___attribute__] = ACTIONS(3983),
    [anon_sym___attribute] = ACTIONS(3983),
    [anon_sym_using] = ACTIONS(3983),
    [anon_sym_COLON_COLON] = ACTIONS(3985),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3985),
    [anon_sym___declspec] = ACTIONS(3983),
    [anon_sym___based] = ACTIONS(3983),
    [anon_sym___cdecl] = ACTIONS(3983),
    [anon_sym___clrcall] = ACTIONS(3983),
    [anon_sym___stdcall] = ACTIONS(3983),
    [anon_sym___fastcall] = ACTIONS(3983),
    [anon_sym___thiscall] = ACTIONS(3983),
    [anon_sym___vectorcall] = ACTIONS(3983),
    [anon_sym_LBRACE] = ACTIONS(3985),
    [anon_sym_signed] = ACTIONS(3983),
    [anon_sym_unsigned] = ACTIONS(3983),
    [anon_sym_long] = ACTIONS(3983),
    [anon_sym_short] = ACTIONS(3983),
    [anon_sym_LBRACK] = ACTIONS(3983),
    [anon_sym_static] = ACTIONS(3983),
    [anon_sym_register] = ACTIONS(3983),
    [anon_sym_inline] = ACTIONS(3983),
    [anon_sym___inline] = ACTIONS(3983),
    [anon_sym___inline__] = ACTIONS(3983),
    [anon_sym___forceinline] = ACTIONS(3983),
    [anon_sym_thread_local] = ACTIONS(3983),
    [anon_sym___thread] = ACTIONS(3983),
    [anon_sym_const] = ACTIONS(3983),
    [anon_sym_constexpr] = ACTIONS(3983),
    [anon_sym_volatile] = ACTIONS(3983),
    [anon_sym_restrict] = ACTIONS(3983),
    [anon_sym___restrict__] = ACTIONS(3983),
    [anon_sym__Atomic] = ACTIONS(3983),
    [anon_sym__Noreturn] = ACTIONS(3983),
    [anon_sym_noreturn] = ACTIONS(3983),
    [anon_sym__Nonnull] = ACTIONS(3983),
    [anon_sym_mutable] = ACTIONS(3983),
    [anon_sym_constinit] = ACTIONS(3983),
    [anon_sym_consteval] = ACTIONS(3983),
    [anon_sym_alignas] = ACTIONS(3983),
    [anon_sym__Alignas] = ACTIONS(3983),
    [sym_primitive_type] = ACTIONS(3983),
    [anon_sym_enum] = ACTIONS(3983),
    [anon_sym_class] = ACTIONS(3983),
    [anon_sym_struct] = ACTIONS(3983),
    [anon_sym_union] = ACTIONS(3983),
    [anon_sym_if] = ACTIONS(3983),
    [anon_sym_switch] = ACTIONS(3983),
    [anon_sym_case] = ACTIONS(3983),
    [anon_sym_default] = ACTIONS(3983),
    [anon_sym_while] = ACTIONS(3983),
    [anon_sym_do] = ACTIONS(3983),
    [anon_sym_for] = ACTIONS(3983),
    [anon_sym_return] = ACTIONS(3983),
    [anon_sym_break] = ACTIONS(3983),
    [anon_sym_continue] = ACTIONS(3983),
    [anon_sym_goto] = ACTIONS(3983),
    [anon_sym___try] = ACTIONS(3983),
    [anon_sym___leave] = ACTIONS(3983),
    [anon_sym_not] = ACTIONS(3983),
    [anon_sym_compl] = ACTIONS(3983),
    [anon_sym_DASH_DASH] = ACTIONS(3985),
    [anon_sym_PLUS_PLUS] = ACTIONS(3985),
    [anon_sym_sizeof] = ACTIONS(3983),
    [anon_sym___alignof__] = ACTIONS(3983),
    [anon_sym___alignof] = ACTIONS(3983),
    [anon_sym__alignof] = ACTIONS(3983),
    [anon_sym_alignof] = ACTIONS(3983),
    [anon_sym__Alignof] = ACTIONS(3983),
    [anon_sym_offsetof] = ACTIONS(3983),
    [anon_sym__Generic] = ACTIONS(3983),
    [anon_sym_asm] = ACTIONS(3983),
    [anon_sym___asm__] = ACTIONS(3983),
    [anon_sym___asm] = ACTIONS(3983),
    [sym_number_literal] = ACTIONS(3985),
    [anon_sym_L_SQUOTE] = ACTIONS(3985),
    [anon_sym_u_SQUOTE] = ACTIONS(3985),
    [anon_sym_U_SQUOTE] = ACTIONS(3985),
    [anon_sym_u8_SQUOTE] = ACTIONS(3985),
    [anon_sym_SQUOTE] = ACTIONS(3985),
    [anon_sym_L_DQUOTE] = ACTIONS(3985),
    [anon_sym_u_DQUOTE] = ACTIONS(3985),
    [anon_sym_U_DQUOTE] = ACTIONS(3985),
    [anon_sym_u8_DQUOTE] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [sym_true] = ACTIONS(3983),
    [sym_false] = ACTIONS(3983),
    [anon_sym_NULL] = ACTIONS(3983),
    [anon_sym_nullptr] = ACTIONS(3983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3983),
    [anon_sym_let] = ACTIONS(3983),
    [anon_sym_This] = ACTIONS(3983),
    [anon_sym_decltype] = ACTIONS(3983),
    [anon_sym_explicit] = ACTIONS(3983),
    [anon_sym_typename] = ACTIONS(3983),
    [anon_sym_template] = ACTIONS(3983),
    [anon_sym_operator] = ACTIONS(3983),
    [anon_sym_try] = ACTIONS(3983),
    [anon_sym_delete] = ACTIONS(3983),
    [anon_sym_throw] = ACTIONS(3983),
    [anon_sym_namespace] = ACTIONS(3983),
    [anon_sym_static_assert] = ACTIONS(3983),
    [anon_sym_concept] = ACTIONS(3983),
    [anon_sym_co_return] = ACTIONS(3983),
    [anon_sym_co_yield] = ACTIONS(3983),
    [anon_sym_R_DQUOTE] = ACTIONS(3985),
    [anon_sym_LR_DQUOTE] = ACTIONS(3985),
    [anon_sym_uR_DQUOTE] = ACTIONS(3985),
    [anon_sym_UR_DQUOTE] = ACTIONS(3985),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3985),
    [anon_sym_co_await] = ACTIONS(3983),
    [anon_sym_new] = ACTIONS(3983),
    [anon_sym_requires] = ACTIONS(3983),
    [sym_this] = ACTIONS(3983),
    [anon_sym_discard] = ACTIONS(3983),
    [anon_sym_precise] = ACTIONS(3983),
    [anon_sym_shared] = ACTIONS(3983),
    [anon_sym_groupshared] = ACTIONS(3983),
    [anon_sym_uniform] = ACTIONS(3983),
    [anon_sym_row_major] = ACTIONS(3983),
    [anon_sym_column_major] = ACTIONS(3983),
    [anon_sym_globallycoherent] = ACTIONS(3983),
    [anon_sym_centroid] = ACTIONS(3983),
    [anon_sym_noperspective] = ACTIONS(3983),
    [anon_sym_nointerpolation] = ACTIONS(3983),
    [anon_sym_sample] = ACTIONS(3983),
    [anon_sym_linear] = ACTIONS(3983),
    [anon_sym_snorm] = ACTIONS(3983),
    [anon_sym_unorm] = ACTIONS(3983),
    [anon_sym_point] = ACTIONS(3983),
    [anon_sym_line] = ACTIONS(3983),
    [anon_sym_triangleadj] = ACTIONS(3983),
    [anon_sym_lineadj] = ACTIONS(3983),
    [anon_sym_triangle] = ACTIONS(3983),
    [anon_sym_cbuffer] = ACTIONS(3983),
    [anon_sym_interface] = ACTIONS(3983),
    [anon_sym_extension] = ACTIONS(3983),
  },
  [632] = {
    [sym_attribute_specifier] = STATE(317),
    [sym_enumerator_list] = STATE(654),
    [ts_builtin_sym_end] = ACTIONS(3987),
    [sym_identifier] = ACTIONS(3989),
    [aux_sym_preproc_include_token1] = ACTIONS(3989),
    [aux_sym_preproc_def_token1] = ACTIONS(3989),
    [aux_sym_preproc_if_token1] = ACTIONS(3989),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3989),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3989),
    [sym_preproc_directive] = ACTIONS(3989),
    [anon_sym_LPAREN2] = ACTIONS(3987),
    [anon_sym_BANG] = ACTIONS(3987),
    [anon_sym_TILDE] = ACTIONS(3987),
    [anon_sym_DASH] = ACTIONS(3989),
    [anon_sym_PLUS] = ACTIONS(3989),
    [anon_sym_STAR] = ACTIONS(3987),
    [anon_sym_AMP_AMP] = ACTIONS(3987),
    [anon_sym_AMP] = ACTIONS(3989),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym___extension__] = ACTIONS(3989),
    [anon_sym_typedef] = ACTIONS(3989),
    [anon_sym_in] = ACTIONS(3989),
    [anon_sym_out] = ACTIONS(3989),
    [anon_sym_inout] = ACTIONS(3989),
    [anon_sym_virtual] = ACTIONS(3989),
    [anon_sym_extern] = ACTIONS(3989),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(3989),
    [anon_sym_COLON_COLON] = ACTIONS(3987),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3987),
    [anon_sym___declspec] = ACTIONS(3989),
    [anon_sym___based] = ACTIONS(3989),
    [anon_sym___cdecl] = ACTIONS(3989),
    [anon_sym___clrcall] = ACTIONS(3989),
    [anon_sym___stdcall] = ACTIONS(3989),
    [anon_sym___fastcall] = ACTIONS(3989),
    [anon_sym___thiscall] = ACTIONS(3989),
    [anon_sym___vectorcall] = ACTIONS(3989),
    [anon_sym_LBRACE] = ACTIONS(3516),
    [anon_sym_signed] = ACTIONS(3989),
    [anon_sym_unsigned] = ACTIONS(3989),
    [anon_sym_long] = ACTIONS(3989),
    [anon_sym_short] = ACTIONS(3989),
    [anon_sym_LBRACK] = ACTIONS(3989),
    [anon_sym_static] = ACTIONS(3989),
    [anon_sym_register] = ACTIONS(3989),
    [anon_sym_inline] = ACTIONS(3989),
    [anon_sym___inline] = ACTIONS(3989),
    [anon_sym___inline__] = ACTIONS(3989),
    [anon_sym___forceinline] = ACTIONS(3989),
    [anon_sym_thread_local] = ACTIONS(3989),
    [anon_sym___thread] = ACTIONS(3989),
    [anon_sym_const] = ACTIONS(3989),
    [anon_sym_constexpr] = ACTIONS(3989),
    [anon_sym_volatile] = ACTIONS(3989),
    [anon_sym_restrict] = ACTIONS(3989),
    [anon_sym___restrict__] = ACTIONS(3989),
    [anon_sym__Atomic] = ACTIONS(3989),
    [anon_sym__Noreturn] = ACTIONS(3989),
    [anon_sym_noreturn] = ACTIONS(3989),
    [anon_sym__Nonnull] = ACTIONS(3989),
    [anon_sym_mutable] = ACTIONS(3989),
    [anon_sym_constinit] = ACTIONS(3989),
    [anon_sym_consteval] = ACTIONS(3989),
    [anon_sym_alignas] = ACTIONS(3989),
    [anon_sym__Alignas] = ACTIONS(3989),
    [sym_primitive_type] = ACTIONS(3989),
    [anon_sym_enum] = ACTIONS(3989),
    [anon_sym_class] = ACTIONS(3989),
    [anon_sym_struct] = ACTIONS(3989),
    [anon_sym_union] = ACTIONS(3989),
    [anon_sym_if] = ACTIONS(3989),
    [anon_sym_switch] = ACTIONS(3989),
    [anon_sym_case] = ACTIONS(3989),
    [anon_sym_default] = ACTIONS(3989),
    [anon_sym_while] = ACTIONS(3989),
    [anon_sym_do] = ACTIONS(3989),
    [anon_sym_for] = ACTIONS(3989),
    [anon_sym_return] = ACTIONS(3989),
    [anon_sym_break] = ACTIONS(3989),
    [anon_sym_continue] = ACTIONS(3989),
    [anon_sym_goto] = ACTIONS(3989),
    [anon_sym_not] = ACTIONS(3989),
    [anon_sym_compl] = ACTIONS(3989),
    [anon_sym_DASH_DASH] = ACTIONS(3987),
    [anon_sym_PLUS_PLUS] = ACTIONS(3987),
    [anon_sym_sizeof] = ACTIONS(3989),
    [anon_sym___alignof__] = ACTIONS(3989),
    [anon_sym___alignof] = ACTIONS(3989),
    [anon_sym__alignof] = ACTIONS(3989),
    [anon_sym_alignof] = ACTIONS(3989),
    [anon_sym__Alignof] = ACTIONS(3989),
    [anon_sym_offsetof] = ACTIONS(3989),
    [anon_sym__Generic] = ACTIONS(3989),
    [anon_sym_asm] = ACTIONS(3989),
    [anon_sym___asm__] = ACTIONS(3989),
    [anon_sym___asm] = ACTIONS(3989),
    [anon_sym_DOT] = ACTIONS(3989),
    [sym_number_literal] = ACTIONS(3987),
    [anon_sym_L_SQUOTE] = ACTIONS(3987),
    [anon_sym_u_SQUOTE] = ACTIONS(3987),
    [anon_sym_U_SQUOTE] = ACTIONS(3987),
    [anon_sym_u8_SQUOTE] = ACTIONS(3987),
    [anon_sym_SQUOTE] = ACTIONS(3987),
    [anon_sym_L_DQUOTE] = ACTIONS(3987),
    [anon_sym_u_DQUOTE] = ACTIONS(3987),
    [anon_sym_U_DQUOTE] = ACTIONS(3987),
    [anon_sym_u8_DQUOTE] = ACTIONS(3987),
    [anon_sym_DQUOTE] = ACTIONS(3987),
    [sym_true] = ACTIONS(3989),
    [sym_false] = ACTIONS(3989),
    [anon_sym_NULL] = ACTIONS(3989),
    [anon_sym_nullptr] = ACTIONS(3989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3989),
    [anon_sym_let] = ACTIONS(3989),
    [anon_sym_This] = ACTIONS(3989),
    [anon_sym_decltype] = ACTIONS(3989),
    [anon_sym_explicit] = ACTIONS(3989),
    [anon_sym_typename] = ACTIONS(3989),
    [anon_sym_export] = ACTIONS(3989),
    [anon_sym_module] = ACTIONS(3989),
    [anon_sym_import] = ACTIONS(3989),
    [anon_sym_template] = ACTIONS(3989),
    [anon_sym_operator] = ACTIONS(3989),
    [anon_sym_try] = ACTIONS(3989),
    [anon_sym_delete] = ACTIONS(3989),
    [anon_sym_throw] = ACTIONS(3989),
    [anon_sym_namespace] = ACTIONS(3989),
    [anon_sym_static_assert] = ACTIONS(3989),
    [anon_sym_concept] = ACTIONS(3989),
    [anon_sym_co_return] = ACTIONS(3989),
    [anon_sym_co_yield] = ACTIONS(3989),
    [anon_sym_R_DQUOTE] = ACTIONS(3987),
    [anon_sym_LR_DQUOTE] = ACTIONS(3987),
    [anon_sym_uR_DQUOTE] = ACTIONS(3987),
    [anon_sym_UR_DQUOTE] = ACTIONS(3987),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3987),
    [anon_sym_co_await] = ACTIONS(3989),
    [anon_sym_new] = ACTIONS(3989),
    [anon_sym_requires] = ACTIONS(3989),
    [sym_this] = ACTIONS(3989),
    [anon_sym_precise] = ACTIONS(3989),
    [anon_sym_shared] = ACTIONS(3989),
    [anon_sym_groupshared] = ACTIONS(3989),
    [anon_sym_uniform] = ACTIONS(3989),
    [anon_sym_row_major] = ACTIONS(3989),
    [anon_sym_column_major] = ACTIONS(3989),
    [anon_sym_globallycoherent] = ACTIONS(3989),
    [anon_sym_centroid] = ACTIONS(3989),
    [anon_sym_noperspective] = ACTIONS(3989),
    [anon_sym_nointerpolation] = ACTIONS(3989),
    [anon_sym_sample] = ACTIONS(3989),
    [anon_sym_linear] = ACTIONS(3989),
    [anon_sym_snorm] = ACTIONS(3989),
    [anon_sym_unorm] = ACTIONS(3989),
    [anon_sym_point] = ACTIONS(3989),
    [anon_sym_line] = ACTIONS(3989),
    [anon_sym_triangleadj] = ACTIONS(3989),
    [anon_sym_lineadj] = ACTIONS(3989),
    [anon_sym_triangle] = ACTIONS(3989),
    [anon_sym_interface] = ACTIONS(3989),
    [anon_sym_extension] = ACTIONS(3989),
    [anon_sym___exported] = ACTIONS(3989),
  },
  [633] = {
    [sym_catch_clause] = STATE(267),
    [aux_sym_constructor_try_statement_repeat1] = STATE(267),
    [ts_builtin_sym_end] = ACTIONS(2922),
    [sym_identifier] = ACTIONS(2920),
    [aux_sym_preproc_include_token1] = ACTIONS(2920),
    [aux_sym_preproc_def_token1] = ACTIONS(2920),
    [aux_sym_preproc_if_token1] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2920),
    [sym_preproc_directive] = ACTIONS(2920),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2920),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2920),
    [anon_sym_SEMI] = ACTIONS(2922),
    [anon_sym___extension__] = ACTIONS(2920),
    [anon_sym_typedef] = ACTIONS(2920),
    [anon_sym_in] = ACTIONS(2920),
    [anon_sym_out] = ACTIONS(2920),
    [anon_sym_inout] = ACTIONS(2920),
    [anon_sym_virtual] = ACTIONS(2920),
    [anon_sym_extern] = ACTIONS(2920),
    [anon_sym___attribute__] = ACTIONS(2920),
    [anon_sym___attribute] = ACTIONS(2920),
    [anon_sym_using] = ACTIONS(2920),
    [anon_sym_COLON_COLON] = ACTIONS(2922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2922),
    [anon_sym___declspec] = ACTIONS(2920),
    [anon_sym___based] = ACTIONS(2920),
    [anon_sym___cdecl] = ACTIONS(2920),
    [anon_sym___clrcall] = ACTIONS(2920),
    [anon_sym___stdcall] = ACTIONS(2920),
    [anon_sym___fastcall] = ACTIONS(2920),
    [anon_sym___thiscall] = ACTIONS(2920),
    [anon_sym___vectorcall] = ACTIONS(2920),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_signed] = ACTIONS(2920),
    [anon_sym_unsigned] = ACTIONS(2920),
    [anon_sym_long] = ACTIONS(2920),
    [anon_sym_short] = ACTIONS(2920),
    [anon_sym_LBRACK] = ACTIONS(2920),
    [anon_sym_static] = ACTIONS(2920),
    [anon_sym_register] = ACTIONS(2920),
    [anon_sym_inline] = ACTIONS(2920),
    [anon_sym___inline] = ACTIONS(2920),
    [anon_sym___inline__] = ACTIONS(2920),
    [anon_sym___forceinline] = ACTIONS(2920),
    [anon_sym_thread_local] = ACTIONS(2920),
    [anon_sym___thread] = ACTIONS(2920),
    [anon_sym_const] = ACTIONS(2920),
    [anon_sym_constexpr] = ACTIONS(2920),
    [anon_sym_volatile] = ACTIONS(2920),
    [anon_sym_restrict] = ACTIONS(2920),
    [anon_sym___restrict__] = ACTIONS(2920),
    [anon_sym__Atomic] = ACTIONS(2920),
    [anon_sym__Noreturn] = ACTIONS(2920),
    [anon_sym_noreturn] = ACTIONS(2920),
    [anon_sym__Nonnull] = ACTIONS(2920),
    [anon_sym_mutable] = ACTIONS(2920),
    [anon_sym_constinit] = ACTIONS(2920),
    [anon_sym_consteval] = ACTIONS(2920),
    [anon_sym_alignas] = ACTIONS(2920),
    [anon_sym__Alignas] = ACTIONS(2920),
    [sym_primitive_type] = ACTIONS(2920),
    [anon_sym_enum] = ACTIONS(2920),
    [anon_sym_class] = ACTIONS(2920),
    [anon_sym_struct] = ACTIONS(2920),
    [anon_sym_union] = ACTIONS(2920),
    [anon_sym_if] = ACTIONS(2920),
    [anon_sym_switch] = ACTIONS(2920),
    [anon_sym_case] = ACTIONS(2920),
    [anon_sym_default] = ACTIONS(2920),
    [anon_sym_while] = ACTIONS(2920),
    [anon_sym_do] = ACTIONS(2920),
    [anon_sym_for] = ACTIONS(2920),
    [anon_sym_return] = ACTIONS(2920),
    [anon_sym_break] = ACTIONS(2920),
    [anon_sym_continue] = ACTIONS(2920),
    [anon_sym_goto] = ACTIONS(2920),
    [anon_sym_not] = ACTIONS(2920),
    [anon_sym_compl] = ACTIONS(2920),
    [anon_sym_DASH_DASH] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2922),
    [anon_sym_sizeof] = ACTIONS(2920),
    [anon_sym___alignof__] = ACTIONS(2920),
    [anon_sym___alignof] = ACTIONS(2920),
    [anon_sym__alignof] = ACTIONS(2920),
    [anon_sym_alignof] = ACTIONS(2920),
    [anon_sym__Alignof] = ACTIONS(2920),
    [anon_sym_offsetof] = ACTIONS(2920),
    [anon_sym__Generic] = ACTIONS(2920),
    [anon_sym_asm] = ACTIONS(2920),
    [anon_sym___asm__] = ACTIONS(2920),
    [anon_sym___asm] = ACTIONS(2920),
    [sym_number_literal] = ACTIONS(2922),
    [anon_sym_L_SQUOTE] = ACTIONS(2922),
    [anon_sym_u_SQUOTE] = ACTIONS(2922),
    [anon_sym_U_SQUOTE] = ACTIONS(2922),
    [anon_sym_u8_SQUOTE] = ACTIONS(2922),
    [anon_sym_SQUOTE] = ACTIONS(2922),
    [anon_sym_L_DQUOTE] = ACTIONS(2922),
    [anon_sym_u_DQUOTE] = ACTIONS(2922),
    [anon_sym_U_DQUOTE] = ACTIONS(2922),
    [anon_sym_u8_DQUOTE] = ACTIONS(2922),
    [anon_sym_DQUOTE] = ACTIONS(2922),
    [sym_true] = ACTIONS(2920),
    [sym_false] = ACTIONS(2920),
    [anon_sym_NULL] = ACTIONS(2920),
    [anon_sym_nullptr] = ACTIONS(2920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2920),
    [anon_sym_let] = ACTIONS(2920),
    [anon_sym_This] = ACTIONS(2920),
    [anon_sym_decltype] = ACTIONS(2920),
    [anon_sym_explicit] = ACTIONS(2920),
    [anon_sym_typename] = ACTIONS(2920),
    [anon_sym_export] = ACTIONS(2920),
    [anon_sym_module] = ACTIONS(2920),
    [anon_sym_import] = ACTIONS(2920),
    [anon_sym_template] = ACTIONS(2920),
    [anon_sym_operator] = ACTIONS(2920),
    [anon_sym_try] = ACTIONS(2920),
    [anon_sym_delete] = ACTIONS(2920),
    [anon_sym_throw] = ACTIONS(2920),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_static_assert] = ACTIONS(2920),
    [anon_sym_concept] = ACTIONS(2920),
    [anon_sym_co_return] = ACTIONS(2920),
    [anon_sym_co_yield] = ACTIONS(2920),
    [anon_sym_catch] = ACTIONS(2891),
    [anon_sym_R_DQUOTE] = ACTIONS(2922),
    [anon_sym_LR_DQUOTE] = ACTIONS(2922),
    [anon_sym_uR_DQUOTE] = ACTIONS(2922),
    [anon_sym_UR_DQUOTE] = ACTIONS(2922),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2922),
    [anon_sym_co_await] = ACTIONS(2920),
    [anon_sym_new] = ACTIONS(2920),
    [anon_sym_requires] = ACTIONS(2920),
    [sym_this] = ACTIONS(2920),
    [anon_sym_precise] = ACTIONS(2920),
    [anon_sym_shared] = ACTIONS(2920),
    [anon_sym_groupshared] = ACTIONS(2920),
    [anon_sym_uniform] = ACTIONS(2920),
    [anon_sym_row_major] = ACTIONS(2920),
    [anon_sym_column_major] = ACTIONS(2920),
    [anon_sym_globallycoherent] = ACTIONS(2920),
    [anon_sym_centroid] = ACTIONS(2920),
    [anon_sym_noperspective] = ACTIONS(2920),
    [anon_sym_nointerpolation] = ACTIONS(2920),
    [anon_sym_sample] = ACTIONS(2920),
    [anon_sym_linear] = ACTIONS(2920),
    [anon_sym_snorm] = ACTIONS(2920),
    [anon_sym_unorm] = ACTIONS(2920),
    [anon_sym_point] = ACTIONS(2920),
    [anon_sym_line] = ACTIONS(2920),
    [anon_sym_triangleadj] = ACTIONS(2920),
    [anon_sym_lineadj] = ACTIONS(2920),
    [anon_sym_triangle] = ACTIONS(2920),
    [anon_sym_interface] = ACTIONS(2920),
    [anon_sym_extension] = ACTIONS(2920),
    [anon_sym___exported] = ACTIONS(2920),
  },
  [634] = {
    [sym_attribute_specifier] = STATE(781),
    [sym_enumerator_list] = STATE(713),
    [sym_identifier] = ACTIONS(3989),
    [aux_sym_preproc_include_token1] = ACTIONS(3989),
    [aux_sym_preproc_def_token1] = ACTIONS(3989),
    [aux_sym_preproc_if_token1] = ACTIONS(3989),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3989),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3989),
    [sym_preproc_directive] = ACTIONS(3989),
    [anon_sym_LPAREN2] = ACTIONS(3987),
    [anon_sym_BANG] = ACTIONS(3987),
    [anon_sym_TILDE] = ACTIONS(3987),
    [anon_sym_DASH] = ACTIONS(3989),
    [anon_sym_PLUS] = ACTIONS(3989),
    [anon_sym_STAR] = ACTIONS(3987),
    [anon_sym_AMP_AMP] = ACTIONS(3987),
    [anon_sym_AMP] = ACTIONS(3989),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym___extension__] = ACTIONS(3989),
    [anon_sym_typedef] = ACTIONS(3989),
    [anon_sym_in] = ACTIONS(3989),
    [anon_sym_out] = ACTIONS(3989),
    [anon_sym_inout] = ACTIONS(3989),
    [anon_sym_virtual] = ACTIONS(3989),
    [anon_sym_extern] = ACTIONS(3989),
    [anon_sym___attribute__] = ACTIONS(2897),
    [anon_sym___attribute] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(3989),
    [anon_sym_COLON_COLON] = ACTIONS(3987),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3987),
    [anon_sym___declspec] = ACTIONS(3989),
    [anon_sym___based] = ACTIONS(3989),
    [anon_sym___cdecl] = ACTIONS(3989),
    [anon_sym___clrcall] = ACTIONS(3989),
    [anon_sym___stdcall] = ACTIONS(3989),
    [anon_sym___fastcall] = ACTIONS(3989),
    [anon_sym___thiscall] = ACTIONS(3989),
    [anon_sym___vectorcall] = ACTIONS(3989),
    [anon_sym_LBRACE] = ACTIONS(3484),
    [anon_sym_RBRACE] = ACTIONS(3987),
    [anon_sym_signed] = ACTIONS(3989),
    [anon_sym_unsigned] = ACTIONS(3989),
    [anon_sym_long] = ACTIONS(3989),
    [anon_sym_short] = ACTIONS(3989),
    [anon_sym_LBRACK] = ACTIONS(3989),
    [anon_sym_static] = ACTIONS(3989),
    [anon_sym_register] = ACTIONS(3989),
    [anon_sym_inline] = ACTIONS(3989),
    [anon_sym___inline] = ACTIONS(3989),
    [anon_sym___inline__] = ACTIONS(3989),
    [anon_sym___forceinline] = ACTIONS(3989),
    [anon_sym_thread_local] = ACTIONS(3989),
    [anon_sym___thread] = ACTIONS(3989),
    [anon_sym_const] = ACTIONS(3989),
    [anon_sym_constexpr] = ACTIONS(3989),
    [anon_sym_volatile] = ACTIONS(3989),
    [anon_sym_restrict] = ACTIONS(3989),
    [anon_sym___restrict__] = ACTIONS(3989),
    [anon_sym__Atomic] = ACTIONS(3989),
    [anon_sym__Noreturn] = ACTIONS(3989),
    [anon_sym_noreturn] = ACTIONS(3989),
    [anon_sym__Nonnull] = ACTIONS(3989),
    [anon_sym_mutable] = ACTIONS(3989),
    [anon_sym_constinit] = ACTIONS(3989),
    [anon_sym_consteval] = ACTIONS(3989),
    [anon_sym_alignas] = ACTIONS(3989),
    [anon_sym__Alignas] = ACTIONS(3989),
    [sym_primitive_type] = ACTIONS(3989),
    [anon_sym_enum] = ACTIONS(3989),
    [anon_sym_class] = ACTIONS(3989),
    [anon_sym_struct] = ACTIONS(3989),
    [anon_sym_union] = ACTIONS(3989),
    [anon_sym_if] = ACTIONS(3989),
    [anon_sym_switch] = ACTIONS(3989),
    [anon_sym_case] = ACTIONS(3989),
    [anon_sym_default] = ACTIONS(3989),
    [anon_sym_while] = ACTIONS(3989),
    [anon_sym_do] = ACTIONS(3989),
    [anon_sym_for] = ACTIONS(3989),
    [anon_sym_return] = ACTIONS(3989),
    [anon_sym_break] = ACTIONS(3989),
    [anon_sym_continue] = ACTIONS(3989),
    [anon_sym_goto] = ACTIONS(3989),
    [anon_sym___try] = ACTIONS(3989),
    [anon_sym___leave] = ACTIONS(3989),
    [anon_sym_not] = ACTIONS(3989),
    [anon_sym_compl] = ACTIONS(3989),
    [anon_sym_DASH_DASH] = ACTIONS(3987),
    [anon_sym_PLUS_PLUS] = ACTIONS(3987),
    [anon_sym_sizeof] = ACTIONS(3989),
    [anon_sym___alignof__] = ACTIONS(3989),
    [anon_sym___alignof] = ACTIONS(3989),
    [anon_sym__alignof] = ACTIONS(3989),
    [anon_sym_alignof] = ACTIONS(3989),
    [anon_sym__Alignof] = ACTIONS(3989),
    [anon_sym_offsetof] = ACTIONS(3989),
    [anon_sym__Generic] = ACTIONS(3989),
    [anon_sym_asm] = ACTIONS(3989),
    [anon_sym___asm__] = ACTIONS(3989),
    [anon_sym___asm] = ACTIONS(3989),
    [anon_sym_DOT] = ACTIONS(3989),
    [sym_number_literal] = ACTIONS(3987),
    [anon_sym_L_SQUOTE] = ACTIONS(3987),
    [anon_sym_u_SQUOTE] = ACTIONS(3987),
    [anon_sym_U_SQUOTE] = ACTIONS(3987),
    [anon_sym_u8_SQUOTE] = ACTIONS(3987),
    [anon_sym_SQUOTE] = ACTIONS(3987),
    [anon_sym_L_DQUOTE] = ACTIONS(3987),
    [anon_sym_u_DQUOTE] = ACTIONS(3987),
    [anon_sym_U_DQUOTE] = ACTIONS(3987),
    [anon_sym_u8_DQUOTE] = ACTIONS(3987),
    [anon_sym_DQUOTE] = ACTIONS(3987),
    [sym_true] = ACTIONS(3989),
    [sym_false] = ACTIONS(3989),
    [anon_sym_NULL] = ACTIONS(3989),
    [anon_sym_nullptr] = ACTIONS(3989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3989),
    [anon_sym_let] = ACTIONS(3989),
    [anon_sym_This] = ACTIONS(3989),
    [anon_sym_decltype] = ACTIONS(3989),
    [anon_sym_explicit] = ACTIONS(3989),
    [anon_sym_typename] = ACTIONS(3989),
    [anon_sym_template] = ACTIONS(3989),
    [anon_sym_operator] = ACTIONS(3989),
    [anon_sym_try] = ACTIONS(3989),
    [anon_sym_delete] = ACTIONS(3989),
    [anon_sym_throw] = ACTIONS(3989),
    [anon_sym_namespace] = ACTIONS(3989),
    [anon_sym_static_assert] = ACTIONS(3989),
    [anon_sym_concept] = ACTIONS(3989),
    [anon_sym_co_return] = ACTIONS(3989),
    [anon_sym_co_yield] = ACTIONS(3989),
    [anon_sym_R_DQUOTE] = ACTIONS(3987),
    [anon_sym_LR_DQUOTE] = ACTIONS(3987),
    [anon_sym_uR_DQUOTE] = ACTIONS(3987),
    [anon_sym_UR_DQUOTE] = ACTIONS(3987),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3987),
    [anon_sym_co_await] = ACTIONS(3989),
    [anon_sym_new] = ACTIONS(3989),
    [anon_sym_requires] = ACTIONS(3989),
    [sym_this] = ACTIONS(3989),
    [anon_sym_discard] = ACTIONS(3989),
    [anon_sym_precise] = ACTIONS(3989),
    [anon_sym_shared] = ACTIONS(3989),
    [anon_sym_groupshared] = ACTIONS(3989),
    [anon_sym_uniform] = ACTIONS(3989),
    [anon_sym_row_major] = ACTIONS(3989),
    [anon_sym_column_major] = ACTIONS(3989),
    [anon_sym_globallycoherent] = ACTIONS(3989),
    [anon_sym_centroid] = ACTIONS(3989),
    [anon_sym_noperspective] = ACTIONS(3989),
    [anon_sym_nointerpolation] = ACTIONS(3989),
    [anon_sym_sample] = ACTIONS(3989),
    [anon_sym_linear] = ACTIONS(3989),
    [anon_sym_snorm] = ACTIONS(3989),
    [anon_sym_unorm] = ACTIONS(3989),
    [anon_sym_point] = ACTIONS(3989),
    [anon_sym_line] = ACTIONS(3989),
    [anon_sym_triangleadj] = ACTIONS(3989),
    [anon_sym_lineadj] = ACTIONS(3989),
    [anon_sym_triangle] = ACTIONS(3989),
    [anon_sym_cbuffer] = ACTIONS(3989),
    [anon_sym_interface] = ACTIONS(3989),
    [anon_sym_extension] = ACTIONS(3989),
  },
  [635] = {
    [sym_catch_clause] = STATE(267),
    [aux_sym_constructor_try_statement_repeat1] = STATE(267),
    [ts_builtin_sym_end] = ACTIONS(2970),
    [sym_identifier] = ACTIONS(2968),
    [aux_sym_preproc_include_token1] = ACTIONS(2968),
    [aux_sym_preproc_def_token1] = ACTIONS(2968),
    [aux_sym_preproc_if_token1] = ACTIONS(2968),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2968),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2968),
    [sym_preproc_directive] = ACTIONS(2968),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_BANG] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2968),
    [anon_sym_PLUS] = ACTIONS(2968),
    [anon_sym_STAR] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_AMP] = ACTIONS(2968),
    [anon_sym_SEMI] = ACTIONS(2970),
    [anon_sym___extension__] = ACTIONS(2968),
    [anon_sym_typedef] = ACTIONS(2968),
    [anon_sym_in] = ACTIONS(2968),
    [anon_sym_out] = ACTIONS(2968),
    [anon_sym_inout] = ACTIONS(2968),
    [anon_sym_virtual] = ACTIONS(2968),
    [anon_sym_extern] = ACTIONS(2968),
    [anon_sym___attribute__] = ACTIONS(2968),
    [anon_sym___attribute] = ACTIONS(2968),
    [anon_sym_using] = ACTIONS(2968),
    [anon_sym_COLON_COLON] = ACTIONS(2970),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2970),
    [anon_sym___declspec] = ACTIONS(2968),
    [anon_sym___based] = ACTIONS(2968),
    [anon_sym___cdecl] = ACTIONS(2968),
    [anon_sym___clrcall] = ACTIONS(2968),
    [anon_sym___stdcall] = ACTIONS(2968),
    [anon_sym___fastcall] = ACTIONS(2968),
    [anon_sym___thiscall] = ACTIONS(2968),
    [anon_sym___vectorcall] = ACTIONS(2968),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_signed] = ACTIONS(2968),
    [anon_sym_unsigned] = ACTIONS(2968),
    [anon_sym_long] = ACTIONS(2968),
    [anon_sym_short] = ACTIONS(2968),
    [anon_sym_LBRACK] = ACTIONS(2968),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_register] = ACTIONS(2968),
    [anon_sym_inline] = ACTIONS(2968),
    [anon_sym___inline] = ACTIONS(2968),
    [anon_sym___inline__] = ACTIONS(2968),
    [anon_sym___forceinline] = ACTIONS(2968),
    [anon_sym_thread_local] = ACTIONS(2968),
    [anon_sym___thread] = ACTIONS(2968),
    [anon_sym_const] = ACTIONS(2968),
    [anon_sym_constexpr] = ACTIONS(2968),
    [anon_sym_volatile] = ACTIONS(2968),
    [anon_sym_restrict] = ACTIONS(2968),
    [anon_sym___restrict__] = ACTIONS(2968),
    [anon_sym__Atomic] = ACTIONS(2968),
    [anon_sym__Noreturn] = ACTIONS(2968),
    [anon_sym_noreturn] = ACTIONS(2968),
    [anon_sym__Nonnull] = ACTIONS(2968),
    [anon_sym_mutable] = ACTIONS(2968),
    [anon_sym_constinit] = ACTIONS(2968),
    [anon_sym_consteval] = ACTIONS(2968),
    [anon_sym_alignas] = ACTIONS(2968),
    [anon_sym__Alignas] = ACTIONS(2968),
    [sym_primitive_type] = ACTIONS(2968),
    [anon_sym_enum] = ACTIONS(2968),
    [anon_sym_class] = ACTIONS(2968),
    [anon_sym_struct] = ACTIONS(2968),
    [anon_sym_union] = ACTIONS(2968),
    [anon_sym_if] = ACTIONS(2968),
    [anon_sym_switch] = ACTIONS(2968),
    [anon_sym_case] = ACTIONS(2968),
    [anon_sym_default] = ACTIONS(2968),
    [anon_sym_while] = ACTIONS(2968),
    [anon_sym_do] = ACTIONS(2968),
    [anon_sym_for] = ACTIONS(2968),
    [anon_sym_return] = ACTIONS(2968),
    [anon_sym_break] = ACTIONS(2968),
    [anon_sym_continue] = ACTIONS(2968),
    [anon_sym_goto] = ACTIONS(2968),
    [anon_sym_not] = ACTIONS(2968),
    [anon_sym_compl] = ACTIONS(2968),
    [anon_sym_DASH_DASH] = ACTIONS(2970),
    [anon_sym_PLUS_PLUS] = ACTIONS(2970),
    [anon_sym_sizeof] = ACTIONS(2968),
    [anon_sym___alignof__] = ACTIONS(2968),
    [anon_sym___alignof] = ACTIONS(2968),
    [anon_sym__alignof] = ACTIONS(2968),
    [anon_sym_alignof] = ACTIONS(2968),
    [anon_sym__Alignof] = ACTIONS(2968),
    [anon_sym_offsetof] = ACTIONS(2968),
    [anon_sym__Generic] = ACTIONS(2968),
    [anon_sym_asm] = ACTIONS(2968),
    [anon_sym___asm__] = ACTIONS(2968),
    [anon_sym___asm] = ACTIONS(2968),
    [sym_number_literal] = ACTIONS(2970),
    [anon_sym_L_SQUOTE] = ACTIONS(2970),
    [anon_sym_u_SQUOTE] = ACTIONS(2970),
    [anon_sym_U_SQUOTE] = ACTIONS(2970),
    [anon_sym_u8_SQUOTE] = ACTIONS(2970),
    [anon_sym_SQUOTE] = ACTIONS(2970),
    [anon_sym_L_DQUOTE] = ACTIONS(2970),
    [anon_sym_u_DQUOTE] = ACTIONS(2970),
    [anon_sym_U_DQUOTE] = ACTIONS(2970),
    [anon_sym_u8_DQUOTE] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(2970),
    [sym_true] = ACTIONS(2968),
    [sym_false] = ACTIONS(2968),
    [anon_sym_NULL] = ACTIONS(2968),
    [anon_sym_nullptr] = ACTIONS(2968),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2968),
    [anon_sym_let] = ACTIONS(2968),
    [anon_sym_This] = ACTIONS(2968),
    [anon_sym_decltype] = ACTIONS(2968),
    [anon_sym_explicit] = ACTIONS(2968),
    [anon_sym_typename] = ACTIONS(2968),
    [anon_sym_export] = ACTIONS(2968),
    [anon_sym_module] = ACTIONS(2968),
    [anon_sym_import] = ACTIONS(2968),
    [anon_sym_template] = ACTIONS(2968),
    [anon_sym_operator] = ACTIONS(2968),
    [anon_sym_try] = ACTIONS(2968),
    [anon_sym_delete] = ACTIONS(2968),
    [anon_sym_throw] = ACTIONS(2968),
    [anon_sym_namespace] = ACTIONS(2968),
    [anon_sym_static_assert] = ACTIONS(2968),
    [anon_sym_concept] = ACTIONS(2968),
    [anon_sym_co_return] = ACTIONS(2968),
    [anon_sym_co_yield] = ACTIONS(2968),
    [anon_sym_catch] = ACTIONS(2891),
    [anon_sym_R_DQUOTE] = ACTIONS(2970),
    [anon_sym_LR_DQUOTE] = ACTIONS(2970),
    [anon_sym_uR_DQUOTE] = ACTIONS(2970),
    [anon_sym_UR_DQUOTE] = ACTIONS(2970),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2970),
    [anon_sym_co_await] = ACTIONS(2968),
    [anon_sym_new] = ACTIONS(2968),
    [anon_sym_requires] = ACTIONS(2968),
    [sym_this] = ACTIONS(2968),
    [anon_sym_precise] = ACTIONS(2968),
    [anon_sym_shared] = ACTIONS(2968),
    [anon_sym_groupshared] = ACTIONS(2968),
    [anon_sym_uniform] = ACTIONS(2968),
    [anon_sym_row_major] = ACTIONS(2968),
    [anon_sym_column_major] = ACTIONS(2968),
    [anon_sym_globallycoherent] = ACTIONS(2968),
    [anon_sym_centroid] = ACTIONS(2968),
    [anon_sym_noperspective] = ACTIONS(2968),
    [anon_sym_nointerpolation] = ACTIONS(2968),
    [anon_sym_sample] = ACTIONS(2968),
    [anon_sym_linear] = ACTIONS(2968),
    [anon_sym_snorm] = ACTIONS(2968),
    [anon_sym_unorm] = ACTIONS(2968),
    [anon_sym_point] = ACTIONS(2968),
    [anon_sym_line] = ACTIONS(2968),
    [anon_sym_triangleadj] = ACTIONS(2968),
    [anon_sym_lineadj] = ACTIONS(2968),
    [anon_sym_triangle] = ACTIONS(2968),
    [anon_sym_interface] = ACTIONS(2968),
    [anon_sym_extension] = ACTIONS(2968),
    [anon_sym___exported] = ACTIONS(2968),
  },
  [636] = {
    [sym_catch_clause] = STATE(616),
    [aux_sym_constructor_try_statement_repeat1] = STATE(616),
    [sym_identifier] = ACTIONS(2920),
    [aux_sym_preproc_include_token1] = ACTIONS(2920),
    [aux_sym_preproc_def_token1] = ACTIONS(2920),
    [aux_sym_preproc_if_token1] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2920),
    [sym_preproc_directive] = ACTIONS(2920),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2920),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2920),
    [anon_sym_SEMI] = ACTIONS(2922),
    [anon_sym___extension__] = ACTIONS(2920),
    [anon_sym_typedef] = ACTIONS(2920),
    [anon_sym_in] = ACTIONS(2920),
    [anon_sym_out] = ACTIONS(2920),
    [anon_sym_inout] = ACTIONS(2920),
    [anon_sym_virtual] = ACTIONS(2920),
    [anon_sym_extern] = ACTIONS(2920),
    [anon_sym___attribute__] = ACTIONS(2920),
    [anon_sym___attribute] = ACTIONS(2920),
    [anon_sym_using] = ACTIONS(2920),
    [anon_sym_COLON_COLON] = ACTIONS(2922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2922),
    [anon_sym___declspec] = ACTIONS(2920),
    [anon_sym___based] = ACTIONS(2920),
    [anon_sym___cdecl] = ACTIONS(2920),
    [anon_sym___clrcall] = ACTIONS(2920),
    [anon_sym___stdcall] = ACTIONS(2920),
    [anon_sym___fastcall] = ACTIONS(2920),
    [anon_sym___thiscall] = ACTIONS(2920),
    [anon_sym___vectorcall] = ACTIONS(2920),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_RBRACE] = ACTIONS(2922),
    [anon_sym_signed] = ACTIONS(2920),
    [anon_sym_unsigned] = ACTIONS(2920),
    [anon_sym_long] = ACTIONS(2920),
    [anon_sym_short] = ACTIONS(2920),
    [anon_sym_LBRACK] = ACTIONS(2920),
    [anon_sym_static] = ACTIONS(2920),
    [anon_sym_register] = ACTIONS(2920),
    [anon_sym_inline] = ACTIONS(2920),
    [anon_sym___inline] = ACTIONS(2920),
    [anon_sym___inline__] = ACTIONS(2920),
    [anon_sym___forceinline] = ACTIONS(2920),
    [anon_sym_thread_local] = ACTIONS(2920),
    [anon_sym___thread] = ACTIONS(2920),
    [anon_sym_const] = ACTIONS(2920),
    [anon_sym_constexpr] = ACTIONS(2920),
    [anon_sym_volatile] = ACTIONS(2920),
    [anon_sym_restrict] = ACTIONS(2920),
    [anon_sym___restrict__] = ACTIONS(2920),
    [anon_sym__Atomic] = ACTIONS(2920),
    [anon_sym__Noreturn] = ACTIONS(2920),
    [anon_sym_noreturn] = ACTIONS(2920),
    [anon_sym__Nonnull] = ACTIONS(2920),
    [anon_sym_mutable] = ACTIONS(2920),
    [anon_sym_constinit] = ACTIONS(2920),
    [anon_sym_consteval] = ACTIONS(2920),
    [anon_sym_alignas] = ACTIONS(2920),
    [anon_sym__Alignas] = ACTIONS(2920),
    [sym_primitive_type] = ACTIONS(2920),
    [anon_sym_enum] = ACTIONS(2920),
    [anon_sym_class] = ACTIONS(2920),
    [anon_sym_struct] = ACTIONS(2920),
    [anon_sym_union] = ACTIONS(2920),
    [anon_sym_if] = ACTIONS(2920),
    [anon_sym_switch] = ACTIONS(2920),
    [anon_sym_case] = ACTIONS(2920),
    [anon_sym_default] = ACTIONS(2920),
    [anon_sym_while] = ACTIONS(2920),
    [anon_sym_do] = ACTIONS(2920),
    [anon_sym_for] = ACTIONS(2920),
    [anon_sym_return] = ACTIONS(2920),
    [anon_sym_break] = ACTIONS(2920),
    [anon_sym_continue] = ACTIONS(2920),
    [anon_sym_goto] = ACTIONS(2920),
    [anon_sym___try] = ACTIONS(2920),
    [anon_sym___leave] = ACTIONS(2920),
    [anon_sym_not] = ACTIONS(2920),
    [anon_sym_compl] = ACTIONS(2920),
    [anon_sym_DASH_DASH] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2922),
    [anon_sym_sizeof] = ACTIONS(2920),
    [anon_sym___alignof__] = ACTIONS(2920),
    [anon_sym___alignof] = ACTIONS(2920),
    [anon_sym__alignof] = ACTIONS(2920),
    [anon_sym_alignof] = ACTIONS(2920),
    [anon_sym__Alignof] = ACTIONS(2920),
    [anon_sym_offsetof] = ACTIONS(2920),
    [anon_sym__Generic] = ACTIONS(2920),
    [anon_sym_asm] = ACTIONS(2920),
    [anon_sym___asm__] = ACTIONS(2920),
    [anon_sym___asm] = ACTIONS(2920),
    [sym_number_literal] = ACTIONS(2922),
    [anon_sym_L_SQUOTE] = ACTIONS(2922),
    [anon_sym_u_SQUOTE] = ACTIONS(2922),
    [anon_sym_U_SQUOTE] = ACTIONS(2922),
    [anon_sym_u8_SQUOTE] = ACTIONS(2922),
    [anon_sym_SQUOTE] = ACTIONS(2922),
    [anon_sym_L_DQUOTE] = ACTIONS(2922),
    [anon_sym_u_DQUOTE] = ACTIONS(2922),
    [anon_sym_U_DQUOTE] = ACTIONS(2922),
    [anon_sym_u8_DQUOTE] = ACTIONS(2922),
    [anon_sym_DQUOTE] = ACTIONS(2922),
    [sym_true] = ACTIONS(2920),
    [sym_false] = ACTIONS(2920),
    [anon_sym_NULL] = ACTIONS(2920),
    [anon_sym_nullptr] = ACTIONS(2920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2920),
    [anon_sym_let] = ACTIONS(2920),
    [anon_sym_This] = ACTIONS(2920),
    [anon_sym_decltype] = ACTIONS(2920),
    [anon_sym_explicit] = ACTIONS(2920),
    [anon_sym_typename] = ACTIONS(2920),
    [anon_sym_template] = ACTIONS(2920),
    [anon_sym_operator] = ACTIONS(2920),
    [anon_sym_try] = ACTIONS(2920),
    [anon_sym_delete] = ACTIONS(2920),
    [anon_sym_throw] = ACTIONS(2920),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_static_assert] = ACTIONS(2920),
    [anon_sym_concept] = ACTIONS(2920),
    [anon_sym_co_return] = ACTIONS(2920),
    [anon_sym_co_yield] = ACTIONS(2920),
    [anon_sym_catch] = ACTIONS(3917),
    [anon_sym_R_DQUOTE] = ACTIONS(2922),
    [anon_sym_LR_DQUOTE] = ACTIONS(2922),
    [anon_sym_uR_DQUOTE] = ACTIONS(2922),
    [anon_sym_UR_DQUOTE] = ACTIONS(2922),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2922),
    [anon_sym_co_await] = ACTIONS(2920),
    [anon_sym_new] = ACTIONS(2920),
    [anon_sym_requires] = ACTIONS(2920),
    [sym_this] = ACTIONS(2920),
    [anon_sym_discard] = ACTIONS(2920),
    [anon_sym_precise] = ACTIONS(2920),
    [anon_sym_shared] = ACTIONS(2920),
    [anon_sym_groupshared] = ACTIONS(2920),
    [anon_sym_uniform] = ACTIONS(2920),
    [anon_sym_row_major] = ACTIONS(2920),
    [anon_sym_column_major] = ACTIONS(2920),
    [anon_sym_globallycoherent] = ACTIONS(2920),
    [anon_sym_centroid] = ACTIONS(2920),
    [anon_sym_noperspective] = ACTIONS(2920),
    [anon_sym_nointerpolation] = ACTIONS(2920),
    [anon_sym_sample] = ACTIONS(2920),
    [anon_sym_linear] = ACTIONS(2920),
    [anon_sym_snorm] = ACTIONS(2920),
    [anon_sym_unorm] = ACTIONS(2920),
    [anon_sym_point] = ACTIONS(2920),
    [anon_sym_line] = ACTIONS(2920),
    [anon_sym_triangleadj] = ACTIONS(2920),
    [anon_sym_lineadj] = ACTIONS(2920),
    [anon_sym_triangle] = ACTIONS(2920),
    [anon_sym_cbuffer] = ACTIONS(2920),
    [anon_sym_interface] = ACTIONS(2920),
    [anon_sym_extension] = ACTIONS(2920),
  },
  [637] = {
    [sym_attribute_specifier] = STATE(306),
    [sym_enumerator_list] = STATE(663),
    [ts_builtin_sym_end] = ACTIONS(3991),
    [sym_identifier] = ACTIONS(3993),
    [aux_sym_preproc_include_token1] = ACTIONS(3993),
    [aux_sym_preproc_def_token1] = ACTIONS(3993),
    [aux_sym_preproc_if_token1] = ACTIONS(3993),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3993),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3993),
    [sym_preproc_directive] = ACTIONS(3993),
    [anon_sym_LPAREN2] = ACTIONS(3991),
    [anon_sym_BANG] = ACTIONS(3991),
    [anon_sym_TILDE] = ACTIONS(3991),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym___extension__] = ACTIONS(3993),
    [anon_sym_typedef] = ACTIONS(3993),
    [anon_sym_in] = ACTIONS(3993),
    [anon_sym_out] = ACTIONS(3993),
    [anon_sym_inout] = ACTIONS(3993),
    [anon_sym_virtual] = ACTIONS(3993),
    [anon_sym_extern] = ACTIONS(3993),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(3993),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3991),
    [anon_sym___declspec] = ACTIONS(3993),
    [anon_sym___based] = ACTIONS(3993),
    [anon_sym___cdecl] = ACTIONS(3993),
    [anon_sym___clrcall] = ACTIONS(3993),
    [anon_sym___stdcall] = ACTIONS(3993),
    [anon_sym___fastcall] = ACTIONS(3993),
    [anon_sym___thiscall] = ACTIONS(3993),
    [anon_sym___vectorcall] = ACTIONS(3993),
    [anon_sym_LBRACE] = ACTIONS(3516),
    [anon_sym_signed] = ACTIONS(3993),
    [anon_sym_unsigned] = ACTIONS(3993),
    [anon_sym_long] = ACTIONS(3993),
    [anon_sym_short] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3993),
    [anon_sym_static] = ACTIONS(3993),
    [anon_sym_register] = ACTIONS(3993),
    [anon_sym_inline] = ACTIONS(3993),
    [anon_sym___inline] = ACTIONS(3993),
    [anon_sym___inline__] = ACTIONS(3993),
    [anon_sym___forceinline] = ACTIONS(3993),
    [anon_sym_thread_local] = ACTIONS(3993),
    [anon_sym___thread] = ACTIONS(3993),
    [anon_sym_const] = ACTIONS(3993),
    [anon_sym_constexpr] = ACTIONS(3993),
    [anon_sym_volatile] = ACTIONS(3993),
    [anon_sym_restrict] = ACTIONS(3993),
    [anon_sym___restrict__] = ACTIONS(3993),
    [anon_sym__Atomic] = ACTIONS(3993),
    [anon_sym__Noreturn] = ACTIONS(3993),
    [anon_sym_noreturn] = ACTIONS(3993),
    [anon_sym__Nonnull] = ACTIONS(3993),
    [anon_sym_mutable] = ACTIONS(3993),
    [anon_sym_constinit] = ACTIONS(3993),
    [anon_sym_consteval] = ACTIONS(3993),
    [anon_sym_alignas] = ACTIONS(3993),
    [anon_sym__Alignas] = ACTIONS(3993),
    [sym_primitive_type] = ACTIONS(3993),
    [anon_sym_enum] = ACTIONS(3993),
    [anon_sym_class] = ACTIONS(3993),
    [anon_sym_struct] = ACTIONS(3993),
    [anon_sym_union] = ACTIONS(3993),
    [anon_sym_if] = ACTIONS(3993),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_case] = ACTIONS(3993),
    [anon_sym_default] = ACTIONS(3993),
    [anon_sym_while] = ACTIONS(3993),
    [anon_sym_do] = ACTIONS(3993),
    [anon_sym_for] = ACTIONS(3993),
    [anon_sym_return] = ACTIONS(3993),
    [anon_sym_break] = ACTIONS(3993),
    [anon_sym_continue] = ACTIONS(3993),
    [anon_sym_goto] = ACTIONS(3993),
    [anon_sym_not] = ACTIONS(3993),
    [anon_sym_compl] = ACTIONS(3993),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_sizeof] = ACTIONS(3993),
    [anon_sym___alignof__] = ACTIONS(3993),
    [anon_sym___alignof] = ACTIONS(3993),
    [anon_sym__alignof] = ACTIONS(3993),
    [anon_sym_alignof] = ACTIONS(3993),
    [anon_sym__Alignof] = ACTIONS(3993),
    [anon_sym_offsetof] = ACTIONS(3993),
    [anon_sym__Generic] = ACTIONS(3993),
    [anon_sym_asm] = ACTIONS(3993),
    [anon_sym___asm__] = ACTIONS(3993),
    [anon_sym___asm] = ACTIONS(3993),
    [anon_sym_DOT] = ACTIONS(3993),
    [sym_number_literal] = ACTIONS(3991),
    [anon_sym_L_SQUOTE] = ACTIONS(3991),
    [anon_sym_u_SQUOTE] = ACTIONS(3991),
    [anon_sym_U_SQUOTE] = ACTIONS(3991),
    [anon_sym_u8_SQUOTE] = ACTIONS(3991),
    [anon_sym_SQUOTE] = ACTIONS(3991),
    [anon_sym_L_DQUOTE] = ACTIONS(3991),
    [anon_sym_u_DQUOTE] = ACTIONS(3991),
    [anon_sym_U_DQUOTE] = ACTIONS(3991),
    [anon_sym_u8_DQUOTE] = ACTIONS(3991),
    [anon_sym_DQUOTE] = ACTIONS(3991),
    [sym_true] = ACTIONS(3993),
    [sym_false] = ACTIONS(3993),
    [anon_sym_NULL] = ACTIONS(3993),
    [anon_sym_nullptr] = ACTIONS(3993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3993),
    [anon_sym_let] = ACTIONS(3993),
    [anon_sym_This] = ACTIONS(3993),
    [anon_sym_decltype] = ACTIONS(3993),
    [anon_sym_explicit] = ACTIONS(3993),
    [anon_sym_typename] = ACTIONS(3993),
    [anon_sym_export] = ACTIONS(3993),
    [anon_sym_module] = ACTIONS(3993),
    [anon_sym_import] = ACTIONS(3993),
    [anon_sym_template] = ACTIONS(3993),
    [anon_sym_operator] = ACTIONS(3993),
    [anon_sym_try] = ACTIONS(3993),
    [anon_sym_delete] = ACTIONS(3993),
    [anon_sym_throw] = ACTIONS(3993),
    [anon_sym_namespace] = ACTIONS(3993),
    [anon_sym_static_assert] = ACTIONS(3993),
    [anon_sym_concept] = ACTIONS(3993),
    [anon_sym_co_return] = ACTIONS(3993),
    [anon_sym_co_yield] = ACTIONS(3993),
    [anon_sym_R_DQUOTE] = ACTIONS(3991),
    [anon_sym_LR_DQUOTE] = ACTIONS(3991),
    [anon_sym_uR_DQUOTE] = ACTIONS(3991),
    [anon_sym_UR_DQUOTE] = ACTIONS(3991),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3991),
    [anon_sym_co_await] = ACTIONS(3993),
    [anon_sym_new] = ACTIONS(3993),
    [anon_sym_requires] = ACTIONS(3993),
    [sym_this] = ACTIONS(3993),
    [anon_sym_precise] = ACTIONS(3993),
    [anon_sym_shared] = ACTIONS(3993),
    [anon_sym_groupshared] = ACTIONS(3993),
    [anon_sym_uniform] = ACTIONS(3993),
    [anon_sym_row_major] = ACTIONS(3993),
    [anon_sym_column_major] = ACTIONS(3993),
    [anon_sym_globallycoherent] = ACTIONS(3993),
    [anon_sym_centroid] = ACTIONS(3993),
    [anon_sym_noperspective] = ACTIONS(3993),
    [anon_sym_nointerpolation] = ACTIONS(3993),
    [anon_sym_sample] = ACTIONS(3993),
    [anon_sym_linear] = ACTIONS(3993),
    [anon_sym_snorm] = ACTIONS(3993),
    [anon_sym_unorm] = ACTIONS(3993),
    [anon_sym_point] = ACTIONS(3993),
    [anon_sym_line] = ACTIONS(3993),
    [anon_sym_triangleadj] = ACTIONS(3993),
    [anon_sym_lineadj] = ACTIONS(3993),
    [anon_sym_triangle] = ACTIONS(3993),
    [anon_sym_interface] = ACTIONS(3993),
    [anon_sym_extension] = ACTIONS(3993),
    [anon_sym___exported] = ACTIONS(3993),
  },
  [638] = {
    [sym_catch_clause] = STATE(616),
    [aux_sym_constructor_try_statement_repeat1] = STATE(616),
    [sym_identifier] = ACTIONS(2968),
    [aux_sym_preproc_include_token1] = ACTIONS(2968),
    [aux_sym_preproc_def_token1] = ACTIONS(2968),
    [aux_sym_preproc_if_token1] = ACTIONS(2968),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2968),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2968),
    [sym_preproc_directive] = ACTIONS(2968),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_BANG] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2968),
    [anon_sym_PLUS] = ACTIONS(2968),
    [anon_sym_STAR] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_AMP] = ACTIONS(2968),
    [anon_sym_SEMI] = ACTIONS(2970),
    [anon_sym___extension__] = ACTIONS(2968),
    [anon_sym_typedef] = ACTIONS(2968),
    [anon_sym_in] = ACTIONS(2968),
    [anon_sym_out] = ACTIONS(2968),
    [anon_sym_inout] = ACTIONS(2968),
    [anon_sym_virtual] = ACTIONS(2968),
    [anon_sym_extern] = ACTIONS(2968),
    [anon_sym___attribute__] = ACTIONS(2968),
    [anon_sym___attribute] = ACTIONS(2968),
    [anon_sym_using] = ACTIONS(2968),
    [anon_sym_COLON_COLON] = ACTIONS(2970),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2970),
    [anon_sym___declspec] = ACTIONS(2968),
    [anon_sym___based] = ACTIONS(2968),
    [anon_sym___cdecl] = ACTIONS(2968),
    [anon_sym___clrcall] = ACTIONS(2968),
    [anon_sym___stdcall] = ACTIONS(2968),
    [anon_sym___fastcall] = ACTIONS(2968),
    [anon_sym___thiscall] = ACTIONS(2968),
    [anon_sym___vectorcall] = ACTIONS(2968),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_RBRACE] = ACTIONS(2970),
    [anon_sym_signed] = ACTIONS(2968),
    [anon_sym_unsigned] = ACTIONS(2968),
    [anon_sym_long] = ACTIONS(2968),
    [anon_sym_short] = ACTIONS(2968),
    [anon_sym_LBRACK] = ACTIONS(2968),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_register] = ACTIONS(2968),
    [anon_sym_inline] = ACTIONS(2968),
    [anon_sym___inline] = ACTIONS(2968),
    [anon_sym___inline__] = ACTIONS(2968),
    [anon_sym___forceinline] = ACTIONS(2968),
    [anon_sym_thread_local] = ACTIONS(2968),
    [anon_sym___thread] = ACTIONS(2968),
    [anon_sym_const] = ACTIONS(2968),
    [anon_sym_constexpr] = ACTIONS(2968),
    [anon_sym_volatile] = ACTIONS(2968),
    [anon_sym_restrict] = ACTIONS(2968),
    [anon_sym___restrict__] = ACTIONS(2968),
    [anon_sym__Atomic] = ACTIONS(2968),
    [anon_sym__Noreturn] = ACTIONS(2968),
    [anon_sym_noreturn] = ACTIONS(2968),
    [anon_sym__Nonnull] = ACTIONS(2968),
    [anon_sym_mutable] = ACTIONS(2968),
    [anon_sym_constinit] = ACTIONS(2968),
    [anon_sym_consteval] = ACTIONS(2968),
    [anon_sym_alignas] = ACTIONS(2968),
    [anon_sym__Alignas] = ACTIONS(2968),
    [sym_primitive_type] = ACTIONS(2968),
    [anon_sym_enum] = ACTIONS(2968),
    [anon_sym_class] = ACTIONS(2968),
    [anon_sym_struct] = ACTIONS(2968),
    [anon_sym_union] = ACTIONS(2968),
    [anon_sym_if] = ACTIONS(2968),
    [anon_sym_switch] = ACTIONS(2968),
    [anon_sym_case] = ACTIONS(2968),
    [anon_sym_default] = ACTIONS(2968),
    [anon_sym_while] = ACTIONS(2968),
    [anon_sym_do] = ACTIONS(2968),
    [anon_sym_for] = ACTIONS(2968),
    [anon_sym_return] = ACTIONS(2968),
    [anon_sym_break] = ACTIONS(2968),
    [anon_sym_continue] = ACTIONS(2968),
    [anon_sym_goto] = ACTIONS(2968),
    [anon_sym___try] = ACTIONS(2968),
    [anon_sym___leave] = ACTIONS(2968),
    [anon_sym_not] = ACTIONS(2968),
    [anon_sym_compl] = ACTIONS(2968),
    [anon_sym_DASH_DASH] = ACTIONS(2970),
    [anon_sym_PLUS_PLUS] = ACTIONS(2970),
    [anon_sym_sizeof] = ACTIONS(2968),
    [anon_sym___alignof__] = ACTIONS(2968),
    [anon_sym___alignof] = ACTIONS(2968),
    [anon_sym__alignof] = ACTIONS(2968),
    [anon_sym_alignof] = ACTIONS(2968),
    [anon_sym__Alignof] = ACTIONS(2968),
    [anon_sym_offsetof] = ACTIONS(2968),
    [anon_sym__Generic] = ACTIONS(2968),
    [anon_sym_asm] = ACTIONS(2968),
    [anon_sym___asm__] = ACTIONS(2968),
    [anon_sym___asm] = ACTIONS(2968),
    [sym_number_literal] = ACTIONS(2970),
    [anon_sym_L_SQUOTE] = ACTIONS(2970),
    [anon_sym_u_SQUOTE] = ACTIONS(2970),
    [anon_sym_U_SQUOTE] = ACTIONS(2970),
    [anon_sym_u8_SQUOTE] = ACTIONS(2970),
    [anon_sym_SQUOTE] = ACTIONS(2970),
    [anon_sym_L_DQUOTE] = ACTIONS(2970),
    [anon_sym_u_DQUOTE] = ACTIONS(2970),
    [anon_sym_U_DQUOTE] = ACTIONS(2970),
    [anon_sym_u8_DQUOTE] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(2970),
    [sym_true] = ACTIONS(2968),
    [sym_false] = ACTIONS(2968),
    [anon_sym_NULL] = ACTIONS(2968),
    [anon_sym_nullptr] = ACTIONS(2968),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2968),
    [anon_sym_let] = ACTIONS(2968),
    [anon_sym_This] = ACTIONS(2968),
    [anon_sym_decltype] = ACTIONS(2968),
    [anon_sym_explicit] = ACTIONS(2968),
    [anon_sym_typename] = ACTIONS(2968),
    [anon_sym_template] = ACTIONS(2968),
    [anon_sym_operator] = ACTIONS(2968),
    [anon_sym_try] = ACTIONS(2968),
    [anon_sym_delete] = ACTIONS(2968),
    [anon_sym_throw] = ACTIONS(2968),
    [anon_sym_namespace] = ACTIONS(2968),
    [anon_sym_static_assert] = ACTIONS(2968),
    [anon_sym_concept] = ACTIONS(2968),
    [anon_sym_co_return] = ACTIONS(2968),
    [anon_sym_co_yield] = ACTIONS(2968),
    [anon_sym_catch] = ACTIONS(3917),
    [anon_sym_R_DQUOTE] = ACTIONS(2970),
    [anon_sym_LR_DQUOTE] = ACTIONS(2970),
    [anon_sym_uR_DQUOTE] = ACTIONS(2970),
    [anon_sym_UR_DQUOTE] = ACTIONS(2970),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2970),
    [anon_sym_co_await] = ACTIONS(2968),
    [anon_sym_new] = ACTIONS(2968),
    [anon_sym_requires] = ACTIONS(2968),
    [sym_this] = ACTIONS(2968),
    [anon_sym_discard] = ACTIONS(2968),
    [anon_sym_precise] = ACTIONS(2968),
    [anon_sym_shared] = ACTIONS(2968),
    [anon_sym_groupshared] = ACTIONS(2968),
    [anon_sym_uniform] = ACTIONS(2968),
    [anon_sym_row_major] = ACTIONS(2968),
    [anon_sym_column_major] = ACTIONS(2968),
    [anon_sym_globallycoherent] = ACTIONS(2968),
    [anon_sym_centroid] = ACTIONS(2968),
    [anon_sym_noperspective] = ACTIONS(2968),
    [anon_sym_nointerpolation] = ACTIONS(2968),
    [anon_sym_sample] = ACTIONS(2968),
    [anon_sym_linear] = ACTIONS(2968),
    [anon_sym_snorm] = ACTIONS(2968),
    [anon_sym_unorm] = ACTIONS(2968),
    [anon_sym_point] = ACTIONS(2968),
    [anon_sym_line] = ACTIONS(2968),
    [anon_sym_triangleadj] = ACTIONS(2968),
    [anon_sym_lineadj] = ACTIONS(2968),
    [anon_sym_triangle] = ACTIONS(2968),
    [anon_sym_cbuffer] = ACTIONS(2968),
    [anon_sym_interface] = ACTIONS(2968),
    [anon_sym_extension] = ACTIONS(2968),
  },
  [639] = {
    [sym_catch_clause] = STATE(569),
    [aux_sym_constructor_try_statement_repeat1] = STATE(569),
    [sym_identifier] = ACTIONS(2920),
    [aux_sym_preproc_include_token1] = ACTIONS(2920),
    [aux_sym_preproc_def_token1] = ACTIONS(2920),
    [aux_sym_preproc_if_token1] = ACTIONS(2920),
    [aux_sym_preproc_if_token2] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2920),
    [sym_preproc_directive] = ACTIONS(2920),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2920),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2920),
    [anon_sym_SEMI] = ACTIONS(2922),
    [anon_sym___extension__] = ACTIONS(2920),
    [anon_sym_typedef] = ACTIONS(2920),
    [anon_sym_in] = ACTIONS(2920),
    [anon_sym_out] = ACTIONS(2920),
    [anon_sym_inout] = ACTIONS(2920),
    [anon_sym_virtual] = ACTIONS(2920),
    [anon_sym_extern] = ACTIONS(2920),
    [anon_sym___attribute__] = ACTIONS(2920),
    [anon_sym___attribute] = ACTIONS(2920),
    [anon_sym_using] = ACTIONS(2920),
    [anon_sym_COLON_COLON] = ACTIONS(2922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2922),
    [anon_sym___declspec] = ACTIONS(2920),
    [anon_sym___based] = ACTIONS(2920),
    [anon_sym___cdecl] = ACTIONS(2920),
    [anon_sym___clrcall] = ACTIONS(2920),
    [anon_sym___stdcall] = ACTIONS(2920),
    [anon_sym___fastcall] = ACTIONS(2920),
    [anon_sym___thiscall] = ACTIONS(2920),
    [anon_sym___vectorcall] = ACTIONS(2920),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_signed] = ACTIONS(2920),
    [anon_sym_unsigned] = ACTIONS(2920),
    [anon_sym_long] = ACTIONS(2920),
    [anon_sym_short] = ACTIONS(2920),
    [anon_sym_LBRACK] = ACTIONS(2920),
    [anon_sym_static] = ACTIONS(2920),
    [anon_sym_register] = ACTIONS(2920),
    [anon_sym_inline] = ACTIONS(2920),
    [anon_sym___inline] = ACTIONS(2920),
    [anon_sym___inline__] = ACTIONS(2920),
    [anon_sym___forceinline] = ACTIONS(2920),
    [anon_sym_thread_local] = ACTIONS(2920),
    [anon_sym___thread] = ACTIONS(2920),
    [anon_sym_const] = ACTIONS(2920),
    [anon_sym_constexpr] = ACTIONS(2920),
    [anon_sym_volatile] = ACTIONS(2920),
    [anon_sym_restrict] = ACTIONS(2920),
    [anon_sym___restrict__] = ACTIONS(2920),
    [anon_sym__Atomic] = ACTIONS(2920),
    [anon_sym__Noreturn] = ACTIONS(2920),
    [anon_sym_noreturn] = ACTIONS(2920),
    [anon_sym__Nonnull] = ACTIONS(2920),
    [anon_sym_mutable] = ACTIONS(2920),
    [anon_sym_constinit] = ACTIONS(2920),
    [anon_sym_consteval] = ACTIONS(2920),
    [anon_sym_alignas] = ACTIONS(2920),
    [anon_sym__Alignas] = ACTIONS(2920),
    [sym_primitive_type] = ACTIONS(2920),
    [anon_sym_enum] = ACTIONS(2920),
    [anon_sym_class] = ACTIONS(2920),
    [anon_sym_struct] = ACTIONS(2920),
    [anon_sym_union] = ACTIONS(2920),
    [anon_sym_if] = ACTIONS(2920),
    [anon_sym_switch] = ACTIONS(2920),
    [anon_sym_case] = ACTIONS(2920),
    [anon_sym_default] = ACTIONS(2920),
    [anon_sym_while] = ACTIONS(2920),
    [anon_sym_do] = ACTIONS(2920),
    [anon_sym_for] = ACTIONS(2920),
    [anon_sym_return] = ACTIONS(2920),
    [anon_sym_break] = ACTIONS(2920),
    [anon_sym_continue] = ACTIONS(2920),
    [anon_sym_goto] = ACTIONS(2920),
    [anon_sym___try] = ACTIONS(2920),
    [anon_sym___leave] = ACTIONS(2920),
    [anon_sym_not] = ACTIONS(2920),
    [anon_sym_compl] = ACTIONS(2920),
    [anon_sym_DASH_DASH] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2922),
    [anon_sym_sizeof] = ACTIONS(2920),
    [anon_sym___alignof__] = ACTIONS(2920),
    [anon_sym___alignof] = ACTIONS(2920),
    [anon_sym__alignof] = ACTIONS(2920),
    [anon_sym_alignof] = ACTIONS(2920),
    [anon_sym__Alignof] = ACTIONS(2920),
    [anon_sym_offsetof] = ACTIONS(2920),
    [anon_sym__Generic] = ACTIONS(2920),
    [anon_sym_asm] = ACTIONS(2920),
    [anon_sym___asm__] = ACTIONS(2920),
    [anon_sym___asm] = ACTIONS(2920),
    [sym_number_literal] = ACTIONS(2922),
    [anon_sym_L_SQUOTE] = ACTIONS(2922),
    [anon_sym_u_SQUOTE] = ACTIONS(2922),
    [anon_sym_U_SQUOTE] = ACTIONS(2922),
    [anon_sym_u8_SQUOTE] = ACTIONS(2922),
    [anon_sym_SQUOTE] = ACTIONS(2922),
    [anon_sym_L_DQUOTE] = ACTIONS(2922),
    [anon_sym_u_DQUOTE] = ACTIONS(2922),
    [anon_sym_U_DQUOTE] = ACTIONS(2922),
    [anon_sym_u8_DQUOTE] = ACTIONS(2922),
    [anon_sym_DQUOTE] = ACTIONS(2922),
    [sym_true] = ACTIONS(2920),
    [sym_false] = ACTIONS(2920),
    [anon_sym_NULL] = ACTIONS(2920),
    [anon_sym_nullptr] = ACTIONS(2920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2920),
    [anon_sym_let] = ACTIONS(2920),
    [anon_sym_This] = ACTIONS(2920),
    [anon_sym_decltype] = ACTIONS(2920),
    [anon_sym_explicit] = ACTIONS(2920),
    [anon_sym_typename] = ACTIONS(2920),
    [anon_sym_template] = ACTIONS(2920),
    [anon_sym_operator] = ACTIONS(2920),
    [anon_sym_try] = ACTIONS(2920),
    [anon_sym_delete] = ACTIONS(2920),
    [anon_sym_throw] = ACTIONS(2920),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_static_assert] = ACTIONS(2920),
    [anon_sym_concept] = ACTIONS(2920),
    [anon_sym_co_return] = ACTIONS(2920),
    [anon_sym_co_yield] = ACTIONS(2920),
    [anon_sym_catch] = ACTIONS(3981),
    [anon_sym_R_DQUOTE] = ACTIONS(2922),
    [anon_sym_LR_DQUOTE] = ACTIONS(2922),
    [anon_sym_uR_DQUOTE] = ACTIONS(2922),
    [anon_sym_UR_DQUOTE] = ACTIONS(2922),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2922),
    [anon_sym_co_await] = ACTIONS(2920),
    [anon_sym_new] = ACTIONS(2920),
    [anon_sym_requires] = ACTIONS(2920),
    [sym_this] = ACTIONS(2920),
    [anon_sym_discard] = ACTIONS(2920),
    [anon_sym_precise] = ACTIONS(2920),
    [anon_sym_shared] = ACTIONS(2920),
    [anon_sym_groupshared] = ACTIONS(2920),
    [anon_sym_uniform] = ACTIONS(2920),
    [anon_sym_row_major] = ACTIONS(2920),
    [anon_sym_column_major] = ACTIONS(2920),
    [anon_sym_globallycoherent] = ACTIONS(2920),
    [anon_sym_centroid] = ACTIONS(2920),
    [anon_sym_noperspective] = ACTIONS(2920),
    [anon_sym_nointerpolation] = ACTIONS(2920),
    [anon_sym_sample] = ACTIONS(2920),
    [anon_sym_linear] = ACTIONS(2920),
    [anon_sym_snorm] = ACTIONS(2920),
    [anon_sym_unorm] = ACTIONS(2920),
    [anon_sym_point] = ACTIONS(2920),
    [anon_sym_line] = ACTIONS(2920),
    [anon_sym_triangleadj] = ACTIONS(2920),
    [anon_sym_lineadj] = ACTIONS(2920),
    [anon_sym_triangle] = ACTIONS(2920),
    [anon_sym_cbuffer] = ACTIONS(2920),
    [anon_sym_interface] = ACTIONS(2920),
    [anon_sym_extension] = ACTIONS(2920),
  },
  [640] = {
    [sym_catch_clause] = STATE(569),
    [aux_sym_constructor_try_statement_repeat1] = STATE(569),
    [sym_identifier] = ACTIONS(2968),
    [aux_sym_preproc_include_token1] = ACTIONS(2968),
    [aux_sym_preproc_def_token1] = ACTIONS(2968),
    [aux_sym_preproc_if_token1] = ACTIONS(2968),
    [aux_sym_preproc_if_token2] = ACTIONS(2968),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2968),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2968),
    [sym_preproc_directive] = ACTIONS(2968),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_BANG] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2968),
    [anon_sym_PLUS] = ACTIONS(2968),
    [anon_sym_STAR] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_AMP] = ACTIONS(2968),
    [anon_sym_SEMI] = ACTIONS(2970),
    [anon_sym___extension__] = ACTIONS(2968),
    [anon_sym_typedef] = ACTIONS(2968),
    [anon_sym_in] = ACTIONS(2968),
    [anon_sym_out] = ACTIONS(2968),
    [anon_sym_inout] = ACTIONS(2968),
    [anon_sym_virtual] = ACTIONS(2968),
    [anon_sym_extern] = ACTIONS(2968),
    [anon_sym___attribute__] = ACTIONS(2968),
    [anon_sym___attribute] = ACTIONS(2968),
    [anon_sym_using] = ACTIONS(2968),
    [anon_sym_COLON_COLON] = ACTIONS(2970),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2970),
    [anon_sym___declspec] = ACTIONS(2968),
    [anon_sym___based] = ACTIONS(2968),
    [anon_sym___cdecl] = ACTIONS(2968),
    [anon_sym___clrcall] = ACTIONS(2968),
    [anon_sym___stdcall] = ACTIONS(2968),
    [anon_sym___fastcall] = ACTIONS(2968),
    [anon_sym___thiscall] = ACTIONS(2968),
    [anon_sym___vectorcall] = ACTIONS(2968),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_signed] = ACTIONS(2968),
    [anon_sym_unsigned] = ACTIONS(2968),
    [anon_sym_long] = ACTIONS(2968),
    [anon_sym_short] = ACTIONS(2968),
    [anon_sym_LBRACK] = ACTIONS(2968),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_register] = ACTIONS(2968),
    [anon_sym_inline] = ACTIONS(2968),
    [anon_sym___inline] = ACTIONS(2968),
    [anon_sym___inline__] = ACTIONS(2968),
    [anon_sym___forceinline] = ACTIONS(2968),
    [anon_sym_thread_local] = ACTIONS(2968),
    [anon_sym___thread] = ACTIONS(2968),
    [anon_sym_const] = ACTIONS(2968),
    [anon_sym_constexpr] = ACTIONS(2968),
    [anon_sym_volatile] = ACTIONS(2968),
    [anon_sym_restrict] = ACTIONS(2968),
    [anon_sym___restrict__] = ACTIONS(2968),
    [anon_sym__Atomic] = ACTIONS(2968),
    [anon_sym__Noreturn] = ACTIONS(2968),
    [anon_sym_noreturn] = ACTIONS(2968),
    [anon_sym__Nonnull] = ACTIONS(2968),
    [anon_sym_mutable] = ACTIONS(2968),
    [anon_sym_constinit] = ACTIONS(2968),
    [anon_sym_consteval] = ACTIONS(2968),
    [anon_sym_alignas] = ACTIONS(2968),
    [anon_sym__Alignas] = ACTIONS(2968),
    [sym_primitive_type] = ACTIONS(2968),
    [anon_sym_enum] = ACTIONS(2968),
    [anon_sym_class] = ACTIONS(2968),
    [anon_sym_struct] = ACTIONS(2968),
    [anon_sym_union] = ACTIONS(2968),
    [anon_sym_if] = ACTIONS(2968),
    [anon_sym_switch] = ACTIONS(2968),
    [anon_sym_case] = ACTIONS(2968),
    [anon_sym_default] = ACTIONS(2968),
    [anon_sym_while] = ACTIONS(2968),
    [anon_sym_do] = ACTIONS(2968),
    [anon_sym_for] = ACTIONS(2968),
    [anon_sym_return] = ACTIONS(2968),
    [anon_sym_break] = ACTIONS(2968),
    [anon_sym_continue] = ACTIONS(2968),
    [anon_sym_goto] = ACTIONS(2968),
    [anon_sym___try] = ACTIONS(2968),
    [anon_sym___leave] = ACTIONS(2968),
    [anon_sym_not] = ACTIONS(2968),
    [anon_sym_compl] = ACTIONS(2968),
    [anon_sym_DASH_DASH] = ACTIONS(2970),
    [anon_sym_PLUS_PLUS] = ACTIONS(2970),
    [anon_sym_sizeof] = ACTIONS(2968),
    [anon_sym___alignof__] = ACTIONS(2968),
    [anon_sym___alignof] = ACTIONS(2968),
    [anon_sym__alignof] = ACTIONS(2968),
    [anon_sym_alignof] = ACTIONS(2968),
    [anon_sym__Alignof] = ACTIONS(2968),
    [anon_sym_offsetof] = ACTIONS(2968),
    [anon_sym__Generic] = ACTIONS(2968),
    [anon_sym_asm] = ACTIONS(2968),
    [anon_sym___asm__] = ACTIONS(2968),
    [anon_sym___asm] = ACTIONS(2968),
    [sym_number_literal] = ACTIONS(2970),
    [anon_sym_L_SQUOTE] = ACTIONS(2970),
    [anon_sym_u_SQUOTE] = ACTIONS(2970),
    [anon_sym_U_SQUOTE] = ACTIONS(2970),
    [anon_sym_u8_SQUOTE] = ACTIONS(2970),
    [anon_sym_SQUOTE] = ACTIONS(2970),
    [anon_sym_L_DQUOTE] = ACTIONS(2970),
    [anon_sym_u_DQUOTE] = ACTIONS(2970),
    [anon_sym_U_DQUOTE] = ACTIONS(2970),
    [anon_sym_u8_DQUOTE] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(2970),
    [sym_true] = ACTIONS(2968),
    [sym_false] = ACTIONS(2968),
    [anon_sym_NULL] = ACTIONS(2968),
    [anon_sym_nullptr] = ACTIONS(2968),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2968),
    [anon_sym_let] = ACTIONS(2968),
    [anon_sym_This] = ACTIONS(2968),
    [anon_sym_decltype] = ACTIONS(2968),
    [anon_sym_explicit] = ACTIONS(2968),
    [anon_sym_typename] = ACTIONS(2968),
    [anon_sym_template] = ACTIONS(2968),
    [anon_sym_operator] = ACTIONS(2968),
    [anon_sym_try] = ACTIONS(2968),
    [anon_sym_delete] = ACTIONS(2968),
    [anon_sym_throw] = ACTIONS(2968),
    [anon_sym_namespace] = ACTIONS(2968),
    [anon_sym_static_assert] = ACTIONS(2968),
    [anon_sym_concept] = ACTIONS(2968),
    [anon_sym_co_return] = ACTIONS(2968),
    [anon_sym_co_yield] = ACTIONS(2968),
    [anon_sym_catch] = ACTIONS(3981),
    [anon_sym_R_DQUOTE] = ACTIONS(2970),
    [anon_sym_LR_DQUOTE] = ACTIONS(2970),
    [anon_sym_uR_DQUOTE] = ACTIONS(2970),
    [anon_sym_UR_DQUOTE] = ACTIONS(2970),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2970),
    [anon_sym_co_await] = ACTIONS(2968),
    [anon_sym_new] = ACTIONS(2968),
    [anon_sym_requires] = ACTIONS(2968),
    [sym_this] = ACTIONS(2968),
    [anon_sym_discard] = ACTIONS(2968),
    [anon_sym_precise] = ACTIONS(2968),
    [anon_sym_shared] = ACTIONS(2968),
    [anon_sym_groupshared] = ACTIONS(2968),
    [anon_sym_uniform] = ACTIONS(2968),
    [anon_sym_row_major] = ACTIONS(2968),
    [anon_sym_column_major] = ACTIONS(2968),
    [anon_sym_globallycoherent] = ACTIONS(2968),
    [anon_sym_centroid] = ACTIONS(2968),
    [anon_sym_noperspective] = ACTIONS(2968),
    [anon_sym_nointerpolation] = ACTIONS(2968),
    [anon_sym_sample] = ACTIONS(2968),
    [anon_sym_linear] = ACTIONS(2968),
    [anon_sym_snorm] = ACTIONS(2968),
    [anon_sym_unorm] = ACTIONS(2968),
    [anon_sym_point] = ACTIONS(2968),
    [anon_sym_line] = ACTIONS(2968),
    [anon_sym_triangleadj] = ACTIONS(2968),
    [anon_sym_lineadj] = ACTIONS(2968),
    [anon_sym_triangle] = ACTIONS(2968),
    [anon_sym_cbuffer] = ACTIONS(2968),
    [anon_sym_interface] = ACTIONS(2968),
    [anon_sym_extension] = ACTIONS(2968),
  },
  [641] = {
    [sym_attribute_specifier] = STATE(789),
    [sym_enumerator_list] = STATE(690),
    [sym_identifier] = ACTIONS(3993),
    [aux_sym_preproc_include_token1] = ACTIONS(3993),
    [aux_sym_preproc_def_token1] = ACTIONS(3993),
    [aux_sym_preproc_if_token1] = ACTIONS(3993),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3993),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3993),
    [sym_preproc_directive] = ACTIONS(3993),
    [anon_sym_LPAREN2] = ACTIONS(3991),
    [anon_sym_BANG] = ACTIONS(3991),
    [anon_sym_TILDE] = ACTIONS(3991),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym___extension__] = ACTIONS(3993),
    [anon_sym_typedef] = ACTIONS(3993),
    [anon_sym_in] = ACTIONS(3993),
    [anon_sym_out] = ACTIONS(3993),
    [anon_sym_inout] = ACTIONS(3993),
    [anon_sym_virtual] = ACTIONS(3993),
    [anon_sym_extern] = ACTIONS(3993),
    [anon_sym___attribute__] = ACTIONS(2897),
    [anon_sym___attribute] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(3993),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3991),
    [anon_sym___declspec] = ACTIONS(3993),
    [anon_sym___based] = ACTIONS(3993),
    [anon_sym___cdecl] = ACTIONS(3993),
    [anon_sym___clrcall] = ACTIONS(3993),
    [anon_sym___stdcall] = ACTIONS(3993),
    [anon_sym___fastcall] = ACTIONS(3993),
    [anon_sym___thiscall] = ACTIONS(3993),
    [anon_sym___vectorcall] = ACTIONS(3993),
    [anon_sym_LBRACE] = ACTIONS(3484),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_signed] = ACTIONS(3993),
    [anon_sym_unsigned] = ACTIONS(3993),
    [anon_sym_long] = ACTIONS(3993),
    [anon_sym_short] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3993),
    [anon_sym_static] = ACTIONS(3993),
    [anon_sym_register] = ACTIONS(3993),
    [anon_sym_inline] = ACTIONS(3993),
    [anon_sym___inline] = ACTIONS(3993),
    [anon_sym___inline__] = ACTIONS(3993),
    [anon_sym___forceinline] = ACTIONS(3993),
    [anon_sym_thread_local] = ACTIONS(3993),
    [anon_sym___thread] = ACTIONS(3993),
    [anon_sym_const] = ACTIONS(3993),
    [anon_sym_constexpr] = ACTIONS(3993),
    [anon_sym_volatile] = ACTIONS(3993),
    [anon_sym_restrict] = ACTIONS(3993),
    [anon_sym___restrict__] = ACTIONS(3993),
    [anon_sym__Atomic] = ACTIONS(3993),
    [anon_sym__Noreturn] = ACTIONS(3993),
    [anon_sym_noreturn] = ACTIONS(3993),
    [anon_sym__Nonnull] = ACTIONS(3993),
    [anon_sym_mutable] = ACTIONS(3993),
    [anon_sym_constinit] = ACTIONS(3993),
    [anon_sym_consteval] = ACTIONS(3993),
    [anon_sym_alignas] = ACTIONS(3993),
    [anon_sym__Alignas] = ACTIONS(3993),
    [sym_primitive_type] = ACTIONS(3993),
    [anon_sym_enum] = ACTIONS(3993),
    [anon_sym_class] = ACTIONS(3993),
    [anon_sym_struct] = ACTIONS(3993),
    [anon_sym_union] = ACTIONS(3993),
    [anon_sym_if] = ACTIONS(3993),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_case] = ACTIONS(3993),
    [anon_sym_default] = ACTIONS(3993),
    [anon_sym_while] = ACTIONS(3993),
    [anon_sym_do] = ACTIONS(3993),
    [anon_sym_for] = ACTIONS(3993),
    [anon_sym_return] = ACTIONS(3993),
    [anon_sym_break] = ACTIONS(3993),
    [anon_sym_continue] = ACTIONS(3993),
    [anon_sym_goto] = ACTIONS(3993),
    [anon_sym___try] = ACTIONS(3993),
    [anon_sym___leave] = ACTIONS(3993),
    [anon_sym_not] = ACTIONS(3993),
    [anon_sym_compl] = ACTIONS(3993),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_sizeof] = ACTIONS(3993),
    [anon_sym___alignof__] = ACTIONS(3993),
    [anon_sym___alignof] = ACTIONS(3993),
    [anon_sym__alignof] = ACTIONS(3993),
    [anon_sym_alignof] = ACTIONS(3993),
    [anon_sym__Alignof] = ACTIONS(3993),
    [anon_sym_offsetof] = ACTIONS(3993),
    [anon_sym__Generic] = ACTIONS(3993),
    [anon_sym_asm] = ACTIONS(3993),
    [anon_sym___asm__] = ACTIONS(3993),
    [anon_sym___asm] = ACTIONS(3993),
    [anon_sym_DOT] = ACTIONS(3993),
    [sym_number_literal] = ACTIONS(3991),
    [anon_sym_L_SQUOTE] = ACTIONS(3991),
    [anon_sym_u_SQUOTE] = ACTIONS(3991),
    [anon_sym_U_SQUOTE] = ACTIONS(3991),
    [anon_sym_u8_SQUOTE] = ACTIONS(3991),
    [anon_sym_SQUOTE] = ACTIONS(3991),
    [anon_sym_L_DQUOTE] = ACTIONS(3991),
    [anon_sym_u_DQUOTE] = ACTIONS(3991),
    [anon_sym_U_DQUOTE] = ACTIONS(3991),
    [anon_sym_u8_DQUOTE] = ACTIONS(3991),
    [anon_sym_DQUOTE] = ACTIONS(3991),
    [sym_true] = ACTIONS(3993),
    [sym_false] = ACTIONS(3993),
    [anon_sym_NULL] = ACTIONS(3993),
    [anon_sym_nullptr] = ACTIONS(3993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3993),
    [anon_sym_let] = ACTIONS(3993),
    [anon_sym_This] = ACTIONS(3993),
    [anon_sym_decltype] = ACTIONS(3993),
    [anon_sym_explicit] = ACTIONS(3993),
    [anon_sym_typename] = ACTIONS(3993),
    [anon_sym_template] = ACTIONS(3993),
    [anon_sym_operator] = ACTIONS(3993),
    [anon_sym_try] = ACTIONS(3993),
    [anon_sym_delete] = ACTIONS(3993),
    [anon_sym_throw] = ACTIONS(3993),
    [anon_sym_namespace] = ACTIONS(3993),
    [anon_sym_static_assert] = ACTIONS(3993),
    [anon_sym_concept] = ACTIONS(3993),
    [anon_sym_co_return] = ACTIONS(3993),
    [anon_sym_co_yield] = ACTIONS(3993),
    [anon_sym_R_DQUOTE] = ACTIONS(3991),
    [anon_sym_LR_DQUOTE] = ACTIONS(3991),
    [anon_sym_uR_DQUOTE] = ACTIONS(3991),
    [anon_sym_UR_DQUOTE] = ACTIONS(3991),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3991),
    [anon_sym_co_await] = ACTIONS(3993),
    [anon_sym_new] = ACTIONS(3993),
    [anon_sym_requires] = ACTIONS(3993),
    [sym_this] = ACTIONS(3993),
    [anon_sym_discard] = ACTIONS(3993),
    [anon_sym_precise] = ACTIONS(3993),
    [anon_sym_shared] = ACTIONS(3993),
    [anon_sym_groupshared] = ACTIONS(3993),
    [anon_sym_uniform] = ACTIONS(3993),
    [anon_sym_row_major] = ACTIONS(3993),
    [anon_sym_column_major] = ACTIONS(3993),
    [anon_sym_globallycoherent] = ACTIONS(3993),
    [anon_sym_centroid] = ACTIONS(3993),
    [anon_sym_noperspective] = ACTIONS(3993),
    [anon_sym_nointerpolation] = ACTIONS(3993),
    [anon_sym_sample] = ACTIONS(3993),
    [anon_sym_linear] = ACTIONS(3993),
    [anon_sym_snorm] = ACTIONS(3993),
    [anon_sym_unorm] = ACTIONS(3993),
    [anon_sym_point] = ACTIONS(3993),
    [anon_sym_line] = ACTIONS(3993),
    [anon_sym_triangleadj] = ACTIONS(3993),
    [anon_sym_lineadj] = ACTIONS(3993),
    [anon_sym_triangle] = ACTIONS(3993),
    [anon_sym_cbuffer] = ACTIONS(3993),
    [anon_sym_interface] = ACTIONS(3993),
    [anon_sym_extension] = ACTIONS(3993),
  },
  [642] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(672),
    [sym_identifier] = ACTIONS(3995),
    [aux_sym_preproc_include_token1] = ACTIONS(3995),
    [aux_sym_preproc_def_token1] = ACTIONS(3995),
    [aux_sym_preproc_if_token1] = ACTIONS(3995),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3995),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3995),
    [sym_preproc_directive] = ACTIONS(3995),
    [anon_sym_LPAREN2] = ACTIONS(3997),
    [anon_sym_BANG] = ACTIONS(3997),
    [anon_sym_TILDE] = ACTIONS(3997),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_AMP] = ACTIONS(3995),
    [anon_sym_SEMI] = ACTIONS(3997),
    [anon_sym___extension__] = ACTIONS(3995),
    [anon_sym_typedef] = ACTIONS(3995),
    [anon_sym_in] = ACTIONS(3995),
    [anon_sym_out] = ACTIONS(3995),
    [anon_sym_inout] = ACTIONS(3995),
    [anon_sym_virtual] = ACTIONS(3995),
    [anon_sym_extern] = ACTIONS(3995),
    [anon_sym___attribute__] = ACTIONS(3995),
    [anon_sym___attribute] = ACTIONS(3995),
    [anon_sym_using] = ACTIONS(3995),
    [anon_sym_COLON_COLON] = ACTIONS(3997),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3997),
    [anon_sym___declspec] = ACTIONS(3995),
    [anon_sym___based] = ACTIONS(3995),
    [anon_sym___cdecl] = ACTIONS(3995),
    [anon_sym___clrcall] = ACTIONS(3995),
    [anon_sym___stdcall] = ACTIONS(3995),
    [anon_sym___fastcall] = ACTIONS(3995),
    [anon_sym___thiscall] = ACTIONS(3995),
    [anon_sym___vectorcall] = ACTIONS(3995),
    [anon_sym_LBRACE] = ACTIONS(3997),
    [anon_sym_RBRACE] = ACTIONS(3997),
    [anon_sym_signed] = ACTIONS(3999),
    [anon_sym_unsigned] = ACTIONS(3999),
    [anon_sym_long] = ACTIONS(3999),
    [anon_sym_short] = ACTIONS(3999),
    [anon_sym_LBRACK] = ACTIONS(3995),
    [anon_sym_static] = ACTIONS(3995),
    [anon_sym_register] = ACTIONS(3995),
    [anon_sym_inline] = ACTIONS(3995),
    [anon_sym___inline] = ACTIONS(3995),
    [anon_sym___inline__] = ACTIONS(3995),
    [anon_sym___forceinline] = ACTIONS(3995),
    [anon_sym_thread_local] = ACTIONS(3995),
    [anon_sym___thread] = ACTIONS(3995),
    [anon_sym_const] = ACTIONS(3995),
    [anon_sym_constexpr] = ACTIONS(3995),
    [anon_sym_volatile] = ACTIONS(3995),
    [anon_sym_restrict] = ACTIONS(3995),
    [anon_sym___restrict__] = ACTIONS(3995),
    [anon_sym__Atomic] = ACTIONS(3995),
    [anon_sym__Noreturn] = ACTIONS(3995),
    [anon_sym_noreturn] = ACTIONS(3995),
    [anon_sym__Nonnull] = ACTIONS(3995),
    [anon_sym_mutable] = ACTIONS(3995),
    [anon_sym_constinit] = ACTIONS(3995),
    [anon_sym_consteval] = ACTIONS(3995),
    [anon_sym_alignas] = ACTIONS(3995),
    [anon_sym__Alignas] = ACTIONS(3995),
    [sym_primitive_type] = ACTIONS(3995),
    [anon_sym_enum] = ACTIONS(3995),
    [anon_sym_class] = ACTIONS(3995),
    [anon_sym_struct] = ACTIONS(3995),
    [anon_sym_union] = ACTIONS(3995),
    [anon_sym_if] = ACTIONS(3995),
    [anon_sym_switch] = ACTIONS(3995),
    [anon_sym_case] = ACTIONS(3995),
    [anon_sym_default] = ACTIONS(3995),
    [anon_sym_while] = ACTIONS(3995),
    [anon_sym_do] = ACTIONS(3995),
    [anon_sym_for] = ACTIONS(3995),
    [anon_sym_return] = ACTIONS(3995),
    [anon_sym_break] = ACTIONS(3995),
    [anon_sym_continue] = ACTIONS(3995),
    [anon_sym_goto] = ACTIONS(3995),
    [anon_sym___try] = ACTIONS(3995),
    [anon_sym___leave] = ACTIONS(3995),
    [anon_sym_not] = ACTIONS(3995),
    [anon_sym_compl] = ACTIONS(3995),
    [anon_sym_DASH_DASH] = ACTIONS(3997),
    [anon_sym_PLUS_PLUS] = ACTIONS(3997),
    [anon_sym_sizeof] = ACTIONS(3995),
    [anon_sym___alignof__] = ACTIONS(3995),
    [anon_sym___alignof] = ACTIONS(3995),
    [anon_sym__alignof] = ACTIONS(3995),
    [anon_sym_alignof] = ACTIONS(3995),
    [anon_sym__Alignof] = ACTIONS(3995),
    [anon_sym_offsetof] = ACTIONS(3995),
    [anon_sym__Generic] = ACTIONS(3995),
    [anon_sym_asm] = ACTIONS(3995),
    [anon_sym___asm__] = ACTIONS(3995),
    [anon_sym___asm] = ACTIONS(3995),
    [anon_sym_DOT] = ACTIONS(3995),
    [sym_number_literal] = ACTIONS(3997),
    [anon_sym_L_SQUOTE] = ACTIONS(3997),
    [anon_sym_u_SQUOTE] = ACTIONS(3997),
    [anon_sym_U_SQUOTE] = ACTIONS(3997),
    [anon_sym_u8_SQUOTE] = ACTIONS(3997),
    [anon_sym_SQUOTE] = ACTIONS(3997),
    [anon_sym_L_DQUOTE] = ACTIONS(3997),
    [anon_sym_u_DQUOTE] = ACTIONS(3997),
    [anon_sym_U_DQUOTE] = ACTIONS(3997),
    [anon_sym_u8_DQUOTE] = ACTIONS(3997),
    [anon_sym_DQUOTE] = ACTIONS(3997),
    [sym_true] = ACTIONS(3995),
    [sym_false] = ACTIONS(3995),
    [anon_sym_NULL] = ACTIONS(3995),
    [anon_sym_nullptr] = ACTIONS(3995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3995),
    [anon_sym_let] = ACTIONS(3995),
    [anon_sym_This] = ACTIONS(3995),
    [anon_sym_decltype] = ACTIONS(3995),
    [anon_sym_explicit] = ACTIONS(3995),
    [anon_sym_typename] = ACTIONS(3995),
    [anon_sym_template] = ACTIONS(3995),
    [anon_sym_operator] = ACTIONS(3995),
    [anon_sym_try] = ACTIONS(3995),
    [anon_sym_delete] = ACTIONS(3995),
    [anon_sym_throw] = ACTIONS(3995),
    [anon_sym_namespace] = ACTIONS(3995),
    [anon_sym_static_assert] = ACTIONS(3995),
    [anon_sym_concept] = ACTIONS(3995),
    [anon_sym_co_return] = ACTIONS(3995),
    [anon_sym_co_yield] = ACTIONS(3995),
    [anon_sym_R_DQUOTE] = ACTIONS(3997),
    [anon_sym_LR_DQUOTE] = ACTIONS(3997),
    [anon_sym_uR_DQUOTE] = ACTIONS(3997),
    [anon_sym_UR_DQUOTE] = ACTIONS(3997),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3997),
    [anon_sym_co_await] = ACTIONS(3995),
    [anon_sym_new] = ACTIONS(3995),
    [anon_sym_requires] = ACTIONS(3995),
    [sym_this] = ACTIONS(3995),
    [anon_sym_discard] = ACTIONS(3995),
    [anon_sym_precise] = ACTIONS(3995),
    [anon_sym_shared] = ACTIONS(3995),
    [anon_sym_groupshared] = ACTIONS(3995),
    [anon_sym_uniform] = ACTIONS(3995),
    [anon_sym_row_major] = ACTIONS(3995),
    [anon_sym_column_major] = ACTIONS(3995),
    [anon_sym_globallycoherent] = ACTIONS(3995),
    [anon_sym_centroid] = ACTIONS(3995),
    [anon_sym_noperspective] = ACTIONS(3995),
    [anon_sym_nointerpolation] = ACTIONS(3995),
    [anon_sym_sample] = ACTIONS(3995),
    [anon_sym_linear] = ACTIONS(3995),
    [anon_sym_snorm] = ACTIONS(3995),
    [anon_sym_unorm] = ACTIONS(3995),
    [anon_sym_point] = ACTIONS(3995),
    [anon_sym_line] = ACTIONS(3995),
    [anon_sym_triangleadj] = ACTIONS(3995),
    [anon_sym_lineadj] = ACTIONS(3995),
    [anon_sym_triangle] = ACTIONS(3995),
    [anon_sym_cbuffer] = ACTIONS(3995),
    [anon_sym_interface] = ACTIONS(3995),
    [anon_sym_extension] = ACTIONS(3995),
  },
  [643] = {
    [sym_identifier] = ACTIONS(2550),
    [aux_sym_preproc_include_token1] = ACTIONS(2550),
    [aux_sym_preproc_def_token1] = ACTIONS(2550),
    [aux_sym_preproc_if_token1] = ACTIONS(2550),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2550),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2550),
    [sym_preproc_directive] = ACTIONS(2550),
    [anon_sym_LPAREN2] = ACTIONS(2548),
    [anon_sym_BANG] = ACTIONS(2548),
    [anon_sym_TILDE] = ACTIONS(2548),
    [anon_sym_DASH] = ACTIONS(2550),
    [anon_sym_PLUS] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(2548),
    [anon_sym_AMP_AMP] = ACTIONS(2548),
    [anon_sym_AMP] = ACTIONS(2550),
    [anon_sym_SEMI] = ACTIONS(2548),
    [anon_sym___extension__] = ACTIONS(2550),
    [anon_sym_typedef] = ACTIONS(2550),
    [anon_sym_in] = ACTIONS(2550),
    [anon_sym_out] = ACTIONS(2550),
    [anon_sym_inout] = ACTIONS(2550),
    [anon_sym_virtual] = ACTIONS(2550),
    [anon_sym_extern] = ACTIONS(2550),
    [anon_sym___attribute__] = ACTIONS(2550),
    [anon_sym___attribute] = ACTIONS(2550),
    [anon_sym_using] = ACTIONS(2550),
    [anon_sym_COLON_COLON] = ACTIONS(2548),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2548),
    [anon_sym___declspec] = ACTIONS(2550),
    [anon_sym___based] = ACTIONS(2550),
    [anon_sym___cdecl] = ACTIONS(2550),
    [anon_sym___clrcall] = ACTIONS(2550),
    [anon_sym___stdcall] = ACTIONS(2550),
    [anon_sym___fastcall] = ACTIONS(2550),
    [anon_sym___thiscall] = ACTIONS(2550),
    [anon_sym___vectorcall] = ACTIONS(2550),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_RBRACE] = ACTIONS(2548),
    [anon_sym_signed] = ACTIONS(2550),
    [anon_sym_unsigned] = ACTIONS(2550),
    [anon_sym_long] = ACTIONS(2550),
    [anon_sym_short] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_static] = ACTIONS(2550),
    [anon_sym_register] = ACTIONS(2550),
    [anon_sym_inline] = ACTIONS(2550),
    [anon_sym___inline] = ACTIONS(2550),
    [anon_sym___inline__] = ACTIONS(2550),
    [anon_sym___forceinline] = ACTIONS(2550),
    [anon_sym_thread_local] = ACTIONS(2550),
    [anon_sym___thread] = ACTIONS(2550),
    [anon_sym_const] = ACTIONS(2550),
    [anon_sym_constexpr] = ACTIONS(2550),
    [anon_sym_volatile] = ACTIONS(2550),
    [anon_sym_restrict] = ACTIONS(2550),
    [anon_sym___restrict__] = ACTIONS(2550),
    [anon_sym__Atomic] = ACTIONS(2550),
    [anon_sym__Noreturn] = ACTIONS(2550),
    [anon_sym_noreturn] = ACTIONS(2550),
    [anon_sym__Nonnull] = ACTIONS(2550),
    [anon_sym_mutable] = ACTIONS(2550),
    [anon_sym_constinit] = ACTIONS(2550),
    [anon_sym_consteval] = ACTIONS(2550),
    [anon_sym_alignas] = ACTIONS(2550),
    [anon_sym__Alignas] = ACTIONS(2550),
    [sym_primitive_type] = ACTIONS(2550),
    [anon_sym_enum] = ACTIONS(2550),
    [anon_sym_class] = ACTIONS(2550),
    [anon_sym_struct] = ACTIONS(2550),
    [anon_sym_union] = ACTIONS(2550),
    [anon_sym_if] = ACTIONS(2550),
    [anon_sym_else] = ACTIONS(2550),
    [anon_sym_switch] = ACTIONS(2550),
    [anon_sym_case] = ACTIONS(2550),
    [anon_sym_default] = ACTIONS(2550),
    [anon_sym_while] = ACTIONS(2550),
    [anon_sym_do] = ACTIONS(2550),
    [anon_sym_for] = ACTIONS(2550),
    [anon_sym_return] = ACTIONS(2550),
    [anon_sym_break] = ACTIONS(2550),
    [anon_sym_continue] = ACTIONS(2550),
    [anon_sym_goto] = ACTIONS(2550),
    [anon_sym___try] = ACTIONS(2550),
    [anon_sym___leave] = ACTIONS(2550),
    [anon_sym_not] = ACTIONS(2550),
    [anon_sym_compl] = ACTIONS(2550),
    [anon_sym_DASH_DASH] = ACTIONS(2548),
    [anon_sym_PLUS_PLUS] = ACTIONS(2548),
    [anon_sym_sizeof] = ACTIONS(2550),
    [anon_sym___alignof__] = ACTIONS(2550),
    [anon_sym___alignof] = ACTIONS(2550),
    [anon_sym__alignof] = ACTIONS(2550),
    [anon_sym_alignof] = ACTIONS(2550),
    [anon_sym__Alignof] = ACTIONS(2550),
    [anon_sym_offsetof] = ACTIONS(2550),
    [anon_sym__Generic] = ACTIONS(2550),
    [anon_sym_asm] = ACTIONS(2550),
    [anon_sym___asm__] = ACTIONS(2550),
    [anon_sym___asm] = ACTIONS(2550),
    [anon_sym_DOT] = ACTIONS(2550),
    [sym_number_literal] = ACTIONS(2548),
    [anon_sym_L_SQUOTE] = ACTIONS(2548),
    [anon_sym_u_SQUOTE] = ACTIONS(2548),
    [anon_sym_U_SQUOTE] = ACTIONS(2548),
    [anon_sym_u8_SQUOTE] = ACTIONS(2548),
    [anon_sym_SQUOTE] = ACTIONS(2548),
    [anon_sym_L_DQUOTE] = ACTIONS(2548),
    [anon_sym_u_DQUOTE] = ACTIONS(2548),
    [anon_sym_U_DQUOTE] = ACTIONS(2548),
    [anon_sym_u8_DQUOTE] = ACTIONS(2548),
    [anon_sym_DQUOTE] = ACTIONS(2548),
    [sym_true] = ACTIONS(2550),
    [sym_false] = ACTIONS(2550),
    [anon_sym_NULL] = ACTIONS(2550),
    [anon_sym_nullptr] = ACTIONS(2550),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(2550),
    [anon_sym_This] = ACTIONS(2550),
    [anon_sym_decltype] = ACTIONS(2550),
    [anon_sym_explicit] = ACTIONS(2550),
    [anon_sym_typename] = ACTIONS(2550),
    [anon_sym_template] = ACTIONS(2550),
    [anon_sym_operator] = ACTIONS(2550),
    [anon_sym_try] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(2550),
    [anon_sym_throw] = ACTIONS(2550),
    [anon_sym_namespace] = ACTIONS(2550),
    [anon_sym_static_assert] = ACTIONS(2550),
    [anon_sym_concept] = ACTIONS(2550),
    [anon_sym_co_return] = ACTIONS(2550),
    [anon_sym_co_yield] = ACTIONS(2550),
    [anon_sym_R_DQUOTE] = ACTIONS(2548),
    [anon_sym_LR_DQUOTE] = ACTIONS(2548),
    [anon_sym_uR_DQUOTE] = ACTIONS(2548),
    [anon_sym_UR_DQUOTE] = ACTIONS(2548),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2548),
    [anon_sym_co_await] = ACTIONS(2550),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2550),
    [sym_this] = ACTIONS(2550),
    [anon_sym_discard] = ACTIONS(2550),
    [anon_sym_precise] = ACTIONS(2550),
    [anon_sym_shared] = ACTIONS(2550),
    [anon_sym_groupshared] = ACTIONS(2550),
    [anon_sym_uniform] = ACTIONS(2550),
    [anon_sym_row_major] = ACTIONS(2550),
    [anon_sym_column_major] = ACTIONS(2550),
    [anon_sym_globallycoherent] = ACTIONS(2550),
    [anon_sym_centroid] = ACTIONS(2550),
    [anon_sym_noperspective] = ACTIONS(2550),
    [anon_sym_nointerpolation] = ACTIONS(2550),
    [anon_sym_sample] = ACTIONS(2550),
    [anon_sym_linear] = ACTIONS(2550),
    [anon_sym_snorm] = ACTIONS(2550),
    [anon_sym_unorm] = ACTIONS(2550),
    [anon_sym_point] = ACTIONS(2550),
    [anon_sym_line] = ACTIONS(2550),
    [anon_sym_triangleadj] = ACTIONS(2550),
    [anon_sym_lineadj] = ACTIONS(2550),
    [anon_sym_triangle] = ACTIONS(2550),
    [anon_sym_cbuffer] = ACTIONS(2550),
    [anon_sym_interface] = ACTIONS(2550),
    [anon_sym_extension] = ACTIONS(2550),
  },
  [644] = {
    [sym_attribute_specifier] = STATE(320),
    [ts_builtin_sym_end] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4004),
    [aux_sym_preproc_include_token1] = ACTIONS(4004),
    [aux_sym_preproc_def_token1] = ACTIONS(4004),
    [aux_sym_preproc_if_token1] = ACTIONS(4004),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4004),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4004),
    [sym_preproc_directive] = ACTIONS(4004),
    [anon_sym_LPAREN2] = ACTIONS(4002),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4004),
    [anon_sym_PLUS] = ACTIONS(4004),
    [anon_sym_STAR] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4002),
    [anon_sym_AMP] = ACTIONS(4004),
    [anon_sym_SEMI] = ACTIONS(4002),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_typedef] = ACTIONS(4004),
    [anon_sym_in] = ACTIONS(4004),
    [anon_sym_out] = ACTIONS(4004),
    [anon_sym_inout] = ACTIONS(4004),
    [anon_sym_virtual] = ACTIONS(4004),
    [anon_sym_extern] = ACTIONS(4004),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4002),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4002),
    [anon_sym___declspec] = ACTIONS(4004),
    [anon_sym___based] = ACTIONS(4004),
    [anon_sym___cdecl] = ACTIONS(4004),
    [anon_sym___clrcall] = ACTIONS(4004),
    [anon_sym___stdcall] = ACTIONS(4004),
    [anon_sym___fastcall] = ACTIONS(4004),
    [anon_sym___thiscall] = ACTIONS(4004),
    [anon_sym___vectorcall] = ACTIONS(4004),
    [anon_sym_LBRACE] = ACTIONS(4002),
    [anon_sym_signed] = ACTIONS(4004),
    [anon_sym_unsigned] = ACTIONS(4004),
    [anon_sym_long] = ACTIONS(4004),
    [anon_sym_short] = ACTIONS(4004),
    [anon_sym_LBRACK] = ACTIONS(4004),
    [anon_sym_static] = ACTIONS(4004),
    [anon_sym_register] = ACTIONS(4004),
    [anon_sym_inline] = ACTIONS(4004),
    [anon_sym___inline] = ACTIONS(4004),
    [anon_sym___inline__] = ACTIONS(4004),
    [anon_sym___forceinline] = ACTIONS(4004),
    [anon_sym_thread_local] = ACTIONS(4004),
    [anon_sym___thread] = ACTIONS(4004),
    [anon_sym_const] = ACTIONS(4004),
    [anon_sym_constexpr] = ACTIONS(4004),
    [anon_sym_volatile] = ACTIONS(4004),
    [anon_sym_restrict] = ACTIONS(4004),
    [anon_sym___restrict__] = ACTIONS(4004),
    [anon_sym__Atomic] = ACTIONS(4004),
    [anon_sym__Noreturn] = ACTIONS(4004),
    [anon_sym_noreturn] = ACTIONS(4004),
    [anon_sym__Nonnull] = ACTIONS(4004),
    [anon_sym_mutable] = ACTIONS(4004),
    [anon_sym_constinit] = ACTIONS(4004),
    [anon_sym_consteval] = ACTIONS(4004),
    [anon_sym_alignas] = ACTIONS(4004),
    [anon_sym__Alignas] = ACTIONS(4004),
    [sym_primitive_type] = ACTIONS(4004),
    [anon_sym_enum] = ACTIONS(4004),
    [anon_sym_class] = ACTIONS(4004),
    [anon_sym_struct] = ACTIONS(4004),
    [anon_sym_union] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(4004),
    [anon_sym_switch] = ACTIONS(4004),
    [anon_sym_case] = ACTIONS(4004),
    [anon_sym_default] = ACTIONS(4004),
    [anon_sym_while] = ACTIONS(4004),
    [anon_sym_do] = ACTIONS(4004),
    [anon_sym_for] = ACTIONS(4004),
    [anon_sym_return] = ACTIONS(4004),
    [anon_sym_break] = ACTIONS(4004),
    [anon_sym_continue] = ACTIONS(4004),
    [anon_sym_goto] = ACTIONS(4004),
    [anon_sym_not] = ACTIONS(4004),
    [anon_sym_compl] = ACTIONS(4004),
    [anon_sym_DASH_DASH] = ACTIONS(4002),
    [anon_sym_PLUS_PLUS] = ACTIONS(4002),
    [anon_sym_sizeof] = ACTIONS(4004),
    [anon_sym___alignof__] = ACTIONS(4004),
    [anon_sym___alignof] = ACTIONS(4004),
    [anon_sym__alignof] = ACTIONS(4004),
    [anon_sym_alignof] = ACTIONS(4004),
    [anon_sym__Alignof] = ACTIONS(4004),
    [anon_sym_offsetof] = ACTIONS(4004),
    [anon_sym__Generic] = ACTIONS(4004),
    [anon_sym_asm] = ACTIONS(4004),
    [anon_sym___asm__] = ACTIONS(4004),
    [anon_sym___asm] = ACTIONS(4004),
    [anon_sym_DOT] = ACTIONS(4004),
    [sym_number_literal] = ACTIONS(4002),
    [anon_sym_L_SQUOTE] = ACTIONS(4002),
    [anon_sym_u_SQUOTE] = ACTIONS(4002),
    [anon_sym_U_SQUOTE] = ACTIONS(4002),
    [anon_sym_u8_SQUOTE] = ACTIONS(4002),
    [anon_sym_SQUOTE] = ACTIONS(4002),
    [anon_sym_L_DQUOTE] = ACTIONS(4002),
    [anon_sym_u_DQUOTE] = ACTIONS(4002),
    [anon_sym_U_DQUOTE] = ACTIONS(4002),
    [anon_sym_u8_DQUOTE] = ACTIONS(4002),
    [anon_sym_DQUOTE] = ACTIONS(4002),
    [sym_true] = ACTIONS(4004),
    [sym_false] = ACTIONS(4004),
    [anon_sym_NULL] = ACTIONS(4004),
    [anon_sym_nullptr] = ACTIONS(4004),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4004),
    [anon_sym_let] = ACTIONS(4004),
    [anon_sym_This] = ACTIONS(4004),
    [anon_sym_decltype] = ACTIONS(4004),
    [anon_sym_explicit] = ACTIONS(4004),
    [anon_sym_typename] = ACTIONS(4004),
    [anon_sym_export] = ACTIONS(4004),
    [anon_sym_module] = ACTIONS(4004),
    [anon_sym_import] = ACTIONS(4004),
    [anon_sym_template] = ACTIONS(4004),
    [anon_sym_operator] = ACTIONS(4004),
    [anon_sym_try] = ACTIONS(4004),
    [anon_sym_delete] = ACTIONS(4004),
    [anon_sym_throw] = ACTIONS(4004),
    [anon_sym_namespace] = ACTIONS(4004),
    [anon_sym_static_assert] = ACTIONS(4004),
    [anon_sym_concept] = ACTIONS(4004),
    [anon_sym_co_return] = ACTIONS(4004),
    [anon_sym_co_yield] = ACTIONS(4004),
    [anon_sym_R_DQUOTE] = ACTIONS(4002),
    [anon_sym_LR_DQUOTE] = ACTIONS(4002),
    [anon_sym_uR_DQUOTE] = ACTIONS(4002),
    [anon_sym_UR_DQUOTE] = ACTIONS(4002),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4002),
    [anon_sym_co_await] = ACTIONS(4004),
    [anon_sym_new] = ACTIONS(4004),
    [anon_sym_requires] = ACTIONS(4004),
    [sym_this] = ACTIONS(4004),
    [anon_sym_precise] = ACTIONS(4004),
    [anon_sym_shared] = ACTIONS(4004),
    [anon_sym_groupshared] = ACTIONS(4004),
    [anon_sym_uniform] = ACTIONS(4004),
    [anon_sym_row_major] = ACTIONS(4004),
    [anon_sym_column_major] = ACTIONS(4004),
    [anon_sym_globallycoherent] = ACTIONS(4004),
    [anon_sym_centroid] = ACTIONS(4004),
    [anon_sym_noperspective] = ACTIONS(4004),
    [anon_sym_nointerpolation] = ACTIONS(4004),
    [anon_sym_sample] = ACTIONS(4004),
    [anon_sym_linear] = ACTIONS(4004),
    [anon_sym_snorm] = ACTIONS(4004),
    [anon_sym_unorm] = ACTIONS(4004),
    [anon_sym_point] = ACTIONS(4004),
    [anon_sym_line] = ACTIONS(4004),
    [anon_sym_triangleadj] = ACTIONS(4004),
    [anon_sym_lineadj] = ACTIONS(4004),
    [anon_sym_triangle] = ACTIONS(4004),
    [anon_sym_interface] = ACTIONS(4004),
    [anon_sym_extension] = ACTIONS(4004),
    [anon_sym___exported] = ACTIONS(4004),
  },
  [645] = {
    [sym_else_clause] = STATE(729),
    [sym_identifier] = ACTIONS(3214),
    [aux_sym_preproc_include_token1] = ACTIONS(3214),
    [aux_sym_preproc_def_token1] = ACTIONS(3214),
    [aux_sym_preproc_if_token1] = ACTIONS(3214),
    [aux_sym_preproc_if_token2] = ACTIONS(3214),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3214),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3214),
    [sym_preproc_directive] = ACTIONS(3214),
    [anon_sym_LPAREN2] = ACTIONS(3212),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3214),
    [anon_sym_STAR] = ACTIONS(3212),
    [anon_sym_AMP_AMP] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3214),
    [anon_sym_SEMI] = ACTIONS(3212),
    [anon_sym___extension__] = ACTIONS(3214),
    [anon_sym_typedef] = ACTIONS(3214),
    [anon_sym_in] = ACTIONS(3214),
    [anon_sym_out] = ACTIONS(3214),
    [anon_sym_inout] = ACTIONS(3214),
    [anon_sym_virtual] = ACTIONS(3214),
    [anon_sym_extern] = ACTIONS(3214),
    [anon_sym___attribute__] = ACTIONS(3214),
    [anon_sym___attribute] = ACTIONS(3214),
    [anon_sym_using] = ACTIONS(3214),
    [anon_sym_COLON_COLON] = ACTIONS(3212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3212),
    [anon_sym___declspec] = ACTIONS(3214),
    [anon_sym___based] = ACTIONS(3214),
    [anon_sym___cdecl] = ACTIONS(3214),
    [anon_sym___clrcall] = ACTIONS(3214),
    [anon_sym___stdcall] = ACTIONS(3214),
    [anon_sym___fastcall] = ACTIONS(3214),
    [anon_sym___thiscall] = ACTIONS(3214),
    [anon_sym___vectorcall] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_signed] = ACTIONS(3214),
    [anon_sym_unsigned] = ACTIONS(3214),
    [anon_sym_long] = ACTIONS(3214),
    [anon_sym_short] = ACTIONS(3214),
    [anon_sym_LBRACK] = ACTIONS(3214),
    [anon_sym_static] = ACTIONS(3214),
    [anon_sym_register] = ACTIONS(3214),
    [anon_sym_inline] = ACTIONS(3214),
    [anon_sym___inline] = ACTIONS(3214),
    [anon_sym___inline__] = ACTIONS(3214),
    [anon_sym___forceinline] = ACTIONS(3214),
    [anon_sym_thread_local] = ACTIONS(3214),
    [anon_sym___thread] = ACTIONS(3214),
    [anon_sym_const] = ACTIONS(3214),
    [anon_sym_constexpr] = ACTIONS(3214),
    [anon_sym_volatile] = ACTIONS(3214),
    [anon_sym_restrict] = ACTIONS(3214),
    [anon_sym___restrict__] = ACTIONS(3214),
    [anon_sym__Atomic] = ACTIONS(3214),
    [anon_sym__Noreturn] = ACTIONS(3214),
    [anon_sym_noreturn] = ACTIONS(3214),
    [anon_sym__Nonnull] = ACTIONS(3214),
    [anon_sym_mutable] = ACTIONS(3214),
    [anon_sym_constinit] = ACTIONS(3214),
    [anon_sym_consteval] = ACTIONS(3214),
    [anon_sym_alignas] = ACTIONS(3214),
    [anon_sym__Alignas] = ACTIONS(3214),
    [sym_primitive_type] = ACTIONS(3214),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3214),
    [anon_sym_struct] = ACTIONS(3214),
    [anon_sym_union] = ACTIONS(3214),
    [anon_sym_if] = ACTIONS(3214),
    [anon_sym_else] = ACTIONS(4006),
    [anon_sym_switch] = ACTIONS(3214),
    [anon_sym_case] = ACTIONS(3214),
    [anon_sym_default] = ACTIONS(3214),
    [anon_sym_while] = ACTIONS(3214),
    [anon_sym_do] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3214),
    [anon_sym_return] = ACTIONS(3214),
    [anon_sym_break] = ACTIONS(3214),
    [anon_sym_continue] = ACTIONS(3214),
    [anon_sym_goto] = ACTIONS(3214),
    [anon_sym___try] = ACTIONS(3214),
    [anon_sym___leave] = ACTIONS(3214),
    [anon_sym_not] = ACTIONS(3214),
    [anon_sym_compl] = ACTIONS(3214),
    [anon_sym_DASH_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_PLUS] = ACTIONS(3212),
    [anon_sym_sizeof] = ACTIONS(3214),
    [anon_sym___alignof__] = ACTIONS(3214),
    [anon_sym___alignof] = ACTIONS(3214),
    [anon_sym__alignof] = ACTIONS(3214),
    [anon_sym_alignof] = ACTIONS(3214),
    [anon_sym__Alignof] = ACTIONS(3214),
    [anon_sym_offsetof] = ACTIONS(3214),
    [anon_sym__Generic] = ACTIONS(3214),
    [anon_sym_asm] = ACTIONS(3214),
    [anon_sym___asm__] = ACTIONS(3214),
    [anon_sym___asm] = ACTIONS(3214),
    [sym_number_literal] = ACTIONS(3212),
    [anon_sym_L_SQUOTE] = ACTIONS(3212),
    [anon_sym_u_SQUOTE] = ACTIONS(3212),
    [anon_sym_U_SQUOTE] = ACTIONS(3212),
    [anon_sym_u8_SQUOTE] = ACTIONS(3212),
    [anon_sym_SQUOTE] = ACTIONS(3212),
    [anon_sym_L_DQUOTE] = ACTIONS(3212),
    [anon_sym_u_DQUOTE] = ACTIONS(3212),
    [anon_sym_U_DQUOTE] = ACTIONS(3212),
    [anon_sym_u8_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [sym_true] = ACTIONS(3214),
    [sym_false] = ACTIONS(3214),
    [anon_sym_NULL] = ACTIONS(3214),
    [anon_sym_nullptr] = ACTIONS(3214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3214),
    [anon_sym_let] = ACTIONS(3214),
    [anon_sym_This] = ACTIONS(3214),
    [anon_sym_decltype] = ACTIONS(3214),
    [anon_sym_explicit] = ACTIONS(3214),
    [anon_sym_typename] = ACTIONS(3214),
    [anon_sym_template] = ACTIONS(3214),
    [anon_sym_operator] = ACTIONS(3214),
    [anon_sym_try] = ACTIONS(3214),
    [anon_sym_delete] = ACTIONS(3214),
    [anon_sym_throw] = ACTIONS(3214),
    [anon_sym_namespace] = ACTIONS(3214),
    [anon_sym_static_assert] = ACTIONS(3214),
    [anon_sym_concept] = ACTIONS(3214),
    [anon_sym_co_return] = ACTIONS(3214),
    [anon_sym_co_yield] = ACTIONS(3214),
    [anon_sym_R_DQUOTE] = ACTIONS(3212),
    [anon_sym_LR_DQUOTE] = ACTIONS(3212),
    [anon_sym_uR_DQUOTE] = ACTIONS(3212),
    [anon_sym_UR_DQUOTE] = ACTIONS(3212),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3212),
    [anon_sym_co_await] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3214),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(3214),
    [anon_sym_discard] = ACTIONS(3214),
    [anon_sym_precise] = ACTIONS(3214),
    [anon_sym_shared] = ACTIONS(3214),
    [anon_sym_groupshared] = ACTIONS(3214),
    [anon_sym_uniform] = ACTIONS(3214),
    [anon_sym_row_major] = ACTIONS(3214),
    [anon_sym_column_major] = ACTIONS(3214),
    [anon_sym_globallycoherent] = ACTIONS(3214),
    [anon_sym_centroid] = ACTIONS(3214),
    [anon_sym_noperspective] = ACTIONS(3214),
    [anon_sym_nointerpolation] = ACTIONS(3214),
    [anon_sym_sample] = ACTIONS(3214),
    [anon_sym_linear] = ACTIONS(3214),
    [anon_sym_snorm] = ACTIONS(3214),
    [anon_sym_unorm] = ACTIONS(3214),
    [anon_sym_point] = ACTIONS(3214),
    [anon_sym_line] = ACTIONS(3214),
    [anon_sym_triangleadj] = ACTIONS(3214),
    [anon_sym_lineadj] = ACTIONS(3214),
    [anon_sym_triangle] = ACTIONS(3214),
    [anon_sym_cbuffer] = ACTIONS(3214),
    [anon_sym_interface] = ACTIONS(3214),
    [anon_sym_extension] = ACTIONS(3214),
  },
  [646] = {
    [sym_attribute_specifier] = STATE(286),
    [ts_builtin_sym_end] = ACTIONS(4008),
    [sym_identifier] = ACTIONS(4010),
    [aux_sym_preproc_include_token1] = ACTIONS(4010),
    [aux_sym_preproc_def_token1] = ACTIONS(4010),
    [aux_sym_preproc_if_token1] = ACTIONS(4010),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4010),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4010),
    [sym_preproc_directive] = ACTIONS(4010),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_BANG] = ACTIONS(4008),
    [anon_sym_TILDE] = ACTIONS(4008),
    [anon_sym_DASH] = ACTIONS(4010),
    [anon_sym_PLUS] = ACTIONS(4010),
    [anon_sym_STAR] = ACTIONS(4008),
    [anon_sym_AMP_AMP] = ACTIONS(4008),
    [anon_sym_AMP] = ACTIONS(4010),
    [anon_sym_SEMI] = ACTIONS(4008),
    [anon_sym___extension__] = ACTIONS(4010),
    [anon_sym_typedef] = ACTIONS(4010),
    [anon_sym_in] = ACTIONS(4010),
    [anon_sym_out] = ACTIONS(4010),
    [anon_sym_inout] = ACTIONS(4010),
    [anon_sym_virtual] = ACTIONS(4010),
    [anon_sym_extern] = ACTIONS(4010),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(4010),
    [anon_sym_COLON_COLON] = ACTIONS(4008),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4008),
    [anon_sym___declspec] = ACTIONS(4010),
    [anon_sym___based] = ACTIONS(4010),
    [anon_sym___cdecl] = ACTIONS(4010),
    [anon_sym___clrcall] = ACTIONS(4010),
    [anon_sym___stdcall] = ACTIONS(4010),
    [anon_sym___fastcall] = ACTIONS(4010),
    [anon_sym___thiscall] = ACTIONS(4010),
    [anon_sym___vectorcall] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4008),
    [anon_sym_signed] = ACTIONS(4010),
    [anon_sym_unsigned] = ACTIONS(4010),
    [anon_sym_long] = ACTIONS(4010),
    [anon_sym_short] = ACTIONS(4010),
    [anon_sym_LBRACK] = ACTIONS(4010),
    [anon_sym_static] = ACTIONS(4010),
    [anon_sym_register] = ACTIONS(4010),
    [anon_sym_inline] = ACTIONS(4010),
    [anon_sym___inline] = ACTIONS(4010),
    [anon_sym___inline__] = ACTIONS(4010),
    [anon_sym___forceinline] = ACTIONS(4010),
    [anon_sym_thread_local] = ACTIONS(4010),
    [anon_sym___thread] = ACTIONS(4010),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_constexpr] = ACTIONS(4010),
    [anon_sym_volatile] = ACTIONS(4010),
    [anon_sym_restrict] = ACTIONS(4010),
    [anon_sym___restrict__] = ACTIONS(4010),
    [anon_sym__Atomic] = ACTIONS(4010),
    [anon_sym__Noreturn] = ACTIONS(4010),
    [anon_sym_noreturn] = ACTIONS(4010),
    [anon_sym__Nonnull] = ACTIONS(4010),
    [anon_sym_mutable] = ACTIONS(4010),
    [anon_sym_constinit] = ACTIONS(4010),
    [anon_sym_consteval] = ACTIONS(4010),
    [anon_sym_alignas] = ACTIONS(4010),
    [anon_sym__Alignas] = ACTIONS(4010),
    [sym_primitive_type] = ACTIONS(4010),
    [anon_sym_enum] = ACTIONS(4010),
    [anon_sym_class] = ACTIONS(4010),
    [anon_sym_struct] = ACTIONS(4010),
    [anon_sym_union] = ACTIONS(4010),
    [anon_sym_if] = ACTIONS(4010),
    [anon_sym_switch] = ACTIONS(4010),
    [anon_sym_case] = ACTIONS(4010),
    [anon_sym_default] = ACTIONS(4010),
    [anon_sym_while] = ACTIONS(4010),
    [anon_sym_do] = ACTIONS(4010),
    [anon_sym_for] = ACTIONS(4010),
    [anon_sym_return] = ACTIONS(4010),
    [anon_sym_break] = ACTIONS(4010),
    [anon_sym_continue] = ACTIONS(4010),
    [anon_sym_goto] = ACTIONS(4010),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_compl] = ACTIONS(4010),
    [anon_sym_DASH_DASH] = ACTIONS(4008),
    [anon_sym_PLUS_PLUS] = ACTIONS(4008),
    [anon_sym_sizeof] = ACTIONS(4010),
    [anon_sym___alignof__] = ACTIONS(4010),
    [anon_sym___alignof] = ACTIONS(4010),
    [anon_sym__alignof] = ACTIONS(4010),
    [anon_sym_alignof] = ACTIONS(4010),
    [anon_sym__Alignof] = ACTIONS(4010),
    [anon_sym_offsetof] = ACTIONS(4010),
    [anon_sym__Generic] = ACTIONS(4010),
    [anon_sym_asm] = ACTIONS(4010),
    [anon_sym___asm__] = ACTIONS(4010),
    [anon_sym___asm] = ACTIONS(4010),
    [anon_sym_DOT] = ACTIONS(4010),
    [sym_number_literal] = ACTIONS(4008),
    [anon_sym_L_SQUOTE] = ACTIONS(4008),
    [anon_sym_u_SQUOTE] = ACTIONS(4008),
    [anon_sym_U_SQUOTE] = ACTIONS(4008),
    [anon_sym_u8_SQUOTE] = ACTIONS(4008),
    [anon_sym_SQUOTE] = ACTIONS(4008),
    [anon_sym_L_DQUOTE] = ACTIONS(4008),
    [anon_sym_u_DQUOTE] = ACTIONS(4008),
    [anon_sym_U_DQUOTE] = ACTIONS(4008),
    [anon_sym_u8_DQUOTE] = ACTIONS(4008),
    [anon_sym_DQUOTE] = ACTIONS(4008),
    [sym_true] = ACTIONS(4010),
    [sym_false] = ACTIONS(4010),
    [anon_sym_NULL] = ACTIONS(4010),
    [anon_sym_nullptr] = ACTIONS(4010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4010),
    [anon_sym_let] = ACTIONS(4010),
    [anon_sym_This] = ACTIONS(4010),
    [anon_sym_decltype] = ACTIONS(4010),
    [anon_sym_explicit] = ACTIONS(4010),
    [anon_sym_typename] = ACTIONS(4010),
    [anon_sym_export] = ACTIONS(4010),
    [anon_sym_module] = ACTIONS(4010),
    [anon_sym_import] = ACTIONS(4010),
    [anon_sym_template] = ACTIONS(4010),
    [anon_sym_operator] = ACTIONS(4010),
    [anon_sym_try] = ACTIONS(4010),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_throw] = ACTIONS(4010),
    [anon_sym_namespace] = ACTIONS(4010),
    [anon_sym_static_assert] = ACTIONS(4010),
    [anon_sym_concept] = ACTIONS(4010),
    [anon_sym_co_return] = ACTIONS(4010),
    [anon_sym_co_yield] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(4008),
    [anon_sym_LR_DQUOTE] = ACTIONS(4008),
    [anon_sym_uR_DQUOTE] = ACTIONS(4008),
    [anon_sym_UR_DQUOTE] = ACTIONS(4008),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4008),
    [anon_sym_co_await] = ACTIONS(4010),
    [anon_sym_new] = ACTIONS(4010),
    [anon_sym_requires] = ACTIONS(4010),
    [sym_this] = ACTIONS(4010),
    [anon_sym_precise] = ACTIONS(4010),
    [anon_sym_shared] = ACTIONS(4010),
    [anon_sym_groupshared] = ACTIONS(4010),
    [anon_sym_uniform] = ACTIONS(4010),
    [anon_sym_row_major] = ACTIONS(4010),
    [anon_sym_column_major] = ACTIONS(4010),
    [anon_sym_globallycoherent] = ACTIONS(4010),
    [anon_sym_centroid] = ACTIONS(4010),
    [anon_sym_noperspective] = ACTIONS(4010),
    [anon_sym_nointerpolation] = ACTIONS(4010),
    [anon_sym_sample] = ACTIONS(4010),
    [anon_sym_linear] = ACTIONS(4010),
    [anon_sym_snorm] = ACTIONS(4010),
    [anon_sym_unorm] = ACTIONS(4010),
    [anon_sym_point] = ACTIONS(4010),
    [anon_sym_line] = ACTIONS(4010),
    [anon_sym_triangleadj] = ACTIONS(4010),
    [anon_sym_lineadj] = ACTIONS(4010),
    [anon_sym_triangle] = ACTIONS(4010),
    [anon_sym_interface] = ACTIONS(4010),
    [anon_sym_extension] = ACTIONS(4010),
    [anon_sym___exported] = ACTIONS(4010),
  },
  [647] = {
    [sym_attribute_specifier] = STATE(287),
    [ts_builtin_sym_end] = ACTIONS(4012),
    [sym_identifier] = ACTIONS(4014),
    [aux_sym_preproc_include_token1] = ACTIONS(4014),
    [aux_sym_preproc_def_token1] = ACTIONS(4014),
    [aux_sym_preproc_if_token1] = ACTIONS(4014),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4014),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4014),
    [sym_preproc_directive] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(4012),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [anon_sym_DASH] = ACTIONS(4014),
    [anon_sym_PLUS] = ACTIONS(4014),
    [anon_sym_STAR] = ACTIONS(4012),
    [anon_sym_AMP_AMP] = ACTIONS(4012),
    [anon_sym_AMP] = ACTIONS(4014),
    [anon_sym_SEMI] = ACTIONS(4012),
    [anon_sym___extension__] = ACTIONS(4014),
    [anon_sym_typedef] = ACTIONS(4014),
    [anon_sym_in] = ACTIONS(4014),
    [anon_sym_out] = ACTIONS(4014),
    [anon_sym_inout] = ACTIONS(4014),
    [anon_sym_virtual] = ACTIONS(4014),
    [anon_sym_extern] = ACTIONS(4014),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(4014),
    [anon_sym_COLON_COLON] = ACTIONS(4012),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4012),
    [anon_sym___declspec] = ACTIONS(4014),
    [anon_sym___based] = ACTIONS(4014),
    [anon_sym___cdecl] = ACTIONS(4014),
    [anon_sym___clrcall] = ACTIONS(4014),
    [anon_sym___stdcall] = ACTIONS(4014),
    [anon_sym___fastcall] = ACTIONS(4014),
    [anon_sym___thiscall] = ACTIONS(4014),
    [anon_sym___vectorcall] = ACTIONS(4014),
    [anon_sym_LBRACE] = ACTIONS(4012),
    [anon_sym_signed] = ACTIONS(4014),
    [anon_sym_unsigned] = ACTIONS(4014),
    [anon_sym_long] = ACTIONS(4014),
    [anon_sym_short] = ACTIONS(4014),
    [anon_sym_LBRACK] = ACTIONS(4014),
    [anon_sym_static] = ACTIONS(4014),
    [anon_sym_register] = ACTIONS(4014),
    [anon_sym_inline] = ACTIONS(4014),
    [anon_sym___inline] = ACTIONS(4014),
    [anon_sym___inline__] = ACTIONS(4014),
    [anon_sym___forceinline] = ACTIONS(4014),
    [anon_sym_thread_local] = ACTIONS(4014),
    [anon_sym___thread] = ACTIONS(4014),
    [anon_sym_const] = ACTIONS(4014),
    [anon_sym_constexpr] = ACTIONS(4014),
    [anon_sym_volatile] = ACTIONS(4014),
    [anon_sym_restrict] = ACTIONS(4014),
    [anon_sym___restrict__] = ACTIONS(4014),
    [anon_sym__Atomic] = ACTIONS(4014),
    [anon_sym__Noreturn] = ACTIONS(4014),
    [anon_sym_noreturn] = ACTIONS(4014),
    [anon_sym__Nonnull] = ACTIONS(4014),
    [anon_sym_mutable] = ACTIONS(4014),
    [anon_sym_constinit] = ACTIONS(4014),
    [anon_sym_consteval] = ACTIONS(4014),
    [anon_sym_alignas] = ACTIONS(4014),
    [anon_sym__Alignas] = ACTIONS(4014),
    [sym_primitive_type] = ACTIONS(4014),
    [anon_sym_enum] = ACTIONS(4014),
    [anon_sym_class] = ACTIONS(4014),
    [anon_sym_struct] = ACTIONS(4014),
    [anon_sym_union] = ACTIONS(4014),
    [anon_sym_if] = ACTIONS(4014),
    [anon_sym_switch] = ACTIONS(4014),
    [anon_sym_case] = ACTIONS(4014),
    [anon_sym_default] = ACTIONS(4014),
    [anon_sym_while] = ACTIONS(4014),
    [anon_sym_do] = ACTIONS(4014),
    [anon_sym_for] = ACTIONS(4014),
    [anon_sym_return] = ACTIONS(4014),
    [anon_sym_break] = ACTIONS(4014),
    [anon_sym_continue] = ACTIONS(4014),
    [anon_sym_goto] = ACTIONS(4014),
    [anon_sym_not] = ACTIONS(4014),
    [anon_sym_compl] = ACTIONS(4014),
    [anon_sym_DASH_DASH] = ACTIONS(4012),
    [anon_sym_PLUS_PLUS] = ACTIONS(4012),
    [anon_sym_sizeof] = ACTIONS(4014),
    [anon_sym___alignof__] = ACTIONS(4014),
    [anon_sym___alignof] = ACTIONS(4014),
    [anon_sym__alignof] = ACTIONS(4014),
    [anon_sym_alignof] = ACTIONS(4014),
    [anon_sym__Alignof] = ACTIONS(4014),
    [anon_sym_offsetof] = ACTIONS(4014),
    [anon_sym__Generic] = ACTIONS(4014),
    [anon_sym_asm] = ACTIONS(4014),
    [anon_sym___asm__] = ACTIONS(4014),
    [anon_sym___asm] = ACTIONS(4014),
    [anon_sym_DOT] = ACTIONS(4014),
    [sym_number_literal] = ACTIONS(4012),
    [anon_sym_L_SQUOTE] = ACTIONS(4012),
    [anon_sym_u_SQUOTE] = ACTIONS(4012),
    [anon_sym_U_SQUOTE] = ACTIONS(4012),
    [anon_sym_u8_SQUOTE] = ACTIONS(4012),
    [anon_sym_SQUOTE] = ACTIONS(4012),
    [anon_sym_L_DQUOTE] = ACTIONS(4012),
    [anon_sym_u_DQUOTE] = ACTIONS(4012),
    [anon_sym_U_DQUOTE] = ACTIONS(4012),
    [anon_sym_u8_DQUOTE] = ACTIONS(4012),
    [anon_sym_DQUOTE] = ACTIONS(4012),
    [sym_true] = ACTIONS(4014),
    [sym_false] = ACTIONS(4014),
    [anon_sym_NULL] = ACTIONS(4014),
    [anon_sym_nullptr] = ACTIONS(4014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4014),
    [anon_sym_let] = ACTIONS(4014),
    [anon_sym_This] = ACTIONS(4014),
    [anon_sym_decltype] = ACTIONS(4014),
    [anon_sym_explicit] = ACTIONS(4014),
    [anon_sym_typename] = ACTIONS(4014),
    [anon_sym_export] = ACTIONS(4014),
    [anon_sym_module] = ACTIONS(4014),
    [anon_sym_import] = ACTIONS(4014),
    [anon_sym_template] = ACTIONS(4014),
    [anon_sym_operator] = ACTIONS(4014),
    [anon_sym_try] = ACTIONS(4014),
    [anon_sym_delete] = ACTIONS(4014),
    [anon_sym_throw] = ACTIONS(4014),
    [anon_sym_namespace] = ACTIONS(4014),
    [anon_sym_static_assert] = ACTIONS(4014),
    [anon_sym_concept] = ACTIONS(4014),
    [anon_sym_co_return] = ACTIONS(4014),
    [anon_sym_co_yield] = ACTIONS(4014),
    [anon_sym_R_DQUOTE] = ACTIONS(4012),
    [anon_sym_LR_DQUOTE] = ACTIONS(4012),
    [anon_sym_uR_DQUOTE] = ACTIONS(4012),
    [anon_sym_UR_DQUOTE] = ACTIONS(4012),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4012),
    [anon_sym_co_await] = ACTIONS(4014),
    [anon_sym_new] = ACTIONS(4014),
    [anon_sym_requires] = ACTIONS(4014),
    [sym_this] = ACTIONS(4014),
    [anon_sym_precise] = ACTIONS(4014),
    [anon_sym_shared] = ACTIONS(4014),
    [anon_sym_groupshared] = ACTIONS(4014),
    [anon_sym_uniform] = ACTIONS(4014),
    [anon_sym_row_major] = ACTIONS(4014),
    [anon_sym_column_major] = ACTIONS(4014),
    [anon_sym_globallycoherent] = ACTIONS(4014),
    [anon_sym_centroid] = ACTIONS(4014),
    [anon_sym_noperspective] = ACTIONS(4014),
    [anon_sym_nointerpolation] = ACTIONS(4014),
    [anon_sym_sample] = ACTIONS(4014),
    [anon_sym_linear] = ACTIONS(4014),
    [anon_sym_snorm] = ACTIONS(4014),
    [anon_sym_unorm] = ACTIONS(4014),
    [anon_sym_point] = ACTIONS(4014),
    [anon_sym_line] = ACTIONS(4014),
    [anon_sym_triangleadj] = ACTIONS(4014),
    [anon_sym_lineadj] = ACTIONS(4014),
    [anon_sym_triangle] = ACTIONS(4014),
    [anon_sym_interface] = ACTIONS(4014),
    [anon_sym_extension] = ACTIONS(4014),
    [anon_sym___exported] = ACTIONS(4014),
  },
  [648] = {
    [sym_expression] = STATE(5656),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11333),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(4016),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(4019),
    [anon_sym___extension__] = ACTIONS(4021),
    [anon_sym_in] = ACTIONS(4024),
    [anon_sym_out] = ACTIONS(4024),
    [anon_sym_inout] = ACTIONS(4024),
    [anon_sym_virtual] = ACTIONS(4024),
    [anon_sym_extern] = ACTIONS(4024),
    [anon_sym___attribute__] = ACTIONS(4024),
    [anon_sym___attribute] = ACTIONS(4024),
    [anon_sym_COLON_COLON] = ACTIONS(4026),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4029),
    [anon_sym___declspec] = ACTIONS(4024),
    [anon_sym_signed] = ACTIONS(4024),
    [anon_sym_unsigned] = ACTIONS(4024),
    [anon_sym_long] = ACTIONS(4024),
    [anon_sym_short] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(4024),
    [anon_sym_register] = ACTIONS(4024),
    [anon_sym_inline] = ACTIONS(4024),
    [anon_sym___inline] = ACTIONS(4024),
    [anon_sym___inline__] = ACTIONS(4024),
    [anon_sym___forceinline] = ACTIONS(4024),
    [anon_sym_thread_local] = ACTIONS(4024),
    [anon_sym___thread] = ACTIONS(4024),
    [anon_sym_const] = ACTIONS(4024),
    [anon_sym_constexpr] = ACTIONS(4024),
    [anon_sym_volatile] = ACTIONS(4024),
    [anon_sym_restrict] = ACTIONS(4024),
    [anon_sym___restrict__] = ACTIONS(4024),
    [anon_sym__Atomic] = ACTIONS(4024),
    [anon_sym__Noreturn] = ACTIONS(4024),
    [anon_sym_noreturn] = ACTIONS(4024),
    [anon_sym__Nonnull] = ACTIONS(4024),
    [anon_sym_mutable] = ACTIONS(4024),
    [anon_sym_constinit] = ACTIONS(4024),
    [anon_sym_consteval] = ACTIONS(4024),
    [anon_sym_alignas] = ACTIONS(4024),
    [anon_sym__Alignas] = ACTIONS(4024),
    [sym_primitive_type] = ACTIONS(4031),
    [anon_sym_enum] = ACTIONS(4024),
    [anon_sym_class] = ACTIONS(4024),
    [anon_sym_struct] = ACTIONS(4024),
    [anon_sym_union] = ACTIONS(4024),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4024),
    [anon_sym_let] = ACTIONS(4024),
    [anon_sym_This] = ACTIONS(4024),
    [anon_sym_decltype] = ACTIONS(4034),
    [anon_sym_typename] = ACTIONS(4024),
    [anon_sym_template] = ACTIONS(4037),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(4024),
    [anon_sym_shared] = ACTIONS(4024),
    [anon_sym_groupshared] = ACTIONS(4024),
    [anon_sym_uniform] = ACTIONS(4024),
    [anon_sym_row_major] = ACTIONS(4024),
    [anon_sym_column_major] = ACTIONS(4024),
    [anon_sym_globallycoherent] = ACTIONS(4024),
    [anon_sym_centroid] = ACTIONS(4024),
    [anon_sym_noperspective] = ACTIONS(4024),
    [anon_sym_nointerpolation] = ACTIONS(4024),
    [anon_sym_sample] = ACTIONS(4024),
    [anon_sym_linear] = ACTIONS(4024),
    [anon_sym_snorm] = ACTIONS(4024),
    [anon_sym_unorm] = ACTIONS(4024),
    [anon_sym_point] = ACTIONS(4024),
    [anon_sym_line] = ACTIONS(4024),
    [anon_sym_triangleadj] = ACTIONS(4024),
    [anon_sym_lineadj] = ACTIONS(4024),
    [anon_sym_triangle] = ACTIONS(4024),
    [anon_sym_interface] = ACTIONS(4024),
    [anon_sym_extension] = ACTIONS(4024),
  },
  [649] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(284),
    [ts_builtin_sym_end] = ACTIONS(3997),
    [sym_identifier] = ACTIONS(3995),
    [aux_sym_preproc_include_token1] = ACTIONS(3995),
    [aux_sym_preproc_def_token1] = ACTIONS(3995),
    [aux_sym_preproc_if_token1] = ACTIONS(3995),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3995),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3995),
    [sym_preproc_directive] = ACTIONS(3995),
    [anon_sym_LPAREN2] = ACTIONS(3997),
    [anon_sym_BANG] = ACTIONS(3997),
    [anon_sym_TILDE] = ACTIONS(3997),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_AMP] = ACTIONS(3995),
    [anon_sym_SEMI] = ACTIONS(3997),
    [anon_sym___extension__] = ACTIONS(3995),
    [anon_sym_typedef] = ACTIONS(3995),
    [anon_sym_in] = ACTIONS(3995),
    [anon_sym_out] = ACTIONS(3995),
    [anon_sym_inout] = ACTIONS(3995),
    [anon_sym_virtual] = ACTIONS(3995),
    [anon_sym_extern] = ACTIONS(3995),
    [anon_sym___attribute__] = ACTIONS(3995),
    [anon_sym___attribute] = ACTIONS(3995),
    [anon_sym_using] = ACTIONS(3995),
    [anon_sym_COLON_COLON] = ACTIONS(3997),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3997),
    [anon_sym___declspec] = ACTIONS(3995),
    [anon_sym___based] = ACTIONS(3995),
    [anon_sym___cdecl] = ACTIONS(3995),
    [anon_sym___clrcall] = ACTIONS(3995),
    [anon_sym___stdcall] = ACTIONS(3995),
    [anon_sym___fastcall] = ACTIONS(3995),
    [anon_sym___thiscall] = ACTIONS(3995),
    [anon_sym___vectorcall] = ACTIONS(3995),
    [anon_sym_LBRACE] = ACTIONS(3997),
    [anon_sym_signed] = ACTIONS(4040),
    [anon_sym_unsigned] = ACTIONS(4040),
    [anon_sym_long] = ACTIONS(4040),
    [anon_sym_short] = ACTIONS(4040),
    [anon_sym_LBRACK] = ACTIONS(3995),
    [anon_sym_static] = ACTIONS(3995),
    [anon_sym_register] = ACTIONS(3995),
    [anon_sym_inline] = ACTIONS(3995),
    [anon_sym___inline] = ACTIONS(3995),
    [anon_sym___inline__] = ACTIONS(3995),
    [anon_sym___forceinline] = ACTIONS(3995),
    [anon_sym_thread_local] = ACTIONS(3995),
    [anon_sym___thread] = ACTIONS(3995),
    [anon_sym_const] = ACTIONS(3995),
    [anon_sym_constexpr] = ACTIONS(3995),
    [anon_sym_volatile] = ACTIONS(3995),
    [anon_sym_restrict] = ACTIONS(3995),
    [anon_sym___restrict__] = ACTIONS(3995),
    [anon_sym__Atomic] = ACTIONS(3995),
    [anon_sym__Noreturn] = ACTIONS(3995),
    [anon_sym_noreturn] = ACTIONS(3995),
    [anon_sym__Nonnull] = ACTIONS(3995),
    [anon_sym_mutable] = ACTIONS(3995),
    [anon_sym_constinit] = ACTIONS(3995),
    [anon_sym_consteval] = ACTIONS(3995),
    [anon_sym_alignas] = ACTIONS(3995),
    [anon_sym__Alignas] = ACTIONS(3995),
    [sym_primitive_type] = ACTIONS(3995),
    [anon_sym_enum] = ACTIONS(3995),
    [anon_sym_class] = ACTIONS(3995),
    [anon_sym_struct] = ACTIONS(3995),
    [anon_sym_union] = ACTIONS(3995),
    [anon_sym_if] = ACTIONS(3995),
    [anon_sym_switch] = ACTIONS(3995),
    [anon_sym_case] = ACTIONS(3995),
    [anon_sym_default] = ACTIONS(3995),
    [anon_sym_while] = ACTIONS(3995),
    [anon_sym_do] = ACTIONS(3995),
    [anon_sym_for] = ACTIONS(3995),
    [anon_sym_return] = ACTIONS(3995),
    [anon_sym_break] = ACTIONS(3995),
    [anon_sym_continue] = ACTIONS(3995),
    [anon_sym_goto] = ACTIONS(3995),
    [anon_sym_not] = ACTIONS(3995),
    [anon_sym_compl] = ACTIONS(3995),
    [anon_sym_DASH_DASH] = ACTIONS(3997),
    [anon_sym_PLUS_PLUS] = ACTIONS(3997),
    [anon_sym_sizeof] = ACTIONS(3995),
    [anon_sym___alignof__] = ACTIONS(3995),
    [anon_sym___alignof] = ACTIONS(3995),
    [anon_sym__alignof] = ACTIONS(3995),
    [anon_sym_alignof] = ACTIONS(3995),
    [anon_sym__Alignof] = ACTIONS(3995),
    [anon_sym_offsetof] = ACTIONS(3995),
    [anon_sym__Generic] = ACTIONS(3995),
    [anon_sym_asm] = ACTIONS(3995),
    [anon_sym___asm__] = ACTIONS(3995),
    [anon_sym___asm] = ACTIONS(3995),
    [anon_sym_DOT] = ACTIONS(3995),
    [sym_number_literal] = ACTIONS(3997),
    [anon_sym_L_SQUOTE] = ACTIONS(3997),
    [anon_sym_u_SQUOTE] = ACTIONS(3997),
    [anon_sym_U_SQUOTE] = ACTIONS(3997),
    [anon_sym_u8_SQUOTE] = ACTIONS(3997),
    [anon_sym_SQUOTE] = ACTIONS(3997),
    [anon_sym_L_DQUOTE] = ACTIONS(3997),
    [anon_sym_u_DQUOTE] = ACTIONS(3997),
    [anon_sym_U_DQUOTE] = ACTIONS(3997),
    [anon_sym_u8_DQUOTE] = ACTIONS(3997),
    [anon_sym_DQUOTE] = ACTIONS(3997),
    [sym_true] = ACTIONS(3995),
    [sym_false] = ACTIONS(3995),
    [anon_sym_NULL] = ACTIONS(3995),
    [anon_sym_nullptr] = ACTIONS(3995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3995),
    [anon_sym_let] = ACTIONS(3995),
    [anon_sym_This] = ACTIONS(3995),
    [anon_sym_decltype] = ACTIONS(3995),
    [anon_sym_explicit] = ACTIONS(3995),
    [anon_sym_typename] = ACTIONS(3995),
    [anon_sym_export] = ACTIONS(3995),
    [anon_sym_module] = ACTIONS(3995),
    [anon_sym_import] = ACTIONS(3995),
    [anon_sym_template] = ACTIONS(3995),
    [anon_sym_operator] = ACTIONS(3995),
    [anon_sym_try] = ACTIONS(3995),
    [anon_sym_delete] = ACTIONS(3995),
    [anon_sym_throw] = ACTIONS(3995),
    [anon_sym_namespace] = ACTIONS(3995),
    [anon_sym_static_assert] = ACTIONS(3995),
    [anon_sym_concept] = ACTIONS(3995),
    [anon_sym_co_return] = ACTIONS(3995),
    [anon_sym_co_yield] = ACTIONS(3995),
    [anon_sym_R_DQUOTE] = ACTIONS(3997),
    [anon_sym_LR_DQUOTE] = ACTIONS(3997),
    [anon_sym_uR_DQUOTE] = ACTIONS(3997),
    [anon_sym_UR_DQUOTE] = ACTIONS(3997),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3997),
    [anon_sym_co_await] = ACTIONS(3995),
    [anon_sym_new] = ACTIONS(3995),
    [anon_sym_requires] = ACTIONS(3995),
    [sym_this] = ACTIONS(3995),
    [anon_sym_precise] = ACTIONS(3995),
    [anon_sym_shared] = ACTIONS(3995),
    [anon_sym_groupshared] = ACTIONS(3995),
    [anon_sym_uniform] = ACTIONS(3995),
    [anon_sym_row_major] = ACTIONS(3995),
    [anon_sym_column_major] = ACTIONS(3995),
    [anon_sym_globallycoherent] = ACTIONS(3995),
    [anon_sym_centroid] = ACTIONS(3995),
    [anon_sym_noperspective] = ACTIONS(3995),
    [anon_sym_nointerpolation] = ACTIONS(3995),
    [anon_sym_sample] = ACTIONS(3995),
    [anon_sym_linear] = ACTIONS(3995),
    [anon_sym_snorm] = ACTIONS(3995),
    [anon_sym_unorm] = ACTIONS(3995),
    [anon_sym_point] = ACTIONS(3995),
    [anon_sym_line] = ACTIONS(3995),
    [anon_sym_triangleadj] = ACTIONS(3995),
    [anon_sym_lineadj] = ACTIONS(3995),
    [anon_sym_triangle] = ACTIONS(3995),
    [anon_sym_interface] = ACTIONS(3995),
    [anon_sym_extension] = ACTIONS(3995),
    [anon_sym___exported] = ACTIONS(3995),
  },
  [650] = {
    [sym_attribute_specifier] = STATE(310),
    [ts_builtin_sym_end] = ACTIONS(4043),
    [sym_identifier] = ACTIONS(4045),
    [aux_sym_preproc_include_token1] = ACTIONS(4045),
    [aux_sym_preproc_def_token1] = ACTIONS(4045),
    [aux_sym_preproc_if_token1] = ACTIONS(4045),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4045),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4045),
    [sym_preproc_directive] = ACTIONS(4045),
    [anon_sym_LPAREN2] = ACTIONS(4043),
    [anon_sym_BANG] = ACTIONS(4043),
    [anon_sym_TILDE] = ACTIONS(4043),
    [anon_sym_DASH] = ACTIONS(4045),
    [anon_sym_PLUS] = ACTIONS(4045),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_AMP_AMP] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_SEMI] = ACTIONS(4043),
    [anon_sym___extension__] = ACTIONS(4045),
    [anon_sym_typedef] = ACTIONS(4045),
    [anon_sym_in] = ACTIONS(4045),
    [anon_sym_out] = ACTIONS(4045),
    [anon_sym_inout] = ACTIONS(4045),
    [anon_sym_virtual] = ACTIONS(4045),
    [anon_sym_extern] = ACTIONS(4045),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(4045),
    [anon_sym_COLON_COLON] = ACTIONS(4043),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4043),
    [anon_sym___declspec] = ACTIONS(4045),
    [anon_sym___based] = ACTIONS(4045),
    [anon_sym___cdecl] = ACTIONS(4045),
    [anon_sym___clrcall] = ACTIONS(4045),
    [anon_sym___stdcall] = ACTIONS(4045),
    [anon_sym___fastcall] = ACTIONS(4045),
    [anon_sym___thiscall] = ACTIONS(4045),
    [anon_sym___vectorcall] = ACTIONS(4045),
    [anon_sym_LBRACE] = ACTIONS(4043),
    [anon_sym_signed] = ACTIONS(4045),
    [anon_sym_unsigned] = ACTIONS(4045),
    [anon_sym_long] = ACTIONS(4045),
    [anon_sym_short] = ACTIONS(4045),
    [anon_sym_LBRACK] = ACTIONS(4045),
    [anon_sym_static] = ACTIONS(4045),
    [anon_sym_register] = ACTIONS(4045),
    [anon_sym_inline] = ACTIONS(4045),
    [anon_sym___inline] = ACTIONS(4045),
    [anon_sym___inline__] = ACTIONS(4045),
    [anon_sym___forceinline] = ACTIONS(4045),
    [anon_sym_thread_local] = ACTIONS(4045),
    [anon_sym___thread] = ACTIONS(4045),
    [anon_sym_const] = ACTIONS(4045),
    [anon_sym_constexpr] = ACTIONS(4045),
    [anon_sym_volatile] = ACTIONS(4045),
    [anon_sym_restrict] = ACTIONS(4045),
    [anon_sym___restrict__] = ACTIONS(4045),
    [anon_sym__Atomic] = ACTIONS(4045),
    [anon_sym__Noreturn] = ACTIONS(4045),
    [anon_sym_noreturn] = ACTIONS(4045),
    [anon_sym__Nonnull] = ACTIONS(4045),
    [anon_sym_mutable] = ACTIONS(4045),
    [anon_sym_constinit] = ACTIONS(4045),
    [anon_sym_consteval] = ACTIONS(4045),
    [anon_sym_alignas] = ACTIONS(4045),
    [anon_sym__Alignas] = ACTIONS(4045),
    [sym_primitive_type] = ACTIONS(4045),
    [anon_sym_enum] = ACTIONS(4045),
    [anon_sym_class] = ACTIONS(4045),
    [anon_sym_struct] = ACTIONS(4045),
    [anon_sym_union] = ACTIONS(4045),
    [anon_sym_if] = ACTIONS(4045),
    [anon_sym_switch] = ACTIONS(4045),
    [anon_sym_case] = ACTIONS(4045),
    [anon_sym_default] = ACTIONS(4045),
    [anon_sym_while] = ACTIONS(4045),
    [anon_sym_do] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4045),
    [anon_sym_return] = ACTIONS(4045),
    [anon_sym_break] = ACTIONS(4045),
    [anon_sym_continue] = ACTIONS(4045),
    [anon_sym_goto] = ACTIONS(4045),
    [anon_sym_not] = ACTIONS(4045),
    [anon_sym_compl] = ACTIONS(4045),
    [anon_sym_DASH_DASH] = ACTIONS(4043),
    [anon_sym_PLUS_PLUS] = ACTIONS(4043),
    [anon_sym_sizeof] = ACTIONS(4045),
    [anon_sym___alignof__] = ACTIONS(4045),
    [anon_sym___alignof] = ACTIONS(4045),
    [anon_sym__alignof] = ACTIONS(4045),
    [anon_sym_alignof] = ACTIONS(4045),
    [anon_sym__Alignof] = ACTIONS(4045),
    [anon_sym_offsetof] = ACTIONS(4045),
    [anon_sym__Generic] = ACTIONS(4045),
    [anon_sym_asm] = ACTIONS(4045),
    [anon_sym___asm__] = ACTIONS(4045),
    [anon_sym___asm] = ACTIONS(4045),
    [anon_sym_DOT] = ACTIONS(4045),
    [sym_number_literal] = ACTIONS(4043),
    [anon_sym_L_SQUOTE] = ACTIONS(4043),
    [anon_sym_u_SQUOTE] = ACTIONS(4043),
    [anon_sym_U_SQUOTE] = ACTIONS(4043),
    [anon_sym_u8_SQUOTE] = ACTIONS(4043),
    [anon_sym_SQUOTE] = ACTIONS(4043),
    [anon_sym_L_DQUOTE] = ACTIONS(4043),
    [anon_sym_u_DQUOTE] = ACTIONS(4043),
    [anon_sym_U_DQUOTE] = ACTIONS(4043),
    [anon_sym_u8_DQUOTE] = ACTIONS(4043),
    [anon_sym_DQUOTE] = ACTIONS(4043),
    [sym_true] = ACTIONS(4045),
    [sym_false] = ACTIONS(4045),
    [anon_sym_NULL] = ACTIONS(4045),
    [anon_sym_nullptr] = ACTIONS(4045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4045),
    [anon_sym_let] = ACTIONS(4045),
    [anon_sym_This] = ACTIONS(4045),
    [anon_sym_decltype] = ACTIONS(4045),
    [anon_sym_explicit] = ACTIONS(4045),
    [anon_sym_typename] = ACTIONS(4045),
    [anon_sym_export] = ACTIONS(4045),
    [anon_sym_module] = ACTIONS(4045),
    [anon_sym_import] = ACTIONS(4045),
    [anon_sym_template] = ACTIONS(4045),
    [anon_sym_operator] = ACTIONS(4045),
    [anon_sym_try] = ACTIONS(4045),
    [anon_sym_delete] = ACTIONS(4045),
    [anon_sym_throw] = ACTIONS(4045),
    [anon_sym_namespace] = ACTIONS(4045),
    [anon_sym_static_assert] = ACTIONS(4045),
    [anon_sym_concept] = ACTIONS(4045),
    [anon_sym_co_return] = ACTIONS(4045),
    [anon_sym_co_yield] = ACTIONS(4045),
    [anon_sym_R_DQUOTE] = ACTIONS(4043),
    [anon_sym_LR_DQUOTE] = ACTIONS(4043),
    [anon_sym_uR_DQUOTE] = ACTIONS(4043),
    [anon_sym_UR_DQUOTE] = ACTIONS(4043),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4043),
    [anon_sym_co_await] = ACTIONS(4045),
    [anon_sym_new] = ACTIONS(4045),
    [anon_sym_requires] = ACTIONS(4045),
    [sym_this] = ACTIONS(4045),
    [anon_sym_precise] = ACTIONS(4045),
    [anon_sym_shared] = ACTIONS(4045),
    [anon_sym_groupshared] = ACTIONS(4045),
    [anon_sym_uniform] = ACTIONS(4045),
    [anon_sym_row_major] = ACTIONS(4045),
    [anon_sym_column_major] = ACTIONS(4045),
    [anon_sym_globallycoherent] = ACTIONS(4045),
    [anon_sym_centroid] = ACTIONS(4045),
    [anon_sym_noperspective] = ACTIONS(4045),
    [anon_sym_nointerpolation] = ACTIONS(4045),
    [anon_sym_sample] = ACTIONS(4045),
    [anon_sym_linear] = ACTIONS(4045),
    [anon_sym_snorm] = ACTIONS(4045),
    [anon_sym_unorm] = ACTIONS(4045),
    [anon_sym_point] = ACTIONS(4045),
    [anon_sym_line] = ACTIONS(4045),
    [anon_sym_triangleadj] = ACTIONS(4045),
    [anon_sym_lineadj] = ACTIONS(4045),
    [anon_sym_triangle] = ACTIONS(4045),
    [anon_sym_interface] = ACTIONS(4045),
    [anon_sym_extension] = ACTIONS(4045),
    [anon_sym___exported] = ACTIONS(4045),
  },
  [651] = {
    [sym_identifier] = ACTIONS(2414),
    [aux_sym_preproc_include_token1] = ACTIONS(2414),
    [aux_sym_preproc_def_token1] = ACTIONS(2414),
    [aux_sym_preproc_if_token1] = ACTIONS(2414),
    [aux_sym_preproc_if_token2] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2414),
    [sym_preproc_directive] = ACTIONS(2414),
    [anon_sym_LPAREN2] = ACTIONS(2412),
    [anon_sym_BANG] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym___extension__] = ACTIONS(2414),
    [anon_sym_typedef] = ACTIONS(2414),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_out] = ACTIONS(2414),
    [anon_sym_inout] = ACTIONS(2414),
    [anon_sym_virtual] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym___attribute__] = ACTIONS(2414),
    [anon_sym___attribute] = ACTIONS(2414),
    [anon_sym_using] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2412),
    [anon_sym___declspec] = ACTIONS(2414),
    [anon_sym___based] = ACTIONS(2414),
    [anon_sym___cdecl] = ACTIONS(2414),
    [anon_sym___clrcall] = ACTIONS(2414),
    [anon_sym___stdcall] = ACTIONS(2414),
    [anon_sym___fastcall] = ACTIONS(2414),
    [anon_sym___thiscall] = ACTIONS(2414),
    [anon_sym___vectorcall] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(2412),
    [anon_sym_signed] = ACTIONS(2414),
    [anon_sym_unsigned] = ACTIONS(2414),
    [anon_sym_long] = ACTIONS(2414),
    [anon_sym_short] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_register] = ACTIONS(2414),
    [anon_sym_inline] = ACTIONS(2414),
    [anon_sym___inline] = ACTIONS(2414),
    [anon_sym___inline__] = ACTIONS(2414),
    [anon_sym___forceinline] = ACTIONS(2414),
    [anon_sym_thread_local] = ACTIONS(2414),
    [anon_sym___thread] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_constexpr] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym_restrict] = ACTIONS(2414),
    [anon_sym___restrict__] = ACTIONS(2414),
    [anon_sym__Atomic] = ACTIONS(2414),
    [anon_sym__Noreturn] = ACTIONS(2414),
    [anon_sym_noreturn] = ACTIONS(2414),
    [anon_sym__Nonnull] = ACTIONS(2414),
    [anon_sym_mutable] = ACTIONS(2414),
    [anon_sym_constinit] = ACTIONS(2414),
    [anon_sym_consteval] = ACTIONS(2414),
    [anon_sym_alignas] = ACTIONS(2414),
    [anon_sym__Alignas] = ACTIONS(2414),
    [sym_primitive_type] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [anon_sym_if] = ACTIONS(2414),
    [anon_sym_else] = ACTIONS(2414),
    [anon_sym_switch] = ACTIONS(2414),
    [anon_sym_case] = ACTIONS(2414),
    [anon_sym_default] = ACTIONS(2414),
    [anon_sym_while] = ACTIONS(2414),
    [anon_sym_do] = ACTIONS(2414),
    [anon_sym_for] = ACTIONS(2414),
    [anon_sym_return] = ACTIONS(2414),
    [anon_sym_break] = ACTIONS(2414),
    [anon_sym_continue] = ACTIONS(2414),
    [anon_sym_goto] = ACTIONS(2414),
    [anon_sym___try] = ACTIONS(2414),
    [anon_sym___leave] = ACTIONS(2414),
    [anon_sym_not] = ACTIONS(2414),
    [anon_sym_compl] = ACTIONS(2414),
    [anon_sym_DASH_DASH] = ACTIONS(2412),
    [anon_sym_PLUS_PLUS] = ACTIONS(2412),
    [anon_sym_sizeof] = ACTIONS(2414),
    [anon_sym___alignof__] = ACTIONS(2414),
    [anon_sym___alignof] = ACTIONS(2414),
    [anon_sym__alignof] = ACTIONS(2414),
    [anon_sym_alignof] = ACTIONS(2414),
    [anon_sym__Alignof] = ACTIONS(2414),
    [anon_sym_offsetof] = ACTIONS(2414),
    [anon_sym__Generic] = ACTIONS(2414),
    [anon_sym_asm] = ACTIONS(2414),
    [anon_sym___asm__] = ACTIONS(2414),
    [anon_sym___asm] = ACTIONS(2414),
    [sym_number_literal] = ACTIONS(2412),
    [anon_sym_L_SQUOTE] = ACTIONS(2412),
    [anon_sym_u_SQUOTE] = ACTIONS(2412),
    [anon_sym_U_SQUOTE] = ACTIONS(2412),
    [anon_sym_u8_SQUOTE] = ACTIONS(2412),
    [anon_sym_SQUOTE] = ACTIONS(2412),
    [anon_sym_L_DQUOTE] = ACTIONS(2412),
    [anon_sym_u_DQUOTE] = ACTIONS(2412),
    [anon_sym_U_DQUOTE] = ACTIONS(2412),
    [anon_sym_u8_DQUOTE] = ACTIONS(2412),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [sym_true] = ACTIONS(2414),
    [sym_false] = ACTIONS(2414),
    [anon_sym_NULL] = ACTIONS(2414),
    [anon_sym_nullptr] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2414),
    [anon_sym_let] = ACTIONS(2414),
    [anon_sym_This] = ACTIONS(2414),
    [anon_sym_decltype] = ACTIONS(2414),
    [anon_sym_explicit] = ACTIONS(2414),
    [anon_sym_typename] = ACTIONS(2414),
    [anon_sym_template] = ACTIONS(2414),
    [anon_sym_operator] = ACTIONS(2414),
    [anon_sym_try] = ACTIONS(2414),
    [anon_sym_delete] = ACTIONS(2414),
    [anon_sym_throw] = ACTIONS(2414),
    [anon_sym_namespace] = ACTIONS(2414),
    [anon_sym_static_assert] = ACTIONS(2414),
    [anon_sym_concept] = ACTIONS(2414),
    [anon_sym_co_return] = ACTIONS(2414),
    [anon_sym_co_yield] = ACTIONS(2414),
    [anon_sym_catch] = ACTIONS(2414),
    [anon_sym_R_DQUOTE] = ACTIONS(2412),
    [anon_sym_LR_DQUOTE] = ACTIONS(2412),
    [anon_sym_uR_DQUOTE] = ACTIONS(2412),
    [anon_sym_UR_DQUOTE] = ACTIONS(2412),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2412),
    [anon_sym_co_await] = ACTIONS(2414),
    [anon_sym_new] = ACTIONS(2414),
    [anon_sym_requires] = ACTIONS(2414),
    [sym_this] = ACTIONS(2414),
    [anon_sym_discard] = ACTIONS(2414),
    [anon_sym_precise] = ACTIONS(2414),
    [anon_sym_shared] = ACTIONS(2414),
    [anon_sym_groupshared] = ACTIONS(2414),
    [anon_sym_uniform] = ACTIONS(2414),
    [anon_sym_row_major] = ACTIONS(2414),
    [anon_sym_column_major] = ACTIONS(2414),
    [anon_sym_globallycoherent] = ACTIONS(2414),
    [anon_sym_centroid] = ACTIONS(2414),
    [anon_sym_noperspective] = ACTIONS(2414),
    [anon_sym_nointerpolation] = ACTIONS(2414),
    [anon_sym_sample] = ACTIONS(2414),
    [anon_sym_linear] = ACTIONS(2414),
    [anon_sym_snorm] = ACTIONS(2414),
    [anon_sym_unorm] = ACTIONS(2414),
    [anon_sym_point] = ACTIONS(2414),
    [anon_sym_line] = ACTIONS(2414),
    [anon_sym_triangleadj] = ACTIONS(2414),
    [anon_sym_lineadj] = ACTIONS(2414),
    [anon_sym_triangle] = ACTIONS(2414),
    [anon_sym_cbuffer] = ACTIONS(2414),
    [anon_sym_interface] = ACTIONS(2414),
    [anon_sym_extension] = ACTIONS(2414),
  },
  [652] = {
    [sym_attribute_specifier] = STATE(311),
    [ts_builtin_sym_end] = ACTIONS(4047),
    [sym_identifier] = ACTIONS(4049),
    [aux_sym_preproc_include_token1] = ACTIONS(4049),
    [aux_sym_preproc_def_token1] = ACTIONS(4049),
    [aux_sym_preproc_if_token1] = ACTIONS(4049),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4049),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4049),
    [sym_preproc_directive] = ACTIONS(4049),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(4047),
    [anon_sym_TILDE] = ACTIONS(4047),
    [anon_sym_DASH] = ACTIONS(4049),
    [anon_sym_PLUS] = ACTIONS(4049),
    [anon_sym_STAR] = ACTIONS(4047),
    [anon_sym_AMP_AMP] = ACTIONS(4047),
    [anon_sym_AMP] = ACTIONS(4049),
    [anon_sym_SEMI] = ACTIONS(4047),
    [anon_sym___extension__] = ACTIONS(4049),
    [anon_sym_typedef] = ACTIONS(4049),
    [anon_sym_in] = ACTIONS(4049),
    [anon_sym_out] = ACTIONS(4049),
    [anon_sym_inout] = ACTIONS(4049),
    [anon_sym_virtual] = ACTIONS(4049),
    [anon_sym_extern] = ACTIONS(4049),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(4049),
    [anon_sym_COLON_COLON] = ACTIONS(4047),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4047),
    [anon_sym___declspec] = ACTIONS(4049),
    [anon_sym___based] = ACTIONS(4049),
    [anon_sym___cdecl] = ACTIONS(4049),
    [anon_sym___clrcall] = ACTIONS(4049),
    [anon_sym___stdcall] = ACTIONS(4049),
    [anon_sym___fastcall] = ACTIONS(4049),
    [anon_sym___thiscall] = ACTIONS(4049),
    [anon_sym___vectorcall] = ACTIONS(4049),
    [anon_sym_LBRACE] = ACTIONS(4047),
    [anon_sym_signed] = ACTIONS(4049),
    [anon_sym_unsigned] = ACTIONS(4049),
    [anon_sym_long] = ACTIONS(4049),
    [anon_sym_short] = ACTIONS(4049),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(4049),
    [anon_sym_register] = ACTIONS(4049),
    [anon_sym_inline] = ACTIONS(4049),
    [anon_sym___inline] = ACTIONS(4049),
    [anon_sym___inline__] = ACTIONS(4049),
    [anon_sym___forceinline] = ACTIONS(4049),
    [anon_sym_thread_local] = ACTIONS(4049),
    [anon_sym___thread] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(4049),
    [anon_sym_constexpr] = ACTIONS(4049),
    [anon_sym_volatile] = ACTIONS(4049),
    [anon_sym_restrict] = ACTIONS(4049),
    [anon_sym___restrict__] = ACTIONS(4049),
    [anon_sym__Atomic] = ACTIONS(4049),
    [anon_sym__Noreturn] = ACTIONS(4049),
    [anon_sym_noreturn] = ACTIONS(4049),
    [anon_sym__Nonnull] = ACTIONS(4049),
    [anon_sym_mutable] = ACTIONS(4049),
    [anon_sym_constinit] = ACTIONS(4049),
    [anon_sym_consteval] = ACTIONS(4049),
    [anon_sym_alignas] = ACTIONS(4049),
    [anon_sym__Alignas] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4049),
    [anon_sym_enum] = ACTIONS(4049),
    [anon_sym_class] = ACTIONS(4049),
    [anon_sym_struct] = ACTIONS(4049),
    [anon_sym_union] = ACTIONS(4049),
    [anon_sym_if] = ACTIONS(4049),
    [anon_sym_switch] = ACTIONS(4049),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_default] = ACTIONS(4049),
    [anon_sym_while] = ACTIONS(4049),
    [anon_sym_do] = ACTIONS(4049),
    [anon_sym_for] = ACTIONS(4049),
    [anon_sym_return] = ACTIONS(4049),
    [anon_sym_break] = ACTIONS(4049),
    [anon_sym_continue] = ACTIONS(4049),
    [anon_sym_goto] = ACTIONS(4049),
    [anon_sym_not] = ACTIONS(4049),
    [anon_sym_compl] = ACTIONS(4049),
    [anon_sym_DASH_DASH] = ACTIONS(4047),
    [anon_sym_PLUS_PLUS] = ACTIONS(4047),
    [anon_sym_sizeof] = ACTIONS(4049),
    [anon_sym___alignof__] = ACTIONS(4049),
    [anon_sym___alignof] = ACTIONS(4049),
    [anon_sym__alignof] = ACTIONS(4049),
    [anon_sym_alignof] = ACTIONS(4049),
    [anon_sym__Alignof] = ACTIONS(4049),
    [anon_sym_offsetof] = ACTIONS(4049),
    [anon_sym__Generic] = ACTIONS(4049),
    [anon_sym_asm] = ACTIONS(4049),
    [anon_sym___asm__] = ACTIONS(4049),
    [anon_sym___asm] = ACTIONS(4049),
    [anon_sym_DOT] = ACTIONS(4049),
    [sym_number_literal] = ACTIONS(4047),
    [anon_sym_L_SQUOTE] = ACTIONS(4047),
    [anon_sym_u_SQUOTE] = ACTIONS(4047),
    [anon_sym_U_SQUOTE] = ACTIONS(4047),
    [anon_sym_u8_SQUOTE] = ACTIONS(4047),
    [anon_sym_SQUOTE] = ACTIONS(4047),
    [anon_sym_L_DQUOTE] = ACTIONS(4047),
    [anon_sym_u_DQUOTE] = ACTIONS(4047),
    [anon_sym_U_DQUOTE] = ACTIONS(4047),
    [anon_sym_u8_DQUOTE] = ACTIONS(4047),
    [anon_sym_DQUOTE] = ACTIONS(4047),
    [sym_true] = ACTIONS(4049),
    [sym_false] = ACTIONS(4049),
    [anon_sym_NULL] = ACTIONS(4049),
    [anon_sym_nullptr] = ACTIONS(4049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4049),
    [anon_sym_let] = ACTIONS(4049),
    [anon_sym_This] = ACTIONS(4049),
    [anon_sym_decltype] = ACTIONS(4049),
    [anon_sym_explicit] = ACTIONS(4049),
    [anon_sym_typename] = ACTIONS(4049),
    [anon_sym_export] = ACTIONS(4049),
    [anon_sym_module] = ACTIONS(4049),
    [anon_sym_import] = ACTIONS(4049),
    [anon_sym_template] = ACTIONS(4049),
    [anon_sym_operator] = ACTIONS(4049),
    [anon_sym_try] = ACTIONS(4049),
    [anon_sym_delete] = ACTIONS(4049),
    [anon_sym_throw] = ACTIONS(4049),
    [anon_sym_namespace] = ACTIONS(4049),
    [anon_sym_static_assert] = ACTIONS(4049),
    [anon_sym_concept] = ACTIONS(4049),
    [anon_sym_co_return] = ACTIONS(4049),
    [anon_sym_co_yield] = ACTIONS(4049),
    [anon_sym_R_DQUOTE] = ACTIONS(4047),
    [anon_sym_LR_DQUOTE] = ACTIONS(4047),
    [anon_sym_uR_DQUOTE] = ACTIONS(4047),
    [anon_sym_UR_DQUOTE] = ACTIONS(4047),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4047),
    [anon_sym_co_await] = ACTIONS(4049),
    [anon_sym_new] = ACTIONS(4049),
    [anon_sym_requires] = ACTIONS(4049),
    [sym_this] = ACTIONS(4049),
    [anon_sym_precise] = ACTIONS(4049),
    [anon_sym_shared] = ACTIONS(4049),
    [anon_sym_groupshared] = ACTIONS(4049),
    [anon_sym_uniform] = ACTIONS(4049),
    [anon_sym_row_major] = ACTIONS(4049),
    [anon_sym_column_major] = ACTIONS(4049),
    [anon_sym_globallycoherent] = ACTIONS(4049),
    [anon_sym_centroid] = ACTIONS(4049),
    [anon_sym_noperspective] = ACTIONS(4049),
    [anon_sym_nointerpolation] = ACTIONS(4049),
    [anon_sym_sample] = ACTIONS(4049),
    [anon_sym_linear] = ACTIONS(4049),
    [anon_sym_snorm] = ACTIONS(4049),
    [anon_sym_unorm] = ACTIONS(4049),
    [anon_sym_point] = ACTIONS(4049),
    [anon_sym_line] = ACTIONS(4049),
    [anon_sym_triangleadj] = ACTIONS(4049),
    [anon_sym_lineadj] = ACTIONS(4049),
    [anon_sym_triangle] = ACTIONS(4049),
    [anon_sym_interface] = ACTIONS(4049),
    [anon_sym_extension] = ACTIONS(4049),
    [anon_sym___exported] = ACTIONS(4049),
  },
  [653] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(666),
    [ts_builtin_sym_end] = ACTIONS(4051),
    [sym_identifier] = ACTIONS(4053),
    [aux_sym_preproc_include_token1] = ACTIONS(4053),
    [aux_sym_preproc_def_token1] = ACTIONS(4053),
    [aux_sym_preproc_if_token1] = ACTIONS(4053),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4053),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4053),
    [sym_preproc_directive] = ACTIONS(4053),
    [anon_sym_LPAREN2] = ACTIONS(4051),
    [anon_sym_BANG] = ACTIONS(4051),
    [anon_sym_TILDE] = ACTIONS(4051),
    [anon_sym_DASH] = ACTIONS(4053),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_STAR] = ACTIONS(4051),
    [anon_sym_AMP_AMP] = ACTIONS(4051),
    [anon_sym_AMP] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4051),
    [anon_sym___extension__] = ACTIONS(4053),
    [anon_sym_typedef] = ACTIONS(4053),
    [anon_sym_in] = ACTIONS(4053),
    [anon_sym_out] = ACTIONS(4053),
    [anon_sym_inout] = ACTIONS(4053),
    [anon_sym_virtual] = ACTIONS(4053),
    [anon_sym_extern] = ACTIONS(4053),
    [anon_sym___attribute__] = ACTIONS(4053),
    [anon_sym___attribute] = ACTIONS(4053),
    [anon_sym_using] = ACTIONS(4053),
    [anon_sym_COLON_COLON] = ACTIONS(4051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4051),
    [anon_sym___declspec] = ACTIONS(4053),
    [anon_sym___based] = ACTIONS(4053),
    [anon_sym___cdecl] = ACTIONS(4053),
    [anon_sym___clrcall] = ACTIONS(4053),
    [anon_sym___stdcall] = ACTIONS(4053),
    [anon_sym___fastcall] = ACTIONS(4053),
    [anon_sym___thiscall] = ACTIONS(4053),
    [anon_sym___vectorcall] = ACTIONS(4053),
    [anon_sym_LBRACE] = ACTIONS(4051),
    [anon_sym_signed] = ACTIONS(4055),
    [anon_sym_unsigned] = ACTIONS(4055),
    [anon_sym_long] = ACTIONS(4055),
    [anon_sym_short] = ACTIONS(4055),
    [anon_sym_LBRACK] = ACTIONS(4053),
    [anon_sym_static] = ACTIONS(4053),
    [anon_sym_register] = ACTIONS(4053),
    [anon_sym_inline] = ACTIONS(4053),
    [anon_sym___inline] = ACTIONS(4053),
    [anon_sym___inline__] = ACTIONS(4053),
    [anon_sym___forceinline] = ACTIONS(4053),
    [anon_sym_thread_local] = ACTIONS(4053),
    [anon_sym___thread] = ACTIONS(4053),
    [anon_sym_const] = ACTIONS(4053),
    [anon_sym_constexpr] = ACTIONS(4053),
    [anon_sym_volatile] = ACTIONS(4053),
    [anon_sym_restrict] = ACTIONS(4053),
    [anon_sym___restrict__] = ACTIONS(4053),
    [anon_sym__Atomic] = ACTIONS(4053),
    [anon_sym__Noreturn] = ACTIONS(4053),
    [anon_sym_noreturn] = ACTIONS(4053),
    [anon_sym__Nonnull] = ACTIONS(4053),
    [anon_sym_mutable] = ACTIONS(4053),
    [anon_sym_constinit] = ACTIONS(4053),
    [anon_sym_consteval] = ACTIONS(4053),
    [anon_sym_alignas] = ACTIONS(4053),
    [anon_sym__Alignas] = ACTIONS(4053),
    [sym_primitive_type] = ACTIONS(4053),
    [anon_sym_enum] = ACTIONS(4053),
    [anon_sym_class] = ACTIONS(4053),
    [anon_sym_struct] = ACTIONS(4053),
    [anon_sym_union] = ACTIONS(4053),
    [anon_sym_if] = ACTIONS(4053),
    [anon_sym_switch] = ACTIONS(4053),
    [anon_sym_case] = ACTIONS(4053),
    [anon_sym_default] = ACTIONS(4053),
    [anon_sym_while] = ACTIONS(4053),
    [anon_sym_do] = ACTIONS(4053),
    [anon_sym_for] = ACTIONS(4053),
    [anon_sym_return] = ACTIONS(4053),
    [anon_sym_break] = ACTIONS(4053),
    [anon_sym_continue] = ACTIONS(4053),
    [anon_sym_goto] = ACTIONS(4053),
    [anon_sym_not] = ACTIONS(4053),
    [anon_sym_compl] = ACTIONS(4053),
    [anon_sym_DASH_DASH] = ACTIONS(4051),
    [anon_sym_PLUS_PLUS] = ACTIONS(4051),
    [anon_sym_sizeof] = ACTIONS(4053),
    [anon_sym___alignof__] = ACTIONS(4053),
    [anon_sym___alignof] = ACTIONS(4053),
    [anon_sym__alignof] = ACTIONS(4053),
    [anon_sym_alignof] = ACTIONS(4053),
    [anon_sym__Alignof] = ACTIONS(4053),
    [anon_sym_offsetof] = ACTIONS(4053),
    [anon_sym__Generic] = ACTIONS(4053),
    [anon_sym_asm] = ACTIONS(4053),
    [anon_sym___asm__] = ACTIONS(4053),
    [anon_sym___asm] = ACTIONS(4053),
    [anon_sym_DOT] = ACTIONS(4053),
    [sym_number_literal] = ACTIONS(4051),
    [anon_sym_L_SQUOTE] = ACTIONS(4051),
    [anon_sym_u_SQUOTE] = ACTIONS(4051),
    [anon_sym_U_SQUOTE] = ACTIONS(4051),
    [anon_sym_u8_SQUOTE] = ACTIONS(4051),
    [anon_sym_SQUOTE] = ACTIONS(4051),
    [anon_sym_L_DQUOTE] = ACTIONS(4051),
    [anon_sym_u_DQUOTE] = ACTIONS(4051),
    [anon_sym_U_DQUOTE] = ACTIONS(4051),
    [anon_sym_u8_DQUOTE] = ACTIONS(4051),
    [anon_sym_DQUOTE] = ACTIONS(4051),
    [sym_true] = ACTIONS(4053),
    [sym_false] = ACTIONS(4053),
    [anon_sym_NULL] = ACTIONS(4053),
    [anon_sym_nullptr] = ACTIONS(4053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4053),
    [anon_sym_let] = ACTIONS(4053),
    [anon_sym_This] = ACTIONS(4053),
    [anon_sym_decltype] = ACTIONS(4053),
    [anon_sym_explicit] = ACTIONS(4053),
    [anon_sym_typename] = ACTIONS(4053),
    [anon_sym_export] = ACTIONS(4053),
    [anon_sym_module] = ACTIONS(4053),
    [anon_sym_import] = ACTIONS(4053),
    [anon_sym_template] = ACTIONS(4053),
    [anon_sym_operator] = ACTIONS(4053),
    [anon_sym_try] = ACTIONS(4053),
    [anon_sym_delete] = ACTIONS(4053),
    [anon_sym_throw] = ACTIONS(4053),
    [anon_sym_namespace] = ACTIONS(4053),
    [anon_sym_static_assert] = ACTIONS(4053),
    [anon_sym_concept] = ACTIONS(4053),
    [anon_sym_co_return] = ACTIONS(4053),
    [anon_sym_co_yield] = ACTIONS(4053),
    [anon_sym_R_DQUOTE] = ACTIONS(4051),
    [anon_sym_LR_DQUOTE] = ACTIONS(4051),
    [anon_sym_uR_DQUOTE] = ACTIONS(4051),
    [anon_sym_UR_DQUOTE] = ACTIONS(4051),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4051),
    [anon_sym_co_await] = ACTIONS(4053),
    [anon_sym_new] = ACTIONS(4053),
    [anon_sym_requires] = ACTIONS(4053),
    [sym_this] = ACTIONS(4053),
    [anon_sym_precise] = ACTIONS(4053),
    [anon_sym_shared] = ACTIONS(4053),
    [anon_sym_groupshared] = ACTIONS(4053),
    [anon_sym_uniform] = ACTIONS(4053),
    [anon_sym_row_major] = ACTIONS(4053),
    [anon_sym_column_major] = ACTIONS(4053),
    [anon_sym_globallycoherent] = ACTIONS(4053),
    [anon_sym_centroid] = ACTIONS(4053),
    [anon_sym_noperspective] = ACTIONS(4053),
    [anon_sym_nointerpolation] = ACTIONS(4053),
    [anon_sym_sample] = ACTIONS(4053),
    [anon_sym_linear] = ACTIONS(4053),
    [anon_sym_snorm] = ACTIONS(4053),
    [anon_sym_unorm] = ACTIONS(4053),
    [anon_sym_point] = ACTIONS(4053),
    [anon_sym_line] = ACTIONS(4053),
    [anon_sym_triangleadj] = ACTIONS(4053),
    [anon_sym_lineadj] = ACTIONS(4053),
    [anon_sym_triangle] = ACTIONS(4053),
    [anon_sym_interface] = ACTIONS(4053),
    [anon_sym_extension] = ACTIONS(4053),
    [anon_sym___exported] = ACTIONS(4053),
  },
  [654] = {
    [sym_attribute_specifier] = STATE(307),
    [ts_builtin_sym_end] = ACTIONS(4058),
    [sym_identifier] = ACTIONS(4060),
    [aux_sym_preproc_include_token1] = ACTIONS(4060),
    [aux_sym_preproc_def_token1] = ACTIONS(4060),
    [aux_sym_preproc_if_token1] = ACTIONS(4060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4060),
    [sym_preproc_directive] = ACTIONS(4060),
    [anon_sym_LPAREN2] = ACTIONS(4058),
    [anon_sym_BANG] = ACTIONS(4058),
    [anon_sym_TILDE] = ACTIONS(4058),
    [anon_sym_DASH] = ACTIONS(4060),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_STAR] = ACTIONS(4058),
    [anon_sym_AMP_AMP] = ACTIONS(4058),
    [anon_sym_AMP] = ACTIONS(4060),
    [anon_sym_SEMI] = ACTIONS(4058),
    [anon_sym___extension__] = ACTIONS(4060),
    [anon_sym_typedef] = ACTIONS(4060),
    [anon_sym_in] = ACTIONS(4060),
    [anon_sym_out] = ACTIONS(4060),
    [anon_sym_inout] = ACTIONS(4060),
    [anon_sym_virtual] = ACTIONS(4060),
    [anon_sym_extern] = ACTIONS(4060),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(4060),
    [anon_sym_COLON_COLON] = ACTIONS(4058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4058),
    [anon_sym___declspec] = ACTIONS(4060),
    [anon_sym___based] = ACTIONS(4060),
    [anon_sym___cdecl] = ACTIONS(4060),
    [anon_sym___clrcall] = ACTIONS(4060),
    [anon_sym___stdcall] = ACTIONS(4060),
    [anon_sym___fastcall] = ACTIONS(4060),
    [anon_sym___thiscall] = ACTIONS(4060),
    [anon_sym___vectorcall] = ACTIONS(4060),
    [anon_sym_LBRACE] = ACTIONS(4058),
    [anon_sym_signed] = ACTIONS(4060),
    [anon_sym_unsigned] = ACTIONS(4060),
    [anon_sym_long] = ACTIONS(4060),
    [anon_sym_short] = ACTIONS(4060),
    [anon_sym_LBRACK] = ACTIONS(4060),
    [anon_sym_static] = ACTIONS(4060),
    [anon_sym_register] = ACTIONS(4060),
    [anon_sym_inline] = ACTIONS(4060),
    [anon_sym___inline] = ACTIONS(4060),
    [anon_sym___inline__] = ACTIONS(4060),
    [anon_sym___forceinline] = ACTIONS(4060),
    [anon_sym_thread_local] = ACTIONS(4060),
    [anon_sym___thread] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4060),
    [anon_sym_constexpr] = ACTIONS(4060),
    [anon_sym_volatile] = ACTIONS(4060),
    [anon_sym_restrict] = ACTIONS(4060),
    [anon_sym___restrict__] = ACTIONS(4060),
    [anon_sym__Atomic] = ACTIONS(4060),
    [anon_sym__Noreturn] = ACTIONS(4060),
    [anon_sym_noreturn] = ACTIONS(4060),
    [anon_sym__Nonnull] = ACTIONS(4060),
    [anon_sym_mutable] = ACTIONS(4060),
    [anon_sym_constinit] = ACTIONS(4060),
    [anon_sym_consteval] = ACTIONS(4060),
    [anon_sym_alignas] = ACTIONS(4060),
    [anon_sym__Alignas] = ACTIONS(4060),
    [sym_primitive_type] = ACTIONS(4060),
    [anon_sym_enum] = ACTIONS(4060),
    [anon_sym_class] = ACTIONS(4060),
    [anon_sym_struct] = ACTIONS(4060),
    [anon_sym_union] = ACTIONS(4060),
    [anon_sym_if] = ACTIONS(4060),
    [anon_sym_switch] = ACTIONS(4060),
    [anon_sym_case] = ACTIONS(4060),
    [anon_sym_default] = ACTIONS(4060),
    [anon_sym_while] = ACTIONS(4060),
    [anon_sym_do] = ACTIONS(4060),
    [anon_sym_for] = ACTIONS(4060),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_break] = ACTIONS(4060),
    [anon_sym_continue] = ACTIONS(4060),
    [anon_sym_goto] = ACTIONS(4060),
    [anon_sym_not] = ACTIONS(4060),
    [anon_sym_compl] = ACTIONS(4060),
    [anon_sym_DASH_DASH] = ACTIONS(4058),
    [anon_sym_PLUS_PLUS] = ACTIONS(4058),
    [anon_sym_sizeof] = ACTIONS(4060),
    [anon_sym___alignof__] = ACTIONS(4060),
    [anon_sym___alignof] = ACTIONS(4060),
    [anon_sym__alignof] = ACTIONS(4060),
    [anon_sym_alignof] = ACTIONS(4060),
    [anon_sym__Alignof] = ACTIONS(4060),
    [anon_sym_offsetof] = ACTIONS(4060),
    [anon_sym__Generic] = ACTIONS(4060),
    [anon_sym_asm] = ACTIONS(4060),
    [anon_sym___asm__] = ACTIONS(4060),
    [anon_sym___asm] = ACTIONS(4060),
    [anon_sym_DOT] = ACTIONS(4060),
    [sym_number_literal] = ACTIONS(4058),
    [anon_sym_L_SQUOTE] = ACTIONS(4058),
    [anon_sym_u_SQUOTE] = ACTIONS(4058),
    [anon_sym_U_SQUOTE] = ACTIONS(4058),
    [anon_sym_u8_SQUOTE] = ACTIONS(4058),
    [anon_sym_SQUOTE] = ACTIONS(4058),
    [anon_sym_L_DQUOTE] = ACTIONS(4058),
    [anon_sym_u_DQUOTE] = ACTIONS(4058),
    [anon_sym_U_DQUOTE] = ACTIONS(4058),
    [anon_sym_u8_DQUOTE] = ACTIONS(4058),
    [anon_sym_DQUOTE] = ACTIONS(4058),
    [sym_true] = ACTIONS(4060),
    [sym_false] = ACTIONS(4060),
    [anon_sym_NULL] = ACTIONS(4060),
    [anon_sym_nullptr] = ACTIONS(4060),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4060),
    [anon_sym_let] = ACTIONS(4060),
    [anon_sym_This] = ACTIONS(4060),
    [anon_sym_decltype] = ACTIONS(4060),
    [anon_sym_explicit] = ACTIONS(4060),
    [anon_sym_typename] = ACTIONS(4060),
    [anon_sym_export] = ACTIONS(4060),
    [anon_sym_module] = ACTIONS(4060),
    [anon_sym_import] = ACTIONS(4060),
    [anon_sym_template] = ACTIONS(4060),
    [anon_sym_operator] = ACTIONS(4060),
    [anon_sym_try] = ACTIONS(4060),
    [anon_sym_delete] = ACTIONS(4060),
    [anon_sym_throw] = ACTIONS(4060),
    [anon_sym_namespace] = ACTIONS(4060),
    [anon_sym_static_assert] = ACTIONS(4060),
    [anon_sym_concept] = ACTIONS(4060),
    [anon_sym_co_return] = ACTIONS(4060),
    [anon_sym_co_yield] = ACTIONS(4060),
    [anon_sym_R_DQUOTE] = ACTIONS(4058),
    [anon_sym_LR_DQUOTE] = ACTIONS(4058),
    [anon_sym_uR_DQUOTE] = ACTIONS(4058),
    [anon_sym_UR_DQUOTE] = ACTIONS(4058),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4058),
    [anon_sym_co_await] = ACTIONS(4060),
    [anon_sym_new] = ACTIONS(4060),
    [anon_sym_requires] = ACTIONS(4060),
    [sym_this] = ACTIONS(4060),
    [anon_sym_precise] = ACTIONS(4060),
    [anon_sym_shared] = ACTIONS(4060),
    [anon_sym_groupshared] = ACTIONS(4060),
    [anon_sym_uniform] = ACTIONS(4060),
    [anon_sym_row_major] = ACTIONS(4060),
    [anon_sym_column_major] = ACTIONS(4060),
    [anon_sym_globallycoherent] = ACTIONS(4060),
    [anon_sym_centroid] = ACTIONS(4060),
    [anon_sym_noperspective] = ACTIONS(4060),
    [anon_sym_nointerpolation] = ACTIONS(4060),
    [anon_sym_sample] = ACTIONS(4060),
    [anon_sym_linear] = ACTIONS(4060),
    [anon_sym_snorm] = ACTIONS(4060),
    [anon_sym_unorm] = ACTIONS(4060),
    [anon_sym_point] = ACTIONS(4060),
    [anon_sym_line] = ACTIONS(4060),
    [anon_sym_triangleadj] = ACTIONS(4060),
    [anon_sym_lineadj] = ACTIONS(4060),
    [anon_sym_triangle] = ACTIONS(4060),
    [anon_sym_interface] = ACTIONS(4060),
    [anon_sym_extension] = ACTIONS(4060),
    [anon_sym___exported] = ACTIONS(4060),
  },
  [655] = {
    [sym_else_clause] = STATE(721),
    [sym_identifier] = ACTIONS(3240),
    [aux_sym_preproc_include_token1] = ACTIONS(3240),
    [aux_sym_preproc_def_token1] = ACTIONS(3240),
    [aux_sym_preproc_if_token1] = ACTIONS(3240),
    [aux_sym_preproc_if_token2] = ACTIONS(3240),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3240),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3240),
    [sym_preproc_directive] = ACTIONS(3240),
    [anon_sym_LPAREN2] = ACTIONS(3238),
    [anon_sym_BANG] = ACTIONS(3238),
    [anon_sym_TILDE] = ACTIONS(3238),
    [anon_sym_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3240),
    [anon_sym_STAR] = ACTIONS(3238),
    [anon_sym_AMP_AMP] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_SEMI] = ACTIONS(3238),
    [anon_sym___extension__] = ACTIONS(3240),
    [anon_sym_typedef] = ACTIONS(3240),
    [anon_sym_in] = ACTIONS(3240),
    [anon_sym_out] = ACTIONS(3240),
    [anon_sym_inout] = ACTIONS(3240),
    [anon_sym_virtual] = ACTIONS(3240),
    [anon_sym_extern] = ACTIONS(3240),
    [anon_sym___attribute__] = ACTIONS(3240),
    [anon_sym___attribute] = ACTIONS(3240),
    [anon_sym_using] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3238),
    [anon_sym___declspec] = ACTIONS(3240),
    [anon_sym___based] = ACTIONS(3240),
    [anon_sym___cdecl] = ACTIONS(3240),
    [anon_sym___clrcall] = ACTIONS(3240),
    [anon_sym___stdcall] = ACTIONS(3240),
    [anon_sym___fastcall] = ACTIONS(3240),
    [anon_sym___thiscall] = ACTIONS(3240),
    [anon_sym___vectorcall] = ACTIONS(3240),
    [anon_sym_LBRACE] = ACTIONS(3238),
    [anon_sym_signed] = ACTIONS(3240),
    [anon_sym_unsigned] = ACTIONS(3240),
    [anon_sym_long] = ACTIONS(3240),
    [anon_sym_short] = ACTIONS(3240),
    [anon_sym_LBRACK] = ACTIONS(3240),
    [anon_sym_static] = ACTIONS(3240),
    [anon_sym_register] = ACTIONS(3240),
    [anon_sym_inline] = ACTIONS(3240),
    [anon_sym___inline] = ACTIONS(3240),
    [anon_sym___inline__] = ACTIONS(3240),
    [anon_sym___forceinline] = ACTIONS(3240),
    [anon_sym_thread_local] = ACTIONS(3240),
    [anon_sym___thread] = ACTIONS(3240),
    [anon_sym_const] = ACTIONS(3240),
    [anon_sym_constexpr] = ACTIONS(3240),
    [anon_sym_volatile] = ACTIONS(3240),
    [anon_sym_restrict] = ACTIONS(3240),
    [anon_sym___restrict__] = ACTIONS(3240),
    [anon_sym__Atomic] = ACTIONS(3240),
    [anon_sym__Noreturn] = ACTIONS(3240),
    [anon_sym_noreturn] = ACTIONS(3240),
    [anon_sym__Nonnull] = ACTIONS(3240),
    [anon_sym_mutable] = ACTIONS(3240),
    [anon_sym_constinit] = ACTIONS(3240),
    [anon_sym_consteval] = ACTIONS(3240),
    [anon_sym_alignas] = ACTIONS(3240),
    [anon_sym__Alignas] = ACTIONS(3240),
    [sym_primitive_type] = ACTIONS(3240),
    [anon_sym_enum] = ACTIONS(3240),
    [anon_sym_class] = ACTIONS(3240),
    [anon_sym_struct] = ACTIONS(3240),
    [anon_sym_union] = ACTIONS(3240),
    [anon_sym_if] = ACTIONS(3240),
    [anon_sym_else] = ACTIONS(4006),
    [anon_sym_switch] = ACTIONS(3240),
    [anon_sym_case] = ACTIONS(3240),
    [anon_sym_default] = ACTIONS(3240),
    [anon_sym_while] = ACTIONS(3240),
    [anon_sym_do] = ACTIONS(3240),
    [anon_sym_for] = ACTIONS(3240),
    [anon_sym_return] = ACTIONS(3240),
    [anon_sym_break] = ACTIONS(3240),
    [anon_sym_continue] = ACTIONS(3240),
    [anon_sym_goto] = ACTIONS(3240),
    [anon_sym___try] = ACTIONS(3240),
    [anon_sym___leave] = ACTIONS(3240),
    [anon_sym_not] = ACTIONS(3240),
    [anon_sym_compl] = ACTIONS(3240),
    [anon_sym_DASH_DASH] = ACTIONS(3238),
    [anon_sym_PLUS_PLUS] = ACTIONS(3238),
    [anon_sym_sizeof] = ACTIONS(3240),
    [anon_sym___alignof__] = ACTIONS(3240),
    [anon_sym___alignof] = ACTIONS(3240),
    [anon_sym__alignof] = ACTIONS(3240),
    [anon_sym_alignof] = ACTIONS(3240),
    [anon_sym__Alignof] = ACTIONS(3240),
    [anon_sym_offsetof] = ACTIONS(3240),
    [anon_sym__Generic] = ACTIONS(3240),
    [anon_sym_asm] = ACTIONS(3240),
    [anon_sym___asm__] = ACTIONS(3240),
    [anon_sym___asm] = ACTIONS(3240),
    [sym_number_literal] = ACTIONS(3238),
    [anon_sym_L_SQUOTE] = ACTIONS(3238),
    [anon_sym_u_SQUOTE] = ACTIONS(3238),
    [anon_sym_U_SQUOTE] = ACTIONS(3238),
    [anon_sym_u8_SQUOTE] = ACTIONS(3238),
    [anon_sym_SQUOTE] = ACTIONS(3238),
    [anon_sym_L_DQUOTE] = ACTIONS(3238),
    [anon_sym_u_DQUOTE] = ACTIONS(3238),
    [anon_sym_U_DQUOTE] = ACTIONS(3238),
    [anon_sym_u8_DQUOTE] = ACTIONS(3238),
    [anon_sym_DQUOTE] = ACTIONS(3238),
    [sym_true] = ACTIONS(3240),
    [sym_false] = ACTIONS(3240),
    [anon_sym_NULL] = ACTIONS(3240),
    [anon_sym_nullptr] = ACTIONS(3240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3240),
    [anon_sym_let] = ACTIONS(3240),
    [anon_sym_This] = ACTIONS(3240),
    [anon_sym_decltype] = ACTIONS(3240),
    [anon_sym_explicit] = ACTIONS(3240),
    [anon_sym_typename] = ACTIONS(3240),
    [anon_sym_template] = ACTIONS(3240),
    [anon_sym_operator] = ACTIONS(3240),
    [anon_sym_try] = ACTIONS(3240),
    [anon_sym_delete] = ACTIONS(3240),
    [anon_sym_throw] = ACTIONS(3240),
    [anon_sym_namespace] = ACTIONS(3240),
    [anon_sym_static_assert] = ACTIONS(3240),
    [anon_sym_concept] = ACTIONS(3240),
    [anon_sym_co_return] = ACTIONS(3240),
    [anon_sym_co_yield] = ACTIONS(3240),
    [anon_sym_R_DQUOTE] = ACTIONS(3238),
    [anon_sym_LR_DQUOTE] = ACTIONS(3238),
    [anon_sym_uR_DQUOTE] = ACTIONS(3238),
    [anon_sym_UR_DQUOTE] = ACTIONS(3238),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3238),
    [anon_sym_co_await] = ACTIONS(3240),
    [anon_sym_new] = ACTIONS(3240),
    [anon_sym_requires] = ACTIONS(3240),
    [sym_this] = ACTIONS(3240),
    [anon_sym_discard] = ACTIONS(3240),
    [anon_sym_precise] = ACTIONS(3240),
    [anon_sym_shared] = ACTIONS(3240),
    [anon_sym_groupshared] = ACTIONS(3240),
    [anon_sym_uniform] = ACTIONS(3240),
    [anon_sym_row_major] = ACTIONS(3240),
    [anon_sym_column_major] = ACTIONS(3240),
    [anon_sym_globallycoherent] = ACTIONS(3240),
    [anon_sym_centroid] = ACTIONS(3240),
    [anon_sym_noperspective] = ACTIONS(3240),
    [anon_sym_nointerpolation] = ACTIONS(3240),
    [anon_sym_sample] = ACTIONS(3240),
    [anon_sym_linear] = ACTIONS(3240),
    [anon_sym_snorm] = ACTIONS(3240),
    [anon_sym_unorm] = ACTIONS(3240),
    [anon_sym_point] = ACTIONS(3240),
    [anon_sym_line] = ACTIONS(3240),
    [anon_sym_triangleadj] = ACTIONS(3240),
    [anon_sym_lineadj] = ACTIONS(3240),
    [anon_sym_triangle] = ACTIONS(3240),
    [anon_sym_cbuffer] = ACTIONS(3240),
    [anon_sym_interface] = ACTIONS(3240),
    [anon_sym_extension] = ACTIONS(3240),
  },
  [656] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(2883),
    [aux_sym_preproc_include_token1] = ACTIONS(2883),
    [aux_sym_preproc_def_token1] = ACTIONS(2883),
    [aux_sym_preproc_if_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2883),
    [sym_preproc_directive] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_typedef] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_using] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2881),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_RBRACE] = ACTIONS(2881),
    [anon_sym_signed] = ACTIONS(3842),
    [anon_sym_unsigned] = ACTIONS(3842),
    [anon_sym_long] = ACTIONS(3842),
    [anon_sym_short] = ACTIONS(3842),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [sym_primitive_type] = ACTIONS(2883),
    [anon_sym_enum] = ACTIONS(2883),
    [anon_sym_class] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2883),
    [anon_sym_union] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_switch] = ACTIONS(2883),
    [anon_sym_case] = ACTIONS(2883),
    [anon_sym_default] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_break] = ACTIONS(2883),
    [anon_sym_continue] = ACTIONS(2883),
    [anon_sym_goto] = ACTIONS(2883),
    [anon_sym___try] = ACTIONS(2883),
    [anon_sym___leave] = ACTIONS(2883),
    [anon_sym_not] = ACTIONS(2883),
    [anon_sym_compl] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_sizeof] = ACTIONS(2883),
    [anon_sym___alignof__] = ACTIONS(2883),
    [anon_sym___alignof] = ACTIONS(2883),
    [anon_sym__alignof] = ACTIONS(2883),
    [anon_sym_alignof] = ACTIONS(2883),
    [anon_sym__Alignof] = ACTIONS(2883),
    [anon_sym_offsetof] = ACTIONS(2883),
    [anon_sym__Generic] = ACTIONS(2883),
    [anon_sym_asm] = ACTIONS(2883),
    [anon_sym___asm__] = ACTIONS(2883),
    [anon_sym___asm] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [sym_number_literal] = ACTIONS(2881),
    [anon_sym_L_SQUOTE] = ACTIONS(2881),
    [anon_sym_u_SQUOTE] = ACTIONS(2881),
    [anon_sym_U_SQUOTE] = ACTIONS(2881),
    [anon_sym_u8_SQUOTE] = ACTIONS(2881),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_L_DQUOTE] = ACTIONS(2881),
    [anon_sym_u_DQUOTE] = ACTIONS(2881),
    [anon_sym_U_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [sym_true] = ACTIONS(2883),
    [sym_false] = ACTIONS(2883),
    [anon_sym_NULL] = ACTIONS(2883),
    [anon_sym_nullptr] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_explicit] = ACTIONS(2883),
    [anon_sym_typename] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_delete] = ACTIONS(2883),
    [anon_sym_throw] = ACTIONS(2883),
    [anon_sym_namespace] = ACTIONS(2883),
    [anon_sym_static_assert] = ACTIONS(2883),
    [anon_sym_concept] = ACTIONS(2883),
    [anon_sym_co_return] = ACTIONS(2883),
    [anon_sym_co_yield] = ACTIONS(2883),
    [anon_sym_R_DQUOTE] = ACTIONS(2881),
    [anon_sym_LR_DQUOTE] = ACTIONS(2881),
    [anon_sym_uR_DQUOTE] = ACTIONS(2881),
    [anon_sym_UR_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2881),
    [anon_sym_co_await] = ACTIONS(2883),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_requires] = ACTIONS(2883),
    [sym_this] = ACTIONS(2883),
    [anon_sym_discard] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
    [anon_sym_cbuffer] = ACTIONS(2883),
    [anon_sym_interface] = ACTIONS(2883),
    [anon_sym_extension] = ACTIONS(2883),
  },
  [657] = {
    [sym_identifier] = ACTIONS(2404),
    [aux_sym_preproc_include_token1] = ACTIONS(2404),
    [aux_sym_preproc_def_token1] = ACTIONS(2404),
    [aux_sym_preproc_if_token1] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2404),
    [sym_preproc_directive] = ACTIONS(2404),
    [anon_sym_LPAREN2] = ACTIONS(2402),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_TILDE] = ACTIONS(2402),
    [anon_sym_DASH] = ACTIONS(2404),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_STAR] = ACTIONS(2402),
    [anon_sym_AMP_AMP] = ACTIONS(2402),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2402),
    [anon_sym___extension__] = ACTIONS(2404),
    [anon_sym_typedef] = ACTIONS(2404),
    [anon_sym_in] = ACTIONS(2404),
    [anon_sym_out] = ACTIONS(2404),
    [anon_sym_inout] = ACTIONS(2404),
    [anon_sym_virtual] = ACTIONS(2404),
    [anon_sym_extern] = ACTIONS(2404),
    [anon_sym___attribute__] = ACTIONS(2404),
    [anon_sym___attribute] = ACTIONS(2404),
    [anon_sym_using] = ACTIONS(2404),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2402),
    [anon_sym___declspec] = ACTIONS(2404),
    [anon_sym___based] = ACTIONS(2404),
    [anon_sym___cdecl] = ACTIONS(2404),
    [anon_sym___clrcall] = ACTIONS(2404),
    [anon_sym___stdcall] = ACTIONS(2404),
    [anon_sym___fastcall] = ACTIONS(2404),
    [anon_sym___thiscall] = ACTIONS(2404),
    [anon_sym___vectorcall] = ACTIONS(2404),
    [anon_sym_LBRACE] = ACTIONS(2402),
    [anon_sym_RBRACE] = ACTIONS(2402),
    [anon_sym_signed] = ACTIONS(2404),
    [anon_sym_unsigned] = ACTIONS(2404),
    [anon_sym_long] = ACTIONS(2404),
    [anon_sym_short] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_register] = ACTIONS(2404),
    [anon_sym_inline] = ACTIONS(2404),
    [anon_sym___inline] = ACTIONS(2404),
    [anon_sym___inline__] = ACTIONS(2404),
    [anon_sym___forceinline] = ACTIONS(2404),
    [anon_sym_thread_local] = ACTIONS(2404),
    [anon_sym___thread] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [anon_sym_constexpr] = ACTIONS(2404),
    [anon_sym_volatile] = ACTIONS(2404),
    [anon_sym_restrict] = ACTIONS(2404),
    [anon_sym___restrict__] = ACTIONS(2404),
    [anon_sym__Atomic] = ACTIONS(2404),
    [anon_sym__Noreturn] = ACTIONS(2404),
    [anon_sym_noreturn] = ACTIONS(2404),
    [anon_sym__Nonnull] = ACTIONS(2404),
    [anon_sym_mutable] = ACTIONS(2404),
    [anon_sym_constinit] = ACTIONS(2404),
    [anon_sym_consteval] = ACTIONS(2404),
    [anon_sym_alignas] = ACTIONS(2404),
    [anon_sym__Alignas] = ACTIONS(2404),
    [sym_primitive_type] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
    [anon_sym_class] = ACTIONS(2404),
    [anon_sym_struct] = ACTIONS(2404),
    [anon_sym_union] = ACTIONS(2404),
    [anon_sym_if] = ACTIONS(2404),
    [anon_sym_else] = ACTIONS(2404),
    [anon_sym_switch] = ACTIONS(2404),
    [anon_sym_case] = ACTIONS(2404),
    [anon_sym_default] = ACTIONS(2404),
    [anon_sym_while] = ACTIONS(2404),
    [anon_sym_do] = ACTIONS(2404),
    [anon_sym_for] = ACTIONS(2404),
    [anon_sym_return] = ACTIONS(2404),
    [anon_sym_break] = ACTIONS(2404),
    [anon_sym_continue] = ACTIONS(2404),
    [anon_sym_goto] = ACTIONS(2404),
    [anon_sym___try] = ACTIONS(2404),
    [anon_sym___leave] = ACTIONS(2404),
    [anon_sym_not] = ACTIONS(2404),
    [anon_sym_compl] = ACTIONS(2404),
    [anon_sym_DASH_DASH] = ACTIONS(2402),
    [anon_sym_PLUS_PLUS] = ACTIONS(2402),
    [anon_sym_sizeof] = ACTIONS(2404),
    [anon_sym___alignof__] = ACTIONS(2404),
    [anon_sym___alignof] = ACTIONS(2404),
    [anon_sym__alignof] = ACTIONS(2404),
    [anon_sym_alignof] = ACTIONS(2404),
    [anon_sym__Alignof] = ACTIONS(2404),
    [anon_sym_offsetof] = ACTIONS(2404),
    [anon_sym__Generic] = ACTIONS(2404),
    [anon_sym_asm] = ACTIONS(2404),
    [anon_sym___asm__] = ACTIONS(2404),
    [anon_sym___asm] = ACTIONS(2404),
    [sym_number_literal] = ACTIONS(2402),
    [anon_sym_L_SQUOTE] = ACTIONS(2402),
    [anon_sym_u_SQUOTE] = ACTIONS(2402),
    [anon_sym_U_SQUOTE] = ACTIONS(2402),
    [anon_sym_u8_SQUOTE] = ACTIONS(2402),
    [anon_sym_SQUOTE] = ACTIONS(2402),
    [anon_sym_L_DQUOTE] = ACTIONS(2402),
    [anon_sym_u_DQUOTE] = ACTIONS(2402),
    [anon_sym_U_DQUOTE] = ACTIONS(2402),
    [anon_sym_u8_DQUOTE] = ACTIONS(2402),
    [anon_sym_DQUOTE] = ACTIONS(2402),
    [sym_true] = ACTIONS(2404),
    [sym_false] = ACTIONS(2404),
    [anon_sym_NULL] = ACTIONS(2404),
    [anon_sym_nullptr] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2404),
    [anon_sym_let] = ACTIONS(2404),
    [anon_sym_This] = ACTIONS(2404),
    [anon_sym_decltype] = ACTIONS(2404),
    [anon_sym_explicit] = ACTIONS(2404),
    [anon_sym_typename] = ACTIONS(2404),
    [anon_sym_template] = ACTIONS(2404),
    [anon_sym_operator] = ACTIONS(2404),
    [anon_sym_try] = ACTIONS(2404),
    [anon_sym_delete] = ACTIONS(2404),
    [anon_sym_throw] = ACTIONS(2404),
    [anon_sym_namespace] = ACTIONS(2404),
    [anon_sym_static_assert] = ACTIONS(2404),
    [anon_sym_concept] = ACTIONS(2404),
    [anon_sym_co_return] = ACTIONS(2404),
    [anon_sym_co_yield] = ACTIONS(2404),
    [anon_sym_catch] = ACTIONS(2404),
    [anon_sym_R_DQUOTE] = ACTIONS(2402),
    [anon_sym_LR_DQUOTE] = ACTIONS(2402),
    [anon_sym_uR_DQUOTE] = ACTIONS(2402),
    [anon_sym_UR_DQUOTE] = ACTIONS(2402),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2402),
    [anon_sym_co_await] = ACTIONS(2404),
    [anon_sym_new] = ACTIONS(2404),
    [anon_sym_requires] = ACTIONS(2404),
    [sym_this] = ACTIONS(2404),
    [anon_sym_discard] = ACTIONS(2404),
    [anon_sym_precise] = ACTIONS(2404),
    [anon_sym_shared] = ACTIONS(2404),
    [anon_sym_groupshared] = ACTIONS(2404),
    [anon_sym_uniform] = ACTIONS(2404),
    [anon_sym_row_major] = ACTIONS(2404),
    [anon_sym_column_major] = ACTIONS(2404),
    [anon_sym_globallycoherent] = ACTIONS(2404),
    [anon_sym_centroid] = ACTIONS(2404),
    [anon_sym_noperspective] = ACTIONS(2404),
    [anon_sym_nointerpolation] = ACTIONS(2404),
    [anon_sym_sample] = ACTIONS(2404),
    [anon_sym_linear] = ACTIONS(2404),
    [anon_sym_snorm] = ACTIONS(2404),
    [anon_sym_unorm] = ACTIONS(2404),
    [anon_sym_point] = ACTIONS(2404),
    [anon_sym_line] = ACTIONS(2404),
    [anon_sym_triangleadj] = ACTIONS(2404),
    [anon_sym_lineadj] = ACTIONS(2404),
    [anon_sym_triangle] = ACTIONS(2404),
    [anon_sym_cbuffer] = ACTIONS(2404),
    [anon_sym_interface] = ACTIONS(2404),
    [anon_sym_extension] = ACTIONS(2404),
  },
  [658] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(284),
    [ts_builtin_sym_end] = ACTIONS(4062),
    [sym_identifier] = ACTIONS(4064),
    [aux_sym_preproc_include_token1] = ACTIONS(4064),
    [aux_sym_preproc_def_token1] = ACTIONS(4064),
    [aux_sym_preproc_if_token1] = ACTIONS(4064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4064),
    [sym_preproc_directive] = ACTIONS(4064),
    [anon_sym_LPAREN2] = ACTIONS(4062),
    [anon_sym_BANG] = ACTIONS(4062),
    [anon_sym_TILDE] = ACTIONS(4062),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_STAR] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4062),
    [anon_sym___extension__] = ACTIONS(4064),
    [anon_sym_typedef] = ACTIONS(4064),
    [anon_sym_in] = ACTIONS(4064),
    [anon_sym_out] = ACTIONS(4064),
    [anon_sym_inout] = ACTIONS(4064),
    [anon_sym_virtual] = ACTIONS(4064),
    [anon_sym_extern] = ACTIONS(4064),
    [anon_sym___attribute__] = ACTIONS(4064),
    [anon_sym___attribute] = ACTIONS(4064),
    [anon_sym_using] = ACTIONS(4064),
    [anon_sym_COLON_COLON] = ACTIONS(4062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4062),
    [anon_sym___declspec] = ACTIONS(4064),
    [anon_sym___based] = ACTIONS(4064),
    [anon_sym___cdecl] = ACTIONS(4064),
    [anon_sym___clrcall] = ACTIONS(4064),
    [anon_sym___stdcall] = ACTIONS(4064),
    [anon_sym___fastcall] = ACTIONS(4064),
    [anon_sym___thiscall] = ACTIONS(4064),
    [anon_sym___vectorcall] = ACTIONS(4064),
    [anon_sym_LBRACE] = ACTIONS(4062),
    [anon_sym_signed] = ACTIONS(4066),
    [anon_sym_unsigned] = ACTIONS(4066),
    [anon_sym_long] = ACTIONS(4066),
    [anon_sym_short] = ACTIONS(4066),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_static] = ACTIONS(4064),
    [anon_sym_register] = ACTIONS(4064),
    [anon_sym_inline] = ACTIONS(4064),
    [anon_sym___inline] = ACTIONS(4064),
    [anon_sym___inline__] = ACTIONS(4064),
    [anon_sym___forceinline] = ACTIONS(4064),
    [anon_sym_thread_local] = ACTIONS(4064),
    [anon_sym___thread] = ACTIONS(4064),
    [anon_sym_const] = ACTIONS(4064),
    [anon_sym_constexpr] = ACTIONS(4064),
    [anon_sym_volatile] = ACTIONS(4064),
    [anon_sym_restrict] = ACTIONS(4064),
    [anon_sym___restrict__] = ACTIONS(4064),
    [anon_sym__Atomic] = ACTIONS(4064),
    [anon_sym__Noreturn] = ACTIONS(4064),
    [anon_sym_noreturn] = ACTIONS(4064),
    [anon_sym__Nonnull] = ACTIONS(4064),
    [anon_sym_mutable] = ACTIONS(4064),
    [anon_sym_constinit] = ACTIONS(4064),
    [anon_sym_consteval] = ACTIONS(4064),
    [anon_sym_alignas] = ACTIONS(4064),
    [anon_sym__Alignas] = ACTIONS(4064),
    [sym_primitive_type] = ACTIONS(4064),
    [anon_sym_enum] = ACTIONS(4064),
    [anon_sym_class] = ACTIONS(4064),
    [anon_sym_struct] = ACTIONS(4064),
    [anon_sym_union] = ACTIONS(4064),
    [anon_sym_if] = ACTIONS(4064),
    [anon_sym_switch] = ACTIONS(4064),
    [anon_sym_case] = ACTIONS(4064),
    [anon_sym_default] = ACTIONS(4064),
    [anon_sym_while] = ACTIONS(4064),
    [anon_sym_do] = ACTIONS(4064),
    [anon_sym_for] = ACTIONS(4064),
    [anon_sym_return] = ACTIONS(4064),
    [anon_sym_break] = ACTIONS(4064),
    [anon_sym_continue] = ACTIONS(4064),
    [anon_sym_goto] = ACTIONS(4064),
    [anon_sym_not] = ACTIONS(4064),
    [anon_sym_compl] = ACTIONS(4064),
    [anon_sym_DASH_DASH] = ACTIONS(4062),
    [anon_sym_PLUS_PLUS] = ACTIONS(4062),
    [anon_sym_sizeof] = ACTIONS(4064),
    [anon_sym___alignof__] = ACTIONS(4064),
    [anon_sym___alignof] = ACTIONS(4064),
    [anon_sym__alignof] = ACTIONS(4064),
    [anon_sym_alignof] = ACTIONS(4064),
    [anon_sym__Alignof] = ACTIONS(4064),
    [anon_sym_offsetof] = ACTIONS(4064),
    [anon_sym__Generic] = ACTIONS(4064),
    [anon_sym_asm] = ACTIONS(4064),
    [anon_sym___asm__] = ACTIONS(4064),
    [anon_sym___asm] = ACTIONS(4064),
    [anon_sym_DOT] = ACTIONS(4064),
    [sym_number_literal] = ACTIONS(4062),
    [anon_sym_L_SQUOTE] = ACTIONS(4062),
    [anon_sym_u_SQUOTE] = ACTIONS(4062),
    [anon_sym_U_SQUOTE] = ACTIONS(4062),
    [anon_sym_u8_SQUOTE] = ACTIONS(4062),
    [anon_sym_SQUOTE] = ACTIONS(4062),
    [anon_sym_L_DQUOTE] = ACTIONS(4062),
    [anon_sym_u_DQUOTE] = ACTIONS(4062),
    [anon_sym_U_DQUOTE] = ACTIONS(4062),
    [anon_sym_u8_DQUOTE] = ACTIONS(4062),
    [anon_sym_DQUOTE] = ACTIONS(4062),
    [sym_true] = ACTIONS(4064),
    [sym_false] = ACTIONS(4064),
    [anon_sym_NULL] = ACTIONS(4064),
    [anon_sym_nullptr] = ACTIONS(4064),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4064),
    [anon_sym_let] = ACTIONS(4064),
    [anon_sym_This] = ACTIONS(4064),
    [anon_sym_decltype] = ACTIONS(4064),
    [anon_sym_explicit] = ACTIONS(4064),
    [anon_sym_typename] = ACTIONS(4064),
    [anon_sym_export] = ACTIONS(4064),
    [anon_sym_module] = ACTIONS(4064),
    [anon_sym_import] = ACTIONS(4064),
    [anon_sym_template] = ACTIONS(4064),
    [anon_sym_operator] = ACTIONS(4064),
    [anon_sym_try] = ACTIONS(4064),
    [anon_sym_delete] = ACTIONS(4064),
    [anon_sym_throw] = ACTIONS(4064),
    [anon_sym_namespace] = ACTIONS(4064),
    [anon_sym_static_assert] = ACTIONS(4064),
    [anon_sym_concept] = ACTIONS(4064),
    [anon_sym_co_return] = ACTIONS(4064),
    [anon_sym_co_yield] = ACTIONS(4064),
    [anon_sym_R_DQUOTE] = ACTIONS(4062),
    [anon_sym_LR_DQUOTE] = ACTIONS(4062),
    [anon_sym_uR_DQUOTE] = ACTIONS(4062),
    [anon_sym_UR_DQUOTE] = ACTIONS(4062),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4062),
    [anon_sym_co_await] = ACTIONS(4064),
    [anon_sym_new] = ACTIONS(4064),
    [anon_sym_requires] = ACTIONS(4064),
    [sym_this] = ACTIONS(4064),
    [anon_sym_precise] = ACTIONS(4064),
    [anon_sym_shared] = ACTIONS(4064),
    [anon_sym_groupshared] = ACTIONS(4064),
    [anon_sym_uniform] = ACTIONS(4064),
    [anon_sym_row_major] = ACTIONS(4064),
    [anon_sym_column_major] = ACTIONS(4064),
    [anon_sym_globallycoherent] = ACTIONS(4064),
    [anon_sym_centroid] = ACTIONS(4064),
    [anon_sym_noperspective] = ACTIONS(4064),
    [anon_sym_nointerpolation] = ACTIONS(4064),
    [anon_sym_sample] = ACTIONS(4064),
    [anon_sym_linear] = ACTIONS(4064),
    [anon_sym_snorm] = ACTIONS(4064),
    [anon_sym_unorm] = ACTIONS(4064),
    [anon_sym_point] = ACTIONS(4064),
    [anon_sym_line] = ACTIONS(4064),
    [anon_sym_triangleadj] = ACTIONS(4064),
    [anon_sym_lineadj] = ACTIONS(4064),
    [anon_sym_triangle] = ACTIONS(4064),
    [anon_sym_interface] = ACTIONS(4064),
    [anon_sym_extension] = ACTIONS(4064),
    [anon_sym___exported] = ACTIONS(4064),
  },
  [659] = {
    [ts_builtin_sym_end] = ACTIONS(3969),
    [sym_identifier] = ACTIONS(3967),
    [aux_sym_preproc_include_token1] = ACTIONS(3967),
    [aux_sym_preproc_def_token1] = ACTIONS(3967),
    [anon_sym_COMMA] = ACTIONS(3969),
    [aux_sym_preproc_if_token1] = ACTIONS(3967),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3967),
    [sym_preproc_directive] = ACTIONS(3967),
    [anon_sym_LPAREN2] = ACTIONS(3969),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_TILDE] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_STAR] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_AMP] = ACTIONS(3967),
    [anon_sym_SEMI] = ACTIONS(3969),
    [anon_sym___extension__] = ACTIONS(3967),
    [anon_sym_typedef] = ACTIONS(3967),
    [anon_sym_in] = ACTIONS(3967),
    [anon_sym_out] = ACTIONS(3967),
    [anon_sym_inout] = ACTIONS(3967),
    [anon_sym_virtual] = ACTIONS(3967),
    [anon_sym_extern] = ACTIONS(3967),
    [anon_sym___attribute__] = ACTIONS(3967),
    [anon_sym___attribute] = ACTIONS(3967),
    [anon_sym_using] = ACTIONS(3967),
    [anon_sym_COLON_COLON] = ACTIONS(3969),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3969),
    [anon_sym___declspec] = ACTIONS(3967),
    [anon_sym___based] = ACTIONS(3967),
    [anon_sym___cdecl] = ACTIONS(3967),
    [anon_sym___clrcall] = ACTIONS(3967),
    [anon_sym___stdcall] = ACTIONS(3967),
    [anon_sym___fastcall] = ACTIONS(3967),
    [anon_sym___thiscall] = ACTIONS(3967),
    [anon_sym___vectorcall] = ACTIONS(3967),
    [anon_sym_LBRACE] = ACTIONS(3969),
    [anon_sym_RBRACE] = ACTIONS(3969),
    [anon_sym_signed] = ACTIONS(3967),
    [anon_sym_unsigned] = ACTIONS(3967),
    [anon_sym_long] = ACTIONS(3967),
    [anon_sym_short] = ACTIONS(3967),
    [anon_sym_LBRACK] = ACTIONS(3967),
    [anon_sym_static] = ACTIONS(3967),
    [anon_sym_register] = ACTIONS(3967),
    [anon_sym_inline] = ACTIONS(3967),
    [anon_sym___inline] = ACTIONS(3967),
    [anon_sym___inline__] = ACTIONS(3967),
    [anon_sym___forceinline] = ACTIONS(3967),
    [anon_sym_thread_local] = ACTIONS(3967),
    [anon_sym___thread] = ACTIONS(3967),
    [anon_sym_const] = ACTIONS(3967),
    [anon_sym_constexpr] = ACTIONS(3967),
    [anon_sym_volatile] = ACTIONS(3967),
    [anon_sym_restrict] = ACTIONS(3967),
    [anon_sym___restrict__] = ACTIONS(3967),
    [anon_sym__Atomic] = ACTIONS(3967),
    [anon_sym__Noreturn] = ACTIONS(3967),
    [anon_sym_noreturn] = ACTIONS(3967),
    [anon_sym__Nonnull] = ACTIONS(3967),
    [anon_sym_mutable] = ACTIONS(3967),
    [anon_sym_constinit] = ACTIONS(3967),
    [anon_sym_consteval] = ACTIONS(3967),
    [anon_sym_alignas] = ACTIONS(3967),
    [anon_sym__Alignas] = ACTIONS(3967),
    [sym_primitive_type] = ACTIONS(3967),
    [anon_sym_enum] = ACTIONS(3967),
    [anon_sym_class] = ACTIONS(3967),
    [anon_sym_struct] = ACTIONS(3967),
    [anon_sym_union] = ACTIONS(3967),
    [anon_sym_if] = ACTIONS(3967),
    [anon_sym_switch] = ACTIONS(3967),
    [anon_sym_case] = ACTIONS(3967),
    [anon_sym_default] = ACTIONS(3967),
    [anon_sym_while] = ACTIONS(3967),
    [anon_sym_do] = ACTIONS(3967),
    [anon_sym_for] = ACTIONS(3967),
    [anon_sym_return] = ACTIONS(3967),
    [anon_sym_break] = ACTIONS(3967),
    [anon_sym_continue] = ACTIONS(3967),
    [anon_sym_goto] = ACTIONS(3967),
    [anon_sym_not] = ACTIONS(3967),
    [anon_sym_compl] = ACTIONS(3967),
    [anon_sym_DASH_DASH] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3969),
    [anon_sym_sizeof] = ACTIONS(3967),
    [anon_sym___alignof__] = ACTIONS(3967),
    [anon_sym___alignof] = ACTIONS(3967),
    [anon_sym__alignof] = ACTIONS(3967),
    [anon_sym_alignof] = ACTIONS(3967),
    [anon_sym__Alignof] = ACTIONS(3967),
    [anon_sym_offsetof] = ACTIONS(3967),
    [anon_sym__Generic] = ACTIONS(3967),
    [anon_sym_asm] = ACTIONS(3967),
    [anon_sym___asm__] = ACTIONS(3967),
    [anon_sym___asm] = ACTIONS(3967),
    [sym_number_literal] = ACTIONS(3969),
    [anon_sym_L_SQUOTE] = ACTIONS(3969),
    [anon_sym_u_SQUOTE] = ACTIONS(3969),
    [anon_sym_U_SQUOTE] = ACTIONS(3969),
    [anon_sym_u8_SQUOTE] = ACTIONS(3969),
    [anon_sym_SQUOTE] = ACTIONS(3969),
    [anon_sym_L_DQUOTE] = ACTIONS(3969),
    [anon_sym_u_DQUOTE] = ACTIONS(3969),
    [anon_sym_U_DQUOTE] = ACTIONS(3969),
    [anon_sym_u8_DQUOTE] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(3969),
    [sym_true] = ACTIONS(3967),
    [sym_false] = ACTIONS(3967),
    [anon_sym_NULL] = ACTIONS(3967),
    [anon_sym_nullptr] = ACTIONS(3967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3967),
    [anon_sym_let] = ACTIONS(3967),
    [anon_sym_This] = ACTIONS(3967),
    [anon_sym_decltype] = ACTIONS(3967),
    [anon_sym_explicit] = ACTIONS(3967),
    [anon_sym_typename] = ACTIONS(3967),
    [anon_sym_export] = ACTIONS(3967),
    [anon_sym_module] = ACTIONS(3967),
    [anon_sym_import] = ACTIONS(3967),
    [anon_sym_template] = ACTIONS(3967),
    [anon_sym_operator] = ACTIONS(3967),
    [anon_sym_try] = ACTIONS(3967),
    [anon_sym_delete] = ACTIONS(3967),
    [anon_sym_throw] = ACTIONS(3967),
    [anon_sym_namespace] = ACTIONS(3967),
    [anon_sym_static_assert] = ACTIONS(3967),
    [anon_sym_concept] = ACTIONS(3967),
    [anon_sym_co_return] = ACTIONS(3967),
    [anon_sym_co_yield] = ACTIONS(3967),
    [anon_sym_R_DQUOTE] = ACTIONS(3969),
    [anon_sym_LR_DQUOTE] = ACTIONS(3969),
    [anon_sym_uR_DQUOTE] = ACTIONS(3969),
    [anon_sym_UR_DQUOTE] = ACTIONS(3969),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3969),
    [anon_sym_co_await] = ACTIONS(3967),
    [anon_sym_new] = ACTIONS(3967),
    [anon_sym_requires] = ACTIONS(3967),
    [sym_this] = ACTIONS(3967),
    [anon_sym_precise] = ACTIONS(3967),
    [anon_sym_shared] = ACTIONS(3967),
    [anon_sym_groupshared] = ACTIONS(3967),
    [anon_sym_uniform] = ACTIONS(3967),
    [anon_sym_row_major] = ACTIONS(3967),
    [anon_sym_column_major] = ACTIONS(3967),
    [anon_sym_globallycoherent] = ACTIONS(3967),
    [anon_sym_centroid] = ACTIONS(3967),
    [anon_sym_noperspective] = ACTIONS(3967),
    [anon_sym_nointerpolation] = ACTIONS(3967),
    [anon_sym_sample] = ACTIONS(3967),
    [anon_sym_linear] = ACTIONS(3967),
    [anon_sym_snorm] = ACTIONS(3967),
    [anon_sym_unorm] = ACTIONS(3967),
    [anon_sym_point] = ACTIONS(3967),
    [anon_sym_line] = ACTIONS(3967),
    [anon_sym_triangleadj] = ACTIONS(3967),
    [anon_sym_lineadj] = ACTIONS(3967),
    [anon_sym_triangle] = ACTIONS(3967),
    [anon_sym_interface] = ACTIONS(3967),
    [anon_sym_extension] = ACTIONS(3967),
    [anon_sym___exported] = ACTIONS(3967),
  },
  [660] = {
    [sym_else_clause] = STATE(770),
    [sym_identifier] = ACTIONS(3240),
    [aux_sym_preproc_include_token1] = ACTIONS(3240),
    [aux_sym_preproc_def_token1] = ACTIONS(3240),
    [aux_sym_preproc_if_token1] = ACTIONS(3240),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3240),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3240),
    [sym_preproc_directive] = ACTIONS(3240),
    [anon_sym_LPAREN2] = ACTIONS(3238),
    [anon_sym_BANG] = ACTIONS(3238),
    [anon_sym_TILDE] = ACTIONS(3238),
    [anon_sym_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3240),
    [anon_sym_STAR] = ACTIONS(3238),
    [anon_sym_AMP_AMP] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_SEMI] = ACTIONS(3238),
    [anon_sym___extension__] = ACTIONS(3240),
    [anon_sym_typedef] = ACTIONS(3240),
    [anon_sym_in] = ACTIONS(3240),
    [anon_sym_out] = ACTIONS(3240),
    [anon_sym_inout] = ACTIONS(3240),
    [anon_sym_virtual] = ACTIONS(3240),
    [anon_sym_extern] = ACTIONS(3240),
    [anon_sym___attribute__] = ACTIONS(3240),
    [anon_sym___attribute] = ACTIONS(3240),
    [anon_sym_using] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3238),
    [anon_sym___declspec] = ACTIONS(3240),
    [anon_sym___based] = ACTIONS(3240),
    [anon_sym___cdecl] = ACTIONS(3240),
    [anon_sym___clrcall] = ACTIONS(3240),
    [anon_sym___stdcall] = ACTIONS(3240),
    [anon_sym___fastcall] = ACTIONS(3240),
    [anon_sym___thiscall] = ACTIONS(3240),
    [anon_sym___vectorcall] = ACTIONS(3240),
    [anon_sym_LBRACE] = ACTIONS(3238),
    [anon_sym_RBRACE] = ACTIONS(3238),
    [anon_sym_signed] = ACTIONS(3240),
    [anon_sym_unsigned] = ACTIONS(3240),
    [anon_sym_long] = ACTIONS(3240),
    [anon_sym_short] = ACTIONS(3240),
    [anon_sym_LBRACK] = ACTIONS(3240),
    [anon_sym_static] = ACTIONS(3240),
    [anon_sym_register] = ACTIONS(3240),
    [anon_sym_inline] = ACTIONS(3240),
    [anon_sym___inline] = ACTIONS(3240),
    [anon_sym___inline__] = ACTIONS(3240),
    [anon_sym___forceinline] = ACTIONS(3240),
    [anon_sym_thread_local] = ACTIONS(3240),
    [anon_sym___thread] = ACTIONS(3240),
    [anon_sym_const] = ACTIONS(3240),
    [anon_sym_constexpr] = ACTIONS(3240),
    [anon_sym_volatile] = ACTIONS(3240),
    [anon_sym_restrict] = ACTIONS(3240),
    [anon_sym___restrict__] = ACTIONS(3240),
    [anon_sym__Atomic] = ACTIONS(3240),
    [anon_sym__Noreturn] = ACTIONS(3240),
    [anon_sym_noreturn] = ACTIONS(3240),
    [anon_sym__Nonnull] = ACTIONS(3240),
    [anon_sym_mutable] = ACTIONS(3240),
    [anon_sym_constinit] = ACTIONS(3240),
    [anon_sym_consteval] = ACTIONS(3240),
    [anon_sym_alignas] = ACTIONS(3240),
    [anon_sym__Alignas] = ACTIONS(3240),
    [sym_primitive_type] = ACTIONS(3240),
    [anon_sym_enum] = ACTIONS(3240),
    [anon_sym_class] = ACTIONS(3240),
    [anon_sym_struct] = ACTIONS(3240),
    [anon_sym_union] = ACTIONS(3240),
    [anon_sym_if] = ACTIONS(3240),
    [anon_sym_else] = ACTIONS(4069),
    [anon_sym_switch] = ACTIONS(3240),
    [anon_sym_case] = ACTIONS(3240),
    [anon_sym_default] = ACTIONS(3240),
    [anon_sym_while] = ACTIONS(3240),
    [anon_sym_do] = ACTIONS(3240),
    [anon_sym_for] = ACTIONS(3240),
    [anon_sym_return] = ACTIONS(3240),
    [anon_sym_break] = ACTIONS(3240),
    [anon_sym_continue] = ACTIONS(3240),
    [anon_sym_goto] = ACTIONS(3240),
    [anon_sym___try] = ACTIONS(3240),
    [anon_sym___leave] = ACTIONS(3240),
    [anon_sym_not] = ACTIONS(3240),
    [anon_sym_compl] = ACTIONS(3240),
    [anon_sym_DASH_DASH] = ACTIONS(3238),
    [anon_sym_PLUS_PLUS] = ACTIONS(3238),
    [anon_sym_sizeof] = ACTIONS(3240),
    [anon_sym___alignof__] = ACTIONS(3240),
    [anon_sym___alignof] = ACTIONS(3240),
    [anon_sym__alignof] = ACTIONS(3240),
    [anon_sym_alignof] = ACTIONS(3240),
    [anon_sym__Alignof] = ACTIONS(3240),
    [anon_sym_offsetof] = ACTIONS(3240),
    [anon_sym__Generic] = ACTIONS(3240),
    [anon_sym_asm] = ACTIONS(3240),
    [anon_sym___asm__] = ACTIONS(3240),
    [anon_sym___asm] = ACTIONS(3240),
    [sym_number_literal] = ACTIONS(3238),
    [anon_sym_L_SQUOTE] = ACTIONS(3238),
    [anon_sym_u_SQUOTE] = ACTIONS(3238),
    [anon_sym_U_SQUOTE] = ACTIONS(3238),
    [anon_sym_u8_SQUOTE] = ACTIONS(3238),
    [anon_sym_SQUOTE] = ACTIONS(3238),
    [anon_sym_L_DQUOTE] = ACTIONS(3238),
    [anon_sym_u_DQUOTE] = ACTIONS(3238),
    [anon_sym_U_DQUOTE] = ACTIONS(3238),
    [anon_sym_u8_DQUOTE] = ACTIONS(3238),
    [anon_sym_DQUOTE] = ACTIONS(3238),
    [sym_true] = ACTIONS(3240),
    [sym_false] = ACTIONS(3240),
    [anon_sym_NULL] = ACTIONS(3240),
    [anon_sym_nullptr] = ACTIONS(3240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3240),
    [anon_sym_let] = ACTIONS(3240),
    [anon_sym_This] = ACTIONS(3240),
    [anon_sym_decltype] = ACTIONS(3240),
    [anon_sym_explicit] = ACTIONS(3240),
    [anon_sym_typename] = ACTIONS(3240),
    [anon_sym_template] = ACTIONS(3240),
    [anon_sym_operator] = ACTIONS(3240),
    [anon_sym_try] = ACTIONS(3240),
    [anon_sym_delete] = ACTIONS(3240),
    [anon_sym_throw] = ACTIONS(3240),
    [anon_sym_namespace] = ACTIONS(3240),
    [anon_sym_static_assert] = ACTIONS(3240),
    [anon_sym_concept] = ACTIONS(3240),
    [anon_sym_co_return] = ACTIONS(3240),
    [anon_sym_co_yield] = ACTIONS(3240),
    [anon_sym_R_DQUOTE] = ACTIONS(3238),
    [anon_sym_LR_DQUOTE] = ACTIONS(3238),
    [anon_sym_uR_DQUOTE] = ACTIONS(3238),
    [anon_sym_UR_DQUOTE] = ACTIONS(3238),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3238),
    [anon_sym_co_await] = ACTIONS(3240),
    [anon_sym_new] = ACTIONS(3240),
    [anon_sym_requires] = ACTIONS(3240),
    [sym_this] = ACTIONS(3240),
    [anon_sym_discard] = ACTIONS(3240),
    [anon_sym_precise] = ACTIONS(3240),
    [anon_sym_shared] = ACTIONS(3240),
    [anon_sym_groupshared] = ACTIONS(3240),
    [anon_sym_uniform] = ACTIONS(3240),
    [anon_sym_row_major] = ACTIONS(3240),
    [anon_sym_column_major] = ACTIONS(3240),
    [anon_sym_globallycoherent] = ACTIONS(3240),
    [anon_sym_centroid] = ACTIONS(3240),
    [anon_sym_noperspective] = ACTIONS(3240),
    [anon_sym_nointerpolation] = ACTIONS(3240),
    [anon_sym_sample] = ACTIONS(3240),
    [anon_sym_linear] = ACTIONS(3240),
    [anon_sym_snorm] = ACTIONS(3240),
    [anon_sym_unorm] = ACTIONS(3240),
    [anon_sym_point] = ACTIONS(3240),
    [anon_sym_line] = ACTIONS(3240),
    [anon_sym_triangleadj] = ACTIONS(3240),
    [anon_sym_lineadj] = ACTIONS(3240),
    [anon_sym_triangle] = ACTIONS(3240),
    [anon_sym_cbuffer] = ACTIONS(3240),
    [anon_sym_interface] = ACTIONS(3240),
    [anon_sym_extension] = ACTIONS(3240),
  },
  [661] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(284),
    [ts_builtin_sym_end] = ACTIONS(4071),
    [sym_identifier] = ACTIONS(4073),
    [aux_sym_preproc_include_token1] = ACTIONS(4073),
    [aux_sym_preproc_def_token1] = ACTIONS(4073),
    [aux_sym_preproc_if_token1] = ACTIONS(4073),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4073),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4073),
    [sym_preproc_directive] = ACTIONS(4073),
    [anon_sym_LPAREN2] = ACTIONS(4071),
    [anon_sym_BANG] = ACTIONS(4071),
    [anon_sym_TILDE] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(4073),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym___extension__] = ACTIONS(4073),
    [anon_sym_typedef] = ACTIONS(4073),
    [anon_sym_in] = ACTIONS(4073),
    [anon_sym_out] = ACTIONS(4073),
    [anon_sym_inout] = ACTIONS(4073),
    [anon_sym_virtual] = ACTIONS(4073),
    [anon_sym_extern] = ACTIONS(4073),
    [anon_sym___attribute__] = ACTIONS(4073),
    [anon_sym___attribute] = ACTIONS(4073),
    [anon_sym_using] = ACTIONS(4073),
    [anon_sym_COLON_COLON] = ACTIONS(4071),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4071),
    [anon_sym___declspec] = ACTIONS(4073),
    [anon_sym___based] = ACTIONS(4073),
    [anon_sym___cdecl] = ACTIONS(4073),
    [anon_sym___clrcall] = ACTIONS(4073),
    [anon_sym___stdcall] = ACTIONS(4073),
    [anon_sym___fastcall] = ACTIONS(4073),
    [anon_sym___thiscall] = ACTIONS(4073),
    [anon_sym___vectorcall] = ACTIONS(4073),
    [anon_sym_LBRACE] = ACTIONS(4071),
    [anon_sym_signed] = ACTIONS(4075),
    [anon_sym_unsigned] = ACTIONS(4075),
    [anon_sym_long] = ACTIONS(4075),
    [anon_sym_short] = ACTIONS(4075),
    [anon_sym_LBRACK] = ACTIONS(4073),
    [anon_sym_static] = ACTIONS(4073),
    [anon_sym_register] = ACTIONS(4073),
    [anon_sym_inline] = ACTIONS(4073),
    [anon_sym___inline] = ACTIONS(4073),
    [anon_sym___inline__] = ACTIONS(4073),
    [anon_sym___forceinline] = ACTIONS(4073),
    [anon_sym_thread_local] = ACTIONS(4073),
    [anon_sym___thread] = ACTIONS(4073),
    [anon_sym_const] = ACTIONS(4073),
    [anon_sym_constexpr] = ACTIONS(4073),
    [anon_sym_volatile] = ACTIONS(4073),
    [anon_sym_restrict] = ACTIONS(4073),
    [anon_sym___restrict__] = ACTIONS(4073),
    [anon_sym__Atomic] = ACTIONS(4073),
    [anon_sym__Noreturn] = ACTIONS(4073),
    [anon_sym_noreturn] = ACTIONS(4073),
    [anon_sym__Nonnull] = ACTIONS(4073),
    [anon_sym_mutable] = ACTIONS(4073),
    [anon_sym_constinit] = ACTIONS(4073),
    [anon_sym_consteval] = ACTIONS(4073),
    [anon_sym_alignas] = ACTIONS(4073),
    [anon_sym__Alignas] = ACTIONS(4073),
    [sym_primitive_type] = ACTIONS(4073),
    [anon_sym_enum] = ACTIONS(4073),
    [anon_sym_class] = ACTIONS(4073),
    [anon_sym_struct] = ACTIONS(4073),
    [anon_sym_union] = ACTIONS(4073),
    [anon_sym_if] = ACTIONS(4073),
    [anon_sym_switch] = ACTIONS(4073),
    [anon_sym_case] = ACTIONS(4073),
    [anon_sym_default] = ACTIONS(4073),
    [anon_sym_while] = ACTIONS(4073),
    [anon_sym_do] = ACTIONS(4073),
    [anon_sym_for] = ACTIONS(4073),
    [anon_sym_return] = ACTIONS(4073),
    [anon_sym_break] = ACTIONS(4073),
    [anon_sym_continue] = ACTIONS(4073),
    [anon_sym_goto] = ACTIONS(4073),
    [anon_sym_not] = ACTIONS(4073),
    [anon_sym_compl] = ACTIONS(4073),
    [anon_sym_DASH_DASH] = ACTIONS(4071),
    [anon_sym_PLUS_PLUS] = ACTIONS(4071),
    [anon_sym_sizeof] = ACTIONS(4073),
    [anon_sym___alignof__] = ACTIONS(4073),
    [anon_sym___alignof] = ACTIONS(4073),
    [anon_sym__alignof] = ACTIONS(4073),
    [anon_sym_alignof] = ACTIONS(4073),
    [anon_sym__Alignof] = ACTIONS(4073),
    [anon_sym_offsetof] = ACTIONS(4073),
    [anon_sym__Generic] = ACTIONS(4073),
    [anon_sym_asm] = ACTIONS(4073),
    [anon_sym___asm__] = ACTIONS(4073),
    [anon_sym___asm] = ACTIONS(4073),
    [anon_sym_DOT] = ACTIONS(4073),
    [sym_number_literal] = ACTIONS(4071),
    [anon_sym_L_SQUOTE] = ACTIONS(4071),
    [anon_sym_u_SQUOTE] = ACTIONS(4071),
    [anon_sym_U_SQUOTE] = ACTIONS(4071),
    [anon_sym_u8_SQUOTE] = ACTIONS(4071),
    [anon_sym_SQUOTE] = ACTIONS(4071),
    [anon_sym_L_DQUOTE] = ACTIONS(4071),
    [anon_sym_u_DQUOTE] = ACTIONS(4071),
    [anon_sym_U_DQUOTE] = ACTIONS(4071),
    [anon_sym_u8_DQUOTE] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(4071),
    [sym_true] = ACTIONS(4073),
    [sym_false] = ACTIONS(4073),
    [anon_sym_NULL] = ACTIONS(4073),
    [anon_sym_nullptr] = ACTIONS(4073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4073),
    [anon_sym_let] = ACTIONS(4073),
    [anon_sym_This] = ACTIONS(4073),
    [anon_sym_decltype] = ACTIONS(4073),
    [anon_sym_explicit] = ACTIONS(4073),
    [anon_sym_typename] = ACTIONS(4073),
    [anon_sym_export] = ACTIONS(4073),
    [anon_sym_module] = ACTIONS(4073),
    [anon_sym_import] = ACTIONS(4073),
    [anon_sym_template] = ACTIONS(4073),
    [anon_sym_operator] = ACTIONS(4073),
    [anon_sym_try] = ACTIONS(4073),
    [anon_sym_delete] = ACTIONS(4073),
    [anon_sym_throw] = ACTIONS(4073),
    [anon_sym_namespace] = ACTIONS(4073),
    [anon_sym_static_assert] = ACTIONS(4073),
    [anon_sym_concept] = ACTIONS(4073),
    [anon_sym_co_return] = ACTIONS(4073),
    [anon_sym_co_yield] = ACTIONS(4073),
    [anon_sym_R_DQUOTE] = ACTIONS(4071),
    [anon_sym_LR_DQUOTE] = ACTIONS(4071),
    [anon_sym_uR_DQUOTE] = ACTIONS(4071),
    [anon_sym_UR_DQUOTE] = ACTIONS(4071),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4071),
    [anon_sym_co_await] = ACTIONS(4073),
    [anon_sym_new] = ACTIONS(4073),
    [anon_sym_requires] = ACTIONS(4073),
    [sym_this] = ACTIONS(4073),
    [anon_sym_precise] = ACTIONS(4073),
    [anon_sym_shared] = ACTIONS(4073),
    [anon_sym_groupshared] = ACTIONS(4073),
    [anon_sym_uniform] = ACTIONS(4073),
    [anon_sym_row_major] = ACTIONS(4073),
    [anon_sym_column_major] = ACTIONS(4073),
    [anon_sym_globallycoherent] = ACTIONS(4073),
    [anon_sym_centroid] = ACTIONS(4073),
    [anon_sym_noperspective] = ACTIONS(4073),
    [anon_sym_nointerpolation] = ACTIONS(4073),
    [anon_sym_sample] = ACTIONS(4073),
    [anon_sym_linear] = ACTIONS(4073),
    [anon_sym_snorm] = ACTIONS(4073),
    [anon_sym_unorm] = ACTIONS(4073),
    [anon_sym_point] = ACTIONS(4073),
    [anon_sym_line] = ACTIONS(4073),
    [anon_sym_triangleadj] = ACTIONS(4073),
    [anon_sym_lineadj] = ACTIONS(4073),
    [anon_sym_triangle] = ACTIONS(4073),
    [anon_sym_interface] = ACTIONS(4073),
    [anon_sym_extension] = ACTIONS(4073),
    [anon_sym___exported] = ACTIONS(4073),
  },
  [662] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(672),
    [sym_identifier] = ACTIONS(4078),
    [aux_sym_preproc_include_token1] = ACTIONS(4078),
    [aux_sym_preproc_def_token1] = ACTIONS(4078),
    [aux_sym_preproc_if_token1] = ACTIONS(4078),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4078),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4078),
    [sym_preproc_directive] = ACTIONS(4078),
    [anon_sym_LPAREN2] = ACTIONS(4080),
    [anon_sym_BANG] = ACTIONS(4080),
    [anon_sym_TILDE] = ACTIONS(4080),
    [anon_sym_DASH] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(4078),
    [anon_sym_STAR] = ACTIONS(4080),
    [anon_sym_AMP_AMP] = ACTIONS(4080),
    [anon_sym_AMP] = ACTIONS(4078),
    [anon_sym_SEMI] = ACTIONS(4080),
    [anon_sym___extension__] = ACTIONS(4078),
    [anon_sym_typedef] = ACTIONS(4078),
    [anon_sym_in] = ACTIONS(4078),
    [anon_sym_out] = ACTIONS(4078),
    [anon_sym_inout] = ACTIONS(4078),
    [anon_sym_virtual] = ACTIONS(4078),
    [anon_sym_extern] = ACTIONS(4078),
    [anon_sym___attribute__] = ACTIONS(4078),
    [anon_sym___attribute] = ACTIONS(4078),
    [anon_sym_using] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(4080),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4080),
    [anon_sym___declspec] = ACTIONS(4078),
    [anon_sym___based] = ACTIONS(4078),
    [anon_sym___cdecl] = ACTIONS(4078),
    [anon_sym___clrcall] = ACTIONS(4078),
    [anon_sym___stdcall] = ACTIONS(4078),
    [anon_sym___fastcall] = ACTIONS(4078),
    [anon_sym___thiscall] = ACTIONS(4078),
    [anon_sym___vectorcall] = ACTIONS(4078),
    [anon_sym_LBRACE] = ACTIONS(4080),
    [anon_sym_RBRACE] = ACTIONS(4080),
    [anon_sym_signed] = ACTIONS(4082),
    [anon_sym_unsigned] = ACTIONS(4082),
    [anon_sym_long] = ACTIONS(4082),
    [anon_sym_short] = ACTIONS(4082),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_static] = ACTIONS(4078),
    [anon_sym_register] = ACTIONS(4078),
    [anon_sym_inline] = ACTIONS(4078),
    [anon_sym___inline] = ACTIONS(4078),
    [anon_sym___inline__] = ACTIONS(4078),
    [anon_sym___forceinline] = ACTIONS(4078),
    [anon_sym_thread_local] = ACTIONS(4078),
    [anon_sym___thread] = ACTIONS(4078),
    [anon_sym_const] = ACTIONS(4078),
    [anon_sym_constexpr] = ACTIONS(4078),
    [anon_sym_volatile] = ACTIONS(4078),
    [anon_sym_restrict] = ACTIONS(4078),
    [anon_sym___restrict__] = ACTIONS(4078),
    [anon_sym__Atomic] = ACTIONS(4078),
    [anon_sym__Noreturn] = ACTIONS(4078),
    [anon_sym_noreturn] = ACTIONS(4078),
    [anon_sym__Nonnull] = ACTIONS(4078),
    [anon_sym_mutable] = ACTIONS(4078),
    [anon_sym_constinit] = ACTIONS(4078),
    [anon_sym_consteval] = ACTIONS(4078),
    [anon_sym_alignas] = ACTIONS(4078),
    [anon_sym__Alignas] = ACTIONS(4078),
    [sym_primitive_type] = ACTIONS(4078),
    [anon_sym_enum] = ACTIONS(4078),
    [anon_sym_class] = ACTIONS(4078),
    [anon_sym_struct] = ACTIONS(4078),
    [anon_sym_union] = ACTIONS(4078),
    [anon_sym_if] = ACTIONS(4078),
    [anon_sym_switch] = ACTIONS(4078),
    [anon_sym_case] = ACTIONS(4078),
    [anon_sym_default] = ACTIONS(4078),
    [anon_sym_while] = ACTIONS(4078),
    [anon_sym_do] = ACTIONS(4078),
    [anon_sym_for] = ACTIONS(4078),
    [anon_sym_return] = ACTIONS(4078),
    [anon_sym_break] = ACTIONS(4078),
    [anon_sym_continue] = ACTIONS(4078),
    [anon_sym_goto] = ACTIONS(4078),
    [anon_sym___try] = ACTIONS(4078),
    [anon_sym___leave] = ACTIONS(4078),
    [anon_sym_not] = ACTIONS(4078),
    [anon_sym_compl] = ACTIONS(4078),
    [anon_sym_DASH_DASH] = ACTIONS(4080),
    [anon_sym_PLUS_PLUS] = ACTIONS(4080),
    [anon_sym_sizeof] = ACTIONS(4078),
    [anon_sym___alignof__] = ACTIONS(4078),
    [anon_sym___alignof] = ACTIONS(4078),
    [anon_sym__alignof] = ACTIONS(4078),
    [anon_sym_alignof] = ACTIONS(4078),
    [anon_sym__Alignof] = ACTIONS(4078),
    [anon_sym_offsetof] = ACTIONS(4078),
    [anon_sym__Generic] = ACTIONS(4078),
    [anon_sym_asm] = ACTIONS(4078),
    [anon_sym___asm__] = ACTIONS(4078),
    [anon_sym___asm] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(4078),
    [sym_number_literal] = ACTIONS(4080),
    [anon_sym_L_SQUOTE] = ACTIONS(4080),
    [anon_sym_u_SQUOTE] = ACTIONS(4080),
    [anon_sym_U_SQUOTE] = ACTIONS(4080),
    [anon_sym_u8_SQUOTE] = ACTIONS(4080),
    [anon_sym_SQUOTE] = ACTIONS(4080),
    [anon_sym_L_DQUOTE] = ACTIONS(4080),
    [anon_sym_u_DQUOTE] = ACTIONS(4080),
    [anon_sym_U_DQUOTE] = ACTIONS(4080),
    [anon_sym_u8_DQUOTE] = ACTIONS(4080),
    [anon_sym_DQUOTE] = ACTIONS(4080),
    [sym_true] = ACTIONS(4078),
    [sym_false] = ACTIONS(4078),
    [anon_sym_NULL] = ACTIONS(4078),
    [anon_sym_nullptr] = ACTIONS(4078),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4078),
    [anon_sym_let] = ACTIONS(4078),
    [anon_sym_This] = ACTIONS(4078),
    [anon_sym_decltype] = ACTIONS(4078),
    [anon_sym_explicit] = ACTIONS(4078),
    [anon_sym_typename] = ACTIONS(4078),
    [anon_sym_template] = ACTIONS(4078),
    [anon_sym_operator] = ACTIONS(4078),
    [anon_sym_try] = ACTIONS(4078),
    [anon_sym_delete] = ACTIONS(4078),
    [anon_sym_throw] = ACTIONS(4078),
    [anon_sym_namespace] = ACTIONS(4078),
    [anon_sym_static_assert] = ACTIONS(4078),
    [anon_sym_concept] = ACTIONS(4078),
    [anon_sym_co_return] = ACTIONS(4078),
    [anon_sym_co_yield] = ACTIONS(4078),
    [anon_sym_R_DQUOTE] = ACTIONS(4080),
    [anon_sym_LR_DQUOTE] = ACTIONS(4080),
    [anon_sym_uR_DQUOTE] = ACTIONS(4080),
    [anon_sym_UR_DQUOTE] = ACTIONS(4080),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4080),
    [anon_sym_co_await] = ACTIONS(4078),
    [anon_sym_new] = ACTIONS(4078),
    [anon_sym_requires] = ACTIONS(4078),
    [sym_this] = ACTIONS(4078),
    [anon_sym_discard] = ACTIONS(4078),
    [anon_sym_precise] = ACTIONS(4078),
    [anon_sym_shared] = ACTIONS(4078),
    [anon_sym_groupshared] = ACTIONS(4078),
    [anon_sym_uniform] = ACTIONS(4078),
    [anon_sym_row_major] = ACTIONS(4078),
    [anon_sym_column_major] = ACTIONS(4078),
    [anon_sym_globallycoherent] = ACTIONS(4078),
    [anon_sym_centroid] = ACTIONS(4078),
    [anon_sym_noperspective] = ACTIONS(4078),
    [anon_sym_nointerpolation] = ACTIONS(4078),
    [anon_sym_sample] = ACTIONS(4078),
    [anon_sym_linear] = ACTIONS(4078),
    [anon_sym_snorm] = ACTIONS(4078),
    [anon_sym_unorm] = ACTIONS(4078),
    [anon_sym_point] = ACTIONS(4078),
    [anon_sym_line] = ACTIONS(4078),
    [anon_sym_triangleadj] = ACTIONS(4078),
    [anon_sym_lineadj] = ACTIONS(4078),
    [anon_sym_triangle] = ACTIONS(4078),
    [anon_sym_cbuffer] = ACTIONS(4078),
    [anon_sym_interface] = ACTIONS(4078),
    [anon_sym_extension] = ACTIONS(4078),
  },
  [663] = {
    [sym_attribute_specifier] = STATE(316),
    [ts_builtin_sym_end] = ACTIONS(4085),
    [sym_identifier] = ACTIONS(4087),
    [aux_sym_preproc_include_token1] = ACTIONS(4087),
    [aux_sym_preproc_def_token1] = ACTIONS(4087),
    [aux_sym_preproc_if_token1] = ACTIONS(4087),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4087),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4087),
    [sym_preproc_directive] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4085),
    [anon_sym_BANG] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4087),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4087),
    [anon_sym_SEMI] = ACTIONS(4085),
    [anon_sym___extension__] = ACTIONS(4087),
    [anon_sym_typedef] = ACTIONS(4087),
    [anon_sym_in] = ACTIONS(4087),
    [anon_sym_out] = ACTIONS(4087),
    [anon_sym_inout] = ACTIONS(4087),
    [anon_sym_virtual] = ACTIONS(4087),
    [anon_sym_extern] = ACTIONS(4087),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(4087),
    [anon_sym_COLON_COLON] = ACTIONS(4085),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4085),
    [anon_sym___declspec] = ACTIONS(4087),
    [anon_sym___based] = ACTIONS(4087),
    [anon_sym___cdecl] = ACTIONS(4087),
    [anon_sym___clrcall] = ACTIONS(4087),
    [anon_sym___stdcall] = ACTIONS(4087),
    [anon_sym___fastcall] = ACTIONS(4087),
    [anon_sym___thiscall] = ACTIONS(4087),
    [anon_sym___vectorcall] = ACTIONS(4087),
    [anon_sym_LBRACE] = ACTIONS(4085),
    [anon_sym_signed] = ACTIONS(4087),
    [anon_sym_unsigned] = ACTIONS(4087),
    [anon_sym_long] = ACTIONS(4087),
    [anon_sym_short] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(4087),
    [anon_sym_static] = ACTIONS(4087),
    [anon_sym_register] = ACTIONS(4087),
    [anon_sym_inline] = ACTIONS(4087),
    [anon_sym___inline] = ACTIONS(4087),
    [anon_sym___inline__] = ACTIONS(4087),
    [anon_sym___forceinline] = ACTIONS(4087),
    [anon_sym_thread_local] = ACTIONS(4087),
    [anon_sym___thread] = ACTIONS(4087),
    [anon_sym_const] = ACTIONS(4087),
    [anon_sym_constexpr] = ACTIONS(4087),
    [anon_sym_volatile] = ACTIONS(4087),
    [anon_sym_restrict] = ACTIONS(4087),
    [anon_sym___restrict__] = ACTIONS(4087),
    [anon_sym__Atomic] = ACTIONS(4087),
    [anon_sym__Noreturn] = ACTIONS(4087),
    [anon_sym_noreturn] = ACTIONS(4087),
    [anon_sym__Nonnull] = ACTIONS(4087),
    [anon_sym_mutable] = ACTIONS(4087),
    [anon_sym_constinit] = ACTIONS(4087),
    [anon_sym_consteval] = ACTIONS(4087),
    [anon_sym_alignas] = ACTIONS(4087),
    [anon_sym__Alignas] = ACTIONS(4087),
    [sym_primitive_type] = ACTIONS(4087),
    [anon_sym_enum] = ACTIONS(4087),
    [anon_sym_class] = ACTIONS(4087),
    [anon_sym_struct] = ACTIONS(4087),
    [anon_sym_union] = ACTIONS(4087),
    [anon_sym_if] = ACTIONS(4087),
    [anon_sym_switch] = ACTIONS(4087),
    [anon_sym_case] = ACTIONS(4087),
    [anon_sym_default] = ACTIONS(4087),
    [anon_sym_while] = ACTIONS(4087),
    [anon_sym_do] = ACTIONS(4087),
    [anon_sym_for] = ACTIONS(4087),
    [anon_sym_return] = ACTIONS(4087),
    [anon_sym_break] = ACTIONS(4087),
    [anon_sym_continue] = ACTIONS(4087),
    [anon_sym_goto] = ACTIONS(4087),
    [anon_sym_not] = ACTIONS(4087),
    [anon_sym_compl] = ACTIONS(4087),
    [anon_sym_DASH_DASH] = ACTIONS(4085),
    [anon_sym_PLUS_PLUS] = ACTIONS(4085),
    [anon_sym_sizeof] = ACTIONS(4087),
    [anon_sym___alignof__] = ACTIONS(4087),
    [anon_sym___alignof] = ACTIONS(4087),
    [anon_sym__alignof] = ACTIONS(4087),
    [anon_sym_alignof] = ACTIONS(4087),
    [anon_sym__Alignof] = ACTIONS(4087),
    [anon_sym_offsetof] = ACTIONS(4087),
    [anon_sym__Generic] = ACTIONS(4087),
    [anon_sym_asm] = ACTIONS(4087),
    [anon_sym___asm__] = ACTIONS(4087),
    [anon_sym___asm] = ACTIONS(4087),
    [anon_sym_DOT] = ACTIONS(4087),
    [sym_number_literal] = ACTIONS(4085),
    [anon_sym_L_SQUOTE] = ACTIONS(4085),
    [anon_sym_u_SQUOTE] = ACTIONS(4085),
    [anon_sym_U_SQUOTE] = ACTIONS(4085),
    [anon_sym_u8_SQUOTE] = ACTIONS(4085),
    [anon_sym_SQUOTE] = ACTIONS(4085),
    [anon_sym_L_DQUOTE] = ACTIONS(4085),
    [anon_sym_u_DQUOTE] = ACTIONS(4085),
    [anon_sym_U_DQUOTE] = ACTIONS(4085),
    [anon_sym_u8_DQUOTE] = ACTIONS(4085),
    [anon_sym_DQUOTE] = ACTIONS(4085),
    [sym_true] = ACTIONS(4087),
    [sym_false] = ACTIONS(4087),
    [anon_sym_NULL] = ACTIONS(4087),
    [anon_sym_nullptr] = ACTIONS(4087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4087),
    [anon_sym_let] = ACTIONS(4087),
    [anon_sym_This] = ACTIONS(4087),
    [anon_sym_decltype] = ACTIONS(4087),
    [anon_sym_explicit] = ACTIONS(4087),
    [anon_sym_typename] = ACTIONS(4087),
    [anon_sym_export] = ACTIONS(4087),
    [anon_sym_module] = ACTIONS(4087),
    [anon_sym_import] = ACTIONS(4087),
    [anon_sym_template] = ACTIONS(4087),
    [anon_sym_operator] = ACTIONS(4087),
    [anon_sym_try] = ACTIONS(4087),
    [anon_sym_delete] = ACTIONS(4087),
    [anon_sym_throw] = ACTIONS(4087),
    [anon_sym_namespace] = ACTIONS(4087),
    [anon_sym_static_assert] = ACTIONS(4087),
    [anon_sym_concept] = ACTIONS(4087),
    [anon_sym_co_return] = ACTIONS(4087),
    [anon_sym_co_yield] = ACTIONS(4087),
    [anon_sym_R_DQUOTE] = ACTIONS(4085),
    [anon_sym_LR_DQUOTE] = ACTIONS(4085),
    [anon_sym_uR_DQUOTE] = ACTIONS(4085),
    [anon_sym_UR_DQUOTE] = ACTIONS(4085),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4085),
    [anon_sym_co_await] = ACTIONS(4087),
    [anon_sym_new] = ACTIONS(4087),
    [anon_sym_requires] = ACTIONS(4087),
    [sym_this] = ACTIONS(4087),
    [anon_sym_precise] = ACTIONS(4087),
    [anon_sym_shared] = ACTIONS(4087),
    [anon_sym_groupshared] = ACTIONS(4087),
    [anon_sym_uniform] = ACTIONS(4087),
    [anon_sym_row_major] = ACTIONS(4087),
    [anon_sym_column_major] = ACTIONS(4087),
    [anon_sym_globallycoherent] = ACTIONS(4087),
    [anon_sym_centroid] = ACTIONS(4087),
    [anon_sym_noperspective] = ACTIONS(4087),
    [anon_sym_nointerpolation] = ACTIONS(4087),
    [anon_sym_sample] = ACTIONS(4087),
    [anon_sym_linear] = ACTIONS(4087),
    [anon_sym_snorm] = ACTIONS(4087),
    [anon_sym_unorm] = ACTIONS(4087),
    [anon_sym_point] = ACTIONS(4087),
    [anon_sym_line] = ACTIONS(4087),
    [anon_sym_triangleadj] = ACTIONS(4087),
    [anon_sym_lineadj] = ACTIONS(4087),
    [anon_sym_triangle] = ACTIONS(4087),
    [anon_sym_interface] = ACTIONS(4087),
    [anon_sym_extension] = ACTIONS(4087),
    [anon_sym___exported] = ACTIONS(4087),
  },
  [664] = {
    [sym_attribute_specifier] = STATE(323),
    [ts_builtin_sym_end] = ACTIONS(4089),
    [sym_identifier] = ACTIONS(4091),
    [aux_sym_preproc_include_token1] = ACTIONS(4091),
    [aux_sym_preproc_def_token1] = ACTIONS(4091),
    [aux_sym_preproc_if_token1] = ACTIONS(4091),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4091),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4091),
    [sym_preproc_directive] = ACTIONS(4091),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4089),
    [anon_sym_TILDE] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4091),
    [anon_sym_PLUS] = ACTIONS(4091),
    [anon_sym_STAR] = ACTIONS(4089),
    [anon_sym_AMP_AMP] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4091),
    [anon_sym_SEMI] = ACTIONS(4089),
    [anon_sym___extension__] = ACTIONS(4091),
    [anon_sym_typedef] = ACTIONS(4091),
    [anon_sym_in] = ACTIONS(4091),
    [anon_sym_out] = ACTIONS(4091),
    [anon_sym_inout] = ACTIONS(4091),
    [anon_sym_virtual] = ACTIONS(4091),
    [anon_sym_extern] = ACTIONS(4091),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(4091),
    [anon_sym_COLON_COLON] = ACTIONS(4089),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4089),
    [anon_sym___declspec] = ACTIONS(4091),
    [anon_sym___based] = ACTIONS(4091),
    [anon_sym___cdecl] = ACTIONS(4091),
    [anon_sym___clrcall] = ACTIONS(4091),
    [anon_sym___stdcall] = ACTIONS(4091),
    [anon_sym___fastcall] = ACTIONS(4091),
    [anon_sym___thiscall] = ACTIONS(4091),
    [anon_sym___vectorcall] = ACTIONS(4091),
    [anon_sym_LBRACE] = ACTIONS(4089),
    [anon_sym_signed] = ACTIONS(4091),
    [anon_sym_unsigned] = ACTIONS(4091),
    [anon_sym_long] = ACTIONS(4091),
    [anon_sym_short] = ACTIONS(4091),
    [anon_sym_LBRACK] = ACTIONS(4091),
    [anon_sym_static] = ACTIONS(4091),
    [anon_sym_register] = ACTIONS(4091),
    [anon_sym_inline] = ACTIONS(4091),
    [anon_sym___inline] = ACTIONS(4091),
    [anon_sym___inline__] = ACTIONS(4091),
    [anon_sym___forceinline] = ACTIONS(4091),
    [anon_sym_thread_local] = ACTIONS(4091),
    [anon_sym___thread] = ACTIONS(4091),
    [anon_sym_const] = ACTIONS(4091),
    [anon_sym_constexpr] = ACTIONS(4091),
    [anon_sym_volatile] = ACTIONS(4091),
    [anon_sym_restrict] = ACTIONS(4091),
    [anon_sym___restrict__] = ACTIONS(4091),
    [anon_sym__Atomic] = ACTIONS(4091),
    [anon_sym__Noreturn] = ACTIONS(4091),
    [anon_sym_noreturn] = ACTIONS(4091),
    [anon_sym__Nonnull] = ACTIONS(4091),
    [anon_sym_mutable] = ACTIONS(4091),
    [anon_sym_constinit] = ACTIONS(4091),
    [anon_sym_consteval] = ACTIONS(4091),
    [anon_sym_alignas] = ACTIONS(4091),
    [anon_sym__Alignas] = ACTIONS(4091),
    [sym_primitive_type] = ACTIONS(4091),
    [anon_sym_enum] = ACTIONS(4091),
    [anon_sym_class] = ACTIONS(4091),
    [anon_sym_struct] = ACTIONS(4091),
    [anon_sym_union] = ACTIONS(4091),
    [anon_sym_if] = ACTIONS(4091),
    [anon_sym_switch] = ACTIONS(4091),
    [anon_sym_case] = ACTIONS(4091),
    [anon_sym_default] = ACTIONS(4091),
    [anon_sym_while] = ACTIONS(4091),
    [anon_sym_do] = ACTIONS(4091),
    [anon_sym_for] = ACTIONS(4091),
    [anon_sym_return] = ACTIONS(4091),
    [anon_sym_break] = ACTIONS(4091),
    [anon_sym_continue] = ACTIONS(4091),
    [anon_sym_goto] = ACTIONS(4091),
    [anon_sym_not] = ACTIONS(4091),
    [anon_sym_compl] = ACTIONS(4091),
    [anon_sym_DASH_DASH] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(4089),
    [anon_sym_sizeof] = ACTIONS(4091),
    [anon_sym___alignof__] = ACTIONS(4091),
    [anon_sym___alignof] = ACTIONS(4091),
    [anon_sym__alignof] = ACTIONS(4091),
    [anon_sym_alignof] = ACTIONS(4091),
    [anon_sym__Alignof] = ACTIONS(4091),
    [anon_sym_offsetof] = ACTIONS(4091),
    [anon_sym__Generic] = ACTIONS(4091),
    [anon_sym_asm] = ACTIONS(4091),
    [anon_sym___asm__] = ACTIONS(4091),
    [anon_sym___asm] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(4091),
    [sym_number_literal] = ACTIONS(4089),
    [anon_sym_L_SQUOTE] = ACTIONS(4089),
    [anon_sym_u_SQUOTE] = ACTIONS(4089),
    [anon_sym_U_SQUOTE] = ACTIONS(4089),
    [anon_sym_u8_SQUOTE] = ACTIONS(4089),
    [anon_sym_SQUOTE] = ACTIONS(4089),
    [anon_sym_L_DQUOTE] = ACTIONS(4089),
    [anon_sym_u_DQUOTE] = ACTIONS(4089),
    [anon_sym_U_DQUOTE] = ACTIONS(4089),
    [anon_sym_u8_DQUOTE] = ACTIONS(4089),
    [anon_sym_DQUOTE] = ACTIONS(4089),
    [sym_true] = ACTIONS(4091),
    [sym_false] = ACTIONS(4091),
    [anon_sym_NULL] = ACTIONS(4091),
    [anon_sym_nullptr] = ACTIONS(4091),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4091),
    [anon_sym_let] = ACTIONS(4091),
    [anon_sym_This] = ACTIONS(4091),
    [anon_sym_decltype] = ACTIONS(4091),
    [anon_sym_explicit] = ACTIONS(4091),
    [anon_sym_typename] = ACTIONS(4091),
    [anon_sym_export] = ACTIONS(4091),
    [anon_sym_module] = ACTIONS(4091),
    [anon_sym_import] = ACTIONS(4091),
    [anon_sym_template] = ACTIONS(4091),
    [anon_sym_operator] = ACTIONS(4091),
    [anon_sym_try] = ACTIONS(4091),
    [anon_sym_delete] = ACTIONS(4091),
    [anon_sym_throw] = ACTIONS(4091),
    [anon_sym_namespace] = ACTIONS(4091),
    [anon_sym_static_assert] = ACTIONS(4091),
    [anon_sym_concept] = ACTIONS(4091),
    [anon_sym_co_return] = ACTIONS(4091),
    [anon_sym_co_yield] = ACTIONS(4091),
    [anon_sym_R_DQUOTE] = ACTIONS(4089),
    [anon_sym_LR_DQUOTE] = ACTIONS(4089),
    [anon_sym_uR_DQUOTE] = ACTIONS(4089),
    [anon_sym_UR_DQUOTE] = ACTIONS(4089),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4089),
    [anon_sym_co_await] = ACTIONS(4091),
    [anon_sym_new] = ACTIONS(4091),
    [anon_sym_requires] = ACTIONS(4091),
    [sym_this] = ACTIONS(4091),
    [anon_sym_precise] = ACTIONS(4091),
    [anon_sym_shared] = ACTIONS(4091),
    [anon_sym_groupshared] = ACTIONS(4091),
    [anon_sym_uniform] = ACTIONS(4091),
    [anon_sym_row_major] = ACTIONS(4091),
    [anon_sym_column_major] = ACTIONS(4091),
    [anon_sym_globallycoherent] = ACTIONS(4091),
    [anon_sym_centroid] = ACTIONS(4091),
    [anon_sym_noperspective] = ACTIONS(4091),
    [anon_sym_nointerpolation] = ACTIONS(4091),
    [anon_sym_sample] = ACTIONS(4091),
    [anon_sym_linear] = ACTIONS(4091),
    [anon_sym_snorm] = ACTIONS(4091),
    [anon_sym_unorm] = ACTIONS(4091),
    [anon_sym_point] = ACTIONS(4091),
    [anon_sym_line] = ACTIONS(4091),
    [anon_sym_triangleadj] = ACTIONS(4091),
    [anon_sym_lineadj] = ACTIONS(4091),
    [anon_sym_triangle] = ACTIONS(4091),
    [anon_sym_interface] = ACTIONS(4091),
    [anon_sym_extension] = ACTIONS(4091),
    [anon_sym___exported] = ACTIONS(4091),
  },
  [665] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(672),
    [sym_identifier] = ACTIONS(4093),
    [aux_sym_preproc_include_token1] = ACTIONS(4093),
    [aux_sym_preproc_def_token1] = ACTIONS(4093),
    [aux_sym_preproc_if_token1] = ACTIONS(4093),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4093),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4093),
    [sym_preproc_directive] = ACTIONS(4093),
    [anon_sym_LPAREN2] = ACTIONS(4095),
    [anon_sym_BANG] = ACTIONS(4095),
    [anon_sym_TILDE] = ACTIONS(4095),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP_AMP] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_SEMI] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4093),
    [anon_sym_typedef] = ACTIONS(4093),
    [anon_sym_in] = ACTIONS(4093),
    [anon_sym_out] = ACTIONS(4093),
    [anon_sym_inout] = ACTIONS(4093),
    [anon_sym_virtual] = ACTIONS(4093),
    [anon_sym_extern] = ACTIONS(4093),
    [anon_sym___attribute__] = ACTIONS(4093),
    [anon_sym___attribute] = ACTIONS(4093),
    [anon_sym_using] = ACTIONS(4093),
    [anon_sym_COLON_COLON] = ACTIONS(4095),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4095),
    [anon_sym___declspec] = ACTIONS(4093),
    [anon_sym___based] = ACTIONS(4093),
    [anon_sym___cdecl] = ACTIONS(4093),
    [anon_sym___clrcall] = ACTIONS(4093),
    [anon_sym___stdcall] = ACTIONS(4093),
    [anon_sym___fastcall] = ACTIONS(4093),
    [anon_sym___thiscall] = ACTIONS(4093),
    [anon_sym___vectorcall] = ACTIONS(4093),
    [anon_sym_LBRACE] = ACTIONS(4095),
    [anon_sym_RBRACE] = ACTIONS(4095),
    [anon_sym_signed] = ACTIONS(4097),
    [anon_sym_unsigned] = ACTIONS(4097),
    [anon_sym_long] = ACTIONS(4097),
    [anon_sym_short] = ACTIONS(4097),
    [anon_sym_LBRACK] = ACTIONS(4093),
    [anon_sym_static] = ACTIONS(4093),
    [anon_sym_register] = ACTIONS(4093),
    [anon_sym_inline] = ACTIONS(4093),
    [anon_sym___inline] = ACTIONS(4093),
    [anon_sym___inline__] = ACTIONS(4093),
    [anon_sym___forceinline] = ACTIONS(4093),
    [anon_sym_thread_local] = ACTIONS(4093),
    [anon_sym___thread] = ACTIONS(4093),
    [anon_sym_const] = ACTIONS(4093),
    [anon_sym_constexpr] = ACTIONS(4093),
    [anon_sym_volatile] = ACTIONS(4093),
    [anon_sym_restrict] = ACTIONS(4093),
    [anon_sym___restrict__] = ACTIONS(4093),
    [anon_sym__Atomic] = ACTIONS(4093),
    [anon_sym__Noreturn] = ACTIONS(4093),
    [anon_sym_noreturn] = ACTIONS(4093),
    [anon_sym__Nonnull] = ACTIONS(4093),
    [anon_sym_mutable] = ACTIONS(4093),
    [anon_sym_constinit] = ACTIONS(4093),
    [anon_sym_consteval] = ACTIONS(4093),
    [anon_sym_alignas] = ACTIONS(4093),
    [anon_sym__Alignas] = ACTIONS(4093),
    [sym_primitive_type] = ACTIONS(4093),
    [anon_sym_enum] = ACTIONS(4093),
    [anon_sym_class] = ACTIONS(4093),
    [anon_sym_struct] = ACTIONS(4093),
    [anon_sym_union] = ACTIONS(4093),
    [anon_sym_if] = ACTIONS(4093),
    [anon_sym_switch] = ACTIONS(4093),
    [anon_sym_case] = ACTIONS(4093),
    [anon_sym_default] = ACTIONS(4093),
    [anon_sym_while] = ACTIONS(4093),
    [anon_sym_do] = ACTIONS(4093),
    [anon_sym_for] = ACTIONS(4093),
    [anon_sym_return] = ACTIONS(4093),
    [anon_sym_break] = ACTIONS(4093),
    [anon_sym_continue] = ACTIONS(4093),
    [anon_sym_goto] = ACTIONS(4093),
    [anon_sym___try] = ACTIONS(4093),
    [anon_sym___leave] = ACTIONS(4093),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4095),
    [anon_sym_PLUS_PLUS] = ACTIONS(4095),
    [anon_sym_sizeof] = ACTIONS(4093),
    [anon_sym___alignof__] = ACTIONS(4093),
    [anon_sym___alignof] = ACTIONS(4093),
    [anon_sym__alignof] = ACTIONS(4093),
    [anon_sym_alignof] = ACTIONS(4093),
    [anon_sym__Alignof] = ACTIONS(4093),
    [anon_sym_offsetof] = ACTIONS(4093),
    [anon_sym__Generic] = ACTIONS(4093),
    [anon_sym_asm] = ACTIONS(4093),
    [anon_sym___asm__] = ACTIONS(4093),
    [anon_sym___asm] = ACTIONS(4093),
    [anon_sym_DOT] = ACTIONS(4093),
    [sym_number_literal] = ACTIONS(4095),
    [anon_sym_L_SQUOTE] = ACTIONS(4095),
    [anon_sym_u_SQUOTE] = ACTIONS(4095),
    [anon_sym_U_SQUOTE] = ACTIONS(4095),
    [anon_sym_u8_SQUOTE] = ACTIONS(4095),
    [anon_sym_SQUOTE] = ACTIONS(4095),
    [anon_sym_L_DQUOTE] = ACTIONS(4095),
    [anon_sym_u_DQUOTE] = ACTIONS(4095),
    [anon_sym_U_DQUOTE] = ACTIONS(4095),
    [anon_sym_u8_DQUOTE] = ACTIONS(4095),
    [anon_sym_DQUOTE] = ACTIONS(4095),
    [sym_true] = ACTIONS(4093),
    [sym_false] = ACTIONS(4093),
    [anon_sym_NULL] = ACTIONS(4093),
    [anon_sym_nullptr] = ACTIONS(4093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4093),
    [anon_sym_let] = ACTIONS(4093),
    [anon_sym_This] = ACTIONS(4093),
    [anon_sym_decltype] = ACTIONS(4093),
    [anon_sym_explicit] = ACTIONS(4093),
    [anon_sym_typename] = ACTIONS(4093),
    [anon_sym_template] = ACTIONS(4093),
    [anon_sym_operator] = ACTIONS(4093),
    [anon_sym_try] = ACTIONS(4093),
    [anon_sym_delete] = ACTIONS(4093),
    [anon_sym_throw] = ACTIONS(4093),
    [anon_sym_namespace] = ACTIONS(4093),
    [anon_sym_static_assert] = ACTIONS(4093),
    [anon_sym_concept] = ACTIONS(4093),
    [anon_sym_co_return] = ACTIONS(4093),
    [anon_sym_co_yield] = ACTIONS(4093),
    [anon_sym_R_DQUOTE] = ACTIONS(4095),
    [anon_sym_LR_DQUOTE] = ACTIONS(4095),
    [anon_sym_uR_DQUOTE] = ACTIONS(4095),
    [anon_sym_UR_DQUOTE] = ACTIONS(4095),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4095),
    [anon_sym_co_await] = ACTIONS(4093),
    [anon_sym_new] = ACTIONS(4093),
    [anon_sym_requires] = ACTIONS(4093),
    [sym_this] = ACTIONS(4093),
    [anon_sym_discard] = ACTIONS(4093),
    [anon_sym_precise] = ACTIONS(4093),
    [anon_sym_shared] = ACTIONS(4093),
    [anon_sym_groupshared] = ACTIONS(4093),
    [anon_sym_uniform] = ACTIONS(4093),
    [anon_sym_row_major] = ACTIONS(4093),
    [anon_sym_column_major] = ACTIONS(4093),
    [anon_sym_globallycoherent] = ACTIONS(4093),
    [anon_sym_centroid] = ACTIONS(4093),
    [anon_sym_noperspective] = ACTIONS(4093),
    [anon_sym_nointerpolation] = ACTIONS(4093),
    [anon_sym_sample] = ACTIONS(4093),
    [anon_sym_linear] = ACTIONS(4093),
    [anon_sym_snorm] = ACTIONS(4093),
    [anon_sym_unorm] = ACTIONS(4093),
    [anon_sym_point] = ACTIONS(4093),
    [anon_sym_line] = ACTIONS(4093),
    [anon_sym_triangleadj] = ACTIONS(4093),
    [anon_sym_lineadj] = ACTIONS(4093),
    [anon_sym_triangle] = ACTIONS(4093),
    [anon_sym_cbuffer] = ACTIONS(4093),
    [anon_sym_interface] = ACTIONS(4093),
    [anon_sym_extension] = ACTIONS(4093),
  },
  [666] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(284),
    [ts_builtin_sym_end] = ACTIONS(4100),
    [sym_identifier] = ACTIONS(4102),
    [aux_sym_preproc_include_token1] = ACTIONS(4102),
    [aux_sym_preproc_def_token1] = ACTIONS(4102),
    [aux_sym_preproc_if_token1] = ACTIONS(4102),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4102),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4102),
    [sym_preproc_directive] = ACTIONS(4102),
    [anon_sym_LPAREN2] = ACTIONS(4100),
    [anon_sym_BANG] = ACTIONS(4100),
    [anon_sym_TILDE] = ACTIONS(4100),
    [anon_sym_DASH] = ACTIONS(4102),
    [anon_sym_PLUS] = ACTIONS(4102),
    [anon_sym_STAR] = ACTIONS(4100),
    [anon_sym_AMP_AMP] = ACTIONS(4100),
    [anon_sym_AMP] = ACTIONS(4102),
    [anon_sym_SEMI] = ACTIONS(4100),
    [anon_sym___extension__] = ACTIONS(4102),
    [anon_sym_typedef] = ACTIONS(4102),
    [anon_sym_in] = ACTIONS(4102),
    [anon_sym_out] = ACTIONS(4102),
    [anon_sym_inout] = ACTIONS(4102),
    [anon_sym_virtual] = ACTIONS(4102),
    [anon_sym_extern] = ACTIONS(4102),
    [anon_sym___attribute__] = ACTIONS(4102),
    [anon_sym___attribute] = ACTIONS(4102),
    [anon_sym_using] = ACTIONS(4102),
    [anon_sym_COLON_COLON] = ACTIONS(4100),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4100),
    [anon_sym___declspec] = ACTIONS(4102),
    [anon_sym___based] = ACTIONS(4102),
    [anon_sym___cdecl] = ACTIONS(4102),
    [anon_sym___clrcall] = ACTIONS(4102),
    [anon_sym___stdcall] = ACTIONS(4102),
    [anon_sym___fastcall] = ACTIONS(4102),
    [anon_sym___thiscall] = ACTIONS(4102),
    [anon_sym___vectorcall] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(4100),
    [anon_sym_signed] = ACTIONS(4104),
    [anon_sym_unsigned] = ACTIONS(4104),
    [anon_sym_long] = ACTIONS(4104),
    [anon_sym_short] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4102),
    [anon_sym_static] = ACTIONS(4102),
    [anon_sym_register] = ACTIONS(4102),
    [anon_sym_inline] = ACTIONS(4102),
    [anon_sym___inline] = ACTIONS(4102),
    [anon_sym___inline__] = ACTIONS(4102),
    [anon_sym___forceinline] = ACTIONS(4102),
    [anon_sym_thread_local] = ACTIONS(4102),
    [anon_sym___thread] = ACTIONS(4102),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_constexpr] = ACTIONS(4102),
    [anon_sym_volatile] = ACTIONS(4102),
    [anon_sym_restrict] = ACTIONS(4102),
    [anon_sym___restrict__] = ACTIONS(4102),
    [anon_sym__Atomic] = ACTIONS(4102),
    [anon_sym__Noreturn] = ACTIONS(4102),
    [anon_sym_noreturn] = ACTIONS(4102),
    [anon_sym__Nonnull] = ACTIONS(4102),
    [anon_sym_mutable] = ACTIONS(4102),
    [anon_sym_constinit] = ACTIONS(4102),
    [anon_sym_consteval] = ACTIONS(4102),
    [anon_sym_alignas] = ACTIONS(4102),
    [anon_sym__Alignas] = ACTIONS(4102),
    [sym_primitive_type] = ACTIONS(4102),
    [anon_sym_enum] = ACTIONS(4102),
    [anon_sym_class] = ACTIONS(4102),
    [anon_sym_struct] = ACTIONS(4102),
    [anon_sym_union] = ACTIONS(4102),
    [anon_sym_if] = ACTIONS(4102),
    [anon_sym_switch] = ACTIONS(4102),
    [anon_sym_case] = ACTIONS(4102),
    [anon_sym_default] = ACTIONS(4102),
    [anon_sym_while] = ACTIONS(4102),
    [anon_sym_do] = ACTIONS(4102),
    [anon_sym_for] = ACTIONS(4102),
    [anon_sym_return] = ACTIONS(4102),
    [anon_sym_break] = ACTIONS(4102),
    [anon_sym_continue] = ACTIONS(4102),
    [anon_sym_goto] = ACTIONS(4102),
    [anon_sym_not] = ACTIONS(4102),
    [anon_sym_compl] = ACTIONS(4102),
    [anon_sym_DASH_DASH] = ACTIONS(4100),
    [anon_sym_PLUS_PLUS] = ACTIONS(4100),
    [anon_sym_sizeof] = ACTIONS(4102),
    [anon_sym___alignof__] = ACTIONS(4102),
    [anon_sym___alignof] = ACTIONS(4102),
    [anon_sym__alignof] = ACTIONS(4102),
    [anon_sym_alignof] = ACTIONS(4102),
    [anon_sym__Alignof] = ACTIONS(4102),
    [anon_sym_offsetof] = ACTIONS(4102),
    [anon_sym__Generic] = ACTIONS(4102),
    [anon_sym_asm] = ACTIONS(4102),
    [anon_sym___asm__] = ACTIONS(4102),
    [anon_sym___asm] = ACTIONS(4102),
    [anon_sym_DOT] = ACTIONS(4102),
    [sym_number_literal] = ACTIONS(4100),
    [anon_sym_L_SQUOTE] = ACTIONS(4100),
    [anon_sym_u_SQUOTE] = ACTIONS(4100),
    [anon_sym_U_SQUOTE] = ACTIONS(4100),
    [anon_sym_u8_SQUOTE] = ACTIONS(4100),
    [anon_sym_SQUOTE] = ACTIONS(4100),
    [anon_sym_L_DQUOTE] = ACTIONS(4100),
    [anon_sym_u_DQUOTE] = ACTIONS(4100),
    [anon_sym_U_DQUOTE] = ACTIONS(4100),
    [anon_sym_u8_DQUOTE] = ACTIONS(4100),
    [anon_sym_DQUOTE] = ACTIONS(4100),
    [sym_true] = ACTIONS(4102),
    [sym_false] = ACTIONS(4102),
    [anon_sym_NULL] = ACTIONS(4102),
    [anon_sym_nullptr] = ACTIONS(4102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4102),
    [anon_sym_let] = ACTIONS(4102),
    [anon_sym_This] = ACTIONS(4102),
    [anon_sym_decltype] = ACTIONS(4102),
    [anon_sym_explicit] = ACTIONS(4102),
    [anon_sym_typename] = ACTIONS(4102),
    [anon_sym_export] = ACTIONS(4102),
    [anon_sym_module] = ACTIONS(4102),
    [anon_sym_import] = ACTIONS(4102),
    [anon_sym_template] = ACTIONS(4102),
    [anon_sym_operator] = ACTIONS(4102),
    [anon_sym_try] = ACTIONS(4102),
    [anon_sym_delete] = ACTIONS(4102),
    [anon_sym_throw] = ACTIONS(4102),
    [anon_sym_namespace] = ACTIONS(4102),
    [anon_sym_static_assert] = ACTIONS(4102),
    [anon_sym_concept] = ACTIONS(4102),
    [anon_sym_co_return] = ACTIONS(4102),
    [anon_sym_co_yield] = ACTIONS(4102),
    [anon_sym_R_DQUOTE] = ACTIONS(4100),
    [anon_sym_LR_DQUOTE] = ACTIONS(4100),
    [anon_sym_uR_DQUOTE] = ACTIONS(4100),
    [anon_sym_UR_DQUOTE] = ACTIONS(4100),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4100),
    [anon_sym_co_await] = ACTIONS(4102),
    [anon_sym_new] = ACTIONS(4102),
    [anon_sym_requires] = ACTIONS(4102),
    [sym_this] = ACTIONS(4102),
    [anon_sym_precise] = ACTIONS(4102),
    [anon_sym_shared] = ACTIONS(4102),
    [anon_sym_groupshared] = ACTIONS(4102),
    [anon_sym_uniform] = ACTIONS(4102),
    [anon_sym_row_major] = ACTIONS(4102),
    [anon_sym_column_major] = ACTIONS(4102),
    [anon_sym_globallycoherent] = ACTIONS(4102),
    [anon_sym_centroid] = ACTIONS(4102),
    [anon_sym_noperspective] = ACTIONS(4102),
    [anon_sym_nointerpolation] = ACTIONS(4102),
    [anon_sym_sample] = ACTIONS(4102),
    [anon_sym_linear] = ACTIONS(4102),
    [anon_sym_snorm] = ACTIONS(4102),
    [anon_sym_unorm] = ACTIONS(4102),
    [anon_sym_point] = ACTIONS(4102),
    [anon_sym_line] = ACTIONS(4102),
    [anon_sym_triangleadj] = ACTIONS(4102),
    [anon_sym_lineadj] = ACTIONS(4102),
    [anon_sym_triangle] = ACTIONS(4102),
    [anon_sym_interface] = ACTIONS(4102),
    [anon_sym_extension] = ACTIONS(4102),
    [anon_sym___exported] = ACTIONS(4102),
  },
  [667] = {
    [sym_attribute_specifier] = STATE(780),
    [sym_identifier] = ACTIONS(4107),
    [aux_sym_preproc_include_token1] = ACTIONS(4107),
    [aux_sym_preproc_def_token1] = ACTIONS(4107),
    [aux_sym_preproc_if_token1] = ACTIONS(4107),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4107),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4107),
    [sym_preproc_directive] = ACTIONS(4107),
    [anon_sym_LPAREN2] = ACTIONS(4109),
    [anon_sym_BANG] = ACTIONS(4109),
    [anon_sym_TILDE] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4107),
    [anon_sym_STAR] = ACTIONS(4109),
    [anon_sym_AMP_AMP] = ACTIONS(4109),
    [anon_sym_AMP] = ACTIONS(4107),
    [anon_sym_SEMI] = ACTIONS(4109),
    [anon_sym___extension__] = ACTIONS(4107),
    [anon_sym_typedef] = ACTIONS(4107),
    [anon_sym_in] = ACTIONS(4107),
    [anon_sym_out] = ACTIONS(4107),
    [anon_sym_inout] = ACTIONS(4107),
    [anon_sym_virtual] = ACTIONS(4107),
    [anon_sym_extern] = ACTIONS(4107),
    [anon_sym___attribute__] = ACTIONS(2897),
    [anon_sym___attribute] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(4107),
    [anon_sym_COLON_COLON] = ACTIONS(4109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4109),
    [anon_sym___declspec] = ACTIONS(4107),
    [anon_sym___based] = ACTIONS(4107),
    [anon_sym___cdecl] = ACTIONS(4107),
    [anon_sym___clrcall] = ACTIONS(4107),
    [anon_sym___stdcall] = ACTIONS(4107),
    [anon_sym___fastcall] = ACTIONS(4107),
    [anon_sym___thiscall] = ACTIONS(4107),
    [anon_sym___vectorcall] = ACTIONS(4107),
    [anon_sym_LBRACE] = ACTIONS(4109),
    [anon_sym_RBRACE] = ACTIONS(4109),
    [anon_sym_signed] = ACTIONS(4107),
    [anon_sym_unsigned] = ACTIONS(4107),
    [anon_sym_long] = ACTIONS(4107),
    [anon_sym_short] = ACTIONS(4107),
    [anon_sym_LBRACK] = ACTIONS(4107),
    [anon_sym_static] = ACTIONS(4107),
    [anon_sym_register] = ACTIONS(4107),
    [anon_sym_inline] = ACTIONS(4107),
    [anon_sym___inline] = ACTIONS(4107),
    [anon_sym___inline__] = ACTIONS(4107),
    [anon_sym___forceinline] = ACTIONS(4107),
    [anon_sym_thread_local] = ACTIONS(4107),
    [anon_sym___thread] = ACTIONS(4107),
    [anon_sym_const] = ACTIONS(4107),
    [anon_sym_constexpr] = ACTIONS(4107),
    [anon_sym_volatile] = ACTIONS(4107),
    [anon_sym_restrict] = ACTIONS(4107),
    [anon_sym___restrict__] = ACTIONS(4107),
    [anon_sym__Atomic] = ACTIONS(4107),
    [anon_sym__Noreturn] = ACTIONS(4107),
    [anon_sym_noreturn] = ACTIONS(4107),
    [anon_sym__Nonnull] = ACTIONS(4107),
    [anon_sym_mutable] = ACTIONS(4107),
    [anon_sym_constinit] = ACTIONS(4107),
    [anon_sym_consteval] = ACTIONS(4107),
    [anon_sym_alignas] = ACTIONS(4107),
    [anon_sym__Alignas] = ACTIONS(4107),
    [sym_primitive_type] = ACTIONS(4107),
    [anon_sym_enum] = ACTIONS(4107),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4107),
    [anon_sym_union] = ACTIONS(4107),
    [anon_sym_if] = ACTIONS(4107),
    [anon_sym_switch] = ACTIONS(4107),
    [anon_sym_case] = ACTIONS(4107),
    [anon_sym_default] = ACTIONS(4107),
    [anon_sym_while] = ACTIONS(4107),
    [anon_sym_do] = ACTIONS(4107),
    [anon_sym_for] = ACTIONS(4107),
    [anon_sym_return] = ACTIONS(4107),
    [anon_sym_break] = ACTIONS(4107),
    [anon_sym_continue] = ACTIONS(4107),
    [anon_sym_goto] = ACTIONS(4107),
    [anon_sym___try] = ACTIONS(4107),
    [anon_sym___leave] = ACTIONS(4107),
    [anon_sym_not] = ACTIONS(4107),
    [anon_sym_compl] = ACTIONS(4107),
    [anon_sym_DASH_DASH] = ACTIONS(4109),
    [anon_sym_PLUS_PLUS] = ACTIONS(4109),
    [anon_sym_sizeof] = ACTIONS(4107),
    [anon_sym___alignof__] = ACTIONS(4107),
    [anon_sym___alignof] = ACTIONS(4107),
    [anon_sym__alignof] = ACTIONS(4107),
    [anon_sym_alignof] = ACTIONS(4107),
    [anon_sym__Alignof] = ACTIONS(4107),
    [anon_sym_offsetof] = ACTIONS(4107),
    [anon_sym__Generic] = ACTIONS(4107),
    [anon_sym_asm] = ACTIONS(4107),
    [anon_sym___asm__] = ACTIONS(4107),
    [anon_sym___asm] = ACTIONS(4107),
    [anon_sym_DOT] = ACTIONS(4107),
    [sym_number_literal] = ACTIONS(4109),
    [anon_sym_L_SQUOTE] = ACTIONS(4109),
    [anon_sym_u_SQUOTE] = ACTIONS(4109),
    [anon_sym_U_SQUOTE] = ACTIONS(4109),
    [anon_sym_u8_SQUOTE] = ACTIONS(4109),
    [anon_sym_SQUOTE] = ACTIONS(4109),
    [anon_sym_L_DQUOTE] = ACTIONS(4109),
    [anon_sym_u_DQUOTE] = ACTIONS(4109),
    [anon_sym_U_DQUOTE] = ACTIONS(4109),
    [anon_sym_u8_DQUOTE] = ACTIONS(4109),
    [anon_sym_DQUOTE] = ACTIONS(4109),
    [sym_true] = ACTIONS(4107),
    [sym_false] = ACTIONS(4107),
    [anon_sym_NULL] = ACTIONS(4107),
    [anon_sym_nullptr] = ACTIONS(4107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4107),
    [anon_sym_let] = ACTIONS(4107),
    [anon_sym_This] = ACTIONS(4107),
    [anon_sym_decltype] = ACTIONS(4107),
    [anon_sym_explicit] = ACTIONS(4107),
    [anon_sym_typename] = ACTIONS(4107),
    [anon_sym_template] = ACTIONS(4107),
    [anon_sym_operator] = ACTIONS(4107),
    [anon_sym_try] = ACTIONS(4107),
    [anon_sym_delete] = ACTIONS(4107),
    [anon_sym_throw] = ACTIONS(4107),
    [anon_sym_namespace] = ACTIONS(4107),
    [anon_sym_static_assert] = ACTIONS(4107),
    [anon_sym_concept] = ACTIONS(4107),
    [anon_sym_co_return] = ACTIONS(4107),
    [anon_sym_co_yield] = ACTIONS(4107),
    [anon_sym_R_DQUOTE] = ACTIONS(4109),
    [anon_sym_LR_DQUOTE] = ACTIONS(4109),
    [anon_sym_uR_DQUOTE] = ACTIONS(4109),
    [anon_sym_UR_DQUOTE] = ACTIONS(4109),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4109),
    [anon_sym_co_await] = ACTIONS(4107),
    [anon_sym_new] = ACTIONS(4107),
    [anon_sym_requires] = ACTIONS(4107),
    [sym_this] = ACTIONS(4107),
    [anon_sym_discard] = ACTIONS(4107),
    [anon_sym_precise] = ACTIONS(4107),
    [anon_sym_shared] = ACTIONS(4107),
    [anon_sym_groupshared] = ACTIONS(4107),
    [anon_sym_uniform] = ACTIONS(4107),
    [anon_sym_row_major] = ACTIONS(4107),
    [anon_sym_column_major] = ACTIONS(4107),
    [anon_sym_globallycoherent] = ACTIONS(4107),
    [anon_sym_centroid] = ACTIONS(4107),
    [anon_sym_noperspective] = ACTIONS(4107),
    [anon_sym_nointerpolation] = ACTIONS(4107),
    [anon_sym_sample] = ACTIONS(4107),
    [anon_sym_linear] = ACTIONS(4107),
    [anon_sym_snorm] = ACTIONS(4107),
    [anon_sym_unorm] = ACTIONS(4107),
    [anon_sym_point] = ACTIONS(4107),
    [anon_sym_line] = ACTIONS(4107),
    [anon_sym_triangleadj] = ACTIONS(4107),
    [anon_sym_lineadj] = ACTIONS(4107),
    [anon_sym_triangle] = ACTIONS(4107),
    [anon_sym_cbuffer] = ACTIONS(4107),
    [anon_sym_interface] = ACTIONS(4107),
    [anon_sym_extension] = ACTIONS(4107),
  },
  [668] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(642),
    [sym_identifier] = ACTIONS(4111),
    [aux_sym_preproc_include_token1] = ACTIONS(4111),
    [aux_sym_preproc_def_token1] = ACTIONS(4111),
    [aux_sym_preproc_if_token1] = ACTIONS(4111),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4111),
    [sym_preproc_directive] = ACTIONS(4111),
    [anon_sym_LPAREN2] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4113),
    [anon_sym_TILDE] = ACTIONS(4113),
    [anon_sym_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4111),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4113),
    [anon_sym_AMP] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym___extension__] = ACTIONS(4111),
    [anon_sym_typedef] = ACTIONS(4111),
    [anon_sym_in] = ACTIONS(4111),
    [anon_sym_out] = ACTIONS(4111),
    [anon_sym_inout] = ACTIONS(4111),
    [anon_sym_virtual] = ACTIONS(4111),
    [anon_sym_extern] = ACTIONS(4111),
    [anon_sym___attribute__] = ACTIONS(4111),
    [anon_sym___attribute] = ACTIONS(4111),
    [anon_sym_using] = ACTIONS(4111),
    [anon_sym_COLON_COLON] = ACTIONS(4113),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4113),
    [anon_sym___declspec] = ACTIONS(4111),
    [anon_sym___based] = ACTIONS(4111),
    [anon_sym___cdecl] = ACTIONS(4111),
    [anon_sym___clrcall] = ACTIONS(4111),
    [anon_sym___stdcall] = ACTIONS(4111),
    [anon_sym___fastcall] = ACTIONS(4111),
    [anon_sym___thiscall] = ACTIONS(4111),
    [anon_sym___vectorcall] = ACTIONS(4111),
    [anon_sym_LBRACE] = ACTIONS(4113),
    [anon_sym_RBRACE] = ACTIONS(4113),
    [anon_sym_signed] = ACTIONS(4115),
    [anon_sym_unsigned] = ACTIONS(4115),
    [anon_sym_long] = ACTIONS(4115),
    [anon_sym_short] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(4111),
    [anon_sym_static] = ACTIONS(4111),
    [anon_sym_register] = ACTIONS(4111),
    [anon_sym_inline] = ACTIONS(4111),
    [anon_sym___inline] = ACTIONS(4111),
    [anon_sym___inline__] = ACTIONS(4111),
    [anon_sym___forceinline] = ACTIONS(4111),
    [anon_sym_thread_local] = ACTIONS(4111),
    [anon_sym___thread] = ACTIONS(4111),
    [anon_sym_const] = ACTIONS(4111),
    [anon_sym_constexpr] = ACTIONS(4111),
    [anon_sym_volatile] = ACTIONS(4111),
    [anon_sym_restrict] = ACTIONS(4111),
    [anon_sym___restrict__] = ACTIONS(4111),
    [anon_sym__Atomic] = ACTIONS(4111),
    [anon_sym__Noreturn] = ACTIONS(4111),
    [anon_sym_noreturn] = ACTIONS(4111),
    [anon_sym__Nonnull] = ACTIONS(4111),
    [anon_sym_mutable] = ACTIONS(4111),
    [anon_sym_constinit] = ACTIONS(4111),
    [anon_sym_consteval] = ACTIONS(4111),
    [anon_sym_alignas] = ACTIONS(4111),
    [anon_sym__Alignas] = ACTIONS(4111),
    [sym_primitive_type] = ACTIONS(4111),
    [anon_sym_enum] = ACTIONS(4111),
    [anon_sym_class] = ACTIONS(4111),
    [anon_sym_struct] = ACTIONS(4111),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_if] = ACTIONS(4111),
    [anon_sym_switch] = ACTIONS(4111),
    [anon_sym_case] = ACTIONS(4111),
    [anon_sym_default] = ACTIONS(4111),
    [anon_sym_while] = ACTIONS(4111),
    [anon_sym_do] = ACTIONS(4111),
    [anon_sym_for] = ACTIONS(4111),
    [anon_sym_return] = ACTIONS(4111),
    [anon_sym_break] = ACTIONS(4111),
    [anon_sym_continue] = ACTIONS(4111),
    [anon_sym_goto] = ACTIONS(4111),
    [anon_sym___try] = ACTIONS(4111),
    [anon_sym___leave] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4111),
    [anon_sym_compl] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4111),
    [anon_sym___alignof__] = ACTIONS(4111),
    [anon_sym___alignof] = ACTIONS(4111),
    [anon_sym__alignof] = ACTIONS(4111),
    [anon_sym_alignof] = ACTIONS(4111),
    [anon_sym__Alignof] = ACTIONS(4111),
    [anon_sym_offsetof] = ACTIONS(4111),
    [anon_sym__Generic] = ACTIONS(4111),
    [anon_sym_asm] = ACTIONS(4111),
    [anon_sym___asm__] = ACTIONS(4111),
    [anon_sym___asm] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4111),
    [sym_number_literal] = ACTIONS(4113),
    [anon_sym_L_SQUOTE] = ACTIONS(4113),
    [anon_sym_u_SQUOTE] = ACTIONS(4113),
    [anon_sym_U_SQUOTE] = ACTIONS(4113),
    [anon_sym_u8_SQUOTE] = ACTIONS(4113),
    [anon_sym_SQUOTE] = ACTIONS(4113),
    [anon_sym_L_DQUOTE] = ACTIONS(4113),
    [anon_sym_u_DQUOTE] = ACTIONS(4113),
    [anon_sym_U_DQUOTE] = ACTIONS(4113),
    [anon_sym_u8_DQUOTE] = ACTIONS(4113),
    [anon_sym_DQUOTE] = ACTIONS(4113),
    [sym_true] = ACTIONS(4111),
    [sym_false] = ACTIONS(4111),
    [anon_sym_NULL] = ACTIONS(4111),
    [anon_sym_nullptr] = ACTIONS(4111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4111),
    [anon_sym_let] = ACTIONS(4111),
    [anon_sym_This] = ACTIONS(4111),
    [anon_sym_decltype] = ACTIONS(4111),
    [anon_sym_explicit] = ACTIONS(4111),
    [anon_sym_typename] = ACTIONS(4111),
    [anon_sym_template] = ACTIONS(4111),
    [anon_sym_operator] = ACTIONS(4111),
    [anon_sym_try] = ACTIONS(4111),
    [anon_sym_delete] = ACTIONS(4111),
    [anon_sym_throw] = ACTIONS(4111),
    [anon_sym_namespace] = ACTIONS(4111),
    [anon_sym_static_assert] = ACTIONS(4111),
    [anon_sym_concept] = ACTIONS(4111),
    [anon_sym_co_return] = ACTIONS(4111),
    [anon_sym_co_yield] = ACTIONS(4111),
    [anon_sym_R_DQUOTE] = ACTIONS(4113),
    [anon_sym_LR_DQUOTE] = ACTIONS(4113),
    [anon_sym_uR_DQUOTE] = ACTIONS(4113),
    [anon_sym_UR_DQUOTE] = ACTIONS(4113),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4113),
    [anon_sym_co_await] = ACTIONS(4111),
    [anon_sym_new] = ACTIONS(4111),
    [anon_sym_requires] = ACTIONS(4111),
    [sym_this] = ACTIONS(4111),
    [anon_sym_discard] = ACTIONS(4111),
    [anon_sym_precise] = ACTIONS(4111),
    [anon_sym_shared] = ACTIONS(4111),
    [anon_sym_groupshared] = ACTIONS(4111),
    [anon_sym_uniform] = ACTIONS(4111),
    [anon_sym_row_major] = ACTIONS(4111),
    [anon_sym_column_major] = ACTIONS(4111),
    [anon_sym_globallycoherent] = ACTIONS(4111),
    [anon_sym_centroid] = ACTIONS(4111),
    [anon_sym_noperspective] = ACTIONS(4111),
    [anon_sym_nointerpolation] = ACTIONS(4111),
    [anon_sym_sample] = ACTIONS(4111),
    [anon_sym_linear] = ACTIONS(4111),
    [anon_sym_snorm] = ACTIONS(4111),
    [anon_sym_unorm] = ACTIONS(4111),
    [anon_sym_point] = ACTIONS(4111),
    [anon_sym_line] = ACTIONS(4111),
    [anon_sym_triangleadj] = ACTIONS(4111),
    [anon_sym_lineadj] = ACTIONS(4111),
    [anon_sym_triangle] = ACTIONS(4111),
    [anon_sym_cbuffer] = ACTIONS(4111),
    [anon_sym_interface] = ACTIONS(4111),
    [anon_sym_extension] = ACTIONS(4111),
  },
  [669] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(680),
    [sym_identifier] = ACTIONS(4053),
    [aux_sym_preproc_include_token1] = ACTIONS(4053),
    [aux_sym_preproc_def_token1] = ACTIONS(4053),
    [aux_sym_preproc_if_token1] = ACTIONS(4053),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4053),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4053),
    [sym_preproc_directive] = ACTIONS(4053),
    [anon_sym_LPAREN2] = ACTIONS(4051),
    [anon_sym_BANG] = ACTIONS(4051),
    [anon_sym_TILDE] = ACTIONS(4051),
    [anon_sym_DASH] = ACTIONS(4053),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_STAR] = ACTIONS(4051),
    [anon_sym_AMP_AMP] = ACTIONS(4051),
    [anon_sym_AMP] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4051),
    [anon_sym___extension__] = ACTIONS(4053),
    [anon_sym_typedef] = ACTIONS(4053),
    [anon_sym_in] = ACTIONS(4053),
    [anon_sym_out] = ACTIONS(4053),
    [anon_sym_inout] = ACTIONS(4053),
    [anon_sym_virtual] = ACTIONS(4053),
    [anon_sym_extern] = ACTIONS(4053),
    [anon_sym___attribute__] = ACTIONS(4053),
    [anon_sym___attribute] = ACTIONS(4053),
    [anon_sym_using] = ACTIONS(4053),
    [anon_sym_COLON_COLON] = ACTIONS(4051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4051),
    [anon_sym___declspec] = ACTIONS(4053),
    [anon_sym___based] = ACTIONS(4053),
    [anon_sym___cdecl] = ACTIONS(4053),
    [anon_sym___clrcall] = ACTIONS(4053),
    [anon_sym___stdcall] = ACTIONS(4053),
    [anon_sym___fastcall] = ACTIONS(4053),
    [anon_sym___thiscall] = ACTIONS(4053),
    [anon_sym___vectorcall] = ACTIONS(4053),
    [anon_sym_LBRACE] = ACTIONS(4051),
    [anon_sym_RBRACE] = ACTIONS(4051),
    [anon_sym_signed] = ACTIONS(4118),
    [anon_sym_unsigned] = ACTIONS(4118),
    [anon_sym_long] = ACTIONS(4118),
    [anon_sym_short] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4053),
    [anon_sym_static] = ACTIONS(4053),
    [anon_sym_register] = ACTIONS(4053),
    [anon_sym_inline] = ACTIONS(4053),
    [anon_sym___inline] = ACTIONS(4053),
    [anon_sym___inline__] = ACTIONS(4053),
    [anon_sym___forceinline] = ACTIONS(4053),
    [anon_sym_thread_local] = ACTIONS(4053),
    [anon_sym___thread] = ACTIONS(4053),
    [anon_sym_const] = ACTIONS(4053),
    [anon_sym_constexpr] = ACTIONS(4053),
    [anon_sym_volatile] = ACTIONS(4053),
    [anon_sym_restrict] = ACTIONS(4053),
    [anon_sym___restrict__] = ACTIONS(4053),
    [anon_sym__Atomic] = ACTIONS(4053),
    [anon_sym__Noreturn] = ACTIONS(4053),
    [anon_sym_noreturn] = ACTIONS(4053),
    [anon_sym__Nonnull] = ACTIONS(4053),
    [anon_sym_mutable] = ACTIONS(4053),
    [anon_sym_constinit] = ACTIONS(4053),
    [anon_sym_consteval] = ACTIONS(4053),
    [anon_sym_alignas] = ACTIONS(4053),
    [anon_sym__Alignas] = ACTIONS(4053),
    [sym_primitive_type] = ACTIONS(4053),
    [anon_sym_enum] = ACTIONS(4053),
    [anon_sym_class] = ACTIONS(4053),
    [anon_sym_struct] = ACTIONS(4053),
    [anon_sym_union] = ACTIONS(4053),
    [anon_sym_if] = ACTIONS(4053),
    [anon_sym_switch] = ACTIONS(4053),
    [anon_sym_case] = ACTIONS(4053),
    [anon_sym_default] = ACTIONS(4053),
    [anon_sym_while] = ACTIONS(4053),
    [anon_sym_do] = ACTIONS(4053),
    [anon_sym_for] = ACTIONS(4053),
    [anon_sym_return] = ACTIONS(4053),
    [anon_sym_break] = ACTIONS(4053),
    [anon_sym_continue] = ACTIONS(4053),
    [anon_sym_goto] = ACTIONS(4053),
    [anon_sym___try] = ACTIONS(4053),
    [anon_sym___leave] = ACTIONS(4053),
    [anon_sym_not] = ACTIONS(4053),
    [anon_sym_compl] = ACTIONS(4053),
    [anon_sym_DASH_DASH] = ACTIONS(4051),
    [anon_sym_PLUS_PLUS] = ACTIONS(4051),
    [anon_sym_sizeof] = ACTIONS(4053),
    [anon_sym___alignof__] = ACTIONS(4053),
    [anon_sym___alignof] = ACTIONS(4053),
    [anon_sym__alignof] = ACTIONS(4053),
    [anon_sym_alignof] = ACTIONS(4053),
    [anon_sym__Alignof] = ACTIONS(4053),
    [anon_sym_offsetof] = ACTIONS(4053),
    [anon_sym__Generic] = ACTIONS(4053),
    [anon_sym_asm] = ACTIONS(4053),
    [anon_sym___asm__] = ACTIONS(4053),
    [anon_sym___asm] = ACTIONS(4053),
    [anon_sym_DOT] = ACTIONS(4053),
    [sym_number_literal] = ACTIONS(4051),
    [anon_sym_L_SQUOTE] = ACTIONS(4051),
    [anon_sym_u_SQUOTE] = ACTIONS(4051),
    [anon_sym_U_SQUOTE] = ACTIONS(4051),
    [anon_sym_u8_SQUOTE] = ACTIONS(4051),
    [anon_sym_SQUOTE] = ACTIONS(4051),
    [anon_sym_L_DQUOTE] = ACTIONS(4051),
    [anon_sym_u_DQUOTE] = ACTIONS(4051),
    [anon_sym_U_DQUOTE] = ACTIONS(4051),
    [anon_sym_u8_DQUOTE] = ACTIONS(4051),
    [anon_sym_DQUOTE] = ACTIONS(4051),
    [sym_true] = ACTIONS(4053),
    [sym_false] = ACTIONS(4053),
    [anon_sym_NULL] = ACTIONS(4053),
    [anon_sym_nullptr] = ACTIONS(4053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4053),
    [anon_sym_let] = ACTIONS(4053),
    [anon_sym_This] = ACTIONS(4053),
    [anon_sym_decltype] = ACTIONS(4053),
    [anon_sym_explicit] = ACTIONS(4053),
    [anon_sym_typename] = ACTIONS(4053),
    [anon_sym_template] = ACTIONS(4053),
    [anon_sym_operator] = ACTIONS(4053),
    [anon_sym_try] = ACTIONS(4053),
    [anon_sym_delete] = ACTIONS(4053),
    [anon_sym_throw] = ACTIONS(4053),
    [anon_sym_namespace] = ACTIONS(4053),
    [anon_sym_static_assert] = ACTIONS(4053),
    [anon_sym_concept] = ACTIONS(4053),
    [anon_sym_co_return] = ACTIONS(4053),
    [anon_sym_co_yield] = ACTIONS(4053),
    [anon_sym_R_DQUOTE] = ACTIONS(4051),
    [anon_sym_LR_DQUOTE] = ACTIONS(4051),
    [anon_sym_uR_DQUOTE] = ACTIONS(4051),
    [anon_sym_UR_DQUOTE] = ACTIONS(4051),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4051),
    [anon_sym_co_await] = ACTIONS(4053),
    [anon_sym_new] = ACTIONS(4053),
    [anon_sym_requires] = ACTIONS(4053),
    [sym_this] = ACTIONS(4053),
    [anon_sym_discard] = ACTIONS(4053),
    [anon_sym_precise] = ACTIONS(4053),
    [anon_sym_shared] = ACTIONS(4053),
    [anon_sym_groupshared] = ACTIONS(4053),
    [anon_sym_uniform] = ACTIONS(4053),
    [anon_sym_row_major] = ACTIONS(4053),
    [anon_sym_column_major] = ACTIONS(4053),
    [anon_sym_globallycoherent] = ACTIONS(4053),
    [anon_sym_centroid] = ACTIONS(4053),
    [anon_sym_noperspective] = ACTIONS(4053),
    [anon_sym_nointerpolation] = ACTIONS(4053),
    [anon_sym_sample] = ACTIONS(4053),
    [anon_sym_linear] = ACTIONS(4053),
    [anon_sym_snorm] = ACTIONS(4053),
    [anon_sym_unorm] = ACTIONS(4053),
    [anon_sym_point] = ACTIONS(4053),
    [anon_sym_line] = ACTIONS(4053),
    [anon_sym_triangleadj] = ACTIONS(4053),
    [anon_sym_lineadj] = ACTIONS(4053),
    [anon_sym_triangle] = ACTIONS(4053),
    [anon_sym_cbuffer] = ACTIONS(4053),
    [anon_sym_interface] = ACTIONS(4053),
    [anon_sym_extension] = ACTIONS(4053),
  },
  [670] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(284),
    [ts_builtin_sym_end] = ACTIONS(4121),
    [sym_identifier] = ACTIONS(4124),
    [aux_sym_preproc_include_token1] = ACTIONS(4124),
    [aux_sym_preproc_def_token1] = ACTIONS(4124),
    [aux_sym_preproc_if_token1] = ACTIONS(4124),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4124),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4124),
    [sym_preproc_directive] = ACTIONS(4124),
    [anon_sym_LPAREN2] = ACTIONS(4121),
    [anon_sym_BANG] = ACTIONS(4121),
    [anon_sym_TILDE] = ACTIONS(4121),
    [anon_sym_DASH] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4124),
    [anon_sym_STAR] = ACTIONS(4121),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_AMP] = ACTIONS(4124),
    [anon_sym_SEMI] = ACTIONS(4121),
    [anon_sym___extension__] = ACTIONS(4124),
    [anon_sym_typedef] = ACTIONS(4124),
    [anon_sym_in] = ACTIONS(4124),
    [anon_sym_out] = ACTIONS(4124),
    [anon_sym_inout] = ACTIONS(4124),
    [anon_sym_virtual] = ACTIONS(4124),
    [anon_sym_extern] = ACTIONS(4124),
    [anon_sym___attribute__] = ACTIONS(4124),
    [anon_sym___attribute] = ACTIONS(4124),
    [anon_sym_using] = ACTIONS(4124),
    [anon_sym_COLON_COLON] = ACTIONS(4121),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4121),
    [anon_sym___declspec] = ACTIONS(4124),
    [anon_sym___based] = ACTIONS(4124),
    [anon_sym___cdecl] = ACTIONS(4124),
    [anon_sym___clrcall] = ACTIONS(4124),
    [anon_sym___stdcall] = ACTIONS(4124),
    [anon_sym___fastcall] = ACTIONS(4124),
    [anon_sym___thiscall] = ACTIONS(4124),
    [anon_sym___vectorcall] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_signed] = ACTIONS(4127),
    [anon_sym_unsigned] = ACTIONS(4127),
    [anon_sym_long] = ACTIONS(4127),
    [anon_sym_short] = ACTIONS(4127),
    [anon_sym_LBRACK] = ACTIONS(4124),
    [anon_sym_static] = ACTIONS(4124),
    [anon_sym_register] = ACTIONS(4124),
    [anon_sym_inline] = ACTIONS(4124),
    [anon_sym___inline] = ACTIONS(4124),
    [anon_sym___inline__] = ACTIONS(4124),
    [anon_sym___forceinline] = ACTIONS(4124),
    [anon_sym_thread_local] = ACTIONS(4124),
    [anon_sym___thread] = ACTIONS(4124),
    [anon_sym_const] = ACTIONS(4124),
    [anon_sym_constexpr] = ACTIONS(4124),
    [anon_sym_volatile] = ACTIONS(4124),
    [anon_sym_restrict] = ACTIONS(4124),
    [anon_sym___restrict__] = ACTIONS(4124),
    [anon_sym__Atomic] = ACTIONS(4124),
    [anon_sym__Noreturn] = ACTIONS(4124),
    [anon_sym_noreturn] = ACTIONS(4124),
    [anon_sym__Nonnull] = ACTIONS(4124),
    [anon_sym_mutable] = ACTIONS(4124),
    [anon_sym_constinit] = ACTIONS(4124),
    [anon_sym_consteval] = ACTIONS(4124),
    [anon_sym_alignas] = ACTIONS(4124),
    [anon_sym__Alignas] = ACTIONS(4124),
    [sym_primitive_type] = ACTIONS(4124),
    [anon_sym_enum] = ACTIONS(4124),
    [anon_sym_class] = ACTIONS(4124),
    [anon_sym_struct] = ACTIONS(4124),
    [anon_sym_union] = ACTIONS(4124),
    [anon_sym_if] = ACTIONS(4124),
    [anon_sym_switch] = ACTIONS(4124),
    [anon_sym_case] = ACTIONS(4124),
    [anon_sym_default] = ACTIONS(4124),
    [anon_sym_while] = ACTIONS(4124),
    [anon_sym_do] = ACTIONS(4124),
    [anon_sym_for] = ACTIONS(4124),
    [anon_sym_return] = ACTIONS(4124),
    [anon_sym_break] = ACTIONS(4124),
    [anon_sym_continue] = ACTIONS(4124),
    [anon_sym_goto] = ACTIONS(4124),
    [anon_sym_not] = ACTIONS(4124),
    [anon_sym_compl] = ACTIONS(4124),
    [anon_sym_DASH_DASH] = ACTIONS(4121),
    [anon_sym_PLUS_PLUS] = ACTIONS(4121),
    [anon_sym_sizeof] = ACTIONS(4124),
    [anon_sym___alignof__] = ACTIONS(4124),
    [anon_sym___alignof] = ACTIONS(4124),
    [anon_sym__alignof] = ACTIONS(4124),
    [anon_sym_alignof] = ACTIONS(4124),
    [anon_sym__Alignof] = ACTIONS(4124),
    [anon_sym_offsetof] = ACTIONS(4124),
    [anon_sym__Generic] = ACTIONS(4124),
    [anon_sym_asm] = ACTIONS(4124),
    [anon_sym___asm__] = ACTIONS(4124),
    [anon_sym___asm] = ACTIONS(4124),
    [anon_sym_DOT] = ACTIONS(4124),
    [sym_number_literal] = ACTIONS(4121),
    [anon_sym_L_SQUOTE] = ACTIONS(4121),
    [anon_sym_u_SQUOTE] = ACTIONS(4121),
    [anon_sym_U_SQUOTE] = ACTIONS(4121),
    [anon_sym_u8_SQUOTE] = ACTIONS(4121),
    [anon_sym_SQUOTE] = ACTIONS(4121),
    [anon_sym_L_DQUOTE] = ACTIONS(4121),
    [anon_sym_u_DQUOTE] = ACTIONS(4121),
    [anon_sym_U_DQUOTE] = ACTIONS(4121),
    [anon_sym_u8_DQUOTE] = ACTIONS(4121),
    [anon_sym_DQUOTE] = ACTIONS(4121),
    [sym_true] = ACTIONS(4124),
    [sym_false] = ACTIONS(4124),
    [anon_sym_NULL] = ACTIONS(4124),
    [anon_sym_nullptr] = ACTIONS(4124),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4124),
    [anon_sym_let] = ACTIONS(4124),
    [anon_sym_This] = ACTIONS(4124),
    [anon_sym_decltype] = ACTIONS(4124),
    [anon_sym_explicit] = ACTIONS(4124),
    [anon_sym_typename] = ACTIONS(4124),
    [anon_sym_export] = ACTIONS(4124),
    [anon_sym_module] = ACTIONS(4124),
    [anon_sym_import] = ACTIONS(4124),
    [anon_sym_template] = ACTIONS(4124),
    [anon_sym_operator] = ACTIONS(4124),
    [anon_sym_try] = ACTIONS(4124),
    [anon_sym_delete] = ACTIONS(4124),
    [anon_sym_throw] = ACTIONS(4124),
    [anon_sym_namespace] = ACTIONS(4124),
    [anon_sym_static_assert] = ACTIONS(4124),
    [anon_sym_concept] = ACTIONS(4124),
    [anon_sym_co_return] = ACTIONS(4124),
    [anon_sym_co_yield] = ACTIONS(4124),
    [anon_sym_R_DQUOTE] = ACTIONS(4121),
    [anon_sym_LR_DQUOTE] = ACTIONS(4121),
    [anon_sym_uR_DQUOTE] = ACTIONS(4121),
    [anon_sym_UR_DQUOTE] = ACTIONS(4121),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4121),
    [anon_sym_co_await] = ACTIONS(4124),
    [anon_sym_new] = ACTIONS(4124),
    [anon_sym_requires] = ACTIONS(4124),
    [sym_this] = ACTIONS(4124),
    [anon_sym_precise] = ACTIONS(4124),
    [anon_sym_shared] = ACTIONS(4124),
    [anon_sym_groupshared] = ACTIONS(4124),
    [anon_sym_uniform] = ACTIONS(4124),
    [anon_sym_row_major] = ACTIONS(4124),
    [anon_sym_column_major] = ACTIONS(4124),
    [anon_sym_globallycoherent] = ACTIONS(4124),
    [anon_sym_centroid] = ACTIONS(4124),
    [anon_sym_noperspective] = ACTIONS(4124),
    [anon_sym_nointerpolation] = ACTIONS(4124),
    [anon_sym_sample] = ACTIONS(4124),
    [anon_sym_linear] = ACTIONS(4124),
    [anon_sym_snorm] = ACTIONS(4124),
    [anon_sym_unorm] = ACTIONS(4124),
    [anon_sym_point] = ACTIONS(4124),
    [anon_sym_line] = ACTIONS(4124),
    [anon_sym_triangleadj] = ACTIONS(4124),
    [anon_sym_lineadj] = ACTIONS(4124),
    [anon_sym_triangle] = ACTIONS(4124),
    [anon_sym_interface] = ACTIONS(4124),
    [anon_sym_extension] = ACTIONS(4124),
    [anon_sym___exported] = ACTIONS(4124),
  },
  [671] = {
    [sym_expression] = STATE(5710),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11264),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(4131),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(4134),
    [anon_sym___extension__] = ACTIONS(4136),
    [anon_sym_in] = ACTIONS(3474),
    [anon_sym_out] = ACTIONS(3474),
    [anon_sym_inout] = ACTIONS(3474),
    [anon_sym_virtual] = ACTIONS(3474),
    [anon_sym_extern] = ACTIONS(3474),
    [anon_sym___attribute__] = ACTIONS(3474),
    [anon_sym___attribute] = ACTIONS(3474),
    [anon_sym_COLON_COLON] = ACTIONS(4139),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3476),
    [anon_sym___declspec] = ACTIONS(3474),
    [anon_sym_signed] = ACTIONS(3474),
    [anon_sym_unsigned] = ACTIONS(3474),
    [anon_sym_long] = ACTIONS(3474),
    [anon_sym_short] = ACTIONS(3474),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(3474),
    [anon_sym_register] = ACTIONS(3474),
    [anon_sym_inline] = ACTIONS(3474),
    [anon_sym___inline] = ACTIONS(3474),
    [anon_sym___inline__] = ACTIONS(3474),
    [anon_sym___forceinline] = ACTIONS(3474),
    [anon_sym_thread_local] = ACTIONS(3474),
    [anon_sym___thread] = ACTIONS(3474),
    [anon_sym_const] = ACTIONS(3474),
    [anon_sym_constexpr] = ACTIONS(3474),
    [anon_sym_volatile] = ACTIONS(3474),
    [anon_sym_restrict] = ACTIONS(3474),
    [anon_sym___restrict__] = ACTIONS(3474),
    [anon_sym__Atomic] = ACTIONS(3474),
    [anon_sym__Noreturn] = ACTIONS(3474),
    [anon_sym_noreturn] = ACTIONS(3474),
    [anon_sym__Nonnull] = ACTIONS(3474),
    [anon_sym_mutable] = ACTIONS(3474),
    [anon_sym_constinit] = ACTIONS(3474),
    [anon_sym_consteval] = ACTIONS(3474),
    [anon_sym_alignas] = ACTIONS(3474),
    [anon_sym__Alignas] = ACTIONS(3474),
    [sym_primitive_type] = ACTIONS(4142),
    [anon_sym_enum] = ACTIONS(3474),
    [anon_sym_class] = ACTIONS(3474),
    [anon_sym_struct] = ACTIONS(3474),
    [anon_sym_union] = ACTIONS(3474),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3474),
    [anon_sym_let] = ACTIONS(3474),
    [anon_sym_This] = ACTIONS(3474),
    [anon_sym_decltype] = ACTIONS(4145),
    [anon_sym_typename] = ACTIONS(3474),
    [anon_sym_template] = ACTIONS(4148),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(3474),
    [anon_sym_shared] = ACTIONS(3474),
    [anon_sym_groupshared] = ACTIONS(3474),
    [anon_sym_uniform] = ACTIONS(3474),
    [anon_sym_row_major] = ACTIONS(3474),
    [anon_sym_column_major] = ACTIONS(3474),
    [anon_sym_globallycoherent] = ACTIONS(3474),
    [anon_sym_centroid] = ACTIONS(3474),
    [anon_sym_noperspective] = ACTIONS(3474),
    [anon_sym_nointerpolation] = ACTIONS(3474),
    [anon_sym_sample] = ACTIONS(3474),
    [anon_sym_linear] = ACTIONS(3474),
    [anon_sym_snorm] = ACTIONS(3474),
    [anon_sym_unorm] = ACTIONS(3474),
    [anon_sym_point] = ACTIONS(3474),
    [anon_sym_line] = ACTIONS(3474),
    [anon_sym_triangleadj] = ACTIONS(3474),
    [anon_sym_lineadj] = ACTIONS(3474),
    [anon_sym_triangle] = ACTIONS(3474),
    [anon_sym_interface] = ACTIONS(3474),
    [anon_sym_extension] = ACTIONS(3474),
  },
  [672] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(672),
    [sym_identifier] = ACTIONS(2915),
    [aux_sym_preproc_include_token1] = ACTIONS(2915),
    [aux_sym_preproc_def_token1] = ACTIONS(2915),
    [aux_sym_preproc_if_token1] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2915),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2915),
    [sym_preproc_directive] = ACTIONS(2915),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2915),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym_typedef] = ACTIONS(2915),
    [anon_sym_in] = ACTIONS(2915),
    [anon_sym_out] = ACTIONS(2915),
    [anon_sym_inout] = ACTIONS(2915),
    [anon_sym_virtual] = ACTIONS(2915),
    [anon_sym_extern] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym_using] = ACTIONS(2915),
    [anon_sym_COLON_COLON] = ACTIONS(2913),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2913),
    [anon_sym___declspec] = ACTIONS(2915),
    [anon_sym___based] = ACTIONS(2915),
    [anon_sym___cdecl] = ACTIONS(2915),
    [anon_sym___clrcall] = ACTIONS(2915),
    [anon_sym___stdcall] = ACTIONS(2915),
    [anon_sym___fastcall] = ACTIONS(2915),
    [anon_sym___thiscall] = ACTIONS(2915),
    [anon_sym___vectorcall] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_RBRACE] = ACTIONS(2913),
    [anon_sym_signed] = ACTIONS(4151),
    [anon_sym_unsigned] = ACTIONS(4151),
    [anon_sym_long] = ACTIONS(4151),
    [anon_sym_short] = ACTIONS(4151),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_static] = ACTIONS(2915),
    [anon_sym_register] = ACTIONS(2915),
    [anon_sym_inline] = ACTIONS(2915),
    [anon_sym___inline] = ACTIONS(2915),
    [anon_sym___inline__] = ACTIONS(2915),
    [anon_sym___forceinline] = ACTIONS(2915),
    [anon_sym_thread_local] = ACTIONS(2915),
    [anon_sym___thread] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_enum] = ACTIONS(2915),
    [anon_sym_class] = ACTIONS(2915),
    [anon_sym_struct] = ACTIONS(2915),
    [anon_sym_union] = ACTIONS(2915),
    [anon_sym_if] = ACTIONS(2915),
    [anon_sym_switch] = ACTIONS(2915),
    [anon_sym_case] = ACTIONS(2915),
    [anon_sym_default] = ACTIONS(2915),
    [anon_sym_while] = ACTIONS(2915),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2915),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_break] = ACTIONS(2915),
    [anon_sym_continue] = ACTIONS(2915),
    [anon_sym_goto] = ACTIONS(2915),
    [anon_sym___try] = ACTIONS(2915),
    [anon_sym___leave] = ACTIONS(2915),
    [anon_sym_not] = ACTIONS(2915),
    [anon_sym_compl] = ACTIONS(2915),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_sizeof] = ACTIONS(2915),
    [anon_sym___alignof__] = ACTIONS(2915),
    [anon_sym___alignof] = ACTIONS(2915),
    [anon_sym__alignof] = ACTIONS(2915),
    [anon_sym_alignof] = ACTIONS(2915),
    [anon_sym__Alignof] = ACTIONS(2915),
    [anon_sym_offsetof] = ACTIONS(2915),
    [anon_sym__Generic] = ACTIONS(2915),
    [anon_sym_asm] = ACTIONS(2915),
    [anon_sym___asm__] = ACTIONS(2915),
    [anon_sym___asm] = ACTIONS(2915),
    [anon_sym_DOT] = ACTIONS(2915),
    [sym_number_literal] = ACTIONS(2913),
    [anon_sym_L_SQUOTE] = ACTIONS(2913),
    [anon_sym_u_SQUOTE] = ACTIONS(2913),
    [anon_sym_U_SQUOTE] = ACTIONS(2913),
    [anon_sym_u8_SQUOTE] = ACTIONS(2913),
    [anon_sym_SQUOTE] = ACTIONS(2913),
    [anon_sym_L_DQUOTE] = ACTIONS(2913),
    [anon_sym_u_DQUOTE] = ACTIONS(2913),
    [anon_sym_U_DQUOTE] = ACTIONS(2913),
    [anon_sym_u8_DQUOTE] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2913),
    [sym_true] = ACTIONS(2915),
    [sym_false] = ACTIONS(2915),
    [anon_sym_NULL] = ACTIONS(2915),
    [anon_sym_nullptr] = ACTIONS(2915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2915),
    [anon_sym_let] = ACTIONS(2915),
    [anon_sym_This] = ACTIONS(2915),
    [anon_sym_decltype] = ACTIONS(2915),
    [anon_sym_explicit] = ACTIONS(2915),
    [anon_sym_typename] = ACTIONS(2915),
    [anon_sym_template] = ACTIONS(2915),
    [anon_sym_operator] = ACTIONS(2915),
    [anon_sym_try] = ACTIONS(2915),
    [anon_sym_delete] = ACTIONS(2915),
    [anon_sym_throw] = ACTIONS(2915),
    [anon_sym_namespace] = ACTIONS(2915),
    [anon_sym_static_assert] = ACTIONS(2915),
    [anon_sym_concept] = ACTIONS(2915),
    [anon_sym_co_return] = ACTIONS(2915),
    [anon_sym_co_yield] = ACTIONS(2915),
    [anon_sym_R_DQUOTE] = ACTIONS(2913),
    [anon_sym_LR_DQUOTE] = ACTIONS(2913),
    [anon_sym_uR_DQUOTE] = ACTIONS(2913),
    [anon_sym_UR_DQUOTE] = ACTIONS(2913),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2913),
    [anon_sym_co_await] = ACTIONS(2915),
    [anon_sym_new] = ACTIONS(2915),
    [anon_sym_requires] = ACTIONS(2915),
    [sym_this] = ACTIONS(2915),
    [anon_sym_discard] = ACTIONS(2915),
    [anon_sym_precise] = ACTIONS(2915),
    [anon_sym_shared] = ACTIONS(2915),
    [anon_sym_groupshared] = ACTIONS(2915),
    [anon_sym_uniform] = ACTIONS(2915),
    [anon_sym_row_major] = ACTIONS(2915),
    [anon_sym_column_major] = ACTIONS(2915),
    [anon_sym_globallycoherent] = ACTIONS(2915),
    [anon_sym_centroid] = ACTIONS(2915),
    [anon_sym_noperspective] = ACTIONS(2915),
    [anon_sym_nointerpolation] = ACTIONS(2915),
    [anon_sym_sample] = ACTIONS(2915),
    [anon_sym_linear] = ACTIONS(2915),
    [anon_sym_snorm] = ACTIONS(2915),
    [anon_sym_unorm] = ACTIONS(2915),
    [anon_sym_point] = ACTIONS(2915),
    [anon_sym_line] = ACTIONS(2915),
    [anon_sym_triangleadj] = ACTIONS(2915),
    [anon_sym_lineadj] = ACTIONS(2915),
    [anon_sym_triangle] = ACTIONS(2915),
    [anon_sym_cbuffer] = ACTIONS(2915),
    [anon_sym_interface] = ACTIONS(2915),
    [anon_sym_extension] = ACTIONS(2915),
  },
  [673] = {
    [sym_attribute_specifier] = STATE(329),
    [ts_builtin_sym_end] = ACTIONS(4154),
    [sym_identifier] = ACTIONS(4156),
    [aux_sym_preproc_include_token1] = ACTIONS(4156),
    [aux_sym_preproc_def_token1] = ACTIONS(4156),
    [aux_sym_preproc_if_token1] = ACTIONS(4156),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4156),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4156),
    [sym_preproc_directive] = ACTIONS(4156),
    [anon_sym_LPAREN2] = ACTIONS(4154),
    [anon_sym_BANG] = ACTIONS(4154),
    [anon_sym_TILDE] = ACTIONS(4154),
    [anon_sym_DASH] = ACTIONS(4156),
    [anon_sym_PLUS] = ACTIONS(4156),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_AMP_AMP] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4156),
    [anon_sym_SEMI] = ACTIONS(4154),
    [anon_sym___extension__] = ACTIONS(4156),
    [anon_sym_typedef] = ACTIONS(4156),
    [anon_sym_in] = ACTIONS(4156),
    [anon_sym_out] = ACTIONS(4156),
    [anon_sym_inout] = ACTIONS(4156),
    [anon_sym_virtual] = ACTIONS(4156),
    [anon_sym_extern] = ACTIONS(4156),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(4156),
    [anon_sym_COLON_COLON] = ACTIONS(4154),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4154),
    [anon_sym___declspec] = ACTIONS(4156),
    [anon_sym___based] = ACTIONS(4156),
    [anon_sym___cdecl] = ACTIONS(4156),
    [anon_sym___clrcall] = ACTIONS(4156),
    [anon_sym___stdcall] = ACTIONS(4156),
    [anon_sym___fastcall] = ACTIONS(4156),
    [anon_sym___thiscall] = ACTIONS(4156),
    [anon_sym___vectorcall] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4154),
    [anon_sym_signed] = ACTIONS(4156),
    [anon_sym_unsigned] = ACTIONS(4156),
    [anon_sym_long] = ACTIONS(4156),
    [anon_sym_short] = ACTIONS(4156),
    [anon_sym_LBRACK] = ACTIONS(4156),
    [anon_sym_static] = ACTIONS(4156),
    [anon_sym_register] = ACTIONS(4156),
    [anon_sym_inline] = ACTIONS(4156),
    [anon_sym___inline] = ACTIONS(4156),
    [anon_sym___inline__] = ACTIONS(4156),
    [anon_sym___forceinline] = ACTIONS(4156),
    [anon_sym_thread_local] = ACTIONS(4156),
    [anon_sym___thread] = ACTIONS(4156),
    [anon_sym_const] = ACTIONS(4156),
    [anon_sym_constexpr] = ACTIONS(4156),
    [anon_sym_volatile] = ACTIONS(4156),
    [anon_sym_restrict] = ACTIONS(4156),
    [anon_sym___restrict__] = ACTIONS(4156),
    [anon_sym__Atomic] = ACTIONS(4156),
    [anon_sym__Noreturn] = ACTIONS(4156),
    [anon_sym_noreturn] = ACTIONS(4156),
    [anon_sym__Nonnull] = ACTIONS(4156),
    [anon_sym_mutable] = ACTIONS(4156),
    [anon_sym_constinit] = ACTIONS(4156),
    [anon_sym_consteval] = ACTIONS(4156),
    [anon_sym_alignas] = ACTIONS(4156),
    [anon_sym__Alignas] = ACTIONS(4156),
    [sym_primitive_type] = ACTIONS(4156),
    [anon_sym_enum] = ACTIONS(4156),
    [anon_sym_class] = ACTIONS(4156),
    [anon_sym_struct] = ACTIONS(4156),
    [anon_sym_union] = ACTIONS(4156),
    [anon_sym_if] = ACTIONS(4156),
    [anon_sym_switch] = ACTIONS(4156),
    [anon_sym_case] = ACTIONS(4156),
    [anon_sym_default] = ACTIONS(4156),
    [anon_sym_while] = ACTIONS(4156),
    [anon_sym_do] = ACTIONS(4156),
    [anon_sym_for] = ACTIONS(4156),
    [anon_sym_return] = ACTIONS(4156),
    [anon_sym_break] = ACTIONS(4156),
    [anon_sym_continue] = ACTIONS(4156),
    [anon_sym_goto] = ACTIONS(4156),
    [anon_sym_not] = ACTIONS(4156),
    [anon_sym_compl] = ACTIONS(4156),
    [anon_sym_DASH_DASH] = ACTIONS(4154),
    [anon_sym_PLUS_PLUS] = ACTIONS(4154),
    [anon_sym_sizeof] = ACTIONS(4156),
    [anon_sym___alignof__] = ACTIONS(4156),
    [anon_sym___alignof] = ACTIONS(4156),
    [anon_sym__alignof] = ACTIONS(4156),
    [anon_sym_alignof] = ACTIONS(4156),
    [anon_sym__Alignof] = ACTIONS(4156),
    [anon_sym_offsetof] = ACTIONS(4156),
    [anon_sym__Generic] = ACTIONS(4156),
    [anon_sym_asm] = ACTIONS(4156),
    [anon_sym___asm__] = ACTIONS(4156),
    [anon_sym___asm] = ACTIONS(4156),
    [anon_sym_DOT] = ACTIONS(4156),
    [sym_number_literal] = ACTIONS(4154),
    [anon_sym_L_SQUOTE] = ACTIONS(4154),
    [anon_sym_u_SQUOTE] = ACTIONS(4154),
    [anon_sym_U_SQUOTE] = ACTIONS(4154),
    [anon_sym_u8_SQUOTE] = ACTIONS(4154),
    [anon_sym_SQUOTE] = ACTIONS(4154),
    [anon_sym_L_DQUOTE] = ACTIONS(4154),
    [anon_sym_u_DQUOTE] = ACTIONS(4154),
    [anon_sym_U_DQUOTE] = ACTIONS(4154),
    [anon_sym_u8_DQUOTE] = ACTIONS(4154),
    [anon_sym_DQUOTE] = ACTIONS(4154),
    [sym_true] = ACTIONS(4156),
    [sym_false] = ACTIONS(4156),
    [anon_sym_NULL] = ACTIONS(4156),
    [anon_sym_nullptr] = ACTIONS(4156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4156),
    [anon_sym_let] = ACTIONS(4156),
    [anon_sym_This] = ACTIONS(4156),
    [anon_sym_decltype] = ACTIONS(4156),
    [anon_sym_explicit] = ACTIONS(4156),
    [anon_sym_typename] = ACTIONS(4156),
    [anon_sym_export] = ACTIONS(4156),
    [anon_sym_module] = ACTIONS(4156),
    [anon_sym_import] = ACTIONS(4156),
    [anon_sym_template] = ACTIONS(4156),
    [anon_sym_operator] = ACTIONS(4156),
    [anon_sym_try] = ACTIONS(4156),
    [anon_sym_delete] = ACTIONS(4156),
    [anon_sym_throw] = ACTIONS(4156),
    [anon_sym_namespace] = ACTIONS(4156),
    [anon_sym_static_assert] = ACTIONS(4156),
    [anon_sym_concept] = ACTIONS(4156),
    [anon_sym_co_return] = ACTIONS(4156),
    [anon_sym_co_yield] = ACTIONS(4156),
    [anon_sym_R_DQUOTE] = ACTIONS(4154),
    [anon_sym_LR_DQUOTE] = ACTIONS(4154),
    [anon_sym_uR_DQUOTE] = ACTIONS(4154),
    [anon_sym_UR_DQUOTE] = ACTIONS(4154),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4154),
    [anon_sym_co_await] = ACTIONS(4156),
    [anon_sym_new] = ACTIONS(4156),
    [anon_sym_requires] = ACTIONS(4156),
    [sym_this] = ACTIONS(4156),
    [anon_sym_precise] = ACTIONS(4156),
    [anon_sym_shared] = ACTIONS(4156),
    [anon_sym_groupshared] = ACTIONS(4156),
    [anon_sym_uniform] = ACTIONS(4156),
    [anon_sym_row_major] = ACTIONS(4156),
    [anon_sym_column_major] = ACTIONS(4156),
    [anon_sym_globallycoherent] = ACTIONS(4156),
    [anon_sym_centroid] = ACTIONS(4156),
    [anon_sym_noperspective] = ACTIONS(4156),
    [anon_sym_nointerpolation] = ACTIONS(4156),
    [anon_sym_sample] = ACTIONS(4156),
    [anon_sym_linear] = ACTIONS(4156),
    [anon_sym_snorm] = ACTIONS(4156),
    [anon_sym_unorm] = ACTIONS(4156),
    [anon_sym_point] = ACTIONS(4156),
    [anon_sym_line] = ACTIONS(4156),
    [anon_sym_triangleadj] = ACTIONS(4156),
    [anon_sym_lineadj] = ACTIONS(4156),
    [anon_sym_triangle] = ACTIONS(4156),
    [anon_sym_interface] = ACTIONS(4156),
    [anon_sym_extension] = ACTIONS(4156),
    [anon_sym___exported] = ACTIONS(4156),
  },
  [674] = {
    [sym_identifier] = ACTIONS(3148),
    [aux_sym_preproc_include_token1] = ACTIONS(3148),
    [aux_sym_preproc_def_token1] = ACTIONS(3148),
    [aux_sym_preproc_if_token1] = ACTIONS(3148),
    [aux_sym_preproc_if_token2] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3148),
    [sym_preproc_directive] = ACTIONS(3148),
    [anon_sym_LPAREN2] = ACTIONS(3150),
    [anon_sym_BANG] = ACTIONS(3150),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_DASH] = ACTIONS(3148),
    [anon_sym_PLUS] = ACTIONS(3148),
    [anon_sym_STAR] = ACTIONS(3150),
    [anon_sym_AMP_AMP] = ACTIONS(3150),
    [anon_sym_AMP] = ACTIONS(3148),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym___extension__] = ACTIONS(3148),
    [anon_sym_typedef] = ACTIONS(3148),
    [anon_sym_in] = ACTIONS(3148),
    [anon_sym_out] = ACTIONS(3148),
    [anon_sym_inout] = ACTIONS(3148),
    [anon_sym_virtual] = ACTIONS(3148),
    [anon_sym_extern] = ACTIONS(3148),
    [anon_sym___attribute__] = ACTIONS(3148),
    [anon_sym___attribute] = ACTIONS(3148),
    [anon_sym_using] = ACTIONS(3148),
    [anon_sym_COLON_COLON] = ACTIONS(3150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3150),
    [anon_sym___declspec] = ACTIONS(3148),
    [anon_sym___based] = ACTIONS(3148),
    [anon_sym___cdecl] = ACTIONS(3148),
    [anon_sym___clrcall] = ACTIONS(3148),
    [anon_sym___stdcall] = ACTIONS(3148),
    [anon_sym___fastcall] = ACTIONS(3148),
    [anon_sym___thiscall] = ACTIONS(3148),
    [anon_sym___vectorcall] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3150),
    [anon_sym_signed] = ACTIONS(3148),
    [anon_sym_unsigned] = ACTIONS(3148),
    [anon_sym_long] = ACTIONS(3148),
    [anon_sym_short] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_static] = ACTIONS(3148),
    [anon_sym_register] = ACTIONS(3148),
    [anon_sym_inline] = ACTIONS(3148),
    [anon_sym___inline] = ACTIONS(3148),
    [anon_sym___inline__] = ACTIONS(3148),
    [anon_sym___forceinline] = ACTIONS(3148),
    [anon_sym_thread_local] = ACTIONS(3148),
    [anon_sym___thread] = ACTIONS(3148),
    [anon_sym_const] = ACTIONS(3148),
    [anon_sym_constexpr] = ACTIONS(3148),
    [anon_sym_volatile] = ACTIONS(3148),
    [anon_sym_restrict] = ACTIONS(3148),
    [anon_sym___restrict__] = ACTIONS(3148),
    [anon_sym__Atomic] = ACTIONS(3148),
    [anon_sym__Noreturn] = ACTIONS(3148),
    [anon_sym_noreturn] = ACTIONS(3148),
    [anon_sym__Nonnull] = ACTIONS(3148),
    [anon_sym_mutable] = ACTIONS(3148),
    [anon_sym_constinit] = ACTIONS(3148),
    [anon_sym_consteval] = ACTIONS(3148),
    [anon_sym_alignas] = ACTIONS(3148),
    [anon_sym__Alignas] = ACTIONS(3148),
    [sym_primitive_type] = ACTIONS(3148),
    [anon_sym_enum] = ACTIONS(3148),
    [anon_sym_class] = ACTIONS(3148),
    [anon_sym_struct] = ACTIONS(3148),
    [anon_sym_union] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_switch] = ACTIONS(3148),
    [anon_sym_case] = ACTIONS(3148),
    [anon_sym_default] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_for] = ACTIONS(3148),
    [anon_sym_return] = ACTIONS(3148),
    [anon_sym_break] = ACTIONS(3148),
    [anon_sym_continue] = ACTIONS(3148),
    [anon_sym_goto] = ACTIONS(3148),
    [anon_sym___try] = ACTIONS(3148),
    [anon_sym___leave] = ACTIONS(3148),
    [anon_sym_not] = ACTIONS(3148),
    [anon_sym_compl] = ACTIONS(3148),
    [anon_sym_DASH_DASH] = ACTIONS(3150),
    [anon_sym_PLUS_PLUS] = ACTIONS(3150),
    [anon_sym_sizeof] = ACTIONS(3148),
    [anon_sym___alignof__] = ACTIONS(3148),
    [anon_sym___alignof] = ACTIONS(3148),
    [anon_sym__alignof] = ACTIONS(3148),
    [anon_sym_alignof] = ACTIONS(3148),
    [anon_sym__Alignof] = ACTIONS(3148),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3148),
    [anon_sym_asm] = ACTIONS(3148),
    [anon_sym___asm__] = ACTIONS(3148),
    [anon_sym___asm] = ACTIONS(3148),
    [sym_number_literal] = ACTIONS(3150),
    [anon_sym_L_SQUOTE] = ACTIONS(3150),
    [anon_sym_u_SQUOTE] = ACTIONS(3150),
    [anon_sym_U_SQUOTE] = ACTIONS(3150),
    [anon_sym_u8_SQUOTE] = ACTIONS(3150),
    [anon_sym_SQUOTE] = ACTIONS(3150),
    [anon_sym_L_DQUOTE] = ACTIONS(3150),
    [anon_sym_u_DQUOTE] = ACTIONS(3150),
    [anon_sym_U_DQUOTE] = ACTIONS(3150),
    [anon_sym_u8_DQUOTE] = ACTIONS(3150),
    [anon_sym_DQUOTE] = ACTIONS(3150),
    [sym_true] = ACTIONS(3148),
    [sym_false] = ACTIONS(3148),
    [anon_sym_NULL] = ACTIONS(3148),
    [anon_sym_nullptr] = ACTIONS(3148),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3148),
    [anon_sym_let] = ACTIONS(3148),
    [anon_sym_This] = ACTIONS(3148),
    [anon_sym_decltype] = ACTIONS(3148),
    [anon_sym_explicit] = ACTIONS(3148),
    [anon_sym_typename] = ACTIONS(3148),
    [anon_sym_template] = ACTIONS(3148),
    [anon_sym_operator] = ACTIONS(3148),
    [anon_sym_try] = ACTIONS(3148),
    [anon_sym_delete] = ACTIONS(3148),
    [anon_sym_throw] = ACTIONS(3148),
    [anon_sym_namespace] = ACTIONS(3148),
    [anon_sym_static_assert] = ACTIONS(3148),
    [anon_sym_concept] = ACTIONS(3148),
    [anon_sym_co_return] = ACTIONS(3148),
    [anon_sym_co_yield] = ACTIONS(3148),
    [anon_sym_catch] = ACTIONS(3148),
    [anon_sym_R_DQUOTE] = ACTIONS(3150),
    [anon_sym_LR_DQUOTE] = ACTIONS(3150),
    [anon_sym_uR_DQUOTE] = ACTIONS(3150),
    [anon_sym_UR_DQUOTE] = ACTIONS(3150),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3150),
    [anon_sym_co_await] = ACTIONS(3148),
    [anon_sym_new] = ACTIONS(3148),
    [anon_sym_requires] = ACTIONS(3148),
    [sym_this] = ACTIONS(3148),
    [anon_sym_discard] = ACTIONS(3148),
    [anon_sym_precise] = ACTIONS(3148),
    [anon_sym_shared] = ACTIONS(3148),
    [anon_sym_groupshared] = ACTIONS(3148),
    [anon_sym_uniform] = ACTIONS(3148),
    [anon_sym_row_major] = ACTIONS(3148),
    [anon_sym_column_major] = ACTIONS(3148),
    [anon_sym_globallycoherent] = ACTIONS(3148),
    [anon_sym_centroid] = ACTIONS(3148),
    [anon_sym_noperspective] = ACTIONS(3148),
    [anon_sym_nointerpolation] = ACTIONS(3148),
    [anon_sym_sample] = ACTIONS(3148),
    [anon_sym_linear] = ACTIONS(3148),
    [anon_sym_snorm] = ACTIONS(3148),
    [anon_sym_unorm] = ACTIONS(3148),
    [anon_sym_point] = ACTIONS(3148),
    [anon_sym_line] = ACTIONS(3148),
    [anon_sym_triangleadj] = ACTIONS(3148),
    [anon_sym_lineadj] = ACTIONS(3148),
    [anon_sym_triangle] = ACTIONS(3148),
    [anon_sym_cbuffer] = ACTIONS(3148),
    [anon_sym_interface] = ACTIONS(3148),
    [anon_sym_extension] = ACTIONS(3148),
  },
  [675] = {
    [sym_attribute_specifier] = STATE(792),
    [sym_identifier] = ACTIONS(4045),
    [aux_sym_preproc_include_token1] = ACTIONS(4045),
    [aux_sym_preproc_def_token1] = ACTIONS(4045),
    [aux_sym_preproc_if_token1] = ACTIONS(4045),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4045),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4045),
    [sym_preproc_directive] = ACTIONS(4045),
    [anon_sym_LPAREN2] = ACTIONS(4043),
    [anon_sym_BANG] = ACTIONS(4043),
    [anon_sym_TILDE] = ACTIONS(4043),
    [anon_sym_DASH] = ACTIONS(4045),
    [anon_sym_PLUS] = ACTIONS(4045),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_AMP_AMP] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_SEMI] = ACTIONS(4043),
    [anon_sym___extension__] = ACTIONS(4045),
    [anon_sym_typedef] = ACTIONS(4045),
    [anon_sym_in] = ACTIONS(4045),
    [anon_sym_out] = ACTIONS(4045),
    [anon_sym_inout] = ACTIONS(4045),
    [anon_sym_virtual] = ACTIONS(4045),
    [anon_sym_extern] = ACTIONS(4045),
    [anon_sym___attribute__] = ACTIONS(2897),
    [anon_sym___attribute] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(4045),
    [anon_sym_COLON_COLON] = ACTIONS(4043),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4043),
    [anon_sym___declspec] = ACTIONS(4045),
    [anon_sym___based] = ACTIONS(4045),
    [anon_sym___cdecl] = ACTIONS(4045),
    [anon_sym___clrcall] = ACTIONS(4045),
    [anon_sym___stdcall] = ACTIONS(4045),
    [anon_sym___fastcall] = ACTIONS(4045),
    [anon_sym___thiscall] = ACTIONS(4045),
    [anon_sym___vectorcall] = ACTIONS(4045),
    [anon_sym_LBRACE] = ACTIONS(4043),
    [anon_sym_RBRACE] = ACTIONS(4043),
    [anon_sym_signed] = ACTIONS(4045),
    [anon_sym_unsigned] = ACTIONS(4045),
    [anon_sym_long] = ACTIONS(4045),
    [anon_sym_short] = ACTIONS(4045),
    [anon_sym_LBRACK] = ACTIONS(4045),
    [anon_sym_static] = ACTIONS(4045),
    [anon_sym_register] = ACTIONS(4045),
    [anon_sym_inline] = ACTIONS(4045),
    [anon_sym___inline] = ACTIONS(4045),
    [anon_sym___inline__] = ACTIONS(4045),
    [anon_sym___forceinline] = ACTIONS(4045),
    [anon_sym_thread_local] = ACTIONS(4045),
    [anon_sym___thread] = ACTIONS(4045),
    [anon_sym_const] = ACTIONS(4045),
    [anon_sym_constexpr] = ACTIONS(4045),
    [anon_sym_volatile] = ACTIONS(4045),
    [anon_sym_restrict] = ACTIONS(4045),
    [anon_sym___restrict__] = ACTIONS(4045),
    [anon_sym__Atomic] = ACTIONS(4045),
    [anon_sym__Noreturn] = ACTIONS(4045),
    [anon_sym_noreturn] = ACTIONS(4045),
    [anon_sym__Nonnull] = ACTIONS(4045),
    [anon_sym_mutable] = ACTIONS(4045),
    [anon_sym_constinit] = ACTIONS(4045),
    [anon_sym_consteval] = ACTIONS(4045),
    [anon_sym_alignas] = ACTIONS(4045),
    [anon_sym__Alignas] = ACTIONS(4045),
    [sym_primitive_type] = ACTIONS(4045),
    [anon_sym_enum] = ACTIONS(4045),
    [anon_sym_class] = ACTIONS(4045),
    [anon_sym_struct] = ACTIONS(4045),
    [anon_sym_union] = ACTIONS(4045),
    [anon_sym_if] = ACTIONS(4045),
    [anon_sym_switch] = ACTIONS(4045),
    [anon_sym_case] = ACTIONS(4045),
    [anon_sym_default] = ACTIONS(4045),
    [anon_sym_while] = ACTIONS(4045),
    [anon_sym_do] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4045),
    [anon_sym_return] = ACTIONS(4045),
    [anon_sym_break] = ACTIONS(4045),
    [anon_sym_continue] = ACTIONS(4045),
    [anon_sym_goto] = ACTIONS(4045),
    [anon_sym___try] = ACTIONS(4045),
    [anon_sym___leave] = ACTIONS(4045),
    [anon_sym_not] = ACTIONS(4045),
    [anon_sym_compl] = ACTIONS(4045),
    [anon_sym_DASH_DASH] = ACTIONS(4043),
    [anon_sym_PLUS_PLUS] = ACTIONS(4043),
    [anon_sym_sizeof] = ACTIONS(4045),
    [anon_sym___alignof__] = ACTIONS(4045),
    [anon_sym___alignof] = ACTIONS(4045),
    [anon_sym__alignof] = ACTIONS(4045),
    [anon_sym_alignof] = ACTIONS(4045),
    [anon_sym__Alignof] = ACTIONS(4045),
    [anon_sym_offsetof] = ACTIONS(4045),
    [anon_sym__Generic] = ACTIONS(4045),
    [anon_sym_asm] = ACTIONS(4045),
    [anon_sym___asm__] = ACTIONS(4045),
    [anon_sym___asm] = ACTIONS(4045),
    [anon_sym_DOT] = ACTIONS(4045),
    [sym_number_literal] = ACTIONS(4043),
    [anon_sym_L_SQUOTE] = ACTIONS(4043),
    [anon_sym_u_SQUOTE] = ACTIONS(4043),
    [anon_sym_U_SQUOTE] = ACTIONS(4043),
    [anon_sym_u8_SQUOTE] = ACTIONS(4043),
    [anon_sym_SQUOTE] = ACTIONS(4043),
    [anon_sym_L_DQUOTE] = ACTIONS(4043),
    [anon_sym_u_DQUOTE] = ACTIONS(4043),
    [anon_sym_U_DQUOTE] = ACTIONS(4043),
    [anon_sym_u8_DQUOTE] = ACTIONS(4043),
    [anon_sym_DQUOTE] = ACTIONS(4043),
    [sym_true] = ACTIONS(4045),
    [sym_false] = ACTIONS(4045),
    [anon_sym_NULL] = ACTIONS(4045),
    [anon_sym_nullptr] = ACTIONS(4045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4045),
    [anon_sym_let] = ACTIONS(4045),
    [anon_sym_This] = ACTIONS(4045),
    [anon_sym_decltype] = ACTIONS(4045),
    [anon_sym_explicit] = ACTIONS(4045),
    [anon_sym_typename] = ACTIONS(4045),
    [anon_sym_template] = ACTIONS(4045),
    [anon_sym_operator] = ACTIONS(4045),
    [anon_sym_try] = ACTIONS(4045),
    [anon_sym_delete] = ACTIONS(4045),
    [anon_sym_throw] = ACTIONS(4045),
    [anon_sym_namespace] = ACTIONS(4045),
    [anon_sym_static_assert] = ACTIONS(4045),
    [anon_sym_concept] = ACTIONS(4045),
    [anon_sym_co_return] = ACTIONS(4045),
    [anon_sym_co_yield] = ACTIONS(4045),
    [anon_sym_R_DQUOTE] = ACTIONS(4043),
    [anon_sym_LR_DQUOTE] = ACTIONS(4043),
    [anon_sym_uR_DQUOTE] = ACTIONS(4043),
    [anon_sym_UR_DQUOTE] = ACTIONS(4043),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4043),
    [anon_sym_co_await] = ACTIONS(4045),
    [anon_sym_new] = ACTIONS(4045),
    [anon_sym_requires] = ACTIONS(4045),
    [sym_this] = ACTIONS(4045),
    [anon_sym_discard] = ACTIONS(4045),
    [anon_sym_precise] = ACTIONS(4045),
    [anon_sym_shared] = ACTIONS(4045),
    [anon_sym_groupshared] = ACTIONS(4045),
    [anon_sym_uniform] = ACTIONS(4045),
    [anon_sym_row_major] = ACTIONS(4045),
    [anon_sym_column_major] = ACTIONS(4045),
    [anon_sym_globallycoherent] = ACTIONS(4045),
    [anon_sym_centroid] = ACTIONS(4045),
    [anon_sym_noperspective] = ACTIONS(4045),
    [anon_sym_nointerpolation] = ACTIONS(4045),
    [anon_sym_sample] = ACTIONS(4045),
    [anon_sym_linear] = ACTIONS(4045),
    [anon_sym_snorm] = ACTIONS(4045),
    [anon_sym_unorm] = ACTIONS(4045),
    [anon_sym_point] = ACTIONS(4045),
    [anon_sym_line] = ACTIONS(4045),
    [anon_sym_triangleadj] = ACTIONS(4045),
    [anon_sym_lineadj] = ACTIONS(4045),
    [anon_sym_triangle] = ACTIONS(4045),
    [anon_sym_cbuffer] = ACTIONS(4045),
    [anon_sym_interface] = ACTIONS(4045),
    [anon_sym_extension] = ACTIONS(4045),
  },
  [676] = {
    [sym_else_clause] = STATE(806),
    [sym_identifier] = ACTIONS(3214),
    [aux_sym_preproc_include_token1] = ACTIONS(3214),
    [aux_sym_preproc_def_token1] = ACTIONS(3214),
    [aux_sym_preproc_if_token1] = ACTIONS(3214),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3214),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3214),
    [sym_preproc_directive] = ACTIONS(3214),
    [anon_sym_LPAREN2] = ACTIONS(3212),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3214),
    [anon_sym_STAR] = ACTIONS(3212),
    [anon_sym_AMP_AMP] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3214),
    [anon_sym_SEMI] = ACTIONS(3212),
    [anon_sym___extension__] = ACTIONS(3214),
    [anon_sym_typedef] = ACTIONS(3214),
    [anon_sym_in] = ACTIONS(3214),
    [anon_sym_out] = ACTIONS(3214),
    [anon_sym_inout] = ACTIONS(3214),
    [anon_sym_virtual] = ACTIONS(3214),
    [anon_sym_extern] = ACTIONS(3214),
    [anon_sym___attribute__] = ACTIONS(3214),
    [anon_sym___attribute] = ACTIONS(3214),
    [anon_sym_using] = ACTIONS(3214),
    [anon_sym_COLON_COLON] = ACTIONS(3212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3212),
    [anon_sym___declspec] = ACTIONS(3214),
    [anon_sym___based] = ACTIONS(3214),
    [anon_sym___cdecl] = ACTIONS(3214),
    [anon_sym___clrcall] = ACTIONS(3214),
    [anon_sym___stdcall] = ACTIONS(3214),
    [anon_sym___fastcall] = ACTIONS(3214),
    [anon_sym___thiscall] = ACTIONS(3214),
    [anon_sym___vectorcall] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_RBRACE] = ACTIONS(3212),
    [anon_sym_signed] = ACTIONS(3214),
    [anon_sym_unsigned] = ACTIONS(3214),
    [anon_sym_long] = ACTIONS(3214),
    [anon_sym_short] = ACTIONS(3214),
    [anon_sym_LBRACK] = ACTIONS(3214),
    [anon_sym_static] = ACTIONS(3214),
    [anon_sym_register] = ACTIONS(3214),
    [anon_sym_inline] = ACTIONS(3214),
    [anon_sym___inline] = ACTIONS(3214),
    [anon_sym___inline__] = ACTIONS(3214),
    [anon_sym___forceinline] = ACTIONS(3214),
    [anon_sym_thread_local] = ACTIONS(3214),
    [anon_sym___thread] = ACTIONS(3214),
    [anon_sym_const] = ACTIONS(3214),
    [anon_sym_constexpr] = ACTIONS(3214),
    [anon_sym_volatile] = ACTIONS(3214),
    [anon_sym_restrict] = ACTIONS(3214),
    [anon_sym___restrict__] = ACTIONS(3214),
    [anon_sym__Atomic] = ACTIONS(3214),
    [anon_sym__Noreturn] = ACTIONS(3214),
    [anon_sym_noreturn] = ACTIONS(3214),
    [anon_sym__Nonnull] = ACTIONS(3214),
    [anon_sym_mutable] = ACTIONS(3214),
    [anon_sym_constinit] = ACTIONS(3214),
    [anon_sym_consteval] = ACTIONS(3214),
    [anon_sym_alignas] = ACTIONS(3214),
    [anon_sym__Alignas] = ACTIONS(3214),
    [sym_primitive_type] = ACTIONS(3214),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3214),
    [anon_sym_struct] = ACTIONS(3214),
    [anon_sym_union] = ACTIONS(3214),
    [anon_sym_if] = ACTIONS(3214),
    [anon_sym_else] = ACTIONS(4069),
    [anon_sym_switch] = ACTIONS(3214),
    [anon_sym_case] = ACTIONS(3214),
    [anon_sym_default] = ACTIONS(3214),
    [anon_sym_while] = ACTIONS(3214),
    [anon_sym_do] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3214),
    [anon_sym_return] = ACTIONS(3214),
    [anon_sym_break] = ACTIONS(3214),
    [anon_sym_continue] = ACTIONS(3214),
    [anon_sym_goto] = ACTIONS(3214),
    [anon_sym___try] = ACTIONS(3214),
    [anon_sym___leave] = ACTIONS(3214),
    [anon_sym_not] = ACTIONS(3214),
    [anon_sym_compl] = ACTIONS(3214),
    [anon_sym_DASH_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_PLUS] = ACTIONS(3212),
    [anon_sym_sizeof] = ACTIONS(3214),
    [anon_sym___alignof__] = ACTIONS(3214),
    [anon_sym___alignof] = ACTIONS(3214),
    [anon_sym__alignof] = ACTIONS(3214),
    [anon_sym_alignof] = ACTIONS(3214),
    [anon_sym__Alignof] = ACTIONS(3214),
    [anon_sym_offsetof] = ACTIONS(3214),
    [anon_sym__Generic] = ACTIONS(3214),
    [anon_sym_asm] = ACTIONS(3214),
    [anon_sym___asm__] = ACTIONS(3214),
    [anon_sym___asm] = ACTIONS(3214),
    [sym_number_literal] = ACTIONS(3212),
    [anon_sym_L_SQUOTE] = ACTIONS(3212),
    [anon_sym_u_SQUOTE] = ACTIONS(3212),
    [anon_sym_U_SQUOTE] = ACTIONS(3212),
    [anon_sym_u8_SQUOTE] = ACTIONS(3212),
    [anon_sym_SQUOTE] = ACTIONS(3212),
    [anon_sym_L_DQUOTE] = ACTIONS(3212),
    [anon_sym_u_DQUOTE] = ACTIONS(3212),
    [anon_sym_U_DQUOTE] = ACTIONS(3212),
    [anon_sym_u8_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [sym_true] = ACTIONS(3214),
    [sym_false] = ACTIONS(3214),
    [anon_sym_NULL] = ACTIONS(3214),
    [anon_sym_nullptr] = ACTIONS(3214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3214),
    [anon_sym_let] = ACTIONS(3214),
    [anon_sym_This] = ACTIONS(3214),
    [anon_sym_decltype] = ACTIONS(3214),
    [anon_sym_explicit] = ACTIONS(3214),
    [anon_sym_typename] = ACTIONS(3214),
    [anon_sym_template] = ACTIONS(3214),
    [anon_sym_operator] = ACTIONS(3214),
    [anon_sym_try] = ACTIONS(3214),
    [anon_sym_delete] = ACTIONS(3214),
    [anon_sym_throw] = ACTIONS(3214),
    [anon_sym_namespace] = ACTIONS(3214),
    [anon_sym_static_assert] = ACTIONS(3214),
    [anon_sym_concept] = ACTIONS(3214),
    [anon_sym_co_return] = ACTIONS(3214),
    [anon_sym_co_yield] = ACTIONS(3214),
    [anon_sym_R_DQUOTE] = ACTIONS(3212),
    [anon_sym_LR_DQUOTE] = ACTIONS(3212),
    [anon_sym_uR_DQUOTE] = ACTIONS(3212),
    [anon_sym_UR_DQUOTE] = ACTIONS(3212),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3212),
    [anon_sym_co_await] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3214),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(3214),
    [anon_sym_discard] = ACTIONS(3214),
    [anon_sym_precise] = ACTIONS(3214),
    [anon_sym_shared] = ACTIONS(3214),
    [anon_sym_groupshared] = ACTIONS(3214),
    [anon_sym_uniform] = ACTIONS(3214),
    [anon_sym_row_major] = ACTIONS(3214),
    [anon_sym_column_major] = ACTIONS(3214),
    [anon_sym_globallycoherent] = ACTIONS(3214),
    [anon_sym_centroid] = ACTIONS(3214),
    [anon_sym_noperspective] = ACTIONS(3214),
    [anon_sym_nointerpolation] = ACTIONS(3214),
    [anon_sym_sample] = ACTIONS(3214),
    [anon_sym_linear] = ACTIONS(3214),
    [anon_sym_snorm] = ACTIONS(3214),
    [anon_sym_unorm] = ACTIONS(3214),
    [anon_sym_point] = ACTIONS(3214),
    [anon_sym_line] = ACTIONS(3214),
    [anon_sym_triangleadj] = ACTIONS(3214),
    [anon_sym_lineadj] = ACTIONS(3214),
    [anon_sym_triangle] = ACTIONS(3214),
    [anon_sym_cbuffer] = ACTIONS(3214),
    [anon_sym_interface] = ACTIONS(3214),
    [anon_sym_extension] = ACTIONS(3214),
  },
  [677] = {
    [sym_else_clause] = STATE(740),
    [sym_identifier] = ACTIONS(3096),
    [aux_sym_preproc_include_token1] = ACTIONS(3096),
    [aux_sym_preproc_def_token1] = ACTIONS(3096),
    [aux_sym_preproc_if_token1] = ACTIONS(3096),
    [aux_sym_preproc_if_token2] = ACTIONS(3096),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3096),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3096),
    [sym_preproc_directive] = ACTIONS(3096),
    [anon_sym_LPAREN2] = ACTIONS(3094),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_TILDE] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3096),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_STAR] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_AMP] = ACTIONS(3096),
    [anon_sym_SEMI] = ACTIONS(3094),
    [anon_sym___extension__] = ACTIONS(3096),
    [anon_sym_typedef] = ACTIONS(3096),
    [anon_sym_in] = ACTIONS(3096),
    [anon_sym_out] = ACTIONS(3096),
    [anon_sym_inout] = ACTIONS(3096),
    [anon_sym_virtual] = ACTIONS(3096),
    [anon_sym_extern] = ACTIONS(3096),
    [anon_sym___attribute__] = ACTIONS(3096),
    [anon_sym___attribute] = ACTIONS(3096),
    [anon_sym_using] = ACTIONS(3096),
    [anon_sym_COLON_COLON] = ACTIONS(3094),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3094),
    [anon_sym___declspec] = ACTIONS(3096),
    [anon_sym___based] = ACTIONS(3096),
    [anon_sym___cdecl] = ACTIONS(3096),
    [anon_sym___clrcall] = ACTIONS(3096),
    [anon_sym___stdcall] = ACTIONS(3096),
    [anon_sym___fastcall] = ACTIONS(3096),
    [anon_sym___thiscall] = ACTIONS(3096),
    [anon_sym___vectorcall] = ACTIONS(3096),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_signed] = ACTIONS(3096),
    [anon_sym_unsigned] = ACTIONS(3096),
    [anon_sym_long] = ACTIONS(3096),
    [anon_sym_short] = ACTIONS(3096),
    [anon_sym_LBRACK] = ACTIONS(3096),
    [anon_sym_static] = ACTIONS(3096),
    [anon_sym_register] = ACTIONS(3096),
    [anon_sym_inline] = ACTIONS(3096),
    [anon_sym___inline] = ACTIONS(3096),
    [anon_sym___inline__] = ACTIONS(3096),
    [anon_sym___forceinline] = ACTIONS(3096),
    [anon_sym_thread_local] = ACTIONS(3096),
    [anon_sym___thread] = ACTIONS(3096),
    [anon_sym_const] = ACTIONS(3096),
    [anon_sym_constexpr] = ACTIONS(3096),
    [anon_sym_volatile] = ACTIONS(3096),
    [anon_sym_restrict] = ACTIONS(3096),
    [anon_sym___restrict__] = ACTIONS(3096),
    [anon_sym__Atomic] = ACTIONS(3096),
    [anon_sym__Noreturn] = ACTIONS(3096),
    [anon_sym_noreturn] = ACTIONS(3096),
    [anon_sym__Nonnull] = ACTIONS(3096),
    [anon_sym_mutable] = ACTIONS(3096),
    [anon_sym_constinit] = ACTIONS(3096),
    [anon_sym_consteval] = ACTIONS(3096),
    [anon_sym_alignas] = ACTIONS(3096),
    [anon_sym__Alignas] = ACTIONS(3096),
    [sym_primitive_type] = ACTIONS(3096),
    [anon_sym_enum] = ACTIONS(3096),
    [anon_sym_class] = ACTIONS(3096),
    [anon_sym_struct] = ACTIONS(3096),
    [anon_sym_union] = ACTIONS(3096),
    [anon_sym_if] = ACTIONS(3096),
    [anon_sym_else] = ACTIONS(4006),
    [anon_sym_switch] = ACTIONS(3096),
    [anon_sym_case] = ACTIONS(3096),
    [anon_sym_default] = ACTIONS(3096),
    [anon_sym_while] = ACTIONS(3096),
    [anon_sym_do] = ACTIONS(3096),
    [anon_sym_for] = ACTIONS(3096),
    [anon_sym_return] = ACTIONS(3096),
    [anon_sym_break] = ACTIONS(3096),
    [anon_sym_continue] = ACTIONS(3096),
    [anon_sym_goto] = ACTIONS(3096),
    [anon_sym___try] = ACTIONS(3096),
    [anon_sym___leave] = ACTIONS(3096),
    [anon_sym_not] = ACTIONS(3096),
    [anon_sym_compl] = ACTIONS(3096),
    [anon_sym_DASH_DASH] = ACTIONS(3094),
    [anon_sym_PLUS_PLUS] = ACTIONS(3094),
    [anon_sym_sizeof] = ACTIONS(3096),
    [anon_sym___alignof__] = ACTIONS(3096),
    [anon_sym___alignof] = ACTIONS(3096),
    [anon_sym__alignof] = ACTIONS(3096),
    [anon_sym_alignof] = ACTIONS(3096),
    [anon_sym__Alignof] = ACTIONS(3096),
    [anon_sym_offsetof] = ACTIONS(3096),
    [anon_sym__Generic] = ACTIONS(3096),
    [anon_sym_asm] = ACTIONS(3096),
    [anon_sym___asm__] = ACTIONS(3096),
    [anon_sym___asm] = ACTIONS(3096),
    [sym_number_literal] = ACTIONS(3094),
    [anon_sym_L_SQUOTE] = ACTIONS(3094),
    [anon_sym_u_SQUOTE] = ACTIONS(3094),
    [anon_sym_U_SQUOTE] = ACTIONS(3094),
    [anon_sym_u8_SQUOTE] = ACTIONS(3094),
    [anon_sym_SQUOTE] = ACTIONS(3094),
    [anon_sym_L_DQUOTE] = ACTIONS(3094),
    [anon_sym_u_DQUOTE] = ACTIONS(3094),
    [anon_sym_U_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8_DQUOTE] = ACTIONS(3094),
    [anon_sym_DQUOTE] = ACTIONS(3094),
    [sym_true] = ACTIONS(3096),
    [sym_false] = ACTIONS(3096),
    [anon_sym_NULL] = ACTIONS(3096),
    [anon_sym_nullptr] = ACTIONS(3096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3096),
    [anon_sym_let] = ACTIONS(3096),
    [anon_sym_This] = ACTIONS(3096),
    [anon_sym_decltype] = ACTIONS(3096),
    [anon_sym_explicit] = ACTIONS(3096),
    [anon_sym_typename] = ACTIONS(3096),
    [anon_sym_template] = ACTIONS(3096),
    [anon_sym_operator] = ACTIONS(3096),
    [anon_sym_try] = ACTIONS(3096),
    [anon_sym_delete] = ACTIONS(3096),
    [anon_sym_throw] = ACTIONS(3096),
    [anon_sym_namespace] = ACTIONS(3096),
    [anon_sym_static_assert] = ACTIONS(3096),
    [anon_sym_concept] = ACTIONS(3096),
    [anon_sym_co_return] = ACTIONS(3096),
    [anon_sym_co_yield] = ACTIONS(3096),
    [anon_sym_R_DQUOTE] = ACTIONS(3094),
    [anon_sym_LR_DQUOTE] = ACTIONS(3094),
    [anon_sym_uR_DQUOTE] = ACTIONS(3094),
    [anon_sym_UR_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3094),
    [anon_sym_co_await] = ACTIONS(3096),
    [anon_sym_new] = ACTIONS(3096),
    [anon_sym_requires] = ACTIONS(3096),
    [sym_this] = ACTIONS(3096),
    [anon_sym_discard] = ACTIONS(3096),
    [anon_sym_precise] = ACTIONS(3096),
    [anon_sym_shared] = ACTIONS(3096),
    [anon_sym_groupshared] = ACTIONS(3096),
    [anon_sym_uniform] = ACTIONS(3096),
    [anon_sym_row_major] = ACTIONS(3096),
    [anon_sym_column_major] = ACTIONS(3096),
    [anon_sym_globallycoherent] = ACTIONS(3096),
    [anon_sym_centroid] = ACTIONS(3096),
    [anon_sym_noperspective] = ACTIONS(3096),
    [anon_sym_nointerpolation] = ACTIONS(3096),
    [anon_sym_sample] = ACTIONS(3096),
    [anon_sym_linear] = ACTIONS(3096),
    [anon_sym_snorm] = ACTIONS(3096),
    [anon_sym_unorm] = ACTIONS(3096),
    [anon_sym_point] = ACTIONS(3096),
    [anon_sym_line] = ACTIONS(3096),
    [anon_sym_triangleadj] = ACTIONS(3096),
    [anon_sym_lineadj] = ACTIONS(3096),
    [anon_sym_triangle] = ACTIONS(3096),
    [anon_sym_cbuffer] = ACTIONS(3096),
    [anon_sym_interface] = ACTIONS(3096),
    [anon_sym_extension] = ACTIONS(3096),
  },
  [678] = {
    [sym_attribute_specifier] = STATE(303),
    [ts_builtin_sym_end] = ACTIONS(4109),
    [sym_identifier] = ACTIONS(4107),
    [aux_sym_preproc_include_token1] = ACTIONS(4107),
    [aux_sym_preproc_def_token1] = ACTIONS(4107),
    [aux_sym_preproc_if_token1] = ACTIONS(4107),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4107),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4107),
    [sym_preproc_directive] = ACTIONS(4107),
    [anon_sym_LPAREN2] = ACTIONS(4109),
    [anon_sym_BANG] = ACTIONS(4109),
    [anon_sym_TILDE] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4107),
    [anon_sym_STAR] = ACTIONS(4109),
    [anon_sym_AMP_AMP] = ACTIONS(4109),
    [anon_sym_AMP] = ACTIONS(4107),
    [anon_sym_SEMI] = ACTIONS(4109),
    [anon_sym___extension__] = ACTIONS(4107),
    [anon_sym_typedef] = ACTIONS(4107),
    [anon_sym_in] = ACTIONS(4107),
    [anon_sym_out] = ACTIONS(4107),
    [anon_sym_inout] = ACTIONS(4107),
    [anon_sym_virtual] = ACTIONS(4107),
    [anon_sym_extern] = ACTIONS(4107),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(4107),
    [anon_sym_COLON_COLON] = ACTIONS(4109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4109),
    [anon_sym___declspec] = ACTIONS(4107),
    [anon_sym___based] = ACTIONS(4107),
    [anon_sym___cdecl] = ACTIONS(4107),
    [anon_sym___clrcall] = ACTIONS(4107),
    [anon_sym___stdcall] = ACTIONS(4107),
    [anon_sym___fastcall] = ACTIONS(4107),
    [anon_sym___thiscall] = ACTIONS(4107),
    [anon_sym___vectorcall] = ACTIONS(4107),
    [anon_sym_LBRACE] = ACTIONS(4109),
    [anon_sym_signed] = ACTIONS(4107),
    [anon_sym_unsigned] = ACTIONS(4107),
    [anon_sym_long] = ACTIONS(4107),
    [anon_sym_short] = ACTIONS(4107),
    [anon_sym_LBRACK] = ACTIONS(4107),
    [anon_sym_static] = ACTIONS(4107),
    [anon_sym_register] = ACTIONS(4107),
    [anon_sym_inline] = ACTIONS(4107),
    [anon_sym___inline] = ACTIONS(4107),
    [anon_sym___inline__] = ACTIONS(4107),
    [anon_sym___forceinline] = ACTIONS(4107),
    [anon_sym_thread_local] = ACTIONS(4107),
    [anon_sym___thread] = ACTIONS(4107),
    [anon_sym_const] = ACTIONS(4107),
    [anon_sym_constexpr] = ACTIONS(4107),
    [anon_sym_volatile] = ACTIONS(4107),
    [anon_sym_restrict] = ACTIONS(4107),
    [anon_sym___restrict__] = ACTIONS(4107),
    [anon_sym__Atomic] = ACTIONS(4107),
    [anon_sym__Noreturn] = ACTIONS(4107),
    [anon_sym_noreturn] = ACTIONS(4107),
    [anon_sym__Nonnull] = ACTIONS(4107),
    [anon_sym_mutable] = ACTIONS(4107),
    [anon_sym_constinit] = ACTIONS(4107),
    [anon_sym_consteval] = ACTIONS(4107),
    [anon_sym_alignas] = ACTIONS(4107),
    [anon_sym__Alignas] = ACTIONS(4107),
    [sym_primitive_type] = ACTIONS(4107),
    [anon_sym_enum] = ACTIONS(4107),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4107),
    [anon_sym_union] = ACTIONS(4107),
    [anon_sym_if] = ACTIONS(4107),
    [anon_sym_switch] = ACTIONS(4107),
    [anon_sym_case] = ACTIONS(4107),
    [anon_sym_default] = ACTIONS(4107),
    [anon_sym_while] = ACTIONS(4107),
    [anon_sym_do] = ACTIONS(4107),
    [anon_sym_for] = ACTIONS(4107),
    [anon_sym_return] = ACTIONS(4107),
    [anon_sym_break] = ACTIONS(4107),
    [anon_sym_continue] = ACTIONS(4107),
    [anon_sym_goto] = ACTIONS(4107),
    [anon_sym_not] = ACTIONS(4107),
    [anon_sym_compl] = ACTIONS(4107),
    [anon_sym_DASH_DASH] = ACTIONS(4109),
    [anon_sym_PLUS_PLUS] = ACTIONS(4109),
    [anon_sym_sizeof] = ACTIONS(4107),
    [anon_sym___alignof__] = ACTIONS(4107),
    [anon_sym___alignof] = ACTIONS(4107),
    [anon_sym__alignof] = ACTIONS(4107),
    [anon_sym_alignof] = ACTIONS(4107),
    [anon_sym__Alignof] = ACTIONS(4107),
    [anon_sym_offsetof] = ACTIONS(4107),
    [anon_sym__Generic] = ACTIONS(4107),
    [anon_sym_asm] = ACTIONS(4107),
    [anon_sym___asm__] = ACTIONS(4107),
    [anon_sym___asm] = ACTIONS(4107),
    [anon_sym_DOT] = ACTIONS(4107),
    [sym_number_literal] = ACTIONS(4109),
    [anon_sym_L_SQUOTE] = ACTIONS(4109),
    [anon_sym_u_SQUOTE] = ACTIONS(4109),
    [anon_sym_U_SQUOTE] = ACTIONS(4109),
    [anon_sym_u8_SQUOTE] = ACTIONS(4109),
    [anon_sym_SQUOTE] = ACTIONS(4109),
    [anon_sym_L_DQUOTE] = ACTIONS(4109),
    [anon_sym_u_DQUOTE] = ACTIONS(4109),
    [anon_sym_U_DQUOTE] = ACTIONS(4109),
    [anon_sym_u8_DQUOTE] = ACTIONS(4109),
    [anon_sym_DQUOTE] = ACTIONS(4109),
    [sym_true] = ACTIONS(4107),
    [sym_false] = ACTIONS(4107),
    [anon_sym_NULL] = ACTIONS(4107),
    [anon_sym_nullptr] = ACTIONS(4107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4107),
    [anon_sym_let] = ACTIONS(4107),
    [anon_sym_This] = ACTIONS(4107),
    [anon_sym_decltype] = ACTIONS(4107),
    [anon_sym_explicit] = ACTIONS(4107),
    [anon_sym_typename] = ACTIONS(4107),
    [anon_sym_export] = ACTIONS(4107),
    [anon_sym_module] = ACTIONS(4107),
    [anon_sym_import] = ACTIONS(4107),
    [anon_sym_template] = ACTIONS(4107),
    [anon_sym_operator] = ACTIONS(4107),
    [anon_sym_try] = ACTIONS(4107),
    [anon_sym_delete] = ACTIONS(4107),
    [anon_sym_throw] = ACTIONS(4107),
    [anon_sym_namespace] = ACTIONS(4107),
    [anon_sym_static_assert] = ACTIONS(4107),
    [anon_sym_concept] = ACTIONS(4107),
    [anon_sym_co_return] = ACTIONS(4107),
    [anon_sym_co_yield] = ACTIONS(4107),
    [anon_sym_R_DQUOTE] = ACTIONS(4109),
    [anon_sym_LR_DQUOTE] = ACTIONS(4109),
    [anon_sym_uR_DQUOTE] = ACTIONS(4109),
    [anon_sym_UR_DQUOTE] = ACTIONS(4109),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4109),
    [anon_sym_co_await] = ACTIONS(4107),
    [anon_sym_new] = ACTIONS(4107),
    [anon_sym_requires] = ACTIONS(4107),
    [sym_this] = ACTIONS(4107),
    [anon_sym_precise] = ACTIONS(4107),
    [anon_sym_shared] = ACTIONS(4107),
    [anon_sym_groupshared] = ACTIONS(4107),
    [anon_sym_uniform] = ACTIONS(4107),
    [anon_sym_row_major] = ACTIONS(4107),
    [anon_sym_column_major] = ACTIONS(4107),
    [anon_sym_globallycoherent] = ACTIONS(4107),
    [anon_sym_centroid] = ACTIONS(4107),
    [anon_sym_noperspective] = ACTIONS(4107),
    [anon_sym_nointerpolation] = ACTIONS(4107),
    [anon_sym_sample] = ACTIONS(4107),
    [anon_sym_linear] = ACTIONS(4107),
    [anon_sym_snorm] = ACTIONS(4107),
    [anon_sym_unorm] = ACTIONS(4107),
    [anon_sym_point] = ACTIONS(4107),
    [anon_sym_line] = ACTIONS(4107),
    [anon_sym_triangleadj] = ACTIONS(4107),
    [anon_sym_lineadj] = ACTIONS(4107),
    [anon_sym_triangle] = ACTIONS(4107),
    [anon_sym_interface] = ACTIONS(4107),
    [anon_sym_extension] = ACTIONS(4107),
    [anon_sym___exported] = ACTIONS(4107),
  },
  [679] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(284),
    [ts_builtin_sym_end] = ACTIONS(4080),
    [sym_identifier] = ACTIONS(4078),
    [aux_sym_preproc_include_token1] = ACTIONS(4078),
    [aux_sym_preproc_def_token1] = ACTIONS(4078),
    [aux_sym_preproc_if_token1] = ACTIONS(4078),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4078),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4078),
    [sym_preproc_directive] = ACTIONS(4078),
    [anon_sym_LPAREN2] = ACTIONS(4080),
    [anon_sym_BANG] = ACTIONS(4080),
    [anon_sym_TILDE] = ACTIONS(4080),
    [anon_sym_DASH] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(4078),
    [anon_sym_STAR] = ACTIONS(4080),
    [anon_sym_AMP_AMP] = ACTIONS(4080),
    [anon_sym_AMP] = ACTIONS(4078),
    [anon_sym_SEMI] = ACTIONS(4080),
    [anon_sym___extension__] = ACTIONS(4078),
    [anon_sym_typedef] = ACTIONS(4078),
    [anon_sym_in] = ACTIONS(4078),
    [anon_sym_out] = ACTIONS(4078),
    [anon_sym_inout] = ACTIONS(4078),
    [anon_sym_virtual] = ACTIONS(4078),
    [anon_sym_extern] = ACTIONS(4078),
    [anon_sym___attribute__] = ACTIONS(4078),
    [anon_sym___attribute] = ACTIONS(4078),
    [anon_sym_using] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(4080),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4080),
    [anon_sym___declspec] = ACTIONS(4078),
    [anon_sym___based] = ACTIONS(4078),
    [anon_sym___cdecl] = ACTIONS(4078),
    [anon_sym___clrcall] = ACTIONS(4078),
    [anon_sym___stdcall] = ACTIONS(4078),
    [anon_sym___fastcall] = ACTIONS(4078),
    [anon_sym___thiscall] = ACTIONS(4078),
    [anon_sym___vectorcall] = ACTIONS(4078),
    [anon_sym_LBRACE] = ACTIONS(4080),
    [anon_sym_signed] = ACTIONS(4158),
    [anon_sym_unsigned] = ACTIONS(4158),
    [anon_sym_long] = ACTIONS(4158),
    [anon_sym_short] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_static] = ACTIONS(4078),
    [anon_sym_register] = ACTIONS(4078),
    [anon_sym_inline] = ACTIONS(4078),
    [anon_sym___inline] = ACTIONS(4078),
    [anon_sym___inline__] = ACTIONS(4078),
    [anon_sym___forceinline] = ACTIONS(4078),
    [anon_sym_thread_local] = ACTIONS(4078),
    [anon_sym___thread] = ACTIONS(4078),
    [anon_sym_const] = ACTIONS(4078),
    [anon_sym_constexpr] = ACTIONS(4078),
    [anon_sym_volatile] = ACTIONS(4078),
    [anon_sym_restrict] = ACTIONS(4078),
    [anon_sym___restrict__] = ACTIONS(4078),
    [anon_sym__Atomic] = ACTIONS(4078),
    [anon_sym__Noreturn] = ACTIONS(4078),
    [anon_sym_noreturn] = ACTIONS(4078),
    [anon_sym__Nonnull] = ACTIONS(4078),
    [anon_sym_mutable] = ACTIONS(4078),
    [anon_sym_constinit] = ACTIONS(4078),
    [anon_sym_consteval] = ACTIONS(4078),
    [anon_sym_alignas] = ACTIONS(4078),
    [anon_sym__Alignas] = ACTIONS(4078),
    [sym_primitive_type] = ACTIONS(4078),
    [anon_sym_enum] = ACTIONS(4078),
    [anon_sym_class] = ACTIONS(4078),
    [anon_sym_struct] = ACTIONS(4078),
    [anon_sym_union] = ACTIONS(4078),
    [anon_sym_if] = ACTIONS(4078),
    [anon_sym_switch] = ACTIONS(4078),
    [anon_sym_case] = ACTIONS(4078),
    [anon_sym_default] = ACTIONS(4078),
    [anon_sym_while] = ACTIONS(4078),
    [anon_sym_do] = ACTIONS(4078),
    [anon_sym_for] = ACTIONS(4078),
    [anon_sym_return] = ACTIONS(4078),
    [anon_sym_break] = ACTIONS(4078),
    [anon_sym_continue] = ACTIONS(4078),
    [anon_sym_goto] = ACTIONS(4078),
    [anon_sym_not] = ACTIONS(4078),
    [anon_sym_compl] = ACTIONS(4078),
    [anon_sym_DASH_DASH] = ACTIONS(4080),
    [anon_sym_PLUS_PLUS] = ACTIONS(4080),
    [anon_sym_sizeof] = ACTIONS(4078),
    [anon_sym___alignof__] = ACTIONS(4078),
    [anon_sym___alignof] = ACTIONS(4078),
    [anon_sym__alignof] = ACTIONS(4078),
    [anon_sym_alignof] = ACTIONS(4078),
    [anon_sym__Alignof] = ACTIONS(4078),
    [anon_sym_offsetof] = ACTIONS(4078),
    [anon_sym__Generic] = ACTIONS(4078),
    [anon_sym_asm] = ACTIONS(4078),
    [anon_sym___asm__] = ACTIONS(4078),
    [anon_sym___asm] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(4078),
    [sym_number_literal] = ACTIONS(4080),
    [anon_sym_L_SQUOTE] = ACTIONS(4080),
    [anon_sym_u_SQUOTE] = ACTIONS(4080),
    [anon_sym_U_SQUOTE] = ACTIONS(4080),
    [anon_sym_u8_SQUOTE] = ACTIONS(4080),
    [anon_sym_SQUOTE] = ACTIONS(4080),
    [anon_sym_L_DQUOTE] = ACTIONS(4080),
    [anon_sym_u_DQUOTE] = ACTIONS(4080),
    [anon_sym_U_DQUOTE] = ACTIONS(4080),
    [anon_sym_u8_DQUOTE] = ACTIONS(4080),
    [anon_sym_DQUOTE] = ACTIONS(4080),
    [sym_true] = ACTIONS(4078),
    [sym_false] = ACTIONS(4078),
    [anon_sym_NULL] = ACTIONS(4078),
    [anon_sym_nullptr] = ACTIONS(4078),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4078),
    [anon_sym_let] = ACTIONS(4078),
    [anon_sym_This] = ACTIONS(4078),
    [anon_sym_decltype] = ACTIONS(4078),
    [anon_sym_explicit] = ACTIONS(4078),
    [anon_sym_typename] = ACTIONS(4078),
    [anon_sym_export] = ACTIONS(4078),
    [anon_sym_module] = ACTIONS(4078),
    [anon_sym_import] = ACTIONS(4078),
    [anon_sym_template] = ACTIONS(4078),
    [anon_sym_operator] = ACTIONS(4078),
    [anon_sym_try] = ACTIONS(4078),
    [anon_sym_delete] = ACTIONS(4078),
    [anon_sym_throw] = ACTIONS(4078),
    [anon_sym_namespace] = ACTIONS(4078),
    [anon_sym_static_assert] = ACTIONS(4078),
    [anon_sym_concept] = ACTIONS(4078),
    [anon_sym_co_return] = ACTIONS(4078),
    [anon_sym_co_yield] = ACTIONS(4078),
    [anon_sym_R_DQUOTE] = ACTIONS(4080),
    [anon_sym_LR_DQUOTE] = ACTIONS(4080),
    [anon_sym_uR_DQUOTE] = ACTIONS(4080),
    [anon_sym_UR_DQUOTE] = ACTIONS(4080),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4080),
    [anon_sym_co_await] = ACTIONS(4078),
    [anon_sym_new] = ACTIONS(4078),
    [anon_sym_requires] = ACTIONS(4078),
    [sym_this] = ACTIONS(4078),
    [anon_sym_precise] = ACTIONS(4078),
    [anon_sym_shared] = ACTIONS(4078),
    [anon_sym_groupshared] = ACTIONS(4078),
    [anon_sym_uniform] = ACTIONS(4078),
    [anon_sym_row_major] = ACTIONS(4078),
    [anon_sym_column_major] = ACTIONS(4078),
    [anon_sym_globallycoherent] = ACTIONS(4078),
    [anon_sym_centroid] = ACTIONS(4078),
    [anon_sym_noperspective] = ACTIONS(4078),
    [anon_sym_nointerpolation] = ACTIONS(4078),
    [anon_sym_sample] = ACTIONS(4078),
    [anon_sym_linear] = ACTIONS(4078),
    [anon_sym_snorm] = ACTIONS(4078),
    [anon_sym_unorm] = ACTIONS(4078),
    [anon_sym_point] = ACTIONS(4078),
    [anon_sym_line] = ACTIONS(4078),
    [anon_sym_triangleadj] = ACTIONS(4078),
    [anon_sym_lineadj] = ACTIONS(4078),
    [anon_sym_triangle] = ACTIONS(4078),
    [anon_sym_interface] = ACTIONS(4078),
    [anon_sym_extension] = ACTIONS(4078),
    [anon_sym___exported] = ACTIONS(4078),
  },
  [680] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(672),
    [sym_identifier] = ACTIONS(4102),
    [aux_sym_preproc_include_token1] = ACTIONS(4102),
    [aux_sym_preproc_def_token1] = ACTIONS(4102),
    [aux_sym_preproc_if_token1] = ACTIONS(4102),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4102),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4102),
    [sym_preproc_directive] = ACTIONS(4102),
    [anon_sym_LPAREN2] = ACTIONS(4100),
    [anon_sym_BANG] = ACTIONS(4100),
    [anon_sym_TILDE] = ACTIONS(4100),
    [anon_sym_DASH] = ACTIONS(4102),
    [anon_sym_PLUS] = ACTIONS(4102),
    [anon_sym_STAR] = ACTIONS(4100),
    [anon_sym_AMP_AMP] = ACTIONS(4100),
    [anon_sym_AMP] = ACTIONS(4102),
    [anon_sym_SEMI] = ACTIONS(4100),
    [anon_sym___extension__] = ACTIONS(4102),
    [anon_sym_typedef] = ACTIONS(4102),
    [anon_sym_in] = ACTIONS(4102),
    [anon_sym_out] = ACTIONS(4102),
    [anon_sym_inout] = ACTIONS(4102),
    [anon_sym_virtual] = ACTIONS(4102),
    [anon_sym_extern] = ACTIONS(4102),
    [anon_sym___attribute__] = ACTIONS(4102),
    [anon_sym___attribute] = ACTIONS(4102),
    [anon_sym_using] = ACTIONS(4102),
    [anon_sym_COLON_COLON] = ACTIONS(4100),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4100),
    [anon_sym___declspec] = ACTIONS(4102),
    [anon_sym___based] = ACTIONS(4102),
    [anon_sym___cdecl] = ACTIONS(4102),
    [anon_sym___clrcall] = ACTIONS(4102),
    [anon_sym___stdcall] = ACTIONS(4102),
    [anon_sym___fastcall] = ACTIONS(4102),
    [anon_sym___thiscall] = ACTIONS(4102),
    [anon_sym___vectorcall] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(4100),
    [anon_sym_RBRACE] = ACTIONS(4100),
    [anon_sym_signed] = ACTIONS(4161),
    [anon_sym_unsigned] = ACTIONS(4161),
    [anon_sym_long] = ACTIONS(4161),
    [anon_sym_short] = ACTIONS(4161),
    [anon_sym_LBRACK] = ACTIONS(4102),
    [anon_sym_static] = ACTIONS(4102),
    [anon_sym_register] = ACTIONS(4102),
    [anon_sym_inline] = ACTIONS(4102),
    [anon_sym___inline] = ACTIONS(4102),
    [anon_sym___inline__] = ACTIONS(4102),
    [anon_sym___forceinline] = ACTIONS(4102),
    [anon_sym_thread_local] = ACTIONS(4102),
    [anon_sym___thread] = ACTIONS(4102),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_constexpr] = ACTIONS(4102),
    [anon_sym_volatile] = ACTIONS(4102),
    [anon_sym_restrict] = ACTIONS(4102),
    [anon_sym___restrict__] = ACTIONS(4102),
    [anon_sym__Atomic] = ACTIONS(4102),
    [anon_sym__Noreturn] = ACTIONS(4102),
    [anon_sym_noreturn] = ACTIONS(4102),
    [anon_sym__Nonnull] = ACTIONS(4102),
    [anon_sym_mutable] = ACTIONS(4102),
    [anon_sym_constinit] = ACTIONS(4102),
    [anon_sym_consteval] = ACTIONS(4102),
    [anon_sym_alignas] = ACTIONS(4102),
    [anon_sym__Alignas] = ACTIONS(4102),
    [sym_primitive_type] = ACTIONS(4102),
    [anon_sym_enum] = ACTIONS(4102),
    [anon_sym_class] = ACTIONS(4102),
    [anon_sym_struct] = ACTIONS(4102),
    [anon_sym_union] = ACTIONS(4102),
    [anon_sym_if] = ACTIONS(4102),
    [anon_sym_switch] = ACTIONS(4102),
    [anon_sym_case] = ACTIONS(4102),
    [anon_sym_default] = ACTIONS(4102),
    [anon_sym_while] = ACTIONS(4102),
    [anon_sym_do] = ACTIONS(4102),
    [anon_sym_for] = ACTIONS(4102),
    [anon_sym_return] = ACTIONS(4102),
    [anon_sym_break] = ACTIONS(4102),
    [anon_sym_continue] = ACTIONS(4102),
    [anon_sym_goto] = ACTIONS(4102),
    [anon_sym___try] = ACTIONS(4102),
    [anon_sym___leave] = ACTIONS(4102),
    [anon_sym_not] = ACTIONS(4102),
    [anon_sym_compl] = ACTIONS(4102),
    [anon_sym_DASH_DASH] = ACTIONS(4100),
    [anon_sym_PLUS_PLUS] = ACTIONS(4100),
    [anon_sym_sizeof] = ACTIONS(4102),
    [anon_sym___alignof__] = ACTIONS(4102),
    [anon_sym___alignof] = ACTIONS(4102),
    [anon_sym__alignof] = ACTIONS(4102),
    [anon_sym_alignof] = ACTIONS(4102),
    [anon_sym__Alignof] = ACTIONS(4102),
    [anon_sym_offsetof] = ACTIONS(4102),
    [anon_sym__Generic] = ACTIONS(4102),
    [anon_sym_asm] = ACTIONS(4102),
    [anon_sym___asm__] = ACTIONS(4102),
    [anon_sym___asm] = ACTIONS(4102),
    [anon_sym_DOT] = ACTIONS(4102),
    [sym_number_literal] = ACTIONS(4100),
    [anon_sym_L_SQUOTE] = ACTIONS(4100),
    [anon_sym_u_SQUOTE] = ACTIONS(4100),
    [anon_sym_U_SQUOTE] = ACTIONS(4100),
    [anon_sym_u8_SQUOTE] = ACTIONS(4100),
    [anon_sym_SQUOTE] = ACTIONS(4100),
    [anon_sym_L_DQUOTE] = ACTIONS(4100),
    [anon_sym_u_DQUOTE] = ACTIONS(4100),
    [anon_sym_U_DQUOTE] = ACTIONS(4100),
    [anon_sym_u8_DQUOTE] = ACTIONS(4100),
    [anon_sym_DQUOTE] = ACTIONS(4100),
    [sym_true] = ACTIONS(4102),
    [sym_false] = ACTIONS(4102),
    [anon_sym_NULL] = ACTIONS(4102),
    [anon_sym_nullptr] = ACTIONS(4102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4102),
    [anon_sym_let] = ACTIONS(4102),
    [anon_sym_This] = ACTIONS(4102),
    [anon_sym_decltype] = ACTIONS(4102),
    [anon_sym_explicit] = ACTIONS(4102),
    [anon_sym_typename] = ACTIONS(4102),
    [anon_sym_template] = ACTIONS(4102),
    [anon_sym_operator] = ACTIONS(4102),
    [anon_sym_try] = ACTIONS(4102),
    [anon_sym_delete] = ACTIONS(4102),
    [anon_sym_throw] = ACTIONS(4102),
    [anon_sym_namespace] = ACTIONS(4102),
    [anon_sym_static_assert] = ACTIONS(4102),
    [anon_sym_concept] = ACTIONS(4102),
    [anon_sym_co_return] = ACTIONS(4102),
    [anon_sym_co_yield] = ACTIONS(4102),
    [anon_sym_R_DQUOTE] = ACTIONS(4100),
    [anon_sym_LR_DQUOTE] = ACTIONS(4100),
    [anon_sym_uR_DQUOTE] = ACTIONS(4100),
    [anon_sym_UR_DQUOTE] = ACTIONS(4100),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4100),
    [anon_sym_co_await] = ACTIONS(4102),
    [anon_sym_new] = ACTIONS(4102),
    [anon_sym_requires] = ACTIONS(4102),
    [sym_this] = ACTIONS(4102),
    [anon_sym_discard] = ACTIONS(4102),
    [anon_sym_precise] = ACTIONS(4102),
    [anon_sym_shared] = ACTIONS(4102),
    [anon_sym_groupshared] = ACTIONS(4102),
    [anon_sym_uniform] = ACTIONS(4102),
    [anon_sym_row_major] = ACTIONS(4102),
    [anon_sym_column_major] = ACTIONS(4102),
    [anon_sym_globallycoherent] = ACTIONS(4102),
    [anon_sym_centroid] = ACTIONS(4102),
    [anon_sym_noperspective] = ACTIONS(4102),
    [anon_sym_nointerpolation] = ACTIONS(4102),
    [anon_sym_sample] = ACTIONS(4102),
    [anon_sym_linear] = ACTIONS(4102),
    [anon_sym_snorm] = ACTIONS(4102),
    [anon_sym_unorm] = ACTIONS(4102),
    [anon_sym_point] = ACTIONS(4102),
    [anon_sym_line] = ACTIONS(4102),
    [anon_sym_triangleadj] = ACTIONS(4102),
    [anon_sym_lineadj] = ACTIONS(4102),
    [anon_sym_triangle] = ACTIONS(4102),
    [anon_sym_cbuffer] = ACTIONS(4102),
    [anon_sym_interface] = ACTIONS(4102),
    [anon_sym_extension] = ACTIONS(4102),
  },
  [681] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(691),
    [sym_identifier] = ACTIONS(4164),
    [aux_sym_preproc_include_token1] = ACTIONS(4164),
    [aux_sym_preproc_def_token1] = ACTIONS(4164),
    [aux_sym_preproc_if_token1] = ACTIONS(4164),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4164),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4164),
    [sym_preproc_directive] = ACTIONS(4164),
    [anon_sym_LPAREN2] = ACTIONS(4166),
    [anon_sym_BANG] = ACTIONS(4166),
    [anon_sym_TILDE] = ACTIONS(4166),
    [anon_sym_DASH] = ACTIONS(4164),
    [anon_sym_PLUS] = ACTIONS(4164),
    [anon_sym_STAR] = ACTIONS(4166),
    [anon_sym_AMP_AMP] = ACTIONS(4166),
    [anon_sym_AMP] = ACTIONS(4164),
    [anon_sym_SEMI] = ACTIONS(4166),
    [anon_sym___extension__] = ACTIONS(4164),
    [anon_sym_typedef] = ACTIONS(4164),
    [anon_sym_in] = ACTIONS(4164),
    [anon_sym_out] = ACTIONS(4164),
    [anon_sym_inout] = ACTIONS(4164),
    [anon_sym_virtual] = ACTIONS(4164),
    [anon_sym_extern] = ACTIONS(4164),
    [anon_sym___attribute__] = ACTIONS(4164),
    [anon_sym___attribute] = ACTIONS(4164),
    [anon_sym_using] = ACTIONS(4164),
    [anon_sym_COLON_COLON] = ACTIONS(4166),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4166),
    [anon_sym___declspec] = ACTIONS(4164),
    [anon_sym___based] = ACTIONS(4164),
    [anon_sym___cdecl] = ACTIONS(4164),
    [anon_sym___clrcall] = ACTIONS(4164),
    [anon_sym___stdcall] = ACTIONS(4164),
    [anon_sym___fastcall] = ACTIONS(4164),
    [anon_sym___thiscall] = ACTIONS(4164),
    [anon_sym___vectorcall] = ACTIONS(4164),
    [anon_sym_LBRACE] = ACTIONS(4166),
    [anon_sym_RBRACE] = ACTIONS(4166),
    [anon_sym_signed] = ACTIONS(4168),
    [anon_sym_unsigned] = ACTIONS(4168),
    [anon_sym_long] = ACTIONS(4168),
    [anon_sym_short] = ACTIONS(4168),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_static] = ACTIONS(4164),
    [anon_sym_register] = ACTIONS(4164),
    [anon_sym_inline] = ACTIONS(4164),
    [anon_sym___inline] = ACTIONS(4164),
    [anon_sym___inline__] = ACTIONS(4164),
    [anon_sym___forceinline] = ACTIONS(4164),
    [anon_sym_thread_local] = ACTIONS(4164),
    [anon_sym___thread] = ACTIONS(4164),
    [anon_sym_const] = ACTIONS(4164),
    [anon_sym_constexpr] = ACTIONS(4164),
    [anon_sym_volatile] = ACTIONS(4164),
    [anon_sym_restrict] = ACTIONS(4164),
    [anon_sym___restrict__] = ACTIONS(4164),
    [anon_sym__Atomic] = ACTIONS(4164),
    [anon_sym__Noreturn] = ACTIONS(4164),
    [anon_sym_noreturn] = ACTIONS(4164),
    [anon_sym__Nonnull] = ACTIONS(4164),
    [anon_sym_mutable] = ACTIONS(4164),
    [anon_sym_constinit] = ACTIONS(4164),
    [anon_sym_consteval] = ACTIONS(4164),
    [anon_sym_alignas] = ACTIONS(4164),
    [anon_sym__Alignas] = ACTIONS(4164),
    [sym_primitive_type] = ACTIONS(4164),
    [anon_sym_enum] = ACTIONS(4164),
    [anon_sym_class] = ACTIONS(4164),
    [anon_sym_struct] = ACTIONS(4164),
    [anon_sym_union] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_switch] = ACTIONS(4164),
    [anon_sym_case] = ACTIONS(4164),
    [anon_sym_default] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_for] = ACTIONS(4164),
    [anon_sym_return] = ACTIONS(4164),
    [anon_sym_break] = ACTIONS(4164),
    [anon_sym_continue] = ACTIONS(4164),
    [anon_sym_goto] = ACTIONS(4164),
    [anon_sym___try] = ACTIONS(4164),
    [anon_sym___leave] = ACTIONS(4164),
    [anon_sym_not] = ACTIONS(4164),
    [anon_sym_compl] = ACTIONS(4164),
    [anon_sym_DASH_DASH] = ACTIONS(4166),
    [anon_sym_PLUS_PLUS] = ACTIONS(4166),
    [anon_sym_sizeof] = ACTIONS(4164),
    [anon_sym___alignof__] = ACTIONS(4164),
    [anon_sym___alignof] = ACTIONS(4164),
    [anon_sym__alignof] = ACTIONS(4164),
    [anon_sym_alignof] = ACTIONS(4164),
    [anon_sym__Alignof] = ACTIONS(4164),
    [anon_sym_offsetof] = ACTIONS(4164),
    [anon_sym__Generic] = ACTIONS(4164),
    [anon_sym_asm] = ACTIONS(4164),
    [anon_sym___asm__] = ACTIONS(4164),
    [anon_sym___asm] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4164),
    [sym_number_literal] = ACTIONS(4166),
    [anon_sym_L_SQUOTE] = ACTIONS(4166),
    [anon_sym_u_SQUOTE] = ACTIONS(4166),
    [anon_sym_U_SQUOTE] = ACTIONS(4166),
    [anon_sym_u8_SQUOTE] = ACTIONS(4166),
    [anon_sym_SQUOTE] = ACTIONS(4166),
    [anon_sym_L_DQUOTE] = ACTIONS(4166),
    [anon_sym_u_DQUOTE] = ACTIONS(4166),
    [anon_sym_U_DQUOTE] = ACTIONS(4166),
    [anon_sym_u8_DQUOTE] = ACTIONS(4166),
    [anon_sym_DQUOTE] = ACTIONS(4166),
    [sym_true] = ACTIONS(4164),
    [sym_false] = ACTIONS(4164),
    [anon_sym_NULL] = ACTIONS(4164),
    [anon_sym_nullptr] = ACTIONS(4164),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4164),
    [anon_sym_let] = ACTIONS(4164),
    [anon_sym_This] = ACTIONS(4164),
    [anon_sym_decltype] = ACTIONS(4164),
    [anon_sym_explicit] = ACTIONS(4164),
    [anon_sym_typename] = ACTIONS(4164),
    [anon_sym_template] = ACTIONS(4164),
    [anon_sym_operator] = ACTIONS(4164),
    [anon_sym_try] = ACTIONS(4164),
    [anon_sym_delete] = ACTIONS(4164),
    [anon_sym_throw] = ACTIONS(4164),
    [anon_sym_namespace] = ACTIONS(4164),
    [anon_sym_static_assert] = ACTIONS(4164),
    [anon_sym_concept] = ACTIONS(4164),
    [anon_sym_co_return] = ACTIONS(4164),
    [anon_sym_co_yield] = ACTIONS(4164),
    [anon_sym_R_DQUOTE] = ACTIONS(4166),
    [anon_sym_LR_DQUOTE] = ACTIONS(4166),
    [anon_sym_uR_DQUOTE] = ACTIONS(4166),
    [anon_sym_UR_DQUOTE] = ACTIONS(4166),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4166),
    [anon_sym_co_await] = ACTIONS(4164),
    [anon_sym_new] = ACTIONS(4164),
    [anon_sym_requires] = ACTIONS(4164),
    [sym_this] = ACTIONS(4164),
    [anon_sym_discard] = ACTIONS(4164),
    [anon_sym_precise] = ACTIONS(4164),
    [anon_sym_shared] = ACTIONS(4164),
    [anon_sym_groupshared] = ACTIONS(4164),
    [anon_sym_uniform] = ACTIONS(4164),
    [anon_sym_row_major] = ACTIONS(4164),
    [anon_sym_column_major] = ACTIONS(4164),
    [anon_sym_globallycoherent] = ACTIONS(4164),
    [anon_sym_centroid] = ACTIONS(4164),
    [anon_sym_noperspective] = ACTIONS(4164),
    [anon_sym_nointerpolation] = ACTIONS(4164),
    [anon_sym_sample] = ACTIONS(4164),
    [anon_sym_linear] = ACTIONS(4164),
    [anon_sym_snorm] = ACTIONS(4164),
    [anon_sym_unorm] = ACTIONS(4164),
    [anon_sym_point] = ACTIONS(4164),
    [anon_sym_line] = ACTIONS(4164),
    [anon_sym_triangleadj] = ACTIONS(4164),
    [anon_sym_lineadj] = ACTIONS(4164),
    [anon_sym_triangle] = ACTIONS(4164),
    [anon_sym_cbuffer] = ACTIONS(4164),
    [anon_sym_interface] = ACTIONS(4164),
    [anon_sym_extension] = ACTIONS(4164),
  },
  [682] = {
    [sym_identifier] = ACTIONS(2414),
    [aux_sym_preproc_include_token1] = ACTIONS(2414),
    [aux_sym_preproc_def_token1] = ACTIONS(2414),
    [aux_sym_preproc_if_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2414),
    [sym_preproc_directive] = ACTIONS(2414),
    [anon_sym_LPAREN2] = ACTIONS(2412),
    [anon_sym_BANG] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym___extension__] = ACTIONS(2414),
    [anon_sym_typedef] = ACTIONS(2414),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_out] = ACTIONS(2414),
    [anon_sym_inout] = ACTIONS(2414),
    [anon_sym_virtual] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym___attribute__] = ACTIONS(2414),
    [anon_sym___attribute] = ACTIONS(2414),
    [anon_sym_using] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2412),
    [anon_sym___declspec] = ACTIONS(2414),
    [anon_sym___based] = ACTIONS(2414),
    [anon_sym___cdecl] = ACTIONS(2414),
    [anon_sym___clrcall] = ACTIONS(2414),
    [anon_sym___stdcall] = ACTIONS(2414),
    [anon_sym___fastcall] = ACTIONS(2414),
    [anon_sym___thiscall] = ACTIONS(2414),
    [anon_sym___vectorcall] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(2412),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [anon_sym_signed] = ACTIONS(2414),
    [anon_sym_unsigned] = ACTIONS(2414),
    [anon_sym_long] = ACTIONS(2414),
    [anon_sym_short] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_register] = ACTIONS(2414),
    [anon_sym_inline] = ACTIONS(2414),
    [anon_sym___inline] = ACTIONS(2414),
    [anon_sym___inline__] = ACTIONS(2414),
    [anon_sym___forceinline] = ACTIONS(2414),
    [anon_sym_thread_local] = ACTIONS(2414),
    [anon_sym___thread] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_constexpr] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym_restrict] = ACTIONS(2414),
    [anon_sym___restrict__] = ACTIONS(2414),
    [anon_sym__Atomic] = ACTIONS(2414),
    [anon_sym__Noreturn] = ACTIONS(2414),
    [anon_sym_noreturn] = ACTIONS(2414),
    [anon_sym__Nonnull] = ACTIONS(2414),
    [anon_sym_mutable] = ACTIONS(2414),
    [anon_sym_constinit] = ACTIONS(2414),
    [anon_sym_consteval] = ACTIONS(2414),
    [anon_sym_alignas] = ACTIONS(2414),
    [anon_sym__Alignas] = ACTIONS(2414),
    [sym_primitive_type] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [anon_sym_if] = ACTIONS(2414),
    [anon_sym_else] = ACTIONS(2414),
    [anon_sym_switch] = ACTIONS(2414),
    [anon_sym_case] = ACTIONS(2414),
    [anon_sym_default] = ACTIONS(2414),
    [anon_sym_while] = ACTIONS(2414),
    [anon_sym_do] = ACTIONS(2414),
    [anon_sym_for] = ACTIONS(2414),
    [anon_sym_return] = ACTIONS(2414),
    [anon_sym_break] = ACTIONS(2414),
    [anon_sym_continue] = ACTIONS(2414),
    [anon_sym_goto] = ACTIONS(2414),
    [anon_sym___try] = ACTIONS(2414),
    [anon_sym___leave] = ACTIONS(2414),
    [anon_sym_not] = ACTIONS(2414),
    [anon_sym_compl] = ACTIONS(2414),
    [anon_sym_DASH_DASH] = ACTIONS(2412),
    [anon_sym_PLUS_PLUS] = ACTIONS(2412),
    [anon_sym_sizeof] = ACTIONS(2414),
    [anon_sym___alignof__] = ACTIONS(2414),
    [anon_sym___alignof] = ACTIONS(2414),
    [anon_sym__alignof] = ACTIONS(2414),
    [anon_sym_alignof] = ACTIONS(2414),
    [anon_sym__Alignof] = ACTIONS(2414),
    [anon_sym_offsetof] = ACTIONS(2414),
    [anon_sym__Generic] = ACTIONS(2414),
    [anon_sym_asm] = ACTIONS(2414),
    [anon_sym___asm__] = ACTIONS(2414),
    [anon_sym___asm] = ACTIONS(2414),
    [sym_number_literal] = ACTIONS(2412),
    [anon_sym_L_SQUOTE] = ACTIONS(2412),
    [anon_sym_u_SQUOTE] = ACTIONS(2412),
    [anon_sym_U_SQUOTE] = ACTIONS(2412),
    [anon_sym_u8_SQUOTE] = ACTIONS(2412),
    [anon_sym_SQUOTE] = ACTIONS(2412),
    [anon_sym_L_DQUOTE] = ACTIONS(2412),
    [anon_sym_u_DQUOTE] = ACTIONS(2412),
    [anon_sym_U_DQUOTE] = ACTIONS(2412),
    [anon_sym_u8_DQUOTE] = ACTIONS(2412),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [sym_true] = ACTIONS(2414),
    [sym_false] = ACTIONS(2414),
    [anon_sym_NULL] = ACTIONS(2414),
    [anon_sym_nullptr] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2414),
    [anon_sym_let] = ACTIONS(2414),
    [anon_sym_This] = ACTIONS(2414),
    [anon_sym_decltype] = ACTIONS(2414),
    [anon_sym_explicit] = ACTIONS(2414),
    [anon_sym_typename] = ACTIONS(2414),
    [anon_sym_template] = ACTIONS(2414),
    [anon_sym_operator] = ACTIONS(2414),
    [anon_sym_try] = ACTIONS(2414),
    [anon_sym_delete] = ACTIONS(2414),
    [anon_sym_throw] = ACTIONS(2414),
    [anon_sym_namespace] = ACTIONS(2414),
    [anon_sym_static_assert] = ACTIONS(2414),
    [anon_sym_concept] = ACTIONS(2414),
    [anon_sym_co_return] = ACTIONS(2414),
    [anon_sym_co_yield] = ACTIONS(2414),
    [anon_sym_catch] = ACTIONS(2414),
    [anon_sym_R_DQUOTE] = ACTIONS(2412),
    [anon_sym_LR_DQUOTE] = ACTIONS(2412),
    [anon_sym_uR_DQUOTE] = ACTIONS(2412),
    [anon_sym_UR_DQUOTE] = ACTIONS(2412),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2412),
    [anon_sym_co_await] = ACTIONS(2414),
    [anon_sym_new] = ACTIONS(2414),
    [anon_sym_requires] = ACTIONS(2414),
    [sym_this] = ACTIONS(2414),
    [anon_sym_discard] = ACTIONS(2414),
    [anon_sym_precise] = ACTIONS(2414),
    [anon_sym_shared] = ACTIONS(2414),
    [anon_sym_groupshared] = ACTIONS(2414),
    [anon_sym_uniform] = ACTIONS(2414),
    [anon_sym_row_major] = ACTIONS(2414),
    [anon_sym_column_major] = ACTIONS(2414),
    [anon_sym_globallycoherent] = ACTIONS(2414),
    [anon_sym_centroid] = ACTIONS(2414),
    [anon_sym_noperspective] = ACTIONS(2414),
    [anon_sym_nointerpolation] = ACTIONS(2414),
    [anon_sym_sample] = ACTIONS(2414),
    [anon_sym_linear] = ACTIONS(2414),
    [anon_sym_snorm] = ACTIONS(2414),
    [anon_sym_unorm] = ACTIONS(2414),
    [anon_sym_point] = ACTIONS(2414),
    [anon_sym_line] = ACTIONS(2414),
    [anon_sym_triangleadj] = ACTIONS(2414),
    [anon_sym_lineadj] = ACTIONS(2414),
    [anon_sym_triangle] = ACTIONS(2414),
    [anon_sym_cbuffer] = ACTIONS(2414),
    [anon_sym_interface] = ACTIONS(2414),
    [anon_sym_extension] = ACTIONS(2414),
  },
  [683] = {
    [ts_builtin_sym_end] = ACTIONS(3895),
    [sym_identifier] = ACTIONS(3893),
    [aux_sym_preproc_include_token1] = ACTIONS(3893),
    [aux_sym_preproc_def_token1] = ACTIONS(3893),
    [anon_sym_COMMA] = ACTIONS(3895),
    [aux_sym_preproc_if_token1] = ACTIONS(3893),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3893),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3893),
    [sym_preproc_directive] = ACTIONS(3893),
    [anon_sym_LPAREN2] = ACTIONS(3895),
    [anon_sym_BANG] = ACTIONS(3895),
    [anon_sym_TILDE] = ACTIONS(3895),
    [anon_sym_DASH] = ACTIONS(3893),
    [anon_sym_PLUS] = ACTIONS(3893),
    [anon_sym_STAR] = ACTIONS(3895),
    [anon_sym_AMP_AMP] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3893),
    [anon_sym_SEMI] = ACTIONS(3895),
    [anon_sym___extension__] = ACTIONS(3893),
    [anon_sym_typedef] = ACTIONS(3893),
    [anon_sym_in] = ACTIONS(3893),
    [anon_sym_out] = ACTIONS(3893),
    [anon_sym_inout] = ACTIONS(3893),
    [anon_sym_virtual] = ACTIONS(3893),
    [anon_sym_extern] = ACTIONS(3893),
    [anon_sym___attribute__] = ACTIONS(3893),
    [anon_sym___attribute] = ACTIONS(3893),
    [anon_sym_using] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3895),
    [anon_sym___declspec] = ACTIONS(3893),
    [anon_sym___based] = ACTIONS(3893),
    [anon_sym___cdecl] = ACTIONS(3893),
    [anon_sym___clrcall] = ACTIONS(3893),
    [anon_sym___stdcall] = ACTIONS(3893),
    [anon_sym___fastcall] = ACTIONS(3893),
    [anon_sym___thiscall] = ACTIONS(3893),
    [anon_sym___vectorcall] = ACTIONS(3893),
    [anon_sym_LBRACE] = ACTIONS(3895),
    [anon_sym_RBRACE] = ACTIONS(3895),
    [anon_sym_signed] = ACTIONS(3893),
    [anon_sym_unsigned] = ACTIONS(3893),
    [anon_sym_long] = ACTIONS(3893),
    [anon_sym_short] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_static] = ACTIONS(3893),
    [anon_sym_register] = ACTIONS(3893),
    [anon_sym_inline] = ACTIONS(3893),
    [anon_sym___inline] = ACTIONS(3893),
    [anon_sym___inline__] = ACTIONS(3893),
    [anon_sym___forceinline] = ACTIONS(3893),
    [anon_sym_thread_local] = ACTIONS(3893),
    [anon_sym___thread] = ACTIONS(3893),
    [anon_sym_const] = ACTIONS(3893),
    [anon_sym_constexpr] = ACTIONS(3893),
    [anon_sym_volatile] = ACTIONS(3893),
    [anon_sym_restrict] = ACTIONS(3893),
    [anon_sym___restrict__] = ACTIONS(3893),
    [anon_sym__Atomic] = ACTIONS(3893),
    [anon_sym__Noreturn] = ACTIONS(3893),
    [anon_sym_noreturn] = ACTIONS(3893),
    [anon_sym__Nonnull] = ACTIONS(3893),
    [anon_sym_mutable] = ACTIONS(3893),
    [anon_sym_constinit] = ACTIONS(3893),
    [anon_sym_consteval] = ACTIONS(3893),
    [anon_sym_alignas] = ACTIONS(3893),
    [anon_sym__Alignas] = ACTIONS(3893),
    [sym_primitive_type] = ACTIONS(3893),
    [anon_sym_enum] = ACTIONS(3893),
    [anon_sym_class] = ACTIONS(3893),
    [anon_sym_struct] = ACTIONS(3893),
    [anon_sym_union] = ACTIONS(3893),
    [anon_sym_if] = ACTIONS(3893),
    [anon_sym_switch] = ACTIONS(3893),
    [anon_sym_case] = ACTIONS(3893),
    [anon_sym_default] = ACTIONS(3893),
    [anon_sym_while] = ACTIONS(3893),
    [anon_sym_do] = ACTIONS(3893),
    [anon_sym_for] = ACTIONS(3893),
    [anon_sym_return] = ACTIONS(3893),
    [anon_sym_break] = ACTIONS(3893),
    [anon_sym_continue] = ACTIONS(3893),
    [anon_sym_goto] = ACTIONS(3893),
    [anon_sym_not] = ACTIONS(3893),
    [anon_sym_compl] = ACTIONS(3893),
    [anon_sym_DASH_DASH] = ACTIONS(3895),
    [anon_sym_PLUS_PLUS] = ACTIONS(3895),
    [anon_sym_sizeof] = ACTIONS(3893),
    [anon_sym___alignof__] = ACTIONS(3893),
    [anon_sym___alignof] = ACTIONS(3893),
    [anon_sym__alignof] = ACTIONS(3893),
    [anon_sym_alignof] = ACTIONS(3893),
    [anon_sym__Alignof] = ACTIONS(3893),
    [anon_sym_offsetof] = ACTIONS(3893),
    [anon_sym__Generic] = ACTIONS(3893),
    [anon_sym_asm] = ACTIONS(3893),
    [anon_sym___asm__] = ACTIONS(3893),
    [anon_sym___asm] = ACTIONS(3893),
    [sym_number_literal] = ACTIONS(3895),
    [anon_sym_L_SQUOTE] = ACTIONS(3895),
    [anon_sym_u_SQUOTE] = ACTIONS(3895),
    [anon_sym_U_SQUOTE] = ACTIONS(3895),
    [anon_sym_u8_SQUOTE] = ACTIONS(3895),
    [anon_sym_SQUOTE] = ACTIONS(3895),
    [anon_sym_L_DQUOTE] = ACTIONS(3895),
    [anon_sym_u_DQUOTE] = ACTIONS(3895),
    [anon_sym_U_DQUOTE] = ACTIONS(3895),
    [anon_sym_u8_DQUOTE] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(3895),
    [sym_true] = ACTIONS(3893),
    [sym_false] = ACTIONS(3893),
    [anon_sym_NULL] = ACTIONS(3893),
    [anon_sym_nullptr] = ACTIONS(3893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_This] = ACTIONS(3893),
    [anon_sym_decltype] = ACTIONS(3893),
    [anon_sym_explicit] = ACTIONS(3893),
    [anon_sym_typename] = ACTIONS(3893),
    [anon_sym_export] = ACTIONS(3893),
    [anon_sym_module] = ACTIONS(3893),
    [anon_sym_import] = ACTIONS(3893),
    [anon_sym_template] = ACTIONS(3893),
    [anon_sym_operator] = ACTIONS(3893),
    [anon_sym_try] = ACTIONS(3893),
    [anon_sym_delete] = ACTIONS(3893),
    [anon_sym_throw] = ACTIONS(3893),
    [anon_sym_namespace] = ACTIONS(3893),
    [anon_sym_static_assert] = ACTIONS(3893),
    [anon_sym_concept] = ACTIONS(3893),
    [anon_sym_co_return] = ACTIONS(3893),
    [anon_sym_co_yield] = ACTIONS(3893),
    [anon_sym_R_DQUOTE] = ACTIONS(3895),
    [anon_sym_LR_DQUOTE] = ACTIONS(3895),
    [anon_sym_uR_DQUOTE] = ACTIONS(3895),
    [anon_sym_UR_DQUOTE] = ACTIONS(3895),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3895),
    [anon_sym_co_await] = ACTIONS(3893),
    [anon_sym_new] = ACTIONS(3893),
    [anon_sym_requires] = ACTIONS(3893),
    [sym_this] = ACTIONS(3893),
    [anon_sym_precise] = ACTIONS(3893),
    [anon_sym_shared] = ACTIONS(3893),
    [anon_sym_groupshared] = ACTIONS(3893),
    [anon_sym_uniform] = ACTIONS(3893),
    [anon_sym_row_major] = ACTIONS(3893),
    [anon_sym_column_major] = ACTIONS(3893),
    [anon_sym_globallycoherent] = ACTIONS(3893),
    [anon_sym_centroid] = ACTIONS(3893),
    [anon_sym_noperspective] = ACTIONS(3893),
    [anon_sym_nointerpolation] = ACTIONS(3893),
    [anon_sym_sample] = ACTIONS(3893),
    [anon_sym_linear] = ACTIONS(3893),
    [anon_sym_snorm] = ACTIONS(3893),
    [anon_sym_unorm] = ACTIONS(3893),
    [anon_sym_point] = ACTIONS(3893),
    [anon_sym_line] = ACTIONS(3893),
    [anon_sym_triangleadj] = ACTIONS(3893),
    [anon_sym_lineadj] = ACTIONS(3893),
    [anon_sym_triangle] = ACTIONS(3893),
    [anon_sym_interface] = ACTIONS(3893),
    [anon_sym_extension] = ACTIONS(3893),
    [anon_sym___exported] = ACTIONS(3893),
  },
  [684] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(649),
    [ts_builtin_sym_end] = ACTIONS(4113),
    [sym_identifier] = ACTIONS(4111),
    [aux_sym_preproc_include_token1] = ACTIONS(4111),
    [aux_sym_preproc_def_token1] = ACTIONS(4111),
    [aux_sym_preproc_if_token1] = ACTIONS(4111),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4111),
    [sym_preproc_directive] = ACTIONS(4111),
    [anon_sym_LPAREN2] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(4113),
    [anon_sym_TILDE] = ACTIONS(4113),
    [anon_sym_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4111),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4113),
    [anon_sym_AMP] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym___extension__] = ACTIONS(4111),
    [anon_sym_typedef] = ACTIONS(4111),
    [anon_sym_in] = ACTIONS(4111),
    [anon_sym_out] = ACTIONS(4111),
    [anon_sym_inout] = ACTIONS(4111),
    [anon_sym_virtual] = ACTIONS(4111),
    [anon_sym_extern] = ACTIONS(4111),
    [anon_sym___attribute__] = ACTIONS(4111),
    [anon_sym___attribute] = ACTIONS(4111),
    [anon_sym_using] = ACTIONS(4111),
    [anon_sym_COLON_COLON] = ACTIONS(4113),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4113),
    [anon_sym___declspec] = ACTIONS(4111),
    [anon_sym___based] = ACTIONS(4111),
    [anon_sym___cdecl] = ACTIONS(4111),
    [anon_sym___clrcall] = ACTIONS(4111),
    [anon_sym___stdcall] = ACTIONS(4111),
    [anon_sym___fastcall] = ACTIONS(4111),
    [anon_sym___thiscall] = ACTIONS(4111),
    [anon_sym___vectorcall] = ACTIONS(4111),
    [anon_sym_LBRACE] = ACTIONS(4113),
    [anon_sym_signed] = ACTIONS(4171),
    [anon_sym_unsigned] = ACTIONS(4171),
    [anon_sym_long] = ACTIONS(4171),
    [anon_sym_short] = ACTIONS(4171),
    [anon_sym_LBRACK] = ACTIONS(4111),
    [anon_sym_static] = ACTIONS(4111),
    [anon_sym_register] = ACTIONS(4111),
    [anon_sym_inline] = ACTIONS(4111),
    [anon_sym___inline] = ACTIONS(4111),
    [anon_sym___inline__] = ACTIONS(4111),
    [anon_sym___forceinline] = ACTIONS(4111),
    [anon_sym_thread_local] = ACTIONS(4111),
    [anon_sym___thread] = ACTIONS(4111),
    [anon_sym_const] = ACTIONS(4111),
    [anon_sym_constexpr] = ACTIONS(4111),
    [anon_sym_volatile] = ACTIONS(4111),
    [anon_sym_restrict] = ACTIONS(4111),
    [anon_sym___restrict__] = ACTIONS(4111),
    [anon_sym__Atomic] = ACTIONS(4111),
    [anon_sym__Noreturn] = ACTIONS(4111),
    [anon_sym_noreturn] = ACTIONS(4111),
    [anon_sym__Nonnull] = ACTIONS(4111),
    [anon_sym_mutable] = ACTIONS(4111),
    [anon_sym_constinit] = ACTIONS(4111),
    [anon_sym_consteval] = ACTIONS(4111),
    [anon_sym_alignas] = ACTIONS(4111),
    [anon_sym__Alignas] = ACTIONS(4111),
    [sym_primitive_type] = ACTIONS(4111),
    [anon_sym_enum] = ACTIONS(4111),
    [anon_sym_class] = ACTIONS(4111),
    [anon_sym_struct] = ACTIONS(4111),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_if] = ACTIONS(4111),
    [anon_sym_switch] = ACTIONS(4111),
    [anon_sym_case] = ACTIONS(4111),
    [anon_sym_default] = ACTIONS(4111),
    [anon_sym_while] = ACTIONS(4111),
    [anon_sym_do] = ACTIONS(4111),
    [anon_sym_for] = ACTIONS(4111),
    [anon_sym_return] = ACTIONS(4111),
    [anon_sym_break] = ACTIONS(4111),
    [anon_sym_continue] = ACTIONS(4111),
    [anon_sym_goto] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4111),
    [anon_sym_compl] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4111),
    [anon_sym___alignof__] = ACTIONS(4111),
    [anon_sym___alignof] = ACTIONS(4111),
    [anon_sym__alignof] = ACTIONS(4111),
    [anon_sym_alignof] = ACTIONS(4111),
    [anon_sym__Alignof] = ACTIONS(4111),
    [anon_sym_offsetof] = ACTIONS(4111),
    [anon_sym__Generic] = ACTIONS(4111),
    [anon_sym_asm] = ACTIONS(4111),
    [anon_sym___asm__] = ACTIONS(4111),
    [anon_sym___asm] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4111),
    [sym_number_literal] = ACTIONS(4113),
    [anon_sym_L_SQUOTE] = ACTIONS(4113),
    [anon_sym_u_SQUOTE] = ACTIONS(4113),
    [anon_sym_U_SQUOTE] = ACTIONS(4113),
    [anon_sym_u8_SQUOTE] = ACTIONS(4113),
    [anon_sym_SQUOTE] = ACTIONS(4113),
    [anon_sym_L_DQUOTE] = ACTIONS(4113),
    [anon_sym_u_DQUOTE] = ACTIONS(4113),
    [anon_sym_U_DQUOTE] = ACTIONS(4113),
    [anon_sym_u8_DQUOTE] = ACTIONS(4113),
    [anon_sym_DQUOTE] = ACTIONS(4113),
    [sym_true] = ACTIONS(4111),
    [sym_false] = ACTIONS(4111),
    [anon_sym_NULL] = ACTIONS(4111),
    [anon_sym_nullptr] = ACTIONS(4111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4111),
    [anon_sym_let] = ACTIONS(4111),
    [anon_sym_This] = ACTIONS(4111),
    [anon_sym_decltype] = ACTIONS(4111),
    [anon_sym_explicit] = ACTIONS(4111),
    [anon_sym_typename] = ACTIONS(4111),
    [anon_sym_export] = ACTIONS(4111),
    [anon_sym_module] = ACTIONS(4111),
    [anon_sym_import] = ACTIONS(4111),
    [anon_sym_template] = ACTIONS(4111),
    [anon_sym_operator] = ACTIONS(4111),
    [anon_sym_try] = ACTIONS(4111),
    [anon_sym_delete] = ACTIONS(4111),
    [anon_sym_throw] = ACTIONS(4111),
    [anon_sym_namespace] = ACTIONS(4111),
    [anon_sym_static_assert] = ACTIONS(4111),
    [anon_sym_concept] = ACTIONS(4111),
    [anon_sym_co_return] = ACTIONS(4111),
    [anon_sym_co_yield] = ACTIONS(4111),
    [anon_sym_R_DQUOTE] = ACTIONS(4113),
    [anon_sym_LR_DQUOTE] = ACTIONS(4113),
    [anon_sym_uR_DQUOTE] = ACTIONS(4113),
    [anon_sym_UR_DQUOTE] = ACTIONS(4113),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4113),
    [anon_sym_co_await] = ACTIONS(4111),
    [anon_sym_new] = ACTIONS(4111),
    [anon_sym_requires] = ACTIONS(4111),
    [sym_this] = ACTIONS(4111),
    [anon_sym_precise] = ACTIONS(4111),
    [anon_sym_shared] = ACTIONS(4111),
    [anon_sym_groupshared] = ACTIONS(4111),
    [anon_sym_uniform] = ACTIONS(4111),
    [anon_sym_row_major] = ACTIONS(4111),
    [anon_sym_column_major] = ACTIONS(4111),
    [anon_sym_globallycoherent] = ACTIONS(4111),
    [anon_sym_centroid] = ACTIONS(4111),
    [anon_sym_noperspective] = ACTIONS(4111),
    [anon_sym_nointerpolation] = ACTIONS(4111),
    [anon_sym_sample] = ACTIONS(4111),
    [anon_sym_linear] = ACTIONS(4111),
    [anon_sym_snorm] = ACTIONS(4111),
    [anon_sym_unorm] = ACTIONS(4111),
    [anon_sym_point] = ACTIONS(4111),
    [anon_sym_line] = ACTIONS(4111),
    [anon_sym_triangleadj] = ACTIONS(4111),
    [anon_sym_lineadj] = ACTIONS(4111),
    [anon_sym_triangle] = ACTIONS(4111),
    [anon_sym_interface] = ACTIONS(4111),
    [anon_sym_extension] = ACTIONS(4111),
    [anon_sym___exported] = ACTIONS(4111),
  },
  [685] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(679),
    [ts_builtin_sym_end] = ACTIONS(2881),
    [sym_identifier] = ACTIONS(2883),
    [aux_sym_preproc_include_token1] = ACTIONS(2883),
    [aux_sym_preproc_def_token1] = ACTIONS(2883),
    [aux_sym_preproc_if_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2883),
    [sym_preproc_directive] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_typedef] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_using] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2881),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_signed] = ACTIONS(3939),
    [anon_sym_unsigned] = ACTIONS(3939),
    [anon_sym_long] = ACTIONS(3939),
    [anon_sym_short] = ACTIONS(3939),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [sym_primitive_type] = ACTIONS(2883),
    [anon_sym_enum] = ACTIONS(2883),
    [anon_sym_class] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2883),
    [anon_sym_union] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_switch] = ACTIONS(2883),
    [anon_sym_case] = ACTIONS(2883),
    [anon_sym_default] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_break] = ACTIONS(2883),
    [anon_sym_continue] = ACTIONS(2883),
    [anon_sym_goto] = ACTIONS(2883),
    [anon_sym_not] = ACTIONS(2883),
    [anon_sym_compl] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_sizeof] = ACTIONS(2883),
    [anon_sym___alignof__] = ACTIONS(2883),
    [anon_sym___alignof] = ACTIONS(2883),
    [anon_sym__alignof] = ACTIONS(2883),
    [anon_sym_alignof] = ACTIONS(2883),
    [anon_sym__Alignof] = ACTIONS(2883),
    [anon_sym_offsetof] = ACTIONS(2883),
    [anon_sym__Generic] = ACTIONS(2883),
    [anon_sym_asm] = ACTIONS(2883),
    [anon_sym___asm__] = ACTIONS(2883),
    [anon_sym___asm] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [sym_number_literal] = ACTIONS(2881),
    [anon_sym_L_SQUOTE] = ACTIONS(2881),
    [anon_sym_u_SQUOTE] = ACTIONS(2881),
    [anon_sym_U_SQUOTE] = ACTIONS(2881),
    [anon_sym_u8_SQUOTE] = ACTIONS(2881),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_L_DQUOTE] = ACTIONS(2881),
    [anon_sym_u_DQUOTE] = ACTIONS(2881),
    [anon_sym_U_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [sym_true] = ACTIONS(2883),
    [sym_false] = ACTIONS(2883),
    [anon_sym_NULL] = ACTIONS(2883),
    [anon_sym_nullptr] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_explicit] = ACTIONS(2883),
    [anon_sym_typename] = ACTIONS(2883),
    [anon_sym_export] = ACTIONS(2883),
    [anon_sym_module] = ACTIONS(2883),
    [anon_sym_import] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_delete] = ACTIONS(2883),
    [anon_sym_throw] = ACTIONS(2883),
    [anon_sym_namespace] = ACTIONS(2883),
    [anon_sym_static_assert] = ACTIONS(2883),
    [anon_sym_concept] = ACTIONS(2883),
    [anon_sym_co_return] = ACTIONS(2883),
    [anon_sym_co_yield] = ACTIONS(2883),
    [anon_sym_R_DQUOTE] = ACTIONS(2881),
    [anon_sym_LR_DQUOTE] = ACTIONS(2881),
    [anon_sym_uR_DQUOTE] = ACTIONS(2881),
    [anon_sym_UR_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2881),
    [anon_sym_co_await] = ACTIONS(2883),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_requires] = ACTIONS(2883),
    [sym_this] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
    [anon_sym_interface] = ACTIONS(2883),
    [anon_sym_extension] = ACTIONS(2883),
    [anon_sym___exported] = ACTIONS(2883),
  },
  [686] = {
    [sym_attribute_specifier] = STATE(319),
    [ts_builtin_sym_end] = ACTIONS(4174),
    [sym_identifier] = ACTIONS(4176),
    [aux_sym_preproc_include_token1] = ACTIONS(4176),
    [aux_sym_preproc_def_token1] = ACTIONS(4176),
    [aux_sym_preproc_if_token1] = ACTIONS(4176),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4176),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4176),
    [sym_preproc_directive] = ACTIONS(4176),
    [anon_sym_LPAREN2] = ACTIONS(4174),
    [anon_sym_BANG] = ACTIONS(4174),
    [anon_sym_TILDE] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4176),
    [anon_sym_PLUS] = ACTIONS(4176),
    [anon_sym_STAR] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4176),
    [anon_sym_SEMI] = ACTIONS(4174),
    [anon_sym___extension__] = ACTIONS(4176),
    [anon_sym_typedef] = ACTIONS(4176),
    [anon_sym_in] = ACTIONS(4176),
    [anon_sym_out] = ACTIONS(4176),
    [anon_sym_inout] = ACTIONS(4176),
    [anon_sym_virtual] = ACTIONS(4176),
    [anon_sym_extern] = ACTIONS(4176),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(4176),
    [anon_sym_COLON_COLON] = ACTIONS(4174),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4174),
    [anon_sym___declspec] = ACTIONS(4176),
    [anon_sym___based] = ACTIONS(4176),
    [anon_sym___cdecl] = ACTIONS(4176),
    [anon_sym___clrcall] = ACTIONS(4176),
    [anon_sym___stdcall] = ACTIONS(4176),
    [anon_sym___fastcall] = ACTIONS(4176),
    [anon_sym___thiscall] = ACTIONS(4176),
    [anon_sym___vectorcall] = ACTIONS(4176),
    [anon_sym_LBRACE] = ACTIONS(4174),
    [anon_sym_signed] = ACTIONS(4176),
    [anon_sym_unsigned] = ACTIONS(4176),
    [anon_sym_long] = ACTIONS(4176),
    [anon_sym_short] = ACTIONS(4176),
    [anon_sym_LBRACK] = ACTIONS(4176),
    [anon_sym_static] = ACTIONS(4176),
    [anon_sym_register] = ACTIONS(4176),
    [anon_sym_inline] = ACTIONS(4176),
    [anon_sym___inline] = ACTIONS(4176),
    [anon_sym___inline__] = ACTIONS(4176),
    [anon_sym___forceinline] = ACTIONS(4176),
    [anon_sym_thread_local] = ACTIONS(4176),
    [anon_sym___thread] = ACTIONS(4176),
    [anon_sym_const] = ACTIONS(4176),
    [anon_sym_constexpr] = ACTIONS(4176),
    [anon_sym_volatile] = ACTIONS(4176),
    [anon_sym_restrict] = ACTIONS(4176),
    [anon_sym___restrict__] = ACTIONS(4176),
    [anon_sym__Atomic] = ACTIONS(4176),
    [anon_sym__Noreturn] = ACTIONS(4176),
    [anon_sym_noreturn] = ACTIONS(4176),
    [anon_sym__Nonnull] = ACTIONS(4176),
    [anon_sym_mutable] = ACTIONS(4176),
    [anon_sym_constinit] = ACTIONS(4176),
    [anon_sym_consteval] = ACTIONS(4176),
    [anon_sym_alignas] = ACTIONS(4176),
    [anon_sym__Alignas] = ACTIONS(4176),
    [sym_primitive_type] = ACTIONS(4176),
    [anon_sym_enum] = ACTIONS(4176),
    [anon_sym_class] = ACTIONS(4176),
    [anon_sym_struct] = ACTIONS(4176),
    [anon_sym_union] = ACTIONS(4176),
    [anon_sym_if] = ACTIONS(4176),
    [anon_sym_switch] = ACTIONS(4176),
    [anon_sym_case] = ACTIONS(4176),
    [anon_sym_default] = ACTIONS(4176),
    [anon_sym_while] = ACTIONS(4176),
    [anon_sym_do] = ACTIONS(4176),
    [anon_sym_for] = ACTIONS(4176),
    [anon_sym_return] = ACTIONS(4176),
    [anon_sym_break] = ACTIONS(4176),
    [anon_sym_continue] = ACTIONS(4176),
    [anon_sym_goto] = ACTIONS(4176),
    [anon_sym_not] = ACTIONS(4176),
    [anon_sym_compl] = ACTIONS(4176),
    [anon_sym_DASH_DASH] = ACTIONS(4174),
    [anon_sym_PLUS_PLUS] = ACTIONS(4174),
    [anon_sym_sizeof] = ACTIONS(4176),
    [anon_sym___alignof__] = ACTIONS(4176),
    [anon_sym___alignof] = ACTIONS(4176),
    [anon_sym__alignof] = ACTIONS(4176),
    [anon_sym_alignof] = ACTIONS(4176),
    [anon_sym__Alignof] = ACTIONS(4176),
    [anon_sym_offsetof] = ACTIONS(4176),
    [anon_sym__Generic] = ACTIONS(4176),
    [anon_sym_asm] = ACTIONS(4176),
    [anon_sym___asm__] = ACTIONS(4176),
    [anon_sym___asm] = ACTIONS(4176),
    [anon_sym_DOT] = ACTIONS(4176),
    [sym_number_literal] = ACTIONS(4174),
    [anon_sym_L_SQUOTE] = ACTIONS(4174),
    [anon_sym_u_SQUOTE] = ACTIONS(4174),
    [anon_sym_U_SQUOTE] = ACTIONS(4174),
    [anon_sym_u8_SQUOTE] = ACTIONS(4174),
    [anon_sym_SQUOTE] = ACTIONS(4174),
    [anon_sym_L_DQUOTE] = ACTIONS(4174),
    [anon_sym_u_DQUOTE] = ACTIONS(4174),
    [anon_sym_U_DQUOTE] = ACTIONS(4174),
    [anon_sym_u8_DQUOTE] = ACTIONS(4174),
    [anon_sym_DQUOTE] = ACTIONS(4174),
    [sym_true] = ACTIONS(4176),
    [sym_false] = ACTIONS(4176),
    [anon_sym_NULL] = ACTIONS(4176),
    [anon_sym_nullptr] = ACTIONS(4176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4176),
    [anon_sym_let] = ACTIONS(4176),
    [anon_sym_This] = ACTIONS(4176),
    [anon_sym_decltype] = ACTIONS(4176),
    [anon_sym_explicit] = ACTIONS(4176),
    [anon_sym_typename] = ACTIONS(4176),
    [anon_sym_export] = ACTIONS(4176),
    [anon_sym_module] = ACTIONS(4176),
    [anon_sym_import] = ACTIONS(4176),
    [anon_sym_template] = ACTIONS(4176),
    [anon_sym_operator] = ACTIONS(4176),
    [anon_sym_try] = ACTIONS(4176),
    [anon_sym_delete] = ACTIONS(4176),
    [anon_sym_throw] = ACTIONS(4176),
    [anon_sym_namespace] = ACTIONS(4176),
    [anon_sym_static_assert] = ACTIONS(4176),
    [anon_sym_concept] = ACTIONS(4176),
    [anon_sym_co_return] = ACTIONS(4176),
    [anon_sym_co_yield] = ACTIONS(4176),
    [anon_sym_R_DQUOTE] = ACTIONS(4174),
    [anon_sym_LR_DQUOTE] = ACTIONS(4174),
    [anon_sym_uR_DQUOTE] = ACTIONS(4174),
    [anon_sym_UR_DQUOTE] = ACTIONS(4174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4174),
    [anon_sym_co_await] = ACTIONS(4176),
    [anon_sym_new] = ACTIONS(4176),
    [anon_sym_requires] = ACTIONS(4176),
    [sym_this] = ACTIONS(4176),
    [anon_sym_precise] = ACTIONS(4176),
    [anon_sym_shared] = ACTIONS(4176),
    [anon_sym_groupshared] = ACTIONS(4176),
    [anon_sym_uniform] = ACTIONS(4176),
    [anon_sym_row_major] = ACTIONS(4176),
    [anon_sym_column_major] = ACTIONS(4176),
    [anon_sym_globallycoherent] = ACTIONS(4176),
    [anon_sym_centroid] = ACTIONS(4176),
    [anon_sym_noperspective] = ACTIONS(4176),
    [anon_sym_nointerpolation] = ACTIONS(4176),
    [anon_sym_sample] = ACTIONS(4176),
    [anon_sym_linear] = ACTIONS(4176),
    [anon_sym_snorm] = ACTIONS(4176),
    [anon_sym_unorm] = ACTIONS(4176),
    [anon_sym_point] = ACTIONS(4176),
    [anon_sym_line] = ACTIONS(4176),
    [anon_sym_triangleadj] = ACTIONS(4176),
    [anon_sym_lineadj] = ACTIONS(4176),
    [anon_sym_triangle] = ACTIONS(4176),
    [anon_sym_interface] = ACTIONS(4176),
    [anon_sym_extension] = ACTIONS(4176),
    [anon_sym___exported] = ACTIONS(4176),
  },
  [687] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(692),
    [sym_identifier] = ACTIONS(4178),
    [aux_sym_preproc_include_token1] = ACTIONS(4178),
    [aux_sym_preproc_def_token1] = ACTIONS(4178),
    [aux_sym_preproc_if_token1] = ACTIONS(4178),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4178),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4178),
    [sym_preproc_directive] = ACTIONS(4178),
    [anon_sym_LPAREN2] = ACTIONS(4180),
    [anon_sym_BANG] = ACTIONS(4180),
    [anon_sym_TILDE] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4178),
    [anon_sym_PLUS] = ACTIONS(4178),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_AMP] = ACTIONS(4178),
    [anon_sym_SEMI] = ACTIONS(4180),
    [anon_sym___extension__] = ACTIONS(4178),
    [anon_sym_typedef] = ACTIONS(4178),
    [anon_sym_in] = ACTIONS(4178),
    [anon_sym_out] = ACTIONS(4178),
    [anon_sym_inout] = ACTIONS(4178),
    [anon_sym_virtual] = ACTIONS(4178),
    [anon_sym_extern] = ACTIONS(4178),
    [anon_sym___attribute__] = ACTIONS(4178),
    [anon_sym___attribute] = ACTIONS(4178),
    [anon_sym_using] = ACTIONS(4178),
    [anon_sym_COLON_COLON] = ACTIONS(4180),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4180),
    [anon_sym___declspec] = ACTIONS(4178),
    [anon_sym___based] = ACTIONS(4178),
    [anon_sym___cdecl] = ACTIONS(4178),
    [anon_sym___clrcall] = ACTIONS(4178),
    [anon_sym___stdcall] = ACTIONS(4178),
    [anon_sym___fastcall] = ACTIONS(4178),
    [anon_sym___thiscall] = ACTIONS(4178),
    [anon_sym___vectorcall] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_RBRACE] = ACTIONS(4180),
    [anon_sym_signed] = ACTIONS(4182),
    [anon_sym_unsigned] = ACTIONS(4182),
    [anon_sym_long] = ACTIONS(4182),
    [anon_sym_short] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4178),
    [anon_sym_static] = ACTIONS(4178),
    [anon_sym_register] = ACTIONS(4178),
    [anon_sym_inline] = ACTIONS(4178),
    [anon_sym___inline] = ACTIONS(4178),
    [anon_sym___inline__] = ACTIONS(4178),
    [anon_sym___forceinline] = ACTIONS(4178),
    [anon_sym_thread_local] = ACTIONS(4178),
    [anon_sym___thread] = ACTIONS(4178),
    [anon_sym_const] = ACTIONS(4178),
    [anon_sym_constexpr] = ACTIONS(4178),
    [anon_sym_volatile] = ACTIONS(4178),
    [anon_sym_restrict] = ACTIONS(4178),
    [anon_sym___restrict__] = ACTIONS(4178),
    [anon_sym__Atomic] = ACTIONS(4178),
    [anon_sym__Noreturn] = ACTIONS(4178),
    [anon_sym_noreturn] = ACTIONS(4178),
    [anon_sym__Nonnull] = ACTIONS(4178),
    [anon_sym_mutable] = ACTIONS(4178),
    [anon_sym_constinit] = ACTIONS(4178),
    [anon_sym_consteval] = ACTIONS(4178),
    [anon_sym_alignas] = ACTIONS(4178),
    [anon_sym__Alignas] = ACTIONS(4178),
    [sym_primitive_type] = ACTIONS(4178),
    [anon_sym_enum] = ACTIONS(4178),
    [anon_sym_class] = ACTIONS(4178),
    [anon_sym_struct] = ACTIONS(4178),
    [anon_sym_union] = ACTIONS(4178),
    [anon_sym_if] = ACTIONS(4178),
    [anon_sym_switch] = ACTIONS(4178),
    [anon_sym_case] = ACTIONS(4178),
    [anon_sym_default] = ACTIONS(4178),
    [anon_sym_while] = ACTIONS(4178),
    [anon_sym_do] = ACTIONS(4178),
    [anon_sym_for] = ACTIONS(4178),
    [anon_sym_return] = ACTIONS(4178),
    [anon_sym_break] = ACTIONS(4178),
    [anon_sym_continue] = ACTIONS(4178),
    [anon_sym_goto] = ACTIONS(4178),
    [anon_sym___try] = ACTIONS(4178),
    [anon_sym___leave] = ACTIONS(4178),
    [anon_sym_not] = ACTIONS(4178),
    [anon_sym_compl] = ACTIONS(4178),
    [anon_sym_DASH_DASH] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4180),
    [anon_sym_sizeof] = ACTIONS(4178),
    [anon_sym___alignof__] = ACTIONS(4178),
    [anon_sym___alignof] = ACTIONS(4178),
    [anon_sym__alignof] = ACTIONS(4178),
    [anon_sym_alignof] = ACTIONS(4178),
    [anon_sym__Alignof] = ACTIONS(4178),
    [anon_sym_offsetof] = ACTIONS(4178),
    [anon_sym__Generic] = ACTIONS(4178),
    [anon_sym_asm] = ACTIONS(4178),
    [anon_sym___asm__] = ACTIONS(4178),
    [anon_sym___asm] = ACTIONS(4178),
    [anon_sym_DOT] = ACTIONS(4178),
    [sym_number_literal] = ACTIONS(4180),
    [anon_sym_L_SQUOTE] = ACTIONS(4180),
    [anon_sym_u_SQUOTE] = ACTIONS(4180),
    [anon_sym_U_SQUOTE] = ACTIONS(4180),
    [anon_sym_u8_SQUOTE] = ACTIONS(4180),
    [anon_sym_SQUOTE] = ACTIONS(4180),
    [anon_sym_L_DQUOTE] = ACTIONS(4180),
    [anon_sym_u_DQUOTE] = ACTIONS(4180),
    [anon_sym_U_DQUOTE] = ACTIONS(4180),
    [anon_sym_u8_DQUOTE] = ACTIONS(4180),
    [anon_sym_DQUOTE] = ACTIONS(4180),
    [sym_true] = ACTIONS(4178),
    [sym_false] = ACTIONS(4178),
    [anon_sym_NULL] = ACTIONS(4178),
    [anon_sym_nullptr] = ACTIONS(4178),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4178),
    [anon_sym_let] = ACTIONS(4178),
    [anon_sym_This] = ACTIONS(4178),
    [anon_sym_decltype] = ACTIONS(4178),
    [anon_sym_explicit] = ACTIONS(4178),
    [anon_sym_typename] = ACTIONS(4178),
    [anon_sym_template] = ACTIONS(4178),
    [anon_sym_operator] = ACTIONS(4178),
    [anon_sym_try] = ACTIONS(4178),
    [anon_sym_delete] = ACTIONS(4178),
    [anon_sym_throw] = ACTIONS(4178),
    [anon_sym_namespace] = ACTIONS(4178),
    [anon_sym_static_assert] = ACTIONS(4178),
    [anon_sym_concept] = ACTIONS(4178),
    [anon_sym_co_return] = ACTIONS(4178),
    [anon_sym_co_yield] = ACTIONS(4178),
    [anon_sym_R_DQUOTE] = ACTIONS(4180),
    [anon_sym_LR_DQUOTE] = ACTIONS(4180),
    [anon_sym_uR_DQUOTE] = ACTIONS(4180),
    [anon_sym_UR_DQUOTE] = ACTIONS(4180),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4180),
    [anon_sym_co_await] = ACTIONS(4178),
    [anon_sym_new] = ACTIONS(4178),
    [anon_sym_requires] = ACTIONS(4178),
    [sym_this] = ACTIONS(4178),
    [anon_sym_discard] = ACTIONS(4178),
    [anon_sym_precise] = ACTIONS(4178),
    [anon_sym_shared] = ACTIONS(4178),
    [anon_sym_groupshared] = ACTIONS(4178),
    [anon_sym_uniform] = ACTIONS(4178),
    [anon_sym_row_major] = ACTIONS(4178),
    [anon_sym_column_major] = ACTIONS(4178),
    [anon_sym_globallycoherent] = ACTIONS(4178),
    [anon_sym_centroid] = ACTIONS(4178),
    [anon_sym_noperspective] = ACTIONS(4178),
    [anon_sym_nointerpolation] = ACTIONS(4178),
    [anon_sym_sample] = ACTIONS(4178),
    [anon_sym_linear] = ACTIONS(4178),
    [anon_sym_snorm] = ACTIONS(4178),
    [anon_sym_unorm] = ACTIONS(4178),
    [anon_sym_point] = ACTIONS(4178),
    [anon_sym_line] = ACTIONS(4178),
    [anon_sym_triangleadj] = ACTIONS(4178),
    [anon_sym_lineadj] = ACTIONS(4178),
    [anon_sym_triangle] = ACTIONS(4178),
    [anon_sym_cbuffer] = ACTIONS(4178),
    [anon_sym_interface] = ACTIONS(4178),
    [anon_sym_extension] = ACTIONS(4178),
  },
  [688] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(672),
    [sym_identifier] = ACTIONS(4185),
    [aux_sym_preproc_include_token1] = ACTIONS(4185),
    [aux_sym_preproc_def_token1] = ACTIONS(4185),
    [aux_sym_preproc_if_token1] = ACTIONS(4185),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4185),
    [sym_preproc_directive] = ACTIONS(4185),
    [anon_sym_LPAREN2] = ACTIONS(4187),
    [anon_sym_BANG] = ACTIONS(4187),
    [anon_sym_TILDE] = ACTIONS(4187),
    [anon_sym_DASH] = ACTIONS(4185),
    [anon_sym_PLUS] = ACTIONS(4185),
    [anon_sym_STAR] = ACTIONS(4187),
    [anon_sym_AMP_AMP] = ACTIONS(4187),
    [anon_sym_AMP] = ACTIONS(4185),
    [anon_sym_SEMI] = ACTIONS(4187),
    [anon_sym___extension__] = ACTIONS(4185),
    [anon_sym_typedef] = ACTIONS(4185),
    [anon_sym_in] = ACTIONS(4185),
    [anon_sym_out] = ACTIONS(4185),
    [anon_sym_inout] = ACTIONS(4185),
    [anon_sym_virtual] = ACTIONS(4185),
    [anon_sym_extern] = ACTIONS(4185),
    [anon_sym___attribute__] = ACTIONS(4185),
    [anon_sym___attribute] = ACTIONS(4185),
    [anon_sym_using] = ACTIONS(4185),
    [anon_sym_COLON_COLON] = ACTIONS(4187),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4187),
    [anon_sym___declspec] = ACTIONS(4185),
    [anon_sym___based] = ACTIONS(4185),
    [anon_sym___cdecl] = ACTIONS(4185),
    [anon_sym___clrcall] = ACTIONS(4185),
    [anon_sym___stdcall] = ACTIONS(4185),
    [anon_sym___fastcall] = ACTIONS(4185),
    [anon_sym___thiscall] = ACTIONS(4185),
    [anon_sym___vectorcall] = ACTIONS(4185),
    [anon_sym_LBRACE] = ACTIONS(4187),
    [anon_sym_RBRACE] = ACTIONS(4187),
    [anon_sym_signed] = ACTIONS(4189),
    [anon_sym_unsigned] = ACTIONS(4189),
    [anon_sym_long] = ACTIONS(4189),
    [anon_sym_short] = ACTIONS(4189),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [anon_sym_static] = ACTIONS(4185),
    [anon_sym_register] = ACTIONS(4185),
    [anon_sym_inline] = ACTIONS(4185),
    [anon_sym___inline] = ACTIONS(4185),
    [anon_sym___inline__] = ACTIONS(4185),
    [anon_sym___forceinline] = ACTIONS(4185),
    [anon_sym_thread_local] = ACTIONS(4185),
    [anon_sym___thread] = ACTIONS(4185),
    [anon_sym_const] = ACTIONS(4185),
    [anon_sym_constexpr] = ACTIONS(4185),
    [anon_sym_volatile] = ACTIONS(4185),
    [anon_sym_restrict] = ACTIONS(4185),
    [anon_sym___restrict__] = ACTIONS(4185),
    [anon_sym__Atomic] = ACTIONS(4185),
    [anon_sym__Noreturn] = ACTIONS(4185),
    [anon_sym_noreturn] = ACTIONS(4185),
    [anon_sym__Nonnull] = ACTIONS(4185),
    [anon_sym_mutable] = ACTIONS(4185),
    [anon_sym_constinit] = ACTIONS(4185),
    [anon_sym_consteval] = ACTIONS(4185),
    [anon_sym_alignas] = ACTIONS(4185),
    [anon_sym__Alignas] = ACTIONS(4185),
    [sym_primitive_type] = ACTIONS(4185),
    [anon_sym_enum] = ACTIONS(4185),
    [anon_sym_class] = ACTIONS(4185),
    [anon_sym_struct] = ACTIONS(4185),
    [anon_sym_union] = ACTIONS(4185),
    [anon_sym_if] = ACTIONS(4185),
    [anon_sym_switch] = ACTIONS(4185),
    [anon_sym_case] = ACTIONS(4185),
    [anon_sym_default] = ACTIONS(4185),
    [anon_sym_while] = ACTIONS(4185),
    [anon_sym_do] = ACTIONS(4185),
    [anon_sym_for] = ACTIONS(4185),
    [anon_sym_return] = ACTIONS(4185),
    [anon_sym_break] = ACTIONS(4185),
    [anon_sym_continue] = ACTIONS(4185),
    [anon_sym_goto] = ACTIONS(4185),
    [anon_sym___try] = ACTIONS(4185),
    [anon_sym___leave] = ACTIONS(4185),
    [anon_sym_not] = ACTIONS(4185),
    [anon_sym_compl] = ACTIONS(4185),
    [anon_sym_DASH_DASH] = ACTIONS(4187),
    [anon_sym_PLUS_PLUS] = ACTIONS(4187),
    [anon_sym_sizeof] = ACTIONS(4185),
    [anon_sym___alignof__] = ACTIONS(4185),
    [anon_sym___alignof] = ACTIONS(4185),
    [anon_sym__alignof] = ACTIONS(4185),
    [anon_sym_alignof] = ACTIONS(4185),
    [anon_sym__Alignof] = ACTIONS(4185),
    [anon_sym_offsetof] = ACTIONS(4185),
    [anon_sym__Generic] = ACTIONS(4185),
    [anon_sym_asm] = ACTIONS(4185),
    [anon_sym___asm__] = ACTIONS(4185),
    [anon_sym___asm] = ACTIONS(4185),
    [anon_sym_DOT] = ACTIONS(4185),
    [sym_number_literal] = ACTIONS(4187),
    [anon_sym_L_SQUOTE] = ACTIONS(4187),
    [anon_sym_u_SQUOTE] = ACTIONS(4187),
    [anon_sym_U_SQUOTE] = ACTIONS(4187),
    [anon_sym_u8_SQUOTE] = ACTIONS(4187),
    [anon_sym_SQUOTE] = ACTIONS(4187),
    [anon_sym_L_DQUOTE] = ACTIONS(4187),
    [anon_sym_u_DQUOTE] = ACTIONS(4187),
    [anon_sym_U_DQUOTE] = ACTIONS(4187),
    [anon_sym_u8_DQUOTE] = ACTIONS(4187),
    [anon_sym_DQUOTE] = ACTIONS(4187),
    [sym_true] = ACTIONS(4185),
    [sym_false] = ACTIONS(4185),
    [anon_sym_NULL] = ACTIONS(4185),
    [anon_sym_nullptr] = ACTIONS(4185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4185),
    [anon_sym_let] = ACTIONS(4185),
    [anon_sym_This] = ACTIONS(4185),
    [anon_sym_decltype] = ACTIONS(4185),
    [anon_sym_explicit] = ACTIONS(4185),
    [anon_sym_typename] = ACTIONS(4185),
    [anon_sym_template] = ACTIONS(4185),
    [anon_sym_operator] = ACTIONS(4185),
    [anon_sym_try] = ACTIONS(4185),
    [anon_sym_delete] = ACTIONS(4185),
    [anon_sym_throw] = ACTIONS(4185),
    [anon_sym_namespace] = ACTIONS(4185),
    [anon_sym_static_assert] = ACTIONS(4185),
    [anon_sym_concept] = ACTIONS(4185),
    [anon_sym_co_return] = ACTIONS(4185),
    [anon_sym_co_yield] = ACTIONS(4185),
    [anon_sym_R_DQUOTE] = ACTIONS(4187),
    [anon_sym_LR_DQUOTE] = ACTIONS(4187),
    [anon_sym_uR_DQUOTE] = ACTIONS(4187),
    [anon_sym_UR_DQUOTE] = ACTIONS(4187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4187),
    [anon_sym_co_await] = ACTIONS(4185),
    [anon_sym_new] = ACTIONS(4185),
    [anon_sym_requires] = ACTIONS(4185),
    [sym_this] = ACTIONS(4185),
    [anon_sym_discard] = ACTIONS(4185),
    [anon_sym_precise] = ACTIONS(4185),
    [anon_sym_shared] = ACTIONS(4185),
    [anon_sym_groupshared] = ACTIONS(4185),
    [anon_sym_uniform] = ACTIONS(4185),
    [anon_sym_row_major] = ACTIONS(4185),
    [anon_sym_column_major] = ACTIONS(4185),
    [anon_sym_globallycoherent] = ACTIONS(4185),
    [anon_sym_centroid] = ACTIONS(4185),
    [anon_sym_noperspective] = ACTIONS(4185),
    [anon_sym_nointerpolation] = ACTIONS(4185),
    [anon_sym_sample] = ACTIONS(4185),
    [anon_sym_linear] = ACTIONS(4185),
    [anon_sym_snorm] = ACTIONS(4185),
    [anon_sym_unorm] = ACTIONS(4185),
    [anon_sym_point] = ACTIONS(4185),
    [anon_sym_line] = ACTIONS(4185),
    [anon_sym_triangleadj] = ACTIONS(4185),
    [anon_sym_lineadj] = ACTIONS(4185),
    [anon_sym_triangle] = ACTIONS(4185),
    [anon_sym_cbuffer] = ACTIONS(4185),
    [anon_sym_interface] = ACTIONS(4185),
    [anon_sym_extension] = ACTIONS(4185),
  },
  [689] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(2974),
    [aux_sym_preproc_include_token1] = ACTIONS(2974),
    [aux_sym_preproc_def_token1] = ACTIONS(2974),
    [aux_sym_preproc_if_token1] = ACTIONS(2974),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2974),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2974),
    [sym_preproc_directive] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_BANG] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym___extension__] = ACTIONS(2974),
    [anon_sym_typedef] = ACTIONS(2974),
    [anon_sym_in] = ACTIONS(2974),
    [anon_sym_out] = ACTIONS(2974),
    [anon_sym_inout] = ACTIONS(2974),
    [anon_sym_virtual] = ACTIONS(2974),
    [anon_sym_extern] = ACTIONS(2974),
    [anon_sym___attribute__] = ACTIONS(2974),
    [anon_sym___attribute] = ACTIONS(2974),
    [anon_sym_using] = ACTIONS(2974),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2974),
    [anon_sym___based] = ACTIONS(2974),
    [anon_sym___cdecl] = ACTIONS(2974),
    [anon_sym___clrcall] = ACTIONS(2974),
    [anon_sym___stdcall] = ACTIONS(2974),
    [anon_sym___fastcall] = ACTIONS(2974),
    [anon_sym___thiscall] = ACTIONS(2974),
    [anon_sym___vectorcall] = ACTIONS(2974),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_signed] = ACTIONS(2974),
    [anon_sym_unsigned] = ACTIONS(2974),
    [anon_sym_long] = ACTIONS(2974),
    [anon_sym_short] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [anon_sym_static] = ACTIONS(2974),
    [anon_sym_register] = ACTIONS(2974),
    [anon_sym_inline] = ACTIONS(2974),
    [anon_sym___inline] = ACTIONS(2974),
    [anon_sym___inline__] = ACTIONS(2974),
    [anon_sym___forceinline] = ACTIONS(2974),
    [anon_sym_thread_local] = ACTIONS(2974),
    [anon_sym___thread] = ACTIONS(2974),
    [anon_sym_const] = ACTIONS(2974),
    [anon_sym_constexpr] = ACTIONS(2974),
    [anon_sym_volatile] = ACTIONS(2974),
    [anon_sym_restrict] = ACTIONS(2974),
    [anon_sym___restrict__] = ACTIONS(2974),
    [anon_sym__Atomic] = ACTIONS(2974),
    [anon_sym__Noreturn] = ACTIONS(2974),
    [anon_sym_noreturn] = ACTIONS(2974),
    [anon_sym__Nonnull] = ACTIONS(2974),
    [anon_sym_mutable] = ACTIONS(2974),
    [anon_sym_constinit] = ACTIONS(2974),
    [anon_sym_consteval] = ACTIONS(2974),
    [anon_sym_alignas] = ACTIONS(2974),
    [anon_sym__Alignas] = ACTIONS(2974),
    [sym_primitive_type] = ACTIONS(2974),
    [anon_sym_enum] = ACTIONS(2974),
    [anon_sym_class] = ACTIONS(2974),
    [anon_sym_struct] = ACTIONS(2974),
    [anon_sym_union] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2974),
    [anon_sym_switch] = ACTIONS(2974),
    [anon_sym_case] = ACTIONS(2974),
    [anon_sym_default] = ACTIONS(2974),
    [anon_sym_while] = ACTIONS(2974),
    [anon_sym_do] = ACTIONS(2974),
    [anon_sym_for] = ACTIONS(2974),
    [anon_sym_return] = ACTIONS(2974),
    [anon_sym_break] = ACTIONS(2974),
    [anon_sym_continue] = ACTIONS(2974),
    [anon_sym_goto] = ACTIONS(2974),
    [anon_sym___try] = ACTIONS(2974),
    [anon_sym___leave] = ACTIONS(2974),
    [anon_sym_not] = ACTIONS(2974),
    [anon_sym_compl] = ACTIONS(2974),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_sizeof] = ACTIONS(2974),
    [anon_sym___alignof__] = ACTIONS(2974),
    [anon_sym___alignof] = ACTIONS(2974),
    [anon_sym__alignof] = ACTIONS(2974),
    [anon_sym_alignof] = ACTIONS(2974),
    [anon_sym__Alignof] = ACTIONS(2974),
    [anon_sym_offsetof] = ACTIONS(2974),
    [anon_sym__Generic] = ACTIONS(2974),
    [anon_sym_asm] = ACTIONS(2974),
    [anon_sym___asm__] = ACTIONS(2974),
    [anon_sym___asm] = ACTIONS(2974),
    [anon_sym_DOT] = ACTIONS(2974),
    [sym_number_literal] = ACTIONS(2972),
    [anon_sym_L_SQUOTE] = ACTIONS(2972),
    [anon_sym_u_SQUOTE] = ACTIONS(2972),
    [anon_sym_U_SQUOTE] = ACTIONS(2972),
    [anon_sym_u8_SQUOTE] = ACTIONS(2972),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [anon_sym_L_DQUOTE] = ACTIONS(2972),
    [anon_sym_u_DQUOTE] = ACTIONS(2972),
    [anon_sym_U_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE] = ACTIONS(2972),
    [sym_true] = ACTIONS(2974),
    [sym_false] = ACTIONS(2974),
    [anon_sym_NULL] = ACTIONS(2974),
    [anon_sym_nullptr] = ACTIONS(2974),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_This] = ACTIONS(2974),
    [anon_sym_decltype] = ACTIONS(2974),
    [anon_sym_explicit] = ACTIONS(2974),
    [anon_sym_typename] = ACTIONS(2974),
    [anon_sym_template] = ACTIONS(2974),
    [anon_sym_operator] = ACTIONS(2974),
    [anon_sym_try] = ACTIONS(2974),
    [anon_sym_delete] = ACTIONS(2974),
    [anon_sym_throw] = ACTIONS(2974),
    [anon_sym_namespace] = ACTIONS(2974),
    [anon_sym_static_assert] = ACTIONS(2974),
    [anon_sym_concept] = ACTIONS(2974),
    [anon_sym_co_return] = ACTIONS(2974),
    [anon_sym_co_yield] = ACTIONS(2974),
    [anon_sym_R_DQUOTE] = ACTIONS(2972),
    [anon_sym_LR_DQUOTE] = ACTIONS(2972),
    [anon_sym_uR_DQUOTE] = ACTIONS(2972),
    [anon_sym_UR_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2972),
    [anon_sym_co_await] = ACTIONS(2974),
    [anon_sym_new] = ACTIONS(2974),
    [anon_sym_requires] = ACTIONS(2974),
    [sym_this] = ACTIONS(2974),
    [anon_sym_discard] = ACTIONS(2974),
    [anon_sym_precise] = ACTIONS(2974),
    [anon_sym_shared] = ACTIONS(2974),
    [anon_sym_groupshared] = ACTIONS(2974),
    [anon_sym_uniform] = ACTIONS(2974),
    [anon_sym_row_major] = ACTIONS(2974),
    [anon_sym_column_major] = ACTIONS(2974),
    [anon_sym_globallycoherent] = ACTIONS(2974),
    [anon_sym_centroid] = ACTIONS(2974),
    [anon_sym_noperspective] = ACTIONS(2974),
    [anon_sym_nointerpolation] = ACTIONS(2974),
    [anon_sym_sample] = ACTIONS(2974),
    [anon_sym_linear] = ACTIONS(2974),
    [anon_sym_snorm] = ACTIONS(2974),
    [anon_sym_unorm] = ACTIONS(2974),
    [anon_sym_point] = ACTIONS(2974),
    [anon_sym_line] = ACTIONS(2974),
    [anon_sym_triangleadj] = ACTIONS(2974),
    [anon_sym_lineadj] = ACTIONS(2974),
    [anon_sym_triangle] = ACTIONS(2974),
    [anon_sym_cbuffer] = ACTIONS(2974),
    [anon_sym_interface] = ACTIONS(2974),
    [anon_sym_extension] = ACTIONS(2974),
  },
  [690] = {
    [sym_attribute_specifier] = STATE(797),
    [sym_identifier] = ACTIONS(4087),
    [aux_sym_preproc_include_token1] = ACTIONS(4087),
    [aux_sym_preproc_def_token1] = ACTIONS(4087),
    [aux_sym_preproc_if_token1] = ACTIONS(4087),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4087),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4087),
    [sym_preproc_directive] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4085),
    [anon_sym_BANG] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4087),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4087),
    [anon_sym_SEMI] = ACTIONS(4085),
    [anon_sym___extension__] = ACTIONS(4087),
    [anon_sym_typedef] = ACTIONS(4087),
    [anon_sym_in] = ACTIONS(4087),
    [anon_sym_out] = ACTIONS(4087),
    [anon_sym_inout] = ACTIONS(4087),
    [anon_sym_virtual] = ACTIONS(4087),
    [anon_sym_extern] = ACTIONS(4087),
    [anon_sym___attribute__] = ACTIONS(2897),
    [anon_sym___attribute] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(4087),
    [anon_sym_COLON_COLON] = ACTIONS(4085),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4085),
    [anon_sym___declspec] = ACTIONS(4087),
    [anon_sym___based] = ACTIONS(4087),
    [anon_sym___cdecl] = ACTIONS(4087),
    [anon_sym___clrcall] = ACTIONS(4087),
    [anon_sym___stdcall] = ACTIONS(4087),
    [anon_sym___fastcall] = ACTIONS(4087),
    [anon_sym___thiscall] = ACTIONS(4087),
    [anon_sym___vectorcall] = ACTIONS(4087),
    [anon_sym_LBRACE] = ACTIONS(4085),
    [anon_sym_RBRACE] = ACTIONS(4085),
    [anon_sym_signed] = ACTIONS(4087),
    [anon_sym_unsigned] = ACTIONS(4087),
    [anon_sym_long] = ACTIONS(4087),
    [anon_sym_short] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(4087),
    [anon_sym_static] = ACTIONS(4087),
    [anon_sym_register] = ACTIONS(4087),
    [anon_sym_inline] = ACTIONS(4087),
    [anon_sym___inline] = ACTIONS(4087),
    [anon_sym___inline__] = ACTIONS(4087),
    [anon_sym___forceinline] = ACTIONS(4087),
    [anon_sym_thread_local] = ACTIONS(4087),
    [anon_sym___thread] = ACTIONS(4087),
    [anon_sym_const] = ACTIONS(4087),
    [anon_sym_constexpr] = ACTIONS(4087),
    [anon_sym_volatile] = ACTIONS(4087),
    [anon_sym_restrict] = ACTIONS(4087),
    [anon_sym___restrict__] = ACTIONS(4087),
    [anon_sym__Atomic] = ACTIONS(4087),
    [anon_sym__Noreturn] = ACTIONS(4087),
    [anon_sym_noreturn] = ACTIONS(4087),
    [anon_sym__Nonnull] = ACTIONS(4087),
    [anon_sym_mutable] = ACTIONS(4087),
    [anon_sym_constinit] = ACTIONS(4087),
    [anon_sym_consteval] = ACTIONS(4087),
    [anon_sym_alignas] = ACTIONS(4087),
    [anon_sym__Alignas] = ACTIONS(4087),
    [sym_primitive_type] = ACTIONS(4087),
    [anon_sym_enum] = ACTIONS(4087),
    [anon_sym_class] = ACTIONS(4087),
    [anon_sym_struct] = ACTIONS(4087),
    [anon_sym_union] = ACTIONS(4087),
    [anon_sym_if] = ACTIONS(4087),
    [anon_sym_switch] = ACTIONS(4087),
    [anon_sym_case] = ACTIONS(4087),
    [anon_sym_default] = ACTIONS(4087),
    [anon_sym_while] = ACTIONS(4087),
    [anon_sym_do] = ACTIONS(4087),
    [anon_sym_for] = ACTIONS(4087),
    [anon_sym_return] = ACTIONS(4087),
    [anon_sym_break] = ACTIONS(4087),
    [anon_sym_continue] = ACTIONS(4087),
    [anon_sym_goto] = ACTIONS(4087),
    [anon_sym___try] = ACTIONS(4087),
    [anon_sym___leave] = ACTIONS(4087),
    [anon_sym_not] = ACTIONS(4087),
    [anon_sym_compl] = ACTIONS(4087),
    [anon_sym_DASH_DASH] = ACTIONS(4085),
    [anon_sym_PLUS_PLUS] = ACTIONS(4085),
    [anon_sym_sizeof] = ACTIONS(4087),
    [anon_sym___alignof__] = ACTIONS(4087),
    [anon_sym___alignof] = ACTIONS(4087),
    [anon_sym__alignof] = ACTIONS(4087),
    [anon_sym_alignof] = ACTIONS(4087),
    [anon_sym__Alignof] = ACTIONS(4087),
    [anon_sym_offsetof] = ACTIONS(4087),
    [anon_sym__Generic] = ACTIONS(4087),
    [anon_sym_asm] = ACTIONS(4087),
    [anon_sym___asm__] = ACTIONS(4087),
    [anon_sym___asm] = ACTIONS(4087),
    [anon_sym_DOT] = ACTIONS(4087),
    [sym_number_literal] = ACTIONS(4085),
    [anon_sym_L_SQUOTE] = ACTIONS(4085),
    [anon_sym_u_SQUOTE] = ACTIONS(4085),
    [anon_sym_U_SQUOTE] = ACTIONS(4085),
    [anon_sym_u8_SQUOTE] = ACTIONS(4085),
    [anon_sym_SQUOTE] = ACTIONS(4085),
    [anon_sym_L_DQUOTE] = ACTIONS(4085),
    [anon_sym_u_DQUOTE] = ACTIONS(4085),
    [anon_sym_U_DQUOTE] = ACTIONS(4085),
    [anon_sym_u8_DQUOTE] = ACTIONS(4085),
    [anon_sym_DQUOTE] = ACTIONS(4085),
    [sym_true] = ACTIONS(4087),
    [sym_false] = ACTIONS(4087),
    [anon_sym_NULL] = ACTIONS(4087),
    [anon_sym_nullptr] = ACTIONS(4087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4087),
    [anon_sym_let] = ACTIONS(4087),
    [anon_sym_This] = ACTIONS(4087),
    [anon_sym_decltype] = ACTIONS(4087),
    [anon_sym_explicit] = ACTIONS(4087),
    [anon_sym_typename] = ACTIONS(4087),
    [anon_sym_template] = ACTIONS(4087),
    [anon_sym_operator] = ACTIONS(4087),
    [anon_sym_try] = ACTIONS(4087),
    [anon_sym_delete] = ACTIONS(4087),
    [anon_sym_throw] = ACTIONS(4087),
    [anon_sym_namespace] = ACTIONS(4087),
    [anon_sym_static_assert] = ACTIONS(4087),
    [anon_sym_concept] = ACTIONS(4087),
    [anon_sym_co_return] = ACTIONS(4087),
    [anon_sym_co_yield] = ACTIONS(4087),
    [anon_sym_R_DQUOTE] = ACTIONS(4085),
    [anon_sym_LR_DQUOTE] = ACTIONS(4085),
    [anon_sym_uR_DQUOTE] = ACTIONS(4085),
    [anon_sym_UR_DQUOTE] = ACTIONS(4085),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4085),
    [anon_sym_co_await] = ACTIONS(4087),
    [anon_sym_new] = ACTIONS(4087),
    [anon_sym_requires] = ACTIONS(4087),
    [sym_this] = ACTIONS(4087),
    [anon_sym_discard] = ACTIONS(4087),
    [anon_sym_precise] = ACTIONS(4087),
    [anon_sym_shared] = ACTIONS(4087),
    [anon_sym_groupshared] = ACTIONS(4087),
    [anon_sym_uniform] = ACTIONS(4087),
    [anon_sym_row_major] = ACTIONS(4087),
    [anon_sym_column_major] = ACTIONS(4087),
    [anon_sym_globallycoherent] = ACTIONS(4087),
    [anon_sym_centroid] = ACTIONS(4087),
    [anon_sym_noperspective] = ACTIONS(4087),
    [anon_sym_nointerpolation] = ACTIONS(4087),
    [anon_sym_sample] = ACTIONS(4087),
    [anon_sym_linear] = ACTIONS(4087),
    [anon_sym_snorm] = ACTIONS(4087),
    [anon_sym_unorm] = ACTIONS(4087),
    [anon_sym_point] = ACTIONS(4087),
    [anon_sym_line] = ACTIONS(4087),
    [anon_sym_triangleadj] = ACTIONS(4087),
    [anon_sym_lineadj] = ACTIONS(4087),
    [anon_sym_triangle] = ACTIONS(4087),
    [anon_sym_cbuffer] = ACTIONS(4087),
    [anon_sym_interface] = ACTIONS(4087),
    [anon_sym_extension] = ACTIONS(4087),
  },
  [691] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(672),
    [sym_identifier] = ACTIONS(4064),
    [aux_sym_preproc_include_token1] = ACTIONS(4064),
    [aux_sym_preproc_def_token1] = ACTIONS(4064),
    [aux_sym_preproc_if_token1] = ACTIONS(4064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4064),
    [sym_preproc_directive] = ACTIONS(4064),
    [anon_sym_LPAREN2] = ACTIONS(4062),
    [anon_sym_BANG] = ACTIONS(4062),
    [anon_sym_TILDE] = ACTIONS(4062),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_STAR] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4062),
    [anon_sym___extension__] = ACTIONS(4064),
    [anon_sym_typedef] = ACTIONS(4064),
    [anon_sym_in] = ACTIONS(4064),
    [anon_sym_out] = ACTIONS(4064),
    [anon_sym_inout] = ACTIONS(4064),
    [anon_sym_virtual] = ACTIONS(4064),
    [anon_sym_extern] = ACTIONS(4064),
    [anon_sym___attribute__] = ACTIONS(4064),
    [anon_sym___attribute] = ACTIONS(4064),
    [anon_sym_using] = ACTIONS(4064),
    [anon_sym_COLON_COLON] = ACTIONS(4062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4062),
    [anon_sym___declspec] = ACTIONS(4064),
    [anon_sym___based] = ACTIONS(4064),
    [anon_sym___cdecl] = ACTIONS(4064),
    [anon_sym___clrcall] = ACTIONS(4064),
    [anon_sym___stdcall] = ACTIONS(4064),
    [anon_sym___fastcall] = ACTIONS(4064),
    [anon_sym___thiscall] = ACTIONS(4064),
    [anon_sym___vectorcall] = ACTIONS(4064),
    [anon_sym_LBRACE] = ACTIONS(4062),
    [anon_sym_RBRACE] = ACTIONS(4062),
    [anon_sym_signed] = ACTIONS(4192),
    [anon_sym_unsigned] = ACTIONS(4192),
    [anon_sym_long] = ACTIONS(4192),
    [anon_sym_short] = ACTIONS(4192),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_static] = ACTIONS(4064),
    [anon_sym_register] = ACTIONS(4064),
    [anon_sym_inline] = ACTIONS(4064),
    [anon_sym___inline] = ACTIONS(4064),
    [anon_sym___inline__] = ACTIONS(4064),
    [anon_sym___forceinline] = ACTIONS(4064),
    [anon_sym_thread_local] = ACTIONS(4064),
    [anon_sym___thread] = ACTIONS(4064),
    [anon_sym_const] = ACTIONS(4064),
    [anon_sym_constexpr] = ACTIONS(4064),
    [anon_sym_volatile] = ACTIONS(4064),
    [anon_sym_restrict] = ACTIONS(4064),
    [anon_sym___restrict__] = ACTIONS(4064),
    [anon_sym__Atomic] = ACTIONS(4064),
    [anon_sym__Noreturn] = ACTIONS(4064),
    [anon_sym_noreturn] = ACTIONS(4064),
    [anon_sym__Nonnull] = ACTIONS(4064),
    [anon_sym_mutable] = ACTIONS(4064),
    [anon_sym_constinit] = ACTIONS(4064),
    [anon_sym_consteval] = ACTIONS(4064),
    [anon_sym_alignas] = ACTIONS(4064),
    [anon_sym__Alignas] = ACTIONS(4064),
    [sym_primitive_type] = ACTIONS(4064),
    [anon_sym_enum] = ACTIONS(4064),
    [anon_sym_class] = ACTIONS(4064),
    [anon_sym_struct] = ACTIONS(4064),
    [anon_sym_union] = ACTIONS(4064),
    [anon_sym_if] = ACTIONS(4064),
    [anon_sym_switch] = ACTIONS(4064),
    [anon_sym_case] = ACTIONS(4064),
    [anon_sym_default] = ACTIONS(4064),
    [anon_sym_while] = ACTIONS(4064),
    [anon_sym_do] = ACTIONS(4064),
    [anon_sym_for] = ACTIONS(4064),
    [anon_sym_return] = ACTIONS(4064),
    [anon_sym_break] = ACTIONS(4064),
    [anon_sym_continue] = ACTIONS(4064),
    [anon_sym_goto] = ACTIONS(4064),
    [anon_sym___try] = ACTIONS(4064),
    [anon_sym___leave] = ACTIONS(4064),
    [anon_sym_not] = ACTIONS(4064),
    [anon_sym_compl] = ACTIONS(4064),
    [anon_sym_DASH_DASH] = ACTIONS(4062),
    [anon_sym_PLUS_PLUS] = ACTIONS(4062),
    [anon_sym_sizeof] = ACTIONS(4064),
    [anon_sym___alignof__] = ACTIONS(4064),
    [anon_sym___alignof] = ACTIONS(4064),
    [anon_sym__alignof] = ACTIONS(4064),
    [anon_sym_alignof] = ACTIONS(4064),
    [anon_sym__Alignof] = ACTIONS(4064),
    [anon_sym_offsetof] = ACTIONS(4064),
    [anon_sym__Generic] = ACTIONS(4064),
    [anon_sym_asm] = ACTIONS(4064),
    [anon_sym___asm__] = ACTIONS(4064),
    [anon_sym___asm] = ACTIONS(4064),
    [anon_sym_DOT] = ACTIONS(4064),
    [sym_number_literal] = ACTIONS(4062),
    [anon_sym_L_SQUOTE] = ACTIONS(4062),
    [anon_sym_u_SQUOTE] = ACTIONS(4062),
    [anon_sym_U_SQUOTE] = ACTIONS(4062),
    [anon_sym_u8_SQUOTE] = ACTIONS(4062),
    [anon_sym_SQUOTE] = ACTIONS(4062),
    [anon_sym_L_DQUOTE] = ACTIONS(4062),
    [anon_sym_u_DQUOTE] = ACTIONS(4062),
    [anon_sym_U_DQUOTE] = ACTIONS(4062),
    [anon_sym_u8_DQUOTE] = ACTIONS(4062),
    [anon_sym_DQUOTE] = ACTIONS(4062),
    [sym_true] = ACTIONS(4064),
    [sym_false] = ACTIONS(4064),
    [anon_sym_NULL] = ACTIONS(4064),
    [anon_sym_nullptr] = ACTIONS(4064),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4064),
    [anon_sym_let] = ACTIONS(4064),
    [anon_sym_This] = ACTIONS(4064),
    [anon_sym_decltype] = ACTIONS(4064),
    [anon_sym_explicit] = ACTIONS(4064),
    [anon_sym_typename] = ACTIONS(4064),
    [anon_sym_template] = ACTIONS(4064),
    [anon_sym_operator] = ACTIONS(4064),
    [anon_sym_try] = ACTIONS(4064),
    [anon_sym_delete] = ACTIONS(4064),
    [anon_sym_throw] = ACTIONS(4064),
    [anon_sym_namespace] = ACTIONS(4064),
    [anon_sym_static_assert] = ACTIONS(4064),
    [anon_sym_concept] = ACTIONS(4064),
    [anon_sym_co_return] = ACTIONS(4064),
    [anon_sym_co_yield] = ACTIONS(4064),
    [anon_sym_R_DQUOTE] = ACTIONS(4062),
    [anon_sym_LR_DQUOTE] = ACTIONS(4062),
    [anon_sym_uR_DQUOTE] = ACTIONS(4062),
    [anon_sym_UR_DQUOTE] = ACTIONS(4062),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4062),
    [anon_sym_co_await] = ACTIONS(4064),
    [anon_sym_new] = ACTIONS(4064),
    [anon_sym_requires] = ACTIONS(4064),
    [sym_this] = ACTIONS(4064),
    [anon_sym_discard] = ACTIONS(4064),
    [anon_sym_precise] = ACTIONS(4064),
    [anon_sym_shared] = ACTIONS(4064),
    [anon_sym_groupshared] = ACTIONS(4064),
    [anon_sym_uniform] = ACTIONS(4064),
    [anon_sym_row_major] = ACTIONS(4064),
    [anon_sym_column_major] = ACTIONS(4064),
    [anon_sym_globallycoherent] = ACTIONS(4064),
    [anon_sym_centroid] = ACTIONS(4064),
    [anon_sym_noperspective] = ACTIONS(4064),
    [anon_sym_nointerpolation] = ACTIONS(4064),
    [anon_sym_sample] = ACTIONS(4064),
    [anon_sym_linear] = ACTIONS(4064),
    [anon_sym_snorm] = ACTIONS(4064),
    [anon_sym_unorm] = ACTIONS(4064),
    [anon_sym_point] = ACTIONS(4064),
    [anon_sym_line] = ACTIONS(4064),
    [anon_sym_triangleadj] = ACTIONS(4064),
    [anon_sym_lineadj] = ACTIONS(4064),
    [anon_sym_triangle] = ACTIONS(4064),
    [anon_sym_cbuffer] = ACTIONS(4064),
    [anon_sym_interface] = ACTIONS(4064),
    [anon_sym_extension] = ACTIONS(4064),
  },
  [692] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(672),
    [sym_identifier] = ACTIONS(4073),
    [aux_sym_preproc_include_token1] = ACTIONS(4073),
    [aux_sym_preproc_def_token1] = ACTIONS(4073),
    [aux_sym_preproc_if_token1] = ACTIONS(4073),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4073),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4073),
    [sym_preproc_directive] = ACTIONS(4073),
    [anon_sym_LPAREN2] = ACTIONS(4071),
    [anon_sym_BANG] = ACTIONS(4071),
    [anon_sym_TILDE] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(4073),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym___extension__] = ACTIONS(4073),
    [anon_sym_typedef] = ACTIONS(4073),
    [anon_sym_in] = ACTIONS(4073),
    [anon_sym_out] = ACTIONS(4073),
    [anon_sym_inout] = ACTIONS(4073),
    [anon_sym_virtual] = ACTIONS(4073),
    [anon_sym_extern] = ACTIONS(4073),
    [anon_sym___attribute__] = ACTIONS(4073),
    [anon_sym___attribute] = ACTIONS(4073),
    [anon_sym_using] = ACTIONS(4073),
    [anon_sym_COLON_COLON] = ACTIONS(4071),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4071),
    [anon_sym___declspec] = ACTIONS(4073),
    [anon_sym___based] = ACTIONS(4073),
    [anon_sym___cdecl] = ACTIONS(4073),
    [anon_sym___clrcall] = ACTIONS(4073),
    [anon_sym___stdcall] = ACTIONS(4073),
    [anon_sym___fastcall] = ACTIONS(4073),
    [anon_sym___thiscall] = ACTIONS(4073),
    [anon_sym___vectorcall] = ACTIONS(4073),
    [anon_sym_LBRACE] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(4071),
    [anon_sym_signed] = ACTIONS(4195),
    [anon_sym_unsigned] = ACTIONS(4195),
    [anon_sym_long] = ACTIONS(4195),
    [anon_sym_short] = ACTIONS(4195),
    [anon_sym_LBRACK] = ACTIONS(4073),
    [anon_sym_static] = ACTIONS(4073),
    [anon_sym_register] = ACTIONS(4073),
    [anon_sym_inline] = ACTIONS(4073),
    [anon_sym___inline] = ACTIONS(4073),
    [anon_sym___inline__] = ACTIONS(4073),
    [anon_sym___forceinline] = ACTIONS(4073),
    [anon_sym_thread_local] = ACTIONS(4073),
    [anon_sym___thread] = ACTIONS(4073),
    [anon_sym_const] = ACTIONS(4073),
    [anon_sym_constexpr] = ACTIONS(4073),
    [anon_sym_volatile] = ACTIONS(4073),
    [anon_sym_restrict] = ACTIONS(4073),
    [anon_sym___restrict__] = ACTIONS(4073),
    [anon_sym__Atomic] = ACTIONS(4073),
    [anon_sym__Noreturn] = ACTIONS(4073),
    [anon_sym_noreturn] = ACTIONS(4073),
    [anon_sym__Nonnull] = ACTIONS(4073),
    [anon_sym_mutable] = ACTIONS(4073),
    [anon_sym_constinit] = ACTIONS(4073),
    [anon_sym_consteval] = ACTIONS(4073),
    [anon_sym_alignas] = ACTIONS(4073),
    [anon_sym__Alignas] = ACTIONS(4073),
    [sym_primitive_type] = ACTIONS(4073),
    [anon_sym_enum] = ACTIONS(4073),
    [anon_sym_class] = ACTIONS(4073),
    [anon_sym_struct] = ACTIONS(4073),
    [anon_sym_union] = ACTIONS(4073),
    [anon_sym_if] = ACTIONS(4073),
    [anon_sym_switch] = ACTIONS(4073),
    [anon_sym_case] = ACTIONS(4073),
    [anon_sym_default] = ACTIONS(4073),
    [anon_sym_while] = ACTIONS(4073),
    [anon_sym_do] = ACTIONS(4073),
    [anon_sym_for] = ACTIONS(4073),
    [anon_sym_return] = ACTIONS(4073),
    [anon_sym_break] = ACTIONS(4073),
    [anon_sym_continue] = ACTIONS(4073),
    [anon_sym_goto] = ACTIONS(4073),
    [anon_sym___try] = ACTIONS(4073),
    [anon_sym___leave] = ACTIONS(4073),
    [anon_sym_not] = ACTIONS(4073),
    [anon_sym_compl] = ACTIONS(4073),
    [anon_sym_DASH_DASH] = ACTIONS(4071),
    [anon_sym_PLUS_PLUS] = ACTIONS(4071),
    [anon_sym_sizeof] = ACTIONS(4073),
    [anon_sym___alignof__] = ACTIONS(4073),
    [anon_sym___alignof] = ACTIONS(4073),
    [anon_sym__alignof] = ACTIONS(4073),
    [anon_sym_alignof] = ACTIONS(4073),
    [anon_sym__Alignof] = ACTIONS(4073),
    [anon_sym_offsetof] = ACTIONS(4073),
    [anon_sym__Generic] = ACTIONS(4073),
    [anon_sym_asm] = ACTIONS(4073),
    [anon_sym___asm__] = ACTIONS(4073),
    [anon_sym___asm] = ACTIONS(4073),
    [anon_sym_DOT] = ACTIONS(4073),
    [sym_number_literal] = ACTIONS(4071),
    [anon_sym_L_SQUOTE] = ACTIONS(4071),
    [anon_sym_u_SQUOTE] = ACTIONS(4071),
    [anon_sym_U_SQUOTE] = ACTIONS(4071),
    [anon_sym_u8_SQUOTE] = ACTIONS(4071),
    [anon_sym_SQUOTE] = ACTIONS(4071),
    [anon_sym_L_DQUOTE] = ACTIONS(4071),
    [anon_sym_u_DQUOTE] = ACTIONS(4071),
    [anon_sym_U_DQUOTE] = ACTIONS(4071),
    [anon_sym_u8_DQUOTE] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(4071),
    [sym_true] = ACTIONS(4073),
    [sym_false] = ACTIONS(4073),
    [anon_sym_NULL] = ACTIONS(4073),
    [anon_sym_nullptr] = ACTIONS(4073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4073),
    [anon_sym_let] = ACTIONS(4073),
    [anon_sym_This] = ACTIONS(4073),
    [anon_sym_decltype] = ACTIONS(4073),
    [anon_sym_explicit] = ACTIONS(4073),
    [anon_sym_typename] = ACTIONS(4073),
    [anon_sym_template] = ACTIONS(4073),
    [anon_sym_operator] = ACTIONS(4073),
    [anon_sym_try] = ACTIONS(4073),
    [anon_sym_delete] = ACTIONS(4073),
    [anon_sym_throw] = ACTIONS(4073),
    [anon_sym_namespace] = ACTIONS(4073),
    [anon_sym_static_assert] = ACTIONS(4073),
    [anon_sym_concept] = ACTIONS(4073),
    [anon_sym_co_return] = ACTIONS(4073),
    [anon_sym_co_yield] = ACTIONS(4073),
    [anon_sym_R_DQUOTE] = ACTIONS(4071),
    [anon_sym_LR_DQUOTE] = ACTIONS(4071),
    [anon_sym_uR_DQUOTE] = ACTIONS(4071),
    [anon_sym_UR_DQUOTE] = ACTIONS(4071),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4071),
    [anon_sym_co_await] = ACTIONS(4073),
    [anon_sym_new] = ACTIONS(4073),
    [anon_sym_requires] = ACTIONS(4073),
    [sym_this] = ACTIONS(4073),
    [anon_sym_discard] = ACTIONS(4073),
    [anon_sym_precise] = ACTIONS(4073),
    [anon_sym_shared] = ACTIONS(4073),
    [anon_sym_groupshared] = ACTIONS(4073),
    [anon_sym_uniform] = ACTIONS(4073),
    [anon_sym_row_major] = ACTIONS(4073),
    [anon_sym_column_major] = ACTIONS(4073),
    [anon_sym_globallycoherent] = ACTIONS(4073),
    [anon_sym_centroid] = ACTIONS(4073),
    [anon_sym_noperspective] = ACTIONS(4073),
    [anon_sym_nointerpolation] = ACTIONS(4073),
    [anon_sym_sample] = ACTIONS(4073),
    [anon_sym_linear] = ACTIONS(4073),
    [anon_sym_snorm] = ACTIONS(4073),
    [anon_sym_unorm] = ACTIONS(4073),
    [anon_sym_point] = ACTIONS(4073),
    [anon_sym_line] = ACTIONS(4073),
    [anon_sym_triangleadj] = ACTIONS(4073),
    [anon_sym_lineadj] = ACTIONS(4073),
    [anon_sym_triangle] = ACTIONS(4073),
    [anon_sym_cbuffer] = ACTIONS(4073),
    [anon_sym_interface] = ACTIONS(4073),
    [anon_sym_extension] = ACTIONS(4073),
  },
  [693] = {
    [sym_attribute_specifier] = STATE(798),
    [sym_identifier] = ACTIONS(4176),
    [aux_sym_preproc_include_token1] = ACTIONS(4176),
    [aux_sym_preproc_def_token1] = ACTIONS(4176),
    [aux_sym_preproc_if_token1] = ACTIONS(4176),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4176),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4176),
    [sym_preproc_directive] = ACTIONS(4176),
    [anon_sym_LPAREN2] = ACTIONS(4174),
    [anon_sym_BANG] = ACTIONS(4174),
    [anon_sym_TILDE] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4176),
    [anon_sym_PLUS] = ACTIONS(4176),
    [anon_sym_STAR] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4176),
    [anon_sym_SEMI] = ACTIONS(4174),
    [anon_sym___extension__] = ACTIONS(4176),
    [anon_sym_typedef] = ACTIONS(4176),
    [anon_sym_in] = ACTIONS(4176),
    [anon_sym_out] = ACTIONS(4176),
    [anon_sym_inout] = ACTIONS(4176),
    [anon_sym_virtual] = ACTIONS(4176),
    [anon_sym_extern] = ACTIONS(4176),
    [anon_sym___attribute__] = ACTIONS(2897),
    [anon_sym___attribute] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(4176),
    [anon_sym_COLON_COLON] = ACTIONS(4174),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4174),
    [anon_sym___declspec] = ACTIONS(4176),
    [anon_sym___based] = ACTIONS(4176),
    [anon_sym___cdecl] = ACTIONS(4176),
    [anon_sym___clrcall] = ACTIONS(4176),
    [anon_sym___stdcall] = ACTIONS(4176),
    [anon_sym___fastcall] = ACTIONS(4176),
    [anon_sym___thiscall] = ACTIONS(4176),
    [anon_sym___vectorcall] = ACTIONS(4176),
    [anon_sym_LBRACE] = ACTIONS(4174),
    [anon_sym_RBRACE] = ACTIONS(4174),
    [anon_sym_signed] = ACTIONS(4176),
    [anon_sym_unsigned] = ACTIONS(4176),
    [anon_sym_long] = ACTIONS(4176),
    [anon_sym_short] = ACTIONS(4176),
    [anon_sym_LBRACK] = ACTIONS(4176),
    [anon_sym_static] = ACTIONS(4176),
    [anon_sym_register] = ACTIONS(4176),
    [anon_sym_inline] = ACTIONS(4176),
    [anon_sym___inline] = ACTIONS(4176),
    [anon_sym___inline__] = ACTIONS(4176),
    [anon_sym___forceinline] = ACTIONS(4176),
    [anon_sym_thread_local] = ACTIONS(4176),
    [anon_sym___thread] = ACTIONS(4176),
    [anon_sym_const] = ACTIONS(4176),
    [anon_sym_constexpr] = ACTIONS(4176),
    [anon_sym_volatile] = ACTIONS(4176),
    [anon_sym_restrict] = ACTIONS(4176),
    [anon_sym___restrict__] = ACTIONS(4176),
    [anon_sym__Atomic] = ACTIONS(4176),
    [anon_sym__Noreturn] = ACTIONS(4176),
    [anon_sym_noreturn] = ACTIONS(4176),
    [anon_sym__Nonnull] = ACTIONS(4176),
    [anon_sym_mutable] = ACTIONS(4176),
    [anon_sym_constinit] = ACTIONS(4176),
    [anon_sym_consteval] = ACTIONS(4176),
    [anon_sym_alignas] = ACTIONS(4176),
    [anon_sym__Alignas] = ACTIONS(4176),
    [sym_primitive_type] = ACTIONS(4176),
    [anon_sym_enum] = ACTIONS(4176),
    [anon_sym_class] = ACTIONS(4176),
    [anon_sym_struct] = ACTIONS(4176),
    [anon_sym_union] = ACTIONS(4176),
    [anon_sym_if] = ACTIONS(4176),
    [anon_sym_switch] = ACTIONS(4176),
    [anon_sym_case] = ACTIONS(4176),
    [anon_sym_default] = ACTIONS(4176),
    [anon_sym_while] = ACTIONS(4176),
    [anon_sym_do] = ACTIONS(4176),
    [anon_sym_for] = ACTIONS(4176),
    [anon_sym_return] = ACTIONS(4176),
    [anon_sym_break] = ACTIONS(4176),
    [anon_sym_continue] = ACTIONS(4176),
    [anon_sym_goto] = ACTIONS(4176),
    [anon_sym___try] = ACTIONS(4176),
    [anon_sym___leave] = ACTIONS(4176),
    [anon_sym_not] = ACTIONS(4176),
    [anon_sym_compl] = ACTIONS(4176),
    [anon_sym_DASH_DASH] = ACTIONS(4174),
    [anon_sym_PLUS_PLUS] = ACTIONS(4174),
    [anon_sym_sizeof] = ACTIONS(4176),
    [anon_sym___alignof__] = ACTIONS(4176),
    [anon_sym___alignof] = ACTIONS(4176),
    [anon_sym__alignof] = ACTIONS(4176),
    [anon_sym_alignof] = ACTIONS(4176),
    [anon_sym__Alignof] = ACTIONS(4176),
    [anon_sym_offsetof] = ACTIONS(4176),
    [anon_sym__Generic] = ACTIONS(4176),
    [anon_sym_asm] = ACTIONS(4176),
    [anon_sym___asm__] = ACTIONS(4176),
    [anon_sym___asm] = ACTIONS(4176),
    [anon_sym_DOT] = ACTIONS(4176),
    [sym_number_literal] = ACTIONS(4174),
    [anon_sym_L_SQUOTE] = ACTIONS(4174),
    [anon_sym_u_SQUOTE] = ACTIONS(4174),
    [anon_sym_U_SQUOTE] = ACTIONS(4174),
    [anon_sym_u8_SQUOTE] = ACTIONS(4174),
    [anon_sym_SQUOTE] = ACTIONS(4174),
    [anon_sym_L_DQUOTE] = ACTIONS(4174),
    [anon_sym_u_DQUOTE] = ACTIONS(4174),
    [anon_sym_U_DQUOTE] = ACTIONS(4174),
    [anon_sym_u8_DQUOTE] = ACTIONS(4174),
    [anon_sym_DQUOTE] = ACTIONS(4174),
    [sym_true] = ACTIONS(4176),
    [sym_false] = ACTIONS(4176),
    [anon_sym_NULL] = ACTIONS(4176),
    [anon_sym_nullptr] = ACTIONS(4176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4176),
    [anon_sym_let] = ACTIONS(4176),
    [anon_sym_This] = ACTIONS(4176),
    [anon_sym_decltype] = ACTIONS(4176),
    [anon_sym_explicit] = ACTIONS(4176),
    [anon_sym_typename] = ACTIONS(4176),
    [anon_sym_template] = ACTIONS(4176),
    [anon_sym_operator] = ACTIONS(4176),
    [anon_sym_try] = ACTIONS(4176),
    [anon_sym_delete] = ACTIONS(4176),
    [anon_sym_throw] = ACTIONS(4176),
    [anon_sym_namespace] = ACTIONS(4176),
    [anon_sym_static_assert] = ACTIONS(4176),
    [anon_sym_concept] = ACTIONS(4176),
    [anon_sym_co_return] = ACTIONS(4176),
    [anon_sym_co_yield] = ACTIONS(4176),
    [anon_sym_R_DQUOTE] = ACTIONS(4174),
    [anon_sym_LR_DQUOTE] = ACTIONS(4174),
    [anon_sym_uR_DQUOTE] = ACTIONS(4174),
    [anon_sym_UR_DQUOTE] = ACTIONS(4174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4174),
    [anon_sym_co_await] = ACTIONS(4176),
    [anon_sym_new] = ACTIONS(4176),
    [anon_sym_requires] = ACTIONS(4176),
    [sym_this] = ACTIONS(4176),
    [anon_sym_discard] = ACTIONS(4176),
    [anon_sym_precise] = ACTIONS(4176),
    [anon_sym_shared] = ACTIONS(4176),
    [anon_sym_groupshared] = ACTIONS(4176),
    [anon_sym_uniform] = ACTIONS(4176),
    [anon_sym_row_major] = ACTIONS(4176),
    [anon_sym_column_major] = ACTIONS(4176),
    [anon_sym_globallycoherent] = ACTIONS(4176),
    [anon_sym_centroid] = ACTIONS(4176),
    [anon_sym_noperspective] = ACTIONS(4176),
    [anon_sym_nointerpolation] = ACTIONS(4176),
    [anon_sym_sample] = ACTIONS(4176),
    [anon_sym_linear] = ACTIONS(4176),
    [anon_sym_snorm] = ACTIONS(4176),
    [anon_sym_unorm] = ACTIONS(4176),
    [anon_sym_point] = ACTIONS(4176),
    [anon_sym_line] = ACTIONS(4176),
    [anon_sym_triangleadj] = ACTIONS(4176),
    [anon_sym_lineadj] = ACTIONS(4176),
    [anon_sym_triangle] = ACTIONS(4176),
    [anon_sym_cbuffer] = ACTIONS(4176),
    [anon_sym_interface] = ACTIONS(4176),
    [anon_sym_extension] = ACTIONS(4176),
  },
  [694] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(679),
    [ts_builtin_sym_end] = ACTIONS(2972),
    [sym_identifier] = ACTIONS(2974),
    [aux_sym_preproc_include_token1] = ACTIONS(2974),
    [aux_sym_preproc_def_token1] = ACTIONS(2974),
    [aux_sym_preproc_if_token1] = ACTIONS(2974),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2974),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2974),
    [sym_preproc_directive] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_BANG] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym___extension__] = ACTIONS(2974),
    [anon_sym_typedef] = ACTIONS(2974),
    [anon_sym_in] = ACTIONS(2974),
    [anon_sym_out] = ACTIONS(2974),
    [anon_sym_inout] = ACTIONS(2974),
    [anon_sym_virtual] = ACTIONS(2974),
    [anon_sym_extern] = ACTIONS(2974),
    [anon_sym___attribute__] = ACTIONS(2974),
    [anon_sym___attribute] = ACTIONS(2974),
    [anon_sym_using] = ACTIONS(2974),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2974),
    [anon_sym___based] = ACTIONS(2974),
    [anon_sym___cdecl] = ACTIONS(2974),
    [anon_sym___clrcall] = ACTIONS(2974),
    [anon_sym___stdcall] = ACTIONS(2974),
    [anon_sym___fastcall] = ACTIONS(2974),
    [anon_sym___thiscall] = ACTIONS(2974),
    [anon_sym___vectorcall] = ACTIONS(2974),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_signed] = ACTIONS(2974),
    [anon_sym_unsigned] = ACTIONS(2974),
    [anon_sym_long] = ACTIONS(2974),
    [anon_sym_short] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [anon_sym_static] = ACTIONS(2974),
    [anon_sym_register] = ACTIONS(2974),
    [anon_sym_inline] = ACTIONS(2974),
    [anon_sym___inline] = ACTIONS(2974),
    [anon_sym___inline__] = ACTIONS(2974),
    [anon_sym___forceinline] = ACTIONS(2974),
    [anon_sym_thread_local] = ACTIONS(2974),
    [anon_sym___thread] = ACTIONS(2974),
    [anon_sym_const] = ACTIONS(2974),
    [anon_sym_constexpr] = ACTIONS(2974),
    [anon_sym_volatile] = ACTIONS(2974),
    [anon_sym_restrict] = ACTIONS(2974),
    [anon_sym___restrict__] = ACTIONS(2974),
    [anon_sym__Atomic] = ACTIONS(2974),
    [anon_sym__Noreturn] = ACTIONS(2974),
    [anon_sym_noreturn] = ACTIONS(2974),
    [anon_sym__Nonnull] = ACTIONS(2974),
    [anon_sym_mutable] = ACTIONS(2974),
    [anon_sym_constinit] = ACTIONS(2974),
    [anon_sym_consteval] = ACTIONS(2974),
    [anon_sym_alignas] = ACTIONS(2974),
    [anon_sym__Alignas] = ACTIONS(2974),
    [sym_primitive_type] = ACTIONS(2974),
    [anon_sym_enum] = ACTIONS(2974),
    [anon_sym_class] = ACTIONS(2974),
    [anon_sym_struct] = ACTIONS(2974),
    [anon_sym_union] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2974),
    [anon_sym_switch] = ACTIONS(2974),
    [anon_sym_case] = ACTIONS(2974),
    [anon_sym_default] = ACTIONS(2974),
    [anon_sym_while] = ACTIONS(2974),
    [anon_sym_do] = ACTIONS(2974),
    [anon_sym_for] = ACTIONS(2974),
    [anon_sym_return] = ACTIONS(2974),
    [anon_sym_break] = ACTIONS(2974),
    [anon_sym_continue] = ACTIONS(2974),
    [anon_sym_goto] = ACTIONS(2974),
    [anon_sym_not] = ACTIONS(2974),
    [anon_sym_compl] = ACTIONS(2974),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_sizeof] = ACTIONS(2974),
    [anon_sym___alignof__] = ACTIONS(2974),
    [anon_sym___alignof] = ACTIONS(2974),
    [anon_sym__alignof] = ACTIONS(2974),
    [anon_sym_alignof] = ACTIONS(2974),
    [anon_sym__Alignof] = ACTIONS(2974),
    [anon_sym_offsetof] = ACTIONS(2974),
    [anon_sym__Generic] = ACTIONS(2974),
    [anon_sym_asm] = ACTIONS(2974),
    [anon_sym___asm__] = ACTIONS(2974),
    [anon_sym___asm] = ACTIONS(2974),
    [anon_sym_DOT] = ACTIONS(2974),
    [sym_number_literal] = ACTIONS(2972),
    [anon_sym_L_SQUOTE] = ACTIONS(2972),
    [anon_sym_u_SQUOTE] = ACTIONS(2972),
    [anon_sym_U_SQUOTE] = ACTIONS(2972),
    [anon_sym_u8_SQUOTE] = ACTIONS(2972),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [anon_sym_L_DQUOTE] = ACTIONS(2972),
    [anon_sym_u_DQUOTE] = ACTIONS(2972),
    [anon_sym_U_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE] = ACTIONS(2972),
    [sym_true] = ACTIONS(2974),
    [sym_false] = ACTIONS(2974),
    [anon_sym_NULL] = ACTIONS(2974),
    [anon_sym_nullptr] = ACTIONS(2974),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_This] = ACTIONS(2974),
    [anon_sym_decltype] = ACTIONS(2974),
    [anon_sym_explicit] = ACTIONS(2974),
    [anon_sym_typename] = ACTIONS(2974),
    [anon_sym_export] = ACTIONS(2974),
    [anon_sym_module] = ACTIONS(2974),
    [anon_sym_import] = ACTIONS(2974),
    [anon_sym_template] = ACTIONS(2974),
    [anon_sym_operator] = ACTIONS(2974),
    [anon_sym_try] = ACTIONS(2974),
    [anon_sym_delete] = ACTIONS(2974),
    [anon_sym_throw] = ACTIONS(2974),
    [anon_sym_namespace] = ACTIONS(2974),
    [anon_sym_static_assert] = ACTIONS(2974),
    [anon_sym_concept] = ACTIONS(2974),
    [anon_sym_co_return] = ACTIONS(2974),
    [anon_sym_co_yield] = ACTIONS(2974),
    [anon_sym_R_DQUOTE] = ACTIONS(2972),
    [anon_sym_LR_DQUOTE] = ACTIONS(2972),
    [anon_sym_uR_DQUOTE] = ACTIONS(2972),
    [anon_sym_UR_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2972),
    [anon_sym_co_await] = ACTIONS(2974),
    [anon_sym_new] = ACTIONS(2974),
    [anon_sym_requires] = ACTIONS(2974),
    [sym_this] = ACTIONS(2974),
    [anon_sym_precise] = ACTIONS(2974),
    [anon_sym_shared] = ACTIONS(2974),
    [anon_sym_groupshared] = ACTIONS(2974),
    [anon_sym_uniform] = ACTIONS(2974),
    [anon_sym_row_major] = ACTIONS(2974),
    [anon_sym_column_major] = ACTIONS(2974),
    [anon_sym_globallycoherent] = ACTIONS(2974),
    [anon_sym_centroid] = ACTIONS(2974),
    [anon_sym_noperspective] = ACTIONS(2974),
    [anon_sym_nointerpolation] = ACTIONS(2974),
    [anon_sym_sample] = ACTIONS(2974),
    [anon_sym_linear] = ACTIONS(2974),
    [anon_sym_snorm] = ACTIONS(2974),
    [anon_sym_unorm] = ACTIONS(2974),
    [anon_sym_point] = ACTIONS(2974),
    [anon_sym_line] = ACTIONS(2974),
    [anon_sym_triangleadj] = ACTIONS(2974),
    [anon_sym_lineadj] = ACTIONS(2974),
    [anon_sym_triangle] = ACTIONS(2974),
    [anon_sym_interface] = ACTIONS(2974),
    [anon_sym_extension] = ACTIONS(2974),
    [anon_sym___exported] = ACTIONS(2974),
  },
  [695] = {
    [sym_identifier] = ACTIONS(3148),
    [aux_sym_preproc_include_token1] = ACTIONS(3148),
    [aux_sym_preproc_def_token1] = ACTIONS(3148),
    [aux_sym_preproc_if_token1] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3148),
    [sym_preproc_directive] = ACTIONS(3148),
    [anon_sym_LPAREN2] = ACTIONS(3150),
    [anon_sym_BANG] = ACTIONS(3150),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_DASH] = ACTIONS(3148),
    [anon_sym_PLUS] = ACTIONS(3148),
    [anon_sym_STAR] = ACTIONS(3150),
    [anon_sym_AMP_AMP] = ACTIONS(3150),
    [anon_sym_AMP] = ACTIONS(3148),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym___extension__] = ACTIONS(3148),
    [anon_sym_typedef] = ACTIONS(3148),
    [anon_sym_in] = ACTIONS(3148),
    [anon_sym_out] = ACTIONS(3148),
    [anon_sym_inout] = ACTIONS(3148),
    [anon_sym_virtual] = ACTIONS(3148),
    [anon_sym_extern] = ACTIONS(3148),
    [anon_sym___attribute__] = ACTIONS(3148),
    [anon_sym___attribute] = ACTIONS(3148),
    [anon_sym_using] = ACTIONS(3148),
    [anon_sym_COLON_COLON] = ACTIONS(3150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3150),
    [anon_sym___declspec] = ACTIONS(3148),
    [anon_sym___based] = ACTIONS(3148),
    [anon_sym___cdecl] = ACTIONS(3148),
    [anon_sym___clrcall] = ACTIONS(3148),
    [anon_sym___stdcall] = ACTIONS(3148),
    [anon_sym___fastcall] = ACTIONS(3148),
    [anon_sym___thiscall] = ACTIONS(3148),
    [anon_sym___vectorcall] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3150),
    [anon_sym_RBRACE] = ACTIONS(3150),
    [anon_sym_signed] = ACTIONS(3148),
    [anon_sym_unsigned] = ACTIONS(3148),
    [anon_sym_long] = ACTIONS(3148),
    [anon_sym_short] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_static] = ACTIONS(3148),
    [anon_sym_register] = ACTIONS(3148),
    [anon_sym_inline] = ACTIONS(3148),
    [anon_sym___inline] = ACTIONS(3148),
    [anon_sym___inline__] = ACTIONS(3148),
    [anon_sym___forceinline] = ACTIONS(3148),
    [anon_sym_thread_local] = ACTIONS(3148),
    [anon_sym___thread] = ACTIONS(3148),
    [anon_sym_const] = ACTIONS(3148),
    [anon_sym_constexpr] = ACTIONS(3148),
    [anon_sym_volatile] = ACTIONS(3148),
    [anon_sym_restrict] = ACTIONS(3148),
    [anon_sym___restrict__] = ACTIONS(3148),
    [anon_sym__Atomic] = ACTIONS(3148),
    [anon_sym__Noreturn] = ACTIONS(3148),
    [anon_sym_noreturn] = ACTIONS(3148),
    [anon_sym__Nonnull] = ACTIONS(3148),
    [anon_sym_mutable] = ACTIONS(3148),
    [anon_sym_constinit] = ACTIONS(3148),
    [anon_sym_consteval] = ACTIONS(3148),
    [anon_sym_alignas] = ACTIONS(3148),
    [anon_sym__Alignas] = ACTIONS(3148),
    [sym_primitive_type] = ACTIONS(3148),
    [anon_sym_enum] = ACTIONS(3148),
    [anon_sym_class] = ACTIONS(3148),
    [anon_sym_struct] = ACTIONS(3148),
    [anon_sym_union] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_switch] = ACTIONS(3148),
    [anon_sym_case] = ACTIONS(3148),
    [anon_sym_default] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_for] = ACTIONS(3148),
    [anon_sym_return] = ACTIONS(3148),
    [anon_sym_break] = ACTIONS(3148),
    [anon_sym_continue] = ACTIONS(3148),
    [anon_sym_goto] = ACTIONS(3148),
    [anon_sym___try] = ACTIONS(3148),
    [anon_sym___leave] = ACTIONS(3148),
    [anon_sym_not] = ACTIONS(3148),
    [anon_sym_compl] = ACTIONS(3148),
    [anon_sym_DASH_DASH] = ACTIONS(3150),
    [anon_sym_PLUS_PLUS] = ACTIONS(3150),
    [anon_sym_sizeof] = ACTIONS(3148),
    [anon_sym___alignof__] = ACTIONS(3148),
    [anon_sym___alignof] = ACTIONS(3148),
    [anon_sym__alignof] = ACTIONS(3148),
    [anon_sym_alignof] = ACTIONS(3148),
    [anon_sym__Alignof] = ACTIONS(3148),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3148),
    [anon_sym_asm] = ACTIONS(3148),
    [anon_sym___asm__] = ACTIONS(3148),
    [anon_sym___asm] = ACTIONS(3148),
    [sym_number_literal] = ACTIONS(3150),
    [anon_sym_L_SQUOTE] = ACTIONS(3150),
    [anon_sym_u_SQUOTE] = ACTIONS(3150),
    [anon_sym_U_SQUOTE] = ACTIONS(3150),
    [anon_sym_u8_SQUOTE] = ACTIONS(3150),
    [anon_sym_SQUOTE] = ACTIONS(3150),
    [anon_sym_L_DQUOTE] = ACTIONS(3150),
    [anon_sym_u_DQUOTE] = ACTIONS(3150),
    [anon_sym_U_DQUOTE] = ACTIONS(3150),
    [anon_sym_u8_DQUOTE] = ACTIONS(3150),
    [anon_sym_DQUOTE] = ACTIONS(3150),
    [sym_true] = ACTIONS(3148),
    [sym_false] = ACTIONS(3148),
    [anon_sym_NULL] = ACTIONS(3148),
    [anon_sym_nullptr] = ACTIONS(3148),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3148),
    [anon_sym_let] = ACTIONS(3148),
    [anon_sym_This] = ACTIONS(3148),
    [anon_sym_decltype] = ACTIONS(3148),
    [anon_sym_explicit] = ACTIONS(3148),
    [anon_sym_typename] = ACTIONS(3148),
    [anon_sym_template] = ACTIONS(3148),
    [anon_sym_operator] = ACTIONS(3148),
    [anon_sym_try] = ACTIONS(3148),
    [anon_sym_delete] = ACTIONS(3148),
    [anon_sym_throw] = ACTIONS(3148),
    [anon_sym_namespace] = ACTIONS(3148),
    [anon_sym_static_assert] = ACTIONS(3148),
    [anon_sym_concept] = ACTIONS(3148),
    [anon_sym_co_return] = ACTIONS(3148),
    [anon_sym_co_yield] = ACTIONS(3148),
    [anon_sym_catch] = ACTIONS(3148),
    [anon_sym_R_DQUOTE] = ACTIONS(3150),
    [anon_sym_LR_DQUOTE] = ACTIONS(3150),
    [anon_sym_uR_DQUOTE] = ACTIONS(3150),
    [anon_sym_UR_DQUOTE] = ACTIONS(3150),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3150),
    [anon_sym_co_await] = ACTIONS(3148),
    [anon_sym_new] = ACTIONS(3148),
    [anon_sym_requires] = ACTIONS(3148),
    [sym_this] = ACTIONS(3148),
    [anon_sym_discard] = ACTIONS(3148),
    [anon_sym_precise] = ACTIONS(3148),
    [anon_sym_shared] = ACTIONS(3148),
    [anon_sym_groupshared] = ACTIONS(3148),
    [anon_sym_uniform] = ACTIONS(3148),
    [anon_sym_row_major] = ACTIONS(3148),
    [anon_sym_column_major] = ACTIONS(3148),
    [anon_sym_globallycoherent] = ACTIONS(3148),
    [anon_sym_centroid] = ACTIONS(3148),
    [anon_sym_noperspective] = ACTIONS(3148),
    [anon_sym_nointerpolation] = ACTIONS(3148),
    [anon_sym_sample] = ACTIONS(3148),
    [anon_sym_linear] = ACTIONS(3148),
    [anon_sym_snorm] = ACTIONS(3148),
    [anon_sym_unorm] = ACTIONS(3148),
    [anon_sym_point] = ACTIONS(3148),
    [anon_sym_line] = ACTIONS(3148),
    [anon_sym_triangleadj] = ACTIONS(3148),
    [anon_sym_lineadj] = ACTIONS(3148),
    [anon_sym_triangle] = ACTIONS(3148),
    [anon_sym_cbuffer] = ACTIONS(3148),
    [anon_sym_interface] = ACTIONS(3148),
    [anon_sym_extension] = ACTIONS(3148),
  },
  [696] = {
    [sym_attribute_specifier] = STATE(794),
    [sym_identifier] = ACTIONS(4049),
    [aux_sym_preproc_include_token1] = ACTIONS(4049),
    [aux_sym_preproc_def_token1] = ACTIONS(4049),
    [aux_sym_preproc_if_token1] = ACTIONS(4049),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4049),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4049),
    [sym_preproc_directive] = ACTIONS(4049),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(4047),
    [anon_sym_TILDE] = ACTIONS(4047),
    [anon_sym_DASH] = ACTIONS(4049),
    [anon_sym_PLUS] = ACTIONS(4049),
    [anon_sym_STAR] = ACTIONS(4047),
    [anon_sym_AMP_AMP] = ACTIONS(4047),
    [anon_sym_AMP] = ACTIONS(4049),
    [anon_sym_SEMI] = ACTIONS(4047),
    [anon_sym___extension__] = ACTIONS(4049),
    [anon_sym_typedef] = ACTIONS(4049),
    [anon_sym_in] = ACTIONS(4049),
    [anon_sym_out] = ACTIONS(4049),
    [anon_sym_inout] = ACTIONS(4049),
    [anon_sym_virtual] = ACTIONS(4049),
    [anon_sym_extern] = ACTIONS(4049),
    [anon_sym___attribute__] = ACTIONS(2897),
    [anon_sym___attribute] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(4049),
    [anon_sym_COLON_COLON] = ACTIONS(4047),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4047),
    [anon_sym___declspec] = ACTIONS(4049),
    [anon_sym___based] = ACTIONS(4049),
    [anon_sym___cdecl] = ACTIONS(4049),
    [anon_sym___clrcall] = ACTIONS(4049),
    [anon_sym___stdcall] = ACTIONS(4049),
    [anon_sym___fastcall] = ACTIONS(4049),
    [anon_sym___thiscall] = ACTIONS(4049),
    [anon_sym___vectorcall] = ACTIONS(4049),
    [anon_sym_LBRACE] = ACTIONS(4047),
    [anon_sym_RBRACE] = ACTIONS(4047),
    [anon_sym_signed] = ACTIONS(4049),
    [anon_sym_unsigned] = ACTIONS(4049),
    [anon_sym_long] = ACTIONS(4049),
    [anon_sym_short] = ACTIONS(4049),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(4049),
    [anon_sym_register] = ACTIONS(4049),
    [anon_sym_inline] = ACTIONS(4049),
    [anon_sym___inline] = ACTIONS(4049),
    [anon_sym___inline__] = ACTIONS(4049),
    [anon_sym___forceinline] = ACTIONS(4049),
    [anon_sym_thread_local] = ACTIONS(4049),
    [anon_sym___thread] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(4049),
    [anon_sym_constexpr] = ACTIONS(4049),
    [anon_sym_volatile] = ACTIONS(4049),
    [anon_sym_restrict] = ACTIONS(4049),
    [anon_sym___restrict__] = ACTIONS(4049),
    [anon_sym__Atomic] = ACTIONS(4049),
    [anon_sym__Noreturn] = ACTIONS(4049),
    [anon_sym_noreturn] = ACTIONS(4049),
    [anon_sym__Nonnull] = ACTIONS(4049),
    [anon_sym_mutable] = ACTIONS(4049),
    [anon_sym_constinit] = ACTIONS(4049),
    [anon_sym_consteval] = ACTIONS(4049),
    [anon_sym_alignas] = ACTIONS(4049),
    [anon_sym__Alignas] = ACTIONS(4049),
    [sym_primitive_type] = ACTIONS(4049),
    [anon_sym_enum] = ACTIONS(4049),
    [anon_sym_class] = ACTIONS(4049),
    [anon_sym_struct] = ACTIONS(4049),
    [anon_sym_union] = ACTIONS(4049),
    [anon_sym_if] = ACTIONS(4049),
    [anon_sym_switch] = ACTIONS(4049),
    [anon_sym_case] = ACTIONS(4049),
    [anon_sym_default] = ACTIONS(4049),
    [anon_sym_while] = ACTIONS(4049),
    [anon_sym_do] = ACTIONS(4049),
    [anon_sym_for] = ACTIONS(4049),
    [anon_sym_return] = ACTIONS(4049),
    [anon_sym_break] = ACTIONS(4049),
    [anon_sym_continue] = ACTIONS(4049),
    [anon_sym_goto] = ACTIONS(4049),
    [anon_sym___try] = ACTIONS(4049),
    [anon_sym___leave] = ACTIONS(4049),
    [anon_sym_not] = ACTIONS(4049),
    [anon_sym_compl] = ACTIONS(4049),
    [anon_sym_DASH_DASH] = ACTIONS(4047),
    [anon_sym_PLUS_PLUS] = ACTIONS(4047),
    [anon_sym_sizeof] = ACTIONS(4049),
    [anon_sym___alignof__] = ACTIONS(4049),
    [anon_sym___alignof] = ACTIONS(4049),
    [anon_sym__alignof] = ACTIONS(4049),
    [anon_sym_alignof] = ACTIONS(4049),
    [anon_sym__Alignof] = ACTIONS(4049),
    [anon_sym_offsetof] = ACTIONS(4049),
    [anon_sym__Generic] = ACTIONS(4049),
    [anon_sym_asm] = ACTIONS(4049),
    [anon_sym___asm__] = ACTIONS(4049),
    [anon_sym___asm] = ACTIONS(4049),
    [anon_sym_DOT] = ACTIONS(4049),
    [sym_number_literal] = ACTIONS(4047),
    [anon_sym_L_SQUOTE] = ACTIONS(4047),
    [anon_sym_u_SQUOTE] = ACTIONS(4047),
    [anon_sym_U_SQUOTE] = ACTIONS(4047),
    [anon_sym_u8_SQUOTE] = ACTIONS(4047),
    [anon_sym_SQUOTE] = ACTIONS(4047),
    [anon_sym_L_DQUOTE] = ACTIONS(4047),
    [anon_sym_u_DQUOTE] = ACTIONS(4047),
    [anon_sym_U_DQUOTE] = ACTIONS(4047),
    [anon_sym_u8_DQUOTE] = ACTIONS(4047),
    [anon_sym_DQUOTE] = ACTIONS(4047),
    [sym_true] = ACTIONS(4049),
    [sym_false] = ACTIONS(4049),
    [anon_sym_NULL] = ACTIONS(4049),
    [anon_sym_nullptr] = ACTIONS(4049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4049),
    [anon_sym_let] = ACTIONS(4049),
    [anon_sym_This] = ACTIONS(4049),
    [anon_sym_decltype] = ACTIONS(4049),
    [anon_sym_explicit] = ACTIONS(4049),
    [anon_sym_typename] = ACTIONS(4049),
    [anon_sym_template] = ACTIONS(4049),
    [anon_sym_operator] = ACTIONS(4049),
    [anon_sym_try] = ACTIONS(4049),
    [anon_sym_delete] = ACTIONS(4049),
    [anon_sym_throw] = ACTIONS(4049),
    [anon_sym_namespace] = ACTIONS(4049),
    [anon_sym_static_assert] = ACTIONS(4049),
    [anon_sym_concept] = ACTIONS(4049),
    [anon_sym_co_return] = ACTIONS(4049),
    [anon_sym_co_yield] = ACTIONS(4049),
    [anon_sym_R_DQUOTE] = ACTIONS(4047),
    [anon_sym_LR_DQUOTE] = ACTIONS(4047),
    [anon_sym_uR_DQUOTE] = ACTIONS(4047),
    [anon_sym_UR_DQUOTE] = ACTIONS(4047),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4047),
    [anon_sym_co_await] = ACTIONS(4049),
    [anon_sym_new] = ACTIONS(4049),
    [anon_sym_requires] = ACTIONS(4049),
    [sym_this] = ACTIONS(4049),
    [anon_sym_discard] = ACTIONS(4049),
    [anon_sym_precise] = ACTIONS(4049),
    [anon_sym_shared] = ACTIONS(4049),
    [anon_sym_groupshared] = ACTIONS(4049),
    [anon_sym_uniform] = ACTIONS(4049),
    [anon_sym_row_major] = ACTIONS(4049),
    [anon_sym_column_major] = ACTIONS(4049),
    [anon_sym_globallycoherent] = ACTIONS(4049),
    [anon_sym_centroid] = ACTIONS(4049),
    [anon_sym_noperspective] = ACTIONS(4049),
    [anon_sym_nointerpolation] = ACTIONS(4049),
    [anon_sym_sample] = ACTIONS(4049),
    [anon_sym_linear] = ACTIONS(4049),
    [anon_sym_snorm] = ACTIONS(4049),
    [anon_sym_unorm] = ACTIONS(4049),
    [anon_sym_point] = ACTIONS(4049),
    [anon_sym_line] = ACTIONS(4049),
    [anon_sym_triangleadj] = ACTIONS(4049),
    [anon_sym_lineadj] = ACTIONS(4049),
    [anon_sym_triangle] = ACTIONS(4049),
    [anon_sym_cbuffer] = ACTIONS(4049),
    [anon_sym_interface] = ACTIONS(4049),
    [anon_sym_extension] = ACTIONS(4049),
  },
  [697] = {
    [sym_else_clause] = STATE(822),
    [sym_identifier] = ACTIONS(3096),
    [aux_sym_preproc_include_token1] = ACTIONS(3096),
    [aux_sym_preproc_def_token1] = ACTIONS(3096),
    [aux_sym_preproc_if_token1] = ACTIONS(3096),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3096),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3096),
    [sym_preproc_directive] = ACTIONS(3096),
    [anon_sym_LPAREN2] = ACTIONS(3094),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_TILDE] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3096),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_STAR] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3094),
    [anon_sym_AMP] = ACTIONS(3096),
    [anon_sym_SEMI] = ACTIONS(3094),
    [anon_sym___extension__] = ACTIONS(3096),
    [anon_sym_typedef] = ACTIONS(3096),
    [anon_sym_in] = ACTIONS(3096),
    [anon_sym_out] = ACTIONS(3096),
    [anon_sym_inout] = ACTIONS(3096),
    [anon_sym_virtual] = ACTIONS(3096),
    [anon_sym_extern] = ACTIONS(3096),
    [anon_sym___attribute__] = ACTIONS(3096),
    [anon_sym___attribute] = ACTIONS(3096),
    [anon_sym_using] = ACTIONS(3096),
    [anon_sym_COLON_COLON] = ACTIONS(3094),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3094),
    [anon_sym___declspec] = ACTIONS(3096),
    [anon_sym___based] = ACTIONS(3096),
    [anon_sym___cdecl] = ACTIONS(3096),
    [anon_sym___clrcall] = ACTIONS(3096),
    [anon_sym___stdcall] = ACTIONS(3096),
    [anon_sym___fastcall] = ACTIONS(3096),
    [anon_sym___thiscall] = ACTIONS(3096),
    [anon_sym___vectorcall] = ACTIONS(3096),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_RBRACE] = ACTIONS(3094),
    [anon_sym_signed] = ACTIONS(3096),
    [anon_sym_unsigned] = ACTIONS(3096),
    [anon_sym_long] = ACTIONS(3096),
    [anon_sym_short] = ACTIONS(3096),
    [anon_sym_LBRACK] = ACTIONS(3096),
    [anon_sym_static] = ACTIONS(3096),
    [anon_sym_register] = ACTIONS(3096),
    [anon_sym_inline] = ACTIONS(3096),
    [anon_sym___inline] = ACTIONS(3096),
    [anon_sym___inline__] = ACTIONS(3096),
    [anon_sym___forceinline] = ACTIONS(3096),
    [anon_sym_thread_local] = ACTIONS(3096),
    [anon_sym___thread] = ACTIONS(3096),
    [anon_sym_const] = ACTIONS(3096),
    [anon_sym_constexpr] = ACTIONS(3096),
    [anon_sym_volatile] = ACTIONS(3096),
    [anon_sym_restrict] = ACTIONS(3096),
    [anon_sym___restrict__] = ACTIONS(3096),
    [anon_sym__Atomic] = ACTIONS(3096),
    [anon_sym__Noreturn] = ACTIONS(3096),
    [anon_sym_noreturn] = ACTIONS(3096),
    [anon_sym__Nonnull] = ACTIONS(3096),
    [anon_sym_mutable] = ACTIONS(3096),
    [anon_sym_constinit] = ACTIONS(3096),
    [anon_sym_consteval] = ACTIONS(3096),
    [anon_sym_alignas] = ACTIONS(3096),
    [anon_sym__Alignas] = ACTIONS(3096),
    [sym_primitive_type] = ACTIONS(3096),
    [anon_sym_enum] = ACTIONS(3096),
    [anon_sym_class] = ACTIONS(3096),
    [anon_sym_struct] = ACTIONS(3096),
    [anon_sym_union] = ACTIONS(3096),
    [anon_sym_if] = ACTIONS(3096),
    [anon_sym_else] = ACTIONS(4069),
    [anon_sym_switch] = ACTIONS(3096),
    [anon_sym_case] = ACTIONS(3096),
    [anon_sym_default] = ACTIONS(3096),
    [anon_sym_while] = ACTIONS(3096),
    [anon_sym_do] = ACTIONS(3096),
    [anon_sym_for] = ACTIONS(3096),
    [anon_sym_return] = ACTIONS(3096),
    [anon_sym_break] = ACTIONS(3096),
    [anon_sym_continue] = ACTIONS(3096),
    [anon_sym_goto] = ACTIONS(3096),
    [anon_sym___try] = ACTIONS(3096),
    [anon_sym___leave] = ACTIONS(3096),
    [anon_sym_not] = ACTIONS(3096),
    [anon_sym_compl] = ACTIONS(3096),
    [anon_sym_DASH_DASH] = ACTIONS(3094),
    [anon_sym_PLUS_PLUS] = ACTIONS(3094),
    [anon_sym_sizeof] = ACTIONS(3096),
    [anon_sym___alignof__] = ACTIONS(3096),
    [anon_sym___alignof] = ACTIONS(3096),
    [anon_sym__alignof] = ACTIONS(3096),
    [anon_sym_alignof] = ACTIONS(3096),
    [anon_sym__Alignof] = ACTIONS(3096),
    [anon_sym_offsetof] = ACTIONS(3096),
    [anon_sym__Generic] = ACTIONS(3096),
    [anon_sym_asm] = ACTIONS(3096),
    [anon_sym___asm__] = ACTIONS(3096),
    [anon_sym___asm] = ACTIONS(3096),
    [sym_number_literal] = ACTIONS(3094),
    [anon_sym_L_SQUOTE] = ACTIONS(3094),
    [anon_sym_u_SQUOTE] = ACTIONS(3094),
    [anon_sym_U_SQUOTE] = ACTIONS(3094),
    [anon_sym_u8_SQUOTE] = ACTIONS(3094),
    [anon_sym_SQUOTE] = ACTIONS(3094),
    [anon_sym_L_DQUOTE] = ACTIONS(3094),
    [anon_sym_u_DQUOTE] = ACTIONS(3094),
    [anon_sym_U_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8_DQUOTE] = ACTIONS(3094),
    [anon_sym_DQUOTE] = ACTIONS(3094),
    [sym_true] = ACTIONS(3096),
    [sym_false] = ACTIONS(3096),
    [anon_sym_NULL] = ACTIONS(3096),
    [anon_sym_nullptr] = ACTIONS(3096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3096),
    [anon_sym_let] = ACTIONS(3096),
    [anon_sym_This] = ACTIONS(3096),
    [anon_sym_decltype] = ACTIONS(3096),
    [anon_sym_explicit] = ACTIONS(3096),
    [anon_sym_typename] = ACTIONS(3096),
    [anon_sym_template] = ACTIONS(3096),
    [anon_sym_operator] = ACTIONS(3096),
    [anon_sym_try] = ACTIONS(3096),
    [anon_sym_delete] = ACTIONS(3096),
    [anon_sym_throw] = ACTIONS(3096),
    [anon_sym_namespace] = ACTIONS(3096),
    [anon_sym_static_assert] = ACTIONS(3096),
    [anon_sym_concept] = ACTIONS(3096),
    [anon_sym_co_return] = ACTIONS(3096),
    [anon_sym_co_yield] = ACTIONS(3096),
    [anon_sym_R_DQUOTE] = ACTIONS(3094),
    [anon_sym_LR_DQUOTE] = ACTIONS(3094),
    [anon_sym_uR_DQUOTE] = ACTIONS(3094),
    [anon_sym_UR_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3094),
    [anon_sym_co_await] = ACTIONS(3096),
    [anon_sym_new] = ACTIONS(3096),
    [anon_sym_requires] = ACTIONS(3096),
    [sym_this] = ACTIONS(3096),
    [anon_sym_discard] = ACTIONS(3096),
    [anon_sym_precise] = ACTIONS(3096),
    [anon_sym_shared] = ACTIONS(3096),
    [anon_sym_groupshared] = ACTIONS(3096),
    [anon_sym_uniform] = ACTIONS(3096),
    [anon_sym_row_major] = ACTIONS(3096),
    [anon_sym_column_major] = ACTIONS(3096),
    [anon_sym_globallycoherent] = ACTIONS(3096),
    [anon_sym_centroid] = ACTIONS(3096),
    [anon_sym_noperspective] = ACTIONS(3096),
    [anon_sym_nointerpolation] = ACTIONS(3096),
    [anon_sym_sample] = ACTIONS(3096),
    [anon_sym_linear] = ACTIONS(3096),
    [anon_sym_snorm] = ACTIONS(3096),
    [anon_sym_unorm] = ACTIONS(3096),
    [anon_sym_point] = ACTIONS(3096),
    [anon_sym_line] = ACTIONS(3096),
    [anon_sym_triangleadj] = ACTIONS(3096),
    [anon_sym_lineadj] = ACTIONS(3096),
    [anon_sym_triangle] = ACTIONS(3096),
    [anon_sym_cbuffer] = ACTIONS(3096),
    [anon_sym_interface] = ACTIONS(3096),
    [anon_sym_extension] = ACTIONS(3096),
  },
  [698] = {
    [sym_attribute_specifier] = STATE(297),
    [ts_builtin_sym_end] = ACTIONS(4198),
    [sym_identifier] = ACTIONS(4200),
    [aux_sym_preproc_include_token1] = ACTIONS(4200),
    [aux_sym_preproc_def_token1] = ACTIONS(4200),
    [aux_sym_preproc_if_token1] = ACTIONS(4200),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4200),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4200),
    [sym_preproc_directive] = ACTIONS(4200),
    [anon_sym_LPAREN2] = ACTIONS(4198),
    [anon_sym_BANG] = ACTIONS(4198),
    [anon_sym_TILDE] = ACTIONS(4198),
    [anon_sym_DASH] = ACTIONS(4200),
    [anon_sym_PLUS] = ACTIONS(4200),
    [anon_sym_STAR] = ACTIONS(4198),
    [anon_sym_AMP_AMP] = ACTIONS(4198),
    [anon_sym_AMP] = ACTIONS(4200),
    [anon_sym_SEMI] = ACTIONS(4198),
    [anon_sym___extension__] = ACTIONS(4200),
    [anon_sym_typedef] = ACTIONS(4200),
    [anon_sym_in] = ACTIONS(4200),
    [anon_sym_out] = ACTIONS(4200),
    [anon_sym_inout] = ACTIONS(4200),
    [anon_sym_virtual] = ACTIONS(4200),
    [anon_sym_extern] = ACTIONS(4200),
    [anon_sym___attribute__] = ACTIONS(2911),
    [anon_sym___attribute] = ACTIONS(2911),
    [anon_sym_using] = ACTIONS(4200),
    [anon_sym_COLON_COLON] = ACTIONS(4198),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4198),
    [anon_sym___declspec] = ACTIONS(4200),
    [anon_sym___based] = ACTIONS(4200),
    [anon_sym___cdecl] = ACTIONS(4200),
    [anon_sym___clrcall] = ACTIONS(4200),
    [anon_sym___stdcall] = ACTIONS(4200),
    [anon_sym___fastcall] = ACTIONS(4200),
    [anon_sym___thiscall] = ACTIONS(4200),
    [anon_sym___vectorcall] = ACTIONS(4200),
    [anon_sym_LBRACE] = ACTIONS(4198),
    [anon_sym_signed] = ACTIONS(4200),
    [anon_sym_unsigned] = ACTIONS(4200),
    [anon_sym_long] = ACTIONS(4200),
    [anon_sym_short] = ACTIONS(4200),
    [anon_sym_LBRACK] = ACTIONS(4200),
    [anon_sym_static] = ACTIONS(4200),
    [anon_sym_register] = ACTIONS(4200),
    [anon_sym_inline] = ACTIONS(4200),
    [anon_sym___inline] = ACTIONS(4200),
    [anon_sym___inline__] = ACTIONS(4200),
    [anon_sym___forceinline] = ACTIONS(4200),
    [anon_sym_thread_local] = ACTIONS(4200),
    [anon_sym___thread] = ACTIONS(4200),
    [anon_sym_const] = ACTIONS(4200),
    [anon_sym_constexpr] = ACTIONS(4200),
    [anon_sym_volatile] = ACTIONS(4200),
    [anon_sym_restrict] = ACTIONS(4200),
    [anon_sym___restrict__] = ACTIONS(4200),
    [anon_sym__Atomic] = ACTIONS(4200),
    [anon_sym__Noreturn] = ACTIONS(4200),
    [anon_sym_noreturn] = ACTIONS(4200),
    [anon_sym__Nonnull] = ACTIONS(4200),
    [anon_sym_mutable] = ACTIONS(4200),
    [anon_sym_constinit] = ACTIONS(4200),
    [anon_sym_consteval] = ACTIONS(4200),
    [anon_sym_alignas] = ACTIONS(4200),
    [anon_sym__Alignas] = ACTIONS(4200),
    [sym_primitive_type] = ACTIONS(4200),
    [anon_sym_enum] = ACTIONS(4200),
    [anon_sym_class] = ACTIONS(4200),
    [anon_sym_struct] = ACTIONS(4200),
    [anon_sym_union] = ACTIONS(4200),
    [anon_sym_if] = ACTIONS(4200),
    [anon_sym_switch] = ACTIONS(4200),
    [anon_sym_case] = ACTIONS(4200),
    [anon_sym_default] = ACTIONS(4200),
    [anon_sym_while] = ACTIONS(4200),
    [anon_sym_do] = ACTIONS(4200),
    [anon_sym_for] = ACTIONS(4200),
    [anon_sym_return] = ACTIONS(4200),
    [anon_sym_break] = ACTIONS(4200),
    [anon_sym_continue] = ACTIONS(4200),
    [anon_sym_goto] = ACTIONS(4200),
    [anon_sym_not] = ACTIONS(4200),
    [anon_sym_compl] = ACTIONS(4200),
    [anon_sym_DASH_DASH] = ACTIONS(4198),
    [anon_sym_PLUS_PLUS] = ACTIONS(4198),
    [anon_sym_sizeof] = ACTIONS(4200),
    [anon_sym___alignof__] = ACTIONS(4200),
    [anon_sym___alignof] = ACTIONS(4200),
    [anon_sym__alignof] = ACTIONS(4200),
    [anon_sym_alignof] = ACTIONS(4200),
    [anon_sym__Alignof] = ACTIONS(4200),
    [anon_sym_offsetof] = ACTIONS(4200),
    [anon_sym__Generic] = ACTIONS(4200),
    [anon_sym_asm] = ACTIONS(4200),
    [anon_sym___asm__] = ACTIONS(4200),
    [anon_sym___asm] = ACTIONS(4200),
    [anon_sym_DOT] = ACTIONS(4200),
    [sym_number_literal] = ACTIONS(4198),
    [anon_sym_L_SQUOTE] = ACTIONS(4198),
    [anon_sym_u_SQUOTE] = ACTIONS(4198),
    [anon_sym_U_SQUOTE] = ACTIONS(4198),
    [anon_sym_u8_SQUOTE] = ACTIONS(4198),
    [anon_sym_SQUOTE] = ACTIONS(4198),
    [anon_sym_L_DQUOTE] = ACTIONS(4198),
    [anon_sym_u_DQUOTE] = ACTIONS(4198),
    [anon_sym_U_DQUOTE] = ACTIONS(4198),
    [anon_sym_u8_DQUOTE] = ACTIONS(4198),
    [anon_sym_DQUOTE] = ACTIONS(4198),
    [sym_true] = ACTIONS(4200),
    [sym_false] = ACTIONS(4200),
    [anon_sym_NULL] = ACTIONS(4200),
    [anon_sym_nullptr] = ACTIONS(4200),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4200),
    [anon_sym_let] = ACTIONS(4200),
    [anon_sym_This] = ACTIONS(4200),
    [anon_sym_decltype] = ACTIONS(4200),
    [anon_sym_explicit] = ACTIONS(4200),
    [anon_sym_typename] = ACTIONS(4200),
    [anon_sym_export] = ACTIONS(4200),
    [anon_sym_module] = ACTIONS(4200),
    [anon_sym_import] = ACTIONS(4200),
    [anon_sym_template] = ACTIONS(4200),
    [anon_sym_operator] = ACTIONS(4200),
    [anon_sym_try] = ACTIONS(4200),
    [anon_sym_delete] = ACTIONS(4200),
    [anon_sym_throw] = ACTIONS(4200),
    [anon_sym_namespace] = ACTIONS(4200),
    [anon_sym_static_assert] = ACTIONS(4200),
    [anon_sym_concept] = ACTIONS(4200),
    [anon_sym_co_return] = ACTIONS(4200),
    [anon_sym_co_yield] = ACTIONS(4200),
    [anon_sym_R_DQUOTE] = ACTIONS(4198),
    [anon_sym_LR_DQUOTE] = ACTIONS(4198),
    [anon_sym_uR_DQUOTE] = ACTIONS(4198),
    [anon_sym_UR_DQUOTE] = ACTIONS(4198),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4198),
    [anon_sym_co_await] = ACTIONS(4200),
    [anon_sym_new] = ACTIONS(4200),
    [anon_sym_requires] = ACTIONS(4200),
    [sym_this] = ACTIONS(4200),
    [anon_sym_precise] = ACTIONS(4200),
    [anon_sym_shared] = ACTIONS(4200),
    [anon_sym_groupshared] = ACTIONS(4200),
    [anon_sym_uniform] = ACTIONS(4200),
    [anon_sym_row_major] = ACTIONS(4200),
    [anon_sym_column_major] = ACTIONS(4200),
    [anon_sym_globallycoherent] = ACTIONS(4200),
    [anon_sym_centroid] = ACTIONS(4200),
    [anon_sym_noperspective] = ACTIONS(4200),
    [anon_sym_nointerpolation] = ACTIONS(4200),
    [anon_sym_sample] = ACTIONS(4200),
    [anon_sym_linear] = ACTIONS(4200),
    [anon_sym_snorm] = ACTIONS(4200),
    [anon_sym_unorm] = ACTIONS(4200),
    [anon_sym_point] = ACTIONS(4200),
    [anon_sym_line] = ACTIONS(4200),
    [anon_sym_triangleadj] = ACTIONS(4200),
    [anon_sym_lineadj] = ACTIONS(4200),
    [anon_sym_triangle] = ACTIONS(4200),
    [anon_sym_interface] = ACTIONS(4200),
    [anon_sym_extension] = ACTIONS(4200),
    [anon_sym___exported] = ACTIONS(4200),
  },
  [699] = {
    [sym_identifier] = ACTIONS(2404),
    [aux_sym_preproc_include_token1] = ACTIONS(2404),
    [aux_sym_preproc_def_token1] = ACTIONS(2404),
    [aux_sym_preproc_if_token1] = ACTIONS(2404),
    [aux_sym_preproc_if_token2] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2404),
    [sym_preproc_directive] = ACTIONS(2404),
    [anon_sym_LPAREN2] = ACTIONS(2402),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_TILDE] = ACTIONS(2402),
    [anon_sym_DASH] = ACTIONS(2404),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_STAR] = ACTIONS(2402),
    [anon_sym_AMP_AMP] = ACTIONS(2402),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2402),
    [anon_sym___extension__] = ACTIONS(2404),
    [anon_sym_typedef] = ACTIONS(2404),
    [anon_sym_in] = ACTIONS(2404),
    [anon_sym_out] = ACTIONS(2404),
    [anon_sym_inout] = ACTIONS(2404),
    [anon_sym_virtual] = ACTIONS(2404),
    [anon_sym_extern] = ACTIONS(2404),
    [anon_sym___attribute__] = ACTIONS(2404),
    [anon_sym___attribute] = ACTIONS(2404),
    [anon_sym_using] = ACTIONS(2404),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2402),
    [anon_sym___declspec] = ACTIONS(2404),
    [anon_sym___based] = ACTIONS(2404),
    [anon_sym___cdecl] = ACTIONS(2404),
    [anon_sym___clrcall] = ACTIONS(2404),
    [anon_sym___stdcall] = ACTIONS(2404),
    [anon_sym___fastcall] = ACTIONS(2404),
    [anon_sym___thiscall] = ACTIONS(2404),
    [anon_sym___vectorcall] = ACTIONS(2404),
    [anon_sym_LBRACE] = ACTIONS(2402),
    [anon_sym_signed] = ACTIONS(2404),
    [anon_sym_unsigned] = ACTIONS(2404),
    [anon_sym_long] = ACTIONS(2404),
    [anon_sym_short] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_register] = ACTIONS(2404),
    [anon_sym_inline] = ACTIONS(2404),
    [anon_sym___inline] = ACTIONS(2404),
    [anon_sym___inline__] = ACTIONS(2404),
    [anon_sym___forceinline] = ACTIONS(2404),
    [anon_sym_thread_local] = ACTIONS(2404),
    [anon_sym___thread] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [anon_sym_constexpr] = ACTIONS(2404),
    [anon_sym_volatile] = ACTIONS(2404),
    [anon_sym_restrict] = ACTIONS(2404),
    [anon_sym___restrict__] = ACTIONS(2404),
    [anon_sym__Atomic] = ACTIONS(2404),
    [anon_sym__Noreturn] = ACTIONS(2404),
    [anon_sym_noreturn] = ACTIONS(2404),
    [anon_sym__Nonnull] = ACTIONS(2404),
    [anon_sym_mutable] = ACTIONS(2404),
    [anon_sym_constinit] = ACTIONS(2404),
    [anon_sym_consteval] = ACTIONS(2404),
    [anon_sym_alignas] = ACTIONS(2404),
    [anon_sym__Alignas] = ACTIONS(2404),
    [sym_primitive_type] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
    [anon_sym_class] = ACTIONS(2404),
    [anon_sym_struct] = ACTIONS(2404),
    [anon_sym_union] = ACTIONS(2404),
    [anon_sym_if] = ACTIONS(2404),
    [anon_sym_else] = ACTIONS(2404),
    [anon_sym_switch] = ACTIONS(2404),
    [anon_sym_case] = ACTIONS(2404),
    [anon_sym_default] = ACTIONS(2404),
    [anon_sym_while] = ACTIONS(2404),
    [anon_sym_do] = ACTIONS(2404),
    [anon_sym_for] = ACTIONS(2404),
    [anon_sym_return] = ACTIONS(2404),
    [anon_sym_break] = ACTIONS(2404),
    [anon_sym_continue] = ACTIONS(2404),
    [anon_sym_goto] = ACTIONS(2404),
    [anon_sym___try] = ACTIONS(2404),
    [anon_sym___leave] = ACTIONS(2404),
    [anon_sym_not] = ACTIONS(2404),
    [anon_sym_compl] = ACTIONS(2404),
    [anon_sym_DASH_DASH] = ACTIONS(2402),
    [anon_sym_PLUS_PLUS] = ACTIONS(2402),
    [anon_sym_sizeof] = ACTIONS(2404),
    [anon_sym___alignof__] = ACTIONS(2404),
    [anon_sym___alignof] = ACTIONS(2404),
    [anon_sym__alignof] = ACTIONS(2404),
    [anon_sym_alignof] = ACTIONS(2404),
    [anon_sym__Alignof] = ACTIONS(2404),
    [anon_sym_offsetof] = ACTIONS(2404),
    [anon_sym__Generic] = ACTIONS(2404),
    [anon_sym_asm] = ACTIONS(2404),
    [anon_sym___asm__] = ACTIONS(2404),
    [anon_sym___asm] = ACTIONS(2404),
    [sym_number_literal] = ACTIONS(2402),
    [anon_sym_L_SQUOTE] = ACTIONS(2402),
    [anon_sym_u_SQUOTE] = ACTIONS(2402),
    [anon_sym_U_SQUOTE] = ACTIONS(2402),
    [anon_sym_u8_SQUOTE] = ACTIONS(2402),
    [anon_sym_SQUOTE] = ACTIONS(2402),
    [anon_sym_L_DQUOTE] = ACTIONS(2402),
    [anon_sym_u_DQUOTE] = ACTIONS(2402),
    [anon_sym_U_DQUOTE] = ACTIONS(2402),
    [anon_sym_u8_DQUOTE] = ACTIONS(2402),
    [anon_sym_DQUOTE] = ACTIONS(2402),
    [sym_true] = ACTIONS(2404),
    [sym_false] = ACTIONS(2404),
    [anon_sym_NULL] = ACTIONS(2404),
    [anon_sym_nullptr] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2404),
    [anon_sym_let] = ACTIONS(2404),
    [anon_sym_This] = ACTIONS(2404),
    [anon_sym_decltype] = ACTIONS(2404),
    [anon_sym_explicit] = ACTIONS(2404),
    [anon_sym_typename] = ACTIONS(2404),
    [anon_sym_template] = ACTIONS(2404),
    [anon_sym_operator] = ACTIONS(2404),
    [anon_sym_try] = ACTIONS(2404),
    [anon_sym_delete] = ACTIONS(2404),
    [anon_sym_throw] = ACTIONS(2404),
    [anon_sym_namespace] = ACTIONS(2404),
    [anon_sym_static_assert] = ACTIONS(2404),
    [anon_sym_concept] = ACTIONS(2404),
    [anon_sym_co_return] = ACTIONS(2404),
    [anon_sym_co_yield] = ACTIONS(2404),
    [anon_sym_catch] = ACTIONS(2404),
    [anon_sym_R_DQUOTE] = ACTIONS(2402),
    [anon_sym_LR_DQUOTE] = ACTIONS(2402),
    [anon_sym_uR_DQUOTE] = ACTIONS(2402),
    [anon_sym_UR_DQUOTE] = ACTIONS(2402),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2402),
    [anon_sym_co_await] = ACTIONS(2404),
    [anon_sym_new] = ACTIONS(2404),
    [anon_sym_requires] = ACTIONS(2404),
    [sym_this] = ACTIONS(2404),
    [anon_sym_discard] = ACTIONS(2404),
    [anon_sym_precise] = ACTIONS(2404),
    [anon_sym_shared] = ACTIONS(2404),
    [anon_sym_groupshared] = ACTIONS(2404),
    [anon_sym_uniform] = ACTIONS(2404),
    [anon_sym_row_major] = ACTIONS(2404),
    [anon_sym_column_major] = ACTIONS(2404),
    [anon_sym_globallycoherent] = ACTIONS(2404),
    [anon_sym_centroid] = ACTIONS(2404),
    [anon_sym_noperspective] = ACTIONS(2404),
    [anon_sym_nointerpolation] = ACTIONS(2404),
    [anon_sym_sample] = ACTIONS(2404),
    [anon_sym_linear] = ACTIONS(2404),
    [anon_sym_snorm] = ACTIONS(2404),
    [anon_sym_unorm] = ACTIONS(2404),
    [anon_sym_point] = ACTIONS(2404),
    [anon_sym_line] = ACTIONS(2404),
    [anon_sym_triangleadj] = ACTIONS(2404),
    [anon_sym_lineadj] = ACTIONS(2404),
    [anon_sym_triangle] = ACTIONS(2404),
    [anon_sym_cbuffer] = ACTIONS(2404),
    [anon_sym_interface] = ACTIONS(2404),
    [anon_sym_extension] = ACTIONS(2404),
  },
  [700] = {
    [sym_attribute_specifier] = STATE(783),
    [sym_identifier] = ACTIONS(4010),
    [aux_sym_preproc_include_token1] = ACTIONS(4010),
    [aux_sym_preproc_def_token1] = ACTIONS(4010),
    [aux_sym_preproc_if_token1] = ACTIONS(4010),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4010),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4010),
    [sym_preproc_directive] = ACTIONS(4010),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_BANG] = ACTIONS(4008),
    [anon_sym_TILDE] = ACTIONS(4008),
    [anon_sym_DASH] = ACTIONS(4010),
    [anon_sym_PLUS] = ACTIONS(4010),
    [anon_sym_STAR] = ACTIONS(4008),
    [anon_sym_AMP_AMP] = ACTIONS(4008),
    [anon_sym_AMP] = ACTIONS(4010),
    [anon_sym_SEMI] = ACTIONS(4008),
    [anon_sym___extension__] = ACTIONS(4010),
    [anon_sym_typedef] = ACTIONS(4010),
    [anon_sym_in] = ACTIONS(4010),
    [anon_sym_out] = ACTIONS(4010),
    [anon_sym_inout] = ACTIONS(4010),
    [anon_sym_virtual] = ACTIONS(4010),
    [anon_sym_extern] = ACTIONS(4010),
    [anon_sym___attribute__] = ACTIONS(2897),
    [anon_sym___attribute] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(4010),
    [anon_sym_COLON_COLON] = ACTIONS(4008),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4008),
    [anon_sym___declspec] = ACTIONS(4010),
    [anon_sym___based] = ACTIONS(4010),
    [anon_sym___cdecl] = ACTIONS(4010),
    [anon_sym___clrcall] = ACTIONS(4010),
    [anon_sym___stdcall] = ACTIONS(4010),
    [anon_sym___fastcall] = ACTIONS(4010),
    [anon_sym___thiscall] = ACTIONS(4010),
    [anon_sym___vectorcall] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4008),
    [anon_sym_RBRACE] = ACTIONS(4008),
    [anon_sym_signed] = ACTIONS(4010),
    [anon_sym_unsigned] = ACTIONS(4010),
    [anon_sym_long] = ACTIONS(4010),
    [anon_sym_short] = ACTIONS(4010),
    [anon_sym_LBRACK] = ACTIONS(4010),
    [anon_sym_static] = ACTIONS(4010),
    [anon_sym_register] = ACTIONS(4010),
    [anon_sym_inline] = ACTIONS(4010),
    [anon_sym___inline] = ACTIONS(4010),
    [anon_sym___inline__] = ACTIONS(4010),
    [anon_sym___forceinline] = ACTIONS(4010),
    [anon_sym_thread_local] = ACTIONS(4010),
    [anon_sym___thread] = ACTIONS(4010),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_constexpr] = ACTIONS(4010),
    [anon_sym_volatile] = ACTIONS(4010),
    [anon_sym_restrict] = ACTIONS(4010),
    [anon_sym___restrict__] = ACTIONS(4010),
    [anon_sym__Atomic] = ACTIONS(4010),
    [anon_sym__Noreturn] = ACTIONS(4010),
    [anon_sym_noreturn] = ACTIONS(4010),
    [anon_sym__Nonnull] = ACTIONS(4010),
    [anon_sym_mutable] = ACTIONS(4010),
    [anon_sym_constinit] = ACTIONS(4010),
    [anon_sym_consteval] = ACTIONS(4010),
    [anon_sym_alignas] = ACTIONS(4010),
    [anon_sym__Alignas] = ACTIONS(4010),
    [sym_primitive_type] = ACTIONS(4010),
    [anon_sym_enum] = ACTIONS(4010),
    [anon_sym_class] = ACTIONS(4010),
    [anon_sym_struct] = ACTIONS(4010),
    [anon_sym_union] = ACTIONS(4010),
    [anon_sym_if] = ACTIONS(4010),
    [anon_sym_switch] = ACTIONS(4010),
    [anon_sym_case] = ACTIONS(4010),
    [anon_sym_default] = ACTIONS(4010),
    [anon_sym_while] = ACTIONS(4010),
    [anon_sym_do] = ACTIONS(4010),
    [anon_sym_for] = ACTIONS(4010),
    [anon_sym_return] = ACTIONS(4010),
    [anon_sym_break] = ACTIONS(4010),
    [anon_sym_continue] = ACTIONS(4010),
    [anon_sym_goto] = ACTIONS(4010),
    [anon_sym___try] = ACTIONS(4010),
    [anon_sym___leave] = ACTIONS(4010),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_compl] = ACTIONS(4010),
    [anon_sym_DASH_DASH] = ACTIONS(4008),
    [anon_sym_PLUS_PLUS] = ACTIONS(4008),
    [anon_sym_sizeof] = ACTIONS(4010),
    [anon_sym___alignof__] = ACTIONS(4010),
    [anon_sym___alignof] = ACTIONS(4010),
    [anon_sym__alignof] = ACTIONS(4010),
    [anon_sym_alignof] = ACTIONS(4010),
    [anon_sym__Alignof] = ACTIONS(4010),
    [anon_sym_offsetof] = ACTIONS(4010),
    [anon_sym__Generic] = ACTIONS(4010),
    [anon_sym_asm] = ACTIONS(4010),
    [anon_sym___asm__] = ACTIONS(4010),
    [anon_sym___asm] = ACTIONS(4010),
    [anon_sym_DOT] = ACTIONS(4010),
    [sym_number_literal] = ACTIONS(4008),
    [anon_sym_L_SQUOTE] = ACTIONS(4008),
    [anon_sym_u_SQUOTE] = ACTIONS(4008),
    [anon_sym_U_SQUOTE] = ACTIONS(4008),
    [anon_sym_u8_SQUOTE] = ACTIONS(4008),
    [anon_sym_SQUOTE] = ACTIONS(4008),
    [anon_sym_L_DQUOTE] = ACTIONS(4008),
    [anon_sym_u_DQUOTE] = ACTIONS(4008),
    [anon_sym_U_DQUOTE] = ACTIONS(4008),
    [anon_sym_u8_DQUOTE] = ACTIONS(4008),
    [anon_sym_DQUOTE] = ACTIONS(4008),
    [sym_true] = ACTIONS(4010),
    [sym_false] = ACTIONS(4010),
    [anon_sym_NULL] = ACTIONS(4010),
    [anon_sym_nullptr] = ACTIONS(4010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4010),
    [anon_sym_let] = ACTIONS(4010),
    [anon_sym_This] = ACTIONS(4010),
    [anon_sym_decltype] = ACTIONS(4010),
    [anon_sym_explicit] = ACTIONS(4010),
    [anon_sym_typename] = ACTIONS(4010),
    [anon_sym_template] = ACTIONS(4010),
    [anon_sym_operator] = ACTIONS(4010),
    [anon_sym_try] = ACTIONS(4010),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_throw] = ACTIONS(4010),
    [anon_sym_namespace] = ACTIONS(4010),
    [anon_sym_static_assert] = ACTIONS(4010),
    [anon_sym_concept] = ACTIONS(4010),
    [anon_sym_co_return] = ACTIONS(4010),
    [anon_sym_co_yield] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(4008),
    [anon_sym_LR_DQUOTE] = ACTIONS(4008),
    [anon_sym_uR_DQUOTE] = ACTIONS(4008),
    [anon_sym_UR_DQUOTE] = ACTIONS(4008),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4008),
    [anon_sym_co_await] = ACTIONS(4010),
    [anon_sym_new] = ACTIONS(4010),
    [anon_sym_requires] = ACTIONS(4010),
    [sym_this] = ACTIONS(4010),
    [anon_sym_discard] = ACTIONS(4010),
    [anon_sym_precise] = ACTIONS(4010),
    [anon_sym_shared] = ACTIONS(4010),
    [anon_sym_groupshared] = ACTIONS(4010),
    [anon_sym_uniform] = ACTIONS(4010),
    [anon_sym_row_major] = ACTIONS(4010),
    [anon_sym_column_major] = ACTIONS(4010),
    [anon_sym_globallycoherent] = ACTIONS(4010),
    [anon_sym_centroid] = ACTIONS(4010),
    [anon_sym_noperspective] = ACTIONS(4010),
    [anon_sym_nointerpolation] = ACTIONS(4010),
    [anon_sym_sample] = ACTIONS(4010),
    [anon_sym_linear] = ACTIONS(4010),
    [anon_sym_snorm] = ACTIONS(4010),
    [anon_sym_unorm] = ACTIONS(4010),
    [anon_sym_point] = ACTIONS(4010),
    [anon_sym_line] = ACTIONS(4010),
    [anon_sym_triangleadj] = ACTIONS(4010),
    [anon_sym_lineadj] = ACTIONS(4010),
    [anon_sym_triangle] = ACTIONS(4010),
    [anon_sym_cbuffer] = ACTIONS(4010),
    [anon_sym_interface] = ACTIONS(4010),
    [anon_sym_extension] = ACTIONS(4010),
  },
  [701] = {
    [sym_attribute_specifier] = STATE(784),
    [sym_identifier] = ACTIONS(4014),
    [aux_sym_preproc_include_token1] = ACTIONS(4014),
    [aux_sym_preproc_def_token1] = ACTIONS(4014),
    [aux_sym_preproc_if_token1] = ACTIONS(4014),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4014),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4014),
    [sym_preproc_directive] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(4012),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [anon_sym_DASH] = ACTIONS(4014),
    [anon_sym_PLUS] = ACTIONS(4014),
    [anon_sym_STAR] = ACTIONS(4012),
    [anon_sym_AMP_AMP] = ACTIONS(4012),
    [anon_sym_AMP] = ACTIONS(4014),
    [anon_sym_SEMI] = ACTIONS(4012),
    [anon_sym___extension__] = ACTIONS(4014),
    [anon_sym_typedef] = ACTIONS(4014),
    [anon_sym_in] = ACTIONS(4014),
    [anon_sym_out] = ACTIONS(4014),
    [anon_sym_inout] = ACTIONS(4014),
    [anon_sym_virtual] = ACTIONS(4014),
    [anon_sym_extern] = ACTIONS(4014),
    [anon_sym___attribute__] = ACTIONS(2897),
    [anon_sym___attribute] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(4014),
    [anon_sym_COLON_COLON] = ACTIONS(4012),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4012),
    [anon_sym___declspec] = ACTIONS(4014),
    [anon_sym___based] = ACTIONS(4014),
    [anon_sym___cdecl] = ACTIONS(4014),
    [anon_sym___clrcall] = ACTIONS(4014),
    [anon_sym___stdcall] = ACTIONS(4014),
    [anon_sym___fastcall] = ACTIONS(4014),
    [anon_sym___thiscall] = ACTIONS(4014),
    [anon_sym___vectorcall] = ACTIONS(4014),
    [anon_sym_LBRACE] = ACTIONS(4012),
    [anon_sym_RBRACE] = ACTIONS(4012),
    [anon_sym_signed] = ACTIONS(4014),
    [anon_sym_unsigned] = ACTIONS(4014),
    [anon_sym_long] = ACTIONS(4014),
    [anon_sym_short] = ACTIONS(4014),
    [anon_sym_LBRACK] = ACTIONS(4014),
    [anon_sym_static] = ACTIONS(4014),
    [anon_sym_register] = ACTIONS(4014),
    [anon_sym_inline] = ACTIONS(4014),
    [anon_sym___inline] = ACTIONS(4014),
    [anon_sym___inline__] = ACTIONS(4014),
    [anon_sym___forceinline] = ACTIONS(4014),
    [anon_sym_thread_local] = ACTIONS(4014),
    [anon_sym___thread] = ACTIONS(4014),
    [anon_sym_const] = ACTIONS(4014),
    [anon_sym_constexpr] = ACTIONS(4014),
    [anon_sym_volatile] = ACTIONS(4014),
    [anon_sym_restrict] = ACTIONS(4014),
    [anon_sym___restrict__] = ACTIONS(4014),
    [anon_sym__Atomic] = ACTIONS(4014),
    [anon_sym__Noreturn] = ACTIONS(4014),
    [anon_sym_noreturn] = ACTIONS(4014),
    [anon_sym__Nonnull] = ACTIONS(4014),
    [anon_sym_mutable] = ACTIONS(4014),
    [anon_sym_constinit] = ACTIONS(4014),
    [anon_sym_consteval] = ACTIONS(4014),
    [anon_sym_alignas] = ACTIONS(4014),
    [anon_sym__Alignas] = ACTIONS(4014),
    [sym_primitive_type] = ACTIONS(4014),
    [anon_sym_enum] = ACTIONS(4014),
    [anon_sym_class] = ACTIONS(4014),
    [anon_sym_struct] = ACTIONS(4014),
    [anon_sym_union] = ACTIONS(4014),
    [anon_sym_if] = ACTIONS(4014),
    [anon_sym_switch] = ACTIONS(4014),
    [anon_sym_case] = ACTIONS(4014),
    [anon_sym_default] = ACTIONS(4014),
    [anon_sym_while] = ACTIONS(4014),
    [anon_sym_do] = ACTIONS(4014),
    [anon_sym_for] = ACTIONS(4014),
    [anon_sym_return] = ACTIONS(4014),
    [anon_sym_break] = ACTIONS(4014),
    [anon_sym_continue] = ACTIONS(4014),
    [anon_sym_goto] = ACTIONS(4014),
    [anon_sym___try] = ACTIONS(4014),
    [anon_sym___leave] = ACTIONS(4014),
    [anon_sym_not] = ACTIONS(4014),
    [anon_sym_compl] = ACTIONS(4014),
    [anon_sym_DASH_DASH] = ACTIONS(4012),
    [anon_sym_PLUS_PLUS] = ACTIONS(4012),
    [anon_sym_sizeof] = ACTIONS(4014),
    [anon_sym___alignof__] = ACTIONS(4014),
    [anon_sym___alignof] = ACTIONS(4014),
    [anon_sym__alignof] = ACTIONS(4014),
    [anon_sym_alignof] = ACTIONS(4014),
    [anon_sym__Alignof] = ACTIONS(4014),
    [anon_sym_offsetof] = ACTIONS(4014),
    [anon_sym__Generic] = ACTIONS(4014),
    [anon_sym_asm] = ACTIONS(4014),
    [anon_sym___asm__] = ACTIONS(4014),
    [anon_sym___asm] = ACTIONS(4014),
    [anon_sym_DOT] = ACTIONS(4014),
    [sym_number_literal] = ACTIONS(4012),
    [anon_sym_L_SQUOTE] = ACTIONS(4012),
    [anon_sym_u_SQUOTE] = ACTIONS(4012),
    [anon_sym_U_SQUOTE] = ACTIONS(4012),
    [anon_sym_u8_SQUOTE] = ACTIONS(4012),
    [anon_sym_SQUOTE] = ACTIONS(4012),
    [anon_sym_L_DQUOTE] = ACTIONS(4012),
    [anon_sym_u_DQUOTE] = ACTIONS(4012),
    [anon_sym_U_DQUOTE] = ACTIONS(4012),
    [anon_sym_u8_DQUOTE] = ACTIONS(4012),
    [anon_sym_DQUOTE] = ACTIONS(4012),
    [sym_true] = ACTIONS(4014),
    [sym_false] = ACTIONS(4014),
    [anon_sym_NULL] = ACTIONS(4014),
    [anon_sym_nullptr] = ACTIONS(4014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4014),
    [anon_sym_let] = ACTIONS(4014),
    [anon_sym_This] = ACTIONS(4014),
    [anon_sym_decltype] = ACTIONS(4014),
    [anon_sym_explicit] = ACTIONS(4014),
    [anon_sym_typename] = ACTIONS(4014),
    [anon_sym_template] = ACTIONS(4014),
    [anon_sym_operator] = ACTIONS(4014),
    [anon_sym_try] = ACTIONS(4014),
    [anon_sym_delete] = ACTIONS(4014),
    [anon_sym_throw] = ACTIONS(4014),
    [anon_sym_namespace] = ACTIONS(4014),
    [anon_sym_static_assert] = ACTIONS(4014),
    [anon_sym_concept] = ACTIONS(4014),
    [anon_sym_co_return] = ACTIONS(4014),
    [anon_sym_co_yield] = ACTIONS(4014),
    [anon_sym_R_DQUOTE] = ACTIONS(4012),
    [anon_sym_LR_DQUOTE] = ACTIONS(4012),
    [anon_sym_uR_DQUOTE] = ACTIONS(4012),
    [anon_sym_UR_DQUOTE] = ACTIONS(4012),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4012),
    [anon_sym_co_await] = ACTIONS(4014),
    [anon_sym_new] = ACTIONS(4014),
    [anon_sym_requires] = ACTIONS(4014),
    [sym_this] = ACTIONS(4014),
    [anon_sym_discard] = ACTIONS(4014),
    [anon_sym_precise] = ACTIONS(4014),
    [anon_sym_shared] = ACTIONS(4014),
    [anon_sym_groupshared] = ACTIONS(4014),
    [anon_sym_uniform] = ACTIONS(4014),
    [anon_sym_row_major] = ACTIONS(4014),
    [anon_sym_column_major] = ACTIONS(4014),
    [anon_sym_globallycoherent] = ACTIONS(4014),
    [anon_sym_centroid] = ACTIONS(4014),
    [anon_sym_noperspective] = ACTIONS(4014),
    [anon_sym_nointerpolation] = ACTIONS(4014),
    [anon_sym_sample] = ACTIONS(4014),
    [anon_sym_linear] = ACTIONS(4014),
    [anon_sym_snorm] = ACTIONS(4014),
    [anon_sym_unorm] = ACTIONS(4014),
    [anon_sym_point] = ACTIONS(4014),
    [anon_sym_line] = ACTIONS(4014),
    [anon_sym_triangleadj] = ACTIONS(4014),
    [anon_sym_lineadj] = ACTIONS(4014),
    [anon_sym_triangle] = ACTIONS(4014),
    [anon_sym_cbuffer] = ACTIONS(4014),
    [anon_sym_interface] = ACTIONS(4014),
    [anon_sym_extension] = ACTIONS(4014),
  },
  [702] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(658),
    [ts_builtin_sym_end] = ACTIONS(4166),
    [sym_identifier] = ACTIONS(4164),
    [aux_sym_preproc_include_token1] = ACTIONS(4164),
    [aux_sym_preproc_def_token1] = ACTIONS(4164),
    [aux_sym_preproc_if_token1] = ACTIONS(4164),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4164),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4164),
    [sym_preproc_directive] = ACTIONS(4164),
    [anon_sym_LPAREN2] = ACTIONS(4166),
    [anon_sym_BANG] = ACTIONS(4166),
    [anon_sym_TILDE] = ACTIONS(4166),
    [anon_sym_DASH] = ACTIONS(4164),
    [anon_sym_PLUS] = ACTIONS(4164),
    [anon_sym_STAR] = ACTIONS(4166),
    [anon_sym_AMP_AMP] = ACTIONS(4166),
    [anon_sym_AMP] = ACTIONS(4164),
    [anon_sym_SEMI] = ACTIONS(4166),
    [anon_sym___extension__] = ACTIONS(4164),
    [anon_sym_typedef] = ACTIONS(4164),
    [anon_sym_in] = ACTIONS(4164),
    [anon_sym_out] = ACTIONS(4164),
    [anon_sym_inout] = ACTIONS(4164),
    [anon_sym_virtual] = ACTIONS(4164),
    [anon_sym_extern] = ACTIONS(4164),
    [anon_sym___attribute__] = ACTIONS(4164),
    [anon_sym___attribute] = ACTIONS(4164),
    [anon_sym_using] = ACTIONS(4164),
    [anon_sym_COLON_COLON] = ACTIONS(4166),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4166),
    [anon_sym___declspec] = ACTIONS(4164),
    [anon_sym___based] = ACTIONS(4164),
    [anon_sym___cdecl] = ACTIONS(4164),
    [anon_sym___clrcall] = ACTIONS(4164),
    [anon_sym___stdcall] = ACTIONS(4164),
    [anon_sym___fastcall] = ACTIONS(4164),
    [anon_sym___thiscall] = ACTIONS(4164),
    [anon_sym___vectorcall] = ACTIONS(4164),
    [anon_sym_LBRACE] = ACTIONS(4166),
    [anon_sym_signed] = ACTIONS(4202),
    [anon_sym_unsigned] = ACTIONS(4202),
    [anon_sym_long] = ACTIONS(4202),
    [anon_sym_short] = ACTIONS(4202),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_static] = ACTIONS(4164),
    [anon_sym_register] = ACTIONS(4164),
    [anon_sym_inline] = ACTIONS(4164),
    [anon_sym___inline] = ACTIONS(4164),
    [anon_sym___inline__] = ACTIONS(4164),
    [anon_sym___forceinline] = ACTIONS(4164),
    [anon_sym_thread_local] = ACTIONS(4164),
    [anon_sym___thread] = ACTIONS(4164),
    [anon_sym_const] = ACTIONS(4164),
    [anon_sym_constexpr] = ACTIONS(4164),
    [anon_sym_volatile] = ACTIONS(4164),
    [anon_sym_restrict] = ACTIONS(4164),
    [anon_sym___restrict__] = ACTIONS(4164),
    [anon_sym__Atomic] = ACTIONS(4164),
    [anon_sym__Noreturn] = ACTIONS(4164),
    [anon_sym_noreturn] = ACTIONS(4164),
    [anon_sym__Nonnull] = ACTIONS(4164),
    [anon_sym_mutable] = ACTIONS(4164),
    [anon_sym_constinit] = ACTIONS(4164),
    [anon_sym_consteval] = ACTIONS(4164),
    [anon_sym_alignas] = ACTIONS(4164),
    [anon_sym__Alignas] = ACTIONS(4164),
    [sym_primitive_type] = ACTIONS(4164),
    [anon_sym_enum] = ACTIONS(4164),
    [anon_sym_class] = ACTIONS(4164),
    [anon_sym_struct] = ACTIONS(4164),
    [anon_sym_union] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_switch] = ACTIONS(4164),
    [anon_sym_case] = ACTIONS(4164),
    [anon_sym_default] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_for] = ACTIONS(4164),
    [anon_sym_return] = ACTIONS(4164),
    [anon_sym_break] = ACTIONS(4164),
    [anon_sym_continue] = ACTIONS(4164),
    [anon_sym_goto] = ACTIONS(4164),
    [anon_sym_not] = ACTIONS(4164),
    [anon_sym_compl] = ACTIONS(4164),
    [anon_sym_DASH_DASH] = ACTIONS(4166),
    [anon_sym_PLUS_PLUS] = ACTIONS(4166),
    [anon_sym_sizeof] = ACTIONS(4164),
    [anon_sym___alignof__] = ACTIONS(4164),
    [anon_sym___alignof] = ACTIONS(4164),
    [anon_sym__alignof] = ACTIONS(4164),
    [anon_sym_alignof] = ACTIONS(4164),
    [anon_sym__Alignof] = ACTIONS(4164),
    [anon_sym_offsetof] = ACTIONS(4164),
    [anon_sym__Generic] = ACTIONS(4164),
    [anon_sym_asm] = ACTIONS(4164),
    [anon_sym___asm__] = ACTIONS(4164),
    [anon_sym___asm] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4164),
    [sym_number_literal] = ACTIONS(4166),
    [anon_sym_L_SQUOTE] = ACTIONS(4166),
    [anon_sym_u_SQUOTE] = ACTIONS(4166),
    [anon_sym_U_SQUOTE] = ACTIONS(4166),
    [anon_sym_u8_SQUOTE] = ACTIONS(4166),
    [anon_sym_SQUOTE] = ACTIONS(4166),
    [anon_sym_L_DQUOTE] = ACTIONS(4166),
    [anon_sym_u_DQUOTE] = ACTIONS(4166),
    [anon_sym_U_DQUOTE] = ACTIONS(4166),
    [anon_sym_u8_DQUOTE] = ACTIONS(4166),
    [anon_sym_DQUOTE] = ACTIONS(4166),
    [sym_true] = ACTIONS(4164),
    [sym_false] = ACTIONS(4164),
    [anon_sym_NULL] = ACTIONS(4164),
    [anon_sym_nullptr] = ACTIONS(4164),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4164),
    [anon_sym_let] = ACTIONS(4164),
    [anon_sym_This] = ACTIONS(4164),
    [anon_sym_decltype] = ACTIONS(4164),
    [anon_sym_explicit] = ACTIONS(4164),
    [anon_sym_typename] = ACTIONS(4164),
    [anon_sym_export] = ACTIONS(4164),
    [anon_sym_module] = ACTIONS(4164),
    [anon_sym_import] = ACTIONS(4164),
    [anon_sym_template] = ACTIONS(4164),
    [anon_sym_operator] = ACTIONS(4164),
    [anon_sym_try] = ACTIONS(4164),
    [anon_sym_delete] = ACTIONS(4164),
    [anon_sym_throw] = ACTIONS(4164),
    [anon_sym_namespace] = ACTIONS(4164),
    [anon_sym_static_assert] = ACTIONS(4164),
    [anon_sym_concept] = ACTIONS(4164),
    [anon_sym_co_return] = ACTIONS(4164),
    [anon_sym_co_yield] = ACTIONS(4164),
    [anon_sym_R_DQUOTE] = ACTIONS(4166),
    [anon_sym_LR_DQUOTE] = ACTIONS(4166),
    [anon_sym_uR_DQUOTE] = ACTIONS(4166),
    [anon_sym_UR_DQUOTE] = ACTIONS(4166),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4166),
    [anon_sym_co_await] = ACTIONS(4164),
    [anon_sym_new] = ACTIONS(4164),
    [anon_sym_requires] = ACTIONS(4164),
    [sym_this] = ACTIONS(4164),
    [anon_sym_precise] = ACTIONS(4164),
    [anon_sym_shared] = ACTIONS(4164),
    [anon_sym_groupshared] = ACTIONS(4164),
    [anon_sym_uniform] = ACTIONS(4164),
    [anon_sym_row_major] = ACTIONS(4164),
    [anon_sym_column_major] = ACTIONS(4164),
    [anon_sym_globallycoherent] = ACTIONS(4164),
    [anon_sym_centroid] = ACTIONS(4164),
    [anon_sym_noperspective] = ACTIONS(4164),
    [anon_sym_nointerpolation] = ACTIONS(4164),
    [anon_sym_sample] = ACTIONS(4164),
    [anon_sym_linear] = ACTIONS(4164),
    [anon_sym_snorm] = ACTIONS(4164),
    [anon_sym_unorm] = ACTIONS(4164),
    [anon_sym_point] = ACTIONS(4164),
    [anon_sym_line] = ACTIONS(4164),
    [anon_sym_triangleadj] = ACTIONS(4164),
    [anon_sym_lineadj] = ACTIONS(4164),
    [anon_sym_triangle] = ACTIONS(4164),
    [anon_sym_interface] = ACTIONS(4164),
    [anon_sym_extension] = ACTIONS(4164),
    [anon_sym___exported] = ACTIONS(4164),
  },
  [703] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(284),
    [ts_builtin_sym_end] = ACTIONS(4187),
    [sym_identifier] = ACTIONS(4185),
    [aux_sym_preproc_include_token1] = ACTIONS(4185),
    [aux_sym_preproc_def_token1] = ACTIONS(4185),
    [aux_sym_preproc_if_token1] = ACTIONS(4185),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4185),
    [sym_preproc_directive] = ACTIONS(4185),
    [anon_sym_LPAREN2] = ACTIONS(4187),
    [anon_sym_BANG] = ACTIONS(4187),
    [anon_sym_TILDE] = ACTIONS(4187),
    [anon_sym_DASH] = ACTIONS(4185),
    [anon_sym_PLUS] = ACTIONS(4185),
    [anon_sym_STAR] = ACTIONS(4187),
    [anon_sym_AMP_AMP] = ACTIONS(4187),
    [anon_sym_AMP] = ACTIONS(4185),
    [anon_sym_SEMI] = ACTIONS(4187),
    [anon_sym___extension__] = ACTIONS(4185),
    [anon_sym_typedef] = ACTIONS(4185),
    [anon_sym_in] = ACTIONS(4185),
    [anon_sym_out] = ACTIONS(4185),
    [anon_sym_inout] = ACTIONS(4185),
    [anon_sym_virtual] = ACTIONS(4185),
    [anon_sym_extern] = ACTIONS(4185),
    [anon_sym___attribute__] = ACTIONS(4185),
    [anon_sym___attribute] = ACTIONS(4185),
    [anon_sym_using] = ACTIONS(4185),
    [anon_sym_COLON_COLON] = ACTIONS(4187),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4187),
    [anon_sym___declspec] = ACTIONS(4185),
    [anon_sym___based] = ACTIONS(4185),
    [anon_sym___cdecl] = ACTIONS(4185),
    [anon_sym___clrcall] = ACTIONS(4185),
    [anon_sym___stdcall] = ACTIONS(4185),
    [anon_sym___fastcall] = ACTIONS(4185),
    [anon_sym___thiscall] = ACTIONS(4185),
    [anon_sym___vectorcall] = ACTIONS(4185),
    [anon_sym_LBRACE] = ACTIONS(4187),
    [anon_sym_signed] = ACTIONS(4205),
    [anon_sym_unsigned] = ACTIONS(4205),
    [anon_sym_long] = ACTIONS(4205),
    [anon_sym_short] = ACTIONS(4205),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [anon_sym_static] = ACTIONS(4185),
    [anon_sym_register] = ACTIONS(4185),
    [anon_sym_inline] = ACTIONS(4185),
    [anon_sym___inline] = ACTIONS(4185),
    [anon_sym___inline__] = ACTIONS(4185),
    [anon_sym___forceinline] = ACTIONS(4185),
    [anon_sym_thread_local] = ACTIONS(4185),
    [anon_sym___thread] = ACTIONS(4185),
    [anon_sym_const] = ACTIONS(4185),
    [anon_sym_constexpr] = ACTIONS(4185),
    [anon_sym_volatile] = ACTIONS(4185),
    [anon_sym_restrict] = ACTIONS(4185),
    [anon_sym___restrict__] = ACTIONS(4185),
    [anon_sym__Atomic] = ACTIONS(4185),
    [anon_sym__Noreturn] = ACTIONS(4185),
    [anon_sym_noreturn] = ACTIONS(4185),
    [anon_sym__Nonnull] = ACTIONS(4185),
    [anon_sym_mutable] = ACTIONS(4185),
    [anon_sym_constinit] = ACTIONS(4185),
    [anon_sym_consteval] = ACTIONS(4185),
    [anon_sym_alignas] = ACTIONS(4185),
    [anon_sym__Alignas] = ACTIONS(4185),
    [sym_primitive_type] = ACTIONS(4185),
    [anon_sym_enum] = ACTIONS(4185),
    [anon_sym_class] = ACTIONS(4185),
    [anon_sym_struct] = ACTIONS(4185),
    [anon_sym_union] = ACTIONS(4185),
    [anon_sym_if] = ACTIONS(4185),
    [anon_sym_switch] = ACTIONS(4185),
    [anon_sym_case] = ACTIONS(4185),
    [anon_sym_default] = ACTIONS(4185),
    [anon_sym_while] = ACTIONS(4185),
    [anon_sym_do] = ACTIONS(4185),
    [anon_sym_for] = ACTIONS(4185),
    [anon_sym_return] = ACTIONS(4185),
    [anon_sym_break] = ACTIONS(4185),
    [anon_sym_continue] = ACTIONS(4185),
    [anon_sym_goto] = ACTIONS(4185),
    [anon_sym_not] = ACTIONS(4185),
    [anon_sym_compl] = ACTIONS(4185),
    [anon_sym_DASH_DASH] = ACTIONS(4187),
    [anon_sym_PLUS_PLUS] = ACTIONS(4187),
    [anon_sym_sizeof] = ACTIONS(4185),
    [anon_sym___alignof__] = ACTIONS(4185),
    [anon_sym___alignof] = ACTIONS(4185),
    [anon_sym__alignof] = ACTIONS(4185),
    [anon_sym_alignof] = ACTIONS(4185),
    [anon_sym__Alignof] = ACTIONS(4185),
    [anon_sym_offsetof] = ACTIONS(4185),
    [anon_sym__Generic] = ACTIONS(4185),
    [anon_sym_asm] = ACTIONS(4185),
    [anon_sym___asm__] = ACTIONS(4185),
    [anon_sym___asm] = ACTIONS(4185),
    [anon_sym_DOT] = ACTIONS(4185),
    [sym_number_literal] = ACTIONS(4187),
    [anon_sym_L_SQUOTE] = ACTIONS(4187),
    [anon_sym_u_SQUOTE] = ACTIONS(4187),
    [anon_sym_U_SQUOTE] = ACTIONS(4187),
    [anon_sym_u8_SQUOTE] = ACTIONS(4187),
    [anon_sym_SQUOTE] = ACTIONS(4187),
    [anon_sym_L_DQUOTE] = ACTIONS(4187),
    [anon_sym_u_DQUOTE] = ACTIONS(4187),
    [anon_sym_U_DQUOTE] = ACTIONS(4187),
    [anon_sym_u8_DQUOTE] = ACTIONS(4187),
    [anon_sym_DQUOTE] = ACTIONS(4187),
    [sym_true] = ACTIONS(4185),
    [sym_false] = ACTIONS(4185),
    [anon_sym_NULL] = ACTIONS(4185),
    [anon_sym_nullptr] = ACTIONS(4185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4185),
    [anon_sym_let] = ACTIONS(4185),
    [anon_sym_This] = ACTIONS(4185),
    [anon_sym_decltype] = ACTIONS(4185),
    [anon_sym_explicit] = ACTIONS(4185),
    [anon_sym_typename] = ACTIONS(4185),
    [anon_sym_export] = ACTIONS(4185),
    [anon_sym_module] = ACTIONS(4185),
    [anon_sym_import] = ACTIONS(4185),
    [anon_sym_template] = ACTIONS(4185),
    [anon_sym_operator] = ACTIONS(4185),
    [anon_sym_try] = ACTIONS(4185),
    [anon_sym_delete] = ACTIONS(4185),
    [anon_sym_throw] = ACTIONS(4185),
    [anon_sym_namespace] = ACTIONS(4185),
    [anon_sym_static_assert] = ACTIONS(4185),
    [anon_sym_concept] = ACTIONS(4185),
    [anon_sym_co_return] = ACTIONS(4185),
    [anon_sym_co_yield] = ACTIONS(4185),
    [anon_sym_R_DQUOTE] = ACTIONS(4187),
    [anon_sym_LR_DQUOTE] = ACTIONS(4187),
    [anon_sym_uR_DQUOTE] = ACTIONS(4187),
    [anon_sym_UR_DQUOTE] = ACTIONS(4187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4187),
    [anon_sym_co_await] = ACTIONS(4185),
    [anon_sym_new] = ACTIONS(4185),
    [anon_sym_requires] = ACTIONS(4185),
    [sym_this] = ACTIONS(4185),
    [anon_sym_precise] = ACTIONS(4185),
    [anon_sym_shared] = ACTIONS(4185),
    [anon_sym_groupshared] = ACTIONS(4185),
    [anon_sym_uniform] = ACTIONS(4185),
    [anon_sym_row_major] = ACTIONS(4185),
    [anon_sym_column_major] = ACTIONS(4185),
    [anon_sym_globallycoherent] = ACTIONS(4185),
    [anon_sym_centroid] = ACTIONS(4185),
    [anon_sym_noperspective] = ACTIONS(4185),
    [anon_sym_nointerpolation] = ACTIONS(4185),
    [anon_sym_sample] = ACTIONS(4185),
    [anon_sym_linear] = ACTIONS(4185),
    [anon_sym_snorm] = ACTIONS(4185),
    [anon_sym_unorm] = ACTIONS(4185),
    [anon_sym_point] = ACTIONS(4185),
    [anon_sym_line] = ACTIONS(4185),
    [anon_sym_triangleadj] = ACTIONS(4185),
    [anon_sym_lineadj] = ACTIONS(4185),
    [anon_sym_triangle] = ACTIONS(4185),
    [anon_sym_interface] = ACTIONS(4185),
    [anon_sym_extension] = ACTIONS(4185),
    [anon_sym___exported] = ACTIONS(4185),
  },
  [704] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(672),
    [sym_identifier] = ACTIONS(4124),
    [aux_sym_preproc_include_token1] = ACTIONS(4124),
    [aux_sym_preproc_def_token1] = ACTIONS(4124),
    [aux_sym_preproc_if_token1] = ACTIONS(4124),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4124),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4124),
    [sym_preproc_directive] = ACTIONS(4124),
    [anon_sym_LPAREN2] = ACTIONS(4121),
    [anon_sym_BANG] = ACTIONS(4121),
    [anon_sym_TILDE] = ACTIONS(4121),
    [anon_sym_DASH] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4124),
    [anon_sym_STAR] = ACTIONS(4121),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_AMP] = ACTIONS(4124),
    [anon_sym_SEMI] = ACTIONS(4121),
    [anon_sym___extension__] = ACTIONS(4124),
    [anon_sym_typedef] = ACTIONS(4124),
    [anon_sym_in] = ACTIONS(4124),
    [anon_sym_out] = ACTIONS(4124),
    [anon_sym_inout] = ACTIONS(4124),
    [anon_sym_virtual] = ACTIONS(4124),
    [anon_sym_extern] = ACTIONS(4124),
    [anon_sym___attribute__] = ACTIONS(4124),
    [anon_sym___attribute] = ACTIONS(4124),
    [anon_sym_using] = ACTIONS(4124),
    [anon_sym_COLON_COLON] = ACTIONS(4121),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4121),
    [anon_sym___declspec] = ACTIONS(4124),
    [anon_sym___based] = ACTIONS(4124),
    [anon_sym___cdecl] = ACTIONS(4124),
    [anon_sym___clrcall] = ACTIONS(4124),
    [anon_sym___stdcall] = ACTIONS(4124),
    [anon_sym___fastcall] = ACTIONS(4124),
    [anon_sym___thiscall] = ACTIONS(4124),
    [anon_sym___vectorcall] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_RBRACE] = ACTIONS(4121),
    [anon_sym_signed] = ACTIONS(4208),
    [anon_sym_unsigned] = ACTIONS(4208),
    [anon_sym_long] = ACTIONS(4208),
    [anon_sym_short] = ACTIONS(4208),
    [anon_sym_LBRACK] = ACTIONS(4124),
    [anon_sym_static] = ACTIONS(4124),
    [anon_sym_register] = ACTIONS(4124),
    [anon_sym_inline] = ACTIONS(4124),
    [anon_sym___inline] = ACTIONS(4124),
    [anon_sym___inline__] = ACTIONS(4124),
    [anon_sym___forceinline] = ACTIONS(4124),
    [anon_sym_thread_local] = ACTIONS(4124),
    [anon_sym___thread] = ACTIONS(4124),
    [anon_sym_const] = ACTIONS(4124),
    [anon_sym_constexpr] = ACTIONS(4124),
    [anon_sym_volatile] = ACTIONS(4124),
    [anon_sym_restrict] = ACTIONS(4124),
    [anon_sym___restrict__] = ACTIONS(4124),
    [anon_sym__Atomic] = ACTIONS(4124),
    [anon_sym__Noreturn] = ACTIONS(4124),
    [anon_sym_noreturn] = ACTIONS(4124),
    [anon_sym__Nonnull] = ACTIONS(4124),
    [anon_sym_mutable] = ACTIONS(4124),
    [anon_sym_constinit] = ACTIONS(4124),
    [anon_sym_consteval] = ACTIONS(4124),
    [anon_sym_alignas] = ACTIONS(4124),
    [anon_sym__Alignas] = ACTIONS(4124),
    [sym_primitive_type] = ACTIONS(4124),
    [anon_sym_enum] = ACTIONS(4124),
    [anon_sym_class] = ACTIONS(4124),
    [anon_sym_struct] = ACTIONS(4124),
    [anon_sym_union] = ACTIONS(4124),
    [anon_sym_if] = ACTIONS(4124),
    [anon_sym_switch] = ACTIONS(4124),
    [anon_sym_case] = ACTIONS(4124),
    [anon_sym_default] = ACTIONS(4124),
    [anon_sym_while] = ACTIONS(4124),
    [anon_sym_do] = ACTIONS(4124),
    [anon_sym_for] = ACTIONS(4124),
    [anon_sym_return] = ACTIONS(4124),
    [anon_sym_break] = ACTIONS(4124),
    [anon_sym_continue] = ACTIONS(4124),
    [anon_sym_goto] = ACTIONS(4124),
    [anon_sym___try] = ACTIONS(4124),
    [anon_sym___leave] = ACTIONS(4124),
    [anon_sym_not] = ACTIONS(4124),
    [anon_sym_compl] = ACTIONS(4124),
    [anon_sym_DASH_DASH] = ACTIONS(4121),
    [anon_sym_PLUS_PLUS] = ACTIONS(4121),
    [anon_sym_sizeof] = ACTIONS(4124),
    [anon_sym___alignof__] = ACTIONS(4124),
    [anon_sym___alignof] = ACTIONS(4124),
    [anon_sym__alignof] = ACTIONS(4124),
    [anon_sym_alignof] = ACTIONS(4124),
    [anon_sym__Alignof] = ACTIONS(4124),
    [anon_sym_offsetof] = ACTIONS(4124),
    [anon_sym__Generic] = ACTIONS(4124),
    [anon_sym_asm] = ACTIONS(4124),
    [anon_sym___asm__] = ACTIONS(4124),
    [anon_sym___asm] = ACTIONS(4124),
    [anon_sym_DOT] = ACTIONS(4124),
    [sym_number_literal] = ACTIONS(4121),
    [anon_sym_L_SQUOTE] = ACTIONS(4121),
    [anon_sym_u_SQUOTE] = ACTIONS(4121),
    [anon_sym_U_SQUOTE] = ACTIONS(4121),
    [anon_sym_u8_SQUOTE] = ACTIONS(4121),
    [anon_sym_SQUOTE] = ACTIONS(4121),
    [anon_sym_L_DQUOTE] = ACTIONS(4121),
    [anon_sym_u_DQUOTE] = ACTIONS(4121),
    [anon_sym_U_DQUOTE] = ACTIONS(4121),
    [anon_sym_u8_DQUOTE] = ACTIONS(4121),
    [anon_sym_DQUOTE] = ACTIONS(4121),
    [sym_true] = ACTIONS(4124),
    [sym_false] = ACTIONS(4124),
    [anon_sym_NULL] = ACTIONS(4124),
    [anon_sym_nullptr] = ACTIONS(4124),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4124),
    [anon_sym_let] = ACTIONS(4124),
    [anon_sym_This] = ACTIONS(4124),
    [anon_sym_decltype] = ACTIONS(4124),
    [anon_sym_explicit] = ACTIONS(4124),
    [anon_sym_typename] = ACTIONS(4124),
    [anon_sym_template] = ACTIONS(4124),
    [anon_sym_operator] = ACTIONS(4124),
    [anon_sym_try] = ACTIONS(4124),
    [anon_sym_delete] = ACTIONS(4124),
    [anon_sym_throw] = ACTIONS(4124),
    [anon_sym_namespace] = ACTIONS(4124),
    [anon_sym_static_assert] = ACTIONS(4124),
    [anon_sym_concept] = ACTIONS(4124),
    [anon_sym_co_return] = ACTIONS(4124),
    [anon_sym_co_yield] = ACTIONS(4124),
    [anon_sym_R_DQUOTE] = ACTIONS(4121),
    [anon_sym_LR_DQUOTE] = ACTIONS(4121),
    [anon_sym_uR_DQUOTE] = ACTIONS(4121),
    [anon_sym_UR_DQUOTE] = ACTIONS(4121),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4121),
    [anon_sym_co_await] = ACTIONS(4124),
    [anon_sym_new] = ACTIONS(4124),
    [anon_sym_requires] = ACTIONS(4124),
    [sym_this] = ACTIONS(4124),
    [anon_sym_discard] = ACTIONS(4124),
    [anon_sym_precise] = ACTIONS(4124),
    [anon_sym_shared] = ACTIONS(4124),
    [anon_sym_groupshared] = ACTIONS(4124),
    [anon_sym_uniform] = ACTIONS(4124),
    [anon_sym_row_major] = ACTIONS(4124),
    [anon_sym_column_major] = ACTIONS(4124),
    [anon_sym_globallycoherent] = ACTIONS(4124),
    [anon_sym_centroid] = ACTIONS(4124),
    [anon_sym_noperspective] = ACTIONS(4124),
    [anon_sym_nointerpolation] = ACTIONS(4124),
    [anon_sym_sample] = ACTIONS(4124),
    [anon_sym_linear] = ACTIONS(4124),
    [anon_sym_snorm] = ACTIONS(4124),
    [anon_sym_unorm] = ACTIONS(4124),
    [anon_sym_point] = ACTIONS(4124),
    [anon_sym_line] = ACTIONS(4124),
    [anon_sym_triangleadj] = ACTIONS(4124),
    [anon_sym_lineadj] = ACTIONS(4124),
    [anon_sym_triangle] = ACTIONS(4124),
    [anon_sym_cbuffer] = ACTIONS(4124),
    [anon_sym_interface] = ACTIONS(4124),
    [anon_sym_extension] = ACTIONS(4124),
  },
  [705] = {
    [sym_identifier] = ACTIONS(2554),
    [aux_sym_preproc_include_token1] = ACTIONS(2554),
    [aux_sym_preproc_def_token1] = ACTIONS(2554),
    [aux_sym_preproc_if_token1] = ACTIONS(2554),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2554),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2554),
    [sym_preproc_directive] = ACTIONS(2554),
    [anon_sym_LPAREN2] = ACTIONS(2552),
    [anon_sym_BANG] = ACTIONS(2552),
    [anon_sym_TILDE] = ACTIONS(2552),
    [anon_sym_DASH] = ACTIONS(2554),
    [anon_sym_PLUS] = ACTIONS(2554),
    [anon_sym_STAR] = ACTIONS(2552),
    [anon_sym_AMP_AMP] = ACTIONS(2552),
    [anon_sym_AMP] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym___extension__] = ACTIONS(2554),
    [anon_sym_typedef] = ACTIONS(2554),
    [anon_sym_in] = ACTIONS(2554),
    [anon_sym_out] = ACTIONS(2554),
    [anon_sym_inout] = ACTIONS(2554),
    [anon_sym_virtual] = ACTIONS(2554),
    [anon_sym_extern] = ACTIONS(2554),
    [anon_sym___attribute__] = ACTIONS(2554),
    [anon_sym___attribute] = ACTIONS(2554),
    [anon_sym_using] = ACTIONS(2554),
    [anon_sym_COLON_COLON] = ACTIONS(2552),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2552),
    [anon_sym___declspec] = ACTIONS(2554),
    [anon_sym___based] = ACTIONS(2554),
    [anon_sym___cdecl] = ACTIONS(2554),
    [anon_sym___clrcall] = ACTIONS(2554),
    [anon_sym___stdcall] = ACTIONS(2554),
    [anon_sym___fastcall] = ACTIONS(2554),
    [anon_sym___thiscall] = ACTIONS(2554),
    [anon_sym___vectorcall] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(2552),
    [anon_sym_RBRACE] = ACTIONS(2552),
    [anon_sym_signed] = ACTIONS(2554),
    [anon_sym_unsigned] = ACTIONS(2554),
    [anon_sym_long] = ACTIONS(2554),
    [anon_sym_short] = ACTIONS(2554),
    [anon_sym_LBRACK] = ACTIONS(2554),
    [anon_sym_static] = ACTIONS(2554),
    [anon_sym_register] = ACTIONS(2554),
    [anon_sym_inline] = ACTIONS(2554),
    [anon_sym___inline] = ACTIONS(2554),
    [anon_sym___inline__] = ACTIONS(2554),
    [anon_sym___forceinline] = ACTIONS(2554),
    [anon_sym_thread_local] = ACTIONS(2554),
    [anon_sym___thread] = ACTIONS(2554),
    [anon_sym_const] = ACTIONS(2554),
    [anon_sym_constexpr] = ACTIONS(2554),
    [anon_sym_volatile] = ACTIONS(2554),
    [anon_sym_restrict] = ACTIONS(2554),
    [anon_sym___restrict__] = ACTIONS(2554),
    [anon_sym__Atomic] = ACTIONS(2554),
    [anon_sym__Noreturn] = ACTIONS(2554),
    [anon_sym_noreturn] = ACTIONS(2554),
    [anon_sym__Nonnull] = ACTIONS(2554),
    [anon_sym_mutable] = ACTIONS(2554),
    [anon_sym_constinit] = ACTIONS(2554),
    [anon_sym_consteval] = ACTIONS(2554),
    [anon_sym_alignas] = ACTIONS(2554),
    [anon_sym__Alignas] = ACTIONS(2554),
    [sym_primitive_type] = ACTIONS(2554),
    [anon_sym_enum] = ACTIONS(2554),
    [anon_sym_class] = ACTIONS(2554),
    [anon_sym_struct] = ACTIONS(2554),
    [anon_sym_union] = ACTIONS(2554),
    [anon_sym_if] = ACTIONS(2554),
    [anon_sym_else] = ACTIONS(2554),
    [anon_sym_switch] = ACTIONS(2554),
    [anon_sym_case] = ACTIONS(2554),
    [anon_sym_default] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2554),
    [anon_sym_do] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2554),
    [anon_sym_return] = ACTIONS(2554),
    [anon_sym_break] = ACTIONS(2554),
    [anon_sym_continue] = ACTIONS(2554),
    [anon_sym_goto] = ACTIONS(2554),
    [anon_sym___try] = ACTIONS(2554),
    [anon_sym___leave] = ACTIONS(2554),
    [anon_sym_not] = ACTIONS(2554),
    [anon_sym_compl] = ACTIONS(2554),
    [anon_sym_DASH_DASH] = ACTIONS(2552),
    [anon_sym_PLUS_PLUS] = ACTIONS(2552),
    [anon_sym_sizeof] = ACTIONS(2554),
    [anon_sym___alignof__] = ACTIONS(2554),
    [anon_sym___alignof] = ACTIONS(2554),
    [anon_sym__alignof] = ACTIONS(2554),
    [anon_sym_alignof] = ACTIONS(2554),
    [anon_sym__Alignof] = ACTIONS(2554),
    [anon_sym_offsetof] = ACTIONS(2554),
    [anon_sym__Generic] = ACTIONS(2554),
    [anon_sym_asm] = ACTIONS(2554),
    [anon_sym___asm__] = ACTIONS(2554),
    [anon_sym___asm] = ACTIONS(2554),
    [anon_sym_DOT] = ACTIONS(2554),
    [sym_number_literal] = ACTIONS(2552),
    [anon_sym_L_SQUOTE] = ACTIONS(2552),
    [anon_sym_u_SQUOTE] = ACTIONS(2552),
    [anon_sym_U_SQUOTE] = ACTIONS(2552),
    [anon_sym_u8_SQUOTE] = ACTIONS(2552),
    [anon_sym_SQUOTE] = ACTIONS(2552),
    [anon_sym_L_DQUOTE] = ACTIONS(2552),
    [anon_sym_u_DQUOTE] = ACTIONS(2552),
    [anon_sym_U_DQUOTE] = ACTIONS(2552),
    [anon_sym_u8_DQUOTE] = ACTIONS(2552),
    [anon_sym_DQUOTE] = ACTIONS(2552),
    [sym_true] = ACTIONS(2554),
    [sym_false] = ACTIONS(2554),
    [anon_sym_NULL] = ACTIONS(2554),
    [anon_sym_nullptr] = ACTIONS(2554),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2554),
    [anon_sym_let] = ACTIONS(2554),
    [anon_sym_This] = ACTIONS(2554),
    [anon_sym_decltype] = ACTIONS(2554),
    [anon_sym_explicit] = ACTIONS(2554),
    [anon_sym_typename] = ACTIONS(2554),
    [anon_sym_template] = ACTIONS(2554),
    [anon_sym_operator] = ACTIONS(2554),
    [anon_sym_try] = ACTIONS(2554),
    [anon_sym_delete] = ACTIONS(2554),
    [anon_sym_throw] = ACTIONS(2554),
    [anon_sym_namespace] = ACTIONS(2554),
    [anon_sym_static_assert] = ACTIONS(2554),
    [anon_sym_concept] = ACTIONS(2554),
    [anon_sym_co_return] = ACTIONS(2554),
    [anon_sym_co_yield] = ACTIONS(2554),
    [anon_sym_R_DQUOTE] = ACTIONS(2552),
    [anon_sym_LR_DQUOTE] = ACTIONS(2552),
    [anon_sym_uR_DQUOTE] = ACTIONS(2552),
    [anon_sym_UR_DQUOTE] = ACTIONS(2552),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2552),
    [anon_sym_co_await] = ACTIONS(2554),
    [anon_sym_new] = ACTIONS(2554),
    [anon_sym_requires] = ACTIONS(2554),
    [sym_this] = ACTIONS(2554),
    [anon_sym_discard] = ACTIONS(2554),
    [anon_sym_precise] = ACTIONS(2554),
    [anon_sym_shared] = ACTIONS(2554),
    [anon_sym_groupshared] = ACTIONS(2554),
    [anon_sym_uniform] = ACTIONS(2554),
    [anon_sym_row_major] = ACTIONS(2554),
    [anon_sym_column_major] = ACTIONS(2554),
    [anon_sym_globallycoherent] = ACTIONS(2554),
    [anon_sym_centroid] = ACTIONS(2554),
    [anon_sym_noperspective] = ACTIONS(2554),
    [anon_sym_nointerpolation] = ACTIONS(2554),
    [anon_sym_sample] = ACTIONS(2554),
    [anon_sym_linear] = ACTIONS(2554),
    [anon_sym_snorm] = ACTIONS(2554),
    [anon_sym_unorm] = ACTIONS(2554),
    [anon_sym_point] = ACTIONS(2554),
    [anon_sym_line] = ACTIONS(2554),
    [anon_sym_triangleadj] = ACTIONS(2554),
    [anon_sym_lineadj] = ACTIONS(2554),
    [anon_sym_triangle] = ACTIONS(2554),
    [anon_sym_cbuffer] = ACTIONS(2554),
    [anon_sym_interface] = ACTIONS(2554),
    [anon_sym_extension] = ACTIONS(2554),
  },
  [706] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(661),
    [ts_builtin_sym_end] = ACTIONS(4180),
    [sym_identifier] = ACTIONS(4178),
    [aux_sym_preproc_include_token1] = ACTIONS(4178),
    [aux_sym_preproc_def_token1] = ACTIONS(4178),
    [aux_sym_preproc_if_token1] = ACTIONS(4178),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4178),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4178),
    [sym_preproc_directive] = ACTIONS(4178),
    [anon_sym_LPAREN2] = ACTIONS(4180),
    [anon_sym_BANG] = ACTIONS(4180),
    [anon_sym_TILDE] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4178),
    [anon_sym_PLUS] = ACTIONS(4178),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_AMP] = ACTIONS(4178),
    [anon_sym_SEMI] = ACTIONS(4180),
    [anon_sym___extension__] = ACTIONS(4178),
    [anon_sym_typedef] = ACTIONS(4178),
    [anon_sym_in] = ACTIONS(4178),
    [anon_sym_out] = ACTIONS(4178),
    [anon_sym_inout] = ACTIONS(4178),
    [anon_sym_virtual] = ACTIONS(4178),
    [anon_sym_extern] = ACTIONS(4178),
    [anon_sym___attribute__] = ACTIONS(4178),
    [anon_sym___attribute] = ACTIONS(4178),
    [anon_sym_using] = ACTIONS(4178),
    [anon_sym_COLON_COLON] = ACTIONS(4180),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4180),
    [anon_sym___declspec] = ACTIONS(4178),
    [anon_sym___based] = ACTIONS(4178),
    [anon_sym___cdecl] = ACTIONS(4178),
    [anon_sym___clrcall] = ACTIONS(4178),
    [anon_sym___stdcall] = ACTIONS(4178),
    [anon_sym___fastcall] = ACTIONS(4178),
    [anon_sym___thiscall] = ACTIONS(4178),
    [anon_sym___vectorcall] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_signed] = ACTIONS(4212),
    [anon_sym_unsigned] = ACTIONS(4212),
    [anon_sym_long] = ACTIONS(4212),
    [anon_sym_short] = ACTIONS(4212),
    [anon_sym_LBRACK] = ACTIONS(4178),
    [anon_sym_static] = ACTIONS(4178),
    [anon_sym_register] = ACTIONS(4178),
    [anon_sym_inline] = ACTIONS(4178),
    [anon_sym___inline] = ACTIONS(4178),
    [anon_sym___inline__] = ACTIONS(4178),
    [anon_sym___forceinline] = ACTIONS(4178),
    [anon_sym_thread_local] = ACTIONS(4178),
    [anon_sym___thread] = ACTIONS(4178),
    [anon_sym_const] = ACTIONS(4178),
    [anon_sym_constexpr] = ACTIONS(4178),
    [anon_sym_volatile] = ACTIONS(4178),
    [anon_sym_restrict] = ACTIONS(4178),
    [anon_sym___restrict__] = ACTIONS(4178),
    [anon_sym__Atomic] = ACTIONS(4178),
    [anon_sym__Noreturn] = ACTIONS(4178),
    [anon_sym_noreturn] = ACTIONS(4178),
    [anon_sym__Nonnull] = ACTIONS(4178),
    [anon_sym_mutable] = ACTIONS(4178),
    [anon_sym_constinit] = ACTIONS(4178),
    [anon_sym_consteval] = ACTIONS(4178),
    [anon_sym_alignas] = ACTIONS(4178),
    [anon_sym__Alignas] = ACTIONS(4178),
    [sym_primitive_type] = ACTIONS(4178),
    [anon_sym_enum] = ACTIONS(4178),
    [anon_sym_class] = ACTIONS(4178),
    [anon_sym_struct] = ACTIONS(4178),
    [anon_sym_union] = ACTIONS(4178),
    [anon_sym_if] = ACTIONS(4178),
    [anon_sym_switch] = ACTIONS(4178),
    [anon_sym_case] = ACTIONS(4178),
    [anon_sym_default] = ACTIONS(4178),
    [anon_sym_while] = ACTIONS(4178),
    [anon_sym_do] = ACTIONS(4178),
    [anon_sym_for] = ACTIONS(4178),
    [anon_sym_return] = ACTIONS(4178),
    [anon_sym_break] = ACTIONS(4178),
    [anon_sym_continue] = ACTIONS(4178),
    [anon_sym_goto] = ACTIONS(4178),
    [anon_sym_not] = ACTIONS(4178),
    [anon_sym_compl] = ACTIONS(4178),
    [anon_sym_DASH_DASH] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4180),
    [anon_sym_sizeof] = ACTIONS(4178),
    [anon_sym___alignof__] = ACTIONS(4178),
    [anon_sym___alignof] = ACTIONS(4178),
    [anon_sym__alignof] = ACTIONS(4178),
    [anon_sym_alignof] = ACTIONS(4178),
    [anon_sym__Alignof] = ACTIONS(4178),
    [anon_sym_offsetof] = ACTIONS(4178),
    [anon_sym__Generic] = ACTIONS(4178),
    [anon_sym_asm] = ACTIONS(4178),
    [anon_sym___asm__] = ACTIONS(4178),
    [anon_sym___asm] = ACTIONS(4178),
    [anon_sym_DOT] = ACTIONS(4178),
    [sym_number_literal] = ACTIONS(4180),
    [anon_sym_L_SQUOTE] = ACTIONS(4180),
    [anon_sym_u_SQUOTE] = ACTIONS(4180),
    [anon_sym_U_SQUOTE] = ACTIONS(4180),
    [anon_sym_u8_SQUOTE] = ACTIONS(4180),
    [anon_sym_SQUOTE] = ACTIONS(4180),
    [anon_sym_L_DQUOTE] = ACTIONS(4180),
    [anon_sym_u_DQUOTE] = ACTIONS(4180),
    [anon_sym_U_DQUOTE] = ACTIONS(4180),
    [anon_sym_u8_DQUOTE] = ACTIONS(4180),
    [anon_sym_DQUOTE] = ACTIONS(4180),
    [sym_true] = ACTIONS(4178),
    [sym_false] = ACTIONS(4178),
    [anon_sym_NULL] = ACTIONS(4178),
    [anon_sym_nullptr] = ACTIONS(4178),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4178),
    [anon_sym_let] = ACTIONS(4178),
    [anon_sym_This] = ACTIONS(4178),
    [anon_sym_decltype] = ACTIONS(4178),
    [anon_sym_explicit] = ACTIONS(4178),
    [anon_sym_typename] = ACTIONS(4178),
    [anon_sym_export] = ACTIONS(4178),
    [anon_sym_module] = ACTIONS(4178),
    [anon_sym_import] = ACTIONS(4178),
    [anon_sym_template] = ACTIONS(4178),
    [anon_sym_operator] = ACTIONS(4178),
    [anon_sym_try] = ACTIONS(4178),
    [anon_sym_delete] = ACTIONS(4178),
    [anon_sym_throw] = ACTIONS(4178),
    [anon_sym_namespace] = ACTIONS(4178),
    [anon_sym_static_assert] = ACTIONS(4178),
    [anon_sym_concept] = ACTIONS(4178),
    [anon_sym_co_return] = ACTIONS(4178),
    [anon_sym_co_yield] = ACTIONS(4178),
    [anon_sym_R_DQUOTE] = ACTIONS(4180),
    [anon_sym_LR_DQUOTE] = ACTIONS(4180),
    [anon_sym_uR_DQUOTE] = ACTIONS(4180),
    [anon_sym_UR_DQUOTE] = ACTIONS(4180),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4180),
    [anon_sym_co_await] = ACTIONS(4178),
    [anon_sym_new] = ACTIONS(4178),
    [anon_sym_requires] = ACTIONS(4178),
    [sym_this] = ACTIONS(4178),
    [anon_sym_precise] = ACTIONS(4178),
    [anon_sym_shared] = ACTIONS(4178),
    [anon_sym_groupshared] = ACTIONS(4178),
    [anon_sym_uniform] = ACTIONS(4178),
    [anon_sym_row_major] = ACTIONS(4178),
    [anon_sym_column_major] = ACTIONS(4178),
    [anon_sym_globallycoherent] = ACTIONS(4178),
    [anon_sym_centroid] = ACTIONS(4178),
    [anon_sym_noperspective] = ACTIONS(4178),
    [anon_sym_nointerpolation] = ACTIONS(4178),
    [anon_sym_sample] = ACTIONS(4178),
    [anon_sym_linear] = ACTIONS(4178),
    [anon_sym_snorm] = ACTIONS(4178),
    [anon_sym_unorm] = ACTIONS(4178),
    [anon_sym_point] = ACTIONS(4178),
    [anon_sym_line] = ACTIONS(4178),
    [anon_sym_triangleadj] = ACTIONS(4178),
    [anon_sym_lineadj] = ACTIONS(4178),
    [anon_sym_triangle] = ACTIONS(4178),
    [anon_sym_interface] = ACTIONS(4178),
    [anon_sym_extension] = ACTIONS(4178),
    [anon_sym___exported] = ACTIONS(4178),
  },
  [707] = {
    [sym_attribute_specifier] = STATE(788),
    [sym_identifier] = ACTIONS(4156),
    [aux_sym_preproc_include_token1] = ACTIONS(4156),
    [aux_sym_preproc_def_token1] = ACTIONS(4156),
    [aux_sym_preproc_if_token1] = ACTIONS(4156),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4156),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4156),
    [sym_preproc_directive] = ACTIONS(4156),
    [anon_sym_LPAREN2] = ACTIONS(4154),
    [anon_sym_BANG] = ACTIONS(4154),
    [anon_sym_TILDE] = ACTIONS(4154),
    [anon_sym_DASH] = ACTIONS(4156),
    [anon_sym_PLUS] = ACTIONS(4156),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_AMP_AMP] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4156),
    [anon_sym_SEMI] = ACTIONS(4154),
    [anon_sym___extension__] = ACTIONS(4156),
    [anon_sym_typedef] = ACTIONS(4156),
    [anon_sym_in] = ACTIONS(4156),
    [anon_sym_out] = ACTIONS(4156),
    [anon_sym_inout] = ACTIONS(4156),
    [anon_sym_virtual] = ACTIONS(4156),
    [anon_sym_extern] = ACTIONS(4156),
    [anon_sym___attribute__] = ACTIONS(2897),
    [anon_sym___attribute] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(4156),
    [anon_sym_COLON_COLON] = ACTIONS(4154),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4154),
    [anon_sym___declspec] = ACTIONS(4156),
    [anon_sym___based] = ACTIONS(4156),
    [anon_sym___cdecl] = ACTIONS(4156),
    [anon_sym___clrcall] = ACTIONS(4156),
    [anon_sym___stdcall] = ACTIONS(4156),
    [anon_sym___fastcall] = ACTIONS(4156),
    [anon_sym___thiscall] = ACTIONS(4156),
    [anon_sym___vectorcall] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4154),
    [anon_sym_RBRACE] = ACTIONS(4154),
    [anon_sym_signed] = ACTIONS(4156),
    [anon_sym_unsigned] = ACTIONS(4156),
    [anon_sym_long] = ACTIONS(4156),
    [anon_sym_short] = ACTIONS(4156),
    [anon_sym_LBRACK] = ACTIONS(4156),
    [anon_sym_static] = ACTIONS(4156),
    [anon_sym_register] = ACTIONS(4156),
    [anon_sym_inline] = ACTIONS(4156),
    [anon_sym___inline] = ACTIONS(4156),
    [anon_sym___inline__] = ACTIONS(4156),
    [anon_sym___forceinline] = ACTIONS(4156),
    [anon_sym_thread_local] = ACTIONS(4156),
    [anon_sym___thread] = ACTIONS(4156),
    [anon_sym_const] = ACTIONS(4156),
    [anon_sym_constexpr] = ACTIONS(4156),
    [anon_sym_volatile] = ACTIONS(4156),
    [anon_sym_restrict] = ACTIONS(4156),
    [anon_sym___restrict__] = ACTIONS(4156),
    [anon_sym__Atomic] = ACTIONS(4156),
    [anon_sym__Noreturn] = ACTIONS(4156),
    [anon_sym_noreturn] = ACTIONS(4156),
    [anon_sym__Nonnull] = ACTIONS(4156),
    [anon_sym_mutable] = ACTIONS(4156),
    [anon_sym_constinit] = ACTIONS(4156),
    [anon_sym_consteval] = ACTIONS(4156),
    [anon_sym_alignas] = ACTIONS(4156),
    [anon_sym__Alignas] = ACTIONS(4156),
    [sym_primitive_type] = ACTIONS(4156),
    [anon_sym_enum] = ACTIONS(4156),
    [anon_sym_class] = ACTIONS(4156),
    [anon_sym_struct] = ACTIONS(4156),
    [anon_sym_union] = ACTIONS(4156),
    [anon_sym_if] = ACTIONS(4156),
    [anon_sym_switch] = ACTIONS(4156),
    [anon_sym_case] = ACTIONS(4156),
    [anon_sym_default] = ACTIONS(4156),
    [anon_sym_while] = ACTIONS(4156),
    [anon_sym_do] = ACTIONS(4156),
    [anon_sym_for] = ACTIONS(4156),
    [anon_sym_return] = ACTIONS(4156),
    [anon_sym_break] = ACTIONS(4156),
    [anon_sym_continue] = ACTIONS(4156),
    [anon_sym_goto] = ACTIONS(4156),
    [anon_sym___try] = ACTIONS(4156),
    [anon_sym___leave] = ACTIONS(4156),
    [anon_sym_not] = ACTIONS(4156),
    [anon_sym_compl] = ACTIONS(4156),
    [anon_sym_DASH_DASH] = ACTIONS(4154),
    [anon_sym_PLUS_PLUS] = ACTIONS(4154),
    [anon_sym_sizeof] = ACTIONS(4156),
    [anon_sym___alignof__] = ACTIONS(4156),
    [anon_sym___alignof] = ACTIONS(4156),
    [anon_sym__alignof] = ACTIONS(4156),
    [anon_sym_alignof] = ACTIONS(4156),
    [anon_sym__Alignof] = ACTIONS(4156),
    [anon_sym_offsetof] = ACTIONS(4156),
    [anon_sym__Generic] = ACTIONS(4156),
    [anon_sym_asm] = ACTIONS(4156),
    [anon_sym___asm__] = ACTIONS(4156),
    [anon_sym___asm] = ACTIONS(4156),
    [anon_sym_DOT] = ACTIONS(4156),
    [sym_number_literal] = ACTIONS(4154),
    [anon_sym_L_SQUOTE] = ACTIONS(4154),
    [anon_sym_u_SQUOTE] = ACTIONS(4154),
    [anon_sym_U_SQUOTE] = ACTIONS(4154),
    [anon_sym_u8_SQUOTE] = ACTIONS(4154),
    [anon_sym_SQUOTE] = ACTIONS(4154),
    [anon_sym_L_DQUOTE] = ACTIONS(4154),
    [anon_sym_u_DQUOTE] = ACTIONS(4154),
    [anon_sym_U_DQUOTE] = ACTIONS(4154),
    [anon_sym_u8_DQUOTE] = ACTIONS(4154),
    [anon_sym_DQUOTE] = ACTIONS(4154),
    [sym_true] = ACTIONS(4156),
    [sym_false] = ACTIONS(4156),
    [anon_sym_NULL] = ACTIONS(4156),
    [anon_sym_nullptr] = ACTIONS(4156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4156),
    [anon_sym_let] = ACTIONS(4156),
    [anon_sym_This] = ACTIONS(4156),
    [anon_sym_decltype] = ACTIONS(4156),
    [anon_sym_explicit] = ACTIONS(4156),
    [anon_sym_typename] = ACTIONS(4156),
    [anon_sym_template] = ACTIONS(4156),
    [anon_sym_operator] = ACTIONS(4156),
    [anon_sym_try] = ACTIONS(4156),
    [anon_sym_delete] = ACTIONS(4156),
    [anon_sym_throw] = ACTIONS(4156),
    [anon_sym_namespace] = ACTIONS(4156),
    [anon_sym_static_assert] = ACTIONS(4156),
    [anon_sym_concept] = ACTIONS(4156),
    [anon_sym_co_return] = ACTIONS(4156),
    [anon_sym_co_yield] = ACTIONS(4156),
    [anon_sym_R_DQUOTE] = ACTIONS(4154),
    [anon_sym_LR_DQUOTE] = ACTIONS(4154),
    [anon_sym_uR_DQUOTE] = ACTIONS(4154),
    [anon_sym_UR_DQUOTE] = ACTIONS(4154),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4154),
    [anon_sym_co_await] = ACTIONS(4156),
    [anon_sym_new] = ACTIONS(4156),
    [anon_sym_requires] = ACTIONS(4156),
    [sym_this] = ACTIONS(4156),
    [anon_sym_discard] = ACTIONS(4156),
    [anon_sym_precise] = ACTIONS(4156),
    [anon_sym_shared] = ACTIONS(4156),
    [anon_sym_groupshared] = ACTIONS(4156),
    [anon_sym_uniform] = ACTIONS(4156),
    [anon_sym_row_major] = ACTIONS(4156),
    [anon_sym_column_major] = ACTIONS(4156),
    [anon_sym_globallycoherent] = ACTIONS(4156),
    [anon_sym_centroid] = ACTIONS(4156),
    [anon_sym_noperspective] = ACTIONS(4156),
    [anon_sym_nointerpolation] = ACTIONS(4156),
    [anon_sym_sample] = ACTIONS(4156),
    [anon_sym_linear] = ACTIONS(4156),
    [anon_sym_snorm] = ACTIONS(4156),
    [anon_sym_unorm] = ACTIONS(4156),
    [anon_sym_point] = ACTIONS(4156),
    [anon_sym_line] = ACTIONS(4156),
    [anon_sym_triangleadj] = ACTIONS(4156),
    [anon_sym_lineadj] = ACTIONS(4156),
    [anon_sym_triangle] = ACTIONS(4156),
    [anon_sym_cbuffer] = ACTIONS(4156),
    [anon_sym_interface] = ACTIONS(4156),
    [anon_sym_extension] = ACTIONS(4156),
  },
  [708] = {
    [sym_attribute_specifier] = STATE(768),
    [sym_identifier] = ACTIONS(4004),
    [aux_sym_preproc_include_token1] = ACTIONS(4004),
    [aux_sym_preproc_def_token1] = ACTIONS(4004),
    [aux_sym_preproc_if_token1] = ACTIONS(4004),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4004),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4004),
    [sym_preproc_directive] = ACTIONS(4004),
    [anon_sym_LPAREN2] = ACTIONS(4002),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4004),
    [anon_sym_PLUS] = ACTIONS(4004),
    [anon_sym_STAR] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4002),
    [anon_sym_AMP] = ACTIONS(4004),
    [anon_sym_SEMI] = ACTIONS(4002),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_typedef] = ACTIONS(4004),
    [anon_sym_in] = ACTIONS(4004),
    [anon_sym_out] = ACTIONS(4004),
    [anon_sym_inout] = ACTIONS(4004),
    [anon_sym_virtual] = ACTIONS(4004),
    [anon_sym_extern] = ACTIONS(4004),
    [anon_sym___attribute__] = ACTIONS(2897),
    [anon_sym___attribute] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4002),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4002),
    [anon_sym___declspec] = ACTIONS(4004),
    [anon_sym___based] = ACTIONS(4004),
    [anon_sym___cdecl] = ACTIONS(4004),
    [anon_sym___clrcall] = ACTIONS(4004),
    [anon_sym___stdcall] = ACTIONS(4004),
    [anon_sym___fastcall] = ACTIONS(4004),
    [anon_sym___thiscall] = ACTIONS(4004),
    [anon_sym___vectorcall] = ACTIONS(4004),
    [anon_sym_LBRACE] = ACTIONS(4002),
    [anon_sym_RBRACE] = ACTIONS(4002),
    [anon_sym_signed] = ACTIONS(4004),
    [anon_sym_unsigned] = ACTIONS(4004),
    [anon_sym_long] = ACTIONS(4004),
    [anon_sym_short] = ACTIONS(4004),
    [anon_sym_LBRACK] = ACTIONS(4004),
    [anon_sym_static] = ACTIONS(4004),
    [anon_sym_register] = ACTIONS(4004),
    [anon_sym_inline] = ACTIONS(4004),
    [anon_sym___inline] = ACTIONS(4004),
    [anon_sym___inline__] = ACTIONS(4004),
    [anon_sym___forceinline] = ACTIONS(4004),
    [anon_sym_thread_local] = ACTIONS(4004),
    [anon_sym___thread] = ACTIONS(4004),
    [anon_sym_const] = ACTIONS(4004),
    [anon_sym_constexpr] = ACTIONS(4004),
    [anon_sym_volatile] = ACTIONS(4004),
    [anon_sym_restrict] = ACTIONS(4004),
    [anon_sym___restrict__] = ACTIONS(4004),
    [anon_sym__Atomic] = ACTIONS(4004),
    [anon_sym__Noreturn] = ACTIONS(4004),
    [anon_sym_noreturn] = ACTIONS(4004),
    [anon_sym__Nonnull] = ACTIONS(4004),
    [anon_sym_mutable] = ACTIONS(4004),
    [anon_sym_constinit] = ACTIONS(4004),
    [anon_sym_consteval] = ACTIONS(4004),
    [anon_sym_alignas] = ACTIONS(4004),
    [anon_sym__Alignas] = ACTIONS(4004),
    [sym_primitive_type] = ACTIONS(4004),
    [anon_sym_enum] = ACTIONS(4004),
    [anon_sym_class] = ACTIONS(4004),
    [anon_sym_struct] = ACTIONS(4004),
    [anon_sym_union] = ACTIONS(4004),
    [anon_sym_if] = ACTIONS(4004),
    [anon_sym_switch] = ACTIONS(4004),
    [anon_sym_case] = ACTIONS(4004),
    [anon_sym_default] = ACTIONS(4004),
    [anon_sym_while] = ACTIONS(4004),
    [anon_sym_do] = ACTIONS(4004),
    [anon_sym_for] = ACTIONS(4004),
    [anon_sym_return] = ACTIONS(4004),
    [anon_sym_break] = ACTIONS(4004),
    [anon_sym_continue] = ACTIONS(4004),
    [anon_sym_goto] = ACTIONS(4004),
    [anon_sym___try] = ACTIONS(4004),
    [anon_sym___leave] = ACTIONS(4004),
    [anon_sym_not] = ACTIONS(4004),
    [anon_sym_compl] = ACTIONS(4004),
    [anon_sym_DASH_DASH] = ACTIONS(4002),
    [anon_sym_PLUS_PLUS] = ACTIONS(4002),
    [anon_sym_sizeof] = ACTIONS(4004),
    [anon_sym___alignof__] = ACTIONS(4004),
    [anon_sym___alignof] = ACTIONS(4004),
    [anon_sym__alignof] = ACTIONS(4004),
    [anon_sym_alignof] = ACTIONS(4004),
    [anon_sym__Alignof] = ACTIONS(4004),
    [anon_sym_offsetof] = ACTIONS(4004),
    [anon_sym__Generic] = ACTIONS(4004),
    [anon_sym_asm] = ACTIONS(4004),
    [anon_sym___asm__] = ACTIONS(4004),
    [anon_sym___asm] = ACTIONS(4004),
    [anon_sym_DOT] = ACTIONS(4004),
    [sym_number_literal] = ACTIONS(4002),
    [anon_sym_L_SQUOTE] = ACTIONS(4002),
    [anon_sym_u_SQUOTE] = ACTIONS(4002),
    [anon_sym_U_SQUOTE] = ACTIONS(4002),
    [anon_sym_u8_SQUOTE] = ACTIONS(4002),
    [anon_sym_SQUOTE] = ACTIONS(4002),
    [anon_sym_L_DQUOTE] = ACTIONS(4002),
    [anon_sym_u_DQUOTE] = ACTIONS(4002),
    [anon_sym_U_DQUOTE] = ACTIONS(4002),
    [anon_sym_u8_DQUOTE] = ACTIONS(4002),
    [anon_sym_DQUOTE] = ACTIONS(4002),
    [sym_true] = ACTIONS(4004),
    [sym_false] = ACTIONS(4004),
    [anon_sym_NULL] = ACTIONS(4004),
    [anon_sym_nullptr] = ACTIONS(4004),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4004),
    [anon_sym_let] = ACTIONS(4004),
    [anon_sym_This] = ACTIONS(4004),
    [anon_sym_decltype] = ACTIONS(4004),
    [anon_sym_explicit] = ACTIONS(4004),
    [anon_sym_typename] = ACTIONS(4004),
    [anon_sym_template] = ACTIONS(4004),
    [anon_sym_operator] = ACTIONS(4004),
    [anon_sym_try] = ACTIONS(4004),
    [anon_sym_delete] = ACTIONS(4004),
    [anon_sym_throw] = ACTIONS(4004),
    [anon_sym_namespace] = ACTIONS(4004),
    [anon_sym_static_assert] = ACTIONS(4004),
    [anon_sym_concept] = ACTIONS(4004),
    [anon_sym_co_return] = ACTIONS(4004),
    [anon_sym_co_yield] = ACTIONS(4004),
    [anon_sym_R_DQUOTE] = ACTIONS(4002),
    [anon_sym_LR_DQUOTE] = ACTIONS(4002),
    [anon_sym_uR_DQUOTE] = ACTIONS(4002),
    [anon_sym_UR_DQUOTE] = ACTIONS(4002),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4002),
    [anon_sym_co_await] = ACTIONS(4004),
    [anon_sym_new] = ACTIONS(4004),
    [anon_sym_requires] = ACTIONS(4004),
    [sym_this] = ACTIONS(4004),
    [anon_sym_discard] = ACTIONS(4004),
    [anon_sym_precise] = ACTIONS(4004),
    [anon_sym_shared] = ACTIONS(4004),
    [anon_sym_groupshared] = ACTIONS(4004),
    [anon_sym_uniform] = ACTIONS(4004),
    [anon_sym_row_major] = ACTIONS(4004),
    [anon_sym_column_major] = ACTIONS(4004),
    [anon_sym_globallycoherent] = ACTIONS(4004),
    [anon_sym_centroid] = ACTIONS(4004),
    [anon_sym_noperspective] = ACTIONS(4004),
    [anon_sym_nointerpolation] = ACTIONS(4004),
    [anon_sym_sample] = ACTIONS(4004),
    [anon_sym_linear] = ACTIONS(4004),
    [anon_sym_snorm] = ACTIONS(4004),
    [anon_sym_unorm] = ACTIONS(4004),
    [anon_sym_point] = ACTIONS(4004),
    [anon_sym_line] = ACTIONS(4004),
    [anon_sym_triangleadj] = ACTIONS(4004),
    [anon_sym_lineadj] = ACTIONS(4004),
    [anon_sym_triangle] = ACTIONS(4004),
    [anon_sym_cbuffer] = ACTIONS(4004),
    [anon_sym_interface] = ACTIONS(4004),
    [anon_sym_extension] = ACTIONS(4004),
  },
  [709] = {
    [sym_identifier] = ACTIONS(2414),
    [aux_sym_preproc_include_token1] = ACTIONS(2414),
    [aux_sym_preproc_def_token1] = ACTIONS(2414),
    [anon_sym_COMMA] = ACTIONS(4215),
    [anon_sym_RPAREN] = ACTIONS(4215),
    [aux_sym_preproc_if_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2414),
    [sym_preproc_directive] = ACTIONS(2414),
    [anon_sym_LPAREN2] = ACTIONS(2412),
    [anon_sym_BANG] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym___extension__] = ACTIONS(2414),
    [anon_sym_typedef] = ACTIONS(2414),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_out] = ACTIONS(2414),
    [anon_sym_inout] = ACTIONS(2414),
    [anon_sym_virtual] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym___attribute__] = ACTIONS(2414),
    [anon_sym___attribute] = ACTIONS(2414),
    [anon_sym_using] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2412),
    [anon_sym___declspec] = ACTIONS(2414),
    [anon_sym___based] = ACTIONS(2414),
    [anon_sym___cdecl] = ACTIONS(2414),
    [anon_sym___clrcall] = ACTIONS(2414),
    [anon_sym___stdcall] = ACTIONS(2414),
    [anon_sym___fastcall] = ACTIONS(2414),
    [anon_sym___thiscall] = ACTIONS(2414),
    [anon_sym___vectorcall] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(2412),
    [anon_sym_RBRACE] = ACTIONS(4215),
    [anon_sym_signed] = ACTIONS(2414),
    [anon_sym_unsigned] = ACTIONS(2414),
    [anon_sym_long] = ACTIONS(2414),
    [anon_sym_short] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_register] = ACTIONS(2414),
    [anon_sym_inline] = ACTIONS(2414),
    [anon_sym___inline] = ACTIONS(2414),
    [anon_sym___inline__] = ACTIONS(2414),
    [anon_sym___forceinline] = ACTIONS(2414),
    [anon_sym_thread_local] = ACTIONS(2414),
    [anon_sym___thread] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_constexpr] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym_restrict] = ACTIONS(2414),
    [anon_sym___restrict__] = ACTIONS(2414),
    [anon_sym__Atomic] = ACTIONS(2414),
    [anon_sym__Noreturn] = ACTIONS(2414),
    [anon_sym_noreturn] = ACTIONS(2414),
    [anon_sym__Nonnull] = ACTIONS(2414),
    [anon_sym_mutable] = ACTIONS(2414),
    [anon_sym_constinit] = ACTIONS(2414),
    [anon_sym_consteval] = ACTIONS(2414),
    [anon_sym_alignas] = ACTIONS(2414),
    [anon_sym__Alignas] = ACTIONS(2414),
    [sym_primitive_type] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [anon_sym_if] = ACTIONS(2414),
    [anon_sym_switch] = ACTIONS(2414),
    [anon_sym_case] = ACTIONS(2414),
    [anon_sym_default] = ACTIONS(2414),
    [anon_sym_while] = ACTIONS(2414),
    [anon_sym_do] = ACTIONS(2414),
    [anon_sym_for] = ACTIONS(2414),
    [anon_sym_return] = ACTIONS(2414),
    [anon_sym_break] = ACTIONS(2414),
    [anon_sym_continue] = ACTIONS(2414),
    [anon_sym_goto] = ACTIONS(2414),
    [anon_sym___try] = ACTIONS(2414),
    [anon_sym___leave] = ACTIONS(2414),
    [anon_sym_not] = ACTIONS(2414),
    [anon_sym_compl] = ACTIONS(2414),
    [anon_sym_DASH_DASH] = ACTIONS(2412),
    [anon_sym_PLUS_PLUS] = ACTIONS(2412),
    [anon_sym_sizeof] = ACTIONS(2414),
    [anon_sym___alignof__] = ACTIONS(2414),
    [anon_sym___alignof] = ACTIONS(2414),
    [anon_sym__alignof] = ACTIONS(2414),
    [anon_sym_alignof] = ACTIONS(2414),
    [anon_sym__Alignof] = ACTIONS(2414),
    [anon_sym_offsetof] = ACTIONS(2414),
    [anon_sym__Generic] = ACTIONS(2414),
    [anon_sym_asm] = ACTIONS(2414),
    [anon_sym___asm__] = ACTIONS(2414),
    [anon_sym___asm] = ACTIONS(2414),
    [sym_number_literal] = ACTIONS(2412),
    [anon_sym_L_SQUOTE] = ACTIONS(2412),
    [anon_sym_u_SQUOTE] = ACTIONS(2412),
    [anon_sym_U_SQUOTE] = ACTIONS(2412),
    [anon_sym_u8_SQUOTE] = ACTIONS(2412),
    [anon_sym_SQUOTE] = ACTIONS(2412),
    [anon_sym_L_DQUOTE] = ACTIONS(2412),
    [anon_sym_u_DQUOTE] = ACTIONS(2412),
    [anon_sym_U_DQUOTE] = ACTIONS(2412),
    [anon_sym_u8_DQUOTE] = ACTIONS(2412),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [sym_true] = ACTIONS(2414),
    [sym_false] = ACTIONS(2414),
    [anon_sym_NULL] = ACTIONS(2414),
    [anon_sym_nullptr] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2414),
    [anon_sym_let] = ACTIONS(2414),
    [anon_sym_This] = ACTIONS(2414),
    [anon_sym_decltype] = ACTIONS(2414),
    [anon_sym_explicit] = ACTIONS(2414),
    [anon_sym_typename] = ACTIONS(2414),
    [anon_sym_template] = ACTIONS(2414),
    [anon_sym_operator] = ACTIONS(2414),
    [anon_sym_try] = ACTIONS(2414),
    [anon_sym_delete] = ACTIONS(2414),
    [anon_sym_throw] = ACTIONS(2414),
    [anon_sym_namespace] = ACTIONS(2414),
    [anon_sym_static_assert] = ACTIONS(2414),
    [anon_sym_concept] = ACTIONS(2414),
    [anon_sym_co_return] = ACTIONS(2414),
    [anon_sym_co_yield] = ACTIONS(2414),
    [anon_sym_R_DQUOTE] = ACTIONS(2412),
    [anon_sym_LR_DQUOTE] = ACTIONS(2412),
    [anon_sym_uR_DQUOTE] = ACTIONS(2412),
    [anon_sym_UR_DQUOTE] = ACTIONS(2412),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2412),
    [anon_sym_co_await] = ACTIONS(2414),
    [anon_sym_new] = ACTIONS(2414),
    [anon_sym_requires] = ACTIONS(2414),
    [sym_this] = ACTIONS(2414),
    [anon_sym_discard] = ACTIONS(2414),
    [anon_sym_precise] = ACTIONS(2414),
    [anon_sym_shared] = ACTIONS(2414),
    [anon_sym_groupshared] = ACTIONS(2414),
    [anon_sym_uniform] = ACTIONS(2414),
    [anon_sym_row_major] = ACTIONS(2414),
    [anon_sym_column_major] = ACTIONS(2414),
    [anon_sym_globallycoherent] = ACTIONS(2414),
    [anon_sym_centroid] = ACTIONS(2414),
    [anon_sym_noperspective] = ACTIONS(2414),
    [anon_sym_nointerpolation] = ACTIONS(2414),
    [anon_sym_sample] = ACTIONS(2414),
    [anon_sym_linear] = ACTIONS(2414),
    [anon_sym_snorm] = ACTIONS(2414),
    [anon_sym_unorm] = ACTIONS(2414),
    [anon_sym_point] = ACTIONS(2414),
    [anon_sym_line] = ACTIONS(2414),
    [anon_sym_triangleadj] = ACTIONS(2414),
    [anon_sym_lineadj] = ACTIONS(2414),
    [anon_sym_triangle] = ACTIONS(2414),
    [anon_sym_cbuffer] = ACTIONS(2414),
    [anon_sym_interface] = ACTIONS(2414),
    [anon_sym_extension] = ACTIONS(2414),
  },
  [710] = {
    [sym_expression] = STATE(5651),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11301),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(4220),
    [anon_sym___extension__] = ACTIONS(4222),
    [anon_sym_in] = ACTIONS(3631),
    [anon_sym_out] = ACTIONS(3631),
    [anon_sym_inout] = ACTIONS(3631),
    [anon_sym_virtual] = ACTIONS(3631),
    [anon_sym_extern] = ACTIONS(3631),
    [anon_sym___attribute__] = ACTIONS(3631),
    [anon_sym___attribute] = ACTIONS(3631),
    [anon_sym_COLON_COLON] = ACTIONS(4225),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3629),
    [anon_sym___declspec] = ACTIONS(3631),
    [anon_sym_signed] = ACTIONS(3631),
    [anon_sym_unsigned] = ACTIONS(3631),
    [anon_sym_long] = ACTIONS(3631),
    [anon_sym_short] = ACTIONS(3631),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(3631),
    [anon_sym_register] = ACTIONS(3631),
    [anon_sym_inline] = ACTIONS(3631),
    [anon_sym___inline] = ACTIONS(3631),
    [anon_sym___inline__] = ACTIONS(3631),
    [anon_sym___forceinline] = ACTIONS(3631),
    [anon_sym_thread_local] = ACTIONS(3631),
    [anon_sym___thread] = ACTIONS(3631),
    [anon_sym_const] = ACTIONS(3631),
    [anon_sym_constexpr] = ACTIONS(3631),
    [anon_sym_volatile] = ACTIONS(3631),
    [anon_sym_restrict] = ACTIONS(3631),
    [anon_sym___restrict__] = ACTIONS(3631),
    [anon_sym__Atomic] = ACTIONS(3631),
    [anon_sym__Noreturn] = ACTIONS(3631),
    [anon_sym_noreturn] = ACTIONS(3631),
    [anon_sym__Nonnull] = ACTIONS(3631),
    [anon_sym_mutable] = ACTIONS(3631),
    [anon_sym_constinit] = ACTIONS(3631),
    [anon_sym_consteval] = ACTIONS(3631),
    [anon_sym_alignas] = ACTIONS(3631),
    [anon_sym__Alignas] = ACTIONS(3631),
    [sym_primitive_type] = ACTIONS(4228),
    [anon_sym_enum] = ACTIONS(3631),
    [anon_sym_class] = ACTIONS(3631),
    [anon_sym_struct] = ACTIONS(3631),
    [anon_sym_union] = ACTIONS(3631),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3631),
    [anon_sym_let] = ACTIONS(3631),
    [anon_sym_This] = ACTIONS(3631),
    [anon_sym_decltype] = ACTIONS(4231),
    [anon_sym_typename] = ACTIONS(3631),
    [anon_sym_template] = ACTIONS(4234),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(3631),
    [anon_sym_shared] = ACTIONS(3631),
    [anon_sym_groupshared] = ACTIONS(3631),
    [anon_sym_uniform] = ACTIONS(3631),
    [anon_sym_row_major] = ACTIONS(3631),
    [anon_sym_column_major] = ACTIONS(3631),
    [anon_sym_globallycoherent] = ACTIONS(3631),
    [anon_sym_centroid] = ACTIONS(3631),
    [anon_sym_noperspective] = ACTIONS(3631),
    [anon_sym_nointerpolation] = ACTIONS(3631),
    [anon_sym_sample] = ACTIONS(3631),
    [anon_sym_linear] = ACTIONS(3631),
    [anon_sym_snorm] = ACTIONS(3631),
    [anon_sym_unorm] = ACTIONS(3631),
    [anon_sym_point] = ACTIONS(3631),
    [anon_sym_line] = ACTIONS(3631),
    [anon_sym_triangleadj] = ACTIONS(3631),
    [anon_sym_lineadj] = ACTIONS(3631),
    [anon_sym_triangle] = ACTIONS(3631),
    [anon_sym_interface] = ACTIONS(3631),
    [anon_sym_extension] = ACTIONS(3631),
  },
  [711] = {
    [sym_attribute_specifier] = STATE(772),
    [sym_identifier] = ACTIONS(4091),
    [aux_sym_preproc_include_token1] = ACTIONS(4091),
    [aux_sym_preproc_def_token1] = ACTIONS(4091),
    [aux_sym_preproc_if_token1] = ACTIONS(4091),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4091),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4091),
    [sym_preproc_directive] = ACTIONS(4091),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4089),
    [anon_sym_TILDE] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4091),
    [anon_sym_PLUS] = ACTIONS(4091),
    [anon_sym_STAR] = ACTIONS(4089),
    [anon_sym_AMP_AMP] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4091),
    [anon_sym_SEMI] = ACTIONS(4089),
    [anon_sym___extension__] = ACTIONS(4091),
    [anon_sym_typedef] = ACTIONS(4091),
    [anon_sym_in] = ACTIONS(4091),
    [anon_sym_out] = ACTIONS(4091),
    [anon_sym_inout] = ACTIONS(4091),
    [anon_sym_virtual] = ACTIONS(4091),
    [anon_sym_extern] = ACTIONS(4091),
    [anon_sym___attribute__] = ACTIONS(2897),
    [anon_sym___attribute] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(4091),
    [anon_sym_COLON_COLON] = ACTIONS(4089),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4089),
    [anon_sym___declspec] = ACTIONS(4091),
    [anon_sym___based] = ACTIONS(4091),
    [anon_sym___cdecl] = ACTIONS(4091),
    [anon_sym___clrcall] = ACTIONS(4091),
    [anon_sym___stdcall] = ACTIONS(4091),
    [anon_sym___fastcall] = ACTIONS(4091),
    [anon_sym___thiscall] = ACTIONS(4091),
    [anon_sym___vectorcall] = ACTIONS(4091),
    [anon_sym_LBRACE] = ACTIONS(4089),
    [anon_sym_RBRACE] = ACTIONS(4089),
    [anon_sym_signed] = ACTIONS(4091),
    [anon_sym_unsigned] = ACTIONS(4091),
    [anon_sym_long] = ACTIONS(4091),
    [anon_sym_short] = ACTIONS(4091),
    [anon_sym_LBRACK] = ACTIONS(4091),
    [anon_sym_static] = ACTIONS(4091),
    [anon_sym_register] = ACTIONS(4091),
    [anon_sym_inline] = ACTIONS(4091),
    [anon_sym___inline] = ACTIONS(4091),
    [anon_sym___inline__] = ACTIONS(4091),
    [anon_sym___forceinline] = ACTIONS(4091),
    [anon_sym_thread_local] = ACTIONS(4091),
    [anon_sym___thread] = ACTIONS(4091),
    [anon_sym_const] = ACTIONS(4091),
    [anon_sym_constexpr] = ACTIONS(4091),
    [anon_sym_volatile] = ACTIONS(4091),
    [anon_sym_restrict] = ACTIONS(4091),
    [anon_sym___restrict__] = ACTIONS(4091),
    [anon_sym__Atomic] = ACTIONS(4091),
    [anon_sym__Noreturn] = ACTIONS(4091),
    [anon_sym_noreturn] = ACTIONS(4091),
    [anon_sym__Nonnull] = ACTIONS(4091),
    [anon_sym_mutable] = ACTIONS(4091),
    [anon_sym_constinit] = ACTIONS(4091),
    [anon_sym_consteval] = ACTIONS(4091),
    [anon_sym_alignas] = ACTIONS(4091),
    [anon_sym__Alignas] = ACTIONS(4091),
    [sym_primitive_type] = ACTIONS(4091),
    [anon_sym_enum] = ACTIONS(4091),
    [anon_sym_class] = ACTIONS(4091),
    [anon_sym_struct] = ACTIONS(4091),
    [anon_sym_union] = ACTIONS(4091),
    [anon_sym_if] = ACTIONS(4091),
    [anon_sym_switch] = ACTIONS(4091),
    [anon_sym_case] = ACTIONS(4091),
    [anon_sym_default] = ACTIONS(4091),
    [anon_sym_while] = ACTIONS(4091),
    [anon_sym_do] = ACTIONS(4091),
    [anon_sym_for] = ACTIONS(4091),
    [anon_sym_return] = ACTIONS(4091),
    [anon_sym_break] = ACTIONS(4091),
    [anon_sym_continue] = ACTIONS(4091),
    [anon_sym_goto] = ACTIONS(4091),
    [anon_sym___try] = ACTIONS(4091),
    [anon_sym___leave] = ACTIONS(4091),
    [anon_sym_not] = ACTIONS(4091),
    [anon_sym_compl] = ACTIONS(4091),
    [anon_sym_DASH_DASH] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(4089),
    [anon_sym_sizeof] = ACTIONS(4091),
    [anon_sym___alignof__] = ACTIONS(4091),
    [anon_sym___alignof] = ACTIONS(4091),
    [anon_sym__alignof] = ACTIONS(4091),
    [anon_sym_alignof] = ACTIONS(4091),
    [anon_sym__Alignof] = ACTIONS(4091),
    [anon_sym_offsetof] = ACTIONS(4091),
    [anon_sym__Generic] = ACTIONS(4091),
    [anon_sym_asm] = ACTIONS(4091),
    [anon_sym___asm__] = ACTIONS(4091),
    [anon_sym___asm] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(4091),
    [sym_number_literal] = ACTIONS(4089),
    [anon_sym_L_SQUOTE] = ACTIONS(4089),
    [anon_sym_u_SQUOTE] = ACTIONS(4089),
    [anon_sym_U_SQUOTE] = ACTIONS(4089),
    [anon_sym_u8_SQUOTE] = ACTIONS(4089),
    [anon_sym_SQUOTE] = ACTIONS(4089),
    [anon_sym_L_DQUOTE] = ACTIONS(4089),
    [anon_sym_u_DQUOTE] = ACTIONS(4089),
    [anon_sym_U_DQUOTE] = ACTIONS(4089),
    [anon_sym_u8_DQUOTE] = ACTIONS(4089),
    [anon_sym_DQUOTE] = ACTIONS(4089),
    [sym_true] = ACTIONS(4091),
    [sym_false] = ACTIONS(4091),
    [anon_sym_NULL] = ACTIONS(4091),
    [anon_sym_nullptr] = ACTIONS(4091),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4091),
    [anon_sym_let] = ACTIONS(4091),
    [anon_sym_This] = ACTIONS(4091),
    [anon_sym_decltype] = ACTIONS(4091),
    [anon_sym_explicit] = ACTIONS(4091),
    [anon_sym_typename] = ACTIONS(4091),
    [anon_sym_template] = ACTIONS(4091),
    [anon_sym_operator] = ACTIONS(4091),
    [anon_sym_try] = ACTIONS(4091),
    [anon_sym_delete] = ACTIONS(4091),
    [anon_sym_throw] = ACTIONS(4091),
    [anon_sym_namespace] = ACTIONS(4091),
    [anon_sym_static_assert] = ACTIONS(4091),
    [anon_sym_concept] = ACTIONS(4091),
    [anon_sym_co_return] = ACTIONS(4091),
    [anon_sym_co_yield] = ACTIONS(4091),
    [anon_sym_R_DQUOTE] = ACTIONS(4089),
    [anon_sym_LR_DQUOTE] = ACTIONS(4089),
    [anon_sym_uR_DQUOTE] = ACTIONS(4089),
    [anon_sym_UR_DQUOTE] = ACTIONS(4089),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4089),
    [anon_sym_co_await] = ACTIONS(4091),
    [anon_sym_new] = ACTIONS(4091),
    [anon_sym_requires] = ACTIONS(4091),
    [sym_this] = ACTIONS(4091),
    [anon_sym_discard] = ACTIONS(4091),
    [anon_sym_precise] = ACTIONS(4091),
    [anon_sym_shared] = ACTIONS(4091),
    [anon_sym_groupshared] = ACTIONS(4091),
    [anon_sym_uniform] = ACTIONS(4091),
    [anon_sym_row_major] = ACTIONS(4091),
    [anon_sym_column_major] = ACTIONS(4091),
    [anon_sym_globallycoherent] = ACTIONS(4091),
    [anon_sym_centroid] = ACTIONS(4091),
    [anon_sym_noperspective] = ACTIONS(4091),
    [anon_sym_nointerpolation] = ACTIONS(4091),
    [anon_sym_sample] = ACTIONS(4091),
    [anon_sym_linear] = ACTIONS(4091),
    [anon_sym_snorm] = ACTIONS(4091),
    [anon_sym_unorm] = ACTIONS(4091),
    [anon_sym_point] = ACTIONS(4091),
    [anon_sym_line] = ACTIONS(4091),
    [anon_sym_triangleadj] = ACTIONS(4091),
    [anon_sym_lineadj] = ACTIONS(4091),
    [anon_sym_triangle] = ACTIONS(4091),
    [anon_sym_cbuffer] = ACTIONS(4091),
    [anon_sym_interface] = ACTIONS(4091),
    [anon_sym_extension] = ACTIONS(4091),
  },
  [712] = {
    [sym_attribute_specifier] = STATE(777),
    [sym_identifier] = ACTIONS(4200),
    [aux_sym_preproc_include_token1] = ACTIONS(4200),
    [aux_sym_preproc_def_token1] = ACTIONS(4200),
    [aux_sym_preproc_if_token1] = ACTIONS(4200),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4200),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4200),
    [sym_preproc_directive] = ACTIONS(4200),
    [anon_sym_LPAREN2] = ACTIONS(4198),
    [anon_sym_BANG] = ACTIONS(4198),
    [anon_sym_TILDE] = ACTIONS(4198),
    [anon_sym_DASH] = ACTIONS(4200),
    [anon_sym_PLUS] = ACTIONS(4200),
    [anon_sym_STAR] = ACTIONS(4198),
    [anon_sym_AMP_AMP] = ACTIONS(4198),
    [anon_sym_AMP] = ACTIONS(4200),
    [anon_sym_SEMI] = ACTIONS(4198),
    [anon_sym___extension__] = ACTIONS(4200),
    [anon_sym_typedef] = ACTIONS(4200),
    [anon_sym_in] = ACTIONS(4200),
    [anon_sym_out] = ACTIONS(4200),
    [anon_sym_inout] = ACTIONS(4200),
    [anon_sym_virtual] = ACTIONS(4200),
    [anon_sym_extern] = ACTIONS(4200),
    [anon_sym___attribute__] = ACTIONS(2897),
    [anon_sym___attribute] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(4200),
    [anon_sym_COLON_COLON] = ACTIONS(4198),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4198),
    [anon_sym___declspec] = ACTIONS(4200),
    [anon_sym___based] = ACTIONS(4200),
    [anon_sym___cdecl] = ACTIONS(4200),
    [anon_sym___clrcall] = ACTIONS(4200),
    [anon_sym___stdcall] = ACTIONS(4200),
    [anon_sym___fastcall] = ACTIONS(4200),
    [anon_sym___thiscall] = ACTIONS(4200),
    [anon_sym___vectorcall] = ACTIONS(4200),
    [anon_sym_LBRACE] = ACTIONS(4198),
    [anon_sym_RBRACE] = ACTIONS(4198),
    [anon_sym_signed] = ACTIONS(4200),
    [anon_sym_unsigned] = ACTIONS(4200),
    [anon_sym_long] = ACTIONS(4200),
    [anon_sym_short] = ACTIONS(4200),
    [anon_sym_LBRACK] = ACTIONS(4200),
    [anon_sym_static] = ACTIONS(4200),
    [anon_sym_register] = ACTIONS(4200),
    [anon_sym_inline] = ACTIONS(4200),
    [anon_sym___inline] = ACTIONS(4200),
    [anon_sym___inline__] = ACTIONS(4200),
    [anon_sym___forceinline] = ACTIONS(4200),
    [anon_sym_thread_local] = ACTIONS(4200),
    [anon_sym___thread] = ACTIONS(4200),
    [anon_sym_const] = ACTIONS(4200),
    [anon_sym_constexpr] = ACTIONS(4200),
    [anon_sym_volatile] = ACTIONS(4200),
    [anon_sym_restrict] = ACTIONS(4200),
    [anon_sym___restrict__] = ACTIONS(4200),
    [anon_sym__Atomic] = ACTIONS(4200),
    [anon_sym__Noreturn] = ACTIONS(4200),
    [anon_sym_noreturn] = ACTIONS(4200),
    [anon_sym__Nonnull] = ACTIONS(4200),
    [anon_sym_mutable] = ACTIONS(4200),
    [anon_sym_constinit] = ACTIONS(4200),
    [anon_sym_consteval] = ACTIONS(4200),
    [anon_sym_alignas] = ACTIONS(4200),
    [anon_sym__Alignas] = ACTIONS(4200),
    [sym_primitive_type] = ACTIONS(4200),
    [anon_sym_enum] = ACTIONS(4200),
    [anon_sym_class] = ACTIONS(4200),
    [anon_sym_struct] = ACTIONS(4200),
    [anon_sym_union] = ACTIONS(4200),
    [anon_sym_if] = ACTIONS(4200),
    [anon_sym_switch] = ACTIONS(4200),
    [anon_sym_case] = ACTIONS(4200),
    [anon_sym_default] = ACTIONS(4200),
    [anon_sym_while] = ACTIONS(4200),
    [anon_sym_do] = ACTIONS(4200),
    [anon_sym_for] = ACTIONS(4200),
    [anon_sym_return] = ACTIONS(4200),
    [anon_sym_break] = ACTIONS(4200),
    [anon_sym_continue] = ACTIONS(4200),
    [anon_sym_goto] = ACTIONS(4200),
    [anon_sym___try] = ACTIONS(4200),
    [anon_sym___leave] = ACTIONS(4200),
    [anon_sym_not] = ACTIONS(4200),
    [anon_sym_compl] = ACTIONS(4200),
    [anon_sym_DASH_DASH] = ACTIONS(4198),
    [anon_sym_PLUS_PLUS] = ACTIONS(4198),
    [anon_sym_sizeof] = ACTIONS(4200),
    [anon_sym___alignof__] = ACTIONS(4200),
    [anon_sym___alignof] = ACTIONS(4200),
    [anon_sym__alignof] = ACTIONS(4200),
    [anon_sym_alignof] = ACTIONS(4200),
    [anon_sym__Alignof] = ACTIONS(4200),
    [anon_sym_offsetof] = ACTIONS(4200),
    [anon_sym__Generic] = ACTIONS(4200),
    [anon_sym_asm] = ACTIONS(4200),
    [anon_sym___asm__] = ACTIONS(4200),
    [anon_sym___asm] = ACTIONS(4200),
    [anon_sym_DOT] = ACTIONS(4200),
    [sym_number_literal] = ACTIONS(4198),
    [anon_sym_L_SQUOTE] = ACTIONS(4198),
    [anon_sym_u_SQUOTE] = ACTIONS(4198),
    [anon_sym_U_SQUOTE] = ACTIONS(4198),
    [anon_sym_u8_SQUOTE] = ACTIONS(4198),
    [anon_sym_SQUOTE] = ACTIONS(4198),
    [anon_sym_L_DQUOTE] = ACTIONS(4198),
    [anon_sym_u_DQUOTE] = ACTIONS(4198),
    [anon_sym_U_DQUOTE] = ACTIONS(4198),
    [anon_sym_u8_DQUOTE] = ACTIONS(4198),
    [anon_sym_DQUOTE] = ACTIONS(4198),
    [sym_true] = ACTIONS(4200),
    [sym_false] = ACTIONS(4200),
    [anon_sym_NULL] = ACTIONS(4200),
    [anon_sym_nullptr] = ACTIONS(4200),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4200),
    [anon_sym_let] = ACTIONS(4200),
    [anon_sym_This] = ACTIONS(4200),
    [anon_sym_decltype] = ACTIONS(4200),
    [anon_sym_explicit] = ACTIONS(4200),
    [anon_sym_typename] = ACTIONS(4200),
    [anon_sym_template] = ACTIONS(4200),
    [anon_sym_operator] = ACTIONS(4200),
    [anon_sym_try] = ACTIONS(4200),
    [anon_sym_delete] = ACTIONS(4200),
    [anon_sym_throw] = ACTIONS(4200),
    [anon_sym_namespace] = ACTIONS(4200),
    [anon_sym_static_assert] = ACTIONS(4200),
    [anon_sym_concept] = ACTIONS(4200),
    [anon_sym_co_return] = ACTIONS(4200),
    [anon_sym_co_yield] = ACTIONS(4200),
    [anon_sym_R_DQUOTE] = ACTIONS(4198),
    [anon_sym_LR_DQUOTE] = ACTIONS(4198),
    [anon_sym_uR_DQUOTE] = ACTIONS(4198),
    [anon_sym_UR_DQUOTE] = ACTIONS(4198),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4198),
    [anon_sym_co_await] = ACTIONS(4200),
    [anon_sym_new] = ACTIONS(4200),
    [anon_sym_requires] = ACTIONS(4200),
    [sym_this] = ACTIONS(4200),
    [anon_sym_discard] = ACTIONS(4200),
    [anon_sym_precise] = ACTIONS(4200),
    [anon_sym_shared] = ACTIONS(4200),
    [anon_sym_groupshared] = ACTIONS(4200),
    [anon_sym_uniform] = ACTIONS(4200),
    [anon_sym_row_major] = ACTIONS(4200),
    [anon_sym_column_major] = ACTIONS(4200),
    [anon_sym_globallycoherent] = ACTIONS(4200),
    [anon_sym_centroid] = ACTIONS(4200),
    [anon_sym_noperspective] = ACTIONS(4200),
    [anon_sym_nointerpolation] = ACTIONS(4200),
    [anon_sym_sample] = ACTIONS(4200),
    [anon_sym_linear] = ACTIONS(4200),
    [anon_sym_snorm] = ACTIONS(4200),
    [anon_sym_unorm] = ACTIONS(4200),
    [anon_sym_point] = ACTIONS(4200),
    [anon_sym_line] = ACTIONS(4200),
    [anon_sym_triangleadj] = ACTIONS(4200),
    [anon_sym_lineadj] = ACTIONS(4200),
    [anon_sym_triangle] = ACTIONS(4200),
    [anon_sym_cbuffer] = ACTIONS(4200),
    [anon_sym_interface] = ACTIONS(4200),
    [anon_sym_extension] = ACTIONS(4200),
  },
  [713] = {
    [sym_attribute_specifier] = STATE(791),
    [sym_identifier] = ACTIONS(4060),
    [aux_sym_preproc_include_token1] = ACTIONS(4060),
    [aux_sym_preproc_def_token1] = ACTIONS(4060),
    [aux_sym_preproc_if_token1] = ACTIONS(4060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4060),
    [sym_preproc_directive] = ACTIONS(4060),
    [anon_sym_LPAREN2] = ACTIONS(4058),
    [anon_sym_BANG] = ACTIONS(4058),
    [anon_sym_TILDE] = ACTIONS(4058),
    [anon_sym_DASH] = ACTIONS(4060),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_STAR] = ACTIONS(4058),
    [anon_sym_AMP_AMP] = ACTIONS(4058),
    [anon_sym_AMP] = ACTIONS(4060),
    [anon_sym_SEMI] = ACTIONS(4058),
    [anon_sym___extension__] = ACTIONS(4060),
    [anon_sym_typedef] = ACTIONS(4060),
    [anon_sym_in] = ACTIONS(4060),
    [anon_sym_out] = ACTIONS(4060),
    [anon_sym_inout] = ACTIONS(4060),
    [anon_sym_virtual] = ACTIONS(4060),
    [anon_sym_extern] = ACTIONS(4060),
    [anon_sym___attribute__] = ACTIONS(2897),
    [anon_sym___attribute] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(4060),
    [anon_sym_COLON_COLON] = ACTIONS(4058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4058),
    [anon_sym___declspec] = ACTIONS(4060),
    [anon_sym___based] = ACTIONS(4060),
    [anon_sym___cdecl] = ACTIONS(4060),
    [anon_sym___clrcall] = ACTIONS(4060),
    [anon_sym___stdcall] = ACTIONS(4060),
    [anon_sym___fastcall] = ACTIONS(4060),
    [anon_sym___thiscall] = ACTIONS(4060),
    [anon_sym___vectorcall] = ACTIONS(4060),
    [anon_sym_LBRACE] = ACTIONS(4058),
    [anon_sym_RBRACE] = ACTIONS(4058),
    [anon_sym_signed] = ACTIONS(4060),
    [anon_sym_unsigned] = ACTIONS(4060),
    [anon_sym_long] = ACTIONS(4060),
    [anon_sym_short] = ACTIONS(4060),
    [anon_sym_LBRACK] = ACTIONS(4060),
    [anon_sym_static] = ACTIONS(4060),
    [anon_sym_register] = ACTIONS(4060),
    [anon_sym_inline] = ACTIONS(4060),
    [anon_sym___inline] = ACTIONS(4060),
    [anon_sym___inline__] = ACTIONS(4060),
    [anon_sym___forceinline] = ACTIONS(4060),
    [anon_sym_thread_local] = ACTIONS(4060),
    [anon_sym___thread] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4060),
    [anon_sym_constexpr] = ACTIONS(4060),
    [anon_sym_volatile] = ACTIONS(4060),
    [anon_sym_restrict] = ACTIONS(4060),
    [anon_sym___restrict__] = ACTIONS(4060),
    [anon_sym__Atomic] = ACTIONS(4060),
    [anon_sym__Noreturn] = ACTIONS(4060),
    [anon_sym_noreturn] = ACTIONS(4060),
    [anon_sym__Nonnull] = ACTIONS(4060),
    [anon_sym_mutable] = ACTIONS(4060),
    [anon_sym_constinit] = ACTIONS(4060),
    [anon_sym_consteval] = ACTIONS(4060),
    [anon_sym_alignas] = ACTIONS(4060),
    [anon_sym__Alignas] = ACTIONS(4060),
    [sym_primitive_type] = ACTIONS(4060),
    [anon_sym_enum] = ACTIONS(4060),
    [anon_sym_class] = ACTIONS(4060),
    [anon_sym_struct] = ACTIONS(4060),
    [anon_sym_union] = ACTIONS(4060),
    [anon_sym_if] = ACTIONS(4060),
    [anon_sym_switch] = ACTIONS(4060),
    [anon_sym_case] = ACTIONS(4060),
    [anon_sym_default] = ACTIONS(4060),
    [anon_sym_while] = ACTIONS(4060),
    [anon_sym_do] = ACTIONS(4060),
    [anon_sym_for] = ACTIONS(4060),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_break] = ACTIONS(4060),
    [anon_sym_continue] = ACTIONS(4060),
    [anon_sym_goto] = ACTIONS(4060),
    [anon_sym___try] = ACTIONS(4060),
    [anon_sym___leave] = ACTIONS(4060),
    [anon_sym_not] = ACTIONS(4060),
    [anon_sym_compl] = ACTIONS(4060),
    [anon_sym_DASH_DASH] = ACTIONS(4058),
    [anon_sym_PLUS_PLUS] = ACTIONS(4058),
    [anon_sym_sizeof] = ACTIONS(4060),
    [anon_sym___alignof__] = ACTIONS(4060),
    [anon_sym___alignof] = ACTIONS(4060),
    [anon_sym__alignof] = ACTIONS(4060),
    [anon_sym_alignof] = ACTIONS(4060),
    [anon_sym__Alignof] = ACTIONS(4060),
    [anon_sym_offsetof] = ACTIONS(4060),
    [anon_sym__Generic] = ACTIONS(4060),
    [anon_sym_asm] = ACTIONS(4060),
    [anon_sym___asm__] = ACTIONS(4060),
    [anon_sym___asm] = ACTIONS(4060),
    [anon_sym_DOT] = ACTIONS(4060),
    [sym_number_literal] = ACTIONS(4058),
    [anon_sym_L_SQUOTE] = ACTIONS(4058),
    [anon_sym_u_SQUOTE] = ACTIONS(4058),
    [anon_sym_U_SQUOTE] = ACTIONS(4058),
    [anon_sym_u8_SQUOTE] = ACTIONS(4058),
    [anon_sym_SQUOTE] = ACTIONS(4058),
    [anon_sym_L_DQUOTE] = ACTIONS(4058),
    [anon_sym_u_DQUOTE] = ACTIONS(4058),
    [anon_sym_U_DQUOTE] = ACTIONS(4058),
    [anon_sym_u8_DQUOTE] = ACTIONS(4058),
    [anon_sym_DQUOTE] = ACTIONS(4058),
    [sym_true] = ACTIONS(4060),
    [sym_false] = ACTIONS(4060),
    [anon_sym_NULL] = ACTIONS(4060),
    [anon_sym_nullptr] = ACTIONS(4060),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4060),
    [anon_sym_let] = ACTIONS(4060),
    [anon_sym_This] = ACTIONS(4060),
    [anon_sym_decltype] = ACTIONS(4060),
    [anon_sym_explicit] = ACTIONS(4060),
    [anon_sym_typename] = ACTIONS(4060),
    [anon_sym_template] = ACTIONS(4060),
    [anon_sym_operator] = ACTIONS(4060),
    [anon_sym_try] = ACTIONS(4060),
    [anon_sym_delete] = ACTIONS(4060),
    [anon_sym_throw] = ACTIONS(4060),
    [anon_sym_namespace] = ACTIONS(4060),
    [anon_sym_static_assert] = ACTIONS(4060),
    [anon_sym_concept] = ACTIONS(4060),
    [anon_sym_co_return] = ACTIONS(4060),
    [anon_sym_co_yield] = ACTIONS(4060),
    [anon_sym_R_DQUOTE] = ACTIONS(4058),
    [anon_sym_LR_DQUOTE] = ACTIONS(4058),
    [anon_sym_uR_DQUOTE] = ACTIONS(4058),
    [anon_sym_UR_DQUOTE] = ACTIONS(4058),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4058),
    [anon_sym_co_await] = ACTIONS(4060),
    [anon_sym_new] = ACTIONS(4060),
    [anon_sym_requires] = ACTIONS(4060),
    [sym_this] = ACTIONS(4060),
    [anon_sym_discard] = ACTIONS(4060),
    [anon_sym_precise] = ACTIONS(4060),
    [anon_sym_shared] = ACTIONS(4060),
    [anon_sym_groupshared] = ACTIONS(4060),
    [anon_sym_uniform] = ACTIONS(4060),
    [anon_sym_row_major] = ACTIONS(4060),
    [anon_sym_column_major] = ACTIONS(4060),
    [anon_sym_globallycoherent] = ACTIONS(4060),
    [anon_sym_centroid] = ACTIONS(4060),
    [anon_sym_noperspective] = ACTIONS(4060),
    [anon_sym_nointerpolation] = ACTIONS(4060),
    [anon_sym_sample] = ACTIONS(4060),
    [anon_sym_linear] = ACTIONS(4060),
    [anon_sym_snorm] = ACTIONS(4060),
    [anon_sym_unorm] = ACTIONS(4060),
    [anon_sym_point] = ACTIONS(4060),
    [anon_sym_line] = ACTIONS(4060),
    [anon_sym_triangleadj] = ACTIONS(4060),
    [anon_sym_lineadj] = ACTIONS(4060),
    [anon_sym_triangle] = ACTIONS(4060),
    [anon_sym_cbuffer] = ACTIONS(4060),
    [anon_sym_interface] = ACTIONS(4060),
    [anon_sym_extension] = ACTIONS(4060),
  },
  [714] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(284),
    [ts_builtin_sym_end] = ACTIONS(4095),
    [sym_identifier] = ACTIONS(4093),
    [aux_sym_preproc_include_token1] = ACTIONS(4093),
    [aux_sym_preproc_def_token1] = ACTIONS(4093),
    [aux_sym_preproc_if_token1] = ACTIONS(4093),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4093),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4093),
    [sym_preproc_directive] = ACTIONS(4093),
    [anon_sym_LPAREN2] = ACTIONS(4095),
    [anon_sym_BANG] = ACTIONS(4095),
    [anon_sym_TILDE] = ACTIONS(4095),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP_AMP] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_SEMI] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4093),
    [anon_sym_typedef] = ACTIONS(4093),
    [anon_sym_in] = ACTIONS(4093),
    [anon_sym_out] = ACTIONS(4093),
    [anon_sym_inout] = ACTIONS(4093),
    [anon_sym_virtual] = ACTIONS(4093),
    [anon_sym_extern] = ACTIONS(4093),
    [anon_sym___attribute__] = ACTIONS(4093),
    [anon_sym___attribute] = ACTIONS(4093),
    [anon_sym_using] = ACTIONS(4093),
    [anon_sym_COLON_COLON] = ACTIONS(4095),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4095),
    [anon_sym___declspec] = ACTIONS(4093),
    [anon_sym___based] = ACTIONS(4093),
    [anon_sym___cdecl] = ACTIONS(4093),
    [anon_sym___clrcall] = ACTIONS(4093),
    [anon_sym___stdcall] = ACTIONS(4093),
    [anon_sym___fastcall] = ACTIONS(4093),
    [anon_sym___thiscall] = ACTIONS(4093),
    [anon_sym___vectorcall] = ACTIONS(4093),
    [anon_sym_LBRACE] = ACTIONS(4095),
    [anon_sym_signed] = ACTIONS(4237),
    [anon_sym_unsigned] = ACTIONS(4237),
    [anon_sym_long] = ACTIONS(4237),
    [anon_sym_short] = ACTIONS(4237),
    [anon_sym_LBRACK] = ACTIONS(4093),
    [anon_sym_static] = ACTIONS(4093),
    [anon_sym_register] = ACTIONS(4093),
    [anon_sym_inline] = ACTIONS(4093),
    [anon_sym___inline] = ACTIONS(4093),
    [anon_sym___inline__] = ACTIONS(4093),
    [anon_sym___forceinline] = ACTIONS(4093),
    [anon_sym_thread_local] = ACTIONS(4093),
    [anon_sym___thread] = ACTIONS(4093),
    [anon_sym_const] = ACTIONS(4093),
    [anon_sym_constexpr] = ACTIONS(4093),
    [anon_sym_volatile] = ACTIONS(4093),
    [anon_sym_restrict] = ACTIONS(4093),
    [anon_sym___restrict__] = ACTIONS(4093),
    [anon_sym__Atomic] = ACTIONS(4093),
    [anon_sym__Noreturn] = ACTIONS(4093),
    [anon_sym_noreturn] = ACTIONS(4093),
    [anon_sym__Nonnull] = ACTIONS(4093),
    [anon_sym_mutable] = ACTIONS(4093),
    [anon_sym_constinit] = ACTIONS(4093),
    [anon_sym_consteval] = ACTIONS(4093),
    [anon_sym_alignas] = ACTIONS(4093),
    [anon_sym__Alignas] = ACTIONS(4093),
    [sym_primitive_type] = ACTIONS(4093),
    [anon_sym_enum] = ACTIONS(4093),
    [anon_sym_class] = ACTIONS(4093),
    [anon_sym_struct] = ACTIONS(4093),
    [anon_sym_union] = ACTIONS(4093),
    [anon_sym_if] = ACTIONS(4093),
    [anon_sym_switch] = ACTIONS(4093),
    [anon_sym_case] = ACTIONS(4093),
    [anon_sym_default] = ACTIONS(4093),
    [anon_sym_while] = ACTIONS(4093),
    [anon_sym_do] = ACTIONS(4093),
    [anon_sym_for] = ACTIONS(4093),
    [anon_sym_return] = ACTIONS(4093),
    [anon_sym_break] = ACTIONS(4093),
    [anon_sym_continue] = ACTIONS(4093),
    [anon_sym_goto] = ACTIONS(4093),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4095),
    [anon_sym_PLUS_PLUS] = ACTIONS(4095),
    [anon_sym_sizeof] = ACTIONS(4093),
    [anon_sym___alignof__] = ACTIONS(4093),
    [anon_sym___alignof] = ACTIONS(4093),
    [anon_sym__alignof] = ACTIONS(4093),
    [anon_sym_alignof] = ACTIONS(4093),
    [anon_sym__Alignof] = ACTIONS(4093),
    [anon_sym_offsetof] = ACTIONS(4093),
    [anon_sym__Generic] = ACTIONS(4093),
    [anon_sym_asm] = ACTIONS(4093),
    [anon_sym___asm__] = ACTIONS(4093),
    [anon_sym___asm] = ACTIONS(4093),
    [anon_sym_DOT] = ACTIONS(4093),
    [sym_number_literal] = ACTIONS(4095),
    [anon_sym_L_SQUOTE] = ACTIONS(4095),
    [anon_sym_u_SQUOTE] = ACTIONS(4095),
    [anon_sym_U_SQUOTE] = ACTIONS(4095),
    [anon_sym_u8_SQUOTE] = ACTIONS(4095),
    [anon_sym_SQUOTE] = ACTIONS(4095),
    [anon_sym_L_DQUOTE] = ACTIONS(4095),
    [anon_sym_u_DQUOTE] = ACTIONS(4095),
    [anon_sym_U_DQUOTE] = ACTIONS(4095),
    [anon_sym_u8_DQUOTE] = ACTIONS(4095),
    [anon_sym_DQUOTE] = ACTIONS(4095),
    [sym_true] = ACTIONS(4093),
    [sym_false] = ACTIONS(4093),
    [anon_sym_NULL] = ACTIONS(4093),
    [anon_sym_nullptr] = ACTIONS(4093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4093),
    [anon_sym_let] = ACTIONS(4093),
    [anon_sym_This] = ACTIONS(4093),
    [anon_sym_decltype] = ACTIONS(4093),
    [anon_sym_explicit] = ACTIONS(4093),
    [anon_sym_typename] = ACTIONS(4093),
    [anon_sym_export] = ACTIONS(4093),
    [anon_sym_module] = ACTIONS(4093),
    [anon_sym_import] = ACTIONS(4093),
    [anon_sym_template] = ACTIONS(4093),
    [anon_sym_operator] = ACTIONS(4093),
    [anon_sym_try] = ACTIONS(4093),
    [anon_sym_delete] = ACTIONS(4093),
    [anon_sym_throw] = ACTIONS(4093),
    [anon_sym_namespace] = ACTIONS(4093),
    [anon_sym_static_assert] = ACTIONS(4093),
    [anon_sym_concept] = ACTIONS(4093),
    [anon_sym_co_return] = ACTIONS(4093),
    [anon_sym_co_yield] = ACTIONS(4093),
    [anon_sym_R_DQUOTE] = ACTIONS(4095),
    [anon_sym_LR_DQUOTE] = ACTIONS(4095),
    [anon_sym_uR_DQUOTE] = ACTIONS(4095),
    [anon_sym_UR_DQUOTE] = ACTIONS(4095),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4095),
    [anon_sym_co_await] = ACTIONS(4093),
    [anon_sym_new] = ACTIONS(4093),
    [anon_sym_requires] = ACTIONS(4093),
    [sym_this] = ACTIONS(4093),
    [anon_sym_precise] = ACTIONS(4093),
    [anon_sym_shared] = ACTIONS(4093),
    [anon_sym_groupshared] = ACTIONS(4093),
    [anon_sym_uniform] = ACTIONS(4093),
    [anon_sym_row_major] = ACTIONS(4093),
    [anon_sym_column_major] = ACTIONS(4093),
    [anon_sym_globallycoherent] = ACTIONS(4093),
    [anon_sym_centroid] = ACTIONS(4093),
    [anon_sym_noperspective] = ACTIONS(4093),
    [anon_sym_nointerpolation] = ACTIONS(4093),
    [anon_sym_sample] = ACTIONS(4093),
    [anon_sym_linear] = ACTIONS(4093),
    [anon_sym_snorm] = ACTIONS(4093),
    [anon_sym_unorm] = ACTIONS(4093),
    [anon_sym_point] = ACTIONS(4093),
    [anon_sym_line] = ACTIONS(4093),
    [anon_sym_triangleadj] = ACTIONS(4093),
    [anon_sym_lineadj] = ACTIONS(4093),
    [anon_sym_triangle] = ACTIONS(4093),
    [anon_sym_interface] = ACTIONS(4093),
    [anon_sym_extension] = ACTIONS(4093),
    [anon_sym___exported] = ACTIONS(4093),
  },
  [715] = {
    [sym_identifier] = ACTIONS(3391),
    [aux_sym_preproc_include_token1] = ACTIONS(3391),
    [aux_sym_preproc_def_token1] = ACTIONS(3391),
    [aux_sym_preproc_if_token1] = ACTIONS(3391),
    [aux_sym_preproc_if_token2] = ACTIONS(3391),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3391),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3391),
    [sym_preproc_directive] = ACTIONS(3391),
    [anon_sym_LPAREN2] = ACTIONS(3393),
    [anon_sym_BANG] = ACTIONS(3393),
    [anon_sym_TILDE] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_STAR] = ACTIONS(3393),
    [anon_sym_AMP_AMP] = ACTIONS(3393),
    [anon_sym_AMP] = ACTIONS(3391),
    [anon_sym_SEMI] = ACTIONS(3393),
    [anon_sym___extension__] = ACTIONS(3391),
    [anon_sym_typedef] = ACTIONS(3391),
    [anon_sym_in] = ACTIONS(3391),
    [anon_sym_out] = ACTIONS(3391),
    [anon_sym_inout] = ACTIONS(3391),
    [anon_sym_virtual] = ACTIONS(3391),
    [anon_sym_extern] = ACTIONS(3391),
    [anon_sym___attribute__] = ACTIONS(3391),
    [anon_sym___attribute] = ACTIONS(3391),
    [anon_sym_using] = ACTIONS(3391),
    [anon_sym_COLON_COLON] = ACTIONS(3393),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3393),
    [anon_sym___declspec] = ACTIONS(3391),
    [anon_sym___based] = ACTIONS(3391),
    [anon_sym___cdecl] = ACTIONS(3391),
    [anon_sym___clrcall] = ACTIONS(3391),
    [anon_sym___stdcall] = ACTIONS(3391),
    [anon_sym___fastcall] = ACTIONS(3391),
    [anon_sym___thiscall] = ACTIONS(3391),
    [anon_sym___vectorcall] = ACTIONS(3391),
    [anon_sym_LBRACE] = ACTIONS(3393),
    [anon_sym_signed] = ACTIONS(3391),
    [anon_sym_unsigned] = ACTIONS(3391),
    [anon_sym_long] = ACTIONS(3391),
    [anon_sym_short] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(3391),
    [anon_sym_static] = ACTIONS(3391),
    [anon_sym_register] = ACTIONS(3391),
    [anon_sym_inline] = ACTIONS(3391),
    [anon_sym___inline] = ACTIONS(3391),
    [anon_sym___inline__] = ACTIONS(3391),
    [anon_sym___forceinline] = ACTIONS(3391),
    [anon_sym_thread_local] = ACTIONS(3391),
    [anon_sym___thread] = ACTIONS(3391),
    [anon_sym_const] = ACTIONS(3391),
    [anon_sym_constexpr] = ACTIONS(3391),
    [anon_sym_volatile] = ACTIONS(3391),
    [anon_sym_restrict] = ACTIONS(3391),
    [anon_sym___restrict__] = ACTIONS(3391),
    [anon_sym__Atomic] = ACTIONS(3391),
    [anon_sym__Noreturn] = ACTIONS(3391),
    [anon_sym_noreturn] = ACTIONS(3391),
    [anon_sym__Nonnull] = ACTIONS(3391),
    [anon_sym_mutable] = ACTIONS(3391),
    [anon_sym_constinit] = ACTIONS(3391),
    [anon_sym_consteval] = ACTIONS(3391),
    [anon_sym_alignas] = ACTIONS(3391),
    [anon_sym__Alignas] = ACTIONS(3391),
    [sym_primitive_type] = ACTIONS(3391),
    [anon_sym_enum] = ACTIONS(3391),
    [anon_sym_class] = ACTIONS(3391),
    [anon_sym_struct] = ACTIONS(3391),
    [anon_sym_union] = ACTIONS(3391),
    [anon_sym_if] = ACTIONS(3391),
    [anon_sym_else] = ACTIONS(3391),
    [anon_sym_switch] = ACTIONS(3391),
    [anon_sym_case] = ACTIONS(3391),
    [anon_sym_default] = ACTIONS(3391),
    [anon_sym_while] = ACTIONS(3391),
    [anon_sym_do] = ACTIONS(3391),
    [anon_sym_for] = ACTIONS(3391),
    [anon_sym_return] = ACTIONS(3391),
    [anon_sym_break] = ACTIONS(3391),
    [anon_sym_continue] = ACTIONS(3391),
    [anon_sym_goto] = ACTIONS(3391),
    [anon_sym___try] = ACTIONS(3391),
    [anon_sym___leave] = ACTIONS(3391),
    [anon_sym_not] = ACTIONS(3391),
    [anon_sym_compl] = ACTIONS(3391),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_sizeof] = ACTIONS(3391),
    [anon_sym___alignof__] = ACTIONS(3391),
    [anon_sym___alignof] = ACTIONS(3391),
    [anon_sym__alignof] = ACTIONS(3391),
    [anon_sym_alignof] = ACTIONS(3391),
    [anon_sym__Alignof] = ACTIONS(3391),
    [anon_sym_offsetof] = ACTIONS(3391),
    [anon_sym__Generic] = ACTIONS(3391),
    [anon_sym_asm] = ACTIONS(3391),
    [anon_sym___asm__] = ACTIONS(3391),
    [anon_sym___asm] = ACTIONS(3391),
    [sym_number_literal] = ACTIONS(3393),
    [anon_sym_L_SQUOTE] = ACTIONS(3393),
    [anon_sym_u_SQUOTE] = ACTIONS(3393),
    [anon_sym_U_SQUOTE] = ACTIONS(3393),
    [anon_sym_u8_SQUOTE] = ACTIONS(3393),
    [anon_sym_SQUOTE] = ACTIONS(3393),
    [anon_sym_L_DQUOTE] = ACTIONS(3393),
    [anon_sym_u_DQUOTE] = ACTIONS(3393),
    [anon_sym_U_DQUOTE] = ACTIONS(3393),
    [anon_sym_u8_DQUOTE] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3393),
    [sym_true] = ACTIONS(3391),
    [sym_false] = ACTIONS(3391),
    [anon_sym_NULL] = ACTIONS(3391),
    [anon_sym_nullptr] = ACTIONS(3391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3391),
    [anon_sym_let] = ACTIONS(3391),
    [anon_sym_This] = ACTIONS(3391),
    [anon_sym_decltype] = ACTIONS(3391),
    [anon_sym_explicit] = ACTIONS(3391),
    [anon_sym_typename] = ACTIONS(3391),
    [anon_sym_template] = ACTIONS(3391),
    [anon_sym_operator] = ACTIONS(3391),
    [anon_sym_try] = ACTIONS(3391),
    [anon_sym_delete] = ACTIONS(3391),
    [anon_sym_throw] = ACTIONS(3391),
    [anon_sym_namespace] = ACTIONS(3391),
    [anon_sym_static_assert] = ACTIONS(3391),
    [anon_sym_concept] = ACTIONS(3391),
    [anon_sym_co_return] = ACTIONS(3391),
    [anon_sym_co_yield] = ACTIONS(3391),
    [anon_sym_R_DQUOTE] = ACTIONS(3393),
    [anon_sym_LR_DQUOTE] = ACTIONS(3393),
    [anon_sym_uR_DQUOTE] = ACTIONS(3393),
    [anon_sym_UR_DQUOTE] = ACTIONS(3393),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3393),
    [anon_sym_co_await] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(3391),
    [anon_sym_requires] = ACTIONS(3391),
    [sym_this] = ACTIONS(3391),
    [anon_sym_discard] = ACTIONS(3391),
    [anon_sym_precise] = ACTIONS(3391),
    [anon_sym_shared] = ACTIONS(3391),
    [anon_sym_groupshared] = ACTIONS(3391),
    [anon_sym_uniform] = ACTIONS(3391),
    [anon_sym_row_major] = ACTIONS(3391),
    [anon_sym_column_major] = ACTIONS(3391),
    [anon_sym_globallycoherent] = ACTIONS(3391),
    [anon_sym_centroid] = ACTIONS(3391),
    [anon_sym_noperspective] = ACTIONS(3391),
    [anon_sym_nointerpolation] = ACTIONS(3391),
    [anon_sym_sample] = ACTIONS(3391),
    [anon_sym_linear] = ACTIONS(3391),
    [anon_sym_snorm] = ACTIONS(3391),
    [anon_sym_unorm] = ACTIONS(3391),
    [anon_sym_point] = ACTIONS(3391),
    [anon_sym_line] = ACTIONS(3391),
    [anon_sym_triangleadj] = ACTIONS(3391),
    [anon_sym_lineadj] = ACTIONS(3391),
    [anon_sym_triangle] = ACTIONS(3391),
    [anon_sym_cbuffer] = ACTIONS(3391),
    [anon_sym_interface] = ACTIONS(3391),
    [anon_sym_extension] = ACTIONS(3391),
  },
  [716] = {
    [sym_identifier] = ACTIONS(3655),
    [aux_sym_preproc_include_token1] = ACTIONS(3655),
    [aux_sym_preproc_def_token1] = ACTIONS(3655),
    [aux_sym_preproc_if_token1] = ACTIONS(3655),
    [aux_sym_preproc_if_token2] = ACTIONS(3655),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3655),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3655),
    [sym_preproc_directive] = ACTIONS(3655),
    [anon_sym_LPAREN2] = ACTIONS(3653),
    [anon_sym_BANG] = ACTIONS(3653),
    [anon_sym_TILDE] = ACTIONS(3653),
    [anon_sym_DASH] = ACTIONS(3655),
    [anon_sym_PLUS] = ACTIONS(3655),
    [anon_sym_STAR] = ACTIONS(3653),
    [anon_sym_AMP_AMP] = ACTIONS(3653),
    [anon_sym_AMP] = ACTIONS(3655),
    [anon_sym_SEMI] = ACTIONS(3653),
    [anon_sym___extension__] = ACTIONS(3655),
    [anon_sym_typedef] = ACTIONS(3655),
    [anon_sym_in] = ACTIONS(3655),
    [anon_sym_out] = ACTIONS(3655),
    [anon_sym_inout] = ACTIONS(3655),
    [anon_sym_virtual] = ACTIONS(3655),
    [anon_sym_extern] = ACTIONS(3655),
    [anon_sym___attribute__] = ACTIONS(3655),
    [anon_sym___attribute] = ACTIONS(3655),
    [anon_sym_using] = ACTIONS(3655),
    [anon_sym_COLON_COLON] = ACTIONS(3653),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3653),
    [anon_sym___declspec] = ACTIONS(3655),
    [anon_sym___based] = ACTIONS(3655),
    [anon_sym___cdecl] = ACTIONS(3655),
    [anon_sym___clrcall] = ACTIONS(3655),
    [anon_sym___stdcall] = ACTIONS(3655),
    [anon_sym___fastcall] = ACTIONS(3655),
    [anon_sym___thiscall] = ACTIONS(3655),
    [anon_sym___vectorcall] = ACTIONS(3655),
    [anon_sym_LBRACE] = ACTIONS(3653),
    [anon_sym_signed] = ACTIONS(3655),
    [anon_sym_unsigned] = ACTIONS(3655),
    [anon_sym_long] = ACTIONS(3655),
    [anon_sym_short] = ACTIONS(3655),
    [anon_sym_LBRACK] = ACTIONS(3655),
    [anon_sym_static] = ACTIONS(3655),
    [anon_sym_register] = ACTIONS(3655),
    [anon_sym_inline] = ACTIONS(3655),
    [anon_sym___inline] = ACTIONS(3655),
    [anon_sym___inline__] = ACTIONS(3655),
    [anon_sym___forceinline] = ACTIONS(3655),
    [anon_sym_thread_local] = ACTIONS(3655),
    [anon_sym___thread] = ACTIONS(3655),
    [anon_sym_const] = ACTIONS(3655),
    [anon_sym_constexpr] = ACTIONS(3655),
    [anon_sym_volatile] = ACTIONS(3655),
    [anon_sym_restrict] = ACTIONS(3655),
    [anon_sym___restrict__] = ACTIONS(3655),
    [anon_sym__Atomic] = ACTIONS(3655),
    [anon_sym__Noreturn] = ACTIONS(3655),
    [anon_sym_noreturn] = ACTIONS(3655),
    [anon_sym__Nonnull] = ACTIONS(3655),
    [anon_sym_mutable] = ACTIONS(3655),
    [anon_sym_constinit] = ACTIONS(3655),
    [anon_sym_consteval] = ACTIONS(3655),
    [anon_sym_alignas] = ACTIONS(3655),
    [anon_sym__Alignas] = ACTIONS(3655),
    [sym_primitive_type] = ACTIONS(3655),
    [anon_sym_enum] = ACTIONS(3655),
    [anon_sym_class] = ACTIONS(3655),
    [anon_sym_struct] = ACTIONS(3655),
    [anon_sym_union] = ACTIONS(3655),
    [anon_sym_if] = ACTIONS(3655),
    [anon_sym_else] = ACTIONS(3655),
    [anon_sym_switch] = ACTIONS(3655),
    [anon_sym_case] = ACTIONS(3655),
    [anon_sym_default] = ACTIONS(3655),
    [anon_sym_while] = ACTIONS(3655),
    [anon_sym_do] = ACTIONS(3655),
    [anon_sym_for] = ACTIONS(3655),
    [anon_sym_return] = ACTIONS(3655),
    [anon_sym_break] = ACTIONS(3655),
    [anon_sym_continue] = ACTIONS(3655),
    [anon_sym_goto] = ACTIONS(3655),
    [anon_sym___try] = ACTIONS(3655),
    [anon_sym___leave] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3655),
    [anon_sym_compl] = ACTIONS(3655),
    [anon_sym_DASH_DASH] = ACTIONS(3653),
    [anon_sym_PLUS_PLUS] = ACTIONS(3653),
    [anon_sym_sizeof] = ACTIONS(3655),
    [anon_sym___alignof__] = ACTIONS(3655),
    [anon_sym___alignof] = ACTIONS(3655),
    [anon_sym__alignof] = ACTIONS(3655),
    [anon_sym_alignof] = ACTIONS(3655),
    [anon_sym__Alignof] = ACTIONS(3655),
    [anon_sym_offsetof] = ACTIONS(3655),
    [anon_sym__Generic] = ACTIONS(3655),
    [anon_sym_asm] = ACTIONS(3655),
    [anon_sym___asm__] = ACTIONS(3655),
    [anon_sym___asm] = ACTIONS(3655),
    [sym_number_literal] = ACTIONS(3653),
    [anon_sym_L_SQUOTE] = ACTIONS(3653),
    [anon_sym_u_SQUOTE] = ACTIONS(3653),
    [anon_sym_U_SQUOTE] = ACTIONS(3653),
    [anon_sym_u8_SQUOTE] = ACTIONS(3653),
    [anon_sym_SQUOTE] = ACTIONS(3653),
    [anon_sym_L_DQUOTE] = ACTIONS(3653),
    [anon_sym_u_DQUOTE] = ACTIONS(3653),
    [anon_sym_U_DQUOTE] = ACTIONS(3653),
    [anon_sym_u8_DQUOTE] = ACTIONS(3653),
    [anon_sym_DQUOTE] = ACTIONS(3653),
    [sym_true] = ACTIONS(3655),
    [sym_false] = ACTIONS(3655),
    [anon_sym_NULL] = ACTIONS(3655),
    [anon_sym_nullptr] = ACTIONS(3655),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3655),
    [anon_sym_let] = ACTIONS(3655),
    [anon_sym_This] = ACTIONS(3655),
    [anon_sym_decltype] = ACTIONS(3655),
    [anon_sym_explicit] = ACTIONS(3655),
    [anon_sym_typename] = ACTIONS(3655),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(3655),
    [anon_sym_try] = ACTIONS(3655),
    [anon_sym_delete] = ACTIONS(3655),
    [anon_sym_throw] = ACTIONS(3655),
    [anon_sym_namespace] = ACTIONS(3655),
    [anon_sym_static_assert] = ACTIONS(3655),
    [anon_sym_concept] = ACTIONS(3655),
    [anon_sym_co_return] = ACTIONS(3655),
    [anon_sym_co_yield] = ACTIONS(3655),
    [anon_sym_R_DQUOTE] = ACTIONS(3653),
    [anon_sym_LR_DQUOTE] = ACTIONS(3653),
    [anon_sym_uR_DQUOTE] = ACTIONS(3653),
    [anon_sym_UR_DQUOTE] = ACTIONS(3653),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3653),
    [anon_sym_co_await] = ACTIONS(3655),
    [anon_sym_new] = ACTIONS(3655),
    [anon_sym_requires] = ACTIONS(3655),
    [sym_this] = ACTIONS(3655),
    [anon_sym_discard] = ACTIONS(3655),
    [anon_sym_precise] = ACTIONS(3655),
    [anon_sym_shared] = ACTIONS(3655),
    [anon_sym_groupshared] = ACTIONS(3655),
    [anon_sym_uniform] = ACTIONS(3655),
    [anon_sym_row_major] = ACTIONS(3655),
    [anon_sym_column_major] = ACTIONS(3655),
    [anon_sym_globallycoherent] = ACTIONS(3655),
    [anon_sym_centroid] = ACTIONS(3655),
    [anon_sym_noperspective] = ACTIONS(3655),
    [anon_sym_nointerpolation] = ACTIONS(3655),
    [anon_sym_sample] = ACTIONS(3655),
    [anon_sym_linear] = ACTIONS(3655),
    [anon_sym_snorm] = ACTIONS(3655),
    [anon_sym_unorm] = ACTIONS(3655),
    [anon_sym_point] = ACTIONS(3655),
    [anon_sym_line] = ACTIONS(3655),
    [anon_sym_triangleadj] = ACTIONS(3655),
    [anon_sym_lineadj] = ACTIONS(3655),
    [anon_sym_triangle] = ACTIONS(3655),
    [anon_sym_cbuffer] = ACTIONS(3655),
    [anon_sym_interface] = ACTIONS(3655),
    [anon_sym_extension] = ACTIONS(3655),
  },
  [717] = {
    [sym_identifier] = ACTIONS(3585),
    [aux_sym_preproc_include_token1] = ACTIONS(3585),
    [aux_sym_preproc_def_token1] = ACTIONS(3585),
    [aux_sym_preproc_if_token1] = ACTIONS(3585),
    [aux_sym_preproc_if_token2] = ACTIONS(3585),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3585),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3585),
    [sym_preproc_directive] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(3587),
    [anon_sym_BANG] = ACTIONS(3587),
    [anon_sym_TILDE] = ACTIONS(3587),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_STAR] = ACTIONS(3587),
    [anon_sym_AMP_AMP] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_SEMI] = ACTIONS(3587),
    [anon_sym___extension__] = ACTIONS(3585),
    [anon_sym_typedef] = ACTIONS(3585),
    [anon_sym_in] = ACTIONS(3585),
    [anon_sym_out] = ACTIONS(3585),
    [anon_sym_inout] = ACTIONS(3585),
    [anon_sym_virtual] = ACTIONS(3585),
    [anon_sym_extern] = ACTIONS(3585),
    [anon_sym___attribute__] = ACTIONS(3585),
    [anon_sym___attribute] = ACTIONS(3585),
    [anon_sym_using] = ACTIONS(3585),
    [anon_sym_COLON_COLON] = ACTIONS(3587),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3587),
    [anon_sym___declspec] = ACTIONS(3585),
    [anon_sym___based] = ACTIONS(3585),
    [anon_sym___cdecl] = ACTIONS(3585),
    [anon_sym___clrcall] = ACTIONS(3585),
    [anon_sym___stdcall] = ACTIONS(3585),
    [anon_sym___fastcall] = ACTIONS(3585),
    [anon_sym___thiscall] = ACTIONS(3585),
    [anon_sym___vectorcall] = ACTIONS(3585),
    [anon_sym_LBRACE] = ACTIONS(3587),
    [anon_sym_signed] = ACTIONS(3585),
    [anon_sym_unsigned] = ACTIONS(3585),
    [anon_sym_long] = ACTIONS(3585),
    [anon_sym_short] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(3585),
    [anon_sym_static] = ACTIONS(3585),
    [anon_sym_register] = ACTIONS(3585),
    [anon_sym_inline] = ACTIONS(3585),
    [anon_sym___inline] = ACTIONS(3585),
    [anon_sym___inline__] = ACTIONS(3585),
    [anon_sym___forceinline] = ACTIONS(3585),
    [anon_sym_thread_local] = ACTIONS(3585),
    [anon_sym___thread] = ACTIONS(3585),
    [anon_sym_const] = ACTIONS(3585),
    [anon_sym_constexpr] = ACTIONS(3585),
    [anon_sym_volatile] = ACTIONS(3585),
    [anon_sym_restrict] = ACTIONS(3585),
    [anon_sym___restrict__] = ACTIONS(3585),
    [anon_sym__Atomic] = ACTIONS(3585),
    [anon_sym__Noreturn] = ACTIONS(3585),
    [anon_sym_noreturn] = ACTIONS(3585),
    [anon_sym__Nonnull] = ACTIONS(3585),
    [anon_sym_mutable] = ACTIONS(3585),
    [anon_sym_constinit] = ACTIONS(3585),
    [anon_sym_consteval] = ACTIONS(3585),
    [anon_sym_alignas] = ACTIONS(3585),
    [anon_sym__Alignas] = ACTIONS(3585),
    [sym_primitive_type] = ACTIONS(3585),
    [anon_sym_enum] = ACTIONS(3585),
    [anon_sym_class] = ACTIONS(3585),
    [anon_sym_struct] = ACTIONS(3585),
    [anon_sym_union] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_else] = ACTIONS(3585),
    [anon_sym_switch] = ACTIONS(3585),
    [anon_sym_case] = ACTIONS(3585),
    [anon_sym_default] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_do] = ACTIONS(3585),
    [anon_sym_for] = ACTIONS(3585),
    [anon_sym_return] = ACTIONS(3585),
    [anon_sym_break] = ACTIONS(3585),
    [anon_sym_continue] = ACTIONS(3585),
    [anon_sym_goto] = ACTIONS(3585),
    [anon_sym___try] = ACTIONS(3585),
    [anon_sym___leave] = ACTIONS(3585),
    [anon_sym_not] = ACTIONS(3585),
    [anon_sym_compl] = ACTIONS(3585),
    [anon_sym_DASH_DASH] = ACTIONS(3587),
    [anon_sym_PLUS_PLUS] = ACTIONS(3587),
    [anon_sym_sizeof] = ACTIONS(3585),
    [anon_sym___alignof__] = ACTIONS(3585),
    [anon_sym___alignof] = ACTIONS(3585),
    [anon_sym__alignof] = ACTIONS(3585),
    [anon_sym_alignof] = ACTIONS(3585),
    [anon_sym__Alignof] = ACTIONS(3585),
    [anon_sym_offsetof] = ACTIONS(3585),
    [anon_sym__Generic] = ACTIONS(3585),
    [anon_sym_asm] = ACTIONS(3585),
    [anon_sym___asm__] = ACTIONS(3585),
    [anon_sym___asm] = ACTIONS(3585),
    [sym_number_literal] = ACTIONS(3587),
    [anon_sym_L_SQUOTE] = ACTIONS(3587),
    [anon_sym_u_SQUOTE] = ACTIONS(3587),
    [anon_sym_U_SQUOTE] = ACTIONS(3587),
    [anon_sym_u8_SQUOTE] = ACTIONS(3587),
    [anon_sym_SQUOTE] = ACTIONS(3587),
    [anon_sym_L_DQUOTE] = ACTIONS(3587),
    [anon_sym_u_DQUOTE] = ACTIONS(3587),
    [anon_sym_U_DQUOTE] = ACTIONS(3587),
    [anon_sym_u8_DQUOTE] = ACTIONS(3587),
    [anon_sym_DQUOTE] = ACTIONS(3587),
    [sym_true] = ACTIONS(3585),
    [sym_false] = ACTIONS(3585),
    [anon_sym_NULL] = ACTIONS(3585),
    [anon_sym_nullptr] = ACTIONS(3585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3585),
    [anon_sym_let] = ACTIONS(3585),
    [anon_sym_This] = ACTIONS(3585),
    [anon_sym_decltype] = ACTIONS(3585),
    [anon_sym_explicit] = ACTIONS(3585),
    [anon_sym_typename] = ACTIONS(3585),
    [anon_sym_template] = ACTIONS(3585),
    [anon_sym_operator] = ACTIONS(3585),
    [anon_sym_try] = ACTIONS(3585),
    [anon_sym_delete] = ACTIONS(3585),
    [anon_sym_throw] = ACTIONS(3585),
    [anon_sym_namespace] = ACTIONS(3585),
    [anon_sym_static_assert] = ACTIONS(3585),
    [anon_sym_concept] = ACTIONS(3585),
    [anon_sym_co_return] = ACTIONS(3585),
    [anon_sym_co_yield] = ACTIONS(3585),
    [anon_sym_R_DQUOTE] = ACTIONS(3587),
    [anon_sym_LR_DQUOTE] = ACTIONS(3587),
    [anon_sym_uR_DQUOTE] = ACTIONS(3587),
    [anon_sym_UR_DQUOTE] = ACTIONS(3587),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3587),
    [anon_sym_co_await] = ACTIONS(3585),
    [anon_sym_new] = ACTIONS(3585),
    [anon_sym_requires] = ACTIONS(3585),
    [sym_this] = ACTIONS(3585),
    [anon_sym_discard] = ACTIONS(3585),
    [anon_sym_precise] = ACTIONS(3585),
    [anon_sym_shared] = ACTIONS(3585),
    [anon_sym_groupshared] = ACTIONS(3585),
    [anon_sym_uniform] = ACTIONS(3585),
    [anon_sym_row_major] = ACTIONS(3585),
    [anon_sym_column_major] = ACTIONS(3585),
    [anon_sym_globallycoherent] = ACTIONS(3585),
    [anon_sym_centroid] = ACTIONS(3585),
    [anon_sym_noperspective] = ACTIONS(3585),
    [anon_sym_nointerpolation] = ACTIONS(3585),
    [anon_sym_sample] = ACTIONS(3585),
    [anon_sym_linear] = ACTIONS(3585),
    [anon_sym_snorm] = ACTIONS(3585),
    [anon_sym_unorm] = ACTIONS(3585),
    [anon_sym_point] = ACTIONS(3585),
    [anon_sym_line] = ACTIONS(3585),
    [anon_sym_triangleadj] = ACTIONS(3585),
    [anon_sym_lineadj] = ACTIONS(3585),
    [anon_sym_triangle] = ACTIONS(3585),
    [anon_sym_cbuffer] = ACTIONS(3585),
    [anon_sym_interface] = ACTIONS(3585),
    [anon_sym_extension] = ACTIONS(3585),
  },
  [718] = {
    [sym_identifier] = ACTIONS(3593),
    [aux_sym_preproc_include_token1] = ACTIONS(3593),
    [aux_sym_preproc_def_token1] = ACTIONS(3593),
    [aux_sym_preproc_if_token1] = ACTIONS(3593),
    [aux_sym_preproc_if_token2] = ACTIONS(3593),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3593),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3593),
    [sym_preproc_directive] = ACTIONS(3593),
    [anon_sym_LPAREN2] = ACTIONS(3595),
    [anon_sym_BANG] = ACTIONS(3595),
    [anon_sym_TILDE] = ACTIONS(3595),
    [anon_sym_DASH] = ACTIONS(3593),
    [anon_sym_PLUS] = ACTIONS(3593),
    [anon_sym_STAR] = ACTIONS(3595),
    [anon_sym_AMP_AMP] = ACTIONS(3595),
    [anon_sym_AMP] = ACTIONS(3593),
    [anon_sym_SEMI] = ACTIONS(3595),
    [anon_sym___extension__] = ACTIONS(3593),
    [anon_sym_typedef] = ACTIONS(3593),
    [anon_sym_in] = ACTIONS(3593),
    [anon_sym_out] = ACTIONS(3593),
    [anon_sym_inout] = ACTIONS(3593),
    [anon_sym_virtual] = ACTIONS(3593),
    [anon_sym_extern] = ACTIONS(3593),
    [anon_sym___attribute__] = ACTIONS(3593),
    [anon_sym___attribute] = ACTIONS(3593),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_COLON_COLON] = ACTIONS(3595),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3595),
    [anon_sym___declspec] = ACTIONS(3593),
    [anon_sym___based] = ACTIONS(3593),
    [anon_sym___cdecl] = ACTIONS(3593),
    [anon_sym___clrcall] = ACTIONS(3593),
    [anon_sym___stdcall] = ACTIONS(3593),
    [anon_sym___fastcall] = ACTIONS(3593),
    [anon_sym___thiscall] = ACTIONS(3593),
    [anon_sym___vectorcall] = ACTIONS(3593),
    [anon_sym_LBRACE] = ACTIONS(3595),
    [anon_sym_signed] = ACTIONS(3593),
    [anon_sym_unsigned] = ACTIONS(3593),
    [anon_sym_long] = ACTIONS(3593),
    [anon_sym_short] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(3593),
    [anon_sym_static] = ACTIONS(3593),
    [anon_sym_register] = ACTIONS(3593),
    [anon_sym_inline] = ACTIONS(3593),
    [anon_sym___inline] = ACTIONS(3593),
    [anon_sym___inline__] = ACTIONS(3593),
    [anon_sym___forceinline] = ACTIONS(3593),
    [anon_sym_thread_local] = ACTIONS(3593),
    [anon_sym___thread] = ACTIONS(3593),
    [anon_sym_const] = ACTIONS(3593),
    [anon_sym_constexpr] = ACTIONS(3593),
    [anon_sym_volatile] = ACTIONS(3593),
    [anon_sym_restrict] = ACTIONS(3593),
    [anon_sym___restrict__] = ACTIONS(3593),
    [anon_sym__Atomic] = ACTIONS(3593),
    [anon_sym__Noreturn] = ACTIONS(3593),
    [anon_sym_noreturn] = ACTIONS(3593),
    [anon_sym__Nonnull] = ACTIONS(3593),
    [anon_sym_mutable] = ACTIONS(3593),
    [anon_sym_constinit] = ACTIONS(3593),
    [anon_sym_consteval] = ACTIONS(3593),
    [anon_sym_alignas] = ACTIONS(3593),
    [anon_sym__Alignas] = ACTIONS(3593),
    [sym_primitive_type] = ACTIONS(3593),
    [anon_sym_enum] = ACTIONS(3593),
    [anon_sym_class] = ACTIONS(3593),
    [anon_sym_struct] = ACTIONS(3593),
    [anon_sym_union] = ACTIONS(3593),
    [anon_sym_if] = ACTIONS(3593),
    [anon_sym_else] = ACTIONS(3593),
    [anon_sym_switch] = ACTIONS(3593),
    [anon_sym_case] = ACTIONS(3593),
    [anon_sym_default] = ACTIONS(3593),
    [anon_sym_while] = ACTIONS(3593),
    [anon_sym_do] = ACTIONS(3593),
    [anon_sym_for] = ACTIONS(3593),
    [anon_sym_return] = ACTIONS(3593),
    [anon_sym_break] = ACTIONS(3593),
    [anon_sym_continue] = ACTIONS(3593),
    [anon_sym_goto] = ACTIONS(3593),
    [anon_sym___try] = ACTIONS(3593),
    [anon_sym___leave] = ACTIONS(3593),
    [anon_sym_not] = ACTIONS(3593),
    [anon_sym_compl] = ACTIONS(3593),
    [anon_sym_DASH_DASH] = ACTIONS(3595),
    [anon_sym_PLUS_PLUS] = ACTIONS(3595),
    [anon_sym_sizeof] = ACTIONS(3593),
    [anon_sym___alignof__] = ACTIONS(3593),
    [anon_sym___alignof] = ACTIONS(3593),
    [anon_sym__alignof] = ACTIONS(3593),
    [anon_sym_alignof] = ACTIONS(3593),
    [anon_sym__Alignof] = ACTIONS(3593),
    [anon_sym_offsetof] = ACTIONS(3593),
    [anon_sym__Generic] = ACTIONS(3593),
    [anon_sym_asm] = ACTIONS(3593),
    [anon_sym___asm__] = ACTIONS(3593),
    [anon_sym___asm] = ACTIONS(3593),
    [sym_number_literal] = ACTIONS(3595),
    [anon_sym_L_SQUOTE] = ACTIONS(3595),
    [anon_sym_u_SQUOTE] = ACTIONS(3595),
    [anon_sym_U_SQUOTE] = ACTIONS(3595),
    [anon_sym_u8_SQUOTE] = ACTIONS(3595),
    [anon_sym_SQUOTE] = ACTIONS(3595),
    [anon_sym_L_DQUOTE] = ACTIONS(3595),
    [anon_sym_u_DQUOTE] = ACTIONS(3595),
    [anon_sym_U_DQUOTE] = ACTIONS(3595),
    [anon_sym_u8_DQUOTE] = ACTIONS(3595),
    [anon_sym_DQUOTE] = ACTIONS(3595),
    [sym_true] = ACTIONS(3593),
    [sym_false] = ACTIONS(3593),
    [anon_sym_NULL] = ACTIONS(3593),
    [anon_sym_nullptr] = ACTIONS(3593),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3593),
    [anon_sym_let] = ACTIONS(3593),
    [anon_sym_This] = ACTIONS(3593),
    [anon_sym_decltype] = ACTIONS(3593),
    [anon_sym_explicit] = ACTIONS(3593),
    [anon_sym_typename] = ACTIONS(3593),
    [anon_sym_template] = ACTIONS(3593),
    [anon_sym_operator] = ACTIONS(3593),
    [anon_sym_try] = ACTIONS(3593),
    [anon_sym_delete] = ACTIONS(3593),
    [anon_sym_throw] = ACTIONS(3593),
    [anon_sym_namespace] = ACTIONS(3593),
    [anon_sym_static_assert] = ACTIONS(3593),
    [anon_sym_concept] = ACTIONS(3593),
    [anon_sym_co_return] = ACTIONS(3593),
    [anon_sym_co_yield] = ACTIONS(3593),
    [anon_sym_R_DQUOTE] = ACTIONS(3595),
    [anon_sym_LR_DQUOTE] = ACTIONS(3595),
    [anon_sym_uR_DQUOTE] = ACTIONS(3595),
    [anon_sym_UR_DQUOTE] = ACTIONS(3595),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3595),
    [anon_sym_co_await] = ACTIONS(3593),
    [anon_sym_new] = ACTIONS(3593),
    [anon_sym_requires] = ACTIONS(3593),
    [sym_this] = ACTIONS(3593),
    [anon_sym_discard] = ACTIONS(3593),
    [anon_sym_precise] = ACTIONS(3593),
    [anon_sym_shared] = ACTIONS(3593),
    [anon_sym_groupshared] = ACTIONS(3593),
    [anon_sym_uniform] = ACTIONS(3593),
    [anon_sym_row_major] = ACTIONS(3593),
    [anon_sym_column_major] = ACTIONS(3593),
    [anon_sym_globallycoherent] = ACTIONS(3593),
    [anon_sym_centroid] = ACTIONS(3593),
    [anon_sym_noperspective] = ACTIONS(3593),
    [anon_sym_nointerpolation] = ACTIONS(3593),
    [anon_sym_sample] = ACTIONS(3593),
    [anon_sym_linear] = ACTIONS(3593),
    [anon_sym_snorm] = ACTIONS(3593),
    [anon_sym_unorm] = ACTIONS(3593),
    [anon_sym_point] = ACTIONS(3593),
    [anon_sym_line] = ACTIONS(3593),
    [anon_sym_triangleadj] = ACTIONS(3593),
    [anon_sym_lineadj] = ACTIONS(3593),
    [anon_sym_triangle] = ACTIONS(3593),
    [anon_sym_cbuffer] = ACTIONS(3593),
    [anon_sym_interface] = ACTIONS(3593),
    [anon_sym_extension] = ACTIONS(3593),
  },
  [719] = {
    [ts_builtin_sym_end] = ACTIONS(4240),
    [sym_identifier] = ACTIONS(4242),
    [aux_sym_preproc_include_token1] = ACTIONS(4242),
    [aux_sym_preproc_def_token1] = ACTIONS(4242),
    [aux_sym_preproc_if_token1] = ACTIONS(4242),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4242),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4242),
    [sym_preproc_directive] = ACTIONS(4242),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_BANG] = ACTIONS(4240),
    [anon_sym_TILDE] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4242),
    [anon_sym_PLUS] = ACTIONS(4242),
    [anon_sym_STAR] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_AMP] = ACTIONS(4242),
    [anon_sym_SEMI] = ACTIONS(4240),
    [anon_sym___extension__] = ACTIONS(4242),
    [anon_sym_typedef] = ACTIONS(4242),
    [anon_sym_in] = ACTIONS(4242),
    [anon_sym_out] = ACTIONS(4242),
    [anon_sym_inout] = ACTIONS(4242),
    [anon_sym_virtual] = ACTIONS(4242),
    [anon_sym_extern] = ACTIONS(4242),
    [anon_sym___attribute__] = ACTIONS(4242),
    [anon_sym___attribute] = ACTIONS(4242),
    [anon_sym_using] = ACTIONS(4242),
    [anon_sym_COLON_COLON] = ACTIONS(4240),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4240),
    [anon_sym___declspec] = ACTIONS(4242),
    [anon_sym___based] = ACTIONS(4242),
    [anon_sym___cdecl] = ACTIONS(4242),
    [anon_sym___clrcall] = ACTIONS(4242),
    [anon_sym___stdcall] = ACTIONS(4242),
    [anon_sym___fastcall] = ACTIONS(4242),
    [anon_sym___thiscall] = ACTIONS(4242),
    [anon_sym___vectorcall] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_signed] = ACTIONS(4242),
    [anon_sym_unsigned] = ACTIONS(4242),
    [anon_sym_long] = ACTIONS(4242),
    [anon_sym_short] = ACTIONS(4242),
    [anon_sym_LBRACK] = ACTIONS(4242),
    [anon_sym_static] = ACTIONS(4242),
    [anon_sym_register] = ACTIONS(4242),
    [anon_sym_inline] = ACTIONS(4242),
    [anon_sym___inline] = ACTIONS(4242),
    [anon_sym___inline__] = ACTIONS(4242),
    [anon_sym___forceinline] = ACTIONS(4242),
    [anon_sym_thread_local] = ACTIONS(4242),
    [anon_sym___thread] = ACTIONS(4242),
    [anon_sym_const] = ACTIONS(4242),
    [anon_sym_constexpr] = ACTIONS(4242),
    [anon_sym_volatile] = ACTIONS(4242),
    [anon_sym_restrict] = ACTIONS(4242),
    [anon_sym___restrict__] = ACTIONS(4242),
    [anon_sym__Atomic] = ACTIONS(4242),
    [anon_sym__Noreturn] = ACTIONS(4242),
    [anon_sym_noreturn] = ACTIONS(4242),
    [anon_sym__Nonnull] = ACTIONS(4242),
    [anon_sym_mutable] = ACTIONS(4242),
    [anon_sym_constinit] = ACTIONS(4242),
    [anon_sym_consteval] = ACTIONS(4242),
    [anon_sym_alignas] = ACTIONS(4242),
    [anon_sym__Alignas] = ACTIONS(4242),
    [sym_primitive_type] = ACTIONS(4242),
    [anon_sym_enum] = ACTIONS(4242),
    [anon_sym_class] = ACTIONS(4242),
    [anon_sym_struct] = ACTIONS(4242),
    [anon_sym_union] = ACTIONS(4242),
    [anon_sym_if] = ACTIONS(4242),
    [anon_sym_switch] = ACTIONS(4242),
    [anon_sym_case] = ACTIONS(4242),
    [anon_sym_default] = ACTIONS(4242),
    [anon_sym_while] = ACTIONS(4242),
    [anon_sym_do] = ACTIONS(4242),
    [anon_sym_for] = ACTIONS(4242),
    [anon_sym_return] = ACTIONS(4242),
    [anon_sym_break] = ACTIONS(4242),
    [anon_sym_continue] = ACTIONS(4242),
    [anon_sym_goto] = ACTIONS(4242),
    [anon_sym_not] = ACTIONS(4242),
    [anon_sym_compl] = ACTIONS(4242),
    [anon_sym_DASH_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_PLUS] = ACTIONS(4240),
    [anon_sym_sizeof] = ACTIONS(4242),
    [anon_sym___alignof__] = ACTIONS(4242),
    [anon_sym___alignof] = ACTIONS(4242),
    [anon_sym__alignof] = ACTIONS(4242),
    [anon_sym_alignof] = ACTIONS(4242),
    [anon_sym__Alignof] = ACTIONS(4242),
    [anon_sym_offsetof] = ACTIONS(4242),
    [anon_sym__Generic] = ACTIONS(4242),
    [anon_sym_asm] = ACTIONS(4242),
    [anon_sym___asm__] = ACTIONS(4242),
    [anon_sym___asm] = ACTIONS(4242),
    [anon_sym_DOT] = ACTIONS(4242),
    [sym_number_literal] = ACTIONS(4240),
    [anon_sym_L_SQUOTE] = ACTIONS(4240),
    [anon_sym_u_SQUOTE] = ACTIONS(4240),
    [anon_sym_U_SQUOTE] = ACTIONS(4240),
    [anon_sym_u8_SQUOTE] = ACTIONS(4240),
    [anon_sym_SQUOTE] = ACTIONS(4240),
    [anon_sym_L_DQUOTE] = ACTIONS(4240),
    [anon_sym_u_DQUOTE] = ACTIONS(4240),
    [anon_sym_U_DQUOTE] = ACTIONS(4240),
    [anon_sym_u8_DQUOTE] = ACTIONS(4240),
    [anon_sym_DQUOTE] = ACTIONS(4240),
    [sym_true] = ACTIONS(4242),
    [sym_false] = ACTIONS(4242),
    [anon_sym_NULL] = ACTIONS(4242),
    [anon_sym_nullptr] = ACTIONS(4242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4242),
    [anon_sym_let] = ACTIONS(4242),
    [anon_sym_This] = ACTIONS(4242),
    [anon_sym_decltype] = ACTIONS(4242),
    [anon_sym_explicit] = ACTIONS(4242),
    [anon_sym_typename] = ACTIONS(4242),
    [anon_sym_export] = ACTIONS(4242),
    [anon_sym_module] = ACTIONS(4242),
    [anon_sym_import] = ACTIONS(4242),
    [anon_sym_template] = ACTIONS(4242),
    [anon_sym_operator] = ACTIONS(4242),
    [anon_sym_try] = ACTIONS(4242),
    [anon_sym_delete] = ACTIONS(4242),
    [anon_sym_throw] = ACTIONS(4242),
    [anon_sym_namespace] = ACTIONS(4242),
    [anon_sym_static_assert] = ACTIONS(4242),
    [anon_sym_concept] = ACTIONS(4242),
    [anon_sym_co_return] = ACTIONS(4242),
    [anon_sym_co_yield] = ACTIONS(4242),
    [anon_sym_R_DQUOTE] = ACTIONS(4240),
    [anon_sym_LR_DQUOTE] = ACTIONS(4240),
    [anon_sym_uR_DQUOTE] = ACTIONS(4240),
    [anon_sym_UR_DQUOTE] = ACTIONS(4240),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4240),
    [anon_sym_co_await] = ACTIONS(4242),
    [anon_sym_new] = ACTIONS(4242),
    [anon_sym_requires] = ACTIONS(4242),
    [sym_this] = ACTIONS(4242),
    [anon_sym_precise] = ACTIONS(4242),
    [anon_sym_shared] = ACTIONS(4242),
    [anon_sym_groupshared] = ACTIONS(4242),
    [anon_sym_uniform] = ACTIONS(4242),
    [anon_sym_row_major] = ACTIONS(4242),
    [anon_sym_column_major] = ACTIONS(4242),
    [anon_sym_globallycoherent] = ACTIONS(4242),
    [anon_sym_centroid] = ACTIONS(4242),
    [anon_sym_noperspective] = ACTIONS(4242),
    [anon_sym_nointerpolation] = ACTIONS(4242),
    [anon_sym_sample] = ACTIONS(4242),
    [anon_sym_linear] = ACTIONS(4242),
    [anon_sym_snorm] = ACTIONS(4242),
    [anon_sym_unorm] = ACTIONS(4242),
    [anon_sym_point] = ACTIONS(4242),
    [anon_sym_line] = ACTIONS(4242),
    [anon_sym_triangleadj] = ACTIONS(4242),
    [anon_sym_lineadj] = ACTIONS(4242),
    [anon_sym_triangle] = ACTIONS(4242),
    [anon_sym_interface] = ACTIONS(4242),
    [anon_sym_extension] = ACTIONS(4242),
    [anon_sym___exported] = ACTIONS(4242),
  },
  [720] = {
    [sym_identifier] = ACTIONS(3417),
    [aux_sym_preproc_include_token1] = ACTIONS(3417),
    [aux_sym_preproc_def_token1] = ACTIONS(3417),
    [aux_sym_preproc_if_token1] = ACTIONS(3417),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3417),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3417),
    [sym_preproc_directive] = ACTIONS(3417),
    [anon_sym_LPAREN2] = ACTIONS(3415),
    [anon_sym_BANG] = ACTIONS(3415),
    [anon_sym_TILDE] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_STAR] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3415),
    [anon_sym_AMP] = ACTIONS(3417),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym___extension__] = ACTIONS(3417),
    [anon_sym_typedef] = ACTIONS(3417),
    [anon_sym_in] = ACTIONS(3417),
    [anon_sym_out] = ACTIONS(3417),
    [anon_sym_inout] = ACTIONS(3417),
    [anon_sym_virtual] = ACTIONS(3417),
    [anon_sym_extern] = ACTIONS(3417),
    [anon_sym___attribute__] = ACTIONS(3417),
    [anon_sym___attribute] = ACTIONS(3417),
    [anon_sym_using] = ACTIONS(3417),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3415),
    [anon_sym___declspec] = ACTIONS(3417),
    [anon_sym___based] = ACTIONS(3417),
    [anon_sym___cdecl] = ACTIONS(3417),
    [anon_sym___clrcall] = ACTIONS(3417),
    [anon_sym___stdcall] = ACTIONS(3417),
    [anon_sym___fastcall] = ACTIONS(3417),
    [anon_sym___thiscall] = ACTIONS(3417),
    [anon_sym___vectorcall] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3415),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_signed] = ACTIONS(3417),
    [anon_sym_unsigned] = ACTIONS(3417),
    [anon_sym_long] = ACTIONS(3417),
    [anon_sym_short] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_static] = ACTIONS(3417),
    [anon_sym_register] = ACTIONS(3417),
    [anon_sym_inline] = ACTIONS(3417),
    [anon_sym___inline] = ACTIONS(3417),
    [anon_sym___inline__] = ACTIONS(3417),
    [anon_sym___forceinline] = ACTIONS(3417),
    [anon_sym_thread_local] = ACTIONS(3417),
    [anon_sym___thread] = ACTIONS(3417),
    [anon_sym_const] = ACTIONS(3417),
    [anon_sym_constexpr] = ACTIONS(3417),
    [anon_sym_volatile] = ACTIONS(3417),
    [anon_sym_restrict] = ACTIONS(3417),
    [anon_sym___restrict__] = ACTIONS(3417),
    [anon_sym__Atomic] = ACTIONS(3417),
    [anon_sym__Noreturn] = ACTIONS(3417),
    [anon_sym_noreturn] = ACTIONS(3417),
    [anon_sym__Nonnull] = ACTIONS(3417),
    [anon_sym_mutable] = ACTIONS(3417),
    [anon_sym_constinit] = ACTIONS(3417),
    [anon_sym_consteval] = ACTIONS(3417),
    [anon_sym_alignas] = ACTIONS(3417),
    [anon_sym__Alignas] = ACTIONS(3417),
    [sym_primitive_type] = ACTIONS(3417),
    [anon_sym_enum] = ACTIONS(3417),
    [anon_sym_class] = ACTIONS(3417),
    [anon_sym_struct] = ACTIONS(3417),
    [anon_sym_union] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_else] = ACTIONS(3417),
    [anon_sym_switch] = ACTIONS(3417),
    [anon_sym_case] = ACTIONS(3417),
    [anon_sym_default] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_break] = ACTIONS(3417),
    [anon_sym_continue] = ACTIONS(3417),
    [anon_sym_goto] = ACTIONS(3417),
    [anon_sym___try] = ACTIONS(3417),
    [anon_sym___leave] = ACTIONS(3417),
    [anon_sym_not] = ACTIONS(3417),
    [anon_sym_compl] = ACTIONS(3417),
    [anon_sym_DASH_DASH] = ACTIONS(3415),
    [anon_sym_PLUS_PLUS] = ACTIONS(3415),
    [anon_sym_sizeof] = ACTIONS(3417),
    [anon_sym___alignof__] = ACTIONS(3417),
    [anon_sym___alignof] = ACTIONS(3417),
    [anon_sym__alignof] = ACTIONS(3417),
    [anon_sym_alignof] = ACTIONS(3417),
    [anon_sym__Alignof] = ACTIONS(3417),
    [anon_sym_offsetof] = ACTIONS(3417),
    [anon_sym__Generic] = ACTIONS(3417),
    [anon_sym_asm] = ACTIONS(3417),
    [anon_sym___asm__] = ACTIONS(3417),
    [anon_sym___asm] = ACTIONS(3417),
    [sym_number_literal] = ACTIONS(3415),
    [anon_sym_L_SQUOTE] = ACTIONS(3415),
    [anon_sym_u_SQUOTE] = ACTIONS(3415),
    [anon_sym_U_SQUOTE] = ACTIONS(3415),
    [anon_sym_u8_SQUOTE] = ACTIONS(3415),
    [anon_sym_SQUOTE] = ACTIONS(3415),
    [anon_sym_L_DQUOTE] = ACTIONS(3415),
    [anon_sym_u_DQUOTE] = ACTIONS(3415),
    [anon_sym_U_DQUOTE] = ACTIONS(3415),
    [anon_sym_u8_DQUOTE] = ACTIONS(3415),
    [anon_sym_DQUOTE] = ACTIONS(3415),
    [sym_true] = ACTIONS(3417),
    [sym_false] = ACTIONS(3417),
    [anon_sym_NULL] = ACTIONS(3417),
    [anon_sym_nullptr] = ACTIONS(3417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_This] = ACTIONS(3417),
    [anon_sym_decltype] = ACTIONS(3417),
    [anon_sym_explicit] = ACTIONS(3417),
    [anon_sym_typename] = ACTIONS(3417),
    [anon_sym_template] = ACTIONS(3417),
    [anon_sym_operator] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_delete] = ACTIONS(3417),
    [anon_sym_throw] = ACTIONS(3417),
    [anon_sym_namespace] = ACTIONS(3417),
    [anon_sym_static_assert] = ACTIONS(3417),
    [anon_sym_concept] = ACTIONS(3417),
    [anon_sym_co_return] = ACTIONS(3417),
    [anon_sym_co_yield] = ACTIONS(3417),
    [anon_sym_R_DQUOTE] = ACTIONS(3415),
    [anon_sym_LR_DQUOTE] = ACTIONS(3415),
    [anon_sym_uR_DQUOTE] = ACTIONS(3415),
    [anon_sym_UR_DQUOTE] = ACTIONS(3415),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3415),
    [anon_sym_co_await] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_requires] = ACTIONS(3417),
    [sym_this] = ACTIONS(3417),
    [anon_sym_discard] = ACTIONS(3417),
    [anon_sym_precise] = ACTIONS(3417),
    [anon_sym_shared] = ACTIONS(3417),
    [anon_sym_groupshared] = ACTIONS(3417),
    [anon_sym_uniform] = ACTIONS(3417),
    [anon_sym_row_major] = ACTIONS(3417),
    [anon_sym_column_major] = ACTIONS(3417),
    [anon_sym_globallycoherent] = ACTIONS(3417),
    [anon_sym_centroid] = ACTIONS(3417),
    [anon_sym_noperspective] = ACTIONS(3417),
    [anon_sym_nointerpolation] = ACTIONS(3417),
    [anon_sym_sample] = ACTIONS(3417),
    [anon_sym_linear] = ACTIONS(3417),
    [anon_sym_snorm] = ACTIONS(3417),
    [anon_sym_unorm] = ACTIONS(3417),
    [anon_sym_point] = ACTIONS(3417),
    [anon_sym_line] = ACTIONS(3417),
    [anon_sym_triangleadj] = ACTIONS(3417),
    [anon_sym_lineadj] = ACTIONS(3417),
    [anon_sym_triangle] = ACTIONS(3417),
    [anon_sym_cbuffer] = ACTIONS(3417),
    [anon_sym_interface] = ACTIONS(3417),
    [anon_sym_extension] = ACTIONS(3417),
  },
  [721] = {
    [sym_identifier] = ACTIONS(3520),
    [aux_sym_preproc_include_token1] = ACTIONS(3520),
    [aux_sym_preproc_def_token1] = ACTIONS(3520),
    [aux_sym_preproc_if_token1] = ACTIONS(3520),
    [aux_sym_preproc_if_token2] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3520),
    [sym_preproc_directive] = ACTIONS(3520),
    [anon_sym_LPAREN2] = ACTIONS(3518),
    [anon_sym_BANG] = ACTIONS(3518),
    [anon_sym_TILDE] = ACTIONS(3518),
    [anon_sym_DASH] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3520),
    [anon_sym_STAR] = ACTIONS(3518),
    [anon_sym_AMP_AMP] = ACTIONS(3518),
    [anon_sym_AMP] = ACTIONS(3520),
    [anon_sym_SEMI] = ACTIONS(3518),
    [anon_sym___extension__] = ACTIONS(3520),
    [anon_sym_typedef] = ACTIONS(3520),
    [anon_sym_in] = ACTIONS(3520),
    [anon_sym_out] = ACTIONS(3520),
    [anon_sym_inout] = ACTIONS(3520),
    [anon_sym_virtual] = ACTIONS(3520),
    [anon_sym_extern] = ACTIONS(3520),
    [anon_sym___attribute__] = ACTIONS(3520),
    [anon_sym___attribute] = ACTIONS(3520),
    [anon_sym_using] = ACTIONS(3520),
    [anon_sym_COLON_COLON] = ACTIONS(3518),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3518),
    [anon_sym___declspec] = ACTIONS(3520),
    [anon_sym___based] = ACTIONS(3520),
    [anon_sym___cdecl] = ACTIONS(3520),
    [anon_sym___clrcall] = ACTIONS(3520),
    [anon_sym___stdcall] = ACTIONS(3520),
    [anon_sym___fastcall] = ACTIONS(3520),
    [anon_sym___thiscall] = ACTIONS(3520),
    [anon_sym___vectorcall] = ACTIONS(3520),
    [anon_sym_LBRACE] = ACTIONS(3518),
    [anon_sym_signed] = ACTIONS(3520),
    [anon_sym_unsigned] = ACTIONS(3520),
    [anon_sym_long] = ACTIONS(3520),
    [anon_sym_short] = ACTIONS(3520),
    [anon_sym_LBRACK] = ACTIONS(3520),
    [anon_sym_static] = ACTIONS(3520),
    [anon_sym_register] = ACTIONS(3520),
    [anon_sym_inline] = ACTIONS(3520),
    [anon_sym___inline] = ACTIONS(3520),
    [anon_sym___inline__] = ACTIONS(3520),
    [anon_sym___forceinline] = ACTIONS(3520),
    [anon_sym_thread_local] = ACTIONS(3520),
    [anon_sym___thread] = ACTIONS(3520),
    [anon_sym_const] = ACTIONS(3520),
    [anon_sym_constexpr] = ACTIONS(3520),
    [anon_sym_volatile] = ACTIONS(3520),
    [anon_sym_restrict] = ACTIONS(3520),
    [anon_sym___restrict__] = ACTIONS(3520),
    [anon_sym__Atomic] = ACTIONS(3520),
    [anon_sym__Noreturn] = ACTIONS(3520),
    [anon_sym_noreturn] = ACTIONS(3520),
    [anon_sym__Nonnull] = ACTIONS(3520),
    [anon_sym_mutable] = ACTIONS(3520),
    [anon_sym_constinit] = ACTIONS(3520),
    [anon_sym_consteval] = ACTIONS(3520),
    [anon_sym_alignas] = ACTIONS(3520),
    [anon_sym__Alignas] = ACTIONS(3520),
    [sym_primitive_type] = ACTIONS(3520),
    [anon_sym_enum] = ACTIONS(3520),
    [anon_sym_class] = ACTIONS(3520),
    [anon_sym_struct] = ACTIONS(3520),
    [anon_sym_union] = ACTIONS(3520),
    [anon_sym_if] = ACTIONS(3520),
    [anon_sym_else] = ACTIONS(3520),
    [anon_sym_switch] = ACTIONS(3520),
    [anon_sym_case] = ACTIONS(3520),
    [anon_sym_default] = ACTIONS(3520),
    [anon_sym_while] = ACTIONS(3520),
    [anon_sym_do] = ACTIONS(3520),
    [anon_sym_for] = ACTIONS(3520),
    [anon_sym_return] = ACTIONS(3520),
    [anon_sym_break] = ACTIONS(3520),
    [anon_sym_continue] = ACTIONS(3520),
    [anon_sym_goto] = ACTIONS(3520),
    [anon_sym___try] = ACTIONS(3520),
    [anon_sym___leave] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3520),
    [anon_sym_compl] = ACTIONS(3520),
    [anon_sym_DASH_DASH] = ACTIONS(3518),
    [anon_sym_PLUS_PLUS] = ACTIONS(3518),
    [anon_sym_sizeof] = ACTIONS(3520),
    [anon_sym___alignof__] = ACTIONS(3520),
    [anon_sym___alignof] = ACTIONS(3520),
    [anon_sym__alignof] = ACTIONS(3520),
    [anon_sym_alignof] = ACTIONS(3520),
    [anon_sym__Alignof] = ACTIONS(3520),
    [anon_sym_offsetof] = ACTIONS(3520),
    [anon_sym__Generic] = ACTIONS(3520),
    [anon_sym_asm] = ACTIONS(3520),
    [anon_sym___asm__] = ACTIONS(3520),
    [anon_sym___asm] = ACTIONS(3520),
    [sym_number_literal] = ACTIONS(3518),
    [anon_sym_L_SQUOTE] = ACTIONS(3518),
    [anon_sym_u_SQUOTE] = ACTIONS(3518),
    [anon_sym_U_SQUOTE] = ACTIONS(3518),
    [anon_sym_u8_SQUOTE] = ACTIONS(3518),
    [anon_sym_SQUOTE] = ACTIONS(3518),
    [anon_sym_L_DQUOTE] = ACTIONS(3518),
    [anon_sym_u_DQUOTE] = ACTIONS(3518),
    [anon_sym_U_DQUOTE] = ACTIONS(3518),
    [anon_sym_u8_DQUOTE] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(3518),
    [sym_true] = ACTIONS(3520),
    [sym_false] = ACTIONS(3520),
    [anon_sym_NULL] = ACTIONS(3520),
    [anon_sym_nullptr] = ACTIONS(3520),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3520),
    [anon_sym_let] = ACTIONS(3520),
    [anon_sym_This] = ACTIONS(3520),
    [anon_sym_decltype] = ACTIONS(3520),
    [anon_sym_explicit] = ACTIONS(3520),
    [anon_sym_typename] = ACTIONS(3520),
    [anon_sym_template] = ACTIONS(3520),
    [anon_sym_operator] = ACTIONS(3520),
    [anon_sym_try] = ACTIONS(3520),
    [anon_sym_delete] = ACTIONS(3520),
    [anon_sym_throw] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3520),
    [anon_sym_static_assert] = ACTIONS(3520),
    [anon_sym_concept] = ACTIONS(3520),
    [anon_sym_co_return] = ACTIONS(3520),
    [anon_sym_co_yield] = ACTIONS(3520),
    [anon_sym_R_DQUOTE] = ACTIONS(3518),
    [anon_sym_LR_DQUOTE] = ACTIONS(3518),
    [anon_sym_uR_DQUOTE] = ACTIONS(3518),
    [anon_sym_UR_DQUOTE] = ACTIONS(3518),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3518),
    [anon_sym_co_await] = ACTIONS(3520),
    [anon_sym_new] = ACTIONS(3520),
    [anon_sym_requires] = ACTIONS(3520),
    [sym_this] = ACTIONS(3520),
    [anon_sym_discard] = ACTIONS(3520),
    [anon_sym_precise] = ACTIONS(3520),
    [anon_sym_shared] = ACTIONS(3520),
    [anon_sym_groupshared] = ACTIONS(3520),
    [anon_sym_uniform] = ACTIONS(3520),
    [anon_sym_row_major] = ACTIONS(3520),
    [anon_sym_column_major] = ACTIONS(3520),
    [anon_sym_globallycoherent] = ACTIONS(3520),
    [anon_sym_centroid] = ACTIONS(3520),
    [anon_sym_noperspective] = ACTIONS(3520),
    [anon_sym_nointerpolation] = ACTIONS(3520),
    [anon_sym_sample] = ACTIONS(3520),
    [anon_sym_linear] = ACTIONS(3520),
    [anon_sym_snorm] = ACTIONS(3520),
    [anon_sym_unorm] = ACTIONS(3520),
    [anon_sym_point] = ACTIONS(3520),
    [anon_sym_line] = ACTIONS(3520),
    [anon_sym_triangleadj] = ACTIONS(3520),
    [anon_sym_lineadj] = ACTIONS(3520),
    [anon_sym_triangle] = ACTIONS(3520),
    [anon_sym_cbuffer] = ACTIONS(3520),
    [anon_sym_interface] = ACTIONS(3520),
    [anon_sym_extension] = ACTIONS(3520),
  },
  [722] = {
    [sym_identifier] = ACTIONS(3444),
    [aux_sym_preproc_include_token1] = ACTIONS(3444),
    [aux_sym_preproc_def_token1] = ACTIONS(3444),
    [aux_sym_preproc_if_token1] = ACTIONS(3444),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3444),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3444),
    [sym_preproc_directive] = ACTIONS(3444),
    [anon_sym_LPAREN2] = ACTIONS(3442),
    [anon_sym_BANG] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3444),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_STAR] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_AMP] = ACTIONS(3444),
    [anon_sym_SEMI] = ACTIONS(3442),
    [anon_sym___extension__] = ACTIONS(3444),
    [anon_sym_typedef] = ACTIONS(3444),
    [anon_sym_in] = ACTIONS(3444),
    [anon_sym_out] = ACTIONS(3444),
    [anon_sym_inout] = ACTIONS(3444),
    [anon_sym_virtual] = ACTIONS(3444),
    [anon_sym_extern] = ACTIONS(3444),
    [anon_sym___attribute__] = ACTIONS(3444),
    [anon_sym___attribute] = ACTIONS(3444),
    [anon_sym_using] = ACTIONS(3444),
    [anon_sym_COLON_COLON] = ACTIONS(3442),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3442),
    [anon_sym___declspec] = ACTIONS(3444),
    [anon_sym___based] = ACTIONS(3444),
    [anon_sym___cdecl] = ACTIONS(3444),
    [anon_sym___clrcall] = ACTIONS(3444),
    [anon_sym___stdcall] = ACTIONS(3444),
    [anon_sym___fastcall] = ACTIONS(3444),
    [anon_sym___thiscall] = ACTIONS(3444),
    [anon_sym___vectorcall] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_RBRACE] = ACTIONS(3442),
    [anon_sym_signed] = ACTIONS(3444),
    [anon_sym_unsigned] = ACTIONS(3444),
    [anon_sym_long] = ACTIONS(3444),
    [anon_sym_short] = ACTIONS(3444),
    [anon_sym_LBRACK] = ACTIONS(3444),
    [anon_sym_static] = ACTIONS(3444),
    [anon_sym_register] = ACTIONS(3444),
    [anon_sym_inline] = ACTIONS(3444),
    [anon_sym___inline] = ACTIONS(3444),
    [anon_sym___inline__] = ACTIONS(3444),
    [anon_sym___forceinline] = ACTIONS(3444),
    [anon_sym_thread_local] = ACTIONS(3444),
    [anon_sym___thread] = ACTIONS(3444),
    [anon_sym_const] = ACTIONS(3444),
    [anon_sym_constexpr] = ACTIONS(3444),
    [anon_sym_volatile] = ACTIONS(3444),
    [anon_sym_restrict] = ACTIONS(3444),
    [anon_sym___restrict__] = ACTIONS(3444),
    [anon_sym__Atomic] = ACTIONS(3444),
    [anon_sym__Noreturn] = ACTIONS(3444),
    [anon_sym_noreturn] = ACTIONS(3444),
    [anon_sym__Nonnull] = ACTIONS(3444),
    [anon_sym_mutable] = ACTIONS(3444),
    [anon_sym_constinit] = ACTIONS(3444),
    [anon_sym_consteval] = ACTIONS(3444),
    [anon_sym_alignas] = ACTIONS(3444),
    [anon_sym__Alignas] = ACTIONS(3444),
    [sym_primitive_type] = ACTIONS(3444),
    [anon_sym_enum] = ACTIONS(3444),
    [anon_sym_class] = ACTIONS(3444),
    [anon_sym_struct] = ACTIONS(3444),
    [anon_sym_union] = ACTIONS(3444),
    [anon_sym_if] = ACTIONS(3444),
    [anon_sym_else] = ACTIONS(3444),
    [anon_sym_switch] = ACTIONS(3444),
    [anon_sym_case] = ACTIONS(3444),
    [anon_sym_default] = ACTIONS(3444),
    [anon_sym_while] = ACTIONS(3444),
    [anon_sym_do] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3444),
    [anon_sym_return] = ACTIONS(3444),
    [anon_sym_break] = ACTIONS(3444),
    [anon_sym_continue] = ACTIONS(3444),
    [anon_sym_goto] = ACTIONS(3444),
    [anon_sym___try] = ACTIONS(3444),
    [anon_sym___leave] = ACTIONS(3444),
    [anon_sym_not] = ACTIONS(3444),
    [anon_sym_compl] = ACTIONS(3444),
    [anon_sym_DASH_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_PLUS] = ACTIONS(3442),
    [anon_sym_sizeof] = ACTIONS(3444),
    [anon_sym___alignof__] = ACTIONS(3444),
    [anon_sym___alignof] = ACTIONS(3444),
    [anon_sym__alignof] = ACTIONS(3444),
    [anon_sym_alignof] = ACTIONS(3444),
    [anon_sym__Alignof] = ACTIONS(3444),
    [anon_sym_offsetof] = ACTIONS(3444),
    [anon_sym__Generic] = ACTIONS(3444),
    [anon_sym_asm] = ACTIONS(3444),
    [anon_sym___asm__] = ACTIONS(3444),
    [anon_sym___asm] = ACTIONS(3444),
    [sym_number_literal] = ACTIONS(3442),
    [anon_sym_L_SQUOTE] = ACTIONS(3442),
    [anon_sym_u_SQUOTE] = ACTIONS(3442),
    [anon_sym_U_SQUOTE] = ACTIONS(3442),
    [anon_sym_u8_SQUOTE] = ACTIONS(3442),
    [anon_sym_SQUOTE] = ACTIONS(3442),
    [anon_sym_L_DQUOTE] = ACTIONS(3442),
    [anon_sym_u_DQUOTE] = ACTIONS(3442),
    [anon_sym_U_DQUOTE] = ACTIONS(3442),
    [anon_sym_u8_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [sym_true] = ACTIONS(3444),
    [sym_false] = ACTIONS(3444),
    [anon_sym_NULL] = ACTIONS(3444),
    [anon_sym_nullptr] = ACTIONS(3444),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3444),
    [anon_sym_let] = ACTIONS(3444),
    [anon_sym_This] = ACTIONS(3444),
    [anon_sym_decltype] = ACTIONS(3444),
    [anon_sym_explicit] = ACTIONS(3444),
    [anon_sym_typename] = ACTIONS(3444),
    [anon_sym_template] = ACTIONS(3444),
    [anon_sym_operator] = ACTIONS(3444),
    [anon_sym_try] = ACTIONS(3444),
    [anon_sym_delete] = ACTIONS(3444),
    [anon_sym_throw] = ACTIONS(3444),
    [anon_sym_namespace] = ACTIONS(3444),
    [anon_sym_static_assert] = ACTIONS(3444),
    [anon_sym_concept] = ACTIONS(3444),
    [anon_sym_co_return] = ACTIONS(3444),
    [anon_sym_co_yield] = ACTIONS(3444),
    [anon_sym_R_DQUOTE] = ACTIONS(3442),
    [anon_sym_LR_DQUOTE] = ACTIONS(3442),
    [anon_sym_uR_DQUOTE] = ACTIONS(3442),
    [anon_sym_UR_DQUOTE] = ACTIONS(3442),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3442),
    [anon_sym_co_await] = ACTIONS(3444),
    [anon_sym_new] = ACTIONS(3444),
    [anon_sym_requires] = ACTIONS(3444),
    [sym_this] = ACTIONS(3444),
    [anon_sym_discard] = ACTIONS(3444),
    [anon_sym_precise] = ACTIONS(3444),
    [anon_sym_shared] = ACTIONS(3444),
    [anon_sym_groupshared] = ACTIONS(3444),
    [anon_sym_uniform] = ACTIONS(3444),
    [anon_sym_row_major] = ACTIONS(3444),
    [anon_sym_column_major] = ACTIONS(3444),
    [anon_sym_globallycoherent] = ACTIONS(3444),
    [anon_sym_centroid] = ACTIONS(3444),
    [anon_sym_noperspective] = ACTIONS(3444),
    [anon_sym_nointerpolation] = ACTIONS(3444),
    [anon_sym_sample] = ACTIONS(3444),
    [anon_sym_linear] = ACTIONS(3444),
    [anon_sym_snorm] = ACTIONS(3444),
    [anon_sym_unorm] = ACTIONS(3444),
    [anon_sym_point] = ACTIONS(3444),
    [anon_sym_line] = ACTIONS(3444),
    [anon_sym_triangleadj] = ACTIONS(3444),
    [anon_sym_lineadj] = ACTIONS(3444),
    [anon_sym_triangle] = ACTIONS(3444),
    [anon_sym_cbuffer] = ACTIONS(3444),
    [anon_sym_interface] = ACTIONS(3444),
    [anon_sym_extension] = ACTIONS(3444),
  },
  [723] = {
    [sym_identifier] = ACTIONS(3448),
    [aux_sym_preproc_include_token1] = ACTIONS(3448),
    [aux_sym_preproc_def_token1] = ACTIONS(3448),
    [aux_sym_preproc_if_token1] = ACTIONS(3448),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3448),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3448),
    [sym_preproc_directive] = ACTIONS(3448),
    [anon_sym_LPAREN2] = ACTIONS(3446),
    [anon_sym_BANG] = ACTIONS(3446),
    [anon_sym_TILDE] = ACTIONS(3446),
    [anon_sym_DASH] = ACTIONS(3448),
    [anon_sym_PLUS] = ACTIONS(3448),
    [anon_sym_STAR] = ACTIONS(3446),
    [anon_sym_AMP_AMP] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3448),
    [anon_sym_SEMI] = ACTIONS(3446),
    [anon_sym___extension__] = ACTIONS(3448),
    [anon_sym_typedef] = ACTIONS(3448),
    [anon_sym_in] = ACTIONS(3448),
    [anon_sym_out] = ACTIONS(3448),
    [anon_sym_inout] = ACTIONS(3448),
    [anon_sym_virtual] = ACTIONS(3448),
    [anon_sym_extern] = ACTIONS(3448),
    [anon_sym___attribute__] = ACTIONS(3448),
    [anon_sym___attribute] = ACTIONS(3448),
    [anon_sym_using] = ACTIONS(3448),
    [anon_sym_COLON_COLON] = ACTIONS(3446),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3446),
    [anon_sym___declspec] = ACTIONS(3448),
    [anon_sym___based] = ACTIONS(3448),
    [anon_sym___cdecl] = ACTIONS(3448),
    [anon_sym___clrcall] = ACTIONS(3448),
    [anon_sym___stdcall] = ACTIONS(3448),
    [anon_sym___fastcall] = ACTIONS(3448),
    [anon_sym___thiscall] = ACTIONS(3448),
    [anon_sym___vectorcall] = ACTIONS(3448),
    [anon_sym_LBRACE] = ACTIONS(3446),
    [anon_sym_RBRACE] = ACTIONS(3446),
    [anon_sym_signed] = ACTIONS(3448),
    [anon_sym_unsigned] = ACTIONS(3448),
    [anon_sym_long] = ACTIONS(3448),
    [anon_sym_short] = ACTIONS(3448),
    [anon_sym_LBRACK] = ACTIONS(3448),
    [anon_sym_static] = ACTIONS(3448),
    [anon_sym_register] = ACTIONS(3448),
    [anon_sym_inline] = ACTIONS(3448),
    [anon_sym___inline] = ACTIONS(3448),
    [anon_sym___inline__] = ACTIONS(3448),
    [anon_sym___forceinline] = ACTIONS(3448),
    [anon_sym_thread_local] = ACTIONS(3448),
    [anon_sym___thread] = ACTIONS(3448),
    [anon_sym_const] = ACTIONS(3448),
    [anon_sym_constexpr] = ACTIONS(3448),
    [anon_sym_volatile] = ACTIONS(3448),
    [anon_sym_restrict] = ACTIONS(3448),
    [anon_sym___restrict__] = ACTIONS(3448),
    [anon_sym__Atomic] = ACTIONS(3448),
    [anon_sym__Noreturn] = ACTIONS(3448),
    [anon_sym_noreturn] = ACTIONS(3448),
    [anon_sym__Nonnull] = ACTIONS(3448),
    [anon_sym_mutable] = ACTIONS(3448),
    [anon_sym_constinit] = ACTIONS(3448),
    [anon_sym_consteval] = ACTIONS(3448),
    [anon_sym_alignas] = ACTIONS(3448),
    [anon_sym__Alignas] = ACTIONS(3448),
    [sym_primitive_type] = ACTIONS(3448),
    [anon_sym_enum] = ACTIONS(3448),
    [anon_sym_class] = ACTIONS(3448),
    [anon_sym_struct] = ACTIONS(3448),
    [anon_sym_union] = ACTIONS(3448),
    [anon_sym_if] = ACTIONS(3448),
    [anon_sym_else] = ACTIONS(3448),
    [anon_sym_switch] = ACTIONS(3448),
    [anon_sym_case] = ACTIONS(3448),
    [anon_sym_default] = ACTIONS(3448),
    [anon_sym_while] = ACTIONS(3448),
    [anon_sym_do] = ACTIONS(3448),
    [anon_sym_for] = ACTIONS(3448),
    [anon_sym_return] = ACTIONS(3448),
    [anon_sym_break] = ACTIONS(3448),
    [anon_sym_continue] = ACTIONS(3448),
    [anon_sym_goto] = ACTIONS(3448),
    [anon_sym___try] = ACTIONS(3448),
    [anon_sym___leave] = ACTIONS(3448),
    [anon_sym_not] = ACTIONS(3448),
    [anon_sym_compl] = ACTIONS(3448),
    [anon_sym_DASH_DASH] = ACTIONS(3446),
    [anon_sym_PLUS_PLUS] = ACTIONS(3446),
    [anon_sym_sizeof] = ACTIONS(3448),
    [anon_sym___alignof__] = ACTIONS(3448),
    [anon_sym___alignof] = ACTIONS(3448),
    [anon_sym__alignof] = ACTIONS(3448),
    [anon_sym_alignof] = ACTIONS(3448),
    [anon_sym__Alignof] = ACTIONS(3448),
    [anon_sym_offsetof] = ACTIONS(3448),
    [anon_sym__Generic] = ACTIONS(3448),
    [anon_sym_asm] = ACTIONS(3448),
    [anon_sym___asm__] = ACTIONS(3448),
    [anon_sym___asm] = ACTIONS(3448),
    [sym_number_literal] = ACTIONS(3446),
    [anon_sym_L_SQUOTE] = ACTIONS(3446),
    [anon_sym_u_SQUOTE] = ACTIONS(3446),
    [anon_sym_U_SQUOTE] = ACTIONS(3446),
    [anon_sym_u8_SQUOTE] = ACTIONS(3446),
    [anon_sym_SQUOTE] = ACTIONS(3446),
    [anon_sym_L_DQUOTE] = ACTIONS(3446),
    [anon_sym_u_DQUOTE] = ACTIONS(3446),
    [anon_sym_U_DQUOTE] = ACTIONS(3446),
    [anon_sym_u8_DQUOTE] = ACTIONS(3446),
    [anon_sym_DQUOTE] = ACTIONS(3446),
    [sym_true] = ACTIONS(3448),
    [sym_false] = ACTIONS(3448),
    [anon_sym_NULL] = ACTIONS(3448),
    [anon_sym_nullptr] = ACTIONS(3448),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3448),
    [anon_sym_let] = ACTIONS(3448),
    [anon_sym_This] = ACTIONS(3448),
    [anon_sym_decltype] = ACTIONS(3448),
    [anon_sym_explicit] = ACTIONS(3448),
    [anon_sym_typename] = ACTIONS(3448),
    [anon_sym_template] = ACTIONS(3448),
    [anon_sym_operator] = ACTIONS(3448),
    [anon_sym_try] = ACTIONS(3448),
    [anon_sym_delete] = ACTIONS(3448),
    [anon_sym_throw] = ACTIONS(3448),
    [anon_sym_namespace] = ACTIONS(3448),
    [anon_sym_static_assert] = ACTIONS(3448),
    [anon_sym_concept] = ACTIONS(3448),
    [anon_sym_co_return] = ACTIONS(3448),
    [anon_sym_co_yield] = ACTIONS(3448),
    [anon_sym_R_DQUOTE] = ACTIONS(3446),
    [anon_sym_LR_DQUOTE] = ACTIONS(3446),
    [anon_sym_uR_DQUOTE] = ACTIONS(3446),
    [anon_sym_UR_DQUOTE] = ACTIONS(3446),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3446),
    [anon_sym_co_await] = ACTIONS(3448),
    [anon_sym_new] = ACTIONS(3448),
    [anon_sym_requires] = ACTIONS(3448),
    [sym_this] = ACTIONS(3448),
    [anon_sym_discard] = ACTIONS(3448),
    [anon_sym_precise] = ACTIONS(3448),
    [anon_sym_shared] = ACTIONS(3448),
    [anon_sym_groupshared] = ACTIONS(3448),
    [anon_sym_uniform] = ACTIONS(3448),
    [anon_sym_row_major] = ACTIONS(3448),
    [anon_sym_column_major] = ACTIONS(3448),
    [anon_sym_globallycoherent] = ACTIONS(3448),
    [anon_sym_centroid] = ACTIONS(3448),
    [anon_sym_noperspective] = ACTIONS(3448),
    [anon_sym_nointerpolation] = ACTIONS(3448),
    [anon_sym_sample] = ACTIONS(3448),
    [anon_sym_linear] = ACTIONS(3448),
    [anon_sym_snorm] = ACTIONS(3448),
    [anon_sym_unorm] = ACTIONS(3448),
    [anon_sym_point] = ACTIONS(3448),
    [anon_sym_line] = ACTIONS(3448),
    [anon_sym_triangleadj] = ACTIONS(3448),
    [anon_sym_lineadj] = ACTIONS(3448),
    [anon_sym_triangle] = ACTIONS(3448),
    [anon_sym_cbuffer] = ACTIONS(3448),
    [anon_sym_interface] = ACTIONS(3448),
    [anon_sym_extension] = ACTIONS(3448),
  },
  [724] = {
    [sym_identifier] = ACTIONS(3637),
    [aux_sym_preproc_include_token1] = ACTIONS(3637),
    [aux_sym_preproc_def_token1] = ACTIONS(3637),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_if_token2] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3637),
    [sym_preproc_directive] = ACTIONS(3637),
    [anon_sym_LPAREN2] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(3639),
    [anon_sym_TILDE] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3637),
    [anon_sym_STAR] = ACTIONS(3639),
    [anon_sym_AMP_AMP] = ACTIONS(3639),
    [anon_sym_AMP] = ACTIONS(3637),
    [anon_sym_SEMI] = ACTIONS(3639),
    [anon_sym___extension__] = ACTIONS(3637),
    [anon_sym_typedef] = ACTIONS(3637),
    [anon_sym_in] = ACTIONS(3637),
    [anon_sym_out] = ACTIONS(3637),
    [anon_sym_inout] = ACTIONS(3637),
    [anon_sym_virtual] = ACTIONS(3637),
    [anon_sym_extern] = ACTIONS(3637),
    [anon_sym___attribute__] = ACTIONS(3637),
    [anon_sym___attribute] = ACTIONS(3637),
    [anon_sym_using] = ACTIONS(3637),
    [anon_sym_COLON_COLON] = ACTIONS(3639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3639),
    [anon_sym___declspec] = ACTIONS(3637),
    [anon_sym___based] = ACTIONS(3637),
    [anon_sym___cdecl] = ACTIONS(3637),
    [anon_sym___clrcall] = ACTIONS(3637),
    [anon_sym___stdcall] = ACTIONS(3637),
    [anon_sym___fastcall] = ACTIONS(3637),
    [anon_sym___thiscall] = ACTIONS(3637),
    [anon_sym___vectorcall] = ACTIONS(3637),
    [anon_sym_LBRACE] = ACTIONS(3639),
    [anon_sym_signed] = ACTIONS(3637),
    [anon_sym_unsigned] = ACTIONS(3637),
    [anon_sym_long] = ACTIONS(3637),
    [anon_sym_short] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(3637),
    [anon_sym_static] = ACTIONS(3637),
    [anon_sym_register] = ACTIONS(3637),
    [anon_sym_inline] = ACTIONS(3637),
    [anon_sym___inline] = ACTIONS(3637),
    [anon_sym___inline__] = ACTIONS(3637),
    [anon_sym___forceinline] = ACTIONS(3637),
    [anon_sym_thread_local] = ACTIONS(3637),
    [anon_sym___thread] = ACTIONS(3637),
    [anon_sym_const] = ACTIONS(3637),
    [anon_sym_constexpr] = ACTIONS(3637),
    [anon_sym_volatile] = ACTIONS(3637),
    [anon_sym_restrict] = ACTIONS(3637),
    [anon_sym___restrict__] = ACTIONS(3637),
    [anon_sym__Atomic] = ACTIONS(3637),
    [anon_sym__Noreturn] = ACTIONS(3637),
    [anon_sym_noreturn] = ACTIONS(3637),
    [anon_sym__Nonnull] = ACTIONS(3637),
    [anon_sym_mutable] = ACTIONS(3637),
    [anon_sym_constinit] = ACTIONS(3637),
    [anon_sym_consteval] = ACTIONS(3637),
    [anon_sym_alignas] = ACTIONS(3637),
    [anon_sym__Alignas] = ACTIONS(3637),
    [sym_primitive_type] = ACTIONS(3637),
    [anon_sym_enum] = ACTIONS(3637),
    [anon_sym_class] = ACTIONS(3637),
    [anon_sym_struct] = ACTIONS(3637),
    [anon_sym_union] = ACTIONS(3637),
    [anon_sym_if] = ACTIONS(3637),
    [anon_sym_else] = ACTIONS(3637),
    [anon_sym_switch] = ACTIONS(3637),
    [anon_sym_case] = ACTIONS(3637),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3637),
    [anon_sym_do] = ACTIONS(3637),
    [anon_sym_for] = ACTIONS(3637),
    [anon_sym_return] = ACTIONS(3637),
    [anon_sym_break] = ACTIONS(3637),
    [anon_sym_continue] = ACTIONS(3637),
    [anon_sym_goto] = ACTIONS(3637),
    [anon_sym___try] = ACTIONS(3637),
    [anon_sym___leave] = ACTIONS(3637),
    [anon_sym_not] = ACTIONS(3637),
    [anon_sym_compl] = ACTIONS(3637),
    [anon_sym_DASH_DASH] = ACTIONS(3639),
    [anon_sym_PLUS_PLUS] = ACTIONS(3639),
    [anon_sym_sizeof] = ACTIONS(3637),
    [anon_sym___alignof__] = ACTIONS(3637),
    [anon_sym___alignof] = ACTIONS(3637),
    [anon_sym__alignof] = ACTIONS(3637),
    [anon_sym_alignof] = ACTIONS(3637),
    [anon_sym__Alignof] = ACTIONS(3637),
    [anon_sym_offsetof] = ACTIONS(3637),
    [anon_sym__Generic] = ACTIONS(3637),
    [anon_sym_asm] = ACTIONS(3637),
    [anon_sym___asm__] = ACTIONS(3637),
    [anon_sym___asm] = ACTIONS(3637),
    [sym_number_literal] = ACTIONS(3639),
    [anon_sym_L_SQUOTE] = ACTIONS(3639),
    [anon_sym_u_SQUOTE] = ACTIONS(3639),
    [anon_sym_U_SQUOTE] = ACTIONS(3639),
    [anon_sym_u8_SQUOTE] = ACTIONS(3639),
    [anon_sym_SQUOTE] = ACTIONS(3639),
    [anon_sym_L_DQUOTE] = ACTIONS(3639),
    [anon_sym_u_DQUOTE] = ACTIONS(3639),
    [anon_sym_U_DQUOTE] = ACTIONS(3639),
    [anon_sym_u8_DQUOTE] = ACTIONS(3639),
    [anon_sym_DQUOTE] = ACTIONS(3639),
    [sym_true] = ACTIONS(3637),
    [sym_false] = ACTIONS(3637),
    [anon_sym_NULL] = ACTIONS(3637),
    [anon_sym_nullptr] = ACTIONS(3637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3637),
    [anon_sym_let] = ACTIONS(3637),
    [anon_sym_This] = ACTIONS(3637),
    [anon_sym_decltype] = ACTIONS(3637),
    [anon_sym_explicit] = ACTIONS(3637),
    [anon_sym_typename] = ACTIONS(3637),
    [anon_sym_template] = ACTIONS(3637),
    [anon_sym_operator] = ACTIONS(3637),
    [anon_sym_try] = ACTIONS(3637),
    [anon_sym_delete] = ACTIONS(3637),
    [anon_sym_throw] = ACTIONS(3637),
    [anon_sym_namespace] = ACTIONS(3637),
    [anon_sym_static_assert] = ACTIONS(3637),
    [anon_sym_concept] = ACTIONS(3637),
    [anon_sym_co_return] = ACTIONS(3637),
    [anon_sym_co_yield] = ACTIONS(3637),
    [anon_sym_R_DQUOTE] = ACTIONS(3639),
    [anon_sym_LR_DQUOTE] = ACTIONS(3639),
    [anon_sym_uR_DQUOTE] = ACTIONS(3639),
    [anon_sym_UR_DQUOTE] = ACTIONS(3639),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3639),
    [anon_sym_co_await] = ACTIONS(3637),
    [anon_sym_new] = ACTIONS(3637),
    [anon_sym_requires] = ACTIONS(3637),
    [sym_this] = ACTIONS(3637),
    [anon_sym_discard] = ACTIONS(3637),
    [anon_sym_precise] = ACTIONS(3637),
    [anon_sym_shared] = ACTIONS(3637),
    [anon_sym_groupshared] = ACTIONS(3637),
    [anon_sym_uniform] = ACTIONS(3637),
    [anon_sym_row_major] = ACTIONS(3637),
    [anon_sym_column_major] = ACTIONS(3637),
    [anon_sym_globallycoherent] = ACTIONS(3637),
    [anon_sym_centroid] = ACTIONS(3637),
    [anon_sym_noperspective] = ACTIONS(3637),
    [anon_sym_nointerpolation] = ACTIONS(3637),
    [anon_sym_sample] = ACTIONS(3637),
    [anon_sym_linear] = ACTIONS(3637),
    [anon_sym_snorm] = ACTIONS(3637),
    [anon_sym_unorm] = ACTIONS(3637),
    [anon_sym_point] = ACTIONS(3637),
    [anon_sym_line] = ACTIONS(3637),
    [anon_sym_triangleadj] = ACTIONS(3637),
    [anon_sym_lineadj] = ACTIONS(3637),
    [anon_sym_triangle] = ACTIONS(3637),
    [anon_sym_cbuffer] = ACTIONS(3637),
    [anon_sym_interface] = ACTIONS(3637),
    [anon_sym_extension] = ACTIONS(3637),
  },
  [725] = {
    [sym_identifier] = ACTIONS(3641),
    [aux_sym_preproc_include_token1] = ACTIONS(3641),
    [aux_sym_preproc_def_token1] = ACTIONS(3641),
    [aux_sym_preproc_if_token1] = ACTIONS(3641),
    [aux_sym_preproc_if_token2] = ACTIONS(3641),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3641),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3641),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(3643),
    [anon_sym_BANG] = ACTIONS(3643),
    [anon_sym_TILDE] = ACTIONS(3643),
    [anon_sym_DASH] = ACTIONS(3641),
    [anon_sym_PLUS] = ACTIONS(3641),
    [anon_sym_STAR] = ACTIONS(3643),
    [anon_sym_AMP_AMP] = ACTIONS(3643),
    [anon_sym_AMP] = ACTIONS(3641),
    [anon_sym_SEMI] = ACTIONS(3643),
    [anon_sym___extension__] = ACTIONS(3641),
    [anon_sym_typedef] = ACTIONS(3641),
    [anon_sym_in] = ACTIONS(3641),
    [anon_sym_out] = ACTIONS(3641),
    [anon_sym_inout] = ACTIONS(3641),
    [anon_sym_virtual] = ACTIONS(3641),
    [anon_sym_extern] = ACTIONS(3641),
    [anon_sym___attribute__] = ACTIONS(3641),
    [anon_sym___attribute] = ACTIONS(3641),
    [anon_sym_using] = ACTIONS(3641),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3643),
    [anon_sym___declspec] = ACTIONS(3641),
    [anon_sym___based] = ACTIONS(3641),
    [anon_sym___cdecl] = ACTIONS(3641),
    [anon_sym___clrcall] = ACTIONS(3641),
    [anon_sym___stdcall] = ACTIONS(3641),
    [anon_sym___fastcall] = ACTIONS(3641),
    [anon_sym___thiscall] = ACTIONS(3641),
    [anon_sym___vectorcall] = ACTIONS(3641),
    [anon_sym_LBRACE] = ACTIONS(3643),
    [anon_sym_signed] = ACTIONS(3641),
    [anon_sym_unsigned] = ACTIONS(3641),
    [anon_sym_long] = ACTIONS(3641),
    [anon_sym_short] = ACTIONS(3641),
    [anon_sym_LBRACK] = ACTIONS(3641),
    [anon_sym_static] = ACTIONS(3641),
    [anon_sym_register] = ACTIONS(3641),
    [anon_sym_inline] = ACTIONS(3641),
    [anon_sym___inline] = ACTIONS(3641),
    [anon_sym___inline__] = ACTIONS(3641),
    [anon_sym___forceinline] = ACTIONS(3641),
    [anon_sym_thread_local] = ACTIONS(3641),
    [anon_sym___thread] = ACTIONS(3641),
    [anon_sym_const] = ACTIONS(3641),
    [anon_sym_constexpr] = ACTIONS(3641),
    [anon_sym_volatile] = ACTIONS(3641),
    [anon_sym_restrict] = ACTIONS(3641),
    [anon_sym___restrict__] = ACTIONS(3641),
    [anon_sym__Atomic] = ACTIONS(3641),
    [anon_sym__Noreturn] = ACTIONS(3641),
    [anon_sym_noreturn] = ACTIONS(3641),
    [anon_sym__Nonnull] = ACTIONS(3641),
    [anon_sym_mutable] = ACTIONS(3641),
    [anon_sym_constinit] = ACTIONS(3641),
    [anon_sym_consteval] = ACTIONS(3641),
    [anon_sym_alignas] = ACTIONS(3641),
    [anon_sym__Alignas] = ACTIONS(3641),
    [sym_primitive_type] = ACTIONS(3641),
    [anon_sym_enum] = ACTIONS(3641),
    [anon_sym_class] = ACTIONS(3641),
    [anon_sym_struct] = ACTIONS(3641),
    [anon_sym_union] = ACTIONS(3641),
    [anon_sym_if] = ACTIONS(3641),
    [anon_sym_else] = ACTIONS(3641),
    [anon_sym_switch] = ACTIONS(3641),
    [anon_sym_case] = ACTIONS(3641),
    [anon_sym_default] = ACTIONS(3641),
    [anon_sym_while] = ACTIONS(3641),
    [anon_sym_do] = ACTIONS(3641),
    [anon_sym_for] = ACTIONS(3641),
    [anon_sym_return] = ACTIONS(3641),
    [anon_sym_break] = ACTIONS(3641),
    [anon_sym_continue] = ACTIONS(3641),
    [anon_sym_goto] = ACTIONS(3641),
    [anon_sym___try] = ACTIONS(3641),
    [anon_sym___leave] = ACTIONS(3641),
    [anon_sym_not] = ACTIONS(3641),
    [anon_sym_compl] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3643),
    [anon_sym_PLUS_PLUS] = ACTIONS(3643),
    [anon_sym_sizeof] = ACTIONS(3641),
    [anon_sym___alignof__] = ACTIONS(3641),
    [anon_sym___alignof] = ACTIONS(3641),
    [anon_sym__alignof] = ACTIONS(3641),
    [anon_sym_alignof] = ACTIONS(3641),
    [anon_sym__Alignof] = ACTIONS(3641),
    [anon_sym_offsetof] = ACTIONS(3641),
    [anon_sym__Generic] = ACTIONS(3641),
    [anon_sym_asm] = ACTIONS(3641),
    [anon_sym___asm__] = ACTIONS(3641),
    [anon_sym___asm] = ACTIONS(3641),
    [sym_number_literal] = ACTIONS(3643),
    [anon_sym_L_SQUOTE] = ACTIONS(3643),
    [anon_sym_u_SQUOTE] = ACTIONS(3643),
    [anon_sym_U_SQUOTE] = ACTIONS(3643),
    [anon_sym_u8_SQUOTE] = ACTIONS(3643),
    [anon_sym_SQUOTE] = ACTIONS(3643),
    [anon_sym_L_DQUOTE] = ACTIONS(3643),
    [anon_sym_u_DQUOTE] = ACTIONS(3643),
    [anon_sym_U_DQUOTE] = ACTIONS(3643),
    [anon_sym_u8_DQUOTE] = ACTIONS(3643),
    [anon_sym_DQUOTE] = ACTIONS(3643),
    [sym_true] = ACTIONS(3641),
    [sym_false] = ACTIONS(3641),
    [anon_sym_NULL] = ACTIONS(3641),
    [anon_sym_nullptr] = ACTIONS(3641),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3641),
    [anon_sym_let] = ACTIONS(3641),
    [anon_sym_This] = ACTIONS(3641),
    [anon_sym_decltype] = ACTIONS(3641),
    [anon_sym_explicit] = ACTIONS(3641),
    [anon_sym_typename] = ACTIONS(3641),
    [anon_sym_template] = ACTIONS(3641),
    [anon_sym_operator] = ACTIONS(3641),
    [anon_sym_try] = ACTIONS(3641),
    [anon_sym_delete] = ACTIONS(3641),
    [anon_sym_throw] = ACTIONS(3641),
    [anon_sym_namespace] = ACTIONS(3641),
    [anon_sym_static_assert] = ACTIONS(3641),
    [anon_sym_concept] = ACTIONS(3641),
    [anon_sym_co_return] = ACTIONS(3641),
    [anon_sym_co_yield] = ACTIONS(3641),
    [anon_sym_R_DQUOTE] = ACTIONS(3643),
    [anon_sym_LR_DQUOTE] = ACTIONS(3643),
    [anon_sym_uR_DQUOTE] = ACTIONS(3643),
    [anon_sym_UR_DQUOTE] = ACTIONS(3643),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3643),
    [anon_sym_co_await] = ACTIONS(3641),
    [anon_sym_new] = ACTIONS(3641),
    [anon_sym_requires] = ACTIONS(3641),
    [sym_this] = ACTIONS(3641),
    [anon_sym_discard] = ACTIONS(3641),
    [anon_sym_precise] = ACTIONS(3641),
    [anon_sym_shared] = ACTIONS(3641),
    [anon_sym_groupshared] = ACTIONS(3641),
    [anon_sym_uniform] = ACTIONS(3641),
    [anon_sym_row_major] = ACTIONS(3641),
    [anon_sym_column_major] = ACTIONS(3641),
    [anon_sym_globallycoherent] = ACTIONS(3641),
    [anon_sym_centroid] = ACTIONS(3641),
    [anon_sym_noperspective] = ACTIONS(3641),
    [anon_sym_nointerpolation] = ACTIONS(3641),
    [anon_sym_sample] = ACTIONS(3641),
    [anon_sym_linear] = ACTIONS(3641),
    [anon_sym_snorm] = ACTIONS(3641),
    [anon_sym_unorm] = ACTIONS(3641),
    [anon_sym_point] = ACTIONS(3641),
    [anon_sym_line] = ACTIONS(3641),
    [anon_sym_triangleadj] = ACTIONS(3641),
    [anon_sym_lineadj] = ACTIONS(3641),
    [anon_sym_triangle] = ACTIONS(3641),
    [anon_sym_cbuffer] = ACTIONS(3641),
    [anon_sym_interface] = ACTIONS(3641),
    [anon_sym_extension] = ACTIONS(3641),
  },
  [726] = {
    [sym_identifier] = ACTIONS(3645),
    [aux_sym_preproc_include_token1] = ACTIONS(3645),
    [aux_sym_preproc_def_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token2] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3645),
    [sym_preproc_directive] = ACTIONS(3645),
    [anon_sym_LPAREN2] = ACTIONS(3647),
    [anon_sym_BANG] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3647),
    [anon_sym_DASH] = ACTIONS(3645),
    [anon_sym_PLUS] = ACTIONS(3645),
    [anon_sym_STAR] = ACTIONS(3647),
    [anon_sym_AMP_AMP] = ACTIONS(3647),
    [anon_sym_AMP] = ACTIONS(3645),
    [anon_sym_SEMI] = ACTIONS(3647),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3645),
    [anon_sym_in] = ACTIONS(3645),
    [anon_sym_out] = ACTIONS(3645),
    [anon_sym_inout] = ACTIONS(3645),
    [anon_sym_virtual] = ACTIONS(3645),
    [anon_sym_extern] = ACTIONS(3645),
    [anon_sym___attribute__] = ACTIONS(3645),
    [anon_sym___attribute] = ACTIONS(3645),
    [anon_sym_using] = ACTIONS(3645),
    [anon_sym_COLON_COLON] = ACTIONS(3647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3647),
    [anon_sym___declspec] = ACTIONS(3645),
    [anon_sym___based] = ACTIONS(3645),
    [anon_sym___cdecl] = ACTIONS(3645),
    [anon_sym___clrcall] = ACTIONS(3645),
    [anon_sym___stdcall] = ACTIONS(3645),
    [anon_sym___fastcall] = ACTIONS(3645),
    [anon_sym___thiscall] = ACTIONS(3645),
    [anon_sym___vectorcall] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(3647),
    [anon_sym_signed] = ACTIONS(3645),
    [anon_sym_unsigned] = ACTIONS(3645),
    [anon_sym_long] = ACTIONS(3645),
    [anon_sym_short] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_static] = ACTIONS(3645),
    [anon_sym_register] = ACTIONS(3645),
    [anon_sym_inline] = ACTIONS(3645),
    [anon_sym___inline] = ACTIONS(3645),
    [anon_sym___inline__] = ACTIONS(3645),
    [anon_sym___forceinline] = ACTIONS(3645),
    [anon_sym_thread_local] = ACTIONS(3645),
    [anon_sym___thread] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(3645),
    [anon_sym_constexpr] = ACTIONS(3645),
    [anon_sym_volatile] = ACTIONS(3645),
    [anon_sym_restrict] = ACTIONS(3645),
    [anon_sym___restrict__] = ACTIONS(3645),
    [anon_sym__Atomic] = ACTIONS(3645),
    [anon_sym__Noreturn] = ACTIONS(3645),
    [anon_sym_noreturn] = ACTIONS(3645),
    [anon_sym__Nonnull] = ACTIONS(3645),
    [anon_sym_mutable] = ACTIONS(3645),
    [anon_sym_constinit] = ACTIONS(3645),
    [anon_sym_consteval] = ACTIONS(3645),
    [anon_sym_alignas] = ACTIONS(3645),
    [anon_sym__Alignas] = ACTIONS(3645),
    [sym_primitive_type] = ACTIONS(3645),
    [anon_sym_enum] = ACTIONS(3645),
    [anon_sym_class] = ACTIONS(3645),
    [anon_sym_struct] = ACTIONS(3645),
    [anon_sym_union] = ACTIONS(3645),
    [anon_sym_if] = ACTIONS(3645),
    [anon_sym_else] = ACTIONS(3645),
    [anon_sym_switch] = ACTIONS(3645),
    [anon_sym_case] = ACTIONS(3645),
    [anon_sym_default] = ACTIONS(3645),
    [anon_sym_while] = ACTIONS(3645),
    [anon_sym_do] = ACTIONS(3645),
    [anon_sym_for] = ACTIONS(3645),
    [anon_sym_return] = ACTIONS(3645),
    [anon_sym_break] = ACTIONS(3645),
    [anon_sym_continue] = ACTIONS(3645),
    [anon_sym_goto] = ACTIONS(3645),
    [anon_sym___try] = ACTIONS(3645),
    [anon_sym___leave] = ACTIONS(3645),
    [anon_sym_not] = ACTIONS(3645),
    [anon_sym_compl] = ACTIONS(3645),
    [anon_sym_DASH_DASH] = ACTIONS(3647),
    [anon_sym_PLUS_PLUS] = ACTIONS(3647),
    [anon_sym_sizeof] = ACTIONS(3645),
    [anon_sym___alignof__] = ACTIONS(3645),
    [anon_sym___alignof] = ACTIONS(3645),
    [anon_sym__alignof] = ACTIONS(3645),
    [anon_sym_alignof] = ACTIONS(3645),
    [anon_sym__Alignof] = ACTIONS(3645),
    [anon_sym_offsetof] = ACTIONS(3645),
    [anon_sym__Generic] = ACTIONS(3645),
    [anon_sym_asm] = ACTIONS(3645),
    [anon_sym___asm__] = ACTIONS(3645),
    [anon_sym___asm] = ACTIONS(3645),
    [sym_number_literal] = ACTIONS(3647),
    [anon_sym_L_SQUOTE] = ACTIONS(3647),
    [anon_sym_u_SQUOTE] = ACTIONS(3647),
    [anon_sym_U_SQUOTE] = ACTIONS(3647),
    [anon_sym_u8_SQUOTE] = ACTIONS(3647),
    [anon_sym_SQUOTE] = ACTIONS(3647),
    [anon_sym_L_DQUOTE] = ACTIONS(3647),
    [anon_sym_u_DQUOTE] = ACTIONS(3647),
    [anon_sym_U_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8_DQUOTE] = ACTIONS(3647),
    [anon_sym_DQUOTE] = ACTIONS(3647),
    [sym_true] = ACTIONS(3645),
    [sym_false] = ACTIONS(3645),
    [anon_sym_NULL] = ACTIONS(3645),
    [anon_sym_nullptr] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3645),
    [anon_sym_let] = ACTIONS(3645),
    [anon_sym_This] = ACTIONS(3645),
    [anon_sym_decltype] = ACTIONS(3645),
    [anon_sym_explicit] = ACTIONS(3645),
    [anon_sym_typename] = ACTIONS(3645),
    [anon_sym_template] = ACTIONS(3645),
    [anon_sym_operator] = ACTIONS(3645),
    [anon_sym_try] = ACTIONS(3645),
    [anon_sym_delete] = ACTIONS(3645),
    [anon_sym_throw] = ACTIONS(3645),
    [anon_sym_namespace] = ACTIONS(3645),
    [anon_sym_static_assert] = ACTIONS(3645),
    [anon_sym_concept] = ACTIONS(3645),
    [anon_sym_co_return] = ACTIONS(3645),
    [anon_sym_co_yield] = ACTIONS(3645),
    [anon_sym_R_DQUOTE] = ACTIONS(3647),
    [anon_sym_LR_DQUOTE] = ACTIONS(3647),
    [anon_sym_uR_DQUOTE] = ACTIONS(3647),
    [anon_sym_UR_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3647),
    [anon_sym_co_await] = ACTIONS(3645),
    [anon_sym_new] = ACTIONS(3645),
    [anon_sym_requires] = ACTIONS(3645),
    [sym_this] = ACTIONS(3645),
    [anon_sym_discard] = ACTIONS(3645),
    [anon_sym_precise] = ACTIONS(3645),
    [anon_sym_shared] = ACTIONS(3645),
    [anon_sym_groupshared] = ACTIONS(3645),
    [anon_sym_uniform] = ACTIONS(3645),
    [anon_sym_row_major] = ACTIONS(3645),
    [anon_sym_column_major] = ACTIONS(3645),
    [anon_sym_globallycoherent] = ACTIONS(3645),
    [anon_sym_centroid] = ACTIONS(3645),
    [anon_sym_noperspective] = ACTIONS(3645),
    [anon_sym_nointerpolation] = ACTIONS(3645),
    [anon_sym_sample] = ACTIONS(3645),
    [anon_sym_linear] = ACTIONS(3645),
    [anon_sym_snorm] = ACTIONS(3645),
    [anon_sym_unorm] = ACTIONS(3645),
    [anon_sym_point] = ACTIONS(3645),
    [anon_sym_line] = ACTIONS(3645),
    [anon_sym_triangleadj] = ACTIONS(3645),
    [anon_sym_lineadj] = ACTIONS(3645),
    [anon_sym_triangle] = ACTIONS(3645),
    [anon_sym_cbuffer] = ACTIONS(3645),
    [anon_sym_interface] = ACTIONS(3645),
    [anon_sym_extension] = ACTIONS(3645),
  },
  [727] = {
    [sym_identifier] = ACTIONS(3649),
    [aux_sym_preproc_include_token1] = ACTIONS(3649),
    [aux_sym_preproc_def_token1] = ACTIONS(3649),
    [aux_sym_preproc_if_token1] = ACTIONS(3649),
    [aux_sym_preproc_if_token2] = ACTIONS(3649),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3649),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3649),
    [sym_preproc_directive] = ACTIONS(3649),
    [anon_sym_LPAREN2] = ACTIONS(3651),
    [anon_sym_BANG] = ACTIONS(3651),
    [anon_sym_TILDE] = ACTIONS(3651),
    [anon_sym_DASH] = ACTIONS(3649),
    [anon_sym_PLUS] = ACTIONS(3649),
    [anon_sym_STAR] = ACTIONS(3651),
    [anon_sym_AMP_AMP] = ACTIONS(3651),
    [anon_sym_AMP] = ACTIONS(3649),
    [anon_sym_SEMI] = ACTIONS(3651),
    [anon_sym___extension__] = ACTIONS(3649),
    [anon_sym_typedef] = ACTIONS(3649),
    [anon_sym_in] = ACTIONS(3649),
    [anon_sym_out] = ACTIONS(3649),
    [anon_sym_inout] = ACTIONS(3649),
    [anon_sym_virtual] = ACTIONS(3649),
    [anon_sym_extern] = ACTIONS(3649),
    [anon_sym___attribute__] = ACTIONS(3649),
    [anon_sym___attribute] = ACTIONS(3649),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(3651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3651),
    [anon_sym___declspec] = ACTIONS(3649),
    [anon_sym___based] = ACTIONS(3649),
    [anon_sym___cdecl] = ACTIONS(3649),
    [anon_sym___clrcall] = ACTIONS(3649),
    [anon_sym___stdcall] = ACTIONS(3649),
    [anon_sym___fastcall] = ACTIONS(3649),
    [anon_sym___thiscall] = ACTIONS(3649),
    [anon_sym___vectorcall] = ACTIONS(3649),
    [anon_sym_LBRACE] = ACTIONS(3651),
    [anon_sym_signed] = ACTIONS(3649),
    [anon_sym_unsigned] = ACTIONS(3649),
    [anon_sym_long] = ACTIONS(3649),
    [anon_sym_short] = ACTIONS(3649),
    [anon_sym_LBRACK] = ACTIONS(3649),
    [anon_sym_static] = ACTIONS(3649),
    [anon_sym_register] = ACTIONS(3649),
    [anon_sym_inline] = ACTIONS(3649),
    [anon_sym___inline] = ACTIONS(3649),
    [anon_sym___inline__] = ACTIONS(3649),
    [anon_sym___forceinline] = ACTIONS(3649),
    [anon_sym_thread_local] = ACTIONS(3649),
    [anon_sym___thread] = ACTIONS(3649),
    [anon_sym_const] = ACTIONS(3649),
    [anon_sym_constexpr] = ACTIONS(3649),
    [anon_sym_volatile] = ACTIONS(3649),
    [anon_sym_restrict] = ACTIONS(3649),
    [anon_sym___restrict__] = ACTIONS(3649),
    [anon_sym__Atomic] = ACTIONS(3649),
    [anon_sym__Noreturn] = ACTIONS(3649),
    [anon_sym_noreturn] = ACTIONS(3649),
    [anon_sym__Nonnull] = ACTIONS(3649),
    [anon_sym_mutable] = ACTIONS(3649),
    [anon_sym_constinit] = ACTIONS(3649),
    [anon_sym_consteval] = ACTIONS(3649),
    [anon_sym_alignas] = ACTIONS(3649),
    [anon_sym__Alignas] = ACTIONS(3649),
    [sym_primitive_type] = ACTIONS(3649),
    [anon_sym_enum] = ACTIONS(3649),
    [anon_sym_class] = ACTIONS(3649),
    [anon_sym_struct] = ACTIONS(3649),
    [anon_sym_union] = ACTIONS(3649),
    [anon_sym_if] = ACTIONS(3649),
    [anon_sym_else] = ACTIONS(3649),
    [anon_sym_switch] = ACTIONS(3649),
    [anon_sym_case] = ACTIONS(3649),
    [anon_sym_default] = ACTIONS(3649),
    [anon_sym_while] = ACTIONS(3649),
    [anon_sym_do] = ACTIONS(3649),
    [anon_sym_for] = ACTIONS(3649),
    [anon_sym_return] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3649),
    [anon_sym_continue] = ACTIONS(3649),
    [anon_sym_goto] = ACTIONS(3649),
    [anon_sym___try] = ACTIONS(3649),
    [anon_sym___leave] = ACTIONS(3649),
    [anon_sym_not] = ACTIONS(3649),
    [anon_sym_compl] = ACTIONS(3649),
    [anon_sym_DASH_DASH] = ACTIONS(3651),
    [anon_sym_PLUS_PLUS] = ACTIONS(3651),
    [anon_sym_sizeof] = ACTIONS(3649),
    [anon_sym___alignof__] = ACTIONS(3649),
    [anon_sym___alignof] = ACTIONS(3649),
    [anon_sym__alignof] = ACTIONS(3649),
    [anon_sym_alignof] = ACTIONS(3649),
    [anon_sym__Alignof] = ACTIONS(3649),
    [anon_sym_offsetof] = ACTIONS(3649),
    [anon_sym__Generic] = ACTIONS(3649),
    [anon_sym_asm] = ACTIONS(3649),
    [anon_sym___asm__] = ACTIONS(3649),
    [anon_sym___asm] = ACTIONS(3649),
    [sym_number_literal] = ACTIONS(3651),
    [anon_sym_L_SQUOTE] = ACTIONS(3651),
    [anon_sym_u_SQUOTE] = ACTIONS(3651),
    [anon_sym_U_SQUOTE] = ACTIONS(3651),
    [anon_sym_u8_SQUOTE] = ACTIONS(3651),
    [anon_sym_SQUOTE] = ACTIONS(3651),
    [anon_sym_L_DQUOTE] = ACTIONS(3651),
    [anon_sym_u_DQUOTE] = ACTIONS(3651),
    [anon_sym_U_DQUOTE] = ACTIONS(3651),
    [anon_sym_u8_DQUOTE] = ACTIONS(3651),
    [anon_sym_DQUOTE] = ACTIONS(3651),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [anon_sym_NULL] = ACTIONS(3649),
    [anon_sym_nullptr] = ACTIONS(3649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3649),
    [anon_sym_let] = ACTIONS(3649),
    [anon_sym_This] = ACTIONS(3649),
    [anon_sym_decltype] = ACTIONS(3649),
    [anon_sym_explicit] = ACTIONS(3649),
    [anon_sym_typename] = ACTIONS(3649),
    [anon_sym_template] = ACTIONS(3649),
    [anon_sym_operator] = ACTIONS(3649),
    [anon_sym_try] = ACTIONS(3649),
    [anon_sym_delete] = ACTIONS(3649),
    [anon_sym_throw] = ACTIONS(3649),
    [anon_sym_namespace] = ACTIONS(3649),
    [anon_sym_static_assert] = ACTIONS(3649),
    [anon_sym_concept] = ACTIONS(3649),
    [anon_sym_co_return] = ACTIONS(3649),
    [anon_sym_co_yield] = ACTIONS(3649),
    [anon_sym_R_DQUOTE] = ACTIONS(3651),
    [anon_sym_LR_DQUOTE] = ACTIONS(3651),
    [anon_sym_uR_DQUOTE] = ACTIONS(3651),
    [anon_sym_UR_DQUOTE] = ACTIONS(3651),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3651),
    [anon_sym_co_await] = ACTIONS(3649),
    [anon_sym_new] = ACTIONS(3649),
    [anon_sym_requires] = ACTIONS(3649),
    [sym_this] = ACTIONS(3649),
    [anon_sym_discard] = ACTIONS(3649),
    [anon_sym_precise] = ACTIONS(3649),
    [anon_sym_shared] = ACTIONS(3649),
    [anon_sym_groupshared] = ACTIONS(3649),
    [anon_sym_uniform] = ACTIONS(3649),
    [anon_sym_row_major] = ACTIONS(3649),
    [anon_sym_column_major] = ACTIONS(3649),
    [anon_sym_globallycoherent] = ACTIONS(3649),
    [anon_sym_centroid] = ACTIONS(3649),
    [anon_sym_noperspective] = ACTIONS(3649),
    [anon_sym_nointerpolation] = ACTIONS(3649),
    [anon_sym_sample] = ACTIONS(3649),
    [anon_sym_linear] = ACTIONS(3649),
    [anon_sym_snorm] = ACTIONS(3649),
    [anon_sym_unorm] = ACTIONS(3649),
    [anon_sym_point] = ACTIONS(3649),
    [anon_sym_line] = ACTIONS(3649),
    [anon_sym_triangleadj] = ACTIONS(3649),
    [anon_sym_lineadj] = ACTIONS(3649),
    [anon_sym_triangle] = ACTIONS(3649),
    [anon_sym_cbuffer] = ACTIONS(3649),
    [anon_sym_interface] = ACTIONS(3649),
    [anon_sym_extension] = ACTIONS(3649),
  },
  [728] = {
    [sym_identifier] = ACTIONS(3452),
    [aux_sym_preproc_include_token1] = ACTIONS(3452),
    [aux_sym_preproc_def_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3452),
    [sym_preproc_directive] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(3450),
    [anon_sym_BANG] = ACTIONS(3450),
    [anon_sym_TILDE] = ACTIONS(3450),
    [anon_sym_DASH] = ACTIONS(3452),
    [anon_sym_PLUS] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_AMP_AMP] = ACTIONS(3450),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym___extension__] = ACTIONS(3452),
    [anon_sym_typedef] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_out] = ACTIONS(3452),
    [anon_sym_inout] = ACTIONS(3452),
    [anon_sym_virtual] = ACTIONS(3452),
    [anon_sym_extern] = ACTIONS(3452),
    [anon_sym___attribute__] = ACTIONS(3452),
    [anon_sym___attribute] = ACTIONS(3452),
    [anon_sym_using] = ACTIONS(3452),
    [anon_sym_COLON_COLON] = ACTIONS(3450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3450),
    [anon_sym___declspec] = ACTIONS(3452),
    [anon_sym___based] = ACTIONS(3452),
    [anon_sym___cdecl] = ACTIONS(3452),
    [anon_sym___clrcall] = ACTIONS(3452),
    [anon_sym___stdcall] = ACTIONS(3452),
    [anon_sym___fastcall] = ACTIONS(3452),
    [anon_sym___thiscall] = ACTIONS(3452),
    [anon_sym___vectorcall] = ACTIONS(3452),
    [anon_sym_LBRACE] = ACTIONS(3450),
    [anon_sym_RBRACE] = ACTIONS(3450),
    [anon_sym_signed] = ACTIONS(3452),
    [anon_sym_unsigned] = ACTIONS(3452),
    [anon_sym_long] = ACTIONS(3452),
    [anon_sym_short] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3452),
    [anon_sym_static] = ACTIONS(3452),
    [anon_sym_register] = ACTIONS(3452),
    [anon_sym_inline] = ACTIONS(3452),
    [anon_sym___inline] = ACTIONS(3452),
    [anon_sym___inline__] = ACTIONS(3452),
    [anon_sym___forceinline] = ACTIONS(3452),
    [anon_sym_thread_local] = ACTIONS(3452),
    [anon_sym___thread] = ACTIONS(3452),
    [anon_sym_const] = ACTIONS(3452),
    [anon_sym_constexpr] = ACTIONS(3452),
    [anon_sym_volatile] = ACTIONS(3452),
    [anon_sym_restrict] = ACTIONS(3452),
    [anon_sym___restrict__] = ACTIONS(3452),
    [anon_sym__Atomic] = ACTIONS(3452),
    [anon_sym__Noreturn] = ACTIONS(3452),
    [anon_sym_noreturn] = ACTIONS(3452),
    [anon_sym__Nonnull] = ACTIONS(3452),
    [anon_sym_mutable] = ACTIONS(3452),
    [anon_sym_constinit] = ACTIONS(3452),
    [anon_sym_consteval] = ACTIONS(3452),
    [anon_sym_alignas] = ACTIONS(3452),
    [anon_sym__Alignas] = ACTIONS(3452),
    [sym_primitive_type] = ACTIONS(3452),
    [anon_sym_enum] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(3452),
    [anon_sym_union] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_else] = ACTIONS(3452),
    [anon_sym_switch] = ACTIONS(3452),
    [anon_sym_case] = ACTIONS(3452),
    [anon_sym_default] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_do] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3452),
    [anon_sym_return] = ACTIONS(3452),
    [anon_sym_break] = ACTIONS(3452),
    [anon_sym_continue] = ACTIONS(3452),
    [anon_sym_goto] = ACTIONS(3452),
    [anon_sym___try] = ACTIONS(3452),
    [anon_sym___leave] = ACTIONS(3452),
    [anon_sym_not] = ACTIONS(3452),
    [anon_sym_compl] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3450),
    [anon_sym_PLUS_PLUS] = ACTIONS(3450),
    [anon_sym_sizeof] = ACTIONS(3452),
    [anon_sym___alignof__] = ACTIONS(3452),
    [anon_sym___alignof] = ACTIONS(3452),
    [anon_sym__alignof] = ACTIONS(3452),
    [anon_sym_alignof] = ACTIONS(3452),
    [anon_sym__Alignof] = ACTIONS(3452),
    [anon_sym_offsetof] = ACTIONS(3452),
    [anon_sym__Generic] = ACTIONS(3452),
    [anon_sym_asm] = ACTIONS(3452),
    [anon_sym___asm__] = ACTIONS(3452),
    [anon_sym___asm] = ACTIONS(3452),
    [sym_number_literal] = ACTIONS(3450),
    [anon_sym_L_SQUOTE] = ACTIONS(3450),
    [anon_sym_u_SQUOTE] = ACTIONS(3450),
    [anon_sym_U_SQUOTE] = ACTIONS(3450),
    [anon_sym_u8_SQUOTE] = ACTIONS(3450),
    [anon_sym_SQUOTE] = ACTIONS(3450),
    [anon_sym_L_DQUOTE] = ACTIONS(3450),
    [anon_sym_u_DQUOTE] = ACTIONS(3450),
    [anon_sym_U_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8_DQUOTE] = ACTIONS(3450),
    [anon_sym_DQUOTE] = ACTIONS(3450),
    [sym_true] = ACTIONS(3452),
    [sym_false] = ACTIONS(3452),
    [anon_sym_NULL] = ACTIONS(3452),
    [anon_sym_nullptr] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3452),
    [anon_sym_let] = ACTIONS(3452),
    [anon_sym_This] = ACTIONS(3452),
    [anon_sym_decltype] = ACTIONS(3452),
    [anon_sym_explicit] = ACTIONS(3452),
    [anon_sym_typename] = ACTIONS(3452),
    [anon_sym_template] = ACTIONS(3452),
    [anon_sym_operator] = ACTIONS(3452),
    [anon_sym_try] = ACTIONS(3452),
    [anon_sym_delete] = ACTIONS(3452),
    [anon_sym_throw] = ACTIONS(3452),
    [anon_sym_namespace] = ACTIONS(3452),
    [anon_sym_static_assert] = ACTIONS(3452),
    [anon_sym_concept] = ACTIONS(3452),
    [anon_sym_co_return] = ACTIONS(3452),
    [anon_sym_co_yield] = ACTIONS(3452),
    [anon_sym_R_DQUOTE] = ACTIONS(3450),
    [anon_sym_LR_DQUOTE] = ACTIONS(3450),
    [anon_sym_uR_DQUOTE] = ACTIONS(3450),
    [anon_sym_UR_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3450),
    [anon_sym_co_await] = ACTIONS(3452),
    [anon_sym_new] = ACTIONS(3452),
    [anon_sym_requires] = ACTIONS(3452),
    [sym_this] = ACTIONS(3452),
    [anon_sym_discard] = ACTIONS(3452),
    [anon_sym_precise] = ACTIONS(3452),
    [anon_sym_shared] = ACTIONS(3452),
    [anon_sym_groupshared] = ACTIONS(3452),
    [anon_sym_uniform] = ACTIONS(3452),
    [anon_sym_row_major] = ACTIONS(3452),
    [anon_sym_column_major] = ACTIONS(3452),
    [anon_sym_globallycoherent] = ACTIONS(3452),
    [anon_sym_centroid] = ACTIONS(3452),
    [anon_sym_noperspective] = ACTIONS(3452),
    [anon_sym_nointerpolation] = ACTIONS(3452),
    [anon_sym_sample] = ACTIONS(3452),
    [anon_sym_linear] = ACTIONS(3452),
    [anon_sym_snorm] = ACTIONS(3452),
    [anon_sym_unorm] = ACTIONS(3452),
    [anon_sym_point] = ACTIONS(3452),
    [anon_sym_line] = ACTIONS(3452),
    [anon_sym_triangleadj] = ACTIONS(3452),
    [anon_sym_lineadj] = ACTIONS(3452),
    [anon_sym_triangle] = ACTIONS(3452),
    [anon_sym_cbuffer] = ACTIONS(3452),
    [anon_sym_interface] = ACTIONS(3452),
    [anon_sym_extension] = ACTIONS(3452),
  },
  [729] = {
    [sym_identifier] = ACTIONS(3603),
    [aux_sym_preproc_include_token1] = ACTIONS(3603),
    [aux_sym_preproc_def_token1] = ACTIONS(3603),
    [aux_sym_preproc_if_token1] = ACTIONS(3603),
    [aux_sym_preproc_if_token2] = ACTIONS(3603),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3603),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3603),
    [sym_preproc_directive] = ACTIONS(3603),
    [anon_sym_LPAREN2] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3601),
    [anon_sym_TILDE] = ACTIONS(3601),
    [anon_sym_DASH] = ACTIONS(3603),
    [anon_sym_PLUS] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(3601),
    [anon_sym_AMP_AMP] = ACTIONS(3601),
    [anon_sym_AMP] = ACTIONS(3603),
    [anon_sym_SEMI] = ACTIONS(3601),
    [anon_sym___extension__] = ACTIONS(3603),
    [anon_sym_typedef] = ACTIONS(3603),
    [anon_sym_in] = ACTIONS(3603),
    [anon_sym_out] = ACTIONS(3603),
    [anon_sym_inout] = ACTIONS(3603),
    [anon_sym_virtual] = ACTIONS(3603),
    [anon_sym_extern] = ACTIONS(3603),
    [anon_sym___attribute__] = ACTIONS(3603),
    [anon_sym___attribute] = ACTIONS(3603),
    [anon_sym_using] = ACTIONS(3603),
    [anon_sym_COLON_COLON] = ACTIONS(3601),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3601),
    [anon_sym___declspec] = ACTIONS(3603),
    [anon_sym___based] = ACTIONS(3603),
    [anon_sym___cdecl] = ACTIONS(3603),
    [anon_sym___clrcall] = ACTIONS(3603),
    [anon_sym___stdcall] = ACTIONS(3603),
    [anon_sym___fastcall] = ACTIONS(3603),
    [anon_sym___thiscall] = ACTIONS(3603),
    [anon_sym___vectorcall] = ACTIONS(3603),
    [anon_sym_LBRACE] = ACTIONS(3601),
    [anon_sym_signed] = ACTIONS(3603),
    [anon_sym_unsigned] = ACTIONS(3603),
    [anon_sym_long] = ACTIONS(3603),
    [anon_sym_short] = ACTIONS(3603),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_static] = ACTIONS(3603),
    [anon_sym_register] = ACTIONS(3603),
    [anon_sym_inline] = ACTIONS(3603),
    [anon_sym___inline] = ACTIONS(3603),
    [anon_sym___inline__] = ACTIONS(3603),
    [anon_sym___forceinline] = ACTIONS(3603),
    [anon_sym_thread_local] = ACTIONS(3603),
    [anon_sym___thread] = ACTIONS(3603),
    [anon_sym_const] = ACTIONS(3603),
    [anon_sym_constexpr] = ACTIONS(3603),
    [anon_sym_volatile] = ACTIONS(3603),
    [anon_sym_restrict] = ACTIONS(3603),
    [anon_sym___restrict__] = ACTIONS(3603),
    [anon_sym__Atomic] = ACTIONS(3603),
    [anon_sym__Noreturn] = ACTIONS(3603),
    [anon_sym_noreturn] = ACTIONS(3603),
    [anon_sym__Nonnull] = ACTIONS(3603),
    [anon_sym_mutable] = ACTIONS(3603),
    [anon_sym_constinit] = ACTIONS(3603),
    [anon_sym_consteval] = ACTIONS(3603),
    [anon_sym_alignas] = ACTIONS(3603),
    [anon_sym__Alignas] = ACTIONS(3603),
    [sym_primitive_type] = ACTIONS(3603),
    [anon_sym_enum] = ACTIONS(3603),
    [anon_sym_class] = ACTIONS(3603),
    [anon_sym_struct] = ACTIONS(3603),
    [anon_sym_union] = ACTIONS(3603),
    [anon_sym_if] = ACTIONS(3603),
    [anon_sym_else] = ACTIONS(3603),
    [anon_sym_switch] = ACTIONS(3603),
    [anon_sym_case] = ACTIONS(3603),
    [anon_sym_default] = ACTIONS(3603),
    [anon_sym_while] = ACTIONS(3603),
    [anon_sym_do] = ACTIONS(3603),
    [anon_sym_for] = ACTIONS(3603),
    [anon_sym_return] = ACTIONS(3603),
    [anon_sym_break] = ACTIONS(3603),
    [anon_sym_continue] = ACTIONS(3603),
    [anon_sym_goto] = ACTIONS(3603),
    [anon_sym___try] = ACTIONS(3603),
    [anon_sym___leave] = ACTIONS(3603),
    [anon_sym_not] = ACTIONS(3603),
    [anon_sym_compl] = ACTIONS(3603),
    [anon_sym_DASH_DASH] = ACTIONS(3601),
    [anon_sym_PLUS_PLUS] = ACTIONS(3601),
    [anon_sym_sizeof] = ACTIONS(3603),
    [anon_sym___alignof__] = ACTIONS(3603),
    [anon_sym___alignof] = ACTIONS(3603),
    [anon_sym__alignof] = ACTIONS(3603),
    [anon_sym_alignof] = ACTIONS(3603),
    [anon_sym__Alignof] = ACTIONS(3603),
    [anon_sym_offsetof] = ACTIONS(3603),
    [anon_sym__Generic] = ACTIONS(3603),
    [anon_sym_asm] = ACTIONS(3603),
    [anon_sym___asm__] = ACTIONS(3603),
    [anon_sym___asm] = ACTIONS(3603),
    [sym_number_literal] = ACTIONS(3601),
    [anon_sym_L_SQUOTE] = ACTIONS(3601),
    [anon_sym_u_SQUOTE] = ACTIONS(3601),
    [anon_sym_U_SQUOTE] = ACTIONS(3601),
    [anon_sym_u8_SQUOTE] = ACTIONS(3601),
    [anon_sym_SQUOTE] = ACTIONS(3601),
    [anon_sym_L_DQUOTE] = ACTIONS(3601),
    [anon_sym_u_DQUOTE] = ACTIONS(3601),
    [anon_sym_U_DQUOTE] = ACTIONS(3601),
    [anon_sym_u8_DQUOTE] = ACTIONS(3601),
    [anon_sym_DQUOTE] = ACTIONS(3601),
    [sym_true] = ACTIONS(3603),
    [sym_false] = ACTIONS(3603),
    [anon_sym_NULL] = ACTIONS(3603),
    [anon_sym_nullptr] = ACTIONS(3603),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3603),
    [anon_sym_let] = ACTIONS(3603),
    [anon_sym_This] = ACTIONS(3603),
    [anon_sym_decltype] = ACTIONS(3603),
    [anon_sym_explicit] = ACTIONS(3603),
    [anon_sym_typename] = ACTIONS(3603),
    [anon_sym_template] = ACTIONS(3603),
    [anon_sym_operator] = ACTIONS(3603),
    [anon_sym_try] = ACTIONS(3603),
    [anon_sym_delete] = ACTIONS(3603),
    [anon_sym_throw] = ACTIONS(3603),
    [anon_sym_namespace] = ACTIONS(3603),
    [anon_sym_static_assert] = ACTIONS(3603),
    [anon_sym_concept] = ACTIONS(3603),
    [anon_sym_co_return] = ACTIONS(3603),
    [anon_sym_co_yield] = ACTIONS(3603),
    [anon_sym_R_DQUOTE] = ACTIONS(3601),
    [anon_sym_LR_DQUOTE] = ACTIONS(3601),
    [anon_sym_uR_DQUOTE] = ACTIONS(3601),
    [anon_sym_UR_DQUOTE] = ACTIONS(3601),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3601),
    [anon_sym_co_await] = ACTIONS(3603),
    [anon_sym_new] = ACTIONS(3603),
    [anon_sym_requires] = ACTIONS(3603),
    [sym_this] = ACTIONS(3603),
    [anon_sym_discard] = ACTIONS(3603),
    [anon_sym_precise] = ACTIONS(3603),
    [anon_sym_shared] = ACTIONS(3603),
    [anon_sym_groupshared] = ACTIONS(3603),
    [anon_sym_uniform] = ACTIONS(3603),
    [anon_sym_row_major] = ACTIONS(3603),
    [anon_sym_column_major] = ACTIONS(3603),
    [anon_sym_globallycoherent] = ACTIONS(3603),
    [anon_sym_centroid] = ACTIONS(3603),
    [anon_sym_noperspective] = ACTIONS(3603),
    [anon_sym_nointerpolation] = ACTIONS(3603),
    [anon_sym_sample] = ACTIONS(3603),
    [anon_sym_linear] = ACTIONS(3603),
    [anon_sym_snorm] = ACTIONS(3603),
    [anon_sym_unorm] = ACTIONS(3603),
    [anon_sym_point] = ACTIONS(3603),
    [anon_sym_line] = ACTIONS(3603),
    [anon_sym_triangleadj] = ACTIONS(3603),
    [anon_sym_lineadj] = ACTIONS(3603),
    [anon_sym_triangle] = ACTIONS(3603),
    [anon_sym_cbuffer] = ACTIONS(3603),
    [anon_sym_interface] = ACTIONS(3603),
    [anon_sym_extension] = ACTIONS(3603),
  },
  [730] = {
    [sym_identifier] = ACTIONS(3607),
    [aux_sym_preproc_include_token1] = ACTIONS(3607),
    [aux_sym_preproc_def_token1] = ACTIONS(3607),
    [aux_sym_preproc_if_token1] = ACTIONS(3607),
    [aux_sym_preproc_if_token2] = ACTIONS(3607),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3607),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3607),
    [sym_preproc_directive] = ACTIONS(3607),
    [anon_sym_LPAREN2] = ACTIONS(3605),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(3605),
    [anon_sym_AMP_AMP] = ACTIONS(3605),
    [anon_sym_AMP] = ACTIONS(3607),
    [anon_sym_SEMI] = ACTIONS(3605),
    [anon_sym___extension__] = ACTIONS(3607),
    [anon_sym_typedef] = ACTIONS(3607),
    [anon_sym_in] = ACTIONS(3607),
    [anon_sym_out] = ACTIONS(3607),
    [anon_sym_inout] = ACTIONS(3607),
    [anon_sym_virtual] = ACTIONS(3607),
    [anon_sym_extern] = ACTIONS(3607),
    [anon_sym___attribute__] = ACTIONS(3607),
    [anon_sym___attribute] = ACTIONS(3607),
    [anon_sym_using] = ACTIONS(3607),
    [anon_sym_COLON_COLON] = ACTIONS(3605),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3605),
    [anon_sym___declspec] = ACTIONS(3607),
    [anon_sym___based] = ACTIONS(3607),
    [anon_sym___cdecl] = ACTIONS(3607),
    [anon_sym___clrcall] = ACTIONS(3607),
    [anon_sym___stdcall] = ACTIONS(3607),
    [anon_sym___fastcall] = ACTIONS(3607),
    [anon_sym___thiscall] = ACTIONS(3607),
    [anon_sym___vectorcall] = ACTIONS(3607),
    [anon_sym_LBRACE] = ACTIONS(3605),
    [anon_sym_signed] = ACTIONS(3607),
    [anon_sym_unsigned] = ACTIONS(3607),
    [anon_sym_long] = ACTIONS(3607),
    [anon_sym_short] = ACTIONS(3607),
    [anon_sym_LBRACK] = ACTIONS(3607),
    [anon_sym_static] = ACTIONS(3607),
    [anon_sym_register] = ACTIONS(3607),
    [anon_sym_inline] = ACTIONS(3607),
    [anon_sym___inline] = ACTIONS(3607),
    [anon_sym___inline__] = ACTIONS(3607),
    [anon_sym___forceinline] = ACTIONS(3607),
    [anon_sym_thread_local] = ACTIONS(3607),
    [anon_sym___thread] = ACTIONS(3607),
    [anon_sym_const] = ACTIONS(3607),
    [anon_sym_constexpr] = ACTIONS(3607),
    [anon_sym_volatile] = ACTIONS(3607),
    [anon_sym_restrict] = ACTIONS(3607),
    [anon_sym___restrict__] = ACTIONS(3607),
    [anon_sym__Atomic] = ACTIONS(3607),
    [anon_sym__Noreturn] = ACTIONS(3607),
    [anon_sym_noreturn] = ACTIONS(3607),
    [anon_sym__Nonnull] = ACTIONS(3607),
    [anon_sym_mutable] = ACTIONS(3607),
    [anon_sym_constinit] = ACTIONS(3607),
    [anon_sym_consteval] = ACTIONS(3607),
    [anon_sym_alignas] = ACTIONS(3607),
    [anon_sym__Alignas] = ACTIONS(3607),
    [sym_primitive_type] = ACTIONS(3607),
    [anon_sym_enum] = ACTIONS(3607),
    [anon_sym_class] = ACTIONS(3607),
    [anon_sym_struct] = ACTIONS(3607),
    [anon_sym_union] = ACTIONS(3607),
    [anon_sym_if] = ACTIONS(3607),
    [anon_sym_else] = ACTIONS(3607),
    [anon_sym_switch] = ACTIONS(3607),
    [anon_sym_case] = ACTIONS(3607),
    [anon_sym_default] = ACTIONS(3607),
    [anon_sym_while] = ACTIONS(3607),
    [anon_sym_do] = ACTIONS(3607),
    [anon_sym_for] = ACTIONS(3607),
    [anon_sym_return] = ACTIONS(3607),
    [anon_sym_break] = ACTIONS(3607),
    [anon_sym_continue] = ACTIONS(3607),
    [anon_sym_goto] = ACTIONS(3607),
    [anon_sym___try] = ACTIONS(3607),
    [anon_sym___leave] = ACTIONS(3607),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(3605),
    [anon_sym_PLUS_PLUS] = ACTIONS(3605),
    [anon_sym_sizeof] = ACTIONS(3607),
    [anon_sym___alignof__] = ACTIONS(3607),
    [anon_sym___alignof] = ACTIONS(3607),
    [anon_sym__alignof] = ACTIONS(3607),
    [anon_sym_alignof] = ACTIONS(3607),
    [anon_sym__Alignof] = ACTIONS(3607),
    [anon_sym_offsetof] = ACTIONS(3607),
    [anon_sym__Generic] = ACTIONS(3607),
    [anon_sym_asm] = ACTIONS(3607),
    [anon_sym___asm__] = ACTIONS(3607),
    [anon_sym___asm] = ACTIONS(3607),
    [sym_number_literal] = ACTIONS(3605),
    [anon_sym_L_SQUOTE] = ACTIONS(3605),
    [anon_sym_u_SQUOTE] = ACTIONS(3605),
    [anon_sym_U_SQUOTE] = ACTIONS(3605),
    [anon_sym_u8_SQUOTE] = ACTIONS(3605),
    [anon_sym_SQUOTE] = ACTIONS(3605),
    [anon_sym_L_DQUOTE] = ACTIONS(3605),
    [anon_sym_u_DQUOTE] = ACTIONS(3605),
    [anon_sym_U_DQUOTE] = ACTIONS(3605),
    [anon_sym_u8_DQUOTE] = ACTIONS(3605),
    [anon_sym_DQUOTE] = ACTIONS(3605),
    [sym_true] = ACTIONS(3607),
    [sym_false] = ACTIONS(3607),
    [anon_sym_NULL] = ACTIONS(3607),
    [anon_sym_nullptr] = ACTIONS(3607),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3607),
    [anon_sym_let] = ACTIONS(3607),
    [anon_sym_This] = ACTIONS(3607),
    [anon_sym_decltype] = ACTIONS(3607),
    [anon_sym_explicit] = ACTIONS(3607),
    [anon_sym_typename] = ACTIONS(3607),
    [anon_sym_template] = ACTIONS(3607),
    [anon_sym_operator] = ACTIONS(3607),
    [anon_sym_try] = ACTIONS(3607),
    [anon_sym_delete] = ACTIONS(3607),
    [anon_sym_throw] = ACTIONS(3607),
    [anon_sym_namespace] = ACTIONS(3607),
    [anon_sym_static_assert] = ACTIONS(3607),
    [anon_sym_concept] = ACTIONS(3607),
    [anon_sym_co_return] = ACTIONS(3607),
    [anon_sym_co_yield] = ACTIONS(3607),
    [anon_sym_R_DQUOTE] = ACTIONS(3605),
    [anon_sym_LR_DQUOTE] = ACTIONS(3605),
    [anon_sym_uR_DQUOTE] = ACTIONS(3605),
    [anon_sym_UR_DQUOTE] = ACTIONS(3605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3605),
    [anon_sym_co_await] = ACTIONS(3607),
    [anon_sym_new] = ACTIONS(3607),
    [anon_sym_requires] = ACTIONS(3607),
    [sym_this] = ACTIONS(3607),
    [anon_sym_discard] = ACTIONS(3607),
    [anon_sym_precise] = ACTIONS(3607),
    [anon_sym_shared] = ACTIONS(3607),
    [anon_sym_groupshared] = ACTIONS(3607),
    [anon_sym_uniform] = ACTIONS(3607),
    [anon_sym_row_major] = ACTIONS(3607),
    [anon_sym_column_major] = ACTIONS(3607),
    [anon_sym_globallycoherent] = ACTIONS(3607),
    [anon_sym_centroid] = ACTIONS(3607),
    [anon_sym_noperspective] = ACTIONS(3607),
    [anon_sym_nointerpolation] = ACTIONS(3607),
    [anon_sym_sample] = ACTIONS(3607),
    [anon_sym_linear] = ACTIONS(3607),
    [anon_sym_snorm] = ACTIONS(3607),
    [anon_sym_unorm] = ACTIONS(3607),
    [anon_sym_point] = ACTIONS(3607),
    [anon_sym_line] = ACTIONS(3607),
    [anon_sym_triangleadj] = ACTIONS(3607),
    [anon_sym_lineadj] = ACTIONS(3607),
    [anon_sym_triangle] = ACTIONS(3607),
    [anon_sym_cbuffer] = ACTIONS(3607),
    [anon_sym_interface] = ACTIONS(3607),
    [anon_sym_extension] = ACTIONS(3607),
  },
  [731] = {
    [sym_identifier] = ACTIONS(3611),
    [aux_sym_preproc_include_token1] = ACTIONS(3611),
    [aux_sym_preproc_def_token1] = ACTIONS(3611),
    [aux_sym_preproc_if_token1] = ACTIONS(3611),
    [aux_sym_preproc_if_token2] = ACTIONS(3611),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3611),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3611),
    [sym_preproc_directive] = ACTIONS(3611),
    [anon_sym_LPAREN2] = ACTIONS(3609),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3611),
    [anon_sym_PLUS] = ACTIONS(3611),
    [anon_sym_STAR] = ACTIONS(3609),
    [anon_sym_AMP_AMP] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(3611),
    [anon_sym_SEMI] = ACTIONS(3609),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_typedef] = ACTIONS(3611),
    [anon_sym_in] = ACTIONS(3611),
    [anon_sym_out] = ACTIONS(3611),
    [anon_sym_inout] = ACTIONS(3611),
    [anon_sym_virtual] = ACTIONS(3611),
    [anon_sym_extern] = ACTIONS(3611),
    [anon_sym___attribute__] = ACTIONS(3611),
    [anon_sym___attribute] = ACTIONS(3611),
    [anon_sym_using] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3609),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3609),
    [anon_sym___declspec] = ACTIONS(3611),
    [anon_sym___based] = ACTIONS(3611),
    [anon_sym___cdecl] = ACTIONS(3611),
    [anon_sym___clrcall] = ACTIONS(3611),
    [anon_sym___stdcall] = ACTIONS(3611),
    [anon_sym___fastcall] = ACTIONS(3611),
    [anon_sym___thiscall] = ACTIONS(3611),
    [anon_sym___vectorcall] = ACTIONS(3611),
    [anon_sym_LBRACE] = ACTIONS(3609),
    [anon_sym_signed] = ACTIONS(3611),
    [anon_sym_unsigned] = ACTIONS(3611),
    [anon_sym_long] = ACTIONS(3611),
    [anon_sym_short] = ACTIONS(3611),
    [anon_sym_LBRACK] = ACTIONS(3611),
    [anon_sym_static] = ACTIONS(3611),
    [anon_sym_register] = ACTIONS(3611),
    [anon_sym_inline] = ACTIONS(3611),
    [anon_sym___inline] = ACTIONS(3611),
    [anon_sym___inline__] = ACTIONS(3611),
    [anon_sym___forceinline] = ACTIONS(3611),
    [anon_sym_thread_local] = ACTIONS(3611),
    [anon_sym___thread] = ACTIONS(3611),
    [anon_sym_const] = ACTIONS(3611),
    [anon_sym_constexpr] = ACTIONS(3611),
    [anon_sym_volatile] = ACTIONS(3611),
    [anon_sym_restrict] = ACTIONS(3611),
    [anon_sym___restrict__] = ACTIONS(3611),
    [anon_sym__Atomic] = ACTIONS(3611),
    [anon_sym__Noreturn] = ACTIONS(3611),
    [anon_sym_noreturn] = ACTIONS(3611),
    [anon_sym__Nonnull] = ACTIONS(3611),
    [anon_sym_mutable] = ACTIONS(3611),
    [anon_sym_constinit] = ACTIONS(3611),
    [anon_sym_consteval] = ACTIONS(3611),
    [anon_sym_alignas] = ACTIONS(3611),
    [anon_sym__Alignas] = ACTIONS(3611),
    [sym_primitive_type] = ACTIONS(3611),
    [anon_sym_enum] = ACTIONS(3611),
    [anon_sym_class] = ACTIONS(3611),
    [anon_sym_struct] = ACTIONS(3611),
    [anon_sym_union] = ACTIONS(3611),
    [anon_sym_if] = ACTIONS(3611),
    [anon_sym_else] = ACTIONS(3611),
    [anon_sym_switch] = ACTIONS(3611),
    [anon_sym_case] = ACTIONS(3611),
    [anon_sym_default] = ACTIONS(3611),
    [anon_sym_while] = ACTIONS(3611),
    [anon_sym_do] = ACTIONS(3611),
    [anon_sym_for] = ACTIONS(3611),
    [anon_sym_return] = ACTIONS(3611),
    [anon_sym_break] = ACTIONS(3611),
    [anon_sym_continue] = ACTIONS(3611),
    [anon_sym_goto] = ACTIONS(3611),
    [anon_sym___try] = ACTIONS(3611),
    [anon_sym___leave] = ACTIONS(3611),
    [anon_sym_not] = ACTIONS(3611),
    [anon_sym_compl] = ACTIONS(3611),
    [anon_sym_DASH_DASH] = ACTIONS(3609),
    [anon_sym_PLUS_PLUS] = ACTIONS(3609),
    [anon_sym_sizeof] = ACTIONS(3611),
    [anon_sym___alignof__] = ACTIONS(3611),
    [anon_sym___alignof] = ACTIONS(3611),
    [anon_sym__alignof] = ACTIONS(3611),
    [anon_sym_alignof] = ACTIONS(3611),
    [anon_sym__Alignof] = ACTIONS(3611),
    [anon_sym_offsetof] = ACTIONS(3611),
    [anon_sym__Generic] = ACTIONS(3611),
    [anon_sym_asm] = ACTIONS(3611),
    [anon_sym___asm__] = ACTIONS(3611),
    [anon_sym___asm] = ACTIONS(3611),
    [sym_number_literal] = ACTIONS(3609),
    [anon_sym_L_SQUOTE] = ACTIONS(3609),
    [anon_sym_u_SQUOTE] = ACTIONS(3609),
    [anon_sym_U_SQUOTE] = ACTIONS(3609),
    [anon_sym_u8_SQUOTE] = ACTIONS(3609),
    [anon_sym_SQUOTE] = ACTIONS(3609),
    [anon_sym_L_DQUOTE] = ACTIONS(3609),
    [anon_sym_u_DQUOTE] = ACTIONS(3609),
    [anon_sym_U_DQUOTE] = ACTIONS(3609),
    [anon_sym_u8_DQUOTE] = ACTIONS(3609),
    [anon_sym_DQUOTE] = ACTIONS(3609),
    [sym_true] = ACTIONS(3611),
    [sym_false] = ACTIONS(3611),
    [anon_sym_NULL] = ACTIONS(3611),
    [anon_sym_nullptr] = ACTIONS(3611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3611),
    [anon_sym_let] = ACTIONS(3611),
    [anon_sym_This] = ACTIONS(3611),
    [anon_sym_decltype] = ACTIONS(3611),
    [anon_sym_explicit] = ACTIONS(3611),
    [anon_sym_typename] = ACTIONS(3611),
    [anon_sym_template] = ACTIONS(3611),
    [anon_sym_operator] = ACTIONS(3611),
    [anon_sym_try] = ACTIONS(3611),
    [anon_sym_delete] = ACTIONS(3611),
    [anon_sym_throw] = ACTIONS(3611),
    [anon_sym_namespace] = ACTIONS(3611),
    [anon_sym_static_assert] = ACTIONS(3611),
    [anon_sym_concept] = ACTIONS(3611),
    [anon_sym_co_return] = ACTIONS(3611),
    [anon_sym_co_yield] = ACTIONS(3611),
    [anon_sym_R_DQUOTE] = ACTIONS(3609),
    [anon_sym_LR_DQUOTE] = ACTIONS(3609),
    [anon_sym_uR_DQUOTE] = ACTIONS(3609),
    [anon_sym_UR_DQUOTE] = ACTIONS(3609),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3609),
    [anon_sym_co_await] = ACTIONS(3611),
    [anon_sym_new] = ACTIONS(3611),
    [anon_sym_requires] = ACTIONS(3611),
    [sym_this] = ACTIONS(3611),
    [anon_sym_discard] = ACTIONS(3611),
    [anon_sym_precise] = ACTIONS(3611),
    [anon_sym_shared] = ACTIONS(3611),
    [anon_sym_groupshared] = ACTIONS(3611),
    [anon_sym_uniform] = ACTIONS(3611),
    [anon_sym_row_major] = ACTIONS(3611),
    [anon_sym_column_major] = ACTIONS(3611),
    [anon_sym_globallycoherent] = ACTIONS(3611),
    [anon_sym_centroid] = ACTIONS(3611),
    [anon_sym_noperspective] = ACTIONS(3611),
    [anon_sym_nointerpolation] = ACTIONS(3611),
    [anon_sym_sample] = ACTIONS(3611),
    [anon_sym_linear] = ACTIONS(3611),
    [anon_sym_snorm] = ACTIONS(3611),
    [anon_sym_unorm] = ACTIONS(3611),
    [anon_sym_point] = ACTIONS(3611),
    [anon_sym_line] = ACTIONS(3611),
    [anon_sym_triangleadj] = ACTIONS(3611),
    [anon_sym_lineadj] = ACTIONS(3611),
    [anon_sym_triangle] = ACTIONS(3611),
    [anon_sym_cbuffer] = ACTIONS(3611),
    [anon_sym_interface] = ACTIONS(3611),
    [anon_sym_extension] = ACTIONS(3611),
  },
  [732] = {
    [sym_identifier] = ACTIONS(3615),
    [aux_sym_preproc_include_token1] = ACTIONS(3615),
    [aux_sym_preproc_def_token1] = ACTIONS(3615),
    [aux_sym_preproc_if_token1] = ACTIONS(3615),
    [aux_sym_preproc_if_token2] = ACTIONS(3615),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3615),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3615),
    [sym_preproc_directive] = ACTIONS(3615),
    [anon_sym_LPAREN2] = ACTIONS(3613),
    [anon_sym_BANG] = ACTIONS(3613),
    [anon_sym_TILDE] = ACTIONS(3613),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3613),
    [anon_sym_AMP_AMP] = ACTIONS(3613),
    [anon_sym_AMP] = ACTIONS(3615),
    [anon_sym_SEMI] = ACTIONS(3613),
    [anon_sym___extension__] = ACTIONS(3615),
    [anon_sym_typedef] = ACTIONS(3615),
    [anon_sym_in] = ACTIONS(3615),
    [anon_sym_out] = ACTIONS(3615),
    [anon_sym_inout] = ACTIONS(3615),
    [anon_sym_virtual] = ACTIONS(3615),
    [anon_sym_extern] = ACTIONS(3615),
    [anon_sym___attribute__] = ACTIONS(3615),
    [anon_sym___attribute] = ACTIONS(3615),
    [anon_sym_using] = ACTIONS(3615),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3613),
    [anon_sym___declspec] = ACTIONS(3615),
    [anon_sym___based] = ACTIONS(3615),
    [anon_sym___cdecl] = ACTIONS(3615),
    [anon_sym___clrcall] = ACTIONS(3615),
    [anon_sym___stdcall] = ACTIONS(3615),
    [anon_sym___fastcall] = ACTIONS(3615),
    [anon_sym___thiscall] = ACTIONS(3615),
    [anon_sym___vectorcall] = ACTIONS(3615),
    [anon_sym_LBRACE] = ACTIONS(3613),
    [anon_sym_signed] = ACTIONS(3615),
    [anon_sym_unsigned] = ACTIONS(3615),
    [anon_sym_long] = ACTIONS(3615),
    [anon_sym_short] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(3615),
    [anon_sym_static] = ACTIONS(3615),
    [anon_sym_register] = ACTIONS(3615),
    [anon_sym_inline] = ACTIONS(3615),
    [anon_sym___inline] = ACTIONS(3615),
    [anon_sym___inline__] = ACTIONS(3615),
    [anon_sym___forceinline] = ACTIONS(3615),
    [anon_sym_thread_local] = ACTIONS(3615),
    [anon_sym___thread] = ACTIONS(3615),
    [anon_sym_const] = ACTIONS(3615),
    [anon_sym_constexpr] = ACTIONS(3615),
    [anon_sym_volatile] = ACTIONS(3615),
    [anon_sym_restrict] = ACTIONS(3615),
    [anon_sym___restrict__] = ACTIONS(3615),
    [anon_sym__Atomic] = ACTIONS(3615),
    [anon_sym__Noreturn] = ACTIONS(3615),
    [anon_sym_noreturn] = ACTIONS(3615),
    [anon_sym__Nonnull] = ACTIONS(3615),
    [anon_sym_mutable] = ACTIONS(3615),
    [anon_sym_constinit] = ACTIONS(3615),
    [anon_sym_consteval] = ACTIONS(3615),
    [anon_sym_alignas] = ACTIONS(3615),
    [anon_sym__Alignas] = ACTIONS(3615),
    [sym_primitive_type] = ACTIONS(3615),
    [anon_sym_enum] = ACTIONS(3615),
    [anon_sym_class] = ACTIONS(3615),
    [anon_sym_struct] = ACTIONS(3615),
    [anon_sym_union] = ACTIONS(3615),
    [anon_sym_if] = ACTIONS(3615),
    [anon_sym_else] = ACTIONS(3615),
    [anon_sym_switch] = ACTIONS(3615),
    [anon_sym_case] = ACTIONS(3615),
    [anon_sym_default] = ACTIONS(3615),
    [anon_sym_while] = ACTIONS(3615),
    [anon_sym_do] = ACTIONS(3615),
    [anon_sym_for] = ACTIONS(3615),
    [anon_sym_return] = ACTIONS(3615),
    [anon_sym_break] = ACTIONS(3615),
    [anon_sym_continue] = ACTIONS(3615),
    [anon_sym_goto] = ACTIONS(3615),
    [anon_sym___try] = ACTIONS(3615),
    [anon_sym___leave] = ACTIONS(3615),
    [anon_sym_not] = ACTIONS(3615),
    [anon_sym_compl] = ACTIONS(3615),
    [anon_sym_DASH_DASH] = ACTIONS(3613),
    [anon_sym_PLUS_PLUS] = ACTIONS(3613),
    [anon_sym_sizeof] = ACTIONS(3615),
    [anon_sym___alignof__] = ACTIONS(3615),
    [anon_sym___alignof] = ACTIONS(3615),
    [anon_sym__alignof] = ACTIONS(3615),
    [anon_sym_alignof] = ACTIONS(3615),
    [anon_sym__Alignof] = ACTIONS(3615),
    [anon_sym_offsetof] = ACTIONS(3615),
    [anon_sym__Generic] = ACTIONS(3615),
    [anon_sym_asm] = ACTIONS(3615),
    [anon_sym___asm__] = ACTIONS(3615),
    [anon_sym___asm] = ACTIONS(3615),
    [sym_number_literal] = ACTIONS(3613),
    [anon_sym_L_SQUOTE] = ACTIONS(3613),
    [anon_sym_u_SQUOTE] = ACTIONS(3613),
    [anon_sym_U_SQUOTE] = ACTIONS(3613),
    [anon_sym_u8_SQUOTE] = ACTIONS(3613),
    [anon_sym_SQUOTE] = ACTIONS(3613),
    [anon_sym_L_DQUOTE] = ACTIONS(3613),
    [anon_sym_u_DQUOTE] = ACTIONS(3613),
    [anon_sym_U_DQUOTE] = ACTIONS(3613),
    [anon_sym_u8_DQUOTE] = ACTIONS(3613),
    [anon_sym_DQUOTE] = ACTIONS(3613),
    [sym_true] = ACTIONS(3615),
    [sym_false] = ACTIONS(3615),
    [anon_sym_NULL] = ACTIONS(3615),
    [anon_sym_nullptr] = ACTIONS(3615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3615),
    [anon_sym_let] = ACTIONS(3615),
    [anon_sym_This] = ACTIONS(3615),
    [anon_sym_decltype] = ACTIONS(3615),
    [anon_sym_explicit] = ACTIONS(3615),
    [anon_sym_typename] = ACTIONS(3615),
    [anon_sym_template] = ACTIONS(3615),
    [anon_sym_operator] = ACTIONS(3615),
    [anon_sym_try] = ACTIONS(3615),
    [anon_sym_delete] = ACTIONS(3615),
    [anon_sym_throw] = ACTIONS(3615),
    [anon_sym_namespace] = ACTIONS(3615),
    [anon_sym_static_assert] = ACTIONS(3615),
    [anon_sym_concept] = ACTIONS(3615),
    [anon_sym_co_return] = ACTIONS(3615),
    [anon_sym_co_yield] = ACTIONS(3615),
    [anon_sym_R_DQUOTE] = ACTIONS(3613),
    [anon_sym_LR_DQUOTE] = ACTIONS(3613),
    [anon_sym_uR_DQUOTE] = ACTIONS(3613),
    [anon_sym_UR_DQUOTE] = ACTIONS(3613),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3613),
    [anon_sym_co_await] = ACTIONS(3615),
    [anon_sym_new] = ACTIONS(3615),
    [anon_sym_requires] = ACTIONS(3615),
    [sym_this] = ACTIONS(3615),
    [anon_sym_discard] = ACTIONS(3615),
    [anon_sym_precise] = ACTIONS(3615),
    [anon_sym_shared] = ACTIONS(3615),
    [anon_sym_groupshared] = ACTIONS(3615),
    [anon_sym_uniform] = ACTIONS(3615),
    [anon_sym_row_major] = ACTIONS(3615),
    [anon_sym_column_major] = ACTIONS(3615),
    [anon_sym_globallycoherent] = ACTIONS(3615),
    [anon_sym_centroid] = ACTIONS(3615),
    [anon_sym_noperspective] = ACTIONS(3615),
    [anon_sym_nointerpolation] = ACTIONS(3615),
    [anon_sym_sample] = ACTIONS(3615),
    [anon_sym_linear] = ACTIONS(3615),
    [anon_sym_snorm] = ACTIONS(3615),
    [anon_sym_unorm] = ACTIONS(3615),
    [anon_sym_point] = ACTIONS(3615),
    [anon_sym_line] = ACTIONS(3615),
    [anon_sym_triangleadj] = ACTIONS(3615),
    [anon_sym_lineadj] = ACTIONS(3615),
    [anon_sym_triangle] = ACTIONS(3615),
    [anon_sym_cbuffer] = ACTIONS(3615),
    [anon_sym_interface] = ACTIONS(3615),
    [anon_sym_extension] = ACTIONS(3615),
  },
  [733] = {
    [sym_identifier] = ACTIONS(3619),
    [aux_sym_preproc_include_token1] = ACTIONS(3619),
    [aux_sym_preproc_def_token1] = ACTIONS(3619),
    [aux_sym_preproc_if_token1] = ACTIONS(3619),
    [aux_sym_preproc_if_token2] = ACTIONS(3619),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3619),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3619),
    [sym_preproc_directive] = ACTIONS(3619),
    [anon_sym_LPAREN2] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_DASH] = ACTIONS(3619),
    [anon_sym_PLUS] = ACTIONS(3619),
    [anon_sym_STAR] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP] = ACTIONS(3619),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym___extension__] = ACTIONS(3619),
    [anon_sym_typedef] = ACTIONS(3619),
    [anon_sym_in] = ACTIONS(3619),
    [anon_sym_out] = ACTIONS(3619),
    [anon_sym_inout] = ACTIONS(3619),
    [anon_sym_virtual] = ACTIONS(3619),
    [anon_sym_extern] = ACTIONS(3619),
    [anon_sym___attribute__] = ACTIONS(3619),
    [anon_sym___attribute] = ACTIONS(3619),
    [anon_sym_using] = ACTIONS(3619),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3617),
    [anon_sym___declspec] = ACTIONS(3619),
    [anon_sym___based] = ACTIONS(3619),
    [anon_sym___cdecl] = ACTIONS(3619),
    [anon_sym___clrcall] = ACTIONS(3619),
    [anon_sym___stdcall] = ACTIONS(3619),
    [anon_sym___fastcall] = ACTIONS(3619),
    [anon_sym___thiscall] = ACTIONS(3619),
    [anon_sym___vectorcall] = ACTIONS(3619),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_signed] = ACTIONS(3619),
    [anon_sym_unsigned] = ACTIONS(3619),
    [anon_sym_long] = ACTIONS(3619),
    [anon_sym_short] = ACTIONS(3619),
    [anon_sym_LBRACK] = ACTIONS(3619),
    [anon_sym_static] = ACTIONS(3619),
    [anon_sym_register] = ACTIONS(3619),
    [anon_sym_inline] = ACTIONS(3619),
    [anon_sym___inline] = ACTIONS(3619),
    [anon_sym___inline__] = ACTIONS(3619),
    [anon_sym___forceinline] = ACTIONS(3619),
    [anon_sym_thread_local] = ACTIONS(3619),
    [anon_sym___thread] = ACTIONS(3619),
    [anon_sym_const] = ACTIONS(3619),
    [anon_sym_constexpr] = ACTIONS(3619),
    [anon_sym_volatile] = ACTIONS(3619),
    [anon_sym_restrict] = ACTIONS(3619),
    [anon_sym___restrict__] = ACTIONS(3619),
    [anon_sym__Atomic] = ACTIONS(3619),
    [anon_sym__Noreturn] = ACTIONS(3619),
    [anon_sym_noreturn] = ACTIONS(3619),
    [anon_sym__Nonnull] = ACTIONS(3619),
    [anon_sym_mutable] = ACTIONS(3619),
    [anon_sym_constinit] = ACTIONS(3619),
    [anon_sym_consteval] = ACTIONS(3619),
    [anon_sym_alignas] = ACTIONS(3619),
    [anon_sym__Alignas] = ACTIONS(3619),
    [sym_primitive_type] = ACTIONS(3619),
    [anon_sym_enum] = ACTIONS(3619),
    [anon_sym_class] = ACTIONS(3619),
    [anon_sym_struct] = ACTIONS(3619),
    [anon_sym_union] = ACTIONS(3619),
    [anon_sym_if] = ACTIONS(3619),
    [anon_sym_else] = ACTIONS(3619),
    [anon_sym_switch] = ACTIONS(3619),
    [anon_sym_case] = ACTIONS(3619),
    [anon_sym_default] = ACTIONS(3619),
    [anon_sym_while] = ACTIONS(3619),
    [anon_sym_do] = ACTIONS(3619),
    [anon_sym_for] = ACTIONS(3619),
    [anon_sym_return] = ACTIONS(3619),
    [anon_sym_break] = ACTIONS(3619),
    [anon_sym_continue] = ACTIONS(3619),
    [anon_sym_goto] = ACTIONS(3619),
    [anon_sym___try] = ACTIONS(3619),
    [anon_sym___leave] = ACTIONS(3619),
    [anon_sym_not] = ACTIONS(3619),
    [anon_sym_compl] = ACTIONS(3619),
    [anon_sym_DASH_DASH] = ACTIONS(3617),
    [anon_sym_PLUS_PLUS] = ACTIONS(3617),
    [anon_sym_sizeof] = ACTIONS(3619),
    [anon_sym___alignof__] = ACTIONS(3619),
    [anon_sym___alignof] = ACTIONS(3619),
    [anon_sym__alignof] = ACTIONS(3619),
    [anon_sym_alignof] = ACTIONS(3619),
    [anon_sym__Alignof] = ACTIONS(3619),
    [anon_sym_offsetof] = ACTIONS(3619),
    [anon_sym__Generic] = ACTIONS(3619),
    [anon_sym_asm] = ACTIONS(3619),
    [anon_sym___asm__] = ACTIONS(3619),
    [anon_sym___asm] = ACTIONS(3619),
    [sym_number_literal] = ACTIONS(3617),
    [anon_sym_L_SQUOTE] = ACTIONS(3617),
    [anon_sym_u_SQUOTE] = ACTIONS(3617),
    [anon_sym_U_SQUOTE] = ACTIONS(3617),
    [anon_sym_u8_SQUOTE] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3617),
    [anon_sym_L_DQUOTE] = ACTIONS(3617),
    [anon_sym_u_DQUOTE] = ACTIONS(3617),
    [anon_sym_U_DQUOTE] = ACTIONS(3617),
    [anon_sym_u8_DQUOTE] = ACTIONS(3617),
    [anon_sym_DQUOTE] = ACTIONS(3617),
    [sym_true] = ACTIONS(3619),
    [sym_false] = ACTIONS(3619),
    [anon_sym_NULL] = ACTIONS(3619),
    [anon_sym_nullptr] = ACTIONS(3619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3619),
    [anon_sym_let] = ACTIONS(3619),
    [anon_sym_This] = ACTIONS(3619),
    [anon_sym_decltype] = ACTIONS(3619),
    [anon_sym_explicit] = ACTIONS(3619),
    [anon_sym_typename] = ACTIONS(3619),
    [anon_sym_template] = ACTIONS(3619),
    [anon_sym_operator] = ACTIONS(3619),
    [anon_sym_try] = ACTIONS(3619),
    [anon_sym_delete] = ACTIONS(3619),
    [anon_sym_throw] = ACTIONS(3619),
    [anon_sym_namespace] = ACTIONS(3619),
    [anon_sym_static_assert] = ACTIONS(3619),
    [anon_sym_concept] = ACTIONS(3619),
    [anon_sym_co_return] = ACTIONS(3619),
    [anon_sym_co_yield] = ACTIONS(3619),
    [anon_sym_R_DQUOTE] = ACTIONS(3617),
    [anon_sym_LR_DQUOTE] = ACTIONS(3617),
    [anon_sym_uR_DQUOTE] = ACTIONS(3617),
    [anon_sym_UR_DQUOTE] = ACTIONS(3617),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3617),
    [anon_sym_co_await] = ACTIONS(3619),
    [anon_sym_new] = ACTIONS(3619),
    [anon_sym_requires] = ACTIONS(3619),
    [sym_this] = ACTIONS(3619),
    [anon_sym_discard] = ACTIONS(3619),
    [anon_sym_precise] = ACTIONS(3619),
    [anon_sym_shared] = ACTIONS(3619),
    [anon_sym_groupshared] = ACTIONS(3619),
    [anon_sym_uniform] = ACTIONS(3619),
    [anon_sym_row_major] = ACTIONS(3619),
    [anon_sym_column_major] = ACTIONS(3619),
    [anon_sym_globallycoherent] = ACTIONS(3619),
    [anon_sym_centroid] = ACTIONS(3619),
    [anon_sym_noperspective] = ACTIONS(3619),
    [anon_sym_nointerpolation] = ACTIONS(3619),
    [anon_sym_sample] = ACTIONS(3619),
    [anon_sym_linear] = ACTIONS(3619),
    [anon_sym_snorm] = ACTIONS(3619),
    [anon_sym_unorm] = ACTIONS(3619),
    [anon_sym_point] = ACTIONS(3619),
    [anon_sym_line] = ACTIONS(3619),
    [anon_sym_triangleadj] = ACTIONS(3619),
    [anon_sym_lineadj] = ACTIONS(3619),
    [anon_sym_triangle] = ACTIONS(3619),
    [anon_sym_cbuffer] = ACTIONS(3619),
    [anon_sym_interface] = ACTIONS(3619),
    [anon_sym_extension] = ACTIONS(3619),
  },
  [734] = {
    [sym_identifier] = ACTIONS(3452),
    [aux_sym_preproc_include_token1] = ACTIONS(3452),
    [aux_sym_preproc_def_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3452),
    [sym_preproc_directive] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(3450),
    [anon_sym_BANG] = ACTIONS(3450),
    [anon_sym_TILDE] = ACTIONS(3450),
    [anon_sym_DASH] = ACTIONS(3452),
    [anon_sym_PLUS] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_AMP_AMP] = ACTIONS(3450),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym___extension__] = ACTIONS(3452),
    [anon_sym_typedef] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_out] = ACTIONS(3452),
    [anon_sym_inout] = ACTIONS(3452),
    [anon_sym_virtual] = ACTIONS(3452),
    [anon_sym_extern] = ACTIONS(3452),
    [anon_sym___attribute__] = ACTIONS(3452),
    [anon_sym___attribute] = ACTIONS(3452),
    [anon_sym_using] = ACTIONS(3452),
    [anon_sym_COLON_COLON] = ACTIONS(3450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3450),
    [anon_sym___declspec] = ACTIONS(3452),
    [anon_sym___based] = ACTIONS(3452),
    [anon_sym___cdecl] = ACTIONS(3452),
    [anon_sym___clrcall] = ACTIONS(3452),
    [anon_sym___stdcall] = ACTIONS(3452),
    [anon_sym___fastcall] = ACTIONS(3452),
    [anon_sym___thiscall] = ACTIONS(3452),
    [anon_sym___vectorcall] = ACTIONS(3452),
    [anon_sym_LBRACE] = ACTIONS(3450),
    [anon_sym_RBRACE] = ACTIONS(3450),
    [anon_sym_signed] = ACTIONS(3452),
    [anon_sym_unsigned] = ACTIONS(3452),
    [anon_sym_long] = ACTIONS(3452),
    [anon_sym_short] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3452),
    [anon_sym_static] = ACTIONS(3452),
    [anon_sym_register] = ACTIONS(3452),
    [anon_sym_inline] = ACTIONS(3452),
    [anon_sym___inline] = ACTIONS(3452),
    [anon_sym___inline__] = ACTIONS(3452),
    [anon_sym___forceinline] = ACTIONS(3452),
    [anon_sym_thread_local] = ACTIONS(3452),
    [anon_sym___thread] = ACTIONS(3452),
    [anon_sym_const] = ACTIONS(3452),
    [anon_sym_constexpr] = ACTIONS(3452),
    [anon_sym_volatile] = ACTIONS(3452),
    [anon_sym_restrict] = ACTIONS(3452),
    [anon_sym___restrict__] = ACTIONS(3452),
    [anon_sym__Atomic] = ACTIONS(3452),
    [anon_sym__Noreturn] = ACTIONS(3452),
    [anon_sym_noreturn] = ACTIONS(3452),
    [anon_sym__Nonnull] = ACTIONS(3452),
    [anon_sym_mutable] = ACTIONS(3452),
    [anon_sym_constinit] = ACTIONS(3452),
    [anon_sym_consteval] = ACTIONS(3452),
    [anon_sym_alignas] = ACTIONS(3452),
    [anon_sym__Alignas] = ACTIONS(3452),
    [sym_primitive_type] = ACTIONS(3452),
    [anon_sym_enum] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(3452),
    [anon_sym_union] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_else] = ACTIONS(3452),
    [anon_sym_switch] = ACTIONS(3452),
    [anon_sym_case] = ACTIONS(3452),
    [anon_sym_default] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_do] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3452),
    [anon_sym_return] = ACTIONS(3452),
    [anon_sym_break] = ACTIONS(3452),
    [anon_sym_continue] = ACTIONS(3452),
    [anon_sym_goto] = ACTIONS(3452),
    [anon_sym___try] = ACTIONS(3452),
    [anon_sym___leave] = ACTIONS(3452),
    [anon_sym_not] = ACTIONS(3452),
    [anon_sym_compl] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3450),
    [anon_sym_PLUS_PLUS] = ACTIONS(3450),
    [anon_sym_sizeof] = ACTIONS(3452),
    [anon_sym___alignof__] = ACTIONS(3452),
    [anon_sym___alignof] = ACTIONS(3452),
    [anon_sym__alignof] = ACTIONS(3452),
    [anon_sym_alignof] = ACTIONS(3452),
    [anon_sym__Alignof] = ACTIONS(3452),
    [anon_sym_offsetof] = ACTIONS(3452),
    [anon_sym__Generic] = ACTIONS(3452),
    [anon_sym_asm] = ACTIONS(3452),
    [anon_sym___asm__] = ACTIONS(3452),
    [anon_sym___asm] = ACTIONS(3452),
    [sym_number_literal] = ACTIONS(3450),
    [anon_sym_L_SQUOTE] = ACTIONS(3450),
    [anon_sym_u_SQUOTE] = ACTIONS(3450),
    [anon_sym_U_SQUOTE] = ACTIONS(3450),
    [anon_sym_u8_SQUOTE] = ACTIONS(3450),
    [anon_sym_SQUOTE] = ACTIONS(3450),
    [anon_sym_L_DQUOTE] = ACTIONS(3450),
    [anon_sym_u_DQUOTE] = ACTIONS(3450),
    [anon_sym_U_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8_DQUOTE] = ACTIONS(3450),
    [anon_sym_DQUOTE] = ACTIONS(3450),
    [sym_true] = ACTIONS(3452),
    [sym_false] = ACTIONS(3452),
    [anon_sym_NULL] = ACTIONS(3452),
    [anon_sym_nullptr] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3452),
    [anon_sym_let] = ACTIONS(3452),
    [anon_sym_This] = ACTIONS(3452),
    [anon_sym_decltype] = ACTIONS(3452),
    [anon_sym_explicit] = ACTIONS(3452),
    [anon_sym_typename] = ACTIONS(3452),
    [anon_sym_template] = ACTIONS(3452),
    [anon_sym_operator] = ACTIONS(3452),
    [anon_sym_try] = ACTIONS(3452),
    [anon_sym_delete] = ACTIONS(3452),
    [anon_sym_throw] = ACTIONS(3452),
    [anon_sym_namespace] = ACTIONS(3452),
    [anon_sym_static_assert] = ACTIONS(3452),
    [anon_sym_concept] = ACTIONS(3452),
    [anon_sym_co_return] = ACTIONS(3452),
    [anon_sym_co_yield] = ACTIONS(3452),
    [anon_sym_R_DQUOTE] = ACTIONS(3450),
    [anon_sym_LR_DQUOTE] = ACTIONS(3450),
    [anon_sym_uR_DQUOTE] = ACTIONS(3450),
    [anon_sym_UR_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3450),
    [anon_sym_co_await] = ACTIONS(3452),
    [anon_sym_new] = ACTIONS(3452),
    [anon_sym_requires] = ACTIONS(3452),
    [sym_this] = ACTIONS(3452),
    [anon_sym_discard] = ACTIONS(3452),
    [anon_sym_precise] = ACTIONS(3452),
    [anon_sym_shared] = ACTIONS(3452),
    [anon_sym_groupshared] = ACTIONS(3452),
    [anon_sym_uniform] = ACTIONS(3452),
    [anon_sym_row_major] = ACTIONS(3452),
    [anon_sym_column_major] = ACTIONS(3452),
    [anon_sym_globallycoherent] = ACTIONS(3452),
    [anon_sym_centroid] = ACTIONS(3452),
    [anon_sym_noperspective] = ACTIONS(3452),
    [anon_sym_nointerpolation] = ACTIONS(3452),
    [anon_sym_sample] = ACTIONS(3452),
    [anon_sym_linear] = ACTIONS(3452),
    [anon_sym_snorm] = ACTIONS(3452),
    [anon_sym_unorm] = ACTIONS(3452),
    [anon_sym_point] = ACTIONS(3452),
    [anon_sym_line] = ACTIONS(3452),
    [anon_sym_triangleadj] = ACTIONS(3452),
    [anon_sym_lineadj] = ACTIONS(3452),
    [anon_sym_triangle] = ACTIONS(3452),
    [anon_sym_cbuffer] = ACTIONS(3452),
    [anon_sym_interface] = ACTIONS(3452),
    [anon_sym_extension] = ACTIONS(3452),
  },
  [735] = {
    [sym_identifier] = ACTIONS(3383),
    [aux_sym_preproc_include_token1] = ACTIONS(3383),
    [aux_sym_preproc_def_token1] = ACTIONS(3383),
    [aux_sym_preproc_if_token1] = ACTIONS(3383),
    [aux_sym_preproc_if_token2] = ACTIONS(3383),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3383),
    [sym_preproc_directive] = ACTIONS(3383),
    [anon_sym_LPAREN2] = ACTIONS(3385),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_TILDE] = ACTIONS(3385),
    [anon_sym_DASH] = ACTIONS(3383),
    [anon_sym_PLUS] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(3385),
    [anon_sym_AMP_AMP] = ACTIONS(3385),
    [anon_sym_AMP] = ACTIONS(3383),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym___extension__] = ACTIONS(3383),
    [anon_sym_typedef] = ACTIONS(3383),
    [anon_sym_in] = ACTIONS(3383),
    [anon_sym_out] = ACTIONS(3383),
    [anon_sym_inout] = ACTIONS(3383),
    [anon_sym_virtual] = ACTIONS(3383),
    [anon_sym_extern] = ACTIONS(3383),
    [anon_sym___attribute__] = ACTIONS(3383),
    [anon_sym___attribute] = ACTIONS(3383),
    [anon_sym_using] = ACTIONS(3383),
    [anon_sym_COLON_COLON] = ACTIONS(3385),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3385),
    [anon_sym___declspec] = ACTIONS(3383),
    [anon_sym___based] = ACTIONS(3383),
    [anon_sym___cdecl] = ACTIONS(3383),
    [anon_sym___clrcall] = ACTIONS(3383),
    [anon_sym___stdcall] = ACTIONS(3383),
    [anon_sym___fastcall] = ACTIONS(3383),
    [anon_sym___thiscall] = ACTIONS(3383),
    [anon_sym___vectorcall] = ACTIONS(3383),
    [anon_sym_LBRACE] = ACTIONS(3385),
    [anon_sym_signed] = ACTIONS(3383),
    [anon_sym_unsigned] = ACTIONS(3383),
    [anon_sym_long] = ACTIONS(3383),
    [anon_sym_short] = ACTIONS(3383),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_static] = ACTIONS(3383),
    [anon_sym_register] = ACTIONS(3383),
    [anon_sym_inline] = ACTIONS(3383),
    [anon_sym___inline] = ACTIONS(3383),
    [anon_sym___inline__] = ACTIONS(3383),
    [anon_sym___forceinline] = ACTIONS(3383),
    [anon_sym_thread_local] = ACTIONS(3383),
    [anon_sym___thread] = ACTIONS(3383),
    [anon_sym_const] = ACTIONS(3383),
    [anon_sym_constexpr] = ACTIONS(3383),
    [anon_sym_volatile] = ACTIONS(3383),
    [anon_sym_restrict] = ACTIONS(3383),
    [anon_sym___restrict__] = ACTIONS(3383),
    [anon_sym__Atomic] = ACTIONS(3383),
    [anon_sym__Noreturn] = ACTIONS(3383),
    [anon_sym_noreturn] = ACTIONS(3383),
    [anon_sym__Nonnull] = ACTIONS(3383),
    [anon_sym_mutable] = ACTIONS(3383),
    [anon_sym_constinit] = ACTIONS(3383),
    [anon_sym_consteval] = ACTIONS(3383),
    [anon_sym_alignas] = ACTIONS(3383),
    [anon_sym__Alignas] = ACTIONS(3383),
    [sym_primitive_type] = ACTIONS(3383),
    [anon_sym_enum] = ACTIONS(3383),
    [anon_sym_class] = ACTIONS(3383),
    [anon_sym_struct] = ACTIONS(3383),
    [anon_sym_union] = ACTIONS(3383),
    [anon_sym_if] = ACTIONS(3383),
    [anon_sym_else] = ACTIONS(3383),
    [anon_sym_switch] = ACTIONS(3383),
    [anon_sym_case] = ACTIONS(3383),
    [anon_sym_default] = ACTIONS(3383),
    [anon_sym_while] = ACTIONS(3383),
    [anon_sym_do] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3383),
    [anon_sym_return] = ACTIONS(3383),
    [anon_sym_break] = ACTIONS(3383),
    [anon_sym_continue] = ACTIONS(3383),
    [anon_sym_goto] = ACTIONS(3383),
    [anon_sym___try] = ACTIONS(3383),
    [anon_sym___leave] = ACTIONS(3383),
    [anon_sym_not] = ACTIONS(3383),
    [anon_sym_compl] = ACTIONS(3383),
    [anon_sym_DASH_DASH] = ACTIONS(3385),
    [anon_sym_PLUS_PLUS] = ACTIONS(3385),
    [anon_sym_sizeof] = ACTIONS(3383),
    [anon_sym___alignof__] = ACTIONS(3383),
    [anon_sym___alignof] = ACTIONS(3383),
    [anon_sym__alignof] = ACTIONS(3383),
    [anon_sym_alignof] = ACTIONS(3383),
    [anon_sym__Alignof] = ACTIONS(3383),
    [anon_sym_offsetof] = ACTIONS(3383),
    [anon_sym__Generic] = ACTIONS(3383),
    [anon_sym_asm] = ACTIONS(3383),
    [anon_sym___asm__] = ACTIONS(3383),
    [anon_sym___asm] = ACTIONS(3383),
    [sym_number_literal] = ACTIONS(3385),
    [anon_sym_L_SQUOTE] = ACTIONS(3385),
    [anon_sym_u_SQUOTE] = ACTIONS(3385),
    [anon_sym_U_SQUOTE] = ACTIONS(3385),
    [anon_sym_u8_SQUOTE] = ACTIONS(3385),
    [anon_sym_SQUOTE] = ACTIONS(3385),
    [anon_sym_L_DQUOTE] = ACTIONS(3385),
    [anon_sym_u_DQUOTE] = ACTIONS(3385),
    [anon_sym_U_DQUOTE] = ACTIONS(3385),
    [anon_sym_u8_DQUOTE] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(3385),
    [sym_true] = ACTIONS(3383),
    [sym_false] = ACTIONS(3383),
    [anon_sym_NULL] = ACTIONS(3383),
    [anon_sym_nullptr] = ACTIONS(3383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3383),
    [anon_sym_let] = ACTIONS(3383),
    [anon_sym_This] = ACTIONS(3383),
    [anon_sym_decltype] = ACTIONS(3383),
    [anon_sym_explicit] = ACTIONS(3383),
    [anon_sym_typename] = ACTIONS(3383),
    [anon_sym_template] = ACTIONS(3383),
    [anon_sym_operator] = ACTIONS(3383),
    [anon_sym_try] = ACTIONS(3383),
    [anon_sym_delete] = ACTIONS(3383),
    [anon_sym_throw] = ACTIONS(3383),
    [anon_sym_namespace] = ACTIONS(3383),
    [anon_sym_static_assert] = ACTIONS(3383),
    [anon_sym_concept] = ACTIONS(3383),
    [anon_sym_co_return] = ACTIONS(3383),
    [anon_sym_co_yield] = ACTIONS(3383),
    [anon_sym_R_DQUOTE] = ACTIONS(3385),
    [anon_sym_LR_DQUOTE] = ACTIONS(3385),
    [anon_sym_uR_DQUOTE] = ACTIONS(3385),
    [anon_sym_UR_DQUOTE] = ACTIONS(3385),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3385),
    [anon_sym_co_await] = ACTIONS(3383),
    [anon_sym_new] = ACTIONS(3383),
    [anon_sym_requires] = ACTIONS(3383),
    [sym_this] = ACTIONS(3383),
    [anon_sym_discard] = ACTIONS(3383),
    [anon_sym_precise] = ACTIONS(3383),
    [anon_sym_shared] = ACTIONS(3383),
    [anon_sym_groupshared] = ACTIONS(3383),
    [anon_sym_uniform] = ACTIONS(3383),
    [anon_sym_row_major] = ACTIONS(3383),
    [anon_sym_column_major] = ACTIONS(3383),
    [anon_sym_globallycoherent] = ACTIONS(3383),
    [anon_sym_centroid] = ACTIONS(3383),
    [anon_sym_noperspective] = ACTIONS(3383),
    [anon_sym_nointerpolation] = ACTIONS(3383),
    [anon_sym_sample] = ACTIONS(3383),
    [anon_sym_linear] = ACTIONS(3383),
    [anon_sym_snorm] = ACTIONS(3383),
    [anon_sym_unorm] = ACTIONS(3383),
    [anon_sym_point] = ACTIONS(3383),
    [anon_sym_line] = ACTIONS(3383),
    [anon_sym_triangleadj] = ACTIONS(3383),
    [anon_sym_lineadj] = ACTIONS(3383),
    [anon_sym_triangle] = ACTIONS(3383),
    [anon_sym_cbuffer] = ACTIONS(3383),
    [anon_sym_interface] = ACTIONS(3383),
    [anon_sym_extension] = ACTIONS(3383),
  },
  [736] = {
    [sym_identifier] = ACTIONS(3387),
    [aux_sym_preproc_include_token1] = ACTIONS(3387),
    [aux_sym_preproc_def_token1] = ACTIONS(3387),
    [aux_sym_preproc_if_token1] = ACTIONS(3387),
    [aux_sym_preproc_if_token2] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3387),
    [sym_preproc_directive] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_BANG] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_STAR] = ACTIONS(3389),
    [anon_sym_AMP_AMP] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_SEMI] = ACTIONS(3389),
    [anon_sym___extension__] = ACTIONS(3387),
    [anon_sym_typedef] = ACTIONS(3387),
    [anon_sym_in] = ACTIONS(3387),
    [anon_sym_out] = ACTIONS(3387),
    [anon_sym_inout] = ACTIONS(3387),
    [anon_sym_virtual] = ACTIONS(3387),
    [anon_sym_extern] = ACTIONS(3387),
    [anon_sym___attribute__] = ACTIONS(3387),
    [anon_sym___attribute] = ACTIONS(3387),
    [anon_sym_using] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3389),
    [anon_sym___declspec] = ACTIONS(3387),
    [anon_sym___based] = ACTIONS(3387),
    [anon_sym___cdecl] = ACTIONS(3387),
    [anon_sym___clrcall] = ACTIONS(3387),
    [anon_sym___stdcall] = ACTIONS(3387),
    [anon_sym___fastcall] = ACTIONS(3387),
    [anon_sym___thiscall] = ACTIONS(3387),
    [anon_sym___vectorcall] = ACTIONS(3387),
    [anon_sym_LBRACE] = ACTIONS(3389),
    [anon_sym_signed] = ACTIONS(3387),
    [anon_sym_unsigned] = ACTIONS(3387),
    [anon_sym_long] = ACTIONS(3387),
    [anon_sym_short] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_register] = ACTIONS(3387),
    [anon_sym_inline] = ACTIONS(3387),
    [anon_sym___inline] = ACTIONS(3387),
    [anon_sym___inline__] = ACTIONS(3387),
    [anon_sym___forceinline] = ACTIONS(3387),
    [anon_sym_thread_local] = ACTIONS(3387),
    [anon_sym___thread] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_constexpr] = ACTIONS(3387),
    [anon_sym_volatile] = ACTIONS(3387),
    [anon_sym_restrict] = ACTIONS(3387),
    [anon_sym___restrict__] = ACTIONS(3387),
    [anon_sym__Atomic] = ACTIONS(3387),
    [anon_sym__Noreturn] = ACTIONS(3387),
    [anon_sym_noreturn] = ACTIONS(3387),
    [anon_sym__Nonnull] = ACTIONS(3387),
    [anon_sym_mutable] = ACTIONS(3387),
    [anon_sym_constinit] = ACTIONS(3387),
    [anon_sym_consteval] = ACTIONS(3387),
    [anon_sym_alignas] = ACTIONS(3387),
    [anon_sym__Alignas] = ACTIONS(3387),
    [sym_primitive_type] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [anon_sym_class] = ACTIONS(3387),
    [anon_sym_struct] = ACTIONS(3387),
    [anon_sym_union] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_else] = ACTIONS(3387),
    [anon_sym_switch] = ACTIONS(3387),
    [anon_sym_case] = ACTIONS(3387),
    [anon_sym_default] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_break] = ACTIONS(3387),
    [anon_sym_continue] = ACTIONS(3387),
    [anon_sym_goto] = ACTIONS(3387),
    [anon_sym___try] = ACTIONS(3387),
    [anon_sym___leave] = ACTIONS(3387),
    [anon_sym_not] = ACTIONS(3387),
    [anon_sym_compl] = ACTIONS(3387),
    [anon_sym_DASH_DASH] = ACTIONS(3389),
    [anon_sym_PLUS_PLUS] = ACTIONS(3389),
    [anon_sym_sizeof] = ACTIONS(3387),
    [anon_sym___alignof__] = ACTIONS(3387),
    [anon_sym___alignof] = ACTIONS(3387),
    [anon_sym__alignof] = ACTIONS(3387),
    [anon_sym_alignof] = ACTIONS(3387),
    [anon_sym__Alignof] = ACTIONS(3387),
    [anon_sym_offsetof] = ACTIONS(3387),
    [anon_sym__Generic] = ACTIONS(3387),
    [anon_sym_asm] = ACTIONS(3387),
    [anon_sym___asm__] = ACTIONS(3387),
    [anon_sym___asm] = ACTIONS(3387),
    [sym_number_literal] = ACTIONS(3389),
    [anon_sym_L_SQUOTE] = ACTIONS(3389),
    [anon_sym_u_SQUOTE] = ACTIONS(3389),
    [anon_sym_U_SQUOTE] = ACTIONS(3389),
    [anon_sym_u8_SQUOTE] = ACTIONS(3389),
    [anon_sym_SQUOTE] = ACTIONS(3389),
    [anon_sym_L_DQUOTE] = ACTIONS(3389),
    [anon_sym_u_DQUOTE] = ACTIONS(3389),
    [anon_sym_U_DQUOTE] = ACTIONS(3389),
    [anon_sym_u8_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE] = ACTIONS(3389),
    [sym_true] = ACTIONS(3387),
    [sym_false] = ACTIONS(3387),
    [anon_sym_NULL] = ACTIONS(3387),
    [anon_sym_nullptr] = ACTIONS(3387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_This] = ACTIONS(3387),
    [anon_sym_decltype] = ACTIONS(3387),
    [anon_sym_explicit] = ACTIONS(3387),
    [anon_sym_typename] = ACTIONS(3387),
    [anon_sym_template] = ACTIONS(3387),
    [anon_sym_operator] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_delete] = ACTIONS(3387),
    [anon_sym_throw] = ACTIONS(3387),
    [anon_sym_namespace] = ACTIONS(3387),
    [anon_sym_static_assert] = ACTIONS(3387),
    [anon_sym_concept] = ACTIONS(3387),
    [anon_sym_co_return] = ACTIONS(3387),
    [anon_sym_co_yield] = ACTIONS(3387),
    [anon_sym_R_DQUOTE] = ACTIONS(3389),
    [anon_sym_LR_DQUOTE] = ACTIONS(3389),
    [anon_sym_uR_DQUOTE] = ACTIONS(3389),
    [anon_sym_UR_DQUOTE] = ACTIONS(3389),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3389),
    [anon_sym_co_await] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_requires] = ACTIONS(3387),
    [sym_this] = ACTIONS(3387),
    [anon_sym_discard] = ACTIONS(3387),
    [anon_sym_precise] = ACTIONS(3387),
    [anon_sym_shared] = ACTIONS(3387),
    [anon_sym_groupshared] = ACTIONS(3387),
    [anon_sym_uniform] = ACTIONS(3387),
    [anon_sym_row_major] = ACTIONS(3387),
    [anon_sym_column_major] = ACTIONS(3387),
    [anon_sym_globallycoherent] = ACTIONS(3387),
    [anon_sym_centroid] = ACTIONS(3387),
    [anon_sym_noperspective] = ACTIONS(3387),
    [anon_sym_nointerpolation] = ACTIONS(3387),
    [anon_sym_sample] = ACTIONS(3387),
    [anon_sym_linear] = ACTIONS(3387),
    [anon_sym_snorm] = ACTIONS(3387),
    [anon_sym_unorm] = ACTIONS(3387),
    [anon_sym_point] = ACTIONS(3387),
    [anon_sym_line] = ACTIONS(3387),
    [anon_sym_triangleadj] = ACTIONS(3387),
    [anon_sym_lineadj] = ACTIONS(3387),
    [anon_sym_triangle] = ACTIONS(3387),
    [anon_sym_cbuffer] = ACTIONS(3387),
    [anon_sym_interface] = ACTIONS(3387),
    [anon_sym_extension] = ACTIONS(3387),
  },
  [737] = {
    [sym_expression] = STATE(5382),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(3357),
    [anon_sym_typedef] = ACTIONS(3657),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3370),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3373),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3376),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [738] = {
    [sym_identifier] = ACTIONS(3395),
    [aux_sym_preproc_include_token1] = ACTIONS(3395),
    [aux_sym_preproc_def_token1] = ACTIONS(3395),
    [aux_sym_preproc_if_token1] = ACTIONS(3395),
    [aux_sym_preproc_if_token2] = ACTIONS(3395),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3395),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3395),
    [sym_preproc_directive] = ACTIONS(3395),
    [anon_sym_LPAREN2] = ACTIONS(3397),
    [anon_sym_BANG] = ACTIONS(3397),
    [anon_sym_TILDE] = ACTIONS(3397),
    [anon_sym_DASH] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3395),
    [anon_sym_STAR] = ACTIONS(3397),
    [anon_sym_AMP_AMP] = ACTIONS(3397),
    [anon_sym_AMP] = ACTIONS(3395),
    [anon_sym_SEMI] = ACTIONS(3397),
    [anon_sym___extension__] = ACTIONS(3395),
    [anon_sym_typedef] = ACTIONS(3395),
    [anon_sym_in] = ACTIONS(3395),
    [anon_sym_out] = ACTIONS(3395),
    [anon_sym_inout] = ACTIONS(3395),
    [anon_sym_virtual] = ACTIONS(3395),
    [anon_sym_extern] = ACTIONS(3395),
    [anon_sym___attribute__] = ACTIONS(3395),
    [anon_sym___attribute] = ACTIONS(3395),
    [anon_sym_using] = ACTIONS(3395),
    [anon_sym_COLON_COLON] = ACTIONS(3397),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3397),
    [anon_sym___declspec] = ACTIONS(3395),
    [anon_sym___based] = ACTIONS(3395),
    [anon_sym___cdecl] = ACTIONS(3395),
    [anon_sym___clrcall] = ACTIONS(3395),
    [anon_sym___stdcall] = ACTIONS(3395),
    [anon_sym___fastcall] = ACTIONS(3395),
    [anon_sym___thiscall] = ACTIONS(3395),
    [anon_sym___vectorcall] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3397),
    [anon_sym_signed] = ACTIONS(3395),
    [anon_sym_unsigned] = ACTIONS(3395),
    [anon_sym_long] = ACTIONS(3395),
    [anon_sym_short] = ACTIONS(3395),
    [anon_sym_LBRACK] = ACTIONS(3395),
    [anon_sym_static] = ACTIONS(3395),
    [anon_sym_register] = ACTIONS(3395),
    [anon_sym_inline] = ACTIONS(3395),
    [anon_sym___inline] = ACTIONS(3395),
    [anon_sym___inline__] = ACTIONS(3395),
    [anon_sym___forceinline] = ACTIONS(3395),
    [anon_sym_thread_local] = ACTIONS(3395),
    [anon_sym___thread] = ACTIONS(3395),
    [anon_sym_const] = ACTIONS(3395),
    [anon_sym_constexpr] = ACTIONS(3395),
    [anon_sym_volatile] = ACTIONS(3395),
    [anon_sym_restrict] = ACTIONS(3395),
    [anon_sym___restrict__] = ACTIONS(3395),
    [anon_sym__Atomic] = ACTIONS(3395),
    [anon_sym__Noreturn] = ACTIONS(3395),
    [anon_sym_noreturn] = ACTIONS(3395),
    [anon_sym__Nonnull] = ACTIONS(3395),
    [anon_sym_mutable] = ACTIONS(3395),
    [anon_sym_constinit] = ACTIONS(3395),
    [anon_sym_consteval] = ACTIONS(3395),
    [anon_sym_alignas] = ACTIONS(3395),
    [anon_sym__Alignas] = ACTIONS(3395),
    [sym_primitive_type] = ACTIONS(3395),
    [anon_sym_enum] = ACTIONS(3395),
    [anon_sym_class] = ACTIONS(3395),
    [anon_sym_struct] = ACTIONS(3395),
    [anon_sym_union] = ACTIONS(3395),
    [anon_sym_if] = ACTIONS(3395),
    [anon_sym_else] = ACTIONS(3395),
    [anon_sym_switch] = ACTIONS(3395),
    [anon_sym_case] = ACTIONS(3395),
    [anon_sym_default] = ACTIONS(3395),
    [anon_sym_while] = ACTIONS(3395),
    [anon_sym_do] = ACTIONS(3395),
    [anon_sym_for] = ACTIONS(3395),
    [anon_sym_return] = ACTIONS(3395),
    [anon_sym_break] = ACTIONS(3395),
    [anon_sym_continue] = ACTIONS(3395),
    [anon_sym_goto] = ACTIONS(3395),
    [anon_sym___try] = ACTIONS(3395),
    [anon_sym___leave] = ACTIONS(3395),
    [anon_sym_not] = ACTIONS(3395),
    [anon_sym_compl] = ACTIONS(3395),
    [anon_sym_DASH_DASH] = ACTIONS(3397),
    [anon_sym_PLUS_PLUS] = ACTIONS(3397),
    [anon_sym_sizeof] = ACTIONS(3395),
    [anon_sym___alignof__] = ACTIONS(3395),
    [anon_sym___alignof] = ACTIONS(3395),
    [anon_sym__alignof] = ACTIONS(3395),
    [anon_sym_alignof] = ACTIONS(3395),
    [anon_sym__Alignof] = ACTIONS(3395),
    [anon_sym_offsetof] = ACTIONS(3395),
    [anon_sym__Generic] = ACTIONS(3395),
    [anon_sym_asm] = ACTIONS(3395),
    [anon_sym___asm__] = ACTIONS(3395),
    [anon_sym___asm] = ACTIONS(3395),
    [sym_number_literal] = ACTIONS(3397),
    [anon_sym_L_SQUOTE] = ACTIONS(3397),
    [anon_sym_u_SQUOTE] = ACTIONS(3397),
    [anon_sym_U_SQUOTE] = ACTIONS(3397),
    [anon_sym_u8_SQUOTE] = ACTIONS(3397),
    [anon_sym_SQUOTE] = ACTIONS(3397),
    [anon_sym_L_DQUOTE] = ACTIONS(3397),
    [anon_sym_u_DQUOTE] = ACTIONS(3397),
    [anon_sym_U_DQUOTE] = ACTIONS(3397),
    [anon_sym_u8_DQUOTE] = ACTIONS(3397),
    [anon_sym_DQUOTE] = ACTIONS(3397),
    [sym_true] = ACTIONS(3395),
    [sym_false] = ACTIONS(3395),
    [anon_sym_NULL] = ACTIONS(3395),
    [anon_sym_nullptr] = ACTIONS(3395),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3395),
    [anon_sym_let] = ACTIONS(3395),
    [anon_sym_This] = ACTIONS(3395),
    [anon_sym_decltype] = ACTIONS(3395),
    [anon_sym_explicit] = ACTIONS(3395),
    [anon_sym_typename] = ACTIONS(3395),
    [anon_sym_template] = ACTIONS(3395),
    [anon_sym_operator] = ACTIONS(3395),
    [anon_sym_try] = ACTIONS(3395),
    [anon_sym_delete] = ACTIONS(3395),
    [anon_sym_throw] = ACTIONS(3395),
    [anon_sym_namespace] = ACTIONS(3395),
    [anon_sym_static_assert] = ACTIONS(3395),
    [anon_sym_concept] = ACTIONS(3395),
    [anon_sym_co_return] = ACTIONS(3395),
    [anon_sym_co_yield] = ACTIONS(3395),
    [anon_sym_R_DQUOTE] = ACTIONS(3397),
    [anon_sym_LR_DQUOTE] = ACTIONS(3397),
    [anon_sym_uR_DQUOTE] = ACTIONS(3397),
    [anon_sym_UR_DQUOTE] = ACTIONS(3397),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3397),
    [anon_sym_co_await] = ACTIONS(3395),
    [anon_sym_new] = ACTIONS(3395),
    [anon_sym_requires] = ACTIONS(3395),
    [sym_this] = ACTIONS(3395),
    [anon_sym_discard] = ACTIONS(3395),
    [anon_sym_precise] = ACTIONS(3395),
    [anon_sym_shared] = ACTIONS(3395),
    [anon_sym_groupshared] = ACTIONS(3395),
    [anon_sym_uniform] = ACTIONS(3395),
    [anon_sym_row_major] = ACTIONS(3395),
    [anon_sym_column_major] = ACTIONS(3395),
    [anon_sym_globallycoherent] = ACTIONS(3395),
    [anon_sym_centroid] = ACTIONS(3395),
    [anon_sym_noperspective] = ACTIONS(3395),
    [anon_sym_nointerpolation] = ACTIONS(3395),
    [anon_sym_sample] = ACTIONS(3395),
    [anon_sym_linear] = ACTIONS(3395),
    [anon_sym_snorm] = ACTIONS(3395),
    [anon_sym_unorm] = ACTIONS(3395),
    [anon_sym_point] = ACTIONS(3395),
    [anon_sym_line] = ACTIONS(3395),
    [anon_sym_triangleadj] = ACTIONS(3395),
    [anon_sym_lineadj] = ACTIONS(3395),
    [anon_sym_triangle] = ACTIONS(3395),
    [anon_sym_cbuffer] = ACTIONS(3395),
    [anon_sym_interface] = ACTIONS(3395),
    [anon_sym_extension] = ACTIONS(3395),
  },
  [739] = {
    [sym_identifier] = ACTIONS(3452),
    [aux_sym_preproc_include_token1] = ACTIONS(3452),
    [aux_sym_preproc_def_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3452),
    [sym_preproc_directive] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(3450),
    [anon_sym_BANG] = ACTIONS(3450),
    [anon_sym_TILDE] = ACTIONS(3450),
    [anon_sym_DASH] = ACTIONS(3452),
    [anon_sym_PLUS] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_AMP_AMP] = ACTIONS(3450),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym___extension__] = ACTIONS(3452),
    [anon_sym_typedef] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_out] = ACTIONS(3452),
    [anon_sym_inout] = ACTIONS(3452),
    [anon_sym_virtual] = ACTIONS(3452),
    [anon_sym_extern] = ACTIONS(3452),
    [anon_sym___attribute__] = ACTIONS(3452),
    [anon_sym___attribute] = ACTIONS(3452),
    [anon_sym_using] = ACTIONS(3452),
    [anon_sym_COLON_COLON] = ACTIONS(3450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3450),
    [anon_sym___declspec] = ACTIONS(3452),
    [anon_sym___based] = ACTIONS(3452),
    [anon_sym___cdecl] = ACTIONS(3452),
    [anon_sym___clrcall] = ACTIONS(3452),
    [anon_sym___stdcall] = ACTIONS(3452),
    [anon_sym___fastcall] = ACTIONS(3452),
    [anon_sym___thiscall] = ACTIONS(3452),
    [anon_sym___vectorcall] = ACTIONS(3452),
    [anon_sym_LBRACE] = ACTIONS(3450),
    [anon_sym_RBRACE] = ACTIONS(3450),
    [anon_sym_signed] = ACTIONS(3452),
    [anon_sym_unsigned] = ACTIONS(3452),
    [anon_sym_long] = ACTIONS(3452),
    [anon_sym_short] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3452),
    [anon_sym_static] = ACTIONS(3452),
    [anon_sym_register] = ACTIONS(3452),
    [anon_sym_inline] = ACTIONS(3452),
    [anon_sym___inline] = ACTIONS(3452),
    [anon_sym___inline__] = ACTIONS(3452),
    [anon_sym___forceinline] = ACTIONS(3452),
    [anon_sym_thread_local] = ACTIONS(3452),
    [anon_sym___thread] = ACTIONS(3452),
    [anon_sym_const] = ACTIONS(3452),
    [anon_sym_constexpr] = ACTIONS(3452),
    [anon_sym_volatile] = ACTIONS(3452),
    [anon_sym_restrict] = ACTIONS(3452),
    [anon_sym___restrict__] = ACTIONS(3452),
    [anon_sym__Atomic] = ACTIONS(3452),
    [anon_sym__Noreturn] = ACTIONS(3452),
    [anon_sym_noreturn] = ACTIONS(3452),
    [anon_sym__Nonnull] = ACTIONS(3452),
    [anon_sym_mutable] = ACTIONS(3452),
    [anon_sym_constinit] = ACTIONS(3452),
    [anon_sym_consteval] = ACTIONS(3452),
    [anon_sym_alignas] = ACTIONS(3452),
    [anon_sym__Alignas] = ACTIONS(3452),
    [sym_primitive_type] = ACTIONS(3452),
    [anon_sym_enum] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(3452),
    [anon_sym_union] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_else] = ACTIONS(3452),
    [anon_sym_switch] = ACTIONS(3452),
    [anon_sym_case] = ACTIONS(3452),
    [anon_sym_default] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_do] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3452),
    [anon_sym_return] = ACTIONS(3452),
    [anon_sym_break] = ACTIONS(3452),
    [anon_sym_continue] = ACTIONS(3452),
    [anon_sym_goto] = ACTIONS(3452),
    [anon_sym___try] = ACTIONS(3452),
    [anon_sym___leave] = ACTIONS(3452),
    [anon_sym_not] = ACTIONS(3452),
    [anon_sym_compl] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3450),
    [anon_sym_PLUS_PLUS] = ACTIONS(3450),
    [anon_sym_sizeof] = ACTIONS(3452),
    [anon_sym___alignof__] = ACTIONS(3452),
    [anon_sym___alignof] = ACTIONS(3452),
    [anon_sym__alignof] = ACTIONS(3452),
    [anon_sym_alignof] = ACTIONS(3452),
    [anon_sym__Alignof] = ACTIONS(3452),
    [anon_sym_offsetof] = ACTIONS(3452),
    [anon_sym__Generic] = ACTIONS(3452),
    [anon_sym_asm] = ACTIONS(3452),
    [anon_sym___asm__] = ACTIONS(3452),
    [anon_sym___asm] = ACTIONS(3452),
    [sym_number_literal] = ACTIONS(3450),
    [anon_sym_L_SQUOTE] = ACTIONS(3450),
    [anon_sym_u_SQUOTE] = ACTIONS(3450),
    [anon_sym_U_SQUOTE] = ACTIONS(3450),
    [anon_sym_u8_SQUOTE] = ACTIONS(3450),
    [anon_sym_SQUOTE] = ACTIONS(3450),
    [anon_sym_L_DQUOTE] = ACTIONS(3450),
    [anon_sym_u_DQUOTE] = ACTIONS(3450),
    [anon_sym_U_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8_DQUOTE] = ACTIONS(3450),
    [anon_sym_DQUOTE] = ACTIONS(3450),
    [sym_true] = ACTIONS(3452),
    [sym_false] = ACTIONS(3452),
    [anon_sym_NULL] = ACTIONS(3452),
    [anon_sym_nullptr] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3452),
    [anon_sym_let] = ACTIONS(3452),
    [anon_sym_This] = ACTIONS(3452),
    [anon_sym_decltype] = ACTIONS(3452),
    [anon_sym_explicit] = ACTIONS(3452),
    [anon_sym_typename] = ACTIONS(3452),
    [anon_sym_template] = ACTIONS(3452),
    [anon_sym_operator] = ACTIONS(3452),
    [anon_sym_try] = ACTIONS(3452),
    [anon_sym_delete] = ACTIONS(3452),
    [anon_sym_throw] = ACTIONS(3452),
    [anon_sym_namespace] = ACTIONS(3452),
    [anon_sym_static_assert] = ACTIONS(3452),
    [anon_sym_concept] = ACTIONS(3452),
    [anon_sym_co_return] = ACTIONS(3452),
    [anon_sym_co_yield] = ACTIONS(3452),
    [anon_sym_R_DQUOTE] = ACTIONS(3450),
    [anon_sym_LR_DQUOTE] = ACTIONS(3450),
    [anon_sym_uR_DQUOTE] = ACTIONS(3450),
    [anon_sym_UR_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3450),
    [anon_sym_co_await] = ACTIONS(3452),
    [anon_sym_new] = ACTIONS(3452),
    [anon_sym_requires] = ACTIONS(3452),
    [sym_this] = ACTIONS(3452),
    [anon_sym_discard] = ACTIONS(3452),
    [anon_sym_precise] = ACTIONS(3452),
    [anon_sym_shared] = ACTIONS(3452),
    [anon_sym_groupshared] = ACTIONS(3452),
    [anon_sym_uniform] = ACTIONS(3452),
    [anon_sym_row_major] = ACTIONS(3452),
    [anon_sym_column_major] = ACTIONS(3452),
    [anon_sym_globallycoherent] = ACTIONS(3452),
    [anon_sym_centroid] = ACTIONS(3452),
    [anon_sym_noperspective] = ACTIONS(3452),
    [anon_sym_nointerpolation] = ACTIONS(3452),
    [anon_sym_sample] = ACTIONS(3452),
    [anon_sym_linear] = ACTIONS(3452),
    [anon_sym_snorm] = ACTIONS(3452),
    [anon_sym_unorm] = ACTIONS(3452),
    [anon_sym_point] = ACTIONS(3452),
    [anon_sym_line] = ACTIONS(3452),
    [anon_sym_triangleadj] = ACTIONS(3452),
    [anon_sym_lineadj] = ACTIONS(3452),
    [anon_sym_triangle] = ACTIONS(3452),
    [anon_sym_cbuffer] = ACTIONS(3452),
    [anon_sym_interface] = ACTIONS(3452),
    [anon_sym_extension] = ACTIONS(3452),
  },
  [740] = {
    [sym_identifier] = ACTIONS(3403),
    [aux_sym_preproc_include_token1] = ACTIONS(3403),
    [aux_sym_preproc_def_token1] = ACTIONS(3403),
    [aux_sym_preproc_if_token1] = ACTIONS(3403),
    [aux_sym_preproc_if_token2] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3403),
    [sym_preproc_directive] = ACTIONS(3403),
    [anon_sym_LPAREN2] = ACTIONS(3405),
    [anon_sym_BANG] = ACTIONS(3405),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_DASH] = ACTIONS(3403),
    [anon_sym_PLUS] = ACTIONS(3403),
    [anon_sym_STAR] = ACTIONS(3405),
    [anon_sym_AMP_AMP] = ACTIONS(3405),
    [anon_sym_AMP] = ACTIONS(3403),
    [anon_sym_SEMI] = ACTIONS(3405),
    [anon_sym___extension__] = ACTIONS(3403),
    [anon_sym_typedef] = ACTIONS(3403),
    [anon_sym_in] = ACTIONS(3403),
    [anon_sym_out] = ACTIONS(3403),
    [anon_sym_inout] = ACTIONS(3403),
    [anon_sym_virtual] = ACTIONS(3403),
    [anon_sym_extern] = ACTIONS(3403),
    [anon_sym___attribute__] = ACTIONS(3403),
    [anon_sym___attribute] = ACTIONS(3403),
    [anon_sym_using] = ACTIONS(3403),
    [anon_sym_COLON_COLON] = ACTIONS(3405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3405),
    [anon_sym___declspec] = ACTIONS(3403),
    [anon_sym___based] = ACTIONS(3403),
    [anon_sym___cdecl] = ACTIONS(3403),
    [anon_sym___clrcall] = ACTIONS(3403),
    [anon_sym___stdcall] = ACTIONS(3403),
    [anon_sym___fastcall] = ACTIONS(3403),
    [anon_sym___thiscall] = ACTIONS(3403),
    [anon_sym___vectorcall] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3405),
    [anon_sym_signed] = ACTIONS(3403),
    [anon_sym_unsigned] = ACTIONS(3403),
    [anon_sym_long] = ACTIONS(3403),
    [anon_sym_short] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3403),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_register] = ACTIONS(3403),
    [anon_sym_inline] = ACTIONS(3403),
    [anon_sym___inline] = ACTIONS(3403),
    [anon_sym___inline__] = ACTIONS(3403),
    [anon_sym___forceinline] = ACTIONS(3403),
    [anon_sym_thread_local] = ACTIONS(3403),
    [anon_sym___thread] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_constexpr] = ACTIONS(3403),
    [anon_sym_volatile] = ACTIONS(3403),
    [anon_sym_restrict] = ACTIONS(3403),
    [anon_sym___restrict__] = ACTIONS(3403),
    [anon_sym__Atomic] = ACTIONS(3403),
    [anon_sym__Noreturn] = ACTIONS(3403),
    [anon_sym_noreturn] = ACTIONS(3403),
    [anon_sym__Nonnull] = ACTIONS(3403),
    [anon_sym_mutable] = ACTIONS(3403),
    [anon_sym_constinit] = ACTIONS(3403),
    [anon_sym_consteval] = ACTIONS(3403),
    [anon_sym_alignas] = ACTIONS(3403),
    [anon_sym__Alignas] = ACTIONS(3403),
    [sym_primitive_type] = ACTIONS(3403),
    [anon_sym_enum] = ACTIONS(3403),
    [anon_sym_class] = ACTIONS(3403),
    [anon_sym_struct] = ACTIONS(3403),
    [anon_sym_union] = ACTIONS(3403),
    [anon_sym_if] = ACTIONS(3403),
    [anon_sym_else] = ACTIONS(3403),
    [anon_sym_switch] = ACTIONS(3403),
    [anon_sym_case] = ACTIONS(3403),
    [anon_sym_default] = ACTIONS(3403),
    [anon_sym_while] = ACTIONS(3403),
    [anon_sym_do] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3403),
    [anon_sym_return] = ACTIONS(3403),
    [anon_sym_break] = ACTIONS(3403),
    [anon_sym_continue] = ACTIONS(3403),
    [anon_sym_goto] = ACTIONS(3403),
    [anon_sym___try] = ACTIONS(3403),
    [anon_sym___leave] = ACTIONS(3403),
    [anon_sym_not] = ACTIONS(3403),
    [anon_sym_compl] = ACTIONS(3403),
    [anon_sym_DASH_DASH] = ACTIONS(3405),
    [anon_sym_PLUS_PLUS] = ACTIONS(3405),
    [anon_sym_sizeof] = ACTIONS(3403),
    [anon_sym___alignof__] = ACTIONS(3403),
    [anon_sym___alignof] = ACTIONS(3403),
    [anon_sym__alignof] = ACTIONS(3403),
    [anon_sym_alignof] = ACTIONS(3403),
    [anon_sym__Alignof] = ACTIONS(3403),
    [anon_sym_offsetof] = ACTIONS(3403),
    [anon_sym__Generic] = ACTIONS(3403),
    [anon_sym_asm] = ACTIONS(3403),
    [anon_sym___asm__] = ACTIONS(3403),
    [anon_sym___asm] = ACTIONS(3403),
    [sym_number_literal] = ACTIONS(3405),
    [anon_sym_L_SQUOTE] = ACTIONS(3405),
    [anon_sym_u_SQUOTE] = ACTIONS(3405),
    [anon_sym_U_SQUOTE] = ACTIONS(3405),
    [anon_sym_u8_SQUOTE] = ACTIONS(3405),
    [anon_sym_SQUOTE] = ACTIONS(3405),
    [anon_sym_L_DQUOTE] = ACTIONS(3405),
    [anon_sym_u_DQUOTE] = ACTIONS(3405),
    [anon_sym_U_DQUOTE] = ACTIONS(3405),
    [anon_sym_u8_DQUOTE] = ACTIONS(3405),
    [anon_sym_DQUOTE] = ACTIONS(3405),
    [sym_true] = ACTIONS(3403),
    [sym_false] = ACTIONS(3403),
    [anon_sym_NULL] = ACTIONS(3403),
    [anon_sym_nullptr] = ACTIONS(3403),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3403),
    [anon_sym_let] = ACTIONS(3403),
    [anon_sym_This] = ACTIONS(3403),
    [anon_sym_decltype] = ACTIONS(3403),
    [anon_sym_explicit] = ACTIONS(3403),
    [anon_sym_typename] = ACTIONS(3403),
    [anon_sym_template] = ACTIONS(3403),
    [anon_sym_operator] = ACTIONS(3403),
    [anon_sym_try] = ACTIONS(3403),
    [anon_sym_delete] = ACTIONS(3403),
    [anon_sym_throw] = ACTIONS(3403),
    [anon_sym_namespace] = ACTIONS(3403),
    [anon_sym_static_assert] = ACTIONS(3403),
    [anon_sym_concept] = ACTIONS(3403),
    [anon_sym_co_return] = ACTIONS(3403),
    [anon_sym_co_yield] = ACTIONS(3403),
    [anon_sym_R_DQUOTE] = ACTIONS(3405),
    [anon_sym_LR_DQUOTE] = ACTIONS(3405),
    [anon_sym_uR_DQUOTE] = ACTIONS(3405),
    [anon_sym_UR_DQUOTE] = ACTIONS(3405),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3405),
    [anon_sym_co_await] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3403),
    [anon_sym_requires] = ACTIONS(3403),
    [sym_this] = ACTIONS(3403),
    [anon_sym_discard] = ACTIONS(3403),
    [anon_sym_precise] = ACTIONS(3403),
    [anon_sym_shared] = ACTIONS(3403),
    [anon_sym_groupshared] = ACTIONS(3403),
    [anon_sym_uniform] = ACTIONS(3403),
    [anon_sym_row_major] = ACTIONS(3403),
    [anon_sym_column_major] = ACTIONS(3403),
    [anon_sym_globallycoherent] = ACTIONS(3403),
    [anon_sym_centroid] = ACTIONS(3403),
    [anon_sym_noperspective] = ACTIONS(3403),
    [anon_sym_nointerpolation] = ACTIONS(3403),
    [anon_sym_sample] = ACTIONS(3403),
    [anon_sym_linear] = ACTIONS(3403),
    [anon_sym_snorm] = ACTIONS(3403),
    [anon_sym_unorm] = ACTIONS(3403),
    [anon_sym_point] = ACTIONS(3403),
    [anon_sym_line] = ACTIONS(3403),
    [anon_sym_triangleadj] = ACTIONS(3403),
    [anon_sym_lineadj] = ACTIONS(3403),
    [anon_sym_triangle] = ACTIONS(3403),
    [anon_sym_cbuffer] = ACTIONS(3403),
    [anon_sym_interface] = ACTIONS(3403),
    [anon_sym_extension] = ACTIONS(3403),
  },
  [741] = {
    [sym_identifier] = ACTIONS(3407),
    [aux_sym_preproc_include_token1] = ACTIONS(3407),
    [aux_sym_preproc_def_token1] = ACTIONS(3407),
    [aux_sym_preproc_if_token1] = ACTIONS(3407),
    [aux_sym_preproc_if_token2] = ACTIONS(3407),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3407),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3407),
    [sym_preproc_directive] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3409),
    [anon_sym_TILDE] = ACTIONS(3409),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_AMP_AMP] = ACTIONS(3409),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_SEMI] = ACTIONS(3409),
    [anon_sym___extension__] = ACTIONS(3407),
    [anon_sym_typedef] = ACTIONS(3407),
    [anon_sym_in] = ACTIONS(3407),
    [anon_sym_out] = ACTIONS(3407),
    [anon_sym_inout] = ACTIONS(3407),
    [anon_sym_virtual] = ACTIONS(3407),
    [anon_sym_extern] = ACTIONS(3407),
    [anon_sym___attribute__] = ACTIONS(3407),
    [anon_sym___attribute] = ACTIONS(3407),
    [anon_sym_using] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3409),
    [anon_sym___declspec] = ACTIONS(3407),
    [anon_sym___based] = ACTIONS(3407),
    [anon_sym___cdecl] = ACTIONS(3407),
    [anon_sym___clrcall] = ACTIONS(3407),
    [anon_sym___stdcall] = ACTIONS(3407),
    [anon_sym___fastcall] = ACTIONS(3407),
    [anon_sym___thiscall] = ACTIONS(3407),
    [anon_sym___vectorcall] = ACTIONS(3407),
    [anon_sym_LBRACE] = ACTIONS(3409),
    [anon_sym_signed] = ACTIONS(3407),
    [anon_sym_unsigned] = ACTIONS(3407),
    [anon_sym_long] = ACTIONS(3407),
    [anon_sym_short] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_register] = ACTIONS(3407),
    [anon_sym_inline] = ACTIONS(3407),
    [anon_sym___inline] = ACTIONS(3407),
    [anon_sym___inline__] = ACTIONS(3407),
    [anon_sym___forceinline] = ACTIONS(3407),
    [anon_sym_thread_local] = ACTIONS(3407),
    [anon_sym___thread] = ACTIONS(3407),
    [anon_sym_const] = ACTIONS(3407),
    [anon_sym_constexpr] = ACTIONS(3407),
    [anon_sym_volatile] = ACTIONS(3407),
    [anon_sym_restrict] = ACTIONS(3407),
    [anon_sym___restrict__] = ACTIONS(3407),
    [anon_sym__Atomic] = ACTIONS(3407),
    [anon_sym__Noreturn] = ACTIONS(3407),
    [anon_sym_noreturn] = ACTIONS(3407),
    [anon_sym__Nonnull] = ACTIONS(3407),
    [anon_sym_mutable] = ACTIONS(3407),
    [anon_sym_constinit] = ACTIONS(3407),
    [anon_sym_consteval] = ACTIONS(3407),
    [anon_sym_alignas] = ACTIONS(3407),
    [anon_sym__Alignas] = ACTIONS(3407),
    [sym_primitive_type] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3407),
    [anon_sym_class] = ACTIONS(3407),
    [anon_sym_struct] = ACTIONS(3407),
    [anon_sym_union] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_else] = ACTIONS(3407),
    [anon_sym_switch] = ACTIONS(3407),
    [anon_sym_case] = ACTIONS(3407),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_break] = ACTIONS(3407),
    [anon_sym_continue] = ACTIONS(3407),
    [anon_sym_goto] = ACTIONS(3407),
    [anon_sym___try] = ACTIONS(3407),
    [anon_sym___leave] = ACTIONS(3407),
    [anon_sym_not] = ACTIONS(3407),
    [anon_sym_compl] = ACTIONS(3407),
    [anon_sym_DASH_DASH] = ACTIONS(3409),
    [anon_sym_PLUS_PLUS] = ACTIONS(3409),
    [anon_sym_sizeof] = ACTIONS(3407),
    [anon_sym___alignof__] = ACTIONS(3407),
    [anon_sym___alignof] = ACTIONS(3407),
    [anon_sym__alignof] = ACTIONS(3407),
    [anon_sym_alignof] = ACTIONS(3407),
    [anon_sym__Alignof] = ACTIONS(3407),
    [anon_sym_offsetof] = ACTIONS(3407),
    [anon_sym__Generic] = ACTIONS(3407),
    [anon_sym_asm] = ACTIONS(3407),
    [anon_sym___asm__] = ACTIONS(3407),
    [anon_sym___asm] = ACTIONS(3407),
    [sym_number_literal] = ACTIONS(3409),
    [anon_sym_L_SQUOTE] = ACTIONS(3409),
    [anon_sym_u_SQUOTE] = ACTIONS(3409),
    [anon_sym_U_SQUOTE] = ACTIONS(3409),
    [anon_sym_u8_SQUOTE] = ACTIONS(3409),
    [anon_sym_SQUOTE] = ACTIONS(3409),
    [anon_sym_L_DQUOTE] = ACTIONS(3409),
    [anon_sym_u_DQUOTE] = ACTIONS(3409),
    [anon_sym_U_DQUOTE] = ACTIONS(3409),
    [anon_sym_u8_DQUOTE] = ACTIONS(3409),
    [anon_sym_DQUOTE] = ACTIONS(3409),
    [sym_true] = ACTIONS(3407),
    [sym_false] = ACTIONS(3407),
    [anon_sym_NULL] = ACTIONS(3407),
    [anon_sym_nullptr] = ACTIONS(3407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_This] = ACTIONS(3407),
    [anon_sym_decltype] = ACTIONS(3407),
    [anon_sym_explicit] = ACTIONS(3407),
    [anon_sym_typename] = ACTIONS(3407),
    [anon_sym_template] = ACTIONS(3407),
    [anon_sym_operator] = ACTIONS(3407),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_delete] = ACTIONS(3407),
    [anon_sym_throw] = ACTIONS(3407),
    [anon_sym_namespace] = ACTIONS(3407),
    [anon_sym_static_assert] = ACTIONS(3407),
    [anon_sym_concept] = ACTIONS(3407),
    [anon_sym_co_return] = ACTIONS(3407),
    [anon_sym_co_yield] = ACTIONS(3407),
    [anon_sym_R_DQUOTE] = ACTIONS(3409),
    [anon_sym_LR_DQUOTE] = ACTIONS(3409),
    [anon_sym_uR_DQUOTE] = ACTIONS(3409),
    [anon_sym_UR_DQUOTE] = ACTIONS(3409),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3409),
    [anon_sym_co_await] = ACTIONS(3407),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_requires] = ACTIONS(3407),
    [sym_this] = ACTIONS(3407),
    [anon_sym_discard] = ACTIONS(3407),
    [anon_sym_precise] = ACTIONS(3407),
    [anon_sym_shared] = ACTIONS(3407),
    [anon_sym_groupshared] = ACTIONS(3407),
    [anon_sym_uniform] = ACTIONS(3407),
    [anon_sym_row_major] = ACTIONS(3407),
    [anon_sym_column_major] = ACTIONS(3407),
    [anon_sym_globallycoherent] = ACTIONS(3407),
    [anon_sym_centroid] = ACTIONS(3407),
    [anon_sym_noperspective] = ACTIONS(3407),
    [anon_sym_nointerpolation] = ACTIONS(3407),
    [anon_sym_sample] = ACTIONS(3407),
    [anon_sym_linear] = ACTIONS(3407),
    [anon_sym_snorm] = ACTIONS(3407),
    [anon_sym_unorm] = ACTIONS(3407),
    [anon_sym_point] = ACTIONS(3407),
    [anon_sym_line] = ACTIONS(3407),
    [anon_sym_triangleadj] = ACTIONS(3407),
    [anon_sym_lineadj] = ACTIONS(3407),
    [anon_sym_triangle] = ACTIONS(3407),
    [anon_sym_cbuffer] = ACTIONS(3407),
    [anon_sym_interface] = ACTIONS(3407),
    [anon_sym_extension] = ACTIONS(3407),
  },
  [742] = {
    [sym_identifier] = ACTIONS(3411),
    [aux_sym_preproc_include_token1] = ACTIONS(3411),
    [aux_sym_preproc_def_token1] = ACTIONS(3411),
    [aux_sym_preproc_if_token1] = ACTIONS(3411),
    [aux_sym_preproc_if_token2] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3411),
    [sym_preproc_directive] = ACTIONS(3411),
    [anon_sym_LPAREN2] = ACTIONS(3413),
    [anon_sym_BANG] = ACTIONS(3413),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_DASH] = ACTIONS(3411),
    [anon_sym_PLUS] = ACTIONS(3411),
    [anon_sym_STAR] = ACTIONS(3413),
    [anon_sym_AMP_AMP] = ACTIONS(3413),
    [anon_sym_AMP] = ACTIONS(3411),
    [anon_sym_SEMI] = ACTIONS(3413),
    [anon_sym___extension__] = ACTIONS(3411),
    [anon_sym_typedef] = ACTIONS(3411),
    [anon_sym_in] = ACTIONS(3411),
    [anon_sym_out] = ACTIONS(3411),
    [anon_sym_inout] = ACTIONS(3411),
    [anon_sym_virtual] = ACTIONS(3411),
    [anon_sym_extern] = ACTIONS(3411),
    [anon_sym___attribute__] = ACTIONS(3411),
    [anon_sym___attribute] = ACTIONS(3411),
    [anon_sym_using] = ACTIONS(3411),
    [anon_sym_COLON_COLON] = ACTIONS(3413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3413),
    [anon_sym___declspec] = ACTIONS(3411),
    [anon_sym___based] = ACTIONS(3411),
    [anon_sym___cdecl] = ACTIONS(3411),
    [anon_sym___clrcall] = ACTIONS(3411),
    [anon_sym___stdcall] = ACTIONS(3411),
    [anon_sym___fastcall] = ACTIONS(3411),
    [anon_sym___thiscall] = ACTIONS(3411),
    [anon_sym___vectorcall] = ACTIONS(3411),
    [anon_sym_LBRACE] = ACTIONS(3413),
    [anon_sym_signed] = ACTIONS(3411),
    [anon_sym_unsigned] = ACTIONS(3411),
    [anon_sym_long] = ACTIONS(3411),
    [anon_sym_short] = ACTIONS(3411),
    [anon_sym_LBRACK] = ACTIONS(3411),
    [anon_sym_static] = ACTIONS(3411),
    [anon_sym_register] = ACTIONS(3411),
    [anon_sym_inline] = ACTIONS(3411),
    [anon_sym___inline] = ACTIONS(3411),
    [anon_sym___inline__] = ACTIONS(3411),
    [anon_sym___forceinline] = ACTIONS(3411),
    [anon_sym_thread_local] = ACTIONS(3411),
    [anon_sym___thread] = ACTIONS(3411),
    [anon_sym_const] = ACTIONS(3411),
    [anon_sym_constexpr] = ACTIONS(3411),
    [anon_sym_volatile] = ACTIONS(3411),
    [anon_sym_restrict] = ACTIONS(3411),
    [anon_sym___restrict__] = ACTIONS(3411),
    [anon_sym__Atomic] = ACTIONS(3411),
    [anon_sym__Noreturn] = ACTIONS(3411),
    [anon_sym_noreturn] = ACTIONS(3411),
    [anon_sym__Nonnull] = ACTIONS(3411),
    [anon_sym_mutable] = ACTIONS(3411),
    [anon_sym_constinit] = ACTIONS(3411),
    [anon_sym_consteval] = ACTIONS(3411),
    [anon_sym_alignas] = ACTIONS(3411),
    [anon_sym__Alignas] = ACTIONS(3411),
    [sym_primitive_type] = ACTIONS(3411),
    [anon_sym_enum] = ACTIONS(3411),
    [anon_sym_class] = ACTIONS(3411),
    [anon_sym_struct] = ACTIONS(3411),
    [anon_sym_union] = ACTIONS(3411),
    [anon_sym_if] = ACTIONS(3411),
    [anon_sym_else] = ACTIONS(3411),
    [anon_sym_switch] = ACTIONS(3411),
    [anon_sym_case] = ACTIONS(3411),
    [anon_sym_default] = ACTIONS(3411),
    [anon_sym_while] = ACTIONS(3411),
    [anon_sym_do] = ACTIONS(3411),
    [anon_sym_for] = ACTIONS(3411),
    [anon_sym_return] = ACTIONS(3411),
    [anon_sym_break] = ACTIONS(3411),
    [anon_sym_continue] = ACTIONS(3411),
    [anon_sym_goto] = ACTIONS(3411),
    [anon_sym___try] = ACTIONS(3411),
    [anon_sym___leave] = ACTIONS(3411),
    [anon_sym_not] = ACTIONS(3411),
    [anon_sym_compl] = ACTIONS(3411),
    [anon_sym_DASH_DASH] = ACTIONS(3413),
    [anon_sym_PLUS_PLUS] = ACTIONS(3413),
    [anon_sym_sizeof] = ACTIONS(3411),
    [anon_sym___alignof__] = ACTIONS(3411),
    [anon_sym___alignof] = ACTIONS(3411),
    [anon_sym__alignof] = ACTIONS(3411),
    [anon_sym_alignof] = ACTIONS(3411),
    [anon_sym__Alignof] = ACTIONS(3411),
    [anon_sym_offsetof] = ACTIONS(3411),
    [anon_sym__Generic] = ACTIONS(3411),
    [anon_sym_asm] = ACTIONS(3411),
    [anon_sym___asm__] = ACTIONS(3411),
    [anon_sym___asm] = ACTIONS(3411),
    [sym_number_literal] = ACTIONS(3413),
    [anon_sym_L_SQUOTE] = ACTIONS(3413),
    [anon_sym_u_SQUOTE] = ACTIONS(3413),
    [anon_sym_U_SQUOTE] = ACTIONS(3413),
    [anon_sym_u8_SQUOTE] = ACTIONS(3413),
    [anon_sym_SQUOTE] = ACTIONS(3413),
    [anon_sym_L_DQUOTE] = ACTIONS(3413),
    [anon_sym_u_DQUOTE] = ACTIONS(3413),
    [anon_sym_U_DQUOTE] = ACTIONS(3413),
    [anon_sym_u8_DQUOTE] = ACTIONS(3413),
    [anon_sym_DQUOTE] = ACTIONS(3413),
    [sym_true] = ACTIONS(3411),
    [sym_false] = ACTIONS(3411),
    [anon_sym_NULL] = ACTIONS(3411),
    [anon_sym_nullptr] = ACTIONS(3411),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3411),
    [anon_sym_let] = ACTIONS(3411),
    [anon_sym_This] = ACTIONS(3411),
    [anon_sym_decltype] = ACTIONS(3411),
    [anon_sym_explicit] = ACTIONS(3411),
    [anon_sym_typename] = ACTIONS(3411),
    [anon_sym_template] = ACTIONS(3411),
    [anon_sym_operator] = ACTIONS(3411),
    [anon_sym_try] = ACTIONS(3411),
    [anon_sym_delete] = ACTIONS(3411),
    [anon_sym_throw] = ACTIONS(3411),
    [anon_sym_namespace] = ACTIONS(3411),
    [anon_sym_static_assert] = ACTIONS(3411),
    [anon_sym_concept] = ACTIONS(3411),
    [anon_sym_co_return] = ACTIONS(3411),
    [anon_sym_co_yield] = ACTIONS(3411),
    [anon_sym_R_DQUOTE] = ACTIONS(3413),
    [anon_sym_LR_DQUOTE] = ACTIONS(3413),
    [anon_sym_uR_DQUOTE] = ACTIONS(3413),
    [anon_sym_UR_DQUOTE] = ACTIONS(3413),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3413),
    [anon_sym_co_await] = ACTIONS(3411),
    [anon_sym_new] = ACTIONS(3411),
    [anon_sym_requires] = ACTIONS(3411),
    [sym_this] = ACTIONS(3411),
    [anon_sym_discard] = ACTIONS(3411),
    [anon_sym_precise] = ACTIONS(3411),
    [anon_sym_shared] = ACTIONS(3411),
    [anon_sym_groupshared] = ACTIONS(3411),
    [anon_sym_uniform] = ACTIONS(3411),
    [anon_sym_row_major] = ACTIONS(3411),
    [anon_sym_column_major] = ACTIONS(3411),
    [anon_sym_globallycoherent] = ACTIONS(3411),
    [anon_sym_centroid] = ACTIONS(3411),
    [anon_sym_noperspective] = ACTIONS(3411),
    [anon_sym_nointerpolation] = ACTIONS(3411),
    [anon_sym_sample] = ACTIONS(3411),
    [anon_sym_linear] = ACTIONS(3411),
    [anon_sym_snorm] = ACTIONS(3411),
    [anon_sym_unorm] = ACTIONS(3411),
    [anon_sym_point] = ACTIONS(3411),
    [anon_sym_line] = ACTIONS(3411),
    [anon_sym_triangleadj] = ACTIONS(3411),
    [anon_sym_lineadj] = ACTIONS(3411),
    [anon_sym_triangle] = ACTIONS(3411),
    [anon_sym_cbuffer] = ACTIONS(3411),
    [anon_sym_interface] = ACTIONS(3411),
    [anon_sym_extension] = ACTIONS(3411),
  },
  [743] = {
    [sym_identifier] = ACTIONS(3452),
    [aux_sym_preproc_include_token1] = ACTIONS(3452),
    [aux_sym_preproc_def_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token2] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3452),
    [sym_preproc_directive] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(3450),
    [anon_sym_BANG] = ACTIONS(3450),
    [anon_sym_TILDE] = ACTIONS(3450),
    [anon_sym_DASH] = ACTIONS(3452),
    [anon_sym_PLUS] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_AMP_AMP] = ACTIONS(3450),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym___extension__] = ACTIONS(3452),
    [anon_sym_typedef] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_out] = ACTIONS(3452),
    [anon_sym_inout] = ACTIONS(3452),
    [anon_sym_virtual] = ACTIONS(3452),
    [anon_sym_extern] = ACTIONS(3452),
    [anon_sym___attribute__] = ACTIONS(3452),
    [anon_sym___attribute] = ACTIONS(3452),
    [anon_sym_using] = ACTIONS(3452),
    [anon_sym_COLON_COLON] = ACTIONS(3450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3450),
    [anon_sym___declspec] = ACTIONS(3452),
    [anon_sym___based] = ACTIONS(3452),
    [anon_sym___cdecl] = ACTIONS(3452),
    [anon_sym___clrcall] = ACTIONS(3452),
    [anon_sym___stdcall] = ACTIONS(3452),
    [anon_sym___fastcall] = ACTIONS(3452),
    [anon_sym___thiscall] = ACTIONS(3452),
    [anon_sym___vectorcall] = ACTIONS(3452),
    [anon_sym_LBRACE] = ACTIONS(3450),
    [anon_sym_signed] = ACTIONS(3452),
    [anon_sym_unsigned] = ACTIONS(3452),
    [anon_sym_long] = ACTIONS(3452),
    [anon_sym_short] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3452),
    [anon_sym_static] = ACTIONS(3452),
    [anon_sym_register] = ACTIONS(3452),
    [anon_sym_inline] = ACTIONS(3452),
    [anon_sym___inline] = ACTIONS(3452),
    [anon_sym___inline__] = ACTIONS(3452),
    [anon_sym___forceinline] = ACTIONS(3452),
    [anon_sym_thread_local] = ACTIONS(3452),
    [anon_sym___thread] = ACTIONS(3452),
    [anon_sym_const] = ACTIONS(3452),
    [anon_sym_constexpr] = ACTIONS(3452),
    [anon_sym_volatile] = ACTIONS(3452),
    [anon_sym_restrict] = ACTIONS(3452),
    [anon_sym___restrict__] = ACTIONS(3452),
    [anon_sym__Atomic] = ACTIONS(3452),
    [anon_sym__Noreturn] = ACTIONS(3452),
    [anon_sym_noreturn] = ACTIONS(3452),
    [anon_sym__Nonnull] = ACTIONS(3452),
    [anon_sym_mutable] = ACTIONS(3452),
    [anon_sym_constinit] = ACTIONS(3452),
    [anon_sym_consteval] = ACTIONS(3452),
    [anon_sym_alignas] = ACTIONS(3452),
    [anon_sym__Alignas] = ACTIONS(3452),
    [sym_primitive_type] = ACTIONS(3452),
    [anon_sym_enum] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(3452),
    [anon_sym_union] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_else] = ACTIONS(3452),
    [anon_sym_switch] = ACTIONS(3452),
    [anon_sym_case] = ACTIONS(3452),
    [anon_sym_default] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_do] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3452),
    [anon_sym_return] = ACTIONS(3452),
    [anon_sym_break] = ACTIONS(3452),
    [anon_sym_continue] = ACTIONS(3452),
    [anon_sym_goto] = ACTIONS(3452),
    [anon_sym___try] = ACTIONS(3452),
    [anon_sym___leave] = ACTIONS(3452),
    [anon_sym_not] = ACTIONS(3452),
    [anon_sym_compl] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3450),
    [anon_sym_PLUS_PLUS] = ACTIONS(3450),
    [anon_sym_sizeof] = ACTIONS(3452),
    [anon_sym___alignof__] = ACTIONS(3452),
    [anon_sym___alignof] = ACTIONS(3452),
    [anon_sym__alignof] = ACTIONS(3452),
    [anon_sym_alignof] = ACTIONS(3452),
    [anon_sym__Alignof] = ACTIONS(3452),
    [anon_sym_offsetof] = ACTIONS(3452),
    [anon_sym__Generic] = ACTIONS(3452),
    [anon_sym_asm] = ACTIONS(3452),
    [anon_sym___asm__] = ACTIONS(3452),
    [anon_sym___asm] = ACTIONS(3452),
    [sym_number_literal] = ACTIONS(3450),
    [anon_sym_L_SQUOTE] = ACTIONS(3450),
    [anon_sym_u_SQUOTE] = ACTIONS(3450),
    [anon_sym_U_SQUOTE] = ACTIONS(3450),
    [anon_sym_u8_SQUOTE] = ACTIONS(3450),
    [anon_sym_SQUOTE] = ACTIONS(3450),
    [anon_sym_L_DQUOTE] = ACTIONS(3450),
    [anon_sym_u_DQUOTE] = ACTIONS(3450),
    [anon_sym_U_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8_DQUOTE] = ACTIONS(3450),
    [anon_sym_DQUOTE] = ACTIONS(3450),
    [sym_true] = ACTIONS(3452),
    [sym_false] = ACTIONS(3452),
    [anon_sym_NULL] = ACTIONS(3452),
    [anon_sym_nullptr] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3452),
    [anon_sym_let] = ACTIONS(3452),
    [anon_sym_This] = ACTIONS(3452),
    [anon_sym_decltype] = ACTIONS(3452),
    [anon_sym_explicit] = ACTIONS(3452),
    [anon_sym_typename] = ACTIONS(3452),
    [anon_sym_template] = ACTIONS(3452),
    [anon_sym_operator] = ACTIONS(3452),
    [anon_sym_try] = ACTIONS(3452),
    [anon_sym_delete] = ACTIONS(3452),
    [anon_sym_throw] = ACTIONS(3452),
    [anon_sym_namespace] = ACTIONS(3452),
    [anon_sym_static_assert] = ACTIONS(3452),
    [anon_sym_concept] = ACTIONS(3452),
    [anon_sym_co_return] = ACTIONS(3452),
    [anon_sym_co_yield] = ACTIONS(3452),
    [anon_sym_R_DQUOTE] = ACTIONS(3450),
    [anon_sym_LR_DQUOTE] = ACTIONS(3450),
    [anon_sym_uR_DQUOTE] = ACTIONS(3450),
    [anon_sym_UR_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3450),
    [anon_sym_co_await] = ACTIONS(3452),
    [anon_sym_new] = ACTIONS(3452),
    [anon_sym_requires] = ACTIONS(3452),
    [sym_this] = ACTIONS(3452),
    [anon_sym_discard] = ACTIONS(3452),
    [anon_sym_precise] = ACTIONS(3452),
    [anon_sym_shared] = ACTIONS(3452),
    [anon_sym_groupshared] = ACTIONS(3452),
    [anon_sym_uniform] = ACTIONS(3452),
    [anon_sym_row_major] = ACTIONS(3452),
    [anon_sym_column_major] = ACTIONS(3452),
    [anon_sym_globallycoherent] = ACTIONS(3452),
    [anon_sym_centroid] = ACTIONS(3452),
    [anon_sym_noperspective] = ACTIONS(3452),
    [anon_sym_nointerpolation] = ACTIONS(3452),
    [anon_sym_sample] = ACTIONS(3452),
    [anon_sym_linear] = ACTIONS(3452),
    [anon_sym_snorm] = ACTIONS(3452),
    [anon_sym_unorm] = ACTIONS(3452),
    [anon_sym_point] = ACTIONS(3452),
    [anon_sym_line] = ACTIONS(3452),
    [anon_sym_triangleadj] = ACTIONS(3452),
    [anon_sym_lineadj] = ACTIONS(3452),
    [anon_sym_triangle] = ACTIONS(3452),
    [anon_sym_cbuffer] = ACTIONS(3452),
    [anon_sym_interface] = ACTIONS(3452),
    [anon_sym_extension] = ACTIONS(3452),
  },
  [744] = {
    [sym_identifier] = ACTIONS(3452),
    [aux_sym_preproc_include_token1] = ACTIONS(3452),
    [aux_sym_preproc_def_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token2] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3452),
    [sym_preproc_directive] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(3450),
    [anon_sym_BANG] = ACTIONS(3450),
    [anon_sym_TILDE] = ACTIONS(3450),
    [anon_sym_DASH] = ACTIONS(3452),
    [anon_sym_PLUS] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_AMP_AMP] = ACTIONS(3450),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym___extension__] = ACTIONS(3452),
    [anon_sym_typedef] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_out] = ACTIONS(3452),
    [anon_sym_inout] = ACTIONS(3452),
    [anon_sym_virtual] = ACTIONS(3452),
    [anon_sym_extern] = ACTIONS(3452),
    [anon_sym___attribute__] = ACTIONS(3452),
    [anon_sym___attribute] = ACTIONS(3452),
    [anon_sym_using] = ACTIONS(3452),
    [anon_sym_COLON_COLON] = ACTIONS(3450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3450),
    [anon_sym___declspec] = ACTIONS(3452),
    [anon_sym___based] = ACTIONS(3452),
    [anon_sym___cdecl] = ACTIONS(3452),
    [anon_sym___clrcall] = ACTIONS(3452),
    [anon_sym___stdcall] = ACTIONS(3452),
    [anon_sym___fastcall] = ACTIONS(3452),
    [anon_sym___thiscall] = ACTIONS(3452),
    [anon_sym___vectorcall] = ACTIONS(3452),
    [anon_sym_LBRACE] = ACTIONS(3450),
    [anon_sym_signed] = ACTIONS(3452),
    [anon_sym_unsigned] = ACTIONS(3452),
    [anon_sym_long] = ACTIONS(3452),
    [anon_sym_short] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3452),
    [anon_sym_static] = ACTIONS(3452),
    [anon_sym_register] = ACTIONS(3452),
    [anon_sym_inline] = ACTIONS(3452),
    [anon_sym___inline] = ACTIONS(3452),
    [anon_sym___inline__] = ACTIONS(3452),
    [anon_sym___forceinline] = ACTIONS(3452),
    [anon_sym_thread_local] = ACTIONS(3452),
    [anon_sym___thread] = ACTIONS(3452),
    [anon_sym_const] = ACTIONS(3452),
    [anon_sym_constexpr] = ACTIONS(3452),
    [anon_sym_volatile] = ACTIONS(3452),
    [anon_sym_restrict] = ACTIONS(3452),
    [anon_sym___restrict__] = ACTIONS(3452),
    [anon_sym__Atomic] = ACTIONS(3452),
    [anon_sym__Noreturn] = ACTIONS(3452),
    [anon_sym_noreturn] = ACTIONS(3452),
    [anon_sym__Nonnull] = ACTIONS(3452),
    [anon_sym_mutable] = ACTIONS(3452),
    [anon_sym_constinit] = ACTIONS(3452),
    [anon_sym_consteval] = ACTIONS(3452),
    [anon_sym_alignas] = ACTIONS(3452),
    [anon_sym__Alignas] = ACTIONS(3452),
    [sym_primitive_type] = ACTIONS(3452),
    [anon_sym_enum] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(3452),
    [anon_sym_union] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_else] = ACTIONS(3452),
    [anon_sym_switch] = ACTIONS(3452),
    [anon_sym_case] = ACTIONS(3452),
    [anon_sym_default] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_do] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3452),
    [anon_sym_return] = ACTIONS(3452),
    [anon_sym_break] = ACTIONS(3452),
    [anon_sym_continue] = ACTIONS(3452),
    [anon_sym_goto] = ACTIONS(3452),
    [anon_sym___try] = ACTIONS(3452),
    [anon_sym___leave] = ACTIONS(3452),
    [anon_sym_not] = ACTIONS(3452),
    [anon_sym_compl] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3450),
    [anon_sym_PLUS_PLUS] = ACTIONS(3450),
    [anon_sym_sizeof] = ACTIONS(3452),
    [anon_sym___alignof__] = ACTIONS(3452),
    [anon_sym___alignof] = ACTIONS(3452),
    [anon_sym__alignof] = ACTIONS(3452),
    [anon_sym_alignof] = ACTIONS(3452),
    [anon_sym__Alignof] = ACTIONS(3452),
    [anon_sym_offsetof] = ACTIONS(3452),
    [anon_sym__Generic] = ACTIONS(3452),
    [anon_sym_asm] = ACTIONS(3452),
    [anon_sym___asm__] = ACTIONS(3452),
    [anon_sym___asm] = ACTIONS(3452),
    [sym_number_literal] = ACTIONS(3450),
    [anon_sym_L_SQUOTE] = ACTIONS(3450),
    [anon_sym_u_SQUOTE] = ACTIONS(3450),
    [anon_sym_U_SQUOTE] = ACTIONS(3450),
    [anon_sym_u8_SQUOTE] = ACTIONS(3450),
    [anon_sym_SQUOTE] = ACTIONS(3450),
    [anon_sym_L_DQUOTE] = ACTIONS(3450),
    [anon_sym_u_DQUOTE] = ACTIONS(3450),
    [anon_sym_U_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8_DQUOTE] = ACTIONS(3450),
    [anon_sym_DQUOTE] = ACTIONS(3450),
    [sym_true] = ACTIONS(3452),
    [sym_false] = ACTIONS(3452),
    [anon_sym_NULL] = ACTIONS(3452),
    [anon_sym_nullptr] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3452),
    [anon_sym_let] = ACTIONS(3452),
    [anon_sym_This] = ACTIONS(3452),
    [anon_sym_decltype] = ACTIONS(3452),
    [anon_sym_explicit] = ACTIONS(3452),
    [anon_sym_typename] = ACTIONS(3452),
    [anon_sym_template] = ACTIONS(3452),
    [anon_sym_operator] = ACTIONS(3452),
    [anon_sym_try] = ACTIONS(3452),
    [anon_sym_delete] = ACTIONS(3452),
    [anon_sym_throw] = ACTIONS(3452),
    [anon_sym_namespace] = ACTIONS(3452),
    [anon_sym_static_assert] = ACTIONS(3452),
    [anon_sym_concept] = ACTIONS(3452),
    [anon_sym_co_return] = ACTIONS(3452),
    [anon_sym_co_yield] = ACTIONS(3452),
    [anon_sym_R_DQUOTE] = ACTIONS(3450),
    [anon_sym_LR_DQUOTE] = ACTIONS(3450),
    [anon_sym_uR_DQUOTE] = ACTIONS(3450),
    [anon_sym_UR_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3450),
    [anon_sym_co_await] = ACTIONS(3452),
    [anon_sym_new] = ACTIONS(3452),
    [anon_sym_requires] = ACTIONS(3452),
    [sym_this] = ACTIONS(3452),
    [anon_sym_discard] = ACTIONS(3452),
    [anon_sym_precise] = ACTIONS(3452),
    [anon_sym_shared] = ACTIONS(3452),
    [anon_sym_groupshared] = ACTIONS(3452),
    [anon_sym_uniform] = ACTIONS(3452),
    [anon_sym_row_major] = ACTIONS(3452),
    [anon_sym_column_major] = ACTIONS(3452),
    [anon_sym_globallycoherent] = ACTIONS(3452),
    [anon_sym_centroid] = ACTIONS(3452),
    [anon_sym_noperspective] = ACTIONS(3452),
    [anon_sym_nointerpolation] = ACTIONS(3452),
    [anon_sym_sample] = ACTIONS(3452),
    [anon_sym_linear] = ACTIONS(3452),
    [anon_sym_snorm] = ACTIONS(3452),
    [anon_sym_unorm] = ACTIONS(3452),
    [anon_sym_point] = ACTIONS(3452),
    [anon_sym_line] = ACTIONS(3452),
    [anon_sym_triangleadj] = ACTIONS(3452),
    [anon_sym_lineadj] = ACTIONS(3452),
    [anon_sym_triangle] = ACTIONS(3452),
    [anon_sym_cbuffer] = ACTIONS(3452),
    [anon_sym_interface] = ACTIONS(3452),
    [anon_sym_extension] = ACTIONS(3452),
  },
  [745] = {
    [sym_identifier] = ACTIONS(3452),
    [aux_sym_preproc_include_token1] = ACTIONS(3452),
    [aux_sym_preproc_def_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token2] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3452),
    [sym_preproc_directive] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(3450),
    [anon_sym_BANG] = ACTIONS(3450),
    [anon_sym_TILDE] = ACTIONS(3450),
    [anon_sym_DASH] = ACTIONS(3452),
    [anon_sym_PLUS] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_AMP_AMP] = ACTIONS(3450),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym___extension__] = ACTIONS(3452),
    [anon_sym_typedef] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_out] = ACTIONS(3452),
    [anon_sym_inout] = ACTIONS(3452),
    [anon_sym_virtual] = ACTIONS(3452),
    [anon_sym_extern] = ACTIONS(3452),
    [anon_sym___attribute__] = ACTIONS(3452),
    [anon_sym___attribute] = ACTIONS(3452),
    [anon_sym_using] = ACTIONS(3452),
    [anon_sym_COLON_COLON] = ACTIONS(3450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3450),
    [anon_sym___declspec] = ACTIONS(3452),
    [anon_sym___based] = ACTIONS(3452),
    [anon_sym___cdecl] = ACTIONS(3452),
    [anon_sym___clrcall] = ACTIONS(3452),
    [anon_sym___stdcall] = ACTIONS(3452),
    [anon_sym___fastcall] = ACTIONS(3452),
    [anon_sym___thiscall] = ACTIONS(3452),
    [anon_sym___vectorcall] = ACTIONS(3452),
    [anon_sym_LBRACE] = ACTIONS(3450),
    [anon_sym_signed] = ACTIONS(3452),
    [anon_sym_unsigned] = ACTIONS(3452),
    [anon_sym_long] = ACTIONS(3452),
    [anon_sym_short] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3452),
    [anon_sym_static] = ACTIONS(3452),
    [anon_sym_register] = ACTIONS(3452),
    [anon_sym_inline] = ACTIONS(3452),
    [anon_sym___inline] = ACTIONS(3452),
    [anon_sym___inline__] = ACTIONS(3452),
    [anon_sym___forceinline] = ACTIONS(3452),
    [anon_sym_thread_local] = ACTIONS(3452),
    [anon_sym___thread] = ACTIONS(3452),
    [anon_sym_const] = ACTIONS(3452),
    [anon_sym_constexpr] = ACTIONS(3452),
    [anon_sym_volatile] = ACTIONS(3452),
    [anon_sym_restrict] = ACTIONS(3452),
    [anon_sym___restrict__] = ACTIONS(3452),
    [anon_sym__Atomic] = ACTIONS(3452),
    [anon_sym__Noreturn] = ACTIONS(3452),
    [anon_sym_noreturn] = ACTIONS(3452),
    [anon_sym__Nonnull] = ACTIONS(3452),
    [anon_sym_mutable] = ACTIONS(3452),
    [anon_sym_constinit] = ACTIONS(3452),
    [anon_sym_consteval] = ACTIONS(3452),
    [anon_sym_alignas] = ACTIONS(3452),
    [anon_sym__Alignas] = ACTIONS(3452),
    [sym_primitive_type] = ACTIONS(3452),
    [anon_sym_enum] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(3452),
    [anon_sym_union] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_else] = ACTIONS(3452),
    [anon_sym_switch] = ACTIONS(3452),
    [anon_sym_case] = ACTIONS(3452),
    [anon_sym_default] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_do] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3452),
    [anon_sym_return] = ACTIONS(3452),
    [anon_sym_break] = ACTIONS(3452),
    [anon_sym_continue] = ACTIONS(3452),
    [anon_sym_goto] = ACTIONS(3452),
    [anon_sym___try] = ACTIONS(3452),
    [anon_sym___leave] = ACTIONS(3452),
    [anon_sym_not] = ACTIONS(3452),
    [anon_sym_compl] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3450),
    [anon_sym_PLUS_PLUS] = ACTIONS(3450),
    [anon_sym_sizeof] = ACTIONS(3452),
    [anon_sym___alignof__] = ACTIONS(3452),
    [anon_sym___alignof] = ACTIONS(3452),
    [anon_sym__alignof] = ACTIONS(3452),
    [anon_sym_alignof] = ACTIONS(3452),
    [anon_sym__Alignof] = ACTIONS(3452),
    [anon_sym_offsetof] = ACTIONS(3452),
    [anon_sym__Generic] = ACTIONS(3452),
    [anon_sym_asm] = ACTIONS(3452),
    [anon_sym___asm__] = ACTIONS(3452),
    [anon_sym___asm] = ACTIONS(3452),
    [sym_number_literal] = ACTIONS(3450),
    [anon_sym_L_SQUOTE] = ACTIONS(3450),
    [anon_sym_u_SQUOTE] = ACTIONS(3450),
    [anon_sym_U_SQUOTE] = ACTIONS(3450),
    [anon_sym_u8_SQUOTE] = ACTIONS(3450),
    [anon_sym_SQUOTE] = ACTIONS(3450),
    [anon_sym_L_DQUOTE] = ACTIONS(3450),
    [anon_sym_u_DQUOTE] = ACTIONS(3450),
    [anon_sym_U_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8_DQUOTE] = ACTIONS(3450),
    [anon_sym_DQUOTE] = ACTIONS(3450),
    [sym_true] = ACTIONS(3452),
    [sym_false] = ACTIONS(3452),
    [anon_sym_NULL] = ACTIONS(3452),
    [anon_sym_nullptr] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3452),
    [anon_sym_let] = ACTIONS(3452),
    [anon_sym_This] = ACTIONS(3452),
    [anon_sym_decltype] = ACTIONS(3452),
    [anon_sym_explicit] = ACTIONS(3452),
    [anon_sym_typename] = ACTIONS(3452),
    [anon_sym_template] = ACTIONS(3452),
    [anon_sym_operator] = ACTIONS(3452),
    [anon_sym_try] = ACTIONS(3452),
    [anon_sym_delete] = ACTIONS(3452),
    [anon_sym_throw] = ACTIONS(3452),
    [anon_sym_namespace] = ACTIONS(3452),
    [anon_sym_static_assert] = ACTIONS(3452),
    [anon_sym_concept] = ACTIONS(3452),
    [anon_sym_co_return] = ACTIONS(3452),
    [anon_sym_co_yield] = ACTIONS(3452),
    [anon_sym_R_DQUOTE] = ACTIONS(3450),
    [anon_sym_LR_DQUOTE] = ACTIONS(3450),
    [anon_sym_uR_DQUOTE] = ACTIONS(3450),
    [anon_sym_UR_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3450),
    [anon_sym_co_await] = ACTIONS(3452),
    [anon_sym_new] = ACTIONS(3452),
    [anon_sym_requires] = ACTIONS(3452),
    [sym_this] = ACTIONS(3452),
    [anon_sym_discard] = ACTIONS(3452),
    [anon_sym_precise] = ACTIONS(3452),
    [anon_sym_shared] = ACTIONS(3452),
    [anon_sym_groupshared] = ACTIONS(3452),
    [anon_sym_uniform] = ACTIONS(3452),
    [anon_sym_row_major] = ACTIONS(3452),
    [anon_sym_column_major] = ACTIONS(3452),
    [anon_sym_globallycoherent] = ACTIONS(3452),
    [anon_sym_centroid] = ACTIONS(3452),
    [anon_sym_noperspective] = ACTIONS(3452),
    [anon_sym_nointerpolation] = ACTIONS(3452),
    [anon_sym_sample] = ACTIONS(3452),
    [anon_sym_linear] = ACTIONS(3452),
    [anon_sym_snorm] = ACTIONS(3452),
    [anon_sym_unorm] = ACTIONS(3452),
    [anon_sym_point] = ACTIONS(3452),
    [anon_sym_line] = ACTIONS(3452),
    [anon_sym_triangleadj] = ACTIONS(3452),
    [anon_sym_lineadj] = ACTIONS(3452),
    [anon_sym_triangle] = ACTIONS(3452),
    [anon_sym_cbuffer] = ACTIONS(3452),
    [anon_sym_interface] = ACTIONS(3452),
    [anon_sym_extension] = ACTIONS(3452),
  },
  [746] = {
    [sym_identifier] = ACTIONS(3460),
    [aux_sym_preproc_include_token1] = ACTIONS(3460),
    [aux_sym_preproc_def_token1] = ACTIONS(3460),
    [aux_sym_preproc_if_token1] = ACTIONS(3460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3460),
    [sym_preproc_directive] = ACTIONS(3460),
    [anon_sym_LPAREN2] = ACTIONS(3458),
    [anon_sym_BANG] = ACTIONS(3458),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3460),
    [anon_sym_PLUS] = ACTIONS(3460),
    [anon_sym_STAR] = ACTIONS(3458),
    [anon_sym_AMP_AMP] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3460),
    [anon_sym_SEMI] = ACTIONS(3458),
    [anon_sym___extension__] = ACTIONS(3460),
    [anon_sym_typedef] = ACTIONS(3460),
    [anon_sym_in] = ACTIONS(3460),
    [anon_sym_out] = ACTIONS(3460),
    [anon_sym_inout] = ACTIONS(3460),
    [anon_sym_virtual] = ACTIONS(3460),
    [anon_sym_extern] = ACTIONS(3460),
    [anon_sym___attribute__] = ACTIONS(3460),
    [anon_sym___attribute] = ACTIONS(3460),
    [anon_sym_using] = ACTIONS(3460),
    [anon_sym_COLON_COLON] = ACTIONS(3458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3458),
    [anon_sym___declspec] = ACTIONS(3460),
    [anon_sym___based] = ACTIONS(3460),
    [anon_sym___cdecl] = ACTIONS(3460),
    [anon_sym___clrcall] = ACTIONS(3460),
    [anon_sym___stdcall] = ACTIONS(3460),
    [anon_sym___fastcall] = ACTIONS(3460),
    [anon_sym___thiscall] = ACTIONS(3460),
    [anon_sym___vectorcall] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(3458),
    [anon_sym_RBRACE] = ACTIONS(3458),
    [anon_sym_signed] = ACTIONS(3460),
    [anon_sym_unsigned] = ACTIONS(3460),
    [anon_sym_long] = ACTIONS(3460),
    [anon_sym_short] = ACTIONS(3460),
    [anon_sym_LBRACK] = ACTIONS(3460),
    [anon_sym_static] = ACTIONS(3460),
    [anon_sym_register] = ACTIONS(3460),
    [anon_sym_inline] = ACTIONS(3460),
    [anon_sym___inline] = ACTIONS(3460),
    [anon_sym___inline__] = ACTIONS(3460),
    [anon_sym___forceinline] = ACTIONS(3460),
    [anon_sym_thread_local] = ACTIONS(3460),
    [anon_sym___thread] = ACTIONS(3460),
    [anon_sym_const] = ACTIONS(3460),
    [anon_sym_constexpr] = ACTIONS(3460),
    [anon_sym_volatile] = ACTIONS(3460),
    [anon_sym_restrict] = ACTIONS(3460),
    [anon_sym___restrict__] = ACTIONS(3460),
    [anon_sym__Atomic] = ACTIONS(3460),
    [anon_sym__Noreturn] = ACTIONS(3460),
    [anon_sym_noreturn] = ACTIONS(3460),
    [anon_sym__Nonnull] = ACTIONS(3460),
    [anon_sym_mutable] = ACTIONS(3460),
    [anon_sym_constinit] = ACTIONS(3460),
    [anon_sym_consteval] = ACTIONS(3460),
    [anon_sym_alignas] = ACTIONS(3460),
    [anon_sym__Alignas] = ACTIONS(3460),
    [sym_primitive_type] = ACTIONS(3460),
    [anon_sym_enum] = ACTIONS(3460),
    [anon_sym_class] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(3460),
    [anon_sym_union] = ACTIONS(3460),
    [anon_sym_if] = ACTIONS(3460),
    [anon_sym_else] = ACTIONS(3460),
    [anon_sym_switch] = ACTIONS(3460),
    [anon_sym_case] = ACTIONS(3460),
    [anon_sym_default] = ACTIONS(3460),
    [anon_sym_while] = ACTIONS(3460),
    [anon_sym_do] = ACTIONS(3460),
    [anon_sym_for] = ACTIONS(3460),
    [anon_sym_return] = ACTIONS(3460),
    [anon_sym_break] = ACTIONS(3460),
    [anon_sym_continue] = ACTIONS(3460),
    [anon_sym_goto] = ACTIONS(3460),
    [anon_sym___try] = ACTIONS(3460),
    [anon_sym___leave] = ACTIONS(3460),
    [anon_sym_not] = ACTIONS(3460),
    [anon_sym_compl] = ACTIONS(3460),
    [anon_sym_DASH_DASH] = ACTIONS(3458),
    [anon_sym_PLUS_PLUS] = ACTIONS(3458),
    [anon_sym_sizeof] = ACTIONS(3460),
    [anon_sym___alignof__] = ACTIONS(3460),
    [anon_sym___alignof] = ACTIONS(3460),
    [anon_sym__alignof] = ACTIONS(3460),
    [anon_sym_alignof] = ACTIONS(3460),
    [anon_sym__Alignof] = ACTIONS(3460),
    [anon_sym_offsetof] = ACTIONS(3460),
    [anon_sym__Generic] = ACTIONS(3460),
    [anon_sym_asm] = ACTIONS(3460),
    [anon_sym___asm__] = ACTIONS(3460),
    [anon_sym___asm] = ACTIONS(3460),
    [sym_number_literal] = ACTIONS(3458),
    [anon_sym_L_SQUOTE] = ACTIONS(3458),
    [anon_sym_u_SQUOTE] = ACTIONS(3458),
    [anon_sym_U_SQUOTE] = ACTIONS(3458),
    [anon_sym_u8_SQUOTE] = ACTIONS(3458),
    [anon_sym_SQUOTE] = ACTIONS(3458),
    [anon_sym_L_DQUOTE] = ACTIONS(3458),
    [anon_sym_u_DQUOTE] = ACTIONS(3458),
    [anon_sym_U_DQUOTE] = ACTIONS(3458),
    [anon_sym_u8_DQUOTE] = ACTIONS(3458),
    [anon_sym_DQUOTE] = ACTIONS(3458),
    [sym_true] = ACTIONS(3460),
    [sym_false] = ACTIONS(3460),
    [anon_sym_NULL] = ACTIONS(3460),
    [anon_sym_nullptr] = ACTIONS(3460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3460),
    [anon_sym_let] = ACTIONS(3460),
    [anon_sym_This] = ACTIONS(3460),
    [anon_sym_decltype] = ACTIONS(3460),
    [anon_sym_explicit] = ACTIONS(3460),
    [anon_sym_typename] = ACTIONS(3460),
    [anon_sym_template] = ACTIONS(3460),
    [anon_sym_operator] = ACTIONS(3460),
    [anon_sym_try] = ACTIONS(3460),
    [anon_sym_delete] = ACTIONS(3460),
    [anon_sym_throw] = ACTIONS(3460),
    [anon_sym_namespace] = ACTIONS(3460),
    [anon_sym_static_assert] = ACTIONS(3460),
    [anon_sym_concept] = ACTIONS(3460),
    [anon_sym_co_return] = ACTIONS(3460),
    [anon_sym_co_yield] = ACTIONS(3460),
    [anon_sym_R_DQUOTE] = ACTIONS(3458),
    [anon_sym_LR_DQUOTE] = ACTIONS(3458),
    [anon_sym_uR_DQUOTE] = ACTIONS(3458),
    [anon_sym_UR_DQUOTE] = ACTIONS(3458),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3458),
    [anon_sym_co_await] = ACTIONS(3460),
    [anon_sym_new] = ACTIONS(3460),
    [anon_sym_requires] = ACTIONS(3460),
    [sym_this] = ACTIONS(3460),
    [anon_sym_discard] = ACTIONS(3460),
    [anon_sym_precise] = ACTIONS(3460),
    [anon_sym_shared] = ACTIONS(3460),
    [anon_sym_groupshared] = ACTIONS(3460),
    [anon_sym_uniform] = ACTIONS(3460),
    [anon_sym_row_major] = ACTIONS(3460),
    [anon_sym_column_major] = ACTIONS(3460),
    [anon_sym_globallycoherent] = ACTIONS(3460),
    [anon_sym_centroid] = ACTIONS(3460),
    [anon_sym_noperspective] = ACTIONS(3460),
    [anon_sym_nointerpolation] = ACTIONS(3460),
    [anon_sym_sample] = ACTIONS(3460),
    [anon_sym_linear] = ACTIONS(3460),
    [anon_sym_snorm] = ACTIONS(3460),
    [anon_sym_unorm] = ACTIONS(3460),
    [anon_sym_point] = ACTIONS(3460),
    [anon_sym_line] = ACTIONS(3460),
    [anon_sym_triangleadj] = ACTIONS(3460),
    [anon_sym_lineadj] = ACTIONS(3460),
    [anon_sym_triangle] = ACTIONS(3460),
    [anon_sym_cbuffer] = ACTIONS(3460),
    [anon_sym_interface] = ACTIONS(3460),
    [anon_sym_extension] = ACTIONS(3460),
  },
  [747] = {
    [sym_identifier] = ACTIONS(3562),
    [aux_sym_preproc_include_token1] = ACTIONS(3562),
    [aux_sym_preproc_def_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token2] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3562),
    [sym_preproc_directive] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym___extension__] = ACTIONS(3562),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_in] = ACTIONS(3562),
    [anon_sym_out] = ACTIONS(3562),
    [anon_sym_inout] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym___attribute__] = ACTIONS(3562),
    [anon_sym___attribute] = ACTIONS(3562),
    [anon_sym_using] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3560),
    [anon_sym___declspec] = ACTIONS(3562),
    [anon_sym___based] = ACTIONS(3562),
    [anon_sym___cdecl] = ACTIONS(3562),
    [anon_sym___clrcall] = ACTIONS(3562),
    [anon_sym___stdcall] = ACTIONS(3562),
    [anon_sym___fastcall] = ACTIONS(3562),
    [anon_sym___thiscall] = ACTIONS(3562),
    [anon_sym___vectorcall] = ACTIONS(3562),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_signed] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym___inline] = ACTIONS(3562),
    [anon_sym___inline__] = ACTIONS(3562),
    [anon_sym___forceinline] = ACTIONS(3562),
    [anon_sym_thread_local] = ACTIONS(3562),
    [anon_sym___thread] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_constexpr] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym___restrict__] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym__Noreturn] = ACTIONS(3562),
    [anon_sym_noreturn] = ACTIONS(3562),
    [anon_sym__Nonnull] = ACTIONS(3562),
    [anon_sym_mutable] = ACTIONS(3562),
    [anon_sym_constinit] = ACTIONS(3562),
    [anon_sym_consteval] = ACTIONS(3562),
    [anon_sym_alignas] = ACTIONS(3562),
    [anon_sym__Alignas] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_else] = ACTIONS(3562),
    [anon_sym_switch] = ACTIONS(3562),
    [anon_sym_case] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_goto] = ACTIONS(3562),
    [anon_sym___try] = ACTIONS(3562),
    [anon_sym___leave] = ACTIONS(3562),
    [anon_sym_not] = ACTIONS(3562),
    [anon_sym_compl] = ACTIONS(3562),
    [anon_sym_DASH_DASH] = ACTIONS(3560),
    [anon_sym_PLUS_PLUS] = ACTIONS(3560),
    [anon_sym_sizeof] = ACTIONS(3562),
    [anon_sym___alignof__] = ACTIONS(3562),
    [anon_sym___alignof] = ACTIONS(3562),
    [anon_sym__alignof] = ACTIONS(3562),
    [anon_sym_alignof] = ACTIONS(3562),
    [anon_sym__Alignof] = ACTIONS(3562),
    [anon_sym_offsetof] = ACTIONS(3562),
    [anon_sym__Generic] = ACTIONS(3562),
    [anon_sym_asm] = ACTIONS(3562),
    [anon_sym___asm__] = ACTIONS(3562),
    [anon_sym___asm] = ACTIONS(3562),
    [sym_number_literal] = ACTIONS(3560),
    [anon_sym_L_SQUOTE] = ACTIONS(3560),
    [anon_sym_u_SQUOTE] = ACTIONS(3560),
    [anon_sym_U_SQUOTE] = ACTIONS(3560),
    [anon_sym_u8_SQUOTE] = ACTIONS(3560),
    [anon_sym_SQUOTE] = ACTIONS(3560),
    [anon_sym_L_DQUOTE] = ACTIONS(3560),
    [anon_sym_u_DQUOTE] = ACTIONS(3560),
    [anon_sym_U_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE] = ACTIONS(3560),
    [sym_true] = ACTIONS(3562),
    [sym_false] = ACTIONS(3562),
    [anon_sym_NULL] = ACTIONS(3562),
    [anon_sym_nullptr] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_This] = ACTIONS(3562),
    [anon_sym_decltype] = ACTIONS(3562),
    [anon_sym_explicit] = ACTIONS(3562),
    [anon_sym_typename] = ACTIONS(3562),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_delete] = ACTIONS(3562),
    [anon_sym_throw] = ACTIONS(3562),
    [anon_sym_namespace] = ACTIONS(3562),
    [anon_sym_static_assert] = ACTIONS(3562),
    [anon_sym_concept] = ACTIONS(3562),
    [anon_sym_co_return] = ACTIONS(3562),
    [anon_sym_co_yield] = ACTIONS(3562),
    [anon_sym_R_DQUOTE] = ACTIONS(3560),
    [anon_sym_LR_DQUOTE] = ACTIONS(3560),
    [anon_sym_uR_DQUOTE] = ACTIONS(3560),
    [anon_sym_UR_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3560),
    [anon_sym_co_await] = ACTIONS(3562),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_requires] = ACTIONS(3562),
    [sym_this] = ACTIONS(3562),
    [anon_sym_discard] = ACTIONS(3562),
    [anon_sym_precise] = ACTIONS(3562),
    [anon_sym_shared] = ACTIONS(3562),
    [anon_sym_groupshared] = ACTIONS(3562),
    [anon_sym_uniform] = ACTIONS(3562),
    [anon_sym_row_major] = ACTIONS(3562),
    [anon_sym_column_major] = ACTIONS(3562),
    [anon_sym_globallycoherent] = ACTIONS(3562),
    [anon_sym_centroid] = ACTIONS(3562),
    [anon_sym_noperspective] = ACTIONS(3562),
    [anon_sym_nointerpolation] = ACTIONS(3562),
    [anon_sym_sample] = ACTIONS(3562),
    [anon_sym_linear] = ACTIONS(3562),
    [anon_sym_snorm] = ACTIONS(3562),
    [anon_sym_unorm] = ACTIONS(3562),
    [anon_sym_point] = ACTIONS(3562),
    [anon_sym_line] = ACTIONS(3562),
    [anon_sym_triangleadj] = ACTIONS(3562),
    [anon_sym_lineadj] = ACTIONS(3562),
    [anon_sym_triangle] = ACTIONS(3562),
    [anon_sym_cbuffer] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_extension] = ACTIONS(3562),
  },
  [748] = {
    [sym_identifier] = ACTIONS(3562),
    [aux_sym_preproc_include_token1] = ACTIONS(3562),
    [aux_sym_preproc_def_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token2] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3562),
    [sym_preproc_directive] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym___extension__] = ACTIONS(3562),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_in] = ACTIONS(3562),
    [anon_sym_out] = ACTIONS(3562),
    [anon_sym_inout] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym___attribute__] = ACTIONS(3562),
    [anon_sym___attribute] = ACTIONS(3562),
    [anon_sym_using] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3560),
    [anon_sym___declspec] = ACTIONS(3562),
    [anon_sym___based] = ACTIONS(3562),
    [anon_sym___cdecl] = ACTIONS(3562),
    [anon_sym___clrcall] = ACTIONS(3562),
    [anon_sym___stdcall] = ACTIONS(3562),
    [anon_sym___fastcall] = ACTIONS(3562),
    [anon_sym___thiscall] = ACTIONS(3562),
    [anon_sym___vectorcall] = ACTIONS(3562),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_signed] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym___inline] = ACTIONS(3562),
    [anon_sym___inline__] = ACTIONS(3562),
    [anon_sym___forceinline] = ACTIONS(3562),
    [anon_sym_thread_local] = ACTIONS(3562),
    [anon_sym___thread] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_constexpr] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym___restrict__] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym__Noreturn] = ACTIONS(3562),
    [anon_sym_noreturn] = ACTIONS(3562),
    [anon_sym__Nonnull] = ACTIONS(3562),
    [anon_sym_mutable] = ACTIONS(3562),
    [anon_sym_constinit] = ACTIONS(3562),
    [anon_sym_consteval] = ACTIONS(3562),
    [anon_sym_alignas] = ACTIONS(3562),
    [anon_sym__Alignas] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_else] = ACTIONS(3562),
    [anon_sym_switch] = ACTIONS(3562),
    [anon_sym_case] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_goto] = ACTIONS(3562),
    [anon_sym___try] = ACTIONS(3562),
    [anon_sym___leave] = ACTIONS(3562),
    [anon_sym_not] = ACTIONS(3562),
    [anon_sym_compl] = ACTIONS(3562),
    [anon_sym_DASH_DASH] = ACTIONS(3560),
    [anon_sym_PLUS_PLUS] = ACTIONS(3560),
    [anon_sym_sizeof] = ACTIONS(3562),
    [anon_sym___alignof__] = ACTIONS(3562),
    [anon_sym___alignof] = ACTIONS(3562),
    [anon_sym__alignof] = ACTIONS(3562),
    [anon_sym_alignof] = ACTIONS(3562),
    [anon_sym__Alignof] = ACTIONS(3562),
    [anon_sym_offsetof] = ACTIONS(3562),
    [anon_sym__Generic] = ACTIONS(3562),
    [anon_sym_asm] = ACTIONS(3562),
    [anon_sym___asm__] = ACTIONS(3562),
    [anon_sym___asm] = ACTIONS(3562),
    [sym_number_literal] = ACTIONS(3560),
    [anon_sym_L_SQUOTE] = ACTIONS(3560),
    [anon_sym_u_SQUOTE] = ACTIONS(3560),
    [anon_sym_U_SQUOTE] = ACTIONS(3560),
    [anon_sym_u8_SQUOTE] = ACTIONS(3560),
    [anon_sym_SQUOTE] = ACTIONS(3560),
    [anon_sym_L_DQUOTE] = ACTIONS(3560),
    [anon_sym_u_DQUOTE] = ACTIONS(3560),
    [anon_sym_U_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE] = ACTIONS(3560),
    [sym_true] = ACTIONS(3562),
    [sym_false] = ACTIONS(3562),
    [anon_sym_NULL] = ACTIONS(3562),
    [anon_sym_nullptr] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_This] = ACTIONS(3562),
    [anon_sym_decltype] = ACTIONS(3562),
    [anon_sym_explicit] = ACTIONS(3562),
    [anon_sym_typename] = ACTIONS(3562),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_delete] = ACTIONS(3562),
    [anon_sym_throw] = ACTIONS(3562),
    [anon_sym_namespace] = ACTIONS(3562),
    [anon_sym_static_assert] = ACTIONS(3562),
    [anon_sym_concept] = ACTIONS(3562),
    [anon_sym_co_return] = ACTIONS(3562),
    [anon_sym_co_yield] = ACTIONS(3562),
    [anon_sym_R_DQUOTE] = ACTIONS(3560),
    [anon_sym_LR_DQUOTE] = ACTIONS(3560),
    [anon_sym_uR_DQUOTE] = ACTIONS(3560),
    [anon_sym_UR_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3560),
    [anon_sym_co_await] = ACTIONS(3562),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_requires] = ACTIONS(3562),
    [sym_this] = ACTIONS(3562),
    [anon_sym_discard] = ACTIONS(3562),
    [anon_sym_precise] = ACTIONS(3562),
    [anon_sym_shared] = ACTIONS(3562),
    [anon_sym_groupshared] = ACTIONS(3562),
    [anon_sym_uniform] = ACTIONS(3562),
    [anon_sym_row_major] = ACTIONS(3562),
    [anon_sym_column_major] = ACTIONS(3562),
    [anon_sym_globallycoherent] = ACTIONS(3562),
    [anon_sym_centroid] = ACTIONS(3562),
    [anon_sym_noperspective] = ACTIONS(3562),
    [anon_sym_nointerpolation] = ACTIONS(3562),
    [anon_sym_sample] = ACTIONS(3562),
    [anon_sym_linear] = ACTIONS(3562),
    [anon_sym_snorm] = ACTIONS(3562),
    [anon_sym_unorm] = ACTIONS(3562),
    [anon_sym_point] = ACTIONS(3562),
    [anon_sym_line] = ACTIONS(3562),
    [anon_sym_triangleadj] = ACTIONS(3562),
    [anon_sym_lineadj] = ACTIONS(3562),
    [anon_sym_triangle] = ACTIONS(3562),
    [anon_sym_cbuffer] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_extension] = ACTIONS(3562),
  },
  [749] = {
    [sym_identifier] = ACTIONS(3562),
    [aux_sym_preproc_include_token1] = ACTIONS(3562),
    [aux_sym_preproc_def_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token2] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3562),
    [sym_preproc_directive] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym___extension__] = ACTIONS(3562),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_in] = ACTIONS(3562),
    [anon_sym_out] = ACTIONS(3562),
    [anon_sym_inout] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym___attribute__] = ACTIONS(3562),
    [anon_sym___attribute] = ACTIONS(3562),
    [anon_sym_using] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3560),
    [anon_sym___declspec] = ACTIONS(3562),
    [anon_sym___based] = ACTIONS(3562),
    [anon_sym___cdecl] = ACTIONS(3562),
    [anon_sym___clrcall] = ACTIONS(3562),
    [anon_sym___stdcall] = ACTIONS(3562),
    [anon_sym___fastcall] = ACTIONS(3562),
    [anon_sym___thiscall] = ACTIONS(3562),
    [anon_sym___vectorcall] = ACTIONS(3562),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_signed] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym___inline] = ACTIONS(3562),
    [anon_sym___inline__] = ACTIONS(3562),
    [anon_sym___forceinline] = ACTIONS(3562),
    [anon_sym_thread_local] = ACTIONS(3562),
    [anon_sym___thread] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_constexpr] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym___restrict__] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym__Noreturn] = ACTIONS(3562),
    [anon_sym_noreturn] = ACTIONS(3562),
    [anon_sym__Nonnull] = ACTIONS(3562),
    [anon_sym_mutable] = ACTIONS(3562),
    [anon_sym_constinit] = ACTIONS(3562),
    [anon_sym_consteval] = ACTIONS(3562),
    [anon_sym_alignas] = ACTIONS(3562),
    [anon_sym__Alignas] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_else] = ACTIONS(3562),
    [anon_sym_switch] = ACTIONS(3562),
    [anon_sym_case] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_goto] = ACTIONS(3562),
    [anon_sym___try] = ACTIONS(3562),
    [anon_sym___leave] = ACTIONS(3562),
    [anon_sym_not] = ACTIONS(3562),
    [anon_sym_compl] = ACTIONS(3562),
    [anon_sym_DASH_DASH] = ACTIONS(3560),
    [anon_sym_PLUS_PLUS] = ACTIONS(3560),
    [anon_sym_sizeof] = ACTIONS(3562),
    [anon_sym___alignof__] = ACTIONS(3562),
    [anon_sym___alignof] = ACTIONS(3562),
    [anon_sym__alignof] = ACTIONS(3562),
    [anon_sym_alignof] = ACTIONS(3562),
    [anon_sym__Alignof] = ACTIONS(3562),
    [anon_sym_offsetof] = ACTIONS(3562),
    [anon_sym__Generic] = ACTIONS(3562),
    [anon_sym_asm] = ACTIONS(3562),
    [anon_sym___asm__] = ACTIONS(3562),
    [anon_sym___asm] = ACTIONS(3562),
    [sym_number_literal] = ACTIONS(3560),
    [anon_sym_L_SQUOTE] = ACTIONS(3560),
    [anon_sym_u_SQUOTE] = ACTIONS(3560),
    [anon_sym_U_SQUOTE] = ACTIONS(3560),
    [anon_sym_u8_SQUOTE] = ACTIONS(3560),
    [anon_sym_SQUOTE] = ACTIONS(3560),
    [anon_sym_L_DQUOTE] = ACTIONS(3560),
    [anon_sym_u_DQUOTE] = ACTIONS(3560),
    [anon_sym_U_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE] = ACTIONS(3560),
    [sym_true] = ACTIONS(3562),
    [sym_false] = ACTIONS(3562),
    [anon_sym_NULL] = ACTIONS(3562),
    [anon_sym_nullptr] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_This] = ACTIONS(3562),
    [anon_sym_decltype] = ACTIONS(3562),
    [anon_sym_explicit] = ACTIONS(3562),
    [anon_sym_typename] = ACTIONS(3562),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_delete] = ACTIONS(3562),
    [anon_sym_throw] = ACTIONS(3562),
    [anon_sym_namespace] = ACTIONS(3562),
    [anon_sym_static_assert] = ACTIONS(3562),
    [anon_sym_concept] = ACTIONS(3562),
    [anon_sym_co_return] = ACTIONS(3562),
    [anon_sym_co_yield] = ACTIONS(3562),
    [anon_sym_R_DQUOTE] = ACTIONS(3560),
    [anon_sym_LR_DQUOTE] = ACTIONS(3560),
    [anon_sym_uR_DQUOTE] = ACTIONS(3560),
    [anon_sym_UR_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3560),
    [anon_sym_co_await] = ACTIONS(3562),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_requires] = ACTIONS(3562),
    [sym_this] = ACTIONS(3562),
    [anon_sym_discard] = ACTIONS(3562),
    [anon_sym_precise] = ACTIONS(3562),
    [anon_sym_shared] = ACTIONS(3562),
    [anon_sym_groupshared] = ACTIONS(3562),
    [anon_sym_uniform] = ACTIONS(3562),
    [anon_sym_row_major] = ACTIONS(3562),
    [anon_sym_column_major] = ACTIONS(3562),
    [anon_sym_globallycoherent] = ACTIONS(3562),
    [anon_sym_centroid] = ACTIONS(3562),
    [anon_sym_noperspective] = ACTIONS(3562),
    [anon_sym_nointerpolation] = ACTIONS(3562),
    [anon_sym_sample] = ACTIONS(3562),
    [anon_sym_linear] = ACTIONS(3562),
    [anon_sym_snorm] = ACTIONS(3562),
    [anon_sym_unorm] = ACTIONS(3562),
    [anon_sym_point] = ACTIONS(3562),
    [anon_sym_line] = ACTIONS(3562),
    [anon_sym_triangleadj] = ACTIONS(3562),
    [anon_sym_lineadj] = ACTIONS(3562),
    [anon_sym_triangle] = ACTIONS(3562),
    [anon_sym_cbuffer] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_extension] = ACTIONS(3562),
  },
  [750] = {
    [sym_identifier] = ACTIONS(3623),
    [aux_sym_preproc_include_token1] = ACTIONS(3623),
    [aux_sym_preproc_def_token1] = ACTIONS(3623),
    [aux_sym_preproc_if_token1] = ACTIONS(3623),
    [aux_sym_preproc_if_token2] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3623),
    [sym_preproc_directive] = ACTIONS(3623),
    [anon_sym_LPAREN2] = ACTIONS(3621),
    [anon_sym_BANG] = ACTIONS(3621),
    [anon_sym_TILDE] = ACTIONS(3621),
    [anon_sym_DASH] = ACTIONS(3623),
    [anon_sym_PLUS] = ACTIONS(3623),
    [anon_sym_STAR] = ACTIONS(3621),
    [anon_sym_AMP_AMP] = ACTIONS(3621),
    [anon_sym_AMP] = ACTIONS(3623),
    [anon_sym_SEMI] = ACTIONS(3621),
    [anon_sym___extension__] = ACTIONS(3623),
    [anon_sym_typedef] = ACTIONS(3623),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_out] = ACTIONS(3623),
    [anon_sym_inout] = ACTIONS(3623),
    [anon_sym_virtual] = ACTIONS(3623),
    [anon_sym_extern] = ACTIONS(3623),
    [anon_sym___attribute__] = ACTIONS(3623),
    [anon_sym___attribute] = ACTIONS(3623),
    [anon_sym_using] = ACTIONS(3623),
    [anon_sym_COLON_COLON] = ACTIONS(3621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3621),
    [anon_sym___declspec] = ACTIONS(3623),
    [anon_sym___based] = ACTIONS(3623),
    [anon_sym___cdecl] = ACTIONS(3623),
    [anon_sym___clrcall] = ACTIONS(3623),
    [anon_sym___stdcall] = ACTIONS(3623),
    [anon_sym___fastcall] = ACTIONS(3623),
    [anon_sym___thiscall] = ACTIONS(3623),
    [anon_sym___vectorcall] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3621),
    [anon_sym_signed] = ACTIONS(3623),
    [anon_sym_unsigned] = ACTIONS(3623),
    [anon_sym_long] = ACTIONS(3623),
    [anon_sym_short] = ACTIONS(3623),
    [anon_sym_LBRACK] = ACTIONS(3623),
    [anon_sym_static] = ACTIONS(3623),
    [anon_sym_register] = ACTIONS(3623),
    [anon_sym_inline] = ACTIONS(3623),
    [anon_sym___inline] = ACTIONS(3623),
    [anon_sym___inline__] = ACTIONS(3623),
    [anon_sym___forceinline] = ACTIONS(3623),
    [anon_sym_thread_local] = ACTIONS(3623),
    [anon_sym___thread] = ACTIONS(3623),
    [anon_sym_const] = ACTIONS(3623),
    [anon_sym_constexpr] = ACTIONS(3623),
    [anon_sym_volatile] = ACTIONS(3623),
    [anon_sym_restrict] = ACTIONS(3623),
    [anon_sym___restrict__] = ACTIONS(3623),
    [anon_sym__Atomic] = ACTIONS(3623),
    [anon_sym__Noreturn] = ACTIONS(3623),
    [anon_sym_noreturn] = ACTIONS(3623),
    [anon_sym__Nonnull] = ACTIONS(3623),
    [anon_sym_mutable] = ACTIONS(3623),
    [anon_sym_constinit] = ACTIONS(3623),
    [anon_sym_consteval] = ACTIONS(3623),
    [anon_sym_alignas] = ACTIONS(3623),
    [anon_sym__Alignas] = ACTIONS(3623),
    [sym_primitive_type] = ACTIONS(3623),
    [anon_sym_enum] = ACTIONS(3623),
    [anon_sym_class] = ACTIONS(3623),
    [anon_sym_struct] = ACTIONS(3623),
    [anon_sym_union] = ACTIONS(3623),
    [anon_sym_if] = ACTIONS(3623),
    [anon_sym_else] = ACTIONS(3623),
    [anon_sym_switch] = ACTIONS(3623),
    [anon_sym_case] = ACTIONS(3623),
    [anon_sym_default] = ACTIONS(3623),
    [anon_sym_while] = ACTIONS(3623),
    [anon_sym_do] = ACTIONS(3623),
    [anon_sym_for] = ACTIONS(3623),
    [anon_sym_return] = ACTIONS(3623),
    [anon_sym_break] = ACTIONS(3623),
    [anon_sym_continue] = ACTIONS(3623),
    [anon_sym_goto] = ACTIONS(3623),
    [anon_sym___try] = ACTIONS(3623),
    [anon_sym___leave] = ACTIONS(3623),
    [anon_sym_not] = ACTIONS(3623),
    [anon_sym_compl] = ACTIONS(3623),
    [anon_sym_DASH_DASH] = ACTIONS(3621),
    [anon_sym_PLUS_PLUS] = ACTIONS(3621),
    [anon_sym_sizeof] = ACTIONS(3623),
    [anon_sym___alignof__] = ACTIONS(3623),
    [anon_sym___alignof] = ACTIONS(3623),
    [anon_sym__alignof] = ACTIONS(3623),
    [anon_sym_alignof] = ACTIONS(3623),
    [anon_sym__Alignof] = ACTIONS(3623),
    [anon_sym_offsetof] = ACTIONS(3623),
    [anon_sym__Generic] = ACTIONS(3623),
    [anon_sym_asm] = ACTIONS(3623),
    [anon_sym___asm__] = ACTIONS(3623),
    [anon_sym___asm] = ACTIONS(3623),
    [sym_number_literal] = ACTIONS(3621),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3621),
    [anon_sym_u_DQUOTE] = ACTIONS(3621),
    [anon_sym_U_DQUOTE] = ACTIONS(3621),
    [anon_sym_u8_DQUOTE] = ACTIONS(3621),
    [anon_sym_DQUOTE] = ACTIONS(3621),
    [sym_true] = ACTIONS(3623),
    [sym_false] = ACTIONS(3623),
    [anon_sym_NULL] = ACTIONS(3623),
    [anon_sym_nullptr] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3623),
    [anon_sym_let] = ACTIONS(3623),
    [anon_sym_This] = ACTIONS(3623),
    [anon_sym_decltype] = ACTIONS(3623),
    [anon_sym_explicit] = ACTIONS(3623),
    [anon_sym_typename] = ACTIONS(3623),
    [anon_sym_template] = ACTIONS(3623),
    [anon_sym_operator] = ACTIONS(3623),
    [anon_sym_try] = ACTIONS(3623),
    [anon_sym_delete] = ACTIONS(3623),
    [anon_sym_throw] = ACTIONS(3623),
    [anon_sym_namespace] = ACTIONS(3623),
    [anon_sym_static_assert] = ACTIONS(3623),
    [anon_sym_concept] = ACTIONS(3623),
    [anon_sym_co_return] = ACTIONS(3623),
    [anon_sym_co_yield] = ACTIONS(3623),
    [anon_sym_R_DQUOTE] = ACTIONS(3621),
    [anon_sym_LR_DQUOTE] = ACTIONS(3621),
    [anon_sym_uR_DQUOTE] = ACTIONS(3621),
    [anon_sym_UR_DQUOTE] = ACTIONS(3621),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3621),
    [anon_sym_co_await] = ACTIONS(3623),
    [anon_sym_new] = ACTIONS(3623),
    [anon_sym_requires] = ACTIONS(3623),
    [sym_this] = ACTIONS(3623),
    [anon_sym_discard] = ACTIONS(3623),
    [anon_sym_precise] = ACTIONS(3623),
    [anon_sym_shared] = ACTIONS(3623),
    [anon_sym_groupshared] = ACTIONS(3623),
    [anon_sym_uniform] = ACTIONS(3623),
    [anon_sym_row_major] = ACTIONS(3623),
    [anon_sym_column_major] = ACTIONS(3623),
    [anon_sym_globallycoherent] = ACTIONS(3623),
    [anon_sym_centroid] = ACTIONS(3623),
    [anon_sym_noperspective] = ACTIONS(3623),
    [anon_sym_nointerpolation] = ACTIONS(3623),
    [anon_sym_sample] = ACTIONS(3623),
    [anon_sym_linear] = ACTIONS(3623),
    [anon_sym_snorm] = ACTIONS(3623),
    [anon_sym_unorm] = ACTIONS(3623),
    [anon_sym_point] = ACTIONS(3623),
    [anon_sym_line] = ACTIONS(3623),
    [anon_sym_triangleadj] = ACTIONS(3623),
    [anon_sym_lineadj] = ACTIONS(3623),
    [anon_sym_triangle] = ACTIONS(3623),
    [anon_sym_cbuffer] = ACTIONS(3623),
    [anon_sym_interface] = ACTIONS(3623),
    [anon_sym_extension] = ACTIONS(3623),
  },
  [751] = {
    [sym_identifier] = ACTIONS(3623),
    [aux_sym_preproc_include_token1] = ACTIONS(3623),
    [aux_sym_preproc_def_token1] = ACTIONS(3623),
    [aux_sym_preproc_if_token1] = ACTIONS(3623),
    [aux_sym_preproc_if_token2] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3623),
    [sym_preproc_directive] = ACTIONS(3623),
    [anon_sym_LPAREN2] = ACTIONS(3621),
    [anon_sym_BANG] = ACTIONS(3621),
    [anon_sym_TILDE] = ACTIONS(3621),
    [anon_sym_DASH] = ACTIONS(3623),
    [anon_sym_PLUS] = ACTIONS(3623),
    [anon_sym_STAR] = ACTIONS(3621),
    [anon_sym_AMP_AMP] = ACTIONS(3621),
    [anon_sym_AMP] = ACTIONS(3623),
    [anon_sym_SEMI] = ACTIONS(3621),
    [anon_sym___extension__] = ACTIONS(3623),
    [anon_sym_typedef] = ACTIONS(3623),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_out] = ACTIONS(3623),
    [anon_sym_inout] = ACTIONS(3623),
    [anon_sym_virtual] = ACTIONS(3623),
    [anon_sym_extern] = ACTIONS(3623),
    [anon_sym___attribute__] = ACTIONS(3623),
    [anon_sym___attribute] = ACTIONS(3623),
    [anon_sym_using] = ACTIONS(3623),
    [anon_sym_COLON_COLON] = ACTIONS(3621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3621),
    [anon_sym___declspec] = ACTIONS(3623),
    [anon_sym___based] = ACTIONS(3623),
    [anon_sym___cdecl] = ACTIONS(3623),
    [anon_sym___clrcall] = ACTIONS(3623),
    [anon_sym___stdcall] = ACTIONS(3623),
    [anon_sym___fastcall] = ACTIONS(3623),
    [anon_sym___thiscall] = ACTIONS(3623),
    [anon_sym___vectorcall] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3621),
    [anon_sym_signed] = ACTIONS(3623),
    [anon_sym_unsigned] = ACTIONS(3623),
    [anon_sym_long] = ACTIONS(3623),
    [anon_sym_short] = ACTIONS(3623),
    [anon_sym_LBRACK] = ACTIONS(3623),
    [anon_sym_static] = ACTIONS(3623),
    [anon_sym_register] = ACTIONS(3623),
    [anon_sym_inline] = ACTIONS(3623),
    [anon_sym___inline] = ACTIONS(3623),
    [anon_sym___inline__] = ACTIONS(3623),
    [anon_sym___forceinline] = ACTIONS(3623),
    [anon_sym_thread_local] = ACTIONS(3623),
    [anon_sym___thread] = ACTIONS(3623),
    [anon_sym_const] = ACTIONS(3623),
    [anon_sym_constexpr] = ACTIONS(3623),
    [anon_sym_volatile] = ACTIONS(3623),
    [anon_sym_restrict] = ACTIONS(3623),
    [anon_sym___restrict__] = ACTIONS(3623),
    [anon_sym__Atomic] = ACTIONS(3623),
    [anon_sym__Noreturn] = ACTIONS(3623),
    [anon_sym_noreturn] = ACTIONS(3623),
    [anon_sym__Nonnull] = ACTIONS(3623),
    [anon_sym_mutable] = ACTIONS(3623),
    [anon_sym_constinit] = ACTIONS(3623),
    [anon_sym_consteval] = ACTIONS(3623),
    [anon_sym_alignas] = ACTIONS(3623),
    [anon_sym__Alignas] = ACTIONS(3623),
    [sym_primitive_type] = ACTIONS(3623),
    [anon_sym_enum] = ACTIONS(3623),
    [anon_sym_class] = ACTIONS(3623),
    [anon_sym_struct] = ACTIONS(3623),
    [anon_sym_union] = ACTIONS(3623),
    [anon_sym_if] = ACTIONS(3623),
    [anon_sym_else] = ACTIONS(3623),
    [anon_sym_switch] = ACTIONS(3623),
    [anon_sym_case] = ACTIONS(3623),
    [anon_sym_default] = ACTIONS(3623),
    [anon_sym_while] = ACTIONS(3623),
    [anon_sym_do] = ACTIONS(3623),
    [anon_sym_for] = ACTIONS(3623),
    [anon_sym_return] = ACTIONS(3623),
    [anon_sym_break] = ACTIONS(3623),
    [anon_sym_continue] = ACTIONS(3623),
    [anon_sym_goto] = ACTIONS(3623),
    [anon_sym___try] = ACTIONS(3623),
    [anon_sym___leave] = ACTIONS(3623),
    [anon_sym_not] = ACTIONS(3623),
    [anon_sym_compl] = ACTIONS(3623),
    [anon_sym_DASH_DASH] = ACTIONS(3621),
    [anon_sym_PLUS_PLUS] = ACTIONS(3621),
    [anon_sym_sizeof] = ACTIONS(3623),
    [anon_sym___alignof__] = ACTIONS(3623),
    [anon_sym___alignof] = ACTIONS(3623),
    [anon_sym__alignof] = ACTIONS(3623),
    [anon_sym_alignof] = ACTIONS(3623),
    [anon_sym__Alignof] = ACTIONS(3623),
    [anon_sym_offsetof] = ACTIONS(3623),
    [anon_sym__Generic] = ACTIONS(3623),
    [anon_sym_asm] = ACTIONS(3623),
    [anon_sym___asm__] = ACTIONS(3623),
    [anon_sym___asm] = ACTIONS(3623),
    [sym_number_literal] = ACTIONS(3621),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3621),
    [anon_sym_u_DQUOTE] = ACTIONS(3621),
    [anon_sym_U_DQUOTE] = ACTIONS(3621),
    [anon_sym_u8_DQUOTE] = ACTIONS(3621),
    [anon_sym_DQUOTE] = ACTIONS(3621),
    [sym_true] = ACTIONS(3623),
    [sym_false] = ACTIONS(3623),
    [anon_sym_NULL] = ACTIONS(3623),
    [anon_sym_nullptr] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3623),
    [anon_sym_let] = ACTIONS(3623),
    [anon_sym_This] = ACTIONS(3623),
    [anon_sym_decltype] = ACTIONS(3623),
    [anon_sym_explicit] = ACTIONS(3623),
    [anon_sym_typename] = ACTIONS(3623),
    [anon_sym_template] = ACTIONS(3623),
    [anon_sym_operator] = ACTIONS(3623),
    [anon_sym_try] = ACTIONS(3623),
    [anon_sym_delete] = ACTIONS(3623),
    [anon_sym_throw] = ACTIONS(3623),
    [anon_sym_namespace] = ACTIONS(3623),
    [anon_sym_static_assert] = ACTIONS(3623),
    [anon_sym_concept] = ACTIONS(3623),
    [anon_sym_co_return] = ACTIONS(3623),
    [anon_sym_co_yield] = ACTIONS(3623),
    [anon_sym_R_DQUOTE] = ACTIONS(3621),
    [anon_sym_LR_DQUOTE] = ACTIONS(3621),
    [anon_sym_uR_DQUOTE] = ACTIONS(3621),
    [anon_sym_UR_DQUOTE] = ACTIONS(3621),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3621),
    [anon_sym_co_await] = ACTIONS(3623),
    [anon_sym_new] = ACTIONS(3623),
    [anon_sym_requires] = ACTIONS(3623),
    [sym_this] = ACTIONS(3623),
    [anon_sym_discard] = ACTIONS(3623),
    [anon_sym_precise] = ACTIONS(3623),
    [anon_sym_shared] = ACTIONS(3623),
    [anon_sym_groupshared] = ACTIONS(3623),
    [anon_sym_uniform] = ACTIONS(3623),
    [anon_sym_row_major] = ACTIONS(3623),
    [anon_sym_column_major] = ACTIONS(3623),
    [anon_sym_globallycoherent] = ACTIONS(3623),
    [anon_sym_centroid] = ACTIONS(3623),
    [anon_sym_noperspective] = ACTIONS(3623),
    [anon_sym_nointerpolation] = ACTIONS(3623),
    [anon_sym_sample] = ACTIONS(3623),
    [anon_sym_linear] = ACTIONS(3623),
    [anon_sym_snorm] = ACTIONS(3623),
    [anon_sym_unorm] = ACTIONS(3623),
    [anon_sym_point] = ACTIONS(3623),
    [anon_sym_line] = ACTIONS(3623),
    [anon_sym_triangleadj] = ACTIONS(3623),
    [anon_sym_lineadj] = ACTIONS(3623),
    [anon_sym_triangle] = ACTIONS(3623),
    [anon_sym_cbuffer] = ACTIONS(3623),
    [anon_sym_interface] = ACTIONS(3623),
    [anon_sym_extension] = ACTIONS(3623),
  },
  [752] = {
    [sym_identifier] = ACTIONS(3399),
    [aux_sym_preproc_include_token1] = ACTIONS(3399),
    [aux_sym_preproc_def_token1] = ACTIONS(3399),
    [aux_sym_preproc_if_token1] = ACTIONS(3399),
    [aux_sym_preproc_if_token2] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3399),
    [sym_preproc_directive] = ACTIONS(3399),
    [anon_sym_LPAREN2] = ACTIONS(3401),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_STAR] = ACTIONS(3401),
    [anon_sym_AMP_AMP] = ACTIONS(3401),
    [anon_sym_AMP] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym___extension__] = ACTIONS(3399),
    [anon_sym_typedef] = ACTIONS(3399),
    [anon_sym_in] = ACTIONS(3399),
    [anon_sym_out] = ACTIONS(3399),
    [anon_sym_inout] = ACTIONS(3399),
    [anon_sym_virtual] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym___attribute__] = ACTIONS(3399),
    [anon_sym___attribute] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_COLON_COLON] = ACTIONS(3401),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3401),
    [anon_sym___declspec] = ACTIONS(3399),
    [anon_sym___based] = ACTIONS(3399),
    [anon_sym___cdecl] = ACTIONS(3399),
    [anon_sym___clrcall] = ACTIONS(3399),
    [anon_sym___stdcall] = ACTIONS(3399),
    [anon_sym___fastcall] = ACTIONS(3399),
    [anon_sym___thiscall] = ACTIONS(3399),
    [anon_sym___vectorcall] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_signed] = ACTIONS(3399),
    [anon_sym_unsigned] = ACTIONS(3399),
    [anon_sym_long] = ACTIONS(3399),
    [anon_sym_short] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_register] = ACTIONS(3399),
    [anon_sym_inline] = ACTIONS(3399),
    [anon_sym___inline] = ACTIONS(3399),
    [anon_sym___inline__] = ACTIONS(3399),
    [anon_sym___forceinline] = ACTIONS(3399),
    [anon_sym_thread_local] = ACTIONS(3399),
    [anon_sym___thread] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_constexpr] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym_restrict] = ACTIONS(3399),
    [anon_sym___restrict__] = ACTIONS(3399),
    [anon_sym__Atomic] = ACTIONS(3399),
    [anon_sym__Noreturn] = ACTIONS(3399),
    [anon_sym_noreturn] = ACTIONS(3399),
    [anon_sym__Nonnull] = ACTIONS(3399),
    [anon_sym_mutable] = ACTIONS(3399),
    [anon_sym_constinit] = ACTIONS(3399),
    [anon_sym_consteval] = ACTIONS(3399),
    [anon_sym_alignas] = ACTIONS(3399),
    [anon_sym__Alignas] = ACTIONS(3399),
    [sym_primitive_type] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_union] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_else] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_case] = ACTIONS(3399),
    [anon_sym_default] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_goto] = ACTIONS(3399),
    [anon_sym___try] = ACTIONS(3399),
    [anon_sym___leave] = ACTIONS(3399),
    [anon_sym_not] = ACTIONS(3399),
    [anon_sym_compl] = ACTIONS(3399),
    [anon_sym_DASH_DASH] = ACTIONS(3401),
    [anon_sym_PLUS_PLUS] = ACTIONS(3401),
    [anon_sym_sizeof] = ACTIONS(3399),
    [anon_sym___alignof__] = ACTIONS(3399),
    [anon_sym___alignof] = ACTIONS(3399),
    [anon_sym__alignof] = ACTIONS(3399),
    [anon_sym_alignof] = ACTIONS(3399),
    [anon_sym__Alignof] = ACTIONS(3399),
    [anon_sym_offsetof] = ACTIONS(3399),
    [anon_sym__Generic] = ACTIONS(3399),
    [anon_sym_asm] = ACTIONS(3399),
    [anon_sym___asm__] = ACTIONS(3399),
    [anon_sym___asm] = ACTIONS(3399),
    [sym_number_literal] = ACTIONS(3401),
    [anon_sym_L_SQUOTE] = ACTIONS(3401),
    [anon_sym_u_SQUOTE] = ACTIONS(3401),
    [anon_sym_U_SQUOTE] = ACTIONS(3401),
    [anon_sym_u8_SQUOTE] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(3401),
    [anon_sym_L_DQUOTE] = ACTIONS(3401),
    [anon_sym_u_DQUOTE] = ACTIONS(3401),
    [anon_sym_U_DQUOTE] = ACTIONS(3401),
    [anon_sym_u8_DQUOTE] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [sym_true] = ACTIONS(3399),
    [sym_false] = ACTIONS(3399),
    [anon_sym_NULL] = ACTIONS(3399),
    [anon_sym_nullptr] = ACTIONS(3399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_This] = ACTIONS(3399),
    [anon_sym_decltype] = ACTIONS(3399),
    [anon_sym_explicit] = ACTIONS(3399),
    [anon_sym_typename] = ACTIONS(3399),
    [anon_sym_template] = ACTIONS(3399),
    [anon_sym_operator] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_delete] = ACTIONS(3399),
    [anon_sym_throw] = ACTIONS(3399),
    [anon_sym_namespace] = ACTIONS(3399),
    [anon_sym_static_assert] = ACTIONS(3399),
    [anon_sym_concept] = ACTIONS(3399),
    [anon_sym_co_return] = ACTIONS(3399),
    [anon_sym_co_yield] = ACTIONS(3399),
    [anon_sym_R_DQUOTE] = ACTIONS(3401),
    [anon_sym_LR_DQUOTE] = ACTIONS(3401),
    [anon_sym_uR_DQUOTE] = ACTIONS(3401),
    [anon_sym_UR_DQUOTE] = ACTIONS(3401),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3401),
    [anon_sym_co_await] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_requires] = ACTIONS(3399),
    [sym_this] = ACTIONS(3399),
    [anon_sym_discard] = ACTIONS(3399),
    [anon_sym_precise] = ACTIONS(3399),
    [anon_sym_shared] = ACTIONS(3399),
    [anon_sym_groupshared] = ACTIONS(3399),
    [anon_sym_uniform] = ACTIONS(3399),
    [anon_sym_row_major] = ACTIONS(3399),
    [anon_sym_column_major] = ACTIONS(3399),
    [anon_sym_globallycoherent] = ACTIONS(3399),
    [anon_sym_centroid] = ACTIONS(3399),
    [anon_sym_noperspective] = ACTIONS(3399),
    [anon_sym_nointerpolation] = ACTIONS(3399),
    [anon_sym_sample] = ACTIONS(3399),
    [anon_sym_linear] = ACTIONS(3399),
    [anon_sym_snorm] = ACTIONS(3399),
    [anon_sym_unorm] = ACTIONS(3399),
    [anon_sym_point] = ACTIONS(3399),
    [anon_sym_line] = ACTIONS(3399),
    [anon_sym_triangleadj] = ACTIONS(3399),
    [anon_sym_lineadj] = ACTIONS(3399),
    [anon_sym_triangle] = ACTIONS(3399),
    [anon_sym_cbuffer] = ACTIONS(3399),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_extension] = ACTIONS(3399),
  },
  [753] = {
    [sym_identifier] = ACTIONS(3399),
    [aux_sym_preproc_include_token1] = ACTIONS(3399),
    [aux_sym_preproc_def_token1] = ACTIONS(3399),
    [aux_sym_preproc_if_token1] = ACTIONS(3399),
    [aux_sym_preproc_if_token2] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3399),
    [sym_preproc_directive] = ACTIONS(3399),
    [anon_sym_LPAREN2] = ACTIONS(3401),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_STAR] = ACTIONS(3401),
    [anon_sym_AMP_AMP] = ACTIONS(3401),
    [anon_sym_AMP] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym___extension__] = ACTIONS(3399),
    [anon_sym_typedef] = ACTIONS(3399),
    [anon_sym_in] = ACTIONS(3399),
    [anon_sym_out] = ACTIONS(3399),
    [anon_sym_inout] = ACTIONS(3399),
    [anon_sym_virtual] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym___attribute__] = ACTIONS(3399),
    [anon_sym___attribute] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_COLON_COLON] = ACTIONS(3401),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3401),
    [anon_sym___declspec] = ACTIONS(3399),
    [anon_sym___based] = ACTIONS(3399),
    [anon_sym___cdecl] = ACTIONS(3399),
    [anon_sym___clrcall] = ACTIONS(3399),
    [anon_sym___stdcall] = ACTIONS(3399),
    [anon_sym___fastcall] = ACTIONS(3399),
    [anon_sym___thiscall] = ACTIONS(3399),
    [anon_sym___vectorcall] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_signed] = ACTIONS(3399),
    [anon_sym_unsigned] = ACTIONS(3399),
    [anon_sym_long] = ACTIONS(3399),
    [anon_sym_short] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_register] = ACTIONS(3399),
    [anon_sym_inline] = ACTIONS(3399),
    [anon_sym___inline] = ACTIONS(3399),
    [anon_sym___inline__] = ACTIONS(3399),
    [anon_sym___forceinline] = ACTIONS(3399),
    [anon_sym_thread_local] = ACTIONS(3399),
    [anon_sym___thread] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_constexpr] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym_restrict] = ACTIONS(3399),
    [anon_sym___restrict__] = ACTIONS(3399),
    [anon_sym__Atomic] = ACTIONS(3399),
    [anon_sym__Noreturn] = ACTIONS(3399),
    [anon_sym_noreturn] = ACTIONS(3399),
    [anon_sym__Nonnull] = ACTIONS(3399),
    [anon_sym_mutable] = ACTIONS(3399),
    [anon_sym_constinit] = ACTIONS(3399),
    [anon_sym_consteval] = ACTIONS(3399),
    [anon_sym_alignas] = ACTIONS(3399),
    [anon_sym__Alignas] = ACTIONS(3399),
    [sym_primitive_type] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_union] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_else] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_case] = ACTIONS(3399),
    [anon_sym_default] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_goto] = ACTIONS(3399),
    [anon_sym___try] = ACTIONS(3399),
    [anon_sym___leave] = ACTIONS(3399),
    [anon_sym_not] = ACTIONS(3399),
    [anon_sym_compl] = ACTIONS(3399),
    [anon_sym_DASH_DASH] = ACTIONS(3401),
    [anon_sym_PLUS_PLUS] = ACTIONS(3401),
    [anon_sym_sizeof] = ACTIONS(3399),
    [anon_sym___alignof__] = ACTIONS(3399),
    [anon_sym___alignof] = ACTIONS(3399),
    [anon_sym__alignof] = ACTIONS(3399),
    [anon_sym_alignof] = ACTIONS(3399),
    [anon_sym__Alignof] = ACTIONS(3399),
    [anon_sym_offsetof] = ACTIONS(3399),
    [anon_sym__Generic] = ACTIONS(3399),
    [anon_sym_asm] = ACTIONS(3399),
    [anon_sym___asm__] = ACTIONS(3399),
    [anon_sym___asm] = ACTIONS(3399),
    [sym_number_literal] = ACTIONS(3401),
    [anon_sym_L_SQUOTE] = ACTIONS(3401),
    [anon_sym_u_SQUOTE] = ACTIONS(3401),
    [anon_sym_U_SQUOTE] = ACTIONS(3401),
    [anon_sym_u8_SQUOTE] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(3401),
    [anon_sym_L_DQUOTE] = ACTIONS(3401),
    [anon_sym_u_DQUOTE] = ACTIONS(3401),
    [anon_sym_U_DQUOTE] = ACTIONS(3401),
    [anon_sym_u8_DQUOTE] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [sym_true] = ACTIONS(3399),
    [sym_false] = ACTIONS(3399),
    [anon_sym_NULL] = ACTIONS(3399),
    [anon_sym_nullptr] = ACTIONS(3399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_This] = ACTIONS(3399),
    [anon_sym_decltype] = ACTIONS(3399),
    [anon_sym_explicit] = ACTIONS(3399),
    [anon_sym_typename] = ACTIONS(3399),
    [anon_sym_template] = ACTIONS(3399),
    [anon_sym_operator] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_delete] = ACTIONS(3399),
    [anon_sym_throw] = ACTIONS(3399),
    [anon_sym_namespace] = ACTIONS(3399),
    [anon_sym_static_assert] = ACTIONS(3399),
    [anon_sym_concept] = ACTIONS(3399),
    [anon_sym_co_return] = ACTIONS(3399),
    [anon_sym_co_yield] = ACTIONS(3399),
    [anon_sym_R_DQUOTE] = ACTIONS(3401),
    [anon_sym_LR_DQUOTE] = ACTIONS(3401),
    [anon_sym_uR_DQUOTE] = ACTIONS(3401),
    [anon_sym_UR_DQUOTE] = ACTIONS(3401),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3401),
    [anon_sym_co_await] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_requires] = ACTIONS(3399),
    [sym_this] = ACTIONS(3399),
    [anon_sym_discard] = ACTIONS(3399),
    [anon_sym_precise] = ACTIONS(3399),
    [anon_sym_shared] = ACTIONS(3399),
    [anon_sym_groupshared] = ACTIONS(3399),
    [anon_sym_uniform] = ACTIONS(3399),
    [anon_sym_row_major] = ACTIONS(3399),
    [anon_sym_column_major] = ACTIONS(3399),
    [anon_sym_globallycoherent] = ACTIONS(3399),
    [anon_sym_centroid] = ACTIONS(3399),
    [anon_sym_noperspective] = ACTIONS(3399),
    [anon_sym_nointerpolation] = ACTIONS(3399),
    [anon_sym_sample] = ACTIONS(3399),
    [anon_sym_linear] = ACTIONS(3399),
    [anon_sym_snorm] = ACTIONS(3399),
    [anon_sym_unorm] = ACTIONS(3399),
    [anon_sym_point] = ACTIONS(3399),
    [anon_sym_line] = ACTIONS(3399),
    [anon_sym_triangleadj] = ACTIONS(3399),
    [anon_sym_lineadj] = ACTIONS(3399),
    [anon_sym_triangle] = ACTIONS(3399),
    [anon_sym_cbuffer] = ACTIONS(3399),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_extension] = ACTIONS(3399),
  },
  [754] = {
    [sym_identifier] = ACTIONS(3014),
    [aux_sym_preproc_include_token1] = ACTIONS(3014),
    [aux_sym_preproc_def_token1] = ACTIONS(3014),
    [aux_sym_preproc_if_token1] = ACTIONS(3014),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3014),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3014),
    [sym_preproc_directive] = ACTIONS(3014),
    [anon_sym_LPAREN2] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3012),
    [anon_sym_TILDE] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_STAR] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym___extension__] = ACTIONS(3014),
    [anon_sym_typedef] = ACTIONS(3014),
    [anon_sym_in] = ACTIONS(3014),
    [anon_sym_out] = ACTIONS(3014),
    [anon_sym_inout] = ACTIONS(3014),
    [anon_sym_virtual] = ACTIONS(3014),
    [anon_sym_extern] = ACTIONS(3014),
    [anon_sym___attribute__] = ACTIONS(3014),
    [anon_sym___attribute] = ACTIONS(3014),
    [anon_sym_using] = ACTIONS(3014),
    [anon_sym_COLON_COLON] = ACTIONS(3012),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3012),
    [anon_sym___declspec] = ACTIONS(3014),
    [anon_sym___based] = ACTIONS(3014),
    [anon_sym___cdecl] = ACTIONS(3014),
    [anon_sym___clrcall] = ACTIONS(3014),
    [anon_sym___stdcall] = ACTIONS(3014),
    [anon_sym___fastcall] = ACTIONS(3014),
    [anon_sym___thiscall] = ACTIONS(3014),
    [anon_sym___vectorcall] = ACTIONS(3014),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_RBRACE] = ACTIONS(3012),
    [anon_sym_signed] = ACTIONS(3014),
    [anon_sym_unsigned] = ACTIONS(3014),
    [anon_sym_long] = ACTIONS(3014),
    [anon_sym_short] = ACTIONS(3014),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_static] = ACTIONS(3014),
    [anon_sym_register] = ACTIONS(3014),
    [anon_sym_inline] = ACTIONS(3014),
    [anon_sym___inline] = ACTIONS(3014),
    [anon_sym___inline__] = ACTIONS(3014),
    [anon_sym___forceinline] = ACTIONS(3014),
    [anon_sym_thread_local] = ACTIONS(3014),
    [anon_sym___thread] = ACTIONS(3014),
    [anon_sym_const] = ACTIONS(3014),
    [anon_sym_constexpr] = ACTIONS(3014),
    [anon_sym_volatile] = ACTIONS(3014),
    [anon_sym_restrict] = ACTIONS(3014),
    [anon_sym___restrict__] = ACTIONS(3014),
    [anon_sym__Atomic] = ACTIONS(3014),
    [anon_sym__Noreturn] = ACTIONS(3014),
    [anon_sym_noreturn] = ACTIONS(3014),
    [anon_sym__Nonnull] = ACTIONS(3014),
    [anon_sym_mutable] = ACTIONS(3014),
    [anon_sym_constinit] = ACTIONS(3014),
    [anon_sym_consteval] = ACTIONS(3014),
    [anon_sym_alignas] = ACTIONS(3014),
    [anon_sym__Alignas] = ACTIONS(3014),
    [sym_primitive_type] = ACTIONS(3014),
    [anon_sym_enum] = ACTIONS(3014),
    [anon_sym_class] = ACTIONS(3014),
    [anon_sym_struct] = ACTIONS(3014),
    [anon_sym_union] = ACTIONS(3014),
    [anon_sym_if] = ACTIONS(3014),
    [anon_sym_switch] = ACTIONS(3014),
    [anon_sym_case] = ACTIONS(3014),
    [anon_sym_default] = ACTIONS(3014),
    [anon_sym_while] = ACTIONS(3014),
    [anon_sym_do] = ACTIONS(3014),
    [anon_sym_for] = ACTIONS(3014),
    [anon_sym_return] = ACTIONS(3014),
    [anon_sym_break] = ACTIONS(3014),
    [anon_sym_continue] = ACTIONS(3014),
    [anon_sym_goto] = ACTIONS(3014),
    [anon_sym___try] = ACTIONS(3014),
    [anon_sym___leave] = ACTIONS(3014),
    [anon_sym_not] = ACTIONS(3014),
    [anon_sym_compl] = ACTIONS(3014),
    [anon_sym_DASH_DASH] = ACTIONS(3012),
    [anon_sym_PLUS_PLUS] = ACTIONS(3012),
    [anon_sym_sizeof] = ACTIONS(3014),
    [anon_sym___alignof__] = ACTIONS(3014),
    [anon_sym___alignof] = ACTIONS(3014),
    [anon_sym__alignof] = ACTIONS(3014),
    [anon_sym_alignof] = ACTIONS(3014),
    [anon_sym__Alignof] = ACTIONS(3014),
    [anon_sym_offsetof] = ACTIONS(3014),
    [anon_sym__Generic] = ACTIONS(3014),
    [anon_sym_asm] = ACTIONS(3014),
    [anon_sym___asm__] = ACTIONS(3014),
    [anon_sym___asm] = ACTIONS(3014),
    [anon_sym_DOT] = ACTIONS(3014),
    [sym_number_literal] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3012),
    [anon_sym_u_SQUOTE] = ACTIONS(3012),
    [anon_sym_U_SQUOTE] = ACTIONS(3012),
    [anon_sym_u8_SQUOTE] = ACTIONS(3012),
    [anon_sym_SQUOTE] = ACTIONS(3012),
    [anon_sym_L_DQUOTE] = ACTIONS(3012),
    [anon_sym_u_DQUOTE] = ACTIONS(3012),
    [anon_sym_U_DQUOTE] = ACTIONS(3012),
    [anon_sym_u8_DQUOTE] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [sym_true] = ACTIONS(3014),
    [sym_false] = ACTIONS(3014),
    [anon_sym_NULL] = ACTIONS(3014),
    [anon_sym_nullptr] = ACTIONS(3014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3014),
    [anon_sym_let] = ACTIONS(3014),
    [anon_sym_This] = ACTIONS(3014),
    [anon_sym_decltype] = ACTIONS(3014),
    [anon_sym_explicit] = ACTIONS(3014),
    [anon_sym_typename] = ACTIONS(3014),
    [anon_sym_template] = ACTIONS(3014),
    [anon_sym_operator] = ACTIONS(3014),
    [anon_sym_try] = ACTIONS(3014),
    [anon_sym_delete] = ACTIONS(3014),
    [anon_sym_throw] = ACTIONS(3014),
    [anon_sym_namespace] = ACTIONS(3014),
    [anon_sym_static_assert] = ACTIONS(3014),
    [anon_sym_concept] = ACTIONS(3014),
    [anon_sym_co_return] = ACTIONS(3014),
    [anon_sym_co_yield] = ACTIONS(3014),
    [anon_sym_R_DQUOTE] = ACTIONS(3012),
    [anon_sym_LR_DQUOTE] = ACTIONS(3012),
    [anon_sym_uR_DQUOTE] = ACTIONS(3012),
    [anon_sym_UR_DQUOTE] = ACTIONS(3012),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3012),
    [anon_sym_co_await] = ACTIONS(3014),
    [anon_sym_new] = ACTIONS(3014),
    [anon_sym_requires] = ACTIONS(3014),
    [sym_this] = ACTIONS(3014),
    [anon_sym_discard] = ACTIONS(3014),
    [anon_sym_precise] = ACTIONS(3014),
    [anon_sym_shared] = ACTIONS(3014),
    [anon_sym_groupshared] = ACTIONS(3014),
    [anon_sym_uniform] = ACTIONS(3014),
    [anon_sym_row_major] = ACTIONS(3014),
    [anon_sym_column_major] = ACTIONS(3014),
    [anon_sym_globallycoherent] = ACTIONS(3014),
    [anon_sym_centroid] = ACTIONS(3014),
    [anon_sym_noperspective] = ACTIONS(3014),
    [anon_sym_nointerpolation] = ACTIONS(3014),
    [anon_sym_sample] = ACTIONS(3014),
    [anon_sym_linear] = ACTIONS(3014),
    [anon_sym_snorm] = ACTIONS(3014),
    [anon_sym_unorm] = ACTIONS(3014),
    [anon_sym_point] = ACTIONS(3014),
    [anon_sym_line] = ACTIONS(3014),
    [anon_sym_triangleadj] = ACTIONS(3014),
    [anon_sym_lineadj] = ACTIONS(3014),
    [anon_sym_triangle] = ACTIONS(3014),
    [anon_sym_cbuffer] = ACTIONS(3014),
    [anon_sym_interface] = ACTIONS(3014),
    [anon_sym_extension] = ACTIONS(3014),
  },
  [755] = {
    [sym_identifier] = ACTIONS(2883),
    [aux_sym_preproc_include_token1] = ACTIONS(2883),
    [aux_sym_preproc_def_token1] = ACTIONS(2883),
    [aux_sym_preproc_if_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2883),
    [sym_preproc_directive] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_typedef] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_using] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2881),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_RBRACE] = ACTIONS(2881),
    [anon_sym_signed] = ACTIONS(2883),
    [anon_sym_unsigned] = ACTIONS(2883),
    [anon_sym_long] = ACTIONS(2883),
    [anon_sym_short] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [sym_primitive_type] = ACTIONS(2883),
    [anon_sym_enum] = ACTIONS(2883),
    [anon_sym_class] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2883),
    [anon_sym_union] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_switch] = ACTIONS(2883),
    [anon_sym_case] = ACTIONS(2883),
    [anon_sym_default] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_break] = ACTIONS(2883),
    [anon_sym_continue] = ACTIONS(2883),
    [anon_sym_goto] = ACTIONS(2883),
    [anon_sym___try] = ACTIONS(2883),
    [anon_sym___leave] = ACTIONS(2883),
    [anon_sym_not] = ACTIONS(2883),
    [anon_sym_compl] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_sizeof] = ACTIONS(2883),
    [anon_sym___alignof__] = ACTIONS(2883),
    [anon_sym___alignof] = ACTIONS(2883),
    [anon_sym__alignof] = ACTIONS(2883),
    [anon_sym_alignof] = ACTIONS(2883),
    [anon_sym__Alignof] = ACTIONS(2883),
    [anon_sym_offsetof] = ACTIONS(2883),
    [anon_sym__Generic] = ACTIONS(2883),
    [anon_sym_asm] = ACTIONS(2883),
    [anon_sym___asm__] = ACTIONS(2883),
    [anon_sym___asm] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [sym_number_literal] = ACTIONS(2881),
    [anon_sym_L_SQUOTE] = ACTIONS(2881),
    [anon_sym_u_SQUOTE] = ACTIONS(2881),
    [anon_sym_U_SQUOTE] = ACTIONS(2881),
    [anon_sym_u8_SQUOTE] = ACTIONS(2881),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_L_DQUOTE] = ACTIONS(2881),
    [anon_sym_u_DQUOTE] = ACTIONS(2881),
    [anon_sym_U_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [sym_true] = ACTIONS(2883),
    [sym_false] = ACTIONS(2883),
    [anon_sym_NULL] = ACTIONS(2883),
    [anon_sym_nullptr] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_explicit] = ACTIONS(2883),
    [anon_sym_typename] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_delete] = ACTIONS(2883),
    [anon_sym_throw] = ACTIONS(2883),
    [anon_sym_namespace] = ACTIONS(2883),
    [anon_sym_static_assert] = ACTIONS(2883),
    [anon_sym_concept] = ACTIONS(2883),
    [anon_sym_co_return] = ACTIONS(2883),
    [anon_sym_co_yield] = ACTIONS(2883),
    [anon_sym_R_DQUOTE] = ACTIONS(2881),
    [anon_sym_LR_DQUOTE] = ACTIONS(2881),
    [anon_sym_uR_DQUOTE] = ACTIONS(2881),
    [anon_sym_UR_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2881),
    [anon_sym_co_await] = ACTIONS(2883),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_requires] = ACTIONS(2883),
    [sym_this] = ACTIONS(2883),
    [anon_sym_discard] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
    [anon_sym_cbuffer] = ACTIONS(2883),
    [anon_sym_interface] = ACTIONS(2883),
    [anon_sym_extension] = ACTIONS(2883),
  },
  [756] = {
    [sym_identifier] = ACTIONS(2883),
    [aux_sym_preproc_include_token1] = ACTIONS(2883),
    [aux_sym_preproc_def_token1] = ACTIONS(2883),
    [aux_sym_preproc_if_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2883),
    [sym_preproc_directive] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_typedef] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_using] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_RBRACE] = ACTIONS(2881),
    [anon_sym_signed] = ACTIONS(2883),
    [anon_sym_unsigned] = ACTIONS(2883),
    [anon_sym_long] = ACTIONS(2883),
    [anon_sym_short] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [sym_primitive_type] = ACTIONS(2883),
    [anon_sym_enum] = ACTIONS(2883),
    [anon_sym_class] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2883),
    [anon_sym_union] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_switch] = ACTIONS(2883),
    [anon_sym_case] = ACTIONS(2883),
    [anon_sym_default] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_break] = ACTIONS(2883),
    [anon_sym_continue] = ACTIONS(2883),
    [anon_sym_goto] = ACTIONS(2883),
    [anon_sym___try] = ACTIONS(2883),
    [anon_sym___leave] = ACTIONS(2883),
    [anon_sym_not] = ACTIONS(2883),
    [anon_sym_compl] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_sizeof] = ACTIONS(2883),
    [anon_sym___alignof__] = ACTIONS(2883),
    [anon_sym___alignof] = ACTIONS(2883),
    [anon_sym__alignof] = ACTIONS(2883),
    [anon_sym_alignof] = ACTIONS(2883),
    [anon_sym__Alignof] = ACTIONS(2883),
    [anon_sym_offsetof] = ACTIONS(2883),
    [anon_sym__Generic] = ACTIONS(2883),
    [anon_sym_asm] = ACTIONS(2883),
    [anon_sym___asm__] = ACTIONS(2883),
    [anon_sym___asm] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [sym_number_literal] = ACTIONS(2881),
    [anon_sym_L_SQUOTE] = ACTIONS(2881),
    [anon_sym_u_SQUOTE] = ACTIONS(2881),
    [anon_sym_U_SQUOTE] = ACTIONS(2881),
    [anon_sym_u8_SQUOTE] = ACTIONS(2881),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_L_DQUOTE] = ACTIONS(2881),
    [anon_sym_u_DQUOTE] = ACTIONS(2881),
    [anon_sym_U_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [sym_true] = ACTIONS(2883),
    [sym_false] = ACTIONS(2883),
    [anon_sym_NULL] = ACTIONS(2883),
    [anon_sym_nullptr] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_explicit] = ACTIONS(2883),
    [anon_sym_typename] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_delete] = ACTIONS(2883),
    [anon_sym_throw] = ACTIONS(2883),
    [anon_sym_namespace] = ACTIONS(2883),
    [anon_sym_static_assert] = ACTIONS(2883),
    [anon_sym_concept] = ACTIONS(2883),
    [anon_sym_co_return] = ACTIONS(2883),
    [anon_sym_co_yield] = ACTIONS(2883),
    [anon_sym_R_DQUOTE] = ACTIONS(2881),
    [anon_sym_LR_DQUOTE] = ACTIONS(2881),
    [anon_sym_uR_DQUOTE] = ACTIONS(2881),
    [anon_sym_UR_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2881),
    [anon_sym_co_await] = ACTIONS(2883),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_requires] = ACTIONS(2883),
    [sym_this] = ACTIONS(2883),
    [anon_sym_discard] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
    [anon_sym_cbuffer] = ACTIONS(2883),
    [anon_sym_interface] = ACTIONS(2883),
    [anon_sym_extension] = ACTIONS(2883),
  },
  [757] = {
    [sym_identifier] = ACTIONS(3631),
    [aux_sym_preproc_include_token1] = ACTIONS(3631),
    [aux_sym_preproc_def_token1] = ACTIONS(3631),
    [aux_sym_preproc_if_token1] = ACTIONS(3631),
    [aux_sym_preproc_if_token2] = ACTIONS(3631),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3631),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3631),
    [sym_preproc_directive] = ACTIONS(3631),
    [anon_sym_LPAREN2] = ACTIONS(3629),
    [anon_sym_BANG] = ACTIONS(3629),
    [anon_sym_TILDE] = ACTIONS(3629),
    [anon_sym_DASH] = ACTIONS(3631),
    [anon_sym_PLUS] = ACTIONS(3631),
    [anon_sym_STAR] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_AMP] = ACTIONS(3631),
    [anon_sym_SEMI] = ACTIONS(3629),
    [anon_sym___extension__] = ACTIONS(3631),
    [anon_sym_typedef] = ACTIONS(3631),
    [anon_sym_in] = ACTIONS(3631),
    [anon_sym_out] = ACTIONS(3631),
    [anon_sym_inout] = ACTIONS(3631),
    [anon_sym_virtual] = ACTIONS(3631),
    [anon_sym_extern] = ACTIONS(3631),
    [anon_sym___attribute__] = ACTIONS(3631),
    [anon_sym___attribute] = ACTIONS(3631),
    [anon_sym_using] = ACTIONS(3631),
    [anon_sym_COLON_COLON] = ACTIONS(3629),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3629),
    [anon_sym___declspec] = ACTIONS(3631),
    [anon_sym___based] = ACTIONS(3631),
    [anon_sym___cdecl] = ACTIONS(3631),
    [anon_sym___clrcall] = ACTIONS(3631),
    [anon_sym___stdcall] = ACTIONS(3631),
    [anon_sym___fastcall] = ACTIONS(3631),
    [anon_sym___thiscall] = ACTIONS(3631),
    [anon_sym___vectorcall] = ACTIONS(3631),
    [anon_sym_LBRACE] = ACTIONS(3629),
    [anon_sym_signed] = ACTIONS(3631),
    [anon_sym_unsigned] = ACTIONS(3631),
    [anon_sym_long] = ACTIONS(3631),
    [anon_sym_short] = ACTIONS(3631),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_static] = ACTIONS(3631),
    [anon_sym_register] = ACTIONS(3631),
    [anon_sym_inline] = ACTIONS(3631),
    [anon_sym___inline] = ACTIONS(3631),
    [anon_sym___inline__] = ACTIONS(3631),
    [anon_sym___forceinline] = ACTIONS(3631),
    [anon_sym_thread_local] = ACTIONS(3631),
    [anon_sym___thread] = ACTIONS(3631),
    [anon_sym_const] = ACTIONS(3631),
    [anon_sym_constexpr] = ACTIONS(3631),
    [anon_sym_volatile] = ACTIONS(3631),
    [anon_sym_restrict] = ACTIONS(3631),
    [anon_sym___restrict__] = ACTIONS(3631),
    [anon_sym__Atomic] = ACTIONS(3631),
    [anon_sym__Noreturn] = ACTIONS(3631),
    [anon_sym_noreturn] = ACTIONS(3631),
    [anon_sym__Nonnull] = ACTIONS(3631),
    [anon_sym_mutable] = ACTIONS(3631),
    [anon_sym_constinit] = ACTIONS(3631),
    [anon_sym_consteval] = ACTIONS(3631),
    [anon_sym_alignas] = ACTIONS(3631),
    [anon_sym__Alignas] = ACTIONS(3631),
    [sym_primitive_type] = ACTIONS(3631),
    [anon_sym_enum] = ACTIONS(3631),
    [anon_sym_class] = ACTIONS(3631),
    [anon_sym_struct] = ACTIONS(3631),
    [anon_sym_union] = ACTIONS(3631),
    [anon_sym_if] = ACTIONS(3631),
    [anon_sym_else] = ACTIONS(3631),
    [anon_sym_switch] = ACTIONS(3631),
    [anon_sym_case] = ACTIONS(3631),
    [anon_sym_default] = ACTIONS(3631),
    [anon_sym_while] = ACTIONS(3631),
    [anon_sym_do] = ACTIONS(3631),
    [anon_sym_for] = ACTIONS(3631),
    [anon_sym_return] = ACTIONS(3631),
    [anon_sym_break] = ACTIONS(3631),
    [anon_sym_continue] = ACTIONS(3631),
    [anon_sym_goto] = ACTIONS(3631),
    [anon_sym___try] = ACTIONS(3631),
    [anon_sym___leave] = ACTIONS(3631),
    [anon_sym_not] = ACTIONS(3631),
    [anon_sym_compl] = ACTIONS(3631),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_sizeof] = ACTIONS(3631),
    [anon_sym___alignof__] = ACTIONS(3631),
    [anon_sym___alignof] = ACTIONS(3631),
    [anon_sym__alignof] = ACTIONS(3631),
    [anon_sym_alignof] = ACTIONS(3631),
    [anon_sym__Alignof] = ACTIONS(3631),
    [anon_sym_offsetof] = ACTIONS(3631),
    [anon_sym__Generic] = ACTIONS(3631),
    [anon_sym_asm] = ACTIONS(3631),
    [anon_sym___asm__] = ACTIONS(3631),
    [anon_sym___asm] = ACTIONS(3631),
    [sym_number_literal] = ACTIONS(3629),
    [anon_sym_L_SQUOTE] = ACTIONS(3629),
    [anon_sym_u_SQUOTE] = ACTIONS(3629),
    [anon_sym_U_SQUOTE] = ACTIONS(3629),
    [anon_sym_u8_SQUOTE] = ACTIONS(3629),
    [anon_sym_SQUOTE] = ACTIONS(3629),
    [anon_sym_L_DQUOTE] = ACTIONS(3629),
    [anon_sym_u_DQUOTE] = ACTIONS(3629),
    [anon_sym_U_DQUOTE] = ACTIONS(3629),
    [anon_sym_u8_DQUOTE] = ACTIONS(3629),
    [anon_sym_DQUOTE] = ACTIONS(3629),
    [sym_true] = ACTIONS(3631),
    [sym_false] = ACTIONS(3631),
    [anon_sym_NULL] = ACTIONS(3631),
    [anon_sym_nullptr] = ACTIONS(3631),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3631),
    [anon_sym_let] = ACTIONS(3631),
    [anon_sym_This] = ACTIONS(3631),
    [anon_sym_decltype] = ACTIONS(3631),
    [anon_sym_explicit] = ACTIONS(3631),
    [anon_sym_typename] = ACTIONS(3631),
    [anon_sym_template] = ACTIONS(3631),
    [anon_sym_operator] = ACTIONS(3631),
    [anon_sym_try] = ACTIONS(3631),
    [anon_sym_delete] = ACTIONS(3631),
    [anon_sym_throw] = ACTIONS(3631),
    [anon_sym_namespace] = ACTIONS(3631),
    [anon_sym_static_assert] = ACTIONS(3631),
    [anon_sym_concept] = ACTIONS(3631),
    [anon_sym_co_return] = ACTIONS(3631),
    [anon_sym_co_yield] = ACTIONS(3631),
    [anon_sym_R_DQUOTE] = ACTIONS(3629),
    [anon_sym_LR_DQUOTE] = ACTIONS(3629),
    [anon_sym_uR_DQUOTE] = ACTIONS(3629),
    [anon_sym_UR_DQUOTE] = ACTIONS(3629),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3629),
    [anon_sym_co_await] = ACTIONS(3631),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3631),
    [sym_this] = ACTIONS(3631),
    [anon_sym_discard] = ACTIONS(3631),
    [anon_sym_precise] = ACTIONS(3631),
    [anon_sym_shared] = ACTIONS(3631),
    [anon_sym_groupshared] = ACTIONS(3631),
    [anon_sym_uniform] = ACTIONS(3631),
    [anon_sym_row_major] = ACTIONS(3631),
    [anon_sym_column_major] = ACTIONS(3631),
    [anon_sym_globallycoherent] = ACTIONS(3631),
    [anon_sym_centroid] = ACTIONS(3631),
    [anon_sym_noperspective] = ACTIONS(3631),
    [anon_sym_nointerpolation] = ACTIONS(3631),
    [anon_sym_sample] = ACTIONS(3631),
    [anon_sym_linear] = ACTIONS(3631),
    [anon_sym_snorm] = ACTIONS(3631),
    [anon_sym_unorm] = ACTIONS(3631),
    [anon_sym_point] = ACTIONS(3631),
    [anon_sym_line] = ACTIONS(3631),
    [anon_sym_triangleadj] = ACTIONS(3631),
    [anon_sym_lineadj] = ACTIONS(3631),
    [anon_sym_triangle] = ACTIONS(3631),
    [anon_sym_cbuffer] = ACTIONS(3631),
    [anon_sym_interface] = ACTIONS(3631),
    [anon_sym_extension] = ACTIONS(3631),
  },
  [758] = {
    [sym_identifier] = ACTIONS(2938),
    [aux_sym_preproc_include_token1] = ACTIONS(2938),
    [aux_sym_preproc_def_token1] = ACTIONS(2938),
    [aux_sym_preproc_if_token1] = ACTIONS(2938),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2938),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2938),
    [sym_preproc_directive] = ACTIONS(2938),
    [anon_sym_LPAREN2] = ACTIONS(2936),
    [anon_sym_BANG] = ACTIONS(2936),
    [anon_sym_TILDE] = ACTIONS(2936),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_STAR] = ACTIONS(2936),
    [anon_sym_AMP_AMP] = ACTIONS(2936),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_SEMI] = ACTIONS(2936),
    [anon_sym___extension__] = ACTIONS(2938),
    [anon_sym_typedef] = ACTIONS(2938),
    [anon_sym_in] = ACTIONS(2938),
    [anon_sym_out] = ACTIONS(2938),
    [anon_sym_inout] = ACTIONS(2938),
    [anon_sym_virtual] = ACTIONS(2938),
    [anon_sym_extern] = ACTIONS(2938),
    [anon_sym___attribute__] = ACTIONS(2938),
    [anon_sym___attribute] = ACTIONS(2938),
    [anon_sym_using] = ACTIONS(2938),
    [anon_sym_COLON_COLON] = ACTIONS(2936),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2936),
    [anon_sym___declspec] = ACTIONS(2938),
    [anon_sym___based] = ACTIONS(2938),
    [anon_sym___cdecl] = ACTIONS(2938),
    [anon_sym___clrcall] = ACTIONS(2938),
    [anon_sym___stdcall] = ACTIONS(2938),
    [anon_sym___fastcall] = ACTIONS(2938),
    [anon_sym___thiscall] = ACTIONS(2938),
    [anon_sym___vectorcall] = ACTIONS(2938),
    [anon_sym_LBRACE] = ACTIONS(2936),
    [anon_sym_RBRACE] = ACTIONS(2936),
    [anon_sym_signed] = ACTIONS(2938),
    [anon_sym_unsigned] = ACTIONS(2938),
    [anon_sym_long] = ACTIONS(2938),
    [anon_sym_short] = ACTIONS(2938),
    [anon_sym_LBRACK] = ACTIONS(2938),
    [anon_sym_static] = ACTIONS(2938),
    [anon_sym_register] = ACTIONS(2938),
    [anon_sym_inline] = ACTIONS(2938),
    [anon_sym___inline] = ACTIONS(2938),
    [anon_sym___inline__] = ACTIONS(2938),
    [anon_sym___forceinline] = ACTIONS(2938),
    [anon_sym_thread_local] = ACTIONS(2938),
    [anon_sym___thread] = ACTIONS(2938),
    [anon_sym_const] = ACTIONS(2938),
    [anon_sym_constexpr] = ACTIONS(2938),
    [anon_sym_volatile] = ACTIONS(2938),
    [anon_sym_restrict] = ACTIONS(2938),
    [anon_sym___restrict__] = ACTIONS(2938),
    [anon_sym__Atomic] = ACTIONS(2938),
    [anon_sym__Noreturn] = ACTIONS(2938),
    [anon_sym_noreturn] = ACTIONS(2938),
    [anon_sym__Nonnull] = ACTIONS(2938),
    [anon_sym_mutable] = ACTIONS(2938),
    [anon_sym_constinit] = ACTIONS(2938),
    [anon_sym_consteval] = ACTIONS(2938),
    [anon_sym_alignas] = ACTIONS(2938),
    [anon_sym__Alignas] = ACTIONS(2938),
    [sym_primitive_type] = ACTIONS(2938),
    [anon_sym_enum] = ACTIONS(2938),
    [anon_sym_class] = ACTIONS(2938),
    [anon_sym_struct] = ACTIONS(2938),
    [anon_sym_union] = ACTIONS(2938),
    [anon_sym_if] = ACTIONS(2938),
    [anon_sym_switch] = ACTIONS(2938),
    [anon_sym_case] = ACTIONS(2938),
    [anon_sym_default] = ACTIONS(2938),
    [anon_sym_while] = ACTIONS(2938),
    [anon_sym_do] = ACTIONS(2938),
    [anon_sym_for] = ACTIONS(2938),
    [anon_sym_return] = ACTIONS(2938),
    [anon_sym_break] = ACTIONS(2938),
    [anon_sym_continue] = ACTIONS(2938),
    [anon_sym_goto] = ACTIONS(2938),
    [anon_sym___try] = ACTIONS(2938),
    [anon_sym___leave] = ACTIONS(2938),
    [anon_sym_not] = ACTIONS(2938),
    [anon_sym_compl] = ACTIONS(2938),
    [anon_sym_DASH_DASH] = ACTIONS(2936),
    [anon_sym_PLUS_PLUS] = ACTIONS(2936),
    [anon_sym_sizeof] = ACTIONS(2938),
    [anon_sym___alignof__] = ACTIONS(2938),
    [anon_sym___alignof] = ACTIONS(2938),
    [anon_sym__alignof] = ACTIONS(2938),
    [anon_sym_alignof] = ACTIONS(2938),
    [anon_sym__Alignof] = ACTIONS(2938),
    [anon_sym_offsetof] = ACTIONS(2938),
    [anon_sym__Generic] = ACTIONS(2938),
    [anon_sym_asm] = ACTIONS(2938),
    [anon_sym___asm__] = ACTIONS(2938),
    [anon_sym___asm] = ACTIONS(2938),
    [anon_sym_DOT] = ACTIONS(2938),
    [sym_number_literal] = ACTIONS(2936),
    [anon_sym_L_SQUOTE] = ACTIONS(2936),
    [anon_sym_u_SQUOTE] = ACTIONS(2936),
    [anon_sym_U_SQUOTE] = ACTIONS(2936),
    [anon_sym_u8_SQUOTE] = ACTIONS(2936),
    [anon_sym_SQUOTE] = ACTIONS(2936),
    [anon_sym_L_DQUOTE] = ACTIONS(2936),
    [anon_sym_u_DQUOTE] = ACTIONS(2936),
    [anon_sym_U_DQUOTE] = ACTIONS(2936),
    [anon_sym_u8_DQUOTE] = ACTIONS(2936),
    [anon_sym_DQUOTE] = ACTIONS(2936),
    [sym_true] = ACTIONS(2938),
    [sym_false] = ACTIONS(2938),
    [anon_sym_NULL] = ACTIONS(2938),
    [anon_sym_nullptr] = ACTIONS(2938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2938),
    [anon_sym_let] = ACTIONS(2938),
    [anon_sym_This] = ACTIONS(2938),
    [anon_sym_decltype] = ACTIONS(2938),
    [anon_sym_explicit] = ACTIONS(2938),
    [anon_sym_typename] = ACTIONS(2938),
    [anon_sym_template] = ACTIONS(2938),
    [anon_sym_operator] = ACTIONS(2938),
    [anon_sym_try] = ACTIONS(2938),
    [anon_sym_delete] = ACTIONS(2938),
    [anon_sym_throw] = ACTIONS(2938),
    [anon_sym_namespace] = ACTIONS(2938),
    [anon_sym_static_assert] = ACTIONS(2938),
    [anon_sym_concept] = ACTIONS(2938),
    [anon_sym_co_return] = ACTIONS(2938),
    [anon_sym_co_yield] = ACTIONS(2938),
    [anon_sym_R_DQUOTE] = ACTIONS(2936),
    [anon_sym_LR_DQUOTE] = ACTIONS(2936),
    [anon_sym_uR_DQUOTE] = ACTIONS(2936),
    [anon_sym_UR_DQUOTE] = ACTIONS(2936),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2936),
    [anon_sym_co_await] = ACTIONS(2938),
    [anon_sym_new] = ACTIONS(2938),
    [anon_sym_requires] = ACTIONS(2938),
    [sym_this] = ACTIONS(2938),
    [anon_sym_discard] = ACTIONS(2938),
    [anon_sym_precise] = ACTIONS(2938),
    [anon_sym_shared] = ACTIONS(2938),
    [anon_sym_groupshared] = ACTIONS(2938),
    [anon_sym_uniform] = ACTIONS(2938),
    [anon_sym_row_major] = ACTIONS(2938),
    [anon_sym_column_major] = ACTIONS(2938),
    [anon_sym_globallycoherent] = ACTIONS(2938),
    [anon_sym_centroid] = ACTIONS(2938),
    [anon_sym_noperspective] = ACTIONS(2938),
    [anon_sym_nointerpolation] = ACTIONS(2938),
    [anon_sym_sample] = ACTIONS(2938),
    [anon_sym_linear] = ACTIONS(2938),
    [anon_sym_snorm] = ACTIONS(2938),
    [anon_sym_unorm] = ACTIONS(2938),
    [anon_sym_point] = ACTIONS(2938),
    [anon_sym_line] = ACTIONS(2938),
    [anon_sym_triangleadj] = ACTIONS(2938),
    [anon_sym_lineadj] = ACTIONS(2938),
    [anon_sym_triangle] = ACTIONS(2938),
    [anon_sym_cbuffer] = ACTIONS(2938),
    [anon_sym_interface] = ACTIONS(2938),
    [anon_sym_extension] = ACTIONS(2938),
  },
  [759] = {
    [sym_identifier] = ACTIONS(2942),
    [aux_sym_preproc_include_token1] = ACTIONS(2942),
    [aux_sym_preproc_def_token1] = ACTIONS(2942),
    [aux_sym_preproc_if_token1] = ACTIONS(2942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2942),
    [sym_preproc_directive] = ACTIONS(2942),
    [anon_sym_LPAREN2] = ACTIONS(2940),
    [anon_sym_BANG] = ACTIONS(2940),
    [anon_sym_TILDE] = ACTIONS(2940),
    [anon_sym_DASH] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(2940),
    [anon_sym_AMP_AMP] = ACTIONS(2940),
    [anon_sym_AMP] = ACTIONS(2942),
    [anon_sym_SEMI] = ACTIONS(2940),
    [anon_sym___extension__] = ACTIONS(2942),
    [anon_sym_typedef] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_out] = ACTIONS(2942),
    [anon_sym_inout] = ACTIONS(2942),
    [anon_sym_virtual] = ACTIONS(2942),
    [anon_sym_extern] = ACTIONS(2942),
    [anon_sym___attribute__] = ACTIONS(2942),
    [anon_sym___attribute] = ACTIONS(2942),
    [anon_sym_using] = ACTIONS(2942),
    [anon_sym_COLON_COLON] = ACTIONS(2940),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2940),
    [anon_sym___declspec] = ACTIONS(2942),
    [anon_sym___based] = ACTIONS(2942),
    [anon_sym___cdecl] = ACTIONS(2942),
    [anon_sym___clrcall] = ACTIONS(2942),
    [anon_sym___stdcall] = ACTIONS(2942),
    [anon_sym___fastcall] = ACTIONS(2942),
    [anon_sym___thiscall] = ACTIONS(2942),
    [anon_sym___vectorcall] = ACTIONS(2942),
    [anon_sym_LBRACE] = ACTIONS(2940),
    [anon_sym_RBRACE] = ACTIONS(2940),
    [anon_sym_signed] = ACTIONS(2942),
    [anon_sym_unsigned] = ACTIONS(2942),
    [anon_sym_long] = ACTIONS(2942),
    [anon_sym_short] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(2942),
    [anon_sym_static] = ACTIONS(2942),
    [anon_sym_register] = ACTIONS(2942),
    [anon_sym_inline] = ACTIONS(2942),
    [anon_sym___inline] = ACTIONS(2942),
    [anon_sym___inline__] = ACTIONS(2942),
    [anon_sym___forceinline] = ACTIONS(2942),
    [anon_sym_thread_local] = ACTIONS(2942),
    [anon_sym___thread] = ACTIONS(2942),
    [anon_sym_const] = ACTIONS(2942),
    [anon_sym_constexpr] = ACTIONS(2942),
    [anon_sym_volatile] = ACTIONS(2942),
    [anon_sym_restrict] = ACTIONS(2942),
    [anon_sym___restrict__] = ACTIONS(2942),
    [anon_sym__Atomic] = ACTIONS(2942),
    [anon_sym__Noreturn] = ACTIONS(2942),
    [anon_sym_noreturn] = ACTIONS(2942),
    [anon_sym__Nonnull] = ACTIONS(2942),
    [anon_sym_mutable] = ACTIONS(2942),
    [anon_sym_constinit] = ACTIONS(2942),
    [anon_sym_consteval] = ACTIONS(2942),
    [anon_sym_alignas] = ACTIONS(2942),
    [anon_sym__Alignas] = ACTIONS(2942),
    [sym_primitive_type] = ACTIONS(2942),
    [anon_sym_enum] = ACTIONS(2942),
    [anon_sym_class] = ACTIONS(2942),
    [anon_sym_struct] = ACTIONS(2942),
    [anon_sym_union] = ACTIONS(2942),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_switch] = ACTIONS(2942),
    [anon_sym_case] = ACTIONS(2942),
    [anon_sym_default] = ACTIONS(2942),
    [anon_sym_while] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(2942),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_return] = ACTIONS(2942),
    [anon_sym_break] = ACTIONS(2942),
    [anon_sym_continue] = ACTIONS(2942),
    [anon_sym_goto] = ACTIONS(2942),
    [anon_sym___try] = ACTIONS(2942),
    [anon_sym___leave] = ACTIONS(2942),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_compl] = ACTIONS(2942),
    [anon_sym_DASH_DASH] = ACTIONS(2940),
    [anon_sym_PLUS_PLUS] = ACTIONS(2940),
    [anon_sym_sizeof] = ACTIONS(2942),
    [anon_sym___alignof__] = ACTIONS(2942),
    [anon_sym___alignof] = ACTIONS(2942),
    [anon_sym__alignof] = ACTIONS(2942),
    [anon_sym_alignof] = ACTIONS(2942),
    [anon_sym__Alignof] = ACTIONS(2942),
    [anon_sym_offsetof] = ACTIONS(2942),
    [anon_sym__Generic] = ACTIONS(2942),
    [anon_sym_asm] = ACTIONS(2942),
    [anon_sym___asm__] = ACTIONS(2942),
    [anon_sym___asm] = ACTIONS(2942),
    [anon_sym_DOT] = ACTIONS(2942),
    [sym_number_literal] = ACTIONS(2940),
    [anon_sym_L_SQUOTE] = ACTIONS(2940),
    [anon_sym_u_SQUOTE] = ACTIONS(2940),
    [anon_sym_U_SQUOTE] = ACTIONS(2940),
    [anon_sym_u8_SQUOTE] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(2940),
    [anon_sym_L_DQUOTE] = ACTIONS(2940),
    [anon_sym_u_DQUOTE] = ACTIONS(2940),
    [anon_sym_U_DQUOTE] = ACTIONS(2940),
    [anon_sym_u8_DQUOTE] = ACTIONS(2940),
    [anon_sym_DQUOTE] = ACTIONS(2940),
    [sym_true] = ACTIONS(2942),
    [sym_false] = ACTIONS(2942),
    [anon_sym_NULL] = ACTIONS(2942),
    [anon_sym_nullptr] = ACTIONS(2942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2942),
    [anon_sym_let] = ACTIONS(2942),
    [anon_sym_This] = ACTIONS(2942),
    [anon_sym_decltype] = ACTIONS(2942),
    [anon_sym_explicit] = ACTIONS(2942),
    [anon_sym_typename] = ACTIONS(2942),
    [anon_sym_template] = ACTIONS(2942),
    [anon_sym_operator] = ACTIONS(2942),
    [anon_sym_try] = ACTIONS(2942),
    [anon_sym_delete] = ACTIONS(2942),
    [anon_sym_throw] = ACTIONS(2942),
    [anon_sym_namespace] = ACTIONS(2942),
    [anon_sym_static_assert] = ACTIONS(2942),
    [anon_sym_concept] = ACTIONS(2942),
    [anon_sym_co_return] = ACTIONS(2942),
    [anon_sym_co_yield] = ACTIONS(2942),
    [anon_sym_R_DQUOTE] = ACTIONS(2940),
    [anon_sym_LR_DQUOTE] = ACTIONS(2940),
    [anon_sym_uR_DQUOTE] = ACTIONS(2940),
    [anon_sym_UR_DQUOTE] = ACTIONS(2940),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2940),
    [anon_sym_co_await] = ACTIONS(2942),
    [anon_sym_new] = ACTIONS(2942),
    [anon_sym_requires] = ACTIONS(2942),
    [sym_this] = ACTIONS(2942),
    [anon_sym_discard] = ACTIONS(2942),
    [anon_sym_precise] = ACTIONS(2942),
    [anon_sym_shared] = ACTIONS(2942),
    [anon_sym_groupshared] = ACTIONS(2942),
    [anon_sym_uniform] = ACTIONS(2942),
    [anon_sym_row_major] = ACTIONS(2942),
    [anon_sym_column_major] = ACTIONS(2942),
    [anon_sym_globallycoherent] = ACTIONS(2942),
    [anon_sym_centroid] = ACTIONS(2942),
    [anon_sym_noperspective] = ACTIONS(2942),
    [anon_sym_nointerpolation] = ACTIONS(2942),
    [anon_sym_sample] = ACTIONS(2942),
    [anon_sym_linear] = ACTIONS(2942),
    [anon_sym_snorm] = ACTIONS(2942),
    [anon_sym_unorm] = ACTIONS(2942),
    [anon_sym_point] = ACTIONS(2942),
    [anon_sym_line] = ACTIONS(2942),
    [anon_sym_triangleadj] = ACTIONS(2942),
    [anon_sym_lineadj] = ACTIONS(2942),
    [anon_sym_triangle] = ACTIONS(2942),
    [anon_sym_cbuffer] = ACTIONS(2942),
    [anon_sym_interface] = ACTIONS(2942),
    [anon_sym_extension] = ACTIONS(2942),
  },
  [760] = {
    [sym_identifier] = ACTIONS(2994),
    [aux_sym_preproc_include_token1] = ACTIONS(2994),
    [aux_sym_preproc_def_token1] = ACTIONS(2994),
    [aux_sym_preproc_if_token1] = ACTIONS(2994),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2994),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2994),
    [sym_preproc_directive] = ACTIONS(2994),
    [anon_sym_LPAREN2] = ACTIONS(2992),
    [anon_sym_BANG] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2992),
    [anon_sym_DASH] = ACTIONS(2994),
    [anon_sym_PLUS] = ACTIONS(2994),
    [anon_sym_STAR] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_AMP] = ACTIONS(2994),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym___extension__] = ACTIONS(2994),
    [anon_sym_typedef] = ACTIONS(2994),
    [anon_sym_in] = ACTIONS(2994),
    [anon_sym_out] = ACTIONS(2994),
    [anon_sym_inout] = ACTIONS(2994),
    [anon_sym_virtual] = ACTIONS(2994),
    [anon_sym_extern] = ACTIONS(2994),
    [anon_sym___attribute__] = ACTIONS(2994),
    [anon_sym___attribute] = ACTIONS(2994),
    [anon_sym_using] = ACTIONS(2994),
    [anon_sym_COLON_COLON] = ACTIONS(2992),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2992),
    [anon_sym___declspec] = ACTIONS(2994),
    [anon_sym___based] = ACTIONS(2994),
    [anon_sym___cdecl] = ACTIONS(2994),
    [anon_sym___clrcall] = ACTIONS(2994),
    [anon_sym___stdcall] = ACTIONS(2994),
    [anon_sym___fastcall] = ACTIONS(2994),
    [anon_sym___thiscall] = ACTIONS(2994),
    [anon_sym___vectorcall] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_RBRACE] = ACTIONS(2992),
    [anon_sym_signed] = ACTIONS(2994),
    [anon_sym_unsigned] = ACTIONS(2994),
    [anon_sym_long] = ACTIONS(2994),
    [anon_sym_short] = ACTIONS(2994),
    [anon_sym_LBRACK] = ACTIONS(2994),
    [anon_sym_static] = ACTIONS(2994),
    [anon_sym_register] = ACTIONS(2994),
    [anon_sym_inline] = ACTIONS(2994),
    [anon_sym___inline] = ACTIONS(2994),
    [anon_sym___inline__] = ACTIONS(2994),
    [anon_sym___forceinline] = ACTIONS(2994),
    [anon_sym_thread_local] = ACTIONS(2994),
    [anon_sym___thread] = ACTIONS(2994),
    [anon_sym_const] = ACTIONS(2994),
    [anon_sym_constexpr] = ACTIONS(2994),
    [anon_sym_volatile] = ACTIONS(2994),
    [anon_sym_restrict] = ACTIONS(2994),
    [anon_sym___restrict__] = ACTIONS(2994),
    [anon_sym__Atomic] = ACTIONS(2994),
    [anon_sym__Noreturn] = ACTIONS(2994),
    [anon_sym_noreturn] = ACTIONS(2994),
    [anon_sym__Nonnull] = ACTIONS(2994),
    [anon_sym_mutable] = ACTIONS(2994),
    [anon_sym_constinit] = ACTIONS(2994),
    [anon_sym_consteval] = ACTIONS(2994),
    [anon_sym_alignas] = ACTIONS(2994),
    [anon_sym__Alignas] = ACTIONS(2994),
    [sym_primitive_type] = ACTIONS(2994),
    [anon_sym_enum] = ACTIONS(2994),
    [anon_sym_class] = ACTIONS(2994),
    [anon_sym_struct] = ACTIONS(2994),
    [anon_sym_union] = ACTIONS(2994),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_switch] = ACTIONS(2994),
    [anon_sym_case] = ACTIONS(2994),
    [anon_sym_default] = ACTIONS(2994),
    [anon_sym_while] = ACTIONS(2994),
    [anon_sym_do] = ACTIONS(2994),
    [anon_sym_for] = ACTIONS(2994),
    [anon_sym_return] = ACTIONS(2994),
    [anon_sym_break] = ACTIONS(2994),
    [anon_sym_continue] = ACTIONS(2994),
    [anon_sym_goto] = ACTIONS(2994),
    [anon_sym___try] = ACTIONS(2994),
    [anon_sym___leave] = ACTIONS(2994),
    [anon_sym_not] = ACTIONS(2994),
    [anon_sym_compl] = ACTIONS(2994),
    [anon_sym_DASH_DASH] = ACTIONS(2992),
    [anon_sym_PLUS_PLUS] = ACTIONS(2992),
    [anon_sym_sizeof] = ACTIONS(2994),
    [anon_sym___alignof__] = ACTIONS(2994),
    [anon_sym___alignof] = ACTIONS(2994),
    [anon_sym__alignof] = ACTIONS(2994),
    [anon_sym_alignof] = ACTIONS(2994),
    [anon_sym__Alignof] = ACTIONS(2994),
    [anon_sym_offsetof] = ACTIONS(2994),
    [anon_sym__Generic] = ACTIONS(2994),
    [anon_sym_asm] = ACTIONS(2994),
    [anon_sym___asm__] = ACTIONS(2994),
    [anon_sym___asm] = ACTIONS(2994),
    [anon_sym_DOT] = ACTIONS(2994),
    [sym_number_literal] = ACTIONS(2992),
    [anon_sym_L_SQUOTE] = ACTIONS(2992),
    [anon_sym_u_SQUOTE] = ACTIONS(2992),
    [anon_sym_U_SQUOTE] = ACTIONS(2992),
    [anon_sym_u8_SQUOTE] = ACTIONS(2992),
    [anon_sym_SQUOTE] = ACTIONS(2992),
    [anon_sym_L_DQUOTE] = ACTIONS(2992),
    [anon_sym_u_DQUOTE] = ACTIONS(2992),
    [anon_sym_U_DQUOTE] = ACTIONS(2992),
    [anon_sym_u8_DQUOTE] = ACTIONS(2992),
    [anon_sym_DQUOTE] = ACTIONS(2992),
    [sym_true] = ACTIONS(2994),
    [sym_false] = ACTIONS(2994),
    [anon_sym_NULL] = ACTIONS(2994),
    [anon_sym_nullptr] = ACTIONS(2994),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2994),
    [anon_sym_let] = ACTIONS(2994),
    [anon_sym_This] = ACTIONS(2994),
    [anon_sym_decltype] = ACTIONS(2994),
    [anon_sym_explicit] = ACTIONS(2994),
    [anon_sym_typename] = ACTIONS(2994),
    [anon_sym_template] = ACTIONS(2994),
    [anon_sym_operator] = ACTIONS(2994),
    [anon_sym_try] = ACTIONS(2994),
    [anon_sym_delete] = ACTIONS(2994),
    [anon_sym_throw] = ACTIONS(2994),
    [anon_sym_namespace] = ACTIONS(2994),
    [anon_sym_static_assert] = ACTIONS(2994),
    [anon_sym_concept] = ACTIONS(2994),
    [anon_sym_co_return] = ACTIONS(2994),
    [anon_sym_co_yield] = ACTIONS(2994),
    [anon_sym_R_DQUOTE] = ACTIONS(2992),
    [anon_sym_LR_DQUOTE] = ACTIONS(2992),
    [anon_sym_uR_DQUOTE] = ACTIONS(2992),
    [anon_sym_UR_DQUOTE] = ACTIONS(2992),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2992),
    [anon_sym_co_await] = ACTIONS(2994),
    [anon_sym_new] = ACTIONS(2994),
    [anon_sym_requires] = ACTIONS(2994),
    [sym_this] = ACTIONS(2994),
    [anon_sym_discard] = ACTIONS(2994),
    [anon_sym_precise] = ACTIONS(2994),
    [anon_sym_shared] = ACTIONS(2994),
    [anon_sym_groupshared] = ACTIONS(2994),
    [anon_sym_uniform] = ACTIONS(2994),
    [anon_sym_row_major] = ACTIONS(2994),
    [anon_sym_column_major] = ACTIONS(2994),
    [anon_sym_globallycoherent] = ACTIONS(2994),
    [anon_sym_centroid] = ACTIONS(2994),
    [anon_sym_noperspective] = ACTIONS(2994),
    [anon_sym_nointerpolation] = ACTIONS(2994),
    [anon_sym_sample] = ACTIONS(2994),
    [anon_sym_linear] = ACTIONS(2994),
    [anon_sym_snorm] = ACTIONS(2994),
    [anon_sym_unorm] = ACTIONS(2994),
    [anon_sym_point] = ACTIONS(2994),
    [anon_sym_line] = ACTIONS(2994),
    [anon_sym_triangleadj] = ACTIONS(2994),
    [anon_sym_lineadj] = ACTIONS(2994),
    [anon_sym_triangle] = ACTIONS(2994),
    [anon_sym_cbuffer] = ACTIONS(2994),
    [anon_sym_interface] = ACTIONS(2994),
    [anon_sym_extension] = ACTIONS(2994),
  },
  [761] = {
    [sym_identifier] = ACTIONS(2998),
    [aux_sym_preproc_include_token1] = ACTIONS(2998),
    [aux_sym_preproc_def_token1] = ACTIONS(2998),
    [aux_sym_preproc_if_token1] = ACTIONS(2998),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2998),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2998),
    [sym_preproc_directive] = ACTIONS(2998),
    [anon_sym_LPAREN2] = ACTIONS(2996),
    [anon_sym_BANG] = ACTIONS(2996),
    [anon_sym_TILDE] = ACTIONS(2996),
    [anon_sym_DASH] = ACTIONS(2998),
    [anon_sym_PLUS] = ACTIONS(2998),
    [anon_sym_STAR] = ACTIONS(2996),
    [anon_sym_AMP_AMP] = ACTIONS(2996),
    [anon_sym_AMP] = ACTIONS(2998),
    [anon_sym_SEMI] = ACTIONS(2996),
    [anon_sym___extension__] = ACTIONS(2998),
    [anon_sym_typedef] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(2998),
    [anon_sym_out] = ACTIONS(2998),
    [anon_sym_inout] = ACTIONS(2998),
    [anon_sym_virtual] = ACTIONS(2998),
    [anon_sym_extern] = ACTIONS(2998),
    [anon_sym___attribute__] = ACTIONS(2998),
    [anon_sym___attribute] = ACTIONS(2998),
    [anon_sym_using] = ACTIONS(2998),
    [anon_sym_COLON_COLON] = ACTIONS(2996),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2996),
    [anon_sym___declspec] = ACTIONS(2998),
    [anon_sym___based] = ACTIONS(2998),
    [anon_sym___cdecl] = ACTIONS(2998),
    [anon_sym___clrcall] = ACTIONS(2998),
    [anon_sym___stdcall] = ACTIONS(2998),
    [anon_sym___fastcall] = ACTIONS(2998),
    [anon_sym___thiscall] = ACTIONS(2998),
    [anon_sym___vectorcall] = ACTIONS(2998),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_RBRACE] = ACTIONS(2996),
    [anon_sym_signed] = ACTIONS(2998),
    [anon_sym_unsigned] = ACTIONS(2998),
    [anon_sym_long] = ACTIONS(2998),
    [anon_sym_short] = ACTIONS(2998),
    [anon_sym_LBRACK] = ACTIONS(2998),
    [anon_sym_static] = ACTIONS(2998),
    [anon_sym_register] = ACTIONS(2998),
    [anon_sym_inline] = ACTIONS(2998),
    [anon_sym___inline] = ACTIONS(2998),
    [anon_sym___inline__] = ACTIONS(2998),
    [anon_sym___forceinline] = ACTIONS(2998),
    [anon_sym_thread_local] = ACTIONS(2998),
    [anon_sym___thread] = ACTIONS(2998),
    [anon_sym_const] = ACTIONS(2998),
    [anon_sym_constexpr] = ACTIONS(2998),
    [anon_sym_volatile] = ACTIONS(2998),
    [anon_sym_restrict] = ACTIONS(2998),
    [anon_sym___restrict__] = ACTIONS(2998),
    [anon_sym__Atomic] = ACTIONS(2998),
    [anon_sym__Noreturn] = ACTIONS(2998),
    [anon_sym_noreturn] = ACTIONS(2998),
    [anon_sym__Nonnull] = ACTIONS(2998),
    [anon_sym_mutable] = ACTIONS(2998),
    [anon_sym_constinit] = ACTIONS(2998),
    [anon_sym_consteval] = ACTIONS(2998),
    [anon_sym_alignas] = ACTIONS(2998),
    [anon_sym__Alignas] = ACTIONS(2998),
    [sym_primitive_type] = ACTIONS(2998),
    [anon_sym_enum] = ACTIONS(2998),
    [anon_sym_class] = ACTIONS(2998),
    [anon_sym_struct] = ACTIONS(2998),
    [anon_sym_union] = ACTIONS(2998),
    [anon_sym_if] = ACTIONS(2998),
    [anon_sym_switch] = ACTIONS(2998),
    [anon_sym_case] = ACTIONS(2998),
    [anon_sym_default] = ACTIONS(2998),
    [anon_sym_while] = ACTIONS(2998),
    [anon_sym_do] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2998),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_break] = ACTIONS(2998),
    [anon_sym_continue] = ACTIONS(2998),
    [anon_sym_goto] = ACTIONS(2998),
    [anon_sym___try] = ACTIONS(2998),
    [anon_sym___leave] = ACTIONS(2998),
    [anon_sym_not] = ACTIONS(2998),
    [anon_sym_compl] = ACTIONS(2998),
    [anon_sym_DASH_DASH] = ACTIONS(2996),
    [anon_sym_PLUS_PLUS] = ACTIONS(2996),
    [anon_sym_sizeof] = ACTIONS(2998),
    [anon_sym___alignof__] = ACTIONS(2998),
    [anon_sym___alignof] = ACTIONS(2998),
    [anon_sym__alignof] = ACTIONS(2998),
    [anon_sym_alignof] = ACTIONS(2998),
    [anon_sym__Alignof] = ACTIONS(2998),
    [anon_sym_offsetof] = ACTIONS(2998),
    [anon_sym__Generic] = ACTIONS(2998),
    [anon_sym_asm] = ACTIONS(2998),
    [anon_sym___asm__] = ACTIONS(2998),
    [anon_sym___asm] = ACTIONS(2998),
    [anon_sym_DOT] = ACTIONS(2998),
    [sym_number_literal] = ACTIONS(2996),
    [anon_sym_L_SQUOTE] = ACTIONS(2996),
    [anon_sym_u_SQUOTE] = ACTIONS(2996),
    [anon_sym_U_SQUOTE] = ACTIONS(2996),
    [anon_sym_u8_SQUOTE] = ACTIONS(2996),
    [anon_sym_SQUOTE] = ACTIONS(2996),
    [anon_sym_L_DQUOTE] = ACTIONS(2996),
    [anon_sym_u_DQUOTE] = ACTIONS(2996),
    [anon_sym_U_DQUOTE] = ACTIONS(2996),
    [anon_sym_u8_DQUOTE] = ACTIONS(2996),
    [anon_sym_DQUOTE] = ACTIONS(2996),
    [sym_true] = ACTIONS(2998),
    [sym_false] = ACTIONS(2998),
    [anon_sym_NULL] = ACTIONS(2998),
    [anon_sym_nullptr] = ACTIONS(2998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2998),
    [anon_sym_let] = ACTIONS(2998),
    [anon_sym_This] = ACTIONS(2998),
    [anon_sym_decltype] = ACTIONS(2998),
    [anon_sym_explicit] = ACTIONS(2998),
    [anon_sym_typename] = ACTIONS(2998),
    [anon_sym_template] = ACTIONS(2998),
    [anon_sym_operator] = ACTIONS(2998),
    [anon_sym_try] = ACTIONS(2998),
    [anon_sym_delete] = ACTIONS(2998),
    [anon_sym_throw] = ACTIONS(2998),
    [anon_sym_namespace] = ACTIONS(2998),
    [anon_sym_static_assert] = ACTIONS(2998),
    [anon_sym_concept] = ACTIONS(2998),
    [anon_sym_co_return] = ACTIONS(2998),
    [anon_sym_co_yield] = ACTIONS(2998),
    [anon_sym_R_DQUOTE] = ACTIONS(2996),
    [anon_sym_LR_DQUOTE] = ACTIONS(2996),
    [anon_sym_uR_DQUOTE] = ACTIONS(2996),
    [anon_sym_UR_DQUOTE] = ACTIONS(2996),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2996),
    [anon_sym_co_await] = ACTIONS(2998),
    [anon_sym_new] = ACTIONS(2998),
    [anon_sym_requires] = ACTIONS(2998),
    [sym_this] = ACTIONS(2998),
    [anon_sym_discard] = ACTIONS(2998),
    [anon_sym_precise] = ACTIONS(2998),
    [anon_sym_shared] = ACTIONS(2998),
    [anon_sym_groupshared] = ACTIONS(2998),
    [anon_sym_uniform] = ACTIONS(2998),
    [anon_sym_row_major] = ACTIONS(2998),
    [anon_sym_column_major] = ACTIONS(2998),
    [anon_sym_globallycoherent] = ACTIONS(2998),
    [anon_sym_centroid] = ACTIONS(2998),
    [anon_sym_noperspective] = ACTIONS(2998),
    [anon_sym_nointerpolation] = ACTIONS(2998),
    [anon_sym_sample] = ACTIONS(2998),
    [anon_sym_linear] = ACTIONS(2998),
    [anon_sym_snorm] = ACTIONS(2998),
    [anon_sym_unorm] = ACTIONS(2998),
    [anon_sym_point] = ACTIONS(2998),
    [anon_sym_line] = ACTIONS(2998),
    [anon_sym_triangleadj] = ACTIONS(2998),
    [anon_sym_lineadj] = ACTIONS(2998),
    [anon_sym_triangle] = ACTIONS(2998),
    [anon_sym_cbuffer] = ACTIONS(2998),
    [anon_sym_interface] = ACTIONS(2998),
    [anon_sym_extension] = ACTIONS(2998),
  },
  [762] = {
    [sym_identifier] = ACTIONS(4244),
    [aux_sym_preproc_include_token1] = ACTIONS(4244),
    [aux_sym_preproc_def_token1] = ACTIONS(4244),
    [aux_sym_preproc_if_token1] = ACTIONS(4244),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4244),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4244),
    [sym_preproc_directive] = ACTIONS(4244),
    [anon_sym_LPAREN2] = ACTIONS(4246),
    [anon_sym_BANG] = ACTIONS(4246),
    [anon_sym_TILDE] = ACTIONS(4246),
    [anon_sym_DASH] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_STAR] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym___extension__] = ACTIONS(4244),
    [anon_sym_typedef] = ACTIONS(4244),
    [anon_sym_in] = ACTIONS(4244),
    [anon_sym_out] = ACTIONS(4244),
    [anon_sym_inout] = ACTIONS(4244),
    [anon_sym_virtual] = ACTIONS(4244),
    [anon_sym_extern] = ACTIONS(4244),
    [anon_sym___attribute__] = ACTIONS(4244),
    [anon_sym___attribute] = ACTIONS(4244),
    [anon_sym_using] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4246),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4246),
    [anon_sym___declspec] = ACTIONS(4244),
    [anon_sym___based] = ACTIONS(4244),
    [anon_sym___cdecl] = ACTIONS(4244),
    [anon_sym___clrcall] = ACTIONS(4244),
    [anon_sym___stdcall] = ACTIONS(4244),
    [anon_sym___fastcall] = ACTIONS(4244),
    [anon_sym___thiscall] = ACTIONS(4244),
    [anon_sym___vectorcall] = ACTIONS(4244),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_signed] = ACTIONS(4244),
    [anon_sym_unsigned] = ACTIONS(4244),
    [anon_sym_long] = ACTIONS(4244),
    [anon_sym_short] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [anon_sym_static] = ACTIONS(4244),
    [anon_sym_register] = ACTIONS(4244),
    [anon_sym_inline] = ACTIONS(4244),
    [anon_sym___inline] = ACTIONS(4244),
    [anon_sym___inline__] = ACTIONS(4244),
    [anon_sym___forceinline] = ACTIONS(4244),
    [anon_sym_thread_local] = ACTIONS(4244),
    [anon_sym___thread] = ACTIONS(4244),
    [anon_sym_const] = ACTIONS(4244),
    [anon_sym_constexpr] = ACTIONS(4244),
    [anon_sym_volatile] = ACTIONS(4244),
    [anon_sym_restrict] = ACTIONS(4244),
    [anon_sym___restrict__] = ACTIONS(4244),
    [anon_sym__Atomic] = ACTIONS(4244),
    [anon_sym__Noreturn] = ACTIONS(4244),
    [anon_sym_noreturn] = ACTIONS(4244),
    [anon_sym__Nonnull] = ACTIONS(4244),
    [anon_sym_mutable] = ACTIONS(4244),
    [anon_sym_constinit] = ACTIONS(4244),
    [anon_sym_consteval] = ACTIONS(4244),
    [anon_sym_alignas] = ACTIONS(4244),
    [anon_sym__Alignas] = ACTIONS(4244),
    [sym_primitive_type] = ACTIONS(4244),
    [anon_sym_enum] = ACTIONS(4244),
    [anon_sym_class] = ACTIONS(4244),
    [anon_sym_struct] = ACTIONS(4244),
    [anon_sym_union] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_switch] = ACTIONS(4244),
    [anon_sym_case] = ACTIONS(4244),
    [anon_sym_default] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_break] = ACTIONS(4244),
    [anon_sym_continue] = ACTIONS(4244),
    [anon_sym_goto] = ACTIONS(4244),
    [anon_sym___try] = ACTIONS(4244),
    [anon_sym___leave] = ACTIONS(4244),
    [anon_sym_not] = ACTIONS(4244),
    [anon_sym_compl] = ACTIONS(4244),
    [anon_sym_DASH_DASH] = ACTIONS(4246),
    [anon_sym_PLUS_PLUS] = ACTIONS(4246),
    [anon_sym_sizeof] = ACTIONS(4244),
    [anon_sym___alignof__] = ACTIONS(4244),
    [anon_sym___alignof] = ACTIONS(4244),
    [anon_sym__alignof] = ACTIONS(4244),
    [anon_sym_alignof] = ACTIONS(4244),
    [anon_sym__Alignof] = ACTIONS(4244),
    [anon_sym_offsetof] = ACTIONS(4244),
    [anon_sym__Generic] = ACTIONS(4244),
    [anon_sym_asm] = ACTIONS(4244),
    [anon_sym___asm__] = ACTIONS(4244),
    [anon_sym___asm] = ACTIONS(4244),
    [anon_sym_DOT] = ACTIONS(2647),
    [sym_number_literal] = ACTIONS(4246),
    [anon_sym_L_SQUOTE] = ACTIONS(4246),
    [anon_sym_u_SQUOTE] = ACTIONS(4246),
    [anon_sym_U_SQUOTE] = ACTIONS(4246),
    [anon_sym_u8_SQUOTE] = ACTIONS(4246),
    [anon_sym_SQUOTE] = ACTIONS(4246),
    [anon_sym_L_DQUOTE] = ACTIONS(4246),
    [anon_sym_u_DQUOTE] = ACTIONS(4246),
    [anon_sym_U_DQUOTE] = ACTIONS(4246),
    [anon_sym_u8_DQUOTE] = ACTIONS(4246),
    [anon_sym_DQUOTE] = ACTIONS(4246),
    [sym_true] = ACTIONS(4244),
    [sym_false] = ACTIONS(4244),
    [anon_sym_NULL] = ACTIONS(4244),
    [anon_sym_nullptr] = ACTIONS(4244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2649),
    [anon_sym_let] = ACTIONS(2649),
    [anon_sym_This] = ACTIONS(2649),
    [anon_sym_decltype] = ACTIONS(4244),
    [anon_sym_explicit] = ACTIONS(4244),
    [anon_sym_typename] = ACTIONS(4244),
    [anon_sym_template] = ACTIONS(4244),
    [anon_sym_operator] = ACTIONS(4244),
    [anon_sym_try] = ACTIONS(4244),
    [anon_sym_delete] = ACTIONS(4244),
    [anon_sym_throw] = ACTIONS(4244),
    [anon_sym_namespace] = ACTIONS(4244),
    [anon_sym_static_assert] = ACTIONS(4244),
    [anon_sym_concept] = ACTIONS(4244),
    [anon_sym_co_return] = ACTIONS(4244),
    [anon_sym_co_yield] = ACTIONS(4244),
    [anon_sym_R_DQUOTE] = ACTIONS(4246),
    [anon_sym_LR_DQUOTE] = ACTIONS(4246),
    [anon_sym_uR_DQUOTE] = ACTIONS(4246),
    [anon_sym_UR_DQUOTE] = ACTIONS(4246),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4246),
    [anon_sym_co_await] = ACTIONS(4244),
    [anon_sym_new] = ACTIONS(4244),
    [anon_sym_requires] = ACTIONS(4244),
    [sym_this] = ACTIONS(4244),
    [anon_sym_discard] = ACTIONS(4244),
    [anon_sym_precise] = ACTIONS(4244),
    [anon_sym_shared] = ACTIONS(4244),
    [anon_sym_groupshared] = ACTIONS(4244),
    [anon_sym_uniform] = ACTIONS(4244),
    [anon_sym_row_major] = ACTIONS(4244),
    [anon_sym_column_major] = ACTIONS(4244),
    [anon_sym_globallycoherent] = ACTIONS(4244),
    [anon_sym_centroid] = ACTIONS(4244),
    [anon_sym_noperspective] = ACTIONS(4244),
    [anon_sym_nointerpolation] = ACTIONS(4244),
    [anon_sym_sample] = ACTIONS(4244),
    [anon_sym_linear] = ACTIONS(4244),
    [anon_sym_snorm] = ACTIONS(4244),
    [anon_sym_unorm] = ACTIONS(4244),
    [anon_sym_point] = ACTIONS(4244),
    [anon_sym_line] = ACTIONS(4244),
    [anon_sym_triangleadj] = ACTIONS(4244),
    [anon_sym_lineadj] = ACTIONS(4244),
    [anon_sym_triangle] = ACTIONS(4244),
    [anon_sym_cbuffer] = ACTIONS(4244),
    [anon_sym_interface] = ACTIONS(4244),
    [anon_sym_extension] = ACTIONS(4244),
  },
  [763] = {
    [sym_identifier] = ACTIONS(2948),
    [aux_sym_preproc_include_token1] = ACTIONS(2948),
    [aux_sym_preproc_def_token1] = ACTIONS(2948),
    [aux_sym_preproc_if_token1] = ACTIONS(2948),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2948),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2948),
    [sym_preproc_directive] = ACTIONS(2948),
    [anon_sym_LPAREN2] = ACTIONS(2946),
    [anon_sym_BANG] = ACTIONS(2946),
    [anon_sym_TILDE] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2948),
    [anon_sym_PLUS] = ACTIONS(2948),
    [anon_sym_STAR] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym___extension__] = ACTIONS(2948),
    [anon_sym_typedef] = ACTIONS(2948),
    [anon_sym_in] = ACTIONS(2948),
    [anon_sym_out] = ACTIONS(2948),
    [anon_sym_inout] = ACTIONS(2948),
    [anon_sym_virtual] = ACTIONS(2948),
    [anon_sym_extern] = ACTIONS(2948),
    [anon_sym___attribute__] = ACTIONS(2948),
    [anon_sym___attribute] = ACTIONS(2948),
    [anon_sym_using] = ACTIONS(2948),
    [anon_sym_COLON_COLON] = ACTIONS(2946),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2946),
    [anon_sym___declspec] = ACTIONS(2948),
    [anon_sym___based] = ACTIONS(2948),
    [anon_sym___cdecl] = ACTIONS(2948),
    [anon_sym___clrcall] = ACTIONS(2948),
    [anon_sym___stdcall] = ACTIONS(2948),
    [anon_sym___fastcall] = ACTIONS(2948),
    [anon_sym___thiscall] = ACTIONS(2948),
    [anon_sym___vectorcall] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_RBRACE] = ACTIONS(2946),
    [anon_sym_signed] = ACTIONS(2948),
    [anon_sym_unsigned] = ACTIONS(2948),
    [anon_sym_long] = ACTIONS(2948),
    [anon_sym_short] = ACTIONS(2948),
    [anon_sym_LBRACK] = ACTIONS(2948),
    [anon_sym_static] = ACTIONS(2948),
    [anon_sym_register] = ACTIONS(2948),
    [anon_sym_inline] = ACTIONS(2948),
    [anon_sym___inline] = ACTIONS(2948),
    [anon_sym___inline__] = ACTIONS(2948),
    [anon_sym___forceinline] = ACTIONS(2948),
    [anon_sym_thread_local] = ACTIONS(2948),
    [anon_sym___thread] = ACTIONS(2948),
    [anon_sym_const] = ACTIONS(2948),
    [anon_sym_constexpr] = ACTIONS(2948),
    [anon_sym_volatile] = ACTIONS(2948),
    [anon_sym_restrict] = ACTIONS(2948),
    [anon_sym___restrict__] = ACTIONS(2948),
    [anon_sym__Atomic] = ACTIONS(2948),
    [anon_sym__Noreturn] = ACTIONS(2948),
    [anon_sym_noreturn] = ACTIONS(2948),
    [anon_sym__Nonnull] = ACTIONS(2948),
    [anon_sym_mutable] = ACTIONS(2948),
    [anon_sym_constinit] = ACTIONS(2948),
    [anon_sym_consteval] = ACTIONS(2948),
    [anon_sym_alignas] = ACTIONS(2948),
    [anon_sym__Alignas] = ACTIONS(2948),
    [sym_primitive_type] = ACTIONS(2948),
    [anon_sym_enum] = ACTIONS(2948),
    [anon_sym_class] = ACTIONS(2948),
    [anon_sym_struct] = ACTIONS(2948),
    [anon_sym_union] = ACTIONS(2948),
    [anon_sym_if] = ACTIONS(2948),
    [anon_sym_switch] = ACTIONS(2948),
    [anon_sym_case] = ACTIONS(2948),
    [anon_sym_default] = ACTIONS(2948),
    [anon_sym_while] = ACTIONS(2948),
    [anon_sym_do] = ACTIONS(2948),
    [anon_sym_for] = ACTIONS(2948),
    [anon_sym_return] = ACTIONS(2948),
    [anon_sym_break] = ACTIONS(2948),
    [anon_sym_continue] = ACTIONS(2948),
    [anon_sym_goto] = ACTIONS(2948),
    [anon_sym___try] = ACTIONS(2948),
    [anon_sym___leave] = ACTIONS(2948),
    [anon_sym_not] = ACTIONS(2948),
    [anon_sym_compl] = ACTIONS(2948),
    [anon_sym_DASH_DASH] = ACTIONS(2946),
    [anon_sym_PLUS_PLUS] = ACTIONS(2946),
    [anon_sym_sizeof] = ACTIONS(2948),
    [anon_sym___alignof__] = ACTIONS(2948),
    [anon_sym___alignof] = ACTIONS(2948),
    [anon_sym__alignof] = ACTIONS(2948),
    [anon_sym_alignof] = ACTIONS(2948),
    [anon_sym__Alignof] = ACTIONS(2948),
    [anon_sym_offsetof] = ACTIONS(2948),
    [anon_sym__Generic] = ACTIONS(2948),
    [anon_sym_asm] = ACTIONS(2948),
    [anon_sym___asm__] = ACTIONS(2948),
    [anon_sym___asm] = ACTIONS(2948),
    [anon_sym_DOT] = ACTIONS(2948),
    [sym_number_literal] = ACTIONS(2946),
    [anon_sym_L_SQUOTE] = ACTIONS(2946),
    [anon_sym_u_SQUOTE] = ACTIONS(2946),
    [anon_sym_U_SQUOTE] = ACTIONS(2946),
    [anon_sym_u8_SQUOTE] = ACTIONS(2946),
    [anon_sym_SQUOTE] = ACTIONS(2946),
    [anon_sym_L_DQUOTE] = ACTIONS(2946),
    [anon_sym_u_DQUOTE] = ACTIONS(2946),
    [anon_sym_U_DQUOTE] = ACTIONS(2946),
    [anon_sym_u8_DQUOTE] = ACTIONS(2946),
    [anon_sym_DQUOTE] = ACTIONS(2946),
    [sym_true] = ACTIONS(2948),
    [sym_false] = ACTIONS(2948),
    [anon_sym_NULL] = ACTIONS(2948),
    [anon_sym_nullptr] = ACTIONS(2948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2948),
    [anon_sym_let] = ACTIONS(2948),
    [anon_sym_This] = ACTIONS(2948),
    [anon_sym_decltype] = ACTIONS(2948),
    [anon_sym_explicit] = ACTIONS(2948),
    [anon_sym_typename] = ACTIONS(2948),
    [anon_sym_template] = ACTIONS(2948),
    [anon_sym_operator] = ACTIONS(2948),
    [anon_sym_try] = ACTIONS(2948),
    [anon_sym_delete] = ACTIONS(2948),
    [anon_sym_throw] = ACTIONS(2948),
    [anon_sym_namespace] = ACTIONS(2948),
    [anon_sym_static_assert] = ACTIONS(2948),
    [anon_sym_concept] = ACTIONS(2948),
    [anon_sym_co_return] = ACTIONS(2948),
    [anon_sym_co_yield] = ACTIONS(2948),
    [anon_sym_R_DQUOTE] = ACTIONS(2946),
    [anon_sym_LR_DQUOTE] = ACTIONS(2946),
    [anon_sym_uR_DQUOTE] = ACTIONS(2946),
    [anon_sym_UR_DQUOTE] = ACTIONS(2946),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2946),
    [anon_sym_co_await] = ACTIONS(2948),
    [anon_sym_new] = ACTIONS(2948),
    [anon_sym_requires] = ACTIONS(2948),
    [sym_this] = ACTIONS(2948),
    [anon_sym_discard] = ACTIONS(2948),
    [anon_sym_precise] = ACTIONS(2948),
    [anon_sym_shared] = ACTIONS(2948),
    [anon_sym_groupshared] = ACTIONS(2948),
    [anon_sym_uniform] = ACTIONS(2948),
    [anon_sym_row_major] = ACTIONS(2948),
    [anon_sym_column_major] = ACTIONS(2948),
    [anon_sym_globallycoherent] = ACTIONS(2948),
    [anon_sym_centroid] = ACTIONS(2948),
    [anon_sym_noperspective] = ACTIONS(2948),
    [anon_sym_nointerpolation] = ACTIONS(2948),
    [anon_sym_sample] = ACTIONS(2948),
    [anon_sym_linear] = ACTIONS(2948),
    [anon_sym_snorm] = ACTIONS(2948),
    [anon_sym_unorm] = ACTIONS(2948),
    [anon_sym_point] = ACTIONS(2948),
    [anon_sym_line] = ACTIONS(2948),
    [anon_sym_triangleadj] = ACTIONS(2948),
    [anon_sym_lineadj] = ACTIONS(2948),
    [anon_sym_triangle] = ACTIONS(2948),
    [anon_sym_cbuffer] = ACTIONS(2948),
    [anon_sym_interface] = ACTIONS(2948),
    [anon_sym_extension] = ACTIONS(2948),
  },
  [764] = {
    [sym_identifier] = ACTIONS(2952),
    [aux_sym_preproc_include_token1] = ACTIONS(2952),
    [aux_sym_preproc_def_token1] = ACTIONS(2952),
    [aux_sym_preproc_if_token1] = ACTIONS(2952),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2952),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2952),
    [sym_preproc_directive] = ACTIONS(2952),
    [anon_sym_LPAREN2] = ACTIONS(2950),
    [anon_sym_BANG] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2952),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_STAR] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_AMP] = ACTIONS(2952),
    [anon_sym_SEMI] = ACTIONS(2950),
    [anon_sym___extension__] = ACTIONS(2952),
    [anon_sym_typedef] = ACTIONS(2952),
    [anon_sym_in] = ACTIONS(2952),
    [anon_sym_out] = ACTIONS(2952),
    [anon_sym_inout] = ACTIONS(2952),
    [anon_sym_virtual] = ACTIONS(2952),
    [anon_sym_extern] = ACTIONS(2952),
    [anon_sym___attribute__] = ACTIONS(2952),
    [anon_sym___attribute] = ACTIONS(2952),
    [anon_sym_using] = ACTIONS(2952),
    [anon_sym_COLON_COLON] = ACTIONS(2950),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2950),
    [anon_sym___declspec] = ACTIONS(2952),
    [anon_sym___based] = ACTIONS(2952),
    [anon_sym___cdecl] = ACTIONS(2952),
    [anon_sym___clrcall] = ACTIONS(2952),
    [anon_sym___stdcall] = ACTIONS(2952),
    [anon_sym___fastcall] = ACTIONS(2952),
    [anon_sym___thiscall] = ACTIONS(2952),
    [anon_sym___vectorcall] = ACTIONS(2952),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_RBRACE] = ACTIONS(2950),
    [anon_sym_signed] = ACTIONS(2952),
    [anon_sym_unsigned] = ACTIONS(2952),
    [anon_sym_long] = ACTIONS(2952),
    [anon_sym_short] = ACTIONS(2952),
    [anon_sym_LBRACK] = ACTIONS(2952),
    [anon_sym_static] = ACTIONS(2952),
    [anon_sym_register] = ACTIONS(2952),
    [anon_sym_inline] = ACTIONS(2952),
    [anon_sym___inline] = ACTIONS(2952),
    [anon_sym___inline__] = ACTIONS(2952),
    [anon_sym___forceinline] = ACTIONS(2952),
    [anon_sym_thread_local] = ACTIONS(2952),
    [anon_sym___thread] = ACTIONS(2952),
    [anon_sym_const] = ACTIONS(2952),
    [anon_sym_constexpr] = ACTIONS(2952),
    [anon_sym_volatile] = ACTIONS(2952),
    [anon_sym_restrict] = ACTIONS(2952),
    [anon_sym___restrict__] = ACTIONS(2952),
    [anon_sym__Atomic] = ACTIONS(2952),
    [anon_sym__Noreturn] = ACTIONS(2952),
    [anon_sym_noreturn] = ACTIONS(2952),
    [anon_sym__Nonnull] = ACTIONS(2952),
    [anon_sym_mutable] = ACTIONS(2952),
    [anon_sym_constinit] = ACTIONS(2952),
    [anon_sym_consteval] = ACTIONS(2952),
    [anon_sym_alignas] = ACTIONS(2952),
    [anon_sym__Alignas] = ACTIONS(2952),
    [sym_primitive_type] = ACTIONS(2952),
    [anon_sym_enum] = ACTIONS(2952),
    [anon_sym_class] = ACTIONS(2952),
    [anon_sym_struct] = ACTIONS(2952),
    [anon_sym_union] = ACTIONS(2952),
    [anon_sym_if] = ACTIONS(2952),
    [anon_sym_switch] = ACTIONS(2952),
    [anon_sym_case] = ACTIONS(2952),
    [anon_sym_default] = ACTIONS(2952),
    [anon_sym_while] = ACTIONS(2952),
    [anon_sym_do] = ACTIONS(2952),
    [anon_sym_for] = ACTIONS(2952),
    [anon_sym_return] = ACTIONS(2952),
    [anon_sym_break] = ACTIONS(2952),
    [anon_sym_continue] = ACTIONS(2952),
    [anon_sym_goto] = ACTIONS(2952),
    [anon_sym___try] = ACTIONS(2952),
    [anon_sym___leave] = ACTIONS(2952),
    [anon_sym_not] = ACTIONS(2952),
    [anon_sym_compl] = ACTIONS(2952),
    [anon_sym_DASH_DASH] = ACTIONS(2950),
    [anon_sym_PLUS_PLUS] = ACTIONS(2950),
    [anon_sym_sizeof] = ACTIONS(2952),
    [anon_sym___alignof__] = ACTIONS(2952),
    [anon_sym___alignof] = ACTIONS(2952),
    [anon_sym__alignof] = ACTIONS(2952),
    [anon_sym_alignof] = ACTIONS(2952),
    [anon_sym__Alignof] = ACTIONS(2952),
    [anon_sym_offsetof] = ACTIONS(2952),
    [anon_sym__Generic] = ACTIONS(2952),
    [anon_sym_asm] = ACTIONS(2952),
    [anon_sym___asm__] = ACTIONS(2952),
    [anon_sym___asm] = ACTIONS(2952),
    [anon_sym_DOT] = ACTIONS(2952),
    [sym_number_literal] = ACTIONS(2950),
    [anon_sym_L_SQUOTE] = ACTIONS(2950),
    [anon_sym_u_SQUOTE] = ACTIONS(2950),
    [anon_sym_U_SQUOTE] = ACTIONS(2950),
    [anon_sym_u8_SQUOTE] = ACTIONS(2950),
    [anon_sym_SQUOTE] = ACTIONS(2950),
    [anon_sym_L_DQUOTE] = ACTIONS(2950),
    [anon_sym_u_DQUOTE] = ACTIONS(2950),
    [anon_sym_U_DQUOTE] = ACTIONS(2950),
    [anon_sym_u8_DQUOTE] = ACTIONS(2950),
    [anon_sym_DQUOTE] = ACTIONS(2950),
    [sym_true] = ACTIONS(2952),
    [sym_false] = ACTIONS(2952),
    [anon_sym_NULL] = ACTIONS(2952),
    [anon_sym_nullptr] = ACTIONS(2952),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2952),
    [anon_sym_let] = ACTIONS(2952),
    [anon_sym_This] = ACTIONS(2952),
    [anon_sym_decltype] = ACTIONS(2952),
    [anon_sym_explicit] = ACTIONS(2952),
    [anon_sym_typename] = ACTIONS(2952),
    [anon_sym_template] = ACTIONS(2952),
    [anon_sym_operator] = ACTIONS(2952),
    [anon_sym_try] = ACTIONS(2952),
    [anon_sym_delete] = ACTIONS(2952),
    [anon_sym_throw] = ACTIONS(2952),
    [anon_sym_namespace] = ACTIONS(2952),
    [anon_sym_static_assert] = ACTIONS(2952),
    [anon_sym_concept] = ACTIONS(2952),
    [anon_sym_co_return] = ACTIONS(2952),
    [anon_sym_co_yield] = ACTIONS(2952),
    [anon_sym_R_DQUOTE] = ACTIONS(2950),
    [anon_sym_LR_DQUOTE] = ACTIONS(2950),
    [anon_sym_uR_DQUOTE] = ACTIONS(2950),
    [anon_sym_UR_DQUOTE] = ACTIONS(2950),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2950),
    [anon_sym_co_await] = ACTIONS(2952),
    [anon_sym_new] = ACTIONS(2952),
    [anon_sym_requires] = ACTIONS(2952),
    [sym_this] = ACTIONS(2952),
    [anon_sym_discard] = ACTIONS(2952),
    [anon_sym_precise] = ACTIONS(2952),
    [anon_sym_shared] = ACTIONS(2952),
    [anon_sym_groupshared] = ACTIONS(2952),
    [anon_sym_uniform] = ACTIONS(2952),
    [anon_sym_row_major] = ACTIONS(2952),
    [anon_sym_column_major] = ACTIONS(2952),
    [anon_sym_globallycoherent] = ACTIONS(2952),
    [anon_sym_centroid] = ACTIONS(2952),
    [anon_sym_noperspective] = ACTIONS(2952),
    [anon_sym_nointerpolation] = ACTIONS(2952),
    [anon_sym_sample] = ACTIONS(2952),
    [anon_sym_linear] = ACTIONS(2952),
    [anon_sym_snorm] = ACTIONS(2952),
    [anon_sym_unorm] = ACTIONS(2952),
    [anon_sym_point] = ACTIONS(2952),
    [anon_sym_line] = ACTIONS(2952),
    [anon_sym_triangleadj] = ACTIONS(2952),
    [anon_sym_lineadj] = ACTIONS(2952),
    [anon_sym_triangle] = ACTIONS(2952),
    [anon_sym_cbuffer] = ACTIONS(2952),
    [anon_sym_interface] = ACTIONS(2952),
    [anon_sym_extension] = ACTIONS(2952),
  },
  [765] = {
    [sym_identifier] = ACTIONS(3054),
    [aux_sym_preproc_include_token1] = ACTIONS(3054),
    [aux_sym_preproc_def_token1] = ACTIONS(3054),
    [aux_sym_preproc_if_token1] = ACTIONS(3054),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3054),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3054),
    [sym_preproc_directive] = ACTIONS(3054),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3054),
    [anon_sym_typedef] = ACTIONS(3054),
    [anon_sym_in] = ACTIONS(3054),
    [anon_sym_out] = ACTIONS(3054),
    [anon_sym_inout] = ACTIONS(3054),
    [anon_sym_virtual] = ACTIONS(3054),
    [anon_sym_extern] = ACTIONS(3054),
    [anon_sym___attribute__] = ACTIONS(3054),
    [anon_sym___attribute] = ACTIONS(3054),
    [anon_sym_using] = ACTIONS(3054),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3052),
    [anon_sym___declspec] = ACTIONS(3054),
    [anon_sym___based] = ACTIONS(3054),
    [anon_sym___cdecl] = ACTIONS(3054),
    [anon_sym___clrcall] = ACTIONS(3054),
    [anon_sym___stdcall] = ACTIONS(3054),
    [anon_sym___fastcall] = ACTIONS(3054),
    [anon_sym___thiscall] = ACTIONS(3054),
    [anon_sym___vectorcall] = ACTIONS(3054),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_RBRACE] = ACTIONS(3052),
    [anon_sym_signed] = ACTIONS(3054),
    [anon_sym_unsigned] = ACTIONS(3054),
    [anon_sym_long] = ACTIONS(3054),
    [anon_sym_short] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3054),
    [anon_sym_static] = ACTIONS(3054),
    [anon_sym_register] = ACTIONS(3054),
    [anon_sym_inline] = ACTIONS(3054),
    [anon_sym___inline] = ACTIONS(3054),
    [anon_sym___inline__] = ACTIONS(3054),
    [anon_sym___forceinline] = ACTIONS(3054),
    [anon_sym_thread_local] = ACTIONS(3054),
    [anon_sym___thread] = ACTIONS(3054),
    [anon_sym_const] = ACTIONS(3054),
    [anon_sym_constexpr] = ACTIONS(3054),
    [anon_sym_volatile] = ACTIONS(3054),
    [anon_sym_restrict] = ACTIONS(3054),
    [anon_sym___restrict__] = ACTIONS(3054),
    [anon_sym__Atomic] = ACTIONS(3054),
    [anon_sym__Noreturn] = ACTIONS(3054),
    [anon_sym_noreturn] = ACTIONS(3054),
    [anon_sym__Nonnull] = ACTIONS(3054),
    [anon_sym_mutable] = ACTIONS(3054),
    [anon_sym_constinit] = ACTIONS(3054),
    [anon_sym_consteval] = ACTIONS(3054),
    [anon_sym_alignas] = ACTIONS(3054),
    [anon_sym__Alignas] = ACTIONS(3054),
    [sym_primitive_type] = ACTIONS(3054),
    [anon_sym_enum] = ACTIONS(3054),
    [anon_sym_class] = ACTIONS(3054),
    [anon_sym_struct] = ACTIONS(3054),
    [anon_sym_union] = ACTIONS(3054),
    [anon_sym_if] = ACTIONS(3054),
    [anon_sym_switch] = ACTIONS(3054),
    [anon_sym_case] = ACTIONS(3054),
    [anon_sym_default] = ACTIONS(3054),
    [anon_sym_while] = ACTIONS(3054),
    [anon_sym_do] = ACTIONS(3054),
    [anon_sym_for] = ACTIONS(3054),
    [anon_sym_return] = ACTIONS(3054),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_continue] = ACTIONS(3054),
    [anon_sym_goto] = ACTIONS(3054),
    [anon_sym___try] = ACTIONS(3054),
    [anon_sym___leave] = ACTIONS(3054),
    [anon_sym_not] = ACTIONS(3054),
    [anon_sym_compl] = ACTIONS(3054),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_sizeof] = ACTIONS(3054),
    [anon_sym___alignof__] = ACTIONS(3054),
    [anon_sym___alignof] = ACTIONS(3054),
    [anon_sym__alignof] = ACTIONS(3054),
    [anon_sym_alignof] = ACTIONS(3054),
    [anon_sym__Alignof] = ACTIONS(3054),
    [anon_sym_offsetof] = ACTIONS(3054),
    [anon_sym__Generic] = ACTIONS(3054),
    [anon_sym_asm] = ACTIONS(3054),
    [anon_sym___asm__] = ACTIONS(3054),
    [anon_sym___asm] = ACTIONS(3054),
    [anon_sym_DOT] = ACTIONS(3054),
    [sym_number_literal] = ACTIONS(3052),
    [anon_sym_L_SQUOTE] = ACTIONS(3052),
    [anon_sym_u_SQUOTE] = ACTIONS(3052),
    [anon_sym_U_SQUOTE] = ACTIONS(3052),
    [anon_sym_u8_SQUOTE] = ACTIONS(3052),
    [anon_sym_SQUOTE] = ACTIONS(3052),
    [anon_sym_L_DQUOTE] = ACTIONS(3052),
    [anon_sym_u_DQUOTE] = ACTIONS(3052),
    [anon_sym_U_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8_DQUOTE] = ACTIONS(3052),
    [anon_sym_DQUOTE] = ACTIONS(3052),
    [sym_true] = ACTIONS(3054),
    [sym_false] = ACTIONS(3054),
    [anon_sym_NULL] = ACTIONS(3054),
    [anon_sym_nullptr] = ACTIONS(3054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3054),
    [anon_sym_let] = ACTIONS(3054),
    [anon_sym_This] = ACTIONS(3054),
    [anon_sym_decltype] = ACTIONS(3054),
    [anon_sym_explicit] = ACTIONS(3054),
    [anon_sym_typename] = ACTIONS(3054),
    [anon_sym_template] = ACTIONS(3054),
    [anon_sym_operator] = ACTIONS(3054),
    [anon_sym_try] = ACTIONS(3054),
    [anon_sym_delete] = ACTIONS(3054),
    [anon_sym_throw] = ACTIONS(3054),
    [anon_sym_namespace] = ACTIONS(3054),
    [anon_sym_static_assert] = ACTIONS(3054),
    [anon_sym_concept] = ACTIONS(3054),
    [anon_sym_co_return] = ACTIONS(3054),
    [anon_sym_co_yield] = ACTIONS(3054),
    [anon_sym_R_DQUOTE] = ACTIONS(3052),
    [anon_sym_LR_DQUOTE] = ACTIONS(3052),
    [anon_sym_uR_DQUOTE] = ACTIONS(3052),
    [anon_sym_UR_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3052),
    [anon_sym_co_await] = ACTIONS(3054),
    [anon_sym_new] = ACTIONS(3054),
    [anon_sym_requires] = ACTIONS(3054),
    [sym_this] = ACTIONS(3054),
    [anon_sym_discard] = ACTIONS(3054),
    [anon_sym_precise] = ACTIONS(3054),
    [anon_sym_shared] = ACTIONS(3054),
    [anon_sym_groupshared] = ACTIONS(3054),
    [anon_sym_uniform] = ACTIONS(3054),
    [anon_sym_row_major] = ACTIONS(3054),
    [anon_sym_column_major] = ACTIONS(3054),
    [anon_sym_globallycoherent] = ACTIONS(3054),
    [anon_sym_centroid] = ACTIONS(3054),
    [anon_sym_noperspective] = ACTIONS(3054),
    [anon_sym_nointerpolation] = ACTIONS(3054),
    [anon_sym_sample] = ACTIONS(3054),
    [anon_sym_linear] = ACTIONS(3054),
    [anon_sym_snorm] = ACTIONS(3054),
    [anon_sym_unorm] = ACTIONS(3054),
    [anon_sym_point] = ACTIONS(3054),
    [anon_sym_line] = ACTIONS(3054),
    [anon_sym_triangleadj] = ACTIONS(3054),
    [anon_sym_lineadj] = ACTIONS(3054),
    [anon_sym_triangle] = ACTIONS(3054),
    [anon_sym_cbuffer] = ACTIONS(3054),
    [anon_sym_interface] = ACTIONS(3054),
    [anon_sym_extension] = ACTIONS(3054),
  },
  [766] = {
    [sym_identifier] = ACTIONS(3474),
    [aux_sym_preproc_include_token1] = ACTIONS(3474),
    [aux_sym_preproc_def_token1] = ACTIONS(3474),
    [aux_sym_preproc_if_token1] = ACTIONS(3474),
    [aux_sym_preproc_if_token2] = ACTIONS(3474),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3474),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3474),
    [sym_preproc_directive] = ACTIONS(3474),
    [anon_sym_LPAREN2] = ACTIONS(3476),
    [anon_sym_BANG] = ACTIONS(3476),
    [anon_sym_TILDE] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3474),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_AMP_AMP] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3474),
    [anon_sym_SEMI] = ACTIONS(3476),
    [anon_sym___extension__] = ACTIONS(3474),
    [anon_sym_typedef] = ACTIONS(3474),
    [anon_sym_in] = ACTIONS(3474),
    [anon_sym_out] = ACTIONS(3474),
    [anon_sym_inout] = ACTIONS(3474),
    [anon_sym_virtual] = ACTIONS(3474),
    [anon_sym_extern] = ACTIONS(3474),
    [anon_sym___attribute__] = ACTIONS(3474),
    [anon_sym___attribute] = ACTIONS(3474),
    [anon_sym_using] = ACTIONS(3474),
    [anon_sym_COLON_COLON] = ACTIONS(3476),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3476),
    [anon_sym___declspec] = ACTIONS(3474),
    [anon_sym___based] = ACTIONS(3474),
    [anon_sym___cdecl] = ACTIONS(3474),
    [anon_sym___clrcall] = ACTIONS(3474),
    [anon_sym___stdcall] = ACTIONS(3474),
    [anon_sym___fastcall] = ACTIONS(3474),
    [anon_sym___thiscall] = ACTIONS(3474),
    [anon_sym___vectorcall] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_signed] = ACTIONS(3474),
    [anon_sym_unsigned] = ACTIONS(3474),
    [anon_sym_long] = ACTIONS(3474),
    [anon_sym_short] = ACTIONS(3474),
    [anon_sym_LBRACK] = ACTIONS(3474),
    [anon_sym_static] = ACTIONS(3474),
    [anon_sym_register] = ACTIONS(3474),
    [anon_sym_inline] = ACTIONS(3474),
    [anon_sym___inline] = ACTIONS(3474),
    [anon_sym___inline__] = ACTIONS(3474),
    [anon_sym___forceinline] = ACTIONS(3474),
    [anon_sym_thread_local] = ACTIONS(3474),
    [anon_sym___thread] = ACTIONS(3474),
    [anon_sym_const] = ACTIONS(3474),
    [anon_sym_constexpr] = ACTIONS(3474),
    [anon_sym_volatile] = ACTIONS(3474),
    [anon_sym_restrict] = ACTIONS(3474),
    [anon_sym___restrict__] = ACTIONS(3474),
    [anon_sym__Atomic] = ACTIONS(3474),
    [anon_sym__Noreturn] = ACTIONS(3474),
    [anon_sym_noreturn] = ACTIONS(3474),
    [anon_sym__Nonnull] = ACTIONS(3474),
    [anon_sym_mutable] = ACTIONS(3474),
    [anon_sym_constinit] = ACTIONS(3474),
    [anon_sym_consteval] = ACTIONS(3474),
    [anon_sym_alignas] = ACTIONS(3474),
    [anon_sym__Alignas] = ACTIONS(3474),
    [sym_primitive_type] = ACTIONS(3474),
    [anon_sym_enum] = ACTIONS(3474),
    [anon_sym_class] = ACTIONS(3474),
    [anon_sym_struct] = ACTIONS(3474),
    [anon_sym_union] = ACTIONS(3474),
    [anon_sym_if] = ACTIONS(3474),
    [anon_sym_else] = ACTIONS(3474),
    [anon_sym_switch] = ACTIONS(3474),
    [anon_sym_case] = ACTIONS(3474),
    [anon_sym_default] = ACTIONS(3474),
    [anon_sym_while] = ACTIONS(3474),
    [anon_sym_do] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3474),
    [anon_sym_return] = ACTIONS(3474),
    [anon_sym_break] = ACTIONS(3474),
    [anon_sym_continue] = ACTIONS(3474),
    [anon_sym_goto] = ACTIONS(3474),
    [anon_sym___try] = ACTIONS(3474),
    [anon_sym___leave] = ACTIONS(3474),
    [anon_sym_not] = ACTIONS(3474),
    [anon_sym_compl] = ACTIONS(3474),
    [anon_sym_DASH_DASH] = ACTIONS(3476),
    [anon_sym_PLUS_PLUS] = ACTIONS(3476),
    [anon_sym_sizeof] = ACTIONS(3474),
    [anon_sym___alignof__] = ACTIONS(3474),
    [anon_sym___alignof] = ACTIONS(3474),
    [anon_sym__alignof] = ACTIONS(3474),
    [anon_sym_alignof] = ACTIONS(3474),
    [anon_sym__Alignof] = ACTIONS(3474),
    [anon_sym_offsetof] = ACTIONS(3474),
    [anon_sym__Generic] = ACTIONS(3474),
    [anon_sym_asm] = ACTIONS(3474),
    [anon_sym___asm__] = ACTIONS(3474),
    [anon_sym___asm] = ACTIONS(3474),
    [sym_number_literal] = ACTIONS(3476),
    [anon_sym_L_SQUOTE] = ACTIONS(3476),
    [anon_sym_u_SQUOTE] = ACTIONS(3476),
    [anon_sym_U_SQUOTE] = ACTIONS(3476),
    [anon_sym_u8_SQUOTE] = ACTIONS(3476),
    [anon_sym_SQUOTE] = ACTIONS(3476),
    [anon_sym_L_DQUOTE] = ACTIONS(3476),
    [anon_sym_u_DQUOTE] = ACTIONS(3476),
    [anon_sym_U_DQUOTE] = ACTIONS(3476),
    [anon_sym_u8_DQUOTE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [sym_true] = ACTIONS(3474),
    [sym_false] = ACTIONS(3474),
    [anon_sym_NULL] = ACTIONS(3474),
    [anon_sym_nullptr] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3474),
    [anon_sym_let] = ACTIONS(3474),
    [anon_sym_This] = ACTIONS(3474),
    [anon_sym_decltype] = ACTIONS(3474),
    [anon_sym_explicit] = ACTIONS(3474),
    [anon_sym_typename] = ACTIONS(3474),
    [anon_sym_template] = ACTIONS(3474),
    [anon_sym_operator] = ACTIONS(3474),
    [anon_sym_try] = ACTIONS(3474),
    [anon_sym_delete] = ACTIONS(3474),
    [anon_sym_throw] = ACTIONS(3474),
    [anon_sym_namespace] = ACTIONS(3474),
    [anon_sym_static_assert] = ACTIONS(3474),
    [anon_sym_concept] = ACTIONS(3474),
    [anon_sym_co_return] = ACTIONS(3474),
    [anon_sym_co_yield] = ACTIONS(3474),
    [anon_sym_R_DQUOTE] = ACTIONS(3476),
    [anon_sym_LR_DQUOTE] = ACTIONS(3476),
    [anon_sym_uR_DQUOTE] = ACTIONS(3476),
    [anon_sym_UR_DQUOTE] = ACTIONS(3476),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3476),
    [anon_sym_co_await] = ACTIONS(3474),
    [anon_sym_new] = ACTIONS(3474),
    [anon_sym_requires] = ACTIONS(3474),
    [sym_this] = ACTIONS(3474),
    [anon_sym_discard] = ACTIONS(3474),
    [anon_sym_precise] = ACTIONS(3474),
    [anon_sym_shared] = ACTIONS(3474),
    [anon_sym_groupshared] = ACTIONS(3474),
    [anon_sym_uniform] = ACTIONS(3474),
    [anon_sym_row_major] = ACTIONS(3474),
    [anon_sym_column_major] = ACTIONS(3474),
    [anon_sym_globallycoherent] = ACTIONS(3474),
    [anon_sym_centroid] = ACTIONS(3474),
    [anon_sym_noperspective] = ACTIONS(3474),
    [anon_sym_nointerpolation] = ACTIONS(3474),
    [anon_sym_sample] = ACTIONS(3474),
    [anon_sym_linear] = ACTIONS(3474),
    [anon_sym_snorm] = ACTIONS(3474),
    [anon_sym_unorm] = ACTIONS(3474),
    [anon_sym_point] = ACTIONS(3474),
    [anon_sym_line] = ACTIONS(3474),
    [anon_sym_triangleadj] = ACTIONS(3474),
    [anon_sym_lineadj] = ACTIONS(3474),
    [anon_sym_triangle] = ACTIONS(3474),
    [anon_sym_cbuffer] = ACTIONS(3474),
    [anon_sym_interface] = ACTIONS(3474),
    [anon_sym_extension] = ACTIONS(3474),
  },
  [767] = {
    [sym_identifier] = ACTIONS(3026),
    [aux_sym_preproc_include_token1] = ACTIONS(3026),
    [aux_sym_preproc_def_token1] = ACTIONS(3026),
    [aux_sym_preproc_if_token1] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3026),
    [sym_preproc_directive] = ACTIONS(3026),
    [anon_sym_LPAREN2] = ACTIONS(3024),
    [anon_sym_BANG] = ACTIONS(3024),
    [anon_sym_TILDE] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3026),
    [anon_sym_PLUS] = ACTIONS(3026),
    [anon_sym_STAR] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_AMP] = ACTIONS(3026),
    [anon_sym_SEMI] = ACTIONS(3024),
    [anon_sym___extension__] = ACTIONS(3026),
    [anon_sym_typedef] = ACTIONS(3026),
    [anon_sym_in] = ACTIONS(3026),
    [anon_sym_out] = ACTIONS(3026),
    [anon_sym_inout] = ACTIONS(3026),
    [anon_sym_virtual] = ACTIONS(3026),
    [anon_sym_extern] = ACTIONS(3026),
    [anon_sym___attribute__] = ACTIONS(3026),
    [anon_sym___attribute] = ACTIONS(3026),
    [anon_sym_using] = ACTIONS(3026),
    [anon_sym_COLON_COLON] = ACTIONS(3024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3024),
    [anon_sym___declspec] = ACTIONS(3026),
    [anon_sym___based] = ACTIONS(3026),
    [anon_sym___cdecl] = ACTIONS(3026),
    [anon_sym___clrcall] = ACTIONS(3026),
    [anon_sym___stdcall] = ACTIONS(3026),
    [anon_sym___fastcall] = ACTIONS(3026),
    [anon_sym___thiscall] = ACTIONS(3026),
    [anon_sym___vectorcall] = ACTIONS(3026),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_RBRACE] = ACTIONS(3024),
    [anon_sym_signed] = ACTIONS(3026),
    [anon_sym_unsigned] = ACTIONS(3026),
    [anon_sym_long] = ACTIONS(3026),
    [anon_sym_short] = ACTIONS(3026),
    [anon_sym_LBRACK] = ACTIONS(3026),
    [anon_sym_static] = ACTIONS(3026),
    [anon_sym_register] = ACTIONS(3026),
    [anon_sym_inline] = ACTIONS(3026),
    [anon_sym___inline] = ACTIONS(3026),
    [anon_sym___inline__] = ACTIONS(3026),
    [anon_sym___forceinline] = ACTIONS(3026),
    [anon_sym_thread_local] = ACTIONS(3026),
    [anon_sym___thread] = ACTIONS(3026),
    [anon_sym_const] = ACTIONS(3026),
    [anon_sym_constexpr] = ACTIONS(3026),
    [anon_sym_volatile] = ACTIONS(3026),
    [anon_sym_restrict] = ACTIONS(3026),
    [anon_sym___restrict__] = ACTIONS(3026),
    [anon_sym__Atomic] = ACTIONS(3026),
    [anon_sym__Noreturn] = ACTIONS(3026),
    [anon_sym_noreturn] = ACTIONS(3026),
    [anon_sym__Nonnull] = ACTIONS(3026),
    [anon_sym_mutable] = ACTIONS(3026),
    [anon_sym_constinit] = ACTIONS(3026),
    [anon_sym_consteval] = ACTIONS(3026),
    [anon_sym_alignas] = ACTIONS(3026),
    [anon_sym__Alignas] = ACTIONS(3026),
    [sym_primitive_type] = ACTIONS(3026),
    [anon_sym_enum] = ACTIONS(3026),
    [anon_sym_class] = ACTIONS(3026),
    [anon_sym_struct] = ACTIONS(3026),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_if] = ACTIONS(3026),
    [anon_sym_switch] = ACTIONS(3026),
    [anon_sym_case] = ACTIONS(3026),
    [anon_sym_default] = ACTIONS(3026),
    [anon_sym_while] = ACTIONS(3026),
    [anon_sym_do] = ACTIONS(3026),
    [anon_sym_for] = ACTIONS(3026),
    [anon_sym_return] = ACTIONS(3026),
    [anon_sym_break] = ACTIONS(3026),
    [anon_sym_continue] = ACTIONS(3026),
    [anon_sym_goto] = ACTIONS(3026),
    [anon_sym___try] = ACTIONS(3026),
    [anon_sym___leave] = ACTIONS(3026),
    [anon_sym_not] = ACTIONS(3026),
    [anon_sym_compl] = ACTIONS(3026),
    [anon_sym_DASH_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_PLUS] = ACTIONS(3024),
    [anon_sym_sizeof] = ACTIONS(3026),
    [anon_sym___alignof__] = ACTIONS(3026),
    [anon_sym___alignof] = ACTIONS(3026),
    [anon_sym__alignof] = ACTIONS(3026),
    [anon_sym_alignof] = ACTIONS(3026),
    [anon_sym__Alignof] = ACTIONS(3026),
    [anon_sym_offsetof] = ACTIONS(3026),
    [anon_sym__Generic] = ACTIONS(3026),
    [anon_sym_asm] = ACTIONS(3026),
    [anon_sym___asm__] = ACTIONS(3026),
    [anon_sym___asm] = ACTIONS(3026),
    [anon_sym_DOT] = ACTIONS(3026),
    [sym_number_literal] = ACTIONS(3024),
    [anon_sym_L_SQUOTE] = ACTIONS(3024),
    [anon_sym_u_SQUOTE] = ACTIONS(3024),
    [anon_sym_U_SQUOTE] = ACTIONS(3024),
    [anon_sym_u8_SQUOTE] = ACTIONS(3024),
    [anon_sym_SQUOTE] = ACTIONS(3024),
    [anon_sym_L_DQUOTE] = ACTIONS(3024),
    [anon_sym_u_DQUOTE] = ACTIONS(3024),
    [anon_sym_U_DQUOTE] = ACTIONS(3024),
    [anon_sym_u8_DQUOTE] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [sym_true] = ACTIONS(3026),
    [sym_false] = ACTIONS(3026),
    [anon_sym_NULL] = ACTIONS(3026),
    [anon_sym_nullptr] = ACTIONS(3026),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3026),
    [anon_sym_let] = ACTIONS(3026),
    [anon_sym_This] = ACTIONS(3026),
    [anon_sym_decltype] = ACTIONS(3026),
    [anon_sym_explicit] = ACTIONS(3026),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(3026),
    [anon_sym_operator] = ACTIONS(3026),
    [anon_sym_try] = ACTIONS(3026),
    [anon_sym_delete] = ACTIONS(3026),
    [anon_sym_throw] = ACTIONS(3026),
    [anon_sym_namespace] = ACTIONS(3026),
    [anon_sym_static_assert] = ACTIONS(3026),
    [anon_sym_concept] = ACTIONS(3026),
    [anon_sym_co_return] = ACTIONS(3026),
    [anon_sym_co_yield] = ACTIONS(3026),
    [anon_sym_R_DQUOTE] = ACTIONS(3024),
    [anon_sym_LR_DQUOTE] = ACTIONS(3024),
    [anon_sym_uR_DQUOTE] = ACTIONS(3024),
    [anon_sym_UR_DQUOTE] = ACTIONS(3024),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3024),
    [anon_sym_co_await] = ACTIONS(3026),
    [anon_sym_new] = ACTIONS(3026),
    [anon_sym_requires] = ACTIONS(3026),
    [sym_this] = ACTIONS(3026),
    [anon_sym_discard] = ACTIONS(3026),
    [anon_sym_precise] = ACTIONS(3026),
    [anon_sym_shared] = ACTIONS(3026),
    [anon_sym_groupshared] = ACTIONS(3026),
    [anon_sym_uniform] = ACTIONS(3026),
    [anon_sym_row_major] = ACTIONS(3026),
    [anon_sym_column_major] = ACTIONS(3026),
    [anon_sym_globallycoherent] = ACTIONS(3026),
    [anon_sym_centroid] = ACTIONS(3026),
    [anon_sym_noperspective] = ACTIONS(3026),
    [anon_sym_nointerpolation] = ACTIONS(3026),
    [anon_sym_sample] = ACTIONS(3026),
    [anon_sym_linear] = ACTIONS(3026),
    [anon_sym_snorm] = ACTIONS(3026),
    [anon_sym_unorm] = ACTIONS(3026),
    [anon_sym_point] = ACTIONS(3026),
    [anon_sym_line] = ACTIONS(3026),
    [anon_sym_triangleadj] = ACTIONS(3026),
    [anon_sym_lineadj] = ACTIONS(3026),
    [anon_sym_triangle] = ACTIONS(3026),
    [anon_sym_cbuffer] = ACTIONS(3026),
    [anon_sym_interface] = ACTIONS(3026),
    [anon_sym_extension] = ACTIONS(3026),
  },
  [768] = {
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_include_token1] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3032),
    [anon_sym_BANG] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_virtual] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym___attribute] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3032),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym___cdecl] = ACTIONS(3034),
    [anon_sym___clrcall] = ACTIONS(3034),
    [anon_sym___stdcall] = ACTIONS(3034),
    [anon_sym___fastcall] = ACTIONS(3034),
    [anon_sym___thiscall] = ACTIONS(3034),
    [anon_sym___vectorcall] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_RBRACE] = ACTIONS(3032),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym__Nonnull] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_case] = ACTIONS(3034),
    [anon_sym_default] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3034),
    [anon_sym___try] = ACTIONS(3034),
    [anon_sym___leave] = ACTIONS(3034),
    [anon_sym_not] = ACTIONS(3034),
    [anon_sym_compl] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_PLUS] = ACTIONS(3032),
    [anon_sym_sizeof] = ACTIONS(3034),
    [anon_sym___alignof__] = ACTIONS(3034),
    [anon_sym___alignof] = ACTIONS(3034),
    [anon_sym__alignof] = ACTIONS(3034),
    [anon_sym_alignof] = ACTIONS(3034),
    [anon_sym__Alignof] = ACTIONS(3034),
    [anon_sym_offsetof] = ACTIONS(3034),
    [anon_sym__Generic] = ACTIONS(3034),
    [anon_sym_asm] = ACTIONS(3034),
    [anon_sym___asm__] = ACTIONS(3034),
    [anon_sym___asm] = ACTIONS(3034),
    [anon_sym_DOT] = ACTIONS(3034),
    [sym_number_literal] = ACTIONS(3032),
    [anon_sym_L_SQUOTE] = ACTIONS(3032),
    [anon_sym_u_SQUOTE] = ACTIONS(3032),
    [anon_sym_U_SQUOTE] = ACTIONS(3032),
    [anon_sym_u8_SQUOTE] = ACTIONS(3032),
    [anon_sym_SQUOTE] = ACTIONS(3032),
    [anon_sym_L_DQUOTE] = ACTIONS(3032),
    [anon_sym_u_DQUOTE] = ACTIONS(3032),
    [anon_sym_U_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [anon_sym_NULL] = ACTIONS(3034),
    [anon_sym_nullptr] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_try] = ACTIONS(3034),
    [anon_sym_delete] = ACTIONS(3034),
    [anon_sym_throw] = ACTIONS(3034),
    [anon_sym_namespace] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_concept] = ACTIONS(3034),
    [anon_sym_co_return] = ACTIONS(3034),
    [anon_sym_co_yield] = ACTIONS(3034),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3034),
    [anon_sym_requires] = ACTIONS(3034),
    [sym_this] = ACTIONS(3034),
    [anon_sym_discard] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
    [anon_sym_cbuffer] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_extension] = ACTIONS(3034),
  },
  [769] = {
    [sym_identifier] = ACTIONS(3038),
    [aux_sym_preproc_include_token1] = ACTIONS(3038),
    [aux_sym_preproc_def_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3038),
    [sym_preproc_directive] = ACTIONS(3038),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3038),
    [anon_sym_typedef] = ACTIONS(3038),
    [anon_sym_in] = ACTIONS(3038),
    [anon_sym_out] = ACTIONS(3038),
    [anon_sym_inout] = ACTIONS(3038),
    [anon_sym_virtual] = ACTIONS(3038),
    [anon_sym_extern] = ACTIONS(3038),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym___attribute] = ACTIONS(3038),
    [anon_sym_using] = ACTIONS(3038),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3038),
    [anon_sym___based] = ACTIONS(3038),
    [anon_sym___cdecl] = ACTIONS(3038),
    [anon_sym___clrcall] = ACTIONS(3038),
    [anon_sym___stdcall] = ACTIONS(3038),
    [anon_sym___fastcall] = ACTIONS(3038),
    [anon_sym___thiscall] = ACTIONS(3038),
    [anon_sym___vectorcall] = ACTIONS(3038),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_RBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3038),
    [anon_sym_unsigned] = ACTIONS(3038),
    [anon_sym_long] = ACTIONS(3038),
    [anon_sym_short] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_register] = ACTIONS(3038),
    [anon_sym_inline] = ACTIONS(3038),
    [anon_sym___inline] = ACTIONS(3038),
    [anon_sym___inline__] = ACTIONS(3038),
    [anon_sym___forceinline] = ACTIONS(3038),
    [anon_sym_thread_local] = ACTIONS(3038),
    [anon_sym___thread] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_constexpr] = ACTIONS(3038),
    [anon_sym_volatile] = ACTIONS(3038),
    [anon_sym_restrict] = ACTIONS(3038),
    [anon_sym___restrict__] = ACTIONS(3038),
    [anon_sym__Atomic] = ACTIONS(3038),
    [anon_sym__Noreturn] = ACTIONS(3038),
    [anon_sym_noreturn] = ACTIONS(3038),
    [anon_sym__Nonnull] = ACTIONS(3038),
    [anon_sym_mutable] = ACTIONS(3038),
    [anon_sym_constinit] = ACTIONS(3038),
    [anon_sym_consteval] = ACTIONS(3038),
    [anon_sym_alignas] = ACTIONS(3038),
    [anon_sym__Alignas] = ACTIONS(3038),
    [sym_primitive_type] = ACTIONS(3038),
    [anon_sym_enum] = ACTIONS(3038),
    [anon_sym_class] = ACTIONS(3038),
    [anon_sym_struct] = ACTIONS(3038),
    [anon_sym_union] = ACTIONS(3038),
    [anon_sym_if] = ACTIONS(3038),
    [anon_sym_switch] = ACTIONS(3038),
    [anon_sym_case] = ACTIONS(3038),
    [anon_sym_default] = ACTIONS(3038),
    [anon_sym_while] = ACTIONS(3038),
    [anon_sym_do] = ACTIONS(3038),
    [anon_sym_for] = ACTIONS(3038),
    [anon_sym_return] = ACTIONS(3038),
    [anon_sym_break] = ACTIONS(3038),
    [anon_sym_continue] = ACTIONS(3038),
    [anon_sym_goto] = ACTIONS(3038),
    [anon_sym___try] = ACTIONS(3038),
    [anon_sym___leave] = ACTIONS(3038),
    [anon_sym_not] = ACTIONS(3038),
    [anon_sym_compl] = ACTIONS(3038),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_sizeof] = ACTIONS(3038),
    [anon_sym___alignof__] = ACTIONS(3038),
    [anon_sym___alignof] = ACTIONS(3038),
    [anon_sym__alignof] = ACTIONS(3038),
    [anon_sym_alignof] = ACTIONS(3038),
    [anon_sym__Alignof] = ACTIONS(3038),
    [anon_sym_offsetof] = ACTIONS(3038),
    [anon_sym__Generic] = ACTIONS(3038),
    [anon_sym_asm] = ACTIONS(3038),
    [anon_sym___asm__] = ACTIONS(3038),
    [anon_sym___asm] = ACTIONS(3038),
    [anon_sym_DOT] = ACTIONS(3038),
    [sym_number_literal] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3036),
    [anon_sym_u_SQUOTE] = ACTIONS(3036),
    [anon_sym_U_SQUOTE] = ACTIONS(3036),
    [anon_sym_u8_SQUOTE] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3036),
    [anon_sym_L_DQUOTE] = ACTIONS(3036),
    [anon_sym_u_DQUOTE] = ACTIONS(3036),
    [anon_sym_U_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8_DQUOTE] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [sym_true] = ACTIONS(3038),
    [sym_false] = ACTIONS(3038),
    [anon_sym_NULL] = ACTIONS(3038),
    [anon_sym_nullptr] = ACTIONS(3038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3038),
    [anon_sym_let] = ACTIONS(3038),
    [anon_sym_This] = ACTIONS(3038),
    [anon_sym_decltype] = ACTIONS(3038),
    [anon_sym_explicit] = ACTIONS(3038),
    [anon_sym_typename] = ACTIONS(3038),
    [anon_sym_template] = ACTIONS(3038),
    [anon_sym_operator] = ACTIONS(3038),
    [anon_sym_try] = ACTIONS(3038),
    [anon_sym_delete] = ACTIONS(3038),
    [anon_sym_throw] = ACTIONS(3038),
    [anon_sym_namespace] = ACTIONS(3038),
    [anon_sym_static_assert] = ACTIONS(3038),
    [anon_sym_concept] = ACTIONS(3038),
    [anon_sym_co_return] = ACTIONS(3038),
    [anon_sym_co_yield] = ACTIONS(3038),
    [anon_sym_R_DQUOTE] = ACTIONS(3036),
    [anon_sym_LR_DQUOTE] = ACTIONS(3036),
    [anon_sym_uR_DQUOTE] = ACTIONS(3036),
    [anon_sym_UR_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3036),
    [anon_sym_co_await] = ACTIONS(3038),
    [anon_sym_new] = ACTIONS(3038),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3038),
    [anon_sym_discard] = ACTIONS(3038),
    [anon_sym_precise] = ACTIONS(3038),
    [anon_sym_shared] = ACTIONS(3038),
    [anon_sym_groupshared] = ACTIONS(3038),
    [anon_sym_uniform] = ACTIONS(3038),
    [anon_sym_row_major] = ACTIONS(3038),
    [anon_sym_column_major] = ACTIONS(3038),
    [anon_sym_globallycoherent] = ACTIONS(3038),
    [anon_sym_centroid] = ACTIONS(3038),
    [anon_sym_noperspective] = ACTIONS(3038),
    [anon_sym_nointerpolation] = ACTIONS(3038),
    [anon_sym_sample] = ACTIONS(3038),
    [anon_sym_linear] = ACTIONS(3038),
    [anon_sym_snorm] = ACTIONS(3038),
    [anon_sym_unorm] = ACTIONS(3038),
    [anon_sym_point] = ACTIONS(3038),
    [anon_sym_line] = ACTIONS(3038),
    [anon_sym_triangleadj] = ACTIONS(3038),
    [anon_sym_lineadj] = ACTIONS(3038),
    [anon_sym_triangle] = ACTIONS(3038),
    [anon_sym_cbuffer] = ACTIONS(3038),
    [anon_sym_interface] = ACTIONS(3038),
    [anon_sym_extension] = ACTIONS(3038),
  },
  [770] = {
    [sym_identifier] = ACTIONS(3520),
    [aux_sym_preproc_include_token1] = ACTIONS(3520),
    [aux_sym_preproc_def_token1] = ACTIONS(3520),
    [aux_sym_preproc_if_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3520),
    [sym_preproc_directive] = ACTIONS(3520),
    [anon_sym_LPAREN2] = ACTIONS(3518),
    [anon_sym_BANG] = ACTIONS(3518),
    [anon_sym_TILDE] = ACTIONS(3518),
    [anon_sym_DASH] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3520),
    [anon_sym_STAR] = ACTIONS(3518),
    [anon_sym_AMP_AMP] = ACTIONS(3518),
    [anon_sym_AMP] = ACTIONS(3520),
    [anon_sym_SEMI] = ACTIONS(3518),
    [anon_sym___extension__] = ACTIONS(3520),
    [anon_sym_typedef] = ACTIONS(3520),
    [anon_sym_in] = ACTIONS(3520),
    [anon_sym_out] = ACTIONS(3520),
    [anon_sym_inout] = ACTIONS(3520),
    [anon_sym_virtual] = ACTIONS(3520),
    [anon_sym_extern] = ACTIONS(3520),
    [anon_sym___attribute__] = ACTIONS(3520),
    [anon_sym___attribute] = ACTIONS(3520),
    [anon_sym_using] = ACTIONS(3520),
    [anon_sym_COLON_COLON] = ACTIONS(3518),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3518),
    [anon_sym___declspec] = ACTIONS(3520),
    [anon_sym___based] = ACTIONS(3520),
    [anon_sym___cdecl] = ACTIONS(3520),
    [anon_sym___clrcall] = ACTIONS(3520),
    [anon_sym___stdcall] = ACTIONS(3520),
    [anon_sym___fastcall] = ACTIONS(3520),
    [anon_sym___thiscall] = ACTIONS(3520),
    [anon_sym___vectorcall] = ACTIONS(3520),
    [anon_sym_LBRACE] = ACTIONS(3518),
    [anon_sym_RBRACE] = ACTIONS(3518),
    [anon_sym_signed] = ACTIONS(3520),
    [anon_sym_unsigned] = ACTIONS(3520),
    [anon_sym_long] = ACTIONS(3520),
    [anon_sym_short] = ACTIONS(3520),
    [anon_sym_LBRACK] = ACTIONS(3520),
    [anon_sym_static] = ACTIONS(3520),
    [anon_sym_register] = ACTIONS(3520),
    [anon_sym_inline] = ACTIONS(3520),
    [anon_sym___inline] = ACTIONS(3520),
    [anon_sym___inline__] = ACTIONS(3520),
    [anon_sym___forceinline] = ACTIONS(3520),
    [anon_sym_thread_local] = ACTIONS(3520),
    [anon_sym___thread] = ACTIONS(3520),
    [anon_sym_const] = ACTIONS(3520),
    [anon_sym_constexpr] = ACTIONS(3520),
    [anon_sym_volatile] = ACTIONS(3520),
    [anon_sym_restrict] = ACTIONS(3520),
    [anon_sym___restrict__] = ACTIONS(3520),
    [anon_sym__Atomic] = ACTIONS(3520),
    [anon_sym__Noreturn] = ACTIONS(3520),
    [anon_sym_noreturn] = ACTIONS(3520),
    [anon_sym__Nonnull] = ACTIONS(3520),
    [anon_sym_mutable] = ACTIONS(3520),
    [anon_sym_constinit] = ACTIONS(3520),
    [anon_sym_consteval] = ACTIONS(3520),
    [anon_sym_alignas] = ACTIONS(3520),
    [anon_sym__Alignas] = ACTIONS(3520),
    [sym_primitive_type] = ACTIONS(3520),
    [anon_sym_enum] = ACTIONS(3520),
    [anon_sym_class] = ACTIONS(3520),
    [anon_sym_struct] = ACTIONS(3520),
    [anon_sym_union] = ACTIONS(3520),
    [anon_sym_if] = ACTIONS(3520),
    [anon_sym_else] = ACTIONS(3520),
    [anon_sym_switch] = ACTIONS(3520),
    [anon_sym_case] = ACTIONS(3520),
    [anon_sym_default] = ACTIONS(3520),
    [anon_sym_while] = ACTIONS(3520),
    [anon_sym_do] = ACTIONS(3520),
    [anon_sym_for] = ACTIONS(3520),
    [anon_sym_return] = ACTIONS(3520),
    [anon_sym_break] = ACTIONS(3520),
    [anon_sym_continue] = ACTIONS(3520),
    [anon_sym_goto] = ACTIONS(3520),
    [anon_sym___try] = ACTIONS(3520),
    [anon_sym___leave] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3520),
    [anon_sym_compl] = ACTIONS(3520),
    [anon_sym_DASH_DASH] = ACTIONS(3518),
    [anon_sym_PLUS_PLUS] = ACTIONS(3518),
    [anon_sym_sizeof] = ACTIONS(3520),
    [anon_sym___alignof__] = ACTIONS(3520),
    [anon_sym___alignof] = ACTIONS(3520),
    [anon_sym__alignof] = ACTIONS(3520),
    [anon_sym_alignof] = ACTIONS(3520),
    [anon_sym__Alignof] = ACTIONS(3520),
    [anon_sym_offsetof] = ACTIONS(3520),
    [anon_sym__Generic] = ACTIONS(3520),
    [anon_sym_asm] = ACTIONS(3520),
    [anon_sym___asm__] = ACTIONS(3520),
    [anon_sym___asm] = ACTIONS(3520),
    [sym_number_literal] = ACTIONS(3518),
    [anon_sym_L_SQUOTE] = ACTIONS(3518),
    [anon_sym_u_SQUOTE] = ACTIONS(3518),
    [anon_sym_U_SQUOTE] = ACTIONS(3518),
    [anon_sym_u8_SQUOTE] = ACTIONS(3518),
    [anon_sym_SQUOTE] = ACTIONS(3518),
    [anon_sym_L_DQUOTE] = ACTIONS(3518),
    [anon_sym_u_DQUOTE] = ACTIONS(3518),
    [anon_sym_U_DQUOTE] = ACTIONS(3518),
    [anon_sym_u8_DQUOTE] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(3518),
    [sym_true] = ACTIONS(3520),
    [sym_false] = ACTIONS(3520),
    [anon_sym_NULL] = ACTIONS(3520),
    [anon_sym_nullptr] = ACTIONS(3520),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3520),
    [anon_sym_let] = ACTIONS(3520),
    [anon_sym_This] = ACTIONS(3520),
    [anon_sym_decltype] = ACTIONS(3520),
    [anon_sym_explicit] = ACTIONS(3520),
    [anon_sym_typename] = ACTIONS(3520),
    [anon_sym_template] = ACTIONS(3520),
    [anon_sym_operator] = ACTIONS(3520),
    [anon_sym_try] = ACTIONS(3520),
    [anon_sym_delete] = ACTIONS(3520),
    [anon_sym_throw] = ACTIONS(3520),
    [anon_sym_namespace] = ACTIONS(3520),
    [anon_sym_static_assert] = ACTIONS(3520),
    [anon_sym_concept] = ACTIONS(3520),
    [anon_sym_co_return] = ACTIONS(3520),
    [anon_sym_co_yield] = ACTIONS(3520),
    [anon_sym_R_DQUOTE] = ACTIONS(3518),
    [anon_sym_LR_DQUOTE] = ACTIONS(3518),
    [anon_sym_uR_DQUOTE] = ACTIONS(3518),
    [anon_sym_UR_DQUOTE] = ACTIONS(3518),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3518),
    [anon_sym_co_await] = ACTIONS(3520),
    [anon_sym_new] = ACTIONS(3520),
    [anon_sym_requires] = ACTIONS(3520),
    [sym_this] = ACTIONS(3520),
    [anon_sym_discard] = ACTIONS(3520),
    [anon_sym_precise] = ACTIONS(3520),
    [anon_sym_shared] = ACTIONS(3520),
    [anon_sym_groupshared] = ACTIONS(3520),
    [anon_sym_uniform] = ACTIONS(3520),
    [anon_sym_row_major] = ACTIONS(3520),
    [anon_sym_column_major] = ACTIONS(3520),
    [anon_sym_globallycoherent] = ACTIONS(3520),
    [anon_sym_centroid] = ACTIONS(3520),
    [anon_sym_noperspective] = ACTIONS(3520),
    [anon_sym_nointerpolation] = ACTIONS(3520),
    [anon_sym_sample] = ACTIONS(3520),
    [anon_sym_linear] = ACTIONS(3520),
    [anon_sym_snorm] = ACTIONS(3520),
    [anon_sym_unorm] = ACTIONS(3520),
    [anon_sym_point] = ACTIONS(3520),
    [anon_sym_line] = ACTIONS(3520),
    [anon_sym_triangleadj] = ACTIONS(3520),
    [anon_sym_lineadj] = ACTIONS(3520),
    [anon_sym_triangle] = ACTIONS(3520),
    [anon_sym_cbuffer] = ACTIONS(3520),
    [anon_sym_interface] = ACTIONS(3520),
    [anon_sym_extension] = ACTIONS(3520),
  },
  [771] = {
    [sym_identifier] = ACTIONS(3042),
    [aux_sym_preproc_include_token1] = ACTIONS(3042),
    [aux_sym_preproc_def_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3042),
    [sym_preproc_directive] = ACTIONS(3042),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym_typedef] = ACTIONS(3042),
    [anon_sym_in] = ACTIONS(3042),
    [anon_sym_out] = ACTIONS(3042),
    [anon_sym_inout] = ACTIONS(3042),
    [anon_sym_virtual] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_using] = ACTIONS(3042),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym___cdecl] = ACTIONS(3042),
    [anon_sym___clrcall] = ACTIONS(3042),
    [anon_sym___stdcall] = ACTIONS(3042),
    [anon_sym___fastcall] = ACTIONS(3042),
    [anon_sym___thiscall] = ACTIONS(3042),
    [anon_sym___vectorcall] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_RBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym___inline] = ACTIONS(3042),
    [anon_sym___inline__] = ACTIONS(3042),
    [anon_sym___forceinline] = ACTIONS(3042),
    [anon_sym_thread_local] = ACTIONS(3042),
    [anon_sym___thread] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_enum] = ACTIONS(3042),
    [anon_sym_class] = ACTIONS(3042),
    [anon_sym_struct] = ACTIONS(3042),
    [anon_sym_union] = ACTIONS(3042),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_switch] = ACTIONS(3042),
    [anon_sym_case] = ACTIONS(3042),
    [anon_sym_default] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_for] = ACTIONS(3042),
    [anon_sym_return] = ACTIONS(3042),
    [anon_sym_break] = ACTIONS(3042),
    [anon_sym_continue] = ACTIONS(3042),
    [anon_sym_goto] = ACTIONS(3042),
    [anon_sym___try] = ACTIONS(3042),
    [anon_sym___leave] = ACTIONS(3042),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_compl] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_sizeof] = ACTIONS(3042),
    [anon_sym___alignof__] = ACTIONS(3042),
    [anon_sym___alignof] = ACTIONS(3042),
    [anon_sym__alignof] = ACTIONS(3042),
    [anon_sym_alignof] = ACTIONS(3042),
    [anon_sym__Alignof] = ACTIONS(3042),
    [anon_sym_offsetof] = ACTIONS(3042),
    [anon_sym__Generic] = ACTIONS(3042),
    [anon_sym_asm] = ACTIONS(3042),
    [anon_sym___asm__] = ACTIONS(3042),
    [anon_sym___asm] = ACTIONS(3042),
    [anon_sym_DOT] = ACTIONS(3042),
    [sym_number_literal] = ACTIONS(3040),
    [anon_sym_L_SQUOTE] = ACTIONS(3040),
    [anon_sym_u_SQUOTE] = ACTIONS(3040),
    [anon_sym_U_SQUOTE] = ACTIONS(3040),
    [anon_sym_u8_SQUOTE] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(3040),
    [anon_sym_L_DQUOTE] = ACTIONS(3040),
    [anon_sym_u_DQUOTE] = ACTIONS(3040),
    [anon_sym_U_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8_DQUOTE] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [sym_true] = ACTIONS(3042),
    [sym_false] = ACTIONS(3042),
    [anon_sym_NULL] = ACTIONS(3042),
    [anon_sym_nullptr] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3042),
    [anon_sym_let] = ACTIONS(3042),
    [anon_sym_This] = ACTIONS(3042),
    [anon_sym_decltype] = ACTIONS(3042),
    [anon_sym_explicit] = ACTIONS(3042),
    [anon_sym_typename] = ACTIONS(3042),
    [anon_sym_template] = ACTIONS(3042),
    [anon_sym_operator] = ACTIONS(3042),
    [anon_sym_try] = ACTIONS(3042),
    [anon_sym_delete] = ACTIONS(3042),
    [anon_sym_throw] = ACTIONS(3042),
    [anon_sym_namespace] = ACTIONS(3042),
    [anon_sym_static_assert] = ACTIONS(3042),
    [anon_sym_concept] = ACTIONS(3042),
    [anon_sym_co_return] = ACTIONS(3042),
    [anon_sym_co_yield] = ACTIONS(3042),
    [anon_sym_R_DQUOTE] = ACTIONS(3040),
    [anon_sym_LR_DQUOTE] = ACTIONS(3040),
    [anon_sym_uR_DQUOTE] = ACTIONS(3040),
    [anon_sym_UR_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3040),
    [anon_sym_co_await] = ACTIONS(3042),
    [anon_sym_new] = ACTIONS(3042),
    [anon_sym_requires] = ACTIONS(3042),
    [sym_this] = ACTIONS(3042),
    [anon_sym_discard] = ACTIONS(3042),
    [anon_sym_precise] = ACTIONS(3042),
    [anon_sym_shared] = ACTIONS(3042),
    [anon_sym_groupshared] = ACTIONS(3042),
    [anon_sym_uniform] = ACTIONS(3042),
    [anon_sym_row_major] = ACTIONS(3042),
    [anon_sym_column_major] = ACTIONS(3042),
    [anon_sym_globallycoherent] = ACTIONS(3042),
    [anon_sym_centroid] = ACTIONS(3042),
    [anon_sym_noperspective] = ACTIONS(3042),
    [anon_sym_nointerpolation] = ACTIONS(3042),
    [anon_sym_sample] = ACTIONS(3042),
    [anon_sym_linear] = ACTIONS(3042),
    [anon_sym_snorm] = ACTIONS(3042),
    [anon_sym_unorm] = ACTIONS(3042),
    [anon_sym_point] = ACTIONS(3042),
    [anon_sym_line] = ACTIONS(3042),
    [anon_sym_triangleadj] = ACTIONS(3042),
    [anon_sym_lineadj] = ACTIONS(3042),
    [anon_sym_triangle] = ACTIONS(3042),
    [anon_sym_cbuffer] = ACTIONS(3042),
    [anon_sym_interface] = ACTIONS(3042),
    [anon_sym_extension] = ACTIONS(3042),
  },
  [772] = {
    [sym_identifier] = ACTIONS(3046),
    [aux_sym_preproc_include_token1] = ACTIONS(3046),
    [aux_sym_preproc_def_token1] = ACTIONS(3046),
    [aux_sym_preproc_if_token1] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3046),
    [sym_preproc_directive] = ACTIONS(3046),
    [anon_sym_LPAREN2] = ACTIONS(3044),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3044),
    [anon_sym_DASH] = ACTIONS(3046),
    [anon_sym_PLUS] = ACTIONS(3046),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3046),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym___extension__] = ACTIONS(3046),
    [anon_sym_typedef] = ACTIONS(3046),
    [anon_sym_in] = ACTIONS(3046),
    [anon_sym_out] = ACTIONS(3046),
    [anon_sym_inout] = ACTIONS(3046),
    [anon_sym_virtual] = ACTIONS(3046),
    [anon_sym_extern] = ACTIONS(3046),
    [anon_sym___attribute__] = ACTIONS(3046),
    [anon_sym___attribute] = ACTIONS(3046),
    [anon_sym_using] = ACTIONS(3046),
    [anon_sym_COLON_COLON] = ACTIONS(3044),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3044),
    [anon_sym___declspec] = ACTIONS(3046),
    [anon_sym___based] = ACTIONS(3046),
    [anon_sym___cdecl] = ACTIONS(3046),
    [anon_sym___clrcall] = ACTIONS(3046),
    [anon_sym___stdcall] = ACTIONS(3046),
    [anon_sym___fastcall] = ACTIONS(3046),
    [anon_sym___thiscall] = ACTIONS(3046),
    [anon_sym___vectorcall] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3044),
    [anon_sym_RBRACE] = ACTIONS(3044),
    [anon_sym_signed] = ACTIONS(3046),
    [anon_sym_unsigned] = ACTIONS(3046),
    [anon_sym_long] = ACTIONS(3046),
    [anon_sym_short] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_static] = ACTIONS(3046),
    [anon_sym_register] = ACTIONS(3046),
    [anon_sym_inline] = ACTIONS(3046),
    [anon_sym___inline] = ACTIONS(3046),
    [anon_sym___inline__] = ACTIONS(3046),
    [anon_sym___forceinline] = ACTIONS(3046),
    [anon_sym_thread_local] = ACTIONS(3046),
    [anon_sym___thread] = ACTIONS(3046),
    [anon_sym_const] = ACTIONS(3046),
    [anon_sym_constexpr] = ACTIONS(3046),
    [anon_sym_volatile] = ACTIONS(3046),
    [anon_sym_restrict] = ACTIONS(3046),
    [anon_sym___restrict__] = ACTIONS(3046),
    [anon_sym__Atomic] = ACTIONS(3046),
    [anon_sym__Noreturn] = ACTIONS(3046),
    [anon_sym_noreturn] = ACTIONS(3046),
    [anon_sym__Nonnull] = ACTIONS(3046),
    [anon_sym_mutable] = ACTIONS(3046),
    [anon_sym_constinit] = ACTIONS(3046),
    [anon_sym_consteval] = ACTIONS(3046),
    [anon_sym_alignas] = ACTIONS(3046),
    [anon_sym__Alignas] = ACTIONS(3046),
    [sym_primitive_type] = ACTIONS(3046),
    [anon_sym_enum] = ACTIONS(3046),
    [anon_sym_class] = ACTIONS(3046),
    [anon_sym_struct] = ACTIONS(3046),
    [anon_sym_union] = ACTIONS(3046),
    [anon_sym_if] = ACTIONS(3046),
    [anon_sym_switch] = ACTIONS(3046),
    [anon_sym_case] = ACTIONS(3046),
    [anon_sym_default] = ACTIONS(3046),
    [anon_sym_while] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_for] = ACTIONS(3046),
    [anon_sym_return] = ACTIONS(3046),
    [anon_sym_break] = ACTIONS(3046),
    [anon_sym_continue] = ACTIONS(3046),
    [anon_sym_goto] = ACTIONS(3046),
    [anon_sym___try] = ACTIONS(3046),
    [anon_sym___leave] = ACTIONS(3046),
    [anon_sym_not] = ACTIONS(3046),
    [anon_sym_compl] = ACTIONS(3046),
    [anon_sym_DASH_DASH] = ACTIONS(3044),
    [anon_sym_PLUS_PLUS] = ACTIONS(3044),
    [anon_sym_sizeof] = ACTIONS(3046),
    [anon_sym___alignof__] = ACTIONS(3046),
    [anon_sym___alignof] = ACTIONS(3046),
    [anon_sym__alignof] = ACTIONS(3046),
    [anon_sym_alignof] = ACTIONS(3046),
    [anon_sym__Alignof] = ACTIONS(3046),
    [anon_sym_offsetof] = ACTIONS(3046),
    [anon_sym__Generic] = ACTIONS(3046),
    [anon_sym_asm] = ACTIONS(3046),
    [anon_sym___asm__] = ACTIONS(3046),
    [anon_sym___asm] = ACTIONS(3046),
    [anon_sym_DOT] = ACTIONS(3046),
    [sym_number_literal] = ACTIONS(3044),
    [anon_sym_L_SQUOTE] = ACTIONS(3044),
    [anon_sym_u_SQUOTE] = ACTIONS(3044),
    [anon_sym_U_SQUOTE] = ACTIONS(3044),
    [anon_sym_u8_SQUOTE] = ACTIONS(3044),
    [anon_sym_SQUOTE] = ACTIONS(3044),
    [anon_sym_L_DQUOTE] = ACTIONS(3044),
    [anon_sym_u_DQUOTE] = ACTIONS(3044),
    [anon_sym_U_DQUOTE] = ACTIONS(3044),
    [anon_sym_u8_DQUOTE] = ACTIONS(3044),
    [anon_sym_DQUOTE] = ACTIONS(3044),
    [sym_true] = ACTIONS(3046),
    [sym_false] = ACTIONS(3046),
    [anon_sym_NULL] = ACTIONS(3046),
    [anon_sym_nullptr] = ACTIONS(3046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3046),
    [anon_sym_let] = ACTIONS(3046),
    [anon_sym_This] = ACTIONS(3046),
    [anon_sym_decltype] = ACTIONS(3046),
    [anon_sym_explicit] = ACTIONS(3046),
    [anon_sym_typename] = ACTIONS(3046),
    [anon_sym_template] = ACTIONS(3046),
    [anon_sym_operator] = ACTIONS(3046),
    [anon_sym_try] = ACTIONS(3046),
    [anon_sym_delete] = ACTIONS(3046),
    [anon_sym_throw] = ACTIONS(3046),
    [anon_sym_namespace] = ACTIONS(3046),
    [anon_sym_static_assert] = ACTIONS(3046),
    [anon_sym_concept] = ACTIONS(3046),
    [anon_sym_co_return] = ACTIONS(3046),
    [anon_sym_co_yield] = ACTIONS(3046),
    [anon_sym_R_DQUOTE] = ACTIONS(3044),
    [anon_sym_LR_DQUOTE] = ACTIONS(3044),
    [anon_sym_uR_DQUOTE] = ACTIONS(3044),
    [anon_sym_UR_DQUOTE] = ACTIONS(3044),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3044),
    [anon_sym_co_await] = ACTIONS(3046),
    [anon_sym_new] = ACTIONS(3046),
    [anon_sym_requires] = ACTIONS(3046),
    [sym_this] = ACTIONS(3046),
    [anon_sym_discard] = ACTIONS(3046),
    [anon_sym_precise] = ACTIONS(3046),
    [anon_sym_shared] = ACTIONS(3046),
    [anon_sym_groupshared] = ACTIONS(3046),
    [anon_sym_uniform] = ACTIONS(3046),
    [anon_sym_row_major] = ACTIONS(3046),
    [anon_sym_column_major] = ACTIONS(3046),
    [anon_sym_globallycoherent] = ACTIONS(3046),
    [anon_sym_centroid] = ACTIONS(3046),
    [anon_sym_noperspective] = ACTIONS(3046),
    [anon_sym_nointerpolation] = ACTIONS(3046),
    [anon_sym_sample] = ACTIONS(3046),
    [anon_sym_linear] = ACTIONS(3046),
    [anon_sym_snorm] = ACTIONS(3046),
    [anon_sym_unorm] = ACTIONS(3046),
    [anon_sym_point] = ACTIONS(3046),
    [anon_sym_line] = ACTIONS(3046),
    [anon_sym_triangleadj] = ACTIONS(3046),
    [anon_sym_lineadj] = ACTIONS(3046),
    [anon_sym_triangle] = ACTIONS(3046),
    [anon_sym_cbuffer] = ACTIONS(3046),
    [anon_sym_interface] = ACTIONS(3046),
    [anon_sym_extension] = ACTIONS(3046),
  },
  [773] = {
    [sym_identifier] = ACTIONS(3050),
    [aux_sym_preproc_include_token1] = ACTIONS(3050),
    [aux_sym_preproc_def_token1] = ACTIONS(3050),
    [aux_sym_preproc_if_token1] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3050),
    [sym_preproc_directive] = ACTIONS(3050),
    [anon_sym_LPAREN2] = ACTIONS(3048),
    [anon_sym_BANG] = ACTIONS(3048),
    [anon_sym_TILDE] = ACTIONS(3048),
    [anon_sym_DASH] = ACTIONS(3050),
    [anon_sym_PLUS] = ACTIONS(3050),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_AMP_AMP] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3050),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym___extension__] = ACTIONS(3050),
    [anon_sym_typedef] = ACTIONS(3050),
    [anon_sym_in] = ACTIONS(3050),
    [anon_sym_out] = ACTIONS(3050),
    [anon_sym_inout] = ACTIONS(3050),
    [anon_sym_virtual] = ACTIONS(3050),
    [anon_sym_extern] = ACTIONS(3050),
    [anon_sym___attribute__] = ACTIONS(3050),
    [anon_sym___attribute] = ACTIONS(3050),
    [anon_sym_using] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3048),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3048),
    [anon_sym___declspec] = ACTIONS(3050),
    [anon_sym___based] = ACTIONS(3050),
    [anon_sym___cdecl] = ACTIONS(3050),
    [anon_sym___clrcall] = ACTIONS(3050),
    [anon_sym___stdcall] = ACTIONS(3050),
    [anon_sym___fastcall] = ACTIONS(3050),
    [anon_sym___thiscall] = ACTIONS(3050),
    [anon_sym___vectorcall] = ACTIONS(3050),
    [anon_sym_LBRACE] = ACTIONS(3048),
    [anon_sym_RBRACE] = ACTIONS(3048),
    [anon_sym_signed] = ACTIONS(3050),
    [anon_sym_unsigned] = ACTIONS(3050),
    [anon_sym_long] = ACTIONS(3050),
    [anon_sym_short] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_static] = ACTIONS(3050),
    [anon_sym_register] = ACTIONS(3050),
    [anon_sym_inline] = ACTIONS(3050),
    [anon_sym___inline] = ACTIONS(3050),
    [anon_sym___inline__] = ACTIONS(3050),
    [anon_sym___forceinline] = ACTIONS(3050),
    [anon_sym_thread_local] = ACTIONS(3050),
    [anon_sym___thread] = ACTIONS(3050),
    [anon_sym_const] = ACTIONS(3050),
    [anon_sym_constexpr] = ACTIONS(3050),
    [anon_sym_volatile] = ACTIONS(3050),
    [anon_sym_restrict] = ACTIONS(3050),
    [anon_sym___restrict__] = ACTIONS(3050),
    [anon_sym__Atomic] = ACTIONS(3050),
    [anon_sym__Noreturn] = ACTIONS(3050),
    [anon_sym_noreturn] = ACTIONS(3050),
    [anon_sym__Nonnull] = ACTIONS(3050),
    [anon_sym_mutable] = ACTIONS(3050),
    [anon_sym_constinit] = ACTIONS(3050),
    [anon_sym_consteval] = ACTIONS(3050),
    [anon_sym_alignas] = ACTIONS(3050),
    [anon_sym__Alignas] = ACTIONS(3050),
    [sym_primitive_type] = ACTIONS(3050),
    [anon_sym_enum] = ACTIONS(3050),
    [anon_sym_class] = ACTIONS(3050),
    [anon_sym_struct] = ACTIONS(3050),
    [anon_sym_union] = ACTIONS(3050),
    [anon_sym_if] = ACTIONS(3050),
    [anon_sym_switch] = ACTIONS(3050),
    [anon_sym_case] = ACTIONS(3050),
    [anon_sym_default] = ACTIONS(3050),
    [anon_sym_while] = ACTIONS(3050),
    [anon_sym_do] = ACTIONS(3050),
    [anon_sym_for] = ACTIONS(3050),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_break] = ACTIONS(3050),
    [anon_sym_continue] = ACTIONS(3050),
    [anon_sym_goto] = ACTIONS(3050),
    [anon_sym___try] = ACTIONS(3050),
    [anon_sym___leave] = ACTIONS(3050),
    [anon_sym_not] = ACTIONS(3050),
    [anon_sym_compl] = ACTIONS(3050),
    [anon_sym_DASH_DASH] = ACTIONS(3048),
    [anon_sym_PLUS_PLUS] = ACTIONS(3048),
    [anon_sym_sizeof] = ACTIONS(3050),
    [anon_sym___alignof__] = ACTIONS(3050),
    [anon_sym___alignof] = ACTIONS(3050),
    [anon_sym__alignof] = ACTIONS(3050),
    [anon_sym_alignof] = ACTIONS(3050),
    [anon_sym__Alignof] = ACTIONS(3050),
    [anon_sym_offsetof] = ACTIONS(3050),
    [anon_sym__Generic] = ACTIONS(3050),
    [anon_sym_asm] = ACTIONS(3050),
    [anon_sym___asm__] = ACTIONS(3050),
    [anon_sym___asm] = ACTIONS(3050),
    [anon_sym_DOT] = ACTIONS(3050),
    [sym_number_literal] = ACTIONS(3048),
    [anon_sym_L_SQUOTE] = ACTIONS(3048),
    [anon_sym_u_SQUOTE] = ACTIONS(3048),
    [anon_sym_U_SQUOTE] = ACTIONS(3048),
    [anon_sym_u8_SQUOTE] = ACTIONS(3048),
    [anon_sym_SQUOTE] = ACTIONS(3048),
    [anon_sym_L_DQUOTE] = ACTIONS(3048),
    [anon_sym_u_DQUOTE] = ACTIONS(3048),
    [anon_sym_U_DQUOTE] = ACTIONS(3048),
    [anon_sym_u8_DQUOTE] = ACTIONS(3048),
    [anon_sym_DQUOTE] = ACTIONS(3048),
    [sym_true] = ACTIONS(3050),
    [sym_false] = ACTIONS(3050),
    [anon_sym_NULL] = ACTIONS(3050),
    [anon_sym_nullptr] = ACTIONS(3050),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3050),
    [anon_sym_let] = ACTIONS(3050),
    [anon_sym_This] = ACTIONS(3050),
    [anon_sym_decltype] = ACTIONS(3050),
    [anon_sym_explicit] = ACTIONS(3050),
    [anon_sym_typename] = ACTIONS(3050),
    [anon_sym_template] = ACTIONS(3050),
    [anon_sym_operator] = ACTIONS(3050),
    [anon_sym_try] = ACTIONS(3050),
    [anon_sym_delete] = ACTIONS(3050),
    [anon_sym_throw] = ACTIONS(3050),
    [anon_sym_namespace] = ACTIONS(3050),
    [anon_sym_static_assert] = ACTIONS(3050),
    [anon_sym_concept] = ACTIONS(3050),
    [anon_sym_co_return] = ACTIONS(3050),
    [anon_sym_co_yield] = ACTIONS(3050),
    [anon_sym_R_DQUOTE] = ACTIONS(3048),
    [anon_sym_LR_DQUOTE] = ACTIONS(3048),
    [anon_sym_uR_DQUOTE] = ACTIONS(3048),
    [anon_sym_UR_DQUOTE] = ACTIONS(3048),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3048),
    [anon_sym_co_await] = ACTIONS(3050),
    [anon_sym_new] = ACTIONS(3050),
    [anon_sym_requires] = ACTIONS(3050),
    [sym_this] = ACTIONS(3050),
    [anon_sym_discard] = ACTIONS(3050),
    [anon_sym_precise] = ACTIONS(3050),
    [anon_sym_shared] = ACTIONS(3050),
    [anon_sym_groupshared] = ACTIONS(3050),
    [anon_sym_uniform] = ACTIONS(3050),
    [anon_sym_row_major] = ACTIONS(3050),
    [anon_sym_column_major] = ACTIONS(3050),
    [anon_sym_globallycoherent] = ACTIONS(3050),
    [anon_sym_centroid] = ACTIONS(3050),
    [anon_sym_noperspective] = ACTIONS(3050),
    [anon_sym_nointerpolation] = ACTIONS(3050),
    [anon_sym_sample] = ACTIONS(3050),
    [anon_sym_linear] = ACTIONS(3050),
    [anon_sym_snorm] = ACTIONS(3050),
    [anon_sym_unorm] = ACTIONS(3050),
    [anon_sym_point] = ACTIONS(3050),
    [anon_sym_line] = ACTIONS(3050),
    [anon_sym_triangleadj] = ACTIONS(3050),
    [anon_sym_lineadj] = ACTIONS(3050),
    [anon_sym_triangle] = ACTIONS(3050),
    [anon_sym_cbuffer] = ACTIONS(3050),
    [anon_sym_interface] = ACTIONS(3050),
    [anon_sym_extension] = ACTIONS(3050),
  },
  [774] = {
    [sym_identifier] = ACTIONS(3042),
    [aux_sym_preproc_include_token1] = ACTIONS(3042),
    [aux_sym_preproc_def_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3042),
    [sym_preproc_directive] = ACTIONS(3042),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym_typedef] = ACTIONS(3042),
    [anon_sym_in] = ACTIONS(3042),
    [anon_sym_out] = ACTIONS(3042),
    [anon_sym_inout] = ACTIONS(3042),
    [anon_sym_virtual] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_using] = ACTIONS(3042),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym___cdecl] = ACTIONS(3042),
    [anon_sym___clrcall] = ACTIONS(3042),
    [anon_sym___stdcall] = ACTIONS(3042),
    [anon_sym___fastcall] = ACTIONS(3042),
    [anon_sym___thiscall] = ACTIONS(3042),
    [anon_sym___vectorcall] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_RBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym___inline] = ACTIONS(3042),
    [anon_sym___inline__] = ACTIONS(3042),
    [anon_sym___forceinline] = ACTIONS(3042),
    [anon_sym_thread_local] = ACTIONS(3042),
    [anon_sym___thread] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_enum] = ACTIONS(3042),
    [anon_sym_class] = ACTIONS(3042),
    [anon_sym_struct] = ACTIONS(3042),
    [anon_sym_union] = ACTIONS(3042),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_switch] = ACTIONS(3042),
    [anon_sym_case] = ACTIONS(3042),
    [anon_sym_default] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_for] = ACTIONS(3042),
    [anon_sym_return] = ACTIONS(3042),
    [anon_sym_break] = ACTIONS(3042),
    [anon_sym_continue] = ACTIONS(3042),
    [anon_sym_goto] = ACTIONS(3042),
    [anon_sym___try] = ACTIONS(3042),
    [anon_sym___leave] = ACTIONS(3042),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_compl] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_sizeof] = ACTIONS(3042),
    [anon_sym___alignof__] = ACTIONS(3042),
    [anon_sym___alignof] = ACTIONS(3042),
    [anon_sym__alignof] = ACTIONS(3042),
    [anon_sym_alignof] = ACTIONS(3042),
    [anon_sym__Alignof] = ACTIONS(3042),
    [anon_sym_offsetof] = ACTIONS(3042),
    [anon_sym__Generic] = ACTIONS(3042),
    [anon_sym_asm] = ACTIONS(3042),
    [anon_sym___asm__] = ACTIONS(3042),
    [anon_sym___asm] = ACTIONS(3042),
    [anon_sym_DOT] = ACTIONS(3042),
    [sym_number_literal] = ACTIONS(3040),
    [anon_sym_L_SQUOTE] = ACTIONS(3040),
    [anon_sym_u_SQUOTE] = ACTIONS(3040),
    [anon_sym_U_SQUOTE] = ACTIONS(3040),
    [anon_sym_u8_SQUOTE] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(3040),
    [anon_sym_L_DQUOTE] = ACTIONS(3040),
    [anon_sym_u_DQUOTE] = ACTIONS(3040),
    [anon_sym_U_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8_DQUOTE] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [sym_true] = ACTIONS(3042),
    [sym_false] = ACTIONS(3042),
    [anon_sym_NULL] = ACTIONS(3042),
    [anon_sym_nullptr] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3042),
    [anon_sym_let] = ACTIONS(3042),
    [anon_sym_This] = ACTIONS(3042),
    [anon_sym_decltype] = ACTIONS(3042),
    [anon_sym_explicit] = ACTIONS(3042),
    [anon_sym_typename] = ACTIONS(3042),
    [anon_sym_template] = ACTIONS(3042),
    [anon_sym_operator] = ACTIONS(3042),
    [anon_sym_try] = ACTIONS(3042),
    [anon_sym_delete] = ACTIONS(3042),
    [anon_sym_throw] = ACTIONS(3042),
    [anon_sym_namespace] = ACTIONS(3042),
    [anon_sym_static_assert] = ACTIONS(3042),
    [anon_sym_concept] = ACTIONS(3042),
    [anon_sym_co_return] = ACTIONS(3042),
    [anon_sym_co_yield] = ACTIONS(3042),
    [anon_sym_R_DQUOTE] = ACTIONS(3040),
    [anon_sym_LR_DQUOTE] = ACTIONS(3040),
    [anon_sym_uR_DQUOTE] = ACTIONS(3040),
    [anon_sym_UR_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3040),
    [anon_sym_co_await] = ACTIONS(3042),
    [anon_sym_new] = ACTIONS(3042),
    [anon_sym_requires] = ACTIONS(3042),
    [sym_this] = ACTIONS(3042),
    [anon_sym_discard] = ACTIONS(3042),
    [anon_sym_precise] = ACTIONS(3042),
    [anon_sym_shared] = ACTIONS(3042),
    [anon_sym_groupshared] = ACTIONS(3042),
    [anon_sym_uniform] = ACTIONS(3042),
    [anon_sym_row_major] = ACTIONS(3042),
    [anon_sym_column_major] = ACTIONS(3042),
    [anon_sym_globallycoherent] = ACTIONS(3042),
    [anon_sym_centroid] = ACTIONS(3042),
    [anon_sym_noperspective] = ACTIONS(3042),
    [anon_sym_nointerpolation] = ACTIONS(3042),
    [anon_sym_sample] = ACTIONS(3042),
    [anon_sym_linear] = ACTIONS(3042),
    [anon_sym_snorm] = ACTIONS(3042),
    [anon_sym_unorm] = ACTIONS(3042),
    [anon_sym_point] = ACTIONS(3042),
    [anon_sym_line] = ACTIONS(3042),
    [anon_sym_triangleadj] = ACTIONS(3042),
    [anon_sym_lineadj] = ACTIONS(3042),
    [anon_sym_triangle] = ACTIONS(3042),
    [anon_sym_cbuffer] = ACTIONS(3042),
    [anon_sym_interface] = ACTIONS(3042),
    [anon_sym_extension] = ACTIONS(3042),
  },
  [775] = {
    [sym_identifier] = ACTIONS(3042),
    [aux_sym_preproc_include_token1] = ACTIONS(3042),
    [aux_sym_preproc_def_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3042),
    [sym_preproc_directive] = ACTIONS(3042),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym_typedef] = ACTIONS(3042),
    [anon_sym_in] = ACTIONS(3042),
    [anon_sym_out] = ACTIONS(3042),
    [anon_sym_inout] = ACTIONS(3042),
    [anon_sym_virtual] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_using] = ACTIONS(3042),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym___cdecl] = ACTIONS(3042),
    [anon_sym___clrcall] = ACTIONS(3042),
    [anon_sym___stdcall] = ACTIONS(3042),
    [anon_sym___fastcall] = ACTIONS(3042),
    [anon_sym___thiscall] = ACTIONS(3042),
    [anon_sym___vectorcall] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_RBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym___inline] = ACTIONS(3042),
    [anon_sym___inline__] = ACTIONS(3042),
    [anon_sym___forceinline] = ACTIONS(3042),
    [anon_sym_thread_local] = ACTIONS(3042),
    [anon_sym___thread] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_enum] = ACTIONS(3042),
    [anon_sym_class] = ACTIONS(3042),
    [anon_sym_struct] = ACTIONS(3042),
    [anon_sym_union] = ACTIONS(3042),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_switch] = ACTIONS(3042),
    [anon_sym_case] = ACTIONS(3042),
    [anon_sym_default] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_for] = ACTIONS(3042),
    [anon_sym_return] = ACTIONS(3042),
    [anon_sym_break] = ACTIONS(3042),
    [anon_sym_continue] = ACTIONS(3042),
    [anon_sym_goto] = ACTIONS(3042),
    [anon_sym___try] = ACTIONS(3042),
    [anon_sym___leave] = ACTIONS(3042),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_compl] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_sizeof] = ACTIONS(3042),
    [anon_sym___alignof__] = ACTIONS(3042),
    [anon_sym___alignof] = ACTIONS(3042),
    [anon_sym__alignof] = ACTIONS(3042),
    [anon_sym_alignof] = ACTIONS(3042),
    [anon_sym__Alignof] = ACTIONS(3042),
    [anon_sym_offsetof] = ACTIONS(3042),
    [anon_sym__Generic] = ACTIONS(3042),
    [anon_sym_asm] = ACTIONS(3042),
    [anon_sym___asm__] = ACTIONS(3042),
    [anon_sym___asm] = ACTIONS(3042),
    [anon_sym_DOT] = ACTIONS(3042),
    [sym_number_literal] = ACTIONS(3040),
    [anon_sym_L_SQUOTE] = ACTIONS(3040),
    [anon_sym_u_SQUOTE] = ACTIONS(3040),
    [anon_sym_U_SQUOTE] = ACTIONS(3040),
    [anon_sym_u8_SQUOTE] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(3040),
    [anon_sym_L_DQUOTE] = ACTIONS(3040),
    [anon_sym_u_DQUOTE] = ACTIONS(3040),
    [anon_sym_U_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8_DQUOTE] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [sym_true] = ACTIONS(3042),
    [sym_false] = ACTIONS(3042),
    [anon_sym_NULL] = ACTIONS(3042),
    [anon_sym_nullptr] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3042),
    [anon_sym_let] = ACTIONS(3042),
    [anon_sym_This] = ACTIONS(3042),
    [anon_sym_decltype] = ACTIONS(3042),
    [anon_sym_explicit] = ACTIONS(3042),
    [anon_sym_typename] = ACTIONS(3042),
    [anon_sym_template] = ACTIONS(3042),
    [anon_sym_operator] = ACTIONS(3042),
    [anon_sym_try] = ACTIONS(3042),
    [anon_sym_delete] = ACTIONS(3042),
    [anon_sym_throw] = ACTIONS(3042),
    [anon_sym_namespace] = ACTIONS(3042),
    [anon_sym_static_assert] = ACTIONS(3042),
    [anon_sym_concept] = ACTIONS(3042),
    [anon_sym_co_return] = ACTIONS(3042),
    [anon_sym_co_yield] = ACTIONS(3042),
    [anon_sym_R_DQUOTE] = ACTIONS(3040),
    [anon_sym_LR_DQUOTE] = ACTIONS(3040),
    [anon_sym_uR_DQUOTE] = ACTIONS(3040),
    [anon_sym_UR_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3040),
    [anon_sym_co_await] = ACTIONS(3042),
    [anon_sym_new] = ACTIONS(3042),
    [anon_sym_requires] = ACTIONS(3042),
    [sym_this] = ACTIONS(3042),
    [anon_sym_discard] = ACTIONS(3042),
    [anon_sym_precise] = ACTIONS(3042),
    [anon_sym_shared] = ACTIONS(3042),
    [anon_sym_groupshared] = ACTIONS(3042),
    [anon_sym_uniform] = ACTIONS(3042),
    [anon_sym_row_major] = ACTIONS(3042),
    [anon_sym_column_major] = ACTIONS(3042),
    [anon_sym_globallycoherent] = ACTIONS(3042),
    [anon_sym_centroid] = ACTIONS(3042),
    [anon_sym_noperspective] = ACTIONS(3042),
    [anon_sym_nointerpolation] = ACTIONS(3042),
    [anon_sym_sample] = ACTIONS(3042),
    [anon_sym_linear] = ACTIONS(3042),
    [anon_sym_snorm] = ACTIONS(3042),
    [anon_sym_unorm] = ACTIONS(3042),
    [anon_sym_point] = ACTIONS(3042),
    [anon_sym_line] = ACTIONS(3042),
    [anon_sym_triangleadj] = ACTIONS(3042),
    [anon_sym_lineadj] = ACTIONS(3042),
    [anon_sym_triangle] = ACTIONS(3042),
    [anon_sym_cbuffer] = ACTIONS(3042),
    [anon_sym_interface] = ACTIONS(3042),
    [anon_sym_extension] = ACTIONS(3042),
  },
  [776] = {
    [sym_identifier] = ACTIONS(2956),
    [aux_sym_preproc_include_token1] = ACTIONS(2956),
    [aux_sym_preproc_def_token1] = ACTIONS(2956),
    [aux_sym_preproc_if_token1] = ACTIONS(2956),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2956),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2956),
    [sym_preproc_directive] = ACTIONS(2956),
    [anon_sym_LPAREN2] = ACTIONS(2954),
    [anon_sym_BANG] = ACTIONS(2954),
    [anon_sym_TILDE] = ACTIONS(2954),
    [anon_sym_DASH] = ACTIONS(2956),
    [anon_sym_PLUS] = ACTIONS(2956),
    [anon_sym_STAR] = ACTIONS(2954),
    [anon_sym_AMP_AMP] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(2956),
    [anon_sym_SEMI] = ACTIONS(2954),
    [anon_sym___extension__] = ACTIONS(2956),
    [anon_sym_typedef] = ACTIONS(2956),
    [anon_sym_in] = ACTIONS(2956),
    [anon_sym_out] = ACTIONS(2956),
    [anon_sym_inout] = ACTIONS(2956),
    [anon_sym_virtual] = ACTIONS(2956),
    [anon_sym_extern] = ACTIONS(2956),
    [anon_sym___attribute__] = ACTIONS(2956),
    [anon_sym___attribute] = ACTIONS(2956),
    [anon_sym_using] = ACTIONS(2956),
    [anon_sym_COLON_COLON] = ACTIONS(2954),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2954),
    [anon_sym___declspec] = ACTIONS(2956),
    [anon_sym___based] = ACTIONS(2956),
    [anon_sym___cdecl] = ACTIONS(2956),
    [anon_sym___clrcall] = ACTIONS(2956),
    [anon_sym___stdcall] = ACTIONS(2956),
    [anon_sym___fastcall] = ACTIONS(2956),
    [anon_sym___thiscall] = ACTIONS(2956),
    [anon_sym___vectorcall] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(2954),
    [anon_sym_signed] = ACTIONS(2956),
    [anon_sym_unsigned] = ACTIONS(2956),
    [anon_sym_long] = ACTIONS(2956),
    [anon_sym_short] = ACTIONS(2956),
    [anon_sym_LBRACK] = ACTIONS(2956),
    [anon_sym_static] = ACTIONS(2956),
    [anon_sym_register] = ACTIONS(2956),
    [anon_sym_inline] = ACTIONS(2956),
    [anon_sym___inline] = ACTIONS(2956),
    [anon_sym___inline__] = ACTIONS(2956),
    [anon_sym___forceinline] = ACTIONS(2956),
    [anon_sym_thread_local] = ACTIONS(2956),
    [anon_sym___thread] = ACTIONS(2956),
    [anon_sym_const] = ACTIONS(2956),
    [anon_sym_constexpr] = ACTIONS(2956),
    [anon_sym_volatile] = ACTIONS(2956),
    [anon_sym_restrict] = ACTIONS(2956),
    [anon_sym___restrict__] = ACTIONS(2956),
    [anon_sym__Atomic] = ACTIONS(2956),
    [anon_sym__Noreturn] = ACTIONS(2956),
    [anon_sym_noreturn] = ACTIONS(2956),
    [anon_sym__Nonnull] = ACTIONS(2956),
    [anon_sym_mutable] = ACTIONS(2956),
    [anon_sym_constinit] = ACTIONS(2956),
    [anon_sym_consteval] = ACTIONS(2956),
    [anon_sym_alignas] = ACTIONS(2956),
    [anon_sym__Alignas] = ACTIONS(2956),
    [sym_primitive_type] = ACTIONS(2956),
    [anon_sym_enum] = ACTIONS(2956),
    [anon_sym_class] = ACTIONS(2956),
    [anon_sym_struct] = ACTIONS(2956),
    [anon_sym_union] = ACTIONS(2956),
    [anon_sym_if] = ACTIONS(2956),
    [anon_sym_switch] = ACTIONS(2956),
    [anon_sym_case] = ACTIONS(2956),
    [anon_sym_default] = ACTIONS(2956),
    [anon_sym_while] = ACTIONS(2956),
    [anon_sym_do] = ACTIONS(2956),
    [anon_sym_for] = ACTIONS(2956),
    [anon_sym_return] = ACTIONS(2956),
    [anon_sym_break] = ACTIONS(2956),
    [anon_sym_continue] = ACTIONS(2956),
    [anon_sym_goto] = ACTIONS(2956),
    [anon_sym___try] = ACTIONS(2956),
    [anon_sym___leave] = ACTIONS(2956),
    [anon_sym_not] = ACTIONS(2956),
    [anon_sym_compl] = ACTIONS(2956),
    [anon_sym_DASH_DASH] = ACTIONS(2954),
    [anon_sym_PLUS_PLUS] = ACTIONS(2954),
    [anon_sym_sizeof] = ACTIONS(2956),
    [anon_sym___alignof__] = ACTIONS(2956),
    [anon_sym___alignof] = ACTIONS(2956),
    [anon_sym__alignof] = ACTIONS(2956),
    [anon_sym_alignof] = ACTIONS(2956),
    [anon_sym__Alignof] = ACTIONS(2956),
    [anon_sym_offsetof] = ACTIONS(2956),
    [anon_sym__Generic] = ACTIONS(2956),
    [anon_sym_asm] = ACTIONS(2956),
    [anon_sym___asm__] = ACTIONS(2956),
    [anon_sym___asm] = ACTIONS(2956),
    [anon_sym_DOT] = ACTIONS(2956),
    [sym_number_literal] = ACTIONS(2954),
    [anon_sym_L_SQUOTE] = ACTIONS(2954),
    [anon_sym_u_SQUOTE] = ACTIONS(2954),
    [anon_sym_U_SQUOTE] = ACTIONS(2954),
    [anon_sym_u8_SQUOTE] = ACTIONS(2954),
    [anon_sym_SQUOTE] = ACTIONS(2954),
    [anon_sym_L_DQUOTE] = ACTIONS(2954),
    [anon_sym_u_DQUOTE] = ACTIONS(2954),
    [anon_sym_U_DQUOTE] = ACTIONS(2954),
    [anon_sym_u8_DQUOTE] = ACTIONS(2954),
    [anon_sym_DQUOTE] = ACTIONS(2954),
    [sym_true] = ACTIONS(2956),
    [sym_false] = ACTIONS(2956),
    [anon_sym_NULL] = ACTIONS(2956),
    [anon_sym_nullptr] = ACTIONS(2956),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2956),
    [anon_sym_let] = ACTIONS(2956),
    [anon_sym_This] = ACTIONS(2956),
    [anon_sym_decltype] = ACTIONS(2956),
    [anon_sym_explicit] = ACTIONS(2956),
    [anon_sym_typename] = ACTIONS(2956),
    [anon_sym_template] = ACTIONS(2956),
    [anon_sym_operator] = ACTIONS(2956),
    [anon_sym_try] = ACTIONS(2956),
    [anon_sym_delete] = ACTIONS(2956),
    [anon_sym_throw] = ACTIONS(2956),
    [anon_sym_namespace] = ACTIONS(2956),
    [anon_sym_static_assert] = ACTIONS(2956),
    [anon_sym_concept] = ACTIONS(2956),
    [anon_sym_co_return] = ACTIONS(2956),
    [anon_sym_co_yield] = ACTIONS(2956),
    [anon_sym_R_DQUOTE] = ACTIONS(2954),
    [anon_sym_LR_DQUOTE] = ACTIONS(2954),
    [anon_sym_uR_DQUOTE] = ACTIONS(2954),
    [anon_sym_UR_DQUOTE] = ACTIONS(2954),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2954),
    [anon_sym_co_await] = ACTIONS(2956),
    [anon_sym_new] = ACTIONS(2956),
    [anon_sym_requires] = ACTIONS(2956),
    [sym_this] = ACTIONS(2956),
    [anon_sym_discard] = ACTIONS(2956),
    [anon_sym_precise] = ACTIONS(2956),
    [anon_sym_shared] = ACTIONS(2956),
    [anon_sym_groupshared] = ACTIONS(2956),
    [anon_sym_uniform] = ACTIONS(2956),
    [anon_sym_row_major] = ACTIONS(2956),
    [anon_sym_column_major] = ACTIONS(2956),
    [anon_sym_globallycoherent] = ACTIONS(2956),
    [anon_sym_centroid] = ACTIONS(2956),
    [anon_sym_noperspective] = ACTIONS(2956),
    [anon_sym_nointerpolation] = ACTIONS(2956),
    [anon_sym_sample] = ACTIONS(2956),
    [anon_sym_linear] = ACTIONS(2956),
    [anon_sym_snorm] = ACTIONS(2956),
    [anon_sym_unorm] = ACTIONS(2956),
    [anon_sym_point] = ACTIONS(2956),
    [anon_sym_line] = ACTIONS(2956),
    [anon_sym_triangleadj] = ACTIONS(2956),
    [anon_sym_lineadj] = ACTIONS(2956),
    [anon_sym_triangle] = ACTIONS(2956),
    [anon_sym_cbuffer] = ACTIONS(2956),
    [anon_sym_interface] = ACTIONS(2956),
    [anon_sym_extension] = ACTIONS(2956),
  },
  [777] = {
    [sym_identifier] = ACTIONS(2960),
    [aux_sym_preproc_include_token1] = ACTIONS(2960),
    [aux_sym_preproc_def_token1] = ACTIONS(2960),
    [aux_sym_preproc_if_token1] = ACTIONS(2960),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2960),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2960),
    [sym_preproc_directive] = ACTIONS(2960),
    [anon_sym_LPAREN2] = ACTIONS(2958),
    [anon_sym_BANG] = ACTIONS(2958),
    [anon_sym_TILDE] = ACTIONS(2958),
    [anon_sym_DASH] = ACTIONS(2960),
    [anon_sym_PLUS] = ACTIONS(2960),
    [anon_sym_STAR] = ACTIONS(2958),
    [anon_sym_AMP_AMP] = ACTIONS(2958),
    [anon_sym_AMP] = ACTIONS(2960),
    [anon_sym_SEMI] = ACTIONS(2958),
    [anon_sym___extension__] = ACTIONS(2960),
    [anon_sym_typedef] = ACTIONS(2960),
    [anon_sym_in] = ACTIONS(2960),
    [anon_sym_out] = ACTIONS(2960),
    [anon_sym_inout] = ACTIONS(2960),
    [anon_sym_virtual] = ACTIONS(2960),
    [anon_sym_extern] = ACTIONS(2960),
    [anon_sym___attribute__] = ACTIONS(2960),
    [anon_sym___attribute] = ACTIONS(2960),
    [anon_sym_using] = ACTIONS(2960),
    [anon_sym_COLON_COLON] = ACTIONS(2958),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2958),
    [anon_sym___declspec] = ACTIONS(2960),
    [anon_sym___based] = ACTIONS(2960),
    [anon_sym___cdecl] = ACTIONS(2960),
    [anon_sym___clrcall] = ACTIONS(2960),
    [anon_sym___stdcall] = ACTIONS(2960),
    [anon_sym___fastcall] = ACTIONS(2960),
    [anon_sym___thiscall] = ACTIONS(2960),
    [anon_sym___vectorcall] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2958),
    [anon_sym_RBRACE] = ACTIONS(2958),
    [anon_sym_signed] = ACTIONS(2960),
    [anon_sym_unsigned] = ACTIONS(2960),
    [anon_sym_long] = ACTIONS(2960),
    [anon_sym_short] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_static] = ACTIONS(2960),
    [anon_sym_register] = ACTIONS(2960),
    [anon_sym_inline] = ACTIONS(2960),
    [anon_sym___inline] = ACTIONS(2960),
    [anon_sym___inline__] = ACTIONS(2960),
    [anon_sym___forceinline] = ACTIONS(2960),
    [anon_sym_thread_local] = ACTIONS(2960),
    [anon_sym___thread] = ACTIONS(2960),
    [anon_sym_const] = ACTIONS(2960),
    [anon_sym_constexpr] = ACTIONS(2960),
    [anon_sym_volatile] = ACTIONS(2960),
    [anon_sym_restrict] = ACTIONS(2960),
    [anon_sym___restrict__] = ACTIONS(2960),
    [anon_sym__Atomic] = ACTIONS(2960),
    [anon_sym__Noreturn] = ACTIONS(2960),
    [anon_sym_noreturn] = ACTIONS(2960),
    [anon_sym__Nonnull] = ACTIONS(2960),
    [anon_sym_mutable] = ACTIONS(2960),
    [anon_sym_constinit] = ACTIONS(2960),
    [anon_sym_consteval] = ACTIONS(2960),
    [anon_sym_alignas] = ACTIONS(2960),
    [anon_sym__Alignas] = ACTIONS(2960),
    [sym_primitive_type] = ACTIONS(2960),
    [anon_sym_enum] = ACTIONS(2960),
    [anon_sym_class] = ACTIONS(2960),
    [anon_sym_struct] = ACTIONS(2960),
    [anon_sym_union] = ACTIONS(2960),
    [anon_sym_if] = ACTIONS(2960),
    [anon_sym_switch] = ACTIONS(2960),
    [anon_sym_case] = ACTIONS(2960),
    [anon_sym_default] = ACTIONS(2960),
    [anon_sym_while] = ACTIONS(2960),
    [anon_sym_do] = ACTIONS(2960),
    [anon_sym_for] = ACTIONS(2960),
    [anon_sym_return] = ACTIONS(2960),
    [anon_sym_break] = ACTIONS(2960),
    [anon_sym_continue] = ACTIONS(2960),
    [anon_sym_goto] = ACTIONS(2960),
    [anon_sym___try] = ACTIONS(2960),
    [anon_sym___leave] = ACTIONS(2960),
    [anon_sym_not] = ACTIONS(2960),
    [anon_sym_compl] = ACTIONS(2960),
    [anon_sym_DASH_DASH] = ACTIONS(2958),
    [anon_sym_PLUS_PLUS] = ACTIONS(2958),
    [anon_sym_sizeof] = ACTIONS(2960),
    [anon_sym___alignof__] = ACTIONS(2960),
    [anon_sym___alignof] = ACTIONS(2960),
    [anon_sym__alignof] = ACTIONS(2960),
    [anon_sym_alignof] = ACTIONS(2960),
    [anon_sym__Alignof] = ACTIONS(2960),
    [anon_sym_offsetof] = ACTIONS(2960),
    [anon_sym__Generic] = ACTIONS(2960),
    [anon_sym_asm] = ACTIONS(2960),
    [anon_sym___asm__] = ACTIONS(2960),
    [anon_sym___asm] = ACTIONS(2960),
    [anon_sym_DOT] = ACTIONS(2960),
    [sym_number_literal] = ACTIONS(2958),
    [anon_sym_L_SQUOTE] = ACTIONS(2958),
    [anon_sym_u_SQUOTE] = ACTIONS(2958),
    [anon_sym_U_SQUOTE] = ACTIONS(2958),
    [anon_sym_u8_SQUOTE] = ACTIONS(2958),
    [anon_sym_SQUOTE] = ACTIONS(2958),
    [anon_sym_L_DQUOTE] = ACTIONS(2958),
    [anon_sym_u_DQUOTE] = ACTIONS(2958),
    [anon_sym_U_DQUOTE] = ACTIONS(2958),
    [anon_sym_u8_DQUOTE] = ACTIONS(2958),
    [anon_sym_DQUOTE] = ACTIONS(2958),
    [sym_true] = ACTIONS(2960),
    [sym_false] = ACTIONS(2960),
    [anon_sym_NULL] = ACTIONS(2960),
    [anon_sym_nullptr] = ACTIONS(2960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2960),
    [anon_sym_let] = ACTIONS(2960),
    [anon_sym_This] = ACTIONS(2960),
    [anon_sym_decltype] = ACTIONS(2960),
    [anon_sym_explicit] = ACTIONS(2960),
    [anon_sym_typename] = ACTIONS(2960),
    [anon_sym_template] = ACTIONS(2960),
    [anon_sym_operator] = ACTIONS(2960),
    [anon_sym_try] = ACTIONS(2960),
    [anon_sym_delete] = ACTIONS(2960),
    [anon_sym_throw] = ACTIONS(2960),
    [anon_sym_namespace] = ACTIONS(2960),
    [anon_sym_static_assert] = ACTIONS(2960),
    [anon_sym_concept] = ACTIONS(2960),
    [anon_sym_co_return] = ACTIONS(2960),
    [anon_sym_co_yield] = ACTIONS(2960),
    [anon_sym_R_DQUOTE] = ACTIONS(2958),
    [anon_sym_LR_DQUOTE] = ACTIONS(2958),
    [anon_sym_uR_DQUOTE] = ACTIONS(2958),
    [anon_sym_UR_DQUOTE] = ACTIONS(2958),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2958),
    [anon_sym_co_await] = ACTIONS(2960),
    [anon_sym_new] = ACTIONS(2960),
    [anon_sym_requires] = ACTIONS(2960),
    [sym_this] = ACTIONS(2960),
    [anon_sym_discard] = ACTIONS(2960),
    [anon_sym_precise] = ACTIONS(2960),
    [anon_sym_shared] = ACTIONS(2960),
    [anon_sym_groupshared] = ACTIONS(2960),
    [anon_sym_uniform] = ACTIONS(2960),
    [anon_sym_row_major] = ACTIONS(2960),
    [anon_sym_column_major] = ACTIONS(2960),
    [anon_sym_globallycoherent] = ACTIONS(2960),
    [anon_sym_centroid] = ACTIONS(2960),
    [anon_sym_noperspective] = ACTIONS(2960),
    [anon_sym_nointerpolation] = ACTIONS(2960),
    [anon_sym_sample] = ACTIONS(2960),
    [anon_sym_linear] = ACTIONS(2960),
    [anon_sym_snorm] = ACTIONS(2960),
    [anon_sym_unorm] = ACTIONS(2960),
    [anon_sym_point] = ACTIONS(2960),
    [anon_sym_line] = ACTIONS(2960),
    [anon_sym_triangleadj] = ACTIONS(2960),
    [anon_sym_lineadj] = ACTIONS(2960),
    [anon_sym_triangle] = ACTIONS(2960),
    [anon_sym_cbuffer] = ACTIONS(2960),
    [anon_sym_interface] = ACTIONS(2960),
    [anon_sym_extension] = ACTIONS(2960),
  },
  [778] = {
    [sym_identifier] = ACTIONS(2964),
    [aux_sym_preproc_include_token1] = ACTIONS(2964),
    [aux_sym_preproc_def_token1] = ACTIONS(2964),
    [aux_sym_preproc_if_token1] = ACTIONS(2964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2964),
    [sym_preproc_directive] = ACTIONS(2964),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_BANG] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2964),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_STAR] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym___extension__] = ACTIONS(2964),
    [anon_sym_typedef] = ACTIONS(2964),
    [anon_sym_in] = ACTIONS(2964),
    [anon_sym_out] = ACTIONS(2964),
    [anon_sym_inout] = ACTIONS(2964),
    [anon_sym_virtual] = ACTIONS(2964),
    [anon_sym_extern] = ACTIONS(2964),
    [anon_sym___attribute__] = ACTIONS(2964),
    [anon_sym___attribute] = ACTIONS(2964),
    [anon_sym_using] = ACTIONS(2964),
    [anon_sym_COLON_COLON] = ACTIONS(2962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2962),
    [anon_sym___declspec] = ACTIONS(2964),
    [anon_sym___based] = ACTIONS(2964),
    [anon_sym___cdecl] = ACTIONS(2964),
    [anon_sym___clrcall] = ACTIONS(2964),
    [anon_sym___stdcall] = ACTIONS(2964),
    [anon_sym___fastcall] = ACTIONS(2964),
    [anon_sym___thiscall] = ACTIONS(2964),
    [anon_sym___vectorcall] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [anon_sym_signed] = ACTIONS(2964),
    [anon_sym_unsigned] = ACTIONS(2964),
    [anon_sym_long] = ACTIONS(2964),
    [anon_sym_short] = ACTIONS(2964),
    [anon_sym_LBRACK] = ACTIONS(2964),
    [anon_sym_static] = ACTIONS(2964),
    [anon_sym_register] = ACTIONS(2964),
    [anon_sym_inline] = ACTIONS(2964),
    [anon_sym___inline] = ACTIONS(2964),
    [anon_sym___inline__] = ACTIONS(2964),
    [anon_sym___forceinline] = ACTIONS(2964),
    [anon_sym_thread_local] = ACTIONS(2964),
    [anon_sym___thread] = ACTIONS(2964),
    [anon_sym_const] = ACTIONS(2964),
    [anon_sym_constexpr] = ACTIONS(2964),
    [anon_sym_volatile] = ACTIONS(2964),
    [anon_sym_restrict] = ACTIONS(2964),
    [anon_sym___restrict__] = ACTIONS(2964),
    [anon_sym__Atomic] = ACTIONS(2964),
    [anon_sym__Noreturn] = ACTIONS(2964),
    [anon_sym_noreturn] = ACTIONS(2964),
    [anon_sym__Nonnull] = ACTIONS(2964),
    [anon_sym_mutable] = ACTIONS(2964),
    [anon_sym_constinit] = ACTIONS(2964),
    [anon_sym_consteval] = ACTIONS(2964),
    [anon_sym_alignas] = ACTIONS(2964),
    [anon_sym__Alignas] = ACTIONS(2964),
    [sym_primitive_type] = ACTIONS(2964),
    [anon_sym_enum] = ACTIONS(2964),
    [anon_sym_class] = ACTIONS(2964),
    [anon_sym_struct] = ACTIONS(2964),
    [anon_sym_union] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2964),
    [anon_sym_switch] = ACTIONS(2964),
    [anon_sym_case] = ACTIONS(2964),
    [anon_sym_default] = ACTIONS(2964),
    [anon_sym_while] = ACTIONS(2964),
    [anon_sym_do] = ACTIONS(2964),
    [anon_sym_for] = ACTIONS(2964),
    [anon_sym_return] = ACTIONS(2964),
    [anon_sym_break] = ACTIONS(2964),
    [anon_sym_continue] = ACTIONS(2964),
    [anon_sym_goto] = ACTIONS(2964),
    [anon_sym___try] = ACTIONS(2964),
    [anon_sym___leave] = ACTIONS(2964),
    [anon_sym_not] = ACTIONS(2964),
    [anon_sym_compl] = ACTIONS(2964),
    [anon_sym_DASH_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_PLUS] = ACTIONS(2962),
    [anon_sym_sizeof] = ACTIONS(2964),
    [anon_sym___alignof__] = ACTIONS(2964),
    [anon_sym___alignof] = ACTIONS(2964),
    [anon_sym__alignof] = ACTIONS(2964),
    [anon_sym_alignof] = ACTIONS(2964),
    [anon_sym__Alignof] = ACTIONS(2964),
    [anon_sym_offsetof] = ACTIONS(2964),
    [anon_sym__Generic] = ACTIONS(2964),
    [anon_sym_asm] = ACTIONS(2964),
    [anon_sym___asm__] = ACTIONS(2964),
    [anon_sym___asm] = ACTIONS(2964),
    [anon_sym_DOT] = ACTIONS(2964),
    [sym_number_literal] = ACTIONS(2962),
    [anon_sym_L_SQUOTE] = ACTIONS(2962),
    [anon_sym_u_SQUOTE] = ACTIONS(2962),
    [anon_sym_U_SQUOTE] = ACTIONS(2962),
    [anon_sym_u8_SQUOTE] = ACTIONS(2962),
    [anon_sym_SQUOTE] = ACTIONS(2962),
    [anon_sym_L_DQUOTE] = ACTIONS(2962),
    [anon_sym_u_DQUOTE] = ACTIONS(2962),
    [anon_sym_U_DQUOTE] = ACTIONS(2962),
    [anon_sym_u8_DQUOTE] = ACTIONS(2962),
    [anon_sym_DQUOTE] = ACTIONS(2962),
    [sym_true] = ACTIONS(2964),
    [sym_false] = ACTIONS(2964),
    [anon_sym_NULL] = ACTIONS(2964),
    [anon_sym_nullptr] = ACTIONS(2964),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2964),
    [anon_sym_let] = ACTIONS(2964),
    [anon_sym_This] = ACTIONS(2964),
    [anon_sym_decltype] = ACTIONS(2964),
    [anon_sym_explicit] = ACTIONS(2964),
    [anon_sym_typename] = ACTIONS(2964),
    [anon_sym_template] = ACTIONS(2964),
    [anon_sym_operator] = ACTIONS(2964),
    [anon_sym_try] = ACTIONS(2964),
    [anon_sym_delete] = ACTIONS(2964),
    [anon_sym_throw] = ACTIONS(2964),
    [anon_sym_namespace] = ACTIONS(2964),
    [anon_sym_static_assert] = ACTIONS(2964),
    [anon_sym_concept] = ACTIONS(2964),
    [anon_sym_co_return] = ACTIONS(2964),
    [anon_sym_co_yield] = ACTIONS(2964),
    [anon_sym_R_DQUOTE] = ACTIONS(2962),
    [anon_sym_LR_DQUOTE] = ACTIONS(2962),
    [anon_sym_uR_DQUOTE] = ACTIONS(2962),
    [anon_sym_UR_DQUOTE] = ACTIONS(2962),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2962),
    [anon_sym_co_await] = ACTIONS(2964),
    [anon_sym_new] = ACTIONS(2964),
    [anon_sym_requires] = ACTIONS(2964),
    [sym_this] = ACTIONS(2964),
    [anon_sym_discard] = ACTIONS(2964),
    [anon_sym_precise] = ACTIONS(2964),
    [anon_sym_shared] = ACTIONS(2964),
    [anon_sym_groupshared] = ACTIONS(2964),
    [anon_sym_uniform] = ACTIONS(2964),
    [anon_sym_row_major] = ACTIONS(2964),
    [anon_sym_column_major] = ACTIONS(2964),
    [anon_sym_globallycoherent] = ACTIONS(2964),
    [anon_sym_centroid] = ACTIONS(2964),
    [anon_sym_noperspective] = ACTIONS(2964),
    [anon_sym_nointerpolation] = ACTIONS(2964),
    [anon_sym_sample] = ACTIONS(2964),
    [anon_sym_linear] = ACTIONS(2964),
    [anon_sym_snorm] = ACTIONS(2964),
    [anon_sym_unorm] = ACTIONS(2964),
    [anon_sym_point] = ACTIONS(2964),
    [anon_sym_line] = ACTIONS(2964),
    [anon_sym_triangleadj] = ACTIONS(2964),
    [anon_sym_lineadj] = ACTIONS(2964),
    [anon_sym_triangle] = ACTIONS(2964),
    [anon_sym_cbuffer] = ACTIONS(2964),
    [anon_sym_interface] = ACTIONS(2964),
    [anon_sym_extension] = ACTIONS(2964),
  },
  [779] = {
    [sym_identifier] = ACTIONS(2974),
    [aux_sym_preproc_include_token1] = ACTIONS(2974),
    [aux_sym_preproc_def_token1] = ACTIONS(2974),
    [aux_sym_preproc_if_token1] = ACTIONS(2974),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2974),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2974),
    [sym_preproc_directive] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_BANG] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym___extension__] = ACTIONS(2974),
    [anon_sym_typedef] = ACTIONS(2974),
    [anon_sym_in] = ACTIONS(2974),
    [anon_sym_out] = ACTIONS(2974),
    [anon_sym_inout] = ACTIONS(2974),
    [anon_sym_virtual] = ACTIONS(2974),
    [anon_sym_extern] = ACTIONS(2974),
    [anon_sym___attribute__] = ACTIONS(2974),
    [anon_sym___attribute] = ACTIONS(2974),
    [anon_sym_using] = ACTIONS(2974),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2974),
    [anon_sym___based] = ACTIONS(2974),
    [anon_sym___cdecl] = ACTIONS(2974),
    [anon_sym___clrcall] = ACTIONS(2974),
    [anon_sym___stdcall] = ACTIONS(2974),
    [anon_sym___fastcall] = ACTIONS(2974),
    [anon_sym___thiscall] = ACTIONS(2974),
    [anon_sym___vectorcall] = ACTIONS(2974),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_signed] = ACTIONS(2974),
    [anon_sym_unsigned] = ACTIONS(2974),
    [anon_sym_long] = ACTIONS(2974),
    [anon_sym_short] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [anon_sym_static] = ACTIONS(2974),
    [anon_sym_register] = ACTIONS(2974),
    [anon_sym_inline] = ACTIONS(2974),
    [anon_sym___inline] = ACTIONS(2974),
    [anon_sym___inline__] = ACTIONS(2974),
    [anon_sym___forceinline] = ACTIONS(2974),
    [anon_sym_thread_local] = ACTIONS(2974),
    [anon_sym___thread] = ACTIONS(2974),
    [anon_sym_const] = ACTIONS(2974),
    [anon_sym_constexpr] = ACTIONS(2974),
    [anon_sym_volatile] = ACTIONS(2974),
    [anon_sym_restrict] = ACTIONS(2974),
    [anon_sym___restrict__] = ACTIONS(2974),
    [anon_sym__Atomic] = ACTIONS(2974),
    [anon_sym__Noreturn] = ACTIONS(2974),
    [anon_sym_noreturn] = ACTIONS(2974),
    [anon_sym__Nonnull] = ACTIONS(2974),
    [anon_sym_mutable] = ACTIONS(2974),
    [anon_sym_constinit] = ACTIONS(2974),
    [anon_sym_consteval] = ACTIONS(2974),
    [anon_sym_alignas] = ACTIONS(2974),
    [anon_sym__Alignas] = ACTIONS(2974),
    [sym_primitive_type] = ACTIONS(2974),
    [anon_sym_enum] = ACTIONS(2974),
    [anon_sym_class] = ACTIONS(2974),
    [anon_sym_struct] = ACTIONS(2974),
    [anon_sym_union] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2974),
    [anon_sym_switch] = ACTIONS(2974),
    [anon_sym_case] = ACTIONS(2974),
    [anon_sym_default] = ACTIONS(2974),
    [anon_sym_while] = ACTIONS(2974),
    [anon_sym_do] = ACTIONS(2974),
    [anon_sym_for] = ACTIONS(2974),
    [anon_sym_return] = ACTIONS(2974),
    [anon_sym_break] = ACTIONS(2974),
    [anon_sym_continue] = ACTIONS(2974),
    [anon_sym_goto] = ACTIONS(2974),
    [anon_sym___try] = ACTIONS(2974),
    [anon_sym___leave] = ACTIONS(2974),
    [anon_sym_not] = ACTIONS(2974),
    [anon_sym_compl] = ACTIONS(2974),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_sizeof] = ACTIONS(2974),
    [anon_sym___alignof__] = ACTIONS(2974),
    [anon_sym___alignof] = ACTIONS(2974),
    [anon_sym__alignof] = ACTIONS(2974),
    [anon_sym_alignof] = ACTIONS(2974),
    [anon_sym__Alignof] = ACTIONS(2974),
    [anon_sym_offsetof] = ACTIONS(2974),
    [anon_sym__Generic] = ACTIONS(2974),
    [anon_sym_asm] = ACTIONS(2974),
    [anon_sym___asm__] = ACTIONS(2974),
    [anon_sym___asm] = ACTIONS(2974),
    [anon_sym_DOT] = ACTIONS(2974),
    [sym_number_literal] = ACTIONS(2972),
    [anon_sym_L_SQUOTE] = ACTIONS(2972),
    [anon_sym_u_SQUOTE] = ACTIONS(2972),
    [anon_sym_U_SQUOTE] = ACTIONS(2972),
    [anon_sym_u8_SQUOTE] = ACTIONS(2972),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [anon_sym_L_DQUOTE] = ACTIONS(2972),
    [anon_sym_u_DQUOTE] = ACTIONS(2972),
    [anon_sym_U_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE] = ACTIONS(2972),
    [sym_true] = ACTIONS(2974),
    [sym_false] = ACTIONS(2974),
    [anon_sym_NULL] = ACTIONS(2974),
    [anon_sym_nullptr] = ACTIONS(2974),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_This] = ACTIONS(2974),
    [anon_sym_decltype] = ACTIONS(2974),
    [anon_sym_explicit] = ACTIONS(2974),
    [anon_sym_typename] = ACTIONS(2974),
    [anon_sym_template] = ACTIONS(2974),
    [anon_sym_operator] = ACTIONS(2974),
    [anon_sym_try] = ACTIONS(2974),
    [anon_sym_delete] = ACTIONS(2974),
    [anon_sym_throw] = ACTIONS(2974),
    [anon_sym_namespace] = ACTIONS(2974),
    [anon_sym_static_assert] = ACTIONS(2974),
    [anon_sym_concept] = ACTIONS(2974),
    [anon_sym_co_return] = ACTIONS(2974),
    [anon_sym_co_yield] = ACTIONS(2974),
    [anon_sym_R_DQUOTE] = ACTIONS(2972),
    [anon_sym_LR_DQUOTE] = ACTIONS(2972),
    [anon_sym_uR_DQUOTE] = ACTIONS(2972),
    [anon_sym_UR_DQUOTE] = ACTIONS(2972),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2972),
    [anon_sym_co_await] = ACTIONS(2974),
    [anon_sym_new] = ACTIONS(2974),
    [anon_sym_requires] = ACTIONS(2974),
    [sym_this] = ACTIONS(2974),
    [anon_sym_discard] = ACTIONS(2974),
    [anon_sym_precise] = ACTIONS(2974),
    [anon_sym_shared] = ACTIONS(2974),
    [anon_sym_groupshared] = ACTIONS(2974),
    [anon_sym_uniform] = ACTIONS(2974),
    [anon_sym_row_major] = ACTIONS(2974),
    [anon_sym_column_major] = ACTIONS(2974),
    [anon_sym_globallycoherent] = ACTIONS(2974),
    [anon_sym_centroid] = ACTIONS(2974),
    [anon_sym_noperspective] = ACTIONS(2974),
    [anon_sym_nointerpolation] = ACTIONS(2974),
    [anon_sym_sample] = ACTIONS(2974),
    [anon_sym_linear] = ACTIONS(2974),
    [anon_sym_snorm] = ACTIONS(2974),
    [anon_sym_unorm] = ACTIONS(2974),
    [anon_sym_point] = ACTIONS(2974),
    [anon_sym_line] = ACTIONS(2974),
    [anon_sym_triangleadj] = ACTIONS(2974),
    [anon_sym_lineadj] = ACTIONS(2974),
    [anon_sym_triangle] = ACTIONS(2974),
    [anon_sym_cbuffer] = ACTIONS(2974),
    [anon_sym_interface] = ACTIONS(2974),
    [anon_sym_extension] = ACTIONS(2974),
  },
  [780] = {
    [sym_identifier] = ACTIONS(2978),
    [aux_sym_preproc_include_token1] = ACTIONS(2978),
    [aux_sym_preproc_def_token1] = ACTIONS(2978),
    [aux_sym_preproc_if_token1] = ACTIONS(2978),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2978),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2978),
    [sym_preproc_directive] = ACTIONS(2978),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2976),
    [anon_sym_TILDE] = ACTIONS(2976),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_STAR] = ACTIONS(2976),
    [anon_sym_AMP_AMP] = ACTIONS(2976),
    [anon_sym_AMP] = ACTIONS(2978),
    [anon_sym_SEMI] = ACTIONS(2976),
    [anon_sym___extension__] = ACTIONS(2978),
    [anon_sym_typedef] = ACTIONS(2978),
    [anon_sym_in] = ACTIONS(2978),
    [anon_sym_out] = ACTIONS(2978),
    [anon_sym_inout] = ACTIONS(2978),
    [anon_sym_virtual] = ACTIONS(2978),
    [anon_sym_extern] = ACTIONS(2978),
    [anon_sym___attribute__] = ACTIONS(2978),
    [anon_sym___attribute] = ACTIONS(2978),
    [anon_sym_using] = ACTIONS(2978),
    [anon_sym_COLON_COLON] = ACTIONS(2976),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2976),
    [anon_sym___declspec] = ACTIONS(2978),
    [anon_sym___based] = ACTIONS(2978),
    [anon_sym___cdecl] = ACTIONS(2978),
    [anon_sym___clrcall] = ACTIONS(2978),
    [anon_sym___stdcall] = ACTIONS(2978),
    [anon_sym___fastcall] = ACTIONS(2978),
    [anon_sym___thiscall] = ACTIONS(2978),
    [anon_sym___vectorcall] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(2976),
    [anon_sym_RBRACE] = ACTIONS(2976),
    [anon_sym_signed] = ACTIONS(2978),
    [anon_sym_unsigned] = ACTIONS(2978),
    [anon_sym_long] = ACTIONS(2978),
    [anon_sym_short] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_static] = ACTIONS(2978),
    [anon_sym_register] = ACTIONS(2978),
    [anon_sym_inline] = ACTIONS(2978),
    [anon_sym___inline] = ACTIONS(2978),
    [anon_sym___inline__] = ACTIONS(2978),
    [anon_sym___forceinline] = ACTIONS(2978),
    [anon_sym_thread_local] = ACTIONS(2978),
    [anon_sym___thread] = ACTIONS(2978),
    [anon_sym_const] = ACTIONS(2978),
    [anon_sym_constexpr] = ACTIONS(2978),
    [anon_sym_volatile] = ACTIONS(2978),
    [anon_sym_restrict] = ACTIONS(2978),
    [anon_sym___restrict__] = ACTIONS(2978),
    [anon_sym__Atomic] = ACTIONS(2978),
    [anon_sym__Noreturn] = ACTIONS(2978),
    [anon_sym_noreturn] = ACTIONS(2978),
    [anon_sym__Nonnull] = ACTIONS(2978),
    [anon_sym_mutable] = ACTIONS(2978),
    [anon_sym_constinit] = ACTIONS(2978),
    [anon_sym_consteval] = ACTIONS(2978),
    [anon_sym_alignas] = ACTIONS(2978),
    [anon_sym__Alignas] = ACTIONS(2978),
    [sym_primitive_type] = ACTIONS(2978),
    [anon_sym_enum] = ACTIONS(2978),
    [anon_sym_class] = ACTIONS(2978),
    [anon_sym_struct] = ACTIONS(2978),
    [anon_sym_union] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_switch] = ACTIONS(2978),
    [anon_sym_case] = ACTIONS(2978),
    [anon_sym_default] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_do] = ACTIONS(2978),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_break] = ACTIONS(2978),
    [anon_sym_continue] = ACTIONS(2978),
    [anon_sym_goto] = ACTIONS(2978),
    [anon_sym___try] = ACTIONS(2978),
    [anon_sym___leave] = ACTIONS(2978),
    [anon_sym_not] = ACTIONS(2978),
    [anon_sym_compl] = ACTIONS(2978),
    [anon_sym_DASH_DASH] = ACTIONS(2976),
    [anon_sym_PLUS_PLUS] = ACTIONS(2976),
    [anon_sym_sizeof] = ACTIONS(2978),
    [anon_sym___alignof__] = ACTIONS(2978),
    [anon_sym___alignof] = ACTIONS(2978),
    [anon_sym__alignof] = ACTIONS(2978),
    [anon_sym_alignof] = ACTIONS(2978),
    [anon_sym__Alignof] = ACTIONS(2978),
    [anon_sym_offsetof] = ACTIONS(2978),
    [anon_sym__Generic] = ACTIONS(2978),
    [anon_sym_asm] = ACTIONS(2978),
    [anon_sym___asm__] = ACTIONS(2978),
    [anon_sym___asm] = ACTIONS(2978),
    [anon_sym_DOT] = ACTIONS(2978),
    [sym_number_literal] = ACTIONS(2976),
    [anon_sym_L_SQUOTE] = ACTIONS(2976),
    [anon_sym_u_SQUOTE] = ACTIONS(2976),
    [anon_sym_U_SQUOTE] = ACTIONS(2976),
    [anon_sym_u8_SQUOTE] = ACTIONS(2976),
    [anon_sym_SQUOTE] = ACTIONS(2976),
    [anon_sym_L_DQUOTE] = ACTIONS(2976),
    [anon_sym_u_DQUOTE] = ACTIONS(2976),
    [anon_sym_U_DQUOTE] = ACTIONS(2976),
    [anon_sym_u8_DQUOTE] = ACTIONS(2976),
    [anon_sym_DQUOTE] = ACTIONS(2976),
    [sym_true] = ACTIONS(2978),
    [sym_false] = ACTIONS(2978),
    [anon_sym_NULL] = ACTIONS(2978),
    [anon_sym_nullptr] = ACTIONS(2978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_This] = ACTIONS(2978),
    [anon_sym_decltype] = ACTIONS(2978),
    [anon_sym_explicit] = ACTIONS(2978),
    [anon_sym_typename] = ACTIONS(2978),
    [anon_sym_template] = ACTIONS(2978),
    [anon_sym_operator] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2978),
    [anon_sym_delete] = ACTIONS(2978),
    [anon_sym_throw] = ACTIONS(2978),
    [anon_sym_namespace] = ACTIONS(2978),
    [anon_sym_static_assert] = ACTIONS(2978),
    [anon_sym_concept] = ACTIONS(2978),
    [anon_sym_co_return] = ACTIONS(2978),
    [anon_sym_co_yield] = ACTIONS(2978),
    [anon_sym_R_DQUOTE] = ACTIONS(2976),
    [anon_sym_LR_DQUOTE] = ACTIONS(2976),
    [anon_sym_uR_DQUOTE] = ACTIONS(2976),
    [anon_sym_UR_DQUOTE] = ACTIONS(2976),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2976),
    [anon_sym_co_await] = ACTIONS(2978),
    [anon_sym_new] = ACTIONS(2978),
    [anon_sym_requires] = ACTIONS(2978),
    [sym_this] = ACTIONS(2978),
    [anon_sym_discard] = ACTIONS(2978),
    [anon_sym_precise] = ACTIONS(2978),
    [anon_sym_shared] = ACTIONS(2978),
    [anon_sym_groupshared] = ACTIONS(2978),
    [anon_sym_uniform] = ACTIONS(2978),
    [anon_sym_row_major] = ACTIONS(2978),
    [anon_sym_column_major] = ACTIONS(2978),
    [anon_sym_globallycoherent] = ACTIONS(2978),
    [anon_sym_centroid] = ACTIONS(2978),
    [anon_sym_noperspective] = ACTIONS(2978),
    [anon_sym_nointerpolation] = ACTIONS(2978),
    [anon_sym_sample] = ACTIONS(2978),
    [anon_sym_linear] = ACTIONS(2978),
    [anon_sym_snorm] = ACTIONS(2978),
    [anon_sym_unorm] = ACTIONS(2978),
    [anon_sym_point] = ACTIONS(2978),
    [anon_sym_line] = ACTIONS(2978),
    [anon_sym_triangleadj] = ACTIONS(2978),
    [anon_sym_lineadj] = ACTIONS(2978),
    [anon_sym_triangle] = ACTIONS(2978),
    [anon_sym_cbuffer] = ACTIONS(2978),
    [anon_sym_interface] = ACTIONS(2978),
    [anon_sym_extension] = ACTIONS(2978),
  },
  [781] = {
    [sym_identifier] = ACTIONS(3022),
    [aux_sym_preproc_include_token1] = ACTIONS(3022),
    [aux_sym_preproc_def_token1] = ACTIONS(3022),
    [aux_sym_preproc_if_token1] = ACTIONS(3022),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3022),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3022),
    [sym_preproc_directive] = ACTIONS(3022),
    [anon_sym_LPAREN2] = ACTIONS(3020),
    [anon_sym_BANG] = ACTIONS(3020),
    [anon_sym_TILDE] = ACTIONS(3020),
    [anon_sym_DASH] = ACTIONS(3022),
    [anon_sym_PLUS] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3020),
    [anon_sym_AMP_AMP] = ACTIONS(3020),
    [anon_sym_AMP] = ACTIONS(3022),
    [anon_sym_SEMI] = ACTIONS(3020),
    [anon_sym___extension__] = ACTIONS(3022),
    [anon_sym_typedef] = ACTIONS(3022),
    [anon_sym_in] = ACTIONS(3022),
    [anon_sym_out] = ACTIONS(3022),
    [anon_sym_inout] = ACTIONS(3022),
    [anon_sym_virtual] = ACTIONS(3022),
    [anon_sym_extern] = ACTIONS(3022),
    [anon_sym___attribute__] = ACTIONS(3022),
    [anon_sym___attribute] = ACTIONS(3022),
    [anon_sym_using] = ACTIONS(3022),
    [anon_sym_COLON_COLON] = ACTIONS(3020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3020),
    [anon_sym___declspec] = ACTIONS(3022),
    [anon_sym___based] = ACTIONS(3022),
    [anon_sym___cdecl] = ACTIONS(3022),
    [anon_sym___clrcall] = ACTIONS(3022),
    [anon_sym___stdcall] = ACTIONS(3022),
    [anon_sym___fastcall] = ACTIONS(3022),
    [anon_sym___thiscall] = ACTIONS(3022),
    [anon_sym___vectorcall] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3020),
    [anon_sym_RBRACE] = ACTIONS(3020),
    [anon_sym_signed] = ACTIONS(3022),
    [anon_sym_unsigned] = ACTIONS(3022),
    [anon_sym_long] = ACTIONS(3022),
    [anon_sym_short] = ACTIONS(3022),
    [anon_sym_LBRACK] = ACTIONS(3022),
    [anon_sym_static] = ACTIONS(3022),
    [anon_sym_register] = ACTIONS(3022),
    [anon_sym_inline] = ACTIONS(3022),
    [anon_sym___inline] = ACTIONS(3022),
    [anon_sym___inline__] = ACTIONS(3022),
    [anon_sym___forceinline] = ACTIONS(3022),
    [anon_sym_thread_local] = ACTIONS(3022),
    [anon_sym___thread] = ACTIONS(3022),
    [anon_sym_const] = ACTIONS(3022),
    [anon_sym_constexpr] = ACTIONS(3022),
    [anon_sym_volatile] = ACTIONS(3022),
    [anon_sym_restrict] = ACTIONS(3022),
    [anon_sym___restrict__] = ACTIONS(3022),
    [anon_sym__Atomic] = ACTIONS(3022),
    [anon_sym__Noreturn] = ACTIONS(3022),
    [anon_sym_noreturn] = ACTIONS(3022),
    [anon_sym__Nonnull] = ACTIONS(3022),
    [anon_sym_mutable] = ACTIONS(3022),
    [anon_sym_constinit] = ACTIONS(3022),
    [anon_sym_consteval] = ACTIONS(3022),
    [anon_sym_alignas] = ACTIONS(3022),
    [anon_sym__Alignas] = ACTIONS(3022),
    [sym_primitive_type] = ACTIONS(3022),
    [anon_sym_enum] = ACTIONS(3022),
    [anon_sym_class] = ACTIONS(3022),
    [anon_sym_struct] = ACTIONS(3022),
    [anon_sym_union] = ACTIONS(3022),
    [anon_sym_if] = ACTIONS(3022),
    [anon_sym_switch] = ACTIONS(3022),
    [anon_sym_case] = ACTIONS(3022),
    [anon_sym_default] = ACTIONS(3022),
    [anon_sym_while] = ACTIONS(3022),
    [anon_sym_do] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(3022),
    [anon_sym_return] = ACTIONS(3022),
    [anon_sym_break] = ACTIONS(3022),
    [anon_sym_continue] = ACTIONS(3022),
    [anon_sym_goto] = ACTIONS(3022),
    [anon_sym___try] = ACTIONS(3022),
    [anon_sym___leave] = ACTIONS(3022),
    [anon_sym_not] = ACTIONS(3022),
    [anon_sym_compl] = ACTIONS(3022),
    [anon_sym_DASH_DASH] = ACTIONS(3020),
    [anon_sym_PLUS_PLUS] = ACTIONS(3020),
    [anon_sym_sizeof] = ACTIONS(3022),
    [anon_sym___alignof__] = ACTIONS(3022),
    [anon_sym___alignof] = ACTIONS(3022),
    [anon_sym__alignof] = ACTIONS(3022),
    [anon_sym_alignof] = ACTIONS(3022),
    [anon_sym__Alignof] = ACTIONS(3022),
    [anon_sym_offsetof] = ACTIONS(3022),
    [anon_sym__Generic] = ACTIONS(3022),
    [anon_sym_asm] = ACTIONS(3022),
    [anon_sym___asm__] = ACTIONS(3022),
    [anon_sym___asm] = ACTIONS(3022),
    [anon_sym_DOT] = ACTIONS(3022),
    [sym_number_literal] = ACTIONS(3020),
    [anon_sym_L_SQUOTE] = ACTIONS(3020),
    [anon_sym_u_SQUOTE] = ACTIONS(3020),
    [anon_sym_U_SQUOTE] = ACTIONS(3020),
    [anon_sym_u8_SQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3020),
    [anon_sym_L_DQUOTE] = ACTIONS(3020),
    [anon_sym_u_DQUOTE] = ACTIONS(3020),
    [anon_sym_U_DQUOTE] = ACTIONS(3020),
    [anon_sym_u8_DQUOTE] = ACTIONS(3020),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [sym_true] = ACTIONS(3022),
    [sym_false] = ACTIONS(3022),
    [anon_sym_NULL] = ACTIONS(3022),
    [anon_sym_nullptr] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3022),
    [anon_sym_let] = ACTIONS(3022),
    [anon_sym_This] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3022),
    [anon_sym_explicit] = ACTIONS(3022),
    [anon_sym_typename] = ACTIONS(3022),
    [anon_sym_template] = ACTIONS(3022),
    [anon_sym_operator] = ACTIONS(3022),
    [anon_sym_try] = ACTIONS(3022),
    [anon_sym_delete] = ACTIONS(3022),
    [anon_sym_throw] = ACTIONS(3022),
    [anon_sym_namespace] = ACTIONS(3022),
    [anon_sym_static_assert] = ACTIONS(3022),
    [anon_sym_concept] = ACTIONS(3022),
    [anon_sym_co_return] = ACTIONS(3022),
    [anon_sym_co_yield] = ACTIONS(3022),
    [anon_sym_R_DQUOTE] = ACTIONS(3020),
    [anon_sym_LR_DQUOTE] = ACTIONS(3020),
    [anon_sym_uR_DQUOTE] = ACTIONS(3020),
    [anon_sym_UR_DQUOTE] = ACTIONS(3020),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3020),
    [anon_sym_co_await] = ACTIONS(3022),
    [anon_sym_new] = ACTIONS(3022),
    [anon_sym_requires] = ACTIONS(3022),
    [sym_this] = ACTIONS(3022),
    [anon_sym_discard] = ACTIONS(3022),
    [anon_sym_precise] = ACTIONS(3022),
    [anon_sym_shared] = ACTIONS(3022),
    [anon_sym_groupshared] = ACTIONS(3022),
    [anon_sym_uniform] = ACTIONS(3022),
    [anon_sym_row_major] = ACTIONS(3022),
    [anon_sym_column_major] = ACTIONS(3022),
    [anon_sym_globallycoherent] = ACTIONS(3022),
    [anon_sym_centroid] = ACTIONS(3022),
    [anon_sym_noperspective] = ACTIONS(3022),
    [anon_sym_nointerpolation] = ACTIONS(3022),
    [anon_sym_sample] = ACTIONS(3022),
    [anon_sym_linear] = ACTIONS(3022),
    [anon_sym_snorm] = ACTIONS(3022),
    [anon_sym_unorm] = ACTIONS(3022),
    [anon_sym_point] = ACTIONS(3022),
    [anon_sym_line] = ACTIONS(3022),
    [anon_sym_triangleadj] = ACTIONS(3022),
    [anon_sym_lineadj] = ACTIONS(3022),
    [anon_sym_triangle] = ACTIONS(3022),
    [anon_sym_cbuffer] = ACTIONS(3022),
    [anon_sym_interface] = ACTIONS(3022),
    [anon_sym_extension] = ACTIONS(3022),
  },
  [782] = {
    [sym_identifier] = ACTIONS(2934),
    [aux_sym_preproc_include_token1] = ACTIONS(2934),
    [aux_sym_preproc_def_token1] = ACTIONS(2934),
    [aux_sym_preproc_if_token1] = ACTIONS(2934),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2934),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2934),
    [sym_preproc_directive] = ACTIONS(2934),
    [anon_sym_LPAREN2] = ACTIONS(2932),
    [anon_sym_BANG] = ACTIONS(2932),
    [anon_sym_TILDE] = ACTIONS(2932),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_STAR] = ACTIONS(2932),
    [anon_sym_AMP_AMP] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym___extension__] = ACTIONS(2934),
    [anon_sym_typedef] = ACTIONS(2934),
    [anon_sym_in] = ACTIONS(2934),
    [anon_sym_out] = ACTIONS(2934),
    [anon_sym_inout] = ACTIONS(2934),
    [anon_sym_virtual] = ACTIONS(2934),
    [anon_sym_extern] = ACTIONS(2934),
    [anon_sym___attribute__] = ACTIONS(2934),
    [anon_sym___attribute] = ACTIONS(2934),
    [anon_sym_using] = ACTIONS(2934),
    [anon_sym_COLON_COLON] = ACTIONS(2932),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2932),
    [anon_sym___declspec] = ACTIONS(2934),
    [anon_sym___based] = ACTIONS(2934),
    [anon_sym___cdecl] = ACTIONS(2934),
    [anon_sym___clrcall] = ACTIONS(2934),
    [anon_sym___stdcall] = ACTIONS(2934),
    [anon_sym___fastcall] = ACTIONS(2934),
    [anon_sym___thiscall] = ACTIONS(2934),
    [anon_sym___vectorcall] = ACTIONS(2934),
    [anon_sym_LBRACE] = ACTIONS(2932),
    [anon_sym_RBRACE] = ACTIONS(2932),
    [anon_sym_signed] = ACTIONS(2934),
    [anon_sym_unsigned] = ACTIONS(2934),
    [anon_sym_long] = ACTIONS(2934),
    [anon_sym_short] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [anon_sym_static] = ACTIONS(2934),
    [anon_sym_register] = ACTIONS(2934),
    [anon_sym_inline] = ACTIONS(2934),
    [anon_sym___inline] = ACTIONS(2934),
    [anon_sym___inline__] = ACTIONS(2934),
    [anon_sym___forceinline] = ACTIONS(2934),
    [anon_sym_thread_local] = ACTIONS(2934),
    [anon_sym___thread] = ACTIONS(2934),
    [anon_sym_const] = ACTIONS(2934),
    [anon_sym_constexpr] = ACTIONS(2934),
    [anon_sym_volatile] = ACTIONS(2934),
    [anon_sym_restrict] = ACTIONS(2934),
    [anon_sym___restrict__] = ACTIONS(2934),
    [anon_sym__Atomic] = ACTIONS(2934),
    [anon_sym__Noreturn] = ACTIONS(2934),
    [anon_sym_noreturn] = ACTIONS(2934),
    [anon_sym__Nonnull] = ACTIONS(2934),
    [anon_sym_mutable] = ACTIONS(2934),
    [anon_sym_constinit] = ACTIONS(2934),
    [anon_sym_consteval] = ACTIONS(2934),
    [anon_sym_alignas] = ACTIONS(2934),
    [anon_sym__Alignas] = ACTIONS(2934),
    [sym_primitive_type] = ACTIONS(2934),
    [anon_sym_enum] = ACTIONS(2934),
    [anon_sym_class] = ACTIONS(2934),
    [anon_sym_struct] = ACTIONS(2934),
    [anon_sym_union] = ACTIONS(2934),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_switch] = ACTIONS(2934),
    [anon_sym_case] = ACTIONS(2934),
    [anon_sym_default] = ACTIONS(2934),
    [anon_sym_while] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2934),
    [anon_sym_for] = ACTIONS(2934),
    [anon_sym_return] = ACTIONS(2934),
    [anon_sym_break] = ACTIONS(2934),
    [anon_sym_continue] = ACTIONS(2934),
    [anon_sym_goto] = ACTIONS(2934),
    [anon_sym___try] = ACTIONS(2934),
    [anon_sym___leave] = ACTIONS(2934),
    [anon_sym_not] = ACTIONS(2934),
    [anon_sym_compl] = ACTIONS(2934),
    [anon_sym_DASH_DASH] = ACTIONS(2932),
    [anon_sym_PLUS_PLUS] = ACTIONS(2932),
    [anon_sym_sizeof] = ACTIONS(2934),
    [anon_sym___alignof__] = ACTIONS(2934),
    [anon_sym___alignof] = ACTIONS(2934),
    [anon_sym__alignof] = ACTIONS(2934),
    [anon_sym_alignof] = ACTIONS(2934),
    [anon_sym__Alignof] = ACTIONS(2934),
    [anon_sym_offsetof] = ACTIONS(2934),
    [anon_sym__Generic] = ACTIONS(2934),
    [anon_sym_asm] = ACTIONS(2934),
    [anon_sym___asm__] = ACTIONS(2934),
    [anon_sym___asm] = ACTIONS(2934),
    [anon_sym_DOT] = ACTIONS(2934),
    [sym_number_literal] = ACTIONS(2932),
    [anon_sym_L_SQUOTE] = ACTIONS(2932),
    [anon_sym_u_SQUOTE] = ACTIONS(2932),
    [anon_sym_U_SQUOTE] = ACTIONS(2932),
    [anon_sym_u8_SQUOTE] = ACTIONS(2932),
    [anon_sym_SQUOTE] = ACTIONS(2932),
    [anon_sym_L_DQUOTE] = ACTIONS(2932),
    [anon_sym_u_DQUOTE] = ACTIONS(2932),
    [anon_sym_U_DQUOTE] = ACTIONS(2932),
    [anon_sym_u8_DQUOTE] = ACTIONS(2932),
    [anon_sym_DQUOTE] = ACTIONS(2932),
    [sym_true] = ACTIONS(2934),
    [sym_false] = ACTIONS(2934),
    [anon_sym_NULL] = ACTIONS(2934),
    [anon_sym_nullptr] = ACTIONS(2934),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_This] = ACTIONS(2934),
    [anon_sym_decltype] = ACTIONS(2934),
    [anon_sym_explicit] = ACTIONS(2934),
    [anon_sym_typename] = ACTIONS(2934),
    [anon_sym_template] = ACTIONS(2934),
    [anon_sym_operator] = ACTIONS(2934),
    [anon_sym_try] = ACTIONS(2934),
    [anon_sym_delete] = ACTIONS(2934),
    [anon_sym_throw] = ACTIONS(2934),
    [anon_sym_namespace] = ACTIONS(2934),
    [anon_sym_static_assert] = ACTIONS(2934),
    [anon_sym_concept] = ACTIONS(2934),
    [anon_sym_co_return] = ACTIONS(2934),
    [anon_sym_co_yield] = ACTIONS(2934),
    [anon_sym_R_DQUOTE] = ACTIONS(2932),
    [anon_sym_LR_DQUOTE] = ACTIONS(2932),
    [anon_sym_uR_DQUOTE] = ACTIONS(2932),
    [anon_sym_UR_DQUOTE] = ACTIONS(2932),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2932),
    [anon_sym_co_await] = ACTIONS(2934),
    [anon_sym_new] = ACTIONS(2934),
    [anon_sym_requires] = ACTIONS(2934),
    [sym_this] = ACTIONS(2934),
    [anon_sym_discard] = ACTIONS(2934),
    [anon_sym_precise] = ACTIONS(2934),
    [anon_sym_shared] = ACTIONS(2934),
    [anon_sym_groupshared] = ACTIONS(2934),
    [anon_sym_uniform] = ACTIONS(2934),
    [anon_sym_row_major] = ACTIONS(2934),
    [anon_sym_column_major] = ACTIONS(2934),
    [anon_sym_globallycoherent] = ACTIONS(2934),
    [anon_sym_centroid] = ACTIONS(2934),
    [anon_sym_noperspective] = ACTIONS(2934),
    [anon_sym_nointerpolation] = ACTIONS(2934),
    [anon_sym_sample] = ACTIONS(2934),
    [anon_sym_linear] = ACTIONS(2934),
    [anon_sym_snorm] = ACTIONS(2934),
    [anon_sym_unorm] = ACTIONS(2934),
    [anon_sym_point] = ACTIONS(2934),
    [anon_sym_line] = ACTIONS(2934),
    [anon_sym_triangleadj] = ACTIONS(2934),
    [anon_sym_lineadj] = ACTIONS(2934),
    [anon_sym_triangle] = ACTIONS(2934),
    [anon_sym_cbuffer] = ACTIONS(2934),
    [anon_sym_interface] = ACTIONS(2934),
    [anon_sym_extension] = ACTIONS(2934),
  },
  [783] = {
    [sym_identifier] = ACTIONS(2926),
    [aux_sym_preproc_include_token1] = ACTIONS(2926),
    [aux_sym_preproc_def_token1] = ACTIONS(2926),
    [aux_sym_preproc_if_token1] = ACTIONS(2926),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2926),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2926),
    [sym_preproc_directive] = ACTIONS(2926),
    [anon_sym_LPAREN2] = ACTIONS(2924),
    [anon_sym_BANG] = ACTIONS(2924),
    [anon_sym_TILDE] = ACTIONS(2924),
    [anon_sym_DASH] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2926),
    [anon_sym_STAR] = ACTIONS(2924),
    [anon_sym_AMP_AMP] = ACTIONS(2924),
    [anon_sym_AMP] = ACTIONS(2926),
    [anon_sym_SEMI] = ACTIONS(2924),
    [anon_sym___extension__] = ACTIONS(2926),
    [anon_sym_typedef] = ACTIONS(2926),
    [anon_sym_in] = ACTIONS(2926),
    [anon_sym_out] = ACTIONS(2926),
    [anon_sym_inout] = ACTIONS(2926),
    [anon_sym_virtual] = ACTIONS(2926),
    [anon_sym_extern] = ACTIONS(2926),
    [anon_sym___attribute__] = ACTIONS(2926),
    [anon_sym___attribute] = ACTIONS(2926),
    [anon_sym_using] = ACTIONS(2926),
    [anon_sym_COLON_COLON] = ACTIONS(2924),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2924),
    [anon_sym___declspec] = ACTIONS(2926),
    [anon_sym___based] = ACTIONS(2926),
    [anon_sym___cdecl] = ACTIONS(2926),
    [anon_sym___clrcall] = ACTIONS(2926),
    [anon_sym___stdcall] = ACTIONS(2926),
    [anon_sym___fastcall] = ACTIONS(2926),
    [anon_sym___thiscall] = ACTIONS(2926),
    [anon_sym___vectorcall] = ACTIONS(2926),
    [anon_sym_LBRACE] = ACTIONS(2924),
    [anon_sym_RBRACE] = ACTIONS(2924),
    [anon_sym_signed] = ACTIONS(2926),
    [anon_sym_unsigned] = ACTIONS(2926),
    [anon_sym_long] = ACTIONS(2926),
    [anon_sym_short] = ACTIONS(2926),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_static] = ACTIONS(2926),
    [anon_sym_register] = ACTIONS(2926),
    [anon_sym_inline] = ACTIONS(2926),
    [anon_sym___inline] = ACTIONS(2926),
    [anon_sym___inline__] = ACTIONS(2926),
    [anon_sym___forceinline] = ACTIONS(2926),
    [anon_sym_thread_local] = ACTIONS(2926),
    [anon_sym___thread] = ACTIONS(2926),
    [anon_sym_const] = ACTIONS(2926),
    [anon_sym_constexpr] = ACTIONS(2926),
    [anon_sym_volatile] = ACTIONS(2926),
    [anon_sym_restrict] = ACTIONS(2926),
    [anon_sym___restrict__] = ACTIONS(2926),
    [anon_sym__Atomic] = ACTIONS(2926),
    [anon_sym__Noreturn] = ACTIONS(2926),
    [anon_sym_noreturn] = ACTIONS(2926),
    [anon_sym__Nonnull] = ACTIONS(2926),
    [anon_sym_mutable] = ACTIONS(2926),
    [anon_sym_constinit] = ACTIONS(2926),
    [anon_sym_consteval] = ACTIONS(2926),
    [anon_sym_alignas] = ACTIONS(2926),
    [anon_sym__Alignas] = ACTIONS(2926),
    [sym_primitive_type] = ACTIONS(2926),
    [anon_sym_enum] = ACTIONS(2926),
    [anon_sym_class] = ACTIONS(2926),
    [anon_sym_struct] = ACTIONS(2926),
    [anon_sym_union] = ACTIONS(2926),
    [anon_sym_if] = ACTIONS(2926),
    [anon_sym_switch] = ACTIONS(2926),
    [anon_sym_case] = ACTIONS(2926),
    [anon_sym_default] = ACTIONS(2926),
    [anon_sym_while] = ACTIONS(2926),
    [anon_sym_do] = ACTIONS(2926),
    [anon_sym_for] = ACTIONS(2926),
    [anon_sym_return] = ACTIONS(2926),
    [anon_sym_break] = ACTIONS(2926),
    [anon_sym_continue] = ACTIONS(2926),
    [anon_sym_goto] = ACTIONS(2926),
    [anon_sym___try] = ACTIONS(2926),
    [anon_sym___leave] = ACTIONS(2926),
    [anon_sym_not] = ACTIONS(2926),
    [anon_sym_compl] = ACTIONS(2926),
    [anon_sym_DASH_DASH] = ACTIONS(2924),
    [anon_sym_PLUS_PLUS] = ACTIONS(2924),
    [anon_sym_sizeof] = ACTIONS(2926),
    [anon_sym___alignof__] = ACTIONS(2926),
    [anon_sym___alignof] = ACTIONS(2926),
    [anon_sym__alignof] = ACTIONS(2926),
    [anon_sym_alignof] = ACTIONS(2926),
    [anon_sym__Alignof] = ACTIONS(2926),
    [anon_sym_offsetof] = ACTIONS(2926),
    [anon_sym__Generic] = ACTIONS(2926),
    [anon_sym_asm] = ACTIONS(2926),
    [anon_sym___asm__] = ACTIONS(2926),
    [anon_sym___asm] = ACTIONS(2926),
    [anon_sym_DOT] = ACTIONS(2926),
    [sym_number_literal] = ACTIONS(2924),
    [anon_sym_L_SQUOTE] = ACTIONS(2924),
    [anon_sym_u_SQUOTE] = ACTIONS(2924),
    [anon_sym_U_SQUOTE] = ACTIONS(2924),
    [anon_sym_u8_SQUOTE] = ACTIONS(2924),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [anon_sym_L_DQUOTE] = ACTIONS(2924),
    [anon_sym_u_DQUOTE] = ACTIONS(2924),
    [anon_sym_U_DQUOTE] = ACTIONS(2924),
    [anon_sym_u8_DQUOTE] = ACTIONS(2924),
    [anon_sym_DQUOTE] = ACTIONS(2924),
    [sym_true] = ACTIONS(2926),
    [sym_false] = ACTIONS(2926),
    [anon_sym_NULL] = ACTIONS(2926),
    [anon_sym_nullptr] = ACTIONS(2926),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2926),
    [anon_sym_let] = ACTIONS(2926),
    [anon_sym_This] = ACTIONS(2926),
    [anon_sym_decltype] = ACTIONS(2926),
    [anon_sym_explicit] = ACTIONS(2926),
    [anon_sym_typename] = ACTIONS(2926),
    [anon_sym_template] = ACTIONS(2926),
    [anon_sym_operator] = ACTIONS(2926),
    [anon_sym_try] = ACTIONS(2926),
    [anon_sym_delete] = ACTIONS(2926),
    [anon_sym_throw] = ACTIONS(2926),
    [anon_sym_namespace] = ACTIONS(2926),
    [anon_sym_static_assert] = ACTIONS(2926),
    [anon_sym_concept] = ACTIONS(2926),
    [anon_sym_co_return] = ACTIONS(2926),
    [anon_sym_co_yield] = ACTIONS(2926),
    [anon_sym_R_DQUOTE] = ACTIONS(2924),
    [anon_sym_LR_DQUOTE] = ACTIONS(2924),
    [anon_sym_uR_DQUOTE] = ACTIONS(2924),
    [anon_sym_UR_DQUOTE] = ACTIONS(2924),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2924),
    [anon_sym_co_await] = ACTIONS(2926),
    [anon_sym_new] = ACTIONS(2926),
    [anon_sym_requires] = ACTIONS(2926),
    [sym_this] = ACTIONS(2926),
    [anon_sym_discard] = ACTIONS(2926),
    [anon_sym_precise] = ACTIONS(2926),
    [anon_sym_shared] = ACTIONS(2926),
    [anon_sym_groupshared] = ACTIONS(2926),
    [anon_sym_uniform] = ACTIONS(2926),
    [anon_sym_row_major] = ACTIONS(2926),
    [anon_sym_column_major] = ACTIONS(2926),
    [anon_sym_globallycoherent] = ACTIONS(2926),
    [anon_sym_centroid] = ACTIONS(2926),
    [anon_sym_noperspective] = ACTIONS(2926),
    [anon_sym_nointerpolation] = ACTIONS(2926),
    [anon_sym_sample] = ACTIONS(2926),
    [anon_sym_linear] = ACTIONS(2926),
    [anon_sym_snorm] = ACTIONS(2926),
    [anon_sym_unorm] = ACTIONS(2926),
    [anon_sym_point] = ACTIONS(2926),
    [anon_sym_line] = ACTIONS(2926),
    [anon_sym_triangleadj] = ACTIONS(2926),
    [anon_sym_lineadj] = ACTIONS(2926),
    [anon_sym_triangle] = ACTIONS(2926),
    [anon_sym_cbuffer] = ACTIONS(2926),
    [anon_sym_interface] = ACTIONS(2926),
    [anon_sym_extension] = ACTIONS(2926),
  },
  [784] = {
    [sym_identifier] = ACTIONS(2930),
    [aux_sym_preproc_include_token1] = ACTIONS(2930),
    [aux_sym_preproc_def_token1] = ACTIONS(2930),
    [aux_sym_preproc_if_token1] = ACTIONS(2930),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2930),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2930),
    [sym_preproc_directive] = ACTIONS(2930),
    [anon_sym_LPAREN2] = ACTIONS(2928),
    [anon_sym_BANG] = ACTIONS(2928),
    [anon_sym_TILDE] = ACTIONS(2928),
    [anon_sym_DASH] = ACTIONS(2930),
    [anon_sym_PLUS] = ACTIONS(2930),
    [anon_sym_STAR] = ACTIONS(2928),
    [anon_sym_AMP_AMP] = ACTIONS(2928),
    [anon_sym_AMP] = ACTIONS(2930),
    [anon_sym_SEMI] = ACTIONS(2928),
    [anon_sym___extension__] = ACTIONS(2930),
    [anon_sym_typedef] = ACTIONS(2930),
    [anon_sym_in] = ACTIONS(2930),
    [anon_sym_out] = ACTIONS(2930),
    [anon_sym_inout] = ACTIONS(2930),
    [anon_sym_virtual] = ACTIONS(2930),
    [anon_sym_extern] = ACTIONS(2930),
    [anon_sym___attribute__] = ACTIONS(2930),
    [anon_sym___attribute] = ACTIONS(2930),
    [anon_sym_using] = ACTIONS(2930),
    [anon_sym_COLON_COLON] = ACTIONS(2928),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2928),
    [anon_sym___declspec] = ACTIONS(2930),
    [anon_sym___based] = ACTIONS(2930),
    [anon_sym___cdecl] = ACTIONS(2930),
    [anon_sym___clrcall] = ACTIONS(2930),
    [anon_sym___stdcall] = ACTIONS(2930),
    [anon_sym___fastcall] = ACTIONS(2930),
    [anon_sym___thiscall] = ACTIONS(2930),
    [anon_sym___vectorcall] = ACTIONS(2930),
    [anon_sym_LBRACE] = ACTIONS(2928),
    [anon_sym_RBRACE] = ACTIONS(2928),
    [anon_sym_signed] = ACTIONS(2930),
    [anon_sym_unsigned] = ACTIONS(2930),
    [anon_sym_long] = ACTIONS(2930),
    [anon_sym_short] = ACTIONS(2930),
    [anon_sym_LBRACK] = ACTIONS(2930),
    [anon_sym_static] = ACTIONS(2930),
    [anon_sym_register] = ACTIONS(2930),
    [anon_sym_inline] = ACTIONS(2930),
    [anon_sym___inline] = ACTIONS(2930),
    [anon_sym___inline__] = ACTIONS(2930),
    [anon_sym___forceinline] = ACTIONS(2930),
    [anon_sym_thread_local] = ACTIONS(2930),
    [anon_sym___thread] = ACTIONS(2930),
    [anon_sym_const] = ACTIONS(2930),
    [anon_sym_constexpr] = ACTIONS(2930),
    [anon_sym_volatile] = ACTIONS(2930),
    [anon_sym_restrict] = ACTIONS(2930),
    [anon_sym___restrict__] = ACTIONS(2930),
    [anon_sym__Atomic] = ACTIONS(2930),
    [anon_sym__Noreturn] = ACTIONS(2930),
    [anon_sym_noreturn] = ACTIONS(2930),
    [anon_sym__Nonnull] = ACTIONS(2930),
    [anon_sym_mutable] = ACTIONS(2930),
    [anon_sym_constinit] = ACTIONS(2930),
    [anon_sym_consteval] = ACTIONS(2930),
    [anon_sym_alignas] = ACTIONS(2930),
    [anon_sym__Alignas] = ACTIONS(2930),
    [sym_primitive_type] = ACTIONS(2930),
    [anon_sym_enum] = ACTIONS(2930),
    [anon_sym_class] = ACTIONS(2930),
    [anon_sym_struct] = ACTIONS(2930),
    [anon_sym_union] = ACTIONS(2930),
    [anon_sym_if] = ACTIONS(2930),
    [anon_sym_switch] = ACTIONS(2930),
    [anon_sym_case] = ACTIONS(2930),
    [anon_sym_default] = ACTIONS(2930),
    [anon_sym_while] = ACTIONS(2930),
    [anon_sym_do] = ACTIONS(2930),
    [anon_sym_for] = ACTIONS(2930),
    [anon_sym_return] = ACTIONS(2930),
    [anon_sym_break] = ACTIONS(2930),
    [anon_sym_continue] = ACTIONS(2930),
    [anon_sym_goto] = ACTIONS(2930),
    [anon_sym___try] = ACTIONS(2930),
    [anon_sym___leave] = ACTIONS(2930),
    [anon_sym_not] = ACTIONS(2930),
    [anon_sym_compl] = ACTIONS(2930),
    [anon_sym_DASH_DASH] = ACTIONS(2928),
    [anon_sym_PLUS_PLUS] = ACTIONS(2928),
    [anon_sym_sizeof] = ACTIONS(2930),
    [anon_sym___alignof__] = ACTIONS(2930),
    [anon_sym___alignof] = ACTIONS(2930),
    [anon_sym__alignof] = ACTIONS(2930),
    [anon_sym_alignof] = ACTIONS(2930),
    [anon_sym__Alignof] = ACTIONS(2930),
    [anon_sym_offsetof] = ACTIONS(2930),
    [anon_sym__Generic] = ACTIONS(2930),
    [anon_sym_asm] = ACTIONS(2930),
    [anon_sym___asm__] = ACTIONS(2930),
    [anon_sym___asm] = ACTIONS(2930),
    [anon_sym_DOT] = ACTIONS(2930),
    [sym_number_literal] = ACTIONS(2928),
    [anon_sym_L_SQUOTE] = ACTIONS(2928),
    [anon_sym_u_SQUOTE] = ACTIONS(2928),
    [anon_sym_U_SQUOTE] = ACTIONS(2928),
    [anon_sym_u8_SQUOTE] = ACTIONS(2928),
    [anon_sym_SQUOTE] = ACTIONS(2928),
    [anon_sym_L_DQUOTE] = ACTIONS(2928),
    [anon_sym_u_DQUOTE] = ACTIONS(2928),
    [anon_sym_U_DQUOTE] = ACTIONS(2928),
    [anon_sym_u8_DQUOTE] = ACTIONS(2928),
    [anon_sym_DQUOTE] = ACTIONS(2928),
    [sym_true] = ACTIONS(2930),
    [sym_false] = ACTIONS(2930),
    [anon_sym_NULL] = ACTIONS(2930),
    [anon_sym_nullptr] = ACTIONS(2930),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2930),
    [anon_sym_This] = ACTIONS(2930),
    [anon_sym_decltype] = ACTIONS(2930),
    [anon_sym_explicit] = ACTIONS(2930),
    [anon_sym_typename] = ACTIONS(2930),
    [anon_sym_template] = ACTIONS(2930),
    [anon_sym_operator] = ACTIONS(2930),
    [anon_sym_try] = ACTIONS(2930),
    [anon_sym_delete] = ACTIONS(2930),
    [anon_sym_throw] = ACTIONS(2930),
    [anon_sym_namespace] = ACTIONS(2930),
    [anon_sym_static_assert] = ACTIONS(2930),
    [anon_sym_concept] = ACTIONS(2930),
    [anon_sym_co_return] = ACTIONS(2930),
    [anon_sym_co_yield] = ACTIONS(2930),
    [anon_sym_R_DQUOTE] = ACTIONS(2928),
    [anon_sym_LR_DQUOTE] = ACTIONS(2928),
    [anon_sym_uR_DQUOTE] = ACTIONS(2928),
    [anon_sym_UR_DQUOTE] = ACTIONS(2928),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2928),
    [anon_sym_co_await] = ACTIONS(2930),
    [anon_sym_new] = ACTIONS(2930),
    [anon_sym_requires] = ACTIONS(2930),
    [sym_this] = ACTIONS(2930),
    [anon_sym_discard] = ACTIONS(2930),
    [anon_sym_precise] = ACTIONS(2930),
    [anon_sym_shared] = ACTIONS(2930),
    [anon_sym_groupshared] = ACTIONS(2930),
    [anon_sym_uniform] = ACTIONS(2930),
    [anon_sym_row_major] = ACTIONS(2930),
    [anon_sym_column_major] = ACTIONS(2930),
    [anon_sym_globallycoherent] = ACTIONS(2930),
    [anon_sym_centroid] = ACTIONS(2930),
    [anon_sym_noperspective] = ACTIONS(2930),
    [anon_sym_nointerpolation] = ACTIONS(2930),
    [anon_sym_sample] = ACTIONS(2930),
    [anon_sym_linear] = ACTIONS(2930),
    [anon_sym_snorm] = ACTIONS(2930),
    [anon_sym_unorm] = ACTIONS(2930),
    [anon_sym_point] = ACTIONS(2930),
    [anon_sym_line] = ACTIONS(2930),
    [anon_sym_triangleadj] = ACTIONS(2930),
    [anon_sym_lineadj] = ACTIONS(2930),
    [anon_sym_triangle] = ACTIONS(2930),
    [anon_sym_cbuffer] = ACTIONS(2930),
    [anon_sym_interface] = ACTIONS(2930),
    [anon_sym_extension] = ACTIONS(2930),
  },
  [785] = {
    [sym_identifier] = ACTIONS(2934),
    [aux_sym_preproc_include_token1] = ACTIONS(2934),
    [aux_sym_preproc_def_token1] = ACTIONS(2934),
    [aux_sym_preproc_if_token1] = ACTIONS(2934),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2934),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2934),
    [sym_preproc_directive] = ACTIONS(2934),
    [anon_sym_LPAREN2] = ACTIONS(2932),
    [anon_sym_BANG] = ACTIONS(2932),
    [anon_sym_TILDE] = ACTIONS(2932),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_STAR] = ACTIONS(2932),
    [anon_sym_AMP_AMP] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym___extension__] = ACTIONS(2934),
    [anon_sym_typedef] = ACTIONS(2934),
    [anon_sym_in] = ACTIONS(2934),
    [anon_sym_out] = ACTIONS(2934),
    [anon_sym_inout] = ACTIONS(2934),
    [anon_sym_virtual] = ACTIONS(2934),
    [anon_sym_extern] = ACTIONS(2934),
    [anon_sym___attribute__] = ACTIONS(2934),
    [anon_sym___attribute] = ACTIONS(2934),
    [anon_sym_using] = ACTIONS(2934),
    [anon_sym_COLON_COLON] = ACTIONS(2932),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2932),
    [anon_sym___declspec] = ACTIONS(2934),
    [anon_sym___based] = ACTIONS(2934),
    [anon_sym___cdecl] = ACTIONS(2934),
    [anon_sym___clrcall] = ACTIONS(2934),
    [anon_sym___stdcall] = ACTIONS(2934),
    [anon_sym___fastcall] = ACTIONS(2934),
    [anon_sym___thiscall] = ACTIONS(2934),
    [anon_sym___vectorcall] = ACTIONS(2934),
    [anon_sym_LBRACE] = ACTIONS(2932),
    [anon_sym_RBRACE] = ACTIONS(2932),
    [anon_sym_signed] = ACTIONS(2934),
    [anon_sym_unsigned] = ACTIONS(2934),
    [anon_sym_long] = ACTIONS(2934),
    [anon_sym_short] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [anon_sym_static] = ACTIONS(2934),
    [anon_sym_register] = ACTIONS(2934),
    [anon_sym_inline] = ACTIONS(2934),
    [anon_sym___inline] = ACTIONS(2934),
    [anon_sym___inline__] = ACTIONS(2934),
    [anon_sym___forceinline] = ACTIONS(2934),
    [anon_sym_thread_local] = ACTIONS(2934),
    [anon_sym___thread] = ACTIONS(2934),
    [anon_sym_const] = ACTIONS(2934),
    [anon_sym_constexpr] = ACTIONS(2934),
    [anon_sym_volatile] = ACTIONS(2934),
    [anon_sym_restrict] = ACTIONS(2934),
    [anon_sym___restrict__] = ACTIONS(2934),
    [anon_sym__Atomic] = ACTIONS(2934),
    [anon_sym__Noreturn] = ACTIONS(2934),
    [anon_sym_noreturn] = ACTIONS(2934),
    [anon_sym__Nonnull] = ACTIONS(2934),
    [anon_sym_mutable] = ACTIONS(2934),
    [anon_sym_constinit] = ACTIONS(2934),
    [anon_sym_consteval] = ACTIONS(2934),
    [anon_sym_alignas] = ACTIONS(2934),
    [anon_sym__Alignas] = ACTIONS(2934),
    [sym_primitive_type] = ACTIONS(2934),
    [anon_sym_enum] = ACTIONS(2934),
    [anon_sym_class] = ACTIONS(2934),
    [anon_sym_struct] = ACTIONS(2934),
    [anon_sym_union] = ACTIONS(2934),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_switch] = ACTIONS(2934),
    [anon_sym_case] = ACTIONS(2934),
    [anon_sym_default] = ACTIONS(2934),
    [anon_sym_while] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2934),
    [anon_sym_for] = ACTIONS(2934),
    [anon_sym_return] = ACTIONS(2934),
    [anon_sym_break] = ACTIONS(2934),
    [anon_sym_continue] = ACTIONS(2934),
    [anon_sym_goto] = ACTIONS(2934),
    [anon_sym___try] = ACTIONS(2934),
    [anon_sym___leave] = ACTIONS(2934),
    [anon_sym_not] = ACTIONS(2934),
    [anon_sym_compl] = ACTIONS(2934),
    [anon_sym_DASH_DASH] = ACTIONS(2932),
    [anon_sym_PLUS_PLUS] = ACTIONS(2932),
    [anon_sym_sizeof] = ACTIONS(2934),
    [anon_sym___alignof__] = ACTIONS(2934),
    [anon_sym___alignof] = ACTIONS(2934),
    [anon_sym__alignof] = ACTIONS(2934),
    [anon_sym_alignof] = ACTIONS(2934),
    [anon_sym__Alignof] = ACTIONS(2934),
    [anon_sym_offsetof] = ACTIONS(2934),
    [anon_sym__Generic] = ACTIONS(2934),
    [anon_sym_asm] = ACTIONS(2934),
    [anon_sym___asm__] = ACTIONS(2934),
    [anon_sym___asm] = ACTIONS(2934),
    [anon_sym_DOT] = ACTIONS(2934),
    [sym_number_literal] = ACTIONS(2932),
    [anon_sym_L_SQUOTE] = ACTIONS(2932),
    [anon_sym_u_SQUOTE] = ACTIONS(2932),
    [anon_sym_U_SQUOTE] = ACTIONS(2932),
    [anon_sym_u8_SQUOTE] = ACTIONS(2932),
    [anon_sym_SQUOTE] = ACTIONS(2932),
    [anon_sym_L_DQUOTE] = ACTIONS(2932),
    [anon_sym_u_DQUOTE] = ACTIONS(2932),
    [anon_sym_U_DQUOTE] = ACTIONS(2932),
    [anon_sym_u8_DQUOTE] = ACTIONS(2932),
    [anon_sym_DQUOTE] = ACTIONS(2932),
    [sym_true] = ACTIONS(2934),
    [sym_false] = ACTIONS(2934),
    [anon_sym_NULL] = ACTIONS(2934),
    [anon_sym_nullptr] = ACTIONS(2934),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_This] = ACTIONS(2934),
    [anon_sym_decltype] = ACTIONS(2934),
    [anon_sym_explicit] = ACTIONS(2934),
    [anon_sym_typename] = ACTIONS(2934),
    [anon_sym_template] = ACTIONS(2934),
    [anon_sym_operator] = ACTIONS(2934),
    [anon_sym_try] = ACTIONS(2934),
    [anon_sym_delete] = ACTIONS(2934),
    [anon_sym_throw] = ACTIONS(2934),
    [anon_sym_namespace] = ACTIONS(2934),
    [anon_sym_static_assert] = ACTIONS(2934),
    [anon_sym_concept] = ACTIONS(2934),
    [anon_sym_co_return] = ACTIONS(2934),
    [anon_sym_co_yield] = ACTIONS(2934),
    [anon_sym_R_DQUOTE] = ACTIONS(2932),
    [anon_sym_LR_DQUOTE] = ACTIONS(2932),
    [anon_sym_uR_DQUOTE] = ACTIONS(2932),
    [anon_sym_UR_DQUOTE] = ACTIONS(2932),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2932),
    [anon_sym_co_await] = ACTIONS(2934),
    [anon_sym_new] = ACTIONS(2934),
    [anon_sym_requires] = ACTIONS(2934),
    [sym_this] = ACTIONS(2934),
    [anon_sym_discard] = ACTIONS(2934),
    [anon_sym_precise] = ACTIONS(2934),
    [anon_sym_shared] = ACTIONS(2934),
    [anon_sym_groupshared] = ACTIONS(2934),
    [anon_sym_uniform] = ACTIONS(2934),
    [anon_sym_row_major] = ACTIONS(2934),
    [anon_sym_column_major] = ACTIONS(2934),
    [anon_sym_globallycoherent] = ACTIONS(2934),
    [anon_sym_centroid] = ACTIONS(2934),
    [anon_sym_noperspective] = ACTIONS(2934),
    [anon_sym_nointerpolation] = ACTIONS(2934),
    [anon_sym_sample] = ACTIONS(2934),
    [anon_sym_linear] = ACTIONS(2934),
    [anon_sym_snorm] = ACTIONS(2934),
    [anon_sym_unorm] = ACTIONS(2934),
    [anon_sym_point] = ACTIONS(2934),
    [anon_sym_line] = ACTIONS(2934),
    [anon_sym_triangleadj] = ACTIONS(2934),
    [anon_sym_lineadj] = ACTIONS(2934),
    [anon_sym_triangle] = ACTIONS(2934),
    [anon_sym_cbuffer] = ACTIONS(2934),
    [anon_sym_interface] = ACTIONS(2934),
    [anon_sym_extension] = ACTIONS(2934),
  },
  [786] = {
    [sym_identifier] = ACTIONS(2879),
    [aux_sym_preproc_include_token1] = ACTIONS(2879),
    [aux_sym_preproc_def_token1] = ACTIONS(2879),
    [aux_sym_preproc_if_token1] = ACTIONS(2879),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2879),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2879),
    [sym_preproc_directive] = ACTIONS(2879),
    [anon_sym_LPAREN2] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2879),
    [anon_sym_PLUS] = ACTIONS(2879),
    [anon_sym_STAR] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_AMP] = ACTIONS(2879),
    [anon_sym_SEMI] = ACTIONS(2877),
    [anon_sym___extension__] = ACTIONS(2879),
    [anon_sym_typedef] = ACTIONS(2879),
    [anon_sym_in] = ACTIONS(2879),
    [anon_sym_out] = ACTIONS(2879),
    [anon_sym_inout] = ACTIONS(2879),
    [anon_sym_virtual] = ACTIONS(2879),
    [anon_sym_extern] = ACTIONS(2879),
    [anon_sym___attribute__] = ACTIONS(2879),
    [anon_sym___attribute] = ACTIONS(2879),
    [anon_sym_using] = ACTIONS(2879),
    [anon_sym_COLON_COLON] = ACTIONS(2877),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2877),
    [anon_sym___declspec] = ACTIONS(2879),
    [anon_sym___based] = ACTIONS(2879),
    [anon_sym___cdecl] = ACTIONS(2879),
    [anon_sym___clrcall] = ACTIONS(2879),
    [anon_sym___stdcall] = ACTIONS(2879),
    [anon_sym___fastcall] = ACTIONS(2879),
    [anon_sym___thiscall] = ACTIONS(2879),
    [anon_sym___vectorcall] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_RBRACE] = ACTIONS(2877),
    [anon_sym_signed] = ACTIONS(2879),
    [anon_sym_unsigned] = ACTIONS(2879),
    [anon_sym_long] = ACTIONS(2879),
    [anon_sym_short] = ACTIONS(2879),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_static] = ACTIONS(2879),
    [anon_sym_register] = ACTIONS(2879),
    [anon_sym_inline] = ACTIONS(2879),
    [anon_sym___inline] = ACTIONS(2879),
    [anon_sym___inline__] = ACTIONS(2879),
    [anon_sym___forceinline] = ACTIONS(2879),
    [anon_sym_thread_local] = ACTIONS(2879),
    [anon_sym___thread] = ACTIONS(2879),
    [anon_sym_const] = ACTIONS(2879),
    [anon_sym_constexpr] = ACTIONS(2879),
    [anon_sym_volatile] = ACTIONS(2879),
    [anon_sym_restrict] = ACTIONS(2879),
    [anon_sym___restrict__] = ACTIONS(2879),
    [anon_sym__Atomic] = ACTIONS(2879),
    [anon_sym__Noreturn] = ACTIONS(2879),
    [anon_sym_noreturn] = ACTIONS(2879),
    [anon_sym__Nonnull] = ACTIONS(2879),
    [anon_sym_mutable] = ACTIONS(2879),
    [anon_sym_constinit] = ACTIONS(2879),
    [anon_sym_consteval] = ACTIONS(2879),
    [anon_sym_alignas] = ACTIONS(2879),
    [anon_sym__Alignas] = ACTIONS(2879),
    [sym_primitive_type] = ACTIONS(2879),
    [anon_sym_enum] = ACTIONS(2879),
    [anon_sym_class] = ACTIONS(2879),
    [anon_sym_struct] = ACTIONS(2879),
    [anon_sym_union] = ACTIONS(2879),
    [anon_sym_if] = ACTIONS(2879),
    [anon_sym_switch] = ACTIONS(2879),
    [anon_sym_case] = ACTIONS(2879),
    [anon_sym_default] = ACTIONS(2879),
    [anon_sym_while] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2879),
    [anon_sym_for] = ACTIONS(2879),
    [anon_sym_return] = ACTIONS(2879),
    [anon_sym_break] = ACTIONS(2879),
    [anon_sym_continue] = ACTIONS(2879),
    [anon_sym_goto] = ACTIONS(2879),
    [anon_sym___try] = ACTIONS(2879),
    [anon_sym___leave] = ACTIONS(2879),
    [anon_sym_not] = ACTIONS(2879),
    [anon_sym_compl] = ACTIONS(2879),
    [anon_sym_DASH_DASH] = ACTIONS(2877),
    [anon_sym_PLUS_PLUS] = ACTIONS(2877),
    [anon_sym_sizeof] = ACTIONS(2879),
    [anon_sym___alignof__] = ACTIONS(2879),
    [anon_sym___alignof] = ACTIONS(2879),
    [anon_sym__alignof] = ACTIONS(2879),
    [anon_sym_alignof] = ACTIONS(2879),
    [anon_sym__Alignof] = ACTIONS(2879),
    [anon_sym_offsetof] = ACTIONS(2879),
    [anon_sym__Generic] = ACTIONS(2879),
    [anon_sym_asm] = ACTIONS(2879),
    [anon_sym___asm__] = ACTIONS(2879),
    [anon_sym___asm] = ACTIONS(2879),
    [anon_sym_DOT] = ACTIONS(2879),
    [sym_number_literal] = ACTIONS(2877),
    [anon_sym_L_SQUOTE] = ACTIONS(2877),
    [anon_sym_u_SQUOTE] = ACTIONS(2877),
    [anon_sym_U_SQUOTE] = ACTIONS(2877),
    [anon_sym_u8_SQUOTE] = ACTIONS(2877),
    [anon_sym_SQUOTE] = ACTIONS(2877),
    [anon_sym_L_DQUOTE] = ACTIONS(2877),
    [anon_sym_u_DQUOTE] = ACTIONS(2877),
    [anon_sym_U_DQUOTE] = ACTIONS(2877),
    [anon_sym_u8_DQUOTE] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [sym_true] = ACTIONS(2879),
    [sym_false] = ACTIONS(2879),
    [anon_sym_NULL] = ACTIONS(2879),
    [anon_sym_nullptr] = ACTIONS(2879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2879),
    [anon_sym_let] = ACTIONS(2879),
    [anon_sym_This] = ACTIONS(2879),
    [anon_sym_decltype] = ACTIONS(2879),
    [anon_sym_explicit] = ACTIONS(2879),
    [anon_sym_typename] = ACTIONS(2879),
    [anon_sym_template] = ACTIONS(2879),
    [anon_sym_operator] = ACTIONS(2879),
    [anon_sym_try] = ACTIONS(2879),
    [anon_sym_delete] = ACTIONS(2879),
    [anon_sym_throw] = ACTIONS(2879),
    [anon_sym_namespace] = ACTIONS(2879),
    [anon_sym_static_assert] = ACTIONS(2879),
    [anon_sym_concept] = ACTIONS(2879),
    [anon_sym_co_return] = ACTIONS(2879),
    [anon_sym_co_yield] = ACTIONS(2879),
    [anon_sym_R_DQUOTE] = ACTIONS(2877),
    [anon_sym_LR_DQUOTE] = ACTIONS(2877),
    [anon_sym_uR_DQUOTE] = ACTIONS(2877),
    [anon_sym_UR_DQUOTE] = ACTIONS(2877),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2877),
    [anon_sym_co_await] = ACTIONS(2879),
    [anon_sym_new] = ACTIONS(2879),
    [anon_sym_requires] = ACTIONS(2879),
    [sym_this] = ACTIONS(2879),
    [anon_sym_discard] = ACTIONS(2879),
    [anon_sym_precise] = ACTIONS(2879),
    [anon_sym_shared] = ACTIONS(2879),
    [anon_sym_groupshared] = ACTIONS(2879),
    [anon_sym_uniform] = ACTIONS(2879),
    [anon_sym_row_major] = ACTIONS(2879),
    [anon_sym_column_major] = ACTIONS(2879),
    [anon_sym_globallycoherent] = ACTIONS(2879),
    [anon_sym_centroid] = ACTIONS(2879),
    [anon_sym_noperspective] = ACTIONS(2879),
    [anon_sym_nointerpolation] = ACTIONS(2879),
    [anon_sym_sample] = ACTIONS(2879),
    [anon_sym_linear] = ACTIONS(2879),
    [anon_sym_snorm] = ACTIONS(2879),
    [anon_sym_unorm] = ACTIONS(2879),
    [anon_sym_point] = ACTIONS(2879),
    [anon_sym_line] = ACTIONS(2879),
    [anon_sym_triangleadj] = ACTIONS(2879),
    [anon_sym_lineadj] = ACTIONS(2879),
    [anon_sym_triangle] = ACTIONS(2879),
    [anon_sym_cbuffer] = ACTIONS(2879),
    [anon_sym_interface] = ACTIONS(2879),
    [anon_sym_extension] = ACTIONS(2879),
  },
  [787] = {
    [sym_identifier] = ACTIONS(2982),
    [aux_sym_preproc_include_token1] = ACTIONS(2982),
    [aux_sym_preproc_def_token1] = ACTIONS(2982),
    [aux_sym_preproc_if_token1] = ACTIONS(2982),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2982),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2982),
    [sym_preproc_directive] = ACTIONS(2982),
    [anon_sym_LPAREN2] = ACTIONS(2980),
    [anon_sym_BANG] = ACTIONS(2980),
    [anon_sym_TILDE] = ACTIONS(2980),
    [anon_sym_DASH] = ACTIONS(2982),
    [anon_sym_PLUS] = ACTIONS(2982),
    [anon_sym_STAR] = ACTIONS(2980),
    [anon_sym_AMP_AMP] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_SEMI] = ACTIONS(2980),
    [anon_sym___extension__] = ACTIONS(2982),
    [anon_sym_typedef] = ACTIONS(2982),
    [anon_sym_in] = ACTIONS(2982),
    [anon_sym_out] = ACTIONS(2982),
    [anon_sym_inout] = ACTIONS(2982),
    [anon_sym_virtual] = ACTIONS(2982),
    [anon_sym_extern] = ACTIONS(2982),
    [anon_sym___attribute__] = ACTIONS(2982),
    [anon_sym___attribute] = ACTIONS(2982),
    [anon_sym_using] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2980),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2980),
    [anon_sym___declspec] = ACTIONS(2982),
    [anon_sym___based] = ACTIONS(2982),
    [anon_sym___cdecl] = ACTIONS(2982),
    [anon_sym___clrcall] = ACTIONS(2982),
    [anon_sym___stdcall] = ACTIONS(2982),
    [anon_sym___fastcall] = ACTIONS(2982),
    [anon_sym___thiscall] = ACTIONS(2982),
    [anon_sym___vectorcall] = ACTIONS(2982),
    [anon_sym_LBRACE] = ACTIONS(2980),
    [anon_sym_RBRACE] = ACTIONS(2980),
    [anon_sym_signed] = ACTIONS(2982),
    [anon_sym_unsigned] = ACTIONS(2982),
    [anon_sym_long] = ACTIONS(2982),
    [anon_sym_short] = ACTIONS(2982),
    [anon_sym_LBRACK] = ACTIONS(2982),
    [anon_sym_static] = ACTIONS(2982),
    [anon_sym_register] = ACTIONS(2982),
    [anon_sym_inline] = ACTIONS(2982),
    [anon_sym___inline] = ACTIONS(2982),
    [anon_sym___inline__] = ACTIONS(2982),
    [anon_sym___forceinline] = ACTIONS(2982),
    [anon_sym_thread_local] = ACTIONS(2982),
    [anon_sym___thread] = ACTIONS(2982),
    [anon_sym_const] = ACTIONS(2982),
    [anon_sym_constexpr] = ACTIONS(2982),
    [anon_sym_volatile] = ACTIONS(2982),
    [anon_sym_restrict] = ACTIONS(2982),
    [anon_sym___restrict__] = ACTIONS(2982),
    [anon_sym__Atomic] = ACTIONS(2982),
    [anon_sym__Noreturn] = ACTIONS(2982),
    [anon_sym_noreturn] = ACTIONS(2982),
    [anon_sym__Nonnull] = ACTIONS(2982),
    [anon_sym_mutable] = ACTIONS(2982),
    [anon_sym_constinit] = ACTIONS(2982),
    [anon_sym_consteval] = ACTIONS(2982),
    [anon_sym_alignas] = ACTIONS(2982),
    [anon_sym__Alignas] = ACTIONS(2982),
    [sym_primitive_type] = ACTIONS(2982),
    [anon_sym_enum] = ACTIONS(2982),
    [anon_sym_class] = ACTIONS(2982),
    [anon_sym_struct] = ACTIONS(2982),
    [anon_sym_union] = ACTIONS(2982),
    [anon_sym_if] = ACTIONS(2982),
    [anon_sym_switch] = ACTIONS(2982),
    [anon_sym_case] = ACTIONS(2982),
    [anon_sym_default] = ACTIONS(2982),
    [anon_sym_while] = ACTIONS(2982),
    [anon_sym_do] = ACTIONS(2982),
    [anon_sym_for] = ACTIONS(2982),
    [anon_sym_return] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2982),
    [anon_sym_continue] = ACTIONS(2982),
    [anon_sym_goto] = ACTIONS(2982),
    [anon_sym___try] = ACTIONS(2982),
    [anon_sym___leave] = ACTIONS(2982),
    [anon_sym_not] = ACTIONS(2982),
    [anon_sym_compl] = ACTIONS(2982),
    [anon_sym_DASH_DASH] = ACTIONS(2980),
    [anon_sym_PLUS_PLUS] = ACTIONS(2980),
    [anon_sym_sizeof] = ACTIONS(2982),
    [anon_sym___alignof__] = ACTIONS(2982),
    [anon_sym___alignof] = ACTIONS(2982),
    [anon_sym__alignof] = ACTIONS(2982),
    [anon_sym_alignof] = ACTIONS(2982),
    [anon_sym__Alignof] = ACTIONS(2982),
    [anon_sym_offsetof] = ACTIONS(2982),
    [anon_sym__Generic] = ACTIONS(2982),
    [anon_sym_asm] = ACTIONS(2982),
    [anon_sym___asm__] = ACTIONS(2982),
    [anon_sym___asm] = ACTIONS(2982),
    [anon_sym_DOT] = ACTIONS(2982),
    [sym_number_literal] = ACTIONS(2980),
    [anon_sym_L_SQUOTE] = ACTIONS(2980),
    [anon_sym_u_SQUOTE] = ACTIONS(2980),
    [anon_sym_U_SQUOTE] = ACTIONS(2980),
    [anon_sym_u8_SQUOTE] = ACTIONS(2980),
    [anon_sym_SQUOTE] = ACTIONS(2980),
    [anon_sym_L_DQUOTE] = ACTIONS(2980),
    [anon_sym_u_DQUOTE] = ACTIONS(2980),
    [anon_sym_U_DQUOTE] = ACTIONS(2980),
    [anon_sym_u8_DQUOTE] = ACTIONS(2980),
    [anon_sym_DQUOTE] = ACTIONS(2980),
    [sym_true] = ACTIONS(2982),
    [sym_false] = ACTIONS(2982),
    [anon_sym_NULL] = ACTIONS(2982),
    [anon_sym_nullptr] = ACTIONS(2982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2982),
    [anon_sym_let] = ACTIONS(2982),
    [anon_sym_This] = ACTIONS(2982),
    [anon_sym_decltype] = ACTIONS(2982),
    [anon_sym_explicit] = ACTIONS(2982),
    [anon_sym_typename] = ACTIONS(2982),
    [anon_sym_template] = ACTIONS(2982),
    [anon_sym_operator] = ACTIONS(2982),
    [anon_sym_try] = ACTIONS(2982),
    [anon_sym_delete] = ACTIONS(2982),
    [anon_sym_throw] = ACTIONS(2982),
    [anon_sym_namespace] = ACTIONS(2982),
    [anon_sym_static_assert] = ACTIONS(2982),
    [anon_sym_concept] = ACTIONS(2982),
    [anon_sym_co_return] = ACTIONS(2982),
    [anon_sym_co_yield] = ACTIONS(2982),
    [anon_sym_R_DQUOTE] = ACTIONS(2980),
    [anon_sym_LR_DQUOTE] = ACTIONS(2980),
    [anon_sym_uR_DQUOTE] = ACTIONS(2980),
    [anon_sym_UR_DQUOTE] = ACTIONS(2980),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2980),
    [anon_sym_co_await] = ACTIONS(2982),
    [anon_sym_new] = ACTIONS(2982),
    [anon_sym_requires] = ACTIONS(2982),
    [sym_this] = ACTIONS(2982),
    [anon_sym_discard] = ACTIONS(2982),
    [anon_sym_precise] = ACTIONS(2982),
    [anon_sym_shared] = ACTIONS(2982),
    [anon_sym_groupshared] = ACTIONS(2982),
    [anon_sym_uniform] = ACTIONS(2982),
    [anon_sym_row_major] = ACTIONS(2982),
    [anon_sym_column_major] = ACTIONS(2982),
    [anon_sym_globallycoherent] = ACTIONS(2982),
    [anon_sym_centroid] = ACTIONS(2982),
    [anon_sym_noperspective] = ACTIONS(2982),
    [anon_sym_nointerpolation] = ACTIONS(2982),
    [anon_sym_sample] = ACTIONS(2982),
    [anon_sym_linear] = ACTIONS(2982),
    [anon_sym_snorm] = ACTIONS(2982),
    [anon_sym_unorm] = ACTIONS(2982),
    [anon_sym_point] = ACTIONS(2982),
    [anon_sym_line] = ACTIONS(2982),
    [anon_sym_triangleadj] = ACTIONS(2982),
    [anon_sym_lineadj] = ACTIONS(2982),
    [anon_sym_triangle] = ACTIONS(2982),
    [anon_sym_cbuffer] = ACTIONS(2982),
    [anon_sym_interface] = ACTIONS(2982),
    [anon_sym_extension] = ACTIONS(2982),
  },
  [788] = {
    [sym_identifier] = ACTIONS(3058),
    [aux_sym_preproc_include_token1] = ACTIONS(3058),
    [aux_sym_preproc_def_token1] = ACTIONS(3058),
    [aux_sym_preproc_if_token1] = ACTIONS(3058),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3058),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3058),
    [sym_preproc_directive] = ACTIONS(3058),
    [anon_sym_LPAREN2] = ACTIONS(3056),
    [anon_sym_BANG] = ACTIONS(3056),
    [anon_sym_TILDE] = ACTIONS(3056),
    [anon_sym_DASH] = ACTIONS(3058),
    [anon_sym_PLUS] = ACTIONS(3058),
    [anon_sym_STAR] = ACTIONS(3056),
    [anon_sym_AMP_AMP] = ACTIONS(3056),
    [anon_sym_AMP] = ACTIONS(3058),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym___extension__] = ACTIONS(3058),
    [anon_sym_typedef] = ACTIONS(3058),
    [anon_sym_in] = ACTIONS(3058),
    [anon_sym_out] = ACTIONS(3058),
    [anon_sym_inout] = ACTIONS(3058),
    [anon_sym_virtual] = ACTIONS(3058),
    [anon_sym_extern] = ACTIONS(3058),
    [anon_sym___attribute__] = ACTIONS(3058),
    [anon_sym___attribute] = ACTIONS(3058),
    [anon_sym_using] = ACTIONS(3058),
    [anon_sym_COLON_COLON] = ACTIONS(3056),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3056),
    [anon_sym___declspec] = ACTIONS(3058),
    [anon_sym___based] = ACTIONS(3058),
    [anon_sym___cdecl] = ACTIONS(3058),
    [anon_sym___clrcall] = ACTIONS(3058),
    [anon_sym___stdcall] = ACTIONS(3058),
    [anon_sym___fastcall] = ACTIONS(3058),
    [anon_sym___thiscall] = ACTIONS(3058),
    [anon_sym___vectorcall] = ACTIONS(3058),
    [anon_sym_LBRACE] = ACTIONS(3056),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_signed] = ACTIONS(3058),
    [anon_sym_unsigned] = ACTIONS(3058),
    [anon_sym_long] = ACTIONS(3058),
    [anon_sym_short] = ACTIONS(3058),
    [anon_sym_LBRACK] = ACTIONS(3058),
    [anon_sym_static] = ACTIONS(3058),
    [anon_sym_register] = ACTIONS(3058),
    [anon_sym_inline] = ACTIONS(3058),
    [anon_sym___inline] = ACTIONS(3058),
    [anon_sym___inline__] = ACTIONS(3058),
    [anon_sym___forceinline] = ACTIONS(3058),
    [anon_sym_thread_local] = ACTIONS(3058),
    [anon_sym___thread] = ACTIONS(3058),
    [anon_sym_const] = ACTIONS(3058),
    [anon_sym_constexpr] = ACTIONS(3058),
    [anon_sym_volatile] = ACTIONS(3058),
    [anon_sym_restrict] = ACTIONS(3058),
    [anon_sym___restrict__] = ACTIONS(3058),
    [anon_sym__Atomic] = ACTIONS(3058),
    [anon_sym__Noreturn] = ACTIONS(3058),
    [anon_sym_noreturn] = ACTIONS(3058),
    [anon_sym__Nonnull] = ACTIONS(3058),
    [anon_sym_mutable] = ACTIONS(3058),
    [anon_sym_constinit] = ACTIONS(3058),
    [anon_sym_consteval] = ACTIONS(3058),
    [anon_sym_alignas] = ACTIONS(3058),
    [anon_sym__Alignas] = ACTIONS(3058),
    [sym_primitive_type] = ACTIONS(3058),
    [anon_sym_enum] = ACTIONS(3058),
    [anon_sym_class] = ACTIONS(3058),
    [anon_sym_struct] = ACTIONS(3058),
    [anon_sym_union] = ACTIONS(3058),
    [anon_sym_if] = ACTIONS(3058),
    [anon_sym_switch] = ACTIONS(3058),
    [anon_sym_case] = ACTIONS(3058),
    [anon_sym_default] = ACTIONS(3058),
    [anon_sym_while] = ACTIONS(3058),
    [anon_sym_do] = ACTIONS(3058),
    [anon_sym_for] = ACTIONS(3058),
    [anon_sym_return] = ACTIONS(3058),
    [anon_sym_break] = ACTIONS(3058),
    [anon_sym_continue] = ACTIONS(3058),
    [anon_sym_goto] = ACTIONS(3058),
    [anon_sym___try] = ACTIONS(3058),
    [anon_sym___leave] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3058),
    [anon_sym_compl] = ACTIONS(3058),
    [anon_sym_DASH_DASH] = ACTIONS(3056),
    [anon_sym_PLUS_PLUS] = ACTIONS(3056),
    [anon_sym_sizeof] = ACTIONS(3058),
    [anon_sym___alignof__] = ACTIONS(3058),
    [anon_sym___alignof] = ACTIONS(3058),
    [anon_sym__alignof] = ACTIONS(3058),
    [anon_sym_alignof] = ACTIONS(3058),
    [anon_sym__Alignof] = ACTIONS(3058),
    [anon_sym_offsetof] = ACTIONS(3058),
    [anon_sym__Generic] = ACTIONS(3058),
    [anon_sym_asm] = ACTIONS(3058),
    [anon_sym___asm__] = ACTIONS(3058),
    [anon_sym___asm] = ACTIONS(3058),
    [anon_sym_DOT] = ACTIONS(3058),
    [sym_number_literal] = ACTIONS(3056),
    [anon_sym_L_SQUOTE] = ACTIONS(3056),
    [anon_sym_u_SQUOTE] = ACTIONS(3056),
    [anon_sym_U_SQUOTE] = ACTIONS(3056),
    [anon_sym_u8_SQUOTE] = ACTIONS(3056),
    [anon_sym_SQUOTE] = ACTIONS(3056),
    [anon_sym_L_DQUOTE] = ACTIONS(3056),
    [anon_sym_u_DQUOTE] = ACTIONS(3056),
    [anon_sym_U_DQUOTE] = ACTIONS(3056),
    [anon_sym_u8_DQUOTE] = ACTIONS(3056),
    [anon_sym_DQUOTE] = ACTIONS(3056),
    [sym_true] = ACTIONS(3058),
    [sym_false] = ACTIONS(3058),
    [anon_sym_NULL] = ACTIONS(3058),
    [anon_sym_nullptr] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3058),
    [anon_sym_let] = ACTIONS(3058),
    [anon_sym_This] = ACTIONS(3058),
    [anon_sym_decltype] = ACTIONS(3058),
    [anon_sym_explicit] = ACTIONS(3058),
    [anon_sym_typename] = ACTIONS(3058),
    [anon_sym_template] = ACTIONS(3058),
    [anon_sym_operator] = ACTIONS(3058),
    [anon_sym_try] = ACTIONS(3058),
    [anon_sym_delete] = ACTIONS(3058),
    [anon_sym_throw] = ACTIONS(3058),
    [anon_sym_namespace] = ACTIONS(3058),
    [anon_sym_static_assert] = ACTIONS(3058),
    [anon_sym_concept] = ACTIONS(3058),
    [anon_sym_co_return] = ACTIONS(3058),
    [anon_sym_co_yield] = ACTIONS(3058),
    [anon_sym_R_DQUOTE] = ACTIONS(3056),
    [anon_sym_LR_DQUOTE] = ACTIONS(3056),
    [anon_sym_uR_DQUOTE] = ACTIONS(3056),
    [anon_sym_UR_DQUOTE] = ACTIONS(3056),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3056),
    [anon_sym_co_await] = ACTIONS(3058),
    [anon_sym_new] = ACTIONS(3058),
    [anon_sym_requires] = ACTIONS(3058),
    [sym_this] = ACTIONS(3058),
    [anon_sym_discard] = ACTIONS(3058),
    [anon_sym_precise] = ACTIONS(3058),
    [anon_sym_shared] = ACTIONS(3058),
    [anon_sym_groupshared] = ACTIONS(3058),
    [anon_sym_uniform] = ACTIONS(3058),
    [anon_sym_row_major] = ACTIONS(3058),
    [anon_sym_column_major] = ACTIONS(3058),
    [anon_sym_globallycoherent] = ACTIONS(3058),
    [anon_sym_centroid] = ACTIONS(3058),
    [anon_sym_noperspective] = ACTIONS(3058),
    [anon_sym_nointerpolation] = ACTIONS(3058),
    [anon_sym_sample] = ACTIONS(3058),
    [anon_sym_linear] = ACTIONS(3058),
    [anon_sym_snorm] = ACTIONS(3058),
    [anon_sym_unorm] = ACTIONS(3058),
    [anon_sym_point] = ACTIONS(3058),
    [anon_sym_line] = ACTIONS(3058),
    [anon_sym_triangleadj] = ACTIONS(3058),
    [anon_sym_lineadj] = ACTIONS(3058),
    [anon_sym_triangle] = ACTIONS(3058),
    [anon_sym_cbuffer] = ACTIONS(3058),
    [anon_sym_interface] = ACTIONS(3058),
    [anon_sym_extension] = ACTIONS(3058),
  },
  [789] = {
    [sym_identifier] = ACTIONS(2986),
    [aux_sym_preproc_include_token1] = ACTIONS(2986),
    [aux_sym_preproc_def_token1] = ACTIONS(2986),
    [aux_sym_preproc_if_token1] = ACTIONS(2986),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2986),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2986),
    [sym_preproc_directive] = ACTIONS(2986),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_BANG] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2984),
    [anon_sym_DASH] = ACTIONS(2986),
    [anon_sym_PLUS] = ACTIONS(2986),
    [anon_sym_STAR] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_AMP] = ACTIONS(2986),
    [anon_sym_SEMI] = ACTIONS(2984),
    [anon_sym___extension__] = ACTIONS(2986),
    [anon_sym_typedef] = ACTIONS(2986),
    [anon_sym_in] = ACTIONS(2986),
    [anon_sym_out] = ACTIONS(2986),
    [anon_sym_inout] = ACTIONS(2986),
    [anon_sym_virtual] = ACTIONS(2986),
    [anon_sym_extern] = ACTIONS(2986),
    [anon_sym___attribute__] = ACTIONS(2986),
    [anon_sym___attribute] = ACTIONS(2986),
    [anon_sym_using] = ACTIONS(2986),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2984),
    [anon_sym___declspec] = ACTIONS(2986),
    [anon_sym___based] = ACTIONS(2986),
    [anon_sym___cdecl] = ACTIONS(2986),
    [anon_sym___clrcall] = ACTIONS(2986),
    [anon_sym___stdcall] = ACTIONS(2986),
    [anon_sym___fastcall] = ACTIONS(2986),
    [anon_sym___thiscall] = ACTIONS(2986),
    [anon_sym___vectorcall] = ACTIONS(2986),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_RBRACE] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2986),
    [anon_sym_unsigned] = ACTIONS(2986),
    [anon_sym_long] = ACTIONS(2986),
    [anon_sym_short] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2986),
    [anon_sym_static] = ACTIONS(2986),
    [anon_sym_register] = ACTIONS(2986),
    [anon_sym_inline] = ACTIONS(2986),
    [anon_sym___inline] = ACTIONS(2986),
    [anon_sym___inline__] = ACTIONS(2986),
    [anon_sym___forceinline] = ACTIONS(2986),
    [anon_sym_thread_local] = ACTIONS(2986),
    [anon_sym___thread] = ACTIONS(2986),
    [anon_sym_const] = ACTIONS(2986),
    [anon_sym_constexpr] = ACTIONS(2986),
    [anon_sym_volatile] = ACTIONS(2986),
    [anon_sym_restrict] = ACTIONS(2986),
    [anon_sym___restrict__] = ACTIONS(2986),
    [anon_sym__Atomic] = ACTIONS(2986),
    [anon_sym__Noreturn] = ACTIONS(2986),
    [anon_sym_noreturn] = ACTIONS(2986),
    [anon_sym__Nonnull] = ACTIONS(2986),
    [anon_sym_mutable] = ACTIONS(2986),
    [anon_sym_constinit] = ACTIONS(2986),
    [anon_sym_consteval] = ACTIONS(2986),
    [anon_sym_alignas] = ACTIONS(2986),
    [anon_sym__Alignas] = ACTIONS(2986),
    [sym_primitive_type] = ACTIONS(2986),
    [anon_sym_enum] = ACTIONS(2986),
    [anon_sym_class] = ACTIONS(2986),
    [anon_sym_struct] = ACTIONS(2986),
    [anon_sym_union] = ACTIONS(2986),
    [anon_sym_if] = ACTIONS(2986),
    [anon_sym_switch] = ACTIONS(2986),
    [anon_sym_case] = ACTIONS(2986),
    [anon_sym_default] = ACTIONS(2986),
    [anon_sym_while] = ACTIONS(2986),
    [anon_sym_do] = ACTIONS(2986),
    [anon_sym_for] = ACTIONS(2986),
    [anon_sym_return] = ACTIONS(2986),
    [anon_sym_break] = ACTIONS(2986),
    [anon_sym_continue] = ACTIONS(2986),
    [anon_sym_goto] = ACTIONS(2986),
    [anon_sym___try] = ACTIONS(2986),
    [anon_sym___leave] = ACTIONS(2986),
    [anon_sym_not] = ACTIONS(2986),
    [anon_sym_compl] = ACTIONS(2986),
    [anon_sym_DASH_DASH] = ACTIONS(2984),
    [anon_sym_PLUS_PLUS] = ACTIONS(2984),
    [anon_sym_sizeof] = ACTIONS(2986),
    [anon_sym___alignof__] = ACTIONS(2986),
    [anon_sym___alignof] = ACTIONS(2986),
    [anon_sym__alignof] = ACTIONS(2986),
    [anon_sym_alignof] = ACTIONS(2986),
    [anon_sym__Alignof] = ACTIONS(2986),
    [anon_sym_offsetof] = ACTIONS(2986),
    [anon_sym__Generic] = ACTIONS(2986),
    [anon_sym_asm] = ACTIONS(2986),
    [anon_sym___asm__] = ACTIONS(2986),
    [anon_sym___asm] = ACTIONS(2986),
    [anon_sym_DOT] = ACTIONS(2986),
    [sym_number_literal] = ACTIONS(2984),
    [anon_sym_L_SQUOTE] = ACTIONS(2984),
    [anon_sym_u_SQUOTE] = ACTIONS(2984),
    [anon_sym_U_SQUOTE] = ACTIONS(2984),
    [anon_sym_u8_SQUOTE] = ACTIONS(2984),
    [anon_sym_SQUOTE] = ACTIONS(2984),
    [anon_sym_L_DQUOTE] = ACTIONS(2984),
    [anon_sym_u_DQUOTE] = ACTIONS(2984),
    [anon_sym_U_DQUOTE] = ACTIONS(2984),
    [anon_sym_u8_DQUOTE] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(2984),
    [sym_true] = ACTIONS(2986),
    [sym_false] = ACTIONS(2986),
    [anon_sym_NULL] = ACTIONS(2986),
    [anon_sym_nullptr] = ACTIONS(2986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2986),
    [anon_sym_let] = ACTIONS(2986),
    [anon_sym_This] = ACTIONS(2986),
    [anon_sym_decltype] = ACTIONS(2986),
    [anon_sym_explicit] = ACTIONS(2986),
    [anon_sym_typename] = ACTIONS(2986),
    [anon_sym_template] = ACTIONS(2986),
    [anon_sym_operator] = ACTIONS(2986),
    [anon_sym_try] = ACTIONS(2986),
    [anon_sym_delete] = ACTIONS(2986),
    [anon_sym_throw] = ACTIONS(2986),
    [anon_sym_namespace] = ACTIONS(2986),
    [anon_sym_static_assert] = ACTIONS(2986),
    [anon_sym_concept] = ACTIONS(2986),
    [anon_sym_co_return] = ACTIONS(2986),
    [anon_sym_co_yield] = ACTIONS(2986),
    [anon_sym_R_DQUOTE] = ACTIONS(2984),
    [anon_sym_LR_DQUOTE] = ACTIONS(2984),
    [anon_sym_uR_DQUOTE] = ACTIONS(2984),
    [anon_sym_UR_DQUOTE] = ACTIONS(2984),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2984),
    [anon_sym_co_await] = ACTIONS(2986),
    [anon_sym_new] = ACTIONS(2986),
    [anon_sym_requires] = ACTIONS(2986),
    [sym_this] = ACTIONS(2986),
    [anon_sym_discard] = ACTIONS(2986),
    [anon_sym_precise] = ACTIONS(2986),
    [anon_sym_shared] = ACTIONS(2986),
    [anon_sym_groupshared] = ACTIONS(2986),
    [anon_sym_uniform] = ACTIONS(2986),
    [anon_sym_row_major] = ACTIONS(2986),
    [anon_sym_column_major] = ACTIONS(2986),
    [anon_sym_globallycoherent] = ACTIONS(2986),
    [anon_sym_centroid] = ACTIONS(2986),
    [anon_sym_noperspective] = ACTIONS(2986),
    [anon_sym_nointerpolation] = ACTIONS(2986),
    [anon_sym_sample] = ACTIONS(2986),
    [anon_sym_linear] = ACTIONS(2986),
    [anon_sym_snorm] = ACTIONS(2986),
    [anon_sym_unorm] = ACTIONS(2986),
    [anon_sym_point] = ACTIONS(2986),
    [anon_sym_line] = ACTIONS(2986),
    [anon_sym_triangleadj] = ACTIONS(2986),
    [anon_sym_lineadj] = ACTIONS(2986),
    [anon_sym_triangle] = ACTIONS(2986),
    [anon_sym_cbuffer] = ACTIONS(2986),
    [anon_sym_interface] = ACTIONS(2986),
    [anon_sym_extension] = ACTIONS(2986),
  },
  [790] = {
    [sym_identifier] = ACTIONS(3562),
    [aux_sym_preproc_include_token1] = ACTIONS(3562),
    [aux_sym_preproc_def_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3562),
    [sym_preproc_directive] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym___extension__] = ACTIONS(3562),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_in] = ACTIONS(3562),
    [anon_sym_out] = ACTIONS(3562),
    [anon_sym_inout] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym___attribute__] = ACTIONS(3562),
    [anon_sym___attribute] = ACTIONS(3562),
    [anon_sym_using] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3560),
    [anon_sym___declspec] = ACTIONS(3562),
    [anon_sym___based] = ACTIONS(3562),
    [anon_sym___cdecl] = ACTIONS(3562),
    [anon_sym___clrcall] = ACTIONS(3562),
    [anon_sym___stdcall] = ACTIONS(3562),
    [anon_sym___fastcall] = ACTIONS(3562),
    [anon_sym___thiscall] = ACTIONS(3562),
    [anon_sym___vectorcall] = ACTIONS(3562),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_RBRACE] = ACTIONS(3560),
    [anon_sym_signed] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym___inline] = ACTIONS(3562),
    [anon_sym___inline__] = ACTIONS(3562),
    [anon_sym___forceinline] = ACTIONS(3562),
    [anon_sym_thread_local] = ACTIONS(3562),
    [anon_sym___thread] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_constexpr] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym___restrict__] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym__Noreturn] = ACTIONS(3562),
    [anon_sym_noreturn] = ACTIONS(3562),
    [anon_sym__Nonnull] = ACTIONS(3562),
    [anon_sym_mutable] = ACTIONS(3562),
    [anon_sym_constinit] = ACTIONS(3562),
    [anon_sym_consteval] = ACTIONS(3562),
    [anon_sym_alignas] = ACTIONS(3562),
    [anon_sym__Alignas] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_else] = ACTIONS(3562),
    [anon_sym_switch] = ACTIONS(3562),
    [anon_sym_case] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_goto] = ACTIONS(3562),
    [anon_sym___try] = ACTIONS(3562),
    [anon_sym___leave] = ACTIONS(3562),
    [anon_sym_not] = ACTIONS(3562),
    [anon_sym_compl] = ACTIONS(3562),
    [anon_sym_DASH_DASH] = ACTIONS(3560),
    [anon_sym_PLUS_PLUS] = ACTIONS(3560),
    [anon_sym_sizeof] = ACTIONS(3562),
    [anon_sym___alignof__] = ACTIONS(3562),
    [anon_sym___alignof] = ACTIONS(3562),
    [anon_sym__alignof] = ACTIONS(3562),
    [anon_sym_alignof] = ACTIONS(3562),
    [anon_sym__Alignof] = ACTIONS(3562),
    [anon_sym_offsetof] = ACTIONS(3562),
    [anon_sym__Generic] = ACTIONS(3562),
    [anon_sym_asm] = ACTIONS(3562),
    [anon_sym___asm__] = ACTIONS(3562),
    [anon_sym___asm] = ACTIONS(3562),
    [sym_number_literal] = ACTIONS(3560),
    [anon_sym_L_SQUOTE] = ACTIONS(3560),
    [anon_sym_u_SQUOTE] = ACTIONS(3560),
    [anon_sym_U_SQUOTE] = ACTIONS(3560),
    [anon_sym_u8_SQUOTE] = ACTIONS(3560),
    [anon_sym_SQUOTE] = ACTIONS(3560),
    [anon_sym_L_DQUOTE] = ACTIONS(3560),
    [anon_sym_u_DQUOTE] = ACTIONS(3560),
    [anon_sym_U_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE] = ACTIONS(3560),
    [sym_true] = ACTIONS(3562),
    [sym_false] = ACTIONS(3562),
    [anon_sym_NULL] = ACTIONS(3562),
    [anon_sym_nullptr] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_This] = ACTIONS(3562),
    [anon_sym_decltype] = ACTIONS(3562),
    [anon_sym_explicit] = ACTIONS(3562),
    [anon_sym_typename] = ACTIONS(3562),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_delete] = ACTIONS(3562),
    [anon_sym_throw] = ACTIONS(3562),
    [anon_sym_namespace] = ACTIONS(3562),
    [anon_sym_static_assert] = ACTIONS(3562),
    [anon_sym_concept] = ACTIONS(3562),
    [anon_sym_co_return] = ACTIONS(3562),
    [anon_sym_co_yield] = ACTIONS(3562),
    [anon_sym_R_DQUOTE] = ACTIONS(3560),
    [anon_sym_LR_DQUOTE] = ACTIONS(3560),
    [anon_sym_uR_DQUOTE] = ACTIONS(3560),
    [anon_sym_UR_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3560),
    [anon_sym_co_await] = ACTIONS(3562),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_requires] = ACTIONS(3562),
    [sym_this] = ACTIONS(3562),
    [anon_sym_discard] = ACTIONS(3562),
    [anon_sym_precise] = ACTIONS(3562),
    [anon_sym_shared] = ACTIONS(3562),
    [anon_sym_groupshared] = ACTIONS(3562),
    [anon_sym_uniform] = ACTIONS(3562),
    [anon_sym_row_major] = ACTIONS(3562),
    [anon_sym_column_major] = ACTIONS(3562),
    [anon_sym_globallycoherent] = ACTIONS(3562),
    [anon_sym_centroid] = ACTIONS(3562),
    [anon_sym_noperspective] = ACTIONS(3562),
    [anon_sym_nointerpolation] = ACTIONS(3562),
    [anon_sym_sample] = ACTIONS(3562),
    [anon_sym_linear] = ACTIONS(3562),
    [anon_sym_snorm] = ACTIONS(3562),
    [anon_sym_unorm] = ACTIONS(3562),
    [anon_sym_point] = ACTIONS(3562),
    [anon_sym_line] = ACTIONS(3562),
    [anon_sym_triangleadj] = ACTIONS(3562),
    [anon_sym_lineadj] = ACTIONS(3562),
    [anon_sym_triangle] = ACTIONS(3562),
    [anon_sym_cbuffer] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_extension] = ACTIONS(3562),
  },
  [791] = {
    [sym_identifier] = ACTIONS(2990),
    [aux_sym_preproc_include_token1] = ACTIONS(2990),
    [aux_sym_preproc_def_token1] = ACTIONS(2990),
    [aux_sym_preproc_if_token1] = ACTIONS(2990),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2990),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2990),
    [sym_preproc_directive] = ACTIONS(2990),
    [anon_sym_LPAREN2] = ACTIONS(2988),
    [anon_sym_BANG] = ACTIONS(2988),
    [anon_sym_TILDE] = ACTIONS(2988),
    [anon_sym_DASH] = ACTIONS(2990),
    [anon_sym_PLUS] = ACTIONS(2990),
    [anon_sym_STAR] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_AMP] = ACTIONS(2990),
    [anon_sym_SEMI] = ACTIONS(2988),
    [anon_sym___extension__] = ACTIONS(2990),
    [anon_sym_typedef] = ACTIONS(2990),
    [anon_sym_in] = ACTIONS(2990),
    [anon_sym_out] = ACTIONS(2990),
    [anon_sym_inout] = ACTIONS(2990),
    [anon_sym_virtual] = ACTIONS(2990),
    [anon_sym_extern] = ACTIONS(2990),
    [anon_sym___attribute__] = ACTIONS(2990),
    [anon_sym___attribute] = ACTIONS(2990),
    [anon_sym_using] = ACTIONS(2990),
    [anon_sym_COLON_COLON] = ACTIONS(2988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2988),
    [anon_sym___declspec] = ACTIONS(2990),
    [anon_sym___based] = ACTIONS(2990),
    [anon_sym___cdecl] = ACTIONS(2990),
    [anon_sym___clrcall] = ACTIONS(2990),
    [anon_sym___stdcall] = ACTIONS(2990),
    [anon_sym___fastcall] = ACTIONS(2990),
    [anon_sym___thiscall] = ACTIONS(2990),
    [anon_sym___vectorcall] = ACTIONS(2990),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_RBRACE] = ACTIONS(2988),
    [anon_sym_signed] = ACTIONS(2990),
    [anon_sym_unsigned] = ACTIONS(2990),
    [anon_sym_long] = ACTIONS(2990),
    [anon_sym_short] = ACTIONS(2990),
    [anon_sym_LBRACK] = ACTIONS(2990),
    [anon_sym_static] = ACTIONS(2990),
    [anon_sym_register] = ACTIONS(2990),
    [anon_sym_inline] = ACTIONS(2990),
    [anon_sym___inline] = ACTIONS(2990),
    [anon_sym___inline__] = ACTIONS(2990),
    [anon_sym___forceinline] = ACTIONS(2990),
    [anon_sym_thread_local] = ACTIONS(2990),
    [anon_sym___thread] = ACTIONS(2990),
    [anon_sym_const] = ACTIONS(2990),
    [anon_sym_constexpr] = ACTIONS(2990),
    [anon_sym_volatile] = ACTIONS(2990),
    [anon_sym_restrict] = ACTIONS(2990),
    [anon_sym___restrict__] = ACTIONS(2990),
    [anon_sym__Atomic] = ACTIONS(2990),
    [anon_sym__Noreturn] = ACTIONS(2990),
    [anon_sym_noreturn] = ACTIONS(2990),
    [anon_sym__Nonnull] = ACTIONS(2990),
    [anon_sym_mutable] = ACTIONS(2990),
    [anon_sym_constinit] = ACTIONS(2990),
    [anon_sym_consteval] = ACTIONS(2990),
    [anon_sym_alignas] = ACTIONS(2990),
    [anon_sym__Alignas] = ACTIONS(2990),
    [sym_primitive_type] = ACTIONS(2990),
    [anon_sym_enum] = ACTIONS(2990),
    [anon_sym_class] = ACTIONS(2990),
    [anon_sym_struct] = ACTIONS(2990),
    [anon_sym_union] = ACTIONS(2990),
    [anon_sym_if] = ACTIONS(2990),
    [anon_sym_switch] = ACTIONS(2990),
    [anon_sym_case] = ACTIONS(2990),
    [anon_sym_default] = ACTIONS(2990),
    [anon_sym_while] = ACTIONS(2990),
    [anon_sym_do] = ACTIONS(2990),
    [anon_sym_for] = ACTIONS(2990),
    [anon_sym_return] = ACTIONS(2990),
    [anon_sym_break] = ACTIONS(2990),
    [anon_sym_continue] = ACTIONS(2990),
    [anon_sym_goto] = ACTIONS(2990),
    [anon_sym___try] = ACTIONS(2990),
    [anon_sym___leave] = ACTIONS(2990),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_compl] = ACTIONS(2990),
    [anon_sym_DASH_DASH] = ACTIONS(2988),
    [anon_sym_PLUS_PLUS] = ACTIONS(2988),
    [anon_sym_sizeof] = ACTIONS(2990),
    [anon_sym___alignof__] = ACTIONS(2990),
    [anon_sym___alignof] = ACTIONS(2990),
    [anon_sym__alignof] = ACTIONS(2990),
    [anon_sym_alignof] = ACTIONS(2990),
    [anon_sym__Alignof] = ACTIONS(2990),
    [anon_sym_offsetof] = ACTIONS(2990),
    [anon_sym__Generic] = ACTIONS(2990),
    [anon_sym_asm] = ACTIONS(2990),
    [anon_sym___asm__] = ACTIONS(2990),
    [anon_sym___asm] = ACTIONS(2990),
    [anon_sym_DOT] = ACTIONS(2990),
    [sym_number_literal] = ACTIONS(2988),
    [anon_sym_L_SQUOTE] = ACTIONS(2988),
    [anon_sym_u_SQUOTE] = ACTIONS(2988),
    [anon_sym_U_SQUOTE] = ACTIONS(2988),
    [anon_sym_u8_SQUOTE] = ACTIONS(2988),
    [anon_sym_SQUOTE] = ACTIONS(2988),
    [anon_sym_L_DQUOTE] = ACTIONS(2988),
    [anon_sym_u_DQUOTE] = ACTIONS(2988),
    [anon_sym_U_DQUOTE] = ACTIONS(2988),
    [anon_sym_u8_DQUOTE] = ACTIONS(2988),
    [anon_sym_DQUOTE] = ACTIONS(2988),
    [sym_true] = ACTIONS(2990),
    [sym_false] = ACTIONS(2990),
    [anon_sym_NULL] = ACTIONS(2990),
    [anon_sym_nullptr] = ACTIONS(2990),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2990),
    [anon_sym_let] = ACTIONS(2990),
    [anon_sym_This] = ACTIONS(2990),
    [anon_sym_decltype] = ACTIONS(2990),
    [anon_sym_explicit] = ACTIONS(2990),
    [anon_sym_typename] = ACTIONS(2990),
    [anon_sym_template] = ACTIONS(2990),
    [anon_sym_operator] = ACTIONS(2990),
    [anon_sym_try] = ACTIONS(2990),
    [anon_sym_delete] = ACTIONS(2990),
    [anon_sym_throw] = ACTIONS(2990),
    [anon_sym_namespace] = ACTIONS(2990),
    [anon_sym_static_assert] = ACTIONS(2990),
    [anon_sym_concept] = ACTIONS(2990),
    [anon_sym_co_return] = ACTIONS(2990),
    [anon_sym_co_yield] = ACTIONS(2990),
    [anon_sym_R_DQUOTE] = ACTIONS(2988),
    [anon_sym_LR_DQUOTE] = ACTIONS(2988),
    [anon_sym_uR_DQUOTE] = ACTIONS(2988),
    [anon_sym_UR_DQUOTE] = ACTIONS(2988),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2988),
    [anon_sym_co_await] = ACTIONS(2990),
    [anon_sym_new] = ACTIONS(2990),
    [anon_sym_requires] = ACTIONS(2990),
    [sym_this] = ACTIONS(2990),
    [anon_sym_discard] = ACTIONS(2990),
    [anon_sym_precise] = ACTIONS(2990),
    [anon_sym_shared] = ACTIONS(2990),
    [anon_sym_groupshared] = ACTIONS(2990),
    [anon_sym_uniform] = ACTIONS(2990),
    [anon_sym_row_major] = ACTIONS(2990),
    [anon_sym_column_major] = ACTIONS(2990),
    [anon_sym_globallycoherent] = ACTIONS(2990),
    [anon_sym_centroid] = ACTIONS(2990),
    [anon_sym_noperspective] = ACTIONS(2990),
    [anon_sym_nointerpolation] = ACTIONS(2990),
    [anon_sym_sample] = ACTIONS(2990),
    [anon_sym_linear] = ACTIONS(2990),
    [anon_sym_snorm] = ACTIONS(2990),
    [anon_sym_unorm] = ACTIONS(2990),
    [anon_sym_point] = ACTIONS(2990),
    [anon_sym_line] = ACTIONS(2990),
    [anon_sym_triangleadj] = ACTIONS(2990),
    [anon_sym_lineadj] = ACTIONS(2990),
    [anon_sym_triangle] = ACTIONS(2990),
    [anon_sym_cbuffer] = ACTIONS(2990),
    [anon_sym_interface] = ACTIONS(2990),
    [anon_sym_extension] = ACTIONS(2990),
  },
  [792] = {
    [sym_identifier] = ACTIONS(3002),
    [aux_sym_preproc_include_token1] = ACTIONS(3002),
    [aux_sym_preproc_def_token1] = ACTIONS(3002),
    [aux_sym_preproc_if_token1] = ACTIONS(3002),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3002),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3002),
    [sym_preproc_directive] = ACTIONS(3002),
    [anon_sym_LPAREN2] = ACTIONS(3000),
    [anon_sym_BANG] = ACTIONS(3000),
    [anon_sym_TILDE] = ACTIONS(3000),
    [anon_sym_DASH] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(3000),
    [anon_sym_AMP_AMP] = ACTIONS(3000),
    [anon_sym_AMP] = ACTIONS(3002),
    [anon_sym_SEMI] = ACTIONS(3000),
    [anon_sym___extension__] = ACTIONS(3002),
    [anon_sym_typedef] = ACTIONS(3002),
    [anon_sym_in] = ACTIONS(3002),
    [anon_sym_out] = ACTIONS(3002),
    [anon_sym_inout] = ACTIONS(3002),
    [anon_sym_virtual] = ACTIONS(3002),
    [anon_sym_extern] = ACTIONS(3002),
    [anon_sym___attribute__] = ACTIONS(3002),
    [anon_sym___attribute] = ACTIONS(3002),
    [anon_sym_using] = ACTIONS(3002),
    [anon_sym_COLON_COLON] = ACTIONS(3000),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3000),
    [anon_sym___declspec] = ACTIONS(3002),
    [anon_sym___based] = ACTIONS(3002),
    [anon_sym___cdecl] = ACTIONS(3002),
    [anon_sym___clrcall] = ACTIONS(3002),
    [anon_sym___stdcall] = ACTIONS(3002),
    [anon_sym___fastcall] = ACTIONS(3002),
    [anon_sym___thiscall] = ACTIONS(3002),
    [anon_sym___vectorcall] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3000),
    [anon_sym_RBRACE] = ACTIONS(3000),
    [anon_sym_signed] = ACTIONS(3002),
    [anon_sym_unsigned] = ACTIONS(3002),
    [anon_sym_long] = ACTIONS(3002),
    [anon_sym_short] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_static] = ACTIONS(3002),
    [anon_sym_register] = ACTIONS(3002),
    [anon_sym_inline] = ACTIONS(3002),
    [anon_sym___inline] = ACTIONS(3002),
    [anon_sym___inline__] = ACTIONS(3002),
    [anon_sym___forceinline] = ACTIONS(3002),
    [anon_sym_thread_local] = ACTIONS(3002),
    [anon_sym___thread] = ACTIONS(3002),
    [anon_sym_const] = ACTIONS(3002),
    [anon_sym_constexpr] = ACTIONS(3002),
    [anon_sym_volatile] = ACTIONS(3002),
    [anon_sym_restrict] = ACTIONS(3002),
    [anon_sym___restrict__] = ACTIONS(3002),
    [anon_sym__Atomic] = ACTIONS(3002),
    [anon_sym__Noreturn] = ACTIONS(3002),
    [anon_sym_noreturn] = ACTIONS(3002),
    [anon_sym__Nonnull] = ACTIONS(3002),
    [anon_sym_mutable] = ACTIONS(3002),
    [anon_sym_constinit] = ACTIONS(3002),
    [anon_sym_consteval] = ACTIONS(3002),
    [anon_sym_alignas] = ACTIONS(3002),
    [anon_sym__Alignas] = ACTIONS(3002),
    [sym_primitive_type] = ACTIONS(3002),
    [anon_sym_enum] = ACTIONS(3002),
    [anon_sym_class] = ACTIONS(3002),
    [anon_sym_struct] = ACTIONS(3002),
    [anon_sym_union] = ACTIONS(3002),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_switch] = ACTIONS(3002),
    [anon_sym_case] = ACTIONS(3002),
    [anon_sym_default] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(3002),
    [anon_sym_for] = ACTIONS(3002),
    [anon_sym_return] = ACTIONS(3002),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_continue] = ACTIONS(3002),
    [anon_sym_goto] = ACTIONS(3002),
    [anon_sym___try] = ACTIONS(3002),
    [anon_sym___leave] = ACTIONS(3002),
    [anon_sym_not] = ACTIONS(3002),
    [anon_sym_compl] = ACTIONS(3002),
    [anon_sym_DASH_DASH] = ACTIONS(3000),
    [anon_sym_PLUS_PLUS] = ACTIONS(3000),
    [anon_sym_sizeof] = ACTIONS(3002),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3002),
    [anon_sym__Generic] = ACTIONS(3002),
    [anon_sym_asm] = ACTIONS(3002),
    [anon_sym___asm__] = ACTIONS(3002),
    [anon_sym___asm] = ACTIONS(3002),
    [anon_sym_DOT] = ACTIONS(3002),
    [sym_number_literal] = ACTIONS(3000),
    [anon_sym_L_SQUOTE] = ACTIONS(3000),
    [anon_sym_u_SQUOTE] = ACTIONS(3000),
    [anon_sym_U_SQUOTE] = ACTIONS(3000),
    [anon_sym_u8_SQUOTE] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(3000),
    [anon_sym_L_DQUOTE] = ACTIONS(3000),
    [anon_sym_u_DQUOTE] = ACTIONS(3000),
    [anon_sym_U_DQUOTE] = ACTIONS(3000),
    [anon_sym_u8_DQUOTE] = ACTIONS(3000),
    [anon_sym_DQUOTE] = ACTIONS(3000),
    [sym_true] = ACTIONS(3002),
    [sym_false] = ACTIONS(3002),
    [anon_sym_NULL] = ACTIONS(3002),
    [anon_sym_nullptr] = ACTIONS(3002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3002),
    [anon_sym_let] = ACTIONS(3002),
    [anon_sym_This] = ACTIONS(3002),
    [anon_sym_decltype] = ACTIONS(3002),
    [anon_sym_explicit] = ACTIONS(3002),
    [anon_sym_typename] = ACTIONS(3002),
    [anon_sym_template] = ACTIONS(3002),
    [anon_sym_operator] = ACTIONS(3002),
    [anon_sym_try] = ACTIONS(3002),
    [anon_sym_delete] = ACTIONS(3002),
    [anon_sym_throw] = ACTIONS(3002),
    [anon_sym_namespace] = ACTIONS(3002),
    [anon_sym_static_assert] = ACTIONS(3002),
    [anon_sym_concept] = ACTIONS(3002),
    [anon_sym_co_return] = ACTIONS(3002),
    [anon_sym_co_yield] = ACTIONS(3002),
    [anon_sym_R_DQUOTE] = ACTIONS(3000),
    [anon_sym_LR_DQUOTE] = ACTIONS(3000),
    [anon_sym_uR_DQUOTE] = ACTIONS(3000),
    [anon_sym_UR_DQUOTE] = ACTIONS(3000),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3000),
    [anon_sym_co_await] = ACTIONS(3002),
    [anon_sym_new] = ACTIONS(3002),
    [anon_sym_requires] = ACTIONS(3002),
    [sym_this] = ACTIONS(3002),
    [anon_sym_discard] = ACTIONS(3002),
    [anon_sym_precise] = ACTIONS(3002),
    [anon_sym_shared] = ACTIONS(3002),
    [anon_sym_groupshared] = ACTIONS(3002),
    [anon_sym_uniform] = ACTIONS(3002),
    [anon_sym_row_major] = ACTIONS(3002),
    [anon_sym_column_major] = ACTIONS(3002),
    [anon_sym_globallycoherent] = ACTIONS(3002),
    [anon_sym_centroid] = ACTIONS(3002),
    [anon_sym_noperspective] = ACTIONS(3002),
    [anon_sym_nointerpolation] = ACTIONS(3002),
    [anon_sym_sample] = ACTIONS(3002),
    [anon_sym_linear] = ACTIONS(3002),
    [anon_sym_snorm] = ACTIONS(3002),
    [anon_sym_unorm] = ACTIONS(3002),
    [anon_sym_point] = ACTIONS(3002),
    [anon_sym_line] = ACTIONS(3002),
    [anon_sym_triangleadj] = ACTIONS(3002),
    [anon_sym_lineadj] = ACTIONS(3002),
    [anon_sym_triangle] = ACTIONS(3002),
    [anon_sym_cbuffer] = ACTIONS(3002),
    [anon_sym_interface] = ACTIONS(3002),
    [anon_sym_extension] = ACTIONS(3002),
  },
  [793] = {
    [sym_identifier] = ACTIONS(3562),
    [aux_sym_preproc_include_token1] = ACTIONS(3562),
    [aux_sym_preproc_def_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3562),
    [sym_preproc_directive] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym___extension__] = ACTIONS(3562),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_in] = ACTIONS(3562),
    [anon_sym_out] = ACTIONS(3562),
    [anon_sym_inout] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym___attribute__] = ACTIONS(3562),
    [anon_sym___attribute] = ACTIONS(3562),
    [anon_sym_using] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3560),
    [anon_sym___declspec] = ACTIONS(3562),
    [anon_sym___based] = ACTIONS(3562),
    [anon_sym___cdecl] = ACTIONS(3562),
    [anon_sym___clrcall] = ACTIONS(3562),
    [anon_sym___stdcall] = ACTIONS(3562),
    [anon_sym___fastcall] = ACTIONS(3562),
    [anon_sym___thiscall] = ACTIONS(3562),
    [anon_sym___vectorcall] = ACTIONS(3562),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_RBRACE] = ACTIONS(3560),
    [anon_sym_signed] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym___inline] = ACTIONS(3562),
    [anon_sym___inline__] = ACTIONS(3562),
    [anon_sym___forceinline] = ACTIONS(3562),
    [anon_sym_thread_local] = ACTIONS(3562),
    [anon_sym___thread] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_constexpr] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym___restrict__] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym__Noreturn] = ACTIONS(3562),
    [anon_sym_noreturn] = ACTIONS(3562),
    [anon_sym__Nonnull] = ACTIONS(3562),
    [anon_sym_mutable] = ACTIONS(3562),
    [anon_sym_constinit] = ACTIONS(3562),
    [anon_sym_consteval] = ACTIONS(3562),
    [anon_sym_alignas] = ACTIONS(3562),
    [anon_sym__Alignas] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_else] = ACTIONS(3562),
    [anon_sym_switch] = ACTIONS(3562),
    [anon_sym_case] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_goto] = ACTIONS(3562),
    [anon_sym___try] = ACTIONS(3562),
    [anon_sym___leave] = ACTIONS(3562),
    [anon_sym_not] = ACTIONS(3562),
    [anon_sym_compl] = ACTIONS(3562),
    [anon_sym_DASH_DASH] = ACTIONS(3560),
    [anon_sym_PLUS_PLUS] = ACTIONS(3560),
    [anon_sym_sizeof] = ACTIONS(3562),
    [anon_sym___alignof__] = ACTIONS(3562),
    [anon_sym___alignof] = ACTIONS(3562),
    [anon_sym__alignof] = ACTIONS(3562),
    [anon_sym_alignof] = ACTIONS(3562),
    [anon_sym__Alignof] = ACTIONS(3562),
    [anon_sym_offsetof] = ACTIONS(3562),
    [anon_sym__Generic] = ACTIONS(3562),
    [anon_sym_asm] = ACTIONS(3562),
    [anon_sym___asm__] = ACTIONS(3562),
    [anon_sym___asm] = ACTIONS(3562),
    [sym_number_literal] = ACTIONS(3560),
    [anon_sym_L_SQUOTE] = ACTIONS(3560),
    [anon_sym_u_SQUOTE] = ACTIONS(3560),
    [anon_sym_U_SQUOTE] = ACTIONS(3560),
    [anon_sym_u8_SQUOTE] = ACTIONS(3560),
    [anon_sym_SQUOTE] = ACTIONS(3560),
    [anon_sym_L_DQUOTE] = ACTIONS(3560),
    [anon_sym_u_DQUOTE] = ACTIONS(3560),
    [anon_sym_U_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE] = ACTIONS(3560),
    [sym_true] = ACTIONS(3562),
    [sym_false] = ACTIONS(3562),
    [anon_sym_NULL] = ACTIONS(3562),
    [anon_sym_nullptr] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_This] = ACTIONS(3562),
    [anon_sym_decltype] = ACTIONS(3562),
    [anon_sym_explicit] = ACTIONS(3562),
    [anon_sym_typename] = ACTIONS(3562),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_delete] = ACTIONS(3562),
    [anon_sym_throw] = ACTIONS(3562),
    [anon_sym_namespace] = ACTIONS(3562),
    [anon_sym_static_assert] = ACTIONS(3562),
    [anon_sym_concept] = ACTIONS(3562),
    [anon_sym_co_return] = ACTIONS(3562),
    [anon_sym_co_yield] = ACTIONS(3562),
    [anon_sym_R_DQUOTE] = ACTIONS(3560),
    [anon_sym_LR_DQUOTE] = ACTIONS(3560),
    [anon_sym_uR_DQUOTE] = ACTIONS(3560),
    [anon_sym_UR_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3560),
    [anon_sym_co_await] = ACTIONS(3562),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_requires] = ACTIONS(3562),
    [sym_this] = ACTIONS(3562),
    [anon_sym_discard] = ACTIONS(3562),
    [anon_sym_precise] = ACTIONS(3562),
    [anon_sym_shared] = ACTIONS(3562),
    [anon_sym_groupshared] = ACTIONS(3562),
    [anon_sym_uniform] = ACTIONS(3562),
    [anon_sym_row_major] = ACTIONS(3562),
    [anon_sym_column_major] = ACTIONS(3562),
    [anon_sym_globallycoherent] = ACTIONS(3562),
    [anon_sym_centroid] = ACTIONS(3562),
    [anon_sym_noperspective] = ACTIONS(3562),
    [anon_sym_nointerpolation] = ACTIONS(3562),
    [anon_sym_sample] = ACTIONS(3562),
    [anon_sym_linear] = ACTIONS(3562),
    [anon_sym_snorm] = ACTIONS(3562),
    [anon_sym_unorm] = ACTIONS(3562),
    [anon_sym_point] = ACTIONS(3562),
    [anon_sym_line] = ACTIONS(3562),
    [anon_sym_triangleadj] = ACTIONS(3562),
    [anon_sym_lineadj] = ACTIONS(3562),
    [anon_sym_triangle] = ACTIONS(3562),
    [anon_sym_cbuffer] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_extension] = ACTIONS(3562),
  },
  [794] = {
    [sym_identifier] = ACTIONS(3006),
    [aux_sym_preproc_include_token1] = ACTIONS(3006),
    [aux_sym_preproc_def_token1] = ACTIONS(3006),
    [aux_sym_preproc_if_token1] = ACTIONS(3006),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3006),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3006),
    [sym_preproc_directive] = ACTIONS(3006),
    [anon_sym_LPAREN2] = ACTIONS(3004),
    [anon_sym_BANG] = ACTIONS(3004),
    [anon_sym_TILDE] = ACTIONS(3004),
    [anon_sym_DASH] = ACTIONS(3006),
    [anon_sym_PLUS] = ACTIONS(3006),
    [anon_sym_STAR] = ACTIONS(3004),
    [anon_sym_AMP_AMP] = ACTIONS(3004),
    [anon_sym_AMP] = ACTIONS(3006),
    [anon_sym_SEMI] = ACTIONS(3004),
    [anon_sym___extension__] = ACTIONS(3006),
    [anon_sym_typedef] = ACTIONS(3006),
    [anon_sym_in] = ACTIONS(3006),
    [anon_sym_out] = ACTIONS(3006),
    [anon_sym_inout] = ACTIONS(3006),
    [anon_sym_virtual] = ACTIONS(3006),
    [anon_sym_extern] = ACTIONS(3006),
    [anon_sym___attribute__] = ACTIONS(3006),
    [anon_sym___attribute] = ACTIONS(3006),
    [anon_sym_using] = ACTIONS(3006),
    [anon_sym_COLON_COLON] = ACTIONS(3004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3004),
    [anon_sym___declspec] = ACTIONS(3006),
    [anon_sym___based] = ACTIONS(3006),
    [anon_sym___cdecl] = ACTIONS(3006),
    [anon_sym___clrcall] = ACTIONS(3006),
    [anon_sym___stdcall] = ACTIONS(3006),
    [anon_sym___fastcall] = ACTIONS(3006),
    [anon_sym___thiscall] = ACTIONS(3006),
    [anon_sym___vectorcall] = ACTIONS(3006),
    [anon_sym_LBRACE] = ACTIONS(3004),
    [anon_sym_RBRACE] = ACTIONS(3004),
    [anon_sym_signed] = ACTIONS(3006),
    [anon_sym_unsigned] = ACTIONS(3006),
    [anon_sym_long] = ACTIONS(3006),
    [anon_sym_short] = ACTIONS(3006),
    [anon_sym_LBRACK] = ACTIONS(3006),
    [anon_sym_static] = ACTIONS(3006),
    [anon_sym_register] = ACTIONS(3006),
    [anon_sym_inline] = ACTIONS(3006),
    [anon_sym___inline] = ACTIONS(3006),
    [anon_sym___inline__] = ACTIONS(3006),
    [anon_sym___forceinline] = ACTIONS(3006),
    [anon_sym_thread_local] = ACTIONS(3006),
    [anon_sym___thread] = ACTIONS(3006),
    [anon_sym_const] = ACTIONS(3006),
    [anon_sym_constexpr] = ACTIONS(3006),
    [anon_sym_volatile] = ACTIONS(3006),
    [anon_sym_restrict] = ACTIONS(3006),
    [anon_sym___restrict__] = ACTIONS(3006),
    [anon_sym__Atomic] = ACTIONS(3006),
    [anon_sym__Noreturn] = ACTIONS(3006),
    [anon_sym_noreturn] = ACTIONS(3006),
    [anon_sym__Nonnull] = ACTIONS(3006),
    [anon_sym_mutable] = ACTIONS(3006),
    [anon_sym_constinit] = ACTIONS(3006),
    [anon_sym_consteval] = ACTIONS(3006),
    [anon_sym_alignas] = ACTIONS(3006),
    [anon_sym__Alignas] = ACTIONS(3006),
    [sym_primitive_type] = ACTIONS(3006),
    [anon_sym_enum] = ACTIONS(3006),
    [anon_sym_class] = ACTIONS(3006),
    [anon_sym_struct] = ACTIONS(3006),
    [anon_sym_union] = ACTIONS(3006),
    [anon_sym_if] = ACTIONS(3006),
    [anon_sym_switch] = ACTIONS(3006),
    [anon_sym_case] = ACTIONS(3006),
    [anon_sym_default] = ACTIONS(3006),
    [anon_sym_while] = ACTIONS(3006),
    [anon_sym_do] = ACTIONS(3006),
    [anon_sym_for] = ACTIONS(3006),
    [anon_sym_return] = ACTIONS(3006),
    [anon_sym_break] = ACTIONS(3006),
    [anon_sym_continue] = ACTIONS(3006),
    [anon_sym_goto] = ACTIONS(3006),
    [anon_sym___try] = ACTIONS(3006),
    [anon_sym___leave] = ACTIONS(3006),
    [anon_sym_not] = ACTIONS(3006),
    [anon_sym_compl] = ACTIONS(3006),
    [anon_sym_DASH_DASH] = ACTIONS(3004),
    [anon_sym_PLUS_PLUS] = ACTIONS(3004),
    [anon_sym_sizeof] = ACTIONS(3006),
    [anon_sym___alignof__] = ACTIONS(3006),
    [anon_sym___alignof] = ACTIONS(3006),
    [anon_sym__alignof] = ACTIONS(3006),
    [anon_sym_alignof] = ACTIONS(3006),
    [anon_sym__Alignof] = ACTIONS(3006),
    [anon_sym_offsetof] = ACTIONS(3006),
    [anon_sym__Generic] = ACTIONS(3006),
    [anon_sym_asm] = ACTIONS(3006),
    [anon_sym___asm__] = ACTIONS(3006),
    [anon_sym___asm] = ACTIONS(3006),
    [anon_sym_DOT] = ACTIONS(3006),
    [sym_number_literal] = ACTIONS(3004),
    [anon_sym_L_SQUOTE] = ACTIONS(3004),
    [anon_sym_u_SQUOTE] = ACTIONS(3004),
    [anon_sym_U_SQUOTE] = ACTIONS(3004),
    [anon_sym_u8_SQUOTE] = ACTIONS(3004),
    [anon_sym_SQUOTE] = ACTIONS(3004),
    [anon_sym_L_DQUOTE] = ACTIONS(3004),
    [anon_sym_u_DQUOTE] = ACTIONS(3004),
    [anon_sym_U_DQUOTE] = ACTIONS(3004),
    [anon_sym_u8_DQUOTE] = ACTIONS(3004),
    [anon_sym_DQUOTE] = ACTIONS(3004),
    [sym_true] = ACTIONS(3006),
    [sym_false] = ACTIONS(3006),
    [anon_sym_NULL] = ACTIONS(3006),
    [anon_sym_nullptr] = ACTIONS(3006),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3006),
    [anon_sym_let] = ACTIONS(3006),
    [anon_sym_This] = ACTIONS(3006),
    [anon_sym_decltype] = ACTIONS(3006),
    [anon_sym_explicit] = ACTIONS(3006),
    [anon_sym_typename] = ACTIONS(3006),
    [anon_sym_template] = ACTIONS(3006),
    [anon_sym_operator] = ACTIONS(3006),
    [anon_sym_try] = ACTIONS(3006),
    [anon_sym_delete] = ACTIONS(3006),
    [anon_sym_throw] = ACTIONS(3006),
    [anon_sym_namespace] = ACTIONS(3006),
    [anon_sym_static_assert] = ACTIONS(3006),
    [anon_sym_concept] = ACTIONS(3006),
    [anon_sym_co_return] = ACTIONS(3006),
    [anon_sym_co_yield] = ACTIONS(3006),
    [anon_sym_R_DQUOTE] = ACTIONS(3004),
    [anon_sym_LR_DQUOTE] = ACTIONS(3004),
    [anon_sym_uR_DQUOTE] = ACTIONS(3004),
    [anon_sym_UR_DQUOTE] = ACTIONS(3004),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3004),
    [anon_sym_co_await] = ACTIONS(3006),
    [anon_sym_new] = ACTIONS(3006),
    [anon_sym_requires] = ACTIONS(3006),
    [sym_this] = ACTIONS(3006),
    [anon_sym_discard] = ACTIONS(3006),
    [anon_sym_precise] = ACTIONS(3006),
    [anon_sym_shared] = ACTIONS(3006),
    [anon_sym_groupshared] = ACTIONS(3006),
    [anon_sym_uniform] = ACTIONS(3006),
    [anon_sym_row_major] = ACTIONS(3006),
    [anon_sym_column_major] = ACTIONS(3006),
    [anon_sym_globallycoherent] = ACTIONS(3006),
    [anon_sym_centroid] = ACTIONS(3006),
    [anon_sym_noperspective] = ACTIONS(3006),
    [anon_sym_nointerpolation] = ACTIONS(3006),
    [anon_sym_sample] = ACTIONS(3006),
    [anon_sym_linear] = ACTIONS(3006),
    [anon_sym_snorm] = ACTIONS(3006),
    [anon_sym_unorm] = ACTIONS(3006),
    [anon_sym_point] = ACTIONS(3006),
    [anon_sym_line] = ACTIONS(3006),
    [anon_sym_triangleadj] = ACTIONS(3006),
    [anon_sym_lineadj] = ACTIONS(3006),
    [anon_sym_triangle] = ACTIONS(3006),
    [anon_sym_cbuffer] = ACTIONS(3006),
    [anon_sym_interface] = ACTIONS(3006),
    [anon_sym_extension] = ACTIONS(3006),
  },
  [795] = {
    [sym_identifier] = ACTIONS(3010),
    [aux_sym_preproc_include_token1] = ACTIONS(3010),
    [aux_sym_preproc_def_token1] = ACTIONS(3010),
    [aux_sym_preproc_if_token1] = ACTIONS(3010),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3010),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3010),
    [sym_preproc_directive] = ACTIONS(3010),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_BANG] = ACTIONS(3008),
    [anon_sym_TILDE] = ACTIONS(3008),
    [anon_sym_DASH] = ACTIONS(3010),
    [anon_sym_PLUS] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(3008),
    [anon_sym_AMP_AMP] = ACTIONS(3008),
    [anon_sym_AMP] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(3008),
    [anon_sym___extension__] = ACTIONS(3010),
    [anon_sym_typedef] = ACTIONS(3010),
    [anon_sym_in] = ACTIONS(3010),
    [anon_sym_out] = ACTIONS(3010),
    [anon_sym_inout] = ACTIONS(3010),
    [anon_sym_virtual] = ACTIONS(3010),
    [anon_sym_extern] = ACTIONS(3010),
    [anon_sym___attribute__] = ACTIONS(3010),
    [anon_sym___attribute] = ACTIONS(3010),
    [anon_sym_using] = ACTIONS(3010),
    [anon_sym_COLON_COLON] = ACTIONS(3008),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3008),
    [anon_sym___declspec] = ACTIONS(3010),
    [anon_sym___based] = ACTIONS(3010),
    [anon_sym___cdecl] = ACTIONS(3010),
    [anon_sym___clrcall] = ACTIONS(3010),
    [anon_sym___stdcall] = ACTIONS(3010),
    [anon_sym___fastcall] = ACTIONS(3010),
    [anon_sym___thiscall] = ACTIONS(3010),
    [anon_sym___vectorcall] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3008),
    [anon_sym_RBRACE] = ACTIONS(3008),
    [anon_sym_signed] = ACTIONS(3010),
    [anon_sym_unsigned] = ACTIONS(3010),
    [anon_sym_long] = ACTIONS(3010),
    [anon_sym_short] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3010),
    [anon_sym_static] = ACTIONS(3010),
    [anon_sym_register] = ACTIONS(3010),
    [anon_sym_inline] = ACTIONS(3010),
    [anon_sym___inline] = ACTIONS(3010),
    [anon_sym___inline__] = ACTIONS(3010),
    [anon_sym___forceinline] = ACTIONS(3010),
    [anon_sym_thread_local] = ACTIONS(3010),
    [anon_sym___thread] = ACTIONS(3010),
    [anon_sym_const] = ACTIONS(3010),
    [anon_sym_constexpr] = ACTIONS(3010),
    [anon_sym_volatile] = ACTIONS(3010),
    [anon_sym_restrict] = ACTIONS(3010),
    [anon_sym___restrict__] = ACTIONS(3010),
    [anon_sym__Atomic] = ACTIONS(3010),
    [anon_sym__Noreturn] = ACTIONS(3010),
    [anon_sym_noreturn] = ACTIONS(3010),
    [anon_sym__Nonnull] = ACTIONS(3010),
    [anon_sym_mutable] = ACTIONS(3010),
    [anon_sym_constinit] = ACTIONS(3010),
    [anon_sym_consteval] = ACTIONS(3010),
    [anon_sym_alignas] = ACTIONS(3010),
    [anon_sym__Alignas] = ACTIONS(3010),
    [sym_primitive_type] = ACTIONS(3010),
    [anon_sym_enum] = ACTIONS(3010),
    [anon_sym_class] = ACTIONS(3010),
    [anon_sym_struct] = ACTIONS(3010),
    [anon_sym_union] = ACTIONS(3010),
    [anon_sym_if] = ACTIONS(3010),
    [anon_sym_switch] = ACTIONS(3010),
    [anon_sym_case] = ACTIONS(3010),
    [anon_sym_default] = ACTIONS(3010),
    [anon_sym_while] = ACTIONS(3010),
    [anon_sym_do] = ACTIONS(3010),
    [anon_sym_for] = ACTIONS(3010),
    [anon_sym_return] = ACTIONS(3010),
    [anon_sym_break] = ACTIONS(3010),
    [anon_sym_continue] = ACTIONS(3010),
    [anon_sym_goto] = ACTIONS(3010),
    [anon_sym___try] = ACTIONS(3010),
    [anon_sym___leave] = ACTIONS(3010),
    [anon_sym_not] = ACTIONS(3010),
    [anon_sym_compl] = ACTIONS(3010),
    [anon_sym_DASH_DASH] = ACTIONS(3008),
    [anon_sym_PLUS_PLUS] = ACTIONS(3008),
    [anon_sym_sizeof] = ACTIONS(3010),
    [anon_sym___alignof__] = ACTIONS(3010),
    [anon_sym___alignof] = ACTIONS(3010),
    [anon_sym__alignof] = ACTIONS(3010),
    [anon_sym_alignof] = ACTIONS(3010),
    [anon_sym__Alignof] = ACTIONS(3010),
    [anon_sym_offsetof] = ACTIONS(3010),
    [anon_sym__Generic] = ACTIONS(3010),
    [anon_sym_asm] = ACTIONS(3010),
    [anon_sym___asm__] = ACTIONS(3010),
    [anon_sym___asm] = ACTIONS(3010),
    [anon_sym_DOT] = ACTIONS(3010),
    [sym_number_literal] = ACTIONS(3008),
    [anon_sym_L_SQUOTE] = ACTIONS(3008),
    [anon_sym_u_SQUOTE] = ACTIONS(3008),
    [anon_sym_U_SQUOTE] = ACTIONS(3008),
    [anon_sym_u8_SQUOTE] = ACTIONS(3008),
    [anon_sym_SQUOTE] = ACTIONS(3008),
    [anon_sym_L_DQUOTE] = ACTIONS(3008),
    [anon_sym_u_DQUOTE] = ACTIONS(3008),
    [anon_sym_U_DQUOTE] = ACTIONS(3008),
    [anon_sym_u8_DQUOTE] = ACTIONS(3008),
    [anon_sym_DQUOTE] = ACTIONS(3008),
    [sym_true] = ACTIONS(3010),
    [sym_false] = ACTIONS(3010),
    [anon_sym_NULL] = ACTIONS(3010),
    [anon_sym_nullptr] = ACTIONS(3010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3010),
    [anon_sym_let] = ACTIONS(3010),
    [anon_sym_This] = ACTIONS(3010),
    [anon_sym_decltype] = ACTIONS(3010),
    [anon_sym_explicit] = ACTIONS(3010),
    [anon_sym_typename] = ACTIONS(3010),
    [anon_sym_template] = ACTIONS(3010),
    [anon_sym_operator] = ACTIONS(3010),
    [anon_sym_try] = ACTIONS(3010),
    [anon_sym_delete] = ACTIONS(3010),
    [anon_sym_throw] = ACTIONS(3010),
    [anon_sym_namespace] = ACTIONS(3010),
    [anon_sym_static_assert] = ACTIONS(3010),
    [anon_sym_concept] = ACTIONS(3010),
    [anon_sym_co_return] = ACTIONS(3010),
    [anon_sym_co_yield] = ACTIONS(3010),
    [anon_sym_R_DQUOTE] = ACTIONS(3008),
    [anon_sym_LR_DQUOTE] = ACTIONS(3008),
    [anon_sym_uR_DQUOTE] = ACTIONS(3008),
    [anon_sym_UR_DQUOTE] = ACTIONS(3008),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3008),
    [anon_sym_co_await] = ACTIONS(3010),
    [anon_sym_new] = ACTIONS(3010),
    [anon_sym_requires] = ACTIONS(3010),
    [sym_this] = ACTIONS(3010),
    [anon_sym_discard] = ACTIONS(3010),
    [anon_sym_precise] = ACTIONS(3010),
    [anon_sym_shared] = ACTIONS(3010),
    [anon_sym_groupshared] = ACTIONS(3010),
    [anon_sym_uniform] = ACTIONS(3010),
    [anon_sym_row_major] = ACTIONS(3010),
    [anon_sym_column_major] = ACTIONS(3010),
    [anon_sym_globallycoherent] = ACTIONS(3010),
    [anon_sym_centroid] = ACTIONS(3010),
    [anon_sym_noperspective] = ACTIONS(3010),
    [anon_sym_nointerpolation] = ACTIONS(3010),
    [anon_sym_sample] = ACTIONS(3010),
    [anon_sym_linear] = ACTIONS(3010),
    [anon_sym_snorm] = ACTIONS(3010),
    [anon_sym_unorm] = ACTIONS(3010),
    [anon_sym_point] = ACTIONS(3010),
    [anon_sym_line] = ACTIONS(3010),
    [anon_sym_triangleadj] = ACTIONS(3010),
    [anon_sym_lineadj] = ACTIONS(3010),
    [anon_sym_triangle] = ACTIONS(3010),
    [anon_sym_cbuffer] = ACTIONS(3010),
    [anon_sym_interface] = ACTIONS(3010),
    [anon_sym_extension] = ACTIONS(3010),
  },
  [796] = {
    [sym_identifier] = ACTIONS(3562),
    [aux_sym_preproc_include_token1] = ACTIONS(3562),
    [aux_sym_preproc_def_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3562),
    [sym_preproc_directive] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym___extension__] = ACTIONS(3562),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_in] = ACTIONS(3562),
    [anon_sym_out] = ACTIONS(3562),
    [anon_sym_inout] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym___attribute__] = ACTIONS(3562),
    [anon_sym___attribute] = ACTIONS(3562),
    [anon_sym_using] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3560),
    [anon_sym___declspec] = ACTIONS(3562),
    [anon_sym___based] = ACTIONS(3562),
    [anon_sym___cdecl] = ACTIONS(3562),
    [anon_sym___clrcall] = ACTIONS(3562),
    [anon_sym___stdcall] = ACTIONS(3562),
    [anon_sym___fastcall] = ACTIONS(3562),
    [anon_sym___thiscall] = ACTIONS(3562),
    [anon_sym___vectorcall] = ACTIONS(3562),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_RBRACE] = ACTIONS(3560),
    [anon_sym_signed] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym___inline] = ACTIONS(3562),
    [anon_sym___inline__] = ACTIONS(3562),
    [anon_sym___forceinline] = ACTIONS(3562),
    [anon_sym_thread_local] = ACTIONS(3562),
    [anon_sym___thread] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_constexpr] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym___restrict__] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym__Noreturn] = ACTIONS(3562),
    [anon_sym_noreturn] = ACTIONS(3562),
    [anon_sym__Nonnull] = ACTIONS(3562),
    [anon_sym_mutable] = ACTIONS(3562),
    [anon_sym_constinit] = ACTIONS(3562),
    [anon_sym_consteval] = ACTIONS(3562),
    [anon_sym_alignas] = ACTIONS(3562),
    [anon_sym__Alignas] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_else] = ACTIONS(3562),
    [anon_sym_switch] = ACTIONS(3562),
    [anon_sym_case] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_goto] = ACTIONS(3562),
    [anon_sym___try] = ACTIONS(3562),
    [anon_sym___leave] = ACTIONS(3562),
    [anon_sym_not] = ACTIONS(3562),
    [anon_sym_compl] = ACTIONS(3562),
    [anon_sym_DASH_DASH] = ACTIONS(3560),
    [anon_sym_PLUS_PLUS] = ACTIONS(3560),
    [anon_sym_sizeof] = ACTIONS(3562),
    [anon_sym___alignof__] = ACTIONS(3562),
    [anon_sym___alignof] = ACTIONS(3562),
    [anon_sym__alignof] = ACTIONS(3562),
    [anon_sym_alignof] = ACTIONS(3562),
    [anon_sym__Alignof] = ACTIONS(3562),
    [anon_sym_offsetof] = ACTIONS(3562),
    [anon_sym__Generic] = ACTIONS(3562),
    [anon_sym_asm] = ACTIONS(3562),
    [anon_sym___asm__] = ACTIONS(3562),
    [anon_sym___asm] = ACTIONS(3562),
    [sym_number_literal] = ACTIONS(3560),
    [anon_sym_L_SQUOTE] = ACTIONS(3560),
    [anon_sym_u_SQUOTE] = ACTIONS(3560),
    [anon_sym_U_SQUOTE] = ACTIONS(3560),
    [anon_sym_u8_SQUOTE] = ACTIONS(3560),
    [anon_sym_SQUOTE] = ACTIONS(3560),
    [anon_sym_L_DQUOTE] = ACTIONS(3560),
    [anon_sym_u_DQUOTE] = ACTIONS(3560),
    [anon_sym_U_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE] = ACTIONS(3560),
    [sym_true] = ACTIONS(3562),
    [sym_false] = ACTIONS(3562),
    [anon_sym_NULL] = ACTIONS(3562),
    [anon_sym_nullptr] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_This] = ACTIONS(3562),
    [anon_sym_decltype] = ACTIONS(3562),
    [anon_sym_explicit] = ACTIONS(3562),
    [anon_sym_typename] = ACTIONS(3562),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_delete] = ACTIONS(3562),
    [anon_sym_throw] = ACTIONS(3562),
    [anon_sym_namespace] = ACTIONS(3562),
    [anon_sym_static_assert] = ACTIONS(3562),
    [anon_sym_concept] = ACTIONS(3562),
    [anon_sym_co_return] = ACTIONS(3562),
    [anon_sym_co_yield] = ACTIONS(3562),
    [anon_sym_R_DQUOTE] = ACTIONS(3560),
    [anon_sym_LR_DQUOTE] = ACTIONS(3560),
    [anon_sym_uR_DQUOTE] = ACTIONS(3560),
    [anon_sym_UR_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3560),
    [anon_sym_co_await] = ACTIONS(3562),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_requires] = ACTIONS(3562),
    [sym_this] = ACTIONS(3562),
    [anon_sym_discard] = ACTIONS(3562),
    [anon_sym_precise] = ACTIONS(3562),
    [anon_sym_shared] = ACTIONS(3562),
    [anon_sym_groupshared] = ACTIONS(3562),
    [anon_sym_uniform] = ACTIONS(3562),
    [anon_sym_row_major] = ACTIONS(3562),
    [anon_sym_column_major] = ACTIONS(3562),
    [anon_sym_globallycoherent] = ACTIONS(3562),
    [anon_sym_centroid] = ACTIONS(3562),
    [anon_sym_noperspective] = ACTIONS(3562),
    [anon_sym_nointerpolation] = ACTIONS(3562),
    [anon_sym_sample] = ACTIONS(3562),
    [anon_sym_linear] = ACTIONS(3562),
    [anon_sym_snorm] = ACTIONS(3562),
    [anon_sym_unorm] = ACTIONS(3562),
    [anon_sym_point] = ACTIONS(3562),
    [anon_sym_line] = ACTIONS(3562),
    [anon_sym_triangleadj] = ACTIONS(3562),
    [anon_sym_lineadj] = ACTIONS(3562),
    [anon_sym_triangle] = ACTIONS(3562),
    [anon_sym_cbuffer] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_extension] = ACTIONS(3562),
  },
  [797] = {
    [sym_identifier] = ACTIONS(3018),
    [aux_sym_preproc_include_token1] = ACTIONS(3018),
    [aux_sym_preproc_def_token1] = ACTIONS(3018),
    [aux_sym_preproc_if_token1] = ACTIONS(3018),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3018),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3018),
    [sym_preproc_directive] = ACTIONS(3018),
    [anon_sym_LPAREN2] = ACTIONS(3016),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [anon_sym_DASH] = ACTIONS(3018),
    [anon_sym_PLUS] = ACTIONS(3018),
    [anon_sym_STAR] = ACTIONS(3016),
    [anon_sym_AMP_AMP] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(3016),
    [anon_sym___extension__] = ACTIONS(3018),
    [anon_sym_typedef] = ACTIONS(3018),
    [anon_sym_in] = ACTIONS(3018),
    [anon_sym_out] = ACTIONS(3018),
    [anon_sym_inout] = ACTIONS(3018),
    [anon_sym_virtual] = ACTIONS(3018),
    [anon_sym_extern] = ACTIONS(3018),
    [anon_sym___attribute__] = ACTIONS(3018),
    [anon_sym___attribute] = ACTIONS(3018),
    [anon_sym_using] = ACTIONS(3018),
    [anon_sym_COLON_COLON] = ACTIONS(3016),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3016),
    [anon_sym___declspec] = ACTIONS(3018),
    [anon_sym___based] = ACTIONS(3018),
    [anon_sym___cdecl] = ACTIONS(3018),
    [anon_sym___clrcall] = ACTIONS(3018),
    [anon_sym___stdcall] = ACTIONS(3018),
    [anon_sym___fastcall] = ACTIONS(3018),
    [anon_sym___thiscall] = ACTIONS(3018),
    [anon_sym___vectorcall] = ACTIONS(3018),
    [anon_sym_LBRACE] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(3016),
    [anon_sym_signed] = ACTIONS(3018),
    [anon_sym_unsigned] = ACTIONS(3018),
    [anon_sym_long] = ACTIONS(3018),
    [anon_sym_short] = ACTIONS(3018),
    [anon_sym_LBRACK] = ACTIONS(3018),
    [anon_sym_static] = ACTIONS(3018),
    [anon_sym_register] = ACTIONS(3018),
    [anon_sym_inline] = ACTIONS(3018),
    [anon_sym___inline] = ACTIONS(3018),
    [anon_sym___inline__] = ACTIONS(3018),
    [anon_sym___forceinline] = ACTIONS(3018),
    [anon_sym_thread_local] = ACTIONS(3018),
    [anon_sym___thread] = ACTIONS(3018),
    [anon_sym_const] = ACTIONS(3018),
    [anon_sym_constexpr] = ACTIONS(3018),
    [anon_sym_volatile] = ACTIONS(3018),
    [anon_sym_restrict] = ACTIONS(3018),
    [anon_sym___restrict__] = ACTIONS(3018),
    [anon_sym__Atomic] = ACTIONS(3018),
    [anon_sym__Noreturn] = ACTIONS(3018),
    [anon_sym_noreturn] = ACTIONS(3018),
    [anon_sym__Nonnull] = ACTIONS(3018),
    [anon_sym_mutable] = ACTIONS(3018),
    [anon_sym_constinit] = ACTIONS(3018),
    [anon_sym_consteval] = ACTIONS(3018),
    [anon_sym_alignas] = ACTIONS(3018),
    [anon_sym__Alignas] = ACTIONS(3018),
    [sym_primitive_type] = ACTIONS(3018),
    [anon_sym_enum] = ACTIONS(3018),
    [anon_sym_class] = ACTIONS(3018),
    [anon_sym_struct] = ACTIONS(3018),
    [anon_sym_union] = ACTIONS(3018),
    [anon_sym_if] = ACTIONS(3018),
    [anon_sym_switch] = ACTIONS(3018),
    [anon_sym_case] = ACTIONS(3018),
    [anon_sym_default] = ACTIONS(3018),
    [anon_sym_while] = ACTIONS(3018),
    [anon_sym_do] = ACTIONS(3018),
    [anon_sym_for] = ACTIONS(3018),
    [anon_sym_return] = ACTIONS(3018),
    [anon_sym_break] = ACTIONS(3018),
    [anon_sym_continue] = ACTIONS(3018),
    [anon_sym_goto] = ACTIONS(3018),
    [anon_sym___try] = ACTIONS(3018),
    [anon_sym___leave] = ACTIONS(3018),
    [anon_sym_not] = ACTIONS(3018),
    [anon_sym_compl] = ACTIONS(3018),
    [anon_sym_DASH_DASH] = ACTIONS(3016),
    [anon_sym_PLUS_PLUS] = ACTIONS(3016),
    [anon_sym_sizeof] = ACTIONS(3018),
    [anon_sym___alignof__] = ACTIONS(3018),
    [anon_sym___alignof] = ACTIONS(3018),
    [anon_sym__alignof] = ACTIONS(3018),
    [anon_sym_alignof] = ACTIONS(3018),
    [anon_sym__Alignof] = ACTIONS(3018),
    [anon_sym_offsetof] = ACTIONS(3018),
    [anon_sym__Generic] = ACTIONS(3018),
    [anon_sym_asm] = ACTIONS(3018),
    [anon_sym___asm__] = ACTIONS(3018),
    [anon_sym___asm] = ACTIONS(3018),
    [anon_sym_DOT] = ACTIONS(3018),
    [sym_number_literal] = ACTIONS(3016),
    [anon_sym_L_SQUOTE] = ACTIONS(3016),
    [anon_sym_u_SQUOTE] = ACTIONS(3016),
    [anon_sym_U_SQUOTE] = ACTIONS(3016),
    [anon_sym_u8_SQUOTE] = ACTIONS(3016),
    [anon_sym_SQUOTE] = ACTIONS(3016),
    [anon_sym_L_DQUOTE] = ACTIONS(3016),
    [anon_sym_u_DQUOTE] = ACTIONS(3016),
    [anon_sym_U_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8_DQUOTE] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [anon_sym_NULL] = ACTIONS(3018),
    [anon_sym_nullptr] = ACTIONS(3018),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3018),
    [anon_sym_let] = ACTIONS(3018),
    [anon_sym_This] = ACTIONS(3018),
    [anon_sym_decltype] = ACTIONS(3018),
    [anon_sym_explicit] = ACTIONS(3018),
    [anon_sym_typename] = ACTIONS(3018),
    [anon_sym_template] = ACTIONS(3018),
    [anon_sym_operator] = ACTIONS(3018),
    [anon_sym_try] = ACTIONS(3018),
    [anon_sym_delete] = ACTIONS(3018),
    [anon_sym_throw] = ACTIONS(3018),
    [anon_sym_namespace] = ACTIONS(3018),
    [anon_sym_static_assert] = ACTIONS(3018),
    [anon_sym_concept] = ACTIONS(3018),
    [anon_sym_co_return] = ACTIONS(3018),
    [anon_sym_co_yield] = ACTIONS(3018),
    [anon_sym_R_DQUOTE] = ACTIONS(3016),
    [anon_sym_LR_DQUOTE] = ACTIONS(3016),
    [anon_sym_uR_DQUOTE] = ACTIONS(3016),
    [anon_sym_UR_DQUOTE] = ACTIONS(3016),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3016),
    [anon_sym_co_await] = ACTIONS(3018),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_requires] = ACTIONS(3018),
    [sym_this] = ACTIONS(3018),
    [anon_sym_discard] = ACTIONS(3018),
    [anon_sym_precise] = ACTIONS(3018),
    [anon_sym_shared] = ACTIONS(3018),
    [anon_sym_groupshared] = ACTIONS(3018),
    [anon_sym_uniform] = ACTIONS(3018),
    [anon_sym_row_major] = ACTIONS(3018),
    [anon_sym_column_major] = ACTIONS(3018),
    [anon_sym_globallycoherent] = ACTIONS(3018),
    [anon_sym_centroid] = ACTIONS(3018),
    [anon_sym_noperspective] = ACTIONS(3018),
    [anon_sym_nointerpolation] = ACTIONS(3018),
    [anon_sym_sample] = ACTIONS(3018),
    [anon_sym_linear] = ACTIONS(3018),
    [anon_sym_snorm] = ACTIONS(3018),
    [anon_sym_unorm] = ACTIONS(3018),
    [anon_sym_point] = ACTIONS(3018),
    [anon_sym_line] = ACTIONS(3018),
    [anon_sym_triangleadj] = ACTIONS(3018),
    [anon_sym_lineadj] = ACTIONS(3018),
    [anon_sym_triangle] = ACTIONS(3018),
    [anon_sym_cbuffer] = ACTIONS(3018),
    [anon_sym_interface] = ACTIONS(3018),
    [anon_sym_extension] = ACTIONS(3018),
  },
  [798] = {
    [sym_identifier] = ACTIONS(3030),
    [aux_sym_preproc_include_token1] = ACTIONS(3030),
    [aux_sym_preproc_def_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3030),
    [sym_preproc_directive] = ACTIONS(3030),
    [anon_sym_LPAREN2] = ACTIONS(3028),
    [anon_sym_BANG] = ACTIONS(3028),
    [anon_sym_TILDE] = ACTIONS(3028),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3028),
    [anon_sym_AMP_AMP] = ACTIONS(3028),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym___extension__] = ACTIONS(3030),
    [anon_sym_typedef] = ACTIONS(3030),
    [anon_sym_in] = ACTIONS(3030),
    [anon_sym_out] = ACTIONS(3030),
    [anon_sym_inout] = ACTIONS(3030),
    [anon_sym_virtual] = ACTIONS(3030),
    [anon_sym_extern] = ACTIONS(3030),
    [anon_sym___attribute__] = ACTIONS(3030),
    [anon_sym___attribute] = ACTIONS(3030),
    [anon_sym_using] = ACTIONS(3030),
    [anon_sym_COLON_COLON] = ACTIONS(3028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3028),
    [anon_sym___declspec] = ACTIONS(3030),
    [anon_sym___based] = ACTIONS(3030),
    [anon_sym___cdecl] = ACTIONS(3030),
    [anon_sym___clrcall] = ACTIONS(3030),
    [anon_sym___stdcall] = ACTIONS(3030),
    [anon_sym___fastcall] = ACTIONS(3030),
    [anon_sym___thiscall] = ACTIONS(3030),
    [anon_sym___vectorcall] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3028),
    [anon_sym_RBRACE] = ACTIONS(3028),
    [anon_sym_signed] = ACTIONS(3030),
    [anon_sym_unsigned] = ACTIONS(3030),
    [anon_sym_long] = ACTIONS(3030),
    [anon_sym_short] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_register] = ACTIONS(3030),
    [anon_sym_inline] = ACTIONS(3030),
    [anon_sym___inline] = ACTIONS(3030),
    [anon_sym___inline__] = ACTIONS(3030),
    [anon_sym___forceinline] = ACTIONS(3030),
    [anon_sym_thread_local] = ACTIONS(3030),
    [anon_sym___thread] = ACTIONS(3030),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_constexpr] = ACTIONS(3030),
    [anon_sym_volatile] = ACTIONS(3030),
    [anon_sym_restrict] = ACTIONS(3030),
    [anon_sym___restrict__] = ACTIONS(3030),
    [anon_sym__Atomic] = ACTIONS(3030),
    [anon_sym__Noreturn] = ACTIONS(3030),
    [anon_sym_noreturn] = ACTIONS(3030),
    [anon_sym__Nonnull] = ACTIONS(3030),
    [anon_sym_mutable] = ACTIONS(3030),
    [anon_sym_constinit] = ACTIONS(3030),
    [anon_sym_consteval] = ACTIONS(3030),
    [anon_sym_alignas] = ACTIONS(3030),
    [anon_sym__Alignas] = ACTIONS(3030),
    [sym_primitive_type] = ACTIONS(3030),
    [anon_sym_enum] = ACTIONS(3030),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_struct] = ACTIONS(3030),
    [anon_sym_union] = ACTIONS(3030),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_switch] = ACTIONS(3030),
    [anon_sym_case] = ACTIONS(3030),
    [anon_sym_default] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3030),
    [anon_sym_break] = ACTIONS(3030),
    [anon_sym_continue] = ACTIONS(3030),
    [anon_sym_goto] = ACTIONS(3030),
    [anon_sym___try] = ACTIONS(3030),
    [anon_sym___leave] = ACTIONS(3030),
    [anon_sym_not] = ACTIONS(3030),
    [anon_sym_compl] = ACTIONS(3030),
    [anon_sym_DASH_DASH] = ACTIONS(3028),
    [anon_sym_PLUS_PLUS] = ACTIONS(3028),
    [anon_sym_sizeof] = ACTIONS(3030),
    [anon_sym___alignof__] = ACTIONS(3030),
    [anon_sym___alignof] = ACTIONS(3030),
    [anon_sym__alignof] = ACTIONS(3030),
    [anon_sym_alignof] = ACTIONS(3030),
    [anon_sym__Alignof] = ACTIONS(3030),
    [anon_sym_offsetof] = ACTIONS(3030),
    [anon_sym__Generic] = ACTIONS(3030),
    [anon_sym_asm] = ACTIONS(3030),
    [anon_sym___asm__] = ACTIONS(3030),
    [anon_sym___asm] = ACTIONS(3030),
    [anon_sym_DOT] = ACTIONS(3030),
    [sym_number_literal] = ACTIONS(3028),
    [anon_sym_L_SQUOTE] = ACTIONS(3028),
    [anon_sym_u_SQUOTE] = ACTIONS(3028),
    [anon_sym_U_SQUOTE] = ACTIONS(3028),
    [anon_sym_u8_SQUOTE] = ACTIONS(3028),
    [anon_sym_SQUOTE] = ACTIONS(3028),
    [anon_sym_L_DQUOTE] = ACTIONS(3028),
    [anon_sym_u_DQUOTE] = ACTIONS(3028),
    [anon_sym_U_DQUOTE] = ACTIONS(3028),
    [anon_sym_u8_DQUOTE] = ACTIONS(3028),
    [anon_sym_DQUOTE] = ACTIONS(3028),
    [sym_true] = ACTIONS(3030),
    [sym_false] = ACTIONS(3030),
    [anon_sym_NULL] = ACTIONS(3030),
    [anon_sym_nullptr] = ACTIONS(3030),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3030),
    [anon_sym_let] = ACTIONS(3030),
    [anon_sym_This] = ACTIONS(3030),
    [anon_sym_decltype] = ACTIONS(3030),
    [anon_sym_explicit] = ACTIONS(3030),
    [anon_sym_typename] = ACTIONS(3030),
    [anon_sym_template] = ACTIONS(3030),
    [anon_sym_operator] = ACTIONS(3030),
    [anon_sym_try] = ACTIONS(3030),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_throw] = ACTIONS(3030),
    [anon_sym_namespace] = ACTIONS(3030),
    [anon_sym_static_assert] = ACTIONS(3030),
    [anon_sym_concept] = ACTIONS(3030),
    [anon_sym_co_return] = ACTIONS(3030),
    [anon_sym_co_yield] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3028),
    [anon_sym_LR_DQUOTE] = ACTIONS(3028),
    [anon_sym_uR_DQUOTE] = ACTIONS(3028),
    [anon_sym_UR_DQUOTE] = ACTIONS(3028),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3028),
    [anon_sym_co_await] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3030),
    [anon_sym_requires] = ACTIONS(3030),
    [sym_this] = ACTIONS(3030),
    [anon_sym_discard] = ACTIONS(3030),
    [anon_sym_precise] = ACTIONS(3030),
    [anon_sym_shared] = ACTIONS(3030),
    [anon_sym_groupshared] = ACTIONS(3030),
    [anon_sym_uniform] = ACTIONS(3030),
    [anon_sym_row_major] = ACTIONS(3030),
    [anon_sym_column_major] = ACTIONS(3030),
    [anon_sym_globallycoherent] = ACTIONS(3030),
    [anon_sym_centroid] = ACTIONS(3030),
    [anon_sym_noperspective] = ACTIONS(3030),
    [anon_sym_nointerpolation] = ACTIONS(3030),
    [anon_sym_sample] = ACTIONS(3030),
    [anon_sym_linear] = ACTIONS(3030),
    [anon_sym_snorm] = ACTIONS(3030),
    [anon_sym_unorm] = ACTIONS(3030),
    [anon_sym_point] = ACTIONS(3030),
    [anon_sym_line] = ACTIONS(3030),
    [anon_sym_triangleadj] = ACTIONS(3030),
    [anon_sym_lineadj] = ACTIONS(3030),
    [anon_sym_triangle] = ACTIONS(3030),
    [anon_sym_cbuffer] = ACTIONS(3030),
    [anon_sym_interface] = ACTIONS(3030),
    [anon_sym_extension] = ACTIONS(3030),
  },
  [799] = {
    [sym_identifier] = ACTIONS(3470),
    [aux_sym_preproc_include_token1] = ACTIONS(3470),
    [aux_sym_preproc_def_token1] = ACTIONS(3470),
    [aux_sym_preproc_if_token1] = ACTIONS(3470),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3470),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3470),
    [sym_preproc_directive] = ACTIONS(3470),
    [anon_sym_LPAREN2] = ACTIONS(3472),
    [anon_sym_BANG] = ACTIONS(3472),
    [anon_sym_TILDE] = ACTIONS(3472),
    [anon_sym_DASH] = ACTIONS(3470),
    [anon_sym_PLUS] = ACTIONS(3470),
    [anon_sym_STAR] = ACTIONS(3472),
    [anon_sym_AMP_AMP] = ACTIONS(3472),
    [anon_sym_AMP] = ACTIONS(3470),
    [anon_sym_SEMI] = ACTIONS(3472),
    [anon_sym___extension__] = ACTIONS(3470),
    [anon_sym_typedef] = ACTIONS(3470),
    [anon_sym_in] = ACTIONS(3470),
    [anon_sym_out] = ACTIONS(3470),
    [anon_sym_inout] = ACTIONS(3470),
    [anon_sym_virtual] = ACTIONS(3470),
    [anon_sym_extern] = ACTIONS(3470),
    [anon_sym___attribute__] = ACTIONS(3470),
    [anon_sym___attribute] = ACTIONS(3470),
    [anon_sym_using] = ACTIONS(3470),
    [anon_sym_COLON_COLON] = ACTIONS(3472),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3472),
    [anon_sym___declspec] = ACTIONS(3470),
    [anon_sym___based] = ACTIONS(3470),
    [anon_sym___cdecl] = ACTIONS(3470),
    [anon_sym___clrcall] = ACTIONS(3470),
    [anon_sym___stdcall] = ACTIONS(3470),
    [anon_sym___fastcall] = ACTIONS(3470),
    [anon_sym___thiscall] = ACTIONS(3470),
    [anon_sym___vectorcall] = ACTIONS(3470),
    [anon_sym_LBRACE] = ACTIONS(3472),
    [anon_sym_RBRACE] = ACTIONS(3472),
    [anon_sym_signed] = ACTIONS(3470),
    [anon_sym_unsigned] = ACTIONS(3470),
    [anon_sym_long] = ACTIONS(3470),
    [anon_sym_short] = ACTIONS(3470),
    [anon_sym_LBRACK] = ACTIONS(3470),
    [anon_sym_static] = ACTIONS(3470),
    [anon_sym_register] = ACTIONS(3470),
    [anon_sym_inline] = ACTIONS(3470),
    [anon_sym___inline] = ACTIONS(3470),
    [anon_sym___inline__] = ACTIONS(3470),
    [anon_sym___forceinline] = ACTIONS(3470),
    [anon_sym_thread_local] = ACTIONS(3470),
    [anon_sym___thread] = ACTIONS(3470),
    [anon_sym_const] = ACTIONS(3470),
    [anon_sym_constexpr] = ACTIONS(3470),
    [anon_sym_volatile] = ACTIONS(3470),
    [anon_sym_restrict] = ACTIONS(3470),
    [anon_sym___restrict__] = ACTIONS(3470),
    [anon_sym__Atomic] = ACTIONS(3470),
    [anon_sym__Noreturn] = ACTIONS(3470),
    [anon_sym_noreturn] = ACTIONS(3470),
    [anon_sym__Nonnull] = ACTIONS(3470),
    [anon_sym_mutable] = ACTIONS(3470),
    [anon_sym_constinit] = ACTIONS(3470),
    [anon_sym_consteval] = ACTIONS(3470),
    [anon_sym_alignas] = ACTIONS(3470),
    [anon_sym__Alignas] = ACTIONS(3470),
    [sym_primitive_type] = ACTIONS(3470),
    [anon_sym_enum] = ACTIONS(3470),
    [anon_sym_class] = ACTIONS(3470),
    [anon_sym_struct] = ACTIONS(3470),
    [anon_sym_union] = ACTIONS(3470),
    [anon_sym_if] = ACTIONS(3470),
    [anon_sym_else] = ACTIONS(3470),
    [anon_sym_switch] = ACTIONS(3470),
    [anon_sym_case] = ACTIONS(3470),
    [anon_sym_default] = ACTIONS(3470),
    [anon_sym_while] = ACTIONS(3470),
    [anon_sym_do] = ACTIONS(3470),
    [anon_sym_for] = ACTIONS(3470),
    [anon_sym_return] = ACTIONS(3470),
    [anon_sym_break] = ACTIONS(3470),
    [anon_sym_continue] = ACTIONS(3470),
    [anon_sym_goto] = ACTIONS(3470),
    [anon_sym___try] = ACTIONS(3470),
    [anon_sym___leave] = ACTIONS(3470),
    [anon_sym_not] = ACTIONS(3470),
    [anon_sym_compl] = ACTIONS(3470),
    [anon_sym_DASH_DASH] = ACTIONS(3472),
    [anon_sym_PLUS_PLUS] = ACTIONS(3472),
    [anon_sym_sizeof] = ACTIONS(3470),
    [anon_sym___alignof__] = ACTIONS(3470),
    [anon_sym___alignof] = ACTIONS(3470),
    [anon_sym__alignof] = ACTIONS(3470),
    [anon_sym_alignof] = ACTIONS(3470),
    [anon_sym__Alignof] = ACTIONS(3470),
    [anon_sym_offsetof] = ACTIONS(3470),
    [anon_sym__Generic] = ACTIONS(3470),
    [anon_sym_asm] = ACTIONS(3470),
    [anon_sym___asm__] = ACTIONS(3470),
    [anon_sym___asm] = ACTIONS(3470),
    [sym_number_literal] = ACTIONS(3472),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3472),
    [anon_sym_u_DQUOTE] = ACTIONS(3472),
    [anon_sym_U_DQUOTE] = ACTIONS(3472),
    [anon_sym_u8_DQUOTE] = ACTIONS(3472),
    [anon_sym_DQUOTE] = ACTIONS(3472),
    [sym_true] = ACTIONS(3470),
    [sym_false] = ACTIONS(3470),
    [anon_sym_NULL] = ACTIONS(3470),
    [anon_sym_nullptr] = ACTIONS(3470),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3470),
    [anon_sym_let] = ACTIONS(3470),
    [anon_sym_This] = ACTIONS(3470),
    [anon_sym_decltype] = ACTIONS(3470),
    [anon_sym_explicit] = ACTIONS(3470),
    [anon_sym_typename] = ACTIONS(3470),
    [anon_sym_template] = ACTIONS(3470),
    [anon_sym_operator] = ACTIONS(3470),
    [anon_sym_try] = ACTIONS(3470),
    [anon_sym_delete] = ACTIONS(3470),
    [anon_sym_throw] = ACTIONS(3470),
    [anon_sym_namespace] = ACTIONS(3470),
    [anon_sym_static_assert] = ACTIONS(3470),
    [anon_sym_concept] = ACTIONS(3470),
    [anon_sym_co_return] = ACTIONS(3470),
    [anon_sym_co_yield] = ACTIONS(3470),
    [anon_sym_R_DQUOTE] = ACTIONS(3472),
    [anon_sym_LR_DQUOTE] = ACTIONS(3472),
    [anon_sym_uR_DQUOTE] = ACTIONS(3472),
    [anon_sym_UR_DQUOTE] = ACTIONS(3472),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3472),
    [anon_sym_co_await] = ACTIONS(3470),
    [anon_sym_new] = ACTIONS(3470),
    [anon_sym_requires] = ACTIONS(3470),
    [sym_this] = ACTIONS(3470),
    [anon_sym_discard] = ACTIONS(3470),
    [anon_sym_precise] = ACTIONS(3470),
    [anon_sym_shared] = ACTIONS(3470),
    [anon_sym_groupshared] = ACTIONS(3470),
    [anon_sym_uniform] = ACTIONS(3470),
    [anon_sym_row_major] = ACTIONS(3470),
    [anon_sym_column_major] = ACTIONS(3470),
    [anon_sym_globallycoherent] = ACTIONS(3470),
    [anon_sym_centroid] = ACTIONS(3470),
    [anon_sym_noperspective] = ACTIONS(3470),
    [anon_sym_nointerpolation] = ACTIONS(3470),
    [anon_sym_sample] = ACTIONS(3470),
    [anon_sym_linear] = ACTIONS(3470),
    [anon_sym_snorm] = ACTIONS(3470),
    [anon_sym_unorm] = ACTIONS(3470),
    [anon_sym_point] = ACTIONS(3470),
    [anon_sym_line] = ACTIONS(3470),
    [anon_sym_triangleadj] = ACTIONS(3470),
    [anon_sym_lineadj] = ACTIONS(3470),
    [anon_sym_triangle] = ACTIONS(3470),
    [anon_sym_cbuffer] = ACTIONS(3470),
    [anon_sym_interface] = ACTIONS(3470),
    [anon_sym_extension] = ACTIONS(3470),
  },
  [800] = {
    [sym_identifier] = ACTIONS(2883),
    [aux_sym_preproc_include_token1] = ACTIONS(2883),
    [aux_sym_preproc_def_token1] = ACTIONS(2883),
    [aux_sym_preproc_if_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2883),
    [sym_preproc_directive] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_typedef] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_using] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2881),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_RBRACE] = ACTIONS(2881),
    [anon_sym_signed] = ACTIONS(2883),
    [anon_sym_unsigned] = ACTIONS(2883),
    [anon_sym_long] = ACTIONS(2883),
    [anon_sym_short] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [sym_primitive_type] = ACTIONS(2883),
    [anon_sym_enum] = ACTIONS(2883),
    [anon_sym_class] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2883),
    [anon_sym_union] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_switch] = ACTIONS(2883),
    [anon_sym_case] = ACTIONS(2883),
    [anon_sym_default] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_break] = ACTIONS(2883),
    [anon_sym_continue] = ACTIONS(2883),
    [anon_sym_goto] = ACTIONS(2883),
    [anon_sym___try] = ACTIONS(2883),
    [anon_sym___leave] = ACTIONS(2883),
    [anon_sym_not] = ACTIONS(2883),
    [anon_sym_compl] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_sizeof] = ACTIONS(2883),
    [anon_sym___alignof__] = ACTIONS(2883),
    [anon_sym___alignof] = ACTIONS(2883),
    [anon_sym__alignof] = ACTIONS(2883),
    [anon_sym_alignof] = ACTIONS(2883),
    [anon_sym__Alignof] = ACTIONS(2883),
    [anon_sym_offsetof] = ACTIONS(2883),
    [anon_sym__Generic] = ACTIONS(2883),
    [anon_sym_asm] = ACTIONS(2883),
    [anon_sym___asm__] = ACTIONS(2883),
    [anon_sym___asm] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [sym_number_literal] = ACTIONS(2881),
    [anon_sym_L_SQUOTE] = ACTIONS(2881),
    [anon_sym_u_SQUOTE] = ACTIONS(2881),
    [anon_sym_U_SQUOTE] = ACTIONS(2881),
    [anon_sym_u8_SQUOTE] = ACTIONS(2881),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_L_DQUOTE] = ACTIONS(2881),
    [anon_sym_u_DQUOTE] = ACTIONS(2881),
    [anon_sym_U_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [sym_true] = ACTIONS(2883),
    [sym_false] = ACTIONS(2883),
    [anon_sym_NULL] = ACTIONS(2883),
    [anon_sym_nullptr] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_explicit] = ACTIONS(2883),
    [anon_sym_typename] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_delete] = ACTIONS(2883),
    [anon_sym_throw] = ACTIONS(2883),
    [anon_sym_namespace] = ACTIONS(2883),
    [anon_sym_static_assert] = ACTIONS(2883),
    [anon_sym_concept] = ACTIONS(2883),
    [anon_sym_co_return] = ACTIONS(2883),
    [anon_sym_co_yield] = ACTIONS(2883),
    [anon_sym_R_DQUOTE] = ACTIONS(2881),
    [anon_sym_LR_DQUOTE] = ACTIONS(2881),
    [anon_sym_uR_DQUOTE] = ACTIONS(2881),
    [anon_sym_UR_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2881),
    [anon_sym_co_await] = ACTIONS(2883),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_requires] = ACTIONS(2883),
    [sym_this] = ACTIONS(2883),
    [anon_sym_discard] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
    [anon_sym_cbuffer] = ACTIONS(2883),
    [anon_sym_interface] = ACTIONS(2883),
    [anon_sym_extension] = ACTIONS(2883),
  },
  [801] = {
    [sym_identifier] = ACTIONS(3581),
    [aux_sym_preproc_include_token1] = ACTIONS(3581),
    [aux_sym_preproc_def_token1] = ACTIONS(3581),
    [aux_sym_preproc_if_token1] = ACTIONS(3581),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3581),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3581),
    [sym_preproc_directive] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(3579),
    [anon_sym_BANG] = ACTIONS(3579),
    [anon_sym_TILDE] = ACTIONS(3579),
    [anon_sym_DASH] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3581),
    [anon_sym_STAR] = ACTIONS(3579),
    [anon_sym_AMP_AMP] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3581),
    [anon_sym_SEMI] = ACTIONS(3579),
    [anon_sym___extension__] = ACTIONS(3581),
    [anon_sym_typedef] = ACTIONS(3581),
    [anon_sym_in] = ACTIONS(3581),
    [anon_sym_out] = ACTIONS(3581),
    [anon_sym_inout] = ACTIONS(3581),
    [anon_sym_virtual] = ACTIONS(3581),
    [anon_sym_extern] = ACTIONS(3581),
    [anon_sym___attribute__] = ACTIONS(3581),
    [anon_sym___attribute] = ACTIONS(3581),
    [anon_sym_using] = ACTIONS(3581),
    [anon_sym_COLON_COLON] = ACTIONS(3579),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3579),
    [anon_sym___declspec] = ACTIONS(3581),
    [anon_sym___based] = ACTIONS(3581),
    [anon_sym___cdecl] = ACTIONS(3581),
    [anon_sym___clrcall] = ACTIONS(3581),
    [anon_sym___stdcall] = ACTIONS(3581),
    [anon_sym___fastcall] = ACTIONS(3581),
    [anon_sym___thiscall] = ACTIONS(3581),
    [anon_sym___vectorcall] = ACTIONS(3581),
    [anon_sym_LBRACE] = ACTIONS(3579),
    [anon_sym_RBRACE] = ACTIONS(3579),
    [anon_sym_signed] = ACTIONS(3581),
    [anon_sym_unsigned] = ACTIONS(3581),
    [anon_sym_long] = ACTIONS(3581),
    [anon_sym_short] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_static] = ACTIONS(3581),
    [anon_sym_register] = ACTIONS(3581),
    [anon_sym_inline] = ACTIONS(3581),
    [anon_sym___inline] = ACTIONS(3581),
    [anon_sym___inline__] = ACTIONS(3581),
    [anon_sym___forceinline] = ACTIONS(3581),
    [anon_sym_thread_local] = ACTIONS(3581),
    [anon_sym___thread] = ACTIONS(3581),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_constexpr] = ACTIONS(3581),
    [anon_sym_volatile] = ACTIONS(3581),
    [anon_sym_restrict] = ACTIONS(3581),
    [anon_sym___restrict__] = ACTIONS(3581),
    [anon_sym__Atomic] = ACTIONS(3581),
    [anon_sym__Noreturn] = ACTIONS(3581),
    [anon_sym_noreturn] = ACTIONS(3581),
    [anon_sym__Nonnull] = ACTIONS(3581),
    [anon_sym_mutable] = ACTIONS(3581),
    [anon_sym_constinit] = ACTIONS(3581),
    [anon_sym_consteval] = ACTIONS(3581),
    [anon_sym_alignas] = ACTIONS(3581),
    [anon_sym__Alignas] = ACTIONS(3581),
    [sym_primitive_type] = ACTIONS(3581),
    [anon_sym_enum] = ACTIONS(3581),
    [anon_sym_class] = ACTIONS(3581),
    [anon_sym_struct] = ACTIONS(3581),
    [anon_sym_union] = ACTIONS(3581),
    [anon_sym_if] = ACTIONS(3581),
    [anon_sym_else] = ACTIONS(3581),
    [anon_sym_switch] = ACTIONS(3581),
    [anon_sym_case] = ACTIONS(3581),
    [anon_sym_default] = ACTIONS(3581),
    [anon_sym_while] = ACTIONS(3581),
    [anon_sym_do] = ACTIONS(3581),
    [anon_sym_for] = ACTIONS(3581),
    [anon_sym_return] = ACTIONS(3581),
    [anon_sym_break] = ACTIONS(3581),
    [anon_sym_continue] = ACTIONS(3581),
    [anon_sym_goto] = ACTIONS(3581),
    [anon_sym___try] = ACTIONS(3581),
    [anon_sym___leave] = ACTIONS(3581),
    [anon_sym_not] = ACTIONS(3581),
    [anon_sym_compl] = ACTIONS(3581),
    [anon_sym_DASH_DASH] = ACTIONS(3579),
    [anon_sym_PLUS_PLUS] = ACTIONS(3579),
    [anon_sym_sizeof] = ACTIONS(3581),
    [anon_sym___alignof__] = ACTIONS(3581),
    [anon_sym___alignof] = ACTIONS(3581),
    [anon_sym__alignof] = ACTIONS(3581),
    [anon_sym_alignof] = ACTIONS(3581),
    [anon_sym__Alignof] = ACTIONS(3581),
    [anon_sym_offsetof] = ACTIONS(3581),
    [anon_sym__Generic] = ACTIONS(3581),
    [anon_sym_asm] = ACTIONS(3581),
    [anon_sym___asm__] = ACTIONS(3581),
    [anon_sym___asm] = ACTIONS(3581),
    [sym_number_literal] = ACTIONS(3579),
    [anon_sym_L_SQUOTE] = ACTIONS(3579),
    [anon_sym_u_SQUOTE] = ACTIONS(3579),
    [anon_sym_U_SQUOTE] = ACTIONS(3579),
    [anon_sym_u8_SQUOTE] = ACTIONS(3579),
    [anon_sym_SQUOTE] = ACTIONS(3579),
    [anon_sym_L_DQUOTE] = ACTIONS(3579),
    [anon_sym_u_DQUOTE] = ACTIONS(3579),
    [anon_sym_U_DQUOTE] = ACTIONS(3579),
    [anon_sym_u8_DQUOTE] = ACTIONS(3579),
    [anon_sym_DQUOTE] = ACTIONS(3579),
    [sym_true] = ACTIONS(3581),
    [sym_false] = ACTIONS(3581),
    [anon_sym_NULL] = ACTIONS(3581),
    [anon_sym_nullptr] = ACTIONS(3581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_This] = ACTIONS(3581),
    [anon_sym_decltype] = ACTIONS(3581),
    [anon_sym_explicit] = ACTIONS(3581),
    [anon_sym_typename] = ACTIONS(3581),
    [anon_sym_template] = ACTIONS(3581),
    [anon_sym_operator] = ACTIONS(3581),
    [anon_sym_try] = ACTIONS(3581),
    [anon_sym_delete] = ACTIONS(3581),
    [anon_sym_throw] = ACTIONS(3581),
    [anon_sym_namespace] = ACTIONS(3581),
    [anon_sym_static_assert] = ACTIONS(3581),
    [anon_sym_concept] = ACTIONS(3581),
    [anon_sym_co_return] = ACTIONS(3581),
    [anon_sym_co_yield] = ACTIONS(3581),
    [anon_sym_R_DQUOTE] = ACTIONS(3579),
    [anon_sym_LR_DQUOTE] = ACTIONS(3579),
    [anon_sym_uR_DQUOTE] = ACTIONS(3579),
    [anon_sym_UR_DQUOTE] = ACTIONS(3579),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3579),
    [anon_sym_co_await] = ACTIONS(3581),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_requires] = ACTIONS(3581),
    [sym_this] = ACTIONS(3581),
    [anon_sym_discard] = ACTIONS(3581),
    [anon_sym_precise] = ACTIONS(3581),
    [anon_sym_shared] = ACTIONS(3581),
    [anon_sym_groupshared] = ACTIONS(3581),
    [anon_sym_uniform] = ACTIONS(3581),
    [anon_sym_row_major] = ACTIONS(3581),
    [anon_sym_column_major] = ACTIONS(3581),
    [anon_sym_globallycoherent] = ACTIONS(3581),
    [anon_sym_centroid] = ACTIONS(3581),
    [anon_sym_noperspective] = ACTIONS(3581),
    [anon_sym_nointerpolation] = ACTIONS(3581),
    [anon_sym_sample] = ACTIONS(3581),
    [anon_sym_linear] = ACTIONS(3581),
    [anon_sym_snorm] = ACTIONS(3581),
    [anon_sym_unorm] = ACTIONS(3581),
    [anon_sym_point] = ACTIONS(3581),
    [anon_sym_line] = ACTIONS(3581),
    [anon_sym_triangleadj] = ACTIONS(3581),
    [anon_sym_lineadj] = ACTIONS(3581),
    [anon_sym_triangle] = ACTIONS(3581),
    [anon_sym_cbuffer] = ACTIONS(3581),
    [anon_sym_interface] = ACTIONS(3581),
    [anon_sym_extension] = ACTIONS(3581),
  },
  [802] = {
    [sym_identifier] = ACTIONS(3591),
    [aux_sym_preproc_include_token1] = ACTIONS(3591),
    [aux_sym_preproc_def_token1] = ACTIONS(3591),
    [aux_sym_preproc_if_token1] = ACTIONS(3591),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3591),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3591),
    [sym_preproc_directive] = ACTIONS(3591),
    [anon_sym_LPAREN2] = ACTIONS(3589),
    [anon_sym_BANG] = ACTIONS(3589),
    [anon_sym_TILDE] = ACTIONS(3589),
    [anon_sym_DASH] = ACTIONS(3591),
    [anon_sym_PLUS] = ACTIONS(3591),
    [anon_sym_STAR] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(3589),
    [anon_sym___extension__] = ACTIONS(3591),
    [anon_sym_typedef] = ACTIONS(3591),
    [anon_sym_in] = ACTIONS(3591),
    [anon_sym_out] = ACTIONS(3591),
    [anon_sym_inout] = ACTIONS(3591),
    [anon_sym_virtual] = ACTIONS(3591),
    [anon_sym_extern] = ACTIONS(3591),
    [anon_sym___attribute__] = ACTIONS(3591),
    [anon_sym___attribute] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3591),
    [anon_sym_COLON_COLON] = ACTIONS(3589),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3589),
    [anon_sym___declspec] = ACTIONS(3591),
    [anon_sym___based] = ACTIONS(3591),
    [anon_sym___cdecl] = ACTIONS(3591),
    [anon_sym___clrcall] = ACTIONS(3591),
    [anon_sym___stdcall] = ACTIONS(3591),
    [anon_sym___fastcall] = ACTIONS(3591),
    [anon_sym___thiscall] = ACTIONS(3591),
    [anon_sym___vectorcall] = ACTIONS(3591),
    [anon_sym_LBRACE] = ACTIONS(3589),
    [anon_sym_RBRACE] = ACTIONS(3589),
    [anon_sym_signed] = ACTIONS(3591),
    [anon_sym_unsigned] = ACTIONS(3591),
    [anon_sym_long] = ACTIONS(3591),
    [anon_sym_short] = ACTIONS(3591),
    [anon_sym_LBRACK] = ACTIONS(3591),
    [anon_sym_static] = ACTIONS(3591),
    [anon_sym_register] = ACTIONS(3591),
    [anon_sym_inline] = ACTIONS(3591),
    [anon_sym___inline] = ACTIONS(3591),
    [anon_sym___inline__] = ACTIONS(3591),
    [anon_sym___forceinline] = ACTIONS(3591),
    [anon_sym_thread_local] = ACTIONS(3591),
    [anon_sym___thread] = ACTIONS(3591),
    [anon_sym_const] = ACTIONS(3591),
    [anon_sym_constexpr] = ACTIONS(3591),
    [anon_sym_volatile] = ACTIONS(3591),
    [anon_sym_restrict] = ACTIONS(3591),
    [anon_sym___restrict__] = ACTIONS(3591),
    [anon_sym__Atomic] = ACTIONS(3591),
    [anon_sym__Noreturn] = ACTIONS(3591),
    [anon_sym_noreturn] = ACTIONS(3591),
    [anon_sym__Nonnull] = ACTIONS(3591),
    [anon_sym_mutable] = ACTIONS(3591),
    [anon_sym_constinit] = ACTIONS(3591),
    [anon_sym_consteval] = ACTIONS(3591),
    [anon_sym_alignas] = ACTIONS(3591),
    [anon_sym__Alignas] = ACTIONS(3591),
    [sym_primitive_type] = ACTIONS(3591),
    [anon_sym_enum] = ACTIONS(3591),
    [anon_sym_class] = ACTIONS(3591),
    [anon_sym_struct] = ACTIONS(3591),
    [anon_sym_union] = ACTIONS(3591),
    [anon_sym_if] = ACTIONS(3591),
    [anon_sym_else] = ACTIONS(3591),
    [anon_sym_switch] = ACTIONS(3591),
    [anon_sym_case] = ACTIONS(3591),
    [anon_sym_default] = ACTIONS(3591),
    [anon_sym_while] = ACTIONS(3591),
    [anon_sym_do] = ACTIONS(3591),
    [anon_sym_for] = ACTIONS(3591),
    [anon_sym_return] = ACTIONS(3591),
    [anon_sym_break] = ACTIONS(3591),
    [anon_sym_continue] = ACTIONS(3591),
    [anon_sym_goto] = ACTIONS(3591),
    [anon_sym___try] = ACTIONS(3591),
    [anon_sym___leave] = ACTIONS(3591),
    [anon_sym_not] = ACTIONS(3591),
    [anon_sym_compl] = ACTIONS(3591),
    [anon_sym_DASH_DASH] = ACTIONS(3589),
    [anon_sym_PLUS_PLUS] = ACTIONS(3589),
    [anon_sym_sizeof] = ACTIONS(3591),
    [anon_sym___alignof__] = ACTIONS(3591),
    [anon_sym___alignof] = ACTIONS(3591),
    [anon_sym__alignof] = ACTIONS(3591),
    [anon_sym_alignof] = ACTIONS(3591),
    [anon_sym__Alignof] = ACTIONS(3591),
    [anon_sym_offsetof] = ACTIONS(3591),
    [anon_sym__Generic] = ACTIONS(3591),
    [anon_sym_asm] = ACTIONS(3591),
    [anon_sym___asm__] = ACTIONS(3591),
    [anon_sym___asm] = ACTIONS(3591),
    [sym_number_literal] = ACTIONS(3589),
    [anon_sym_L_SQUOTE] = ACTIONS(3589),
    [anon_sym_u_SQUOTE] = ACTIONS(3589),
    [anon_sym_U_SQUOTE] = ACTIONS(3589),
    [anon_sym_u8_SQUOTE] = ACTIONS(3589),
    [anon_sym_SQUOTE] = ACTIONS(3589),
    [anon_sym_L_DQUOTE] = ACTIONS(3589),
    [anon_sym_u_DQUOTE] = ACTIONS(3589),
    [anon_sym_U_DQUOTE] = ACTIONS(3589),
    [anon_sym_u8_DQUOTE] = ACTIONS(3589),
    [anon_sym_DQUOTE] = ACTIONS(3589),
    [sym_true] = ACTIONS(3591),
    [sym_false] = ACTIONS(3591),
    [anon_sym_NULL] = ACTIONS(3591),
    [anon_sym_nullptr] = ACTIONS(3591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3591),
    [anon_sym_let] = ACTIONS(3591),
    [anon_sym_This] = ACTIONS(3591),
    [anon_sym_decltype] = ACTIONS(3591),
    [anon_sym_explicit] = ACTIONS(3591),
    [anon_sym_typename] = ACTIONS(3591),
    [anon_sym_template] = ACTIONS(3591),
    [anon_sym_operator] = ACTIONS(3591),
    [anon_sym_try] = ACTIONS(3591),
    [anon_sym_delete] = ACTIONS(3591),
    [anon_sym_throw] = ACTIONS(3591),
    [anon_sym_namespace] = ACTIONS(3591),
    [anon_sym_static_assert] = ACTIONS(3591),
    [anon_sym_concept] = ACTIONS(3591),
    [anon_sym_co_return] = ACTIONS(3591),
    [anon_sym_co_yield] = ACTIONS(3591),
    [anon_sym_R_DQUOTE] = ACTIONS(3589),
    [anon_sym_LR_DQUOTE] = ACTIONS(3589),
    [anon_sym_uR_DQUOTE] = ACTIONS(3589),
    [anon_sym_UR_DQUOTE] = ACTIONS(3589),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3589),
    [anon_sym_co_await] = ACTIONS(3591),
    [anon_sym_new] = ACTIONS(3591),
    [anon_sym_requires] = ACTIONS(3591),
    [sym_this] = ACTIONS(3591),
    [anon_sym_discard] = ACTIONS(3591),
    [anon_sym_precise] = ACTIONS(3591),
    [anon_sym_shared] = ACTIONS(3591),
    [anon_sym_groupshared] = ACTIONS(3591),
    [anon_sym_uniform] = ACTIONS(3591),
    [anon_sym_row_major] = ACTIONS(3591),
    [anon_sym_column_major] = ACTIONS(3591),
    [anon_sym_globallycoherent] = ACTIONS(3591),
    [anon_sym_centroid] = ACTIONS(3591),
    [anon_sym_noperspective] = ACTIONS(3591),
    [anon_sym_nointerpolation] = ACTIONS(3591),
    [anon_sym_sample] = ACTIONS(3591),
    [anon_sym_linear] = ACTIONS(3591),
    [anon_sym_snorm] = ACTIONS(3591),
    [anon_sym_unorm] = ACTIONS(3591),
    [anon_sym_point] = ACTIONS(3591),
    [anon_sym_line] = ACTIONS(3591),
    [anon_sym_triangleadj] = ACTIONS(3591),
    [anon_sym_lineadj] = ACTIONS(3591),
    [anon_sym_triangle] = ACTIONS(3591),
    [anon_sym_cbuffer] = ACTIONS(3591),
    [anon_sym_interface] = ACTIONS(3591),
    [anon_sym_extension] = ACTIONS(3591),
  },
  [803] = {
    [sym_identifier] = ACTIONS(3460),
    [aux_sym_preproc_include_token1] = ACTIONS(3460),
    [aux_sym_preproc_def_token1] = ACTIONS(3460),
    [aux_sym_preproc_if_token1] = ACTIONS(3460),
    [aux_sym_preproc_if_token2] = ACTIONS(3460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3460),
    [sym_preproc_directive] = ACTIONS(3460),
    [anon_sym_LPAREN2] = ACTIONS(3458),
    [anon_sym_BANG] = ACTIONS(3458),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3460),
    [anon_sym_PLUS] = ACTIONS(3460),
    [anon_sym_STAR] = ACTIONS(3458),
    [anon_sym_AMP_AMP] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3460),
    [anon_sym_SEMI] = ACTIONS(3458),
    [anon_sym___extension__] = ACTIONS(3460),
    [anon_sym_typedef] = ACTIONS(3460),
    [anon_sym_in] = ACTIONS(3460),
    [anon_sym_out] = ACTIONS(3460),
    [anon_sym_inout] = ACTIONS(3460),
    [anon_sym_virtual] = ACTIONS(3460),
    [anon_sym_extern] = ACTIONS(3460),
    [anon_sym___attribute__] = ACTIONS(3460),
    [anon_sym___attribute] = ACTIONS(3460),
    [anon_sym_using] = ACTIONS(3460),
    [anon_sym_COLON_COLON] = ACTIONS(3458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3458),
    [anon_sym___declspec] = ACTIONS(3460),
    [anon_sym___based] = ACTIONS(3460),
    [anon_sym___cdecl] = ACTIONS(3460),
    [anon_sym___clrcall] = ACTIONS(3460),
    [anon_sym___stdcall] = ACTIONS(3460),
    [anon_sym___fastcall] = ACTIONS(3460),
    [anon_sym___thiscall] = ACTIONS(3460),
    [anon_sym___vectorcall] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(3458),
    [anon_sym_signed] = ACTIONS(3460),
    [anon_sym_unsigned] = ACTIONS(3460),
    [anon_sym_long] = ACTIONS(3460),
    [anon_sym_short] = ACTIONS(3460),
    [anon_sym_LBRACK] = ACTIONS(3460),
    [anon_sym_static] = ACTIONS(3460),
    [anon_sym_register] = ACTIONS(3460),
    [anon_sym_inline] = ACTIONS(3460),
    [anon_sym___inline] = ACTIONS(3460),
    [anon_sym___inline__] = ACTIONS(3460),
    [anon_sym___forceinline] = ACTIONS(3460),
    [anon_sym_thread_local] = ACTIONS(3460),
    [anon_sym___thread] = ACTIONS(3460),
    [anon_sym_const] = ACTIONS(3460),
    [anon_sym_constexpr] = ACTIONS(3460),
    [anon_sym_volatile] = ACTIONS(3460),
    [anon_sym_restrict] = ACTIONS(3460),
    [anon_sym___restrict__] = ACTIONS(3460),
    [anon_sym__Atomic] = ACTIONS(3460),
    [anon_sym__Noreturn] = ACTIONS(3460),
    [anon_sym_noreturn] = ACTIONS(3460),
    [anon_sym__Nonnull] = ACTIONS(3460),
    [anon_sym_mutable] = ACTIONS(3460),
    [anon_sym_constinit] = ACTIONS(3460),
    [anon_sym_consteval] = ACTIONS(3460),
    [anon_sym_alignas] = ACTIONS(3460),
    [anon_sym__Alignas] = ACTIONS(3460),
    [sym_primitive_type] = ACTIONS(3460),
    [anon_sym_enum] = ACTIONS(3460),
    [anon_sym_class] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(3460),
    [anon_sym_union] = ACTIONS(3460),
    [anon_sym_if] = ACTIONS(3460),
    [anon_sym_else] = ACTIONS(3460),
    [anon_sym_switch] = ACTIONS(3460),
    [anon_sym_case] = ACTIONS(3460),
    [anon_sym_default] = ACTIONS(3460),
    [anon_sym_while] = ACTIONS(3460),
    [anon_sym_do] = ACTIONS(3460),
    [anon_sym_for] = ACTIONS(3460),
    [anon_sym_return] = ACTIONS(3460),
    [anon_sym_break] = ACTIONS(3460),
    [anon_sym_continue] = ACTIONS(3460),
    [anon_sym_goto] = ACTIONS(3460),
    [anon_sym___try] = ACTIONS(3460),
    [anon_sym___leave] = ACTIONS(3460),
    [anon_sym_not] = ACTIONS(3460),
    [anon_sym_compl] = ACTIONS(3460),
    [anon_sym_DASH_DASH] = ACTIONS(3458),
    [anon_sym_PLUS_PLUS] = ACTIONS(3458),
    [anon_sym_sizeof] = ACTIONS(3460),
    [anon_sym___alignof__] = ACTIONS(3460),
    [anon_sym___alignof] = ACTIONS(3460),
    [anon_sym__alignof] = ACTIONS(3460),
    [anon_sym_alignof] = ACTIONS(3460),
    [anon_sym__Alignof] = ACTIONS(3460),
    [anon_sym_offsetof] = ACTIONS(3460),
    [anon_sym__Generic] = ACTIONS(3460),
    [anon_sym_asm] = ACTIONS(3460),
    [anon_sym___asm__] = ACTIONS(3460),
    [anon_sym___asm] = ACTIONS(3460),
    [sym_number_literal] = ACTIONS(3458),
    [anon_sym_L_SQUOTE] = ACTIONS(3458),
    [anon_sym_u_SQUOTE] = ACTIONS(3458),
    [anon_sym_U_SQUOTE] = ACTIONS(3458),
    [anon_sym_u8_SQUOTE] = ACTIONS(3458),
    [anon_sym_SQUOTE] = ACTIONS(3458),
    [anon_sym_L_DQUOTE] = ACTIONS(3458),
    [anon_sym_u_DQUOTE] = ACTIONS(3458),
    [anon_sym_U_DQUOTE] = ACTIONS(3458),
    [anon_sym_u8_DQUOTE] = ACTIONS(3458),
    [anon_sym_DQUOTE] = ACTIONS(3458),
    [sym_true] = ACTIONS(3460),
    [sym_false] = ACTIONS(3460),
    [anon_sym_NULL] = ACTIONS(3460),
    [anon_sym_nullptr] = ACTIONS(3460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3460),
    [anon_sym_let] = ACTIONS(3460),
    [anon_sym_This] = ACTIONS(3460),
    [anon_sym_decltype] = ACTIONS(3460),
    [anon_sym_explicit] = ACTIONS(3460),
    [anon_sym_typename] = ACTIONS(3460),
    [anon_sym_template] = ACTIONS(3460),
    [anon_sym_operator] = ACTIONS(3460),
    [anon_sym_try] = ACTIONS(3460),
    [anon_sym_delete] = ACTIONS(3460),
    [anon_sym_throw] = ACTIONS(3460),
    [anon_sym_namespace] = ACTIONS(3460),
    [anon_sym_static_assert] = ACTIONS(3460),
    [anon_sym_concept] = ACTIONS(3460),
    [anon_sym_co_return] = ACTIONS(3460),
    [anon_sym_co_yield] = ACTIONS(3460),
    [anon_sym_R_DQUOTE] = ACTIONS(3458),
    [anon_sym_LR_DQUOTE] = ACTIONS(3458),
    [anon_sym_uR_DQUOTE] = ACTIONS(3458),
    [anon_sym_UR_DQUOTE] = ACTIONS(3458),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3458),
    [anon_sym_co_await] = ACTIONS(3460),
    [anon_sym_new] = ACTIONS(3460),
    [anon_sym_requires] = ACTIONS(3460),
    [sym_this] = ACTIONS(3460),
    [anon_sym_discard] = ACTIONS(3460),
    [anon_sym_precise] = ACTIONS(3460),
    [anon_sym_shared] = ACTIONS(3460),
    [anon_sym_groupshared] = ACTIONS(3460),
    [anon_sym_uniform] = ACTIONS(3460),
    [anon_sym_row_major] = ACTIONS(3460),
    [anon_sym_column_major] = ACTIONS(3460),
    [anon_sym_globallycoherent] = ACTIONS(3460),
    [anon_sym_centroid] = ACTIONS(3460),
    [anon_sym_noperspective] = ACTIONS(3460),
    [anon_sym_nointerpolation] = ACTIONS(3460),
    [anon_sym_sample] = ACTIONS(3460),
    [anon_sym_linear] = ACTIONS(3460),
    [anon_sym_snorm] = ACTIONS(3460),
    [anon_sym_unorm] = ACTIONS(3460),
    [anon_sym_point] = ACTIONS(3460),
    [anon_sym_line] = ACTIONS(3460),
    [anon_sym_triangleadj] = ACTIONS(3460),
    [anon_sym_lineadj] = ACTIONS(3460),
    [anon_sym_triangle] = ACTIONS(3460),
    [anon_sym_cbuffer] = ACTIONS(3460),
    [anon_sym_interface] = ACTIONS(3460),
    [anon_sym_extension] = ACTIONS(3460),
  },
  [804] = {
    [sym_identifier] = ACTIONS(3581),
    [aux_sym_preproc_include_token1] = ACTIONS(3581),
    [aux_sym_preproc_def_token1] = ACTIONS(3581),
    [aux_sym_preproc_if_token1] = ACTIONS(3581),
    [aux_sym_preproc_if_token2] = ACTIONS(3581),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3581),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3581),
    [sym_preproc_directive] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(3579),
    [anon_sym_BANG] = ACTIONS(3579),
    [anon_sym_TILDE] = ACTIONS(3579),
    [anon_sym_DASH] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3581),
    [anon_sym_STAR] = ACTIONS(3579),
    [anon_sym_AMP_AMP] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3581),
    [anon_sym_SEMI] = ACTIONS(3579),
    [anon_sym___extension__] = ACTIONS(3581),
    [anon_sym_typedef] = ACTIONS(3581),
    [anon_sym_in] = ACTIONS(3581),
    [anon_sym_out] = ACTIONS(3581),
    [anon_sym_inout] = ACTIONS(3581),
    [anon_sym_virtual] = ACTIONS(3581),
    [anon_sym_extern] = ACTIONS(3581),
    [anon_sym___attribute__] = ACTIONS(3581),
    [anon_sym___attribute] = ACTIONS(3581),
    [anon_sym_using] = ACTIONS(3581),
    [anon_sym_COLON_COLON] = ACTIONS(3579),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3579),
    [anon_sym___declspec] = ACTIONS(3581),
    [anon_sym___based] = ACTIONS(3581),
    [anon_sym___cdecl] = ACTIONS(3581),
    [anon_sym___clrcall] = ACTIONS(3581),
    [anon_sym___stdcall] = ACTIONS(3581),
    [anon_sym___fastcall] = ACTIONS(3581),
    [anon_sym___thiscall] = ACTIONS(3581),
    [anon_sym___vectorcall] = ACTIONS(3581),
    [anon_sym_LBRACE] = ACTIONS(3579),
    [anon_sym_signed] = ACTIONS(3581),
    [anon_sym_unsigned] = ACTIONS(3581),
    [anon_sym_long] = ACTIONS(3581),
    [anon_sym_short] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_static] = ACTIONS(3581),
    [anon_sym_register] = ACTIONS(3581),
    [anon_sym_inline] = ACTIONS(3581),
    [anon_sym___inline] = ACTIONS(3581),
    [anon_sym___inline__] = ACTIONS(3581),
    [anon_sym___forceinline] = ACTIONS(3581),
    [anon_sym_thread_local] = ACTIONS(3581),
    [anon_sym___thread] = ACTIONS(3581),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_constexpr] = ACTIONS(3581),
    [anon_sym_volatile] = ACTIONS(3581),
    [anon_sym_restrict] = ACTIONS(3581),
    [anon_sym___restrict__] = ACTIONS(3581),
    [anon_sym__Atomic] = ACTIONS(3581),
    [anon_sym__Noreturn] = ACTIONS(3581),
    [anon_sym_noreturn] = ACTIONS(3581),
    [anon_sym__Nonnull] = ACTIONS(3581),
    [anon_sym_mutable] = ACTIONS(3581),
    [anon_sym_constinit] = ACTIONS(3581),
    [anon_sym_consteval] = ACTIONS(3581),
    [anon_sym_alignas] = ACTIONS(3581),
    [anon_sym__Alignas] = ACTIONS(3581),
    [sym_primitive_type] = ACTIONS(3581),
    [anon_sym_enum] = ACTIONS(3581),
    [anon_sym_class] = ACTIONS(3581),
    [anon_sym_struct] = ACTIONS(3581),
    [anon_sym_union] = ACTIONS(3581),
    [anon_sym_if] = ACTIONS(3581),
    [anon_sym_else] = ACTIONS(3581),
    [anon_sym_switch] = ACTIONS(3581),
    [anon_sym_case] = ACTIONS(3581),
    [anon_sym_default] = ACTIONS(3581),
    [anon_sym_while] = ACTIONS(3581),
    [anon_sym_do] = ACTIONS(3581),
    [anon_sym_for] = ACTIONS(3581),
    [anon_sym_return] = ACTIONS(3581),
    [anon_sym_break] = ACTIONS(3581),
    [anon_sym_continue] = ACTIONS(3581),
    [anon_sym_goto] = ACTIONS(3581),
    [anon_sym___try] = ACTIONS(3581),
    [anon_sym___leave] = ACTIONS(3581),
    [anon_sym_not] = ACTIONS(3581),
    [anon_sym_compl] = ACTIONS(3581),
    [anon_sym_DASH_DASH] = ACTIONS(3579),
    [anon_sym_PLUS_PLUS] = ACTIONS(3579),
    [anon_sym_sizeof] = ACTIONS(3581),
    [anon_sym___alignof__] = ACTIONS(3581),
    [anon_sym___alignof] = ACTIONS(3581),
    [anon_sym__alignof] = ACTIONS(3581),
    [anon_sym_alignof] = ACTIONS(3581),
    [anon_sym__Alignof] = ACTIONS(3581),
    [anon_sym_offsetof] = ACTIONS(3581),
    [anon_sym__Generic] = ACTIONS(3581),
    [anon_sym_asm] = ACTIONS(3581),
    [anon_sym___asm__] = ACTIONS(3581),
    [anon_sym___asm] = ACTIONS(3581),
    [sym_number_literal] = ACTIONS(3579),
    [anon_sym_L_SQUOTE] = ACTIONS(3579),
    [anon_sym_u_SQUOTE] = ACTIONS(3579),
    [anon_sym_U_SQUOTE] = ACTIONS(3579),
    [anon_sym_u8_SQUOTE] = ACTIONS(3579),
    [anon_sym_SQUOTE] = ACTIONS(3579),
    [anon_sym_L_DQUOTE] = ACTIONS(3579),
    [anon_sym_u_DQUOTE] = ACTIONS(3579),
    [anon_sym_U_DQUOTE] = ACTIONS(3579),
    [anon_sym_u8_DQUOTE] = ACTIONS(3579),
    [anon_sym_DQUOTE] = ACTIONS(3579),
    [sym_true] = ACTIONS(3581),
    [sym_false] = ACTIONS(3581),
    [anon_sym_NULL] = ACTIONS(3581),
    [anon_sym_nullptr] = ACTIONS(3581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_This] = ACTIONS(3581),
    [anon_sym_decltype] = ACTIONS(3581),
    [anon_sym_explicit] = ACTIONS(3581),
    [anon_sym_typename] = ACTIONS(3581),
    [anon_sym_template] = ACTIONS(3581),
    [anon_sym_operator] = ACTIONS(3581),
    [anon_sym_try] = ACTIONS(3581),
    [anon_sym_delete] = ACTIONS(3581),
    [anon_sym_throw] = ACTIONS(3581),
    [anon_sym_namespace] = ACTIONS(3581),
    [anon_sym_static_assert] = ACTIONS(3581),
    [anon_sym_concept] = ACTIONS(3581),
    [anon_sym_co_return] = ACTIONS(3581),
    [anon_sym_co_yield] = ACTIONS(3581),
    [anon_sym_R_DQUOTE] = ACTIONS(3579),
    [anon_sym_LR_DQUOTE] = ACTIONS(3579),
    [anon_sym_uR_DQUOTE] = ACTIONS(3579),
    [anon_sym_UR_DQUOTE] = ACTIONS(3579),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3579),
    [anon_sym_co_await] = ACTIONS(3581),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_requires] = ACTIONS(3581),
    [sym_this] = ACTIONS(3581),
    [anon_sym_discard] = ACTIONS(3581),
    [anon_sym_precise] = ACTIONS(3581),
    [anon_sym_shared] = ACTIONS(3581),
    [anon_sym_groupshared] = ACTIONS(3581),
    [anon_sym_uniform] = ACTIONS(3581),
    [anon_sym_row_major] = ACTIONS(3581),
    [anon_sym_column_major] = ACTIONS(3581),
    [anon_sym_globallycoherent] = ACTIONS(3581),
    [anon_sym_centroid] = ACTIONS(3581),
    [anon_sym_noperspective] = ACTIONS(3581),
    [anon_sym_nointerpolation] = ACTIONS(3581),
    [anon_sym_sample] = ACTIONS(3581),
    [anon_sym_linear] = ACTIONS(3581),
    [anon_sym_snorm] = ACTIONS(3581),
    [anon_sym_unorm] = ACTIONS(3581),
    [anon_sym_point] = ACTIONS(3581),
    [anon_sym_line] = ACTIONS(3581),
    [anon_sym_triangleadj] = ACTIONS(3581),
    [anon_sym_lineadj] = ACTIONS(3581),
    [anon_sym_triangle] = ACTIONS(3581),
    [anon_sym_cbuffer] = ACTIONS(3581),
    [anon_sym_interface] = ACTIONS(3581),
    [anon_sym_extension] = ACTIONS(3581),
  },
  [805] = {
    [sym_identifier] = ACTIONS(3591),
    [aux_sym_preproc_include_token1] = ACTIONS(3591),
    [aux_sym_preproc_def_token1] = ACTIONS(3591),
    [aux_sym_preproc_if_token1] = ACTIONS(3591),
    [aux_sym_preproc_if_token2] = ACTIONS(3591),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3591),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3591),
    [sym_preproc_directive] = ACTIONS(3591),
    [anon_sym_LPAREN2] = ACTIONS(3589),
    [anon_sym_BANG] = ACTIONS(3589),
    [anon_sym_TILDE] = ACTIONS(3589),
    [anon_sym_DASH] = ACTIONS(3591),
    [anon_sym_PLUS] = ACTIONS(3591),
    [anon_sym_STAR] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(3589),
    [anon_sym___extension__] = ACTIONS(3591),
    [anon_sym_typedef] = ACTIONS(3591),
    [anon_sym_in] = ACTIONS(3591),
    [anon_sym_out] = ACTIONS(3591),
    [anon_sym_inout] = ACTIONS(3591),
    [anon_sym_virtual] = ACTIONS(3591),
    [anon_sym_extern] = ACTIONS(3591),
    [anon_sym___attribute__] = ACTIONS(3591),
    [anon_sym___attribute] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3591),
    [anon_sym_COLON_COLON] = ACTIONS(3589),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3589),
    [anon_sym___declspec] = ACTIONS(3591),
    [anon_sym___based] = ACTIONS(3591),
    [anon_sym___cdecl] = ACTIONS(3591),
    [anon_sym___clrcall] = ACTIONS(3591),
    [anon_sym___stdcall] = ACTIONS(3591),
    [anon_sym___fastcall] = ACTIONS(3591),
    [anon_sym___thiscall] = ACTIONS(3591),
    [anon_sym___vectorcall] = ACTIONS(3591),
    [anon_sym_LBRACE] = ACTIONS(3589),
    [anon_sym_signed] = ACTIONS(3591),
    [anon_sym_unsigned] = ACTIONS(3591),
    [anon_sym_long] = ACTIONS(3591),
    [anon_sym_short] = ACTIONS(3591),
    [anon_sym_LBRACK] = ACTIONS(3591),
    [anon_sym_static] = ACTIONS(3591),
    [anon_sym_register] = ACTIONS(3591),
    [anon_sym_inline] = ACTIONS(3591),
    [anon_sym___inline] = ACTIONS(3591),
    [anon_sym___inline__] = ACTIONS(3591),
    [anon_sym___forceinline] = ACTIONS(3591),
    [anon_sym_thread_local] = ACTIONS(3591),
    [anon_sym___thread] = ACTIONS(3591),
    [anon_sym_const] = ACTIONS(3591),
    [anon_sym_constexpr] = ACTIONS(3591),
    [anon_sym_volatile] = ACTIONS(3591),
    [anon_sym_restrict] = ACTIONS(3591),
    [anon_sym___restrict__] = ACTIONS(3591),
    [anon_sym__Atomic] = ACTIONS(3591),
    [anon_sym__Noreturn] = ACTIONS(3591),
    [anon_sym_noreturn] = ACTIONS(3591),
    [anon_sym__Nonnull] = ACTIONS(3591),
    [anon_sym_mutable] = ACTIONS(3591),
    [anon_sym_constinit] = ACTIONS(3591),
    [anon_sym_consteval] = ACTIONS(3591),
    [anon_sym_alignas] = ACTIONS(3591),
    [anon_sym__Alignas] = ACTIONS(3591),
    [sym_primitive_type] = ACTIONS(3591),
    [anon_sym_enum] = ACTIONS(3591),
    [anon_sym_class] = ACTIONS(3591),
    [anon_sym_struct] = ACTIONS(3591),
    [anon_sym_union] = ACTIONS(3591),
    [anon_sym_if] = ACTIONS(3591),
    [anon_sym_else] = ACTIONS(3591),
    [anon_sym_switch] = ACTIONS(3591),
    [anon_sym_case] = ACTIONS(3591),
    [anon_sym_default] = ACTIONS(3591),
    [anon_sym_while] = ACTIONS(3591),
    [anon_sym_do] = ACTIONS(3591),
    [anon_sym_for] = ACTIONS(3591),
    [anon_sym_return] = ACTIONS(3591),
    [anon_sym_break] = ACTIONS(3591),
    [anon_sym_continue] = ACTIONS(3591),
    [anon_sym_goto] = ACTIONS(3591),
    [anon_sym___try] = ACTIONS(3591),
    [anon_sym___leave] = ACTIONS(3591),
    [anon_sym_not] = ACTIONS(3591),
    [anon_sym_compl] = ACTIONS(3591),
    [anon_sym_DASH_DASH] = ACTIONS(3589),
    [anon_sym_PLUS_PLUS] = ACTIONS(3589),
    [anon_sym_sizeof] = ACTIONS(3591),
    [anon_sym___alignof__] = ACTIONS(3591),
    [anon_sym___alignof] = ACTIONS(3591),
    [anon_sym__alignof] = ACTIONS(3591),
    [anon_sym_alignof] = ACTIONS(3591),
    [anon_sym__Alignof] = ACTIONS(3591),
    [anon_sym_offsetof] = ACTIONS(3591),
    [anon_sym__Generic] = ACTIONS(3591),
    [anon_sym_asm] = ACTIONS(3591),
    [anon_sym___asm__] = ACTIONS(3591),
    [anon_sym___asm] = ACTIONS(3591),
    [sym_number_literal] = ACTIONS(3589),
    [anon_sym_L_SQUOTE] = ACTIONS(3589),
    [anon_sym_u_SQUOTE] = ACTIONS(3589),
    [anon_sym_U_SQUOTE] = ACTIONS(3589),
    [anon_sym_u8_SQUOTE] = ACTIONS(3589),
    [anon_sym_SQUOTE] = ACTIONS(3589),
    [anon_sym_L_DQUOTE] = ACTIONS(3589),
    [anon_sym_u_DQUOTE] = ACTIONS(3589),
    [anon_sym_U_DQUOTE] = ACTIONS(3589),
    [anon_sym_u8_DQUOTE] = ACTIONS(3589),
    [anon_sym_DQUOTE] = ACTIONS(3589),
    [sym_true] = ACTIONS(3591),
    [sym_false] = ACTIONS(3591),
    [anon_sym_NULL] = ACTIONS(3591),
    [anon_sym_nullptr] = ACTIONS(3591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3591),
    [anon_sym_let] = ACTIONS(3591),
    [anon_sym_This] = ACTIONS(3591),
    [anon_sym_decltype] = ACTIONS(3591),
    [anon_sym_explicit] = ACTIONS(3591),
    [anon_sym_typename] = ACTIONS(3591),
    [anon_sym_template] = ACTIONS(3591),
    [anon_sym_operator] = ACTIONS(3591),
    [anon_sym_try] = ACTIONS(3591),
    [anon_sym_delete] = ACTIONS(3591),
    [anon_sym_throw] = ACTIONS(3591),
    [anon_sym_namespace] = ACTIONS(3591),
    [anon_sym_static_assert] = ACTIONS(3591),
    [anon_sym_concept] = ACTIONS(3591),
    [anon_sym_co_return] = ACTIONS(3591),
    [anon_sym_co_yield] = ACTIONS(3591),
    [anon_sym_R_DQUOTE] = ACTIONS(3589),
    [anon_sym_LR_DQUOTE] = ACTIONS(3589),
    [anon_sym_uR_DQUOTE] = ACTIONS(3589),
    [anon_sym_UR_DQUOTE] = ACTIONS(3589),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3589),
    [anon_sym_co_await] = ACTIONS(3591),
    [anon_sym_new] = ACTIONS(3591),
    [anon_sym_requires] = ACTIONS(3591),
    [sym_this] = ACTIONS(3591),
    [anon_sym_discard] = ACTIONS(3591),
    [anon_sym_precise] = ACTIONS(3591),
    [anon_sym_shared] = ACTIONS(3591),
    [anon_sym_groupshared] = ACTIONS(3591),
    [anon_sym_uniform] = ACTIONS(3591),
    [anon_sym_row_major] = ACTIONS(3591),
    [anon_sym_column_major] = ACTIONS(3591),
    [anon_sym_globallycoherent] = ACTIONS(3591),
    [anon_sym_centroid] = ACTIONS(3591),
    [anon_sym_noperspective] = ACTIONS(3591),
    [anon_sym_nointerpolation] = ACTIONS(3591),
    [anon_sym_sample] = ACTIONS(3591),
    [anon_sym_linear] = ACTIONS(3591),
    [anon_sym_snorm] = ACTIONS(3591),
    [anon_sym_unorm] = ACTIONS(3591),
    [anon_sym_point] = ACTIONS(3591),
    [anon_sym_line] = ACTIONS(3591),
    [anon_sym_triangleadj] = ACTIONS(3591),
    [anon_sym_lineadj] = ACTIONS(3591),
    [anon_sym_triangle] = ACTIONS(3591),
    [anon_sym_cbuffer] = ACTIONS(3591),
    [anon_sym_interface] = ACTIONS(3591),
    [anon_sym_extension] = ACTIONS(3591),
  },
  [806] = {
    [sym_identifier] = ACTIONS(3603),
    [aux_sym_preproc_include_token1] = ACTIONS(3603),
    [aux_sym_preproc_def_token1] = ACTIONS(3603),
    [aux_sym_preproc_if_token1] = ACTIONS(3603),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3603),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3603),
    [sym_preproc_directive] = ACTIONS(3603),
    [anon_sym_LPAREN2] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3601),
    [anon_sym_TILDE] = ACTIONS(3601),
    [anon_sym_DASH] = ACTIONS(3603),
    [anon_sym_PLUS] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(3601),
    [anon_sym_AMP_AMP] = ACTIONS(3601),
    [anon_sym_AMP] = ACTIONS(3603),
    [anon_sym_SEMI] = ACTIONS(3601),
    [anon_sym___extension__] = ACTIONS(3603),
    [anon_sym_typedef] = ACTIONS(3603),
    [anon_sym_in] = ACTIONS(3603),
    [anon_sym_out] = ACTIONS(3603),
    [anon_sym_inout] = ACTIONS(3603),
    [anon_sym_virtual] = ACTIONS(3603),
    [anon_sym_extern] = ACTIONS(3603),
    [anon_sym___attribute__] = ACTIONS(3603),
    [anon_sym___attribute] = ACTIONS(3603),
    [anon_sym_using] = ACTIONS(3603),
    [anon_sym_COLON_COLON] = ACTIONS(3601),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3601),
    [anon_sym___declspec] = ACTIONS(3603),
    [anon_sym___based] = ACTIONS(3603),
    [anon_sym___cdecl] = ACTIONS(3603),
    [anon_sym___clrcall] = ACTIONS(3603),
    [anon_sym___stdcall] = ACTIONS(3603),
    [anon_sym___fastcall] = ACTIONS(3603),
    [anon_sym___thiscall] = ACTIONS(3603),
    [anon_sym___vectorcall] = ACTIONS(3603),
    [anon_sym_LBRACE] = ACTIONS(3601),
    [anon_sym_RBRACE] = ACTIONS(3601),
    [anon_sym_signed] = ACTIONS(3603),
    [anon_sym_unsigned] = ACTIONS(3603),
    [anon_sym_long] = ACTIONS(3603),
    [anon_sym_short] = ACTIONS(3603),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_static] = ACTIONS(3603),
    [anon_sym_register] = ACTIONS(3603),
    [anon_sym_inline] = ACTIONS(3603),
    [anon_sym___inline] = ACTIONS(3603),
    [anon_sym___inline__] = ACTIONS(3603),
    [anon_sym___forceinline] = ACTIONS(3603),
    [anon_sym_thread_local] = ACTIONS(3603),
    [anon_sym___thread] = ACTIONS(3603),
    [anon_sym_const] = ACTIONS(3603),
    [anon_sym_constexpr] = ACTIONS(3603),
    [anon_sym_volatile] = ACTIONS(3603),
    [anon_sym_restrict] = ACTIONS(3603),
    [anon_sym___restrict__] = ACTIONS(3603),
    [anon_sym__Atomic] = ACTIONS(3603),
    [anon_sym__Noreturn] = ACTIONS(3603),
    [anon_sym_noreturn] = ACTIONS(3603),
    [anon_sym__Nonnull] = ACTIONS(3603),
    [anon_sym_mutable] = ACTIONS(3603),
    [anon_sym_constinit] = ACTIONS(3603),
    [anon_sym_consteval] = ACTIONS(3603),
    [anon_sym_alignas] = ACTIONS(3603),
    [anon_sym__Alignas] = ACTIONS(3603),
    [sym_primitive_type] = ACTIONS(3603),
    [anon_sym_enum] = ACTIONS(3603),
    [anon_sym_class] = ACTIONS(3603),
    [anon_sym_struct] = ACTIONS(3603),
    [anon_sym_union] = ACTIONS(3603),
    [anon_sym_if] = ACTIONS(3603),
    [anon_sym_else] = ACTIONS(3603),
    [anon_sym_switch] = ACTIONS(3603),
    [anon_sym_case] = ACTIONS(3603),
    [anon_sym_default] = ACTIONS(3603),
    [anon_sym_while] = ACTIONS(3603),
    [anon_sym_do] = ACTIONS(3603),
    [anon_sym_for] = ACTIONS(3603),
    [anon_sym_return] = ACTIONS(3603),
    [anon_sym_break] = ACTIONS(3603),
    [anon_sym_continue] = ACTIONS(3603),
    [anon_sym_goto] = ACTIONS(3603),
    [anon_sym___try] = ACTIONS(3603),
    [anon_sym___leave] = ACTIONS(3603),
    [anon_sym_not] = ACTIONS(3603),
    [anon_sym_compl] = ACTIONS(3603),
    [anon_sym_DASH_DASH] = ACTIONS(3601),
    [anon_sym_PLUS_PLUS] = ACTIONS(3601),
    [anon_sym_sizeof] = ACTIONS(3603),
    [anon_sym___alignof__] = ACTIONS(3603),
    [anon_sym___alignof] = ACTIONS(3603),
    [anon_sym__alignof] = ACTIONS(3603),
    [anon_sym_alignof] = ACTIONS(3603),
    [anon_sym__Alignof] = ACTIONS(3603),
    [anon_sym_offsetof] = ACTIONS(3603),
    [anon_sym__Generic] = ACTIONS(3603),
    [anon_sym_asm] = ACTIONS(3603),
    [anon_sym___asm__] = ACTIONS(3603),
    [anon_sym___asm] = ACTIONS(3603),
    [sym_number_literal] = ACTIONS(3601),
    [anon_sym_L_SQUOTE] = ACTIONS(3601),
    [anon_sym_u_SQUOTE] = ACTIONS(3601),
    [anon_sym_U_SQUOTE] = ACTIONS(3601),
    [anon_sym_u8_SQUOTE] = ACTIONS(3601),
    [anon_sym_SQUOTE] = ACTIONS(3601),
    [anon_sym_L_DQUOTE] = ACTIONS(3601),
    [anon_sym_u_DQUOTE] = ACTIONS(3601),
    [anon_sym_U_DQUOTE] = ACTIONS(3601),
    [anon_sym_u8_DQUOTE] = ACTIONS(3601),
    [anon_sym_DQUOTE] = ACTIONS(3601),
    [sym_true] = ACTIONS(3603),
    [sym_false] = ACTIONS(3603),
    [anon_sym_NULL] = ACTIONS(3603),
    [anon_sym_nullptr] = ACTIONS(3603),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3603),
    [anon_sym_let] = ACTIONS(3603),
    [anon_sym_This] = ACTIONS(3603),
    [anon_sym_decltype] = ACTIONS(3603),
    [anon_sym_explicit] = ACTIONS(3603),
    [anon_sym_typename] = ACTIONS(3603),
    [anon_sym_template] = ACTIONS(3603),
    [anon_sym_operator] = ACTIONS(3603),
    [anon_sym_try] = ACTIONS(3603),
    [anon_sym_delete] = ACTIONS(3603),
    [anon_sym_throw] = ACTIONS(3603),
    [anon_sym_namespace] = ACTIONS(3603),
    [anon_sym_static_assert] = ACTIONS(3603),
    [anon_sym_concept] = ACTIONS(3603),
    [anon_sym_co_return] = ACTIONS(3603),
    [anon_sym_co_yield] = ACTIONS(3603),
    [anon_sym_R_DQUOTE] = ACTIONS(3601),
    [anon_sym_LR_DQUOTE] = ACTIONS(3601),
    [anon_sym_uR_DQUOTE] = ACTIONS(3601),
    [anon_sym_UR_DQUOTE] = ACTIONS(3601),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3601),
    [anon_sym_co_await] = ACTIONS(3603),
    [anon_sym_new] = ACTIONS(3603),
    [anon_sym_requires] = ACTIONS(3603),
    [sym_this] = ACTIONS(3603),
    [anon_sym_discard] = ACTIONS(3603),
    [anon_sym_precise] = ACTIONS(3603),
    [anon_sym_shared] = ACTIONS(3603),
    [anon_sym_groupshared] = ACTIONS(3603),
    [anon_sym_uniform] = ACTIONS(3603),
    [anon_sym_row_major] = ACTIONS(3603),
    [anon_sym_column_major] = ACTIONS(3603),
    [anon_sym_globallycoherent] = ACTIONS(3603),
    [anon_sym_centroid] = ACTIONS(3603),
    [anon_sym_noperspective] = ACTIONS(3603),
    [anon_sym_nointerpolation] = ACTIONS(3603),
    [anon_sym_sample] = ACTIONS(3603),
    [anon_sym_linear] = ACTIONS(3603),
    [anon_sym_snorm] = ACTIONS(3603),
    [anon_sym_unorm] = ACTIONS(3603),
    [anon_sym_point] = ACTIONS(3603),
    [anon_sym_line] = ACTIONS(3603),
    [anon_sym_triangleadj] = ACTIONS(3603),
    [anon_sym_lineadj] = ACTIONS(3603),
    [anon_sym_triangle] = ACTIONS(3603),
    [anon_sym_cbuffer] = ACTIONS(3603),
    [anon_sym_interface] = ACTIONS(3603),
    [anon_sym_extension] = ACTIONS(3603),
  },
  [807] = {
    [sym_identifier] = ACTIONS(3448),
    [aux_sym_preproc_include_token1] = ACTIONS(3448),
    [aux_sym_preproc_def_token1] = ACTIONS(3448),
    [aux_sym_preproc_if_token1] = ACTIONS(3448),
    [aux_sym_preproc_if_token2] = ACTIONS(3448),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3448),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3448),
    [sym_preproc_directive] = ACTIONS(3448),
    [anon_sym_LPAREN2] = ACTIONS(3446),
    [anon_sym_BANG] = ACTIONS(3446),
    [anon_sym_TILDE] = ACTIONS(3446),
    [anon_sym_DASH] = ACTIONS(3448),
    [anon_sym_PLUS] = ACTIONS(3448),
    [anon_sym_STAR] = ACTIONS(3446),
    [anon_sym_AMP_AMP] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3448),
    [anon_sym_SEMI] = ACTIONS(3446),
    [anon_sym___extension__] = ACTIONS(3448),
    [anon_sym_typedef] = ACTIONS(3448),
    [anon_sym_in] = ACTIONS(3448),
    [anon_sym_out] = ACTIONS(3448),
    [anon_sym_inout] = ACTIONS(3448),
    [anon_sym_virtual] = ACTIONS(3448),
    [anon_sym_extern] = ACTIONS(3448),
    [anon_sym___attribute__] = ACTIONS(3448),
    [anon_sym___attribute] = ACTIONS(3448),
    [anon_sym_using] = ACTIONS(3448),
    [anon_sym_COLON_COLON] = ACTIONS(3446),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3446),
    [anon_sym___declspec] = ACTIONS(3448),
    [anon_sym___based] = ACTIONS(3448),
    [anon_sym___cdecl] = ACTIONS(3448),
    [anon_sym___clrcall] = ACTIONS(3448),
    [anon_sym___stdcall] = ACTIONS(3448),
    [anon_sym___fastcall] = ACTIONS(3448),
    [anon_sym___thiscall] = ACTIONS(3448),
    [anon_sym___vectorcall] = ACTIONS(3448),
    [anon_sym_LBRACE] = ACTIONS(3446),
    [anon_sym_signed] = ACTIONS(3448),
    [anon_sym_unsigned] = ACTIONS(3448),
    [anon_sym_long] = ACTIONS(3448),
    [anon_sym_short] = ACTIONS(3448),
    [anon_sym_LBRACK] = ACTIONS(3448),
    [anon_sym_static] = ACTIONS(3448),
    [anon_sym_register] = ACTIONS(3448),
    [anon_sym_inline] = ACTIONS(3448),
    [anon_sym___inline] = ACTIONS(3448),
    [anon_sym___inline__] = ACTIONS(3448),
    [anon_sym___forceinline] = ACTIONS(3448),
    [anon_sym_thread_local] = ACTIONS(3448),
    [anon_sym___thread] = ACTIONS(3448),
    [anon_sym_const] = ACTIONS(3448),
    [anon_sym_constexpr] = ACTIONS(3448),
    [anon_sym_volatile] = ACTIONS(3448),
    [anon_sym_restrict] = ACTIONS(3448),
    [anon_sym___restrict__] = ACTIONS(3448),
    [anon_sym__Atomic] = ACTIONS(3448),
    [anon_sym__Noreturn] = ACTIONS(3448),
    [anon_sym_noreturn] = ACTIONS(3448),
    [anon_sym__Nonnull] = ACTIONS(3448),
    [anon_sym_mutable] = ACTIONS(3448),
    [anon_sym_constinit] = ACTIONS(3448),
    [anon_sym_consteval] = ACTIONS(3448),
    [anon_sym_alignas] = ACTIONS(3448),
    [anon_sym__Alignas] = ACTIONS(3448),
    [sym_primitive_type] = ACTIONS(3448),
    [anon_sym_enum] = ACTIONS(3448),
    [anon_sym_class] = ACTIONS(3448),
    [anon_sym_struct] = ACTIONS(3448),
    [anon_sym_union] = ACTIONS(3448),
    [anon_sym_if] = ACTIONS(3448),
    [anon_sym_else] = ACTIONS(3448),
    [anon_sym_switch] = ACTIONS(3448),
    [anon_sym_case] = ACTIONS(3448),
    [anon_sym_default] = ACTIONS(3448),
    [anon_sym_while] = ACTIONS(3448),
    [anon_sym_do] = ACTIONS(3448),
    [anon_sym_for] = ACTIONS(3448),
    [anon_sym_return] = ACTIONS(3448),
    [anon_sym_break] = ACTIONS(3448),
    [anon_sym_continue] = ACTIONS(3448),
    [anon_sym_goto] = ACTIONS(3448),
    [anon_sym___try] = ACTIONS(3448),
    [anon_sym___leave] = ACTIONS(3448),
    [anon_sym_not] = ACTIONS(3448),
    [anon_sym_compl] = ACTIONS(3448),
    [anon_sym_DASH_DASH] = ACTIONS(3446),
    [anon_sym_PLUS_PLUS] = ACTIONS(3446),
    [anon_sym_sizeof] = ACTIONS(3448),
    [anon_sym___alignof__] = ACTIONS(3448),
    [anon_sym___alignof] = ACTIONS(3448),
    [anon_sym__alignof] = ACTIONS(3448),
    [anon_sym_alignof] = ACTIONS(3448),
    [anon_sym__Alignof] = ACTIONS(3448),
    [anon_sym_offsetof] = ACTIONS(3448),
    [anon_sym__Generic] = ACTIONS(3448),
    [anon_sym_asm] = ACTIONS(3448),
    [anon_sym___asm__] = ACTIONS(3448),
    [anon_sym___asm] = ACTIONS(3448),
    [sym_number_literal] = ACTIONS(3446),
    [anon_sym_L_SQUOTE] = ACTIONS(3446),
    [anon_sym_u_SQUOTE] = ACTIONS(3446),
    [anon_sym_U_SQUOTE] = ACTIONS(3446),
    [anon_sym_u8_SQUOTE] = ACTIONS(3446),
    [anon_sym_SQUOTE] = ACTIONS(3446),
    [anon_sym_L_DQUOTE] = ACTIONS(3446),
    [anon_sym_u_DQUOTE] = ACTIONS(3446),
    [anon_sym_U_DQUOTE] = ACTIONS(3446),
    [anon_sym_u8_DQUOTE] = ACTIONS(3446),
    [anon_sym_DQUOTE] = ACTIONS(3446),
    [sym_true] = ACTIONS(3448),
    [sym_false] = ACTIONS(3448),
    [anon_sym_NULL] = ACTIONS(3448),
    [anon_sym_nullptr] = ACTIONS(3448),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3448),
    [anon_sym_let] = ACTIONS(3448),
    [anon_sym_This] = ACTIONS(3448),
    [anon_sym_decltype] = ACTIONS(3448),
    [anon_sym_explicit] = ACTIONS(3448),
    [anon_sym_typename] = ACTIONS(3448),
    [anon_sym_template] = ACTIONS(3448),
    [anon_sym_operator] = ACTIONS(3448),
    [anon_sym_try] = ACTIONS(3448),
    [anon_sym_delete] = ACTIONS(3448),
    [anon_sym_throw] = ACTIONS(3448),
    [anon_sym_namespace] = ACTIONS(3448),
    [anon_sym_static_assert] = ACTIONS(3448),
    [anon_sym_concept] = ACTIONS(3448),
    [anon_sym_co_return] = ACTIONS(3448),
    [anon_sym_co_yield] = ACTIONS(3448),
    [anon_sym_R_DQUOTE] = ACTIONS(3446),
    [anon_sym_LR_DQUOTE] = ACTIONS(3446),
    [anon_sym_uR_DQUOTE] = ACTIONS(3446),
    [anon_sym_UR_DQUOTE] = ACTIONS(3446),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3446),
    [anon_sym_co_await] = ACTIONS(3448),
    [anon_sym_new] = ACTIONS(3448),
    [anon_sym_requires] = ACTIONS(3448),
    [sym_this] = ACTIONS(3448),
    [anon_sym_discard] = ACTIONS(3448),
    [anon_sym_precise] = ACTIONS(3448),
    [anon_sym_shared] = ACTIONS(3448),
    [anon_sym_groupshared] = ACTIONS(3448),
    [anon_sym_uniform] = ACTIONS(3448),
    [anon_sym_row_major] = ACTIONS(3448),
    [anon_sym_column_major] = ACTIONS(3448),
    [anon_sym_globallycoherent] = ACTIONS(3448),
    [anon_sym_centroid] = ACTIONS(3448),
    [anon_sym_noperspective] = ACTIONS(3448),
    [anon_sym_nointerpolation] = ACTIONS(3448),
    [anon_sym_sample] = ACTIONS(3448),
    [anon_sym_linear] = ACTIONS(3448),
    [anon_sym_snorm] = ACTIONS(3448),
    [anon_sym_unorm] = ACTIONS(3448),
    [anon_sym_point] = ACTIONS(3448),
    [anon_sym_line] = ACTIONS(3448),
    [anon_sym_triangleadj] = ACTIONS(3448),
    [anon_sym_lineadj] = ACTIONS(3448),
    [anon_sym_triangle] = ACTIONS(3448),
    [anon_sym_cbuffer] = ACTIONS(3448),
    [anon_sym_interface] = ACTIONS(3448),
    [anon_sym_extension] = ACTIONS(3448),
  },
  [808] = {
    [sym_identifier] = ACTIONS(3611),
    [aux_sym_preproc_include_token1] = ACTIONS(3611),
    [aux_sym_preproc_def_token1] = ACTIONS(3611),
    [aux_sym_preproc_if_token1] = ACTIONS(3611),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3611),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3611),
    [sym_preproc_directive] = ACTIONS(3611),
    [anon_sym_LPAREN2] = ACTIONS(3609),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3611),
    [anon_sym_PLUS] = ACTIONS(3611),
    [anon_sym_STAR] = ACTIONS(3609),
    [anon_sym_AMP_AMP] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(3611),
    [anon_sym_SEMI] = ACTIONS(3609),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_typedef] = ACTIONS(3611),
    [anon_sym_in] = ACTIONS(3611),
    [anon_sym_out] = ACTIONS(3611),
    [anon_sym_inout] = ACTIONS(3611),
    [anon_sym_virtual] = ACTIONS(3611),
    [anon_sym_extern] = ACTIONS(3611),
    [anon_sym___attribute__] = ACTIONS(3611),
    [anon_sym___attribute] = ACTIONS(3611),
    [anon_sym_using] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3609),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3609),
    [anon_sym___declspec] = ACTIONS(3611),
    [anon_sym___based] = ACTIONS(3611),
    [anon_sym___cdecl] = ACTIONS(3611),
    [anon_sym___clrcall] = ACTIONS(3611),
    [anon_sym___stdcall] = ACTIONS(3611),
    [anon_sym___fastcall] = ACTIONS(3611),
    [anon_sym___thiscall] = ACTIONS(3611),
    [anon_sym___vectorcall] = ACTIONS(3611),
    [anon_sym_LBRACE] = ACTIONS(3609),
    [anon_sym_RBRACE] = ACTIONS(3609),
    [anon_sym_signed] = ACTIONS(3611),
    [anon_sym_unsigned] = ACTIONS(3611),
    [anon_sym_long] = ACTIONS(3611),
    [anon_sym_short] = ACTIONS(3611),
    [anon_sym_LBRACK] = ACTIONS(3611),
    [anon_sym_static] = ACTIONS(3611),
    [anon_sym_register] = ACTIONS(3611),
    [anon_sym_inline] = ACTIONS(3611),
    [anon_sym___inline] = ACTIONS(3611),
    [anon_sym___inline__] = ACTIONS(3611),
    [anon_sym___forceinline] = ACTIONS(3611),
    [anon_sym_thread_local] = ACTIONS(3611),
    [anon_sym___thread] = ACTIONS(3611),
    [anon_sym_const] = ACTIONS(3611),
    [anon_sym_constexpr] = ACTIONS(3611),
    [anon_sym_volatile] = ACTIONS(3611),
    [anon_sym_restrict] = ACTIONS(3611),
    [anon_sym___restrict__] = ACTIONS(3611),
    [anon_sym__Atomic] = ACTIONS(3611),
    [anon_sym__Noreturn] = ACTIONS(3611),
    [anon_sym_noreturn] = ACTIONS(3611),
    [anon_sym__Nonnull] = ACTIONS(3611),
    [anon_sym_mutable] = ACTIONS(3611),
    [anon_sym_constinit] = ACTIONS(3611),
    [anon_sym_consteval] = ACTIONS(3611),
    [anon_sym_alignas] = ACTIONS(3611),
    [anon_sym__Alignas] = ACTIONS(3611),
    [sym_primitive_type] = ACTIONS(3611),
    [anon_sym_enum] = ACTIONS(3611),
    [anon_sym_class] = ACTIONS(3611),
    [anon_sym_struct] = ACTIONS(3611),
    [anon_sym_union] = ACTIONS(3611),
    [anon_sym_if] = ACTIONS(3611),
    [anon_sym_else] = ACTIONS(3611),
    [anon_sym_switch] = ACTIONS(3611),
    [anon_sym_case] = ACTIONS(3611),
    [anon_sym_default] = ACTIONS(3611),
    [anon_sym_while] = ACTIONS(3611),
    [anon_sym_do] = ACTIONS(3611),
    [anon_sym_for] = ACTIONS(3611),
    [anon_sym_return] = ACTIONS(3611),
    [anon_sym_break] = ACTIONS(3611),
    [anon_sym_continue] = ACTIONS(3611),
    [anon_sym_goto] = ACTIONS(3611),
    [anon_sym___try] = ACTIONS(3611),
    [anon_sym___leave] = ACTIONS(3611),
    [anon_sym_not] = ACTIONS(3611),
    [anon_sym_compl] = ACTIONS(3611),
    [anon_sym_DASH_DASH] = ACTIONS(3609),
    [anon_sym_PLUS_PLUS] = ACTIONS(3609),
    [anon_sym_sizeof] = ACTIONS(3611),
    [anon_sym___alignof__] = ACTIONS(3611),
    [anon_sym___alignof] = ACTIONS(3611),
    [anon_sym__alignof] = ACTIONS(3611),
    [anon_sym_alignof] = ACTIONS(3611),
    [anon_sym__Alignof] = ACTIONS(3611),
    [anon_sym_offsetof] = ACTIONS(3611),
    [anon_sym__Generic] = ACTIONS(3611),
    [anon_sym_asm] = ACTIONS(3611),
    [anon_sym___asm__] = ACTIONS(3611),
    [anon_sym___asm] = ACTIONS(3611),
    [sym_number_literal] = ACTIONS(3609),
    [anon_sym_L_SQUOTE] = ACTIONS(3609),
    [anon_sym_u_SQUOTE] = ACTIONS(3609),
    [anon_sym_U_SQUOTE] = ACTIONS(3609),
    [anon_sym_u8_SQUOTE] = ACTIONS(3609),
    [anon_sym_SQUOTE] = ACTIONS(3609),
    [anon_sym_L_DQUOTE] = ACTIONS(3609),
    [anon_sym_u_DQUOTE] = ACTIONS(3609),
    [anon_sym_U_DQUOTE] = ACTIONS(3609),
    [anon_sym_u8_DQUOTE] = ACTIONS(3609),
    [anon_sym_DQUOTE] = ACTIONS(3609),
    [sym_true] = ACTIONS(3611),
    [sym_false] = ACTIONS(3611),
    [anon_sym_NULL] = ACTIONS(3611),
    [anon_sym_nullptr] = ACTIONS(3611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3611),
    [anon_sym_let] = ACTIONS(3611),
    [anon_sym_This] = ACTIONS(3611),
    [anon_sym_decltype] = ACTIONS(3611),
    [anon_sym_explicit] = ACTIONS(3611),
    [anon_sym_typename] = ACTIONS(3611),
    [anon_sym_template] = ACTIONS(3611),
    [anon_sym_operator] = ACTIONS(3611),
    [anon_sym_try] = ACTIONS(3611),
    [anon_sym_delete] = ACTIONS(3611),
    [anon_sym_throw] = ACTIONS(3611),
    [anon_sym_namespace] = ACTIONS(3611),
    [anon_sym_static_assert] = ACTIONS(3611),
    [anon_sym_concept] = ACTIONS(3611),
    [anon_sym_co_return] = ACTIONS(3611),
    [anon_sym_co_yield] = ACTIONS(3611),
    [anon_sym_R_DQUOTE] = ACTIONS(3609),
    [anon_sym_LR_DQUOTE] = ACTIONS(3609),
    [anon_sym_uR_DQUOTE] = ACTIONS(3609),
    [anon_sym_UR_DQUOTE] = ACTIONS(3609),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3609),
    [anon_sym_co_await] = ACTIONS(3611),
    [anon_sym_new] = ACTIONS(3611),
    [anon_sym_requires] = ACTIONS(3611),
    [sym_this] = ACTIONS(3611),
    [anon_sym_discard] = ACTIONS(3611),
    [anon_sym_precise] = ACTIONS(3611),
    [anon_sym_shared] = ACTIONS(3611),
    [anon_sym_groupshared] = ACTIONS(3611),
    [anon_sym_uniform] = ACTIONS(3611),
    [anon_sym_row_major] = ACTIONS(3611),
    [anon_sym_column_major] = ACTIONS(3611),
    [anon_sym_globallycoherent] = ACTIONS(3611),
    [anon_sym_centroid] = ACTIONS(3611),
    [anon_sym_noperspective] = ACTIONS(3611),
    [anon_sym_nointerpolation] = ACTIONS(3611),
    [anon_sym_sample] = ACTIONS(3611),
    [anon_sym_linear] = ACTIONS(3611),
    [anon_sym_snorm] = ACTIONS(3611),
    [anon_sym_unorm] = ACTIONS(3611),
    [anon_sym_point] = ACTIONS(3611),
    [anon_sym_line] = ACTIONS(3611),
    [anon_sym_triangleadj] = ACTIONS(3611),
    [anon_sym_lineadj] = ACTIONS(3611),
    [anon_sym_triangle] = ACTIONS(3611),
    [anon_sym_cbuffer] = ACTIONS(3611),
    [anon_sym_interface] = ACTIONS(3611),
    [anon_sym_extension] = ACTIONS(3611),
  },
  [809] = {
    [sym_identifier] = ACTIONS(3615),
    [aux_sym_preproc_include_token1] = ACTIONS(3615),
    [aux_sym_preproc_def_token1] = ACTIONS(3615),
    [aux_sym_preproc_if_token1] = ACTIONS(3615),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3615),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3615),
    [sym_preproc_directive] = ACTIONS(3615),
    [anon_sym_LPAREN2] = ACTIONS(3613),
    [anon_sym_BANG] = ACTIONS(3613),
    [anon_sym_TILDE] = ACTIONS(3613),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3613),
    [anon_sym_AMP_AMP] = ACTIONS(3613),
    [anon_sym_AMP] = ACTIONS(3615),
    [anon_sym_SEMI] = ACTIONS(3613),
    [anon_sym___extension__] = ACTIONS(3615),
    [anon_sym_typedef] = ACTIONS(3615),
    [anon_sym_in] = ACTIONS(3615),
    [anon_sym_out] = ACTIONS(3615),
    [anon_sym_inout] = ACTIONS(3615),
    [anon_sym_virtual] = ACTIONS(3615),
    [anon_sym_extern] = ACTIONS(3615),
    [anon_sym___attribute__] = ACTIONS(3615),
    [anon_sym___attribute] = ACTIONS(3615),
    [anon_sym_using] = ACTIONS(3615),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3613),
    [anon_sym___declspec] = ACTIONS(3615),
    [anon_sym___based] = ACTIONS(3615),
    [anon_sym___cdecl] = ACTIONS(3615),
    [anon_sym___clrcall] = ACTIONS(3615),
    [anon_sym___stdcall] = ACTIONS(3615),
    [anon_sym___fastcall] = ACTIONS(3615),
    [anon_sym___thiscall] = ACTIONS(3615),
    [anon_sym___vectorcall] = ACTIONS(3615),
    [anon_sym_LBRACE] = ACTIONS(3613),
    [anon_sym_RBRACE] = ACTIONS(3613),
    [anon_sym_signed] = ACTIONS(3615),
    [anon_sym_unsigned] = ACTIONS(3615),
    [anon_sym_long] = ACTIONS(3615),
    [anon_sym_short] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(3615),
    [anon_sym_static] = ACTIONS(3615),
    [anon_sym_register] = ACTIONS(3615),
    [anon_sym_inline] = ACTIONS(3615),
    [anon_sym___inline] = ACTIONS(3615),
    [anon_sym___inline__] = ACTIONS(3615),
    [anon_sym___forceinline] = ACTIONS(3615),
    [anon_sym_thread_local] = ACTIONS(3615),
    [anon_sym___thread] = ACTIONS(3615),
    [anon_sym_const] = ACTIONS(3615),
    [anon_sym_constexpr] = ACTIONS(3615),
    [anon_sym_volatile] = ACTIONS(3615),
    [anon_sym_restrict] = ACTIONS(3615),
    [anon_sym___restrict__] = ACTIONS(3615),
    [anon_sym__Atomic] = ACTIONS(3615),
    [anon_sym__Noreturn] = ACTIONS(3615),
    [anon_sym_noreturn] = ACTIONS(3615),
    [anon_sym__Nonnull] = ACTIONS(3615),
    [anon_sym_mutable] = ACTIONS(3615),
    [anon_sym_constinit] = ACTIONS(3615),
    [anon_sym_consteval] = ACTIONS(3615),
    [anon_sym_alignas] = ACTIONS(3615),
    [anon_sym__Alignas] = ACTIONS(3615),
    [sym_primitive_type] = ACTIONS(3615),
    [anon_sym_enum] = ACTIONS(3615),
    [anon_sym_class] = ACTIONS(3615),
    [anon_sym_struct] = ACTIONS(3615),
    [anon_sym_union] = ACTIONS(3615),
    [anon_sym_if] = ACTIONS(3615),
    [anon_sym_else] = ACTIONS(3615),
    [anon_sym_switch] = ACTIONS(3615),
    [anon_sym_case] = ACTIONS(3615),
    [anon_sym_default] = ACTIONS(3615),
    [anon_sym_while] = ACTIONS(3615),
    [anon_sym_do] = ACTIONS(3615),
    [anon_sym_for] = ACTIONS(3615),
    [anon_sym_return] = ACTIONS(3615),
    [anon_sym_break] = ACTIONS(3615),
    [anon_sym_continue] = ACTIONS(3615),
    [anon_sym_goto] = ACTIONS(3615),
    [anon_sym___try] = ACTIONS(3615),
    [anon_sym___leave] = ACTIONS(3615),
    [anon_sym_not] = ACTIONS(3615),
    [anon_sym_compl] = ACTIONS(3615),
    [anon_sym_DASH_DASH] = ACTIONS(3613),
    [anon_sym_PLUS_PLUS] = ACTIONS(3613),
    [anon_sym_sizeof] = ACTIONS(3615),
    [anon_sym___alignof__] = ACTIONS(3615),
    [anon_sym___alignof] = ACTIONS(3615),
    [anon_sym__alignof] = ACTIONS(3615),
    [anon_sym_alignof] = ACTIONS(3615),
    [anon_sym__Alignof] = ACTIONS(3615),
    [anon_sym_offsetof] = ACTIONS(3615),
    [anon_sym__Generic] = ACTIONS(3615),
    [anon_sym_asm] = ACTIONS(3615),
    [anon_sym___asm__] = ACTIONS(3615),
    [anon_sym___asm] = ACTIONS(3615),
    [sym_number_literal] = ACTIONS(3613),
    [anon_sym_L_SQUOTE] = ACTIONS(3613),
    [anon_sym_u_SQUOTE] = ACTIONS(3613),
    [anon_sym_U_SQUOTE] = ACTIONS(3613),
    [anon_sym_u8_SQUOTE] = ACTIONS(3613),
    [anon_sym_SQUOTE] = ACTIONS(3613),
    [anon_sym_L_DQUOTE] = ACTIONS(3613),
    [anon_sym_u_DQUOTE] = ACTIONS(3613),
    [anon_sym_U_DQUOTE] = ACTIONS(3613),
    [anon_sym_u8_DQUOTE] = ACTIONS(3613),
    [anon_sym_DQUOTE] = ACTIONS(3613),
    [sym_true] = ACTIONS(3615),
    [sym_false] = ACTIONS(3615),
    [anon_sym_NULL] = ACTIONS(3615),
    [anon_sym_nullptr] = ACTIONS(3615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3615),
    [anon_sym_let] = ACTIONS(3615),
    [anon_sym_This] = ACTIONS(3615),
    [anon_sym_decltype] = ACTIONS(3615),
    [anon_sym_explicit] = ACTIONS(3615),
    [anon_sym_typename] = ACTIONS(3615),
    [anon_sym_template] = ACTIONS(3615),
    [anon_sym_operator] = ACTIONS(3615),
    [anon_sym_try] = ACTIONS(3615),
    [anon_sym_delete] = ACTIONS(3615),
    [anon_sym_throw] = ACTIONS(3615),
    [anon_sym_namespace] = ACTIONS(3615),
    [anon_sym_static_assert] = ACTIONS(3615),
    [anon_sym_concept] = ACTIONS(3615),
    [anon_sym_co_return] = ACTIONS(3615),
    [anon_sym_co_yield] = ACTIONS(3615),
    [anon_sym_R_DQUOTE] = ACTIONS(3613),
    [anon_sym_LR_DQUOTE] = ACTIONS(3613),
    [anon_sym_uR_DQUOTE] = ACTIONS(3613),
    [anon_sym_UR_DQUOTE] = ACTIONS(3613),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3613),
    [anon_sym_co_await] = ACTIONS(3615),
    [anon_sym_new] = ACTIONS(3615),
    [anon_sym_requires] = ACTIONS(3615),
    [sym_this] = ACTIONS(3615),
    [anon_sym_discard] = ACTIONS(3615),
    [anon_sym_precise] = ACTIONS(3615),
    [anon_sym_shared] = ACTIONS(3615),
    [anon_sym_groupshared] = ACTIONS(3615),
    [anon_sym_uniform] = ACTIONS(3615),
    [anon_sym_row_major] = ACTIONS(3615),
    [anon_sym_column_major] = ACTIONS(3615),
    [anon_sym_globallycoherent] = ACTIONS(3615),
    [anon_sym_centroid] = ACTIONS(3615),
    [anon_sym_noperspective] = ACTIONS(3615),
    [anon_sym_nointerpolation] = ACTIONS(3615),
    [anon_sym_sample] = ACTIONS(3615),
    [anon_sym_linear] = ACTIONS(3615),
    [anon_sym_snorm] = ACTIONS(3615),
    [anon_sym_unorm] = ACTIONS(3615),
    [anon_sym_point] = ACTIONS(3615),
    [anon_sym_line] = ACTIONS(3615),
    [anon_sym_triangleadj] = ACTIONS(3615),
    [anon_sym_lineadj] = ACTIONS(3615),
    [anon_sym_triangle] = ACTIONS(3615),
    [anon_sym_cbuffer] = ACTIONS(3615),
    [anon_sym_interface] = ACTIONS(3615),
    [anon_sym_extension] = ACTIONS(3615),
  },
  [810] = {
    [sym_identifier] = ACTIONS(3379),
    [aux_sym_preproc_include_token1] = ACTIONS(3379),
    [aux_sym_preproc_def_token1] = ACTIONS(3379),
    [aux_sym_preproc_if_token1] = ACTIONS(3379),
    [aux_sym_preproc_if_token2] = ACTIONS(3379),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3379),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3379),
    [sym_preproc_directive] = ACTIONS(3379),
    [anon_sym_LPAREN2] = ACTIONS(3381),
    [anon_sym_BANG] = ACTIONS(3381),
    [anon_sym_TILDE] = ACTIONS(3381),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_STAR] = ACTIONS(3381),
    [anon_sym_AMP_AMP] = ACTIONS(3381),
    [anon_sym_AMP] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3381),
    [anon_sym___extension__] = ACTIONS(3379),
    [anon_sym_typedef] = ACTIONS(3379),
    [anon_sym_in] = ACTIONS(3379),
    [anon_sym_out] = ACTIONS(3379),
    [anon_sym_inout] = ACTIONS(3379),
    [anon_sym_virtual] = ACTIONS(3379),
    [anon_sym_extern] = ACTIONS(3379),
    [anon_sym___attribute__] = ACTIONS(3379),
    [anon_sym___attribute] = ACTIONS(3379),
    [anon_sym_using] = ACTIONS(3379),
    [anon_sym_COLON_COLON] = ACTIONS(3381),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3381),
    [anon_sym___declspec] = ACTIONS(3379),
    [anon_sym___based] = ACTIONS(3379),
    [anon_sym___cdecl] = ACTIONS(3379),
    [anon_sym___clrcall] = ACTIONS(3379),
    [anon_sym___stdcall] = ACTIONS(3379),
    [anon_sym___fastcall] = ACTIONS(3379),
    [anon_sym___thiscall] = ACTIONS(3379),
    [anon_sym___vectorcall] = ACTIONS(3379),
    [anon_sym_LBRACE] = ACTIONS(3381),
    [anon_sym_signed] = ACTIONS(3379),
    [anon_sym_unsigned] = ACTIONS(3379),
    [anon_sym_long] = ACTIONS(3379),
    [anon_sym_short] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_register] = ACTIONS(3379),
    [anon_sym_inline] = ACTIONS(3379),
    [anon_sym___inline] = ACTIONS(3379),
    [anon_sym___inline__] = ACTIONS(3379),
    [anon_sym___forceinline] = ACTIONS(3379),
    [anon_sym_thread_local] = ACTIONS(3379),
    [anon_sym___thread] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_constexpr] = ACTIONS(3379),
    [anon_sym_volatile] = ACTIONS(3379),
    [anon_sym_restrict] = ACTIONS(3379),
    [anon_sym___restrict__] = ACTIONS(3379),
    [anon_sym__Atomic] = ACTIONS(3379),
    [anon_sym__Noreturn] = ACTIONS(3379),
    [anon_sym_noreturn] = ACTIONS(3379),
    [anon_sym__Nonnull] = ACTIONS(3379),
    [anon_sym_mutable] = ACTIONS(3379),
    [anon_sym_constinit] = ACTIONS(3379),
    [anon_sym_consteval] = ACTIONS(3379),
    [anon_sym_alignas] = ACTIONS(3379),
    [anon_sym__Alignas] = ACTIONS(3379),
    [sym_primitive_type] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_struct] = ACTIONS(3379),
    [anon_sym_union] = ACTIONS(3379),
    [anon_sym_if] = ACTIONS(3379),
    [anon_sym_else] = ACTIONS(3379),
    [anon_sym_switch] = ACTIONS(3379),
    [anon_sym_case] = ACTIONS(3379),
    [anon_sym_default] = ACTIONS(3379),
    [anon_sym_while] = ACTIONS(3379),
    [anon_sym_do] = ACTIONS(3379),
    [anon_sym_for] = ACTIONS(3379),
    [anon_sym_return] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(3379),
    [anon_sym_continue] = ACTIONS(3379),
    [anon_sym_goto] = ACTIONS(3379),
    [anon_sym___try] = ACTIONS(3379),
    [anon_sym___leave] = ACTIONS(3379),
    [anon_sym_not] = ACTIONS(3379),
    [anon_sym_compl] = ACTIONS(3379),
    [anon_sym_DASH_DASH] = ACTIONS(3381),
    [anon_sym_PLUS_PLUS] = ACTIONS(3381),
    [anon_sym_sizeof] = ACTIONS(3379),
    [anon_sym___alignof__] = ACTIONS(3379),
    [anon_sym___alignof] = ACTIONS(3379),
    [anon_sym__alignof] = ACTIONS(3379),
    [anon_sym_alignof] = ACTIONS(3379),
    [anon_sym__Alignof] = ACTIONS(3379),
    [anon_sym_offsetof] = ACTIONS(3379),
    [anon_sym__Generic] = ACTIONS(3379),
    [anon_sym_asm] = ACTIONS(3379),
    [anon_sym___asm__] = ACTIONS(3379),
    [anon_sym___asm] = ACTIONS(3379),
    [sym_number_literal] = ACTIONS(3381),
    [anon_sym_L_SQUOTE] = ACTIONS(3381),
    [anon_sym_u_SQUOTE] = ACTIONS(3381),
    [anon_sym_U_SQUOTE] = ACTIONS(3381),
    [anon_sym_u8_SQUOTE] = ACTIONS(3381),
    [anon_sym_SQUOTE] = ACTIONS(3381),
    [anon_sym_L_DQUOTE] = ACTIONS(3381),
    [anon_sym_u_DQUOTE] = ACTIONS(3381),
    [anon_sym_U_DQUOTE] = ACTIONS(3381),
    [anon_sym_u8_DQUOTE] = ACTIONS(3381),
    [anon_sym_DQUOTE] = ACTIONS(3381),
    [sym_true] = ACTIONS(3379),
    [sym_false] = ACTIONS(3379),
    [anon_sym_NULL] = ACTIONS(3379),
    [anon_sym_nullptr] = ACTIONS(3379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3379),
    [anon_sym_let] = ACTIONS(3379),
    [anon_sym_This] = ACTIONS(3379),
    [anon_sym_decltype] = ACTIONS(3379),
    [anon_sym_explicit] = ACTIONS(3379),
    [anon_sym_typename] = ACTIONS(3379),
    [anon_sym_template] = ACTIONS(3379),
    [anon_sym_operator] = ACTIONS(3379),
    [anon_sym_try] = ACTIONS(3379),
    [anon_sym_delete] = ACTIONS(3379),
    [anon_sym_throw] = ACTIONS(3379),
    [anon_sym_namespace] = ACTIONS(3379),
    [anon_sym_static_assert] = ACTIONS(3379),
    [anon_sym_concept] = ACTIONS(3379),
    [anon_sym_co_return] = ACTIONS(3379),
    [anon_sym_co_yield] = ACTIONS(3379),
    [anon_sym_R_DQUOTE] = ACTIONS(3381),
    [anon_sym_LR_DQUOTE] = ACTIONS(3381),
    [anon_sym_uR_DQUOTE] = ACTIONS(3381),
    [anon_sym_UR_DQUOTE] = ACTIONS(3381),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3381),
    [anon_sym_co_await] = ACTIONS(3379),
    [anon_sym_new] = ACTIONS(3379),
    [anon_sym_requires] = ACTIONS(3379),
    [sym_this] = ACTIONS(3379),
    [anon_sym_discard] = ACTIONS(3379),
    [anon_sym_precise] = ACTIONS(3379),
    [anon_sym_shared] = ACTIONS(3379),
    [anon_sym_groupshared] = ACTIONS(3379),
    [anon_sym_uniform] = ACTIONS(3379),
    [anon_sym_row_major] = ACTIONS(3379),
    [anon_sym_column_major] = ACTIONS(3379),
    [anon_sym_globallycoherent] = ACTIONS(3379),
    [anon_sym_centroid] = ACTIONS(3379),
    [anon_sym_noperspective] = ACTIONS(3379),
    [anon_sym_nointerpolation] = ACTIONS(3379),
    [anon_sym_sample] = ACTIONS(3379),
    [anon_sym_linear] = ACTIONS(3379),
    [anon_sym_snorm] = ACTIONS(3379),
    [anon_sym_unorm] = ACTIONS(3379),
    [anon_sym_point] = ACTIONS(3379),
    [anon_sym_line] = ACTIONS(3379),
    [anon_sym_triangleadj] = ACTIONS(3379),
    [anon_sym_lineadj] = ACTIONS(3379),
    [anon_sym_triangle] = ACTIONS(3379),
    [anon_sym_cbuffer] = ACTIONS(3379),
    [anon_sym_interface] = ACTIONS(3379),
    [anon_sym_extension] = ACTIONS(3379),
  },
  [811] = {
    [sym_identifier] = ACTIONS(3619),
    [aux_sym_preproc_include_token1] = ACTIONS(3619),
    [aux_sym_preproc_def_token1] = ACTIONS(3619),
    [aux_sym_preproc_if_token1] = ACTIONS(3619),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3619),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3619),
    [sym_preproc_directive] = ACTIONS(3619),
    [anon_sym_LPAREN2] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_DASH] = ACTIONS(3619),
    [anon_sym_PLUS] = ACTIONS(3619),
    [anon_sym_STAR] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP] = ACTIONS(3619),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym___extension__] = ACTIONS(3619),
    [anon_sym_typedef] = ACTIONS(3619),
    [anon_sym_in] = ACTIONS(3619),
    [anon_sym_out] = ACTIONS(3619),
    [anon_sym_inout] = ACTIONS(3619),
    [anon_sym_virtual] = ACTIONS(3619),
    [anon_sym_extern] = ACTIONS(3619),
    [anon_sym___attribute__] = ACTIONS(3619),
    [anon_sym___attribute] = ACTIONS(3619),
    [anon_sym_using] = ACTIONS(3619),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3617),
    [anon_sym___declspec] = ACTIONS(3619),
    [anon_sym___based] = ACTIONS(3619),
    [anon_sym___cdecl] = ACTIONS(3619),
    [anon_sym___clrcall] = ACTIONS(3619),
    [anon_sym___stdcall] = ACTIONS(3619),
    [anon_sym___fastcall] = ACTIONS(3619),
    [anon_sym___thiscall] = ACTIONS(3619),
    [anon_sym___vectorcall] = ACTIONS(3619),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_signed] = ACTIONS(3619),
    [anon_sym_unsigned] = ACTIONS(3619),
    [anon_sym_long] = ACTIONS(3619),
    [anon_sym_short] = ACTIONS(3619),
    [anon_sym_LBRACK] = ACTIONS(3619),
    [anon_sym_static] = ACTIONS(3619),
    [anon_sym_register] = ACTIONS(3619),
    [anon_sym_inline] = ACTIONS(3619),
    [anon_sym___inline] = ACTIONS(3619),
    [anon_sym___inline__] = ACTIONS(3619),
    [anon_sym___forceinline] = ACTIONS(3619),
    [anon_sym_thread_local] = ACTIONS(3619),
    [anon_sym___thread] = ACTIONS(3619),
    [anon_sym_const] = ACTIONS(3619),
    [anon_sym_constexpr] = ACTIONS(3619),
    [anon_sym_volatile] = ACTIONS(3619),
    [anon_sym_restrict] = ACTIONS(3619),
    [anon_sym___restrict__] = ACTIONS(3619),
    [anon_sym__Atomic] = ACTIONS(3619),
    [anon_sym__Noreturn] = ACTIONS(3619),
    [anon_sym_noreturn] = ACTIONS(3619),
    [anon_sym__Nonnull] = ACTIONS(3619),
    [anon_sym_mutable] = ACTIONS(3619),
    [anon_sym_constinit] = ACTIONS(3619),
    [anon_sym_consteval] = ACTIONS(3619),
    [anon_sym_alignas] = ACTIONS(3619),
    [anon_sym__Alignas] = ACTIONS(3619),
    [sym_primitive_type] = ACTIONS(3619),
    [anon_sym_enum] = ACTIONS(3619),
    [anon_sym_class] = ACTIONS(3619),
    [anon_sym_struct] = ACTIONS(3619),
    [anon_sym_union] = ACTIONS(3619),
    [anon_sym_if] = ACTIONS(3619),
    [anon_sym_else] = ACTIONS(3619),
    [anon_sym_switch] = ACTIONS(3619),
    [anon_sym_case] = ACTIONS(3619),
    [anon_sym_default] = ACTIONS(3619),
    [anon_sym_while] = ACTIONS(3619),
    [anon_sym_do] = ACTIONS(3619),
    [anon_sym_for] = ACTIONS(3619),
    [anon_sym_return] = ACTIONS(3619),
    [anon_sym_break] = ACTIONS(3619),
    [anon_sym_continue] = ACTIONS(3619),
    [anon_sym_goto] = ACTIONS(3619),
    [anon_sym___try] = ACTIONS(3619),
    [anon_sym___leave] = ACTIONS(3619),
    [anon_sym_not] = ACTIONS(3619),
    [anon_sym_compl] = ACTIONS(3619),
    [anon_sym_DASH_DASH] = ACTIONS(3617),
    [anon_sym_PLUS_PLUS] = ACTIONS(3617),
    [anon_sym_sizeof] = ACTIONS(3619),
    [anon_sym___alignof__] = ACTIONS(3619),
    [anon_sym___alignof] = ACTIONS(3619),
    [anon_sym__alignof] = ACTIONS(3619),
    [anon_sym_alignof] = ACTIONS(3619),
    [anon_sym__Alignof] = ACTIONS(3619),
    [anon_sym_offsetof] = ACTIONS(3619),
    [anon_sym__Generic] = ACTIONS(3619),
    [anon_sym_asm] = ACTIONS(3619),
    [anon_sym___asm__] = ACTIONS(3619),
    [anon_sym___asm] = ACTIONS(3619),
    [sym_number_literal] = ACTIONS(3617),
    [anon_sym_L_SQUOTE] = ACTIONS(3617),
    [anon_sym_u_SQUOTE] = ACTIONS(3617),
    [anon_sym_U_SQUOTE] = ACTIONS(3617),
    [anon_sym_u8_SQUOTE] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3617),
    [anon_sym_L_DQUOTE] = ACTIONS(3617),
    [anon_sym_u_DQUOTE] = ACTIONS(3617),
    [anon_sym_U_DQUOTE] = ACTIONS(3617),
    [anon_sym_u8_DQUOTE] = ACTIONS(3617),
    [anon_sym_DQUOTE] = ACTIONS(3617),
    [sym_true] = ACTIONS(3619),
    [sym_false] = ACTIONS(3619),
    [anon_sym_NULL] = ACTIONS(3619),
    [anon_sym_nullptr] = ACTIONS(3619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3619),
    [anon_sym_let] = ACTIONS(3619),
    [anon_sym_This] = ACTIONS(3619),
    [anon_sym_decltype] = ACTIONS(3619),
    [anon_sym_explicit] = ACTIONS(3619),
    [anon_sym_typename] = ACTIONS(3619),
    [anon_sym_template] = ACTIONS(3619),
    [anon_sym_operator] = ACTIONS(3619),
    [anon_sym_try] = ACTIONS(3619),
    [anon_sym_delete] = ACTIONS(3619),
    [anon_sym_throw] = ACTIONS(3619),
    [anon_sym_namespace] = ACTIONS(3619),
    [anon_sym_static_assert] = ACTIONS(3619),
    [anon_sym_concept] = ACTIONS(3619),
    [anon_sym_co_return] = ACTIONS(3619),
    [anon_sym_co_yield] = ACTIONS(3619),
    [anon_sym_R_DQUOTE] = ACTIONS(3617),
    [anon_sym_LR_DQUOTE] = ACTIONS(3617),
    [anon_sym_uR_DQUOTE] = ACTIONS(3617),
    [anon_sym_UR_DQUOTE] = ACTIONS(3617),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3617),
    [anon_sym_co_await] = ACTIONS(3619),
    [anon_sym_new] = ACTIONS(3619),
    [anon_sym_requires] = ACTIONS(3619),
    [sym_this] = ACTIONS(3619),
    [anon_sym_discard] = ACTIONS(3619),
    [anon_sym_precise] = ACTIONS(3619),
    [anon_sym_shared] = ACTIONS(3619),
    [anon_sym_groupshared] = ACTIONS(3619),
    [anon_sym_uniform] = ACTIONS(3619),
    [anon_sym_row_major] = ACTIONS(3619),
    [anon_sym_column_major] = ACTIONS(3619),
    [anon_sym_globallycoherent] = ACTIONS(3619),
    [anon_sym_centroid] = ACTIONS(3619),
    [anon_sym_noperspective] = ACTIONS(3619),
    [anon_sym_nointerpolation] = ACTIONS(3619),
    [anon_sym_sample] = ACTIONS(3619),
    [anon_sym_linear] = ACTIONS(3619),
    [anon_sym_snorm] = ACTIONS(3619),
    [anon_sym_unorm] = ACTIONS(3619),
    [anon_sym_point] = ACTIONS(3619),
    [anon_sym_line] = ACTIONS(3619),
    [anon_sym_triangleadj] = ACTIONS(3619),
    [anon_sym_lineadj] = ACTIONS(3619),
    [anon_sym_triangle] = ACTIONS(3619),
    [anon_sym_cbuffer] = ACTIONS(3619),
    [anon_sym_interface] = ACTIONS(3619),
    [anon_sym_extension] = ACTIONS(3619),
  },
  [812] = {
    [sym_identifier] = ACTIONS(3623),
    [aux_sym_preproc_include_token1] = ACTIONS(3623),
    [aux_sym_preproc_def_token1] = ACTIONS(3623),
    [aux_sym_preproc_if_token1] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3623),
    [sym_preproc_directive] = ACTIONS(3623),
    [anon_sym_LPAREN2] = ACTIONS(3621),
    [anon_sym_BANG] = ACTIONS(3621),
    [anon_sym_TILDE] = ACTIONS(3621),
    [anon_sym_DASH] = ACTIONS(3623),
    [anon_sym_PLUS] = ACTIONS(3623),
    [anon_sym_STAR] = ACTIONS(3621),
    [anon_sym_AMP_AMP] = ACTIONS(3621),
    [anon_sym_AMP] = ACTIONS(3623),
    [anon_sym_SEMI] = ACTIONS(3621),
    [anon_sym___extension__] = ACTIONS(3623),
    [anon_sym_typedef] = ACTIONS(3623),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_out] = ACTIONS(3623),
    [anon_sym_inout] = ACTIONS(3623),
    [anon_sym_virtual] = ACTIONS(3623),
    [anon_sym_extern] = ACTIONS(3623),
    [anon_sym___attribute__] = ACTIONS(3623),
    [anon_sym___attribute] = ACTIONS(3623),
    [anon_sym_using] = ACTIONS(3623),
    [anon_sym_COLON_COLON] = ACTIONS(3621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3621),
    [anon_sym___declspec] = ACTIONS(3623),
    [anon_sym___based] = ACTIONS(3623),
    [anon_sym___cdecl] = ACTIONS(3623),
    [anon_sym___clrcall] = ACTIONS(3623),
    [anon_sym___stdcall] = ACTIONS(3623),
    [anon_sym___fastcall] = ACTIONS(3623),
    [anon_sym___thiscall] = ACTIONS(3623),
    [anon_sym___vectorcall] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3621),
    [anon_sym_RBRACE] = ACTIONS(3621),
    [anon_sym_signed] = ACTIONS(3623),
    [anon_sym_unsigned] = ACTIONS(3623),
    [anon_sym_long] = ACTIONS(3623),
    [anon_sym_short] = ACTIONS(3623),
    [anon_sym_LBRACK] = ACTIONS(3623),
    [anon_sym_static] = ACTIONS(3623),
    [anon_sym_register] = ACTIONS(3623),
    [anon_sym_inline] = ACTIONS(3623),
    [anon_sym___inline] = ACTIONS(3623),
    [anon_sym___inline__] = ACTIONS(3623),
    [anon_sym___forceinline] = ACTIONS(3623),
    [anon_sym_thread_local] = ACTIONS(3623),
    [anon_sym___thread] = ACTIONS(3623),
    [anon_sym_const] = ACTIONS(3623),
    [anon_sym_constexpr] = ACTIONS(3623),
    [anon_sym_volatile] = ACTIONS(3623),
    [anon_sym_restrict] = ACTIONS(3623),
    [anon_sym___restrict__] = ACTIONS(3623),
    [anon_sym__Atomic] = ACTIONS(3623),
    [anon_sym__Noreturn] = ACTIONS(3623),
    [anon_sym_noreturn] = ACTIONS(3623),
    [anon_sym__Nonnull] = ACTIONS(3623),
    [anon_sym_mutable] = ACTIONS(3623),
    [anon_sym_constinit] = ACTIONS(3623),
    [anon_sym_consteval] = ACTIONS(3623),
    [anon_sym_alignas] = ACTIONS(3623),
    [anon_sym__Alignas] = ACTIONS(3623),
    [sym_primitive_type] = ACTIONS(3623),
    [anon_sym_enum] = ACTIONS(3623),
    [anon_sym_class] = ACTIONS(3623),
    [anon_sym_struct] = ACTIONS(3623),
    [anon_sym_union] = ACTIONS(3623),
    [anon_sym_if] = ACTIONS(3623),
    [anon_sym_else] = ACTIONS(3623),
    [anon_sym_switch] = ACTIONS(3623),
    [anon_sym_case] = ACTIONS(3623),
    [anon_sym_default] = ACTIONS(3623),
    [anon_sym_while] = ACTIONS(3623),
    [anon_sym_do] = ACTIONS(3623),
    [anon_sym_for] = ACTIONS(3623),
    [anon_sym_return] = ACTIONS(3623),
    [anon_sym_break] = ACTIONS(3623),
    [anon_sym_continue] = ACTIONS(3623),
    [anon_sym_goto] = ACTIONS(3623),
    [anon_sym___try] = ACTIONS(3623),
    [anon_sym___leave] = ACTIONS(3623),
    [anon_sym_not] = ACTIONS(3623),
    [anon_sym_compl] = ACTIONS(3623),
    [anon_sym_DASH_DASH] = ACTIONS(3621),
    [anon_sym_PLUS_PLUS] = ACTIONS(3621),
    [anon_sym_sizeof] = ACTIONS(3623),
    [anon_sym___alignof__] = ACTIONS(3623),
    [anon_sym___alignof] = ACTIONS(3623),
    [anon_sym__alignof] = ACTIONS(3623),
    [anon_sym_alignof] = ACTIONS(3623),
    [anon_sym__Alignof] = ACTIONS(3623),
    [anon_sym_offsetof] = ACTIONS(3623),
    [anon_sym__Generic] = ACTIONS(3623),
    [anon_sym_asm] = ACTIONS(3623),
    [anon_sym___asm__] = ACTIONS(3623),
    [anon_sym___asm] = ACTIONS(3623),
    [sym_number_literal] = ACTIONS(3621),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3621),
    [anon_sym_u_DQUOTE] = ACTIONS(3621),
    [anon_sym_U_DQUOTE] = ACTIONS(3621),
    [anon_sym_u8_DQUOTE] = ACTIONS(3621),
    [anon_sym_DQUOTE] = ACTIONS(3621),
    [sym_true] = ACTIONS(3623),
    [sym_false] = ACTIONS(3623),
    [anon_sym_NULL] = ACTIONS(3623),
    [anon_sym_nullptr] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3623),
    [anon_sym_let] = ACTIONS(3623),
    [anon_sym_This] = ACTIONS(3623),
    [anon_sym_decltype] = ACTIONS(3623),
    [anon_sym_explicit] = ACTIONS(3623),
    [anon_sym_typename] = ACTIONS(3623),
    [anon_sym_template] = ACTIONS(3623),
    [anon_sym_operator] = ACTIONS(3623),
    [anon_sym_try] = ACTIONS(3623),
    [anon_sym_delete] = ACTIONS(3623),
    [anon_sym_throw] = ACTIONS(3623),
    [anon_sym_namespace] = ACTIONS(3623),
    [anon_sym_static_assert] = ACTIONS(3623),
    [anon_sym_concept] = ACTIONS(3623),
    [anon_sym_co_return] = ACTIONS(3623),
    [anon_sym_co_yield] = ACTIONS(3623),
    [anon_sym_R_DQUOTE] = ACTIONS(3621),
    [anon_sym_LR_DQUOTE] = ACTIONS(3621),
    [anon_sym_uR_DQUOTE] = ACTIONS(3621),
    [anon_sym_UR_DQUOTE] = ACTIONS(3621),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3621),
    [anon_sym_co_await] = ACTIONS(3623),
    [anon_sym_new] = ACTIONS(3623),
    [anon_sym_requires] = ACTIONS(3623),
    [sym_this] = ACTIONS(3623),
    [anon_sym_discard] = ACTIONS(3623),
    [anon_sym_precise] = ACTIONS(3623),
    [anon_sym_shared] = ACTIONS(3623),
    [anon_sym_groupshared] = ACTIONS(3623),
    [anon_sym_uniform] = ACTIONS(3623),
    [anon_sym_row_major] = ACTIONS(3623),
    [anon_sym_column_major] = ACTIONS(3623),
    [anon_sym_globallycoherent] = ACTIONS(3623),
    [anon_sym_centroid] = ACTIONS(3623),
    [anon_sym_noperspective] = ACTIONS(3623),
    [anon_sym_nointerpolation] = ACTIONS(3623),
    [anon_sym_sample] = ACTIONS(3623),
    [anon_sym_linear] = ACTIONS(3623),
    [anon_sym_snorm] = ACTIONS(3623),
    [anon_sym_unorm] = ACTIONS(3623),
    [anon_sym_point] = ACTIONS(3623),
    [anon_sym_line] = ACTIONS(3623),
    [anon_sym_triangleadj] = ACTIONS(3623),
    [anon_sym_lineadj] = ACTIONS(3623),
    [anon_sym_triangle] = ACTIONS(3623),
    [anon_sym_cbuffer] = ACTIONS(3623),
    [anon_sym_interface] = ACTIONS(3623),
    [anon_sym_extension] = ACTIONS(3623),
  },
  [813] = {
    [sym_identifier] = ACTIONS(3623),
    [aux_sym_preproc_include_token1] = ACTIONS(3623),
    [aux_sym_preproc_def_token1] = ACTIONS(3623),
    [aux_sym_preproc_if_token1] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3623),
    [sym_preproc_directive] = ACTIONS(3623),
    [anon_sym_LPAREN2] = ACTIONS(3621),
    [anon_sym_BANG] = ACTIONS(3621),
    [anon_sym_TILDE] = ACTIONS(3621),
    [anon_sym_DASH] = ACTIONS(3623),
    [anon_sym_PLUS] = ACTIONS(3623),
    [anon_sym_STAR] = ACTIONS(3621),
    [anon_sym_AMP_AMP] = ACTIONS(3621),
    [anon_sym_AMP] = ACTIONS(3623),
    [anon_sym_SEMI] = ACTIONS(3621),
    [anon_sym___extension__] = ACTIONS(3623),
    [anon_sym_typedef] = ACTIONS(3623),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_out] = ACTIONS(3623),
    [anon_sym_inout] = ACTIONS(3623),
    [anon_sym_virtual] = ACTIONS(3623),
    [anon_sym_extern] = ACTIONS(3623),
    [anon_sym___attribute__] = ACTIONS(3623),
    [anon_sym___attribute] = ACTIONS(3623),
    [anon_sym_using] = ACTIONS(3623),
    [anon_sym_COLON_COLON] = ACTIONS(3621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3621),
    [anon_sym___declspec] = ACTIONS(3623),
    [anon_sym___based] = ACTIONS(3623),
    [anon_sym___cdecl] = ACTIONS(3623),
    [anon_sym___clrcall] = ACTIONS(3623),
    [anon_sym___stdcall] = ACTIONS(3623),
    [anon_sym___fastcall] = ACTIONS(3623),
    [anon_sym___thiscall] = ACTIONS(3623),
    [anon_sym___vectorcall] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3621),
    [anon_sym_RBRACE] = ACTIONS(3621),
    [anon_sym_signed] = ACTIONS(3623),
    [anon_sym_unsigned] = ACTIONS(3623),
    [anon_sym_long] = ACTIONS(3623),
    [anon_sym_short] = ACTIONS(3623),
    [anon_sym_LBRACK] = ACTIONS(3623),
    [anon_sym_static] = ACTIONS(3623),
    [anon_sym_register] = ACTIONS(3623),
    [anon_sym_inline] = ACTIONS(3623),
    [anon_sym___inline] = ACTIONS(3623),
    [anon_sym___inline__] = ACTIONS(3623),
    [anon_sym___forceinline] = ACTIONS(3623),
    [anon_sym_thread_local] = ACTIONS(3623),
    [anon_sym___thread] = ACTIONS(3623),
    [anon_sym_const] = ACTIONS(3623),
    [anon_sym_constexpr] = ACTIONS(3623),
    [anon_sym_volatile] = ACTIONS(3623),
    [anon_sym_restrict] = ACTIONS(3623),
    [anon_sym___restrict__] = ACTIONS(3623),
    [anon_sym__Atomic] = ACTIONS(3623),
    [anon_sym__Noreturn] = ACTIONS(3623),
    [anon_sym_noreturn] = ACTIONS(3623),
    [anon_sym__Nonnull] = ACTIONS(3623),
    [anon_sym_mutable] = ACTIONS(3623),
    [anon_sym_constinit] = ACTIONS(3623),
    [anon_sym_consteval] = ACTIONS(3623),
    [anon_sym_alignas] = ACTIONS(3623),
    [anon_sym__Alignas] = ACTIONS(3623),
    [sym_primitive_type] = ACTIONS(3623),
    [anon_sym_enum] = ACTIONS(3623),
    [anon_sym_class] = ACTIONS(3623),
    [anon_sym_struct] = ACTIONS(3623),
    [anon_sym_union] = ACTIONS(3623),
    [anon_sym_if] = ACTIONS(3623),
    [anon_sym_else] = ACTIONS(3623),
    [anon_sym_switch] = ACTIONS(3623),
    [anon_sym_case] = ACTIONS(3623),
    [anon_sym_default] = ACTIONS(3623),
    [anon_sym_while] = ACTIONS(3623),
    [anon_sym_do] = ACTIONS(3623),
    [anon_sym_for] = ACTIONS(3623),
    [anon_sym_return] = ACTIONS(3623),
    [anon_sym_break] = ACTIONS(3623),
    [anon_sym_continue] = ACTIONS(3623),
    [anon_sym_goto] = ACTIONS(3623),
    [anon_sym___try] = ACTIONS(3623),
    [anon_sym___leave] = ACTIONS(3623),
    [anon_sym_not] = ACTIONS(3623),
    [anon_sym_compl] = ACTIONS(3623),
    [anon_sym_DASH_DASH] = ACTIONS(3621),
    [anon_sym_PLUS_PLUS] = ACTIONS(3621),
    [anon_sym_sizeof] = ACTIONS(3623),
    [anon_sym___alignof__] = ACTIONS(3623),
    [anon_sym___alignof] = ACTIONS(3623),
    [anon_sym__alignof] = ACTIONS(3623),
    [anon_sym_alignof] = ACTIONS(3623),
    [anon_sym__Alignof] = ACTIONS(3623),
    [anon_sym_offsetof] = ACTIONS(3623),
    [anon_sym__Generic] = ACTIONS(3623),
    [anon_sym_asm] = ACTIONS(3623),
    [anon_sym___asm__] = ACTIONS(3623),
    [anon_sym___asm] = ACTIONS(3623),
    [sym_number_literal] = ACTIONS(3621),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3621),
    [anon_sym_u_DQUOTE] = ACTIONS(3621),
    [anon_sym_U_DQUOTE] = ACTIONS(3621),
    [anon_sym_u8_DQUOTE] = ACTIONS(3621),
    [anon_sym_DQUOTE] = ACTIONS(3621),
    [sym_true] = ACTIONS(3623),
    [sym_false] = ACTIONS(3623),
    [anon_sym_NULL] = ACTIONS(3623),
    [anon_sym_nullptr] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3623),
    [anon_sym_let] = ACTIONS(3623),
    [anon_sym_This] = ACTIONS(3623),
    [anon_sym_decltype] = ACTIONS(3623),
    [anon_sym_explicit] = ACTIONS(3623),
    [anon_sym_typename] = ACTIONS(3623),
    [anon_sym_template] = ACTIONS(3623),
    [anon_sym_operator] = ACTIONS(3623),
    [anon_sym_try] = ACTIONS(3623),
    [anon_sym_delete] = ACTIONS(3623),
    [anon_sym_throw] = ACTIONS(3623),
    [anon_sym_namespace] = ACTIONS(3623),
    [anon_sym_static_assert] = ACTIONS(3623),
    [anon_sym_concept] = ACTIONS(3623),
    [anon_sym_co_return] = ACTIONS(3623),
    [anon_sym_co_yield] = ACTIONS(3623),
    [anon_sym_R_DQUOTE] = ACTIONS(3621),
    [anon_sym_LR_DQUOTE] = ACTIONS(3621),
    [anon_sym_uR_DQUOTE] = ACTIONS(3621),
    [anon_sym_UR_DQUOTE] = ACTIONS(3621),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3621),
    [anon_sym_co_await] = ACTIONS(3623),
    [anon_sym_new] = ACTIONS(3623),
    [anon_sym_requires] = ACTIONS(3623),
    [sym_this] = ACTIONS(3623),
    [anon_sym_discard] = ACTIONS(3623),
    [anon_sym_precise] = ACTIONS(3623),
    [anon_sym_shared] = ACTIONS(3623),
    [anon_sym_groupshared] = ACTIONS(3623),
    [anon_sym_uniform] = ACTIONS(3623),
    [anon_sym_row_major] = ACTIONS(3623),
    [anon_sym_column_major] = ACTIONS(3623),
    [anon_sym_globallycoherent] = ACTIONS(3623),
    [anon_sym_centroid] = ACTIONS(3623),
    [anon_sym_noperspective] = ACTIONS(3623),
    [anon_sym_nointerpolation] = ACTIONS(3623),
    [anon_sym_sample] = ACTIONS(3623),
    [anon_sym_linear] = ACTIONS(3623),
    [anon_sym_snorm] = ACTIONS(3623),
    [anon_sym_unorm] = ACTIONS(3623),
    [anon_sym_point] = ACTIONS(3623),
    [anon_sym_line] = ACTIONS(3623),
    [anon_sym_triangleadj] = ACTIONS(3623),
    [anon_sym_lineadj] = ACTIONS(3623),
    [anon_sym_triangle] = ACTIONS(3623),
    [anon_sym_cbuffer] = ACTIONS(3623),
    [anon_sym_interface] = ACTIONS(3623),
    [anon_sym_extension] = ACTIONS(3623),
  },
  [814] = {
    [sym_identifier] = ACTIONS(2550),
    [aux_sym_preproc_include_token1] = ACTIONS(2550),
    [aux_sym_preproc_def_token1] = ACTIONS(2550),
    [aux_sym_preproc_if_token1] = ACTIONS(2550),
    [aux_sym_preproc_if_token2] = ACTIONS(2550),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2550),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2550),
    [sym_preproc_directive] = ACTIONS(2550),
    [anon_sym_LPAREN2] = ACTIONS(2548),
    [anon_sym_BANG] = ACTIONS(2548),
    [anon_sym_TILDE] = ACTIONS(2548),
    [anon_sym_DASH] = ACTIONS(2550),
    [anon_sym_PLUS] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(2548),
    [anon_sym_AMP_AMP] = ACTIONS(2548),
    [anon_sym_AMP] = ACTIONS(2550),
    [anon_sym_SEMI] = ACTIONS(2548),
    [anon_sym___extension__] = ACTIONS(2550),
    [anon_sym_typedef] = ACTIONS(2550),
    [anon_sym_in] = ACTIONS(2550),
    [anon_sym_out] = ACTIONS(2550),
    [anon_sym_inout] = ACTIONS(2550),
    [anon_sym_virtual] = ACTIONS(2550),
    [anon_sym_extern] = ACTIONS(2550),
    [anon_sym___attribute__] = ACTIONS(2550),
    [anon_sym___attribute] = ACTIONS(2550),
    [anon_sym_using] = ACTIONS(2550),
    [anon_sym_COLON_COLON] = ACTIONS(2548),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2548),
    [anon_sym___declspec] = ACTIONS(2550),
    [anon_sym___based] = ACTIONS(2550),
    [anon_sym___cdecl] = ACTIONS(2550),
    [anon_sym___clrcall] = ACTIONS(2550),
    [anon_sym___stdcall] = ACTIONS(2550),
    [anon_sym___fastcall] = ACTIONS(2550),
    [anon_sym___thiscall] = ACTIONS(2550),
    [anon_sym___vectorcall] = ACTIONS(2550),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_signed] = ACTIONS(2550),
    [anon_sym_unsigned] = ACTIONS(2550),
    [anon_sym_long] = ACTIONS(2550),
    [anon_sym_short] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_static] = ACTIONS(2550),
    [anon_sym_register] = ACTIONS(2550),
    [anon_sym_inline] = ACTIONS(2550),
    [anon_sym___inline] = ACTIONS(2550),
    [anon_sym___inline__] = ACTIONS(2550),
    [anon_sym___forceinline] = ACTIONS(2550),
    [anon_sym_thread_local] = ACTIONS(2550),
    [anon_sym___thread] = ACTIONS(2550),
    [anon_sym_const] = ACTIONS(2550),
    [anon_sym_constexpr] = ACTIONS(2550),
    [anon_sym_volatile] = ACTIONS(2550),
    [anon_sym_restrict] = ACTIONS(2550),
    [anon_sym___restrict__] = ACTIONS(2550),
    [anon_sym__Atomic] = ACTIONS(2550),
    [anon_sym__Noreturn] = ACTIONS(2550),
    [anon_sym_noreturn] = ACTIONS(2550),
    [anon_sym__Nonnull] = ACTIONS(2550),
    [anon_sym_mutable] = ACTIONS(2550),
    [anon_sym_constinit] = ACTIONS(2550),
    [anon_sym_consteval] = ACTIONS(2550),
    [anon_sym_alignas] = ACTIONS(2550),
    [anon_sym__Alignas] = ACTIONS(2550),
    [sym_primitive_type] = ACTIONS(2550),
    [anon_sym_enum] = ACTIONS(2550),
    [anon_sym_class] = ACTIONS(2550),
    [anon_sym_struct] = ACTIONS(2550),
    [anon_sym_union] = ACTIONS(2550),
    [anon_sym_if] = ACTIONS(2550),
    [anon_sym_else] = ACTIONS(2550),
    [anon_sym_switch] = ACTIONS(2550),
    [anon_sym_case] = ACTIONS(2550),
    [anon_sym_default] = ACTIONS(2550),
    [anon_sym_while] = ACTIONS(2550),
    [anon_sym_do] = ACTIONS(2550),
    [anon_sym_for] = ACTIONS(2550),
    [anon_sym_return] = ACTIONS(2550),
    [anon_sym_break] = ACTIONS(2550),
    [anon_sym_continue] = ACTIONS(2550),
    [anon_sym_goto] = ACTIONS(2550),
    [anon_sym___try] = ACTIONS(2550),
    [anon_sym___leave] = ACTIONS(2550),
    [anon_sym_not] = ACTIONS(2550),
    [anon_sym_compl] = ACTIONS(2550),
    [anon_sym_DASH_DASH] = ACTIONS(2548),
    [anon_sym_PLUS_PLUS] = ACTIONS(2548),
    [anon_sym_sizeof] = ACTIONS(2550),
    [anon_sym___alignof__] = ACTIONS(2550),
    [anon_sym___alignof] = ACTIONS(2550),
    [anon_sym__alignof] = ACTIONS(2550),
    [anon_sym_alignof] = ACTIONS(2550),
    [anon_sym__Alignof] = ACTIONS(2550),
    [anon_sym_offsetof] = ACTIONS(2550),
    [anon_sym__Generic] = ACTIONS(2550),
    [anon_sym_asm] = ACTIONS(2550),
    [anon_sym___asm__] = ACTIONS(2550),
    [anon_sym___asm] = ACTIONS(2550),
    [sym_number_literal] = ACTIONS(2548),
    [anon_sym_L_SQUOTE] = ACTIONS(2548),
    [anon_sym_u_SQUOTE] = ACTIONS(2548),
    [anon_sym_U_SQUOTE] = ACTIONS(2548),
    [anon_sym_u8_SQUOTE] = ACTIONS(2548),
    [anon_sym_SQUOTE] = ACTIONS(2548),
    [anon_sym_L_DQUOTE] = ACTIONS(2548),
    [anon_sym_u_DQUOTE] = ACTIONS(2548),
    [anon_sym_U_DQUOTE] = ACTIONS(2548),
    [anon_sym_u8_DQUOTE] = ACTIONS(2548),
    [anon_sym_DQUOTE] = ACTIONS(2548),
    [sym_true] = ACTIONS(2550),
    [sym_false] = ACTIONS(2550),
    [anon_sym_NULL] = ACTIONS(2550),
    [anon_sym_nullptr] = ACTIONS(2550),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(2550),
    [anon_sym_This] = ACTIONS(2550),
    [anon_sym_decltype] = ACTIONS(2550),
    [anon_sym_explicit] = ACTIONS(2550),
    [anon_sym_typename] = ACTIONS(2550),
    [anon_sym_template] = ACTIONS(2550),
    [anon_sym_operator] = ACTIONS(2550),
    [anon_sym_try] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(2550),
    [anon_sym_throw] = ACTIONS(2550),
    [anon_sym_namespace] = ACTIONS(2550),
    [anon_sym_static_assert] = ACTIONS(2550),
    [anon_sym_concept] = ACTIONS(2550),
    [anon_sym_co_return] = ACTIONS(2550),
    [anon_sym_co_yield] = ACTIONS(2550),
    [anon_sym_R_DQUOTE] = ACTIONS(2548),
    [anon_sym_LR_DQUOTE] = ACTIONS(2548),
    [anon_sym_uR_DQUOTE] = ACTIONS(2548),
    [anon_sym_UR_DQUOTE] = ACTIONS(2548),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2548),
    [anon_sym_co_await] = ACTIONS(2550),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2550),
    [sym_this] = ACTIONS(2550),
    [anon_sym_discard] = ACTIONS(2550),
    [anon_sym_precise] = ACTIONS(2550),
    [anon_sym_shared] = ACTIONS(2550),
    [anon_sym_groupshared] = ACTIONS(2550),
    [anon_sym_uniform] = ACTIONS(2550),
    [anon_sym_row_major] = ACTIONS(2550),
    [anon_sym_column_major] = ACTIONS(2550),
    [anon_sym_globallycoherent] = ACTIONS(2550),
    [anon_sym_centroid] = ACTIONS(2550),
    [anon_sym_noperspective] = ACTIONS(2550),
    [anon_sym_nointerpolation] = ACTIONS(2550),
    [anon_sym_sample] = ACTIONS(2550),
    [anon_sym_linear] = ACTIONS(2550),
    [anon_sym_snorm] = ACTIONS(2550),
    [anon_sym_unorm] = ACTIONS(2550),
    [anon_sym_point] = ACTIONS(2550),
    [anon_sym_line] = ACTIONS(2550),
    [anon_sym_triangleadj] = ACTIONS(2550),
    [anon_sym_lineadj] = ACTIONS(2550),
    [anon_sym_triangle] = ACTIONS(2550),
    [anon_sym_cbuffer] = ACTIONS(2550),
    [anon_sym_interface] = ACTIONS(2550),
    [anon_sym_extension] = ACTIONS(2550),
  },
  [815] = {
    [sym_identifier] = ACTIONS(3379),
    [aux_sym_preproc_include_token1] = ACTIONS(3379),
    [aux_sym_preproc_def_token1] = ACTIONS(3379),
    [aux_sym_preproc_if_token1] = ACTIONS(3379),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3379),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3379),
    [sym_preproc_directive] = ACTIONS(3379),
    [anon_sym_LPAREN2] = ACTIONS(3381),
    [anon_sym_BANG] = ACTIONS(3381),
    [anon_sym_TILDE] = ACTIONS(3381),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_STAR] = ACTIONS(3381),
    [anon_sym_AMP_AMP] = ACTIONS(3381),
    [anon_sym_AMP] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3381),
    [anon_sym___extension__] = ACTIONS(3379),
    [anon_sym_typedef] = ACTIONS(3379),
    [anon_sym_in] = ACTIONS(3379),
    [anon_sym_out] = ACTIONS(3379),
    [anon_sym_inout] = ACTIONS(3379),
    [anon_sym_virtual] = ACTIONS(3379),
    [anon_sym_extern] = ACTIONS(3379),
    [anon_sym___attribute__] = ACTIONS(3379),
    [anon_sym___attribute] = ACTIONS(3379),
    [anon_sym_using] = ACTIONS(3379),
    [anon_sym_COLON_COLON] = ACTIONS(3381),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3381),
    [anon_sym___declspec] = ACTIONS(3379),
    [anon_sym___based] = ACTIONS(3379),
    [anon_sym___cdecl] = ACTIONS(3379),
    [anon_sym___clrcall] = ACTIONS(3379),
    [anon_sym___stdcall] = ACTIONS(3379),
    [anon_sym___fastcall] = ACTIONS(3379),
    [anon_sym___thiscall] = ACTIONS(3379),
    [anon_sym___vectorcall] = ACTIONS(3379),
    [anon_sym_LBRACE] = ACTIONS(3381),
    [anon_sym_RBRACE] = ACTIONS(3381),
    [anon_sym_signed] = ACTIONS(3379),
    [anon_sym_unsigned] = ACTIONS(3379),
    [anon_sym_long] = ACTIONS(3379),
    [anon_sym_short] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_register] = ACTIONS(3379),
    [anon_sym_inline] = ACTIONS(3379),
    [anon_sym___inline] = ACTIONS(3379),
    [anon_sym___inline__] = ACTIONS(3379),
    [anon_sym___forceinline] = ACTIONS(3379),
    [anon_sym_thread_local] = ACTIONS(3379),
    [anon_sym___thread] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_constexpr] = ACTIONS(3379),
    [anon_sym_volatile] = ACTIONS(3379),
    [anon_sym_restrict] = ACTIONS(3379),
    [anon_sym___restrict__] = ACTIONS(3379),
    [anon_sym__Atomic] = ACTIONS(3379),
    [anon_sym__Noreturn] = ACTIONS(3379),
    [anon_sym_noreturn] = ACTIONS(3379),
    [anon_sym__Nonnull] = ACTIONS(3379),
    [anon_sym_mutable] = ACTIONS(3379),
    [anon_sym_constinit] = ACTIONS(3379),
    [anon_sym_consteval] = ACTIONS(3379),
    [anon_sym_alignas] = ACTIONS(3379),
    [anon_sym__Alignas] = ACTIONS(3379),
    [sym_primitive_type] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_struct] = ACTIONS(3379),
    [anon_sym_union] = ACTIONS(3379),
    [anon_sym_if] = ACTIONS(3379),
    [anon_sym_else] = ACTIONS(3379),
    [anon_sym_switch] = ACTIONS(3379),
    [anon_sym_case] = ACTIONS(3379),
    [anon_sym_default] = ACTIONS(3379),
    [anon_sym_while] = ACTIONS(3379),
    [anon_sym_do] = ACTIONS(3379),
    [anon_sym_for] = ACTIONS(3379),
    [anon_sym_return] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(3379),
    [anon_sym_continue] = ACTIONS(3379),
    [anon_sym_goto] = ACTIONS(3379),
    [anon_sym___try] = ACTIONS(3379),
    [anon_sym___leave] = ACTIONS(3379),
    [anon_sym_not] = ACTIONS(3379),
    [anon_sym_compl] = ACTIONS(3379),
    [anon_sym_DASH_DASH] = ACTIONS(3381),
    [anon_sym_PLUS_PLUS] = ACTIONS(3381),
    [anon_sym_sizeof] = ACTIONS(3379),
    [anon_sym___alignof__] = ACTIONS(3379),
    [anon_sym___alignof] = ACTIONS(3379),
    [anon_sym__alignof] = ACTIONS(3379),
    [anon_sym_alignof] = ACTIONS(3379),
    [anon_sym__Alignof] = ACTIONS(3379),
    [anon_sym_offsetof] = ACTIONS(3379),
    [anon_sym__Generic] = ACTIONS(3379),
    [anon_sym_asm] = ACTIONS(3379),
    [anon_sym___asm__] = ACTIONS(3379),
    [anon_sym___asm] = ACTIONS(3379),
    [sym_number_literal] = ACTIONS(3381),
    [anon_sym_L_SQUOTE] = ACTIONS(3381),
    [anon_sym_u_SQUOTE] = ACTIONS(3381),
    [anon_sym_U_SQUOTE] = ACTIONS(3381),
    [anon_sym_u8_SQUOTE] = ACTIONS(3381),
    [anon_sym_SQUOTE] = ACTIONS(3381),
    [anon_sym_L_DQUOTE] = ACTIONS(3381),
    [anon_sym_u_DQUOTE] = ACTIONS(3381),
    [anon_sym_U_DQUOTE] = ACTIONS(3381),
    [anon_sym_u8_DQUOTE] = ACTIONS(3381),
    [anon_sym_DQUOTE] = ACTIONS(3381),
    [sym_true] = ACTIONS(3379),
    [sym_false] = ACTIONS(3379),
    [anon_sym_NULL] = ACTIONS(3379),
    [anon_sym_nullptr] = ACTIONS(3379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3379),
    [anon_sym_let] = ACTIONS(3379),
    [anon_sym_This] = ACTIONS(3379),
    [anon_sym_decltype] = ACTIONS(3379),
    [anon_sym_explicit] = ACTIONS(3379),
    [anon_sym_typename] = ACTIONS(3379),
    [anon_sym_template] = ACTIONS(3379),
    [anon_sym_operator] = ACTIONS(3379),
    [anon_sym_try] = ACTIONS(3379),
    [anon_sym_delete] = ACTIONS(3379),
    [anon_sym_throw] = ACTIONS(3379),
    [anon_sym_namespace] = ACTIONS(3379),
    [anon_sym_static_assert] = ACTIONS(3379),
    [anon_sym_concept] = ACTIONS(3379),
    [anon_sym_co_return] = ACTIONS(3379),
    [anon_sym_co_yield] = ACTIONS(3379),
    [anon_sym_R_DQUOTE] = ACTIONS(3381),
    [anon_sym_LR_DQUOTE] = ACTIONS(3381),
    [anon_sym_uR_DQUOTE] = ACTIONS(3381),
    [anon_sym_UR_DQUOTE] = ACTIONS(3381),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3381),
    [anon_sym_co_await] = ACTIONS(3379),
    [anon_sym_new] = ACTIONS(3379),
    [anon_sym_requires] = ACTIONS(3379),
    [sym_this] = ACTIONS(3379),
    [anon_sym_discard] = ACTIONS(3379),
    [anon_sym_precise] = ACTIONS(3379),
    [anon_sym_shared] = ACTIONS(3379),
    [anon_sym_groupshared] = ACTIONS(3379),
    [anon_sym_uniform] = ACTIONS(3379),
    [anon_sym_row_major] = ACTIONS(3379),
    [anon_sym_column_major] = ACTIONS(3379),
    [anon_sym_globallycoherent] = ACTIONS(3379),
    [anon_sym_centroid] = ACTIONS(3379),
    [anon_sym_noperspective] = ACTIONS(3379),
    [anon_sym_nointerpolation] = ACTIONS(3379),
    [anon_sym_sample] = ACTIONS(3379),
    [anon_sym_linear] = ACTIONS(3379),
    [anon_sym_snorm] = ACTIONS(3379),
    [anon_sym_unorm] = ACTIONS(3379),
    [anon_sym_point] = ACTIONS(3379),
    [anon_sym_line] = ACTIONS(3379),
    [anon_sym_triangleadj] = ACTIONS(3379),
    [anon_sym_lineadj] = ACTIONS(3379),
    [anon_sym_triangle] = ACTIONS(3379),
    [anon_sym_cbuffer] = ACTIONS(3379),
    [anon_sym_interface] = ACTIONS(3379),
    [anon_sym_extension] = ACTIONS(3379),
  },
  [816] = {
    [sym_identifier] = ACTIONS(3474),
    [aux_sym_preproc_include_token1] = ACTIONS(3474),
    [aux_sym_preproc_def_token1] = ACTIONS(3474),
    [aux_sym_preproc_if_token1] = ACTIONS(3474),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3474),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3474),
    [sym_preproc_directive] = ACTIONS(3474),
    [anon_sym_LPAREN2] = ACTIONS(3476),
    [anon_sym_BANG] = ACTIONS(3476),
    [anon_sym_TILDE] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3474),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_AMP_AMP] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3474),
    [anon_sym_SEMI] = ACTIONS(3476),
    [anon_sym___extension__] = ACTIONS(3474),
    [anon_sym_typedef] = ACTIONS(3474),
    [anon_sym_in] = ACTIONS(3474),
    [anon_sym_out] = ACTIONS(3474),
    [anon_sym_inout] = ACTIONS(3474),
    [anon_sym_virtual] = ACTIONS(3474),
    [anon_sym_extern] = ACTIONS(3474),
    [anon_sym___attribute__] = ACTIONS(3474),
    [anon_sym___attribute] = ACTIONS(3474),
    [anon_sym_using] = ACTIONS(3474),
    [anon_sym_COLON_COLON] = ACTIONS(3476),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3476),
    [anon_sym___declspec] = ACTIONS(3474),
    [anon_sym___based] = ACTIONS(3474),
    [anon_sym___cdecl] = ACTIONS(3474),
    [anon_sym___clrcall] = ACTIONS(3474),
    [anon_sym___stdcall] = ACTIONS(3474),
    [anon_sym___fastcall] = ACTIONS(3474),
    [anon_sym___thiscall] = ACTIONS(3474),
    [anon_sym___vectorcall] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_RBRACE] = ACTIONS(3476),
    [anon_sym_signed] = ACTIONS(3474),
    [anon_sym_unsigned] = ACTIONS(3474),
    [anon_sym_long] = ACTIONS(3474),
    [anon_sym_short] = ACTIONS(3474),
    [anon_sym_LBRACK] = ACTIONS(3474),
    [anon_sym_static] = ACTIONS(3474),
    [anon_sym_register] = ACTIONS(3474),
    [anon_sym_inline] = ACTIONS(3474),
    [anon_sym___inline] = ACTIONS(3474),
    [anon_sym___inline__] = ACTIONS(3474),
    [anon_sym___forceinline] = ACTIONS(3474),
    [anon_sym_thread_local] = ACTIONS(3474),
    [anon_sym___thread] = ACTIONS(3474),
    [anon_sym_const] = ACTIONS(3474),
    [anon_sym_constexpr] = ACTIONS(3474),
    [anon_sym_volatile] = ACTIONS(3474),
    [anon_sym_restrict] = ACTIONS(3474),
    [anon_sym___restrict__] = ACTIONS(3474),
    [anon_sym__Atomic] = ACTIONS(3474),
    [anon_sym__Noreturn] = ACTIONS(3474),
    [anon_sym_noreturn] = ACTIONS(3474),
    [anon_sym__Nonnull] = ACTIONS(3474),
    [anon_sym_mutable] = ACTIONS(3474),
    [anon_sym_constinit] = ACTIONS(3474),
    [anon_sym_consteval] = ACTIONS(3474),
    [anon_sym_alignas] = ACTIONS(3474),
    [anon_sym__Alignas] = ACTIONS(3474),
    [sym_primitive_type] = ACTIONS(3474),
    [anon_sym_enum] = ACTIONS(3474),
    [anon_sym_class] = ACTIONS(3474),
    [anon_sym_struct] = ACTIONS(3474),
    [anon_sym_union] = ACTIONS(3474),
    [anon_sym_if] = ACTIONS(3474),
    [anon_sym_else] = ACTIONS(3474),
    [anon_sym_switch] = ACTIONS(3474),
    [anon_sym_case] = ACTIONS(3474),
    [anon_sym_default] = ACTIONS(3474),
    [anon_sym_while] = ACTIONS(3474),
    [anon_sym_do] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3474),
    [anon_sym_return] = ACTIONS(3474),
    [anon_sym_break] = ACTIONS(3474),
    [anon_sym_continue] = ACTIONS(3474),
    [anon_sym_goto] = ACTIONS(3474),
    [anon_sym___try] = ACTIONS(3474),
    [anon_sym___leave] = ACTIONS(3474),
    [anon_sym_not] = ACTIONS(3474),
    [anon_sym_compl] = ACTIONS(3474),
    [anon_sym_DASH_DASH] = ACTIONS(3476),
    [anon_sym_PLUS_PLUS] = ACTIONS(3476),
    [anon_sym_sizeof] = ACTIONS(3474),
    [anon_sym___alignof__] = ACTIONS(3474),
    [anon_sym___alignof] = ACTIONS(3474),
    [anon_sym__alignof] = ACTIONS(3474),
    [anon_sym_alignof] = ACTIONS(3474),
    [anon_sym__Alignof] = ACTIONS(3474),
    [anon_sym_offsetof] = ACTIONS(3474),
    [anon_sym__Generic] = ACTIONS(3474),
    [anon_sym_asm] = ACTIONS(3474),
    [anon_sym___asm__] = ACTIONS(3474),
    [anon_sym___asm] = ACTIONS(3474),
    [sym_number_literal] = ACTIONS(3476),
    [anon_sym_L_SQUOTE] = ACTIONS(3476),
    [anon_sym_u_SQUOTE] = ACTIONS(3476),
    [anon_sym_U_SQUOTE] = ACTIONS(3476),
    [anon_sym_u8_SQUOTE] = ACTIONS(3476),
    [anon_sym_SQUOTE] = ACTIONS(3476),
    [anon_sym_L_DQUOTE] = ACTIONS(3476),
    [anon_sym_u_DQUOTE] = ACTIONS(3476),
    [anon_sym_U_DQUOTE] = ACTIONS(3476),
    [anon_sym_u8_DQUOTE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [sym_true] = ACTIONS(3474),
    [sym_false] = ACTIONS(3474),
    [anon_sym_NULL] = ACTIONS(3474),
    [anon_sym_nullptr] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3474),
    [anon_sym_let] = ACTIONS(3474),
    [anon_sym_This] = ACTIONS(3474),
    [anon_sym_decltype] = ACTIONS(3474),
    [anon_sym_explicit] = ACTIONS(3474),
    [anon_sym_typename] = ACTIONS(3474),
    [anon_sym_template] = ACTIONS(3474),
    [anon_sym_operator] = ACTIONS(3474),
    [anon_sym_try] = ACTIONS(3474),
    [anon_sym_delete] = ACTIONS(3474),
    [anon_sym_throw] = ACTIONS(3474),
    [anon_sym_namespace] = ACTIONS(3474),
    [anon_sym_static_assert] = ACTIONS(3474),
    [anon_sym_concept] = ACTIONS(3474),
    [anon_sym_co_return] = ACTIONS(3474),
    [anon_sym_co_yield] = ACTIONS(3474),
    [anon_sym_R_DQUOTE] = ACTIONS(3476),
    [anon_sym_LR_DQUOTE] = ACTIONS(3476),
    [anon_sym_uR_DQUOTE] = ACTIONS(3476),
    [anon_sym_UR_DQUOTE] = ACTIONS(3476),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3476),
    [anon_sym_co_await] = ACTIONS(3474),
    [anon_sym_new] = ACTIONS(3474),
    [anon_sym_requires] = ACTIONS(3474),
    [sym_this] = ACTIONS(3474),
    [anon_sym_discard] = ACTIONS(3474),
    [anon_sym_precise] = ACTIONS(3474),
    [anon_sym_shared] = ACTIONS(3474),
    [anon_sym_groupshared] = ACTIONS(3474),
    [anon_sym_uniform] = ACTIONS(3474),
    [anon_sym_row_major] = ACTIONS(3474),
    [anon_sym_column_major] = ACTIONS(3474),
    [anon_sym_globallycoherent] = ACTIONS(3474),
    [anon_sym_centroid] = ACTIONS(3474),
    [anon_sym_noperspective] = ACTIONS(3474),
    [anon_sym_nointerpolation] = ACTIONS(3474),
    [anon_sym_sample] = ACTIONS(3474),
    [anon_sym_linear] = ACTIONS(3474),
    [anon_sym_snorm] = ACTIONS(3474),
    [anon_sym_unorm] = ACTIONS(3474),
    [anon_sym_point] = ACTIONS(3474),
    [anon_sym_line] = ACTIONS(3474),
    [anon_sym_triangleadj] = ACTIONS(3474),
    [anon_sym_lineadj] = ACTIONS(3474),
    [anon_sym_triangle] = ACTIONS(3474),
    [anon_sym_cbuffer] = ACTIONS(3474),
    [anon_sym_interface] = ACTIONS(3474),
    [anon_sym_extension] = ACTIONS(3474),
  },
  [817] = {
    [sym_identifier] = ACTIONS(4248),
    [aux_sym_preproc_include_token1] = ACTIONS(4248),
    [aux_sym_preproc_def_token1] = ACTIONS(4248),
    [aux_sym_preproc_if_token1] = ACTIONS(4248),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4248),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4248),
    [sym_preproc_directive] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4250),
    [anon_sym_BANG] = ACTIONS(4250),
    [anon_sym_TILDE] = ACTIONS(4250),
    [anon_sym_DASH] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_AMP_AMP] = ACTIONS(4250),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4250),
    [anon_sym___extension__] = ACTIONS(4248),
    [anon_sym_typedef] = ACTIONS(4248),
    [anon_sym_in] = ACTIONS(4248),
    [anon_sym_out] = ACTIONS(4248),
    [anon_sym_inout] = ACTIONS(4248),
    [anon_sym_virtual] = ACTIONS(4248),
    [anon_sym_extern] = ACTIONS(4248),
    [anon_sym___attribute__] = ACTIONS(4248),
    [anon_sym___attribute] = ACTIONS(4248),
    [anon_sym_using] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4250),
    [anon_sym___declspec] = ACTIONS(4248),
    [anon_sym___based] = ACTIONS(4248),
    [anon_sym___cdecl] = ACTIONS(4248),
    [anon_sym___clrcall] = ACTIONS(4248),
    [anon_sym___stdcall] = ACTIONS(4248),
    [anon_sym___fastcall] = ACTIONS(4248),
    [anon_sym___thiscall] = ACTIONS(4248),
    [anon_sym___vectorcall] = ACTIONS(4248),
    [anon_sym_LBRACE] = ACTIONS(4250),
    [anon_sym_RBRACE] = ACTIONS(4250),
    [anon_sym_signed] = ACTIONS(4248),
    [anon_sym_unsigned] = ACTIONS(4248),
    [anon_sym_long] = ACTIONS(4248),
    [anon_sym_short] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_static] = ACTIONS(4248),
    [anon_sym_register] = ACTIONS(4248),
    [anon_sym_inline] = ACTIONS(4248),
    [anon_sym___inline] = ACTIONS(4248),
    [anon_sym___inline__] = ACTIONS(4248),
    [anon_sym___forceinline] = ACTIONS(4248),
    [anon_sym_thread_local] = ACTIONS(4248),
    [anon_sym___thread] = ACTIONS(4248),
    [anon_sym_const] = ACTIONS(4248),
    [anon_sym_constexpr] = ACTIONS(4248),
    [anon_sym_volatile] = ACTIONS(4248),
    [anon_sym_restrict] = ACTIONS(4248),
    [anon_sym___restrict__] = ACTIONS(4248),
    [anon_sym__Atomic] = ACTIONS(4248),
    [anon_sym__Noreturn] = ACTIONS(4248),
    [anon_sym_noreturn] = ACTIONS(4248),
    [anon_sym__Nonnull] = ACTIONS(4248),
    [anon_sym_mutable] = ACTIONS(4248),
    [anon_sym_constinit] = ACTIONS(4248),
    [anon_sym_consteval] = ACTIONS(4248),
    [anon_sym_alignas] = ACTIONS(4248),
    [anon_sym__Alignas] = ACTIONS(4248),
    [sym_primitive_type] = ACTIONS(4248),
    [anon_sym_enum] = ACTIONS(4248),
    [anon_sym_class] = ACTIONS(4248),
    [anon_sym_struct] = ACTIONS(4248),
    [anon_sym_union] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4248),
    [anon_sym_switch] = ACTIONS(4248),
    [anon_sym_case] = ACTIONS(4248),
    [anon_sym_default] = ACTIONS(4248),
    [anon_sym_while] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4248),
    [anon_sym_for] = ACTIONS(4248),
    [anon_sym_return] = ACTIONS(4248),
    [anon_sym_break] = ACTIONS(4248),
    [anon_sym_continue] = ACTIONS(4248),
    [anon_sym_goto] = ACTIONS(4248),
    [anon_sym___try] = ACTIONS(4248),
    [anon_sym___leave] = ACTIONS(4248),
    [anon_sym_not] = ACTIONS(4248),
    [anon_sym_compl] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4250),
    [anon_sym_PLUS_PLUS] = ACTIONS(4250),
    [anon_sym_sizeof] = ACTIONS(4248),
    [anon_sym___alignof__] = ACTIONS(4248),
    [anon_sym___alignof] = ACTIONS(4248),
    [anon_sym__alignof] = ACTIONS(4248),
    [anon_sym_alignof] = ACTIONS(4248),
    [anon_sym__Alignof] = ACTIONS(4248),
    [anon_sym_offsetof] = ACTIONS(4248),
    [anon_sym__Generic] = ACTIONS(4248),
    [anon_sym_asm] = ACTIONS(4248),
    [anon_sym___asm__] = ACTIONS(4248),
    [anon_sym___asm] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4248),
    [sym_number_literal] = ACTIONS(4250),
    [anon_sym_L_SQUOTE] = ACTIONS(4250),
    [anon_sym_u_SQUOTE] = ACTIONS(4250),
    [anon_sym_U_SQUOTE] = ACTIONS(4250),
    [anon_sym_u8_SQUOTE] = ACTIONS(4250),
    [anon_sym_SQUOTE] = ACTIONS(4250),
    [anon_sym_L_DQUOTE] = ACTIONS(4250),
    [anon_sym_u_DQUOTE] = ACTIONS(4250),
    [anon_sym_U_DQUOTE] = ACTIONS(4250),
    [anon_sym_u8_DQUOTE] = ACTIONS(4250),
    [anon_sym_DQUOTE] = ACTIONS(4250),
    [sym_true] = ACTIONS(4248),
    [sym_false] = ACTIONS(4248),
    [anon_sym_NULL] = ACTIONS(4248),
    [anon_sym_nullptr] = ACTIONS(4248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4248),
    [anon_sym_let] = ACTIONS(4248),
    [anon_sym_This] = ACTIONS(4248),
    [anon_sym_decltype] = ACTIONS(4248),
    [anon_sym_explicit] = ACTIONS(4248),
    [anon_sym_typename] = ACTIONS(4248),
    [anon_sym_template] = ACTIONS(4248),
    [anon_sym_operator] = ACTIONS(4248),
    [anon_sym_try] = ACTIONS(4248),
    [anon_sym_delete] = ACTIONS(4248),
    [anon_sym_throw] = ACTIONS(4248),
    [anon_sym_namespace] = ACTIONS(4248),
    [anon_sym_static_assert] = ACTIONS(4248),
    [anon_sym_concept] = ACTIONS(4248),
    [anon_sym_co_return] = ACTIONS(4248),
    [anon_sym_co_yield] = ACTIONS(4248),
    [anon_sym_R_DQUOTE] = ACTIONS(4250),
    [anon_sym_LR_DQUOTE] = ACTIONS(4250),
    [anon_sym_uR_DQUOTE] = ACTIONS(4250),
    [anon_sym_UR_DQUOTE] = ACTIONS(4250),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4250),
    [anon_sym_co_await] = ACTIONS(4248),
    [anon_sym_new] = ACTIONS(4248),
    [anon_sym_requires] = ACTIONS(4248),
    [sym_this] = ACTIONS(4248),
    [anon_sym_discard] = ACTIONS(4248),
    [anon_sym_precise] = ACTIONS(4248),
    [anon_sym_shared] = ACTIONS(4248),
    [anon_sym_groupshared] = ACTIONS(4248),
    [anon_sym_uniform] = ACTIONS(4248),
    [anon_sym_row_major] = ACTIONS(4248),
    [anon_sym_column_major] = ACTIONS(4248),
    [anon_sym_globallycoherent] = ACTIONS(4248),
    [anon_sym_centroid] = ACTIONS(4248),
    [anon_sym_noperspective] = ACTIONS(4248),
    [anon_sym_nointerpolation] = ACTIONS(4248),
    [anon_sym_sample] = ACTIONS(4248),
    [anon_sym_linear] = ACTIONS(4248),
    [anon_sym_snorm] = ACTIONS(4248),
    [anon_sym_unorm] = ACTIONS(4248),
    [anon_sym_point] = ACTIONS(4248),
    [anon_sym_line] = ACTIONS(4248),
    [anon_sym_triangleadj] = ACTIONS(4248),
    [anon_sym_lineadj] = ACTIONS(4248),
    [anon_sym_triangle] = ACTIONS(4248),
    [anon_sym_cbuffer] = ACTIONS(4248),
    [anon_sym_interface] = ACTIONS(4248),
    [anon_sym_extension] = ACTIONS(4248),
  },
  [818] = {
    [sym_identifier] = ACTIONS(2554),
    [aux_sym_preproc_include_token1] = ACTIONS(2554),
    [aux_sym_preproc_def_token1] = ACTIONS(2554),
    [aux_sym_preproc_if_token1] = ACTIONS(2554),
    [aux_sym_preproc_if_token2] = ACTIONS(2554),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2554),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2554),
    [sym_preproc_directive] = ACTIONS(2554),
    [anon_sym_LPAREN2] = ACTIONS(2552),
    [anon_sym_BANG] = ACTIONS(2552),
    [anon_sym_TILDE] = ACTIONS(2552),
    [anon_sym_DASH] = ACTIONS(2554),
    [anon_sym_PLUS] = ACTIONS(2554),
    [anon_sym_STAR] = ACTIONS(2552),
    [anon_sym_AMP_AMP] = ACTIONS(2552),
    [anon_sym_AMP] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym___extension__] = ACTIONS(2554),
    [anon_sym_typedef] = ACTIONS(2554),
    [anon_sym_in] = ACTIONS(2554),
    [anon_sym_out] = ACTIONS(2554),
    [anon_sym_inout] = ACTIONS(2554),
    [anon_sym_virtual] = ACTIONS(2554),
    [anon_sym_extern] = ACTIONS(2554),
    [anon_sym___attribute__] = ACTIONS(2554),
    [anon_sym___attribute] = ACTIONS(2554),
    [anon_sym_using] = ACTIONS(2554),
    [anon_sym_COLON_COLON] = ACTIONS(2552),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2552),
    [anon_sym___declspec] = ACTIONS(2554),
    [anon_sym___based] = ACTIONS(2554),
    [anon_sym___cdecl] = ACTIONS(2554),
    [anon_sym___clrcall] = ACTIONS(2554),
    [anon_sym___stdcall] = ACTIONS(2554),
    [anon_sym___fastcall] = ACTIONS(2554),
    [anon_sym___thiscall] = ACTIONS(2554),
    [anon_sym___vectorcall] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(2552),
    [anon_sym_signed] = ACTIONS(2554),
    [anon_sym_unsigned] = ACTIONS(2554),
    [anon_sym_long] = ACTIONS(2554),
    [anon_sym_short] = ACTIONS(2554),
    [anon_sym_LBRACK] = ACTIONS(2554),
    [anon_sym_static] = ACTIONS(2554),
    [anon_sym_register] = ACTIONS(2554),
    [anon_sym_inline] = ACTIONS(2554),
    [anon_sym___inline] = ACTIONS(2554),
    [anon_sym___inline__] = ACTIONS(2554),
    [anon_sym___forceinline] = ACTIONS(2554),
    [anon_sym_thread_local] = ACTIONS(2554),
    [anon_sym___thread] = ACTIONS(2554),
    [anon_sym_const] = ACTIONS(2554),
    [anon_sym_constexpr] = ACTIONS(2554),
    [anon_sym_volatile] = ACTIONS(2554),
    [anon_sym_restrict] = ACTIONS(2554),
    [anon_sym___restrict__] = ACTIONS(2554),
    [anon_sym__Atomic] = ACTIONS(2554),
    [anon_sym__Noreturn] = ACTIONS(2554),
    [anon_sym_noreturn] = ACTIONS(2554),
    [anon_sym__Nonnull] = ACTIONS(2554),
    [anon_sym_mutable] = ACTIONS(2554),
    [anon_sym_constinit] = ACTIONS(2554),
    [anon_sym_consteval] = ACTIONS(2554),
    [anon_sym_alignas] = ACTIONS(2554),
    [anon_sym__Alignas] = ACTIONS(2554),
    [sym_primitive_type] = ACTIONS(2554),
    [anon_sym_enum] = ACTIONS(2554),
    [anon_sym_class] = ACTIONS(2554),
    [anon_sym_struct] = ACTIONS(2554),
    [anon_sym_union] = ACTIONS(2554),
    [anon_sym_if] = ACTIONS(2554),
    [anon_sym_else] = ACTIONS(2554),
    [anon_sym_switch] = ACTIONS(2554),
    [anon_sym_case] = ACTIONS(2554),
    [anon_sym_default] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2554),
    [anon_sym_do] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2554),
    [anon_sym_return] = ACTIONS(2554),
    [anon_sym_break] = ACTIONS(2554),
    [anon_sym_continue] = ACTIONS(2554),
    [anon_sym_goto] = ACTIONS(2554),
    [anon_sym___try] = ACTIONS(2554),
    [anon_sym___leave] = ACTIONS(2554),
    [anon_sym_not] = ACTIONS(2554),
    [anon_sym_compl] = ACTIONS(2554),
    [anon_sym_DASH_DASH] = ACTIONS(2552),
    [anon_sym_PLUS_PLUS] = ACTIONS(2552),
    [anon_sym_sizeof] = ACTIONS(2554),
    [anon_sym___alignof__] = ACTIONS(2554),
    [anon_sym___alignof] = ACTIONS(2554),
    [anon_sym__alignof] = ACTIONS(2554),
    [anon_sym_alignof] = ACTIONS(2554),
    [anon_sym__Alignof] = ACTIONS(2554),
    [anon_sym_offsetof] = ACTIONS(2554),
    [anon_sym__Generic] = ACTIONS(2554),
    [anon_sym_asm] = ACTIONS(2554),
    [anon_sym___asm__] = ACTIONS(2554),
    [anon_sym___asm] = ACTIONS(2554),
    [sym_number_literal] = ACTIONS(2552),
    [anon_sym_L_SQUOTE] = ACTIONS(2552),
    [anon_sym_u_SQUOTE] = ACTIONS(2552),
    [anon_sym_U_SQUOTE] = ACTIONS(2552),
    [anon_sym_u8_SQUOTE] = ACTIONS(2552),
    [anon_sym_SQUOTE] = ACTIONS(2552),
    [anon_sym_L_DQUOTE] = ACTIONS(2552),
    [anon_sym_u_DQUOTE] = ACTIONS(2552),
    [anon_sym_U_DQUOTE] = ACTIONS(2552),
    [anon_sym_u8_DQUOTE] = ACTIONS(2552),
    [anon_sym_DQUOTE] = ACTIONS(2552),
    [sym_true] = ACTIONS(2554),
    [sym_false] = ACTIONS(2554),
    [anon_sym_NULL] = ACTIONS(2554),
    [anon_sym_nullptr] = ACTIONS(2554),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2554),
    [anon_sym_let] = ACTIONS(2554),
    [anon_sym_This] = ACTIONS(2554),
    [anon_sym_decltype] = ACTIONS(2554),
    [anon_sym_explicit] = ACTIONS(2554),
    [anon_sym_typename] = ACTIONS(2554),
    [anon_sym_template] = ACTIONS(2554),
    [anon_sym_operator] = ACTIONS(2554),
    [anon_sym_try] = ACTIONS(2554),
    [anon_sym_delete] = ACTIONS(2554),
    [anon_sym_throw] = ACTIONS(2554),
    [anon_sym_namespace] = ACTIONS(2554),
    [anon_sym_static_assert] = ACTIONS(2554),
    [anon_sym_concept] = ACTIONS(2554),
    [anon_sym_co_return] = ACTIONS(2554),
    [anon_sym_co_yield] = ACTIONS(2554),
    [anon_sym_R_DQUOTE] = ACTIONS(2552),
    [anon_sym_LR_DQUOTE] = ACTIONS(2552),
    [anon_sym_uR_DQUOTE] = ACTIONS(2552),
    [anon_sym_UR_DQUOTE] = ACTIONS(2552),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2552),
    [anon_sym_co_await] = ACTIONS(2554),
    [anon_sym_new] = ACTIONS(2554),
    [anon_sym_requires] = ACTIONS(2554),
    [sym_this] = ACTIONS(2554),
    [anon_sym_discard] = ACTIONS(2554),
    [anon_sym_precise] = ACTIONS(2554),
    [anon_sym_shared] = ACTIONS(2554),
    [anon_sym_groupshared] = ACTIONS(2554),
    [anon_sym_uniform] = ACTIONS(2554),
    [anon_sym_row_major] = ACTIONS(2554),
    [anon_sym_column_major] = ACTIONS(2554),
    [anon_sym_globallycoherent] = ACTIONS(2554),
    [anon_sym_centroid] = ACTIONS(2554),
    [anon_sym_noperspective] = ACTIONS(2554),
    [anon_sym_nointerpolation] = ACTIONS(2554),
    [anon_sym_sample] = ACTIONS(2554),
    [anon_sym_linear] = ACTIONS(2554),
    [anon_sym_snorm] = ACTIONS(2554),
    [anon_sym_unorm] = ACTIONS(2554),
    [anon_sym_point] = ACTIONS(2554),
    [anon_sym_line] = ACTIONS(2554),
    [anon_sym_triangleadj] = ACTIONS(2554),
    [anon_sym_lineadj] = ACTIONS(2554),
    [anon_sym_triangle] = ACTIONS(2554),
    [anon_sym_cbuffer] = ACTIONS(2554),
    [anon_sym_interface] = ACTIONS(2554),
    [anon_sym_extension] = ACTIONS(2554),
  },
  [819] = {
    [sym_identifier] = ACTIONS(4252),
    [aux_sym_preproc_include_token1] = ACTIONS(4252),
    [aux_sym_preproc_def_token1] = ACTIONS(4252),
    [aux_sym_preproc_if_token1] = ACTIONS(4252),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4252),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4252),
    [sym_preproc_directive] = ACTIONS(4252),
    [anon_sym_LPAREN2] = ACTIONS(4254),
    [anon_sym_BANG] = ACTIONS(4254),
    [anon_sym_TILDE] = ACTIONS(4254),
    [anon_sym_DASH] = ACTIONS(4252),
    [anon_sym_PLUS] = ACTIONS(4252),
    [anon_sym_STAR] = ACTIONS(4254),
    [anon_sym_AMP_AMP] = ACTIONS(4254),
    [anon_sym_AMP] = ACTIONS(4252),
    [anon_sym_SEMI] = ACTIONS(4254),
    [anon_sym___extension__] = ACTIONS(4252),
    [anon_sym_typedef] = ACTIONS(4252),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_out] = ACTIONS(4252),
    [anon_sym_inout] = ACTIONS(4252),
    [anon_sym_virtual] = ACTIONS(4252),
    [anon_sym_extern] = ACTIONS(4252),
    [anon_sym___attribute__] = ACTIONS(4252),
    [anon_sym___attribute] = ACTIONS(4252),
    [anon_sym_using] = ACTIONS(4252),
    [anon_sym_COLON_COLON] = ACTIONS(4254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4254),
    [anon_sym___declspec] = ACTIONS(4252),
    [anon_sym___based] = ACTIONS(4252),
    [anon_sym___cdecl] = ACTIONS(4252),
    [anon_sym___clrcall] = ACTIONS(4252),
    [anon_sym___stdcall] = ACTIONS(4252),
    [anon_sym___fastcall] = ACTIONS(4252),
    [anon_sym___thiscall] = ACTIONS(4252),
    [anon_sym___vectorcall] = ACTIONS(4252),
    [anon_sym_LBRACE] = ACTIONS(4254),
    [anon_sym_RBRACE] = ACTIONS(4254),
    [anon_sym_signed] = ACTIONS(4252),
    [anon_sym_unsigned] = ACTIONS(4252),
    [anon_sym_long] = ACTIONS(4252),
    [anon_sym_short] = ACTIONS(4252),
    [anon_sym_LBRACK] = ACTIONS(4252),
    [anon_sym_static] = ACTIONS(4252),
    [anon_sym_register] = ACTIONS(4252),
    [anon_sym_inline] = ACTIONS(4252),
    [anon_sym___inline] = ACTIONS(4252),
    [anon_sym___inline__] = ACTIONS(4252),
    [anon_sym___forceinline] = ACTIONS(4252),
    [anon_sym_thread_local] = ACTIONS(4252),
    [anon_sym___thread] = ACTIONS(4252),
    [anon_sym_const] = ACTIONS(4252),
    [anon_sym_constexpr] = ACTIONS(4252),
    [anon_sym_volatile] = ACTIONS(4252),
    [anon_sym_restrict] = ACTIONS(4252),
    [anon_sym___restrict__] = ACTIONS(4252),
    [anon_sym__Atomic] = ACTIONS(4252),
    [anon_sym__Noreturn] = ACTIONS(4252),
    [anon_sym_noreturn] = ACTIONS(4252),
    [anon_sym__Nonnull] = ACTIONS(4252),
    [anon_sym_mutable] = ACTIONS(4252),
    [anon_sym_constinit] = ACTIONS(4252),
    [anon_sym_consteval] = ACTIONS(4252),
    [anon_sym_alignas] = ACTIONS(4252),
    [anon_sym__Alignas] = ACTIONS(4252),
    [sym_primitive_type] = ACTIONS(4252),
    [anon_sym_enum] = ACTIONS(4252),
    [anon_sym_class] = ACTIONS(4252),
    [anon_sym_struct] = ACTIONS(4252),
    [anon_sym_union] = ACTIONS(4252),
    [anon_sym_if] = ACTIONS(4252),
    [anon_sym_switch] = ACTIONS(4252),
    [anon_sym_case] = ACTIONS(4252),
    [anon_sym_default] = ACTIONS(4252),
    [anon_sym_while] = ACTIONS(4252),
    [anon_sym_do] = ACTIONS(4252),
    [anon_sym_for] = ACTIONS(4252),
    [anon_sym_return] = ACTIONS(4252),
    [anon_sym_break] = ACTIONS(4252),
    [anon_sym_continue] = ACTIONS(4252),
    [anon_sym_goto] = ACTIONS(4252),
    [anon_sym___try] = ACTIONS(4252),
    [anon_sym___leave] = ACTIONS(4252),
    [anon_sym_not] = ACTIONS(4252),
    [anon_sym_compl] = ACTIONS(4252),
    [anon_sym_DASH_DASH] = ACTIONS(4254),
    [anon_sym_PLUS_PLUS] = ACTIONS(4254),
    [anon_sym_sizeof] = ACTIONS(4252),
    [anon_sym___alignof__] = ACTIONS(4252),
    [anon_sym___alignof] = ACTIONS(4252),
    [anon_sym__alignof] = ACTIONS(4252),
    [anon_sym_alignof] = ACTIONS(4252),
    [anon_sym__Alignof] = ACTIONS(4252),
    [anon_sym_offsetof] = ACTIONS(4252),
    [anon_sym__Generic] = ACTIONS(4252),
    [anon_sym_asm] = ACTIONS(4252),
    [anon_sym___asm__] = ACTIONS(4252),
    [anon_sym___asm] = ACTIONS(4252),
    [anon_sym_DOT] = ACTIONS(2647),
    [sym_number_literal] = ACTIONS(4254),
    [anon_sym_L_SQUOTE] = ACTIONS(4254),
    [anon_sym_u_SQUOTE] = ACTIONS(4254),
    [anon_sym_U_SQUOTE] = ACTIONS(4254),
    [anon_sym_u8_SQUOTE] = ACTIONS(4254),
    [anon_sym_SQUOTE] = ACTIONS(4254),
    [anon_sym_L_DQUOTE] = ACTIONS(4254),
    [anon_sym_u_DQUOTE] = ACTIONS(4254),
    [anon_sym_U_DQUOTE] = ACTIONS(4254),
    [anon_sym_u8_DQUOTE] = ACTIONS(4254),
    [anon_sym_DQUOTE] = ACTIONS(4254),
    [sym_true] = ACTIONS(4252),
    [sym_false] = ACTIONS(4252),
    [anon_sym_NULL] = ACTIONS(4252),
    [anon_sym_nullptr] = ACTIONS(4252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2649),
    [anon_sym_let] = ACTIONS(2649),
    [anon_sym_This] = ACTIONS(2649),
    [anon_sym_decltype] = ACTIONS(4252),
    [anon_sym_explicit] = ACTIONS(4252),
    [anon_sym_typename] = ACTIONS(4252),
    [anon_sym_template] = ACTIONS(4252),
    [anon_sym_operator] = ACTIONS(4252),
    [anon_sym_try] = ACTIONS(4252),
    [anon_sym_delete] = ACTIONS(4252),
    [anon_sym_throw] = ACTIONS(4252),
    [anon_sym_namespace] = ACTIONS(4252),
    [anon_sym_static_assert] = ACTIONS(4252),
    [anon_sym_concept] = ACTIONS(4252),
    [anon_sym_co_return] = ACTIONS(4252),
    [anon_sym_co_yield] = ACTIONS(4252),
    [anon_sym_R_DQUOTE] = ACTIONS(4254),
    [anon_sym_LR_DQUOTE] = ACTIONS(4254),
    [anon_sym_uR_DQUOTE] = ACTIONS(4254),
    [anon_sym_UR_DQUOTE] = ACTIONS(4254),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4254),
    [anon_sym_co_await] = ACTIONS(4252),
    [anon_sym_new] = ACTIONS(4252),
    [anon_sym_requires] = ACTIONS(4252),
    [sym_this] = ACTIONS(4252),
    [anon_sym_discard] = ACTIONS(4252),
    [anon_sym_precise] = ACTIONS(4252),
    [anon_sym_shared] = ACTIONS(4252),
    [anon_sym_groupshared] = ACTIONS(4252),
    [anon_sym_uniform] = ACTIONS(4252),
    [anon_sym_row_major] = ACTIONS(4252),
    [anon_sym_column_major] = ACTIONS(4252),
    [anon_sym_globallycoherent] = ACTIONS(4252),
    [anon_sym_centroid] = ACTIONS(4252),
    [anon_sym_noperspective] = ACTIONS(4252),
    [anon_sym_nointerpolation] = ACTIONS(4252),
    [anon_sym_sample] = ACTIONS(4252),
    [anon_sym_linear] = ACTIONS(4252),
    [anon_sym_snorm] = ACTIONS(4252),
    [anon_sym_unorm] = ACTIONS(4252),
    [anon_sym_point] = ACTIONS(4252),
    [anon_sym_line] = ACTIONS(4252),
    [anon_sym_triangleadj] = ACTIONS(4252),
    [anon_sym_lineadj] = ACTIONS(4252),
    [anon_sym_triangle] = ACTIONS(4252),
    [anon_sym_cbuffer] = ACTIONS(4252),
    [anon_sym_interface] = ACTIONS(4252),
    [anon_sym_extension] = ACTIONS(4252),
  },
  [820] = {
    [sym_identifier] = ACTIONS(3399),
    [aux_sym_preproc_include_token1] = ACTIONS(3399),
    [aux_sym_preproc_def_token1] = ACTIONS(3399),
    [aux_sym_preproc_if_token1] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3399),
    [sym_preproc_directive] = ACTIONS(3399),
    [anon_sym_LPAREN2] = ACTIONS(3401),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_STAR] = ACTIONS(3401),
    [anon_sym_AMP_AMP] = ACTIONS(3401),
    [anon_sym_AMP] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym___extension__] = ACTIONS(3399),
    [anon_sym_typedef] = ACTIONS(3399),
    [anon_sym_in] = ACTIONS(3399),
    [anon_sym_out] = ACTIONS(3399),
    [anon_sym_inout] = ACTIONS(3399),
    [anon_sym_virtual] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym___attribute__] = ACTIONS(3399),
    [anon_sym___attribute] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_COLON_COLON] = ACTIONS(3401),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3401),
    [anon_sym___declspec] = ACTIONS(3399),
    [anon_sym___based] = ACTIONS(3399),
    [anon_sym___cdecl] = ACTIONS(3399),
    [anon_sym___clrcall] = ACTIONS(3399),
    [anon_sym___stdcall] = ACTIONS(3399),
    [anon_sym___fastcall] = ACTIONS(3399),
    [anon_sym___thiscall] = ACTIONS(3399),
    [anon_sym___vectorcall] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_RBRACE] = ACTIONS(3401),
    [anon_sym_signed] = ACTIONS(3399),
    [anon_sym_unsigned] = ACTIONS(3399),
    [anon_sym_long] = ACTIONS(3399),
    [anon_sym_short] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_register] = ACTIONS(3399),
    [anon_sym_inline] = ACTIONS(3399),
    [anon_sym___inline] = ACTIONS(3399),
    [anon_sym___inline__] = ACTIONS(3399),
    [anon_sym___forceinline] = ACTIONS(3399),
    [anon_sym_thread_local] = ACTIONS(3399),
    [anon_sym___thread] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_constexpr] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym_restrict] = ACTIONS(3399),
    [anon_sym___restrict__] = ACTIONS(3399),
    [anon_sym__Atomic] = ACTIONS(3399),
    [anon_sym__Noreturn] = ACTIONS(3399),
    [anon_sym_noreturn] = ACTIONS(3399),
    [anon_sym__Nonnull] = ACTIONS(3399),
    [anon_sym_mutable] = ACTIONS(3399),
    [anon_sym_constinit] = ACTIONS(3399),
    [anon_sym_consteval] = ACTIONS(3399),
    [anon_sym_alignas] = ACTIONS(3399),
    [anon_sym__Alignas] = ACTIONS(3399),
    [sym_primitive_type] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_union] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_else] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_case] = ACTIONS(3399),
    [anon_sym_default] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_goto] = ACTIONS(3399),
    [anon_sym___try] = ACTIONS(3399),
    [anon_sym___leave] = ACTIONS(3399),
    [anon_sym_not] = ACTIONS(3399),
    [anon_sym_compl] = ACTIONS(3399),
    [anon_sym_DASH_DASH] = ACTIONS(3401),
    [anon_sym_PLUS_PLUS] = ACTIONS(3401),
    [anon_sym_sizeof] = ACTIONS(3399),
    [anon_sym___alignof__] = ACTIONS(3399),
    [anon_sym___alignof] = ACTIONS(3399),
    [anon_sym__alignof] = ACTIONS(3399),
    [anon_sym_alignof] = ACTIONS(3399),
    [anon_sym__Alignof] = ACTIONS(3399),
    [anon_sym_offsetof] = ACTIONS(3399),
    [anon_sym__Generic] = ACTIONS(3399),
    [anon_sym_asm] = ACTIONS(3399),
    [anon_sym___asm__] = ACTIONS(3399),
    [anon_sym___asm] = ACTIONS(3399),
    [sym_number_literal] = ACTIONS(3401),
    [anon_sym_L_SQUOTE] = ACTIONS(3401),
    [anon_sym_u_SQUOTE] = ACTIONS(3401),
    [anon_sym_U_SQUOTE] = ACTIONS(3401),
    [anon_sym_u8_SQUOTE] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(3401),
    [anon_sym_L_DQUOTE] = ACTIONS(3401),
    [anon_sym_u_DQUOTE] = ACTIONS(3401),
    [anon_sym_U_DQUOTE] = ACTIONS(3401),
    [anon_sym_u8_DQUOTE] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [sym_true] = ACTIONS(3399),
    [sym_false] = ACTIONS(3399),
    [anon_sym_NULL] = ACTIONS(3399),
    [anon_sym_nullptr] = ACTIONS(3399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_This] = ACTIONS(3399),
    [anon_sym_decltype] = ACTIONS(3399),
    [anon_sym_explicit] = ACTIONS(3399),
    [anon_sym_typename] = ACTIONS(3399),
    [anon_sym_template] = ACTIONS(3399),
    [anon_sym_operator] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_delete] = ACTIONS(3399),
    [anon_sym_throw] = ACTIONS(3399),
    [anon_sym_namespace] = ACTIONS(3399),
    [anon_sym_static_assert] = ACTIONS(3399),
    [anon_sym_concept] = ACTIONS(3399),
    [anon_sym_co_return] = ACTIONS(3399),
    [anon_sym_co_yield] = ACTIONS(3399),
    [anon_sym_R_DQUOTE] = ACTIONS(3401),
    [anon_sym_LR_DQUOTE] = ACTIONS(3401),
    [anon_sym_uR_DQUOTE] = ACTIONS(3401),
    [anon_sym_UR_DQUOTE] = ACTIONS(3401),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3401),
    [anon_sym_co_await] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_requires] = ACTIONS(3399),
    [sym_this] = ACTIONS(3399),
    [anon_sym_discard] = ACTIONS(3399),
    [anon_sym_precise] = ACTIONS(3399),
    [anon_sym_shared] = ACTIONS(3399),
    [anon_sym_groupshared] = ACTIONS(3399),
    [anon_sym_uniform] = ACTIONS(3399),
    [anon_sym_row_major] = ACTIONS(3399),
    [anon_sym_column_major] = ACTIONS(3399),
    [anon_sym_globallycoherent] = ACTIONS(3399),
    [anon_sym_centroid] = ACTIONS(3399),
    [anon_sym_noperspective] = ACTIONS(3399),
    [anon_sym_nointerpolation] = ACTIONS(3399),
    [anon_sym_sample] = ACTIONS(3399),
    [anon_sym_linear] = ACTIONS(3399),
    [anon_sym_snorm] = ACTIONS(3399),
    [anon_sym_unorm] = ACTIONS(3399),
    [anon_sym_point] = ACTIONS(3399),
    [anon_sym_line] = ACTIONS(3399),
    [anon_sym_triangleadj] = ACTIONS(3399),
    [anon_sym_lineadj] = ACTIONS(3399),
    [anon_sym_triangle] = ACTIONS(3399),
    [anon_sym_cbuffer] = ACTIONS(3399),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_extension] = ACTIONS(3399),
  },
  [821] = {
    [sym_identifier] = ACTIONS(3399),
    [aux_sym_preproc_include_token1] = ACTIONS(3399),
    [aux_sym_preproc_def_token1] = ACTIONS(3399),
    [aux_sym_preproc_if_token1] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3399),
    [sym_preproc_directive] = ACTIONS(3399),
    [anon_sym_LPAREN2] = ACTIONS(3401),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_STAR] = ACTIONS(3401),
    [anon_sym_AMP_AMP] = ACTIONS(3401),
    [anon_sym_AMP] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym___extension__] = ACTIONS(3399),
    [anon_sym_typedef] = ACTIONS(3399),
    [anon_sym_in] = ACTIONS(3399),
    [anon_sym_out] = ACTIONS(3399),
    [anon_sym_inout] = ACTIONS(3399),
    [anon_sym_virtual] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym___attribute__] = ACTIONS(3399),
    [anon_sym___attribute] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_COLON_COLON] = ACTIONS(3401),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3401),
    [anon_sym___declspec] = ACTIONS(3399),
    [anon_sym___based] = ACTIONS(3399),
    [anon_sym___cdecl] = ACTIONS(3399),
    [anon_sym___clrcall] = ACTIONS(3399),
    [anon_sym___stdcall] = ACTIONS(3399),
    [anon_sym___fastcall] = ACTIONS(3399),
    [anon_sym___thiscall] = ACTIONS(3399),
    [anon_sym___vectorcall] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_RBRACE] = ACTIONS(3401),
    [anon_sym_signed] = ACTIONS(3399),
    [anon_sym_unsigned] = ACTIONS(3399),
    [anon_sym_long] = ACTIONS(3399),
    [anon_sym_short] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_register] = ACTIONS(3399),
    [anon_sym_inline] = ACTIONS(3399),
    [anon_sym___inline] = ACTIONS(3399),
    [anon_sym___inline__] = ACTIONS(3399),
    [anon_sym___forceinline] = ACTIONS(3399),
    [anon_sym_thread_local] = ACTIONS(3399),
    [anon_sym___thread] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_constexpr] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym_restrict] = ACTIONS(3399),
    [anon_sym___restrict__] = ACTIONS(3399),
    [anon_sym__Atomic] = ACTIONS(3399),
    [anon_sym__Noreturn] = ACTIONS(3399),
    [anon_sym_noreturn] = ACTIONS(3399),
    [anon_sym__Nonnull] = ACTIONS(3399),
    [anon_sym_mutable] = ACTIONS(3399),
    [anon_sym_constinit] = ACTIONS(3399),
    [anon_sym_consteval] = ACTIONS(3399),
    [anon_sym_alignas] = ACTIONS(3399),
    [anon_sym__Alignas] = ACTIONS(3399),
    [sym_primitive_type] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_union] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_else] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_case] = ACTIONS(3399),
    [anon_sym_default] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_goto] = ACTIONS(3399),
    [anon_sym___try] = ACTIONS(3399),
    [anon_sym___leave] = ACTIONS(3399),
    [anon_sym_not] = ACTIONS(3399),
    [anon_sym_compl] = ACTIONS(3399),
    [anon_sym_DASH_DASH] = ACTIONS(3401),
    [anon_sym_PLUS_PLUS] = ACTIONS(3401),
    [anon_sym_sizeof] = ACTIONS(3399),
    [anon_sym___alignof__] = ACTIONS(3399),
    [anon_sym___alignof] = ACTIONS(3399),
    [anon_sym__alignof] = ACTIONS(3399),
    [anon_sym_alignof] = ACTIONS(3399),
    [anon_sym__Alignof] = ACTIONS(3399),
    [anon_sym_offsetof] = ACTIONS(3399),
    [anon_sym__Generic] = ACTIONS(3399),
    [anon_sym_asm] = ACTIONS(3399),
    [anon_sym___asm__] = ACTIONS(3399),
    [anon_sym___asm] = ACTIONS(3399),
    [sym_number_literal] = ACTIONS(3401),
    [anon_sym_L_SQUOTE] = ACTIONS(3401),
    [anon_sym_u_SQUOTE] = ACTIONS(3401),
    [anon_sym_U_SQUOTE] = ACTIONS(3401),
    [anon_sym_u8_SQUOTE] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(3401),
    [anon_sym_L_DQUOTE] = ACTIONS(3401),
    [anon_sym_u_DQUOTE] = ACTIONS(3401),
    [anon_sym_U_DQUOTE] = ACTIONS(3401),
    [anon_sym_u8_DQUOTE] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [sym_true] = ACTIONS(3399),
    [sym_false] = ACTIONS(3399),
    [anon_sym_NULL] = ACTIONS(3399),
    [anon_sym_nullptr] = ACTIONS(3399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_This] = ACTIONS(3399),
    [anon_sym_decltype] = ACTIONS(3399),
    [anon_sym_explicit] = ACTIONS(3399),
    [anon_sym_typename] = ACTIONS(3399),
    [anon_sym_template] = ACTIONS(3399),
    [anon_sym_operator] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_delete] = ACTIONS(3399),
    [anon_sym_throw] = ACTIONS(3399),
    [anon_sym_namespace] = ACTIONS(3399),
    [anon_sym_static_assert] = ACTIONS(3399),
    [anon_sym_concept] = ACTIONS(3399),
    [anon_sym_co_return] = ACTIONS(3399),
    [anon_sym_co_yield] = ACTIONS(3399),
    [anon_sym_R_DQUOTE] = ACTIONS(3401),
    [anon_sym_LR_DQUOTE] = ACTIONS(3401),
    [anon_sym_uR_DQUOTE] = ACTIONS(3401),
    [anon_sym_UR_DQUOTE] = ACTIONS(3401),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3401),
    [anon_sym_co_await] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_requires] = ACTIONS(3399),
    [sym_this] = ACTIONS(3399),
    [anon_sym_discard] = ACTIONS(3399),
    [anon_sym_precise] = ACTIONS(3399),
    [anon_sym_shared] = ACTIONS(3399),
    [anon_sym_groupshared] = ACTIONS(3399),
    [anon_sym_uniform] = ACTIONS(3399),
    [anon_sym_row_major] = ACTIONS(3399),
    [anon_sym_column_major] = ACTIONS(3399),
    [anon_sym_globallycoherent] = ACTIONS(3399),
    [anon_sym_centroid] = ACTIONS(3399),
    [anon_sym_noperspective] = ACTIONS(3399),
    [anon_sym_nointerpolation] = ACTIONS(3399),
    [anon_sym_sample] = ACTIONS(3399),
    [anon_sym_linear] = ACTIONS(3399),
    [anon_sym_snorm] = ACTIONS(3399),
    [anon_sym_unorm] = ACTIONS(3399),
    [anon_sym_point] = ACTIONS(3399),
    [anon_sym_line] = ACTIONS(3399),
    [anon_sym_triangleadj] = ACTIONS(3399),
    [anon_sym_lineadj] = ACTIONS(3399),
    [anon_sym_triangle] = ACTIONS(3399),
    [anon_sym_cbuffer] = ACTIONS(3399),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_extension] = ACTIONS(3399),
  },
  [822] = {
    [sym_identifier] = ACTIONS(3403),
    [aux_sym_preproc_include_token1] = ACTIONS(3403),
    [aux_sym_preproc_def_token1] = ACTIONS(3403),
    [aux_sym_preproc_if_token1] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3403),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3403),
    [sym_preproc_directive] = ACTIONS(3403),
    [anon_sym_LPAREN2] = ACTIONS(3405),
    [anon_sym_BANG] = ACTIONS(3405),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_DASH] = ACTIONS(3403),
    [anon_sym_PLUS] = ACTIONS(3403),
    [anon_sym_STAR] = ACTIONS(3405),
    [anon_sym_AMP_AMP] = ACTIONS(3405),
    [anon_sym_AMP] = ACTIONS(3403),
    [anon_sym_SEMI] = ACTIONS(3405),
    [anon_sym___extension__] = ACTIONS(3403),
    [anon_sym_typedef] = ACTIONS(3403),
    [anon_sym_in] = ACTIONS(3403),
    [anon_sym_out] = ACTIONS(3403),
    [anon_sym_inout] = ACTIONS(3403),
    [anon_sym_virtual] = ACTIONS(3403),
    [anon_sym_extern] = ACTIONS(3403),
    [anon_sym___attribute__] = ACTIONS(3403),
    [anon_sym___attribute] = ACTIONS(3403),
    [anon_sym_using] = ACTIONS(3403),
    [anon_sym_COLON_COLON] = ACTIONS(3405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3405),
    [anon_sym___declspec] = ACTIONS(3403),
    [anon_sym___based] = ACTIONS(3403),
    [anon_sym___cdecl] = ACTIONS(3403),
    [anon_sym___clrcall] = ACTIONS(3403),
    [anon_sym___stdcall] = ACTIONS(3403),
    [anon_sym___fastcall] = ACTIONS(3403),
    [anon_sym___thiscall] = ACTIONS(3403),
    [anon_sym___vectorcall] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3405),
    [anon_sym_RBRACE] = ACTIONS(3405),
    [anon_sym_signed] = ACTIONS(3403),
    [anon_sym_unsigned] = ACTIONS(3403),
    [anon_sym_long] = ACTIONS(3403),
    [anon_sym_short] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3403),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_register] = ACTIONS(3403),
    [anon_sym_inline] = ACTIONS(3403),
    [anon_sym___inline] = ACTIONS(3403),
    [anon_sym___inline__] = ACTIONS(3403),
    [anon_sym___forceinline] = ACTIONS(3403),
    [anon_sym_thread_local] = ACTIONS(3403),
    [anon_sym___thread] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_constexpr] = ACTIONS(3403),
    [anon_sym_volatile] = ACTIONS(3403),
    [anon_sym_restrict] = ACTIONS(3403),
    [anon_sym___restrict__] = ACTIONS(3403),
    [anon_sym__Atomic] = ACTIONS(3403),
    [anon_sym__Noreturn] = ACTIONS(3403),
    [anon_sym_noreturn] = ACTIONS(3403),
    [anon_sym__Nonnull] = ACTIONS(3403),
    [anon_sym_mutable] = ACTIONS(3403),
    [anon_sym_constinit] = ACTIONS(3403),
    [anon_sym_consteval] = ACTIONS(3403),
    [anon_sym_alignas] = ACTIONS(3403),
    [anon_sym__Alignas] = ACTIONS(3403),
    [sym_primitive_type] = ACTIONS(3403),
    [anon_sym_enum] = ACTIONS(3403),
    [anon_sym_class] = ACTIONS(3403),
    [anon_sym_struct] = ACTIONS(3403),
    [anon_sym_union] = ACTIONS(3403),
    [anon_sym_if] = ACTIONS(3403),
    [anon_sym_else] = ACTIONS(3403),
    [anon_sym_switch] = ACTIONS(3403),
    [anon_sym_case] = ACTIONS(3403),
    [anon_sym_default] = ACTIONS(3403),
    [anon_sym_while] = ACTIONS(3403),
    [anon_sym_do] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3403),
    [anon_sym_return] = ACTIONS(3403),
    [anon_sym_break] = ACTIONS(3403),
    [anon_sym_continue] = ACTIONS(3403),
    [anon_sym_goto] = ACTIONS(3403),
    [anon_sym___try] = ACTIONS(3403),
    [anon_sym___leave] = ACTIONS(3403),
    [anon_sym_not] = ACTIONS(3403),
    [anon_sym_compl] = ACTIONS(3403),
    [anon_sym_DASH_DASH] = ACTIONS(3405),
    [anon_sym_PLUS_PLUS] = ACTIONS(3405),
    [anon_sym_sizeof] = ACTIONS(3403),
    [anon_sym___alignof__] = ACTIONS(3403),
    [anon_sym___alignof] = ACTIONS(3403),
    [anon_sym__alignof] = ACTIONS(3403),
    [anon_sym_alignof] = ACTIONS(3403),
    [anon_sym__Alignof] = ACTIONS(3403),
    [anon_sym_offsetof] = ACTIONS(3403),
    [anon_sym__Generic] = ACTIONS(3403),
    [anon_sym_asm] = ACTIONS(3403),
    [anon_sym___asm__] = ACTIONS(3403),
    [anon_sym___asm] = ACTIONS(3403),
    [sym_number_literal] = ACTIONS(3405),
    [anon_sym_L_SQUOTE] = ACTIONS(3405),
    [anon_sym_u_SQUOTE] = ACTIONS(3405),
    [anon_sym_U_SQUOTE] = ACTIONS(3405),
    [anon_sym_u8_SQUOTE] = ACTIONS(3405),
    [anon_sym_SQUOTE] = ACTIONS(3405),
    [anon_sym_L_DQUOTE] = ACTIONS(3405),
    [anon_sym_u_DQUOTE] = ACTIONS(3405),
    [anon_sym_U_DQUOTE] = ACTIONS(3405),
    [anon_sym_u8_DQUOTE] = ACTIONS(3405),
    [anon_sym_DQUOTE] = ACTIONS(3405),
    [sym_true] = ACTIONS(3403),
    [sym_false] = ACTIONS(3403),
    [anon_sym_NULL] = ACTIONS(3403),
    [anon_sym_nullptr] = ACTIONS(3403),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3403),
    [anon_sym_let] = ACTIONS(3403),
    [anon_sym_This] = ACTIONS(3403),
    [anon_sym_decltype] = ACTIONS(3403),
    [anon_sym_explicit] = ACTIONS(3403),
    [anon_sym_typename] = ACTIONS(3403),
    [anon_sym_template] = ACTIONS(3403),
    [anon_sym_operator] = ACTIONS(3403),
    [anon_sym_try] = ACTIONS(3403),
    [anon_sym_delete] = ACTIONS(3403),
    [anon_sym_throw] = ACTIONS(3403),
    [anon_sym_namespace] = ACTIONS(3403),
    [anon_sym_static_assert] = ACTIONS(3403),
    [anon_sym_concept] = ACTIONS(3403),
    [anon_sym_co_return] = ACTIONS(3403),
    [anon_sym_co_yield] = ACTIONS(3403),
    [anon_sym_R_DQUOTE] = ACTIONS(3405),
    [anon_sym_LR_DQUOTE] = ACTIONS(3405),
    [anon_sym_uR_DQUOTE] = ACTIONS(3405),
    [anon_sym_UR_DQUOTE] = ACTIONS(3405),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3405),
    [anon_sym_co_await] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3403),
    [anon_sym_requires] = ACTIONS(3403),
    [sym_this] = ACTIONS(3403),
    [anon_sym_discard] = ACTIONS(3403),
    [anon_sym_precise] = ACTIONS(3403),
    [anon_sym_shared] = ACTIONS(3403),
    [anon_sym_groupshared] = ACTIONS(3403),
    [anon_sym_uniform] = ACTIONS(3403),
    [anon_sym_row_major] = ACTIONS(3403),
    [anon_sym_column_major] = ACTIONS(3403),
    [anon_sym_globallycoherent] = ACTIONS(3403),
    [anon_sym_centroid] = ACTIONS(3403),
    [anon_sym_noperspective] = ACTIONS(3403),
    [anon_sym_nointerpolation] = ACTIONS(3403),
    [anon_sym_sample] = ACTIONS(3403),
    [anon_sym_linear] = ACTIONS(3403),
    [anon_sym_snorm] = ACTIONS(3403),
    [anon_sym_unorm] = ACTIONS(3403),
    [anon_sym_point] = ACTIONS(3403),
    [anon_sym_line] = ACTIONS(3403),
    [anon_sym_triangleadj] = ACTIONS(3403),
    [anon_sym_lineadj] = ACTIONS(3403),
    [anon_sym_triangle] = ACTIONS(3403),
    [anon_sym_cbuffer] = ACTIONS(3403),
    [anon_sym_interface] = ACTIONS(3403),
    [anon_sym_extension] = ACTIONS(3403),
  },
  [823] = {
    [sym_identifier] = ACTIONS(3407),
    [aux_sym_preproc_include_token1] = ACTIONS(3407),
    [aux_sym_preproc_def_token1] = ACTIONS(3407),
    [aux_sym_preproc_if_token1] = ACTIONS(3407),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3407),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3407),
    [sym_preproc_directive] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3409),
    [anon_sym_TILDE] = ACTIONS(3409),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_AMP_AMP] = ACTIONS(3409),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym_SEMI] = ACTIONS(3409),
    [anon_sym___extension__] = ACTIONS(3407),
    [anon_sym_typedef] = ACTIONS(3407),
    [anon_sym_in] = ACTIONS(3407),
    [anon_sym_out] = ACTIONS(3407),
    [anon_sym_inout] = ACTIONS(3407),
    [anon_sym_virtual] = ACTIONS(3407),
    [anon_sym_extern] = ACTIONS(3407),
    [anon_sym___attribute__] = ACTIONS(3407),
    [anon_sym___attribute] = ACTIONS(3407),
    [anon_sym_using] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3409),
    [anon_sym___declspec] = ACTIONS(3407),
    [anon_sym___based] = ACTIONS(3407),
    [anon_sym___cdecl] = ACTIONS(3407),
    [anon_sym___clrcall] = ACTIONS(3407),
    [anon_sym___stdcall] = ACTIONS(3407),
    [anon_sym___fastcall] = ACTIONS(3407),
    [anon_sym___thiscall] = ACTIONS(3407),
    [anon_sym___vectorcall] = ACTIONS(3407),
    [anon_sym_LBRACE] = ACTIONS(3409),
    [anon_sym_RBRACE] = ACTIONS(3409),
    [anon_sym_signed] = ACTIONS(3407),
    [anon_sym_unsigned] = ACTIONS(3407),
    [anon_sym_long] = ACTIONS(3407),
    [anon_sym_short] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_register] = ACTIONS(3407),
    [anon_sym_inline] = ACTIONS(3407),
    [anon_sym___inline] = ACTIONS(3407),
    [anon_sym___inline__] = ACTIONS(3407),
    [anon_sym___forceinline] = ACTIONS(3407),
    [anon_sym_thread_local] = ACTIONS(3407),
    [anon_sym___thread] = ACTIONS(3407),
    [anon_sym_const] = ACTIONS(3407),
    [anon_sym_constexpr] = ACTIONS(3407),
    [anon_sym_volatile] = ACTIONS(3407),
    [anon_sym_restrict] = ACTIONS(3407),
    [anon_sym___restrict__] = ACTIONS(3407),
    [anon_sym__Atomic] = ACTIONS(3407),
    [anon_sym__Noreturn] = ACTIONS(3407),
    [anon_sym_noreturn] = ACTIONS(3407),
    [anon_sym__Nonnull] = ACTIONS(3407),
    [anon_sym_mutable] = ACTIONS(3407),
    [anon_sym_constinit] = ACTIONS(3407),
    [anon_sym_consteval] = ACTIONS(3407),
    [anon_sym_alignas] = ACTIONS(3407),
    [anon_sym__Alignas] = ACTIONS(3407),
    [sym_primitive_type] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3407),
    [anon_sym_class] = ACTIONS(3407),
    [anon_sym_struct] = ACTIONS(3407),
    [anon_sym_union] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_else] = ACTIONS(3407),
    [anon_sym_switch] = ACTIONS(3407),
    [anon_sym_case] = ACTIONS(3407),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_break] = ACTIONS(3407),
    [anon_sym_continue] = ACTIONS(3407),
    [anon_sym_goto] = ACTIONS(3407),
    [anon_sym___try] = ACTIONS(3407),
    [anon_sym___leave] = ACTIONS(3407),
    [anon_sym_not] = ACTIONS(3407),
    [anon_sym_compl] = ACTIONS(3407),
    [anon_sym_DASH_DASH] = ACTIONS(3409),
    [anon_sym_PLUS_PLUS] = ACTIONS(3409),
    [anon_sym_sizeof] = ACTIONS(3407),
    [anon_sym___alignof__] = ACTIONS(3407),
    [anon_sym___alignof] = ACTIONS(3407),
    [anon_sym__alignof] = ACTIONS(3407),
    [anon_sym_alignof] = ACTIONS(3407),
    [anon_sym__Alignof] = ACTIONS(3407),
    [anon_sym_offsetof] = ACTIONS(3407),
    [anon_sym__Generic] = ACTIONS(3407),
    [anon_sym_asm] = ACTIONS(3407),
    [anon_sym___asm__] = ACTIONS(3407),
    [anon_sym___asm] = ACTIONS(3407),
    [sym_number_literal] = ACTIONS(3409),
    [anon_sym_L_SQUOTE] = ACTIONS(3409),
    [anon_sym_u_SQUOTE] = ACTIONS(3409),
    [anon_sym_U_SQUOTE] = ACTIONS(3409),
    [anon_sym_u8_SQUOTE] = ACTIONS(3409),
    [anon_sym_SQUOTE] = ACTIONS(3409),
    [anon_sym_L_DQUOTE] = ACTIONS(3409),
    [anon_sym_u_DQUOTE] = ACTIONS(3409),
    [anon_sym_U_DQUOTE] = ACTIONS(3409),
    [anon_sym_u8_DQUOTE] = ACTIONS(3409),
    [anon_sym_DQUOTE] = ACTIONS(3409),
    [sym_true] = ACTIONS(3407),
    [sym_false] = ACTIONS(3407),
    [anon_sym_NULL] = ACTIONS(3407),
    [anon_sym_nullptr] = ACTIONS(3407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_This] = ACTIONS(3407),
    [anon_sym_decltype] = ACTIONS(3407),
    [anon_sym_explicit] = ACTIONS(3407),
    [anon_sym_typename] = ACTIONS(3407),
    [anon_sym_template] = ACTIONS(3407),
    [anon_sym_operator] = ACTIONS(3407),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_delete] = ACTIONS(3407),
    [anon_sym_throw] = ACTIONS(3407),
    [anon_sym_namespace] = ACTIONS(3407),
    [anon_sym_static_assert] = ACTIONS(3407),
    [anon_sym_concept] = ACTIONS(3407),
    [anon_sym_co_return] = ACTIONS(3407),
    [anon_sym_co_yield] = ACTIONS(3407),
    [anon_sym_R_DQUOTE] = ACTIONS(3409),
    [anon_sym_LR_DQUOTE] = ACTIONS(3409),
    [anon_sym_uR_DQUOTE] = ACTIONS(3409),
    [anon_sym_UR_DQUOTE] = ACTIONS(3409),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3409),
    [anon_sym_co_await] = ACTIONS(3407),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_requires] = ACTIONS(3407),
    [sym_this] = ACTIONS(3407),
    [anon_sym_discard] = ACTIONS(3407),
    [anon_sym_precise] = ACTIONS(3407),
    [anon_sym_shared] = ACTIONS(3407),
    [anon_sym_groupshared] = ACTIONS(3407),
    [anon_sym_uniform] = ACTIONS(3407),
    [anon_sym_row_major] = ACTIONS(3407),
    [anon_sym_column_major] = ACTIONS(3407),
    [anon_sym_globallycoherent] = ACTIONS(3407),
    [anon_sym_centroid] = ACTIONS(3407),
    [anon_sym_noperspective] = ACTIONS(3407),
    [anon_sym_nointerpolation] = ACTIONS(3407),
    [anon_sym_sample] = ACTIONS(3407),
    [anon_sym_linear] = ACTIONS(3407),
    [anon_sym_snorm] = ACTIONS(3407),
    [anon_sym_unorm] = ACTIONS(3407),
    [anon_sym_point] = ACTIONS(3407),
    [anon_sym_line] = ACTIONS(3407),
    [anon_sym_triangleadj] = ACTIONS(3407),
    [anon_sym_lineadj] = ACTIONS(3407),
    [anon_sym_triangle] = ACTIONS(3407),
    [anon_sym_cbuffer] = ACTIONS(3407),
    [anon_sym_interface] = ACTIONS(3407),
    [anon_sym_extension] = ACTIONS(3407),
  },
  [824] = {
    [sym_identifier] = ACTIONS(3362),
    [aux_sym_preproc_include_token1] = ACTIONS(3362),
    [aux_sym_preproc_def_token1] = ACTIONS(3362),
    [aux_sym_preproc_if_token1] = ACTIONS(3362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3362),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3362),
    [sym_preproc_directive] = ACTIONS(3362),
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_BANG] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [anon_sym_DASH] = ACTIONS(3362),
    [anon_sym_PLUS] = ACTIONS(3362),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym_typedef] = ACTIONS(3362),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_using] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3352),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym___cdecl] = ACTIONS(3362),
    [anon_sym___clrcall] = ACTIONS(3362),
    [anon_sym___stdcall] = ACTIONS(3362),
    [anon_sym___fastcall] = ACTIONS(3362),
    [anon_sym___thiscall] = ACTIONS(3362),
    [anon_sym___vectorcall] = ACTIONS(3362),
    [anon_sym_LBRACE] = ACTIONS(3352),
    [anon_sym_RBRACE] = ACTIONS(3352),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3362),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3362),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [anon_sym_if] = ACTIONS(3362),
    [anon_sym_switch] = ACTIONS(3362),
    [anon_sym_case] = ACTIONS(3362),
    [anon_sym_default] = ACTIONS(3362),
    [anon_sym_while] = ACTIONS(3362),
    [anon_sym_do] = ACTIONS(3362),
    [anon_sym_for] = ACTIONS(3362),
    [anon_sym_return] = ACTIONS(3362),
    [anon_sym_break] = ACTIONS(3362),
    [anon_sym_continue] = ACTIONS(3362),
    [anon_sym_goto] = ACTIONS(3362),
    [anon_sym___try] = ACTIONS(3362),
    [anon_sym___leave] = ACTIONS(3362),
    [anon_sym_not] = ACTIONS(3362),
    [anon_sym_compl] = ACTIONS(3362),
    [anon_sym_DASH_DASH] = ACTIONS(3352),
    [anon_sym_PLUS_PLUS] = ACTIONS(3352),
    [anon_sym_sizeof] = ACTIONS(3362),
    [anon_sym___alignof__] = ACTIONS(3362),
    [anon_sym___alignof] = ACTIONS(3362),
    [anon_sym__alignof] = ACTIONS(3362),
    [anon_sym_alignof] = ACTIONS(3362),
    [anon_sym__Alignof] = ACTIONS(3362),
    [anon_sym_offsetof] = ACTIONS(3362),
    [anon_sym__Generic] = ACTIONS(3362),
    [anon_sym_asm] = ACTIONS(3362),
    [anon_sym___asm__] = ACTIONS(3362),
    [anon_sym___asm] = ACTIONS(3362),
    [anon_sym_DOT] = ACTIONS(3362),
    [sym_number_literal] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3352),
    [anon_sym_u_SQUOTE] = ACTIONS(3352),
    [anon_sym_U_SQUOTE] = ACTIONS(3352),
    [anon_sym_u8_SQUOTE] = ACTIONS(3352),
    [anon_sym_SQUOTE] = ACTIONS(3352),
    [anon_sym_L_DQUOTE] = ACTIONS(3352),
    [anon_sym_u_DQUOTE] = ACTIONS(3352),
    [anon_sym_U_DQUOTE] = ACTIONS(3352),
    [anon_sym_u8_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3352),
    [sym_true] = ACTIONS(3362),
    [sym_false] = ACTIONS(3362),
    [anon_sym_NULL] = ACTIONS(3362),
    [anon_sym_nullptr] = ACTIONS(3362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3362),
    [anon_sym_explicit] = ACTIONS(3362),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3362),
    [anon_sym_operator] = ACTIONS(3362),
    [anon_sym_try] = ACTIONS(3362),
    [anon_sym_delete] = ACTIONS(3362),
    [anon_sym_throw] = ACTIONS(3362),
    [anon_sym_namespace] = ACTIONS(3362),
    [anon_sym_static_assert] = ACTIONS(3362),
    [anon_sym_concept] = ACTIONS(3362),
    [anon_sym_co_return] = ACTIONS(3362),
    [anon_sym_co_yield] = ACTIONS(3362),
    [anon_sym_R_DQUOTE] = ACTIONS(3352),
    [anon_sym_LR_DQUOTE] = ACTIONS(3352),
    [anon_sym_uR_DQUOTE] = ACTIONS(3352),
    [anon_sym_UR_DQUOTE] = ACTIONS(3352),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3352),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(3362),
    [anon_sym_requires] = ACTIONS(3362),
    [sym_this] = ACTIONS(3362),
    [anon_sym_discard] = ACTIONS(3362),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_cbuffer] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [825] = {
    [sym_identifier] = ACTIONS(4242),
    [aux_sym_preproc_include_token1] = ACTIONS(4242),
    [aux_sym_preproc_def_token1] = ACTIONS(4242),
    [aux_sym_preproc_if_token1] = ACTIONS(4242),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4242),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4242),
    [sym_preproc_directive] = ACTIONS(4242),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_BANG] = ACTIONS(4240),
    [anon_sym_TILDE] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4242),
    [anon_sym_PLUS] = ACTIONS(4242),
    [anon_sym_STAR] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_AMP] = ACTIONS(4242),
    [anon_sym_SEMI] = ACTIONS(4240),
    [anon_sym___extension__] = ACTIONS(4242),
    [anon_sym_typedef] = ACTIONS(4242),
    [anon_sym_in] = ACTIONS(4242),
    [anon_sym_out] = ACTIONS(4242),
    [anon_sym_inout] = ACTIONS(4242),
    [anon_sym_virtual] = ACTIONS(4242),
    [anon_sym_extern] = ACTIONS(4242),
    [anon_sym___attribute__] = ACTIONS(4242),
    [anon_sym___attribute] = ACTIONS(4242),
    [anon_sym_using] = ACTIONS(4242),
    [anon_sym_COLON_COLON] = ACTIONS(4240),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4240),
    [anon_sym___declspec] = ACTIONS(4242),
    [anon_sym___based] = ACTIONS(4242),
    [anon_sym___cdecl] = ACTIONS(4242),
    [anon_sym___clrcall] = ACTIONS(4242),
    [anon_sym___stdcall] = ACTIONS(4242),
    [anon_sym___fastcall] = ACTIONS(4242),
    [anon_sym___thiscall] = ACTIONS(4242),
    [anon_sym___vectorcall] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_RBRACE] = ACTIONS(4240),
    [anon_sym_signed] = ACTIONS(4242),
    [anon_sym_unsigned] = ACTIONS(4242),
    [anon_sym_long] = ACTIONS(4242),
    [anon_sym_short] = ACTIONS(4242),
    [anon_sym_LBRACK] = ACTIONS(4242),
    [anon_sym_static] = ACTIONS(4242),
    [anon_sym_register] = ACTIONS(4242),
    [anon_sym_inline] = ACTIONS(4242),
    [anon_sym___inline] = ACTIONS(4242),
    [anon_sym___inline__] = ACTIONS(4242),
    [anon_sym___forceinline] = ACTIONS(4242),
    [anon_sym_thread_local] = ACTIONS(4242),
    [anon_sym___thread] = ACTIONS(4242),
    [anon_sym_const] = ACTIONS(4242),
    [anon_sym_constexpr] = ACTIONS(4242),
    [anon_sym_volatile] = ACTIONS(4242),
    [anon_sym_restrict] = ACTIONS(4242),
    [anon_sym___restrict__] = ACTIONS(4242),
    [anon_sym__Atomic] = ACTIONS(4242),
    [anon_sym__Noreturn] = ACTIONS(4242),
    [anon_sym_noreturn] = ACTIONS(4242),
    [anon_sym__Nonnull] = ACTIONS(4242),
    [anon_sym_mutable] = ACTIONS(4242),
    [anon_sym_constinit] = ACTIONS(4242),
    [anon_sym_consteval] = ACTIONS(4242),
    [anon_sym_alignas] = ACTIONS(4242),
    [anon_sym__Alignas] = ACTIONS(4242),
    [sym_primitive_type] = ACTIONS(4242),
    [anon_sym_enum] = ACTIONS(4242),
    [anon_sym_class] = ACTIONS(4242),
    [anon_sym_struct] = ACTIONS(4242),
    [anon_sym_union] = ACTIONS(4242),
    [anon_sym_if] = ACTIONS(4242),
    [anon_sym_switch] = ACTIONS(4242),
    [anon_sym_case] = ACTIONS(4242),
    [anon_sym_default] = ACTIONS(4242),
    [anon_sym_while] = ACTIONS(4242),
    [anon_sym_do] = ACTIONS(4242),
    [anon_sym_for] = ACTIONS(4242),
    [anon_sym_return] = ACTIONS(4242),
    [anon_sym_break] = ACTIONS(4242),
    [anon_sym_continue] = ACTIONS(4242),
    [anon_sym_goto] = ACTIONS(4242),
    [anon_sym___try] = ACTIONS(4242),
    [anon_sym___leave] = ACTIONS(4242),
    [anon_sym_not] = ACTIONS(4242),
    [anon_sym_compl] = ACTIONS(4242),
    [anon_sym_DASH_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_PLUS] = ACTIONS(4240),
    [anon_sym_sizeof] = ACTIONS(4242),
    [anon_sym___alignof__] = ACTIONS(4242),
    [anon_sym___alignof] = ACTIONS(4242),
    [anon_sym__alignof] = ACTIONS(4242),
    [anon_sym_alignof] = ACTIONS(4242),
    [anon_sym__Alignof] = ACTIONS(4242),
    [anon_sym_offsetof] = ACTIONS(4242),
    [anon_sym__Generic] = ACTIONS(4242),
    [anon_sym_asm] = ACTIONS(4242),
    [anon_sym___asm__] = ACTIONS(4242),
    [anon_sym___asm] = ACTIONS(4242),
    [anon_sym_DOT] = ACTIONS(4242),
    [sym_number_literal] = ACTIONS(4240),
    [anon_sym_L_SQUOTE] = ACTIONS(4240),
    [anon_sym_u_SQUOTE] = ACTIONS(4240),
    [anon_sym_U_SQUOTE] = ACTIONS(4240),
    [anon_sym_u8_SQUOTE] = ACTIONS(4240),
    [anon_sym_SQUOTE] = ACTIONS(4240),
    [anon_sym_L_DQUOTE] = ACTIONS(4240),
    [anon_sym_u_DQUOTE] = ACTIONS(4240),
    [anon_sym_U_DQUOTE] = ACTIONS(4240),
    [anon_sym_u8_DQUOTE] = ACTIONS(4240),
    [anon_sym_DQUOTE] = ACTIONS(4240),
    [sym_true] = ACTIONS(4242),
    [sym_false] = ACTIONS(4242),
    [anon_sym_NULL] = ACTIONS(4242),
    [anon_sym_nullptr] = ACTIONS(4242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4242),
    [anon_sym_let] = ACTIONS(4242),
    [anon_sym_This] = ACTIONS(4242),
    [anon_sym_decltype] = ACTIONS(4242),
    [anon_sym_explicit] = ACTIONS(4242),
    [anon_sym_typename] = ACTIONS(4242),
    [anon_sym_template] = ACTIONS(4242),
    [anon_sym_operator] = ACTIONS(4242),
    [anon_sym_try] = ACTIONS(4242),
    [anon_sym_delete] = ACTIONS(4242),
    [anon_sym_throw] = ACTIONS(4242),
    [anon_sym_namespace] = ACTIONS(4242),
    [anon_sym_static_assert] = ACTIONS(4242),
    [anon_sym_concept] = ACTIONS(4242),
    [anon_sym_co_return] = ACTIONS(4242),
    [anon_sym_co_yield] = ACTIONS(4242),
    [anon_sym_R_DQUOTE] = ACTIONS(4240),
    [anon_sym_LR_DQUOTE] = ACTIONS(4240),
    [anon_sym_uR_DQUOTE] = ACTIONS(4240),
    [anon_sym_UR_DQUOTE] = ACTIONS(4240),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4240),
    [anon_sym_co_await] = ACTIONS(4242),
    [anon_sym_new] = ACTIONS(4242),
    [anon_sym_requires] = ACTIONS(4242),
    [sym_this] = ACTIONS(4242),
    [anon_sym_discard] = ACTIONS(4242),
    [anon_sym_precise] = ACTIONS(4242),
    [anon_sym_shared] = ACTIONS(4242),
    [anon_sym_groupshared] = ACTIONS(4242),
    [anon_sym_uniform] = ACTIONS(4242),
    [anon_sym_row_major] = ACTIONS(4242),
    [anon_sym_column_major] = ACTIONS(4242),
    [anon_sym_globallycoherent] = ACTIONS(4242),
    [anon_sym_centroid] = ACTIONS(4242),
    [anon_sym_noperspective] = ACTIONS(4242),
    [anon_sym_nointerpolation] = ACTIONS(4242),
    [anon_sym_sample] = ACTIONS(4242),
    [anon_sym_linear] = ACTIONS(4242),
    [anon_sym_snorm] = ACTIONS(4242),
    [anon_sym_unorm] = ACTIONS(4242),
    [anon_sym_point] = ACTIONS(4242),
    [anon_sym_line] = ACTIONS(4242),
    [anon_sym_triangleadj] = ACTIONS(4242),
    [anon_sym_lineadj] = ACTIONS(4242),
    [anon_sym_triangle] = ACTIONS(4242),
    [anon_sym_cbuffer] = ACTIONS(4242),
    [anon_sym_interface] = ACTIONS(4242),
    [anon_sym_extension] = ACTIONS(4242),
  },
  [826] = {
    [ts_builtin_sym_end] = ACTIONS(4254),
    [sym_identifier] = ACTIONS(4252),
    [aux_sym_preproc_include_token1] = ACTIONS(4252),
    [aux_sym_preproc_def_token1] = ACTIONS(4252),
    [aux_sym_preproc_if_token1] = ACTIONS(4252),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4252),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4252),
    [sym_preproc_directive] = ACTIONS(4252),
    [anon_sym_LPAREN2] = ACTIONS(4254),
    [anon_sym_BANG] = ACTIONS(4254),
    [anon_sym_TILDE] = ACTIONS(4254),
    [anon_sym_DASH] = ACTIONS(4252),
    [anon_sym_PLUS] = ACTIONS(4252),
    [anon_sym_STAR] = ACTIONS(4254),
    [anon_sym_AMP_AMP] = ACTIONS(4254),
    [anon_sym_AMP] = ACTIONS(4252),
    [anon_sym_SEMI] = ACTIONS(4254),
    [anon_sym___extension__] = ACTIONS(4252),
    [anon_sym_typedef] = ACTIONS(4252),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_out] = ACTIONS(4252),
    [anon_sym_inout] = ACTIONS(4252),
    [anon_sym_virtual] = ACTIONS(4252),
    [anon_sym_extern] = ACTIONS(4252),
    [anon_sym___attribute__] = ACTIONS(4252),
    [anon_sym___attribute] = ACTIONS(4252),
    [anon_sym_using] = ACTIONS(4252),
    [anon_sym_COLON_COLON] = ACTIONS(4254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4254),
    [anon_sym___declspec] = ACTIONS(4252),
    [anon_sym___based] = ACTIONS(4252),
    [anon_sym___cdecl] = ACTIONS(4252),
    [anon_sym___clrcall] = ACTIONS(4252),
    [anon_sym___stdcall] = ACTIONS(4252),
    [anon_sym___fastcall] = ACTIONS(4252),
    [anon_sym___thiscall] = ACTIONS(4252),
    [anon_sym___vectorcall] = ACTIONS(4252),
    [anon_sym_LBRACE] = ACTIONS(4254),
    [anon_sym_signed] = ACTIONS(4252),
    [anon_sym_unsigned] = ACTIONS(4252),
    [anon_sym_long] = ACTIONS(4252),
    [anon_sym_short] = ACTIONS(4252),
    [anon_sym_LBRACK] = ACTIONS(4252),
    [anon_sym_static] = ACTIONS(4252),
    [anon_sym_register] = ACTIONS(4252),
    [anon_sym_inline] = ACTIONS(4252),
    [anon_sym___inline] = ACTIONS(4252),
    [anon_sym___inline__] = ACTIONS(4252),
    [anon_sym___forceinline] = ACTIONS(4252),
    [anon_sym_thread_local] = ACTIONS(4252),
    [anon_sym___thread] = ACTIONS(4252),
    [anon_sym_const] = ACTIONS(4252),
    [anon_sym_constexpr] = ACTIONS(4252),
    [anon_sym_volatile] = ACTIONS(4252),
    [anon_sym_restrict] = ACTIONS(4252),
    [anon_sym___restrict__] = ACTIONS(4252),
    [anon_sym__Atomic] = ACTIONS(4252),
    [anon_sym__Noreturn] = ACTIONS(4252),
    [anon_sym_noreturn] = ACTIONS(4252),
    [anon_sym__Nonnull] = ACTIONS(4252),
    [anon_sym_mutable] = ACTIONS(4252),
    [anon_sym_constinit] = ACTIONS(4252),
    [anon_sym_consteval] = ACTIONS(4252),
    [anon_sym_alignas] = ACTIONS(4252),
    [anon_sym__Alignas] = ACTIONS(4252),
    [sym_primitive_type] = ACTIONS(4252),
    [anon_sym_enum] = ACTIONS(4252),
    [anon_sym_class] = ACTIONS(4252),
    [anon_sym_struct] = ACTIONS(4252),
    [anon_sym_union] = ACTIONS(4252),
    [anon_sym_if] = ACTIONS(4252),
    [anon_sym_switch] = ACTIONS(4252),
    [anon_sym_case] = ACTIONS(4252),
    [anon_sym_default] = ACTIONS(4252),
    [anon_sym_while] = ACTIONS(4252),
    [anon_sym_do] = ACTIONS(4252),
    [anon_sym_for] = ACTIONS(4252),
    [anon_sym_return] = ACTIONS(4252),
    [anon_sym_break] = ACTIONS(4252),
    [anon_sym_continue] = ACTIONS(4252),
    [anon_sym_goto] = ACTIONS(4252),
    [anon_sym_not] = ACTIONS(4252),
    [anon_sym_compl] = ACTIONS(4252),
    [anon_sym_DASH_DASH] = ACTIONS(4254),
    [anon_sym_PLUS_PLUS] = ACTIONS(4254),
    [anon_sym_sizeof] = ACTIONS(4252),
    [anon_sym___alignof__] = ACTIONS(4252),
    [anon_sym___alignof] = ACTIONS(4252),
    [anon_sym__alignof] = ACTIONS(4252),
    [anon_sym_alignof] = ACTIONS(4252),
    [anon_sym__Alignof] = ACTIONS(4252),
    [anon_sym_offsetof] = ACTIONS(4252),
    [anon_sym__Generic] = ACTIONS(4252),
    [anon_sym_asm] = ACTIONS(4252),
    [anon_sym___asm__] = ACTIONS(4252),
    [anon_sym___asm] = ACTIONS(4252),
    [anon_sym_DOT] = ACTIONS(2606),
    [sym_number_literal] = ACTIONS(4254),
    [anon_sym_L_SQUOTE] = ACTIONS(4254),
    [anon_sym_u_SQUOTE] = ACTIONS(4254),
    [anon_sym_U_SQUOTE] = ACTIONS(4254),
    [anon_sym_u8_SQUOTE] = ACTIONS(4254),
    [anon_sym_SQUOTE] = ACTIONS(4254),
    [anon_sym_L_DQUOTE] = ACTIONS(4254),
    [anon_sym_u_DQUOTE] = ACTIONS(4254),
    [anon_sym_U_DQUOTE] = ACTIONS(4254),
    [anon_sym_u8_DQUOTE] = ACTIONS(4254),
    [anon_sym_DQUOTE] = ACTIONS(4254),
    [sym_true] = ACTIONS(4252),
    [sym_false] = ACTIONS(4252),
    [anon_sym_NULL] = ACTIONS(4252),
    [anon_sym_nullptr] = ACTIONS(4252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_This] = ACTIONS(2608),
    [anon_sym_decltype] = ACTIONS(4252),
    [anon_sym_explicit] = ACTIONS(4252),
    [anon_sym_typename] = ACTIONS(4252),
    [anon_sym_export] = ACTIONS(4252),
    [anon_sym_module] = ACTIONS(4252),
    [anon_sym_import] = ACTIONS(4252),
    [anon_sym_template] = ACTIONS(4252),
    [anon_sym_operator] = ACTIONS(4252),
    [anon_sym_try] = ACTIONS(4252),
    [anon_sym_delete] = ACTIONS(4252),
    [anon_sym_throw] = ACTIONS(4252),
    [anon_sym_namespace] = ACTIONS(4252),
    [anon_sym_static_assert] = ACTIONS(4252),
    [anon_sym_concept] = ACTIONS(4252),
    [anon_sym_co_return] = ACTIONS(4252),
    [anon_sym_co_yield] = ACTIONS(4252),
    [anon_sym_R_DQUOTE] = ACTIONS(4254),
    [anon_sym_LR_DQUOTE] = ACTIONS(4254),
    [anon_sym_uR_DQUOTE] = ACTIONS(4254),
    [anon_sym_UR_DQUOTE] = ACTIONS(4254),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4254),
    [anon_sym_co_await] = ACTIONS(4252),
    [anon_sym_new] = ACTIONS(4252),
    [anon_sym_requires] = ACTIONS(4252),
    [sym_this] = ACTIONS(4252),
    [anon_sym_precise] = ACTIONS(4252),
    [anon_sym_shared] = ACTIONS(4252),
    [anon_sym_groupshared] = ACTIONS(4252),
    [anon_sym_uniform] = ACTIONS(4252),
    [anon_sym_row_major] = ACTIONS(4252),
    [anon_sym_column_major] = ACTIONS(4252),
    [anon_sym_globallycoherent] = ACTIONS(4252),
    [anon_sym_centroid] = ACTIONS(4252),
    [anon_sym_noperspective] = ACTIONS(4252),
    [anon_sym_nointerpolation] = ACTIONS(4252),
    [anon_sym_sample] = ACTIONS(4252),
    [anon_sym_linear] = ACTIONS(4252),
    [anon_sym_snorm] = ACTIONS(4252),
    [anon_sym_unorm] = ACTIONS(4252),
    [anon_sym_point] = ACTIONS(4252),
    [anon_sym_line] = ACTIONS(4252),
    [anon_sym_triangleadj] = ACTIONS(4252),
    [anon_sym_lineadj] = ACTIONS(4252),
    [anon_sym_triangle] = ACTIONS(4252),
    [anon_sym_interface] = ACTIONS(4252),
    [anon_sym_extension] = ACTIONS(4252),
    [anon_sym___exported] = ACTIONS(4252),
  },
  [827] = {
    [sym_identifier] = ACTIONS(3637),
    [aux_sym_preproc_include_token1] = ACTIONS(3637),
    [aux_sym_preproc_def_token1] = ACTIONS(3637),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3637),
    [sym_preproc_directive] = ACTIONS(3637),
    [anon_sym_LPAREN2] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(3639),
    [anon_sym_TILDE] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3637),
    [anon_sym_STAR] = ACTIONS(3639),
    [anon_sym_AMP_AMP] = ACTIONS(3639),
    [anon_sym_AMP] = ACTIONS(3637),
    [anon_sym_SEMI] = ACTIONS(3639),
    [anon_sym___extension__] = ACTIONS(3637),
    [anon_sym_typedef] = ACTIONS(3637),
    [anon_sym_in] = ACTIONS(3637),
    [anon_sym_out] = ACTIONS(3637),
    [anon_sym_inout] = ACTIONS(3637),
    [anon_sym_virtual] = ACTIONS(3637),
    [anon_sym_extern] = ACTIONS(3637),
    [anon_sym___attribute__] = ACTIONS(3637),
    [anon_sym___attribute] = ACTIONS(3637),
    [anon_sym_using] = ACTIONS(3637),
    [anon_sym_COLON_COLON] = ACTIONS(3639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3639),
    [anon_sym___declspec] = ACTIONS(3637),
    [anon_sym___based] = ACTIONS(3637),
    [anon_sym___cdecl] = ACTIONS(3637),
    [anon_sym___clrcall] = ACTIONS(3637),
    [anon_sym___stdcall] = ACTIONS(3637),
    [anon_sym___fastcall] = ACTIONS(3637),
    [anon_sym___thiscall] = ACTIONS(3637),
    [anon_sym___vectorcall] = ACTIONS(3637),
    [anon_sym_LBRACE] = ACTIONS(3639),
    [anon_sym_RBRACE] = ACTIONS(3639),
    [anon_sym_signed] = ACTIONS(3637),
    [anon_sym_unsigned] = ACTIONS(3637),
    [anon_sym_long] = ACTIONS(3637),
    [anon_sym_short] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(3637),
    [anon_sym_static] = ACTIONS(3637),
    [anon_sym_register] = ACTIONS(3637),
    [anon_sym_inline] = ACTIONS(3637),
    [anon_sym___inline] = ACTIONS(3637),
    [anon_sym___inline__] = ACTIONS(3637),
    [anon_sym___forceinline] = ACTIONS(3637),
    [anon_sym_thread_local] = ACTIONS(3637),
    [anon_sym___thread] = ACTIONS(3637),
    [anon_sym_const] = ACTIONS(3637),
    [anon_sym_constexpr] = ACTIONS(3637),
    [anon_sym_volatile] = ACTIONS(3637),
    [anon_sym_restrict] = ACTIONS(3637),
    [anon_sym___restrict__] = ACTIONS(3637),
    [anon_sym__Atomic] = ACTIONS(3637),
    [anon_sym__Noreturn] = ACTIONS(3637),
    [anon_sym_noreturn] = ACTIONS(3637),
    [anon_sym__Nonnull] = ACTIONS(3637),
    [anon_sym_mutable] = ACTIONS(3637),
    [anon_sym_constinit] = ACTIONS(3637),
    [anon_sym_consteval] = ACTIONS(3637),
    [anon_sym_alignas] = ACTIONS(3637),
    [anon_sym__Alignas] = ACTIONS(3637),
    [sym_primitive_type] = ACTIONS(3637),
    [anon_sym_enum] = ACTIONS(3637),
    [anon_sym_class] = ACTIONS(3637),
    [anon_sym_struct] = ACTIONS(3637),
    [anon_sym_union] = ACTIONS(3637),
    [anon_sym_if] = ACTIONS(3637),
    [anon_sym_else] = ACTIONS(3637),
    [anon_sym_switch] = ACTIONS(3637),
    [anon_sym_case] = ACTIONS(3637),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3637),
    [anon_sym_do] = ACTIONS(3637),
    [anon_sym_for] = ACTIONS(3637),
    [anon_sym_return] = ACTIONS(3637),
    [anon_sym_break] = ACTIONS(3637),
    [anon_sym_continue] = ACTIONS(3637),
    [anon_sym_goto] = ACTIONS(3637),
    [anon_sym___try] = ACTIONS(3637),
    [anon_sym___leave] = ACTIONS(3637),
    [anon_sym_not] = ACTIONS(3637),
    [anon_sym_compl] = ACTIONS(3637),
    [anon_sym_DASH_DASH] = ACTIONS(3639),
    [anon_sym_PLUS_PLUS] = ACTIONS(3639),
    [anon_sym_sizeof] = ACTIONS(3637),
    [anon_sym___alignof__] = ACTIONS(3637),
    [anon_sym___alignof] = ACTIONS(3637),
    [anon_sym__alignof] = ACTIONS(3637),
    [anon_sym_alignof] = ACTIONS(3637),
    [anon_sym__Alignof] = ACTIONS(3637),
    [anon_sym_offsetof] = ACTIONS(3637),
    [anon_sym__Generic] = ACTIONS(3637),
    [anon_sym_asm] = ACTIONS(3637),
    [anon_sym___asm__] = ACTIONS(3637),
    [anon_sym___asm] = ACTIONS(3637),
    [sym_number_literal] = ACTIONS(3639),
    [anon_sym_L_SQUOTE] = ACTIONS(3639),
    [anon_sym_u_SQUOTE] = ACTIONS(3639),
    [anon_sym_U_SQUOTE] = ACTIONS(3639),
    [anon_sym_u8_SQUOTE] = ACTIONS(3639),
    [anon_sym_SQUOTE] = ACTIONS(3639),
    [anon_sym_L_DQUOTE] = ACTIONS(3639),
    [anon_sym_u_DQUOTE] = ACTIONS(3639),
    [anon_sym_U_DQUOTE] = ACTIONS(3639),
    [anon_sym_u8_DQUOTE] = ACTIONS(3639),
    [anon_sym_DQUOTE] = ACTIONS(3639),
    [sym_true] = ACTIONS(3637),
    [sym_false] = ACTIONS(3637),
    [anon_sym_NULL] = ACTIONS(3637),
    [anon_sym_nullptr] = ACTIONS(3637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3637),
    [anon_sym_let] = ACTIONS(3637),
    [anon_sym_This] = ACTIONS(3637),
    [anon_sym_decltype] = ACTIONS(3637),
    [anon_sym_explicit] = ACTIONS(3637),
    [anon_sym_typename] = ACTIONS(3637),
    [anon_sym_template] = ACTIONS(3637),
    [anon_sym_operator] = ACTIONS(3637),
    [anon_sym_try] = ACTIONS(3637),
    [anon_sym_delete] = ACTIONS(3637),
    [anon_sym_throw] = ACTIONS(3637),
    [anon_sym_namespace] = ACTIONS(3637),
    [anon_sym_static_assert] = ACTIONS(3637),
    [anon_sym_concept] = ACTIONS(3637),
    [anon_sym_co_return] = ACTIONS(3637),
    [anon_sym_co_yield] = ACTIONS(3637),
    [anon_sym_R_DQUOTE] = ACTIONS(3639),
    [anon_sym_LR_DQUOTE] = ACTIONS(3639),
    [anon_sym_uR_DQUOTE] = ACTIONS(3639),
    [anon_sym_UR_DQUOTE] = ACTIONS(3639),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3639),
    [anon_sym_co_await] = ACTIONS(3637),
    [anon_sym_new] = ACTIONS(3637),
    [anon_sym_requires] = ACTIONS(3637),
    [sym_this] = ACTIONS(3637),
    [anon_sym_discard] = ACTIONS(3637),
    [anon_sym_precise] = ACTIONS(3637),
    [anon_sym_shared] = ACTIONS(3637),
    [anon_sym_groupshared] = ACTIONS(3637),
    [anon_sym_uniform] = ACTIONS(3637),
    [anon_sym_row_major] = ACTIONS(3637),
    [anon_sym_column_major] = ACTIONS(3637),
    [anon_sym_globallycoherent] = ACTIONS(3637),
    [anon_sym_centroid] = ACTIONS(3637),
    [anon_sym_noperspective] = ACTIONS(3637),
    [anon_sym_nointerpolation] = ACTIONS(3637),
    [anon_sym_sample] = ACTIONS(3637),
    [anon_sym_linear] = ACTIONS(3637),
    [anon_sym_snorm] = ACTIONS(3637),
    [anon_sym_unorm] = ACTIONS(3637),
    [anon_sym_point] = ACTIONS(3637),
    [anon_sym_line] = ACTIONS(3637),
    [anon_sym_triangleadj] = ACTIONS(3637),
    [anon_sym_lineadj] = ACTIONS(3637),
    [anon_sym_triangle] = ACTIONS(3637),
    [anon_sym_cbuffer] = ACTIONS(3637),
    [anon_sym_interface] = ACTIONS(3637),
    [anon_sym_extension] = ACTIONS(3637),
  },
  [828] = {
    [sym_identifier] = ACTIONS(3641),
    [aux_sym_preproc_include_token1] = ACTIONS(3641),
    [aux_sym_preproc_def_token1] = ACTIONS(3641),
    [aux_sym_preproc_if_token1] = ACTIONS(3641),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3641),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3641),
    [sym_preproc_directive] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(3643),
    [anon_sym_BANG] = ACTIONS(3643),
    [anon_sym_TILDE] = ACTIONS(3643),
    [anon_sym_DASH] = ACTIONS(3641),
    [anon_sym_PLUS] = ACTIONS(3641),
    [anon_sym_STAR] = ACTIONS(3643),
    [anon_sym_AMP_AMP] = ACTIONS(3643),
    [anon_sym_AMP] = ACTIONS(3641),
    [anon_sym_SEMI] = ACTIONS(3643),
    [anon_sym___extension__] = ACTIONS(3641),
    [anon_sym_typedef] = ACTIONS(3641),
    [anon_sym_in] = ACTIONS(3641),
    [anon_sym_out] = ACTIONS(3641),
    [anon_sym_inout] = ACTIONS(3641),
    [anon_sym_virtual] = ACTIONS(3641),
    [anon_sym_extern] = ACTIONS(3641),
    [anon_sym___attribute__] = ACTIONS(3641),
    [anon_sym___attribute] = ACTIONS(3641),
    [anon_sym_using] = ACTIONS(3641),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3643),
    [anon_sym___declspec] = ACTIONS(3641),
    [anon_sym___based] = ACTIONS(3641),
    [anon_sym___cdecl] = ACTIONS(3641),
    [anon_sym___clrcall] = ACTIONS(3641),
    [anon_sym___stdcall] = ACTIONS(3641),
    [anon_sym___fastcall] = ACTIONS(3641),
    [anon_sym___thiscall] = ACTIONS(3641),
    [anon_sym___vectorcall] = ACTIONS(3641),
    [anon_sym_LBRACE] = ACTIONS(3643),
    [anon_sym_RBRACE] = ACTIONS(3643),
    [anon_sym_signed] = ACTIONS(3641),
    [anon_sym_unsigned] = ACTIONS(3641),
    [anon_sym_long] = ACTIONS(3641),
    [anon_sym_short] = ACTIONS(3641),
    [anon_sym_LBRACK] = ACTIONS(3641),
    [anon_sym_static] = ACTIONS(3641),
    [anon_sym_register] = ACTIONS(3641),
    [anon_sym_inline] = ACTIONS(3641),
    [anon_sym___inline] = ACTIONS(3641),
    [anon_sym___inline__] = ACTIONS(3641),
    [anon_sym___forceinline] = ACTIONS(3641),
    [anon_sym_thread_local] = ACTIONS(3641),
    [anon_sym___thread] = ACTIONS(3641),
    [anon_sym_const] = ACTIONS(3641),
    [anon_sym_constexpr] = ACTIONS(3641),
    [anon_sym_volatile] = ACTIONS(3641),
    [anon_sym_restrict] = ACTIONS(3641),
    [anon_sym___restrict__] = ACTIONS(3641),
    [anon_sym__Atomic] = ACTIONS(3641),
    [anon_sym__Noreturn] = ACTIONS(3641),
    [anon_sym_noreturn] = ACTIONS(3641),
    [anon_sym__Nonnull] = ACTIONS(3641),
    [anon_sym_mutable] = ACTIONS(3641),
    [anon_sym_constinit] = ACTIONS(3641),
    [anon_sym_consteval] = ACTIONS(3641),
    [anon_sym_alignas] = ACTIONS(3641),
    [anon_sym__Alignas] = ACTIONS(3641),
    [sym_primitive_type] = ACTIONS(3641),
    [anon_sym_enum] = ACTIONS(3641),
    [anon_sym_class] = ACTIONS(3641),
    [anon_sym_struct] = ACTIONS(3641),
    [anon_sym_union] = ACTIONS(3641),
    [anon_sym_if] = ACTIONS(3641),
    [anon_sym_else] = ACTIONS(3641),
    [anon_sym_switch] = ACTIONS(3641),
    [anon_sym_case] = ACTIONS(3641),
    [anon_sym_default] = ACTIONS(3641),
    [anon_sym_while] = ACTIONS(3641),
    [anon_sym_do] = ACTIONS(3641),
    [anon_sym_for] = ACTIONS(3641),
    [anon_sym_return] = ACTIONS(3641),
    [anon_sym_break] = ACTIONS(3641),
    [anon_sym_continue] = ACTIONS(3641),
    [anon_sym_goto] = ACTIONS(3641),
    [anon_sym___try] = ACTIONS(3641),
    [anon_sym___leave] = ACTIONS(3641),
    [anon_sym_not] = ACTIONS(3641),
    [anon_sym_compl] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3643),
    [anon_sym_PLUS_PLUS] = ACTIONS(3643),
    [anon_sym_sizeof] = ACTIONS(3641),
    [anon_sym___alignof__] = ACTIONS(3641),
    [anon_sym___alignof] = ACTIONS(3641),
    [anon_sym__alignof] = ACTIONS(3641),
    [anon_sym_alignof] = ACTIONS(3641),
    [anon_sym__Alignof] = ACTIONS(3641),
    [anon_sym_offsetof] = ACTIONS(3641),
    [anon_sym__Generic] = ACTIONS(3641),
    [anon_sym_asm] = ACTIONS(3641),
    [anon_sym___asm__] = ACTIONS(3641),
    [anon_sym___asm] = ACTIONS(3641),
    [sym_number_literal] = ACTIONS(3643),
    [anon_sym_L_SQUOTE] = ACTIONS(3643),
    [anon_sym_u_SQUOTE] = ACTIONS(3643),
    [anon_sym_U_SQUOTE] = ACTIONS(3643),
    [anon_sym_u8_SQUOTE] = ACTIONS(3643),
    [anon_sym_SQUOTE] = ACTIONS(3643),
    [anon_sym_L_DQUOTE] = ACTIONS(3643),
    [anon_sym_u_DQUOTE] = ACTIONS(3643),
    [anon_sym_U_DQUOTE] = ACTIONS(3643),
    [anon_sym_u8_DQUOTE] = ACTIONS(3643),
    [anon_sym_DQUOTE] = ACTIONS(3643),
    [sym_true] = ACTIONS(3641),
    [sym_false] = ACTIONS(3641),
    [anon_sym_NULL] = ACTIONS(3641),
    [anon_sym_nullptr] = ACTIONS(3641),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3641),
    [anon_sym_let] = ACTIONS(3641),
    [anon_sym_This] = ACTIONS(3641),
    [anon_sym_decltype] = ACTIONS(3641),
    [anon_sym_explicit] = ACTIONS(3641),
    [anon_sym_typename] = ACTIONS(3641),
    [anon_sym_template] = ACTIONS(3641),
    [anon_sym_operator] = ACTIONS(3641),
    [anon_sym_try] = ACTIONS(3641),
    [anon_sym_delete] = ACTIONS(3641),
    [anon_sym_throw] = ACTIONS(3641),
    [anon_sym_namespace] = ACTIONS(3641),
    [anon_sym_static_assert] = ACTIONS(3641),
    [anon_sym_concept] = ACTIONS(3641),
    [anon_sym_co_return] = ACTIONS(3641),
    [anon_sym_co_yield] = ACTIONS(3641),
    [anon_sym_R_DQUOTE] = ACTIONS(3643),
    [anon_sym_LR_DQUOTE] = ACTIONS(3643),
    [anon_sym_uR_DQUOTE] = ACTIONS(3643),
    [anon_sym_UR_DQUOTE] = ACTIONS(3643),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3643),
    [anon_sym_co_await] = ACTIONS(3641),
    [anon_sym_new] = ACTIONS(3641),
    [anon_sym_requires] = ACTIONS(3641),
    [sym_this] = ACTIONS(3641),
    [anon_sym_discard] = ACTIONS(3641),
    [anon_sym_precise] = ACTIONS(3641),
    [anon_sym_shared] = ACTIONS(3641),
    [anon_sym_groupshared] = ACTIONS(3641),
    [anon_sym_uniform] = ACTIONS(3641),
    [anon_sym_row_major] = ACTIONS(3641),
    [anon_sym_column_major] = ACTIONS(3641),
    [anon_sym_globallycoherent] = ACTIONS(3641),
    [anon_sym_centroid] = ACTIONS(3641),
    [anon_sym_noperspective] = ACTIONS(3641),
    [anon_sym_nointerpolation] = ACTIONS(3641),
    [anon_sym_sample] = ACTIONS(3641),
    [anon_sym_linear] = ACTIONS(3641),
    [anon_sym_snorm] = ACTIONS(3641),
    [anon_sym_unorm] = ACTIONS(3641),
    [anon_sym_point] = ACTIONS(3641),
    [anon_sym_line] = ACTIONS(3641),
    [anon_sym_triangleadj] = ACTIONS(3641),
    [anon_sym_lineadj] = ACTIONS(3641),
    [anon_sym_triangle] = ACTIONS(3641),
    [anon_sym_cbuffer] = ACTIONS(3641),
    [anon_sym_interface] = ACTIONS(3641),
    [anon_sym_extension] = ACTIONS(3641),
  },
  [829] = {
    [sym_identifier] = ACTIONS(3645),
    [aux_sym_preproc_include_token1] = ACTIONS(3645),
    [aux_sym_preproc_def_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3645),
    [sym_preproc_directive] = ACTIONS(3645),
    [anon_sym_LPAREN2] = ACTIONS(3647),
    [anon_sym_BANG] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3647),
    [anon_sym_DASH] = ACTIONS(3645),
    [anon_sym_PLUS] = ACTIONS(3645),
    [anon_sym_STAR] = ACTIONS(3647),
    [anon_sym_AMP_AMP] = ACTIONS(3647),
    [anon_sym_AMP] = ACTIONS(3645),
    [anon_sym_SEMI] = ACTIONS(3647),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3645),
    [anon_sym_in] = ACTIONS(3645),
    [anon_sym_out] = ACTIONS(3645),
    [anon_sym_inout] = ACTIONS(3645),
    [anon_sym_virtual] = ACTIONS(3645),
    [anon_sym_extern] = ACTIONS(3645),
    [anon_sym___attribute__] = ACTIONS(3645),
    [anon_sym___attribute] = ACTIONS(3645),
    [anon_sym_using] = ACTIONS(3645),
    [anon_sym_COLON_COLON] = ACTIONS(3647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3647),
    [anon_sym___declspec] = ACTIONS(3645),
    [anon_sym___based] = ACTIONS(3645),
    [anon_sym___cdecl] = ACTIONS(3645),
    [anon_sym___clrcall] = ACTIONS(3645),
    [anon_sym___stdcall] = ACTIONS(3645),
    [anon_sym___fastcall] = ACTIONS(3645),
    [anon_sym___thiscall] = ACTIONS(3645),
    [anon_sym___vectorcall] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(3647),
    [anon_sym_RBRACE] = ACTIONS(3647),
    [anon_sym_signed] = ACTIONS(3645),
    [anon_sym_unsigned] = ACTIONS(3645),
    [anon_sym_long] = ACTIONS(3645),
    [anon_sym_short] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_static] = ACTIONS(3645),
    [anon_sym_register] = ACTIONS(3645),
    [anon_sym_inline] = ACTIONS(3645),
    [anon_sym___inline] = ACTIONS(3645),
    [anon_sym___inline__] = ACTIONS(3645),
    [anon_sym___forceinline] = ACTIONS(3645),
    [anon_sym_thread_local] = ACTIONS(3645),
    [anon_sym___thread] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(3645),
    [anon_sym_constexpr] = ACTIONS(3645),
    [anon_sym_volatile] = ACTIONS(3645),
    [anon_sym_restrict] = ACTIONS(3645),
    [anon_sym___restrict__] = ACTIONS(3645),
    [anon_sym__Atomic] = ACTIONS(3645),
    [anon_sym__Noreturn] = ACTIONS(3645),
    [anon_sym_noreturn] = ACTIONS(3645),
    [anon_sym__Nonnull] = ACTIONS(3645),
    [anon_sym_mutable] = ACTIONS(3645),
    [anon_sym_constinit] = ACTIONS(3645),
    [anon_sym_consteval] = ACTIONS(3645),
    [anon_sym_alignas] = ACTIONS(3645),
    [anon_sym__Alignas] = ACTIONS(3645),
    [sym_primitive_type] = ACTIONS(3645),
    [anon_sym_enum] = ACTIONS(3645),
    [anon_sym_class] = ACTIONS(3645),
    [anon_sym_struct] = ACTIONS(3645),
    [anon_sym_union] = ACTIONS(3645),
    [anon_sym_if] = ACTIONS(3645),
    [anon_sym_else] = ACTIONS(3645),
    [anon_sym_switch] = ACTIONS(3645),
    [anon_sym_case] = ACTIONS(3645),
    [anon_sym_default] = ACTIONS(3645),
    [anon_sym_while] = ACTIONS(3645),
    [anon_sym_do] = ACTIONS(3645),
    [anon_sym_for] = ACTIONS(3645),
    [anon_sym_return] = ACTIONS(3645),
    [anon_sym_break] = ACTIONS(3645),
    [anon_sym_continue] = ACTIONS(3645),
    [anon_sym_goto] = ACTIONS(3645),
    [anon_sym___try] = ACTIONS(3645),
    [anon_sym___leave] = ACTIONS(3645),
    [anon_sym_not] = ACTIONS(3645),
    [anon_sym_compl] = ACTIONS(3645),
    [anon_sym_DASH_DASH] = ACTIONS(3647),
    [anon_sym_PLUS_PLUS] = ACTIONS(3647),
    [anon_sym_sizeof] = ACTIONS(3645),
    [anon_sym___alignof__] = ACTIONS(3645),
    [anon_sym___alignof] = ACTIONS(3645),
    [anon_sym__alignof] = ACTIONS(3645),
    [anon_sym_alignof] = ACTIONS(3645),
    [anon_sym__Alignof] = ACTIONS(3645),
    [anon_sym_offsetof] = ACTIONS(3645),
    [anon_sym__Generic] = ACTIONS(3645),
    [anon_sym_asm] = ACTIONS(3645),
    [anon_sym___asm__] = ACTIONS(3645),
    [anon_sym___asm] = ACTIONS(3645),
    [sym_number_literal] = ACTIONS(3647),
    [anon_sym_L_SQUOTE] = ACTIONS(3647),
    [anon_sym_u_SQUOTE] = ACTIONS(3647),
    [anon_sym_U_SQUOTE] = ACTIONS(3647),
    [anon_sym_u8_SQUOTE] = ACTIONS(3647),
    [anon_sym_SQUOTE] = ACTIONS(3647),
    [anon_sym_L_DQUOTE] = ACTIONS(3647),
    [anon_sym_u_DQUOTE] = ACTIONS(3647),
    [anon_sym_U_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8_DQUOTE] = ACTIONS(3647),
    [anon_sym_DQUOTE] = ACTIONS(3647),
    [sym_true] = ACTIONS(3645),
    [sym_false] = ACTIONS(3645),
    [anon_sym_NULL] = ACTIONS(3645),
    [anon_sym_nullptr] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3645),
    [anon_sym_let] = ACTIONS(3645),
    [anon_sym_This] = ACTIONS(3645),
    [anon_sym_decltype] = ACTIONS(3645),
    [anon_sym_explicit] = ACTIONS(3645),
    [anon_sym_typename] = ACTIONS(3645),
    [anon_sym_template] = ACTIONS(3645),
    [anon_sym_operator] = ACTIONS(3645),
    [anon_sym_try] = ACTIONS(3645),
    [anon_sym_delete] = ACTIONS(3645),
    [anon_sym_throw] = ACTIONS(3645),
    [anon_sym_namespace] = ACTIONS(3645),
    [anon_sym_static_assert] = ACTIONS(3645),
    [anon_sym_concept] = ACTIONS(3645),
    [anon_sym_co_return] = ACTIONS(3645),
    [anon_sym_co_yield] = ACTIONS(3645),
    [anon_sym_R_DQUOTE] = ACTIONS(3647),
    [anon_sym_LR_DQUOTE] = ACTIONS(3647),
    [anon_sym_uR_DQUOTE] = ACTIONS(3647),
    [anon_sym_UR_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3647),
    [anon_sym_co_await] = ACTIONS(3645),
    [anon_sym_new] = ACTIONS(3645),
    [anon_sym_requires] = ACTIONS(3645),
    [sym_this] = ACTIONS(3645),
    [anon_sym_discard] = ACTIONS(3645),
    [anon_sym_precise] = ACTIONS(3645),
    [anon_sym_shared] = ACTIONS(3645),
    [anon_sym_groupshared] = ACTIONS(3645),
    [anon_sym_uniform] = ACTIONS(3645),
    [anon_sym_row_major] = ACTIONS(3645),
    [anon_sym_column_major] = ACTIONS(3645),
    [anon_sym_globallycoherent] = ACTIONS(3645),
    [anon_sym_centroid] = ACTIONS(3645),
    [anon_sym_noperspective] = ACTIONS(3645),
    [anon_sym_nointerpolation] = ACTIONS(3645),
    [anon_sym_sample] = ACTIONS(3645),
    [anon_sym_linear] = ACTIONS(3645),
    [anon_sym_snorm] = ACTIONS(3645),
    [anon_sym_unorm] = ACTIONS(3645),
    [anon_sym_point] = ACTIONS(3645),
    [anon_sym_line] = ACTIONS(3645),
    [anon_sym_triangleadj] = ACTIONS(3645),
    [anon_sym_lineadj] = ACTIONS(3645),
    [anon_sym_triangle] = ACTIONS(3645),
    [anon_sym_cbuffer] = ACTIONS(3645),
    [anon_sym_interface] = ACTIONS(3645),
    [anon_sym_extension] = ACTIONS(3645),
  },
  [830] = {
    [sym_identifier] = ACTIONS(3649),
    [aux_sym_preproc_include_token1] = ACTIONS(3649),
    [aux_sym_preproc_def_token1] = ACTIONS(3649),
    [aux_sym_preproc_if_token1] = ACTIONS(3649),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3649),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3649),
    [sym_preproc_directive] = ACTIONS(3649),
    [anon_sym_LPAREN2] = ACTIONS(3651),
    [anon_sym_BANG] = ACTIONS(3651),
    [anon_sym_TILDE] = ACTIONS(3651),
    [anon_sym_DASH] = ACTIONS(3649),
    [anon_sym_PLUS] = ACTIONS(3649),
    [anon_sym_STAR] = ACTIONS(3651),
    [anon_sym_AMP_AMP] = ACTIONS(3651),
    [anon_sym_AMP] = ACTIONS(3649),
    [anon_sym_SEMI] = ACTIONS(3651),
    [anon_sym___extension__] = ACTIONS(3649),
    [anon_sym_typedef] = ACTIONS(3649),
    [anon_sym_in] = ACTIONS(3649),
    [anon_sym_out] = ACTIONS(3649),
    [anon_sym_inout] = ACTIONS(3649),
    [anon_sym_virtual] = ACTIONS(3649),
    [anon_sym_extern] = ACTIONS(3649),
    [anon_sym___attribute__] = ACTIONS(3649),
    [anon_sym___attribute] = ACTIONS(3649),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(3651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3651),
    [anon_sym___declspec] = ACTIONS(3649),
    [anon_sym___based] = ACTIONS(3649),
    [anon_sym___cdecl] = ACTIONS(3649),
    [anon_sym___clrcall] = ACTIONS(3649),
    [anon_sym___stdcall] = ACTIONS(3649),
    [anon_sym___fastcall] = ACTIONS(3649),
    [anon_sym___thiscall] = ACTIONS(3649),
    [anon_sym___vectorcall] = ACTIONS(3649),
    [anon_sym_LBRACE] = ACTIONS(3651),
    [anon_sym_RBRACE] = ACTIONS(3651),
    [anon_sym_signed] = ACTIONS(3649),
    [anon_sym_unsigned] = ACTIONS(3649),
    [anon_sym_long] = ACTIONS(3649),
    [anon_sym_short] = ACTIONS(3649),
    [anon_sym_LBRACK] = ACTIONS(3649),
    [anon_sym_static] = ACTIONS(3649),
    [anon_sym_register] = ACTIONS(3649),
    [anon_sym_inline] = ACTIONS(3649),
    [anon_sym___inline] = ACTIONS(3649),
    [anon_sym___inline__] = ACTIONS(3649),
    [anon_sym___forceinline] = ACTIONS(3649),
    [anon_sym_thread_local] = ACTIONS(3649),
    [anon_sym___thread] = ACTIONS(3649),
    [anon_sym_const] = ACTIONS(3649),
    [anon_sym_constexpr] = ACTIONS(3649),
    [anon_sym_volatile] = ACTIONS(3649),
    [anon_sym_restrict] = ACTIONS(3649),
    [anon_sym___restrict__] = ACTIONS(3649),
    [anon_sym__Atomic] = ACTIONS(3649),
    [anon_sym__Noreturn] = ACTIONS(3649),
    [anon_sym_noreturn] = ACTIONS(3649),
    [anon_sym__Nonnull] = ACTIONS(3649),
    [anon_sym_mutable] = ACTIONS(3649),
    [anon_sym_constinit] = ACTIONS(3649),
    [anon_sym_consteval] = ACTIONS(3649),
    [anon_sym_alignas] = ACTIONS(3649),
    [anon_sym__Alignas] = ACTIONS(3649),
    [sym_primitive_type] = ACTIONS(3649),
    [anon_sym_enum] = ACTIONS(3649),
    [anon_sym_class] = ACTIONS(3649),
    [anon_sym_struct] = ACTIONS(3649),
    [anon_sym_union] = ACTIONS(3649),
    [anon_sym_if] = ACTIONS(3649),
    [anon_sym_else] = ACTIONS(3649),
    [anon_sym_switch] = ACTIONS(3649),
    [anon_sym_case] = ACTIONS(3649),
    [anon_sym_default] = ACTIONS(3649),
    [anon_sym_while] = ACTIONS(3649),
    [anon_sym_do] = ACTIONS(3649),
    [anon_sym_for] = ACTIONS(3649),
    [anon_sym_return] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3649),
    [anon_sym_continue] = ACTIONS(3649),
    [anon_sym_goto] = ACTIONS(3649),
    [anon_sym___try] = ACTIONS(3649),
    [anon_sym___leave] = ACTIONS(3649),
    [anon_sym_not] = ACTIONS(3649),
    [anon_sym_compl] = ACTIONS(3649),
    [anon_sym_DASH_DASH] = ACTIONS(3651),
    [anon_sym_PLUS_PLUS] = ACTIONS(3651),
    [anon_sym_sizeof] = ACTIONS(3649),
    [anon_sym___alignof__] = ACTIONS(3649),
    [anon_sym___alignof] = ACTIONS(3649),
    [anon_sym__alignof] = ACTIONS(3649),
    [anon_sym_alignof] = ACTIONS(3649),
    [anon_sym__Alignof] = ACTIONS(3649),
    [anon_sym_offsetof] = ACTIONS(3649),
    [anon_sym__Generic] = ACTIONS(3649),
    [anon_sym_asm] = ACTIONS(3649),
    [anon_sym___asm__] = ACTIONS(3649),
    [anon_sym___asm] = ACTIONS(3649),
    [sym_number_literal] = ACTIONS(3651),
    [anon_sym_L_SQUOTE] = ACTIONS(3651),
    [anon_sym_u_SQUOTE] = ACTIONS(3651),
    [anon_sym_U_SQUOTE] = ACTIONS(3651),
    [anon_sym_u8_SQUOTE] = ACTIONS(3651),
    [anon_sym_SQUOTE] = ACTIONS(3651),
    [anon_sym_L_DQUOTE] = ACTIONS(3651),
    [anon_sym_u_DQUOTE] = ACTIONS(3651),
    [anon_sym_U_DQUOTE] = ACTIONS(3651),
    [anon_sym_u8_DQUOTE] = ACTIONS(3651),
    [anon_sym_DQUOTE] = ACTIONS(3651),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [anon_sym_NULL] = ACTIONS(3649),
    [anon_sym_nullptr] = ACTIONS(3649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3649),
    [anon_sym_let] = ACTIONS(3649),
    [anon_sym_This] = ACTIONS(3649),
    [anon_sym_decltype] = ACTIONS(3649),
    [anon_sym_explicit] = ACTIONS(3649),
    [anon_sym_typename] = ACTIONS(3649),
    [anon_sym_template] = ACTIONS(3649),
    [anon_sym_operator] = ACTIONS(3649),
    [anon_sym_try] = ACTIONS(3649),
    [anon_sym_delete] = ACTIONS(3649),
    [anon_sym_throw] = ACTIONS(3649),
    [anon_sym_namespace] = ACTIONS(3649),
    [anon_sym_static_assert] = ACTIONS(3649),
    [anon_sym_concept] = ACTIONS(3649),
    [anon_sym_co_return] = ACTIONS(3649),
    [anon_sym_co_yield] = ACTIONS(3649),
    [anon_sym_R_DQUOTE] = ACTIONS(3651),
    [anon_sym_LR_DQUOTE] = ACTIONS(3651),
    [anon_sym_uR_DQUOTE] = ACTIONS(3651),
    [anon_sym_UR_DQUOTE] = ACTIONS(3651),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3651),
    [anon_sym_co_await] = ACTIONS(3649),
    [anon_sym_new] = ACTIONS(3649),
    [anon_sym_requires] = ACTIONS(3649),
    [sym_this] = ACTIONS(3649),
    [anon_sym_discard] = ACTIONS(3649),
    [anon_sym_precise] = ACTIONS(3649),
    [anon_sym_shared] = ACTIONS(3649),
    [anon_sym_groupshared] = ACTIONS(3649),
    [anon_sym_uniform] = ACTIONS(3649),
    [anon_sym_row_major] = ACTIONS(3649),
    [anon_sym_column_major] = ACTIONS(3649),
    [anon_sym_globallycoherent] = ACTIONS(3649),
    [anon_sym_centroid] = ACTIONS(3649),
    [anon_sym_noperspective] = ACTIONS(3649),
    [anon_sym_nointerpolation] = ACTIONS(3649),
    [anon_sym_sample] = ACTIONS(3649),
    [anon_sym_linear] = ACTIONS(3649),
    [anon_sym_snorm] = ACTIONS(3649),
    [anon_sym_unorm] = ACTIONS(3649),
    [anon_sym_point] = ACTIONS(3649),
    [anon_sym_line] = ACTIONS(3649),
    [anon_sym_triangleadj] = ACTIONS(3649),
    [anon_sym_lineadj] = ACTIONS(3649),
    [anon_sym_triangle] = ACTIONS(3649),
    [anon_sym_cbuffer] = ACTIONS(3649),
    [anon_sym_interface] = ACTIONS(3649),
    [anon_sym_extension] = ACTIONS(3649),
  },
  [831] = {
    [ts_builtin_sym_end] = ACTIONS(2881),
    [sym_identifier] = ACTIONS(2883),
    [aux_sym_preproc_include_token1] = ACTIONS(2883),
    [aux_sym_preproc_def_token1] = ACTIONS(2883),
    [aux_sym_preproc_if_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2883),
    [sym_preproc_directive] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_typedef] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_using] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(4256),
    [anon_sym_signed] = ACTIONS(2883),
    [anon_sym_unsigned] = ACTIONS(2883),
    [anon_sym_long] = ACTIONS(2883),
    [anon_sym_short] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [sym_primitive_type] = ACTIONS(2883),
    [anon_sym_enum] = ACTIONS(2883),
    [anon_sym_class] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2883),
    [anon_sym_union] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_switch] = ACTIONS(2883),
    [anon_sym_case] = ACTIONS(2883),
    [anon_sym_default] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_break] = ACTIONS(2883),
    [anon_sym_continue] = ACTIONS(2883),
    [anon_sym_goto] = ACTIONS(2883),
    [anon_sym_not] = ACTIONS(2883),
    [anon_sym_compl] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_sizeof] = ACTIONS(2883),
    [anon_sym___alignof__] = ACTIONS(2883),
    [anon_sym___alignof] = ACTIONS(2883),
    [anon_sym__alignof] = ACTIONS(2883),
    [anon_sym_alignof] = ACTIONS(2883),
    [anon_sym__Alignof] = ACTIONS(2883),
    [anon_sym_offsetof] = ACTIONS(2883),
    [anon_sym__Generic] = ACTIONS(2883),
    [anon_sym_asm] = ACTIONS(2883),
    [anon_sym___asm__] = ACTIONS(2883),
    [anon_sym___asm] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [sym_number_literal] = ACTIONS(2881),
    [anon_sym_L_SQUOTE] = ACTIONS(2881),
    [anon_sym_u_SQUOTE] = ACTIONS(2881),
    [anon_sym_U_SQUOTE] = ACTIONS(2881),
    [anon_sym_u8_SQUOTE] = ACTIONS(2881),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_L_DQUOTE] = ACTIONS(2881),
    [anon_sym_u_DQUOTE] = ACTIONS(2881),
    [anon_sym_U_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [sym_true] = ACTIONS(2883),
    [sym_false] = ACTIONS(2883),
    [anon_sym_NULL] = ACTIONS(2883),
    [anon_sym_nullptr] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_explicit] = ACTIONS(2883),
    [anon_sym_typename] = ACTIONS(2883),
    [anon_sym_export] = ACTIONS(2883),
    [anon_sym_module] = ACTIONS(2883),
    [anon_sym_import] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_delete] = ACTIONS(2883),
    [anon_sym_throw] = ACTIONS(2883),
    [anon_sym_namespace] = ACTIONS(2883),
    [anon_sym_static_assert] = ACTIONS(2883),
    [anon_sym_concept] = ACTIONS(2883),
    [anon_sym_co_return] = ACTIONS(2883),
    [anon_sym_co_yield] = ACTIONS(2883),
    [anon_sym_R_DQUOTE] = ACTIONS(2881),
    [anon_sym_LR_DQUOTE] = ACTIONS(2881),
    [anon_sym_uR_DQUOTE] = ACTIONS(2881),
    [anon_sym_UR_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2881),
    [anon_sym_co_await] = ACTIONS(2883),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_requires] = ACTIONS(2883),
    [sym_this] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
    [anon_sym_interface] = ACTIONS(2883),
    [anon_sym_extension] = ACTIONS(2883),
    [anon_sym___exported] = ACTIONS(2883),
  },
  [832] = {
    [sym_identifier] = ACTIONS(3655),
    [aux_sym_preproc_include_token1] = ACTIONS(3655),
    [aux_sym_preproc_def_token1] = ACTIONS(3655),
    [aux_sym_preproc_if_token1] = ACTIONS(3655),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3655),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3655),
    [sym_preproc_directive] = ACTIONS(3655),
    [anon_sym_LPAREN2] = ACTIONS(3653),
    [anon_sym_BANG] = ACTIONS(3653),
    [anon_sym_TILDE] = ACTIONS(3653),
    [anon_sym_DASH] = ACTIONS(3655),
    [anon_sym_PLUS] = ACTIONS(3655),
    [anon_sym_STAR] = ACTIONS(3653),
    [anon_sym_AMP_AMP] = ACTIONS(3653),
    [anon_sym_AMP] = ACTIONS(3655),
    [anon_sym_SEMI] = ACTIONS(3653),
    [anon_sym___extension__] = ACTIONS(3655),
    [anon_sym_typedef] = ACTIONS(3655),
    [anon_sym_in] = ACTIONS(3655),
    [anon_sym_out] = ACTIONS(3655),
    [anon_sym_inout] = ACTIONS(3655),
    [anon_sym_virtual] = ACTIONS(3655),
    [anon_sym_extern] = ACTIONS(3655),
    [anon_sym___attribute__] = ACTIONS(3655),
    [anon_sym___attribute] = ACTIONS(3655),
    [anon_sym_using] = ACTIONS(3655),
    [anon_sym_COLON_COLON] = ACTIONS(3653),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3653),
    [anon_sym___declspec] = ACTIONS(3655),
    [anon_sym___based] = ACTIONS(3655),
    [anon_sym___cdecl] = ACTIONS(3655),
    [anon_sym___clrcall] = ACTIONS(3655),
    [anon_sym___stdcall] = ACTIONS(3655),
    [anon_sym___fastcall] = ACTIONS(3655),
    [anon_sym___thiscall] = ACTIONS(3655),
    [anon_sym___vectorcall] = ACTIONS(3655),
    [anon_sym_LBRACE] = ACTIONS(3653),
    [anon_sym_RBRACE] = ACTIONS(3653),
    [anon_sym_signed] = ACTIONS(3655),
    [anon_sym_unsigned] = ACTIONS(3655),
    [anon_sym_long] = ACTIONS(3655),
    [anon_sym_short] = ACTIONS(3655),
    [anon_sym_LBRACK] = ACTIONS(3655),
    [anon_sym_static] = ACTIONS(3655),
    [anon_sym_register] = ACTIONS(3655),
    [anon_sym_inline] = ACTIONS(3655),
    [anon_sym___inline] = ACTIONS(3655),
    [anon_sym___inline__] = ACTIONS(3655),
    [anon_sym___forceinline] = ACTIONS(3655),
    [anon_sym_thread_local] = ACTIONS(3655),
    [anon_sym___thread] = ACTIONS(3655),
    [anon_sym_const] = ACTIONS(3655),
    [anon_sym_constexpr] = ACTIONS(3655),
    [anon_sym_volatile] = ACTIONS(3655),
    [anon_sym_restrict] = ACTIONS(3655),
    [anon_sym___restrict__] = ACTIONS(3655),
    [anon_sym__Atomic] = ACTIONS(3655),
    [anon_sym__Noreturn] = ACTIONS(3655),
    [anon_sym_noreturn] = ACTIONS(3655),
    [anon_sym__Nonnull] = ACTIONS(3655),
    [anon_sym_mutable] = ACTIONS(3655),
    [anon_sym_constinit] = ACTIONS(3655),
    [anon_sym_consteval] = ACTIONS(3655),
    [anon_sym_alignas] = ACTIONS(3655),
    [anon_sym__Alignas] = ACTIONS(3655),
    [sym_primitive_type] = ACTIONS(3655),
    [anon_sym_enum] = ACTIONS(3655),
    [anon_sym_class] = ACTIONS(3655),
    [anon_sym_struct] = ACTIONS(3655),
    [anon_sym_union] = ACTIONS(3655),
    [anon_sym_if] = ACTIONS(3655),
    [anon_sym_else] = ACTIONS(3655),
    [anon_sym_switch] = ACTIONS(3655),
    [anon_sym_case] = ACTIONS(3655),
    [anon_sym_default] = ACTIONS(3655),
    [anon_sym_while] = ACTIONS(3655),
    [anon_sym_do] = ACTIONS(3655),
    [anon_sym_for] = ACTIONS(3655),
    [anon_sym_return] = ACTIONS(3655),
    [anon_sym_break] = ACTIONS(3655),
    [anon_sym_continue] = ACTIONS(3655),
    [anon_sym_goto] = ACTIONS(3655),
    [anon_sym___try] = ACTIONS(3655),
    [anon_sym___leave] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3655),
    [anon_sym_compl] = ACTIONS(3655),
    [anon_sym_DASH_DASH] = ACTIONS(3653),
    [anon_sym_PLUS_PLUS] = ACTIONS(3653),
    [anon_sym_sizeof] = ACTIONS(3655),
    [anon_sym___alignof__] = ACTIONS(3655),
    [anon_sym___alignof] = ACTIONS(3655),
    [anon_sym__alignof] = ACTIONS(3655),
    [anon_sym_alignof] = ACTIONS(3655),
    [anon_sym__Alignof] = ACTIONS(3655),
    [anon_sym_offsetof] = ACTIONS(3655),
    [anon_sym__Generic] = ACTIONS(3655),
    [anon_sym_asm] = ACTIONS(3655),
    [anon_sym___asm__] = ACTIONS(3655),
    [anon_sym___asm] = ACTIONS(3655),
    [sym_number_literal] = ACTIONS(3653),
    [anon_sym_L_SQUOTE] = ACTIONS(3653),
    [anon_sym_u_SQUOTE] = ACTIONS(3653),
    [anon_sym_U_SQUOTE] = ACTIONS(3653),
    [anon_sym_u8_SQUOTE] = ACTIONS(3653),
    [anon_sym_SQUOTE] = ACTIONS(3653),
    [anon_sym_L_DQUOTE] = ACTIONS(3653),
    [anon_sym_u_DQUOTE] = ACTIONS(3653),
    [anon_sym_U_DQUOTE] = ACTIONS(3653),
    [anon_sym_u8_DQUOTE] = ACTIONS(3653),
    [anon_sym_DQUOTE] = ACTIONS(3653),
    [sym_true] = ACTIONS(3655),
    [sym_false] = ACTIONS(3655),
    [anon_sym_NULL] = ACTIONS(3655),
    [anon_sym_nullptr] = ACTIONS(3655),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3655),
    [anon_sym_let] = ACTIONS(3655),
    [anon_sym_This] = ACTIONS(3655),
    [anon_sym_decltype] = ACTIONS(3655),
    [anon_sym_explicit] = ACTIONS(3655),
    [anon_sym_typename] = ACTIONS(3655),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_operator] = ACTIONS(3655),
    [anon_sym_try] = ACTIONS(3655),
    [anon_sym_delete] = ACTIONS(3655),
    [anon_sym_throw] = ACTIONS(3655),
    [anon_sym_namespace] = ACTIONS(3655),
    [anon_sym_static_assert] = ACTIONS(3655),
    [anon_sym_concept] = ACTIONS(3655),
    [anon_sym_co_return] = ACTIONS(3655),
    [anon_sym_co_yield] = ACTIONS(3655),
    [anon_sym_R_DQUOTE] = ACTIONS(3653),
    [anon_sym_LR_DQUOTE] = ACTIONS(3653),
    [anon_sym_uR_DQUOTE] = ACTIONS(3653),
    [anon_sym_UR_DQUOTE] = ACTIONS(3653),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3653),
    [anon_sym_co_await] = ACTIONS(3655),
    [anon_sym_new] = ACTIONS(3655),
    [anon_sym_requires] = ACTIONS(3655),
    [sym_this] = ACTIONS(3655),
    [anon_sym_discard] = ACTIONS(3655),
    [anon_sym_precise] = ACTIONS(3655),
    [anon_sym_shared] = ACTIONS(3655),
    [anon_sym_groupshared] = ACTIONS(3655),
    [anon_sym_uniform] = ACTIONS(3655),
    [anon_sym_row_major] = ACTIONS(3655),
    [anon_sym_column_major] = ACTIONS(3655),
    [anon_sym_globallycoherent] = ACTIONS(3655),
    [anon_sym_centroid] = ACTIONS(3655),
    [anon_sym_noperspective] = ACTIONS(3655),
    [anon_sym_nointerpolation] = ACTIONS(3655),
    [anon_sym_sample] = ACTIONS(3655),
    [anon_sym_linear] = ACTIONS(3655),
    [anon_sym_snorm] = ACTIONS(3655),
    [anon_sym_unorm] = ACTIONS(3655),
    [anon_sym_point] = ACTIONS(3655),
    [anon_sym_line] = ACTIONS(3655),
    [anon_sym_triangleadj] = ACTIONS(3655),
    [anon_sym_lineadj] = ACTIONS(3655),
    [anon_sym_triangle] = ACTIONS(3655),
    [anon_sym_cbuffer] = ACTIONS(3655),
    [anon_sym_interface] = ACTIONS(3655),
    [anon_sym_extension] = ACTIONS(3655),
  },
  [833] = {
    [sym_identifier] = ACTIONS(3585),
    [aux_sym_preproc_include_token1] = ACTIONS(3585),
    [aux_sym_preproc_def_token1] = ACTIONS(3585),
    [aux_sym_preproc_if_token1] = ACTIONS(3585),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3585),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3585),
    [sym_preproc_directive] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(3587),
    [anon_sym_BANG] = ACTIONS(3587),
    [anon_sym_TILDE] = ACTIONS(3587),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_STAR] = ACTIONS(3587),
    [anon_sym_AMP_AMP] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_SEMI] = ACTIONS(3587),
    [anon_sym___extension__] = ACTIONS(3585),
    [anon_sym_typedef] = ACTIONS(3585),
    [anon_sym_in] = ACTIONS(3585),
    [anon_sym_out] = ACTIONS(3585),
    [anon_sym_inout] = ACTIONS(3585),
    [anon_sym_virtual] = ACTIONS(3585),
    [anon_sym_extern] = ACTIONS(3585),
    [anon_sym___attribute__] = ACTIONS(3585),
    [anon_sym___attribute] = ACTIONS(3585),
    [anon_sym_using] = ACTIONS(3585),
    [anon_sym_COLON_COLON] = ACTIONS(3587),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3587),
    [anon_sym___declspec] = ACTIONS(3585),
    [anon_sym___based] = ACTIONS(3585),
    [anon_sym___cdecl] = ACTIONS(3585),
    [anon_sym___clrcall] = ACTIONS(3585),
    [anon_sym___stdcall] = ACTIONS(3585),
    [anon_sym___fastcall] = ACTIONS(3585),
    [anon_sym___thiscall] = ACTIONS(3585),
    [anon_sym___vectorcall] = ACTIONS(3585),
    [anon_sym_LBRACE] = ACTIONS(3587),
    [anon_sym_RBRACE] = ACTIONS(3587),
    [anon_sym_signed] = ACTIONS(3585),
    [anon_sym_unsigned] = ACTIONS(3585),
    [anon_sym_long] = ACTIONS(3585),
    [anon_sym_short] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(3585),
    [anon_sym_static] = ACTIONS(3585),
    [anon_sym_register] = ACTIONS(3585),
    [anon_sym_inline] = ACTIONS(3585),
    [anon_sym___inline] = ACTIONS(3585),
    [anon_sym___inline__] = ACTIONS(3585),
    [anon_sym___forceinline] = ACTIONS(3585),
    [anon_sym_thread_local] = ACTIONS(3585),
    [anon_sym___thread] = ACTIONS(3585),
    [anon_sym_const] = ACTIONS(3585),
    [anon_sym_constexpr] = ACTIONS(3585),
    [anon_sym_volatile] = ACTIONS(3585),
    [anon_sym_restrict] = ACTIONS(3585),
    [anon_sym___restrict__] = ACTIONS(3585),
    [anon_sym__Atomic] = ACTIONS(3585),
    [anon_sym__Noreturn] = ACTIONS(3585),
    [anon_sym_noreturn] = ACTIONS(3585),
    [anon_sym__Nonnull] = ACTIONS(3585),
    [anon_sym_mutable] = ACTIONS(3585),
    [anon_sym_constinit] = ACTIONS(3585),
    [anon_sym_consteval] = ACTIONS(3585),
    [anon_sym_alignas] = ACTIONS(3585),
    [anon_sym__Alignas] = ACTIONS(3585),
    [sym_primitive_type] = ACTIONS(3585),
    [anon_sym_enum] = ACTIONS(3585),
    [anon_sym_class] = ACTIONS(3585),
    [anon_sym_struct] = ACTIONS(3585),
    [anon_sym_union] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_else] = ACTIONS(3585),
    [anon_sym_switch] = ACTIONS(3585),
    [anon_sym_case] = ACTIONS(3585),
    [anon_sym_default] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_do] = ACTIONS(3585),
    [anon_sym_for] = ACTIONS(3585),
    [anon_sym_return] = ACTIONS(3585),
    [anon_sym_break] = ACTIONS(3585),
    [anon_sym_continue] = ACTIONS(3585),
    [anon_sym_goto] = ACTIONS(3585),
    [anon_sym___try] = ACTIONS(3585),
    [anon_sym___leave] = ACTIONS(3585),
    [anon_sym_not] = ACTIONS(3585),
    [anon_sym_compl] = ACTIONS(3585),
    [anon_sym_DASH_DASH] = ACTIONS(3587),
    [anon_sym_PLUS_PLUS] = ACTIONS(3587),
    [anon_sym_sizeof] = ACTIONS(3585),
    [anon_sym___alignof__] = ACTIONS(3585),
    [anon_sym___alignof] = ACTIONS(3585),
    [anon_sym__alignof] = ACTIONS(3585),
    [anon_sym_alignof] = ACTIONS(3585),
    [anon_sym__Alignof] = ACTIONS(3585),
    [anon_sym_offsetof] = ACTIONS(3585),
    [anon_sym__Generic] = ACTIONS(3585),
    [anon_sym_asm] = ACTIONS(3585),
    [anon_sym___asm__] = ACTIONS(3585),
    [anon_sym___asm] = ACTIONS(3585),
    [sym_number_literal] = ACTIONS(3587),
    [anon_sym_L_SQUOTE] = ACTIONS(3587),
    [anon_sym_u_SQUOTE] = ACTIONS(3587),
    [anon_sym_U_SQUOTE] = ACTIONS(3587),
    [anon_sym_u8_SQUOTE] = ACTIONS(3587),
    [anon_sym_SQUOTE] = ACTIONS(3587),
    [anon_sym_L_DQUOTE] = ACTIONS(3587),
    [anon_sym_u_DQUOTE] = ACTIONS(3587),
    [anon_sym_U_DQUOTE] = ACTIONS(3587),
    [anon_sym_u8_DQUOTE] = ACTIONS(3587),
    [anon_sym_DQUOTE] = ACTIONS(3587),
    [sym_true] = ACTIONS(3585),
    [sym_false] = ACTIONS(3585),
    [anon_sym_NULL] = ACTIONS(3585),
    [anon_sym_nullptr] = ACTIONS(3585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3585),
    [anon_sym_let] = ACTIONS(3585),
    [anon_sym_This] = ACTIONS(3585),
    [anon_sym_decltype] = ACTIONS(3585),
    [anon_sym_explicit] = ACTIONS(3585),
    [anon_sym_typename] = ACTIONS(3585),
    [anon_sym_template] = ACTIONS(3585),
    [anon_sym_operator] = ACTIONS(3585),
    [anon_sym_try] = ACTIONS(3585),
    [anon_sym_delete] = ACTIONS(3585),
    [anon_sym_throw] = ACTIONS(3585),
    [anon_sym_namespace] = ACTIONS(3585),
    [anon_sym_static_assert] = ACTIONS(3585),
    [anon_sym_concept] = ACTIONS(3585),
    [anon_sym_co_return] = ACTIONS(3585),
    [anon_sym_co_yield] = ACTIONS(3585),
    [anon_sym_R_DQUOTE] = ACTIONS(3587),
    [anon_sym_LR_DQUOTE] = ACTIONS(3587),
    [anon_sym_uR_DQUOTE] = ACTIONS(3587),
    [anon_sym_UR_DQUOTE] = ACTIONS(3587),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3587),
    [anon_sym_co_await] = ACTIONS(3585),
    [anon_sym_new] = ACTIONS(3585),
    [anon_sym_requires] = ACTIONS(3585),
    [sym_this] = ACTIONS(3585),
    [anon_sym_discard] = ACTIONS(3585),
    [anon_sym_precise] = ACTIONS(3585),
    [anon_sym_shared] = ACTIONS(3585),
    [anon_sym_groupshared] = ACTIONS(3585),
    [anon_sym_uniform] = ACTIONS(3585),
    [anon_sym_row_major] = ACTIONS(3585),
    [anon_sym_column_major] = ACTIONS(3585),
    [anon_sym_globallycoherent] = ACTIONS(3585),
    [anon_sym_centroid] = ACTIONS(3585),
    [anon_sym_noperspective] = ACTIONS(3585),
    [anon_sym_nointerpolation] = ACTIONS(3585),
    [anon_sym_sample] = ACTIONS(3585),
    [anon_sym_linear] = ACTIONS(3585),
    [anon_sym_snorm] = ACTIONS(3585),
    [anon_sym_unorm] = ACTIONS(3585),
    [anon_sym_point] = ACTIONS(3585),
    [anon_sym_line] = ACTIONS(3585),
    [anon_sym_triangleadj] = ACTIONS(3585),
    [anon_sym_lineadj] = ACTIONS(3585),
    [anon_sym_triangle] = ACTIONS(3585),
    [anon_sym_cbuffer] = ACTIONS(3585),
    [anon_sym_interface] = ACTIONS(3585),
    [anon_sym_extension] = ACTIONS(3585),
  },
  [834] = {
    [sym_identifier] = ACTIONS(3631),
    [aux_sym_preproc_include_token1] = ACTIONS(3631),
    [aux_sym_preproc_def_token1] = ACTIONS(3631),
    [aux_sym_preproc_if_token1] = ACTIONS(3631),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3631),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3631),
    [sym_preproc_directive] = ACTIONS(3631),
    [anon_sym_LPAREN2] = ACTIONS(3629),
    [anon_sym_BANG] = ACTIONS(3629),
    [anon_sym_TILDE] = ACTIONS(3629),
    [anon_sym_DASH] = ACTIONS(3631),
    [anon_sym_PLUS] = ACTIONS(3631),
    [anon_sym_STAR] = ACTIONS(3629),
    [anon_sym_AMP_AMP] = ACTIONS(3629),
    [anon_sym_AMP] = ACTIONS(3631),
    [anon_sym_SEMI] = ACTIONS(3629),
    [anon_sym___extension__] = ACTIONS(3631),
    [anon_sym_typedef] = ACTIONS(3631),
    [anon_sym_in] = ACTIONS(3631),
    [anon_sym_out] = ACTIONS(3631),
    [anon_sym_inout] = ACTIONS(3631),
    [anon_sym_virtual] = ACTIONS(3631),
    [anon_sym_extern] = ACTIONS(3631),
    [anon_sym___attribute__] = ACTIONS(3631),
    [anon_sym___attribute] = ACTIONS(3631),
    [anon_sym_using] = ACTIONS(3631),
    [anon_sym_COLON_COLON] = ACTIONS(3629),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3629),
    [anon_sym___declspec] = ACTIONS(3631),
    [anon_sym___based] = ACTIONS(3631),
    [anon_sym___cdecl] = ACTIONS(3631),
    [anon_sym___clrcall] = ACTIONS(3631),
    [anon_sym___stdcall] = ACTIONS(3631),
    [anon_sym___fastcall] = ACTIONS(3631),
    [anon_sym___thiscall] = ACTIONS(3631),
    [anon_sym___vectorcall] = ACTIONS(3631),
    [anon_sym_LBRACE] = ACTIONS(3629),
    [anon_sym_RBRACE] = ACTIONS(3629),
    [anon_sym_signed] = ACTIONS(3631),
    [anon_sym_unsigned] = ACTIONS(3631),
    [anon_sym_long] = ACTIONS(3631),
    [anon_sym_short] = ACTIONS(3631),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_static] = ACTIONS(3631),
    [anon_sym_register] = ACTIONS(3631),
    [anon_sym_inline] = ACTIONS(3631),
    [anon_sym___inline] = ACTIONS(3631),
    [anon_sym___inline__] = ACTIONS(3631),
    [anon_sym___forceinline] = ACTIONS(3631),
    [anon_sym_thread_local] = ACTIONS(3631),
    [anon_sym___thread] = ACTIONS(3631),
    [anon_sym_const] = ACTIONS(3631),
    [anon_sym_constexpr] = ACTIONS(3631),
    [anon_sym_volatile] = ACTIONS(3631),
    [anon_sym_restrict] = ACTIONS(3631),
    [anon_sym___restrict__] = ACTIONS(3631),
    [anon_sym__Atomic] = ACTIONS(3631),
    [anon_sym__Noreturn] = ACTIONS(3631),
    [anon_sym_noreturn] = ACTIONS(3631),
    [anon_sym__Nonnull] = ACTIONS(3631),
    [anon_sym_mutable] = ACTIONS(3631),
    [anon_sym_constinit] = ACTIONS(3631),
    [anon_sym_consteval] = ACTIONS(3631),
    [anon_sym_alignas] = ACTIONS(3631),
    [anon_sym__Alignas] = ACTIONS(3631),
    [sym_primitive_type] = ACTIONS(3631),
    [anon_sym_enum] = ACTIONS(3631),
    [anon_sym_class] = ACTIONS(3631),
    [anon_sym_struct] = ACTIONS(3631),
    [anon_sym_union] = ACTIONS(3631),
    [anon_sym_if] = ACTIONS(3631),
    [anon_sym_else] = ACTIONS(3631),
    [anon_sym_switch] = ACTIONS(3631),
    [anon_sym_case] = ACTIONS(3631),
    [anon_sym_default] = ACTIONS(3631),
    [anon_sym_while] = ACTIONS(3631),
    [anon_sym_do] = ACTIONS(3631),
    [anon_sym_for] = ACTIONS(3631),
    [anon_sym_return] = ACTIONS(3631),
    [anon_sym_break] = ACTIONS(3631),
    [anon_sym_continue] = ACTIONS(3631),
    [anon_sym_goto] = ACTIONS(3631),
    [anon_sym___try] = ACTIONS(3631),
    [anon_sym___leave] = ACTIONS(3631),
    [anon_sym_not] = ACTIONS(3631),
    [anon_sym_compl] = ACTIONS(3631),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_sizeof] = ACTIONS(3631),
    [anon_sym___alignof__] = ACTIONS(3631),
    [anon_sym___alignof] = ACTIONS(3631),
    [anon_sym__alignof] = ACTIONS(3631),
    [anon_sym_alignof] = ACTIONS(3631),
    [anon_sym__Alignof] = ACTIONS(3631),
    [anon_sym_offsetof] = ACTIONS(3631),
    [anon_sym__Generic] = ACTIONS(3631),
    [anon_sym_asm] = ACTIONS(3631),
    [anon_sym___asm__] = ACTIONS(3631),
    [anon_sym___asm] = ACTIONS(3631),
    [sym_number_literal] = ACTIONS(3629),
    [anon_sym_L_SQUOTE] = ACTIONS(3629),
    [anon_sym_u_SQUOTE] = ACTIONS(3629),
    [anon_sym_U_SQUOTE] = ACTIONS(3629),
    [anon_sym_u8_SQUOTE] = ACTIONS(3629),
    [anon_sym_SQUOTE] = ACTIONS(3629),
    [anon_sym_L_DQUOTE] = ACTIONS(3629),
    [anon_sym_u_DQUOTE] = ACTIONS(3629),
    [anon_sym_U_DQUOTE] = ACTIONS(3629),
    [anon_sym_u8_DQUOTE] = ACTIONS(3629),
    [anon_sym_DQUOTE] = ACTIONS(3629),
    [sym_true] = ACTIONS(3631),
    [sym_false] = ACTIONS(3631),
    [anon_sym_NULL] = ACTIONS(3631),
    [anon_sym_nullptr] = ACTIONS(3631),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3631),
    [anon_sym_let] = ACTIONS(3631),
    [anon_sym_This] = ACTIONS(3631),
    [anon_sym_decltype] = ACTIONS(3631),
    [anon_sym_explicit] = ACTIONS(3631),
    [anon_sym_typename] = ACTIONS(3631),
    [anon_sym_template] = ACTIONS(3631),
    [anon_sym_operator] = ACTIONS(3631),
    [anon_sym_try] = ACTIONS(3631),
    [anon_sym_delete] = ACTIONS(3631),
    [anon_sym_throw] = ACTIONS(3631),
    [anon_sym_namespace] = ACTIONS(3631),
    [anon_sym_static_assert] = ACTIONS(3631),
    [anon_sym_concept] = ACTIONS(3631),
    [anon_sym_co_return] = ACTIONS(3631),
    [anon_sym_co_yield] = ACTIONS(3631),
    [anon_sym_R_DQUOTE] = ACTIONS(3629),
    [anon_sym_LR_DQUOTE] = ACTIONS(3629),
    [anon_sym_uR_DQUOTE] = ACTIONS(3629),
    [anon_sym_UR_DQUOTE] = ACTIONS(3629),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3629),
    [anon_sym_co_await] = ACTIONS(3631),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3631),
    [sym_this] = ACTIONS(3631),
    [anon_sym_discard] = ACTIONS(3631),
    [anon_sym_precise] = ACTIONS(3631),
    [anon_sym_shared] = ACTIONS(3631),
    [anon_sym_groupshared] = ACTIONS(3631),
    [anon_sym_uniform] = ACTIONS(3631),
    [anon_sym_row_major] = ACTIONS(3631),
    [anon_sym_column_major] = ACTIONS(3631),
    [anon_sym_globallycoherent] = ACTIONS(3631),
    [anon_sym_centroid] = ACTIONS(3631),
    [anon_sym_noperspective] = ACTIONS(3631),
    [anon_sym_nointerpolation] = ACTIONS(3631),
    [anon_sym_sample] = ACTIONS(3631),
    [anon_sym_linear] = ACTIONS(3631),
    [anon_sym_snorm] = ACTIONS(3631),
    [anon_sym_unorm] = ACTIONS(3631),
    [anon_sym_point] = ACTIONS(3631),
    [anon_sym_line] = ACTIONS(3631),
    [anon_sym_triangleadj] = ACTIONS(3631),
    [anon_sym_lineadj] = ACTIONS(3631),
    [anon_sym_triangle] = ACTIONS(3631),
    [anon_sym_cbuffer] = ACTIONS(3631),
    [anon_sym_interface] = ACTIONS(3631),
    [anon_sym_extension] = ACTIONS(3631),
  },
  [835] = {
    [sym_identifier] = ACTIONS(3593),
    [aux_sym_preproc_include_token1] = ACTIONS(3593),
    [aux_sym_preproc_def_token1] = ACTIONS(3593),
    [aux_sym_preproc_if_token1] = ACTIONS(3593),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3593),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3593),
    [sym_preproc_directive] = ACTIONS(3593),
    [anon_sym_LPAREN2] = ACTIONS(3595),
    [anon_sym_BANG] = ACTIONS(3595),
    [anon_sym_TILDE] = ACTIONS(3595),
    [anon_sym_DASH] = ACTIONS(3593),
    [anon_sym_PLUS] = ACTIONS(3593),
    [anon_sym_STAR] = ACTIONS(3595),
    [anon_sym_AMP_AMP] = ACTIONS(3595),
    [anon_sym_AMP] = ACTIONS(3593),
    [anon_sym_SEMI] = ACTIONS(3595),
    [anon_sym___extension__] = ACTIONS(3593),
    [anon_sym_typedef] = ACTIONS(3593),
    [anon_sym_in] = ACTIONS(3593),
    [anon_sym_out] = ACTIONS(3593),
    [anon_sym_inout] = ACTIONS(3593),
    [anon_sym_virtual] = ACTIONS(3593),
    [anon_sym_extern] = ACTIONS(3593),
    [anon_sym___attribute__] = ACTIONS(3593),
    [anon_sym___attribute] = ACTIONS(3593),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_COLON_COLON] = ACTIONS(3595),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3595),
    [anon_sym___declspec] = ACTIONS(3593),
    [anon_sym___based] = ACTIONS(3593),
    [anon_sym___cdecl] = ACTIONS(3593),
    [anon_sym___clrcall] = ACTIONS(3593),
    [anon_sym___stdcall] = ACTIONS(3593),
    [anon_sym___fastcall] = ACTIONS(3593),
    [anon_sym___thiscall] = ACTIONS(3593),
    [anon_sym___vectorcall] = ACTIONS(3593),
    [anon_sym_LBRACE] = ACTIONS(3595),
    [anon_sym_RBRACE] = ACTIONS(3595),
    [anon_sym_signed] = ACTIONS(3593),
    [anon_sym_unsigned] = ACTIONS(3593),
    [anon_sym_long] = ACTIONS(3593),
    [anon_sym_short] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(3593),
    [anon_sym_static] = ACTIONS(3593),
    [anon_sym_register] = ACTIONS(3593),
    [anon_sym_inline] = ACTIONS(3593),
    [anon_sym___inline] = ACTIONS(3593),
    [anon_sym___inline__] = ACTIONS(3593),
    [anon_sym___forceinline] = ACTIONS(3593),
    [anon_sym_thread_local] = ACTIONS(3593),
    [anon_sym___thread] = ACTIONS(3593),
    [anon_sym_const] = ACTIONS(3593),
    [anon_sym_constexpr] = ACTIONS(3593),
    [anon_sym_volatile] = ACTIONS(3593),
    [anon_sym_restrict] = ACTIONS(3593),
    [anon_sym___restrict__] = ACTIONS(3593),
    [anon_sym__Atomic] = ACTIONS(3593),
    [anon_sym__Noreturn] = ACTIONS(3593),
    [anon_sym_noreturn] = ACTIONS(3593),
    [anon_sym__Nonnull] = ACTIONS(3593),
    [anon_sym_mutable] = ACTIONS(3593),
    [anon_sym_constinit] = ACTIONS(3593),
    [anon_sym_consteval] = ACTIONS(3593),
    [anon_sym_alignas] = ACTIONS(3593),
    [anon_sym__Alignas] = ACTIONS(3593),
    [sym_primitive_type] = ACTIONS(3593),
    [anon_sym_enum] = ACTIONS(3593),
    [anon_sym_class] = ACTIONS(3593),
    [anon_sym_struct] = ACTIONS(3593),
    [anon_sym_union] = ACTIONS(3593),
    [anon_sym_if] = ACTIONS(3593),
    [anon_sym_else] = ACTIONS(3593),
    [anon_sym_switch] = ACTIONS(3593),
    [anon_sym_case] = ACTIONS(3593),
    [anon_sym_default] = ACTIONS(3593),
    [anon_sym_while] = ACTIONS(3593),
    [anon_sym_do] = ACTIONS(3593),
    [anon_sym_for] = ACTIONS(3593),
    [anon_sym_return] = ACTIONS(3593),
    [anon_sym_break] = ACTIONS(3593),
    [anon_sym_continue] = ACTIONS(3593),
    [anon_sym_goto] = ACTIONS(3593),
    [anon_sym___try] = ACTIONS(3593),
    [anon_sym___leave] = ACTIONS(3593),
    [anon_sym_not] = ACTIONS(3593),
    [anon_sym_compl] = ACTIONS(3593),
    [anon_sym_DASH_DASH] = ACTIONS(3595),
    [anon_sym_PLUS_PLUS] = ACTIONS(3595),
    [anon_sym_sizeof] = ACTIONS(3593),
    [anon_sym___alignof__] = ACTIONS(3593),
    [anon_sym___alignof] = ACTIONS(3593),
    [anon_sym__alignof] = ACTIONS(3593),
    [anon_sym_alignof] = ACTIONS(3593),
    [anon_sym__Alignof] = ACTIONS(3593),
    [anon_sym_offsetof] = ACTIONS(3593),
    [anon_sym__Generic] = ACTIONS(3593),
    [anon_sym_asm] = ACTIONS(3593),
    [anon_sym___asm__] = ACTIONS(3593),
    [anon_sym___asm] = ACTIONS(3593),
    [sym_number_literal] = ACTIONS(3595),
    [anon_sym_L_SQUOTE] = ACTIONS(3595),
    [anon_sym_u_SQUOTE] = ACTIONS(3595),
    [anon_sym_U_SQUOTE] = ACTIONS(3595),
    [anon_sym_u8_SQUOTE] = ACTIONS(3595),
    [anon_sym_SQUOTE] = ACTIONS(3595),
    [anon_sym_L_DQUOTE] = ACTIONS(3595),
    [anon_sym_u_DQUOTE] = ACTIONS(3595),
    [anon_sym_U_DQUOTE] = ACTIONS(3595),
    [anon_sym_u8_DQUOTE] = ACTIONS(3595),
    [anon_sym_DQUOTE] = ACTIONS(3595),
    [sym_true] = ACTIONS(3593),
    [sym_false] = ACTIONS(3593),
    [anon_sym_NULL] = ACTIONS(3593),
    [anon_sym_nullptr] = ACTIONS(3593),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3593),
    [anon_sym_let] = ACTIONS(3593),
    [anon_sym_This] = ACTIONS(3593),
    [anon_sym_decltype] = ACTIONS(3593),
    [anon_sym_explicit] = ACTIONS(3593),
    [anon_sym_typename] = ACTIONS(3593),
    [anon_sym_template] = ACTIONS(3593),
    [anon_sym_operator] = ACTIONS(3593),
    [anon_sym_try] = ACTIONS(3593),
    [anon_sym_delete] = ACTIONS(3593),
    [anon_sym_throw] = ACTIONS(3593),
    [anon_sym_namespace] = ACTIONS(3593),
    [anon_sym_static_assert] = ACTIONS(3593),
    [anon_sym_concept] = ACTIONS(3593),
    [anon_sym_co_return] = ACTIONS(3593),
    [anon_sym_co_yield] = ACTIONS(3593),
    [anon_sym_R_DQUOTE] = ACTIONS(3595),
    [anon_sym_LR_DQUOTE] = ACTIONS(3595),
    [anon_sym_uR_DQUOTE] = ACTIONS(3595),
    [anon_sym_UR_DQUOTE] = ACTIONS(3595),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3595),
    [anon_sym_co_await] = ACTIONS(3593),
    [anon_sym_new] = ACTIONS(3593),
    [anon_sym_requires] = ACTIONS(3593),
    [sym_this] = ACTIONS(3593),
    [anon_sym_discard] = ACTIONS(3593),
    [anon_sym_precise] = ACTIONS(3593),
    [anon_sym_shared] = ACTIONS(3593),
    [anon_sym_groupshared] = ACTIONS(3593),
    [anon_sym_uniform] = ACTIONS(3593),
    [anon_sym_row_major] = ACTIONS(3593),
    [anon_sym_column_major] = ACTIONS(3593),
    [anon_sym_globallycoherent] = ACTIONS(3593),
    [anon_sym_centroid] = ACTIONS(3593),
    [anon_sym_noperspective] = ACTIONS(3593),
    [anon_sym_nointerpolation] = ACTIONS(3593),
    [anon_sym_sample] = ACTIONS(3593),
    [anon_sym_linear] = ACTIONS(3593),
    [anon_sym_snorm] = ACTIONS(3593),
    [anon_sym_unorm] = ACTIONS(3593),
    [anon_sym_point] = ACTIONS(3593),
    [anon_sym_line] = ACTIONS(3593),
    [anon_sym_triangleadj] = ACTIONS(3593),
    [anon_sym_lineadj] = ACTIONS(3593),
    [anon_sym_triangle] = ACTIONS(3593),
    [anon_sym_cbuffer] = ACTIONS(3593),
    [anon_sym_interface] = ACTIONS(3593),
    [anon_sym_extension] = ACTIONS(3593),
  },
  [836] = {
    [ts_builtin_sym_end] = ACTIONS(4250),
    [sym_identifier] = ACTIONS(4248),
    [aux_sym_preproc_include_token1] = ACTIONS(4248),
    [aux_sym_preproc_def_token1] = ACTIONS(4248),
    [aux_sym_preproc_if_token1] = ACTIONS(4248),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4248),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4248),
    [sym_preproc_directive] = ACTIONS(4248),
    [anon_sym_LPAREN2] = ACTIONS(4250),
    [anon_sym_BANG] = ACTIONS(4250),
    [anon_sym_TILDE] = ACTIONS(4250),
    [anon_sym_DASH] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_AMP_AMP] = ACTIONS(4250),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4250),
    [anon_sym___extension__] = ACTIONS(4248),
    [anon_sym_typedef] = ACTIONS(4248),
    [anon_sym_in] = ACTIONS(4248),
    [anon_sym_out] = ACTIONS(4248),
    [anon_sym_inout] = ACTIONS(4248),
    [anon_sym_virtual] = ACTIONS(4248),
    [anon_sym_extern] = ACTIONS(4248),
    [anon_sym___attribute__] = ACTIONS(4248),
    [anon_sym___attribute] = ACTIONS(4248),
    [anon_sym_using] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4250),
    [anon_sym___declspec] = ACTIONS(4248),
    [anon_sym___based] = ACTIONS(4248),
    [anon_sym___cdecl] = ACTIONS(4248),
    [anon_sym___clrcall] = ACTIONS(4248),
    [anon_sym___stdcall] = ACTIONS(4248),
    [anon_sym___fastcall] = ACTIONS(4248),
    [anon_sym___thiscall] = ACTIONS(4248),
    [anon_sym___vectorcall] = ACTIONS(4248),
    [anon_sym_LBRACE] = ACTIONS(4250),
    [anon_sym_signed] = ACTIONS(4248),
    [anon_sym_unsigned] = ACTIONS(4248),
    [anon_sym_long] = ACTIONS(4248),
    [anon_sym_short] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_static] = ACTIONS(4248),
    [anon_sym_register] = ACTIONS(4248),
    [anon_sym_inline] = ACTIONS(4248),
    [anon_sym___inline] = ACTIONS(4248),
    [anon_sym___inline__] = ACTIONS(4248),
    [anon_sym___forceinline] = ACTIONS(4248),
    [anon_sym_thread_local] = ACTIONS(4248),
    [anon_sym___thread] = ACTIONS(4248),
    [anon_sym_const] = ACTIONS(4248),
    [anon_sym_constexpr] = ACTIONS(4248),
    [anon_sym_volatile] = ACTIONS(4248),
    [anon_sym_restrict] = ACTIONS(4248),
    [anon_sym___restrict__] = ACTIONS(4248),
    [anon_sym__Atomic] = ACTIONS(4248),
    [anon_sym__Noreturn] = ACTIONS(4248),
    [anon_sym_noreturn] = ACTIONS(4248),
    [anon_sym__Nonnull] = ACTIONS(4248),
    [anon_sym_mutable] = ACTIONS(4248),
    [anon_sym_constinit] = ACTIONS(4248),
    [anon_sym_consteval] = ACTIONS(4248),
    [anon_sym_alignas] = ACTIONS(4248),
    [anon_sym__Alignas] = ACTIONS(4248),
    [sym_primitive_type] = ACTIONS(4248),
    [anon_sym_enum] = ACTIONS(4248),
    [anon_sym_class] = ACTIONS(4248),
    [anon_sym_struct] = ACTIONS(4248),
    [anon_sym_union] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4248),
    [anon_sym_switch] = ACTIONS(4248),
    [anon_sym_case] = ACTIONS(4248),
    [anon_sym_default] = ACTIONS(4248),
    [anon_sym_while] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4248),
    [anon_sym_for] = ACTIONS(4248),
    [anon_sym_return] = ACTIONS(4248),
    [anon_sym_break] = ACTIONS(4248),
    [anon_sym_continue] = ACTIONS(4248),
    [anon_sym_goto] = ACTIONS(4248),
    [anon_sym_not] = ACTIONS(4248),
    [anon_sym_compl] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4250),
    [anon_sym_PLUS_PLUS] = ACTIONS(4250),
    [anon_sym_sizeof] = ACTIONS(4248),
    [anon_sym___alignof__] = ACTIONS(4248),
    [anon_sym___alignof] = ACTIONS(4248),
    [anon_sym__alignof] = ACTIONS(4248),
    [anon_sym_alignof] = ACTIONS(4248),
    [anon_sym__Alignof] = ACTIONS(4248),
    [anon_sym_offsetof] = ACTIONS(4248),
    [anon_sym__Generic] = ACTIONS(4248),
    [anon_sym_asm] = ACTIONS(4248),
    [anon_sym___asm__] = ACTIONS(4248),
    [anon_sym___asm] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4248),
    [sym_number_literal] = ACTIONS(4250),
    [anon_sym_L_SQUOTE] = ACTIONS(4250),
    [anon_sym_u_SQUOTE] = ACTIONS(4250),
    [anon_sym_U_SQUOTE] = ACTIONS(4250),
    [anon_sym_u8_SQUOTE] = ACTIONS(4250),
    [anon_sym_SQUOTE] = ACTIONS(4250),
    [anon_sym_L_DQUOTE] = ACTIONS(4250),
    [anon_sym_u_DQUOTE] = ACTIONS(4250),
    [anon_sym_U_DQUOTE] = ACTIONS(4250),
    [anon_sym_u8_DQUOTE] = ACTIONS(4250),
    [anon_sym_DQUOTE] = ACTIONS(4250),
    [sym_true] = ACTIONS(4248),
    [sym_false] = ACTIONS(4248),
    [anon_sym_NULL] = ACTIONS(4248),
    [anon_sym_nullptr] = ACTIONS(4248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4248),
    [anon_sym_let] = ACTIONS(4248),
    [anon_sym_This] = ACTIONS(4248),
    [anon_sym_decltype] = ACTIONS(4248),
    [anon_sym_explicit] = ACTIONS(4248),
    [anon_sym_typename] = ACTIONS(4248),
    [anon_sym_export] = ACTIONS(4248),
    [anon_sym_module] = ACTIONS(4248),
    [anon_sym_import] = ACTIONS(4248),
    [anon_sym_template] = ACTIONS(4248),
    [anon_sym_operator] = ACTIONS(4248),
    [anon_sym_try] = ACTIONS(4248),
    [anon_sym_delete] = ACTIONS(4248),
    [anon_sym_throw] = ACTIONS(4248),
    [anon_sym_namespace] = ACTIONS(4248),
    [anon_sym_static_assert] = ACTIONS(4248),
    [anon_sym_concept] = ACTIONS(4248),
    [anon_sym_co_return] = ACTIONS(4248),
    [anon_sym_co_yield] = ACTIONS(4248),
    [anon_sym_R_DQUOTE] = ACTIONS(4250),
    [anon_sym_LR_DQUOTE] = ACTIONS(4250),
    [anon_sym_uR_DQUOTE] = ACTIONS(4250),
    [anon_sym_UR_DQUOTE] = ACTIONS(4250),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4250),
    [anon_sym_co_await] = ACTIONS(4248),
    [anon_sym_new] = ACTIONS(4248),
    [anon_sym_requires] = ACTIONS(4248),
    [sym_this] = ACTIONS(4248),
    [anon_sym_precise] = ACTIONS(4248),
    [anon_sym_shared] = ACTIONS(4248),
    [anon_sym_groupshared] = ACTIONS(4248),
    [anon_sym_uniform] = ACTIONS(4248),
    [anon_sym_row_major] = ACTIONS(4248),
    [anon_sym_column_major] = ACTIONS(4248),
    [anon_sym_globallycoherent] = ACTIONS(4248),
    [anon_sym_centroid] = ACTIONS(4248),
    [anon_sym_noperspective] = ACTIONS(4248),
    [anon_sym_nointerpolation] = ACTIONS(4248),
    [anon_sym_sample] = ACTIONS(4248),
    [anon_sym_linear] = ACTIONS(4248),
    [anon_sym_snorm] = ACTIONS(4248),
    [anon_sym_unorm] = ACTIONS(4248),
    [anon_sym_point] = ACTIONS(4248),
    [anon_sym_line] = ACTIONS(4248),
    [anon_sym_triangleadj] = ACTIONS(4248),
    [anon_sym_lineadj] = ACTIONS(4248),
    [anon_sym_triangle] = ACTIONS(4248),
    [anon_sym_interface] = ACTIONS(4248),
    [anon_sym_extension] = ACTIONS(4248),
    [anon_sym___exported] = ACTIONS(4248),
  },
  [837] = {
    [sym_identifier] = ACTIONS(3383),
    [aux_sym_preproc_include_token1] = ACTIONS(3383),
    [aux_sym_preproc_def_token1] = ACTIONS(3383),
    [aux_sym_preproc_if_token1] = ACTIONS(3383),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3383),
    [sym_preproc_directive] = ACTIONS(3383),
    [anon_sym_LPAREN2] = ACTIONS(3385),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_TILDE] = ACTIONS(3385),
    [anon_sym_DASH] = ACTIONS(3383),
    [anon_sym_PLUS] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(3385),
    [anon_sym_AMP_AMP] = ACTIONS(3385),
    [anon_sym_AMP] = ACTIONS(3383),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym___extension__] = ACTIONS(3383),
    [anon_sym_typedef] = ACTIONS(3383),
    [anon_sym_in] = ACTIONS(3383),
    [anon_sym_out] = ACTIONS(3383),
    [anon_sym_inout] = ACTIONS(3383),
    [anon_sym_virtual] = ACTIONS(3383),
    [anon_sym_extern] = ACTIONS(3383),
    [anon_sym___attribute__] = ACTIONS(3383),
    [anon_sym___attribute] = ACTIONS(3383),
    [anon_sym_using] = ACTIONS(3383),
    [anon_sym_COLON_COLON] = ACTIONS(3385),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3385),
    [anon_sym___declspec] = ACTIONS(3383),
    [anon_sym___based] = ACTIONS(3383),
    [anon_sym___cdecl] = ACTIONS(3383),
    [anon_sym___clrcall] = ACTIONS(3383),
    [anon_sym___stdcall] = ACTIONS(3383),
    [anon_sym___fastcall] = ACTIONS(3383),
    [anon_sym___thiscall] = ACTIONS(3383),
    [anon_sym___vectorcall] = ACTIONS(3383),
    [anon_sym_LBRACE] = ACTIONS(3385),
    [anon_sym_RBRACE] = ACTIONS(3385),
    [anon_sym_signed] = ACTIONS(3383),
    [anon_sym_unsigned] = ACTIONS(3383),
    [anon_sym_long] = ACTIONS(3383),
    [anon_sym_short] = ACTIONS(3383),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_static] = ACTIONS(3383),
    [anon_sym_register] = ACTIONS(3383),
    [anon_sym_inline] = ACTIONS(3383),
    [anon_sym___inline] = ACTIONS(3383),
    [anon_sym___inline__] = ACTIONS(3383),
    [anon_sym___forceinline] = ACTIONS(3383),
    [anon_sym_thread_local] = ACTIONS(3383),
    [anon_sym___thread] = ACTIONS(3383),
    [anon_sym_const] = ACTIONS(3383),
    [anon_sym_constexpr] = ACTIONS(3383),
    [anon_sym_volatile] = ACTIONS(3383),
    [anon_sym_restrict] = ACTIONS(3383),
    [anon_sym___restrict__] = ACTIONS(3383),
    [anon_sym__Atomic] = ACTIONS(3383),
    [anon_sym__Noreturn] = ACTIONS(3383),
    [anon_sym_noreturn] = ACTIONS(3383),
    [anon_sym__Nonnull] = ACTIONS(3383),
    [anon_sym_mutable] = ACTIONS(3383),
    [anon_sym_constinit] = ACTIONS(3383),
    [anon_sym_consteval] = ACTIONS(3383),
    [anon_sym_alignas] = ACTIONS(3383),
    [anon_sym__Alignas] = ACTIONS(3383),
    [sym_primitive_type] = ACTIONS(3383),
    [anon_sym_enum] = ACTIONS(3383),
    [anon_sym_class] = ACTIONS(3383),
    [anon_sym_struct] = ACTIONS(3383),
    [anon_sym_union] = ACTIONS(3383),
    [anon_sym_if] = ACTIONS(3383),
    [anon_sym_else] = ACTIONS(3383),
    [anon_sym_switch] = ACTIONS(3383),
    [anon_sym_case] = ACTIONS(3383),
    [anon_sym_default] = ACTIONS(3383),
    [anon_sym_while] = ACTIONS(3383),
    [anon_sym_do] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3383),
    [anon_sym_return] = ACTIONS(3383),
    [anon_sym_break] = ACTIONS(3383),
    [anon_sym_continue] = ACTIONS(3383),
    [anon_sym_goto] = ACTIONS(3383),
    [anon_sym___try] = ACTIONS(3383),
    [anon_sym___leave] = ACTIONS(3383),
    [anon_sym_not] = ACTIONS(3383),
    [anon_sym_compl] = ACTIONS(3383),
    [anon_sym_DASH_DASH] = ACTIONS(3385),
    [anon_sym_PLUS_PLUS] = ACTIONS(3385),
    [anon_sym_sizeof] = ACTIONS(3383),
    [anon_sym___alignof__] = ACTIONS(3383),
    [anon_sym___alignof] = ACTIONS(3383),
    [anon_sym__alignof] = ACTIONS(3383),
    [anon_sym_alignof] = ACTIONS(3383),
    [anon_sym__Alignof] = ACTIONS(3383),
    [anon_sym_offsetof] = ACTIONS(3383),
    [anon_sym__Generic] = ACTIONS(3383),
    [anon_sym_asm] = ACTIONS(3383),
    [anon_sym___asm__] = ACTIONS(3383),
    [anon_sym___asm] = ACTIONS(3383),
    [sym_number_literal] = ACTIONS(3385),
    [anon_sym_L_SQUOTE] = ACTIONS(3385),
    [anon_sym_u_SQUOTE] = ACTIONS(3385),
    [anon_sym_U_SQUOTE] = ACTIONS(3385),
    [anon_sym_u8_SQUOTE] = ACTIONS(3385),
    [anon_sym_SQUOTE] = ACTIONS(3385),
    [anon_sym_L_DQUOTE] = ACTIONS(3385),
    [anon_sym_u_DQUOTE] = ACTIONS(3385),
    [anon_sym_U_DQUOTE] = ACTIONS(3385),
    [anon_sym_u8_DQUOTE] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(3385),
    [sym_true] = ACTIONS(3383),
    [sym_false] = ACTIONS(3383),
    [anon_sym_NULL] = ACTIONS(3383),
    [anon_sym_nullptr] = ACTIONS(3383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3383),
    [anon_sym_let] = ACTIONS(3383),
    [anon_sym_This] = ACTIONS(3383),
    [anon_sym_decltype] = ACTIONS(3383),
    [anon_sym_explicit] = ACTIONS(3383),
    [anon_sym_typename] = ACTIONS(3383),
    [anon_sym_template] = ACTIONS(3383),
    [anon_sym_operator] = ACTIONS(3383),
    [anon_sym_try] = ACTIONS(3383),
    [anon_sym_delete] = ACTIONS(3383),
    [anon_sym_throw] = ACTIONS(3383),
    [anon_sym_namespace] = ACTIONS(3383),
    [anon_sym_static_assert] = ACTIONS(3383),
    [anon_sym_concept] = ACTIONS(3383),
    [anon_sym_co_return] = ACTIONS(3383),
    [anon_sym_co_yield] = ACTIONS(3383),
    [anon_sym_R_DQUOTE] = ACTIONS(3385),
    [anon_sym_LR_DQUOTE] = ACTIONS(3385),
    [anon_sym_uR_DQUOTE] = ACTIONS(3385),
    [anon_sym_UR_DQUOTE] = ACTIONS(3385),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3385),
    [anon_sym_co_await] = ACTIONS(3383),
    [anon_sym_new] = ACTIONS(3383),
    [anon_sym_requires] = ACTIONS(3383),
    [sym_this] = ACTIONS(3383),
    [anon_sym_discard] = ACTIONS(3383),
    [anon_sym_precise] = ACTIONS(3383),
    [anon_sym_shared] = ACTIONS(3383),
    [anon_sym_groupshared] = ACTIONS(3383),
    [anon_sym_uniform] = ACTIONS(3383),
    [anon_sym_row_major] = ACTIONS(3383),
    [anon_sym_column_major] = ACTIONS(3383),
    [anon_sym_globallycoherent] = ACTIONS(3383),
    [anon_sym_centroid] = ACTIONS(3383),
    [anon_sym_noperspective] = ACTIONS(3383),
    [anon_sym_nointerpolation] = ACTIONS(3383),
    [anon_sym_sample] = ACTIONS(3383),
    [anon_sym_linear] = ACTIONS(3383),
    [anon_sym_snorm] = ACTIONS(3383),
    [anon_sym_unorm] = ACTIONS(3383),
    [anon_sym_point] = ACTIONS(3383),
    [anon_sym_line] = ACTIONS(3383),
    [anon_sym_triangleadj] = ACTIONS(3383),
    [anon_sym_lineadj] = ACTIONS(3383),
    [anon_sym_triangle] = ACTIONS(3383),
    [anon_sym_cbuffer] = ACTIONS(3383),
    [anon_sym_interface] = ACTIONS(3383),
    [anon_sym_extension] = ACTIONS(3383),
  },
  [838] = {
    [sym_identifier] = ACTIONS(3387),
    [aux_sym_preproc_include_token1] = ACTIONS(3387),
    [aux_sym_preproc_def_token1] = ACTIONS(3387),
    [aux_sym_preproc_if_token1] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3387),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3387),
    [sym_preproc_directive] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_BANG] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_STAR] = ACTIONS(3389),
    [anon_sym_AMP_AMP] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_SEMI] = ACTIONS(3389),
    [anon_sym___extension__] = ACTIONS(3387),
    [anon_sym_typedef] = ACTIONS(3387),
    [anon_sym_in] = ACTIONS(3387),
    [anon_sym_out] = ACTIONS(3387),
    [anon_sym_inout] = ACTIONS(3387),
    [anon_sym_virtual] = ACTIONS(3387),
    [anon_sym_extern] = ACTIONS(3387),
    [anon_sym___attribute__] = ACTIONS(3387),
    [anon_sym___attribute] = ACTIONS(3387),
    [anon_sym_using] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3389),
    [anon_sym___declspec] = ACTIONS(3387),
    [anon_sym___based] = ACTIONS(3387),
    [anon_sym___cdecl] = ACTIONS(3387),
    [anon_sym___clrcall] = ACTIONS(3387),
    [anon_sym___stdcall] = ACTIONS(3387),
    [anon_sym___fastcall] = ACTIONS(3387),
    [anon_sym___thiscall] = ACTIONS(3387),
    [anon_sym___vectorcall] = ACTIONS(3387),
    [anon_sym_LBRACE] = ACTIONS(3389),
    [anon_sym_RBRACE] = ACTIONS(3389),
    [anon_sym_signed] = ACTIONS(3387),
    [anon_sym_unsigned] = ACTIONS(3387),
    [anon_sym_long] = ACTIONS(3387),
    [anon_sym_short] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_register] = ACTIONS(3387),
    [anon_sym_inline] = ACTIONS(3387),
    [anon_sym___inline] = ACTIONS(3387),
    [anon_sym___inline__] = ACTIONS(3387),
    [anon_sym___forceinline] = ACTIONS(3387),
    [anon_sym_thread_local] = ACTIONS(3387),
    [anon_sym___thread] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_constexpr] = ACTIONS(3387),
    [anon_sym_volatile] = ACTIONS(3387),
    [anon_sym_restrict] = ACTIONS(3387),
    [anon_sym___restrict__] = ACTIONS(3387),
    [anon_sym__Atomic] = ACTIONS(3387),
    [anon_sym__Noreturn] = ACTIONS(3387),
    [anon_sym_noreturn] = ACTIONS(3387),
    [anon_sym__Nonnull] = ACTIONS(3387),
    [anon_sym_mutable] = ACTIONS(3387),
    [anon_sym_constinit] = ACTIONS(3387),
    [anon_sym_consteval] = ACTIONS(3387),
    [anon_sym_alignas] = ACTIONS(3387),
    [anon_sym__Alignas] = ACTIONS(3387),
    [sym_primitive_type] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [anon_sym_class] = ACTIONS(3387),
    [anon_sym_struct] = ACTIONS(3387),
    [anon_sym_union] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_else] = ACTIONS(3387),
    [anon_sym_switch] = ACTIONS(3387),
    [anon_sym_case] = ACTIONS(3387),
    [anon_sym_default] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_break] = ACTIONS(3387),
    [anon_sym_continue] = ACTIONS(3387),
    [anon_sym_goto] = ACTIONS(3387),
    [anon_sym___try] = ACTIONS(3387),
    [anon_sym___leave] = ACTIONS(3387),
    [anon_sym_not] = ACTIONS(3387),
    [anon_sym_compl] = ACTIONS(3387),
    [anon_sym_DASH_DASH] = ACTIONS(3389),
    [anon_sym_PLUS_PLUS] = ACTIONS(3389),
    [anon_sym_sizeof] = ACTIONS(3387),
    [anon_sym___alignof__] = ACTIONS(3387),
    [anon_sym___alignof] = ACTIONS(3387),
    [anon_sym__alignof] = ACTIONS(3387),
    [anon_sym_alignof] = ACTIONS(3387),
    [anon_sym__Alignof] = ACTIONS(3387),
    [anon_sym_offsetof] = ACTIONS(3387),
    [anon_sym__Generic] = ACTIONS(3387),
    [anon_sym_asm] = ACTIONS(3387),
    [anon_sym___asm__] = ACTIONS(3387),
    [anon_sym___asm] = ACTIONS(3387),
    [sym_number_literal] = ACTIONS(3389),
    [anon_sym_L_SQUOTE] = ACTIONS(3389),
    [anon_sym_u_SQUOTE] = ACTIONS(3389),
    [anon_sym_U_SQUOTE] = ACTIONS(3389),
    [anon_sym_u8_SQUOTE] = ACTIONS(3389),
    [anon_sym_SQUOTE] = ACTIONS(3389),
    [anon_sym_L_DQUOTE] = ACTIONS(3389),
    [anon_sym_u_DQUOTE] = ACTIONS(3389),
    [anon_sym_U_DQUOTE] = ACTIONS(3389),
    [anon_sym_u8_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE] = ACTIONS(3389),
    [sym_true] = ACTIONS(3387),
    [sym_false] = ACTIONS(3387),
    [anon_sym_NULL] = ACTIONS(3387),
    [anon_sym_nullptr] = ACTIONS(3387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_This] = ACTIONS(3387),
    [anon_sym_decltype] = ACTIONS(3387),
    [anon_sym_explicit] = ACTIONS(3387),
    [anon_sym_typename] = ACTIONS(3387),
    [anon_sym_template] = ACTIONS(3387),
    [anon_sym_operator] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_delete] = ACTIONS(3387),
    [anon_sym_throw] = ACTIONS(3387),
    [anon_sym_namespace] = ACTIONS(3387),
    [anon_sym_static_assert] = ACTIONS(3387),
    [anon_sym_concept] = ACTIONS(3387),
    [anon_sym_co_return] = ACTIONS(3387),
    [anon_sym_co_yield] = ACTIONS(3387),
    [anon_sym_R_DQUOTE] = ACTIONS(3389),
    [anon_sym_LR_DQUOTE] = ACTIONS(3389),
    [anon_sym_uR_DQUOTE] = ACTIONS(3389),
    [anon_sym_UR_DQUOTE] = ACTIONS(3389),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3389),
    [anon_sym_co_await] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_requires] = ACTIONS(3387),
    [sym_this] = ACTIONS(3387),
    [anon_sym_discard] = ACTIONS(3387),
    [anon_sym_precise] = ACTIONS(3387),
    [anon_sym_shared] = ACTIONS(3387),
    [anon_sym_groupshared] = ACTIONS(3387),
    [anon_sym_uniform] = ACTIONS(3387),
    [anon_sym_row_major] = ACTIONS(3387),
    [anon_sym_column_major] = ACTIONS(3387),
    [anon_sym_globallycoherent] = ACTIONS(3387),
    [anon_sym_centroid] = ACTIONS(3387),
    [anon_sym_noperspective] = ACTIONS(3387),
    [anon_sym_nointerpolation] = ACTIONS(3387),
    [anon_sym_sample] = ACTIONS(3387),
    [anon_sym_linear] = ACTIONS(3387),
    [anon_sym_snorm] = ACTIONS(3387),
    [anon_sym_unorm] = ACTIONS(3387),
    [anon_sym_point] = ACTIONS(3387),
    [anon_sym_line] = ACTIONS(3387),
    [anon_sym_triangleadj] = ACTIONS(3387),
    [anon_sym_lineadj] = ACTIONS(3387),
    [anon_sym_triangle] = ACTIONS(3387),
    [anon_sym_cbuffer] = ACTIONS(3387),
    [anon_sym_interface] = ACTIONS(3387),
    [anon_sym_extension] = ACTIONS(3387),
  },
  [839] = {
    [sym_identifier] = ACTIONS(3391),
    [aux_sym_preproc_include_token1] = ACTIONS(3391),
    [aux_sym_preproc_def_token1] = ACTIONS(3391),
    [aux_sym_preproc_if_token1] = ACTIONS(3391),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3391),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3391),
    [sym_preproc_directive] = ACTIONS(3391),
    [anon_sym_LPAREN2] = ACTIONS(3393),
    [anon_sym_BANG] = ACTIONS(3393),
    [anon_sym_TILDE] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_STAR] = ACTIONS(3393),
    [anon_sym_AMP_AMP] = ACTIONS(3393),
    [anon_sym_AMP] = ACTIONS(3391),
    [anon_sym_SEMI] = ACTIONS(3393),
    [anon_sym___extension__] = ACTIONS(3391),
    [anon_sym_typedef] = ACTIONS(3391),
    [anon_sym_in] = ACTIONS(3391),
    [anon_sym_out] = ACTIONS(3391),
    [anon_sym_inout] = ACTIONS(3391),
    [anon_sym_virtual] = ACTIONS(3391),
    [anon_sym_extern] = ACTIONS(3391),
    [anon_sym___attribute__] = ACTIONS(3391),
    [anon_sym___attribute] = ACTIONS(3391),
    [anon_sym_using] = ACTIONS(3391),
    [anon_sym_COLON_COLON] = ACTIONS(3393),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3393),
    [anon_sym___declspec] = ACTIONS(3391),
    [anon_sym___based] = ACTIONS(3391),
    [anon_sym___cdecl] = ACTIONS(3391),
    [anon_sym___clrcall] = ACTIONS(3391),
    [anon_sym___stdcall] = ACTIONS(3391),
    [anon_sym___fastcall] = ACTIONS(3391),
    [anon_sym___thiscall] = ACTIONS(3391),
    [anon_sym___vectorcall] = ACTIONS(3391),
    [anon_sym_LBRACE] = ACTIONS(3393),
    [anon_sym_RBRACE] = ACTIONS(3393),
    [anon_sym_signed] = ACTIONS(3391),
    [anon_sym_unsigned] = ACTIONS(3391),
    [anon_sym_long] = ACTIONS(3391),
    [anon_sym_short] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(3391),
    [anon_sym_static] = ACTIONS(3391),
    [anon_sym_register] = ACTIONS(3391),
    [anon_sym_inline] = ACTIONS(3391),
    [anon_sym___inline] = ACTIONS(3391),
    [anon_sym___inline__] = ACTIONS(3391),
    [anon_sym___forceinline] = ACTIONS(3391),
    [anon_sym_thread_local] = ACTIONS(3391),
    [anon_sym___thread] = ACTIONS(3391),
    [anon_sym_const] = ACTIONS(3391),
    [anon_sym_constexpr] = ACTIONS(3391),
    [anon_sym_volatile] = ACTIONS(3391),
    [anon_sym_restrict] = ACTIONS(3391),
    [anon_sym___restrict__] = ACTIONS(3391),
    [anon_sym__Atomic] = ACTIONS(3391),
    [anon_sym__Noreturn] = ACTIONS(3391),
    [anon_sym_noreturn] = ACTIONS(3391),
    [anon_sym__Nonnull] = ACTIONS(3391),
    [anon_sym_mutable] = ACTIONS(3391),
    [anon_sym_constinit] = ACTIONS(3391),
    [anon_sym_consteval] = ACTIONS(3391),
    [anon_sym_alignas] = ACTIONS(3391),
    [anon_sym__Alignas] = ACTIONS(3391),
    [sym_primitive_type] = ACTIONS(3391),
    [anon_sym_enum] = ACTIONS(3391),
    [anon_sym_class] = ACTIONS(3391),
    [anon_sym_struct] = ACTIONS(3391),
    [anon_sym_union] = ACTIONS(3391),
    [anon_sym_if] = ACTIONS(3391),
    [anon_sym_else] = ACTIONS(3391),
    [anon_sym_switch] = ACTIONS(3391),
    [anon_sym_case] = ACTIONS(3391),
    [anon_sym_default] = ACTIONS(3391),
    [anon_sym_while] = ACTIONS(3391),
    [anon_sym_do] = ACTIONS(3391),
    [anon_sym_for] = ACTIONS(3391),
    [anon_sym_return] = ACTIONS(3391),
    [anon_sym_break] = ACTIONS(3391),
    [anon_sym_continue] = ACTIONS(3391),
    [anon_sym_goto] = ACTIONS(3391),
    [anon_sym___try] = ACTIONS(3391),
    [anon_sym___leave] = ACTIONS(3391),
    [anon_sym_not] = ACTIONS(3391),
    [anon_sym_compl] = ACTIONS(3391),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_sizeof] = ACTIONS(3391),
    [anon_sym___alignof__] = ACTIONS(3391),
    [anon_sym___alignof] = ACTIONS(3391),
    [anon_sym__alignof] = ACTIONS(3391),
    [anon_sym_alignof] = ACTIONS(3391),
    [anon_sym__Alignof] = ACTIONS(3391),
    [anon_sym_offsetof] = ACTIONS(3391),
    [anon_sym__Generic] = ACTIONS(3391),
    [anon_sym_asm] = ACTIONS(3391),
    [anon_sym___asm__] = ACTIONS(3391),
    [anon_sym___asm] = ACTIONS(3391),
    [sym_number_literal] = ACTIONS(3393),
    [anon_sym_L_SQUOTE] = ACTIONS(3393),
    [anon_sym_u_SQUOTE] = ACTIONS(3393),
    [anon_sym_U_SQUOTE] = ACTIONS(3393),
    [anon_sym_u8_SQUOTE] = ACTIONS(3393),
    [anon_sym_SQUOTE] = ACTIONS(3393),
    [anon_sym_L_DQUOTE] = ACTIONS(3393),
    [anon_sym_u_DQUOTE] = ACTIONS(3393),
    [anon_sym_U_DQUOTE] = ACTIONS(3393),
    [anon_sym_u8_DQUOTE] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3393),
    [sym_true] = ACTIONS(3391),
    [sym_false] = ACTIONS(3391),
    [anon_sym_NULL] = ACTIONS(3391),
    [anon_sym_nullptr] = ACTIONS(3391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3391),
    [anon_sym_let] = ACTIONS(3391),
    [anon_sym_This] = ACTIONS(3391),
    [anon_sym_decltype] = ACTIONS(3391),
    [anon_sym_explicit] = ACTIONS(3391),
    [anon_sym_typename] = ACTIONS(3391),
    [anon_sym_template] = ACTIONS(3391),
    [anon_sym_operator] = ACTIONS(3391),
    [anon_sym_try] = ACTIONS(3391),
    [anon_sym_delete] = ACTIONS(3391),
    [anon_sym_throw] = ACTIONS(3391),
    [anon_sym_namespace] = ACTIONS(3391),
    [anon_sym_static_assert] = ACTIONS(3391),
    [anon_sym_concept] = ACTIONS(3391),
    [anon_sym_co_return] = ACTIONS(3391),
    [anon_sym_co_yield] = ACTIONS(3391),
    [anon_sym_R_DQUOTE] = ACTIONS(3393),
    [anon_sym_LR_DQUOTE] = ACTIONS(3393),
    [anon_sym_uR_DQUOTE] = ACTIONS(3393),
    [anon_sym_UR_DQUOTE] = ACTIONS(3393),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3393),
    [anon_sym_co_await] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(3391),
    [anon_sym_requires] = ACTIONS(3391),
    [sym_this] = ACTIONS(3391),
    [anon_sym_discard] = ACTIONS(3391),
    [anon_sym_precise] = ACTIONS(3391),
    [anon_sym_shared] = ACTIONS(3391),
    [anon_sym_groupshared] = ACTIONS(3391),
    [anon_sym_uniform] = ACTIONS(3391),
    [anon_sym_row_major] = ACTIONS(3391),
    [anon_sym_column_major] = ACTIONS(3391),
    [anon_sym_globallycoherent] = ACTIONS(3391),
    [anon_sym_centroid] = ACTIONS(3391),
    [anon_sym_noperspective] = ACTIONS(3391),
    [anon_sym_nointerpolation] = ACTIONS(3391),
    [anon_sym_sample] = ACTIONS(3391),
    [anon_sym_linear] = ACTIONS(3391),
    [anon_sym_snorm] = ACTIONS(3391),
    [anon_sym_unorm] = ACTIONS(3391),
    [anon_sym_point] = ACTIONS(3391),
    [anon_sym_line] = ACTIONS(3391),
    [anon_sym_triangleadj] = ACTIONS(3391),
    [anon_sym_lineadj] = ACTIONS(3391),
    [anon_sym_triangle] = ACTIONS(3391),
    [anon_sym_cbuffer] = ACTIONS(3391),
    [anon_sym_interface] = ACTIONS(3391),
    [anon_sym_extension] = ACTIONS(3391),
  },
  [840] = {
    [sym_identifier] = ACTIONS(3395),
    [aux_sym_preproc_include_token1] = ACTIONS(3395),
    [aux_sym_preproc_def_token1] = ACTIONS(3395),
    [aux_sym_preproc_if_token1] = ACTIONS(3395),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3395),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3395),
    [sym_preproc_directive] = ACTIONS(3395),
    [anon_sym_LPAREN2] = ACTIONS(3397),
    [anon_sym_BANG] = ACTIONS(3397),
    [anon_sym_TILDE] = ACTIONS(3397),
    [anon_sym_DASH] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3395),
    [anon_sym_STAR] = ACTIONS(3397),
    [anon_sym_AMP_AMP] = ACTIONS(3397),
    [anon_sym_AMP] = ACTIONS(3395),
    [anon_sym_SEMI] = ACTIONS(3397),
    [anon_sym___extension__] = ACTIONS(3395),
    [anon_sym_typedef] = ACTIONS(3395),
    [anon_sym_in] = ACTIONS(3395),
    [anon_sym_out] = ACTIONS(3395),
    [anon_sym_inout] = ACTIONS(3395),
    [anon_sym_virtual] = ACTIONS(3395),
    [anon_sym_extern] = ACTIONS(3395),
    [anon_sym___attribute__] = ACTIONS(3395),
    [anon_sym___attribute] = ACTIONS(3395),
    [anon_sym_using] = ACTIONS(3395),
    [anon_sym_COLON_COLON] = ACTIONS(3397),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3397),
    [anon_sym___declspec] = ACTIONS(3395),
    [anon_sym___based] = ACTIONS(3395),
    [anon_sym___cdecl] = ACTIONS(3395),
    [anon_sym___clrcall] = ACTIONS(3395),
    [anon_sym___stdcall] = ACTIONS(3395),
    [anon_sym___fastcall] = ACTIONS(3395),
    [anon_sym___thiscall] = ACTIONS(3395),
    [anon_sym___vectorcall] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3397),
    [anon_sym_RBRACE] = ACTIONS(3397),
    [anon_sym_signed] = ACTIONS(3395),
    [anon_sym_unsigned] = ACTIONS(3395),
    [anon_sym_long] = ACTIONS(3395),
    [anon_sym_short] = ACTIONS(3395),
    [anon_sym_LBRACK] = ACTIONS(3395),
    [anon_sym_static] = ACTIONS(3395),
    [anon_sym_register] = ACTIONS(3395),
    [anon_sym_inline] = ACTIONS(3395),
    [anon_sym___inline] = ACTIONS(3395),
    [anon_sym___inline__] = ACTIONS(3395),
    [anon_sym___forceinline] = ACTIONS(3395),
    [anon_sym_thread_local] = ACTIONS(3395),
    [anon_sym___thread] = ACTIONS(3395),
    [anon_sym_const] = ACTIONS(3395),
    [anon_sym_constexpr] = ACTIONS(3395),
    [anon_sym_volatile] = ACTIONS(3395),
    [anon_sym_restrict] = ACTIONS(3395),
    [anon_sym___restrict__] = ACTIONS(3395),
    [anon_sym__Atomic] = ACTIONS(3395),
    [anon_sym__Noreturn] = ACTIONS(3395),
    [anon_sym_noreturn] = ACTIONS(3395),
    [anon_sym__Nonnull] = ACTIONS(3395),
    [anon_sym_mutable] = ACTIONS(3395),
    [anon_sym_constinit] = ACTIONS(3395),
    [anon_sym_consteval] = ACTIONS(3395),
    [anon_sym_alignas] = ACTIONS(3395),
    [anon_sym__Alignas] = ACTIONS(3395),
    [sym_primitive_type] = ACTIONS(3395),
    [anon_sym_enum] = ACTIONS(3395),
    [anon_sym_class] = ACTIONS(3395),
    [anon_sym_struct] = ACTIONS(3395),
    [anon_sym_union] = ACTIONS(3395),
    [anon_sym_if] = ACTIONS(3395),
    [anon_sym_else] = ACTIONS(3395),
    [anon_sym_switch] = ACTIONS(3395),
    [anon_sym_case] = ACTIONS(3395),
    [anon_sym_default] = ACTIONS(3395),
    [anon_sym_while] = ACTIONS(3395),
    [anon_sym_do] = ACTIONS(3395),
    [anon_sym_for] = ACTIONS(3395),
    [anon_sym_return] = ACTIONS(3395),
    [anon_sym_break] = ACTIONS(3395),
    [anon_sym_continue] = ACTIONS(3395),
    [anon_sym_goto] = ACTIONS(3395),
    [anon_sym___try] = ACTIONS(3395),
    [anon_sym___leave] = ACTIONS(3395),
    [anon_sym_not] = ACTIONS(3395),
    [anon_sym_compl] = ACTIONS(3395),
    [anon_sym_DASH_DASH] = ACTIONS(3397),
    [anon_sym_PLUS_PLUS] = ACTIONS(3397),
    [anon_sym_sizeof] = ACTIONS(3395),
    [anon_sym___alignof__] = ACTIONS(3395),
    [anon_sym___alignof] = ACTIONS(3395),
    [anon_sym__alignof] = ACTIONS(3395),
    [anon_sym_alignof] = ACTIONS(3395),
    [anon_sym__Alignof] = ACTIONS(3395),
    [anon_sym_offsetof] = ACTIONS(3395),
    [anon_sym__Generic] = ACTIONS(3395),
    [anon_sym_asm] = ACTIONS(3395),
    [anon_sym___asm__] = ACTIONS(3395),
    [anon_sym___asm] = ACTIONS(3395),
    [sym_number_literal] = ACTIONS(3397),
    [anon_sym_L_SQUOTE] = ACTIONS(3397),
    [anon_sym_u_SQUOTE] = ACTIONS(3397),
    [anon_sym_U_SQUOTE] = ACTIONS(3397),
    [anon_sym_u8_SQUOTE] = ACTIONS(3397),
    [anon_sym_SQUOTE] = ACTIONS(3397),
    [anon_sym_L_DQUOTE] = ACTIONS(3397),
    [anon_sym_u_DQUOTE] = ACTIONS(3397),
    [anon_sym_U_DQUOTE] = ACTIONS(3397),
    [anon_sym_u8_DQUOTE] = ACTIONS(3397),
    [anon_sym_DQUOTE] = ACTIONS(3397),
    [sym_true] = ACTIONS(3395),
    [sym_false] = ACTIONS(3395),
    [anon_sym_NULL] = ACTIONS(3395),
    [anon_sym_nullptr] = ACTIONS(3395),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3395),
    [anon_sym_let] = ACTIONS(3395),
    [anon_sym_This] = ACTIONS(3395),
    [anon_sym_decltype] = ACTIONS(3395),
    [anon_sym_explicit] = ACTIONS(3395),
    [anon_sym_typename] = ACTIONS(3395),
    [anon_sym_template] = ACTIONS(3395),
    [anon_sym_operator] = ACTIONS(3395),
    [anon_sym_try] = ACTIONS(3395),
    [anon_sym_delete] = ACTIONS(3395),
    [anon_sym_throw] = ACTIONS(3395),
    [anon_sym_namespace] = ACTIONS(3395),
    [anon_sym_static_assert] = ACTIONS(3395),
    [anon_sym_concept] = ACTIONS(3395),
    [anon_sym_co_return] = ACTIONS(3395),
    [anon_sym_co_yield] = ACTIONS(3395),
    [anon_sym_R_DQUOTE] = ACTIONS(3397),
    [anon_sym_LR_DQUOTE] = ACTIONS(3397),
    [anon_sym_uR_DQUOTE] = ACTIONS(3397),
    [anon_sym_UR_DQUOTE] = ACTIONS(3397),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3397),
    [anon_sym_co_await] = ACTIONS(3395),
    [anon_sym_new] = ACTIONS(3395),
    [anon_sym_requires] = ACTIONS(3395),
    [sym_this] = ACTIONS(3395),
    [anon_sym_discard] = ACTIONS(3395),
    [anon_sym_precise] = ACTIONS(3395),
    [anon_sym_shared] = ACTIONS(3395),
    [anon_sym_groupshared] = ACTIONS(3395),
    [anon_sym_uniform] = ACTIONS(3395),
    [anon_sym_row_major] = ACTIONS(3395),
    [anon_sym_column_major] = ACTIONS(3395),
    [anon_sym_globallycoherent] = ACTIONS(3395),
    [anon_sym_centroid] = ACTIONS(3395),
    [anon_sym_noperspective] = ACTIONS(3395),
    [anon_sym_nointerpolation] = ACTIONS(3395),
    [anon_sym_sample] = ACTIONS(3395),
    [anon_sym_linear] = ACTIONS(3395),
    [anon_sym_snorm] = ACTIONS(3395),
    [anon_sym_unorm] = ACTIONS(3395),
    [anon_sym_point] = ACTIONS(3395),
    [anon_sym_line] = ACTIONS(3395),
    [anon_sym_triangleadj] = ACTIONS(3395),
    [anon_sym_lineadj] = ACTIONS(3395),
    [anon_sym_triangle] = ACTIONS(3395),
    [anon_sym_cbuffer] = ACTIONS(3395),
    [anon_sym_interface] = ACTIONS(3395),
    [anon_sym_extension] = ACTIONS(3395),
  },
  [841] = {
    [ts_builtin_sym_end] = ACTIONS(2881),
    [sym_identifier] = ACTIONS(2883),
    [aux_sym_preproc_include_token1] = ACTIONS(2883),
    [aux_sym_preproc_def_token1] = ACTIONS(2883),
    [aux_sym_preproc_if_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2883),
    [sym_preproc_directive] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_typedef] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_using] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2881),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(4256),
    [anon_sym_signed] = ACTIONS(2883),
    [anon_sym_unsigned] = ACTIONS(2883),
    [anon_sym_long] = ACTIONS(2883),
    [anon_sym_short] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [sym_primitive_type] = ACTIONS(2883),
    [anon_sym_enum] = ACTIONS(2883),
    [anon_sym_class] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2883),
    [anon_sym_union] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_switch] = ACTIONS(2883),
    [anon_sym_case] = ACTIONS(2883),
    [anon_sym_default] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_break] = ACTIONS(2883),
    [anon_sym_continue] = ACTIONS(2883),
    [anon_sym_goto] = ACTIONS(2883),
    [anon_sym_not] = ACTIONS(2883),
    [anon_sym_compl] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_sizeof] = ACTIONS(2883),
    [anon_sym___alignof__] = ACTIONS(2883),
    [anon_sym___alignof] = ACTIONS(2883),
    [anon_sym__alignof] = ACTIONS(2883),
    [anon_sym_alignof] = ACTIONS(2883),
    [anon_sym__Alignof] = ACTIONS(2883),
    [anon_sym_offsetof] = ACTIONS(2883),
    [anon_sym__Generic] = ACTIONS(2883),
    [anon_sym_asm] = ACTIONS(2883),
    [anon_sym___asm__] = ACTIONS(2883),
    [anon_sym___asm] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [sym_number_literal] = ACTIONS(2881),
    [anon_sym_L_SQUOTE] = ACTIONS(2881),
    [anon_sym_u_SQUOTE] = ACTIONS(2881),
    [anon_sym_U_SQUOTE] = ACTIONS(2881),
    [anon_sym_u8_SQUOTE] = ACTIONS(2881),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_L_DQUOTE] = ACTIONS(2881),
    [anon_sym_u_DQUOTE] = ACTIONS(2881),
    [anon_sym_U_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [sym_true] = ACTIONS(2883),
    [sym_false] = ACTIONS(2883),
    [anon_sym_NULL] = ACTIONS(2883),
    [anon_sym_nullptr] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_explicit] = ACTIONS(2883),
    [anon_sym_typename] = ACTIONS(2883),
    [anon_sym_export] = ACTIONS(2883),
    [anon_sym_module] = ACTIONS(2883),
    [anon_sym_import] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_delete] = ACTIONS(2883),
    [anon_sym_throw] = ACTIONS(2883),
    [anon_sym_namespace] = ACTIONS(2883),
    [anon_sym_static_assert] = ACTIONS(2883),
    [anon_sym_concept] = ACTIONS(2883),
    [anon_sym_co_return] = ACTIONS(2883),
    [anon_sym_co_yield] = ACTIONS(2883),
    [anon_sym_R_DQUOTE] = ACTIONS(2881),
    [anon_sym_LR_DQUOTE] = ACTIONS(2881),
    [anon_sym_uR_DQUOTE] = ACTIONS(2881),
    [anon_sym_UR_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2881),
    [anon_sym_co_await] = ACTIONS(2883),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_requires] = ACTIONS(2883),
    [sym_this] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
    [anon_sym_interface] = ACTIONS(2883),
    [anon_sym_extension] = ACTIONS(2883),
    [anon_sym___exported] = ACTIONS(2883),
  },
  [842] = {
    [sym_identifier] = ACTIONS(3635),
    [aux_sym_preproc_include_token1] = ACTIONS(3635),
    [aux_sym_preproc_def_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3635),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3635),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3635),
    [sym_preproc_directive] = ACTIONS(3635),
    [anon_sym_LPAREN2] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_TILDE] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3635),
    [anon_sym_PLUS] = ACTIONS(3635),
    [anon_sym_STAR] = ACTIONS(3633),
    [anon_sym_AMP_AMP] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_SEMI] = ACTIONS(3633),
    [anon_sym___extension__] = ACTIONS(3635),
    [anon_sym_typedef] = ACTIONS(3635),
    [anon_sym_in] = ACTIONS(3635),
    [anon_sym_out] = ACTIONS(3635),
    [anon_sym_inout] = ACTIONS(3635),
    [anon_sym_virtual] = ACTIONS(3635),
    [anon_sym_extern] = ACTIONS(3635),
    [anon_sym___attribute__] = ACTIONS(3635),
    [anon_sym___attribute] = ACTIONS(3635),
    [anon_sym_using] = ACTIONS(3635),
    [anon_sym_COLON_COLON] = ACTIONS(3633),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3633),
    [anon_sym___declspec] = ACTIONS(3635),
    [anon_sym___based] = ACTIONS(3635),
    [anon_sym___cdecl] = ACTIONS(3635),
    [anon_sym___clrcall] = ACTIONS(3635),
    [anon_sym___stdcall] = ACTIONS(3635),
    [anon_sym___fastcall] = ACTIONS(3635),
    [anon_sym___thiscall] = ACTIONS(3635),
    [anon_sym___vectorcall] = ACTIONS(3635),
    [anon_sym_LBRACE] = ACTIONS(3633),
    [anon_sym_RBRACE] = ACTIONS(3633),
    [anon_sym_signed] = ACTIONS(3635),
    [anon_sym_unsigned] = ACTIONS(3635),
    [anon_sym_long] = ACTIONS(3635),
    [anon_sym_short] = ACTIONS(3635),
    [anon_sym_LBRACK] = ACTIONS(3635),
    [anon_sym_static] = ACTIONS(3635),
    [anon_sym_register] = ACTIONS(3635),
    [anon_sym_inline] = ACTIONS(3635),
    [anon_sym___inline] = ACTIONS(3635),
    [anon_sym___inline__] = ACTIONS(3635),
    [anon_sym___forceinline] = ACTIONS(3635),
    [anon_sym_thread_local] = ACTIONS(3635),
    [anon_sym___thread] = ACTIONS(3635),
    [anon_sym_const] = ACTIONS(3635),
    [anon_sym_constexpr] = ACTIONS(3635),
    [anon_sym_volatile] = ACTIONS(3635),
    [anon_sym_restrict] = ACTIONS(3635),
    [anon_sym___restrict__] = ACTIONS(3635),
    [anon_sym__Atomic] = ACTIONS(3635),
    [anon_sym__Noreturn] = ACTIONS(3635),
    [anon_sym_noreturn] = ACTIONS(3635),
    [anon_sym__Nonnull] = ACTIONS(3635),
    [anon_sym_mutable] = ACTIONS(3635),
    [anon_sym_constinit] = ACTIONS(3635),
    [anon_sym_consteval] = ACTIONS(3635),
    [anon_sym_alignas] = ACTIONS(3635),
    [anon_sym__Alignas] = ACTIONS(3635),
    [sym_primitive_type] = ACTIONS(3635),
    [anon_sym_enum] = ACTIONS(3635),
    [anon_sym_class] = ACTIONS(3635),
    [anon_sym_struct] = ACTIONS(3635),
    [anon_sym_union] = ACTIONS(3635),
    [anon_sym_if] = ACTIONS(3635),
    [anon_sym_else] = ACTIONS(3635),
    [anon_sym_switch] = ACTIONS(3635),
    [anon_sym_case] = ACTIONS(3635),
    [anon_sym_default] = ACTIONS(3635),
    [anon_sym_while] = ACTIONS(3635),
    [anon_sym_do] = ACTIONS(3635),
    [anon_sym_for] = ACTIONS(3635),
    [anon_sym_return] = ACTIONS(3635),
    [anon_sym_break] = ACTIONS(3635),
    [anon_sym_continue] = ACTIONS(3635),
    [anon_sym_goto] = ACTIONS(3635),
    [anon_sym___try] = ACTIONS(3635),
    [anon_sym___leave] = ACTIONS(3635),
    [anon_sym_not] = ACTIONS(3635),
    [anon_sym_compl] = ACTIONS(3635),
    [anon_sym_DASH_DASH] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3633),
    [anon_sym_sizeof] = ACTIONS(3635),
    [anon_sym___alignof__] = ACTIONS(3635),
    [anon_sym___alignof] = ACTIONS(3635),
    [anon_sym__alignof] = ACTIONS(3635),
    [anon_sym_alignof] = ACTIONS(3635),
    [anon_sym__Alignof] = ACTIONS(3635),
    [anon_sym_offsetof] = ACTIONS(3635),
    [anon_sym__Generic] = ACTIONS(3635),
    [anon_sym_asm] = ACTIONS(3635),
    [anon_sym___asm__] = ACTIONS(3635),
    [anon_sym___asm] = ACTIONS(3635),
    [sym_number_literal] = ACTIONS(3633),
    [anon_sym_L_SQUOTE] = ACTIONS(3633),
    [anon_sym_u_SQUOTE] = ACTIONS(3633),
    [anon_sym_U_SQUOTE] = ACTIONS(3633),
    [anon_sym_u8_SQUOTE] = ACTIONS(3633),
    [anon_sym_SQUOTE] = ACTIONS(3633),
    [anon_sym_L_DQUOTE] = ACTIONS(3633),
    [anon_sym_u_DQUOTE] = ACTIONS(3633),
    [anon_sym_U_DQUOTE] = ACTIONS(3633),
    [anon_sym_u8_DQUOTE] = ACTIONS(3633),
    [anon_sym_DQUOTE] = ACTIONS(3633),
    [sym_true] = ACTIONS(3635),
    [sym_false] = ACTIONS(3635),
    [anon_sym_NULL] = ACTIONS(3635),
    [anon_sym_nullptr] = ACTIONS(3635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3635),
    [anon_sym_let] = ACTIONS(3635),
    [anon_sym_This] = ACTIONS(3635),
    [anon_sym_decltype] = ACTIONS(3635),
    [anon_sym_explicit] = ACTIONS(3635),
    [anon_sym_typename] = ACTIONS(3635),
    [anon_sym_template] = ACTIONS(3635),
    [anon_sym_operator] = ACTIONS(3635),
    [anon_sym_try] = ACTIONS(3635),
    [anon_sym_delete] = ACTIONS(3635),
    [anon_sym_throw] = ACTIONS(3635),
    [anon_sym_namespace] = ACTIONS(3635),
    [anon_sym_static_assert] = ACTIONS(3635),
    [anon_sym_concept] = ACTIONS(3635),
    [anon_sym_co_return] = ACTIONS(3635),
    [anon_sym_co_yield] = ACTIONS(3635),
    [anon_sym_R_DQUOTE] = ACTIONS(3633),
    [anon_sym_LR_DQUOTE] = ACTIONS(3633),
    [anon_sym_uR_DQUOTE] = ACTIONS(3633),
    [anon_sym_UR_DQUOTE] = ACTIONS(3633),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3633),
    [anon_sym_co_await] = ACTIONS(3635),
    [anon_sym_new] = ACTIONS(3635),
    [anon_sym_requires] = ACTIONS(3635),
    [sym_this] = ACTIONS(3635),
    [anon_sym_discard] = ACTIONS(3635),
    [anon_sym_precise] = ACTIONS(3635),
    [anon_sym_shared] = ACTIONS(3635),
    [anon_sym_groupshared] = ACTIONS(3635),
    [anon_sym_uniform] = ACTIONS(3635),
    [anon_sym_row_major] = ACTIONS(3635),
    [anon_sym_column_major] = ACTIONS(3635),
    [anon_sym_globallycoherent] = ACTIONS(3635),
    [anon_sym_centroid] = ACTIONS(3635),
    [anon_sym_noperspective] = ACTIONS(3635),
    [anon_sym_nointerpolation] = ACTIONS(3635),
    [anon_sym_sample] = ACTIONS(3635),
    [anon_sym_linear] = ACTIONS(3635),
    [anon_sym_snorm] = ACTIONS(3635),
    [anon_sym_unorm] = ACTIONS(3635),
    [anon_sym_point] = ACTIONS(3635),
    [anon_sym_line] = ACTIONS(3635),
    [anon_sym_triangleadj] = ACTIONS(3635),
    [anon_sym_lineadj] = ACTIONS(3635),
    [anon_sym_triangle] = ACTIONS(3635),
    [anon_sym_cbuffer] = ACTIONS(3635),
    [anon_sym_interface] = ACTIONS(3635),
    [anon_sym_extension] = ACTIONS(3635),
  },
  [843] = {
    [ts_builtin_sym_end] = ACTIONS(4246),
    [sym_identifier] = ACTIONS(4244),
    [aux_sym_preproc_include_token1] = ACTIONS(4244),
    [aux_sym_preproc_def_token1] = ACTIONS(4244),
    [aux_sym_preproc_if_token1] = ACTIONS(4244),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4244),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4244),
    [sym_preproc_directive] = ACTIONS(4244),
    [anon_sym_LPAREN2] = ACTIONS(4246),
    [anon_sym_BANG] = ACTIONS(4246),
    [anon_sym_TILDE] = ACTIONS(4246),
    [anon_sym_DASH] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_STAR] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym___extension__] = ACTIONS(4244),
    [anon_sym_typedef] = ACTIONS(4244),
    [anon_sym_in] = ACTIONS(4244),
    [anon_sym_out] = ACTIONS(4244),
    [anon_sym_inout] = ACTIONS(4244),
    [anon_sym_virtual] = ACTIONS(4244),
    [anon_sym_extern] = ACTIONS(4244),
    [anon_sym___attribute__] = ACTIONS(4244),
    [anon_sym___attribute] = ACTIONS(4244),
    [anon_sym_using] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4246),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4246),
    [anon_sym___declspec] = ACTIONS(4244),
    [anon_sym___based] = ACTIONS(4244),
    [anon_sym___cdecl] = ACTIONS(4244),
    [anon_sym___clrcall] = ACTIONS(4244),
    [anon_sym___stdcall] = ACTIONS(4244),
    [anon_sym___fastcall] = ACTIONS(4244),
    [anon_sym___thiscall] = ACTIONS(4244),
    [anon_sym___vectorcall] = ACTIONS(4244),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_signed] = ACTIONS(4244),
    [anon_sym_unsigned] = ACTIONS(4244),
    [anon_sym_long] = ACTIONS(4244),
    [anon_sym_short] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [anon_sym_static] = ACTIONS(4244),
    [anon_sym_register] = ACTIONS(4244),
    [anon_sym_inline] = ACTIONS(4244),
    [anon_sym___inline] = ACTIONS(4244),
    [anon_sym___inline__] = ACTIONS(4244),
    [anon_sym___forceinline] = ACTIONS(4244),
    [anon_sym_thread_local] = ACTIONS(4244),
    [anon_sym___thread] = ACTIONS(4244),
    [anon_sym_const] = ACTIONS(4244),
    [anon_sym_constexpr] = ACTIONS(4244),
    [anon_sym_volatile] = ACTIONS(4244),
    [anon_sym_restrict] = ACTIONS(4244),
    [anon_sym___restrict__] = ACTIONS(4244),
    [anon_sym__Atomic] = ACTIONS(4244),
    [anon_sym__Noreturn] = ACTIONS(4244),
    [anon_sym_noreturn] = ACTIONS(4244),
    [anon_sym__Nonnull] = ACTIONS(4244),
    [anon_sym_mutable] = ACTIONS(4244),
    [anon_sym_constinit] = ACTIONS(4244),
    [anon_sym_consteval] = ACTIONS(4244),
    [anon_sym_alignas] = ACTIONS(4244),
    [anon_sym__Alignas] = ACTIONS(4244),
    [sym_primitive_type] = ACTIONS(4244),
    [anon_sym_enum] = ACTIONS(4244),
    [anon_sym_class] = ACTIONS(4244),
    [anon_sym_struct] = ACTIONS(4244),
    [anon_sym_union] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_switch] = ACTIONS(4244),
    [anon_sym_case] = ACTIONS(4244),
    [anon_sym_default] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_break] = ACTIONS(4244),
    [anon_sym_continue] = ACTIONS(4244),
    [anon_sym_goto] = ACTIONS(4244),
    [anon_sym_not] = ACTIONS(4244),
    [anon_sym_compl] = ACTIONS(4244),
    [anon_sym_DASH_DASH] = ACTIONS(4246),
    [anon_sym_PLUS_PLUS] = ACTIONS(4246),
    [anon_sym_sizeof] = ACTIONS(4244),
    [anon_sym___alignof__] = ACTIONS(4244),
    [anon_sym___alignof] = ACTIONS(4244),
    [anon_sym__alignof] = ACTIONS(4244),
    [anon_sym_alignof] = ACTIONS(4244),
    [anon_sym__Alignof] = ACTIONS(4244),
    [anon_sym_offsetof] = ACTIONS(4244),
    [anon_sym__Generic] = ACTIONS(4244),
    [anon_sym_asm] = ACTIONS(4244),
    [anon_sym___asm__] = ACTIONS(4244),
    [anon_sym___asm] = ACTIONS(4244),
    [anon_sym_DOT] = ACTIONS(2606),
    [sym_number_literal] = ACTIONS(4246),
    [anon_sym_L_SQUOTE] = ACTIONS(4246),
    [anon_sym_u_SQUOTE] = ACTIONS(4246),
    [anon_sym_U_SQUOTE] = ACTIONS(4246),
    [anon_sym_u8_SQUOTE] = ACTIONS(4246),
    [anon_sym_SQUOTE] = ACTIONS(4246),
    [anon_sym_L_DQUOTE] = ACTIONS(4246),
    [anon_sym_u_DQUOTE] = ACTIONS(4246),
    [anon_sym_U_DQUOTE] = ACTIONS(4246),
    [anon_sym_u8_DQUOTE] = ACTIONS(4246),
    [anon_sym_DQUOTE] = ACTIONS(4246),
    [sym_true] = ACTIONS(4244),
    [sym_false] = ACTIONS(4244),
    [anon_sym_NULL] = ACTIONS(4244),
    [anon_sym_nullptr] = ACTIONS(4244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_This] = ACTIONS(2608),
    [anon_sym_decltype] = ACTIONS(4244),
    [anon_sym_explicit] = ACTIONS(4244),
    [anon_sym_typename] = ACTIONS(4244),
    [anon_sym_export] = ACTIONS(4244),
    [anon_sym_module] = ACTIONS(4244),
    [anon_sym_import] = ACTIONS(4244),
    [anon_sym_template] = ACTIONS(4244),
    [anon_sym_operator] = ACTIONS(4244),
    [anon_sym_try] = ACTIONS(4244),
    [anon_sym_delete] = ACTIONS(4244),
    [anon_sym_throw] = ACTIONS(4244),
    [anon_sym_namespace] = ACTIONS(4244),
    [anon_sym_static_assert] = ACTIONS(4244),
    [anon_sym_concept] = ACTIONS(4244),
    [anon_sym_co_return] = ACTIONS(4244),
    [anon_sym_co_yield] = ACTIONS(4244),
    [anon_sym_R_DQUOTE] = ACTIONS(4246),
    [anon_sym_LR_DQUOTE] = ACTIONS(4246),
    [anon_sym_uR_DQUOTE] = ACTIONS(4246),
    [anon_sym_UR_DQUOTE] = ACTIONS(4246),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4246),
    [anon_sym_co_await] = ACTIONS(4244),
    [anon_sym_new] = ACTIONS(4244),
    [anon_sym_requires] = ACTIONS(4244),
    [sym_this] = ACTIONS(4244),
    [anon_sym_precise] = ACTIONS(4244),
    [anon_sym_shared] = ACTIONS(4244),
    [anon_sym_groupshared] = ACTIONS(4244),
    [anon_sym_uniform] = ACTIONS(4244),
    [anon_sym_row_major] = ACTIONS(4244),
    [anon_sym_column_major] = ACTIONS(4244),
    [anon_sym_globallycoherent] = ACTIONS(4244),
    [anon_sym_centroid] = ACTIONS(4244),
    [anon_sym_noperspective] = ACTIONS(4244),
    [anon_sym_nointerpolation] = ACTIONS(4244),
    [anon_sym_sample] = ACTIONS(4244),
    [anon_sym_linear] = ACTIONS(4244),
    [anon_sym_snorm] = ACTIONS(4244),
    [anon_sym_unorm] = ACTIONS(4244),
    [anon_sym_point] = ACTIONS(4244),
    [anon_sym_line] = ACTIONS(4244),
    [anon_sym_triangleadj] = ACTIONS(4244),
    [anon_sym_lineadj] = ACTIONS(4244),
    [anon_sym_triangle] = ACTIONS(4244),
    [anon_sym_interface] = ACTIONS(4244),
    [anon_sym_extension] = ACTIONS(4244),
    [anon_sym___exported] = ACTIONS(4244),
  },
  [844] = {
    [sym_identifier] = ACTIONS(3411),
    [aux_sym_preproc_include_token1] = ACTIONS(3411),
    [aux_sym_preproc_def_token1] = ACTIONS(3411),
    [aux_sym_preproc_if_token1] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3411),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3411),
    [sym_preproc_directive] = ACTIONS(3411),
    [anon_sym_LPAREN2] = ACTIONS(3413),
    [anon_sym_BANG] = ACTIONS(3413),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_DASH] = ACTIONS(3411),
    [anon_sym_PLUS] = ACTIONS(3411),
    [anon_sym_STAR] = ACTIONS(3413),
    [anon_sym_AMP_AMP] = ACTIONS(3413),
    [anon_sym_AMP] = ACTIONS(3411),
    [anon_sym_SEMI] = ACTIONS(3413),
    [anon_sym___extension__] = ACTIONS(3411),
    [anon_sym_typedef] = ACTIONS(3411),
    [anon_sym_in] = ACTIONS(3411),
    [anon_sym_out] = ACTIONS(3411),
    [anon_sym_inout] = ACTIONS(3411),
    [anon_sym_virtual] = ACTIONS(3411),
    [anon_sym_extern] = ACTIONS(3411),
    [anon_sym___attribute__] = ACTIONS(3411),
    [anon_sym___attribute] = ACTIONS(3411),
    [anon_sym_using] = ACTIONS(3411),
    [anon_sym_COLON_COLON] = ACTIONS(3413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3413),
    [anon_sym___declspec] = ACTIONS(3411),
    [anon_sym___based] = ACTIONS(3411),
    [anon_sym___cdecl] = ACTIONS(3411),
    [anon_sym___clrcall] = ACTIONS(3411),
    [anon_sym___stdcall] = ACTIONS(3411),
    [anon_sym___fastcall] = ACTIONS(3411),
    [anon_sym___thiscall] = ACTIONS(3411),
    [anon_sym___vectorcall] = ACTIONS(3411),
    [anon_sym_LBRACE] = ACTIONS(3413),
    [anon_sym_RBRACE] = ACTIONS(3413),
    [anon_sym_signed] = ACTIONS(3411),
    [anon_sym_unsigned] = ACTIONS(3411),
    [anon_sym_long] = ACTIONS(3411),
    [anon_sym_short] = ACTIONS(3411),
    [anon_sym_LBRACK] = ACTIONS(3411),
    [anon_sym_static] = ACTIONS(3411),
    [anon_sym_register] = ACTIONS(3411),
    [anon_sym_inline] = ACTIONS(3411),
    [anon_sym___inline] = ACTIONS(3411),
    [anon_sym___inline__] = ACTIONS(3411),
    [anon_sym___forceinline] = ACTIONS(3411),
    [anon_sym_thread_local] = ACTIONS(3411),
    [anon_sym___thread] = ACTIONS(3411),
    [anon_sym_const] = ACTIONS(3411),
    [anon_sym_constexpr] = ACTIONS(3411),
    [anon_sym_volatile] = ACTIONS(3411),
    [anon_sym_restrict] = ACTIONS(3411),
    [anon_sym___restrict__] = ACTIONS(3411),
    [anon_sym__Atomic] = ACTIONS(3411),
    [anon_sym__Noreturn] = ACTIONS(3411),
    [anon_sym_noreturn] = ACTIONS(3411),
    [anon_sym__Nonnull] = ACTIONS(3411),
    [anon_sym_mutable] = ACTIONS(3411),
    [anon_sym_constinit] = ACTIONS(3411),
    [anon_sym_consteval] = ACTIONS(3411),
    [anon_sym_alignas] = ACTIONS(3411),
    [anon_sym__Alignas] = ACTIONS(3411),
    [sym_primitive_type] = ACTIONS(3411),
    [anon_sym_enum] = ACTIONS(3411),
    [anon_sym_class] = ACTIONS(3411),
    [anon_sym_struct] = ACTIONS(3411),
    [anon_sym_union] = ACTIONS(3411),
    [anon_sym_if] = ACTIONS(3411),
    [anon_sym_else] = ACTIONS(3411),
    [anon_sym_switch] = ACTIONS(3411),
    [anon_sym_case] = ACTIONS(3411),
    [anon_sym_default] = ACTIONS(3411),
    [anon_sym_while] = ACTIONS(3411),
    [anon_sym_do] = ACTIONS(3411),
    [anon_sym_for] = ACTIONS(3411),
    [anon_sym_return] = ACTIONS(3411),
    [anon_sym_break] = ACTIONS(3411),
    [anon_sym_continue] = ACTIONS(3411),
    [anon_sym_goto] = ACTIONS(3411),
    [anon_sym___try] = ACTIONS(3411),
    [anon_sym___leave] = ACTIONS(3411),
    [anon_sym_not] = ACTIONS(3411),
    [anon_sym_compl] = ACTIONS(3411),
    [anon_sym_DASH_DASH] = ACTIONS(3413),
    [anon_sym_PLUS_PLUS] = ACTIONS(3413),
    [anon_sym_sizeof] = ACTIONS(3411),
    [anon_sym___alignof__] = ACTIONS(3411),
    [anon_sym___alignof] = ACTIONS(3411),
    [anon_sym__alignof] = ACTIONS(3411),
    [anon_sym_alignof] = ACTIONS(3411),
    [anon_sym__Alignof] = ACTIONS(3411),
    [anon_sym_offsetof] = ACTIONS(3411),
    [anon_sym__Generic] = ACTIONS(3411),
    [anon_sym_asm] = ACTIONS(3411),
    [anon_sym___asm__] = ACTIONS(3411),
    [anon_sym___asm] = ACTIONS(3411),
    [sym_number_literal] = ACTIONS(3413),
    [anon_sym_L_SQUOTE] = ACTIONS(3413),
    [anon_sym_u_SQUOTE] = ACTIONS(3413),
    [anon_sym_U_SQUOTE] = ACTIONS(3413),
    [anon_sym_u8_SQUOTE] = ACTIONS(3413),
    [anon_sym_SQUOTE] = ACTIONS(3413),
    [anon_sym_L_DQUOTE] = ACTIONS(3413),
    [anon_sym_u_DQUOTE] = ACTIONS(3413),
    [anon_sym_U_DQUOTE] = ACTIONS(3413),
    [anon_sym_u8_DQUOTE] = ACTIONS(3413),
    [anon_sym_DQUOTE] = ACTIONS(3413),
    [sym_true] = ACTIONS(3411),
    [sym_false] = ACTIONS(3411),
    [anon_sym_NULL] = ACTIONS(3411),
    [anon_sym_nullptr] = ACTIONS(3411),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3411),
    [anon_sym_let] = ACTIONS(3411),
    [anon_sym_This] = ACTIONS(3411),
    [anon_sym_decltype] = ACTIONS(3411),
    [anon_sym_explicit] = ACTIONS(3411),
    [anon_sym_typename] = ACTIONS(3411),
    [anon_sym_template] = ACTIONS(3411),
    [anon_sym_operator] = ACTIONS(3411),
    [anon_sym_try] = ACTIONS(3411),
    [anon_sym_delete] = ACTIONS(3411),
    [anon_sym_throw] = ACTIONS(3411),
    [anon_sym_namespace] = ACTIONS(3411),
    [anon_sym_static_assert] = ACTIONS(3411),
    [anon_sym_concept] = ACTIONS(3411),
    [anon_sym_co_return] = ACTIONS(3411),
    [anon_sym_co_yield] = ACTIONS(3411),
    [anon_sym_R_DQUOTE] = ACTIONS(3413),
    [anon_sym_LR_DQUOTE] = ACTIONS(3413),
    [anon_sym_uR_DQUOTE] = ACTIONS(3413),
    [anon_sym_UR_DQUOTE] = ACTIONS(3413),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3413),
    [anon_sym_co_await] = ACTIONS(3411),
    [anon_sym_new] = ACTIONS(3411),
    [anon_sym_requires] = ACTIONS(3411),
    [sym_this] = ACTIONS(3411),
    [anon_sym_discard] = ACTIONS(3411),
    [anon_sym_precise] = ACTIONS(3411),
    [anon_sym_shared] = ACTIONS(3411),
    [anon_sym_groupshared] = ACTIONS(3411),
    [anon_sym_uniform] = ACTIONS(3411),
    [anon_sym_row_major] = ACTIONS(3411),
    [anon_sym_column_major] = ACTIONS(3411),
    [anon_sym_globallycoherent] = ACTIONS(3411),
    [anon_sym_centroid] = ACTIONS(3411),
    [anon_sym_noperspective] = ACTIONS(3411),
    [anon_sym_nointerpolation] = ACTIONS(3411),
    [anon_sym_sample] = ACTIONS(3411),
    [anon_sym_linear] = ACTIONS(3411),
    [anon_sym_snorm] = ACTIONS(3411),
    [anon_sym_unorm] = ACTIONS(3411),
    [anon_sym_point] = ACTIONS(3411),
    [anon_sym_line] = ACTIONS(3411),
    [anon_sym_triangleadj] = ACTIONS(3411),
    [anon_sym_lineadj] = ACTIONS(3411),
    [anon_sym_triangle] = ACTIONS(3411),
    [anon_sym_cbuffer] = ACTIONS(3411),
    [anon_sym_interface] = ACTIONS(3411),
    [anon_sym_extension] = ACTIONS(3411),
  },
  [845] = {
    [sym_expression] = STATE(5382),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(3357),
    [anon_sym_typedef] = ACTIONS(4259),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3370),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3373),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3376),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [846] = {
    [sym_identifier] = ACTIONS(3627),
    [aux_sym_preproc_include_token1] = ACTIONS(3627),
    [aux_sym_preproc_def_token1] = ACTIONS(3627),
    [aux_sym_preproc_if_token1] = ACTIONS(3627),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3627),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3627),
    [sym_preproc_directive] = ACTIONS(3627),
    [anon_sym_LPAREN2] = ACTIONS(3625),
    [anon_sym_BANG] = ACTIONS(3625),
    [anon_sym_TILDE] = ACTIONS(3625),
    [anon_sym_DASH] = ACTIONS(3627),
    [anon_sym_PLUS] = ACTIONS(3627),
    [anon_sym_STAR] = ACTIONS(3625),
    [anon_sym_AMP_AMP] = ACTIONS(3625),
    [anon_sym_AMP] = ACTIONS(3627),
    [anon_sym_SEMI] = ACTIONS(3625),
    [anon_sym___extension__] = ACTIONS(3627),
    [anon_sym_typedef] = ACTIONS(3627),
    [anon_sym_in] = ACTIONS(3627),
    [anon_sym_out] = ACTIONS(3627),
    [anon_sym_inout] = ACTIONS(3627),
    [anon_sym_virtual] = ACTIONS(3627),
    [anon_sym_extern] = ACTIONS(3627),
    [anon_sym___attribute__] = ACTIONS(3627),
    [anon_sym___attribute] = ACTIONS(3627),
    [anon_sym_using] = ACTIONS(3627),
    [anon_sym_COLON_COLON] = ACTIONS(3625),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3625),
    [anon_sym___declspec] = ACTIONS(3627),
    [anon_sym___based] = ACTIONS(3627),
    [anon_sym___cdecl] = ACTIONS(3627),
    [anon_sym___clrcall] = ACTIONS(3627),
    [anon_sym___stdcall] = ACTIONS(3627),
    [anon_sym___fastcall] = ACTIONS(3627),
    [anon_sym___thiscall] = ACTIONS(3627),
    [anon_sym___vectorcall] = ACTIONS(3627),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_RBRACE] = ACTIONS(3625),
    [anon_sym_signed] = ACTIONS(3627),
    [anon_sym_unsigned] = ACTIONS(3627),
    [anon_sym_long] = ACTIONS(3627),
    [anon_sym_short] = ACTIONS(3627),
    [anon_sym_LBRACK] = ACTIONS(3627),
    [anon_sym_static] = ACTIONS(3627),
    [anon_sym_register] = ACTIONS(3627),
    [anon_sym_inline] = ACTIONS(3627),
    [anon_sym___inline] = ACTIONS(3627),
    [anon_sym___inline__] = ACTIONS(3627),
    [anon_sym___forceinline] = ACTIONS(3627),
    [anon_sym_thread_local] = ACTIONS(3627),
    [anon_sym___thread] = ACTIONS(3627),
    [anon_sym_const] = ACTIONS(3627),
    [anon_sym_constexpr] = ACTIONS(3627),
    [anon_sym_volatile] = ACTIONS(3627),
    [anon_sym_restrict] = ACTIONS(3627),
    [anon_sym___restrict__] = ACTIONS(3627),
    [anon_sym__Atomic] = ACTIONS(3627),
    [anon_sym__Noreturn] = ACTIONS(3627),
    [anon_sym_noreturn] = ACTIONS(3627),
    [anon_sym__Nonnull] = ACTIONS(3627),
    [anon_sym_mutable] = ACTIONS(3627),
    [anon_sym_constinit] = ACTIONS(3627),
    [anon_sym_consteval] = ACTIONS(3627),
    [anon_sym_alignas] = ACTIONS(3627),
    [anon_sym__Alignas] = ACTIONS(3627),
    [sym_primitive_type] = ACTIONS(3627),
    [anon_sym_enum] = ACTIONS(3627),
    [anon_sym_class] = ACTIONS(3627),
    [anon_sym_struct] = ACTIONS(3627),
    [anon_sym_union] = ACTIONS(3627),
    [anon_sym_if] = ACTIONS(3627),
    [anon_sym_else] = ACTIONS(3627),
    [anon_sym_switch] = ACTIONS(3627),
    [anon_sym_case] = ACTIONS(3627),
    [anon_sym_default] = ACTIONS(3627),
    [anon_sym_while] = ACTIONS(3627),
    [anon_sym_do] = ACTIONS(3627),
    [anon_sym_for] = ACTIONS(3627),
    [anon_sym_return] = ACTIONS(3627),
    [anon_sym_break] = ACTIONS(3627),
    [anon_sym_continue] = ACTIONS(3627),
    [anon_sym_goto] = ACTIONS(3627),
    [anon_sym___try] = ACTIONS(3627),
    [anon_sym___leave] = ACTIONS(3627),
    [anon_sym_not] = ACTIONS(3627),
    [anon_sym_compl] = ACTIONS(3627),
    [anon_sym_DASH_DASH] = ACTIONS(3625),
    [anon_sym_PLUS_PLUS] = ACTIONS(3625),
    [anon_sym_sizeof] = ACTIONS(3627),
    [anon_sym___alignof__] = ACTIONS(3627),
    [anon_sym___alignof] = ACTIONS(3627),
    [anon_sym__alignof] = ACTIONS(3627),
    [anon_sym_alignof] = ACTIONS(3627),
    [anon_sym__Alignof] = ACTIONS(3627),
    [anon_sym_offsetof] = ACTIONS(3627),
    [anon_sym__Generic] = ACTIONS(3627),
    [anon_sym_asm] = ACTIONS(3627),
    [anon_sym___asm__] = ACTIONS(3627),
    [anon_sym___asm] = ACTIONS(3627),
    [sym_number_literal] = ACTIONS(3625),
    [anon_sym_L_SQUOTE] = ACTIONS(3625),
    [anon_sym_u_SQUOTE] = ACTIONS(3625),
    [anon_sym_U_SQUOTE] = ACTIONS(3625),
    [anon_sym_u8_SQUOTE] = ACTIONS(3625),
    [anon_sym_SQUOTE] = ACTIONS(3625),
    [anon_sym_L_DQUOTE] = ACTIONS(3625),
    [anon_sym_u_DQUOTE] = ACTIONS(3625),
    [anon_sym_U_DQUOTE] = ACTIONS(3625),
    [anon_sym_u8_DQUOTE] = ACTIONS(3625),
    [anon_sym_DQUOTE] = ACTIONS(3625),
    [sym_true] = ACTIONS(3627),
    [sym_false] = ACTIONS(3627),
    [anon_sym_NULL] = ACTIONS(3627),
    [anon_sym_nullptr] = ACTIONS(3627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3627),
    [anon_sym_let] = ACTIONS(3627),
    [anon_sym_This] = ACTIONS(3627),
    [anon_sym_decltype] = ACTIONS(3627),
    [anon_sym_explicit] = ACTIONS(3627),
    [anon_sym_typename] = ACTIONS(3627),
    [anon_sym_template] = ACTIONS(3627),
    [anon_sym_operator] = ACTIONS(3627),
    [anon_sym_try] = ACTIONS(3627),
    [anon_sym_delete] = ACTIONS(3627),
    [anon_sym_throw] = ACTIONS(3627),
    [anon_sym_namespace] = ACTIONS(3627),
    [anon_sym_static_assert] = ACTIONS(3627),
    [anon_sym_concept] = ACTIONS(3627),
    [anon_sym_co_return] = ACTIONS(3627),
    [anon_sym_co_yield] = ACTIONS(3627),
    [anon_sym_R_DQUOTE] = ACTIONS(3625),
    [anon_sym_LR_DQUOTE] = ACTIONS(3625),
    [anon_sym_uR_DQUOTE] = ACTIONS(3625),
    [anon_sym_UR_DQUOTE] = ACTIONS(3625),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3625),
    [anon_sym_co_await] = ACTIONS(3627),
    [anon_sym_new] = ACTIONS(3627),
    [anon_sym_requires] = ACTIONS(3627),
    [sym_this] = ACTIONS(3627),
    [anon_sym_discard] = ACTIONS(3627),
    [anon_sym_precise] = ACTIONS(3627),
    [anon_sym_shared] = ACTIONS(3627),
    [anon_sym_groupshared] = ACTIONS(3627),
    [anon_sym_uniform] = ACTIONS(3627),
    [anon_sym_row_major] = ACTIONS(3627),
    [anon_sym_column_major] = ACTIONS(3627),
    [anon_sym_globallycoherent] = ACTIONS(3627),
    [anon_sym_centroid] = ACTIONS(3627),
    [anon_sym_noperspective] = ACTIONS(3627),
    [anon_sym_nointerpolation] = ACTIONS(3627),
    [anon_sym_sample] = ACTIONS(3627),
    [anon_sym_linear] = ACTIONS(3627),
    [anon_sym_snorm] = ACTIONS(3627),
    [anon_sym_unorm] = ACTIONS(3627),
    [anon_sym_point] = ACTIONS(3627),
    [anon_sym_line] = ACTIONS(3627),
    [anon_sym_triangleadj] = ACTIONS(3627),
    [anon_sym_lineadj] = ACTIONS(3627),
    [anon_sym_triangle] = ACTIONS(3627),
    [anon_sym_cbuffer] = ACTIONS(3627),
    [anon_sym_interface] = ACTIONS(3627),
    [anon_sym_extension] = ACTIONS(3627),
  },
  [847] = {
    [sym_identifier] = ACTIONS(3597),
    [aux_sym_preproc_include_token1] = ACTIONS(3597),
    [aux_sym_preproc_def_token1] = ACTIONS(3597),
    [aux_sym_preproc_if_token1] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3597),
    [sym_preproc_directive] = ACTIONS(3597),
    [anon_sym_LPAREN2] = ACTIONS(3599),
    [anon_sym_BANG] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3599),
    [anon_sym_DASH] = ACTIONS(3597),
    [anon_sym_PLUS] = ACTIONS(3597),
    [anon_sym_STAR] = ACTIONS(3599),
    [anon_sym_AMP_AMP] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3597),
    [anon_sym_SEMI] = ACTIONS(3599),
    [anon_sym___extension__] = ACTIONS(3597),
    [anon_sym_typedef] = ACTIONS(3597),
    [anon_sym_in] = ACTIONS(3597),
    [anon_sym_out] = ACTIONS(3597),
    [anon_sym_inout] = ACTIONS(3597),
    [anon_sym_virtual] = ACTIONS(3597),
    [anon_sym_extern] = ACTIONS(3597),
    [anon_sym___attribute__] = ACTIONS(3597),
    [anon_sym___attribute] = ACTIONS(3597),
    [anon_sym_using] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3599),
    [anon_sym___declspec] = ACTIONS(3597),
    [anon_sym___based] = ACTIONS(3597),
    [anon_sym___cdecl] = ACTIONS(3597),
    [anon_sym___clrcall] = ACTIONS(3597),
    [anon_sym___stdcall] = ACTIONS(3597),
    [anon_sym___fastcall] = ACTIONS(3597),
    [anon_sym___thiscall] = ACTIONS(3597),
    [anon_sym___vectorcall] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(3599),
    [anon_sym_RBRACE] = ACTIONS(3599),
    [anon_sym_signed] = ACTIONS(3597),
    [anon_sym_unsigned] = ACTIONS(3597),
    [anon_sym_long] = ACTIONS(3597),
    [anon_sym_short] = ACTIONS(3597),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_static] = ACTIONS(3597),
    [anon_sym_register] = ACTIONS(3597),
    [anon_sym_inline] = ACTIONS(3597),
    [anon_sym___inline] = ACTIONS(3597),
    [anon_sym___inline__] = ACTIONS(3597),
    [anon_sym___forceinline] = ACTIONS(3597),
    [anon_sym_thread_local] = ACTIONS(3597),
    [anon_sym___thread] = ACTIONS(3597),
    [anon_sym_const] = ACTIONS(3597),
    [anon_sym_constexpr] = ACTIONS(3597),
    [anon_sym_volatile] = ACTIONS(3597),
    [anon_sym_restrict] = ACTIONS(3597),
    [anon_sym___restrict__] = ACTIONS(3597),
    [anon_sym__Atomic] = ACTIONS(3597),
    [anon_sym__Noreturn] = ACTIONS(3597),
    [anon_sym_noreturn] = ACTIONS(3597),
    [anon_sym__Nonnull] = ACTIONS(3597),
    [anon_sym_mutable] = ACTIONS(3597),
    [anon_sym_constinit] = ACTIONS(3597),
    [anon_sym_consteval] = ACTIONS(3597),
    [anon_sym_alignas] = ACTIONS(3597),
    [anon_sym__Alignas] = ACTIONS(3597),
    [sym_primitive_type] = ACTIONS(3597),
    [anon_sym_enum] = ACTIONS(3597),
    [anon_sym_class] = ACTIONS(3597),
    [anon_sym_struct] = ACTIONS(3597),
    [anon_sym_union] = ACTIONS(3597),
    [anon_sym_if] = ACTIONS(3597),
    [anon_sym_else] = ACTIONS(3597),
    [anon_sym_switch] = ACTIONS(3597),
    [anon_sym_case] = ACTIONS(3597),
    [anon_sym_default] = ACTIONS(3597),
    [anon_sym_while] = ACTIONS(3597),
    [anon_sym_do] = ACTIONS(3597),
    [anon_sym_for] = ACTIONS(3597),
    [anon_sym_return] = ACTIONS(3597),
    [anon_sym_break] = ACTIONS(3597),
    [anon_sym_continue] = ACTIONS(3597),
    [anon_sym_goto] = ACTIONS(3597),
    [anon_sym___try] = ACTIONS(3597),
    [anon_sym___leave] = ACTIONS(3597),
    [anon_sym_not] = ACTIONS(3597),
    [anon_sym_compl] = ACTIONS(3597),
    [anon_sym_DASH_DASH] = ACTIONS(3599),
    [anon_sym_PLUS_PLUS] = ACTIONS(3599),
    [anon_sym_sizeof] = ACTIONS(3597),
    [anon_sym___alignof__] = ACTIONS(3597),
    [anon_sym___alignof] = ACTIONS(3597),
    [anon_sym__alignof] = ACTIONS(3597),
    [anon_sym_alignof] = ACTIONS(3597),
    [anon_sym__Alignof] = ACTIONS(3597),
    [anon_sym_offsetof] = ACTIONS(3597),
    [anon_sym__Generic] = ACTIONS(3597),
    [anon_sym_asm] = ACTIONS(3597),
    [anon_sym___asm__] = ACTIONS(3597),
    [anon_sym___asm] = ACTIONS(3597),
    [sym_number_literal] = ACTIONS(3599),
    [anon_sym_L_SQUOTE] = ACTIONS(3599),
    [anon_sym_u_SQUOTE] = ACTIONS(3599),
    [anon_sym_U_SQUOTE] = ACTIONS(3599),
    [anon_sym_u8_SQUOTE] = ACTIONS(3599),
    [anon_sym_SQUOTE] = ACTIONS(3599),
    [anon_sym_L_DQUOTE] = ACTIONS(3599),
    [anon_sym_u_DQUOTE] = ACTIONS(3599),
    [anon_sym_U_DQUOTE] = ACTIONS(3599),
    [anon_sym_u8_DQUOTE] = ACTIONS(3599),
    [anon_sym_DQUOTE] = ACTIONS(3599),
    [sym_true] = ACTIONS(3597),
    [sym_false] = ACTIONS(3597),
    [anon_sym_NULL] = ACTIONS(3597),
    [anon_sym_nullptr] = ACTIONS(3597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3597),
    [anon_sym_let] = ACTIONS(3597),
    [anon_sym_This] = ACTIONS(3597),
    [anon_sym_decltype] = ACTIONS(3597),
    [anon_sym_explicit] = ACTIONS(3597),
    [anon_sym_typename] = ACTIONS(3597),
    [anon_sym_template] = ACTIONS(3597),
    [anon_sym_operator] = ACTIONS(3597),
    [anon_sym_try] = ACTIONS(3597),
    [anon_sym_delete] = ACTIONS(3597),
    [anon_sym_throw] = ACTIONS(3597),
    [anon_sym_namespace] = ACTIONS(3597),
    [anon_sym_static_assert] = ACTIONS(3597),
    [anon_sym_concept] = ACTIONS(3597),
    [anon_sym_co_return] = ACTIONS(3597),
    [anon_sym_co_yield] = ACTIONS(3597),
    [anon_sym_R_DQUOTE] = ACTIONS(3599),
    [anon_sym_LR_DQUOTE] = ACTIONS(3599),
    [anon_sym_uR_DQUOTE] = ACTIONS(3599),
    [anon_sym_UR_DQUOTE] = ACTIONS(3599),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3599),
    [anon_sym_co_await] = ACTIONS(3597),
    [anon_sym_new] = ACTIONS(3597),
    [anon_sym_requires] = ACTIONS(3597),
    [sym_this] = ACTIONS(3597),
    [anon_sym_discard] = ACTIONS(3597),
    [anon_sym_precise] = ACTIONS(3597),
    [anon_sym_shared] = ACTIONS(3597),
    [anon_sym_groupshared] = ACTIONS(3597),
    [anon_sym_uniform] = ACTIONS(3597),
    [anon_sym_row_major] = ACTIONS(3597),
    [anon_sym_column_major] = ACTIONS(3597),
    [anon_sym_globallycoherent] = ACTIONS(3597),
    [anon_sym_centroid] = ACTIONS(3597),
    [anon_sym_noperspective] = ACTIONS(3597),
    [anon_sym_nointerpolation] = ACTIONS(3597),
    [anon_sym_sample] = ACTIONS(3597),
    [anon_sym_linear] = ACTIONS(3597),
    [anon_sym_snorm] = ACTIONS(3597),
    [anon_sym_unorm] = ACTIONS(3597),
    [anon_sym_point] = ACTIONS(3597),
    [anon_sym_line] = ACTIONS(3597),
    [anon_sym_triangleadj] = ACTIONS(3597),
    [anon_sym_lineadj] = ACTIONS(3597),
    [anon_sym_triangle] = ACTIONS(3597),
    [anon_sym_cbuffer] = ACTIONS(3597),
    [anon_sym_interface] = ACTIONS(3597),
    [anon_sym_extension] = ACTIONS(3597),
  },
  [848] = {
    [sym_identifier] = ACTIONS(3490),
    [aux_sym_preproc_include_token1] = ACTIONS(3490),
    [aux_sym_preproc_def_token1] = ACTIONS(3490),
    [aux_sym_preproc_if_token1] = ACTIONS(3490),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3490),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3490),
    [sym_preproc_directive] = ACTIONS(3490),
    [anon_sym_LPAREN2] = ACTIONS(3492),
    [anon_sym_BANG] = ACTIONS(3492),
    [anon_sym_TILDE] = ACTIONS(3492),
    [anon_sym_DASH] = ACTIONS(3490),
    [anon_sym_PLUS] = ACTIONS(3490),
    [anon_sym_STAR] = ACTIONS(3492),
    [anon_sym_AMP_AMP] = ACTIONS(3492),
    [anon_sym_AMP] = ACTIONS(3490),
    [anon_sym_SEMI] = ACTIONS(3492),
    [anon_sym___extension__] = ACTIONS(3490),
    [anon_sym_typedef] = ACTIONS(3490),
    [anon_sym_in] = ACTIONS(3490),
    [anon_sym_out] = ACTIONS(3490),
    [anon_sym_inout] = ACTIONS(3490),
    [anon_sym_virtual] = ACTIONS(3490),
    [anon_sym_extern] = ACTIONS(3490),
    [anon_sym___attribute__] = ACTIONS(3490),
    [anon_sym___attribute] = ACTIONS(3490),
    [anon_sym_using] = ACTIONS(3490),
    [anon_sym_COLON_COLON] = ACTIONS(3492),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3492),
    [anon_sym___declspec] = ACTIONS(3490),
    [anon_sym___based] = ACTIONS(3490),
    [anon_sym___cdecl] = ACTIONS(3490),
    [anon_sym___clrcall] = ACTIONS(3490),
    [anon_sym___stdcall] = ACTIONS(3490),
    [anon_sym___fastcall] = ACTIONS(3490),
    [anon_sym___thiscall] = ACTIONS(3490),
    [anon_sym___vectorcall] = ACTIONS(3490),
    [anon_sym_LBRACE] = ACTIONS(3492),
    [anon_sym_RBRACE] = ACTIONS(3492),
    [anon_sym_signed] = ACTIONS(3490),
    [anon_sym_unsigned] = ACTIONS(3490),
    [anon_sym_long] = ACTIONS(3490),
    [anon_sym_short] = ACTIONS(3490),
    [anon_sym_LBRACK] = ACTIONS(3490),
    [anon_sym_static] = ACTIONS(3490),
    [anon_sym_register] = ACTIONS(3490),
    [anon_sym_inline] = ACTIONS(3490),
    [anon_sym___inline] = ACTIONS(3490),
    [anon_sym___inline__] = ACTIONS(3490),
    [anon_sym___forceinline] = ACTIONS(3490),
    [anon_sym_thread_local] = ACTIONS(3490),
    [anon_sym___thread] = ACTIONS(3490),
    [anon_sym_const] = ACTIONS(3490),
    [anon_sym_constexpr] = ACTIONS(3490),
    [anon_sym_volatile] = ACTIONS(3490),
    [anon_sym_restrict] = ACTIONS(3490),
    [anon_sym___restrict__] = ACTIONS(3490),
    [anon_sym__Atomic] = ACTIONS(3490),
    [anon_sym__Noreturn] = ACTIONS(3490),
    [anon_sym_noreturn] = ACTIONS(3490),
    [anon_sym__Nonnull] = ACTIONS(3490),
    [anon_sym_mutable] = ACTIONS(3490),
    [anon_sym_constinit] = ACTIONS(3490),
    [anon_sym_consteval] = ACTIONS(3490),
    [anon_sym_alignas] = ACTIONS(3490),
    [anon_sym__Alignas] = ACTIONS(3490),
    [sym_primitive_type] = ACTIONS(3490),
    [anon_sym_enum] = ACTIONS(3490),
    [anon_sym_class] = ACTIONS(3490),
    [anon_sym_struct] = ACTIONS(3490),
    [anon_sym_union] = ACTIONS(3490),
    [anon_sym_if] = ACTIONS(3490),
    [anon_sym_else] = ACTIONS(3490),
    [anon_sym_switch] = ACTIONS(3490),
    [anon_sym_case] = ACTIONS(3490),
    [anon_sym_default] = ACTIONS(3490),
    [anon_sym_while] = ACTIONS(3490),
    [anon_sym_do] = ACTIONS(3490),
    [anon_sym_for] = ACTIONS(3490),
    [anon_sym_return] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3490),
    [anon_sym_continue] = ACTIONS(3490),
    [anon_sym_goto] = ACTIONS(3490),
    [anon_sym___try] = ACTIONS(3490),
    [anon_sym___leave] = ACTIONS(3490),
    [anon_sym_not] = ACTIONS(3490),
    [anon_sym_compl] = ACTIONS(3490),
    [anon_sym_DASH_DASH] = ACTIONS(3492),
    [anon_sym_PLUS_PLUS] = ACTIONS(3492),
    [anon_sym_sizeof] = ACTIONS(3490),
    [anon_sym___alignof__] = ACTIONS(3490),
    [anon_sym___alignof] = ACTIONS(3490),
    [anon_sym__alignof] = ACTIONS(3490),
    [anon_sym_alignof] = ACTIONS(3490),
    [anon_sym__Alignof] = ACTIONS(3490),
    [anon_sym_offsetof] = ACTIONS(3490),
    [anon_sym__Generic] = ACTIONS(3490),
    [anon_sym_asm] = ACTIONS(3490),
    [anon_sym___asm__] = ACTIONS(3490),
    [anon_sym___asm] = ACTIONS(3490),
    [sym_number_literal] = ACTIONS(3492),
    [anon_sym_L_SQUOTE] = ACTIONS(3492),
    [anon_sym_u_SQUOTE] = ACTIONS(3492),
    [anon_sym_U_SQUOTE] = ACTIONS(3492),
    [anon_sym_u8_SQUOTE] = ACTIONS(3492),
    [anon_sym_SQUOTE] = ACTIONS(3492),
    [anon_sym_L_DQUOTE] = ACTIONS(3492),
    [anon_sym_u_DQUOTE] = ACTIONS(3492),
    [anon_sym_U_DQUOTE] = ACTIONS(3492),
    [anon_sym_u8_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE] = ACTIONS(3492),
    [sym_true] = ACTIONS(3490),
    [sym_false] = ACTIONS(3490),
    [anon_sym_NULL] = ACTIONS(3490),
    [anon_sym_nullptr] = ACTIONS(3490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3490),
    [anon_sym_let] = ACTIONS(3490),
    [anon_sym_This] = ACTIONS(3490),
    [anon_sym_decltype] = ACTIONS(3490),
    [anon_sym_explicit] = ACTIONS(3490),
    [anon_sym_typename] = ACTIONS(3490),
    [anon_sym_template] = ACTIONS(3490),
    [anon_sym_operator] = ACTIONS(3490),
    [anon_sym_try] = ACTIONS(3490),
    [anon_sym_delete] = ACTIONS(3490),
    [anon_sym_throw] = ACTIONS(3490),
    [anon_sym_namespace] = ACTIONS(3490),
    [anon_sym_static_assert] = ACTIONS(3490),
    [anon_sym_concept] = ACTIONS(3490),
    [anon_sym_co_return] = ACTIONS(3490),
    [anon_sym_co_yield] = ACTIONS(3490),
    [anon_sym_R_DQUOTE] = ACTIONS(3492),
    [anon_sym_LR_DQUOTE] = ACTIONS(3492),
    [anon_sym_uR_DQUOTE] = ACTIONS(3492),
    [anon_sym_UR_DQUOTE] = ACTIONS(3492),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3492),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3490),
    [anon_sym_requires] = ACTIONS(3490),
    [sym_this] = ACTIONS(3490),
    [anon_sym_discard] = ACTIONS(3490),
    [anon_sym_precise] = ACTIONS(3490),
    [anon_sym_shared] = ACTIONS(3490),
    [anon_sym_groupshared] = ACTIONS(3490),
    [anon_sym_uniform] = ACTIONS(3490),
    [anon_sym_row_major] = ACTIONS(3490),
    [anon_sym_column_major] = ACTIONS(3490),
    [anon_sym_globallycoherent] = ACTIONS(3490),
    [anon_sym_centroid] = ACTIONS(3490),
    [anon_sym_noperspective] = ACTIONS(3490),
    [anon_sym_nointerpolation] = ACTIONS(3490),
    [anon_sym_sample] = ACTIONS(3490),
    [anon_sym_linear] = ACTIONS(3490),
    [anon_sym_snorm] = ACTIONS(3490),
    [anon_sym_unorm] = ACTIONS(3490),
    [anon_sym_point] = ACTIONS(3490),
    [anon_sym_line] = ACTIONS(3490),
    [anon_sym_triangleadj] = ACTIONS(3490),
    [anon_sym_lineadj] = ACTIONS(3490),
    [anon_sym_triangle] = ACTIONS(3490),
    [anon_sym_cbuffer] = ACTIONS(3490),
    [anon_sym_interface] = ACTIONS(3490),
    [anon_sym_extension] = ACTIONS(3490),
  },
  [849] = {
    [sym_identifier] = ACTIONS(3421),
    [aux_sym_preproc_include_token1] = ACTIONS(3421),
    [aux_sym_preproc_def_token1] = ACTIONS(3421),
    [aux_sym_preproc_if_token1] = ACTIONS(3421),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3421),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3421),
    [sym_preproc_directive] = ACTIONS(3421),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_BANG] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_SEMI] = ACTIONS(3419),
    [anon_sym___extension__] = ACTIONS(3421),
    [anon_sym_typedef] = ACTIONS(3421),
    [anon_sym_in] = ACTIONS(3421),
    [anon_sym_out] = ACTIONS(3421),
    [anon_sym_inout] = ACTIONS(3421),
    [anon_sym_virtual] = ACTIONS(3421),
    [anon_sym_extern] = ACTIONS(3421),
    [anon_sym___attribute__] = ACTIONS(3421),
    [anon_sym___attribute] = ACTIONS(3421),
    [anon_sym_using] = ACTIONS(3421),
    [anon_sym_COLON_COLON] = ACTIONS(3419),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3419),
    [anon_sym___declspec] = ACTIONS(3421),
    [anon_sym___based] = ACTIONS(3421),
    [anon_sym___cdecl] = ACTIONS(3421),
    [anon_sym___clrcall] = ACTIONS(3421),
    [anon_sym___stdcall] = ACTIONS(3421),
    [anon_sym___fastcall] = ACTIONS(3421),
    [anon_sym___thiscall] = ACTIONS(3421),
    [anon_sym___vectorcall] = ACTIONS(3421),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_RBRACE] = ACTIONS(3419),
    [anon_sym_signed] = ACTIONS(3421),
    [anon_sym_unsigned] = ACTIONS(3421),
    [anon_sym_long] = ACTIONS(3421),
    [anon_sym_short] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3421),
    [anon_sym_static] = ACTIONS(3421),
    [anon_sym_register] = ACTIONS(3421),
    [anon_sym_inline] = ACTIONS(3421),
    [anon_sym___inline] = ACTIONS(3421),
    [anon_sym___inline__] = ACTIONS(3421),
    [anon_sym___forceinline] = ACTIONS(3421),
    [anon_sym_thread_local] = ACTIONS(3421),
    [anon_sym___thread] = ACTIONS(3421),
    [anon_sym_const] = ACTIONS(3421),
    [anon_sym_constexpr] = ACTIONS(3421),
    [anon_sym_volatile] = ACTIONS(3421),
    [anon_sym_restrict] = ACTIONS(3421),
    [anon_sym___restrict__] = ACTIONS(3421),
    [anon_sym__Atomic] = ACTIONS(3421),
    [anon_sym__Noreturn] = ACTIONS(3421),
    [anon_sym_noreturn] = ACTIONS(3421),
    [anon_sym__Nonnull] = ACTIONS(3421),
    [anon_sym_mutable] = ACTIONS(3421),
    [anon_sym_constinit] = ACTIONS(3421),
    [anon_sym_consteval] = ACTIONS(3421),
    [anon_sym_alignas] = ACTIONS(3421),
    [anon_sym__Alignas] = ACTIONS(3421),
    [sym_primitive_type] = ACTIONS(3421),
    [anon_sym_enum] = ACTIONS(3421),
    [anon_sym_class] = ACTIONS(3421),
    [anon_sym_struct] = ACTIONS(3421),
    [anon_sym_union] = ACTIONS(3421),
    [anon_sym_if] = ACTIONS(3421),
    [anon_sym_else] = ACTIONS(3421),
    [anon_sym_switch] = ACTIONS(3421),
    [anon_sym_case] = ACTIONS(3421),
    [anon_sym_default] = ACTIONS(3421),
    [anon_sym_while] = ACTIONS(3421),
    [anon_sym_do] = ACTIONS(3421),
    [anon_sym_for] = ACTIONS(3421),
    [anon_sym_return] = ACTIONS(3421),
    [anon_sym_break] = ACTIONS(3421),
    [anon_sym_continue] = ACTIONS(3421),
    [anon_sym_goto] = ACTIONS(3421),
    [anon_sym___try] = ACTIONS(3421),
    [anon_sym___leave] = ACTIONS(3421),
    [anon_sym_not] = ACTIONS(3421),
    [anon_sym_compl] = ACTIONS(3421),
    [anon_sym_DASH_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_PLUS] = ACTIONS(3419),
    [anon_sym_sizeof] = ACTIONS(3421),
    [anon_sym___alignof__] = ACTIONS(3421),
    [anon_sym___alignof] = ACTIONS(3421),
    [anon_sym__alignof] = ACTIONS(3421),
    [anon_sym_alignof] = ACTIONS(3421),
    [anon_sym__Alignof] = ACTIONS(3421),
    [anon_sym_offsetof] = ACTIONS(3421),
    [anon_sym__Generic] = ACTIONS(3421),
    [anon_sym_asm] = ACTIONS(3421),
    [anon_sym___asm__] = ACTIONS(3421),
    [anon_sym___asm] = ACTIONS(3421),
    [sym_number_literal] = ACTIONS(3419),
    [anon_sym_L_SQUOTE] = ACTIONS(3419),
    [anon_sym_u_SQUOTE] = ACTIONS(3419),
    [anon_sym_U_SQUOTE] = ACTIONS(3419),
    [anon_sym_u8_SQUOTE] = ACTIONS(3419),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym_L_DQUOTE] = ACTIONS(3419),
    [anon_sym_u_DQUOTE] = ACTIONS(3419),
    [anon_sym_U_DQUOTE] = ACTIONS(3419),
    [anon_sym_u8_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [sym_true] = ACTIONS(3421),
    [sym_false] = ACTIONS(3421),
    [anon_sym_NULL] = ACTIONS(3421),
    [anon_sym_nullptr] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3421),
    [anon_sym_let] = ACTIONS(3421),
    [anon_sym_This] = ACTIONS(3421),
    [anon_sym_decltype] = ACTIONS(3421),
    [anon_sym_explicit] = ACTIONS(3421),
    [anon_sym_typename] = ACTIONS(3421),
    [anon_sym_template] = ACTIONS(3421),
    [anon_sym_operator] = ACTIONS(3421),
    [anon_sym_try] = ACTIONS(3421),
    [anon_sym_delete] = ACTIONS(3421),
    [anon_sym_throw] = ACTIONS(3421),
    [anon_sym_namespace] = ACTIONS(3421),
    [anon_sym_static_assert] = ACTIONS(3421),
    [anon_sym_concept] = ACTIONS(3421),
    [anon_sym_co_return] = ACTIONS(3421),
    [anon_sym_co_yield] = ACTIONS(3421),
    [anon_sym_R_DQUOTE] = ACTIONS(3419),
    [anon_sym_LR_DQUOTE] = ACTIONS(3419),
    [anon_sym_uR_DQUOTE] = ACTIONS(3419),
    [anon_sym_UR_DQUOTE] = ACTIONS(3419),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3419),
    [anon_sym_co_await] = ACTIONS(3421),
    [anon_sym_new] = ACTIONS(3421),
    [anon_sym_requires] = ACTIONS(3421),
    [sym_this] = ACTIONS(3421),
    [anon_sym_discard] = ACTIONS(3421),
    [anon_sym_precise] = ACTIONS(3421),
    [anon_sym_shared] = ACTIONS(3421),
    [anon_sym_groupshared] = ACTIONS(3421),
    [anon_sym_uniform] = ACTIONS(3421),
    [anon_sym_row_major] = ACTIONS(3421),
    [anon_sym_column_major] = ACTIONS(3421),
    [anon_sym_globallycoherent] = ACTIONS(3421),
    [anon_sym_centroid] = ACTIONS(3421),
    [anon_sym_noperspective] = ACTIONS(3421),
    [anon_sym_nointerpolation] = ACTIONS(3421),
    [anon_sym_sample] = ACTIONS(3421),
    [anon_sym_linear] = ACTIONS(3421),
    [anon_sym_snorm] = ACTIONS(3421),
    [anon_sym_unorm] = ACTIONS(3421),
    [anon_sym_point] = ACTIONS(3421),
    [anon_sym_line] = ACTIONS(3421),
    [anon_sym_triangleadj] = ACTIONS(3421),
    [anon_sym_lineadj] = ACTIONS(3421),
    [anon_sym_triangle] = ACTIONS(3421),
    [anon_sym_cbuffer] = ACTIONS(3421),
    [anon_sym_interface] = ACTIONS(3421),
    [anon_sym_extension] = ACTIONS(3421),
  },
  [850] = {
    [sym_identifier] = ACTIONS(3456),
    [aux_sym_preproc_include_token1] = ACTIONS(3456),
    [aux_sym_preproc_def_token1] = ACTIONS(3456),
    [aux_sym_preproc_if_token1] = ACTIONS(3456),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3456),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3456),
    [sym_preproc_directive] = ACTIONS(3456),
    [anon_sym_LPAREN2] = ACTIONS(3454),
    [anon_sym_BANG] = ACTIONS(3454),
    [anon_sym_TILDE] = ACTIONS(3454),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3454),
    [anon_sym_AMP_AMP] = ACTIONS(3454),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_SEMI] = ACTIONS(3454),
    [anon_sym___extension__] = ACTIONS(3456),
    [anon_sym_typedef] = ACTIONS(3456),
    [anon_sym_in] = ACTIONS(3456),
    [anon_sym_out] = ACTIONS(3456),
    [anon_sym_inout] = ACTIONS(3456),
    [anon_sym_virtual] = ACTIONS(3456),
    [anon_sym_extern] = ACTIONS(3456),
    [anon_sym___attribute__] = ACTIONS(3456),
    [anon_sym___attribute] = ACTIONS(3456),
    [anon_sym_using] = ACTIONS(3456),
    [anon_sym_COLON_COLON] = ACTIONS(3454),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3454),
    [anon_sym___declspec] = ACTIONS(3456),
    [anon_sym___based] = ACTIONS(3456),
    [anon_sym___cdecl] = ACTIONS(3456),
    [anon_sym___clrcall] = ACTIONS(3456),
    [anon_sym___stdcall] = ACTIONS(3456),
    [anon_sym___fastcall] = ACTIONS(3456),
    [anon_sym___thiscall] = ACTIONS(3456),
    [anon_sym___vectorcall] = ACTIONS(3456),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_RBRACE] = ACTIONS(3454),
    [anon_sym_signed] = ACTIONS(3456),
    [anon_sym_unsigned] = ACTIONS(3456),
    [anon_sym_long] = ACTIONS(3456),
    [anon_sym_short] = ACTIONS(3456),
    [anon_sym_LBRACK] = ACTIONS(3456),
    [anon_sym_static] = ACTIONS(3456),
    [anon_sym_register] = ACTIONS(3456),
    [anon_sym_inline] = ACTIONS(3456),
    [anon_sym___inline] = ACTIONS(3456),
    [anon_sym___inline__] = ACTIONS(3456),
    [anon_sym___forceinline] = ACTIONS(3456),
    [anon_sym_thread_local] = ACTIONS(3456),
    [anon_sym___thread] = ACTIONS(3456),
    [anon_sym_const] = ACTIONS(3456),
    [anon_sym_constexpr] = ACTIONS(3456),
    [anon_sym_volatile] = ACTIONS(3456),
    [anon_sym_restrict] = ACTIONS(3456),
    [anon_sym___restrict__] = ACTIONS(3456),
    [anon_sym__Atomic] = ACTIONS(3456),
    [anon_sym__Noreturn] = ACTIONS(3456),
    [anon_sym_noreturn] = ACTIONS(3456),
    [anon_sym__Nonnull] = ACTIONS(3456),
    [anon_sym_mutable] = ACTIONS(3456),
    [anon_sym_constinit] = ACTIONS(3456),
    [anon_sym_consteval] = ACTIONS(3456),
    [anon_sym_alignas] = ACTIONS(3456),
    [anon_sym__Alignas] = ACTIONS(3456),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_enum] = ACTIONS(3456),
    [anon_sym_class] = ACTIONS(3456),
    [anon_sym_struct] = ACTIONS(3456),
    [anon_sym_union] = ACTIONS(3456),
    [anon_sym_if] = ACTIONS(3456),
    [anon_sym_else] = ACTIONS(3456),
    [anon_sym_switch] = ACTIONS(3456),
    [anon_sym_case] = ACTIONS(3456),
    [anon_sym_default] = ACTIONS(3456),
    [anon_sym_while] = ACTIONS(3456),
    [anon_sym_do] = ACTIONS(3456),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_return] = ACTIONS(3456),
    [anon_sym_break] = ACTIONS(3456),
    [anon_sym_continue] = ACTIONS(3456),
    [anon_sym_goto] = ACTIONS(3456),
    [anon_sym___try] = ACTIONS(3456),
    [anon_sym___leave] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(3456),
    [anon_sym_compl] = ACTIONS(3456),
    [anon_sym_DASH_DASH] = ACTIONS(3454),
    [anon_sym_PLUS_PLUS] = ACTIONS(3454),
    [anon_sym_sizeof] = ACTIONS(3456),
    [anon_sym___alignof__] = ACTIONS(3456),
    [anon_sym___alignof] = ACTIONS(3456),
    [anon_sym__alignof] = ACTIONS(3456),
    [anon_sym_alignof] = ACTIONS(3456),
    [anon_sym__Alignof] = ACTIONS(3456),
    [anon_sym_offsetof] = ACTIONS(3456),
    [anon_sym__Generic] = ACTIONS(3456),
    [anon_sym_asm] = ACTIONS(3456),
    [anon_sym___asm__] = ACTIONS(3456),
    [anon_sym___asm] = ACTIONS(3456),
    [sym_number_literal] = ACTIONS(3454),
    [anon_sym_L_SQUOTE] = ACTIONS(3454),
    [anon_sym_u_SQUOTE] = ACTIONS(3454),
    [anon_sym_U_SQUOTE] = ACTIONS(3454),
    [anon_sym_u8_SQUOTE] = ACTIONS(3454),
    [anon_sym_SQUOTE] = ACTIONS(3454),
    [anon_sym_L_DQUOTE] = ACTIONS(3454),
    [anon_sym_u_DQUOTE] = ACTIONS(3454),
    [anon_sym_U_DQUOTE] = ACTIONS(3454),
    [anon_sym_u8_DQUOTE] = ACTIONS(3454),
    [anon_sym_DQUOTE] = ACTIONS(3454),
    [sym_true] = ACTIONS(3456),
    [sym_false] = ACTIONS(3456),
    [anon_sym_NULL] = ACTIONS(3456),
    [anon_sym_nullptr] = ACTIONS(3456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3456),
    [anon_sym_let] = ACTIONS(3456),
    [anon_sym_This] = ACTIONS(3456),
    [anon_sym_decltype] = ACTIONS(3456),
    [anon_sym_explicit] = ACTIONS(3456),
    [anon_sym_typename] = ACTIONS(3456),
    [anon_sym_template] = ACTIONS(3456),
    [anon_sym_operator] = ACTIONS(3456),
    [anon_sym_try] = ACTIONS(3456),
    [anon_sym_delete] = ACTIONS(3456),
    [anon_sym_throw] = ACTIONS(3456),
    [anon_sym_namespace] = ACTIONS(3456),
    [anon_sym_static_assert] = ACTIONS(3456),
    [anon_sym_concept] = ACTIONS(3456),
    [anon_sym_co_return] = ACTIONS(3456),
    [anon_sym_co_yield] = ACTIONS(3456),
    [anon_sym_R_DQUOTE] = ACTIONS(3454),
    [anon_sym_LR_DQUOTE] = ACTIONS(3454),
    [anon_sym_uR_DQUOTE] = ACTIONS(3454),
    [anon_sym_UR_DQUOTE] = ACTIONS(3454),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3454),
    [anon_sym_co_await] = ACTIONS(3456),
    [anon_sym_new] = ACTIONS(3456),
    [anon_sym_requires] = ACTIONS(3456),
    [sym_this] = ACTIONS(3456),
    [anon_sym_discard] = ACTIONS(3456),
    [anon_sym_precise] = ACTIONS(3456),
    [anon_sym_shared] = ACTIONS(3456),
    [anon_sym_groupshared] = ACTIONS(3456),
    [anon_sym_uniform] = ACTIONS(3456),
    [anon_sym_row_major] = ACTIONS(3456),
    [anon_sym_column_major] = ACTIONS(3456),
    [anon_sym_globallycoherent] = ACTIONS(3456),
    [anon_sym_centroid] = ACTIONS(3456),
    [anon_sym_noperspective] = ACTIONS(3456),
    [anon_sym_nointerpolation] = ACTIONS(3456),
    [anon_sym_sample] = ACTIONS(3456),
    [anon_sym_linear] = ACTIONS(3456),
    [anon_sym_snorm] = ACTIONS(3456),
    [anon_sym_unorm] = ACTIONS(3456),
    [anon_sym_point] = ACTIONS(3456),
    [anon_sym_line] = ACTIONS(3456),
    [anon_sym_triangleadj] = ACTIONS(3456),
    [anon_sym_lineadj] = ACTIONS(3456),
    [anon_sym_triangle] = ACTIONS(3456),
    [anon_sym_cbuffer] = ACTIONS(3456),
    [anon_sym_interface] = ACTIONS(3456),
    [anon_sym_extension] = ACTIONS(3456),
  },
  [851] = {
    [sym_identifier] = ACTIONS(3558),
    [aux_sym_preproc_include_token1] = ACTIONS(3558),
    [aux_sym_preproc_def_token1] = ACTIONS(3558),
    [aux_sym_preproc_if_token1] = ACTIONS(3558),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3558),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3558),
    [sym_preproc_directive] = ACTIONS(3558),
    [anon_sym_LPAREN2] = ACTIONS(3556),
    [anon_sym_BANG] = ACTIONS(3556),
    [anon_sym_TILDE] = ACTIONS(3556),
    [anon_sym_DASH] = ACTIONS(3558),
    [anon_sym_PLUS] = ACTIONS(3558),
    [anon_sym_STAR] = ACTIONS(3556),
    [anon_sym_AMP_AMP] = ACTIONS(3556),
    [anon_sym_AMP] = ACTIONS(3558),
    [anon_sym_SEMI] = ACTIONS(3556),
    [anon_sym___extension__] = ACTIONS(3558),
    [anon_sym_typedef] = ACTIONS(3558),
    [anon_sym_in] = ACTIONS(3558),
    [anon_sym_out] = ACTIONS(3558),
    [anon_sym_inout] = ACTIONS(3558),
    [anon_sym_virtual] = ACTIONS(3558),
    [anon_sym_extern] = ACTIONS(3558),
    [anon_sym___attribute__] = ACTIONS(3558),
    [anon_sym___attribute] = ACTIONS(3558),
    [anon_sym_using] = ACTIONS(3558),
    [anon_sym_COLON_COLON] = ACTIONS(3556),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3556),
    [anon_sym___declspec] = ACTIONS(3558),
    [anon_sym___based] = ACTIONS(3558),
    [anon_sym___cdecl] = ACTIONS(3558),
    [anon_sym___clrcall] = ACTIONS(3558),
    [anon_sym___stdcall] = ACTIONS(3558),
    [anon_sym___fastcall] = ACTIONS(3558),
    [anon_sym___thiscall] = ACTIONS(3558),
    [anon_sym___vectorcall] = ACTIONS(3558),
    [anon_sym_LBRACE] = ACTIONS(3556),
    [anon_sym_RBRACE] = ACTIONS(3556),
    [anon_sym_signed] = ACTIONS(3558),
    [anon_sym_unsigned] = ACTIONS(3558),
    [anon_sym_long] = ACTIONS(3558),
    [anon_sym_short] = ACTIONS(3558),
    [anon_sym_LBRACK] = ACTIONS(3558),
    [anon_sym_static] = ACTIONS(3558),
    [anon_sym_register] = ACTIONS(3558),
    [anon_sym_inline] = ACTIONS(3558),
    [anon_sym___inline] = ACTIONS(3558),
    [anon_sym___inline__] = ACTIONS(3558),
    [anon_sym___forceinline] = ACTIONS(3558),
    [anon_sym_thread_local] = ACTIONS(3558),
    [anon_sym___thread] = ACTIONS(3558),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_constexpr] = ACTIONS(3558),
    [anon_sym_volatile] = ACTIONS(3558),
    [anon_sym_restrict] = ACTIONS(3558),
    [anon_sym___restrict__] = ACTIONS(3558),
    [anon_sym__Atomic] = ACTIONS(3558),
    [anon_sym__Noreturn] = ACTIONS(3558),
    [anon_sym_noreturn] = ACTIONS(3558),
    [anon_sym__Nonnull] = ACTIONS(3558),
    [anon_sym_mutable] = ACTIONS(3558),
    [anon_sym_constinit] = ACTIONS(3558),
    [anon_sym_consteval] = ACTIONS(3558),
    [anon_sym_alignas] = ACTIONS(3558),
    [anon_sym__Alignas] = ACTIONS(3558),
    [sym_primitive_type] = ACTIONS(3558),
    [anon_sym_enum] = ACTIONS(3558),
    [anon_sym_class] = ACTIONS(3558),
    [anon_sym_struct] = ACTIONS(3558),
    [anon_sym_union] = ACTIONS(3558),
    [anon_sym_if] = ACTIONS(3558),
    [anon_sym_else] = ACTIONS(3558),
    [anon_sym_switch] = ACTIONS(3558),
    [anon_sym_case] = ACTIONS(3558),
    [anon_sym_default] = ACTIONS(3558),
    [anon_sym_while] = ACTIONS(3558),
    [anon_sym_do] = ACTIONS(3558),
    [anon_sym_for] = ACTIONS(3558),
    [anon_sym_return] = ACTIONS(3558),
    [anon_sym_break] = ACTIONS(3558),
    [anon_sym_continue] = ACTIONS(3558),
    [anon_sym_goto] = ACTIONS(3558),
    [anon_sym___try] = ACTIONS(3558),
    [anon_sym___leave] = ACTIONS(3558),
    [anon_sym_not] = ACTIONS(3558),
    [anon_sym_compl] = ACTIONS(3558),
    [anon_sym_DASH_DASH] = ACTIONS(3556),
    [anon_sym_PLUS_PLUS] = ACTIONS(3556),
    [anon_sym_sizeof] = ACTIONS(3558),
    [anon_sym___alignof__] = ACTIONS(3558),
    [anon_sym___alignof] = ACTIONS(3558),
    [anon_sym__alignof] = ACTIONS(3558),
    [anon_sym_alignof] = ACTIONS(3558),
    [anon_sym__Alignof] = ACTIONS(3558),
    [anon_sym_offsetof] = ACTIONS(3558),
    [anon_sym__Generic] = ACTIONS(3558),
    [anon_sym_asm] = ACTIONS(3558),
    [anon_sym___asm__] = ACTIONS(3558),
    [anon_sym___asm] = ACTIONS(3558),
    [sym_number_literal] = ACTIONS(3556),
    [anon_sym_L_SQUOTE] = ACTIONS(3556),
    [anon_sym_u_SQUOTE] = ACTIONS(3556),
    [anon_sym_U_SQUOTE] = ACTIONS(3556),
    [anon_sym_u8_SQUOTE] = ACTIONS(3556),
    [anon_sym_SQUOTE] = ACTIONS(3556),
    [anon_sym_L_DQUOTE] = ACTIONS(3556),
    [anon_sym_u_DQUOTE] = ACTIONS(3556),
    [anon_sym_U_DQUOTE] = ACTIONS(3556),
    [anon_sym_u8_DQUOTE] = ACTIONS(3556),
    [anon_sym_DQUOTE] = ACTIONS(3556),
    [sym_true] = ACTIONS(3558),
    [sym_false] = ACTIONS(3558),
    [anon_sym_NULL] = ACTIONS(3558),
    [anon_sym_nullptr] = ACTIONS(3558),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3558),
    [anon_sym_let] = ACTIONS(3558),
    [anon_sym_This] = ACTIONS(3558),
    [anon_sym_decltype] = ACTIONS(3558),
    [anon_sym_explicit] = ACTIONS(3558),
    [anon_sym_typename] = ACTIONS(3558),
    [anon_sym_template] = ACTIONS(3558),
    [anon_sym_operator] = ACTIONS(3558),
    [anon_sym_try] = ACTIONS(3558),
    [anon_sym_delete] = ACTIONS(3558),
    [anon_sym_throw] = ACTIONS(3558),
    [anon_sym_namespace] = ACTIONS(3558),
    [anon_sym_static_assert] = ACTIONS(3558),
    [anon_sym_concept] = ACTIONS(3558),
    [anon_sym_co_return] = ACTIONS(3558),
    [anon_sym_co_yield] = ACTIONS(3558),
    [anon_sym_R_DQUOTE] = ACTIONS(3556),
    [anon_sym_LR_DQUOTE] = ACTIONS(3556),
    [anon_sym_uR_DQUOTE] = ACTIONS(3556),
    [anon_sym_UR_DQUOTE] = ACTIONS(3556),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3556),
    [anon_sym_co_await] = ACTIONS(3558),
    [anon_sym_new] = ACTIONS(3558),
    [anon_sym_requires] = ACTIONS(3558),
    [sym_this] = ACTIONS(3558),
    [anon_sym_discard] = ACTIONS(3558),
    [anon_sym_precise] = ACTIONS(3558),
    [anon_sym_shared] = ACTIONS(3558),
    [anon_sym_groupshared] = ACTIONS(3558),
    [anon_sym_uniform] = ACTIONS(3558),
    [anon_sym_row_major] = ACTIONS(3558),
    [anon_sym_column_major] = ACTIONS(3558),
    [anon_sym_globallycoherent] = ACTIONS(3558),
    [anon_sym_centroid] = ACTIONS(3558),
    [anon_sym_noperspective] = ACTIONS(3558),
    [anon_sym_nointerpolation] = ACTIONS(3558),
    [anon_sym_sample] = ACTIONS(3558),
    [anon_sym_linear] = ACTIONS(3558),
    [anon_sym_snorm] = ACTIONS(3558),
    [anon_sym_unorm] = ACTIONS(3558),
    [anon_sym_point] = ACTIONS(3558),
    [anon_sym_line] = ACTIONS(3558),
    [anon_sym_triangleadj] = ACTIONS(3558),
    [anon_sym_lineadj] = ACTIONS(3558),
    [anon_sym_triangle] = ACTIONS(3558),
    [anon_sym_cbuffer] = ACTIONS(3558),
    [anon_sym_interface] = ACTIONS(3558),
    [anon_sym_extension] = ACTIONS(3558),
  },
  [852] = {
    [sym_identifier] = ACTIONS(3462),
    [aux_sym_preproc_include_token1] = ACTIONS(3462),
    [aux_sym_preproc_def_token1] = ACTIONS(3462),
    [aux_sym_preproc_if_token1] = ACTIONS(3462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3462),
    [sym_preproc_directive] = ACTIONS(3462),
    [anon_sym_LPAREN2] = ACTIONS(3464),
    [anon_sym_BANG] = ACTIONS(3464),
    [anon_sym_TILDE] = ACTIONS(3464),
    [anon_sym_DASH] = ACTIONS(3462),
    [anon_sym_PLUS] = ACTIONS(3462),
    [anon_sym_STAR] = ACTIONS(3464),
    [anon_sym_AMP_AMP] = ACTIONS(3464),
    [anon_sym_AMP] = ACTIONS(3462),
    [anon_sym_SEMI] = ACTIONS(3464),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_typedef] = ACTIONS(3462),
    [anon_sym_in] = ACTIONS(3462),
    [anon_sym_out] = ACTIONS(3462),
    [anon_sym_inout] = ACTIONS(3462),
    [anon_sym_virtual] = ACTIONS(3462),
    [anon_sym_extern] = ACTIONS(3462),
    [anon_sym___attribute__] = ACTIONS(3462),
    [anon_sym___attribute] = ACTIONS(3462),
    [anon_sym_using] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3464),
    [anon_sym___declspec] = ACTIONS(3462),
    [anon_sym___based] = ACTIONS(3462),
    [anon_sym___cdecl] = ACTIONS(3462),
    [anon_sym___clrcall] = ACTIONS(3462),
    [anon_sym___stdcall] = ACTIONS(3462),
    [anon_sym___fastcall] = ACTIONS(3462),
    [anon_sym___thiscall] = ACTIONS(3462),
    [anon_sym___vectorcall] = ACTIONS(3462),
    [anon_sym_LBRACE] = ACTIONS(3464),
    [anon_sym_RBRACE] = ACTIONS(3464),
    [anon_sym_signed] = ACTIONS(3462),
    [anon_sym_unsigned] = ACTIONS(3462),
    [anon_sym_long] = ACTIONS(3462),
    [anon_sym_short] = ACTIONS(3462),
    [anon_sym_LBRACK] = ACTIONS(3462),
    [anon_sym_static] = ACTIONS(3462),
    [anon_sym_register] = ACTIONS(3462),
    [anon_sym_inline] = ACTIONS(3462),
    [anon_sym___inline] = ACTIONS(3462),
    [anon_sym___inline__] = ACTIONS(3462),
    [anon_sym___forceinline] = ACTIONS(3462),
    [anon_sym_thread_local] = ACTIONS(3462),
    [anon_sym___thread] = ACTIONS(3462),
    [anon_sym_const] = ACTIONS(3462),
    [anon_sym_constexpr] = ACTIONS(3462),
    [anon_sym_volatile] = ACTIONS(3462),
    [anon_sym_restrict] = ACTIONS(3462),
    [anon_sym___restrict__] = ACTIONS(3462),
    [anon_sym__Atomic] = ACTIONS(3462),
    [anon_sym__Noreturn] = ACTIONS(3462),
    [anon_sym_noreturn] = ACTIONS(3462),
    [anon_sym__Nonnull] = ACTIONS(3462),
    [anon_sym_mutable] = ACTIONS(3462),
    [anon_sym_constinit] = ACTIONS(3462),
    [anon_sym_consteval] = ACTIONS(3462),
    [anon_sym_alignas] = ACTIONS(3462),
    [anon_sym__Alignas] = ACTIONS(3462),
    [sym_primitive_type] = ACTIONS(3462),
    [anon_sym_enum] = ACTIONS(3462),
    [anon_sym_class] = ACTIONS(3462),
    [anon_sym_struct] = ACTIONS(3462),
    [anon_sym_union] = ACTIONS(3462),
    [anon_sym_if] = ACTIONS(3462),
    [anon_sym_else] = ACTIONS(3462),
    [anon_sym_switch] = ACTIONS(3462),
    [anon_sym_case] = ACTIONS(3462),
    [anon_sym_default] = ACTIONS(3462),
    [anon_sym_while] = ACTIONS(3462),
    [anon_sym_do] = ACTIONS(3462),
    [anon_sym_for] = ACTIONS(3462),
    [anon_sym_return] = ACTIONS(3462),
    [anon_sym_break] = ACTIONS(3462),
    [anon_sym_continue] = ACTIONS(3462),
    [anon_sym_goto] = ACTIONS(3462),
    [anon_sym___try] = ACTIONS(3462),
    [anon_sym___leave] = ACTIONS(3462),
    [anon_sym_not] = ACTIONS(3462),
    [anon_sym_compl] = ACTIONS(3462),
    [anon_sym_DASH_DASH] = ACTIONS(3464),
    [anon_sym_PLUS_PLUS] = ACTIONS(3464),
    [anon_sym_sizeof] = ACTIONS(3462),
    [anon_sym___alignof__] = ACTIONS(3462),
    [anon_sym___alignof] = ACTIONS(3462),
    [anon_sym__alignof] = ACTIONS(3462),
    [anon_sym_alignof] = ACTIONS(3462),
    [anon_sym__Alignof] = ACTIONS(3462),
    [anon_sym_offsetof] = ACTIONS(3462),
    [anon_sym__Generic] = ACTIONS(3462),
    [anon_sym_asm] = ACTIONS(3462),
    [anon_sym___asm__] = ACTIONS(3462),
    [anon_sym___asm] = ACTIONS(3462),
    [sym_number_literal] = ACTIONS(3464),
    [anon_sym_L_SQUOTE] = ACTIONS(3464),
    [anon_sym_u_SQUOTE] = ACTIONS(3464),
    [anon_sym_U_SQUOTE] = ACTIONS(3464),
    [anon_sym_u8_SQUOTE] = ACTIONS(3464),
    [anon_sym_SQUOTE] = ACTIONS(3464),
    [anon_sym_L_DQUOTE] = ACTIONS(3464),
    [anon_sym_u_DQUOTE] = ACTIONS(3464),
    [anon_sym_U_DQUOTE] = ACTIONS(3464),
    [anon_sym_u8_DQUOTE] = ACTIONS(3464),
    [anon_sym_DQUOTE] = ACTIONS(3464),
    [sym_true] = ACTIONS(3462),
    [sym_false] = ACTIONS(3462),
    [anon_sym_NULL] = ACTIONS(3462),
    [anon_sym_nullptr] = ACTIONS(3462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3462),
    [anon_sym_let] = ACTIONS(3462),
    [anon_sym_This] = ACTIONS(3462),
    [anon_sym_decltype] = ACTIONS(3462),
    [anon_sym_explicit] = ACTIONS(3462),
    [anon_sym_typename] = ACTIONS(3462),
    [anon_sym_template] = ACTIONS(3462),
    [anon_sym_operator] = ACTIONS(3462),
    [anon_sym_try] = ACTIONS(3462),
    [anon_sym_delete] = ACTIONS(3462),
    [anon_sym_throw] = ACTIONS(3462),
    [anon_sym_namespace] = ACTIONS(3462),
    [anon_sym_static_assert] = ACTIONS(3462),
    [anon_sym_concept] = ACTIONS(3462),
    [anon_sym_co_return] = ACTIONS(3462),
    [anon_sym_co_yield] = ACTIONS(3462),
    [anon_sym_R_DQUOTE] = ACTIONS(3464),
    [anon_sym_LR_DQUOTE] = ACTIONS(3464),
    [anon_sym_uR_DQUOTE] = ACTIONS(3464),
    [anon_sym_UR_DQUOTE] = ACTIONS(3464),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3464),
    [anon_sym_co_await] = ACTIONS(3462),
    [anon_sym_new] = ACTIONS(3462),
    [anon_sym_requires] = ACTIONS(3462),
    [sym_this] = ACTIONS(3462),
    [anon_sym_discard] = ACTIONS(3462),
    [anon_sym_precise] = ACTIONS(3462),
    [anon_sym_shared] = ACTIONS(3462),
    [anon_sym_groupshared] = ACTIONS(3462),
    [anon_sym_uniform] = ACTIONS(3462),
    [anon_sym_row_major] = ACTIONS(3462),
    [anon_sym_column_major] = ACTIONS(3462),
    [anon_sym_globallycoherent] = ACTIONS(3462),
    [anon_sym_centroid] = ACTIONS(3462),
    [anon_sym_noperspective] = ACTIONS(3462),
    [anon_sym_nointerpolation] = ACTIONS(3462),
    [anon_sym_sample] = ACTIONS(3462),
    [anon_sym_linear] = ACTIONS(3462),
    [anon_sym_snorm] = ACTIONS(3462),
    [anon_sym_unorm] = ACTIONS(3462),
    [anon_sym_point] = ACTIONS(3462),
    [anon_sym_line] = ACTIONS(3462),
    [anon_sym_triangleadj] = ACTIONS(3462),
    [anon_sym_lineadj] = ACTIONS(3462),
    [anon_sym_triangle] = ACTIONS(3462),
    [anon_sym_cbuffer] = ACTIONS(3462),
    [anon_sym_interface] = ACTIONS(3462),
    [anon_sym_extension] = ACTIONS(3462),
  },
  [853] = {
    [sym_identifier] = ACTIONS(3466),
    [aux_sym_preproc_include_token1] = ACTIONS(3466),
    [aux_sym_preproc_def_token1] = ACTIONS(3466),
    [aux_sym_preproc_if_token1] = ACTIONS(3466),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3466),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3466),
    [sym_preproc_directive] = ACTIONS(3466),
    [anon_sym_LPAREN2] = ACTIONS(3468),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3466),
    [anon_sym_PLUS] = ACTIONS(3466),
    [anon_sym_STAR] = ACTIONS(3468),
    [anon_sym_AMP_AMP] = ACTIONS(3468),
    [anon_sym_AMP] = ACTIONS(3466),
    [anon_sym_SEMI] = ACTIONS(3468),
    [anon_sym___extension__] = ACTIONS(3466),
    [anon_sym_typedef] = ACTIONS(3466),
    [anon_sym_in] = ACTIONS(3466),
    [anon_sym_out] = ACTIONS(3466),
    [anon_sym_inout] = ACTIONS(3466),
    [anon_sym_virtual] = ACTIONS(3466),
    [anon_sym_extern] = ACTIONS(3466),
    [anon_sym___attribute__] = ACTIONS(3466),
    [anon_sym___attribute] = ACTIONS(3466),
    [anon_sym_using] = ACTIONS(3466),
    [anon_sym_COLON_COLON] = ACTIONS(3468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3468),
    [anon_sym___declspec] = ACTIONS(3466),
    [anon_sym___based] = ACTIONS(3466),
    [anon_sym___cdecl] = ACTIONS(3466),
    [anon_sym___clrcall] = ACTIONS(3466),
    [anon_sym___stdcall] = ACTIONS(3466),
    [anon_sym___fastcall] = ACTIONS(3466),
    [anon_sym___thiscall] = ACTIONS(3466),
    [anon_sym___vectorcall] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_RBRACE] = ACTIONS(3468),
    [anon_sym_signed] = ACTIONS(3466),
    [anon_sym_unsigned] = ACTIONS(3466),
    [anon_sym_long] = ACTIONS(3466),
    [anon_sym_short] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(3466),
    [anon_sym_static] = ACTIONS(3466),
    [anon_sym_register] = ACTIONS(3466),
    [anon_sym_inline] = ACTIONS(3466),
    [anon_sym___inline] = ACTIONS(3466),
    [anon_sym___inline__] = ACTIONS(3466),
    [anon_sym___forceinline] = ACTIONS(3466),
    [anon_sym_thread_local] = ACTIONS(3466),
    [anon_sym___thread] = ACTIONS(3466),
    [anon_sym_const] = ACTIONS(3466),
    [anon_sym_constexpr] = ACTIONS(3466),
    [anon_sym_volatile] = ACTIONS(3466),
    [anon_sym_restrict] = ACTIONS(3466),
    [anon_sym___restrict__] = ACTIONS(3466),
    [anon_sym__Atomic] = ACTIONS(3466),
    [anon_sym__Noreturn] = ACTIONS(3466),
    [anon_sym_noreturn] = ACTIONS(3466),
    [anon_sym__Nonnull] = ACTIONS(3466),
    [anon_sym_mutable] = ACTIONS(3466),
    [anon_sym_constinit] = ACTIONS(3466),
    [anon_sym_consteval] = ACTIONS(3466),
    [anon_sym_alignas] = ACTIONS(3466),
    [anon_sym__Alignas] = ACTIONS(3466),
    [sym_primitive_type] = ACTIONS(3466),
    [anon_sym_enum] = ACTIONS(3466),
    [anon_sym_class] = ACTIONS(3466),
    [anon_sym_struct] = ACTIONS(3466),
    [anon_sym_union] = ACTIONS(3466),
    [anon_sym_if] = ACTIONS(3466),
    [anon_sym_else] = ACTIONS(3466),
    [anon_sym_switch] = ACTIONS(3466),
    [anon_sym_case] = ACTIONS(3466),
    [anon_sym_default] = ACTIONS(3466),
    [anon_sym_while] = ACTIONS(3466),
    [anon_sym_do] = ACTIONS(3466),
    [anon_sym_for] = ACTIONS(3466),
    [anon_sym_return] = ACTIONS(3466),
    [anon_sym_break] = ACTIONS(3466),
    [anon_sym_continue] = ACTIONS(3466),
    [anon_sym_goto] = ACTIONS(3466),
    [anon_sym___try] = ACTIONS(3466),
    [anon_sym___leave] = ACTIONS(3466),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_compl] = ACTIONS(3466),
    [anon_sym_DASH_DASH] = ACTIONS(3468),
    [anon_sym_PLUS_PLUS] = ACTIONS(3468),
    [anon_sym_sizeof] = ACTIONS(3466),
    [anon_sym___alignof__] = ACTIONS(3466),
    [anon_sym___alignof] = ACTIONS(3466),
    [anon_sym__alignof] = ACTIONS(3466),
    [anon_sym_alignof] = ACTIONS(3466),
    [anon_sym__Alignof] = ACTIONS(3466),
    [anon_sym_offsetof] = ACTIONS(3466),
    [anon_sym__Generic] = ACTIONS(3466),
    [anon_sym_asm] = ACTIONS(3466),
    [anon_sym___asm__] = ACTIONS(3466),
    [anon_sym___asm] = ACTIONS(3466),
    [sym_number_literal] = ACTIONS(3468),
    [anon_sym_L_SQUOTE] = ACTIONS(3468),
    [anon_sym_u_SQUOTE] = ACTIONS(3468),
    [anon_sym_U_SQUOTE] = ACTIONS(3468),
    [anon_sym_u8_SQUOTE] = ACTIONS(3468),
    [anon_sym_SQUOTE] = ACTIONS(3468),
    [anon_sym_L_DQUOTE] = ACTIONS(3468),
    [anon_sym_u_DQUOTE] = ACTIONS(3468),
    [anon_sym_U_DQUOTE] = ACTIONS(3468),
    [anon_sym_u8_DQUOTE] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3468),
    [sym_true] = ACTIONS(3466),
    [sym_false] = ACTIONS(3466),
    [anon_sym_NULL] = ACTIONS(3466),
    [anon_sym_nullptr] = ACTIONS(3466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3466),
    [anon_sym_let] = ACTIONS(3466),
    [anon_sym_This] = ACTIONS(3466),
    [anon_sym_decltype] = ACTIONS(3466),
    [anon_sym_explicit] = ACTIONS(3466),
    [anon_sym_typename] = ACTIONS(3466),
    [anon_sym_template] = ACTIONS(3466),
    [anon_sym_operator] = ACTIONS(3466),
    [anon_sym_try] = ACTIONS(3466),
    [anon_sym_delete] = ACTIONS(3466),
    [anon_sym_throw] = ACTIONS(3466),
    [anon_sym_namespace] = ACTIONS(3466),
    [anon_sym_static_assert] = ACTIONS(3466),
    [anon_sym_concept] = ACTIONS(3466),
    [anon_sym_co_return] = ACTIONS(3466),
    [anon_sym_co_yield] = ACTIONS(3466),
    [anon_sym_R_DQUOTE] = ACTIONS(3468),
    [anon_sym_LR_DQUOTE] = ACTIONS(3468),
    [anon_sym_uR_DQUOTE] = ACTIONS(3468),
    [anon_sym_UR_DQUOTE] = ACTIONS(3468),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3468),
    [anon_sym_co_await] = ACTIONS(3466),
    [anon_sym_new] = ACTIONS(3466),
    [anon_sym_requires] = ACTIONS(3466),
    [sym_this] = ACTIONS(3466),
    [anon_sym_discard] = ACTIONS(3466),
    [anon_sym_precise] = ACTIONS(3466),
    [anon_sym_shared] = ACTIONS(3466),
    [anon_sym_groupshared] = ACTIONS(3466),
    [anon_sym_uniform] = ACTIONS(3466),
    [anon_sym_row_major] = ACTIONS(3466),
    [anon_sym_column_major] = ACTIONS(3466),
    [anon_sym_globallycoherent] = ACTIONS(3466),
    [anon_sym_centroid] = ACTIONS(3466),
    [anon_sym_noperspective] = ACTIONS(3466),
    [anon_sym_nointerpolation] = ACTIONS(3466),
    [anon_sym_sample] = ACTIONS(3466),
    [anon_sym_linear] = ACTIONS(3466),
    [anon_sym_snorm] = ACTIONS(3466),
    [anon_sym_unorm] = ACTIONS(3466),
    [anon_sym_point] = ACTIONS(3466),
    [anon_sym_line] = ACTIONS(3466),
    [anon_sym_triangleadj] = ACTIONS(3466),
    [anon_sym_lineadj] = ACTIONS(3466),
    [anon_sym_triangle] = ACTIONS(3466),
    [anon_sym_cbuffer] = ACTIONS(3466),
    [anon_sym_interface] = ACTIONS(3466),
    [anon_sym_extension] = ACTIONS(3466),
  },
  [854] = {
    [ts_builtin_sym_end] = ACTIONS(3352),
    [sym_identifier] = ACTIONS(3362),
    [aux_sym_preproc_include_token1] = ACTIONS(3362),
    [aux_sym_preproc_def_token1] = ACTIONS(3362),
    [aux_sym_preproc_if_token1] = ACTIONS(3362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3362),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3362),
    [sym_preproc_directive] = ACTIONS(3362),
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_BANG] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [anon_sym_DASH] = ACTIONS(3362),
    [anon_sym_PLUS] = ACTIONS(3362),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym_typedef] = ACTIONS(3362),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_using] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3352),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym___cdecl] = ACTIONS(3362),
    [anon_sym___clrcall] = ACTIONS(3362),
    [anon_sym___stdcall] = ACTIONS(3362),
    [anon_sym___fastcall] = ACTIONS(3362),
    [anon_sym___thiscall] = ACTIONS(3362),
    [anon_sym___vectorcall] = ACTIONS(3362),
    [anon_sym_LBRACE] = ACTIONS(3352),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3362),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3362),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [anon_sym_if] = ACTIONS(3362),
    [anon_sym_switch] = ACTIONS(3362),
    [anon_sym_case] = ACTIONS(3362),
    [anon_sym_default] = ACTIONS(3362),
    [anon_sym_while] = ACTIONS(3362),
    [anon_sym_do] = ACTIONS(3362),
    [anon_sym_for] = ACTIONS(3362),
    [anon_sym_return] = ACTIONS(3362),
    [anon_sym_break] = ACTIONS(3362),
    [anon_sym_continue] = ACTIONS(3362),
    [anon_sym_goto] = ACTIONS(3362),
    [anon_sym_not] = ACTIONS(3362),
    [anon_sym_compl] = ACTIONS(3362),
    [anon_sym_DASH_DASH] = ACTIONS(3352),
    [anon_sym_PLUS_PLUS] = ACTIONS(3352),
    [anon_sym_sizeof] = ACTIONS(3362),
    [anon_sym___alignof__] = ACTIONS(3362),
    [anon_sym___alignof] = ACTIONS(3362),
    [anon_sym__alignof] = ACTIONS(3362),
    [anon_sym_alignof] = ACTIONS(3362),
    [anon_sym__Alignof] = ACTIONS(3362),
    [anon_sym_offsetof] = ACTIONS(3362),
    [anon_sym__Generic] = ACTIONS(3362),
    [anon_sym_asm] = ACTIONS(3362),
    [anon_sym___asm__] = ACTIONS(3362),
    [anon_sym___asm] = ACTIONS(3362),
    [anon_sym_DOT] = ACTIONS(3362),
    [sym_number_literal] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3352),
    [anon_sym_u_SQUOTE] = ACTIONS(3352),
    [anon_sym_U_SQUOTE] = ACTIONS(3352),
    [anon_sym_u8_SQUOTE] = ACTIONS(3352),
    [anon_sym_SQUOTE] = ACTIONS(3352),
    [anon_sym_L_DQUOTE] = ACTIONS(3352),
    [anon_sym_u_DQUOTE] = ACTIONS(3352),
    [anon_sym_U_DQUOTE] = ACTIONS(3352),
    [anon_sym_u8_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3352),
    [sym_true] = ACTIONS(3362),
    [sym_false] = ACTIONS(3362),
    [anon_sym_NULL] = ACTIONS(3362),
    [anon_sym_nullptr] = ACTIONS(3362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3362),
    [anon_sym_explicit] = ACTIONS(3362),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_export] = ACTIONS(3362),
    [anon_sym_module] = ACTIONS(3362),
    [anon_sym_import] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3362),
    [anon_sym_operator] = ACTIONS(3362),
    [anon_sym_try] = ACTIONS(3362),
    [anon_sym_delete] = ACTIONS(3362),
    [anon_sym_throw] = ACTIONS(3362),
    [anon_sym_namespace] = ACTIONS(3362),
    [anon_sym_static_assert] = ACTIONS(3362),
    [anon_sym_concept] = ACTIONS(3362),
    [anon_sym_co_return] = ACTIONS(3362),
    [anon_sym_co_yield] = ACTIONS(3362),
    [anon_sym_R_DQUOTE] = ACTIONS(3352),
    [anon_sym_LR_DQUOTE] = ACTIONS(3352),
    [anon_sym_uR_DQUOTE] = ACTIONS(3352),
    [anon_sym_UR_DQUOTE] = ACTIONS(3352),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3352),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(3362),
    [anon_sym_requires] = ACTIONS(3362),
    [sym_this] = ACTIONS(3362),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
    [anon_sym___exported] = ACTIONS(3362),
  },
  [855] = {
    [sym_identifier] = ACTIONS(2883),
    [aux_sym_preproc_include_token1] = ACTIONS(2883),
    [aux_sym_preproc_def_token1] = ACTIONS(2883),
    [aux_sym_preproc_if_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2883),
    [sym_preproc_directive] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_typedef] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_using] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(4256),
    [anon_sym_RBRACE] = ACTIONS(2881),
    [anon_sym_signed] = ACTIONS(2883),
    [anon_sym_unsigned] = ACTIONS(2883),
    [anon_sym_long] = ACTIONS(2883),
    [anon_sym_short] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [sym_primitive_type] = ACTIONS(2883),
    [anon_sym_enum] = ACTIONS(2883),
    [anon_sym_class] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2883),
    [anon_sym_union] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_switch] = ACTIONS(2883),
    [anon_sym_case] = ACTIONS(2883),
    [anon_sym_default] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_break] = ACTIONS(2883),
    [anon_sym_continue] = ACTIONS(2883),
    [anon_sym_goto] = ACTIONS(2883),
    [anon_sym___try] = ACTIONS(2883),
    [anon_sym___leave] = ACTIONS(2883),
    [anon_sym_not] = ACTIONS(2883),
    [anon_sym_compl] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_sizeof] = ACTIONS(2883),
    [anon_sym___alignof__] = ACTIONS(2883),
    [anon_sym___alignof] = ACTIONS(2883),
    [anon_sym__alignof] = ACTIONS(2883),
    [anon_sym_alignof] = ACTIONS(2883),
    [anon_sym__Alignof] = ACTIONS(2883),
    [anon_sym_offsetof] = ACTIONS(2883),
    [anon_sym__Generic] = ACTIONS(2883),
    [anon_sym_asm] = ACTIONS(2883),
    [anon_sym___asm__] = ACTIONS(2883),
    [anon_sym___asm] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [sym_number_literal] = ACTIONS(2881),
    [anon_sym_L_SQUOTE] = ACTIONS(2881),
    [anon_sym_u_SQUOTE] = ACTIONS(2881),
    [anon_sym_U_SQUOTE] = ACTIONS(2881),
    [anon_sym_u8_SQUOTE] = ACTIONS(2881),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_L_DQUOTE] = ACTIONS(2881),
    [anon_sym_u_DQUOTE] = ACTIONS(2881),
    [anon_sym_U_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [sym_true] = ACTIONS(2883),
    [sym_false] = ACTIONS(2883),
    [anon_sym_NULL] = ACTIONS(2883),
    [anon_sym_nullptr] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_explicit] = ACTIONS(2883),
    [anon_sym_typename] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_delete] = ACTIONS(2883),
    [anon_sym_throw] = ACTIONS(2883),
    [anon_sym_namespace] = ACTIONS(2883),
    [anon_sym_static_assert] = ACTIONS(2883),
    [anon_sym_concept] = ACTIONS(2883),
    [anon_sym_co_return] = ACTIONS(2883),
    [anon_sym_co_yield] = ACTIONS(2883),
    [anon_sym_R_DQUOTE] = ACTIONS(2881),
    [anon_sym_LR_DQUOTE] = ACTIONS(2881),
    [anon_sym_uR_DQUOTE] = ACTIONS(2881),
    [anon_sym_UR_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2881),
    [anon_sym_co_await] = ACTIONS(2883),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_requires] = ACTIONS(2883),
    [sym_this] = ACTIONS(2883),
    [anon_sym_discard] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
    [anon_sym_cbuffer] = ACTIONS(2883),
    [anon_sym_interface] = ACTIONS(2883),
    [anon_sym_extension] = ACTIONS(2883),
  },
  [856] = {
    [sym_identifier] = ACTIONS(2883),
    [aux_sym_preproc_include_token1] = ACTIONS(2883),
    [aux_sym_preproc_def_token1] = ACTIONS(2883),
    [aux_sym_preproc_if_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2883),
    [sym_preproc_directive] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_typedef] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_using] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2881),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(4256),
    [anon_sym_RBRACE] = ACTIONS(2881),
    [anon_sym_signed] = ACTIONS(2883),
    [anon_sym_unsigned] = ACTIONS(2883),
    [anon_sym_long] = ACTIONS(2883),
    [anon_sym_short] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [sym_primitive_type] = ACTIONS(2883),
    [anon_sym_enum] = ACTIONS(2883),
    [anon_sym_class] = ACTIONS(2883),
    [anon_sym_struct] = ACTIONS(2883),
    [anon_sym_union] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_switch] = ACTIONS(2883),
    [anon_sym_case] = ACTIONS(2883),
    [anon_sym_default] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_break] = ACTIONS(2883),
    [anon_sym_continue] = ACTIONS(2883),
    [anon_sym_goto] = ACTIONS(2883),
    [anon_sym___try] = ACTIONS(2883),
    [anon_sym___leave] = ACTIONS(2883),
    [anon_sym_not] = ACTIONS(2883),
    [anon_sym_compl] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_sizeof] = ACTIONS(2883),
    [anon_sym___alignof__] = ACTIONS(2883),
    [anon_sym___alignof] = ACTIONS(2883),
    [anon_sym__alignof] = ACTIONS(2883),
    [anon_sym_alignof] = ACTIONS(2883),
    [anon_sym__Alignof] = ACTIONS(2883),
    [anon_sym_offsetof] = ACTIONS(2883),
    [anon_sym__Generic] = ACTIONS(2883),
    [anon_sym_asm] = ACTIONS(2883),
    [anon_sym___asm__] = ACTIONS(2883),
    [anon_sym___asm] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [sym_number_literal] = ACTIONS(2881),
    [anon_sym_L_SQUOTE] = ACTIONS(2881),
    [anon_sym_u_SQUOTE] = ACTIONS(2881),
    [anon_sym_U_SQUOTE] = ACTIONS(2881),
    [anon_sym_u8_SQUOTE] = ACTIONS(2881),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [anon_sym_L_DQUOTE] = ACTIONS(2881),
    [anon_sym_u_DQUOTE] = ACTIONS(2881),
    [anon_sym_U_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [sym_true] = ACTIONS(2883),
    [sym_false] = ACTIONS(2883),
    [anon_sym_NULL] = ACTIONS(2883),
    [anon_sym_nullptr] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_explicit] = ACTIONS(2883),
    [anon_sym_typename] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_delete] = ACTIONS(2883),
    [anon_sym_throw] = ACTIONS(2883),
    [anon_sym_namespace] = ACTIONS(2883),
    [anon_sym_static_assert] = ACTIONS(2883),
    [anon_sym_concept] = ACTIONS(2883),
    [anon_sym_co_return] = ACTIONS(2883),
    [anon_sym_co_yield] = ACTIONS(2883),
    [anon_sym_R_DQUOTE] = ACTIONS(2881),
    [anon_sym_LR_DQUOTE] = ACTIONS(2881),
    [anon_sym_uR_DQUOTE] = ACTIONS(2881),
    [anon_sym_UR_DQUOTE] = ACTIONS(2881),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2881),
    [anon_sym_co_await] = ACTIONS(2883),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_requires] = ACTIONS(2883),
    [sym_this] = ACTIONS(2883),
    [anon_sym_discard] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
    [anon_sym_cbuffer] = ACTIONS(2883),
    [anon_sym_interface] = ACTIONS(2883),
    [anon_sym_extension] = ACTIONS(2883),
  },
  [857] = {
    [sym_identifier] = ACTIONS(3635),
    [aux_sym_preproc_include_token1] = ACTIONS(3635),
    [aux_sym_preproc_def_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3635),
    [aux_sym_preproc_if_token2] = ACTIONS(3635),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3635),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3635),
    [sym_preproc_directive] = ACTIONS(3635),
    [anon_sym_LPAREN2] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_TILDE] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3635),
    [anon_sym_PLUS] = ACTIONS(3635),
    [anon_sym_STAR] = ACTIONS(3633),
    [anon_sym_AMP_AMP] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3635),
    [anon_sym_SEMI] = ACTIONS(3633),
    [anon_sym___extension__] = ACTIONS(3635),
    [anon_sym_typedef] = ACTIONS(3635),
    [anon_sym_in] = ACTIONS(3635),
    [anon_sym_out] = ACTIONS(3635),
    [anon_sym_inout] = ACTIONS(3635),
    [anon_sym_virtual] = ACTIONS(3635),
    [anon_sym_extern] = ACTIONS(3635),
    [anon_sym___attribute__] = ACTIONS(3635),
    [anon_sym___attribute] = ACTIONS(3635),
    [anon_sym_using] = ACTIONS(3635),
    [anon_sym_COLON_COLON] = ACTIONS(3633),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3633),
    [anon_sym___declspec] = ACTIONS(3635),
    [anon_sym___based] = ACTIONS(3635),
    [anon_sym___cdecl] = ACTIONS(3635),
    [anon_sym___clrcall] = ACTIONS(3635),
    [anon_sym___stdcall] = ACTIONS(3635),
    [anon_sym___fastcall] = ACTIONS(3635),
    [anon_sym___thiscall] = ACTIONS(3635),
    [anon_sym___vectorcall] = ACTIONS(3635),
    [anon_sym_LBRACE] = ACTIONS(3633),
    [anon_sym_signed] = ACTIONS(3635),
    [anon_sym_unsigned] = ACTIONS(3635),
    [anon_sym_long] = ACTIONS(3635),
    [anon_sym_short] = ACTIONS(3635),
    [anon_sym_LBRACK] = ACTIONS(3635),
    [anon_sym_static] = ACTIONS(3635),
    [anon_sym_register] = ACTIONS(3635),
    [anon_sym_inline] = ACTIONS(3635),
    [anon_sym___inline] = ACTIONS(3635),
    [anon_sym___inline__] = ACTIONS(3635),
    [anon_sym___forceinline] = ACTIONS(3635),
    [anon_sym_thread_local] = ACTIONS(3635),
    [anon_sym___thread] = ACTIONS(3635),
    [anon_sym_const] = ACTIONS(3635),
    [anon_sym_constexpr] = ACTIONS(3635),
    [anon_sym_volatile] = ACTIONS(3635),
    [anon_sym_restrict] = ACTIONS(3635),
    [anon_sym___restrict__] = ACTIONS(3635),
    [anon_sym__Atomic] = ACTIONS(3635),
    [anon_sym__Noreturn] = ACTIONS(3635),
    [anon_sym_noreturn] = ACTIONS(3635),
    [anon_sym__Nonnull] = ACTIONS(3635),
    [anon_sym_mutable] = ACTIONS(3635),
    [anon_sym_constinit] = ACTIONS(3635),
    [anon_sym_consteval] = ACTIONS(3635),
    [anon_sym_alignas] = ACTIONS(3635),
    [anon_sym__Alignas] = ACTIONS(3635),
    [sym_primitive_type] = ACTIONS(3635),
    [anon_sym_enum] = ACTIONS(3635),
    [anon_sym_class] = ACTIONS(3635),
    [anon_sym_struct] = ACTIONS(3635),
    [anon_sym_union] = ACTIONS(3635),
    [anon_sym_if] = ACTIONS(3635),
    [anon_sym_else] = ACTIONS(3635),
    [anon_sym_switch] = ACTIONS(3635),
    [anon_sym_case] = ACTIONS(3635),
    [anon_sym_default] = ACTIONS(3635),
    [anon_sym_while] = ACTIONS(3635),
    [anon_sym_do] = ACTIONS(3635),
    [anon_sym_for] = ACTIONS(3635),
    [anon_sym_return] = ACTIONS(3635),
    [anon_sym_break] = ACTIONS(3635),
    [anon_sym_continue] = ACTIONS(3635),
    [anon_sym_goto] = ACTIONS(3635),
    [anon_sym___try] = ACTIONS(3635),
    [anon_sym___leave] = ACTIONS(3635),
    [anon_sym_not] = ACTIONS(3635),
    [anon_sym_compl] = ACTIONS(3635),
    [anon_sym_DASH_DASH] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3633),
    [anon_sym_sizeof] = ACTIONS(3635),
    [anon_sym___alignof__] = ACTIONS(3635),
    [anon_sym___alignof] = ACTIONS(3635),
    [anon_sym__alignof] = ACTIONS(3635),
    [anon_sym_alignof] = ACTIONS(3635),
    [anon_sym__Alignof] = ACTIONS(3635),
    [anon_sym_offsetof] = ACTIONS(3635),
    [anon_sym__Generic] = ACTIONS(3635),
    [anon_sym_asm] = ACTIONS(3635),
    [anon_sym___asm__] = ACTIONS(3635),
    [anon_sym___asm] = ACTIONS(3635),
    [sym_number_literal] = ACTIONS(3633),
    [anon_sym_L_SQUOTE] = ACTIONS(3633),
    [anon_sym_u_SQUOTE] = ACTIONS(3633),
    [anon_sym_U_SQUOTE] = ACTIONS(3633),
    [anon_sym_u8_SQUOTE] = ACTIONS(3633),
    [anon_sym_SQUOTE] = ACTIONS(3633),
    [anon_sym_L_DQUOTE] = ACTIONS(3633),
    [anon_sym_u_DQUOTE] = ACTIONS(3633),
    [anon_sym_U_DQUOTE] = ACTIONS(3633),
    [anon_sym_u8_DQUOTE] = ACTIONS(3633),
    [anon_sym_DQUOTE] = ACTIONS(3633),
    [sym_true] = ACTIONS(3635),
    [sym_false] = ACTIONS(3635),
    [anon_sym_NULL] = ACTIONS(3635),
    [anon_sym_nullptr] = ACTIONS(3635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3635),
    [anon_sym_let] = ACTIONS(3635),
    [anon_sym_This] = ACTIONS(3635),
    [anon_sym_decltype] = ACTIONS(3635),
    [anon_sym_explicit] = ACTIONS(3635),
    [anon_sym_typename] = ACTIONS(3635),
    [anon_sym_template] = ACTIONS(3635),
    [anon_sym_operator] = ACTIONS(3635),
    [anon_sym_try] = ACTIONS(3635),
    [anon_sym_delete] = ACTIONS(3635),
    [anon_sym_throw] = ACTIONS(3635),
    [anon_sym_namespace] = ACTIONS(3635),
    [anon_sym_static_assert] = ACTIONS(3635),
    [anon_sym_concept] = ACTIONS(3635),
    [anon_sym_co_return] = ACTIONS(3635),
    [anon_sym_co_yield] = ACTIONS(3635),
    [anon_sym_R_DQUOTE] = ACTIONS(3633),
    [anon_sym_LR_DQUOTE] = ACTIONS(3633),
    [anon_sym_uR_DQUOTE] = ACTIONS(3633),
    [anon_sym_UR_DQUOTE] = ACTIONS(3633),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3633),
    [anon_sym_co_await] = ACTIONS(3635),
    [anon_sym_new] = ACTIONS(3635),
    [anon_sym_requires] = ACTIONS(3635),
    [sym_this] = ACTIONS(3635),
    [anon_sym_discard] = ACTIONS(3635),
    [anon_sym_precise] = ACTIONS(3635),
    [anon_sym_shared] = ACTIONS(3635),
    [anon_sym_groupshared] = ACTIONS(3635),
    [anon_sym_uniform] = ACTIONS(3635),
    [anon_sym_row_major] = ACTIONS(3635),
    [anon_sym_column_major] = ACTIONS(3635),
    [anon_sym_globallycoherent] = ACTIONS(3635),
    [anon_sym_centroid] = ACTIONS(3635),
    [anon_sym_noperspective] = ACTIONS(3635),
    [anon_sym_nointerpolation] = ACTIONS(3635),
    [anon_sym_sample] = ACTIONS(3635),
    [anon_sym_linear] = ACTIONS(3635),
    [anon_sym_snorm] = ACTIONS(3635),
    [anon_sym_unorm] = ACTIONS(3635),
    [anon_sym_point] = ACTIONS(3635),
    [anon_sym_line] = ACTIONS(3635),
    [anon_sym_triangleadj] = ACTIONS(3635),
    [anon_sym_lineadj] = ACTIONS(3635),
    [anon_sym_triangle] = ACTIONS(3635),
    [anon_sym_cbuffer] = ACTIONS(3635),
    [anon_sym_interface] = ACTIONS(3635),
    [anon_sym_extension] = ACTIONS(3635),
  },
  [858] = {
    [sym_identifier] = ACTIONS(3494),
    [aux_sym_preproc_include_token1] = ACTIONS(3494),
    [aux_sym_preproc_def_token1] = ACTIONS(3494),
    [aux_sym_preproc_if_token1] = ACTIONS(3494),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3494),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3494),
    [sym_preproc_directive] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(3496),
    [anon_sym_BANG] = ACTIONS(3496),
    [anon_sym_TILDE] = ACTIONS(3496),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3496),
    [anon_sym_AMP_AMP] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_SEMI] = ACTIONS(3496),
    [anon_sym___extension__] = ACTIONS(3494),
    [anon_sym_typedef] = ACTIONS(3494),
    [anon_sym_in] = ACTIONS(3494),
    [anon_sym_out] = ACTIONS(3494),
    [anon_sym_inout] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym___attribute__] = ACTIONS(3494),
    [anon_sym___attribute] = ACTIONS(3494),
    [anon_sym_using] = ACTIONS(3494),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3496),
    [anon_sym___declspec] = ACTIONS(3494),
    [anon_sym___based] = ACTIONS(3494),
    [anon_sym___cdecl] = ACTIONS(3494),
    [anon_sym___clrcall] = ACTIONS(3494),
    [anon_sym___stdcall] = ACTIONS(3494),
    [anon_sym___fastcall] = ACTIONS(3494),
    [anon_sym___thiscall] = ACTIONS(3494),
    [anon_sym___vectorcall] = ACTIONS(3494),
    [anon_sym_LBRACE] = ACTIONS(3496),
    [anon_sym_RBRACE] = ACTIONS(3496),
    [anon_sym_signed] = ACTIONS(3494),
    [anon_sym_unsigned] = ACTIONS(3494),
    [anon_sym_long] = ACTIONS(3494),
    [anon_sym_short] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_register] = ACTIONS(3494),
    [anon_sym_inline] = ACTIONS(3494),
    [anon_sym___inline] = ACTIONS(3494),
    [anon_sym___inline__] = ACTIONS(3494),
    [anon_sym___forceinline] = ACTIONS(3494),
    [anon_sym_thread_local] = ACTIONS(3494),
    [anon_sym___thread] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_constexpr] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_restrict] = ACTIONS(3494),
    [anon_sym___restrict__] = ACTIONS(3494),
    [anon_sym__Atomic] = ACTIONS(3494),
    [anon_sym__Noreturn] = ACTIONS(3494),
    [anon_sym_noreturn] = ACTIONS(3494),
    [anon_sym__Nonnull] = ACTIONS(3494),
    [anon_sym_mutable] = ACTIONS(3494),
    [anon_sym_constinit] = ACTIONS(3494),
    [anon_sym_consteval] = ACTIONS(3494),
    [anon_sym_alignas] = ACTIONS(3494),
    [anon_sym__Alignas] = ACTIONS(3494),
    [sym_primitive_type] = ACTIONS(3494),
    [anon_sym_enum] = ACTIONS(3494),
    [anon_sym_class] = ACTIONS(3494),
    [anon_sym_struct] = ACTIONS(3494),
    [anon_sym_union] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_else] = ACTIONS(3494),
    [anon_sym_switch] = ACTIONS(3494),
    [anon_sym_case] = ACTIONS(3494),
    [anon_sym_default] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_break] = ACTIONS(3494),
    [anon_sym_continue] = ACTIONS(3494),
    [anon_sym_goto] = ACTIONS(3494),
    [anon_sym___try] = ACTIONS(3494),
    [anon_sym___leave] = ACTIONS(3494),
    [anon_sym_not] = ACTIONS(3494),
    [anon_sym_compl] = ACTIONS(3494),
    [anon_sym_DASH_DASH] = ACTIONS(3496),
    [anon_sym_PLUS_PLUS] = ACTIONS(3496),
    [anon_sym_sizeof] = ACTIONS(3494),
    [anon_sym___alignof__] = ACTIONS(3494),
    [anon_sym___alignof] = ACTIONS(3494),
    [anon_sym__alignof] = ACTIONS(3494),
    [anon_sym_alignof] = ACTIONS(3494),
    [anon_sym__Alignof] = ACTIONS(3494),
    [anon_sym_offsetof] = ACTIONS(3494),
    [anon_sym__Generic] = ACTIONS(3494),
    [anon_sym_asm] = ACTIONS(3494),
    [anon_sym___asm__] = ACTIONS(3494),
    [anon_sym___asm] = ACTIONS(3494),
    [sym_number_literal] = ACTIONS(3496),
    [anon_sym_L_SQUOTE] = ACTIONS(3496),
    [anon_sym_u_SQUOTE] = ACTIONS(3496),
    [anon_sym_U_SQUOTE] = ACTIONS(3496),
    [anon_sym_u8_SQUOTE] = ACTIONS(3496),
    [anon_sym_SQUOTE] = ACTIONS(3496),
    [anon_sym_L_DQUOTE] = ACTIONS(3496),
    [anon_sym_u_DQUOTE] = ACTIONS(3496),
    [anon_sym_U_DQUOTE] = ACTIONS(3496),
    [anon_sym_u8_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE] = ACTIONS(3496),
    [sym_true] = ACTIONS(3494),
    [sym_false] = ACTIONS(3494),
    [anon_sym_NULL] = ACTIONS(3494),
    [anon_sym_nullptr] = ACTIONS(3494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_This] = ACTIONS(3494),
    [anon_sym_decltype] = ACTIONS(3494),
    [anon_sym_explicit] = ACTIONS(3494),
    [anon_sym_typename] = ACTIONS(3494),
    [anon_sym_template] = ACTIONS(3494),
    [anon_sym_operator] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_delete] = ACTIONS(3494),
    [anon_sym_throw] = ACTIONS(3494),
    [anon_sym_namespace] = ACTIONS(3494),
    [anon_sym_static_assert] = ACTIONS(3494),
    [anon_sym_concept] = ACTIONS(3494),
    [anon_sym_co_return] = ACTIONS(3494),
    [anon_sym_co_yield] = ACTIONS(3494),
    [anon_sym_R_DQUOTE] = ACTIONS(3496),
    [anon_sym_LR_DQUOTE] = ACTIONS(3496),
    [anon_sym_uR_DQUOTE] = ACTIONS(3496),
    [anon_sym_UR_DQUOTE] = ACTIONS(3496),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3496),
    [anon_sym_co_await] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_requires] = ACTIONS(3494),
    [sym_this] = ACTIONS(3494),
    [anon_sym_discard] = ACTIONS(3494),
    [anon_sym_precise] = ACTIONS(3494),
    [anon_sym_shared] = ACTIONS(3494),
    [anon_sym_groupshared] = ACTIONS(3494),
    [anon_sym_uniform] = ACTIONS(3494),
    [anon_sym_row_major] = ACTIONS(3494),
    [anon_sym_column_major] = ACTIONS(3494),
    [anon_sym_globallycoherent] = ACTIONS(3494),
    [anon_sym_centroid] = ACTIONS(3494),
    [anon_sym_noperspective] = ACTIONS(3494),
    [anon_sym_nointerpolation] = ACTIONS(3494),
    [anon_sym_sample] = ACTIONS(3494),
    [anon_sym_linear] = ACTIONS(3494),
    [anon_sym_snorm] = ACTIONS(3494),
    [anon_sym_unorm] = ACTIONS(3494),
    [anon_sym_point] = ACTIONS(3494),
    [anon_sym_line] = ACTIONS(3494),
    [anon_sym_triangleadj] = ACTIONS(3494),
    [anon_sym_lineadj] = ACTIONS(3494),
    [anon_sym_triangle] = ACTIONS(3494),
    [anon_sym_cbuffer] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_extension] = ACTIONS(3494),
  },
  [859] = {
    [sym_identifier] = ACTIONS(3627),
    [aux_sym_preproc_include_token1] = ACTIONS(3627),
    [aux_sym_preproc_def_token1] = ACTIONS(3627),
    [aux_sym_preproc_if_token1] = ACTIONS(3627),
    [aux_sym_preproc_if_token2] = ACTIONS(3627),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3627),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3627),
    [sym_preproc_directive] = ACTIONS(3627),
    [anon_sym_LPAREN2] = ACTIONS(3625),
    [anon_sym_BANG] = ACTIONS(3625),
    [anon_sym_TILDE] = ACTIONS(3625),
    [anon_sym_DASH] = ACTIONS(3627),
    [anon_sym_PLUS] = ACTIONS(3627),
    [anon_sym_STAR] = ACTIONS(3625),
    [anon_sym_AMP_AMP] = ACTIONS(3625),
    [anon_sym_AMP] = ACTIONS(3627),
    [anon_sym_SEMI] = ACTIONS(3625),
    [anon_sym___extension__] = ACTIONS(3627),
    [anon_sym_typedef] = ACTIONS(3627),
    [anon_sym_in] = ACTIONS(3627),
    [anon_sym_out] = ACTIONS(3627),
    [anon_sym_inout] = ACTIONS(3627),
    [anon_sym_virtual] = ACTIONS(3627),
    [anon_sym_extern] = ACTIONS(3627),
    [anon_sym___attribute__] = ACTIONS(3627),
    [anon_sym___attribute] = ACTIONS(3627),
    [anon_sym_using] = ACTIONS(3627),
    [anon_sym_COLON_COLON] = ACTIONS(3625),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3625),
    [anon_sym___declspec] = ACTIONS(3627),
    [anon_sym___based] = ACTIONS(3627),
    [anon_sym___cdecl] = ACTIONS(3627),
    [anon_sym___clrcall] = ACTIONS(3627),
    [anon_sym___stdcall] = ACTIONS(3627),
    [anon_sym___fastcall] = ACTIONS(3627),
    [anon_sym___thiscall] = ACTIONS(3627),
    [anon_sym___vectorcall] = ACTIONS(3627),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_signed] = ACTIONS(3627),
    [anon_sym_unsigned] = ACTIONS(3627),
    [anon_sym_long] = ACTIONS(3627),
    [anon_sym_short] = ACTIONS(3627),
    [anon_sym_LBRACK] = ACTIONS(3627),
    [anon_sym_static] = ACTIONS(3627),
    [anon_sym_register] = ACTIONS(3627),
    [anon_sym_inline] = ACTIONS(3627),
    [anon_sym___inline] = ACTIONS(3627),
    [anon_sym___inline__] = ACTIONS(3627),
    [anon_sym___forceinline] = ACTIONS(3627),
    [anon_sym_thread_local] = ACTIONS(3627),
    [anon_sym___thread] = ACTIONS(3627),
    [anon_sym_const] = ACTIONS(3627),
    [anon_sym_constexpr] = ACTIONS(3627),
    [anon_sym_volatile] = ACTIONS(3627),
    [anon_sym_restrict] = ACTIONS(3627),
    [anon_sym___restrict__] = ACTIONS(3627),
    [anon_sym__Atomic] = ACTIONS(3627),
    [anon_sym__Noreturn] = ACTIONS(3627),
    [anon_sym_noreturn] = ACTIONS(3627),
    [anon_sym__Nonnull] = ACTIONS(3627),
    [anon_sym_mutable] = ACTIONS(3627),
    [anon_sym_constinit] = ACTIONS(3627),
    [anon_sym_consteval] = ACTIONS(3627),
    [anon_sym_alignas] = ACTIONS(3627),
    [anon_sym__Alignas] = ACTIONS(3627),
    [sym_primitive_type] = ACTIONS(3627),
    [anon_sym_enum] = ACTIONS(3627),
    [anon_sym_class] = ACTIONS(3627),
    [anon_sym_struct] = ACTIONS(3627),
    [anon_sym_union] = ACTIONS(3627),
    [anon_sym_if] = ACTIONS(3627),
    [anon_sym_else] = ACTIONS(3627),
    [anon_sym_switch] = ACTIONS(3627),
    [anon_sym_case] = ACTIONS(3627),
    [anon_sym_default] = ACTIONS(3627),
    [anon_sym_while] = ACTIONS(3627),
    [anon_sym_do] = ACTIONS(3627),
    [anon_sym_for] = ACTIONS(3627),
    [anon_sym_return] = ACTIONS(3627),
    [anon_sym_break] = ACTIONS(3627),
    [anon_sym_continue] = ACTIONS(3627),
    [anon_sym_goto] = ACTIONS(3627),
    [anon_sym___try] = ACTIONS(3627),
    [anon_sym___leave] = ACTIONS(3627),
    [anon_sym_not] = ACTIONS(3627),
    [anon_sym_compl] = ACTIONS(3627),
    [anon_sym_DASH_DASH] = ACTIONS(3625),
    [anon_sym_PLUS_PLUS] = ACTIONS(3625),
    [anon_sym_sizeof] = ACTIONS(3627),
    [anon_sym___alignof__] = ACTIONS(3627),
    [anon_sym___alignof] = ACTIONS(3627),
    [anon_sym__alignof] = ACTIONS(3627),
    [anon_sym_alignof] = ACTIONS(3627),
    [anon_sym__Alignof] = ACTIONS(3627),
    [anon_sym_offsetof] = ACTIONS(3627),
    [anon_sym__Generic] = ACTIONS(3627),
    [anon_sym_asm] = ACTIONS(3627),
    [anon_sym___asm__] = ACTIONS(3627),
    [anon_sym___asm] = ACTIONS(3627),
    [sym_number_literal] = ACTIONS(3625),
    [anon_sym_L_SQUOTE] = ACTIONS(3625),
    [anon_sym_u_SQUOTE] = ACTIONS(3625),
    [anon_sym_U_SQUOTE] = ACTIONS(3625),
    [anon_sym_u8_SQUOTE] = ACTIONS(3625),
    [anon_sym_SQUOTE] = ACTIONS(3625),
    [anon_sym_L_DQUOTE] = ACTIONS(3625),
    [anon_sym_u_DQUOTE] = ACTIONS(3625),
    [anon_sym_U_DQUOTE] = ACTIONS(3625),
    [anon_sym_u8_DQUOTE] = ACTIONS(3625),
    [anon_sym_DQUOTE] = ACTIONS(3625),
    [sym_true] = ACTIONS(3627),
    [sym_false] = ACTIONS(3627),
    [anon_sym_NULL] = ACTIONS(3627),
    [anon_sym_nullptr] = ACTIONS(3627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3627),
    [anon_sym_let] = ACTIONS(3627),
    [anon_sym_This] = ACTIONS(3627),
    [anon_sym_decltype] = ACTIONS(3627),
    [anon_sym_explicit] = ACTIONS(3627),
    [anon_sym_typename] = ACTIONS(3627),
    [anon_sym_template] = ACTIONS(3627),
    [anon_sym_operator] = ACTIONS(3627),
    [anon_sym_try] = ACTIONS(3627),
    [anon_sym_delete] = ACTIONS(3627),
    [anon_sym_throw] = ACTIONS(3627),
    [anon_sym_namespace] = ACTIONS(3627),
    [anon_sym_static_assert] = ACTIONS(3627),
    [anon_sym_concept] = ACTIONS(3627),
    [anon_sym_co_return] = ACTIONS(3627),
    [anon_sym_co_yield] = ACTIONS(3627),
    [anon_sym_R_DQUOTE] = ACTIONS(3625),
    [anon_sym_LR_DQUOTE] = ACTIONS(3625),
    [anon_sym_uR_DQUOTE] = ACTIONS(3625),
    [anon_sym_UR_DQUOTE] = ACTIONS(3625),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3625),
    [anon_sym_co_await] = ACTIONS(3627),
    [anon_sym_new] = ACTIONS(3627),
    [anon_sym_requires] = ACTIONS(3627),
    [sym_this] = ACTIONS(3627),
    [anon_sym_discard] = ACTIONS(3627),
    [anon_sym_precise] = ACTIONS(3627),
    [anon_sym_shared] = ACTIONS(3627),
    [anon_sym_groupshared] = ACTIONS(3627),
    [anon_sym_uniform] = ACTIONS(3627),
    [anon_sym_row_major] = ACTIONS(3627),
    [anon_sym_column_major] = ACTIONS(3627),
    [anon_sym_globallycoherent] = ACTIONS(3627),
    [anon_sym_centroid] = ACTIONS(3627),
    [anon_sym_noperspective] = ACTIONS(3627),
    [anon_sym_nointerpolation] = ACTIONS(3627),
    [anon_sym_sample] = ACTIONS(3627),
    [anon_sym_linear] = ACTIONS(3627),
    [anon_sym_snorm] = ACTIONS(3627),
    [anon_sym_unorm] = ACTIONS(3627),
    [anon_sym_point] = ACTIONS(3627),
    [anon_sym_line] = ACTIONS(3627),
    [anon_sym_triangleadj] = ACTIONS(3627),
    [anon_sym_lineadj] = ACTIONS(3627),
    [anon_sym_triangle] = ACTIONS(3627),
    [anon_sym_cbuffer] = ACTIONS(3627),
    [anon_sym_interface] = ACTIONS(3627),
    [anon_sym_extension] = ACTIONS(3627),
  },
  [860] = {
    [sym_identifier] = ACTIONS(3597),
    [aux_sym_preproc_include_token1] = ACTIONS(3597),
    [aux_sym_preproc_def_token1] = ACTIONS(3597),
    [aux_sym_preproc_if_token1] = ACTIONS(3597),
    [aux_sym_preproc_if_token2] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3597),
    [sym_preproc_directive] = ACTIONS(3597),
    [anon_sym_LPAREN2] = ACTIONS(3599),
    [anon_sym_BANG] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3599),
    [anon_sym_DASH] = ACTIONS(3597),
    [anon_sym_PLUS] = ACTIONS(3597),
    [anon_sym_STAR] = ACTIONS(3599),
    [anon_sym_AMP_AMP] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3597),
    [anon_sym_SEMI] = ACTIONS(3599),
    [anon_sym___extension__] = ACTIONS(3597),
    [anon_sym_typedef] = ACTIONS(3597),
    [anon_sym_in] = ACTIONS(3597),
    [anon_sym_out] = ACTIONS(3597),
    [anon_sym_inout] = ACTIONS(3597),
    [anon_sym_virtual] = ACTIONS(3597),
    [anon_sym_extern] = ACTIONS(3597),
    [anon_sym___attribute__] = ACTIONS(3597),
    [anon_sym___attribute] = ACTIONS(3597),
    [anon_sym_using] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3599),
    [anon_sym___declspec] = ACTIONS(3597),
    [anon_sym___based] = ACTIONS(3597),
    [anon_sym___cdecl] = ACTIONS(3597),
    [anon_sym___clrcall] = ACTIONS(3597),
    [anon_sym___stdcall] = ACTIONS(3597),
    [anon_sym___fastcall] = ACTIONS(3597),
    [anon_sym___thiscall] = ACTIONS(3597),
    [anon_sym___vectorcall] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(3599),
    [anon_sym_signed] = ACTIONS(3597),
    [anon_sym_unsigned] = ACTIONS(3597),
    [anon_sym_long] = ACTIONS(3597),
    [anon_sym_short] = ACTIONS(3597),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_static] = ACTIONS(3597),
    [anon_sym_register] = ACTIONS(3597),
    [anon_sym_inline] = ACTIONS(3597),
    [anon_sym___inline] = ACTIONS(3597),
    [anon_sym___inline__] = ACTIONS(3597),
    [anon_sym___forceinline] = ACTIONS(3597),
    [anon_sym_thread_local] = ACTIONS(3597),
    [anon_sym___thread] = ACTIONS(3597),
    [anon_sym_const] = ACTIONS(3597),
    [anon_sym_constexpr] = ACTIONS(3597),
    [anon_sym_volatile] = ACTIONS(3597),
    [anon_sym_restrict] = ACTIONS(3597),
    [anon_sym___restrict__] = ACTIONS(3597),
    [anon_sym__Atomic] = ACTIONS(3597),
    [anon_sym__Noreturn] = ACTIONS(3597),
    [anon_sym_noreturn] = ACTIONS(3597),
    [anon_sym__Nonnull] = ACTIONS(3597),
    [anon_sym_mutable] = ACTIONS(3597),
    [anon_sym_constinit] = ACTIONS(3597),
    [anon_sym_consteval] = ACTIONS(3597),
    [anon_sym_alignas] = ACTIONS(3597),
    [anon_sym__Alignas] = ACTIONS(3597),
    [sym_primitive_type] = ACTIONS(3597),
    [anon_sym_enum] = ACTIONS(3597),
    [anon_sym_class] = ACTIONS(3597),
    [anon_sym_struct] = ACTIONS(3597),
    [anon_sym_union] = ACTIONS(3597),
    [anon_sym_if] = ACTIONS(3597),
    [anon_sym_else] = ACTIONS(3597),
    [anon_sym_switch] = ACTIONS(3597),
    [anon_sym_case] = ACTIONS(3597),
    [anon_sym_default] = ACTIONS(3597),
    [anon_sym_while] = ACTIONS(3597),
    [anon_sym_do] = ACTIONS(3597),
    [anon_sym_for] = ACTIONS(3597),
    [anon_sym_return] = ACTIONS(3597),
    [anon_sym_break] = ACTIONS(3597),
    [anon_sym_continue] = ACTIONS(3597),
    [anon_sym_goto] = ACTIONS(3597),
    [anon_sym___try] = ACTIONS(3597),
    [anon_sym___leave] = ACTIONS(3597),
    [anon_sym_not] = ACTIONS(3597),
    [anon_sym_compl] = ACTIONS(3597),
    [anon_sym_DASH_DASH] = ACTIONS(3599),
    [anon_sym_PLUS_PLUS] = ACTIONS(3599),
    [anon_sym_sizeof] = ACTIONS(3597),
    [anon_sym___alignof__] = ACTIONS(3597),
    [anon_sym___alignof] = ACTIONS(3597),
    [anon_sym__alignof] = ACTIONS(3597),
    [anon_sym_alignof] = ACTIONS(3597),
    [anon_sym__Alignof] = ACTIONS(3597),
    [anon_sym_offsetof] = ACTIONS(3597),
    [anon_sym__Generic] = ACTIONS(3597),
    [anon_sym_asm] = ACTIONS(3597),
    [anon_sym___asm__] = ACTIONS(3597),
    [anon_sym___asm] = ACTIONS(3597),
    [sym_number_literal] = ACTIONS(3599),
    [anon_sym_L_SQUOTE] = ACTIONS(3599),
    [anon_sym_u_SQUOTE] = ACTIONS(3599),
    [anon_sym_U_SQUOTE] = ACTIONS(3599),
    [anon_sym_u8_SQUOTE] = ACTIONS(3599),
    [anon_sym_SQUOTE] = ACTIONS(3599),
    [anon_sym_L_DQUOTE] = ACTIONS(3599),
    [anon_sym_u_DQUOTE] = ACTIONS(3599),
    [anon_sym_U_DQUOTE] = ACTIONS(3599),
    [anon_sym_u8_DQUOTE] = ACTIONS(3599),
    [anon_sym_DQUOTE] = ACTIONS(3599),
    [sym_true] = ACTIONS(3597),
    [sym_false] = ACTIONS(3597),
    [anon_sym_NULL] = ACTIONS(3597),
    [anon_sym_nullptr] = ACTIONS(3597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3597),
    [anon_sym_let] = ACTIONS(3597),
    [anon_sym_This] = ACTIONS(3597),
    [anon_sym_decltype] = ACTIONS(3597),
    [anon_sym_explicit] = ACTIONS(3597),
    [anon_sym_typename] = ACTIONS(3597),
    [anon_sym_template] = ACTIONS(3597),
    [anon_sym_operator] = ACTIONS(3597),
    [anon_sym_try] = ACTIONS(3597),
    [anon_sym_delete] = ACTIONS(3597),
    [anon_sym_throw] = ACTIONS(3597),
    [anon_sym_namespace] = ACTIONS(3597),
    [anon_sym_static_assert] = ACTIONS(3597),
    [anon_sym_concept] = ACTIONS(3597),
    [anon_sym_co_return] = ACTIONS(3597),
    [anon_sym_co_yield] = ACTIONS(3597),
    [anon_sym_R_DQUOTE] = ACTIONS(3599),
    [anon_sym_LR_DQUOTE] = ACTIONS(3599),
    [anon_sym_uR_DQUOTE] = ACTIONS(3599),
    [anon_sym_UR_DQUOTE] = ACTIONS(3599),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3599),
    [anon_sym_co_await] = ACTIONS(3597),
    [anon_sym_new] = ACTIONS(3597),
    [anon_sym_requires] = ACTIONS(3597),
    [sym_this] = ACTIONS(3597),
    [anon_sym_discard] = ACTIONS(3597),
    [anon_sym_precise] = ACTIONS(3597),
    [anon_sym_shared] = ACTIONS(3597),
    [anon_sym_groupshared] = ACTIONS(3597),
    [anon_sym_uniform] = ACTIONS(3597),
    [anon_sym_row_major] = ACTIONS(3597),
    [anon_sym_column_major] = ACTIONS(3597),
    [anon_sym_globallycoherent] = ACTIONS(3597),
    [anon_sym_centroid] = ACTIONS(3597),
    [anon_sym_noperspective] = ACTIONS(3597),
    [anon_sym_nointerpolation] = ACTIONS(3597),
    [anon_sym_sample] = ACTIONS(3597),
    [anon_sym_linear] = ACTIONS(3597),
    [anon_sym_snorm] = ACTIONS(3597),
    [anon_sym_unorm] = ACTIONS(3597),
    [anon_sym_point] = ACTIONS(3597),
    [anon_sym_line] = ACTIONS(3597),
    [anon_sym_triangleadj] = ACTIONS(3597),
    [anon_sym_lineadj] = ACTIONS(3597),
    [anon_sym_triangle] = ACTIONS(3597),
    [anon_sym_cbuffer] = ACTIONS(3597),
    [anon_sym_interface] = ACTIONS(3597),
    [anon_sym_extension] = ACTIONS(3597),
  },
  [861] = {
    [sym_identifier] = ACTIONS(3490),
    [aux_sym_preproc_include_token1] = ACTIONS(3490),
    [aux_sym_preproc_def_token1] = ACTIONS(3490),
    [aux_sym_preproc_if_token1] = ACTIONS(3490),
    [aux_sym_preproc_if_token2] = ACTIONS(3490),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3490),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3490),
    [sym_preproc_directive] = ACTIONS(3490),
    [anon_sym_LPAREN2] = ACTIONS(3492),
    [anon_sym_BANG] = ACTIONS(3492),
    [anon_sym_TILDE] = ACTIONS(3492),
    [anon_sym_DASH] = ACTIONS(3490),
    [anon_sym_PLUS] = ACTIONS(3490),
    [anon_sym_STAR] = ACTIONS(3492),
    [anon_sym_AMP_AMP] = ACTIONS(3492),
    [anon_sym_AMP] = ACTIONS(3490),
    [anon_sym_SEMI] = ACTIONS(3492),
    [anon_sym___extension__] = ACTIONS(3490),
    [anon_sym_typedef] = ACTIONS(3490),
    [anon_sym_in] = ACTIONS(3490),
    [anon_sym_out] = ACTIONS(3490),
    [anon_sym_inout] = ACTIONS(3490),
    [anon_sym_virtual] = ACTIONS(3490),
    [anon_sym_extern] = ACTIONS(3490),
    [anon_sym___attribute__] = ACTIONS(3490),
    [anon_sym___attribute] = ACTIONS(3490),
    [anon_sym_using] = ACTIONS(3490),
    [anon_sym_COLON_COLON] = ACTIONS(3492),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3492),
    [anon_sym___declspec] = ACTIONS(3490),
    [anon_sym___based] = ACTIONS(3490),
    [anon_sym___cdecl] = ACTIONS(3490),
    [anon_sym___clrcall] = ACTIONS(3490),
    [anon_sym___stdcall] = ACTIONS(3490),
    [anon_sym___fastcall] = ACTIONS(3490),
    [anon_sym___thiscall] = ACTIONS(3490),
    [anon_sym___vectorcall] = ACTIONS(3490),
    [anon_sym_LBRACE] = ACTIONS(3492),
    [anon_sym_signed] = ACTIONS(3490),
    [anon_sym_unsigned] = ACTIONS(3490),
    [anon_sym_long] = ACTIONS(3490),
    [anon_sym_short] = ACTIONS(3490),
    [anon_sym_LBRACK] = ACTIONS(3490),
    [anon_sym_static] = ACTIONS(3490),
    [anon_sym_register] = ACTIONS(3490),
    [anon_sym_inline] = ACTIONS(3490),
    [anon_sym___inline] = ACTIONS(3490),
    [anon_sym___inline__] = ACTIONS(3490),
    [anon_sym___forceinline] = ACTIONS(3490),
    [anon_sym_thread_local] = ACTIONS(3490),
    [anon_sym___thread] = ACTIONS(3490),
    [anon_sym_const] = ACTIONS(3490),
    [anon_sym_constexpr] = ACTIONS(3490),
    [anon_sym_volatile] = ACTIONS(3490),
    [anon_sym_restrict] = ACTIONS(3490),
    [anon_sym___restrict__] = ACTIONS(3490),
    [anon_sym__Atomic] = ACTIONS(3490),
    [anon_sym__Noreturn] = ACTIONS(3490),
    [anon_sym_noreturn] = ACTIONS(3490),
    [anon_sym__Nonnull] = ACTIONS(3490),
    [anon_sym_mutable] = ACTIONS(3490),
    [anon_sym_constinit] = ACTIONS(3490),
    [anon_sym_consteval] = ACTIONS(3490),
    [anon_sym_alignas] = ACTIONS(3490),
    [anon_sym__Alignas] = ACTIONS(3490),
    [sym_primitive_type] = ACTIONS(3490),
    [anon_sym_enum] = ACTIONS(3490),
    [anon_sym_class] = ACTIONS(3490),
    [anon_sym_struct] = ACTIONS(3490),
    [anon_sym_union] = ACTIONS(3490),
    [anon_sym_if] = ACTIONS(3490),
    [anon_sym_else] = ACTIONS(3490),
    [anon_sym_switch] = ACTIONS(3490),
    [anon_sym_case] = ACTIONS(3490),
    [anon_sym_default] = ACTIONS(3490),
    [anon_sym_while] = ACTIONS(3490),
    [anon_sym_do] = ACTIONS(3490),
    [anon_sym_for] = ACTIONS(3490),
    [anon_sym_return] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3490),
    [anon_sym_continue] = ACTIONS(3490),
    [anon_sym_goto] = ACTIONS(3490),
    [anon_sym___try] = ACTIONS(3490),
    [anon_sym___leave] = ACTIONS(3490),
    [anon_sym_not] = ACTIONS(3490),
    [anon_sym_compl] = ACTIONS(3490),
    [anon_sym_DASH_DASH] = ACTIONS(3492),
    [anon_sym_PLUS_PLUS] = ACTIONS(3492),
    [anon_sym_sizeof] = ACTIONS(3490),
    [anon_sym___alignof__] = ACTIONS(3490),
    [anon_sym___alignof] = ACTIONS(3490),
    [anon_sym__alignof] = ACTIONS(3490),
    [anon_sym_alignof] = ACTIONS(3490),
    [anon_sym__Alignof] = ACTIONS(3490),
    [anon_sym_offsetof] = ACTIONS(3490),
    [anon_sym__Generic] = ACTIONS(3490),
    [anon_sym_asm] = ACTIONS(3490),
    [anon_sym___asm__] = ACTIONS(3490),
    [anon_sym___asm] = ACTIONS(3490),
    [sym_number_literal] = ACTIONS(3492),
    [anon_sym_L_SQUOTE] = ACTIONS(3492),
    [anon_sym_u_SQUOTE] = ACTIONS(3492),
    [anon_sym_U_SQUOTE] = ACTIONS(3492),
    [anon_sym_u8_SQUOTE] = ACTIONS(3492),
    [anon_sym_SQUOTE] = ACTIONS(3492),
    [anon_sym_L_DQUOTE] = ACTIONS(3492),
    [anon_sym_u_DQUOTE] = ACTIONS(3492),
    [anon_sym_U_DQUOTE] = ACTIONS(3492),
    [anon_sym_u8_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE] = ACTIONS(3492),
    [sym_true] = ACTIONS(3490),
    [sym_false] = ACTIONS(3490),
    [anon_sym_NULL] = ACTIONS(3490),
    [anon_sym_nullptr] = ACTIONS(3490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3490),
    [anon_sym_let] = ACTIONS(3490),
    [anon_sym_This] = ACTIONS(3490),
    [anon_sym_decltype] = ACTIONS(3490),
    [anon_sym_explicit] = ACTIONS(3490),
    [anon_sym_typename] = ACTIONS(3490),
    [anon_sym_template] = ACTIONS(3490),
    [anon_sym_operator] = ACTIONS(3490),
    [anon_sym_try] = ACTIONS(3490),
    [anon_sym_delete] = ACTIONS(3490),
    [anon_sym_throw] = ACTIONS(3490),
    [anon_sym_namespace] = ACTIONS(3490),
    [anon_sym_static_assert] = ACTIONS(3490),
    [anon_sym_concept] = ACTIONS(3490),
    [anon_sym_co_return] = ACTIONS(3490),
    [anon_sym_co_yield] = ACTIONS(3490),
    [anon_sym_R_DQUOTE] = ACTIONS(3492),
    [anon_sym_LR_DQUOTE] = ACTIONS(3492),
    [anon_sym_uR_DQUOTE] = ACTIONS(3492),
    [anon_sym_UR_DQUOTE] = ACTIONS(3492),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3492),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3490),
    [anon_sym_requires] = ACTIONS(3490),
    [sym_this] = ACTIONS(3490),
    [anon_sym_discard] = ACTIONS(3490),
    [anon_sym_precise] = ACTIONS(3490),
    [anon_sym_shared] = ACTIONS(3490),
    [anon_sym_groupshared] = ACTIONS(3490),
    [anon_sym_uniform] = ACTIONS(3490),
    [anon_sym_row_major] = ACTIONS(3490),
    [anon_sym_column_major] = ACTIONS(3490),
    [anon_sym_globallycoherent] = ACTIONS(3490),
    [anon_sym_centroid] = ACTIONS(3490),
    [anon_sym_noperspective] = ACTIONS(3490),
    [anon_sym_nointerpolation] = ACTIONS(3490),
    [anon_sym_sample] = ACTIONS(3490),
    [anon_sym_linear] = ACTIONS(3490),
    [anon_sym_snorm] = ACTIONS(3490),
    [anon_sym_unorm] = ACTIONS(3490),
    [anon_sym_point] = ACTIONS(3490),
    [anon_sym_line] = ACTIONS(3490),
    [anon_sym_triangleadj] = ACTIONS(3490),
    [anon_sym_lineadj] = ACTIONS(3490),
    [anon_sym_triangle] = ACTIONS(3490),
    [anon_sym_cbuffer] = ACTIONS(3490),
    [anon_sym_interface] = ACTIONS(3490),
    [anon_sym_extension] = ACTIONS(3490),
  },
  [862] = {
    [sym_identifier] = ACTIONS(3421),
    [aux_sym_preproc_include_token1] = ACTIONS(3421),
    [aux_sym_preproc_def_token1] = ACTIONS(3421),
    [aux_sym_preproc_if_token1] = ACTIONS(3421),
    [aux_sym_preproc_if_token2] = ACTIONS(3421),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3421),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3421),
    [sym_preproc_directive] = ACTIONS(3421),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_BANG] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_SEMI] = ACTIONS(3419),
    [anon_sym___extension__] = ACTIONS(3421),
    [anon_sym_typedef] = ACTIONS(3421),
    [anon_sym_in] = ACTIONS(3421),
    [anon_sym_out] = ACTIONS(3421),
    [anon_sym_inout] = ACTIONS(3421),
    [anon_sym_virtual] = ACTIONS(3421),
    [anon_sym_extern] = ACTIONS(3421),
    [anon_sym___attribute__] = ACTIONS(3421),
    [anon_sym___attribute] = ACTIONS(3421),
    [anon_sym_using] = ACTIONS(3421),
    [anon_sym_COLON_COLON] = ACTIONS(3419),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3419),
    [anon_sym___declspec] = ACTIONS(3421),
    [anon_sym___based] = ACTIONS(3421),
    [anon_sym___cdecl] = ACTIONS(3421),
    [anon_sym___clrcall] = ACTIONS(3421),
    [anon_sym___stdcall] = ACTIONS(3421),
    [anon_sym___fastcall] = ACTIONS(3421),
    [anon_sym___thiscall] = ACTIONS(3421),
    [anon_sym___vectorcall] = ACTIONS(3421),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_signed] = ACTIONS(3421),
    [anon_sym_unsigned] = ACTIONS(3421),
    [anon_sym_long] = ACTIONS(3421),
    [anon_sym_short] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3421),
    [anon_sym_static] = ACTIONS(3421),
    [anon_sym_register] = ACTIONS(3421),
    [anon_sym_inline] = ACTIONS(3421),
    [anon_sym___inline] = ACTIONS(3421),
    [anon_sym___inline__] = ACTIONS(3421),
    [anon_sym___forceinline] = ACTIONS(3421),
    [anon_sym_thread_local] = ACTIONS(3421),
    [anon_sym___thread] = ACTIONS(3421),
    [anon_sym_const] = ACTIONS(3421),
    [anon_sym_constexpr] = ACTIONS(3421),
    [anon_sym_volatile] = ACTIONS(3421),
    [anon_sym_restrict] = ACTIONS(3421),
    [anon_sym___restrict__] = ACTIONS(3421),
    [anon_sym__Atomic] = ACTIONS(3421),
    [anon_sym__Noreturn] = ACTIONS(3421),
    [anon_sym_noreturn] = ACTIONS(3421),
    [anon_sym__Nonnull] = ACTIONS(3421),
    [anon_sym_mutable] = ACTIONS(3421),
    [anon_sym_constinit] = ACTIONS(3421),
    [anon_sym_consteval] = ACTIONS(3421),
    [anon_sym_alignas] = ACTIONS(3421),
    [anon_sym__Alignas] = ACTIONS(3421),
    [sym_primitive_type] = ACTIONS(3421),
    [anon_sym_enum] = ACTIONS(3421),
    [anon_sym_class] = ACTIONS(3421),
    [anon_sym_struct] = ACTIONS(3421),
    [anon_sym_union] = ACTIONS(3421),
    [anon_sym_if] = ACTIONS(3421),
    [anon_sym_else] = ACTIONS(3421),
    [anon_sym_switch] = ACTIONS(3421),
    [anon_sym_case] = ACTIONS(3421),
    [anon_sym_default] = ACTIONS(3421),
    [anon_sym_while] = ACTIONS(3421),
    [anon_sym_do] = ACTIONS(3421),
    [anon_sym_for] = ACTIONS(3421),
    [anon_sym_return] = ACTIONS(3421),
    [anon_sym_break] = ACTIONS(3421),
    [anon_sym_continue] = ACTIONS(3421),
    [anon_sym_goto] = ACTIONS(3421),
    [anon_sym___try] = ACTIONS(3421),
    [anon_sym___leave] = ACTIONS(3421),
    [anon_sym_not] = ACTIONS(3421),
    [anon_sym_compl] = ACTIONS(3421),
    [anon_sym_DASH_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_PLUS] = ACTIONS(3419),
    [anon_sym_sizeof] = ACTIONS(3421),
    [anon_sym___alignof__] = ACTIONS(3421),
    [anon_sym___alignof] = ACTIONS(3421),
    [anon_sym__alignof] = ACTIONS(3421),
    [anon_sym_alignof] = ACTIONS(3421),
    [anon_sym__Alignof] = ACTIONS(3421),
    [anon_sym_offsetof] = ACTIONS(3421),
    [anon_sym__Generic] = ACTIONS(3421),
    [anon_sym_asm] = ACTIONS(3421),
    [anon_sym___asm__] = ACTIONS(3421),
    [anon_sym___asm] = ACTIONS(3421),
    [sym_number_literal] = ACTIONS(3419),
    [anon_sym_L_SQUOTE] = ACTIONS(3419),
    [anon_sym_u_SQUOTE] = ACTIONS(3419),
    [anon_sym_U_SQUOTE] = ACTIONS(3419),
    [anon_sym_u8_SQUOTE] = ACTIONS(3419),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym_L_DQUOTE] = ACTIONS(3419),
    [anon_sym_u_DQUOTE] = ACTIONS(3419),
    [anon_sym_U_DQUOTE] = ACTIONS(3419),
    [anon_sym_u8_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [sym_true] = ACTIONS(3421),
    [sym_false] = ACTIONS(3421),
    [anon_sym_NULL] = ACTIONS(3421),
    [anon_sym_nullptr] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3421),
    [anon_sym_let] = ACTIONS(3421),
    [anon_sym_This] = ACTIONS(3421),
    [anon_sym_decltype] = ACTIONS(3421),
    [anon_sym_explicit] = ACTIONS(3421),
    [anon_sym_typename] = ACTIONS(3421),
    [anon_sym_template] = ACTIONS(3421),
    [anon_sym_operator] = ACTIONS(3421),
    [anon_sym_try] = ACTIONS(3421),
    [anon_sym_delete] = ACTIONS(3421),
    [anon_sym_throw] = ACTIONS(3421),
    [anon_sym_namespace] = ACTIONS(3421),
    [anon_sym_static_assert] = ACTIONS(3421),
    [anon_sym_concept] = ACTIONS(3421),
    [anon_sym_co_return] = ACTIONS(3421),
    [anon_sym_co_yield] = ACTIONS(3421),
    [anon_sym_R_DQUOTE] = ACTIONS(3419),
    [anon_sym_LR_DQUOTE] = ACTIONS(3419),
    [anon_sym_uR_DQUOTE] = ACTIONS(3419),
    [anon_sym_UR_DQUOTE] = ACTIONS(3419),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3419),
    [anon_sym_co_await] = ACTIONS(3421),
    [anon_sym_new] = ACTIONS(3421),
    [anon_sym_requires] = ACTIONS(3421),
    [sym_this] = ACTIONS(3421),
    [anon_sym_discard] = ACTIONS(3421),
    [anon_sym_precise] = ACTIONS(3421),
    [anon_sym_shared] = ACTIONS(3421),
    [anon_sym_groupshared] = ACTIONS(3421),
    [anon_sym_uniform] = ACTIONS(3421),
    [anon_sym_row_major] = ACTIONS(3421),
    [anon_sym_column_major] = ACTIONS(3421),
    [anon_sym_globallycoherent] = ACTIONS(3421),
    [anon_sym_centroid] = ACTIONS(3421),
    [anon_sym_noperspective] = ACTIONS(3421),
    [anon_sym_nointerpolation] = ACTIONS(3421),
    [anon_sym_sample] = ACTIONS(3421),
    [anon_sym_linear] = ACTIONS(3421),
    [anon_sym_snorm] = ACTIONS(3421),
    [anon_sym_unorm] = ACTIONS(3421),
    [anon_sym_point] = ACTIONS(3421),
    [anon_sym_line] = ACTIONS(3421),
    [anon_sym_triangleadj] = ACTIONS(3421),
    [anon_sym_lineadj] = ACTIONS(3421),
    [anon_sym_triangle] = ACTIONS(3421),
    [anon_sym_cbuffer] = ACTIONS(3421),
    [anon_sym_interface] = ACTIONS(3421),
    [anon_sym_extension] = ACTIONS(3421),
  },
  [863] = {
    [sym_identifier] = ACTIONS(3456),
    [aux_sym_preproc_include_token1] = ACTIONS(3456),
    [aux_sym_preproc_def_token1] = ACTIONS(3456),
    [aux_sym_preproc_if_token1] = ACTIONS(3456),
    [aux_sym_preproc_if_token2] = ACTIONS(3456),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3456),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3456),
    [sym_preproc_directive] = ACTIONS(3456),
    [anon_sym_LPAREN2] = ACTIONS(3454),
    [anon_sym_BANG] = ACTIONS(3454),
    [anon_sym_TILDE] = ACTIONS(3454),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3454),
    [anon_sym_AMP_AMP] = ACTIONS(3454),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_SEMI] = ACTIONS(3454),
    [anon_sym___extension__] = ACTIONS(3456),
    [anon_sym_typedef] = ACTIONS(3456),
    [anon_sym_in] = ACTIONS(3456),
    [anon_sym_out] = ACTIONS(3456),
    [anon_sym_inout] = ACTIONS(3456),
    [anon_sym_virtual] = ACTIONS(3456),
    [anon_sym_extern] = ACTIONS(3456),
    [anon_sym___attribute__] = ACTIONS(3456),
    [anon_sym___attribute] = ACTIONS(3456),
    [anon_sym_using] = ACTIONS(3456),
    [anon_sym_COLON_COLON] = ACTIONS(3454),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3454),
    [anon_sym___declspec] = ACTIONS(3456),
    [anon_sym___based] = ACTIONS(3456),
    [anon_sym___cdecl] = ACTIONS(3456),
    [anon_sym___clrcall] = ACTIONS(3456),
    [anon_sym___stdcall] = ACTIONS(3456),
    [anon_sym___fastcall] = ACTIONS(3456),
    [anon_sym___thiscall] = ACTIONS(3456),
    [anon_sym___vectorcall] = ACTIONS(3456),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_signed] = ACTIONS(3456),
    [anon_sym_unsigned] = ACTIONS(3456),
    [anon_sym_long] = ACTIONS(3456),
    [anon_sym_short] = ACTIONS(3456),
    [anon_sym_LBRACK] = ACTIONS(3456),
    [anon_sym_static] = ACTIONS(3456),
    [anon_sym_register] = ACTIONS(3456),
    [anon_sym_inline] = ACTIONS(3456),
    [anon_sym___inline] = ACTIONS(3456),
    [anon_sym___inline__] = ACTIONS(3456),
    [anon_sym___forceinline] = ACTIONS(3456),
    [anon_sym_thread_local] = ACTIONS(3456),
    [anon_sym___thread] = ACTIONS(3456),
    [anon_sym_const] = ACTIONS(3456),
    [anon_sym_constexpr] = ACTIONS(3456),
    [anon_sym_volatile] = ACTIONS(3456),
    [anon_sym_restrict] = ACTIONS(3456),
    [anon_sym___restrict__] = ACTIONS(3456),
    [anon_sym__Atomic] = ACTIONS(3456),
    [anon_sym__Noreturn] = ACTIONS(3456),
    [anon_sym_noreturn] = ACTIONS(3456),
    [anon_sym__Nonnull] = ACTIONS(3456),
    [anon_sym_mutable] = ACTIONS(3456),
    [anon_sym_constinit] = ACTIONS(3456),
    [anon_sym_consteval] = ACTIONS(3456),
    [anon_sym_alignas] = ACTIONS(3456),
    [anon_sym__Alignas] = ACTIONS(3456),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_enum] = ACTIONS(3456),
    [anon_sym_class] = ACTIONS(3456),
    [anon_sym_struct] = ACTIONS(3456),
    [anon_sym_union] = ACTIONS(3456),
    [anon_sym_if] = ACTIONS(3456),
    [anon_sym_else] = ACTIONS(3456),
    [anon_sym_switch] = ACTIONS(3456),
    [anon_sym_case] = ACTIONS(3456),
    [anon_sym_default] = ACTIONS(3456),
    [anon_sym_while] = ACTIONS(3456),
    [anon_sym_do] = ACTIONS(3456),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_return] = ACTIONS(3456),
    [anon_sym_break] = ACTIONS(3456),
    [anon_sym_continue] = ACTIONS(3456),
    [anon_sym_goto] = ACTIONS(3456),
    [anon_sym___try] = ACTIONS(3456),
    [anon_sym___leave] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(3456),
    [anon_sym_compl] = ACTIONS(3456),
    [anon_sym_DASH_DASH] = ACTIONS(3454),
    [anon_sym_PLUS_PLUS] = ACTIONS(3454),
    [anon_sym_sizeof] = ACTIONS(3456),
    [anon_sym___alignof__] = ACTIONS(3456),
    [anon_sym___alignof] = ACTIONS(3456),
    [anon_sym__alignof] = ACTIONS(3456),
    [anon_sym_alignof] = ACTIONS(3456),
    [anon_sym__Alignof] = ACTIONS(3456),
    [anon_sym_offsetof] = ACTIONS(3456),
    [anon_sym__Generic] = ACTIONS(3456),
    [anon_sym_asm] = ACTIONS(3456),
    [anon_sym___asm__] = ACTIONS(3456),
    [anon_sym___asm] = ACTIONS(3456),
    [sym_number_literal] = ACTIONS(3454),
    [anon_sym_L_SQUOTE] = ACTIONS(3454),
    [anon_sym_u_SQUOTE] = ACTIONS(3454),
    [anon_sym_U_SQUOTE] = ACTIONS(3454),
    [anon_sym_u8_SQUOTE] = ACTIONS(3454),
    [anon_sym_SQUOTE] = ACTIONS(3454),
    [anon_sym_L_DQUOTE] = ACTIONS(3454),
    [anon_sym_u_DQUOTE] = ACTIONS(3454),
    [anon_sym_U_DQUOTE] = ACTIONS(3454),
    [anon_sym_u8_DQUOTE] = ACTIONS(3454),
    [anon_sym_DQUOTE] = ACTIONS(3454),
    [sym_true] = ACTIONS(3456),
    [sym_false] = ACTIONS(3456),
    [anon_sym_NULL] = ACTIONS(3456),
    [anon_sym_nullptr] = ACTIONS(3456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3456),
    [anon_sym_let] = ACTIONS(3456),
    [anon_sym_This] = ACTIONS(3456),
    [anon_sym_decltype] = ACTIONS(3456),
    [anon_sym_explicit] = ACTIONS(3456),
    [anon_sym_typename] = ACTIONS(3456),
    [anon_sym_template] = ACTIONS(3456),
    [anon_sym_operator] = ACTIONS(3456),
    [anon_sym_try] = ACTIONS(3456),
    [anon_sym_delete] = ACTIONS(3456),
    [anon_sym_throw] = ACTIONS(3456),
    [anon_sym_namespace] = ACTIONS(3456),
    [anon_sym_static_assert] = ACTIONS(3456),
    [anon_sym_concept] = ACTIONS(3456),
    [anon_sym_co_return] = ACTIONS(3456),
    [anon_sym_co_yield] = ACTIONS(3456),
    [anon_sym_R_DQUOTE] = ACTIONS(3454),
    [anon_sym_LR_DQUOTE] = ACTIONS(3454),
    [anon_sym_uR_DQUOTE] = ACTIONS(3454),
    [anon_sym_UR_DQUOTE] = ACTIONS(3454),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3454),
    [anon_sym_co_await] = ACTIONS(3456),
    [anon_sym_new] = ACTIONS(3456),
    [anon_sym_requires] = ACTIONS(3456),
    [sym_this] = ACTIONS(3456),
    [anon_sym_discard] = ACTIONS(3456),
    [anon_sym_precise] = ACTIONS(3456),
    [anon_sym_shared] = ACTIONS(3456),
    [anon_sym_groupshared] = ACTIONS(3456),
    [anon_sym_uniform] = ACTIONS(3456),
    [anon_sym_row_major] = ACTIONS(3456),
    [anon_sym_column_major] = ACTIONS(3456),
    [anon_sym_globallycoherent] = ACTIONS(3456),
    [anon_sym_centroid] = ACTIONS(3456),
    [anon_sym_noperspective] = ACTIONS(3456),
    [anon_sym_nointerpolation] = ACTIONS(3456),
    [anon_sym_sample] = ACTIONS(3456),
    [anon_sym_linear] = ACTIONS(3456),
    [anon_sym_snorm] = ACTIONS(3456),
    [anon_sym_unorm] = ACTIONS(3456),
    [anon_sym_point] = ACTIONS(3456),
    [anon_sym_line] = ACTIONS(3456),
    [anon_sym_triangleadj] = ACTIONS(3456),
    [anon_sym_lineadj] = ACTIONS(3456),
    [anon_sym_triangle] = ACTIONS(3456),
    [anon_sym_cbuffer] = ACTIONS(3456),
    [anon_sym_interface] = ACTIONS(3456),
    [anon_sym_extension] = ACTIONS(3456),
  },
  [864] = {
    [sym_identifier] = ACTIONS(3558),
    [aux_sym_preproc_include_token1] = ACTIONS(3558),
    [aux_sym_preproc_def_token1] = ACTIONS(3558),
    [aux_sym_preproc_if_token1] = ACTIONS(3558),
    [aux_sym_preproc_if_token2] = ACTIONS(3558),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3558),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3558),
    [sym_preproc_directive] = ACTIONS(3558),
    [anon_sym_LPAREN2] = ACTIONS(3556),
    [anon_sym_BANG] = ACTIONS(3556),
    [anon_sym_TILDE] = ACTIONS(3556),
    [anon_sym_DASH] = ACTIONS(3558),
    [anon_sym_PLUS] = ACTIONS(3558),
    [anon_sym_STAR] = ACTIONS(3556),
    [anon_sym_AMP_AMP] = ACTIONS(3556),
    [anon_sym_AMP] = ACTIONS(3558),
    [anon_sym_SEMI] = ACTIONS(3556),
    [anon_sym___extension__] = ACTIONS(3558),
    [anon_sym_typedef] = ACTIONS(3558),
    [anon_sym_in] = ACTIONS(3558),
    [anon_sym_out] = ACTIONS(3558),
    [anon_sym_inout] = ACTIONS(3558),
    [anon_sym_virtual] = ACTIONS(3558),
    [anon_sym_extern] = ACTIONS(3558),
    [anon_sym___attribute__] = ACTIONS(3558),
    [anon_sym___attribute] = ACTIONS(3558),
    [anon_sym_using] = ACTIONS(3558),
    [anon_sym_COLON_COLON] = ACTIONS(3556),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3556),
    [anon_sym___declspec] = ACTIONS(3558),
    [anon_sym___based] = ACTIONS(3558),
    [anon_sym___cdecl] = ACTIONS(3558),
    [anon_sym___clrcall] = ACTIONS(3558),
    [anon_sym___stdcall] = ACTIONS(3558),
    [anon_sym___fastcall] = ACTIONS(3558),
    [anon_sym___thiscall] = ACTIONS(3558),
    [anon_sym___vectorcall] = ACTIONS(3558),
    [anon_sym_LBRACE] = ACTIONS(3556),
    [anon_sym_signed] = ACTIONS(3558),
    [anon_sym_unsigned] = ACTIONS(3558),
    [anon_sym_long] = ACTIONS(3558),
    [anon_sym_short] = ACTIONS(3558),
    [anon_sym_LBRACK] = ACTIONS(3558),
    [anon_sym_static] = ACTIONS(3558),
    [anon_sym_register] = ACTIONS(3558),
    [anon_sym_inline] = ACTIONS(3558),
    [anon_sym___inline] = ACTIONS(3558),
    [anon_sym___inline__] = ACTIONS(3558),
    [anon_sym___forceinline] = ACTIONS(3558),
    [anon_sym_thread_local] = ACTIONS(3558),
    [anon_sym___thread] = ACTIONS(3558),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_constexpr] = ACTIONS(3558),
    [anon_sym_volatile] = ACTIONS(3558),
    [anon_sym_restrict] = ACTIONS(3558),
    [anon_sym___restrict__] = ACTIONS(3558),
    [anon_sym__Atomic] = ACTIONS(3558),
    [anon_sym__Noreturn] = ACTIONS(3558),
    [anon_sym_noreturn] = ACTIONS(3558),
    [anon_sym__Nonnull] = ACTIONS(3558),
    [anon_sym_mutable] = ACTIONS(3558),
    [anon_sym_constinit] = ACTIONS(3558),
    [anon_sym_consteval] = ACTIONS(3558),
    [anon_sym_alignas] = ACTIONS(3558),
    [anon_sym__Alignas] = ACTIONS(3558),
    [sym_primitive_type] = ACTIONS(3558),
    [anon_sym_enum] = ACTIONS(3558),
    [anon_sym_class] = ACTIONS(3558),
    [anon_sym_struct] = ACTIONS(3558),
    [anon_sym_union] = ACTIONS(3558),
    [anon_sym_if] = ACTIONS(3558),
    [anon_sym_else] = ACTIONS(3558),
    [anon_sym_switch] = ACTIONS(3558),
    [anon_sym_case] = ACTIONS(3558),
    [anon_sym_default] = ACTIONS(3558),
    [anon_sym_while] = ACTIONS(3558),
    [anon_sym_do] = ACTIONS(3558),
    [anon_sym_for] = ACTIONS(3558),
    [anon_sym_return] = ACTIONS(3558),
    [anon_sym_break] = ACTIONS(3558),
    [anon_sym_continue] = ACTIONS(3558),
    [anon_sym_goto] = ACTIONS(3558),
    [anon_sym___try] = ACTIONS(3558),
    [anon_sym___leave] = ACTIONS(3558),
    [anon_sym_not] = ACTIONS(3558),
    [anon_sym_compl] = ACTIONS(3558),
    [anon_sym_DASH_DASH] = ACTIONS(3556),
    [anon_sym_PLUS_PLUS] = ACTIONS(3556),
    [anon_sym_sizeof] = ACTIONS(3558),
    [anon_sym___alignof__] = ACTIONS(3558),
    [anon_sym___alignof] = ACTIONS(3558),
    [anon_sym__alignof] = ACTIONS(3558),
    [anon_sym_alignof] = ACTIONS(3558),
    [anon_sym__Alignof] = ACTIONS(3558),
    [anon_sym_offsetof] = ACTIONS(3558),
    [anon_sym__Generic] = ACTIONS(3558),
    [anon_sym_asm] = ACTIONS(3558),
    [anon_sym___asm__] = ACTIONS(3558),
    [anon_sym___asm] = ACTIONS(3558),
    [sym_number_literal] = ACTIONS(3556),
    [anon_sym_L_SQUOTE] = ACTIONS(3556),
    [anon_sym_u_SQUOTE] = ACTIONS(3556),
    [anon_sym_U_SQUOTE] = ACTIONS(3556),
    [anon_sym_u8_SQUOTE] = ACTIONS(3556),
    [anon_sym_SQUOTE] = ACTIONS(3556),
    [anon_sym_L_DQUOTE] = ACTIONS(3556),
    [anon_sym_u_DQUOTE] = ACTIONS(3556),
    [anon_sym_U_DQUOTE] = ACTIONS(3556),
    [anon_sym_u8_DQUOTE] = ACTIONS(3556),
    [anon_sym_DQUOTE] = ACTIONS(3556),
    [sym_true] = ACTIONS(3558),
    [sym_false] = ACTIONS(3558),
    [anon_sym_NULL] = ACTIONS(3558),
    [anon_sym_nullptr] = ACTIONS(3558),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3558),
    [anon_sym_let] = ACTIONS(3558),
    [anon_sym_This] = ACTIONS(3558),
    [anon_sym_decltype] = ACTIONS(3558),
    [anon_sym_explicit] = ACTIONS(3558),
    [anon_sym_typename] = ACTIONS(3558),
    [anon_sym_template] = ACTIONS(3558),
    [anon_sym_operator] = ACTIONS(3558),
    [anon_sym_try] = ACTIONS(3558),
    [anon_sym_delete] = ACTIONS(3558),
    [anon_sym_throw] = ACTIONS(3558),
    [anon_sym_namespace] = ACTIONS(3558),
    [anon_sym_static_assert] = ACTIONS(3558),
    [anon_sym_concept] = ACTIONS(3558),
    [anon_sym_co_return] = ACTIONS(3558),
    [anon_sym_co_yield] = ACTIONS(3558),
    [anon_sym_R_DQUOTE] = ACTIONS(3556),
    [anon_sym_LR_DQUOTE] = ACTIONS(3556),
    [anon_sym_uR_DQUOTE] = ACTIONS(3556),
    [anon_sym_UR_DQUOTE] = ACTIONS(3556),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3556),
    [anon_sym_co_await] = ACTIONS(3558),
    [anon_sym_new] = ACTIONS(3558),
    [anon_sym_requires] = ACTIONS(3558),
    [sym_this] = ACTIONS(3558),
    [anon_sym_discard] = ACTIONS(3558),
    [anon_sym_precise] = ACTIONS(3558),
    [anon_sym_shared] = ACTIONS(3558),
    [anon_sym_groupshared] = ACTIONS(3558),
    [anon_sym_uniform] = ACTIONS(3558),
    [anon_sym_row_major] = ACTIONS(3558),
    [anon_sym_column_major] = ACTIONS(3558),
    [anon_sym_globallycoherent] = ACTIONS(3558),
    [anon_sym_centroid] = ACTIONS(3558),
    [anon_sym_noperspective] = ACTIONS(3558),
    [anon_sym_nointerpolation] = ACTIONS(3558),
    [anon_sym_sample] = ACTIONS(3558),
    [anon_sym_linear] = ACTIONS(3558),
    [anon_sym_snorm] = ACTIONS(3558),
    [anon_sym_unorm] = ACTIONS(3558),
    [anon_sym_point] = ACTIONS(3558),
    [anon_sym_line] = ACTIONS(3558),
    [anon_sym_triangleadj] = ACTIONS(3558),
    [anon_sym_lineadj] = ACTIONS(3558),
    [anon_sym_triangle] = ACTIONS(3558),
    [anon_sym_cbuffer] = ACTIONS(3558),
    [anon_sym_interface] = ACTIONS(3558),
    [anon_sym_extension] = ACTIONS(3558),
  },
  [865] = {
    [sym_identifier] = ACTIONS(3462),
    [aux_sym_preproc_include_token1] = ACTIONS(3462),
    [aux_sym_preproc_def_token1] = ACTIONS(3462),
    [aux_sym_preproc_if_token1] = ACTIONS(3462),
    [aux_sym_preproc_if_token2] = ACTIONS(3462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3462),
    [sym_preproc_directive] = ACTIONS(3462),
    [anon_sym_LPAREN2] = ACTIONS(3464),
    [anon_sym_BANG] = ACTIONS(3464),
    [anon_sym_TILDE] = ACTIONS(3464),
    [anon_sym_DASH] = ACTIONS(3462),
    [anon_sym_PLUS] = ACTIONS(3462),
    [anon_sym_STAR] = ACTIONS(3464),
    [anon_sym_AMP_AMP] = ACTIONS(3464),
    [anon_sym_AMP] = ACTIONS(3462),
    [anon_sym_SEMI] = ACTIONS(3464),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_typedef] = ACTIONS(3462),
    [anon_sym_in] = ACTIONS(3462),
    [anon_sym_out] = ACTIONS(3462),
    [anon_sym_inout] = ACTIONS(3462),
    [anon_sym_virtual] = ACTIONS(3462),
    [anon_sym_extern] = ACTIONS(3462),
    [anon_sym___attribute__] = ACTIONS(3462),
    [anon_sym___attribute] = ACTIONS(3462),
    [anon_sym_using] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3464),
    [anon_sym___declspec] = ACTIONS(3462),
    [anon_sym___based] = ACTIONS(3462),
    [anon_sym___cdecl] = ACTIONS(3462),
    [anon_sym___clrcall] = ACTIONS(3462),
    [anon_sym___stdcall] = ACTIONS(3462),
    [anon_sym___fastcall] = ACTIONS(3462),
    [anon_sym___thiscall] = ACTIONS(3462),
    [anon_sym___vectorcall] = ACTIONS(3462),
    [anon_sym_LBRACE] = ACTIONS(3464),
    [anon_sym_signed] = ACTIONS(3462),
    [anon_sym_unsigned] = ACTIONS(3462),
    [anon_sym_long] = ACTIONS(3462),
    [anon_sym_short] = ACTIONS(3462),
    [anon_sym_LBRACK] = ACTIONS(3462),
    [anon_sym_static] = ACTIONS(3462),
    [anon_sym_register] = ACTIONS(3462),
    [anon_sym_inline] = ACTIONS(3462),
    [anon_sym___inline] = ACTIONS(3462),
    [anon_sym___inline__] = ACTIONS(3462),
    [anon_sym___forceinline] = ACTIONS(3462),
    [anon_sym_thread_local] = ACTIONS(3462),
    [anon_sym___thread] = ACTIONS(3462),
    [anon_sym_const] = ACTIONS(3462),
    [anon_sym_constexpr] = ACTIONS(3462),
    [anon_sym_volatile] = ACTIONS(3462),
    [anon_sym_restrict] = ACTIONS(3462),
    [anon_sym___restrict__] = ACTIONS(3462),
    [anon_sym__Atomic] = ACTIONS(3462),
    [anon_sym__Noreturn] = ACTIONS(3462),
    [anon_sym_noreturn] = ACTIONS(3462),
    [anon_sym__Nonnull] = ACTIONS(3462),
    [anon_sym_mutable] = ACTIONS(3462),
    [anon_sym_constinit] = ACTIONS(3462),
    [anon_sym_consteval] = ACTIONS(3462),
    [anon_sym_alignas] = ACTIONS(3462),
    [anon_sym__Alignas] = ACTIONS(3462),
    [sym_primitive_type] = ACTIONS(3462),
    [anon_sym_enum] = ACTIONS(3462),
    [anon_sym_class] = ACTIONS(3462),
    [anon_sym_struct] = ACTIONS(3462),
    [anon_sym_union] = ACTIONS(3462),
    [anon_sym_if] = ACTIONS(3462),
    [anon_sym_else] = ACTIONS(3462),
    [anon_sym_switch] = ACTIONS(3462),
    [anon_sym_case] = ACTIONS(3462),
    [anon_sym_default] = ACTIONS(3462),
    [anon_sym_while] = ACTIONS(3462),
    [anon_sym_do] = ACTIONS(3462),
    [anon_sym_for] = ACTIONS(3462),
    [anon_sym_return] = ACTIONS(3462),
    [anon_sym_break] = ACTIONS(3462),
    [anon_sym_continue] = ACTIONS(3462),
    [anon_sym_goto] = ACTIONS(3462),
    [anon_sym___try] = ACTIONS(3462),
    [anon_sym___leave] = ACTIONS(3462),
    [anon_sym_not] = ACTIONS(3462),
    [anon_sym_compl] = ACTIONS(3462),
    [anon_sym_DASH_DASH] = ACTIONS(3464),
    [anon_sym_PLUS_PLUS] = ACTIONS(3464),
    [anon_sym_sizeof] = ACTIONS(3462),
    [anon_sym___alignof__] = ACTIONS(3462),
    [anon_sym___alignof] = ACTIONS(3462),
    [anon_sym__alignof] = ACTIONS(3462),
    [anon_sym_alignof] = ACTIONS(3462),
    [anon_sym__Alignof] = ACTIONS(3462),
    [anon_sym_offsetof] = ACTIONS(3462),
    [anon_sym__Generic] = ACTIONS(3462),
    [anon_sym_asm] = ACTIONS(3462),
    [anon_sym___asm__] = ACTIONS(3462),
    [anon_sym___asm] = ACTIONS(3462),
    [sym_number_literal] = ACTIONS(3464),
    [anon_sym_L_SQUOTE] = ACTIONS(3464),
    [anon_sym_u_SQUOTE] = ACTIONS(3464),
    [anon_sym_U_SQUOTE] = ACTIONS(3464),
    [anon_sym_u8_SQUOTE] = ACTIONS(3464),
    [anon_sym_SQUOTE] = ACTIONS(3464),
    [anon_sym_L_DQUOTE] = ACTIONS(3464),
    [anon_sym_u_DQUOTE] = ACTIONS(3464),
    [anon_sym_U_DQUOTE] = ACTIONS(3464),
    [anon_sym_u8_DQUOTE] = ACTIONS(3464),
    [anon_sym_DQUOTE] = ACTIONS(3464),
    [sym_true] = ACTIONS(3462),
    [sym_false] = ACTIONS(3462),
    [anon_sym_NULL] = ACTIONS(3462),
    [anon_sym_nullptr] = ACTIONS(3462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3462),
    [anon_sym_let] = ACTIONS(3462),
    [anon_sym_This] = ACTIONS(3462),
    [anon_sym_decltype] = ACTIONS(3462),
    [anon_sym_explicit] = ACTIONS(3462),
    [anon_sym_typename] = ACTIONS(3462),
    [anon_sym_template] = ACTIONS(3462),
    [anon_sym_operator] = ACTIONS(3462),
    [anon_sym_try] = ACTIONS(3462),
    [anon_sym_delete] = ACTIONS(3462),
    [anon_sym_throw] = ACTIONS(3462),
    [anon_sym_namespace] = ACTIONS(3462),
    [anon_sym_static_assert] = ACTIONS(3462),
    [anon_sym_concept] = ACTIONS(3462),
    [anon_sym_co_return] = ACTIONS(3462),
    [anon_sym_co_yield] = ACTIONS(3462),
    [anon_sym_R_DQUOTE] = ACTIONS(3464),
    [anon_sym_LR_DQUOTE] = ACTIONS(3464),
    [anon_sym_uR_DQUOTE] = ACTIONS(3464),
    [anon_sym_UR_DQUOTE] = ACTIONS(3464),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3464),
    [anon_sym_co_await] = ACTIONS(3462),
    [anon_sym_new] = ACTIONS(3462),
    [anon_sym_requires] = ACTIONS(3462),
    [sym_this] = ACTIONS(3462),
    [anon_sym_discard] = ACTIONS(3462),
    [anon_sym_precise] = ACTIONS(3462),
    [anon_sym_shared] = ACTIONS(3462),
    [anon_sym_groupshared] = ACTIONS(3462),
    [anon_sym_uniform] = ACTIONS(3462),
    [anon_sym_row_major] = ACTIONS(3462),
    [anon_sym_column_major] = ACTIONS(3462),
    [anon_sym_globallycoherent] = ACTIONS(3462),
    [anon_sym_centroid] = ACTIONS(3462),
    [anon_sym_noperspective] = ACTIONS(3462),
    [anon_sym_nointerpolation] = ACTIONS(3462),
    [anon_sym_sample] = ACTIONS(3462),
    [anon_sym_linear] = ACTIONS(3462),
    [anon_sym_snorm] = ACTIONS(3462),
    [anon_sym_unorm] = ACTIONS(3462),
    [anon_sym_point] = ACTIONS(3462),
    [anon_sym_line] = ACTIONS(3462),
    [anon_sym_triangleadj] = ACTIONS(3462),
    [anon_sym_lineadj] = ACTIONS(3462),
    [anon_sym_triangle] = ACTIONS(3462),
    [anon_sym_cbuffer] = ACTIONS(3462),
    [anon_sym_interface] = ACTIONS(3462),
    [anon_sym_extension] = ACTIONS(3462),
  },
  [866] = {
    [sym_identifier] = ACTIONS(3466),
    [aux_sym_preproc_include_token1] = ACTIONS(3466),
    [aux_sym_preproc_def_token1] = ACTIONS(3466),
    [aux_sym_preproc_if_token1] = ACTIONS(3466),
    [aux_sym_preproc_if_token2] = ACTIONS(3466),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3466),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3466),
    [sym_preproc_directive] = ACTIONS(3466),
    [anon_sym_LPAREN2] = ACTIONS(3468),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3466),
    [anon_sym_PLUS] = ACTIONS(3466),
    [anon_sym_STAR] = ACTIONS(3468),
    [anon_sym_AMP_AMP] = ACTIONS(3468),
    [anon_sym_AMP] = ACTIONS(3466),
    [anon_sym_SEMI] = ACTIONS(3468),
    [anon_sym___extension__] = ACTIONS(3466),
    [anon_sym_typedef] = ACTIONS(3466),
    [anon_sym_in] = ACTIONS(3466),
    [anon_sym_out] = ACTIONS(3466),
    [anon_sym_inout] = ACTIONS(3466),
    [anon_sym_virtual] = ACTIONS(3466),
    [anon_sym_extern] = ACTIONS(3466),
    [anon_sym___attribute__] = ACTIONS(3466),
    [anon_sym___attribute] = ACTIONS(3466),
    [anon_sym_using] = ACTIONS(3466),
    [anon_sym_COLON_COLON] = ACTIONS(3468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3468),
    [anon_sym___declspec] = ACTIONS(3466),
    [anon_sym___based] = ACTIONS(3466),
    [anon_sym___cdecl] = ACTIONS(3466),
    [anon_sym___clrcall] = ACTIONS(3466),
    [anon_sym___stdcall] = ACTIONS(3466),
    [anon_sym___fastcall] = ACTIONS(3466),
    [anon_sym___thiscall] = ACTIONS(3466),
    [anon_sym___vectorcall] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_signed] = ACTIONS(3466),
    [anon_sym_unsigned] = ACTIONS(3466),
    [anon_sym_long] = ACTIONS(3466),
    [anon_sym_short] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(3466),
    [anon_sym_static] = ACTIONS(3466),
    [anon_sym_register] = ACTIONS(3466),
    [anon_sym_inline] = ACTIONS(3466),
    [anon_sym___inline] = ACTIONS(3466),
    [anon_sym___inline__] = ACTIONS(3466),
    [anon_sym___forceinline] = ACTIONS(3466),
    [anon_sym_thread_local] = ACTIONS(3466),
    [anon_sym___thread] = ACTIONS(3466),
    [anon_sym_const] = ACTIONS(3466),
    [anon_sym_constexpr] = ACTIONS(3466),
    [anon_sym_volatile] = ACTIONS(3466),
    [anon_sym_restrict] = ACTIONS(3466),
    [anon_sym___restrict__] = ACTIONS(3466),
    [anon_sym__Atomic] = ACTIONS(3466),
    [anon_sym__Noreturn] = ACTIONS(3466),
    [anon_sym_noreturn] = ACTIONS(3466),
    [anon_sym__Nonnull] = ACTIONS(3466),
    [anon_sym_mutable] = ACTIONS(3466),
    [anon_sym_constinit] = ACTIONS(3466),
    [anon_sym_consteval] = ACTIONS(3466),
    [anon_sym_alignas] = ACTIONS(3466),
    [anon_sym__Alignas] = ACTIONS(3466),
    [sym_primitive_type] = ACTIONS(3466),
    [anon_sym_enum] = ACTIONS(3466),
    [anon_sym_class] = ACTIONS(3466),
    [anon_sym_struct] = ACTIONS(3466),
    [anon_sym_union] = ACTIONS(3466),
    [anon_sym_if] = ACTIONS(3466),
    [anon_sym_else] = ACTIONS(3466),
    [anon_sym_switch] = ACTIONS(3466),
    [anon_sym_case] = ACTIONS(3466),
    [anon_sym_default] = ACTIONS(3466),
    [anon_sym_while] = ACTIONS(3466),
    [anon_sym_do] = ACTIONS(3466),
    [anon_sym_for] = ACTIONS(3466),
    [anon_sym_return] = ACTIONS(3466),
    [anon_sym_break] = ACTIONS(3466),
    [anon_sym_continue] = ACTIONS(3466),
    [anon_sym_goto] = ACTIONS(3466),
    [anon_sym___try] = ACTIONS(3466),
    [anon_sym___leave] = ACTIONS(3466),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_compl] = ACTIONS(3466),
    [anon_sym_DASH_DASH] = ACTIONS(3468),
    [anon_sym_PLUS_PLUS] = ACTIONS(3468),
    [anon_sym_sizeof] = ACTIONS(3466),
    [anon_sym___alignof__] = ACTIONS(3466),
    [anon_sym___alignof] = ACTIONS(3466),
    [anon_sym__alignof] = ACTIONS(3466),
    [anon_sym_alignof] = ACTIONS(3466),
    [anon_sym__Alignof] = ACTIONS(3466),
    [anon_sym_offsetof] = ACTIONS(3466),
    [anon_sym__Generic] = ACTIONS(3466),
    [anon_sym_asm] = ACTIONS(3466),
    [anon_sym___asm__] = ACTIONS(3466),
    [anon_sym___asm] = ACTIONS(3466),
    [sym_number_literal] = ACTIONS(3468),
    [anon_sym_L_SQUOTE] = ACTIONS(3468),
    [anon_sym_u_SQUOTE] = ACTIONS(3468),
    [anon_sym_U_SQUOTE] = ACTIONS(3468),
    [anon_sym_u8_SQUOTE] = ACTIONS(3468),
    [anon_sym_SQUOTE] = ACTIONS(3468),
    [anon_sym_L_DQUOTE] = ACTIONS(3468),
    [anon_sym_u_DQUOTE] = ACTIONS(3468),
    [anon_sym_U_DQUOTE] = ACTIONS(3468),
    [anon_sym_u8_DQUOTE] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3468),
    [sym_true] = ACTIONS(3466),
    [sym_false] = ACTIONS(3466),
    [anon_sym_NULL] = ACTIONS(3466),
    [anon_sym_nullptr] = ACTIONS(3466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3466),
    [anon_sym_let] = ACTIONS(3466),
    [anon_sym_This] = ACTIONS(3466),
    [anon_sym_decltype] = ACTIONS(3466),
    [anon_sym_explicit] = ACTIONS(3466),
    [anon_sym_typename] = ACTIONS(3466),
    [anon_sym_template] = ACTIONS(3466),
    [anon_sym_operator] = ACTIONS(3466),
    [anon_sym_try] = ACTIONS(3466),
    [anon_sym_delete] = ACTIONS(3466),
    [anon_sym_throw] = ACTIONS(3466),
    [anon_sym_namespace] = ACTIONS(3466),
    [anon_sym_static_assert] = ACTIONS(3466),
    [anon_sym_concept] = ACTIONS(3466),
    [anon_sym_co_return] = ACTIONS(3466),
    [anon_sym_co_yield] = ACTIONS(3466),
    [anon_sym_R_DQUOTE] = ACTIONS(3468),
    [anon_sym_LR_DQUOTE] = ACTIONS(3468),
    [anon_sym_uR_DQUOTE] = ACTIONS(3468),
    [anon_sym_UR_DQUOTE] = ACTIONS(3468),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3468),
    [anon_sym_co_await] = ACTIONS(3466),
    [anon_sym_new] = ACTIONS(3466),
    [anon_sym_requires] = ACTIONS(3466),
    [sym_this] = ACTIONS(3466),
    [anon_sym_discard] = ACTIONS(3466),
    [anon_sym_precise] = ACTIONS(3466),
    [anon_sym_shared] = ACTIONS(3466),
    [anon_sym_groupshared] = ACTIONS(3466),
    [anon_sym_uniform] = ACTIONS(3466),
    [anon_sym_row_major] = ACTIONS(3466),
    [anon_sym_column_major] = ACTIONS(3466),
    [anon_sym_globallycoherent] = ACTIONS(3466),
    [anon_sym_centroid] = ACTIONS(3466),
    [anon_sym_noperspective] = ACTIONS(3466),
    [anon_sym_nointerpolation] = ACTIONS(3466),
    [anon_sym_sample] = ACTIONS(3466),
    [anon_sym_linear] = ACTIONS(3466),
    [anon_sym_snorm] = ACTIONS(3466),
    [anon_sym_unorm] = ACTIONS(3466),
    [anon_sym_point] = ACTIONS(3466),
    [anon_sym_line] = ACTIONS(3466),
    [anon_sym_triangleadj] = ACTIONS(3466),
    [anon_sym_lineadj] = ACTIONS(3466),
    [anon_sym_triangle] = ACTIONS(3466),
    [anon_sym_cbuffer] = ACTIONS(3466),
    [anon_sym_interface] = ACTIONS(3466),
    [anon_sym_extension] = ACTIONS(3466),
  },
  [867] = {
    [sym_identifier] = ACTIONS(3470),
    [aux_sym_preproc_include_token1] = ACTIONS(3470),
    [aux_sym_preproc_def_token1] = ACTIONS(3470),
    [aux_sym_preproc_if_token1] = ACTIONS(3470),
    [aux_sym_preproc_if_token2] = ACTIONS(3470),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3470),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3470),
    [sym_preproc_directive] = ACTIONS(3470),
    [anon_sym_LPAREN2] = ACTIONS(3472),
    [anon_sym_BANG] = ACTIONS(3472),
    [anon_sym_TILDE] = ACTIONS(3472),
    [anon_sym_DASH] = ACTIONS(3470),
    [anon_sym_PLUS] = ACTIONS(3470),
    [anon_sym_STAR] = ACTIONS(3472),
    [anon_sym_AMP_AMP] = ACTIONS(3472),
    [anon_sym_AMP] = ACTIONS(3470),
    [anon_sym_SEMI] = ACTIONS(3472),
    [anon_sym___extension__] = ACTIONS(3470),
    [anon_sym_typedef] = ACTIONS(3470),
    [anon_sym_in] = ACTIONS(3470),
    [anon_sym_out] = ACTIONS(3470),
    [anon_sym_inout] = ACTIONS(3470),
    [anon_sym_virtual] = ACTIONS(3470),
    [anon_sym_extern] = ACTIONS(3470),
    [anon_sym___attribute__] = ACTIONS(3470),
    [anon_sym___attribute] = ACTIONS(3470),
    [anon_sym_using] = ACTIONS(3470),
    [anon_sym_COLON_COLON] = ACTIONS(3472),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3472),
    [anon_sym___declspec] = ACTIONS(3470),
    [anon_sym___based] = ACTIONS(3470),
    [anon_sym___cdecl] = ACTIONS(3470),
    [anon_sym___clrcall] = ACTIONS(3470),
    [anon_sym___stdcall] = ACTIONS(3470),
    [anon_sym___fastcall] = ACTIONS(3470),
    [anon_sym___thiscall] = ACTIONS(3470),
    [anon_sym___vectorcall] = ACTIONS(3470),
    [anon_sym_LBRACE] = ACTIONS(3472),
    [anon_sym_signed] = ACTIONS(3470),
    [anon_sym_unsigned] = ACTIONS(3470),
    [anon_sym_long] = ACTIONS(3470),
    [anon_sym_short] = ACTIONS(3470),
    [anon_sym_LBRACK] = ACTIONS(3470),
    [anon_sym_static] = ACTIONS(3470),
    [anon_sym_register] = ACTIONS(3470),
    [anon_sym_inline] = ACTIONS(3470),
    [anon_sym___inline] = ACTIONS(3470),
    [anon_sym___inline__] = ACTIONS(3470),
    [anon_sym___forceinline] = ACTIONS(3470),
    [anon_sym_thread_local] = ACTIONS(3470),
    [anon_sym___thread] = ACTIONS(3470),
    [anon_sym_const] = ACTIONS(3470),
    [anon_sym_constexpr] = ACTIONS(3470),
    [anon_sym_volatile] = ACTIONS(3470),
    [anon_sym_restrict] = ACTIONS(3470),
    [anon_sym___restrict__] = ACTIONS(3470),
    [anon_sym__Atomic] = ACTIONS(3470),
    [anon_sym__Noreturn] = ACTIONS(3470),
    [anon_sym_noreturn] = ACTIONS(3470),
    [anon_sym__Nonnull] = ACTIONS(3470),
    [anon_sym_mutable] = ACTIONS(3470),
    [anon_sym_constinit] = ACTIONS(3470),
    [anon_sym_consteval] = ACTIONS(3470),
    [anon_sym_alignas] = ACTIONS(3470),
    [anon_sym__Alignas] = ACTIONS(3470),
    [sym_primitive_type] = ACTIONS(3470),
    [anon_sym_enum] = ACTIONS(3470),
    [anon_sym_class] = ACTIONS(3470),
    [anon_sym_struct] = ACTIONS(3470),
    [anon_sym_union] = ACTIONS(3470),
    [anon_sym_if] = ACTIONS(3470),
    [anon_sym_else] = ACTIONS(3470),
    [anon_sym_switch] = ACTIONS(3470),
    [anon_sym_case] = ACTIONS(3470),
    [anon_sym_default] = ACTIONS(3470),
    [anon_sym_while] = ACTIONS(3470),
    [anon_sym_do] = ACTIONS(3470),
    [anon_sym_for] = ACTIONS(3470),
    [anon_sym_return] = ACTIONS(3470),
    [anon_sym_break] = ACTIONS(3470),
    [anon_sym_continue] = ACTIONS(3470),
    [anon_sym_goto] = ACTIONS(3470),
    [anon_sym___try] = ACTIONS(3470),
    [anon_sym___leave] = ACTIONS(3470),
    [anon_sym_not] = ACTIONS(3470),
    [anon_sym_compl] = ACTIONS(3470),
    [anon_sym_DASH_DASH] = ACTIONS(3472),
    [anon_sym_PLUS_PLUS] = ACTIONS(3472),
    [anon_sym_sizeof] = ACTIONS(3470),
    [anon_sym___alignof__] = ACTIONS(3470),
    [anon_sym___alignof] = ACTIONS(3470),
    [anon_sym__alignof] = ACTIONS(3470),
    [anon_sym_alignof] = ACTIONS(3470),
    [anon_sym__Alignof] = ACTIONS(3470),
    [anon_sym_offsetof] = ACTIONS(3470),
    [anon_sym__Generic] = ACTIONS(3470),
    [anon_sym_asm] = ACTIONS(3470),
    [anon_sym___asm__] = ACTIONS(3470),
    [anon_sym___asm] = ACTIONS(3470),
    [sym_number_literal] = ACTIONS(3472),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3472),
    [anon_sym_u_DQUOTE] = ACTIONS(3472),
    [anon_sym_U_DQUOTE] = ACTIONS(3472),
    [anon_sym_u8_DQUOTE] = ACTIONS(3472),
    [anon_sym_DQUOTE] = ACTIONS(3472),
    [sym_true] = ACTIONS(3470),
    [sym_false] = ACTIONS(3470),
    [anon_sym_NULL] = ACTIONS(3470),
    [anon_sym_nullptr] = ACTIONS(3470),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3470),
    [anon_sym_let] = ACTIONS(3470),
    [anon_sym_This] = ACTIONS(3470),
    [anon_sym_decltype] = ACTIONS(3470),
    [anon_sym_explicit] = ACTIONS(3470),
    [anon_sym_typename] = ACTIONS(3470),
    [anon_sym_template] = ACTIONS(3470),
    [anon_sym_operator] = ACTIONS(3470),
    [anon_sym_try] = ACTIONS(3470),
    [anon_sym_delete] = ACTIONS(3470),
    [anon_sym_throw] = ACTIONS(3470),
    [anon_sym_namespace] = ACTIONS(3470),
    [anon_sym_static_assert] = ACTIONS(3470),
    [anon_sym_concept] = ACTIONS(3470),
    [anon_sym_co_return] = ACTIONS(3470),
    [anon_sym_co_yield] = ACTIONS(3470),
    [anon_sym_R_DQUOTE] = ACTIONS(3472),
    [anon_sym_LR_DQUOTE] = ACTIONS(3472),
    [anon_sym_uR_DQUOTE] = ACTIONS(3472),
    [anon_sym_UR_DQUOTE] = ACTIONS(3472),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3472),
    [anon_sym_co_await] = ACTIONS(3470),
    [anon_sym_new] = ACTIONS(3470),
    [anon_sym_requires] = ACTIONS(3470),
    [sym_this] = ACTIONS(3470),
    [anon_sym_discard] = ACTIONS(3470),
    [anon_sym_precise] = ACTIONS(3470),
    [anon_sym_shared] = ACTIONS(3470),
    [anon_sym_groupshared] = ACTIONS(3470),
    [anon_sym_uniform] = ACTIONS(3470),
    [anon_sym_row_major] = ACTIONS(3470),
    [anon_sym_column_major] = ACTIONS(3470),
    [anon_sym_globallycoherent] = ACTIONS(3470),
    [anon_sym_centroid] = ACTIONS(3470),
    [anon_sym_noperspective] = ACTIONS(3470),
    [anon_sym_nointerpolation] = ACTIONS(3470),
    [anon_sym_sample] = ACTIONS(3470),
    [anon_sym_linear] = ACTIONS(3470),
    [anon_sym_snorm] = ACTIONS(3470),
    [anon_sym_unorm] = ACTIONS(3470),
    [anon_sym_point] = ACTIONS(3470),
    [anon_sym_line] = ACTIONS(3470),
    [anon_sym_triangleadj] = ACTIONS(3470),
    [anon_sym_lineadj] = ACTIONS(3470),
    [anon_sym_triangle] = ACTIONS(3470),
    [anon_sym_cbuffer] = ACTIONS(3470),
    [anon_sym_interface] = ACTIONS(3470),
    [anon_sym_extension] = ACTIONS(3470),
  },
  [868] = {
    [sym_identifier] = ACTIONS(3506),
    [aux_sym_preproc_include_token1] = ACTIONS(3506),
    [aux_sym_preproc_def_token1] = ACTIONS(3506),
    [aux_sym_preproc_if_token1] = ACTIONS(3506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3506),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3506),
    [sym_preproc_directive] = ACTIONS(3506),
    [anon_sym_LPAREN2] = ACTIONS(3508),
    [anon_sym_BANG] = ACTIONS(3508),
    [anon_sym_TILDE] = ACTIONS(3508),
    [anon_sym_DASH] = ACTIONS(3506),
    [anon_sym_PLUS] = ACTIONS(3506),
    [anon_sym_STAR] = ACTIONS(3508),
    [anon_sym_AMP_AMP] = ACTIONS(3508),
    [anon_sym_AMP] = ACTIONS(3506),
    [anon_sym_SEMI] = ACTIONS(3508),
    [anon_sym___extension__] = ACTIONS(3506),
    [anon_sym_typedef] = ACTIONS(3506),
    [anon_sym_in] = ACTIONS(3506),
    [anon_sym_out] = ACTIONS(3506),
    [anon_sym_inout] = ACTIONS(3506),
    [anon_sym_virtual] = ACTIONS(3506),
    [anon_sym_extern] = ACTIONS(3506),
    [anon_sym___attribute__] = ACTIONS(3506),
    [anon_sym___attribute] = ACTIONS(3506),
    [anon_sym_using] = ACTIONS(3506),
    [anon_sym_COLON_COLON] = ACTIONS(3508),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3508),
    [anon_sym___declspec] = ACTIONS(3506),
    [anon_sym___based] = ACTIONS(3506),
    [anon_sym___cdecl] = ACTIONS(3506),
    [anon_sym___clrcall] = ACTIONS(3506),
    [anon_sym___stdcall] = ACTIONS(3506),
    [anon_sym___fastcall] = ACTIONS(3506),
    [anon_sym___thiscall] = ACTIONS(3506),
    [anon_sym___vectorcall] = ACTIONS(3506),
    [anon_sym_LBRACE] = ACTIONS(3508),
    [anon_sym_RBRACE] = ACTIONS(3508),
    [anon_sym_signed] = ACTIONS(3506),
    [anon_sym_unsigned] = ACTIONS(3506),
    [anon_sym_long] = ACTIONS(3506),
    [anon_sym_short] = ACTIONS(3506),
    [anon_sym_LBRACK] = ACTIONS(3506),
    [anon_sym_static] = ACTIONS(3506),
    [anon_sym_register] = ACTIONS(3506),
    [anon_sym_inline] = ACTIONS(3506),
    [anon_sym___inline] = ACTIONS(3506),
    [anon_sym___inline__] = ACTIONS(3506),
    [anon_sym___forceinline] = ACTIONS(3506),
    [anon_sym_thread_local] = ACTIONS(3506),
    [anon_sym___thread] = ACTIONS(3506),
    [anon_sym_const] = ACTIONS(3506),
    [anon_sym_constexpr] = ACTIONS(3506),
    [anon_sym_volatile] = ACTIONS(3506),
    [anon_sym_restrict] = ACTIONS(3506),
    [anon_sym___restrict__] = ACTIONS(3506),
    [anon_sym__Atomic] = ACTIONS(3506),
    [anon_sym__Noreturn] = ACTIONS(3506),
    [anon_sym_noreturn] = ACTIONS(3506),
    [anon_sym__Nonnull] = ACTIONS(3506),
    [anon_sym_mutable] = ACTIONS(3506),
    [anon_sym_constinit] = ACTIONS(3506),
    [anon_sym_consteval] = ACTIONS(3506),
    [anon_sym_alignas] = ACTIONS(3506),
    [anon_sym__Alignas] = ACTIONS(3506),
    [sym_primitive_type] = ACTIONS(3506),
    [anon_sym_enum] = ACTIONS(3506),
    [anon_sym_class] = ACTIONS(3506),
    [anon_sym_struct] = ACTIONS(3506),
    [anon_sym_union] = ACTIONS(3506),
    [anon_sym_if] = ACTIONS(3506),
    [anon_sym_else] = ACTIONS(3506),
    [anon_sym_switch] = ACTIONS(3506),
    [anon_sym_case] = ACTIONS(3506),
    [anon_sym_default] = ACTIONS(3506),
    [anon_sym_while] = ACTIONS(3506),
    [anon_sym_do] = ACTIONS(3506),
    [anon_sym_for] = ACTIONS(3506),
    [anon_sym_return] = ACTIONS(3506),
    [anon_sym_break] = ACTIONS(3506),
    [anon_sym_continue] = ACTIONS(3506),
    [anon_sym_goto] = ACTIONS(3506),
    [anon_sym___try] = ACTIONS(3506),
    [anon_sym___leave] = ACTIONS(3506),
    [anon_sym_not] = ACTIONS(3506),
    [anon_sym_compl] = ACTIONS(3506),
    [anon_sym_DASH_DASH] = ACTIONS(3508),
    [anon_sym_PLUS_PLUS] = ACTIONS(3508),
    [anon_sym_sizeof] = ACTIONS(3506),
    [anon_sym___alignof__] = ACTIONS(3506),
    [anon_sym___alignof] = ACTIONS(3506),
    [anon_sym__alignof] = ACTIONS(3506),
    [anon_sym_alignof] = ACTIONS(3506),
    [anon_sym__Alignof] = ACTIONS(3506),
    [anon_sym_offsetof] = ACTIONS(3506),
    [anon_sym__Generic] = ACTIONS(3506),
    [anon_sym_asm] = ACTIONS(3506),
    [anon_sym___asm__] = ACTIONS(3506),
    [anon_sym___asm] = ACTIONS(3506),
    [sym_number_literal] = ACTIONS(3508),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3508),
    [anon_sym_u_DQUOTE] = ACTIONS(3508),
    [anon_sym_U_DQUOTE] = ACTIONS(3508),
    [anon_sym_u8_DQUOTE] = ACTIONS(3508),
    [anon_sym_DQUOTE] = ACTIONS(3508),
    [sym_true] = ACTIONS(3506),
    [sym_false] = ACTIONS(3506),
    [anon_sym_NULL] = ACTIONS(3506),
    [anon_sym_nullptr] = ACTIONS(3506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3506),
    [anon_sym_let] = ACTIONS(3506),
    [anon_sym_This] = ACTIONS(3506),
    [anon_sym_decltype] = ACTIONS(3506),
    [anon_sym_explicit] = ACTIONS(3506),
    [anon_sym_typename] = ACTIONS(3506),
    [anon_sym_template] = ACTIONS(3506),
    [anon_sym_operator] = ACTIONS(3506),
    [anon_sym_try] = ACTIONS(3506),
    [anon_sym_delete] = ACTIONS(3506),
    [anon_sym_throw] = ACTIONS(3506),
    [anon_sym_namespace] = ACTIONS(3506),
    [anon_sym_static_assert] = ACTIONS(3506),
    [anon_sym_concept] = ACTIONS(3506),
    [anon_sym_co_return] = ACTIONS(3506),
    [anon_sym_co_yield] = ACTIONS(3506),
    [anon_sym_R_DQUOTE] = ACTIONS(3508),
    [anon_sym_LR_DQUOTE] = ACTIONS(3508),
    [anon_sym_uR_DQUOTE] = ACTIONS(3508),
    [anon_sym_UR_DQUOTE] = ACTIONS(3508),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3508),
    [anon_sym_co_await] = ACTIONS(3506),
    [anon_sym_new] = ACTIONS(3506),
    [anon_sym_requires] = ACTIONS(3506),
    [sym_this] = ACTIONS(3506),
    [anon_sym_discard] = ACTIONS(3506),
    [anon_sym_precise] = ACTIONS(3506),
    [anon_sym_shared] = ACTIONS(3506),
    [anon_sym_groupshared] = ACTIONS(3506),
    [anon_sym_uniform] = ACTIONS(3506),
    [anon_sym_row_major] = ACTIONS(3506),
    [anon_sym_column_major] = ACTIONS(3506),
    [anon_sym_globallycoherent] = ACTIONS(3506),
    [anon_sym_centroid] = ACTIONS(3506),
    [anon_sym_noperspective] = ACTIONS(3506),
    [anon_sym_nointerpolation] = ACTIONS(3506),
    [anon_sym_sample] = ACTIONS(3506),
    [anon_sym_linear] = ACTIONS(3506),
    [anon_sym_snorm] = ACTIONS(3506),
    [anon_sym_unorm] = ACTIONS(3506),
    [anon_sym_point] = ACTIONS(3506),
    [anon_sym_line] = ACTIONS(3506),
    [anon_sym_triangleadj] = ACTIONS(3506),
    [anon_sym_lineadj] = ACTIONS(3506),
    [anon_sym_triangle] = ACTIONS(3506),
    [anon_sym_cbuffer] = ACTIONS(3506),
    [anon_sym_interface] = ACTIONS(3506),
    [anon_sym_extension] = ACTIONS(3506),
  },
  [869] = {
    [sym_identifier] = ACTIONS(3488),
    [aux_sym_preproc_include_token1] = ACTIONS(3488),
    [aux_sym_preproc_def_token1] = ACTIONS(3488),
    [aux_sym_preproc_if_token1] = ACTIONS(3488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3488),
    [sym_preproc_directive] = ACTIONS(3488),
    [anon_sym_LPAREN2] = ACTIONS(3486),
    [anon_sym_BANG] = ACTIONS(3486),
    [anon_sym_TILDE] = ACTIONS(3486),
    [anon_sym_DASH] = ACTIONS(3488),
    [anon_sym_PLUS] = ACTIONS(3488),
    [anon_sym_STAR] = ACTIONS(3486),
    [anon_sym_AMP_AMP] = ACTIONS(3486),
    [anon_sym_AMP] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3486),
    [anon_sym___extension__] = ACTIONS(3488),
    [anon_sym_typedef] = ACTIONS(3488),
    [anon_sym_in] = ACTIONS(3488),
    [anon_sym_out] = ACTIONS(3488),
    [anon_sym_inout] = ACTIONS(3488),
    [anon_sym_virtual] = ACTIONS(3488),
    [anon_sym_extern] = ACTIONS(3488),
    [anon_sym___attribute__] = ACTIONS(3488),
    [anon_sym___attribute] = ACTIONS(3488),
    [anon_sym_using] = ACTIONS(3488),
    [anon_sym_COLON_COLON] = ACTIONS(3486),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3486),
    [anon_sym___declspec] = ACTIONS(3488),
    [anon_sym___based] = ACTIONS(3488),
    [anon_sym___cdecl] = ACTIONS(3488),
    [anon_sym___clrcall] = ACTIONS(3488),
    [anon_sym___stdcall] = ACTIONS(3488),
    [anon_sym___fastcall] = ACTIONS(3488),
    [anon_sym___thiscall] = ACTIONS(3488),
    [anon_sym___vectorcall] = ACTIONS(3488),
    [anon_sym_LBRACE] = ACTIONS(3486),
    [anon_sym_RBRACE] = ACTIONS(3486),
    [anon_sym_signed] = ACTIONS(3488),
    [anon_sym_unsigned] = ACTIONS(3488),
    [anon_sym_long] = ACTIONS(3488),
    [anon_sym_short] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(3488),
    [anon_sym_static] = ACTIONS(3488),
    [anon_sym_register] = ACTIONS(3488),
    [anon_sym_inline] = ACTIONS(3488),
    [anon_sym___inline] = ACTIONS(3488),
    [anon_sym___inline__] = ACTIONS(3488),
    [anon_sym___forceinline] = ACTIONS(3488),
    [anon_sym_thread_local] = ACTIONS(3488),
    [anon_sym___thread] = ACTIONS(3488),
    [anon_sym_const] = ACTIONS(3488),
    [anon_sym_constexpr] = ACTIONS(3488),
    [anon_sym_volatile] = ACTIONS(3488),
    [anon_sym_restrict] = ACTIONS(3488),
    [anon_sym___restrict__] = ACTIONS(3488),
    [anon_sym__Atomic] = ACTIONS(3488),
    [anon_sym__Noreturn] = ACTIONS(3488),
    [anon_sym_noreturn] = ACTIONS(3488),
    [anon_sym__Nonnull] = ACTIONS(3488),
    [anon_sym_mutable] = ACTIONS(3488),
    [anon_sym_constinit] = ACTIONS(3488),
    [anon_sym_consteval] = ACTIONS(3488),
    [anon_sym_alignas] = ACTIONS(3488),
    [anon_sym__Alignas] = ACTIONS(3488),
    [sym_primitive_type] = ACTIONS(3488),
    [anon_sym_enum] = ACTIONS(3488),
    [anon_sym_class] = ACTIONS(3488),
    [anon_sym_struct] = ACTIONS(3488),
    [anon_sym_union] = ACTIONS(3488),
    [anon_sym_if] = ACTIONS(3488),
    [anon_sym_else] = ACTIONS(3488),
    [anon_sym_switch] = ACTIONS(3488),
    [anon_sym_case] = ACTIONS(3488),
    [anon_sym_default] = ACTIONS(3488),
    [anon_sym_while] = ACTIONS(3488),
    [anon_sym_do] = ACTIONS(3488),
    [anon_sym_for] = ACTIONS(3488),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_break] = ACTIONS(3488),
    [anon_sym_continue] = ACTIONS(3488),
    [anon_sym_goto] = ACTIONS(3488),
    [anon_sym___try] = ACTIONS(3488),
    [anon_sym___leave] = ACTIONS(3488),
    [anon_sym_not] = ACTIONS(3488),
    [anon_sym_compl] = ACTIONS(3488),
    [anon_sym_DASH_DASH] = ACTIONS(3486),
    [anon_sym_PLUS_PLUS] = ACTIONS(3486),
    [anon_sym_sizeof] = ACTIONS(3488),
    [anon_sym___alignof__] = ACTIONS(3488),
    [anon_sym___alignof] = ACTIONS(3488),
    [anon_sym__alignof] = ACTIONS(3488),
    [anon_sym_alignof] = ACTIONS(3488),
    [anon_sym__Alignof] = ACTIONS(3488),
    [anon_sym_offsetof] = ACTIONS(3488),
    [anon_sym__Generic] = ACTIONS(3488),
    [anon_sym_asm] = ACTIONS(3488),
    [anon_sym___asm__] = ACTIONS(3488),
    [anon_sym___asm] = ACTIONS(3488),
    [sym_number_literal] = ACTIONS(3486),
    [anon_sym_L_SQUOTE] = ACTIONS(3486),
    [anon_sym_u_SQUOTE] = ACTIONS(3486),
    [anon_sym_U_SQUOTE] = ACTIONS(3486),
    [anon_sym_u8_SQUOTE] = ACTIONS(3486),
    [anon_sym_SQUOTE] = ACTIONS(3486),
    [anon_sym_L_DQUOTE] = ACTIONS(3486),
    [anon_sym_u_DQUOTE] = ACTIONS(3486),
    [anon_sym_U_DQUOTE] = ACTIONS(3486),
    [anon_sym_u8_DQUOTE] = ACTIONS(3486),
    [anon_sym_DQUOTE] = ACTIONS(3486),
    [sym_true] = ACTIONS(3488),
    [sym_false] = ACTIONS(3488),
    [anon_sym_NULL] = ACTIONS(3488),
    [anon_sym_nullptr] = ACTIONS(3488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3488),
    [anon_sym_let] = ACTIONS(3488),
    [anon_sym_This] = ACTIONS(3488),
    [anon_sym_decltype] = ACTIONS(3488),
    [anon_sym_explicit] = ACTIONS(3488),
    [anon_sym_typename] = ACTIONS(3488),
    [anon_sym_template] = ACTIONS(3488),
    [anon_sym_operator] = ACTIONS(3488),
    [anon_sym_try] = ACTIONS(3488),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_throw] = ACTIONS(3488),
    [anon_sym_namespace] = ACTIONS(3488),
    [anon_sym_static_assert] = ACTIONS(3488),
    [anon_sym_concept] = ACTIONS(3488),
    [anon_sym_co_return] = ACTIONS(3488),
    [anon_sym_co_yield] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(3486),
    [anon_sym_LR_DQUOTE] = ACTIONS(3486),
    [anon_sym_uR_DQUOTE] = ACTIONS(3486),
    [anon_sym_UR_DQUOTE] = ACTIONS(3486),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3486),
    [anon_sym_co_await] = ACTIONS(3488),
    [anon_sym_new] = ACTIONS(3488),
    [anon_sym_requires] = ACTIONS(3488),
    [sym_this] = ACTIONS(3488),
    [anon_sym_discard] = ACTIONS(3488),
    [anon_sym_precise] = ACTIONS(3488),
    [anon_sym_shared] = ACTIONS(3488),
    [anon_sym_groupshared] = ACTIONS(3488),
    [anon_sym_uniform] = ACTIONS(3488),
    [anon_sym_row_major] = ACTIONS(3488),
    [anon_sym_column_major] = ACTIONS(3488),
    [anon_sym_globallycoherent] = ACTIONS(3488),
    [anon_sym_centroid] = ACTIONS(3488),
    [anon_sym_noperspective] = ACTIONS(3488),
    [anon_sym_nointerpolation] = ACTIONS(3488),
    [anon_sym_sample] = ACTIONS(3488),
    [anon_sym_linear] = ACTIONS(3488),
    [anon_sym_snorm] = ACTIONS(3488),
    [anon_sym_unorm] = ACTIONS(3488),
    [anon_sym_point] = ACTIONS(3488),
    [anon_sym_line] = ACTIONS(3488),
    [anon_sym_triangleadj] = ACTIONS(3488),
    [anon_sym_lineadj] = ACTIONS(3488),
    [anon_sym_triangle] = ACTIONS(3488),
    [anon_sym_cbuffer] = ACTIONS(3488),
    [anon_sym_interface] = ACTIONS(3488),
    [anon_sym_extension] = ACTIONS(3488),
  },
  [870] = {
    [sym_identifier] = ACTIONS(3494),
    [aux_sym_preproc_include_token1] = ACTIONS(3494),
    [aux_sym_preproc_def_token1] = ACTIONS(3494),
    [aux_sym_preproc_if_token1] = ACTIONS(3494),
    [aux_sym_preproc_if_token2] = ACTIONS(3494),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3494),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3494),
    [sym_preproc_directive] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(3496),
    [anon_sym_BANG] = ACTIONS(3496),
    [anon_sym_TILDE] = ACTIONS(3496),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3496),
    [anon_sym_AMP_AMP] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3494),
    [anon_sym_SEMI] = ACTIONS(3496),
    [anon_sym___extension__] = ACTIONS(3494),
    [anon_sym_typedef] = ACTIONS(3494),
    [anon_sym_in] = ACTIONS(3494),
    [anon_sym_out] = ACTIONS(3494),
    [anon_sym_inout] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym___attribute__] = ACTIONS(3494),
    [anon_sym___attribute] = ACTIONS(3494),
    [anon_sym_using] = ACTIONS(3494),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3496),
    [anon_sym___declspec] = ACTIONS(3494),
    [anon_sym___based] = ACTIONS(3494),
    [anon_sym___cdecl] = ACTIONS(3494),
    [anon_sym___clrcall] = ACTIONS(3494),
    [anon_sym___stdcall] = ACTIONS(3494),
    [anon_sym___fastcall] = ACTIONS(3494),
    [anon_sym___thiscall] = ACTIONS(3494),
    [anon_sym___vectorcall] = ACTIONS(3494),
    [anon_sym_LBRACE] = ACTIONS(3496),
    [anon_sym_signed] = ACTIONS(3494),
    [anon_sym_unsigned] = ACTIONS(3494),
    [anon_sym_long] = ACTIONS(3494),
    [anon_sym_short] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_register] = ACTIONS(3494),
    [anon_sym_inline] = ACTIONS(3494),
    [anon_sym___inline] = ACTIONS(3494),
    [anon_sym___inline__] = ACTIONS(3494),
    [anon_sym___forceinline] = ACTIONS(3494),
    [anon_sym_thread_local] = ACTIONS(3494),
    [anon_sym___thread] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_constexpr] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_restrict] = ACTIONS(3494),
    [anon_sym___restrict__] = ACTIONS(3494),
    [anon_sym__Atomic] = ACTIONS(3494),
    [anon_sym__Noreturn] = ACTIONS(3494),
    [anon_sym_noreturn] = ACTIONS(3494),
    [anon_sym__Nonnull] = ACTIONS(3494),
    [anon_sym_mutable] = ACTIONS(3494),
    [anon_sym_constinit] = ACTIONS(3494),
    [anon_sym_consteval] = ACTIONS(3494),
    [anon_sym_alignas] = ACTIONS(3494),
    [anon_sym__Alignas] = ACTIONS(3494),
    [sym_primitive_type] = ACTIONS(3494),
    [anon_sym_enum] = ACTIONS(3494),
    [anon_sym_class] = ACTIONS(3494),
    [anon_sym_struct] = ACTIONS(3494),
    [anon_sym_union] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_else] = ACTIONS(3494),
    [anon_sym_switch] = ACTIONS(3494),
    [anon_sym_case] = ACTIONS(3494),
    [anon_sym_default] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_break] = ACTIONS(3494),
    [anon_sym_continue] = ACTIONS(3494),
    [anon_sym_goto] = ACTIONS(3494),
    [anon_sym___try] = ACTIONS(3494),
    [anon_sym___leave] = ACTIONS(3494),
    [anon_sym_not] = ACTIONS(3494),
    [anon_sym_compl] = ACTIONS(3494),
    [anon_sym_DASH_DASH] = ACTIONS(3496),
    [anon_sym_PLUS_PLUS] = ACTIONS(3496),
    [anon_sym_sizeof] = ACTIONS(3494),
    [anon_sym___alignof__] = ACTIONS(3494),
    [anon_sym___alignof] = ACTIONS(3494),
    [anon_sym__alignof] = ACTIONS(3494),
    [anon_sym_alignof] = ACTIONS(3494),
    [anon_sym__Alignof] = ACTIONS(3494),
    [anon_sym_offsetof] = ACTIONS(3494),
    [anon_sym__Generic] = ACTIONS(3494),
    [anon_sym_asm] = ACTIONS(3494),
    [anon_sym___asm__] = ACTIONS(3494),
    [anon_sym___asm] = ACTIONS(3494),
    [sym_number_literal] = ACTIONS(3496),
    [anon_sym_L_SQUOTE] = ACTIONS(3496),
    [anon_sym_u_SQUOTE] = ACTIONS(3496),
    [anon_sym_U_SQUOTE] = ACTIONS(3496),
    [anon_sym_u8_SQUOTE] = ACTIONS(3496),
    [anon_sym_SQUOTE] = ACTIONS(3496),
    [anon_sym_L_DQUOTE] = ACTIONS(3496),
    [anon_sym_u_DQUOTE] = ACTIONS(3496),
    [anon_sym_U_DQUOTE] = ACTIONS(3496),
    [anon_sym_u8_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE] = ACTIONS(3496),
    [sym_true] = ACTIONS(3494),
    [sym_false] = ACTIONS(3494),
    [anon_sym_NULL] = ACTIONS(3494),
    [anon_sym_nullptr] = ACTIONS(3494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_This] = ACTIONS(3494),
    [anon_sym_decltype] = ACTIONS(3494),
    [anon_sym_explicit] = ACTIONS(3494),
    [anon_sym_typename] = ACTIONS(3494),
    [anon_sym_template] = ACTIONS(3494),
    [anon_sym_operator] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_delete] = ACTIONS(3494),
    [anon_sym_throw] = ACTIONS(3494),
    [anon_sym_namespace] = ACTIONS(3494),
    [anon_sym_static_assert] = ACTIONS(3494),
    [anon_sym_concept] = ACTIONS(3494),
    [anon_sym_co_return] = ACTIONS(3494),
    [anon_sym_co_yield] = ACTIONS(3494),
    [anon_sym_R_DQUOTE] = ACTIONS(3496),
    [anon_sym_LR_DQUOTE] = ACTIONS(3496),
    [anon_sym_uR_DQUOTE] = ACTIONS(3496),
    [anon_sym_UR_DQUOTE] = ACTIONS(3496),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3496),
    [anon_sym_co_await] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_requires] = ACTIONS(3494),
    [sym_this] = ACTIONS(3494),
    [anon_sym_discard] = ACTIONS(3494),
    [anon_sym_precise] = ACTIONS(3494),
    [anon_sym_shared] = ACTIONS(3494),
    [anon_sym_groupshared] = ACTIONS(3494),
    [anon_sym_uniform] = ACTIONS(3494),
    [anon_sym_row_major] = ACTIONS(3494),
    [anon_sym_column_major] = ACTIONS(3494),
    [anon_sym_globallycoherent] = ACTIONS(3494),
    [anon_sym_centroid] = ACTIONS(3494),
    [anon_sym_noperspective] = ACTIONS(3494),
    [anon_sym_nointerpolation] = ACTIONS(3494),
    [anon_sym_sample] = ACTIONS(3494),
    [anon_sym_linear] = ACTIONS(3494),
    [anon_sym_snorm] = ACTIONS(3494),
    [anon_sym_unorm] = ACTIONS(3494),
    [anon_sym_point] = ACTIONS(3494),
    [anon_sym_line] = ACTIONS(3494),
    [anon_sym_triangleadj] = ACTIONS(3494),
    [anon_sym_lineadj] = ACTIONS(3494),
    [anon_sym_triangle] = ACTIONS(3494),
    [anon_sym_cbuffer] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_extension] = ACTIONS(3494),
  },
  [871] = {
    [sym_identifier] = ACTIONS(3500),
    [aux_sym_preproc_include_token1] = ACTIONS(3500),
    [aux_sym_preproc_def_token1] = ACTIONS(3500),
    [aux_sym_preproc_if_token1] = ACTIONS(3500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3500),
    [sym_preproc_directive] = ACTIONS(3500),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3500),
    [anon_sym_PLUS] = ACTIONS(3500),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_AMP] = ACTIONS(3500),
    [anon_sym_SEMI] = ACTIONS(3498),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_typedef] = ACTIONS(3500),
    [anon_sym_in] = ACTIONS(3500),
    [anon_sym_out] = ACTIONS(3500),
    [anon_sym_inout] = ACTIONS(3500),
    [anon_sym_virtual] = ACTIONS(3500),
    [anon_sym_extern] = ACTIONS(3500),
    [anon_sym___attribute__] = ACTIONS(3500),
    [anon_sym___attribute] = ACTIONS(3500),
    [anon_sym_using] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3498),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3498),
    [anon_sym___declspec] = ACTIONS(3500),
    [anon_sym___based] = ACTIONS(3500),
    [anon_sym___cdecl] = ACTIONS(3500),
    [anon_sym___clrcall] = ACTIONS(3500),
    [anon_sym___stdcall] = ACTIONS(3500),
    [anon_sym___fastcall] = ACTIONS(3500),
    [anon_sym___thiscall] = ACTIONS(3500),
    [anon_sym___vectorcall] = ACTIONS(3500),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_RBRACE] = ACTIONS(3498),
    [anon_sym_signed] = ACTIONS(3500),
    [anon_sym_unsigned] = ACTIONS(3500),
    [anon_sym_long] = ACTIONS(3500),
    [anon_sym_short] = ACTIONS(3500),
    [anon_sym_LBRACK] = ACTIONS(3500),
    [anon_sym_static] = ACTIONS(3500),
    [anon_sym_register] = ACTIONS(3500),
    [anon_sym_inline] = ACTIONS(3500),
    [anon_sym___inline] = ACTIONS(3500),
    [anon_sym___inline__] = ACTIONS(3500),
    [anon_sym___forceinline] = ACTIONS(3500),
    [anon_sym_thread_local] = ACTIONS(3500),
    [anon_sym___thread] = ACTIONS(3500),
    [anon_sym_const] = ACTIONS(3500),
    [anon_sym_constexpr] = ACTIONS(3500),
    [anon_sym_volatile] = ACTIONS(3500),
    [anon_sym_restrict] = ACTIONS(3500),
    [anon_sym___restrict__] = ACTIONS(3500),
    [anon_sym__Atomic] = ACTIONS(3500),
    [anon_sym__Noreturn] = ACTIONS(3500),
    [anon_sym_noreturn] = ACTIONS(3500),
    [anon_sym__Nonnull] = ACTIONS(3500),
    [anon_sym_mutable] = ACTIONS(3500),
    [anon_sym_constinit] = ACTIONS(3500),
    [anon_sym_consteval] = ACTIONS(3500),
    [anon_sym_alignas] = ACTIONS(3500),
    [anon_sym__Alignas] = ACTIONS(3500),
    [sym_primitive_type] = ACTIONS(3500),
    [anon_sym_enum] = ACTIONS(3500),
    [anon_sym_class] = ACTIONS(3500),
    [anon_sym_struct] = ACTIONS(3500),
    [anon_sym_union] = ACTIONS(3500),
    [anon_sym_if] = ACTIONS(3500),
    [anon_sym_else] = ACTIONS(3500),
    [anon_sym_switch] = ACTIONS(3500),
    [anon_sym_case] = ACTIONS(3500),
    [anon_sym_default] = ACTIONS(3500),
    [anon_sym_while] = ACTIONS(3500),
    [anon_sym_do] = ACTIONS(3500),
    [anon_sym_for] = ACTIONS(3500),
    [anon_sym_return] = ACTIONS(3500),
    [anon_sym_break] = ACTIONS(3500),
    [anon_sym_continue] = ACTIONS(3500),
    [anon_sym_goto] = ACTIONS(3500),
    [anon_sym___try] = ACTIONS(3500),
    [anon_sym___leave] = ACTIONS(3500),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_compl] = ACTIONS(3500),
    [anon_sym_DASH_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_PLUS] = ACTIONS(3498),
    [anon_sym_sizeof] = ACTIONS(3500),
    [anon_sym___alignof__] = ACTIONS(3500),
    [anon_sym___alignof] = ACTIONS(3500),
    [anon_sym__alignof] = ACTIONS(3500),
    [anon_sym_alignof] = ACTIONS(3500),
    [anon_sym__Alignof] = ACTIONS(3500),
    [anon_sym_offsetof] = ACTIONS(3500),
    [anon_sym__Generic] = ACTIONS(3500),
    [anon_sym_asm] = ACTIONS(3500),
    [anon_sym___asm__] = ACTIONS(3500),
    [anon_sym___asm] = ACTIONS(3500),
    [sym_number_literal] = ACTIONS(3498),
    [anon_sym_L_SQUOTE] = ACTIONS(3498),
    [anon_sym_u_SQUOTE] = ACTIONS(3498),
    [anon_sym_U_SQUOTE] = ACTIONS(3498),
    [anon_sym_u8_SQUOTE] = ACTIONS(3498),
    [anon_sym_SQUOTE] = ACTIONS(3498),
    [anon_sym_L_DQUOTE] = ACTIONS(3498),
    [anon_sym_u_DQUOTE] = ACTIONS(3498),
    [anon_sym_U_DQUOTE] = ACTIONS(3498),
    [anon_sym_u8_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [sym_true] = ACTIONS(3500),
    [sym_false] = ACTIONS(3500),
    [anon_sym_NULL] = ACTIONS(3500),
    [anon_sym_nullptr] = ACTIONS(3500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3500),
    [anon_sym_let] = ACTIONS(3500),
    [anon_sym_This] = ACTIONS(3500),
    [anon_sym_decltype] = ACTIONS(3500),
    [anon_sym_explicit] = ACTIONS(3500),
    [anon_sym_typename] = ACTIONS(3500),
    [anon_sym_template] = ACTIONS(3500),
    [anon_sym_operator] = ACTIONS(3500),
    [anon_sym_try] = ACTIONS(3500),
    [anon_sym_delete] = ACTIONS(3500),
    [anon_sym_throw] = ACTIONS(3500),
    [anon_sym_namespace] = ACTIONS(3500),
    [anon_sym_static_assert] = ACTIONS(3500),
    [anon_sym_concept] = ACTIONS(3500),
    [anon_sym_co_return] = ACTIONS(3500),
    [anon_sym_co_yield] = ACTIONS(3500),
    [anon_sym_R_DQUOTE] = ACTIONS(3498),
    [anon_sym_LR_DQUOTE] = ACTIONS(3498),
    [anon_sym_uR_DQUOTE] = ACTIONS(3498),
    [anon_sym_UR_DQUOTE] = ACTIONS(3498),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3498),
    [anon_sym_co_await] = ACTIONS(3500),
    [anon_sym_new] = ACTIONS(3500),
    [anon_sym_requires] = ACTIONS(3500),
    [sym_this] = ACTIONS(3500),
    [anon_sym_discard] = ACTIONS(3500),
    [anon_sym_precise] = ACTIONS(3500),
    [anon_sym_shared] = ACTIONS(3500),
    [anon_sym_groupshared] = ACTIONS(3500),
    [anon_sym_uniform] = ACTIONS(3500),
    [anon_sym_row_major] = ACTIONS(3500),
    [anon_sym_column_major] = ACTIONS(3500),
    [anon_sym_globallycoherent] = ACTIONS(3500),
    [anon_sym_centroid] = ACTIONS(3500),
    [anon_sym_noperspective] = ACTIONS(3500),
    [anon_sym_nointerpolation] = ACTIONS(3500),
    [anon_sym_sample] = ACTIONS(3500),
    [anon_sym_linear] = ACTIONS(3500),
    [anon_sym_snorm] = ACTIONS(3500),
    [anon_sym_unorm] = ACTIONS(3500),
    [anon_sym_point] = ACTIONS(3500),
    [anon_sym_line] = ACTIONS(3500),
    [anon_sym_triangleadj] = ACTIONS(3500),
    [anon_sym_lineadj] = ACTIONS(3500),
    [anon_sym_triangle] = ACTIONS(3500),
    [anon_sym_cbuffer] = ACTIONS(3500),
    [anon_sym_interface] = ACTIONS(3500),
    [anon_sym_extension] = ACTIONS(3500),
  },
  [872] = {
    [sym_identifier] = ACTIONS(3510),
    [aux_sym_preproc_include_token1] = ACTIONS(3510),
    [aux_sym_preproc_def_token1] = ACTIONS(3510),
    [aux_sym_preproc_if_token1] = ACTIONS(3510),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3510),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3510),
    [sym_preproc_directive] = ACTIONS(3510),
    [anon_sym_LPAREN2] = ACTIONS(3512),
    [anon_sym_BANG] = ACTIONS(3512),
    [anon_sym_TILDE] = ACTIONS(3512),
    [anon_sym_DASH] = ACTIONS(3510),
    [anon_sym_PLUS] = ACTIONS(3510),
    [anon_sym_STAR] = ACTIONS(3512),
    [anon_sym_AMP_AMP] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3510),
    [anon_sym_SEMI] = ACTIONS(3512),
    [anon_sym___extension__] = ACTIONS(3510),
    [anon_sym_typedef] = ACTIONS(3510),
    [anon_sym_in] = ACTIONS(3510),
    [anon_sym_out] = ACTIONS(3510),
    [anon_sym_inout] = ACTIONS(3510),
    [anon_sym_virtual] = ACTIONS(3510),
    [anon_sym_extern] = ACTIONS(3510),
    [anon_sym___attribute__] = ACTIONS(3510),
    [anon_sym___attribute] = ACTIONS(3510),
    [anon_sym_using] = ACTIONS(3510),
    [anon_sym_COLON_COLON] = ACTIONS(3512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3512),
    [anon_sym___declspec] = ACTIONS(3510),
    [anon_sym___based] = ACTIONS(3510),
    [anon_sym___cdecl] = ACTIONS(3510),
    [anon_sym___clrcall] = ACTIONS(3510),
    [anon_sym___stdcall] = ACTIONS(3510),
    [anon_sym___fastcall] = ACTIONS(3510),
    [anon_sym___thiscall] = ACTIONS(3510),
    [anon_sym___vectorcall] = ACTIONS(3510),
    [anon_sym_LBRACE] = ACTIONS(3512),
    [anon_sym_RBRACE] = ACTIONS(3512),
    [anon_sym_signed] = ACTIONS(3510),
    [anon_sym_unsigned] = ACTIONS(3510),
    [anon_sym_long] = ACTIONS(3510),
    [anon_sym_short] = ACTIONS(3510),
    [anon_sym_LBRACK] = ACTIONS(3510),
    [anon_sym_static] = ACTIONS(3510),
    [anon_sym_register] = ACTIONS(3510),
    [anon_sym_inline] = ACTIONS(3510),
    [anon_sym___inline] = ACTIONS(3510),
    [anon_sym___inline__] = ACTIONS(3510),
    [anon_sym___forceinline] = ACTIONS(3510),
    [anon_sym_thread_local] = ACTIONS(3510),
    [anon_sym___thread] = ACTIONS(3510),
    [anon_sym_const] = ACTIONS(3510),
    [anon_sym_constexpr] = ACTIONS(3510),
    [anon_sym_volatile] = ACTIONS(3510),
    [anon_sym_restrict] = ACTIONS(3510),
    [anon_sym___restrict__] = ACTIONS(3510),
    [anon_sym__Atomic] = ACTIONS(3510),
    [anon_sym__Noreturn] = ACTIONS(3510),
    [anon_sym_noreturn] = ACTIONS(3510),
    [anon_sym__Nonnull] = ACTIONS(3510),
    [anon_sym_mutable] = ACTIONS(3510),
    [anon_sym_constinit] = ACTIONS(3510),
    [anon_sym_consteval] = ACTIONS(3510),
    [anon_sym_alignas] = ACTIONS(3510),
    [anon_sym__Alignas] = ACTIONS(3510),
    [sym_primitive_type] = ACTIONS(3510),
    [anon_sym_enum] = ACTIONS(3510),
    [anon_sym_class] = ACTIONS(3510),
    [anon_sym_struct] = ACTIONS(3510),
    [anon_sym_union] = ACTIONS(3510),
    [anon_sym_if] = ACTIONS(3510),
    [anon_sym_else] = ACTIONS(3510),
    [anon_sym_switch] = ACTIONS(3510),
    [anon_sym_case] = ACTIONS(3510),
    [anon_sym_default] = ACTIONS(3510),
    [anon_sym_while] = ACTIONS(3510),
    [anon_sym_do] = ACTIONS(3510),
    [anon_sym_for] = ACTIONS(3510),
    [anon_sym_return] = ACTIONS(3510),
    [anon_sym_break] = ACTIONS(3510),
    [anon_sym_continue] = ACTIONS(3510),
    [anon_sym_goto] = ACTIONS(3510),
    [anon_sym___try] = ACTIONS(3510),
    [anon_sym___leave] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3510),
    [anon_sym_compl] = ACTIONS(3510),
    [anon_sym_DASH_DASH] = ACTIONS(3512),
    [anon_sym_PLUS_PLUS] = ACTIONS(3512),
    [anon_sym_sizeof] = ACTIONS(3510),
    [anon_sym___alignof__] = ACTIONS(3510),
    [anon_sym___alignof] = ACTIONS(3510),
    [anon_sym__alignof] = ACTIONS(3510),
    [anon_sym_alignof] = ACTIONS(3510),
    [anon_sym__Alignof] = ACTIONS(3510),
    [anon_sym_offsetof] = ACTIONS(3510),
    [anon_sym__Generic] = ACTIONS(3510),
    [anon_sym_asm] = ACTIONS(3510),
    [anon_sym___asm__] = ACTIONS(3510),
    [anon_sym___asm] = ACTIONS(3510),
    [sym_number_literal] = ACTIONS(3512),
    [anon_sym_L_SQUOTE] = ACTIONS(3512),
    [anon_sym_u_SQUOTE] = ACTIONS(3512),
    [anon_sym_U_SQUOTE] = ACTIONS(3512),
    [anon_sym_u8_SQUOTE] = ACTIONS(3512),
    [anon_sym_SQUOTE] = ACTIONS(3512),
    [anon_sym_L_DQUOTE] = ACTIONS(3512),
    [anon_sym_u_DQUOTE] = ACTIONS(3512),
    [anon_sym_U_DQUOTE] = ACTIONS(3512),
    [anon_sym_u8_DQUOTE] = ACTIONS(3512),
    [anon_sym_DQUOTE] = ACTIONS(3512),
    [sym_true] = ACTIONS(3510),
    [sym_false] = ACTIONS(3510),
    [anon_sym_NULL] = ACTIONS(3510),
    [anon_sym_nullptr] = ACTIONS(3510),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3510),
    [anon_sym_let] = ACTIONS(3510),
    [anon_sym_This] = ACTIONS(3510),
    [anon_sym_decltype] = ACTIONS(3510),
    [anon_sym_explicit] = ACTIONS(3510),
    [anon_sym_typename] = ACTIONS(3510),
    [anon_sym_template] = ACTIONS(3510),
    [anon_sym_operator] = ACTIONS(3510),
    [anon_sym_try] = ACTIONS(3510),
    [anon_sym_delete] = ACTIONS(3510),
    [anon_sym_throw] = ACTIONS(3510),
    [anon_sym_namespace] = ACTIONS(3510),
    [anon_sym_static_assert] = ACTIONS(3510),
    [anon_sym_concept] = ACTIONS(3510),
    [anon_sym_co_return] = ACTIONS(3510),
    [anon_sym_co_yield] = ACTIONS(3510),
    [anon_sym_R_DQUOTE] = ACTIONS(3512),
    [anon_sym_LR_DQUOTE] = ACTIONS(3512),
    [anon_sym_uR_DQUOTE] = ACTIONS(3512),
    [anon_sym_UR_DQUOTE] = ACTIONS(3512),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3512),
    [anon_sym_co_await] = ACTIONS(3510),
    [anon_sym_new] = ACTIONS(3510),
    [anon_sym_requires] = ACTIONS(3510),
    [sym_this] = ACTIONS(3510),
    [anon_sym_discard] = ACTIONS(3510),
    [anon_sym_precise] = ACTIONS(3510),
    [anon_sym_shared] = ACTIONS(3510),
    [anon_sym_groupshared] = ACTIONS(3510),
    [anon_sym_uniform] = ACTIONS(3510),
    [anon_sym_row_major] = ACTIONS(3510),
    [anon_sym_column_major] = ACTIONS(3510),
    [anon_sym_globallycoherent] = ACTIONS(3510),
    [anon_sym_centroid] = ACTIONS(3510),
    [anon_sym_noperspective] = ACTIONS(3510),
    [anon_sym_nointerpolation] = ACTIONS(3510),
    [anon_sym_sample] = ACTIONS(3510),
    [anon_sym_linear] = ACTIONS(3510),
    [anon_sym_snorm] = ACTIONS(3510),
    [anon_sym_unorm] = ACTIONS(3510),
    [anon_sym_point] = ACTIONS(3510),
    [anon_sym_line] = ACTIONS(3510),
    [anon_sym_triangleadj] = ACTIONS(3510),
    [anon_sym_lineadj] = ACTIONS(3510),
    [anon_sym_triangle] = ACTIONS(3510),
    [anon_sym_cbuffer] = ACTIONS(3510),
    [anon_sym_interface] = ACTIONS(3510),
    [anon_sym_extension] = ACTIONS(3510),
  },
  [873] = {
    [sym_identifier] = ACTIONS(3506),
    [aux_sym_preproc_include_token1] = ACTIONS(3506),
    [aux_sym_preproc_def_token1] = ACTIONS(3506),
    [aux_sym_preproc_if_token1] = ACTIONS(3506),
    [aux_sym_preproc_if_token2] = ACTIONS(3506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3506),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3506),
    [sym_preproc_directive] = ACTIONS(3506),
    [anon_sym_LPAREN2] = ACTIONS(3508),
    [anon_sym_BANG] = ACTIONS(3508),
    [anon_sym_TILDE] = ACTIONS(3508),
    [anon_sym_DASH] = ACTIONS(3506),
    [anon_sym_PLUS] = ACTIONS(3506),
    [anon_sym_STAR] = ACTIONS(3508),
    [anon_sym_AMP_AMP] = ACTIONS(3508),
    [anon_sym_AMP] = ACTIONS(3506),
    [anon_sym_SEMI] = ACTIONS(3508),
    [anon_sym___extension__] = ACTIONS(3506),
    [anon_sym_typedef] = ACTIONS(3506),
    [anon_sym_in] = ACTIONS(3506),
    [anon_sym_out] = ACTIONS(3506),
    [anon_sym_inout] = ACTIONS(3506),
    [anon_sym_virtual] = ACTIONS(3506),
    [anon_sym_extern] = ACTIONS(3506),
    [anon_sym___attribute__] = ACTIONS(3506),
    [anon_sym___attribute] = ACTIONS(3506),
    [anon_sym_using] = ACTIONS(3506),
    [anon_sym_COLON_COLON] = ACTIONS(3508),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3508),
    [anon_sym___declspec] = ACTIONS(3506),
    [anon_sym___based] = ACTIONS(3506),
    [anon_sym___cdecl] = ACTIONS(3506),
    [anon_sym___clrcall] = ACTIONS(3506),
    [anon_sym___stdcall] = ACTIONS(3506),
    [anon_sym___fastcall] = ACTIONS(3506),
    [anon_sym___thiscall] = ACTIONS(3506),
    [anon_sym___vectorcall] = ACTIONS(3506),
    [anon_sym_LBRACE] = ACTIONS(3508),
    [anon_sym_signed] = ACTIONS(3506),
    [anon_sym_unsigned] = ACTIONS(3506),
    [anon_sym_long] = ACTIONS(3506),
    [anon_sym_short] = ACTIONS(3506),
    [anon_sym_LBRACK] = ACTIONS(3506),
    [anon_sym_static] = ACTIONS(3506),
    [anon_sym_register] = ACTIONS(3506),
    [anon_sym_inline] = ACTIONS(3506),
    [anon_sym___inline] = ACTIONS(3506),
    [anon_sym___inline__] = ACTIONS(3506),
    [anon_sym___forceinline] = ACTIONS(3506),
    [anon_sym_thread_local] = ACTIONS(3506),
    [anon_sym___thread] = ACTIONS(3506),
    [anon_sym_const] = ACTIONS(3506),
    [anon_sym_constexpr] = ACTIONS(3506),
    [anon_sym_volatile] = ACTIONS(3506),
    [anon_sym_restrict] = ACTIONS(3506),
    [anon_sym___restrict__] = ACTIONS(3506),
    [anon_sym__Atomic] = ACTIONS(3506),
    [anon_sym__Noreturn] = ACTIONS(3506),
    [anon_sym_noreturn] = ACTIONS(3506),
    [anon_sym__Nonnull] = ACTIONS(3506),
    [anon_sym_mutable] = ACTIONS(3506),
    [anon_sym_constinit] = ACTIONS(3506),
    [anon_sym_consteval] = ACTIONS(3506),
    [anon_sym_alignas] = ACTIONS(3506),
    [anon_sym__Alignas] = ACTIONS(3506),
    [sym_primitive_type] = ACTIONS(3506),
    [anon_sym_enum] = ACTIONS(3506),
    [anon_sym_class] = ACTIONS(3506),
    [anon_sym_struct] = ACTIONS(3506),
    [anon_sym_union] = ACTIONS(3506),
    [anon_sym_if] = ACTIONS(3506),
    [anon_sym_else] = ACTIONS(3506),
    [anon_sym_switch] = ACTIONS(3506),
    [anon_sym_case] = ACTIONS(3506),
    [anon_sym_default] = ACTIONS(3506),
    [anon_sym_while] = ACTIONS(3506),
    [anon_sym_do] = ACTIONS(3506),
    [anon_sym_for] = ACTIONS(3506),
    [anon_sym_return] = ACTIONS(3506),
    [anon_sym_break] = ACTIONS(3506),
    [anon_sym_continue] = ACTIONS(3506),
    [anon_sym_goto] = ACTIONS(3506),
    [anon_sym___try] = ACTIONS(3506),
    [anon_sym___leave] = ACTIONS(3506),
    [anon_sym_not] = ACTIONS(3506),
    [anon_sym_compl] = ACTIONS(3506),
    [anon_sym_DASH_DASH] = ACTIONS(3508),
    [anon_sym_PLUS_PLUS] = ACTIONS(3508),
    [anon_sym_sizeof] = ACTIONS(3506),
    [anon_sym___alignof__] = ACTIONS(3506),
    [anon_sym___alignof] = ACTIONS(3506),
    [anon_sym__alignof] = ACTIONS(3506),
    [anon_sym_alignof] = ACTIONS(3506),
    [anon_sym__Alignof] = ACTIONS(3506),
    [anon_sym_offsetof] = ACTIONS(3506),
    [anon_sym__Generic] = ACTIONS(3506),
    [anon_sym_asm] = ACTIONS(3506),
    [anon_sym___asm__] = ACTIONS(3506),
    [anon_sym___asm] = ACTIONS(3506),
    [sym_number_literal] = ACTIONS(3508),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3508),
    [anon_sym_u_DQUOTE] = ACTIONS(3508),
    [anon_sym_U_DQUOTE] = ACTIONS(3508),
    [anon_sym_u8_DQUOTE] = ACTIONS(3508),
    [anon_sym_DQUOTE] = ACTIONS(3508),
    [sym_true] = ACTIONS(3506),
    [sym_false] = ACTIONS(3506),
    [anon_sym_NULL] = ACTIONS(3506),
    [anon_sym_nullptr] = ACTIONS(3506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3506),
    [anon_sym_let] = ACTIONS(3506),
    [anon_sym_This] = ACTIONS(3506),
    [anon_sym_decltype] = ACTIONS(3506),
    [anon_sym_explicit] = ACTIONS(3506),
    [anon_sym_typename] = ACTIONS(3506),
    [anon_sym_template] = ACTIONS(3506),
    [anon_sym_operator] = ACTIONS(3506),
    [anon_sym_try] = ACTIONS(3506),
    [anon_sym_delete] = ACTIONS(3506),
    [anon_sym_throw] = ACTIONS(3506),
    [anon_sym_namespace] = ACTIONS(3506),
    [anon_sym_static_assert] = ACTIONS(3506),
    [anon_sym_concept] = ACTIONS(3506),
    [anon_sym_co_return] = ACTIONS(3506),
    [anon_sym_co_yield] = ACTIONS(3506),
    [anon_sym_R_DQUOTE] = ACTIONS(3508),
    [anon_sym_LR_DQUOTE] = ACTIONS(3508),
    [anon_sym_uR_DQUOTE] = ACTIONS(3508),
    [anon_sym_UR_DQUOTE] = ACTIONS(3508),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3508),
    [anon_sym_co_await] = ACTIONS(3506),
    [anon_sym_new] = ACTIONS(3506),
    [anon_sym_requires] = ACTIONS(3506),
    [sym_this] = ACTIONS(3506),
    [anon_sym_discard] = ACTIONS(3506),
    [anon_sym_precise] = ACTIONS(3506),
    [anon_sym_shared] = ACTIONS(3506),
    [anon_sym_groupshared] = ACTIONS(3506),
    [anon_sym_uniform] = ACTIONS(3506),
    [anon_sym_row_major] = ACTIONS(3506),
    [anon_sym_column_major] = ACTIONS(3506),
    [anon_sym_globallycoherent] = ACTIONS(3506),
    [anon_sym_centroid] = ACTIONS(3506),
    [anon_sym_noperspective] = ACTIONS(3506),
    [anon_sym_nointerpolation] = ACTIONS(3506),
    [anon_sym_sample] = ACTIONS(3506),
    [anon_sym_linear] = ACTIONS(3506),
    [anon_sym_snorm] = ACTIONS(3506),
    [anon_sym_unorm] = ACTIONS(3506),
    [anon_sym_point] = ACTIONS(3506),
    [anon_sym_line] = ACTIONS(3506),
    [anon_sym_triangleadj] = ACTIONS(3506),
    [anon_sym_lineadj] = ACTIONS(3506),
    [anon_sym_triangle] = ACTIONS(3506),
    [anon_sym_cbuffer] = ACTIONS(3506),
    [anon_sym_interface] = ACTIONS(3506),
    [anon_sym_extension] = ACTIONS(3506),
  },
  [874] = {
    [sym_identifier] = ACTIONS(3488),
    [aux_sym_preproc_include_token1] = ACTIONS(3488),
    [aux_sym_preproc_def_token1] = ACTIONS(3488),
    [aux_sym_preproc_if_token1] = ACTIONS(3488),
    [aux_sym_preproc_if_token2] = ACTIONS(3488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3488),
    [sym_preproc_directive] = ACTIONS(3488),
    [anon_sym_LPAREN2] = ACTIONS(3486),
    [anon_sym_BANG] = ACTIONS(3486),
    [anon_sym_TILDE] = ACTIONS(3486),
    [anon_sym_DASH] = ACTIONS(3488),
    [anon_sym_PLUS] = ACTIONS(3488),
    [anon_sym_STAR] = ACTIONS(3486),
    [anon_sym_AMP_AMP] = ACTIONS(3486),
    [anon_sym_AMP] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3486),
    [anon_sym___extension__] = ACTIONS(3488),
    [anon_sym_typedef] = ACTIONS(3488),
    [anon_sym_in] = ACTIONS(3488),
    [anon_sym_out] = ACTIONS(3488),
    [anon_sym_inout] = ACTIONS(3488),
    [anon_sym_virtual] = ACTIONS(3488),
    [anon_sym_extern] = ACTIONS(3488),
    [anon_sym___attribute__] = ACTIONS(3488),
    [anon_sym___attribute] = ACTIONS(3488),
    [anon_sym_using] = ACTIONS(3488),
    [anon_sym_COLON_COLON] = ACTIONS(3486),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3486),
    [anon_sym___declspec] = ACTIONS(3488),
    [anon_sym___based] = ACTIONS(3488),
    [anon_sym___cdecl] = ACTIONS(3488),
    [anon_sym___clrcall] = ACTIONS(3488),
    [anon_sym___stdcall] = ACTIONS(3488),
    [anon_sym___fastcall] = ACTIONS(3488),
    [anon_sym___thiscall] = ACTIONS(3488),
    [anon_sym___vectorcall] = ACTIONS(3488),
    [anon_sym_LBRACE] = ACTIONS(3486),
    [anon_sym_signed] = ACTIONS(3488),
    [anon_sym_unsigned] = ACTIONS(3488),
    [anon_sym_long] = ACTIONS(3488),
    [anon_sym_short] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(3488),
    [anon_sym_static] = ACTIONS(3488),
    [anon_sym_register] = ACTIONS(3488),
    [anon_sym_inline] = ACTIONS(3488),
    [anon_sym___inline] = ACTIONS(3488),
    [anon_sym___inline__] = ACTIONS(3488),
    [anon_sym___forceinline] = ACTIONS(3488),
    [anon_sym_thread_local] = ACTIONS(3488),
    [anon_sym___thread] = ACTIONS(3488),
    [anon_sym_const] = ACTIONS(3488),
    [anon_sym_constexpr] = ACTIONS(3488),
    [anon_sym_volatile] = ACTIONS(3488),
    [anon_sym_restrict] = ACTIONS(3488),
    [anon_sym___restrict__] = ACTIONS(3488),
    [anon_sym__Atomic] = ACTIONS(3488),
    [anon_sym__Noreturn] = ACTIONS(3488),
    [anon_sym_noreturn] = ACTIONS(3488),
    [anon_sym__Nonnull] = ACTIONS(3488),
    [anon_sym_mutable] = ACTIONS(3488),
    [anon_sym_constinit] = ACTIONS(3488),
    [anon_sym_consteval] = ACTIONS(3488),
    [anon_sym_alignas] = ACTIONS(3488),
    [anon_sym__Alignas] = ACTIONS(3488),
    [sym_primitive_type] = ACTIONS(3488),
    [anon_sym_enum] = ACTIONS(3488),
    [anon_sym_class] = ACTIONS(3488),
    [anon_sym_struct] = ACTIONS(3488),
    [anon_sym_union] = ACTIONS(3488),
    [anon_sym_if] = ACTIONS(3488),
    [anon_sym_else] = ACTIONS(3488),
    [anon_sym_switch] = ACTIONS(3488),
    [anon_sym_case] = ACTIONS(3488),
    [anon_sym_default] = ACTIONS(3488),
    [anon_sym_while] = ACTIONS(3488),
    [anon_sym_do] = ACTIONS(3488),
    [anon_sym_for] = ACTIONS(3488),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_break] = ACTIONS(3488),
    [anon_sym_continue] = ACTIONS(3488),
    [anon_sym_goto] = ACTIONS(3488),
    [anon_sym___try] = ACTIONS(3488),
    [anon_sym___leave] = ACTIONS(3488),
    [anon_sym_not] = ACTIONS(3488),
    [anon_sym_compl] = ACTIONS(3488),
    [anon_sym_DASH_DASH] = ACTIONS(3486),
    [anon_sym_PLUS_PLUS] = ACTIONS(3486),
    [anon_sym_sizeof] = ACTIONS(3488),
    [anon_sym___alignof__] = ACTIONS(3488),
    [anon_sym___alignof] = ACTIONS(3488),
    [anon_sym__alignof] = ACTIONS(3488),
    [anon_sym_alignof] = ACTIONS(3488),
    [anon_sym__Alignof] = ACTIONS(3488),
    [anon_sym_offsetof] = ACTIONS(3488),
    [anon_sym__Generic] = ACTIONS(3488),
    [anon_sym_asm] = ACTIONS(3488),
    [anon_sym___asm__] = ACTIONS(3488),
    [anon_sym___asm] = ACTIONS(3488),
    [sym_number_literal] = ACTIONS(3486),
    [anon_sym_L_SQUOTE] = ACTIONS(3486),
    [anon_sym_u_SQUOTE] = ACTIONS(3486),
    [anon_sym_U_SQUOTE] = ACTIONS(3486),
    [anon_sym_u8_SQUOTE] = ACTIONS(3486),
    [anon_sym_SQUOTE] = ACTIONS(3486),
    [anon_sym_L_DQUOTE] = ACTIONS(3486),
    [anon_sym_u_DQUOTE] = ACTIONS(3486),
    [anon_sym_U_DQUOTE] = ACTIONS(3486),
    [anon_sym_u8_DQUOTE] = ACTIONS(3486),
    [anon_sym_DQUOTE] = ACTIONS(3486),
    [sym_true] = ACTIONS(3488),
    [sym_false] = ACTIONS(3488),
    [anon_sym_NULL] = ACTIONS(3488),
    [anon_sym_nullptr] = ACTIONS(3488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3488),
    [anon_sym_let] = ACTIONS(3488),
    [anon_sym_This] = ACTIONS(3488),
    [anon_sym_decltype] = ACTIONS(3488),
    [anon_sym_explicit] = ACTIONS(3488),
    [anon_sym_typename] = ACTIONS(3488),
    [anon_sym_template] = ACTIONS(3488),
    [anon_sym_operator] = ACTIONS(3488),
    [anon_sym_try] = ACTIONS(3488),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_throw] = ACTIONS(3488),
    [anon_sym_namespace] = ACTIONS(3488),
    [anon_sym_static_assert] = ACTIONS(3488),
    [anon_sym_concept] = ACTIONS(3488),
    [anon_sym_co_return] = ACTIONS(3488),
    [anon_sym_co_yield] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(3486),
    [anon_sym_LR_DQUOTE] = ACTIONS(3486),
    [anon_sym_uR_DQUOTE] = ACTIONS(3486),
    [anon_sym_UR_DQUOTE] = ACTIONS(3486),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3486),
    [anon_sym_co_await] = ACTIONS(3488),
    [anon_sym_new] = ACTIONS(3488),
    [anon_sym_requires] = ACTIONS(3488),
    [sym_this] = ACTIONS(3488),
    [anon_sym_discard] = ACTIONS(3488),
    [anon_sym_precise] = ACTIONS(3488),
    [anon_sym_shared] = ACTIONS(3488),
    [anon_sym_groupshared] = ACTIONS(3488),
    [anon_sym_uniform] = ACTIONS(3488),
    [anon_sym_row_major] = ACTIONS(3488),
    [anon_sym_column_major] = ACTIONS(3488),
    [anon_sym_globallycoherent] = ACTIONS(3488),
    [anon_sym_centroid] = ACTIONS(3488),
    [anon_sym_noperspective] = ACTIONS(3488),
    [anon_sym_nointerpolation] = ACTIONS(3488),
    [anon_sym_sample] = ACTIONS(3488),
    [anon_sym_linear] = ACTIONS(3488),
    [anon_sym_snorm] = ACTIONS(3488),
    [anon_sym_unorm] = ACTIONS(3488),
    [anon_sym_point] = ACTIONS(3488),
    [anon_sym_line] = ACTIONS(3488),
    [anon_sym_triangleadj] = ACTIONS(3488),
    [anon_sym_lineadj] = ACTIONS(3488),
    [anon_sym_triangle] = ACTIONS(3488),
    [anon_sym_cbuffer] = ACTIONS(3488),
    [anon_sym_interface] = ACTIONS(3488),
    [anon_sym_extension] = ACTIONS(3488),
  },
  [875] = {
    [sym_identifier] = ACTIONS(3500),
    [aux_sym_preproc_include_token1] = ACTIONS(3500),
    [aux_sym_preproc_def_token1] = ACTIONS(3500),
    [aux_sym_preproc_if_token1] = ACTIONS(3500),
    [aux_sym_preproc_if_token2] = ACTIONS(3500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3500),
    [sym_preproc_directive] = ACTIONS(3500),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3500),
    [anon_sym_PLUS] = ACTIONS(3500),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_AMP] = ACTIONS(3500),
    [anon_sym_SEMI] = ACTIONS(3498),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_typedef] = ACTIONS(3500),
    [anon_sym_in] = ACTIONS(3500),
    [anon_sym_out] = ACTIONS(3500),
    [anon_sym_inout] = ACTIONS(3500),
    [anon_sym_virtual] = ACTIONS(3500),
    [anon_sym_extern] = ACTIONS(3500),
    [anon_sym___attribute__] = ACTIONS(3500),
    [anon_sym___attribute] = ACTIONS(3500),
    [anon_sym_using] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3498),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3498),
    [anon_sym___declspec] = ACTIONS(3500),
    [anon_sym___based] = ACTIONS(3500),
    [anon_sym___cdecl] = ACTIONS(3500),
    [anon_sym___clrcall] = ACTIONS(3500),
    [anon_sym___stdcall] = ACTIONS(3500),
    [anon_sym___fastcall] = ACTIONS(3500),
    [anon_sym___thiscall] = ACTIONS(3500),
    [anon_sym___vectorcall] = ACTIONS(3500),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_signed] = ACTIONS(3500),
    [anon_sym_unsigned] = ACTIONS(3500),
    [anon_sym_long] = ACTIONS(3500),
    [anon_sym_short] = ACTIONS(3500),
    [anon_sym_LBRACK] = ACTIONS(3500),
    [anon_sym_static] = ACTIONS(3500),
    [anon_sym_register] = ACTIONS(3500),
    [anon_sym_inline] = ACTIONS(3500),
    [anon_sym___inline] = ACTIONS(3500),
    [anon_sym___inline__] = ACTIONS(3500),
    [anon_sym___forceinline] = ACTIONS(3500),
    [anon_sym_thread_local] = ACTIONS(3500),
    [anon_sym___thread] = ACTIONS(3500),
    [anon_sym_const] = ACTIONS(3500),
    [anon_sym_constexpr] = ACTIONS(3500),
    [anon_sym_volatile] = ACTIONS(3500),
    [anon_sym_restrict] = ACTIONS(3500),
    [anon_sym___restrict__] = ACTIONS(3500),
    [anon_sym__Atomic] = ACTIONS(3500),
    [anon_sym__Noreturn] = ACTIONS(3500),
    [anon_sym_noreturn] = ACTIONS(3500),
    [anon_sym__Nonnull] = ACTIONS(3500),
    [anon_sym_mutable] = ACTIONS(3500),
    [anon_sym_constinit] = ACTIONS(3500),
    [anon_sym_consteval] = ACTIONS(3500),
    [anon_sym_alignas] = ACTIONS(3500),
    [anon_sym__Alignas] = ACTIONS(3500),
    [sym_primitive_type] = ACTIONS(3500),
    [anon_sym_enum] = ACTIONS(3500),
    [anon_sym_class] = ACTIONS(3500),
    [anon_sym_struct] = ACTIONS(3500),
    [anon_sym_union] = ACTIONS(3500),
    [anon_sym_if] = ACTIONS(3500),
    [anon_sym_else] = ACTIONS(3500),
    [anon_sym_switch] = ACTIONS(3500),
    [anon_sym_case] = ACTIONS(3500),
    [anon_sym_default] = ACTIONS(3500),
    [anon_sym_while] = ACTIONS(3500),
    [anon_sym_do] = ACTIONS(3500),
    [anon_sym_for] = ACTIONS(3500),
    [anon_sym_return] = ACTIONS(3500),
    [anon_sym_break] = ACTIONS(3500),
    [anon_sym_continue] = ACTIONS(3500),
    [anon_sym_goto] = ACTIONS(3500),
    [anon_sym___try] = ACTIONS(3500),
    [anon_sym___leave] = ACTIONS(3500),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_compl] = ACTIONS(3500),
    [anon_sym_DASH_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_PLUS] = ACTIONS(3498),
    [anon_sym_sizeof] = ACTIONS(3500),
    [anon_sym___alignof__] = ACTIONS(3500),
    [anon_sym___alignof] = ACTIONS(3500),
    [anon_sym__alignof] = ACTIONS(3500),
    [anon_sym_alignof] = ACTIONS(3500),
    [anon_sym__Alignof] = ACTIONS(3500),
    [anon_sym_offsetof] = ACTIONS(3500),
    [anon_sym__Generic] = ACTIONS(3500),
    [anon_sym_asm] = ACTIONS(3500),
    [anon_sym___asm__] = ACTIONS(3500),
    [anon_sym___asm] = ACTIONS(3500),
    [sym_number_literal] = ACTIONS(3498),
    [anon_sym_L_SQUOTE] = ACTIONS(3498),
    [anon_sym_u_SQUOTE] = ACTIONS(3498),
    [anon_sym_U_SQUOTE] = ACTIONS(3498),
    [anon_sym_u8_SQUOTE] = ACTIONS(3498),
    [anon_sym_SQUOTE] = ACTIONS(3498),
    [anon_sym_L_DQUOTE] = ACTIONS(3498),
    [anon_sym_u_DQUOTE] = ACTIONS(3498),
    [anon_sym_U_DQUOTE] = ACTIONS(3498),
    [anon_sym_u8_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [sym_true] = ACTIONS(3500),
    [sym_false] = ACTIONS(3500),
    [anon_sym_NULL] = ACTIONS(3500),
    [anon_sym_nullptr] = ACTIONS(3500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3500),
    [anon_sym_let] = ACTIONS(3500),
    [anon_sym_This] = ACTIONS(3500),
    [anon_sym_decltype] = ACTIONS(3500),
    [anon_sym_explicit] = ACTIONS(3500),
    [anon_sym_typename] = ACTIONS(3500),
    [anon_sym_template] = ACTIONS(3500),
    [anon_sym_operator] = ACTIONS(3500),
    [anon_sym_try] = ACTIONS(3500),
    [anon_sym_delete] = ACTIONS(3500),
    [anon_sym_throw] = ACTIONS(3500),
    [anon_sym_namespace] = ACTIONS(3500),
    [anon_sym_static_assert] = ACTIONS(3500),
    [anon_sym_concept] = ACTIONS(3500),
    [anon_sym_co_return] = ACTIONS(3500),
    [anon_sym_co_yield] = ACTIONS(3500),
    [anon_sym_R_DQUOTE] = ACTIONS(3498),
    [anon_sym_LR_DQUOTE] = ACTIONS(3498),
    [anon_sym_uR_DQUOTE] = ACTIONS(3498),
    [anon_sym_UR_DQUOTE] = ACTIONS(3498),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3498),
    [anon_sym_co_await] = ACTIONS(3500),
    [anon_sym_new] = ACTIONS(3500),
    [anon_sym_requires] = ACTIONS(3500),
    [sym_this] = ACTIONS(3500),
    [anon_sym_discard] = ACTIONS(3500),
    [anon_sym_precise] = ACTIONS(3500),
    [anon_sym_shared] = ACTIONS(3500),
    [anon_sym_groupshared] = ACTIONS(3500),
    [anon_sym_uniform] = ACTIONS(3500),
    [anon_sym_row_major] = ACTIONS(3500),
    [anon_sym_column_major] = ACTIONS(3500),
    [anon_sym_globallycoherent] = ACTIONS(3500),
    [anon_sym_centroid] = ACTIONS(3500),
    [anon_sym_noperspective] = ACTIONS(3500),
    [anon_sym_nointerpolation] = ACTIONS(3500),
    [anon_sym_sample] = ACTIONS(3500),
    [anon_sym_linear] = ACTIONS(3500),
    [anon_sym_snorm] = ACTIONS(3500),
    [anon_sym_unorm] = ACTIONS(3500),
    [anon_sym_point] = ACTIONS(3500),
    [anon_sym_line] = ACTIONS(3500),
    [anon_sym_triangleadj] = ACTIONS(3500),
    [anon_sym_lineadj] = ACTIONS(3500),
    [anon_sym_triangle] = ACTIONS(3500),
    [anon_sym_cbuffer] = ACTIONS(3500),
    [anon_sym_interface] = ACTIONS(3500),
    [anon_sym_extension] = ACTIONS(3500),
  },
  [876] = {
    [sym_identifier] = ACTIONS(3510),
    [aux_sym_preproc_include_token1] = ACTIONS(3510),
    [aux_sym_preproc_def_token1] = ACTIONS(3510),
    [aux_sym_preproc_if_token1] = ACTIONS(3510),
    [aux_sym_preproc_if_token2] = ACTIONS(3510),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3510),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3510),
    [sym_preproc_directive] = ACTIONS(3510),
    [anon_sym_LPAREN2] = ACTIONS(3512),
    [anon_sym_BANG] = ACTIONS(3512),
    [anon_sym_TILDE] = ACTIONS(3512),
    [anon_sym_DASH] = ACTIONS(3510),
    [anon_sym_PLUS] = ACTIONS(3510),
    [anon_sym_STAR] = ACTIONS(3512),
    [anon_sym_AMP_AMP] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3510),
    [anon_sym_SEMI] = ACTIONS(3512),
    [anon_sym___extension__] = ACTIONS(3510),
    [anon_sym_typedef] = ACTIONS(3510),
    [anon_sym_in] = ACTIONS(3510),
    [anon_sym_out] = ACTIONS(3510),
    [anon_sym_inout] = ACTIONS(3510),
    [anon_sym_virtual] = ACTIONS(3510),
    [anon_sym_extern] = ACTIONS(3510),
    [anon_sym___attribute__] = ACTIONS(3510),
    [anon_sym___attribute] = ACTIONS(3510),
    [anon_sym_using] = ACTIONS(3510),
    [anon_sym_COLON_COLON] = ACTIONS(3512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3512),
    [anon_sym___declspec] = ACTIONS(3510),
    [anon_sym___based] = ACTIONS(3510),
    [anon_sym___cdecl] = ACTIONS(3510),
    [anon_sym___clrcall] = ACTIONS(3510),
    [anon_sym___stdcall] = ACTIONS(3510),
    [anon_sym___fastcall] = ACTIONS(3510),
    [anon_sym___thiscall] = ACTIONS(3510),
    [anon_sym___vectorcall] = ACTIONS(3510),
    [anon_sym_LBRACE] = ACTIONS(3512),
    [anon_sym_signed] = ACTIONS(3510),
    [anon_sym_unsigned] = ACTIONS(3510),
    [anon_sym_long] = ACTIONS(3510),
    [anon_sym_short] = ACTIONS(3510),
    [anon_sym_LBRACK] = ACTIONS(3510),
    [anon_sym_static] = ACTIONS(3510),
    [anon_sym_register] = ACTIONS(3510),
    [anon_sym_inline] = ACTIONS(3510),
    [anon_sym___inline] = ACTIONS(3510),
    [anon_sym___inline__] = ACTIONS(3510),
    [anon_sym___forceinline] = ACTIONS(3510),
    [anon_sym_thread_local] = ACTIONS(3510),
    [anon_sym___thread] = ACTIONS(3510),
    [anon_sym_const] = ACTIONS(3510),
    [anon_sym_constexpr] = ACTIONS(3510),
    [anon_sym_volatile] = ACTIONS(3510),
    [anon_sym_restrict] = ACTIONS(3510),
    [anon_sym___restrict__] = ACTIONS(3510),
    [anon_sym__Atomic] = ACTIONS(3510),
    [anon_sym__Noreturn] = ACTIONS(3510),
    [anon_sym_noreturn] = ACTIONS(3510),
    [anon_sym__Nonnull] = ACTIONS(3510),
    [anon_sym_mutable] = ACTIONS(3510),
    [anon_sym_constinit] = ACTIONS(3510),
    [anon_sym_consteval] = ACTIONS(3510),
    [anon_sym_alignas] = ACTIONS(3510),
    [anon_sym__Alignas] = ACTIONS(3510),
    [sym_primitive_type] = ACTIONS(3510),
    [anon_sym_enum] = ACTIONS(3510),
    [anon_sym_class] = ACTIONS(3510),
    [anon_sym_struct] = ACTIONS(3510),
    [anon_sym_union] = ACTIONS(3510),
    [anon_sym_if] = ACTIONS(3510),
    [anon_sym_else] = ACTIONS(3510),
    [anon_sym_switch] = ACTIONS(3510),
    [anon_sym_case] = ACTIONS(3510),
    [anon_sym_default] = ACTIONS(3510),
    [anon_sym_while] = ACTIONS(3510),
    [anon_sym_do] = ACTIONS(3510),
    [anon_sym_for] = ACTIONS(3510),
    [anon_sym_return] = ACTIONS(3510),
    [anon_sym_break] = ACTIONS(3510),
    [anon_sym_continue] = ACTIONS(3510),
    [anon_sym_goto] = ACTIONS(3510),
    [anon_sym___try] = ACTIONS(3510),
    [anon_sym___leave] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3510),
    [anon_sym_compl] = ACTIONS(3510),
    [anon_sym_DASH_DASH] = ACTIONS(3512),
    [anon_sym_PLUS_PLUS] = ACTIONS(3512),
    [anon_sym_sizeof] = ACTIONS(3510),
    [anon_sym___alignof__] = ACTIONS(3510),
    [anon_sym___alignof] = ACTIONS(3510),
    [anon_sym__alignof] = ACTIONS(3510),
    [anon_sym_alignof] = ACTIONS(3510),
    [anon_sym__Alignof] = ACTIONS(3510),
    [anon_sym_offsetof] = ACTIONS(3510),
    [anon_sym__Generic] = ACTIONS(3510),
    [anon_sym_asm] = ACTIONS(3510),
    [anon_sym___asm__] = ACTIONS(3510),
    [anon_sym___asm] = ACTIONS(3510),
    [sym_number_literal] = ACTIONS(3512),
    [anon_sym_L_SQUOTE] = ACTIONS(3512),
    [anon_sym_u_SQUOTE] = ACTIONS(3512),
    [anon_sym_U_SQUOTE] = ACTIONS(3512),
    [anon_sym_u8_SQUOTE] = ACTIONS(3512),
    [anon_sym_SQUOTE] = ACTIONS(3512),
    [anon_sym_L_DQUOTE] = ACTIONS(3512),
    [anon_sym_u_DQUOTE] = ACTIONS(3512),
    [anon_sym_U_DQUOTE] = ACTIONS(3512),
    [anon_sym_u8_DQUOTE] = ACTIONS(3512),
    [anon_sym_DQUOTE] = ACTIONS(3512),
    [sym_true] = ACTIONS(3510),
    [sym_false] = ACTIONS(3510),
    [anon_sym_NULL] = ACTIONS(3510),
    [anon_sym_nullptr] = ACTIONS(3510),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3510),
    [anon_sym_let] = ACTIONS(3510),
    [anon_sym_This] = ACTIONS(3510),
    [anon_sym_decltype] = ACTIONS(3510),
    [anon_sym_explicit] = ACTIONS(3510),
    [anon_sym_typename] = ACTIONS(3510),
    [anon_sym_template] = ACTIONS(3510),
    [anon_sym_operator] = ACTIONS(3510),
    [anon_sym_try] = ACTIONS(3510),
    [anon_sym_delete] = ACTIONS(3510),
    [anon_sym_throw] = ACTIONS(3510),
    [anon_sym_namespace] = ACTIONS(3510),
    [anon_sym_static_assert] = ACTIONS(3510),
    [anon_sym_concept] = ACTIONS(3510),
    [anon_sym_co_return] = ACTIONS(3510),
    [anon_sym_co_yield] = ACTIONS(3510),
    [anon_sym_R_DQUOTE] = ACTIONS(3512),
    [anon_sym_LR_DQUOTE] = ACTIONS(3512),
    [anon_sym_uR_DQUOTE] = ACTIONS(3512),
    [anon_sym_UR_DQUOTE] = ACTIONS(3512),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3512),
    [anon_sym_co_await] = ACTIONS(3510),
    [anon_sym_new] = ACTIONS(3510),
    [anon_sym_requires] = ACTIONS(3510),
    [sym_this] = ACTIONS(3510),
    [anon_sym_discard] = ACTIONS(3510),
    [anon_sym_precise] = ACTIONS(3510),
    [anon_sym_shared] = ACTIONS(3510),
    [anon_sym_groupshared] = ACTIONS(3510),
    [anon_sym_uniform] = ACTIONS(3510),
    [anon_sym_row_major] = ACTIONS(3510),
    [anon_sym_column_major] = ACTIONS(3510),
    [anon_sym_globallycoherent] = ACTIONS(3510),
    [anon_sym_centroid] = ACTIONS(3510),
    [anon_sym_noperspective] = ACTIONS(3510),
    [anon_sym_nointerpolation] = ACTIONS(3510),
    [anon_sym_sample] = ACTIONS(3510),
    [anon_sym_linear] = ACTIONS(3510),
    [anon_sym_snorm] = ACTIONS(3510),
    [anon_sym_unorm] = ACTIONS(3510),
    [anon_sym_point] = ACTIONS(3510),
    [anon_sym_line] = ACTIONS(3510),
    [anon_sym_triangleadj] = ACTIONS(3510),
    [anon_sym_lineadj] = ACTIONS(3510),
    [anon_sym_triangle] = ACTIONS(3510),
    [anon_sym_cbuffer] = ACTIONS(3510),
    [anon_sym_interface] = ACTIONS(3510),
    [anon_sym_extension] = ACTIONS(3510),
  },
  [877] = {
    [sym_expression] = STATE(5382),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(3357),
    [anon_sym_typedef] = ACTIONS(3360),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3370),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3373),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3376),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [878] = {
    [sym_identifier] = ACTIONS(3417),
    [aux_sym_preproc_include_token1] = ACTIONS(3417),
    [aux_sym_preproc_def_token1] = ACTIONS(3417),
    [aux_sym_preproc_if_token1] = ACTIONS(3417),
    [aux_sym_preproc_if_token2] = ACTIONS(3417),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3417),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3417),
    [sym_preproc_directive] = ACTIONS(3417),
    [anon_sym_LPAREN2] = ACTIONS(3415),
    [anon_sym_BANG] = ACTIONS(3415),
    [anon_sym_TILDE] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_STAR] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3415),
    [anon_sym_AMP] = ACTIONS(3417),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym___extension__] = ACTIONS(3417),
    [anon_sym_typedef] = ACTIONS(3417),
    [anon_sym_in] = ACTIONS(3417),
    [anon_sym_out] = ACTIONS(3417),
    [anon_sym_inout] = ACTIONS(3417),
    [anon_sym_virtual] = ACTIONS(3417),
    [anon_sym_extern] = ACTIONS(3417),
    [anon_sym___attribute__] = ACTIONS(3417),
    [anon_sym___attribute] = ACTIONS(3417),
    [anon_sym_using] = ACTIONS(3417),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3415),
    [anon_sym___declspec] = ACTIONS(3417),
    [anon_sym___based] = ACTIONS(3417),
    [anon_sym___cdecl] = ACTIONS(3417),
    [anon_sym___clrcall] = ACTIONS(3417),
    [anon_sym___stdcall] = ACTIONS(3417),
    [anon_sym___fastcall] = ACTIONS(3417),
    [anon_sym___thiscall] = ACTIONS(3417),
    [anon_sym___vectorcall] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3415),
    [anon_sym_signed] = ACTIONS(3417),
    [anon_sym_unsigned] = ACTIONS(3417),
    [anon_sym_long] = ACTIONS(3417),
    [anon_sym_short] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_static] = ACTIONS(3417),
    [anon_sym_register] = ACTIONS(3417),
    [anon_sym_inline] = ACTIONS(3417),
    [anon_sym___inline] = ACTIONS(3417),
    [anon_sym___inline__] = ACTIONS(3417),
    [anon_sym___forceinline] = ACTIONS(3417),
    [anon_sym_thread_local] = ACTIONS(3417),
    [anon_sym___thread] = ACTIONS(3417),
    [anon_sym_const] = ACTIONS(3417),
    [anon_sym_constexpr] = ACTIONS(3417),
    [anon_sym_volatile] = ACTIONS(3417),
    [anon_sym_restrict] = ACTIONS(3417),
    [anon_sym___restrict__] = ACTIONS(3417),
    [anon_sym__Atomic] = ACTIONS(3417),
    [anon_sym__Noreturn] = ACTIONS(3417),
    [anon_sym_noreturn] = ACTIONS(3417),
    [anon_sym__Nonnull] = ACTIONS(3417),
    [anon_sym_mutable] = ACTIONS(3417),
    [anon_sym_constinit] = ACTIONS(3417),
    [anon_sym_consteval] = ACTIONS(3417),
    [anon_sym_alignas] = ACTIONS(3417),
    [anon_sym__Alignas] = ACTIONS(3417),
    [sym_primitive_type] = ACTIONS(3417),
    [anon_sym_enum] = ACTIONS(3417),
    [anon_sym_class] = ACTIONS(3417),
    [anon_sym_struct] = ACTIONS(3417),
    [anon_sym_union] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_else] = ACTIONS(3417),
    [anon_sym_switch] = ACTIONS(3417),
    [anon_sym_case] = ACTIONS(3417),
    [anon_sym_default] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_break] = ACTIONS(3417),
    [anon_sym_continue] = ACTIONS(3417),
    [anon_sym_goto] = ACTIONS(3417),
    [anon_sym___try] = ACTIONS(3417),
    [anon_sym___leave] = ACTIONS(3417),
    [anon_sym_not] = ACTIONS(3417),
    [anon_sym_compl] = ACTIONS(3417),
    [anon_sym_DASH_DASH] = ACTIONS(3415),
    [anon_sym_PLUS_PLUS] = ACTIONS(3415),
    [anon_sym_sizeof] = ACTIONS(3417),
    [anon_sym___alignof__] = ACTIONS(3417),
    [anon_sym___alignof] = ACTIONS(3417),
    [anon_sym__alignof] = ACTIONS(3417),
    [anon_sym_alignof] = ACTIONS(3417),
    [anon_sym__Alignof] = ACTIONS(3417),
    [anon_sym_offsetof] = ACTIONS(3417),
    [anon_sym__Generic] = ACTIONS(3417),
    [anon_sym_asm] = ACTIONS(3417),
    [anon_sym___asm__] = ACTIONS(3417),
    [anon_sym___asm] = ACTIONS(3417),
    [sym_number_literal] = ACTIONS(3415),
    [anon_sym_L_SQUOTE] = ACTIONS(3415),
    [anon_sym_u_SQUOTE] = ACTIONS(3415),
    [anon_sym_U_SQUOTE] = ACTIONS(3415),
    [anon_sym_u8_SQUOTE] = ACTIONS(3415),
    [anon_sym_SQUOTE] = ACTIONS(3415),
    [anon_sym_L_DQUOTE] = ACTIONS(3415),
    [anon_sym_u_DQUOTE] = ACTIONS(3415),
    [anon_sym_U_DQUOTE] = ACTIONS(3415),
    [anon_sym_u8_DQUOTE] = ACTIONS(3415),
    [anon_sym_DQUOTE] = ACTIONS(3415),
    [sym_true] = ACTIONS(3417),
    [sym_false] = ACTIONS(3417),
    [anon_sym_NULL] = ACTIONS(3417),
    [anon_sym_nullptr] = ACTIONS(3417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_This] = ACTIONS(3417),
    [anon_sym_decltype] = ACTIONS(3417),
    [anon_sym_explicit] = ACTIONS(3417),
    [anon_sym_typename] = ACTIONS(3417),
    [anon_sym_template] = ACTIONS(3417),
    [anon_sym_operator] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_delete] = ACTIONS(3417),
    [anon_sym_throw] = ACTIONS(3417),
    [anon_sym_namespace] = ACTIONS(3417),
    [anon_sym_static_assert] = ACTIONS(3417),
    [anon_sym_concept] = ACTIONS(3417),
    [anon_sym_co_return] = ACTIONS(3417),
    [anon_sym_co_yield] = ACTIONS(3417),
    [anon_sym_R_DQUOTE] = ACTIONS(3415),
    [anon_sym_LR_DQUOTE] = ACTIONS(3415),
    [anon_sym_uR_DQUOTE] = ACTIONS(3415),
    [anon_sym_UR_DQUOTE] = ACTIONS(3415),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3415),
    [anon_sym_co_await] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_requires] = ACTIONS(3417),
    [sym_this] = ACTIONS(3417),
    [anon_sym_discard] = ACTIONS(3417),
    [anon_sym_precise] = ACTIONS(3417),
    [anon_sym_shared] = ACTIONS(3417),
    [anon_sym_groupshared] = ACTIONS(3417),
    [anon_sym_uniform] = ACTIONS(3417),
    [anon_sym_row_major] = ACTIONS(3417),
    [anon_sym_column_major] = ACTIONS(3417),
    [anon_sym_globallycoherent] = ACTIONS(3417),
    [anon_sym_centroid] = ACTIONS(3417),
    [anon_sym_noperspective] = ACTIONS(3417),
    [anon_sym_nointerpolation] = ACTIONS(3417),
    [anon_sym_sample] = ACTIONS(3417),
    [anon_sym_linear] = ACTIONS(3417),
    [anon_sym_snorm] = ACTIONS(3417),
    [anon_sym_unorm] = ACTIONS(3417),
    [anon_sym_point] = ACTIONS(3417),
    [anon_sym_line] = ACTIONS(3417),
    [anon_sym_triangleadj] = ACTIONS(3417),
    [anon_sym_lineadj] = ACTIONS(3417),
    [anon_sym_triangle] = ACTIONS(3417),
    [anon_sym_cbuffer] = ACTIONS(3417),
    [anon_sym_interface] = ACTIONS(3417),
    [anon_sym_extension] = ACTIONS(3417),
  },
  [879] = {
    [sym_expression] = STATE(5382),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(3357),
    [anon_sym_typedef] = ACTIONS(4261),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3370),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3373),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3376),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [880] = {
    [sym_expression] = STATE(5382),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(3357),
    [anon_sym_typedef] = ACTIONS(3659),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3370),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3373),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3376),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [881] = {
    [sym_identifier] = ACTIONS(3444),
    [aux_sym_preproc_include_token1] = ACTIONS(3444),
    [aux_sym_preproc_def_token1] = ACTIONS(3444),
    [aux_sym_preproc_if_token1] = ACTIONS(3444),
    [aux_sym_preproc_if_token2] = ACTIONS(3444),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3444),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3444),
    [sym_preproc_directive] = ACTIONS(3444),
    [anon_sym_LPAREN2] = ACTIONS(3442),
    [anon_sym_BANG] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3444),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_STAR] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_AMP] = ACTIONS(3444),
    [anon_sym_SEMI] = ACTIONS(3442),
    [anon_sym___extension__] = ACTIONS(3444),
    [anon_sym_typedef] = ACTIONS(3444),
    [anon_sym_in] = ACTIONS(3444),
    [anon_sym_out] = ACTIONS(3444),
    [anon_sym_inout] = ACTIONS(3444),
    [anon_sym_virtual] = ACTIONS(3444),
    [anon_sym_extern] = ACTIONS(3444),
    [anon_sym___attribute__] = ACTIONS(3444),
    [anon_sym___attribute] = ACTIONS(3444),
    [anon_sym_using] = ACTIONS(3444),
    [anon_sym_COLON_COLON] = ACTIONS(3442),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3442),
    [anon_sym___declspec] = ACTIONS(3444),
    [anon_sym___based] = ACTIONS(3444),
    [anon_sym___cdecl] = ACTIONS(3444),
    [anon_sym___clrcall] = ACTIONS(3444),
    [anon_sym___stdcall] = ACTIONS(3444),
    [anon_sym___fastcall] = ACTIONS(3444),
    [anon_sym___thiscall] = ACTIONS(3444),
    [anon_sym___vectorcall] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_signed] = ACTIONS(3444),
    [anon_sym_unsigned] = ACTIONS(3444),
    [anon_sym_long] = ACTIONS(3444),
    [anon_sym_short] = ACTIONS(3444),
    [anon_sym_LBRACK] = ACTIONS(3444),
    [anon_sym_static] = ACTIONS(3444),
    [anon_sym_register] = ACTIONS(3444),
    [anon_sym_inline] = ACTIONS(3444),
    [anon_sym___inline] = ACTIONS(3444),
    [anon_sym___inline__] = ACTIONS(3444),
    [anon_sym___forceinline] = ACTIONS(3444),
    [anon_sym_thread_local] = ACTIONS(3444),
    [anon_sym___thread] = ACTIONS(3444),
    [anon_sym_const] = ACTIONS(3444),
    [anon_sym_constexpr] = ACTIONS(3444),
    [anon_sym_volatile] = ACTIONS(3444),
    [anon_sym_restrict] = ACTIONS(3444),
    [anon_sym___restrict__] = ACTIONS(3444),
    [anon_sym__Atomic] = ACTIONS(3444),
    [anon_sym__Noreturn] = ACTIONS(3444),
    [anon_sym_noreturn] = ACTIONS(3444),
    [anon_sym__Nonnull] = ACTIONS(3444),
    [anon_sym_mutable] = ACTIONS(3444),
    [anon_sym_constinit] = ACTIONS(3444),
    [anon_sym_consteval] = ACTIONS(3444),
    [anon_sym_alignas] = ACTIONS(3444),
    [anon_sym__Alignas] = ACTIONS(3444),
    [sym_primitive_type] = ACTIONS(3444),
    [anon_sym_enum] = ACTIONS(3444),
    [anon_sym_class] = ACTIONS(3444),
    [anon_sym_struct] = ACTIONS(3444),
    [anon_sym_union] = ACTIONS(3444),
    [anon_sym_if] = ACTIONS(3444),
    [anon_sym_else] = ACTIONS(3444),
    [anon_sym_switch] = ACTIONS(3444),
    [anon_sym_case] = ACTIONS(3444),
    [anon_sym_default] = ACTIONS(3444),
    [anon_sym_while] = ACTIONS(3444),
    [anon_sym_do] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3444),
    [anon_sym_return] = ACTIONS(3444),
    [anon_sym_break] = ACTIONS(3444),
    [anon_sym_continue] = ACTIONS(3444),
    [anon_sym_goto] = ACTIONS(3444),
    [anon_sym___try] = ACTIONS(3444),
    [anon_sym___leave] = ACTIONS(3444),
    [anon_sym_not] = ACTIONS(3444),
    [anon_sym_compl] = ACTIONS(3444),
    [anon_sym_DASH_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_PLUS] = ACTIONS(3442),
    [anon_sym_sizeof] = ACTIONS(3444),
    [anon_sym___alignof__] = ACTIONS(3444),
    [anon_sym___alignof] = ACTIONS(3444),
    [anon_sym__alignof] = ACTIONS(3444),
    [anon_sym_alignof] = ACTIONS(3444),
    [anon_sym__Alignof] = ACTIONS(3444),
    [anon_sym_offsetof] = ACTIONS(3444),
    [anon_sym__Generic] = ACTIONS(3444),
    [anon_sym_asm] = ACTIONS(3444),
    [anon_sym___asm__] = ACTIONS(3444),
    [anon_sym___asm] = ACTIONS(3444),
    [sym_number_literal] = ACTIONS(3442),
    [anon_sym_L_SQUOTE] = ACTIONS(3442),
    [anon_sym_u_SQUOTE] = ACTIONS(3442),
    [anon_sym_U_SQUOTE] = ACTIONS(3442),
    [anon_sym_u8_SQUOTE] = ACTIONS(3442),
    [anon_sym_SQUOTE] = ACTIONS(3442),
    [anon_sym_L_DQUOTE] = ACTIONS(3442),
    [anon_sym_u_DQUOTE] = ACTIONS(3442),
    [anon_sym_U_DQUOTE] = ACTIONS(3442),
    [anon_sym_u8_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [sym_true] = ACTIONS(3444),
    [sym_false] = ACTIONS(3444),
    [anon_sym_NULL] = ACTIONS(3444),
    [anon_sym_nullptr] = ACTIONS(3444),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3444),
    [anon_sym_let] = ACTIONS(3444),
    [anon_sym_This] = ACTIONS(3444),
    [anon_sym_decltype] = ACTIONS(3444),
    [anon_sym_explicit] = ACTIONS(3444),
    [anon_sym_typename] = ACTIONS(3444),
    [anon_sym_template] = ACTIONS(3444),
    [anon_sym_operator] = ACTIONS(3444),
    [anon_sym_try] = ACTIONS(3444),
    [anon_sym_delete] = ACTIONS(3444),
    [anon_sym_throw] = ACTIONS(3444),
    [anon_sym_namespace] = ACTIONS(3444),
    [anon_sym_static_assert] = ACTIONS(3444),
    [anon_sym_concept] = ACTIONS(3444),
    [anon_sym_co_return] = ACTIONS(3444),
    [anon_sym_co_yield] = ACTIONS(3444),
    [anon_sym_R_DQUOTE] = ACTIONS(3442),
    [anon_sym_LR_DQUOTE] = ACTIONS(3442),
    [anon_sym_uR_DQUOTE] = ACTIONS(3442),
    [anon_sym_UR_DQUOTE] = ACTIONS(3442),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3442),
    [anon_sym_co_await] = ACTIONS(3444),
    [anon_sym_new] = ACTIONS(3444),
    [anon_sym_requires] = ACTIONS(3444),
    [sym_this] = ACTIONS(3444),
    [anon_sym_discard] = ACTIONS(3444),
    [anon_sym_precise] = ACTIONS(3444),
    [anon_sym_shared] = ACTIONS(3444),
    [anon_sym_groupshared] = ACTIONS(3444),
    [anon_sym_uniform] = ACTIONS(3444),
    [anon_sym_row_major] = ACTIONS(3444),
    [anon_sym_column_major] = ACTIONS(3444),
    [anon_sym_globallycoherent] = ACTIONS(3444),
    [anon_sym_centroid] = ACTIONS(3444),
    [anon_sym_noperspective] = ACTIONS(3444),
    [anon_sym_nointerpolation] = ACTIONS(3444),
    [anon_sym_sample] = ACTIONS(3444),
    [anon_sym_linear] = ACTIONS(3444),
    [anon_sym_snorm] = ACTIONS(3444),
    [anon_sym_unorm] = ACTIONS(3444),
    [anon_sym_point] = ACTIONS(3444),
    [anon_sym_line] = ACTIONS(3444),
    [anon_sym_triangleadj] = ACTIONS(3444),
    [anon_sym_lineadj] = ACTIONS(3444),
    [anon_sym_triangle] = ACTIONS(3444),
    [anon_sym_cbuffer] = ACTIONS(3444),
    [anon_sym_interface] = ACTIONS(3444),
    [anon_sym_extension] = ACTIONS(3444),
  },
  [882] = {
    [sym_expression] = STATE(5382),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(3357),
    [anon_sym_typedef] = ACTIONS(3583),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3370),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3373),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3376),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [883] = {
    [sym_identifier] = ACTIONS(3607),
    [aux_sym_preproc_include_token1] = ACTIONS(3607),
    [aux_sym_preproc_def_token1] = ACTIONS(3607),
    [aux_sym_preproc_if_token1] = ACTIONS(3607),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3607),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3607),
    [sym_preproc_directive] = ACTIONS(3607),
    [anon_sym_LPAREN2] = ACTIONS(3605),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(3605),
    [anon_sym_AMP_AMP] = ACTIONS(3605),
    [anon_sym_AMP] = ACTIONS(3607),
    [anon_sym_SEMI] = ACTIONS(3605),
    [anon_sym___extension__] = ACTIONS(3607),
    [anon_sym_typedef] = ACTIONS(3607),
    [anon_sym_in] = ACTIONS(3607),
    [anon_sym_out] = ACTIONS(3607),
    [anon_sym_inout] = ACTIONS(3607),
    [anon_sym_virtual] = ACTIONS(3607),
    [anon_sym_extern] = ACTIONS(3607),
    [anon_sym___attribute__] = ACTIONS(3607),
    [anon_sym___attribute] = ACTIONS(3607),
    [anon_sym_using] = ACTIONS(3607),
    [anon_sym_COLON_COLON] = ACTIONS(3605),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3605),
    [anon_sym___declspec] = ACTIONS(3607),
    [anon_sym___based] = ACTIONS(3607),
    [anon_sym___cdecl] = ACTIONS(3607),
    [anon_sym___clrcall] = ACTIONS(3607),
    [anon_sym___stdcall] = ACTIONS(3607),
    [anon_sym___fastcall] = ACTIONS(3607),
    [anon_sym___thiscall] = ACTIONS(3607),
    [anon_sym___vectorcall] = ACTIONS(3607),
    [anon_sym_LBRACE] = ACTIONS(3605),
    [anon_sym_RBRACE] = ACTIONS(3605),
    [anon_sym_signed] = ACTIONS(3607),
    [anon_sym_unsigned] = ACTIONS(3607),
    [anon_sym_long] = ACTIONS(3607),
    [anon_sym_short] = ACTIONS(3607),
    [anon_sym_LBRACK] = ACTIONS(3607),
    [anon_sym_static] = ACTIONS(3607),
    [anon_sym_register] = ACTIONS(3607),
    [anon_sym_inline] = ACTIONS(3607),
    [anon_sym___inline] = ACTIONS(3607),
    [anon_sym___inline__] = ACTIONS(3607),
    [anon_sym___forceinline] = ACTIONS(3607),
    [anon_sym_thread_local] = ACTIONS(3607),
    [anon_sym___thread] = ACTIONS(3607),
    [anon_sym_const] = ACTIONS(3607),
    [anon_sym_constexpr] = ACTIONS(3607),
    [anon_sym_volatile] = ACTIONS(3607),
    [anon_sym_restrict] = ACTIONS(3607),
    [anon_sym___restrict__] = ACTIONS(3607),
    [anon_sym__Atomic] = ACTIONS(3607),
    [anon_sym__Noreturn] = ACTIONS(3607),
    [anon_sym_noreturn] = ACTIONS(3607),
    [anon_sym__Nonnull] = ACTIONS(3607),
    [anon_sym_mutable] = ACTIONS(3607),
    [anon_sym_constinit] = ACTIONS(3607),
    [anon_sym_consteval] = ACTIONS(3607),
    [anon_sym_alignas] = ACTIONS(3607),
    [anon_sym__Alignas] = ACTIONS(3607),
    [sym_primitive_type] = ACTIONS(3607),
    [anon_sym_enum] = ACTIONS(3607),
    [anon_sym_class] = ACTIONS(3607),
    [anon_sym_struct] = ACTIONS(3607),
    [anon_sym_union] = ACTIONS(3607),
    [anon_sym_if] = ACTIONS(3607),
    [anon_sym_else] = ACTIONS(3607),
    [anon_sym_switch] = ACTIONS(3607),
    [anon_sym_case] = ACTIONS(3607),
    [anon_sym_default] = ACTIONS(3607),
    [anon_sym_while] = ACTIONS(3607),
    [anon_sym_do] = ACTIONS(3607),
    [anon_sym_for] = ACTIONS(3607),
    [anon_sym_return] = ACTIONS(3607),
    [anon_sym_break] = ACTIONS(3607),
    [anon_sym_continue] = ACTIONS(3607),
    [anon_sym_goto] = ACTIONS(3607),
    [anon_sym___try] = ACTIONS(3607),
    [anon_sym___leave] = ACTIONS(3607),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(3605),
    [anon_sym_PLUS_PLUS] = ACTIONS(3605),
    [anon_sym_sizeof] = ACTIONS(3607),
    [anon_sym___alignof__] = ACTIONS(3607),
    [anon_sym___alignof] = ACTIONS(3607),
    [anon_sym__alignof] = ACTIONS(3607),
    [anon_sym_alignof] = ACTIONS(3607),
    [anon_sym__Alignof] = ACTIONS(3607),
    [anon_sym_offsetof] = ACTIONS(3607),
    [anon_sym__Generic] = ACTIONS(3607),
    [anon_sym_asm] = ACTIONS(3607),
    [anon_sym___asm__] = ACTIONS(3607),
    [anon_sym___asm] = ACTIONS(3607),
    [sym_number_literal] = ACTIONS(3605),
    [anon_sym_L_SQUOTE] = ACTIONS(3605),
    [anon_sym_u_SQUOTE] = ACTIONS(3605),
    [anon_sym_U_SQUOTE] = ACTIONS(3605),
    [anon_sym_u8_SQUOTE] = ACTIONS(3605),
    [anon_sym_SQUOTE] = ACTIONS(3605),
    [anon_sym_L_DQUOTE] = ACTIONS(3605),
    [anon_sym_u_DQUOTE] = ACTIONS(3605),
    [anon_sym_U_DQUOTE] = ACTIONS(3605),
    [anon_sym_u8_DQUOTE] = ACTIONS(3605),
    [anon_sym_DQUOTE] = ACTIONS(3605),
    [sym_true] = ACTIONS(3607),
    [sym_false] = ACTIONS(3607),
    [anon_sym_NULL] = ACTIONS(3607),
    [anon_sym_nullptr] = ACTIONS(3607),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3607),
    [anon_sym_let] = ACTIONS(3607),
    [anon_sym_This] = ACTIONS(3607),
    [anon_sym_decltype] = ACTIONS(3607),
    [anon_sym_explicit] = ACTIONS(3607),
    [anon_sym_typename] = ACTIONS(3607),
    [anon_sym_template] = ACTIONS(3607),
    [anon_sym_operator] = ACTIONS(3607),
    [anon_sym_try] = ACTIONS(3607),
    [anon_sym_delete] = ACTIONS(3607),
    [anon_sym_throw] = ACTIONS(3607),
    [anon_sym_namespace] = ACTIONS(3607),
    [anon_sym_static_assert] = ACTIONS(3607),
    [anon_sym_concept] = ACTIONS(3607),
    [anon_sym_co_return] = ACTIONS(3607),
    [anon_sym_co_yield] = ACTIONS(3607),
    [anon_sym_R_DQUOTE] = ACTIONS(3605),
    [anon_sym_LR_DQUOTE] = ACTIONS(3605),
    [anon_sym_uR_DQUOTE] = ACTIONS(3605),
    [anon_sym_UR_DQUOTE] = ACTIONS(3605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3605),
    [anon_sym_co_await] = ACTIONS(3607),
    [anon_sym_new] = ACTIONS(3607),
    [anon_sym_requires] = ACTIONS(3607),
    [sym_this] = ACTIONS(3607),
    [anon_sym_discard] = ACTIONS(3607),
    [anon_sym_precise] = ACTIONS(3607),
    [anon_sym_shared] = ACTIONS(3607),
    [anon_sym_groupshared] = ACTIONS(3607),
    [anon_sym_uniform] = ACTIONS(3607),
    [anon_sym_row_major] = ACTIONS(3607),
    [anon_sym_column_major] = ACTIONS(3607),
    [anon_sym_globallycoherent] = ACTIONS(3607),
    [anon_sym_centroid] = ACTIONS(3607),
    [anon_sym_noperspective] = ACTIONS(3607),
    [anon_sym_nointerpolation] = ACTIONS(3607),
    [anon_sym_sample] = ACTIONS(3607),
    [anon_sym_linear] = ACTIONS(3607),
    [anon_sym_snorm] = ACTIONS(3607),
    [anon_sym_unorm] = ACTIONS(3607),
    [anon_sym_point] = ACTIONS(3607),
    [anon_sym_line] = ACTIONS(3607),
    [anon_sym_triangleadj] = ACTIONS(3607),
    [anon_sym_lineadj] = ACTIONS(3607),
    [anon_sym_triangle] = ACTIONS(3607),
    [anon_sym_cbuffer] = ACTIONS(3607),
    [anon_sym_interface] = ACTIONS(3607),
    [anon_sym_extension] = ACTIONS(3607),
  },
  [884] = {
    [ts_builtin_sym_end] = ACTIONS(3867),
    [sym_identifier] = ACTIONS(3865),
    [aux_sym_preproc_include_token1] = ACTIONS(3865),
    [aux_sym_preproc_def_token1] = ACTIONS(3865),
    [aux_sym_preproc_if_token1] = ACTIONS(3865),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3865),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3865),
    [sym_preproc_directive] = ACTIONS(3865),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_BANG] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_STAR] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_AMP] = ACTIONS(3865),
    [anon_sym_SEMI] = ACTIONS(3867),
    [anon_sym___extension__] = ACTIONS(3865),
    [anon_sym_typedef] = ACTIONS(3865),
    [anon_sym_in] = ACTIONS(3865),
    [anon_sym_out] = ACTIONS(3865),
    [anon_sym_inout] = ACTIONS(3865),
    [anon_sym_virtual] = ACTIONS(3865),
    [anon_sym_extern] = ACTIONS(3865),
    [anon_sym___attribute__] = ACTIONS(3865),
    [anon_sym___attribute] = ACTIONS(3865),
    [anon_sym_using] = ACTIONS(3865),
    [anon_sym_COLON_COLON] = ACTIONS(3867),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3867),
    [anon_sym___declspec] = ACTIONS(3865),
    [anon_sym___based] = ACTIONS(3865),
    [anon_sym___cdecl] = ACTIONS(3865),
    [anon_sym___clrcall] = ACTIONS(3865),
    [anon_sym___stdcall] = ACTIONS(3865),
    [anon_sym___fastcall] = ACTIONS(3865),
    [anon_sym___thiscall] = ACTIONS(3865),
    [anon_sym___vectorcall] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3867),
    [anon_sym_signed] = ACTIONS(3865),
    [anon_sym_unsigned] = ACTIONS(3865),
    [anon_sym_long] = ACTIONS(3865),
    [anon_sym_short] = ACTIONS(3865),
    [anon_sym_LBRACK] = ACTIONS(3865),
    [anon_sym_static] = ACTIONS(3865),
    [anon_sym_register] = ACTIONS(3865),
    [anon_sym_inline] = ACTIONS(3865),
    [anon_sym___inline] = ACTIONS(3865),
    [anon_sym___inline__] = ACTIONS(3865),
    [anon_sym___forceinline] = ACTIONS(3865),
    [anon_sym_thread_local] = ACTIONS(3865),
    [anon_sym___thread] = ACTIONS(3865),
    [anon_sym_const] = ACTIONS(3865),
    [anon_sym_constexpr] = ACTIONS(3865),
    [anon_sym_volatile] = ACTIONS(3865),
    [anon_sym_restrict] = ACTIONS(3865),
    [anon_sym___restrict__] = ACTIONS(3865),
    [anon_sym__Atomic] = ACTIONS(3865),
    [anon_sym__Noreturn] = ACTIONS(3865),
    [anon_sym_noreturn] = ACTIONS(3865),
    [anon_sym__Nonnull] = ACTIONS(3865),
    [anon_sym_mutable] = ACTIONS(3865),
    [anon_sym_constinit] = ACTIONS(3865),
    [anon_sym_consteval] = ACTIONS(3865),
    [anon_sym_alignas] = ACTIONS(3865),
    [anon_sym__Alignas] = ACTIONS(3865),
    [sym_primitive_type] = ACTIONS(3865),
    [anon_sym_enum] = ACTIONS(3865),
    [anon_sym_class] = ACTIONS(3865),
    [anon_sym_struct] = ACTIONS(3865),
    [anon_sym_union] = ACTIONS(3865),
    [anon_sym_if] = ACTIONS(3865),
    [anon_sym_switch] = ACTIONS(3865),
    [anon_sym_case] = ACTIONS(3865),
    [anon_sym_default] = ACTIONS(3865),
    [anon_sym_while] = ACTIONS(3865),
    [anon_sym_do] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3865),
    [anon_sym_return] = ACTIONS(3865),
    [anon_sym_break] = ACTIONS(3865),
    [anon_sym_continue] = ACTIONS(3865),
    [anon_sym_goto] = ACTIONS(3865),
    [anon_sym_not] = ACTIONS(3865),
    [anon_sym_compl] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3867),
    [anon_sym_PLUS_PLUS] = ACTIONS(3867),
    [anon_sym_sizeof] = ACTIONS(3865),
    [anon_sym___alignof__] = ACTIONS(3865),
    [anon_sym___alignof] = ACTIONS(3865),
    [anon_sym__alignof] = ACTIONS(3865),
    [anon_sym_alignof] = ACTIONS(3865),
    [anon_sym__Alignof] = ACTIONS(3865),
    [anon_sym_offsetof] = ACTIONS(3865),
    [anon_sym__Generic] = ACTIONS(3865),
    [anon_sym_asm] = ACTIONS(3865),
    [anon_sym___asm__] = ACTIONS(3865),
    [anon_sym___asm] = ACTIONS(3865),
    [sym_number_literal] = ACTIONS(3867),
    [anon_sym_L_SQUOTE] = ACTIONS(3867),
    [anon_sym_u_SQUOTE] = ACTIONS(3867),
    [anon_sym_U_SQUOTE] = ACTIONS(3867),
    [anon_sym_u8_SQUOTE] = ACTIONS(3867),
    [anon_sym_SQUOTE] = ACTIONS(3867),
    [anon_sym_L_DQUOTE] = ACTIONS(3867),
    [anon_sym_u_DQUOTE] = ACTIONS(3867),
    [anon_sym_U_DQUOTE] = ACTIONS(3867),
    [anon_sym_u8_DQUOTE] = ACTIONS(3867),
    [anon_sym_DQUOTE] = ACTIONS(3867),
    [sym_true] = ACTIONS(3865),
    [sym_false] = ACTIONS(3865),
    [anon_sym_NULL] = ACTIONS(3865),
    [anon_sym_nullptr] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3865),
    [anon_sym_let] = ACTIONS(3865),
    [anon_sym_This] = ACTIONS(3865),
    [anon_sym_decltype] = ACTIONS(3865),
    [anon_sym_explicit] = ACTIONS(3865),
    [anon_sym_typename] = ACTIONS(3865),
    [anon_sym_export] = ACTIONS(3865),
    [anon_sym_module] = ACTIONS(3865),
    [anon_sym_import] = ACTIONS(3865),
    [anon_sym_template] = ACTIONS(3865),
    [anon_sym_operator] = ACTIONS(3865),
    [anon_sym_try] = ACTIONS(3865),
    [anon_sym_delete] = ACTIONS(3865),
    [anon_sym_throw] = ACTIONS(3865),
    [anon_sym_namespace] = ACTIONS(3865),
    [anon_sym_static_assert] = ACTIONS(3865),
    [anon_sym_concept] = ACTIONS(3865),
    [anon_sym_co_return] = ACTIONS(3865),
    [anon_sym_co_yield] = ACTIONS(3865),
    [anon_sym_R_DQUOTE] = ACTIONS(3867),
    [anon_sym_LR_DQUOTE] = ACTIONS(3867),
    [anon_sym_uR_DQUOTE] = ACTIONS(3867),
    [anon_sym_UR_DQUOTE] = ACTIONS(3867),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3867),
    [anon_sym_co_await] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(3865),
    [sym_this] = ACTIONS(3865),
    [anon_sym_precise] = ACTIONS(3865),
    [anon_sym_shared] = ACTIONS(3865),
    [anon_sym_groupshared] = ACTIONS(3865),
    [anon_sym_uniform] = ACTIONS(3865),
    [anon_sym_row_major] = ACTIONS(3865),
    [anon_sym_column_major] = ACTIONS(3865),
    [anon_sym_globallycoherent] = ACTIONS(3865),
    [anon_sym_centroid] = ACTIONS(3865),
    [anon_sym_noperspective] = ACTIONS(3865),
    [anon_sym_nointerpolation] = ACTIONS(3865),
    [anon_sym_sample] = ACTIONS(3865),
    [anon_sym_linear] = ACTIONS(3865),
    [anon_sym_snorm] = ACTIONS(3865),
    [anon_sym_unorm] = ACTIONS(3865),
    [anon_sym_point] = ACTIONS(3865),
    [anon_sym_line] = ACTIONS(3865),
    [anon_sym_triangleadj] = ACTIONS(3865),
    [anon_sym_lineadj] = ACTIONS(3865),
    [anon_sym_triangle] = ACTIONS(3865),
    [anon_sym_interface] = ACTIONS(3865),
    [anon_sym_extension] = ACTIONS(3865),
    [anon_sym___exported] = ACTIONS(3865),
  },
  [885] = {
    [sym_identifier] = ACTIONS(3691),
    [aux_sym_preproc_include_token1] = ACTIONS(3691),
    [aux_sym_preproc_def_token1] = ACTIONS(3691),
    [aux_sym_preproc_if_token1] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3691),
    [sym_preproc_directive] = ACTIONS(3691),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_BANG] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_PLUS] = ACTIONS(3691),
    [anon_sym_STAR] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_AMP] = ACTIONS(3691),
    [anon_sym_SEMI] = ACTIONS(3693),
    [anon_sym___extension__] = ACTIONS(3691),
    [anon_sym_typedef] = ACTIONS(3691),
    [anon_sym_in] = ACTIONS(3691),
    [anon_sym_out] = ACTIONS(3691),
    [anon_sym_inout] = ACTIONS(3691),
    [anon_sym_virtual] = ACTIONS(3691),
    [anon_sym_extern] = ACTIONS(3691),
    [anon_sym___attribute__] = ACTIONS(3691),
    [anon_sym___attribute] = ACTIONS(3691),
    [anon_sym_using] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3693),
    [anon_sym___declspec] = ACTIONS(3691),
    [anon_sym___based] = ACTIONS(3691),
    [anon_sym___cdecl] = ACTIONS(3691),
    [anon_sym___clrcall] = ACTIONS(3691),
    [anon_sym___stdcall] = ACTIONS(3691),
    [anon_sym___fastcall] = ACTIONS(3691),
    [anon_sym___thiscall] = ACTIONS(3691),
    [anon_sym___vectorcall] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_RBRACE] = ACTIONS(3693),
    [anon_sym_signed] = ACTIONS(3691),
    [anon_sym_unsigned] = ACTIONS(3691),
    [anon_sym_long] = ACTIONS(3691),
    [anon_sym_short] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(3691),
    [anon_sym_static] = ACTIONS(3691),
    [anon_sym_register] = ACTIONS(3691),
    [anon_sym_inline] = ACTIONS(3691),
    [anon_sym___inline] = ACTIONS(3691),
    [anon_sym___inline__] = ACTIONS(3691),
    [anon_sym___forceinline] = ACTIONS(3691),
    [anon_sym_thread_local] = ACTIONS(3691),
    [anon_sym___thread] = ACTIONS(3691),
    [anon_sym_const] = ACTIONS(3691),
    [anon_sym_constexpr] = ACTIONS(3691),
    [anon_sym_volatile] = ACTIONS(3691),
    [anon_sym_restrict] = ACTIONS(3691),
    [anon_sym___restrict__] = ACTIONS(3691),
    [anon_sym__Atomic] = ACTIONS(3691),
    [anon_sym__Noreturn] = ACTIONS(3691),
    [anon_sym_noreturn] = ACTIONS(3691),
    [anon_sym__Nonnull] = ACTIONS(3691),
    [anon_sym_mutable] = ACTIONS(3691),
    [anon_sym_constinit] = ACTIONS(3691),
    [anon_sym_consteval] = ACTIONS(3691),
    [anon_sym_alignas] = ACTIONS(3691),
    [anon_sym__Alignas] = ACTIONS(3691),
    [sym_primitive_type] = ACTIONS(3691),
    [anon_sym_enum] = ACTIONS(3691),
    [anon_sym_class] = ACTIONS(3691),
    [anon_sym_struct] = ACTIONS(3691),
    [anon_sym_union] = ACTIONS(3691),
    [anon_sym_if] = ACTIONS(3691),
    [anon_sym_switch] = ACTIONS(3691),
    [anon_sym_case] = ACTIONS(3691),
    [anon_sym_default] = ACTIONS(3691),
    [anon_sym_while] = ACTIONS(3691),
    [anon_sym_do] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3691),
    [anon_sym_return] = ACTIONS(3691),
    [anon_sym_break] = ACTIONS(3691),
    [anon_sym_continue] = ACTIONS(3691),
    [anon_sym_goto] = ACTIONS(3691),
    [anon_sym___try] = ACTIONS(3691),
    [anon_sym___leave] = ACTIONS(3691),
    [anon_sym_not] = ACTIONS(3691),
    [anon_sym_compl] = ACTIONS(3691),
    [anon_sym_DASH_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_PLUS] = ACTIONS(3693),
    [anon_sym_sizeof] = ACTIONS(3691),
    [anon_sym___alignof__] = ACTIONS(3691),
    [anon_sym___alignof] = ACTIONS(3691),
    [anon_sym__alignof] = ACTIONS(3691),
    [anon_sym_alignof] = ACTIONS(3691),
    [anon_sym__Alignof] = ACTIONS(3691),
    [anon_sym_offsetof] = ACTIONS(3691),
    [anon_sym__Generic] = ACTIONS(3691),
    [anon_sym_asm] = ACTIONS(3691),
    [anon_sym___asm__] = ACTIONS(3691),
    [anon_sym___asm] = ACTIONS(3691),
    [sym_number_literal] = ACTIONS(3693),
    [anon_sym_L_SQUOTE] = ACTIONS(3693),
    [anon_sym_u_SQUOTE] = ACTIONS(3693),
    [anon_sym_U_SQUOTE] = ACTIONS(3693),
    [anon_sym_u8_SQUOTE] = ACTIONS(3693),
    [anon_sym_SQUOTE] = ACTIONS(3693),
    [anon_sym_L_DQUOTE] = ACTIONS(3693),
    [anon_sym_u_DQUOTE] = ACTIONS(3693),
    [anon_sym_U_DQUOTE] = ACTIONS(3693),
    [anon_sym_u8_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [sym_true] = ACTIONS(3691),
    [sym_false] = ACTIONS(3691),
    [anon_sym_NULL] = ACTIONS(3691),
    [anon_sym_nullptr] = ACTIONS(3691),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3691),
    [anon_sym_let] = ACTIONS(3691),
    [anon_sym_This] = ACTIONS(3691),
    [anon_sym_decltype] = ACTIONS(3691),
    [anon_sym_explicit] = ACTIONS(3691),
    [anon_sym_typename] = ACTIONS(3691),
    [anon_sym_template] = ACTIONS(3691),
    [anon_sym_operator] = ACTIONS(3691),
    [anon_sym_try] = ACTIONS(3691),
    [anon_sym_delete] = ACTIONS(3691),
    [anon_sym_throw] = ACTIONS(3691),
    [anon_sym_namespace] = ACTIONS(3691),
    [anon_sym_static_assert] = ACTIONS(3691),
    [anon_sym_concept] = ACTIONS(3691),
    [anon_sym_co_return] = ACTIONS(3691),
    [anon_sym_co_yield] = ACTIONS(3691),
    [anon_sym_R_DQUOTE] = ACTIONS(3693),
    [anon_sym_LR_DQUOTE] = ACTIONS(3693),
    [anon_sym_uR_DQUOTE] = ACTIONS(3693),
    [anon_sym_UR_DQUOTE] = ACTIONS(3693),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3693),
    [anon_sym_co_await] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3691),
    [anon_sym_requires] = ACTIONS(3691),
    [sym_this] = ACTIONS(3691),
    [anon_sym_discard] = ACTIONS(3691),
    [anon_sym_precise] = ACTIONS(3691),
    [anon_sym_shared] = ACTIONS(3691),
    [anon_sym_groupshared] = ACTIONS(3691),
    [anon_sym_uniform] = ACTIONS(3691),
    [anon_sym_row_major] = ACTIONS(3691),
    [anon_sym_column_major] = ACTIONS(3691),
    [anon_sym_globallycoherent] = ACTIONS(3691),
    [anon_sym_centroid] = ACTIONS(3691),
    [anon_sym_noperspective] = ACTIONS(3691),
    [anon_sym_nointerpolation] = ACTIONS(3691),
    [anon_sym_sample] = ACTIONS(3691),
    [anon_sym_linear] = ACTIONS(3691),
    [anon_sym_snorm] = ACTIONS(3691),
    [anon_sym_unorm] = ACTIONS(3691),
    [anon_sym_point] = ACTIONS(3691),
    [anon_sym_line] = ACTIONS(3691),
    [anon_sym_triangleadj] = ACTIONS(3691),
    [anon_sym_lineadj] = ACTIONS(3691),
    [anon_sym_triangle] = ACTIONS(3691),
    [anon_sym_cbuffer] = ACTIONS(3691),
    [anon_sym_interface] = ACTIONS(3691),
    [anon_sym_extension] = ACTIONS(3691),
  },
  [886] = {
    [sym_identifier] = ACTIONS(3771),
    [aux_sym_preproc_include_token1] = ACTIONS(3771),
    [aux_sym_preproc_def_token1] = ACTIONS(3771),
    [aux_sym_preproc_if_token1] = ACTIONS(3771),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3771),
    [sym_preproc_directive] = ACTIONS(3771),
    [anon_sym_LPAREN2] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(3773),
    [anon_sym_TILDE] = ACTIONS(3773),
    [anon_sym_DASH] = ACTIONS(3771),
    [anon_sym_PLUS] = ACTIONS(3771),
    [anon_sym_STAR] = ACTIONS(3773),
    [anon_sym_AMP_AMP] = ACTIONS(3773),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_SEMI] = ACTIONS(3773),
    [anon_sym___extension__] = ACTIONS(3771),
    [anon_sym_typedef] = ACTIONS(3771),
    [anon_sym_in] = ACTIONS(3771),
    [anon_sym_out] = ACTIONS(3771),
    [anon_sym_inout] = ACTIONS(3771),
    [anon_sym_virtual] = ACTIONS(3771),
    [anon_sym_extern] = ACTIONS(3771),
    [anon_sym___attribute__] = ACTIONS(3771),
    [anon_sym___attribute] = ACTIONS(3771),
    [anon_sym_using] = ACTIONS(3771),
    [anon_sym_COLON_COLON] = ACTIONS(3773),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3773),
    [anon_sym___declspec] = ACTIONS(3771),
    [anon_sym___based] = ACTIONS(3771),
    [anon_sym___cdecl] = ACTIONS(3771),
    [anon_sym___clrcall] = ACTIONS(3771),
    [anon_sym___stdcall] = ACTIONS(3771),
    [anon_sym___fastcall] = ACTIONS(3771),
    [anon_sym___thiscall] = ACTIONS(3771),
    [anon_sym___vectorcall] = ACTIONS(3771),
    [anon_sym_LBRACE] = ACTIONS(3773),
    [anon_sym_RBRACE] = ACTIONS(3773),
    [anon_sym_signed] = ACTIONS(3771),
    [anon_sym_unsigned] = ACTIONS(3771),
    [anon_sym_long] = ACTIONS(3771),
    [anon_sym_short] = ACTIONS(3771),
    [anon_sym_LBRACK] = ACTIONS(3771),
    [anon_sym_static] = ACTIONS(3771),
    [anon_sym_register] = ACTIONS(3771),
    [anon_sym_inline] = ACTIONS(3771),
    [anon_sym___inline] = ACTIONS(3771),
    [anon_sym___inline__] = ACTIONS(3771),
    [anon_sym___forceinline] = ACTIONS(3771),
    [anon_sym_thread_local] = ACTIONS(3771),
    [anon_sym___thread] = ACTIONS(3771),
    [anon_sym_const] = ACTIONS(3771),
    [anon_sym_constexpr] = ACTIONS(3771),
    [anon_sym_volatile] = ACTIONS(3771),
    [anon_sym_restrict] = ACTIONS(3771),
    [anon_sym___restrict__] = ACTIONS(3771),
    [anon_sym__Atomic] = ACTIONS(3771),
    [anon_sym__Noreturn] = ACTIONS(3771),
    [anon_sym_noreturn] = ACTIONS(3771),
    [anon_sym__Nonnull] = ACTIONS(3771),
    [anon_sym_mutable] = ACTIONS(3771),
    [anon_sym_constinit] = ACTIONS(3771),
    [anon_sym_consteval] = ACTIONS(3771),
    [anon_sym_alignas] = ACTIONS(3771),
    [anon_sym__Alignas] = ACTIONS(3771),
    [sym_primitive_type] = ACTIONS(3771),
    [anon_sym_enum] = ACTIONS(3771),
    [anon_sym_class] = ACTIONS(3771),
    [anon_sym_struct] = ACTIONS(3771),
    [anon_sym_union] = ACTIONS(3771),
    [anon_sym_if] = ACTIONS(3771),
    [anon_sym_switch] = ACTIONS(3771),
    [anon_sym_case] = ACTIONS(3771),
    [anon_sym_default] = ACTIONS(3771),
    [anon_sym_while] = ACTIONS(3771),
    [anon_sym_do] = ACTIONS(3771),
    [anon_sym_for] = ACTIONS(3771),
    [anon_sym_return] = ACTIONS(3771),
    [anon_sym_break] = ACTIONS(3771),
    [anon_sym_continue] = ACTIONS(3771),
    [anon_sym_goto] = ACTIONS(3771),
    [anon_sym___try] = ACTIONS(3771),
    [anon_sym___leave] = ACTIONS(3771),
    [anon_sym_not] = ACTIONS(3771),
    [anon_sym_compl] = ACTIONS(3771),
    [anon_sym_DASH_DASH] = ACTIONS(3773),
    [anon_sym_PLUS_PLUS] = ACTIONS(3773),
    [anon_sym_sizeof] = ACTIONS(3771),
    [anon_sym___alignof__] = ACTIONS(3771),
    [anon_sym___alignof] = ACTIONS(3771),
    [anon_sym__alignof] = ACTIONS(3771),
    [anon_sym_alignof] = ACTIONS(3771),
    [anon_sym__Alignof] = ACTIONS(3771),
    [anon_sym_offsetof] = ACTIONS(3771),
    [anon_sym__Generic] = ACTIONS(3771),
    [anon_sym_asm] = ACTIONS(3771),
    [anon_sym___asm__] = ACTIONS(3771),
    [anon_sym___asm] = ACTIONS(3771),
    [sym_number_literal] = ACTIONS(3773),
    [anon_sym_L_SQUOTE] = ACTIONS(3773),
    [anon_sym_u_SQUOTE] = ACTIONS(3773),
    [anon_sym_U_SQUOTE] = ACTIONS(3773),
    [anon_sym_u8_SQUOTE] = ACTIONS(3773),
    [anon_sym_SQUOTE] = ACTIONS(3773),
    [anon_sym_L_DQUOTE] = ACTIONS(3773),
    [anon_sym_u_DQUOTE] = ACTIONS(3773),
    [anon_sym_U_DQUOTE] = ACTIONS(3773),
    [anon_sym_u8_DQUOTE] = ACTIONS(3773),
    [anon_sym_DQUOTE] = ACTIONS(3773),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [anon_sym_NULL] = ACTIONS(3771),
    [anon_sym_nullptr] = ACTIONS(3771),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3771),
    [anon_sym_let] = ACTIONS(3771),
    [anon_sym_This] = ACTIONS(3771),
    [anon_sym_decltype] = ACTIONS(3771),
    [anon_sym_explicit] = ACTIONS(3771),
    [anon_sym_typename] = ACTIONS(3771),
    [anon_sym_template] = ACTIONS(3771),
    [anon_sym_operator] = ACTIONS(3771),
    [anon_sym_try] = ACTIONS(3771),
    [anon_sym_delete] = ACTIONS(3771),
    [anon_sym_throw] = ACTIONS(3771),
    [anon_sym_namespace] = ACTIONS(3771),
    [anon_sym_static_assert] = ACTIONS(3771),
    [anon_sym_concept] = ACTIONS(3771),
    [anon_sym_co_return] = ACTIONS(3771),
    [anon_sym_co_yield] = ACTIONS(3771),
    [anon_sym_R_DQUOTE] = ACTIONS(3773),
    [anon_sym_LR_DQUOTE] = ACTIONS(3773),
    [anon_sym_uR_DQUOTE] = ACTIONS(3773),
    [anon_sym_UR_DQUOTE] = ACTIONS(3773),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3773),
    [anon_sym_co_await] = ACTIONS(3771),
    [anon_sym_new] = ACTIONS(3771),
    [anon_sym_requires] = ACTIONS(3771),
    [sym_this] = ACTIONS(3771),
    [anon_sym_discard] = ACTIONS(3771),
    [anon_sym_precise] = ACTIONS(3771),
    [anon_sym_shared] = ACTIONS(3771),
    [anon_sym_groupshared] = ACTIONS(3771),
    [anon_sym_uniform] = ACTIONS(3771),
    [anon_sym_row_major] = ACTIONS(3771),
    [anon_sym_column_major] = ACTIONS(3771),
    [anon_sym_globallycoherent] = ACTIONS(3771),
    [anon_sym_centroid] = ACTIONS(3771),
    [anon_sym_noperspective] = ACTIONS(3771),
    [anon_sym_nointerpolation] = ACTIONS(3771),
    [anon_sym_sample] = ACTIONS(3771),
    [anon_sym_linear] = ACTIONS(3771),
    [anon_sym_snorm] = ACTIONS(3771),
    [anon_sym_unorm] = ACTIONS(3771),
    [anon_sym_point] = ACTIONS(3771),
    [anon_sym_line] = ACTIONS(3771),
    [anon_sym_triangleadj] = ACTIONS(3771),
    [anon_sym_lineadj] = ACTIONS(3771),
    [anon_sym_triangle] = ACTIONS(3771),
    [anon_sym_cbuffer] = ACTIONS(3771),
    [anon_sym_interface] = ACTIONS(3771),
    [anon_sym_extension] = ACTIONS(3771),
  },
  [887] = {
    [sym_identifier] = ACTIONS(3695),
    [aux_sym_preproc_include_token1] = ACTIONS(3695),
    [aux_sym_preproc_def_token1] = ACTIONS(3695),
    [aux_sym_preproc_if_token1] = ACTIONS(3695),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3695),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3695),
    [sym_preproc_directive] = ACTIONS(3695),
    [anon_sym_LPAREN2] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3695),
    [anon_sym_PLUS] = ACTIONS(3695),
    [anon_sym_STAR] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3695),
    [anon_sym_SEMI] = ACTIONS(3697),
    [anon_sym___extension__] = ACTIONS(3695),
    [anon_sym_typedef] = ACTIONS(3695),
    [anon_sym_in] = ACTIONS(3695),
    [anon_sym_out] = ACTIONS(3695),
    [anon_sym_inout] = ACTIONS(3695),
    [anon_sym_virtual] = ACTIONS(3695),
    [anon_sym_extern] = ACTIONS(3695),
    [anon_sym___attribute__] = ACTIONS(3695),
    [anon_sym___attribute] = ACTIONS(3695),
    [anon_sym_using] = ACTIONS(3695),
    [anon_sym_COLON_COLON] = ACTIONS(3697),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3697),
    [anon_sym___declspec] = ACTIONS(3695),
    [anon_sym___based] = ACTIONS(3695),
    [anon_sym___cdecl] = ACTIONS(3695),
    [anon_sym___clrcall] = ACTIONS(3695),
    [anon_sym___stdcall] = ACTIONS(3695),
    [anon_sym___fastcall] = ACTIONS(3695),
    [anon_sym___thiscall] = ACTIONS(3695),
    [anon_sym___vectorcall] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_RBRACE] = ACTIONS(3697),
    [anon_sym_signed] = ACTIONS(3695),
    [anon_sym_unsigned] = ACTIONS(3695),
    [anon_sym_long] = ACTIONS(3695),
    [anon_sym_short] = ACTIONS(3695),
    [anon_sym_LBRACK] = ACTIONS(3695),
    [anon_sym_static] = ACTIONS(3695),
    [anon_sym_register] = ACTIONS(3695),
    [anon_sym_inline] = ACTIONS(3695),
    [anon_sym___inline] = ACTIONS(3695),
    [anon_sym___inline__] = ACTIONS(3695),
    [anon_sym___forceinline] = ACTIONS(3695),
    [anon_sym_thread_local] = ACTIONS(3695),
    [anon_sym___thread] = ACTIONS(3695),
    [anon_sym_const] = ACTIONS(3695),
    [anon_sym_constexpr] = ACTIONS(3695),
    [anon_sym_volatile] = ACTIONS(3695),
    [anon_sym_restrict] = ACTIONS(3695),
    [anon_sym___restrict__] = ACTIONS(3695),
    [anon_sym__Atomic] = ACTIONS(3695),
    [anon_sym__Noreturn] = ACTIONS(3695),
    [anon_sym_noreturn] = ACTIONS(3695),
    [anon_sym__Nonnull] = ACTIONS(3695),
    [anon_sym_mutable] = ACTIONS(3695),
    [anon_sym_constinit] = ACTIONS(3695),
    [anon_sym_consteval] = ACTIONS(3695),
    [anon_sym_alignas] = ACTIONS(3695),
    [anon_sym__Alignas] = ACTIONS(3695),
    [sym_primitive_type] = ACTIONS(3695),
    [anon_sym_enum] = ACTIONS(3695),
    [anon_sym_class] = ACTIONS(3695),
    [anon_sym_struct] = ACTIONS(3695),
    [anon_sym_union] = ACTIONS(3695),
    [anon_sym_if] = ACTIONS(3695),
    [anon_sym_switch] = ACTIONS(3695),
    [anon_sym_case] = ACTIONS(3695),
    [anon_sym_default] = ACTIONS(3695),
    [anon_sym_while] = ACTIONS(3695),
    [anon_sym_do] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3695),
    [anon_sym_return] = ACTIONS(3695),
    [anon_sym_break] = ACTIONS(3695),
    [anon_sym_continue] = ACTIONS(3695),
    [anon_sym_goto] = ACTIONS(3695),
    [anon_sym___try] = ACTIONS(3695),
    [anon_sym___leave] = ACTIONS(3695),
    [anon_sym_not] = ACTIONS(3695),
    [anon_sym_compl] = ACTIONS(3695),
    [anon_sym_DASH_DASH] = ACTIONS(3697),
    [anon_sym_PLUS_PLUS] = ACTIONS(3697),
    [anon_sym_sizeof] = ACTIONS(3695),
    [anon_sym___alignof__] = ACTIONS(3695),
    [anon_sym___alignof] = ACTIONS(3695),
    [anon_sym__alignof] = ACTIONS(3695),
    [anon_sym_alignof] = ACTIONS(3695),
    [anon_sym__Alignof] = ACTIONS(3695),
    [anon_sym_offsetof] = ACTIONS(3695),
    [anon_sym__Generic] = ACTIONS(3695),
    [anon_sym_asm] = ACTIONS(3695),
    [anon_sym___asm__] = ACTIONS(3695),
    [anon_sym___asm] = ACTIONS(3695),
    [sym_number_literal] = ACTIONS(3697),
    [anon_sym_L_SQUOTE] = ACTIONS(3697),
    [anon_sym_u_SQUOTE] = ACTIONS(3697),
    [anon_sym_U_SQUOTE] = ACTIONS(3697),
    [anon_sym_u8_SQUOTE] = ACTIONS(3697),
    [anon_sym_SQUOTE] = ACTIONS(3697),
    [anon_sym_L_DQUOTE] = ACTIONS(3697),
    [anon_sym_u_DQUOTE] = ACTIONS(3697),
    [anon_sym_U_DQUOTE] = ACTIONS(3697),
    [anon_sym_u8_DQUOTE] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [sym_true] = ACTIONS(3695),
    [sym_false] = ACTIONS(3695),
    [anon_sym_NULL] = ACTIONS(3695),
    [anon_sym_nullptr] = ACTIONS(3695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3695),
    [anon_sym_let] = ACTIONS(3695),
    [anon_sym_This] = ACTIONS(3695),
    [anon_sym_decltype] = ACTIONS(3695),
    [anon_sym_explicit] = ACTIONS(3695),
    [anon_sym_typename] = ACTIONS(3695),
    [anon_sym_template] = ACTIONS(3695),
    [anon_sym_operator] = ACTIONS(3695),
    [anon_sym_try] = ACTIONS(3695),
    [anon_sym_delete] = ACTIONS(3695),
    [anon_sym_throw] = ACTIONS(3695),
    [anon_sym_namespace] = ACTIONS(3695),
    [anon_sym_static_assert] = ACTIONS(3695),
    [anon_sym_concept] = ACTIONS(3695),
    [anon_sym_co_return] = ACTIONS(3695),
    [anon_sym_co_yield] = ACTIONS(3695),
    [anon_sym_R_DQUOTE] = ACTIONS(3697),
    [anon_sym_LR_DQUOTE] = ACTIONS(3697),
    [anon_sym_uR_DQUOTE] = ACTIONS(3697),
    [anon_sym_UR_DQUOTE] = ACTIONS(3697),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3697),
    [anon_sym_co_await] = ACTIONS(3695),
    [anon_sym_new] = ACTIONS(3695),
    [anon_sym_requires] = ACTIONS(3695),
    [sym_this] = ACTIONS(3695),
    [anon_sym_discard] = ACTIONS(3695),
    [anon_sym_precise] = ACTIONS(3695),
    [anon_sym_shared] = ACTIONS(3695),
    [anon_sym_groupshared] = ACTIONS(3695),
    [anon_sym_uniform] = ACTIONS(3695),
    [anon_sym_row_major] = ACTIONS(3695),
    [anon_sym_column_major] = ACTIONS(3695),
    [anon_sym_globallycoherent] = ACTIONS(3695),
    [anon_sym_centroid] = ACTIONS(3695),
    [anon_sym_noperspective] = ACTIONS(3695),
    [anon_sym_nointerpolation] = ACTIONS(3695),
    [anon_sym_sample] = ACTIONS(3695),
    [anon_sym_linear] = ACTIONS(3695),
    [anon_sym_snorm] = ACTIONS(3695),
    [anon_sym_unorm] = ACTIONS(3695),
    [anon_sym_point] = ACTIONS(3695),
    [anon_sym_line] = ACTIONS(3695),
    [anon_sym_triangleadj] = ACTIONS(3695),
    [anon_sym_lineadj] = ACTIONS(3695),
    [anon_sym_triangle] = ACTIONS(3695),
    [anon_sym_cbuffer] = ACTIONS(3695),
    [anon_sym_interface] = ACTIONS(3695),
    [anon_sym_extension] = ACTIONS(3695),
  },
  [888] = {
    [ts_builtin_sym_end] = ACTIONS(3790),
    [sym_identifier] = ACTIONS(3788),
    [aux_sym_preproc_include_token1] = ACTIONS(3788),
    [aux_sym_preproc_def_token1] = ACTIONS(3788),
    [aux_sym_preproc_if_token1] = ACTIONS(3788),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3788),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3788),
    [sym_preproc_directive] = ACTIONS(3788),
    [anon_sym_LPAREN2] = ACTIONS(3790),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_DASH] = ACTIONS(3788),
    [anon_sym_PLUS] = ACTIONS(3788),
    [anon_sym_STAR] = ACTIONS(3790),
    [anon_sym_AMP_AMP] = ACTIONS(3790),
    [anon_sym_AMP] = ACTIONS(3788),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym___extension__] = ACTIONS(3788),
    [anon_sym_typedef] = ACTIONS(3788),
    [anon_sym_in] = ACTIONS(3788),
    [anon_sym_out] = ACTIONS(3788),
    [anon_sym_inout] = ACTIONS(3788),
    [anon_sym_virtual] = ACTIONS(3788),
    [anon_sym_extern] = ACTIONS(3788),
    [anon_sym___attribute__] = ACTIONS(3788),
    [anon_sym___attribute] = ACTIONS(3788),
    [anon_sym_using] = ACTIONS(3788),
    [anon_sym_COLON_COLON] = ACTIONS(3790),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3790),
    [anon_sym___declspec] = ACTIONS(3788),
    [anon_sym___based] = ACTIONS(3788),
    [anon_sym___cdecl] = ACTIONS(3788),
    [anon_sym___clrcall] = ACTIONS(3788),
    [anon_sym___stdcall] = ACTIONS(3788),
    [anon_sym___fastcall] = ACTIONS(3788),
    [anon_sym___thiscall] = ACTIONS(3788),
    [anon_sym___vectorcall] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_signed] = ACTIONS(3788),
    [anon_sym_unsigned] = ACTIONS(3788),
    [anon_sym_long] = ACTIONS(3788),
    [anon_sym_short] = ACTIONS(3788),
    [anon_sym_LBRACK] = ACTIONS(3788),
    [anon_sym_static] = ACTIONS(3788),
    [anon_sym_register] = ACTIONS(3788),
    [anon_sym_inline] = ACTIONS(3788),
    [anon_sym___inline] = ACTIONS(3788),
    [anon_sym___inline__] = ACTIONS(3788),
    [anon_sym___forceinline] = ACTIONS(3788),
    [anon_sym_thread_local] = ACTIONS(3788),
    [anon_sym___thread] = ACTIONS(3788),
    [anon_sym_const] = ACTIONS(3788),
    [anon_sym_constexpr] = ACTIONS(3788),
    [anon_sym_volatile] = ACTIONS(3788),
    [anon_sym_restrict] = ACTIONS(3788),
    [anon_sym___restrict__] = ACTIONS(3788),
    [anon_sym__Atomic] = ACTIONS(3788),
    [anon_sym__Noreturn] = ACTIONS(3788),
    [anon_sym_noreturn] = ACTIONS(3788),
    [anon_sym__Nonnull] = ACTIONS(3788),
    [anon_sym_mutable] = ACTIONS(3788),
    [anon_sym_constinit] = ACTIONS(3788),
    [anon_sym_consteval] = ACTIONS(3788),
    [anon_sym_alignas] = ACTIONS(3788),
    [anon_sym__Alignas] = ACTIONS(3788),
    [sym_primitive_type] = ACTIONS(3788),
    [anon_sym_enum] = ACTIONS(3788),
    [anon_sym_class] = ACTIONS(3788),
    [anon_sym_struct] = ACTIONS(3788),
    [anon_sym_union] = ACTIONS(3788),
    [anon_sym_if] = ACTIONS(3788),
    [anon_sym_switch] = ACTIONS(3788),
    [anon_sym_case] = ACTIONS(3788),
    [anon_sym_default] = ACTIONS(3788),
    [anon_sym_while] = ACTIONS(3788),
    [anon_sym_do] = ACTIONS(3788),
    [anon_sym_for] = ACTIONS(3788),
    [anon_sym_return] = ACTIONS(3788),
    [anon_sym_break] = ACTIONS(3788),
    [anon_sym_continue] = ACTIONS(3788),
    [anon_sym_goto] = ACTIONS(3788),
    [anon_sym_not] = ACTIONS(3788),
    [anon_sym_compl] = ACTIONS(3788),
    [anon_sym_DASH_DASH] = ACTIONS(3790),
    [anon_sym_PLUS_PLUS] = ACTIONS(3790),
    [anon_sym_sizeof] = ACTIONS(3788),
    [anon_sym___alignof__] = ACTIONS(3788),
    [anon_sym___alignof] = ACTIONS(3788),
    [anon_sym__alignof] = ACTIONS(3788),
    [anon_sym_alignof] = ACTIONS(3788),
    [anon_sym__Alignof] = ACTIONS(3788),
    [anon_sym_offsetof] = ACTIONS(3788),
    [anon_sym__Generic] = ACTIONS(3788),
    [anon_sym_asm] = ACTIONS(3788),
    [anon_sym___asm__] = ACTIONS(3788),
    [anon_sym___asm] = ACTIONS(3788),
    [sym_number_literal] = ACTIONS(3790),
    [anon_sym_L_SQUOTE] = ACTIONS(3790),
    [anon_sym_u_SQUOTE] = ACTIONS(3790),
    [anon_sym_U_SQUOTE] = ACTIONS(3790),
    [anon_sym_u8_SQUOTE] = ACTIONS(3790),
    [anon_sym_SQUOTE] = ACTIONS(3790),
    [anon_sym_L_DQUOTE] = ACTIONS(3790),
    [anon_sym_u_DQUOTE] = ACTIONS(3790),
    [anon_sym_U_DQUOTE] = ACTIONS(3790),
    [anon_sym_u8_DQUOTE] = ACTIONS(3790),
    [anon_sym_DQUOTE] = ACTIONS(3790),
    [sym_true] = ACTIONS(3788),
    [sym_false] = ACTIONS(3788),
    [anon_sym_NULL] = ACTIONS(3788),
    [anon_sym_nullptr] = ACTIONS(3788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3788),
    [anon_sym_let] = ACTIONS(3788),
    [anon_sym_This] = ACTIONS(3788),
    [anon_sym_decltype] = ACTIONS(3788),
    [anon_sym_explicit] = ACTIONS(3788),
    [anon_sym_typename] = ACTIONS(3788),
    [anon_sym_export] = ACTIONS(3788),
    [anon_sym_module] = ACTIONS(3788),
    [anon_sym_import] = ACTIONS(3788),
    [anon_sym_template] = ACTIONS(3788),
    [anon_sym_operator] = ACTIONS(3788),
    [anon_sym_try] = ACTIONS(3788),
    [anon_sym_delete] = ACTIONS(3788),
    [anon_sym_throw] = ACTIONS(3788),
    [anon_sym_namespace] = ACTIONS(3788),
    [anon_sym_static_assert] = ACTIONS(3788),
    [anon_sym_concept] = ACTIONS(3788),
    [anon_sym_co_return] = ACTIONS(3788),
    [anon_sym_co_yield] = ACTIONS(3788),
    [anon_sym_R_DQUOTE] = ACTIONS(3790),
    [anon_sym_LR_DQUOTE] = ACTIONS(3790),
    [anon_sym_uR_DQUOTE] = ACTIONS(3790),
    [anon_sym_UR_DQUOTE] = ACTIONS(3790),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3790),
    [anon_sym_co_await] = ACTIONS(3788),
    [anon_sym_new] = ACTIONS(3788),
    [anon_sym_requires] = ACTIONS(3788),
    [sym_this] = ACTIONS(3788),
    [anon_sym_precise] = ACTIONS(3788),
    [anon_sym_shared] = ACTIONS(3788),
    [anon_sym_groupshared] = ACTIONS(3788),
    [anon_sym_uniform] = ACTIONS(3788),
    [anon_sym_row_major] = ACTIONS(3788),
    [anon_sym_column_major] = ACTIONS(3788),
    [anon_sym_globallycoherent] = ACTIONS(3788),
    [anon_sym_centroid] = ACTIONS(3788),
    [anon_sym_noperspective] = ACTIONS(3788),
    [anon_sym_nointerpolation] = ACTIONS(3788),
    [anon_sym_sample] = ACTIONS(3788),
    [anon_sym_linear] = ACTIONS(3788),
    [anon_sym_snorm] = ACTIONS(3788),
    [anon_sym_unorm] = ACTIONS(3788),
    [anon_sym_point] = ACTIONS(3788),
    [anon_sym_line] = ACTIONS(3788),
    [anon_sym_triangleadj] = ACTIONS(3788),
    [anon_sym_lineadj] = ACTIONS(3788),
    [anon_sym_triangle] = ACTIONS(3788),
    [anon_sym_interface] = ACTIONS(3788),
    [anon_sym_extension] = ACTIONS(3788),
    [anon_sym___exported] = ACTIONS(3788),
  },
  [889] = {
    [sym_identifier] = ACTIONS(3967),
    [aux_sym_preproc_include_token1] = ACTIONS(3967),
    [aux_sym_preproc_def_token1] = ACTIONS(3967),
    [aux_sym_preproc_if_token1] = ACTIONS(3967),
    [aux_sym_preproc_if_token2] = ACTIONS(3967),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3967),
    [sym_preproc_directive] = ACTIONS(3967),
    [anon_sym_LPAREN2] = ACTIONS(3969),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_TILDE] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_STAR] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_AMP] = ACTIONS(3967),
    [anon_sym_SEMI] = ACTIONS(3969),
    [anon_sym___extension__] = ACTIONS(3967),
    [anon_sym_typedef] = ACTIONS(3967),
    [anon_sym_in] = ACTIONS(3967),
    [anon_sym_out] = ACTIONS(3967),
    [anon_sym_inout] = ACTIONS(3967),
    [anon_sym_virtual] = ACTIONS(3967),
    [anon_sym_extern] = ACTIONS(3967),
    [anon_sym___attribute__] = ACTIONS(3967),
    [anon_sym___attribute] = ACTIONS(3967),
    [anon_sym_using] = ACTIONS(3967),
    [anon_sym_COLON_COLON] = ACTIONS(3969),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3969),
    [anon_sym___declspec] = ACTIONS(3967),
    [anon_sym___based] = ACTIONS(3967),
    [anon_sym___cdecl] = ACTIONS(3967),
    [anon_sym___clrcall] = ACTIONS(3967),
    [anon_sym___stdcall] = ACTIONS(3967),
    [anon_sym___fastcall] = ACTIONS(3967),
    [anon_sym___thiscall] = ACTIONS(3967),
    [anon_sym___vectorcall] = ACTIONS(3967),
    [anon_sym_LBRACE] = ACTIONS(3969),
    [anon_sym_signed] = ACTIONS(3967),
    [anon_sym_unsigned] = ACTIONS(3967),
    [anon_sym_long] = ACTIONS(3967),
    [anon_sym_short] = ACTIONS(3967),
    [anon_sym_LBRACK] = ACTIONS(3967),
    [anon_sym_static] = ACTIONS(3967),
    [anon_sym_register] = ACTIONS(3967),
    [anon_sym_inline] = ACTIONS(3967),
    [anon_sym___inline] = ACTIONS(3967),
    [anon_sym___inline__] = ACTIONS(3967),
    [anon_sym___forceinline] = ACTIONS(3967),
    [anon_sym_thread_local] = ACTIONS(3967),
    [anon_sym___thread] = ACTIONS(3967),
    [anon_sym_const] = ACTIONS(3967),
    [anon_sym_constexpr] = ACTIONS(3967),
    [anon_sym_volatile] = ACTIONS(3967),
    [anon_sym_restrict] = ACTIONS(3967),
    [anon_sym___restrict__] = ACTIONS(3967),
    [anon_sym__Atomic] = ACTIONS(3967),
    [anon_sym__Noreturn] = ACTIONS(3967),
    [anon_sym_noreturn] = ACTIONS(3967),
    [anon_sym__Nonnull] = ACTIONS(3967),
    [anon_sym_mutable] = ACTIONS(3967),
    [anon_sym_constinit] = ACTIONS(3967),
    [anon_sym_consteval] = ACTIONS(3967),
    [anon_sym_alignas] = ACTIONS(3967),
    [anon_sym__Alignas] = ACTIONS(3967),
    [sym_primitive_type] = ACTIONS(3967),
    [anon_sym_enum] = ACTIONS(3967),
    [anon_sym_class] = ACTIONS(3967),
    [anon_sym_struct] = ACTIONS(3967),
    [anon_sym_union] = ACTIONS(3967),
    [anon_sym_if] = ACTIONS(3967),
    [anon_sym_switch] = ACTIONS(3967),
    [anon_sym_case] = ACTIONS(3967),
    [anon_sym_default] = ACTIONS(3967),
    [anon_sym_while] = ACTIONS(3967),
    [anon_sym_do] = ACTIONS(3967),
    [anon_sym_for] = ACTIONS(3967),
    [anon_sym_return] = ACTIONS(3967),
    [anon_sym_break] = ACTIONS(3967),
    [anon_sym_continue] = ACTIONS(3967),
    [anon_sym_goto] = ACTIONS(3967),
    [anon_sym___try] = ACTIONS(3967),
    [anon_sym___leave] = ACTIONS(3967),
    [anon_sym_not] = ACTIONS(3967),
    [anon_sym_compl] = ACTIONS(3967),
    [anon_sym_DASH_DASH] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3969),
    [anon_sym_sizeof] = ACTIONS(3967),
    [anon_sym___alignof__] = ACTIONS(3967),
    [anon_sym___alignof] = ACTIONS(3967),
    [anon_sym__alignof] = ACTIONS(3967),
    [anon_sym_alignof] = ACTIONS(3967),
    [anon_sym__Alignof] = ACTIONS(3967),
    [anon_sym_offsetof] = ACTIONS(3967),
    [anon_sym__Generic] = ACTIONS(3967),
    [anon_sym_asm] = ACTIONS(3967),
    [anon_sym___asm__] = ACTIONS(3967),
    [anon_sym___asm] = ACTIONS(3967),
    [sym_number_literal] = ACTIONS(3969),
    [anon_sym_L_SQUOTE] = ACTIONS(3969),
    [anon_sym_u_SQUOTE] = ACTIONS(3969),
    [anon_sym_U_SQUOTE] = ACTIONS(3969),
    [anon_sym_u8_SQUOTE] = ACTIONS(3969),
    [anon_sym_SQUOTE] = ACTIONS(3969),
    [anon_sym_L_DQUOTE] = ACTIONS(3969),
    [anon_sym_u_DQUOTE] = ACTIONS(3969),
    [anon_sym_U_DQUOTE] = ACTIONS(3969),
    [anon_sym_u8_DQUOTE] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(3969),
    [sym_true] = ACTIONS(3967),
    [sym_false] = ACTIONS(3967),
    [anon_sym_NULL] = ACTIONS(3967),
    [anon_sym_nullptr] = ACTIONS(3967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3967),
    [anon_sym_let] = ACTIONS(3967),
    [anon_sym_This] = ACTIONS(3967),
    [anon_sym_decltype] = ACTIONS(3967),
    [anon_sym_explicit] = ACTIONS(3967),
    [anon_sym_typename] = ACTIONS(3967),
    [anon_sym_template] = ACTIONS(3967),
    [anon_sym_operator] = ACTIONS(3967),
    [anon_sym_try] = ACTIONS(3967),
    [anon_sym_delete] = ACTIONS(3967),
    [anon_sym_throw] = ACTIONS(3967),
    [anon_sym_namespace] = ACTIONS(3967),
    [anon_sym_static_assert] = ACTIONS(3967),
    [anon_sym_concept] = ACTIONS(3967),
    [anon_sym_co_return] = ACTIONS(3967),
    [anon_sym_co_yield] = ACTIONS(3967),
    [anon_sym_R_DQUOTE] = ACTIONS(3969),
    [anon_sym_LR_DQUOTE] = ACTIONS(3969),
    [anon_sym_uR_DQUOTE] = ACTIONS(3969),
    [anon_sym_UR_DQUOTE] = ACTIONS(3969),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3969),
    [anon_sym_co_await] = ACTIONS(3967),
    [anon_sym_new] = ACTIONS(3967),
    [anon_sym_requires] = ACTIONS(3967),
    [sym_this] = ACTIONS(3967),
    [anon_sym_discard] = ACTIONS(3967),
    [anon_sym_precise] = ACTIONS(3967),
    [anon_sym_shared] = ACTIONS(3967),
    [anon_sym_groupshared] = ACTIONS(3967),
    [anon_sym_uniform] = ACTIONS(3967),
    [anon_sym_row_major] = ACTIONS(3967),
    [anon_sym_column_major] = ACTIONS(3967),
    [anon_sym_globallycoherent] = ACTIONS(3967),
    [anon_sym_centroid] = ACTIONS(3967),
    [anon_sym_noperspective] = ACTIONS(3967),
    [anon_sym_nointerpolation] = ACTIONS(3967),
    [anon_sym_sample] = ACTIONS(3967),
    [anon_sym_linear] = ACTIONS(3967),
    [anon_sym_snorm] = ACTIONS(3967),
    [anon_sym_unorm] = ACTIONS(3967),
    [anon_sym_point] = ACTIONS(3967),
    [anon_sym_line] = ACTIONS(3967),
    [anon_sym_triangleadj] = ACTIONS(3967),
    [anon_sym_lineadj] = ACTIONS(3967),
    [anon_sym_triangle] = ACTIONS(3967),
    [anon_sym_cbuffer] = ACTIONS(3967),
    [anon_sym_interface] = ACTIONS(3967),
    [anon_sym_extension] = ACTIONS(3967),
  },
  [890] = {
    [sym_identifier] = ACTIONS(3788),
    [aux_sym_preproc_include_token1] = ACTIONS(3788),
    [aux_sym_preproc_def_token1] = ACTIONS(3788),
    [aux_sym_preproc_if_token1] = ACTIONS(3788),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3788),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3788),
    [sym_preproc_directive] = ACTIONS(3788),
    [anon_sym_LPAREN2] = ACTIONS(3790),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_DASH] = ACTIONS(3788),
    [anon_sym_PLUS] = ACTIONS(3788),
    [anon_sym_STAR] = ACTIONS(3790),
    [anon_sym_AMP_AMP] = ACTIONS(3790),
    [anon_sym_AMP] = ACTIONS(3788),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym___extension__] = ACTIONS(3788),
    [anon_sym_typedef] = ACTIONS(3788),
    [anon_sym_in] = ACTIONS(3788),
    [anon_sym_out] = ACTIONS(3788),
    [anon_sym_inout] = ACTIONS(3788),
    [anon_sym_virtual] = ACTIONS(3788),
    [anon_sym_extern] = ACTIONS(3788),
    [anon_sym___attribute__] = ACTIONS(3788),
    [anon_sym___attribute] = ACTIONS(3788),
    [anon_sym_using] = ACTIONS(3788),
    [anon_sym_COLON_COLON] = ACTIONS(3790),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3790),
    [anon_sym___declspec] = ACTIONS(3788),
    [anon_sym___based] = ACTIONS(3788),
    [anon_sym___cdecl] = ACTIONS(3788),
    [anon_sym___clrcall] = ACTIONS(3788),
    [anon_sym___stdcall] = ACTIONS(3788),
    [anon_sym___fastcall] = ACTIONS(3788),
    [anon_sym___thiscall] = ACTIONS(3788),
    [anon_sym___vectorcall] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_RBRACE] = ACTIONS(3790),
    [anon_sym_signed] = ACTIONS(3788),
    [anon_sym_unsigned] = ACTIONS(3788),
    [anon_sym_long] = ACTIONS(3788),
    [anon_sym_short] = ACTIONS(3788),
    [anon_sym_LBRACK] = ACTIONS(3788),
    [anon_sym_static] = ACTIONS(3788),
    [anon_sym_register] = ACTIONS(3788),
    [anon_sym_inline] = ACTIONS(3788),
    [anon_sym___inline] = ACTIONS(3788),
    [anon_sym___inline__] = ACTIONS(3788),
    [anon_sym___forceinline] = ACTIONS(3788),
    [anon_sym_thread_local] = ACTIONS(3788),
    [anon_sym___thread] = ACTIONS(3788),
    [anon_sym_const] = ACTIONS(3788),
    [anon_sym_constexpr] = ACTIONS(3788),
    [anon_sym_volatile] = ACTIONS(3788),
    [anon_sym_restrict] = ACTIONS(3788),
    [anon_sym___restrict__] = ACTIONS(3788),
    [anon_sym__Atomic] = ACTIONS(3788),
    [anon_sym__Noreturn] = ACTIONS(3788),
    [anon_sym_noreturn] = ACTIONS(3788),
    [anon_sym__Nonnull] = ACTIONS(3788),
    [anon_sym_mutable] = ACTIONS(3788),
    [anon_sym_constinit] = ACTIONS(3788),
    [anon_sym_consteval] = ACTIONS(3788),
    [anon_sym_alignas] = ACTIONS(3788),
    [anon_sym__Alignas] = ACTIONS(3788),
    [sym_primitive_type] = ACTIONS(3788),
    [anon_sym_enum] = ACTIONS(3788),
    [anon_sym_class] = ACTIONS(3788),
    [anon_sym_struct] = ACTIONS(3788),
    [anon_sym_union] = ACTIONS(3788),
    [anon_sym_if] = ACTIONS(3788),
    [anon_sym_switch] = ACTIONS(3788),
    [anon_sym_case] = ACTIONS(3788),
    [anon_sym_default] = ACTIONS(3788),
    [anon_sym_while] = ACTIONS(3788),
    [anon_sym_do] = ACTIONS(3788),
    [anon_sym_for] = ACTIONS(3788),
    [anon_sym_return] = ACTIONS(3788),
    [anon_sym_break] = ACTIONS(3788),
    [anon_sym_continue] = ACTIONS(3788),
    [anon_sym_goto] = ACTIONS(3788),
    [anon_sym___try] = ACTIONS(3788),
    [anon_sym___leave] = ACTIONS(3788),
    [anon_sym_not] = ACTIONS(3788),
    [anon_sym_compl] = ACTIONS(3788),
    [anon_sym_DASH_DASH] = ACTIONS(3790),
    [anon_sym_PLUS_PLUS] = ACTIONS(3790),
    [anon_sym_sizeof] = ACTIONS(3788),
    [anon_sym___alignof__] = ACTIONS(3788),
    [anon_sym___alignof] = ACTIONS(3788),
    [anon_sym__alignof] = ACTIONS(3788),
    [anon_sym_alignof] = ACTIONS(3788),
    [anon_sym__Alignof] = ACTIONS(3788),
    [anon_sym_offsetof] = ACTIONS(3788),
    [anon_sym__Generic] = ACTIONS(3788),
    [anon_sym_asm] = ACTIONS(3788),
    [anon_sym___asm__] = ACTIONS(3788),
    [anon_sym___asm] = ACTIONS(3788),
    [sym_number_literal] = ACTIONS(3790),
    [anon_sym_L_SQUOTE] = ACTIONS(3790),
    [anon_sym_u_SQUOTE] = ACTIONS(3790),
    [anon_sym_U_SQUOTE] = ACTIONS(3790),
    [anon_sym_u8_SQUOTE] = ACTIONS(3790),
    [anon_sym_SQUOTE] = ACTIONS(3790),
    [anon_sym_L_DQUOTE] = ACTIONS(3790),
    [anon_sym_u_DQUOTE] = ACTIONS(3790),
    [anon_sym_U_DQUOTE] = ACTIONS(3790),
    [anon_sym_u8_DQUOTE] = ACTIONS(3790),
    [anon_sym_DQUOTE] = ACTIONS(3790),
    [sym_true] = ACTIONS(3788),
    [sym_false] = ACTIONS(3788),
    [anon_sym_NULL] = ACTIONS(3788),
    [anon_sym_nullptr] = ACTIONS(3788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3788),
    [anon_sym_let] = ACTIONS(3788),
    [anon_sym_This] = ACTIONS(3788),
    [anon_sym_decltype] = ACTIONS(3788),
    [anon_sym_explicit] = ACTIONS(3788),
    [anon_sym_typename] = ACTIONS(3788),
    [anon_sym_template] = ACTIONS(3788),
    [anon_sym_operator] = ACTIONS(3788),
    [anon_sym_try] = ACTIONS(3788),
    [anon_sym_delete] = ACTIONS(3788),
    [anon_sym_throw] = ACTIONS(3788),
    [anon_sym_namespace] = ACTIONS(3788),
    [anon_sym_static_assert] = ACTIONS(3788),
    [anon_sym_concept] = ACTIONS(3788),
    [anon_sym_co_return] = ACTIONS(3788),
    [anon_sym_co_yield] = ACTIONS(3788),
    [anon_sym_R_DQUOTE] = ACTIONS(3790),
    [anon_sym_LR_DQUOTE] = ACTIONS(3790),
    [anon_sym_uR_DQUOTE] = ACTIONS(3790),
    [anon_sym_UR_DQUOTE] = ACTIONS(3790),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3790),
    [anon_sym_co_await] = ACTIONS(3788),
    [anon_sym_new] = ACTIONS(3788),
    [anon_sym_requires] = ACTIONS(3788),
    [sym_this] = ACTIONS(3788),
    [anon_sym_discard] = ACTIONS(3788),
    [anon_sym_precise] = ACTIONS(3788),
    [anon_sym_shared] = ACTIONS(3788),
    [anon_sym_groupshared] = ACTIONS(3788),
    [anon_sym_uniform] = ACTIONS(3788),
    [anon_sym_row_major] = ACTIONS(3788),
    [anon_sym_column_major] = ACTIONS(3788),
    [anon_sym_globallycoherent] = ACTIONS(3788),
    [anon_sym_centroid] = ACTIONS(3788),
    [anon_sym_noperspective] = ACTIONS(3788),
    [anon_sym_nointerpolation] = ACTIONS(3788),
    [anon_sym_sample] = ACTIONS(3788),
    [anon_sym_linear] = ACTIONS(3788),
    [anon_sym_snorm] = ACTIONS(3788),
    [anon_sym_unorm] = ACTIONS(3788),
    [anon_sym_point] = ACTIONS(3788),
    [anon_sym_line] = ACTIONS(3788),
    [anon_sym_triangleadj] = ACTIONS(3788),
    [anon_sym_lineadj] = ACTIONS(3788),
    [anon_sym_triangle] = ACTIONS(3788),
    [anon_sym_cbuffer] = ACTIONS(3788),
    [anon_sym_interface] = ACTIONS(3788),
    [anon_sym_extension] = ACTIONS(3788),
  },
  [891] = {
    [sym_identifier] = ACTIONS(3792),
    [aux_sym_preproc_include_token1] = ACTIONS(3792),
    [aux_sym_preproc_def_token1] = ACTIONS(3792),
    [aux_sym_preproc_if_token1] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3792),
    [sym_preproc_directive] = ACTIONS(3792),
    [anon_sym_LPAREN2] = ACTIONS(3794),
    [anon_sym_BANG] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3794),
    [anon_sym_DASH] = ACTIONS(3792),
    [anon_sym_PLUS] = ACTIONS(3792),
    [anon_sym_STAR] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_AMP] = ACTIONS(3792),
    [anon_sym_SEMI] = ACTIONS(3794),
    [anon_sym___extension__] = ACTIONS(3792),
    [anon_sym_typedef] = ACTIONS(3792),
    [anon_sym_in] = ACTIONS(3792),
    [anon_sym_out] = ACTIONS(3792),
    [anon_sym_inout] = ACTIONS(3792),
    [anon_sym_virtual] = ACTIONS(3792),
    [anon_sym_extern] = ACTIONS(3792),
    [anon_sym___attribute__] = ACTIONS(3792),
    [anon_sym___attribute] = ACTIONS(3792),
    [anon_sym_using] = ACTIONS(3792),
    [anon_sym_COLON_COLON] = ACTIONS(3794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3794),
    [anon_sym___declspec] = ACTIONS(3792),
    [anon_sym___based] = ACTIONS(3792),
    [anon_sym___cdecl] = ACTIONS(3792),
    [anon_sym___clrcall] = ACTIONS(3792),
    [anon_sym___stdcall] = ACTIONS(3792),
    [anon_sym___fastcall] = ACTIONS(3792),
    [anon_sym___thiscall] = ACTIONS(3792),
    [anon_sym___vectorcall] = ACTIONS(3792),
    [anon_sym_LBRACE] = ACTIONS(3794),
    [anon_sym_RBRACE] = ACTIONS(3794),
    [anon_sym_signed] = ACTIONS(3792),
    [anon_sym_unsigned] = ACTIONS(3792),
    [anon_sym_long] = ACTIONS(3792),
    [anon_sym_short] = ACTIONS(3792),
    [anon_sym_LBRACK] = ACTIONS(3792),
    [anon_sym_static] = ACTIONS(3792),
    [anon_sym_register] = ACTIONS(3792),
    [anon_sym_inline] = ACTIONS(3792),
    [anon_sym___inline] = ACTIONS(3792),
    [anon_sym___inline__] = ACTIONS(3792),
    [anon_sym___forceinline] = ACTIONS(3792),
    [anon_sym_thread_local] = ACTIONS(3792),
    [anon_sym___thread] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3792),
    [anon_sym_constexpr] = ACTIONS(3792),
    [anon_sym_volatile] = ACTIONS(3792),
    [anon_sym_restrict] = ACTIONS(3792),
    [anon_sym___restrict__] = ACTIONS(3792),
    [anon_sym__Atomic] = ACTIONS(3792),
    [anon_sym__Noreturn] = ACTIONS(3792),
    [anon_sym_noreturn] = ACTIONS(3792),
    [anon_sym__Nonnull] = ACTIONS(3792),
    [anon_sym_mutable] = ACTIONS(3792),
    [anon_sym_constinit] = ACTIONS(3792),
    [anon_sym_consteval] = ACTIONS(3792),
    [anon_sym_alignas] = ACTIONS(3792),
    [anon_sym__Alignas] = ACTIONS(3792),
    [sym_primitive_type] = ACTIONS(3792),
    [anon_sym_enum] = ACTIONS(3792),
    [anon_sym_class] = ACTIONS(3792),
    [anon_sym_struct] = ACTIONS(3792),
    [anon_sym_union] = ACTIONS(3792),
    [anon_sym_if] = ACTIONS(3792),
    [anon_sym_switch] = ACTIONS(3792),
    [anon_sym_case] = ACTIONS(3792),
    [anon_sym_default] = ACTIONS(3792),
    [anon_sym_while] = ACTIONS(3792),
    [anon_sym_do] = ACTIONS(3792),
    [anon_sym_for] = ACTIONS(3792),
    [anon_sym_return] = ACTIONS(3792),
    [anon_sym_break] = ACTIONS(3792),
    [anon_sym_continue] = ACTIONS(3792),
    [anon_sym_goto] = ACTIONS(3792),
    [anon_sym___try] = ACTIONS(3792),
    [anon_sym___leave] = ACTIONS(3792),
    [anon_sym_not] = ACTIONS(3792),
    [anon_sym_compl] = ACTIONS(3792),
    [anon_sym_DASH_DASH] = ACTIONS(3794),
    [anon_sym_PLUS_PLUS] = ACTIONS(3794),
    [anon_sym_sizeof] = ACTIONS(3792),
    [anon_sym___alignof__] = ACTIONS(3792),
    [anon_sym___alignof] = ACTIONS(3792),
    [anon_sym__alignof] = ACTIONS(3792),
    [anon_sym_alignof] = ACTIONS(3792),
    [anon_sym__Alignof] = ACTIONS(3792),
    [anon_sym_offsetof] = ACTIONS(3792),
    [anon_sym__Generic] = ACTIONS(3792),
    [anon_sym_asm] = ACTIONS(3792),
    [anon_sym___asm__] = ACTIONS(3792),
    [anon_sym___asm] = ACTIONS(3792),
    [sym_number_literal] = ACTIONS(3794),
    [anon_sym_L_SQUOTE] = ACTIONS(3794),
    [anon_sym_u_SQUOTE] = ACTIONS(3794),
    [anon_sym_U_SQUOTE] = ACTIONS(3794),
    [anon_sym_u8_SQUOTE] = ACTIONS(3794),
    [anon_sym_SQUOTE] = ACTIONS(3794),
    [anon_sym_L_DQUOTE] = ACTIONS(3794),
    [anon_sym_u_DQUOTE] = ACTIONS(3794),
    [anon_sym_U_DQUOTE] = ACTIONS(3794),
    [anon_sym_u8_DQUOTE] = ACTIONS(3794),
    [anon_sym_DQUOTE] = ACTIONS(3794),
    [sym_true] = ACTIONS(3792),
    [sym_false] = ACTIONS(3792),
    [anon_sym_NULL] = ACTIONS(3792),
    [anon_sym_nullptr] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3792),
    [anon_sym_let] = ACTIONS(3792),
    [anon_sym_This] = ACTIONS(3792),
    [anon_sym_decltype] = ACTIONS(3792),
    [anon_sym_explicit] = ACTIONS(3792),
    [anon_sym_typename] = ACTIONS(3792),
    [anon_sym_template] = ACTIONS(3792),
    [anon_sym_operator] = ACTIONS(3792),
    [anon_sym_try] = ACTIONS(3792),
    [anon_sym_delete] = ACTIONS(3792),
    [anon_sym_throw] = ACTIONS(3792),
    [anon_sym_namespace] = ACTIONS(3792),
    [anon_sym_static_assert] = ACTIONS(3792),
    [anon_sym_concept] = ACTIONS(3792),
    [anon_sym_co_return] = ACTIONS(3792),
    [anon_sym_co_yield] = ACTIONS(3792),
    [anon_sym_R_DQUOTE] = ACTIONS(3794),
    [anon_sym_LR_DQUOTE] = ACTIONS(3794),
    [anon_sym_uR_DQUOTE] = ACTIONS(3794),
    [anon_sym_UR_DQUOTE] = ACTIONS(3794),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3794),
    [anon_sym_co_await] = ACTIONS(3792),
    [anon_sym_new] = ACTIONS(3792),
    [anon_sym_requires] = ACTIONS(3792),
    [sym_this] = ACTIONS(3792),
    [anon_sym_discard] = ACTIONS(3792),
    [anon_sym_precise] = ACTIONS(3792),
    [anon_sym_shared] = ACTIONS(3792),
    [anon_sym_groupshared] = ACTIONS(3792),
    [anon_sym_uniform] = ACTIONS(3792),
    [anon_sym_row_major] = ACTIONS(3792),
    [anon_sym_column_major] = ACTIONS(3792),
    [anon_sym_globallycoherent] = ACTIONS(3792),
    [anon_sym_centroid] = ACTIONS(3792),
    [anon_sym_noperspective] = ACTIONS(3792),
    [anon_sym_nointerpolation] = ACTIONS(3792),
    [anon_sym_sample] = ACTIONS(3792),
    [anon_sym_linear] = ACTIONS(3792),
    [anon_sym_snorm] = ACTIONS(3792),
    [anon_sym_unorm] = ACTIONS(3792),
    [anon_sym_point] = ACTIONS(3792),
    [anon_sym_line] = ACTIONS(3792),
    [anon_sym_triangleadj] = ACTIONS(3792),
    [anon_sym_lineadj] = ACTIONS(3792),
    [anon_sym_triangle] = ACTIONS(3792),
    [anon_sym_cbuffer] = ACTIONS(3792),
    [anon_sym_interface] = ACTIONS(3792),
    [anon_sym_extension] = ACTIONS(3792),
  },
  [892] = {
    [sym_identifier] = ACTIONS(3792),
    [aux_sym_preproc_include_token1] = ACTIONS(3792),
    [aux_sym_preproc_def_token1] = ACTIONS(3792),
    [aux_sym_preproc_if_token1] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3792),
    [sym_preproc_directive] = ACTIONS(3792),
    [anon_sym_LPAREN2] = ACTIONS(3794),
    [anon_sym_BANG] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3794),
    [anon_sym_DASH] = ACTIONS(3792),
    [anon_sym_PLUS] = ACTIONS(3792),
    [anon_sym_STAR] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_AMP] = ACTIONS(3792),
    [anon_sym_SEMI] = ACTIONS(3794),
    [anon_sym___extension__] = ACTIONS(3792),
    [anon_sym_typedef] = ACTIONS(3792),
    [anon_sym_in] = ACTIONS(3792),
    [anon_sym_out] = ACTIONS(3792),
    [anon_sym_inout] = ACTIONS(3792),
    [anon_sym_virtual] = ACTIONS(3792),
    [anon_sym_extern] = ACTIONS(3792),
    [anon_sym___attribute__] = ACTIONS(3792),
    [anon_sym___attribute] = ACTIONS(3792),
    [anon_sym_using] = ACTIONS(3792),
    [anon_sym_COLON_COLON] = ACTIONS(3794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3794),
    [anon_sym___declspec] = ACTIONS(3792),
    [anon_sym___based] = ACTIONS(3792),
    [anon_sym___cdecl] = ACTIONS(3792),
    [anon_sym___clrcall] = ACTIONS(3792),
    [anon_sym___stdcall] = ACTIONS(3792),
    [anon_sym___fastcall] = ACTIONS(3792),
    [anon_sym___thiscall] = ACTIONS(3792),
    [anon_sym___vectorcall] = ACTIONS(3792),
    [anon_sym_LBRACE] = ACTIONS(3794),
    [anon_sym_RBRACE] = ACTIONS(3794),
    [anon_sym_signed] = ACTIONS(3792),
    [anon_sym_unsigned] = ACTIONS(3792),
    [anon_sym_long] = ACTIONS(3792),
    [anon_sym_short] = ACTIONS(3792),
    [anon_sym_LBRACK] = ACTIONS(3792),
    [anon_sym_static] = ACTIONS(3792),
    [anon_sym_register] = ACTIONS(3792),
    [anon_sym_inline] = ACTIONS(3792),
    [anon_sym___inline] = ACTIONS(3792),
    [anon_sym___inline__] = ACTIONS(3792),
    [anon_sym___forceinline] = ACTIONS(3792),
    [anon_sym_thread_local] = ACTIONS(3792),
    [anon_sym___thread] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3792),
    [anon_sym_constexpr] = ACTIONS(3792),
    [anon_sym_volatile] = ACTIONS(3792),
    [anon_sym_restrict] = ACTIONS(3792),
    [anon_sym___restrict__] = ACTIONS(3792),
    [anon_sym__Atomic] = ACTIONS(3792),
    [anon_sym__Noreturn] = ACTIONS(3792),
    [anon_sym_noreturn] = ACTIONS(3792),
    [anon_sym__Nonnull] = ACTIONS(3792),
    [anon_sym_mutable] = ACTIONS(3792),
    [anon_sym_constinit] = ACTIONS(3792),
    [anon_sym_consteval] = ACTIONS(3792),
    [anon_sym_alignas] = ACTIONS(3792),
    [anon_sym__Alignas] = ACTIONS(3792),
    [sym_primitive_type] = ACTIONS(3792),
    [anon_sym_enum] = ACTIONS(3792),
    [anon_sym_class] = ACTIONS(3792),
    [anon_sym_struct] = ACTIONS(3792),
    [anon_sym_union] = ACTIONS(3792),
    [anon_sym_if] = ACTIONS(3792),
    [anon_sym_switch] = ACTIONS(3792),
    [anon_sym_case] = ACTIONS(3792),
    [anon_sym_default] = ACTIONS(3792),
    [anon_sym_while] = ACTIONS(3792),
    [anon_sym_do] = ACTIONS(3792),
    [anon_sym_for] = ACTIONS(3792),
    [anon_sym_return] = ACTIONS(3792),
    [anon_sym_break] = ACTIONS(3792),
    [anon_sym_continue] = ACTIONS(3792),
    [anon_sym_goto] = ACTIONS(3792),
    [anon_sym___try] = ACTIONS(3792),
    [anon_sym___leave] = ACTIONS(3792),
    [anon_sym_not] = ACTIONS(3792),
    [anon_sym_compl] = ACTIONS(3792),
    [anon_sym_DASH_DASH] = ACTIONS(3794),
    [anon_sym_PLUS_PLUS] = ACTIONS(3794),
    [anon_sym_sizeof] = ACTIONS(3792),
    [anon_sym___alignof__] = ACTIONS(3792),
    [anon_sym___alignof] = ACTIONS(3792),
    [anon_sym__alignof] = ACTIONS(3792),
    [anon_sym_alignof] = ACTIONS(3792),
    [anon_sym__Alignof] = ACTIONS(3792),
    [anon_sym_offsetof] = ACTIONS(3792),
    [anon_sym__Generic] = ACTIONS(3792),
    [anon_sym_asm] = ACTIONS(3792),
    [anon_sym___asm__] = ACTIONS(3792),
    [anon_sym___asm] = ACTIONS(3792),
    [sym_number_literal] = ACTIONS(3794),
    [anon_sym_L_SQUOTE] = ACTIONS(3794),
    [anon_sym_u_SQUOTE] = ACTIONS(3794),
    [anon_sym_U_SQUOTE] = ACTIONS(3794),
    [anon_sym_u8_SQUOTE] = ACTIONS(3794),
    [anon_sym_SQUOTE] = ACTIONS(3794),
    [anon_sym_L_DQUOTE] = ACTIONS(3794),
    [anon_sym_u_DQUOTE] = ACTIONS(3794),
    [anon_sym_U_DQUOTE] = ACTIONS(3794),
    [anon_sym_u8_DQUOTE] = ACTIONS(3794),
    [anon_sym_DQUOTE] = ACTIONS(3794),
    [sym_true] = ACTIONS(3792),
    [sym_false] = ACTIONS(3792),
    [anon_sym_NULL] = ACTIONS(3792),
    [anon_sym_nullptr] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3792),
    [anon_sym_let] = ACTIONS(3792),
    [anon_sym_This] = ACTIONS(3792),
    [anon_sym_decltype] = ACTIONS(3792),
    [anon_sym_explicit] = ACTIONS(3792),
    [anon_sym_typename] = ACTIONS(3792),
    [anon_sym_template] = ACTIONS(3792),
    [anon_sym_operator] = ACTIONS(3792),
    [anon_sym_try] = ACTIONS(3792),
    [anon_sym_delete] = ACTIONS(3792),
    [anon_sym_throw] = ACTIONS(3792),
    [anon_sym_namespace] = ACTIONS(3792),
    [anon_sym_static_assert] = ACTIONS(3792),
    [anon_sym_concept] = ACTIONS(3792),
    [anon_sym_co_return] = ACTIONS(3792),
    [anon_sym_co_yield] = ACTIONS(3792),
    [anon_sym_R_DQUOTE] = ACTIONS(3794),
    [anon_sym_LR_DQUOTE] = ACTIONS(3794),
    [anon_sym_uR_DQUOTE] = ACTIONS(3794),
    [anon_sym_UR_DQUOTE] = ACTIONS(3794),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3794),
    [anon_sym_co_await] = ACTIONS(3792),
    [anon_sym_new] = ACTIONS(3792),
    [anon_sym_requires] = ACTIONS(3792),
    [sym_this] = ACTIONS(3792),
    [anon_sym_discard] = ACTIONS(3792),
    [anon_sym_precise] = ACTIONS(3792),
    [anon_sym_shared] = ACTIONS(3792),
    [anon_sym_groupshared] = ACTIONS(3792),
    [anon_sym_uniform] = ACTIONS(3792),
    [anon_sym_row_major] = ACTIONS(3792),
    [anon_sym_column_major] = ACTIONS(3792),
    [anon_sym_globallycoherent] = ACTIONS(3792),
    [anon_sym_centroid] = ACTIONS(3792),
    [anon_sym_noperspective] = ACTIONS(3792),
    [anon_sym_nointerpolation] = ACTIONS(3792),
    [anon_sym_sample] = ACTIONS(3792),
    [anon_sym_linear] = ACTIONS(3792),
    [anon_sym_snorm] = ACTIONS(3792),
    [anon_sym_unorm] = ACTIONS(3792),
    [anon_sym_point] = ACTIONS(3792),
    [anon_sym_line] = ACTIONS(3792),
    [anon_sym_triangleadj] = ACTIONS(3792),
    [anon_sym_lineadj] = ACTIONS(3792),
    [anon_sym_triangle] = ACTIONS(3792),
    [anon_sym_cbuffer] = ACTIONS(3792),
    [anon_sym_interface] = ACTIONS(3792),
    [anon_sym_extension] = ACTIONS(3792),
  },
  [893] = {
    [sym_expression] = STATE(5382),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(3357),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3370),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3373),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3376),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [894] = {
    [sym_identifier] = ACTIONS(3699),
    [aux_sym_preproc_include_token1] = ACTIONS(3699),
    [aux_sym_preproc_def_token1] = ACTIONS(3699),
    [aux_sym_preproc_if_token1] = ACTIONS(3699),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3699),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3699),
    [sym_preproc_directive] = ACTIONS(3699),
    [anon_sym_LPAREN2] = ACTIONS(3701),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_STAR] = ACTIONS(3701),
    [anon_sym_AMP_AMP] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(3701),
    [anon_sym___extension__] = ACTIONS(3699),
    [anon_sym_typedef] = ACTIONS(3699),
    [anon_sym_in] = ACTIONS(3699),
    [anon_sym_out] = ACTIONS(3699),
    [anon_sym_inout] = ACTIONS(3699),
    [anon_sym_virtual] = ACTIONS(3699),
    [anon_sym_extern] = ACTIONS(3699),
    [anon_sym___attribute__] = ACTIONS(3699),
    [anon_sym___attribute] = ACTIONS(3699),
    [anon_sym_using] = ACTIONS(3699),
    [anon_sym_COLON_COLON] = ACTIONS(3701),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3701),
    [anon_sym___declspec] = ACTIONS(3699),
    [anon_sym___based] = ACTIONS(3699),
    [anon_sym___cdecl] = ACTIONS(3699),
    [anon_sym___clrcall] = ACTIONS(3699),
    [anon_sym___stdcall] = ACTIONS(3699),
    [anon_sym___fastcall] = ACTIONS(3699),
    [anon_sym___thiscall] = ACTIONS(3699),
    [anon_sym___vectorcall] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3701),
    [anon_sym_RBRACE] = ACTIONS(3701),
    [anon_sym_signed] = ACTIONS(3699),
    [anon_sym_unsigned] = ACTIONS(3699),
    [anon_sym_long] = ACTIONS(3699),
    [anon_sym_short] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(3699),
    [anon_sym_static] = ACTIONS(3699),
    [anon_sym_register] = ACTIONS(3699),
    [anon_sym_inline] = ACTIONS(3699),
    [anon_sym___inline] = ACTIONS(3699),
    [anon_sym___inline__] = ACTIONS(3699),
    [anon_sym___forceinline] = ACTIONS(3699),
    [anon_sym_thread_local] = ACTIONS(3699),
    [anon_sym___thread] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3699),
    [anon_sym_constexpr] = ACTIONS(3699),
    [anon_sym_volatile] = ACTIONS(3699),
    [anon_sym_restrict] = ACTIONS(3699),
    [anon_sym___restrict__] = ACTIONS(3699),
    [anon_sym__Atomic] = ACTIONS(3699),
    [anon_sym__Noreturn] = ACTIONS(3699),
    [anon_sym_noreturn] = ACTIONS(3699),
    [anon_sym__Nonnull] = ACTIONS(3699),
    [anon_sym_mutable] = ACTIONS(3699),
    [anon_sym_constinit] = ACTIONS(3699),
    [anon_sym_consteval] = ACTIONS(3699),
    [anon_sym_alignas] = ACTIONS(3699),
    [anon_sym__Alignas] = ACTIONS(3699),
    [sym_primitive_type] = ACTIONS(3699),
    [anon_sym_enum] = ACTIONS(3699),
    [anon_sym_class] = ACTIONS(3699),
    [anon_sym_struct] = ACTIONS(3699),
    [anon_sym_union] = ACTIONS(3699),
    [anon_sym_if] = ACTIONS(3699),
    [anon_sym_switch] = ACTIONS(3699),
    [anon_sym_case] = ACTIONS(3699),
    [anon_sym_default] = ACTIONS(3699),
    [anon_sym_while] = ACTIONS(3699),
    [anon_sym_do] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3699),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_break] = ACTIONS(3699),
    [anon_sym_continue] = ACTIONS(3699),
    [anon_sym_goto] = ACTIONS(3699),
    [anon_sym___try] = ACTIONS(3699),
    [anon_sym___leave] = ACTIONS(3699),
    [anon_sym_not] = ACTIONS(3699),
    [anon_sym_compl] = ACTIONS(3699),
    [anon_sym_DASH_DASH] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3701),
    [anon_sym_sizeof] = ACTIONS(3699),
    [anon_sym___alignof__] = ACTIONS(3699),
    [anon_sym___alignof] = ACTIONS(3699),
    [anon_sym__alignof] = ACTIONS(3699),
    [anon_sym_alignof] = ACTIONS(3699),
    [anon_sym__Alignof] = ACTIONS(3699),
    [anon_sym_offsetof] = ACTIONS(3699),
    [anon_sym__Generic] = ACTIONS(3699),
    [anon_sym_asm] = ACTIONS(3699),
    [anon_sym___asm__] = ACTIONS(3699),
    [anon_sym___asm] = ACTIONS(3699),
    [sym_number_literal] = ACTIONS(3701),
    [anon_sym_L_SQUOTE] = ACTIONS(3701),
    [anon_sym_u_SQUOTE] = ACTIONS(3701),
    [anon_sym_U_SQUOTE] = ACTIONS(3701),
    [anon_sym_u8_SQUOTE] = ACTIONS(3701),
    [anon_sym_SQUOTE] = ACTIONS(3701),
    [anon_sym_L_DQUOTE] = ACTIONS(3701),
    [anon_sym_u_DQUOTE] = ACTIONS(3701),
    [anon_sym_U_DQUOTE] = ACTIONS(3701),
    [anon_sym_u8_DQUOTE] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [sym_true] = ACTIONS(3699),
    [sym_false] = ACTIONS(3699),
    [anon_sym_NULL] = ACTIONS(3699),
    [anon_sym_nullptr] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3699),
    [anon_sym_let] = ACTIONS(3699),
    [anon_sym_This] = ACTIONS(3699),
    [anon_sym_decltype] = ACTIONS(3699),
    [anon_sym_explicit] = ACTIONS(3699),
    [anon_sym_typename] = ACTIONS(3699),
    [anon_sym_template] = ACTIONS(3699),
    [anon_sym_operator] = ACTIONS(3699),
    [anon_sym_try] = ACTIONS(3699),
    [anon_sym_delete] = ACTIONS(3699),
    [anon_sym_throw] = ACTIONS(3699),
    [anon_sym_namespace] = ACTIONS(3699),
    [anon_sym_static_assert] = ACTIONS(3699),
    [anon_sym_concept] = ACTIONS(3699),
    [anon_sym_co_return] = ACTIONS(3699),
    [anon_sym_co_yield] = ACTIONS(3699),
    [anon_sym_R_DQUOTE] = ACTIONS(3701),
    [anon_sym_LR_DQUOTE] = ACTIONS(3701),
    [anon_sym_uR_DQUOTE] = ACTIONS(3701),
    [anon_sym_UR_DQUOTE] = ACTIONS(3701),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3701),
    [anon_sym_co_await] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3699),
    [anon_sym_requires] = ACTIONS(3699),
    [sym_this] = ACTIONS(3699),
    [anon_sym_discard] = ACTIONS(3699),
    [anon_sym_precise] = ACTIONS(3699),
    [anon_sym_shared] = ACTIONS(3699),
    [anon_sym_groupshared] = ACTIONS(3699),
    [anon_sym_uniform] = ACTIONS(3699),
    [anon_sym_row_major] = ACTIONS(3699),
    [anon_sym_column_major] = ACTIONS(3699),
    [anon_sym_globallycoherent] = ACTIONS(3699),
    [anon_sym_centroid] = ACTIONS(3699),
    [anon_sym_noperspective] = ACTIONS(3699),
    [anon_sym_nointerpolation] = ACTIONS(3699),
    [anon_sym_sample] = ACTIONS(3699),
    [anon_sym_linear] = ACTIONS(3699),
    [anon_sym_snorm] = ACTIONS(3699),
    [anon_sym_unorm] = ACTIONS(3699),
    [anon_sym_point] = ACTIONS(3699),
    [anon_sym_line] = ACTIONS(3699),
    [anon_sym_triangleadj] = ACTIONS(3699),
    [anon_sym_lineadj] = ACTIONS(3699),
    [anon_sym_triangle] = ACTIONS(3699),
    [anon_sym_cbuffer] = ACTIONS(3699),
    [anon_sym_interface] = ACTIONS(3699),
    [anon_sym_extension] = ACTIONS(3699),
  },
  [895] = {
    [sym_identifier] = ACTIONS(3661),
    [aux_sym_preproc_include_token1] = ACTIONS(3661),
    [aux_sym_preproc_def_token1] = ACTIONS(3661),
    [aux_sym_preproc_if_token1] = ACTIONS(3661),
    [aux_sym_preproc_if_token2] = ACTIONS(3661),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3661),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3661),
    [sym_preproc_directive] = ACTIONS(3661),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_BANG] = ACTIONS(3663),
    [anon_sym_TILDE] = ACTIONS(3663),
    [anon_sym_DASH] = ACTIONS(3661),
    [anon_sym_PLUS] = ACTIONS(3661),
    [anon_sym_STAR] = ACTIONS(3663),
    [anon_sym_AMP_AMP] = ACTIONS(3663),
    [anon_sym_AMP] = ACTIONS(3661),
    [anon_sym_SEMI] = ACTIONS(3663),
    [anon_sym___extension__] = ACTIONS(3661),
    [anon_sym_typedef] = ACTIONS(3661),
    [anon_sym_in] = ACTIONS(3661),
    [anon_sym_out] = ACTIONS(3661),
    [anon_sym_inout] = ACTIONS(3661),
    [anon_sym_virtual] = ACTIONS(3661),
    [anon_sym_extern] = ACTIONS(3661),
    [anon_sym___attribute__] = ACTIONS(3661),
    [anon_sym___attribute] = ACTIONS(3661),
    [anon_sym_using] = ACTIONS(3661),
    [anon_sym_COLON_COLON] = ACTIONS(3663),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3663),
    [anon_sym___declspec] = ACTIONS(3661),
    [anon_sym___based] = ACTIONS(3661),
    [anon_sym___cdecl] = ACTIONS(3661),
    [anon_sym___clrcall] = ACTIONS(3661),
    [anon_sym___stdcall] = ACTIONS(3661),
    [anon_sym___fastcall] = ACTIONS(3661),
    [anon_sym___thiscall] = ACTIONS(3661),
    [anon_sym___vectorcall] = ACTIONS(3661),
    [anon_sym_LBRACE] = ACTIONS(3663),
    [anon_sym_signed] = ACTIONS(3661),
    [anon_sym_unsigned] = ACTIONS(3661),
    [anon_sym_long] = ACTIONS(3661),
    [anon_sym_short] = ACTIONS(3661),
    [anon_sym_LBRACK] = ACTIONS(3661),
    [anon_sym_static] = ACTIONS(3661),
    [anon_sym_register] = ACTIONS(3661),
    [anon_sym_inline] = ACTIONS(3661),
    [anon_sym___inline] = ACTIONS(3661),
    [anon_sym___inline__] = ACTIONS(3661),
    [anon_sym___forceinline] = ACTIONS(3661),
    [anon_sym_thread_local] = ACTIONS(3661),
    [anon_sym___thread] = ACTIONS(3661),
    [anon_sym_const] = ACTIONS(3661),
    [anon_sym_constexpr] = ACTIONS(3661),
    [anon_sym_volatile] = ACTIONS(3661),
    [anon_sym_restrict] = ACTIONS(3661),
    [anon_sym___restrict__] = ACTIONS(3661),
    [anon_sym__Atomic] = ACTIONS(3661),
    [anon_sym__Noreturn] = ACTIONS(3661),
    [anon_sym_noreturn] = ACTIONS(3661),
    [anon_sym__Nonnull] = ACTIONS(3661),
    [anon_sym_mutable] = ACTIONS(3661),
    [anon_sym_constinit] = ACTIONS(3661),
    [anon_sym_consteval] = ACTIONS(3661),
    [anon_sym_alignas] = ACTIONS(3661),
    [anon_sym__Alignas] = ACTIONS(3661),
    [sym_primitive_type] = ACTIONS(3661),
    [anon_sym_enum] = ACTIONS(3661),
    [anon_sym_class] = ACTIONS(3661),
    [anon_sym_struct] = ACTIONS(3661),
    [anon_sym_union] = ACTIONS(3661),
    [anon_sym_if] = ACTIONS(3661),
    [anon_sym_switch] = ACTIONS(3661),
    [anon_sym_case] = ACTIONS(3661),
    [anon_sym_default] = ACTIONS(3661),
    [anon_sym_while] = ACTIONS(3661),
    [anon_sym_do] = ACTIONS(3661),
    [anon_sym_for] = ACTIONS(3661),
    [anon_sym_return] = ACTIONS(3661),
    [anon_sym_break] = ACTIONS(3661),
    [anon_sym_continue] = ACTIONS(3661),
    [anon_sym_goto] = ACTIONS(3661),
    [anon_sym___try] = ACTIONS(3661),
    [anon_sym___leave] = ACTIONS(3661),
    [anon_sym_not] = ACTIONS(3661),
    [anon_sym_compl] = ACTIONS(3661),
    [anon_sym_DASH_DASH] = ACTIONS(3663),
    [anon_sym_PLUS_PLUS] = ACTIONS(3663),
    [anon_sym_sizeof] = ACTIONS(3661),
    [anon_sym___alignof__] = ACTIONS(3661),
    [anon_sym___alignof] = ACTIONS(3661),
    [anon_sym__alignof] = ACTIONS(3661),
    [anon_sym_alignof] = ACTIONS(3661),
    [anon_sym__Alignof] = ACTIONS(3661),
    [anon_sym_offsetof] = ACTIONS(3661),
    [anon_sym__Generic] = ACTIONS(3661),
    [anon_sym_asm] = ACTIONS(3661),
    [anon_sym___asm__] = ACTIONS(3661),
    [anon_sym___asm] = ACTIONS(3661),
    [sym_number_literal] = ACTIONS(3663),
    [anon_sym_L_SQUOTE] = ACTIONS(3663),
    [anon_sym_u_SQUOTE] = ACTIONS(3663),
    [anon_sym_U_SQUOTE] = ACTIONS(3663),
    [anon_sym_u8_SQUOTE] = ACTIONS(3663),
    [anon_sym_SQUOTE] = ACTIONS(3663),
    [anon_sym_L_DQUOTE] = ACTIONS(3663),
    [anon_sym_u_DQUOTE] = ACTIONS(3663),
    [anon_sym_U_DQUOTE] = ACTIONS(3663),
    [anon_sym_u8_DQUOTE] = ACTIONS(3663),
    [anon_sym_DQUOTE] = ACTIONS(3663),
    [sym_true] = ACTIONS(3661),
    [sym_false] = ACTIONS(3661),
    [anon_sym_NULL] = ACTIONS(3661),
    [anon_sym_nullptr] = ACTIONS(3661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3661),
    [anon_sym_let] = ACTIONS(3661),
    [anon_sym_This] = ACTIONS(3661),
    [anon_sym_decltype] = ACTIONS(3661),
    [anon_sym_explicit] = ACTIONS(3661),
    [anon_sym_typename] = ACTIONS(3661),
    [anon_sym_template] = ACTIONS(3661),
    [anon_sym_operator] = ACTIONS(3661),
    [anon_sym_try] = ACTIONS(3661),
    [anon_sym_delete] = ACTIONS(3661),
    [anon_sym_throw] = ACTIONS(3661),
    [anon_sym_namespace] = ACTIONS(3661),
    [anon_sym_static_assert] = ACTIONS(3661),
    [anon_sym_concept] = ACTIONS(3661),
    [anon_sym_co_return] = ACTIONS(3661),
    [anon_sym_co_yield] = ACTIONS(3661),
    [anon_sym_R_DQUOTE] = ACTIONS(3663),
    [anon_sym_LR_DQUOTE] = ACTIONS(3663),
    [anon_sym_uR_DQUOTE] = ACTIONS(3663),
    [anon_sym_UR_DQUOTE] = ACTIONS(3663),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3663),
    [anon_sym_co_await] = ACTIONS(3661),
    [anon_sym_new] = ACTIONS(3661),
    [anon_sym_requires] = ACTIONS(3661),
    [sym_this] = ACTIONS(3661),
    [anon_sym_discard] = ACTIONS(3661),
    [anon_sym_precise] = ACTIONS(3661),
    [anon_sym_shared] = ACTIONS(3661),
    [anon_sym_groupshared] = ACTIONS(3661),
    [anon_sym_uniform] = ACTIONS(3661),
    [anon_sym_row_major] = ACTIONS(3661),
    [anon_sym_column_major] = ACTIONS(3661),
    [anon_sym_globallycoherent] = ACTIONS(3661),
    [anon_sym_centroid] = ACTIONS(3661),
    [anon_sym_noperspective] = ACTIONS(3661),
    [anon_sym_nointerpolation] = ACTIONS(3661),
    [anon_sym_sample] = ACTIONS(3661),
    [anon_sym_linear] = ACTIONS(3661),
    [anon_sym_snorm] = ACTIONS(3661),
    [anon_sym_unorm] = ACTIONS(3661),
    [anon_sym_point] = ACTIONS(3661),
    [anon_sym_line] = ACTIONS(3661),
    [anon_sym_triangleadj] = ACTIONS(3661),
    [anon_sym_lineadj] = ACTIONS(3661),
    [anon_sym_triangle] = ACTIONS(3661),
    [anon_sym_cbuffer] = ACTIONS(3661),
    [anon_sym_interface] = ACTIONS(3661),
    [anon_sym_extension] = ACTIONS(3661),
  },
  [896] = {
    [sym_identifier] = ACTIONS(3784),
    [aux_sym_preproc_include_token1] = ACTIONS(3784),
    [aux_sym_preproc_def_token1] = ACTIONS(3784),
    [aux_sym_preproc_if_token1] = ACTIONS(3784),
    [aux_sym_preproc_if_token2] = ACTIONS(3784),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3784),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3784),
    [sym_preproc_directive] = ACTIONS(3784),
    [anon_sym_LPAREN2] = ACTIONS(3786),
    [anon_sym_BANG] = ACTIONS(3786),
    [anon_sym_TILDE] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3784),
    [anon_sym_PLUS] = ACTIONS(3784),
    [anon_sym_STAR] = ACTIONS(3786),
    [anon_sym_AMP_AMP] = ACTIONS(3786),
    [anon_sym_AMP] = ACTIONS(3784),
    [anon_sym_SEMI] = ACTIONS(3786),
    [anon_sym___extension__] = ACTIONS(3784),
    [anon_sym_typedef] = ACTIONS(3784),
    [anon_sym_in] = ACTIONS(3784),
    [anon_sym_out] = ACTIONS(3784),
    [anon_sym_inout] = ACTIONS(3784),
    [anon_sym_virtual] = ACTIONS(3784),
    [anon_sym_extern] = ACTIONS(3784),
    [anon_sym___attribute__] = ACTIONS(3784),
    [anon_sym___attribute] = ACTIONS(3784),
    [anon_sym_using] = ACTIONS(3784),
    [anon_sym_COLON_COLON] = ACTIONS(3786),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3786),
    [anon_sym___declspec] = ACTIONS(3784),
    [anon_sym___based] = ACTIONS(3784),
    [anon_sym___cdecl] = ACTIONS(3784),
    [anon_sym___clrcall] = ACTIONS(3784),
    [anon_sym___stdcall] = ACTIONS(3784),
    [anon_sym___fastcall] = ACTIONS(3784),
    [anon_sym___thiscall] = ACTIONS(3784),
    [anon_sym___vectorcall] = ACTIONS(3784),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3784),
    [anon_sym_static] = ACTIONS(3784),
    [anon_sym_register] = ACTIONS(3784),
    [anon_sym_inline] = ACTIONS(3784),
    [anon_sym___inline] = ACTIONS(3784),
    [anon_sym___inline__] = ACTIONS(3784),
    [anon_sym___forceinline] = ACTIONS(3784),
    [anon_sym_thread_local] = ACTIONS(3784),
    [anon_sym___thread] = ACTIONS(3784),
    [anon_sym_const] = ACTIONS(3784),
    [anon_sym_constexpr] = ACTIONS(3784),
    [anon_sym_volatile] = ACTIONS(3784),
    [anon_sym_restrict] = ACTIONS(3784),
    [anon_sym___restrict__] = ACTIONS(3784),
    [anon_sym__Atomic] = ACTIONS(3784),
    [anon_sym__Noreturn] = ACTIONS(3784),
    [anon_sym_noreturn] = ACTIONS(3784),
    [anon_sym__Nonnull] = ACTIONS(3784),
    [anon_sym_mutable] = ACTIONS(3784),
    [anon_sym_constinit] = ACTIONS(3784),
    [anon_sym_consteval] = ACTIONS(3784),
    [anon_sym_alignas] = ACTIONS(3784),
    [anon_sym__Alignas] = ACTIONS(3784),
    [sym_primitive_type] = ACTIONS(3784),
    [anon_sym_enum] = ACTIONS(3784),
    [anon_sym_class] = ACTIONS(3784),
    [anon_sym_struct] = ACTIONS(3784),
    [anon_sym_union] = ACTIONS(3784),
    [anon_sym_if] = ACTIONS(3784),
    [anon_sym_switch] = ACTIONS(3784),
    [anon_sym_case] = ACTIONS(3784),
    [anon_sym_default] = ACTIONS(3784),
    [anon_sym_while] = ACTIONS(3784),
    [anon_sym_do] = ACTIONS(3784),
    [anon_sym_for] = ACTIONS(3784),
    [anon_sym_return] = ACTIONS(3784),
    [anon_sym_break] = ACTIONS(3784),
    [anon_sym_continue] = ACTIONS(3784),
    [anon_sym_goto] = ACTIONS(3784),
    [anon_sym___try] = ACTIONS(3784),
    [anon_sym___leave] = ACTIONS(3784),
    [anon_sym_not] = ACTIONS(3784),
    [anon_sym_compl] = ACTIONS(3784),
    [anon_sym_DASH_DASH] = ACTIONS(3786),
    [anon_sym_PLUS_PLUS] = ACTIONS(3786),
    [anon_sym_sizeof] = ACTIONS(3784),
    [anon_sym___alignof__] = ACTIONS(3784),
    [anon_sym___alignof] = ACTIONS(3784),
    [anon_sym__alignof] = ACTIONS(3784),
    [anon_sym_alignof] = ACTIONS(3784),
    [anon_sym__Alignof] = ACTIONS(3784),
    [anon_sym_offsetof] = ACTIONS(3784),
    [anon_sym__Generic] = ACTIONS(3784),
    [anon_sym_asm] = ACTIONS(3784),
    [anon_sym___asm__] = ACTIONS(3784),
    [anon_sym___asm] = ACTIONS(3784),
    [sym_number_literal] = ACTIONS(3786),
    [anon_sym_L_SQUOTE] = ACTIONS(3786),
    [anon_sym_u_SQUOTE] = ACTIONS(3786),
    [anon_sym_U_SQUOTE] = ACTIONS(3786),
    [anon_sym_u8_SQUOTE] = ACTIONS(3786),
    [anon_sym_SQUOTE] = ACTIONS(3786),
    [anon_sym_L_DQUOTE] = ACTIONS(3786),
    [anon_sym_u_DQUOTE] = ACTIONS(3786),
    [anon_sym_U_DQUOTE] = ACTIONS(3786),
    [anon_sym_u8_DQUOTE] = ACTIONS(3786),
    [anon_sym_DQUOTE] = ACTIONS(3786),
    [sym_true] = ACTIONS(3784),
    [sym_false] = ACTIONS(3784),
    [anon_sym_NULL] = ACTIONS(3784),
    [anon_sym_nullptr] = ACTIONS(3784),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3784),
    [anon_sym_let] = ACTIONS(3784),
    [anon_sym_This] = ACTIONS(3784),
    [anon_sym_decltype] = ACTIONS(3784),
    [anon_sym_explicit] = ACTIONS(3784),
    [anon_sym_typename] = ACTIONS(3784),
    [anon_sym_template] = ACTIONS(3784),
    [anon_sym_operator] = ACTIONS(3784),
    [anon_sym_try] = ACTIONS(3784),
    [anon_sym_delete] = ACTIONS(3784),
    [anon_sym_throw] = ACTIONS(3784),
    [anon_sym_namespace] = ACTIONS(3784),
    [anon_sym_static_assert] = ACTIONS(3784),
    [anon_sym_concept] = ACTIONS(3784),
    [anon_sym_co_return] = ACTIONS(3784),
    [anon_sym_co_yield] = ACTIONS(3784),
    [anon_sym_R_DQUOTE] = ACTIONS(3786),
    [anon_sym_LR_DQUOTE] = ACTIONS(3786),
    [anon_sym_uR_DQUOTE] = ACTIONS(3786),
    [anon_sym_UR_DQUOTE] = ACTIONS(3786),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3786),
    [anon_sym_co_await] = ACTIONS(3784),
    [anon_sym_new] = ACTIONS(3784),
    [anon_sym_requires] = ACTIONS(3784),
    [sym_this] = ACTIONS(3784),
    [anon_sym_discard] = ACTIONS(3784),
    [anon_sym_precise] = ACTIONS(3784),
    [anon_sym_shared] = ACTIONS(3784),
    [anon_sym_groupshared] = ACTIONS(3784),
    [anon_sym_uniform] = ACTIONS(3784),
    [anon_sym_row_major] = ACTIONS(3784),
    [anon_sym_column_major] = ACTIONS(3784),
    [anon_sym_globallycoherent] = ACTIONS(3784),
    [anon_sym_centroid] = ACTIONS(3784),
    [anon_sym_noperspective] = ACTIONS(3784),
    [anon_sym_nointerpolation] = ACTIONS(3784),
    [anon_sym_sample] = ACTIONS(3784),
    [anon_sym_linear] = ACTIONS(3784),
    [anon_sym_snorm] = ACTIONS(3784),
    [anon_sym_unorm] = ACTIONS(3784),
    [anon_sym_point] = ACTIONS(3784),
    [anon_sym_line] = ACTIONS(3784),
    [anon_sym_triangleadj] = ACTIONS(3784),
    [anon_sym_lineadj] = ACTIONS(3784),
    [anon_sym_triangle] = ACTIONS(3784),
    [anon_sym_cbuffer] = ACTIONS(3784),
    [anon_sym_interface] = ACTIONS(3784),
    [anon_sym_extension] = ACTIONS(3784),
  },
  [897] = {
    [sym_identifier] = ACTIONS(3919),
    [aux_sym_preproc_include_token1] = ACTIONS(3919),
    [aux_sym_preproc_def_token1] = ACTIONS(3919),
    [aux_sym_preproc_if_token1] = ACTIONS(3919),
    [aux_sym_preproc_if_token2] = ACTIONS(3919),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3919),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3919),
    [sym_preproc_directive] = ACTIONS(3919),
    [anon_sym_LPAREN2] = ACTIONS(3921),
    [anon_sym_BANG] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3919),
    [anon_sym_PLUS] = ACTIONS(3919),
    [anon_sym_STAR] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_AMP] = ACTIONS(3919),
    [anon_sym_SEMI] = ACTIONS(3921),
    [anon_sym___extension__] = ACTIONS(3919),
    [anon_sym_typedef] = ACTIONS(3919),
    [anon_sym_in] = ACTIONS(3919),
    [anon_sym_out] = ACTIONS(3919),
    [anon_sym_inout] = ACTIONS(3919),
    [anon_sym_virtual] = ACTIONS(3919),
    [anon_sym_extern] = ACTIONS(3919),
    [anon_sym___attribute__] = ACTIONS(3919),
    [anon_sym___attribute] = ACTIONS(3919),
    [anon_sym_using] = ACTIONS(3919),
    [anon_sym_COLON_COLON] = ACTIONS(3921),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3921),
    [anon_sym___declspec] = ACTIONS(3919),
    [anon_sym___based] = ACTIONS(3919),
    [anon_sym___cdecl] = ACTIONS(3919),
    [anon_sym___clrcall] = ACTIONS(3919),
    [anon_sym___stdcall] = ACTIONS(3919),
    [anon_sym___fastcall] = ACTIONS(3919),
    [anon_sym___thiscall] = ACTIONS(3919),
    [anon_sym___vectorcall] = ACTIONS(3919),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_signed] = ACTIONS(3919),
    [anon_sym_unsigned] = ACTIONS(3919),
    [anon_sym_long] = ACTIONS(3919),
    [anon_sym_short] = ACTIONS(3919),
    [anon_sym_LBRACK] = ACTIONS(3919),
    [anon_sym_static] = ACTIONS(3919),
    [anon_sym_register] = ACTIONS(3919),
    [anon_sym_inline] = ACTIONS(3919),
    [anon_sym___inline] = ACTIONS(3919),
    [anon_sym___inline__] = ACTIONS(3919),
    [anon_sym___forceinline] = ACTIONS(3919),
    [anon_sym_thread_local] = ACTIONS(3919),
    [anon_sym___thread] = ACTIONS(3919),
    [anon_sym_const] = ACTIONS(3919),
    [anon_sym_constexpr] = ACTIONS(3919),
    [anon_sym_volatile] = ACTIONS(3919),
    [anon_sym_restrict] = ACTIONS(3919),
    [anon_sym___restrict__] = ACTIONS(3919),
    [anon_sym__Atomic] = ACTIONS(3919),
    [anon_sym__Noreturn] = ACTIONS(3919),
    [anon_sym_noreturn] = ACTIONS(3919),
    [anon_sym__Nonnull] = ACTIONS(3919),
    [anon_sym_mutable] = ACTIONS(3919),
    [anon_sym_constinit] = ACTIONS(3919),
    [anon_sym_consteval] = ACTIONS(3919),
    [anon_sym_alignas] = ACTIONS(3919),
    [anon_sym__Alignas] = ACTIONS(3919),
    [sym_primitive_type] = ACTIONS(3919),
    [anon_sym_enum] = ACTIONS(3919),
    [anon_sym_class] = ACTIONS(3919),
    [anon_sym_struct] = ACTIONS(3919),
    [anon_sym_union] = ACTIONS(3919),
    [anon_sym_if] = ACTIONS(3919),
    [anon_sym_switch] = ACTIONS(3919),
    [anon_sym_case] = ACTIONS(3919),
    [anon_sym_default] = ACTIONS(3919),
    [anon_sym_while] = ACTIONS(3919),
    [anon_sym_do] = ACTIONS(3919),
    [anon_sym_for] = ACTIONS(3919),
    [anon_sym_return] = ACTIONS(3919),
    [anon_sym_break] = ACTIONS(3919),
    [anon_sym_continue] = ACTIONS(3919),
    [anon_sym_goto] = ACTIONS(3919),
    [anon_sym___try] = ACTIONS(3919),
    [anon_sym___leave] = ACTIONS(3919),
    [anon_sym_not] = ACTIONS(3919),
    [anon_sym_compl] = ACTIONS(3919),
    [anon_sym_DASH_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_PLUS] = ACTIONS(3921),
    [anon_sym_sizeof] = ACTIONS(3919),
    [anon_sym___alignof__] = ACTIONS(3919),
    [anon_sym___alignof] = ACTIONS(3919),
    [anon_sym__alignof] = ACTIONS(3919),
    [anon_sym_alignof] = ACTIONS(3919),
    [anon_sym__Alignof] = ACTIONS(3919),
    [anon_sym_offsetof] = ACTIONS(3919),
    [anon_sym__Generic] = ACTIONS(3919),
    [anon_sym_asm] = ACTIONS(3919),
    [anon_sym___asm__] = ACTIONS(3919),
    [anon_sym___asm] = ACTIONS(3919),
    [sym_number_literal] = ACTIONS(3921),
    [anon_sym_L_SQUOTE] = ACTIONS(3921),
    [anon_sym_u_SQUOTE] = ACTIONS(3921),
    [anon_sym_U_SQUOTE] = ACTIONS(3921),
    [anon_sym_u8_SQUOTE] = ACTIONS(3921),
    [anon_sym_SQUOTE] = ACTIONS(3921),
    [anon_sym_L_DQUOTE] = ACTIONS(3921),
    [anon_sym_u_DQUOTE] = ACTIONS(3921),
    [anon_sym_U_DQUOTE] = ACTIONS(3921),
    [anon_sym_u8_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [sym_true] = ACTIONS(3919),
    [sym_false] = ACTIONS(3919),
    [anon_sym_NULL] = ACTIONS(3919),
    [anon_sym_nullptr] = ACTIONS(3919),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3919),
    [anon_sym_let] = ACTIONS(3919),
    [anon_sym_This] = ACTIONS(3919),
    [anon_sym_decltype] = ACTIONS(3919),
    [anon_sym_explicit] = ACTIONS(3919),
    [anon_sym_typename] = ACTIONS(3919),
    [anon_sym_template] = ACTIONS(3919),
    [anon_sym_operator] = ACTIONS(3919),
    [anon_sym_try] = ACTIONS(3919),
    [anon_sym_delete] = ACTIONS(3919),
    [anon_sym_throw] = ACTIONS(3919),
    [anon_sym_namespace] = ACTIONS(3919),
    [anon_sym_static_assert] = ACTIONS(3919),
    [anon_sym_concept] = ACTIONS(3919),
    [anon_sym_co_return] = ACTIONS(3919),
    [anon_sym_co_yield] = ACTIONS(3919),
    [anon_sym_R_DQUOTE] = ACTIONS(3921),
    [anon_sym_LR_DQUOTE] = ACTIONS(3921),
    [anon_sym_uR_DQUOTE] = ACTIONS(3921),
    [anon_sym_UR_DQUOTE] = ACTIONS(3921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3921),
    [anon_sym_co_await] = ACTIONS(3919),
    [anon_sym_new] = ACTIONS(3919),
    [anon_sym_requires] = ACTIONS(3919),
    [sym_this] = ACTIONS(3919),
    [anon_sym_discard] = ACTIONS(3919),
    [anon_sym_precise] = ACTIONS(3919),
    [anon_sym_shared] = ACTIONS(3919),
    [anon_sym_groupshared] = ACTIONS(3919),
    [anon_sym_uniform] = ACTIONS(3919),
    [anon_sym_row_major] = ACTIONS(3919),
    [anon_sym_column_major] = ACTIONS(3919),
    [anon_sym_globallycoherent] = ACTIONS(3919),
    [anon_sym_centroid] = ACTIONS(3919),
    [anon_sym_noperspective] = ACTIONS(3919),
    [anon_sym_nointerpolation] = ACTIONS(3919),
    [anon_sym_sample] = ACTIONS(3919),
    [anon_sym_linear] = ACTIONS(3919),
    [anon_sym_snorm] = ACTIONS(3919),
    [anon_sym_unorm] = ACTIONS(3919),
    [anon_sym_point] = ACTIONS(3919),
    [anon_sym_line] = ACTIONS(3919),
    [anon_sym_triangleadj] = ACTIONS(3919),
    [anon_sym_lineadj] = ACTIONS(3919),
    [anon_sym_triangle] = ACTIONS(3919),
    [anon_sym_cbuffer] = ACTIONS(3919),
    [anon_sym_interface] = ACTIONS(3919),
    [anon_sym_extension] = ACTIONS(3919),
  },
  [898] = {
    [sym_identifier] = ACTIONS(3949),
    [aux_sym_preproc_include_token1] = ACTIONS(3949),
    [aux_sym_preproc_def_token1] = ACTIONS(3949),
    [aux_sym_preproc_if_token1] = ACTIONS(3949),
    [aux_sym_preproc_if_token2] = ACTIONS(3949),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3949),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3949),
    [sym_preproc_directive] = ACTIONS(3949),
    [anon_sym_LPAREN2] = ACTIONS(3951),
    [anon_sym_BANG] = ACTIONS(3951),
    [anon_sym_TILDE] = ACTIONS(3951),
    [anon_sym_DASH] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3949),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3949),
    [anon_sym_SEMI] = ACTIONS(3951),
    [anon_sym___extension__] = ACTIONS(3949),
    [anon_sym_typedef] = ACTIONS(3949),
    [anon_sym_in] = ACTIONS(3949),
    [anon_sym_out] = ACTIONS(3949),
    [anon_sym_inout] = ACTIONS(3949),
    [anon_sym_virtual] = ACTIONS(3949),
    [anon_sym_extern] = ACTIONS(3949),
    [anon_sym___attribute__] = ACTIONS(3949),
    [anon_sym___attribute] = ACTIONS(3949),
    [anon_sym_using] = ACTIONS(3949),
    [anon_sym_COLON_COLON] = ACTIONS(3951),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3951),
    [anon_sym___declspec] = ACTIONS(3949),
    [anon_sym___based] = ACTIONS(3949),
    [anon_sym___cdecl] = ACTIONS(3949),
    [anon_sym___clrcall] = ACTIONS(3949),
    [anon_sym___stdcall] = ACTIONS(3949),
    [anon_sym___fastcall] = ACTIONS(3949),
    [anon_sym___thiscall] = ACTIONS(3949),
    [anon_sym___vectorcall] = ACTIONS(3949),
    [anon_sym_LBRACE] = ACTIONS(3951),
    [anon_sym_signed] = ACTIONS(3949),
    [anon_sym_unsigned] = ACTIONS(3949),
    [anon_sym_long] = ACTIONS(3949),
    [anon_sym_short] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_static] = ACTIONS(3949),
    [anon_sym_register] = ACTIONS(3949),
    [anon_sym_inline] = ACTIONS(3949),
    [anon_sym___inline] = ACTIONS(3949),
    [anon_sym___inline__] = ACTIONS(3949),
    [anon_sym___forceinline] = ACTIONS(3949),
    [anon_sym_thread_local] = ACTIONS(3949),
    [anon_sym___thread] = ACTIONS(3949),
    [anon_sym_const] = ACTIONS(3949),
    [anon_sym_constexpr] = ACTIONS(3949),
    [anon_sym_volatile] = ACTIONS(3949),
    [anon_sym_restrict] = ACTIONS(3949),
    [anon_sym___restrict__] = ACTIONS(3949),
    [anon_sym__Atomic] = ACTIONS(3949),
    [anon_sym__Noreturn] = ACTIONS(3949),
    [anon_sym_noreturn] = ACTIONS(3949),
    [anon_sym__Nonnull] = ACTIONS(3949),
    [anon_sym_mutable] = ACTIONS(3949),
    [anon_sym_constinit] = ACTIONS(3949),
    [anon_sym_consteval] = ACTIONS(3949),
    [anon_sym_alignas] = ACTIONS(3949),
    [anon_sym__Alignas] = ACTIONS(3949),
    [sym_primitive_type] = ACTIONS(3949),
    [anon_sym_enum] = ACTIONS(3949),
    [anon_sym_class] = ACTIONS(3949),
    [anon_sym_struct] = ACTIONS(3949),
    [anon_sym_union] = ACTIONS(3949),
    [anon_sym_if] = ACTIONS(3949),
    [anon_sym_switch] = ACTIONS(3949),
    [anon_sym_case] = ACTIONS(3949),
    [anon_sym_default] = ACTIONS(3949),
    [anon_sym_while] = ACTIONS(3949),
    [anon_sym_do] = ACTIONS(3949),
    [anon_sym_for] = ACTIONS(3949),
    [anon_sym_return] = ACTIONS(3949),
    [anon_sym_break] = ACTIONS(3949),
    [anon_sym_continue] = ACTIONS(3949),
    [anon_sym_goto] = ACTIONS(3949),
    [anon_sym___try] = ACTIONS(3949),
    [anon_sym___leave] = ACTIONS(3949),
    [anon_sym_not] = ACTIONS(3949),
    [anon_sym_compl] = ACTIONS(3949),
    [anon_sym_DASH_DASH] = ACTIONS(3951),
    [anon_sym_PLUS_PLUS] = ACTIONS(3951),
    [anon_sym_sizeof] = ACTIONS(3949),
    [anon_sym___alignof__] = ACTIONS(3949),
    [anon_sym___alignof] = ACTIONS(3949),
    [anon_sym__alignof] = ACTIONS(3949),
    [anon_sym_alignof] = ACTIONS(3949),
    [anon_sym__Alignof] = ACTIONS(3949),
    [anon_sym_offsetof] = ACTIONS(3949),
    [anon_sym__Generic] = ACTIONS(3949),
    [anon_sym_asm] = ACTIONS(3949),
    [anon_sym___asm__] = ACTIONS(3949),
    [anon_sym___asm] = ACTIONS(3949),
    [sym_number_literal] = ACTIONS(3951),
    [anon_sym_L_SQUOTE] = ACTIONS(3951),
    [anon_sym_u_SQUOTE] = ACTIONS(3951),
    [anon_sym_U_SQUOTE] = ACTIONS(3951),
    [anon_sym_u8_SQUOTE] = ACTIONS(3951),
    [anon_sym_SQUOTE] = ACTIONS(3951),
    [anon_sym_L_DQUOTE] = ACTIONS(3951),
    [anon_sym_u_DQUOTE] = ACTIONS(3951),
    [anon_sym_U_DQUOTE] = ACTIONS(3951),
    [anon_sym_u8_DQUOTE] = ACTIONS(3951),
    [anon_sym_DQUOTE] = ACTIONS(3951),
    [sym_true] = ACTIONS(3949),
    [sym_false] = ACTIONS(3949),
    [anon_sym_NULL] = ACTIONS(3949),
    [anon_sym_nullptr] = ACTIONS(3949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_This] = ACTIONS(3949),
    [anon_sym_decltype] = ACTIONS(3949),
    [anon_sym_explicit] = ACTIONS(3949),
    [anon_sym_typename] = ACTIONS(3949),
    [anon_sym_template] = ACTIONS(3949),
    [anon_sym_operator] = ACTIONS(3949),
    [anon_sym_try] = ACTIONS(3949),
    [anon_sym_delete] = ACTIONS(3949),
    [anon_sym_throw] = ACTIONS(3949),
    [anon_sym_namespace] = ACTIONS(3949),
    [anon_sym_static_assert] = ACTIONS(3949),
    [anon_sym_concept] = ACTIONS(3949),
    [anon_sym_co_return] = ACTIONS(3949),
    [anon_sym_co_yield] = ACTIONS(3949),
    [anon_sym_R_DQUOTE] = ACTIONS(3951),
    [anon_sym_LR_DQUOTE] = ACTIONS(3951),
    [anon_sym_uR_DQUOTE] = ACTIONS(3951),
    [anon_sym_UR_DQUOTE] = ACTIONS(3951),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3951),
    [anon_sym_co_await] = ACTIONS(3949),
    [anon_sym_new] = ACTIONS(3949),
    [anon_sym_requires] = ACTIONS(3949),
    [sym_this] = ACTIONS(3949),
    [anon_sym_discard] = ACTIONS(3949),
    [anon_sym_precise] = ACTIONS(3949),
    [anon_sym_shared] = ACTIONS(3949),
    [anon_sym_groupshared] = ACTIONS(3949),
    [anon_sym_uniform] = ACTIONS(3949),
    [anon_sym_row_major] = ACTIONS(3949),
    [anon_sym_column_major] = ACTIONS(3949),
    [anon_sym_globallycoherent] = ACTIONS(3949),
    [anon_sym_centroid] = ACTIONS(3949),
    [anon_sym_noperspective] = ACTIONS(3949),
    [anon_sym_nointerpolation] = ACTIONS(3949),
    [anon_sym_sample] = ACTIONS(3949),
    [anon_sym_linear] = ACTIONS(3949),
    [anon_sym_snorm] = ACTIONS(3949),
    [anon_sym_unorm] = ACTIONS(3949),
    [anon_sym_point] = ACTIONS(3949),
    [anon_sym_line] = ACTIONS(3949),
    [anon_sym_triangleadj] = ACTIONS(3949),
    [anon_sym_lineadj] = ACTIONS(3949),
    [anon_sym_triangle] = ACTIONS(3949),
    [anon_sym_cbuffer] = ACTIONS(3949),
    [anon_sym_interface] = ACTIONS(3949),
    [anon_sym_extension] = ACTIONS(3949),
  },
  [899] = {
    [sym_identifier] = ACTIONS(3796),
    [aux_sym_preproc_include_token1] = ACTIONS(3796),
    [aux_sym_preproc_def_token1] = ACTIONS(3796),
    [aux_sym_preproc_if_token1] = ACTIONS(3796),
    [aux_sym_preproc_if_token2] = ACTIONS(3796),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3796),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3796),
    [sym_preproc_directive] = ACTIONS(3796),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3798),
    [anon_sym_TILDE] = ACTIONS(3798),
    [anon_sym_DASH] = ACTIONS(3796),
    [anon_sym_PLUS] = ACTIONS(3796),
    [anon_sym_STAR] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_AMP] = ACTIONS(3796),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym___extension__] = ACTIONS(3796),
    [anon_sym_typedef] = ACTIONS(3796),
    [anon_sym_in] = ACTIONS(3796),
    [anon_sym_out] = ACTIONS(3796),
    [anon_sym_inout] = ACTIONS(3796),
    [anon_sym_virtual] = ACTIONS(3796),
    [anon_sym_extern] = ACTIONS(3796),
    [anon_sym___attribute__] = ACTIONS(3796),
    [anon_sym___attribute] = ACTIONS(3796),
    [anon_sym_using] = ACTIONS(3796),
    [anon_sym_COLON_COLON] = ACTIONS(3798),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3798),
    [anon_sym___declspec] = ACTIONS(3796),
    [anon_sym___based] = ACTIONS(3796),
    [anon_sym___cdecl] = ACTIONS(3796),
    [anon_sym___clrcall] = ACTIONS(3796),
    [anon_sym___stdcall] = ACTIONS(3796),
    [anon_sym___fastcall] = ACTIONS(3796),
    [anon_sym___thiscall] = ACTIONS(3796),
    [anon_sym___vectorcall] = ACTIONS(3796),
    [anon_sym_LBRACE] = ACTIONS(3798),
    [anon_sym_signed] = ACTIONS(3796),
    [anon_sym_unsigned] = ACTIONS(3796),
    [anon_sym_long] = ACTIONS(3796),
    [anon_sym_short] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3796),
    [anon_sym_static] = ACTIONS(3796),
    [anon_sym_register] = ACTIONS(3796),
    [anon_sym_inline] = ACTIONS(3796),
    [anon_sym___inline] = ACTIONS(3796),
    [anon_sym___inline__] = ACTIONS(3796),
    [anon_sym___forceinline] = ACTIONS(3796),
    [anon_sym_thread_local] = ACTIONS(3796),
    [anon_sym___thread] = ACTIONS(3796),
    [anon_sym_const] = ACTIONS(3796),
    [anon_sym_constexpr] = ACTIONS(3796),
    [anon_sym_volatile] = ACTIONS(3796),
    [anon_sym_restrict] = ACTIONS(3796),
    [anon_sym___restrict__] = ACTIONS(3796),
    [anon_sym__Atomic] = ACTIONS(3796),
    [anon_sym__Noreturn] = ACTIONS(3796),
    [anon_sym_noreturn] = ACTIONS(3796),
    [anon_sym__Nonnull] = ACTIONS(3796),
    [anon_sym_mutable] = ACTIONS(3796),
    [anon_sym_constinit] = ACTIONS(3796),
    [anon_sym_consteval] = ACTIONS(3796),
    [anon_sym_alignas] = ACTIONS(3796),
    [anon_sym__Alignas] = ACTIONS(3796),
    [sym_primitive_type] = ACTIONS(3796),
    [anon_sym_enum] = ACTIONS(3796),
    [anon_sym_class] = ACTIONS(3796),
    [anon_sym_struct] = ACTIONS(3796),
    [anon_sym_union] = ACTIONS(3796),
    [anon_sym_if] = ACTIONS(3796),
    [anon_sym_switch] = ACTIONS(3796),
    [anon_sym_case] = ACTIONS(3796),
    [anon_sym_default] = ACTIONS(3796),
    [anon_sym_while] = ACTIONS(3796),
    [anon_sym_do] = ACTIONS(3796),
    [anon_sym_for] = ACTIONS(3796),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_continue] = ACTIONS(3796),
    [anon_sym_goto] = ACTIONS(3796),
    [anon_sym___try] = ACTIONS(3796),
    [anon_sym___leave] = ACTIONS(3796),
    [anon_sym_not] = ACTIONS(3796),
    [anon_sym_compl] = ACTIONS(3796),
    [anon_sym_DASH_DASH] = ACTIONS(3798),
    [anon_sym_PLUS_PLUS] = ACTIONS(3798),
    [anon_sym_sizeof] = ACTIONS(3796),
    [anon_sym___alignof__] = ACTIONS(3796),
    [anon_sym___alignof] = ACTIONS(3796),
    [anon_sym__alignof] = ACTIONS(3796),
    [anon_sym_alignof] = ACTIONS(3796),
    [anon_sym__Alignof] = ACTIONS(3796),
    [anon_sym_offsetof] = ACTIONS(3796),
    [anon_sym__Generic] = ACTIONS(3796),
    [anon_sym_asm] = ACTIONS(3796),
    [anon_sym___asm__] = ACTIONS(3796),
    [anon_sym___asm] = ACTIONS(3796),
    [sym_number_literal] = ACTIONS(3798),
    [anon_sym_L_SQUOTE] = ACTIONS(3798),
    [anon_sym_u_SQUOTE] = ACTIONS(3798),
    [anon_sym_U_SQUOTE] = ACTIONS(3798),
    [anon_sym_u8_SQUOTE] = ACTIONS(3798),
    [anon_sym_SQUOTE] = ACTIONS(3798),
    [anon_sym_L_DQUOTE] = ACTIONS(3798),
    [anon_sym_u_DQUOTE] = ACTIONS(3798),
    [anon_sym_U_DQUOTE] = ACTIONS(3798),
    [anon_sym_u8_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(3798),
    [sym_true] = ACTIONS(3796),
    [sym_false] = ACTIONS(3796),
    [anon_sym_NULL] = ACTIONS(3796),
    [anon_sym_nullptr] = ACTIONS(3796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3796),
    [anon_sym_let] = ACTIONS(3796),
    [anon_sym_This] = ACTIONS(3796),
    [anon_sym_decltype] = ACTIONS(3796),
    [anon_sym_explicit] = ACTIONS(3796),
    [anon_sym_typename] = ACTIONS(3796),
    [anon_sym_template] = ACTIONS(3796),
    [anon_sym_operator] = ACTIONS(3796),
    [anon_sym_try] = ACTIONS(3796),
    [anon_sym_delete] = ACTIONS(3796),
    [anon_sym_throw] = ACTIONS(3796),
    [anon_sym_namespace] = ACTIONS(3796),
    [anon_sym_static_assert] = ACTIONS(3796),
    [anon_sym_concept] = ACTIONS(3796),
    [anon_sym_co_return] = ACTIONS(3796),
    [anon_sym_co_yield] = ACTIONS(3796),
    [anon_sym_R_DQUOTE] = ACTIONS(3798),
    [anon_sym_LR_DQUOTE] = ACTIONS(3798),
    [anon_sym_uR_DQUOTE] = ACTIONS(3798),
    [anon_sym_UR_DQUOTE] = ACTIONS(3798),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3798),
    [anon_sym_co_await] = ACTIONS(3796),
    [anon_sym_new] = ACTIONS(3796),
    [anon_sym_requires] = ACTIONS(3796),
    [sym_this] = ACTIONS(3796),
    [anon_sym_discard] = ACTIONS(3796),
    [anon_sym_precise] = ACTIONS(3796),
    [anon_sym_shared] = ACTIONS(3796),
    [anon_sym_groupshared] = ACTIONS(3796),
    [anon_sym_uniform] = ACTIONS(3796),
    [anon_sym_row_major] = ACTIONS(3796),
    [anon_sym_column_major] = ACTIONS(3796),
    [anon_sym_globallycoherent] = ACTIONS(3796),
    [anon_sym_centroid] = ACTIONS(3796),
    [anon_sym_noperspective] = ACTIONS(3796),
    [anon_sym_nointerpolation] = ACTIONS(3796),
    [anon_sym_sample] = ACTIONS(3796),
    [anon_sym_linear] = ACTIONS(3796),
    [anon_sym_snorm] = ACTIONS(3796),
    [anon_sym_unorm] = ACTIONS(3796),
    [anon_sym_point] = ACTIONS(3796),
    [anon_sym_line] = ACTIONS(3796),
    [anon_sym_triangleadj] = ACTIONS(3796),
    [anon_sym_lineadj] = ACTIONS(3796),
    [anon_sym_triangle] = ACTIONS(3796),
    [anon_sym_cbuffer] = ACTIONS(3796),
    [anon_sym_interface] = ACTIONS(3796),
    [anon_sym_extension] = ACTIONS(3796),
  },
  [900] = {
    [sym_identifier] = ACTIONS(3800),
    [aux_sym_preproc_include_token1] = ACTIONS(3800),
    [aux_sym_preproc_def_token1] = ACTIONS(3800),
    [aux_sym_preproc_if_token1] = ACTIONS(3800),
    [aux_sym_preproc_if_token2] = ACTIONS(3800),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3800),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3800),
    [sym_preproc_directive] = ACTIONS(3800),
    [anon_sym_LPAREN2] = ACTIONS(3802),
    [anon_sym_BANG] = ACTIONS(3802),
    [anon_sym_TILDE] = ACTIONS(3802),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_STAR] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_SEMI] = ACTIONS(3802),
    [anon_sym___extension__] = ACTIONS(3800),
    [anon_sym_typedef] = ACTIONS(3800),
    [anon_sym_in] = ACTIONS(3800),
    [anon_sym_out] = ACTIONS(3800),
    [anon_sym_inout] = ACTIONS(3800),
    [anon_sym_virtual] = ACTIONS(3800),
    [anon_sym_extern] = ACTIONS(3800),
    [anon_sym___attribute__] = ACTIONS(3800),
    [anon_sym___attribute] = ACTIONS(3800),
    [anon_sym_using] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3802),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3802),
    [anon_sym___declspec] = ACTIONS(3800),
    [anon_sym___based] = ACTIONS(3800),
    [anon_sym___cdecl] = ACTIONS(3800),
    [anon_sym___clrcall] = ACTIONS(3800),
    [anon_sym___stdcall] = ACTIONS(3800),
    [anon_sym___fastcall] = ACTIONS(3800),
    [anon_sym___thiscall] = ACTIONS(3800),
    [anon_sym___vectorcall] = ACTIONS(3800),
    [anon_sym_LBRACE] = ACTIONS(3802),
    [anon_sym_signed] = ACTIONS(3800),
    [anon_sym_unsigned] = ACTIONS(3800),
    [anon_sym_long] = ACTIONS(3800),
    [anon_sym_short] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3800),
    [anon_sym_static] = ACTIONS(3800),
    [anon_sym_register] = ACTIONS(3800),
    [anon_sym_inline] = ACTIONS(3800),
    [anon_sym___inline] = ACTIONS(3800),
    [anon_sym___inline__] = ACTIONS(3800),
    [anon_sym___forceinline] = ACTIONS(3800),
    [anon_sym_thread_local] = ACTIONS(3800),
    [anon_sym___thread] = ACTIONS(3800),
    [anon_sym_const] = ACTIONS(3800),
    [anon_sym_constexpr] = ACTIONS(3800),
    [anon_sym_volatile] = ACTIONS(3800),
    [anon_sym_restrict] = ACTIONS(3800),
    [anon_sym___restrict__] = ACTIONS(3800),
    [anon_sym__Atomic] = ACTIONS(3800),
    [anon_sym__Noreturn] = ACTIONS(3800),
    [anon_sym_noreturn] = ACTIONS(3800),
    [anon_sym__Nonnull] = ACTIONS(3800),
    [anon_sym_mutable] = ACTIONS(3800),
    [anon_sym_constinit] = ACTIONS(3800),
    [anon_sym_consteval] = ACTIONS(3800),
    [anon_sym_alignas] = ACTIONS(3800),
    [anon_sym__Alignas] = ACTIONS(3800),
    [sym_primitive_type] = ACTIONS(3800),
    [anon_sym_enum] = ACTIONS(3800),
    [anon_sym_class] = ACTIONS(3800),
    [anon_sym_struct] = ACTIONS(3800),
    [anon_sym_union] = ACTIONS(3800),
    [anon_sym_if] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(3800),
    [anon_sym_case] = ACTIONS(3800),
    [anon_sym_default] = ACTIONS(3800),
    [anon_sym_while] = ACTIONS(3800),
    [anon_sym_do] = ACTIONS(3800),
    [anon_sym_for] = ACTIONS(3800),
    [anon_sym_return] = ACTIONS(3800),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_continue] = ACTIONS(3800),
    [anon_sym_goto] = ACTIONS(3800),
    [anon_sym___try] = ACTIONS(3800),
    [anon_sym___leave] = ACTIONS(3800),
    [anon_sym_not] = ACTIONS(3800),
    [anon_sym_compl] = ACTIONS(3800),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3800),
    [anon_sym___alignof__] = ACTIONS(3800),
    [anon_sym___alignof] = ACTIONS(3800),
    [anon_sym__alignof] = ACTIONS(3800),
    [anon_sym_alignof] = ACTIONS(3800),
    [anon_sym__Alignof] = ACTIONS(3800),
    [anon_sym_offsetof] = ACTIONS(3800),
    [anon_sym__Generic] = ACTIONS(3800),
    [anon_sym_asm] = ACTIONS(3800),
    [anon_sym___asm__] = ACTIONS(3800),
    [anon_sym___asm] = ACTIONS(3800),
    [sym_number_literal] = ACTIONS(3802),
    [anon_sym_L_SQUOTE] = ACTIONS(3802),
    [anon_sym_u_SQUOTE] = ACTIONS(3802),
    [anon_sym_U_SQUOTE] = ACTIONS(3802),
    [anon_sym_u8_SQUOTE] = ACTIONS(3802),
    [anon_sym_SQUOTE] = ACTIONS(3802),
    [anon_sym_L_DQUOTE] = ACTIONS(3802),
    [anon_sym_u_DQUOTE] = ACTIONS(3802),
    [anon_sym_U_DQUOTE] = ACTIONS(3802),
    [anon_sym_u8_DQUOTE] = ACTIONS(3802),
    [anon_sym_DQUOTE] = ACTIONS(3802),
    [sym_true] = ACTIONS(3800),
    [sym_false] = ACTIONS(3800),
    [anon_sym_NULL] = ACTIONS(3800),
    [anon_sym_nullptr] = ACTIONS(3800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_This] = ACTIONS(3800),
    [anon_sym_decltype] = ACTIONS(3800),
    [anon_sym_explicit] = ACTIONS(3800),
    [anon_sym_typename] = ACTIONS(3800),
    [anon_sym_template] = ACTIONS(3800),
    [anon_sym_operator] = ACTIONS(3800),
    [anon_sym_try] = ACTIONS(3800),
    [anon_sym_delete] = ACTIONS(3800),
    [anon_sym_throw] = ACTIONS(3800),
    [anon_sym_namespace] = ACTIONS(3800),
    [anon_sym_static_assert] = ACTIONS(3800),
    [anon_sym_concept] = ACTIONS(3800),
    [anon_sym_co_return] = ACTIONS(3800),
    [anon_sym_co_yield] = ACTIONS(3800),
    [anon_sym_R_DQUOTE] = ACTIONS(3802),
    [anon_sym_LR_DQUOTE] = ACTIONS(3802),
    [anon_sym_uR_DQUOTE] = ACTIONS(3802),
    [anon_sym_UR_DQUOTE] = ACTIONS(3802),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3802),
    [anon_sym_co_await] = ACTIONS(3800),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_requires] = ACTIONS(3800),
    [sym_this] = ACTIONS(3800),
    [anon_sym_discard] = ACTIONS(3800),
    [anon_sym_precise] = ACTIONS(3800),
    [anon_sym_shared] = ACTIONS(3800),
    [anon_sym_groupshared] = ACTIONS(3800),
    [anon_sym_uniform] = ACTIONS(3800),
    [anon_sym_row_major] = ACTIONS(3800),
    [anon_sym_column_major] = ACTIONS(3800),
    [anon_sym_globallycoherent] = ACTIONS(3800),
    [anon_sym_centroid] = ACTIONS(3800),
    [anon_sym_noperspective] = ACTIONS(3800),
    [anon_sym_nointerpolation] = ACTIONS(3800),
    [anon_sym_sample] = ACTIONS(3800),
    [anon_sym_linear] = ACTIONS(3800),
    [anon_sym_snorm] = ACTIONS(3800),
    [anon_sym_unorm] = ACTIONS(3800),
    [anon_sym_point] = ACTIONS(3800),
    [anon_sym_line] = ACTIONS(3800),
    [anon_sym_triangleadj] = ACTIONS(3800),
    [anon_sym_lineadj] = ACTIONS(3800),
    [anon_sym_triangle] = ACTIONS(3800),
    [anon_sym_cbuffer] = ACTIONS(3800),
    [anon_sym_interface] = ACTIONS(3800),
    [anon_sym_extension] = ACTIONS(3800),
  },
  [901] = {
    [sym_identifier] = ACTIONS(3877),
    [aux_sym_preproc_include_token1] = ACTIONS(3877),
    [aux_sym_preproc_def_token1] = ACTIONS(3877),
    [aux_sym_preproc_if_token1] = ACTIONS(3877),
    [aux_sym_preproc_if_token2] = ACTIONS(3877),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3877),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3877),
    [sym_preproc_directive] = ACTIONS(3877),
    [anon_sym_LPAREN2] = ACTIONS(3879),
    [anon_sym_BANG] = ACTIONS(3879),
    [anon_sym_TILDE] = ACTIONS(3879),
    [anon_sym_DASH] = ACTIONS(3877),
    [anon_sym_PLUS] = ACTIONS(3877),
    [anon_sym_STAR] = ACTIONS(3879),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3877),
    [anon_sym_SEMI] = ACTIONS(3879),
    [anon_sym___extension__] = ACTIONS(3877),
    [anon_sym_typedef] = ACTIONS(3877),
    [anon_sym_in] = ACTIONS(3877),
    [anon_sym_out] = ACTIONS(3877),
    [anon_sym_inout] = ACTIONS(3877),
    [anon_sym_virtual] = ACTIONS(3877),
    [anon_sym_extern] = ACTIONS(3877),
    [anon_sym___attribute__] = ACTIONS(3877),
    [anon_sym___attribute] = ACTIONS(3877),
    [anon_sym_using] = ACTIONS(3877),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3879),
    [anon_sym___declspec] = ACTIONS(3877),
    [anon_sym___based] = ACTIONS(3877),
    [anon_sym___cdecl] = ACTIONS(3877),
    [anon_sym___clrcall] = ACTIONS(3877),
    [anon_sym___stdcall] = ACTIONS(3877),
    [anon_sym___fastcall] = ACTIONS(3877),
    [anon_sym___thiscall] = ACTIONS(3877),
    [anon_sym___vectorcall] = ACTIONS(3877),
    [anon_sym_LBRACE] = ACTIONS(3879),
    [anon_sym_signed] = ACTIONS(3877),
    [anon_sym_unsigned] = ACTIONS(3877),
    [anon_sym_long] = ACTIONS(3877),
    [anon_sym_short] = ACTIONS(3877),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_static] = ACTIONS(3877),
    [anon_sym_register] = ACTIONS(3877),
    [anon_sym_inline] = ACTIONS(3877),
    [anon_sym___inline] = ACTIONS(3877),
    [anon_sym___inline__] = ACTIONS(3877),
    [anon_sym___forceinline] = ACTIONS(3877),
    [anon_sym_thread_local] = ACTIONS(3877),
    [anon_sym___thread] = ACTIONS(3877),
    [anon_sym_const] = ACTIONS(3877),
    [anon_sym_constexpr] = ACTIONS(3877),
    [anon_sym_volatile] = ACTIONS(3877),
    [anon_sym_restrict] = ACTIONS(3877),
    [anon_sym___restrict__] = ACTIONS(3877),
    [anon_sym__Atomic] = ACTIONS(3877),
    [anon_sym__Noreturn] = ACTIONS(3877),
    [anon_sym_noreturn] = ACTIONS(3877),
    [anon_sym__Nonnull] = ACTIONS(3877),
    [anon_sym_mutable] = ACTIONS(3877),
    [anon_sym_constinit] = ACTIONS(3877),
    [anon_sym_consteval] = ACTIONS(3877),
    [anon_sym_alignas] = ACTIONS(3877),
    [anon_sym__Alignas] = ACTIONS(3877),
    [sym_primitive_type] = ACTIONS(3877),
    [anon_sym_enum] = ACTIONS(3877),
    [anon_sym_class] = ACTIONS(3877),
    [anon_sym_struct] = ACTIONS(3877),
    [anon_sym_union] = ACTIONS(3877),
    [anon_sym_if] = ACTIONS(3877),
    [anon_sym_switch] = ACTIONS(3877),
    [anon_sym_case] = ACTIONS(3877),
    [anon_sym_default] = ACTIONS(3877),
    [anon_sym_while] = ACTIONS(3877),
    [anon_sym_do] = ACTIONS(3877),
    [anon_sym_for] = ACTIONS(3877),
    [anon_sym_return] = ACTIONS(3877),
    [anon_sym_break] = ACTIONS(3877),
    [anon_sym_continue] = ACTIONS(3877),
    [anon_sym_goto] = ACTIONS(3877),
    [anon_sym___try] = ACTIONS(3877),
    [anon_sym___leave] = ACTIONS(3877),
    [anon_sym_not] = ACTIONS(3877),
    [anon_sym_compl] = ACTIONS(3877),
    [anon_sym_DASH_DASH] = ACTIONS(3879),
    [anon_sym_PLUS_PLUS] = ACTIONS(3879),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(3877),
    [anon_sym___alignof] = ACTIONS(3877),
    [anon_sym__alignof] = ACTIONS(3877),
    [anon_sym_alignof] = ACTIONS(3877),
    [anon_sym__Alignof] = ACTIONS(3877),
    [anon_sym_offsetof] = ACTIONS(3877),
    [anon_sym__Generic] = ACTIONS(3877),
    [anon_sym_asm] = ACTIONS(3877),
    [anon_sym___asm__] = ACTIONS(3877),
    [anon_sym___asm] = ACTIONS(3877),
    [sym_number_literal] = ACTIONS(3879),
    [anon_sym_L_SQUOTE] = ACTIONS(3879),
    [anon_sym_u_SQUOTE] = ACTIONS(3879),
    [anon_sym_U_SQUOTE] = ACTIONS(3879),
    [anon_sym_u8_SQUOTE] = ACTIONS(3879),
    [anon_sym_SQUOTE] = ACTIONS(3879),
    [anon_sym_L_DQUOTE] = ACTIONS(3879),
    [anon_sym_u_DQUOTE] = ACTIONS(3879),
    [anon_sym_U_DQUOTE] = ACTIONS(3879),
    [anon_sym_u8_DQUOTE] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [sym_true] = ACTIONS(3877),
    [sym_false] = ACTIONS(3877),
    [anon_sym_NULL] = ACTIONS(3877),
    [anon_sym_nullptr] = ACTIONS(3877),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3877),
    [anon_sym_let] = ACTIONS(3877),
    [anon_sym_This] = ACTIONS(3877),
    [anon_sym_decltype] = ACTIONS(3877),
    [anon_sym_explicit] = ACTIONS(3877),
    [anon_sym_typename] = ACTIONS(3877),
    [anon_sym_template] = ACTIONS(3877),
    [anon_sym_operator] = ACTIONS(3877),
    [anon_sym_try] = ACTIONS(3877),
    [anon_sym_delete] = ACTIONS(3877),
    [anon_sym_throw] = ACTIONS(3877),
    [anon_sym_namespace] = ACTIONS(3877),
    [anon_sym_static_assert] = ACTIONS(3877),
    [anon_sym_concept] = ACTIONS(3877),
    [anon_sym_co_return] = ACTIONS(3877),
    [anon_sym_co_yield] = ACTIONS(3877),
    [anon_sym_R_DQUOTE] = ACTIONS(3879),
    [anon_sym_LR_DQUOTE] = ACTIONS(3879),
    [anon_sym_uR_DQUOTE] = ACTIONS(3879),
    [anon_sym_UR_DQUOTE] = ACTIONS(3879),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3879),
    [anon_sym_co_await] = ACTIONS(3877),
    [anon_sym_new] = ACTIONS(3877),
    [anon_sym_requires] = ACTIONS(3877),
    [sym_this] = ACTIONS(3877),
    [anon_sym_discard] = ACTIONS(3877),
    [anon_sym_precise] = ACTIONS(3877),
    [anon_sym_shared] = ACTIONS(3877),
    [anon_sym_groupshared] = ACTIONS(3877),
    [anon_sym_uniform] = ACTIONS(3877),
    [anon_sym_row_major] = ACTIONS(3877),
    [anon_sym_column_major] = ACTIONS(3877),
    [anon_sym_globallycoherent] = ACTIONS(3877),
    [anon_sym_centroid] = ACTIONS(3877),
    [anon_sym_noperspective] = ACTIONS(3877),
    [anon_sym_nointerpolation] = ACTIONS(3877),
    [anon_sym_sample] = ACTIONS(3877),
    [anon_sym_linear] = ACTIONS(3877),
    [anon_sym_snorm] = ACTIONS(3877),
    [anon_sym_unorm] = ACTIONS(3877),
    [anon_sym_point] = ACTIONS(3877),
    [anon_sym_line] = ACTIONS(3877),
    [anon_sym_triangleadj] = ACTIONS(3877),
    [anon_sym_lineadj] = ACTIONS(3877),
    [anon_sym_triangle] = ACTIONS(3877),
    [anon_sym_cbuffer] = ACTIONS(3877),
    [anon_sym_interface] = ACTIONS(3877),
    [anon_sym_extension] = ACTIONS(3877),
  },
  [902] = {
    [sym_identifier] = ACTIONS(3893),
    [aux_sym_preproc_include_token1] = ACTIONS(3893),
    [aux_sym_preproc_def_token1] = ACTIONS(3893),
    [aux_sym_preproc_if_token1] = ACTIONS(3893),
    [aux_sym_preproc_if_token2] = ACTIONS(3893),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3893),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3893),
    [sym_preproc_directive] = ACTIONS(3893),
    [anon_sym_LPAREN2] = ACTIONS(3895),
    [anon_sym_BANG] = ACTIONS(3895),
    [anon_sym_TILDE] = ACTIONS(3895),
    [anon_sym_DASH] = ACTIONS(3893),
    [anon_sym_PLUS] = ACTIONS(3893),
    [anon_sym_STAR] = ACTIONS(3895),
    [anon_sym_AMP_AMP] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3893),
    [anon_sym_SEMI] = ACTIONS(3895),
    [anon_sym___extension__] = ACTIONS(3893),
    [anon_sym_typedef] = ACTIONS(3893),
    [anon_sym_in] = ACTIONS(3893),
    [anon_sym_out] = ACTIONS(3893),
    [anon_sym_inout] = ACTIONS(3893),
    [anon_sym_virtual] = ACTIONS(3893),
    [anon_sym_extern] = ACTIONS(3893),
    [anon_sym___attribute__] = ACTIONS(3893),
    [anon_sym___attribute] = ACTIONS(3893),
    [anon_sym_using] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3895),
    [anon_sym___declspec] = ACTIONS(3893),
    [anon_sym___based] = ACTIONS(3893),
    [anon_sym___cdecl] = ACTIONS(3893),
    [anon_sym___clrcall] = ACTIONS(3893),
    [anon_sym___stdcall] = ACTIONS(3893),
    [anon_sym___fastcall] = ACTIONS(3893),
    [anon_sym___thiscall] = ACTIONS(3893),
    [anon_sym___vectorcall] = ACTIONS(3893),
    [anon_sym_LBRACE] = ACTIONS(3895),
    [anon_sym_signed] = ACTIONS(3893),
    [anon_sym_unsigned] = ACTIONS(3893),
    [anon_sym_long] = ACTIONS(3893),
    [anon_sym_short] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_static] = ACTIONS(3893),
    [anon_sym_register] = ACTIONS(3893),
    [anon_sym_inline] = ACTIONS(3893),
    [anon_sym___inline] = ACTIONS(3893),
    [anon_sym___inline__] = ACTIONS(3893),
    [anon_sym___forceinline] = ACTIONS(3893),
    [anon_sym_thread_local] = ACTIONS(3893),
    [anon_sym___thread] = ACTIONS(3893),
    [anon_sym_const] = ACTIONS(3893),
    [anon_sym_constexpr] = ACTIONS(3893),
    [anon_sym_volatile] = ACTIONS(3893),
    [anon_sym_restrict] = ACTIONS(3893),
    [anon_sym___restrict__] = ACTIONS(3893),
    [anon_sym__Atomic] = ACTIONS(3893),
    [anon_sym__Noreturn] = ACTIONS(3893),
    [anon_sym_noreturn] = ACTIONS(3893),
    [anon_sym__Nonnull] = ACTIONS(3893),
    [anon_sym_mutable] = ACTIONS(3893),
    [anon_sym_constinit] = ACTIONS(3893),
    [anon_sym_consteval] = ACTIONS(3893),
    [anon_sym_alignas] = ACTIONS(3893),
    [anon_sym__Alignas] = ACTIONS(3893),
    [sym_primitive_type] = ACTIONS(3893),
    [anon_sym_enum] = ACTIONS(3893),
    [anon_sym_class] = ACTIONS(3893),
    [anon_sym_struct] = ACTIONS(3893),
    [anon_sym_union] = ACTIONS(3893),
    [anon_sym_if] = ACTIONS(3893),
    [anon_sym_switch] = ACTIONS(3893),
    [anon_sym_case] = ACTIONS(3893),
    [anon_sym_default] = ACTIONS(3893),
    [anon_sym_while] = ACTIONS(3893),
    [anon_sym_do] = ACTIONS(3893),
    [anon_sym_for] = ACTIONS(3893),
    [anon_sym_return] = ACTIONS(3893),
    [anon_sym_break] = ACTIONS(3893),
    [anon_sym_continue] = ACTIONS(3893),
    [anon_sym_goto] = ACTIONS(3893),
    [anon_sym___try] = ACTIONS(3893),
    [anon_sym___leave] = ACTIONS(3893),
    [anon_sym_not] = ACTIONS(3893),
    [anon_sym_compl] = ACTIONS(3893),
    [anon_sym_DASH_DASH] = ACTIONS(3895),
    [anon_sym_PLUS_PLUS] = ACTIONS(3895),
    [anon_sym_sizeof] = ACTIONS(3893),
    [anon_sym___alignof__] = ACTIONS(3893),
    [anon_sym___alignof] = ACTIONS(3893),
    [anon_sym__alignof] = ACTIONS(3893),
    [anon_sym_alignof] = ACTIONS(3893),
    [anon_sym__Alignof] = ACTIONS(3893),
    [anon_sym_offsetof] = ACTIONS(3893),
    [anon_sym__Generic] = ACTIONS(3893),
    [anon_sym_asm] = ACTIONS(3893),
    [anon_sym___asm__] = ACTIONS(3893),
    [anon_sym___asm] = ACTIONS(3893),
    [sym_number_literal] = ACTIONS(3895),
    [anon_sym_L_SQUOTE] = ACTIONS(3895),
    [anon_sym_u_SQUOTE] = ACTIONS(3895),
    [anon_sym_U_SQUOTE] = ACTIONS(3895),
    [anon_sym_u8_SQUOTE] = ACTIONS(3895),
    [anon_sym_SQUOTE] = ACTIONS(3895),
    [anon_sym_L_DQUOTE] = ACTIONS(3895),
    [anon_sym_u_DQUOTE] = ACTIONS(3895),
    [anon_sym_U_DQUOTE] = ACTIONS(3895),
    [anon_sym_u8_DQUOTE] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(3895),
    [sym_true] = ACTIONS(3893),
    [sym_false] = ACTIONS(3893),
    [anon_sym_NULL] = ACTIONS(3893),
    [anon_sym_nullptr] = ACTIONS(3893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_This] = ACTIONS(3893),
    [anon_sym_decltype] = ACTIONS(3893),
    [anon_sym_explicit] = ACTIONS(3893),
    [anon_sym_typename] = ACTIONS(3893),
    [anon_sym_template] = ACTIONS(3893),
    [anon_sym_operator] = ACTIONS(3893),
    [anon_sym_try] = ACTIONS(3893),
    [anon_sym_delete] = ACTIONS(3893),
    [anon_sym_throw] = ACTIONS(3893),
    [anon_sym_namespace] = ACTIONS(3893),
    [anon_sym_static_assert] = ACTIONS(3893),
    [anon_sym_concept] = ACTIONS(3893),
    [anon_sym_co_return] = ACTIONS(3893),
    [anon_sym_co_yield] = ACTIONS(3893),
    [anon_sym_R_DQUOTE] = ACTIONS(3895),
    [anon_sym_LR_DQUOTE] = ACTIONS(3895),
    [anon_sym_uR_DQUOTE] = ACTIONS(3895),
    [anon_sym_UR_DQUOTE] = ACTIONS(3895),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3895),
    [anon_sym_co_await] = ACTIONS(3893),
    [anon_sym_new] = ACTIONS(3893),
    [anon_sym_requires] = ACTIONS(3893),
    [sym_this] = ACTIONS(3893),
    [anon_sym_discard] = ACTIONS(3893),
    [anon_sym_precise] = ACTIONS(3893),
    [anon_sym_shared] = ACTIONS(3893),
    [anon_sym_groupshared] = ACTIONS(3893),
    [anon_sym_uniform] = ACTIONS(3893),
    [anon_sym_row_major] = ACTIONS(3893),
    [anon_sym_column_major] = ACTIONS(3893),
    [anon_sym_globallycoherent] = ACTIONS(3893),
    [anon_sym_centroid] = ACTIONS(3893),
    [anon_sym_noperspective] = ACTIONS(3893),
    [anon_sym_nointerpolation] = ACTIONS(3893),
    [anon_sym_sample] = ACTIONS(3893),
    [anon_sym_linear] = ACTIONS(3893),
    [anon_sym_snorm] = ACTIONS(3893),
    [anon_sym_unorm] = ACTIONS(3893),
    [anon_sym_point] = ACTIONS(3893),
    [anon_sym_line] = ACTIONS(3893),
    [anon_sym_triangleadj] = ACTIONS(3893),
    [anon_sym_lineadj] = ACTIONS(3893),
    [anon_sym_triangle] = ACTIONS(3893),
    [anon_sym_cbuffer] = ACTIONS(3893),
    [anon_sym_interface] = ACTIONS(3893),
    [anon_sym_extension] = ACTIONS(3893),
  },
  [903] = {
    [sym_identifier] = ACTIONS(3739),
    [aux_sym_preproc_include_token1] = ACTIONS(3739),
    [aux_sym_preproc_def_token1] = ACTIONS(3739),
    [aux_sym_preproc_if_token1] = ACTIONS(3739),
    [aux_sym_preproc_if_token2] = ACTIONS(3739),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3739),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3739),
    [sym_preproc_directive] = ACTIONS(3739),
    [anon_sym_LPAREN2] = ACTIONS(3741),
    [anon_sym_BANG] = ACTIONS(3741),
    [anon_sym_TILDE] = ACTIONS(3741),
    [anon_sym_DASH] = ACTIONS(3739),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_STAR] = ACTIONS(3741),
    [anon_sym_AMP_AMP] = ACTIONS(3741),
    [anon_sym_AMP] = ACTIONS(3739),
    [anon_sym_SEMI] = ACTIONS(3741),
    [anon_sym___extension__] = ACTIONS(3739),
    [anon_sym_typedef] = ACTIONS(3739),
    [anon_sym_in] = ACTIONS(3739),
    [anon_sym_out] = ACTIONS(3739),
    [anon_sym_inout] = ACTIONS(3739),
    [anon_sym_virtual] = ACTIONS(3739),
    [anon_sym_extern] = ACTIONS(3739),
    [anon_sym___attribute__] = ACTIONS(3739),
    [anon_sym___attribute] = ACTIONS(3739),
    [anon_sym_using] = ACTIONS(3739),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3741),
    [anon_sym___declspec] = ACTIONS(3739),
    [anon_sym___based] = ACTIONS(3739),
    [anon_sym___cdecl] = ACTIONS(3739),
    [anon_sym___clrcall] = ACTIONS(3739),
    [anon_sym___stdcall] = ACTIONS(3739),
    [anon_sym___fastcall] = ACTIONS(3739),
    [anon_sym___thiscall] = ACTIONS(3739),
    [anon_sym___vectorcall] = ACTIONS(3739),
    [anon_sym_LBRACE] = ACTIONS(3741),
    [anon_sym_signed] = ACTIONS(3739),
    [anon_sym_unsigned] = ACTIONS(3739),
    [anon_sym_long] = ACTIONS(3739),
    [anon_sym_short] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3739),
    [anon_sym_static] = ACTIONS(3739),
    [anon_sym_register] = ACTIONS(3739),
    [anon_sym_inline] = ACTIONS(3739),
    [anon_sym___inline] = ACTIONS(3739),
    [anon_sym___inline__] = ACTIONS(3739),
    [anon_sym___forceinline] = ACTIONS(3739),
    [anon_sym_thread_local] = ACTIONS(3739),
    [anon_sym___thread] = ACTIONS(3739),
    [anon_sym_const] = ACTIONS(3739),
    [anon_sym_constexpr] = ACTIONS(3739),
    [anon_sym_volatile] = ACTIONS(3739),
    [anon_sym_restrict] = ACTIONS(3739),
    [anon_sym___restrict__] = ACTIONS(3739),
    [anon_sym__Atomic] = ACTIONS(3739),
    [anon_sym__Noreturn] = ACTIONS(3739),
    [anon_sym_noreturn] = ACTIONS(3739),
    [anon_sym__Nonnull] = ACTIONS(3739),
    [anon_sym_mutable] = ACTIONS(3739),
    [anon_sym_constinit] = ACTIONS(3739),
    [anon_sym_consteval] = ACTIONS(3739),
    [anon_sym_alignas] = ACTIONS(3739),
    [anon_sym__Alignas] = ACTIONS(3739),
    [sym_primitive_type] = ACTIONS(3739),
    [anon_sym_enum] = ACTIONS(3739),
    [anon_sym_class] = ACTIONS(3739),
    [anon_sym_struct] = ACTIONS(3739),
    [anon_sym_union] = ACTIONS(3739),
    [anon_sym_if] = ACTIONS(3739),
    [anon_sym_switch] = ACTIONS(3739),
    [anon_sym_case] = ACTIONS(3739),
    [anon_sym_default] = ACTIONS(3739),
    [anon_sym_while] = ACTIONS(3739),
    [anon_sym_do] = ACTIONS(3739),
    [anon_sym_for] = ACTIONS(3739),
    [anon_sym_return] = ACTIONS(3739),
    [anon_sym_break] = ACTIONS(3739),
    [anon_sym_continue] = ACTIONS(3739),
    [anon_sym_goto] = ACTIONS(3739),
    [anon_sym___try] = ACTIONS(3739),
    [anon_sym___leave] = ACTIONS(3739),
    [anon_sym_not] = ACTIONS(3739),
    [anon_sym_compl] = ACTIONS(3739),
    [anon_sym_DASH_DASH] = ACTIONS(3741),
    [anon_sym_PLUS_PLUS] = ACTIONS(3741),
    [anon_sym_sizeof] = ACTIONS(3739),
    [anon_sym___alignof__] = ACTIONS(3739),
    [anon_sym___alignof] = ACTIONS(3739),
    [anon_sym__alignof] = ACTIONS(3739),
    [anon_sym_alignof] = ACTIONS(3739),
    [anon_sym__Alignof] = ACTIONS(3739),
    [anon_sym_offsetof] = ACTIONS(3739),
    [anon_sym__Generic] = ACTIONS(3739),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [anon_sym___asm] = ACTIONS(3739),
    [sym_number_literal] = ACTIONS(3741),
    [anon_sym_L_SQUOTE] = ACTIONS(3741),
    [anon_sym_u_SQUOTE] = ACTIONS(3741),
    [anon_sym_U_SQUOTE] = ACTIONS(3741),
    [anon_sym_u8_SQUOTE] = ACTIONS(3741),
    [anon_sym_SQUOTE] = ACTIONS(3741),
    [anon_sym_L_DQUOTE] = ACTIONS(3741),
    [anon_sym_u_DQUOTE] = ACTIONS(3741),
    [anon_sym_U_DQUOTE] = ACTIONS(3741),
    [anon_sym_u8_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE] = ACTIONS(3741),
    [sym_true] = ACTIONS(3739),
    [sym_false] = ACTIONS(3739),
    [anon_sym_NULL] = ACTIONS(3739),
    [anon_sym_nullptr] = ACTIONS(3739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3739),
    [anon_sym_let] = ACTIONS(3739),
    [anon_sym_This] = ACTIONS(3739),
    [anon_sym_decltype] = ACTIONS(3739),
    [anon_sym_explicit] = ACTIONS(3739),
    [anon_sym_typename] = ACTIONS(3739),
    [anon_sym_template] = ACTIONS(3739),
    [anon_sym_operator] = ACTIONS(3739),
    [anon_sym_try] = ACTIONS(3739),
    [anon_sym_delete] = ACTIONS(3739),
    [anon_sym_throw] = ACTIONS(3739),
    [anon_sym_namespace] = ACTIONS(3739),
    [anon_sym_static_assert] = ACTIONS(3739),
    [anon_sym_concept] = ACTIONS(3739),
    [anon_sym_co_return] = ACTIONS(3739),
    [anon_sym_co_yield] = ACTIONS(3739),
    [anon_sym_R_DQUOTE] = ACTIONS(3741),
    [anon_sym_LR_DQUOTE] = ACTIONS(3741),
    [anon_sym_uR_DQUOTE] = ACTIONS(3741),
    [anon_sym_UR_DQUOTE] = ACTIONS(3741),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3741),
    [anon_sym_co_await] = ACTIONS(3739),
    [anon_sym_new] = ACTIONS(3739),
    [anon_sym_requires] = ACTIONS(3739),
    [sym_this] = ACTIONS(3739),
    [anon_sym_discard] = ACTIONS(3739),
    [anon_sym_precise] = ACTIONS(3739),
    [anon_sym_shared] = ACTIONS(3739),
    [anon_sym_groupshared] = ACTIONS(3739),
    [anon_sym_uniform] = ACTIONS(3739),
    [anon_sym_row_major] = ACTIONS(3739),
    [anon_sym_column_major] = ACTIONS(3739),
    [anon_sym_globallycoherent] = ACTIONS(3739),
    [anon_sym_centroid] = ACTIONS(3739),
    [anon_sym_noperspective] = ACTIONS(3739),
    [anon_sym_nointerpolation] = ACTIONS(3739),
    [anon_sym_sample] = ACTIONS(3739),
    [anon_sym_linear] = ACTIONS(3739),
    [anon_sym_snorm] = ACTIONS(3739),
    [anon_sym_unorm] = ACTIONS(3739),
    [anon_sym_point] = ACTIONS(3739),
    [anon_sym_line] = ACTIONS(3739),
    [anon_sym_triangleadj] = ACTIONS(3739),
    [anon_sym_lineadj] = ACTIONS(3739),
    [anon_sym_triangle] = ACTIONS(3739),
    [anon_sym_cbuffer] = ACTIONS(3739),
    [anon_sym_interface] = ACTIONS(3739),
    [anon_sym_extension] = ACTIONS(3739),
  },
  [904] = {
    [sym_identifier] = ACTIONS(3703),
    [aux_sym_preproc_include_token1] = ACTIONS(3703),
    [aux_sym_preproc_def_token1] = ACTIONS(3703),
    [aux_sym_preproc_if_token1] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3703),
    [sym_preproc_directive] = ACTIONS(3703),
    [anon_sym_LPAREN2] = ACTIONS(3705),
    [anon_sym_BANG] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3703),
    [anon_sym_STAR] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_AMP] = ACTIONS(3703),
    [anon_sym_SEMI] = ACTIONS(3705),
    [anon_sym___extension__] = ACTIONS(3703),
    [anon_sym_typedef] = ACTIONS(3703),
    [anon_sym_in] = ACTIONS(3703),
    [anon_sym_out] = ACTIONS(3703),
    [anon_sym_inout] = ACTIONS(3703),
    [anon_sym_virtual] = ACTIONS(3703),
    [anon_sym_extern] = ACTIONS(3703),
    [anon_sym___attribute__] = ACTIONS(3703),
    [anon_sym___attribute] = ACTIONS(3703),
    [anon_sym_using] = ACTIONS(3703),
    [anon_sym_COLON_COLON] = ACTIONS(3705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3705),
    [anon_sym___declspec] = ACTIONS(3703),
    [anon_sym___based] = ACTIONS(3703),
    [anon_sym___cdecl] = ACTIONS(3703),
    [anon_sym___clrcall] = ACTIONS(3703),
    [anon_sym___stdcall] = ACTIONS(3703),
    [anon_sym___fastcall] = ACTIONS(3703),
    [anon_sym___thiscall] = ACTIONS(3703),
    [anon_sym___vectorcall] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_RBRACE] = ACTIONS(3705),
    [anon_sym_signed] = ACTIONS(3703),
    [anon_sym_unsigned] = ACTIONS(3703),
    [anon_sym_long] = ACTIONS(3703),
    [anon_sym_short] = ACTIONS(3703),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_static] = ACTIONS(3703),
    [anon_sym_register] = ACTIONS(3703),
    [anon_sym_inline] = ACTIONS(3703),
    [anon_sym___inline] = ACTIONS(3703),
    [anon_sym___inline__] = ACTIONS(3703),
    [anon_sym___forceinline] = ACTIONS(3703),
    [anon_sym_thread_local] = ACTIONS(3703),
    [anon_sym___thread] = ACTIONS(3703),
    [anon_sym_const] = ACTIONS(3703),
    [anon_sym_constexpr] = ACTIONS(3703),
    [anon_sym_volatile] = ACTIONS(3703),
    [anon_sym_restrict] = ACTIONS(3703),
    [anon_sym___restrict__] = ACTIONS(3703),
    [anon_sym__Atomic] = ACTIONS(3703),
    [anon_sym__Noreturn] = ACTIONS(3703),
    [anon_sym_noreturn] = ACTIONS(3703),
    [anon_sym__Nonnull] = ACTIONS(3703),
    [anon_sym_mutable] = ACTIONS(3703),
    [anon_sym_constinit] = ACTIONS(3703),
    [anon_sym_consteval] = ACTIONS(3703),
    [anon_sym_alignas] = ACTIONS(3703),
    [anon_sym__Alignas] = ACTIONS(3703),
    [sym_primitive_type] = ACTIONS(3703),
    [anon_sym_enum] = ACTIONS(3703),
    [anon_sym_class] = ACTIONS(3703),
    [anon_sym_struct] = ACTIONS(3703),
    [anon_sym_union] = ACTIONS(3703),
    [anon_sym_if] = ACTIONS(3703),
    [anon_sym_switch] = ACTIONS(3703),
    [anon_sym_case] = ACTIONS(3703),
    [anon_sym_default] = ACTIONS(3703),
    [anon_sym_while] = ACTIONS(3703),
    [anon_sym_do] = ACTIONS(3703),
    [anon_sym_for] = ACTIONS(3703),
    [anon_sym_return] = ACTIONS(3703),
    [anon_sym_break] = ACTIONS(3703),
    [anon_sym_continue] = ACTIONS(3703),
    [anon_sym_goto] = ACTIONS(3703),
    [anon_sym___try] = ACTIONS(3703),
    [anon_sym___leave] = ACTIONS(3703),
    [anon_sym_not] = ACTIONS(3703),
    [anon_sym_compl] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3705),
    [anon_sym_PLUS_PLUS] = ACTIONS(3705),
    [anon_sym_sizeof] = ACTIONS(3703),
    [anon_sym___alignof__] = ACTIONS(3703),
    [anon_sym___alignof] = ACTIONS(3703),
    [anon_sym__alignof] = ACTIONS(3703),
    [anon_sym_alignof] = ACTIONS(3703),
    [anon_sym__Alignof] = ACTIONS(3703),
    [anon_sym_offsetof] = ACTIONS(3703),
    [anon_sym__Generic] = ACTIONS(3703),
    [anon_sym_asm] = ACTIONS(3703),
    [anon_sym___asm__] = ACTIONS(3703),
    [anon_sym___asm] = ACTIONS(3703),
    [sym_number_literal] = ACTIONS(3705),
    [anon_sym_L_SQUOTE] = ACTIONS(3705),
    [anon_sym_u_SQUOTE] = ACTIONS(3705),
    [anon_sym_U_SQUOTE] = ACTIONS(3705),
    [anon_sym_u8_SQUOTE] = ACTIONS(3705),
    [anon_sym_SQUOTE] = ACTIONS(3705),
    [anon_sym_L_DQUOTE] = ACTIONS(3705),
    [anon_sym_u_DQUOTE] = ACTIONS(3705),
    [anon_sym_U_DQUOTE] = ACTIONS(3705),
    [anon_sym_u8_DQUOTE] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [sym_true] = ACTIONS(3703),
    [sym_false] = ACTIONS(3703),
    [anon_sym_NULL] = ACTIONS(3703),
    [anon_sym_nullptr] = ACTIONS(3703),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3703),
    [anon_sym_let] = ACTIONS(3703),
    [anon_sym_This] = ACTIONS(3703),
    [anon_sym_decltype] = ACTIONS(3703),
    [anon_sym_explicit] = ACTIONS(3703),
    [anon_sym_typename] = ACTIONS(3703),
    [anon_sym_template] = ACTIONS(3703),
    [anon_sym_operator] = ACTIONS(3703),
    [anon_sym_try] = ACTIONS(3703),
    [anon_sym_delete] = ACTIONS(3703),
    [anon_sym_throw] = ACTIONS(3703),
    [anon_sym_namespace] = ACTIONS(3703),
    [anon_sym_static_assert] = ACTIONS(3703),
    [anon_sym_concept] = ACTIONS(3703),
    [anon_sym_co_return] = ACTIONS(3703),
    [anon_sym_co_yield] = ACTIONS(3703),
    [anon_sym_R_DQUOTE] = ACTIONS(3705),
    [anon_sym_LR_DQUOTE] = ACTIONS(3705),
    [anon_sym_uR_DQUOTE] = ACTIONS(3705),
    [anon_sym_UR_DQUOTE] = ACTIONS(3705),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3705),
    [anon_sym_co_await] = ACTIONS(3703),
    [anon_sym_new] = ACTIONS(3703),
    [anon_sym_requires] = ACTIONS(3703),
    [sym_this] = ACTIONS(3703),
    [anon_sym_discard] = ACTIONS(3703),
    [anon_sym_precise] = ACTIONS(3703),
    [anon_sym_shared] = ACTIONS(3703),
    [anon_sym_groupshared] = ACTIONS(3703),
    [anon_sym_uniform] = ACTIONS(3703),
    [anon_sym_row_major] = ACTIONS(3703),
    [anon_sym_column_major] = ACTIONS(3703),
    [anon_sym_globallycoherent] = ACTIONS(3703),
    [anon_sym_centroid] = ACTIONS(3703),
    [anon_sym_noperspective] = ACTIONS(3703),
    [anon_sym_nointerpolation] = ACTIONS(3703),
    [anon_sym_sample] = ACTIONS(3703),
    [anon_sym_linear] = ACTIONS(3703),
    [anon_sym_snorm] = ACTIONS(3703),
    [anon_sym_unorm] = ACTIONS(3703),
    [anon_sym_point] = ACTIONS(3703),
    [anon_sym_line] = ACTIONS(3703),
    [anon_sym_triangleadj] = ACTIONS(3703),
    [anon_sym_lineadj] = ACTIONS(3703),
    [anon_sym_triangle] = ACTIONS(3703),
    [anon_sym_cbuffer] = ACTIONS(3703),
    [anon_sym_interface] = ACTIONS(3703),
    [anon_sym_extension] = ACTIONS(3703),
  },
  [905] = {
    [sym_identifier] = ACTIONS(3707),
    [aux_sym_preproc_include_token1] = ACTIONS(3707),
    [aux_sym_preproc_def_token1] = ACTIONS(3707),
    [aux_sym_preproc_if_token1] = ACTIONS(3707),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3707),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3707),
    [sym_preproc_directive] = ACTIONS(3707),
    [anon_sym_LPAREN2] = ACTIONS(3709),
    [anon_sym_BANG] = ACTIONS(3709),
    [anon_sym_TILDE] = ACTIONS(3709),
    [anon_sym_DASH] = ACTIONS(3707),
    [anon_sym_PLUS] = ACTIONS(3707),
    [anon_sym_STAR] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(3707),
    [anon_sym_SEMI] = ACTIONS(3709),
    [anon_sym___extension__] = ACTIONS(3707),
    [anon_sym_typedef] = ACTIONS(3707),
    [anon_sym_in] = ACTIONS(3707),
    [anon_sym_out] = ACTIONS(3707),
    [anon_sym_inout] = ACTIONS(3707),
    [anon_sym_virtual] = ACTIONS(3707),
    [anon_sym_extern] = ACTIONS(3707),
    [anon_sym___attribute__] = ACTIONS(3707),
    [anon_sym___attribute] = ACTIONS(3707),
    [anon_sym_using] = ACTIONS(3707),
    [anon_sym_COLON_COLON] = ACTIONS(3709),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3709),
    [anon_sym___declspec] = ACTIONS(3707),
    [anon_sym___based] = ACTIONS(3707),
    [anon_sym___cdecl] = ACTIONS(3707),
    [anon_sym___clrcall] = ACTIONS(3707),
    [anon_sym___stdcall] = ACTIONS(3707),
    [anon_sym___fastcall] = ACTIONS(3707),
    [anon_sym___thiscall] = ACTIONS(3707),
    [anon_sym___vectorcall] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3709),
    [anon_sym_RBRACE] = ACTIONS(3709),
    [anon_sym_signed] = ACTIONS(3707),
    [anon_sym_unsigned] = ACTIONS(3707),
    [anon_sym_long] = ACTIONS(3707),
    [anon_sym_short] = ACTIONS(3707),
    [anon_sym_LBRACK] = ACTIONS(3707),
    [anon_sym_static] = ACTIONS(3707),
    [anon_sym_register] = ACTIONS(3707),
    [anon_sym_inline] = ACTIONS(3707),
    [anon_sym___inline] = ACTIONS(3707),
    [anon_sym___inline__] = ACTIONS(3707),
    [anon_sym___forceinline] = ACTIONS(3707),
    [anon_sym_thread_local] = ACTIONS(3707),
    [anon_sym___thread] = ACTIONS(3707),
    [anon_sym_const] = ACTIONS(3707),
    [anon_sym_constexpr] = ACTIONS(3707),
    [anon_sym_volatile] = ACTIONS(3707),
    [anon_sym_restrict] = ACTIONS(3707),
    [anon_sym___restrict__] = ACTIONS(3707),
    [anon_sym__Atomic] = ACTIONS(3707),
    [anon_sym__Noreturn] = ACTIONS(3707),
    [anon_sym_noreturn] = ACTIONS(3707),
    [anon_sym__Nonnull] = ACTIONS(3707),
    [anon_sym_mutable] = ACTIONS(3707),
    [anon_sym_constinit] = ACTIONS(3707),
    [anon_sym_consteval] = ACTIONS(3707),
    [anon_sym_alignas] = ACTIONS(3707),
    [anon_sym__Alignas] = ACTIONS(3707),
    [sym_primitive_type] = ACTIONS(3707),
    [anon_sym_enum] = ACTIONS(3707),
    [anon_sym_class] = ACTIONS(3707),
    [anon_sym_struct] = ACTIONS(3707),
    [anon_sym_union] = ACTIONS(3707),
    [anon_sym_if] = ACTIONS(3707),
    [anon_sym_switch] = ACTIONS(3707),
    [anon_sym_case] = ACTIONS(3707),
    [anon_sym_default] = ACTIONS(3707),
    [anon_sym_while] = ACTIONS(3707),
    [anon_sym_do] = ACTIONS(3707),
    [anon_sym_for] = ACTIONS(3707),
    [anon_sym_return] = ACTIONS(3707),
    [anon_sym_break] = ACTIONS(3707),
    [anon_sym_continue] = ACTIONS(3707),
    [anon_sym_goto] = ACTIONS(3707),
    [anon_sym___try] = ACTIONS(3707),
    [anon_sym___leave] = ACTIONS(3707),
    [anon_sym_not] = ACTIONS(3707),
    [anon_sym_compl] = ACTIONS(3707),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_sizeof] = ACTIONS(3707),
    [anon_sym___alignof__] = ACTIONS(3707),
    [anon_sym___alignof] = ACTIONS(3707),
    [anon_sym__alignof] = ACTIONS(3707),
    [anon_sym_alignof] = ACTIONS(3707),
    [anon_sym__Alignof] = ACTIONS(3707),
    [anon_sym_offsetof] = ACTIONS(3707),
    [anon_sym__Generic] = ACTIONS(3707),
    [anon_sym_asm] = ACTIONS(3707),
    [anon_sym___asm__] = ACTIONS(3707),
    [anon_sym___asm] = ACTIONS(3707),
    [sym_number_literal] = ACTIONS(3709),
    [anon_sym_L_SQUOTE] = ACTIONS(3709),
    [anon_sym_u_SQUOTE] = ACTIONS(3709),
    [anon_sym_U_SQUOTE] = ACTIONS(3709),
    [anon_sym_u8_SQUOTE] = ACTIONS(3709),
    [anon_sym_SQUOTE] = ACTIONS(3709),
    [anon_sym_L_DQUOTE] = ACTIONS(3709),
    [anon_sym_u_DQUOTE] = ACTIONS(3709),
    [anon_sym_U_DQUOTE] = ACTIONS(3709),
    [anon_sym_u8_DQUOTE] = ACTIONS(3709),
    [anon_sym_DQUOTE] = ACTIONS(3709),
    [sym_true] = ACTIONS(3707),
    [sym_false] = ACTIONS(3707),
    [anon_sym_NULL] = ACTIONS(3707),
    [anon_sym_nullptr] = ACTIONS(3707),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3707),
    [anon_sym_let] = ACTIONS(3707),
    [anon_sym_This] = ACTIONS(3707),
    [anon_sym_decltype] = ACTIONS(3707),
    [anon_sym_explicit] = ACTIONS(3707),
    [anon_sym_typename] = ACTIONS(3707),
    [anon_sym_template] = ACTIONS(3707),
    [anon_sym_operator] = ACTIONS(3707),
    [anon_sym_try] = ACTIONS(3707),
    [anon_sym_delete] = ACTIONS(3707),
    [anon_sym_throw] = ACTIONS(3707),
    [anon_sym_namespace] = ACTIONS(3707),
    [anon_sym_static_assert] = ACTIONS(3707),
    [anon_sym_concept] = ACTIONS(3707),
    [anon_sym_co_return] = ACTIONS(3707),
    [anon_sym_co_yield] = ACTIONS(3707),
    [anon_sym_R_DQUOTE] = ACTIONS(3709),
    [anon_sym_LR_DQUOTE] = ACTIONS(3709),
    [anon_sym_uR_DQUOTE] = ACTIONS(3709),
    [anon_sym_UR_DQUOTE] = ACTIONS(3709),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3709),
    [anon_sym_co_await] = ACTIONS(3707),
    [anon_sym_new] = ACTIONS(3707),
    [anon_sym_requires] = ACTIONS(3707),
    [sym_this] = ACTIONS(3707),
    [anon_sym_discard] = ACTIONS(3707),
    [anon_sym_precise] = ACTIONS(3707),
    [anon_sym_shared] = ACTIONS(3707),
    [anon_sym_groupshared] = ACTIONS(3707),
    [anon_sym_uniform] = ACTIONS(3707),
    [anon_sym_row_major] = ACTIONS(3707),
    [anon_sym_column_major] = ACTIONS(3707),
    [anon_sym_globallycoherent] = ACTIONS(3707),
    [anon_sym_centroid] = ACTIONS(3707),
    [anon_sym_noperspective] = ACTIONS(3707),
    [anon_sym_nointerpolation] = ACTIONS(3707),
    [anon_sym_sample] = ACTIONS(3707),
    [anon_sym_linear] = ACTIONS(3707),
    [anon_sym_snorm] = ACTIONS(3707),
    [anon_sym_unorm] = ACTIONS(3707),
    [anon_sym_point] = ACTIONS(3707),
    [anon_sym_line] = ACTIONS(3707),
    [anon_sym_triangleadj] = ACTIONS(3707),
    [anon_sym_lineadj] = ACTIONS(3707),
    [anon_sym_triangle] = ACTIONS(3707),
    [anon_sym_cbuffer] = ACTIONS(3707),
    [anon_sym_interface] = ACTIONS(3707),
    [anon_sym_extension] = ACTIONS(3707),
  },
  [906] = {
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_include_token1] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_BANG] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3812),
    [anon_sym_PLUS] = ACTIONS(3812),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym___cdecl] = ACTIONS(3812),
    [anon_sym___clrcall] = ACTIONS(3812),
    [anon_sym___stdcall] = ACTIONS(3812),
    [anon_sym___fastcall] = ACTIONS(3812),
    [anon_sym___thiscall] = ACTIONS(3812),
    [anon_sym___vectorcall] = ACTIONS(3812),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_RBRACE] = ACTIONS(3814),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [anon_sym_if] = ACTIONS(3812),
    [anon_sym_switch] = ACTIONS(3812),
    [anon_sym_case] = ACTIONS(3812),
    [anon_sym_default] = ACTIONS(3812),
    [anon_sym_while] = ACTIONS(3812),
    [anon_sym_do] = ACTIONS(3812),
    [anon_sym_for] = ACTIONS(3812),
    [anon_sym_return] = ACTIONS(3812),
    [anon_sym_break] = ACTIONS(3812),
    [anon_sym_continue] = ACTIONS(3812),
    [anon_sym_goto] = ACTIONS(3812),
    [anon_sym___try] = ACTIONS(3812),
    [anon_sym___leave] = ACTIONS(3812),
    [anon_sym_not] = ACTIONS(3812),
    [anon_sym_compl] = ACTIONS(3812),
    [anon_sym_DASH_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_PLUS] = ACTIONS(3814),
    [anon_sym_sizeof] = ACTIONS(3812),
    [anon_sym___alignof__] = ACTIONS(3812),
    [anon_sym___alignof] = ACTIONS(3812),
    [anon_sym__alignof] = ACTIONS(3812),
    [anon_sym_alignof] = ACTIONS(3812),
    [anon_sym__Alignof] = ACTIONS(3812),
    [anon_sym_offsetof] = ACTIONS(3812),
    [anon_sym__Generic] = ACTIONS(3812),
    [anon_sym_asm] = ACTIONS(3812),
    [anon_sym___asm__] = ACTIONS(3812),
    [anon_sym___asm] = ACTIONS(3812),
    [sym_number_literal] = ACTIONS(3814),
    [anon_sym_L_SQUOTE] = ACTIONS(3814),
    [anon_sym_u_SQUOTE] = ACTIONS(3814),
    [anon_sym_U_SQUOTE] = ACTIONS(3814),
    [anon_sym_u8_SQUOTE] = ACTIONS(3814),
    [anon_sym_SQUOTE] = ACTIONS(3814),
    [anon_sym_L_DQUOTE] = ACTIONS(3814),
    [anon_sym_u_DQUOTE] = ACTIONS(3814),
    [anon_sym_U_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [anon_sym_NULL] = ACTIONS(3812),
    [anon_sym_nullptr] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_try] = ACTIONS(3812),
    [anon_sym_delete] = ACTIONS(3812),
    [anon_sym_throw] = ACTIONS(3812),
    [anon_sym_namespace] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_concept] = ACTIONS(3812),
    [anon_sym_co_return] = ACTIONS(3812),
    [anon_sym_co_yield] = ACTIONS(3812),
    [anon_sym_R_DQUOTE] = ACTIONS(3814),
    [anon_sym_LR_DQUOTE] = ACTIONS(3814),
    [anon_sym_uR_DQUOTE] = ACTIONS(3814),
    [anon_sym_UR_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3814),
    [anon_sym_co_await] = ACTIONS(3812),
    [anon_sym_new] = ACTIONS(3812),
    [anon_sym_requires] = ACTIONS(3812),
    [sym_this] = ACTIONS(3812),
    [anon_sym_discard] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_cbuffer] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
  },
  [907] = {
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_include_token1] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_BANG] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3812),
    [anon_sym_PLUS] = ACTIONS(3812),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym___cdecl] = ACTIONS(3812),
    [anon_sym___clrcall] = ACTIONS(3812),
    [anon_sym___stdcall] = ACTIONS(3812),
    [anon_sym___fastcall] = ACTIONS(3812),
    [anon_sym___thiscall] = ACTIONS(3812),
    [anon_sym___vectorcall] = ACTIONS(3812),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_RBRACE] = ACTIONS(3814),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [anon_sym_if] = ACTIONS(3812),
    [anon_sym_switch] = ACTIONS(3812),
    [anon_sym_case] = ACTIONS(3812),
    [anon_sym_default] = ACTIONS(3812),
    [anon_sym_while] = ACTIONS(3812),
    [anon_sym_do] = ACTIONS(3812),
    [anon_sym_for] = ACTIONS(3812),
    [anon_sym_return] = ACTIONS(3812),
    [anon_sym_break] = ACTIONS(3812),
    [anon_sym_continue] = ACTIONS(3812),
    [anon_sym_goto] = ACTIONS(3812),
    [anon_sym___try] = ACTIONS(3812),
    [anon_sym___leave] = ACTIONS(3812),
    [anon_sym_not] = ACTIONS(3812),
    [anon_sym_compl] = ACTIONS(3812),
    [anon_sym_DASH_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_PLUS] = ACTIONS(3814),
    [anon_sym_sizeof] = ACTIONS(3812),
    [anon_sym___alignof__] = ACTIONS(3812),
    [anon_sym___alignof] = ACTIONS(3812),
    [anon_sym__alignof] = ACTIONS(3812),
    [anon_sym_alignof] = ACTIONS(3812),
    [anon_sym__Alignof] = ACTIONS(3812),
    [anon_sym_offsetof] = ACTIONS(3812),
    [anon_sym__Generic] = ACTIONS(3812),
    [anon_sym_asm] = ACTIONS(3812),
    [anon_sym___asm__] = ACTIONS(3812),
    [anon_sym___asm] = ACTIONS(3812),
    [sym_number_literal] = ACTIONS(3814),
    [anon_sym_L_SQUOTE] = ACTIONS(3814),
    [anon_sym_u_SQUOTE] = ACTIONS(3814),
    [anon_sym_U_SQUOTE] = ACTIONS(3814),
    [anon_sym_u8_SQUOTE] = ACTIONS(3814),
    [anon_sym_SQUOTE] = ACTIONS(3814),
    [anon_sym_L_DQUOTE] = ACTIONS(3814),
    [anon_sym_u_DQUOTE] = ACTIONS(3814),
    [anon_sym_U_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [anon_sym_NULL] = ACTIONS(3812),
    [anon_sym_nullptr] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_try] = ACTIONS(3812),
    [anon_sym_delete] = ACTIONS(3812),
    [anon_sym_throw] = ACTIONS(3812),
    [anon_sym_namespace] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_concept] = ACTIONS(3812),
    [anon_sym_co_return] = ACTIONS(3812),
    [anon_sym_co_yield] = ACTIONS(3812),
    [anon_sym_R_DQUOTE] = ACTIONS(3814),
    [anon_sym_LR_DQUOTE] = ACTIONS(3814),
    [anon_sym_uR_DQUOTE] = ACTIONS(3814),
    [anon_sym_UR_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3814),
    [anon_sym_co_await] = ACTIONS(3812),
    [anon_sym_new] = ACTIONS(3812),
    [anon_sym_requires] = ACTIONS(3812),
    [sym_this] = ACTIONS(3812),
    [anon_sym_discard] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_cbuffer] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
  },
  [908] = {
    [sym_identifier] = ACTIONS(3816),
    [aux_sym_preproc_include_token1] = ACTIONS(3816),
    [aux_sym_preproc_def_token1] = ACTIONS(3816),
    [aux_sym_preproc_if_token1] = ACTIONS(3816),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3816),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3816),
    [sym_preproc_directive] = ACTIONS(3816),
    [anon_sym_LPAREN2] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3818),
    [anon_sym_TILDE] = ACTIONS(3818),
    [anon_sym_DASH] = ACTIONS(3816),
    [anon_sym_PLUS] = ACTIONS(3816),
    [anon_sym_STAR] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_SEMI] = ACTIONS(3818),
    [anon_sym___extension__] = ACTIONS(3816),
    [anon_sym_typedef] = ACTIONS(3816),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_out] = ACTIONS(3816),
    [anon_sym_inout] = ACTIONS(3816),
    [anon_sym_virtual] = ACTIONS(3816),
    [anon_sym_extern] = ACTIONS(3816),
    [anon_sym___attribute__] = ACTIONS(3816),
    [anon_sym___attribute] = ACTIONS(3816),
    [anon_sym_using] = ACTIONS(3816),
    [anon_sym_COLON_COLON] = ACTIONS(3818),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3818),
    [anon_sym___declspec] = ACTIONS(3816),
    [anon_sym___based] = ACTIONS(3816),
    [anon_sym___cdecl] = ACTIONS(3816),
    [anon_sym___clrcall] = ACTIONS(3816),
    [anon_sym___stdcall] = ACTIONS(3816),
    [anon_sym___fastcall] = ACTIONS(3816),
    [anon_sym___thiscall] = ACTIONS(3816),
    [anon_sym___vectorcall] = ACTIONS(3816),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_RBRACE] = ACTIONS(3818),
    [anon_sym_signed] = ACTIONS(3816),
    [anon_sym_unsigned] = ACTIONS(3816),
    [anon_sym_long] = ACTIONS(3816),
    [anon_sym_short] = ACTIONS(3816),
    [anon_sym_LBRACK] = ACTIONS(3816),
    [anon_sym_static] = ACTIONS(3816),
    [anon_sym_register] = ACTIONS(3816),
    [anon_sym_inline] = ACTIONS(3816),
    [anon_sym___inline] = ACTIONS(3816),
    [anon_sym___inline__] = ACTIONS(3816),
    [anon_sym___forceinline] = ACTIONS(3816),
    [anon_sym_thread_local] = ACTIONS(3816),
    [anon_sym___thread] = ACTIONS(3816),
    [anon_sym_const] = ACTIONS(3816),
    [anon_sym_constexpr] = ACTIONS(3816),
    [anon_sym_volatile] = ACTIONS(3816),
    [anon_sym_restrict] = ACTIONS(3816),
    [anon_sym___restrict__] = ACTIONS(3816),
    [anon_sym__Atomic] = ACTIONS(3816),
    [anon_sym__Noreturn] = ACTIONS(3816),
    [anon_sym_noreturn] = ACTIONS(3816),
    [anon_sym__Nonnull] = ACTIONS(3816),
    [anon_sym_mutable] = ACTIONS(3816),
    [anon_sym_constinit] = ACTIONS(3816),
    [anon_sym_consteval] = ACTIONS(3816),
    [anon_sym_alignas] = ACTIONS(3816),
    [anon_sym__Alignas] = ACTIONS(3816),
    [sym_primitive_type] = ACTIONS(3816),
    [anon_sym_enum] = ACTIONS(3816),
    [anon_sym_class] = ACTIONS(3816),
    [anon_sym_struct] = ACTIONS(3816),
    [anon_sym_union] = ACTIONS(3816),
    [anon_sym_if] = ACTIONS(3816),
    [anon_sym_switch] = ACTIONS(3816),
    [anon_sym_case] = ACTIONS(3816),
    [anon_sym_default] = ACTIONS(3816),
    [anon_sym_while] = ACTIONS(3816),
    [anon_sym_do] = ACTIONS(3816),
    [anon_sym_for] = ACTIONS(3816),
    [anon_sym_return] = ACTIONS(3816),
    [anon_sym_break] = ACTIONS(3816),
    [anon_sym_continue] = ACTIONS(3816),
    [anon_sym_goto] = ACTIONS(3816),
    [anon_sym___try] = ACTIONS(3816),
    [anon_sym___leave] = ACTIONS(3816),
    [anon_sym_not] = ACTIONS(3816),
    [anon_sym_compl] = ACTIONS(3816),
    [anon_sym_DASH_DASH] = ACTIONS(3818),
    [anon_sym_PLUS_PLUS] = ACTIONS(3818),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3816),
    [anon_sym___alignof] = ACTIONS(3816),
    [anon_sym__alignof] = ACTIONS(3816),
    [anon_sym_alignof] = ACTIONS(3816),
    [anon_sym__Alignof] = ACTIONS(3816),
    [anon_sym_offsetof] = ACTIONS(3816),
    [anon_sym__Generic] = ACTIONS(3816),
    [anon_sym_asm] = ACTIONS(3816),
    [anon_sym___asm__] = ACTIONS(3816),
    [anon_sym___asm] = ACTIONS(3816),
    [sym_number_literal] = ACTIONS(3818),
    [anon_sym_L_SQUOTE] = ACTIONS(3818),
    [anon_sym_u_SQUOTE] = ACTIONS(3818),
    [anon_sym_U_SQUOTE] = ACTIONS(3818),
    [anon_sym_u8_SQUOTE] = ACTIONS(3818),
    [anon_sym_SQUOTE] = ACTIONS(3818),
    [anon_sym_L_DQUOTE] = ACTIONS(3818),
    [anon_sym_u_DQUOTE] = ACTIONS(3818),
    [anon_sym_U_DQUOTE] = ACTIONS(3818),
    [anon_sym_u8_DQUOTE] = ACTIONS(3818),
    [anon_sym_DQUOTE] = ACTIONS(3818),
    [sym_true] = ACTIONS(3816),
    [sym_false] = ACTIONS(3816),
    [anon_sym_NULL] = ACTIONS(3816),
    [anon_sym_nullptr] = ACTIONS(3816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3816),
    [anon_sym_let] = ACTIONS(3816),
    [anon_sym_This] = ACTIONS(3816),
    [anon_sym_decltype] = ACTIONS(3816),
    [anon_sym_explicit] = ACTIONS(3816),
    [anon_sym_typename] = ACTIONS(3816),
    [anon_sym_template] = ACTIONS(3816),
    [anon_sym_operator] = ACTIONS(3816),
    [anon_sym_try] = ACTIONS(3816),
    [anon_sym_delete] = ACTIONS(3816),
    [anon_sym_throw] = ACTIONS(3816),
    [anon_sym_namespace] = ACTIONS(3816),
    [anon_sym_static_assert] = ACTIONS(3816),
    [anon_sym_concept] = ACTIONS(3816),
    [anon_sym_co_return] = ACTIONS(3816),
    [anon_sym_co_yield] = ACTIONS(3816),
    [anon_sym_R_DQUOTE] = ACTIONS(3818),
    [anon_sym_LR_DQUOTE] = ACTIONS(3818),
    [anon_sym_uR_DQUOTE] = ACTIONS(3818),
    [anon_sym_UR_DQUOTE] = ACTIONS(3818),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3818),
    [anon_sym_co_await] = ACTIONS(3816),
    [anon_sym_new] = ACTIONS(3816),
    [anon_sym_requires] = ACTIONS(3816),
    [sym_this] = ACTIONS(3816),
    [anon_sym_discard] = ACTIONS(3816),
    [anon_sym_precise] = ACTIONS(3816),
    [anon_sym_shared] = ACTIONS(3816),
    [anon_sym_groupshared] = ACTIONS(3816),
    [anon_sym_uniform] = ACTIONS(3816),
    [anon_sym_row_major] = ACTIONS(3816),
    [anon_sym_column_major] = ACTIONS(3816),
    [anon_sym_globallycoherent] = ACTIONS(3816),
    [anon_sym_centroid] = ACTIONS(3816),
    [anon_sym_noperspective] = ACTIONS(3816),
    [anon_sym_nointerpolation] = ACTIONS(3816),
    [anon_sym_sample] = ACTIONS(3816),
    [anon_sym_linear] = ACTIONS(3816),
    [anon_sym_snorm] = ACTIONS(3816),
    [anon_sym_unorm] = ACTIONS(3816),
    [anon_sym_point] = ACTIONS(3816),
    [anon_sym_line] = ACTIONS(3816),
    [anon_sym_triangleadj] = ACTIONS(3816),
    [anon_sym_lineadj] = ACTIONS(3816),
    [anon_sym_triangle] = ACTIONS(3816),
    [anon_sym_cbuffer] = ACTIONS(3816),
    [anon_sym_interface] = ACTIONS(3816),
    [anon_sym_extension] = ACTIONS(3816),
  },
  [909] = {
    [sym_identifier] = ACTIONS(3711),
    [aux_sym_preproc_include_token1] = ACTIONS(3711),
    [aux_sym_preproc_def_token1] = ACTIONS(3711),
    [aux_sym_preproc_if_token1] = ACTIONS(3711),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3711),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3711),
    [sym_preproc_directive] = ACTIONS(3711),
    [anon_sym_LPAREN2] = ACTIONS(3713),
    [anon_sym_BANG] = ACTIONS(3713),
    [anon_sym_TILDE] = ACTIONS(3713),
    [anon_sym_DASH] = ACTIONS(3711),
    [anon_sym_PLUS] = ACTIONS(3711),
    [anon_sym_STAR] = ACTIONS(3713),
    [anon_sym_AMP_AMP] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(3711),
    [anon_sym_SEMI] = ACTIONS(3713),
    [anon_sym___extension__] = ACTIONS(3711),
    [anon_sym_typedef] = ACTIONS(3711),
    [anon_sym_in] = ACTIONS(3711),
    [anon_sym_out] = ACTIONS(3711),
    [anon_sym_inout] = ACTIONS(3711),
    [anon_sym_virtual] = ACTIONS(3711),
    [anon_sym_extern] = ACTIONS(3711),
    [anon_sym___attribute__] = ACTIONS(3711),
    [anon_sym___attribute] = ACTIONS(3711),
    [anon_sym_using] = ACTIONS(3711),
    [anon_sym_COLON_COLON] = ACTIONS(3713),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3713),
    [anon_sym___declspec] = ACTIONS(3711),
    [anon_sym___based] = ACTIONS(3711),
    [anon_sym___cdecl] = ACTIONS(3711),
    [anon_sym___clrcall] = ACTIONS(3711),
    [anon_sym___stdcall] = ACTIONS(3711),
    [anon_sym___fastcall] = ACTIONS(3711),
    [anon_sym___thiscall] = ACTIONS(3711),
    [anon_sym___vectorcall] = ACTIONS(3711),
    [anon_sym_LBRACE] = ACTIONS(3713),
    [anon_sym_RBRACE] = ACTIONS(3713),
    [anon_sym_signed] = ACTIONS(3711),
    [anon_sym_unsigned] = ACTIONS(3711),
    [anon_sym_long] = ACTIONS(3711),
    [anon_sym_short] = ACTIONS(3711),
    [anon_sym_LBRACK] = ACTIONS(3711),
    [anon_sym_static] = ACTIONS(3711),
    [anon_sym_register] = ACTIONS(3711),
    [anon_sym_inline] = ACTIONS(3711),
    [anon_sym___inline] = ACTIONS(3711),
    [anon_sym___inline__] = ACTIONS(3711),
    [anon_sym___forceinline] = ACTIONS(3711),
    [anon_sym_thread_local] = ACTIONS(3711),
    [anon_sym___thread] = ACTIONS(3711),
    [anon_sym_const] = ACTIONS(3711),
    [anon_sym_constexpr] = ACTIONS(3711),
    [anon_sym_volatile] = ACTIONS(3711),
    [anon_sym_restrict] = ACTIONS(3711),
    [anon_sym___restrict__] = ACTIONS(3711),
    [anon_sym__Atomic] = ACTIONS(3711),
    [anon_sym__Noreturn] = ACTIONS(3711),
    [anon_sym_noreturn] = ACTIONS(3711),
    [anon_sym__Nonnull] = ACTIONS(3711),
    [anon_sym_mutable] = ACTIONS(3711),
    [anon_sym_constinit] = ACTIONS(3711),
    [anon_sym_consteval] = ACTIONS(3711),
    [anon_sym_alignas] = ACTIONS(3711),
    [anon_sym__Alignas] = ACTIONS(3711),
    [sym_primitive_type] = ACTIONS(3711),
    [anon_sym_enum] = ACTIONS(3711),
    [anon_sym_class] = ACTIONS(3711),
    [anon_sym_struct] = ACTIONS(3711),
    [anon_sym_union] = ACTIONS(3711),
    [anon_sym_if] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3711),
    [anon_sym_case] = ACTIONS(3711),
    [anon_sym_default] = ACTIONS(3711),
    [anon_sym_while] = ACTIONS(3711),
    [anon_sym_do] = ACTIONS(3711),
    [anon_sym_for] = ACTIONS(3711),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_break] = ACTIONS(3711),
    [anon_sym_continue] = ACTIONS(3711),
    [anon_sym_goto] = ACTIONS(3711),
    [anon_sym___try] = ACTIONS(3711),
    [anon_sym___leave] = ACTIONS(3711),
    [anon_sym_not] = ACTIONS(3711),
    [anon_sym_compl] = ACTIONS(3711),
    [anon_sym_DASH_DASH] = ACTIONS(3713),
    [anon_sym_PLUS_PLUS] = ACTIONS(3713),
    [anon_sym_sizeof] = ACTIONS(3711),
    [anon_sym___alignof__] = ACTIONS(3711),
    [anon_sym___alignof] = ACTIONS(3711),
    [anon_sym__alignof] = ACTIONS(3711),
    [anon_sym_alignof] = ACTIONS(3711),
    [anon_sym__Alignof] = ACTIONS(3711),
    [anon_sym_offsetof] = ACTIONS(3711),
    [anon_sym__Generic] = ACTIONS(3711),
    [anon_sym_asm] = ACTIONS(3711),
    [anon_sym___asm__] = ACTIONS(3711),
    [anon_sym___asm] = ACTIONS(3711),
    [sym_number_literal] = ACTIONS(3713),
    [anon_sym_L_SQUOTE] = ACTIONS(3713),
    [anon_sym_u_SQUOTE] = ACTIONS(3713),
    [anon_sym_U_SQUOTE] = ACTIONS(3713),
    [anon_sym_u8_SQUOTE] = ACTIONS(3713),
    [anon_sym_SQUOTE] = ACTIONS(3713),
    [anon_sym_L_DQUOTE] = ACTIONS(3713),
    [anon_sym_u_DQUOTE] = ACTIONS(3713),
    [anon_sym_U_DQUOTE] = ACTIONS(3713),
    [anon_sym_u8_DQUOTE] = ACTIONS(3713),
    [anon_sym_DQUOTE] = ACTIONS(3713),
    [sym_true] = ACTIONS(3711),
    [sym_false] = ACTIONS(3711),
    [anon_sym_NULL] = ACTIONS(3711),
    [anon_sym_nullptr] = ACTIONS(3711),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_This] = ACTIONS(3711),
    [anon_sym_decltype] = ACTIONS(3711),
    [anon_sym_explicit] = ACTIONS(3711),
    [anon_sym_typename] = ACTIONS(3711),
    [anon_sym_template] = ACTIONS(3711),
    [anon_sym_operator] = ACTIONS(3711),
    [anon_sym_try] = ACTIONS(3711),
    [anon_sym_delete] = ACTIONS(3711),
    [anon_sym_throw] = ACTIONS(3711),
    [anon_sym_namespace] = ACTIONS(3711),
    [anon_sym_static_assert] = ACTIONS(3711),
    [anon_sym_concept] = ACTIONS(3711),
    [anon_sym_co_return] = ACTIONS(3711),
    [anon_sym_co_yield] = ACTIONS(3711),
    [anon_sym_R_DQUOTE] = ACTIONS(3713),
    [anon_sym_LR_DQUOTE] = ACTIONS(3713),
    [anon_sym_uR_DQUOTE] = ACTIONS(3713),
    [anon_sym_UR_DQUOTE] = ACTIONS(3713),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3713),
    [anon_sym_co_await] = ACTIONS(3711),
    [anon_sym_new] = ACTIONS(3711),
    [anon_sym_requires] = ACTIONS(3711),
    [sym_this] = ACTIONS(3711),
    [anon_sym_discard] = ACTIONS(3711),
    [anon_sym_precise] = ACTIONS(3711),
    [anon_sym_shared] = ACTIONS(3711),
    [anon_sym_groupshared] = ACTIONS(3711),
    [anon_sym_uniform] = ACTIONS(3711),
    [anon_sym_row_major] = ACTIONS(3711),
    [anon_sym_column_major] = ACTIONS(3711),
    [anon_sym_globallycoherent] = ACTIONS(3711),
    [anon_sym_centroid] = ACTIONS(3711),
    [anon_sym_noperspective] = ACTIONS(3711),
    [anon_sym_nointerpolation] = ACTIONS(3711),
    [anon_sym_sample] = ACTIONS(3711),
    [anon_sym_linear] = ACTIONS(3711),
    [anon_sym_snorm] = ACTIONS(3711),
    [anon_sym_unorm] = ACTIONS(3711),
    [anon_sym_point] = ACTIONS(3711),
    [anon_sym_line] = ACTIONS(3711),
    [anon_sym_triangleadj] = ACTIONS(3711),
    [anon_sym_lineadj] = ACTIONS(3711),
    [anon_sym_triangle] = ACTIONS(3711),
    [anon_sym_cbuffer] = ACTIONS(3711),
    [anon_sym_interface] = ACTIONS(3711),
    [anon_sym_extension] = ACTIONS(3711),
  },
  [910] = {
    [sym_identifier] = ACTIONS(3808),
    [aux_sym_preproc_include_token1] = ACTIONS(3808),
    [aux_sym_preproc_def_token1] = ACTIONS(3808),
    [aux_sym_preproc_if_token1] = ACTIONS(3808),
    [aux_sym_preproc_if_token2] = ACTIONS(3808),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3808),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3808),
    [sym_preproc_directive] = ACTIONS(3808),
    [anon_sym_LPAREN2] = ACTIONS(3810),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [anon_sym_DASH] = ACTIONS(3808),
    [anon_sym_PLUS] = ACTIONS(3808),
    [anon_sym_STAR] = ACTIONS(3810),
    [anon_sym_AMP_AMP] = ACTIONS(3810),
    [anon_sym_AMP] = ACTIONS(3808),
    [anon_sym_SEMI] = ACTIONS(3810),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_typedef] = ACTIONS(3808),
    [anon_sym_in] = ACTIONS(3808),
    [anon_sym_out] = ACTIONS(3808),
    [anon_sym_inout] = ACTIONS(3808),
    [anon_sym_virtual] = ACTIONS(3808),
    [anon_sym_extern] = ACTIONS(3808),
    [anon_sym___attribute__] = ACTIONS(3808),
    [anon_sym___attribute] = ACTIONS(3808),
    [anon_sym_using] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3810),
    [anon_sym___declspec] = ACTIONS(3808),
    [anon_sym___based] = ACTIONS(3808),
    [anon_sym___cdecl] = ACTIONS(3808),
    [anon_sym___clrcall] = ACTIONS(3808),
    [anon_sym___stdcall] = ACTIONS(3808),
    [anon_sym___fastcall] = ACTIONS(3808),
    [anon_sym___thiscall] = ACTIONS(3808),
    [anon_sym___vectorcall] = ACTIONS(3808),
    [anon_sym_LBRACE] = ACTIONS(3810),
    [anon_sym_signed] = ACTIONS(3808),
    [anon_sym_unsigned] = ACTIONS(3808),
    [anon_sym_long] = ACTIONS(3808),
    [anon_sym_short] = ACTIONS(3808),
    [anon_sym_LBRACK] = ACTIONS(3808),
    [anon_sym_static] = ACTIONS(3808),
    [anon_sym_register] = ACTIONS(3808),
    [anon_sym_inline] = ACTIONS(3808),
    [anon_sym___inline] = ACTIONS(3808),
    [anon_sym___inline__] = ACTIONS(3808),
    [anon_sym___forceinline] = ACTIONS(3808),
    [anon_sym_thread_local] = ACTIONS(3808),
    [anon_sym___thread] = ACTIONS(3808),
    [anon_sym_const] = ACTIONS(3808),
    [anon_sym_constexpr] = ACTIONS(3808),
    [anon_sym_volatile] = ACTIONS(3808),
    [anon_sym_restrict] = ACTIONS(3808),
    [anon_sym___restrict__] = ACTIONS(3808),
    [anon_sym__Atomic] = ACTIONS(3808),
    [anon_sym__Noreturn] = ACTIONS(3808),
    [anon_sym_noreturn] = ACTIONS(3808),
    [anon_sym__Nonnull] = ACTIONS(3808),
    [anon_sym_mutable] = ACTIONS(3808),
    [anon_sym_constinit] = ACTIONS(3808),
    [anon_sym_consteval] = ACTIONS(3808),
    [anon_sym_alignas] = ACTIONS(3808),
    [anon_sym__Alignas] = ACTIONS(3808),
    [sym_primitive_type] = ACTIONS(3808),
    [anon_sym_enum] = ACTIONS(3808),
    [anon_sym_class] = ACTIONS(3808),
    [anon_sym_struct] = ACTIONS(3808),
    [anon_sym_union] = ACTIONS(3808),
    [anon_sym_if] = ACTIONS(3808),
    [anon_sym_switch] = ACTIONS(3808),
    [anon_sym_case] = ACTIONS(3808),
    [anon_sym_default] = ACTIONS(3808),
    [anon_sym_while] = ACTIONS(3808),
    [anon_sym_do] = ACTIONS(3808),
    [anon_sym_for] = ACTIONS(3808),
    [anon_sym_return] = ACTIONS(3808),
    [anon_sym_break] = ACTIONS(3808),
    [anon_sym_continue] = ACTIONS(3808),
    [anon_sym_goto] = ACTIONS(3808),
    [anon_sym___try] = ACTIONS(3808),
    [anon_sym___leave] = ACTIONS(3808),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_compl] = ACTIONS(3808),
    [anon_sym_DASH_DASH] = ACTIONS(3810),
    [anon_sym_PLUS_PLUS] = ACTIONS(3810),
    [anon_sym_sizeof] = ACTIONS(3808),
    [anon_sym___alignof__] = ACTIONS(3808),
    [anon_sym___alignof] = ACTIONS(3808),
    [anon_sym__alignof] = ACTIONS(3808),
    [anon_sym_alignof] = ACTIONS(3808),
    [anon_sym__Alignof] = ACTIONS(3808),
    [anon_sym_offsetof] = ACTIONS(3808),
    [anon_sym__Generic] = ACTIONS(3808),
    [anon_sym_asm] = ACTIONS(3808),
    [anon_sym___asm__] = ACTIONS(3808),
    [anon_sym___asm] = ACTIONS(3808),
    [sym_number_literal] = ACTIONS(3810),
    [anon_sym_L_SQUOTE] = ACTIONS(3810),
    [anon_sym_u_SQUOTE] = ACTIONS(3810),
    [anon_sym_U_SQUOTE] = ACTIONS(3810),
    [anon_sym_u8_SQUOTE] = ACTIONS(3810),
    [anon_sym_SQUOTE] = ACTIONS(3810),
    [anon_sym_L_DQUOTE] = ACTIONS(3810),
    [anon_sym_u_DQUOTE] = ACTIONS(3810),
    [anon_sym_U_DQUOTE] = ACTIONS(3810),
    [anon_sym_u8_DQUOTE] = ACTIONS(3810),
    [anon_sym_DQUOTE] = ACTIONS(3810),
    [sym_true] = ACTIONS(3808),
    [sym_false] = ACTIONS(3808),
    [anon_sym_NULL] = ACTIONS(3808),
    [anon_sym_nullptr] = ACTIONS(3808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3808),
    [anon_sym_let] = ACTIONS(3808),
    [anon_sym_This] = ACTIONS(3808),
    [anon_sym_decltype] = ACTIONS(3808),
    [anon_sym_explicit] = ACTIONS(3808),
    [anon_sym_typename] = ACTIONS(3808),
    [anon_sym_template] = ACTIONS(3808),
    [anon_sym_operator] = ACTIONS(3808),
    [anon_sym_try] = ACTIONS(3808),
    [anon_sym_delete] = ACTIONS(3808),
    [anon_sym_throw] = ACTIONS(3808),
    [anon_sym_namespace] = ACTIONS(3808),
    [anon_sym_static_assert] = ACTIONS(3808),
    [anon_sym_concept] = ACTIONS(3808),
    [anon_sym_co_return] = ACTIONS(3808),
    [anon_sym_co_yield] = ACTIONS(3808),
    [anon_sym_R_DQUOTE] = ACTIONS(3810),
    [anon_sym_LR_DQUOTE] = ACTIONS(3810),
    [anon_sym_uR_DQUOTE] = ACTIONS(3810),
    [anon_sym_UR_DQUOTE] = ACTIONS(3810),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3810),
    [anon_sym_co_await] = ACTIONS(3808),
    [anon_sym_new] = ACTIONS(3808),
    [anon_sym_requires] = ACTIONS(3808),
    [sym_this] = ACTIONS(3808),
    [anon_sym_discard] = ACTIONS(3808),
    [anon_sym_precise] = ACTIONS(3808),
    [anon_sym_shared] = ACTIONS(3808),
    [anon_sym_groupshared] = ACTIONS(3808),
    [anon_sym_uniform] = ACTIONS(3808),
    [anon_sym_row_major] = ACTIONS(3808),
    [anon_sym_column_major] = ACTIONS(3808),
    [anon_sym_globallycoherent] = ACTIONS(3808),
    [anon_sym_centroid] = ACTIONS(3808),
    [anon_sym_noperspective] = ACTIONS(3808),
    [anon_sym_nointerpolation] = ACTIONS(3808),
    [anon_sym_sample] = ACTIONS(3808),
    [anon_sym_linear] = ACTIONS(3808),
    [anon_sym_snorm] = ACTIONS(3808),
    [anon_sym_unorm] = ACTIONS(3808),
    [anon_sym_point] = ACTIONS(3808),
    [anon_sym_line] = ACTIONS(3808),
    [anon_sym_triangleadj] = ACTIONS(3808),
    [anon_sym_lineadj] = ACTIONS(3808),
    [anon_sym_triangle] = ACTIONS(3808),
    [anon_sym_cbuffer] = ACTIONS(3808),
    [anon_sym_interface] = ACTIONS(3808),
    [anon_sym_extension] = ACTIONS(3808),
  },
  [911] = {
    [sym_identifier] = ACTIONS(3715),
    [aux_sym_preproc_include_token1] = ACTIONS(3715),
    [aux_sym_preproc_def_token1] = ACTIONS(3715),
    [aux_sym_preproc_if_token1] = ACTIONS(3715),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3715),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3715),
    [sym_preproc_directive] = ACTIONS(3715),
    [anon_sym_LPAREN2] = ACTIONS(3717),
    [anon_sym_BANG] = ACTIONS(3717),
    [anon_sym_TILDE] = ACTIONS(3717),
    [anon_sym_DASH] = ACTIONS(3715),
    [anon_sym_PLUS] = ACTIONS(3715),
    [anon_sym_STAR] = ACTIONS(3717),
    [anon_sym_AMP_AMP] = ACTIONS(3717),
    [anon_sym_AMP] = ACTIONS(3715),
    [anon_sym_SEMI] = ACTIONS(3717),
    [anon_sym___extension__] = ACTIONS(3715),
    [anon_sym_typedef] = ACTIONS(3715),
    [anon_sym_in] = ACTIONS(3715),
    [anon_sym_out] = ACTIONS(3715),
    [anon_sym_inout] = ACTIONS(3715),
    [anon_sym_virtual] = ACTIONS(3715),
    [anon_sym_extern] = ACTIONS(3715),
    [anon_sym___attribute__] = ACTIONS(3715),
    [anon_sym___attribute] = ACTIONS(3715),
    [anon_sym_using] = ACTIONS(3715),
    [anon_sym_COLON_COLON] = ACTIONS(3717),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3717),
    [anon_sym___declspec] = ACTIONS(3715),
    [anon_sym___based] = ACTIONS(3715),
    [anon_sym___cdecl] = ACTIONS(3715),
    [anon_sym___clrcall] = ACTIONS(3715),
    [anon_sym___stdcall] = ACTIONS(3715),
    [anon_sym___fastcall] = ACTIONS(3715),
    [anon_sym___thiscall] = ACTIONS(3715),
    [anon_sym___vectorcall] = ACTIONS(3715),
    [anon_sym_LBRACE] = ACTIONS(3717),
    [anon_sym_RBRACE] = ACTIONS(3717),
    [anon_sym_signed] = ACTIONS(3715),
    [anon_sym_unsigned] = ACTIONS(3715),
    [anon_sym_long] = ACTIONS(3715),
    [anon_sym_short] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_static] = ACTIONS(3715),
    [anon_sym_register] = ACTIONS(3715),
    [anon_sym_inline] = ACTIONS(3715),
    [anon_sym___inline] = ACTIONS(3715),
    [anon_sym___inline__] = ACTIONS(3715),
    [anon_sym___forceinline] = ACTIONS(3715),
    [anon_sym_thread_local] = ACTIONS(3715),
    [anon_sym___thread] = ACTIONS(3715),
    [anon_sym_const] = ACTIONS(3715),
    [anon_sym_constexpr] = ACTIONS(3715),
    [anon_sym_volatile] = ACTIONS(3715),
    [anon_sym_restrict] = ACTIONS(3715),
    [anon_sym___restrict__] = ACTIONS(3715),
    [anon_sym__Atomic] = ACTIONS(3715),
    [anon_sym__Noreturn] = ACTIONS(3715),
    [anon_sym_noreturn] = ACTIONS(3715),
    [anon_sym__Nonnull] = ACTIONS(3715),
    [anon_sym_mutable] = ACTIONS(3715),
    [anon_sym_constinit] = ACTIONS(3715),
    [anon_sym_consteval] = ACTIONS(3715),
    [anon_sym_alignas] = ACTIONS(3715),
    [anon_sym__Alignas] = ACTIONS(3715),
    [sym_primitive_type] = ACTIONS(3715),
    [anon_sym_enum] = ACTIONS(3715),
    [anon_sym_class] = ACTIONS(3715),
    [anon_sym_struct] = ACTIONS(3715),
    [anon_sym_union] = ACTIONS(3715),
    [anon_sym_if] = ACTIONS(3715),
    [anon_sym_switch] = ACTIONS(3715),
    [anon_sym_case] = ACTIONS(3715),
    [anon_sym_default] = ACTIONS(3715),
    [anon_sym_while] = ACTIONS(3715),
    [anon_sym_do] = ACTIONS(3715),
    [anon_sym_for] = ACTIONS(3715),
    [anon_sym_return] = ACTIONS(3715),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_continue] = ACTIONS(3715),
    [anon_sym_goto] = ACTIONS(3715),
    [anon_sym___try] = ACTIONS(3715),
    [anon_sym___leave] = ACTIONS(3715),
    [anon_sym_not] = ACTIONS(3715),
    [anon_sym_compl] = ACTIONS(3715),
    [anon_sym_DASH_DASH] = ACTIONS(3717),
    [anon_sym_PLUS_PLUS] = ACTIONS(3717),
    [anon_sym_sizeof] = ACTIONS(3715),
    [anon_sym___alignof__] = ACTIONS(3715),
    [anon_sym___alignof] = ACTIONS(3715),
    [anon_sym__alignof] = ACTIONS(3715),
    [anon_sym_alignof] = ACTIONS(3715),
    [anon_sym__Alignof] = ACTIONS(3715),
    [anon_sym_offsetof] = ACTIONS(3715),
    [anon_sym__Generic] = ACTIONS(3715),
    [anon_sym_asm] = ACTIONS(3715),
    [anon_sym___asm__] = ACTIONS(3715),
    [anon_sym___asm] = ACTIONS(3715),
    [sym_number_literal] = ACTIONS(3717),
    [anon_sym_L_SQUOTE] = ACTIONS(3717),
    [anon_sym_u_SQUOTE] = ACTIONS(3717),
    [anon_sym_U_SQUOTE] = ACTIONS(3717),
    [anon_sym_u8_SQUOTE] = ACTIONS(3717),
    [anon_sym_SQUOTE] = ACTIONS(3717),
    [anon_sym_L_DQUOTE] = ACTIONS(3717),
    [anon_sym_u_DQUOTE] = ACTIONS(3717),
    [anon_sym_U_DQUOTE] = ACTIONS(3717),
    [anon_sym_u8_DQUOTE] = ACTIONS(3717),
    [anon_sym_DQUOTE] = ACTIONS(3717),
    [sym_true] = ACTIONS(3715),
    [sym_false] = ACTIONS(3715),
    [anon_sym_NULL] = ACTIONS(3715),
    [anon_sym_nullptr] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3715),
    [anon_sym_let] = ACTIONS(3715),
    [anon_sym_This] = ACTIONS(3715),
    [anon_sym_decltype] = ACTIONS(3715),
    [anon_sym_explicit] = ACTIONS(3715),
    [anon_sym_typename] = ACTIONS(3715),
    [anon_sym_template] = ACTIONS(3715),
    [anon_sym_operator] = ACTIONS(3715),
    [anon_sym_try] = ACTIONS(3715),
    [anon_sym_delete] = ACTIONS(3715),
    [anon_sym_throw] = ACTIONS(3715),
    [anon_sym_namespace] = ACTIONS(3715),
    [anon_sym_static_assert] = ACTIONS(3715),
    [anon_sym_concept] = ACTIONS(3715),
    [anon_sym_co_return] = ACTIONS(3715),
    [anon_sym_co_yield] = ACTIONS(3715),
    [anon_sym_R_DQUOTE] = ACTIONS(3717),
    [anon_sym_LR_DQUOTE] = ACTIONS(3717),
    [anon_sym_uR_DQUOTE] = ACTIONS(3717),
    [anon_sym_UR_DQUOTE] = ACTIONS(3717),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3717),
    [anon_sym_co_await] = ACTIONS(3715),
    [anon_sym_new] = ACTIONS(3715),
    [anon_sym_requires] = ACTIONS(3715),
    [sym_this] = ACTIONS(3715),
    [anon_sym_discard] = ACTIONS(3715),
    [anon_sym_precise] = ACTIONS(3715),
    [anon_sym_shared] = ACTIONS(3715),
    [anon_sym_groupshared] = ACTIONS(3715),
    [anon_sym_uniform] = ACTIONS(3715),
    [anon_sym_row_major] = ACTIONS(3715),
    [anon_sym_column_major] = ACTIONS(3715),
    [anon_sym_globallycoherent] = ACTIONS(3715),
    [anon_sym_centroid] = ACTIONS(3715),
    [anon_sym_noperspective] = ACTIONS(3715),
    [anon_sym_nointerpolation] = ACTIONS(3715),
    [anon_sym_sample] = ACTIONS(3715),
    [anon_sym_linear] = ACTIONS(3715),
    [anon_sym_snorm] = ACTIONS(3715),
    [anon_sym_unorm] = ACTIONS(3715),
    [anon_sym_point] = ACTIONS(3715),
    [anon_sym_line] = ACTIONS(3715),
    [anon_sym_triangleadj] = ACTIONS(3715),
    [anon_sym_lineadj] = ACTIONS(3715),
    [anon_sym_triangle] = ACTIONS(3715),
    [anon_sym_cbuffer] = ACTIONS(3715),
    [anon_sym_interface] = ACTIONS(3715),
    [anon_sym_extension] = ACTIONS(3715),
  },
  [912] = {
    [sym_identifier] = ACTIONS(3820),
    [aux_sym_preproc_include_token1] = ACTIONS(3820),
    [aux_sym_preproc_def_token1] = ACTIONS(3820),
    [aux_sym_preproc_if_token1] = ACTIONS(3820),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3820),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3820),
    [sym_preproc_directive] = ACTIONS(3820),
    [anon_sym_LPAREN2] = ACTIONS(3822),
    [anon_sym_BANG] = ACTIONS(3822),
    [anon_sym_TILDE] = ACTIONS(3822),
    [anon_sym_DASH] = ACTIONS(3820),
    [anon_sym_PLUS] = ACTIONS(3820),
    [anon_sym_STAR] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3822),
    [anon_sym_AMP] = ACTIONS(3820),
    [anon_sym_SEMI] = ACTIONS(3822),
    [anon_sym___extension__] = ACTIONS(3820),
    [anon_sym_typedef] = ACTIONS(3820),
    [anon_sym_in] = ACTIONS(3820),
    [anon_sym_out] = ACTIONS(3820),
    [anon_sym_inout] = ACTIONS(3820),
    [anon_sym_virtual] = ACTIONS(3820),
    [anon_sym_extern] = ACTIONS(3820),
    [anon_sym___attribute__] = ACTIONS(3820),
    [anon_sym___attribute] = ACTIONS(3820),
    [anon_sym_using] = ACTIONS(3820),
    [anon_sym_COLON_COLON] = ACTIONS(3822),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3822),
    [anon_sym___declspec] = ACTIONS(3820),
    [anon_sym___based] = ACTIONS(3820),
    [anon_sym___cdecl] = ACTIONS(3820),
    [anon_sym___clrcall] = ACTIONS(3820),
    [anon_sym___stdcall] = ACTIONS(3820),
    [anon_sym___fastcall] = ACTIONS(3820),
    [anon_sym___thiscall] = ACTIONS(3820),
    [anon_sym___vectorcall] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3822),
    [anon_sym_RBRACE] = ACTIONS(3822),
    [anon_sym_signed] = ACTIONS(3820),
    [anon_sym_unsigned] = ACTIONS(3820),
    [anon_sym_long] = ACTIONS(3820),
    [anon_sym_short] = ACTIONS(3820),
    [anon_sym_LBRACK] = ACTIONS(3820),
    [anon_sym_static] = ACTIONS(3820),
    [anon_sym_register] = ACTIONS(3820),
    [anon_sym_inline] = ACTIONS(3820),
    [anon_sym___inline] = ACTIONS(3820),
    [anon_sym___inline__] = ACTIONS(3820),
    [anon_sym___forceinline] = ACTIONS(3820),
    [anon_sym_thread_local] = ACTIONS(3820),
    [anon_sym___thread] = ACTIONS(3820),
    [anon_sym_const] = ACTIONS(3820),
    [anon_sym_constexpr] = ACTIONS(3820),
    [anon_sym_volatile] = ACTIONS(3820),
    [anon_sym_restrict] = ACTIONS(3820),
    [anon_sym___restrict__] = ACTIONS(3820),
    [anon_sym__Atomic] = ACTIONS(3820),
    [anon_sym__Noreturn] = ACTIONS(3820),
    [anon_sym_noreturn] = ACTIONS(3820),
    [anon_sym__Nonnull] = ACTIONS(3820),
    [anon_sym_mutable] = ACTIONS(3820),
    [anon_sym_constinit] = ACTIONS(3820),
    [anon_sym_consteval] = ACTIONS(3820),
    [anon_sym_alignas] = ACTIONS(3820),
    [anon_sym__Alignas] = ACTIONS(3820),
    [sym_primitive_type] = ACTIONS(3820),
    [anon_sym_enum] = ACTIONS(3820),
    [anon_sym_class] = ACTIONS(3820),
    [anon_sym_struct] = ACTIONS(3820),
    [anon_sym_union] = ACTIONS(3820),
    [anon_sym_if] = ACTIONS(3820),
    [anon_sym_switch] = ACTIONS(3820),
    [anon_sym_case] = ACTIONS(3820),
    [anon_sym_default] = ACTIONS(3820),
    [anon_sym_while] = ACTIONS(3820),
    [anon_sym_do] = ACTIONS(3820),
    [anon_sym_for] = ACTIONS(3820),
    [anon_sym_return] = ACTIONS(3820),
    [anon_sym_break] = ACTIONS(3820),
    [anon_sym_continue] = ACTIONS(3820),
    [anon_sym_goto] = ACTIONS(3820),
    [anon_sym___try] = ACTIONS(3820),
    [anon_sym___leave] = ACTIONS(3820),
    [anon_sym_not] = ACTIONS(3820),
    [anon_sym_compl] = ACTIONS(3820),
    [anon_sym_DASH_DASH] = ACTIONS(3822),
    [anon_sym_PLUS_PLUS] = ACTIONS(3822),
    [anon_sym_sizeof] = ACTIONS(3820),
    [anon_sym___alignof__] = ACTIONS(3820),
    [anon_sym___alignof] = ACTIONS(3820),
    [anon_sym__alignof] = ACTIONS(3820),
    [anon_sym_alignof] = ACTIONS(3820),
    [anon_sym__Alignof] = ACTIONS(3820),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3820),
    [anon_sym_asm] = ACTIONS(3820),
    [anon_sym___asm__] = ACTIONS(3820),
    [anon_sym___asm] = ACTIONS(3820),
    [sym_number_literal] = ACTIONS(3822),
    [anon_sym_L_SQUOTE] = ACTIONS(3822),
    [anon_sym_u_SQUOTE] = ACTIONS(3822),
    [anon_sym_U_SQUOTE] = ACTIONS(3822),
    [anon_sym_u8_SQUOTE] = ACTIONS(3822),
    [anon_sym_SQUOTE] = ACTIONS(3822),
    [anon_sym_L_DQUOTE] = ACTIONS(3822),
    [anon_sym_u_DQUOTE] = ACTIONS(3822),
    [anon_sym_U_DQUOTE] = ACTIONS(3822),
    [anon_sym_u8_DQUOTE] = ACTIONS(3822),
    [anon_sym_DQUOTE] = ACTIONS(3822),
    [sym_true] = ACTIONS(3820),
    [sym_false] = ACTIONS(3820),
    [anon_sym_NULL] = ACTIONS(3820),
    [anon_sym_nullptr] = ACTIONS(3820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3820),
    [anon_sym_let] = ACTIONS(3820),
    [anon_sym_This] = ACTIONS(3820),
    [anon_sym_decltype] = ACTIONS(3820),
    [anon_sym_explicit] = ACTIONS(3820),
    [anon_sym_typename] = ACTIONS(3820),
    [anon_sym_template] = ACTIONS(3820),
    [anon_sym_operator] = ACTIONS(3820),
    [anon_sym_try] = ACTIONS(3820),
    [anon_sym_delete] = ACTIONS(3820),
    [anon_sym_throw] = ACTIONS(3820),
    [anon_sym_namespace] = ACTIONS(3820),
    [anon_sym_static_assert] = ACTIONS(3820),
    [anon_sym_concept] = ACTIONS(3820),
    [anon_sym_co_return] = ACTIONS(3820),
    [anon_sym_co_yield] = ACTIONS(3820),
    [anon_sym_R_DQUOTE] = ACTIONS(3822),
    [anon_sym_LR_DQUOTE] = ACTIONS(3822),
    [anon_sym_uR_DQUOTE] = ACTIONS(3822),
    [anon_sym_UR_DQUOTE] = ACTIONS(3822),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3822),
    [anon_sym_co_await] = ACTIONS(3820),
    [anon_sym_new] = ACTIONS(3820),
    [anon_sym_requires] = ACTIONS(3820),
    [sym_this] = ACTIONS(3820),
    [anon_sym_discard] = ACTIONS(3820),
    [anon_sym_precise] = ACTIONS(3820),
    [anon_sym_shared] = ACTIONS(3820),
    [anon_sym_groupshared] = ACTIONS(3820),
    [anon_sym_uniform] = ACTIONS(3820),
    [anon_sym_row_major] = ACTIONS(3820),
    [anon_sym_column_major] = ACTIONS(3820),
    [anon_sym_globallycoherent] = ACTIONS(3820),
    [anon_sym_centroid] = ACTIONS(3820),
    [anon_sym_noperspective] = ACTIONS(3820),
    [anon_sym_nointerpolation] = ACTIONS(3820),
    [anon_sym_sample] = ACTIONS(3820),
    [anon_sym_linear] = ACTIONS(3820),
    [anon_sym_snorm] = ACTIONS(3820),
    [anon_sym_unorm] = ACTIONS(3820),
    [anon_sym_point] = ACTIONS(3820),
    [anon_sym_line] = ACTIONS(3820),
    [anon_sym_triangleadj] = ACTIONS(3820),
    [anon_sym_lineadj] = ACTIONS(3820),
    [anon_sym_triangle] = ACTIONS(3820),
    [anon_sym_cbuffer] = ACTIONS(3820),
    [anon_sym_interface] = ACTIONS(3820),
    [anon_sym_extension] = ACTIONS(3820),
  },
  [913] = {
    [sym_identifier] = ACTIONS(3824),
    [aux_sym_preproc_include_token1] = ACTIONS(3824),
    [aux_sym_preproc_def_token1] = ACTIONS(3824),
    [aux_sym_preproc_if_token1] = ACTIONS(3824),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3824),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3824),
    [sym_preproc_directive] = ACTIONS(3824),
    [anon_sym_LPAREN2] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3826),
    [anon_sym_TILDE] = ACTIONS(3826),
    [anon_sym_DASH] = ACTIONS(3824),
    [anon_sym_PLUS] = ACTIONS(3824),
    [anon_sym_STAR] = ACTIONS(3826),
    [anon_sym_AMP_AMP] = ACTIONS(3826),
    [anon_sym_AMP] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(3826),
    [anon_sym___extension__] = ACTIONS(3824),
    [anon_sym_typedef] = ACTIONS(3824),
    [anon_sym_in] = ACTIONS(3824),
    [anon_sym_out] = ACTIONS(3824),
    [anon_sym_inout] = ACTIONS(3824),
    [anon_sym_virtual] = ACTIONS(3824),
    [anon_sym_extern] = ACTIONS(3824),
    [anon_sym___attribute__] = ACTIONS(3824),
    [anon_sym___attribute] = ACTIONS(3824),
    [anon_sym_using] = ACTIONS(3824),
    [anon_sym_COLON_COLON] = ACTIONS(3826),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3826),
    [anon_sym___declspec] = ACTIONS(3824),
    [anon_sym___based] = ACTIONS(3824),
    [anon_sym___cdecl] = ACTIONS(3824),
    [anon_sym___clrcall] = ACTIONS(3824),
    [anon_sym___stdcall] = ACTIONS(3824),
    [anon_sym___fastcall] = ACTIONS(3824),
    [anon_sym___thiscall] = ACTIONS(3824),
    [anon_sym___vectorcall] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(3826),
    [anon_sym_RBRACE] = ACTIONS(3826),
    [anon_sym_signed] = ACTIONS(3824),
    [anon_sym_unsigned] = ACTIONS(3824),
    [anon_sym_long] = ACTIONS(3824),
    [anon_sym_short] = ACTIONS(3824),
    [anon_sym_LBRACK] = ACTIONS(3824),
    [anon_sym_static] = ACTIONS(3824),
    [anon_sym_register] = ACTIONS(3824),
    [anon_sym_inline] = ACTIONS(3824),
    [anon_sym___inline] = ACTIONS(3824),
    [anon_sym___inline__] = ACTIONS(3824),
    [anon_sym___forceinline] = ACTIONS(3824),
    [anon_sym_thread_local] = ACTIONS(3824),
    [anon_sym___thread] = ACTIONS(3824),
    [anon_sym_const] = ACTIONS(3824),
    [anon_sym_constexpr] = ACTIONS(3824),
    [anon_sym_volatile] = ACTIONS(3824),
    [anon_sym_restrict] = ACTIONS(3824),
    [anon_sym___restrict__] = ACTIONS(3824),
    [anon_sym__Atomic] = ACTIONS(3824),
    [anon_sym__Noreturn] = ACTIONS(3824),
    [anon_sym_noreturn] = ACTIONS(3824),
    [anon_sym__Nonnull] = ACTIONS(3824),
    [anon_sym_mutable] = ACTIONS(3824),
    [anon_sym_constinit] = ACTIONS(3824),
    [anon_sym_consteval] = ACTIONS(3824),
    [anon_sym_alignas] = ACTIONS(3824),
    [anon_sym__Alignas] = ACTIONS(3824),
    [sym_primitive_type] = ACTIONS(3824),
    [anon_sym_enum] = ACTIONS(3824),
    [anon_sym_class] = ACTIONS(3824),
    [anon_sym_struct] = ACTIONS(3824),
    [anon_sym_union] = ACTIONS(3824),
    [anon_sym_if] = ACTIONS(3824),
    [anon_sym_switch] = ACTIONS(3824),
    [anon_sym_case] = ACTIONS(3824),
    [anon_sym_default] = ACTIONS(3824),
    [anon_sym_while] = ACTIONS(3824),
    [anon_sym_do] = ACTIONS(3824),
    [anon_sym_for] = ACTIONS(3824),
    [anon_sym_return] = ACTIONS(3824),
    [anon_sym_break] = ACTIONS(3824),
    [anon_sym_continue] = ACTIONS(3824),
    [anon_sym_goto] = ACTIONS(3824),
    [anon_sym___try] = ACTIONS(3824),
    [anon_sym___leave] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3824),
    [anon_sym_compl] = ACTIONS(3824),
    [anon_sym_DASH_DASH] = ACTIONS(3826),
    [anon_sym_PLUS_PLUS] = ACTIONS(3826),
    [anon_sym_sizeof] = ACTIONS(3824),
    [anon_sym___alignof__] = ACTIONS(3824),
    [anon_sym___alignof] = ACTIONS(3824),
    [anon_sym__alignof] = ACTIONS(3824),
    [anon_sym_alignof] = ACTIONS(3824),
    [anon_sym__Alignof] = ACTIONS(3824),
    [anon_sym_offsetof] = ACTIONS(3824),
    [anon_sym__Generic] = ACTIONS(3824),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3826),
    [anon_sym_u_SQUOTE] = ACTIONS(3826),
    [anon_sym_U_SQUOTE] = ACTIONS(3826),
    [anon_sym_u8_SQUOTE] = ACTIONS(3826),
    [anon_sym_SQUOTE] = ACTIONS(3826),
    [anon_sym_L_DQUOTE] = ACTIONS(3826),
    [anon_sym_u_DQUOTE] = ACTIONS(3826),
    [anon_sym_U_DQUOTE] = ACTIONS(3826),
    [anon_sym_u8_DQUOTE] = ACTIONS(3826),
    [anon_sym_DQUOTE] = ACTIONS(3826),
    [sym_true] = ACTIONS(3824),
    [sym_false] = ACTIONS(3824),
    [anon_sym_NULL] = ACTIONS(3824),
    [anon_sym_nullptr] = ACTIONS(3824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3824),
    [anon_sym_let] = ACTIONS(3824),
    [anon_sym_This] = ACTIONS(3824),
    [anon_sym_decltype] = ACTIONS(3824),
    [anon_sym_explicit] = ACTIONS(3824),
    [anon_sym_typename] = ACTIONS(3824),
    [anon_sym_template] = ACTIONS(3824),
    [anon_sym_operator] = ACTIONS(3824),
    [anon_sym_try] = ACTIONS(3824),
    [anon_sym_delete] = ACTIONS(3824),
    [anon_sym_throw] = ACTIONS(3824),
    [anon_sym_namespace] = ACTIONS(3824),
    [anon_sym_static_assert] = ACTIONS(3824),
    [anon_sym_concept] = ACTIONS(3824),
    [anon_sym_co_return] = ACTIONS(3824),
    [anon_sym_co_yield] = ACTIONS(3824),
    [anon_sym_R_DQUOTE] = ACTIONS(3826),
    [anon_sym_LR_DQUOTE] = ACTIONS(3826),
    [anon_sym_uR_DQUOTE] = ACTIONS(3826),
    [anon_sym_UR_DQUOTE] = ACTIONS(3826),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3826),
    [anon_sym_co_await] = ACTIONS(3824),
    [anon_sym_new] = ACTIONS(3824),
    [anon_sym_requires] = ACTIONS(3824),
    [sym_this] = ACTIONS(3824),
    [anon_sym_discard] = ACTIONS(3824),
    [anon_sym_precise] = ACTIONS(3824),
    [anon_sym_shared] = ACTIONS(3824),
    [anon_sym_groupshared] = ACTIONS(3824),
    [anon_sym_uniform] = ACTIONS(3824),
    [anon_sym_row_major] = ACTIONS(3824),
    [anon_sym_column_major] = ACTIONS(3824),
    [anon_sym_globallycoherent] = ACTIONS(3824),
    [anon_sym_centroid] = ACTIONS(3824),
    [anon_sym_noperspective] = ACTIONS(3824),
    [anon_sym_nointerpolation] = ACTIONS(3824),
    [anon_sym_sample] = ACTIONS(3824),
    [anon_sym_linear] = ACTIONS(3824),
    [anon_sym_snorm] = ACTIONS(3824),
    [anon_sym_unorm] = ACTIONS(3824),
    [anon_sym_point] = ACTIONS(3824),
    [anon_sym_line] = ACTIONS(3824),
    [anon_sym_triangleadj] = ACTIONS(3824),
    [anon_sym_lineadj] = ACTIONS(3824),
    [anon_sym_triangle] = ACTIONS(3824),
    [anon_sym_cbuffer] = ACTIONS(3824),
    [anon_sym_interface] = ACTIONS(3824),
    [anon_sym_extension] = ACTIONS(3824),
  },
  [914] = {
    [sym_identifier] = ACTIONS(3832),
    [aux_sym_preproc_include_token1] = ACTIONS(3832),
    [aux_sym_preproc_def_token1] = ACTIONS(3832),
    [aux_sym_preproc_if_token1] = ACTIONS(3832),
    [aux_sym_preproc_if_token2] = ACTIONS(3832),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3832),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3832),
    [sym_preproc_directive] = ACTIONS(3832),
    [anon_sym_LPAREN2] = ACTIONS(3834),
    [anon_sym_BANG] = ACTIONS(3834),
    [anon_sym_TILDE] = ACTIONS(3834),
    [anon_sym_DASH] = ACTIONS(3832),
    [anon_sym_PLUS] = ACTIONS(3832),
    [anon_sym_STAR] = ACTIONS(3834),
    [anon_sym_AMP_AMP] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3834),
    [anon_sym___extension__] = ACTIONS(3832),
    [anon_sym_typedef] = ACTIONS(3832),
    [anon_sym_in] = ACTIONS(3832),
    [anon_sym_out] = ACTIONS(3832),
    [anon_sym_inout] = ACTIONS(3832),
    [anon_sym_virtual] = ACTIONS(3832),
    [anon_sym_extern] = ACTIONS(3832),
    [anon_sym___attribute__] = ACTIONS(3832),
    [anon_sym___attribute] = ACTIONS(3832),
    [anon_sym_using] = ACTIONS(3832),
    [anon_sym_COLON_COLON] = ACTIONS(3834),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3834),
    [anon_sym___declspec] = ACTIONS(3832),
    [anon_sym___based] = ACTIONS(3832),
    [anon_sym___cdecl] = ACTIONS(3832),
    [anon_sym___clrcall] = ACTIONS(3832),
    [anon_sym___stdcall] = ACTIONS(3832),
    [anon_sym___fastcall] = ACTIONS(3832),
    [anon_sym___thiscall] = ACTIONS(3832),
    [anon_sym___vectorcall] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_signed] = ACTIONS(3832),
    [anon_sym_unsigned] = ACTIONS(3832),
    [anon_sym_long] = ACTIONS(3832),
    [anon_sym_short] = ACTIONS(3832),
    [anon_sym_LBRACK] = ACTIONS(3832),
    [anon_sym_static] = ACTIONS(3832),
    [anon_sym_register] = ACTIONS(3832),
    [anon_sym_inline] = ACTIONS(3832),
    [anon_sym___inline] = ACTIONS(3832),
    [anon_sym___inline__] = ACTIONS(3832),
    [anon_sym___forceinline] = ACTIONS(3832),
    [anon_sym_thread_local] = ACTIONS(3832),
    [anon_sym___thread] = ACTIONS(3832),
    [anon_sym_const] = ACTIONS(3832),
    [anon_sym_constexpr] = ACTIONS(3832),
    [anon_sym_volatile] = ACTIONS(3832),
    [anon_sym_restrict] = ACTIONS(3832),
    [anon_sym___restrict__] = ACTIONS(3832),
    [anon_sym__Atomic] = ACTIONS(3832),
    [anon_sym__Noreturn] = ACTIONS(3832),
    [anon_sym_noreturn] = ACTIONS(3832),
    [anon_sym__Nonnull] = ACTIONS(3832),
    [anon_sym_mutable] = ACTIONS(3832),
    [anon_sym_constinit] = ACTIONS(3832),
    [anon_sym_consteval] = ACTIONS(3832),
    [anon_sym_alignas] = ACTIONS(3832),
    [anon_sym__Alignas] = ACTIONS(3832),
    [sym_primitive_type] = ACTIONS(3832),
    [anon_sym_enum] = ACTIONS(3832),
    [anon_sym_class] = ACTIONS(3832),
    [anon_sym_struct] = ACTIONS(3832),
    [anon_sym_union] = ACTIONS(3832),
    [anon_sym_if] = ACTIONS(3832),
    [anon_sym_switch] = ACTIONS(3832),
    [anon_sym_case] = ACTIONS(3832),
    [anon_sym_default] = ACTIONS(3832),
    [anon_sym_while] = ACTIONS(3832),
    [anon_sym_do] = ACTIONS(3832),
    [anon_sym_for] = ACTIONS(3832),
    [anon_sym_return] = ACTIONS(3832),
    [anon_sym_break] = ACTIONS(3832),
    [anon_sym_continue] = ACTIONS(3832),
    [anon_sym_goto] = ACTIONS(3832),
    [anon_sym___try] = ACTIONS(3832),
    [anon_sym___leave] = ACTIONS(3832),
    [anon_sym_not] = ACTIONS(3832),
    [anon_sym_compl] = ACTIONS(3832),
    [anon_sym_DASH_DASH] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(3834),
    [anon_sym_sizeof] = ACTIONS(3832),
    [anon_sym___alignof__] = ACTIONS(3832),
    [anon_sym___alignof] = ACTIONS(3832),
    [anon_sym__alignof] = ACTIONS(3832),
    [anon_sym_alignof] = ACTIONS(3832),
    [anon_sym__Alignof] = ACTIONS(3832),
    [anon_sym_offsetof] = ACTIONS(3832),
    [anon_sym__Generic] = ACTIONS(3832),
    [anon_sym_asm] = ACTIONS(3832),
    [anon_sym___asm__] = ACTIONS(3832),
    [anon_sym___asm] = ACTIONS(3832),
    [sym_number_literal] = ACTIONS(3834),
    [anon_sym_L_SQUOTE] = ACTIONS(3834),
    [anon_sym_u_SQUOTE] = ACTIONS(3834),
    [anon_sym_U_SQUOTE] = ACTIONS(3834),
    [anon_sym_u8_SQUOTE] = ACTIONS(3834),
    [anon_sym_SQUOTE] = ACTIONS(3834),
    [anon_sym_L_DQUOTE] = ACTIONS(3834),
    [anon_sym_u_DQUOTE] = ACTIONS(3834),
    [anon_sym_U_DQUOTE] = ACTIONS(3834),
    [anon_sym_u8_DQUOTE] = ACTIONS(3834),
    [anon_sym_DQUOTE] = ACTIONS(3834),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3832),
    [anon_sym_nullptr] = ACTIONS(3832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3832),
    [anon_sym_let] = ACTIONS(3832),
    [anon_sym_This] = ACTIONS(3832),
    [anon_sym_decltype] = ACTIONS(3832),
    [anon_sym_explicit] = ACTIONS(3832),
    [anon_sym_typename] = ACTIONS(3832),
    [anon_sym_template] = ACTIONS(3832),
    [anon_sym_operator] = ACTIONS(3832),
    [anon_sym_try] = ACTIONS(3832),
    [anon_sym_delete] = ACTIONS(3832),
    [anon_sym_throw] = ACTIONS(3832),
    [anon_sym_namespace] = ACTIONS(3832),
    [anon_sym_static_assert] = ACTIONS(3832),
    [anon_sym_concept] = ACTIONS(3832),
    [anon_sym_co_return] = ACTIONS(3832),
    [anon_sym_co_yield] = ACTIONS(3832),
    [anon_sym_R_DQUOTE] = ACTIONS(3834),
    [anon_sym_LR_DQUOTE] = ACTIONS(3834),
    [anon_sym_uR_DQUOTE] = ACTIONS(3834),
    [anon_sym_UR_DQUOTE] = ACTIONS(3834),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3834),
    [anon_sym_co_await] = ACTIONS(3832),
    [anon_sym_new] = ACTIONS(3832),
    [anon_sym_requires] = ACTIONS(3832),
    [sym_this] = ACTIONS(3832),
    [anon_sym_discard] = ACTIONS(3832),
    [anon_sym_precise] = ACTIONS(3832),
    [anon_sym_shared] = ACTIONS(3832),
    [anon_sym_groupshared] = ACTIONS(3832),
    [anon_sym_uniform] = ACTIONS(3832),
    [anon_sym_row_major] = ACTIONS(3832),
    [anon_sym_column_major] = ACTIONS(3832),
    [anon_sym_globallycoherent] = ACTIONS(3832),
    [anon_sym_centroid] = ACTIONS(3832),
    [anon_sym_noperspective] = ACTIONS(3832),
    [anon_sym_nointerpolation] = ACTIONS(3832),
    [anon_sym_sample] = ACTIONS(3832),
    [anon_sym_linear] = ACTIONS(3832),
    [anon_sym_snorm] = ACTIONS(3832),
    [anon_sym_unorm] = ACTIONS(3832),
    [anon_sym_point] = ACTIONS(3832),
    [anon_sym_line] = ACTIONS(3832),
    [anon_sym_triangleadj] = ACTIONS(3832),
    [anon_sym_lineadj] = ACTIONS(3832),
    [anon_sym_triangle] = ACTIONS(3832),
    [anon_sym_cbuffer] = ACTIONS(3832),
    [anon_sym_interface] = ACTIONS(3832),
    [anon_sym_extension] = ACTIONS(3832),
  },
  [915] = {
    [sym_identifier] = ACTIONS(3885),
    [aux_sym_preproc_include_token1] = ACTIONS(3885),
    [aux_sym_preproc_def_token1] = ACTIONS(3885),
    [aux_sym_preproc_if_token1] = ACTIONS(3885),
    [aux_sym_preproc_if_token2] = ACTIONS(3885),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3885),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3885),
    [sym_preproc_directive] = ACTIONS(3885),
    [anon_sym_LPAREN2] = ACTIONS(3887),
    [anon_sym_BANG] = ACTIONS(3887),
    [anon_sym_TILDE] = ACTIONS(3887),
    [anon_sym_DASH] = ACTIONS(3885),
    [anon_sym_PLUS] = ACTIONS(3885),
    [anon_sym_STAR] = ACTIONS(3887),
    [anon_sym_AMP_AMP] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3885),
    [anon_sym_SEMI] = ACTIONS(3887),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_typedef] = ACTIONS(3885),
    [anon_sym_in] = ACTIONS(3885),
    [anon_sym_out] = ACTIONS(3885),
    [anon_sym_inout] = ACTIONS(3885),
    [anon_sym_virtual] = ACTIONS(3885),
    [anon_sym_extern] = ACTIONS(3885),
    [anon_sym___attribute__] = ACTIONS(3885),
    [anon_sym___attribute] = ACTIONS(3885),
    [anon_sym_using] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3887),
    [anon_sym___declspec] = ACTIONS(3885),
    [anon_sym___based] = ACTIONS(3885),
    [anon_sym___cdecl] = ACTIONS(3885),
    [anon_sym___clrcall] = ACTIONS(3885),
    [anon_sym___stdcall] = ACTIONS(3885),
    [anon_sym___fastcall] = ACTIONS(3885),
    [anon_sym___thiscall] = ACTIONS(3885),
    [anon_sym___vectorcall] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_signed] = ACTIONS(3885),
    [anon_sym_unsigned] = ACTIONS(3885),
    [anon_sym_long] = ACTIONS(3885),
    [anon_sym_short] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_static] = ACTIONS(3885),
    [anon_sym_register] = ACTIONS(3885),
    [anon_sym_inline] = ACTIONS(3885),
    [anon_sym___inline] = ACTIONS(3885),
    [anon_sym___inline__] = ACTIONS(3885),
    [anon_sym___forceinline] = ACTIONS(3885),
    [anon_sym_thread_local] = ACTIONS(3885),
    [anon_sym___thread] = ACTIONS(3885),
    [anon_sym_const] = ACTIONS(3885),
    [anon_sym_constexpr] = ACTIONS(3885),
    [anon_sym_volatile] = ACTIONS(3885),
    [anon_sym_restrict] = ACTIONS(3885),
    [anon_sym___restrict__] = ACTIONS(3885),
    [anon_sym__Atomic] = ACTIONS(3885),
    [anon_sym__Noreturn] = ACTIONS(3885),
    [anon_sym_noreturn] = ACTIONS(3885),
    [anon_sym__Nonnull] = ACTIONS(3885),
    [anon_sym_mutable] = ACTIONS(3885),
    [anon_sym_constinit] = ACTIONS(3885),
    [anon_sym_consteval] = ACTIONS(3885),
    [anon_sym_alignas] = ACTIONS(3885),
    [anon_sym__Alignas] = ACTIONS(3885),
    [sym_primitive_type] = ACTIONS(3885),
    [anon_sym_enum] = ACTIONS(3885),
    [anon_sym_class] = ACTIONS(3885),
    [anon_sym_struct] = ACTIONS(3885),
    [anon_sym_union] = ACTIONS(3885),
    [anon_sym_if] = ACTIONS(3885),
    [anon_sym_switch] = ACTIONS(3885),
    [anon_sym_case] = ACTIONS(3885),
    [anon_sym_default] = ACTIONS(3885),
    [anon_sym_while] = ACTIONS(3885),
    [anon_sym_do] = ACTIONS(3885),
    [anon_sym_for] = ACTIONS(3885),
    [anon_sym_return] = ACTIONS(3885),
    [anon_sym_break] = ACTIONS(3885),
    [anon_sym_continue] = ACTIONS(3885),
    [anon_sym_goto] = ACTIONS(3885),
    [anon_sym___try] = ACTIONS(3885),
    [anon_sym___leave] = ACTIONS(3885),
    [anon_sym_not] = ACTIONS(3885),
    [anon_sym_compl] = ACTIONS(3885),
    [anon_sym_DASH_DASH] = ACTIONS(3887),
    [anon_sym_PLUS_PLUS] = ACTIONS(3887),
    [anon_sym_sizeof] = ACTIONS(3885),
    [anon_sym___alignof__] = ACTIONS(3885),
    [anon_sym___alignof] = ACTIONS(3885),
    [anon_sym__alignof] = ACTIONS(3885),
    [anon_sym_alignof] = ACTIONS(3885),
    [anon_sym__Alignof] = ACTIONS(3885),
    [anon_sym_offsetof] = ACTIONS(3885),
    [anon_sym__Generic] = ACTIONS(3885),
    [anon_sym_asm] = ACTIONS(3885),
    [anon_sym___asm__] = ACTIONS(3885),
    [anon_sym___asm] = ACTIONS(3885),
    [sym_number_literal] = ACTIONS(3887),
    [anon_sym_L_SQUOTE] = ACTIONS(3887),
    [anon_sym_u_SQUOTE] = ACTIONS(3887),
    [anon_sym_U_SQUOTE] = ACTIONS(3887),
    [anon_sym_u8_SQUOTE] = ACTIONS(3887),
    [anon_sym_SQUOTE] = ACTIONS(3887),
    [anon_sym_L_DQUOTE] = ACTIONS(3887),
    [anon_sym_u_DQUOTE] = ACTIONS(3887),
    [anon_sym_U_DQUOTE] = ACTIONS(3887),
    [anon_sym_u8_DQUOTE] = ACTIONS(3887),
    [anon_sym_DQUOTE] = ACTIONS(3887),
    [sym_true] = ACTIONS(3885),
    [sym_false] = ACTIONS(3885),
    [anon_sym_NULL] = ACTIONS(3885),
    [anon_sym_nullptr] = ACTIONS(3885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3885),
    [anon_sym_let] = ACTIONS(3885),
    [anon_sym_This] = ACTIONS(3885),
    [anon_sym_decltype] = ACTIONS(3885),
    [anon_sym_explicit] = ACTIONS(3885),
    [anon_sym_typename] = ACTIONS(3885),
    [anon_sym_template] = ACTIONS(3885),
    [anon_sym_operator] = ACTIONS(3885),
    [anon_sym_try] = ACTIONS(3885),
    [anon_sym_delete] = ACTIONS(3885),
    [anon_sym_throw] = ACTIONS(3885),
    [anon_sym_namespace] = ACTIONS(3885),
    [anon_sym_static_assert] = ACTIONS(3885),
    [anon_sym_concept] = ACTIONS(3885),
    [anon_sym_co_return] = ACTIONS(3885),
    [anon_sym_co_yield] = ACTIONS(3885),
    [anon_sym_R_DQUOTE] = ACTIONS(3887),
    [anon_sym_LR_DQUOTE] = ACTIONS(3887),
    [anon_sym_uR_DQUOTE] = ACTIONS(3887),
    [anon_sym_UR_DQUOTE] = ACTIONS(3887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3887),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3885),
    [anon_sym_requires] = ACTIONS(3885),
    [sym_this] = ACTIONS(3885),
    [anon_sym_discard] = ACTIONS(3885),
    [anon_sym_precise] = ACTIONS(3885),
    [anon_sym_shared] = ACTIONS(3885),
    [anon_sym_groupshared] = ACTIONS(3885),
    [anon_sym_uniform] = ACTIONS(3885),
    [anon_sym_row_major] = ACTIONS(3885),
    [anon_sym_column_major] = ACTIONS(3885),
    [anon_sym_globallycoherent] = ACTIONS(3885),
    [anon_sym_centroid] = ACTIONS(3885),
    [anon_sym_noperspective] = ACTIONS(3885),
    [anon_sym_nointerpolation] = ACTIONS(3885),
    [anon_sym_sample] = ACTIONS(3885),
    [anon_sym_linear] = ACTIONS(3885),
    [anon_sym_snorm] = ACTIONS(3885),
    [anon_sym_unorm] = ACTIONS(3885),
    [anon_sym_point] = ACTIONS(3885),
    [anon_sym_line] = ACTIONS(3885),
    [anon_sym_triangleadj] = ACTIONS(3885),
    [anon_sym_lineadj] = ACTIONS(3885),
    [anon_sym_triangle] = ACTIONS(3885),
    [anon_sym_cbuffer] = ACTIONS(3885),
    [anon_sym_interface] = ACTIONS(3885),
    [anon_sym_extension] = ACTIONS(3885),
  },
  [916] = {
    [sym_identifier] = ACTIONS(3853),
    [aux_sym_preproc_include_token1] = ACTIONS(3853),
    [aux_sym_preproc_def_token1] = ACTIONS(3853),
    [aux_sym_preproc_if_token1] = ACTIONS(3853),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3853),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3853),
    [sym_preproc_directive] = ACTIONS(3853),
    [anon_sym_LPAREN2] = ACTIONS(3855),
    [anon_sym_BANG] = ACTIONS(3855),
    [anon_sym_TILDE] = ACTIONS(3855),
    [anon_sym_DASH] = ACTIONS(3853),
    [anon_sym_PLUS] = ACTIONS(3853),
    [anon_sym_STAR] = ACTIONS(3855),
    [anon_sym_AMP_AMP] = ACTIONS(3855),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_SEMI] = ACTIONS(3855),
    [anon_sym___extension__] = ACTIONS(3853),
    [anon_sym_typedef] = ACTIONS(3853),
    [anon_sym_in] = ACTIONS(3853),
    [anon_sym_out] = ACTIONS(3853),
    [anon_sym_inout] = ACTIONS(3853),
    [anon_sym_virtual] = ACTIONS(3853),
    [anon_sym_extern] = ACTIONS(3853),
    [anon_sym___attribute__] = ACTIONS(3853),
    [anon_sym___attribute] = ACTIONS(3853),
    [anon_sym_using] = ACTIONS(3853),
    [anon_sym_COLON_COLON] = ACTIONS(3855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3855),
    [anon_sym___declspec] = ACTIONS(3853),
    [anon_sym___based] = ACTIONS(3853),
    [anon_sym___cdecl] = ACTIONS(3853),
    [anon_sym___clrcall] = ACTIONS(3853),
    [anon_sym___stdcall] = ACTIONS(3853),
    [anon_sym___fastcall] = ACTIONS(3853),
    [anon_sym___thiscall] = ACTIONS(3853),
    [anon_sym___vectorcall] = ACTIONS(3853),
    [anon_sym_LBRACE] = ACTIONS(3855),
    [anon_sym_RBRACE] = ACTIONS(3855),
    [anon_sym_signed] = ACTIONS(3853),
    [anon_sym_unsigned] = ACTIONS(3853),
    [anon_sym_long] = ACTIONS(3853),
    [anon_sym_short] = ACTIONS(3853),
    [anon_sym_LBRACK] = ACTIONS(3853),
    [anon_sym_static] = ACTIONS(3853),
    [anon_sym_register] = ACTIONS(3853),
    [anon_sym_inline] = ACTIONS(3853),
    [anon_sym___inline] = ACTIONS(3853),
    [anon_sym___inline__] = ACTIONS(3853),
    [anon_sym___forceinline] = ACTIONS(3853),
    [anon_sym_thread_local] = ACTIONS(3853),
    [anon_sym___thread] = ACTIONS(3853),
    [anon_sym_const] = ACTIONS(3853),
    [anon_sym_constexpr] = ACTIONS(3853),
    [anon_sym_volatile] = ACTIONS(3853),
    [anon_sym_restrict] = ACTIONS(3853),
    [anon_sym___restrict__] = ACTIONS(3853),
    [anon_sym__Atomic] = ACTIONS(3853),
    [anon_sym__Noreturn] = ACTIONS(3853),
    [anon_sym_noreturn] = ACTIONS(3853),
    [anon_sym__Nonnull] = ACTIONS(3853),
    [anon_sym_mutable] = ACTIONS(3853),
    [anon_sym_constinit] = ACTIONS(3853),
    [anon_sym_consteval] = ACTIONS(3853),
    [anon_sym_alignas] = ACTIONS(3853),
    [anon_sym__Alignas] = ACTIONS(3853),
    [sym_primitive_type] = ACTIONS(3853),
    [anon_sym_enum] = ACTIONS(3853),
    [anon_sym_class] = ACTIONS(3853),
    [anon_sym_struct] = ACTIONS(3853),
    [anon_sym_union] = ACTIONS(3853),
    [anon_sym_if] = ACTIONS(3853),
    [anon_sym_switch] = ACTIONS(3853),
    [anon_sym_case] = ACTIONS(3853),
    [anon_sym_default] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3853),
    [anon_sym_do] = ACTIONS(3853),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_return] = ACTIONS(3853),
    [anon_sym_break] = ACTIONS(3853),
    [anon_sym_continue] = ACTIONS(3853),
    [anon_sym_goto] = ACTIONS(3853),
    [anon_sym___try] = ACTIONS(3853),
    [anon_sym___leave] = ACTIONS(3853),
    [anon_sym_not] = ACTIONS(3853),
    [anon_sym_compl] = ACTIONS(3853),
    [anon_sym_DASH_DASH] = ACTIONS(3855),
    [anon_sym_PLUS_PLUS] = ACTIONS(3855),
    [anon_sym_sizeof] = ACTIONS(3853),
    [anon_sym___alignof__] = ACTIONS(3853),
    [anon_sym___alignof] = ACTIONS(3853),
    [anon_sym__alignof] = ACTIONS(3853),
    [anon_sym_alignof] = ACTIONS(3853),
    [anon_sym__Alignof] = ACTIONS(3853),
    [anon_sym_offsetof] = ACTIONS(3853),
    [anon_sym__Generic] = ACTIONS(3853),
    [anon_sym_asm] = ACTIONS(3853),
    [anon_sym___asm__] = ACTIONS(3853),
    [anon_sym___asm] = ACTIONS(3853),
    [sym_number_literal] = ACTIONS(3855),
    [anon_sym_L_SQUOTE] = ACTIONS(3855),
    [anon_sym_u_SQUOTE] = ACTIONS(3855),
    [anon_sym_U_SQUOTE] = ACTIONS(3855),
    [anon_sym_u8_SQUOTE] = ACTIONS(3855),
    [anon_sym_SQUOTE] = ACTIONS(3855),
    [anon_sym_L_DQUOTE] = ACTIONS(3855),
    [anon_sym_u_DQUOTE] = ACTIONS(3855),
    [anon_sym_U_DQUOTE] = ACTIONS(3855),
    [anon_sym_u8_DQUOTE] = ACTIONS(3855),
    [anon_sym_DQUOTE] = ACTIONS(3855),
    [sym_true] = ACTIONS(3853),
    [sym_false] = ACTIONS(3853),
    [anon_sym_NULL] = ACTIONS(3853),
    [anon_sym_nullptr] = ACTIONS(3853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3853),
    [anon_sym_let] = ACTIONS(3853),
    [anon_sym_This] = ACTIONS(3853),
    [anon_sym_decltype] = ACTIONS(3853),
    [anon_sym_explicit] = ACTIONS(3853),
    [anon_sym_typename] = ACTIONS(3853),
    [anon_sym_template] = ACTIONS(3853),
    [anon_sym_operator] = ACTIONS(3853),
    [anon_sym_try] = ACTIONS(3853),
    [anon_sym_delete] = ACTIONS(3853),
    [anon_sym_throw] = ACTIONS(3853),
    [anon_sym_namespace] = ACTIONS(3853),
    [anon_sym_static_assert] = ACTIONS(3853),
    [anon_sym_concept] = ACTIONS(3853),
    [anon_sym_co_return] = ACTIONS(3853),
    [anon_sym_co_yield] = ACTIONS(3853),
    [anon_sym_R_DQUOTE] = ACTIONS(3855),
    [anon_sym_LR_DQUOTE] = ACTIONS(3855),
    [anon_sym_uR_DQUOTE] = ACTIONS(3855),
    [anon_sym_UR_DQUOTE] = ACTIONS(3855),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3855),
    [anon_sym_co_await] = ACTIONS(3853),
    [anon_sym_new] = ACTIONS(3853),
    [anon_sym_requires] = ACTIONS(3853),
    [sym_this] = ACTIONS(3853),
    [anon_sym_discard] = ACTIONS(3853),
    [anon_sym_precise] = ACTIONS(3853),
    [anon_sym_shared] = ACTIONS(3853),
    [anon_sym_groupshared] = ACTIONS(3853),
    [anon_sym_uniform] = ACTIONS(3853),
    [anon_sym_row_major] = ACTIONS(3853),
    [anon_sym_column_major] = ACTIONS(3853),
    [anon_sym_globallycoherent] = ACTIONS(3853),
    [anon_sym_centroid] = ACTIONS(3853),
    [anon_sym_noperspective] = ACTIONS(3853),
    [anon_sym_nointerpolation] = ACTIONS(3853),
    [anon_sym_sample] = ACTIONS(3853),
    [anon_sym_linear] = ACTIONS(3853),
    [anon_sym_snorm] = ACTIONS(3853),
    [anon_sym_unorm] = ACTIONS(3853),
    [anon_sym_point] = ACTIONS(3853),
    [anon_sym_line] = ACTIONS(3853),
    [anon_sym_triangleadj] = ACTIONS(3853),
    [anon_sym_lineadj] = ACTIONS(3853),
    [anon_sym_triangle] = ACTIONS(3853),
    [anon_sym_cbuffer] = ACTIONS(3853),
    [anon_sym_interface] = ACTIONS(3853),
    [anon_sym_extension] = ACTIONS(3853),
  },
  [917] = {
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_include_token1] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_BANG] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3812),
    [anon_sym_PLUS] = ACTIONS(3812),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym___cdecl] = ACTIONS(3812),
    [anon_sym___clrcall] = ACTIONS(3812),
    [anon_sym___stdcall] = ACTIONS(3812),
    [anon_sym___fastcall] = ACTIONS(3812),
    [anon_sym___thiscall] = ACTIONS(3812),
    [anon_sym___vectorcall] = ACTIONS(3812),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_RBRACE] = ACTIONS(3814),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [anon_sym_if] = ACTIONS(3812),
    [anon_sym_switch] = ACTIONS(3812),
    [anon_sym_case] = ACTIONS(3812),
    [anon_sym_default] = ACTIONS(3812),
    [anon_sym_while] = ACTIONS(3812),
    [anon_sym_do] = ACTIONS(3812),
    [anon_sym_for] = ACTIONS(3812),
    [anon_sym_return] = ACTIONS(3812),
    [anon_sym_break] = ACTIONS(3812),
    [anon_sym_continue] = ACTIONS(3812),
    [anon_sym_goto] = ACTIONS(3812),
    [anon_sym___try] = ACTIONS(3812),
    [anon_sym___leave] = ACTIONS(3812),
    [anon_sym_not] = ACTIONS(3812),
    [anon_sym_compl] = ACTIONS(3812),
    [anon_sym_DASH_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_PLUS] = ACTIONS(3814),
    [anon_sym_sizeof] = ACTIONS(3812),
    [anon_sym___alignof__] = ACTIONS(3812),
    [anon_sym___alignof] = ACTIONS(3812),
    [anon_sym__alignof] = ACTIONS(3812),
    [anon_sym_alignof] = ACTIONS(3812),
    [anon_sym__Alignof] = ACTIONS(3812),
    [anon_sym_offsetof] = ACTIONS(3812),
    [anon_sym__Generic] = ACTIONS(3812),
    [anon_sym_asm] = ACTIONS(3812),
    [anon_sym___asm__] = ACTIONS(3812),
    [anon_sym___asm] = ACTIONS(3812),
    [sym_number_literal] = ACTIONS(3814),
    [anon_sym_L_SQUOTE] = ACTIONS(3814),
    [anon_sym_u_SQUOTE] = ACTIONS(3814),
    [anon_sym_U_SQUOTE] = ACTIONS(3814),
    [anon_sym_u8_SQUOTE] = ACTIONS(3814),
    [anon_sym_SQUOTE] = ACTIONS(3814),
    [anon_sym_L_DQUOTE] = ACTIONS(3814),
    [anon_sym_u_DQUOTE] = ACTIONS(3814),
    [anon_sym_U_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [anon_sym_NULL] = ACTIONS(3812),
    [anon_sym_nullptr] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_try] = ACTIONS(3812),
    [anon_sym_delete] = ACTIONS(3812),
    [anon_sym_throw] = ACTIONS(3812),
    [anon_sym_namespace] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_concept] = ACTIONS(3812),
    [anon_sym_co_return] = ACTIONS(3812),
    [anon_sym_co_yield] = ACTIONS(3812),
    [anon_sym_R_DQUOTE] = ACTIONS(3814),
    [anon_sym_LR_DQUOTE] = ACTIONS(3814),
    [anon_sym_uR_DQUOTE] = ACTIONS(3814),
    [anon_sym_UR_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3814),
    [anon_sym_co_await] = ACTIONS(3812),
    [anon_sym_new] = ACTIONS(3812),
    [anon_sym_requires] = ACTIONS(3812),
    [sym_this] = ACTIONS(3812),
    [anon_sym_discard] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_cbuffer] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
  },
  [918] = {
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_include_token1] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_BANG] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3812),
    [anon_sym_PLUS] = ACTIONS(3812),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym___cdecl] = ACTIONS(3812),
    [anon_sym___clrcall] = ACTIONS(3812),
    [anon_sym___stdcall] = ACTIONS(3812),
    [anon_sym___fastcall] = ACTIONS(3812),
    [anon_sym___thiscall] = ACTIONS(3812),
    [anon_sym___vectorcall] = ACTIONS(3812),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_RBRACE] = ACTIONS(3814),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [anon_sym_if] = ACTIONS(3812),
    [anon_sym_switch] = ACTIONS(3812),
    [anon_sym_case] = ACTIONS(3812),
    [anon_sym_default] = ACTIONS(3812),
    [anon_sym_while] = ACTIONS(3812),
    [anon_sym_do] = ACTIONS(3812),
    [anon_sym_for] = ACTIONS(3812),
    [anon_sym_return] = ACTIONS(3812),
    [anon_sym_break] = ACTIONS(3812),
    [anon_sym_continue] = ACTIONS(3812),
    [anon_sym_goto] = ACTIONS(3812),
    [anon_sym___try] = ACTIONS(3812),
    [anon_sym___leave] = ACTIONS(3812),
    [anon_sym_not] = ACTIONS(3812),
    [anon_sym_compl] = ACTIONS(3812),
    [anon_sym_DASH_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_PLUS] = ACTIONS(3814),
    [anon_sym_sizeof] = ACTIONS(3812),
    [anon_sym___alignof__] = ACTIONS(3812),
    [anon_sym___alignof] = ACTIONS(3812),
    [anon_sym__alignof] = ACTIONS(3812),
    [anon_sym_alignof] = ACTIONS(3812),
    [anon_sym__Alignof] = ACTIONS(3812),
    [anon_sym_offsetof] = ACTIONS(3812),
    [anon_sym__Generic] = ACTIONS(3812),
    [anon_sym_asm] = ACTIONS(3812),
    [anon_sym___asm__] = ACTIONS(3812),
    [anon_sym___asm] = ACTIONS(3812),
    [sym_number_literal] = ACTIONS(3814),
    [anon_sym_L_SQUOTE] = ACTIONS(3814),
    [anon_sym_u_SQUOTE] = ACTIONS(3814),
    [anon_sym_U_SQUOTE] = ACTIONS(3814),
    [anon_sym_u8_SQUOTE] = ACTIONS(3814),
    [anon_sym_SQUOTE] = ACTIONS(3814),
    [anon_sym_L_DQUOTE] = ACTIONS(3814),
    [anon_sym_u_DQUOTE] = ACTIONS(3814),
    [anon_sym_U_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [anon_sym_NULL] = ACTIONS(3812),
    [anon_sym_nullptr] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_try] = ACTIONS(3812),
    [anon_sym_delete] = ACTIONS(3812),
    [anon_sym_throw] = ACTIONS(3812),
    [anon_sym_namespace] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_concept] = ACTIONS(3812),
    [anon_sym_co_return] = ACTIONS(3812),
    [anon_sym_co_yield] = ACTIONS(3812),
    [anon_sym_R_DQUOTE] = ACTIONS(3814),
    [anon_sym_LR_DQUOTE] = ACTIONS(3814),
    [anon_sym_uR_DQUOTE] = ACTIONS(3814),
    [anon_sym_UR_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3814),
    [anon_sym_co_await] = ACTIONS(3812),
    [anon_sym_new] = ACTIONS(3812),
    [anon_sym_requires] = ACTIONS(3812),
    [sym_this] = ACTIONS(3812),
    [anon_sym_discard] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_cbuffer] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
  },
  [919] = {
    [sym_identifier] = ACTIONS(3857),
    [aux_sym_preproc_include_token1] = ACTIONS(3857),
    [aux_sym_preproc_def_token1] = ACTIONS(3857),
    [aux_sym_preproc_if_token1] = ACTIONS(3857),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3857),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3857),
    [sym_preproc_directive] = ACTIONS(3857),
    [anon_sym_LPAREN2] = ACTIONS(3859),
    [anon_sym_BANG] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3859),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_STAR] = ACTIONS(3859),
    [anon_sym_AMP_AMP] = ACTIONS(3859),
    [anon_sym_AMP] = ACTIONS(3857),
    [anon_sym_SEMI] = ACTIONS(3859),
    [anon_sym___extension__] = ACTIONS(3857),
    [anon_sym_typedef] = ACTIONS(3857),
    [anon_sym_in] = ACTIONS(3857),
    [anon_sym_out] = ACTIONS(3857),
    [anon_sym_inout] = ACTIONS(3857),
    [anon_sym_virtual] = ACTIONS(3857),
    [anon_sym_extern] = ACTIONS(3857),
    [anon_sym___attribute__] = ACTIONS(3857),
    [anon_sym___attribute] = ACTIONS(3857),
    [anon_sym_using] = ACTIONS(3857),
    [anon_sym_COLON_COLON] = ACTIONS(3859),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3859),
    [anon_sym___declspec] = ACTIONS(3857),
    [anon_sym___based] = ACTIONS(3857),
    [anon_sym___cdecl] = ACTIONS(3857),
    [anon_sym___clrcall] = ACTIONS(3857),
    [anon_sym___stdcall] = ACTIONS(3857),
    [anon_sym___fastcall] = ACTIONS(3857),
    [anon_sym___thiscall] = ACTIONS(3857),
    [anon_sym___vectorcall] = ACTIONS(3857),
    [anon_sym_LBRACE] = ACTIONS(3859),
    [anon_sym_RBRACE] = ACTIONS(3859),
    [anon_sym_signed] = ACTIONS(3857),
    [anon_sym_unsigned] = ACTIONS(3857),
    [anon_sym_long] = ACTIONS(3857),
    [anon_sym_short] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(3857),
    [anon_sym_static] = ACTIONS(3857),
    [anon_sym_register] = ACTIONS(3857),
    [anon_sym_inline] = ACTIONS(3857),
    [anon_sym___inline] = ACTIONS(3857),
    [anon_sym___inline__] = ACTIONS(3857),
    [anon_sym___forceinline] = ACTIONS(3857),
    [anon_sym_thread_local] = ACTIONS(3857),
    [anon_sym___thread] = ACTIONS(3857),
    [anon_sym_const] = ACTIONS(3857),
    [anon_sym_constexpr] = ACTIONS(3857),
    [anon_sym_volatile] = ACTIONS(3857),
    [anon_sym_restrict] = ACTIONS(3857),
    [anon_sym___restrict__] = ACTIONS(3857),
    [anon_sym__Atomic] = ACTIONS(3857),
    [anon_sym__Noreturn] = ACTIONS(3857),
    [anon_sym_noreturn] = ACTIONS(3857),
    [anon_sym__Nonnull] = ACTIONS(3857),
    [anon_sym_mutable] = ACTIONS(3857),
    [anon_sym_constinit] = ACTIONS(3857),
    [anon_sym_consteval] = ACTIONS(3857),
    [anon_sym_alignas] = ACTIONS(3857),
    [anon_sym__Alignas] = ACTIONS(3857),
    [sym_primitive_type] = ACTIONS(3857),
    [anon_sym_enum] = ACTIONS(3857),
    [anon_sym_class] = ACTIONS(3857),
    [anon_sym_struct] = ACTIONS(3857),
    [anon_sym_union] = ACTIONS(3857),
    [anon_sym_if] = ACTIONS(3857),
    [anon_sym_switch] = ACTIONS(3857),
    [anon_sym_case] = ACTIONS(3857),
    [anon_sym_default] = ACTIONS(3857),
    [anon_sym_while] = ACTIONS(3857),
    [anon_sym_do] = ACTIONS(3857),
    [anon_sym_for] = ACTIONS(3857),
    [anon_sym_return] = ACTIONS(3857),
    [anon_sym_break] = ACTIONS(3857),
    [anon_sym_continue] = ACTIONS(3857),
    [anon_sym_goto] = ACTIONS(3857),
    [anon_sym___try] = ACTIONS(3857),
    [anon_sym___leave] = ACTIONS(3857),
    [anon_sym_not] = ACTIONS(3857),
    [anon_sym_compl] = ACTIONS(3857),
    [anon_sym_DASH_DASH] = ACTIONS(3859),
    [anon_sym_PLUS_PLUS] = ACTIONS(3859),
    [anon_sym_sizeof] = ACTIONS(3857),
    [anon_sym___alignof__] = ACTIONS(3857),
    [anon_sym___alignof] = ACTIONS(3857),
    [anon_sym__alignof] = ACTIONS(3857),
    [anon_sym_alignof] = ACTIONS(3857),
    [anon_sym__Alignof] = ACTIONS(3857),
    [anon_sym_offsetof] = ACTIONS(3857),
    [anon_sym__Generic] = ACTIONS(3857),
    [anon_sym_asm] = ACTIONS(3857),
    [anon_sym___asm__] = ACTIONS(3857),
    [anon_sym___asm] = ACTIONS(3857),
    [sym_number_literal] = ACTIONS(3859),
    [anon_sym_L_SQUOTE] = ACTIONS(3859),
    [anon_sym_u_SQUOTE] = ACTIONS(3859),
    [anon_sym_U_SQUOTE] = ACTIONS(3859),
    [anon_sym_u8_SQUOTE] = ACTIONS(3859),
    [anon_sym_SQUOTE] = ACTIONS(3859),
    [anon_sym_L_DQUOTE] = ACTIONS(3859),
    [anon_sym_u_DQUOTE] = ACTIONS(3859),
    [anon_sym_U_DQUOTE] = ACTIONS(3859),
    [anon_sym_u8_DQUOTE] = ACTIONS(3859),
    [anon_sym_DQUOTE] = ACTIONS(3859),
    [sym_true] = ACTIONS(3857),
    [sym_false] = ACTIONS(3857),
    [anon_sym_NULL] = ACTIONS(3857),
    [anon_sym_nullptr] = ACTIONS(3857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3857),
    [anon_sym_let] = ACTIONS(3857),
    [anon_sym_This] = ACTIONS(3857),
    [anon_sym_decltype] = ACTIONS(3857),
    [anon_sym_explicit] = ACTIONS(3857),
    [anon_sym_typename] = ACTIONS(3857),
    [anon_sym_template] = ACTIONS(3857),
    [anon_sym_operator] = ACTIONS(3857),
    [anon_sym_try] = ACTIONS(3857),
    [anon_sym_delete] = ACTIONS(3857),
    [anon_sym_throw] = ACTIONS(3857),
    [anon_sym_namespace] = ACTIONS(3857),
    [anon_sym_static_assert] = ACTIONS(3857),
    [anon_sym_concept] = ACTIONS(3857),
    [anon_sym_co_return] = ACTIONS(3857),
    [anon_sym_co_yield] = ACTIONS(3857),
    [anon_sym_R_DQUOTE] = ACTIONS(3859),
    [anon_sym_LR_DQUOTE] = ACTIONS(3859),
    [anon_sym_uR_DQUOTE] = ACTIONS(3859),
    [anon_sym_UR_DQUOTE] = ACTIONS(3859),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3859),
    [anon_sym_co_await] = ACTIONS(3857),
    [anon_sym_new] = ACTIONS(3857),
    [anon_sym_requires] = ACTIONS(3857),
    [sym_this] = ACTIONS(3857),
    [anon_sym_discard] = ACTIONS(3857),
    [anon_sym_precise] = ACTIONS(3857),
    [anon_sym_shared] = ACTIONS(3857),
    [anon_sym_groupshared] = ACTIONS(3857),
    [anon_sym_uniform] = ACTIONS(3857),
    [anon_sym_row_major] = ACTIONS(3857),
    [anon_sym_column_major] = ACTIONS(3857),
    [anon_sym_globallycoherent] = ACTIONS(3857),
    [anon_sym_centroid] = ACTIONS(3857),
    [anon_sym_noperspective] = ACTIONS(3857),
    [anon_sym_nointerpolation] = ACTIONS(3857),
    [anon_sym_sample] = ACTIONS(3857),
    [anon_sym_linear] = ACTIONS(3857),
    [anon_sym_snorm] = ACTIONS(3857),
    [anon_sym_unorm] = ACTIONS(3857),
    [anon_sym_point] = ACTIONS(3857),
    [anon_sym_line] = ACTIONS(3857),
    [anon_sym_triangleadj] = ACTIONS(3857),
    [anon_sym_lineadj] = ACTIONS(3857),
    [anon_sym_triangle] = ACTIONS(3857),
    [anon_sym_cbuffer] = ACTIONS(3857),
    [anon_sym_interface] = ACTIONS(3857),
    [anon_sym_extension] = ACTIONS(3857),
  },
  [920] = {
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_include_token1] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token2] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_BANG] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3812),
    [anon_sym_PLUS] = ACTIONS(3812),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym___cdecl] = ACTIONS(3812),
    [anon_sym___clrcall] = ACTIONS(3812),
    [anon_sym___stdcall] = ACTIONS(3812),
    [anon_sym___fastcall] = ACTIONS(3812),
    [anon_sym___thiscall] = ACTIONS(3812),
    [anon_sym___vectorcall] = ACTIONS(3812),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [anon_sym_if] = ACTIONS(3812),
    [anon_sym_switch] = ACTIONS(3812),
    [anon_sym_case] = ACTIONS(3812),
    [anon_sym_default] = ACTIONS(3812),
    [anon_sym_while] = ACTIONS(3812),
    [anon_sym_do] = ACTIONS(3812),
    [anon_sym_for] = ACTIONS(3812),
    [anon_sym_return] = ACTIONS(3812),
    [anon_sym_break] = ACTIONS(3812),
    [anon_sym_continue] = ACTIONS(3812),
    [anon_sym_goto] = ACTIONS(3812),
    [anon_sym___try] = ACTIONS(3812),
    [anon_sym___leave] = ACTIONS(3812),
    [anon_sym_not] = ACTIONS(3812),
    [anon_sym_compl] = ACTIONS(3812),
    [anon_sym_DASH_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_PLUS] = ACTIONS(3814),
    [anon_sym_sizeof] = ACTIONS(3812),
    [anon_sym___alignof__] = ACTIONS(3812),
    [anon_sym___alignof] = ACTIONS(3812),
    [anon_sym__alignof] = ACTIONS(3812),
    [anon_sym_alignof] = ACTIONS(3812),
    [anon_sym__Alignof] = ACTIONS(3812),
    [anon_sym_offsetof] = ACTIONS(3812),
    [anon_sym__Generic] = ACTIONS(3812),
    [anon_sym_asm] = ACTIONS(3812),
    [anon_sym___asm__] = ACTIONS(3812),
    [anon_sym___asm] = ACTIONS(3812),
    [sym_number_literal] = ACTIONS(3814),
    [anon_sym_L_SQUOTE] = ACTIONS(3814),
    [anon_sym_u_SQUOTE] = ACTIONS(3814),
    [anon_sym_U_SQUOTE] = ACTIONS(3814),
    [anon_sym_u8_SQUOTE] = ACTIONS(3814),
    [anon_sym_SQUOTE] = ACTIONS(3814),
    [anon_sym_L_DQUOTE] = ACTIONS(3814),
    [anon_sym_u_DQUOTE] = ACTIONS(3814),
    [anon_sym_U_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [anon_sym_NULL] = ACTIONS(3812),
    [anon_sym_nullptr] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_try] = ACTIONS(3812),
    [anon_sym_delete] = ACTIONS(3812),
    [anon_sym_throw] = ACTIONS(3812),
    [anon_sym_namespace] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_concept] = ACTIONS(3812),
    [anon_sym_co_return] = ACTIONS(3812),
    [anon_sym_co_yield] = ACTIONS(3812),
    [anon_sym_R_DQUOTE] = ACTIONS(3814),
    [anon_sym_LR_DQUOTE] = ACTIONS(3814),
    [anon_sym_uR_DQUOTE] = ACTIONS(3814),
    [anon_sym_UR_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3814),
    [anon_sym_co_await] = ACTIONS(3812),
    [anon_sym_new] = ACTIONS(3812),
    [anon_sym_requires] = ACTIONS(3812),
    [sym_this] = ACTIONS(3812),
    [anon_sym_discard] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_cbuffer] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
  },
  [921] = {
    [sym_identifier] = ACTIONS(3861),
    [aux_sym_preproc_include_token1] = ACTIONS(3861),
    [aux_sym_preproc_def_token1] = ACTIONS(3861),
    [aux_sym_preproc_if_token1] = ACTIONS(3861),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3861),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3861),
    [sym_preproc_directive] = ACTIONS(3861),
    [anon_sym_LPAREN2] = ACTIONS(3863),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3861),
    [anon_sym_PLUS] = ACTIONS(3861),
    [anon_sym_STAR] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_AMP] = ACTIONS(3861),
    [anon_sym_SEMI] = ACTIONS(3863),
    [anon_sym___extension__] = ACTIONS(3861),
    [anon_sym_typedef] = ACTIONS(3861),
    [anon_sym_in] = ACTIONS(3861),
    [anon_sym_out] = ACTIONS(3861),
    [anon_sym_inout] = ACTIONS(3861),
    [anon_sym_virtual] = ACTIONS(3861),
    [anon_sym_extern] = ACTIONS(3861),
    [anon_sym___attribute__] = ACTIONS(3861),
    [anon_sym___attribute] = ACTIONS(3861),
    [anon_sym_using] = ACTIONS(3861),
    [anon_sym_COLON_COLON] = ACTIONS(3863),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3863),
    [anon_sym___declspec] = ACTIONS(3861),
    [anon_sym___based] = ACTIONS(3861),
    [anon_sym___cdecl] = ACTIONS(3861),
    [anon_sym___clrcall] = ACTIONS(3861),
    [anon_sym___stdcall] = ACTIONS(3861),
    [anon_sym___fastcall] = ACTIONS(3861),
    [anon_sym___thiscall] = ACTIONS(3861),
    [anon_sym___vectorcall] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_RBRACE] = ACTIONS(3863),
    [anon_sym_signed] = ACTIONS(3861),
    [anon_sym_unsigned] = ACTIONS(3861),
    [anon_sym_long] = ACTIONS(3861),
    [anon_sym_short] = ACTIONS(3861),
    [anon_sym_LBRACK] = ACTIONS(3861),
    [anon_sym_static] = ACTIONS(3861),
    [anon_sym_register] = ACTIONS(3861),
    [anon_sym_inline] = ACTIONS(3861),
    [anon_sym___inline] = ACTIONS(3861),
    [anon_sym___inline__] = ACTIONS(3861),
    [anon_sym___forceinline] = ACTIONS(3861),
    [anon_sym_thread_local] = ACTIONS(3861),
    [anon_sym___thread] = ACTIONS(3861),
    [anon_sym_const] = ACTIONS(3861),
    [anon_sym_constexpr] = ACTIONS(3861),
    [anon_sym_volatile] = ACTIONS(3861),
    [anon_sym_restrict] = ACTIONS(3861),
    [anon_sym___restrict__] = ACTIONS(3861),
    [anon_sym__Atomic] = ACTIONS(3861),
    [anon_sym__Noreturn] = ACTIONS(3861),
    [anon_sym_noreturn] = ACTIONS(3861),
    [anon_sym__Nonnull] = ACTIONS(3861),
    [anon_sym_mutable] = ACTIONS(3861),
    [anon_sym_constinit] = ACTIONS(3861),
    [anon_sym_consteval] = ACTIONS(3861),
    [anon_sym_alignas] = ACTIONS(3861),
    [anon_sym__Alignas] = ACTIONS(3861),
    [sym_primitive_type] = ACTIONS(3861),
    [anon_sym_enum] = ACTIONS(3861),
    [anon_sym_class] = ACTIONS(3861),
    [anon_sym_struct] = ACTIONS(3861),
    [anon_sym_union] = ACTIONS(3861),
    [anon_sym_if] = ACTIONS(3861),
    [anon_sym_switch] = ACTIONS(3861),
    [anon_sym_case] = ACTIONS(3861),
    [anon_sym_default] = ACTIONS(3861),
    [anon_sym_while] = ACTIONS(3861),
    [anon_sym_do] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3861),
    [anon_sym_return] = ACTIONS(3861),
    [anon_sym_break] = ACTIONS(3861),
    [anon_sym_continue] = ACTIONS(3861),
    [anon_sym_goto] = ACTIONS(3861),
    [anon_sym___try] = ACTIONS(3861),
    [anon_sym___leave] = ACTIONS(3861),
    [anon_sym_not] = ACTIONS(3861),
    [anon_sym_compl] = ACTIONS(3861),
    [anon_sym_DASH_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3863),
    [anon_sym_sizeof] = ACTIONS(3861),
    [anon_sym___alignof__] = ACTIONS(3861),
    [anon_sym___alignof] = ACTIONS(3861),
    [anon_sym__alignof] = ACTIONS(3861),
    [anon_sym_alignof] = ACTIONS(3861),
    [anon_sym__Alignof] = ACTIONS(3861),
    [anon_sym_offsetof] = ACTIONS(3861),
    [anon_sym__Generic] = ACTIONS(3861),
    [anon_sym_asm] = ACTIONS(3861),
    [anon_sym___asm__] = ACTIONS(3861),
    [anon_sym___asm] = ACTIONS(3861),
    [sym_number_literal] = ACTIONS(3863),
    [anon_sym_L_SQUOTE] = ACTIONS(3863),
    [anon_sym_u_SQUOTE] = ACTIONS(3863),
    [anon_sym_U_SQUOTE] = ACTIONS(3863),
    [anon_sym_u8_SQUOTE] = ACTIONS(3863),
    [anon_sym_SQUOTE] = ACTIONS(3863),
    [anon_sym_L_DQUOTE] = ACTIONS(3863),
    [anon_sym_u_DQUOTE] = ACTIONS(3863),
    [anon_sym_U_DQUOTE] = ACTIONS(3863),
    [anon_sym_u8_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [sym_true] = ACTIONS(3861),
    [sym_false] = ACTIONS(3861),
    [anon_sym_NULL] = ACTIONS(3861),
    [anon_sym_nullptr] = ACTIONS(3861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3861),
    [anon_sym_let] = ACTIONS(3861),
    [anon_sym_This] = ACTIONS(3861),
    [anon_sym_decltype] = ACTIONS(3861),
    [anon_sym_explicit] = ACTIONS(3861),
    [anon_sym_typename] = ACTIONS(3861),
    [anon_sym_template] = ACTIONS(3861),
    [anon_sym_operator] = ACTIONS(3861),
    [anon_sym_try] = ACTIONS(3861),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_throw] = ACTIONS(3861),
    [anon_sym_namespace] = ACTIONS(3861),
    [anon_sym_static_assert] = ACTIONS(3861),
    [anon_sym_concept] = ACTIONS(3861),
    [anon_sym_co_return] = ACTIONS(3861),
    [anon_sym_co_yield] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(3863),
    [anon_sym_LR_DQUOTE] = ACTIONS(3863),
    [anon_sym_uR_DQUOTE] = ACTIONS(3863),
    [anon_sym_UR_DQUOTE] = ACTIONS(3863),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3863),
    [anon_sym_co_await] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3861),
    [anon_sym_requires] = ACTIONS(3861),
    [sym_this] = ACTIONS(3861),
    [anon_sym_discard] = ACTIONS(3861),
    [anon_sym_precise] = ACTIONS(3861),
    [anon_sym_shared] = ACTIONS(3861),
    [anon_sym_groupshared] = ACTIONS(3861),
    [anon_sym_uniform] = ACTIONS(3861),
    [anon_sym_row_major] = ACTIONS(3861),
    [anon_sym_column_major] = ACTIONS(3861),
    [anon_sym_globallycoherent] = ACTIONS(3861),
    [anon_sym_centroid] = ACTIONS(3861),
    [anon_sym_noperspective] = ACTIONS(3861),
    [anon_sym_nointerpolation] = ACTIONS(3861),
    [anon_sym_sample] = ACTIONS(3861),
    [anon_sym_linear] = ACTIONS(3861),
    [anon_sym_snorm] = ACTIONS(3861),
    [anon_sym_unorm] = ACTIONS(3861),
    [anon_sym_point] = ACTIONS(3861),
    [anon_sym_line] = ACTIONS(3861),
    [anon_sym_triangleadj] = ACTIONS(3861),
    [anon_sym_lineadj] = ACTIONS(3861),
    [anon_sym_triangle] = ACTIONS(3861),
    [anon_sym_cbuffer] = ACTIONS(3861),
    [anon_sym_interface] = ACTIONS(3861),
    [anon_sym_extension] = ACTIONS(3861),
  },
  [922] = {
    [sym_identifier] = ACTIONS(3865),
    [aux_sym_preproc_include_token1] = ACTIONS(3865),
    [aux_sym_preproc_def_token1] = ACTIONS(3865),
    [aux_sym_preproc_if_token1] = ACTIONS(3865),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3865),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3865),
    [sym_preproc_directive] = ACTIONS(3865),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_BANG] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_STAR] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_AMP] = ACTIONS(3865),
    [anon_sym_SEMI] = ACTIONS(3867),
    [anon_sym___extension__] = ACTIONS(3865),
    [anon_sym_typedef] = ACTIONS(3865),
    [anon_sym_in] = ACTIONS(3865),
    [anon_sym_out] = ACTIONS(3865),
    [anon_sym_inout] = ACTIONS(3865),
    [anon_sym_virtual] = ACTIONS(3865),
    [anon_sym_extern] = ACTIONS(3865),
    [anon_sym___attribute__] = ACTIONS(3865),
    [anon_sym___attribute] = ACTIONS(3865),
    [anon_sym_using] = ACTIONS(3865),
    [anon_sym_COLON_COLON] = ACTIONS(3867),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3867),
    [anon_sym___declspec] = ACTIONS(3865),
    [anon_sym___based] = ACTIONS(3865),
    [anon_sym___cdecl] = ACTIONS(3865),
    [anon_sym___clrcall] = ACTIONS(3865),
    [anon_sym___stdcall] = ACTIONS(3865),
    [anon_sym___fastcall] = ACTIONS(3865),
    [anon_sym___thiscall] = ACTIONS(3865),
    [anon_sym___vectorcall] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3867),
    [anon_sym_RBRACE] = ACTIONS(3867),
    [anon_sym_signed] = ACTIONS(3865),
    [anon_sym_unsigned] = ACTIONS(3865),
    [anon_sym_long] = ACTIONS(3865),
    [anon_sym_short] = ACTIONS(3865),
    [anon_sym_LBRACK] = ACTIONS(3865),
    [anon_sym_static] = ACTIONS(3865),
    [anon_sym_register] = ACTIONS(3865),
    [anon_sym_inline] = ACTIONS(3865),
    [anon_sym___inline] = ACTIONS(3865),
    [anon_sym___inline__] = ACTIONS(3865),
    [anon_sym___forceinline] = ACTIONS(3865),
    [anon_sym_thread_local] = ACTIONS(3865),
    [anon_sym___thread] = ACTIONS(3865),
    [anon_sym_const] = ACTIONS(3865),
    [anon_sym_constexpr] = ACTIONS(3865),
    [anon_sym_volatile] = ACTIONS(3865),
    [anon_sym_restrict] = ACTIONS(3865),
    [anon_sym___restrict__] = ACTIONS(3865),
    [anon_sym__Atomic] = ACTIONS(3865),
    [anon_sym__Noreturn] = ACTIONS(3865),
    [anon_sym_noreturn] = ACTIONS(3865),
    [anon_sym__Nonnull] = ACTIONS(3865),
    [anon_sym_mutable] = ACTIONS(3865),
    [anon_sym_constinit] = ACTIONS(3865),
    [anon_sym_consteval] = ACTIONS(3865),
    [anon_sym_alignas] = ACTIONS(3865),
    [anon_sym__Alignas] = ACTIONS(3865),
    [sym_primitive_type] = ACTIONS(3865),
    [anon_sym_enum] = ACTIONS(3865),
    [anon_sym_class] = ACTIONS(3865),
    [anon_sym_struct] = ACTIONS(3865),
    [anon_sym_union] = ACTIONS(3865),
    [anon_sym_if] = ACTIONS(3865),
    [anon_sym_switch] = ACTIONS(3865),
    [anon_sym_case] = ACTIONS(3865),
    [anon_sym_default] = ACTIONS(3865),
    [anon_sym_while] = ACTIONS(3865),
    [anon_sym_do] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3865),
    [anon_sym_return] = ACTIONS(3865),
    [anon_sym_break] = ACTIONS(3865),
    [anon_sym_continue] = ACTIONS(3865),
    [anon_sym_goto] = ACTIONS(3865),
    [anon_sym___try] = ACTIONS(3865),
    [anon_sym___leave] = ACTIONS(3865),
    [anon_sym_not] = ACTIONS(3865),
    [anon_sym_compl] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3867),
    [anon_sym_PLUS_PLUS] = ACTIONS(3867),
    [anon_sym_sizeof] = ACTIONS(3865),
    [anon_sym___alignof__] = ACTIONS(3865),
    [anon_sym___alignof] = ACTIONS(3865),
    [anon_sym__alignof] = ACTIONS(3865),
    [anon_sym_alignof] = ACTIONS(3865),
    [anon_sym__Alignof] = ACTIONS(3865),
    [anon_sym_offsetof] = ACTIONS(3865),
    [anon_sym__Generic] = ACTIONS(3865),
    [anon_sym_asm] = ACTIONS(3865),
    [anon_sym___asm__] = ACTIONS(3865),
    [anon_sym___asm] = ACTIONS(3865),
    [sym_number_literal] = ACTIONS(3867),
    [anon_sym_L_SQUOTE] = ACTIONS(3867),
    [anon_sym_u_SQUOTE] = ACTIONS(3867),
    [anon_sym_U_SQUOTE] = ACTIONS(3867),
    [anon_sym_u8_SQUOTE] = ACTIONS(3867),
    [anon_sym_SQUOTE] = ACTIONS(3867),
    [anon_sym_L_DQUOTE] = ACTIONS(3867),
    [anon_sym_u_DQUOTE] = ACTIONS(3867),
    [anon_sym_U_DQUOTE] = ACTIONS(3867),
    [anon_sym_u8_DQUOTE] = ACTIONS(3867),
    [anon_sym_DQUOTE] = ACTIONS(3867),
    [sym_true] = ACTIONS(3865),
    [sym_false] = ACTIONS(3865),
    [anon_sym_NULL] = ACTIONS(3865),
    [anon_sym_nullptr] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3865),
    [anon_sym_let] = ACTIONS(3865),
    [anon_sym_This] = ACTIONS(3865),
    [anon_sym_decltype] = ACTIONS(3865),
    [anon_sym_explicit] = ACTIONS(3865),
    [anon_sym_typename] = ACTIONS(3865),
    [anon_sym_template] = ACTIONS(3865),
    [anon_sym_operator] = ACTIONS(3865),
    [anon_sym_try] = ACTIONS(3865),
    [anon_sym_delete] = ACTIONS(3865),
    [anon_sym_throw] = ACTIONS(3865),
    [anon_sym_namespace] = ACTIONS(3865),
    [anon_sym_static_assert] = ACTIONS(3865),
    [anon_sym_concept] = ACTIONS(3865),
    [anon_sym_co_return] = ACTIONS(3865),
    [anon_sym_co_yield] = ACTIONS(3865),
    [anon_sym_R_DQUOTE] = ACTIONS(3867),
    [anon_sym_LR_DQUOTE] = ACTIONS(3867),
    [anon_sym_uR_DQUOTE] = ACTIONS(3867),
    [anon_sym_UR_DQUOTE] = ACTIONS(3867),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3867),
    [anon_sym_co_await] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(3865),
    [sym_this] = ACTIONS(3865),
    [anon_sym_discard] = ACTIONS(3865),
    [anon_sym_precise] = ACTIONS(3865),
    [anon_sym_shared] = ACTIONS(3865),
    [anon_sym_groupshared] = ACTIONS(3865),
    [anon_sym_uniform] = ACTIONS(3865),
    [anon_sym_row_major] = ACTIONS(3865),
    [anon_sym_column_major] = ACTIONS(3865),
    [anon_sym_globallycoherent] = ACTIONS(3865),
    [anon_sym_centroid] = ACTIONS(3865),
    [anon_sym_noperspective] = ACTIONS(3865),
    [anon_sym_nointerpolation] = ACTIONS(3865),
    [anon_sym_sample] = ACTIONS(3865),
    [anon_sym_linear] = ACTIONS(3865),
    [anon_sym_snorm] = ACTIONS(3865),
    [anon_sym_unorm] = ACTIONS(3865),
    [anon_sym_point] = ACTIONS(3865),
    [anon_sym_line] = ACTIONS(3865),
    [anon_sym_triangleadj] = ACTIONS(3865),
    [anon_sym_lineadj] = ACTIONS(3865),
    [anon_sym_triangle] = ACTIONS(3865),
    [anon_sym_cbuffer] = ACTIONS(3865),
    [anon_sym_interface] = ACTIONS(3865),
    [anon_sym_extension] = ACTIONS(3865),
  },
  [923] = {
    [sym_identifier] = ACTIONS(3869),
    [aux_sym_preproc_include_token1] = ACTIONS(3869),
    [aux_sym_preproc_def_token1] = ACTIONS(3869),
    [aux_sym_preproc_if_token1] = ACTIONS(3869),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3869),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3869),
    [sym_preproc_directive] = ACTIONS(3869),
    [anon_sym_LPAREN2] = ACTIONS(3871),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(3871),
    [anon_sym_AMP_AMP] = ACTIONS(3871),
    [anon_sym_AMP] = ACTIONS(3869),
    [anon_sym_SEMI] = ACTIONS(3871),
    [anon_sym___extension__] = ACTIONS(3869),
    [anon_sym_typedef] = ACTIONS(3869),
    [anon_sym_in] = ACTIONS(3869),
    [anon_sym_out] = ACTIONS(3869),
    [anon_sym_inout] = ACTIONS(3869),
    [anon_sym_virtual] = ACTIONS(3869),
    [anon_sym_extern] = ACTIONS(3869),
    [anon_sym___attribute__] = ACTIONS(3869),
    [anon_sym___attribute] = ACTIONS(3869),
    [anon_sym_using] = ACTIONS(3869),
    [anon_sym_COLON_COLON] = ACTIONS(3871),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3871),
    [anon_sym___declspec] = ACTIONS(3869),
    [anon_sym___based] = ACTIONS(3869),
    [anon_sym___cdecl] = ACTIONS(3869),
    [anon_sym___clrcall] = ACTIONS(3869),
    [anon_sym___stdcall] = ACTIONS(3869),
    [anon_sym___fastcall] = ACTIONS(3869),
    [anon_sym___thiscall] = ACTIONS(3869),
    [anon_sym___vectorcall] = ACTIONS(3869),
    [anon_sym_LBRACE] = ACTIONS(3871),
    [anon_sym_RBRACE] = ACTIONS(3871),
    [anon_sym_signed] = ACTIONS(3869),
    [anon_sym_unsigned] = ACTIONS(3869),
    [anon_sym_long] = ACTIONS(3869),
    [anon_sym_short] = ACTIONS(3869),
    [anon_sym_LBRACK] = ACTIONS(3869),
    [anon_sym_static] = ACTIONS(3869),
    [anon_sym_register] = ACTIONS(3869),
    [anon_sym_inline] = ACTIONS(3869),
    [anon_sym___inline] = ACTIONS(3869),
    [anon_sym___inline__] = ACTIONS(3869),
    [anon_sym___forceinline] = ACTIONS(3869),
    [anon_sym_thread_local] = ACTIONS(3869),
    [anon_sym___thread] = ACTIONS(3869),
    [anon_sym_const] = ACTIONS(3869),
    [anon_sym_constexpr] = ACTIONS(3869),
    [anon_sym_volatile] = ACTIONS(3869),
    [anon_sym_restrict] = ACTIONS(3869),
    [anon_sym___restrict__] = ACTIONS(3869),
    [anon_sym__Atomic] = ACTIONS(3869),
    [anon_sym__Noreturn] = ACTIONS(3869),
    [anon_sym_noreturn] = ACTIONS(3869),
    [anon_sym__Nonnull] = ACTIONS(3869),
    [anon_sym_mutable] = ACTIONS(3869),
    [anon_sym_constinit] = ACTIONS(3869),
    [anon_sym_consteval] = ACTIONS(3869),
    [anon_sym_alignas] = ACTIONS(3869),
    [anon_sym__Alignas] = ACTIONS(3869),
    [sym_primitive_type] = ACTIONS(3869),
    [anon_sym_enum] = ACTIONS(3869),
    [anon_sym_class] = ACTIONS(3869),
    [anon_sym_struct] = ACTIONS(3869),
    [anon_sym_union] = ACTIONS(3869),
    [anon_sym_if] = ACTIONS(3869),
    [anon_sym_switch] = ACTIONS(3869),
    [anon_sym_case] = ACTIONS(3869),
    [anon_sym_default] = ACTIONS(3869),
    [anon_sym_while] = ACTIONS(3869),
    [anon_sym_do] = ACTIONS(3869),
    [anon_sym_for] = ACTIONS(3869),
    [anon_sym_return] = ACTIONS(3869),
    [anon_sym_break] = ACTIONS(3869),
    [anon_sym_continue] = ACTIONS(3869),
    [anon_sym_goto] = ACTIONS(3869),
    [anon_sym___try] = ACTIONS(3869),
    [anon_sym___leave] = ACTIONS(3869),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(3871),
    [anon_sym_PLUS_PLUS] = ACTIONS(3871),
    [anon_sym_sizeof] = ACTIONS(3869),
    [anon_sym___alignof__] = ACTIONS(3869),
    [anon_sym___alignof] = ACTIONS(3869),
    [anon_sym__alignof] = ACTIONS(3869),
    [anon_sym_alignof] = ACTIONS(3869),
    [anon_sym__Alignof] = ACTIONS(3869),
    [anon_sym_offsetof] = ACTIONS(3869),
    [anon_sym__Generic] = ACTIONS(3869),
    [anon_sym_asm] = ACTIONS(3869),
    [anon_sym___asm__] = ACTIONS(3869),
    [anon_sym___asm] = ACTIONS(3869),
    [sym_number_literal] = ACTIONS(3871),
    [anon_sym_L_SQUOTE] = ACTIONS(3871),
    [anon_sym_u_SQUOTE] = ACTIONS(3871),
    [anon_sym_U_SQUOTE] = ACTIONS(3871),
    [anon_sym_u8_SQUOTE] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3871),
    [anon_sym_L_DQUOTE] = ACTIONS(3871),
    [anon_sym_u_DQUOTE] = ACTIONS(3871),
    [anon_sym_U_DQUOTE] = ACTIONS(3871),
    [anon_sym_u8_DQUOTE] = ACTIONS(3871),
    [anon_sym_DQUOTE] = ACTIONS(3871),
    [sym_true] = ACTIONS(3869),
    [sym_false] = ACTIONS(3869),
    [anon_sym_NULL] = ACTIONS(3869),
    [anon_sym_nullptr] = ACTIONS(3869),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3869),
    [anon_sym_let] = ACTIONS(3869),
    [anon_sym_This] = ACTIONS(3869),
    [anon_sym_decltype] = ACTIONS(3869),
    [anon_sym_explicit] = ACTIONS(3869),
    [anon_sym_typename] = ACTIONS(3869),
    [anon_sym_template] = ACTIONS(3869),
    [anon_sym_operator] = ACTIONS(3869),
    [anon_sym_try] = ACTIONS(3869),
    [anon_sym_delete] = ACTIONS(3869),
    [anon_sym_throw] = ACTIONS(3869),
    [anon_sym_namespace] = ACTIONS(3869),
    [anon_sym_static_assert] = ACTIONS(3869),
    [anon_sym_concept] = ACTIONS(3869),
    [anon_sym_co_return] = ACTIONS(3869),
    [anon_sym_co_yield] = ACTIONS(3869),
    [anon_sym_R_DQUOTE] = ACTIONS(3871),
    [anon_sym_LR_DQUOTE] = ACTIONS(3871),
    [anon_sym_uR_DQUOTE] = ACTIONS(3871),
    [anon_sym_UR_DQUOTE] = ACTIONS(3871),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3871),
    [anon_sym_co_await] = ACTIONS(3869),
    [anon_sym_new] = ACTIONS(3869),
    [anon_sym_requires] = ACTIONS(3869),
    [sym_this] = ACTIONS(3869),
    [anon_sym_discard] = ACTIONS(3869),
    [anon_sym_precise] = ACTIONS(3869),
    [anon_sym_shared] = ACTIONS(3869),
    [anon_sym_groupshared] = ACTIONS(3869),
    [anon_sym_uniform] = ACTIONS(3869),
    [anon_sym_row_major] = ACTIONS(3869),
    [anon_sym_column_major] = ACTIONS(3869),
    [anon_sym_globallycoherent] = ACTIONS(3869),
    [anon_sym_centroid] = ACTIONS(3869),
    [anon_sym_noperspective] = ACTIONS(3869),
    [anon_sym_nointerpolation] = ACTIONS(3869),
    [anon_sym_sample] = ACTIONS(3869),
    [anon_sym_linear] = ACTIONS(3869),
    [anon_sym_snorm] = ACTIONS(3869),
    [anon_sym_unorm] = ACTIONS(3869),
    [anon_sym_point] = ACTIONS(3869),
    [anon_sym_line] = ACTIONS(3869),
    [anon_sym_triangleadj] = ACTIONS(3869),
    [anon_sym_lineadj] = ACTIONS(3869),
    [anon_sym_triangle] = ACTIONS(3869),
    [anon_sym_cbuffer] = ACTIONS(3869),
    [anon_sym_interface] = ACTIONS(3869),
    [anon_sym_extension] = ACTIONS(3869),
  },
  [924] = {
    [sym_identifier] = ACTIONS(3873),
    [aux_sym_preproc_include_token1] = ACTIONS(3873),
    [aux_sym_preproc_def_token1] = ACTIONS(3873),
    [aux_sym_preproc_if_token1] = ACTIONS(3873),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3873),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3873),
    [sym_preproc_directive] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(3875),
    [anon_sym_BANG] = ACTIONS(3875),
    [anon_sym_TILDE] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3873),
    [anon_sym_PLUS] = ACTIONS(3873),
    [anon_sym_STAR] = ACTIONS(3875),
    [anon_sym_AMP_AMP] = ACTIONS(3875),
    [anon_sym_AMP] = ACTIONS(3873),
    [anon_sym_SEMI] = ACTIONS(3875),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_typedef] = ACTIONS(3873),
    [anon_sym_in] = ACTIONS(3873),
    [anon_sym_out] = ACTIONS(3873),
    [anon_sym_inout] = ACTIONS(3873),
    [anon_sym_virtual] = ACTIONS(3873),
    [anon_sym_extern] = ACTIONS(3873),
    [anon_sym___attribute__] = ACTIONS(3873),
    [anon_sym___attribute] = ACTIONS(3873),
    [anon_sym_using] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3875),
    [anon_sym___declspec] = ACTIONS(3873),
    [anon_sym___based] = ACTIONS(3873),
    [anon_sym___cdecl] = ACTIONS(3873),
    [anon_sym___clrcall] = ACTIONS(3873),
    [anon_sym___stdcall] = ACTIONS(3873),
    [anon_sym___fastcall] = ACTIONS(3873),
    [anon_sym___thiscall] = ACTIONS(3873),
    [anon_sym___vectorcall] = ACTIONS(3873),
    [anon_sym_LBRACE] = ACTIONS(3875),
    [anon_sym_RBRACE] = ACTIONS(3875),
    [anon_sym_signed] = ACTIONS(3873),
    [anon_sym_unsigned] = ACTIONS(3873),
    [anon_sym_long] = ACTIONS(3873),
    [anon_sym_short] = ACTIONS(3873),
    [anon_sym_LBRACK] = ACTIONS(3873),
    [anon_sym_static] = ACTIONS(3873),
    [anon_sym_register] = ACTIONS(3873),
    [anon_sym_inline] = ACTIONS(3873),
    [anon_sym___inline] = ACTIONS(3873),
    [anon_sym___inline__] = ACTIONS(3873),
    [anon_sym___forceinline] = ACTIONS(3873),
    [anon_sym_thread_local] = ACTIONS(3873),
    [anon_sym___thread] = ACTIONS(3873),
    [anon_sym_const] = ACTIONS(3873),
    [anon_sym_constexpr] = ACTIONS(3873),
    [anon_sym_volatile] = ACTIONS(3873),
    [anon_sym_restrict] = ACTIONS(3873),
    [anon_sym___restrict__] = ACTIONS(3873),
    [anon_sym__Atomic] = ACTIONS(3873),
    [anon_sym__Noreturn] = ACTIONS(3873),
    [anon_sym_noreturn] = ACTIONS(3873),
    [anon_sym__Nonnull] = ACTIONS(3873),
    [anon_sym_mutable] = ACTIONS(3873),
    [anon_sym_constinit] = ACTIONS(3873),
    [anon_sym_consteval] = ACTIONS(3873),
    [anon_sym_alignas] = ACTIONS(3873),
    [anon_sym__Alignas] = ACTIONS(3873),
    [sym_primitive_type] = ACTIONS(3873),
    [anon_sym_enum] = ACTIONS(3873),
    [anon_sym_class] = ACTIONS(3873),
    [anon_sym_struct] = ACTIONS(3873),
    [anon_sym_union] = ACTIONS(3873),
    [anon_sym_if] = ACTIONS(3873),
    [anon_sym_switch] = ACTIONS(3873),
    [anon_sym_case] = ACTIONS(3873),
    [anon_sym_default] = ACTIONS(3873),
    [anon_sym_while] = ACTIONS(3873),
    [anon_sym_do] = ACTIONS(3873),
    [anon_sym_for] = ACTIONS(3873),
    [anon_sym_return] = ACTIONS(3873),
    [anon_sym_break] = ACTIONS(3873),
    [anon_sym_continue] = ACTIONS(3873),
    [anon_sym_goto] = ACTIONS(3873),
    [anon_sym___try] = ACTIONS(3873),
    [anon_sym___leave] = ACTIONS(3873),
    [anon_sym_not] = ACTIONS(3873),
    [anon_sym_compl] = ACTIONS(3873),
    [anon_sym_DASH_DASH] = ACTIONS(3875),
    [anon_sym_PLUS_PLUS] = ACTIONS(3875),
    [anon_sym_sizeof] = ACTIONS(3873),
    [anon_sym___alignof__] = ACTIONS(3873),
    [anon_sym___alignof] = ACTIONS(3873),
    [anon_sym__alignof] = ACTIONS(3873),
    [anon_sym_alignof] = ACTIONS(3873),
    [anon_sym__Alignof] = ACTIONS(3873),
    [anon_sym_offsetof] = ACTIONS(3873),
    [anon_sym__Generic] = ACTIONS(3873),
    [anon_sym_asm] = ACTIONS(3873),
    [anon_sym___asm__] = ACTIONS(3873),
    [anon_sym___asm] = ACTIONS(3873),
    [sym_number_literal] = ACTIONS(3875),
    [anon_sym_L_SQUOTE] = ACTIONS(3875),
    [anon_sym_u_SQUOTE] = ACTIONS(3875),
    [anon_sym_U_SQUOTE] = ACTIONS(3875),
    [anon_sym_u8_SQUOTE] = ACTIONS(3875),
    [anon_sym_SQUOTE] = ACTIONS(3875),
    [anon_sym_L_DQUOTE] = ACTIONS(3875),
    [anon_sym_u_DQUOTE] = ACTIONS(3875),
    [anon_sym_U_DQUOTE] = ACTIONS(3875),
    [anon_sym_u8_DQUOTE] = ACTIONS(3875),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_true] = ACTIONS(3873),
    [sym_false] = ACTIONS(3873),
    [anon_sym_NULL] = ACTIONS(3873),
    [anon_sym_nullptr] = ACTIONS(3873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3873),
    [anon_sym_let] = ACTIONS(3873),
    [anon_sym_This] = ACTIONS(3873),
    [anon_sym_decltype] = ACTIONS(3873),
    [anon_sym_explicit] = ACTIONS(3873),
    [anon_sym_typename] = ACTIONS(3873),
    [anon_sym_template] = ACTIONS(3873),
    [anon_sym_operator] = ACTIONS(3873),
    [anon_sym_try] = ACTIONS(3873),
    [anon_sym_delete] = ACTIONS(3873),
    [anon_sym_throw] = ACTIONS(3873),
    [anon_sym_namespace] = ACTIONS(3873),
    [anon_sym_static_assert] = ACTIONS(3873),
    [anon_sym_concept] = ACTIONS(3873),
    [anon_sym_co_return] = ACTIONS(3873),
    [anon_sym_co_yield] = ACTIONS(3873),
    [anon_sym_R_DQUOTE] = ACTIONS(3875),
    [anon_sym_LR_DQUOTE] = ACTIONS(3875),
    [anon_sym_uR_DQUOTE] = ACTIONS(3875),
    [anon_sym_UR_DQUOTE] = ACTIONS(3875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3875),
    [anon_sym_co_await] = ACTIONS(3873),
    [anon_sym_new] = ACTIONS(3873),
    [anon_sym_requires] = ACTIONS(3873),
    [sym_this] = ACTIONS(3873),
    [anon_sym_discard] = ACTIONS(3873),
    [anon_sym_precise] = ACTIONS(3873),
    [anon_sym_shared] = ACTIONS(3873),
    [anon_sym_groupshared] = ACTIONS(3873),
    [anon_sym_uniform] = ACTIONS(3873),
    [anon_sym_row_major] = ACTIONS(3873),
    [anon_sym_column_major] = ACTIONS(3873),
    [anon_sym_globallycoherent] = ACTIONS(3873),
    [anon_sym_centroid] = ACTIONS(3873),
    [anon_sym_noperspective] = ACTIONS(3873),
    [anon_sym_nointerpolation] = ACTIONS(3873),
    [anon_sym_sample] = ACTIONS(3873),
    [anon_sym_linear] = ACTIONS(3873),
    [anon_sym_snorm] = ACTIONS(3873),
    [anon_sym_unorm] = ACTIONS(3873),
    [anon_sym_point] = ACTIONS(3873),
    [anon_sym_line] = ACTIONS(3873),
    [anon_sym_triangleadj] = ACTIONS(3873),
    [anon_sym_lineadj] = ACTIONS(3873),
    [anon_sym_triangle] = ACTIONS(3873),
    [anon_sym_cbuffer] = ACTIONS(3873),
    [anon_sym_interface] = ACTIONS(3873),
    [anon_sym_extension] = ACTIONS(3873),
  },
  [925] = {
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_include_token1] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token2] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_BANG] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3812),
    [anon_sym_PLUS] = ACTIONS(3812),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym___cdecl] = ACTIONS(3812),
    [anon_sym___clrcall] = ACTIONS(3812),
    [anon_sym___stdcall] = ACTIONS(3812),
    [anon_sym___fastcall] = ACTIONS(3812),
    [anon_sym___thiscall] = ACTIONS(3812),
    [anon_sym___vectorcall] = ACTIONS(3812),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [anon_sym_if] = ACTIONS(3812),
    [anon_sym_switch] = ACTIONS(3812),
    [anon_sym_case] = ACTIONS(3812),
    [anon_sym_default] = ACTIONS(3812),
    [anon_sym_while] = ACTIONS(3812),
    [anon_sym_do] = ACTIONS(3812),
    [anon_sym_for] = ACTIONS(3812),
    [anon_sym_return] = ACTIONS(3812),
    [anon_sym_break] = ACTIONS(3812),
    [anon_sym_continue] = ACTIONS(3812),
    [anon_sym_goto] = ACTIONS(3812),
    [anon_sym___try] = ACTIONS(3812),
    [anon_sym___leave] = ACTIONS(3812),
    [anon_sym_not] = ACTIONS(3812),
    [anon_sym_compl] = ACTIONS(3812),
    [anon_sym_DASH_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_PLUS] = ACTIONS(3814),
    [anon_sym_sizeof] = ACTIONS(3812),
    [anon_sym___alignof__] = ACTIONS(3812),
    [anon_sym___alignof] = ACTIONS(3812),
    [anon_sym__alignof] = ACTIONS(3812),
    [anon_sym_alignof] = ACTIONS(3812),
    [anon_sym__Alignof] = ACTIONS(3812),
    [anon_sym_offsetof] = ACTIONS(3812),
    [anon_sym__Generic] = ACTIONS(3812),
    [anon_sym_asm] = ACTIONS(3812),
    [anon_sym___asm__] = ACTIONS(3812),
    [anon_sym___asm] = ACTIONS(3812),
    [sym_number_literal] = ACTIONS(3814),
    [anon_sym_L_SQUOTE] = ACTIONS(3814),
    [anon_sym_u_SQUOTE] = ACTIONS(3814),
    [anon_sym_U_SQUOTE] = ACTIONS(3814),
    [anon_sym_u8_SQUOTE] = ACTIONS(3814),
    [anon_sym_SQUOTE] = ACTIONS(3814),
    [anon_sym_L_DQUOTE] = ACTIONS(3814),
    [anon_sym_u_DQUOTE] = ACTIONS(3814),
    [anon_sym_U_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [anon_sym_NULL] = ACTIONS(3812),
    [anon_sym_nullptr] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_try] = ACTIONS(3812),
    [anon_sym_delete] = ACTIONS(3812),
    [anon_sym_throw] = ACTIONS(3812),
    [anon_sym_namespace] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_concept] = ACTIONS(3812),
    [anon_sym_co_return] = ACTIONS(3812),
    [anon_sym_co_yield] = ACTIONS(3812),
    [anon_sym_R_DQUOTE] = ACTIONS(3814),
    [anon_sym_LR_DQUOTE] = ACTIONS(3814),
    [anon_sym_uR_DQUOTE] = ACTIONS(3814),
    [anon_sym_UR_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3814),
    [anon_sym_co_await] = ACTIONS(3812),
    [anon_sym_new] = ACTIONS(3812),
    [anon_sym_requires] = ACTIONS(3812),
    [sym_this] = ACTIONS(3812),
    [anon_sym_discard] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_cbuffer] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
  },
  [926] = {
    [sym_identifier] = ACTIONS(3865),
    [aux_sym_preproc_include_token1] = ACTIONS(3865),
    [aux_sym_preproc_def_token1] = ACTIONS(3865),
    [aux_sym_preproc_if_token1] = ACTIONS(3865),
    [aux_sym_preproc_if_token2] = ACTIONS(3865),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3865),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3865),
    [sym_preproc_directive] = ACTIONS(3865),
    [anon_sym_LPAREN2] = ACTIONS(3867),
    [anon_sym_BANG] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_PLUS] = ACTIONS(3865),
    [anon_sym_STAR] = ACTIONS(3867),
    [anon_sym_AMP_AMP] = ACTIONS(3867),
    [anon_sym_AMP] = ACTIONS(3865),
    [anon_sym_SEMI] = ACTIONS(3867),
    [anon_sym___extension__] = ACTIONS(3865),
    [anon_sym_typedef] = ACTIONS(3865),
    [anon_sym_in] = ACTIONS(3865),
    [anon_sym_out] = ACTIONS(3865),
    [anon_sym_inout] = ACTIONS(3865),
    [anon_sym_virtual] = ACTIONS(3865),
    [anon_sym_extern] = ACTIONS(3865),
    [anon_sym___attribute__] = ACTIONS(3865),
    [anon_sym___attribute] = ACTIONS(3865),
    [anon_sym_using] = ACTIONS(3865),
    [anon_sym_COLON_COLON] = ACTIONS(3867),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3867),
    [anon_sym___declspec] = ACTIONS(3865),
    [anon_sym___based] = ACTIONS(3865),
    [anon_sym___cdecl] = ACTIONS(3865),
    [anon_sym___clrcall] = ACTIONS(3865),
    [anon_sym___stdcall] = ACTIONS(3865),
    [anon_sym___fastcall] = ACTIONS(3865),
    [anon_sym___thiscall] = ACTIONS(3865),
    [anon_sym___vectorcall] = ACTIONS(3865),
    [anon_sym_LBRACE] = ACTIONS(3867),
    [anon_sym_signed] = ACTIONS(3865),
    [anon_sym_unsigned] = ACTIONS(3865),
    [anon_sym_long] = ACTIONS(3865),
    [anon_sym_short] = ACTIONS(3865),
    [anon_sym_LBRACK] = ACTIONS(3865),
    [anon_sym_static] = ACTIONS(3865),
    [anon_sym_register] = ACTIONS(3865),
    [anon_sym_inline] = ACTIONS(3865),
    [anon_sym___inline] = ACTIONS(3865),
    [anon_sym___inline__] = ACTIONS(3865),
    [anon_sym___forceinline] = ACTIONS(3865),
    [anon_sym_thread_local] = ACTIONS(3865),
    [anon_sym___thread] = ACTIONS(3865),
    [anon_sym_const] = ACTIONS(3865),
    [anon_sym_constexpr] = ACTIONS(3865),
    [anon_sym_volatile] = ACTIONS(3865),
    [anon_sym_restrict] = ACTIONS(3865),
    [anon_sym___restrict__] = ACTIONS(3865),
    [anon_sym__Atomic] = ACTIONS(3865),
    [anon_sym__Noreturn] = ACTIONS(3865),
    [anon_sym_noreturn] = ACTIONS(3865),
    [anon_sym__Nonnull] = ACTIONS(3865),
    [anon_sym_mutable] = ACTIONS(3865),
    [anon_sym_constinit] = ACTIONS(3865),
    [anon_sym_consteval] = ACTIONS(3865),
    [anon_sym_alignas] = ACTIONS(3865),
    [anon_sym__Alignas] = ACTIONS(3865),
    [sym_primitive_type] = ACTIONS(3865),
    [anon_sym_enum] = ACTIONS(3865),
    [anon_sym_class] = ACTIONS(3865),
    [anon_sym_struct] = ACTIONS(3865),
    [anon_sym_union] = ACTIONS(3865),
    [anon_sym_if] = ACTIONS(3865),
    [anon_sym_switch] = ACTIONS(3865),
    [anon_sym_case] = ACTIONS(3865),
    [anon_sym_default] = ACTIONS(3865),
    [anon_sym_while] = ACTIONS(3865),
    [anon_sym_do] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3865),
    [anon_sym_return] = ACTIONS(3865),
    [anon_sym_break] = ACTIONS(3865),
    [anon_sym_continue] = ACTIONS(3865),
    [anon_sym_goto] = ACTIONS(3865),
    [anon_sym___try] = ACTIONS(3865),
    [anon_sym___leave] = ACTIONS(3865),
    [anon_sym_not] = ACTIONS(3865),
    [anon_sym_compl] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3867),
    [anon_sym_PLUS_PLUS] = ACTIONS(3867),
    [anon_sym_sizeof] = ACTIONS(3865),
    [anon_sym___alignof__] = ACTIONS(3865),
    [anon_sym___alignof] = ACTIONS(3865),
    [anon_sym__alignof] = ACTIONS(3865),
    [anon_sym_alignof] = ACTIONS(3865),
    [anon_sym__Alignof] = ACTIONS(3865),
    [anon_sym_offsetof] = ACTIONS(3865),
    [anon_sym__Generic] = ACTIONS(3865),
    [anon_sym_asm] = ACTIONS(3865),
    [anon_sym___asm__] = ACTIONS(3865),
    [anon_sym___asm] = ACTIONS(3865),
    [sym_number_literal] = ACTIONS(3867),
    [anon_sym_L_SQUOTE] = ACTIONS(3867),
    [anon_sym_u_SQUOTE] = ACTIONS(3867),
    [anon_sym_U_SQUOTE] = ACTIONS(3867),
    [anon_sym_u8_SQUOTE] = ACTIONS(3867),
    [anon_sym_SQUOTE] = ACTIONS(3867),
    [anon_sym_L_DQUOTE] = ACTIONS(3867),
    [anon_sym_u_DQUOTE] = ACTIONS(3867),
    [anon_sym_U_DQUOTE] = ACTIONS(3867),
    [anon_sym_u8_DQUOTE] = ACTIONS(3867),
    [anon_sym_DQUOTE] = ACTIONS(3867),
    [sym_true] = ACTIONS(3865),
    [sym_false] = ACTIONS(3865),
    [anon_sym_NULL] = ACTIONS(3865),
    [anon_sym_nullptr] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3865),
    [anon_sym_let] = ACTIONS(3865),
    [anon_sym_This] = ACTIONS(3865),
    [anon_sym_decltype] = ACTIONS(3865),
    [anon_sym_explicit] = ACTIONS(3865),
    [anon_sym_typename] = ACTIONS(3865),
    [anon_sym_template] = ACTIONS(3865),
    [anon_sym_operator] = ACTIONS(3865),
    [anon_sym_try] = ACTIONS(3865),
    [anon_sym_delete] = ACTIONS(3865),
    [anon_sym_throw] = ACTIONS(3865),
    [anon_sym_namespace] = ACTIONS(3865),
    [anon_sym_static_assert] = ACTIONS(3865),
    [anon_sym_concept] = ACTIONS(3865),
    [anon_sym_co_return] = ACTIONS(3865),
    [anon_sym_co_yield] = ACTIONS(3865),
    [anon_sym_R_DQUOTE] = ACTIONS(3867),
    [anon_sym_LR_DQUOTE] = ACTIONS(3867),
    [anon_sym_uR_DQUOTE] = ACTIONS(3867),
    [anon_sym_UR_DQUOTE] = ACTIONS(3867),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3867),
    [anon_sym_co_await] = ACTIONS(3865),
    [anon_sym_new] = ACTIONS(3865),
    [anon_sym_requires] = ACTIONS(3865),
    [sym_this] = ACTIONS(3865),
    [anon_sym_discard] = ACTIONS(3865),
    [anon_sym_precise] = ACTIONS(3865),
    [anon_sym_shared] = ACTIONS(3865),
    [anon_sym_groupshared] = ACTIONS(3865),
    [anon_sym_uniform] = ACTIONS(3865),
    [anon_sym_row_major] = ACTIONS(3865),
    [anon_sym_column_major] = ACTIONS(3865),
    [anon_sym_globallycoherent] = ACTIONS(3865),
    [anon_sym_centroid] = ACTIONS(3865),
    [anon_sym_noperspective] = ACTIONS(3865),
    [anon_sym_nointerpolation] = ACTIONS(3865),
    [anon_sym_sample] = ACTIONS(3865),
    [anon_sym_linear] = ACTIONS(3865),
    [anon_sym_snorm] = ACTIONS(3865),
    [anon_sym_unorm] = ACTIONS(3865),
    [anon_sym_point] = ACTIONS(3865),
    [anon_sym_line] = ACTIONS(3865),
    [anon_sym_triangleadj] = ACTIONS(3865),
    [anon_sym_lineadj] = ACTIONS(3865),
    [anon_sym_triangle] = ACTIONS(3865),
    [anon_sym_cbuffer] = ACTIONS(3865),
    [anon_sym_interface] = ACTIONS(3865),
    [anon_sym_extension] = ACTIONS(3865),
  },
  [927] = {
    [sym_identifier] = ACTIONS(3889),
    [aux_sym_preproc_include_token1] = ACTIONS(3889),
    [aux_sym_preproc_def_token1] = ACTIONS(3889),
    [aux_sym_preproc_if_token1] = ACTIONS(3889),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3889),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3889),
    [sym_preproc_directive] = ACTIONS(3889),
    [anon_sym_LPAREN2] = ACTIONS(3891),
    [anon_sym_BANG] = ACTIONS(3891),
    [anon_sym_TILDE] = ACTIONS(3891),
    [anon_sym_DASH] = ACTIONS(3889),
    [anon_sym_PLUS] = ACTIONS(3889),
    [anon_sym_STAR] = ACTIONS(3891),
    [anon_sym_AMP_AMP] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3889),
    [anon_sym_SEMI] = ACTIONS(3891),
    [anon_sym___extension__] = ACTIONS(3889),
    [anon_sym_typedef] = ACTIONS(3889),
    [anon_sym_in] = ACTIONS(3889),
    [anon_sym_out] = ACTIONS(3889),
    [anon_sym_inout] = ACTIONS(3889),
    [anon_sym_virtual] = ACTIONS(3889),
    [anon_sym_extern] = ACTIONS(3889),
    [anon_sym___attribute__] = ACTIONS(3889),
    [anon_sym___attribute] = ACTIONS(3889),
    [anon_sym_using] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3891),
    [anon_sym___declspec] = ACTIONS(3889),
    [anon_sym___based] = ACTIONS(3889),
    [anon_sym___cdecl] = ACTIONS(3889),
    [anon_sym___clrcall] = ACTIONS(3889),
    [anon_sym___stdcall] = ACTIONS(3889),
    [anon_sym___fastcall] = ACTIONS(3889),
    [anon_sym___thiscall] = ACTIONS(3889),
    [anon_sym___vectorcall] = ACTIONS(3889),
    [anon_sym_LBRACE] = ACTIONS(3891),
    [anon_sym_RBRACE] = ACTIONS(3891),
    [anon_sym_signed] = ACTIONS(3889),
    [anon_sym_unsigned] = ACTIONS(3889),
    [anon_sym_long] = ACTIONS(3889),
    [anon_sym_short] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_static] = ACTIONS(3889),
    [anon_sym_register] = ACTIONS(3889),
    [anon_sym_inline] = ACTIONS(3889),
    [anon_sym___inline] = ACTIONS(3889),
    [anon_sym___inline__] = ACTIONS(3889),
    [anon_sym___forceinline] = ACTIONS(3889),
    [anon_sym_thread_local] = ACTIONS(3889),
    [anon_sym___thread] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3889),
    [anon_sym_constexpr] = ACTIONS(3889),
    [anon_sym_volatile] = ACTIONS(3889),
    [anon_sym_restrict] = ACTIONS(3889),
    [anon_sym___restrict__] = ACTIONS(3889),
    [anon_sym__Atomic] = ACTIONS(3889),
    [anon_sym__Noreturn] = ACTIONS(3889),
    [anon_sym_noreturn] = ACTIONS(3889),
    [anon_sym__Nonnull] = ACTIONS(3889),
    [anon_sym_mutable] = ACTIONS(3889),
    [anon_sym_constinit] = ACTIONS(3889),
    [anon_sym_consteval] = ACTIONS(3889),
    [anon_sym_alignas] = ACTIONS(3889),
    [anon_sym__Alignas] = ACTIONS(3889),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_enum] = ACTIONS(3889),
    [anon_sym_class] = ACTIONS(3889),
    [anon_sym_struct] = ACTIONS(3889),
    [anon_sym_union] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_switch] = ACTIONS(3889),
    [anon_sym_case] = ACTIONS(3889),
    [anon_sym_default] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_break] = ACTIONS(3889),
    [anon_sym_continue] = ACTIONS(3889),
    [anon_sym_goto] = ACTIONS(3889),
    [anon_sym___try] = ACTIONS(3889),
    [anon_sym___leave] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3889),
    [anon_sym_compl] = ACTIONS(3889),
    [anon_sym_DASH_DASH] = ACTIONS(3891),
    [anon_sym_PLUS_PLUS] = ACTIONS(3891),
    [anon_sym_sizeof] = ACTIONS(3889),
    [anon_sym___alignof__] = ACTIONS(3889),
    [anon_sym___alignof] = ACTIONS(3889),
    [anon_sym__alignof] = ACTIONS(3889),
    [anon_sym_alignof] = ACTIONS(3889),
    [anon_sym__Alignof] = ACTIONS(3889),
    [anon_sym_offsetof] = ACTIONS(3889),
    [anon_sym__Generic] = ACTIONS(3889),
    [anon_sym_asm] = ACTIONS(3889),
    [anon_sym___asm__] = ACTIONS(3889),
    [anon_sym___asm] = ACTIONS(3889),
    [sym_number_literal] = ACTIONS(3891),
    [anon_sym_L_SQUOTE] = ACTIONS(3891),
    [anon_sym_u_SQUOTE] = ACTIONS(3891),
    [anon_sym_U_SQUOTE] = ACTIONS(3891),
    [anon_sym_u8_SQUOTE] = ACTIONS(3891),
    [anon_sym_SQUOTE] = ACTIONS(3891),
    [anon_sym_L_DQUOTE] = ACTIONS(3891),
    [anon_sym_u_DQUOTE] = ACTIONS(3891),
    [anon_sym_U_DQUOTE] = ACTIONS(3891),
    [anon_sym_u8_DQUOTE] = ACTIONS(3891),
    [anon_sym_DQUOTE] = ACTIONS(3891),
    [sym_true] = ACTIONS(3889),
    [sym_false] = ACTIONS(3889),
    [anon_sym_NULL] = ACTIONS(3889),
    [anon_sym_nullptr] = ACTIONS(3889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_This] = ACTIONS(3889),
    [anon_sym_decltype] = ACTIONS(3889),
    [anon_sym_explicit] = ACTIONS(3889),
    [anon_sym_typename] = ACTIONS(3889),
    [anon_sym_template] = ACTIONS(3889),
    [anon_sym_operator] = ACTIONS(3889),
    [anon_sym_try] = ACTIONS(3889),
    [anon_sym_delete] = ACTIONS(3889),
    [anon_sym_throw] = ACTIONS(3889),
    [anon_sym_namespace] = ACTIONS(3889),
    [anon_sym_static_assert] = ACTIONS(3889),
    [anon_sym_concept] = ACTIONS(3889),
    [anon_sym_co_return] = ACTIONS(3889),
    [anon_sym_co_yield] = ACTIONS(3889),
    [anon_sym_R_DQUOTE] = ACTIONS(3891),
    [anon_sym_LR_DQUOTE] = ACTIONS(3891),
    [anon_sym_uR_DQUOTE] = ACTIONS(3891),
    [anon_sym_UR_DQUOTE] = ACTIONS(3891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3891),
    [anon_sym_co_await] = ACTIONS(3889),
    [anon_sym_new] = ACTIONS(3889),
    [anon_sym_requires] = ACTIONS(3889),
    [sym_this] = ACTIONS(3889),
    [anon_sym_discard] = ACTIONS(3889),
    [anon_sym_precise] = ACTIONS(3889),
    [anon_sym_shared] = ACTIONS(3889),
    [anon_sym_groupshared] = ACTIONS(3889),
    [anon_sym_uniform] = ACTIONS(3889),
    [anon_sym_row_major] = ACTIONS(3889),
    [anon_sym_column_major] = ACTIONS(3889),
    [anon_sym_globallycoherent] = ACTIONS(3889),
    [anon_sym_centroid] = ACTIONS(3889),
    [anon_sym_noperspective] = ACTIONS(3889),
    [anon_sym_nointerpolation] = ACTIONS(3889),
    [anon_sym_sample] = ACTIONS(3889),
    [anon_sym_linear] = ACTIONS(3889),
    [anon_sym_snorm] = ACTIONS(3889),
    [anon_sym_unorm] = ACTIONS(3889),
    [anon_sym_point] = ACTIONS(3889),
    [anon_sym_line] = ACTIONS(3889),
    [anon_sym_triangleadj] = ACTIONS(3889),
    [anon_sym_lineadj] = ACTIONS(3889),
    [anon_sym_triangle] = ACTIONS(3889),
    [anon_sym_cbuffer] = ACTIONS(3889),
    [anon_sym_interface] = ACTIONS(3889),
    [anon_sym_extension] = ACTIONS(3889),
  },
  [928] = {
    [ts_builtin_sym_end] = ACTIONS(3794),
    [sym_identifier] = ACTIONS(3792),
    [aux_sym_preproc_include_token1] = ACTIONS(3792),
    [aux_sym_preproc_def_token1] = ACTIONS(3792),
    [aux_sym_preproc_if_token1] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3792),
    [sym_preproc_directive] = ACTIONS(3792),
    [anon_sym_LPAREN2] = ACTIONS(3794),
    [anon_sym_BANG] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3794),
    [anon_sym_DASH] = ACTIONS(3792),
    [anon_sym_PLUS] = ACTIONS(3792),
    [anon_sym_STAR] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_AMP] = ACTIONS(3792),
    [anon_sym_SEMI] = ACTIONS(3794),
    [anon_sym___extension__] = ACTIONS(3792),
    [anon_sym_typedef] = ACTIONS(3792),
    [anon_sym_in] = ACTIONS(3792),
    [anon_sym_out] = ACTIONS(3792),
    [anon_sym_inout] = ACTIONS(3792),
    [anon_sym_virtual] = ACTIONS(3792),
    [anon_sym_extern] = ACTIONS(3792),
    [anon_sym___attribute__] = ACTIONS(3792),
    [anon_sym___attribute] = ACTIONS(3792),
    [anon_sym_using] = ACTIONS(3792),
    [anon_sym_COLON_COLON] = ACTIONS(3794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3794),
    [anon_sym___declspec] = ACTIONS(3792),
    [anon_sym___based] = ACTIONS(3792),
    [anon_sym___cdecl] = ACTIONS(3792),
    [anon_sym___clrcall] = ACTIONS(3792),
    [anon_sym___stdcall] = ACTIONS(3792),
    [anon_sym___fastcall] = ACTIONS(3792),
    [anon_sym___thiscall] = ACTIONS(3792),
    [anon_sym___vectorcall] = ACTIONS(3792),
    [anon_sym_LBRACE] = ACTIONS(3794),
    [anon_sym_signed] = ACTIONS(3792),
    [anon_sym_unsigned] = ACTIONS(3792),
    [anon_sym_long] = ACTIONS(3792),
    [anon_sym_short] = ACTIONS(3792),
    [anon_sym_LBRACK] = ACTIONS(3792),
    [anon_sym_static] = ACTIONS(3792),
    [anon_sym_register] = ACTIONS(3792),
    [anon_sym_inline] = ACTIONS(3792),
    [anon_sym___inline] = ACTIONS(3792),
    [anon_sym___inline__] = ACTIONS(3792),
    [anon_sym___forceinline] = ACTIONS(3792),
    [anon_sym_thread_local] = ACTIONS(3792),
    [anon_sym___thread] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3792),
    [anon_sym_constexpr] = ACTIONS(3792),
    [anon_sym_volatile] = ACTIONS(3792),
    [anon_sym_restrict] = ACTIONS(3792),
    [anon_sym___restrict__] = ACTIONS(3792),
    [anon_sym__Atomic] = ACTIONS(3792),
    [anon_sym__Noreturn] = ACTIONS(3792),
    [anon_sym_noreturn] = ACTIONS(3792),
    [anon_sym__Nonnull] = ACTIONS(3792),
    [anon_sym_mutable] = ACTIONS(3792),
    [anon_sym_constinit] = ACTIONS(3792),
    [anon_sym_consteval] = ACTIONS(3792),
    [anon_sym_alignas] = ACTIONS(3792),
    [anon_sym__Alignas] = ACTIONS(3792),
    [sym_primitive_type] = ACTIONS(3792),
    [anon_sym_enum] = ACTIONS(3792),
    [anon_sym_class] = ACTIONS(3792),
    [anon_sym_struct] = ACTIONS(3792),
    [anon_sym_union] = ACTIONS(3792),
    [anon_sym_if] = ACTIONS(3792),
    [anon_sym_switch] = ACTIONS(3792),
    [anon_sym_case] = ACTIONS(3792),
    [anon_sym_default] = ACTIONS(3792),
    [anon_sym_while] = ACTIONS(3792),
    [anon_sym_do] = ACTIONS(3792),
    [anon_sym_for] = ACTIONS(3792),
    [anon_sym_return] = ACTIONS(3792),
    [anon_sym_break] = ACTIONS(3792),
    [anon_sym_continue] = ACTIONS(3792),
    [anon_sym_goto] = ACTIONS(3792),
    [anon_sym_not] = ACTIONS(3792),
    [anon_sym_compl] = ACTIONS(3792),
    [anon_sym_DASH_DASH] = ACTIONS(3794),
    [anon_sym_PLUS_PLUS] = ACTIONS(3794),
    [anon_sym_sizeof] = ACTIONS(3792),
    [anon_sym___alignof__] = ACTIONS(3792),
    [anon_sym___alignof] = ACTIONS(3792),
    [anon_sym__alignof] = ACTIONS(3792),
    [anon_sym_alignof] = ACTIONS(3792),
    [anon_sym__Alignof] = ACTIONS(3792),
    [anon_sym_offsetof] = ACTIONS(3792),
    [anon_sym__Generic] = ACTIONS(3792),
    [anon_sym_asm] = ACTIONS(3792),
    [anon_sym___asm__] = ACTIONS(3792),
    [anon_sym___asm] = ACTIONS(3792),
    [sym_number_literal] = ACTIONS(3794),
    [anon_sym_L_SQUOTE] = ACTIONS(3794),
    [anon_sym_u_SQUOTE] = ACTIONS(3794),
    [anon_sym_U_SQUOTE] = ACTIONS(3794),
    [anon_sym_u8_SQUOTE] = ACTIONS(3794),
    [anon_sym_SQUOTE] = ACTIONS(3794),
    [anon_sym_L_DQUOTE] = ACTIONS(3794),
    [anon_sym_u_DQUOTE] = ACTIONS(3794),
    [anon_sym_U_DQUOTE] = ACTIONS(3794),
    [anon_sym_u8_DQUOTE] = ACTIONS(3794),
    [anon_sym_DQUOTE] = ACTIONS(3794),
    [sym_true] = ACTIONS(3792),
    [sym_false] = ACTIONS(3792),
    [anon_sym_NULL] = ACTIONS(3792),
    [anon_sym_nullptr] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3792),
    [anon_sym_let] = ACTIONS(3792),
    [anon_sym_This] = ACTIONS(3792),
    [anon_sym_decltype] = ACTIONS(3792),
    [anon_sym_explicit] = ACTIONS(3792),
    [anon_sym_typename] = ACTIONS(3792),
    [anon_sym_export] = ACTIONS(3792),
    [anon_sym_module] = ACTIONS(3792),
    [anon_sym_import] = ACTIONS(3792),
    [anon_sym_template] = ACTIONS(3792),
    [anon_sym_operator] = ACTIONS(3792),
    [anon_sym_try] = ACTIONS(3792),
    [anon_sym_delete] = ACTIONS(3792),
    [anon_sym_throw] = ACTIONS(3792),
    [anon_sym_namespace] = ACTIONS(3792),
    [anon_sym_static_assert] = ACTIONS(3792),
    [anon_sym_concept] = ACTIONS(3792),
    [anon_sym_co_return] = ACTIONS(3792),
    [anon_sym_co_yield] = ACTIONS(3792),
    [anon_sym_R_DQUOTE] = ACTIONS(3794),
    [anon_sym_LR_DQUOTE] = ACTIONS(3794),
    [anon_sym_uR_DQUOTE] = ACTIONS(3794),
    [anon_sym_UR_DQUOTE] = ACTIONS(3794),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3794),
    [anon_sym_co_await] = ACTIONS(3792),
    [anon_sym_new] = ACTIONS(3792),
    [anon_sym_requires] = ACTIONS(3792),
    [sym_this] = ACTIONS(3792),
    [anon_sym_precise] = ACTIONS(3792),
    [anon_sym_shared] = ACTIONS(3792),
    [anon_sym_groupshared] = ACTIONS(3792),
    [anon_sym_uniform] = ACTIONS(3792),
    [anon_sym_row_major] = ACTIONS(3792),
    [anon_sym_column_major] = ACTIONS(3792),
    [anon_sym_globallycoherent] = ACTIONS(3792),
    [anon_sym_centroid] = ACTIONS(3792),
    [anon_sym_noperspective] = ACTIONS(3792),
    [anon_sym_nointerpolation] = ACTIONS(3792),
    [anon_sym_sample] = ACTIONS(3792),
    [anon_sym_linear] = ACTIONS(3792),
    [anon_sym_snorm] = ACTIONS(3792),
    [anon_sym_unorm] = ACTIONS(3792),
    [anon_sym_point] = ACTIONS(3792),
    [anon_sym_line] = ACTIONS(3792),
    [anon_sym_triangleadj] = ACTIONS(3792),
    [anon_sym_lineadj] = ACTIONS(3792),
    [anon_sym_triangle] = ACTIONS(3792),
    [anon_sym_interface] = ACTIONS(3792),
    [anon_sym_extension] = ACTIONS(3792),
    [anon_sym___exported] = ACTIONS(3792),
  },
  [929] = {
    [ts_builtin_sym_end] = ACTIONS(3794),
    [sym_identifier] = ACTIONS(3792),
    [aux_sym_preproc_include_token1] = ACTIONS(3792),
    [aux_sym_preproc_def_token1] = ACTIONS(3792),
    [aux_sym_preproc_if_token1] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3792),
    [sym_preproc_directive] = ACTIONS(3792),
    [anon_sym_LPAREN2] = ACTIONS(3794),
    [anon_sym_BANG] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3794),
    [anon_sym_DASH] = ACTIONS(3792),
    [anon_sym_PLUS] = ACTIONS(3792),
    [anon_sym_STAR] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_AMP] = ACTIONS(3792),
    [anon_sym_SEMI] = ACTIONS(3794),
    [anon_sym___extension__] = ACTIONS(3792),
    [anon_sym_typedef] = ACTIONS(3792),
    [anon_sym_in] = ACTIONS(3792),
    [anon_sym_out] = ACTIONS(3792),
    [anon_sym_inout] = ACTIONS(3792),
    [anon_sym_virtual] = ACTIONS(3792),
    [anon_sym_extern] = ACTIONS(3792),
    [anon_sym___attribute__] = ACTIONS(3792),
    [anon_sym___attribute] = ACTIONS(3792),
    [anon_sym_using] = ACTIONS(3792),
    [anon_sym_COLON_COLON] = ACTIONS(3794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3794),
    [anon_sym___declspec] = ACTIONS(3792),
    [anon_sym___based] = ACTIONS(3792),
    [anon_sym___cdecl] = ACTIONS(3792),
    [anon_sym___clrcall] = ACTIONS(3792),
    [anon_sym___stdcall] = ACTIONS(3792),
    [anon_sym___fastcall] = ACTIONS(3792),
    [anon_sym___thiscall] = ACTIONS(3792),
    [anon_sym___vectorcall] = ACTIONS(3792),
    [anon_sym_LBRACE] = ACTIONS(3794),
    [anon_sym_signed] = ACTIONS(3792),
    [anon_sym_unsigned] = ACTIONS(3792),
    [anon_sym_long] = ACTIONS(3792),
    [anon_sym_short] = ACTIONS(3792),
    [anon_sym_LBRACK] = ACTIONS(3792),
    [anon_sym_static] = ACTIONS(3792),
    [anon_sym_register] = ACTIONS(3792),
    [anon_sym_inline] = ACTIONS(3792),
    [anon_sym___inline] = ACTIONS(3792),
    [anon_sym___inline__] = ACTIONS(3792),
    [anon_sym___forceinline] = ACTIONS(3792),
    [anon_sym_thread_local] = ACTIONS(3792),
    [anon_sym___thread] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3792),
    [anon_sym_constexpr] = ACTIONS(3792),
    [anon_sym_volatile] = ACTIONS(3792),
    [anon_sym_restrict] = ACTIONS(3792),
    [anon_sym___restrict__] = ACTIONS(3792),
    [anon_sym__Atomic] = ACTIONS(3792),
    [anon_sym__Noreturn] = ACTIONS(3792),
    [anon_sym_noreturn] = ACTIONS(3792),
    [anon_sym__Nonnull] = ACTIONS(3792),
    [anon_sym_mutable] = ACTIONS(3792),
    [anon_sym_constinit] = ACTIONS(3792),
    [anon_sym_consteval] = ACTIONS(3792),
    [anon_sym_alignas] = ACTIONS(3792),
    [anon_sym__Alignas] = ACTIONS(3792),
    [sym_primitive_type] = ACTIONS(3792),
    [anon_sym_enum] = ACTIONS(3792),
    [anon_sym_class] = ACTIONS(3792),
    [anon_sym_struct] = ACTIONS(3792),
    [anon_sym_union] = ACTIONS(3792),
    [anon_sym_if] = ACTIONS(3792),
    [anon_sym_switch] = ACTIONS(3792),
    [anon_sym_case] = ACTIONS(3792),
    [anon_sym_default] = ACTIONS(3792),
    [anon_sym_while] = ACTIONS(3792),
    [anon_sym_do] = ACTIONS(3792),
    [anon_sym_for] = ACTIONS(3792),
    [anon_sym_return] = ACTIONS(3792),
    [anon_sym_break] = ACTIONS(3792),
    [anon_sym_continue] = ACTIONS(3792),
    [anon_sym_goto] = ACTIONS(3792),
    [anon_sym_not] = ACTIONS(3792),
    [anon_sym_compl] = ACTIONS(3792),
    [anon_sym_DASH_DASH] = ACTIONS(3794),
    [anon_sym_PLUS_PLUS] = ACTIONS(3794),
    [anon_sym_sizeof] = ACTIONS(3792),
    [anon_sym___alignof__] = ACTIONS(3792),
    [anon_sym___alignof] = ACTIONS(3792),
    [anon_sym__alignof] = ACTIONS(3792),
    [anon_sym_alignof] = ACTIONS(3792),
    [anon_sym__Alignof] = ACTIONS(3792),
    [anon_sym_offsetof] = ACTIONS(3792),
    [anon_sym__Generic] = ACTIONS(3792),
    [anon_sym_asm] = ACTIONS(3792),
    [anon_sym___asm__] = ACTIONS(3792),
    [anon_sym___asm] = ACTIONS(3792),
    [sym_number_literal] = ACTIONS(3794),
    [anon_sym_L_SQUOTE] = ACTIONS(3794),
    [anon_sym_u_SQUOTE] = ACTIONS(3794),
    [anon_sym_U_SQUOTE] = ACTIONS(3794),
    [anon_sym_u8_SQUOTE] = ACTIONS(3794),
    [anon_sym_SQUOTE] = ACTIONS(3794),
    [anon_sym_L_DQUOTE] = ACTIONS(3794),
    [anon_sym_u_DQUOTE] = ACTIONS(3794),
    [anon_sym_U_DQUOTE] = ACTIONS(3794),
    [anon_sym_u8_DQUOTE] = ACTIONS(3794),
    [anon_sym_DQUOTE] = ACTIONS(3794),
    [sym_true] = ACTIONS(3792),
    [sym_false] = ACTIONS(3792),
    [anon_sym_NULL] = ACTIONS(3792),
    [anon_sym_nullptr] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3792),
    [anon_sym_let] = ACTIONS(3792),
    [anon_sym_This] = ACTIONS(3792),
    [anon_sym_decltype] = ACTIONS(3792),
    [anon_sym_explicit] = ACTIONS(3792),
    [anon_sym_typename] = ACTIONS(3792),
    [anon_sym_export] = ACTIONS(3792),
    [anon_sym_module] = ACTIONS(3792),
    [anon_sym_import] = ACTIONS(3792),
    [anon_sym_template] = ACTIONS(3792),
    [anon_sym_operator] = ACTIONS(3792),
    [anon_sym_try] = ACTIONS(3792),
    [anon_sym_delete] = ACTIONS(3792),
    [anon_sym_throw] = ACTIONS(3792),
    [anon_sym_namespace] = ACTIONS(3792),
    [anon_sym_static_assert] = ACTIONS(3792),
    [anon_sym_concept] = ACTIONS(3792),
    [anon_sym_co_return] = ACTIONS(3792),
    [anon_sym_co_yield] = ACTIONS(3792),
    [anon_sym_R_DQUOTE] = ACTIONS(3794),
    [anon_sym_LR_DQUOTE] = ACTIONS(3794),
    [anon_sym_uR_DQUOTE] = ACTIONS(3794),
    [anon_sym_UR_DQUOTE] = ACTIONS(3794),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3794),
    [anon_sym_co_await] = ACTIONS(3792),
    [anon_sym_new] = ACTIONS(3792),
    [anon_sym_requires] = ACTIONS(3792),
    [sym_this] = ACTIONS(3792),
    [anon_sym_precise] = ACTIONS(3792),
    [anon_sym_shared] = ACTIONS(3792),
    [anon_sym_groupshared] = ACTIONS(3792),
    [anon_sym_uniform] = ACTIONS(3792),
    [anon_sym_row_major] = ACTIONS(3792),
    [anon_sym_column_major] = ACTIONS(3792),
    [anon_sym_globallycoherent] = ACTIONS(3792),
    [anon_sym_centroid] = ACTIONS(3792),
    [anon_sym_noperspective] = ACTIONS(3792),
    [anon_sym_nointerpolation] = ACTIONS(3792),
    [anon_sym_sample] = ACTIONS(3792),
    [anon_sym_linear] = ACTIONS(3792),
    [anon_sym_snorm] = ACTIONS(3792),
    [anon_sym_unorm] = ACTIONS(3792),
    [anon_sym_point] = ACTIONS(3792),
    [anon_sym_line] = ACTIONS(3792),
    [anon_sym_triangleadj] = ACTIONS(3792),
    [anon_sym_lineadj] = ACTIONS(3792),
    [anon_sym_triangle] = ACTIONS(3792),
    [anon_sym_interface] = ACTIONS(3792),
    [anon_sym_extension] = ACTIONS(3792),
    [anon_sym___exported] = ACTIONS(3792),
  },
  [930] = {
    [ts_builtin_sym_end] = ACTIONS(3903),
    [sym_identifier] = ACTIONS(3901),
    [aux_sym_preproc_include_token1] = ACTIONS(3901),
    [aux_sym_preproc_def_token1] = ACTIONS(3901),
    [aux_sym_preproc_if_token1] = ACTIONS(3901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3901),
    [sym_preproc_directive] = ACTIONS(3901),
    [anon_sym_LPAREN2] = ACTIONS(3903),
    [anon_sym_BANG] = ACTIONS(3903),
    [anon_sym_TILDE] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3901),
    [anon_sym_STAR] = ACTIONS(3903),
    [anon_sym_AMP_AMP] = ACTIONS(3903),
    [anon_sym_AMP] = ACTIONS(3901),
    [anon_sym_SEMI] = ACTIONS(3903),
    [anon_sym___extension__] = ACTIONS(3901),
    [anon_sym_typedef] = ACTIONS(3901),
    [anon_sym_in] = ACTIONS(3901),
    [anon_sym_out] = ACTIONS(3901),
    [anon_sym_inout] = ACTIONS(3901),
    [anon_sym_virtual] = ACTIONS(3901),
    [anon_sym_extern] = ACTIONS(3901),
    [anon_sym___attribute__] = ACTIONS(3901),
    [anon_sym___attribute] = ACTIONS(3901),
    [anon_sym_using] = ACTIONS(3901),
    [anon_sym_COLON_COLON] = ACTIONS(3903),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3903),
    [anon_sym___declspec] = ACTIONS(3901),
    [anon_sym___based] = ACTIONS(3901),
    [anon_sym___cdecl] = ACTIONS(3901),
    [anon_sym___clrcall] = ACTIONS(3901),
    [anon_sym___stdcall] = ACTIONS(3901),
    [anon_sym___fastcall] = ACTIONS(3901),
    [anon_sym___thiscall] = ACTIONS(3901),
    [anon_sym___vectorcall] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_signed] = ACTIONS(3901),
    [anon_sym_unsigned] = ACTIONS(3901),
    [anon_sym_long] = ACTIONS(3901),
    [anon_sym_short] = ACTIONS(3901),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_static] = ACTIONS(3901),
    [anon_sym_register] = ACTIONS(3901),
    [anon_sym_inline] = ACTIONS(3901),
    [anon_sym___inline] = ACTIONS(3901),
    [anon_sym___inline__] = ACTIONS(3901),
    [anon_sym___forceinline] = ACTIONS(3901),
    [anon_sym_thread_local] = ACTIONS(3901),
    [anon_sym___thread] = ACTIONS(3901),
    [anon_sym_const] = ACTIONS(3901),
    [anon_sym_constexpr] = ACTIONS(3901),
    [anon_sym_volatile] = ACTIONS(3901),
    [anon_sym_restrict] = ACTIONS(3901),
    [anon_sym___restrict__] = ACTIONS(3901),
    [anon_sym__Atomic] = ACTIONS(3901),
    [anon_sym__Noreturn] = ACTIONS(3901),
    [anon_sym_noreturn] = ACTIONS(3901),
    [anon_sym__Nonnull] = ACTIONS(3901),
    [anon_sym_mutable] = ACTIONS(3901),
    [anon_sym_constinit] = ACTIONS(3901),
    [anon_sym_consteval] = ACTIONS(3901),
    [anon_sym_alignas] = ACTIONS(3901),
    [anon_sym__Alignas] = ACTIONS(3901),
    [sym_primitive_type] = ACTIONS(3901),
    [anon_sym_enum] = ACTIONS(3901),
    [anon_sym_class] = ACTIONS(3901),
    [anon_sym_struct] = ACTIONS(3901),
    [anon_sym_union] = ACTIONS(3901),
    [anon_sym_if] = ACTIONS(3901),
    [anon_sym_switch] = ACTIONS(3901),
    [anon_sym_case] = ACTIONS(3901),
    [anon_sym_default] = ACTIONS(3901),
    [anon_sym_while] = ACTIONS(3901),
    [anon_sym_do] = ACTIONS(3901),
    [anon_sym_for] = ACTIONS(3901),
    [anon_sym_return] = ACTIONS(3901),
    [anon_sym_break] = ACTIONS(3901),
    [anon_sym_continue] = ACTIONS(3901),
    [anon_sym_goto] = ACTIONS(3901),
    [anon_sym_not] = ACTIONS(3901),
    [anon_sym_compl] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3903),
    [anon_sym_PLUS_PLUS] = ACTIONS(3903),
    [anon_sym_sizeof] = ACTIONS(3901),
    [anon_sym___alignof__] = ACTIONS(3901),
    [anon_sym___alignof] = ACTIONS(3901),
    [anon_sym__alignof] = ACTIONS(3901),
    [anon_sym_alignof] = ACTIONS(3901),
    [anon_sym__Alignof] = ACTIONS(3901),
    [anon_sym_offsetof] = ACTIONS(3901),
    [anon_sym__Generic] = ACTIONS(3901),
    [anon_sym_asm] = ACTIONS(3901),
    [anon_sym___asm__] = ACTIONS(3901),
    [anon_sym___asm] = ACTIONS(3901),
    [sym_number_literal] = ACTIONS(3903),
    [anon_sym_L_SQUOTE] = ACTIONS(3903),
    [anon_sym_u_SQUOTE] = ACTIONS(3903),
    [anon_sym_U_SQUOTE] = ACTIONS(3903),
    [anon_sym_u8_SQUOTE] = ACTIONS(3903),
    [anon_sym_SQUOTE] = ACTIONS(3903),
    [anon_sym_L_DQUOTE] = ACTIONS(3903),
    [anon_sym_u_DQUOTE] = ACTIONS(3903),
    [anon_sym_U_DQUOTE] = ACTIONS(3903),
    [anon_sym_u8_DQUOTE] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(3903),
    [sym_true] = ACTIONS(3901),
    [sym_false] = ACTIONS(3901),
    [anon_sym_NULL] = ACTIONS(3901),
    [anon_sym_nullptr] = ACTIONS(3901),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3901),
    [anon_sym_let] = ACTIONS(3901),
    [anon_sym_This] = ACTIONS(3901),
    [anon_sym_decltype] = ACTIONS(3901),
    [anon_sym_explicit] = ACTIONS(3901),
    [anon_sym_typename] = ACTIONS(3901),
    [anon_sym_export] = ACTIONS(3901),
    [anon_sym_module] = ACTIONS(3901),
    [anon_sym_import] = ACTIONS(3901),
    [anon_sym_template] = ACTIONS(3901),
    [anon_sym_operator] = ACTIONS(3901),
    [anon_sym_try] = ACTIONS(3901),
    [anon_sym_delete] = ACTIONS(3901),
    [anon_sym_throw] = ACTIONS(3901),
    [anon_sym_namespace] = ACTIONS(3901),
    [anon_sym_static_assert] = ACTIONS(3901),
    [anon_sym_concept] = ACTIONS(3901),
    [anon_sym_co_return] = ACTIONS(3901),
    [anon_sym_co_yield] = ACTIONS(3901),
    [anon_sym_R_DQUOTE] = ACTIONS(3903),
    [anon_sym_LR_DQUOTE] = ACTIONS(3903),
    [anon_sym_uR_DQUOTE] = ACTIONS(3903),
    [anon_sym_UR_DQUOTE] = ACTIONS(3903),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3903),
    [anon_sym_co_await] = ACTIONS(3901),
    [anon_sym_new] = ACTIONS(3901),
    [anon_sym_requires] = ACTIONS(3901),
    [sym_this] = ACTIONS(3901),
    [anon_sym_precise] = ACTIONS(3901),
    [anon_sym_shared] = ACTIONS(3901),
    [anon_sym_groupshared] = ACTIONS(3901),
    [anon_sym_uniform] = ACTIONS(3901),
    [anon_sym_row_major] = ACTIONS(3901),
    [anon_sym_column_major] = ACTIONS(3901),
    [anon_sym_globallycoherent] = ACTIONS(3901),
    [anon_sym_centroid] = ACTIONS(3901),
    [anon_sym_noperspective] = ACTIONS(3901),
    [anon_sym_nointerpolation] = ACTIONS(3901),
    [anon_sym_sample] = ACTIONS(3901),
    [anon_sym_linear] = ACTIONS(3901),
    [anon_sym_snorm] = ACTIONS(3901),
    [anon_sym_unorm] = ACTIONS(3901),
    [anon_sym_point] = ACTIONS(3901),
    [anon_sym_line] = ACTIONS(3901),
    [anon_sym_triangleadj] = ACTIONS(3901),
    [anon_sym_lineadj] = ACTIONS(3901),
    [anon_sym_triangle] = ACTIONS(3901),
    [anon_sym_interface] = ACTIONS(3901),
    [anon_sym_extension] = ACTIONS(3901),
    [anon_sym___exported] = ACTIONS(3901),
  },
  [931] = {
    [sym_identifier] = ACTIONS(3905),
    [aux_sym_preproc_include_token1] = ACTIONS(3905),
    [aux_sym_preproc_def_token1] = ACTIONS(3905),
    [aux_sym_preproc_if_token1] = ACTIONS(3905),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3905),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3905),
    [sym_preproc_directive] = ACTIONS(3905),
    [anon_sym_LPAREN2] = ACTIONS(3907),
    [anon_sym_BANG] = ACTIONS(3907),
    [anon_sym_TILDE] = ACTIONS(3907),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3907),
    [anon_sym_AMP_AMP] = ACTIONS(3907),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_SEMI] = ACTIONS(3907),
    [anon_sym___extension__] = ACTIONS(3905),
    [anon_sym_typedef] = ACTIONS(3905),
    [anon_sym_in] = ACTIONS(3905),
    [anon_sym_out] = ACTIONS(3905),
    [anon_sym_inout] = ACTIONS(3905),
    [anon_sym_virtual] = ACTIONS(3905),
    [anon_sym_extern] = ACTIONS(3905),
    [anon_sym___attribute__] = ACTIONS(3905),
    [anon_sym___attribute] = ACTIONS(3905),
    [anon_sym_using] = ACTIONS(3905),
    [anon_sym_COLON_COLON] = ACTIONS(3907),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3907),
    [anon_sym___declspec] = ACTIONS(3905),
    [anon_sym___based] = ACTIONS(3905),
    [anon_sym___cdecl] = ACTIONS(3905),
    [anon_sym___clrcall] = ACTIONS(3905),
    [anon_sym___stdcall] = ACTIONS(3905),
    [anon_sym___fastcall] = ACTIONS(3905),
    [anon_sym___thiscall] = ACTIONS(3905),
    [anon_sym___vectorcall] = ACTIONS(3905),
    [anon_sym_LBRACE] = ACTIONS(3907),
    [anon_sym_RBRACE] = ACTIONS(3907),
    [anon_sym_signed] = ACTIONS(3905),
    [anon_sym_unsigned] = ACTIONS(3905),
    [anon_sym_long] = ACTIONS(3905),
    [anon_sym_short] = ACTIONS(3905),
    [anon_sym_LBRACK] = ACTIONS(3905),
    [anon_sym_static] = ACTIONS(3905),
    [anon_sym_register] = ACTIONS(3905),
    [anon_sym_inline] = ACTIONS(3905),
    [anon_sym___inline] = ACTIONS(3905),
    [anon_sym___inline__] = ACTIONS(3905),
    [anon_sym___forceinline] = ACTIONS(3905),
    [anon_sym_thread_local] = ACTIONS(3905),
    [anon_sym___thread] = ACTIONS(3905),
    [anon_sym_const] = ACTIONS(3905),
    [anon_sym_constexpr] = ACTIONS(3905),
    [anon_sym_volatile] = ACTIONS(3905),
    [anon_sym_restrict] = ACTIONS(3905),
    [anon_sym___restrict__] = ACTIONS(3905),
    [anon_sym__Atomic] = ACTIONS(3905),
    [anon_sym__Noreturn] = ACTIONS(3905),
    [anon_sym_noreturn] = ACTIONS(3905),
    [anon_sym__Nonnull] = ACTIONS(3905),
    [anon_sym_mutable] = ACTIONS(3905),
    [anon_sym_constinit] = ACTIONS(3905),
    [anon_sym_consteval] = ACTIONS(3905),
    [anon_sym_alignas] = ACTIONS(3905),
    [anon_sym__Alignas] = ACTIONS(3905),
    [sym_primitive_type] = ACTIONS(3905),
    [anon_sym_enum] = ACTIONS(3905),
    [anon_sym_class] = ACTIONS(3905),
    [anon_sym_struct] = ACTIONS(3905),
    [anon_sym_union] = ACTIONS(3905),
    [anon_sym_if] = ACTIONS(3905),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_case] = ACTIONS(3905),
    [anon_sym_default] = ACTIONS(3905),
    [anon_sym_while] = ACTIONS(3905),
    [anon_sym_do] = ACTIONS(3905),
    [anon_sym_for] = ACTIONS(3905),
    [anon_sym_return] = ACTIONS(3905),
    [anon_sym_break] = ACTIONS(3905),
    [anon_sym_continue] = ACTIONS(3905),
    [anon_sym_goto] = ACTIONS(3905),
    [anon_sym___try] = ACTIONS(3905),
    [anon_sym___leave] = ACTIONS(3905),
    [anon_sym_not] = ACTIONS(3905),
    [anon_sym_compl] = ACTIONS(3905),
    [anon_sym_DASH_DASH] = ACTIONS(3907),
    [anon_sym_PLUS_PLUS] = ACTIONS(3907),
    [anon_sym_sizeof] = ACTIONS(3905),
    [anon_sym___alignof__] = ACTIONS(3905),
    [anon_sym___alignof] = ACTIONS(3905),
    [anon_sym__alignof] = ACTIONS(3905),
    [anon_sym_alignof] = ACTIONS(3905),
    [anon_sym__Alignof] = ACTIONS(3905),
    [anon_sym_offsetof] = ACTIONS(3905),
    [anon_sym__Generic] = ACTIONS(3905),
    [anon_sym_asm] = ACTIONS(3905),
    [anon_sym___asm__] = ACTIONS(3905),
    [anon_sym___asm] = ACTIONS(3905),
    [sym_number_literal] = ACTIONS(3907),
    [anon_sym_L_SQUOTE] = ACTIONS(3907),
    [anon_sym_u_SQUOTE] = ACTIONS(3907),
    [anon_sym_U_SQUOTE] = ACTIONS(3907),
    [anon_sym_u8_SQUOTE] = ACTIONS(3907),
    [anon_sym_SQUOTE] = ACTIONS(3907),
    [anon_sym_L_DQUOTE] = ACTIONS(3907),
    [anon_sym_u_DQUOTE] = ACTIONS(3907),
    [anon_sym_U_DQUOTE] = ACTIONS(3907),
    [anon_sym_u8_DQUOTE] = ACTIONS(3907),
    [anon_sym_DQUOTE] = ACTIONS(3907),
    [sym_true] = ACTIONS(3905),
    [sym_false] = ACTIONS(3905),
    [anon_sym_NULL] = ACTIONS(3905),
    [anon_sym_nullptr] = ACTIONS(3905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3905),
    [anon_sym_let] = ACTIONS(3905),
    [anon_sym_This] = ACTIONS(3905),
    [anon_sym_decltype] = ACTIONS(3905),
    [anon_sym_explicit] = ACTIONS(3905),
    [anon_sym_typename] = ACTIONS(3905),
    [anon_sym_template] = ACTIONS(3905),
    [anon_sym_operator] = ACTIONS(3905),
    [anon_sym_try] = ACTIONS(3905),
    [anon_sym_delete] = ACTIONS(3905),
    [anon_sym_throw] = ACTIONS(3905),
    [anon_sym_namespace] = ACTIONS(3905),
    [anon_sym_static_assert] = ACTIONS(3905),
    [anon_sym_concept] = ACTIONS(3905),
    [anon_sym_co_return] = ACTIONS(3905),
    [anon_sym_co_yield] = ACTIONS(3905),
    [anon_sym_R_DQUOTE] = ACTIONS(3907),
    [anon_sym_LR_DQUOTE] = ACTIONS(3907),
    [anon_sym_uR_DQUOTE] = ACTIONS(3907),
    [anon_sym_UR_DQUOTE] = ACTIONS(3907),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3907),
    [anon_sym_co_await] = ACTIONS(3905),
    [anon_sym_new] = ACTIONS(3905),
    [anon_sym_requires] = ACTIONS(3905),
    [sym_this] = ACTIONS(3905),
    [anon_sym_discard] = ACTIONS(3905),
    [anon_sym_precise] = ACTIONS(3905),
    [anon_sym_shared] = ACTIONS(3905),
    [anon_sym_groupshared] = ACTIONS(3905),
    [anon_sym_uniform] = ACTIONS(3905),
    [anon_sym_row_major] = ACTIONS(3905),
    [anon_sym_column_major] = ACTIONS(3905),
    [anon_sym_globallycoherent] = ACTIONS(3905),
    [anon_sym_centroid] = ACTIONS(3905),
    [anon_sym_noperspective] = ACTIONS(3905),
    [anon_sym_nointerpolation] = ACTIONS(3905),
    [anon_sym_sample] = ACTIONS(3905),
    [anon_sym_linear] = ACTIONS(3905),
    [anon_sym_snorm] = ACTIONS(3905),
    [anon_sym_unorm] = ACTIONS(3905),
    [anon_sym_point] = ACTIONS(3905),
    [anon_sym_line] = ACTIONS(3905),
    [anon_sym_triangleadj] = ACTIONS(3905),
    [anon_sym_lineadj] = ACTIONS(3905),
    [anon_sym_triangle] = ACTIONS(3905),
    [anon_sym_cbuffer] = ACTIONS(3905),
    [anon_sym_interface] = ACTIONS(3905),
    [anon_sym_extension] = ACTIONS(3905),
  },
  [932] = {
    [sym_identifier] = ACTIONS(3691),
    [aux_sym_preproc_include_token1] = ACTIONS(3691),
    [aux_sym_preproc_def_token1] = ACTIONS(3691),
    [aux_sym_preproc_if_token1] = ACTIONS(3691),
    [aux_sym_preproc_if_token2] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3691),
    [sym_preproc_directive] = ACTIONS(3691),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_BANG] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_PLUS] = ACTIONS(3691),
    [anon_sym_STAR] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_AMP] = ACTIONS(3691),
    [anon_sym_SEMI] = ACTIONS(3693),
    [anon_sym___extension__] = ACTIONS(3691),
    [anon_sym_typedef] = ACTIONS(3691),
    [anon_sym_in] = ACTIONS(3691),
    [anon_sym_out] = ACTIONS(3691),
    [anon_sym_inout] = ACTIONS(3691),
    [anon_sym_virtual] = ACTIONS(3691),
    [anon_sym_extern] = ACTIONS(3691),
    [anon_sym___attribute__] = ACTIONS(3691),
    [anon_sym___attribute] = ACTIONS(3691),
    [anon_sym_using] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3693),
    [anon_sym___declspec] = ACTIONS(3691),
    [anon_sym___based] = ACTIONS(3691),
    [anon_sym___cdecl] = ACTIONS(3691),
    [anon_sym___clrcall] = ACTIONS(3691),
    [anon_sym___stdcall] = ACTIONS(3691),
    [anon_sym___fastcall] = ACTIONS(3691),
    [anon_sym___thiscall] = ACTIONS(3691),
    [anon_sym___vectorcall] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_signed] = ACTIONS(3691),
    [anon_sym_unsigned] = ACTIONS(3691),
    [anon_sym_long] = ACTIONS(3691),
    [anon_sym_short] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(3691),
    [anon_sym_static] = ACTIONS(3691),
    [anon_sym_register] = ACTIONS(3691),
    [anon_sym_inline] = ACTIONS(3691),
    [anon_sym___inline] = ACTIONS(3691),
    [anon_sym___inline__] = ACTIONS(3691),
    [anon_sym___forceinline] = ACTIONS(3691),
    [anon_sym_thread_local] = ACTIONS(3691),
    [anon_sym___thread] = ACTIONS(3691),
    [anon_sym_const] = ACTIONS(3691),
    [anon_sym_constexpr] = ACTIONS(3691),
    [anon_sym_volatile] = ACTIONS(3691),
    [anon_sym_restrict] = ACTIONS(3691),
    [anon_sym___restrict__] = ACTIONS(3691),
    [anon_sym__Atomic] = ACTIONS(3691),
    [anon_sym__Noreturn] = ACTIONS(3691),
    [anon_sym_noreturn] = ACTIONS(3691),
    [anon_sym__Nonnull] = ACTIONS(3691),
    [anon_sym_mutable] = ACTIONS(3691),
    [anon_sym_constinit] = ACTIONS(3691),
    [anon_sym_consteval] = ACTIONS(3691),
    [anon_sym_alignas] = ACTIONS(3691),
    [anon_sym__Alignas] = ACTIONS(3691),
    [sym_primitive_type] = ACTIONS(3691),
    [anon_sym_enum] = ACTIONS(3691),
    [anon_sym_class] = ACTIONS(3691),
    [anon_sym_struct] = ACTIONS(3691),
    [anon_sym_union] = ACTIONS(3691),
    [anon_sym_if] = ACTIONS(3691),
    [anon_sym_switch] = ACTIONS(3691),
    [anon_sym_case] = ACTIONS(3691),
    [anon_sym_default] = ACTIONS(3691),
    [anon_sym_while] = ACTIONS(3691),
    [anon_sym_do] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3691),
    [anon_sym_return] = ACTIONS(3691),
    [anon_sym_break] = ACTIONS(3691),
    [anon_sym_continue] = ACTIONS(3691),
    [anon_sym_goto] = ACTIONS(3691),
    [anon_sym___try] = ACTIONS(3691),
    [anon_sym___leave] = ACTIONS(3691),
    [anon_sym_not] = ACTIONS(3691),
    [anon_sym_compl] = ACTIONS(3691),
    [anon_sym_DASH_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_PLUS] = ACTIONS(3693),
    [anon_sym_sizeof] = ACTIONS(3691),
    [anon_sym___alignof__] = ACTIONS(3691),
    [anon_sym___alignof] = ACTIONS(3691),
    [anon_sym__alignof] = ACTIONS(3691),
    [anon_sym_alignof] = ACTIONS(3691),
    [anon_sym__Alignof] = ACTIONS(3691),
    [anon_sym_offsetof] = ACTIONS(3691),
    [anon_sym__Generic] = ACTIONS(3691),
    [anon_sym_asm] = ACTIONS(3691),
    [anon_sym___asm__] = ACTIONS(3691),
    [anon_sym___asm] = ACTIONS(3691),
    [sym_number_literal] = ACTIONS(3693),
    [anon_sym_L_SQUOTE] = ACTIONS(3693),
    [anon_sym_u_SQUOTE] = ACTIONS(3693),
    [anon_sym_U_SQUOTE] = ACTIONS(3693),
    [anon_sym_u8_SQUOTE] = ACTIONS(3693),
    [anon_sym_SQUOTE] = ACTIONS(3693),
    [anon_sym_L_DQUOTE] = ACTIONS(3693),
    [anon_sym_u_DQUOTE] = ACTIONS(3693),
    [anon_sym_U_DQUOTE] = ACTIONS(3693),
    [anon_sym_u8_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [sym_true] = ACTIONS(3691),
    [sym_false] = ACTIONS(3691),
    [anon_sym_NULL] = ACTIONS(3691),
    [anon_sym_nullptr] = ACTIONS(3691),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3691),
    [anon_sym_let] = ACTIONS(3691),
    [anon_sym_This] = ACTIONS(3691),
    [anon_sym_decltype] = ACTIONS(3691),
    [anon_sym_explicit] = ACTIONS(3691),
    [anon_sym_typename] = ACTIONS(3691),
    [anon_sym_template] = ACTIONS(3691),
    [anon_sym_operator] = ACTIONS(3691),
    [anon_sym_try] = ACTIONS(3691),
    [anon_sym_delete] = ACTIONS(3691),
    [anon_sym_throw] = ACTIONS(3691),
    [anon_sym_namespace] = ACTIONS(3691),
    [anon_sym_static_assert] = ACTIONS(3691),
    [anon_sym_concept] = ACTIONS(3691),
    [anon_sym_co_return] = ACTIONS(3691),
    [anon_sym_co_yield] = ACTIONS(3691),
    [anon_sym_R_DQUOTE] = ACTIONS(3693),
    [anon_sym_LR_DQUOTE] = ACTIONS(3693),
    [anon_sym_uR_DQUOTE] = ACTIONS(3693),
    [anon_sym_UR_DQUOTE] = ACTIONS(3693),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3693),
    [anon_sym_co_await] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3691),
    [anon_sym_requires] = ACTIONS(3691),
    [sym_this] = ACTIONS(3691),
    [anon_sym_discard] = ACTIONS(3691),
    [anon_sym_precise] = ACTIONS(3691),
    [anon_sym_shared] = ACTIONS(3691),
    [anon_sym_groupshared] = ACTIONS(3691),
    [anon_sym_uniform] = ACTIONS(3691),
    [anon_sym_row_major] = ACTIONS(3691),
    [anon_sym_column_major] = ACTIONS(3691),
    [anon_sym_globallycoherent] = ACTIONS(3691),
    [anon_sym_centroid] = ACTIONS(3691),
    [anon_sym_noperspective] = ACTIONS(3691),
    [anon_sym_nointerpolation] = ACTIONS(3691),
    [anon_sym_sample] = ACTIONS(3691),
    [anon_sym_linear] = ACTIONS(3691),
    [anon_sym_snorm] = ACTIONS(3691),
    [anon_sym_unorm] = ACTIONS(3691),
    [anon_sym_point] = ACTIONS(3691),
    [anon_sym_line] = ACTIONS(3691),
    [anon_sym_triangleadj] = ACTIONS(3691),
    [anon_sym_lineadj] = ACTIONS(3691),
    [anon_sym_triangle] = ACTIONS(3691),
    [anon_sym_cbuffer] = ACTIONS(3691),
    [anon_sym_interface] = ACTIONS(3691),
    [anon_sym_extension] = ACTIONS(3691),
  },
  [933] = {
    [sym_identifier] = ACTIONS(3909),
    [aux_sym_preproc_include_token1] = ACTIONS(3909),
    [aux_sym_preproc_def_token1] = ACTIONS(3909),
    [aux_sym_preproc_if_token1] = ACTIONS(3909),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3909),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3909),
    [sym_preproc_directive] = ACTIONS(3909),
    [anon_sym_LPAREN2] = ACTIONS(3911),
    [anon_sym_BANG] = ACTIONS(3911),
    [anon_sym_TILDE] = ACTIONS(3911),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_SEMI] = ACTIONS(3911),
    [anon_sym___extension__] = ACTIONS(3909),
    [anon_sym_typedef] = ACTIONS(3909),
    [anon_sym_in] = ACTIONS(3909),
    [anon_sym_out] = ACTIONS(3909),
    [anon_sym_inout] = ACTIONS(3909),
    [anon_sym_virtual] = ACTIONS(3909),
    [anon_sym_extern] = ACTIONS(3909),
    [anon_sym___attribute__] = ACTIONS(3909),
    [anon_sym___attribute] = ACTIONS(3909),
    [anon_sym_using] = ACTIONS(3909),
    [anon_sym_COLON_COLON] = ACTIONS(3911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3911),
    [anon_sym___declspec] = ACTIONS(3909),
    [anon_sym___based] = ACTIONS(3909),
    [anon_sym___cdecl] = ACTIONS(3909),
    [anon_sym___clrcall] = ACTIONS(3909),
    [anon_sym___stdcall] = ACTIONS(3909),
    [anon_sym___fastcall] = ACTIONS(3909),
    [anon_sym___thiscall] = ACTIONS(3909),
    [anon_sym___vectorcall] = ACTIONS(3909),
    [anon_sym_LBRACE] = ACTIONS(3911),
    [anon_sym_RBRACE] = ACTIONS(3911),
    [anon_sym_signed] = ACTIONS(3909),
    [anon_sym_unsigned] = ACTIONS(3909),
    [anon_sym_long] = ACTIONS(3909),
    [anon_sym_short] = ACTIONS(3909),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_static] = ACTIONS(3909),
    [anon_sym_register] = ACTIONS(3909),
    [anon_sym_inline] = ACTIONS(3909),
    [anon_sym___inline] = ACTIONS(3909),
    [anon_sym___inline__] = ACTIONS(3909),
    [anon_sym___forceinline] = ACTIONS(3909),
    [anon_sym_thread_local] = ACTIONS(3909),
    [anon_sym___thread] = ACTIONS(3909),
    [anon_sym_const] = ACTIONS(3909),
    [anon_sym_constexpr] = ACTIONS(3909),
    [anon_sym_volatile] = ACTIONS(3909),
    [anon_sym_restrict] = ACTIONS(3909),
    [anon_sym___restrict__] = ACTIONS(3909),
    [anon_sym__Atomic] = ACTIONS(3909),
    [anon_sym__Noreturn] = ACTIONS(3909),
    [anon_sym_noreturn] = ACTIONS(3909),
    [anon_sym__Nonnull] = ACTIONS(3909),
    [anon_sym_mutable] = ACTIONS(3909),
    [anon_sym_constinit] = ACTIONS(3909),
    [anon_sym_consteval] = ACTIONS(3909),
    [anon_sym_alignas] = ACTIONS(3909),
    [anon_sym__Alignas] = ACTIONS(3909),
    [sym_primitive_type] = ACTIONS(3909),
    [anon_sym_enum] = ACTIONS(3909),
    [anon_sym_class] = ACTIONS(3909),
    [anon_sym_struct] = ACTIONS(3909),
    [anon_sym_union] = ACTIONS(3909),
    [anon_sym_if] = ACTIONS(3909),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_case] = ACTIONS(3909),
    [anon_sym_default] = ACTIONS(3909),
    [anon_sym_while] = ACTIONS(3909),
    [anon_sym_do] = ACTIONS(3909),
    [anon_sym_for] = ACTIONS(3909),
    [anon_sym_return] = ACTIONS(3909),
    [anon_sym_break] = ACTIONS(3909),
    [anon_sym_continue] = ACTIONS(3909),
    [anon_sym_goto] = ACTIONS(3909),
    [anon_sym___try] = ACTIONS(3909),
    [anon_sym___leave] = ACTIONS(3909),
    [anon_sym_not] = ACTIONS(3909),
    [anon_sym_compl] = ACTIONS(3909),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_sizeof] = ACTIONS(3909),
    [anon_sym___alignof__] = ACTIONS(3909),
    [anon_sym___alignof] = ACTIONS(3909),
    [anon_sym__alignof] = ACTIONS(3909),
    [anon_sym_alignof] = ACTIONS(3909),
    [anon_sym__Alignof] = ACTIONS(3909),
    [anon_sym_offsetof] = ACTIONS(3909),
    [anon_sym__Generic] = ACTIONS(3909),
    [anon_sym_asm] = ACTIONS(3909),
    [anon_sym___asm__] = ACTIONS(3909),
    [anon_sym___asm] = ACTIONS(3909),
    [sym_number_literal] = ACTIONS(3911),
    [anon_sym_L_SQUOTE] = ACTIONS(3911),
    [anon_sym_u_SQUOTE] = ACTIONS(3911),
    [anon_sym_U_SQUOTE] = ACTIONS(3911),
    [anon_sym_u8_SQUOTE] = ACTIONS(3911),
    [anon_sym_SQUOTE] = ACTIONS(3911),
    [anon_sym_L_DQUOTE] = ACTIONS(3911),
    [anon_sym_u_DQUOTE] = ACTIONS(3911),
    [anon_sym_U_DQUOTE] = ACTIONS(3911),
    [anon_sym_u8_DQUOTE] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [sym_true] = ACTIONS(3909),
    [sym_false] = ACTIONS(3909),
    [anon_sym_NULL] = ACTIONS(3909),
    [anon_sym_nullptr] = ACTIONS(3909),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3909),
    [anon_sym_let] = ACTIONS(3909),
    [anon_sym_This] = ACTIONS(3909),
    [anon_sym_decltype] = ACTIONS(3909),
    [anon_sym_explicit] = ACTIONS(3909),
    [anon_sym_typename] = ACTIONS(3909),
    [anon_sym_template] = ACTIONS(3909),
    [anon_sym_operator] = ACTIONS(3909),
    [anon_sym_try] = ACTIONS(3909),
    [anon_sym_delete] = ACTIONS(3909),
    [anon_sym_throw] = ACTIONS(3909),
    [anon_sym_namespace] = ACTIONS(3909),
    [anon_sym_static_assert] = ACTIONS(3909),
    [anon_sym_concept] = ACTIONS(3909),
    [anon_sym_co_return] = ACTIONS(3909),
    [anon_sym_co_yield] = ACTIONS(3909),
    [anon_sym_R_DQUOTE] = ACTIONS(3911),
    [anon_sym_LR_DQUOTE] = ACTIONS(3911),
    [anon_sym_uR_DQUOTE] = ACTIONS(3911),
    [anon_sym_UR_DQUOTE] = ACTIONS(3911),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3911),
    [anon_sym_co_await] = ACTIONS(3909),
    [anon_sym_new] = ACTIONS(3909),
    [anon_sym_requires] = ACTIONS(3909),
    [sym_this] = ACTIONS(3909),
    [anon_sym_discard] = ACTIONS(3909),
    [anon_sym_precise] = ACTIONS(3909),
    [anon_sym_shared] = ACTIONS(3909),
    [anon_sym_groupshared] = ACTIONS(3909),
    [anon_sym_uniform] = ACTIONS(3909),
    [anon_sym_row_major] = ACTIONS(3909),
    [anon_sym_column_major] = ACTIONS(3909),
    [anon_sym_globallycoherent] = ACTIONS(3909),
    [anon_sym_centroid] = ACTIONS(3909),
    [anon_sym_noperspective] = ACTIONS(3909),
    [anon_sym_nointerpolation] = ACTIONS(3909),
    [anon_sym_sample] = ACTIONS(3909),
    [anon_sym_linear] = ACTIONS(3909),
    [anon_sym_snorm] = ACTIONS(3909),
    [anon_sym_unorm] = ACTIONS(3909),
    [anon_sym_point] = ACTIONS(3909),
    [anon_sym_line] = ACTIONS(3909),
    [anon_sym_triangleadj] = ACTIONS(3909),
    [anon_sym_lineadj] = ACTIONS(3909),
    [anon_sym_triangle] = ACTIONS(3909),
    [anon_sym_cbuffer] = ACTIONS(3909),
    [anon_sym_interface] = ACTIONS(3909),
    [anon_sym_extension] = ACTIONS(3909),
  },
  [934] = {
    [ts_builtin_sym_end] = ACTIONS(3798),
    [sym_identifier] = ACTIONS(3796),
    [aux_sym_preproc_include_token1] = ACTIONS(3796),
    [aux_sym_preproc_def_token1] = ACTIONS(3796),
    [aux_sym_preproc_if_token1] = ACTIONS(3796),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3796),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3796),
    [sym_preproc_directive] = ACTIONS(3796),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3798),
    [anon_sym_TILDE] = ACTIONS(3798),
    [anon_sym_DASH] = ACTIONS(3796),
    [anon_sym_PLUS] = ACTIONS(3796),
    [anon_sym_STAR] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_AMP] = ACTIONS(3796),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym___extension__] = ACTIONS(3796),
    [anon_sym_typedef] = ACTIONS(3796),
    [anon_sym_in] = ACTIONS(3796),
    [anon_sym_out] = ACTIONS(3796),
    [anon_sym_inout] = ACTIONS(3796),
    [anon_sym_virtual] = ACTIONS(3796),
    [anon_sym_extern] = ACTIONS(3796),
    [anon_sym___attribute__] = ACTIONS(3796),
    [anon_sym___attribute] = ACTIONS(3796),
    [anon_sym_using] = ACTIONS(3796),
    [anon_sym_COLON_COLON] = ACTIONS(3798),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3798),
    [anon_sym___declspec] = ACTIONS(3796),
    [anon_sym___based] = ACTIONS(3796),
    [anon_sym___cdecl] = ACTIONS(3796),
    [anon_sym___clrcall] = ACTIONS(3796),
    [anon_sym___stdcall] = ACTIONS(3796),
    [anon_sym___fastcall] = ACTIONS(3796),
    [anon_sym___thiscall] = ACTIONS(3796),
    [anon_sym___vectorcall] = ACTIONS(3796),
    [anon_sym_LBRACE] = ACTIONS(3798),
    [anon_sym_signed] = ACTIONS(3796),
    [anon_sym_unsigned] = ACTIONS(3796),
    [anon_sym_long] = ACTIONS(3796),
    [anon_sym_short] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3796),
    [anon_sym_static] = ACTIONS(3796),
    [anon_sym_register] = ACTIONS(3796),
    [anon_sym_inline] = ACTIONS(3796),
    [anon_sym___inline] = ACTIONS(3796),
    [anon_sym___inline__] = ACTIONS(3796),
    [anon_sym___forceinline] = ACTIONS(3796),
    [anon_sym_thread_local] = ACTIONS(3796),
    [anon_sym___thread] = ACTIONS(3796),
    [anon_sym_const] = ACTIONS(3796),
    [anon_sym_constexpr] = ACTIONS(3796),
    [anon_sym_volatile] = ACTIONS(3796),
    [anon_sym_restrict] = ACTIONS(3796),
    [anon_sym___restrict__] = ACTIONS(3796),
    [anon_sym__Atomic] = ACTIONS(3796),
    [anon_sym__Noreturn] = ACTIONS(3796),
    [anon_sym_noreturn] = ACTIONS(3796),
    [anon_sym__Nonnull] = ACTIONS(3796),
    [anon_sym_mutable] = ACTIONS(3796),
    [anon_sym_constinit] = ACTIONS(3796),
    [anon_sym_consteval] = ACTIONS(3796),
    [anon_sym_alignas] = ACTIONS(3796),
    [anon_sym__Alignas] = ACTIONS(3796),
    [sym_primitive_type] = ACTIONS(3796),
    [anon_sym_enum] = ACTIONS(3796),
    [anon_sym_class] = ACTIONS(3796),
    [anon_sym_struct] = ACTIONS(3796),
    [anon_sym_union] = ACTIONS(3796),
    [anon_sym_if] = ACTIONS(3796),
    [anon_sym_switch] = ACTIONS(3796),
    [anon_sym_case] = ACTIONS(3796),
    [anon_sym_default] = ACTIONS(3796),
    [anon_sym_while] = ACTIONS(3796),
    [anon_sym_do] = ACTIONS(3796),
    [anon_sym_for] = ACTIONS(3796),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_continue] = ACTIONS(3796),
    [anon_sym_goto] = ACTIONS(3796),
    [anon_sym_not] = ACTIONS(3796),
    [anon_sym_compl] = ACTIONS(3796),
    [anon_sym_DASH_DASH] = ACTIONS(3798),
    [anon_sym_PLUS_PLUS] = ACTIONS(3798),
    [anon_sym_sizeof] = ACTIONS(3796),
    [anon_sym___alignof__] = ACTIONS(3796),
    [anon_sym___alignof] = ACTIONS(3796),
    [anon_sym__alignof] = ACTIONS(3796),
    [anon_sym_alignof] = ACTIONS(3796),
    [anon_sym__Alignof] = ACTIONS(3796),
    [anon_sym_offsetof] = ACTIONS(3796),
    [anon_sym__Generic] = ACTIONS(3796),
    [anon_sym_asm] = ACTIONS(3796),
    [anon_sym___asm__] = ACTIONS(3796),
    [anon_sym___asm] = ACTIONS(3796),
    [sym_number_literal] = ACTIONS(3798),
    [anon_sym_L_SQUOTE] = ACTIONS(3798),
    [anon_sym_u_SQUOTE] = ACTIONS(3798),
    [anon_sym_U_SQUOTE] = ACTIONS(3798),
    [anon_sym_u8_SQUOTE] = ACTIONS(3798),
    [anon_sym_SQUOTE] = ACTIONS(3798),
    [anon_sym_L_DQUOTE] = ACTIONS(3798),
    [anon_sym_u_DQUOTE] = ACTIONS(3798),
    [anon_sym_U_DQUOTE] = ACTIONS(3798),
    [anon_sym_u8_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(3798),
    [sym_true] = ACTIONS(3796),
    [sym_false] = ACTIONS(3796),
    [anon_sym_NULL] = ACTIONS(3796),
    [anon_sym_nullptr] = ACTIONS(3796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3796),
    [anon_sym_let] = ACTIONS(3796),
    [anon_sym_This] = ACTIONS(3796),
    [anon_sym_decltype] = ACTIONS(3796),
    [anon_sym_explicit] = ACTIONS(3796),
    [anon_sym_typename] = ACTIONS(3796),
    [anon_sym_export] = ACTIONS(3796),
    [anon_sym_module] = ACTIONS(3796),
    [anon_sym_import] = ACTIONS(3796),
    [anon_sym_template] = ACTIONS(3796),
    [anon_sym_operator] = ACTIONS(3796),
    [anon_sym_try] = ACTIONS(3796),
    [anon_sym_delete] = ACTIONS(3796),
    [anon_sym_throw] = ACTIONS(3796),
    [anon_sym_namespace] = ACTIONS(3796),
    [anon_sym_static_assert] = ACTIONS(3796),
    [anon_sym_concept] = ACTIONS(3796),
    [anon_sym_co_return] = ACTIONS(3796),
    [anon_sym_co_yield] = ACTIONS(3796),
    [anon_sym_R_DQUOTE] = ACTIONS(3798),
    [anon_sym_LR_DQUOTE] = ACTIONS(3798),
    [anon_sym_uR_DQUOTE] = ACTIONS(3798),
    [anon_sym_UR_DQUOTE] = ACTIONS(3798),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3798),
    [anon_sym_co_await] = ACTIONS(3796),
    [anon_sym_new] = ACTIONS(3796),
    [anon_sym_requires] = ACTIONS(3796),
    [sym_this] = ACTIONS(3796),
    [anon_sym_precise] = ACTIONS(3796),
    [anon_sym_shared] = ACTIONS(3796),
    [anon_sym_groupshared] = ACTIONS(3796),
    [anon_sym_uniform] = ACTIONS(3796),
    [anon_sym_row_major] = ACTIONS(3796),
    [anon_sym_column_major] = ACTIONS(3796),
    [anon_sym_globallycoherent] = ACTIONS(3796),
    [anon_sym_centroid] = ACTIONS(3796),
    [anon_sym_noperspective] = ACTIONS(3796),
    [anon_sym_nointerpolation] = ACTIONS(3796),
    [anon_sym_sample] = ACTIONS(3796),
    [anon_sym_linear] = ACTIONS(3796),
    [anon_sym_snorm] = ACTIONS(3796),
    [anon_sym_unorm] = ACTIONS(3796),
    [anon_sym_point] = ACTIONS(3796),
    [anon_sym_line] = ACTIONS(3796),
    [anon_sym_triangleadj] = ACTIONS(3796),
    [anon_sym_lineadj] = ACTIONS(3796),
    [anon_sym_triangle] = ACTIONS(3796),
    [anon_sym_interface] = ACTIONS(3796),
    [anon_sym_extension] = ACTIONS(3796),
    [anon_sym___exported] = ACTIONS(3796),
  },
  [935] = {
    [ts_builtin_sym_end] = ACTIONS(3802),
    [sym_identifier] = ACTIONS(3800),
    [aux_sym_preproc_include_token1] = ACTIONS(3800),
    [aux_sym_preproc_def_token1] = ACTIONS(3800),
    [aux_sym_preproc_if_token1] = ACTIONS(3800),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3800),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3800),
    [sym_preproc_directive] = ACTIONS(3800),
    [anon_sym_LPAREN2] = ACTIONS(3802),
    [anon_sym_BANG] = ACTIONS(3802),
    [anon_sym_TILDE] = ACTIONS(3802),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_STAR] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_SEMI] = ACTIONS(3802),
    [anon_sym___extension__] = ACTIONS(3800),
    [anon_sym_typedef] = ACTIONS(3800),
    [anon_sym_in] = ACTIONS(3800),
    [anon_sym_out] = ACTIONS(3800),
    [anon_sym_inout] = ACTIONS(3800),
    [anon_sym_virtual] = ACTIONS(3800),
    [anon_sym_extern] = ACTIONS(3800),
    [anon_sym___attribute__] = ACTIONS(3800),
    [anon_sym___attribute] = ACTIONS(3800),
    [anon_sym_using] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3802),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3802),
    [anon_sym___declspec] = ACTIONS(3800),
    [anon_sym___based] = ACTIONS(3800),
    [anon_sym___cdecl] = ACTIONS(3800),
    [anon_sym___clrcall] = ACTIONS(3800),
    [anon_sym___stdcall] = ACTIONS(3800),
    [anon_sym___fastcall] = ACTIONS(3800),
    [anon_sym___thiscall] = ACTIONS(3800),
    [anon_sym___vectorcall] = ACTIONS(3800),
    [anon_sym_LBRACE] = ACTIONS(3802),
    [anon_sym_signed] = ACTIONS(3800),
    [anon_sym_unsigned] = ACTIONS(3800),
    [anon_sym_long] = ACTIONS(3800),
    [anon_sym_short] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3800),
    [anon_sym_static] = ACTIONS(3800),
    [anon_sym_register] = ACTIONS(3800),
    [anon_sym_inline] = ACTIONS(3800),
    [anon_sym___inline] = ACTIONS(3800),
    [anon_sym___inline__] = ACTIONS(3800),
    [anon_sym___forceinline] = ACTIONS(3800),
    [anon_sym_thread_local] = ACTIONS(3800),
    [anon_sym___thread] = ACTIONS(3800),
    [anon_sym_const] = ACTIONS(3800),
    [anon_sym_constexpr] = ACTIONS(3800),
    [anon_sym_volatile] = ACTIONS(3800),
    [anon_sym_restrict] = ACTIONS(3800),
    [anon_sym___restrict__] = ACTIONS(3800),
    [anon_sym__Atomic] = ACTIONS(3800),
    [anon_sym__Noreturn] = ACTIONS(3800),
    [anon_sym_noreturn] = ACTIONS(3800),
    [anon_sym__Nonnull] = ACTIONS(3800),
    [anon_sym_mutable] = ACTIONS(3800),
    [anon_sym_constinit] = ACTIONS(3800),
    [anon_sym_consteval] = ACTIONS(3800),
    [anon_sym_alignas] = ACTIONS(3800),
    [anon_sym__Alignas] = ACTIONS(3800),
    [sym_primitive_type] = ACTIONS(3800),
    [anon_sym_enum] = ACTIONS(3800),
    [anon_sym_class] = ACTIONS(3800),
    [anon_sym_struct] = ACTIONS(3800),
    [anon_sym_union] = ACTIONS(3800),
    [anon_sym_if] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(3800),
    [anon_sym_case] = ACTIONS(3800),
    [anon_sym_default] = ACTIONS(3800),
    [anon_sym_while] = ACTIONS(3800),
    [anon_sym_do] = ACTIONS(3800),
    [anon_sym_for] = ACTIONS(3800),
    [anon_sym_return] = ACTIONS(3800),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_continue] = ACTIONS(3800),
    [anon_sym_goto] = ACTIONS(3800),
    [anon_sym_not] = ACTIONS(3800),
    [anon_sym_compl] = ACTIONS(3800),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3800),
    [anon_sym___alignof__] = ACTIONS(3800),
    [anon_sym___alignof] = ACTIONS(3800),
    [anon_sym__alignof] = ACTIONS(3800),
    [anon_sym_alignof] = ACTIONS(3800),
    [anon_sym__Alignof] = ACTIONS(3800),
    [anon_sym_offsetof] = ACTIONS(3800),
    [anon_sym__Generic] = ACTIONS(3800),
    [anon_sym_asm] = ACTIONS(3800),
    [anon_sym___asm__] = ACTIONS(3800),
    [anon_sym___asm] = ACTIONS(3800),
    [sym_number_literal] = ACTIONS(3802),
    [anon_sym_L_SQUOTE] = ACTIONS(3802),
    [anon_sym_u_SQUOTE] = ACTIONS(3802),
    [anon_sym_U_SQUOTE] = ACTIONS(3802),
    [anon_sym_u8_SQUOTE] = ACTIONS(3802),
    [anon_sym_SQUOTE] = ACTIONS(3802),
    [anon_sym_L_DQUOTE] = ACTIONS(3802),
    [anon_sym_u_DQUOTE] = ACTIONS(3802),
    [anon_sym_U_DQUOTE] = ACTIONS(3802),
    [anon_sym_u8_DQUOTE] = ACTIONS(3802),
    [anon_sym_DQUOTE] = ACTIONS(3802),
    [sym_true] = ACTIONS(3800),
    [sym_false] = ACTIONS(3800),
    [anon_sym_NULL] = ACTIONS(3800),
    [anon_sym_nullptr] = ACTIONS(3800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_This] = ACTIONS(3800),
    [anon_sym_decltype] = ACTIONS(3800),
    [anon_sym_explicit] = ACTIONS(3800),
    [anon_sym_typename] = ACTIONS(3800),
    [anon_sym_export] = ACTIONS(3800),
    [anon_sym_module] = ACTIONS(3800),
    [anon_sym_import] = ACTIONS(3800),
    [anon_sym_template] = ACTIONS(3800),
    [anon_sym_operator] = ACTIONS(3800),
    [anon_sym_try] = ACTIONS(3800),
    [anon_sym_delete] = ACTIONS(3800),
    [anon_sym_throw] = ACTIONS(3800),
    [anon_sym_namespace] = ACTIONS(3800),
    [anon_sym_static_assert] = ACTIONS(3800),
    [anon_sym_concept] = ACTIONS(3800),
    [anon_sym_co_return] = ACTIONS(3800),
    [anon_sym_co_yield] = ACTIONS(3800),
    [anon_sym_R_DQUOTE] = ACTIONS(3802),
    [anon_sym_LR_DQUOTE] = ACTIONS(3802),
    [anon_sym_uR_DQUOTE] = ACTIONS(3802),
    [anon_sym_UR_DQUOTE] = ACTIONS(3802),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3802),
    [anon_sym_co_await] = ACTIONS(3800),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_requires] = ACTIONS(3800),
    [sym_this] = ACTIONS(3800),
    [anon_sym_precise] = ACTIONS(3800),
    [anon_sym_shared] = ACTIONS(3800),
    [anon_sym_groupshared] = ACTIONS(3800),
    [anon_sym_uniform] = ACTIONS(3800),
    [anon_sym_row_major] = ACTIONS(3800),
    [anon_sym_column_major] = ACTIONS(3800),
    [anon_sym_globallycoherent] = ACTIONS(3800),
    [anon_sym_centroid] = ACTIONS(3800),
    [anon_sym_noperspective] = ACTIONS(3800),
    [anon_sym_nointerpolation] = ACTIONS(3800),
    [anon_sym_sample] = ACTIONS(3800),
    [anon_sym_linear] = ACTIONS(3800),
    [anon_sym_snorm] = ACTIONS(3800),
    [anon_sym_unorm] = ACTIONS(3800),
    [anon_sym_point] = ACTIONS(3800),
    [anon_sym_line] = ACTIONS(3800),
    [anon_sym_triangleadj] = ACTIONS(3800),
    [anon_sym_lineadj] = ACTIONS(3800),
    [anon_sym_triangle] = ACTIONS(3800),
    [anon_sym_interface] = ACTIONS(3800),
    [anon_sym_extension] = ACTIONS(3800),
    [anon_sym___exported] = ACTIONS(3800),
  },
  [936] = {
    [sym_identifier] = ACTIONS(3695),
    [aux_sym_preproc_include_token1] = ACTIONS(3695),
    [aux_sym_preproc_def_token1] = ACTIONS(3695),
    [aux_sym_preproc_if_token1] = ACTIONS(3695),
    [aux_sym_preproc_if_token2] = ACTIONS(3695),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3695),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3695),
    [sym_preproc_directive] = ACTIONS(3695),
    [anon_sym_LPAREN2] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3695),
    [anon_sym_PLUS] = ACTIONS(3695),
    [anon_sym_STAR] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3695),
    [anon_sym_SEMI] = ACTIONS(3697),
    [anon_sym___extension__] = ACTIONS(3695),
    [anon_sym_typedef] = ACTIONS(3695),
    [anon_sym_in] = ACTIONS(3695),
    [anon_sym_out] = ACTIONS(3695),
    [anon_sym_inout] = ACTIONS(3695),
    [anon_sym_virtual] = ACTIONS(3695),
    [anon_sym_extern] = ACTIONS(3695),
    [anon_sym___attribute__] = ACTIONS(3695),
    [anon_sym___attribute] = ACTIONS(3695),
    [anon_sym_using] = ACTIONS(3695),
    [anon_sym_COLON_COLON] = ACTIONS(3697),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3697),
    [anon_sym___declspec] = ACTIONS(3695),
    [anon_sym___based] = ACTIONS(3695),
    [anon_sym___cdecl] = ACTIONS(3695),
    [anon_sym___clrcall] = ACTIONS(3695),
    [anon_sym___stdcall] = ACTIONS(3695),
    [anon_sym___fastcall] = ACTIONS(3695),
    [anon_sym___thiscall] = ACTIONS(3695),
    [anon_sym___vectorcall] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_signed] = ACTIONS(3695),
    [anon_sym_unsigned] = ACTIONS(3695),
    [anon_sym_long] = ACTIONS(3695),
    [anon_sym_short] = ACTIONS(3695),
    [anon_sym_LBRACK] = ACTIONS(3695),
    [anon_sym_static] = ACTIONS(3695),
    [anon_sym_register] = ACTIONS(3695),
    [anon_sym_inline] = ACTIONS(3695),
    [anon_sym___inline] = ACTIONS(3695),
    [anon_sym___inline__] = ACTIONS(3695),
    [anon_sym___forceinline] = ACTIONS(3695),
    [anon_sym_thread_local] = ACTIONS(3695),
    [anon_sym___thread] = ACTIONS(3695),
    [anon_sym_const] = ACTIONS(3695),
    [anon_sym_constexpr] = ACTIONS(3695),
    [anon_sym_volatile] = ACTIONS(3695),
    [anon_sym_restrict] = ACTIONS(3695),
    [anon_sym___restrict__] = ACTIONS(3695),
    [anon_sym__Atomic] = ACTIONS(3695),
    [anon_sym__Noreturn] = ACTIONS(3695),
    [anon_sym_noreturn] = ACTIONS(3695),
    [anon_sym__Nonnull] = ACTIONS(3695),
    [anon_sym_mutable] = ACTIONS(3695),
    [anon_sym_constinit] = ACTIONS(3695),
    [anon_sym_consteval] = ACTIONS(3695),
    [anon_sym_alignas] = ACTIONS(3695),
    [anon_sym__Alignas] = ACTIONS(3695),
    [sym_primitive_type] = ACTIONS(3695),
    [anon_sym_enum] = ACTIONS(3695),
    [anon_sym_class] = ACTIONS(3695),
    [anon_sym_struct] = ACTIONS(3695),
    [anon_sym_union] = ACTIONS(3695),
    [anon_sym_if] = ACTIONS(3695),
    [anon_sym_switch] = ACTIONS(3695),
    [anon_sym_case] = ACTIONS(3695),
    [anon_sym_default] = ACTIONS(3695),
    [anon_sym_while] = ACTIONS(3695),
    [anon_sym_do] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3695),
    [anon_sym_return] = ACTIONS(3695),
    [anon_sym_break] = ACTIONS(3695),
    [anon_sym_continue] = ACTIONS(3695),
    [anon_sym_goto] = ACTIONS(3695),
    [anon_sym___try] = ACTIONS(3695),
    [anon_sym___leave] = ACTIONS(3695),
    [anon_sym_not] = ACTIONS(3695),
    [anon_sym_compl] = ACTIONS(3695),
    [anon_sym_DASH_DASH] = ACTIONS(3697),
    [anon_sym_PLUS_PLUS] = ACTIONS(3697),
    [anon_sym_sizeof] = ACTIONS(3695),
    [anon_sym___alignof__] = ACTIONS(3695),
    [anon_sym___alignof] = ACTIONS(3695),
    [anon_sym__alignof] = ACTIONS(3695),
    [anon_sym_alignof] = ACTIONS(3695),
    [anon_sym__Alignof] = ACTIONS(3695),
    [anon_sym_offsetof] = ACTIONS(3695),
    [anon_sym__Generic] = ACTIONS(3695),
    [anon_sym_asm] = ACTIONS(3695),
    [anon_sym___asm__] = ACTIONS(3695),
    [anon_sym___asm] = ACTIONS(3695),
    [sym_number_literal] = ACTIONS(3697),
    [anon_sym_L_SQUOTE] = ACTIONS(3697),
    [anon_sym_u_SQUOTE] = ACTIONS(3697),
    [anon_sym_U_SQUOTE] = ACTIONS(3697),
    [anon_sym_u8_SQUOTE] = ACTIONS(3697),
    [anon_sym_SQUOTE] = ACTIONS(3697),
    [anon_sym_L_DQUOTE] = ACTIONS(3697),
    [anon_sym_u_DQUOTE] = ACTIONS(3697),
    [anon_sym_U_DQUOTE] = ACTIONS(3697),
    [anon_sym_u8_DQUOTE] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [sym_true] = ACTIONS(3695),
    [sym_false] = ACTIONS(3695),
    [anon_sym_NULL] = ACTIONS(3695),
    [anon_sym_nullptr] = ACTIONS(3695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3695),
    [anon_sym_let] = ACTIONS(3695),
    [anon_sym_This] = ACTIONS(3695),
    [anon_sym_decltype] = ACTIONS(3695),
    [anon_sym_explicit] = ACTIONS(3695),
    [anon_sym_typename] = ACTIONS(3695),
    [anon_sym_template] = ACTIONS(3695),
    [anon_sym_operator] = ACTIONS(3695),
    [anon_sym_try] = ACTIONS(3695),
    [anon_sym_delete] = ACTIONS(3695),
    [anon_sym_throw] = ACTIONS(3695),
    [anon_sym_namespace] = ACTIONS(3695),
    [anon_sym_static_assert] = ACTIONS(3695),
    [anon_sym_concept] = ACTIONS(3695),
    [anon_sym_co_return] = ACTIONS(3695),
    [anon_sym_co_yield] = ACTIONS(3695),
    [anon_sym_R_DQUOTE] = ACTIONS(3697),
    [anon_sym_LR_DQUOTE] = ACTIONS(3697),
    [anon_sym_uR_DQUOTE] = ACTIONS(3697),
    [anon_sym_UR_DQUOTE] = ACTIONS(3697),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3697),
    [anon_sym_co_await] = ACTIONS(3695),
    [anon_sym_new] = ACTIONS(3695),
    [anon_sym_requires] = ACTIONS(3695),
    [sym_this] = ACTIONS(3695),
    [anon_sym_discard] = ACTIONS(3695),
    [anon_sym_precise] = ACTIONS(3695),
    [anon_sym_shared] = ACTIONS(3695),
    [anon_sym_groupshared] = ACTIONS(3695),
    [anon_sym_uniform] = ACTIONS(3695),
    [anon_sym_row_major] = ACTIONS(3695),
    [anon_sym_column_major] = ACTIONS(3695),
    [anon_sym_globallycoherent] = ACTIONS(3695),
    [anon_sym_centroid] = ACTIONS(3695),
    [anon_sym_noperspective] = ACTIONS(3695),
    [anon_sym_nointerpolation] = ACTIONS(3695),
    [anon_sym_sample] = ACTIONS(3695),
    [anon_sym_linear] = ACTIONS(3695),
    [anon_sym_snorm] = ACTIONS(3695),
    [anon_sym_unorm] = ACTIONS(3695),
    [anon_sym_point] = ACTIONS(3695),
    [anon_sym_line] = ACTIONS(3695),
    [anon_sym_triangleadj] = ACTIONS(3695),
    [anon_sym_lineadj] = ACTIONS(3695),
    [anon_sym_triangle] = ACTIONS(3695),
    [anon_sym_cbuffer] = ACTIONS(3695),
    [anon_sym_interface] = ACTIONS(3695),
    [anon_sym_extension] = ACTIONS(3695),
  },
  [937] = {
    [sym_identifier] = ACTIONS(3699),
    [aux_sym_preproc_include_token1] = ACTIONS(3699),
    [aux_sym_preproc_def_token1] = ACTIONS(3699),
    [aux_sym_preproc_if_token1] = ACTIONS(3699),
    [aux_sym_preproc_if_token2] = ACTIONS(3699),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3699),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3699),
    [sym_preproc_directive] = ACTIONS(3699),
    [anon_sym_LPAREN2] = ACTIONS(3701),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_STAR] = ACTIONS(3701),
    [anon_sym_AMP_AMP] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(3701),
    [anon_sym___extension__] = ACTIONS(3699),
    [anon_sym_typedef] = ACTIONS(3699),
    [anon_sym_in] = ACTIONS(3699),
    [anon_sym_out] = ACTIONS(3699),
    [anon_sym_inout] = ACTIONS(3699),
    [anon_sym_virtual] = ACTIONS(3699),
    [anon_sym_extern] = ACTIONS(3699),
    [anon_sym___attribute__] = ACTIONS(3699),
    [anon_sym___attribute] = ACTIONS(3699),
    [anon_sym_using] = ACTIONS(3699),
    [anon_sym_COLON_COLON] = ACTIONS(3701),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3701),
    [anon_sym___declspec] = ACTIONS(3699),
    [anon_sym___based] = ACTIONS(3699),
    [anon_sym___cdecl] = ACTIONS(3699),
    [anon_sym___clrcall] = ACTIONS(3699),
    [anon_sym___stdcall] = ACTIONS(3699),
    [anon_sym___fastcall] = ACTIONS(3699),
    [anon_sym___thiscall] = ACTIONS(3699),
    [anon_sym___vectorcall] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3701),
    [anon_sym_signed] = ACTIONS(3699),
    [anon_sym_unsigned] = ACTIONS(3699),
    [anon_sym_long] = ACTIONS(3699),
    [anon_sym_short] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(3699),
    [anon_sym_static] = ACTIONS(3699),
    [anon_sym_register] = ACTIONS(3699),
    [anon_sym_inline] = ACTIONS(3699),
    [anon_sym___inline] = ACTIONS(3699),
    [anon_sym___inline__] = ACTIONS(3699),
    [anon_sym___forceinline] = ACTIONS(3699),
    [anon_sym_thread_local] = ACTIONS(3699),
    [anon_sym___thread] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3699),
    [anon_sym_constexpr] = ACTIONS(3699),
    [anon_sym_volatile] = ACTIONS(3699),
    [anon_sym_restrict] = ACTIONS(3699),
    [anon_sym___restrict__] = ACTIONS(3699),
    [anon_sym__Atomic] = ACTIONS(3699),
    [anon_sym__Noreturn] = ACTIONS(3699),
    [anon_sym_noreturn] = ACTIONS(3699),
    [anon_sym__Nonnull] = ACTIONS(3699),
    [anon_sym_mutable] = ACTIONS(3699),
    [anon_sym_constinit] = ACTIONS(3699),
    [anon_sym_consteval] = ACTIONS(3699),
    [anon_sym_alignas] = ACTIONS(3699),
    [anon_sym__Alignas] = ACTIONS(3699),
    [sym_primitive_type] = ACTIONS(3699),
    [anon_sym_enum] = ACTIONS(3699),
    [anon_sym_class] = ACTIONS(3699),
    [anon_sym_struct] = ACTIONS(3699),
    [anon_sym_union] = ACTIONS(3699),
    [anon_sym_if] = ACTIONS(3699),
    [anon_sym_switch] = ACTIONS(3699),
    [anon_sym_case] = ACTIONS(3699),
    [anon_sym_default] = ACTIONS(3699),
    [anon_sym_while] = ACTIONS(3699),
    [anon_sym_do] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3699),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_break] = ACTIONS(3699),
    [anon_sym_continue] = ACTIONS(3699),
    [anon_sym_goto] = ACTIONS(3699),
    [anon_sym___try] = ACTIONS(3699),
    [anon_sym___leave] = ACTIONS(3699),
    [anon_sym_not] = ACTIONS(3699),
    [anon_sym_compl] = ACTIONS(3699),
    [anon_sym_DASH_DASH] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3701),
    [anon_sym_sizeof] = ACTIONS(3699),
    [anon_sym___alignof__] = ACTIONS(3699),
    [anon_sym___alignof] = ACTIONS(3699),
    [anon_sym__alignof] = ACTIONS(3699),
    [anon_sym_alignof] = ACTIONS(3699),
    [anon_sym__Alignof] = ACTIONS(3699),
    [anon_sym_offsetof] = ACTIONS(3699),
    [anon_sym__Generic] = ACTIONS(3699),
    [anon_sym_asm] = ACTIONS(3699),
    [anon_sym___asm__] = ACTIONS(3699),
    [anon_sym___asm] = ACTIONS(3699),
    [sym_number_literal] = ACTIONS(3701),
    [anon_sym_L_SQUOTE] = ACTIONS(3701),
    [anon_sym_u_SQUOTE] = ACTIONS(3701),
    [anon_sym_U_SQUOTE] = ACTIONS(3701),
    [anon_sym_u8_SQUOTE] = ACTIONS(3701),
    [anon_sym_SQUOTE] = ACTIONS(3701),
    [anon_sym_L_DQUOTE] = ACTIONS(3701),
    [anon_sym_u_DQUOTE] = ACTIONS(3701),
    [anon_sym_U_DQUOTE] = ACTIONS(3701),
    [anon_sym_u8_DQUOTE] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [sym_true] = ACTIONS(3699),
    [sym_false] = ACTIONS(3699),
    [anon_sym_NULL] = ACTIONS(3699),
    [anon_sym_nullptr] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3699),
    [anon_sym_let] = ACTIONS(3699),
    [anon_sym_This] = ACTIONS(3699),
    [anon_sym_decltype] = ACTIONS(3699),
    [anon_sym_explicit] = ACTIONS(3699),
    [anon_sym_typename] = ACTIONS(3699),
    [anon_sym_template] = ACTIONS(3699),
    [anon_sym_operator] = ACTIONS(3699),
    [anon_sym_try] = ACTIONS(3699),
    [anon_sym_delete] = ACTIONS(3699),
    [anon_sym_throw] = ACTIONS(3699),
    [anon_sym_namespace] = ACTIONS(3699),
    [anon_sym_static_assert] = ACTIONS(3699),
    [anon_sym_concept] = ACTIONS(3699),
    [anon_sym_co_return] = ACTIONS(3699),
    [anon_sym_co_yield] = ACTIONS(3699),
    [anon_sym_R_DQUOTE] = ACTIONS(3701),
    [anon_sym_LR_DQUOTE] = ACTIONS(3701),
    [anon_sym_uR_DQUOTE] = ACTIONS(3701),
    [anon_sym_UR_DQUOTE] = ACTIONS(3701),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3701),
    [anon_sym_co_await] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3699),
    [anon_sym_requires] = ACTIONS(3699),
    [sym_this] = ACTIONS(3699),
    [anon_sym_discard] = ACTIONS(3699),
    [anon_sym_precise] = ACTIONS(3699),
    [anon_sym_shared] = ACTIONS(3699),
    [anon_sym_groupshared] = ACTIONS(3699),
    [anon_sym_uniform] = ACTIONS(3699),
    [anon_sym_row_major] = ACTIONS(3699),
    [anon_sym_column_major] = ACTIONS(3699),
    [anon_sym_globallycoherent] = ACTIONS(3699),
    [anon_sym_centroid] = ACTIONS(3699),
    [anon_sym_noperspective] = ACTIONS(3699),
    [anon_sym_nointerpolation] = ACTIONS(3699),
    [anon_sym_sample] = ACTIONS(3699),
    [anon_sym_linear] = ACTIONS(3699),
    [anon_sym_snorm] = ACTIONS(3699),
    [anon_sym_unorm] = ACTIONS(3699),
    [anon_sym_point] = ACTIONS(3699),
    [anon_sym_line] = ACTIONS(3699),
    [anon_sym_triangleadj] = ACTIONS(3699),
    [anon_sym_lineadj] = ACTIONS(3699),
    [anon_sym_triangle] = ACTIONS(3699),
    [anon_sym_cbuffer] = ACTIONS(3699),
    [anon_sym_interface] = ACTIONS(3699),
    [anon_sym_extension] = ACTIONS(3699),
  },
  [938] = {
    [sym_identifier] = ACTIONS(3889),
    [aux_sym_preproc_include_token1] = ACTIONS(3889),
    [aux_sym_preproc_def_token1] = ACTIONS(3889),
    [aux_sym_preproc_if_token1] = ACTIONS(3889),
    [aux_sym_preproc_if_token2] = ACTIONS(3889),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3889),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3889),
    [sym_preproc_directive] = ACTIONS(3889),
    [anon_sym_LPAREN2] = ACTIONS(3891),
    [anon_sym_BANG] = ACTIONS(3891),
    [anon_sym_TILDE] = ACTIONS(3891),
    [anon_sym_DASH] = ACTIONS(3889),
    [anon_sym_PLUS] = ACTIONS(3889),
    [anon_sym_STAR] = ACTIONS(3891),
    [anon_sym_AMP_AMP] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3889),
    [anon_sym_SEMI] = ACTIONS(3891),
    [anon_sym___extension__] = ACTIONS(3889),
    [anon_sym_typedef] = ACTIONS(3889),
    [anon_sym_in] = ACTIONS(3889),
    [anon_sym_out] = ACTIONS(3889),
    [anon_sym_inout] = ACTIONS(3889),
    [anon_sym_virtual] = ACTIONS(3889),
    [anon_sym_extern] = ACTIONS(3889),
    [anon_sym___attribute__] = ACTIONS(3889),
    [anon_sym___attribute] = ACTIONS(3889),
    [anon_sym_using] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3891),
    [anon_sym___declspec] = ACTIONS(3889),
    [anon_sym___based] = ACTIONS(3889),
    [anon_sym___cdecl] = ACTIONS(3889),
    [anon_sym___clrcall] = ACTIONS(3889),
    [anon_sym___stdcall] = ACTIONS(3889),
    [anon_sym___fastcall] = ACTIONS(3889),
    [anon_sym___thiscall] = ACTIONS(3889),
    [anon_sym___vectorcall] = ACTIONS(3889),
    [anon_sym_LBRACE] = ACTIONS(3891),
    [anon_sym_signed] = ACTIONS(3889),
    [anon_sym_unsigned] = ACTIONS(3889),
    [anon_sym_long] = ACTIONS(3889),
    [anon_sym_short] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_static] = ACTIONS(3889),
    [anon_sym_register] = ACTIONS(3889),
    [anon_sym_inline] = ACTIONS(3889),
    [anon_sym___inline] = ACTIONS(3889),
    [anon_sym___inline__] = ACTIONS(3889),
    [anon_sym___forceinline] = ACTIONS(3889),
    [anon_sym_thread_local] = ACTIONS(3889),
    [anon_sym___thread] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3889),
    [anon_sym_constexpr] = ACTIONS(3889),
    [anon_sym_volatile] = ACTIONS(3889),
    [anon_sym_restrict] = ACTIONS(3889),
    [anon_sym___restrict__] = ACTIONS(3889),
    [anon_sym__Atomic] = ACTIONS(3889),
    [anon_sym__Noreturn] = ACTIONS(3889),
    [anon_sym_noreturn] = ACTIONS(3889),
    [anon_sym__Nonnull] = ACTIONS(3889),
    [anon_sym_mutable] = ACTIONS(3889),
    [anon_sym_constinit] = ACTIONS(3889),
    [anon_sym_consteval] = ACTIONS(3889),
    [anon_sym_alignas] = ACTIONS(3889),
    [anon_sym__Alignas] = ACTIONS(3889),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_enum] = ACTIONS(3889),
    [anon_sym_class] = ACTIONS(3889),
    [anon_sym_struct] = ACTIONS(3889),
    [anon_sym_union] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_switch] = ACTIONS(3889),
    [anon_sym_case] = ACTIONS(3889),
    [anon_sym_default] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_break] = ACTIONS(3889),
    [anon_sym_continue] = ACTIONS(3889),
    [anon_sym_goto] = ACTIONS(3889),
    [anon_sym___try] = ACTIONS(3889),
    [anon_sym___leave] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3889),
    [anon_sym_compl] = ACTIONS(3889),
    [anon_sym_DASH_DASH] = ACTIONS(3891),
    [anon_sym_PLUS_PLUS] = ACTIONS(3891),
    [anon_sym_sizeof] = ACTIONS(3889),
    [anon_sym___alignof__] = ACTIONS(3889),
    [anon_sym___alignof] = ACTIONS(3889),
    [anon_sym__alignof] = ACTIONS(3889),
    [anon_sym_alignof] = ACTIONS(3889),
    [anon_sym__Alignof] = ACTIONS(3889),
    [anon_sym_offsetof] = ACTIONS(3889),
    [anon_sym__Generic] = ACTIONS(3889),
    [anon_sym_asm] = ACTIONS(3889),
    [anon_sym___asm__] = ACTIONS(3889),
    [anon_sym___asm] = ACTIONS(3889),
    [sym_number_literal] = ACTIONS(3891),
    [anon_sym_L_SQUOTE] = ACTIONS(3891),
    [anon_sym_u_SQUOTE] = ACTIONS(3891),
    [anon_sym_U_SQUOTE] = ACTIONS(3891),
    [anon_sym_u8_SQUOTE] = ACTIONS(3891),
    [anon_sym_SQUOTE] = ACTIONS(3891),
    [anon_sym_L_DQUOTE] = ACTIONS(3891),
    [anon_sym_u_DQUOTE] = ACTIONS(3891),
    [anon_sym_U_DQUOTE] = ACTIONS(3891),
    [anon_sym_u8_DQUOTE] = ACTIONS(3891),
    [anon_sym_DQUOTE] = ACTIONS(3891),
    [sym_true] = ACTIONS(3889),
    [sym_false] = ACTIONS(3889),
    [anon_sym_NULL] = ACTIONS(3889),
    [anon_sym_nullptr] = ACTIONS(3889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_This] = ACTIONS(3889),
    [anon_sym_decltype] = ACTIONS(3889),
    [anon_sym_explicit] = ACTIONS(3889),
    [anon_sym_typename] = ACTIONS(3889),
    [anon_sym_template] = ACTIONS(3889),
    [anon_sym_operator] = ACTIONS(3889),
    [anon_sym_try] = ACTIONS(3889),
    [anon_sym_delete] = ACTIONS(3889),
    [anon_sym_throw] = ACTIONS(3889),
    [anon_sym_namespace] = ACTIONS(3889),
    [anon_sym_static_assert] = ACTIONS(3889),
    [anon_sym_concept] = ACTIONS(3889),
    [anon_sym_co_return] = ACTIONS(3889),
    [anon_sym_co_yield] = ACTIONS(3889),
    [anon_sym_R_DQUOTE] = ACTIONS(3891),
    [anon_sym_LR_DQUOTE] = ACTIONS(3891),
    [anon_sym_uR_DQUOTE] = ACTIONS(3891),
    [anon_sym_UR_DQUOTE] = ACTIONS(3891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3891),
    [anon_sym_co_await] = ACTIONS(3889),
    [anon_sym_new] = ACTIONS(3889),
    [anon_sym_requires] = ACTIONS(3889),
    [sym_this] = ACTIONS(3889),
    [anon_sym_discard] = ACTIONS(3889),
    [anon_sym_precise] = ACTIONS(3889),
    [anon_sym_shared] = ACTIONS(3889),
    [anon_sym_groupshared] = ACTIONS(3889),
    [anon_sym_uniform] = ACTIONS(3889),
    [anon_sym_row_major] = ACTIONS(3889),
    [anon_sym_column_major] = ACTIONS(3889),
    [anon_sym_globallycoherent] = ACTIONS(3889),
    [anon_sym_centroid] = ACTIONS(3889),
    [anon_sym_noperspective] = ACTIONS(3889),
    [anon_sym_nointerpolation] = ACTIONS(3889),
    [anon_sym_sample] = ACTIONS(3889),
    [anon_sym_linear] = ACTIONS(3889),
    [anon_sym_snorm] = ACTIONS(3889),
    [anon_sym_unorm] = ACTIONS(3889),
    [anon_sym_point] = ACTIONS(3889),
    [anon_sym_line] = ACTIONS(3889),
    [anon_sym_triangleadj] = ACTIONS(3889),
    [anon_sym_lineadj] = ACTIONS(3889),
    [anon_sym_triangle] = ACTIONS(3889),
    [anon_sym_cbuffer] = ACTIONS(3889),
    [anon_sym_interface] = ACTIONS(3889),
    [anon_sym_extension] = ACTIONS(3889),
  },
  [939] = {
    [sym_identifier] = ACTIONS(3703),
    [aux_sym_preproc_include_token1] = ACTIONS(3703),
    [aux_sym_preproc_def_token1] = ACTIONS(3703),
    [aux_sym_preproc_if_token1] = ACTIONS(3703),
    [aux_sym_preproc_if_token2] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3703),
    [sym_preproc_directive] = ACTIONS(3703),
    [anon_sym_LPAREN2] = ACTIONS(3705),
    [anon_sym_BANG] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3703),
    [anon_sym_STAR] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_AMP] = ACTIONS(3703),
    [anon_sym_SEMI] = ACTIONS(3705),
    [anon_sym___extension__] = ACTIONS(3703),
    [anon_sym_typedef] = ACTIONS(3703),
    [anon_sym_in] = ACTIONS(3703),
    [anon_sym_out] = ACTIONS(3703),
    [anon_sym_inout] = ACTIONS(3703),
    [anon_sym_virtual] = ACTIONS(3703),
    [anon_sym_extern] = ACTIONS(3703),
    [anon_sym___attribute__] = ACTIONS(3703),
    [anon_sym___attribute] = ACTIONS(3703),
    [anon_sym_using] = ACTIONS(3703),
    [anon_sym_COLON_COLON] = ACTIONS(3705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3705),
    [anon_sym___declspec] = ACTIONS(3703),
    [anon_sym___based] = ACTIONS(3703),
    [anon_sym___cdecl] = ACTIONS(3703),
    [anon_sym___clrcall] = ACTIONS(3703),
    [anon_sym___stdcall] = ACTIONS(3703),
    [anon_sym___fastcall] = ACTIONS(3703),
    [anon_sym___thiscall] = ACTIONS(3703),
    [anon_sym___vectorcall] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_signed] = ACTIONS(3703),
    [anon_sym_unsigned] = ACTIONS(3703),
    [anon_sym_long] = ACTIONS(3703),
    [anon_sym_short] = ACTIONS(3703),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_static] = ACTIONS(3703),
    [anon_sym_register] = ACTIONS(3703),
    [anon_sym_inline] = ACTIONS(3703),
    [anon_sym___inline] = ACTIONS(3703),
    [anon_sym___inline__] = ACTIONS(3703),
    [anon_sym___forceinline] = ACTIONS(3703),
    [anon_sym_thread_local] = ACTIONS(3703),
    [anon_sym___thread] = ACTIONS(3703),
    [anon_sym_const] = ACTIONS(3703),
    [anon_sym_constexpr] = ACTIONS(3703),
    [anon_sym_volatile] = ACTIONS(3703),
    [anon_sym_restrict] = ACTIONS(3703),
    [anon_sym___restrict__] = ACTIONS(3703),
    [anon_sym__Atomic] = ACTIONS(3703),
    [anon_sym__Noreturn] = ACTIONS(3703),
    [anon_sym_noreturn] = ACTIONS(3703),
    [anon_sym__Nonnull] = ACTIONS(3703),
    [anon_sym_mutable] = ACTIONS(3703),
    [anon_sym_constinit] = ACTIONS(3703),
    [anon_sym_consteval] = ACTIONS(3703),
    [anon_sym_alignas] = ACTIONS(3703),
    [anon_sym__Alignas] = ACTIONS(3703),
    [sym_primitive_type] = ACTIONS(3703),
    [anon_sym_enum] = ACTIONS(3703),
    [anon_sym_class] = ACTIONS(3703),
    [anon_sym_struct] = ACTIONS(3703),
    [anon_sym_union] = ACTIONS(3703),
    [anon_sym_if] = ACTIONS(3703),
    [anon_sym_switch] = ACTIONS(3703),
    [anon_sym_case] = ACTIONS(3703),
    [anon_sym_default] = ACTIONS(3703),
    [anon_sym_while] = ACTIONS(3703),
    [anon_sym_do] = ACTIONS(3703),
    [anon_sym_for] = ACTIONS(3703),
    [anon_sym_return] = ACTIONS(3703),
    [anon_sym_break] = ACTIONS(3703),
    [anon_sym_continue] = ACTIONS(3703),
    [anon_sym_goto] = ACTIONS(3703),
    [anon_sym___try] = ACTIONS(3703),
    [anon_sym___leave] = ACTIONS(3703),
    [anon_sym_not] = ACTIONS(3703),
    [anon_sym_compl] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3705),
    [anon_sym_PLUS_PLUS] = ACTIONS(3705),
    [anon_sym_sizeof] = ACTIONS(3703),
    [anon_sym___alignof__] = ACTIONS(3703),
    [anon_sym___alignof] = ACTIONS(3703),
    [anon_sym__alignof] = ACTIONS(3703),
    [anon_sym_alignof] = ACTIONS(3703),
    [anon_sym__Alignof] = ACTIONS(3703),
    [anon_sym_offsetof] = ACTIONS(3703),
    [anon_sym__Generic] = ACTIONS(3703),
    [anon_sym_asm] = ACTIONS(3703),
    [anon_sym___asm__] = ACTIONS(3703),
    [anon_sym___asm] = ACTIONS(3703),
    [sym_number_literal] = ACTIONS(3705),
    [anon_sym_L_SQUOTE] = ACTIONS(3705),
    [anon_sym_u_SQUOTE] = ACTIONS(3705),
    [anon_sym_U_SQUOTE] = ACTIONS(3705),
    [anon_sym_u8_SQUOTE] = ACTIONS(3705),
    [anon_sym_SQUOTE] = ACTIONS(3705),
    [anon_sym_L_DQUOTE] = ACTIONS(3705),
    [anon_sym_u_DQUOTE] = ACTIONS(3705),
    [anon_sym_U_DQUOTE] = ACTIONS(3705),
    [anon_sym_u8_DQUOTE] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [sym_true] = ACTIONS(3703),
    [sym_false] = ACTIONS(3703),
    [anon_sym_NULL] = ACTIONS(3703),
    [anon_sym_nullptr] = ACTIONS(3703),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3703),
    [anon_sym_let] = ACTIONS(3703),
    [anon_sym_This] = ACTIONS(3703),
    [anon_sym_decltype] = ACTIONS(3703),
    [anon_sym_explicit] = ACTIONS(3703),
    [anon_sym_typename] = ACTIONS(3703),
    [anon_sym_template] = ACTIONS(3703),
    [anon_sym_operator] = ACTIONS(3703),
    [anon_sym_try] = ACTIONS(3703),
    [anon_sym_delete] = ACTIONS(3703),
    [anon_sym_throw] = ACTIONS(3703),
    [anon_sym_namespace] = ACTIONS(3703),
    [anon_sym_static_assert] = ACTIONS(3703),
    [anon_sym_concept] = ACTIONS(3703),
    [anon_sym_co_return] = ACTIONS(3703),
    [anon_sym_co_yield] = ACTIONS(3703),
    [anon_sym_R_DQUOTE] = ACTIONS(3705),
    [anon_sym_LR_DQUOTE] = ACTIONS(3705),
    [anon_sym_uR_DQUOTE] = ACTIONS(3705),
    [anon_sym_UR_DQUOTE] = ACTIONS(3705),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3705),
    [anon_sym_co_await] = ACTIONS(3703),
    [anon_sym_new] = ACTIONS(3703),
    [anon_sym_requires] = ACTIONS(3703),
    [sym_this] = ACTIONS(3703),
    [anon_sym_discard] = ACTIONS(3703),
    [anon_sym_precise] = ACTIONS(3703),
    [anon_sym_shared] = ACTIONS(3703),
    [anon_sym_groupshared] = ACTIONS(3703),
    [anon_sym_uniform] = ACTIONS(3703),
    [anon_sym_row_major] = ACTIONS(3703),
    [anon_sym_column_major] = ACTIONS(3703),
    [anon_sym_globallycoherent] = ACTIONS(3703),
    [anon_sym_centroid] = ACTIONS(3703),
    [anon_sym_noperspective] = ACTIONS(3703),
    [anon_sym_nointerpolation] = ACTIONS(3703),
    [anon_sym_sample] = ACTIONS(3703),
    [anon_sym_linear] = ACTIONS(3703),
    [anon_sym_snorm] = ACTIONS(3703),
    [anon_sym_unorm] = ACTIONS(3703),
    [anon_sym_point] = ACTIONS(3703),
    [anon_sym_line] = ACTIONS(3703),
    [anon_sym_triangleadj] = ACTIONS(3703),
    [anon_sym_lineadj] = ACTIONS(3703),
    [anon_sym_triangle] = ACTIONS(3703),
    [anon_sym_cbuffer] = ACTIONS(3703),
    [anon_sym_interface] = ACTIONS(3703),
    [anon_sym_extension] = ACTIONS(3703),
  },
  [940] = {
    [sym_identifier] = ACTIONS(3707),
    [aux_sym_preproc_include_token1] = ACTIONS(3707),
    [aux_sym_preproc_def_token1] = ACTIONS(3707),
    [aux_sym_preproc_if_token1] = ACTIONS(3707),
    [aux_sym_preproc_if_token2] = ACTIONS(3707),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3707),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3707),
    [sym_preproc_directive] = ACTIONS(3707),
    [anon_sym_LPAREN2] = ACTIONS(3709),
    [anon_sym_BANG] = ACTIONS(3709),
    [anon_sym_TILDE] = ACTIONS(3709),
    [anon_sym_DASH] = ACTIONS(3707),
    [anon_sym_PLUS] = ACTIONS(3707),
    [anon_sym_STAR] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(3707),
    [anon_sym_SEMI] = ACTIONS(3709),
    [anon_sym___extension__] = ACTIONS(3707),
    [anon_sym_typedef] = ACTIONS(3707),
    [anon_sym_in] = ACTIONS(3707),
    [anon_sym_out] = ACTIONS(3707),
    [anon_sym_inout] = ACTIONS(3707),
    [anon_sym_virtual] = ACTIONS(3707),
    [anon_sym_extern] = ACTIONS(3707),
    [anon_sym___attribute__] = ACTIONS(3707),
    [anon_sym___attribute] = ACTIONS(3707),
    [anon_sym_using] = ACTIONS(3707),
    [anon_sym_COLON_COLON] = ACTIONS(3709),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3709),
    [anon_sym___declspec] = ACTIONS(3707),
    [anon_sym___based] = ACTIONS(3707),
    [anon_sym___cdecl] = ACTIONS(3707),
    [anon_sym___clrcall] = ACTIONS(3707),
    [anon_sym___stdcall] = ACTIONS(3707),
    [anon_sym___fastcall] = ACTIONS(3707),
    [anon_sym___thiscall] = ACTIONS(3707),
    [anon_sym___vectorcall] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3709),
    [anon_sym_signed] = ACTIONS(3707),
    [anon_sym_unsigned] = ACTIONS(3707),
    [anon_sym_long] = ACTIONS(3707),
    [anon_sym_short] = ACTIONS(3707),
    [anon_sym_LBRACK] = ACTIONS(3707),
    [anon_sym_static] = ACTIONS(3707),
    [anon_sym_register] = ACTIONS(3707),
    [anon_sym_inline] = ACTIONS(3707),
    [anon_sym___inline] = ACTIONS(3707),
    [anon_sym___inline__] = ACTIONS(3707),
    [anon_sym___forceinline] = ACTIONS(3707),
    [anon_sym_thread_local] = ACTIONS(3707),
    [anon_sym___thread] = ACTIONS(3707),
    [anon_sym_const] = ACTIONS(3707),
    [anon_sym_constexpr] = ACTIONS(3707),
    [anon_sym_volatile] = ACTIONS(3707),
    [anon_sym_restrict] = ACTIONS(3707),
    [anon_sym___restrict__] = ACTIONS(3707),
    [anon_sym__Atomic] = ACTIONS(3707),
    [anon_sym__Noreturn] = ACTIONS(3707),
    [anon_sym_noreturn] = ACTIONS(3707),
    [anon_sym__Nonnull] = ACTIONS(3707),
    [anon_sym_mutable] = ACTIONS(3707),
    [anon_sym_constinit] = ACTIONS(3707),
    [anon_sym_consteval] = ACTIONS(3707),
    [anon_sym_alignas] = ACTIONS(3707),
    [anon_sym__Alignas] = ACTIONS(3707),
    [sym_primitive_type] = ACTIONS(3707),
    [anon_sym_enum] = ACTIONS(3707),
    [anon_sym_class] = ACTIONS(3707),
    [anon_sym_struct] = ACTIONS(3707),
    [anon_sym_union] = ACTIONS(3707),
    [anon_sym_if] = ACTIONS(3707),
    [anon_sym_switch] = ACTIONS(3707),
    [anon_sym_case] = ACTIONS(3707),
    [anon_sym_default] = ACTIONS(3707),
    [anon_sym_while] = ACTIONS(3707),
    [anon_sym_do] = ACTIONS(3707),
    [anon_sym_for] = ACTIONS(3707),
    [anon_sym_return] = ACTIONS(3707),
    [anon_sym_break] = ACTIONS(3707),
    [anon_sym_continue] = ACTIONS(3707),
    [anon_sym_goto] = ACTIONS(3707),
    [anon_sym___try] = ACTIONS(3707),
    [anon_sym___leave] = ACTIONS(3707),
    [anon_sym_not] = ACTIONS(3707),
    [anon_sym_compl] = ACTIONS(3707),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_sizeof] = ACTIONS(3707),
    [anon_sym___alignof__] = ACTIONS(3707),
    [anon_sym___alignof] = ACTIONS(3707),
    [anon_sym__alignof] = ACTIONS(3707),
    [anon_sym_alignof] = ACTIONS(3707),
    [anon_sym__Alignof] = ACTIONS(3707),
    [anon_sym_offsetof] = ACTIONS(3707),
    [anon_sym__Generic] = ACTIONS(3707),
    [anon_sym_asm] = ACTIONS(3707),
    [anon_sym___asm__] = ACTIONS(3707),
    [anon_sym___asm] = ACTIONS(3707),
    [sym_number_literal] = ACTIONS(3709),
    [anon_sym_L_SQUOTE] = ACTIONS(3709),
    [anon_sym_u_SQUOTE] = ACTIONS(3709),
    [anon_sym_U_SQUOTE] = ACTIONS(3709),
    [anon_sym_u8_SQUOTE] = ACTIONS(3709),
    [anon_sym_SQUOTE] = ACTIONS(3709),
    [anon_sym_L_DQUOTE] = ACTIONS(3709),
    [anon_sym_u_DQUOTE] = ACTIONS(3709),
    [anon_sym_U_DQUOTE] = ACTIONS(3709),
    [anon_sym_u8_DQUOTE] = ACTIONS(3709),
    [anon_sym_DQUOTE] = ACTIONS(3709),
    [sym_true] = ACTIONS(3707),
    [sym_false] = ACTIONS(3707),
    [anon_sym_NULL] = ACTIONS(3707),
    [anon_sym_nullptr] = ACTIONS(3707),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3707),
    [anon_sym_let] = ACTIONS(3707),
    [anon_sym_This] = ACTIONS(3707),
    [anon_sym_decltype] = ACTIONS(3707),
    [anon_sym_explicit] = ACTIONS(3707),
    [anon_sym_typename] = ACTIONS(3707),
    [anon_sym_template] = ACTIONS(3707),
    [anon_sym_operator] = ACTIONS(3707),
    [anon_sym_try] = ACTIONS(3707),
    [anon_sym_delete] = ACTIONS(3707),
    [anon_sym_throw] = ACTIONS(3707),
    [anon_sym_namespace] = ACTIONS(3707),
    [anon_sym_static_assert] = ACTIONS(3707),
    [anon_sym_concept] = ACTIONS(3707),
    [anon_sym_co_return] = ACTIONS(3707),
    [anon_sym_co_yield] = ACTIONS(3707),
    [anon_sym_R_DQUOTE] = ACTIONS(3709),
    [anon_sym_LR_DQUOTE] = ACTIONS(3709),
    [anon_sym_uR_DQUOTE] = ACTIONS(3709),
    [anon_sym_UR_DQUOTE] = ACTIONS(3709),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3709),
    [anon_sym_co_await] = ACTIONS(3707),
    [anon_sym_new] = ACTIONS(3707),
    [anon_sym_requires] = ACTIONS(3707),
    [sym_this] = ACTIONS(3707),
    [anon_sym_discard] = ACTIONS(3707),
    [anon_sym_precise] = ACTIONS(3707),
    [anon_sym_shared] = ACTIONS(3707),
    [anon_sym_groupshared] = ACTIONS(3707),
    [anon_sym_uniform] = ACTIONS(3707),
    [anon_sym_row_major] = ACTIONS(3707),
    [anon_sym_column_major] = ACTIONS(3707),
    [anon_sym_globallycoherent] = ACTIONS(3707),
    [anon_sym_centroid] = ACTIONS(3707),
    [anon_sym_noperspective] = ACTIONS(3707),
    [anon_sym_nointerpolation] = ACTIONS(3707),
    [anon_sym_sample] = ACTIONS(3707),
    [anon_sym_linear] = ACTIONS(3707),
    [anon_sym_snorm] = ACTIONS(3707),
    [anon_sym_unorm] = ACTIONS(3707),
    [anon_sym_point] = ACTIONS(3707),
    [anon_sym_line] = ACTIONS(3707),
    [anon_sym_triangleadj] = ACTIONS(3707),
    [anon_sym_lineadj] = ACTIONS(3707),
    [anon_sym_triangle] = ACTIONS(3707),
    [anon_sym_cbuffer] = ACTIONS(3707),
    [anon_sym_interface] = ACTIONS(3707),
    [anon_sym_extension] = ACTIONS(3707),
  },
  [941] = {
    [sym_identifier] = ACTIONS(3711),
    [aux_sym_preproc_include_token1] = ACTIONS(3711),
    [aux_sym_preproc_def_token1] = ACTIONS(3711),
    [aux_sym_preproc_if_token1] = ACTIONS(3711),
    [aux_sym_preproc_if_token2] = ACTIONS(3711),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3711),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3711),
    [sym_preproc_directive] = ACTIONS(3711),
    [anon_sym_LPAREN2] = ACTIONS(3713),
    [anon_sym_BANG] = ACTIONS(3713),
    [anon_sym_TILDE] = ACTIONS(3713),
    [anon_sym_DASH] = ACTIONS(3711),
    [anon_sym_PLUS] = ACTIONS(3711),
    [anon_sym_STAR] = ACTIONS(3713),
    [anon_sym_AMP_AMP] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(3711),
    [anon_sym_SEMI] = ACTIONS(3713),
    [anon_sym___extension__] = ACTIONS(3711),
    [anon_sym_typedef] = ACTIONS(3711),
    [anon_sym_in] = ACTIONS(3711),
    [anon_sym_out] = ACTIONS(3711),
    [anon_sym_inout] = ACTIONS(3711),
    [anon_sym_virtual] = ACTIONS(3711),
    [anon_sym_extern] = ACTIONS(3711),
    [anon_sym___attribute__] = ACTIONS(3711),
    [anon_sym___attribute] = ACTIONS(3711),
    [anon_sym_using] = ACTIONS(3711),
    [anon_sym_COLON_COLON] = ACTIONS(3713),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3713),
    [anon_sym___declspec] = ACTIONS(3711),
    [anon_sym___based] = ACTIONS(3711),
    [anon_sym___cdecl] = ACTIONS(3711),
    [anon_sym___clrcall] = ACTIONS(3711),
    [anon_sym___stdcall] = ACTIONS(3711),
    [anon_sym___fastcall] = ACTIONS(3711),
    [anon_sym___thiscall] = ACTIONS(3711),
    [anon_sym___vectorcall] = ACTIONS(3711),
    [anon_sym_LBRACE] = ACTIONS(3713),
    [anon_sym_signed] = ACTIONS(3711),
    [anon_sym_unsigned] = ACTIONS(3711),
    [anon_sym_long] = ACTIONS(3711),
    [anon_sym_short] = ACTIONS(3711),
    [anon_sym_LBRACK] = ACTIONS(3711),
    [anon_sym_static] = ACTIONS(3711),
    [anon_sym_register] = ACTIONS(3711),
    [anon_sym_inline] = ACTIONS(3711),
    [anon_sym___inline] = ACTIONS(3711),
    [anon_sym___inline__] = ACTIONS(3711),
    [anon_sym___forceinline] = ACTIONS(3711),
    [anon_sym_thread_local] = ACTIONS(3711),
    [anon_sym___thread] = ACTIONS(3711),
    [anon_sym_const] = ACTIONS(3711),
    [anon_sym_constexpr] = ACTIONS(3711),
    [anon_sym_volatile] = ACTIONS(3711),
    [anon_sym_restrict] = ACTIONS(3711),
    [anon_sym___restrict__] = ACTIONS(3711),
    [anon_sym__Atomic] = ACTIONS(3711),
    [anon_sym__Noreturn] = ACTIONS(3711),
    [anon_sym_noreturn] = ACTIONS(3711),
    [anon_sym__Nonnull] = ACTIONS(3711),
    [anon_sym_mutable] = ACTIONS(3711),
    [anon_sym_constinit] = ACTIONS(3711),
    [anon_sym_consteval] = ACTIONS(3711),
    [anon_sym_alignas] = ACTIONS(3711),
    [anon_sym__Alignas] = ACTIONS(3711),
    [sym_primitive_type] = ACTIONS(3711),
    [anon_sym_enum] = ACTIONS(3711),
    [anon_sym_class] = ACTIONS(3711),
    [anon_sym_struct] = ACTIONS(3711),
    [anon_sym_union] = ACTIONS(3711),
    [anon_sym_if] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3711),
    [anon_sym_case] = ACTIONS(3711),
    [anon_sym_default] = ACTIONS(3711),
    [anon_sym_while] = ACTIONS(3711),
    [anon_sym_do] = ACTIONS(3711),
    [anon_sym_for] = ACTIONS(3711),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_break] = ACTIONS(3711),
    [anon_sym_continue] = ACTIONS(3711),
    [anon_sym_goto] = ACTIONS(3711),
    [anon_sym___try] = ACTIONS(3711),
    [anon_sym___leave] = ACTIONS(3711),
    [anon_sym_not] = ACTIONS(3711),
    [anon_sym_compl] = ACTIONS(3711),
    [anon_sym_DASH_DASH] = ACTIONS(3713),
    [anon_sym_PLUS_PLUS] = ACTIONS(3713),
    [anon_sym_sizeof] = ACTIONS(3711),
    [anon_sym___alignof__] = ACTIONS(3711),
    [anon_sym___alignof] = ACTIONS(3711),
    [anon_sym__alignof] = ACTIONS(3711),
    [anon_sym_alignof] = ACTIONS(3711),
    [anon_sym__Alignof] = ACTIONS(3711),
    [anon_sym_offsetof] = ACTIONS(3711),
    [anon_sym__Generic] = ACTIONS(3711),
    [anon_sym_asm] = ACTIONS(3711),
    [anon_sym___asm__] = ACTIONS(3711),
    [anon_sym___asm] = ACTIONS(3711),
    [sym_number_literal] = ACTIONS(3713),
    [anon_sym_L_SQUOTE] = ACTIONS(3713),
    [anon_sym_u_SQUOTE] = ACTIONS(3713),
    [anon_sym_U_SQUOTE] = ACTIONS(3713),
    [anon_sym_u8_SQUOTE] = ACTIONS(3713),
    [anon_sym_SQUOTE] = ACTIONS(3713),
    [anon_sym_L_DQUOTE] = ACTIONS(3713),
    [anon_sym_u_DQUOTE] = ACTIONS(3713),
    [anon_sym_U_DQUOTE] = ACTIONS(3713),
    [anon_sym_u8_DQUOTE] = ACTIONS(3713),
    [anon_sym_DQUOTE] = ACTIONS(3713),
    [sym_true] = ACTIONS(3711),
    [sym_false] = ACTIONS(3711),
    [anon_sym_NULL] = ACTIONS(3711),
    [anon_sym_nullptr] = ACTIONS(3711),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_This] = ACTIONS(3711),
    [anon_sym_decltype] = ACTIONS(3711),
    [anon_sym_explicit] = ACTIONS(3711),
    [anon_sym_typename] = ACTIONS(3711),
    [anon_sym_template] = ACTIONS(3711),
    [anon_sym_operator] = ACTIONS(3711),
    [anon_sym_try] = ACTIONS(3711),
    [anon_sym_delete] = ACTIONS(3711),
    [anon_sym_throw] = ACTIONS(3711),
    [anon_sym_namespace] = ACTIONS(3711),
    [anon_sym_static_assert] = ACTIONS(3711),
    [anon_sym_concept] = ACTIONS(3711),
    [anon_sym_co_return] = ACTIONS(3711),
    [anon_sym_co_yield] = ACTIONS(3711),
    [anon_sym_R_DQUOTE] = ACTIONS(3713),
    [anon_sym_LR_DQUOTE] = ACTIONS(3713),
    [anon_sym_uR_DQUOTE] = ACTIONS(3713),
    [anon_sym_UR_DQUOTE] = ACTIONS(3713),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3713),
    [anon_sym_co_await] = ACTIONS(3711),
    [anon_sym_new] = ACTIONS(3711),
    [anon_sym_requires] = ACTIONS(3711),
    [sym_this] = ACTIONS(3711),
    [anon_sym_discard] = ACTIONS(3711),
    [anon_sym_precise] = ACTIONS(3711),
    [anon_sym_shared] = ACTIONS(3711),
    [anon_sym_groupshared] = ACTIONS(3711),
    [anon_sym_uniform] = ACTIONS(3711),
    [anon_sym_row_major] = ACTIONS(3711),
    [anon_sym_column_major] = ACTIONS(3711),
    [anon_sym_globallycoherent] = ACTIONS(3711),
    [anon_sym_centroid] = ACTIONS(3711),
    [anon_sym_noperspective] = ACTIONS(3711),
    [anon_sym_nointerpolation] = ACTIONS(3711),
    [anon_sym_sample] = ACTIONS(3711),
    [anon_sym_linear] = ACTIONS(3711),
    [anon_sym_snorm] = ACTIONS(3711),
    [anon_sym_unorm] = ACTIONS(3711),
    [anon_sym_point] = ACTIONS(3711),
    [anon_sym_line] = ACTIONS(3711),
    [anon_sym_triangleadj] = ACTIONS(3711),
    [anon_sym_lineadj] = ACTIONS(3711),
    [anon_sym_triangle] = ACTIONS(3711),
    [anon_sym_cbuffer] = ACTIONS(3711),
    [anon_sym_interface] = ACTIONS(3711),
    [anon_sym_extension] = ACTIONS(3711),
  },
  [942] = {
    [sym_identifier] = ACTIONS(3715),
    [aux_sym_preproc_include_token1] = ACTIONS(3715),
    [aux_sym_preproc_def_token1] = ACTIONS(3715),
    [aux_sym_preproc_if_token1] = ACTIONS(3715),
    [aux_sym_preproc_if_token2] = ACTIONS(3715),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3715),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3715),
    [sym_preproc_directive] = ACTIONS(3715),
    [anon_sym_LPAREN2] = ACTIONS(3717),
    [anon_sym_BANG] = ACTIONS(3717),
    [anon_sym_TILDE] = ACTIONS(3717),
    [anon_sym_DASH] = ACTIONS(3715),
    [anon_sym_PLUS] = ACTIONS(3715),
    [anon_sym_STAR] = ACTIONS(3717),
    [anon_sym_AMP_AMP] = ACTIONS(3717),
    [anon_sym_AMP] = ACTIONS(3715),
    [anon_sym_SEMI] = ACTIONS(3717),
    [anon_sym___extension__] = ACTIONS(3715),
    [anon_sym_typedef] = ACTIONS(3715),
    [anon_sym_in] = ACTIONS(3715),
    [anon_sym_out] = ACTIONS(3715),
    [anon_sym_inout] = ACTIONS(3715),
    [anon_sym_virtual] = ACTIONS(3715),
    [anon_sym_extern] = ACTIONS(3715),
    [anon_sym___attribute__] = ACTIONS(3715),
    [anon_sym___attribute] = ACTIONS(3715),
    [anon_sym_using] = ACTIONS(3715),
    [anon_sym_COLON_COLON] = ACTIONS(3717),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3717),
    [anon_sym___declspec] = ACTIONS(3715),
    [anon_sym___based] = ACTIONS(3715),
    [anon_sym___cdecl] = ACTIONS(3715),
    [anon_sym___clrcall] = ACTIONS(3715),
    [anon_sym___stdcall] = ACTIONS(3715),
    [anon_sym___fastcall] = ACTIONS(3715),
    [anon_sym___thiscall] = ACTIONS(3715),
    [anon_sym___vectorcall] = ACTIONS(3715),
    [anon_sym_LBRACE] = ACTIONS(3717),
    [anon_sym_signed] = ACTIONS(3715),
    [anon_sym_unsigned] = ACTIONS(3715),
    [anon_sym_long] = ACTIONS(3715),
    [anon_sym_short] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_static] = ACTIONS(3715),
    [anon_sym_register] = ACTIONS(3715),
    [anon_sym_inline] = ACTIONS(3715),
    [anon_sym___inline] = ACTIONS(3715),
    [anon_sym___inline__] = ACTIONS(3715),
    [anon_sym___forceinline] = ACTIONS(3715),
    [anon_sym_thread_local] = ACTIONS(3715),
    [anon_sym___thread] = ACTIONS(3715),
    [anon_sym_const] = ACTIONS(3715),
    [anon_sym_constexpr] = ACTIONS(3715),
    [anon_sym_volatile] = ACTIONS(3715),
    [anon_sym_restrict] = ACTIONS(3715),
    [anon_sym___restrict__] = ACTIONS(3715),
    [anon_sym__Atomic] = ACTIONS(3715),
    [anon_sym__Noreturn] = ACTIONS(3715),
    [anon_sym_noreturn] = ACTIONS(3715),
    [anon_sym__Nonnull] = ACTIONS(3715),
    [anon_sym_mutable] = ACTIONS(3715),
    [anon_sym_constinit] = ACTIONS(3715),
    [anon_sym_consteval] = ACTIONS(3715),
    [anon_sym_alignas] = ACTIONS(3715),
    [anon_sym__Alignas] = ACTIONS(3715),
    [sym_primitive_type] = ACTIONS(3715),
    [anon_sym_enum] = ACTIONS(3715),
    [anon_sym_class] = ACTIONS(3715),
    [anon_sym_struct] = ACTIONS(3715),
    [anon_sym_union] = ACTIONS(3715),
    [anon_sym_if] = ACTIONS(3715),
    [anon_sym_switch] = ACTIONS(3715),
    [anon_sym_case] = ACTIONS(3715),
    [anon_sym_default] = ACTIONS(3715),
    [anon_sym_while] = ACTIONS(3715),
    [anon_sym_do] = ACTIONS(3715),
    [anon_sym_for] = ACTIONS(3715),
    [anon_sym_return] = ACTIONS(3715),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_continue] = ACTIONS(3715),
    [anon_sym_goto] = ACTIONS(3715),
    [anon_sym___try] = ACTIONS(3715),
    [anon_sym___leave] = ACTIONS(3715),
    [anon_sym_not] = ACTIONS(3715),
    [anon_sym_compl] = ACTIONS(3715),
    [anon_sym_DASH_DASH] = ACTIONS(3717),
    [anon_sym_PLUS_PLUS] = ACTIONS(3717),
    [anon_sym_sizeof] = ACTIONS(3715),
    [anon_sym___alignof__] = ACTIONS(3715),
    [anon_sym___alignof] = ACTIONS(3715),
    [anon_sym__alignof] = ACTIONS(3715),
    [anon_sym_alignof] = ACTIONS(3715),
    [anon_sym__Alignof] = ACTIONS(3715),
    [anon_sym_offsetof] = ACTIONS(3715),
    [anon_sym__Generic] = ACTIONS(3715),
    [anon_sym_asm] = ACTIONS(3715),
    [anon_sym___asm__] = ACTIONS(3715),
    [anon_sym___asm] = ACTIONS(3715),
    [sym_number_literal] = ACTIONS(3717),
    [anon_sym_L_SQUOTE] = ACTIONS(3717),
    [anon_sym_u_SQUOTE] = ACTIONS(3717),
    [anon_sym_U_SQUOTE] = ACTIONS(3717),
    [anon_sym_u8_SQUOTE] = ACTIONS(3717),
    [anon_sym_SQUOTE] = ACTIONS(3717),
    [anon_sym_L_DQUOTE] = ACTIONS(3717),
    [anon_sym_u_DQUOTE] = ACTIONS(3717),
    [anon_sym_U_DQUOTE] = ACTIONS(3717),
    [anon_sym_u8_DQUOTE] = ACTIONS(3717),
    [anon_sym_DQUOTE] = ACTIONS(3717),
    [sym_true] = ACTIONS(3715),
    [sym_false] = ACTIONS(3715),
    [anon_sym_NULL] = ACTIONS(3715),
    [anon_sym_nullptr] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3715),
    [anon_sym_let] = ACTIONS(3715),
    [anon_sym_This] = ACTIONS(3715),
    [anon_sym_decltype] = ACTIONS(3715),
    [anon_sym_explicit] = ACTIONS(3715),
    [anon_sym_typename] = ACTIONS(3715),
    [anon_sym_template] = ACTIONS(3715),
    [anon_sym_operator] = ACTIONS(3715),
    [anon_sym_try] = ACTIONS(3715),
    [anon_sym_delete] = ACTIONS(3715),
    [anon_sym_throw] = ACTIONS(3715),
    [anon_sym_namespace] = ACTIONS(3715),
    [anon_sym_static_assert] = ACTIONS(3715),
    [anon_sym_concept] = ACTIONS(3715),
    [anon_sym_co_return] = ACTIONS(3715),
    [anon_sym_co_yield] = ACTIONS(3715),
    [anon_sym_R_DQUOTE] = ACTIONS(3717),
    [anon_sym_LR_DQUOTE] = ACTIONS(3717),
    [anon_sym_uR_DQUOTE] = ACTIONS(3717),
    [anon_sym_UR_DQUOTE] = ACTIONS(3717),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3717),
    [anon_sym_co_await] = ACTIONS(3715),
    [anon_sym_new] = ACTIONS(3715),
    [anon_sym_requires] = ACTIONS(3715),
    [sym_this] = ACTIONS(3715),
    [anon_sym_discard] = ACTIONS(3715),
    [anon_sym_precise] = ACTIONS(3715),
    [anon_sym_shared] = ACTIONS(3715),
    [anon_sym_groupshared] = ACTIONS(3715),
    [anon_sym_uniform] = ACTIONS(3715),
    [anon_sym_row_major] = ACTIONS(3715),
    [anon_sym_column_major] = ACTIONS(3715),
    [anon_sym_globallycoherent] = ACTIONS(3715),
    [anon_sym_centroid] = ACTIONS(3715),
    [anon_sym_noperspective] = ACTIONS(3715),
    [anon_sym_nointerpolation] = ACTIONS(3715),
    [anon_sym_sample] = ACTIONS(3715),
    [anon_sym_linear] = ACTIONS(3715),
    [anon_sym_snorm] = ACTIONS(3715),
    [anon_sym_unorm] = ACTIONS(3715),
    [anon_sym_point] = ACTIONS(3715),
    [anon_sym_line] = ACTIONS(3715),
    [anon_sym_triangleadj] = ACTIONS(3715),
    [anon_sym_lineadj] = ACTIONS(3715),
    [anon_sym_triangle] = ACTIONS(3715),
    [anon_sym_cbuffer] = ACTIONS(3715),
    [anon_sym_interface] = ACTIONS(3715),
    [anon_sym_extension] = ACTIONS(3715),
  },
  [943] = {
    [sym_identifier] = ACTIONS(3735),
    [aux_sym_preproc_include_token1] = ACTIONS(3735),
    [aux_sym_preproc_def_token1] = ACTIONS(3735),
    [aux_sym_preproc_if_token1] = ACTIONS(3735),
    [aux_sym_preproc_if_token2] = ACTIONS(3735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3735),
    [sym_preproc_directive] = ACTIONS(3735),
    [anon_sym_LPAREN2] = ACTIONS(3737),
    [anon_sym_BANG] = ACTIONS(3737),
    [anon_sym_TILDE] = ACTIONS(3737),
    [anon_sym_DASH] = ACTIONS(3735),
    [anon_sym_PLUS] = ACTIONS(3735),
    [anon_sym_STAR] = ACTIONS(3737),
    [anon_sym_AMP_AMP] = ACTIONS(3737),
    [anon_sym_AMP] = ACTIONS(3735),
    [anon_sym_SEMI] = ACTIONS(3737),
    [anon_sym___extension__] = ACTIONS(3735),
    [anon_sym_typedef] = ACTIONS(3735),
    [anon_sym_in] = ACTIONS(3735),
    [anon_sym_out] = ACTIONS(3735),
    [anon_sym_inout] = ACTIONS(3735),
    [anon_sym_virtual] = ACTIONS(3735),
    [anon_sym_extern] = ACTIONS(3735),
    [anon_sym___attribute__] = ACTIONS(3735),
    [anon_sym___attribute] = ACTIONS(3735),
    [anon_sym_using] = ACTIONS(3735),
    [anon_sym_COLON_COLON] = ACTIONS(3737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3737),
    [anon_sym___declspec] = ACTIONS(3735),
    [anon_sym___based] = ACTIONS(3735),
    [anon_sym___cdecl] = ACTIONS(3735),
    [anon_sym___clrcall] = ACTIONS(3735),
    [anon_sym___stdcall] = ACTIONS(3735),
    [anon_sym___fastcall] = ACTIONS(3735),
    [anon_sym___thiscall] = ACTIONS(3735),
    [anon_sym___vectorcall] = ACTIONS(3735),
    [anon_sym_LBRACE] = ACTIONS(3737),
    [anon_sym_signed] = ACTIONS(3735),
    [anon_sym_unsigned] = ACTIONS(3735),
    [anon_sym_long] = ACTIONS(3735),
    [anon_sym_short] = ACTIONS(3735),
    [anon_sym_LBRACK] = ACTIONS(3735),
    [anon_sym_static] = ACTIONS(3735),
    [anon_sym_register] = ACTIONS(3735),
    [anon_sym_inline] = ACTIONS(3735),
    [anon_sym___inline] = ACTIONS(3735),
    [anon_sym___inline__] = ACTIONS(3735),
    [anon_sym___forceinline] = ACTIONS(3735),
    [anon_sym_thread_local] = ACTIONS(3735),
    [anon_sym___thread] = ACTIONS(3735),
    [anon_sym_const] = ACTIONS(3735),
    [anon_sym_constexpr] = ACTIONS(3735),
    [anon_sym_volatile] = ACTIONS(3735),
    [anon_sym_restrict] = ACTIONS(3735),
    [anon_sym___restrict__] = ACTIONS(3735),
    [anon_sym__Atomic] = ACTIONS(3735),
    [anon_sym__Noreturn] = ACTIONS(3735),
    [anon_sym_noreturn] = ACTIONS(3735),
    [anon_sym__Nonnull] = ACTIONS(3735),
    [anon_sym_mutable] = ACTIONS(3735),
    [anon_sym_constinit] = ACTIONS(3735),
    [anon_sym_consteval] = ACTIONS(3735),
    [anon_sym_alignas] = ACTIONS(3735),
    [anon_sym__Alignas] = ACTIONS(3735),
    [sym_primitive_type] = ACTIONS(3735),
    [anon_sym_enum] = ACTIONS(3735),
    [anon_sym_class] = ACTIONS(3735),
    [anon_sym_struct] = ACTIONS(3735),
    [anon_sym_union] = ACTIONS(3735),
    [anon_sym_if] = ACTIONS(3735),
    [anon_sym_switch] = ACTIONS(3735),
    [anon_sym_case] = ACTIONS(3735),
    [anon_sym_default] = ACTIONS(3735),
    [anon_sym_while] = ACTIONS(3735),
    [anon_sym_do] = ACTIONS(3735),
    [anon_sym_for] = ACTIONS(3735),
    [anon_sym_return] = ACTIONS(3735),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_continue] = ACTIONS(3735),
    [anon_sym_goto] = ACTIONS(3735),
    [anon_sym___try] = ACTIONS(3735),
    [anon_sym___leave] = ACTIONS(3735),
    [anon_sym_not] = ACTIONS(3735),
    [anon_sym_compl] = ACTIONS(3735),
    [anon_sym_DASH_DASH] = ACTIONS(3737),
    [anon_sym_PLUS_PLUS] = ACTIONS(3737),
    [anon_sym_sizeof] = ACTIONS(3735),
    [anon_sym___alignof__] = ACTIONS(3735),
    [anon_sym___alignof] = ACTIONS(3735),
    [anon_sym__alignof] = ACTIONS(3735),
    [anon_sym_alignof] = ACTIONS(3735),
    [anon_sym__Alignof] = ACTIONS(3735),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3735),
    [anon_sym_asm] = ACTIONS(3735),
    [anon_sym___asm__] = ACTIONS(3735),
    [anon_sym___asm] = ACTIONS(3735),
    [sym_number_literal] = ACTIONS(3737),
    [anon_sym_L_SQUOTE] = ACTIONS(3737),
    [anon_sym_u_SQUOTE] = ACTIONS(3737),
    [anon_sym_U_SQUOTE] = ACTIONS(3737),
    [anon_sym_u8_SQUOTE] = ACTIONS(3737),
    [anon_sym_SQUOTE] = ACTIONS(3737),
    [anon_sym_L_DQUOTE] = ACTIONS(3737),
    [anon_sym_u_DQUOTE] = ACTIONS(3737),
    [anon_sym_U_DQUOTE] = ACTIONS(3737),
    [anon_sym_u8_DQUOTE] = ACTIONS(3737),
    [anon_sym_DQUOTE] = ACTIONS(3737),
    [sym_true] = ACTIONS(3735),
    [sym_false] = ACTIONS(3735),
    [anon_sym_NULL] = ACTIONS(3735),
    [anon_sym_nullptr] = ACTIONS(3735),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3735),
    [anon_sym_let] = ACTIONS(3735),
    [anon_sym_This] = ACTIONS(3735),
    [anon_sym_decltype] = ACTIONS(3735),
    [anon_sym_explicit] = ACTIONS(3735),
    [anon_sym_typename] = ACTIONS(3735),
    [anon_sym_template] = ACTIONS(3735),
    [anon_sym_operator] = ACTIONS(3735),
    [anon_sym_try] = ACTIONS(3735),
    [anon_sym_delete] = ACTIONS(3735),
    [anon_sym_throw] = ACTIONS(3735),
    [anon_sym_namespace] = ACTIONS(3735),
    [anon_sym_static_assert] = ACTIONS(3735),
    [anon_sym_concept] = ACTIONS(3735),
    [anon_sym_co_return] = ACTIONS(3735),
    [anon_sym_co_yield] = ACTIONS(3735),
    [anon_sym_R_DQUOTE] = ACTIONS(3737),
    [anon_sym_LR_DQUOTE] = ACTIONS(3737),
    [anon_sym_uR_DQUOTE] = ACTIONS(3737),
    [anon_sym_UR_DQUOTE] = ACTIONS(3737),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3737),
    [anon_sym_co_await] = ACTIONS(3735),
    [anon_sym_new] = ACTIONS(3735),
    [anon_sym_requires] = ACTIONS(3735),
    [sym_this] = ACTIONS(3735),
    [anon_sym_discard] = ACTIONS(3735),
    [anon_sym_precise] = ACTIONS(3735),
    [anon_sym_shared] = ACTIONS(3735),
    [anon_sym_groupshared] = ACTIONS(3735),
    [anon_sym_uniform] = ACTIONS(3735),
    [anon_sym_row_major] = ACTIONS(3735),
    [anon_sym_column_major] = ACTIONS(3735),
    [anon_sym_globallycoherent] = ACTIONS(3735),
    [anon_sym_centroid] = ACTIONS(3735),
    [anon_sym_noperspective] = ACTIONS(3735),
    [anon_sym_nointerpolation] = ACTIONS(3735),
    [anon_sym_sample] = ACTIONS(3735),
    [anon_sym_linear] = ACTIONS(3735),
    [anon_sym_snorm] = ACTIONS(3735),
    [anon_sym_unorm] = ACTIONS(3735),
    [anon_sym_point] = ACTIONS(3735),
    [anon_sym_line] = ACTIONS(3735),
    [anon_sym_triangleadj] = ACTIONS(3735),
    [anon_sym_lineadj] = ACTIONS(3735),
    [anon_sym_triangle] = ACTIONS(3735),
    [anon_sym_cbuffer] = ACTIONS(3735),
    [anon_sym_interface] = ACTIONS(3735),
    [anon_sym_extension] = ACTIONS(3735),
  },
  [944] = {
    [sym_identifier] = ACTIONS(3763),
    [aux_sym_preproc_include_token1] = ACTIONS(3763),
    [aux_sym_preproc_def_token1] = ACTIONS(3763),
    [aux_sym_preproc_if_token1] = ACTIONS(3763),
    [aux_sym_preproc_if_token2] = ACTIONS(3763),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3763),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3763),
    [sym_preproc_directive] = ACTIONS(3763),
    [anon_sym_LPAREN2] = ACTIONS(3765),
    [anon_sym_BANG] = ACTIONS(3765),
    [anon_sym_TILDE] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3763),
    [anon_sym_STAR] = ACTIONS(3765),
    [anon_sym_AMP_AMP] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3763),
    [anon_sym_SEMI] = ACTIONS(3765),
    [anon_sym___extension__] = ACTIONS(3763),
    [anon_sym_typedef] = ACTIONS(3763),
    [anon_sym_in] = ACTIONS(3763),
    [anon_sym_out] = ACTIONS(3763),
    [anon_sym_inout] = ACTIONS(3763),
    [anon_sym_virtual] = ACTIONS(3763),
    [anon_sym_extern] = ACTIONS(3763),
    [anon_sym___attribute__] = ACTIONS(3763),
    [anon_sym___attribute] = ACTIONS(3763),
    [anon_sym_using] = ACTIONS(3763),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3765),
    [anon_sym___declspec] = ACTIONS(3763),
    [anon_sym___based] = ACTIONS(3763),
    [anon_sym___cdecl] = ACTIONS(3763),
    [anon_sym___clrcall] = ACTIONS(3763),
    [anon_sym___stdcall] = ACTIONS(3763),
    [anon_sym___fastcall] = ACTIONS(3763),
    [anon_sym___thiscall] = ACTIONS(3763),
    [anon_sym___vectorcall] = ACTIONS(3763),
    [anon_sym_LBRACE] = ACTIONS(3765),
    [anon_sym_signed] = ACTIONS(3763),
    [anon_sym_unsigned] = ACTIONS(3763),
    [anon_sym_long] = ACTIONS(3763),
    [anon_sym_short] = ACTIONS(3763),
    [anon_sym_LBRACK] = ACTIONS(3763),
    [anon_sym_static] = ACTIONS(3763),
    [anon_sym_register] = ACTIONS(3763),
    [anon_sym_inline] = ACTIONS(3763),
    [anon_sym___inline] = ACTIONS(3763),
    [anon_sym___inline__] = ACTIONS(3763),
    [anon_sym___forceinline] = ACTIONS(3763),
    [anon_sym_thread_local] = ACTIONS(3763),
    [anon_sym___thread] = ACTIONS(3763),
    [anon_sym_const] = ACTIONS(3763),
    [anon_sym_constexpr] = ACTIONS(3763),
    [anon_sym_volatile] = ACTIONS(3763),
    [anon_sym_restrict] = ACTIONS(3763),
    [anon_sym___restrict__] = ACTIONS(3763),
    [anon_sym__Atomic] = ACTIONS(3763),
    [anon_sym__Noreturn] = ACTIONS(3763),
    [anon_sym_noreturn] = ACTIONS(3763),
    [anon_sym__Nonnull] = ACTIONS(3763),
    [anon_sym_mutable] = ACTIONS(3763),
    [anon_sym_constinit] = ACTIONS(3763),
    [anon_sym_consteval] = ACTIONS(3763),
    [anon_sym_alignas] = ACTIONS(3763),
    [anon_sym__Alignas] = ACTIONS(3763),
    [sym_primitive_type] = ACTIONS(3763),
    [anon_sym_enum] = ACTIONS(3763),
    [anon_sym_class] = ACTIONS(3763),
    [anon_sym_struct] = ACTIONS(3763),
    [anon_sym_union] = ACTIONS(3763),
    [anon_sym_if] = ACTIONS(3763),
    [anon_sym_switch] = ACTIONS(3763),
    [anon_sym_case] = ACTIONS(3763),
    [anon_sym_default] = ACTIONS(3763),
    [anon_sym_while] = ACTIONS(3763),
    [anon_sym_do] = ACTIONS(3763),
    [anon_sym_for] = ACTIONS(3763),
    [anon_sym_return] = ACTIONS(3763),
    [anon_sym_break] = ACTIONS(3763),
    [anon_sym_continue] = ACTIONS(3763),
    [anon_sym_goto] = ACTIONS(3763),
    [anon_sym___try] = ACTIONS(3763),
    [anon_sym___leave] = ACTIONS(3763),
    [anon_sym_not] = ACTIONS(3763),
    [anon_sym_compl] = ACTIONS(3763),
    [anon_sym_DASH_DASH] = ACTIONS(3765),
    [anon_sym_PLUS_PLUS] = ACTIONS(3765),
    [anon_sym_sizeof] = ACTIONS(3763),
    [anon_sym___alignof__] = ACTIONS(3763),
    [anon_sym___alignof] = ACTIONS(3763),
    [anon_sym__alignof] = ACTIONS(3763),
    [anon_sym_alignof] = ACTIONS(3763),
    [anon_sym__Alignof] = ACTIONS(3763),
    [anon_sym_offsetof] = ACTIONS(3763),
    [anon_sym__Generic] = ACTIONS(3763),
    [anon_sym_asm] = ACTIONS(3763),
    [anon_sym___asm__] = ACTIONS(3763),
    [anon_sym___asm] = ACTIONS(3763),
    [sym_number_literal] = ACTIONS(3765),
    [anon_sym_L_SQUOTE] = ACTIONS(3765),
    [anon_sym_u_SQUOTE] = ACTIONS(3765),
    [anon_sym_U_SQUOTE] = ACTIONS(3765),
    [anon_sym_u8_SQUOTE] = ACTIONS(3765),
    [anon_sym_SQUOTE] = ACTIONS(3765),
    [anon_sym_L_DQUOTE] = ACTIONS(3765),
    [anon_sym_u_DQUOTE] = ACTIONS(3765),
    [anon_sym_U_DQUOTE] = ACTIONS(3765),
    [anon_sym_u8_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE] = ACTIONS(3765),
    [sym_true] = ACTIONS(3763),
    [sym_false] = ACTIONS(3763),
    [anon_sym_NULL] = ACTIONS(3763),
    [anon_sym_nullptr] = ACTIONS(3763),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3763),
    [anon_sym_let] = ACTIONS(3763),
    [anon_sym_This] = ACTIONS(3763),
    [anon_sym_decltype] = ACTIONS(3763),
    [anon_sym_explicit] = ACTIONS(3763),
    [anon_sym_typename] = ACTIONS(3763),
    [anon_sym_template] = ACTIONS(3763),
    [anon_sym_operator] = ACTIONS(3763),
    [anon_sym_try] = ACTIONS(3763),
    [anon_sym_delete] = ACTIONS(3763),
    [anon_sym_throw] = ACTIONS(3763),
    [anon_sym_namespace] = ACTIONS(3763),
    [anon_sym_static_assert] = ACTIONS(3763),
    [anon_sym_concept] = ACTIONS(3763),
    [anon_sym_co_return] = ACTIONS(3763),
    [anon_sym_co_yield] = ACTIONS(3763),
    [anon_sym_R_DQUOTE] = ACTIONS(3765),
    [anon_sym_LR_DQUOTE] = ACTIONS(3765),
    [anon_sym_uR_DQUOTE] = ACTIONS(3765),
    [anon_sym_UR_DQUOTE] = ACTIONS(3765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3765),
    [anon_sym_co_await] = ACTIONS(3763),
    [anon_sym_new] = ACTIONS(3763),
    [anon_sym_requires] = ACTIONS(3763),
    [sym_this] = ACTIONS(3763),
    [anon_sym_discard] = ACTIONS(3763),
    [anon_sym_precise] = ACTIONS(3763),
    [anon_sym_shared] = ACTIONS(3763),
    [anon_sym_groupshared] = ACTIONS(3763),
    [anon_sym_uniform] = ACTIONS(3763),
    [anon_sym_row_major] = ACTIONS(3763),
    [anon_sym_column_major] = ACTIONS(3763),
    [anon_sym_globallycoherent] = ACTIONS(3763),
    [anon_sym_centroid] = ACTIONS(3763),
    [anon_sym_noperspective] = ACTIONS(3763),
    [anon_sym_nointerpolation] = ACTIONS(3763),
    [anon_sym_sample] = ACTIONS(3763),
    [anon_sym_linear] = ACTIONS(3763),
    [anon_sym_snorm] = ACTIONS(3763),
    [anon_sym_unorm] = ACTIONS(3763),
    [anon_sym_point] = ACTIONS(3763),
    [anon_sym_line] = ACTIONS(3763),
    [anon_sym_triangleadj] = ACTIONS(3763),
    [anon_sym_lineadj] = ACTIONS(3763),
    [anon_sym_triangle] = ACTIONS(3763),
    [anon_sym_cbuffer] = ACTIONS(3763),
    [anon_sym_interface] = ACTIONS(3763),
    [anon_sym_extension] = ACTIONS(3763),
  },
  [945] = {
    [sym_identifier] = ACTIONS(3719),
    [aux_sym_preproc_include_token1] = ACTIONS(3719),
    [aux_sym_preproc_def_token1] = ACTIONS(3719),
    [aux_sym_preproc_if_token1] = ACTIONS(3719),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3719),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3719),
    [sym_preproc_directive] = ACTIONS(3719),
    [anon_sym_LPAREN2] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_TILDE] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3719),
    [anon_sym_SEMI] = ACTIONS(3721),
    [anon_sym___extension__] = ACTIONS(3719),
    [anon_sym_typedef] = ACTIONS(3719),
    [anon_sym_in] = ACTIONS(3719),
    [anon_sym_out] = ACTIONS(3719),
    [anon_sym_inout] = ACTIONS(3719),
    [anon_sym_virtual] = ACTIONS(3719),
    [anon_sym_extern] = ACTIONS(3719),
    [anon_sym___attribute__] = ACTIONS(3719),
    [anon_sym___attribute] = ACTIONS(3719),
    [anon_sym_using] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3721),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3721),
    [anon_sym___declspec] = ACTIONS(3719),
    [anon_sym___based] = ACTIONS(3719),
    [anon_sym___cdecl] = ACTIONS(3719),
    [anon_sym___clrcall] = ACTIONS(3719),
    [anon_sym___stdcall] = ACTIONS(3719),
    [anon_sym___fastcall] = ACTIONS(3719),
    [anon_sym___thiscall] = ACTIONS(3719),
    [anon_sym___vectorcall] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(3721),
    [anon_sym_RBRACE] = ACTIONS(3721),
    [anon_sym_signed] = ACTIONS(3719),
    [anon_sym_unsigned] = ACTIONS(3719),
    [anon_sym_long] = ACTIONS(3719),
    [anon_sym_short] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_static] = ACTIONS(3719),
    [anon_sym_register] = ACTIONS(3719),
    [anon_sym_inline] = ACTIONS(3719),
    [anon_sym___inline] = ACTIONS(3719),
    [anon_sym___inline__] = ACTIONS(3719),
    [anon_sym___forceinline] = ACTIONS(3719),
    [anon_sym_thread_local] = ACTIONS(3719),
    [anon_sym___thread] = ACTIONS(3719),
    [anon_sym_const] = ACTIONS(3719),
    [anon_sym_constexpr] = ACTIONS(3719),
    [anon_sym_volatile] = ACTIONS(3719),
    [anon_sym_restrict] = ACTIONS(3719),
    [anon_sym___restrict__] = ACTIONS(3719),
    [anon_sym__Atomic] = ACTIONS(3719),
    [anon_sym__Noreturn] = ACTIONS(3719),
    [anon_sym_noreturn] = ACTIONS(3719),
    [anon_sym__Nonnull] = ACTIONS(3719),
    [anon_sym_mutable] = ACTIONS(3719),
    [anon_sym_constinit] = ACTIONS(3719),
    [anon_sym_consteval] = ACTIONS(3719),
    [anon_sym_alignas] = ACTIONS(3719),
    [anon_sym__Alignas] = ACTIONS(3719),
    [sym_primitive_type] = ACTIONS(3719),
    [anon_sym_enum] = ACTIONS(3719),
    [anon_sym_class] = ACTIONS(3719),
    [anon_sym_struct] = ACTIONS(3719),
    [anon_sym_union] = ACTIONS(3719),
    [anon_sym_if] = ACTIONS(3719),
    [anon_sym_switch] = ACTIONS(3719),
    [anon_sym_case] = ACTIONS(3719),
    [anon_sym_default] = ACTIONS(3719),
    [anon_sym_while] = ACTIONS(3719),
    [anon_sym_do] = ACTIONS(3719),
    [anon_sym_for] = ACTIONS(3719),
    [anon_sym_return] = ACTIONS(3719),
    [anon_sym_break] = ACTIONS(3719),
    [anon_sym_continue] = ACTIONS(3719),
    [anon_sym_goto] = ACTIONS(3719),
    [anon_sym___try] = ACTIONS(3719),
    [anon_sym___leave] = ACTIONS(3719),
    [anon_sym_not] = ACTIONS(3719),
    [anon_sym_compl] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3721),
    [anon_sym_sizeof] = ACTIONS(3719),
    [anon_sym___alignof__] = ACTIONS(3719),
    [anon_sym___alignof] = ACTIONS(3719),
    [anon_sym__alignof] = ACTIONS(3719),
    [anon_sym_alignof] = ACTIONS(3719),
    [anon_sym__Alignof] = ACTIONS(3719),
    [anon_sym_offsetof] = ACTIONS(3719),
    [anon_sym__Generic] = ACTIONS(3719),
    [anon_sym_asm] = ACTIONS(3719),
    [anon_sym___asm__] = ACTIONS(3719),
    [anon_sym___asm] = ACTIONS(3719),
    [sym_number_literal] = ACTIONS(3721),
    [anon_sym_L_SQUOTE] = ACTIONS(3721),
    [anon_sym_u_SQUOTE] = ACTIONS(3721),
    [anon_sym_U_SQUOTE] = ACTIONS(3721),
    [anon_sym_u8_SQUOTE] = ACTIONS(3721),
    [anon_sym_SQUOTE] = ACTIONS(3721),
    [anon_sym_L_DQUOTE] = ACTIONS(3721),
    [anon_sym_u_DQUOTE] = ACTIONS(3721),
    [anon_sym_U_DQUOTE] = ACTIONS(3721),
    [anon_sym_u8_DQUOTE] = ACTIONS(3721),
    [anon_sym_DQUOTE] = ACTIONS(3721),
    [sym_true] = ACTIONS(3719),
    [sym_false] = ACTIONS(3719),
    [anon_sym_NULL] = ACTIONS(3719),
    [anon_sym_nullptr] = ACTIONS(3719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3719),
    [anon_sym_let] = ACTIONS(3719),
    [anon_sym_This] = ACTIONS(3719),
    [anon_sym_decltype] = ACTIONS(3719),
    [anon_sym_explicit] = ACTIONS(3719),
    [anon_sym_typename] = ACTIONS(3719),
    [anon_sym_template] = ACTIONS(3719),
    [anon_sym_operator] = ACTIONS(3719),
    [anon_sym_try] = ACTIONS(3719),
    [anon_sym_delete] = ACTIONS(3719),
    [anon_sym_throw] = ACTIONS(3719),
    [anon_sym_namespace] = ACTIONS(3719),
    [anon_sym_static_assert] = ACTIONS(3719),
    [anon_sym_concept] = ACTIONS(3719),
    [anon_sym_co_return] = ACTIONS(3719),
    [anon_sym_co_yield] = ACTIONS(3719),
    [anon_sym_R_DQUOTE] = ACTIONS(3721),
    [anon_sym_LR_DQUOTE] = ACTIONS(3721),
    [anon_sym_uR_DQUOTE] = ACTIONS(3721),
    [anon_sym_UR_DQUOTE] = ACTIONS(3721),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3721),
    [anon_sym_co_await] = ACTIONS(3719),
    [anon_sym_new] = ACTIONS(3719),
    [anon_sym_requires] = ACTIONS(3719),
    [sym_this] = ACTIONS(3719),
    [anon_sym_discard] = ACTIONS(3719),
    [anon_sym_precise] = ACTIONS(3719),
    [anon_sym_shared] = ACTIONS(3719),
    [anon_sym_groupshared] = ACTIONS(3719),
    [anon_sym_uniform] = ACTIONS(3719),
    [anon_sym_row_major] = ACTIONS(3719),
    [anon_sym_column_major] = ACTIONS(3719),
    [anon_sym_globallycoherent] = ACTIONS(3719),
    [anon_sym_centroid] = ACTIONS(3719),
    [anon_sym_noperspective] = ACTIONS(3719),
    [anon_sym_nointerpolation] = ACTIONS(3719),
    [anon_sym_sample] = ACTIONS(3719),
    [anon_sym_linear] = ACTIONS(3719),
    [anon_sym_snorm] = ACTIONS(3719),
    [anon_sym_unorm] = ACTIONS(3719),
    [anon_sym_point] = ACTIONS(3719),
    [anon_sym_line] = ACTIONS(3719),
    [anon_sym_triangleadj] = ACTIONS(3719),
    [anon_sym_lineadj] = ACTIONS(3719),
    [anon_sym_triangle] = ACTIONS(3719),
    [anon_sym_cbuffer] = ACTIONS(3719),
    [anon_sym_interface] = ACTIONS(3719),
    [anon_sym_extension] = ACTIONS(3719),
  },
  [946] = {
    [ts_builtin_sym_end] = ACTIONS(3915),
    [sym_identifier] = ACTIONS(3913),
    [aux_sym_preproc_include_token1] = ACTIONS(3913),
    [aux_sym_preproc_def_token1] = ACTIONS(3913),
    [aux_sym_preproc_if_token1] = ACTIONS(3913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3913),
    [sym_preproc_directive] = ACTIONS(3913),
    [anon_sym_LPAREN2] = ACTIONS(3915),
    [anon_sym_BANG] = ACTIONS(3915),
    [anon_sym_TILDE] = ACTIONS(3915),
    [anon_sym_DASH] = ACTIONS(3913),
    [anon_sym_PLUS] = ACTIONS(3913),
    [anon_sym_STAR] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3913),
    [anon_sym_SEMI] = ACTIONS(3915),
    [anon_sym___extension__] = ACTIONS(3913),
    [anon_sym_typedef] = ACTIONS(3913),
    [anon_sym_in] = ACTIONS(3913),
    [anon_sym_out] = ACTIONS(3913),
    [anon_sym_inout] = ACTIONS(3913),
    [anon_sym_virtual] = ACTIONS(3913),
    [anon_sym_extern] = ACTIONS(3913),
    [anon_sym___attribute__] = ACTIONS(3913),
    [anon_sym___attribute] = ACTIONS(3913),
    [anon_sym_using] = ACTIONS(3913),
    [anon_sym_COLON_COLON] = ACTIONS(3915),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3915),
    [anon_sym___declspec] = ACTIONS(3913),
    [anon_sym___based] = ACTIONS(3913),
    [anon_sym___cdecl] = ACTIONS(3913),
    [anon_sym___clrcall] = ACTIONS(3913),
    [anon_sym___stdcall] = ACTIONS(3913),
    [anon_sym___fastcall] = ACTIONS(3913),
    [anon_sym___thiscall] = ACTIONS(3913),
    [anon_sym___vectorcall] = ACTIONS(3913),
    [anon_sym_LBRACE] = ACTIONS(3915),
    [anon_sym_signed] = ACTIONS(3913),
    [anon_sym_unsigned] = ACTIONS(3913),
    [anon_sym_long] = ACTIONS(3913),
    [anon_sym_short] = ACTIONS(3913),
    [anon_sym_LBRACK] = ACTIONS(3913),
    [anon_sym_static] = ACTIONS(3913),
    [anon_sym_register] = ACTIONS(3913),
    [anon_sym_inline] = ACTIONS(3913),
    [anon_sym___inline] = ACTIONS(3913),
    [anon_sym___inline__] = ACTIONS(3913),
    [anon_sym___forceinline] = ACTIONS(3913),
    [anon_sym_thread_local] = ACTIONS(3913),
    [anon_sym___thread] = ACTIONS(3913),
    [anon_sym_const] = ACTIONS(3913),
    [anon_sym_constexpr] = ACTIONS(3913),
    [anon_sym_volatile] = ACTIONS(3913),
    [anon_sym_restrict] = ACTIONS(3913),
    [anon_sym___restrict__] = ACTIONS(3913),
    [anon_sym__Atomic] = ACTIONS(3913),
    [anon_sym__Noreturn] = ACTIONS(3913),
    [anon_sym_noreturn] = ACTIONS(3913),
    [anon_sym__Nonnull] = ACTIONS(3913),
    [anon_sym_mutable] = ACTIONS(3913),
    [anon_sym_constinit] = ACTIONS(3913),
    [anon_sym_consteval] = ACTIONS(3913),
    [anon_sym_alignas] = ACTIONS(3913),
    [anon_sym__Alignas] = ACTIONS(3913),
    [sym_primitive_type] = ACTIONS(3913),
    [anon_sym_enum] = ACTIONS(3913),
    [anon_sym_class] = ACTIONS(3913),
    [anon_sym_struct] = ACTIONS(3913),
    [anon_sym_union] = ACTIONS(3913),
    [anon_sym_if] = ACTIONS(3913),
    [anon_sym_switch] = ACTIONS(3913),
    [anon_sym_case] = ACTIONS(3913),
    [anon_sym_default] = ACTIONS(3913),
    [anon_sym_while] = ACTIONS(3913),
    [anon_sym_do] = ACTIONS(3913),
    [anon_sym_for] = ACTIONS(3913),
    [anon_sym_return] = ACTIONS(3913),
    [anon_sym_break] = ACTIONS(3913),
    [anon_sym_continue] = ACTIONS(3913),
    [anon_sym_goto] = ACTIONS(3913),
    [anon_sym_not] = ACTIONS(3913),
    [anon_sym_compl] = ACTIONS(3913),
    [anon_sym_DASH_DASH] = ACTIONS(3915),
    [anon_sym_PLUS_PLUS] = ACTIONS(3915),
    [anon_sym_sizeof] = ACTIONS(3913),
    [anon_sym___alignof__] = ACTIONS(3913),
    [anon_sym___alignof] = ACTIONS(3913),
    [anon_sym__alignof] = ACTIONS(3913),
    [anon_sym_alignof] = ACTIONS(3913),
    [anon_sym__Alignof] = ACTIONS(3913),
    [anon_sym_offsetof] = ACTIONS(3913),
    [anon_sym__Generic] = ACTIONS(3913),
    [anon_sym_asm] = ACTIONS(3913),
    [anon_sym___asm__] = ACTIONS(3913),
    [anon_sym___asm] = ACTIONS(3913),
    [sym_number_literal] = ACTIONS(3915),
    [anon_sym_L_SQUOTE] = ACTIONS(3915),
    [anon_sym_u_SQUOTE] = ACTIONS(3915),
    [anon_sym_U_SQUOTE] = ACTIONS(3915),
    [anon_sym_u8_SQUOTE] = ACTIONS(3915),
    [anon_sym_SQUOTE] = ACTIONS(3915),
    [anon_sym_L_DQUOTE] = ACTIONS(3915),
    [anon_sym_u_DQUOTE] = ACTIONS(3915),
    [anon_sym_U_DQUOTE] = ACTIONS(3915),
    [anon_sym_u8_DQUOTE] = ACTIONS(3915),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [sym_true] = ACTIONS(3913),
    [sym_false] = ACTIONS(3913),
    [anon_sym_NULL] = ACTIONS(3913),
    [anon_sym_nullptr] = ACTIONS(3913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3913),
    [anon_sym_let] = ACTIONS(3913),
    [anon_sym_This] = ACTIONS(3913),
    [anon_sym_decltype] = ACTIONS(3913),
    [anon_sym_explicit] = ACTIONS(3913),
    [anon_sym_typename] = ACTIONS(3913),
    [anon_sym_export] = ACTIONS(3913),
    [anon_sym_module] = ACTIONS(3913),
    [anon_sym_import] = ACTIONS(3913),
    [anon_sym_template] = ACTIONS(3913),
    [anon_sym_operator] = ACTIONS(3913),
    [anon_sym_try] = ACTIONS(3913),
    [anon_sym_delete] = ACTIONS(3913),
    [anon_sym_throw] = ACTIONS(3913),
    [anon_sym_namespace] = ACTIONS(3913),
    [anon_sym_static_assert] = ACTIONS(3913),
    [anon_sym_concept] = ACTIONS(3913),
    [anon_sym_co_return] = ACTIONS(3913),
    [anon_sym_co_yield] = ACTIONS(3913),
    [anon_sym_R_DQUOTE] = ACTIONS(3915),
    [anon_sym_LR_DQUOTE] = ACTIONS(3915),
    [anon_sym_uR_DQUOTE] = ACTIONS(3915),
    [anon_sym_UR_DQUOTE] = ACTIONS(3915),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3915),
    [anon_sym_co_await] = ACTIONS(3913),
    [anon_sym_new] = ACTIONS(3913),
    [anon_sym_requires] = ACTIONS(3913),
    [sym_this] = ACTIONS(3913),
    [anon_sym_precise] = ACTIONS(3913),
    [anon_sym_shared] = ACTIONS(3913),
    [anon_sym_groupshared] = ACTIONS(3913),
    [anon_sym_uniform] = ACTIONS(3913),
    [anon_sym_row_major] = ACTIONS(3913),
    [anon_sym_column_major] = ACTIONS(3913),
    [anon_sym_globallycoherent] = ACTIONS(3913),
    [anon_sym_centroid] = ACTIONS(3913),
    [anon_sym_noperspective] = ACTIONS(3913),
    [anon_sym_nointerpolation] = ACTIONS(3913),
    [anon_sym_sample] = ACTIONS(3913),
    [anon_sym_linear] = ACTIONS(3913),
    [anon_sym_snorm] = ACTIONS(3913),
    [anon_sym_unorm] = ACTIONS(3913),
    [anon_sym_point] = ACTIONS(3913),
    [anon_sym_line] = ACTIONS(3913),
    [anon_sym_triangleadj] = ACTIONS(3913),
    [anon_sym_lineadj] = ACTIONS(3913),
    [anon_sym_triangle] = ACTIONS(3913),
    [anon_sym_interface] = ACTIONS(3913),
    [anon_sym_extension] = ACTIONS(3913),
    [anon_sym___exported] = ACTIONS(3913),
  },
  [947] = {
    [sym_identifier] = ACTIONS(3923),
    [aux_sym_preproc_include_token1] = ACTIONS(3923),
    [aux_sym_preproc_def_token1] = ACTIONS(3923),
    [aux_sym_preproc_if_token1] = ACTIONS(3923),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3923),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3923),
    [sym_preproc_directive] = ACTIONS(3923),
    [anon_sym_LPAREN2] = ACTIONS(3925),
    [anon_sym_BANG] = ACTIONS(3925),
    [anon_sym_TILDE] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_STAR] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_AMP] = ACTIONS(3923),
    [anon_sym_SEMI] = ACTIONS(3925),
    [anon_sym___extension__] = ACTIONS(3923),
    [anon_sym_typedef] = ACTIONS(3923),
    [anon_sym_in] = ACTIONS(3923),
    [anon_sym_out] = ACTIONS(3923),
    [anon_sym_inout] = ACTIONS(3923),
    [anon_sym_virtual] = ACTIONS(3923),
    [anon_sym_extern] = ACTIONS(3923),
    [anon_sym___attribute__] = ACTIONS(3923),
    [anon_sym___attribute] = ACTIONS(3923),
    [anon_sym_using] = ACTIONS(3923),
    [anon_sym_COLON_COLON] = ACTIONS(3925),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3925),
    [anon_sym___declspec] = ACTIONS(3923),
    [anon_sym___based] = ACTIONS(3923),
    [anon_sym___cdecl] = ACTIONS(3923),
    [anon_sym___clrcall] = ACTIONS(3923),
    [anon_sym___stdcall] = ACTIONS(3923),
    [anon_sym___fastcall] = ACTIONS(3923),
    [anon_sym___thiscall] = ACTIONS(3923),
    [anon_sym___vectorcall] = ACTIONS(3923),
    [anon_sym_LBRACE] = ACTIONS(3925),
    [anon_sym_RBRACE] = ACTIONS(3925),
    [anon_sym_signed] = ACTIONS(3923),
    [anon_sym_unsigned] = ACTIONS(3923),
    [anon_sym_long] = ACTIONS(3923),
    [anon_sym_short] = ACTIONS(3923),
    [anon_sym_LBRACK] = ACTIONS(3923),
    [anon_sym_static] = ACTIONS(3923),
    [anon_sym_register] = ACTIONS(3923),
    [anon_sym_inline] = ACTIONS(3923),
    [anon_sym___inline] = ACTIONS(3923),
    [anon_sym___inline__] = ACTIONS(3923),
    [anon_sym___forceinline] = ACTIONS(3923),
    [anon_sym_thread_local] = ACTIONS(3923),
    [anon_sym___thread] = ACTIONS(3923),
    [anon_sym_const] = ACTIONS(3923),
    [anon_sym_constexpr] = ACTIONS(3923),
    [anon_sym_volatile] = ACTIONS(3923),
    [anon_sym_restrict] = ACTIONS(3923),
    [anon_sym___restrict__] = ACTIONS(3923),
    [anon_sym__Atomic] = ACTIONS(3923),
    [anon_sym__Noreturn] = ACTIONS(3923),
    [anon_sym_noreturn] = ACTIONS(3923),
    [anon_sym__Nonnull] = ACTIONS(3923),
    [anon_sym_mutable] = ACTIONS(3923),
    [anon_sym_constinit] = ACTIONS(3923),
    [anon_sym_consteval] = ACTIONS(3923),
    [anon_sym_alignas] = ACTIONS(3923),
    [anon_sym__Alignas] = ACTIONS(3923),
    [sym_primitive_type] = ACTIONS(3923),
    [anon_sym_enum] = ACTIONS(3923),
    [anon_sym_class] = ACTIONS(3923),
    [anon_sym_struct] = ACTIONS(3923),
    [anon_sym_union] = ACTIONS(3923),
    [anon_sym_if] = ACTIONS(3923),
    [anon_sym_switch] = ACTIONS(3923),
    [anon_sym_case] = ACTIONS(3923),
    [anon_sym_default] = ACTIONS(3923),
    [anon_sym_while] = ACTIONS(3923),
    [anon_sym_do] = ACTIONS(3923),
    [anon_sym_for] = ACTIONS(3923),
    [anon_sym_return] = ACTIONS(3923),
    [anon_sym_break] = ACTIONS(3923),
    [anon_sym_continue] = ACTIONS(3923),
    [anon_sym_goto] = ACTIONS(3923),
    [anon_sym___try] = ACTIONS(3923),
    [anon_sym___leave] = ACTIONS(3923),
    [anon_sym_not] = ACTIONS(3923),
    [anon_sym_compl] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3923),
    [anon_sym___alignof__] = ACTIONS(3923),
    [anon_sym___alignof] = ACTIONS(3923),
    [anon_sym__alignof] = ACTIONS(3923),
    [anon_sym_alignof] = ACTIONS(3923),
    [anon_sym__Alignof] = ACTIONS(3923),
    [anon_sym_offsetof] = ACTIONS(3923),
    [anon_sym__Generic] = ACTIONS(3923),
    [anon_sym_asm] = ACTIONS(3923),
    [anon_sym___asm__] = ACTIONS(3923),
    [anon_sym___asm] = ACTIONS(3923),
    [sym_number_literal] = ACTIONS(3925),
    [anon_sym_L_SQUOTE] = ACTIONS(3925),
    [anon_sym_u_SQUOTE] = ACTIONS(3925),
    [anon_sym_U_SQUOTE] = ACTIONS(3925),
    [anon_sym_u8_SQUOTE] = ACTIONS(3925),
    [anon_sym_SQUOTE] = ACTIONS(3925),
    [anon_sym_L_DQUOTE] = ACTIONS(3925),
    [anon_sym_u_DQUOTE] = ACTIONS(3925),
    [anon_sym_U_DQUOTE] = ACTIONS(3925),
    [anon_sym_u8_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [sym_true] = ACTIONS(3923),
    [sym_false] = ACTIONS(3923),
    [anon_sym_NULL] = ACTIONS(3923),
    [anon_sym_nullptr] = ACTIONS(3923),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3923),
    [anon_sym_let] = ACTIONS(3923),
    [anon_sym_This] = ACTIONS(3923),
    [anon_sym_decltype] = ACTIONS(3923),
    [anon_sym_explicit] = ACTIONS(3923),
    [anon_sym_typename] = ACTIONS(3923),
    [anon_sym_template] = ACTIONS(3923),
    [anon_sym_operator] = ACTIONS(3923),
    [anon_sym_try] = ACTIONS(3923),
    [anon_sym_delete] = ACTIONS(3923),
    [anon_sym_throw] = ACTIONS(3923),
    [anon_sym_namespace] = ACTIONS(3923),
    [anon_sym_static_assert] = ACTIONS(3923),
    [anon_sym_concept] = ACTIONS(3923),
    [anon_sym_co_return] = ACTIONS(3923),
    [anon_sym_co_yield] = ACTIONS(3923),
    [anon_sym_R_DQUOTE] = ACTIONS(3925),
    [anon_sym_LR_DQUOTE] = ACTIONS(3925),
    [anon_sym_uR_DQUOTE] = ACTIONS(3925),
    [anon_sym_UR_DQUOTE] = ACTIONS(3925),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3925),
    [anon_sym_co_await] = ACTIONS(3923),
    [anon_sym_new] = ACTIONS(3923),
    [anon_sym_requires] = ACTIONS(3923),
    [sym_this] = ACTIONS(3923),
    [anon_sym_discard] = ACTIONS(3923),
    [anon_sym_precise] = ACTIONS(3923),
    [anon_sym_shared] = ACTIONS(3923),
    [anon_sym_groupshared] = ACTIONS(3923),
    [anon_sym_uniform] = ACTIONS(3923),
    [anon_sym_row_major] = ACTIONS(3923),
    [anon_sym_column_major] = ACTIONS(3923),
    [anon_sym_globallycoherent] = ACTIONS(3923),
    [anon_sym_centroid] = ACTIONS(3923),
    [anon_sym_noperspective] = ACTIONS(3923),
    [anon_sym_nointerpolation] = ACTIONS(3923),
    [anon_sym_sample] = ACTIONS(3923),
    [anon_sym_linear] = ACTIONS(3923),
    [anon_sym_snorm] = ACTIONS(3923),
    [anon_sym_unorm] = ACTIONS(3923),
    [anon_sym_point] = ACTIONS(3923),
    [anon_sym_line] = ACTIONS(3923),
    [anon_sym_triangleadj] = ACTIONS(3923),
    [anon_sym_lineadj] = ACTIONS(3923),
    [anon_sym_triangle] = ACTIONS(3923),
    [anon_sym_cbuffer] = ACTIONS(3923),
    [anon_sym_interface] = ACTIONS(3923),
    [anon_sym_extension] = ACTIONS(3923),
  },
  [948] = {
    [sym_identifier] = ACTIONS(3927),
    [aux_sym_preproc_include_token1] = ACTIONS(3927),
    [aux_sym_preproc_def_token1] = ACTIONS(3927),
    [aux_sym_preproc_if_token1] = ACTIONS(3927),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3927),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3927),
    [sym_preproc_directive] = ACTIONS(3927),
    [anon_sym_LPAREN2] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_TILDE] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_SEMI] = ACTIONS(3929),
    [anon_sym___extension__] = ACTIONS(3927),
    [anon_sym_typedef] = ACTIONS(3927),
    [anon_sym_in] = ACTIONS(3927),
    [anon_sym_out] = ACTIONS(3927),
    [anon_sym_inout] = ACTIONS(3927),
    [anon_sym_virtual] = ACTIONS(3927),
    [anon_sym_extern] = ACTIONS(3927),
    [anon_sym___attribute__] = ACTIONS(3927),
    [anon_sym___attribute] = ACTIONS(3927),
    [anon_sym_using] = ACTIONS(3927),
    [anon_sym_COLON_COLON] = ACTIONS(3929),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3929),
    [anon_sym___declspec] = ACTIONS(3927),
    [anon_sym___based] = ACTIONS(3927),
    [anon_sym___cdecl] = ACTIONS(3927),
    [anon_sym___clrcall] = ACTIONS(3927),
    [anon_sym___stdcall] = ACTIONS(3927),
    [anon_sym___fastcall] = ACTIONS(3927),
    [anon_sym___thiscall] = ACTIONS(3927),
    [anon_sym___vectorcall] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3929),
    [anon_sym_RBRACE] = ACTIONS(3929),
    [anon_sym_signed] = ACTIONS(3927),
    [anon_sym_unsigned] = ACTIONS(3927),
    [anon_sym_long] = ACTIONS(3927),
    [anon_sym_short] = ACTIONS(3927),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_static] = ACTIONS(3927),
    [anon_sym_register] = ACTIONS(3927),
    [anon_sym_inline] = ACTIONS(3927),
    [anon_sym___inline] = ACTIONS(3927),
    [anon_sym___inline__] = ACTIONS(3927),
    [anon_sym___forceinline] = ACTIONS(3927),
    [anon_sym_thread_local] = ACTIONS(3927),
    [anon_sym___thread] = ACTIONS(3927),
    [anon_sym_const] = ACTIONS(3927),
    [anon_sym_constexpr] = ACTIONS(3927),
    [anon_sym_volatile] = ACTIONS(3927),
    [anon_sym_restrict] = ACTIONS(3927),
    [anon_sym___restrict__] = ACTIONS(3927),
    [anon_sym__Atomic] = ACTIONS(3927),
    [anon_sym__Noreturn] = ACTIONS(3927),
    [anon_sym_noreturn] = ACTIONS(3927),
    [anon_sym__Nonnull] = ACTIONS(3927),
    [anon_sym_mutable] = ACTIONS(3927),
    [anon_sym_constinit] = ACTIONS(3927),
    [anon_sym_consteval] = ACTIONS(3927),
    [anon_sym_alignas] = ACTIONS(3927),
    [anon_sym__Alignas] = ACTIONS(3927),
    [sym_primitive_type] = ACTIONS(3927),
    [anon_sym_enum] = ACTIONS(3927),
    [anon_sym_class] = ACTIONS(3927),
    [anon_sym_struct] = ACTIONS(3927),
    [anon_sym_union] = ACTIONS(3927),
    [anon_sym_if] = ACTIONS(3927),
    [anon_sym_switch] = ACTIONS(3927),
    [anon_sym_case] = ACTIONS(3927),
    [anon_sym_default] = ACTIONS(3927),
    [anon_sym_while] = ACTIONS(3927),
    [anon_sym_do] = ACTIONS(3927),
    [anon_sym_for] = ACTIONS(3927),
    [anon_sym_return] = ACTIONS(3927),
    [anon_sym_break] = ACTIONS(3927),
    [anon_sym_continue] = ACTIONS(3927),
    [anon_sym_goto] = ACTIONS(3927),
    [anon_sym___try] = ACTIONS(3927),
    [anon_sym___leave] = ACTIONS(3927),
    [anon_sym_not] = ACTIONS(3927),
    [anon_sym_compl] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3929),
    [anon_sym_sizeof] = ACTIONS(3927),
    [anon_sym___alignof__] = ACTIONS(3927),
    [anon_sym___alignof] = ACTIONS(3927),
    [anon_sym__alignof] = ACTIONS(3927),
    [anon_sym_alignof] = ACTIONS(3927),
    [anon_sym__Alignof] = ACTIONS(3927),
    [anon_sym_offsetof] = ACTIONS(3927),
    [anon_sym__Generic] = ACTIONS(3927),
    [anon_sym_asm] = ACTIONS(3927),
    [anon_sym___asm__] = ACTIONS(3927),
    [anon_sym___asm] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(3929),
    [anon_sym_L_SQUOTE] = ACTIONS(3929),
    [anon_sym_u_SQUOTE] = ACTIONS(3929),
    [anon_sym_U_SQUOTE] = ACTIONS(3929),
    [anon_sym_u8_SQUOTE] = ACTIONS(3929),
    [anon_sym_SQUOTE] = ACTIONS(3929),
    [anon_sym_L_DQUOTE] = ACTIONS(3929),
    [anon_sym_u_DQUOTE] = ACTIONS(3929),
    [anon_sym_U_DQUOTE] = ACTIONS(3929),
    [anon_sym_u8_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [sym_true] = ACTIONS(3927),
    [sym_false] = ACTIONS(3927),
    [anon_sym_NULL] = ACTIONS(3927),
    [anon_sym_nullptr] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3927),
    [anon_sym_let] = ACTIONS(3927),
    [anon_sym_This] = ACTIONS(3927),
    [anon_sym_decltype] = ACTIONS(3927),
    [anon_sym_explicit] = ACTIONS(3927),
    [anon_sym_typename] = ACTIONS(3927),
    [anon_sym_template] = ACTIONS(3927),
    [anon_sym_operator] = ACTIONS(3927),
    [anon_sym_try] = ACTIONS(3927),
    [anon_sym_delete] = ACTIONS(3927),
    [anon_sym_throw] = ACTIONS(3927),
    [anon_sym_namespace] = ACTIONS(3927),
    [anon_sym_static_assert] = ACTIONS(3927),
    [anon_sym_concept] = ACTIONS(3927),
    [anon_sym_co_return] = ACTIONS(3927),
    [anon_sym_co_yield] = ACTIONS(3927),
    [anon_sym_R_DQUOTE] = ACTIONS(3929),
    [anon_sym_LR_DQUOTE] = ACTIONS(3929),
    [anon_sym_uR_DQUOTE] = ACTIONS(3929),
    [anon_sym_UR_DQUOTE] = ACTIONS(3929),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3929),
    [anon_sym_co_await] = ACTIONS(3927),
    [anon_sym_new] = ACTIONS(3927),
    [anon_sym_requires] = ACTIONS(3927),
    [sym_this] = ACTIONS(3927),
    [anon_sym_discard] = ACTIONS(3927),
    [anon_sym_precise] = ACTIONS(3927),
    [anon_sym_shared] = ACTIONS(3927),
    [anon_sym_groupshared] = ACTIONS(3927),
    [anon_sym_uniform] = ACTIONS(3927),
    [anon_sym_row_major] = ACTIONS(3927),
    [anon_sym_column_major] = ACTIONS(3927),
    [anon_sym_globallycoherent] = ACTIONS(3927),
    [anon_sym_centroid] = ACTIONS(3927),
    [anon_sym_noperspective] = ACTIONS(3927),
    [anon_sym_nointerpolation] = ACTIONS(3927),
    [anon_sym_sample] = ACTIONS(3927),
    [anon_sym_linear] = ACTIONS(3927),
    [anon_sym_snorm] = ACTIONS(3927),
    [anon_sym_unorm] = ACTIONS(3927),
    [anon_sym_point] = ACTIONS(3927),
    [anon_sym_line] = ACTIONS(3927),
    [anon_sym_triangleadj] = ACTIONS(3927),
    [anon_sym_lineadj] = ACTIONS(3927),
    [anon_sym_triangle] = ACTIONS(3927),
    [anon_sym_cbuffer] = ACTIONS(3927),
    [anon_sym_interface] = ACTIONS(3927),
    [anon_sym_extension] = ACTIONS(3927),
  },
  [949] = {
    [sym_identifier] = ACTIONS(3931),
    [aux_sym_preproc_include_token1] = ACTIONS(3931),
    [aux_sym_preproc_def_token1] = ACTIONS(3931),
    [aux_sym_preproc_if_token1] = ACTIONS(3931),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3931),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3931),
    [sym_preproc_directive] = ACTIONS(3931),
    [anon_sym_LPAREN2] = ACTIONS(3933),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_TILDE] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_STAR] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_SEMI] = ACTIONS(3933),
    [anon_sym___extension__] = ACTIONS(3931),
    [anon_sym_typedef] = ACTIONS(3931),
    [anon_sym_in] = ACTIONS(3931),
    [anon_sym_out] = ACTIONS(3931),
    [anon_sym_inout] = ACTIONS(3931),
    [anon_sym_virtual] = ACTIONS(3931),
    [anon_sym_extern] = ACTIONS(3931),
    [anon_sym___attribute__] = ACTIONS(3931),
    [anon_sym___attribute] = ACTIONS(3931),
    [anon_sym_using] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3933),
    [anon_sym___declspec] = ACTIONS(3931),
    [anon_sym___based] = ACTIONS(3931),
    [anon_sym___cdecl] = ACTIONS(3931),
    [anon_sym___clrcall] = ACTIONS(3931),
    [anon_sym___stdcall] = ACTIONS(3931),
    [anon_sym___fastcall] = ACTIONS(3931),
    [anon_sym___thiscall] = ACTIONS(3931),
    [anon_sym___vectorcall] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3933),
    [anon_sym_RBRACE] = ACTIONS(3933),
    [anon_sym_signed] = ACTIONS(3931),
    [anon_sym_unsigned] = ACTIONS(3931),
    [anon_sym_long] = ACTIONS(3931),
    [anon_sym_short] = ACTIONS(3931),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_static] = ACTIONS(3931),
    [anon_sym_register] = ACTIONS(3931),
    [anon_sym_inline] = ACTIONS(3931),
    [anon_sym___inline] = ACTIONS(3931),
    [anon_sym___inline__] = ACTIONS(3931),
    [anon_sym___forceinline] = ACTIONS(3931),
    [anon_sym_thread_local] = ACTIONS(3931),
    [anon_sym___thread] = ACTIONS(3931),
    [anon_sym_const] = ACTIONS(3931),
    [anon_sym_constexpr] = ACTIONS(3931),
    [anon_sym_volatile] = ACTIONS(3931),
    [anon_sym_restrict] = ACTIONS(3931),
    [anon_sym___restrict__] = ACTIONS(3931),
    [anon_sym__Atomic] = ACTIONS(3931),
    [anon_sym__Noreturn] = ACTIONS(3931),
    [anon_sym_noreturn] = ACTIONS(3931),
    [anon_sym__Nonnull] = ACTIONS(3931),
    [anon_sym_mutable] = ACTIONS(3931),
    [anon_sym_constinit] = ACTIONS(3931),
    [anon_sym_consteval] = ACTIONS(3931),
    [anon_sym_alignas] = ACTIONS(3931),
    [anon_sym__Alignas] = ACTIONS(3931),
    [sym_primitive_type] = ACTIONS(3931),
    [anon_sym_enum] = ACTIONS(3931),
    [anon_sym_class] = ACTIONS(3931),
    [anon_sym_struct] = ACTIONS(3931),
    [anon_sym_union] = ACTIONS(3931),
    [anon_sym_if] = ACTIONS(3931),
    [anon_sym_switch] = ACTIONS(3931),
    [anon_sym_case] = ACTIONS(3931),
    [anon_sym_default] = ACTIONS(3931),
    [anon_sym_while] = ACTIONS(3931),
    [anon_sym_do] = ACTIONS(3931),
    [anon_sym_for] = ACTIONS(3931),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_break] = ACTIONS(3931),
    [anon_sym_continue] = ACTIONS(3931),
    [anon_sym_goto] = ACTIONS(3931),
    [anon_sym___try] = ACTIONS(3931),
    [anon_sym___leave] = ACTIONS(3931),
    [anon_sym_not] = ACTIONS(3931),
    [anon_sym_compl] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_sizeof] = ACTIONS(3931),
    [anon_sym___alignof__] = ACTIONS(3931),
    [anon_sym___alignof] = ACTIONS(3931),
    [anon_sym__alignof] = ACTIONS(3931),
    [anon_sym_alignof] = ACTIONS(3931),
    [anon_sym__Alignof] = ACTIONS(3931),
    [anon_sym_offsetof] = ACTIONS(3931),
    [anon_sym__Generic] = ACTIONS(3931),
    [anon_sym_asm] = ACTIONS(3931),
    [anon_sym___asm__] = ACTIONS(3931),
    [anon_sym___asm] = ACTIONS(3931),
    [sym_number_literal] = ACTIONS(3933),
    [anon_sym_L_SQUOTE] = ACTIONS(3933),
    [anon_sym_u_SQUOTE] = ACTIONS(3933),
    [anon_sym_U_SQUOTE] = ACTIONS(3933),
    [anon_sym_u8_SQUOTE] = ACTIONS(3933),
    [anon_sym_SQUOTE] = ACTIONS(3933),
    [anon_sym_L_DQUOTE] = ACTIONS(3933),
    [anon_sym_u_DQUOTE] = ACTIONS(3933),
    [anon_sym_U_DQUOTE] = ACTIONS(3933),
    [anon_sym_u8_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE] = ACTIONS(3933),
    [sym_true] = ACTIONS(3931),
    [sym_false] = ACTIONS(3931),
    [anon_sym_NULL] = ACTIONS(3931),
    [anon_sym_nullptr] = ACTIONS(3931),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3931),
    [anon_sym_let] = ACTIONS(3931),
    [anon_sym_This] = ACTIONS(3931),
    [anon_sym_decltype] = ACTIONS(3931),
    [anon_sym_explicit] = ACTIONS(3931),
    [anon_sym_typename] = ACTIONS(3931),
    [anon_sym_template] = ACTIONS(3931),
    [anon_sym_operator] = ACTIONS(3931),
    [anon_sym_try] = ACTIONS(3931),
    [anon_sym_delete] = ACTIONS(3931),
    [anon_sym_throw] = ACTIONS(3931),
    [anon_sym_namespace] = ACTIONS(3931),
    [anon_sym_static_assert] = ACTIONS(3931),
    [anon_sym_concept] = ACTIONS(3931),
    [anon_sym_co_return] = ACTIONS(3931),
    [anon_sym_co_yield] = ACTIONS(3931),
    [anon_sym_R_DQUOTE] = ACTIONS(3933),
    [anon_sym_LR_DQUOTE] = ACTIONS(3933),
    [anon_sym_uR_DQUOTE] = ACTIONS(3933),
    [anon_sym_UR_DQUOTE] = ACTIONS(3933),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3933),
    [anon_sym_co_await] = ACTIONS(3931),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_requires] = ACTIONS(3931),
    [sym_this] = ACTIONS(3931),
    [anon_sym_discard] = ACTIONS(3931),
    [anon_sym_precise] = ACTIONS(3931),
    [anon_sym_shared] = ACTIONS(3931),
    [anon_sym_groupshared] = ACTIONS(3931),
    [anon_sym_uniform] = ACTIONS(3931),
    [anon_sym_row_major] = ACTIONS(3931),
    [anon_sym_column_major] = ACTIONS(3931),
    [anon_sym_globallycoherent] = ACTIONS(3931),
    [anon_sym_centroid] = ACTIONS(3931),
    [anon_sym_noperspective] = ACTIONS(3931),
    [anon_sym_nointerpolation] = ACTIONS(3931),
    [anon_sym_sample] = ACTIONS(3931),
    [anon_sym_linear] = ACTIONS(3931),
    [anon_sym_snorm] = ACTIONS(3931),
    [anon_sym_unorm] = ACTIONS(3931),
    [anon_sym_point] = ACTIONS(3931),
    [anon_sym_line] = ACTIONS(3931),
    [anon_sym_triangleadj] = ACTIONS(3931),
    [anon_sym_lineadj] = ACTIONS(3931),
    [anon_sym_triangle] = ACTIONS(3931),
    [anon_sym_cbuffer] = ACTIONS(3931),
    [anon_sym_interface] = ACTIONS(3931),
    [anon_sym_extension] = ACTIONS(3931),
  },
  [950] = {
    [sym_identifier] = ACTIONS(3935),
    [aux_sym_preproc_include_token1] = ACTIONS(3935),
    [aux_sym_preproc_def_token1] = ACTIONS(3935),
    [aux_sym_preproc_if_token1] = ACTIONS(3935),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3935),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3935),
    [sym_preproc_directive] = ACTIONS(3935),
    [anon_sym_LPAREN2] = ACTIONS(3937),
    [anon_sym_BANG] = ACTIONS(3937),
    [anon_sym_TILDE] = ACTIONS(3937),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3935),
    [anon_sym_STAR] = ACTIONS(3937),
    [anon_sym_AMP_AMP] = ACTIONS(3937),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_SEMI] = ACTIONS(3937),
    [anon_sym___extension__] = ACTIONS(3935),
    [anon_sym_typedef] = ACTIONS(3935),
    [anon_sym_in] = ACTIONS(3935),
    [anon_sym_out] = ACTIONS(3935),
    [anon_sym_inout] = ACTIONS(3935),
    [anon_sym_virtual] = ACTIONS(3935),
    [anon_sym_extern] = ACTIONS(3935),
    [anon_sym___attribute__] = ACTIONS(3935),
    [anon_sym___attribute] = ACTIONS(3935),
    [anon_sym_using] = ACTIONS(3935),
    [anon_sym_COLON_COLON] = ACTIONS(3937),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3937),
    [anon_sym___declspec] = ACTIONS(3935),
    [anon_sym___based] = ACTIONS(3935),
    [anon_sym___cdecl] = ACTIONS(3935),
    [anon_sym___clrcall] = ACTIONS(3935),
    [anon_sym___stdcall] = ACTIONS(3935),
    [anon_sym___fastcall] = ACTIONS(3935),
    [anon_sym___thiscall] = ACTIONS(3935),
    [anon_sym___vectorcall] = ACTIONS(3935),
    [anon_sym_LBRACE] = ACTIONS(3937),
    [anon_sym_RBRACE] = ACTIONS(3937),
    [anon_sym_signed] = ACTIONS(3935),
    [anon_sym_unsigned] = ACTIONS(3935),
    [anon_sym_long] = ACTIONS(3935),
    [anon_sym_short] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3935),
    [anon_sym_static] = ACTIONS(3935),
    [anon_sym_register] = ACTIONS(3935),
    [anon_sym_inline] = ACTIONS(3935),
    [anon_sym___inline] = ACTIONS(3935),
    [anon_sym___inline__] = ACTIONS(3935),
    [anon_sym___forceinline] = ACTIONS(3935),
    [anon_sym_thread_local] = ACTIONS(3935),
    [anon_sym___thread] = ACTIONS(3935),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_constexpr] = ACTIONS(3935),
    [anon_sym_volatile] = ACTIONS(3935),
    [anon_sym_restrict] = ACTIONS(3935),
    [anon_sym___restrict__] = ACTIONS(3935),
    [anon_sym__Atomic] = ACTIONS(3935),
    [anon_sym__Noreturn] = ACTIONS(3935),
    [anon_sym_noreturn] = ACTIONS(3935),
    [anon_sym__Nonnull] = ACTIONS(3935),
    [anon_sym_mutable] = ACTIONS(3935),
    [anon_sym_constinit] = ACTIONS(3935),
    [anon_sym_consteval] = ACTIONS(3935),
    [anon_sym_alignas] = ACTIONS(3935),
    [anon_sym__Alignas] = ACTIONS(3935),
    [sym_primitive_type] = ACTIONS(3935),
    [anon_sym_enum] = ACTIONS(3935),
    [anon_sym_class] = ACTIONS(3935),
    [anon_sym_struct] = ACTIONS(3935),
    [anon_sym_union] = ACTIONS(3935),
    [anon_sym_if] = ACTIONS(3935),
    [anon_sym_switch] = ACTIONS(3935),
    [anon_sym_case] = ACTIONS(3935),
    [anon_sym_default] = ACTIONS(3935),
    [anon_sym_while] = ACTIONS(3935),
    [anon_sym_do] = ACTIONS(3935),
    [anon_sym_for] = ACTIONS(3935),
    [anon_sym_return] = ACTIONS(3935),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_continue] = ACTIONS(3935),
    [anon_sym_goto] = ACTIONS(3935),
    [anon_sym___try] = ACTIONS(3935),
    [anon_sym___leave] = ACTIONS(3935),
    [anon_sym_not] = ACTIONS(3935),
    [anon_sym_compl] = ACTIONS(3935),
    [anon_sym_DASH_DASH] = ACTIONS(3937),
    [anon_sym_PLUS_PLUS] = ACTIONS(3937),
    [anon_sym_sizeof] = ACTIONS(3935),
    [anon_sym___alignof__] = ACTIONS(3935),
    [anon_sym___alignof] = ACTIONS(3935),
    [anon_sym__alignof] = ACTIONS(3935),
    [anon_sym_alignof] = ACTIONS(3935),
    [anon_sym__Alignof] = ACTIONS(3935),
    [anon_sym_offsetof] = ACTIONS(3935),
    [anon_sym__Generic] = ACTIONS(3935),
    [anon_sym_asm] = ACTIONS(3935),
    [anon_sym___asm__] = ACTIONS(3935),
    [anon_sym___asm] = ACTIONS(3935),
    [sym_number_literal] = ACTIONS(3937),
    [anon_sym_L_SQUOTE] = ACTIONS(3937),
    [anon_sym_u_SQUOTE] = ACTIONS(3937),
    [anon_sym_U_SQUOTE] = ACTIONS(3937),
    [anon_sym_u8_SQUOTE] = ACTIONS(3937),
    [anon_sym_SQUOTE] = ACTIONS(3937),
    [anon_sym_L_DQUOTE] = ACTIONS(3937),
    [anon_sym_u_DQUOTE] = ACTIONS(3937),
    [anon_sym_U_DQUOTE] = ACTIONS(3937),
    [anon_sym_u8_DQUOTE] = ACTIONS(3937),
    [anon_sym_DQUOTE] = ACTIONS(3937),
    [sym_true] = ACTIONS(3935),
    [sym_false] = ACTIONS(3935),
    [anon_sym_NULL] = ACTIONS(3935),
    [anon_sym_nullptr] = ACTIONS(3935),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3935),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_This] = ACTIONS(3935),
    [anon_sym_decltype] = ACTIONS(3935),
    [anon_sym_explicit] = ACTIONS(3935),
    [anon_sym_typename] = ACTIONS(3935),
    [anon_sym_template] = ACTIONS(3935),
    [anon_sym_operator] = ACTIONS(3935),
    [anon_sym_try] = ACTIONS(3935),
    [anon_sym_delete] = ACTIONS(3935),
    [anon_sym_throw] = ACTIONS(3935),
    [anon_sym_namespace] = ACTIONS(3935),
    [anon_sym_static_assert] = ACTIONS(3935),
    [anon_sym_concept] = ACTIONS(3935),
    [anon_sym_co_return] = ACTIONS(3935),
    [anon_sym_co_yield] = ACTIONS(3935),
    [anon_sym_R_DQUOTE] = ACTIONS(3937),
    [anon_sym_LR_DQUOTE] = ACTIONS(3937),
    [anon_sym_uR_DQUOTE] = ACTIONS(3937),
    [anon_sym_UR_DQUOTE] = ACTIONS(3937),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3937),
    [anon_sym_co_await] = ACTIONS(3935),
    [anon_sym_new] = ACTIONS(3935),
    [anon_sym_requires] = ACTIONS(3935),
    [sym_this] = ACTIONS(3935),
    [anon_sym_discard] = ACTIONS(3935),
    [anon_sym_precise] = ACTIONS(3935),
    [anon_sym_shared] = ACTIONS(3935),
    [anon_sym_groupshared] = ACTIONS(3935),
    [anon_sym_uniform] = ACTIONS(3935),
    [anon_sym_row_major] = ACTIONS(3935),
    [anon_sym_column_major] = ACTIONS(3935),
    [anon_sym_globallycoherent] = ACTIONS(3935),
    [anon_sym_centroid] = ACTIONS(3935),
    [anon_sym_noperspective] = ACTIONS(3935),
    [anon_sym_nointerpolation] = ACTIONS(3935),
    [anon_sym_sample] = ACTIONS(3935),
    [anon_sym_linear] = ACTIONS(3935),
    [anon_sym_snorm] = ACTIONS(3935),
    [anon_sym_unorm] = ACTIONS(3935),
    [anon_sym_point] = ACTIONS(3935),
    [anon_sym_line] = ACTIONS(3935),
    [anon_sym_triangleadj] = ACTIONS(3935),
    [anon_sym_lineadj] = ACTIONS(3935),
    [anon_sym_triangle] = ACTIONS(3935),
    [anon_sym_cbuffer] = ACTIONS(3935),
    [anon_sym_interface] = ACTIONS(3935),
    [anon_sym_extension] = ACTIONS(3935),
  },
  [951] = {
    [sym_identifier] = ACTIONS(3723),
    [aux_sym_preproc_include_token1] = ACTIONS(3723),
    [aux_sym_preproc_def_token1] = ACTIONS(3723),
    [aux_sym_preproc_if_token1] = ACTIONS(3723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3723),
    [sym_preproc_directive] = ACTIONS(3723),
    [anon_sym_LPAREN2] = ACTIONS(3725),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(3725),
    [anon_sym_AMP_AMP] = ACTIONS(3725),
    [anon_sym_AMP] = ACTIONS(3723),
    [anon_sym_SEMI] = ACTIONS(3725),
    [anon_sym___extension__] = ACTIONS(3723),
    [anon_sym_typedef] = ACTIONS(3723),
    [anon_sym_in] = ACTIONS(3723),
    [anon_sym_out] = ACTIONS(3723),
    [anon_sym_inout] = ACTIONS(3723),
    [anon_sym_virtual] = ACTIONS(3723),
    [anon_sym_extern] = ACTIONS(3723),
    [anon_sym___attribute__] = ACTIONS(3723),
    [anon_sym___attribute] = ACTIONS(3723),
    [anon_sym_using] = ACTIONS(3723),
    [anon_sym_COLON_COLON] = ACTIONS(3725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3725),
    [anon_sym___declspec] = ACTIONS(3723),
    [anon_sym___based] = ACTIONS(3723),
    [anon_sym___cdecl] = ACTIONS(3723),
    [anon_sym___clrcall] = ACTIONS(3723),
    [anon_sym___stdcall] = ACTIONS(3723),
    [anon_sym___fastcall] = ACTIONS(3723),
    [anon_sym___thiscall] = ACTIONS(3723),
    [anon_sym___vectorcall] = ACTIONS(3723),
    [anon_sym_LBRACE] = ACTIONS(3725),
    [anon_sym_RBRACE] = ACTIONS(3725),
    [anon_sym_signed] = ACTIONS(3723),
    [anon_sym_unsigned] = ACTIONS(3723),
    [anon_sym_long] = ACTIONS(3723),
    [anon_sym_short] = ACTIONS(3723),
    [anon_sym_LBRACK] = ACTIONS(3723),
    [anon_sym_static] = ACTIONS(3723),
    [anon_sym_register] = ACTIONS(3723),
    [anon_sym_inline] = ACTIONS(3723),
    [anon_sym___inline] = ACTIONS(3723),
    [anon_sym___inline__] = ACTIONS(3723),
    [anon_sym___forceinline] = ACTIONS(3723),
    [anon_sym_thread_local] = ACTIONS(3723),
    [anon_sym___thread] = ACTIONS(3723),
    [anon_sym_const] = ACTIONS(3723),
    [anon_sym_constexpr] = ACTIONS(3723),
    [anon_sym_volatile] = ACTIONS(3723),
    [anon_sym_restrict] = ACTIONS(3723),
    [anon_sym___restrict__] = ACTIONS(3723),
    [anon_sym__Atomic] = ACTIONS(3723),
    [anon_sym__Noreturn] = ACTIONS(3723),
    [anon_sym_noreturn] = ACTIONS(3723),
    [anon_sym__Nonnull] = ACTIONS(3723),
    [anon_sym_mutable] = ACTIONS(3723),
    [anon_sym_constinit] = ACTIONS(3723),
    [anon_sym_consteval] = ACTIONS(3723),
    [anon_sym_alignas] = ACTIONS(3723),
    [anon_sym__Alignas] = ACTIONS(3723),
    [sym_primitive_type] = ACTIONS(3723),
    [anon_sym_enum] = ACTIONS(3723),
    [anon_sym_class] = ACTIONS(3723),
    [anon_sym_struct] = ACTIONS(3723),
    [anon_sym_union] = ACTIONS(3723),
    [anon_sym_if] = ACTIONS(3723),
    [anon_sym_switch] = ACTIONS(3723),
    [anon_sym_case] = ACTIONS(3723),
    [anon_sym_default] = ACTIONS(3723),
    [anon_sym_while] = ACTIONS(3723),
    [anon_sym_do] = ACTIONS(3723),
    [anon_sym_for] = ACTIONS(3723),
    [anon_sym_return] = ACTIONS(3723),
    [anon_sym_break] = ACTIONS(3723),
    [anon_sym_continue] = ACTIONS(3723),
    [anon_sym_goto] = ACTIONS(3723),
    [anon_sym___try] = ACTIONS(3723),
    [anon_sym___leave] = ACTIONS(3723),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(3725),
    [anon_sym_PLUS_PLUS] = ACTIONS(3725),
    [anon_sym_sizeof] = ACTIONS(3723),
    [anon_sym___alignof__] = ACTIONS(3723),
    [anon_sym___alignof] = ACTIONS(3723),
    [anon_sym__alignof] = ACTIONS(3723),
    [anon_sym_alignof] = ACTIONS(3723),
    [anon_sym__Alignof] = ACTIONS(3723),
    [anon_sym_offsetof] = ACTIONS(3723),
    [anon_sym__Generic] = ACTIONS(3723),
    [anon_sym_asm] = ACTIONS(3723),
    [anon_sym___asm__] = ACTIONS(3723),
    [anon_sym___asm] = ACTIONS(3723),
    [sym_number_literal] = ACTIONS(3725),
    [anon_sym_L_SQUOTE] = ACTIONS(3725),
    [anon_sym_u_SQUOTE] = ACTIONS(3725),
    [anon_sym_U_SQUOTE] = ACTIONS(3725),
    [anon_sym_u8_SQUOTE] = ACTIONS(3725),
    [anon_sym_SQUOTE] = ACTIONS(3725),
    [anon_sym_L_DQUOTE] = ACTIONS(3725),
    [anon_sym_u_DQUOTE] = ACTIONS(3725),
    [anon_sym_U_DQUOTE] = ACTIONS(3725),
    [anon_sym_u8_DQUOTE] = ACTIONS(3725),
    [anon_sym_DQUOTE] = ACTIONS(3725),
    [sym_true] = ACTIONS(3723),
    [sym_false] = ACTIONS(3723),
    [anon_sym_NULL] = ACTIONS(3723),
    [anon_sym_nullptr] = ACTIONS(3723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3723),
    [anon_sym_let] = ACTIONS(3723),
    [anon_sym_This] = ACTIONS(3723),
    [anon_sym_decltype] = ACTIONS(3723),
    [anon_sym_explicit] = ACTIONS(3723),
    [anon_sym_typename] = ACTIONS(3723),
    [anon_sym_template] = ACTIONS(3723),
    [anon_sym_operator] = ACTIONS(3723),
    [anon_sym_try] = ACTIONS(3723),
    [anon_sym_delete] = ACTIONS(3723),
    [anon_sym_throw] = ACTIONS(3723),
    [anon_sym_namespace] = ACTIONS(3723),
    [anon_sym_static_assert] = ACTIONS(3723),
    [anon_sym_concept] = ACTIONS(3723),
    [anon_sym_co_return] = ACTIONS(3723),
    [anon_sym_co_yield] = ACTIONS(3723),
    [anon_sym_R_DQUOTE] = ACTIONS(3725),
    [anon_sym_LR_DQUOTE] = ACTIONS(3725),
    [anon_sym_uR_DQUOTE] = ACTIONS(3725),
    [anon_sym_UR_DQUOTE] = ACTIONS(3725),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3725),
    [anon_sym_co_await] = ACTIONS(3723),
    [anon_sym_new] = ACTIONS(3723),
    [anon_sym_requires] = ACTIONS(3723),
    [sym_this] = ACTIONS(3723),
    [anon_sym_discard] = ACTIONS(3723),
    [anon_sym_precise] = ACTIONS(3723),
    [anon_sym_shared] = ACTIONS(3723),
    [anon_sym_groupshared] = ACTIONS(3723),
    [anon_sym_uniform] = ACTIONS(3723),
    [anon_sym_row_major] = ACTIONS(3723),
    [anon_sym_column_major] = ACTIONS(3723),
    [anon_sym_globallycoherent] = ACTIONS(3723),
    [anon_sym_centroid] = ACTIONS(3723),
    [anon_sym_noperspective] = ACTIONS(3723),
    [anon_sym_nointerpolation] = ACTIONS(3723),
    [anon_sym_sample] = ACTIONS(3723),
    [anon_sym_linear] = ACTIONS(3723),
    [anon_sym_snorm] = ACTIONS(3723),
    [anon_sym_unorm] = ACTIONS(3723),
    [anon_sym_point] = ACTIONS(3723),
    [anon_sym_line] = ACTIONS(3723),
    [anon_sym_triangleadj] = ACTIONS(3723),
    [anon_sym_lineadj] = ACTIONS(3723),
    [anon_sym_triangle] = ACTIONS(3723),
    [anon_sym_cbuffer] = ACTIONS(3723),
    [anon_sym_interface] = ACTIONS(3723),
    [anon_sym_extension] = ACTIONS(3723),
  },
  [952] = {
    [sym_identifier] = ACTIONS(3727),
    [aux_sym_preproc_include_token1] = ACTIONS(3727),
    [aux_sym_preproc_def_token1] = ACTIONS(3727),
    [aux_sym_preproc_if_token1] = ACTIONS(3727),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3727),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3727),
    [sym_preproc_directive] = ACTIONS(3727),
    [anon_sym_LPAREN2] = ACTIONS(3729),
    [anon_sym_BANG] = ACTIONS(3729),
    [anon_sym_TILDE] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3727),
    [anon_sym_PLUS] = ACTIONS(3727),
    [anon_sym_STAR] = ACTIONS(3729),
    [anon_sym_AMP_AMP] = ACTIONS(3729),
    [anon_sym_AMP] = ACTIONS(3727),
    [anon_sym_SEMI] = ACTIONS(3729),
    [anon_sym___extension__] = ACTIONS(3727),
    [anon_sym_typedef] = ACTIONS(3727),
    [anon_sym_in] = ACTIONS(3727),
    [anon_sym_out] = ACTIONS(3727),
    [anon_sym_inout] = ACTIONS(3727),
    [anon_sym_virtual] = ACTIONS(3727),
    [anon_sym_extern] = ACTIONS(3727),
    [anon_sym___attribute__] = ACTIONS(3727),
    [anon_sym___attribute] = ACTIONS(3727),
    [anon_sym_using] = ACTIONS(3727),
    [anon_sym_COLON_COLON] = ACTIONS(3729),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3729),
    [anon_sym___declspec] = ACTIONS(3727),
    [anon_sym___based] = ACTIONS(3727),
    [anon_sym___cdecl] = ACTIONS(3727),
    [anon_sym___clrcall] = ACTIONS(3727),
    [anon_sym___stdcall] = ACTIONS(3727),
    [anon_sym___fastcall] = ACTIONS(3727),
    [anon_sym___thiscall] = ACTIONS(3727),
    [anon_sym___vectorcall] = ACTIONS(3727),
    [anon_sym_LBRACE] = ACTIONS(3729),
    [anon_sym_RBRACE] = ACTIONS(3729),
    [anon_sym_signed] = ACTIONS(3727),
    [anon_sym_unsigned] = ACTIONS(3727),
    [anon_sym_long] = ACTIONS(3727),
    [anon_sym_short] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(3727),
    [anon_sym_static] = ACTIONS(3727),
    [anon_sym_register] = ACTIONS(3727),
    [anon_sym_inline] = ACTIONS(3727),
    [anon_sym___inline] = ACTIONS(3727),
    [anon_sym___inline__] = ACTIONS(3727),
    [anon_sym___forceinline] = ACTIONS(3727),
    [anon_sym_thread_local] = ACTIONS(3727),
    [anon_sym___thread] = ACTIONS(3727),
    [anon_sym_const] = ACTIONS(3727),
    [anon_sym_constexpr] = ACTIONS(3727),
    [anon_sym_volatile] = ACTIONS(3727),
    [anon_sym_restrict] = ACTIONS(3727),
    [anon_sym___restrict__] = ACTIONS(3727),
    [anon_sym__Atomic] = ACTIONS(3727),
    [anon_sym__Noreturn] = ACTIONS(3727),
    [anon_sym_noreturn] = ACTIONS(3727),
    [anon_sym__Nonnull] = ACTIONS(3727),
    [anon_sym_mutable] = ACTIONS(3727),
    [anon_sym_constinit] = ACTIONS(3727),
    [anon_sym_consteval] = ACTIONS(3727),
    [anon_sym_alignas] = ACTIONS(3727),
    [anon_sym__Alignas] = ACTIONS(3727),
    [sym_primitive_type] = ACTIONS(3727),
    [anon_sym_enum] = ACTIONS(3727),
    [anon_sym_class] = ACTIONS(3727),
    [anon_sym_struct] = ACTIONS(3727),
    [anon_sym_union] = ACTIONS(3727),
    [anon_sym_if] = ACTIONS(3727),
    [anon_sym_switch] = ACTIONS(3727),
    [anon_sym_case] = ACTIONS(3727),
    [anon_sym_default] = ACTIONS(3727),
    [anon_sym_while] = ACTIONS(3727),
    [anon_sym_do] = ACTIONS(3727),
    [anon_sym_for] = ACTIONS(3727),
    [anon_sym_return] = ACTIONS(3727),
    [anon_sym_break] = ACTIONS(3727),
    [anon_sym_continue] = ACTIONS(3727),
    [anon_sym_goto] = ACTIONS(3727),
    [anon_sym___try] = ACTIONS(3727),
    [anon_sym___leave] = ACTIONS(3727),
    [anon_sym_not] = ACTIONS(3727),
    [anon_sym_compl] = ACTIONS(3727),
    [anon_sym_DASH_DASH] = ACTIONS(3729),
    [anon_sym_PLUS_PLUS] = ACTIONS(3729),
    [anon_sym_sizeof] = ACTIONS(3727),
    [anon_sym___alignof__] = ACTIONS(3727),
    [anon_sym___alignof] = ACTIONS(3727),
    [anon_sym__alignof] = ACTIONS(3727),
    [anon_sym_alignof] = ACTIONS(3727),
    [anon_sym__Alignof] = ACTIONS(3727),
    [anon_sym_offsetof] = ACTIONS(3727),
    [anon_sym__Generic] = ACTIONS(3727),
    [anon_sym_asm] = ACTIONS(3727),
    [anon_sym___asm__] = ACTIONS(3727),
    [anon_sym___asm] = ACTIONS(3727),
    [sym_number_literal] = ACTIONS(3729),
    [anon_sym_L_SQUOTE] = ACTIONS(3729),
    [anon_sym_u_SQUOTE] = ACTIONS(3729),
    [anon_sym_U_SQUOTE] = ACTIONS(3729),
    [anon_sym_u8_SQUOTE] = ACTIONS(3729),
    [anon_sym_SQUOTE] = ACTIONS(3729),
    [anon_sym_L_DQUOTE] = ACTIONS(3729),
    [anon_sym_u_DQUOTE] = ACTIONS(3729),
    [anon_sym_U_DQUOTE] = ACTIONS(3729),
    [anon_sym_u8_DQUOTE] = ACTIONS(3729),
    [anon_sym_DQUOTE] = ACTIONS(3729),
    [sym_true] = ACTIONS(3727),
    [sym_false] = ACTIONS(3727),
    [anon_sym_NULL] = ACTIONS(3727),
    [anon_sym_nullptr] = ACTIONS(3727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3727),
    [anon_sym_let] = ACTIONS(3727),
    [anon_sym_This] = ACTIONS(3727),
    [anon_sym_decltype] = ACTIONS(3727),
    [anon_sym_explicit] = ACTIONS(3727),
    [anon_sym_typename] = ACTIONS(3727),
    [anon_sym_template] = ACTIONS(3727),
    [anon_sym_operator] = ACTIONS(3727),
    [anon_sym_try] = ACTIONS(3727),
    [anon_sym_delete] = ACTIONS(3727),
    [anon_sym_throw] = ACTIONS(3727),
    [anon_sym_namespace] = ACTIONS(3727),
    [anon_sym_static_assert] = ACTIONS(3727),
    [anon_sym_concept] = ACTIONS(3727),
    [anon_sym_co_return] = ACTIONS(3727),
    [anon_sym_co_yield] = ACTIONS(3727),
    [anon_sym_R_DQUOTE] = ACTIONS(3729),
    [anon_sym_LR_DQUOTE] = ACTIONS(3729),
    [anon_sym_uR_DQUOTE] = ACTIONS(3729),
    [anon_sym_UR_DQUOTE] = ACTIONS(3729),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3729),
    [anon_sym_co_await] = ACTIONS(3727),
    [anon_sym_new] = ACTIONS(3727),
    [anon_sym_requires] = ACTIONS(3727),
    [sym_this] = ACTIONS(3727),
    [anon_sym_discard] = ACTIONS(3727),
    [anon_sym_precise] = ACTIONS(3727),
    [anon_sym_shared] = ACTIONS(3727),
    [anon_sym_groupshared] = ACTIONS(3727),
    [anon_sym_uniform] = ACTIONS(3727),
    [anon_sym_row_major] = ACTIONS(3727),
    [anon_sym_column_major] = ACTIONS(3727),
    [anon_sym_globallycoherent] = ACTIONS(3727),
    [anon_sym_centroid] = ACTIONS(3727),
    [anon_sym_noperspective] = ACTIONS(3727),
    [anon_sym_nointerpolation] = ACTIONS(3727),
    [anon_sym_sample] = ACTIONS(3727),
    [anon_sym_linear] = ACTIONS(3727),
    [anon_sym_snorm] = ACTIONS(3727),
    [anon_sym_unorm] = ACTIONS(3727),
    [anon_sym_point] = ACTIONS(3727),
    [anon_sym_line] = ACTIONS(3727),
    [anon_sym_triangleadj] = ACTIONS(3727),
    [anon_sym_lineadj] = ACTIONS(3727),
    [anon_sym_triangle] = ACTIONS(3727),
    [anon_sym_cbuffer] = ACTIONS(3727),
    [anon_sym_interface] = ACTIONS(3727),
    [anon_sym_extension] = ACTIONS(3727),
  },
  [953] = {
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_include_token1] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_BANG] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym___cdecl] = ACTIONS(3942),
    [anon_sym___clrcall] = ACTIONS(3942),
    [anon_sym___stdcall] = ACTIONS(3942),
    [anon_sym___fastcall] = ACTIONS(3942),
    [anon_sym___thiscall] = ACTIONS(3942),
    [anon_sym___vectorcall] = ACTIONS(3942),
    [anon_sym_LBRACE] = ACTIONS(3944),
    [anon_sym_RBRACE] = ACTIONS(3944),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_switch] = ACTIONS(3942),
    [anon_sym_case] = ACTIONS(3942),
    [anon_sym_default] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_break] = ACTIONS(3942),
    [anon_sym_continue] = ACTIONS(3942),
    [anon_sym_goto] = ACTIONS(3942),
    [anon_sym___try] = ACTIONS(3942),
    [anon_sym___leave] = ACTIONS(3942),
    [anon_sym_not] = ACTIONS(3942),
    [anon_sym_compl] = ACTIONS(3942),
    [anon_sym_DASH_DASH] = ACTIONS(3944),
    [anon_sym_PLUS_PLUS] = ACTIONS(3944),
    [anon_sym_sizeof] = ACTIONS(3942),
    [anon_sym___alignof__] = ACTIONS(3942),
    [anon_sym___alignof] = ACTIONS(3942),
    [anon_sym__alignof] = ACTIONS(3942),
    [anon_sym_alignof] = ACTIONS(3942),
    [anon_sym__Alignof] = ACTIONS(3942),
    [anon_sym_offsetof] = ACTIONS(3942),
    [anon_sym__Generic] = ACTIONS(3942),
    [anon_sym_asm] = ACTIONS(3942),
    [anon_sym___asm__] = ACTIONS(3942),
    [anon_sym___asm] = ACTIONS(3942),
    [sym_number_literal] = ACTIONS(3944),
    [anon_sym_L_SQUOTE] = ACTIONS(3944),
    [anon_sym_u_SQUOTE] = ACTIONS(3944),
    [anon_sym_U_SQUOTE] = ACTIONS(3944),
    [anon_sym_u8_SQUOTE] = ACTIONS(3944),
    [anon_sym_SQUOTE] = ACTIONS(3944),
    [anon_sym_L_DQUOTE] = ACTIONS(3944),
    [anon_sym_u_DQUOTE] = ACTIONS(3944),
    [anon_sym_U_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE] = ACTIONS(3944),
    [sym_true] = ACTIONS(3942),
    [sym_false] = ACTIONS(3942),
    [anon_sym_NULL] = ACTIONS(3942),
    [anon_sym_nullptr] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_delete] = ACTIONS(3942),
    [anon_sym_throw] = ACTIONS(3942),
    [anon_sym_namespace] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_concept] = ACTIONS(3942),
    [anon_sym_co_return] = ACTIONS(3942),
    [anon_sym_co_yield] = ACTIONS(3942),
    [anon_sym_R_DQUOTE] = ACTIONS(3944),
    [anon_sym_LR_DQUOTE] = ACTIONS(3944),
    [anon_sym_uR_DQUOTE] = ACTIONS(3944),
    [anon_sym_UR_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3944),
    [anon_sym_co_await] = ACTIONS(3942),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_requires] = ACTIONS(3942),
    [sym_this] = ACTIONS(3942),
    [anon_sym_discard] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_cbuffer] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
  },
  [954] = {
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_include_token1] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_BANG] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym___cdecl] = ACTIONS(3942),
    [anon_sym___clrcall] = ACTIONS(3942),
    [anon_sym___stdcall] = ACTIONS(3942),
    [anon_sym___fastcall] = ACTIONS(3942),
    [anon_sym___thiscall] = ACTIONS(3942),
    [anon_sym___vectorcall] = ACTIONS(3942),
    [anon_sym_LBRACE] = ACTIONS(3944),
    [anon_sym_RBRACE] = ACTIONS(3944),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_switch] = ACTIONS(3942),
    [anon_sym_case] = ACTIONS(3942),
    [anon_sym_default] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_break] = ACTIONS(3942),
    [anon_sym_continue] = ACTIONS(3942),
    [anon_sym_goto] = ACTIONS(3942),
    [anon_sym___try] = ACTIONS(3942),
    [anon_sym___leave] = ACTIONS(3942),
    [anon_sym_not] = ACTIONS(3942),
    [anon_sym_compl] = ACTIONS(3942),
    [anon_sym_DASH_DASH] = ACTIONS(3944),
    [anon_sym_PLUS_PLUS] = ACTIONS(3944),
    [anon_sym_sizeof] = ACTIONS(3942),
    [anon_sym___alignof__] = ACTIONS(3942),
    [anon_sym___alignof] = ACTIONS(3942),
    [anon_sym__alignof] = ACTIONS(3942),
    [anon_sym_alignof] = ACTIONS(3942),
    [anon_sym__Alignof] = ACTIONS(3942),
    [anon_sym_offsetof] = ACTIONS(3942),
    [anon_sym__Generic] = ACTIONS(3942),
    [anon_sym_asm] = ACTIONS(3942),
    [anon_sym___asm__] = ACTIONS(3942),
    [anon_sym___asm] = ACTIONS(3942),
    [sym_number_literal] = ACTIONS(3944),
    [anon_sym_L_SQUOTE] = ACTIONS(3944),
    [anon_sym_u_SQUOTE] = ACTIONS(3944),
    [anon_sym_U_SQUOTE] = ACTIONS(3944),
    [anon_sym_u8_SQUOTE] = ACTIONS(3944),
    [anon_sym_SQUOTE] = ACTIONS(3944),
    [anon_sym_L_DQUOTE] = ACTIONS(3944),
    [anon_sym_u_DQUOTE] = ACTIONS(3944),
    [anon_sym_U_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE] = ACTIONS(3944),
    [sym_true] = ACTIONS(3942),
    [sym_false] = ACTIONS(3942),
    [anon_sym_NULL] = ACTIONS(3942),
    [anon_sym_nullptr] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_delete] = ACTIONS(3942),
    [anon_sym_throw] = ACTIONS(3942),
    [anon_sym_namespace] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_concept] = ACTIONS(3942),
    [anon_sym_co_return] = ACTIONS(3942),
    [anon_sym_co_yield] = ACTIONS(3942),
    [anon_sym_R_DQUOTE] = ACTIONS(3944),
    [anon_sym_LR_DQUOTE] = ACTIONS(3944),
    [anon_sym_uR_DQUOTE] = ACTIONS(3944),
    [anon_sym_UR_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3944),
    [anon_sym_co_await] = ACTIONS(3942),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_requires] = ACTIONS(3942),
    [sym_this] = ACTIONS(3942),
    [anon_sym_discard] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_cbuffer] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
  },
  [955] = {
    [ts_builtin_sym_end] = ACTIONS(3814),
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_include_token1] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_BANG] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3812),
    [anon_sym_PLUS] = ACTIONS(3812),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym___cdecl] = ACTIONS(3812),
    [anon_sym___clrcall] = ACTIONS(3812),
    [anon_sym___stdcall] = ACTIONS(3812),
    [anon_sym___fastcall] = ACTIONS(3812),
    [anon_sym___thiscall] = ACTIONS(3812),
    [anon_sym___vectorcall] = ACTIONS(3812),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [anon_sym_if] = ACTIONS(3812),
    [anon_sym_switch] = ACTIONS(3812),
    [anon_sym_case] = ACTIONS(3812),
    [anon_sym_default] = ACTIONS(3812),
    [anon_sym_while] = ACTIONS(3812),
    [anon_sym_do] = ACTIONS(3812),
    [anon_sym_for] = ACTIONS(3812),
    [anon_sym_return] = ACTIONS(3812),
    [anon_sym_break] = ACTIONS(3812),
    [anon_sym_continue] = ACTIONS(3812),
    [anon_sym_goto] = ACTIONS(3812),
    [anon_sym_not] = ACTIONS(3812),
    [anon_sym_compl] = ACTIONS(3812),
    [anon_sym_DASH_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_PLUS] = ACTIONS(3814),
    [anon_sym_sizeof] = ACTIONS(3812),
    [anon_sym___alignof__] = ACTIONS(3812),
    [anon_sym___alignof] = ACTIONS(3812),
    [anon_sym__alignof] = ACTIONS(3812),
    [anon_sym_alignof] = ACTIONS(3812),
    [anon_sym__Alignof] = ACTIONS(3812),
    [anon_sym_offsetof] = ACTIONS(3812),
    [anon_sym__Generic] = ACTIONS(3812),
    [anon_sym_asm] = ACTIONS(3812),
    [anon_sym___asm__] = ACTIONS(3812),
    [anon_sym___asm] = ACTIONS(3812),
    [sym_number_literal] = ACTIONS(3814),
    [anon_sym_L_SQUOTE] = ACTIONS(3814),
    [anon_sym_u_SQUOTE] = ACTIONS(3814),
    [anon_sym_U_SQUOTE] = ACTIONS(3814),
    [anon_sym_u8_SQUOTE] = ACTIONS(3814),
    [anon_sym_SQUOTE] = ACTIONS(3814),
    [anon_sym_L_DQUOTE] = ACTIONS(3814),
    [anon_sym_u_DQUOTE] = ACTIONS(3814),
    [anon_sym_U_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [anon_sym_NULL] = ACTIONS(3812),
    [anon_sym_nullptr] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_export] = ACTIONS(3812),
    [anon_sym_module] = ACTIONS(3812),
    [anon_sym_import] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_try] = ACTIONS(3812),
    [anon_sym_delete] = ACTIONS(3812),
    [anon_sym_throw] = ACTIONS(3812),
    [anon_sym_namespace] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_concept] = ACTIONS(3812),
    [anon_sym_co_return] = ACTIONS(3812),
    [anon_sym_co_yield] = ACTIONS(3812),
    [anon_sym_R_DQUOTE] = ACTIONS(3814),
    [anon_sym_LR_DQUOTE] = ACTIONS(3814),
    [anon_sym_uR_DQUOTE] = ACTIONS(3814),
    [anon_sym_UR_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3814),
    [anon_sym_co_await] = ACTIONS(3812),
    [anon_sym_new] = ACTIONS(3812),
    [anon_sym_requires] = ACTIONS(3812),
    [sym_this] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
    [anon_sym___exported] = ACTIONS(3812),
  },
  [956] = {
    [ts_builtin_sym_end] = ACTIONS(3814),
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_include_token1] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_BANG] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3812),
    [anon_sym_PLUS] = ACTIONS(3812),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym___cdecl] = ACTIONS(3812),
    [anon_sym___clrcall] = ACTIONS(3812),
    [anon_sym___stdcall] = ACTIONS(3812),
    [anon_sym___fastcall] = ACTIONS(3812),
    [anon_sym___thiscall] = ACTIONS(3812),
    [anon_sym___vectorcall] = ACTIONS(3812),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [anon_sym_if] = ACTIONS(3812),
    [anon_sym_switch] = ACTIONS(3812),
    [anon_sym_case] = ACTIONS(3812),
    [anon_sym_default] = ACTIONS(3812),
    [anon_sym_while] = ACTIONS(3812),
    [anon_sym_do] = ACTIONS(3812),
    [anon_sym_for] = ACTIONS(3812),
    [anon_sym_return] = ACTIONS(3812),
    [anon_sym_break] = ACTIONS(3812),
    [anon_sym_continue] = ACTIONS(3812),
    [anon_sym_goto] = ACTIONS(3812),
    [anon_sym_not] = ACTIONS(3812),
    [anon_sym_compl] = ACTIONS(3812),
    [anon_sym_DASH_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_PLUS] = ACTIONS(3814),
    [anon_sym_sizeof] = ACTIONS(3812),
    [anon_sym___alignof__] = ACTIONS(3812),
    [anon_sym___alignof] = ACTIONS(3812),
    [anon_sym__alignof] = ACTIONS(3812),
    [anon_sym_alignof] = ACTIONS(3812),
    [anon_sym__Alignof] = ACTIONS(3812),
    [anon_sym_offsetof] = ACTIONS(3812),
    [anon_sym__Generic] = ACTIONS(3812),
    [anon_sym_asm] = ACTIONS(3812),
    [anon_sym___asm__] = ACTIONS(3812),
    [anon_sym___asm] = ACTIONS(3812),
    [sym_number_literal] = ACTIONS(3814),
    [anon_sym_L_SQUOTE] = ACTIONS(3814),
    [anon_sym_u_SQUOTE] = ACTIONS(3814),
    [anon_sym_U_SQUOTE] = ACTIONS(3814),
    [anon_sym_u8_SQUOTE] = ACTIONS(3814),
    [anon_sym_SQUOTE] = ACTIONS(3814),
    [anon_sym_L_DQUOTE] = ACTIONS(3814),
    [anon_sym_u_DQUOTE] = ACTIONS(3814),
    [anon_sym_U_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [anon_sym_NULL] = ACTIONS(3812),
    [anon_sym_nullptr] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_export] = ACTIONS(3812),
    [anon_sym_module] = ACTIONS(3812),
    [anon_sym_import] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_try] = ACTIONS(3812),
    [anon_sym_delete] = ACTIONS(3812),
    [anon_sym_throw] = ACTIONS(3812),
    [anon_sym_namespace] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_concept] = ACTIONS(3812),
    [anon_sym_co_return] = ACTIONS(3812),
    [anon_sym_co_yield] = ACTIONS(3812),
    [anon_sym_R_DQUOTE] = ACTIONS(3814),
    [anon_sym_LR_DQUOTE] = ACTIONS(3814),
    [anon_sym_uR_DQUOTE] = ACTIONS(3814),
    [anon_sym_UR_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3814),
    [anon_sym_co_await] = ACTIONS(3812),
    [anon_sym_new] = ACTIONS(3812),
    [anon_sym_requires] = ACTIONS(3812),
    [sym_this] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
    [anon_sym___exported] = ACTIONS(3812),
  },
  [957] = {
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_include_token1] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_BANG] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym___cdecl] = ACTIONS(3942),
    [anon_sym___clrcall] = ACTIONS(3942),
    [anon_sym___stdcall] = ACTIONS(3942),
    [anon_sym___fastcall] = ACTIONS(3942),
    [anon_sym___thiscall] = ACTIONS(3942),
    [anon_sym___vectorcall] = ACTIONS(3942),
    [anon_sym_LBRACE] = ACTIONS(3944),
    [anon_sym_RBRACE] = ACTIONS(3944),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_switch] = ACTIONS(3942),
    [anon_sym_case] = ACTIONS(3942),
    [anon_sym_default] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_break] = ACTIONS(3942),
    [anon_sym_continue] = ACTIONS(3942),
    [anon_sym_goto] = ACTIONS(3942),
    [anon_sym___try] = ACTIONS(3942),
    [anon_sym___leave] = ACTIONS(3942),
    [anon_sym_not] = ACTIONS(3942),
    [anon_sym_compl] = ACTIONS(3942),
    [anon_sym_DASH_DASH] = ACTIONS(3944),
    [anon_sym_PLUS_PLUS] = ACTIONS(3944),
    [anon_sym_sizeof] = ACTIONS(3942),
    [anon_sym___alignof__] = ACTIONS(3942),
    [anon_sym___alignof] = ACTIONS(3942),
    [anon_sym__alignof] = ACTIONS(3942),
    [anon_sym_alignof] = ACTIONS(3942),
    [anon_sym__Alignof] = ACTIONS(3942),
    [anon_sym_offsetof] = ACTIONS(3942),
    [anon_sym__Generic] = ACTIONS(3942),
    [anon_sym_asm] = ACTIONS(3942),
    [anon_sym___asm__] = ACTIONS(3942),
    [anon_sym___asm] = ACTIONS(3942),
    [sym_number_literal] = ACTIONS(3944),
    [anon_sym_L_SQUOTE] = ACTIONS(3944),
    [anon_sym_u_SQUOTE] = ACTIONS(3944),
    [anon_sym_U_SQUOTE] = ACTIONS(3944),
    [anon_sym_u8_SQUOTE] = ACTIONS(3944),
    [anon_sym_SQUOTE] = ACTIONS(3944),
    [anon_sym_L_DQUOTE] = ACTIONS(3944),
    [anon_sym_u_DQUOTE] = ACTIONS(3944),
    [anon_sym_U_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE] = ACTIONS(3944),
    [sym_true] = ACTIONS(3942),
    [sym_false] = ACTIONS(3942),
    [anon_sym_NULL] = ACTIONS(3942),
    [anon_sym_nullptr] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_delete] = ACTIONS(3942),
    [anon_sym_throw] = ACTIONS(3942),
    [anon_sym_namespace] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_concept] = ACTIONS(3942),
    [anon_sym_co_return] = ACTIONS(3942),
    [anon_sym_co_yield] = ACTIONS(3942),
    [anon_sym_R_DQUOTE] = ACTIONS(3944),
    [anon_sym_LR_DQUOTE] = ACTIONS(3944),
    [anon_sym_uR_DQUOTE] = ACTIONS(3944),
    [anon_sym_UR_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3944),
    [anon_sym_co_await] = ACTIONS(3942),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_requires] = ACTIONS(3942),
    [sym_this] = ACTIONS(3942),
    [anon_sym_discard] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_cbuffer] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
  },
  [958] = {
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_include_token1] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_BANG] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym___cdecl] = ACTIONS(3942),
    [anon_sym___clrcall] = ACTIONS(3942),
    [anon_sym___stdcall] = ACTIONS(3942),
    [anon_sym___fastcall] = ACTIONS(3942),
    [anon_sym___thiscall] = ACTIONS(3942),
    [anon_sym___vectorcall] = ACTIONS(3942),
    [anon_sym_LBRACE] = ACTIONS(3944),
    [anon_sym_RBRACE] = ACTIONS(3944),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_switch] = ACTIONS(3942),
    [anon_sym_case] = ACTIONS(3942),
    [anon_sym_default] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_break] = ACTIONS(3942),
    [anon_sym_continue] = ACTIONS(3942),
    [anon_sym_goto] = ACTIONS(3942),
    [anon_sym___try] = ACTIONS(3942),
    [anon_sym___leave] = ACTIONS(3942),
    [anon_sym_not] = ACTIONS(3942),
    [anon_sym_compl] = ACTIONS(3942),
    [anon_sym_DASH_DASH] = ACTIONS(3944),
    [anon_sym_PLUS_PLUS] = ACTIONS(3944),
    [anon_sym_sizeof] = ACTIONS(3942),
    [anon_sym___alignof__] = ACTIONS(3942),
    [anon_sym___alignof] = ACTIONS(3942),
    [anon_sym__alignof] = ACTIONS(3942),
    [anon_sym_alignof] = ACTIONS(3942),
    [anon_sym__Alignof] = ACTIONS(3942),
    [anon_sym_offsetof] = ACTIONS(3942),
    [anon_sym__Generic] = ACTIONS(3942),
    [anon_sym_asm] = ACTIONS(3942),
    [anon_sym___asm__] = ACTIONS(3942),
    [anon_sym___asm] = ACTIONS(3942),
    [sym_number_literal] = ACTIONS(3944),
    [anon_sym_L_SQUOTE] = ACTIONS(3944),
    [anon_sym_u_SQUOTE] = ACTIONS(3944),
    [anon_sym_U_SQUOTE] = ACTIONS(3944),
    [anon_sym_u8_SQUOTE] = ACTIONS(3944),
    [anon_sym_SQUOTE] = ACTIONS(3944),
    [anon_sym_L_DQUOTE] = ACTIONS(3944),
    [anon_sym_u_DQUOTE] = ACTIONS(3944),
    [anon_sym_U_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE] = ACTIONS(3944),
    [sym_true] = ACTIONS(3942),
    [sym_false] = ACTIONS(3942),
    [anon_sym_NULL] = ACTIONS(3942),
    [anon_sym_nullptr] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_delete] = ACTIONS(3942),
    [anon_sym_throw] = ACTIONS(3942),
    [anon_sym_namespace] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_concept] = ACTIONS(3942),
    [anon_sym_co_return] = ACTIONS(3942),
    [anon_sym_co_yield] = ACTIONS(3942),
    [anon_sym_R_DQUOTE] = ACTIONS(3944),
    [anon_sym_LR_DQUOTE] = ACTIONS(3944),
    [anon_sym_uR_DQUOTE] = ACTIONS(3944),
    [anon_sym_UR_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3944),
    [anon_sym_co_await] = ACTIONS(3942),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_requires] = ACTIONS(3942),
    [sym_this] = ACTIONS(3942),
    [anon_sym_discard] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_cbuffer] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
  },
  [959] = {
    [sym_identifier] = ACTIONS(3953),
    [aux_sym_preproc_include_token1] = ACTIONS(3953),
    [aux_sym_preproc_def_token1] = ACTIONS(3953),
    [aux_sym_preproc_if_token1] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3953),
    [sym_preproc_directive] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_BANG] = ACTIONS(3955),
    [anon_sym_TILDE] = ACTIONS(3955),
    [anon_sym_DASH] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3953),
    [anon_sym_STAR] = ACTIONS(3955),
    [anon_sym_AMP_AMP] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_SEMI] = ACTIONS(3955),
    [anon_sym___extension__] = ACTIONS(3953),
    [anon_sym_typedef] = ACTIONS(3953),
    [anon_sym_in] = ACTIONS(3953),
    [anon_sym_out] = ACTIONS(3953),
    [anon_sym_inout] = ACTIONS(3953),
    [anon_sym_virtual] = ACTIONS(3953),
    [anon_sym_extern] = ACTIONS(3953),
    [anon_sym___attribute__] = ACTIONS(3953),
    [anon_sym___attribute] = ACTIONS(3953),
    [anon_sym_using] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3955),
    [anon_sym___declspec] = ACTIONS(3953),
    [anon_sym___based] = ACTIONS(3953),
    [anon_sym___cdecl] = ACTIONS(3953),
    [anon_sym___clrcall] = ACTIONS(3953),
    [anon_sym___stdcall] = ACTIONS(3953),
    [anon_sym___fastcall] = ACTIONS(3953),
    [anon_sym___thiscall] = ACTIONS(3953),
    [anon_sym___vectorcall] = ACTIONS(3953),
    [anon_sym_LBRACE] = ACTIONS(3955),
    [anon_sym_RBRACE] = ACTIONS(3955),
    [anon_sym_signed] = ACTIONS(3953),
    [anon_sym_unsigned] = ACTIONS(3953),
    [anon_sym_long] = ACTIONS(3953),
    [anon_sym_short] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_static] = ACTIONS(3953),
    [anon_sym_register] = ACTIONS(3953),
    [anon_sym_inline] = ACTIONS(3953),
    [anon_sym___inline] = ACTIONS(3953),
    [anon_sym___inline__] = ACTIONS(3953),
    [anon_sym___forceinline] = ACTIONS(3953),
    [anon_sym_thread_local] = ACTIONS(3953),
    [anon_sym___thread] = ACTIONS(3953),
    [anon_sym_const] = ACTIONS(3953),
    [anon_sym_constexpr] = ACTIONS(3953),
    [anon_sym_volatile] = ACTIONS(3953),
    [anon_sym_restrict] = ACTIONS(3953),
    [anon_sym___restrict__] = ACTIONS(3953),
    [anon_sym__Atomic] = ACTIONS(3953),
    [anon_sym__Noreturn] = ACTIONS(3953),
    [anon_sym_noreturn] = ACTIONS(3953),
    [anon_sym__Nonnull] = ACTIONS(3953),
    [anon_sym_mutable] = ACTIONS(3953),
    [anon_sym_constinit] = ACTIONS(3953),
    [anon_sym_consteval] = ACTIONS(3953),
    [anon_sym_alignas] = ACTIONS(3953),
    [anon_sym__Alignas] = ACTIONS(3953),
    [sym_primitive_type] = ACTIONS(3953),
    [anon_sym_enum] = ACTIONS(3953),
    [anon_sym_class] = ACTIONS(3953),
    [anon_sym_struct] = ACTIONS(3953),
    [anon_sym_union] = ACTIONS(3953),
    [anon_sym_if] = ACTIONS(3953),
    [anon_sym_switch] = ACTIONS(3953),
    [anon_sym_case] = ACTIONS(3953),
    [anon_sym_default] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3953),
    [anon_sym_do] = ACTIONS(3953),
    [anon_sym_for] = ACTIONS(3953),
    [anon_sym_return] = ACTIONS(3953),
    [anon_sym_break] = ACTIONS(3953),
    [anon_sym_continue] = ACTIONS(3953),
    [anon_sym_goto] = ACTIONS(3953),
    [anon_sym___try] = ACTIONS(3953),
    [anon_sym___leave] = ACTIONS(3953),
    [anon_sym_not] = ACTIONS(3953),
    [anon_sym_compl] = ACTIONS(3953),
    [anon_sym_DASH_DASH] = ACTIONS(3955),
    [anon_sym_PLUS_PLUS] = ACTIONS(3955),
    [anon_sym_sizeof] = ACTIONS(3953),
    [anon_sym___alignof__] = ACTIONS(3953),
    [anon_sym___alignof] = ACTIONS(3953),
    [anon_sym__alignof] = ACTIONS(3953),
    [anon_sym_alignof] = ACTIONS(3953),
    [anon_sym__Alignof] = ACTIONS(3953),
    [anon_sym_offsetof] = ACTIONS(3953),
    [anon_sym__Generic] = ACTIONS(3953),
    [anon_sym_asm] = ACTIONS(3953),
    [anon_sym___asm__] = ACTIONS(3953),
    [anon_sym___asm] = ACTIONS(3953),
    [sym_number_literal] = ACTIONS(3955),
    [anon_sym_L_SQUOTE] = ACTIONS(3955),
    [anon_sym_u_SQUOTE] = ACTIONS(3955),
    [anon_sym_U_SQUOTE] = ACTIONS(3955),
    [anon_sym_u8_SQUOTE] = ACTIONS(3955),
    [anon_sym_SQUOTE] = ACTIONS(3955),
    [anon_sym_L_DQUOTE] = ACTIONS(3955),
    [anon_sym_u_DQUOTE] = ACTIONS(3955),
    [anon_sym_U_DQUOTE] = ACTIONS(3955),
    [anon_sym_u8_DQUOTE] = ACTIONS(3955),
    [anon_sym_DQUOTE] = ACTIONS(3955),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [anon_sym_NULL] = ACTIONS(3953),
    [anon_sym_nullptr] = ACTIONS(3953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_This] = ACTIONS(3953),
    [anon_sym_decltype] = ACTIONS(3953),
    [anon_sym_explicit] = ACTIONS(3953),
    [anon_sym_typename] = ACTIONS(3953),
    [anon_sym_template] = ACTIONS(3953),
    [anon_sym_operator] = ACTIONS(3953),
    [anon_sym_try] = ACTIONS(3953),
    [anon_sym_delete] = ACTIONS(3953),
    [anon_sym_throw] = ACTIONS(3953),
    [anon_sym_namespace] = ACTIONS(3953),
    [anon_sym_static_assert] = ACTIONS(3953),
    [anon_sym_concept] = ACTIONS(3953),
    [anon_sym_co_return] = ACTIONS(3953),
    [anon_sym_co_yield] = ACTIONS(3953),
    [anon_sym_R_DQUOTE] = ACTIONS(3955),
    [anon_sym_LR_DQUOTE] = ACTIONS(3955),
    [anon_sym_uR_DQUOTE] = ACTIONS(3955),
    [anon_sym_UR_DQUOTE] = ACTIONS(3955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3955),
    [anon_sym_co_await] = ACTIONS(3953),
    [anon_sym_new] = ACTIONS(3953),
    [anon_sym_requires] = ACTIONS(3953),
    [sym_this] = ACTIONS(3953),
    [anon_sym_discard] = ACTIONS(3953),
    [anon_sym_precise] = ACTIONS(3953),
    [anon_sym_shared] = ACTIONS(3953),
    [anon_sym_groupshared] = ACTIONS(3953),
    [anon_sym_uniform] = ACTIONS(3953),
    [anon_sym_row_major] = ACTIONS(3953),
    [anon_sym_column_major] = ACTIONS(3953),
    [anon_sym_globallycoherent] = ACTIONS(3953),
    [anon_sym_centroid] = ACTIONS(3953),
    [anon_sym_noperspective] = ACTIONS(3953),
    [anon_sym_nointerpolation] = ACTIONS(3953),
    [anon_sym_sample] = ACTIONS(3953),
    [anon_sym_linear] = ACTIONS(3953),
    [anon_sym_snorm] = ACTIONS(3953),
    [anon_sym_unorm] = ACTIONS(3953),
    [anon_sym_point] = ACTIONS(3953),
    [anon_sym_line] = ACTIONS(3953),
    [anon_sym_triangleadj] = ACTIONS(3953),
    [anon_sym_lineadj] = ACTIONS(3953),
    [anon_sym_triangle] = ACTIONS(3953),
    [anon_sym_cbuffer] = ACTIONS(3953),
    [anon_sym_interface] = ACTIONS(3953),
    [anon_sym_extension] = ACTIONS(3953),
  },
  [960] = {
    [sym_identifier] = ACTIONS(3953),
    [aux_sym_preproc_include_token1] = ACTIONS(3953),
    [aux_sym_preproc_def_token1] = ACTIONS(3953),
    [aux_sym_preproc_if_token1] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3953),
    [sym_preproc_directive] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_BANG] = ACTIONS(3955),
    [anon_sym_TILDE] = ACTIONS(3955),
    [anon_sym_DASH] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3953),
    [anon_sym_STAR] = ACTIONS(3955),
    [anon_sym_AMP_AMP] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_SEMI] = ACTIONS(3955),
    [anon_sym___extension__] = ACTIONS(3953),
    [anon_sym_typedef] = ACTIONS(3953),
    [anon_sym_in] = ACTIONS(3953),
    [anon_sym_out] = ACTIONS(3953),
    [anon_sym_inout] = ACTIONS(3953),
    [anon_sym_virtual] = ACTIONS(3953),
    [anon_sym_extern] = ACTIONS(3953),
    [anon_sym___attribute__] = ACTIONS(3953),
    [anon_sym___attribute] = ACTIONS(3953),
    [anon_sym_using] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3955),
    [anon_sym___declspec] = ACTIONS(3953),
    [anon_sym___based] = ACTIONS(3953),
    [anon_sym___cdecl] = ACTIONS(3953),
    [anon_sym___clrcall] = ACTIONS(3953),
    [anon_sym___stdcall] = ACTIONS(3953),
    [anon_sym___fastcall] = ACTIONS(3953),
    [anon_sym___thiscall] = ACTIONS(3953),
    [anon_sym___vectorcall] = ACTIONS(3953),
    [anon_sym_LBRACE] = ACTIONS(3955),
    [anon_sym_RBRACE] = ACTIONS(3955),
    [anon_sym_signed] = ACTIONS(3953),
    [anon_sym_unsigned] = ACTIONS(3953),
    [anon_sym_long] = ACTIONS(3953),
    [anon_sym_short] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_static] = ACTIONS(3953),
    [anon_sym_register] = ACTIONS(3953),
    [anon_sym_inline] = ACTIONS(3953),
    [anon_sym___inline] = ACTIONS(3953),
    [anon_sym___inline__] = ACTIONS(3953),
    [anon_sym___forceinline] = ACTIONS(3953),
    [anon_sym_thread_local] = ACTIONS(3953),
    [anon_sym___thread] = ACTIONS(3953),
    [anon_sym_const] = ACTIONS(3953),
    [anon_sym_constexpr] = ACTIONS(3953),
    [anon_sym_volatile] = ACTIONS(3953),
    [anon_sym_restrict] = ACTIONS(3953),
    [anon_sym___restrict__] = ACTIONS(3953),
    [anon_sym__Atomic] = ACTIONS(3953),
    [anon_sym__Noreturn] = ACTIONS(3953),
    [anon_sym_noreturn] = ACTIONS(3953),
    [anon_sym__Nonnull] = ACTIONS(3953),
    [anon_sym_mutable] = ACTIONS(3953),
    [anon_sym_constinit] = ACTIONS(3953),
    [anon_sym_consteval] = ACTIONS(3953),
    [anon_sym_alignas] = ACTIONS(3953),
    [anon_sym__Alignas] = ACTIONS(3953),
    [sym_primitive_type] = ACTIONS(3953),
    [anon_sym_enum] = ACTIONS(3953),
    [anon_sym_class] = ACTIONS(3953),
    [anon_sym_struct] = ACTIONS(3953),
    [anon_sym_union] = ACTIONS(3953),
    [anon_sym_if] = ACTIONS(3953),
    [anon_sym_switch] = ACTIONS(3953),
    [anon_sym_case] = ACTIONS(3953),
    [anon_sym_default] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3953),
    [anon_sym_do] = ACTIONS(3953),
    [anon_sym_for] = ACTIONS(3953),
    [anon_sym_return] = ACTIONS(3953),
    [anon_sym_break] = ACTIONS(3953),
    [anon_sym_continue] = ACTIONS(3953),
    [anon_sym_goto] = ACTIONS(3953),
    [anon_sym___try] = ACTIONS(3953),
    [anon_sym___leave] = ACTIONS(3953),
    [anon_sym_not] = ACTIONS(3953),
    [anon_sym_compl] = ACTIONS(3953),
    [anon_sym_DASH_DASH] = ACTIONS(3955),
    [anon_sym_PLUS_PLUS] = ACTIONS(3955),
    [anon_sym_sizeof] = ACTIONS(3953),
    [anon_sym___alignof__] = ACTIONS(3953),
    [anon_sym___alignof] = ACTIONS(3953),
    [anon_sym__alignof] = ACTIONS(3953),
    [anon_sym_alignof] = ACTIONS(3953),
    [anon_sym__Alignof] = ACTIONS(3953),
    [anon_sym_offsetof] = ACTIONS(3953),
    [anon_sym__Generic] = ACTIONS(3953),
    [anon_sym_asm] = ACTIONS(3953),
    [anon_sym___asm__] = ACTIONS(3953),
    [anon_sym___asm] = ACTIONS(3953),
    [sym_number_literal] = ACTIONS(3955),
    [anon_sym_L_SQUOTE] = ACTIONS(3955),
    [anon_sym_u_SQUOTE] = ACTIONS(3955),
    [anon_sym_U_SQUOTE] = ACTIONS(3955),
    [anon_sym_u8_SQUOTE] = ACTIONS(3955),
    [anon_sym_SQUOTE] = ACTIONS(3955),
    [anon_sym_L_DQUOTE] = ACTIONS(3955),
    [anon_sym_u_DQUOTE] = ACTIONS(3955),
    [anon_sym_U_DQUOTE] = ACTIONS(3955),
    [anon_sym_u8_DQUOTE] = ACTIONS(3955),
    [anon_sym_DQUOTE] = ACTIONS(3955),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [anon_sym_NULL] = ACTIONS(3953),
    [anon_sym_nullptr] = ACTIONS(3953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_This] = ACTIONS(3953),
    [anon_sym_decltype] = ACTIONS(3953),
    [anon_sym_explicit] = ACTIONS(3953),
    [anon_sym_typename] = ACTIONS(3953),
    [anon_sym_template] = ACTIONS(3953),
    [anon_sym_operator] = ACTIONS(3953),
    [anon_sym_try] = ACTIONS(3953),
    [anon_sym_delete] = ACTIONS(3953),
    [anon_sym_throw] = ACTIONS(3953),
    [anon_sym_namespace] = ACTIONS(3953),
    [anon_sym_static_assert] = ACTIONS(3953),
    [anon_sym_concept] = ACTIONS(3953),
    [anon_sym_co_return] = ACTIONS(3953),
    [anon_sym_co_yield] = ACTIONS(3953),
    [anon_sym_R_DQUOTE] = ACTIONS(3955),
    [anon_sym_LR_DQUOTE] = ACTIONS(3955),
    [anon_sym_uR_DQUOTE] = ACTIONS(3955),
    [anon_sym_UR_DQUOTE] = ACTIONS(3955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3955),
    [anon_sym_co_await] = ACTIONS(3953),
    [anon_sym_new] = ACTIONS(3953),
    [anon_sym_requires] = ACTIONS(3953),
    [sym_this] = ACTIONS(3953),
    [anon_sym_discard] = ACTIONS(3953),
    [anon_sym_precise] = ACTIONS(3953),
    [anon_sym_shared] = ACTIONS(3953),
    [anon_sym_groupshared] = ACTIONS(3953),
    [anon_sym_uniform] = ACTIONS(3953),
    [anon_sym_row_major] = ACTIONS(3953),
    [anon_sym_column_major] = ACTIONS(3953),
    [anon_sym_globallycoherent] = ACTIONS(3953),
    [anon_sym_centroid] = ACTIONS(3953),
    [anon_sym_noperspective] = ACTIONS(3953),
    [anon_sym_nointerpolation] = ACTIONS(3953),
    [anon_sym_sample] = ACTIONS(3953),
    [anon_sym_linear] = ACTIONS(3953),
    [anon_sym_snorm] = ACTIONS(3953),
    [anon_sym_unorm] = ACTIONS(3953),
    [anon_sym_point] = ACTIONS(3953),
    [anon_sym_line] = ACTIONS(3953),
    [anon_sym_triangleadj] = ACTIONS(3953),
    [anon_sym_lineadj] = ACTIONS(3953),
    [anon_sym_triangle] = ACTIONS(3953),
    [anon_sym_cbuffer] = ACTIONS(3953),
    [anon_sym_interface] = ACTIONS(3953),
    [anon_sym_extension] = ACTIONS(3953),
  },
  [961] = {
    [sym_identifier] = ACTIONS(3963),
    [aux_sym_preproc_include_token1] = ACTIONS(3963),
    [aux_sym_preproc_def_token1] = ACTIONS(3963),
    [aux_sym_preproc_if_token1] = ACTIONS(3963),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3963),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3963),
    [sym_preproc_directive] = ACTIONS(3963),
    [anon_sym_LPAREN2] = ACTIONS(3965),
    [anon_sym_BANG] = ACTIONS(3965),
    [anon_sym_TILDE] = ACTIONS(3965),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_STAR] = ACTIONS(3965),
    [anon_sym_AMP_AMP] = ACTIONS(3965),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_SEMI] = ACTIONS(3965),
    [anon_sym___extension__] = ACTIONS(3963),
    [anon_sym_typedef] = ACTIONS(3963),
    [anon_sym_in] = ACTIONS(3963),
    [anon_sym_out] = ACTIONS(3963),
    [anon_sym_inout] = ACTIONS(3963),
    [anon_sym_virtual] = ACTIONS(3963),
    [anon_sym_extern] = ACTIONS(3963),
    [anon_sym___attribute__] = ACTIONS(3963),
    [anon_sym___attribute] = ACTIONS(3963),
    [anon_sym_using] = ACTIONS(3963),
    [anon_sym_COLON_COLON] = ACTIONS(3965),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3965),
    [anon_sym___declspec] = ACTIONS(3963),
    [anon_sym___based] = ACTIONS(3963),
    [anon_sym___cdecl] = ACTIONS(3963),
    [anon_sym___clrcall] = ACTIONS(3963),
    [anon_sym___stdcall] = ACTIONS(3963),
    [anon_sym___fastcall] = ACTIONS(3963),
    [anon_sym___thiscall] = ACTIONS(3963),
    [anon_sym___vectorcall] = ACTIONS(3963),
    [anon_sym_LBRACE] = ACTIONS(3965),
    [anon_sym_RBRACE] = ACTIONS(3965),
    [anon_sym_signed] = ACTIONS(3963),
    [anon_sym_unsigned] = ACTIONS(3963),
    [anon_sym_long] = ACTIONS(3963),
    [anon_sym_short] = ACTIONS(3963),
    [anon_sym_LBRACK] = ACTIONS(3963),
    [anon_sym_static] = ACTIONS(3963),
    [anon_sym_register] = ACTIONS(3963),
    [anon_sym_inline] = ACTIONS(3963),
    [anon_sym___inline] = ACTIONS(3963),
    [anon_sym___inline__] = ACTIONS(3963),
    [anon_sym___forceinline] = ACTIONS(3963),
    [anon_sym_thread_local] = ACTIONS(3963),
    [anon_sym___thread] = ACTIONS(3963),
    [anon_sym_const] = ACTIONS(3963),
    [anon_sym_constexpr] = ACTIONS(3963),
    [anon_sym_volatile] = ACTIONS(3963),
    [anon_sym_restrict] = ACTIONS(3963),
    [anon_sym___restrict__] = ACTIONS(3963),
    [anon_sym__Atomic] = ACTIONS(3963),
    [anon_sym__Noreturn] = ACTIONS(3963),
    [anon_sym_noreturn] = ACTIONS(3963),
    [anon_sym__Nonnull] = ACTIONS(3963),
    [anon_sym_mutable] = ACTIONS(3963),
    [anon_sym_constinit] = ACTIONS(3963),
    [anon_sym_consteval] = ACTIONS(3963),
    [anon_sym_alignas] = ACTIONS(3963),
    [anon_sym__Alignas] = ACTIONS(3963),
    [sym_primitive_type] = ACTIONS(3963),
    [anon_sym_enum] = ACTIONS(3963),
    [anon_sym_class] = ACTIONS(3963),
    [anon_sym_struct] = ACTIONS(3963),
    [anon_sym_union] = ACTIONS(3963),
    [anon_sym_if] = ACTIONS(3963),
    [anon_sym_switch] = ACTIONS(3963),
    [anon_sym_case] = ACTIONS(3963),
    [anon_sym_default] = ACTIONS(3963),
    [anon_sym_while] = ACTIONS(3963),
    [anon_sym_do] = ACTIONS(3963),
    [anon_sym_for] = ACTIONS(3963),
    [anon_sym_return] = ACTIONS(3963),
    [anon_sym_break] = ACTIONS(3963),
    [anon_sym_continue] = ACTIONS(3963),
    [anon_sym_goto] = ACTIONS(3963),
    [anon_sym___try] = ACTIONS(3963),
    [anon_sym___leave] = ACTIONS(3963),
    [anon_sym_not] = ACTIONS(3963),
    [anon_sym_compl] = ACTIONS(3963),
    [anon_sym_DASH_DASH] = ACTIONS(3965),
    [anon_sym_PLUS_PLUS] = ACTIONS(3965),
    [anon_sym_sizeof] = ACTIONS(3963),
    [anon_sym___alignof__] = ACTIONS(3963),
    [anon_sym___alignof] = ACTIONS(3963),
    [anon_sym__alignof] = ACTIONS(3963),
    [anon_sym_alignof] = ACTIONS(3963),
    [anon_sym__Alignof] = ACTIONS(3963),
    [anon_sym_offsetof] = ACTIONS(3963),
    [anon_sym__Generic] = ACTIONS(3963),
    [anon_sym_asm] = ACTIONS(3963),
    [anon_sym___asm__] = ACTIONS(3963),
    [anon_sym___asm] = ACTIONS(3963),
    [sym_number_literal] = ACTIONS(3965),
    [anon_sym_L_SQUOTE] = ACTIONS(3965),
    [anon_sym_u_SQUOTE] = ACTIONS(3965),
    [anon_sym_U_SQUOTE] = ACTIONS(3965),
    [anon_sym_u8_SQUOTE] = ACTIONS(3965),
    [anon_sym_SQUOTE] = ACTIONS(3965),
    [anon_sym_L_DQUOTE] = ACTIONS(3965),
    [anon_sym_u_DQUOTE] = ACTIONS(3965),
    [anon_sym_U_DQUOTE] = ACTIONS(3965),
    [anon_sym_u8_DQUOTE] = ACTIONS(3965),
    [anon_sym_DQUOTE] = ACTIONS(3965),
    [sym_true] = ACTIONS(3963),
    [sym_false] = ACTIONS(3963),
    [anon_sym_NULL] = ACTIONS(3963),
    [anon_sym_nullptr] = ACTIONS(3963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3963),
    [anon_sym_let] = ACTIONS(3963),
    [anon_sym_This] = ACTIONS(3963),
    [anon_sym_decltype] = ACTIONS(3963),
    [anon_sym_explicit] = ACTIONS(3963),
    [anon_sym_typename] = ACTIONS(3963),
    [anon_sym_template] = ACTIONS(3963),
    [anon_sym_operator] = ACTIONS(3963),
    [anon_sym_try] = ACTIONS(3963),
    [anon_sym_delete] = ACTIONS(3963),
    [anon_sym_throw] = ACTIONS(3963),
    [anon_sym_namespace] = ACTIONS(3963),
    [anon_sym_static_assert] = ACTIONS(3963),
    [anon_sym_concept] = ACTIONS(3963),
    [anon_sym_co_return] = ACTIONS(3963),
    [anon_sym_co_yield] = ACTIONS(3963),
    [anon_sym_R_DQUOTE] = ACTIONS(3965),
    [anon_sym_LR_DQUOTE] = ACTIONS(3965),
    [anon_sym_uR_DQUOTE] = ACTIONS(3965),
    [anon_sym_UR_DQUOTE] = ACTIONS(3965),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3965),
    [anon_sym_co_await] = ACTIONS(3963),
    [anon_sym_new] = ACTIONS(3963),
    [anon_sym_requires] = ACTIONS(3963),
    [sym_this] = ACTIONS(3963),
    [anon_sym_discard] = ACTIONS(3963),
    [anon_sym_precise] = ACTIONS(3963),
    [anon_sym_shared] = ACTIONS(3963),
    [anon_sym_groupshared] = ACTIONS(3963),
    [anon_sym_uniform] = ACTIONS(3963),
    [anon_sym_row_major] = ACTIONS(3963),
    [anon_sym_column_major] = ACTIONS(3963),
    [anon_sym_globallycoherent] = ACTIONS(3963),
    [anon_sym_centroid] = ACTIONS(3963),
    [anon_sym_noperspective] = ACTIONS(3963),
    [anon_sym_nointerpolation] = ACTIONS(3963),
    [anon_sym_sample] = ACTIONS(3963),
    [anon_sym_linear] = ACTIONS(3963),
    [anon_sym_snorm] = ACTIONS(3963),
    [anon_sym_unorm] = ACTIONS(3963),
    [anon_sym_point] = ACTIONS(3963),
    [anon_sym_line] = ACTIONS(3963),
    [anon_sym_triangleadj] = ACTIONS(3963),
    [anon_sym_lineadj] = ACTIONS(3963),
    [anon_sym_triangle] = ACTIONS(3963),
    [anon_sym_cbuffer] = ACTIONS(3963),
    [anon_sym_interface] = ACTIONS(3963),
    [anon_sym_extension] = ACTIONS(3963),
  },
  [962] = {
    [sym_identifier] = ACTIONS(3869),
    [aux_sym_preproc_include_token1] = ACTIONS(3869),
    [aux_sym_preproc_def_token1] = ACTIONS(3869),
    [aux_sym_preproc_if_token1] = ACTIONS(3869),
    [aux_sym_preproc_if_token2] = ACTIONS(3869),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3869),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3869),
    [sym_preproc_directive] = ACTIONS(3869),
    [anon_sym_LPAREN2] = ACTIONS(3871),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(3871),
    [anon_sym_AMP_AMP] = ACTIONS(3871),
    [anon_sym_AMP] = ACTIONS(3869),
    [anon_sym_SEMI] = ACTIONS(3871),
    [anon_sym___extension__] = ACTIONS(3869),
    [anon_sym_typedef] = ACTIONS(3869),
    [anon_sym_in] = ACTIONS(3869),
    [anon_sym_out] = ACTIONS(3869),
    [anon_sym_inout] = ACTIONS(3869),
    [anon_sym_virtual] = ACTIONS(3869),
    [anon_sym_extern] = ACTIONS(3869),
    [anon_sym___attribute__] = ACTIONS(3869),
    [anon_sym___attribute] = ACTIONS(3869),
    [anon_sym_using] = ACTIONS(3869),
    [anon_sym_COLON_COLON] = ACTIONS(3871),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3871),
    [anon_sym___declspec] = ACTIONS(3869),
    [anon_sym___based] = ACTIONS(3869),
    [anon_sym___cdecl] = ACTIONS(3869),
    [anon_sym___clrcall] = ACTIONS(3869),
    [anon_sym___stdcall] = ACTIONS(3869),
    [anon_sym___fastcall] = ACTIONS(3869),
    [anon_sym___thiscall] = ACTIONS(3869),
    [anon_sym___vectorcall] = ACTIONS(3869),
    [anon_sym_LBRACE] = ACTIONS(3871),
    [anon_sym_signed] = ACTIONS(3869),
    [anon_sym_unsigned] = ACTIONS(3869),
    [anon_sym_long] = ACTIONS(3869),
    [anon_sym_short] = ACTIONS(3869),
    [anon_sym_LBRACK] = ACTIONS(3869),
    [anon_sym_static] = ACTIONS(3869),
    [anon_sym_register] = ACTIONS(3869),
    [anon_sym_inline] = ACTIONS(3869),
    [anon_sym___inline] = ACTIONS(3869),
    [anon_sym___inline__] = ACTIONS(3869),
    [anon_sym___forceinline] = ACTIONS(3869),
    [anon_sym_thread_local] = ACTIONS(3869),
    [anon_sym___thread] = ACTIONS(3869),
    [anon_sym_const] = ACTIONS(3869),
    [anon_sym_constexpr] = ACTIONS(3869),
    [anon_sym_volatile] = ACTIONS(3869),
    [anon_sym_restrict] = ACTIONS(3869),
    [anon_sym___restrict__] = ACTIONS(3869),
    [anon_sym__Atomic] = ACTIONS(3869),
    [anon_sym__Noreturn] = ACTIONS(3869),
    [anon_sym_noreturn] = ACTIONS(3869),
    [anon_sym__Nonnull] = ACTIONS(3869),
    [anon_sym_mutable] = ACTIONS(3869),
    [anon_sym_constinit] = ACTIONS(3869),
    [anon_sym_consteval] = ACTIONS(3869),
    [anon_sym_alignas] = ACTIONS(3869),
    [anon_sym__Alignas] = ACTIONS(3869),
    [sym_primitive_type] = ACTIONS(3869),
    [anon_sym_enum] = ACTIONS(3869),
    [anon_sym_class] = ACTIONS(3869),
    [anon_sym_struct] = ACTIONS(3869),
    [anon_sym_union] = ACTIONS(3869),
    [anon_sym_if] = ACTIONS(3869),
    [anon_sym_switch] = ACTIONS(3869),
    [anon_sym_case] = ACTIONS(3869),
    [anon_sym_default] = ACTIONS(3869),
    [anon_sym_while] = ACTIONS(3869),
    [anon_sym_do] = ACTIONS(3869),
    [anon_sym_for] = ACTIONS(3869),
    [anon_sym_return] = ACTIONS(3869),
    [anon_sym_break] = ACTIONS(3869),
    [anon_sym_continue] = ACTIONS(3869),
    [anon_sym_goto] = ACTIONS(3869),
    [anon_sym___try] = ACTIONS(3869),
    [anon_sym___leave] = ACTIONS(3869),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(3871),
    [anon_sym_PLUS_PLUS] = ACTIONS(3871),
    [anon_sym_sizeof] = ACTIONS(3869),
    [anon_sym___alignof__] = ACTIONS(3869),
    [anon_sym___alignof] = ACTIONS(3869),
    [anon_sym__alignof] = ACTIONS(3869),
    [anon_sym_alignof] = ACTIONS(3869),
    [anon_sym__Alignof] = ACTIONS(3869),
    [anon_sym_offsetof] = ACTIONS(3869),
    [anon_sym__Generic] = ACTIONS(3869),
    [anon_sym_asm] = ACTIONS(3869),
    [anon_sym___asm__] = ACTIONS(3869),
    [anon_sym___asm] = ACTIONS(3869),
    [sym_number_literal] = ACTIONS(3871),
    [anon_sym_L_SQUOTE] = ACTIONS(3871),
    [anon_sym_u_SQUOTE] = ACTIONS(3871),
    [anon_sym_U_SQUOTE] = ACTIONS(3871),
    [anon_sym_u8_SQUOTE] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3871),
    [anon_sym_L_DQUOTE] = ACTIONS(3871),
    [anon_sym_u_DQUOTE] = ACTIONS(3871),
    [anon_sym_U_DQUOTE] = ACTIONS(3871),
    [anon_sym_u8_DQUOTE] = ACTIONS(3871),
    [anon_sym_DQUOTE] = ACTIONS(3871),
    [sym_true] = ACTIONS(3869),
    [sym_false] = ACTIONS(3869),
    [anon_sym_NULL] = ACTIONS(3869),
    [anon_sym_nullptr] = ACTIONS(3869),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3869),
    [anon_sym_let] = ACTIONS(3869),
    [anon_sym_This] = ACTIONS(3869),
    [anon_sym_decltype] = ACTIONS(3869),
    [anon_sym_explicit] = ACTIONS(3869),
    [anon_sym_typename] = ACTIONS(3869),
    [anon_sym_template] = ACTIONS(3869),
    [anon_sym_operator] = ACTIONS(3869),
    [anon_sym_try] = ACTIONS(3869),
    [anon_sym_delete] = ACTIONS(3869),
    [anon_sym_throw] = ACTIONS(3869),
    [anon_sym_namespace] = ACTIONS(3869),
    [anon_sym_static_assert] = ACTIONS(3869),
    [anon_sym_concept] = ACTIONS(3869),
    [anon_sym_co_return] = ACTIONS(3869),
    [anon_sym_co_yield] = ACTIONS(3869),
    [anon_sym_R_DQUOTE] = ACTIONS(3871),
    [anon_sym_LR_DQUOTE] = ACTIONS(3871),
    [anon_sym_uR_DQUOTE] = ACTIONS(3871),
    [anon_sym_UR_DQUOTE] = ACTIONS(3871),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3871),
    [anon_sym_co_await] = ACTIONS(3869),
    [anon_sym_new] = ACTIONS(3869),
    [anon_sym_requires] = ACTIONS(3869),
    [sym_this] = ACTIONS(3869),
    [anon_sym_discard] = ACTIONS(3869),
    [anon_sym_precise] = ACTIONS(3869),
    [anon_sym_shared] = ACTIONS(3869),
    [anon_sym_groupshared] = ACTIONS(3869),
    [anon_sym_uniform] = ACTIONS(3869),
    [anon_sym_row_major] = ACTIONS(3869),
    [anon_sym_column_major] = ACTIONS(3869),
    [anon_sym_globallycoherent] = ACTIONS(3869),
    [anon_sym_centroid] = ACTIONS(3869),
    [anon_sym_noperspective] = ACTIONS(3869),
    [anon_sym_nointerpolation] = ACTIONS(3869),
    [anon_sym_sample] = ACTIONS(3869),
    [anon_sym_linear] = ACTIONS(3869),
    [anon_sym_snorm] = ACTIONS(3869),
    [anon_sym_unorm] = ACTIONS(3869),
    [anon_sym_point] = ACTIONS(3869),
    [anon_sym_line] = ACTIONS(3869),
    [anon_sym_triangleadj] = ACTIONS(3869),
    [anon_sym_lineadj] = ACTIONS(3869),
    [anon_sym_triangle] = ACTIONS(3869),
    [anon_sym_cbuffer] = ACTIONS(3869),
    [anon_sym_interface] = ACTIONS(3869),
    [anon_sym_extension] = ACTIONS(3869),
  },
  [963] = {
    [sym_identifier] = ACTIONS(3983),
    [aux_sym_preproc_include_token1] = ACTIONS(3983),
    [aux_sym_preproc_def_token1] = ACTIONS(3983),
    [aux_sym_preproc_if_token1] = ACTIONS(3983),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3983),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3983),
    [sym_preproc_directive] = ACTIONS(3983),
    [anon_sym_LPAREN2] = ACTIONS(3985),
    [anon_sym_BANG] = ACTIONS(3985),
    [anon_sym_TILDE] = ACTIONS(3985),
    [anon_sym_DASH] = ACTIONS(3983),
    [anon_sym_PLUS] = ACTIONS(3983),
    [anon_sym_STAR] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3983),
    [anon_sym_SEMI] = ACTIONS(3985),
    [anon_sym___extension__] = ACTIONS(3983),
    [anon_sym_typedef] = ACTIONS(3983),
    [anon_sym_in] = ACTIONS(3983),
    [anon_sym_out] = ACTIONS(3983),
    [anon_sym_inout] = ACTIONS(3983),
    [anon_sym_virtual] = ACTIONS(3983),
    [anon_sym_extern] = ACTIONS(3983),
    [anon_sym___attribute__] = ACTIONS(3983),
    [anon_sym___attribute] = ACTIONS(3983),
    [anon_sym_using] = ACTIONS(3983),
    [anon_sym_COLON_COLON] = ACTIONS(3985),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3985),
    [anon_sym___declspec] = ACTIONS(3983),
    [anon_sym___based] = ACTIONS(3983),
    [anon_sym___cdecl] = ACTIONS(3983),
    [anon_sym___clrcall] = ACTIONS(3983),
    [anon_sym___stdcall] = ACTIONS(3983),
    [anon_sym___fastcall] = ACTIONS(3983),
    [anon_sym___thiscall] = ACTIONS(3983),
    [anon_sym___vectorcall] = ACTIONS(3983),
    [anon_sym_LBRACE] = ACTIONS(3985),
    [anon_sym_RBRACE] = ACTIONS(3985),
    [anon_sym_signed] = ACTIONS(3983),
    [anon_sym_unsigned] = ACTIONS(3983),
    [anon_sym_long] = ACTIONS(3983),
    [anon_sym_short] = ACTIONS(3983),
    [anon_sym_LBRACK] = ACTIONS(3983),
    [anon_sym_static] = ACTIONS(3983),
    [anon_sym_register] = ACTIONS(3983),
    [anon_sym_inline] = ACTIONS(3983),
    [anon_sym___inline] = ACTIONS(3983),
    [anon_sym___inline__] = ACTIONS(3983),
    [anon_sym___forceinline] = ACTIONS(3983),
    [anon_sym_thread_local] = ACTIONS(3983),
    [anon_sym___thread] = ACTIONS(3983),
    [anon_sym_const] = ACTIONS(3983),
    [anon_sym_constexpr] = ACTIONS(3983),
    [anon_sym_volatile] = ACTIONS(3983),
    [anon_sym_restrict] = ACTIONS(3983),
    [anon_sym___restrict__] = ACTIONS(3983),
    [anon_sym__Atomic] = ACTIONS(3983),
    [anon_sym__Noreturn] = ACTIONS(3983),
    [anon_sym_noreturn] = ACTIONS(3983),
    [anon_sym__Nonnull] = ACTIONS(3983),
    [anon_sym_mutable] = ACTIONS(3983),
    [anon_sym_constinit] = ACTIONS(3983),
    [anon_sym_consteval] = ACTIONS(3983),
    [anon_sym_alignas] = ACTIONS(3983),
    [anon_sym__Alignas] = ACTIONS(3983),
    [sym_primitive_type] = ACTIONS(3983),
    [anon_sym_enum] = ACTIONS(3983),
    [anon_sym_class] = ACTIONS(3983),
    [anon_sym_struct] = ACTIONS(3983),
    [anon_sym_union] = ACTIONS(3983),
    [anon_sym_if] = ACTIONS(3983),
    [anon_sym_switch] = ACTIONS(3983),
    [anon_sym_case] = ACTIONS(3983),
    [anon_sym_default] = ACTIONS(3983),
    [anon_sym_while] = ACTIONS(3983),
    [anon_sym_do] = ACTIONS(3983),
    [anon_sym_for] = ACTIONS(3983),
    [anon_sym_return] = ACTIONS(3983),
    [anon_sym_break] = ACTIONS(3983),
    [anon_sym_continue] = ACTIONS(3983),
    [anon_sym_goto] = ACTIONS(3983),
    [anon_sym___try] = ACTIONS(3983),
    [anon_sym___leave] = ACTIONS(3983),
    [anon_sym_not] = ACTIONS(3983),
    [anon_sym_compl] = ACTIONS(3983),
    [anon_sym_DASH_DASH] = ACTIONS(3985),
    [anon_sym_PLUS_PLUS] = ACTIONS(3985),
    [anon_sym_sizeof] = ACTIONS(3983),
    [anon_sym___alignof__] = ACTIONS(3983),
    [anon_sym___alignof] = ACTIONS(3983),
    [anon_sym__alignof] = ACTIONS(3983),
    [anon_sym_alignof] = ACTIONS(3983),
    [anon_sym__Alignof] = ACTIONS(3983),
    [anon_sym_offsetof] = ACTIONS(3983),
    [anon_sym__Generic] = ACTIONS(3983),
    [anon_sym_asm] = ACTIONS(3983),
    [anon_sym___asm__] = ACTIONS(3983),
    [anon_sym___asm] = ACTIONS(3983),
    [sym_number_literal] = ACTIONS(3985),
    [anon_sym_L_SQUOTE] = ACTIONS(3985),
    [anon_sym_u_SQUOTE] = ACTIONS(3985),
    [anon_sym_U_SQUOTE] = ACTIONS(3985),
    [anon_sym_u8_SQUOTE] = ACTIONS(3985),
    [anon_sym_SQUOTE] = ACTIONS(3985),
    [anon_sym_L_DQUOTE] = ACTIONS(3985),
    [anon_sym_u_DQUOTE] = ACTIONS(3985),
    [anon_sym_U_DQUOTE] = ACTIONS(3985),
    [anon_sym_u8_DQUOTE] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [sym_true] = ACTIONS(3983),
    [sym_false] = ACTIONS(3983),
    [anon_sym_NULL] = ACTIONS(3983),
    [anon_sym_nullptr] = ACTIONS(3983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3983),
    [anon_sym_let] = ACTIONS(3983),
    [anon_sym_This] = ACTIONS(3983),
    [anon_sym_decltype] = ACTIONS(3983),
    [anon_sym_explicit] = ACTIONS(3983),
    [anon_sym_typename] = ACTIONS(3983),
    [anon_sym_template] = ACTIONS(3983),
    [anon_sym_operator] = ACTIONS(3983),
    [anon_sym_try] = ACTIONS(3983),
    [anon_sym_delete] = ACTIONS(3983),
    [anon_sym_throw] = ACTIONS(3983),
    [anon_sym_namespace] = ACTIONS(3983),
    [anon_sym_static_assert] = ACTIONS(3983),
    [anon_sym_concept] = ACTIONS(3983),
    [anon_sym_co_return] = ACTIONS(3983),
    [anon_sym_co_yield] = ACTIONS(3983),
    [anon_sym_R_DQUOTE] = ACTIONS(3985),
    [anon_sym_LR_DQUOTE] = ACTIONS(3985),
    [anon_sym_uR_DQUOTE] = ACTIONS(3985),
    [anon_sym_UR_DQUOTE] = ACTIONS(3985),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3985),
    [anon_sym_co_await] = ACTIONS(3983),
    [anon_sym_new] = ACTIONS(3983),
    [anon_sym_requires] = ACTIONS(3983),
    [sym_this] = ACTIONS(3983),
    [anon_sym_discard] = ACTIONS(3983),
    [anon_sym_precise] = ACTIONS(3983),
    [anon_sym_shared] = ACTIONS(3983),
    [anon_sym_groupshared] = ACTIONS(3983),
    [anon_sym_uniform] = ACTIONS(3983),
    [anon_sym_row_major] = ACTIONS(3983),
    [anon_sym_column_major] = ACTIONS(3983),
    [anon_sym_globallycoherent] = ACTIONS(3983),
    [anon_sym_centroid] = ACTIONS(3983),
    [anon_sym_noperspective] = ACTIONS(3983),
    [anon_sym_nointerpolation] = ACTIONS(3983),
    [anon_sym_sample] = ACTIONS(3983),
    [anon_sym_linear] = ACTIONS(3983),
    [anon_sym_snorm] = ACTIONS(3983),
    [anon_sym_unorm] = ACTIONS(3983),
    [anon_sym_point] = ACTIONS(3983),
    [anon_sym_line] = ACTIONS(3983),
    [anon_sym_triangleadj] = ACTIONS(3983),
    [anon_sym_lineadj] = ACTIONS(3983),
    [anon_sym_triangle] = ACTIONS(3983),
    [anon_sym_cbuffer] = ACTIONS(3983),
    [anon_sym_interface] = ACTIONS(3983),
    [anon_sym_extension] = ACTIONS(3983),
  },
  [964] = {
    [sym_identifier] = ACTIONS(3977),
    [aux_sym_preproc_include_token1] = ACTIONS(3977),
    [aux_sym_preproc_def_token1] = ACTIONS(3977),
    [aux_sym_preproc_if_token1] = ACTIONS(3977),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3977),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3977),
    [sym_preproc_directive] = ACTIONS(3977),
    [anon_sym_LPAREN2] = ACTIONS(3979),
    [anon_sym_BANG] = ACTIONS(3979),
    [anon_sym_TILDE] = ACTIONS(3979),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_PLUS] = ACTIONS(3977),
    [anon_sym_STAR] = ACTIONS(3979),
    [anon_sym_AMP_AMP] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3977),
    [anon_sym_SEMI] = ACTIONS(3979),
    [anon_sym___extension__] = ACTIONS(3977),
    [anon_sym_typedef] = ACTIONS(3977),
    [anon_sym_in] = ACTIONS(3977),
    [anon_sym_out] = ACTIONS(3977),
    [anon_sym_inout] = ACTIONS(3977),
    [anon_sym_virtual] = ACTIONS(3977),
    [anon_sym_extern] = ACTIONS(3977),
    [anon_sym___attribute__] = ACTIONS(3977),
    [anon_sym___attribute] = ACTIONS(3977),
    [anon_sym_using] = ACTIONS(3977),
    [anon_sym_COLON_COLON] = ACTIONS(3979),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3979),
    [anon_sym___declspec] = ACTIONS(3977),
    [anon_sym___based] = ACTIONS(3977),
    [anon_sym___cdecl] = ACTIONS(3977),
    [anon_sym___clrcall] = ACTIONS(3977),
    [anon_sym___stdcall] = ACTIONS(3977),
    [anon_sym___fastcall] = ACTIONS(3977),
    [anon_sym___thiscall] = ACTIONS(3977),
    [anon_sym___vectorcall] = ACTIONS(3977),
    [anon_sym_LBRACE] = ACTIONS(3979),
    [anon_sym_RBRACE] = ACTIONS(3979),
    [anon_sym_signed] = ACTIONS(3977),
    [anon_sym_unsigned] = ACTIONS(3977),
    [anon_sym_long] = ACTIONS(3977),
    [anon_sym_short] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3977),
    [anon_sym_static] = ACTIONS(3977),
    [anon_sym_register] = ACTIONS(3977),
    [anon_sym_inline] = ACTIONS(3977),
    [anon_sym___inline] = ACTIONS(3977),
    [anon_sym___inline__] = ACTIONS(3977),
    [anon_sym___forceinline] = ACTIONS(3977),
    [anon_sym_thread_local] = ACTIONS(3977),
    [anon_sym___thread] = ACTIONS(3977),
    [anon_sym_const] = ACTIONS(3977),
    [anon_sym_constexpr] = ACTIONS(3977),
    [anon_sym_volatile] = ACTIONS(3977),
    [anon_sym_restrict] = ACTIONS(3977),
    [anon_sym___restrict__] = ACTIONS(3977),
    [anon_sym__Atomic] = ACTIONS(3977),
    [anon_sym__Noreturn] = ACTIONS(3977),
    [anon_sym_noreturn] = ACTIONS(3977),
    [anon_sym__Nonnull] = ACTIONS(3977),
    [anon_sym_mutable] = ACTIONS(3977),
    [anon_sym_constinit] = ACTIONS(3977),
    [anon_sym_consteval] = ACTIONS(3977),
    [anon_sym_alignas] = ACTIONS(3977),
    [anon_sym__Alignas] = ACTIONS(3977),
    [sym_primitive_type] = ACTIONS(3977),
    [anon_sym_enum] = ACTIONS(3977),
    [anon_sym_class] = ACTIONS(3977),
    [anon_sym_struct] = ACTIONS(3977),
    [anon_sym_union] = ACTIONS(3977),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_switch] = ACTIONS(3977),
    [anon_sym_case] = ACTIONS(3977),
    [anon_sym_default] = ACTIONS(3977),
    [anon_sym_while] = ACTIONS(3977),
    [anon_sym_do] = ACTIONS(3977),
    [anon_sym_for] = ACTIONS(3977),
    [anon_sym_return] = ACTIONS(3977),
    [anon_sym_break] = ACTIONS(3977),
    [anon_sym_continue] = ACTIONS(3977),
    [anon_sym_goto] = ACTIONS(3977),
    [anon_sym___try] = ACTIONS(3977),
    [anon_sym___leave] = ACTIONS(3977),
    [anon_sym_not] = ACTIONS(3977),
    [anon_sym_compl] = ACTIONS(3977),
    [anon_sym_DASH_DASH] = ACTIONS(3979),
    [anon_sym_PLUS_PLUS] = ACTIONS(3979),
    [anon_sym_sizeof] = ACTIONS(3977),
    [anon_sym___alignof__] = ACTIONS(3977),
    [anon_sym___alignof] = ACTIONS(3977),
    [anon_sym__alignof] = ACTIONS(3977),
    [anon_sym_alignof] = ACTIONS(3977),
    [anon_sym__Alignof] = ACTIONS(3977),
    [anon_sym_offsetof] = ACTIONS(3977),
    [anon_sym__Generic] = ACTIONS(3977),
    [anon_sym_asm] = ACTIONS(3977),
    [anon_sym___asm__] = ACTIONS(3977),
    [anon_sym___asm] = ACTIONS(3977),
    [sym_number_literal] = ACTIONS(3979),
    [anon_sym_L_SQUOTE] = ACTIONS(3979),
    [anon_sym_u_SQUOTE] = ACTIONS(3979),
    [anon_sym_U_SQUOTE] = ACTIONS(3979),
    [anon_sym_u8_SQUOTE] = ACTIONS(3979),
    [anon_sym_SQUOTE] = ACTIONS(3979),
    [anon_sym_L_DQUOTE] = ACTIONS(3979),
    [anon_sym_u_DQUOTE] = ACTIONS(3979),
    [anon_sym_U_DQUOTE] = ACTIONS(3979),
    [anon_sym_u8_DQUOTE] = ACTIONS(3979),
    [anon_sym_DQUOTE] = ACTIONS(3979),
    [sym_true] = ACTIONS(3977),
    [sym_false] = ACTIONS(3977),
    [anon_sym_NULL] = ACTIONS(3977),
    [anon_sym_nullptr] = ACTIONS(3977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3977),
    [anon_sym_let] = ACTIONS(3977),
    [anon_sym_This] = ACTIONS(3977),
    [anon_sym_decltype] = ACTIONS(3977),
    [anon_sym_explicit] = ACTIONS(3977),
    [anon_sym_typename] = ACTIONS(3977),
    [anon_sym_template] = ACTIONS(3977),
    [anon_sym_operator] = ACTIONS(3977),
    [anon_sym_try] = ACTIONS(3977),
    [anon_sym_delete] = ACTIONS(3977),
    [anon_sym_throw] = ACTIONS(3977),
    [anon_sym_namespace] = ACTIONS(3977),
    [anon_sym_static_assert] = ACTIONS(3977),
    [anon_sym_concept] = ACTIONS(3977),
    [anon_sym_co_return] = ACTIONS(3977),
    [anon_sym_co_yield] = ACTIONS(3977),
    [anon_sym_R_DQUOTE] = ACTIONS(3979),
    [anon_sym_LR_DQUOTE] = ACTIONS(3979),
    [anon_sym_uR_DQUOTE] = ACTIONS(3979),
    [anon_sym_UR_DQUOTE] = ACTIONS(3979),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3979),
    [anon_sym_co_await] = ACTIONS(3977),
    [anon_sym_new] = ACTIONS(3977),
    [anon_sym_requires] = ACTIONS(3977),
    [sym_this] = ACTIONS(3977),
    [anon_sym_discard] = ACTIONS(3977),
    [anon_sym_precise] = ACTIONS(3977),
    [anon_sym_shared] = ACTIONS(3977),
    [anon_sym_groupshared] = ACTIONS(3977),
    [anon_sym_uniform] = ACTIONS(3977),
    [anon_sym_row_major] = ACTIONS(3977),
    [anon_sym_column_major] = ACTIONS(3977),
    [anon_sym_globallycoherent] = ACTIONS(3977),
    [anon_sym_centroid] = ACTIONS(3977),
    [anon_sym_noperspective] = ACTIONS(3977),
    [anon_sym_nointerpolation] = ACTIONS(3977),
    [anon_sym_sample] = ACTIONS(3977),
    [anon_sym_linear] = ACTIONS(3977),
    [anon_sym_snorm] = ACTIONS(3977),
    [anon_sym_unorm] = ACTIONS(3977),
    [anon_sym_point] = ACTIONS(3977),
    [anon_sym_line] = ACTIONS(3977),
    [anon_sym_triangleadj] = ACTIONS(3977),
    [anon_sym_lineadj] = ACTIONS(3977),
    [anon_sym_triangle] = ACTIONS(3977),
    [anon_sym_cbuffer] = ACTIONS(3977),
    [anon_sym_interface] = ACTIONS(3977),
    [anon_sym_extension] = ACTIONS(3977),
  },
  [965] = {
    [sym_identifier] = ACTIONS(3771),
    [aux_sym_preproc_include_token1] = ACTIONS(3771),
    [aux_sym_preproc_def_token1] = ACTIONS(3771),
    [aux_sym_preproc_if_token1] = ACTIONS(3771),
    [aux_sym_preproc_if_token2] = ACTIONS(3771),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3771),
    [sym_preproc_directive] = ACTIONS(3771),
    [anon_sym_LPAREN2] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(3773),
    [anon_sym_TILDE] = ACTIONS(3773),
    [anon_sym_DASH] = ACTIONS(3771),
    [anon_sym_PLUS] = ACTIONS(3771),
    [anon_sym_STAR] = ACTIONS(3773),
    [anon_sym_AMP_AMP] = ACTIONS(3773),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_SEMI] = ACTIONS(3773),
    [anon_sym___extension__] = ACTIONS(3771),
    [anon_sym_typedef] = ACTIONS(3771),
    [anon_sym_in] = ACTIONS(3771),
    [anon_sym_out] = ACTIONS(3771),
    [anon_sym_inout] = ACTIONS(3771),
    [anon_sym_virtual] = ACTIONS(3771),
    [anon_sym_extern] = ACTIONS(3771),
    [anon_sym___attribute__] = ACTIONS(3771),
    [anon_sym___attribute] = ACTIONS(3771),
    [anon_sym_using] = ACTIONS(3771),
    [anon_sym_COLON_COLON] = ACTIONS(3773),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3773),
    [anon_sym___declspec] = ACTIONS(3771),
    [anon_sym___based] = ACTIONS(3771),
    [anon_sym___cdecl] = ACTIONS(3771),
    [anon_sym___clrcall] = ACTIONS(3771),
    [anon_sym___stdcall] = ACTIONS(3771),
    [anon_sym___fastcall] = ACTIONS(3771),
    [anon_sym___thiscall] = ACTIONS(3771),
    [anon_sym___vectorcall] = ACTIONS(3771),
    [anon_sym_LBRACE] = ACTIONS(3773),
    [anon_sym_signed] = ACTIONS(3771),
    [anon_sym_unsigned] = ACTIONS(3771),
    [anon_sym_long] = ACTIONS(3771),
    [anon_sym_short] = ACTIONS(3771),
    [anon_sym_LBRACK] = ACTIONS(3771),
    [anon_sym_static] = ACTIONS(3771),
    [anon_sym_register] = ACTIONS(3771),
    [anon_sym_inline] = ACTIONS(3771),
    [anon_sym___inline] = ACTIONS(3771),
    [anon_sym___inline__] = ACTIONS(3771),
    [anon_sym___forceinline] = ACTIONS(3771),
    [anon_sym_thread_local] = ACTIONS(3771),
    [anon_sym___thread] = ACTIONS(3771),
    [anon_sym_const] = ACTIONS(3771),
    [anon_sym_constexpr] = ACTIONS(3771),
    [anon_sym_volatile] = ACTIONS(3771),
    [anon_sym_restrict] = ACTIONS(3771),
    [anon_sym___restrict__] = ACTIONS(3771),
    [anon_sym__Atomic] = ACTIONS(3771),
    [anon_sym__Noreturn] = ACTIONS(3771),
    [anon_sym_noreturn] = ACTIONS(3771),
    [anon_sym__Nonnull] = ACTIONS(3771),
    [anon_sym_mutable] = ACTIONS(3771),
    [anon_sym_constinit] = ACTIONS(3771),
    [anon_sym_consteval] = ACTIONS(3771),
    [anon_sym_alignas] = ACTIONS(3771),
    [anon_sym__Alignas] = ACTIONS(3771),
    [sym_primitive_type] = ACTIONS(3771),
    [anon_sym_enum] = ACTIONS(3771),
    [anon_sym_class] = ACTIONS(3771),
    [anon_sym_struct] = ACTIONS(3771),
    [anon_sym_union] = ACTIONS(3771),
    [anon_sym_if] = ACTIONS(3771),
    [anon_sym_switch] = ACTIONS(3771),
    [anon_sym_case] = ACTIONS(3771),
    [anon_sym_default] = ACTIONS(3771),
    [anon_sym_while] = ACTIONS(3771),
    [anon_sym_do] = ACTIONS(3771),
    [anon_sym_for] = ACTIONS(3771),
    [anon_sym_return] = ACTIONS(3771),
    [anon_sym_break] = ACTIONS(3771),
    [anon_sym_continue] = ACTIONS(3771),
    [anon_sym_goto] = ACTIONS(3771),
    [anon_sym___try] = ACTIONS(3771),
    [anon_sym___leave] = ACTIONS(3771),
    [anon_sym_not] = ACTIONS(3771),
    [anon_sym_compl] = ACTIONS(3771),
    [anon_sym_DASH_DASH] = ACTIONS(3773),
    [anon_sym_PLUS_PLUS] = ACTIONS(3773),
    [anon_sym_sizeof] = ACTIONS(3771),
    [anon_sym___alignof__] = ACTIONS(3771),
    [anon_sym___alignof] = ACTIONS(3771),
    [anon_sym__alignof] = ACTIONS(3771),
    [anon_sym_alignof] = ACTIONS(3771),
    [anon_sym__Alignof] = ACTIONS(3771),
    [anon_sym_offsetof] = ACTIONS(3771),
    [anon_sym__Generic] = ACTIONS(3771),
    [anon_sym_asm] = ACTIONS(3771),
    [anon_sym___asm__] = ACTIONS(3771),
    [anon_sym___asm] = ACTIONS(3771),
    [sym_number_literal] = ACTIONS(3773),
    [anon_sym_L_SQUOTE] = ACTIONS(3773),
    [anon_sym_u_SQUOTE] = ACTIONS(3773),
    [anon_sym_U_SQUOTE] = ACTIONS(3773),
    [anon_sym_u8_SQUOTE] = ACTIONS(3773),
    [anon_sym_SQUOTE] = ACTIONS(3773),
    [anon_sym_L_DQUOTE] = ACTIONS(3773),
    [anon_sym_u_DQUOTE] = ACTIONS(3773),
    [anon_sym_U_DQUOTE] = ACTIONS(3773),
    [anon_sym_u8_DQUOTE] = ACTIONS(3773),
    [anon_sym_DQUOTE] = ACTIONS(3773),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [anon_sym_NULL] = ACTIONS(3771),
    [anon_sym_nullptr] = ACTIONS(3771),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3771),
    [anon_sym_let] = ACTIONS(3771),
    [anon_sym_This] = ACTIONS(3771),
    [anon_sym_decltype] = ACTIONS(3771),
    [anon_sym_explicit] = ACTIONS(3771),
    [anon_sym_typename] = ACTIONS(3771),
    [anon_sym_template] = ACTIONS(3771),
    [anon_sym_operator] = ACTIONS(3771),
    [anon_sym_try] = ACTIONS(3771),
    [anon_sym_delete] = ACTIONS(3771),
    [anon_sym_throw] = ACTIONS(3771),
    [anon_sym_namespace] = ACTIONS(3771),
    [anon_sym_static_assert] = ACTIONS(3771),
    [anon_sym_concept] = ACTIONS(3771),
    [anon_sym_co_return] = ACTIONS(3771),
    [anon_sym_co_yield] = ACTIONS(3771),
    [anon_sym_R_DQUOTE] = ACTIONS(3773),
    [anon_sym_LR_DQUOTE] = ACTIONS(3773),
    [anon_sym_uR_DQUOTE] = ACTIONS(3773),
    [anon_sym_UR_DQUOTE] = ACTIONS(3773),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3773),
    [anon_sym_co_await] = ACTIONS(3771),
    [anon_sym_new] = ACTIONS(3771),
    [anon_sym_requires] = ACTIONS(3771),
    [sym_this] = ACTIONS(3771),
    [anon_sym_discard] = ACTIONS(3771),
    [anon_sym_precise] = ACTIONS(3771),
    [anon_sym_shared] = ACTIONS(3771),
    [anon_sym_groupshared] = ACTIONS(3771),
    [anon_sym_uniform] = ACTIONS(3771),
    [anon_sym_row_major] = ACTIONS(3771),
    [anon_sym_column_major] = ACTIONS(3771),
    [anon_sym_globallycoherent] = ACTIONS(3771),
    [anon_sym_centroid] = ACTIONS(3771),
    [anon_sym_noperspective] = ACTIONS(3771),
    [anon_sym_nointerpolation] = ACTIONS(3771),
    [anon_sym_sample] = ACTIONS(3771),
    [anon_sym_linear] = ACTIONS(3771),
    [anon_sym_snorm] = ACTIONS(3771),
    [anon_sym_unorm] = ACTIONS(3771),
    [anon_sym_point] = ACTIONS(3771),
    [anon_sym_line] = ACTIONS(3771),
    [anon_sym_triangleadj] = ACTIONS(3771),
    [anon_sym_lineadj] = ACTIONS(3771),
    [anon_sym_triangle] = ACTIONS(3771),
    [anon_sym_cbuffer] = ACTIONS(3771),
    [anon_sym_interface] = ACTIONS(3771),
    [anon_sym_extension] = ACTIONS(3771),
  },
  [966] = {
    [sym_identifier] = ACTIONS(3763),
    [aux_sym_preproc_include_token1] = ACTIONS(3763),
    [aux_sym_preproc_def_token1] = ACTIONS(3763),
    [aux_sym_preproc_if_token1] = ACTIONS(3763),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3763),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3763),
    [sym_preproc_directive] = ACTIONS(3763),
    [anon_sym_LPAREN2] = ACTIONS(3765),
    [anon_sym_BANG] = ACTIONS(3765),
    [anon_sym_TILDE] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3763),
    [anon_sym_STAR] = ACTIONS(3765),
    [anon_sym_AMP_AMP] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3763),
    [anon_sym_SEMI] = ACTIONS(3765),
    [anon_sym___extension__] = ACTIONS(3763),
    [anon_sym_typedef] = ACTIONS(3763),
    [anon_sym_in] = ACTIONS(3763),
    [anon_sym_out] = ACTIONS(3763),
    [anon_sym_inout] = ACTIONS(3763),
    [anon_sym_virtual] = ACTIONS(3763),
    [anon_sym_extern] = ACTIONS(3763),
    [anon_sym___attribute__] = ACTIONS(3763),
    [anon_sym___attribute] = ACTIONS(3763),
    [anon_sym_using] = ACTIONS(3763),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3765),
    [anon_sym___declspec] = ACTIONS(3763),
    [anon_sym___based] = ACTIONS(3763),
    [anon_sym___cdecl] = ACTIONS(3763),
    [anon_sym___clrcall] = ACTIONS(3763),
    [anon_sym___stdcall] = ACTIONS(3763),
    [anon_sym___fastcall] = ACTIONS(3763),
    [anon_sym___thiscall] = ACTIONS(3763),
    [anon_sym___vectorcall] = ACTIONS(3763),
    [anon_sym_LBRACE] = ACTIONS(3765),
    [anon_sym_RBRACE] = ACTIONS(3765),
    [anon_sym_signed] = ACTIONS(3763),
    [anon_sym_unsigned] = ACTIONS(3763),
    [anon_sym_long] = ACTIONS(3763),
    [anon_sym_short] = ACTIONS(3763),
    [anon_sym_LBRACK] = ACTIONS(3763),
    [anon_sym_static] = ACTIONS(3763),
    [anon_sym_register] = ACTIONS(3763),
    [anon_sym_inline] = ACTIONS(3763),
    [anon_sym___inline] = ACTIONS(3763),
    [anon_sym___inline__] = ACTIONS(3763),
    [anon_sym___forceinline] = ACTIONS(3763),
    [anon_sym_thread_local] = ACTIONS(3763),
    [anon_sym___thread] = ACTIONS(3763),
    [anon_sym_const] = ACTIONS(3763),
    [anon_sym_constexpr] = ACTIONS(3763),
    [anon_sym_volatile] = ACTIONS(3763),
    [anon_sym_restrict] = ACTIONS(3763),
    [anon_sym___restrict__] = ACTIONS(3763),
    [anon_sym__Atomic] = ACTIONS(3763),
    [anon_sym__Noreturn] = ACTIONS(3763),
    [anon_sym_noreturn] = ACTIONS(3763),
    [anon_sym__Nonnull] = ACTIONS(3763),
    [anon_sym_mutable] = ACTIONS(3763),
    [anon_sym_constinit] = ACTIONS(3763),
    [anon_sym_consteval] = ACTIONS(3763),
    [anon_sym_alignas] = ACTIONS(3763),
    [anon_sym__Alignas] = ACTIONS(3763),
    [sym_primitive_type] = ACTIONS(3763),
    [anon_sym_enum] = ACTIONS(3763),
    [anon_sym_class] = ACTIONS(3763),
    [anon_sym_struct] = ACTIONS(3763),
    [anon_sym_union] = ACTIONS(3763),
    [anon_sym_if] = ACTIONS(3763),
    [anon_sym_switch] = ACTIONS(3763),
    [anon_sym_case] = ACTIONS(3763),
    [anon_sym_default] = ACTIONS(3763),
    [anon_sym_while] = ACTIONS(3763),
    [anon_sym_do] = ACTIONS(3763),
    [anon_sym_for] = ACTIONS(3763),
    [anon_sym_return] = ACTIONS(3763),
    [anon_sym_break] = ACTIONS(3763),
    [anon_sym_continue] = ACTIONS(3763),
    [anon_sym_goto] = ACTIONS(3763),
    [anon_sym___try] = ACTIONS(3763),
    [anon_sym___leave] = ACTIONS(3763),
    [anon_sym_not] = ACTIONS(3763),
    [anon_sym_compl] = ACTIONS(3763),
    [anon_sym_DASH_DASH] = ACTIONS(3765),
    [anon_sym_PLUS_PLUS] = ACTIONS(3765),
    [anon_sym_sizeof] = ACTIONS(3763),
    [anon_sym___alignof__] = ACTIONS(3763),
    [anon_sym___alignof] = ACTIONS(3763),
    [anon_sym__alignof] = ACTIONS(3763),
    [anon_sym_alignof] = ACTIONS(3763),
    [anon_sym__Alignof] = ACTIONS(3763),
    [anon_sym_offsetof] = ACTIONS(3763),
    [anon_sym__Generic] = ACTIONS(3763),
    [anon_sym_asm] = ACTIONS(3763),
    [anon_sym___asm__] = ACTIONS(3763),
    [anon_sym___asm] = ACTIONS(3763),
    [sym_number_literal] = ACTIONS(3765),
    [anon_sym_L_SQUOTE] = ACTIONS(3765),
    [anon_sym_u_SQUOTE] = ACTIONS(3765),
    [anon_sym_U_SQUOTE] = ACTIONS(3765),
    [anon_sym_u8_SQUOTE] = ACTIONS(3765),
    [anon_sym_SQUOTE] = ACTIONS(3765),
    [anon_sym_L_DQUOTE] = ACTIONS(3765),
    [anon_sym_u_DQUOTE] = ACTIONS(3765),
    [anon_sym_U_DQUOTE] = ACTIONS(3765),
    [anon_sym_u8_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE] = ACTIONS(3765),
    [sym_true] = ACTIONS(3763),
    [sym_false] = ACTIONS(3763),
    [anon_sym_NULL] = ACTIONS(3763),
    [anon_sym_nullptr] = ACTIONS(3763),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3763),
    [anon_sym_let] = ACTIONS(3763),
    [anon_sym_This] = ACTIONS(3763),
    [anon_sym_decltype] = ACTIONS(3763),
    [anon_sym_explicit] = ACTIONS(3763),
    [anon_sym_typename] = ACTIONS(3763),
    [anon_sym_template] = ACTIONS(3763),
    [anon_sym_operator] = ACTIONS(3763),
    [anon_sym_try] = ACTIONS(3763),
    [anon_sym_delete] = ACTIONS(3763),
    [anon_sym_throw] = ACTIONS(3763),
    [anon_sym_namespace] = ACTIONS(3763),
    [anon_sym_static_assert] = ACTIONS(3763),
    [anon_sym_concept] = ACTIONS(3763),
    [anon_sym_co_return] = ACTIONS(3763),
    [anon_sym_co_yield] = ACTIONS(3763),
    [anon_sym_R_DQUOTE] = ACTIONS(3765),
    [anon_sym_LR_DQUOTE] = ACTIONS(3765),
    [anon_sym_uR_DQUOTE] = ACTIONS(3765),
    [anon_sym_UR_DQUOTE] = ACTIONS(3765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3765),
    [anon_sym_co_await] = ACTIONS(3763),
    [anon_sym_new] = ACTIONS(3763),
    [anon_sym_requires] = ACTIONS(3763),
    [sym_this] = ACTIONS(3763),
    [anon_sym_discard] = ACTIONS(3763),
    [anon_sym_precise] = ACTIONS(3763),
    [anon_sym_shared] = ACTIONS(3763),
    [anon_sym_groupshared] = ACTIONS(3763),
    [anon_sym_uniform] = ACTIONS(3763),
    [anon_sym_row_major] = ACTIONS(3763),
    [anon_sym_column_major] = ACTIONS(3763),
    [anon_sym_globallycoherent] = ACTIONS(3763),
    [anon_sym_centroid] = ACTIONS(3763),
    [anon_sym_noperspective] = ACTIONS(3763),
    [anon_sym_nointerpolation] = ACTIONS(3763),
    [anon_sym_sample] = ACTIONS(3763),
    [anon_sym_linear] = ACTIONS(3763),
    [anon_sym_snorm] = ACTIONS(3763),
    [anon_sym_unorm] = ACTIONS(3763),
    [anon_sym_point] = ACTIONS(3763),
    [anon_sym_line] = ACTIONS(3763),
    [anon_sym_triangleadj] = ACTIONS(3763),
    [anon_sym_lineadj] = ACTIONS(3763),
    [anon_sym_triangle] = ACTIONS(3763),
    [anon_sym_cbuffer] = ACTIONS(3763),
    [anon_sym_interface] = ACTIONS(3763),
    [anon_sym_extension] = ACTIONS(3763),
  },
  [967] = {
    [sym_identifier] = ACTIONS(3873),
    [aux_sym_preproc_include_token1] = ACTIONS(3873),
    [aux_sym_preproc_def_token1] = ACTIONS(3873),
    [aux_sym_preproc_if_token1] = ACTIONS(3873),
    [aux_sym_preproc_if_token2] = ACTIONS(3873),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3873),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3873),
    [sym_preproc_directive] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(3875),
    [anon_sym_BANG] = ACTIONS(3875),
    [anon_sym_TILDE] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3873),
    [anon_sym_PLUS] = ACTIONS(3873),
    [anon_sym_STAR] = ACTIONS(3875),
    [anon_sym_AMP_AMP] = ACTIONS(3875),
    [anon_sym_AMP] = ACTIONS(3873),
    [anon_sym_SEMI] = ACTIONS(3875),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_typedef] = ACTIONS(3873),
    [anon_sym_in] = ACTIONS(3873),
    [anon_sym_out] = ACTIONS(3873),
    [anon_sym_inout] = ACTIONS(3873),
    [anon_sym_virtual] = ACTIONS(3873),
    [anon_sym_extern] = ACTIONS(3873),
    [anon_sym___attribute__] = ACTIONS(3873),
    [anon_sym___attribute] = ACTIONS(3873),
    [anon_sym_using] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3875),
    [anon_sym___declspec] = ACTIONS(3873),
    [anon_sym___based] = ACTIONS(3873),
    [anon_sym___cdecl] = ACTIONS(3873),
    [anon_sym___clrcall] = ACTIONS(3873),
    [anon_sym___stdcall] = ACTIONS(3873),
    [anon_sym___fastcall] = ACTIONS(3873),
    [anon_sym___thiscall] = ACTIONS(3873),
    [anon_sym___vectorcall] = ACTIONS(3873),
    [anon_sym_LBRACE] = ACTIONS(3875),
    [anon_sym_signed] = ACTIONS(3873),
    [anon_sym_unsigned] = ACTIONS(3873),
    [anon_sym_long] = ACTIONS(3873),
    [anon_sym_short] = ACTIONS(3873),
    [anon_sym_LBRACK] = ACTIONS(3873),
    [anon_sym_static] = ACTIONS(3873),
    [anon_sym_register] = ACTIONS(3873),
    [anon_sym_inline] = ACTIONS(3873),
    [anon_sym___inline] = ACTIONS(3873),
    [anon_sym___inline__] = ACTIONS(3873),
    [anon_sym___forceinline] = ACTIONS(3873),
    [anon_sym_thread_local] = ACTIONS(3873),
    [anon_sym___thread] = ACTIONS(3873),
    [anon_sym_const] = ACTIONS(3873),
    [anon_sym_constexpr] = ACTIONS(3873),
    [anon_sym_volatile] = ACTIONS(3873),
    [anon_sym_restrict] = ACTIONS(3873),
    [anon_sym___restrict__] = ACTIONS(3873),
    [anon_sym__Atomic] = ACTIONS(3873),
    [anon_sym__Noreturn] = ACTIONS(3873),
    [anon_sym_noreturn] = ACTIONS(3873),
    [anon_sym__Nonnull] = ACTIONS(3873),
    [anon_sym_mutable] = ACTIONS(3873),
    [anon_sym_constinit] = ACTIONS(3873),
    [anon_sym_consteval] = ACTIONS(3873),
    [anon_sym_alignas] = ACTIONS(3873),
    [anon_sym__Alignas] = ACTIONS(3873),
    [sym_primitive_type] = ACTIONS(3873),
    [anon_sym_enum] = ACTIONS(3873),
    [anon_sym_class] = ACTIONS(3873),
    [anon_sym_struct] = ACTIONS(3873),
    [anon_sym_union] = ACTIONS(3873),
    [anon_sym_if] = ACTIONS(3873),
    [anon_sym_switch] = ACTIONS(3873),
    [anon_sym_case] = ACTIONS(3873),
    [anon_sym_default] = ACTIONS(3873),
    [anon_sym_while] = ACTIONS(3873),
    [anon_sym_do] = ACTIONS(3873),
    [anon_sym_for] = ACTIONS(3873),
    [anon_sym_return] = ACTIONS(3873),
    [anon_sym_break] = ACTIONS(3873),
    [anon_sym_continue] = ACTIONS(3873),
    [anon_sym_goto] = ACTIONS(3873),
    [anon_sym___try] = ACTIONS(3873),
    [anon_sym___leave] = ACTIONS(3873),
    [anon_sym_not] = ACTIONS(3873),
    [anon_sym_compl] = ACTIONS(3873),
    [anon_sym_DASH_DASH] = ACTIONS(3875),
    [anon_sym_PLUS_PLUS] = ACTIONS(3875),
    [anon_sym_sizeof] = ACTIONS(3873),
    [anon_sym___alignof__] = ACTIONS(3873),
    [anon_sym___alignof] = ACTIONS(3873),
    [anon_sym__alignof] = ACTIONS(3873),
    [anon_sym_alignof] = ACTIONS(3873),
    [anon_sym__Alignof] = ACTIONS(3873),
    [anon_sym_offsetof] = ACTIONS(3873),
    [anon_sym__Generic] = ACTIONS(3873),
    [anon_sym_asm] = ACTIONS(3873),
    [anon_sym___asm__] = ACTIONS(3873),
    [anon_sym___asm] = ACTIONS(3873),
    [sym_number_literal] = ACTIONS(3875),
    [anon_sym_L_SQUOTE] = ACTIONS(3875),
    [anon_sym_u_SQUOTE] = ACTIONS(3875),
    [anon_sym_U_SQUOTE] = ACTIONS(3875),
    [anon_sym_u8_SQUOTE] = ACTIONS(3875),
    [anon_sym_SQUOTE] = ACTIONS(3875),
    [anon_sym_L_DQUOTE] = ACTIONS(3875),
    [anon_sym_u_DQUOTE] = ACTIONS(3875),
    [anon_sym_U_DQUOTE] = ACTIONS(3875),
    [anon_sym_u8_DQUOTE] = ACTIONS(3875),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_true] = ACTIONS(3873),
    [sym_false] = ACTIONS(3873),
    [anon_sym_NULL] = ACTIONS(3873),
    [anon_sym_nullptr] = ACTIONS(3873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3873),
    [anon_sym_let] = ACTIONS(3873),
    [anon_sym_This] = ACTIONS(3873),
    [anon_sym_decltype] = ACTIONS(3873),
    [anon_sym_explicit] = ACTIONS(3873),
    [anon_sym_typename] = ACTIONS(3873),
    [anon_sym_template] = ACTIONS(3873),
    [anon_sym_operator] = ACTIONS(3873),
    [anon_sym_try] = ACTIONS(3873),
    [anon_sym_delete] = ACTIONS(3873),
    [anon_sym_throw] = ACTIONS(3873),
    [anon_sym_namespace] = ACTIONS(3873),
    [anon_sym_static_assert] = ACTIONS(3873),
    [anon_sym_concept] = ACTIONS(3873),
    [anon_sym_co_return] = ACTIONS(3873),
    [anon_sym_co_yield] = ACTIONS(3873),
    [anon_sym_R_DQUOTE] = ACTIONS(3875),
    [anon_sym_LR_DQUOTE] = ACTIONS(3875),
    [anon_sym_uR_DQUOTE] = ACTIONS(3875),
    [anon_sym_UR_DQUOTE] = ACTIONS(3875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3875),
    [anon_sym_co_await] = ACTIONS(3873),
    [anon_sym_new] = ACTIONS(3873),
    [anon_sym_requires] = ACTIONS(3873),
    [sym_this] = ACTIONS(3873),
    [anon_sym_discard] = ACTIONS(3873),
    [anon_sym_precise] = ACTIONS(3873),
    [anon_sym_shared] = ACTIONS(3873),
    [anon_sym_groupshared] = ACTIONS(3873),
    [anon_sym_uniform] = ACTIONS(3873),
    [anon_sym_row_major] = ACTIONS(3873),
    [anon_sym_column_major] = ACTIONS(3873),
    [anon_sym_globallycoherent] = ACTIONS(3873),
    [anon_sym_centroid] = ACTIONS(3873),
    [anon_sym_noperspective] = ACTIONS(3873),
    [anon_sym_nointerpolation] = ACTIONS(3873),
    [anon_sym_sample] = ACTIONS(3873),
    [anon_sym_linear] = ACTIONS(3873),
    [anon_sym_snorm] = ACTIONS(3873),
    [anon_sym_unorm] = ACTIONS(3873),
    [anon_sym_point] = ACTIONS(3873),
    [anon_sym_line] = ACTIONS(3873),
    [anon_sym_triangleadj] = ACTIONS(3873),
    [anon_sym_lineadj] = ACTIONS(3873),
    [anon_sym_triangle] = ACTIONS(3873),
    [anon_sym_cbuffer] = ACTIONS(3873),
    [anon_sym_interface] = ACTIONS(3873),
    [anon_sym_extension] = ACTIONS(3873),
  },
  [968] = {
    [sym_identifier] = ACTIONS(3719),
    [aux_sym_preproc_include_token1] = ACTIONS(3719),
    [aux_sym_preproc_def_token1] = ACTIONS(3719),
    [aux_sym_preproc_if_token1] = ACTIONS(3719),
    [aux_sym_preproc_if_token2] = ACTIONS(3719),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3719),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3719),
    [sym_preproc_directive] = ACTIONS(3719),
    [anon_sym_LPAREN2] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_TILDE] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3719),
    [anon_sym_SEMI] = ACTIONS(3721),
    [anon_sym___extension__] = ACTIONS(3719),
    [anon_sym_typedef] = ACTIONS(3719),
    [anon_sym_in] = ACTIONS(3719),
    [anon_sym_out] = ACTIONS(3719),
    [anon_sym_inout] = ACTIONS(3719),
    [anon_sym_virtual] = ACTIONS(3719),
    [anon_sym_extern] = ACTIONS(3719),
    [anon_sym___attribute__] = ACTIONS(3719),
    [anon_sym___attribute] = ACTIONS(3719),
    [anon_sym_using] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3721),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3721),
    [anon_sym___declspec] = ACTIONS(3719),
    [anon_sym___based] = ACTIONS(3719),
    [anon_sym___cdecl] = ACTIONS(3719),
    [anon_sym___clrcall] = ACTIONS(3719),
    [anon_sym___stdcall] = ACTIONS(3719),
    [anon_sym___fastcall] = ACTIONS(3719),
    [anon_sym___thiscall] = ACTIONS(3719),
    [anon_sym___vectorcall] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(3721),
    [anon_sym_signed] = ACTIONS(3719),
    [anon_sym_unsigned] = ACTIONS(3719),
    [anon_sym_long] = ACTIONS(3719),
    [anon_sym_short] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_static] = ACTIONS(3719),
    [anon_sym_register] = ACTIONS(3719),
    [anon_sym_inline] = ACTIONS(3719),
    [anon_sym___inline] = ACTIONS(3719),
    [anon_sym___inline__] = ACTIONS(3719),
    [anon_sym___forceinline] = ACTIONS(3719),
    [anon_sym_thread_local] = ACTIONS(3719),
    [anon_sym___thread] = ACTIONS(3719),
    [anon_sym_const] = ACTIONS(3719),
    [anon_sym_constexpr] = ACTIONS(3719),
    [anon_sym_volatile] = ACTIONS(3719),
    [anon_sym_restrict] = ACTIONS(3719),
    [anon_sym___restrict__] = ACTIONS(3719),
    [anon_sym__Atomic] = ACTIONS(3719),
    [anon_sym__Noreturn] = ACTIONS(3719),
    [anon_sym_noreturn] = ACTIONS(3719),
    [anon_sym__Nonnull] = ACTIONS(3719),
    [anon_sym_mutable] = ACTIONS(3719),
    [anon_sym_constinit] = ACTIONS(3719),
    [anon_sym_consteval] = ACTIONS(3719),
    [anon_sym_alignas] = ACTIONS(3719),
    [anon_sym__Alignas] = ACTIONS(3719),
    [sym_primitive_type] = ACTIONS(3719),
    [anon_sym_enum] = ACTIONS(3719),
    [anon_sym_class] = ACTIONS(3719),
    [anon_sym_struct] = ACTIONS(3719),
    [anon_sym_union] = ACTIONS(3719),
    [anon_sym_if] = ACTIONS(3719),
    [anon_sym_switch] = ACTIONS(3719),
    [anon_sym_case] = ACTIONS(3719),
    [anon_sym_default] = ACTIONS(3719),
    [anon_sym_while] = ACTIONS(3719),
    [anon_sym_do] = ACTIONS(3719),
    [anon_sym_for] = ACTIONS(3719),
    [anon_sym_return] = ACTIONS(3719),
    [anon_sym_break] = ACTIONS(3719),
    [anon_sym_continue] = ACTIONS(3719),
    [anon_sym_goto] = ACTIONS(3719),
    [anon_sym___try] = ACTIONS(3719),
    [anon_sym___leave] = ACTIONS(3719),
    [anon_sym_not] = ACTIONS(3719),
    [anon_sym_compl] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3721),
    [anon_sym_sizeof] = ACTIONS(3719),
    [anon_sym___alignof__] = ACTIONS(3719),
    [anon_sym___alignof] = ACTIONS(3719),
    [anon_sym__alignof] = ACTIONS(3719),
    [anon_sym_alignof] = ACTIONS(3719),
    [anon_sym__Alignof] = ACTIONS(3719),
    [anon_sym_offsetof] = ACTIONS(3719),
    [anon_sym__Generic] = ACTIONS(3719),
    [anon_sym_asm] = ACTIONS(3719),
    [anon_sym___asm__] = ACTIONS(3719),
    [anon_sym___asm] = ACTIONS(3719),
    [sym_number_literal] = ACTIONS(3721),
    [anon_sym_L_SQUOTE] = ACTIONS(3721),
    [anon_sym_u_SQUOTE] = ACTIONS(3721),
    [anon_sym_U_SQUOTE] = ACTIONS(3721),
    [anon_sym_u8_SQUOTE] = ACTIONS(3721),
    [anon_sym_SQUOTE] = ACTIONS(3721),
    [anon_sym_L_DQUOTE] = ACTIONS(3721),
    [anon_sym_u_DQUOTE] = ACTIONS(3721),
    [anon_sym_U_DQUOTE] = ACTIONS(3721),
    [anon_sym_u8_DQUOTE] = ACTIONS(3721),
    [anon_sym_DQUOTE] = ACTIONS(3721),
    [sym_true] = ACTIONS(3719),
    [sym_false] = ACTIONS(3719),
    [anon_sym_NULL] = ACTIONS(3719),
    [anon_sym_nullptr] = ACTIONS(3719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3719),
    [anon_sym_let] = ACTIONS(3719),
    [anon_sym_This] = ACTIONS(3719),
    [anon_sym_decltype] = ACTIONS(3719),
    [anon_sym_explicit] = ACTIONS(3719),
    [anon_sym_typename] = ACTIONS(3719),
    [anon_sym_template] = ACTIONS(3719),
    [anon_sym_operator] = ACTIONS(3719),
    [anon_sym_try] = ACTIONS(3719),
    [anon_sym_delete] = ACTIONS(3719),
    [anon_sym_throw] = ACTIONS(3719),
    [anon_sym_namespace] = ACTIONS(3719),
    [anon_sym_static_assert] = ACTIONS(3719),
    [anon_sym_concept] = ACTIONS(3719),
    [anon_sym_co_return] = ACTIONS(3719),
    [anon_sym_co_yield] = ACTIONS(3719),
    [anon_sym_R_DQUOTE] = ACTIONS(3721),
    [anon_sym_LR_DQUOTE] = ACTIONS(3721),
    [anon_sym_uR_DQUOTE] = ACTIONS(3721),
    [anon_sym_UR_DQUOTE] = ACTIONS(3721),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3721),
    [anon_sym_co_await] = ACTIONS(3719),
    [anon_sym_new] = ACTIONS(3719),
    [anon_sym_requires] = ACTIONS(3719),
    [sym_this] = ACTIONS(3719),
    [anon_sym_discard] = ACTIONS(3719),
    [anon_sym_precise] = ACTIONS(3719),
    [anon_sym_shared] = ACTIONS(3719),
    [anon_sym_groupshared] = ACTIONS(3719),
    [anon_sym_uniform] = ACTIONS(3719),
    [anon_sym_row_major] = ACTIONS(3719),
    [anon_sym_column_major] = ACTIONS(3719),
    [anon_sym_globallycoherent] = ACTIONS(3719),
    [anon_sym_centroid] = ACTIONS(3719),
    [anon_sym_noperspective] = ACTIONS(3719),
    [anon_sym_nointerpolation] = ACTIONS(3719),
    [anon_sym_sample] = ACTIONS(3719),
    [anon_sym_linear] = ACTIONS(3719),
    [anon_sym_snorm] = ACTIONS(3719),
    [anon_sym_unorm] = ACTIONS(3719),
    [anon_sym_point] = ACTIONS(3719),
    [anon_sym_line] = ACTIONS(3719),
    [anon_sym_triangleadj] = ACTIONS(3719),
    [anon_sym_lineadj] = ACTIONS(3719),
    [anon_sym_triangle] = ACTIONS(3719),
    [anon_sym_cbuffer] = ACTIONS(3719),
    [anon_sym_interface] = ACTIONS(3719),
    [anon_sym_extension] = ACTIONS(3719),
  },
  [969] = {
    [ts_builtin_sym_end] = ACTIONS(3818),
    [sym_identifier] = ACTIONS(3816),
    [aux_sym_preproc_include_token1] = ACTIONS(3816),
    [aux_sym_preproc_def_token1] = ACTIONS(3816),
    [aux_sym_preproc_if_token1] = ACTIONS(3816),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3816),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3816),
    [sym_preproc_directive] = ACTIONS(3816),
    [anon_sym_LPAREN2] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3818),
    [anon_sym_TILDE] = ACTIONS(3818),
    [anon_sym_DASH] = ACTIONS(3816),
    [anon_sym_PLUS] = ACTIONS(3816),
    [anon_sym_STAR] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_SEMI] = ACTIONS(3818),
    [anon_sym___extension__] = ACTIONS(3816),
    [anon_sym_typedef] = ACTIONS(3816),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_out] = ACTIONS(3816),
    [anon_sym_inout] = ACTIONS(3816),
    [anon_sym_virtual] = ACTIONS(3816),
    [anon_sym_extern] = ACTIONS(3816),
    [anon_sym___attribute__] = ACTIONS(3816),
    [anon_sym___attribute] = ACTIONS(3816),
    [anon_sym_using] = ACTIONS(3816),
    [anon_sym_COLON_COLON] = ACTIONS(3818),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3818),
    [anon_sym___declspec] = ACTIONS(3816),
    [anon_sym___based] = ACTIONS(3816),
    [anon_sym___cdecl] = ACTIONS(3816),
    [anon_sym___clrcall] = ACTIONS(3816),
    [anon_sym___stdcall] = ACTIONS(3816),
    [anon_sym___fastcall] = ACTIONS(3816),
    [anon_sym___thiscall] = ACTIONS(3816),
    [anon_sym___vectorcall] = ACTIONS(3816),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_signed] = ACTIONS(3816),
    [anon_sym_unsigned] = ACTIONS(3816),
    [anon_sym_long] = ACTIONS(3816),
    [anon_sym_short] = ACTIONS(3816),
    [anon_sym_LBRACK] = ACTIONS(3816),
    [anon_sym_static] = ACTIONS(3816),
    [anon_sym_register] = ACTIONS(3816),
    [anon_sym_inline] = ACTIONS(3816),
    [anon_sym___inline] = ACTIONS(3816),
    [anon_sym___inline__] = ACTIONS(3816),
    [anon_sym___forceinline] = ACTIONS(3816),
    [anon_sym_thread_local] = ACTIONS(3816),
    [anon_sym___thread] = ACTIONS(3816),
    [anon_sym_const] = ACTIONS(3816),
    [anon_sym_constexpr] = ACTIONS(3816),
    [anon_sym_volatile] = ACTIONS(3816),
    [anon_sym_restrict] = ACTIONS(3816),
    [anon_sym___restrict__] = ACTIONS(3816),
    [anon_sym__Atomic] = ACTIONS(3816),
    [anon_sym__Noreturn] = ACTIONS(3816),
    [anon_sym_noreturn] = ACTIONS(3816),
    [anon_sym__Nonnull] = ACTIONS(3816),
    [anon_sym_mutable] = ACTIONS(3816),
    [anon_sym_constinit] = ACTIONS(3816),
    [anon_sym_consteval] = ACTIONS(3816),
    [anon_sym_alignas] = ACTIONS(3816),
    [anon_sym__Alignas] = ACTIONS(3816),
    [sym_primitive_type] = ACTIONS(3816),
    [anon_sym_enum] = ACTIONS(3816),
    [anon_sym_class] = ACTIONS(3816),
    [anon_sym_struct] = ACTIONS(3816),
    [anon_sym_union] = ACTIONS(3816),
    [anon_sym_if] = ACTIONS(3816),
    [anon_sym_switch] = ACTIONS(3816),
    [anon_sym_case] = ACTIONS(3816),
    [anon_sym_default] = ACTIONS(3816),
    [anon_sym_while] = ACTIONS(3816),
    [anon_sym_do] = ACTIONS(3816),
    [anon_sym_for] = ACTIONS(3816),
    [anon_sym_return] = ACTIONS(3816),
    [anon_sym_break] = ACTIONS(3816),
    [anon_sym_continue] = ACTIONS(3816),
    [anon_sym_goto] = ACTIONS(3816),
    [anon_sym_not] = ACTIONS(3816),
    [anon_sym_compl] = ACTIONS(3816),
    [anon_sym_DASH_DASH] = ACTIONS(3818),
    [anon_sym_PLUS_PLUS] = ACTIONS(3818),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3816),
    [anon_sym___alignof] = ACTIONS(3816),
    [anon_sym__alignof] = ACTIONS(3816),
    [anon_sym_alignof] = ACTIONS(3816),
    [anon_sym__Alignof] = ACTIONS(3816),
    [anon_sym_offsetof] = ACTIONS(3816),
    [anon_sym__Generic] = ACTIONS(3816),
    [anon_sym_asm] = ACTIONS(3816),
    [anon_sym___asm__] = ACTIONS(3816),
    [anon_sym___asm] = ACTIONS(3816),
    [sym_number_literal] = ACTIONS(3818),
    [anon_sym_L_SQUOTE] = ACTIONS(3818),
    [anon_sym_u_SQUOTE] = ACTIONS(3818),
    [anon_sym_U_SQUOTE] = ACTIONS(3818),
    [anon_sym_u8_SQUOTE] = ACTIONS(3818),
    [anon_sym_SQUOTE] = ACTIONS(3818),
    [anon_sym_L_DQUOTE] = ACTIONS(3818),
    [anon_sym_u_DQUOTE] = ACTIONS(3818),
    [anon_sym_U_DQUOTE] = ACTIONS(3818),
    [anon_sym_u8_DQUOTE] = ACTIONS(3818),
    [anon_sym_DQUOTE] = ACTIONS(3818),
    [sym_true] = ACTIONS(3816),
    [sym_false] = ACTIONS(3816),
    [anon_sym_NULL] = ACTIONS(3816),
    [anon_sym_nullptr] = ACTIONS(3816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3816),
    [anon_sym_let] = ACTIONS(3816),
    [anon_sym_This] = ACTIONS(3816),
    [anon_sym_decltype] = ACTIONS(3816),
    [anon_sym_explicit] = ACTIONS(3816),
    [anon_sym_typename] = ACTIONS(3816),
    [anon_sym_export] = ACTIONS(3816),
    [anon_sym_module] = ACTIONS(3816),
    [anon_sym_import] = ACTIONS(3816),
    [anon_sym_template] = ACTIONS(3816),
    [anon_sym_operator] = ACTIONS(3816),
    [anon_sym_try] = ACTIONS(3816),
    [anon_sym_delete] = ACTIONS(3816),
    [anon_sym_throw] = ACTIONS(3816),
    [anon_sym_namespace] = ACTIONS(3816),
    [anon_sym_static_assert] = ACTIONS(3816),
    [anon_sym_concept] = ACTIONS(3816),
    [anon_sym_co_return] = ACTIONS(3816),
    [anon_sym_co_yield] = ACTIONS(3816),
    [anon_sym_R_DQUOTE] = ACTIONS(3818),
    [anon_sym_LR_DQUOTE] = ACTIONS(3818),
    [anon_sym_uR_DQUOTE] = ACTIONS(3818),
    [anon_sym_UR_DQUOTE] = ACTIONS(3818),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3818),
    [anon_sym_co_await] = ACTIONS(3816),
    [anon_sym_new] = ACTIONS(3816),
    [anon_sym_requires] = ACTIONS(3816),
    [sym_this] = ACTIONS(3816),
    [anon_sym_precise] = ACTIONS(3816),
    [anon_sym_shared] = ACTIONS(3816),
    [anon_sym_groupshared] = ACTIONS(3816),
    [anon_sym_uniform] = ACTIONS(3816),
    [anon_sym_row_major] = ACTIONS(3816),
    [anon_sym_column_major] = ACTIONS(3816),
    [anon_sym_globallycoherent] = ACTIONS(3816),
    [anon_sym_centroid] = ACTIONS(3816),
    [anon_sym_noperspective] = ACTIONS(3816),
    [anon_sym_nointerpolation] = ACTIONS(3816),
    [anon_sym_sample] = ACTIONS(3816),
    [anon_sym_linear] = ACTIONS(3816),
    [anon_sym_snorm] = ACTIONS(3816),
    [anon_sym_unorm] = ACTIONS(3816),
    [anon_sym_point] = ACTIONS(3816),
    [anon_sym_line] = ACTIONS(3816),
    [anon_sym_triangleadj] = ACTIONS(3816),
    [anon_sym_lineadj] = ACTIONS(3816),
    [anon_sym_triangle] = ACTIONS(3816),
    [anon_sym_interface] = ACTIONS(3816),
    [anon_sym_extension] = ACTIONS(3816),
    [anon_sym___exported] = ACTIONS(3816),
  },
  [970] = {
    [sym_identifier] = ACTIONS(3747),
    [aux_sym_preproc_include_token1] = ACTIONS(3747),
    [aux_sym_preproc_def_token1] = ACTIONS(3747),
    [aux_sym_preproc_if_token1] = ACTIONS(3747),
    [aux_sym_preproc_if_token2] = ACTIONS(3747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3747),
    [sym_preproc_directive] = ACTIONS(3747),
    [anon_sym_LPAREN2] = ACTIONS(3749),
    [anon_sym_BANG] = ACTIONS(3749),
    [anon_sym_TILDE] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_STAR] = ACTIONS(3749),
    [anon_sym_AMP_AMP] = ACTIONS(3749),
    [anon_sym_AMP] = ACTIONS(3747),
    [anon_sym_SEMI] = ACTIONS(3749),
    [anon_sym___extension__] = ACTIONS(3747),
    [anon_sym_typedef] = ACTIONS(3747),
    [anon_sym_in] = ACTIONS(3747),
    [anon_sym_out] = ACTIONS(3747),
    [anon_sym_inout] = ACTIONS(3747),
    [anon_sym_virtual] = ACTIONS(3747),
    [anon_sym_extern] = ACTIONS(3747),
    [anon_sym___attribute__] = ACTIONS(3747),
    [anon_sym___attribute] = ACTIONS(3747),
    [anon_sym_using] = ACTIONS(3747),
    [anon_sym_COLON_COLON] = ACTIONS(3749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3749),
    [anon_sym___declspec] = ACTIONS(3747),
    [anon_sym___based] = ACTIONS(3747),
    [anon_sym___cdecl] = ACTIONS(3747),
    [anon_sym___clrcall] = ACTIONS(3747),
    [anon_sym___stdcall] = ACTIONS(3747),
    [anon_sym___fastcall] = ACTIONS(3747),
    [anon_sym___thiscall] = ACTIONS(3747),
    [anon_sym___vectorcall] = ACTIONS(3747),
    [anon_sym_LBRACE] = ACTIONS(3749),
    [anon_sym_signed] = ACTIONS(3747),
    [anon_sym_unsigned] = ACTIONS(3747),
    [anon_sym_long] = ACTIONS(3747),
    [anon_sym_short] = ACTIONS(3747),
    [anon_sym_LBRACK] = ACTIONS(3747),
    [anon_sym_static] = ACTIONS(3747),
    [anon_sym_register] = ACTIONS(3747),
    [anon_sym_inline] = ACTIONS(3747),
    [anon_sym___inline] = ACTIONS(3747),
    [anon_sym___inline__] = ACTIONS(3747),
    [anon_sym___forceinline] = ACTIONS(3747),
    [anon_sym_thread_local] = ACTIONS(3747),
    [anon_sym___thread] = ACTIONS(3747),
    [anon_sym_const] = ACTIONS(3747),
    [anon_sym_constexpr] = ACTIONS(3747),
    [anon_sym_volatile] = ACTIONS(3747),
    [anon_sym_restrict] = ACTIONS(3747),
    [anon_sym___restrict__] = ACTIONS(3747),
    [anon_sym__Atomic] = ACTIONS(3747),
    [anon_sym__Noreturn] = ACTIONS(3747),
    [anon_sym_noreturn] = ACTIONS(3747),
    [anon_sym__Nonnull] = ACTIONS(3747),
    [anon_sym_mutable] = ACTIONS(3747),
    [anon_sym_constinit] = ACTIONS(3747),
    [anon_sym_consteval] = ACTIONS(3747),
    [anon_sym_alignas] = ACTIONS(3747),
    [anon_sym__Alignas] = ACTIONS(3747),
    [sym_primitive_type] = ACTIONS(3747),
    [anon_sym_enum] = ACTIONS(3747),
    [anon_sym_class] = ACTIONS(3747),
    [anon_sym_struct] = ACTIONS(3747),
    [anon_sym_union] = ACTIONS(3747),
    [anon_sym_if] = ACTIONS(3747),
    [anon_sym_switch] = ACTIONS(3747),
    [anon_sym_case] = ACTIONS(3747),
    [anon_sym_default] = ACTIONS(3747),
    [anon_sym_while] = ACTIONS(3747),
    [anon_sym_do] = ACTIONS(3747),
    [anon_sym_for] = ACTIONS(3747),
    [anon_sym_return] = ACTIONS(3747),
    [anon_sym_break] = ACTIONS(3747),
    [anon_sym_continue] = ACTIONS(3747),
    [anon_sym_goto] = ACTIONS(3747),
    [anon_sym___try] = ACTIONS(3747),
    [anon_sym___leave] = ACTIONS(3747),
    [anon_sym_not] = ACTIONS(3747),
    [anon_sym_compl] = ACTIONS(3747),
    [anon_sym_DASH_DASH] = ACTIONS(3749),
    [anon_sym_PLUS_PLUS] = ACTIONS(3749),
    [anon_sym_sizeof] = ACTIONS(3747),
    [anon_sym___alignof__] = ACTIONS(3747),
    [anon_sym___alignof] = ACTIONS(3747),
    [anon_sym__alignof] = ACTIONS(3747),
    [anon_sym_alignof] = ACTIONS(3747),
    [anon_sym__Alignof] = ACTIONS(3747),
    [anon_sym_offsetof] = ACTIONS(3747),
    [anon_sym__Generic] = ACTIONS(3747),
    [anon_sym_asm] = ACTIONS(3747),
    [anon_sym___asm__] = ACTIONS(3747),
    [anon_sym___asm] = ACTIONS(3747),
    [sym_number_literal] = ACTIONS(3749),
    [anon_sym_L_SQUOTE] = ACTIONS(3749),
    [anon_sym_u_SQUOTE] = ACTIONS(3749),
    [anon_sym_U_SQUOTE] = ACTIONS(3749),
    [anon_sym_u8_SQUOTE] = ACTIONS(3749),
    [anon_sym_SQUOTE] = ACTIONS(3749),
    [anon_sym_L_DQUOTE] = ACTIONS(3749),
    [anon_sym_u_DQUOTE] = ACTIONS(3749),
    [anon_sym_U_DQUOTE] = ACTIONS(3749),
    [anon_sym_u8_DQUOTE] = ACTIONS(3749),
    [anon_sym_DQUOTE] = ACTIONS(3749),
    [sym_true] = ACTIONS(3747),
    [sym_false] = ACTIONS(3747),
    [anon_sym_NULL] = ACTIONS(3747),
    [anon_sym_nullptr] = ACTIONS(3747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3747),
    [anon_sym_let] = ACTIONS(3747),
    [anon_sym_This] = ACTIONS(3747),
    [anon_sym_decltype] = ACTIONS(3747),
    [anon_sym_explicit] = ACTIONS(3747),
    [anon_sym_typename] = ACTIONS(3747),
    [anon_sym_template] = ACTIONS(3747),
    [anon_sym_operator] = ACTIONS(3747),
    [anon_sym_try] = ACTIONS(3747),
    [anon_sym_delete] = ACTIONS(3747),
    [anon_sym_throw] = ACTIONS(3747),
    [anon_sym_namespace] = ACTIONS(3747),
    [anon_sym_static_assert] = ACTIONS(3747),
    [anon_sym_concept] = ACTIONS(3747),
    [anon_sym_co_return] = ACTIONS(3747),
    [anon_sym_co_yield] = ACTIONS(3747),
    [anon_sym_R_DQUOTE] = ACTIONS(3749),
    [anon_sym_LR_DQUOTE] = ACTIONS(3749),
    [anon_sym_uR_DQUOTE] = ACTIONS(3749),
    [anon_sym_UR_DQUOTE] = ACTIONS(3749),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3749),
    [anon_sym_co_await] = ACTIONS(3747),
    [anon_sym_new] = ACTIONS(3747),
    [anon_sym_requires] = ACTIONS(3747),
    [sym_this] = ACTIONS(3747),
    [anon_sym_discard] = ACTIONS(3747),
    [anon_sym_precise] = ACTIONS(3747),
    [anon_sym_shared] = ACTIONS(3747),
    [anon_sym_groupshared] = ACTIONS(3747),
    [anon_sym_uniform] = ACTIONS(3747),
    [anon_sym_row_major] = ACTIONS(3747),
    [anon_sym_column_major] = ACTIONS(3747),
    [anon_sym_globallycoherent] = ACTIONS(3747),
    [anon_sym_centroid] = ACTIONS(3747),
    [anon_sym_noperspective] = ACTIONS(3747),
    [anon_sym_nointerpolation] = ACTIONS(3747),
    [anon_sym_sample] = ACTIONS(3747),
    [anon_sym_linear] = ACTIONS(3747),
    [anon_sym_snorm] = ACTIONS(3747),
    [anon_sym_unorm] = ACTIONS(3747),
    [anon_sym_point] = ACTIONS(3747),
    [anon_sym_line] = ACTIONS(3747),
    [anon_sym_triangleadj] = ACTIONS(3747),
    [anon_sym_lineadj] = ACTIONS(3747),
    [anon_sym_triangle] = ACTIONS(3747),
    [anon_sym_cbuffer] = ACTIONS(3747),
    [anon_sym_interface] = ACTIONS(3747),
    [anon_sym_extension] = ACTIONS(3747),
  },
  [971] = {
    [ts_builtin_sym_end] = ACTIONS(3822),
    [sym_identifier] = ACTIONS(3820),
    [aux_sym_preproc_include_token1] = ACTIONS(3820),
    [aux_sym_preproc_def_token1] = ACTIONS(3820),
    [aux_sym_preproc_if_token1] = ACTIONS(3820),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3820),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3820),
    [sym_preproc_directive] = ACTIONS(3820),
    [anon_sym_LPAREN2] = ACTIONS(3822),
    [anon_sym_BANG] = ACTIONS(3822),
    [anon_sym_TILDE] = ACTIONS(3822),
    [anon_sym_DASH] = ACTIONS(3820),
    [anon_sym_PLUS] = ACTIONS(3820),
    [anon_sym_STAR] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3822),
    [anon_sym_AMP] = ACTIONS(3820),
    [anon_sym_SEMI] = ACTIONS(3822),
    [anon_sym___extension__] = ACTIONS(3820),
    [anon_sym_typedef] = ACTIONS(3820),
    [anon_sym_in] = ACTIONS(3820),
    [anon_sym_out] = ACTIONS(3820),
    [anon_sym_inout] = ACTIONS(3820),
    [anon_sym_virtual] = ACTIONS(3820),
    [anon_sym_extern] = ACTIONS(3820),
    [anon_sym___attribute__] = ACTIONS(3820),
    [anon_sym___attribute] = ACTIONS(3820),
    [anon_sym_using] = ACTIONS(3820),
    [anon_sym_COLON_COLON] = ACTIONS(3822),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3822),
    [anon_sym___declspec] = ACTIONS(3820),
    [anon_sym___based] = ACTIONS(3820),
    [anon_sym___cdecl] = ACTIONS(3820),
    [anon_sym___clrcall] = ACTIONS(3820),
    [anon_sym___stdcall] = ACTIONS(3820),
    [anon_sym___fastcall] = ACTIONS(3820),
    [anon_sym___thiscall] = ACTIONS(3820),
    [anon_sym___vectorcall] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3822),
    [anon_sym_signed] = ACTIONS(3820),
    [anon_sym_unsigned] = ACTIONS(3820),
    [anon_sym_long] = ACTIONS(3820),
    [anon_sym_short] = ACTIONS(3820),
    [anon_sym_LBRACK] = ACTIONS(3820),
    [anon_sym_static] = ACTIONS(3820),
    [anon_sym_register] = ACTIONS(3820),
    [anon_sym_inline] = ACTIONS(3820),
    [anon_sym___inline] = ACTIONS(3820),
    [anon_sym___inline__] = ACTIONS(3820),
    [anon_sym___forceinline] = ACTIONS(3820),
    [anon_sym_thread_local] = ACTIONS(3820),
    [anon_sym___thread] = ACTIONS(3820),
    [anon_sym_const] = ACTIONS(3820),
    [anon_sym_constexpr] = ACTIONS(3820),
    [anon_sym_volatile] = ACTIONS(3820),
    [anon_sym_restrict] = ACTIONS(3820),
    [anon_sym___restrict__] = ACTIONS(3820),
    [anon_sym__Atomic] = ACTIONS(3820),
    [anon_sym__Noreturn] = ACTIONS(3820),
    [anon_sym_noreturn] = ACTIONS(3820),
    [anon_sym__Nonnull] = ACTIONS(3820),
    [anon_sym_mutable] = ACTIONS(3820),
    [anon_sym_constinit] = ACTIONS(3820),
    [anon_sym_consteval] = ACTIONS(3820),
    [anon_sym_alignas] = ACTIONS(3820),
    [anon_sym__Alignas] = ACTIONS(3820),
    [sym_primitive_type] = ACTIONS(3820),
    [anon_sym_enum] = ACTIONS(3820),
    [anon_sym_class] = ACTIONS(3820),
    [anon_sym_struct] = ACTIONS(3820),
    [anon_sym_union] = ACTIONS(3820),
    [anon_sym_if] = ACTIONS(3820),
    [anon_sym_switch] = ACTIONS(3820),
    [anon_sym_case] = ACTIONS(3820),
    [anon_sym_default] = ACTIONS(3820),
    [anon_sym_while] = ACTIONS(3820),
    [anon_sym_do] = ACTIONS(3820),
    [anon_sym_for] = ACTIONS(3820),
    [anon_sym_return] = ACTIONS(3820),
    [anon_sym_break] = ACTIONS(3820),
    [anon_sym_continue] = ACTIONS(3820),
    [anon_sym_goto] = ACTIONS(3820),
    [anon_sym_not] = ACTIONS(3820),
    [anon_sym_compl] = ACTIONS(3820),
    [anon_sym_DASH_DASH] = ACTIONS(3822),
    [anon_sym_PLUS_PLUS] = ACTIONS(3822),
    [anon_sym_sizeof] = ACTIONS(3820),
    [anon_sym___alignof__] = ACTIONS(3820),
    [anon_sym___alignof] = ACTIONS(3820),
    [anon_sym__alignof] = ACTIONS(3820),
    [anon_sym_alignof] = ACTIONS(3820),
    [anon_sym__Alignof] = ACTIONS(3820),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3820),
    [anon_sym_asm] = ACTIONS(3820),
    [anon_sym___asm__] = ACTIONS(3820),
    [anon_sym___asm] = ACTIONS(3820),
    [sym_number_literal] = ACTIONS(3822),
    [anon_sym_L_SQUOTE] = ACTIONS(3822),
    [anon_sym_u_SQUOTE] = ACTIONS(3822),
    [anon_sym_U_SQUOTE] = ACTIONS(3822),
    [anon_sym_u8_SQUOTE] = ACTIONS(3822),
    [anon_sym_SQUOTE] = ACTIONS(3822),
    [anon_sym_L_DQUOTE] = ACTIONS(3822),
    [anon_sym_u_DQUOTE] = ACTIONS(3822),
    [anon_sym_U_DQUOTE] = ACTIONS(3822),
    [anon_sym_u8_DQUOTE] = ACTIONS(3822),
    [anon_sym_DQUOTE] = ACTIONS(3822),
    [sym_true] = ACTIONS(3820),
    [sym_false] = ACTIONS(3820),
    [anon_sym_NULL] = ACTIONS(3820),
    [anon_sym_nullptr] = ACTIONS(3820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3820),
    [anon_sym_let] = ACTIONS(3820),
    [anon_sym_This] = ACTIONS(3820),
    [anon_sym_decltype] = ACTIONS(3820),
    [anon_sym_explicit] = ACTIONS(3820),
    [anon_sym_typename] = ACTIONS(3820),
    [anon_sym_export] = ACTIONS(3820),
    [anon_sym_module] = ACTIONS(3820),
    [anon_sym_import] = ACTIONS(3820),
    [anon_sym_template] = ACTIONS(3820),
    [anon_sym_operator] = ACTIONS(3820),
    [anon_sym_try] = ACTIONS(3820),
    [anon_sym_delete] = ACTIONS(3820),
    [anon_sym_throw] = ACTIONS(3820),
    [anon_sym_namespace] = ACTIONS(3820),
    [anon_sym_static_assert] = ACTIONS(3820),
    [anon_sym_concept] = ACTIONS(3820),
    [anon_sym_co_return] = ACTIONS(3820),
    [anon_sym_co_yield] = ACTIONS(3820),
    [anon_sym_R_DQUOTE] = ACTIONS(3822),
    [anon_sym_LR_DQUOTE] = ACTIONS(3822),
    [anon_sym_uR_DQUOTE] = ACTIONS(3822),
    [anon_sym_UR_DQUOTE] = ACTIONS(3822),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3822),
    [anon_sym_co_await] = ACTIONS(3820),
    [anon_sym_new] = ACTIONS(3820),
    [anon_sym_requires] = ACTIONS(3820),
    [sym_this] = ACTIONS(3820),
    [anon_sym_precise] = ACTIONS(3820),
    [anon_sym_shared] = ACTIONS(3820),
    [anon_sym_groupshared] = ACTIONS(3820),
    [anon_sym_uniform] = ACTIONS(3820),
    [anon_sym_row_major] = ACTIONS(3820),
    [anon_sym_column_major] = ACTIONS(3820),
    [anon_sym_globallycoherent] = ACTIONS(3820),
    [anon_sym_centroid] = ACTIONS(3820),
    [anon_sym_noperspective] = ACTIONS(3820),
    [anon_sym_nointerpolation] = ACTIONS(3820),
    [anon_sym_sample] = ACTIONS(3820),
    [anon_sym_linear] = ACTIONS(3820),
    [anon_sym_snorm] = ACTIONS(3820),
    [anon_sym_unorm] = ACTIONS(3820),
    [anon_sym_point] = ACTIONS(3820),
    [anon_sym_line] = ACTIONS(3820),
    [anon_sym_triangleadj] = ACTIONS(3820),
    [anon_sym_lineadj] = ACTIONS(3820),
    [anon_sym_triangle] = ACTIONS(3820),
    [anon_sym_interface] = ACTIONS(3820),
    [anon_sym_extension] = ACTIONS(3820),
    [anon_sym___exported] = ACTIONS(3820),
  },
  [972] = {
    [ts_builtin_sym_end] = ACTIONS(3826),
    [sym_identifier] = ACTIONS(3824),
    [aux_sym_preproc_include_token1] = ACTIONS(3824),
    [aux_sym_preproc_def_token1] = ACTIONS(3824),
    [aux_sym_preproc_if_token1] = ACTIONS(3824),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3824),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3824),
    [sym_preproc_directive] = ACTIONS(3824),
    [anon_sym_LPAREN2] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3826),
    [anon_sym_TILDE] = ACTIONS(3826),
    [anon_sym_DASH] = ACTIONS(3824),
    [anon_sym_PLUS] = ACTIONS(3824),
    [anon_sym_STAR] = ACTIONS(3826),
    [anon_sym_AMP_AMP] = ACTIONS(3826),
    [anon_sym_AMP] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(3826),
    [anon_sym___extension__] = ACTIONS(3824),
    [anon_sym_typedef] = ACTIONS(3824),
    [anon_sym_in] = ACTIONS(3824),
    [anon_sym_out] = ACTIONS(3824),
    [anon_sym_inout] = ACTIONS(3824),
    [anon_sym_virtual] = ACTIONS(3824),
    [anon_sym_extern] = ACTIONS(3824),
    [anon_sym___attribute__] = ACTIONS(3824),
    [anon_sym___attribute] = ACTIONS(3824),
    [anon_sym_using] = ACTIONS(3824),
    [anon_sym_COLON_COLON] = ACTIONS(3826),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3826),
    [anon_sym___declspec] = ACTIONS(3824),
    [anon_sym___based] = ACTIONS(3824),
    [anon_sym___cdecl] = ACTIONS(3824),
    [anon_sym___clrcall] = ACTIONS(3824),
    [anon_sym___stdcall] = ACTIONS(3824),
    [anon_sym___fastcall] = ACTIONS(3824),
    [anon_sym___thiscall] = ACTIONS(3824),
    [anon_sym___vectorcall] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(3826),
    [anon_sym_signed] = ACTIONS(3824),
    [anon_sym_unsigned] = ACTIONS(3824),
    [anon_sym_long] = ACTIONS(3824),
    [anon_sym_short] = ACTIONS(3824),
    [anon_sym_LBRACK] = ACTIONS(3824),
    [anon_sym_static] = ACTIONS(3824),
    [anon_sym_register] = ACTIONS(3824),
    [anon_sym_inline] = ACTIONS(3824),
    [anon_sym___inline] = ACTIONS(3824),
    [anon_sym___inline__] = ACTIONS(3824),
    [anon_sym___forceinline] = ACTIONS(3824),
    [anon_sym_thread_local] = ACTIONS(3824),
    [anon_sym___thread] = ACTIONS(3824),
    [anon_sym_const] = ACTIONS(3824),
    [anon_sym_constexpr] = ACTIONS(3824),
    [anon_sym_volatile] = ACTIONS(3824),
    [anon_sym_restrict] = ACTIONS(3824),
    [anon_sym___restrict__] = ACTIONS(3824),
    [anon_sym__Atomic] = ACTIONS(3824),
    [anon_sym__Noreturn] = ACTIONS(3824),
    [anon_sym_noreturn] = ACTIONS(3824),
    [anon_sym__Nonnull] = ACTIONS(3824),
    [anon_sym_mutable] = ACTIONS(3824),
    [anon_sym_constinit] = ACTIONS(3824),
    [anon_sym_consteval] = ACTIONS(3824),
    [anon_sym_alignas] = ACTIONS(3824),
    [anon_sym__Alignas] = ACTIONS(3824),
    [sym_primitive_type] = ACTIONS(3824),
    [anon_sym_enum] = ACTIONS(3824),
    [anon_sym_class] = ACTIONS(3824),
    [anon_sym_struct] = ACTIONS(3824),
    [anon_sym_union] = ACTIONS(3824),
    [anon_sym_if] = ACTIONS(3824),
    [anon_sym_switch] = ACTIONS(3824),
    [anon_sym_case] = ACTIONS(3824),
    [anon_sym_default] = ACTIONS(3824),
    [anon_sym_while] = ACTIONS(3824),
    [anon_sym_do] = ACTIONS(3824),
    [anon_sym_for] = ACTIONS(3824),
    [anon_sym_return] = ACTIONS(3824),
    [anon_sym_break] = ACTIONS(3824),
    [anon_sym_continue] = ACTIONS(3824),
    [anon_sym_goto] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3824),
    [anon_sym_compl] = ACTIONS(3824),
    [anon_sym_DASH_DASH] = ACTIONS(3826),
    [anon_sym_PLUS_PLUS] = ACTIONS(3826),
    [anon_sym_sizeof] = ACTIONS(3824),
    [anon_sym___alignof__] = ACTIONS(3824),
    [anon_sym___alignof] = ACTIONS(3824),
    [anon_sym__alignof] = ACTIONS(3824),
    [anon_sym_alignof] = ACTIONS(3824),
    [anon_sym__Alignof] = ACTIONS(3824),
    [anon_sym_offsetof] = ACTIONS(3824),
    [anon_sym__Generic] = ACTIONS(3824),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3826),
    [anon_sym_u_SQUOTE] = ACTIONS(3826),
    [anon_sym_U_SQUOTE] = ACTIONS(3826),
    [anon_sym_u8_SQUOTE] = ACTIONS(3826),
    [anon_sym_SQUOTE] = ACTIONS(3826),
    [anon_sym_L_DQUOTE] = ACTIONS(3826),
    [anon_sym_u_DQUOTE] = ACTIONS(3826),
    [anon_sym_U_DQUOTE] = ACTIONS(3826),
    [anon_sym_u8_DQUOTE] = ACTIONS(3826),
    [anon_sym_DQUOTE] = ACTIONS(3826),
    [sym_true] = ACTIONS(3824),
    [sym_false] = ACTIONS(3824),
    [anon_sym_NULL] = ACTIONS(3824),
    [anon_sym_nullptr] = ACTIONS(3824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3824),
    [anon_sym_let] = ACTIONS(3824),
    [anon_sym_This] = ACTIONS(3824),
    [anon_sym_decltype] = ACTIONS(3824),
    [anon_sym_explicit] = ACTIONS(3824),
    [anon_sym_typename] = ACTIONS(3824),
    [anon_sym_export] = ACTIONS(3824),
    [anon_sym_module] = ACTIONS(3824),
    [anon_sym_import] = ACTIONS(3824),
    [anon_sym_template] = ACTIONS(3824),
    [anon_sym_operator] = ACTIONS(3824),
    [anon_sym_try] = ACTIONS(3824),
    [anon_sym_delete] = ACTIONS(3824),
    [anon_sym_throw] = ACTIONS(3824),
    [anon_sym_namespace] = ACTIONS(3824),
    [anon_sym_static_assert] = ACTIONS(3824),
    [anon_sym_concept] = ACTIONS(3824),
    [anon_sym_co_return] = ACTIONS(3824),
    [anon_sym_co_yield] = ACTIONS(3824),
    [anon_sym_R_DQUOTE] = ACTIONS(3826),
    [anon_sym_LR_DQUOTE] = ACTIONS(3826),
    [anon_sym_uR_DQUOTE] = ACTIONS(3826),
    [anon_sym_UR_DQUOTE] = ACTIONS(3826),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3826),
    [anon_sym_co_await] = ACTIONS(3824),
    [anon_sym_new] = ACTIONS(3824),
    [anon_sym_requires] = ACTIONS(3824),
    [sym_this] = ACTIONS(3824),
    [anon_sym_precise] = ACTIONS(3824),
    [anon_sym_shared] = ACTIONS(3824),
    [anon_sym_groupshared] = ACTIONS(3824),
    [anon_sym_uniform] = ACTIONS(3824),
    [anon_sym_row_major] = ACTIONS(3824),
    [anon_sym_column_major] = ACTIONS(3824),
    [anon_sym_globallycoherent] = ACTIONS(3824),
    [anon_sym_centroid] = ACTIONS(3824),
    [anon_sym_noperspective] = ACTIONS(3824),
    [anon_sym_nointerpolation] = ACTIONS(3824),
    [anon_sym_sample] = ACTIONS(3824),
    [anon_sym_linear] = ACTIONS(3824),
    [anon_sym_snorm] = ACTIONS(3824),
    [anon_sym_unorm] = ACTIONS(3824),
    [anon_sym_point] = ACTIONS(3824),
    [anon_sym_line] = ACTIONS(3824),
    [anon_sym_triangleadj] = ACTIONS(3824),
    [anon_sym_lineadj] = ACTIONS(3824),
    [anon_sym_triangle] = ACTIONS(3824),
    [anon_sym_interface] = ACTIONS(3824),
    [anon_sym_extension] = ACTIONS(3824),
    [anon_sym___exported] = ACTIONS(3824),
  },
  [973] = {
    [ts_builtin_sym_end] = ACTIONS(3810),
    [sym_identifier] = ACTIONS(3808),
    [aux_sym_preproc_include_token1] = ACTIONS(3808),
    [aux_sym_preproc_def_token1] = ACTIONS(3808),
    [aux_sym_preproc_if_token1] = ACTIONS(3808),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3808),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3808),
    [sym_preproc_directive] = ACTIONS(3808),
    [anon_sym_LPAREN2] = ACTIONS(3810),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [anon_sym_DASH] = ACTIONS(3808),
    [anon_sym_PLUS] = ACTIONS(3808),
    [anon_sym_STAR] = ACTIONS(3810),
    [anon_sym_AMP_AMP] = ACTIONS(3810),
    [anon_sym_AMP] = ACTIONS(3808),
    [anon_sym_SEMI] = ACTIONS(3810),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_typedef] = ACTIONS(3808),
    [anon_sym_in] = ACTIONS(3808),
    [anon_sym_out] = ACTIONS(3808),
    [anon_sym_inout] = ACTIONS(3808),
    [anon_sym_virtual] = ACTIONS(3808),
    [anon_sym_extern] = ACTIONS(3808),
    [anon_sym___attribute__] = ACTIONS(3808),
    [anon_sym___attribute] = ACTIONS(3808),
    [anon_sym_using] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3810),
    [anon_sym___declspec] = ACTIONS(3808),
    [anon_sym___based] = ACTIONS(3808),
    [anon_sym___cdecl] = ACTIONS(3808),
    [anon_sym___clrcall] = ACTIONS(3808),
    [anon_sym___stdcall] = ACTIONS(3808),
    [anon_sym___fastcall] = ACTIONS(3808),
    [anon_sym___thiscall] = ACTIONS(3808),
    [anon_sym___vectorcall] = ACTIONS(3808),
    [anon_sym_LBRACE] = ACTIONS(3810),
    [anon_sym_signed] = ACTIONS(3808),
    [anon_sym_unsigned] = ACTIONS(3808),
    [anon_sym_long] = ACTIONS(3808),
    [anon_sym_short] = ACTIONS(3808),
    [anon_sym_LBRACK] = ACTIONS(3808),
    [anon_sym_static] = ACTIONS(3808),
    [anon_sym_register] = ACTIONS(3808),
    [anon_sym_inline] = ACTIONS(3808),
    [anon_sym___inline] = ACTIONS(3808),
    [anon_sym___inline__] = ACTIONS(3808),
    [anon_sym___forceinline] = ACTIONS(3808),
    [anon_sym_thread_local] = ACTIONS(3808),
    [anon_sym___thread] = ACTIONS(3808),
    [anon_sym_const] = ACTIONS(3808),
    [anon_sym_constexpr] = ACTIONS(3808),
    [anon_sym_volatile] = ACTIONS(3808),
    [anon_sym_restrict] = ACTIONS(3808),
    [anon_sym___restrict__] = ACTIONS(3808),
    [anon_sym__Atomic] = ACTIONS(3808),
    [anon_sym__Noreturn] = ACTIONS(3808),
    [anon_sym_noreturn] = ACTIONS(3808),
    [anon_sym__Nonnull] = ACTIONS(3808),
    [anon_sym_mutable] = ACTIONS(3808),
    [anon_sym_constinit] = ACTIONS(3808),
    [anon_sym_consteval] = ACTIONS(3808),
    [anon_sym_alignas] = ACTIONS(3808),
    [anon_sym__Alignas] = ACTIONS(3808),
    [sym_primitive_type] = ACTIONS(3808),
    [anon_sym_enum] = ACTIONS(3808),
    [anon_sym_class] = ACTIONS(3808),
    [anon_sym_struct] = ACTIONS(3808),
    [anon_sym_union] = ACTIONS(3808),
    [anon_sym_if] = ACTIONS(3808),
    [anon_sym_switch] = ACTIONS(3808),
    [anon_sym_case] = ACTIONS(3808),
    [anon_sym_default] = ACTIONS(3808),
    [anon_sym_while] = ACTIONS(3808),
    [anon_sym_do] = ACTIONS(3808),
    [anon_sym_for] = ACTIONS(3808),
    [anon_sym_return] = ACTIONS(3808),
    [anon_sym_break] = ACTIONS(3808),
    [anon_sym_continue] = ACTIONS(3808),
    [anon_sym_goto] = ACTIONS(3808),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_compl] = ACTIONS(3808),
    [anon_sym_DASH_DASH] = ACTIONS(3810),
    [anon_sym_PLUS_PLUS] = ACTIONS(3810),
    [anon_sym_sizeof] = ACTIONS(3808),
    [anon_sym___alignof__] = ACTIONS(3808),
    [anon_sym___alignof] = ACTIONS(3808),
    [anon_sym__alignof] = ACTIONS(3808),
    [anon_sym_alignof] = ACTIONS(3808),
    [anon_sym__Alignof] = ACTIONS(3808),
    [anon_sym_offsetof] = ACTIONS(3808),
    [anon_sym__Generic] = ACTIONS(3808),
    [anon_sym_asm] = ACTIONS(3808),
    [anon_sym___asm__] = ACTIONS(3808),
    [anon_sym___asm] = ACTIONS(3808),
    [sym_number_literal] = ACTIONS(3810),
    [anon_sym_L_SQUOTE] = ACTIONS(3810),
    [anon_sym_u_SQUOTE] = ACTIONS(3810),
    [anon_sym_U_SQUOTE] = ACTIONS(3810),
    [anon_sym_u8_SQUOTE] = ACTIONS(3810),
    [anon_sym_SQUOTE] = ACTIONS(3810),
    [anon_sym_L_DQUOTE] = ACTIONS(3810),
    [anon_sym_u_DQUOTE] = ACTIONS(3810),
    [anon_sym_U_DQUOTE] = ACTIONS(3810),
    [anon_sym_u8_DQUOTE] = ACTIONS(3810),
    [anon_sym_DQUOTE] = ACTIONS(3810),
    [sym_true] = ACTIONS(3808),
    [sym_false] = ACTIONS(3808),
    [anon_sym_NULL] = ACTIONS(3808),
    [anon_sym_nullptr] = ACTIONS(3808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3808),
    [anon_sym_let] = ACTIONS(3808),
    [anon_sym_This] = ACTIONS(3808),
    [anon_sym_decltype] = ACTIONS(3808),
    [anon_sym_explicit] = ACTIONS(3808),
    [anon_sym_typename] = ACTIONS(3808),
    [anon_sym_export] = ACTIONS(3808),
    [anon_sym_module] = ACTIONS(3808),
    [anon_sym_import] = ACTIONS(3808),
    [anon_sym_template] = ACTIONS(3808),
    [anon_sym_operator] = ACTIONS(3808),
    [anon_sym_try] = ACTIONS(3808),
    [anon_sym_delete] = ACTIONS(3808),
    [anon_sym_throw] = ACTIONS(3808),
    [anon_sym_namespace] = ACTIONS(3808),
    [anon_sym_static_assert] = ACTIONS(3808),
    [anon_sym_concept] = ACTIONS(3808),
    [anon_sym_co_return] = ACTIONS(3808),
    [anon_sym_co_yield] = ACTIONS(3808),
    [anon_sym_R_DQUOTE] = ACTIONS(3810),
    [anon_sym_LR_DQUOTE] = ACTIONS(3810),
    [anon_sym_uR_DQUOTE] = ACTIONS(3810),
    [anon_sym_UR_DQUOTE] = ACTIONS(3810),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3810),
    [anon_sym_co_await] = ACTIONS(3808),
    [anon_sym_new] = ACTIONS(3808),
    [anon_sym_requires] = ACTIONS(3808),
    [sym_this] = ACTIONS(3808),
    [anon_sym_precise] = ACTIONS(3808),
    [anon_sym_shared] = ACTIONS(3808),
    [anon_sym_groupshared] = ACTIONS(3808),
    [anon_sym_uniform] = ACTIONS(3808),
    [anon_sym_row_major] = ACTIONS(3808),
    [anon_sym_column_major] = ACTIONS(3808),
    [anon_sym_globallycoherent] = ACTIONS(3808),
    [anon_sym_centroid] = ACTIONS(3808),
    [anon_sym_noperspective] = ACTIONS(3808),
    [anon_sym_nointerpolation] = ACTIONS(3808),
    [anon_sym_sample] = ACTIONS(3808),
    [anon_sym_linear] = ACTIONS(3808),
    [anon_sym_snorm] = ACTIONS(3808),
    [anon_sym_unorm] = ACTIONS(3808),
    [anon_sym_point] = ACTIONS(3808),
    [anon_sym_line] = ACTIONS(3808),
    [anon_sym_triangleadj] = ACTIONS(3808),
    [anon_sym_lineadj] = ACTIONS(3808),
    [anon_sym_triangle] = ACTIONS(3808),
    [anon_sym_interface] = ACTIONS(3808),
    [anon_sym_extension] = ACTIONS(3808),
    [anon_sym___exported] = ACTIONS(3808),
  },
  [974] = {
    [sym_identifier] = ACTIONS(3816),
    [aux_sym_preproc_include_token1] = ACTIONS(3816),
    [aux_sym_preproc_def_token1] = ACTIONS(3816),
    [aux_sym_preproc_if_token1] = ACTIONS(3816),
    [aux_sym_preproc_if_token2] = ACTIONS(3816),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3816),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3816),
    [sym_preproc_directive] = ACTIONS(3816),
    [anon_sym_LPAREN2] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3818),
    [anon_sym_TILDE] = ACTIONS(3818),
    [anon_sym_DASH] = ACTIONS(3816),
    [anon_sym_PLUS] = ACTIONS(3816),
    [anon_sym_STAR] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_SEMI] = ACTIONS(3818),
    [anon_sym___extension__] = ACTIONS(3816),
    [anon_sym_typedef] = ACTIONS(3816),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_out] = ACTIONS(3816),
    [anon_sym_inout] = ACTIONS(3816),
    [anon_sym_virtual] = ACTIONS(3816),
    [anon_sym_extern] = ACTIONS(3816),
    [anon_sym___attribute__] = ACTIONS(3816),
    [anon_sym___attribute] = ACTIONS(3816),
    [anon_sym_using] = ACTIONS(3816),
    [anon_sym_COLON_COLON] = ACTIONS(3818),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3818),
    [anon_sym___declspec] = ACTIONS(3816),
    [anon_sym___based] = ACTIONS(3816),
    [anon_sym___cdecl] = ACTIONS(3816),
    [anon_sym___clrcall] = ACTIONS(3816),
    [anon_sym___stdcall] = ACTIONS(3816),
    [anon_sym___fastcall] = ACTIONS(3816),
    [anon_sym___thiscall] = ACTIONS(3816),
    [anon_sym___vectorcall] = ACTIONS(3816),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_signed] = ACTIONS(3816),
    [anon_sym_unsigned] = ACTIONS(3816),
    [anon_sym_long] = ACTIONS(3816),
    [anon_sym_short] = ACTIONS(3816),
    [anon_sym_LBRACK] = ACTIONS(3816),
    [anon_sym_static] = ACTIONS(3816),
    [anon_sym_register] = ACTIONS(3816),
    [anon_sym_inline] = ACTIONS(3816),
    [anon_sym___inline] = ACTIONS(3816),
    [anon_sym___inline__] = ACTIONS(3816),
    [anon_sym___forceinline] = ACTIONS(3816),
    [anon_sym_thread_local] = ACTIONS(3816),
    [anon_sym___thread] = ACTIONS(3816),
    [anon_sym_const] = ACTIONS(3816),
    [anon_sym_constexpr] = ACTIONS(3816),
    [anon_sym_volatile] = ACTIONS(3816),
    [anon_sym_restrict] = ACTIONS(3816),
    [anon_sym___restrict__] = ACTIONS(3816),
    [anon_sym__Atomic] = ACTIONS(3816),
    [anon_sym__Noreturn] = ACTIONS(3816),
    [anon_sym_noreturn] = ACTIONS(3816),
    [anon_sym__Nonnull] = ACTIONS(3816),
    [anon_sym_mutable] = ACTIONS(3816),
    [anon_sym_constinit] = ACTIONS(3816),
    [anon_sym_consteval] = ACTIONS(3816),
    [anon_sym_alignas] = ACTIONS(3816),
    [anon_sym__Alignas] = ACTIONS(3816),
    [sym_primitive_type] = ACTIONS(3816),
    [anon_sym_enum] = ACTIONS(3816),
    [anon_sym_class] = ACTIONS(3816),
    [anon_sym_struct] = ACTIONS(3816),
    [anon_sym_union] = ACTIONS(3816),
    [anon_sym_if] = ACTIONS(3816),
    [anon_sym_switch] = ACTIONS(3816),
    [anon_sym_case] = ACTIONS(3816),
    [anon_sym_default] = ACTIONS(3816),
    [anon_sym_while] = ACTIONS(3816),
    [anon_sym_do] = ACTIONS(3816),
    [anon_sym_for] = ACTIONS(3816),
    [anon_sym_return] = ACTIONS(3816),
    [anon_sym_break] = ACTIONS(3816),
    [anon_sym_continue] = ACTIONS(3816),
    [anon_sym_goto] = ACTIONS(3816),
    [anon_sym___try] = ACTIONS(3816),
    [anon_sym___leave] = ACTIONS(3816),
    [anon_sym_not] = ACTIONS(3816),
    [anon_sym_compl] = ACTIONS(3816),
    [anon_sym_DASH_DASH] = ACTIONS(3818),
    [anon_sym_PLUS_PLUS] = ACTIONS(3818),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3816),
    [anon_sym___alignof] = ACTIONS(3816),
    [anon_sym__alignof] = ACTIONS(3816),
    [anon_sym_alignof] = ACTIONS(3816),
    [anon_sym__Alignof] = ACTIONS(3816),
    [anon_sym_offsetof] = ACTIONS(3816),
    [anon_sym__Generic] = ACTIONS(3816),
    [anon_sym_asm] = ACTIONS(3816),
    [anon_sym___asm__] = ACTIONS(3816),
    [anon_sym___asm] = ACTIONS(3816),
    [sym_number_literal] = ACTIONS(3818),
    [anon_sym_L_SQUOTE] = ACTIONS(3818),
    [anon_sym_u_SQUOTE] = ACTIONS(3818),
    [anon_sym_U_SQUOTE] = ACTIONS(3818),
    [anon_sym_u8_SQUOTE] = ACTIONS(3818),
    [anon_sym_SQUOTE] = ACTIONS(3818),
    [anon_sym_L_DQUOTE] = ACTIONS(3818),
    [anon_sym_u_DQUOTE] = ACTIONS(3818),
    [anon_sym_U_DQUOTE] = ACTIONS(3818),
    [anon_sym_u8_DQUOTE] = ACTIONS(3818),
    [anon_sym_DQUOTE] = ACTIONS(3818),
    [sym_true] = ACTIONS(3816),
    [sym_false] = ACTIONS(3816),
    [anon_sym_NULL] = ACTIONS(3816),
    [anon_sym_nullptr] = ACTIONS(3816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3816),
    [anon_sym_let] = ACTIONS(3816),
    [anon_sym_This] = ACTIONS(3816),
    [anon_sym_decltype] = ACTIONS(3816),
    [anon_sym_explicit] = ACTIONS(3816),
    [anon_sym_typename] = ACTIONS(3816),
    [anon_sym_template] = ACTIONS(3816),
    [anon_sym_operator] = ACTIONS(3816),
    [anon_sym_try] = ACTIONS(3816),
    [anon_sym_delete] = ACTIONS(3816),
    [anon_sym_throw] = ACTIONS(3816),
    [anon_sym_namespace] = ACTIONS(3816),
    [anon_sym_static_assert] = ACTIONS(3816),
    [anon_sym_concept] = ACTIONS(3816),
    [anon_sym_co_return] = ACTIONS(3816),
    [anon_sym_co_yield] = ACTIONS(3816),
    [anon_sym_R_DQUOTE] = ACTIONS(3818),
    [anon_sym_LR_DQUOTE] = ACTIONS(3818),
    [anon_sym_uR_DQUOTE] = ACTIONS(3818),
    [anon_sym_UR_DQUOTE] = ACTIONS(3818),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3818),
    [anon_sym_co_await] = ACTIONS(3816),
    [anon_sym_new] = ACTIONS(3816),
    [anon_sym_requires] = ACTIONS(3816),
    [sym_this] = ACTIONS(3816),
    [anon_sym_discard] = ACTIONS(3816),
    [anon_sym_precise] = ACTIONS(3816),
    [anon_sym_shared] = ACTIONS(3816),
    [anon_sym_groupshared] = ACTIONS(3816),
    [anon_sym_uniform] = ACTIONS(3816),
    [anon_sym_row_major] = ACTIONS(3816),
    [anon_sym_column_major] = ACTIONS(3816),
    [anon_sym_globallycoherent] = ACTIONS(3816),
    [anon_sym_centroid] = ACTIONS(3816),
    [anon_sym_noperspective] = ACTIONS(3816),
    [anon_sym_nointerpolation] = ACTIONS(3816),
    [anon_sym_sample] = ACTIONS(3816),
    [anon_sym_linear] = ACTIONS(3816),
    [anon_sym_snorm] = ACTIONS(3816),
    [anon_sym_unorm] = ACTIONS(3816),
    [anon_sym_point] = ACTIONS(3816),
    [anon_sym_line] = ACTIONS(3816),
    [anon_sym_triangleadj] = ACTIONS(3816),
    [anon_sym_lineadj] = ACTIONS(3816),
    [anon_sym_triangle] = ACTIONS(3816),
    [anon_sym_cbuffer] = ACTIONS(3816),
    [anon_sym_interface] = ACTIONS(3816),
    [anon_sym_extension] = ACTIONS(3816),
  },
  [975] = {
    [sym_identifier] = ACTIONS(3820),
    [aux_sym_preproc_include_token1] = ACTIONS(3820),
    [aux_sym_preproc_def_token1] = ACTIONS(3820),
    [aux_sym_preproc_if_token1] = ACTIONS(3820),
    [aux_sym_preproc_if_token2] = ACTIONS(3820),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3820),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3820),
    [sym_preproc_directive] = ACTIONS(3820),
    [anon_sym_LPAREN2] = ACTIONS(3822),
    [anon_sym_BANG] = ACTIONS(3822),
    [anon_sym_TILDE] = ACTIONS(3822),
    [anon_sym_DASH] = ACTIONS(3820),
    [anon_sym_PLUS] = ACTIONS(3820),
    [anon_sym_STAR] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3822),
    [anon_sym_AMP] = ACTIONS(3820),
    [anon_sym_SEMI] = ACTIONS(3822),
    [anon_sym___extension__] = ACTIONS(3820),
    [anon_sym_typedef] = ACTIONS(3820),
    [anon_sym_in] = ACTIONS(3820),
    [anon_sym_out] = ACTIONS(3820),
    [anon_sym_inout] = ACTIONS(3820),
    [anon_sym_virtual] = ACTIONS(3820),
    [anon_sym_extern] = ACTIONS(3820),
    [anon_sym___attribute__] = ACTIONS(3820),
    [anon_sym___attribute] = ACTIONS(3820),
    [anon_sym_using] = ACTIONS(3820),
    [anon_sym_COLON_COLON] = ACTIONS(3822),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3822),
    [anon_sym___declspec] = ACTIONS(3820),
    [anon_sym___based] = ACTIONS(3820),
    [anon_sym___cdecl] = ACTIONS(3820),
    [anon_sym___clrcall] = ACTIONS(3820),
    [anon_sym___stdcall] = ACTIONS(3820),
    [anon_sym___fastcall] = ACTIONS(3820),
    [anon_sym___thiscall] = ACTIONS(3820),
    [anon_sym___vectorcall] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3822),
    [anon_sym_signed] = ACTIONS(3820),
    [anon_sym_unsigned] = ACTIONS(3820),
    [anon_sym_long] = ACTIONS(3820),
    [anon_sym_short] = ACTIONS(3820),
    [anon_sym_LBRACK] = ACTIONS(3820),
    [anon_sym_static] = ACTIONS(3820),
    [anon_sym_register] = ACTIONS(3820),
    [anon_sym_inline] = ACTIONS(3820),
    [anon_sym___inline] = ACTIONS(3820),
    [anon_sym___inline__] = ACTIONS(3820),
    [anon_sym___forceinline] = ACTIONS(3820),
    [anon_sym_thread_local] = ACTIONS(3820),
    [anon_sym___thread] = ACTIONS(3820),
    [anon_sym_const] = ACTIONS(3820),
    [anon_sym_constexpr] = ACTIONS(3820),
    [anon_sym_volatile] = ACTIONS(3820),
    [anon_sym_restrict] = ACTIONS(3820),
    [anon_sym___restrict__] = ACTIONS(3820),
    [anon_sym__Atomic] = ACTIONS(3820),
    [anon_sym__Noreturn] = ACTIONS(3820),
    [anon_sym_noreturn] = ACTIONS(3820),
    [anon_sym__Nonnull] = ACTIONS(3820),
    [anon_sym_mutable] = ACTIONS(3820),
    [anon_sym_constinit] = ACTIONS(3820),
    [anon_sym_consteval] = ACTIONS(3820),
    [anon_sym_alignas] = ACTIONS(3820),
    [anon_sym__Alignas] = ACTIONS(3820),
    [sym_primitive_type] = ACTIONS(3820),
    [anon_sym_enum] = ACTIONS(3820),
    [anon_sym_class] = ACTIONS(3820),
    [anon_sym_struct] = ACTIONS(3820),
    [anon_sym_union] = ACTIONS(3820),
    [anon_sym_if] = ACTIONS(3820),
    [anon_sym_switch] = ACTIONS(3820),
    [anon_sym_case] = ACTIONS(3820),
    [anon_sym_default] = ACTIONS(3820),
    [anon_sym_while] = ACTIONS(3820),
    [anon_sym_do] = ACTIONS(3820),
    [anon_sym_for] = ACTIONS(3820),
    [anon_sym_return] = ACTIONS(3820),
    [anon_sym_break] = ACTIONS(3820),
    [anon_sym_continue] = ACTIONS(3820),
    [anon_sym_goto] = ACTIONS(3820),
    [anon_sym___try] = ACTIONS(3820),
    [anon_sym___leave] = ACTIONS(3820),
    [anon_sym_not] = ACTIONS(3820),
    [anon_sym_compl] = ACTIONS(3820),
    [anon_sym_DASH_DASH] = ACTIONS(3822),
    [anon_sym_PLUS_PLUS] = ACTIONS(3822),
    [anon_sym_sizeof] = ACTIONS(3820),
    [anon_sym___alignof__] = ACTIONS(3820),
    [anon_sym___alignof] = ACTIONS(3820),
    [anon_sym__alignof] = ACTIONS(3820),
    [anon_sym_alignof] = ACTIONS(3820),
    [anon_sym__Alignof] = ACTIONS(3820),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3820),
    [anon_sym_asm] = ACTIONS(3820),
    [anon_sym___asm__] = ACTIONS(3820),
    [anon_sym___asm] = ACTIONS(3820),
    [sym_number_literal] = ACTIONS(3822),
    [anon_sym_L_SQUOTE] = ACTIONS(3822),
    [anon_sym_u_SQUOTE] = ACTIONS(3822),
    [anon_sym_U_SQUOTE] = ACTIONS(3822),
    [anon_sym_u8_SQUOTE] = ACTIONS(3822),
    [anon_sym_SQUOTE] = ACTIONS(3822),
    [anon_sym_L_DQUOTE] = ACTIONS(3822),
    [anon_sym_u_DQUOTE] = ACTIONS(3822),
    [anon_sym_U_DQUOTE] = ACTIONS(3822),
    [anon_sym_u8_DQUOTE] = ACTIONS(3822),
    [anon_sym_DQUOTE] = ACTIONS(3822),
    [sym_true] = ACTIONS(3820),
    [sym_false] = ACTIONS(3820),
    [anon_sym_NULL] = ACTIONS(3820),
    [anon_sym_nullptr] = ACTIONS(3820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3820),
    [anon_sym_let] = ACTIONS(3820),
    [anon_sym_This] = ACTIONS(3820),
    [anon_sym_decltype] = ACTIONS(3820),
    [anon_sym_explicit] = ACTIONS(3820),
    [anon_sym_typename] = ACTIONS(3820),
    [anon_sym_template] = ACTIONS(3820),
    [anon_sym_operator] = ACTIONS(3820),
    [anon_sym_try] = ACTIONS(3820),
    [anon_sym_delete] = ACTIONS(3820),
    [anon_sym_throw] = ACTIONS(3820),
    [anon_sym_namespace] = ACTIONS(3820),
    [anon_sym_static_assert] = ACTIONS(3820),
    [anon_sym_concept] = ACTIONS(3820),
    [anon_sym_co_return] = ACTIONS(3820),
    [anon_sym_co_yield] = ACTIONS(3820),
    [anon_sym_R_DQUOTE] = ACTIONS(3822),
    [anon_sym_LR_DQUOTE] = ACTIONS(3822),
    [anon_sym_uR_DQUOTE] = ACTIONS(3822),
    [anon_sym_UR_DQUOTE] = ACTIONS(3822),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3822),
    [anon_sym_co_await] = ACTIONS(3820),
    [anon_sym_new] = ACTIONS(3820),
    [anon_sym_requires] = ACTIONS(3820),
    [sym_this] = ACTIONS(3820),
    [anon_sym_discard] = ACTIONS(3820),
    [anon_sym_precise] = ACTIONS(3820),
    [anon_sym_shared] = ACTIONS(3820),
    [anon_sym_groupshared] = ACTIONS(3820),
    [anon_sym_uniform] = ACTIONS(3820),
    [anon_sym_row_major] = ACTIONS(3820),
    [anon_sym_column_major] = ACTIONS(3820),
    [anon_sym_globallycoherent] = ACTIONS(3820),
    [anon_sym_centroid] = ACTIONS(3820),
    [anon_sym_noperspective] = ACTIONS(3820),
    [anon_sym_nointerpolation] = ACTIONS(3820),
    [anon_sym_sample] = ACTIONS(3820),
    [anon_sym_linear] = ACTIONS(3820),
    [anon_sym_snorm] = ACTIONS(3820),
    [anon_sym_unorm] = ACTIONS(3820),
    [anon_sym_point] = ACTIONS(3820),
    [anon_sym_line] = ACTIONS(3820),
    [anon_sym_triangleadj] = ACTIONS(3820),
    [anon_sym_lineadj] = ACTIONS(3820),
    [anon_sym_triangle] = ACTIONS(3820),
    [anon_sym_cbuffer] = ACTIONS(3820),
    [anon_sym_interface] = ACTIONS(3820),
    [anon_sym_extension] = ACTIONS(3820),
  },
  [976] = {
    [sym_identifier] = ACTIONS(3824),
    [aux_sym_preproc_include_token1] = ACTIONS(3824),
    [aux_sym_preproc_def_token1] = ACTIONS(3824),
    [aux_sym_preproc_if_token1] = ACTIONS(3824),
    [aux_sym_preproc_if_token2] = ACTIONS(3824),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3824),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3824),
    [sym_preproc_directive] = ACTIONS(3824),
    [anon_sym_LPAREN2] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3826),
    [anon_sym_TILDE] = ACTIONS(3826),
    [anon_sym_DASH] = ACTIONS(3824),
    [anon_sym_PLUS] = ACTIONS(3824),
    [anon_sym_STAR] = ACTIONS(3826),
    [anon_sym_AMP_AMP] = ACTIONS(3826),
    [anon_sym_AMP] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(3826),
    [anon_sym___extension__] = ACTIONS(3824),
    [anon_sym_typedef] = ACTIONS(3824),
    [anon_sym_in] = ACTIONS(3824),
    [anon_sym_out] = ACTIONS(3824),
    [anon_sym_inout] = ACTIONS(3824),
    [anon_sym_virtual] = ACTIONS(3824),
    [anon_sym_extern] = ACTIONS(3824),
    [anon_sym___attribute__] = ACTIONS(3824),
    [anon_sym___attribute] = ACTIONS(3824),
    [anon_sym_using] = ACTIONS(3824),
    [anon_sym_COLON_COLON] = ACTIONS(3826),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3826),
    [anon_sym___declspec] = ACTIONS(3824),
    [anon_sym___based] = ACTIONS(3824),
    [anon_sym___cdecl] = ACTIONS(3824),
    [anon_sym___clrcall] = ACTIONS(3824),
    [anon_sym___stdcall] = ACTIONS(3824),
    [anon_sym___fastcall] = ACTIONS(3824),
    [anon_sym___thiscall] = ACTIONS(3824),
    [anon_sym___vectorcall] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(3826),
    [anon_sym_signed] = ACTIONS(3824),
    [anon_sym_unsigned] = ACTIONS(3824),
    [anon_sym_long] = ACTIONS(3824),
    [anon_sym_short] = ACTIONS(3824),
    [anon_sym_LBRACK] = ACTIONS(3824),
    [anon_sym_static] = ACTIONS(3824),
    [anon_sym_register] = ACTIONS(3824),
    [anon_sym_inline] = ACTIONS(3824),
    [anon_sym___inline] = ACTIONS(3824),
    [anon_sym___inline__] = ACTIONS(3824),
    [anon_sym___forceinline] = ACTIONS(3824),
    [anon_sym_thread_local] = ACTIONS(3824),
    [anon_sym___thread] = ACTIONS(3824),
    [anon_sym_const] = ACTIONS(3824),
    [anon_sym_constexpr] = ACTIONS(3824),
    [anon_sym_volatile] = ACTIONS(3824),
    [anon_sym_restrict] = ACTIONS(3824),
    [anon_sym___restrict__] = ACTIONS(3824),
    [anon_sym__Atomic] = ACTIONS(3824),
    [anon_sym__Noreturn] = ACTIONS(3824),
    [anon_sym_noreturn] = ACTIONS(3824),
    [anon_sym__Nonnull] = ACTIONS(3824),
    [anon_sym_mutable] = ACTIONS(3824),
    [anon_sym_constinit] = ACTIONS(3824),
    [anon_sym_consteval] = ACTIONS(3824),
    [anon_sym_alignas] = ACTIONS(3824),
    [anon_sym__Alignas] = ACTIONS(3824),
    [sym_primitive_type] = ACTIONS(3824),
    [anon_sym_enum] = ACTIONS(3824),
    [anon_sym_class] = ACTIONS(3824),
    [anon_sym_struct] = ACTIONS(3824),
    [anon_sym_union] = ACTIONS(3824),
    [anon_sym_if] = ACTIONS(3824),
    [anon_sym_switch] = ACTIONS(3824),
    [anon_sym_case] = ACTIONS(3824),
    [anon_sym_default] = ACTIONS(3824),
    [anon_sym_while] = ACTIONS(3824),
    [anon_sym_do] = ACTIONS(3824),
    [anon_sym_for] = ACTIONS(3824),
    [anon_sym_return] = ACTIONS(3824),
    [anon_sym_break] = ACTIONS(3824),
    [anon_sym_continue] = ACTIONS(3824),
    [anon_sym_goto] = ACTIONS(3824),
    [anon_sym___try] = ACTIONS(3824),
    [anon_sym___leave] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3824),
    [anon_sym_compl] = ACTIONS(3824),
    [anon_sym_DASH_DASH] = ACTIONS(3826),
    [anon_sym_PLUS_PLUS] = ACTIONS(3826),
    [anon_sym_sizeof] = ACTIONS(3824),
    [anon_sym___alignof__] = ACTIONS(3824),
    [anon_sym___alignof] = ACTIONS(3824),
    [anon_sym__alignof] = ACTIONS(3824),
    [anon_sym_alignof] = ACTIONS(3824),
    [anon_sym__Alignof] = ACTIONS(3824),
    [anon_sym_offsetof] = ACTIONS(3824),
    [anon_sym__Generic] = ACTIONS(3824),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3826),
    [anon_sym_u_SQUOTE] = ACTIONS(3826),
    [anon_sym_U_SQUOTE] = ACTIONS(3826),
    [anon_sym_u8_SQUOTE] = ACTIONS(3826),
    [anon_sym_SQUOTE] = ACTIONS(3826),
    [anon_sym_L_DQUOTE] = ACTIONS(3826),
    [anon_sym_u_DQUOTE] = ACTIONS(3826),
    [anon_sym_U_DQUOTE] = ACTIONS(3826),
    [anon_sym_u8_DQUOTE] = ACTIONS(3826),
    [anon_sym_DQUOTE] = ACTIONS(3826),
    [sym_true] = ACTIONS(3824),
    [sym_false] = ACTIONS(3824),
    [anon_sym_NULL] = ACTIONS(3824),
    [anon_sym_nullptr] = ACTIONS(3824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3824),
    [anon_sym_let] = ACTIONS(3824),
    [anon_sym_This] = ACTIONS(3824),
    [anon_sym_decltype] = ACTIONS(3824),
    [anon_sym_explicit] = ACTIONS(3824),
    [anon_sym_typename] = ACTIONS(3824),
    [anon_sym_template] = ACTIONS(3824),
    [anon_sym_operator] = ACTIONS(3824),
    [anon_sym_try] = ACTIONS(3824),
    [anon_sym_delete] = ACTIONS(3824),
    [anon_sym_throw] = ACTIONS(3824),
    [anon_sym_namespace] = ACTIONS(3824),
    [anon_sym_static_assert] = ACTIONS(3824),
    [anon_sym_concept] = ACTIONS(3824),
    [anon_sym_co_return] = ACTIONS(3824),
    [anon_sym_co_yield] = ACTIONS(3824),
    [anon_sym_R_DQUOTE] = ACTIONS(3826),
    [anon_sym_LR_DQUOTE] = ACTIONS(3826),
    [anon_sym_uR_DQUOTE] = ACTIONS(3826),
    [anon_sym_UR_DQUOTE] = ACTIONS(3826),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3826),
    [anon_sym_co_await] = ACTIONS(3824),
    [anon_sym_new] = ACTIONS(3824),
    [anon_sym_requires] = ACTIONS(3824),
    [sym_this] = ACTIONS(3824),
    [anon_sym_discard] = ACTIONS(3824),
    [anon_sym_precise] = ACTIONS(3824),
    [anon_sym_shared] = ACTIONS(3824),
    [anon_sym_groupshared] = ACTIONS(3824),
    [anon_sym_uniform] = ACTIONS(3824),
    [anon_sym_row_major] = ACTIONS(3824),
    [anon_sym_column_major] = ACTIONS(3824),
    [anon_sym_globallycoherent] = ACTIONS(3824),
    [anon_sym_centroid] = ACTIONS(3824),
    [anon_sym_noperspective] = ACTIONS(3824),
    [anon_sym_nointerpolation] = ACTIONS(3824),
    [anon_sym_sample] = ACTIONS(3824),
    [anon_sym_linear] = ACTIONS(3824),
    [anon_sym_snorm] = ACTIONS(3824),
    [anon_sym_unorm] = ACTIONS(3824),
    [anon_sym_point] = ACTIONS(3824),
    [anon_sym_line] = ACTIONS(3824),
    [anon_sym_triangleadj] = ACTIONS(3824),
    [anon_sym_lineadj] = ACTIONS(3824),
    [anon_sym_triangle] = ACTIONS(3824),
    [anon_sym_cbuffer] = ACTIONS(3824),
    [anon_sym_interface] = ACTIONS(3824),
    [anon_sym_extension] = ACTIONS(3824),
  },
  [977] = {
    [sym_identifier] = ACTIONS(3735),
    [aux_sym_preproc_include_token1] = ACTIONS(3735),
    [aux_sym_preproc_def_token1] = ACTIONS(3735),
    [aux_sym_preproc_if_token1] = ACTIONS(3735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3735),
    [sym_preproc_directive] = ACTIONS(3735),
    [anon_sym_LPAREN2] = ACTIONS(3737),
    [anon_sym_BANG] = ACTIONS(3737),
    [anon_sym_TILDE] = ACTIONS(3737),
    [anon_sym_DASH] = ACTIONS(3735),
    [anon_sym_PLUS] = ACTIONS(3735),
    [anon_sym_STAR] = ACTIONS(3737),
    [anon_sym_AMP_AMP] = ACTIONS(3737),
    [anon_sym_AMP] = ACTIONS(3735),
    [anon_sym_SEMI] = ACTIONS(3737),
    [anon_sym___extension__] = ACTIONS(3735),
    [anon_sym_typedef] = ACTIONS(3735),
    [anon_sym_in] = ACTIONS(3735),
    [anon_sym_out] = ACTIONS(3735),
    [anon_sym_inout] = ACTIONS(3735),
    [anon_sym_virtual] = ACTIONS(3735),
    [anon_sym_extern] = ACTIONS(3735),
    [anon_sym___attribute__] = ACTIONS(3735),
    [anon_sym___attribute] = ACTIONS(3735),
    [anon_sym_using] = ACTIONS(3735),
    [anon_sym_COLON_COLON] = ACTIONS(3737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3737),
    [anon_sym___declspec] = ACTIONS(3735),
    [anon_sym___based] = ACTIONS(3735),
    [anon_sym___cdecl] = ACTIONS(3735),
    [anon_sym___clrcall] = ACTIONS(3735),
    [anon_sym___stdcall] = ACTIONS(3735),
    [anon_sym___fastcall] = ACTIONS(3735),
    [anon_sym___thiscall] = ACTIONS(3735),
    [anon_sym___vectorcall] = ACTIONS(3735),
    [anon_sym_LBRACE] = ACTIONS(3737),
    [anon_sym_RBRACE] = ACTIONS(3737),
    [anon_sym_signed] = ACTIONS(3735),
    [anon_sym_unsigned] = ACTIONS(3735),
    [anon_sym_long] = ACTIONS(3735),
    [anon_sym_short] = ACTIONS(3735),
    [anon_sym_LBRACK] = ACTIONS(3735),
    [anon_sym_static] = ACTIONS(3735),
    [anon_sym_register] = ACTIONS(3735),
    [anon_sym_inline] = ACTIONS(3735),
    [anon_sym___inline] = ACTIONS(3735),
    [anon_sym___inline__] = ACTIONS(3735),
    [anon_sym___forceinline] = ACTIONS(3735),
    [anon_sym_thread_local] = ACTIONS(3735),
    [anon_sym___thread] = ACTIONS(3735),
    [anon_sym_const] = ACTIONS(3735),
    [anon_sym_constexpr] = ACTIONS(3735),
    [anon_sym_volatile] = ACTIONS(3735),
    [anon_sym_restrict] = ACTIONS(3735),
    [anon_sym___restrict__] = ACTIONS(3735),
    [anon_sym__Atomic] = ACTIONS(3735),
    [anon_sym__Noreturn] = ACTIONS(3735),
    [anon_sym_noreturn] = ACTIONS(3735),
    [anon_sym__Nonnull] = ACTIONS(3735),
    [anon_sym_mutable] = ACTIONS(3735),
    [anon_sym_constinit] = ACTIONS(3735),
    [anon_sym_consteval] = ACTIONS(3735),
    [anon_sym_alignas] = ACTIONS(3735),
    [anon_sym__Alignas] = ACTIONS(3735),
    [sym_primitive_type] = ACTIONS(3735),
    [anon_sym_enum] = ACTIONS(3735),
    [anon_sym_class] = ACTIONS(3735),
    [anon_sym_struct] = ACTIONS(3735),
    [anon_sym_union] = ACTIONS(3735),
    [anon_sym_if] = ACTIONS(3735),
    [anon_sym_switch] = ACTIONS(3735),
    [anon_sym_case] = ACTIONS(3735),
    [anon_sym_default] = ACTIONS(3735),
    [anon_sym_while] = ACTIONS(3735),
    [anon_sym_do] = ACTIONS(3735),
    [anon_sym_for] = ACTIONS(3735),
    [anon_sym_return] = ACTIONS(3735),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_continue] = ACTIONS(3735),
    [anon_sym_goto] = ACTIONS(3735),
    [anon_sym___try] = ACTIONS(3735),
    [anon_sym___leave] = ACTIONS(3735),
    [anon_sym_not] = ACTIONS(3735),
    [anon_sym_compl] = ACTIONS(3735),
    [anon_sym_DASH_DASH] = ACTIONS(3737),
    [anon_sym_PLUS_PLUS] = ACTIONS(3737),
    [anon_sym_sizeof] = ACTIONS(3735),
    [anon_sym___alignof__] = ACTIONS(3735),
    [anon_sym___alignof] = ACTIONS(3735),
    [anon_sym__alignof] = ACTIONS(3735),
    [anon_sym_alignof] = ACTIONS(3735),
    [anon_sym__Alignof] = ACTIONS(3735),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3735),
    [anon_sym_asm] = ACTIONS(3735),
    [anon_sym___asm__] = ACTIONS(3735),
    [anon_sym___asm] = ACTIONS(3735),
    [sym_number_literal] = ACTIONS(3737),
    [anon_sym_L_SQUOTE] = ACTIONS(3737),
    [anon_sym_u_SQUOTE] = ACTIONS(3737),
    [anon_sym_U_SQUOTE] = ACTIONS(3737),
    [anon_sym_u8_SQUOTE] = ACTIONS(3737),
    [anon_sym_SQUOTE] = ACTIONS(3737),
    [anon_sym_L_DQUOTE] = ACTIONS(3737),
    [anon_sym_u_DQUOTE] = ACTIONS(3737),
    [anon_sym_U_DQUOTE] = ACTIONS(3737),
    [anon_sym_u8_DQUOTE] = ACTIONS(3737),
    [anon_sym_DQUOTE] = ACTIONS(3737),
    [sym_true] = ACTIONS(3735),
    [sym_false] = ACTIONS(3735),
    [anon_sym_NULL] = ACTIONS(3735),
    [anon_sym_nullptr] = ACTIONS(3735),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3735),
    [anon_sym_let] = ACTIONS(3735),
    [anon_sym_This] = ACTIONS(3735),
    [anon_sym_decltype] = ACTIONS(3735),
    [anon_sym_explicit] = ACTIONS(3735),
    [anon_sym_typename] = ACTIONS(3735),
    [anon_sym_template] = ACTIONS(3735),
    [anon_sym_operator] = ACTIONS(3735),
    [anon_sym_try] = ACTIONS(3735),
    [anon_sym_delete] = ACTIONS(3735),
    [anon_sym_throw] = ACTIONS(3735),
    [anon_sym_namespace] = ACTIONS(3735),
    [anon_sym_static_assert] = ACTIONS(3735),
    [anon_sym_concept] = ACTIONS(3735),
    [anon_sym_co_return] = ACTIONS(3735),
    [anon_sym_co_yield] = ACTIONS(3735),
    [anon_sym_R_DQUOTE] = ACTIONS(3737),
    [anon_sym_LR_DQUOTE] = ACTIONS(3737),
    [anon_sym_uR_DQUOTE] = ACTIONS(3737),
    [anon_sym_UR_DQUOTE] = ACTIONS(3737),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3737),
    [anon_sym_co_await] = ACTIONS(3735),
    [anon_sym_new] = ACTIONS(3735),
    [anon_sym_requires] = ACTIONS(3735),
    [sym_this] = ACTIONS(3735),
    [anon_sym_discard] = ACTIONS(3735),
    [anon_sym_precise] = ACTIONS(3735),
    [anon_sym_shared] = ACTIONS(3735),
    [anon_sym_groupshared] = ACTIONS(3735),
    [anon_sym_uniform] = ACTIONS(3735),
    [anon_sym_row_major] = ACTIONS(3735),
    [anon_sym_column_major] = ACTIONS(3735),
    [anon_sym_globallycoherent] = ACTIONS(3735),
    [anon_sym_centroid] = ACTIONS(3735),
    [anon_sym_noperspective] = ACTIONS(3735),
    [anon_sym_nointerpolation] = ACTIONS(3735),
    [anon_sym_sample] = ACTIONS(3735),
    [anon_sym_linear] = ACTIONS(3735),
    [anon_sym_snorm] = ACTIONS(3735),
    [anon_sym_unorm] = ACTIONS(3735),
    [anon_sym_point] = ACTIONS(3735),
    [anon_sym_line] = ACTIONS(3735),
    [anon_sym_triangleadj] = ACTIONS(3735),
    [anon_sym_lineadj] = ACTIONS(3735),
    [anon_sym_triangle] = ACTIONS(3735),
    [anon_sym_cbuffer] = ACTIONS(3735),
    [anon_sym_interface] = ACTIONS(3735),
    [anon_sym_extension] = ACTIONS(3735),
  },
  [978] = {
    [sym_identifier] = ACTIONS(3853),
    [aux_sym_preproc_include_token1] = ACTIONS(3853),
    [aux_sym_preproc_def_token1] = ACTIONS(3853),
    [aux_sym_preproc_if_token1] = ACTIONS(3853),
    [aux_sym_preproc_if_token2] = ACTIONS(3853),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3853),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3853),
    [sym_preproc_directive] = ACTIONS(3853),
    [anon_sym_LPAREN2] = ACTIONS(3855),
    [anon_sym_BANG] = ACTIONS(3855),
    [anon_sym_TILDE] = ACTIONS(3855),
    [anon_sym_DASH] = ACTIONS(3853),
    [anon_sym_PLUS] = ACTIONS(3853),
    [anon_sym_STAR] = ACTIONS(3855),
    [anon_sym_AMP_AMP] = ACTIONS(3855),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_SEMI] = ACTIONS(3855),
    [anon_sym___extension__] = ACTIONS(3853),
    [anon_sym_typedef] = ACTIONS(3853),
    [anon_sym_in] = ACTIONS(3853),
    [anon_sym_out] = ACTIONS(3853),
    [anon_sym_inout] = ACTIONS(3853),
    [anon_sym_virtual] = ACTIONS(3853),
    [anon_sym_extern] = ACTIONS(3853),
    [anon_sym___attribute__] = ACTIONS(3853),
    [anon_sym___attribute] = ACTIONS(3853),
    [anon_sym_using] = ACTIONS(3853),
    [anon_sym_COLON_COLON] = ACTIONS(3855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3855),
    [anon_sym___declspec] = ACTIONS(3853),
    [anon_sym___based] = ACTIONS(3853),
    [anon_sym___cdecl] = ACTIONS(3853),
    [anon_sym___clrcall] = ACTIONS(3853),
    [anon_sym___stdcall] = ACTIONS(3853),
    [anon_sym___fastcall] = ACTIONS(3853),
    [anon_sym___thiscall] = ACTIONS(3853),
    [anon_sym___vectorcall] = ACTIONS(3853),
    [anon_sym_LBRACE] = ACTIONS(3855),
    [anon_sym_signed] = ACTIONS(3853),
    [anon_sym_unsigned] = ACTIONS(3853),
    [anon_sym_long] = ACTIONS(3853),
    [anon_sym_short] = ACTIONS(3853),
    [anon_sym_LBRACK] = ACTIONS(3853),
    [anon_sym_static] = ACTIONS(3853),
    [anon_sym_register] = ACTIONS(3853),
    [anon_sym_inline] = ACTIONS(3853),
    [anon_sym___inline] = ACTIONS(3853),
    [anon_sym___inline__] = ACTIONS(3853),
    [anon_sym___forceinline] = ACTIONS(3853),
    [anon_sym_thread_local] = ACTIONS(3853),
    [anon_sym___thread] = ACTIONS(3853),
    [anon_sym_const] = ACTIONS(3853),
    [anon_sym_constexpr] = ACTIONS(3853),
    [anon_sym_volatile] = ACTIONS(3853),
    [anon_sym_restrict] = ACTIONS(3853),
    [anon_sym___restrict__] = ACTIONS(3853),
    [anon_sym__Atomic] = ACTIONS(3853),
    [anon_sym__Noreturn] = ACTIONS(3853),
    [anon_sym_noreturn] = ACTIONS(3853),
    [anon_sym__Nonnull] = ACTIONS(3853),
    [anon_sym_mutable] = ACTIONS(3853),
    [anon_sym_constinit] = ACTIONS(3853),
    [anon_sym_consteval] = ACTIONS(3853),
    [anon_sym_alignas] = ACTIONS(3853),
    [anon_sym__Alignas] = ACTIONS(3853),
    [sym_primitive_type] = ACTIONS(3853),
    [anon_sym_enum] = ACTIONS(3853),
    [anon_sym_class] = ACTIONS(3853),
    [anon_sym_struct] = ACTIONS(3853),
    [anon_sym_union] = ACTIONS(3853),
    [anon_sym_if] = ACTIONS(3853),
    [anon_sym_switch] = ACTIONS(3853),
    [anon_sym_case] = ACTIONS(3853),
    [anon_sym_default] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3853),
    [anon_sym_do] = ACTIONS(3853),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_return] = ACTIONS(3853),
    [anon_sym_break] = ACTIONS(3853),
    [anon_sym_continue] = ACTIONS(3853),
    [anon_sym_goto] = ACTIONS(3853),
    [anon_sym___try] = ACTIONS(3853),
    [anon_sym___leave] = ACTIONS(3853),
    [anon_sym_not] = ACTIONS(3853),
    [anon_sym_compl] = ACTIONS(3853),
    [anon_sym_DASH_DASH] = ACTIONS(3855),
    [anon_sym_PLUS_PLUS] = ACTIONS(3855),
    [anon_sym_sizeof] = ACTIONS(3853),
    [anon_sym___alignof__] = ACTIONS(3853),
    [anon_sym___alignof] = ACTIONS(3853),
    [anon_sym__alignof] = ACTIONS(3853),
    [anon_sym_alignof] = ACTIONS(3853),
    [anon_sym__Alignof] = ACTIONS(3853),
    [anon_sym_offsetof] = ACTIONS(3853),
    [anon_sym__Generic] = ACTIONS(3853),
    [anon_sym_asm] = ACTIONS(3853),
    [anon_sym___asm__] = ACTIONS(3853),
    [anon_sym___asm] = ACTIONS(3853),
    [sym_number_literal] = ACTIONS(3855),
    [anon_sym_L_SQUOTE] = ACTIONS(3855),
    [anon_sym_u_SQUOTE] = ACTIONS(3855),
    [anon_sym_U_SQUOTE] = ACTIONS(3855),
    [anon_sym_u8_SQUOTE] = ACTIONS(3855),
    [anon_sym_SQUOTE] = ACTIONS(3855),
    [anon_sym_L_DQUOTE] = ACTIONS(3855),
    [anon_sym_u_DQUOTE] = ACTIONS(3855),
    [anon_sym_U_DQUOTE] = ACTIONS(3855),
    [anon_sym_u8_DQUOTE] = ACTIONS(3855),
    [anon_sym_DQUOTE] = ACTIONS(3855),
    [sym_true] = ACTIONS(3853),
    [sym_false] = ACTIONS(3853),
    [anon_sym_NULL] = ACTIONS(3853),
    [anon_sym_nullptr] = ACTIONS(3853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3853),
    [anon_sym_let] = ACTIONS(3853),
    [anon_sym_This] = ACTIONS(3853),
    [anon_sym_decltype] = ACTIONS(3853),
    [anon_sym_explicit] = ACTIONS(3853),
    [anon_sym_typename] = ACTIONS(3853),
    [anon_sym_template] = ACTIONS(3853),
    [anon_sym_operator] = ACTIONS(3853),
    [anon_sym_try] = ACTIONS(3853),
    [anon_sym_delete] = ACTIONS(3853),
    [anon_sym_throw] = ACTIONS(3853),
    [anon_sym_namespace] = ACTIONS(3853),
    [anon_sym_static_assert] = ACTIONS(3853),
    [anon_sym_concept] = ACTIONS(3853),
    [anon_sym_co_return] = ACTIONS(3853),
    [anon_sym_co_yield] = ACTIONS(3853),
    [anon_sym_R_DQUOTE] = ACTIONS(3855),
    [anon_sym_LR_DQUOTE] = ACTIONS(3855),
    [anon_sym_uR_DQUOTE] = ACTIONS(3855),
    [anon_sym_UR_DQUOTE] = ACTIONS(3855),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3855),
    [anon_sym_co_await] = ACTIONS(3853),
    [anon_sym_new] = ACTIONS(3853),
    [anon_sym_requires] = ACTIONS(3853),
    [sym_this] = ACTIONS(3853),
    [anon_sym_discard] = ACTIONS(3853),
    [anon_sym_precise] = ACTIONS(3853),
    [anon_sym_shared] = ACTIONS(3853),
    [anon_sym_groupshared] = ACTIONS(3853),
    [anon_sym_uniform] = ACTIONS(3853),
    [anon_sym_row_major] = ACTIONS(3853),
    [anon_sym_column_major] = ACTIONS(3853),
    [anon_sym_globallycoherent] = ACTIONS(3853),
    [anon_sym_centroid] = ACTIONS(3853),
    [anon_sym_noperspective] = ACTIONS(3853),
    [anon_sym_nointerpolation] = ACTIONS(3853),
    [anon_sym_sample] = ACTIONS(3853),
    [anon_sym_linear] = ACTIONS(3853),
    [anon_sym_snorm] = ACTIONS(3853),
    [anon_sym_unorm] = ACTIONS(3853),
    [anon_sym_point] = ACTIONS(3853),
    [anon_sym_line] = ACTIONS(3853),
    [anon_sym_triangleadj] = ACTIONS(3853),
    [anon_sym_lineadj] = ACTIONS(3853),
    [anon_sym_triangle] = ACTIONS(3853),
    [anon_sym_cbuffer] = ACTIONS(3853),
    [anon_sym_interface] = ACTIONS(3853),
    [anon_sym_extension] = ACTIONS(3853),
  },
  [979] = {
    [sym_identifier] = ACTIONS(3845),
    [aux_sym_preproc_include_token1] = ACTIONS(3845),
    [aux_sym_preproc_def_token1] = ACTIONS(3845),
    [aux_sym_preproc_if_token1] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3845),
    [sym_preproc_directive] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3847),
    [anon_sym_BANG] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_STAR] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_SEMI] = ACTIONS(3847),
    [anon_sym___extension__] = ACTIONS(3845),
    [anon_sym_typedef] = ACTIONS(3845),
    [anon_sym_in] = ACTIONS(3845),
    [anon_sym_out] = ACTIONS(3845),
    [anon_sym_inout] = ACTIONS(3845),
    [anon_sym_virtual] = ACTIONS(3845),
    [anon_sym_extern] = ACTIONS(3845),
    [anon_sym___attribute__] = ACTIONS(3845),
    [anon_sym___attribute] = ACTIONS(3845),
    [anon_sym_using] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3847),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3847),
    [anon_sym___declspec] = ACTIONS(3845),
    [anon_sym___based] = ACTIONS(3845),
    [anon_sym___cdecl] = ACTIONS(3845),
    [anon_sym___clrcall] = ACTIONS(3845),
    [anon_sym___stdcall] = ACTIONS(3845),
    [anon_sym___fastcall] = ACTIONS(3845),
    [anon_sym___thiscall] = ACTIONS(3845),
    [anon_sym___vectorcall] = ACTIONS(3845),
    [anon_sym_LBRACE] = ACTIONS(3847),
    [anon_sym_RBRACE] = ACTIONS(3847),
    [anon_sym_signed] = ACTIONS(3845),
    [anon_sym_unsigned] = ACTIONS(3845),
    [anon_sym_long] = ACTIONS(3845),
    [anon_sym_short] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_static] = ACTIONS(3845),
    [anon_sym_register] = ACTIONS(3845),
    [anon_sym_inline] = ACTIONS(3845),
    [anon_sym___inline] = ACTIONS(3845),
    [anon_sym___inline__] = ACTIONS(3845),
    [anon_sym___forceinline] = ACTIONS(3845),
    [anon_sym_thread_local] = ACTIONS(3845),
    [anon_sym___thread] = ACTIONS(3845),
    [anon_sym_const] = ACTIONS(3845),
    [anon_sym_constexpr] = ACTIONS(3845),
    [anon_sym_volatile] = ACTIONS(3845),
    [anon_sym_restrict] = ACTIONS(3845),
    [anon_sym___restrict__] = ACTIONS(3845),
    [anon_sym__Atomic] = ACTIONS(3845),
    [anon_sym__Noreturn] = ACTIONS(3845),
    [anon_sym_noreturn] = ACTIONS(3845),
    [anon_sym__Nonnull] = ACTIONS(3845),
    [anon_sym_mutable] = ACTIONS(3845),
    [anon_sym_constinit] = ACTIONS(3845),
    [anon_sym_consteval] = ACTIONS(3845),
    [anon_sym_alignas] = ACTIONS(3845),
    [anon_sym__Alignas] = ACTIONS(3845),
    [sym_primitive_type] = ACTIONS(3845),
    [anon_sym_enum] = ACTIONS(3845),
    [anon_sym_class] = ACTIONS(3845),
    [anon_sym_struct] = ACTIONS(3845),
    [anon_sym_union] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_switch] = ACTIONS(3845),
    [anon_sym_case] = ACTIONS(3845),
    [anon_sym_default] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_break] = ACTIONS(3845),
    [anon_sym_continue] = ACTIONS(3845),
    [anon_sym_goto] = ACTIONS(3845),
    [anon_sym___try] = ACTIONS(3845),
    [anon_sym___leave] = ACTIONS(3845),
    [anon_sym_not] = ACTIONS(3845),
    [anon_sym_compl] = ACTIONS(3845),
    [anon_sym_DASH_DASH] = ACTIONS(3847),
    [anon_sym_PLUS_PLUS] = ACTIONS(3847),
    [anon_sym_sizeof] = ACTIONS(3845),
    [anon_sym___alignof__] = ACTIONS(3845),
    [anon_sym___alignof] = ACTIONS(3845),
    [anon_sym__alignof] = ACTIONS(3845),
    [anon_sym_alignof] = ACTIONS(3845),
    [anon_sym__Alignof] = ACTIONS(3845),
    [anon_sym_offsetof] = ACTIONS(3845),
    [anon_sym__Generic] = ACTIONS(3845),
    [anon_sym_asm] = ACTIONS(3845),
    [anon_sym___asm__] = ACTIONS(3845),
    [anon_sym___asm] = ACTIONS(3845),
    [sym_number_literal] = ACTIONS(3847),
    [anon_sym_L_SQUOTE] = ACTIONS(3847),
    [anon_sym_u_SQUOTE] = ACTIONS(3847),
    [anon_sym_U_SQUOTE] = ACTIONS(3847),
    [anon_sym_u8_SQUOTE] = ACTIONS(3847),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [anon_sym_L_DQUOTE] = ACTIONS(3847),
    [anon_sym_u_DQUOTE] = ACTIONS(3847),
    [anon_sym_U_DQUOTE] = ACTIONS(3847),
    [anon_sym_u8_DQUOTE] = ACTIONS(3847),
    [anon_sym_DQUOTE] = ACTIONS(3847),
    [sym_true] = ACTIONS(3845),
    [sym_false] = ACTIONS(3845),
    [anon_sym_NULL] = ACTIONS(3845),
    [anon_sym_nullptr] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_This] = ACTIONS(3845),
    [anon_sym_decltype] = ACTIONS(3845),
    [anon_sym_explicit] = ACTIONS(3845),
    [anon_sym_typename] = ACTIONS(3845),
    [anon_sym_template] = ACTIONS(3845),
    [anon_sym_operator] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_delete] = ACTIONS(3845),
    [anon_sym_throw] = ACTIONS(3845),
    [anon_sym_namespace] = ACTIONS(3845),
    [anon_sym_static_assert] = ACTIONS(3845),
    [anon_sym_concept] = ACTIONS(3845),
    [anon_sym_co_return] = ACTIONS(3845),
    [anon_sym_co_yield] = ACTIONS(3845),
    [anon_sym_R_DQUOTE] = ACTIONS(3847),
    [anon_sym_LR_DQUOTE] = ACTIONS(3847),
    [anon_sym_uR_DQUOTE] = ACTIONS(3847),
    [anon_sym_UR_DQUOTE] = ACTIONS(3847),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3847),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_requires] = ACTIONS(3845),
    [sym_this] = ACTIONS(3845),
    [anon_sym_discard] = ACTIONS(3845),
    [anon_sym_precise] = ACTIONS(3845),
    [anon_sym_shared] = ACTIONS(3845),
    [anon_sym_groupshared] = ACTIONS(3845),
    [anon_sym_uniform] = ACTIONS(3845),
    [anon_sym_row_major] = ACTIONS(3845),
    [anon_sym_column_major] = ACTIONS(3845),
    [anon_sym_globallycoherent] = ACTIONS(3845),
    [anon_sym_centroid] = ACTIONS(3845),
    [anon_sym_noperspective] = ACTIONS(3845),
    [anon_sym_nointerpolation] = ACTIONS(3845),
    [anon_sym_sample] = ACTIONS(3845),
    [anon_sym_linear] = ACTIONS(3845),
    [anon_sym_snorm] = ACTIONS(3845),
    [anon_sym_unorm] = ACTIONS(3845),
    [anon_sym_point] = ACTIONS(3845),
    [anon_sym_line] = ACTIONS(3845),
    [anon_sym_triangleadj] = ACTIONS(3845),
    [anon_sym_lineadj] = ACTIONS(3845),
    [anon_sym_triangle] = ACTIONS(3845),
    [anon_sym_cbuffer] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3845),
    [anon_sym_extension] = ACTIONS(3845),
  },
  [980] = {
    [sym_identifier] = ACTIONS(3845),
    [aux_sym_preproc_include_token1] = ACTIONS(3845),
    [aux_sym_preproc_def_token1] = ACTIONS(3845),
    [aux_sym_preproc_if_token1] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3845),
    [sym_preproc_directive] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3847),
    [anon_sym_BANG] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_STAR] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_SEMI] = ACTIONS(3847),
    [anon_sym___extension__] = ACTIONS(3845),
    [anon_sym_typedef] = ACTIONS(3845),
    [anon_sym_in] = ACTIONS(3845),
    [anon_sym_out] = ACTIONS(3845),
    [anon_sym_inout] = ACTIONS(3845),
    [anon_sym_virtual] = ACTIONS(3845),
    [anon_sym_extern] = ACTIONS(3845),
    [anon_sym___attribute__] = ACTIONS(3845),
    [anon_sym___attribute] = ACTIONS(3845),
    [anon_sym_using] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3847),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3847),
    [anon_sym___declspec] = ACTIONS(3845),
    [anon_sym___based] = ACTIONS(3845),
    [anon_sym___cdecl] = ACTIONS(3845),
    [anon_sym___clrcall] = ACTIONS(3845),
    [anon_sym___stdcall] = ACTIONS(3845),
    [anon_sym___fastcall] = ACTIONS(3845),
    [anon_sym___thiscall] = ACTIONS(3845),
    [anon_sym___vectorcall] = ACTIONS(3845),
    [anon_sym_LBRACE] = ACTIONS(3847),
    [anon_sym_RBRACE] = ACTIONS(3847),
    [anon_sym_signed] = ACTIONS(3845),
    [anon_sym_unsigned] = ACTIONS(3845),
    [anon_sym_long] = ACTIONS(3845),
    [anon_sym_short] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_static] = ACTIONS(3845),
    [anon_sym_register] = ACTIONS(3845),
    [anon_sym_inline] = ACTIONS(3845),
    [anon_sym___inline] = ACTIONS(3845),
    [anon_sym___inline__] = ACTIONS(3845),
    [anon_sym___forceinline] = ACTIONS(3845),
    [anon_sym_thread_local] = ACTIONS(3845),
    [anon_sym___thread] = ACTIONS(3845),
    [anon_sym_const] = ACTIONS(3845),
    [anon_sym_constexpr] = ACTIONS(3845),
    [anon_sym_volatile] = ACTIONS(3845),
    [anon_sym_restrict] = ACTIONS(3845),
    [anon_sym___restrict__] = ACTIONS(3845),
    [anon_sym__Atomic] = ACTIONS(3845),
    [anon_sym__Noreturn] = ACTIONS(3845),
    [anon_sym_noreturn] = ACTIONS(3845),
    [anon_sym__Nonnull] = ACTIONS(3845),
    [anon_sym_mutable] = ACTIONS(3845),
    [anon_sym_constinit] = ACTIONS(3845),
    [anon_sym_consteval] = ACTIONS(3845),
    [anon_sym_alignas] = ACTIONS(3845),
    [anon_sym__Alignas] = ACTIONS(3845),
    [sym_primitive_type] = ACTIONS(3845),
    [anon_sym_enum] = ACTIONS(3845),
    [anon_sym_class] = ACTIONS(3845),
    [anon_sym_struct] = ACTIONS(3845),
    [anon_sym_union] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_switch] = ACTIONS(3845),
    [anon_sym_case] = ACTIONS(3845),
    [anon_sym_default] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_break] = ACTIONS(3845),
    [anon_sym_continue] = ACTIONS(3845),
    [anon_sym_goto] = ACTIONS(3845),
    [anon_sym___try] = ACTIONS(3845),
    [anon_sym___leave] = ACTIONS(3845),
    [anon_sym_not] = ACTIONS(3845),
    [anon_sym_compl] = ACTIONS(3845),
    [anon_sym_DASH_DASH] = ACTIONS(3847),
    [anon_sym_PLUS_PLUS] = ACTIONS(3847),
    [anon_sym_sizeof] = ACTIONS(3845),
    [anon_sym___alignof__] = ACTIONS(3845),
    [anon_sym___alignof] = ACTIONS(3845),
    [anon_sym__alignof] = ACTIONS(3845),
    [anon_sym_alignof] = ACTIONS(3845),
    [anon_sym__Alignof] = ACTIONS(3845),
    [anon_sym_offsetof] = ACTIONS(3845),
    [anon_sym__Generic] = ACTIONS(3845),
    [anon_sym_asm] = ACTIONS(3845),
    [anon_sym___asm__] = ACTIONS(3845),
    [anon_sym___asm] = ACTIONS(3845),
    [sym_number_literal] = ACTIONS(3847),
    [anon_sym_L_SQUOTE] = ACTIONS(3847),
    [anon_sym_u_SQUOTE] = ACTIONS(3847),
    [anon_sym_U_SQUOTE] = ACTIONS(3847),
    [anon_sym_u8_SQUOTE] = ACTIONS(3847),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [anon_sym_L_DQUOTE] = ACTIONS(3847),
    [anon_sym_u_DQUOTE] = ACTIONS(3847),
    [anon_sym_U_DQUOTE] = ACTIONS(3847),
    [anon_sym_u8_DQUOTE] = ACTIONS(3847),
    [anon_sym_DQUOTE] = ACTIONS(3847),
    [sym_true] = ACTIONS(3845),
    [sym_false] = ACTIONS(3845),
    [anon_sym_NULL] = ACTIONS(3845),
    [anon_sym_nullptr] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_This] = ACTIONS(3845),
    [anon_sym_decltype] = ACTIONS(3845),
    [anon_sym_explicit] = ACTIONS(3845),
    [anon_sym_typename] = ACTIONS(3845),
    [anon_sym_template] = ACTIONS(3845),
    [anon_sym_operator] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_delete] = ACTIONS(3845),
    [anon_sym_throw] = ACTIONS(3845),
    [anon_sym_namespace] = ACTIONS(3845),
    [anon_sym_static_assert] = ACTIONS(3845),
    [anon_sym_concept] = ACTIONS(3845),
    [anon_sym_co_return] = ACTIONS(3845),
    [anon_sym_co_yield] = ACTIONS(3845),
    [anon_sym_R_DQUOTE] = ACTIONS(3847),
    [anon_sym_LR_DQUOTE] = ACTIONS(3847),
    [anon_sym_uR_DQUOTE] = ACTIONS(3847),
    [anon_sym_UR_DQUOTE] = ACTIONS(3847),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3847),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_requires] = ACTIONS(3845),
    [sym_this] = ACTIONS(3845),
    [anon_sym_discard] = ACTIONS(3845),
    [anon_sym_precise] = ACTIONS(3845),
    [anon_sym_shared] = ACTIONS(3845),
    [anon_sym_groupshared] = ACTIONS(3845),
    [anon_sym_uniform] = ACTIONS(3845),
    [anon_sym_row_major] = ACTIONS(3845),
    [anon_sym_column_major] = ACTIONS(3845),
    [anon_sym_globallycoherent] = ACTIONS(3845),
    [anon_sym_centroid] = ACTIONS(3845),
    [anon_sym_noperspective] = ACTIONS(3845),
    [anon_sym_nointerpolation] = ACTIONS(3845),
    [anon_sym_sample] = ACTIONS(3845),
    [anon_sym_linear] = ACTIONS(3845),
    [anon_sym_snorm] = ACTIONS(3845),
    [anon_sym_unorm] = ACTIONS(3845),
    [anon_sym_point] = ACTIONS(3845),
    [anon_sym_line] = ACTIONS(3845),
    [anon_sym_triangleadj] = ACTIONS(3845),
    [anon_sym_lineadj] = ACTIONS(3845),
    [anon_sym_triangle] = ACTIONS(3845),
    [anon_sym_cbuffer] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3845),
    [anon_sym_extension] = ACTIONS(3845),
  },
  [981] = {
    [ts_builtin_sym_end] = ACTIONS(3834),
    [sym_identifier] = ACTIONS(3832),
    [aux_sym_preproc_include_token1] = ACTIONS(3832),
    [aux_sym_preproc_def_token1] = ACTIONS(3832),
    [aux_sym_preproc_if_token1] = ACTIONS(3832),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3832),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3832),
    [sym_preproc_directive] = ACTIONS(3832),
    [anon_sym_LPAREN2] = ACTIONS(3834),
    [anon_sym_BANG] = ACTIONS(3834),
    [anon_sym_TILDE] = ACTIONS(3834),
    [anon_sym_DASH] = ACTIONS(3832),
    [anon_sym_PLUS] = ACTIONS(3832),
    [anon_sym_STAR] = ACTIONS(3834),
    [anon_sym_AMP_AMP] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3834),
    [anon_sym___extension__] = ACTIONS(3832),
    [anon_sym_typedef] = ACTIONS(3832),
    [anon_sym_in] = ACTIONS(3832),
    [anon_sym_out] = ACTIONS(3832),
    [anon_sym_inout] = ACTIONS(3832),
    [anon_sym_virtual] = ACTIONS(3832),
    [anon_sym_extern] = ACTIONS(3832),
    [anon_sym___attribute__] = ACTIONS(3832),
    [anon_sym___attribute] = ACTIONS(3832),
    [anon_sym_using] = ACTIONS(3832),
    [anon_sym_COLON_COLON] = ACTIONS(3834),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3834),
    [anon_sym___declspec] = ACTIONS(3832),
    [anon_sym___based] = ACTIONS(3832),
    [anon_sym___cdecl] = ACTIONS(3832),
    [anon_sym___clrcall] = ACTIONS(3832),
    [anon_sym___stdcall] = ACTIONS(3832),
    [anon_sym___fastcall] = ACTIONS(3832),
    [anon_sym___thiscall] = ACTIONS(3832),
    [anon_sym___vectorcall] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_signed] = ACTIONS(3832),
    [anon_sym_unsigned] = ACTIONS(3832),
    [anon_sym_long] = ACTIONS(3832),
    [anon_sym_short] = ACTIONS(3832),
    [anon_sym_LBRACK] = ACTIONS(3832),
    [anon_sym_static] = ACTIONS(3832),
    [anon_sym_register] = ACTIONS(3832),
    [anon_sym_inline] = ACTIONS(3832),
    [anon_sym___inline] = ACTIONS(3832),
    [anon_sym___inline__] = ACTIONS(3832),
    [anon_sym___forceinline] = ACTIONS(3832),
    [anon_sym_thread_local] = ACTIONS(3832),
    [anon_sym___thread] = ACTIONS(3832),
    [anon_sym_const] = ACTIONS(3832),
    [anon_sym_constexpr] = ACTIONS(3832),
    [anon_sym_volatile] = ACTIONS(3832),
    [anon_sym_restrict] = ACTIONS(3832),
    [anon_sym___restrict__] = ACTIONS(3832),
    [anon_sym__Atomic] = ACTIONS(3832),
    [anon_sym__Noreturn] = ACTIONS(3832),
    [anon_sym_noreturn] = ACTIONS(3832),
    [anon_sym__Nonnull] = ACTIONS(3832),
    [anon_sym_mutable] = ACTIONS(3832),
    [anon_sym_constinit] = ACTIONS(3832),
    [anon_sym_consteval] = ACTIONS(3832),
    [anon_sym_alignas] = ACTIONS(3832),
    [anon_sym__Alignas] = ACTIONS(3832),
    [sym_primitive_type] = ACTIONS(3832),
    [anon_sym_enum] = ACTIONS(3832),
    [anon_sym_class] = ACTIONS(3832),
    [anon_sym_struct] = ACTIONS(3832),
    [anon_sym_union] = ACTIONS(3832),
    [anon_sym_if] = ACTIONS(3832),
    [anon_sym_switch] = ACTIONS(3832),
    [anon_sym_case] = ACTIONS(3832),
    [anon_sym_default] = ACTIONS(3832),
    [anon_sym_while] = ACTIONS(3832),
    [anon_sym_do] = ACTIONS(3832),
    [anon_sym_for] = ACTIONS(3832),
    [anon_sym_return] = ACTIONS(3832),
    [anon_sym_break] = ACTIONS(3832),
    [anon_sym_continue] = ACTIONS(3832),
    [anon_sym_goto] = ACTIONS(3832),
    [anon_sym_not] = ACTIONS(3832),
    [anon_sym_compl] = ACTIONS(3832),
    [anon_sym_DASH_DASH] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(3834),
    [anon_sym_sizeof] = ACTIONS(3832),
    [anon_sym___alignof__] = ACTIONS(3832),
    [anon_sym___alignof] = ACTIONS(3832),
    [anon_sym__alignof] = ACTIONS(3832),
    [anon_sym_alignof] = ACTIONS(3832),
    [anon_sym__Alignof] = ACTIONS(3832),
    [anon_sym_offsetof] = ACTIONS(3832),
    [anon_sym__Generic] = ACTIONS(3832),
    [anon_sym_asm] = ACTIONS(3832),
    [anon_sym___asm__] = ACTIONS(3832),
    [anon_sym___asm] = ACTIONS(3832),
    [sym_number_literal] = ACTIONS(3834),
    [anon_sym_L_SQUOTE] = ACTIONS(3834),
    [anon_sym_u_SQUOTE] = ACTIONS(3834),
    [anon_sym_U_SQUOTE] = ACTIONS(3834),
    [anon_sym_u8_SQUOTE] = ACTIONS(3834),
    [anon_sym_SQUOTE] = ACTIONS(3834),
    [anon_sym_L_DQUOTE] = ACTIONS(3834),
    [anon_sym_u_DQUOTE] = ACTIONS(3834),
    [anon_sym_U_DQUOTE] = ACTIONS(3834),
    [anon_sym_u8_DQUOTE] = ACTIONS(3834),
    [anon_sym_DQUOTE] = ACTIONS(3834),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3832),
    [anon_sym_nullptr] = ACTIONS(3832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3832),
    [anon_sym_let] = ACTIONS(3832),
    [anon_sym_This] = ACTIONS(3832),
    [anon_sym_decltype] = ACTIONS(3832),
    [anon_sym_explicit] = ACTIONS(3832),
    [anon_sym_typename] = ACTIONS(3832),
    [anon_sym_export] = ACTIONS(3832),
    [anon_sym_module] = ACTIONS(3832),
    [anon_sym_import] = ACTIONS(3832),
    [anon_sym_template] = ACTIONS(3832),
    [anon_sym_operator] = ACTIONS(3832),
    [anon_sym_try] = ACTIONS(3832),
    [anon_sym_delete] = ACTIONS(3832),
    [anon_sym_throw] = ACTIONS(3832),
    [anon_sym_namespace] = ACTIONS(3832),
    [anon_sym_static_assert] = ACTIONS(3832),
    [anon_sym_concept] = ACTIONS(3832),
    [anon_sym_co_return] = ACTIONS(3832),
    [anon_sym_co_yield] = ACTIONS(3832),
    [anon_sym_R_DQUOTE] = ACTIONS(3834),
    [anon_sym_LR_DQUOTE] = ACTIONS(3834),
    [anon_sym_uR_DQUOTE] = ACTIONS(3834),
    [anon_sym_UR_DQUOTE] = ACTIONS(3834),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3834),
    [anon_sym_co_await] = ACTIONS(3832),
    [anon_sym_new] = ACTIONS(3832),
    [anon_sym_requires] = ACTIONS(3832),
    [sym_this] = ACTIONS(3832),
    [anon_sym_precise] = ACTIONS(3832),
    [anon_sym_shared] = ACTIONS(3832),
    [anon_sym_groupshared] = ACTIONS(3832),
    [anon_sym_uniform] = ACTIONS(3832),
    [anon_sym_row_major] = ACTIONS(3832),
    [anon_sym_column_major] = ACTIONS(3832),
    [anon_sym_globallycoherent] = ACTIONS(3832),
    [anon_sym_centroid] = ACTIONS(3832),
    [anon_sym_noperspective] = ACTIONS(3832),
    [anon_sym_nointerpolation] = ACTIONS(3832),
    [anon_sym_sample] = ACTIONS(3832),
    [anon_sym_linear] = ACTIONS(3832),
    [anon_sym_snorm] = ACTIONS(3832),
    [anon_sym_unorm] = ACTIONS(3832),
    [anon_sym_point] = ACTIONS(3832),
    [anon_sym_line] = ACTIONS(3832),
    [anon_sym_triangleadj] = ACTIONS(3832),
    [anon_sym_lineadj] = ACTIONS(3832),
    [anon_sym_triangle] = ACTIONS(3832),
    [anon_sym_interface] = ACTIONS(3832),
    [anon_sym_extension] = ACTIONS(3832),
    [anon_sym___exported] = ACTIONS(3832),
  },
  [982] = {
    [sym_identifier] = ACTIONS(3665),
    [aux_sym_preproc_include_token1] = ACTIONS(3665),
    [aux_sym_preproc_def_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3665),
    [sym_preproc_directive] = ACTIONS(3665),
    [anon_sym_LPAREN2] = ACTIONS(3667),
    [anon_sym_BANG] = ACTIONS(3667),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_DASH] = ACTIONS(3665),
    [anon_sym_PLUS] = ACTIONS(3665),
    [anon_sym_STAR] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_SEMI] = ACTIONS(3667),
    [anon_sym___extension__] = ACTIONS(3665),
    [anon_sym_typedef] = ACTIONS(3665),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_out] = ACTIONS(3665),
    [anon_sym_inout] = ACTIONS(3665),
    [anon_sym_virtual] = ACTIONS(3665),
    [anon_sym_extern] = ACTIONS(3665),
    [anon_sym___attribute__] = ACTIONS(3665),
    [anon_sym___attribute] = ACTIONS(3665),
    [anon_sym_using] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(3667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3667),
    [anon_sym___declspec] = ACTIONS(3665),
    [anon_sym___based] = ACTIONS(3665),
    [anon_sym___cdecl] = ACTIONS(3665),
    [anon_sym___clrcall] = ACTIONS(3665),
    [anon_sym___stdcall] = ACTIONS(3665),
    [anon_sym___fastcall] = ACTIONS(3665),
    [anon_sym___thiscall] = ACTIONS(3665),
    [anon_sym___vectorcall] = ACTIONS(3665),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_RBRACE] = ACTIONS(3667),
    [anon_sym_signed] = ACTIONS(3665),
    [anon_sym_unsigned] = ACTIONS(3665),
    [anon_sym_long] = ACTIONS(3665),
    [anon_sym_short] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3665),
    [anon_sym_static] = ACTIONS(3665),
    [anon_sym_register] = ACTIONS(3665),
    [anon_sym_inline] = ACTIONS(3665),
    [anon_sym___inline] = ACTIONS(3665),
    [anon_sym___inline__] = ACTIONS(3665),
    [anon_sym___forceinline] = ACTIONS(3665),
    [anon_sym_thread_local] = ACTIONS(3665),
    [anon_sym___thread] = ACTIONS(3665),
    [anon_sym_const] = ACTIONS(3665),
    [anon_sym_constexpr] = ACTIONS(3665),
    [anon_sym_volatile] = ACTIONS(3665),
    [anon_sym_restrict] = ACTIONS(3665),
    [anon_sym___restrict__] = ACTIONS(3665),
    [anon_sym__Atomic] = ACTIONS(3665),
    [anon_sym__Noreturn] = ACTIONS(3665),
    [anon_sym_noreturn] = ACTIONS(3665),
    [anon_sym__Nonnull] = ACTIONS(3665),
    [anon_sym_mutable] = ACTIONS(3665),
    [anon_sym_constinit] = ACTIONS(3665),
    [anon_sym_consteval] = ACTIONS(3665),
    [anon_sym_alignas] = ACTIONS(3665),
    [anon_sym__Alignas] = ACTIONS(3665),
    [sym_primitive_type] = ACTIONS(3665),
    [anon_sym_enum] = ACTIONS(3665),
    [anon_sym_class] = ACTIONS(3665),
    [anon_sym_struct] = ACTIONS(3665),
    [anon_sym_union] = ACTIONS(3665),
    [anon_sym_if] = ACTIONS(3665),
    [anon_sym_switch] = ACTIONS(3665),
    [anon_sym_case] = ACTIONS(3665),
    [anon_sym_default] = ACTIONS(3665),
    [anon_sym_while] = ACTIONS(3665),
    [anon_sym_do] = ACTIONS(3665),
    [anon_sym_for] = ACTIONS(3665),
    [anon_sym_return] = ACTIONS(3665),
    [anon_sym_break] = ACTIONS(3665),
    [anon_sym_continue] = ACTIONS(3665),
    [anon_sym_goto] = ACTIONS(3665),
    [anon_sym___try] = ACTIONS(3665),
    [anon_sym___leave] = ACTIONS(3665),
    [anon_sym_not] = ACTIONS(3665),
    [anon_sym_compl] = ACTIONS(3665),
    [anon_sym_DASH_DASH] = ACTIONS(3667),
    [anon_sym_PLUS_PLUS] = ACTIONS(3667),
    [anon_sym_sizeof] = ACTIONS(3665),
    [anon_sym___alignof__] = ACTIONS(3665),
    [anon_sym___alignof] = ACTIONS(3665),
    [anon_sym__alignof] = ACTIONS(3665),
    [anon_sym_alignof] = ACTIONS(3665),
    [anon_sym__Alignof] = ACTIONS(3665),
    [anon_sym_offsetof] = ACTIONS(3665),
    [anon_sym__Generic] = ACTIONS(3665),
    [anon_sym_asm] = ACTIONS(3665),
    [anon_sym___asm__] = ACTIONS(3665),
    [anon_sym___asm] = ACTIONS(3665),
    [sym_number_literal] = ACTIONS(3667),
    [anon_sym_L_SQUOTE] = ACTIONS(3667),
    [anon_sym_u_SQUOTE] = ACTIONS(3667),
    [anon_sym_U_SQUOTE] = ACTIONS(3667),
    [anon_sym_u8_SQUOTE] = ACTIONS(3667),
    [anon_sym_SQUOTE] = ACTIONS(3667),
    [anon_sym_L_DQUOTE] = ACTIONS(3667),
    [anon_sym_u_DQUOTE] = ACTIONS(3667),
    [anon_sym_U_DQUOTE] = ACTIONS(3667),
    [anon_sym_u8_DQUOTE] = ACTIONS(3667),
    [anon_sym_DQUOTE] = ACTIONS(3667),
    [sym_true] = ACTIONS(3665),
    [sym_false] = ACTIONS(3665),
    [anon_sym_NULL] = ACTIONS(3665),
    [anon_sym_nullptr] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3665),
    [anon_sym_let] = ACTIONS(3665),
    [anon_sym_This] = ACTIONS(3665),
    [anon_sym_decltype] = ACTIONS(3665),
    [anon_sym_explicit] = ACTIONS(3665),
    [anon_sym_typename] = ACTIONS(3665),
    [anon_sym_template] = ACTIONS(3665),
    [anon_sym_operator] = ACTIONS(3665),
    [anon_sym_try] = ACTIONS(3665),
    [anon_sym_delete] = ACTIONS(3665),
    [anon_sym_throw] = ACTIONS(3665),
    [anon_sym_namespace] = ACTIONS(3665),
    [anon_sym_static_assert] = ACTIONS(3665),
    [anon_sym_concept] = ACTIONS(3665),
    [anon_sym_co_return] = ACTIONS(3665),
    [anon_sym_co_yield] = ACTIONS(3665),
    [anon_sym_R_DQUOTE] = ACTIONS(3667),
    [anon_sym_LR_DQUOTE] = ACTIONS(3667),
    [anon_sym_uR_DQUOTE] = ACTIONS(3667),
    [anon_sym_UR_DQUOTE] = ACTIONS(3667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3667),
    [anon_sym_co_await] = ACTIONS(3665),
    [anon_sym_new] = ACTIONS(3665),
    [anon_sym_requires] = ACTIONS(3665),
    [sym_this] = ACTIONS(3665),
    [anon_sym_discard] = ACTIONS(3665),
    [anon_sym_precise] = ACTIONS(3665),
    [anon_sym_shared] = ACTIONS(3665),
    [anon_sym_groupshared] = ACTIONS(3665),
    [anon_sym_uniform] = ACTIONS(3665),
    [anon_sym_row_major] = ACTIONS(3665),
    [anon_sym_column_major] = ACTIONS(3665),
    [anon_sym_globallycoherent] = ACTIONS(3665),
    [anon_sym_centroid] = ACTIONS(3665),
    [anon_sym_noperspective] = ACTIONS(3665),
    [anon_sym_nointerpolation] = ACTIONS(3665),
    [anon_sym_sample] = ACTIONS(3665),
    [anon_sym_linear] = ACTIONS(3665),
    [anon_sym_snorm] = ACTIONS(3665),
    [anon_sym_unorm] = ACTIONS(3665),
    [anon_sym_point] = ACTIONS(3665),
    [anon_sym_line] = ACTIONS(3665),
    [anon_sym_triangleadj] = ACTIONS(3665),
    [anon_sym_lineadj] = ACTIONS(3665),
    [anon_sym_triangle] = ACTIONS(3665),
    [anon_sym_cbuffer] = ACTIONS(3665),
    [anon_sym_interface] = ACTIONS(3665),
    [anon_sym_extension] = ACTIONS(3665),
  },
  [983] = {
    [ts_builtin_sym_end] = ACTIONS(3855),
    [sym_identifier] = ACTIONS(3853),
    [aux_sym_preproc_include_token1] = ACTIONS(3853),
    [aux_sym_preproc_def_token1] = ACTIONS(3853),
    [aux_sym_preproc_if_token1] = ACTIONS(3853),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3853),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3853),
    [sym_preproc_directive] = ACTIONS(3853),
    [anon_sym_LPAREN2] = ACTIONS(3855),
    [anon_sym_BANG] = ACTIONS(3855),
    [anon_sym_TILDE] = ACTIONS(3855),
    [anon_sym_DASH] = ACTIONS(3853),
    [anon_sym_PLUS] = ACTIONS(3853),
    [anon_sym_STAR] = ACTIONS(3855),
    [anon_sym_AMP_AMP] = ACTIONS(3855),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_SEMI] = ACTIONS(3855),
    [anon_sym___extension__] = ACTIONS(3853),
    [anon_sym_typedef] = ACTIONS(3853),
    [anon_sym_in] = ACTIONS(3853),
    [anon_sym_out] = ACTIONS(3853),
    [anon_sym_inout] = ACTIONS(3853),
    [anon_sym_virtual] = ACTIONS(3853),
    [anon_sym_extern] = ACTIONS(3853),
    [anon_sym___attribute__] = ACTIONS(3853),
    [anon_sym___attribute] = ACTIONS(3853),
    [anon_sym_using] = ACTIONS(3853),
    [anon_sym_COLON_COLON] = ACTIONS(3855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3855),
    [anon_sym___declspec] = ACTIONS(3853),
    [anon_sym___based] = ACTIONS(3853),
    [anon_sym___cdecl] = ACTIONS(3853),
    [anon_sym___clrcall] = ACTIONS(3853),
    [anon_sym___stdcall] = ACTIONS(3853),
    [anon_sym___fastcall] = ACTIONS(3853),
    [anon_sym___thiscall] = ACTIONS(3853),
    [anon_sym___vectorcall] = ACTIONS(3853),
    [anon_sym_LBRACE] = ACTIONS(3855),
    [anon_sym_signed] = ACTIONS(3853),
    [anon_sym_unsigned] = ACTIONS(3853),
    [anon_sym_long] = ACTIONS(3853),
    [anon_sym_short] = ACTIONS(3853),
    [anon_sym_LBRACK] = ACTIONS(3853),
    [anon_sym_static] = ACTIONS(3853),
    [anon_sym_register] = ACTIONS(3853),
    [anon_sym_inline] = ACTIONS(3853),
    [anon_sym___inline] = ACTIONS(3853),
    [anon_sym___inline__] = ACTIONS(3853),
    [anon_sym___forceinline] = ACTIONS(3853),
    [anon_sym_thread_local] = ACTIONS(3853),
    [anon_sym___thread] = ACTIONS(3853),
    [anon_sym_const] = ACTIONS(3853),
    [anon_sym_constexpr] = ACTIONS(3853),
    [anon_sym_volatile] = ACTIONS(3853),
    [anon_sym_restrict] = ACTIONS(3853),
    [anon_sym___restrict__] = ACTIONS(3853),
    [anon_sym__Atomic] = ACTIONS(3853),
    [anon_sym__Noreturn] = ACTIONS(3853),
    [anon_sym_noreturn] = ACTIONS(3853),
    [anon_sym__Nonnull] = ACTIONS(3853),
    [anon_sym_mutable] = ACTIONS(3853),
    [anon_sym_constinit] = ACTIONS(3853),
    [anon_sym_consteval] = ACTIONS(3853),
    [anon_sym_alignas] = ACTIONS(3853),
    [anon_sym__Alignas] = ACTIONS(3853),
    [sym_primitive_type] = ACTIONS(3853),
    [anon_sym_enum] = ACTIONS(3853),
    [anon_sym_class] = ACTIONS(3853),
    [anon_sym_struct] = ACTIONS(3853),
    [anon_sym_union] = ACTIONS(3853),
    [anon_sym_if] = ACTIONS(3853),
    [anon_sym_switch] = ACTIONS(3853),
    [anon_sym_case] = ACTIONS(3853),
    [anon_sym_default] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3853),
    [anon_sym_do] = ACTIONS(3853),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_return] = ACTIONS(3853),
    [anon_sym_break] = ACTIONS(3853),
    [anon_sym_continue] = ACTIONS(3853),
    [anon_sym_goto] = ACTIONS(3853),
    [anon_sym_not] = ACTIONS(3853),
    [anon_sym_compl] = ACTIONS(3853),
    [anon_sym_DASH_DASH] = ACTIONS(3855),
    [anon_sym_PLUS_PLUS] = ACTIONS(3855),
    [anon_sym_sizeof] = ACTIONS(3853),
    [anon_sym___alignof__] = ACTIONS(3853),
    [anon_sym___alignof] = ACTIONS(3853),
    [anon_sym__alignof] = ACTIONS(3853),
    [anon_sym_alignof] = ACTIONS(3853),
    [anon_sym__Alignof] = ACTIONS(3853),
    [anon_sym_offsetof] = ACTIONS(3853),
    [anon_sym__Generic] = ACTIONS(3853),
    [anon_sym_asm] = ACTIONS(3853),
    [anon_sym___asm__] = ACTIONS(3853),
    [anon_sym___asm] = ACTIONS(3853),
    [sym_number_literal] = ACTIONS(3855),
    [anon_sym_L_SQUOTE] = ACTIONS(3855),
    [anon_sym_u_SQUOTE] = ACTIONS(3855),
    [anon_sym_U_SQUOTE] = ACTIONS(3855),
    [anon_sym_u8_SQUOTE] = ACTIONS(3855),
    [anon_sym_SQUOTE] = ACTIONS(3855),
    [anon_sym_L_DQUOTE] = ACTIONS(3855),
    [anon_sym_u_DQUOTE] = ACTIONS(3855),
    [anon_sym_U_DQUOTE] = ACTIONS(3855),
    [anon_sym_u8_DQUOTE] = ACTIONS(3855),
    [anon_sym_DQUOTE] = ACTIONS(3855),
    [sym_true] = ACTIONS(3853),
    [sym_false] = ACTIONS(3853),
    [anon_sym_NULL] = ACTIONS(3853),
    [anon_sym_nullptr] = ACTIONS(3853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3853),
    [anon_sym_let] = ACTIONS(3853),
    [anon_sym_This] = ACTIONS(3853),
    [anon_sym_decltype] = ACTIONS(3853),
    [anon_sym_explicit] = ACTIONS(3853),
    [anon_sym_typename] = ACTIONS(3853),
    [anon_sym_export] = ACTIONS(3853),
    [anon_sym_module] = ACTIONS(3853),
    [anon_sym_import] = ACTIONS(3853),
    [anon_sym_template] = ACTIONS(3853),
    [anon_sym_operator] = ACTIONS(3853),
    [anon_sym_try] = ACTIONS(3853),
    [anon_sym_delete] = ACTIONS(3853),
    [anon_sym_throw] = ACTIONS(3853),
    [anon_sym_namespace] = ACTIONS(3853),
    [anon_sym_static_assert] = ACTIONS(3853),
    [anon_sym_concept] = ACTIONS(3853),
    [anon_sym_co_return] = ACTIONS(3853),
    [anon_sym_co_yield] = ACTIONS(3853),
    [anon_sym_R_DQUOTE] = ACTIONS(3855),
    [anon_sym_LR_DQUOTE] = ACTIONS(3855),
    [anon_sym_uR_DQUOTE] = ACTIONS(3855),
    [anon_sym_UR_DQUOTE] = ACTIONS(3855),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3855),
    [anon_sym_co_await] = ACTIONS(3853),
    [anon_sym_new] = ACTIONS(3853),
    [anon_sym_requires] = ACTIONS(3853),
    [sym_this] = ACTIONS(3853),
    [anon_sym_precise] = ACTIONS(3853),
    [anon_sym_shared] = ACTIONS(3853),
    [anon_sym_groupshared] = ACTIONS(3853),
    [anon_sym_uniform] = ACTIONS(3853),
    [anon_sym_row_major] = ACTIONS(3853),
    [anon_sym_column_major] = ACTIONS(3853),
    [anon_sym_globallycoherent] = ACTIONS(3853),
    [anon_sym_centroid] = ACTIONS(3853),
    [anon_sym_noperspective] = ACTIONS(3853),
    [anon_sym_nointerpolation] = ACTIONS(3853),
    [anon_sym_sample] = ACTIONS(3853),
    [anon_sym_linear] = ACTIONS(3853),
    [anon_sym_snorm] = ACTIONS(3853),
    [anon_sym_unorm] = ACTIONS(3853),
    [anon_sym_point] = ACTIONS(3853),
    [anon_sym_line] = ACTIONS(3853),
    [anon_sym_triangleadj] = ACTIONS(3853),
    [anon_sym_lineadj] = ACTIONS(3853),
    [anon_sym_triangle] = ACTIONS(3853),
    [anon_sym_interface] = ACTIONS(3853),
    [anon_sym_extension] = ACTIONS(3853),
    [anon_sym___exported] = ACTIONS(3853),
  },
  [984] = {
    [ts_builtin_sym_end] = ACTIONS(3814),
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_include_token1] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_BANG] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3812),
    [anon_sym_PLUS] = ACTIONS(3812),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym___cdecl] = ACTIONS(3812),
    [anon_sym___clrcall] = ACTIONS(3812),
    [anon_sym___stdcall] = ACTIONS(3812),
    [anon_sym___fastcall] = ACTIONS(3812),
    [anon_sym___thiscall] = ACTIONS(3812),
    [anon_sym___vectorcall] = ACTIONS(3812),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [anon_sym_if] = ACTIONS(3812),
    [anon_sym_switch] = ACTIONS(3812),
    [anon_sym_case] = ACTIONS(3812),
    [anon_sym_default] = ACTIONS(3812),
    [anon_sym_while] = ACTIONS(3812),
    [anon_sym_do] = ACTIONS(3812),
    [anon_sym_for] = ACTIONS(3812),
    [anon_sym_return] = ACTIONS(3812),
    [anon_sym_break] = ACTIONS(3812),
    [anon_sym_continue] = ACTIONS(3812),
    [anon_sym_goto] = ACTIONS(3812),
    [anon_sym_not] = ACTIONS(3812),
    [anon_sym_compl] = ACTIONS(3812),
    [anon_sym_DASH_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_PLUS] = ACTIONS(3814),
    [anon_sym_sizeof] = ACTIONS(3812),
    [anon_sym___alignof__] = ACTIONS(3812),
    [anon_sym___alignof] = ACTIONS(3812),
    [anon_sym__alignof] = ACTIONS(3812),
    [anon_sym_alignof] = ACTIONS(3812),
    [anon_sym__Alignof] = ACTIONS(3812),
    [anon_sym_offsetof] = ACTIONS(3812),
    [anon_sym__Generic] = ACTIONS(3812),
    [anon_sym_asm] = ACTIONS(3812),
    [anon_sym___asm__] = ACTIONS(3812),
    [anon_sym___asm] = ACTIONS(3812),
    [sym_number_literal] = ACTIONS(3814),
    [anon_sym_L_SQUOTE] = ACTIONS(3814),
    [anon_sym_u_SQUOTE] = ACTIONS(3814),
    [anon_sym_U_SQUOTE] = ACTIONS(3814),
    [anon_sym_u8_SQUOTE] = ACTIONS(3814),
    [anon_sym_SQUOTE] = ACTIONS(3814),
    [anon_sym_L_DQUOTE] = ACTIONS(3814),
    [anon_sym_u_DQUOTE] = ACTIONS(3814),
    [anon_sym_U_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [anon_sym_NULL] = ACTIONS(3812),
    [anon_sym_nullptr] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_export] = ACTIONS(3812),
    [anon_sym_module] = ACTIONS(3812),
    [anon_sym_import] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_try] = ACTIONS(3812),
    [anon_sym_delete] = ACTIONS(3812),
    [anon_sym_throw] = ACTIONS(3812),
    [anon_sym_namespace] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_concept] = ACTIONS(3812),
    [anon_sym_co_return] = ACTIONS(3812),
    [anon_sym_co_yield] = ACTIONS(3812),
    [anon_sym_R_DQUOTE] = ACTIONS(3814),
    [anon_sym_LR_DQUOTE] = ACTIONS(3814),
    [anon_sym_uR_DQUOTE] = ACTIONS(3814),
    [anon_sym_UR_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3814),
    [anon_sym_co_await] = ACTIONS(3812),
    [anon_sym_new] = ACTIONS(3812),
    [anon_sym_requires] = ACTIONS(3812),
    [sym_this] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
    [anon_sym___exported] = ACTIONS(3812),
  },
  [985] = {
    [ts_builtin_sym_end] = ACTIONS(3814),
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_include_token1] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_BANG] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3812),
    [anon_sym_PLUS] = ACTIONS(3812),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym___cdecl] = ACTIONS(3812),
    [anon_sym___clrcall] = ACTIONS(3812),
    [anon_sym___stdcall] = ACTIONS(3812),
    [anon_sym___fastcall] = ACTIONS(3812),
    [anon_sym___thiscall] = ACTIONS(3812),
    [anon_sym___vectorcall] = ACTIONS(3812),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [anon_sym_if] = ACTIONS(3812),
    [anon_sym_switch] = ACTIONS(3812),
    [anon_sym_case] = ACTIONS(3812),
    [anon_sym_default] = ACTIONS(3812),
    [anon_sym_while] = ACTIONS(3812),
    [anon_sym_do] = ACTIONS(3812),
    [anon_sym_for] = ACTIONS(3812),
    [anon_sym_return] = ACTIONS(3812),
    [anon_sym_break] = ACTIONS(3812),
    [anon_sym_continue] = ACTIONS(3812),
    [anon_sym_goto] = ACTIONS(3812),
    [anon_sym_not] = ACTIONS(3812),
    [anon_sym_compl] = ACTIONS(3812),
    [anon_sym_DASH_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_PLUS] = ACTIONS(3814),
    [anon_sym_sizeof] = ACTIONS(3812),
    [anon_sym___alignof__] = ACTIONS(3812),
    [anon_sym___alignof] = ACTIONS(3812),
    [anon_sym__alignof] = ACTIONS(3812),
    [anon_sym_alignof] = ACTIONS(3812),
    [anon_sym__Alignof] = ACTIONS(3812),
    [anon_sym_offsetof] = ACTIONS(3812),
    [anon_sym__Generic] = ACTIONS(3812),
    [anon_sym_asm] = ACTIONS(3812),
    [anon_sym___asm__] = ACTIONS(3812),
    [anon_sym___asm] = ACTIONS(3812),
    [sym_number_literal] = ACTIONS(3814),
    [anon_sym_L_SQUOTE] = ACTIONS(3814),
    [anon_sym_u_SQUOTE] = ACTIONS(3814),
    [anon_sym_U_SQUOTE] = ACTIONS(3814),
    [anon_sym_u8_SQUOTE] = ACTIONS(3814),
    [anon_sym_SQUOTE] = ACTIONS(3814),
    [anon_sym_L_DQUOTE] = ACTIONS(3814),
    [anon_sym_u_DQUOTE] = ACTIONS(3814),
    [anon_sym_U_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [anon_sym_NULL] = ACTIONS(3812),
    [anon_sym_nullptr] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_export] = ACTIONS(3812),
    [anon_sym_module] = ACTIONS(3812),
    [anon_sym_import] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_try] = ACTIONS(3812),
    [anon_sym_delete] = ACTIONS(3812),
    [anon_sym_throw] = ACTIONS(3812),
    [anon_sym_namespace] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_concept] = ACTIONS(3812),
    [anon_sym_co_return] = ACTIONS(3812),
    [anon_sym_co_yield] = ACTIONS(3812),
    [anon_sym_R_DQUOTE] = ACTIONS(3814),
    [anon_sym_LR_DQUOTE] = ACTIONS(3814),
    [anon_sym_uR_DQUOTE] = ACTIONS(3814),
    [anon_sym_UR_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3814),
    [anon_sym_co_await] = ACTIONS(3812),
    [anon_sym_new] = ACTIONS(3812),
    [anon_sym_requires] = ACTIONS(3812),
    [sym_this] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
    [anon_sym___exported] = ACTIONS(3812),
  },
  [986] = {
    [ts_builtin_sym_end] = ACTIONS(3679),
    [sym_identifier] = ACTIONS(3677),
    [aux_sym_preproc_include_token1] = ACTIONS(3677),
    [aux_sym_preproc_def_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3677),
    [sym_preproc_directive] = ACTIONS(3677),
    [anon_sym_LPAREN2] = ACTIONS(3679),
    [anon_sym_BANG] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3677),
    [anon_sym_PLUS] = ACTIONS(3677),
    [anon_sym_STAR] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_AMP] = ACTIONS(3677),
    [anon_sym_SEMI] = ACTIONS(3679),
    [anon_sym___extension__] = ACTIONS(3677),
    [anon_sym_typedef] = ACTIONS(3677),
    [anon_sym_in] = ACTIONS(3677),
    [anon_sym_out] = ACTIONS(3677),
    [anon_sym_inout] = ACTIONS(3677),
    [anon_sym_virtual] = ACTIONS(3677),
    [anon_sym_extern] = ACTIONS(3677),
    [anon_sym___attribute__] = ACTIONS(3677),
    [anon_sym___attribute] = ACTIONS(3677),
    [anon_sym_using] = ACTIONS(3677),
    [anon_sym_COLON_COLON] = ACTIONS(3679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3679),
    [anon_sym___declspec] = ACTIONS(3677),
    [anon_sym___based] = ACTIONS(3677),
    [anon_sym___cdecl] = ACTIONS(3677),
    [anon_sym___clrcall] = ACTIONS(3677),
    [anon_sym___stdcall] = ACTIONS(3677),
    [anon_sym___fastcall] = ACTIONS(3677),
    [anon_sym___thiscall] = ACTIONS(3677),
    [anon_sym___vectorcall] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_signed] = ACTIONS(3677),
    [anon_sym_unsigned] = ACTIONS(3677),
    [anon_sym_long] = ACTIONS(3677),
    [anon_sym_short] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3677),
    [anon_sym_static] = ACTIONS(3677),
    [anon_sym_register] = ACTIONS(3677),
    [anon_sym_inline] = ACTIONS(3677),
    [anon_sym___inline] = ACTIONS(3677),
    [anon_sym___inline__] = ACTIONS(3677),
    [anon_sym___forceinline] = ACTIONS(3677),
    [anon_sym_thread_local] = ACTIONS(3677),
    [anon_sym___thread] = ACTIONS(3677),
    [anon_sym_const] = ACTIONS(3677),
    [anon_sym_constexpr] = ACTIONS(3677),
    [anon_sym_volatile] = ACTIONS(3677),
    [anon_sym_restrict] = ACTIONS(3677),
    [anon_sym___restrict__] = ACTIONS(3677),
    [anon_sym__Atomic] = ACTIONS(3677),
    [anon_sym__Noreturn] = ACTIONS(3677),
    [anon_sym_noreturn] = ACTIONS(3677),
    [anon_sym__Nonnull] = ACTIONS(3677),
    [anon_sym_mutable] = ACTIONS(3677),
    [anon_sym_constinit] = ACTIONS(3677),
    [anon_sym_consteval] = ACTIONS(3677),
    [anon_sym_alignas] = ACTIONS(3677),
    [anon_sym__Alignas] = ACTIONS(3677),
    [sym_primitive_type] = ACTIONS(3677),
    [anon_sym_enum] = ACTIONS(3677),
    [anon_sym_class] = ACTIONS(3677),
    [anon_sym_struct] = ACTIONS(3677),
    [anon_sym_union] = ACTIONS(3677),
    [anon_sym_if] = ACTIONS(3677),
    [anon_sym_switch] = ACTIONS(3677),
    [anon_sym_case] = ACTIONS(3677),
    [anon_sym_default] = ACTIONS(3677),
    [anon_sym_while] = ACTIONS(3677),
    [anon_sym_do] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3677),
    [anon_sym_return] = ACTIONS(3677),
    [anon_sym_break] = ACTIONS(3677),
    [anon_sym_continue] = ACTIONS(3677),
    [anon_sym_goto] = ACTIONS(3677),
    [anon_sym_not] = ACTIONS(3677),
    [anon_sym_compl] = ACTIONS(3677),
    [anon_sym_DASH_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_PLUS] = ACTIONS(3679),
    [anon_sym_sizeof] = ACTIONS(3677),
    [anon_sym___alignof__] = ACTIONS(3677),
    [anon_sym___alignof] = ACTIONS(3677),
    [anon_sym__alignof] = ACTIONS(3677),
    [anon_sym_alignof] = ACTIONS(3677),
    [anon_sym__Alignof] = ACTIONS(3677),
    [anon_sym_offsetof] = ACTIONS(3677),
    [anon_sym__Generic] = ACTIONS(3677),
    [anon_sym_asm] = ACTIONS(3677),
    [anon_sym___asm__] = ACTIONS(3677),
    [anon_sym___asm] = ACTIONS(3677),
    [sym_number_literal] = ACTIONS(3679),
    [anon_sym_L_SQUOTE] = ACTIONS(3679),
    [anon_sym_u_SQUOTE] = ACTIONS(3679),
    [anon_sym_U_SQUOTE] = ACTIONS(3679),
    [anon_sym_u8_SQUOTE] = ACTIONS(3679),
    [anon_sym_SQUOTE] = ACTIONS(3679),
    [anon_sym_L_DQUOTE] = ACTIONS(3679),
    [anon_sym_u_DQUOTE] = ACTIONS(3679),
    [anon_sym_U_DQUOTE] = ACTIONS(3679),
    [anon_sym_u8_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [sym_true] = ACTIONS(3677),
    [sym_false] = ACTIONS(3677),
    [anon_sym_NULL] = ACTIONS(3677),
    [anon_sym_nullptr] = ACTIONS(3677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3677),
    [anon_sym_let] = ACTIONS(3677),
    [anon_sym_This] = ACTIONS(3677),
    [anon_sym_decltype] = ACTIONS(3677),
    [anon_sym_explicit] = ACTIONS(3677),
    [anon_sym_typename] = ACTIONS(3677),
    [anon_sym_export] = ACTIONS(3677),
    [anon_sym_module] = ACTIONS(3677),
    [anon_sym_import] = ACTIONS(3677),
    [anon_sym_template] = ACTIONS(3677),
    [anon_sym_operator] = ACTIONS(3677),
    [anon_sym_try] = ACTIONS(3677),
    [anon_sym_delete] = ACTIONS(3677),
    [anon_sym_throw] = ACTIONS(3677),
    [anon_sym_namespace] = ACTIONS(3677),
    [anon_sym_static_assert] = ACTIONS(3677),
    [anon_sym_concept] = ACTIONS(3677),
    [anon_sym_co_return] = ACTIONS(3677),
    [anon_sym_co_yield] = ACTIONS(3677),
    [anon_sym_R_DQUOTE] = ACTIONS(3679),
    [anon_sym_LR_DQUOTE] = ACTIONS(3679),
    [anon_sym_uR_DQUOTE] = ACTIONS(3679),
    [anon_sym_UR_DQUOTE] = ACTIONS(3679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3679),
    [anon_sym_co_await] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3677),
    [anon_sym_requires] = ACTIONS(3677),
    [sym_this] = ACTIONS(3677),
    [anon_sym_precise] = ACTIONS(3677),
    [anon_sym_shared] = ACTIONS(3677),
    [anon_sym_groupshared] = ACTIONS(3677),
    [anon_sym_uniform] = ACTIONS(3677),
    [anon_sym_row_major] = ACTIONS(3677),
    [anon_sym_column_major] = ACTIONS(3677),
    [anon_sym_globallycoherent] = ACTIONS(3677),
    [anon_sym_centroid] = ACTIONS(3677),
    [anon_sym_noperspective] = ACTIONS(3677),
    [anon_sym_nointerpolation] = ACTIONS(3677),
    [anon_sym_sample] = ACTIONS(3677),
    [anon_sym_linear] = ACTIONS(3677),
    [anon_sym_snorm] = ACTIONS(3677),
    [anon_sym_unorm] = ACTIONS(3677),
    [anon_sym_point] = ACTIONS(3677),
    [anon_sym_line] = ACTIONS(3677),
    [anon_sym_triangleadj] = ACTIONS(3677),
    [anon_sym_lineadj] = ACTIONS(3677),
    [anon_sym_triangle] = ACTIONS(3677),
    [anon_sym_interface] = ACTIONS(3677),
    [anon_sym_extension] = ACTIONS(3677),
    [anon_sym___exported] = ACTIONS(3677),
  },
  [987] = {
    [ts_builtin_sym_end] = ACTIONS(3859),
    [sym_identifier] = ACTIONS(3857),
    [aux_sym_preproc_include_token1] = ACTIONS(3857),
    [aux_sym_preproc_def_token1] = ACTIONS(3857),
    [aux_sym_preproc_if_token1] = ACTIONS(3857),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3857),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3857),
    [sym_preproc_directive] = ACTIONS(3857),
    [anon_sym_LPAREN2] = ACTIONS(3859),
    [anon_sym_BANG] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3859),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_STAR] = ACTIONS(3859),
    [anon_sym_AMP_AMP] = ACTIONS(3859),
    [anon_sym_AMP] = ACTIONS(3857),
    [anon_sym_SEMI] = ACTIONS(3859),
    [anon_sym___extension__] = ACTIONS(3857),
    [anon_sym_typedef] = ACTIONS(3857),
    [anon_sym_in] = ACTIONS(3857),
    [anon_sym_out] = ACTIONS(3857),
    [anon_sym_inout] = ACTIONS(3857),
    [anon_sym_virtual] = ACTIONS(3857),
    [anon_sym_extern] = ACTIONS(3857),
    [anon_sym___attribute__] = ACTIONS(3857),
    [anon_sym___attribute] = ACTIONS(3857),
    [anon_sym_using] = ACTIONS(3857),
    [anon_sym_COLON_COLON] = ACTIONS(3859),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3859),
    [anon_sym___declspec] = ACTIONS(3857),
    [anon_sym___based] = ACTIONS(3857),
    [anon_sym___cdecl] = ACTIONS(3857),
    [anon_sym___clrcall] = ACTIONS(3857),
    [anon_sym___stdcall] = ACTIONS(3857),
    [anon_sym___fastcall] = ACTIONS(3857),
    [anon_sym___thiscall] = ACTIONS(3857),
    [anon_sym___vectorcall] = ACTIONS(3857),
    [anon_sym_LBRACE] = ACTIONS(3859),
    [anon_sym_signed] = ACTIONS(3857),
    [anon_sym_unsigned] = ACTIONS(3857),
    [anon_sym_long] = ACTIONS(3857),
    [anon_sym_short] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(3857),
    [anon_sym_static] = ACTIONS(3857),
    [anon_sym_register] = ACTIONS(3857),
    [anon_sym_inline] = ACTIONS(3857),
    [anon_sym___inline] = ACTIONS(3857),
    [anon_sym___inline__] = ACTIONS(3857),
    [anon_sym___forceinline] = ACTIONS(3857),
    [anon_sym_thread_local] = ACTIONS(3857),
    [anon_sym___thread] = ACTIONS(3857),
    [anon_sym_const] = ACTIONS(3857),
    [anon_sym_constexpr] = ACTIONS(3857),
    [anon_sym_volatile] = ACTIONS(3857),
    [anon_sym_restrict] = ACTIONS(3857),
    [anon_sym___restrict__] = ACTIONS(3857),
    [anon_sym__Atomic] = ACTIONS(3857),
    [anon_sym__Noreturn] = ACTIONS(3857),
    [anon_sym_noreturn] = ACTIONS(3857),
    [anon_sym__Nonnull] = ACTIONS(3857),
    [anon_sym_mutable] = ACTIONS(3857),
    [anon_sym_constinit] = ACTIONS(3857),
    [anon_sym_consteval] = ACTIONS(3857),
    [anon_sym_alignas] = ACTIONS(3857),
    [anon_sym__Alignas] = ACTIONS(3857),
    [sym_primitive_type] = ACTIONS(3857),
    [anon_sym_enum] = ACTIONS(3857),
    [anon_sym_class] = ACTIONS(3857),
    [anon_sym_struct] = ACTIONS(3857),
    [anon_sym_union] = ACTIONS(3857),
    [anon_sym_if] = ACTIONS(3857),
    [anon_sym_switch] = ACTIONS(3857),
    [anon_sym_case] = ACTIONS(3857),
    [anon_sym_default] = ACTIONS(3857),
    [anon_sym_while] = ACTIONS(3857),
    [anon_sym_do] = ACTIONS(3857),
    [anon_sym_for] = ACTIONS(3857),
    [anon_sym_return] = ACTIONS(3857),
    [anon_sym_break] = ACTIONS(3857),
    [anon_sym_continue] = ACTIONS(3857),
    [anon_sym_goto] = ACTIONS(3857),
    [anon_sym_not] = ACTIONS(3857),
    [anon_sym_compl] = ACTIONS(3857),
    [anon_sym_DASH_DASH] = ACTIONS(3859),
    [anon_sym_PLUS_PLUS] = ACTIONS(3859),
    [anon_sym_sizeof] = ACTIONS(3857),
    [anon_sym___alignof__] = ACTIONS(3857),
    [anon_sym___alignof] = ACTIONS(3857),
    [anon_sym__alignof] = ACTIONS(3857),
    [anon_sym_alignof] = ACTIONS(3857),
    [anon_sym__Alignof] = ACTIONS(3857),
    [anon_sym_offsetof] = ACTIONS(3857),
    [anon_sym__Generic] = ACTIONS(3857),
    [anon_sym_asm] = ACTIONS(3857),
    [anon_sym___asm__] = ACTIONS(3857),
    [anon_sym___asm] = ACTIONS(3857),
    [sym_number_literal] = ACTIONS(3859),
    [anon_sym_L_SQUOTE] = ACTIONS(3859),
    [anon_sym_u_SQUOTE] = ACTIONS(3859),
    [anon_sym_U_SQUOTE] = ACTIONS(3859),
    [anon_sym_u8_SQUOTE] = ACTIONS(3859),
    [anon_sym_SQUOTE] = ACTIONS(3859),
    [anon_sym_L_DQUOTE] = ACTIONS(3859),
    [anon_sym_u_DQUOTE] = ACTIONS(3859),
    [anon_sym_U_DQUOTE] = ACTIONS(3859),
    [anon_sym_u8_DQUOTE] = ACTIONS(3859),
    [anon_sym_DQUOTE] = ACTIONS(3859),
    [sym_true] = ACTIONS(3857),
    [sym_false] = ACTIONS(3857),
    [anon_sym_NULL] = ACTIONS(3857),
    [anon_sym_nullptr] = ACTIONS(3857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3857),
    [anon_sym_let] = ACTIONS(3857),
    [anon_sym_This] = ACTIONS(3857),
    [anon_sym_decltype] = ACTIONS(3857),
    [anon_sym_explicit] = ACTIONS(3857),
    [anon_sym_typename] = ACTIONS(3857),
    [anon_sym_export] = ACTIONS(3857),
    [anon_sym_module] = ACTIONS(3857),
    [anon_sym_import] = ACTIONS(3857),
    [anon_sym_template] = ACTIONS(3857),
    [anon_sym_operator] = ACTIONS(3857),
    [anon_sym_try] = ACTIONS(3857),
    [anon_sym_delete] = ACTIONS(3857),
    [anon_sym_throw] = ACTIONS(3857),
    [anon_sym_namespace] = ACTIONS(3857),
    [anon_sym_static_assert] = ACTIONS(3857),
    [anon_sym_concept] = ACTIONS(3857),
    [anon_sym_co_return] = ACTIONS(3857),
    [anon_sym_co_yield] = ACTIONS(3857),
    [anon_sym_R_DQUOTE] = ACTIONS(3859),
    [anon_sym_LR_DQUOTE] = ACTIONS(3859),
    [anon_sym_uR_DQUOTE] = ACTIONS(3859),
    [anon_sym_UR_DQUOTE] = ACTIONS(3859),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3859),
    [anon_sym_co_await] = ACTIONS(3857),
    [anon_sym_new] = ACTIONS(3857),
    [anon_sym_requires] = ACTIONS(3857),
    [sym_this] = ACTIONS(3857),
    [anon_sym_precise] = ACTIONS(3857),
    [anon_sym_shared] = ACTIONS(3857),
    [anon_sym_groupshared] = ACTIONS(3857),
    [anon_sym_uniform] = ACTIONS(3857),
    [anon_sym_row_major] = ACTIONS(3857),
    [anon_sym_column_major] = ACTIONS(3857),
    [anon_sym_globallycoherent] = ACTIONS(3857),
    [anon_sym_centroid] = ACTIONS(3857),
    [anon_sym_noperspective] = ACTIONS(3857),
    [anon_sym_nointerpolation] = ACTIONS(3857),
    [anon_sym_sample] = ACTIONS(3857),
    [anon_sym_linear] = ACTIONS(3857),
    [anon_sym_snorm] = ACTIONS(3857),
    [anon_sym_unorm] = ACTIONS(3857),
    [anon_sym_point] = ACTIONS(3857),
    [anon_sym_line] = ACTIONS(3857),
    [anon_sym_triangleadj] = ACTIONS(3857),
    [anon_sym_lineadj] = ACTIONS(3857),
    [anon_sym_triangle] = ACTIONS(3857),
    [anon_sym_interface] = ACTIONS(3857),
    [anon_sym_extension] = ACTIONS(3857),
    [anon_sym___exported] = ACTIONS(3857),
  },
  [988] = {
    [ts_builtin_sym_end] = ACTIONS(3863),
    [sym_identifier] = ACTIONS(3861),
    [aux_sym_preproc_include_token1] = ACTIONS(3861),
    [aux_sym_preproc_def_token1] = ACTIONS(3861),
    [aux_sym_preproc_if_token1] = ACTIONS(3861),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3861),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3861),
    [sym_preproc_directive] = ACTIONS(3861),
    [anon_sym_LPAREN2] = ACTIONS(3863),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3861),
    [anon_sym_PLUS] = ACTIONS(3861),
    [anon_sym_STAR] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_AMP] = ACTIONS(3861),
    [anon_sym_SEMI] = ACTIONS(3863),
    [anon_sym___extension__] = ACTIONS(3861),
    [anon_sym_typedef] = ACTIONS(3861),
    [anon_sym_in] = ACTIONS(3861),
    [anon_sym_out] = ACTIONS(3861),
    [anon_sym_inout] = ACTIONS(3861),
    [anon_sym_virtual] = ACTIONS(3861),
    [anon_sym_extern] = ACTIONS(3861),
    [anon_sym___attribute__] = ACTIONS(3861),
    [anon_sym___attribute] = ACTIONS(3861),
    [anon_sym_using] = ACTIONS(3861),
    [anon_sym_COLON_COLON] = ACTIONS(3863),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3863),
    [anon_sym___declspec] = ACTIONS(3861),
    [anon_sym___based] = ACTIONS(3861),
    [anon_sym___cdecl] = ACTIONS(3861),
    [anon_sym___clrcall] = ACTIONS(3861),
    [anon_sym___stdcall] = ACTIONS(3861),
    [anon_sym___fastcall] = ACTIONS(3861),
    [anon_sym___thiscall] = ACTIONS(3861),
    [anon_sym___vectorcall] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_signed] = ACTIONS(3861),
    [anon_sym_unsigned] = ACTIONS(3861),
    [anon_sym_long] = ACTIONS(3861),
    [anon_sym_short] = ACTIONS(3861),
    [anon_sym_LBRACK] = ACTIONS(3861),
    [anon_sym_static] = ACTIONS(3861),
    [anon_sym_register] = ACTIONS(3861),
    [anon_sym_inline] = ACTIONS(3861),
    [anon_sym___inline] = ACTIONS(3861),
    [anon_sym___inline__] = ACTIONS(3861),
    [anon_sym___forceinline] = ACTIONS(3861),
    [anon_sym_thread_local] = ACTIONS(3861),
    [anon_sym___thread] = ACTIONS(3861),
    [anon_sym_const] = ACTIONS(3861),
    [anon_sym_constexpr] = ACTIONS(3861),
    [anon_sym_volatile] = ACTIONS(3861),
    [anon_sym_restrict] = ACTIONS(3861),
    [anon_sym___restrict__] = ACTIONS(3861),
    [anon_sym__Atomic] = ACTIONS(3861),
    [anon_sym__Noreturn] = ACTIONS(3861),
    [anon_sym_noreturn] = ACTIONS(3861),
    [anon_sym__Nonnull] = ACTIONS(3861),
    [anon_sym_mutable] = ACTIONS(3861),
    [anon_sym_constinit] = ACTIONS(3861),
    [anon_sym_consteval] = ACTIONS(3861),
    [anon_sym_alignas] = ACTIONS(3861),
    [anon_sym__Alignas] = ACTIONS(3861),
    [sym_primitive_type] = ACTIONS(3861),
    [anon_sym_enum] = ACTIONS(3861),
    [anon_sym_class] = ACTIONS(3861),
    [anon_sym_struct] = ACTIONS(3861),
    [anon_sym_union] = ACTIONS(3861),
    [anon_sym_if] = ACTIONS(3861),
    [anon_sym_switch] = ACTIONS(3861),
    [anon_sym_case] = ACTIONS(3861),
    [anon_sym_default] = ACTIONS(3861),
    [anon_sym_while] = ACTIONS(3861),
    [anon_sym_do] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3861),
    [anon_sym_return] = ACTIONS(3861),
    [anon_sym_break] = ACTIONS(3861),
    [anon_sym_continue] = ACTIONS(3861),
    [anon_sym_goto] = ACTIONS(3861),
    [anon_sym_not] = ACTIONS(3861),
    [anon_sym_compl] = ACTIONS(3861),
    [anon_sym_DASH_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3863),
    [anon_sym_sizeof] = ACTIONS(3861),
    [anon_sym___alignof__] = ACTIONS(3861),
    [anon_sym___alignof] = ACTIONS(3861),
    [anon_sym__alignof] = ACTIONS(3861),
    [anon_sym_alignof] = ACTIONS(3861),
    [anon_sym__Alignof] = ACTIONS(3861),
    [anon_sym_offsetof] = ACTIONS(3861),
    [anon_sym__Generic] = ACTIONS(3861),
    [anon_sym_asm] = ACTIONS(3861),
    [anon_sym___asm__] = ACTIONS(3861),
    [anon_sym___asm] = ACTIONS(3861),
    [sym_number_literal] = ACTIONS(3863),
    [anon_sym_L_SQUOTE] = ACTIONS(3863),
    [anon_sym_u_SQUOTE] = ACTIONS(3863),
    [anon_sym_U_SQUOTE] = ACTIONS(3863),
    [anon_sym_u8_SQUOTE] = ACTIONS(3863),
    [anon_sym_SQUOTE] = ACTIONS(3863),
    [anon_sym_L_DQUOTE] = ACTIONS(3863),
    [anon_sym_u_DQUOTE] = ACTIONS(3863),
    [anon_sym_U_DQUOTE] = ACTIONS(3863),
    [anon_sym_u8_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [sym_true] = ACTIONS(3861),
    [sym_false] = ACTIONS(3861),
    [anon_sym_NULL] = ACTIONS(3861),
    [anon_sym_nullptr] = ACTIONS(3861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3861),
    [anon_sym_let] = ACTIONS(3861),
    [anon_sym_This] = ACTIONS(3861),
    [anon_sym_decltype] = ACTIONS(3861),
    [anon_sym_explicit] = ACTIONS(3861),
    [anon_sym_typename] = ACTIONS(3861),
    [anon_sym_export] = ACTIONS(3861),
    [anon_sym_module] = ACTIONS(3861),
    [anon_sym_import] = ACTIONS(3861),
    [anon_sym_template] = ACTIONS(3861),
    [anon_sym_operator] = ACTIONS(3861),
    [anon_sym_try] = ACTIONS(3861),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_throw] = ACTIONS(3861),
    [anon_sym_namespace] = ACTIONS(3861),
    [anon_sym_static_assert] = ACTIONS(3861),
    [anon_sym_concept] = ACTIONS(3861),
    [anon_sym_co_return] = ACTIONS(3861),
    [anon_sym_co_yield] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(3863),
    [anon_sym_LR_DQUOTE] = ACTIONS(3863),
    [anon_sym_uR_DQUOTE] = ACTIONS(3863),
    [anon_sym_UR_DQUOTE] = ACTIONS(3863),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3863),
    [anon_sym_co_await] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3861),
    [anon_sym_requires] = ACTIONS(3861),
    [sym_this] = ACTIONS(3861),
    [anon_sym_precise] = ACTIONS(3861),
    [anon_sym_shared] = ACTIONS(3861),
    [anon_sym_groupshared] = ACTIONS(3861),
    [anon_sym_uniform] = ACTIONS(3861),
    [anon_sym_row_major] = ACTIONS(3861),
    [anon_sym_column_major] = ACTIONS(3861),
    [anon_sym_globallycoherent] = ACTIONS(3861),
    [anon_sym_centroid] = ACTIONS(3861),
    [anon_sym_noperspective] = ACTIONS(3861),
    [anon_sym_nointerpolation] = ACTIONS(3861),
    [anon_sym_sample] = ACTIONS(3861),
    [anon_sym_linear] = ACTIONS(3861),
    [anon_sym_snorm] = ACTIONS(3861),
    [anon_sym_unorm] = ACTIONS(3861),
    [anon_sym_point] = ACTIONS(3861),
    [anon_sym_line] = ACTIONS(3861),
    [anon_sym_triangleadj] = ACTIONS(3861),
    [anon_sym_lineadj] = ACTIONS(3861),
    [anon_sym_triangle] = ACTIONS(3861),
    [anon_sym_interface] = ACTIONS(3861),
    [anon_sym_extension] = ACTIONS(3861),
    [anon_sym___exported] = ACTIONS(3861),
  },
  [989] = {
    [ts_builtin_sym_end] = ACTIONS(4263),
    [sym_identifier] = ACTIONS(4265),
    [aux_sym_preproc_include_token1] = ACTIONS(4265),
    [aux_sym_preproc_def_token1] = ACTIONS(4265),
    [aux_sym_preproc_if_token1] = ACTIONS(4265),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4265),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4265),
    [sym_preproc_directive] = ACTIONS(4265),
    [anon_sym_LPAREN2] = ACTIONS(4263),
    [anon_sym_BANG] = ACTIONS(4263),
    [anon_sym_TILDE] = ACTIONS(4263),
    [anon_sym_DASH] = ACTIONS(4265),
    [anon_sym_PLUS] = ACTIONS(4265),
    [anon_sym_STAR] = ACTIONS(4263),
    [anon_sym_AMP_AMP] = ACTIONS(4263),
    [anon_sym_AMP] = ACTIONS(4265),
    [anon_sym_SEMI] = ACTIONS(4263),
    [anon_sym___extension__] = ACTIONS(4265),
    [anon_sym_typedef] = ACTIONS(4265),
    [anon_sym_in] = ACTIONS(4265),
    [anon_sym_out] = ACTIONS(4265),
    [anon_sym_inout] = ACTIONS(4265),
    [anon_sym_virtual] = ACTIONS(4265),
    [anon_sym_extern] = ACTIONS(4265),
    [anon_sym___attribute__] = ACTIONS(4265),
    [anon_sym___attribute] = ACTIONS(4265),
    [anon_sym_using] = ACTIONS(4265),
    [anon_sym_COLON_COLON] = ACTIONS(4263),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4263),
    [anon_sym___declspec] = ACTIONS(4265),
    [anon_sym___based] = ACTIONS(4265),
    [anon_sym___cdecl] = ACTIONS(4265),
    [anon_sym___clrcall] = ACTIONS(4265),
    [anon_sym___stdcall] = ACTIONS(4265),
    [anon_sym___fastcall] = ACTIONS(4265),
    [anon_sym___thiscall] = ACTIONS(4265),
    [anon_sym___vectorcall] = ACTIONS(4265),
    [anon_sym_LBRACE] = ACTIONS(4263),
    [anon_sym_signed] = ACTIONS(4265),
    [anon_sym_unsigned] = ACTIONS(4265),
    [anon_sym_long] = ACTIONS(4265),
    [anon_sym_short] = ACTIONS(4265),
    [anon_sym_LBRACK] = ACTIONS(4265),
    [anon_sym_static] = ACTIONS(4265),
    [anon_sym_register] = ACTIONS(4265),
    [anon_sym_inline] = ACTIONS(4265),
    [anon_sym___inline] = ACTIONS(4265),
    [anon_sym___inline__] = ACTIONS(4265),
    [anon_sym___forceinline] = ACTIONS(4265),
    [anon_sym_thread_local] = ACTIONS(4265),
    [anon_sym___thread] = ACTIONS(4265),
    [anon_sym_const] = ACTIONS(4265),
    [anon_sym_constexpr] = ACTIONS(4265),
    [anon_sym_volatile] = ACTIONS(4265),
    [anon_sym_restrict] = ACTIONS(4265),
    [anon_sym___restrict__] = ACTIONS(4265),
    [anon_sym__Atomic] = ACTIONS(4265),
    [anon_sym__Noreturn] = ACTIONS(4265),
    [anon_sym_noreturn] = ACTIONS(4265),
    [anon_sym__Nonnull] = ACTIONS(4265),
    [anon_sym_mutable] = ACTIONS(4265),
    [anon_sym_constinit] = ACTIONS(4265),
    [anon_sym_consteval] = ACTIONS(4265),
    [anon_sym_alignas] = ACTIONS(4265),
    [anon_sym__Alignas] = ACTIONS(4265),
    [sym_primitive_type] = ACTIONS(4265),
    [anon_sym_enum] = ACTIONS(4265),
    [anon_sym_class] = ACTIONS(4265),
    [anon_sym_struct] = ACTIONS(4265),
    [anon_sym_union] = ACTIONS(4265),
    [anon_sym_if] = ACTIONS(4265),
    [anon_sym_switch] = ACTIONS(4265),
    [anon_sym_case] = ACTIONS(4265),
    [anon_sym_default] = ACTIONS(4265),
    [anon_sym_while] = ACTIONS(4265),
    [anon_sym_do] = ACTIONS(4265),
    [anon_sym_for] = ACTIONS(4265),
    [anon_sym_return] = ACTIONS(4265),
    [anon_sym_break] = ACTIONS(4265),
    [anon_sym_continue] = ACTIONS(4265),
    [anon_sym_goto] = ACTIONS(4265),
    [anon_sym_not] = ACTIONS(4265),
    [anon_sym_compl] = ACTIONS(4265),
    [anon_sym_DASH_DASH] = ACTIONS(4263),
    [anon_sym_PLUS_PLUS] = ACTIONS(4263),
    [anon_sym_sizeof] = ACTIONS(4265),
    [anon_sym___alignof__] = ACTIONS(4265),
    [anon_sym___alignof] = ACTIONS(4265),
    [anon_sym__alignof] = ACTIONS(4265),
    [anon_sym_alignof] = ACTIONS(4265),
    [anon_sym__Alignof] = ACTIONS(4265),
    [anon_sym_offsetof] = ACTIONS(4265),
    [anon_sym__Generic] = ACTIONS(4265),
    [anon_sym_asm] = ACTIONS(4265),
    [anon_sym___asm__] = ACTIONS(4265),
    [anon_sym___asm] = ACTIONS(4265),
    [sym_number_literal] = ACTIONS(4263),
    [anon_sym_L_SQUOTE] = ACTIONS(4263),
    [anon_sym_u_SQUOTE] = ACTIONS(4263),
    [anon_sym_U_SQUOTE] = ACTIONS(4263),
    [anon_sym_u8_SQUOTE] = ACTIONS(4263),
    [anon_sym_SQUOTE] = ACTIONS(4263),
    [anon_sym_L_DQUOTE] = ACTIONS(4263),
    [anon_sym_u_DQUOTE] = ACTIONS(4263),
    [anon_sym_U_DQUOTE] = ACTIONS(4263),
    [anon_sym_u8_DQUOTE] = ACTIONS(4263),
    [anon_sym_DQUOTE] = ACTIONS(4263),
    [sym_true] = ACTIONS(4265),
    [sym_false] = ACTIONS(4265),
    [anon_sym_NULL] = ACTIONS(4265),
    [anon_sym_nullptr] = ACTIONS(4265),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4265),
    [anon_sym_let] = ACTIONS(4265),
    [anon_sym_This] = ACTIONS(4265),
    [anon_sym_decltype] = ACTIONS(4265),
    [anon_sym_explicit] = ACTIONS(4265),
    [anon_sym_typename] = ACTIONS(4265),
    [anon_sym_export] = ACTIONS(4265),
    [anon_sym_module] = ACTIONS(4265),
    [anon_sym_import] = ACTIONS(4265),
    [anon_sym_template] = ACTIONS(4265),
    [anon_sym_operator] = ACTIONS(4265),
    [anon_sym_try] = ACTIONS(4265),
    [anon_sym_delete] = ACTIONS(4265),
    [anon_sym_throw] = ACTIONS(4265),
    [anon_sym_namespace] = ACTIONS(4265),
    [anon_sym_static_assert] = ACTIONS(4265),
    [anon_sym_concept] = ACTIONS(4265),
    [anon_sym_co_return] = ACTIONS(4265),
    [anon_sym_co_yield] = ACTIONS(4265),
    [anon_sym_R_DQUOTE] = ACTIONS(4263),
    [anon_sym_LR_DQUOTE] = ACTIONS(4263),
    [anon_sym_uR_DQUOTE] = ACTIONS(4263),
    [anon_sym_UR_DQUOTE] = ACTIONS(4263),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4263),
    [anon_sym_co_await] = ACTIONS(4265),
    [anon_sym_new] = ACTIONS(4265),
    [anon_sym_requires] = ACTIONS(4265),
    [sym_this] = ACTIONS(4265),
    [anon_sym_precise] = ACTIONS(4265),
    [anon_sym_shared] = ACTIONS(4265),
    [anon_sym_groupshared] = ACTIONS(4265),
    [anon_sym_uniform] = ACTIONS(4265),
    [anon_sym_row_major] = ACTIONS(4265),
    [anon_sym_column_major] = ACTIONS(4265),
    [anon_sym_globallycoherent] = ACTIONS(4265),
    [anon_sym_centroid] = ACTIONS(4265),
    [anon_sym_noperspective] = ACTIONS(4265),
    [anon_sym_nointerpolation] = ACTIONS(4265),
    [anon_sym_sample] = ACTIONS(4265),
    [anon_sym_linear] = ACTIONS(4265),
    [anon_sym_snorm] = ACTIONS(4265),
    [anon_sym_unorm] = ACTIONS(4265),
    [anon_sym_point] = ACTIONS(4265),
    [anon_sym_line] = ACTIONS(4265),
    [anon_sym_triangleadj] = ACTIONS(4265),
    [anon_sym_lineadj] = ACTIONS(4265),
    [anon_sym_triangle] = ACTIONS(4265),
    [anon_sym_interface] = ACTIONS(4265),
    [anon_sym_extension] = ACTIONS(4265),
    [anon_sym___exported] = ACTIONS(4265),
  },
  [990] = {
    [sym_identifier] = ACTIONS(3857),
    [aux_sym_preproc_include_token1] = ACTIONS(3857),
    [aux_sym_preproc_def_token1] = ACTIONS(3857),
    [aux_sym_preproc_if_token1] = ACTIONS(3857),
    [aux_sym_preproc_if_token2] = ACTIONS(3857),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3857),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3857),
    [sym_preproc_directive] = ACTIONS(3857),
    [anon_sym_LPAREN2] = ACTIONS(3859),
    [anon_sym_BANG] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3859),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_STAR] = ACTIONS(3859),
    [anon_sym_AMP_AMP] = ACTIONS(3859),
    [anon_sym_AMP] = ACTIONS(3857),
    [anon_sym_SEMI] = ACTIONS(3859),
    [anon_sym___extension__] = ACTIONS(3857),
    [anon_sym_typedef] = ACTIONS(3857),
    [anon_sym_in] = ACTIONS(3857),
    [anon_sym_out] = ACTIONS(3857),
    [anon_sym_inout] = ACTIONS(3857),
    [anon_sym_virtual] = ACTIONS(3857),
    [anon_sym_extern] = ACTIONS(3857),
    [anon_sym___attribute__] = ACTIONS(3857),
    [anon_sym___attribute] = ACTIONS(3857),
    [anon_sym_using] = ACTIONS(3857),
    [anon_sym_COLON_COLON] = ACTIONS(3859),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3859),
    [anon_sym___declspec] = ACTIONS(3857),
    [anon_sym___based] = ACTIONS(3857),
    [anon_sym___cdecl] = ACTIONS(3857),
    [anon_sym___clrcall] = ACTIONS(3857),
    [anon_sym___stdcall] = ACTIONS(3857),
    [anon_sym___fastcall] = ACTIONS(3857),
    [anon_sym___thiscall] = ACTIONS(3857),
    [anon_sym___vectorcall] = ACTIONS(3857),
    [anon_sym_LBRACE] = ACTIONS(3859),
    [anon_sym_signed] = ACTIONS(3857),
    [anon_sym_unsigned] = ACTIONS(3857),
    [anon_sym_long] = ACTIONS(3857),
    [anon_sym_short] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(3857),
    [anon_sym_static] = ACTIONS(3857),
    [anon_sym_register] = ACTIONS(3857),
    [anon_sym_inline] = ACTIONS(3857),
    [anon_sym___inline] = ACTIONS(3857),
    [anon_sym___inline__] = ACTIONS(3857),
    [anon_sym___forceinline] = ACTIONS(3857),
    [anon_sym_thread_local] = ACTIONS(3857),
    [anon_sym___thread] = ACTIONS(3857),
    [anon_sym_const] = ACTIONS(3857),
    [anon_sym_constexpr] = ACTIONS(3857),
    [anon_sym_volatile] = ACTIONS(3857),
    [anon_sym_restrict] = ACTIONS(3857),
    [anon_sym___restrict__] = ACTIONS(3857),
    [anon_sym__Atomic] = ACTIONS(3857),
    [anon_sym__Noreturn] = ACTIONS(3857),
    [anon_sym_noreturn] = ACTIONS(3857),
    [anon_sym__Nonnull] = ACTIONS(3857),
    [anon_sym_mutable] = ACTIONS(3857),
    [anon_sym_constinit] = ACTIONS(3857),
    [anon_sym_consteval] = ACTIONS(3857),
    [anon_sym_alignas] = ACTIONS(3857),
    [anon_sym__Alignas] = ACTIONS(3857),
    [sym_primitive_type] = ACTIONS(3857),
    [anon_sym_enum] = ACTIONS(3857),
    [anon_sym_class] = ACTIONS(3857),
    [anon_sym_struct] = ACTIONS(3857),
    [anon_sym_union] = ACTIONS(3857),
    [anon_sym_if] = ACTIONS(3857),
    [anon_sym_switch] = ACTIONS(3857),
    [anon_sym_case] = ACTIONS(3857),
    [anon_sym_default] = ACTIONS(3857),
    [anon_sym_while] = ACTIONS(3857),
    [anon_sym_do] = ACTIONS(3857),
    [anon_sym_for] = ACTIONS(3857),
    [anon_sym_return] = ACTIONS(3857),
    [anon_sym_break] = ACTIONS(3857),
    [anon_sym_continue] = ACTIONS(3857),
    [anon_sym_goto] = ACTIONS(3857),
    [anon_sym___try] = ACTIONS(3857),
    [anon_sym___leave] = ACTIONS(3857),
    [anon_sym_not] = ACTIONS(3857),
    [anon_sym_compl] = ACTIONS(3857),
    [anon_sym_DASH_DASH] = ACTIONS(3859),
    [anon_sym_PLUS_PLUS] = ACTIONS(3859),
    [anon_sym_sizeof] = ACTIONS(3857),
    [anon_sym___alignof__] = ACTIONS(3857),
    [anon_sym___alignof] = ACTIONS(3857),
    [anon_sym__alignof] = ACTIONS(3857),
    [anon_sym_alignof] = ACTIONS(3857),
    [anon_sym__Alignof] = ACTIONS(3857),
    [anon_sym_offsetof] = ACTIONS(3857),
    [anon_sym__Generic] = ACTIONS(3857),
    [anon_sym_asm] = ACTIONS(3857),
    [anon_sym___asm__] = ACTIONS(3857),
    [anon_sym___asm] = ACTIONS(3857),
    [sym_number_literal] = ACTIONS(3859),
    [anon_sym_L_SQUOTE] = ACTIONS(3859),
    [anon_sym_u_SQUOTE] = ACTIONS(3859),
    [anon_sym_U_SQUOTE] = ACTIONS(3859),
    [anon_sym_u8_SQUOTE] = ACTIONS(3859),
    [anon_sym_SQUOTE] = ACTIONS(3859),
    [anon_sym_L_DQUOTE] = ACTIONS(3859),
    [anon_sym_u_DQUOTE] = ACTIONS(3859),
    [anon_sym_U_DQUOTE] = ACTIONS(3859),
    [anon_sym_u8_DQUOTE] = ACTIONS(3859),
    [anon_sym_DQUOTE] = ACTIONS(3859),
    [sym_true] = ACTIONS(3857),
    [sym_false] = ACTIONS(3857),
    [anon_sym_NULL] = ACTIONS(3857),
    [anon_sym_nullptr] = ACTIONS(3857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3857),
    [anon_sym_let] = ACTIONS(3857),
    [anon_sym_This] = ACTIONS(3857),
    [anon_sym_decltype] = ACTIONS(3857),
    [anon_sym_explicit] = ACTIONS(3857),
    [anon_sym_typename] = ACTIONS(3857),
    [anon_sym_template] = ACTIONS(3857),
    [anon_sym_operator] = ACTIONS(3857),
    [anon_sym_try] = ACTIONS(3857),
    [anon_sym_delete] = ACTIONS(3857),
    [anon_sym_throw] = ACTIONS(3857),
    [anon_sym_namespace] = ACTIONS(3857),
    [anon_sym_static_assert] = ACTIONS(3857),
    [anon_sym_concept] = ACTIONS(3857),
    [anon_sym_co_return] = ACTIONS(3857),
    [anon_sym_co_yield] = ACTIONS(3857),
    [anon_sym_R_DQUOTE] = ACTIONS(3859),
    [anon_sym_LR_DQUOTE] = ACTIONS(3859),
    [anon_sym_uR_DQUOTE] = ACTIONS(3859),
    [anon_sym_UR_DQUOTE] = ACTIONS(3859),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3859),
    [anon_sym_co_await] = ACTIONS(3857),
    [anon_sym_new] = ACTIONS(3857),
    [anon_sym_requires] = ACTIONS(3857),
    [sym_this] = ACTIONS(3857),
    [anon_sym_discard] = ACTIONS(3857),
    [anon_sym_precise] = ACTIONS(3857),
    [anon_sym_shared] = ACTIONS(3857),
    [anon_sym_groupshared] = ACTIONS(3857),
    [anon_sym_uniform] = ACTIONS(3857),
    [anon_sym_row_major] = ACTIONS(3857),
    [anon_sym_column_major] = ACTIONS(3857),
    [anon_sym_globallycoherent] = ACTIONS(3857),
    [anon_sym_centroid] = ACTIONS(3857),
    [anon_sym_noperspective] = ACTIONS(3857),
    [anon_sym_nointerpolation] = ACTIONS(3857),
    [anon_sym_sample] = ACTIONS(3857),
    [anon_sym_linear] = ACTIONS(3857),
    [anon_sym_snorm] = ACTIONS(3857),
    [anon_sym_unorm] = ACTIONS(3857),
    [anon_sym_point] = ACTIONS(3857),
    [anon_sym_line] = ACTIONS(3857),
    [anon_sym_triangleadj] = ACTIONS(3857),
    [anon_sym_lineadj] = ACTIONS(3857),
    [anon_sym_triangle] = ACTIONS(3857),
    [anon_sym_cbuffer] = ACTIONS(3857),
    [anon_sym_interface] = ACTIONS(3857),
    [anon_sym_extension] = ACTIONS(3857),
  },
  [991] = {
    [ts_builtin_sym_end] = ACTIONS(3871),
    [sym_identifier] = ACTIONS(3869),
    [aux_sym_preproc_include_token1] = ACTIONS(3869),
    [aux_sym_preproc_def_token1] = ACTIONS(3869),
    [aux_sym_preproc_if_token1] = ACTIONS(3869),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3869),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3869),
    [sym_preproc_directive] = ACTIONS(3869),
    [anon_sym_LPAREN2] = ACTIONS(3871),
    [anon_sym_BANG] = ACTIONS(3871),
    [anon_sym_TILDE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3869),
    [anon_sym_PLUS] = ACTIONS(3869),
    [anon_sym_STAR] = ACTIONS(3871),
    [anon_sym_AMP_AMP] = ACTIONS(3871),
    [anon_sym_AMP] = ACTIONS(3869),
    [anon_sym_SEMI] = ACTIONS(3871),
    [anon_sym___extension__] = ACTIONS(3869),
    [anon_sym_typedef] = ACTIONS(3869),
    [anon_sym_in] = ACTIONS(3869),
    [anon_sym_out] = ACTIONS(3869),
    [anon_sym_inout] = ACTIONS(3869),
    [anon_sym_virtual] = ACTIONS(3869),
    [anon_sym_extern] = ACTIONS(3869),
    [anon_sym___attribute__] = ACTIONS(3869),
    [anon_sym___attribute] = ACTIONS(3869),
    [anon_sym_using] = ACTIONS(3869),
    [anon_sym_COLON_COLON] = ACTIONS(3871),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3871),
    [anon_sym___declspec] = ACTIONS(3869),
    [anon_sym___based] = ACTIONS(3869),
    [anon_sym___cdecl] = ACTIONS(3869),
    [anon_sym___clrcall] = ACTIONS(3869),
    [anon_sym___stdcall] = ACTIONS(3869),
    [anon_sym___fastcall] = ACTIONS(3869),
    [anon_sym___thiscall] = ACTIONS(3869),
    [anon_sym___vectorcall] = ACTIONS(3869),
    [anon_sym_LBRACE] = ACTIONS(3871),
    [anon_sym_signed] = ACTIONS(3869),
    [anon_sym_unsigned] = ACTIONS(3869),
    [anon_sym_long] = ACTIONS(3869),
    [anon_sym_short] = ACTIONS(3869),
    [anon_sym_LBRACK] = ACTIONS(3869),
    [anon_sym_static] = ACTIONS(3869),
    [anon_sym_register] = ACTIONS(3869),
    [anon_sym_inline] = ACTIONS(3869),
    [anon_sym___inline] = ACTIONS(3869),
    [anon_sym___inline__] = ACTIONS(3869),
    [anon_sym___forceinline] = ACTIONS(3869),
    [anon_sym_thread_local] = ACTIONS(3869),
    [anon_sym___thread] = ACTIONS(3869),
    [anon_sym_const] = ACTIONS(3869),
    [anon_sym_constexpr] = ACTIONS(3869),
    [anon_sym_volatile] = ACTIONS(3869),
    [anon_sym_restrict] = ACTIONS(3869),
    [anon_sym___restrict__] = ACTIONS(3869),
    [anon_sym__Atomic] = ACTIONS(3869),
    [anon_sym__Noreturn] = ACTIONS(3869),
    [anon_sym_noreturn] = ACTIONS(3869),
    [anon_sym__Nonnull] = ACTIONS(3869),
    [anon_sym_mutable] = ACTIONS(3869),
    [anon_sym_constinit] = ACTIONS(3869),
    [anon_sym_consteval] = ACTIONS(3869),
    [anon_sym_alignas] = ACTIONS(3869),
    [anon_sym__Alignas] = ACTIONS(3869),
    [sym_primitive_type] = ACTIONS(3869),
    [anon_sym_enum] = ACTIONS(3869),
    [anon_sym_class] = ACTIONS(3869),
    [anon_sym_struct] = ACTIONS(3869),
    [anon_sym_union] = ACTIONS(3869),
    [anon_sym_if] = ACTIONS(3869),
    [anon_sym_switch] = ACTIONS(3869),
    [anon_sym_case] = ACTIONS(3869),
    [anon_sym_default] = ACTIONS(3869),
    [anon_sym_while] = ACTIONS(3869),
    [anon_sym_do] = ACTIONS(3869),
    [anon_sym_for] = ACTIONS(3869),
    [anon_sym_return] = ACTIONS(3869),
    [anon_sym_break] = ACTIONS(3869),
    [anon_sym_continue] = ACTIONS(3869),
    [anon_sym_goto] = ACTIONS(3869),
    [anon_sym_not] = ACTIONS(3869),
    [anon_sym_compl] = ACTIONS(3869),
    [anon_sym_DASH_DASH] = ACTIONS(3871),
    [anon_sym_PLUS_PLUS] = ACTIONS(3871),
    [anon_sym_sizeof] = ACTIONS(3869),
    [anon_sym___alignof__] = ACTIONS(3869),
    [anon_sym___alignof] = ACTIONS(3869),
    [anon_sym__alignof] = ACTIONS(3869),
    [anon_sym_alignof] = ACTIONS(3869),
    [anon_sym__Alignof] = ACTIONS(3869),
    [anon_sym_offsetof] = ACTIONS(3869),
    [anon_sym__Generic] = ACTIONS(3869),
    [anon_sym_asm] = ACTIONS(3869),
    [anon_sym___asm__] = ACTIONS(3869),
    [anon_sym___asm] = ACTIONS(3869),
    [sym_number_literal] = ACTIONS(3871),
    [anon_sym_L_SQUOTE] = ACTIONS(3871),
    [anon_sym_u_SQUOTE] = ACTIONS(3871),
    [anon_sym_U_SQUOTE] = ACTIONS(3871),
    [anon_sym_u8_SQUOTE] = ACTIONS(3871),
    [anon_sym_SQUOTE] = ACTIONS(3871),
    [anon_sym_L_DQUOTE] = ACTIONS(3871),
    [anon_sym_u_DQUOTE] = ACTIONS(3871),
    [anon_sym_U_DQUOTE] = ACTIONS(3871),
    [anon_sym_u8_DQUOTE] = ACTIONS(3871),
    [anon_sym_DQUOTE] = ACTIONS(3871),
    [sym_true] = ACTIONS(3869),
    [sym_false] = ACTIONS(3869),
    [anon_sym_NULL] = ACTIONS(3869),
    [anon_sym_nullptr] = ACTIONS(3869),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3869),
    [anon_sym_let] = ACTIONS(3869),
    [anon_sym_This] = ACTIONS(3869),
    [anon_sym_decltype] = ACTIONS(3869),
    [anon_sym_explicit] = ACTIONS(3869),
    [anon_sym_typename] = ACTIONS(3869),
    [anon_sym_export] = ACTIONS(3869),
    [anon_sym_module] = ACTIONS(3869),
    [anon_sym_import] = ACTIONS(3869),
    [anon_sym_template] = ACTIONS(3869),
    [anon_sym_operator] = ACTIONS(3869),
    [anon_sym_try] = ACTIONS(3869),
    [anon_sym_delete] = ACTIONS(3869),
    [anon_sym_throw] = ACTIONS(3869),
    [anon_sym_namespace] = ACTIONS(3869),
    [anon_sym_static_assert] = ACTIONS(3869),
    [anon_sym_concept] = ACTIONS(3869),
    [anon_sym_co_return] = ACTIONS(3869),
    [anon_sym_co_yield] = ACTIONS(3869),
    [anon_sym_R_DQUOTE] = ACTIONS(3871),
    [anon_sym_LR_DQUOTE] = ACTIONS(3871),
    [anon_sym_uR_DQUOTE] = ACTIONS(3871),
    [anon_sym_UR_DQUOTE] = ACTIONS(3871),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3871),
    [anon_sym_co_await] = ACTIONS(3869),
    [anon_sym_new] = ACTIONS(3869),
    [anon_sym_requires] = ACTIONS(3869),
    [sym_this] = ACTIONS(3869),
    [anon_sym_precise] = ACTIONS(3869),
    [anon_sym_shared] = ACTIONS(3869),
    [anon_sym_groupshared] = ACTIONS(3869),
    [anon_sym_uniform] = ACTIONS(3869),
    [anon_sym_row_major] = ACTIONS(3869),
    [anon_sym_column_major] = ACTIONS(3869),
    [anon_sym_globallycoherent] = ACTIONS(3869),
    [anon_sym_centroid] = ACTIONS(3869),
    [anon_sym_noperspective] = ACTIONS(3869),
    [anon_sym_nointerpolation] = ACTIONS(3869),
    [anon_sym_sample] = ACTIONS(3869),
    [anon_sym_linear] = ACTIONS(3869),
    [anon_sym_snorm] = ACTIONS(3869),
    [anon_sym_unorm] = ACTIONS(3869),
    [anon_sym_point] = ACTIONS(3869),
    [anon_sym_line] = ACTIONS(3869),
    [anon_sym_triangleadj] = ACTIONS(3869),
    [anon_sym_lineadj] = ACTIONS(3869),
    [anon_sym_triangle] = ACTIONS(3869),
    [anon_sym_interface] = ACTIONS(3869),
    [anon_sym_extension] = ACTIONS(3869),
    [anon_sym___exported] = ACTIONS(3869),
  },
  [992] = {
    [ts_builtin_sym_end] = ACTIONS(3679),
    [sym_identifier] = ACTIONS(3677),
    [aux_sym_preproc_include_token1] = ACTIONS(3677),
    [aux_sym_preproc_def_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3677),
    [sym_preproc_directive] = ACTIONS(3677),
    [anon_sym_LPAREN2] = ACTIONS(3679),
    [anon_sym_BANG] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3677),
    [anon_sym_PLUS] = ACTIONS(3677),
    [anon_sym_STAR] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_AMP] = ACTIONS(3677),
    [anon_sym_SEMI] = ACTIONS(3679),
    [anon_sym___extension__] = ACTIONS(3677),
    [anon_sym_typedef] = ACTIONS(3677),
    [anon_sym_in] = ACTIONS(3677),
    [anon_sym_out] = ACTIONS(3677),
    [anon_sym_inout] = ACTIONS(3677),
    [anon_sym_virtual] = ACTIONS(3677),
    [anon_sym_extern] = ACTIONS(3677),
    [anon_sym___attribute__] = ACTIONS(3677),
    [anon_sym___attribute] = ACTIONS(3677),
    [anon_sym_using] = ACTIONS(3677),
    [anon_sym_COLON_COLON] = ACTIONS(3679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3679),
    [anon_sym___declspec] = ACTIONS(3677),
    [anon_sym___based] = ACTIONS(3677),
    [anon_sym___cdecl] = ACTIONS(3677),
    [anon_sym___clrcall] = ACTIONS(3677),
    [anon_sym___stdcall] = ACTIONS(3677),
    [anon_sym___fastcall] = ACTIONS(3677),
    [anon_sym___thiscall] = ACTIONS(3677),
    [anon_sym___vectorcall] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_signed] = ACTIONS(3677),
    [anon_sym_unsigned] = ACTIONS(3677),
    [anon_sym_long] = ACTIONS(3677),
    [anon_sym_short] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3677),
    [anon_sym_static] = ACTIONS(3677),
    [anon_sym_register] = ACTIONS(3677),
    [anon_sym_inline] = ACTIONS(3677),
    [anon_sym___inline] = ACTIONS(3677),
    [anon_sym___inline__] = ACTIONS(3677),
    [anon_sym___forceinline] = ACTIONS(3677),
    [anon_sym_thread_local] = ACTIONS(3677),
    [anon_sym___thread] = ACTIONS(3677),
    [anon_sym_const] = ACTIONS(3677),
    [anon_sym_constexpr] = ACTIONS(3677),
    [anon_sym_volatile] = ACTIONS(3677),
    [anon_sym_restrict] = ACTIONS(3677),
    [anon_sym___restrict__] = ACTIONS(3677),
    [anon_sym__Atomic] = ACTIONS(3677),
    [anon_sym__Noreturn] = ACTIONS(3677),
    [anon_sym_noreturn] = ACTIONS(3677),
    [anon_sym__Nonnull] = ACTIONS(3677),
    [anon_sym_mutable] = ACTIONS(3677),
    [anon_sym_constinit] = ACTIONS(3677),
    [anon_sym_consteval] = ACTIONS(3677),
    [anon_sym_alignas] = ACTIONS(3677),
    [anon_sym__Alignas] = ACTIONS(3677),
    [sym_primitive_type] = ACTIONS(3677),
    [anon_sym_enum] = ACTIONS(3677),
    [anon_sym_class] = ACTIONS(3677),
    [anon_sym_struct] = ACTIONS(3677),
    [anon_sym_union] = ACTIONS(3677),
    [anon_sym_if] = ACTIONS(3677),
    [anon_sym_switch] = ACTIONS(3677),
    [anon_sym_case] = ACTIONS(3677),
    [anon_sym_default] = ACTIONS(3677),
    [anon_sym_while] = ACTIONS(3677),
    [anon_sym_do] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3677),
    [anon_sym_return] = ACTIONS(3677),
    [anon_sym_break] = ACTIONS(3677),
    [anon_sym_continue] = ACTIONS(3677),
    [anon_sym_goto] = ACTIONS(3677),
    [anon_sym_not] = ACTIONS(3677),
    [anon_sym_compl] = ACTIONS(3677),
    [anon_sym_DASH_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_PLUS] = ACTIONS(3679),
    [anon_sym_sizeof] = ACTIONS(3677),
    [anon_sym___alignof__] = ACTIONS(3677),
    [anon_sym___alignof] = ACTIONS(3677),
    [anon_sym__alignof] = ACTIONS(3677),
    [anon_sym_alignof] = ACTIONS(3677),
    [anon_sym__Alignof] = ACTIONS(3677),
    [anon_sym_offsetof] = ACTIONS(3677),
    [anon_sym__Generic] = ACTIONS(3677),
    [anon_sym_asm] = ACTIONS(3677),
    [anon_sym___asm__] = ACTIONS(3677),
    [anon_sym___asm] = ACTIONS(3677),
    [sym_number_literal] = ACTIONS(3679),
    [anon_sym_L_SQUOTE] = ACTIONS(3679),
    [anon_sym_u_SQUOTE] = ACTIONS(3679),
    [anon_sym_U_SQUOTE] = ACTIONS(3679),
    [anon_sym_u8_SQUOTE] = ACTIONS(3679),
    [anon_sym_SQUOTE] = ACTIONS(3679),
    [anon_sym_L_DQUOTE] = ACTIONS(3679),
    [anon_sym_u_DQUOTE] = ACTIONS(3679),
    [anon_sym_U_DQUOTE] = ACTIONS(3679),
    [anon_sym_u8_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [sym_true] = ACTIONS(3677),
    [sym_false] = ACTIONS(3677),
    [anon_sym_NULL] = ACTIONS(3677),
    [anon_sym_nullptr] = ACTIONS(3677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3677),
    [anon_sym_let] = ACTIONS(3677),
    [anon_sym_This] = ACTIONS(3677),
    [anon_sym_decltype] = ACTIONS(3677),
    [anon_sym_explicit] = ACTIONS(3677),
    [anon_sym_typename] = ACTIONS(3677),
    [anon_sym_export] = ACTIONS(3677),
    [anon_sym_module] = ACTIONS(3677),
    [anon_sym_import] = ACTIONS(3677),
    [anon_sym_template] = ACTIONS(3677),
    [anon_sym_operator] = ACTIONS(3677),
    [anon_sym_try] = ACTIONS(3677),
    [anon_sym_delete] = ACTIONS(3677),
    [anon_sym_throw] = ACTIONS(3677),
    [anon_sym_namespace] = ACTIONS(3677),
    [anon_sym_static_assert] = ACTIONS(3677),
    [anon_sym_concept] = ACTIONS(3677),
    [anon_sym_co_return] = ACTIONS(3677),
    [anon_sym_co_yield] = ACTIONS(3677),
    [anon_sym_R_DQUOTE] = ACTIONS(3679),
    [anon_sym_LR_DQUOTE] = ACTIONS(3679),
    [anon_sym_uR_DQUOTE] = ACTIONS(3679),
    [anon_sym_UR_DQUOTE] = ACTIONS(3679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3679),
    [anon_sym_co_await] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3677),
    [anon_sym_requires] = ACTIONS(3677),
    [sym_this] = ACTIONS(3677),
    [anon_sym_precise] = ACTIONS(3677),
    [anon_sym_shared] = ACTIONS(3677),
    [anon_sym_groupshared] = ACTIONS(3677),
    [anon_sym_uniform] = ACTIONS(3677),
    [anon_sym_row_major] = ACTIONS(3677),
    [anon_sym_column_major] = ACTIONS(3677),
    [anon_sym_globallycoherent] = ACTIONS(3677),
    [anon_sym_centroid] = ACTIONS(3677),
    [anon_sym_noperspective] = ACTIONS(3677),
    [anon_sym_nointerpolation] = ACTIONS(3677),
    [anon_sym_sample] = ACTIONS(3677),
    [anon_sym_linear] = ACTIONS(3677),
    [anon_sym_snorm] = ACTIONS(3677),
    [anon_sym_unorm] = ACTIONS(3677),
    [anon_sym_point] = ACTIONS(3677),
    [anon_sym_line] = ACTIONS(3677),
    [anon_sym_triangleadj] = ACTIONS(3677),
    [anon_sym_lineadj] = ACTIONS(3677),
    [anon_sym_triangle] = ACTIONS(3677),
    [anon_sym_interface] = ACTIONS(3677),
    [anon_sym_extension] = ACTIONS(3677),
    [anon_sym___exported] = ACTIONS(3677),
  },
  [993] = {
    [ts_builtin_sym_end] = ACTIONS(3806),
    [sym_identifier] = ACTIONS(3804),
    [aux_sym_preproc_include_token1] = ACTIONS(3804),
    [aux_sym_preproc_def_token1] = ACTIONS(3804),
    [aux_sym_preproc_if_token1] = ACTIONS(3804),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3804),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3804),
    [sym_preproc_directive] = ACTIONS(3804),
    [anon_sym_LPAREN2] = ACTIONS(3806),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(3806),
    [anon_sym_AMP_AMP] = ACTIONS(3806),
    [anon_sym_AMP] = ACTIONS(3804),
    [anon_sym_SEMI] = ACTIONS(3806),
    [anon_sym___extension__] = ACTIONS(3804),
    [anon_sym_typedef] = ACTIONS(3804),
    [anon_sym_in] = ACTIONS(3804),
    [anon_sym_out] = ACTIONS(3804),
    [anon_sym_inout] = ACTIONS(3804),
    [anon_sym_virtual] = ACTIONS(3804),
    [anon_sym_extern] = ACTIONS(3804),
    [anon_sym___attribute__] = ACTIONS(3804),
    [anon_sym___attribute] = ACTIONS(3804),
    [anon_sym_using] = ACTIONS(3804),
    [anon_sym_COLON_COLON] = ACTIONS(3806),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3806),
    [anon_sym___declspec] = ACTIONS(3804),
    [anon_sym___based] = ACTIONS(3804),
    [anon_sym___cdecl] = ACTIONS(3804),
    [anon_sym___clrcall] = ACTIONS(3804),
    [anon_sym___stdcall] = ACTIONS(3804),
    [anon_sym___fastcall] = ACTIONS(3804),
    [anon_sym___thiscall] = ACTIONS(3804),
    [anon_sym___vectorcall] = ACTIONS(3804),
    [anon_sym_LBRACE] = ACTIONS(3806),
    [anon_sym_signed] = ACTIONS(3804),
    [anon_sym_unsigned] = ACTIONS(3804),
    [anon_sym_long] = ACTIONS(3804),
    [anon_sym_short] = ACTIONS(3804),
    [anon_sym_LBRACK] = ACTIONS(3804),
    [anon_sym_static] = ACTIONS(3804),
    [anon_sym_register] = ACTIONS(3804),
    [anon_sym_inline] = ACTIONS(3804),
    [anon_sym___inline] = ACTIONS(3804),
    [anon_sym___inline__] = ACTIONS(3804),
    [anon_sym___forceinline] = ACTIONS(3804),
    [anon_sym_thread_local] = ACTIONS(3804),
    [anon_sym___thread] = ACTIONS(3804),
    [anon_sym_const] = ACTIONS(3804),
    [anon_sym_constexpr] = ACTIONS(3804),
    [anon_sym_volatile] = ACTIONS(3804),
    [anon_sym_restrict] = ACTIONS(3804),
    [anon_sym___restrict__] = ACTIONS(3804),
    [anon_sym__Atomic] = ACTIONS(3804),
    [anon_sym__Noreturn] = ACTIONS(3804),
    [anon_sym_noreturn] = ACTIONS(3804),
    [anon_sym__Nonnull] = ACTIONS(3804),
    [anon_sym_mutable] = ACTIONS(3804),
    [anon_sym_constinit] = ACTIONS(3804),
    [anon_sym_consteval] = ACTIONS(3804),
    [anon_sym_alignas] = ACTIONS(3804),
    [anon_sym__Alignas] = ACTIONS(3804),
    [sym_primitive_type] = ACTIONS(3804),
    [anon_sym_enum] = ACTIONS(3804),
    [anon_sym_class] = ACTIONS(3804),
    [anon_sym_struct] = ACTIONS(3804),
    [anon_sym_union] = ACTIONS(3804),
    [anon_sym_if] = ACTIONS(3804),
    [anon_sym_switch] = ACTIONS(3804),
    [anon_sym_case] = ACTIONS(3804),
    [anon_sym_default] = ACTIONS(3804),
    [anon_sym_while] = ACTIONS(3804),
    [anon_sym_do] = ACTIONS(3804),
    [anon_sym_for] = ACTIONS(3804),
    [anon_sym_return] = ACTIONS(3804),
    [anon_sym_break] = ACTIONS(3804),
    [anon_sym_continue] = ACTIONS(3804),
    [anon_sym_goto] = ACTIONS(3804),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(3806),
    [anon_sym_PLUS_PLUS] = ACTIONS(3806),
    [anon_sym_sizeof] = ACTIONS(3804),
    [anon_sym___alignof__] = ACTIONS(3804),
    [anon_sym___alignof] = ACTIONS(3804),
    [anon_sym__alignof] = ACTIONS(3804),
    [anon_sym_alignof] = ACTIONS(3804),
    [anon_sym__Alignof] = ACTIONS(3804),
    [anon_sym_offsetof] = ACTIONS(3804),
    [anon_sym__Generic] = ACTIONS(3804),
    [anon_sym_asm] = ACTIONS(3804),
    [anon_sym___asm__] = ACTIONS(3804),
    [anon_sym___asm] = ACTIONS(3804),
    [sym_number_literal] = ACTIONS(3806),
    [anon_sym_L_SQUOTE] = ACTIONS(3806),
    [anon_sym_u_SQUOTE] = ACTIONS(3806),
    [anon_sym_U_SQUOTE] = ACTIONS(3806),
    [anon_sym_u8_SQUOTE] = ACTIONS(3806),
    [anon_sym_SQUOTE] = ACTIONS(3806),
    [anon_sym_L_DQUOTE] = ACTIONS(3806),
    [anon_sym_u_DQUOTE] = ACTIONS(3806),
    [anon_sym_U_DQUOTE] = ACTIONS(3806),
    [anon_sym_u8_DQUOTE] = ACTIONS(3806),
    [anon_sym_DQUOTE] = ACTIONS(3806),
    [sym_true] = ACTIONS(3804),
    [sym_false] = ACTIONS(3804),
    [anon_sym_NULL] = ACTIONS(3804),
    [anon_sym_nullptr] = ACTIONS(3804),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3804),
    [anon_sym_let] = ACTIONS(3804),
    [anon_sym_This] = ACTIONS(3804),
    [anon_sym_decltype] = ACTIONS(3804),
    [anon_sym_explicit] = ACTIONS(3804),
    [anon_sym_typename] = ACTIONS(3804),
    [anon_sym_export] = ACTIONS(3804),
    [anon_sym_module] = ACTIONS(3804),
    [anon_sym_import] = ACTIONS(3804),
    [anon_sym_template] = ACTIONS(3804),
    [anon_sym_operator] = ACTIONS(3804),
    [anon_sym_try] = ACTIONS(3804),
    [anon_sym_delete] = ACTIONS(3804),
    [anon_sym_throw] = ACTIONS(3804),
    [anon_sym_namespace] = ACTIONS(3804),
    [anon_sym_static_assert] = ACTIONS(3804),
    [anon_sym_concept] = ACTIONS(3804),
    [anon_sym_co_return] = ACTIONS(3804),
    [anon_sym_co_yield] = ACTIONS(3804),
    [anon_sym_R_DQUOTE] = ACTIONS(3806),
    [anon_sym_LR_DQUOTE] = ACTIONS(3806),
    [anon_sym_uR_DQUOTE] = ACTIONS(3806),
    [anon_sym_UR_DQUOTE] = ACTIONS(3806),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3806),
    [anon_sym_co_await] = ACTIONS(3804),
    [anon_sym_new] = ACTIONS(3804),
    [anon_sym_requires] = ACTIONS(3804),
    [sym_this] = ACTIONS(3804),
    [anon_sym_precise] = ACTIONS(3804),
    [anon_sym_shared] = ACTIONS(3804),
    [anon_sym_groupshared] = ACTIONS(3804),
    [anon_sym_uniform] = ACTIONS(3804),
    [anon_sym_row_major] = ACTIONS(3804),
    [anon_sym_column_major] = ACTIONS(3804),
    [anon_sym_globallycoherent] = ACTIONS(3804),
    [anon_sym_centroid] = ACTIONS(3804),
    [anon_sym_noperspective] = ACTIONS(3804),
    [anon_sym_nointerpolation] = ACTIONS(3804),
    [anon_sym_sample] = ACTIONS(3804),
    [anon_sym_linear] = ACTIONS(3804),
    [anon_sym_snorm] = ACTIONS(3804),
    [anon_sym_unorm] = ACTIONS(3804),
    [anon_sym_point] = ACTIONS(3804),
    [anon_sym_line] = ACTIONS(3804),
    [anon_sym_triangleadj] = ACTIONS(3804),
    [anon_sym_lineadj] = ACTIONS(3804),
    [anon_sym_triangle] = ACTIONS(3804),
    [anon_sym_interface] = ACTIONS(3804),
    [anon_sym_extension] = ACTIONS(3804),
    [anon_sym___exported] = ACTIONS(3804),
  },
  [994] = {
    [sym_identifier] = ACTIONS(3861),
    [aux_sym_preproc_include_token1] = ACTIONS(3861),
    [aux_sym_preproc_def_token1] = ACTIONS(3861),
    [aux_sym_preproc_if_token1] = ACTIONS(3861),
    [aux_sym_preproc_if_token2] = ACTIONS(3861),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3861),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3861),
    [sym_preproc_directive] = ACTIONS(3861),
    [anon_sym_LPAREN2] = ACTIONS(3863),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3863),
    [anon_sym_DASH] = ACTIONS(3861),
    [anon_sym_PLUS] = ACTIONS(3861),
    [anon_sym_STAR] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_AMP] = ACTIONS(3861),
    [anon_sym_SEMI] = ACTIONS(3863),
    [anon_sym___extension__] = ACTIONS(3861),
    [anon_sym_typedef] = ACTIONS(3861),
    [anon_sym_in] = ACTIONS(3861),
    [anon_sym_out] = ACTIONS(3861),
    [anon_sym_inout] = ACTIONS(3861),
    [anon_sym_virtual] = ACTIONS(3861),
    [anon_sym_extern] = ACTIONS(3861),
    [anon_sym___attribute__] = ACTIONS(3861),
    [anon_sym___attribute] = ACTIONS(3861),
    [anon_sym_using] = ACTIONS(3861),
    [anon_sym_COLON_COLON] = ACTIONS(3863),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3863),
    [anon_sym___declspec] = ACTIONS(3861),
    [anon_sym___based] = ACTIONS(3861),
    [anon_sym___cdecl] = ACTIONS(3861),
    [anon_sym___clrcall] = ACTIONS(3861),
    [anon_sym___stdcall] = ACTIONS(3861),
    [anon_sym___fastcall] = ACTIONS(3861),
    [anon_sym___thiscall] = ACTIONS(3861),
    [anon_sym___vectorcall] = ACTIONS(3861),
    [anon_sym_LBRACE] = ACTIONS(3863),
    [anon_sym_signed] = ACTIONS(3861),
    [anon_sym_unsigned] = ACTIONS(3861),
    [anon_sym_long] = ACTIONS(3861),
    [anon_sym_short] = ACTIONS(3861),
    [anon_sym_LBRACK] = ACTIONS(3861),
    [anon_sym_static] = ACTIONS(3861),
    [anon_sym_register] = ACTIONS(3861),
    [anon_sym_inline] = ACTIONS(3861),
    [anon_sym___inline] = ACTIONS(3861),
    [anon_sym___inline__] = ACTIONS(3861),
    [anon_sym___forceinline] = ACTIONS(3861),
    [anon_sym_thread_local] = ACTIONS(3861),
    [anon_sym___thread] = ACTIONS(3861),
    [anon_sym_const] = ACTIONS(3861),
    [anon_sym_constexpr] = ACTIONS(3861),
    [anon_sym_volatile] = ACTIONS(3861),
    [anon_sym_restrict] = ACTIONS(3861),
    [anon_sym___restrict__] = ACTIONS(3861),
    [anon_sym__Atomic] = ACTIONS(3861),
    [anon_sym__Noreturn] = ACTIONS(3861),
    [anon_sym_noreturn] = ACTIONS(3861),
    [anon_sym__Nonnull] = ACTIONS(3861),
    [anon_sym_mutable] = ACTIONS(3861),
    [anon_sym_constinit] = ACTIONS(3861),
    [anon_sym_consteval] = ACTIONS(3861),
    [anon_sym_alignas] = ACTIONS(3861),
    [anon_sym__Alignas] = ACTIONS(3861),
    [sym_primitive_type] = ACTIONS(3861),
    [anon_sym_enum] = ACTIONS(3861),
    [anon_sym_class] = ACTIONS(3861),
    [anon_sym_struct] = ACTIONS(3861),
    [anon_sym_union] = ACTIONS(3861),
    [anon_sym_if] = ACTIONS(3861),
    [anon_sym_switch] = ACTIONS(3861),
    [anon_sym_case] = ACTIONS(3861),
    [anon_sym_default] = ACTIONS(3861),
    [anon_sym_while] = ACTIONS(3861),
    [anon_sym_do] = ACTIONS(3861),
    [anon_sym_for] = ACTIONS(3861),
    [anon_sym_return] = ACTIONS(3861),
    [anon_sym_break] = ACTIONS(3861),
    [anon_sym_continue] = ACTIONS(3861),
    [anon_sym_goto] = ACTIONS(3861),
    [anon_sym___try] = ACTIONS(3861),
    [anon_sym___leave] = ACTIONS(3861),
    [anon_sym_not] = ACTIONS(3861),
    [anon_sym_compl] = ACTIONS(3861),
    [anon_sym_DASH_DASH] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3863),
    [anon_sym_sizeof] = ACTIONS(3861),
    [anon_sym___alignof__] = ACTIONS(3861),
    [anon_sym___alignof] = ACTIONS(3861),
    [anon_sym__alignof] = ACTIONS(3861),
    [anon_sym_alignof] = ACTIONS(3861),
    [anon_sym__Alignof] = ACTIONS(3861),
    [anon_sym_offsetof] = ACTIONS(3861),
    [anon_sym__Generic] = ACTIONS(3861),
    [anon_sym_asm] = ACTIONS(3861),
    [anon_sym___asm__] = ACTIONS(3861),
    [anon_sym___asm] = ACTIONS(3861),
    [sym_number_literal] = ACTIONS(3863),
    [anon_sym_L_SQUOTE] = ACTIONS(3863),
    [anon_sym_u_SQUOTE] = ACTIONS(3863),
    [anon_sym_U_SQUOTE] = ACTIONS(3863),
    [anon_sym_u8_SQUOTE] = ACTIONS(3863),
    [anon_sym_SQUOTE] = ACTIONS(3863),
    [anon_sym_L_DQUOTE] = ACTIONS(3863),
    [anon_sym_u_DQUOTE] = ACTIONS(3863),
    [anon_sym_U_DQUOTE] = ACTIONS(3863),
    [anon_sym_u8_DQUOTE] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(3863),
    [sym_true] = ACTIONS(3861),
    [sym_false] = ACTIONS(3861),
    [anon_sym_NULL] = ACTIONS(3861),
    [anon_sym_nullptr] = ACTIONS(3861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3861),
    [anon_sym_let] = ACTIONS(3861),
    [anon_sym_This] = ACTIONS(3861),
    [anon_sym_decltype] = ACTIONS(3861),
    [anon_sym_explicit] = ACTIONS(3861),
    [anon_sym_typename] = ACTIONS(3861),
    [anon_sym_template] = ACTIONS(3861),
    [anon_sym_operator] = ACTIONS(3861),
    [anon_sym_try] = ACTIONS(3861),
    [anon_sym_delete] = ACTIONS(3861),
    [anon_sym_throw] = ACTIONS(3861),
    [anon_sym_namespace] = ACTIONS(3861),
    [anon_sym_static_assert] = ACTIONS(3861),
    [anon_sym_concept] = ACTIONS(3861),
    [anon_sym_co_return] = ACTIONS(3861),
    [anon_sym_co_yield] = ACTIONS(3861),
    [anon_sym_R_DQUOTE] = ACTIONS(3863),
    [anon_sym_LR_DQUOTE] = ACTIONS(3863),
    [anon_sym_uR_DQUOTE] = ACTIONS(3863),
    [anon_sym_UR_DQUOTE] = ACTIONS(3863),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3863),
    [anon_sym_co_await] = ACTIONS(3861),
    [anon_sym_new] = ACTIONS(3861),
    [anon_sym_requires] = ACTIONS(3861),
    [sym_this] = ACTIONS(3861),
    [anon_sym_discard] = ACTIONS(3861),
    [anon_sym_precise] = ACTIONS(3861),
    [anon_sym_shared] = ACTIONS(3861),
    [anon_sym_groupshared] = ACTIONS(3861),
    [anon_sym_uniform] = ACTIONS(3861),
    [anon_sym_row_major] = ACTIONS(3861),
    [anon_sym_column_major] = ACTIONS(3861),
    [anon_sym_globallycoherent] = ACTIONS(3861),
    [anon_sym_centroid] = ACTIONS(3861),
    [anon_sym_noperspective] = ACTIONS(3861),
    [anon_sym_nointerpolation] = ACTIONS(3861),
    [anon_sym_sample] = ACTIONS(3861),
    [anon_sym_linear] = ACTIONS(3861),
    [anon_sym_snorm] = ACTIONS(3861),
    [anon_sym_unorm] = ACTIONS(3861),
    [anon_sym_point] = ACTIONS(3861),
    [anon_sym_line] = ACTIONS(3861),
    [anon_sym_triangleadj] = ACTIONS(3861),
    [anon_sym_lineadj] = ACTIONS(3861),
    [anon_sym_triangle] = ACTIONS(3861),
    [anon_sym_cbuffer] = ACTIONS(3861),
    [anon_sym_interface] = ACTIONS(3861),
    [anon_sym_extension] = ACTIONS(3861),
  },
  [995] = {
    [ts_builtin_sym_end] = ACTIONS(3875),
    [sym_identifier] = ACTIONS(3873),
    [aux_sym_preproc_include_token1] = ACTIONS(3873),
    [aux_sym_preproc_def_token1] = ACTIONS(3873),
    [aux_sym_preproc_if_token1] = ACTIONS(3873),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3873),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3873),
    [sym_preproc_directive] = ACTIONS(3873),
    [anon_sym_LPAREN2] = ACTIONS(3875),
    [anon_sym_BANG] = ACTIONS(3875),
    [anon_sym_TILDE] = ACTIONS(3875),
    [anon_sym_DASH] = ACTIONS(3873),
    [anon_sym_PLUS] = ACTIONS(3873),
    [anon_sym_STAR] = ACTIONS(3875),
    [anon_sym_AMP_AMP] = ACTIONS(3875),
    [anon_sym_AMP] = ACTIONS(3873),
    [anon_sym_SEMI] = ACTIONS(3875),
    [anon_sym___extension__] = ACTIONS(3873),
    [anon_sym_typedef] = ACTIONS(3873),
    [anon_sym_in] = ACTIONS(3873),
    [anon_sym_out] = ACTIONS(3873),
    [anon_sym_inout] = ACTIONS(3873),
    [anon_sym_virtual] = ACTIONS(3873),
    [anon_sym_extern] = ACTIONS(3873),
    [anon_sym___attribute__] = ACTIONS(3873),
    [anon_sym___attribute] = ACTIONS(3873),
    [anon_sym_using] = ACTIONS(3873),
    [anon_sym_COLON_COLON] = ACTIONS(3875),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3875),
    [anon_sym___declspec] = ACTIONS(3873),
    [anon_sym___based] = ACTIONS(3873),
    [anon_sym___cdecl] = ACTIONS(3873),
    [anon_sym___clrcall] = ACTIONS(3873),
    [anon_sym___stdcall] = ACTIONS(3873),
    [anon_sym___fastcall] = ACTIONS(3873),
    [anon_sym___thiscall] = ACTIONS(3873),
    [anon_sym___vectorcall] = ACTIONS(3873),
    [anon_sym_LBRACE] = ACTIONS(3875),
    [anon_sym_signed] = ACTIONS(3873),
    [anon_sym_unsigned] = ACTIONS(3873),
    [anon_sym_long] = ACTIONS(3873),
    [anon_sym_short] = ACTIONS(3873),
    [anon_sym_LBRACK] = ACTIONS(3873),
    [anon_sym_static] = ACTIONS(3873),
    [anon_sym_register] = ACTIONS(3873),
    [anon_sym_inline] = ACTIONS(3873),
    [anon_sym___inline] = ACTIONS(3873),
    [anon_sym___inline__] = ACTIONS(3873),
    [anon_sym___forceinline] = ACTIONS(3873),
    [anon_sym_thread_local] = ACTIONS(3873),
    [anon_sym___thread] = ACTIONS(3873),
    [anon_sym_const] = ACTIONS(3873),
    [anon_sym_constexpr] = ACTIONS(3873),
    [anon_sym_volatile] = ACTIONS(3873),
    [anon_sym_restrict] = ACTIONS(3873),
    [anon_sym___restrict__] = ACTIONS(3873),
    [anon_sym__Atomic] = ACTIONS(3873),
    [anon_sym__Noreturn] = ACTIONS(3873),
    [anon_sym_noreturn] = ACTIONS(3873),
    [anon_sym__Nonnull] = ACTIONS(3873),
    [anon_sym_mutable] = ACTIONS(3873),
    [anon_sym_constinit] = ACTIONS(3873),
    [anon_sym_consteval] = ACTIONS(3873),
    [anon_sym_alignas] = ACTIONS(3873),
    [anon_sym__Alignas] = ACTIONS(3873),
    [sym_primitive_type] = ACTIONS(3873),
    [anon_sym_enum] = ACTIONS(3873),
    [anon_sym_class] = ACTIONS(3873),
    [anon_sym_struct] = ACTIONS(3873),
    [anon_sym_union] = ACTIONS(3873),
    [anon_sym_if] = ACTIONS(3873),
    [anon_sym_switch] = ACTIONS(3873),
    [anon_sym_case] = ACTIONS(3873),
    [anon_sym_default] = ACTIONS(3873),
    [anon_sym_while] = ACTIONS(3873),
    [anon_sym_do] = ACTIONS(3873),
    [anon_sym_for] = ACTIONS(3873),
    [anon_sym_return] = ACTIONS(3873),
    [anon_sym_break] = ACTIONS(3873),
    [anon_sym_continue] = ACTIONS(3873),
    [anon_sym_goto] = ACTIONS(3873),
    [anon_sym_not] = ACTIONS(3873),
    [anon_sym_compl] = ACTIONS(3873),
    [anon_sym_DASH_DASH] = ACTIONS(3875),
    [anon_sym_PLUS_PLUS] = ACTIONS(3875),
    [anon_sym_sizeof] = ACTIONS(3873),
    [anon_sym___alignof__] = ACTIONS(3873),
    [anon_sym___alignof] = ACTIONS(3873),
    [anon_sym__alignof] = ACTIONS(3873),
    [anon_sym_alignof] = ACTIONS(3873),
    [anon_sym__Alignof] = ACTIONS(3873),
    [anon_sym_offsetof] = ACTIONS(3873),
    [anon_sym__Generic] = ACTIONS(3873),
    [anon_sym_asm] = ACTIONS(3873),
    [anon_sym___asm__] = ACTIONS(3873),
    [anon_sym___asm] = ACTIONS(3873),
    [sym_number_literal] = ACTIONS(3875),
    [anon_sym_L_SQUOTE] = ACTIONS(3875),
    [anon_sym_u_SQUOTE] = ACTIONS(3875),
    [anon_sym_U_SQUOTE] = ACTIONS(3875),
    [anon_sym_u8_SQUOTE] = ACTIONS(3875),
    [anon_sym_SQUOTE] = ACTIONS(3875),
    [anon_sym_L_DQUOTE] = ACTIONS(3875),
    [anon_sym_u_DQUOTE] = ACTIONS(3875),
    [anon_sym_U_DQUOTE] = ACTIONS(3875),
    [anon_sym_u8_DQUOTE] = ACTIONS(3875),
    [anon_sym_DQUOTE] = ACTIONS(3875),
    [sym_true] = ACTIONS(3873),
    [sym_false] = ACTIONS(3873),
    [anon_sym_NULL] = ACTIONS(3873),
    [anon_sym_nullptr] = ACTIONS(3873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3873),
    [anon_sym_let] = ACTIONS(3873),
    [anon_sym_This] = ACTIONS(3873),
    [anon_sym_decltype] = ACTIONS(3873),
    [anon_sym_explicit] = ACTIONS(3873),
    [anon_sym_typename] = ACTIONS(3873),
    [anon_sym_export] = ACTIONS(3873),
    [anon_sym_module] = ACTIONS(3873),
    [anon_sym_import] = ACTIONS(3873),
    [anon_sym_template] = ACTIONS(3873),
    [anon_sym_operator] = ACTIONS(3873),
    [anon_sym_try] = ACTIONS(3873),
    [anon_sym_delete] = ACTIONS(3873),
    [anon_sym_throw] = ACTIONS(3873),
    [anon_sym_namespace] = ACTIONS(3873),
    [anon_sym_static_assert] = ACTIONS(3873),
    [anon_sym_concept] = ACTIONS(3873),
    [anon_sym_co_return] = ACTIONS(3873),
    [anon_sym_co_yield] = ACTIONS(3873),
    [anon_sym_R_DQUOTE] = ACTIONS(3875),
    [anon_sym_LR_DQUOTE] = ACTIONS(3875),
    [anon_sym_uR_DQUOTE] = ACTIONS(3875),
    [anon_sym_UR_DQUOTE] = ACTIONS(3875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3875),
    [anon_sym_co_await] = ACTIONS(3873),
    [anon_sym_new] = ACTIONS(3873),
    [anon_sym_requires] = ACTIONS(3873),
    [sym_this] = ACTIONS(3873),
    [anon_sym_precise] = ACTIONS(3873),
    [anon_sym_shared] = ACTIONS(3873),
    [anon_sym_groupshared] = ACTIONS(3873),
    [anon_sym_uniform] = ACTIONS(3873),
    [anon_sym_row_major] = ACTIONS(3873),
    [anon_sym_column_major] = ACTIONS(3873),
    [anon_sym_globallycoherent] = ACTIONS(3873),
    [anon_sym_centroid] = ACTIONS(3873),
    [anon_sym_noperspective] = ACTIONS(3873),
    [anon_sym_nointerpolation] = ACTIONS(3873),
    [anon_sym_sample] = ACTIONS(3873),
    [anon_sym_linear] = ACTIONS(3873),
    [anon_sym_snorm] = ACTIONS(3873),
    [anon_sym_unorm] = ACTIONS(3873),
    [anon_sym_point] = ACTIONS(3873),
    [anon_sym_line] = ACTIONS(3873),
    [anon_sym_triangleadj] = ACTIONS(3873),
    [anon_sym_lineadj] = ACTIONS(3873),
    [anon_sym_triangle] = ACTIONS(3873),
    [anon_sym_interface] = ACTIONS(3873),
    [anon_sym_extension] = ACTIONS(3873),
    [anon_sym___exported] = ACTIONS(3873),
  },
  [996] = {
    [ts_builtin_sym_end] = ACTIONS(3693),
    [sym_identifier] = ACTIONS(3691),
    [aux_sym_preproc_include_token1] = ACTIONS(3691),
    [aux_sym_preproc_def_token1] = ACTIONS(3691),
    [aux_sym_preproc_if_token1] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3691),
    [sym_preproc_directive] = ACTIONS(3691),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_BANG] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_PLUS] = ACTIONS(3691),
    [anon_sym_STAR] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_AMP] = ACTIONS(3691),
    [anon_sym_SEMI] = ACTIONS(3693),
    [anon_sym___extension__] = ACTIONS(3691),
    [anon_sym_typedef] = ACTIONS(3691),
    [anon_sym_in] = ACTIONS(3691),
    [anon_sym_out] = ACTIONS(3691),
    [anon_sym_inout] = ACTIONS(3691),
    [anon_sym_virtual] = ACTIONS(3691),
    [anon_sym_extern] = ACTIONS(3691),
    [anon_sym___attribute__] = ACTIONS(3691),
    [anon_sym___attribute] = ACTIONS(3691),
    [anon_sym_using] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3693),
    [anon_sym___declspec] = ACTIONS(3691),
    [anon_sym___based] = ACTIONS(3691),
    [anon_sym___cdecl] = ACTIONS(3691),
    [anon_sym___clrcall] = ACTIONS(3691),
    [anon_sym___stdcall] = ACTIONS(3691),
    [anon_sym___fastcall] = ACTIONS(3691),
    [anon_sym___thiscall] = ACTIONS(3691),
    [anon_sym___vectorcall] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_signed] = ACTIONS(3691),
    [anon_sym_unsigned] = ACTIONS(3691),
    [anon_sym_long] = ACTIONS(3691),
    [anon_sym_short] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(3691),
    [anon_sym_static] = ACTIONS(3691),
    [anon_sym_register] = ACTIONS(3691),
    [anon_sym_inline] = ACTIONS(3691),
    [anon_sym___inline] = ACTIONS(3691),
    [anon_sym___inline__] = ACTIONS(3691),
    [anon_sym___forceinline] = ACTIONS(3691),
    [anon_sym_thread_local] = ACTIONS(3691),
    [anon_sym___thread] = ACTIONS(3691),
    [anon_sym_const] = ACTIONS(3691),
    [anon_sym_constexpr] = ACTIONS(3691),
    [anon_sym_volatile] = ACTIONS(3691),
    [anon_sym_restrict] = ACTIONS(3691),
    [anon_sym___restrict__] = ACTIONS(3691),
    [anon_sym__Atomic] = ACTIONS(3691),
    [anon_sym__Noreturn] = ACTIONS(3691),
    [anon_sym_noreturn] = ACTIONS(3691),
    [anon_sym__Nonnull] = ACTIONS(3691),
    [anon_sym_mutable] = ACTIONS(3691),
    [anon_sym_constinit] = ACTIONS(3691),
    [anon_sym_consteval] = ACTIONS(3691),
    [anon_sym_alignas] = ACTIONS(3691),
    [anon_sym__Alignas] = ACTIONS(3691),
    [sym_primitive_type] = ACTIONS(3691),
    [anon_sym_enum] = ACTIONS(3691),
    [anon_sym_class] = ACTIONS(3691),
    [anon_sym_struct] = ACTIONS(3691),
    [anon_sym_union] = ACTIONS(3691),
    [anon_sym_if] = ACTIONS(3691),
    [anon_sym_switch] = ACTIONS(3691),
    [anon_sym_case] = ACTIONS(3691),
    [anon_sym_default] = ACTIONS(3691),
    [anon_sym_while] = ACTIONS(3691),
    [anon_sym_do] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3691),
    [anon_sym_return] = ACTIONS(3691),
    [anon_sym_break] = ACTIONS(3691),
    [anon_sym_continue] = ACTIONS(3691),
    [anon_sym_goto] = ACTIONS(3691),
    [anon_sym_not] = ACTIONS(3691),
    [anon_sym_compl] = ACTIONS(3691),
    [anon_sym_DASH_DASH] = ACTIONS(3693),
    [anon_sym_PLUS_PLUS] = ACTIONS(3693),
    [anon_sym_sizeof] = ACTIONS(3691),
    [anon_sym___alignof__] = ACTIONS(3691),
    [anon_sym___alignof] = ACTIONS(3691),
    [anon_sym__alignof] = ACTIONS(3691),
    [anon_sym_alignof] = ACTIONS(3691),
    [anon_sym__Alignof] = ACTIONS(3691),
    [anon_sym_offsetof] = ACTIONS(3691),
    [anon_sym__Generic] = ACTIONS(3691),
    [anon_sym_asm] = ACTIONS(3691),
    [anon_sym___asm__] = ACTIONS(3691),
    [anon_sym___asm] = ACTIONS(3691),
    [sym_number_literal] = ACTIONS(3693),
    [anon_sym_L_SQUOTE] = ACTIONS(3693),
    [anon_sym_u_SQUOTE] = ACTIONS(3693),
    [anon_sym_U_SQUOTE] = ACTIONS(3693),
    [anon_sym_u8_SQUOTE] = ACTIONS(3693),
    [anon_sym_SQUOTE] = ACTIONS(3693),
    [anon_sym_L_DQUOTE] = ACTIONS(3693),
    [anon_sym_u_DQUOTE] = ACTIONS(3693),
    [anon_sym_U_DQUOTE] = ACTIONS(3693),
    [anon_sym_u8_DQUOTE] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [sym_true] = ACTIONS(3691),
    [sym_false] = ACTIONS(3691),
    [anon_sym_NULL] = ACTIONS(3691),
    [anon_sym_nullptr] = ACTIONS(3691),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3691),
    [anon_sym_let] = ACTIONS(3691),
    [anon_sym_This] = ACTIONS(3691),
    [anon_sym_decltype] = ACTIONS(3691),
    [anon_sym_explicit] = ACTIONS(3691),
    [anon_sym_typename] = ACTIONS(3691),
    [anon_sym_export] = ACTIONS(3691),
    [anon_sym_module] = ACTIONS(3691),
    [anon_sym_import] = ACTIONS(3691),
    [anon_sym_template] = ACTIONS(3691),
    [anon_sym_operator] = ACTIONS(3691),
    [anon_sym_try] = ACTIONS(3691),
    [anon_sym_delete] = ACTIONS(3691),
    [anon_sym_throw] = ACTIONS(3691),
    [anon_sym_namespace] = ACTIONS(3691),
    [anon_sym_static_assert] = ACTIONS(3691),
    [anon_sym_concept] = ACTIONS(3691),
    [anon_sym_co_return] = ACTIONS(3691),
    [anon_sym_co_yield] = ACTIONS(3691),
    [anon_sym_R_DQUOTE] = ACTIONS(3693),
    [anon_sym_LR_DQUOTE] = ACTIONS(3693),
    [anon_sym_uR_DQUOTE] = ACTIONS(3693),
    [anon_sym_UR_DQUOTE] = ACTIONS(3693),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3693),
    [anon_sym_co_await] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3691),
    [anon_sym_requires] = ACTIONS(3691),
    [sym_this] = ACTIONS(3691),
    [anon_sym_precise] = ACTIONS(3691),
    [anon_sym_shared] = ACTIONS(3691),
    [anon_sym_groupshared] = ACTIONS(3691),
    [anon_sym_uniform] = ACTIONS(3691),
    [anon_sym_row_major] = ACTIONS(3691),
    [anon_sym_column_major] = ACTIONS(3691),
    [anon_sym_globallycoherent] = ACTIONS(3691),
    [anon_sym_centroid] = ACTIONS(3691),
    [anon_sym_noperspective] = ACTIONS(3691),
    [anon_sym_nointerpolation] = ACTIONS(3691),
    [anon_sym_sample] = ACTIONS(3691),
    [anon_sym_linear] = ACTIONS(3691),
    [anon_sym_snorm] = ACTIONS(3691),
    [anon_sym_unorm] = ACTIONS(3691),
    [anon_sym_point] = ACTIONS(3691),
    [anon_sym_line] = ACTIONS(3691),
    [anon_sym_triangleadj] = ACTIONS(3691),
    [anon_sym_lineadj] = ACTIONS(3691),
    [anon_sym_triangle] = ACTIONS(3691),
    [anon_sym_interface] = ACTIONS(3691),
    [anon_sym_extension] = ACTIONS(3691),
    [anon_sym___exported] = ACTIONS(3691),
  },
  [997] = {
    [ts_builtin_sym_end] = ACTIONS(3891),
    [sym_identifier] = ACTIONS(3889),
    [aux_sym_preproc_include_token1] = ACTIONS(3889),
    [aux_sym_preproc_def_token1] = ACTIONS(3889),
    [aux_sym_preproc_if_token1] = ACTIONS(3889),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3889),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3889),
    [sym_preproc_directive] = ACTIONS(3889),
    [anon_sym_LPAREN2] = ACTIONS(3891),
    [anon_sym_BANG] = ACTIONS(3891),
    [anon_sym_TILDE] = ACTIONS(3891),
    [anon_sym_DASH] = ACTIONS(3889),
    [anon_sym_PLUS] = ACTIONS(3889),
    [anon_sym_STAR] = ACTIONS(3891),
    [anon_sym_AMP_AMP] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3889),
    [anon_sym_SEMI] = ACTIONS(3891),
    [anon_sym___extension__] = ACTIONS(3889),
    [anon_sym_typedef] = ACTIONS(3889),
    [anon_sym_in] = ACTIONS(3889),
    [anon_sym_out] = ACTIONS(3889),
    [anon_sym_inout] = ACTIONS(3889),
    [anon_sym_virtual] = ACTIONS(3889),
    [anon_sym_extern] = ACTIONS(3889),
    [anon_sym___attribute__] = ACTIONS(3889),
    [anon_sym___attribute] = ACTIONS(3889),
    [anon_sym_using] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3891),
    [anon_sym___declspec] = ACTIONS(3889),
    [anon_sym___based] = ACTIONS(3889),
    [anon_sym___cdecl] = ACTIONS(3889),
    [anon_sym___clrcall] = ACTIONS(3889),
    [anon_sym___stdcall] = ACTIONS(3889),
    [anon_sym___fastcall] = ACTIONS(3889),
    [anon_sym___thiscall] = ACTIONS(3889),
    [anon_sym___vectorcall] = ACTIONS(3889),
    [anon_sym_LBRACE] = ACTIONS(3891),
    [anon_sym_signed] = ACTIONS(3889),
    [anon_sym_unsigned] = ACTIONS(3889),
    [anon_sym_long] = ACTIONS(3889),
    [anon_sym_short] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_static] = ACTIONS(3889),
    [anon_sym_register] = ACTIONS(3889),
    [anon_sym_inline] = ACTIONS(3889),
    [anon_sym___inline] = ACTIONS(3889),
    [anon_sym___inline__] = ACTIONS(3889),
    [anon_sym___forceinline] = ACTIONS(3889),
    [anon_sym_thread_local] = ACTIONS(3889),
    [anon_sym___thread] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3889),
    [anon_sym_constexpr] = ACTIONS(3889),
    [anon_sym_volatile] = ACTIONS(3889),
    [anon_sym_restrict] = ACTIONS(3889),
    [anon_sym___restrict__] = ACTIONS(3889),
    [anon_sym__Atomic] = ACTIONS(3889),
    [anon_sym__Noreturn] = ACTIONS(3889),
    [anon_sym_noreturn] = ACTIONS(3889),
    [anon_sym__Nonnull] = ACTIONS(3889),
    [anon_sym_mutable] = ACTIONS(3889),
    [anon_sym_constinit] = ACTIONS(3889),
    [anon_sym_consteval] = ACTIONS(3889),
    [anon_sym_alignas] = ACTIONS(3889),
    [anon_sym__Alignas] = ACTIONS(3889),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_enum] = ACTIONS(3889),
    [anon_sym_class] = ACTIONS(3889),
    [anon_sym_struct] = ACTIONS(3889),
    [anon_sym_union] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3889),
    [anon_sym_switch] = ACTIONS(3889),
    [anon_sym_case] = ACTIONS(3889),
    [anon_sym_default] = ACTIONS(3889),
    [anon_sym_while] = ACTIONS(3889),
    [anon_sym_do] = ACTIONS(3889),
    [anon_sym_for] = ACTIONS(3889),
    [anon_sym_return] = ACTIONS(3889),
    [anon_sym_break] = ACTIONS(3889),
    [anon_sym_continue] = ACTIONS(3889),
    [anon_sym_goto] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3889),
    [anon_sym_compl] = ACTIONS(3889),
    [anon_sym_DASH_DASH] = ACTIONS(3891),
    [anon_sym_PLUS_PLUS] = ACTIONS(3891),
    [anon_sym_sizeof] = ACTIONS(3889),
    [anon_sym___alignof__] = ACTIONS(3889),
    [anon_sym___alignof] = ACTIONS(3889),
    [anon_sym__alignof] = ACTIONS(3889),
    [anon_sym_alignof] = ACTIONS(3889),
    [anon_sym__Alignof] = ACTIONS(3889),
    [anon_sym_offsetof] = ACTIONS(3889),
    [anon_sym__Generic] = ACTIONS(3889),
    [anon_sym_asm] = ACTIONS(3889),
    [anon_sym___asm__] = ACTIONS(3889),
    [anon_sym___asm] = ACTIONS(3889),
    [sym_number_literal] = ACTIONS(3891),
    [anon_sym_L_SQUOTE] = ACTIONS(3891),
    [anon_sym_u_SQUOTE] = ACTIONS(3891),
    [anon_sym_U_SQUOTE] = ACTIONS(3891),
    [anon_sym_u8_SQUOTE] = ACTIONS(3891),
    [anon_sym_SQUOTE] = ACTIONS(3891),
    [anon_sym_L_DQUOTE] = ACTIONS(3891),
    [anon_sym_u_DQUOTE] = ACTIONS(3891),
    [anon_sym_U_DQUOTE] = ACTIONS(3891),
    [anon_sym_u8_DQUOTE] = ACTIONS(3891),
    [anon_sym_DQUOTE] = ACTIONS(3891),
    [sym_true] = ACTIONS(3889),
    [sym_false] = ACTIONS(3889),
    [anon_sym_NULL] = ACTIONS(3889),
    [anon_sym_nullptr] = ACTIONS(3889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_This] = ACTIONS(3889),
    [anon_sym_decltype] = ACTIONS(3889),
    [anon_sym_explicit] = ACTIONS(3889),
    [anon_sym_typename] = ACTIONS(3889),
    [anon_sym_export] = ACTIONS(3889),
    [anon_sym_module] = ACTIONS(3889),
    [anon_sym_import] = ACTIONS(3889),
    [anon_sym_template] = ACTIONS(3889),
    [anon_sym_operator] = ACTIONS(3889),
    [anon_sym_try] = ACTIONS(3889),
    [anon_sym_delete] = ACTIONS(3889),
    [anon_sym_throw] = ACTIONS(3889),
    [anon_sym_namespace] = ACTIONS(3889),
    [anon_sym_static_assert] = ACTIONS(3889),
    [anon_sym_concept] = ACTIONS(3889),
    [anon_sym_co_return] = ACTIONS(3889),
    [anon_sym_co_yield] = ACTIONS(3889),
    [anon_sym_R_DQUOTE] = ACTIONS(3891),
    [anon_sym_LR_DQUOTE] = ACTIONS(3891),
    [anon_sym_uR_DQUOTE] = ACTIONS(3891),
    [anon_sym_UR_DQUOTE] = ACTIONS(3891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3891),
    [anon_sym_co_await] = ACTIONS(3889),
    [anon_sym_new] = ACTIONS(3889),
    [anon_sym_requires] = ACTIONS(3889),
    [sym_this] = ACTIONS(3889),
    [anon_sym_precise] = ACTIONS(3889),
    [anon_sym_shared] = ACTIONS(3889),
    [anon_sym_groupshared] = ACTIONS(3889),
    [anon_sym_uniform] = ACTIONS(3889),
    [anon_sym_row_major] = ACTIONS(3889),
    [anon_sym_column_major] = ACTIONS(3889),
    [anon_sym_globallycoherent] = ACTIONS(3889),
    [anon_sym_centroid] = ACTIONS(3889),
    [anon_sym_noperspective] = ACTIONS(3889),
    [anon_sym_nointerpolation] = ACTIONS(3889),
    [anon_sym_sample] = ACTIONS(3889),
    [anon_sym_linear] = ACTIONS(3889),
    [anon_sym_snorm] = ACTIONS(3889),
    [anon_sym_unorm] = ACTIONS(3889),
    [anon_sym_point] = ACTIONS(3889),
    [anon_sym_line] = ACTIONS(3889),
    [anon_sym_triangleadj] = ACTIONS(3889),
    [anon_sym_lineadj] = ACTIONS(3889),
    [anon_sym_triangle] = ACTIONS(3889),
    [anon_sym_interface] = ACTIONS(3889),
    [anon_sym_extension] = ACTIONS(3889),
    [anon_sym___exported] = ACTIONS(3889),
  },
  [998] = {
    [sym_identifier] = ACTIONS(3931),
    [aux_sym_preproc_include_token1] = ACTIONS(3931),
    [aux_sym_preproc_def_token1] = ACTIONS(3931),
    [aux_sym_preproc_if_token1] = ACTIONS(3931),
    [aux_sym_preproc_if_token2] = ACTIONS(3931),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3931),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3931),
    [sym_preproc_directive] = ACTIONS(3931),
    [anon_sym_LPAREN2] = ACTIONS(3933),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_TILDE] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_STAR] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_SEMI] = ACTIONS(3933),
    [anon_sym___extension__] = ACTIONS(3931),
    [anon_sym_typedef] = ACTIONS(3931),
    [anon_sym_in] = ACTIONS(3931),
    [anon_sym_out] = ACTIONS(3931),
    [anon_sym_inout] = ACTIONS(3931),
    [anon_sym_virtual] = ACTIONS(3931),
    [anon_sym_extern] = ACTIONS(3931),
    [anon_sym___attribute__] = ACTIONS(3931),
    [anon_sym___attribute] = ACTIONS(3931),
    [anon_sym_using] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3933),
    [anon_sym___declspec] = ACTIONS(3931),
    [anon_sym___based] = ACTIONS(3931),
    [anon_sym___cdecl] = ACTIONS(3931),
    [anon_sym___clrcall] = ACTIONS(3931),
    [anon_sym___stdcall] = ACTIONS(3931),
    [anon_sym___fastcall] = ACTIONS(3931),
    [anon_sym___thiscall] = ACTIONS(3931),
    [anon_sym___vectorcall] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3933),
    [anon_sym_signed] = ACTIONS(3931),
    [anon_sym_unsigned] = ACTIONS(3931),
    [anon_sym_long] = ACTIONS(3931),
    [anon_sym_short] = ACTIONS(3931),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_static] = ACTIONS(3931),
    [anon_sym_register] = ACTIONS(3931),
    [anon_sym_inline] = ACTIONS(3931),
    [anon_sym___inline] = ACTIONS(3931),
    [anon_sym___inline__] = ACTIONS(3931),
    [anon_sym___forceinline] = ACTIONS(3931),
    [anon_sym_thread_local] = ACTIONS(3931),
    [anon_sym___thread] = ACTIONS(3931),
    [anon_sym_const] = ACTIONS(3931),
    [anon_sym_constexpr] = ACTIONS(3931),
    [anon_sym_volatile] = ACTIONS(3931),
    [anon_sym_restrict] = ACTIONS(3931),
    [anon_sym___restrict__] = ACTIONS(3931),
    [anon_sym__Atomic] = ACTIONS(3931),
    [anon_sym__Noreturn] = ACTIONS(3931),
    [anon_sym_noreturn] = ACTIONS(3931),
    [anon_sym__Nonnull] = ACTIONS(3931),
    [anon_sym_mutable] = ACTIONS(3931),
    [anon_sym_constinit] = ACTIONS(3931),
    [anon_sym_consteval] = ACTIONS(3931),
    [anon_sym_alignas] = ACTIONS(3931),
    [anon_sym__Alignas] = ACTIONS(3931),
    [sym_primitive_type] = ACTIONS(3931),
    [anon_sym_enum] = ACTIONS(3931),
    [anon_sym_class] = ACTIONS(3931),
    [anon_sym_struct] = ACTIONS(3931),
    [anon_sym_union] = ACTIONS(3931),
    [anon_sym_if] = ACTIONS(3931),
    [anon_sym_switch] = ACTIONS(3931),
    [anon_sym_case] = ACTIONS(3931),
    [anon_sym_default] = ACTIONS(3931),
    [anon_sym_while] = ACTIONS(3931),
    [anon_sym_do] = ACTIONS(3931),
    [anon_sym_for] = ACTIONS(3931),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_break] = ACTIONS(3931),
    [anon_sym_continue] = ACTIONS(3931),
    [anon_sym_goto] = ACTIONS(3931),
    [anon_sym___try] = ACTIONS(3931),
    [anon_sym___leave] = ACTIONS(3931),
    [anon_sym_not] = ACTIONS(3931),
    [anon_sym_compl] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_sizeof] = ACTIONS(3931),
    [anon_sym___alignof__] = ACTIONS(3931),
    [anon_sym___alignof] = ACTIONS(3931),
    [anon_sym__alignof] = ACTIONS(3931),
    [anon_sym_alignof] = ACTIONS(3931),
    [anon_sym__Alignof] = ACTIONS(3931),
    [anon_sym_offsetof] = ACTIONS(3931),
    [anon_sym__Generic] = ACTIONS(3931),
    [anon_sym_asm] = ACTIONS(3931),
    [anon_sym___asm__] = ACTIONS(3931),
    [anon_sym___asm] = ACTIONS(3931),
    [sym_number_literal] = ACTIONS(3933),
    [anon_sym_L_SQUOTE] = ACTIONS(3933),
    [anon_sym_u_SQUOTE] = ACTIONS(3933),
    [anon_sym_U_SQUOTE] = ACTIONS(3933),
    [anon_sym_u8_SQUOTE] = ACTIONS(3933),
    [anon_sym_SQUOTE] = ACTIONS(3933),
    [anon_sym_L_DQUOTE] = ACTIONS(3933),
    [anon_sym_u_DQUOTE] = ACTIONS(3933),
    [anon_sym_U_DQUOTE] = ACTIONS(3933),
    [anon_sym_u8_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE] = ACTIONS(3933),
    [sym_true] = ACTIONS(3931),
    [sym_false] = ACTIONS(3931),
    [anon_sym_NULL] = ACTIONS(3931),
    [anon_sym_nullptr] = ACTIONS(3931),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3931),
    [anon_sym_let] = ACTIONS(3931),
    [anon_sym_This] = ACTIONS(3931),
    [anon_sym_decltype] = ACTIONS(3931),
    [anon_sym_explicit] = ACTIONS(3931),
    [anon_sym_typename] = ACTIONS(3931),
    [anon_sym_template] = ACTIONS(3931),
    [anon_sym_operator] = ACTIONS(3931),
    [anon_sym_try] = ACTIONS(3931),
    [anon_sym_delete] = ACTIONS(3931),
    [anon_sym_throw] = ACTIONS(3931),
    [anon_sym_namespace] = ACTIONS(3931),
    [anon_sym_static_assert] = ACTIONS(3931),
    [anon_sym_concept] = ACTIONS(3931),
    [anon_sym_co_return] = ACTIONS(3931),
    [anon_sym_co_yield] = ACTIONS(3931),
    [anon_sym_R_DQUOTE] = ACTIONS(3933),
    [anon_sym_LR_DQUOTE] = ACTIONS(3933),
    [anon_sym_uR_DQUOTE] = ACTIONS(3933),
    [anon_sym_UR_DQUOTE] = ACTIONS(3933),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3933),
    [anon_sym_co_await] = ACTIONS(3931),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_requires] = ACTIONS(3931),
    [sym_this] = ACTIONS(3931),
    [anon_sym_discard] = ACTIONS(3931),
    [anon_sym_precise] = ACTIONS(3931),
    [anon_sym_shared] = ACTIONS(3931),
    [anon_sym_groupshared] = ACTIONS(3931),
    [anon_sym_uniform] = ACTIONS(3931),
    [anon_sym_row_major] = ACTIONS(3931),
    [anon_sym_column_major] = ACTIONS(3931),
    [anon_sym_globallycoherent] = ACTIONS(3931),
    [anon_sym_centroid] = ACTIONS(3931),
    [anon_sym_noperspective] = ACTIONS(3931),
    [anon_sym_nointerpolation] = ACTIONS(3931),
    [anon_sym_sample] = ACTIONS(3931),
    [anon_sym_linear] = ACTIONS(3931),
    [anon_sym_snorm] = ACTIONS(3931),
    [anon_sym_unorm] = ACTIONS(3931),
    [anon_sym_point] = ACTIONS(3931),
    [anon_sym_line] = ACTIONS(3931),
    [anon_sym_triangleadj] = ACTIONS(3931),
    [anon_sym_lineadj] = ACTIONS(3931),
    [anon_sym_triangle] = ACTIONS(3931),
    [anon_sym_cbuffer] = ACTIONS(3931),
    [anon_sym_interface] = ACTIONS(3931),
    [anon_sym_extension] = ACTIONS(3931),
  },
  [999] = {
    [sym_identifier] = ACTIONS(3751),
    [aux_sym_preproc_include_token1] = ACTIONS(3751),
    [aux_sym_preproc_def_token1] = ACTIONS(3751),
    [aux_sym_preproc_if_token1] = ACTIONS(3751),
    [aux_sym_preproc_if_token2] = ACTIONS(3751),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3751),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3751),
    [sym_preproc_directive] = ACTIONS(3751),
    [anon_sym_LPAREN2] = ACTIONS(3753),
    [anon_sym_BANG] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3751),
    [anon_sym_PLUS] = ACTIONS(3751),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_AMP] = ACTIONS(3751),
    [anon_sym_SEMI] = ACTIONS(3753),
    [anon_sym___extension__] = ACTIONS(3751),
    [anon_sym_typedef] = ACTIONS(3751),
    [anon_sym_in] = ACTIONS(3751),
    [anon_sym_out] = ACTIONS(3751),
    [anon_sym_inout] = ACTIONS(3751),
    [anon_sym_virtual] = ACTIONS(3751),
    [anon_sym_extern] = ACTIONS(3751),
    [anon_sym___attribute__] = ACTIONS(3751),
    [anon_sym___attribute] = ACTIONS(3751),
    [anon_sym_using] = ACTIONS(3751),
    [anon_sym_COLON_COLON] = ACTIONS(3753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3753),
    [anon_sym___declspec] = ACTIONS(3751),
    [anon_sym___based] = ACTIONS(3751),
    [anon_sym___cdecl] = ACTIONS(3751),
    [anon_sym___clrcall] = ACTIONS(3751),
    [anon_sym___stdcall] = ACTIONS(3751),
    [anon_sym___fastcall] = ACTIONS(3751),
    [anon_sym___thiscall] = ACTIONS(3751),
    [anon_sym___vectorcall] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_signed] = ACTIONS(3751),
    [anon_sym_unsigned] = ACTIONS(3751),
    [anon_sym_long] = ACTIONS(3751),
    [anon_sym_short] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3751),
    [anon_sym_static] = ACTIONS(3751),
    [anon_sym_register] = ACTIONS(3751),
    [anon_sym_inline] = ACTIONS(3751),
    [anon_sym___inline] = ACTIONS(3751),
    [anon_sym___inline__] = ACTIONS(3751),
    [anon_sym___forceinline] = ACTIONS(3751),
    [anon_sym_thread_local] = ACTIONS(3751),
    [anon_sym___thread] = ACTIONS(3751),
    [anon_sym_const] = ACTIONS(3751),
    [anon_sym_constexpr] = ACTIONS(3751),
    [anon_sym_volatile] = ACTIONS(3751),
    [anon_sym_restrict] = ACTIONS(3751),
    [anon_sym___restrict__] = ACTIONS(3751),
    [anon_sym__Atomic] = ACTIONS(3751),
    [anon_sym__Noreturn] = ACTIONS(3751),
    [anon_sym_noreturn] = ACTIONS(3751),
    [anon_sym__Nonnull] = ACTIONS(3751),
    [anon_sym_mutable] = ACTIONS(3751),
    [anon_sym_constinit] = ACTIONS(3751),
    [anon_sym_consteval] = ACTIONS(3751),
    [anon_sym_alignas] = ACTIONS(3751),
    [anon_sym__Alignas] = ACTIONS(3751),
    [sym_primitive_type] = ACTIONS(3751),
    [anon_sym_enum] = ACTIONS(3751),
    [anon_sym_class] = ACTIONS(3751),
    [anon_sym_struct] = ACTIONS(3751),
    [anon_sym_union] = ACTIONS(3751),
    [anon_sym_if] = ACTIONS(3751),
    [anon_sym_switch] = ACTIONS(3751),
    [anon_sym_case] = ACTIONS(3751),
    [anon_sym_default] = ACTIONS(3751),
    [anon_sym_while] = ACTIONS(3751),
    [anon_sym_do] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3751),
    [anon_sym_return] = ACTIONS(3751),
    [anon_sym_break] = ACTIONS(3751),
    [anon_sym_continue] = ACTIONS(3751),
    [anon_sym_goto] = ACTIONS(3751),
    [anon_sym___try] = ACTIONS(3751),
    [anon_sym___leave] = ACTIONS(3751),
    [anon_sym_not] = ACTIONS(3751),
    [anon_sym_compl] = ACTIONS(3751),
    [anon_sym_DASH_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_PLUS] = ACTIONS(3753),
    [anon_sym_sizeof] = ACTIONS(3751),
    [anon_sym___alignof__] = ACTIONS(3751),
    [anon_sym___alignof] = ACTIONS(3751),
    [anon_sym__alignof] = ACTIONS(3751),
    [anon_sym_alignof] = ACTIONS(3751),
    [anon_sym__Alignof] = ACTIONS(3751),
    [anon_sym_offsetof] = ACTIONS(3751),
    [anon_sym__Generic] = ACTIONS(3751),
    [anon_sym_asm] = ACTIONS(3751),
    [anon_sym___asm__] = ACTIONS(3751),
    [anon_sym___asm] = ACTIONS(3751),
    [sym_number_literal] = ACTIONS(3753),
    [anon_sym_L_SQUOTE] = ACTIONS(3753),
    [anon_sym_u_SQUOTE] = ACTIONS(3753),
    [anon_sym_U_SQUOTE] = ACTIONS(3753),
    [anon_sym_u8_SQUOTE] = ACTIONS(3753),
    [anon_sym_SQUOTE] = ACTIONS(3753),
    [anon_sym_L_DQUOTE] = ACTIONS(3753),
    [anon_sym_u_DQUOTE] = ACTIONS(3753),
    [anon_sym_U_DQUOTE] = ACTIONS(3753),
    [anon_sym_u8_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [sym_true] = ACTIONS(3751),
    [sym_false] = ACTIONS(3751),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3751),
    [anon_sym_let] = ACTIONS(3751),
    [anon_sym_This] = ACTIONS(3751),
    [anon_sym_decltype] = ACTIONS(3751),
    [anon_sym_explicit] = ACTIONS(3751),
    [anon_sym_typename] = ACTIONS(3751),
    [anon_sym_template] = ACTIONS(3751),
    [anon_sym_operator] = ACTIONS(3751),
    [anon_sym_try] = ACTIONS(3751),
    [anon_sym_delete] = ACTIONS(3751),
    [anon_sym_throw] = ACTIONS(3751),
    [anon_sym_namespace] = ACTIONS(3751),
    [anon_sym_static_assert] = ACTIONS(3751),
    [anon_sym_concept] = ACTIONS(3751),
    [anon_sym_co_return] = ACTIONS(3751),
    [anon_sym_co_yield] = ACTIONS(3751),
    [anon_sym_R_DQUOTE] = ACTIONS(3753),
    [anon_sym_LR_DQUOTE] = ACTIONS(3753),
    [anon_sym_uR_DQUOTE] = ACTIONS(3753),
    [anon_sym_UR_DQUOTE] = ACTIONS(3753),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3753),
    [anon_sym_co_await] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3751),
    [anon_sym_requires] = ACTIONS(3751),
    [sym_this] = ACTIONS(3751),
    [anon_sym_discard] = ACTIONS(3751),
    [anon_sym_precise] = ACTIONS(3751),
    [anon_sym_shared] = ACTIONS(3751),
    [anon_sym_groupshared] = ACTIONS(3751),
    [anon_sym_uniform] = ACTIONS(3751),
    [anon_sym_row_major] = ACTIONS(3751),
    [anon_sym_column_major] = ACTIONS(3751),
    [anon_sym_globallycoherent] = ACTIONS(3751),
    [anon_sym_centroid] = ACTIONS(3751),
    [anon_sym_noperspective] = ACTIONS(3751),
    [anon_sym_nointerpolation] = ACTIONS(3751),
    [anon_sym_sample] = ACTIONS(3751),
    [anon_sym_linear] = ACTIONS(3751),
    [anon_sym_snorm] = ACTIONS(3751),
    [anon_sym_unorm] = ACTIONS(3751),
    [anon_sym_point] = ACTIONS(3751),
    [anon_sym_line] = ACTIONS(3751),
    [anon_sym_triangleadj] = ACTIONS(3751),
    [anon_sym_lineadj] = ACTIONS(3751),
    [anon_sym_triangle] = ACTIONS(3751),
    [anon_sym_cbuffer] = ACTIONS(3751),
    [anon_sym_interface] = ACTIONS(3751),
    [anon_sym_extension] = ACTIONS(3751),
  },
  [1000] = {
    [sym_identifier] = ACTIONS(3755),
    [aux_sym_preproc_include_token1] = ACTIONS(3755),
    [aux_sym_preproc_def_token1] = ACTIONS(3755),
    [aux_sym_preproc_if_token1] = ACTIONS(3755),
    [aux_sym_preproc_if_token2] = ACTIONS(3755),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3755),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3755),
    [sym_preproc_directive] = ACTIONS(3755),
    [anon_sym_LPAREN2] = ACTIONS(3757),
    [anon_sym_BANG] = ACTIONS(3757),
    [anon_sym_TILDE] = ACTIONS(3757),
    [anon_sym_DASH] = ACTIONS(3755),
    [anon_sym_PLUS] = ACTIONS(3755),
    [anon_sym_STAR] = ACTIONS(3757),
    [anon_sym_AMP_AMP] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3755),
    [anon_sym_SEMI] = ACTIONS(3757),
    [anon_sym___extension__] = ACTIONS(3755),
    [anon_sym_typedef] = ACTIONS(3755),
    [anon_sym_in] = ACTIONS(3755),
    [anon_sym_out] = ACTIONS(3755),
    [anon_sym_inout] = ACTIONS(3755),
    [anon_sym_virtual] = ACTIONS(3755),
    [anon_sym_extern] = ACTIONS(3755),
    [anon_sym___attribute__] = ACTIONS(3755),
    [anon_sym___attribute] = ACTIONS(3755),
    [anon_sym_using] = ACTIONS(3755),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3757),
    [anon_sym___declspec] = ACTIONS(3755),
    [anon_sym___based] = ACTIONS(3755),
    [anon_sym___cdecl] = ACTIONS(3755),
    [anon_sym___clrcall] = ACTIONS(3755),
    [anon_sym___stdcall] = ACTIONS(3755),
    [anon_sym___fastcall] = ACTIONS(3755),
    [anon_sym___thiscall] = ACTIONS(3755),
    [anon_sym___vectorcall] = ACTIONS(3755),
    [anon_sym_LBRACE] = ACTIONS(3757),
    [anon_sym_signed] = ACTIONS(3755),
    [anon_sym_unsigned] = ACTIONS(3755),
    [anon_sym_long] = ACTIONS(3755),
    [anon_sym_short] = ACTIONS(3755),
    [anon_sym_LBRACK] = ACTIONS(3755),
    [anon_sym_static] = ACTIONS(3755),
    [anon_sym_register] = ACTIONS(3755),
    [anon_sym_inline] = ACTIONS(3755),
    [anon_sym___inline] = ACTIONS(3755),
    [anon_sym___inline__] = ACTIONS(3755),
    [anon_sym___forceinline] = ACTIONS(3755),
    [anon_sym_thread_local] = ACTIONS(3755),
    [anon_sym___thread] = ACTIONS(3755),
    [anon_sym_const] = ACTIONS(3755),
    [anon_sym_constexpr] = ACTIONS(3755),
    [anon_sym_volatile] = ACTIONS(3755),
    [anon_sym_restrict] = ACTIONS(3755),
    [anon_sym___restrict__] = ACTIONS(3755),
    [anon_sym__Atomic] = ACTIONS(3755),
    [anon_sym__Noreturn] = ACTIONS(3755),
    [anon_sym_noreturn] = ACTIONS(3755),
    [anon_sym__Nonnull] = ACTIONS(3755),
    [anon_sym_mutable] = ACTIONS(3755),
    [anon_sym_constinit] = ACTIONS(3755),
    [anon_sym_consteval] = ACTIONS(3755),
    [anon_sym_alignas] = ACTIONS(3755),
    [anon_sym__Alignas] = ACTIONS(3755),
    [sym_primitive_type] = ACTIONS(3755),
    [anon_sym_enum] = ACTIONS(3755),
    [anon_sym_class] = ACTIONS(3755),
    [anon_sym_struct] = ACTIONS(3755),
    [anon_sym_union] = ACTIONS(3755),
    [anon_sym_if] = ACTIONS(3755),
    [anon_sym_switch] = ACTIONS(3755),
    [anon_sym_case] = ACTIONS(3755),
    [anon_sym_default] = ACTIONS(3755),
    [anon_sym_while] = ACTIONS(3755),
    [anon_sym_do] = ACTIONS(3755),
    [anon_sym_for] = ACTIONS(3755),
    [anon_sym_return] = ACTIONS(3755),
    [anon_sym_break] = ACTIONS(3755),
    [anon_sym_continue] = ACTIONS(3755),
    [anon_sym_goto] = ACTIONS(3755),
    [anon_sym___try] = ACTIONS(3755),
    [anon_sym___leave] = ACTIONS(3755),
    [anon_sym_not] = ACTIONS(3755),
    [anon_sym_compl] = ACTIONS(3755),
    [anon_sym_DASH_DASH] = ACTIONS(3757),
    [anon_sym_PLUS_PLUS] = ACTIONS(3757),
    [anon_sym_sizeof] = ACTIONS(3755),
    [anon_sym___alignof__] = ACTIONS(3755),
    [anon_sym___alignof] = ACTIONS(3755),
    [anon_sym__alignof] = ACTIONS(3755),
    [anon_sym_alignof] = ACTIONS(3755),
    [anon_sym__Alignof] = ACTIONS(3755),
    [anon_sym_offsetof] = ACTIONS(3755),
    [anon_sym__Generic] = ACTIONS(3755),
    [anon_sym_asm] = ACTIONS(3755),
    [anon_sym___asm__] = ACTIONS(3755),
    [anon_sym___asm] = ACTIONS(3755),
    [sym_number_literal] = ACTIONS(3757),
    [anon_sym_L_SQUOTE] = ACTIONS(3757),
    [anon_sym_u_SQUOTE] = ACTIONS(3757),
    [anon_sym_U_SQUOTE] = ACTIONS(3757),
    [anon_sym_u8_SQUOTE] = ACTIONS(3757),
    [anon_sym_SQUOTE] = ACTIONS(3757),
    [anon_sym_L_DQUOTE] = ACTIONS(3757),
    [anon_sym_u_DQUOTE] = ACTIONS(3757),
    [anon_sym_U_DQUOTE] = ACTIONS(3757),
    [anon_sym_u8_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE] = ACTIONS(3757),
    [sym_true] = ACTIONS(3755),
    [sym_false] = ACTIONS(3755),
    [anon_sym_NULL] = ACTIONS(3755),
    [anon_sym_nullptr] = ACTIONS(3755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3755),
    [anon_sym_let] = ACTIONS(3755),
    [anon_sym_This] = ACTIONS(3755),
    [anon_sym_decltype] = ACTIONS(3755),
    [anon_sym_explicit] = ACTIONS(3755),
    [anon_sym_typename] = ACTIONS(3755),
    [anon_sym_template] = ACTIONS(3755),
    [anon_sym_operator] = ACTIONS(3755),
    [anon_sym_try] = ACTIONS(3755),
    [anon_sym_delete] = ACTIONS(3755),
    [anon_sym_throw] = ACTIONS(3755),
    [anon_sym_namespace] = ACTIONS(3755),
    [anon_sym_static_assert] = ACTIONS(3755),
    [anon_sym_concept] = ACTIONS(3755),
    [anon_sym_co_return] = ACTIONS(3755),
    [anon_sym_co_yield] = ACTIONS(3755),
    [anon_sym_R_DQUOTE] = ACTIONS(3757),
    [anon_sym_LR_DQUOTE] = ACTIONS(3757),
    [anon_sym_uR_DQUOTE] = ACTIONS(3757),
    [anon_sym_UR_DQUOTE] = ACTIONS(3757),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3757),
    [anon_sym_co_await] = ACTIONS(3755),
    [anon_sym_new] = ACTIONS(3755),
    [anon_sym_requires] = ACTIONS(3755),
    [sym_this] = ACTIONS(3755),
    [anon_sym_discard] = ACTIONS(3755),
    [anon_sym_precise] = ACTIONS(3755),
    [anon_sym_shared] = ACTIONS(3755),
    [anon_sym_groupshared] = ACTIONS(3755),
    [anon_sym_uniform] = ACTIONS(3755),
    [anon_sym_row_major] = ACTIONS(3755),
    [anon_sym_column_major] = ACTIONS(3755),
    [anon_sym_globallycoherent] = ACTIONS(3755),
    [anon_sym_centroid] = ACTIONS(3755),
    [anon_sym_noperspective] = ACTIONS(3755),
    [anon_sym_nointerpolation] = ACTIONS(3755),
    [anon_sym_sample] = ACTIONS(3755),
    [anon_sym_linear] = ACTIONS(3755),
    [anon_sym_snorm] = ACTIONS(3755),
    [anon_sym_unorm] = ACTIONS(3755),
    [anon_sym_point] = ACTIONS(3755),
    [anon_sym_line] = ACTIONS(3755),
    [anon_sym_triangleadj] = ACTIONS(3755),
    [anon_sym_lineadj] = ACTIONS(3755),
    [anon_sym_triangle] = ACTIONS(3755),
    [anon_sym_cbuffer] = ACTIONS(3755),
    [anon_sym_interface] = ACTIONS(3755),
    [anon_sym_extension] = ACTIONS(3755),
  },
  [1001] = {
    [ts_builtin_sym_end] = ACTIONS(4267),
    [sym_identifier] = ACTIONS(4269),
    [aux_sym_preproc_include_token1] = ACTIONS(4269),
    [aux_sym_preproc_def_token1] = ACTIONS(4269),
    [aux_sym_preproc_if_token1] = ACTIONS(4269),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4269),
    [sym_preproc_directive] = ACTIONS(4269),
    [anon_sym_LPAREN2] = ACTIONS(4267),
    [anon_sym_BANG] = ACTIONS(4267),
    [anon_sym_TILDE] = ACTIONS(4267),
    [anon_sym_DASH] = ACTIONS(4269),
    [anon_sym_PLUS] = ACTIONS(4269),
    [anon_sym_STAR] = ACTIONS(4267),
    [anon_sym_AMP_AMP] = ACTIONS(4267),
    [anon_sym_AMP] = ACTIONS(4269),
    [anon_sym_SEMI] = ACTIONS(4267),
    [anon_sym___extension__] = ACTIONS(4269),
    [anon_sym_typedef] = ACTIONS(4269),
    [anon_sym_in] = ACTIONS(4269),
    [anon_sym_out] = ACTIONS(4269),
    [anon_sym_inout] = ACTIONS(4269),
    [anon_sym_virtual] = ACTIONS(4269),
    [anon_sym_extern] = ACTIONS(4269),
    [anon_sym___attribute__] = ACTIONS(4269),
    [anon_sym___attribute] = ACTIONS(4269),
    [anon_sym_using] = ACTIONS(4269),
    [anon_sym_COLON_COLON] = ACTIONS(4267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4267),
    [anon_sym___declspec] = ACTIONS(4269),
    [anon_sym___based] = ACTIONS(4269),
    [anon_sym___cdecl] = ACTIONS(4269),
    [anon_sym___clrcall] = ACTIONS(4269),
    [anon_sym___stdcall] = ACTIONS(4269),
    [anon_sym___fastcall] = ACTIONS(4269),
    [anon_sym___thiscall] = ACTIONS(4269),
    [anon_sym___vectorcall] = ACTIONS(4269),
    [anon_sym_LBRACE] = ACTIONS(4267),
    [anon_sym_signed] = ACTIONS(4269),
    [anon_sym_unsigned] = ACTIONS(4269),
    [anon_sym_long] = ACTIONS(4269),
    [anon_sym_short] = ACTIONS(4269),
    [anon_sym_LBRACK] = ACTIONS(4269),
    [anon_sym_static] = ACTIONS(4269),
    [anon_sym_register] = ACTIONS(4269),
    [anon_sym_inline] = ACTIONS(4269),
    [anon_sym___inline] = ACTIONS(4269),
    [anon_sym___inline__] = ACTIONS(4269),
    [anon_sym___forceinline] = ACTIONS(4269),
    [anon_sym_thread_local] = ACTIONS(4269),
    [anon_sym___thread] = ACTIONS(4269),
    [anon_sym_const] = ACTIONS(4269),
    [anon_sym_constexpr] = ACTIONS(4269),
    [anon_sym_volatile] = ACTIONS(4269),
    [anon_sym_restrict] = ACTIONS(4269),
    [anon_sym___restrict__] = ACTIONS(4269),
    [anon_sym__Atomic] = ACTIONS(4269),
    [anon_sym__Noreturn] = ACTIONS(4269),
    [anon_sym_noreturn] = ACTIONS(4269),
    [anon_sym__Nonnull] = ACTIONS(4269),
    [anon_sym_mutable] = ACTIONS(4269),
    [anon_sym_constinit] = ACTIONS(4269),
    [anon_sym_consteval] = ACTIONS(4269),
    [anon_sym_alignas] = ACTIONS(4269),
    [anon_sym__Alignas] = ACTIONS(4269),
    [sym_primitive_type] = ACTIONS(4269),
    [anon_sym_enum] = ACTIONS(4269),
    [anon_sym_class] = ACTIONS(4269),
    [anon_sym_struct] = ACTIONS(4269),
    [anon_sym_union] = ACTIONS(4269),
    [anon_sym_if] = ACTIONS(4269),
    [anon_sym_switch] = ACTIONS(4269),
    [anon_sym_case] = ACTIONS(4269),
    [anon_sym_default] = ACTIONS(4269),
    [anon_sym_while] = ACTIONS(4269),
    [anon_sym_do] = ACTIONS(4269),
    [anon_sym_for] = ACTIONS(4269),
    [anon_sym_return] = ACTIONS(4269),
    [anon_sym_break] = ACTIONS(4269),
    [anon_sym_continue] = ACTIONS(4269),
    [anon_sym_goto] = ACTIONS(4269),
    [anon_sym_not] = ACTIONS(4269),
    [anon_sym_compl] = ACTIONS(4269),
    [anon_sym_DASH_DASH] = ACTIONS(4267),
    [anon_sym_PLUS_PLUS] = ACTIONS(4267),
    [anon_sym_sizeof] = ACTIONS(4269),
    [anon_sym___alignof__] = ACTIONS(4269),
    [anon_sym___alignof] = ACTIONS(4269),
    [anon_sym__alignof] = ACTIONS(4269),
    [anon_sym_alignof] = ACTIONS(4269),
    [anon_sym__Alignof] = ACTIONS(4269),
    [anon_sym_offsetof] = ACTIONS(4269),
    [anon_sym__Generic] = ACTIONS(4269),
    [anon_sym_asm] = ACTIONS(4269),
    [anon_sym___asm__] = ACTIONS(4269),
    [anon_sym___asm] = ACTIONS(4269),
    [sym_number_literal] = ACTIONS(4267),
    [anon_sym_L_SQUOTE] = ACTIONS(4267),
    [anon_sym_u_SQUOTE] = ACTIONS(4267),
    [anon_sym_U_SQUOTE] = ACTIONS(4267),
    [anon_sym_u8_SQUOTE] = ACTIONS(4267),
    [anon_sym_SQUOTE] = ACTIONS(4267),
    [anon_sym_L_DQUOTE] = ACTIONS(4267),
    [anon_sym_u_DQUOTE] = ACTIONS(4267),
    [anon_sym_U_DQUOTE] = ACTIONS(4267),
    [anon_sym_u8_DQUOTE] = ACTIONS(4267),
    [anon_sym_DQUOTE] = ACTIONS(4267),
    [sym_true] = ACTIONS(4269),
    [sym_false] = ACTIONS(4269),
    [anon_sym_NULL] = ACTIONS(4269),
    [anon_sym_nullptr] = ACTIONS(4269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4269),
    [anon_sym_let] = ACTIONS(4269),
    [anon_sym_This] = ACTIONS(4269),
    [anon_sym_decltype] = ACTIONS(4269),
    [anon_sym_explicit] = ACTIONS(4269),
    [anon_sym_typename] = ACTIONS(4269),
    [anon_sym_export] = ACTIONS(4269),
    [anon_sym_module] = ACTIONS(4269),
    [anon_sym_import] = ACTIONS(4269),
    [anon_sym_template] = ACTIONS(4269),
    [anon_sym_operator] = ACTIONS(4269),
    [anon_sym_try] = ACTIONS(4269),
    [anon_sym_delete] = ACTIONS(4269),
    [anon_sym_throw] = ACTIONS(4269),
    [anon_sym_namespace] = ACTIONS(4269),
    [anon_sym_static_assert] = ACTIONS(4269),
    [anon_sym_concept] = ACTIONS(4269),
    [anon_sym_co_return] = ACTIONS(4269),
    [anon_sym_co_yield] = ACTIONS(4269),
    [anon_sym_R_DQUOTE] = ACTIONS(4267),
    [anon_sym_LR_DQUOTE] = ACTIONS(4267),
    [anon_sym_uR_DQUOTE] = ACTIONS(4267),
    [anon_sym_UR_DQUOTE] = ACTIONS(4267),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4267),
    [anon_sym_co_await] = ACTIONS(4269),
    [anon_sym_new] = ACTIONS(4269),
    [anon_sym_requires] = ACTIONS(4269),
    [sym_this] = ACTIONS(4269),
    [anon_sym_precise] = ACTIONS(4269),
    [anon_sym_shared] = ACTIONS(4269),
    [anon_sym_groupshared] = ACTIONS(4269),
    [anon_sym_uniform] = ACTIONS(4269),
    [anon_sym_row_major] = ACTIONS(4269),
    [anon_sym_column_major] = ACTIONS(4269),
    [anon_sym_globallycoherent] = ACTIONS(4269),
    [anon_sym_centroid] = ACTIONS(4269),
    [anon_sym_noperspective] = ACTIONS(4269),
    [anon_sym_nointerpolation] = ACTIONS(4269),
    [anon_sym_sample] = ACTIONS(4269),
    [anon_sym_linear] = ACTIONS(4269),
    [anon_sym_snorm] = ACTIONS(4269),
    [anon_sym_unorm] = ACTIONS(4269),
    [anon_sym_point] = ACTIONS(4269),
    [anon_sym_line] = ACTIONS(4269),
    [anon_sym_triangleadj] = ACTIONS(4269),
    [anon_sym_lineadj] = ACTIONS(4269),
    [anon_sym_triangle] = ACTIONS(4269),
    [anon_sym_interface] = ACTIONS(4269),
    [anon_sym_extension] = ACTIONS(4269),
    [anon_sym___exported] = ACTIONS(4269),
  },
  [1002] = {
    [sym_identifier] = ACTIONS(3963),
    [aux_sym_preproc_include_token1] = ACTIONS(3963),
    [aux_sym_preproc_def_token1] = ACTIONS(3963),
    [aux_sym_preproc_if_token1] = ACTIONS(3963),
    [aux_sym_preproc_if_token2] = ACTIONS(3963),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3963),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3963),
    [sym_preproc_directive] = ACTIONS(3963),
    [anon_sym_LPAREN2] = ACTIONS(3965),
    [anon_sym_BANG] = ACTIONS(3965),
    [anon_sym_TILDE] = ACTIONS(3965),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_STAR] = ACTIONS(3965),
    [anon_sym_AMP_AMP] = ACTIONS(3965),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_SEMI] = ACTIONS(3965),
    [anon_sym___extension__] = ACTIONS(3963),
    [anon_sym_typedef] = ACTIONS(3963),
    [anon_sym_in] = ACTIONS(3963),
    [anon_sym_out] = ACTIONS(3963),
    [anon_sym_inout] = ACTIONS(3963),
    [anon_sym_virtual] = ACTIONS(3963),
    [anon_sym_extern] = ACTIONS(3963),
    [anon_sym___attribute__] = ACTIONS(3963),
    [anon_sym___attribute] = ACTIONS(3963),
    [anon_sym_using] = ACTIONS(3963),
    [anon_sym_COLON_COLON] = ACTIONS(3965),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3965),
    [anon_sym___declspec] = ACTIONS(3963),
    [anon_sym___based] = ACTIONS(3963),
    [anon_sym___cdecl] = ACTIONS(3963),
    [anon_sym___clrcall] = ACTIONS(3963),
    [anon_sym___stdcall] = ACTIONS(3963),
    [anon_sym___fastcall] = ACTIONS(3963),
    [anon_sym___thiscall] = ACTIONS(3963),
    [anon_sym___vectorcall] = ACTIONS(3963),
    [anon_sym_LBRACE] = ACTIONS(3965),
    [anon_sym_signed] = ACTIONS(3963),
    [anon_sym_unsigned] = ACTIONS(3963),
    [anon_sym_long] = ACTIONS(3963),
    [anon_sym_short] = ACTIONS(3963),
    [anon_sym_LBRACK] = ACTIONS(3963),
    [anon_sym_static] = ACTIONS(3963),
    [anon_sym_register] = ACTIONS(3963),
    [anon_sym_inline] = ACTIONS(3963),
    [anon_sym___inline] = ACTIONS(3963),
    [anon_sym___inline__] = ACTIONS(3963),
    [anon_sym___forceinline] = ACTIONS(3963),
    [anon_sym_thread_local] = ACTIONS(3963),
    [anon_sym___thread] = ACTIONS(3963),
    [anon_sym_const] = ACTIONS(3963),
    [anon_sym_constexpr] = ACTIONS(3963),
    [anon_sym_volatile] = ACTIONS(3963),
    [anon_sym_restrict] = ACTIONS(3963),
    [anon_sym___restrict__] = ACTIONS(3963),
    [anon_sym__Atomic] = ACTIONS(3963),
    [anon_sym__Noreturn] = ACTIONS(3963),
    [anon_sym_noreturn] = ACTIONS(3963),
    [anon_sym__Nonnull] = ACTIONS(3963),
    [anon_sym_mutable] = ACTIONS(3963),
    [anon_sym_constinit] = ACTIONS(3963),
    [anon_sym_consteval] = ACTIONS(3963),
    [anon_sym_alignas] = ACTIONS(3963),
    [anon_sym__Alignas] = ACTIONS(3963),
    [sym_primitive_type] = ACTIONS(3963),
    [anon_sym_enum] = ACTIONS(3963),
    [anon_sym_class] = ACTIONS(3963),
    [anon_sym_struct] = ACTIONS(3963),
    [anon_sym_union] = ACTIONS(3963),
    [anon_sym_if] = ACTIONS(3963),
    [anon_sym_switch] = ACTIONS(3963),
    [anon_sym_case] = ACTIONS(3963),
    [anon_sym_default] = ACTIONS(3963),
    [anon_sym_while] = ACTIONS(3963),
    [anon_sym_do] = ACTIONS(3963),
    [anon_sym_for] = ACTIONS(3963),
    [anon_sym_return] = ACTIONS(3963),
    [anon_sym_break] = ACTIONS(3963),
    [anon_sym_continue] = ACTIONS(3963),
    [anon_sym_goto] = ACTIONS(3963),
    [anon_sym___try] = ACTIONS(3963),
    [anon_sym___leave] = ACTIONS(3963),
    [anon_sym_not] = ACTIONS(3963),
    [anon_sym_compl] = ACTIONS(3963),
    [anon_sym_DASH_DASH] = ACTIONS(3965),
    [anon_sym_PLUS_PLUS] = ACTIONS(3965),
    [anon_sym_sizeof] = ACTIONS(3963),
    [anon_sym___alignof__] = ACTIONS(3963),
    [anon_sym___alignof] = ACTIONS(3963),
    [anon_sym__alignof] = ACTIONS(3963),
    [anon_sym_alignof] = ACTIONS(3963),
    [anon_sym__Alignof] = ACTIONS(3963),
    [anon_sym_offsetof] = ACTIONS(3963),
    [anon_sym__Generic] = ACTIONS(3963),
    [anon_sym_asm] = ACTIONS(3963),
    [anon_sym___asm__] = ACTIONS(3963),
    [anon_sym___asm] = ACTIONS(3963),
    [sym_number_literal] = ACTIONS(3965),
    [anon_sym_L_SQUOTE] = ACTIONS(3965),
    [anon_sym_u_SQUOTE] = ACTIONS(3965),
    [anon_sym_U_SQUOTE] = ACTIONS(3965),
    [anon_sym_u8_SQUOTE] = ACTIONS(3965),
    [anon_sym_SQUOTE] = ACTIONS(3965),
    [anon_sym_L_DQUOTE] = ACTIONS(3965),
    [anon_sym_u_DQUOTE] = ACTIONS(3965),
    [anon_sym_U_DQUOTE] = ACTIONS(3965),
    [anon_sym_u8_DQUOTE] = ACTIONS(3965),
    [anon_sym_DQUOTE] = ACTIONS(3965),
    [sym_true] = ACTIONS(3963),
    [sym_false] = ACTIONS(3963),
    [anon_sym_NULL] = ACTIONS(3963),
    [anon_sym_nullptr] = ACTIONS(3963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3963),
    [anon_sym_let] = ACTIONS(3963),
    [anon_sym_This] = ACTIONS(3963),
    [anon_sym_decltype] = ACTIONS(3963),
    [anon_sym_explicit] = ACTIONS(3963),
    [anon_sym_typename] = ACTIONS(3963),
    [anon_sym_template] = ACTIONS(3963),
    [anon_sym_operator] = ACTIONS(3963),
    [anon_sym_try] = ACTIONS(3963),
    [anon_sym_delete] = ACTIONS(3963),
    [anon_sym_throw] = ACTIONS(3963),
    [anon_sym_namespace] = ACTIONS(3963),
    [anon_sym_static_assert] = ACTIONS(3963),
    [anon_sym_concept] = ACTIONS(3963),
    [anon_sym_co_return] = ACTIONS(3963),
    [anon_sym_co_yield] = ACTIONS(3963),
    [anon_sym_R_DQUOTE] = ACTIONS(3965),
    [anon_sym_LR_DQUOTE] = ACTIONS(3965),
    [anon_sym_uR_DQUOTE] = ACTIONS(3965),
    [anon_sym_UR_DQUOTE] = ACTIONS(3965),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3965),
    [anon_sym_co_await] = ACTIONS(3963),
    [anon_sym_new] = ACTIONS(3963),
    [anon_sym_requires] = ACTIONS(3963),
    [sym_this] = ACTIONS(3963),
    [anon_sym_discard] = ACTIONS(3963),
    [anon_sym_precise] = ACTIONS(3963),
    [anon_sym_shared] = ACTIONS(3963),
    [anon_sym_groupshared] = ACTIONS(3963),
    [anon_sym_uniform] = ACTIONS(3963),
    [anon_sym_row_major] = ACTIONS(3963),
    [anon_sym_column_major] = ACTIONS(3963),
    [anon_sym_globallycoherent] = ACTIONS(3963),
    [anon_sym_centroid] = ACTIONS(3963),
    [anon_sym_noperspective] = ACTIONS(3963),
    [anon_sym_nointerpolation] = ACTIONS(3963),
    [anon_sym_sample] = ACTIONS(3963),
    [anon_sym_linear] = ACTIONS(3963),
    [anon_sym_snorm] = ACTIONS(3963),
    [anon_sym_unorm] = ACTIONS(3963),
    [anon_sym_point] = ACTIONS(3963),
    [anon_sym_line] = ACTIONS(3963),
    [anon_sym_triangleadj] = ACTIONS(3963),
    [anon_sym_lineadj] = ACTIONS(3963),
    [anon_sym_triangle] = ACTIONS(3963),
    [anon_sym_cbuffer] = ACTIONS(3963),
    [anon_sym_interface] = ACTIONS(3963),
    [anon_sym_extension] = ACTIONS(3963),
  },
  [1003] = {
    [ts_builtin_sym_end] = ACTIONS(3907),
    [sym_identifier] = ACTIONS(3905),
    [aux_sym_preproc_include_token1] = ACTIONS(3905),
    [aux_sym_preproc_def_token1] = ACTIONS(3905),
    [aux_sym_preproc_if_token1] = ACTIONS(3905),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3905),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3905),
    [sym_preproc_directive] = ACTIONS(3905),
    [anon_sym_LPAREN2] = ACTIONS(3907),
    [anon_sym_BANG] = ACTIONS(3907),
    [anon_sym_TILDE] = ACTIONS(3907),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3907),
    [anon_sym_AMP_AMP] = ACTIONS(3907),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_SEMI] = ACTIONS(3907),
    [anon_sym___extension__] = ACTIONS(3905),
    [anon_sym_typedef] = ACTIONS(3905),
    [anon_sym_in] = ACTIONS(3905),
    [anon_sym_out] = ACTIONS(3905),
    [anon_sym_inout] = ACTIONS(3905),
    [anon_sym_virtual] = ACTIONS(3905),
    [anon_sym_extern] = ACTIONS(3905),
    [anon_sym___attribute__] = ACTIONS(3905),
    [anon_sym___attribute] = ACTIONS(3905),
    [anon_sym_using] = ACTIONS(3905),
    [anon_sym_COLON_COLON] = ACTIONS(3907),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3907),
    [anon_sym___declspec] = ACTIONS(3905),
    [anon_sym___based] = ACTIONS(3905),
    [anon_sym___cdecl] = ACTIONS(3905),
    [anon_sym___clrcall] = ACTIONS(3905),
    [anon_sym___stdcall] = ACTIONS(3905),
    [anon_sym___fastcall] = ACTIONS(3905),
    [anon_sym___thiscall] = ACTIONS(3905),
    [anon_sym___vectorcall] = ACTIONS(3905),
    [anon_sym_LBRACE] = ACTIONS(3907),
    [anon_sym_signed] = ACTIONS(3905),
    [anon_sym_unsigned] = ACTIONS(3905),
    [anon_sym_long] = ACTIONS(3905),
    [anon_sym_short] = ACTIONS(3905),
    [anon_sym_LBRACK] = ACTIONS(3905),
    [anon_sym_static] = ACTIONS(3905),
    [anon_sym_register] = ACTIONS(3905),
    [anon_sym_inline] = ACTIONS(3905),
    [anon_sym___inline] = ACTIONS(3905),
    [anon_sym___inline__] = ACTIONS(3905),
    [anon_sym___forceinline] = ACTIONS(3905),
    [anon_sym_thread_local] = ACTIONS(3905),
    [anon_sym___thread] = ACTIONS(3905),
    [anon_sym_const] = ACTIONS(3905),
    [anon_sym_constexpr] = ACTIONS(3905),
    [anon_sym_volatile] = ACTIONS(3905),
    [anon_sym_restrict] = ACTIONS(3905),
    [anon_sym___restrict__] = ACTIONS(3905),
    [anon_sym__Atomic] = ACTIONS(3905),
    [anon_sym__Noreturn] = ACTIONS(3905),
    [anon_sym_noreturn] = ACTIONS(3905),
    [anon_sym__Nonnull] = ACTIONS(3905),
    [anon_sym_mutable] = ACTIONS(3905),
    [anon_sym_constinit] = ACTIONS(3905),
    [anon_sym_consteval] = ACTIONS(3905),
    [anon_sym_alignas] = ACTIONS(3905),
    [anon_sym__Alignas] = ACTIONS(3905),
    [sym_primitive_type] = ACTIONS(3905),
    [anon_sym_enum] = ACTIONS(3905),
    [anon_sym_class] = ACTIONS(3905),
    [anon_sym_struct] = ACTIONS(3905),
    [anon_sym_union] = ACTIONS(3905),
    [anon_sym_if] = ACTIONS(3905),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_case] = ACTIONS(3905),
    [anon_sym_default] = ACTIONS(3905),
    [anon_sym_while] = ACTIONS(3905),
    [anon_sym_do] = ACTIONS(3905),
    [anon_sym_for] = ACTIONS(3905),
    [anon_sym_return] = ACTIONS(3905),
    [anon_sym_break] = ACTIONS(3905),
    [anon_sym_continue] = ACTIONS(3905),
    [anon_sym_goto] = ACTIONS(3905),
    [anon_sym_not] = ACTIONS(3905),
    [anon_sym_compl] = ACTIONS(3905),
    [anon_sym_DASH_DASH] = ACTIONS(3907),
    [anon_sym_PLUS_PLUS] = ACTIONS(3907),
    [anon_sym_sizeof] = ACTIONS(3905),
    [anon_sym___alignof__] = ACTIONS(3905),
    [anon_sym___alignof] = ACTIONS(3905),
    [anon_sym__alignof] = ACTIONS(3905),
    [anon_sym_alignof] = ACTIONS(3905),
    [anon_sym__Alignof] = ACTIONS(3905),
    [anon_sym_offsetof] = ACTIONS(3905),
    [anon_sym__Generic] = ACTIONS(3905),
    [anon_sym_asm] = ACTIONS(3905),
    [anon_sym___asm__] = ACTIONS(3905),
    [anon_sym___asm] = ACTIONS(3905),
    [sym_number_literal] = ACTIONS(3907),
    [anon_sym_L_SQUOTE] = ACTIONS(3907),
    [anon_sym_u_SQUOTE] = ACTIONS(3907),
    [anon_sym_U_SQUOTE] = ACTIONS(3907),
    [anon_sym_u8_SQUOTE] = ACTIONS(3907),
    [anon_sym_SQUOTE] = ACTIONS(3907),
    [anon_sym_L_DQUOTE] = ACTIONS(3907),
    [anon_sym_u_DQUOTE] = ACTIONS(3907),
    [anon_sym_U_DQUOTE] = ACTIONS(3907),
    [anon_sym_u8_DQUOTE] = ACTIONS(3907),
    [anon_sym_DQUOTE] = ACTIONS(3907),
    [sym_true] = ACTIONS(3905),
    [sym_false] = ACTIONS(3905),
    [anon_sym_NULL] = ACTIONS(3905),
    [anon_sym_nullptr] = ACTIONS(3905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3905),
    [anon_sym_let] = ACTIONS(3905),
    [anon_sym_This] = ACTIONS(3905),
    [anon_sym_decltype] = ACTIONS(3905),
    [anon_sym_explicit] = ACTIONS(3905),
    [anon_sym_typename] = ACTIONS(3905),
    [anon_sym_export] = ACTIONS(3905),
    [anon_sym_module] = ACTIONS(3905),
    [anon_sym_import] = ACTIONS(3905),
    [anon_sym_template] = ACTIONS(3905),
    [anon_sym_operator] = ACTIONS(3905),
    [anon_sym_try] = ACTIONS(3905),
    [anon_sym_delete] = ACTIONS(3905),
    [anon_sym_throw] = ACTIONS(3905),
    [anon_sym_namespace] = ACTIONS(3905),
    [anon_sym_static_assert] = ACTIONS(3905),
    [anon_sym_concept] = ACTIONS(3905),
    [anon_sym_co_return] = ACTIONS(3905),
    [anon_sym_co_yield] = ACTIONS(3905),
    [anon_sym_R_DQUOTE] = ACTIONS(3907),
    [anon_sym_LR_DQUOTE] = ACTIONS(3907),
    [anon_sym_uR_DQUOTE] = ACTIONS(3907),
    [anon_sym_UR_DQUOTE] = ACTIONS(3907),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3907),
    [anon_sym_co_await] = ACTIONS(3905),
    [anon_sym_new] = ACTIONS(3905),
    [anon_sym_requires] = ACTIONS(3905),
    [sym_this] = ACTIONS(3905),
    [anon_sym_precise] = ACTIONS(3905),
    [anon_sym_shared] = ACTIONS(3905),
    [anon_sym_groupshared] = ACTIONS(3905),
    [anon_sym_uniform] = ACTIONS(3905),
    [anon_sym_row_major] = ACTIONS(3905),
    [anon_sym_column_major] = ACTIONS(3905),
    [anon_sym_globallycoherent] = ACTIONS(3905),
    [anon_sym_centroid] = ACTIONS(3905),
    [anon_sym_noperspective] = ACTIONS(3905),
    [anon_sym_nointerpolation] = ACTIONS(3905),
    [anon_sym_sample] = ACTIONS(3905),
    [anon_sym_linear] = ACTIONS(3905),
    [anon_sym_snorm] = ACTIONS(3905),
    [anon_sym_unorm] = ACTIONS(3905),
    [anon_sym_point] = ACTIONS(3905),
    [anon_sym_line] = ACTIONS(3905),
    [anon_sym_triangleadj] = ACTIONS(3905),
    [anon_sym_lineadj] = ACTIONS(3905),
    [anon_sym_triangle] = ACTIONS(3905),
    [anon_sym_interface] = ACTIONS(3905),
    [anon_sym_extension] = ACTIONS(3905),
    [anon_sym___exported] = ACTIONS(3905),
  },
  [1004] = {
    [ts_builtin_sym_end] = ACTIONS(3911),
    [sym_identifier] = ACTIONS(3909),
    [aux_sym_preproc_include_token1] = ACTIONS(3909),
    [aux_sym_preproc_def_token1] = ACTIONS(3909),
    [aux_sym_preproc_if_token1] = ACTIONS(3909),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3909),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3909),
    [sym_preproc_directive] = ACTIONS(3909),
    [anon_sym_LPAREN2] = ACTIONS(3911),
    [anon_sym_BANG] = ACTIONS(3911),
    [anon_sym_TILDE] = ACTIONS(3911),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_SEMI] = ACTIONS(3911),
    [anon_sym___extension__] = ACTIONS(3909),
    [anon_sym_typedef] = ACTIONS(3909),
    [anon_sym_in] = ACTIONS(3909),
    [anon_sym_out] = ACTIONS(3909),
    [anon_sym_inout] = ACTIONS(3909),
    [anon_sym_virtual] = ACTIONS(3909),
    [anon_sym_extern] = ACTIONS(3909),
    [anon_sym___attribute__] = ACTIONS(3909),
    [anon_sym___attribute] = ACTIONS(3909),
    [anon_sym_using] = ACTIONS(3909),
    [anon_sym_COLON_COLON] = ACTIONS(3911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3911),
    [anon_sym___declspec] = ACTIONS(3909),
    [anon_sym___based] = ACTIONS(3909),
    [anon_sym___cdecl] = ACTIONS(3909),
    [anon_sym___clrcall] = ACTIONS(3909),
    [anon_sym___stdcall] = ACTIONS(3909),
    [anon_sym___fastcall] = ACTIONS(3909),
    [anon_sym___thiscall] = ACTIONS(3909),
    [anon_sym___vectorcall] = ACTIONS(3909),
    [anon_sym_LBRACE] = ACTIONS(3911),
    [anon_sym_signed] = ACTIONS(3909),
    [anon_sym_unsigned] = ACTIONS(3909),
    [anon_sym_long] = ACTIONS(3909),
    [anon_sym_short] = ACTIONS(3909),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_static] = ACTIONS(3909),
    [anon_sym_register] = ACTIONS(3909),
    [anon_sym_inline] = ACTIONS(3909),
    [anon_sym___inline] = ACTIONS(3909),
    [anon_sym___inline__] = ACTIONS(3909),
    [anon_sym___forceinline] = ACTIONS(3909),
    [anon_sym_thread_local] = ACTIONS(3909),
    [anon_sym___thread] = ACTIONS(3909),
    [anon_sym_const] = ACTIONS(3909),
    [anon_sym_constexpr] = ACTIONS(3909),
    [anon_sym_volatile] = ACTIONS(3909),
    [anon_sym_restrict] = ACTIONS(3909),
    [anon_sym___restrict__] = ACTIONS(3909),
    [anon_sym__Atomic] = ACTIONS(3909),
    [anon_sym__Noreturn] = ACTIONS(3909),
    [anon_sym_noreturn] = ACTIONS(3909),
    [anon_sym__Nonnull] = ACTIONS(3909),
    [anon_sym_mutable] = ACTIONS(3909),
    [anon_sym_constinit] = ACTIONS(3909),
    [anon_sym_consteval] = ACTIONS(3909),
    [anon_sym_alignas] = ACTIONS(3909),
    [anon_sym__Alignas] = ACTIONS(3909),
    [sym_primitive_type] = ACTIONS(3909),
    [anon_sym_enum] = ACTIONS(3909),
    [anon_sym_class] = ACTIONS(3909),
    [anon_sym_struct] = ACTIONS(3909),
    [anon_sym_union] = ACTIONS(3909),
    [anon_sym_if] = ACTIONS(3909),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_case] = ACTIONS(3909),
    [anon_sym_default] = ACTIONS(3909),
    [anon_sym_while] = ACTIONS(3909),
    [anon_sym_do] = ACTIONS(3909),
    [anon_sym_for] = ACTIONS(3909),
    [anon_sym_return] = ACTIONS(3909),
    [anon_sym_break] = ACTIONS(3909),
    [anon_sym_continue] = ACTIONS(3909),
    [anon_sym_goto] = ACTIONS(3909),
    [anon_sym_not] = ACTIONS(3909),
    [anon_sym_compl] = ACTIONS(3909),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_sizeof] = ACTIONS(3909),
    [anon_sym___alignof__] = ACTIONS(3909),
    [anon_sym___alignof] = ACTIONS(3909),
    [anon_sym__alignof] = ACTIONS(3909),
    [anon_sym_alignof] = ACTIONS(3909),
    [anon_sym__Alignof] = ACTIONS(3909),
    [anon_sym_offsetof] = ACTIONS(3909),
    [anon_sym__Generic] = ACTIONS(3909),
    [anon_sym_asm] = ACTIONS(3909),
    [anon_sym___asm__] = ACTIONS(3909),
    [anon_sym___asm] = ACTIONS(3909),
    [sym_number_literal] = ACTIONS(3911),
    [anon_sym_L_SQUOTE] = ACTIONS(3911),
    [anon_sym_u_SQUOTE] = ACTIONS(3911),
    [anon_sym_U_SQUOTE] = ACTIONS(3911),
    [anon_sym_u8_SQUOTE] = ACTIONS(3911),
    [anon_sym_SQUOTE] = ACTIONS(3911),
    [anon_sym_L_DQUOTE] = ACTIONS(3911),
    [anon_sym_u_DQUOTE] = ACTIONS(3911),
    [anon_sym_U_DQUOTE] = ACTIONS(3911),
    [anon_sym_u8_DQUOTE] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [sym_true] = ACTIONS(3909),
    [sym_false] = ACTIONS(3909),
    [anon_sym_NULL] = ACTIONS(3909),
    [anon_sym_nullptr] = ACTIONS(3909),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3909),
    [anon_sym_let] = ACTIONS(3909),
    [anon_sym_This] = ACTIONS(3909),
    [anon_sym_decltype] = ACTIONS(3909),
    [anon_sym_explicit] = ACTIONS(3909),
    [anon_sym_typename] = ACTIONS(3909),
    [anon_sym_export] = ACTIONS(3909),
    [anon_sym_module] = ACTIONS(3909),
    [anon_sym_import] = ACTIONS(3909),
    [anon_sym_template] = ACTIONS(3909),
    [anon_sym_operator] = ACTIONS(3909),
    [anon_sym_try] = ACTIONS(3909),
    [anon_sym_delete] = ACTIONS(3909),
    [anon_sym_throw] = ACTIONS(3909),
    [anon_sym_namespace] = ACTIONS(3909),
    [anon_sym_static_assert] = ACTIONS(3909),
    [anon_sym_concept] = ACTIONS(3909),
    [anon_sym_co_return] = ACTIONS(3909),
    [anon_sym_co_yield] = ACTIONS(3909),
    [anon_sym_R_DQUOTE] = ACTIONS(3911),
    [anon_sym_LR_DQUOTE] = ACTIONS(3911),
    [anon_sym_uR_DQUOTE] = ACTIONS(3911),
    [anon_sym_UR_DQUOTE] = ACTIONS(3911),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3911),
    [anon_sym_co_await] = ACTIONS(3909),
    [anon_sym_new] = ACTIONS(3909),
    [anon_sym_requires] = ACTIONS(3909),
    [sym_this] = ACTIONS(3909),
    [anon_sym_precise] = ACTIONS(3909),
    [anon_sym_shared] = ACTIONS(3909),
    [anon_sym_groupshared] = ACTIONS(3909),
    [anon_sym_uniform] = ACTIONS(3909),
    [anon_sym_row_major] = ACTIONS(3909),
    [anon_sym_column_major] = ACTIONS(3909),
    [anon_sym_globallycoherent] = ACTIONS(3909),
    [anon_sym_centroid] = ACTIONS(3909),
    [anon_sym_noperspective] = ACTIONS(3909),
    [anon_sym_nointerpolation] = ACTIONS(3909),
    [anon_sym_sample] = ACTIONS(3909),
    [anon_sym_linear] = ACTIONS(3909),
    [anon_sym_snorm] = ACTIONS(3909),
    [anon_sym_unorm] = ACTIONS(3909),
    [anon_sym_point] = ACTIONS(3909),
    [anon_sym_line] = ACTIONS(3909),
    [anon_sym_triangleadj] = ACTIONS(3909),
    [anon_sym_lineadj] = ACTIONS(3909),
    [anon_sym_triangle] = ACTIONS(3909),
    [anon_sym_interface] = ACTIONS(3909),
    [anon_sym_extension] = ACTIONS(3909),
    [anon_sym___exported] = ACTIONS(3909),
  },
  [1005] = {
    [ts_builtin_sym_end] = ACTIONS(3663),
    [sym_identifier] = ACTIONS(3661),
    [aux_sym_preproc_include_token1] = ACTIONS(3661),
    [aux_sym_preproc_def_token1] = ACTIONS(3661),
    [aux_sym_preproc_if_token1] = ACTIONS(3661),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3661),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3661),
    [sym_preproc_directive] = ACTIONS(3661),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_BANG] = ACTIONS(3663),
    [anon_sym_TILDE] = ACTIONS(3663),
    [anon_sym_DASH] = ACTIONS(3661),
    [anon_sym_PLUS] = ACTIONS(3661),
    [anon_sym_STAR] = ACTIONS(3663),
    [anon_sym_AMP_AMP] = ACTIONS(3663),
    [anon_sym_AMP] = ACTIONS(3661),
    [anon_sym_SEMI] = ACTIONS(3663),
    [anon_sym___extension__] = ACTIONS(3661),
    [anon_sym_typedef] = ACTIONS(3661),
    [anon_sym_in] = ACTIONS(3661),
    [anon_sym_out] = ACTIONS(3661),
    [anon_sym_inout] = ACTIONS(3661),
    [anon_sym_virtual] = ACTIONS(3661),
    [anon_sym_extern] = ACTIONS(3661),
    [anon_sym___attribute__] = ACTIONS(3661),
    [anon_sym___attribute] = ACTIONS(3661),
    [anon_sym_using] = ACTIONS(3661),
    [anon_sym_COLON_COLON] = ACTIONS(3663),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3663),
    [anon_sym___declspec] = ACTIONS(3661),
    [anon_sym___based] = ACTIONS(3661),
    [anon_sym___cdecl] = ACTIONS(3661),
    [anon_sym___clrcall] = ACTIONS(3661),
    [anon_sym___stdcall] = ACTIONS(3661),
    [anon_sym___fastcall] = ACTIONS(3661),
    [anon_sym___thiscall] = ACTIONS(3661),
    [anon_sym___vectorcall] = ACTIONS(3661),
    [anon_sym_LBRACE] = ACTIONS(3663),
    [anon_sym_signed] = ACTIONS(3661),
    [anon_sym_unsigned] = ACTIONS(3661),
    [anon_sym_long] = ACTIONS(3661),
    [anon_sym_short] = ACTIONS(3661),
    [anon_sym_LBRACK] = ACTIONS(3661),
    [anon_sym_static] = ACTIONS(3661),
    [anon_sym_register] = ACTIONS(3661),
    [anon_sym_inline] = ACTIONS(3661),
    [anon_sym___inline] = ACTIONS(3661),
    [anon_sym___inline__] = ACTIONS(3661),
    [anon_sym___forceinline] = ACTIONS(3661),
    [anon_sym_thread_local] = ACTIONS(3661),
    [anon_sym___thread] = ACTIONS(3661),
    [anon_sym_const] = ACTIONS(3661),
    [anon_sym_constexpr] = ACTIONS(3661),
    [anon_sym_volatile] = ACTIONS(3661),
    [anon_sym_restrict] = ACTIONS(3661),
    [anon_sym___restrict__] = ACTIONS(3661),
    [anon_sym__Atomic] = ACTIONS(3661),
    [anon_sym__Noreturn] = ACTIONS(3661),
    [anon_sym_noreturn] = ACTIONS(3661),
    [anon_sym__Nonnull] = ACTIONS(3661),
    [anon_sym_mutable] = ACTIONS(3661),
    [anon_sym_constinit] = ACTIONS(3661),
    [anon_sym_consteval] = ACTIONS(3661),
    [anon_sym_alignas] = ACTIONS(3661),
    [anon_sym__Alignas] = ACTIONS(3661),
    [sym_primitive_type] = ACTIONS(3661),
    [anon_sym_enum] = ACTIONS(3661),
    [anon_sym_class] = ACTIONS(3661),
    [anon_sym_struct] = ACTIONS(3661),
    [anon_sym_union] = ACTIONS(3661),
    [anon_sym_if] = ACTIONS(3661),
    [anon_sym_switch] = ACTIONS(3661),
    [anon_sym_case] = ACTIONS(3661),
    [anon_sym_default] = ACTIONS(3661),
    [anon_sym_while] = ACTIONS(3661),
    [anon_sym_do] = ACTIONS(3661),
    [anon_sym_for] = ACTIONS(3661),
    [anon_sym_return] = ACTIONS(3661),
    [anon_sym_break] = ACTIONS(3661),
    [anon_sym_continue] = ACTIONS(3661),
    [anon_sym_goto] = ACTIONS(3661),
    [anon_sym_not] = ACTIONS(3661),
    [anon_sym_compl] = ACTIONS(3661),
    [anon_sym_DASH_DASH] = ACTIONS(3663),
    [anon_sym_PLUS_PLUS] = ACTIONS(3663),
    [anon_sym_sizeof] = ACTIONS(3661),
    [anon_sym___alignof__] = ACTIONS(3661),
    [anon_sym___alignof] = ACTIONS(3661),
    [anon_sym__alignof] = ACTIONS(3661),
    [anon_sym_alignof] = ACTIONS(3661),
    [anon_sym__Alignof] = ACTIONS(3661),
    [anon_sym_offsetof] = ACTIONS(3661),
    [anon_sym__Generic] = ACTIONS(3661),
    [anon_sym_asm] = ACTIONS(3661),
    [anon_sym___asm__] = ACTIONS(3661),
    [anon_sym___asm] = ACTIONS(3661),
    [sym_number_literal] = ACTIONS(3663),
    [anon_sym_L_SQUOTE] = ACTIONS(3663),
    [anon_sym_u_SQUOTE] = ACTIONS(3663),
    [anon_sym_U_SQUOTE] = ACTIONS(3663),
    [anon_sym_u8_SQUOTE] = ACTIONS(3663),
    [anon_sym_SQUOTE] = ACTIONS(3663),
    [anon_sym_L_DQUOTE] = ACTIONS(3663),
    [anon_sym_u_DQUOTE] = ACTIONS(3663),
    [anon_sym_U_DQUOTE] = ACTIONS(3663),
    [anon_sym_u8_DQUOTE] = ACTIONS(3663),
    [anon_sym_DQUOTE] = ACTIONS(3663),
    [sym_true] = ACTIONS(3661),
    [sym_false] = ACTIONS(3661),
    [anon_sym_NULL] = ACTIONS(3661),
    [anon_sym_nullptr] = ACTIONS(3661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3661),
    [anon_sym_let] = ACTIONS(3661),
    [anon_sym_This] = ACTIONS(3661),
    [anon_sym_decltype] = ACTIONS(3661),
    [anon_sym_explicit] = ACTIONS(3661),
    [anon_sym_typename] = ACTIONS(3661),
    [anon_sym_export] = ACTIONS(3661),
    [anon_sym_module] = ACTIONS(3661),
    [anon_sym_import] = ACTIONS(3661),
    [anon_sym_template] = ACTIONS(3661),
    [anon_sym_operator] = ACTIONS(3661),
    [anon_sym_try] = ACTIONS(3661),
    [anon_sym_delete] = ACTIONS(3661),
    [anon_sym_throw] = ACTIONS(3661),
    [anon_sym_namespace] = ACTIONS(3661),
    [anon_sym_static_assert] = ACTIONS(3661),
    [anon_sym_concept] = ACTIONS(3661),
    [anon_sym_co_return] = ACTIONS(3661),
    [anon_sym_co_yield] = ACTIONS(3661),
    [anon_sym_R_DQUOTE] = ACTIONS(3663),
    [anon_sym_LR_DQUOTE] = ACTIONS(3663),
    [anon_sym_uR_DQUOTE] = ACTIONS(3663),
    [anon_sym_UR_DQUOTE] = ACTIONS(3663),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3663),
    [anon_sym_co_await] = ACTIONS(3661),
    [anon_sym_new] = ACTIONS(3661),
    [anon_sym_requires] = ACTIONS(3661),
    [sym_this] = ACTIONS(3661),
    [anon_sym_precise] = ACTIONS(3661),
    [anon_sym_shared] = ACTIONS(3661),
    [anon_sym_groupshared] = ACTIONS(3661),
    [anon_sym_uniform] = ACTIONS(3661),
    [anon_sym_row_major] = ACTIONS(3661),
    [anon_sym_column_major] = ACTIONS(3661),
    [anon_sym_globallycoherent] = ACTIONS(3661),
    [anon_sym_centroid] = ACTIONS(3661),
    [anon_sym_noperspective] = ACTIONS(3661),
    [anon_sym_nointerpolation] = ACTIONS(3661),
    [anon_sym_sample] = ACTIONS(3661),
    [anon_sym_linear] = ACTIONS(3661),
    [anon_sym_snorm] = ACTIONS(3661),
    [anon_sym_unorm] = ACTIONS(3661),
    [anon_sym_point] = ACTIONS(3661),
    [anon_sym_line] = ACTIONS(3661),
    [anon_sym_triangleadj] = ACTIONS(3661),
    [anon_sym_lineadj] = ACTIONS(3661),
    [anon_sym_triangle] = ACTIONS(3661),
    [anon_sym_interface] = ACTIONS(3661),
    [anon_sym_extension] = ACTIONS(3661),
    [anon_sym___exported] = ACTIONS(3661),
  },
  [1006] = {
    [ts_builtin_sym_end] = ACTIONS(3786),
    [sym_identifier] = ACTIONS(3784),
    [aux_sym_preproc_include_token1] = ACTIONS(3784),
    [aux_sym_preproc_def_token1] = ACTIONS(3784),
    [aux_sym_preproc_if_token1] = ACTIONS(3784),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3784),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3784),
    [sym_preproc_directive] = ACTIONS(3784),
    [anon_sym_LPAREN2] = ACTIONS(3786),
    [anon_sym_BANG] = ACTIONS(3786),
    [anon_sym_TILDE] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3784),
    [anon_sym_PLUS] = ACTIONS(3784),
    [anon_sym_STAR] = ACTIONS(3786),
    [anon_sym_AMP_AMP] = ACTIONS(3786),
    [anon_sym_AMP] = ACTIONS(3784),
    [anon_sym_SEMI] = ACTIONS(3786),
    [anon_sym___extension__] = ACTIONS(3784),
    [anon_sym_typedef] = ACTIONS(3784),
    [anon_sym_in] = ACTIONS(3784),
    [anon_sym_out] = ACTIONS(3784),
    [anon_sym_inout] = ACTIONS(3784),
    [anon_sym_virtual] = ACTIONS(3784),
    [anon_sym_extern] = ACTIONS(3784),
    [anon_sym___attribute__] = ACTIONS(3784),
    [anon_sym___attribute] = ACTIONS(3784),
    [anon_sym_using] = ACTIONS(3784),
    [anon_sym_COLON_COLON] = ACTIONS(3786),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3786),
    [anon_sym___declspec] = ACTIONS(3784),
    [anon_sym___based] = ACTIONS(3784),
    [anon_sym___cdecl] = ACTIONS(3784),
    [anon_sym___clrcall] = ACTIONS(3784),
    [anon_sym___stdcall] = ACTIONS(3784),
    [anon_sym___fastcall] = ACTIONS(3784),
    [anon_sym___thiscall] = ACTIONS(3784),
    [anon_sym___vectorcall] = ACTIONS(3784),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3784),
    [anon_sym_static] = ACTIONS(3784),
    [anon_sym_register] = ACTIONS(3784),
    [anon_sym_inline] = ACTIONS(3784),
    [anon_sym___inline] = ACTIONS(3784),
    [anon_sym___inline__] = ACTIONS(3784),
    [anon_sym___forceinline] = ACTIONS(3784),
    [anon_sym_thread_local] = ACTIONS(3784),
    [anon_sym___thread] = ACTIONS(3784),
    [anon_sym_const] = ACTIONS(3784),
    [anon_sym_constexpr] = ACTIONS(3784),
    [anon_sym_volatile] = ACTIONS(3784),
    [anon_sym_restrict] = ACTIONS(3784),
    [anon_sym___restrict__] = ACTIONS(3784),
    [anon_sym__Atomic] = ACTIONS(3784),
    [anon_sym__Noreturn] = ACTIONS(3784),
    [anon_sym_noreturn] = ACTIONS(3784),
    [anon_sym__Nonnull] = ACTIONS(3784),
    [anon_sym_mutable] = ACTIONS(3784),
    [anon_sym_constinit] = ACTIONS(3784),
    [anon_sym_consteval] = ACTIONS(3784),
    [anon_sym_alignas] = ACTIONS(3784),
    [anon_sym__Alignas] = ACTIONS(3784),
    [sym_primitive_type] = ACTIONS(3784),
    [anon_sym_enum] = ACTIONS(3784),
    [anon_sym_class] = ACTIONS(3784),
    [anon_sym_struct] = ACTIONS(3784),
    [anon_sym_union] = ACTIONS(3784),
    [anon_sym_if] = ACTIONS(3784),
    [anon_sym_switch] = ACTIONS(3784),
    [anon_sym_case] = ACTIONS(3784),
    [anon_sym_default] = ACTIONS(3784),
    [anon_sym_while] = ACTIONS(3784),
    [anon_sym_do] = ACTIONS(3784),
    [anon_sym_for] = ACTIONS(3784),
    [anon_sym_return] = ACTIONS(3784),
    [anon_sym_break] = ACTIONS(3784),
    [anon_sym_continue] = ACTIONS(3784),
    [anon_sym_goto] = ACTIONS(3784),
    [anon_sym_not] = ACTIONS(3784),
    [anon_sym_compl] = ACTIONS(3784),
    [anon_sym_DASH_DASH] = ACTIONS(3786),
    [anon_sym_PLUS_PLUS] = ACTIONS(3786),
    [anon_sym_sizeof] = ACTIONS(3784),
    [anon_sym___alignof__] = ACTIONS(3784),
    [anon_sym___alignof] = ACTIONS(3784),
    [anon_sym__alignof] = ACTIONS(3784),
    [anon_sym_alignof] = ACTIONS(3784),
    [anon_sym__Alignof] = ACTIONS(3784),
    [anon_sym_offsetof] = ACTIONS(3784),
    [anon_sym__Generic] = ACTIONS(3784),
    [anon_sym_asm] = ACTIONS(3784),
    [anon_sym___asm__] = ACTIONS(3784),
    [anon_sym___asm] = ACTIONS(3784),
    [sym_number_literal] = ACTIONS(3786),
    [anon_sym_L_SQUOTE] = ACTIONS(3786),
    [anon_sym_u_SQUOTE] = ACTIONS(3786),
    [anon_sym_U_SQUOTE] = ACTIONS(3786),
    [anon_sym_u8_SQUOTE] = ACTIONS(3786),
    [anon_sym_SQUOTE] = ACTIONS(3786),
    [anon_sym_L_DQUOTE] = ACTIONS(3786),
    [anon_sym_u_DQUOTE] = ACTIONS(3786),
    [anon_sym_U_DQUOTE] = ACTIONS(3786),
    [anon_sym_u8_DQUOTE] = ACTIONS(3786),
    [anon_sym_DQUOTE] = ACTIONS(3786),
    [sym_true] = ACTIONS(3784),
    [sym_false] = ACTIONS(3784),
    [anon_sym_NULL] = ACTIONS(3784),
    [anon_sym_nullptr] = ACTIONS(3784),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3784),
    [anon_sym_let] = ACTIONS(3784),
    [anon_sym_This] = ACTIONS(3784),
    [anon_sym_decltype] = ACTIONS(3784),
    [anon_sym_explicit] = ACTIONS(3784),
    [anon_sym_typename] = ACTIONS(3784),
    [anon_sym_export] = ACTIONS(3784),
    [anon_sym_module] = ACTIONS(3784),
    [anon_sym_import] = ACTIONS(3784),
    [anon_sym_template] = ACTIONS(3784),
    [anon_sym_operator] = ACTIONS(3784),
    [anon_sym_try] = ACTIONS(3784),
    [anon_sym_delete] = ACTIONS(3784),
    [anon_sym_throw] = ACTIONS(3784),
    [anon_sym_namespace] = ACTIONS(3784),
    [anon_sym_static_assert] = ACTIONS(3784),
    [anon_sym_concept] = ACTIONS(3784),
    [anon_sym_co_return] = ACTIONS(3784),
    [anon_sym_co_yield] = ACTIONS(3784),
    [anon_sym_R_DQUOTE] = ACTIONS(3786),
    [anon_sym_LR_DQUOTE] = ACTIONS(3786),
    [anon_sym_uR_DQUOTE] = ACTIONS(3786),
    [anon_sym_UR_DQUOTE] = ACTIONS(3786),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3786),
    [anon_sym_co_await] = ACTIONS(3784),
    [anon_sym_new] = ACTIONS(3784),
    [anon_sym_requires] = ACTIONS(3784),
    [sym_this] = ACTIONS(3784),
    [anon_sym_precise] = ACTIONS(3784),
    [anon_sym_shared] = ACTIONS(3784),
    [anon_sym_groupshared] = ACTIONS(3784),
    [anon_sym_uniform] = ACTIONS(3784),
    [anon_sym_row_major] = ACTIONS(3784),
    [anon_sym_column_major] = ACTIONS(3784),
    [anon_sym_globallycoherent] = ACTIONS(3784),
    [anon_sym_centroid] = ACTIONS(3784),
    [anon_sym_noperspective] = ACTIONS(3784),
    [anon_sym_nointerpolation] = ACTIONS(3784),
    [anon_sym_sample] = ACTIONS(3784),
    [anon_sym_linear] = ACTIONS(3784),
    [anon_sym_snorm] = ACTIONS(3784),
    [anon_sym_unorm] = ACTIONS(3784),
    [anon_sym_point] = ACTIONS(3784),
    [anon_sym_line] = ACTIONS(3784),
    [anon_sym_triangleadj] = ACTIONS(3784),
    [anon_sym_lineadj] = ACTIONS(3784),
    [anon_sym_triangle] = ACTIONS(3784),
    [anon_sym_interface] = ACTIONS(3784),
    [anon_sym_extension] = ACTIONS(3784),
    [anon_sym___exported] = ACTIONS(3784),
  },
  [1007] = {
    [ts_builtin_sym_end] = ACTIONS(3830),
    [sym_identifier] = ACTIONS(3828),
    [aux_sym_preproc_include_token1] = ACTIONS(3828),
    [aux_sym_preproc_def_token1] = ACTIONS(3828),
    [aux_sym_preproc_if_token1] = ACTIONS(3828),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3828),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3828),
    [sym_preproc_directive] = ACTIONS(3828),
    [anon_sym_LPAREN2] = ACTIONS(3830),
    [anon_sym_BANG] = ACTIONS(3830),
    [anon_sym_TILDE] = ACTIONS(3830),
    [anon_sym_DASH] = ACTIONS(3828),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_SEMI] = ACTIONS(3830),
    [anon_sym___extension__] = ACTIONS(3828),
    [anon_sym_typedef] = ACTIONS(3828),
    [anon_sym_in] = ACTIONS(3828),
    [anon_sym_out] = ACTIONS(3828),
    [anon_sym_inout] = ACTIONS(3828),
    [anon_sym_virtual] = ACTIONS(3828),
    [anon_sym_extern] = ACTIONS(3828),
    [anon_sym___attribute__] = ACTIONS(3828),
    [anon_sym___attribute] = ACTIONS(3828),
    [anon_sym_using] = ACTIONS(3828),
    [anon_sym_COLON_COLON] = ACTIONS(3830),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3830),
    [anon_sym___declspec] = ACTIONS(3828),
    [anon_sym___based] = ACTIONS(3828),
    [anon_sym___cdecl] = ACTIONS(3828),
    [anon_sym___clrcall] = ACTIONS(3828),
    [anon_sym___stdcall] = ACTIONS(3828),
    [anon_sym___fastcall] = ACTIONS(3828),
    [anon_sym___thiscall] = ACTIONS(3828),
    [anon_sym___vectorcall] = ACTIONS(3828),
    [anon_sym_LBRACE] = ACTIONS(3830),
    [anon_sym_signed] = ACTIONS(3828),
    [anon_sym_unsigned] = ACTIONS(3828),
    [anon_sym_long] = ACTIONS(3828),
    [anon_sym_short] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_static] = ACTIONS(3828),
    [anon_sym_register] = ACTIONS(3828),
    [anon_sym_inline] = ACTIONS(3828),
    [anon_sym___inline] = ACTIONS(3828),
    [anon_sym___inline__] = ACTIONS(3828),
    [anon_sym___forceinline] = ACTIONS(3828),
    [anon_sym_thread_local] = ACTIONS(3828),
    [anon_sym___thread] = ACTIONS(3828),
    [anon_sym_const] = ACTIONS(3828),
    [anon_sym_constexpr] = ACTIONS(3828),
    [anon_sym_volatile] = ACTIONS(3828),
    [anon_sym_restrict] = ACTIONS(3828),
    [anon_sym___restrict__] = ACTIONS(3828),
    [anon_sym__Atomic] = ACTIONS(3828),
    [anon_sym__Noreturn] = ACTIONS(3828),
    [anon_sym_noreturn] = ACTIONS(3828),
    [anon_sym__Nonnull] = ACTIONS(3828),
    [anon_sym_mutable] = ACTIONS(3828),
    [anon_sym_constinit] = ACTIONS(3828),
    [anon_sym_consteval] = ACTIONS(3828),
    [anon_sym_alignas] = ACTIONS(3828),
    [anon_sym__Alignas] = ACTIONS(3828),
    [sym_primitive_type] = ACTIONS(3828),
    [anon_sym_enum] = ACTIONS(3828),
    [anon_sym_class] = ACTIONS(3828),
    [anon_sym_struct] = ACTIONS(3828),
    [anon_sym_union] = ACTIONS(3828),
    [anon_sym_if] = ACTIONS(3828),
    [anon_sym_switch] = ACTIONS(3828),
    [anon_sym_case] = ACTIONS(3828),
    [anon_sym_default] = ACTIONS(3828),
    [anon_sym_while] = ACTIONS(3828),
    [anon_sym_do] = ACTIONS(3828),
    [anon_sym_for] = ACTIONS(3828),
    [anon_sym_return] = ACTIONS(3828),
    [anon_sym_break] = ACTIONS(3828),
    [anon_sym_continue] = ACTIONS(3828),
    [anon_sym_goto] = ACTIONS(3828),
    [anon_sym_not] = ACTIONS(3828),
    [anon_sym_compl] = ACTIONS(3828),
    [anon_sym_DASH_DASH] = ACTIONS(3830),
    [anon_sym_PLUS_PLUS] = ACTIONS(3830),
    [anon_sym_sizeof] = ACTIONS(3828),
    [anon_sym___alignof__] = ACTIONS(3828),
    [anon_sym___alignof] = ACTIONS(3828),
    [anon_sym__alignof] = ACTIONS(3828),
    [anon_sym_alignof] = ACTIONS(3828),
    [anon_sym__Alignof] = ACTIONS(3828),
    [anon_sym_offsetof] = ACTIONS(3828),
    [anon_sym__Generic] = ACTIONS(3828),
    [anon_sym_asm] = ACTIONS(3828),
    [anon_sym___asm__] = ACTIONS(3828),
    [anon_sym___asm] = ACTIONS(3828),
    [sym_number_literal] = ACTIONS(3830),
    [anon_sym_L_SQUOTE] = ACTIONS(3830),
    [anon_sym_u_SQUOTE] = ACTIONS(3830),
    [anon_sym_U_SQUOTE] = ACTIONS(3830),
    [anon_sym_u8_SQUOTE] = ACTIONS(3830),
    [anon_sym_SQUOTE] = ACTIONS(3830),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3828),
    [sym_false] = ACTIONS(3828),
    [anon_sym_NULL] = ACTIONS(3828),
    [anon_sym_nullptr] = ACTIONS(3828),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_This] = ACTIONS(3828),
    [anon_sym_decltype] = ACTIONS(3828),
    [anon_sym_explicit] = ACTIONS(3828),
    [anon_sym_typename] = ACTIONS(3828),
    [anon_sym_export] = ACTIONS(3828),
    [anon_sym_module] = ACTIONS(3828),
    [anon_sym_import] = ACTIONS(3828),
    [anon_sym_template] = ACTIONS(3828),
    [anon_sym_operator] = ACTIONS(3828),
    [anon_sym_try] = ACTIONS(3828),
    [anon_sym_delete] = ACTIONS(3828),
    [anon_sym_throw] = ACTIONS(3828),
    [anon_sym_namespace] = ACTIONS(3828),
    [anon_sym_static_assert] = ACTIONS(3828),
    [anon_sym_concept] = ACTIONS(3828),
    [anon_sym_co_return] = ACTIONS(3828),
    [anon_sym_co_yield] = ACTIONS(3828),
    [anon_sym_R_DQUOTE] = ACTIONS(3830),
    [anon_sym_LR_DQUOTE] = ACTIONS(3830),
    [anon_sym_uR_DQUOTE] = ACTIONS(3830),
    [anon_sym_UR_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3830),
    [anon_sym_co_await] = ACTIONS(3828),
    [anon_sym_new] = ACTIONS(3828),
    [anon_sym_requires] = ACTIONS(3828),
    [sym_this] = ACTIONS(3828),
    [anon_sym_precise] = ACTIONS(3828),
    [anon_sym_shared] = ACTIONS(3828),
    [anon_sym_groupshared] = ACTIONS(3828),
    [anon_sym_uniform] = ACTIONS(3828),
    [anon_sym_row_major] = ACTIONS(3828),
    [anon_sym_column_major] = ACTIONS(3828),
    [anon_sym_globallycoherent] = ACTIONS(3828),
    [anon_sym_centroid] = ACTIONS(3828),
    [anon_sym_noperspective] = ACTIONS(3828),
    [anon_sym_nointerpolation] = ACTIONS(3828),
    [anon_sym_sample] = ACTIONS(3828),
    [anon_sym_linear] = ACTIONS(3828),
    [anon_sym_snorm] = ACTIONS(3828),
    [anon_sym_unorm] = ACTIONS(3828),
    [anon_sym_point] = ACTIONS(3828),
    [anon_sym_line] = ACTIONS(3828),
    [anon_sym_triangleadj] = ACTIONS(3828),
    [anon_sym_lineadj] = ACTIONS(3828),
    [anon_sym_triangle] = ACTIONS(3828),
    [anon_sym_interface] = ACTIONS(3828),
    [anon_sym_extension] = ACTIONS(3828),
    [anon_sym___exported] = ACTIONS(3828),
  },
  [1008] = {
    [ts_builtin_sym_end] = ACTIONS(4271),
    [sym_identifier] = ACTIONS(4274),
    [aux_sym_preproc_include_token1] = ACTIONS(4274),
    [aux_sym_preproc_def_token1] = ACTIONS(4274),
    [aux_sym_preproc_if_token1] = ACTIONS(4274),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4274),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4274),
    [sym_preproc_directive] = ACTIONS(4274),
    [anon_sym_LPAREN2] = ACTIONS(4271),
    [anon_sym_BANG] = ACTIONS(4271),
    [anon_sym_TILDE] = ACTIONS(4271),
    [anon_sym_DASH] = ACTIONS(4274),
    [anon_sym_PLUS] = ACTIONS(4274),
    [anon_sym_STAR] = ACTIONS(4271),
    [anon_sym_AMP_AMP] = ACTIONS(4271),
    [anon_sym_AMP] = ACTIONS(4274),
    [anon_sym_SEMI] = ACTIONS(4271),
    [anon_sym___extension__] = ACTIONS(4274),
    [anon_sym_typedef] = ACTIONS(4274),
    [anon_sym_in] = ACTIONS(4274),
    [anon_sym_out] = ACTIONS(4274),
    [anon_sym_inout] = ACTIONS(4274),
    [anon_sym_virtual] = ACTIONS(4274),
    [anon_sym_extern] = ACTIONS(4274),
    [anon_sym___attribute__] = ACTIONS(4274),
    [anon_sym___attribute] = ACTIONS(4274),
    [anon_sym_using] = ACTIONS(4274),
    [anon_sym_COLON_COLON] = ACTIONS(4271),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4271),
    [anon_sym___declspec] = ACTIONS(4274),
    [anon_sym___based] = ACTIONS(4274),
    [anon_sym___cdecl] = ACTIONS(4274),
    [anon_sym___clrcall] = ACTIONS(4274),
    [anon_sym___stdcall] = ACTIONS(4274),
    [anon_sym___fastcall] = ACTIONS(4274),
    [anon_sym___thiscall] = ACTIONS(4274),
    [anon_sym___vectorcall] = ACTIONS(4274),
    [anon_sym_LBRACE] = ACTIONS(4271),
    [anon_sym_signed] = ACTIONS(4274),
    [anon_sym_unsigned] = ACTIONS(4274),
    [anon_sym_long] = ACTIONS(4274),
    [anon_sym_short] = ACTIONS(4274),
    [anon_sym_LBRACK] = ACTIONS(4274),
    [anon_sym_static] = ACTIONS(4274),
    [anon_sym_register] = ACTIONS(4274),
    [anon_sym_inline] = ACTIONS(4274),
    [anon_sym___inline] = ACTIONS(4274),
    [anon_sym___inline__] = ACTIONS(4274),
    [anon_sym___forceinline] = ACTIONS(4274),
    [anon_sym_thread_local] = ACTIONS(4274),
    [anon_sym___thread] = ACTIONS(4274),
    [anon_sym_const] = ACTIONS(4274),
    [anon_sym_constexpr] = ACTIONS(4274),
    [anon_sym_volatile] = ACTIONS(4274),
    [anon_sym_restrict] = ACTIONS(4274),
    [anon_sym___restrict__] = ACTIONS(4274),
    [anon_sym__Atomic] = ACTIONS(4274),
    [anon_sym__Noreturn] = ACTIONS(4274),
    [anon_sym_noreturn] = ACTIONS(4274),
    [anon_sym__Nonnull] = ACTIONS(4274),
    [anon_sym_mutable] = ACTIONS(4274),
    [anon_sym_constinit] = ACTIONS(4274),
    [anon_sym_consteval] = ACTIONS(4274),
    [anon_sym_alignas] = ACTIONS(4274),
    [anon_sym__Alignas] = ACTIONS(4274),
    [sym_primitive_type] = ACTIONS(4274),
    [anon_sym_enum] = ACTIONS(4274),
    [anon_sym_class] = ACTIONS(4274),
    [anon_sym_struct] = ACTIONS(4274),
    [anon_sym_union] = ACTIONS(4274),
    [anon_sym_if] = ACTIONS(4274),
    [anon_sym_switch] = ACTIONS(4274),
    [anon_sym_case] = ACTIONS(4274),
    [anon_sym_default] = ACTIONS(4274),
    [anon_sym_while] = ACTIONS(4274),
    [anon_sym_do] = ACTIONS(4274),
    [anon_sym_for] = ACTIONS(4274),
    [anon_sym_return] = ACTIONS(4274),
    [anon_sym_break] = ACTIONS(4274),
    [anon_sym_continue] = ACTIONS(4274),
    [anon_sym_goto] = ACTIONS(4274),
    [anon_sym_not] = ACTIONS(4274),
    [anon_sym_compl] = ACTIONS(4274),
    [anon_sym_DASH_DASH] = ACTIONS(4271),
    [anon_sym_PLUS_PLUS] = ACTIONS(4271),
    [anon_sym_sizeof] = ACTIONS(4274),
    [anon_sym___alignof__] = ACTIONS(4274),
    [anon_sym___alignof] = ACTIONS(4274),
    [anon_sym__alignof] = ACTIONS(4274),
    [anon_sym_alignof] = ACTIONS(4274),
    [anon_sym__Alignof] = ACTIONS(4274),
    [anon_sym_offsetof] = ACTIONS(4274),
    [anon_sym__Generic] = ACTIONS(4274),
    [anon_sym_asm] = ACTIONS(4274),
    [anon_sym___asm__] = ACTIONS(4274),
    [anon_sym___asm] = ACTIONS(4274),
    [sym_number_literal] = ACTIONS(4271),
    [anon_sym_L_SQUOTE] = ACTIONS(4271),
    [anon_sym_u_SQUOTE] = ACTIONS(4271),
    [anon_sym_U_SQUOTE] = ACTIONS(4271),
    [anon_sym_u8_SQUOTE] = ACTIONS(4271),
    [anon_sym_SQUOTE] = ACTIONS(4271),
    [anon_sym_L_DQUOTE] = ACTIONS(4271),
    [anon_sym_u_DQUOTE] = ACTIONS(4271),
    [anon_sym_U_DQUOTE] = ACTIONS(4271),
    [anon_sym_u8_DQUOTE] = ACTIONS(4271),
    [anon_sym_DQUOTE] = ACTIONS(4271),
    [sym_true] = ACTIONS(4274),
    [sym_false] = ACTIONS(4274),
    [anon_sym_NULL] = ACTIONS(4274),
    [anon_sym_nullptr] = ACTIONS(4274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4274),
    [anon_sym_let] = ACTIONS(4274),
    [anon_sym_This] = ACTIONS(4274),
    [anon_sym_decltype] = ACTIONS(4274),
    [anon_sym_explicit] = ACTIONS(4274),
    [anon_sym_typename] = ACTIONS(4274),
    [anon_sym_export] = ACTIONS(4274),
    [anon_sym_module] = ACTIONS(4274),
    [anon_sym_import] = ACTIONS(4274),
    [anon_sym_template] = ACTIONS(4274),
    [anon_sym_operator] = ACTIONS(4274),
    [anon_sym_try] = ACTIONS(4274),
    [anon_sym_delete] = ACTIONS(4274),
    [anon_sym_throw] = ACTIONS(4274),
    [anon_sym_namespace] = ACTIONS(4274),
    [anon_sym_static_assert] = ACTIONS(4274),
    [anon_sym_concept] = ACTIONS(4274),
    [anon_sym_co_return] = ACTIONS(4274),
    [anon_sym_co_yield] = ACTIONS(4274),
    [anon_sym_R_DQUOTE] = ACTIONS(4271),
    [anon_sym_LR_DQUOTE] = ACTIONS(4271),
    [anon_sym_uR_DQUOTE] = ACTIONS(4271),
    [anon_sym_UR_DQUOTE] = ACTIONS(4271),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4271),
    [anon_sym_co_await] = ACTIONS(4274),
    [anon_sym_new] = ACTIONS(4274),
    [anon_sym_requires] = ACTIONS(4274),
    [sym_this] = ACTIONS(4274),
    [anon_sym_precise] = ACTIONS(4274),
    [anon_sym_shared] = ACTIONS(4274),
    [anon_sym_groupshared] = ACTIONS(4274),
    [anon_sym_uniform] = ACTIONS(4274),
    [anon_sym_row_major] = ACTIONS(4274),
    [anon_sym_column_major] = ACTIONS(4274),
    [anon_sym_globallycoherent] = ACTIONS(4274),
    [anon_sym_centroid] = ACTIONS(4274),
    [anon_sym_noperspective] = ACTIONS(4274),
    [anon_sym_nointerpolation] = ACTIONS(4274),
    [anon_sym_sample] = ACTIONS(4274),
    [anon_sym_linear] = ACTIONS(4274),
    [anon_sym_snorm] = ACTIONS(4274),
    [anon_sym_unorm] = ACTIONS(4274),
    [anon_sym_point] = ACTIONS(4274),
    [anon_sym_line] = ACTIONS(4274),
    [anon_sym_triangleadj] = ACTIONS(4274),
    [anon_sym_lineadj] = ACTIONS(4274),
    [anon_sym_triangle] = ACTIONS(4274),
    [anon_sym_interface] = ACTIONS(4274),
    [anon_sym_extension] = ACTIONS(4274),
    [anon_sym___exported] = ACTIONS(4274),
  },
  [1009] = {
    [ts_builtin_sym_end] = ACTIONS(3921),
    [sym_identifier] = ACTIONS(3919),
    [aux_sym_preproc_include_token1] = ACTIONS(3919),
    [aux_sym_preproc_def_token1] = ACTIONS(3919),
    [aux_sym_preproc_if_token1] = ACTIONS(3919),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3919),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3919),
    [sym_preproc_directive] = ACTIONS(3919),
    [anon_sym_LPAREN2] = ACTIONS(3921),
    [anon_sym_BANG] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3919),
    [anon_sym_PLUS] = ACTIONS(3919),
    [anon_sym_STAR] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_AMP] = ACTIONS(3919),
    [anon_sym_SEMI] = ACTIONS(3921),
    [anon_sym___extension__] = ACTIONS(3919),
    [anon_sym_typedef] = ACTIONS(3919),
    [anon_sym_in] = ACTIONS(3919),
    [anon_sym_out] = ACTIONS(3919),
    [anon_sym_inout] = ACTIONS(3919),
    [anon_sym_virtual] = ACTIONS(3919),
    [anon_sym_extern] = ACTIONS(3919),
    [anon_sym___attribute__] = ACTIONS(3919),
    [anon_sym___attribute] = ACTIONS(3919),
    [anon_sym_using] = ACTIONS(3919),
    [anon_sym_COLON_COLON] = ACTIONS(3921),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3921),
    [anon_sym___declspec] = ACTIONS(3919),
    [anon_sym___based] = ACTIONS(3919),
    [anon_sym___cdecl] = ACTIONS(3919),
    [anon_sym___clrcall] = ACTIONS(3919),
    [anon_sym___stdcall] = ACTIONS(3919),
    [anon_sym___fastcall] = ACTIONS(3919),
    [anon_sym___thiscall] = ACTIONS(3919),
    [anon_sym___vectorcall] = ACTIONS(3919),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_signed] = ACTIONS(3919),
    [anon_sym_unsigned] = ACTIONS(3919),
    [anon_sym_long] = ACTIONS(3919),
    [anon_sym_short] = ACTIONS(3919),
    [anon_sym_LBRACK] = ACTIONS(3919),
    [anon_sym_static] = ACTIONS(3919),
    [anon_sym_register] = ACTIONS(3919),
    [anon_sym_inline] = ACTIONS(3919),
    [anon_sym___inline] = ACTIONS(3919),
    [anon_sym___inline__] = ACTIONS(3919),
    [anon_sym___forceinline] = ACTIONS(3919),
    [anon_sym_thread_local] = ACTIONS(3919),
    [anon_sym___thread] = ACTIONS(3919),
    [anon_sym_const] = ACTIONS(3919),
    [anon_sym_constexpr] = ACTIONS(3919),
    [anon_sym_volatile] = ACTIONS(3919),
    [anon_sym_restrict] = ACTIONS(3919),
    [anon_sym___restrict__] = ACTIONS(3919),
    [anon_sym__Atomic] = ACTIONS(3919),
    [anon_sym__Noreturn] = ACTIONS(3919),
    [anon_sym_noreturn] = ACTIONS(3919),
    [anon_sym__Nonnull] = ACTIONS(3919),
    [anon_sym_mutable] = ACTIONS(3919),
    [anon_sym_constinit] = ACTIONS(3919),
    [anon_sym_consteval] = ACTIONS(3919),
    [anon_sym_alignas] = ACTIONS(3919),
    [anon_sym__Alignas] = ACTIONS(3919),
    [sym_primitive_type] = ACTIONS(3919),
    [anon_sym_enum] = ACTIONS(3919),
    [anon_sym_class] = ACTIONS(3919),
    [anon_sym_struct] = ACTIONS(3919),
    [anon_sym_union] = ACTIONS(3919),
    [anon_sym_if] = ACTIONS(3919),
    [anon_sym_switch] = ACTIONS(3919),
    [anon_sym_case] = ACTIONS(3919),
    [anon_sym_default] = ACTIONS(3919),
    [anon_sym_while] = ACTIONS(3919),
    [anon_sym_do] = ACTIONS(3919),
    [anon_sym_for] = ACTIONS(3919),
    [anon_sym_return] = ACTIONS(3919),
    [anon_sym_break] = ACTIONS(3919),
    [anon_sym_continue] = ACTIONS(3919),
    [anon_sym_goto] = ACTIONS(3919),
    [anon_sym_not] = ACTIONS(3919),
    [anon_sym_compl] = ACTIONS(3919),
    [anon_sym_DASH_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_PLUS] = ACTIONS(3921),
    [anon_sym_sizeof] = ACTIONS(3919),
    [anon_sym___alignof__] = ACTIONS(3919),
    [anon_sym___alignof] = ACTIONS(3919),
    [anon_sym__alignof] = ACTIONS(3919),
    [anon_sym_alignof] = ACTIONS(3919),
    [anon_sym__Alignof] = ACTIONS(3919),
    [anon_sym_offsetof] = ACTIONS(3919),
    [anon_sym__Generic] = ACTIONS(3919),
    [anon_sym_asm] = ACTIONS(3919),
    [anon_sym___asm__] = ACTIONS(3919),
    [anon_sym___asm] = ACTIONS(3919),
    [sym_number_literal] = ACTIONS(3921),
    [anon_sym_L_SQUOTE] = ACTIONS(3921),
    [anon_sym_u_SQUOTE] = ACTIONS(3921),
    [anon_sym_U_SQUOTE] = ACTIONS(3921),
    [anon_sym_u8_SQUOTE] = ACTIONS(3921),
    [anon_sym_SQUOTE] = ACTIONS(3921),
    [anon_sym_L_DQUOTE] = ACTIONS(3921),
    [anon_sym_u_DQUOTE] = ACTIONS(3921),
    [anon_sym_U_DQUOTE] = ACTIONS(3921),
    [anon_sym_u8_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [sym_true] = ACTIONS(3919),
    [sym_false] = ACTIONS(3919),
    [anon_sym_NULL] = ACTIONS(3919),
    [anon_sym_nullptr] = ACTIONS(3919),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3919),
    [anon_sym_let] = ACTIONS(3919),
    [anon_sym_This] = ACTIONS(3919),
    [anon_sym_decltype] = ACTIONS(3919),
    [anon_sym_explicit] = ACTIONS(3919),
    [anon_sym_typename] = ACTIONS(3919),
    [anon_sym_export] = ACTIONS(3919),
    [anon_sym_module] = ACTIONS(3919),
    [anon_sym_import] = ACTIONS(3919),
    [anon_sym_template] = ACTIONS(3919),
    [anon_sym_operator] = ACTIONS(3919),
    [anon_sym_try] = ACTIONS(3919),
    [anon_sym_delete] = ACTIONS(3919),
    [anon_sym_throw] = ACTIONS(3919),
    [anon_sym_namespace] = ACTIONS(3919),
    [anon_sym_static_assert] = ACTIONS(3919),
    [anon_sym_concept] = ACTIONS(3919),
    [anon_sym_co_return] = ACTIONS(3919),
    [anon_sym_co_yield] = ACTIONS(3919),
    [anon_sym_R_DQUOTE] = ACTIONS(3921),
    [anon_sym_LR_DQUOTE] = ACTIONS(3921),
    [anon_sym_uR_DQUOTE] = ACTIONS(3921),
    [anon_sym_UR_DQUOTE] = ACTIONS(3921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3921),
    [anon_sym_co_await] = ACTIONS(3919),
    [anon_sym_new] = ACTIONS(3919),
    [anon_sym_requires] = ACTIONS(3919),
    [sym_this] = ACTIONS(3919),
    [anon_sym_precise] = ACTIONS(3919),
    [anon_sym_shared] = ACTIONS(3919),
    [anon_sym_groupshared] = ACTIONS(3919),
    [anon_sym_uniform] = ACTIONS(3919),
    [anon_sym_row_major] = ACTIONS(3919),
    [anon_sym_column_major] = ACTIONS(3919),
    [anon_sym_globallycoherent] = ACTIONS(3919),
    [anon_sym_centroid] = ACTIONS(3919),
    [anon_sym_noperspective] = ACTIONS(3919),
    [anon_sym_nointerpolation] = ACTIONS(3919),
    [anon_sym_sample] = ACTIONS(3919),
    [anon_sym_linear] = ACTIONS(3919),
    [anon_sym_snorm] = ACTIONS(3919),
    [anon_sym_unorm] = ACTIONS(3919),
    [anon_sym_point] = ACTIONS(3919),
    [anon_sym_line] = ACTIONS(3919),
    [anon_sym_triangleadj] = ACTIONS(3919),
    [anon_sym_lineadj] = ACTIONS(3919),
    [anon_sym_triangle] = ACTIONS(3919),
    [anon_sym_interface] = ACTIONS(3919),
    [anon_sym_extension] = ACTIONS(3919),
    [anon_sym___exported] = ACTIONS(3919),
  },
  [1010] = {
    [ts_builtin_sym_end] = ACTIONS(3951),
    [sym_identifier] = ACTIONS(3949),
    [aux_sym_preproc_include_token1] = ACTIONS(3949),
    [aux_sym_preproc_def_token1] = ACTIONS(3949),
    [aux_sym_preproc_if_token1] = ACTIONS(3949),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3949),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3949),
    [sym_preproc_directive] = ACTIONS(3949),
    [anon_sym_LPAREN2] = ACTIONS(3951),
    [anon_sym_BANG] = ACTIONS(3951),
    [anon_sym_TILDE] = ACTIONS(3951),
    [anon_sym_DASH] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3949),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3949),
    [anon_sym_SEMI] = ACTIONS(3951),
    [anon_sym___extension__] = ACTIONS(3949),
    [anon_sym_typedef] = ACTIONS(3949),
    [anon_sym_in] = ACTIONS(3949),
    [anon_sym_out] = ACTIONS(3949),
    [anon_sym_inout] = ACTIONS(3949),
    [anon_sym_virtual] = ACTIONS(3949),
    [anon_sym_extern] = ACTIONS(3949),
    [anon_sym___attribute__] = ACTIONS(3949),
    [anon_sym___attribute] = ACTIONS(3949),
    [anon_sym_using] = ACTIONS(3949),
    [anon_sym_COLON_COLON] = ACTIONS(3951),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3951),
    [anon_sym___declspec] = ACTIONS(3949),
    [anon_sym___based] = ACTIONS(3949),
    [anon_sym___cdecl] = ACTIONS(3949),
    [anon_sym___clrcall] = ACTIONS(3949),
    [anon_sym___stdcall] = ACTIONS(3949),
    [anon_sym___fastcall] = ACTIONS(3949),
    [anon_sym___thiscall] = ACTIONS(3949),
    [anon_sym___vectorcall] = ACTIONS(3949),
    [anon_sym_LBRACE] = ACTIONS(3951),
    [anon_sym_signed] = ACTIONS(3949),
    [anon_sym_unsigned] = ACTIONS(3949),
    [anon_sym_long] = ACTIONS(3949),
    [anon_sym_short] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_static] = ACTIONS(3949),
    [anon_sym_register] = ACTIONS(3949),
    [anon_sym_inline] = ACTIONS(3949),
    [anon_sym___inline] = ACTIONS(3949),
    [anon_sym___inline__] = ACTIONS(3949),
    [anon_sym___forceinline] = ACTIONS(3949),
    [anon_sym_thread_local] = ACTIONS(3949),
    [anon_sym___thread] = ACTIONS(3949),
    [anon_sym_const] = ACTIONS(3949),
    [anon_sym_constexpr] = ACTIONS(3949),
    [anon_sym_volatile] = ACTIONS(3949),
    [anon_sym_restrict] = ACTIONS(3949),
    [anon_sym___restrict__] = ACTIONS(3949),
    [anon_sym__Atomic] = ACTIONS(3949),
    [anon_sym__Noreturn] = ACTIONS(3949),
    [anon_sym_noreturn] = ACTIONS(3949),
    [anon_sym__Nonnull] = ACTIONS(3949),
    [anon_sym_mutable] = ACTIONS(3949),
    [anon_sym_constinit] = ACTIONS(3949),
    [anon_sym_consteval] = ACTIONS(3949),
    [anon_sym_alignas] = ACTIONS(3949),
    [anon_sym__Alignas] = ACTIONS(3949),
    [sym_primitive_type] = ACTIONS(3949),
    [anon_sym_enum] = ACTIONS(3949),
    [anon_sym_class] = ACTIONS(3949),
    [anon_sym_struct] = ACTIONS(3949),
    [anon_sym_union] = ACTIONS(3949),
    [anon_sym_if] = ACTIONS(3949),
    [anon_sym_switch] = ACTIONS(3949),
    [anon_sym_case] = ACTIONS(3949),
    [anon_sym_default] = ACTIONS(3949),
    [anon_sym_while] = ACTIONS(3949),
    [anon_sym_do] = ACTIONS(3949),
    [anon_sym_for] = ACTIONS(3949),
    [anon_sym_return] = ACTIONS(3949),
    [anon_sym_break] = ACTIONS(3949),
    [anon_sym_continue] = ACTIONS(3949),
    [anon_sym_goto] = ACTIONS(3949),
    [anon_sym_not] = ACTIONS(3949),
    [anon_sym_compl] = ACTIONS(3949),
    [anon_sym_DASH_DASH] = ACTIONS(3951),
    [anon_sym_PLUS_PLUS] = ACTIONS(3951),
    [anon_sym_sizeof] = ACTIONS(3949),
    [anon_sym___alignof__] = ACTIONS(3949),
    [anon_sym___alignof] = ACTIONS(3949),
    [anon_sym__alignof] = ACTIONS(3949),
    [anon_sym_alignof] = ACTIONS(3949),
    [anon_sym__Alignof] = ACTIONS(3949),
    [anon_sym_offsetof] = ACTIONS(3949),
    [anon_sym__Generic] = ACTIONS(3949),
    [anon_sym_asm] = ACTIONS(3949),
    [anon_sym___asm__] = ACTIONS(3949),
    [anon_sym___asm] = ACTIONS(3949),
    [sym_number_literal] = ACTIONS(3951),
    [anon_sym_L_SQUOTE] = ACTIONS(3951),
    [anon_sym_u_SQUOTE] = ACTIONS(3951),
    [anon_sym_U_SQUOTE] = ACTIONS(3951),
    [anon_sym_u8_SQUOTE] = ACTIONS(3951),
    [anon_sym_SQUOTE] = ACTIONS(3951),
    [anon_sym_L_DQUOTE] = ACTIONS(3951),
    [anon_sym_u_DQUOTE] = ACTIONS(3951),
    [anon_sym_U_DQUOTE] = ACTIONS(3951),
    [anon_sym_u8_DQUOTE] = ACTIONS(3951),
    [anon_sym_DQUOTE] = ACTIONS(3951),
    [sym_true] = ACTIONS(3949),
    [sym_false] = ACTIONS(3949),
    [anon_sym_NULL] = ACTIONS(3949),
    [anon_sym_nullptr] = ACTIONS(3949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_This] = ACTIONS(3949),
    [anon_sym_decltype] = ACTIONS(3949),
    [anon_sym_explicit] = ACTIONS(3949),
    [anon_sym_typename] = ACTIONS(3949),
    [anon_sym_export] = ACTIONS(3949),
    [anon_sym_module] = ACTIONS(3949),
    [anon_sym_import] = ACTIONS(3949),
    [anon_sym_template] = ACTIONS(3949),
    [anon_sym_operator] = ACTIONS(3949),
    [anon_sym_try] = ACTIONS(3949),
    [anon_sym_delete] = ACTIONS(3949),
    [anon_sym_throw] = ACTIONS(3949),
    [anon_sym_namespace] = ACTIONS(3949),
    [anon_sym_static_assert] = ACTIONS(3949),
    [anon_sym_concept] = ACTIONS(3949),
    [anon_sym_co_return] = ACTIONS(3949),
    [anon_sym_co_yield] = ACTIONS(3949),
    [anon_sym_R_DQUOTE] = ACTIONS(3951),
    [anon_sym_LR_DQUOTE] = ACTIONS(3951),
    [anon_sym_uR_DQUOTE] = ACTIONS(3951),
    [anon_sym_UR_DQUOTE] = ACTIONS(3951),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3951),
    [anon_sym_co_await] = ACTIONS(3949),
    [anon_sym_new] = ACTIONS(3949),
    [anon_sym_requires] = ACTIONS(3949),
    [sym_this] = ACTIONS(3949),
    [anon_sym_precise] = ACTIONS(3949),
    [anon_sym_shared] = ACTIONS(3949),
    [anon_sym_groupshared] = ACTIONS(3949),
    [anon_sym_uniform] = ACTIONS(3949),
    [anon_sym_row_major] = ACTIONS(3949),
    [anon_sym_column_major] = ACTIONS(3949),
    [anon_sym_globallycoherent] = ACTIONS(3949),
    [anon_sym_centroid] = ACTIONS(3949),
    [anon_sym_noperspective] = ACTIONS(3949),
    [anon_sym_nointerpolation] = ACTIONS(3949),
    [anon_sym_sample] = ACTIONS(3949),
    [anon_sym_linear] = ACTIONS(3949),
    [anon_sym_snorm] = ACTIONS(3949),
    [anon_sym_unorm] = ACTIONS(3949),
    [anon_sym_point] = ACTIONS(3949),
    [anon_sym_line] = ACTIONS(3949),
    [anon_sym_triangleadj] = ACTIONS(3949),
    [anon_sym_lineadj] = ACTIONS(3949),
    [anon_sym_triangle] = ACTIONS(3949),
    [anon_sym_interface] = ACTIONS(3949),
    [anon_sym_extension] = ACTIONS(3949),
    [anon_sym___exported] = ACTIONS(3949),
  },
  [1011] = {
    [ts_builtin_sym_end] = ACTIONS(3697),
    [sym_identifier] = ACTIONS(3695),
    [aux_sym_preproc_include_token1] = ACTIONS(3695),
    [aux_sym_preproc_def_token1] = ACTIONS(3695),
    [aux_sym_preproc_if_token1] = ACTIONS(3695),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3695),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3695),
    [sym_preproc_directive] = ACTIONS(3695),
    [anon_sym_LPAREN2] = ACTIONS(3697),
    [anon_sym_BANG] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3695),
    [anon_sym_PLUS] = ACTIONS(3695),
    [anon_sym_STAR] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3695),
    [anon_sym_SEMI] = ACTIONS(3697),
    [anon_sym___extension__] = ACTIONS(3695),
    [anon_sym_typedef] = ACTIONS(3695),
    [anon_sym_in] = ACTIONS(3695),
    [anon_sym_out] = ACTIONS(3695),
    [anon_sym_inout] = ACTIONS(3695),
    [anon_sym_virtual] = ACTIONS(3695),
    [anon_sym_extern] = ACTIONS(3695),
    [anon_sym___attribute__] = ACTIONS(3695),
    [anon_sym___attribute] = ACTIONS(3695),
    [anon_sym_using] = ACTIONS(3695),
    [anon_sym_COLON_COLON] = ACTIONS(3697),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3697),
    [anon_sym___declspec] = ACTIONS(3695),
    [anon_sym___based] = ACTIONS(3695),
    [anon_sym___cdecl] = ACTIONS(3695),
    [anon_sym___clrcall] = ACTIONS(3695),
    [anon_sym___stdcall] = ACTIONS(3695),
    [anon_sym___fastcall] = ACTIONS(3695),
    [anon_sym___thiscall] = ACTIONS(3695),
    [anon_sym___vectorcall] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_signed] = ACTIONS(3695),
    [anon_sym_unsigned] = ACTIONS(3695),
    [anon_sym_long] = ACTIONS(3695),
    [anon_sym_short] = ACTIONS(3695),
    [anon_sym_LBRACK] = ACTIONS(3695),
    [anon_sym_static] = ACTIONS(3695),
    [anon_sym_register] = ACTIONS(3695),
    [anon_sym_inline] = ACTIONS(3695),
    [anon_sym___inline] = ACTIONS(3695),
    [anon_sym___inline__] = ACTIONS(3695),
    [anon_sym___forceinline] = ACTIONS(3695),
    [anon_sym_thread_local] = ACTIONS(3695),
    [anon_sym___thread] = ACTIONS(3695),
    [anon_sym_const] = ACTIONS(3695),
    [anon_sym_constexpr] = ACTIONS(3695),
    [anon_sym_volatile] = ACTIONS(3695),
    [anon_sym_restrict] = ACTIONS(3695),
    [anon_sym___restrict__] = ACTIONS(3695),
    [anon_sym__Atomic] = ACTIONS(3695),
    [anon_sym__Noreturn] = ACTIONS(3695),
    [anon_sym_noreturn] = ACTIONS(3695),
    [anon_sym__Nonnull] = ACTIONS(3695),
    [anon_sym_mutable] = ACTIONS(3695),
    [anon_sym_constinit] = ACTIONS(3695),
    [anon_sym_consteval] = ACTIONS(3695),
    [anon_sym_alignas] = ACTIONS(3695),
    [anon_sym__Alignas] = ACTIONS(3695),
    [sym_primitive_type] = ACTIONS(3695),
    [anon_sym_enum] = ACTIONS(3695),
    [anon_sym_class] = ACTIONS(3695),
    [anon_sym_struct] = ACTIONS(3695),
    [anon_sym_union] = ACTIONS(3695),
    [anon_sym_if] = ACTIONS(3695),
    [anon_sym_switch] = ACTIONS(3695),
    [anon_sym_case] = ACTIONS(3695),
    [anon_sym_default] = ACTIONS(3695),
    [anon_sym_while] = ACTIONS(3695),
    [anon_sym_do] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3695),
    [anon_sym_return] = ACTIONS(3695),
    [anon_sym_break] = ACTIONS(3695),
    [anon_sym_continue] = ACTIONS(3695),
    [anon_sym_goto] = ACTIONS(3695),
    [anon_sym_not] = ACTIONS(3695),
    [anon_sym_compl] = ACTIONS(3695),
    [anon_sym_DASH_DASH] = ACTIONS(3697),
    [anon_sym_PLUS_PLUS] = ACTIONS(3697),
    [anon_sym_sizeof] = ACTIONS(3695),
    [anon_sym___alignof__] = ACTIONS(3695),
    [anon_sym___alignof] = ACTIONS(3695),
    [anon_sym__alignof] = ACTIONS(3695),
    [anon_sym_alignof] = ACTIONS(3695),
    [anon_sym__Alignof] = ACTIONS(3695),
    [anon_sym_offsetof] = ACTIONS(3695),
    [anon_sym__Generic] = ACTIONS(3695),
    [anon_sym_asm] = ACTIONS(3695),
    [anon_sym___asm__] = ACTIONS(3695),
    [anon_sym___asm] = ACTIONS(3695),
    [sym_number_literal] = ACTIONS(3697),
    [anon_sym_L_SQUOTE] = ACTIONS(3697),
    [anon_sym_u_SQUOTE] = ACTIONS(3697),
    [anon_sym_U_SQUOTE] = ACTIONS(3697),
    [anon_sym_u8_SQUOTE] = ACTIONS(3697),
    [anon_sym_SQUOTE] = ACTIONS(3697),
    [anon_sym_L_DQUOTE] = ACTIONS(3697),
    [anon_sym_u_DQUOTE] = ACTIONS(3697),
    [anon_sym_U_DQUOTE] = ACTIONS(3697),
    [anon_sym_u8_DQUOTE] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [sym_true] = ACTIONS(3695),
    [sym_false] = ACTIONS(3695),
    [anon_sym_NULL] = ACTIONS(3695),
    [anon_sym_nullptr] = ACTIONS(3695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3695),
    [anon_sym_let] = ACTIONS(3695),
    [anon_sym_This] = ACTIONS(3695),
    [anon_sym_decltype] = ACTIONS(3695),
    [anon_sym_explicit] = ACTIONS(3695),
    [anon_sym_typename] = ACTIONS(3695),
    [anon_sym_export] = ACTIONS(3695),
    [anon_sym_module] = ACTIONS(3695),
    [anon_sym_import] = ACTIONS(3695),
    [anon_sym_template] = ACTIONS(3695),
    [anon_sym_operator] = ACTIONS(3695),
    [anon_sym_try] = ACTIONS(3695),
    [anon_sym_delete] = ACTIONS(3695),
    [anon_sym_throw] = ACTIONS(3695),
    [anon_sym_namespace] = ACTIONS(3695),
    [anon_sym_static_assert] = ACTIONS(3695),
    [anon_sym_concept] = ACTIONS(3695),
    [anon_sym_co_return] = ACTIONS(3695),
    [anon_sym_co_yield] = ACTIONS(3695),
    [anon_sym_R_DQUOTE] = ACTIONS(3697),
    [anon_sym_LR_DQUOTE] = ACTIONS(3697),
    [anon_sym_uR_DQUOTE] = ACTIONS(3697),
    [anon_sym_UR_DQUOTE] = ACTIONS(3697),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3697),
    [anon_sym_co_await] = ACTIONS(3695),
    [anon_sym_new] = ACTIONS(3695),
    [anon_sym_requires] = ACTIONS(3695),
    [sym_this] = ACTIONS(3695),
    [anon_sym_precise] = ACTIONS(3695),
    [anon_sym_shared] = ACTIONS(3695),
    [anon_sym_groupshared] = ACTIONS(3695),
    [anon_sym_uniform] = ACTIONS(3695),
    [anon_sym_row_major] = ACTIONS(3695),
    [anon_sym_column_major] = ACTIONS(3695),
    [anon_sym_globallycoherent] = ACTIONS(3695),
    [anon_sym_centroid] = ACTIONS(3695),
    [anon_sym_noperspective] = ACTIONS(3695),
    [anon_sym_nointerpolation] = ACTIONS(3695),
    [anon_sym_sample] = ACTIONS(3695),
    [anon_sym_linear] = ACTIONS(3695),
    [anon_sym_snorm] = ACTIONS(3695),
    [anon_sym_unorm] = ACTIONS(3695),
    [anon_sym_point] = ACTIONS(3695),
    [anon_sym_line] = ACTIONS(3695),
    [anon_sym_triangleadj] = ACTIONS(3695),
    [anon_sym_lineadj] = ACTIONS(3695),
    [anon_sym_triangle] = ACTIONS(3695),
    [anon_sym_interface] = ACTIONS(3695),
    [anon_sym_extension] = ACTIONS(3695),
    [anon_sym___exported] = ACTIONS(3695),
  },
  [1012] = {
    [ts_builtin_sym_end] = ACTIONS(3701),
    [sym_identifier] = ACTIONS(3699),
    [aux_sym_preproc_include_token1] = ACTIONS(3699),
    [aux_sym_preproc_def_token1] = ACTIONS(3699),
    [aux_sym_preproc_if_token1] = ACTIONS(3699),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3699),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3699),
    [sym_preproc_directive] = ACTIONS(3699),
    [anon_sym_LPAREN2] = ACTIONS(3701),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_STAR] = ACTIONS(3701),
    [anon_sym_AMP_AMP] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(3701),
    [anon_sym___extension__] = ACTIONS(3699),
    [anon_sym_typedef] = ACTIONS(3699),
    [anon_sym_in] = ACTIONS(3699),
    [anon_sym_out] = ACTIONS(3699),
    [anon_sym_inout] = ACTIONS(3699),
    [anon_sym_virtual] = ACTIONS(3699),
    [anon_sym_extern] = ACTIONS(3699),
    [anon_sym___attribute__] = ACTIONS(3699),
    [anon_sym___attribute] = ACTIONS(3699),
    [anon_sym_using] = ACTIONS(3699),
    [anon_sym_COLON_COLON] = ACTIONS(3701),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3701),
    [anon_sym___declspec] = ACTIONS(3699),
    [anon_sym___based] = ACTIONS(3699),
    [anon_sym___cdecl] = ACTIONS(3699),
    [anon_sym___clrcall] = ACTIONS(3699),
    [anon_sym___stdcall] = ACTIONS(3699),
    [anon_sym___fastcall] = ACTIONS(3699),
    [anon_sym___thiscall] = ACTIONS(3699),
    [anon_sym___vectorcall] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3701),
    [anon_sym_signed] = ACTIONS(3699),
    [anon_sym_unsigned] = ACTIONS(3699),
    [anon_sym_long] = ACTIONS(3699),
    [anon_sym_short] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(3699),
    [anon_sym_static] = ACTIONS(3699),
    [anon_sym_register] = ACTIONS(3699),
    [anon_sym_inline] = ACTIONS(3699),
    [anon_sym___inline] = ACTIONS(3699),
    [anon_sym___inline__] = ACTIONS(3699),
    [anon_sym___forceinline] = ACTIONS(3699),
    [anon_sym_thread_local] = ACTIONS(3699),
    [anon_sym___thread] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3699),
    [anon_sym_constexpr] = ACTIONS(3699),
    [anon_sym_volatile] = ACTIONS(3699),
    [anon_sym_restrict] = ACTIONS(3699),
    [anon_sym___restrict__] = ACTIONS(3699),
    [anon_sym__Atomic] = ACTIONS(3699),
    [anon_sym__Noreturn] = ACTIONS(3699),
    [anon_sym_noreturn] = ACTIONS(3699),
    [anon_sym__Nonnull] = ACTIONS(3699),
    [anon_sym_mutable] = ACTIONS(3699),
    [anon_sym_constinit] = ACTIONS(3699),
    [anon_sym_consteval] = ACTIONS(3699),
    [anon_sym_alignas] = ACTIONS(3699),
    [anon_sym__Alignas] = ACTIONS(3699),
    [sym_primitive_type] = ACTIONS(3699),
    [anon_sym_enum] = ACTIONS(3699),
    [anon_sym_class] = ACTIONS(3699),
    [anon_sym_struct] = ACTIONS(3699),
    [anon_sym_union] = ACTIONS(3699),
    [anon_sym_if] = ACTIONS(3699),
    [anon_sym_switch] = ACTIONS(3699),
    [anon_sym_case] = ACTIONS(3699),
    [anon_sym_default] = ACTIONS(3699),
    [anon_sym_while] = ACTIONS(3699),
    [anon_sym_do] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3699),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_break] = ACTIONS(3699),
    [anon_sym_continue] = ACTIONS(3699),
    [anon_sym_goto] = ACTIONS(3699),
    [anon_sym_not] = ACTIONS(3699),
    [anon_sym_compl] = ACTIONS(3699),
    [anon_sym_DASH_DASH] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3701),
    [anon_sym_sizeof] = ACTIONS(3699),
    [anon_sym___alignof__] = ACTIONS(3699),
    [anon_sym___alignof] = ACTIONS(3699),
    [anon_sym__alignof] = ACTIONS(3699),
    [anon_sym_alignof] = ACTIONS(3699),
    [anon_sym__Alignof] = ACTIONS(3699),
    [anon_sym_offsetof] = ACTIONS(3699),
    [anon_sym__Generic] = ACTIONS(3699),
    [anon_sym_asm] = ACTIONS(3699),
    [anon_sym___asm__] = ACTIONS(3699),
    [anon_sym___asm] = ACTIONS(3699),
    [sym_number_literal] = ACTIONS(3701),
    [anon_sym_L_SQUOTE] = ACTIONS(3701),
    [anon_sym_u_SQUOTE] = ACTIONS(3701),
    [anon_sym_U_SQUOTE] = ACTIONS(3701),
    [anon_sym_u8_SQUOTE] = ACTIONS(3701),
    [anon_sym_SQUOTE] = ACTIONS(3701),
    [anon_sym_L_DQUOTE] = ACTIONS(3701),
    [anon_sym_u_DQUOTE] = ACTIONS(3701),
    [anon_sym_U_DQUOTE] = ACTIONS(3701),
    [anon_sym_u8_DQUOTE] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [sym_true] = ACTIONS(3699),
    [sym_false] = ACTIONS(3699),
    [anon_sym_NULL] = ACTIONS(3699),
    [anon_sym_nullptr] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3699),
    [anon_sym_let] = ACTIONS(3699),
    [anon_sym_This] = ACTIONS(3699),
    [anon_sym_decltype] = ACTIONS(3699),
    [anon_sym_explicit] = ACTIONS(3699),
    [anon_sym_typename] = ACTIONS(3699),
    [anon_sym_export] = ACTIONS(3699),
    [anon_sym_module] = ACTIONS(3699),
    [anon_sym_import] = ACTIONS(3699),
    [anon_sym_template] = ACTIONS(3699),
    [anon_sym_operator] = ACTIONS(3699),
    [anon_sym_try] = ACTIONS(3699),
    [anon_sym_delete] = ACTIONS(3699),
    [anon_sym_throw] = ACTIONS(3699),
    [anon_sym_namespace] = ACTIONS(3699),
    [anon_sym_static_assert] = ACTIONS(3699),
    [anon_sym_concept] = ACTIONS(3699),
    [anon_sym_co_return] = ACTIONS(3699),
    [anon_sym_co_yield] = ACTIONS(3699),
    [anon_sym_R_DQUOTE] = ACTIONS(3701),
    [anon_sym_LR_DQUOTE] = ACTIONS(3701),
    [anon_sym_uR_DQUOTE] = ACTIONS(3701),
    [anon_sym_UR_DQUOTE] = ACTIONS(3701),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3701),
    [anon_sym_co_await] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3699),
    [anon_sym_requires] = ACTIONS(3699),
    [sym_this] = ACTIONS(3699),
    [anon_sym_precise] = ACTIONS(3699),
    [anon_sym_shared] = ACTIONS(3699),
    [anon_sym_groupshared] = ACTIONS(3699),
    [anon_sym_uniform] = ACTIONS(3699),
    [anon_sym_row_major] = ACTIONS(3699),
    [anon_sym_column_major] = ACTIONS(3699),
    [anon_sym_globallycoherent] = ACTIONS(3699),
    [anon_sym_centroid] = ACTIONS(3699),
    [anon_sym_noperspective] = ACTIONS(3699),
    [anon_sym_nointerpolation] = ACTIONS(3699),
    [anon_sym_sample] = ACTIONS(3699),
    [anon_sym_linear] = ACTIONS(3699),
    [anon_sym_snorm] = ACTIONS(3699),
    [anon_sym_unorm] = ACTIONS(3699),
    [anon_sym_point] = ACTIONS(3699),
    [anon_sym_line] = ACTIONS(3699),
    [anon_sym_triangleadj] = ACTIONS(3699),
    [anon_sym_lineadj] = ACTIONS(3699),
    [anon_sym_triangle] = ACTIONS(3699),
    [anon_sym_interface] = ACTIONS(3699),
    [anon_sym_extension] = ACTIONS(3699),
    [anon_sym___exported] = ACTIONS(3699),
  },
  [1013] = {
    [ts_builtin_sym_end] = ACTIONS(3705),
    [sym_identifier] = ACTIONS(3703),
    [aux_sym_preproc_include_token1] = ACTIONS(3703),
    [aux_sym_preproc_def_token1] = ACTIONS(3703),
    [aux_sym_preproc_if_token1] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3703),
    [sym_preproc_directive] = ACTIONS(3703),
    [anon_sym_LPAREN2] = ACTIONS(3705),
    [anon_sym_BANG] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3703),
    [anon_sym_STAR] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_AMP] = ACTIONS(3703),
    [anon_sym_SEMI] = ACTIONS(3705),
    [anon_sym___extension__] = ACTIONS(3703),
    [anon_sym_typedef] = ACTIONS(3703),
    [anon_sym_in] = ACTIONS(3703),
    [anon_sym_out] = ACTIONS(3703),
    [anon_sym_inout] = ACTIONS(3703),
    [anon_sym_virtual] = ACTIONS(3703),
    [anon_sym_extern] = ACTIONS(3703),
    [anon_sym___attribute__] = ACTIONS(3703),
    [anon_sym___attribute] = ACTIONS(3703),
    [anon_sym_using] = ACTIONS(3703),
    [anon_sym_COLON_COLON] = ACTIONS(3705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3705),
    [anon_sym___declspec] = ACTIONS(3703),
    [anon_sym___based] = ACTIONS(3703),
    [anon_sym___cdecl] = ACTIONS(3703),
    [anon_sym___clrcall] = ACTIONS(3703),
    [anon_sym___stdcall] = ACTIONS(3703),
    [anon_sym___fastcall] = ACTIONS(3703),
    [anon_sym___thiscall] = ACTIONS(3703),
    [anon_sym___vectorcall] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_signed] = ACTIONS(3703),
    [anon_sym_unsigned] = ACTIONS(3703),
    [anon_sym_long] = ACTIONS(3703),
    [anon_sym_short] = ACTIONS(3703),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_static] = ACTIONS(3703),
    [anon_sym_register] = ACTIONS(3703),
    [anon_sym_inline] = ACTIONS(3703),
    [anon_sym___inline] = ACTIONS(3703),
    [anon_sym___inline__] = ACTIONS(3703),
    [anon_sym___forceinline] = ACTIONS(3703),
    [anon_sym_thread_local] = ACTIONS(3703),
    [anon_sym___thread] = ACTIONS(3703),
    [anon_sym_const] = ACTIONS(3703),
    [anon_sym_constexpr] = ACTIONS(3703),
    [anon_sym_volatile] = ACTIONS(3703),
    [anon_sym_restrict] = ACTIONS(3703),
    [anon_sym___restrict__] = ACTIONS(3703),
    [anon_sym__Atomic] = ACTIONS(3703),
    [anon_sym__Noreturn] = ACTIONS(3703),
    [anon_sym_noreturn] = ACTIONS(3703),
    [anon_sym__Nonnull] = ACTIONS(3703),
    [anon_sym_mutable] = ACTIONS(3703),
    [anon_sym_constinit] = ACTIONS(3703),
    [anon_sym_consteval] = ACTIONS(3703),
    [anon_sym_alignas] = ACTIONS(3703),
    [anon_sym__Alignas] = ACTIONS(3703),
    [sym_primitive_type] = ACTIONS(3703),
    [anon_sym_enum] = ACTIONS(3703),
    [anon_sym_class] = ACTIONS(3703),
    [anon_sym_struct] = ACTIONS(3703),
    [anon_sym_union] = ACTIONS(3703),
    [anon_sym_if] = ACTIONS(3703),
    [anon_sym_switch] = ACTIONS(3703),
    [anon_sym_case] = ACTIONS(3703),
    [anon_sym_default] = ACTIONS(3703),
    [anon_sym_while] = ACTIONS(3703),
    [anon_sym_do] = ACTIONS(3703),
    [anon_sym_for] = ACTIONS(3703),
    [anon_sym_return] = ACTIONS(3703),
    [anon_sym_break] = ACTIONS(3703),
    [anon_sym_continue] = ACTIONS(3703),
    [anon_sym_goto] = ACTIONS(3703),
    [anon_sym_not] = ACTIONS(3703),
    [anon_sym_compl] = ACTIONS(3703),
    [anon_sym_DASH_DASH] = ACTIONS(3705),
    [anon_sym_PLUS_PLUS] = ACTIONS(3705),
    [anon_sym_sizeof] = ACTIONS(3703),
    [anon_sym___alignof__] = ACTIONS(3703),
    [anon_sym___alignof] = ACTIONS(3703),
    [anon_sym__alignof] = ACTIONS(3703),
    [anon_sym_alignof] = ACTIONS(3703),
    [anon_sym__Alignof] = ACTIONS(3703),
    [anon_sym_offsetof] = ACTIONS(3703),
    [anon_sym__Generic] = ACTIONS(3703),
    [anon_sym_asm] = ACTIONS(3703),
    [anon_sym___asm__] = ACTIONS(3703),
    [anon_sym___asm] = ACTIONS(3703),
    [sym_number_literal] = ACTIONS(3705),
    [anon_sym_L_SQUOTE] = ACTIONS(3705),
    [anon_sym_u_SQUOTE] = ACTIONS(3705),
    [anon_sym_U_SQUOTE] = ACTIONS(3705),
    [anon_sym_u8_SQUOTE] = ACTIONS(3705),
    [anon_sym_SQUOTE] = ACTIONS(3705),
    [anon_sym_L_DQUOTE] = ACTIONS(3705),
    [anon_sym_u_DQUOTE] = ACTIONS(3705),
    [anon_sym_U_DQUOTE] = ACTIONS(3705),
    [anon_sym_u8_DQUOTE] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [sym_true] = ACTIONS(3703),
    [sym_false] = ACTIONS(3703),
    [anon_sym_NULL] = ACTIONS(3703),
    [anon_sym_nullptr] = ACTIONS(3703),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3703),
    [anon_sym_let] = ACTIONS(3703),
    [anon_sym_This] = ACTIONS(3703),
    [anon_sym_decltype] = ACTIONS(3703),
    [anon_sym_explicit] = ACTIONS(3703),
    [anon_sym_typename] = ACTIONS(3703),
    [anon_sym_export] = ACTIONS(3703),
    [anon_sym_module] = ACTIONS(3703),
    [anon_sym_import] = ACTIONS(3703),
    [anon_sym_template] = ACTIONS(3703),
    [anon_sym_operator] = ACTIONS(3703),
    [anon_sym_try] = ACTIONS(3703),
    [anon_sym_delete] = ACTIONS(3703),
    [anon_sym_throw] = ACTIONS(3703),
    [anon_sym_namespace] = ACTIONS(3703),
    [anon_sym_static_assert] = ACTIONS(3703),
    [anon_sym_concept] = ACTIONS(3703),
    [anon_sym_co_return] = ACTIONS(3703),
    [anon_sym_co_yield] = ACTIONS(3703),
    [anon_sym_R_DQUOTE] = ACTIONS(3705),
    [anon_sym_LR_DQUOTE] = ACTIONS(3705),
    [anon_sym_uR_DQUOTE] = ACTIONS(3705),
    [anon_sym_UR_DQUOTE] = ACTIONS(3705),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3705),
    [anon_sym_co_await] = ACTIONS(3703),
    [anon_sym_new] = ACTIONS(3703),
    [anon_sym_requires] = ACTIONS(3703),
    [sym_this] = ACTIONS(3703),
    [anon_sym_precise] = ACTIONS(3703),
    [anon_sym_shared] = ACTIONS(3703),
    [anon_sym_groupshared] = ACTIONS(3703),
    [anon_sym_uniform] = ACTIONS(3703),
    [anon_sym_row_major] = ACTIONS(3703),
    [anon_sym_column_major] = ACTIONS(3703),
    [anon_sym_globallycoherent] = ACTIONS(3703),
    [anon_sym_centroid] = ACTIONS(3703),
    [anon_sym_noperspective] = ACTIONS(3703),
    [anon_sym_nointerpolation] = ACTIONS(3703),
    [anon_sym_sample] = ACTIONS(3703),
    [anon_sym_linear] = ACTIONS(3703),
    [anon_sym_snorm] = ACTIONS(3703),
    [anon_sym_unorm] = ACTIONS(3703),
    [anon_sym_point] = ACTIONS(3703),
    [anon_sym_line] = ACTIONS(3703),
    [anon_sym_triangleadj] = ACTIONS(3703),
    [anon_sym_lineadj] = ACTIONS(3703),
    [anon_sym_triangle] = ACTIONS(3703),
    [anon_sym_interface] = ACTIONS(3703),
    [anon_sym_extension] = ACTIONS(3703),
    [anon_sym___exported] = ACTIONS(3703),
  },
  [1014] = {
    [ts_builtin_sym_end] = ACTIONS(3709),
    [sym_identifier] = ACTIONS(3707),
    [aux_sym_preproc_include_token1] = ACTIONS(3707),
    [aux_sym_preproc_def_token1] = ACTIONS(3707),
    [aux_sym_preproc_if_token1] = ACTIONS(3707),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3707),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3707),
    [sym_preproc_directive] = ACTIONS(3707),
    [anon_sym_LPAREN2] = ACTIONS(3709),
    [anon_sym_BANG] = ACTIONS(3709),
    [anon_sym_TILDE] = ACTIONS(3709),
    [anon_sym_DASH] = ACTIONS(3707),
    [anon_sym_PLUS] = ACTIONS(3707),
    [anon_sym_STAR] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(3707),
    [anon_sym_SEMI] = ACTIONS(3709),
    [anon_sym___extension__] = ACTIONS(3707),
    [anon_sym_typedef] = ACTIONS(3707),
    [anon_sym_in] = ACTIONS(3707),
    [anon_sym_out] = ACTIONS(3707),
    [anon_sym_inout] = ACTIONS(3707),
    [anon_sym_virtual] = ACTIONS(3707),
    [anon_sym_extern] = ACTIONS(3707),
    [anon_sym___attribute__] = ACTIONS(3707),
    [anon_sym___attribute] = ACTIONS(3707),
    [anon_sym_using] = ACTIONS(3707),
    [anon_sym_COLON_COLON] = ACTIONS(3709),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3709),
    [anon_sym___declspec] = ACTIONS(3707),
    [anon_sym___based] = ACTIONS(3707),
    [anon_sym___cdecl] = ACTIONS(3707),
    [anon_sym___clrcall] = ACTIONS(3707),
    [anon_sym___stdcall] = ACTIONS(3707),
    [anon_sym___fastcall] = ACTIONS(3707),
    [anon_sym___thiscall] = ACTIONS(3707),
    [anon_sym___vectorcall] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3709),
    [anon_sym_signed] = ACTIONS(3707),
    [anon_sym_unsigned] = ACTIONS(3707),
    [anon_sym_long] = ACTIONS(3707),
    [anon_sym_short] = ACTIONS(3707),
    [anon_sym_LBRACK] = ACTIONS(3707),
    [anon_sym_static] = ACTIONS(3707),
    [anon_sym_register] = ACTIONS(3707),
    [anon_sym_inline] = ACTIONS(3707),
    [anon_sym___inline] = ACTIONS(3707),
    [anon_sym___inline__] = ACTIONS(3707),
    [anon_sym___forceinline] = ACTIONS(3707),
    [anon_sym_thread_local] = ACTIONS(3707),
    [anon_sym___thread] = ACTIONS(3707),
    [anon_sym_const] = ACTIONS(3707),
    [anon_sym_constexpr] = ACTIONS(3707),
    [anon_sym_volatile] = ACTIONS(3707),
    [anon_sym_restrict] = ACTIONS(3707),
    [anon_sym___restrict__] = ACTIONS(3707),
    [anon_sym__Atomic] = ACTIONS(3707),
    [anon_sym__Noreturn] = ACTIONS(3707),
    [anon_sym_noreturn] = ACTIONS(3707),
    [anon_sym__Nonnull] = ACTIONS(3707),
    [anon_sym_mutable] = ACTIONS(3707),
    [anon_sym_constinit] = ACTIONS(3707),
    [anon_sym_consteval] = ACTIONS(3707),
    [anon_sym_alignas] = ACTIONS(3707),
    [anon_sym__Alignas] = ACTIONS(3707),
    [sym_primitive_type] = ACTIONS(3707),
    [anon_sym_enum] = ACTIONS(3707),
    [anon_sym_class] = ACTIONS(3707),
    [anon_sym_struct] = ACTIONS(3707),
    [anon_sym_union] = ACTIONS(3707),
    [anon_sym_if] = ACTIONS(3707),
    [anon_sym_switch] = ACTIONS(3707),
    [anon_sym_case] = ACTIONS(3707),
    [anon_sym_default] = ACTIONS(3707),
    [anon_sym_while] = ACTIONS(3707),
    [anon_sym_do] = ACTIONS(3707),
    [anon_sym_for] = ACTIONS(3707),
    [anon_sym_return] = ACTIONS(3707),
    [anon_sym_break] = ACTIONS(3707),
    [anon_sym_continue] = ACTIONS(3707),
    [anon_sym_goto] = ACTIONS(3707),
    [anon_sym_not] = ACTIONS(3707),
    [anon_sym_compl] = ACTIONS(3707),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_sizeof] = ACTIONS(3707),
    [anon_sym___alignof__] = ACTIONS(3707),
    [anon_sym___alignof] = ACTIONS(3707),
    [anon_sym__alignof] = ACTIONS(3707),
    [anon_sym_alignof] = ACTIONS(3707),
    [anon_sym__Alignof] = ACTIONS(3707),
    [anon_sym_offsetof] = ACTIONS(3707),
    [anon_sym__Generic] = ACTIONS(3707),
    [anon_sym_asm] = ACTIONS(3707),
    [anon_sym___asm__] = ACTIONS(3707),
    [anon_sym___asm] = ACTIONS(3707),
    [sym_number_literal] = ACTIONS(3709),
    [anon_sym_L_SQUOTE] = ACTIONS(3709),
    [anon_sym_u_SQUOTE] = ACTIONS(3709),
    [anon_sym_U_SQUOTE] = ACTIONS(3709),
    [anon_sym_u8_SQUOTE] = ACTIONS(3709),
    [anon_sym_SQUOTE] = ACTIONS(3709),
    [anon_sym_L_DQUOTE] = ACTIONS(3709),
    [anon_sym_u_DQUOTE] = ACTIONS(3709),
    [anon_sym_U_DQUOTE] = ACTIONS(3709),
    [anon_sym_u8_DQUOTE] = ACTIONS(3709),
    [anon_sym_DQUOTE] = ACTIONS(3709),
    [sym_true] = ACTIONS(3707),
    [sym_false] = ACTIONS(3707),
    [anon_sym_NULL] = ACTIONS(3707),
    [anon_sym_nullptr] = ACTIONS(3707),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3707),
    [anon_sym_let] = ACTIONS(3707),
    [anon_sym_This] = ACTIONS(3707),
    [anon_sym_decltype] = ACTIONS(3707),
    [anon_sym_explicit] = ACTIONS(3707),
    [anon_sym_typename] = ACTIONS(3707),
    [anon_sym_export] = ACTIONS(3707),
    [anon_sym_module] = ACTIONS(3707),
    [anon_sym_import] = ACTIONS(3707),
    [anon_sym_template] = ACTIONS(3707),
    [anon_sym_operator] = ACTIONS(3707),
    [anon_sym_try] = ACTIONS(3707),
    [anon_sym_delete] = ACTIONS(3707),
    [anon_sym_throw] = ACTIONS(3707),
    [anon_sym_namespace] = ACTIONS(3707),
    [anon_sym_static_assert] = ACTIONS(3707),
    [anon_sym_concept] = ACTIONS(3707),
    [anon_sym_co_return] = ACTIONS(3707),
    [anon_sym_co_yield] = ACTIONS(3707),
    [anon_sym_R_DQUOTE] = ACTIONS(3709),
    [anon_sym_LR_DQUOTE] = ACTIONS(3709),
    [anon_sym_uR_DQUOTE] = ACTIONS(3709),
    [anon_sym_UR_DQUOTE] = ACTIONS(3709),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3709),
    [anon_sym_co_await] = ACTIONS(3707),
    [anon_sym_new] = ACTIONS(3707),
    [anon_sym_requires] = ACTIONS(3707),
    [sym_this] = ACTIONS(3707),
    [anon_sym_precise] = ACTIONS(3707),
    [anon_sym_shared] = ACTIONS(3707),
    [anon_sym_groupshared] = ACTIONS(3707),
    [anon_sym_uniform] = ACTIONS(3707),
    [anon_sym_row_major] = ACTIONS(3707),
    [anon_sym_column_major] = ACTIONS(3707),
    [anon_sym_globallycoherent] = ACTIONS(3707),
    [anon_sym_centroid] = ACTIONS(3707),
    [anon_sym_noperspective] = ACTIONS(3707),
    [anon_sym_nointerpolation] = ACTIONS(3707),
    [anon_sym_sample] = ACTIONS(3707),
    [anon_sym_linear] = ACTIONS(3707),
    [anon_sym_snorm] = ACTIONS(3707),
    [anon_sym_unorm] = ACTIONS(3707),
    [anon_sym_point] = ACTIONS(3707),
    [anon_sym_line] = ACTIONS(3707),
    [anon_sym_triangleadj] = ACTIONS(3707),
    [anon_sym_lineadj] = ACTIONS(3707),
    [anon_sym_triangle] = ACTIONS(3707),
    [anon_sym_interface] = ACTIONS(3707),
    [anon_sym_extension] = ACTIONS(3707),
    [anon_sym___exported] = ACTIONS(3707),
  },
  [1015] = {
    [ts_builtin_sym_end] = ACTIONS(3713),
    [sym_identifier] = ACTIONS(3711),
    [aux_sym_preproc_include_token1] = ACTIONS(3711),
    [aux_sym_preproc_def_token1] = ACTIONS(3711),
    [aux_sym_preproc_if_token1] = ACTIONS(3711),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3711),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3711),
    [sym_preproc_directive] = ACTIONS(3711),
    [anon_sym_LPAREN2] = ACTIONS(3713),
    [anon_sym_BANG] = ACTIONS(3713),
    [anon_sym_TILDE] = ACTIONS(3713),
    [anon_sym_DASH] = ACTIONS(3711),
    [anon_sym_PLUS] = ACTIONS(3711),
    [anon_sym_STAR] = ACTIONS(3713),
    [anon_sym_AMP_AMP] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(3711),
    [anon_sym_SEMI] = ACTIONS(3713),
    [anon_sym___extension__] = ACTIONS(3711),
    [anon_sym_typedef] = ACTIONS(3711),
    [anon_sym_in] = ACTIONS(3711),
    [anon_sym_out] = ACTIONS(3711),
    [anon_sym_inout] = ACTIONS(3711),
    [anon_sym_virtual] = ACTIONS(3711),
    [anon_sym_extern] = ACTIONS(3711),
    [anon_sym___attribute__] = ACTIONS(3711),
    [anon_sym___attribute] = ACTIONS(3711),
    [anon_sym_using] = ACTIONS(3711),
    [anon_sym_COLON_COLON] = ACTIONS(3713),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3713),
    [anon_sym___declspec] = ACTIONS(3711),
    [anon_sym___based] = ACTIONS(3711),
    [anon_sym___cdecl] = ACTIONS(3711),
    [anon_sym___clrcall] = ACTIONS(3711),
    [anon_sym___stdcall] = ACTIONS(3711),
    [anon_sym___fastcall] = ACTIONS(3711),
    [anon_sym___thiscall] = ACTIONS(3711),
    [anon_sym___vectorcall] = ACTIONS(3711),
    [anon_sym_LBRACE] = ACTIONS(3713),
    [anon_sym_signed] = ACTIONS(3711),
    [anon_sym_unsigned] = ACTIONS(3711),
    [anon_sym_long] = ACTIONS(3711),
    [anon_sym_short] = ACTIONS(3711),
    [anon_sym_LBRACK] = ACTIONS(3711),
    [anon_sym_static] = ACTIONS(3711),
    [anon_sym_register] = ACTIONS(3711),
    [anon_sym_inline] = ACTIONS(3711),
    [anon_sym___inline] = ACTIONS(3711),
    [anon_sym___inline__] = ACTIONS(3711),
    [anon_sym___forceinline] = ACTIONS(3711),
    [anon_sym_thread_local] = ACTIONS(3711),
    [anon_sym___thread] = ACTIONS(3711),
    [anon_sym_const] = ACTIONS(3711),
    [anon_sym_constexpr] = ACTIONS(3711),
    [anon_sym_volatile] = ACTIONS(3711),
    [anon_sym_restrict] = ACTIONS(3711),
    [anon_sym___restrict__] = ACTIONS(3711),
    [anon_sym__Atomic] = ACTIONS(3711),
    [anon_sym__Noreturn] = ACTIONS(3711),
    [anon_sym_noreturn] = ACTIONS(3711),
    [anon_sym__Nonnull] = ACTIONS(3711),
    [anon_sym_mutable] = ACTIONS(3711),
    [anon_sym_constinit] = ACTIONS(3711),
    [anon_sym_consteval] = ACTIONS(3711),
    [anon_sym_alignas] = ACTIONS(3711),
    [anon_sym__Alignas] = ACTIONS(3711),
    [sym_primitive_type] = ACTIONS(3711),
    [anon_sym_enum] = ACTIONS(3711),
    [anon_sym_class] = ACTIONS(3711),
    [anon_sym_struct] = ACTIONS(3711),
    [anon_sym_union] = ACTIONS(3711),
    [anon_sym_if] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3711),
    [anon_sym_case] = ACTIONS(3711),
    [anon_sym_default] = ACTIONS(3711),
    [anon_sym_while] = ACTIONS(3711),
    [anon_sym_do] = ACTIONS(3711),
    [anon_sym_for] = ACTIONS(3711),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_break] = ACTIONS(3711),
    [anon_sym_continue] = ACTIONS(3711),
    [anon_sym_goto] = ACTIONS(3711),
    [anon_sym_not] = ACTIONS(3711),
    [anon_sym_compl] = ACTIONS(3711),
    [anon_sym_DASH_DASH] = ACTIONS(3713),
    [anon_sym_PLUS_PLUS] = ACTIONS(3713),
    [anon_sym_sizeof] = ACTIONS(3711),
    [anon_sym___alignof__] = ACTIONS(3711),
    [anon_sym___alignof] = ACTIONS(3711),
    [anon_sym__alignof] = ACTIONS(3711),
    [anon_sym_alignof] = ACTIONS(3711),
    [anon_sym__Alignof] = ACTIONS(3711),
    [anon_sym_offsetof] = ACTIONS(3711),
    [anon_sym__Generic] = ACTIONS(3711),
    [anon_sym_asm] = ACTIONS(3711),
    [anon_sym___asm__] = ACTIONS(3711),
    [anon_sym___asm] = ACTIONS(3711),
    [sym_number_literal] = ACTIONS(3713),
    [anon_sym_L_SQUOTE] = ACTIONS(3713),
    [anon_sym_u_SQUOTE] = ACTIONS(3713),
    [anon_sym_U_SQUOTE] = ACTIONS(3713),
    [anon_sym_u8_SQUOTE] = ACTIONS(3713),
    [anon_sym_SQUOTE] = ACTIONS(3713),
    [anon_sym_L_DQUOTE] = ACTIONS(3713),
    [anon_sym_u_DQUOTE] = ACTIONS(3713),
    [anon_sym_U_DQUOTE] = ACTIONS(3713),
    [anon_sym_u8_DQUOTE] = ACTIONS(3713),
    [anon_sym_DQUOTE] = ACTIONS(3713),
    [sym_true] = ACTIONS(3711),
    [sym_false] = ACTIONS(3711),
    [anon_sym_NULL] = ACTIONS(3711),
    [anon_sym_nullptr] = ACTIONS(3711),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_This] = ACTIONS(3711),
    [anon_sym_decltype] = ACTIONS(3711),
    [anon_sym_explicit] = ACTIONS(3711),
    [anon_sym_typename] = ACTIONS(3711),
    [anon_sym_export] = ACTIONS(3711),
    [anon_sym_module] = ACTIONS(3711),
    [anon_sym_import] = ACTIONS(3711),
    [anon_sym_template] = ACTIONS(3711),
    [anon_sym_operator] = ACTIONS(3711),
    [anon_sym_try] = ACTIONS(3711),
    [anon_sym_delete] = ACTIONS(3711),
    [anon_sym_throw] = ACTIONS(3711),
    [anon_sym_namespace] = ACTIONS(3711),
    [anon_sym_static_assert] = ACTIONS(3711),
    [anon_sym_concept] = ACTIONS(3711),
    [anon_sym_co_return] = ACTIONS(3711),
    [anon_sym_co_yield] = ACTIONS(3711),
    [anon_sym_R_DQUOTE] = ACTIONS(3713),
    [anon_sym_LR_DQUOTE] = ACTIONS(3713),
    [anon_sym_uR_DQUOTE] = ACTIONS(3713),
    [anon_sym_UR_DQUOTE] = ACTIONS(3713),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3713),
    [anon_sym_co_await] = ACTIONS(3711),
    [anon_sym_new] = ACTIONS(3711),
    [anon_sym_requires] = ACTIONS(3711),
    [sym_this] = ACTIONS(3711),
    [anon_sym_precise] = ACTIONS(3711),
    [anon_sym_shared] = ACTIONS(3711),
    [anon_sym_groupshared] = ACTIONS(3711),
    [anon_sym_uniform] = ACTIONS(3711),
    [anon_sym_row_major] = ACTIONS(3711),
    [anon_sym_column_major] = ACTIONS(3711),
    [anon_sym_globallycoherent] = ACTIONS(3711),
    [anon_sym_centroid] = ACTIONS(3711),
    [anon_sym_noperspective] = ACTIONS(3711),
    [anon_sym_nointerpolation] = ACTIONS(3711),
    [anon_sym_sample] = ACTIONS(3711),
    [anon_sym_linear] = ACTIONS(3711),
    [anon_sym_snorm] = ACTIONS(3711),
    [anon_sym_unorm] = ACTIONS(3711),
    [anon_sym_point] = ACTIONS(3711),
    [anon_sym_line] = ACTIONS(3711),
    [anon_sym_triangleadj] = ACTIONS(3711),
    [anon_sym_lineadj] = ACTIONS(3711),
    [anon_sym_triangle] = ACTIONS(3711),
    [anon_sym_interface] = ACTIONS(3711),
    [anon_sym_extension] = ACTIONS(3711),
    [anon_sym___exported] = ACTIONS(3711),
  },
  [1016] = {
    [ts_builtin_sym_end] = ACTIONS(3717),
    [sym_identifier] = ACTIONS(3715),
    [aux_sym_preproc_include_token1] = ACTIONS(3715),
    [aux_sym_preproc_def_token1] = ACTIONS(3715),
    [aux_sym_preproc_if_token1] = ACTIONS(3715),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3715),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3715),
    [sym_preproc_directive] = ACTIONS(3715),
    [anon_sym_LPAREN2] = ACTIONS(3717),
    [anon_sym_BANG] = ACTIONS(3717),
    [anon_sym_TILDE] = ACTIONS(3717),
    [anon_sym_DASH] = ACTIONS(3715),
    [anon_sym_PLUS] = ACTIONS(3715),
    [anon_sym_STAR] = ACTIONS(3717),
    [anon_sym_AMP_AMP] = ACTIONS(3717),
    [anon_sym_AMP] = ACTIONS(3715),
    [anon_sym_SEMI] = ACTIONS(3717),
    [anon_sym___extension__] = ACTIONS(3715),
    [anon_sym_typedef] = ACTIONS(3715),
    [anon_sym_in] = ACTIONS(3715),
    [anon_sym_out] = ACTIONS(3715),
    [anon_sym_inout] = ACTIONS(3715),
    [anon_sym_virtual] = ACTIONS(3715),
    [anon_sym_extern] = ACTIONS(3715),
    [anon_sym___attribute__] = ACTIONS(3715),
    [anon_sym___attribute] = ACTIONS(3715),
    [anon_sym_using] = ACTIONS(3715),
    [anon_sym_COLON_COLON] = ACTIONS(3717),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3717),
    [anon_sym___declspec] = ACTIONS(3715),
    [anon_sym___based] = ACTIONS(3715),
    [anon_sym___cdecl] = ACTIONS(3715),
    [anon_sym___clrcall] = ACTIONS(3715),
    [anon_sym___stdcall] = ACTIONS(3715),
    [anon_sym___fastcall] = ACTIONS(3715),
    [anon_sym___thiscall] = ACTIONS(3715),
    [anon_sym___vectorcall] = ACTIONS(3715),
    [anon_sym_LBRACE] = ACTIONS(3717),
    [anon_sym_signed] = ACTIONS(3715),
    [anon_sym_unsigned] = ACTIONS(3715),
    [anon_sym_long] = ACTIONS(3715),
    [anon_sym_short] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_static] = ACTIONS(3715),
    [anon_sym_register] = ACTIONS(3715),
    [anon_sym_inline] = ACTIONS(3715),
    [anon_sym___inline] = ACTIONS(3715),
    [anon_sym___inline__] = ACTIONS(3715),
    [anon_sym___forceinline] = ACTIONS(3715),
    [anon_sym_thread_local] = ACTIONS(3715),
    [anon_sym___thread] = ACTIONS(3715),
    [anon_sym_const] = ACTIONS(3715),
    [anon_sym_constexpr] = ACTIONS(3715),
    [anon_sym_volatile] = ACTIONS(3715),
    [anon_sym_restrict] = ACTIONS(3715),
    [anon_sym___restrict__] = ACTIONS(3715),
    [anon_sym__Atomic] = ACTIONS(3715),
    [anon_sym__Noreturn] = ACTIONS(3715),
    [anon_sym_noreturn] = ACTIONS(3715),
    [anon_sym__Nonnull] = ACTIONS(3715),
    [anon_sym_mutable] = ACTIONS(3715),
    [anon_sym_constinit] = ACTIONS(3715),
    [anon_sym_consteval] = ACTIONS(3715),
    [anon_sym_alignas] = ACTIONS(3715),
    [anon_sym__Alignas] = ACTIONS(3715),
    [sym_primitive_type] = ACTIONS(3715),
    [anon_sym_enum] = ACTIONS(3715),
    [anon_sym_class] = ACTIONS(3715),
    [anon_sym_struct] = ACTIONS(3715),
    [anon_sym_union] = ACTIONS(3715),
    [anon_sym_if] = ACTIONS(3715),
    [anon_sym_switch] = ACTIONS(3715),
    [anon_sym_case] = ACTIONS(3715),
    [anon_sym_default] = ACTIONS(3715),
    [anon_sym_while] = ACTIONS(3715),
    [anon_sym_do] = ACTIONS(3715),
    [anon_sym_for] = ACTIONS(3715),
    [anon_sym_return] = ACTIONS(3715),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_continue] = ACTIONS(3715),
    [anon_sym_goto] = ACTIONS(3715),
    [anon_sym_not] = ACTIONS(3715),
    [anon_sym_compl] = ACTIONS(3715),
    [anon_sym_DASH_DASH] = ACTIONS(3717),
    [anon_sym_PLUS_PLUS] = ACTIONS(3717),
    [anon_sym_sizeof] = ACTIONS(3715),
    [anon_sym___alignof__] = ACTIONS(3715),
    [anon_sym___alignof] = ACTIONS(3715),
    [anon_sym__alignof] = ACTIONS(3715),
    [anon_sym_alignof] = ACTIONS(3715),
    [anon_sym__Alignof] = ACTIONS(3715),
    [anon_sym_offsetof] = ACTIONS(3715),
    [anon_sym__Generic] = ACTIONS(3715),
    [anon_sym_asm] = ACTIONS(3715),
    [anon_sym___asm__] = ACTIONS(3715),
    [anon_sym___asm] = ACTIONS(3715),
    [sym_number_literal] = ACTIONS(3717),
    [anon_sym_L_SQUOTE] = ACTIONS(3717),
    [anon_sym_u_SQUOTE] = ACTIONS(3717),
    [anon_sym_U_SQUOTE] = ACTIONS(3717),
    [anon_sym_u8_SQUOTE] = ACTIONS(3717),
    [anon_sym_SQUOTE] = ACTIONS(3717),
    [anon_sym_L_DQUOTE] = ACTIONS(3717),
    [anon_sym_u_DQUOTE] = ACTIONS(3717),
    [anon_sym_U_DQUOTE] = ACTIONS(3717),
    [anon_sym_u8_DQUOTE] = ACTIONS(3717),
    [anon_sym_DQUOTE] = ACTIONS(3717),
    [sym_true] = ACTIONS(3715),
    [sym_false] = ACTIONS(3715),
    [anon_sym_NULL] = ACTIONS(3715),
    [anon_sym_nullptr] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3715),
    [anon_sym_let] = ACTIONS(3715),
    [anon_sym_This] = ACTIONS(3715),
    [anon_sym_decltype] = ACTIONS(3715),
    [anon_sym_explicit] = ACTIONS(3715),
    [anon_sym_typename] = ACTIONS(3715),
    [anon_sym_export] = ACTIONS(3715),
    [anon_sym_module] = ACTIONS(3715),
    [anon_sym_import] = ACTIONS(3715),
    [anon_sym_template] = ACTIONS(3715),
    [anon_sym_operator] = ACTIONS(3715),
    [anon_sym_try] = ACTIONS(3715),
    [anon_sym_delete] = ACTIONS(3715),
    [anon_sym_throw] = ACTIONS(3715),
    [anon_sym_namespace] = ACTIONS(3715),
    [anon_sym_static_assert] = ACTIONS(3715),
    [anon_sym_concept] = ACTIONS(3715),
    [anon_sym_co_return] = ACTIONS(3715),
    [anon_sym_co_yield] = ACTIONS(3715),
    [anon_sym_R_DQUOTE] = ACTIONS(3717),
    [anon_sym_LR_DQUOTE] = ACTIONS(3717),
    [anon_sym_uR_DQUOTE] = ACTIONS(3717),
    [anon_sym_UR_DQUOTE] = ACTIONS(3717),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3717),
    [anon_sym_co_await] = ACTIONS(3715),
    [anon_sym_new] = ACTIONS(3715),
    [anon_sym_requires] = ACTIONS(3715),
    [sym_this] = ACTIONS(3715),
    [anon_sym_precise] = ACTIONS(3715),
    [anon_sym_shared] = ACTIONS(3715),
    [anon_sym_groupshared] = ACTIONS(3715),
    [anon_sym_uniform] = ACTIONS(3715),
    [anon_sym_row_major] = ACTIONS(3715),
    [anon_sym_column_major] = ACTIONS(3715),
    [anon_sym_globallycoherent] = ACTIONS(3715),
    [anon_sym_centroid] = ACTIONS(3715),
    [anon_sym_noperspective] = ACTIONS(3715),
    [anon_sym_nointerpolation] = ACTIONS(3715),
    [anon_sym_sample] = ACTIONS(3715),
    [anon_sym_linear] = ACTIONS(3715),
    [anon_sym_snorm] = ACTIONS(3715),
    [anon_sym_unorm] = ACTIONS(3715),
    [anon_sym_point] = ACTIONS(3715),
    [anon_sym_line] = ACTIONS(3715),
    [anon_sym_triangleadj] = ACTIONS(3715),
    [anon_sym_lineadj] = ACTIONS(3715),
    [anon_sym_triangle] = ACTIONS(3715),
    [anon_sym_interface] = ACTIONS(3715),
    [anon_sym_extension] = ACTIONS(3715),
    [anon_sym___exported] = ACTIONS(3715),
  },
  [1017] = {
    [ts_builtin_sym_end] = ACTIONS(3721),
    [sym_identifier] = ACTIONS(3719),
    [aux_sym_preproc_include_token1] = ACTIONS(3719),
    [aux_sym_preproc_def_token1] = ACTIONS(3719),
    [aux_sym_preproc_if_token1] = ACTIONS(3719),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3719),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3719),
    [sym_preproc_directive] = ACTIONS(3719),
    [anon_sym_LPAREN2] = ACTIONS(3721),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_TILDE] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_AMP_AMP] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3719),
    [anon_sym_SEMI] = ACTIONS(3721),
    [anon_sym___extension__] = ACTIONS(3719),
    [anon_sym_typedef] = ACTIONS(3719),
    [anon_sym_in] = ACTIONS(3719),
    [anon_sym_out] = ACTIONS(3719),
    [anon_sym_inout] = ACTIONS(3719),
    [anon_sym_virtual] = ACTIONS(3719),
    [anon_sym_extern] = ACTIONS(3719),
    [anon_sym___attribute__] = ACTIONS(3719),
    [anon_sym___attribute] = ACTIONS(3719),
    [anon_sym_using] = ACTIONS(3719),
    [anon_sym_COLON_COLON] = ACTIONS(3721),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3721),
    [anon_sym___declspec] = ACTIONS(3719),
    [anon_sym___based] = ACTIONS(3719),
    [anon_sym___cdecl] = ACTIONS(3719),
    [anon_sym___clrcall] = ACTIONS(3719),
    [anon_sym___stdcall] = ACTIONS(3719),
    [anon_sym___fastcall] = ACTIONS(3719),
    [anon_sym___thiscall] = ACTIONS(3719),
    [anon_sym___vectorcall] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(3721),
    [anon_sym_signed] = ACTIONS(3719),
    [anon_sym_unsigned] = ACTIONS(3719),
    [anon_sym_long] = ACTIONS(3719),
    [anon_sym_short] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_static] = ACTIONS(3719),
    [anon_sym_register] = ACTIONS(3719),
    [anon_sym_inline] = ACTIONS(3719),
    [anon_sym___inline] = ACTIONS(3719),
    [anon_sym___inline__] = ACTIONS(3719),
    [anon_sym___forceinline] = ACTIONS(3719),
    [anon_sym_thread_local] = ACTIONS(3719),
    [anon_sym___thread] = ACTIONS(3719),
    [anon_sym_const] = ACTIONS(3719),
    [anon_sym_constexpr] = ACTIONS(3719),
    [anon_sym_volatile] = ACTIONS(3719),
    [anon_sym_restrict] = ACTIONS(3719),
    [anon_sym___restrict__] = ACTIONS(3719),
    [anon_sym__Atomic] = ACTIONS(3719),
    [anon_sym__Noreturn] = ACTIONS(3719),
    [anon_sym_noreturn] = ACTIONS(3719),
    [anon_sym__Nonnull] = ACTIONS(3719),
    [anon_sym_mutable] = ACTIONS(3719),
    [anon_sym_constinit] = ACTIONS(3719),
    [anon_sym_consteval] = ACTIONS(3719),
    [anon_sym_alignas] = ACTIONS(3719),
    [anon_sym__Alignas] = ACTIONS(3719),
    [sym_primitive_type] = ACTIONS(3719),
    [anon_sym_enum] = ACTIONS(3719),
    [anon_sym_class] = ACTIONS(3719),
    [anon_sym_struct] = ACTIONS(3719),
    [anon_sym_union] = ACTIONS(3719),
    [anon_sym_if] = ACTIONS(3719),
    [anon_sym_switch] = ACTIONS(3719),
    [anon_sym_case] = ACTIONS(3719),
    [anon_sym_default] = ACTIONS(3719),
    [anon_sym_while] = ACTIONS(3719),
    [anon_sym_do] = ACTIONS(3719),
    [anon_sym_for] = ACTIONS(3719),
    [anon_sym_return] = ACTIONS(3719),
    [anon_sym_break] = ACTIONS(3719),
    [anon_sym_continue] = ACTIONS(3719),
    [anon_sym_goto] = ACTIONS(3719),
    [anon_sym_not] = ACTIONS(3719),
    [anon_sym_compl] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3721),
    [anon_sym_sizeof] = ACTIONS(3719),
    [anon_sym___alignof__] = ACTIONS(3719),
    [anon_sym___alignof] = ACTIONS(3719),
    [anon_sym__alignof] = ACTIONS(3719),
    [anon_sym_alignof] = ACTIONS(3719),
    [anon_sym__Alignof] = ACTIONS(3719),
    [anon_sym_offsetof] = ACTIONS(3719),
    [anon_sym__Generic] = ACTIONS(3719),
    [anon_sym_asm] = ACTIONS(3719),
    [anon_sym___asm__] = ACTIONS(3719),
    [anon_sym___asm] = ACTIONS(3719),
    [sym_number_literal] = ACTIONS(3721),
    [anon_sym_L_SQUOTE] = ACTIONS(3721),
    [anon_sym_u_SQUOTE] = ACTIONS(3721),
    [anon_sym_U_SQUOTE] = ACTIONS(3721),
    [anon_sym_u8_SQUOTE] = ACTIONS(3721),
    [anon_sym_SQUOTE] = ACTIONS(3721),
    [anon_sym_L_DQUOTE] = ACTIONS(3721),
    [anon_sym_u_DQUOTE] = ACTIONS(3721),
    [anon_sym_U_DQUOTE] = ACTIONS(3721),
    [anon_sym_u8_DQUOTE] = ACTIONS(3721),
    [anon_sym_DQUOTE] = ACTIONS(3721),
    [sym_true] = ACTIONS(3719),
    [sym_false] = ACTIONS(3719),
    [anon_sym_NULL] = ACTIONS(3719),
    [anon_sym_nullptr] = ACTIONS(3719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3719),
    [anon_sym_let] = ACTIONS(3719),
    [anon_sym_This] = ACTIONS(3719),
    [anon_sym_decltype] = ACTIONS(3719),
    [anon_sym_explicit] = ACTIONS(3719),
    [anon_sym_typename] = ACTIONS(3719),
    [anon_sym_export] = ACTIONS(3719),
    [anon_sym_module] = ACTIONS(3719),
    [anon_sym_import] = ACTIONS(3719),
    [anon_sym_template] = ACTIONS(3719),
    [anon_sym_operator] = ACTIONS(3719),
    [anon_sym_try] = ACTIONS(3719),
    [anon_sym_delete] = ACTIONS(3719),
    [anon_sym_throw] = ACTIONS(3719),
    [anon_sym_namespace] = ACTIONS(3719),
    [anon_sym_static_assert] = ACTIONS(3719),
    [anon_sym_concept] = ACTIONS(3719),
    [anon_sym_co_return] = ACTIONS(3719),
    [anon_sym_co_yield] = ACTIONS(3719),
    [anon_sym_R_DQUOTE] = ACTIONS(3721),
    [anon_sym_LR_DQUOTE] = ACTIONS(3721),
    [anon_sym_uR_DQUOTE] = ACTIONS(3721),
    [anon_sym_UR_DQUOTE] = ACTIONS(3721),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3721),
    [anon_sym_co_await] = ACTIONS(3719),
    [anon_sym_new] = ACTIONS(3719),
    [anon_sym_requires] = ACTIONS(3719),
    [sym_this] = ACTIONS(3719),
    [anon_sym_precise] = ACTIONS(3719),
    [anon_sym_shared] = ACTIONS(3719),
    [anon_sym_groupshared] = ACTIONS(3719),
    [anon_sym_uniform] = ACTIONS(3719),
    [anon_sym_row_major] = ACTIONS(3719),
    [anon_sym_column_major] = ACTIONS(3719),
    [anon_sym_globallycoherent] = ACTIONS(3719),
    [anon_sym_centroid] = ACTIONS(3719),
    [anon_sym_noperspective] = ACTIONS(3719),
    [anon_sym_nointerpolation] = ACTIONS(3719),
    [anon_sym_sample] = ACTIONS(3719),
    [anon_sym_linear] = ACTIONS(3719),
    [anon_sym_snorm] = ACTIONS(3719),
    [anon_sym_unorm] = ACTIONS(3719),
    [anon_sym_point] = ACTIONS(3719),
    [anon_sym_line] = ACTIONS(3719),
    [anon_sym_triangleadj] = ACTIONS(3719),
    [anon_sym_lineadj] = ACTIONS(3719),
    [anon_sym_triangle] = ACTIONS(3719),
    [anon_sym_interface] = ACTIONS(3719),
    [anon_sym_extension] = ACTIONS(3719),
    [anon_sym___exported] = ACTIONS(3719),
  },
  [1018] = {
    [sym_identifier] = ACTIONS(3983),
    [aux_sym_preproc_include_token1] = ACTIONS(3983),
    [aux_sym_preproc_def_token1] = ACTIONS(3983),
    [aux_sym_preproc_if_token1] = ACTIONS(3983),
    [aux_sym_preproc_if_token2] = ACTIONS(3983),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3983),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3983),
    [sym_preproc_directive] = ACTIONS(3983),
    [anon_sym_LPAREN2] = ACTIONS(3985),
    [anon_sym_BANG] = ACTIONS(3985),
    [anon_sym_TILDE] = ACTIONS(3985),
    [anon_sym_DASH] = ACTIONS(3983),
    [anon_sym_PLUS] = ACTIONS(3983),
    [anon_sym_STAR] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3983),
    [anon_sym_SEMI] = ACTIONS(3985),
    [anon_sym___extension__] = ACTIONS(3983),
    [anon_sym_typedef] = ACTIONS(3983),
    [anon_sym_in] = ACTIONS(3983),
    [anon_sym_out] = ACTIONS(3983),
    [anon_sym_inout] = ACTIONS(3983),
    [anon_sym_virtual] = ACTIONS(3983),
    [anon_sym_extern] = ACTIONS(3983),
    [anon_sym___attribute__] = ACTIONS(3983),
    [anon_sym___attribute] = ACTIONS(3983),
    [anon_sym_using] = ACTIONS(3983),
    [anon_sym_COLON_COLON] = ACTIONS(3985),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3985),
    [anon_sym___declspec] = ACTIONS(3983),
    [anon_sym___based] = ACTIONS(3983),
    [anon_sym___cdecl] = ACTIONS(3983),
    [anon_sym___clrcall] = ACTIONS(3983),
    [anon_sym___stdcall] = ACTIONS(3983),
    [anon_sym___fastcall] = ACTIONS(3983),
    [anon_sym___thiscall] = ACTIONS(3983),
    [anon_sym___vectorcall] = ACTIONS(3983),
    [anon_sym_LBRACE] = ACTIONS(3985),
    [anon_sym_signed] = ACTIONS(3983),
    [anon_sym_unsigned] = ACTIONS(3983),
    [anon_sym_long] = ACTIONS(3983),
    [anon_sym_short] = ACTIONS(3983),
    [anon_sym_LBRACK] = ACTIONS(3983),
    [anon_sym_static] = ACTIONS(3983),
    [anon_sym_register] = ACTIONS(3983),
    [anon_sym_inline] = ACTIONS(3983),
    [anon_sym___inline] = ACTIONS(3983),
    [anon_sym___inline__] = ACTIONS(3983),
    [anon_sym___forceinline] = ACTIONS(3983),
    [anon_sym_thread_local] = ACTIONS(3983),
    [anon_sym___thread] = ACTIONS(3983),
    [anon_sym_const] = ACTIONS(3983),
    [anon_sym_constexpr] = ACTIONS(3983),
    [anon_sym_volatile] = ACTIONS(3983),
    [anon_sym_restrict] = ACTIONS(3983),
    [anon_sym___restrict__] = ACTIONS(3983),
    [anon_sym__Atomic] = ACTIONS(3983),
    [anon_sym__Noreturn] = ACTIONS(3983),
    [anon_sym_noreturn] = ACTIONS(3983),
    [anon_sym__Nonnull] = ACTIONS(3983),
    [anon_sym_mutable] = ACTIONS(3983),
    [anon_sym_constinit] = ACTIONS(3983),
    [anon_sym_consteval] = ACTIONS(3983),
    [anon_sym_alignas] = ACTIONS(3983),
    [anon_sym__Alignas] = ACTIONS(3983),
    [sym_primitive_type] = ACTIONS(3983),
    [anon_sym_enum] = ACTIONS(3983),
    [anon_sym_class] = ACTIONS(3983),
    [anon_sym_struct] = ACTIONS(3983),
    [anon_sym_union] = ACTIONS(3983),
    [anon_sym_if] = ACTIONS(3983),
    [anon_sym_switch] = ACTIONS(3983),
    [anon_sym_case] = ACTIONS(3983),
    [anon_sym_default] = ACTIONS(3983),
    [anon_sym_while] = ACTIONS(3983),
    [anon_sym_do] = ACTIONS(3983),
    [anon_sym_for] = ACTIONS(3983),
    [anon_sym_return] = ACTIONS(3983),
    [anon_sym_break] = ACTIONS(3983),
    [anon_sym_continue] = ACTIONS(3983),
    [anon_sym_goto] = ACTIONS(3983),
    [anon_sym___try] = ACTIONS(3983),
    [anon_sym___leave] = ACTIONS(3983),
    [anon_sym_not] = ACTIONS(3983),
    [anon_sym_compl] = ACTIONS(3983),
    [anon_sym_DASH_DASH] = ACTIONS(3985),
    [anon_sym_PLUS_PLUS] = ACTIONS(3985),
    [anon_sym_sizeof] = ACTIONS(3983),
    [anon_sym___alignof__] = ACTIONS(3983),
    [anon_sym___alignof] = ACTIONS(3983),
    [anon_sym__alignof] = ACTIONS(3983),
    [anon_sym_alignof] = ACTIONS(3983),
    [anon_sym__Alignof] = ACTIONS(3983),
    [anon_sym_offsetof] = ACTIONS(3983),
    [anon_sym__Generic] = ACTIONS(3983),
    [anon_sym_asm] = ACTIONS(3983),
    [anon_sym___asm__] = ACTIONS(3983),
    [anon_sym___asm] = ACTIONS(3983),
    [sym_number_literal] = ACTIONS(3985),
    [anon_sym_L_SQUOTE] = ACTIONS(3985),
    [anon_sym_u_SQUOTE] = ACTIONS(3985),
    [anon_sym_U_SQUOTE] = ACTIONS(3985),
    [anon_sym_u8_SQUOTE] = ACTIONS(3985),
    [anon_sym_SQUOTE] = ACTIONS(3985),
    [anon_sym_L_DQUOTE] = ACTIONS(3985),
    [anon_sym_u_DQUOTE] = ACTIONS(3985),
    [anon_sym_U_DQUOTE] = ACTIONS(3985),
    [anon_sym_u8_DQUOTE] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [sym_true] = ACTIONS(3983),
    [sym_false] = ACTIONS(3983),
    [anon_sym_NULL] = ACTIONS(3983),
    [anon_sym_nullptr] = ACTIONS(3983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3983),
    [anon_sym_let] = ACTIONS(3983),
    [anon_sym_This] = ACTIONS(3983),
    [anon_sym_decltype] = ACTIONS(3983),
    [anon_sym_explicit] = ACTIONS(3983),
    [anon_sym_typename] = ACTIONS(3983),
    [anon_sym_template] = ACTIONS(3983),
    [anon_sym_operator] = ACTIONS(3983),
    [anon_sym_try] = ACTIONS(3983),
    [anon_sym_delete] = ACTIONS(3983),
    [anon_sym_throw] = ACTIONS(3983),
    [anon_sym_namespace] = ACTIONS(3983),
    [anon_sym_static_assert] = ACTIONS(3983),
    [anon_sym_concept] = ACTIONS(3983),
    [anon_sym_co_return] = ACTIONS(3983),
    [anon_sym_co_yield] = ACTIONS(3983),
    [anon_sym_R_DQUOTE] = ACTIONS(3985),
    [anon_sym_LR_DQUOTE] = ACTIONS(3985),
    [anon_sym_uR_DQUOTE] = ACTIONS(3985),
    [anon_sym_UR_DQUOTE] = ACTIONS(3985),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3985),
    [anon_sym_co_await] = ACTIONS(3983),
    [anon_sym_new] = ACTIONS(3983),
    [anon_sym_requires] = ACTIONS(3983),
    [sym_this] = ACTIONS(3983),
    [anon_sym_discard] = ACTIONS(3983),
    [anon_sym_precise] = ACTIONS(3983),
    [anon_sym_shared] = ACTIONS(3983),
    [anon_sym_groupshared] = ACTIONS(3983),
    [anon_sym_uniform] = ACTIONS(3983),
    [anon_sym_row_major] = ACTIONS(3983),
    [anon_sym_column_major] = ACTIONS(3983),
    [anon_sym_globallycoherent] = ACTIONS(3983),
    [anon_sym_centroid] = ACTIONS(3983),
    [anon_sym_noperspective] = ACTIONS(3983),
    [anon_sym_nointerpolation] = ACTIONS(3983),
    [anon_sym_sample] = ACTIONS(3983),
    [anon_sym_linear] = ACTIONS(3983),
    [anon_sym_snorm] = ACTIONS(3983),
    [anon_sym_unorm] = ACTIONS(3983),
    [anon_sym_point] = ACTIONS(3983),
    [anon_sym_line] = ACTIONS(3983),
    [anon_sym_triangleadj] = ACTIONS(3983),
    [anon_sym_lineadj] = ACTIONS(3983),
    [anon_sym_triangle] = ACTIONS(3983),
    [anon_sym_cbuffer] = ACTIONS(3983),
    [anon_sym_interface] = ACTIONS(3983),
    [anon_sym_extension] = ACTIONS(3983),
  },
  [1019] = {
    [ts_builtin_sym_end] = ACTIONS(3725),
    [sym_identifier] = ACTIONS(3723),
    [aux_sym_preproc_include_token1] = ACTIONS(3723),
    [aux_sym_preproc_def_token1] = ACTIONS(3723),
    [aux_sym_preproc_if_token1] = ACTIONS(3723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3723),
    [sym_preproc_directive] = ACTIONS(3723),
    [anon_sym_LPAREN2] = ACTIONS(3725),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(3725),
    [anon_sym_AMP_AMP] = ACTIONS(3725),
    [anon_sym_AMP] = ACTIONS(3723),
    [anon_sym_SEMI] = ACTIONS(3725),
    [anon_sym___extension__] = ACTIONS(3723),
    [anon_sym_typedef] = ACTIONS(3723),
    [anon_sym_in] = ACTIONS(3723),
    [anon_sym_out] = ACTIONS(3723),
    [anon_sym_inout] = ACTIONS(3723),
    [anon_sym_virtual] = ACTIONS(3723),
    [anon_sym_extern] = ACTIONS(3723),
    [anon_sym___attribute__] = ACTIONS(3723),
    [anon_sym___attribute] = ACTIONS(3723),
    [anon_sym_using] = ACTIONS(3723),
    [anon_sym_COLON_COLON] = ACTIONS(3725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3725),
    [anon_sym___declspec] = ACTIONS(3723),
    [anon_sym___based] = ACTIONS(3723),
    [anon_sym___cdecl] = ACTIONS(3723),
    [anon_sym___clrcall] = ACTIONS(3723),
    [anon_sym___stdcall] = ACTIONS(3723),
    [anon_sym___fastcall] = ACTIONS(3723),
    [anon_sym___thiscall] = ACTIONS(3723),
    [anon_sym___vectorcall] = ACTIONS(3723),
    [anon_sym_LBRACE] = ACTIONS(3725),
    [anon_sym_signed] = ACTIONS(3723),
    [anon_sym_unsigned] = ACTIONS(3723),
    [anon_sym_long] = ACTIONS(3723),
    [anon_sym_short] = ACTIONS(3723),
    [anon_sym_LBRACK] = ACTIONS(3723),
    [anon_sym_static] = ACTIONS(3723),
    [anon_sym_register] = ACTIONS(3723),
    [anon_sym_inline] = ACTIONS(3723),
    [anon_sym___inline] = ACTIONS(3723),
    [anon_sym___inline__] = ACTIONS(3723),
    [anon_sym___forceinline] = ACTIONS(3723),
    [anon_sym_thread_local] = ACTIONS(3723),
    [anon_sym___thread] = ACTIONS(3723),
    [anon_sym_const] = ACTIONS(3723),
    [anon_sym_constexpr] = ACTIONS(3723),
    [anon_sym_volatile] = ACTIONS(3723),
    [anon_sym_restrict] = ACTIONS(3723),
    [anon_sym___restrict__] = ACTIONS(3723),
    [anon_sym__Atomic] = ACTIONS(3723),
    [anon_sym__Noreturn] = ACTIONS(3723),
    [anon_sym_noreturn] = ACTIONS(3723),
    [anon_sym__Nonnull] = ACTIONS(3723),
    [anon_sym_mutable] = ACTIONS(3723),
    [anon_sym_constinit] = ACTIONS(3723),
    [anon_sym_consteval] = ACTIONS(3723),
    [anon_sym_alignas] = ACTIONS(3723),
    [anon_sym__Alignas] = ACTIONS(3723),
    [sym_primitive_type] = ACTIONS(3723),
    [anon_sym_enum] = ACTIONS(3723),
    [anon_sym_class] = ACTIONS(3723),
    [anon_sym_struct] = ACTIONS(3723),
    [anon_sym_union] = ACTIONS(3723),
    [anon_sym_if] = ACTIONS(3723),
    [anon_sym_switch] = ACTIONS(3723),
    [anon_sym_case] = ACTIONS(3723),
    [anon_sym_default] = ACTIONS(3723),
    [anon_sym_while] = ACTIONS(3723),
    [anon_sym_do] = ACTIONS(3723),
    [anon_sym_for] = ACTIONS(3723),
    [anon_sym_return] = ACTIONS(3723),
    [anon_sym_break] = ACTIONS(3723),
    [anon_sym_continue] = ACTIONS(3723),
    [anon_sym_goto] = ACTIONS(3723),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(3725),
    [anon_sym_PLUS_PLUS] = ACTIONS(3725),
    [anon_sym_sizeof] = ACTIONS(3723),
    [anon_sym___alignof__] = ACTIONS(3723),
    [anon_sym___alignof] = ACTIONS(3723),
    [anon_sym__alignof] = ACTIONS(3723),
    [anon_sym_alignof] = ACTIONS(3723),
    [anon_sym__Alignof] = ACTIONS(3723),
    [anon_sym_offsetof] = ACTIONS(3723),
    [anon_sym__Generic] = ACTIONS(3723),
    [anon_sym_asm] = ACTIONS(3723),
    [anon_sym___asm__] = ACTIONS(3723),
    [anon_sym___asm] = ACTIONS(3723),
    [sym_number_literal] = ACTIONS(3725),
    [anon_sym_L_SQUOTE] = ACTIONS(3725),
    [anon_sym_u_SQUOTE] = ACTIONS(3725),
    [anon_sym_U_SQUOTE] = ACTIONS(3725),
    [anon_sym_u8_SQUOTE] = ACTIONS(3725),
    [anon_sym_SQUOTE] = ACTIONS(3725),
    [anon_sym_L_DQUOTE] = ACTIONS(3725),
    [anon_sym_u_DQUOTE] = ACTIONS(3725),
    [anon_sym_U_DQUOTE] = ACTIONS(3725),
    [anon_sym_u8_DQUOTE] = ACTIONS(3725),
    [anon_sym_DQUOTE] = ACTIONS(3725),
    [sym_true] = ACTIONS(3723),
    [sym_false] = ACTIONS(3723),
    [anon_sym_NULL] = ACTIONS(3723),
    [anon_sym_nullptr] = ACTIONS(3723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3723),
    [anon_sym_let] = ACTIONS(3723),
    [anon_sym_This] = ACTIONS(3723),
    [anon_sym_decltype] = ACTIONS(3723),
    [anon_sym_explicit] = ACTIONS(3723),
    [anon_sym_typename] = ACTIONS(3723),
    [anon_sym_export] = ACTIONS(3723),
    [anon_sym_module] = ACTIONS(3723),
    [anon_sym_import] = ACTIONS(3723),
    [anon_sym_template] = ACTIONS(3723),
    [anon_sym_operator] = ACTIONS(3723),
    [anon_sym_try] = ACTIONS(3723),
    [anon_sym_delete] = ACTIONS(3723),
    [anon_sym_throw] = ACTIONS(3723),
    [anon_sym_namespace] = ACTIONS(3723),
    [anon_sym_static_assert] = ACTIONS(3723),
    [anon_sym_concept] = ACTIONS(3723),
    [anon_sym_co_return] = ACTIONS(3723),
    [anon_sym_co_yield] = ACTIONS(3723),
    [anon_sym_R_DQUOTE] = ACTIONS(3725),
    [anon_sym_LR_DQUOTE] = ACTIONS(3725),
    [anon_sym_uR_DQUOTE] = ACTIONS(3725),
    [anon_sym_UR_DQUOTE] = ACTIONS(3725),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3725),
    [anon_sym_co_await] = ACTIONS(3723),
    [anon_sym_new] = ACTIONS(3723),
    [anon_sym_requires] = ACTIONS(3723),
    [sym_this] = ACTIONS(3723),
    [anon_sym_precise] = ACTIONS(3723),
    [anon_sym_shared] = ACTIONS(3723),
    [anon_sym_groupshared] = ACTIONS(3723),
    [anon_sym_uniform] = ACTIONS(3723),
    [anon_sym_row_major] = ACTIONS(3723),
    [anon_sym_column_major] = ACTIONS(3723),
    [anon_sym_globallycoherent] = ACTIONS(3723),
    [anon_sym_centroid] = ACTIONS(3723),
    [anon_sym_noperspective] = ACTIONS(3723),
    [anon_sym_nointerpolation] = ACTIONS(3723),
    [anon_sym_sample] = ACTIONS(3723),
    [anon_sym_linear] = ACTIONS(3723),
    [anon_sym_snorm] = ACTIONS(3723),
    [anon_sym_unorm] = ACTIONS(3723),
    [anon_sym_point] = ACTIONS(3723),
    [anon_sym_line] = ACTIONS(3723),
    [anon_sym_triangleadj] = ACTIONS(3723),
    [anon_sym_lineadj] = ACTIONS(3723),
    [anon_sym_triangle] = ACTIONS(3723),
    [anon_sym_interface] = ACTIONS(3723),
    [anon_sym_extension] = ACTIONS(3723),
    [anon_sym___exported] = ACTIONS(3723),
  },
  [1020] = {
    [ts_builtin_sym_end] = ACTIONS(3729),
    [sym_identifier] = ACTIONS(3727),
    [aux_sym_preproc_include_token1] = ACTIONS(3727),
    [aux_sym_preproc_def_token1] = ACTIONS(3727),
    [aux_sym_preproc_if_token1] = ACTIONS(3727),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3727),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3727),
    [sym_preproc_directive] = ACTIONS(3727),
    [anon_sym_LPAREN2] = ACTIONS(3729),
    [anon_sym_BANG] = ACTIONS(3729),
    [anon_sym_TILDE] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3727),
    [anon_sym_PLUS] = ACTIONS(3727),
    [anon_sym_STAR] = ACTIONS(3729),
    [anon_sym_AMP_AMP] = ACTIONS(3729),
    [anon_sym_AMP] = ACTIONS(3727),
    [anon_sym_SEMI] = ACTIONS(3729),
    [anon_sym___extension__] = ACTIONS(3727),
    [anon_sym_typedef] = ACTIONS(3727),
    [anon_sym_in] = ACTIONS(3727),
    [anon_sym_out] = ACTIONS(3727),
    [anon_sym_inout] = ACTIONS(3727),
    [anon_sym_virtual] = ACTIONS(3727),
    [anon_sym_extern] = ACTIONS(3727),
    [anon_sym___attribute__] = ACTIONS(3727),
    [anon_sym___attribute] = ACTIONS(3727),
    [anon_sym_using] = ACTIONS(3727),
    [anon_sym_COLON_COLON] = ACTIONS(3729),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3729),
    [anon_sym___declspec] = ACTIONS(3727),
    [anon_sym___based] = ACTIONS(3727),
    [anon_sym___cdecl] = ACTIONS(3727),
    [anon_sym___clrcall] = ACTIONS(3727),
    [anon_sym___stdcall] = ACTIONS(3727),
    [anon_sym___fastcall] = ACTIONS(3727),
    [anon_sym___thiscall] = ACTIONS(3727),
    [anon_sym___vectorcall] = ACTIONS(3727),
    [anon_sym_LBRACE] = ACTIONS(3729),
    [anon_sym_signed] = ACTIONS(3727),
    [anon_sym_unsigned] = ACTIONS(3727),
    [anon_sym_long] = ACTIONS(3727),
    [anon_sym_short] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(3727),
    [anon_sym_static] = ACTIONS(3727),
    [anon_sym_register] = ACTIONS(3727),
    [anon_sym_inline] = ACTIONS(3727),
    [anon_sym___inline] = ACTIONS(3727),
    [anon_sym___inline__] = ACTIONS(3727),
    [anon_sym___forceinline] = ACTIONS(3727),
    [anon_sym_thread_local] = ACTIONS(3727),
    [anon_sym___thread] = ACTIONS(3727),
    [anon_sym_const] = ACTIONS(3727),
    [anon_sym_constexpr] = ACTIONS(3727),
    [anon_sym_volatile] = ACTIONS(3727),
    [anon_sym_restrict] = ACTIONS(3727),
    [anon_sym___restrict__] = ACTIONS(3727),
    [anon_sym__Atomic] = ACTIONS(3727),
    [anon_sym__Noreturn] = ACTIONS(3727),
    [anon_sym_noreturn] = ACTIONS(3727),
    [anon_sym__Nonnull] = ACTIONS(3727),
    [anon_sym_mutable] = ACTIONS(3727),
    [anon_sym_constinit] = ACTIONS(3727),
    [anon_sym_consteval] = ACTIONS(3727),
    [anon_sym_alignas] = ACTIONS(3727),
    [anon_sym__Alignas] = ACTIONS(3727),
    [sym_primitive_type] = ACTIONS(3727),
    [anon_sym_enum] = ACTIONS(3727),
    [anon_sym_class] = ACTIONS(3727),
    [anon_sym_struct] = ACTIONS(3727),
    [anon_sym_union] = ACTIONS(3727),
    [anon_sym_if] = ACTIONS(3727),
    [anon_sym_switch] = ACTIONS(3727),
    [anon_sym_case] = ACTIONS(3727),
    [anon_sym_default] = ACTIONS(3727),
    [anon_sym_while] = ACTIONS(3727),
    [anon_sym_do] = ACTIONS(3727),
    [anon_sym_for] = ACTIONS(3727),
    [anon_sym_return] = ACTIONS(3727),
    [anon_sym_break] = ACTIONS(3727),
    [anon_sym_continue] = ACTIONS(3727),
    [anon_sym_goto] = ACTIONS(3727),
    [anon_sym_not] = ACTIONS(3727),
    [anon_sym_compl] = ACTIONS(3727),
    [anon_sym_DASH_DASH] = ACTIONS(3729),
    [anon_sym_PLUS_PLUS] = ACTIONS(3729),
    [anon_sym_sizeof] = ACTIONS(3727),
    [anon_sym___alignof__] = ACTIONS(3727),
    [anon_sym___alignof] = ACTIONS(3727),
    [anon_sym__alignof] = ACTIONS(3727),
    [anon_sym_alignof] = ACTIONS(3727),
    [anon_sym__Alignof] = ACTIONS(3727),
    [anon_sym_offsetof] = ACTIONS(3727),
    [anon_sym__Generic] = ACTIONS(3727),
    [anon_sym_asm] = ACTIONS(3727),
    [anon_sym___asm__] = ACTIONS(3727),
    [anon_sym___asm] = ACTIONS(3727),
    [sym_number_literal] = ACTIONS(3729),
    [anon_sym_L_SQUOTE] = ACTIONS(3729),
    [anon_sym_u_SQUOTE] = ACTIONS(3729),
    [anon_sym_U_SQUOTE] = ACTIONS(3729),
    [anon_sym_u8_SQUOTE] = ACTIONS(3729),
    [anon_sym_SQUOTE] = ACTIONS(3729),
    [anon_sym_L_DQUOTE] = ACTIONS(3729),
    [anon_sym_u_DQUOTE] = ACTIONS(3729),
    [anon_sym_U_DQUOTE] = ACTIONS(3729),
    [anon_sym_u8_DQUOTE] = ACTIONS(3729),
    [anon_sym_DQUOTE] = ACTIONS(3729),
    [sym_true] = ACTIONS(3727),
    [sym_false] = ACTIONS(3727),
    [anon_sym_NULL] = ACTIONS(3727),
    [anon_sym_nullptr] = ACTIONS(3727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3727),
    [anon_sym_let] = ACTIONS(3727),
    [anon_sym_This] = ACTIONS(3727),
    [anon_sym_decltype] = ACTIONS(3727),
    [anon_sym_explicit] = ACTIONS(3727),
    [anon_sym_typename] = ACTIONS(3727),
    [anon_sym_export] = ACTIONS(3727),
    [anon_sym_module] = ACTIONS(3727),
    [anon_sym_import] = ACTIONS(3727),
    [anon_sym_template] = ACTIONS(3727),
    [anon_sym_operator] = ACTIONS(3727),
    [anon_sym_try] = ACTIONS(3727),
    [anon_sym_delete] = ACTIONS(3727),
    [anon_sym_throw] = ACTIONS(3727),
    [anon_sym_namespace] = ACTIONS(3727),
    [anon_sym_static_assert] = ACTIONS(3727),
    [anon_sym_concept] = ACTIONS(3727),
    [anon_sym_co_return] = ACTIONS(3727),
    [anon_sym_co_yield] = ACTIONS(3727),
    [anon_sym_R_DQUOTE] = ACTIONS(3729),
    [anon_sym_LR_DQUOTE] = ACTIONS(3729),
    [anon_sym_uR_DQUOTE] = ACTIONS(3729),
    [anon_sym_UR_DQUOTE] = ACTIONS(3729),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3729),
    [anon_sym_co_await] = ACTIONS(3727),
    [anon_sym_new] = ACTIONS(3727),
    [anon_sym_requires] = ACTIONS(3727),
    [sym_this] = ACTIONS(3727),
    [anon_sym_precise] = ACTIONS(3727),
    [anon_sym_shared] = ACTIONS(3727),
    [anon_sym_groupshared] = ACTIONS(3727),
    [anon_sym_uniform] = ACTIONS(3727),
    [anon_sym_row_major] = ACTIONS(3727),
    [anon_sym_column_major] = ACTIONS(3727),
    [anon_sym_globallycoherent] = ACTIONS(3727),
    [anon_sym_centroid] = ACTIONS(3727),
    [anon_sym_noperspective] = ACTIONS(3727),
    [anon_sym_nointerpolation] = ACTIONS(3727),
    [anon_sym_sample] = ACTIONS(3727),
    [anon_sym_linear] = ACTIONS(3727),
    [anon_sym_snorm] = ACTIONS(3727),
    [anon_sym_unorm] = ACTIONS(3727),
    [anon_sym_point] = ACTIONS(3727),
    [anon_sym_line] = ACTIONS(3727),
    [anon_sym_triangleadj] = ACTIONS(3727),
    [anon_sym_lineadj] = ACTIONS(3727),
    [anon_sym_triangle] = ACTIONS(3727),
    [anon_sym_interface] = ACTIONS(3727),
    [anon_sym_extension] = ACTIONS(3727),
    [anon_sym___exported] = ACTIONS(3727),
  },
  [1021] = {
    [ts_builtin_sym_end] = ACTIONS(3737),
    [sym_identifier] = ACTIONS(3735),
    [aux_sym_preproc_include_token1] = ACTIONS(3735),
    [aux_sym_preproc_def_token1] = ACTIONS(3735),
    [aux_sym_preproc_if_token1] = ACTIONS(3735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3735),
    [sym_preproc_directive] = ACTIONS(3735),
    [anon_sym_LPAREN2] = ACTIONS(3737),
    [anon_sym_BANG] = ACTIONS(3737),
    [anon_sym_TILDE] = ACTIONS(3737),
    [anon_sym_DASH] = ACTIONS(3735),
    [anon_sym_PLUS] = ACTIONS(3735),
    [anon_sym_STAR] = ACTIONS(3737),
    [anon_sym_AMP_AMP] = ACTIONS(3737),
    [anon_sym_AMP] = ACTIONS(3735),
    [anon_sym_SEMI] = ACTIONS(3737),
    [anon_sym___extension__] = ACTIONS(3735),
    [anon_sym_typedef] = ACTIONS(3735),
    [anon_sym_in] = ACTIONS(3735),
    [anon_sym_out] = ACTIONS(3735),
    [anon_sym_inout] = ACTIONS(3735),
    [anon_sym_virtual] = ACTIONS(3735),
    [anon_sym_extern] = ACTIONS(3735),
    [anon_sym___attribute__] = ACTIONS(3735),
    [anon_sym___attribute] = ACTIONS(3735),
    [anon_sym_using] = ACTIONS(3735),
    [anon_sym_COLON_COLON] = ACTIONS(3737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3737),
    [anon_sym___declspec] = ACTIONS(3735),
    [anon_sym___based] = ACTIONS(3735),
    [anon_sym___cdecl] = ACTIONS(3735),
    [anon_sym___clrcall] = ACTIONS(3735),
    [anon_sym___stdcall] = ACTIONS(3735),
    [anon_sym___fastcall] = ACTIONS(3735),
    [anon_sym___thiscall] = ACTIONS(3735),
    [anon_sym___vectorcall] = ACTIONS(3735),
    [anon_sym_LBRACE] = ACTIONS(3737),
    [anon_sym_signed] = ACTIONS(3735),
    [anon_sym_unsigned] = ACTIONS(3735),
    [anon_sym_long] = ACTIONS(3735),
    [anon_sym_short] = ACTIONS(3735),
    [anon_sym_LBRACK] = ACTIONS(3735),
    [anon_sym_static] = ACTIONS(3735),
    [anon_sym_register] = ACTIONS(3735),
    [anon_sym_inline] = ACTIONS(3735),
    [anon_sym___inline] = ACTIONS(3735),
    [anon_sym___inline__] = ACTIONS(3735),
    [anon_sym___forceinline] = ACTIONS(3735),
    [anon_sym_thread_local] = ACTIONS(3735),
    [anon_sym___thread] = ACTIONS(3735),
    [anon_sym_const] = ACTIONS(3735),
    [anon_sym_constexpr] = ACTIONS(3735),
    [anon_sym_volatile] = ACTIONS(3735),
    [anon_sym_restrict] = ACTIONS(3735),
    [anon_sym___restrict__] = ACTIONS(3735),
    [anon_sym__Atomic] = ACTIONS(3735),
    [anon_sym__Noreturn] = ACTIONS(3735),
    [anon_sym_noreturn] = ACTIONS(3735),
    [anon_sym__Nonnull] = ACTIONS(3735),
    [anon_sym_mutable] = ACTIONS(3735),
    [anon_sym_constinit] = ACTIONS(3735),
    [anon_sym_consteval] = ACTIONS(3735),
    [anon_sym_alignas] = ACTIONS(3735),
    [anon_sym__Alignas] = ACTIONS(3735),
    [sym_primitive_type] = ACTIONS(3735),
    [anon_sym_enum] = ACTIONS(3735),
    [anon_sym_class] = ACTIONS(3735),
    [anon_sym_struct] = ACTIONS(3735),
    [anon_sym_union] = ACTIONS(3735),
    [anon_sym_if] = ACTIONS(3735),
    [anon_sym_switch] = ACTIONS(3735),
    [anon_sym_case] = ACTIONS(3735),
    [anon_sym_default] = ACTIONS(3735),
    [anon_sym_while] = ACTIONS(3735),
    [anon_sym_do] = ACTIONS(3735),
    [anon_sym_for] = ACTIONS(3735),
    [anon_sym_return] = ACTIONS(3735),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_continue] = ACTIONS(3735),
    [anon_sym_goto] = ACTIONS(3735),
    [anon_sym_not] = ACTIONS(3735),
    [anon_sym_compl] = ACTIONS(3735),
    [anon_sym_DASH_DASH] = ACTIONS(3737),
    [anon_sym_PLUS_PLUS] = ACTIONS(3737),
    [anon_sym_sizeof] = ACTIONS(3735),
    [anon_sym___alignof__] = ACTIONS(3735),
    [anon_sym___alignof] = ACTIONS(3735),
    [anon_sym__alignof] = ACTIONS(3735),
    [anon_sym_alignof] = ACTIONS(3735),
    [anon_sym__Alignof] = ACTIONS(3735),
    [anon_sym_offsetof] = ACTIONS(3735),
    [anon_sym__Generic] = ACTIONS(3735),
    [anon_sym_asm] = ACTIONS(3735),
    [anon_sym___asm__] = ACTIONS(3735),
    [anon_sym___asm] = ACTIONS(3735),
    [sym_number_literal] = ACTIONS(3737),
    [anon_sym_L_SQUOTE] = ACTIONS(3737),
    [anon_sym_u_SQUOTE] = ACTIONS(3737),
    [anon_sym_U_SQUOTE] = ACTIONS(3737),
    [anon_sym_u8_SQUOTE] = ACTIONS(3737),
    [anon_sym_SQUOTE] = ACTIONS(3737),
    [anon_sym_L_DQUOTE] = ACTIONS(3737),
    [anon_sym_u_DQUOTE] = ACTIONS(3737),
    [anon_sym_U_DQUOTE] = ACTIONS(3737),
    [anon_sym_u8_DQUOTE] = ACTIONS(3737),
    [anon_sym_DQUOTE] = ACTIONS(3737),
    [sym_true] = ACTIONS(3735),
    [sym_false] = ACTIONS(3735),
    [anon_sym_NULL] = ACTIONS(3735),
    [anon_sym_nullptr] = ACTIONS(3735),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3735),
    [anon_sym_let] = ACTIONS(3735),
    [anon_sym_This] = ACTIONS(3735),
    [anon_sym_decltype] = ACTIONS(3735),
    [anon_sym_explicit] = ACTIONS(3735),
    [anon_sym_typename] = ACTIONS(3735),
    [anon_sym_export] = ACTIONS(3735),
    [anon_sym_module] = ACTIONS(3735),
    [anon_sym_import] = ACTIONS(3735),
    [anon_sym_template] = ACTIONS(3735),
    [anon_sym_operator] = ACTIONS(3735),
    [anon_sym_try] = ACTIONS(3735),
    [anon_sym_delete] = ACTIONS(3735),
    [anon_sym_throw] = ACTIONS(3735),
    [anon_sym_namespace] = ACTIONS(3735),
    [anon_sym_static_assert] = ACTIONS(3735),
    [anon_sym_concept] = ACTIONS(3735),
    [anon_sym_co_return] = ACTIONS(3735),
    [anon_sym_co_yield] = ACTIONS(3735),
    [anon_sym_R_DQUOTE] = ACTIONS(3737),
    [anon_sym_LR_DQUOTE] = ACTIONS(3737),
    [anon_sym_uR_DQUOTE] = ACTIONS(3737),
    [anon_sym_UR_DQUOTE] = ACTIONS(3737),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3737),
    [anon_sym_co_await] = ACTIONS(3735),
    [anon_sym_new] = ACTIONS(3735),
    [anon_sym_requires] = ACTIONS(3735),
    [sym_this] = ACTIONS(3735),
    [anon_sym_precise] = ACTIONS(3735),
    [anon_sym_shared] = ACTIONS(3735),
    [anon_sym_groupshared] = ACTIONS(3735),
    [anon_sym_uniform] = ACTIONS(3735),
    [anon_sym_row_major] = ACTIONS(3735),
    [anon_sym_column_major] = ACTIONS(3735),
    [anon_sym_globallycoherent] = ACTIONS(3735),
    [anon_sym_centroid] = ACTIONS(3735),
    [anon_sym_noperspective] = ACTIONS(3735),
    [anon_sym_nointerpolation] = ACTIONS(3735),
    [anon_sym_sample] = ACTIONS(3735),
    [anon_sym_linear] = ACTIONS(3735),
    [anon_sym_snorm] = ACTIONS(3735),
    [anon_sym_unorm] = ACTIONS(3735),
    [anon_sym_point] = ACTIONS(3735),
    [anon_sym_line] = ACTIONS(3735),
    [anon_sym_triangleadj] = ACTIONS(3735),
    [anon_sym_lineadj] = ACTIONS(3735),
    [anon_sym_triangle] = ACTIONS(3735),
    [anon_sym_interface] = ACTIONS(3735),
    [anon_sym_extension] = ACTIONS(3735),
    [anon_sym___exported] = ACTIONS(3735),
  },
  [1022] = {
    [ts_builtin_sym_end] = ACTIONS(4277),
    [sym_identifier] = ACTIONS(4279),
    [aux_sym_preproc_include_token1] = ACTIONS(4279),
    [aux_sym_preproc_def_token1] = ACTIONS(4279),
    [aux_sym_preproc_if_token1] = ACTIONS(4279),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4279),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4279),
    [sym_preproc_directive] = ACTIONS(4279),
    [anon_sym_LPAREN2] = ACTIONS(4277),
    [anon_sym_BANG] = ACTIONS(4277),
    [anon_sym_TILDE] = ACTIONS(4277),
    [anon_sym_DASH] = ACTIONS(4279),
    [anon_sym_PLUS] = ACTIONS(4279),
    [anon_sym_STAR] = ACTIONS(4277),
    [anon_sym_AMP_AMP] = ACTIONS(4277),
    [anon_sym_AMP] = ACTIONS(4279),
    [anon_sym_SEMI] = ACTIONS(4277),
    [anon_sym___extension__] = ACTIONS(4279),
    [anon_sym_typedef] = ACTIONS(4279),
    [anon_sym_in] = ACTIONS(4279),
    [anon_sym_out] = ACTIONS(4279),
    [anon_sym_inout] = ACTIONS(4279),
    [anon_sym_virtual] = ACTIONS(4279),
    [anon_sym_extern] = ACTIONS(4279),
    [anon_sym___attribute__] = ACTIONS(4279),
    [anon_sym___attribute] = ACTIONS(4279),
    [anon_sym_using] = ACTIONS(4279),
    [anon_sym_COLON_COLON] = ACTIONS(4277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4277),
    [anon_sym___declspec] = ACTIONS(4279),
    [anon_sym___based] = ACTIONS(4279),
    [anon_sym___cdecl] = ACTIONS(4279),
    [anon_sym___clrcall] = ACTIONS(4279),
    [anon_sym___stdcall] = ACTIONS(4279),
    [anon_sym___fastcall] = ACTIONS(4279),
    [anon_sym___thiscall] = ACTIONS(4279),
    [anon_sym___vectorcall] = ACTIONS(4279),
    [anon_sym_LBRACE] = ACTIONS(4277),
    [anon_sym_signed] = ACTIONS(4279),
    [anon_sym_unsigned] = ACTIONS(4279),
    [anon_sym_long] = ACTIONS(4279),
    [anon_sym_short] = ACTIONS(4279),
    [anon_sym_LBRACK] = ACTIONS(4279),
    [anon_sym_static] = ACTIONS(4279),
    [anon_sym_register] = ACTIONS(4279),
    [anon_sym_inline] = ACTIONS(4279),
    [anon_sym___inline] = ACTIONS(4279),
    [anon_sym___inline__] = ACTIONS(4279),
    [anon_sym___forceinline] = ACTIONS(4279),
    [anon_sym_thread_local] = ACTIONS(4279),
    [anon_sym___thread] = ACTIONS(4279),
    [anon_sym_const] = ACTIONS(4279),
    [anon_sym_constexpr] = ACTIONS(4279),
    [anon_sym_volatile] = ACTIONS(4279),
    [anon_sym_restrict] = ACTIONS(4279),
    [anon_sym___restrict__] = ACTIONS(4279),
    [anon_sym__Atomic] = ACTIONS(4279),
    [anon_sym__Noreturn] = ACTIONS(4279),
    [anon_sym_noreturn] = ACTIONS(4279),
    [anon_sym__Nonnull] = ACTIONS(4279),
    [anon_sym_mutable] = ACTIONS(4279),
    [anon_sym_constinit] = ACTIONS(4279),
    [anon_sym_consteval] = ACTIONS(4279),
    [anon_sym_alignas] = ACTIONS(4279),
    [anon_sym__Alignas] = ACTIONS(4279),
    [sym_primitive_type] = ACTIONS(4279),
    [anon_sym_enum] = ACTIONS(4279),
    [anon_sym_class] = ACTIONS(4279),
    [anon_sym_struct] = ACTIONS(4279),
    [anon_sym_union] = ACTIONS(4279),
    [anon_sym_if] = ACTIONS(4279),
    [anon_sym_switch] = ACTIONS(4279),
    [anon_sym_case] = ACTIONS(4279),
    [anon_sym_default] = ACTIONS(4279),
    [anon_sym_while] = ACTIONS(4279),
    [anon_sym_do] = ACTIONS(4279),
    [anon_sym_for] = ACTIONS(4279),
    [anon_sym_return] = ACTIONS(4279),
    [anon_sym_break] = ACTIONS(4279),
    [anon_sym_continue] = ACTIONS(4279),
    [anon_sym_goto] = ACTIONS(4279),
    [anon_sym_not] = ACTIONS(4279),
    [anon_sym_compl] = ACTIONS(4279),
    [anon_sym_DASH_DASH] = ACTIONS(4277),
    [anon_sym_PLUS_PLUS] = ACTIONS(4277),
    [anon_sym_sizeof] = ACTIONS(4279),
    [anon_sym___alignof__] = ACTIONS(4279),
    [anon_sym___alignof] = ACTIONS(4279),
    [anon_sym__alignof] = ACTIONS(4279),
    [anon_sym_alignof] = ACTIONS(4279),
    [anon_sym__Alignof] = ACTIONS(4279),
    [anon_sym_offsetof] = ACTIONS(4279),
    [anon_sym__Generic] = ACTIONS(4279),
    [anon_sym_asm] = ACTIONS(4279),
    [anon_sym___asm__] = ACTIONS(4279),
    [anon_sym___asm] = ACTIONS(4279),
    [sym_number_literal] = ACTIONS(4277),
    [anon_sym_L_SQUOTE] = ACTIONS(4277),
    [anon_sym_u_SQUOTE] = ACTIONS(4277),
    [anon_sym_U_SQUOTE] = ACTIONS(4277),
    [anon_sym_u8_SQUOTE] = ACTIONS(4277),
    [anon_sym_SQUOTE] = ACTIONS(4277),
    [anon_sym_L_DQUOTE] = ACTIONS(4277),
    [anon_sym_u_DQUOTE] = ACTIONS(4277),
    [anon_sym_U_DQUOTE] = ACTIONS(4277),
    [anon_sym_u8_DQUOTE] = ACTIONS(4277),
    [anon_sym_DQUOTE] = ACTIONS(4277),
    [sym_true] = ACTIONS(4279),
    [sym_false] = ACTIONS(4279),
    [anon_sym_NULL] = ACTIONS(4279),
    [anon_sym_nullptr] = ACTIONS(4279),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4279),
    [anon_sym_let] = ACTIONS(4279),
    [anon_sym_This] = ACTIONS(4279),
    [anon_sym_decltype] = ACTIONS(4279),
    [anon_sym_explicit] = ACTIONS(4279),
    [anon_sym_typename] = ACTIONS(4279),
    [anon_sym_export] = ACTIONS(4279),
    [anon_sym_module] = ACTIONS(4279),
    [anon_sym_import] = ACTIONS(4279),
    [anon_sym_template] = ACTIONS(4279),
    [anon_sym_operator] = ACTIONS(4279),
    [anon_sym_try] = ACTIONS(4279),
    [anon_sym_delete] = ACTIONS(4279),
    [anon_sym_throw] = ACTIONS(4279),
    [anon_sym_namespace] = ACTIONS(4279),
    [anon_sym_static_assert] = ACTIONS(4279),
    [anon_sym_concept] = ACTIONS(4279),
    [anon_sym_co_return] = ACTIONS(4279),
    [anon_sym_co_yield] = ACTIONS(4279),
    [anon_sym_R_DQUOTE] = ACTIONS(4277),
    [anon_sym_LR_DQUOTE] = ACTIONS(4277),
    [anon_sym_uR_DQUOTE] = ACTIONS(4277),
    [anon_sym_UR_DQUOTE] = ACTIONS(4277),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4277),
    [anon_sym_co_await] = ACTIONS(4279),
    [anon_sym_new] = ACTIONS(4279),
    [anon_sym_requires] = ACTIONS(4279),
    [sym_this] = ACTIONS(4279),
    [anon_sym_precise] = ACTIONS(4279),
    [anon_sym_shared] = ACTIONS(4279),
    [anon_sym_groupshared] = ACTIONS(4279),
    [anon_sym_uniform] = ACTIONS(4279),
    [anon_sym_row_major] = ACTIONS(4279),
    [anon_sym_column_major] = ACTIONS(4279),
    [anon_sym_globallycoherent] = ACTIONS(4279),
    [anon_sym_centroid] = ACTIONS(4279),
    [anon_sym_noperspective] = ACTIONS(4279),
    [anon_sym_nointerpolation] = ACTIONS(4279),
    [anon_sym_sample] = ACTIONS(4279),
    [anon_sym_linear] = ACTIONS(4279),
    [anon_sym_snorm] = ACTIONS(4279),
    [anon_sym_unorm] = ACTIONS(4279),
    [anon_sym_point] = ACTIONS(4279),
    [anon_sym_line] = ACTIONS(4279),
    [anon_sym_triangleadj] = ACTIONS(4279),
    [anon_sym_lineadj] = ACTIONS(4279),
    [anon_sym_triangle] = ACTIONS(4279),
    [anon_sym_interface] = ACTIONS(4279),
    [anon_sym_extension] = ACTIONS(4279),
    [anon_sym___exported] = ACTIONS(4279),
  },
  [1023] = {
    [ts_builtin_sym_end] = ACTIONS(4281),
    [sym_identifier] = ACTIONS(4283),
    [aux_sym_preproc_include_token1] = ACTIONS(4283),
    [aux_sym_preproc_def_token1] = ACTIONS(4283),
    [aux_sym_preproc_if_token1] = ACTIONS(4283),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4283),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4283),
    [sym_preproc_directive] = ACTIONS(4283),
    [anon_sym_LPAREN2] = ACTIONS(4281),
    [anon_sym_BANG] = ACTIONS(4281),
    [anon_sym_TILDE] = ACTIONS(4281),
    [anon_sym_DASH] = ACTIONS(4283),
    [anon_sym_PLUS] = ACTIONS(4283),
    [anon_sym_STAR] = ACTIONS(4281),
    [anon_sym_AMP_AMP] = ACTIONS(4281),
    [anon_sym_AMP] = ACTIONS(4283),
    [anon_sym_SEMI] = ACTIONS(4281),
    [anon_sym___extension__] = ACTIONS(4283),
    [anon_sym_typedef] = ACTIONS(4283),
    [anon_sym_in] = ACTIONS(4283),
    [anon_sym_out] = ACTIONS(4283),
    [anon_sym_inout] = ACTIONS(4283),
    [anon_sym_virtual] = ACTIONS(4283),
    [anon_sym_extern] = ACTIONS(4283),
    [anon_sym___attribute__] = ACTIONS(4283),
    [anon_sym___attribute] = ACTIONS(4283),
    [anon_sym_using] = ACTIONS(4283),
    [anon_sym_COLON_COLON] = ACTIONS(4281),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4281),
    [anon_sym___declspec] = ACTIONS(4283),
    [anon_sym___based] = ACTIONS(4283),
    [anon_sym___cdecl] = ACTIONS(4283),
    [anon_sym___clrcall] = ACTIONS(4283),
    [anon_sym___stdcall] = ACTIONS(4283),
    [anon_sym___fastcall] = ACTIONS(4283),
    [anon_sym___thiscall] = ACTIONS(4283),
    [anon_sym___vectorcall] = ACTIONS(4283),
    [anon_sym_LBRACE] = ACTIONS(4281),
    [anon_sym_signed] = ACTIONS(4283),
    [anon_sym_unsigned] = ACTIONS(4283),
    [anon_sym_long] = ACTIONS(4283),
    [anon_sym_short] = ACTIONS(4283),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_static] = ACTIONS(4283),
    [anon_sym_register] = ACTIONS(4283),
    [anon_sym_inline] = ACTIONS(4283),
    [anon_sym___inline] = ACTIONS(4283),
    [anon_sym___inline__] = ACTIONS(4283),
    [anon_sym___forceinline] = ACTIONS(4283),
    [anon_sym_thread_local] = ACTIONS(4283),
    [anon_sym___thread] = ACTIONS(4283),
    [anon_sym_const] = ACTIONS(4283),
    [anon_sym_constexpr] = ACTIONS(4283),
    [anon_sym_volatile] = ACTIONS(4283),
    [anon_sym_restrict] = ACTIONS(4283),
    [anon_sym___restrict__] = ACTIONS(4283),
    [anon_sym__Atomic] = ACTIONS(4283),
    [anon_sym__Noreturn] = ACTIONS(4283),
    [anon_sym_noreturn] = ACTIONS(4283),
    [anon_sym__Nonnull] = ACTIONS(4283),
    [anon_sym_mutable] = ACTIONS(4283),
    [anon_sym_constinit] = ACTIONS(4283),
    [anon_sym_consteval] = ACTIONS(4283),
    [anon_sym_alignas] = ACTIONS(4283),
    [anon_sym__Alignas] = ACTIONS(4283),
    [sym_primitive_type] = ACTIONS(4283),
    [anon_sym_enum] = ACTIONS(4283),
    [anon_sym_class] = ACTIONS(4283),
    [anon_sym_struct] = ACTIONS(4283),
    [anon_sym_union] = ACTIONS(4283),
    [anon_sym_if] = ACTIONS(4283),
    [anon_sym_switch] = ACTIONS(4283),
    [anon_sym_case] = ACTIONS(4283),
    [anon_sym_default] = ACTIONS(4283),
    [anon_sym_while] = ACTIONS(4283),
    [anon_sym_do] = ACTIONS(4283),
    [anon_sym_for] = ACTIONS(4283),
    [anon_sym_return] = ACTIONS(4283),
    [anon_sym_break] = ACTIONS(4283),
    [anon_sym_continue] = ACTIONS(4283),
    [anon_sym_goto] = ACTIONS(4283),
    [anon_sym_not] = ACTIONS(4283),
    [anon_sym_compl] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4281),
    [anon_sym_PLUS_PLUS] = ACTIONS(4281),
    [anon_sym_sizeof] = ACTIONS(4283),
    [anon_sym___alignof__] = ACTIONS(4283),
    [anon_sym___alignof] = ACTIONS(4283),
    [anon_sym__alignof] = ACTIONS(4283),
    [anon_sym_alignof] = ACTIONS(4283),
    [anon_sym__Alignof] = ACTIONS(4283),
    [anon_sym_offsetof] = ACTIONS(4283),
    [anon_sym__Generic] = ACTIONS(4283),
    [anon_sym_asm] = ACTIONS(4283),
    [anon_sym___asm__] = ACTIONS(4283),
    [anon_sym___asm] = ACTIONS(4283),
    [sym_number_literal] = ACTIONS(4281),
    [anon_sym_L_SQUOTE] = ACTIONS(4281),
    [anon_sym_u_SQUOTE] = ACTIONS(4281),
    [anon_sym_U_SQUOTE] = ACTIONS(4281),
    [anon_sym_u8_SQUOTE] = ACTIONS(4281),
    [anon_sym_SQUOTE] = ACTIONS(4281),
    [anon_sym_L_DQUOTE] = ACTIONS(4281),
    [anon_sym_u_DQUOTE] = ACTIONS(4281),
    [anon_sym_U_DQUOTE] = ACTIONS(4281),
    [anon_sym_u8_DQUOTE] = ACTIONS(4281),
    [anon_sym_DQUOTE] = ACTIONS(4281),
    [sym_true] = ACTIONS(4283),
    [sym_false] = ACTIONS(4283),
    [anon_sym_NULL] = ACTIONS(4283),
    [anon_sym_nullptr] = ACTIONS(4283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4283),
    [anon_sym_let] = ACTIONS(4283),
    [anon_sym_This] = ACTIONS(4283),
    [anon_sym_decltype] = ACTIONS(4283),
    [anon_sym_explicit] = ACTIONS(4283),
    [anon_sym_typename] = ACTIONS(4283),
    [anon_sym_export] = ACTIONS(4283),
    [anon_sym_module] = ACTIONS(4283),
    [anon_sym_import] = ACTIONS(4283),
    [anon_sym_template] = ACTIONS(4283),
    [anon_sym_operator] = ACTIONS(4283),
    [anon_sym_try] = ACTIONS(4283),
    [anon_sym_delete] = ACTIONS(4283),
    [anon_sym_throw] = ACTIONS(4283),
    [anon_sym_namespace] = ACTIONS(4283),
    [anon_sym_static_assert] = ACTIONS(4283),
    [anon_sym_concept] = ACTIONS(4283),
    [anon_sym_co_return] = ACTIONS(4283),
    [anon_sym_co_yield] = ACTIONS(4283),
    [anon_sym_R_DQUOTE] = ACTIONS(4281),
    [anon_sym_LR_DQUOTE] = ACTIONS(4281),
    [anon_sym_uR_DQUOTE] = ACTIONS(4281),
    [anon_sym_UR_DQUOTE] = ACTIONS(4281),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4281),
    [anon_sym_co_await] = ACTIONS(4283),
    [anon_sym_new] = ACTIONS(4283),
    [anon_sym_requires] = ACTIONS(4283),
    [sym_this] = ACTIONS(4283),
    [anon_sym_precise] = ACTIONS(4283),
    [anon_sym_shared] = ACTIONS(4283),
    [anon_sym_groupshared] = ACTIONS(4283),
    [anon_sym_uniform] = ACTIONS(4283),
    [anon_sym_row_major] = ACTIONS(4283),
    [anon_sym_column_major] = ACTIONS(4283),
    [anon_sym_globallycoherent] = ACTIONS(4283),
    [anon_sym_centroid] = ACTIONS(4283),
    [anon_sym_noperspective] = ACTIONS(4283),
    [anon_sym_nointerpolation] = ACTIONS(4283),
    [anon_sym_sample] = ACTIONS(4283),
    [anon_sym_linear] = ACTIONS(4283),
    [anon_sym_snorm] = ACTIONS(4283),
    [anon_sym_unorm] = ACTIONS(4283),
    [anon_sym_point] = ACTIONS(4283),
    [anon_sym_line] = ACTIONS(4283),
    [anon_sym_triangleadj] = ACTIONS(4283),
    [anon_sym_lineadj] = ACTIONS(4283),
    [anon_sym_triangle] = ACTIONS(4283),
    [anon_sym_interface] = ACTIONS(4283),
    [anon_sym_extension] = ACTIONS(4283),
    [anon_sym___exported] = ACTIONS(4283),
  },
  [1024] = {
    [ts_builtin_sym_end] = ACTIONS(4285),
    [sym_identifier] = ACTIONS(4287),
    [aux_sym_preproc_include_token1] = ACTIONS(4287),
    [aux_sym_preproc_def_token1] = ACTIONS(4287),
    [aux_sym_preproc_if_token1] = ACTIONS(4287),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4287),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4287),
    [sym_preproc_directive] = ACTIONS(4287),
    [anon_sym_LPAREN2] = ACTIONS(4285),
    [anon_sym_BANG] = ACTIONS(4285),
    [anon_sym_TILDE] = ACTIONS(4285),
    [anon_sym_DASH] = ACTIONS(4287),
    [anon_sym_PLUS] = ACTIONS(4287),
    [anon_sym_STAR] = ACTIONS(4285),
    [anon_sym_AMP_AMP] = ACTIONS(4285),
    [anon_sym_AMP] = ACTIONS(4287),
    [anon_sym_SEMI] = ACTIONS(4285),
    [anon_sym___extension__] = ACTIONS(4287),
    [anon_sym_typedef] = ACTIONS(4287),
    [anon_sym_in] = ACTIONS(4287),
    [anon_sym_out] = ACTIONS(4287),
    [anon_sym_inout] = ACTIONS(4287),
    [anon_sym_virtual] = ACTIONS(4287),
    [anon_sym_extern] = ACTIONS(4287),
    [anon_sym___attribute__] = ACTIONS(4287),
    [anon_sym___attribute] = ACTIONS(4287),
    [anon_sym_using] = ACTIONS(4287),
    [anon_sym_COLON_COLON] = ACTIONS(4285),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4285),
    [anon_sym___declspec] = ACTIONS(4287),
    [anon_sym___based] = ACTIONS(4287),
    [anon_sym___cdecl] = ACTIONS(4287),
    [anon_sym___clrcall] = ACTIONS(4287),
    [anon_sym___stdcall] = ACTIONS(4287),
    [anon_sym___fastcall] = ACTIONS(4287),
    [anon_sym___thiscall] = ACTIONS(4287),
    [anon_sym___vectorcall] = ACTIONS(4287),
    [anon_sym_LBRACE] = ACTIONS(4285),
    [anon_sym_signed] = ACTIONS(4287),
    [anon_sym_unsigned] = ACTIONS(4287),
    [anon_sym_long] = ACTIONS(4287),
    [anon_sym_short] = ACTIONS(4287),
    [anon_sym_LBRACK] = ACTIONS(4287),
    [anon_sym_static] = ACTIONS(4287),
    [anon_sym_register] = ACTIONS(4287),
    [anon_sym_inline] = ACTIONS(4287),
    [anon_sym___inline] = ACTIONS(4287),
    [anon_sym___inline__] = ACTIONS(4287),
    [anon_sym___forceinline] = ACTIONS(4287),
    [anon_sym_thread_local] = ACTIONS(4287),
    [anon_sym___thread] = ACTIONS(4287),
    [anon_sym_const] = ACTIONS(4287),
    [anon_sym_constexpr] = ACTIONS(4287),
    [anon_sym_volatile] = ACTIONS(4287),
    [anon_sym_restrict] = ACTIONS(4287),
    [anon_sym___restrict__] = ACTIONS(4287),
    [anon_sym__Atomic] = ACTIONS(4287),
    [anon_sym__Noreturn] = ACTIONS(4287),
    [anon_sym_noreturn] = ACTIONS(4287),
    [anon_sym__Nonnull] = ACTIONS(4287),
    [anon_sym_mutable] = ACTIONS(4287),
    [anon_sym_constinit] = ACTIONS(4287),
    [anon_sym_consteval] = ACTIONS(4287),
    [anon_sym_alignas] = ACTIONS(4287),
    [anon_sym__Alignas] = ACTIONS(4287),
    [sym_primitive_type] = ACTIONS(4287),
    [anon_sym_enum] = ACTIONS(4287),
    [anon_sym_class] = ACTIONS(4287),
    [anon_sym_struct] = ACTIONS(4287),
    [anon_sym_union] = ACTIONS(4287),
    [anon_sym_if] = ACTIONS(4287),
    [anon_sym_switch] = ACTIONS(4287),
    [anon_sym_case] = ACTIONS(4287),
    [anon_sym_default] = ACTIONS(4287),
    [anon_sym_while] = ACTIONS(4287),
    [anon_sym_do] = ACTIONS(4287),
    [anon_sym_for] = ACTIONS(4287),
    [anon_sym_return] = ACTIONS(4287),
    [anon_sym_break] = ACTIONS(4287),
    [anon_sym_continue] = ACTIONS(4287),
    [anon_sym_goto] = ACTIONS(4287),
    [anon_sym_not] = ACTIONS(4287),
    [anon_sym_compl] = ACTIONS(4287),
    [anon_sym_DASH_DASH] = ACTIONS(4285),
    [anon_sym_PLUS_PLUS] = ACTIONS(4285),
    [anon_sym_sizeof] = ACTIONS(4287),
    [anon_sym___alignof__] = ACTIONS(4287),
    [anon_sym___alignof] = ACTIONS(4287),
    [anon_sym__alignof] = ACTIONS(4287),
    [anon_sym_alignof] = ACTIONS(4287),
    [anon_sym__Alignof] = ACTIONS(4287),
    [anon_sym_offsetof] = ACTIONS(4287),
    [anon_sym__Generic] = ACTIONS(4287),
    [anon_sym_asm] = ACTIONS(4287),
    [anon_sym___asm__] = ACTIONS(4287),
    [anon_sym___asm] = ACTIONS(4287),
    [sym_number_literal] = ACTIONS(4285),
    [anon_sym_L_SQUOTE] = ACTIONS(4285),
    [anon_sym_u_SQUOTE] = ACTIONS(4285),
    [anon_sym_U_SQUOTE] = ACTIONS(4285),
    [anon_sym_u8_SQUOTE] = ACTIONS(4285),
    [anon_sym_SQUOTE] = ACTIONS(4285),
    [anon_sym_L_DQUOTE] = ACTIONS(4285),
    [anon_sym_u_DQUOTE] = ACTIONS(4285),
    [anon_sym_U_DQUOTE] = ACTIONS(4285),
    [anon_sym_u8_DQUOTE] = ACTIONS(4285),
    [anon_sym_DQUOTE] = ACTIONS(4285),
    [sym_true] = ACTIONS(4287),
    [sym_false] = ACTIONS(4287),
    [anon_sym_NULL] = ACTIONS(4287),
    [anon_sym_nullptr] = ACTIONS(4287),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4287),
    [anon_sym_let] = ACTIONS(4287),
    [anon_sym_This] = ACTIONS(4287),
    [anon_sym_decltype] = ACTIONS(4287),
    [anon_sym_explicit] = ACTIONS(4287),
    [anon_sym_typename] = ACTIONS(4287),
    [anon_sym_export] = ACTIONS(4287),
    [anon_sym_module] = ACTIONS(4287),
    [anon_sym_import] = ACTIONS(4287),
    [anon_sym_template] = ACTIONS(4287),
    [anon_sym_operator] = ACTIONS(4287),
    [anon_sym_try] = ACTIONS(4287),
    [anon_sym_delete] = ACTIONS(4287),
    [anon_sym_throw] = ACTIONS(4287),
    [anon_sym_namespace] = ACTIONS(4287),
    [anon_sym_static_assert] = ACTIONS(4287),
    [anon_sym_concept] = ACTIONS(4287),
    [anon_sym_co_return] = ACTIONS(4287),
    [anon_sym_co_yield] = ACTIONS(4287),
    [anon_sym_R_DQUOTE] = ACTIONS(4285),
    [anon_sym_LR_DQUOTE] = ACTIONS(4285),
    [anon_sym_uR_DQUOTE] = ACTIONS(4285),
    [anon_sym_UR_DQUOTE] = ACTIONS(4285),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4285),
    [anon_sym_co_await] = ACTIONS(4287),
    [anon_sym_new] = ACTIONS(4287),
    [anon_sym_requires] = ACTIONS(4287),
    [sym_this] = ACTIONS(4287),
    [anon_sym_precise] = ACTIONS(4287),
    [anon_sym_shared] = ACTIONS(4287),
    [anon_sym_groupshared] = ACTIONS(4287),
    [anon_sym_uniform] = ACTIONS(4287),
    [anon_sym_row_major] = ACTIONS(4287),
    [anon_sym_column_major] = ACTIONS(4287),
    [anon_sym_globallycoherent] = ACTIONS(4287),
    [anon_sym_centroid] = ACTIONS(4287),
    [anon_sym_noperspective] = ACTIONS(4287),
    [anon_sym_nointerpolation] = ACTIONS(4287),
    [anon_sym_sample] = ACTIONS(4287),
    [anon_sym_linear] = ACTIONS(4287),
    [anon_sym_snorm] = ACTIONS(4287),
    [anon_sym_unorm] = ACTIONS(4287),
    [anon_sym_point] = ACTIONS(4287),
    [anon_sym_line] = ACTIONS(4287),
    [anon_sym_triangleadj] = ACTIONS(4287),
    [anon_sym_lineadj] = ACTIONS(4287),
    [anon_sym_triangle] = ACTIONS(4287),
    [anon_sym_interface] = ACTIONS(4287),
    [anon_sym_extension] = ACTIONS(4287),
    [anon_sym___exported] = ACTIONS(4287),
  },
  [1025] = {
    [ts_builtin_sym_end] = ACTIONS(4289),
    [sym_identifier] = ACTIONS(4291),
    [aux_sym_preproc_include_token1] = ACTIONS(4291),
    [aux_sym_preproc_def_token1] = ACTIONS(4291),
    [aux_sym_preproc_if_token1] = ACTIONS(4291),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4291),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4291),
    [sym_preproc_directive] = ACTIONS(4291),
    [anon_sym_LPAREN2] = ACTIONS(4289),
    [anon_sym_BANG] = ACTIONS(4289),
    [anon_sym_TILDE] = ACTIONS(4289),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4289),
    [anon_sym_AMP_AMP] = ACTIONS(4289),
    [anon_sym_AMP] = ACTIONS(4291),
    [anon_sym_SEMI] = ACTIONS(4289),
    [anon_sym___extension__] = ACTIONS(4291),
    [anon_sym_typedef] = ACTIONS(4291),
    [anon_sym_in] = ACTIONS(4291),
    [anon_sym_out] = ACTIONS(4291),
    [anon_sym_inout] = ACTIONS(4291),
    [anon_sym_virtual] = ACTIONS(4291),
    [anon_sym_extern] = ACTIONS(4291),
    [anon_sym___attribute__] = ACTIONS(4291),
    [anon_sym___attribute] = ACTIONS(4291),
    [anon_sym_using] = ACTIONS(4291),
    [anon_sym_COLON_COLON] = ACTIONS(4289),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4289),
    [anon_sym___declspec] = ACTIONS(4291),
    [anon_sym___based] = ACTIONS(4291),
    [anon_sym___cdecl] = ACTIONS(4291),
    [anon_sym___clrcall] = ACTIONS(4291),
    [anon_sym___stdcall] = ACTIONS(4291),
    [anon_sym___fastcall] = ACTIONS(4291),
    [anon_sym___thiscall] = ACTIONS(4291),
    [anon_sym___vectorcall] = ACTIONS(4291),
    [anon_sym_LBRACE] = ACTIONS(4289),
    [anon_sym_signed] = ACTIONS(4291),
    [anon_sym_unsigned] = ACTIONS(4291),
    [anon_sym_long] = ACTIONS(4291),
    [anon_sym_short] = ACTIONS(4291),
    [anon_sym_LBRACK] = ACTIONS(4291),
    [anon_sym_static] = ACTIONS(4291),
    [anon_sym_register] = ACTIONS(4291),
    [anon_sym_inline] = ACTIONS(4291),
    [anon_sym___inline] = ACTIONS(4291),
    [anon_sym___inline__] = ACTIONS(4291),
    [anon_sym___forceinline] = ACTIONS(4291),
    [anon_sym_thread_local] = ACTIONS(4291),
    [anon_sym___thread] = ACTIONS(4291),
    [anon_sym_const] = ACTIONS(4291),
    [anon_sym_constexpr] = ACTIONS(4291),
    [anon_sym_volatile] = ACTIONS(4291),
    [anon_sym_restrict] = ACTIONS(4291),
    [anon_sym___restrict__] = ACTIONS(4291),
    [anon_sym__Atomic] = ACTIONS(4291),
    [anon_sym__Noreturn] = ACTIONS(4291),
    [anon_sym_noreturn] = ACTIONS(4291),
    [anon_sym__Nonnull] = ACTIONS(4291),
    [anon_sym_mutable] = ACTIONS(4291),
    [anon_sym_constinit] = ACTIONS(4291),
    [anon_sym_consteval] = ACTIONS(4291),
    [anon_sym_alignas] = ACTIONS(4291),
    [anon_sym__Alignas] = ACTIONS(4291),
    [sym_primitive_type] = ACTIONS(4291),
    [anon_sym_enum] = ACTIONS(4291),
    [anon_sym_class] = ACTIONS(4291),
    [anon_sym_struct] = ACTIONS(4291),
    [anon_sym_union] = ACTIONS(4291),
    [anon_sym_if] = ACTIONS(4291),
    [anon_sym_switch] = ACTIONS(4291),
    [anon_sym_case] = ACTIONS(4291),
    [anon_sym_default] = ACTIONS(4291),
    [anon_sym_while] = ACTIONS(4291),
    [anon_sym_do] = ACTIONS(4291),
    [anon_sym_for] = ACTIONS(4291),
    [anon_sym_return] = ACTIONS(4291),
    [anon_sym_break] = ACTIONS(4291),
    [anon_sym_continue] = ACTIONS(4291),
    [anon_sym_goto] = ACTIONS(4291),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4289),
    [anon_sym_PLUS_PLUS] = ACTIONS(4289),
    [anon_sym_sizeof] = ACTIONS(4291),
    [anon_sym___alignof__] = ACTIONS(4291),
    [anon_sym___alignof] = ACTIONS(4291),
    [anon_sym__alignof] = ACTIONS(4291),
    [anon_sym_alignof] = ACTIONS(4291),
    [anon_sym__Alignof] = ACTIONS(4291),
    [anon_sym_offsetof] = ACTIONS(4291),
    [anon_sym__Generic] = ACTIONS(4291),
    [anon_sym_asm] = ACTIONS(4291),
    [anon_sym___asm__] = ACTIONS(4291),
    [anon_sym___asm] = ACTIONS(4291),
    [sym_number_literal] = ACTIONS(4289),
    [anon_sym_L_SQUOTE] = ACTIONS(4289),
    [anon_sym_u_SQUOTE] = ACTIONS(4289),
    [anon_sym_U_SQUOTE] = ACTIONS(4289),
    [anon_sym_u8_SQUOTE] = ACTIONS(4289),
    [anon_sym_SQUOTE] = ACTIONS(4289),
    [anon_sym_L_DQUOTE] = ACTIONS(4289),
    [anon_sym_u_DQUOTE] = ACTIONS(4289),
    [anon_sym_U_DQUOTE] = ACTIONS(4289),
    [anon_sym_u8_DQUOTE] = ACTIONS(4289),
    [anon_sym_DQUOTE] = ACTIONS(4289),
    [sym_true] = ACTIONS(4291),
    [sym_false] = ACTIONS(4291),
    [anon_sym_NULL] = ACTIONS(4291),
    [anon_sym_nullptr] = ACTIONS(4291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4291),
    [anon_sym_let] = ACTIONS(4291),
    [anon_sym_This] = ACTIONS(4291),
    [anon_sym_decltype] = ACTIONS(4291),
    [anon_sym_explicit] = ACTIONS(4291),
    [anon_sym_typename] = ACTIONS(4291),
    [anon_sym_export] = ACTIONS(4291),
    [anon_sym_module] = ACTIONS(4291),
    [anon_sym_import] = ACTIONS(4291),
    [anon_sym_template] = ACTIONS(4291),
    [anon_sym_operator] = ACTIONS(4291),
    [anon_sym_try] = ACTIONS(4291),
    [anon_sym_delete] = ACTIONS(4291),
    [anon_sym_throw] = ACTIONS(4291),
    [anon_sym_namespace] = ACTIONS(4291),
    [anon_sym_static_assert] = ACTIONS(4291),
    [anon_sym_concept] = ACTIONS(4291),
    [anon_sym_co_return] = ACTIONS(4291),
    [anon_sym_co_yield] = ACTIONS(4291),
    [anon_sym_R_DQUOTE] = ACTIONS(4289),
    [anon_sym_LR_DQUOTE] = ACTIONS(4289),
    [anon_sym_uR_DQUOTE] = ACTIONS(4289),
    [anon_sym_UR_DQUOTE] = ACTIONS(4289),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4289),
    [anon_sym_co_await] = ACTIONS(4291),
    [anon_sym_new] = ACTIONS(4291),
    [anon_sym_requires] = ACTIONS(4291),
    [sym_this] = ACTIONS(4291),
    [anon_sym_precise] = ACTIONS(4291),
    [anon_sym_shared] = ACTIONS(4291),
    [anon_sym_groupshared] = ACTIONS(4291),
    [anon_sym_uniform] = ACTIONS(4291),
    [anon_sym_row_major] = ACTIONS(4291),
    [anon_sym_column_major] = ACTIONS(4291),
    [anon_sym_globallycoherent] = ACTIONS(4291),
    [anon_sym_centroid] = ACTIONS(4291),
    [anon_sym_noperspective] = ACTIONS(4291),
    [anon_sym_nointerpolation] = ACTIONS(4291),
    [anon_sym_sample] = ACTIONS(4291),
    [anon_sym_linear] = ACTIONS(4291),
    [anon_sym_snorm] = ACTIONS(4291),
    [anon_sym_unorm] = ACTIONS(4291),
    [anon_sym_point] = ACTIONS(4291),
    [anon_sym_line] = ACTIONS(4291),
    [anon_sym_triangleadj] = ACTIONS(4291),
    [anon_sym_lineadj] = ACTIONS(4291),
    [anon_sym_triangle] = ACTIONS(4291),
    [anon_sym_interface] = ACTIONS(4291),
    [anon_sym_extension] = ACTIONS(4291),
    [anon_sym___exported] = ACTIONS(4291),
  },
  [1026] = {
    [ts_builtin_sym_end] = ACTIONS(4293),
    [sym_identifier] = ACTIONS(4295),
    [aux_sym_preproc_include_token1] = ACTIONS(4295),
    [aux_sym_preproc_def_token1] = ACTIONS(4295),
    [aux_sym_preproc_if_token1] = ACTIONS(4295),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4295),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4295),
    [sym_preproc_directive] = ACTIONS(4295),
    [anon_sym_LPAREN2] = ACTIONS(4293),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4295),
    [anon_sym_PLUS] = ACTIONS(4295),
    [anon_sym_STAR] = ACTIONS(4293),
    [anon_sym_AMP_AMP] = ACTIONS(4293),
    [anon_sym_AMP] = ACTIONS(4295),
    [anon_sym_SEMI] = ACTIONS(4293),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_typedef] = ACTIONS(4295),
    [anon_sym_in] = ACTIONS(4295),
    [anon_sym_out] = ACTIONS(4295),
    [anon_sym_inout] = ACTIONS(4295),
    [anon_sym_virtual] = ACTIONS(4295),
    [anon_sym_extern] = ACTIONS(4295),
    [anon_sym___attribute__] = ACTIONS(4295),
    [anon_sym___attribute] = ACTIONS(4295),
    [anon_sym_using] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4293),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4293),
    [anon_sym___declspec] = ACTIONS(4295),
    [anon_sym___based] = ACTIONS(4295),
    [anon_sym___cdecl] = ACTIONS(4295),
    [anon_sym___clrcall] = ACTIONS(4295),
    [anon_sym___stdcall] = ACTIONS(4295),
    [anon_sym___fastcall] = ACTIONS(4295),
    [anon_sym___thiscall] = ACTIONS(4295),
    [anon_sym___vectorcall] = ACTIONS(4295),
    [anon_sym_LBRACE] = ACTIONS(4293),
    [anon_sym_signed] = ACTIONS(4295),
    [anon_sym_unsigned] = ACTIONS(4295),
    [anon_sym_long] = ACTIONS(4295),
    [anon_sym_short] = ACTIONS(4295),
    [anon_sym_LBRACK] = ACTIONS(4295),
    [anon_sym_static] = ACTIONS(4295),
    [anon_sym_register] = ACTIONS(4295),
    [anon_sym_inline] = ACTIONS(4295),
    [anon_sym___inline] = ACTIONS(4295),
    [anon_sym___inline__] = ACTIONS(4295),
    [anon_sym___forceinline] = ACTIONS(4295),
    [anon_sym_thread_local] = ACTIONS(4295),
    [anon_sym___thread] = ACTIONS(4295),
    [anon_sym_const] = ACTIONS(4295),
    [anon_sym_constexpr] = ACTIONS(4295),
    [anon_sym_volatile] = ACTIONS(4295),
    [anon_sym_restrict] = ACTIONS(4295),
    [anon_sym___restrict__] = ACTIONS(4295),
    [anon_sym__Atomic] = ACTIONS(4295),
    [anon_sym__Noreturn] = ACTIONS(4295),
    [anon_sym_noreturn] = ACTIONS(4295),
    [anon_sym__Nonnull] = ACTIONS(4295),
    [anon_sym_mutable] = ACTIONS(4295),
    [anon_sym_constinit] = ACTIONS(4295),
    [anon_sym_consteval] = ACTIONS(4295),
    [anon_sym_alignas] = ACTIONS(4295),
    [anon_sym__Alignas] = ACTIONS(4295),
    [sym_primitive_type] = ACTIONS(4295),
    [anon_sym_enum] = ACTIONS(4295),
    [anon_sym_class] = ACTIONS(4295),
    [anon_sym_struct] = ACTIONS(4295),
    [anon_sym_union] = ACTIONS(4295),
    [anon_sym_if] = ACTIONS(4295),
    [anon_sym_switch] = ACTIONS(4295),
    [anon_sym_case] = ACTIONS(4295),
    [anon_sym_default] = ACTIONS(4295),
    [anon_sym_while] = ACTIONS(4295),
    [anon_sym_do] = ACTIONS(4295),
    [anon_sym_for] = ACTIONS(4295),
    [anon_sym_return] = ACTIONS(4295),
    [anon_sym_break] = ACTIONS(4295),
    [anon_sym_continue] = ACTIONS(4295),
    [anon_sym_goto] = ACTIONS(4295),
    [anon_sym_not] = ACTIONS(4295),
    [anon_sym_compl] = ACTIONS(4295),
    [anon_sym_DASH_DASH] = ACTIONS(4293),
    [anon_sym_PLUS_PLUS] = ACTIONS(4293),
    [anon_sym_sizeof] = ACTIONS(4295),
    [anon_sym___alignof__] = ACTIONS(4295),
    [anon_sym___alignof] = ACTIONS(4295),
    [anon_sym__alignof] = ACTIONS(4295),
    [anon_sym_alignof] = ACTIONS(4295),
    [anon_sym__Alignof] = ACTIONS(4295),
    [anon_sym_offsetof] = ACTIONS(4295),
    [anon_sym__Generic] = ACTIONS(4295),
    [anon_sym_asm] = ACTIONS(4295),
    [anon_sym___asm__] = ACTIONS(4295),
    [anon_sym___asm] = ACTIONS(4295),
    [sym_number_literal] = ACTIONS(4293),
    [anon_sym_L_SQUOTE] = ACTIONS(4293),
    [anon_sym_u_SQUOTE] = ACTIONS(4293),
    [anon_sym_U_SQUOTE] = ACTIONS(4293),
    [anon_sym_u8_SQUOTE] = ACTIONS(4293),
    [anon_sym_SQUOTE] = ACTIONS(4293),
    [anon_sym_L_DQUOTE] = ACTIONS(4293),
    [anon_sym_u_DQUOTE] = ACTIONS(4293),
    [anon_sym_U_DQUOTE] = ACTIONS(4293),
    [anon_sym_u8_DQUOTE] = ACTIONS(4293),
    [anon_sym_DQUOTE] = ACTIONS(4293),
    [sym_true] = ACTIONS(4295),
    [sym_false] = ACTIONS(4295),
    [anon_sym_NULL] = ACTIONS(4295),
    [anon_sym_nullptr] = ACTIONS(4295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4295),
    [anon_sym_let] = ACTIONS(4295),
    [anon_sym_This] = ACTIONS(4295),
    [anon_sym_decltype] = ACTIONS(4295),
    [anon_sym_explicit] = ACTIONS(4295),
    [anon_sym_typename] = ACTIONS(4295),
    [anon_sym_export] = ACTIONS(4295),
    [anon_sym_module] = ACTIONS(4295),
    [anon_sym_import] = ACTIONS(4295),
    [anon_sym_template] = ACTIONS(4295),
    [anon_sym_operator] = ACTIONS(4295),
    [anon_sym_try] = ACTIONS(4295),
    [anon_sym_delete] = ACTIONS(4295),
    [anon_sym_throw] = ACTIONS(4295),
    [anon_sym_namespace] = ACTIONS(4295),
    [anon_sym_static_assert] = ACTIONS(4295),
    [anon_sym_concept] = ACTIONS(4295),
    [anon_sym_co_return] = ACTIONS(4295),
    [anon_sym_co_yield] = ACTIONS(4295),
    [anon_sym_R_DQUOTE] = ACTIONS(4293),
    [anon_sym_LR_DQUOTE] = ACTIONS(4293),
    [anon_sym_uR_DQUOTE] = ACTIONS(4293),
    [anon_sym_UR_DQUOTE] = ACTIONS(4293),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4293),
    [anon_sym_co_await] = ACTIONS(4295),
    [anon_sym_new] = ACTIONS(4295),
    [anon_sym_requires] = ACTIONS(4295),
    [sym_this] = ACTIONS(4295),
    [anon_sym_precise] = ACTIONS(4295),
    [anon_sym_shared] = ACTIONS(4295),
    [anon_sym_groupshared] = ACTIONS(4295),
    [anon_sym_uniform] = ACTIONS(4295),
    [anon_sym_row_major] = ACTIONS(4295),
    [anon_sym_column_major] = ACTIONS(4295),
    [anon_sym_globallycoherent] = ACTIONS(4295),
    [anon_sym_centroid] = ACTIONS(4295),
    [anon_sym_noperspective] = ACTIONS(4295),
    [anon_sym_nointerpolation] = ACTIONS(4295),
    [anon_sym_sample] = ACTIONS(4295),
    [anon_sym_linear] = ACTIONS(4295),
    [anon_sym_snorm] = ACTIONS(4295),
    [anon_sym_unorm] = ACTIONS(4295),
    [anon_sym_point] = ACTIONS(4295),
    [anon_sym_line] = ACTIONS(4295),
    [anon_sym_triangleadj] = ACTIONS(4295),
    [anon_sym_lineadj] = ACTIONS(4295),
    [anon_sym_triangle] = ACTIONS(4295),
    [anon_sym_interface] = ACTIONS(4295),
    [anon_sym_extension] = ACTIONS(4295),
    [anon_sym___exported] = ACTIONS(4295),
  },
  [1027] = {
    [ts_builtin_sym_end] = ACTIONS(4297),
    [sym_identifier] = ACTIONS(4299),
    [aux_sym_preproc_include_token1] = ACTIONS(4299),
    [aux_sym_preproc_def_token1] = ACTIONS(4299),
    [aux_sym_preproc_if_token1] = ACTIONS(4299),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4299),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4299),
    [sym_preproc_directive] = ACTIONS(4299),
    [anon_sym_LPAREN2] = ACTIONS(4297),
    [anon_sym_BANG] = ACTIONS(4297),
    [anon_sym_TILDE] = ACTIONS(4297),
    [anon_sym_DASH] = ACTIONS(4299),
    [anon_sym_PLUS] = ACTIONS(4299),
    [anon_sym_STAR] = ACTIONS(4297),
    [anon_sym_AMP_AMP] = ACTIONS(4297),
    [anon_sym_AMP] = ACTIONS(4299),
    [anon_sym_SEMI] = ACTIONS(4297),
    [anon_sym___extension__] = ACTIONS(4299),
    [anon_sym_typedef] = ACTIONS(4299),
    [anon_sym_in] = ACTIONS(4299),
    [anon_sym_out] = ACTIONS(4299),
    [anon_sym_inout] = ACTIONS(4299),
    [anon_sym_virtual] = ACTIONS(4299),
    [anon_sym_extern] = ACTIONS(4299),
    [anon_sym___attribute__] = ACTIONS(4299),
    [anon_sym___attribute] = ACTIONS(4299),
    [anon_sym_using] = ACTIONS(4299),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4297),
    [anon_sym___declspec] = ACTIONS(4299),
    [anon_sym___based] = ACTIONS(4299),
    [anon_sym___cdecl] = ACTIONS(4299),
    [anon_sym___clrcall] = ACTIONS(4299),
    [anon_sym___stdcall] = ACTIONS(4299),
    [anon_sym___fastcall] = ACTIONS(4299),
    [anon_sym___thiscall] = ACTIONS(4299),
    [anon_sym___vectorcall] = ACTIONS(4299),
    [anon_sym_LBRACE] = ACTIONS(4297),
    [anon_sym_signed] = ACTIONS(4299),
    [anon_sym_unsigned] = ACTIONS(4299),
    [anon_sym_long] = ACTIONS(4299),
    [anon_sym_short] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(4299),
    [anon_sym_static] = ACTIONS(4299),
    [anon_sym_register] = ACTIONS(4299),
    [anon_sym_inline] = ACTIONS(4299),
    [anon_sym___inline] = ACTIONS(4299),
    [anon_sym___inline__] = ACTIONS(4299),
    [anon_sym___forceinline] = ACTIONS(4299),
    [anon_sym_thread_local] = ACTIONS(4299),
    [anon_sym___thread] = ACTIONS(4299),
    [anon_sym_const] = ACTIONS(4299),
    [anon_sym_constexpr] = ACTIONS(4299),
    [anon_sym_volatile] = ACTIONS(4299),
    [anon_sym_restrict] = ACTIONS(4299),
    [anon_sym___restrict__] = ACTIONS(4299),
    [anon_sym__Atomic] = ACTIONS(4299),
    [anon_sym__Noreturn] = ACTIONS(4299),
    [anon_sym_noreturn] = ACTIONS(4299),
    [anon_sym__Nonnull] = ACTIONS(4299),
    [anon_sym_mutable] = ACTIONS(4299),
    [anon_sym_constinit] = ACTIONS(4299),
    [anon_sym_consteval] = ACTIONS(4299),
    [anon_sym_alignas] = ACTIONS(4299),
    [anon_sym__Alignas] = ACTIONS(4299),
    [sym_primitive_type] = ACTIONS(4299),
    [anon_sym_enum] = ACTIONS(4299),
    [anon_sym_class] = ACTIONS(4299),
    [anon_sym_struct] = ACTIONS(4299),
    [anon_sym_union] = ACTIONS(4299),
    [anon_sym_if] = ACTIONS(4299),
    [anon_sym_switch] = ACTIONS(4299),
    [anon_sym_case] = ACTIONS(4299),
    [anon_sym_default] = ACTIONS(4299),
    [anon_sym_while] = ACTIONS(4299),
    [anon_sym_do] = ACTIONS(4299),
    [anon_sym_for] = ACTIONS(4299),
    [anon_sym_return] = ACTIONS(4299),
    [anon_sym_break] = ACTIONS(4299),
    [anon_sym_continue] = ACTIONS(4299),
    [anon_sym_goto] = ACTIONS(4299),
    [anon_sym_not] = ACTIONS(4299),
    [anon_sym_compl] = ACTIONS(4299),
    [anon_sym_DASH_DASH] = ACTIONS(4297),
    [anon_sym_PLUS_PLUS] = ACTIONS(4297),
    [anon_sym_sizeof] = ACTIONS(4299),
    [anon_sym___alignof__] = ACTIONS(4299),
    [anon_sym___alignof] = ACTIONS(4299),
    [anon_sym__alignof] = ACTIONS(4299),
    [anon_sym_alignof] = ACTIONS(4299),
    [anon_sym__Alignof] = ACTIONS(4299),
    [anon_sym_offsetof] = ACTIONS(4299),
    [anon_sym__Generic] = ACTIONS(4299),
    [anon_sym_asm] = ACTIONS(4299),
    [anon_sym___asm__] = ACTIONS(4299),
    [anon_sym___asm] = ACTIONS(4299),
    [sym_number_literal] = ACTIONS(4297),
    [anon_sym_L_SQUOTE] = ACTIONS(4297),
    [anon_sym_u_SQUOTE] = ACTIONS(4297),
    [anon_sym_U_SQUOTE] = ACTIONS(4297),
    [anon_sym_u8_SQUOTE] = ACTIONS(4297),
    [anon_sym_SQUOTE] = ACTIONS(4297),
    [anon_sym_L_DQUOTE] = ACTIONS(4297),
    [anon_sym_u_DQUOTE] = ACTIONS(4297),
    [anon_sym_U_DQUOTE] = ACTIONS(4297),
    [anon_sym_u8_DQUOTE] = ACTIONS(4297),
    [anon_sym_DQUOTE] = ACTIONS(4297),
    [sym_true] = ACTIONS(4299),
    [sym_false] = ACTIONS(4299),
    [anon_sym_NULL] = ACTIONS(4299),
    [anon_sym_nullptr] = ACTIONS(4299),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4299),
    [anon_sym_let] = ACTIONS(4299),
    [anon_sym_This] = ACTIONS(4299),
    [anon_sym_decltype] = ACTIONS(4299),
    [anon_sym_explicit] = ACTIONS(4299),
    [anon_sym_typename] = ACTIONS(4299),
    [anon_sym_export] = ACTIONS(4299),
    [anon_sym_module] = ACTIONS(4299),
    [anon_sym_import] = ACTIONS(4299),
    [anon_sym_template] = ACTIONS(4299),
    [anon_sym_operator] = ACTIONS(4299),
    [anon_sym_try] = ACTIONS(4299),
    [anon_sym_delete] = ACTIONS(4299),
    [anon_sym_throw] = ACTIONS(4299),
    [anon_sym_namespace] = ACTIONS(4299),
    [anon_sym_static_assert] = ACTIONS(4299),
    [anon_sym_concept] = ACTIONS(4299),
    [anon_sym_co_return] = ACTIONS(4299),
    [anon_sym_co_yield] = ACTIONS(4299),
    [anon_sym_R_DQUOTE] = ACTIONS(4297),
    [anon_sym_LR_DQUOTE] = ACTIONS(4297),
    [anon_sym_uR_DQUOTE] = ACTIONS(4297),
    [anon_sym_UR_DQUOTE] = ACTIONS(4297),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4297),
    [anon_sym_co_await] = ACTIONS(4299),
    [anon_sym_new] = ACTIONS(4299),
    [anon_sym_requires] = ACTIONS(4299),
    [sym_this] = ACTIONS(4299),
    [anon_sym_precise] = ACTIONS(4299),
    [anon_sym_shared] = ACTIONS(4299),
    [anon_sym_groupshared] = ACTIONS(4299),
    [anon_sym_uniform] = ACTIONS(4299),
    [anon_sym_row_major] = ACTIONS(4299),
    [anon_sym_column_major] = ACTIONS(4299),
    [anon_sym_globallycoherent] = ACTIONS(4299),
    [anon_sym_centroid] = ACTIONS(4299),
    [anon_sym_noperspective] = ACTIONS(4299),
    [anon_sym_nointerpolation] = ACTIONS(4299),
    [anon_sym_sample] = ACTIONS(4299),
    [anon_sym_linear] = ACTIONS(4299),
    [anon_sym_snorm] = ACTIONS(4299),
    [anon_sym_unorm] = ACTIONS(4299),
    [anon_sym_point] = ACTIONS(4299),
    [anon_sym_line] = ACTIONS(4299),
    [anon_sym_triangleadj] = ACTIONS(4299),
    [anon_sym_lineadj] = ACTIONS(4299),
    [anon_sym_triangle] = ACTIONS(4299),
    [anon_sym_interface] = ACTIONS(4299),
    [anon_sym_extension] = ACTIONS(4299),
    [anon_sym___exported] = ACTIONS(4299),
  },
  [1028] = {
    [ts_builtin_sym_end] = ACTIONS(4301),
    [sym_identifier] = ACTIONS(4303),
    [aux_sym_preproc_include_token1] = ACTIONS(4303),
    [aux_sym_preproc_def_token1] = ACTIONS(4303),
    [aux_sym_preproc_if_token1] = ACTIONS(4303),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4303),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4303),
    [sym_preproc_directive] = ACTIONS(4303),
    [anon_sym_LPAREN2] = ACTIONS(4301),
    [anon_sym_BANG] = ACTIONS(4301),
    [anon_sym_TILDE] = ACTIONS(4301),
    [anon_sym_DASH] = ACTIONS(4303),
    [anon_sym_PLUS] = ACTIONS(4303),
    [anon_sym_STAR] = ACTIONS(4301),
    [anon_sym_AMP_AMP] = ACTIONS(4301),
    [anon_sym_AMP] = ACTIONS(4303),
    [anon_sym_SEMI] = ACTIONS(4301),
    [anon_sym___extension__] = ACTIONS(4303),
    [anon_sym_typedef] = ACTIONS(4303),
    [anon_sym_in] = ACTIONS(4303),
    [anon_sym_out] = ACTIONS(4303),
    [anon_sym_inout] = ACTIONS(4303),
    [anon_sym_virtual] = ACTIONS(4303),
    [anon_sym_extern] = ACTIONS(4303),
    [anon_sym___attribute__] = ACTIONS(4303),
    [anon_sym___attribute] = ACTIONS(4303),
    [anon_sym_using] = ACTIONS(4303),
    [anon_sym_COLON_COLON] = ACTIONS(4301),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4301),
    [anon_sym___declspec] = ACTIONS(4303),
    [anon_sym___based] = ACTIONS(4303),
    [anon_sym___cdecl] = ACTIONS(4303),
    [anon_sym___clrcall] = ACTIONS(4303),
    [anon_sym___stdcall] = ACTIONS(4303),
    [anon_sym___fastcall] = ACTIONS(4303),
    [anon_sym___thiscall] = ACTIONS(4303),
    [anon_sym___vectorcall] = ACTIONS(4303),
    [anon_sym_LBRACE] = ACTIONS(4301),
    [anon_sym_signed] = ACTIONS(4303),
    [anon_sym_unsigned] = ACTIONS(4303),
    [anon_sym_long] = ACTIONS(4303),
    [anon_sym_short] = ACTIONS(4303),
    [anon_sym_LBRACK] = ACTIONS(4303),
    [anon_sym_static] = ACTIONS(4303),
    [anon_sym_register] = ACTIONS(4303),
    [anon_sym_inline] = ACTIONS(4303),
    [anon_sym___inline] = ACTIONS(4303),
    [anon_sym___inline__] = ACTIONS(4303),
    [anon_sym___forceinline] = ACTIONS(4303),
    [anon_sym_thread_local] = ACTIONS(4303),
    [anon_sym___thread] = ACTIONS(4303),
    [anon_sym_const] = ACTIONS(4303),
    [anon_sym_constexpr] = ACTIONS(4303),
    [anon_sym_volatile] = ACTIONS(4303),
    [anon_sym_restrict] = ACTIONS(4303),
    [anon_sym___restrict__] = ACTIONS(4303),
    [anon_sym__Atomic] = ACTIONS(4303),
    [anon_sym__Noreturn] = ACTIONS(4303),
    [anon_sym_noreturn] = ACTIONS(4303),
    [anon_sym__Nonnull] = ACTIONS(4303),
    [anon_sym_mutable] = ACTIONS(4303),
    [anon_sym_constinit] = ACTIONS(4303),
    [anon_sym_consteval] = ACTIONS(4303),
    [anon_sym_alignas] = ACTIONS(4303),
    [anon_sym__Alignas] = ACTIONS(4303),
    [sym_primitive_type] = ACTIONS(4303),
    [anon_sym_enum] = ACTIONS(4303),
    [anon_sym_class] = ACTIONS(4303),
    [anon_sym_struct] = ACTIONS(4303),
    [anon_sym_union] = ACTIONS(4303),
    [anon_sym_if] = ACTIONS(4303),
    [anon_sym_switch] = ACTIONS(4303),
    [anon_sym_case] = ACTIONS(4303),
    [anon_sym_default] = ACTIONS(4303),
    [anon_sym_while] = ACTIONS(4303),
    [anon_sym_do] = ACTIONS(4303),
    [anon_sym_for] = ACTIONS(4303),
    [anon_sym_return] = ACTIONS(4303),
    [anon_sym_break] = ACTIONS(4303),
    [anon_sym_continue] = ACTIONS(4303),
    [anon_sym_goto] = ACTIONS(4303),
    [anon_sym_not] = ACTIONS(4303),
    [anon_sym_compl] = ACTIONS(4303),
    [anon_sym_DASH_DASH] = ACTIONS(4301),
    [anon_sym_PLUS_PLUS] = ACTIONS(4301),
    [anon_sym_sizeof] = ACTIONS(4303),
    [anon_sym___alignof__] = ACTIONS(4303),
    [anon_sym___alignof] = ACTIONS(4303),
    [anon_sym__alignof] = ACTIONS(4303),
    [anon_sym_alignof] = ACTIONS(4303),
    [anon_sym__Alignof] = ACTIONS(4303),
    [anon_sym_offsetof] = ACTIONS(4303),
    [anon_sym__Generic] = ACTIONS(4303),
    [anon_sym_asm] = ACTIONS(4303),
    [anon_sym___asm__] = ACTIONS(4303),
    [anon_sym___asm] = ACTIONS(4303),
    [sym_number_literal] = ACTIONS(4301),
    [anon_sym_L_SQUOTE] = ACTIONS(4301),
    [anon_sym_u_SQUOTE] = ACTIONS(4301),
    [anon_sym_U_SQUOTE] = ACTIONS(4301),
    [anon_sym_u8_SQUOTE] = ACTIONS(4301),
    [anon_sym_SQUOTE] = ACTIONS(4301),
    [anon_sym_L_DQUOTE] = ACTIONS(4301),
    [anon_sym_u_DQUOTE] = ACTIONS(4301),
    [anon_sym_U_DQUOTE] = ACTIONS(4301),
    [anon_sym_u8_DQUOTE] = ACTIONS(4301),
    [anon_sym_DQUOTE] = ACTIONS(4301),
    [sym_true] = ACTIONS(4303),
    [sym_false] = ACTIONS(4303),
    [anon_sym_NULL] = ACTIONS(4303),
    [anon_sym_nullptr] = ACTIONS(4303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4303),
    [anon_sym_let] = ACTIONS(4303),
    [anon_sym_This] = ACTIONS(4303),
    [anon_sym_decltype] = ACTIONS(4303),
    [anon_sym_explicit] = ACTIONS(4303),
    [anon_sym_typename] = ACTIONS(4303),
    [anon_sym_export] = ACTIONS(4303),
    [anon_sym_module] = ACTIONS(4303),
    [anon_sym_import] = ACTIONS(4303),
    [anon_sym_template] = ACTIONS(4303),
    [anon_sym_operator] = ACTIONS(4303),
    [anon_sym_try] = ACTIONS(4303),
    [anon_sym_delete] = ACTIONS(4303),
    [anon_sym_throw] = ACTIONS(4303),
    [anon_sym_namespace] = ACTIONS(4303),
    [anon_sym_static_assert] = ACTIONS(4303),
    [anon_sym_concept] = ACTIONS(4303),
    [anon_sym_co_return] = ACTIONS(4303),
    [anon_sym_co_yield] = ACTIONS(4303),
    [anon_sym_R_DQUOTE] = ACTIONS(4301),
    [anon_sym_LR_DQUOTE] = ACTIONS(4301),
    [anon_sym_uR_DQUOTE] = ACTIONS(4301),
    [anon_sym_UR_DQUOTE] = ACTIONS(4301),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4301),
    [anon_sym_co_await] = ACTIONS(4303),
    [anon_sym_new] = ACTIONS(4303),
    [anon_sym_requires] = ACTIONS(4303),
    [sym_this] = ACTIONS(4303),
    [anon_sym_precise] = ACTIONS(4303),
    [anon_sym_shared] = ACTIONS(4303),
    [anon_sym_groupshared] = ACTIONS(4303),
    [anon_sym_uniform] = ACTIONS(4303),
    [anon_sym_row_major] = ACTIONS(4303),
    [anon_sym_column_major] = ACTIONS(4303),
    [anon_sym_globallycoherent] = ACTIONS(4303),
    [anon_sym_centroid] = ACTIONS(4303),
    [anon_sym_noperspective] = ACTIONS(4303),
    [anon_sym_nointerpolation] = ACTIONS(4303),
    [anon_sym_sample] = ACTIONS(4303),
    [anon_sym_linear] = ACTIONS(4303),
    [anon_sym_snorm] = ACTIONS(4303),
    [anon_sym_unorm] = ACTIONS(4303),
    [anon_sym_point] = ACTIONS(4303),
    [anon_sym_line] = ACTIONS(4303),
    [anon_sym_triangleadj] = ACTIONS(4303),
    [anon_sym_lineadj] = ACTIONS(4303),
    [anon_sym_triangle] = ACTIONS(4303),
    [anon_sym_interface] = ACTIONS(4303),
    [anon_sym_extension] = ACTIONS(4303),
    [anon_sym___exported] = ACTIONS(4303),
  },
  [1029] = {
    [sym_identifier] = ACTIONS(3905),
    [aux_sym_preproc_include_token1] = ACTIONS(3905),
    [aux_sym_preproc_def_token1] = ACTIONS(3905),
    [aux_sym_preproc_if_token1] = ACTIONS(3905),
    [aux_sym_preproc_if_token2] = ACTIONS(3905),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3905),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3905),
    [sym_preproc_directive] = ACTIONS(3905),
    [anon_sym_LPAREN2] = ACTIONS(3907),
    [anon_sym_BANG] = ACTIONS(3907),
    [anon_sym_TILDE] = ACTIONS(3907),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_STAR] = ACTIONS(3907),
    [anon_sym_AMP_AMP] = ACTIONS(3907),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_SEMI] = ACTIONS(3907),
    [anon_sym___extension__] = ACTIONS(3905),
    [anon_sym_typedef] = ACTIONS(3905),
    [anon_sym_in] = ACTIONS(3905),
    [anon_sym_out] = ACTIONS(3905),
    [anon_sym_inout] = ACTIONS(3905),
    [anon_sym_virtual] = ACTIONS(3905),
    [anon_sym_extern] = ACTIONS(3905),
    [anon_sym___attribute__] = ACTIONS(3905),
    [anon_sym___attribute] = ACTIONS(3905),
    [anon_sym_using] = ACTIONS(3905),
    [anon_sym_COLON_COLON] = ACTIONS(3907),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3907),
    [anon_sym___declspec] = ACTIONS(3905),
    [anon_sym___based] = ACTIONS(3905),
    [anon_sym___cdecl] = ACTIONS(3905),
    [anon_sym___clrcall] = ACTIONS(3905),
    [anon_sym___stdcall] = ACTIONS(3905),
    [anon_sym___fastcall] = ACTIONS(3905),
    [anon_sym___thiscall] = ACTIONS(3905),
    [anon_sym___vectorcall] = ACTIONS(3905),
    [anon_sym_LBRACE] = ACTIONS(3907),
    [anon_sym_signed] = ACTIONS(3905),
    [anon_sym_unsigned] = ACTIONS(3905),
    [anon_sym_long] = ACTIONS(3905),
    [anon_sym_short] = ACTIONS(3905),
    [anon_sym_LBRACK] = ACTIONS(3905),
    [anon_sym_static] = ACTIONS(3905),
    [anon_sym_register] = ACTIONS(3905),
    [anon_sym_inline] = ACTIONS(3905),
    [anon_sym___inline] = ACTIONS(3905),
    [anon_sym___inline__] = ACTIONS(3905),
    [anon_sym___forceinline] = ACTIONS(3905),
    [anon_sym_thread_local] = ACTIONS(3905),
    [anon_sym___thread] = ACTIONS(3905),
    [anon_sym_const] = ACTIONS(3905),
    [anon_sym_constexpr] = ACTIONS(3905),
    [anon_sym_volatile] = ACTIONS(3905),
    [anon_sym_restrict] = ACTIONS(3905),
    [anon_sym___restrict__] = ACTIONS(3905),
    [anon_sym__Atomic] = ACTIONS(3905),
    [anon_sym__Noreturn] = ACTIONS(3905),
    [anon_sym_noreturn] = ACTIONS(3905),
    [anon_sym__Nonnull] = ACTIONS(3905),
    [anon_sym_mutable] = ACTIONS(3905),
    [anon_sym_constinit] = ACTIONS(3905),
    [anon_sym_consteval] = ACTIONS(3905),
    [anon_sym_alignas] = ACTIONS(3905),
    [anon_sym__Alignas] = ACTIONS(3905),
    [sym_primitive_type] = ACTIONS(3905),
    [anon_sym_enum] = ACTIONS(3905),
    [anon_sym_class] = ACTIONS(3905),
    [anon_sym_struct] = ACTIONS(3905),
    [anon_sym_union] = ACTIONS(3905),
    [anon_sym_if] = ACTIONS(3905),
    [anon_sym_switch] = ACTIONS(3905),
    [anon_sym_case] = ACTIONS(3905),
    [anon_sym_default] = ACTIONS(3905),
    [anon_sym_while] = ACTIONS(3905),
    [anon_sym_do] = ACTIONS(3905),
    [anon_sym_for] = ACTIONS(3905),
    [anon_sym_return] = ACTIONS(3905),
    [anon_sym_break] = ACTIONS(3905),
    [anon_sym_continue] = ACTIONS(3905),
    [anon_sym_goto] = ACTIONS(3905),
    [anon_sym___try] = ACTIONS(3905),
    [anon_sym___leave] = ACTIONS(3905),
    [anon_sym_not] = ACTIONS(3905),
    [anon_sym_compl] = ACTIONS(3905),
    [anon_sym_DASH_DASH] = ACTIONS(3907),
    [anon_sym_PLUS_PLUS] = ACTIONS(3907),
    [anon_sym_sizeof] = ACTIONS(3905),
    [anon_sym___alignof__] = ACTIONS(3905),
    [anon_sym___alignof] = ACTIONS(3905),
    [anon_sym__alignof] = ACTIONS(3905),
    [anon_sym_alignof] = ACTIONS(3905),
    [anon_sym__Alignof] = ACTIONS(3905),
    [anon_sym_offsetof] = ACTIONS(3905),
    [anon_sym__Generic] = ACTIONS(3905),
    [anon_sym_asm] = ACTIONS(3905),
    [anon_sym___asm__] = ACTIONS(3905),
    [anon_sym___asm] = ACTIONS(3905),
    [sym_number_literal] = ACTIONS(3907),
    [anon_sym_L_SQUOTE] = ACTIONS(3907),
    [anon_sym_u_SQUOTE] = ACTIONS(3907),
    [anon_sym_U_SQUOTE] = ACTIONS(3907),
    [anon_sym_u8_SQUOTE] = ACTIONS(3907),
    [anon_sym_SQUOTE] = ACTIONS(3907),
    [anon_sym_L_DQUOTE] = ACTIONS(3907),
    [anon_sym_u_DQUOTE] = ACTIONS(3907),
    [anon_sym_U_DQUOTE] = ACTIONS(3907),
    [anon_sym_u8_DQUOTE] = ACTIONS(3907),
    [anon_sym_DQUOTE] = ACTIONS(3907),
    [sym_true] = ACTIONS(3905),
    [sym_false] = ACTIONS(3905),
    [anon_sym_NULL] = ACTIONS(3905),
    [anon_sym_nullptr] = ACTIONS(3905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3905),
    [anon_sym_let] = ACTIONS(3905),
    [anon_sym_This] = ACTIONS(3905),
    [anon_sym_decltype] = ACTIONS(3905),
    [anon_sym_explicit] = ACTIONS(3905),
    [anon_sym_typename] = ACTIONS(3905),
    [anon_sym_template] = ACTIONS(3905),
    [anon_sym_operator] = ACTIONS(3905),
    [anon_sym_try] = ACTIONS(3905),
    [anon_sym_delete] = ACTIONS(3905),
    [anon_sym_throw] = ACTIONS(3905),
    [anon_sym_namespace] = ACTIONS(3905),
    [anon_sym_static_assert] = ACTIONS(3905),
    [anon_sym_concept] = ACTIONS(3905),
    [anon_sym_co_return] = ACTIONS(3905),
    [anon_sym_co_yield] = ACTIONS(3905),
    [anon_sym_R_DQUOTE] = ACTIONS(3907),
    [anon_sym_LR_DQUOTE] = ACTIONS(3907),
    [anon_sym_uR_DQUOTE] = ACTIONS(3907),
    [anon_sym_UR_DQUOTE] = ACTIONS(3907),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3907),
    [anon_sym_co_await] = ACTIONS(3905),
    [anon_sym_new] = ACTIONS(3905),
    [anon_sym_requires] = ACTIONS(3905),
    [sym_this] = ACTIONS(3905),
    [anon_sym_discard] = ACTIONS(3905),
    [anon_sym_precise] = ACTIONS(3905),
    [anon_sym_shared] = ACTIONS(3905),
    [anon_sym_groupshared] = ACTIONS(3905),
    [anon_sym_uniform] = ACTIONS(3905),
    [anon_sym_row_major] = ACTIONS(3905),
    [anon_sym_column_major] = ACTIONS(3905),
    [anon_sym_globallycoherent] = ACTIONS(3905),
    [anon_sym_centroid] = ACTIONS(3905),
    [anon_sym_noperspective] = ACTIONS(3905),
    [anon_sym_nointerpolation] = ACTIONS(3905),
    [anon_sym_sample] = ACTIONS(3905),
    [anon_sym_linear] = ACTIONS(3905),
    [anon_sym_snorm] = ACTIONS(3905),
    [anon_sym_unorm] = ACTIONS(3905),
    [anon_sym_point] = ACTIONS(3905),
    [anon_sym_line] = ACTIONS(3905),
    [anon_sym_triangleadj] = ACTIONS(3905),
    [anon_sym_lineadj] = ACTIONS(3905),
    [anon_sym_triangle] = ACTIONS(3905),
    [anon_sym_cbuffer] = ACTIONS(3905),
    [anon_sym_interface] = ACTIONS(3905),
    [anon_sym_extension] = ACTIONS(3905),
  },
  [1030] = {
    [ts_builtin_sym_end] = ACTIONS(3925),
    [sym_identifier] = ACTIONS(3923),
    [aux_sym_preproc_include_token1] = ACTIONS(3923),
    [aux_sym_preproc_def_token1] = ACTIONS(3923),
    [aux_sym_preproc_if_token1] = ACTIONS(3923),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3923),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3923),
    [sym_preproc_directive] = ACTIONS(3923),
    [anon_sym_LPAREN2] = ACTIONS(3925),
    [anon_sym_BANG] = ACTIONS(3925),
    [anon_sym_TILDE] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_STAR] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_AMP] = ACTIONS(3923),
    [anon_sym_SEMI] = ACTIONS(3925),
    [anon_sym___extension__] = ACTIONS(3923),
    [anon_sym_typedef] = ACTIONS(3923),
    [anon_sym_in] = ACTIONS(3923),
    [anon_sym_out] = ACTIONS(3923),
    [anon_sym_inout] = ACTIONS(3923),
    [anon_sym_virtual] = ACTIONS(3923),
    [anon_sym_extern] = ACTIONS(3923),
    [anon_sym___attribute__] = ACTIONS(3923),
    [anon_sym___attribute] = ACTIONS(3923),
    [anon_sym_using] = ACTIONS(3923),
    [anon_sym_COLON_COLON] = ACTIONS(3925),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3925),
    [anon_sym___declspec] = ACTIONS(3923),
    [anon_sym___based] = ACTIONS(3923),
    [anon_sym___cdecl] = ACTIONS(3923),
    [anon_sym___clrcall] = ACTIONS(3923),
    [anon_sym___stdcall] = ACTIONS(3923),
    [anon_sym___fastcall] = ACTIONS(3923),
    [anon_sym___thiscall] = ACTIONS(3923),
    [anon_sym___vectorcall] = ACTIONS(3923),
    [anon_sym_LBRACE] = ACTIONS(3925),
    [anon_sym_signed] = ACTIONS(3923),
    [anon_sym_unsigned] = ACTIONS(3923),
    [anon_sym_long] = ACTIONS(3923),
    [anon_sym_short] = ACTIONS(3923),
    [anon_sym_LBRACK] = ACTIONS(3923),
    [anon_sym_static] = ACTIONS(3923),
    [anon_sym_register] = ACTIONS(3923),
    [anon_sym_inline] = ACTIONS(3923),
    [anon_sym___inline] = ACTIONS(3923),
    [anon_sym___inline__] = ACTIONS(3923),
    [anon_sym___forceinline] = ACTIONS(3923),
    [anon_sym_thread_local] = ACTIONS(3923),
    [anon_sym___thread] = ACTIONS(3923),
    [anon_sym_const] = ACTIONS(3923),
    [anon_sym_constexpr] = ACTIONS(3923),
    [anon_sym_volatile] = ACTIONS(3923),
    [anon_sym_restrict] = ACTIONS(3923),
    [anon_sym___restrict__] = ACTIONS(3923),
    [anon_sym__Atomic] = ACTIONS(3923),
    [anon_sym__Noreturn] = ACTIONS(3923),
    [anon_sym_noreturn] = ACTIONS(3923),
    [anon_sym__Nonnull] = ACTIONS(3923),
    [anon_sym_mutable] = ACTIONS(3923),
    [anon_sym_constinit] = ACTIONS(3923),
    [anon_sym_consteval] = ACTIONS(3923),
    [anon_sym_alignas] = ACTIONS(3923),
    [anon_sym__Alignas] = ACTIONS(3923),
    [sym_primitive_type] = ACTIONS(3923),
    [anon_sym_enum] = ACTIONS(3923),
    [anon_sym_class] = ACTIONS(3923),
    [anon_sym_struct] = ACTIONS(3923),
    [anon_sym_union] = ACTIONS(3923),
    [anon_sym_if] = ACTIONS(3923),
    [anon_sym_switch] = ACTIONS(3923),
    [anon_sym_case] = ACTIONS(3923),
    [anon_sym_default] = ACTIONS(3923),
    [anon_sym_while] = ACTIONS(3923),
    [anon_sym_do] = ACTIONS(3923),
    [anon_sym_for] = ACTIONS(3923),
    [anon_sym_return] = ACTIONS(3923),
    [anon_sym_break] = ACTIONS(3923),
    [anon_sym_continue] = ACTIONS(3923),
    [anon_sym_goto] = ACTIONS(3923),
    [anon_sym_not] = ACTIONS(3923),
    [anon_sym_compl] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3923),
    [anon_sym___alignof__] = ACTIONS(3923),
    [anon_sym___alignof] = ACTIONS(3923),
    [anon_sym__alignof] = ACTIONS(3923),
    [anon_sym_alignof] = ACTIONS(3923),
    [anon_sym__Alignof] = ACTIONS(3923),
    [anon_sym_offsetof] = ACTIONS(3923),
    [anon_sym__Generic] = ACTIONS(3923),
    [anon_sym_asm] = ACTIONS(3923),
    [anon_sym___asm__] = ACTIONS(3923),
    [anon_sym___asm] = ACTIONS(3923),
    [sym_number_literal] = ACTIONS(3925),
    [anon_sym_L_SQUOTE] = ACTIONS(3925),
    [anon_sym_u_SQUOTE] = ACTIONS(3925),
    [anon_sym_U_SQUOTE] = ACTIONS(3925),
    [anon_sym_u8_SQUOTE] = ACTIONS(3925),
    [anon_sym_SQUOTE] = ACTIONS(3925),
    [anon_sym_L_DQUOTE] = ACTIONS(3925),
    [anon_sym_u_DQUOTE] = ACTIONS(3925),
    [anon_sym_U_DQUOTE] = ACTIONS(3925),
    [anon_sym_u8_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [sym_true] = ACTIONS(3923),
    [sym_false] = ACTIONS(3923),
    [anon_sym_NULL] = ACTIONS(3923),
    [anon_sym_nullptr] = ACTIONS(3923),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3923),
    [anon_sym_let] = ACTIONS(3923),
    [anon_sym_This] = ACTIONS(3923),
    [anon_sym_decltype] = ACTIONS(3923),
    [anon_sym_explicit] = ACTIONS(3923),
    [anon_sym_typename] = ACTIONS(3923),
    [anon_sym_export] = ACTIONS(3923),
    [anon_sym_module] = ACTIONS(3923),
    [anon_sym_import] = ACTIONS(3923),
    [anon_sym_template] = ACTIONS(3923),
    [anon_sym_operator] = ACTIONS(3923),
    [anon_sym_try] = ACTIONS(3923),
    [anon_sym_delete] = ACTIONS(3923),
    [anon_sym_throw] = ACTIONS(3923),
    [anon_sym_namespace] = ACTIONS(3923),
    [anon_sym_static_assert] = ACTIONS(3923),
    [anon_sym_concept] = ACTIONS(3923),
    [anon_sym_co_return] = ACTIONS(3923),
    [anon_sym_co_yield] = ACTIONS(3923),
    [anon_sym_R_DQUOTE] = ACTIONS(3925),
    [anon_sym_LR_DQUOTE] = ACTIONS(3925),
    [anon_sym_uR_DQUOTE] = ACTIONS(3925),
    [anon_sym_UR_DQUOTE] = ACTIONS(3925),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3925),
    [anon_sym_co_await] = ACTIONS(3923),
    [anon_sym_new] = ACTIONS(3923),
    [anon_sym_requires] = ACTIONS(3923),
    [sym_this] = ACTIONS(3923),
    [anon_sym_precise] = ACTIONS(3923),
    [anon_sym_shared] = ACTIONS(3923),
    [anon_sym_groupshared] = ACTIONS(3923),
    [anon_sym_uniform] = ACTIONS(3923),
    [anon_sym_row_major] = ACTIONS(3923),
    [anon_sym_column_major] = ACTIONS(3923),
    [anon_sym_globallycoherent] = ACTIONS(3923),
    [anon_sym_centroid] = ACTIONS(3923),
    [anon_sym_noperspective] = ACTIONS(3923),
    [anon_sym_nointerpolation] = ACTIONS(3923),
    [anon_sym_sample] = ACTIONS(3923),
    [anon_sym_linear] = ACTIONS(3923),
    [anon_sym_snorm] = ACTIONS(3923),
    [anon_sym_unorm] = ACTIONS(3923),
    [anon_sym_point] = ACTIONS(3923),
    [anon_sym_line] = ACTIONS(3923),
    [anon_sym_triangleadj] = ACTIONS(3923),
    [anon_sym_lineadj] = ACTIONS(3923),
    [anon_sym_triangle] = ACTIONS(3923),
    [anon_sym_interface] = ACTIONS(3923),
    [anon_sym_extension] = ACTIONS(3923),
    [anon_sym___exported] = ACTIONS(3923),
  },
  [1031] = {
    [ts_builtin_sym_end] = ACTIONS(3929),
    [sym_identifier] = ACTIONS(3927),
    [aux_sym_preproc_include_token1] = ACTIONS(3927),
    [aux_sym_preproc_def_token1] = ACTIONS(3927),
    [aux_sym_preproc_if_token1] = ACTIONS(3927),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3927),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3927),
    [sym_preproc_directive] = ACTIONS(3927),
    [anon_sym_LPAREN2] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_TILDE] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_SEMI] = ACTIONS(3929),
    [anon_sym___extension__] = ACTIONS(3927),
    [anon_sym_typedef] = ACTIONS(3927),
    [anon_sym_in] = ACTIONS(3927),
    [anon_sym_out] = ACTIONS(3927),
    [anon_sym_inout] = ACTIONS(3927),
    [anon_sym_virtual] = ACTIONS(3927),
    [anon_sym_extern] = ACTIONS(3927),
    [anon_sym___attribute__] = ACTIONS(3927),
    [anon_sym___attribute] = ACTIONS(3927),
    [anon_sym_using] = ACTIONS(3927),
    [anon_sym_COLON_COLON] = ACTIONS(3929),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3929),
    [anon_sym___declspec] = ACTIONS(3927),
    [anon_sym___based] = ACTIONS(3927),
    [anon_sym___cdecl] = ACTIONS(3927),
    [anon_sym___clrcall] = ACTIONS(3927),
    [anon_sym___stdcall] = ACTIONS(3927),
    [anon_sym___fastcall] = ACTIONS(3927),
    [anon_sym___thiscall] = ACTIONS(3927),
    [anon_sym___vectorcall] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3929),
    [anon_sym_signed] = ACTIONS(3927),
    [anon_sym_unsigned] = ACTIONS(3927),
    [anon_sym_long] = ACTIONS(3927),
    [anon_sym_short] = ACTIONS(3927),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_static] = ACTIONS(3927),
    [anon_sym_register] = ACTIONS(3927),
    [anon_sym_inline] = ACTIONS(3927),
    [anon_sym___inline] = ACTIONS(3927),
    [anon_sym___inline__] = ACTIONS(3927),
    [anon_sym___forceinline] = ACTIONS(3927),
    [anon_sym_thread_local] = ACTIONS(3927),
    [anon_sym___thread] = ACTIONS(3927),
    [anon_sym_const] = ACTIONS(3927),
    [anon_sym_constexpr] = ACTIONS(3927),
    [anon_sym_volatile] = ACTIONS(3927),
    [anon_sym_restrict] = ACTIONS(3927),
    [anon_sym___restrict__] = ACTIONS(3927),
    [anon_sym__Atomic] = ACTIONS(3927),
    [anon_sym__Noreturn] = ACTIONS(3927),
    [anon_sym_noreturn] = ACTIONS(3927),
    [anon_sym__Nonnull] = ACTIONS(3927),
    [anon_sym_mutable] = ACTIONS(3927),
    [anon_sym_constinit] = ACTIONS(3927),
    [anon_sym_consteval] = ACTIONS(3927),
    [anon_sym_alignas] = ACTIONS(3927),
    [anon_sym__Alignas] = ACTIONS(3927),
    [sym_primitive_type] = ACTIONS(3927),
    [anon_sym_enum] = ACTIONS(3927),
    [anon_sym_class] = ACTIONS(3927),
    [anon_sym_struct] = ACTIONS(3927),
    [anon_sym_union] = ACTIONS(3927),
    [anon_sym_if] = ACTIONS(3927),
    [anon_sym_switch] = ACTIONS(3927),
    [anon_sym_case] = ACTIONS(3927),
    [anon_sym_default] = ACTIONS(3927),
    [anon_sym_while] = ACTIONS(3927),
    [anon_sym_do] = ACTIONS(3927),
    [anon_sym_for] = ACTIONS(3927),
    [anon_sym_return] = ACTIONS(3927),
    [anon_sym_break] = ACTIONS(3927),
    [anon_sym_continue] = ACTIONS(3927),
    [anon_sym_goto] = ACTIONS(3927),
    [anon_sym_not] = ACTIONS(3927),
    [anon_sym_compl] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3929),
    [anon_sym_sizeof] = ACTIONS(3927),
    [anon_sym___alignof__] = ACTIONS(3927),
    [anon_sym___alignof] = ACTIONS(3927),
    [anon_sym__alignof] = ACTIONS(3927),
    [anon_sym_alignof] = ACTIONS(3927),
    [anon_sym__Alignof] = ACTIONS(3927),
    [anon_sym_offsetof] = ACTIONS(3927),
    [anon_sym__Generic] = ACTIONS(3927),
    [anon_sym_asm] = ACTIONS(3927),
    [anon_sym___asm__] = ACTIONS(3927),
    [anon_sym___asm] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(3929),
    [anon_sym_L_SQUOTE] = ACTIONS(3929),
    [anon_sym_u_SQUOTE] = ACTIONS(3929),
    [anon_sym_U_SQUOTE] = ACTIONS(3929),
    [anon_sym_u8_SQUOTE] = ACTIONS(3929),
    [anon_sym_SQUOTE] = ACTIONS(3929),
    [anon_sym_L_DQUOTE] = ACTIONS(3929),
    [anon_sym_u_DQUOTE] = ACTIONS(3929),
    [anon_sym_U_DQUOTE] = ACTIONS(3929),
    [anon_sym_u8_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [sym_true] = ACTIONS(3927),
    [sym_false] = ACTIONS(3927),
    [anon_sym_NULL] = ACTIONS(3927),
    [anon_sym_nullptr] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3927),
    [anon_sym_let] = ACTIONS(3927),
    [anon_sym_This] = ACTIONS(3927),
    [anon_sym_decltype] = ACTIONS(3927),
    [anon_sym_explicit] = ACTIONS(3927),
    [anon_sym_typename] = ACTIONS(3927),
    [anon_sym_export] = ACTIONS(3927),
    [anon_sym_module] = ACTIONS(3927),
    [anon_sym_import] = ACTIONS(3927),
    [anon_sym_template] = ACTIONS(3927),
    [anon_sym_operator] = ACTIONS(3927),
    [anon_sym_try] = ACTIONS(3927),
    [anon_sym_delete] = ACTIONS(3927),
    [anon_sym_throw] = ACTIONS(3927),
    [anon_sym_namespace] = ACTIONS(3927),
    [anon_sym_static_assert] = ACTIONS(3927),
    [anon_sym_concept] = ACTIONS(3927),
    [anon_sym_co_return] = ACTIONS(3927),
    [anon_sym_co_yield] = ACTIONS(3927),
    [anon_sym_R_DQUOTE] = ACTIONS(3929),
    [anon_sym_LR_DQUOTE] = ACTIONS(3929),
    [anon_sym_uR_DQUOTE] = ACTIONS(3929),
    [anon_sym_UR_DQUOTE] = ACTIONS(3929),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3929),
    [anon_sym_co_await] = ACTIONS(3927),
    [anon_sym_new] = ACTIONS(3927),
    [anon_sym_requires] = ACTIONS(3927),
    [sym_this] = ACTIONS(3927),
    [anon_sym_precise] = ACTIONS(3927),
    [anon_sym_shared] = ACTIONS(3927),
    [anon_sym_groupshared] = ACTIONS(3927),
    [anon_sym_uniform] = ACTIONS(3927),
    [anon_sym_row_major] = ACTIONS(3927),
    [anon_sym_column_major] = ACTIONS(3927),
    [anon_sym_globallycoherent] = ACTIONS(3927),
    [anon_sym_centroid] = ACTIONS(3927),
    [anon_sym_noperspective] = ACTIONS(3927),
    [anon_sym_nointerpolation] = ACTIONS(3927),
    [anon_sym_sample] = ACTIONS(3927),
    [anon_sym_linear] = ACTIONS(3927),
    [anon_sym_snorm] = ACTIONS(3927),
    [anon_sym_unorm] = ACTIONS(3927),
    [anon_sym_point] = ACTIONS(3927),
    [anon_sym_line] = ACTIONS(3927),
    [anon_sym_triangleadj] = ACTIONS(3927),
    [anon_sym_lineadj] = ACTIONS(3927),
    [anon_sym_triangle] = ACTIONS(3927),
    [anon_sym_interface] = ACTIONS(3927),
    [anon_sym_extension] = ACTIONS(3927),
    [anon_sym___exported] = ACTIONS(3927),
  },
  [1032] = {
    [ts_builtin_sym_end] = ACTIONS(3933),
    [sym_identifier] = ACTIONS(3931),
    [aux_sym_preproc_include_token1] = ACTIONS(3931),
    [aux_sym_preproc_def_token1] = ACTIONS(3931),
    [aux_sym_preproc_if_token1] = ACTIONS(3931),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3931),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3931),
    [sym_preproc_directive] = ACTIONS(3931),
    [anon_sym_LPAREN2] = ACTIONS(3933),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_TILDE] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3931),
    [anon_sym_STAR] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_SEMI] = ACTIONS(3933),
    [anon_sym___extension__] = ACTIONS(3931),
    [anon_sym_typedef] = ACTIONS(3931),
    [anon_sym_in] = ACTIONS(3931),
    [anon_sym_out] = ACTIONS(3931),
    [anon_sym_inout] = ACTIONS(3931),
    [anon_sym_virtual] = ACTIONS(3931),
    [anon_sym_extern] = ACTIONS(3931),
    [anon_sym___attribute__] = ACTIONS(3931),
    [anon_sym___attribute] = ACTIONS(3931),
    [anon_sym_using] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3933),
    [anon_sym___declspec] = ACTIONS(3931),
    [anon_sym___based] = ACTIONS(3931),
    [anon_sym___cdecl] = ACTIONS(3931),
    [anon_sym___clrcall] = ACTIONS(3931),
    [anon_sym___stdcall] = ACTIONS(3931),
    [anon_sym___fastcall] = ACTIONS(3931),
    [anon_sym___thiscall] = ACTIONS(3931),
    [anon_sym___vectorcall] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3933),
    [anon_sym_signed] = ACTIONS(3931),
    [anon_sym_unsigned] = ACTIONS(3931),
    [anon_sym_long] = ACTIONS(3931),
    [anon_sym_short] = ACTIONS(3931),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_static] = ACTIONS(3931),
    [anon_sym_register] = ACTIONS(3931),
    [anon_sym_inline] = ACTIONS(3931),
    [anon_sym___inline] = ACTIONS(3931),
    [anon_sym___inline__] = ACTIONS(3931),
    [anon_sym___forceinline] = ACTIONS(3931),
    [anon_sym_thread_local] = ACTIONS(3931),
    [anon_sym___thread] = ACTIONS(3931),
    [anon_sym_const] = ACTIONS(3931),
    [anon_sym_constexpr] = ACTIONS(3931),
    [anon_sym_volatile] = ACTIONS(3931),
    [anon_sym_restrict] = ACTIONS(3931),
    [anon_sym___restrict__] = ACTIONS(3931),
    [anon_sym__Atomic] = ACTIONS(3931),
    [anon_sym__Noreturn] = ACTIONS(3931),
    [anon_sym_noreturn] = ACTIONS(3931),
    [anon_sym__Nonnull] = ACTIONS(3931),
    [anon_sym_mutable] = ACTIONS(3931),
    [anon_sym_constinit] = ACTIONS(3931),
    [anon_sym_consteval] = ACTIONS(3931),
    [anon_sym_alignas] = ACTIONS(3931),
    [anon_sym__Alignas] = ACTIONS(3931),
    [sym_primitive_type] = ACTIONS(3931),
    [anon_sym_enum] = ACTIONS(3931),
    [anon_sym_class] = ACTIONS(3931),
    [anon_sym_struct] = ACTIONS(3931),
    [anon_sym_union] = ACTIONS(3931),
    [anon_sym_if] = ACTIONS(3931),
    [anon_sym_switch] = ACTIONS(3931),
    [anon_sym_case] = ACTIONS(3931),
    [anon_sym_default] = ACTIONS(3931),
    [anon_sym_while] = ACTIONS(3931),
    [anon_sym_do] = ACTIONS(3931),
    [anon_sym_for] = ACTIONS(3931),
    [anon_sym_return] = ACTIONS(3931),
    [anon_sym_break] = ACTIONS(3931),
    [anon_sym_continue] = ACTIONS(3931),
    [anon_sym_goto] = ACTIONS(3931),
    [anon_sym_not] = ACTIONS(3931),
    [anon_sym_compl] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_sizeof] = ACTIONS(3931),
    [anon_sym___alignof__] = ACTIONS(3931),
    [anon_sym___alignof] = ACTIONS(3931),
    [anon_sym__alignof] = ACTIONS(3931),
    [anon_sym_alignof] = ACTIONS(3931),
    [anon_sym__Alignof] = ACTIONS(3931),
    [anon_sym_offsetof] = ACTIONS(3931),
    [anon_sym__Generic] = ACTIONS(3931),
    [anon_sym_asm] = ACTIONS(3931),
    [anon_sym___asm__] = ACTIONS(3931),
    [anon_sym___asm] = ACTIONS(3931),
    [sym_number_literal] = ACTIONS(3933),
    [anon_sym_L_SQUOTE] = ACTIONS(3933),
    [anon_sym_u_SQUOTE] = ACTIONS(3933),
    [anon_sym_U_SQUOTE] = ACTIONS(3933),
    [anon_sym_u8_SQUOTE] = ACTIONS(3933),
    [anon_sym_SQUOTE] = ACTIONS(3933),
    [anon_sym_L_DQUOTE] = ACTIONS(3933),
    [anon_sym_u_DQUOTE] = ACTIONS(3933),
    [anon_sym_U_DQUOTE] = ACTIONS(3933),
    [anon_sym_u8_DQUOTE] = ACTIONS(3933),
    [anon_sym_DQUOTE] = ACTIONS(3933),
    [sym_true] = ACTIONS(3931),
    [sym_false] = ACTIONS(3931),
    [anon_sym_NULL] = ACTIONS(3931),
    [anon_sym_nullptr] = ACTIONS(3931),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3931),
    [anon_sym_let] = ACTIONS(3931),
    [anon_sym_This] = ACTIONS(3931),
    [anon_sym_decltype] = ACTIONS(3931),
    [anon_sym_explicit] = ACTIONS(3931),
    [anon_sym_typename] = ACTIONS(3931),
    [anon_sym_export] = ACTIONS(3931),
    [anon_sym_module] = ACTIONS(3931),
    [anon_sym_import] = ACTIONS(3931),
    [anon_sym_template] = ACTIONS(3931),
    [anon_sym_operator] = ACTIONS(3931),
    [anon_sym_try] = ACTIONS(3931),
    [anon_sym_delete] = ACTIONS(3931),
    [anon_sym_throw] = ACTIONS(3931),
    [anon_sym_namespace] = ACTIONS(3931),
    [anon_sym_static_assert] = ACTIONS(3931),
    [anon_sym_concept] = ACTIONS(3931),
    [anon_sym_co_return] = ACTIONS(3931),
    [anon_sym_co_yield] = ACTIONS(3931),
    [anon_sym_R_DQUOTE] = ACTIONS(3933),
    [anon_sym_LR_DQUOTE] = ACTIONS(3933),
    [anon_sym_uR_DQUOTE] = ACTIONS(3933),
    [anon_sym_UR_DQUOTE] = ACTIONS(3933),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3933),
    [anon_sym_co_await] = ACTIONS(3931),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_requires] = ACTIONS(3931),
    [sym_this] = ACTIONS(3931),
    [anon_sym_precise] = ACTIONS(3931),
    [anon_sym_shared] = ACTIONS(3931),
    [anon_sym_groupshared] = ACTIONS(3931),
    [anon_sym_uniform] = ACTIONS(3931),
    [anon_sym_row_major] = ACTIONS(3931),
    [anon_sym_column_major] = ACTIONS(3931),
    [anon_sym_globallycoherent] = ACTIONS(3931),
    [anon_sym_centroid] = ACTIONS(3931),
    [anon_sym_noperspective] = ACTIONS(3931),
    [anon_sym_nointerpolation] = ACTIONS(3931),
    [anon_sym_sample] = ACTIONS(3931),
    [anon_sym_linear] = ACTIONS(3931),
    [anon_sym_snorm] = ACTIONS(3931),
    [anon_sym_unorm] = ACTIONS(3931),
    [anon_sym_point] = ACTIONS(3931),
    [anon_sym_line] = ACTIONS(3931),
    [anon_sym_triangleadj] = ACTIONS(3931),
    [anon_sym_lineadj] = ACTIONS(3931),
    [anon_sym_triangle] = ACTIONS(3931),
    [anon_sym_interface] = ACTIONS(3931),
    [anon_sym_extension] = ACTIONS(3931),
    [anon_sym___exported] = ACTIONS(3931),
  },
  [1033] = {
    [ts_builtin_sym_end] = ACTIONS(3937),
    [sym_identifier] = ACTIONS(3935),
    [aux_sym_preproc_include_token1] = ACTIONS(3935),
    [aux_sym_preproc_def_token1] = ACTIONS(3935),
    [aux_sym_preproc_if_token1] = ACTIONS(3935),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3935),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3935),
    [sym_preproc_directive] = ACTIONS(3935),
    [anon_sym_LPAREN2] = ACTIONS(3937),
    [anon_sym_BANG] = ACTIONS(3937),
    [anon_sym_TILDE] = ACTIONS(3937),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3935),
    [anon_sym_STAR] = ACTIONS(3937),
    [anon_sym_AMP_AMP] = ACTIONS(3937),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_SEMI] = ACTIONS(3937),
    [anon_sym___extension__] = ACTIONS(3935),
    [anon_sym_typedef] = ACTIONS(3935),
    [anon_sym_in] = ACTIONS(3935),
    [anon_sym_out] = ACTIONS(3935),
    [anon_sym_inout] = ACTIONS(3935),
    [anon_sym_virtual] = ACTIONS(3935),
    [anon_sym_extern] = ACTIONS(3935),
    [anon_sym___attribute__] = ACTIONS(3935),
    [anon_sym___attribute] = ACTIONS(3935),
    [anon_sym_using] = ACTIONS(3935),
    [anon_sym_COLON_COLON] = ACTIONS(3937),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3937),
    [anon_sym___declspec] = ACTIONS(3935),
    [anon_sym___based] = ACTIONS(3935),
    [anon_sym___cdecl] = ACTIONS(3935),
    [anon_sym___clrcall] = ACTIONS(3935),
    [anon_sym___stdcall] = ACTIONS(3935),
    [anon_sym___fastcall] = ACTIONS(3935),
    [anon_sym___thiscall] = ACTIONS(3935),
    [anon_sym___vectorcall] = ACTIONS(3935),
    [anon_sym_LBRACE] = ACTIONS(3937),
    [anon_sym_signed] = ACTIONS(3935),
    [anon_sym_unsigned] = ACTIONS(3935),
    [anon_sym_long] = ACTIONS(3935),
    [anon_sym_short] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3935),
    [anon_sym_static] = ACTIONS(3935),
    [anon_sym_register] = ACTIONS(3935),
    [anon_sym_inline] = ACTIONS(3935),
    [anon_sym___inline] = ACTIONS(3935),
    [anon_sym___inline__] = ACTIONS(3935),
    [anon_sym___forceinline] = ACTIONS(3935),
    [anon_sym_thread_local] = ACTIONS(3935),
    [anon_sym___thread] = ACTIONS(3935),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_constexpr] = ACTIONS(3935),
    [anon_sym_volatile] = ACTIONS(3935),
    [anon_sym_restrict] = ACTIONS(3935),
    [anon_sym___restrict__] = ACTIONS(3935),
    [anon_sym__Atomic] = ACTIONS(3935),
    [anon_sym__Noreturn] = ACTIONS(3935),
    [anon_sym_noreturn] = ACTIONS(3935),
    [anon_sym__Nonnull] = ACTIONS(3935),
    [anon_sym_mutable] = ACTIONS(3935),
    [anon_sym_constinit] = ACTIONS(3935),
    [anon_sym_consteval] = ACTIONS(3935),
    [anon_sym_alignas] = ACTIONS(3935),
    [anon_sym__Alignas] = ACTIONS(3935),
    [sym_primitive_type] = ACTIONS(3935),
    [anon_sym_enum] = ACTIONS(3935),
    [anon_sym_class] = ACTIONS(3935),
    [anon_sym_struct] = ACTIONS(3935),
    [anon_sym_union] = ACTIONS(3935),
    [anon_sym_if] = ACTIONS(3935),
    [anon_sym_switch] = ACTIONS(3935),
    [anon_sym_case] = ACTIONS(3935),
    [anon_sym_default] = ACTIONS(3935),
    [anon_sym_while] = ACTIONS(3935),
    [anon_sym_do] = ACTIONS(3935),
    [anon_sym_for] = ACTIONS(3935),
    [anon_sym_return] = ACTIONS(3935),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_continue] = ACTIONS(3935),
    [anon_sym_goto] = ACTIONS(3935),
    [anon_sym_not] = ACTIONS(3935),
    [anon_sym_compl] = ACTIONS(3935),
    [anon_sym_DASH_DASH] = ACTIONS(3937),
    [anon_sym_PLUS_PLUS] = ACTIONS(3937),
    [anon_sym_sizeof] = ACTIONS(3935),
    [anon_sym___alignof__] = ACTIONS(3935),
    [anon_sym___alignof] = ACTIONS(3935),
    [anon_sym__alignof] = ACTIONS(3935),
    [anon_sym_alignof] = ACTIONS(3935),
    [anon_sym__Alignof] = ACTIONS(3935),
    [anon_sym_offsetof] = ACTIONS(3935),
    [anon_sym__Generic] = ACTIONS(3935),
    [anon_sym_asm] = ACTIONS(3935),
    [anon_sym___asm__] = ACTIONS(3935),
    [anon_sym___asm] = ACTIONS(3935),
    [sym_number_literal] = ACTIONS(3937),
    [anon_sym_L_SQUOTE] = ACTIONS(3937),
    [anon_sym_u_SQUOTE] = ACTIONS(3937),
    [anon_sym_U_SQUOTE] = ACTIONS(3937),
    [anon_sym_u8_SQUOTE] = ACTIONS(3937),
    [anon_sym_SQUOTE] = ACTIONS(3937),
    [anon_sym_L_DQUOTE] = ACTIONS(3937),
    [anon_sym_u_DQUOTE] = ACTIONS(3937),
    [anon_sym_U_DQUOTE] = ACTIONS(3937),
    [anon_sym_u8_DQUOTE] = ACTIONS(3937),
    [anon_sym_DQUOTE] = ACTIONS(3937),
    [sym_true] = ACTIONS(3935),
    [sym_false] = ACTIONS(3935),
    [anon_sym_NULL] = ACTIONS(3935),
    [anon_sym_nullptr] = ACTIONS(3935),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3935),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_This] = ACTIONS(3935),
    [anon_sym_decltype] = ACTIONS(3935),
    [anon_sym_explicit] = ACTIONS(3935),
    [anon_sym_typename] = ACTIONS(3935),
    [anon_sym_export] = ACTIONS(3935),
    [anon_sym_module] = ACTIONS(3935),
    [anon_sym_import] = ACTIONS(3935),
    [anon_sym_template] = ACTIONS(3935),
    [anon_sym_operator] = ACTIONS(3935),
    [anon_sym_try] = ACTIONS(3935),
    [anon_sym_delete] = ACTIONS(3935),
    [anon_sym_throw] = ACTIONS(3935),
    [anon_sym_namespace] = ACTIONS(3935),
    [anon_sym_static_assert] = ACTIONS(3935),
    [anon_sym_concept] = ACTIONS(3935),
    [anon_sym_co_return] = ACTIONS(3935),
    [anon_sym_co_yield] = ACTIONS(3935),
    [anon_sym_R_DQUOTE] = ACTIONS(3937),
    [anon_sym_LR_DQUOTE] = ACTIONS(3937),
    [anon_sym_uR_DQUOTE] = ACTIONS(3937),
    [anon_sym_UR_DQUOTE] = ACTIONS(3937),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3937),
    [anon_sym_co_await] = ACTIONS(3935),
    [anon_sym_new] = ACTIONS(3935),
    [anon_sym_requires] = ACTIONS(3935),
    [sym_this] = ACTIONS(3935),
    [anon_sym_precise] = ACTIONS(3935),
    [anon_sym_shared] = ACTIONS(3935),
    [anon_sym_groupshared] = ACTIONS(3935),
    [anon_sym_uniform] = ACTIONS(3935),
    [anon_sym_row_major] = ACTIONS(3935),
    [anon_sym_column_major] = ACTIONS(3935),
    [anon_sym_globallycoherent] = ACTIONS(3935),
    [anon_sym_centroid] = ACTIONS(3935),
    [anon_sym_noperspective] = ACTIONS(3935),
    [anon_sym_nointerpolation] = ACTIONS(3935),
    [anon_sym_sample] = ACTIONS(3935),
    [anon_sym_linear] = ACTIONS(3935),
    [anon_sym_snorm] = ACTIONS(3935),
    [anon_sym_unorm] = ACTIONS(3935),
    [anon_sym_point] = ACTIONS(3935),
    [anon_sym_line] = ACTIONS(3935),
    [anon_sym_triangleadj] = ACTIONS(3935),
    [anon_sym_lineadj] = ACTIONS(3935),
    [anon_sym_triangle] = ACTIONS(3935),
    [anon_sym_interface] = ACTIONS(3935),
    [anon_sym_extension] = ACTIONS(3935),
    [anon_sym___exported] = ACTIONS(3935),
  },
  [1034] = {
    [ts_builtin_sym_end] = ACTIONS(4305),
    [sym_identifier] = ACTIONS(4307),
    [aux_sym_preproc_include_token1] = ACTIONS(4307),
    [aux_sym_preproc_def_token1] = ACTIONS(4307),
    [aux_sym_preproc_if_token1] = ACTIONS(4307),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4307),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4307),
    [sym_preproc_directive] = ACTIONS(4307),
    [anon_sym_LPAREN2] = ACTIONS(4305),
    [anon_sym_BANG] = ACTIONS(4305),
    [anon_sym_TILDE] = ACTIONS(4305),
    [anon_sym_DASH] = ACTIONS(4307),
    [anon_sym_PLUS] = ACTIONS(4307),
    [anon_sym_STAR] = ACTIONS(4305),
    [anon_sym_AMP_AMP] = ACTIONS(4305),
    [anon_sym_AMP] = ACTIONS(4307),
    [anon_sym_SEMI] = ACTIONS(4305),
    [anon_sym___extension__] = ACTIONS(4307),
    [anon_sym_typedef] = ACTIONS(4307),
    [anon_sym_in] = ACTIONS(4307),
    [anon_sym_out] = ACTIONS(4307),
    [anon_sym_inout] = ACTIONS(4307),
    [anon_sym_virtual] = ACTIONS(4307),
    [anon_sym_extern] = ACTIONS(4307),
    [anon_sym___attribute__] = ACTIONS(4307),
    [anon_sym___attribute] = ACTIONS(4307),
    [anon_sym_using] = ACTIONS(4307),
    [anon_sym_COLON_COLON] = ACTIONS(4305),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4305),
    [anon_sym___declspec] = ACTIONS(4307),
    [anon_sym___based] = ACTIONS(4307),
    [anon_sym___cdecl] = ACTIONS(4307),
    [anon_sym___clrcall] = ACTIONS(4307),
    [anon_sym___stdcall] = ACTIONS(4307),
    [anon_sym___fastcall] = ACTIONS(4307),
    [anon_sym___thiscall] = ACTIONS(4307),
    [anon_sym___vectorcall] = ACTIONS(4307),
    [anon_sym_LBRACE] = ACTIONS(4305),
    [anon_sym_signed] = ACTIONS(4307),
    [anon_sym_unsigned] = ACTIONS(4307),
    [anon_sym_long] = ACTIONS(4307),
    [anon_sym_short] = ACTIONS(4307),
    [anon_sym_LBRACK] = ACTIONS(4307),
    [anon_sym_static] = ACTIONS(4307),
    [anon_sym_register] = ACTIONS(4307),
    [anon_sym_inline] = ACTIONS(4307),
    [anon_sym___inline] = ACTIONS(4307),
    [anon_sym___inline__] = ACTIONS(4307),
    [anon_sym___forceinline] = ACTIONS(4307),
    [anon_sym_thread_local] = ACTIONS(4307),
    [anon_sym___thread] = ACTIONS(4307),
    [anon_sym_const] = ACTIONS(4307),
    [anon_sym_constexpr] = ACTIONS(4307),
    [anon_sym_volatile] = ACTIONS(4307),
    [anon_sym_restrict] = ACTIONS(4307),
    [anon_sym___restrict__] = ACTIONS(4307),
    [anon_sym__Atomic] = ACTIONS(4307),
    [anon_sym__Noreturn] = ACTIONS(4307),
    [anon_sym_noreturn] = ACTIONS(4307),
    [anon_sym__Nonnull] = ACTIONS(4307),
    [anon_sym_mutable] = ACTIONS(4307),
    [anon_sym_constinit] = ACTIONS(4307),
    [anon_sym_consteval] = ACTIONS(4307),
    [anon_sym_alignas] = ACTIONS(4307),
    [anon_sym__Alignas] = ACTIONS(4307),
    [sym_primitive_type] = ACTIONS(4307),
    [anon_sym_enum] = ACTIONS(4307),
    [anon_sym_class] = ACTIONS(4307),
    [anon_sym_struct] = ACTIONS(4307),
    [anon_sym_union] = ACTIONS(4307),
    [anon_sym_if] = ACTIONS(4307),
    [anon_sym_switch] = ACTIONS(4307),
    [anon_sym_case] = ACTIONS(4307),
    [anon_sym_default] = ACTIONS(4307),
    [anon_sym_while] = ACTIONS(4307),
    [anon_sym_do] = ACTIONS(4307),
    [anon_sym_for] = ACTIONS(4307),
    [anon_sym_return] = ACTIONS(4307),
    [anon_sym_break] = ACTIONS(4307),
    [anon_sym_continue] = ACTIONS(4307),
    [anon_sym_goto] = ACTIONS(4307),
    [anon_sym_not] = ACTIONS(4307),
    [anon_sym_compl] = ACTIONS(4307),
    [anon_sym_DASH_DASH] = ACTIONS(4305),
    [anon_sym_PLUS_PLUS] = ACTIONS(4305),
    [anon_sym_sizeof] = ACTIONS(4307),
    [anon_sym___alignof__] = ACTIONS(4307),
    [anon_sym___alignof] = ACTIONS(4307),
    [anon_sym__alignof] = ACTIONS(4307),
    [anon_sym_alignof] = ACTIONS(4307),
    [anon_sym__Alignof] = ACTIONS(4307),
    [anon_sym_offsetof] = ACTIONS(4307),
    [anon_sym__Generic] = ACTIONS(4307),
    [anon_sym_asm] = ACTIONS(4307),
    [anon_sym___asm__] = ACTIONS(4307),
    [anon_sym___asm] = ACTIONS(4307),
    [sym_number_literal] = ACTIONS(4305),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4305),
    [anon_sym_u_DQUOTE] = ACTIONS(4305),
    [anon_sym_U_DQUOTE] = ACTIONS(4305),
    [anon_sym_u8_DQUOTE] = ACTIONS(4305),
    [anon_sym_DQUOTE] = ACTIONS(4305),
    [sym_true] = ACTIONS(4307),
    [sym_false] = ACTIONS(4307),
    [anon_sym_NULL] = ACTIONS(4307),
    [anon_sym_nullptr] = ACTIONS(4307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4307),
    [anon_sym_let] = ACTIONS(4307),
    [anon_sym_This] = ACTIONS(4307),
    [anon_sym_decltype] = ACTIONS(4307),
    [anon_sym_explicit] = ACTIONS(4307),
    [anon_sym_typename] = ACTIONS(4307),
    [anon_sym_export] = ACTIONS(4307),
    [anon_sym_module] = ACTIONS(4307),
    [anon_sym_import] = ACTIONS(4307),
    [anon_sym_template] = ACTIONS(4307),
    [anon_sym_operator] = ACTIONS(4307),
    [anon_sym_try] = ACTIONS(4307),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_throw] = ACTIONS(4307),
    [anon_sym_namespace] = ACTIONS(4307),
    [anon_sym_static_assert] = ACTIONS(4307),
    [anon_sym_concept] = ACTIONS(4307),
    [anon_sym_co_return] = ACTIONS(4307),
    [anon_sym_co_yield] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4305),
    [anon_sym_LR_DQUOTE] = ACTIONS(4305),
    [anon_sym_uR_DQUOTE] = ACTIONS(4305),
    [anon_sym_UR_DQUOTE] = ACTIONS(4305),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4305),
    [anon_sym_co_await] = ACTIONS(4307),
    [anon_sym_new] = ACTIONS(4307),
    [anon_sym_requires] = ACTIONS(4307),
    [sym_this] = ACTIONS(4307),
    [anon_sym_precise] = ACTIONS(4307),
    [anon_sym_shared] = ACTIONS(4307),
    [anon_sym_groupshared] = ACTIONS(4307),
    [anon_sym_uniform] = ACTIONS(4307),
    [anon_sym_row_major] = ACTIONS(4307),
    [anon_sym_column_major] = ACTIONS(4307),
    [anon_sym_globallycoherent] = ACTIONS(4307),
    [anon_sym_centroid] = ACTIONS(4307),
    [anon_sym_noperspective] = ACTIONS(4307),
    [anon_sym_nointerpolation] = ACTIONS(4307),
    [anon_sym_sample] = ACTIONS(4307),
    [anon_sym_linear] = ACTIONS(4307),
    [anon_sym_snorm] = ACTIONS(4307),
    [anon_sym_unorm] = ACTIONS(4307),
    [anon_sym_point] = ACTIONS(4307),
    [anon_sym_line] = ACTIONS(4307),
    [anon_sym_triangleadj] = ACTIONS(4307),
    [anon_sym_lineadj] = ACTIONS(4307),
    [anon_sym_triangle] = ACTIONS(4307),
    [anon_sym_interface] = ACTIONS(4307),
    [anon_sym_extension] = ACTIONS(4307),
    [anon_sym___exported] = ACTIONS(4307),
  },
  [1035] = {
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_include_token1] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token2] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_BANG] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3812),
    [anon_sym_PLUS] = ACTIONS(3812),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym___cdecl] = ACTIONS(3812),
    [anon_sym___clrcall] = ACTIONS(3812),
    [anon_sym___stdcall] = ACTIONS(3812),
    [anon_sym___fastcall] = ACTIONS(3812),
    [anon_sym___thiscall] = ACTIONS(3812),
    [anon_sym___vectorcall] = ACTIONS(3812),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [anon_sym_if] = ACTIONS(3812),
    [anon_sym_switch] = ACTIONS(3812),
    [anon_sym_case] = ACTIONS(3812),
    [anon_sym_default] = ACTIONS(3812),
    [anon_sym_while] = ACTIONS(3812),
    [anon_sym_do] = ACTIONS(3812),
    [anon_sym_for] = ACTIONS(3812),
    [anon_sym_return] = ACTIONS(3812),
    [anon_sym_break] = ACTIONS(3812),
    [anon_sym_continue] = ACTIONS(3812),
    [anon_sym_goto] = ACTIONS(3812),
    [anon_sym___try] = ACTIONS(3812),
    [anon_sym___leave] = ACTIONS(3812),
    [anon_sym_not] = ACTIONS(3812),
    [anon_sym_compl] = ACTIONS(3812),
    [anon_sym_DASH_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_PLUS] = ACTIONS(3814),
    [anon_sym_sizeof] = ACTIONS(3812),
    [anon_sym___alignof__] = ACTIONS(3812),
    [anon_sym___alignof] = ACTIONS(3812),
    [anon_sym__alignof] = ACTIONS(3812),
    [anon_sym_alignof] = ACTIONS(3812),
    [anon_sym__Alignof] = ACTIONS(3812),
    [anon_sym_offsetof] = ACTIONS(3812),
    [anon_sym__Generic] = ACTIONS(3812),
    [anon_sym_asm] = ACTIONS(3812),
    [anon_sym___asm__] = ACTIONS(3812),
    [anon_sym___asm] = ACTIONS(3812),
    [sym_number_literal] = ACTIONS(3814),
    [anon_sym_L_SQUOTE] = ACTIONS(3814),
    [anon_sym_u_SQUOTE] = ACTIONS(3814),
    [anon_sym_U_SQUOTE] = ACTIONS(3814),
    [anon_sym_u8_SQUOTE] = ACTIONS(3814),
    [anon_sym_SQUOTE] = ACTIONS(3814),
    [anon_sym_L_DQUOTE] = ACTIONS(3814),
    [anon_sym_u_DQUOTE] = ACTIONS(3814),
    [anon_sym_U_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [anon_sym_NULL] = ACTIONS(3812),
    [anon_sym_nullptr] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_try] = ACTIONS(3812),
    [anon_sym_delete] = ACTIONS(3812),
    [anon_sym_throw] = ACTIONS(3812),
    [anon_sym_namespace] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_concept] = ACTIONS(3812),
    [anon_sym_co_return] = ACTIONS(3812),
    [anon_sym_co_yield] = ACTIONS(3812),
    [anon_sym_R_DQUOTE] = ACTIONS(3814),
    [anon_sym_LR_DQUOTE] = ACTIONS(3814),
    [anon_sym_uR_DQUOTE] = ACTIONS(3814),
    [anon_sym_UR_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3814),
    [anon_sym_co_await] = ACTIONS(3812),
    [anon_sym_new] = ACTIONS(3812),
    [anon_sym_requires] = ACTIONS(3812),
    [sym_this] = ACTIONS(3812),
    [anon_sym_discard] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_cbuffer] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
  },
  [1036] = {
    [sym_identifier] = ACTIONS(3665),
    [aux_sym_preproc_include_token1] = ACTIONS(3665),
    [aux_sym_preproc_def_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token2] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3665),
    [sym_preproc_directive] = ACTIONS(3665),
    [anon_sym_LPAREN2] = ACTIONS(3667),
    [anon_sym_BANG] = ACTIONS(3667),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_DASH] = ACTIONS(3665),
    [anon_sym_PLUS] = ACTIONS(3665),
    [anon_sym_STAR] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_SEMI] = ACTIONS(3667),
    [anon_sym___extension__] = ACTIONS(3665),
    [anon_sym_typedef] = ACTIONS(3665),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_out] = ACTIONS(3665),
    [anon_sym_inout] = ACTIONS(3665),
    [anon_sym_virtual] = ACTIONS(3665),
    [anon_sym_extern] = ACTIONS(3665),
    [anon_sym___attribute__] = ACTIONS(3665),
    [anon_sym___attribute] = ACTIONS(3665),
    [anon_sym_using] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(3667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3667),
    [anon_sym___declspec] = ACTIONS(3665),
    [anon_sym___based] = ACTIONS(3665),
    [anon_sym___cdecl] = ACTIONS(3665),
    [anon_sym___clrcall] = ACTIONS(3665),
    [anon_sym___stdcall] = ACTIONS(3665),
    [anon_sym___fastcall] = ACTIONS(3665),
    [anon_sym___thiscall] = ACTIONS(3665),
    [anon_sym___vectorcall] = ACTIONS(3665),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_signed] = ACTIONS(3665),
    [anon_sym_unsigned] = ACTIONS(3665),
    [anon_sym_long] = ACTIONS(3665),
    [anon_sym_short] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3665),
    [anon_sym_static] = ACTIONS(3665),
    [anon_sym_register] = ACTIONS(3665),
    [anon_sym_inline] = ACTIONS(3665),
    [anon_sym___inline] = ACTIONS(3665),
    [anon_sym___inline__] = ACTIONS(3665),
    [anon_sym___forceinline] = ACTIONS(3665),
    [anon_sym_thread_local] = ACTIONS(3665),
    [anon_sym___thread] = ACTIONS(3665),
    [anon_sym_const] = ACTIONS(3665),
    [anon_sym_constexpr] = ACTIONS(3665),
    [anon_sym_volatile] = ACTIONS(3665),
    [anon_sym_restrict] = ACTIONS(3665),
    [anon_sym___restrict__] = ACTIONS(3665),
    [anon_sym__Atomic] = ACTIONS(3665),
    [anon_sym__Noreturn] = ACTIONS(3665),
    [anon_sym_noreturn] = ACTIONS(3665),
    [anon_sym__Nonnull] = ACTIONS(3665),
    [anon_sym_mutable] = ACTIONS(3665),
    [anon_sym_constinit] = ACTIONS(3665),
    [anon_sym_consteval] = ACTIONS(3665),
    [anon_sym_alignas] = ACTIONS(3665),
    [anon_sym__Alignas] = ACTIONS(3665),
    [sym_primitive_type] = ACTIONS(3665),
    [anon_sym_enum] = ACTIONS(3665),
    [anon_sym_class] = ACTIONS(3665),
    [anon_sym_struct] = ACTIONS(3665),
    [anon_sym_union] = ACTIONS(3665),
    [anon_sym_if] = ACTIONS(3665),
    [anon_sym_switch] = ACTIONS(3665),
    [anon_sym_case] = ACTIONS(3665),
    [anon_sym_default] = ACTIONS(3665),
    [anon_sym_while] = ACTIONS(3665),
    [anon_sym_do] = ACTIONS(3665),
    [anon_sym_for] = ACTIONS(3665),
    [anon_sym_return] = ACTIONS(3665),
    [anon_sym_break] = ACTIONS(3665),
    [anon_sym_continue] = ACTIONS(3665),
    [anon_sym_goto] = ACTIONS(3665),
    [anon_sym___try] = ACTIONS(3665),
    [anon_sym___leave] = ACTIONS(3665),
    [anon_sym_not] = ACTIONS(3665),
    [anon_sym_compl] = ACTIONS(3665),
    [anon_sym_DASH_DASH] = ACTIONS(3667),
    [anon_sym_PLUS_PLUS] = ACTIONS(3667),
    [anon_sym_sizeof] = ACTIONS(3665),
    [anon_sym___alignof__] = ACTIONS(3665),
    [anon_sym___alignof] = ACTIONS(3665),
    [anon_sym__alignof] = ACTIONS(3665),
    [anon_sym_alignof] = ACTIONS(3665),
    [anon_sym__Alignof] = ACTIONS(3665),
    [anon_sym_offsetof] = ACTIONS(3665),
    [anon_sym__Generic] = ACTIONS(3665),
    [anon_sym_asm] = ACTIONS(3665),
    [anon_sym___asm__] = ACTIONS(3665),
    [anon_sym___asm] = ACTIONS(3665),
    [sym_number_literal] = ACTIONS(3667),
    [anon_sym_L_SQUOTE] = ACTIONS(3667),
    [anon_sym_u_SQUOTE] = ACTIONS(3667),
    [anon_sym_U_SQUOTE] = ACTIONS(3667),
    [anon_sym_u8_SQUOTE] = ACTIONS(3667),
    [anon_sym_SQUOTE] = ACTIONS(3667),
    [anon_sym_L_DQUOTE] = ACTIONS(3667),
    [anon_sym_u_DQUOTE] = ACTIONS(3667),
    [anon_sym_U_DQUOTE] = ACTIONS(3667),
    [anon_sym_u8_DQUOTE] = ACTIONS(3667),
    [anon_sym_DQUOTE] = ACTIONS(3667),
    [sym_true] = ACTIONS(3665),
    [sym_false] = ACTIONS(3665),
    [anon_sym_NULL] = ACTIONS(3665),
    [anon_sym_nullptr] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3665),
    [anon_sym_let] = ACTIONS(3665),
    [anon_sym_This] = ACTIONS(3665),
    [anon_sym_decltype] = ACTIONS(3665),
    [anon_sym_explicit] = ACTIONS(3665),
    [anon_sym_typename] = ACTIONS(3665),
    [anon_sym_template] = ACTIONS(3665),
    [anon_sym_operator] = ACTIONS(3665),
    [anon_sym_try] = ACTIONS(3665),
    [anon_sym_delete] = ACTIONS(3665),
    [anon_sym_throw] = ACTIONS(3665),
    [anon_sym_namespace] = ACTIONS(3665),
    [anon_sym_static_assert] = ACTIONS(3665),
    [anon_sym_concept] = ACTIONS(3665),
    [anon_sym_co_return] = ACTIONS(3665),
    [anon_sym_co_yield] = ACTIONS(3665),
    [anon_sym_R_DQUOTE] = ACTIONS(3667),
    [anon_sym_LR_DQUOTE] = ACTIONS(3667),
    [anon_sym_uR_DQUOTE] = ACTIONS(3667),
    [anon_sym_UR_DQUOTE] = ACTIONS(3667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3667),
    [anon_sym_co_await] = ACTIONS(3665),
    [anon_sym_new] = ACTIONS(3665),
    [anon_sym_requires] = ACTIONS(3665),
    [sym_this] = ACTIONS(3665),
    [anon_sym_discard] = ACTIONS(3665),
    [anon_sym_precise] = ACTIONS(3665),
    [anon_sym_shared] = ACTIONS(3665),
    [anon_sym_groupshared] = ACTIONS(3665),
    [anon_sym_uniform] = ACTIONS(3665),
    [anon_sym_row_major] = ACTIONS(3665),
    [anon_sym_column_major] = ACTIONS(3665),
    [anon_sym_globallycoherent] = ACTIONS(3665),
    [anon_sym_centroid] = ACTIONS(3665),
    [anon_sym_noperspective] = ACTIONS(3665),
    [anon_sym_nointerpolation] = ACTIONS(3665),
    [anon_sym_sample] = ACTIONS(3665),
    [anon_sym_linear] = ACTIONS(3665),
    [anon_sym_snorm] = ACTIONS(3665),
    [anon_sym_unorm] = ACTIONS(3665),
    [anon_sym_point] = ACTIONS(3665),
    [anon_sym_line] = ACTIONS(3665),
    [anon_sym_triangleadj] = ACTIONS(3665),
    [anon_sym_lineadj] = ACTIONS(3665),
    [anon_sym_triangle] = ACTIONS(3665),
    [anon_sym_cbuffer] = ACTIONS(3665),
    [anon_sym_interface] = ACTIONS(3665),
    [anon_sym_extension] = ACTIONS(3665),
  },
  [1037] = {
    [ts_builtin_sym_end] = ACTIONS(3944),
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_include_token1] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_BANG] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym___cdecl] = ACTIONS(3942),
    [anon_sym___clrcall] = ACTIONS(3942),
    [anon_sym___stdcall] = ACTIONS(3942),
    [anon_sym___fastcall] = ACTIONS(3942),
    [anon_sym___thiscall] = ACTIONS(3942),
    [anon_sym___vectorcall] = ACTIONS(3942),
    [anon_sym_LBRACE] = ACTIONS(3944),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_switch] = ACTIONS(3942),
    [anon_sym_case] = ACTIONS(3942),
    [anon_sym_default] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_break] = ACTIONS(3942),
    [anon_sym_continue] = ACTIONS(3942),
    [anon_sym_goto] = ACTIONS(3942),
    [anon_sym_not] = ACTIONS(3942),
    [anon_sym_compl] = ACTIONS(3942),
    [anon_sym_DASH_DASH] = ACTIONS(3944),
    [anon_sym_PLUS_PLUS] = ACTIONS(3944),
    [anon_sym_sizeof] = ACTIONS(3942),
    [anon_sym___alignof__] = ACTIONS(3942),
    [anon_sym___alignof] = ACTIONS(3942),
    [anon_sym__alignof] = ACTIONS(3942),
    [anon_sym_alignof] = ACTIONS(3942),
    [anon_sym__Alignof] = ACTIONS(3942),
    [anon_sym_offsetof] = ACTIONS(3942),
    [anon_sym__Generic] = ACTIONS(3942),
    [anon_sym_asm] = ACTIONS(3942),
    [anon_sym___asm__] = ACTIONS(3942),
    [anon_sym___asm] = ACTIONS(3942),
    [sym_number_literal] = ACTIONS(3944),
    [anon_sym_L_SQUOTE] = ACTIONS(3944),
    [anon_sym_u_SQUOTE] = ACTIONS(3944),
    [anon_sym_U_SQUOTE] = ACTIONS(3944),
    [anon_sym_u8_SQUOTE] = ACTIONS(3944),
    [anon_sym_SQUOTE] = ACTIONS(3944),
    [anon_sym_L_DQUOTE] = ACTIONS(3944),
    [anon_sym_u_DQUOTE] = ACTIONS(3944),
    [anon_sym_U_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE] = ACTIONS(3944),
    [sym_true] = ACTIONS(3942),
    [sym_false] = ACTIONS(3942),
    [anon_sym_NULL] = ACTIONS(3942),
    [anon_sym_nullptr] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_export] = ACTIONS(3942),
    [anon_sym_module] = ACTIONS(3942),
    [anon_sym_import] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_delete] = ACTIONS(3942),
    [anon_sym_throw] = ACTIONS(3942),
    [anon_sym_namespace] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_concept] = ACTIONS(3942),
    [anon_sym_co_return] = ACTIONS(3942),
    [anon_sym_co_yield] = ACTIONS(3942),
    [anon_sym_R_DQUOTE] = ACTIONS(3944),
    [anon_sym_LR_DQUOTE] = ACTIONS(3944),
    [anon_sym_uR_DQUOTE] = ACTIONS(3944),
    [anon_sym_UR_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3944),
    [anon_sym_co_await] = ACTIONS(3942),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_requires] = ACTIONS(3942),
    [sym_this] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
    [anon_sym___exported] = ACTIONS(3942),
  },
  [1038] = {
    [ts_builtin_sym_end] = ACTIONS(3944),
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_include_token1] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_BANG] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym___cdecl] = ACTIONS(3942),
    [anon_sym___clrcall] = ACTIONS(3942),
    [anon_sym___stdcall] = ACTIONS(3942),
    [anon_sym___fastcall] = ACTIONS(3942),
    [anon_sym___thiscall] = ACTIONS(3942),
    [anon_sym___vectorcall] = ACTIONS(3942),
    [anon_sym_LBRACE] = ACTIONS(3944),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_switch] = ACTIONS(3942),
    [anon_sym_case] = ACTIONS(3942),
    [anon_sym_default] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_break] = ACTIONS(3942),
    [anon_sym_continue] = ACTIONS(3942),
    [anon_sym_goto] = ACTIONS(3942),
    [anon_sym_not] = ACTIONS(3942),
    [anon_sym_compl] = ACTIONS(3942),
    [anon_sym_DASH_DASH] = ACTIONS(3944),
    [anon_sym_PLUS_PLUS] = ACTIONS(3944),
    [anon_sym_sizeof] = ACTIONS(3942),
    [anon_sym___alignof__] = ACTIONS(3942),
    [anon_sym___alignof] = ACTIONS(3942),
    [anon_sym__alignof] = ACTIONS(3942),
    [anon_sym_alignof] = ACTIONS(3942),
    [anon_sym__Alignof] = ACTIONS(3942),
    [anon_sym_offsetof] = ACTIONS(3942),
    [anon_sym__Generic] = ACTIONS(3942),
    [anon_sym_asm] = ACTIONS(3942),
    [anon_sym___asm__] = ACTIONS(3942),
    [anon_sym___asm] = ACTIONS(3942),
    [sym_number_literal] = ACTIONS(3944),
    [anon_sym_L_SQUOTE] = ACTIONS(3944),
    [anon_sym_u_SQUOTE] = ACTIONS(3944),
    [anon_sym_U_SQUOTE] = ACTIONS(3944),
    [anon_sym_u8_SQUOTE] = ACTIONS(3944),
    [anon_sym_SQUOTE] = ACTIONS(3944),
    [anon_sym_L_DQUOTE] = ACTIONS(3944),
    [anon_sym_u_DQUOTE] = ACTIONS(3944),
    [anon_sym_U_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE] = ACTIONS(3944),
    [sym_true] = ACTIONS(3942),
    [sym_false] = ACTIONS(3942),
    [anon_sym_NULL] = ACTIONS(3942),
    [anon_sym_nullptr] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_export] = ACTIONS(3942),
    [anon_sym_module] = ACTIONS(3942),
    [anon_sym_import] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_delete] = ACTIONS(3942),
    [anon_sym_throw] = ACTIONS(3942),
    [anon_sym_namespace] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_concept] = ACTIONS(3942),
    [anon_sym_co_return] = ACTIONS(3942),
    [anon_sym_co_yield] = ACTIONS(3942),
    [anon_sym_R_DQUOTE] = ACTIONS(3944),
    [anon_sym_LR_DQUOTE] = ACTIONS(3944),
    [anon_sym_uR_DQUOTE] = ACTIONS(3944),
    [anon_sym_UR_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3944),
    [anon_sym_co_await] = ACTIONS(3942),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_requires] = ACTIONS(3942),
    [sym_this] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
    [anon_sym___exported] = ACTIONS(3942),
  },
  [1039] = {
    [sym_identifier] = ACTIONS(3723),
    [aux_sym_preproc_include_token1] = ACTIONS(3723),
    [aux_sym_preproc_def_token1] = ACTIONS(3723),
    [aux_sym_preproc_if_token1] = ACTIONS(3723),
    [aux_sym_preproc_if_token2] = ACTIONS(3723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3723),
    [sym_preproc_directive] = ACTIONS(3723),
    [anon_sym_LPAREN2] = ACTIONS(3725),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(3725),
    [anon_sym_AMP_AMP] = ACTIONS(3725),
    [anon_sym_AMP] = ACTIONS(3723),
    [anon_sym_SEMI] = ACTIONS(3725),
    [anon_sym___extension__] = ACTIONS(3723),
    [anon_sym_typedef] = ACTIONS(3723),
    [anon_sym_in] = ACTIONS(3723),
    [anon_sym_out] = ACTIONS(3723),
    [anon_sym_inout] = ACTIONS(3723),
    [anon_sym_virtual] = ACTIONS(3723),
    [anon_sym_extern] = ACTIONS(3723),
    [anon_sym___attribute__] = ACTIONS(3723),
    [anon_sym___attribute] = ACTIONS(3723),
    [anon_sym_using] = ACTIONS(3723),
    [anon_sym_COLON_COLON] = ACTIONS(3725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3725),
    [anon_sym___declspec] = ACTIONS(3723),
    [anon_sym___based] = ACTIONS(3723),
    [anon_sym___cdecl] = ACTIONS(3723),
    [anon_sym___clrcall] = ACTIONS(3723),
    [anon_sym___stdcall] = ACTIONS(3723),
    [anon_sym___fastcall] = ACTIONS(3723),
    [anon_sym___thiscall] = ACTIONS(3723),
    [anon_sym___vectorcall] = ACTIONS(3723),
    [anon_sym_LBRACE] = ACTIONS(3725),
    [anon_sym_signed] = ACTIONS(3723),
    [anon_sym_unsigned] = ACTIONS(3723),
    [anon_sym_long] = ACTIONS(3723),
    [anon_sym_short] = ACTIONS(3723),
    [anon_sym_LBRACK] = ACTIONS(3723),
    [anon_sym_static] = ACTIONS(3723),
    [anon_sym_register] = ACTIONS(3723),
    [anon_sym_inline] = ACTIONS(3723),
    [anon_sym___inline] = ACTIONS(3723),
    [anon_sym___inline__] = ACTIONS(3723),
    [anon_sym___forceinline] = ACTIONS(3723),
    [anon_sym_thread_local] = ACTIONS(3723),
    [anon_sym___thread] = ACTIONS(3723),
    [anon_sym_const] = ACTIONS(3723),
    [anon_sym_constexpr] = ACTIONS(3723),
    [anon_sym_volatile] = ACTIONS(3723),
    [anon_sym_restrict] = ACTIONS(3723),
    [anon_sym___restrict__] = ACTIONS(3723),
    [anon_sym__Atomic] = ACTIONS(3723),
    [anon_sym__Noreturn] = ACTIONS(3723),
    [anon_sym_noreturn] = ACTIONS(3723),
    [anon_sym__Nonnull] = ACTIONS(3723),
    [anon_sym_mutable] = ACTIONS(3723),
    [anon_sym_constinit] = ACTIONS(3723),
    [anon_sym_consteval] = ACTIONS(3723),
    [anon_sym_alignas] = ACTIONS(3723),
    [anon_sym__Alignas] = ACTIONS(3723),
    [sym_primitive_type] = ACTIONS(3723),
    [anon_sym_enum] = ACTIONS(3723),
    [anon_sym_class] = ACTIONS(3723),
    [anon_sym_struct] = ACTIONS(3723),
    [anon_sym_union] = ACTIONS(3723),
    [anon_sym_if] = ACTIONS(3723),
    [anon_sym_switch] = ACTIONS(3723),
    [anon_sym_case] = ACTIONS(3723),
    [anon_sym_default] = ACTIONS(3723),
    [anon_sym_while] = ACTIONS(3723),
    [anon_sym_do] = ACTIONS(3723),
    [anon_sym_for] = ACTIONS(3723),
    [anon_sym_return] = ACTIONS(3723),
    [anon_sym_break] = ACTIONS(3723),
    [anon_sym_continue] = ACTIONS(3723),
    [anon_sym_goto] = ACTIONS(3723),
    [anon_sym___try] = ACTIONS(3723),
    [anon_sym___leave] = ACTIONS(3723),
    [anon_sym_not] = ACTIONS(3723),
    [anon_sym_compl] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(3725),
    [anon_sym_PLUS_PLUS] = ACTIONS(3725),
    [anon_sym_sizeof] = ACTIONS(3723),
    [anon_sym___alignof__] = ACTIONS(3723),
    [anon_sym___alignof] = ACTIONS(3723),
    [anon_sym__alignof] = ACTIONS(3723),
    [anon_sym_alignof] = ACTIONS(3723),
    [anon_sym__Alignof] = ACTIONS(3723),
    [anon_sym_offsetof] = ACTIONS(3723),
    [anon_sym__Generic] = ACTIONS(3723),
    [anon_sym_asm] = ACTIONS(3723),
    [anon_sym___asm__] = ACTIONS(3723),
    [anon_sym___asm] = ACTIONS(3723),
    [sym_number_literal] = ACTIONS(3725),
    [anon_sym_L_SQUOTE] = ACTIONS(3725),
    [anon_sym_u_SQUOTE] = ACTIONS(3725),
    [anon_sym_U_SQUOTE] = ACTIONS(3725),
    [anon_sym_u8_SQUOTE] = ACTIONS(3725),
    [anon_sym_SQUOTE] = ACTIONS(3725),
    [anon_sym_L_DQUOTE] = ACTIONS(3725),
    [anon_sym_u_DQUOTE] = ACTIONS(3725),
    [anon_sym_U_DQUOTE] = ACTIONS(3725),
    [anon_sym_u8_DQUOTE] = ACTIONS(3725),
    [anon_sym_DQUOTE] = ACTIONS(3725),
    [sym_true] = ACTIONS(3723),
    [sym_false] = ACTIONS(3723),
    [anon_sym_NULL] = ACTIONS(3723),
    [anon_sym_nullptr] = ACTIONS(3723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3723),
    [anon_sym_let] = ACTIONS(3723),
    [anon_sym_This] = ACTIONS(3723),
    [anon_sym_decltype] = ACTIONS(3723),
    [anon_sym_explicit] = ACTIONS(3723),
    [anon_sym_typename] = ACTIONS(3723),
    [anon_sym_template] = ACTIONS(3723),
    [anon_sym_operator] = ACTIONS(3723),
    [anon_sym_try] = ACTIONS(3723),
    [anon_sym_delete] = ACTIONS(3723),
    [anon_sym_throw] = ACTIONS(3723),
    [anon_sym_namespace] = ACTIONS(3723),
    [anon_sym_static_assert] = ACTIONS(3723),
    [anon_sym_concept] = ACTIONS(3723),
    [anon_sym_co_return] = ACTIONS(3723),
    [anon_sym_co_yield] = ACTIONS(3723),
    [anon_sym_R_DQUOTE] = ACTIONS(3725),
    [anon_sym_LR_DQUOTE] = ACTIONS(3725),
    [anon_sym_uR_DQUOTE] = ACTIONS(3725),
    [anon_sym_UR_DQUOTE] = ACTIONS(3725),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3725),
    [anon_sym_co_await] = ACTIONS(3723),
    [anon_sym_new] = ACTIONS(3723),
    [anon_sym_requires] = ACTIONS(3723),
    [sym_this] = ACTIONS(3723),
    [anon_sym_discard] = ACTIONS(3723),
    [anon_sym_precise] = ACTIONS(3723),
    [anon_sym_shared] = ACTIONS(3723),
    [anon_sym_groupshared] = ACTIONS(3723),
    [anon_sym_uniform] = ACTIONS(3723),
    [anon_sym_row_major] = ACTIONS(3723),
    [anon_sym_column_major] = ACTIONS(3723),
    [anon_sym_globallycoherent] = ACTIONS(3723),
    [anon_sym_centroid] = ACTIONS(3723),
    [anon_sym_noperspective] = ACTIONS(3723),
    [anon_sym_nointerpolation] = ACTIONS(3723),
    [anon_sym_sample] = ACTIONS(3723),
    [anon_sym_linear] = ACTIONS(3723),
    [anon_sym_snorm] = ACTIONS(3723),
    [anon_sym_unorm] = ACTIONS(3723),
    [anon_sym_point] = ACTIONS(3723),
    [anon_sym_line] = ACTIONS(3723),
    [anon_sym_triangleadj] = ACTIONS(3723),
    [anon_sym_lineadj] = ACTIONS(3723),
    [anon_sym_triangle] = ACTIONS(3723),
    [anon_sym_cbuffer] = ACTIONS(3723),
    [anon_sym_interface] = ACTIONS(3723),
    [anon_sym_extension] = ACTIONS(3723),
  },
  [1040] = {
    [ts_builtin_sym_end] = ACTIONS(3749),
    [sym_identifier] = ACTIONS(3747),
    [aux_sym_preproc_include_token1] = ACTIONS(3747),
    [aux_sym_preproc_def_token1] = ACTIONS(3747),
    [aux_sym_preproc_if_token1] = ACTIONS(3747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3747),
    [sym_preproc_directive] = ACTIONS(3747),
    [anon_sym_LPAREN2] = ACTIONS(3749),
    [anon_sym_BANG] = ACTIONS(3749),
    [anon_sym_TILDE] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_STAR] = ACTIONS(3749),
    [anon_sym_AMP_AMP] = ACTIONS(3749),
    [anon_sym_AMP] = ACTIONS(3747),
    [anon_sym_SEMI] = ACTIONS(3749),
    [anon_sym___extension__] = ACTIONS(3747),
    [anon_sym_typedef] = ACTIONS(3747),
    [anon_sym_in] = ACTIONS(3747),
    [anon_sym_out] = ACTIONS(3747),
    [anon_sym_inout] = ACTIONS(3747),
    [anon_sym_virtual] = ACTIONS(3747),
    [anon_sym_extern] = ACTIONS(3747),
    [anon_sym___attribute__] = ACTIONS(3747),
    [anon_sym___attribute] = ACTIONS(3747),
    [anon_sym_using] = ACTIONS(3747),
    [anon_sym_COLON_COLON] = ACTIONS(3749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3749),
    [anon_sym___declspec] = ACTIONS(3747),
    [anon_sym___based] = ACTIONS(3747),
    [anon_sym___cdecl] = ACTIONS(3747),
    [anon_sym___clrcall] = ACTIONS(3747),
    [anon_sym___stdcall] = ACTIONS(3747),
    [anon_sym___fastcall] = ACTIONS(3747),
    [anon_sym___thiscall] = ACTIONS(3747),
    [anon_sym___vectorcall] = ACTIONS(3747),
    [anon_sym_LBRACE] = ACTIONS(3749),
    [anon_sym_signed] = ACTIONS(3747),
    [anon_sym_unsigned] = ACTIONS(3747),
    [anon_sym_long] = ACTIONS(3747),
    [anon_sym_short] = ACTIONS(3747),
    [anon_sym_LBRACK] = ACTIONS(3747),
    [anon_sym_static] = ACTIONS(3747),
    [anon_sym_register] = ACTIONS(3747),
    [anon_sym_inline] = ACTIONS(3747),
    [anon_sym___inline] = ACTIONS(3747),
    [anon_sym___inline__] = ACTIONS(3747),
    [anon_sym___forceinline] = ACTIONS(3747),
    [anon_sym_thread_local] = ACTIONS(3747),
    [anon_sym___thread] = ACTIONS(3747),
    [anon_sym_const] = ACTIONS(3747),
    [anon_sym_constexpr] = ACTIONS(3747),
    [anon_sym_volatile] = ACTIONS(3747),
    [anon_sym_restrict] = ACTIONS(3747),
    [anon_sym___restrict__] = ACTIONS(3747),
    [anon_sym__Atomic] = ACTIONS(3747),
    [anon_sym__Noreturn] = ACTIONS(3747),
    [anon_sym_noreturn] = ACTIONS(3747),
    [anon_sym__Nonnull] = ACTIONS(3747),
    [anon_sym_mutable] = ACTIONS(3747),
    [anon_sym_constinit] = ACTIONS(3747),
    [anon_sym_consteval] = ACTIONS(3747),
    [anon_sym_alignas] = ACTIONS(3747),
    [anon_sym__Alignas] = ACTIONS(3747),
    [sym_primitive_type] = ACTIONS(3747),
    [anon_sym_enum] = ACTIONS(3747),
    [anon_sym_class] = ACTIONS(3747),
    [anon_sym_struct] = ACTIONS(3747),
    [anon_sym_union] = ACTIONS(3747),
    [anon_sym_if] = ACTIONS(3747),
    [anon_sym_switch] = ACTIONS(3747),
    [anon_sym_case] = ACTIONS(3747),
    [anon_sym_default] = ACTIONS(3747),
    [anon_sym_while] = ACTIONS(3747),
    [anon_sym_do] = ACTIONS(3747),
    [anon_sym_for] = ACTIONS(3747),
    [anon_sym_return] = ACTIONS(3747),
    [anon_sym_break] = ACTIONS(3747),
    [anon_sym_continue] = ACTIONS(3747),
    [anon_sym_goto] = ACTIONS(3747),
    [anon_sym_not] = ACTIONS(3747),
    [anon_sym_compl] = ACTIONS(3747),
    [anon_sym_DASH_DASH] = ACTIONS(3749),
    [anon_sym_PLUS_PLUS] = ACTIONS(3749),
    [anon_sym_sizeof] = ACTIONS(3747),
    [anon_sym___alignof__] = ACTIONS(3747),
    [anon_sym___alignof] = ACTIONS(3747),
    [anon_sym__alignof] = ACTIONS(3747),
    [anon_sym_alignof] = ACTIONS(3747),
    [anon_sym__Alignof] = ACTIONS(3747),
    [anon_sym_offsetof] = ACTIONS(3747),
    [anon_sym__Generic] = ACTIONS(3747),
    [anon_sym_asm] = ACTIONS(3747),
    [anon_sym___asm__] = ACTIONS(3747),
    [anon_sym___asm] = ACTIONS(3747),
    [sym_number_literal] = ACTIONS(3749),
    [anon_sym_L_SQUOTE] = ACTIONS(3749),
    [anon_sym_u_SQUOTE] = ACTIONS(3749),
    [anon_sym_U_SQUOTE] = ACTIONS(3749),
    [anon_sym_u8_SQUOTE] = ACTIONS(3749),
    [anon_sym_SQUOTE] = ACTIONS(3749),
    [anon_sym_L_DQUOTE] = ACTIONS(3749),
    [anon_sym_u_DQUOTE] = ACTIONS(3749),
    [anon_sym_U_DQUOTE] = ACTIONS(3749),
    [anon_sym_u8_DQUOTE] = ACTIONS(3749),
    [anon_sym_DQUOTE] = ACTIONS(3749),
    [sym_true] = ACTIONS(3747),
    [sym_false] = ACTIONS(3747),
    [anon_sym_NULL] = ACTIONS(3747),
    [anon_sym_nullptr] = ACTIONS(3747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3747),
    [anon_sym_let] = ACTIONS(3747),
    [anon_sym_This] = ACTIONS(3747),
    [anon_sym_decltype] = ACTIONS(3747),
    [anon_sym_explicit] = ACTIONS(3747),
    [anon_sym_typename] = ACTIONS(3747),
    [anon_sym_export] = ACTIONS(3747),
    [anon_sym_module] = ACTIONS(3747),
    [anon_sym_import] = ACTIONS(3747),
    [anon_sym_template] = ACTIONS(3747),
    [anon_sym_operator] = ACTIONS(3747),
    [anon_sym_try] = ACTIONS(3747),
    [anon_sym_delete] = ACTIONS(3747),
    [anon_sym_throw] = ACTIONS(3747),
    [anon_sym_namespace] = ACTIONS(3747),
    [anon_sym_static_assert] = ACTIONS(3747),
    [anon_sym_concept] = ACTIONS(3747),
    [anon_sym_co_return] = ACTIONS(3747),
    [anon_sym_co_yield] = ACTIONS(3747),
    [anon_sym_R_DQUOTE] = ACTIONS(3749),
    [anon_sym_LR_DQUOTE] = ACTIONS(3749),
    [anon_sym_uR_DQUOTE] = ACTIONS(3749),
    [anon_sym_UR_DQUOTE] = ACTIONS(3749),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3749),
    [anon_sym_co_await] = ACTIONS(3747),
    [anon_sym_new] = ACTIONS(3747),
    [anon_sym_requires] = ACTIONS(3747),
    [sym_this] = ACTIONS(3747),
    [anon_sym_precise] = ACTIONS(3747),
    [anon_sym_shared] = ACTIONS(3747),
    [anon_sym_groupshared] = ACTIONS(3747),
    [anon_sym_uniform] = ACTIONS(3747),
    [anon_sym_row_major] = ACTIONS(3747),
    [anon_sym_column_major] = ACTIONS(3747),
    [anon_sym_globallycoherent] = ACTIONS(3747),
    [anon_sym_centroid] = ACTIONS(3747),
    [anon_sym_noperspective] = ACTIONS(3747),
    [anon_sym_nointerpolation] = ACTIONS(3747),
    [anon_sym_sample] = ACTIONS(3747),
    [anon_sym_linear] = ACTIONS(3747),
    [anon_sym_snorm] = ACTIONS(3747),
    [anon_sym_unorm] = ACTIONS(3747),
    [anon_sym_point] = ACTIONS(3747),
    [anon_sym_line] = ACTIONS(3747),
    [anon_sym_triangleadj] = ACTIONS(3747),
    [anon_sym_lineadj] = ACTIONS(3747),
    [anon_sym_triangle] = ACTIONS(3747),
    [anon_sym_interface] = ACTIONS(3747),
    [anon_sym_extension] = ACTIONS(3747),
    [anon_sym___exported] = ACTIONS(3747),
  },
  [1041] = {
    [sym_identifier] = ACTIONS(3677),
    [aux_sym_preproc_include_token1] = ACTIONS(3677),
    [aux_sym_preproc_def_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3677),
    [sym_preproc_directive] = ACTIONS(3677),
    [anon_sym_LPAREN2] = ACTIONS(3679),
    [anon_sym_BANG] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3677),
    [anon_sym_PLUS] = ACTIONS(3677),
    [anon_sym_STAR] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_AMP] = ACTIONS(3677),
    [anon_sym_SEMI] = ACTIONS(3679),
    [anon_sym___extension__] = ACTIONS(3677),
    [anon_sym_typedef] = ACTIONS(3677),
    [anon_sym_in] = ACTIONS(3677),
    [anon_sym_out] = ACTIONS(3677),
    [anon_sym_inout] = ACTIONS(3677),
    [anon_sym_virtual] = ACTIONS(3677),
    [anon_sym_extern] = ACTIONS(3677),
    [anon_sym___attribute__] = ACTIONS(3677),
    [anon_sym___attribute] = ACTIONS(3677),
    [anon_sym_using] = ACTIONS(3677),
    [anon_sym_COLON_COLON] = ACTIONS(3679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3679),
    [anon_sym___declspec] = ACTIONS(3677),
    [anon_sym___based] = ACTIONS(3677),
    [anon_sym___cdecl] = ACTIONS(3677),
    [anon_sym___clrcall] = ACTIONS(3677),
    [anon_sym___stdcall] = ACTIONS(3677),
    [anon_sym___fastcall] = ACTIONS(3677),
    [anon_sym___thiscall] = ACTIONS(3677),
    [anon_sym___vectorcall] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_RBRACE] = ACTIONS(3679),
    [anon_sym_signed] = ACTIONS(3677),
    [anon_sym_unsigned] = ACTIONS(3677),
    [anon_sym_long] = ACTIONS(3677),
    [anon_sym_short] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3677),
    [anon_sym_static] = ACTIONS(3677),
    [anon_sym_register] = ACTIONS(3677),
    [anon_sym_inline] = ACTIONS(3677),
    [anon_sym___inline] = ACTIONS(3677),
    [anon_sym___inline__] = ACTIONS(3677),
    [anon_sym___forceinline] = ACTIONS(3677),
    [anon_sym_thread_local] = ACTIONS(3677),
    [anon_sym___thread] = ACTIONS(3677),
    [anon_sym_const] = ACTIONS(3677),
    [anon_sym_constexpr] = ACTIONS(3677),
    [anon_sym_volatile] = ACTIONS(3677),
    [anon_sym_restrict] = ACTIONS(3677),
    [anon_sym___restrict__] = ACTIONS(3677),
    [anon_sym__Atomic] = ACTIONS(3677),
    [anon_sym__Noreturn] = ACTIONS(3677),
    [anon_sym_noreturn] = ACTIONS(3677),
    [anon_sym__Nonnull] = ACTIONS(3677),
    [anon_sym_mutable] = ACTIONS(3677),
    [anon_sym_constinit] = ACTIONS(3677),
    [anon_sym_consteval] = ACTIONS(3677),
    [anon_sym_alignas] = ACTIONS(3677),
    [anon_sym__Alignas] = ACTIONS(3677),
    [sym_primitive_type] = ACTIONS(3677),
    [anon_sym_enum] = ACTIONS(3677),
    [anon_sym_class] = ACTIONS(3677),
    [anon_sym_struct] = ACTIONS(3677),
    [anon_sym_union] = ACTIONS(3677),
    [anon_sym_if] = ACTIONS(3677),
    [anon_sym_switch] = ACTIONS(3677),
    [anon_sym_case] = ACTIONS(3677),
    [anon_sym_default] = ACTIONS(3677),
    [anon_sym_while] = ACTIONS(3677),
    [anon_sym_do] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3677),
    [anon_sym_return] = ACTIONS(3677),
    [anon_sym_break] = ACTIONS(3677),
    [anon_sym_continue] = ACTIONS(3677),
    [anon_sym_goto] = ACTIONS(3677),
    [anon_sym___try] = ACTIONS(3677),
    [anon_sym___leave] = ACTIONS(3677),
    [anon_sym_not] = ACTIONS(3677),
    [anon_sym_compl] = ACTIONS(3677),
    [anon_sym_DASH_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_PLUS] = ACTIONS(3679),
    [anon_sym_sizeof] = ACTIONS(3677),
    [anon_sym___alignof__] = ACTIONS(3677),
    [anon_sym___alignof] = ACTIONS(3677),
    [anon_sym__alignof] = ACTIONS(3677),
    [anon_sym_alignof] = ACTIONS(3677),
    [anon_sym__Alignof] = ACTIONS(3677),
    [anon_sym_offsetof] = ACTIONS(3677),
    [anon_sym__Generic] = ACTIONS(3677),
    [anon_sym_asm] = ACTIONS(3677),
    [anon_sym___asm__] = ACTIONS(3677),
    [anon_sym___asm] = ACTIONS(3677),
    [sym_number_literal] = ACTIONS(3679),
    [anon_sym_L_SQUOTE] = ACTIONS(3679),
    [anon_sym_u_SQUOTE] = ACTIONS(3679),
    [anon_sym_U_SQUOTE] = ACTIONS(3679),
    [anon_sym_u8_SQUOTE] = ACTIONS(3679),
    [anon_sym_SQUOTE] = ACTIONS(3679),
    [anon_sym_L_DQUOTE] = ACTIONS(3679),
    [anon_sym_u_DQUOTE] = ACTIONS(3679),
    [anon_sym_U_DQUOTE] = ACTIONS(3679),
    [anon_sym_u8_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [sym_true] = ACTIONS(3677),
    [sym_false] = ACTIONS(3677),
    [anon_sym_NULL] = ACTIONS(3677),
    [anon_sym_nullptr] = ACTIONS(3677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3677),
    [anon_sym_let] = ACTIONS(3677),
    [anon_sym_This] = ACTIONS(3677),
    [anon_sym_decltype] = ACTIONS(3677),
    [anon_sym_explicit] = ACTIONS(3677),
    [anon_sym_typename] = ACTIONS(3677),
    [anon_sym_template] = ACTIONS(3677),
    [anon_sym_operator] = ACTIONS(3677),
    [anon_sym_try] = ACTIONS(3677),
    [anon_sym_delete] = ACTIONS(3677),
    [anon_sym_throw] = ACTIONS(3677),
    [anon_sym_namespace] = ACTIONS(3677),
    [anon_sym_static_assert] = ACTIONS(3677),
    [anon_sym_concept] = ACTIONS(3677),
    [anon_sym_co_return] = ACTIONS(3677),
    [anon_sym_co_yield] = ACTIONS(3677),
    [anon_sym_R_DQUOTE] = ACTIONS(3679),
    [anon_sym_LR_DQUOTE] = ACTIONS(3679),
    [anon_sym_uR_DQUOTE] = ACTIONS(3679),
    [anon_sym_UR_DQUOTE] = ACTIONS(3679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3679),
    [anon_sym_co_await] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3677),
    [anon_sym_requires] = ACTIONS(3677),
    [sym_this] = ACTIONS(3677),
    [anon_sym_discard] = ACTIONS(3677),
    [anon_sym_precise] = ACTIONS(3677),
    [anon_sym_shared] = ACTIONS(3677),
    [anon_sym_groupshared] = ACTIONS(3677),
    [anon_sym_uniform] = ACTIONS(3677),
    [anon_sym_row_major] = ACTIONS(3677),
    [anon_sym_column_major] = ACTIONS(3677),
    [anon_sym_globallycoherent] = ACTIONS(3677),
    [anon_sym_centroid] = ACTIONS(3677),
    [anon_sym_noperspective] = ACTIONS(3677),
    [anon_sym_nointerpolation] = ACTIONS(3677),
    [anon_sym_sample] = ACTIONS(3677),
    [anon_sym_linear] = ACTIONS(3677),
    [anon_sym_snorm] = ACTIONS(3677),
    [anon_sym_unorm] = ACTIONS(3677),
    [anon_sym_point] = ACTIONS(3677),
    [anon_sym_line] = ACTIONS(3677),
    [anon_sym_triangleadj] = ACTIONS(3677),
    [anon_sym_lineadj] = ACTIONS(3677),
    [anon_sym_triangle] = ACTIONS(3677),
    [anon_sym_cbuffer] = ACTIONS(3677),
    [anon_sym_interface] = ACTIONS(3677),
    [anon_sym_extension] = ACTIONS(3677),
  },
  [1042] = {
    [ts_builtin_sym_end] = ACTIONS(3944),
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_include_token1] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_BANG] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym___cdecl] = ACTIONS(3942),
    [anon_sym___clrcall] = ACTIONS(3942),
    [anon_sym___stdcall] = ACTIONS(3942),
    [anon_sym___fastcall] = ACTIONS(3942),
    [anon_sym___thiscall] = ACTIONS(3942),
    [anon_sym___vectorcall] = ACTIONS(3942),
    [anon_sym_LBRACE] = ACTIONS(3944),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_switch] = ACTIONS(3942),
    [anon_sym_case] = ACTIONS(3942),
    [anon_sym_default] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_break] = ACTIONS(3942),
    [anon_sym_continue] = ACTIONS(3942),
    [anon_sym_goto] = ACTIONS(3942),
    [anon_sym_not] = ACTIONS(3942),
    [anon_sym_compl] = ACTIONS(3942),
    [anon_sym_DASH_DASH] = ACTIONS(3944),
    [anon_sym_PLUS_PLUS] = ACTIONS(3944),
    [anon_sym_sizeof] = ACTIONS(3942),
    [anon_sym___alignof__] = ACTIONS(3942),
    [anon_sym___alignof] = ACTIONS(3942),
    [anon_sym__alignof] = ACTIONS(3942),
    [anon_sym_alignof] = ACTIONS(3942),
    [anon_sym__Alignof] = ACTIONS(3942),
    [anon_sym_offsetof] = ACTIONS(3942),
    [anon_sym__Generic] = ACTIONS(3942),
    [anon_sym_asm] = ACTIONS(3942),
    [anon_sym___asm__] = ACTIONS(3942),
    [anon_sym___asm] = ACTIONS(3942),
    [sym_number_literal] = ACTIONS(3944),
    [anon_sym_L_SQUOTE] = ACTIONS(3944),
    [anon_sym_u_SQUOTE] = ACTIONS(3944),
    [anon_sym_U_SQUOTE] = ACTIONS(3944),
    [anon_sym_u8_SQUOTE] = ACTIONS(3944),
    [anon_sym_SQUOTE] = ACTIONS(3944),
    [anon_sym_L_DQUOTE] = ACTIONS(3944),
    [anon_sym_u_DQUOTE] = ACTIONS(3944),
    [anon_sym_U_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE] = ACTIONS(3944),
    [sym_true] = ACTIONS(3942),
    [sym_false] = ACTIONS(3942),
    [anon_sym_NULL] = ACTIONS(3942),
    [anon_sym_nullptr] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_export] = ACTIONS(3942),
    [anon_sym_module] = ACTIONS(3942),
    [anon_sym_import] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_delete] = ACTIONS(3942),
    [anon_sym_throw] = ACTIONS(3942),
    [anon_sym_namespace] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_concept] = ACTIONS(3942),
    [anon_sym_co_return] = ACTIONS(3942),
    [anon_sym_co_yield] = ACTIONS(3942),
    [anon_sym_R_DQUOTE] = ACTIONS(3944),
    [anon_sym_LR_DQUOTE] = ACTIONS(3944),
    [anon_sym_uR_DQUOTE] = ACTIONS(3944),
    [anon_sym_UR_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3944),
    [anon_sym_co_await] = ACTIONS(3942),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_requires] = ACTIONS(3942),
    [sym_this] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
    [anon_sym___exported] = ACTIONS(3942),
  },
  [1043] = {
    [ts_builtin_sym_end] = ACTIONS(3944),
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_include_token1] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_BANG] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym___cdecl] = ACTIONS(3942),
    [anon_sym___clrcall] = ACTIONS(3942),
    [anon_sym___stdcall] = ACTIONS(3942),
    [anon_sym___fastcall] = ACTIONS(3942),
    [anon_sym___thiscall] = ACTIONS(3942),
    [anon_sym___vectorcall] = ACTIONS(3942),
    [anon_sym_LBRACE] = ACTIONS(3944),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_switch] = ACTIONS(3942),
    [anon_sym_case] = ACTIONS(3942),
    [anon_sym_default] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_break] = ACTIONS(3942),
    [anon_sym_continue] = ACTIONS(3942),
    [anon_sym_goto] = ACTIONS(3942),
    [anon_sym_not] = ACTIONS(3942),
    [anon_sym_compl] = ACTIONS(3942),
    [anon_sym_DASH_DASH] = ACTIONS(3944),
    [anon_sym_PLUS_PLUS] = ACTIONS(3944),
    [anon_sym_sizeof] = ACTIONS(3942),
    [anon_sym___alignof__] = ACTIONS(3942),
    [anon_sym___alignof] = ACTIONS(3942),
    [anon_sym__alignof] = ACTIONS(3942),
    [anon_sym_alignof] = ACTIONS(3942),
    [anon_sym__Alignof] = ACTIONS(3942),
    [anon_sym_offsetof] = ACTIONS(3942),
    [anon_sym__Generic] = ACTIONS(3942),
    [anon_sym_asm] = ACTIONS(3942),
    [anon_sym___asm__] = ACTIONS(3942),
    [anon_sym___asm] = ACTIONS(3942),
    [sym_number_literal] = ACTIONS(3944),
    [anon_sym_L_SQUOTE] = ACTIONS(3944),
    [anon_sym_u_SQUOTE] = ACTIONS(3944),
    [anon_sym_U_SQUOTE] = ACTIONS(3944),
    [anon_sym_u8_SQUOTE] = ACTIONS(3944),
    [anon_sym_SQUOTE] = ACTIONS(3944),
    [anon_sym_L_DQUOTE] = ACTIONS(3944),
    [anon_sym_u_DQUOTE] = ACTIONS(3944),
    [anon_sym_U_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE] = ACTIONS(3944),
    [sym_true] = ACTIONS(3942),
    [sym_false] = ACTIONS(3942),
    [anon_sym_NULL] = ACTIONS(3942),
    [anon_sym_nullptr] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_export] = ACTIONS(3942),
    [anon_sym_module] = ACTIONS(3942),
    [anon_sym_import] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_delete] = ACTIONS(3942),
    [anon_sym_throw] = ACTIONS(3942),
    [anon_sym_namespace] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_concept] = ACTIONS(3942),
    [anon_sym_co_return] = ACTIONS(3942),
    [anon_sym_co_yield] = ACTIONS(3942),
    [anon_sym_R_DQUOTE] = ACTIONS(3944),
    [anon_sym_LR_DQUOTE] = ACTIONS(3944),
    [anon_sym_uR_DQUOTE] = ACTIONS(3944),
    [anon_sym_UR_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3944),
    [anon_sym_co_await] = ACTIONS(3942),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_requires] = ACTIONS(3942),
    [sym_this] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
    [anon_sym___exported] = ACTIONS(3942),
  },
  [1044] = {
    [ts_builtin_sym_end] = ACTIONS(3955),
    [sym_identifier] = ACTIONS(3953),
    [aux_sym_preproc_include_token1] = ACTIONS(3953),
    [aux_sym_preproc_def_token1] = ACTIONS(3953),
    [aux_sym_preproc_if_token1] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3953),
    [sym_preproc_directive] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_BANG] = ACTIONS(3955),
    [anon_sym_TILDE] = ACTIONS(3955),
    [anon_sym_DASH] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3953),
    [anon_sym_STAR] = ACTIONS(3955),
    [anon_sym_AMP_AMP] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_SEMI] = ACTIONS(3955),
    [anon_sym___extension__] = ACTIONS(3953),
    [anon_sym_typedef] = ACTIONS(3953),
    [anon_sym_in] = ACTIONS(3953),
    [anon_sym_out] = ACTIONS(3953),
    [anon_sym_inout] = ACTIONS(3953),
    [anon_sym_virtual] = ACTIONS(3953),
    [anon_sym_extern] = ACTIONS(3953),
    [anon_sym___attribute__] = ACTIONS(3953),
    [anon_sym___attribute] = ACTIONS(3953),
    [anon_sym_using] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3955),
    [anon_sym___declspec] = ACTIONS(3953),
    [anon_sym___based] = ACTIONS(3953),
    [anon_sym___cdecl] = ACTIONS(3953),
    [anon_sym___clrcall] = ACTIONS(3953),
    [anon_sym___stdcall] = ACTIONS(3953),
    [anon_sym___fastcall] = ACTIONS(3953),
    [anon_sym___thiscall] = ACTIONS(3953),
    [anon_sym___vectorcall] = ACTIONS(3953),
    [anon_sym_LBRACE] = ACTIONS(3955),
    [anon_sym_signed] = ACTIONS(3953),
    [anon_sym_unsigned] = ACTIONS(3953),
    [anon_sym_long] = ACTIONS(3953),
    [anon_sym_short] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_static] = ACTIONS(3953),
    [anon_sym_register] = ACTIONS(3953),
    [anon_sym_inline] = ACTIONS(3953),
    [anon_sym___inline] = ACTIONS(3953),
    [anon_sym___inline__] = ACTIONS(3953),
    [anon_sym___forceinline] = ACTIONS(3953),
    [anon_sym_thread_local] = ACTIONS(3953),
    [anon_sym___thread] = ACTIONS(3953),
    [anon_sym_const] = ACTIONS(3953),
    [anon_sym_constexpr] = ACTIONS(3953),
    [anon_sym_volatile] = ACTIONS(3953),
    [anon_sym_restrict] = ACTIONS(3953),
    [anon_sym___restrict__] = ACTIONS(3953),
    [anon_sym__Atomic] = ACTIONS(3953),
    [anon_sym__Noreturn] = ACTIONS(3953),
    [anon_sym_noreturn] = ACTIONS(3953),
    [anon_sym__Nonnull] = ACTIONS(3953),
    [anon_sym_mutable] = ACTIONS(3953),
    [anon_sym_constinit] = ACTIONS(3953),
    [anon_sym_consteval] = ACTIONS(3953),
    [anon_sym_alignas] = ACTIONS(3953),
    [anon_sym__Alignas] = ACTIONS(3953),
    [sym_primitive_type] = ACTIONS(3953),
    [anon_sym_enum] = ACTIONS(3953),
    [anon_sym_class] = ACTIONS(3953),
    [anon_sym_struct] = ACTIONS(3953),
    [anon_sym_union] = ACTIONS(3953),
    [anon_sym_if] = ACTIONS(3953),
    [anon_sym_switch] = ACTIONS(3953),
    [anon_sym_case] = ACTIONS(3953),
    [anon_sym_default] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3953),
    [anon_sym_do] = ACTIONS(3953),
    [anon_sym_for] = ACTIONS(3953),
    [anon_sym_return] = ACTIONS(3953),
    [anon_sym_break] = ACTIONS(3953),
    [anon_sym_continue] = ACTIONS(3953),
    [anon_sym_goto] = ACTIONS(3953),
    [anon_sym_not] = ACTIONS(3953),
    [anon_sym_compl] = ACTIONS(3953),
    [anon_sym_DASH_DASH] = ACTIONS(3955),
    [anon_sym_PLUS_PLUS] = ACTIONS(3955),
    [anon_sym_sizeof] = ACTIONS(3953),
    [anon_sym___alignof__] = ACTIONS(3953),
    [anon_sym___alignof] = ACTIONS(3953),
    [anon_sym__alignof] = ACTIONS(3953),
    [anon_sym_alignof] = ACTIONS(3953),
    [anon_sym__Alignof] = ACTIONS(3953),
    [anon_sym_offsetof] = ACTIONS(3953),
    [anon_sym__Generic] = ACTIONS(3953),
    [anon_sym_asm] = ACTIONS(3953),
    [anon_sym___asm__] = ACTIONS(3953),
    [anon_sym___asm] = ACTIONS(3953),
    [sym_number_literal] = ACTIONS(3955),
    [anon_sym_L_SQUOTE] = ACTIONS(3955),
    [anon_sym_u_SQUOTE] = ACTIONS(3955),
    [anon_sym_U_SQUOTE] = ACTIONS(3955),
    [anon_sym_u8_SQUOTE] = ACTIONS(3955),
    [anon_sym_SQUOTE] = ACTIONS(3955),
    [anon_sym_L_DQUOTE] = ACTIONS(3955),
    [anon_sym_u_DQUOTE] = ACTIONS(3955),
    [anon_sym_U_DQUOTE] = ACTIONS(3955),
    [anon_sym_u8_DQUOTE] = ACTIONS(3955),
    [anon_sym_DQUOTE] = ACTIONS(3955),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [anon_sym_NULL] = ACTIONS(3953),
    [anon_sym_nullptr] = ACTIONS(3953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_This] = ACTIONS(3953),
    [anon_sym_decltype] = ACTIONS(3953),
    [anon_sym_explicit] = ACTIONS(3953),
    [anon_sym_typename] = ACTIONS(3953),
    [anon_sym_export] = ACTIONS(3953),
    [anon_sym_module] = ACTIONS(3953),
    [anon_sym_import] = ACTIONS(3953),
    [anon_sym_template] = ACTIONS(3953),
    [anon_sym_operator] = ACTIONS(3953),
    [anon_sym_try] = ACTIONS(3953),
    [anon_sym_delete] = ACTIONS(3953),
    [anon_sym_throw] = ACTIONS(3953),
    [anon_sym_namespace] = ACTIONS(3953),
    [anon_sym_static_assert] = ACTIONS(3953),
    [anon_sym_concept] = ACTIONS(3953),
    [anon_sym_co_return] = ACTIONS(3953),
    [anon_sym_co_yield] = ACTIONS(3953),
    [anon_sym_R_DQUOTE] = ACTIONS(3955),
    [anon_sym_LR_DQUOTE] = ACTIONS(3955),
    [anon_sym_uR_DQUOTE] = ACTIONS(3955),
    [anon_sym_UR_DQUOTE] = ACTIONS(3955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3955),
    [anon_sym_co_await] = ACTIONS(3953),
    [anon_sym_new] = ACTIONS(3953),
    [anon_sym_requires] = ACTIONS(3953),
    [sym_this] = ACTIONS(3953),
    [anon_sym_precise] = ACTIONS(3953),
    [anon_sym_shared] = ACTIONS(3953),
    [anon_sym_groupshared] = ACTIONS(3953),
    [anon_sym_uniform] = ACTIONS(3953),
    [anon_sym_row_major] = ACTIONS(3953),
    [anon_sym_column_major] = ACTIONS(3953),
    [anon_sym_globallycoherent] = ACTIONS(3953),
    [anon_sym_centroid] = ACTIONS(3953),
    [anon_sym_noperspective] = ACTIONS(3953),
    [anon_sym_nointerpolation] = ACTIONS(3953),
    [anon_sym_sample] = ACTIONS(3953),
    [anon_sym_linear] = ACTIONS(3953),
    [anon_sym_snorm] = ACTIONS(3953),
    [anon_sym_unorm] = ACTIONS(3953),
    [anon_sym_point] = ACTIONS(3953),
    [anon_sym_line] = ACTIONS(3953),
    [anon_sym_triangleadj] = ACTIONS(3953),
    [anon_sym_lineadj] = ACTIONS(3953),
    [anon_sym_triangle] = ACTIONS(3953),
    [anon_sym_interface] = ACTIONS(3953),
    [anon_sym_extension] = ACTIONS(3953),
    [anon_sym___exported] = ACTIONS(3953),
  },
  [1045] = {
    [ts_builtin_sym_end] = ACTIONS(3955),
    [sym_identifier] = ACTIONS(3953),
    [aux_sym_preproc_include_token1] = ACTIONS(3953),
    [aux_sym_preproc_def_token1] = ACTIONS(3953),
    [aux_sym_preproc_if_token1] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3953),
    [sym_preproc_directive] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_BANG] = ACTIONS(3955),
    [anon_sym_TILDE] = ACTIONS(3955),
    [anon_sym_DASH] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3953),
    [anon_sym_STAR] = ACTIONS(3955),
    [anon_sym_AMP_AMP] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_SEMI] = ACTIONS(3955),
    [anon_sym___extension__] = ACTIONS(3953),
    [anon_sym_typedef] = ACTIONS(3953),
    [anon_sym_in] = ACTIONS(3953),
    [anon_sym_out] = ACTIONS(3953),
    [anon_sym_inout] = ACTIONS(3953),
    [anon_sym_virtual] = ACTIONS(3953),
    [anon_sym_extern] = ACTIONS(3953),
    [anon_sym___attribute__] = ACTIONS(3953),
    [anon_sym___attribute] = ACTIONS(3953),
    [anon_sym_using] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3955),
    [anon_sym___declspec] = ACTIONS(3953),
    [anon_sym___based] = ACTIONS(3953),
    [anon_sym___cdecl] = ACTIONS(3953),
    [anon_sym___clrcall] = ACTIONS(3953),
    [anon_sym___stdcall] = ACTIONS(3953),
    [anon_sym___fastcall] = ACTIONS(3953),
    [anon_sym___thiscall] = ACTIONS(3953),
    [anon_sym___vectorcall] = ACTIONS(3953),
    [anon_sym_LBRACE] = ACTIONS(3955),
    [anon_sym_signed] = ACTIONS(3953),
    [anon_sym_unsigned] = ACTIONS(3953),
    [anon_sym_long] = ACTIONS(3953),
    [anon_sym_short] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_static] = ACTIONS(3953),
    [anon_sym_register] = ACTIONS(3953),
    [anon_sym_inline] = ACTIONS(3953),
    [anon_sym___inline] = ACTIONS(3953),
    [anon_sym___inline__] = ACTIONS(3953),
    [anon_sym___forceinline] = ACTIONS(3953),
    [anon_sym_thread_local] = ACTIONS(3953),
    [anon_sym___thread] = ACTIONS(3953),
    [anon_sym_const] = ACTIONS(3953),
    [anon_sym_constexpr] = ACTIONS(3953),
    [anon_sym_volatile] = ACTIONS(3953),
    [anon_sym_restrict] = ACTIONS(3953),
    [anon_sym___restrict__] = ACTIONS(3953),
    [anon_sym__Atomic] = ACTIONS(3953),
    [anon_sym__Noreturn] = ACTIONS(3953),
    [anon_sym_noreturn] = ACTIONS(3953),
    [anon_sym__Nonnull] = ACTIONS(3953),
    [anon_sym_mutable] = ACTIONS(3953),
    [anon_sym_constinit] = ACTIONS(3953),
    [anon_sym_consteval] = ACTIONS(3953),
    [anon_sym_alignas] = ACTIONS(3953),
    [anon_sym__Alignas] = ACTIONS(3953),
    [sym_primitive_type] = ACTIONS(3953),
    [anon_sym_enum] = ACTIONS(3953),
    [anon_sym_class] = ACTIONS(3953),
    [anon_sym_struct] = ACTIONS(3953),
    [anon_sym_union] = ACTIONS(3953),
    [anon_sym_if] = ACTIONS(3953),
    [anon_sym_switch] = ACTIONS(3953),
    [anon_sym_case] = ACTIONS(3953),
    [anon_sym_default] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3953),
    [anon_sym_do] = ACTIONS(3953),
    [anon_sym_for] = ACTIONS(3953),
    [anon_sym_return] = ACTIONS(3953),
    [anon_sym_break] = ACTIONS(3953),
    [anon_sym_continue] = ACTIONS(3953),
    [anon_sym_goto] = ACTIONS(3953),
    [anon_sym_not] = ACTIONS(3953),
    [anon_sym_compl] = ACTIONS(3953),
    [anon_sym_DASH_DASH] = ACTIONS(3955),
    [anon_sym_PLUS_PLUS] = ACTIONS(3955),
    [anon_sym_sizeof] = ACTIONS(3953),
    [anon_sym___alignof__] = ACTIONS(3953),
    [anon_sym___alignof] = ACTIONS(3953),
    [anon_sym__alignof] = ACTIONS(3953),
    [anon_sym_alignof] = ACTIONS(3953),
    [anon_sym__Alignof] = ACTIONS(3953),
    [anon_sym_offsetof] = ACTIONS(3953),
    [anon_sym__Generic] = ACTIONS(3953),
    [anon_sym_asm] = ACTIONS(3953),
    [anon_sym___asm__] = ACTIONS(3953),
    [anon_sym___asm] = ACTIONS(3953),
    [sym_number_literal] = ACTIONS(3955),
    [anon_sym_L_SQUOTE] = ACTIONS(3955),
    [anon_sym_u_SQUOTE] = ACTIONS(3955),
    [anon_sym_U_SQUOTE] = ACTIONS(3955),
    [anon_sym_u8_SQUOTE] = ACTIONS(3955),
    [anon_sym_SQUOTE] = ACTIONS(3955),
    [anon_sym_L_DQUOTE] = ACTIONS(3955),
    [anon_sym_u_DQUOTE] = ACTIONS(3955),
    [anon_sym_U_DQUOTE] = ACTIONS(3955),
    [anon_sym_u8_DQUOTE] = ACTIONS(3955),
    [anon_sym_DQUOTE] = ACTIONS(3955),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [anon_sym_NULL] = ACTIONS(3953),
    [anon_sym_nullptr] = ACTIONS(3953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_This] = ACTIONS(3953),
    [anon_sym_decltype] = ACTIONS(3953),
    [anon_sym_explicit] = ACTIONS(3953),
    [anon_sym_typename] = ACTIONS(3953),
    [anon_sym_export] = ACTIONS(3953),
    [anon_sym_module] = ACTIONS(3953),
    [anon_sym_import] = ACTIONS(3953),
    [anon_sym_template] = ACTIONS(3953),
    [anon_sym_operator] = ACTIONS(3953),
    [anon_sym_try] = ACTIONS(3953),
    [anon_sym_delete] = ACTIONS(3953),
    [anon_sym_throw] = ACTIONS(3953),
    [anon_sym_namespace] = ACTIONS(3953),
    [anon_sym_static_assert] = ACTIONS(3953),
    [anon_sym_concept] = ACTIONS(3953),
    [anon_sym_co_return] = ACTIONS(3953),
    [anon_sym_co_yield] = ACTIONS(3953),
    [anon_sym_R_DQUOTE] = ACTIONS(3955),
    [anon_sym_LR_DQUOTE] = ACTIONS(3955),
    [anon_sym_uR_DQUOTE] = ACTIONS(3955),
    [anon_sym_UR_DQUOTE] = ACTIONS(3955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3955),
    [anon_sym_co_await] = ACTIONS(3953),
    [anon_sym_new] = ACTIONS(3953),
    [anon_sym_requires] = ACTIONS(3953),
    [sym_this] = ACTIONS(3953),
    [anon_sym_precise] = ACTIONS(3953),
    [anon_sym_shared] = ACTIONS(3953),
    [anon_sym_groupshared] = ACTIONS(3953),
    [anon_sym_uniform] = ACTIONS(3953),
    [anon_sym_row_major] = ACTIONS(3953),
    [anon_sym_column_major] = ACTIONS(3953),
    [anon_sym_globallycoherent] = ACTIONS(3953),
    [anon_sym_centroid] = ACTIONS(3953),
    [anon_sym_noperspective] = ACTIONS(3953),
    [anon_sym_nointerpolation] = ACTIONS(3953),
    [anon_sym_sample] = ACTIONS(3953),
    [anon_sym_linear] = ACTIONS(3953),
    [anon_sym_snorm] = ACTIONS(3953),
    [anon_sym_unorm] = ACTIONS(3953),
    [anon_sym_point] = ACTIONS(3953),
    [anon_sym_line] = ACTIONS(3953),
    [anon_sym_triangleadj] = ACTIONS(3953),
    [anon_sym_lineadj] = ACTIONS(3953),
    [anon_sym_triangle] = ACTIONS(3953),
    [anon_sym_interface] = ACTIONS(3953),
    [anon_sym_extension] = ACTIONS(3953),
    [anon_sym___exported] = ACTIONS(3953),
  },
  [1046] = {
    [ts_builtin_sym_end] = ACTIONS(3965),
    [sym_identifier] = ACTIONS(3963),
    [aux_sym_preproc_include_token1] = ACTIONS(3963),
    [aux_sym_preproc_def_token1] = ACTIONS(3963),
    [aux_sym_preproc_if_token1] = ACTIONS(3963),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3963),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3963),
    [sym_preproc_directive] = ACTIONS(3963),
    [anon_sym_LPAREN2] = ACTIONS(3965),
    [anon_sym_BANG] = ACTIONS(3965),
    [anon_sym_TILDE] = ACTIONS(3965),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_STAR] = ACTIONS(3965),
    [anon_sym_AMP_AMP] = ACTIONS(3965),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_SEMI] = ACTIONS(3965),
    [anon_sym___extension__] = ACTIONS(3963),
    [anon_sym_typedef] = ACTIONS(3963),
    [anon_sym_in] = ACTIONS(3963),
    [anon_sym_out] = ACTIONS(3963),
    [anon_sym_inout] = ACTIONS(3963),
    [anon_sym_virtual] = ACTIONS(3963),
    [anon_sym_extern] = ACTIONS(3963),
    [anon_sym___attribute__] = ACTIONS(3963),
    [anon_sym___attribute] = ACTIONS(3963),
    [anon_sym_using] = ACTIONS(3963),
    [anon_sym_COLON_COLON] = ACTIONS(3965),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3965),
    [anon_sym___declspec] = ACTIONS(3963),
    [anon_sym___based] = ACTIONS(3963),
    [anon_sym___cdecl] = ACTIONS(3963),
    [anon_sym___clrcall] = ACTIONS(3963),
    [anon_sym___stdcall] = ACTIONS(3963),
    [anon_sym___fastcall] = ACTIONS(3963),
    [anon_sym___thiscall] = ACTIONS(3963),
    [anon_sym___vectorcall] = ACTIONS(3963),
    [anon_sym_LBRACE] = ACTIONS(3965),
    [anon_sym_signed] = ACTIONS(3963),
    [anon_sym_unsigned] = ACTIONS(3963),
    [anon_sym_long] = ACTIONS(3963),
    [anon_sym_short] = ACTIONS(3963),
    [anon_sym_LBRACK] = ACTIONS(3963),
    [anon_sym_static] = ACTIONS(3963),
    [anon_sym_register] = ACTIONS(3963),
    [anon_sym_inline] = ACTIONS(3963),
    [anon_sym___inline] = ACTIONS(3963),
    [anon_sym___inline__] = ACTIONS(3963),
    [anon_sym___forceinline] = ACTIONS(3963),
    [anon_sym_thread_local] = ACTIONS(3963),
    [anon_sym___thread] = ACTIONS(3963),
    [anon_sym_const] = ACTIONS(3963),
    [anon_sym_constexpr] = ACTIONS(3963),
    [anon_sym_volatile] = ACTIONS(3963),
    [anon_sym_restrict] = ACTIONS(3963),
    [anon_sym___restrict__] = ACTIONS(3963),
    [anon_sym__Atomic] = ACTIONS(3963),
    [anon_sym__Noreturn] = ACTIONS(3963),
    [anon_sym_noreturn] = ACTIONS(3963),
    [anon_sym__Nonnull] = ACTIONS(3963),
    [anon_sym_mutable] = ACTIONS(3963),
    [anon_sym_constinit] = ACTIONS(3963),
    [anon_sym_consteval] = ACTIONS(3963),
    [anon_sym_alignas] = ACTIONS(3963),
    [anon_sym__Alignas] = ACTIONS(3963),
    [sym_primitive_type] = ACTIONS(3963),
    [anon_sym_enum] = ACTIONS(3963),
    [anon_sym_class] = ACTIONS(3963),
    [anon_sym_struct] = ACTIONS(3963),
    [anon_sym_union] = ACTIONS(3963),
    [anon_sym_if] = ACTIONS(3963),
    [anon_sym_switch] = ACTIONS(3963),
    [anon_sym_case] = ACTIONS(3963),
    [anon_sym_default] = ACTIONS(3963),
    [anon_sym_while] = ACTIONS(3963),
    [anon_sym_do] = ACTIONS(3963),
    [anon_sym_for] = ACTIONS(3963),
    [anon_sym_return] = ACTIONS(3963),
    [anon_sym_break] = ACTIONS(3963),
    [anon_sym_continue] = ACTIONS(3963),
    [anon_sym_goto] = ACTIONS(3963),
    [anon_sym_not] = ACTIONS(3963),
    [anon_sym_compl] = ACTIONS(3963),
    [anon_sym_DASH_DASH] = ACTIONS(3965),
    [anon_sym_PLUS_PLUS] = ACTIONS(3965),
    [anon_sym_sizeof] = ACTIONS(3963),
    [anon_sym___alignof__] = ACTIONS(3963),
    [anon_sym___alignof] = ACTIONS(3963),
    [anon_sym__alignof] = ACTIONS(3963),
    [anon_sym_alignof] = ACTIONS(3963),
    [anon_sym__Alignof] = ACTIONS(3963),
    [anon_sym_offsetof] = ACTIONS(3963),
    [anon_sym__Generic] = ACTIONS(3963),
    [anon_sym_asm] = ACTIONS(3963),
    [anon_sym___asm__] = ACTIONS(3963),
    [anon_sym___asm] = ACTIONS(3963),
    [sym_number_literal] = ACTIONS(3965),
    [anon_sym_L_SQUOTE] = ACTIONS(3965),
    [anon_sym_u_SQUOTE] = ACTIONS(3965),
    [anon_sym_U_SQUOTE] = ACTIONS(3965),
    [anon_sym_u8_SQUOTE] = ACTIONS(3965),
    [anon_sym_SQUOTE] = ACTIONS(3965),
    [anon_sym_L_DQUOTE] = ACTIONS(3965),
    [anon_sym_u_DQUOTE] = ACTIONS(3965),
    [anon_sym_U_DQUOTE] = ACTIONS(3965),
    [anon_sym_u8_DQUOTE] = ACTIONS(3965),
    [anon_sym_DQUOTE] = ACTIONS(3965),
    [sym_true] = ACTIONS(3963),
    [sym_false] = ACTIONS(3963),
    [anon_sym_NULL] = ACTIONS(3963),
    [anon_sym_nullptr] = ACTIONS(3963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3963),
    [anon_sym_let] = ACTIONS(3963),
    [anon_sym_This] = ACTIONS(3963),
    [anon_sym_decltype] = ACTIONS(3963),
    [anon_sym_explicit] = ACTIONS(3963),
    [anon_sym_typename] = ACTIONS(3963),
    [anon_sym_export] = ACTIONS(3963),
    [anon_sym_module] = ACTIONS(3963),
    [anon_sym_import] = ACTIONS(3963),
    [anon_sym_template] = ACTIONS(3963),
    [anon_sym_operator] = ACTIONS(3963),
    [anon_sym_try] = ACTIONS(3963),
    [anon_sym_delete] = ACTIONS(3963),
    [anon_sym_throw] = ACTIONS(3963),
    [anon_sym_namespace] = ACTIONS(3963),
    [anon_sym_static_assert] = ACTIONS(3963),
    [anon_sym_concept] = ACTIONS(3963),
    [anon_sym_co_return] = ACTIONS(3963),
    [anon_sym_co_yield] = ACTIONS(3963),
    [anon_sym_R_DQUOTE] = ACTIONS(3965),
    [anon_sym_LR_DQUOTE] = ACTIONS(3965),
    [anon_sym_uR_DQUOTE] = ACTIONS(3965),
    [anon_sym_UR_DQUOTE] = ACTIONS(3965),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3965),
    [anon_sym_co_await] = ACTIONS(3963),
    [anon_sym_new] = ACTIONS(3963),
    [anon_sym_requires] = ACTIONS(3963),
    [sym_this] = ACTIONS(3963),
    [anon_sym_precise] = ACTIONS(3963),
    [anon_sym_shared] = ACTIONS(3963),
    [anon_sym_groupshared] = ACTIONS(3963),
    [anon_sym_uniform] = ACTIONS(3963),
    [anon_sym_row_major] = ACTIONS(3963),
    [anon_sym_column_major] = ACTIONS(3963),
    [anon_sym_globallycoherent] = ACTIONS(3963),
    [anon_sym_centroid] = ACTIONS(3963),
    [anon_sym_noperspective] = ACTIONS(3963),
    [anon_sym_nointerpolation] = ACTIONS(3963),
    [anon_sym_sample] = ACTIONS(3963),
    [anon_sym_linear] = ACTIONS(3963),
    [anon_sym_snorm] = ACTIONS(3963),
    [anon_sym_unorm] = ACTIONS(3963),
    [anon_sym_point] = ACTIONS(3963),
    [anon_sym_line] = ACTIONS(3963),
    [anon_sym_triangleadj] = ACTIONS(3963),
    [anon_sym_lineadj] = ACTIONS(3963),
    [anon_sym_triangle] = ACTIONS(3963),
    [anon_sym_interface] = ACTIONS(3963),
    [anon_sym_extension] = ACTIONS(3963),
    [anon_sym___exported] = ACTIONS(3963),
  },
  [1047] = {
    [ts_builtin_sym_end] = ACTIONS(3985),
    [sym_identifier] = ACTIONS(3983),
    [aux_sym_preproc_include_token1] = ACTIONS(3983),
    [aux_sym_preproc_def_token1] = ACTIONS(3983),
    [aux_sym_preproc_if_token1] = ACTIONS(3983),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3983),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3983),
    [sym_preproc_directive] = ACTIONS(3983),
    [anon_sym_LPAREN2] = ACTIONS(3985),
    [anon_sym_BANG] = ACTIONS(3985),
    [anon_sym_TILDE] = ACTIONS(3985),
    [anon_sym_DASH] = ACTIONS(3983),
    [anon_sym_PLUS] = ACTIONS(3983),
    [anon_sym_STAR] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3983),
    [anon_sym_SEMI] = ACTIONS(3985),
    [anon_sym___extension__] = ACTIONS(3983),
    [anon_sym_typedef] = ACTIONS(3983),
    [anon_sym_in] = ACTIONS(3983),
    [anon_sym_out] = ACTIONS(3983),
    [anon_sym_inout] = ACTIONS(3983),
    [anon_sym_virtual] = ACTIONS(3983),
    [anon_sym_extern] = ACTIONS(3983),
    [anon_sym___attribute__] = ACTIONS(3983),
    [anon_sym___attribute] = ACTIONS(3983),
    [anon_sym_using] = ACTIONS(3983),
    [anon_sym_COLON_COLON] = ACTIONS(3985),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3985),
    [anon_sym___declspec] = ACTIONS(3983),
    [anon_sym___based] = ACTIONS(3983),
    [anon_sym___cdecl] = ACTIONS(3983),
    [anon_sym___clrcall] = ACTIONS(3983),
    [anon_sym___stdcall] = ACTIONS(3983),
    [anon_sym___fastcall] = ACTIONS(3983),
    [anon_sym___thiscall] = ACTIONS(3983),
    [anon_sym___vectorcall] = ACTIONS(3983),
    [anon_sym_LBRACE] = ACTIONS(3985),
    [anon_sym_signed] = ACTIONS(3983),
    [anon_sym_unsigned] = ACTIONS(3983),
    [anon_sym_long] = ACTIONS(3983),
    [anon_sym_short] = ACTIONS(3983),
    [anon_sym_LBRACK] = ACTIONS(3983),
    [anon_sym_static] = ACTIONS(3983),
    [anon_sym_register] = ACTIONS(3983),
    [anon_sym_inline] = ACTIONS(3983),
    [anon_sym___inline] = ACTIONS(3983),
    [anon_sym___inline__] = ACTIONS(3983),
    [anon_sym___forceinline] = ACTIONS(3983),
    [anon_sym_thread_local] = ACTIONS(3983),
    [anon_sym___thread] = ACTIONS(3983),
    [anon_sym_const] = ACTIONS(3983),
    [anon_sym_constexpr] = ACTIONS(3983),
    [anon_sym_volatile] = ACTIONS(3983),
    [anon_sym_restrict] = ACTIONS(3983),
    [anon_sym___restrict__] = ACTIONS(3983),
    [anon_sym__Atomic] = ACTIONS(3983),
    [anon_sym__Noreturn] = ACTIONS(3983),
    [anon_sym_noreturn] = ACTIONS(3983),
    [anon_sym__Nonnull] = ACTIONS(3983),
    [anon_sym_mutable] = ACTIONS(3983),
    [anon_sym_constinit] = ACTIONS(3983),
    [anon_sym_consteval] = ACTIONS(3983),
    [anon_sym_alignas] = ACTIONS(3983),
    [anon_sym__Alignas] = ACTIONS(3983),
    [sym_primitive_type] = ACTIONS(3983),
    [anon_sym_enum] = ACTIONS(3983),
    [anon_sym_class] = ACTIONS(3983),
    [anon_sym_struct] = ACTIONS(3983),
    [anon_sym_union] = ACTIONS(3983),
    [anon_sym_if] = ACTIONS(3983),
    [anon_sym_switch] = ACTIONS(3983),
    [anon_sym_case] = ACTIONS(3983),
    [anon_sym_default] = ACTIONS(3983),
    [anon_sym_while] = ACTIONS(3983),
    [anon_sym_do] = ACTIONS(3983),
    [anon_sym_for] = ACTIONS(3983),
    [anon_sym_return] = ACTIONS(3983),
    [anon_sym_break] = ACTIONS(3983),
    [anon_sym_continue] = ACTIONS(3983),
    [anon_sym_goto] = ACTIONS(3983),
    [anon_sym_not] = ACTIONS(3983),
    [anon_sym_compl] = ACTIONS(3983),
    [anon_sym_DASH_DASH] = ACTIONS(3985),
    [anon_sym_PLUS_PLUS] = ACTIONS(3985),
    [anon_sym_sizeof] = ACTIONS(3983),
    [anon_sym___alignof__] = ACTIONS(3983),
    [anon_sym___alignof] = ACTIONS(3983),
    [anon_sym__alignof] = ACTIONS(3983),
    [anon_sym_alignof] = ACTIONS(3983),
    [anon_sym__Alignof] = ACTIONS(3983),
    [anon_sym_offsetof] = ACTIONS(3983),
    [anon_sym__Generic] = ACTIONS(3983),
    [anon_sym_asm] = ACTIONS(3983),
    [anon_sym___asm__] = ACTIONS(3983),
    [anon_sym___asm] = ACTIONS(3983),
    [sym_number_literal] = ACTIONS(3985),
    [anon_sym_L_SQUOTE] = ACTIONS(3985),
    [anon_sym_u_SQUOTE] = ACTIONS(3985),
    [anon_sym_U_SQUOTE] = ACTIONS(3985),
    [anon_sym_u8_SQUOTE] = ACTIONS(3985),
    [anon_sym_SQUOTE] = ACTIONS(3985),
    [anon_sym_L_DQUOTE] = ACTIONS(3985),
    [anon_sym_u_DQUOTE] = ACTIONS(3985),
    [anon_sym_U_DQUOTE] = ACTIONS(3985),
    [anon_sym_u8_DQUOTE] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(3985),
    [sym_true] = ACTIONS(3983),
    [sym_false] = ACTIONS(3983),
    [anon_sym_NULL] = ACTIONS(3983),
    [anon_sym_nullptr] = ACTIONS(3983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3983),
    [anon_sym_let] = ACTIONS(3983),
    [anon_sym_This] = ACTIONS(3983),
    [anon_sym_decltype] = ACTIONS(3983),
    [anon_sym_explicit] = ACTIONS(3983),
    [anon_sym_typename] = ACTIONS(3983),
    [anon_sym_export] = ACTIONS(3983),
    [anon_sym_module] = ACTIONS(3983),
    [anon_sym_import] = ACTIONS(3983),
    [anon_sym_template] = ACTIONS(3983),
    [anon_sym_operator] = ACTIONS(3983),
    [anon_sym_try] = ACTIONS(3983),
    [anon_sym_delete] = ACTIONS(3983),
    [anon_sym_throw] = ACTIONS(3983),
    [anon_sym_namespace] = ACTIONS(3983),
    [anon_sym_static_assert] = ACTIONS(3983),
    [anon_sym_concept] = ACTIONS(3983),
    [anon_sym_co_return] = ACTIONS(3983),
    [anon_sym_co_yield] = ACTIONS(3983),
    [anon_sym_R_DQUOTE] = ACTIONS(3985),
    [anon_sym_LR_DQUOTE] = ACTIONS(3985),
    [anon_sym_uR_DQUOTE] = ACTIONS(3985),
    [anon_sym_UR_DQUOTE] = ACTIONS(3985),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3985),
    [anon_sym_co_await] = ACTIONS(3983),
    [anon_sym_new] = ACTIONS(3983),
    [anon_sym_requires] = ACTIONS(3983),
    [sym_this] = ACTIONS(3983),
    [anon_sym_precise] = ACTIONS(3983),
    [anon_sym_shared] = ACTIONS(3983),
    [anon_sym_groupshared] = ACTIONS(3983),
    [anon_sym_uniform] = ACTIONS(3983),
    [anon_sym_row_major] = ACTIONS(3983),
    [anon_sym_column_major] = ACTIONS(3983),
    [anon_sym_globallycoherent] = ACTIONS(3983),
    [anon_sym_centroid] = ACTIONS(3983),
    [anon_sym_noperspective] = ACTIONS(3983),
    [anon_sym_nointerpolation] = ACTIONS(3983),
    [anon_sym_sample] = ACTIONS(3983),
    [anon_sym_linear] = ACTIONS(3983),
    [anon_sym_snorm] = ACTIONS(3983),
    [anon_sym_unorm] = ACTIONS(3983),
    [anon_sym_point] = ACTIONS(3983),
    [anon_sym_line] = ACTIONS(3983),
    [anon_sym_triangleadj] = ACTIONS(3983),
    [anon_sym_lineadj] = ACTIONS(3983),
    [anon_sym_triangle] = ACTIONS(3983),
    [anon_sym_interface] = ACTIONS(3983),
    [anon_sym_extension] = ACTIONS(3983),
    [anon_sym___exported] = ACTIONS(3983),
  },
  [1048] = {
    [ts_builtin_sym_end] = ACTIONS(3979),
    [sym_identifier] = ACTIONS(3977),
    [aux_sym_preproc_include_token1] = ACTIONS(3977),
    [aux_sym_preproc_def_token1] = ACTIONS(3977),
    [aux_sym_preproc_if_token1] = ACTIONS(3977),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3977),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3977),
    [sym_preproc_directive] = ACTIONS(3977),
    [anon_sym_LPAREN2] = ACTIONS(3979),
    [anon_sym_BANG] = ACTIONS(3979),
    [anon_sym_TILDE] = ACTIONS(3979),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_PLUS] = ACTIONS(3977),
    [anon_sym_STAR] = ACTIONS(3979),
    [anon_sym_AMP_AMP] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3977),
    [anon_sym_SEMI] = ACTIONS(3979),
    [anon_sym___extension__] = ACTIONS(3977),
    [anon_sym_typedef] = ACTIONS(3977),
    [anon_sym_in] = ACTIONS(3977),
    [anon_sym_out] = ACTIONS(3977),
    [anon_sym_inout] = ACTIONS(3977),
    [anon_sym_virtual] = ACTIONS(3977),
    [anon_sym_extern] = ACTIONS(3977),
    [anon_sym___attribute__] = ACTIONS(3977),
    [anon_sym___attribute] = ACTIONS(3977),
    [anon_sym_using] = ACTIONS(3977),
    [anon_sym_COLON_COLON] = ACTIONS(3979),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3979),
    [anon_sym___declspec] = ACTIONS(3977),
    [anon_sym___based] = ACTIONS(3977),
    [anon_sym___cdecl] = ACTIONS(3977),
    [anon_sym___clrcall] = ACTIONS(3977),
    [anon_sym___stdcall] = ACTIONS(3977),
    [anon_sym___fastcall] = ACTIONS(3977),
    [anon_sym___thiscall] = ACTIONS(3977),
    [anon_sym___vectorcall] = ACTIONS(3977),
    [anon_sym_LBRACE] = ACTIONS(3979),
    [anon_sym_signed] = ACTIONS(3977),
    [anon_sym_unsigned] = ACTIONS(3977),
    [anon_sym_long] = ACTIONS(3977),
    [anon_sym_short] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3977),
    [anon_sym_static] = ACTIONS(3977),
    [anon_sym_register] = ACTIONS(3977),
    [anon_sym_inline] = ACTIONS(3977),
    [anon_sym___inline] = ACTIONS(3977),
    [anon_sym___inline__] = ACTIONS(3977),
    [anon_sym___forceinline] = ACTIONS(3977),
    [anon_sym_thread_local] = ACTIONS(3977),
    [anon_sym___thread] = ACTIONS(3977),
    [anon_sym_const] = ACTIONS(3977),
    [anon_sym_constexpr] = ACTIONS(3977),
    [anon_sym_volatile] = ACTIONS(3977),
    [anon_sym_restrict] = ACTIONS(3977),
    [anon_sym___restrict__] = ACTIONS(3977),
    [anon_sym__Atomic] = ACTIONS(3977),
    [anon_sym__Noreturn] = ACTIONS(3977),
    [anon_sym_noreturn] = ACTIONS(3977),
    [anon_sym__Nonnull] = ACTIONS(3977),
    [anon_sym_mutable] = ACTIONS(3977),
    [anon_sym_constinit] = ACTIONS(3977),
    [anon_sym_consteval] = ACTIONS(3977),
    [anon_sym_alignas] = ACTIONS(3977),
    [anon_sym__Alignas] = ACTIONS(3977),
    [sym_primitive_type] = ACTIONS(3977),
    [anon_sym_enum] = ACTIONS(3977),
    [anon_sym_class] = ACTIONS(3977),
    [anon_sym_struct] = ACTIONS(3977),
    [anon_sym_union] = ACTIONS(3977),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_switch] = ACTIONS(3977),
    [anon_sym_case] = ACTIONS(3977),
    [anon_sym_default] = ACTIONS(3977),
    [anon_sym_while] = ACTIONS(3977),
    [anon_sym_do] = ACTIONS(3977),
    [anon_sym_for] = ACTIONS(3977),
    [anon_sym_return] = ACTIONS(3977),
    [anon_sym_break] = ACTIONS(3977),
    [anon_sym_continue] = ACTIONS(3977),
    [anon_sym_goto] = ACTIONS(3977),
    [anon_sym_not] = ACTIONS(3977),
    [anon_sym_compl] = ACTIONS(3977),
    [anon_sym_DASH_DASH] = ACTIONS(3979),
    [anon_sym_PLUS_PLUS] = ACTIONS(3979),
    [anon_sym_sizeof] = ACTIONS(3977),
    [anon_sym___alignof__] = ACTIONS(3977),
    [anon_sym___alignof] = ACTIONS(3977),
    [anon_sym__alignof] = ACTIONS(3977),
    [anon_sym_alignof] = ACTIONS(3977),
    [anon_sym__Alignof] = ACTIONS(3977),
    [anon_sym_offsetof] = ACTIONS(3977),
    [anon_sym__Generic] = ACTIONS(3977),
    [anon_sym_asm] = ACTIONS(3977),
    [anon_sym___asm__] = ACTIONS(3977),
    [anon_sym___asm] = ACTIONS(3977),
    [sym_number_literal] = ACTIONS(3979),
    [anon_sym_L_SQUOTE] = ACTIONS(3979),
    [anon_sym_u_SQUOTE] = ACTIONS(3979),
    [anon_sym_U_SQUOTE] = ACTIONS(3979),
    [anon_sym_u8_SQUOTE] = ACTIONS(3979),
    [anon_sym_SQUOTE] = ACTIONS(3979),
    [anon_sym_L_DQUOTE] = ACTIONS(3979),
    [anon_sym_u_DQUOTE] = ACTIONS(3979),
    [anon_sym_U_DQUOTE] = ACTIONS(3979),
    [anon_sym_u8_DQUOTE] = ACTIONS(3979),
    [anon_sym_DQUOTE] = ACTIONS(3979),
    [sym_true] = ACTIONS(3977),
    [sym_false] = ACTIONS(3977),
    [anon_sym_NULL] = ACTIONS(3977),
    [anon_sym_nullptr] = ACTIONS(3977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3977),
    [anon_sym_let] = ACTIONS(3977),
    [anon_sym_This] = ACTIONS(3977),
    [anon_sym_decltype] = ACTIONS(3977),
    [anon_sym_explicit] = ACTIONS(3977),
    [anon_sym_typename] = ACTIONS(3977),
    [anon_sym_export] = ACTIONS(3977),
    [anon_sym_module] = ACTIONS(3977),
    [anon_sym_import] = ACTIONS(3977),
    [anon_sym_template] = ACTIONS(3977),
    [anon_sym_operator] = ACTIONS(3977),
    [anon_sym_try] = ACTIONS(3977),
    [anon_sym_delete] = ACTIONS(3977),
    [anon_sym_throw] = ACTIONS(3977),
    [anon_sym_namespace] = ACTIONS(3977),
    [anon_sym_static_assert] = ACTIONS(3977),
    [anon_sym_concept] = ACTIONS(3977),
    [anon_sym_co_return] = ACTIONS(3977),
    [anon_sym_co_yield] = ACTIONS(3977),
    [anon_sym_R_DQUOTE] = ACTIONS(3979),
    [anon_sym_LR_DQUOTE] = ACTIONS(3979),
    [anon_sym_uR_DQUOTE] = ACTIONS(3979),
    [anon_sym_UR_DQUOTE] = ACTIONS(3979),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3979),
    [anon_sym_co_await] = ACTIONS(3977),
    [anon_sym_new] = ACTIONS(3977),
    [anon_sym_requires] = ACTIONS(3977),
    [sym_this] = ACTIONS(3977),
    [anon_sym_precise] = ACTIONS(3977),
    [anon_sym_shared] = ACTIONS(3977),
    [anon_sym_groupshared] = ACTIONS(3977),
    [anon_sym_uniform] = ACTIONS(3977),
    [anon_sym_row_major] = ACTIONS(3977),
    [anon_sym_column_major] = ACTIONS(3977),
    [anon_sym_globallycoherent] = ACTIONS(3977),
    [anon_sym_centroid] = ACTIONS(3977),
    [anon_sym_noperspective] = ACTIONS(3977),
    [anon_sym_nointerpolation] = ACTIONS(3977),
    [anon_sym_sample] = ACTIONS(3977),
    [anon_sym_linear] = ACTIONS(3977),
    [anon_sym_snorm] = ACTIONS(3977),
    [anon_sym_unorm] = ACTIONS(3977),
    [anon_sym_point] = ACTIONS(3977),
    [anon_sym_line] = ACTIONS(3977),
    [anon_sym_triangleadj] = ACTIONS(3977),
    [anon_sym_lineadj] = ACTIONS(3977),
    [anon_sym_triangle] = ACTIONS(3977),
    [anon_sym_interface] = ACTIONS(3977),
    [anon_sym_extension] = ACTIONS(3977),
    [anon_sym___exported] = ACTIONS(3977),
  },
  [1049] = {
    [ts_builtin_sym_end] = ACTIONS(3753),
    [sym_identifier] = ACTIONS(3751),
    [aux_sym_preproc_include_token1] = ACTIONS(3751),
    [aux_sym_preproc_def_token1] = ACTIONS(3751),
    [aux_sym_preproc_if_token1] = ACTIONS(3751),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3751),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3751),
    [sym_preproc_directive] = ACTIONS(3751),
    [anon_sym_LPAREN2] = ACTIONS(3753),
    [anon_sym_BANG] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3751),
    [anon_sym_PLUS] = ACTIONS(3751),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_AMP] = ACTIONS(3751),
    [anon_sym_SEMI] = ACTIONS(3753),
    [anon_sym___extension__] = ACTIONS(3751),
    [anon_sym_typedef] = ACTIONS(3751),
    [anon_sym_in] = ACTIONS(3751),
    [anon_sym_out] = ACTIONS(3751),
    [anon_sym_inout] = ACTIONS(3751),
    [anon_sym_virtual] = ACTIONS(3751),
    [anon_sym_extern] = ACTIONS(3751),
    [anon_sym___attribute__] = ACTIONS(3751),
    [anon_sym___attribute] = ACTIONS(3751),
    [anon_sym_using] = ACTIONS(3751),
    [anon_sym_COLON_COLON] = ACTIONS(3753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3753),
    [anon_sym___declspec] = ACTIONS(3751),
    [anon_sym___based] = ACTIONS(3751),
    [anon_sym___cdecl] = ACTIONS(3751),
    [anon_sym___clrcall] = ACTIONS(3751),
    [anon_sym___stdcall] = ACTIONS(3751),
    [anon_sym___fastcall] = ACTIONS(3751),
    [anon_sym___thiscall] = ACTIONS(3751),
    [anon_sym___vectorcall] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_signed] = ACTIONS(3751),
    [anon_sym_unsigned] = ACTIONS(3751),
    [anon_sym_long] = ACTIONS(3751),
    [anon_sym_short] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3751),
    [anon_sym_static] = ACTIONS(3751),
    [anon_sym_register] = ACTIONS(3751),
    [anon_sym_inline] = ACTIONS(3751),
    [anon_sym___inline] = ACTIONS(3751),
    [anon_sym___inline__] = ACTIONS(3751),
    [anon_sym___forceinline] = ACTIONS(3751),
    [anon_sym_thread_local] = ACTIONS(3751),
    [anon_sym___thread] = ACTIONS(3751),
    [anon_sym_const] = ACTIONS(3751),
    [anon_sym_constexpr] = ACTIONS(3751),
    [anon_sym_volatile] = ACTIONS(3751),
    [anon_sym_restrict] = ACTIONS(3751),
    [anon_sym___restrict__] = ACTIONS(3751),
    [anon_sym__Atomic] = ACTIONS(3751),
    [anon_sym__Noreturn] = ACTIONS(3751),
    [anon_sym_noreturn] = ACTIONS(3751),
    [anon_sym__Nonnull] = ACTIONS(3751),
    [anon_sym_mutable] = ACTIONS(3751),
    [anon_sym_constinit] = ACTIONS(3751),
    [anon_sym_consteval] = ACTIONS(3751),
    [anon_sym_alignas] = ACTIONS(3751),
    [anon_sym__Alignas] = ACTIONS(3751),
    [sym_primitive_type] = ACTIONS(3751),
    [anon_sym_enum] = ACTIONS(3751),
    [anon_sym_class] = ACTIONS(3751),
    [anon_sym_struct] = ACTIONS(3751),
    [anon_sym_union] = ACTIONS(3751),
    [anon_sym_if] = ACTIONS(3751),
    [anon_sym_switch] = ACTIONS(3751),
    [anon_sym_case] = ACTIONS(3751),
    [anon_sym_default] = ACTIONS(3751),
    [anon_sym_while] = ACTIONS(3751),
    [anon_sym_do] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3751),
    [anon_sym_return] = ACTIONS(3751),
    [anon_sym_break] = ACTIONS(3751),
    [anon_sym_continue] = ACTIONS(3751),
    [anon_sym_goto] = ACTIONS(3751),
    [anon_sym_not] = ACTIONS(3751),
    [anon_sym_compl] = ACTIONS(3751),
    [anon_sym_DASH_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_PLUS] = ACTIONS(3753),
    [anon_sym_sizeof] = ACTIONS(3751),
    [anon_sym___alignof__] = ACTIONS(3751),
    [anon_sym___alignof] = ACTIONS(3751),
    [anon_sym__alignof] = ACTIONS(3751),
    [anon_sym_alignof] = ACTIONS(3751),
    [anon_sym__Alignof] = ACTIONS(3751),
    [anon_sym_offsetof] = ACTIONS(3751),
    [anon_sym__Generic] = ACTIONS(3751),
    [anon_sym_asm] = ACTIONS(3751),
    [anon_sym___asm__] = ACTIONS(3751),
    [anon_sym___asm] = ACTIONS(3751),
    [sym_number_literal] = ACTIONS(3753),
    [anon_sym_L_SQUOTE] = ACTIONS(3753),
    [anon_sym_u_SQUOTE] = ACTIONS(3753),
    [anon_sym_U_SQUOTE] = ACTIONS(3753),
    [anon_sym_u8_SQUOTE] = ACTIONS(3753),
    [anon_sym_SQUOTE] = ACTIONS(3753),
    [anon_sym_L_DQUOTE] = ACTIONS(3753),
    [anon_sym_u_DQUOTE] = ACTIONS(3753),
    [anon_sym_U_DQUOTE] = ACTIONS(3753),
    [anon_sym_u8_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [sym_true] = ACTIONS(3751),
    [sym_false] = ACTIONS(3751),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3751),
    [anon_sym_let] = ACTIONS(3751),
    [anon_sym_This] = ACTIONS(3751),
    [anon_sym_decltype] = ACTIONS(3751),
    [anon_sym_explicit] = ACTIONS(3751),
    [anon_sym_typename] = ACTIONS(3751),
    [anon_sym_export] = ACTIONS(3751),
    [anon_sym_module] = ACTIONS(3751),
    [anon_sym_import] = ACTIONS(3751),
    [anon_sym_template] = ACTIONS(3751),
    [anon_sym_operator] = ACTIONS(3751),
    [anon_sym_try] = ACTIONS(3751),
    [anon_sym_delete] = ACTIONS(3751),
    [anon_sym_throw] = ACTIONS(3751),
    [anon_sym_namespace] = ACTIONS(3751),
    [anon_sym_static_assert] = ACTIONS(3751),
    [anon_sym_concept] = ACTIONS(3751),
    [anon_sym_co_return] = ACTIONS(3751),
    [anon_sym_co_yield] = ACTIONS(3751),
    [anon_sym_R_DQUOTE] = ACTIONS(3753),
    [anon_sym_LR_DQUOTE] = ACTIONS(3753),
    [anon_sym_uR_DQUOTE] = ACTIONS(3753),
    [anon_sym_UR_DQUOTE] = ACTIONS(3753),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3753),
    [anon_sym_co_await] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3751),
    [anon_sym_requires] = ACTIONS(3751),
    [sym_this] = ACTIONS(3751),
    [anon_sym_precise] = ACTIONS(3751),
    [anon_sym_shared] = ACTIONS(3751),
    [anon_sym_groupshared] = ACTIONS(3751),
    [anon_sym_uniform] = ACTIONS(3751),
    [anon_sym_row_major] = ACTIONS(3751),
    [anon_sym_column_major] = ACTIONS(3751),
    [anon_sym_globallycoherent] = ACTIONS(3751),
    [anon_sym_centroid] = ACTIONS(3751),
    [anon_sym_noperspective] = ACTIONS(3751),
    [anon_sym_nointerpolation] = ACTIONS(3751),
    [anon_sym_sample] = ACTIONS(3751),
    [anon_sym_linear] = ACTIONS(3751),
    [anon_sym_snorm] = ACTIONS(3751),
    [anon_sym_unorm] = ACTIONS(3751),
    [anon_sym_point] = ACTIONS(3751),
    [anon_sym_line] = ACTIONS(3751),
    [anon_sym_triangleadj] = ACTIONS(3751),
    [anon_sym_lineadj] = ACTIONS(3751),
    [anon_sym_triangle] = ACTIONS(3751),
    [anon_sym_interface] = ACTIONS(3751),
    [anon_sym_extension] = ACTIONS(3751),
    [anon_sym___exported] = ACTIONS(3751),
  },
  [1050] = {
    [sym_identifier] = ACTIONS(3669),
    [aux_sym_preproc_include_token1] = ACTIONS(3669),
    [aux_sym_preproc_def_token1] = ACTIONS(3669),
    [aux_sym_preproc_if_token1] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3669),
    [sym_preproc_directive] = ACTIONS(3669),
    [anon_sym_LPAREN2] = ACTIONS(3671),
    [anon_sym_BANG] = ACTIONS(3671),
    [anon_sym_TILDE] = ACTIONS(3671),
    [anon_sym_DASH] = ACTIONS(3669),
    [anon_sym_PLUS] = ACTIONS(3669),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3671),
    [anon_sym_AMP] = ACTIONS(3669),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym___extension__] = ACTIONS(3669),
    [anon_sym_typedef] = ACTIONS(3669),
    [anon_sym_in] = ACTIONS(3669),
    [anon_sym_out] = ACTIONS(3669),
    [anon_sym_inout] = ACTIONS(3669),
    [anon_sym_virtual] = ACTIONS(3669),
    [anon_sym_extern] = ACTIONS(3669),
    [anon_sym___attribute__] = ACTIONS(3669),
    [anon_sym___attribute] = ACTIONS(3669),
    [anon_sym_using] = ACTIONS(3669),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3671),
    [anon_sym___declspec] = ACTIONS(3669),
    [anon_sym___based] = ACTIONS(3669),
    [anon_sym___cdecl] = ACTIONS(3669),
    [anon_sym___clrcall] = ACTIONS(3669),
    [anon_sym___stdcall] = ACTIONS(3669),
    [anon_sym___fastcall] = ACTIONS(3669),
    [anon_sym___thiscall] = ACTIONS(3669),
    [anon_sym___vectorcall] = ACTIONS(3669),
    [anon_sym_LBRACE] = ACTIONS(3671),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [anon_sym_signed] = ACTIONS(3669),
    [anon_sym_unsigned] = ACTIONS(3669),
    [anon_sym_long] = ACTIONS(3669),
    [anon_sym_short] = ACTIONS(3669),
    [anon_sym_LBRACK] = ACTIONS(3669),
    [anon_sym_static] = ACTIONS(3669),
    [anon_sym_register] = ACTIONS(3669),
    [anon_sym_inline] = ACTIONS(3669),
    [anon_sym___inline] = ACTIONS(3669),
    [anon_sym___inline__] = ACTIONS(3669),
    [anon_sym___forceinline] = ACTIONS(3669),
    [anon_sym_thread_local] = ACTIONS(3669),
    [anon_sym___thread] = ACTIONS(3669),
    [anon_sym_const] = ACTIONS(3669),
    [anon_sym_constexpr] = ACTIONS(3669),
    [anon_sym_volatile] = ACTIONS(3669),
    [anon_sym_restrict] = ACTIONS(3669),
    [anon_sym___restrict__] = ACTIONS(3669),
    [anon_sym__Atomic] = ACTIONS(3669),
    [anon_sym__Noreturn] = ACTIONS(3669),
    [anon_sym_noreturn] = ACTIONS(3669),
    [anon_sym__Nonnull] = ACTIONS(3669),
    [anon_sym_mutable] = ACTIONS(3669),
    [anon_sym_constinit] = ACTIONS(3669),
    [anon_sym_consteval] = ACTIONS(3669),
    [anon_sym_alignas] = ACTIONS(3669),
    [anon_sym__Alignas] = ACTIONS(3669),
    [sym_primitive_type] = ACTIONS(3669),
    [anon_sym_enum] = ACTIONS(3669),
    [anon_sym_class] = ACTIONS(3669),
    [anon_sym_struct] = ACTIONS(3669),
    [anon_sym_union] = ACTIONS(3669),
    [anon_sym_if] = ACTIONS(3669),
    [anon_sym_switch] = ACTIONS(3669),
    [anon_sym_case] = ACTIONS(3669),
    [anon_sym_default] = ACTIONS(3669),
    [anon_sym_while] = ACTIONS(3669),
    [anon_sym_do] = ACTIONS(3669),
    [anon_sym_for] = ACTIONS(3669),
    [anon_sym_return] = ACTIONS(3669),
    [anon_sym_break] = ACTIONS(3669),
    [anon_sym_continue] = ACTIONS(3669),
    [anon_sym_goto] = ACTIONS(3669),
    [anon_sym___try] = ACTIONS(3669),
    [anon_sym___leave] = ACTIONS(3669),
    [anon_sym_not] = ACTIONS(3669),
    [anon_sym_compl] = ACTIONS(3669),
    [anon_sym_DASH_DASH] = ACTIONS(3671),
    [anon_sym_PLUS_PLUS] = ACTIONS(3671),
    [anon_sym_sizeof] = ACTIONS(3669),
    [anon_sym___alignof__] = ACTIONS(3669),
    [anon_sym___alignof] = ACTIONS(3669),
    [anon_sym__alignof] = ACTIONS(3669),
    [anon_sym_alignof] = ACTIONS(3669),
    [anon_sym__Alignof] = ACTIONS(3669),
    [anon_sym_offsetof] = ACTIONS(3669),
    [anon_sym__Generic] = ACTIONS(3669),
    [anon_sym_asm] = ACTIONS(3669),
    [anon_sym___asm__] = ACTIONS(3669),
    [anon_sym___asm] = ACTIONS(3669),
    [sym_number_literal] = ACTIONS(3671),
    [anon_sym_L_SQUOTE] = ACTIONS(3671),
    [anon_sym_u_SQUOTE] = ACTIONS(3671),
    [anon_sym_U_SQUOTE] = ACTIONS(3671),
    [anon_sym_u8_SQUOTE] = ACTIONS(3671),
    [anon_sym_SQUOTE] = ACTIONS(3671),
    [anon_sym_L_DQUOTE] = ACTIONS(3671),
    [anon_sym_u_DQUOTE] = ACTIONS(3671),
    [anon_sym_U_DQUOTE] = ACTIONS(3671),
    [anon_sym_u8_DQUOTE] = ACTIONS(3671),
    [anon_sym_DQUOTE] = ACTIONS(3671),
    [sym_true] = ACTIONS(3669),
    [sym_false] = ACTIONS(3669),
    [anon_sym_NULL] = ACTIONS(3669),
    [anon_sym_nullptr] = ACTIONS(3669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3669),
    [anon_sym_let] = ACTIONS(3669),
    [anon_sym_This] = ACTIONS(3669),
    [anon_sym_decltype] = ACTIONS(3669),
    [anon_sym_explicit] = ACTIONS(3669),
    [anon_sym_typename] = ACTIONS(3669),
    [anon_sym_template] = ACTIONS(3669),
    [anon_sym_operator] = ACTIONS(3669),
    [anon_sym_try] = ACTIONS(3669),
    [anon_sym_delete] = ACTIONS(3669),
    [anon_sym_throw] = ACTIONS(3669),
    [anon_sym_namespace] = ACTIONS(3669),
    [anon_sym_static_assert] = ACTIONS(3669),
    [anon_sym_concept] = ACTIONS(3669),
    [anon_sym_co_return] = ACTIONS(3669),
    [anon_sym_co_yield] = ACTIONS(3669),
    [anon_sym_R_DQUOTE] = ACTIONS(3671),
    [anon_sym_LR_DQUOTE] = ACTIONS(3671),
    [anon_sym_uR_DQUOTE] = ACTIONS(3671),
    [anon_sym_UR_DQUOTE] = ACTIONS(3671),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3671),
    [anon_sym_co_await] = ACTIONS(3669),
    [anon_sym_new] = ACTIONS(3669),
    [anon_sym_requires] = ACTIONS(3669),
    [sym_this] = ACTIONS(3669),
    [anon_sym_discard] = ACTIONS(3669),
    [anon_sym_precise] = ACTIONS(3669),
    [anon_sym_shared] = ACTIONS(3669),
    [anon_sym_groupshared] = ACTIONS(3669),
    [anon_sym_uniform] = ACTIONS(3669),
    [anon_sym_row_major] = ACTIONS(3669),
    [anon_sym_column_major] = ACTIONS(3669),
    [anon_sym_globallycoherent] = ACTIONS(3669),
    [anon_sym_centroid] = ACTIONS(3669),
    [anon_sym_noperspective] = ACTIONS(3669),
    [anon_sym_nointerpolation] = ACTIONS(3669),
    [anon_sym_sample] = ACTIONS(3669),
    [anon_sym_linear] = ACTIONS(3669),
    [anon_sym_snorm] = ACTIONS(3669),
    [anon_sym_unorm] = ACTIONS(3669),
    [anon_sym_point] = ACTIONS(3669),
    [anon_sym_line] = ACTIONS(3669),
    [anon_sym_triangleadj] = ACTIONS(3669),
    [anon_sym_lineadj] = ACTIONS(3669),
    [anon_sym_triangle] = ACTIONS(3669),
    [anon_sym_cbuffer] = ACTIONS(3669),
    [anon_sym_interface] = ACTIONS(3669),
    [anon_sym_extension] = ACTIONS(3669),
  },
  [1051] = {
    [sym_identifier] = ACTIONS(3673),
    [aux_sym_preproc_include_token1] = ACTIONS(3673),
    [aux_sym_preproc_def_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token1] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3673),
    [sym_preproc_directive] = ACTIONS(3673),
    [anon_sym_LPAREN2] = ACTIONS(3675),
    [anon_sym_BANG] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3673),
    [anon_sym_PLUS] = ACTIONS(3673),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3673),
    [anon_sym_SEMI] = ACTIONS(3675),
    [anon_sym___extension__] = ACTIONS(3673),
    [anon_sym_typedef] = ACTIONS(3673),
    [anon_sym_in] = ACTIONS(3673),
    [anon_sym_out] = ACTIONS(3673),
    [anon_sym_inout] = ACTIONS(3673),
    [anon_sym_virtual] = ACTIONS(3673),
    [anon_sym_extern] = ACTIONS(3673),
    [anon_sym___attribute__] = ACTIONS(3673),
    [anon_sym___attribute] = ACTIONS(3673),
    [anon_sym_using] = ACTIONS(3673),
    [anon_sym_COLON_COLON] = ACTIONS(3675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3675),
    [anon_sym___declspec] = ACTIONS(3673),
    [anon_sym___based] = ACTIONS(3673),
    [anon_sym___cdecl] = ACTIONS(3673),
    [anon_sym___clrcall] = ACTIONS(3673),
    [anon_sym___stdcall] = ACTIONS(3673),
    [anon_sym___fastcall] = ACTIONS(3673),
    [anon_sym___thiscall] = ACTIONS(3673),
    [anon_sym___vectorcall] = ACTIONS(3673),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_RBRACE] = ACTIONS(3675),
    [anon_sym_signed] = ACTIONS(3673),
    [anon_sym_unsigned] = ACTIONS(3673),
    [anon_sym_long] = ACTIONS(3673),
    [anon_sym_short] = ACTIONS(3673),
    [anon_sym_LBRACK] = ACTIONS(3673),
    [anon_sym_static] = ACTIONS(3673),
    [anon_sym_register] = ACTIONS(3673),
    [anon_sym_inline] = ACTIONS(3673),
    [anon_sym___inline] = ACTIONS(3673),
    [anon_sym___inline__] = ACTIONS(3673),
    [anon_sym___forceinline] = ACTIONS(3673),
    [anon_sym_thread_local] = ACTIONS(3673),
    [anon_sym___thread] = ACTIONS(3673),
    [anon_sym_const] = ACTIONS(3673),
    [anon_sym_constexpr] = ACTIONS(3673),
    [anon_sym_volatile] = ACTIONS(3673),
    [anon_sym_restrict] = ACTIONS(3673),
    [anon_sym___restrict__] = ACTIONS(3673),
    [anon_sym__Atomic] = ACTIONS(3673),
    [anon_sym__Noreturn] = ACTIONS(3673),
    [anon_sym_noreturn] = ACTIONS(3673),
    [anon_sym__Nonnull] = ACTIONS(3673),
    [anon_sym_mutable] = ACTIONS(3673),
    [anon_sym_constinit] = ACTIONS(3673),
    [anon_sym_consteval] = ACTIONS(3673),
    [anon_sym_alignas] = ACTIONS(3673),
    [anon_sym__Alignas] = ACTIONS(3673),
    [sym_primitive_type] = ACTIONS(3673),
    [anon_sym_enum] = ACTIONS(3673),
    [anon_sym_class] = ACTIONS(3673),
    [anon_sym_struct] = ACTIONS(3673),
    [anon_sym_union] = ACTIONS(3673),
    [anon_sym_if] = ACTIONS(3673),
    [anon_sym_switch] = ACTIONS(3673),
    [anon_sym_case] = ACTIONS(3673),
    [anon_sym_default] = ACTIONS(3673),
    [anon_sym_while] = ACTIONS(3673),
    [anon_sym_do] = ACTIONS(3673),
    [anon_sym_for] = ACTIONS(3673),
    [anon_sym_return] = ACTIONS(3673),
    [anon_sym_break] = ACTIONS(3673),
    [anon_sym_continue] = ACTIONS(3673),
    [anon_sym_goto] = ACTIONS(3673),
    [anon_sym___try] = ACTIONS(3673),
    [anon_sym___leave] = ACTIONS(3673),
    [anon_sym_not] = ACTIONS(3673),
    [anon_sym_compl] = ACTIONS(3673),
    [anon_sym_DASH_DASH] = ACTIONS(3675),
    [anon_sym_PLUS_PLUS] = ACTIONS(3675),
    [anon_sym_sizeof] = ACTIONS(3673),
    [anon_sym___alignof__] = ACTIONS(3673),
    [anon_sym___alignof] = ACTIONS(3673),
    [anon_sym__alignof] = ACTIONS(3673),
    [anon_sym_alignof] = ACTIONS(3673),
    [anon_sym__Alignof] = ACTIONS(3673),
    [anon_sym_offsetof] = ACTIONS(3673),
    [anon_sym__Generic] = ACTIONS(3673),
    [anon_sym_asm] = ACTIONS(3673),
    [anon_sym___asm__] = ACTIONS(3673),
    [anon_sym___asm] = ACTIONS(3673),
    [sym_number_literal] = ACTIONS(3675),
    [anon_sym_L_SQUOTE] = ACTIONS(3675),
    [anon_sym_u_SQUOTE] = ACTIONS(3675),
    [anon_sym_U_SQUOTE] = ACTIONS(3675),
    [anon_sym_u8_SQUOTE] = ACTIONS(3675),
    [anon_sym_SQUOTE] = ACTIONS(3675),
    [anon_sym_L_DQUOTE] = ACTIONS(3675),
    [anon_sym_u_DQUOTE] = ACTIONS(3675),
    [anon_sym_U_DQUOTE] = ACTIONS(3675),
    [anon_sym_u8_DQUOTE] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(3675),
    [sym_true] = ACTIONS(3673),
    [sym_false] = ACTIONS(3673),
    [anon_sym_NULL] = ACTIONS(3673),
    [anon_sym_nullptr] = ACTIONS(3673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3673),
    [anon_sym_let] = ACTIONS(3673),
    [anon_sym_This] = ACTIONS(3673),
    [anon_sym_decltype] = ACTIONS(3673),
    [anon_sym_explicit] = ACTIONS(3673),
    [anon_sym_typename] = ACTIONS(3673),
    [anon_sym_template] = ACTIONS(3673),
    [anon_sym_operator] = ACTIONS(3673),
    [anon_sym_try] = ACTIONS(3673),
    [anon_sym_delete] = ACTIONS(3673),
    [anon_sym_throw] = ACTIONS(3673),
    [anon_sym_namespace] = ACTIONS(3673),
    [anon_sym_static_assert] = ACTIONS(3673),
    [anon_sym_concept] = ACTIONS(3673),
    [anon_sym_co_return] = ACTIONS(3673),
    [anon_sym_co_yield] = ACTIONS(3673),
    [anon_sym_R_DQUOTE] = ACTIONS(3675),
    [anon_sym_LR_DQUOTE] = ACTIONS(3675),
    [anon_sym_uR_DQUOTE] = ACTIONS(3675),
    [anon_sym_UR_DQUOTE] = ACTIONS(3675),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3675),
    [anon_sym_co_await] = ACTIONS(3673),
    [anon_sym_new] = ACTIONS(3673),
    [anon_sym_requires] = ACTIONS(3673),
    [sym_this] = ACTIONS(3673),
    [anon_sym_discard] = ACTIONS(3673),
    [anon_sym_precise] = ACTIONS(3673),
    [anon_sym_shared] = ACTIONS(3673),
    [anon_sym_groupshared] = ACTIONS(3673),
    [anon_sym_uniform] = ACTIONS(3673),
    [anon_sym_row_major] = ACTIONS(3673),
    [anon_sym_column_major] = ACTIONS(3673),
    [anon_sym_globallycoherent] = ACTIONS(3673),
    [anon_sym_centroid] = ACTIONS(3673),
    [anon_sym_noperspective] = ACTIONS(3673),
    [anon_sym_nointerpolation] = ACTIONS(3673),
    [anon_sym_sample] = ACTIONS(3673),
    [anon_sym_linear] = ACTIONS(3673),
    [anon_sym_snorm] = ACTIONS(3673),
    [anon_sym_unorm] = ACTIONS(3673),
    [anon_sym_point] = ACTIONS(3673),
    [anon_sym_line] = ACTIONS(3673),
    [anon_sym_triangleadj] = ACTIONS(3673),
    [anon_sym_lineadj] = ACTIONS(3673),
    [anon_sym_triangle] = ACTIONS(3673),
    [anon_sym_cbuffer] = ACTIONS(3673),
    [anon_sym_interface] = ACTIONS(3673),
    [anon_sym_extension] = ACTIONS(3673),
  },
  [1052] = {
    [ts_builtin_sym_end] = ACTIONS(3757),
    [sym_identifier] = ACTIONS(3755),
    [aux_sym_preproc_include_token1] = ACTIONS(3755),
    [aux_sym_preproc_def_token1] = ACTIONS(3755),
    [aux_sym_preproc_if_token1] = ACTIONS(3755),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3755),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3755),
    [sym_preproc_directive] = ACTIONS(3755),
    [anon_sym_LPAREN2] = ACTIONS(3757),
    [anon_sym_BANG] = ACTIONS(3757),
    [anon_sym_TILDE] = ACTIONS(3757),
    [anon_sym_DASH] = ACTIONS(3755),
    [anon_sym_PLUS] = ACTIONS(3755),
    [anon_sym_STAR] = ACTIONS(3757),
    [anon_sym_AMP_AMP] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3755),
    [anon_sym_SEMI] = ACTIONS(3757),
    [anon_sym___extension__] = ACTIONS(3755),
    [anon_sym_typedef] = ACTIONS(3755),
    [anon_sym_in] = ACTIONS(3755),
    [anon_sym_out] = ACTIONS(3755),
    [anon_sym_inout] = ACTIONS(3755),
    [anon_sym_virtual] = ACTIONS(3755),
    [anon_sym_extern] = ACTIONS(3755),
    [anon_sym___attribute__] = ACTIONS(3755),
    [anon_sym___attribute] = ACTIONS(3755),
    [anon_sym_using] = ACTIONS(3755),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3757),
    [anon_sym___declspec] = ACTIONS(3755),
    [anon_sym___based] = ACTIONS(3755),
    [anon_sym___cdecl] = ACTIONS(3755),
    [anon_sym___clrcall] = ACTIONS(3755),
    [anon_sym___stdcall] = ACTIONS(3755),
    [anon_sym___fastcall] = ACTIONS(3755),
    [anon_sym___thiscall] = ACTIONS(3755),
    [anon_sym___vectorcall] = ACTIONS(3755),
    [anon_sym_LBRACE] = ACTIONS(3757),
    [anon_sym_signed] = ACTIONS(3755),
    [anon_sym_unsigned] = ACTIONS(3755),
    [anon_sym_long] = ACTIONS(3755),
    [anon_sym_short] = ACTIONS(3755),
    [anon_sym_LBRACK] = ACTIONS(3755),
    [anon_sym_static] = ACTIONS(3755),
    [anon_sym_register] = ACTIONS(3755),
    [anon_sym_inline] = ACTIONS(3755),
    [anon_sym___inline] = ACTIONS(3755),
    [anon_sym___inline__] = ACTIONS(3755),
    [anon_sym___forceinline] = ACTIONS(3755),
    [anon_sym_thread_local] = ACTIONS(3755),
    [anon_sym___thread] = ACTIONS(3755),
    [anon_sym_const] = ACTIONS(3755),
    [anon_sym_constexpr] = ACTIONS(3755),
    [anon_sym_volatile] = ACTIONS(3755),
    [anon_sym_restrict] = ACTIONS(3755),
    [anon_sym___restrict__] = ACTIONS(3755),
    [anon_sym__Atomic] = ACTIONS(3755),
    [anon_sym__Noreturn] = ACTIONS(3755),
    [anon_sym_noreturn] = ACTIONS(3755),
    [anon_sym__Nonnull] = ACTIONS(3755),
    [anon_sym_mutable] = ACTIONS(3755),
    [anon_sym_constinit] = ACTIONS(3755),
    [anon_sym_consteval] = ACTIONS(3755),
    [anon_sym_alignas] = ACTIONS(3755),
    [anon_sym__Alignas] = ACTIONS(3755),
    [sym_primitive_type] = ACTIONS(3755),
    [anon_sym_enum] = ACTIONS(3755),
    [anon_sym_class] = ACTIONS(3755),
    [anon_sym_struct] = ACTIONS(3755),
    [anon_sym_union] = ACTIONS(3755),
    [anon_sym_if] = ACTIONS(3755),
    [anon_sym_switch] = ACTIONS(3755),
    [anon_sym_case] = ACTIONS(3755),
    [anon_sym_default] = ACTIONS(3755),
    [anon_sym_while] = ACTIONS(3755),
    [anon_sym_do] = ACTIONS(3755),
    [anon_sym_for] = ACTIONS(3755),
    [anon_sym_return] = ACTIONS(3755),
    [anon_sym_break] = ACTIONS(3755),
    [anon_sym_continue] = ACTIONS(3755),
    [anon_sym_goto] = ACTIONS(3755),
    [anon_sym_not] = ACTIONS(3755),
    [anon_sym_compl] = ACTIONS(3755),
    [anon_sym_DASH_DASH] = ACTIONS(3757),
    [anon_sym_PLUS_PLUS] = ACTIONS(3757),
    [anon_sym_sizeof] = ACTIONS(3755),
    [anon_sym___alignof__] = ACTIONS(3755),
    [anon_sym___alignof] = ACTIONS(3755),
    [anon_sym__alignof] = ACTIONS(3755),
    [anon_sym_alignof] = ACTIONS(3755),
    [anon_sym__Alignof] = ACTIONS(3755),
    [anon_sym_offsetof] = ACTIONS(3755),
    [anon_sym__Generic] = ACTIONS(3755),
    [anon_sym_asm] = ACTIONS(3755),
    [anon_sym___asm__] = ACTIONS(3755),
    [anon_sym___asm] = ACTIONS(3755),
    [sym_number_literal] = ACTIONS(3757),
    [anon_sym_L_SQUOTE] = ACTIONS(3757),
    [anon_sym_u_SQUOTE] = ACTIONS(3757),
    [anon_sym_U_SQUOTE] = ACTIONS(3757),
    [anon_sym_u8_SQUOTE] = ACTIONS(3757),
    [anon_sym_SQUOTE] = ACTIONS(3757),
    [anon_sym_L_DQUOTE] = ACTIONS(3757),
    [anon_sym_u_DQUOTE] = ACTIONS(3757),
    [anon_sym_U_DQUOTE] = ACTIONS(3757),
    [anon_sym_u8_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE] = ACTIONS(3757),
    [sym_true] = ACTIONS(3755),
    [sym_false] = ACTIONS(3755),
    [anon_sym_NULL] = ACTIONS(3755),
    [anon_sym_nullptr] = ACTIONS(3755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3755),
    [anon_sym_let] = ACTIONS(3755),
    [anon_sym_This] = ACTIONS(3755),
    [anon_sym_decltype] = ACTIONS(3755),
    [anon_sym_explicit] = ACTIONS(3755),
    [anon_sym_typename] = ACTIONS(3755),
    [anon_sym_export] = ACTIONS(3755),
    [anon_sym_module] = ACTIONS(3755),
    [anon_sym_import] = ACTIONS(3755),
    [anon_sym_template] = ACTIONS(3755),
    [anon_sym_operator] = ACTIONS(3755),
    [anon_sym_try] = ACTIONS(3755),
    [anon_sym_delete] = ACTIONS(3755),
    [anon_sym_throw] = ACTIONS(3755),
    [anon_sym_namespace] = ACTIONS(3755),
    [anon_sym_static_assert] = ACTIONS(3755),
    [anon_sym_concept] = ACTIONS(3755),
    [anon_sym_co_return] = ACTIONS(3755),
    [anon_sym_co_yield] = ACTIONS(3755),
    [anon_sym_R_DQUOTE] = ACTIONS(3757),
    [anon_sym_LR_DQUOTE] = ACTIONS(3757),
    [anon_sym_uR_DQUOTE] = ACTIONS(3757),
    [anon_sym_UR_DQUOTE] = ACTIONS(3757),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3757),
    [anon_sym_co_await] = ACTIONS(3755),
    [anon_sym_new] = ACTIONS(3755),
    [anon_sym_requires] = ACTIONS(3755),
    [sym_this] = ACTIONS(3755),
    [anon_sym_precise] = ACTIONS(3755),
    [anon_sym_shared] = ACTIONS(3755),
    [anon_sym_groupshared] = ACTIONS(3755),
    [anon_sym_uniform] = ACTIONS(3755),
    [anon_sym_row_major] = ACTIONS(3755),
    [anon_sym_column_major] = ACTIONS(3755),
    [anon_sym_globallycoherent] = ACTIONS(3755),
    [anon_sym_centroid] = ACTIONS(3755),
    [anon_sym_noperspective] = ACTIONS(3755),
    [anon_sym_nointerpolation] = ACTIONS(3755),
    [anon_sym_sample] = ACTIONS(3755),
    [anon_sym_linear] = ACTIONS(3755),
    [anon_sym_snorm] = ACTIONS(3755),
    [anon_sym_unorm] = ACTIONS(3755),
    [anon_sym_point] = ACTIONS(3755),
    [anon_sym_line] = ACTIONS(3755),
    [anon_sym_triangleadj] = ACTIONS(3755),
    [anon_sym_lineadj] = ACTIONS(3755),
    [anon_sym_triangle] = ACTIONS(3755),
    [anon_sym_interface] = ACTIONS(3755),
    [anon_sym_extension] = ACTIONS(3755),
    [anon_sym___exported] = ACTIONS(3755),
  },
  [1053] = {
    [ts_builtin_sym_end] = ACTIONS(3765),
    [sym_identifier] = ACTIONS(3763),
    [aux_sym_preproc_include_token1] = ACTIONS(3763),
    [aux_sym_preproc_def_token1] = ACTIONS(3763),
    [aux_sym_preproc_if_token1] = ACTIONS(3763),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3763),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3763),
    [sym_preproc_directive] = ACTIONS(3763),
    [anon_sym_LPAREN2] = ACTIONS(3765),
    [anon_sym_BANG] = ACTIONS(3765),
    [anon_sym_TILDE] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3763),
    [anon_sym_STAR] = ACTIONS(3765),
    [anon_sym_AMP_AMP] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3763),
    [anon_sym_SEMI] = ACTIONS(3765),
    [anon_sym___extension__] = ACTIONS(3763),
    [anon_sym_typedef] = ACTIONS(3763),
    [anon_sym_in] = ACTIONS(3763),
    [anon_sym_out] = ACTIONS(3763),
    [anon_sym_inout] = ACTIONS(3763),
    [anon_sym_virtual] = ACTIONS(3763),
    [anon_sym_extern] = ACTIONS(3763),
    [anon_sym___attribute__] = ACTIONS(3763),
    [anon_sym___attribute] = ACTIONS(3763),
    [anon_sym_using] = ACTIONS(3763),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3765),
    [anon_sym___declspec] = ACTIONS(3763),
    [anon_sym___based] = ACTIONS(3763),
    [anon_sym___cdecl] = ACTIONS(3763),
    [anon_sym___clrcall] = ACTIONS(3763),
    [anon_sym___stdcall] = ACTIONS(3763),
    [anon_sym___fastcall] = ACTIONS(3763),
    [anon_sym___thiscall] = ACTIONS(3763),
    [anon_sym___vectorcall] = ACTIONS(3763),
    [anon_sym_LBRACE] = ACTIONS(3765),
    [anon_sym_signed] = ACTIONS(3763),
    [anon_sym_unsigned] = ACTIONS(3763),
    [anon_sym_long] = ACTIONS(3763),
    [anon_sym_short] = ACTIONS(3763),
    [anon_sym_LBRACK] = ACTIONS(3763),
    [anon_sym_static] = ACTIONS(3763),
    [anon_sym_register] = ACTIONS(3763),
    [anon_sym_inline] = ACTIONS(3763),
    [anon_sym___inline] = ACTIONS(3763),
    [anon_sym___inline__] = ACTIONS(3763),
    [anon_sym___forceinline] = ACTIONS(3763),
    [anon_sym_thread_local] = ACTIONS(3763),
    [anon_sym___thread] = ACTIONS(3763),
    [anon_sym_const] = ACTIONS(3763),
    [anon_sym_constexpr] = ACTIONS(3763),
    [anon_sym_volatile] = ACTIONS(3763),
    [anon_sym_restrict] = ACTIONS(3763),
    [anon_sym___restrict__] = ACTIONS(3763),
    [anon_sym__Atomic] = ACTIONS(3763),
    [anon_sym__Noreturn] = ACTIONS(3763),
    [anon_sym_noreturn] = ACTIONS(3763),
    [anon_sym__Nonnull] = ACTIONS(3763),
    [anon_sym_mutable] = ACTIONS(3763),
    [anon_sym_constinit] = ACTIONS(3763),
    [anon_sym_consteval] = ACTIONS(3763),
    [anon_sym_alignas] = ACTIONS(3763),
    [anon_sym__Alignas] = ACTIONS(3763),
    [sym_primitive_type] = ACTIONS(3763),
    [anon_sym_enum] = ACTIONS(3763),
    [anon_sym_class] = ACTIONS(3763),
    [anon_sym_struct] = ACTIONS(3763),
    [anon_sym_union] = ACTIONS(3763),
    [anon_sym_if] = ACTIONS(3763),
    [anon_sym_switch] = ACTIONS(3763),
    [anon_sym_case] = ACTIONS(3763),
    [anon_sym_default] = ACTIONS(3763),
    [anon_sym_while] = ACTIONS(3763),
    [anon_sym_do] = ACTIONS(3763),
    [anon_sym_for] = ACTIONS(3763),
    [anon_sym_return] = ACTIONS(3763),
    [anon_sym_break] = ACTIONS(3763),
    [anon_sym_continue] = ACTIONS(3763),
    [anon_sym_goto] = ACTIONS(3763),
    [anon_sym_not] = ACTIONS(3763),
    [anon_sym_compl] = ACTIONS(3763),
    [anon_sym_DASH_DASH] = ACTIONS(3765),
    [anon_sym_PLUS_PLUS] = ACTIONS(3765),
    [anon_sym_sizeof] = ACTIONS(3763),
    [anon_sym___alignof__] = ACTIONS(3763),
    [anon_sym___alignof] = ACTIONS(3763),
    [anon_sym__alignof] = ACTIONS(3763),
    [anon_sym_alignof] = ACTIONS(3763),
    [anon_sym__Alignof] = ACTIONS(3763),
    [anon_sym_offsetof] = ACTIONS(3763),
    [anon_sym__Generic] = ACTIONS(3763),
    [anon_sym_asm] = ACTIONS(3763),
    [anon_sym___asm__] = ACTIONS(3763),
    [anon_sym___asm] = ACTIONS(3763),
    [sym_number_literal] = ACTIONS(3765),
    [anon_sym_L_SQUOTE] = ACTIONS(3765),
    [anon_sym_u_SQUOTE] = ACTIONS(3765),
    [anon_sym_U_SQUOTE] = ACTIONS(3765),
    [anon_sym_u8_SQUOTE] = ACTIONS(3765),
    [anon_sym_SQUOTE] = ACTIONS(3765),
    [anon_sym_L_DQUOTE] = ACTIONS(3765),
    [anon_sym_u_DQUOTE] = ACTIONS(3765),
    [anon_sym_U_DQUOTE] = ACTIONS(3765),
    [anon_sym_u8_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE] = ACTIONS(3765),
    [sym_true] = ACTIONS(3763),
    [sym_false] = ACTIONS(3763),
    [anon_sym_NULL] = ACTIONS(3763),
    [anon_sym_nullptr] = ACTIONS(3763),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3763),
    [anon_sym_let] = ACTIONS(3763),
    [anon_sym_This] = ACTIONS(3763),
    [anon_sym_decltype] = ACTIONS(3763),
    [anon_sym_explicit] = ACTIONS(3763),
    [anon_sym_typename] = ACTIONS(3763),
    [anon_sym_export] = ACTIONS(3763),
    [anon_sym_module] = ACTIONS(3763),
    [anon_sym_import] = ACTIONS(3763),
    [anon_sym_template] = ACTIONS(3763),
    [anon_sym_operator] = ACTIONS(3763),
    [anon_sym_try] = ACTIONS(3763),
    [anon_sym_delete] = ACTIONS(3763),
    [anon_sym_throw] = ACTIONS(3763),
    [anon_sym_namespace] = ACTIONS(3763),
    [anon_sym_static_assert] = ACTIONS(3763),
    [anon_sym_concept] = ACTIONS(3763),
    [anon_sym_co_return] = ACTIONS(3763),
    [anon_sym_co_yield] = ACTIONS(3763),
    [anon_sym_R_DQUOTE] = ACTIONS(3765),
    [anon_sym_LR_DQUOTE] = ACTIONS(3765),
    [anon_sym_uR_DQUOTE] = ACTIONS(3765),
    [anon_sym_UR_DQUOTE] = ACTIONS(3765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3765),
    [anon_sym_co_await] = ACTIONS(3763),
    [anon_sym_new] = ACTIONS(3763),
    [anon_sym_requires] = ACTIONS(3763),
    [sym_this] = ACTIONS(3763),
    [anon_sym_precise] = ACTIONS(3763),
    [anon_sym_shared] = ACTIONS(3763),
    [anon_sym_groupshared] = ACTIONS(3763),
    [anon_sym_uniform] = ACTIONS(3763),
    [anon_sym_row_major] = ACTIONS(3763),
    [anon_sym_column_major] = ACTIONS(3763),
    [anon_sym_globallycoherent] = ACTIONS(3763),
    [anon_sym_centroid] = ACTIONS(3763),
    [anon_sym_noperspective] = ACTIONS(3763),
    [anon_sym_nointerpolation] = ACTIONS(3763),
    [anon_sym_sample] = ACTIONS(3763),
    [anon_sym_linear] = ACTIONS(3763),
    [anon_sym_snorm] = ACTIONS(3763),
    [anon_sym_unorm] = ACTIONS(3763),
    [anon_sym_point] = ACTIONS(3763),
    [anon_sym_line] = ACTIONS(3763),
    [anon_sym_triangleadj] = ACTIONS(3763),
    [anon_sym_lineadj] = ACTIONS(3763),
    [anon_sym_triangle] = ACTIONS(3763),
    [anon_sym_interface] = ACTIONS(3763),
    [anon_sym_extension] = ACTIONS(3763),
    [anon_sym___exported] = ACTIONS(3763),
  },
  [1054] = {
    [ts_builtin_sym_end] = ACTIONS(4309),
    [sym_identifier] = ACTIONS(4311),
    [aux_sym_preproc_include_token1] = ACTIONS(4311),
    [aux_sym_preproc_def_token1] = ACTIONS(4311),
    [aux_sym_preproc_if_token1] = ACTIONS(4311),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4311),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4311),
    [sym_preproc_directive] = ACTIONS(4311),
    [anon_sym_LPAREN2] = ACTIONS(4309),
    [anon_sym_BANG] = ACTIONS(4309),
    [anon_sym_TILDE] = ACTIONS(4309),
    [anon_sym_DASH] = ACTIONS(4311),
    [anon_sym_PLUS] = ACTIONS(4311),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP_AMP] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4311),
    [anon_sym_SEMI] = ACTIONS(4309),
    [anon_sym___extension__] = ACTIONS(4311),
    [anon_sym_typedef] = ACTIONS(4311),
    [anon_sym_in] = ACTIONS(4311),
    [anon_sym_out] = ACTIONS(4311),
    [anon_sym_inout] = ACTIONS(4311),
    [anon_sym_virtual] = ACTIONS(4311),
    [anon_sym_extern] = ACTIONS(4311),
    [anon_sym___attribute__] = ACTIONS(4311),
    [anon_sym___attribute] = ACTIONS(4311),
    [anon_sym_using] = ACTIONS(4311),
    [anon_sym_COLON_COLON] = ACTIONS(4309),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4309),
    [anon_sym___declspec] = ACTIONS(4311),
    [anon_sym___based] = ACTIONS(4311),
    [anon_sym___cdecl] = ACTIONS(4311),
    [anon_sym___clrcall] = ACTIONS(4311),
    [anon_sym___stdcall] = ACTIONS(4311),
    [anon_sym___fastcall] = ACTIONS(4311),
    [anon_sym___thiscall] = ACTIONS(4311),
    [anon_sym___vectorcall] = ACTIONS(4311),
    [anon_sym_LBRACE] = ACTIONS(4309),
    [anon_sym_signed] = ACTIONS(4311),
    [anon_sym_unsigned] = ACTIONS(4311),
    [anon_sym_long] = ACTIONS(4311),
    [anon_sym_short] = ACTIONS(4311),
    [anon_sym_LBRACK] = ACTIONS(4311),
    [anon_sym_static] = ACTIONS(4311),
    [anon_sym_register] = ACTIONS(4311),
    [anon_sym_inline] = ACTIONS(4311),
    [anon_sym___inline] = ACTIONS(4311),
    [anon_sym___inline__] = ACTIONS(4311),
    [anon_sym___forceinline] = ACTIONS(4311),
    [anon_sym_thread_local] = ACTIONS(4311),
    [anon_sym___thread] = ACTIONS(4311),
    [anon_sym_const] = ACTIONS(4311),
    [anon_sym_constexpr] = ACTIONS(4311),
    [anon_sym_volatile] = ACTIONS(4311),
    [anon_sym_restrict] = ACTIONS(4311),
    [anon_sym___restrict__] = ACTIONS(4311),
    [anon_sym__Atomic] = ACTIONS(4311),
    [anon_sym__Noreturn] = ACTIONS(4311),
    [anon_sym_noreturn] = ACTIONS(4311),
    [anon_sym__Nonnull] = ACTIONS(4311),
    [anon_sym_mutable] = ACTIONS(4311),
    [anon_sym_constinit] = ACTIONS(4311),
    [anon_sym_consteval] = ACTIONS(4311),
    [anon_sym_alignas] = ACTIONS(4311),
    [anon_sym__Alignas] = ACTIONS(4311),
    [sym_primitive_type] = ACTIONS(4311),
    [anon_sym_enum] = ACTIONS(4311),
    [anon_sym_class] = ACTIONS(4311),
    [anon_sym_struct] = ACTIONS(4311),
    [anon_sym_union] = ACTIONS(4311),
    [anon_sym_if] = ACTIONS(4311),
    [anon_sym_switch] = ACTIONS(4311),
    [anon_sym_case] = ACTIONS(4311),
    [anon_sym_default] = ACTIONS(4311),
    [anon_sym_while] = ACTIONS(4311),
    [anon_sym_do] = ACTIONS(4311),
    [anon_sym_for] = ACTIONS(4311),
    [anon_sym_return] = ACTIONS(4311),
    [anon_sym_break] = ACTIONS(4311),
    [anon_sym_continue] = ACTIONS(4311),
    [anon_sym_goto] = ACTIONS(4311),
    [anon_sym_not] = ACTIONS(4311),
    [anon_sym_compl] = ACTIONS(4311),
    [anon_sym_DASH_DASH] = ACTIONS(4309),
    [anon_sym_PLUS_PLUS] = ACTIONS(4309),
    [anon_sym_sizeof] = ACTIONS(4311),
    [anon_sym___alignof__] = ACTIONS(4311),
    [anon_sym___alignof] = ACTIONS(4311),
    [anon_sym__alignof] = ACTIONS(4311),
    [anon_sym_alignof] = ACTIONS(4311),
    [anon_sym__Alignof] = ACTIONS(4311),
    [anon_sym_offsetof] = ACTIONS(4311),
    [anon_sym__Generic] = ACTIONS(4311),
    [anon_sym_asm] = ACTIONS(4311),
    [anon_sym___asm__] = ACTIONS(4311),
    [anon_sym___asm] = ACTIONS(4311),
    [sym_number_literal] = ACTIONS(4309),
    [anon_sym_L_SQUOTE] = ACTIONS(4309),
    [anon_sym_u_SQUOTE] = ACTIONS(4309),
    [anon_sym_U_SQUOTE] = ACTIONS(4309),
    [anon_sym_u8_SQUOTE] = ACTIONS(4309),
    [anon_sym_SQUOTE] = ACTIONS(4309),
    [anon_sym_L_DQUOTE] = ACTIONS(4309),
    [anon_sym_u_DQUOTE] = ACTIONS(4309),
    [anon_sym_U_DQUOTE] = ACTIONS(4309),
    [anon_sym_u8_DQUOTE] = ACTIONS(4309),
    [anon_sym_DQUOTE] = ACTIONS(4309),
    [sym_true] = ACTIONS(4311),
    [sym_false] = ACTIONS(4311),
    [anon_sym_NULL] = ACTIONS(4311),
    [anon_sym_nullptr] = ACTIONS(4311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4311),
    [anon_sym_let] = ACTIONS(4311),
    [anon_sym_This] = ACTIONS(4311),
    [anon_sym_decltype] = ACTIONS(4311),
    [anon_sym_explicit] = ACTIONS(4311),
    [anon_sym_typename] = ACTIONS(4311),
    [anon_sym_export] = ACTIONS(4311),
    [anon_sym_module] = ACTIONS(4311),
    [anon_sym_import] = ACTIONS(4311),
    [anon_sym_template] = ACTIONS(4311),
    [anon_sym_operator] = ACTIONS(4311),
    [anon_sym_try] = ACTIONS(4311),
    [anon_sym_delete] = ACTIONS(4311),
    [anon_sym_throw] = ACTIONS(4311),
    [anon_sym_namespace] = ACTIONS(4311),
    [anon_sym_static_assert] = ACTIONS(4311),
    [anon_sym_concept] = ACTIONS(4311),
    [anon_sym_co_return] = ACTIONS(4311),
    [anon_sym_co_yield] = ACTIONS(4311),
    [anon_sym_R_DQUOTE] = ACTIONS(4309),
    [anon_sym_LR_DQUOTE] = ACTIONS(4309),
    [anon_sym_uR_DQUOTE] = ACTIONS(4309),
    [anon_sym_UR_DQUOTE] = ACTIONS(4309),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4309),
    [anon_sym_co_await] = ACTIONS(4311),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4311),
    [sym_this] = ACTIONS(4311),
    [anon_sym_precise] = ACTIONS(4311),
    [anon_sym_shared] = ACTIONS(4311),
    [anon_sym_groupshared] = ACTIONS(4311),
    [anon_sym_uniform] = ACTIONS(4311),
    [anon_sym_row_major] = ACTIONS(4311),
    [anon_sym_column_major] = ACTIONS(4311),
    [anon_sym_globallycoherent] = ACTIONS(4311),
    [anon_sym_centroid] = ACTIONS(4311),
    [anon_sym_noperspective] = ACTIONS(4311),
    [anon_sym_nointerpolation] = ACTIONS(4311),
    [anon_sym_sample] = ACTIONS(4311),
    [anon_sym_linear] = ACTIONS(4311),
    [anon_sym_snorm] = ACTIONS(4311),
    [anon_sym_unorm] = ACTIONS(4311),
    [anon_sym_point] = ACTIONS(4311),
    [anon_sym_line] = ACTIONS(4311),
    [anon_sym_triangleadj] = ACTIONS(4311),
    [anon_sym_lineadj] = ACTIONS(4311),
    [anon_sym_triangle] = ACTIONS(4311),
    [anon_sym_interface] = ACTIONS(4311),
    [anon_sym_extension] = ACTIONS(4311),
    [anon_sym___exported] = ACTIONS(4311),
  },
  [1055] = {
    [sym_expression] = STATE(4754),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(4313),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(4316),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(4319),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(4322),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3373),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3376),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [1056] = {
    [ts_builtin_sym_end] = ACTIONS(4325),
    [sym_identifier] = ACTIONS(4327),
    [aux_sym_preproc_include_token1] = ACTIONS(4327),
    [aux_sym_preproc_def_token1] = ACTIONS(4327),
    [aux_sym_preproc_if_token1] = ACTIONS(4327),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4327),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4327),
    [sym_preproc_directive] = ACTIONS(4327),
    [anon_sym_LPAREN2] = ACTIONS(4325),
    [anon_sym_BANG] = ACTIONS(4325),
    [anon_sym_TILDE] = ACTIONS(4325),
    [anon_sym_DASH] = ACTIONS(4327),
    [anon_sym_PLUS] = ACTIONS(4327),
    [anon_sym_STAR] = ACTIONS(4325),
    [anon_sym_AMP_AMP] = ACTIONS(4325),
    [anon_sym_AMP] = ACTIONS(4327),
    [anon_sym_SEMI] = ACTIONS(4325),
    [anon_sym___extension__] = ACTIONS(4327),
    [anon_sym_typedef] = ACTIONS(4327),
    [anon_sym_in] = ACTIONS(4327),
    [anon_sym_out] = ACTIONS(4327),
    [anon_sym_inout] = ACTIONS(4327),
    [anon_sym_virtual] = ACTIONS(4327),
    [anon_sym_extern] = ACTIONS(4327),
    [anon_sym___attribute__] = ACTIONS(4327),
    [anon_sym___attribute] = ACTIONS(4327),
    [anon_sym_using] = ACTIONS(4327),
    [anon_sym_COLON_COLON] = ACTIONS(4325),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4325),
    [anon_sym___declspec] = ACTIONS(4327),
    [anon_sym___based] = ACTIONS(4327),
    [anon_sym___cdecl] = ACTIONS(4327),
    [anon_sym___clrcall] = ACTIONS(4327),
    [anon_sym___stdcall] = ACTIONS(4327),
    [anon_sym___fastcall] = ACTIONS(4327),
    [anon_sym___thiscall] = ACTIONS(4327),
    [anon_sym___vectorcall] = ACTIONS(4327),
    [anon_sym_LBRACE] = ACTIONS(4325),
    [anon_sym_signed] = ACTIONS(4327),
    [anon_sym_unsigned] = ACTIONS(4327),
    [anon_sym_long] = ACTIONS(4327),
    [anon_sym_short] = ACTIONS(4327),
    [anon_sym_LBRACK] = ACTIONS(4327),
    [anon_sym_static] = ACTIONS(4327),
    [anon_sym_register] = ACTIONS(4327),
    [anon_sym_inline] = ACTIONS(4327),
    [anon_sym___inline] = ACTIONS(4327),
    [anon_sym___inline__] = ACTIONS(4327),
    [anon_sym___forceinline] = ACTIONS(4327),
    [anon_sym_thread_local] = ACTIONS(4327),
    [anon_sym___thread] = ACTIONS(4327),
    [anon_sym_const] = ACTIONS(4327),
    [anon_sym_constexpr] = ACTIONS(4327),
    [anon_sym_volatile] = ACTIONS(4327),
    [anon_sym_restrict] = ACTIONS(4327),
    [anon_sym___restrict__] = ACTIONS(4327),
    [anon_sym__Atomic] = ACTIONS(4327),
    [anon_sym__Noreturn] = ACTIONS(4327),
    [anon_sym_noreturn] = ACTIONS(4327),
    [anon_sym__Nonnull] = ACTIONS(4327),
    [anon_sym_mutable] = ACTIONS(4327),
    [anon_sym_constinit] = ACTIONS(4327),
    [anon_sym_consteval] = ACTIONS(4327),
    [anon_sym_alignas] = ACTIONS(4327),
    [anon_sym__Alignas] = ACTIONS(4327),
    [sym_primitive_type] = ACTIONS(4327),
    [anon_sym_enum] = ACTIONS(4327),
    [anon_sym_class] = ACTIONS(4327),
    [anon_sym_struct] = ACTIONS(4327),
    [anon_sym_union] = ACTIONS(4327),
    [anon_sym_if] = ACTIONS(4327),
    [anon_sym_switch] = ACTIONS(4327),
    [anon_sym_case] = ACTIONS(4327),
    [anon_sym_default] = ACTIONS(4327),
    [anon_sym_while] = ACTIONS(4327),
    [anon_sym_do] = ACTIONS(4327),
    [anon_sym_for] = ACTIONS(4327),
    [anon_sym_return] = ACTIONS(4327),
    [anon_sym_break] = ACTIONS(4327),
    [anon_sym_continue] = ACTIONS(4327),
    [anon_sym_goto] = ACTIONS(4327),
    [anon_sym_not] = ACTIONS(4327),
    [anon_sym_compl] = ACTIONS(4327),
    [anon_sym_DASH_DASH] = ACTIONS(4325),
    [anon_sym_PLUS_PLUS] = ACTIONS(4325),
    [anon_sym_sizeof] = ACTIONS(4327),
    [anon_sym___alignof__] = ACTIONS(4327),
    [anon_sym___alignof] = ACTIONS(4327),
    [anon_sym__alignof] = ACTIONS(4327),
    [anon_sym_alignof] = ACTIONS(4327),
    [anon_sym__Alignof] = ACTIONS(4327),
    [anon_sym_offsetof] = ACTIONS(4327),
    [anon_sym__Generic] = ACTIONS(4327),
    [anon_sym_asm] = ACTIONS(4327),
    [anon_sym___asm__] = ACTIONS(4327),
    [anon_sym___asm] = ACTIONS(4327),
    [sym_number_literal] = ACTIONS(4325),
    [anon_sym_L_SQUOTE] = ACTIONS(4325),
    [anon_sym_u_SQUOTE] = ACTIONS(4325),
    [anon_sym_U_SQUOTE] = ACTIONS(4325),
    [anon_sym_u8_SQUOTE] = ACTIONS(4325),
    [anon_sym_SQUOTE] = ACTIONS(4325),
    [anon_sym_L_DQUOTE] = ACTIONS(4325),
    [anon_sym_u_DQUOTE] = ACTIONS(4325),
    [anon_sym_U_DQUOTE] = ACTIONS(4325),
    [anon_sym_u8_DQUOTE] = ACTIONS(4325),
    [anon_sym_DQUOTE] = ACTIONS(4325),
    [sym_true] = ACTIONS(4327),
    [sym_false] = ACTIONS(4327),
    [anon_sym_NULL] = ACTIONS(4327),
    [anon_sym_nullptr] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4327),
    [anon_sym_let] = ACTIONS(4327),
    [anon_sym_This] = ACTIONS(4327),
    [anon_sym_decltype] = ACTIONS(4327),
    [anon_sym_explicit] = ACTIONS(4327),
    [anon_sym_typename] = ACTIONS(4327),
    [anon_sym_export] = ACTIONS(4327),
    [anon_sym_module] = ACTIONS(4327),
    [anon_sym_import] = ACTIONS(4327),
    [anon_sym_template] = ACTIONS(4327),
    [anon_sym_operator] = ACTIONS(4327),
    [anon_sym_try] = ACTIONS(4327),
    [anon_sym_delete] = ACTIONS(4327),
    [anon_sym_throw] = ACTIONS(4327),
    [anon_sym_namespace] = ACTIONS(4327),
    [anon_sym_static_assert] = ACTIONS(4327),
    [anon_sym_concept] = ACTIONS(4327),
    [anon_sym_co_return] = ACTIONS(4327),
    [anon_sym_co_yield] = ACTIONS(4327),
    [anon_sym_R_DQUOTE] = ACTIONS(4325),
    [anon_sym_LR_DQUOTE] = ACTIONS(4325),
    [anon_sym_uR_DQUOTE] = ACTIONS(4325),
    [anon_sym_UR_DQUOTE] = ACTIONS(4325),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4325),
    [anon_sym_co_await] = ACTIONS(4327),
    [anon_sym_new] = ACTIONS(4327),
    [anon_sym_requires] = ACTIONS(4327),
    [sym_this] = ACTIONS(4327),
    [anon_sym_precise] = ACTIONS(4327),
    [anon_sym_shared] = ACTIONS(4327),
    [anon_sym_groupshared] = ACTIONS(4327),
    [anon_sym_uniform] = ACTIONS(4327),
    [anon_sym_row_major] = ACTIONS(4327),
    [anon_sym_column_major] = ACTIONS(4327),
    [anon_sym_globallycoherent] = ACTIONS(4327),
    [anon_sym_centroid] = ACTIONS(4327),
    [anon_sym_noperspective] = ACTIONS(4327),
    [anon_sym_nointerpolation] = ACTIONS(4327),
    [anon_sym_sample] = ACTIONS(4327),
    [anon_sym_linear] = ACTIONS(4327),
    [anon_sym_snorm] = ACTIONS(4327),
    [anon_sym_unorm] = ACTIONS(4327),
    [anon_sym_point] = ACTIONS(4327),
    [anon_sym_line] = ACTIONS(4327),
    [anon_sym_triangleadj] = ACTIONS(4327),
    [anon_sym_lineadj] = ACTIONS(4327),
    [anon_sym_triangle] = ACTIONS(4327),
    [anon_sym_interface] = ACTIONS(4327),
    [anon_sym_extension] = ACTIONS(4327),
    [anon_sym___exported] = ACTIONS(4327),
  },
  [1057] = {
    [sym_identifier] = ACTIONS(3727),
    [aux_sym_preproc_include_token1] = ACTIONS(3727),
    [aux_sym_preproc_def_token1] = ACTIONS(3727),
    [aux_sym_preproc_if_token1] = ACTIONS(3727),
    [aux_sym_preproc_if_token2] = ACTIONS(3727),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3727),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3727),
    [sym_preproc_directive] = ACTIONS(3727),
    [anon_sym_LPAREN2] = ACTIONS(3729),
    [anon_sym_BANG] = ACTIONS(3729),
    [anon_sym_TILDE] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3727),
    [anon_sym_PLUS] = ACTIONS(3727),
    [anon_sym_STAR] = ACTIONS(3729),
    [anon_sym_AMP_AMP] = ACTIONS(3729),
    [anon_sym_AMP] = ACTIONS(3727),
    [anon_sym_SEMI] = ACTIONS(3729),
    [anon_sym___extension__] = ACTIONS(3727),
    [anon_sym_typedef] = ACTIONS(3727),
    [anon_sym_in] = ACTIONS(3727),
    [anon_sym_out] = ACTIONS(3727),
    [anon_sym_inout] = ACTIONS(3727),
    [anon_sym_virtual] = ACTIONS(3727),
    [anon_sym_extern] = ACTIONS(3727),
    [anon_sym___attribute__] = ACTIONS(3727),
    [anon_sym___attribute] = ACTIONS(3727),
    [anon_sym_using] = ACTIONS(3727),
    [anon_sym_COLON_COLON] = ACTIONS(3729),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3729),
    [anon_sym___declspec] = ACTIONS(3727),
    [anon_sym___based] = ACTIONS(3727),
    [anon_sym___cdecl] = ACTIONS(3727),
    [anon_sym___clrcall] = ACTIONS(3727),
    [anon_sym___stdcall] = ACTIONS(3727),
    [anon_sym___fastcall] = ACTIONS(3727),
    [anon_sym___thiscall] = ACTIONS(3727),
    [anon_sym___vectorcall] = ACTIONS(3727),
    [anon_sym_LBRACE] = ACTIONS(3729),
    [anon_sym_signed] = ACTIONS(3727),
    [anon_sym_unsigned] = ACTIONS(3727),
    [anon_sym_long] = ACTIONS(3727),
    [anon_sym_short] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(3727),
    [anon_sym_static] = ACTIONS(3727),
    [anon_sym_register] = ACTIONS(3727),
    [anon_sym_inline] = ACTIONS(3727),
    [anon_sym___inline] = ACTIONS(3727),
    [anon_sym___inline__] = ACTIONS(3727),
    [anon_sym___forceinline] = ACTIONS(3727),
    [anon_sym_thread_local] = ACTIONS(3727),
    [anon_sym___thread] = ACTIONS(3727),
    [anon_sym_const] = ACTIONS(3727),
    [anon_sym_constexpr] = ACTIONS(3727),
    [anon_sym_volatile] = ACTIONS(3727),
    [anon_sym_restrict] = ACTIONS(3727),
    [anon_sym___restrict__] = ACTIONS(3727),
    [anon_sym__Atomic] = ACTIONS(3727),
    [anon_sym__Noreturn] = ACTIONS(3727),
    [anon_sym_noreturn] = ACTIONS(3727),
    [anon_sym__Nonnull] = ACTIONS(3727),
    [anon_sym_mutable] = ACTIONS(3727),
    [anon_sym_constinit] = ACTIONS(3727),
    [anon_sym_consteval] = ACTIONS(3727),
    [anon_sym_alignas] = ACTIONS(3727),
    [anon_sym__Alignas] = ACTIONS(3727),
    [sym_primitive_type] = ACTIONS(3727),
    [anon_sym_enum] = ACTIONS(3727),
    [anon_sym_class] = ACTIONS(3727),
    [anon_sym_struct] = ACTIONS(3727),
    [anon_sym_union] = ACTIONS(3727),
    [anon_sym_if] = ACTIONS(3727),
    [anon_sym_switch] = ACTIONS(3727),
    [anon_sym_case] = ACTIONS(3727),
    [anon_sym_default] = ACTIONS(3727),
    [anon_sym_while] = ACTIONS(3727),
    [anon_sym_do] = ACTIONS(3727),
    [anon_sym_for] = ACTIONS(3727),
    [anon_sym_return] = ACTIONS(3727),
    [anon_sym_break] = ACTIONS(3727),
    [anon_sym_continue] = ACTIONS(3727),
    [anon_sym_goto] = ACTIONS(3727),
    [anon_sym___try] = ACTIONS(3727),
    [anon_sym___leave] = ACTIONS(3727),
    [anon_sym_not] = ACTIONS(3727),
    [anon_sym_compl] = ACTIONS(3727),
    [anon_sym_DASH_DASH] = ACTIONS(3729),
    [anon_sym_PLUS_PLUS] = ACTIONS(3729),
    [anon_sym_sizeof] = ACTIONS(3727),
    [anon_sym___alignof__] = ACTIONS(3727),
    [anon_sym___alignof] = ACTIONS(3727),
    [anon_sym__alignof] = ACTIONS(3727),
    [anon_sym_alignof] = ACTIONS(3727),
    [anon_sym__Alignof] = ACTIONS(3727),
    [anon_sym_offsetof] = ACTIONS(3727),
    [anon_sym__Generic] = ACTIONS(3727),
    [anon_sym_asm] = ACTIONS(3727),
    [anon_sym___asm__] = ACTIONS(3727),
    [anon_sym___asm] = ACTIONS(3727),
    [sym_number_literal] = ACTIONS(3729),
    [anon_sym_L_SQUOTE] = ACTIONS(3729),
    [anon_sym_u_SQUOTE] = ACTIONS(3729),
    [anon_sym_U_SQUOTE] = ACTIONS(3729),
    [anon_sym_u8_SQUOTE] = ACTIONS(3729),
    [anon_sym_SQUOTE] = ACTIONS(3729),
    [anon_sym_L_DQUOTE] = ACTIONS(3729),
    [anon_sym_u_DQUOTE] = ACTIONS(3729),
    [anon_sym_U_DQUOTE] = ACTIONS(3729),
    [anon_sym_u8_DQUOTE] = ACTIONS(3729),
    [anon_sym_DQUOTE] = ACTIONS(3729),
    [sym_true] = ACTIONS(3727),
    [sym_false] = ACTIONS(3727),
    [anon_sym_NULL] = ACTIONS(3727),
    [anon_sym_nullptr] = ACTIONS(3727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3727),
    [anon_sym_let] = ACTIONS(3727),
    [anon_sym_This] = ACTIONS(3727),
    [anon_sym_decltype] = ACTIONS(3727),
    [anon_sym_explicit] = ACTIONS(3727),
    [anon_sym_typename] = ACTIONS(3727),
    [anon_sym_template] = ACTIONS(3727),
    [anon_sym_operator] = ACTIONS(3727),
    [anon_sym_try] = ACTIONS(3727),
    [anon_sym_delete] = ACTIONS(3727),
    [anon_sym_throw] = ACTIONS(3727),
    [anon_sym_namespace] = ACTIONS(3727),
    [anon_sym_static_assert] = ACTIONS(3727),
    [anon_sym_concept] = ACTIONS(3727),
    [anon_sym_co_return] = ACTIONS(3727),
    [anon_sym_co_yield] = ACTIONS(3727),
    [anon_sym_R_DQUOTE] = ACTIONS(3729),
    [anon_sym_LR_DQUOTE] = ACTIONS(3729),
    [anon_sym_uR_DQUOTE] = ACTIONS(3729),
    [anon_sym_UR_DQUOTE] = ACTIONS(3729),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3729),
    [anon_sym_co_await] = ACTIONS(3727),
    [anon_sym_new] = ACTIONS(3727),
    [anon_sym_requires] = ACTIONS(3727),
    [sym_this] = ACTIONS(3727),
    [anon_sym_discard] = ACTIONS(3727),
    [anon_sym_precise] = ACTIONS(3727),
    [anon_sym_shared] = ACTIONS(3727),
    [anon_sym_groupshared] = ACTIONS(3727),
    [anon_sym_uniform] = ACTIONS(3727),
    [anon_sym_row_major] = ACTIONS(3727),
    [anon_sym_column_major] = ACTIONS(3727),
    [anon_sym_globallycoherent] = ACTIONS(3727),
    [anon_sym_centroid] = ACTIONS(3727),
    [anon_sym_noperspective] = ACTIONS(3727),
    [anon_sym_nointerpolation] = ACTIONS(3727),
    [anon_sym_sample] = ACTIONS(3727),
    [anon_sym_linear] = ACTIONS(3727),
    [anon_sym_snorm] = ACTIONS(3727),
    [anon_sym_unorm] = ACTIONS(3727),
    [anon_sym_point] = ACTIONS(3727),
    [anon_sym_line] = ACTIONS(3727),
    [anon_sym_triangleadj] = ACTIONS(3727),
    [anon_sym_lineadj] = ACTIONS(3727),
    [anon_sym_triangle] = ACTIONS(3727),
    [anon_sym_cbuffer] = ACTIONS(3727),
    [anon_sym_interface] = ACTIONS(3727),
    [anon_sym_extension] = ACTIONS(3727),
  },
  [1058] = {
    [ts_builtin_sym_end] = ACTIONS(4329),
    [sym_identifier] = ACTIONS(4331),
    [aux_sym_preproc_include_token1] = ACTIONS(4331),
    [aux_sym_preproc_def_token1] = ACTIONS(4331),
    [aux_sym_preproc_if_token1] = ACTIONS(4331),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4331),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4331),
    [sym_preproc_directive] = ACTIONS(4331),
    [anon_sym_LPAREN2] = ACTIONS(4329),
    [anon_sym_BANG] = ACTIONS(4329),
    [anon_sym_TILDE] = ACTIONS(4329),
    [anon_sym_DASH] = ACTIONS(4331),
    [anon_sym_PLUS] = ACTIONS(4331),
    [anon_sym_STAR] = ACTIONS(4329),
    [anon_sym_AMP_AMP] = ACTIONS(4329),
    [anon_sym_AMP] = ACTIONS(4331),
    [anon_sym_SEMI] = ACTIONS(4329),
    [anon_sym___extension__] = ACTIONS(4331),
    [anon_sym_typedef] = ACTIONS(4331),
    [anon_sym_in] = ACTIONS(4331),
    [anon_sym_out] = ACTIONS(4331),
    [anon_sym_inout] = ACTIONS(4331),
    [anon_sym_virtual] = ACTIONS(4331),
    [anon_sym_extern] = ACTIONS(4331),
    [anon_sym___attribute__] = ACTIONS(4331),
    [anon_sym___attribute] = ACTIONS(4331),
    [anon_sym_using] = ACTIONS(4331),
    [anon_sym_COLON_COLON] = ACTIONS(4329),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4329),
    [anon_sym___declspec] = ACTIONS(4331),
    [anon_sym___based] = ACTIONS(4331),
    [anon_sym___cdecl] = ACTIONS(4331),
    [anon_sym___clrcall] = ACTIONS(4331),
    [anon_sym___stdcall] = ACTIONS(4331),
    [anon_sym___fastcall] = ACTIONS(4331),
    [anon_sym___thiscall] = ACTIONS(4331),
    [anon_sym___vectorcall] = ACTIONS(4331),
    [anon_sym_LBRACE] = ACTIONS(4329),
    [anon_sym_signed] = ACTIONS(4331),
    [anon_sym_unsigned] = ACTIONS(4331),
    [anon_sym_long] = ACTIONS(4331),
    [anon_sym_short] = ACTIONS(4331),
    [anon_sym_LBRACK] = ACTIONS(4331),
    [anon_sym_static] = ACTIONS(4331),
    [anon_sym_register] = ACTIONS(4331),
    [anon_sym_inline] = ACTIONS(4331),
    [anon_sym___inline] = ACTIONS(4331),
    [anon_sym___inline__] = ACTIONS(4331),
    [anon_sym___forceinline] = ACTIONS(4331),
    [anon_sym_thread_local] = ACTIONS(4331),
    [anon_sym___thread] = ACTIONS(4331),
    [anon_sym_const] = ACTIONS(4331),
    [anon_sym_constexpr] = ACTIONS(4331),
    [anon_sym_volatile] = ACTIONS(4331),
    [anon_sym_restrict] = ACTIONS(4331),
    [anon_sym___restrict__] = ACTIONS(4331),
    [anon_sym__Atomic] = ACTIONS(4331),
    [anon_sym__Noreturn] = ACTIONS(4331),
    [anon_sym_noreturn] = ACTIONS(4331),
    [anon_sym__Nonnull] = ACTIONS(4331),
    [anon_sym_mutable] = ACTIONS(4331),
    [anon_sym_constinit] = ACTIONS(4331),
    [anon_sym_consteval] = ACTIONS(4331),
    [anon_sym_alignas] = ACTIONS(4331),
    [anon_sym__Alignas] = ACTIONS(4331),
    [sym_primitive_type] = ACTIONS(4331),
    [anon_sym_enum] = ACTIONS(4331),
    [anon_sym_class] = ACTIONS(4331),
    [anon_sym_struct] = ACTIONS(4331),
    [anon_sym_union] = ACTIONS(4331),
    [anon_sym_if] = ACTIONS(4331),
    [anon_sym_switch] = ACTIONS(4331),
    [anon_sym_case] = ACTIONS(4331),
    [anon_sym_default] = ACTIONS(4331),
    [anon_sym_while] = ACTIONS(4331),
    [anon_sym_do] = ACTIONS(4331),
    [anon_sym_for] = ACTIONS(4331),
    [anon_sym_return] = ACTIONS(4331),
    [anon_sym_break] = ACTIONS(4331),
    [anon_sym_continue] = ACTIONS(4331),
    [anon_sym_goto] = ACTIONS(4331),
    [anon_sym_not] = ACTIONS(4331),
    [anon_sym_compl] = ACTIONS(4331),
    [anon_sym_DASH_DASH] = ACTIONS(4329),
    [anon_sym_PLUS_PLUS] = ACTIONS(4329),
    [anon_sym_sizeof] = ACTIONS(4331),
    [anon_sym___alignof__] = ACTIONS(4331),
    [anon_sym___alignof] = ACTIONS(4331),
    [anon_sym__alignof] = ACTIONS(4331),
    [anon_sym_alignof] = ACTIONS(4331),
    [anon_sym__Alignof] = ACTIONS(4331),
    [anon_sym_offsetof] = ACTIONS(4331),
    [anon_sym__Generic] = ACTIONS(4331),
    [anon_sym_asm] = ACTIONS(4331),
    [anon_sym___asm__] = ACTIONS(4331),
    [anon_sym___asm] = ACTIONS(4331),
    [sym_number_literal] = ACTIONS(4329),
    [anon_sym_L_SQUOTE] = ACTIONS(4329),
    [anon_sym_u_SQUOTE] = ACTIONS(4329),
    [anon_sym_U_SQUOTE] = ACTIONS(4329),
    [anon_sym_u8_SQUOTE] = ACTIONS(4329),
    [anon_sym_SQUOTE] = ACTIONS(4329),
    [anon_sym_L_DQUOTE] = ACTIONS(4329),
    [anon_sym_u_DQUOTE] = ACTIONS(4329),
    [anon_sym_U_DQUOTE] = ACTIONS(4329),
    [anon_sym_u8_DQUOTE] = ACTIONS(4329),
    [anon_sym_DQUOTE] = ACTIONS(4329),
    [sym_true] = ACTIONS(4331),
    [sym_false] = ACTIONS(4331),
    [anon_sym_NULL] = ACTIONS(4331),
    [anon_sym_nullptr] = ACTIONS(4331),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4331),
    [anon_sym_let] = ACTIONS(4331),
    [anon_sym_This] = ACTIONS(4331),
    [anon_sym_decltype] = ACTIONS(4331),
    [anon_sym_explicit] = ACTIONS(4331),
    [anon_sym_typename] = ACTIONS(4331),
    [anon_sym_export] = ACTIONS(4331),
    [anon_sym_module] = ACTIONS(4331),
    [anon_sym_import] = ACTIONS(4331),
    [anon_sym_template] = ACTIONS(4331),
    [anon_sym_operator] = ACTIONS(4331),
    [anon_sym_try] = ACTIONS(4331),
    [anon_sym_delete] = ACTIONS(4331),
    [anon_sym_throw] = ACTIONS(4331),
    [anon_sym_namespace] = ACTIONS(4331),
    [anon_sym_static_assert] = ACTIONS(4331),
    [anon_sym_concept] = ACTIONS(4331),
    [anon_sym_co_return] = ACTIONS(4331),
    [anon_sym_co_yield] = ACTIONS(4331),
    [anon_sym_R_DQUOTE] = ACTIONS(4329),
    [anon_sym_LR_DQUOTE] = ACTIONS(4329),
    [anon_sym_uR_DQUOTE] = ACTIONS(4329),
    [anon_sym_UR_DQUOTE] = ACTIONS(4329),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4329),
    [anon_sym_co_await] = ACTIONS(4331),
    [anon_sym_new] = ACTIONS(4331),
    [anon_sym_requires] = ACTIONS(4331),
    [sym_this] = ACTIONS(4331),
    [anon_sym_precise] = ACTIONS(4331),
    [anon_sym_shared] = ACTIONS(4331),
    [anon_sym_groupshared] = ACTIONS(4331),
    [anon_sym_uniform] = ACTIONS(4331),
    [anon_sym_row_major] = ACTIONS(4331),
    [anon_sym_column_major] = ACTIONS(4331),
    [anon_sym_globallycoherent] = ACTIONS(4331),
    [anon_sym_centroid] = ACTIONS(4331),
    [anon_sym_noperspective] = ACTIONS(4331),
    [anon_sym_nointerpolation] = ACTIONS(4331),
    [anon_sym_sample] = ACTIONS(4331),
    [anon_sym_linear] = ACTIONS(4331),
    [anon_sym_snorm] = ACTIONS(4331),
    [anon_sym_unorm] = ACTIONS(4331),
    [anon_sym_point] = ACTIONS(4331),
    [anon_sym_line] = ACTIONS(4331),
    [anon_sym_triangleadj] = ACTIONS(4331),
    [anon_sym_lineadj] = ACTIONS(4331),
    [anon_sym_triangle] = ACTIONS(4331),
    [anon_sym_interface] = ACTIONS(4331),
    [anon_sym_extension] = ACTIONS(4331),
    [anon_sym___exported] = ACTIONS(4331),
  },
  [1059] = {
    [sym_identifier] = ACTIONS(3747),
    [aux_sym_preproc_include_token1] = ACTIONS(3747),
    [aux_sym_preproc_def_token1] = ACTIONS(3747),
    [aux_sym_preproc_if_token1] = ACTIONS(3747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3747),
    [sym_preproc_directive] = ACTIONS(3747),
    [anon_sym_LPAREN2] = ACTIONS(3749),
    [anon_sym_BANG] = ACTIONS(3749),
    [anon_sym_TILDE] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_STAR] = ACTIONS(3749),
    [anon_sym_AMP_AMP] = ACTIONS(3749),
    [anon_sym_AMP] = ACTIONS(3747),
    [anon_sym_SEMI] = ACTIONS(3749),
    [anon_sym___extension__] = ACTIONS(3747),
    [anon_sym_typedef] = ACTIONS(3747),
    [anon_sym_in] = ACTIONS(3747),
    [anon_sym_out] = ACTIONS(3747),
    [anon_sym_inout] = ACTIONS(3747),
    [anon_sym_virtual] = ACTIONS(3747),
    [anon_sym_extern] = ACTIONS(3747),
    [anon_sym___attribute__] = ACTIONS(3747),
    [anon_sym___attribute] = ACTIONS(3747),
    [anon_sym_using] = ACTIONS(3747),
    [anon_sym_COLON_COLON] = ACTIONS(3749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3749),
    [anon_sym___declspec] = ACTIONS(3747),
    [anon_sym___based] = ACTIONS(3747),
    [anon_sym___cdecl] = ACTIONS(3747),
    [anon_sym___clrcall] = ACTIONS(3747),
    [anon_sym___stdcall] = ACTIONS(3747),
    [anon_sym___fastcall] = ACTIONS(3747),
    [anon_sym___thiscall] = ACTIONS(3747),
    [anon_sym___vectorcall] = ACTIONS(3747),
    [anon_sym_LBRACE] = ACTIONS(3749),
    [anon_sym_RBRACE] = ACTIONS(3749),
    [anon_sym_signed] = ACTIONS(3747),
    [anon_sym_unsigned] = ACTIONS(3747),
    [anon_sym_long] = ACTIONS(3747),
    [anon_sym_short] = ACTIONS(3747),
    [anon_sym_LBRACK] = ACTIONS(3747),
    [anon_sym_static] = ACTIONS(3747),
    [anon_sym_register] = ACTIONS(3747),
    [anon_sym_inline] = ACTIONS(3747),
    [anon_sym___inline] = ACTIONS(3747),
    [anon_sym___inline__] = ACTIONS(3747),
    [anon_sym___forceinline] = ACTIONS(3747),
    [anon_sym_thread_local] = ACTIONS(3747),
    [anon_sym___thread] = ACTIONS(3747),
    [anon_sym_const] = ACTIONS(3747),
    [anon_sym_constexpr] = ACTIONS(3747),
    [anon_sym_volatile] = ACTIONS(3747),
    [anon_sym_restrict] = ACTIONS(3747),
    [anon_sym___restrict__] = ACTIONS(3747),
    [anon_sym__Atomic] = ACTIONS(3747),
    [anon_sym__Noreturn] = ACTIONS(3747),
    [anon_sym_noreturn] = ACTIONS(3747),
    [anon_sym__Nonnull] = ACTIONS(3747),
    [anon_sym_mutable] = ACTIONS(3747),
    [anon_sym_constinit] = ACTIONS(3747),
    [anon_sym_consteval] = ACTIONS(3747),
    [anon_sym_alignas] = ACTIONS(3747),
    [anon_sym__Alignas] = ACTIONS(3747),
    [sym_primitive_type] = ACTIONS(3747),
    [anon_sym_enum] = ACTIONS(3747),
    [anon_sym_class] = ACTIONS(3747),
    [anon_sym_struct] = ACTIONS(3747),
    [anon_sym_union] = ACTIONS(3747),
    [anon_sym_if] = ACTIONS(3747),
    [anon_sym_switch] = ACTIONS(3747),
    [anon_sym_case] = ACTIONS(3747),
    [anon_sym_default] = ACTIONS(3747),
    [anon_sym_while] = ACTIONS(3747),
    [anon_sym_do] = ACTIONS(3747),
    [anon_sym_for] = ACTIONS(3747),
    [anon_sym_return] = ACTIONS(3747),
    [anon_sym_break] = ACTIONS(3747),
    [anon_sym_continue] = ACTIONS(3747),
    [anon_sym_goto] = ACTIONS(3747),
    [anon_sym___try] = ACTIONS(3747),
    [anon_sym___leave] = ACTIONS(3747),
    [anon_sym_not] = ACTIONS(3747),
    [anon_sym_compl] = ACTIONS(3747),
    [anon_sym_DASH_DASH] = ACTIONS(3749),
    [anon_sym_PLUS_PLUS] = ACTIONS(3749),
    [anon_sym_sizeof] = ACTIONS(3747),
    [anon_sym___alignof__] = ACTIONS(3747),
    [anon_sym___alignof] = ACTIONS(3747),
    [anon_sym__alignof] = ACTIONS(3747),
    [anon_sym_alignof] = ACTIONS(3747),
    [anon_sym__Alignof] = ACTIONS(3747),
    [anon_sym_offsetof] = ACTIONS(3747),
    [anon_sym__Generic] = ACTIONS(3747),
    [anon_sym_asm] = ACTIONS(3747),
    [anon_sym___asm__] = ACTIONS(3747),
    [anon_sym___asm] = ACTIONS(3747),
    [sym_number_literal] = ACTIONS(3749),
    [anon_sym_L_SQUOTE] = ACTIONS(3749),
    [anon_sym_u_SQUOTE] = ACTIONS(3749),
    [anon_sym_U_SQUOTE] = ACTIONS(3749),
    [anon_sym_u8_SQUOTE] = ACTIONS(3749),
    [anon_sym_SQUOTE] = ACTIONS(3749),
    [anon_sym_L_DQUOTE] = ACTIONS(3749),
    [anon_sym_u_DQUOTE] = ACTIONS(3749),
    [anon_sym_U_DQUOTE] = ACTIONS(3749),
    [anon_sym_u8_DQUOTE] = ACTIONS(3749),
    [anon_sym_DQUOTE] = ACTIONS(3749),
    [sym_true] = ACTIONS(3747),
    [sym_false] = ACTIONS(3747),
    [anon_sym_NULL] = ACTIONS(3747),
    [anon_sym_nullptr] = ACTIONS(3747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3747),
    [anon_sym_let] = ACTIONS(3747),
    [anon_sym_This] = ACTIONS(3747),
    [anon_sym_decltype] = ACTIONS(3747),
    [anon_sym_explicit] = ACTIONS(3747),
    [anon_sym_typename] = ACTIONS(3747),
    [anon_sym_template] = ACTIONS(3747),
    [anon_sym_operator] = ACTIONS(3747),
    [anon_sym_try] = ACTIONS(3747),
    [anon_sym_delete] = ACTIONS(3747),
    [anon_sym_throw] = ACTIONS(3747),
    [anon_sym_namespace] = ACTIONS(3747),
    [anon_sym_static_assert] = ACTIONS(3747),
    [anon_sym_concept] = ACTIONS(3747),
    [anon_sym_co_return] = ACTIONS(3747),
    [anon_sym_co_yield] = ACTIONS(3747),
    [anon_sym_R_DQUOTE] = ACTIONS(3749),
    [anon_sym_LR_DQUOTE] = ACTIONS(3749),
    [anon_sym_uR_DQUOTE] = ACTIONS(3749),
    [anon_sym_UR_DQUOTE] = ACTIONS(3749),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3749),
    [anon_sym_co_await] = ACTIONS(3747),
    [anon_sym_new] = ACTIONS(3747),
    [anon_sym_requires] = ACTIONS(3747),
    [sym_this] = ACTIONS(3747),
    [anon_sym_discard] = ACTIONS(3747),
    [anon_sym_precise] = ACTIONS(3747),
    [anon_sym_shared] = ACTIONS(3747),
    [anon_sym_groupshared] = ACTIONS(3747),
    [anon_sym_uniform] = ACTIONS(3747),
    [anon_sym_row_major] = ACTIONS(3747),
    [anon_sym_column_major] = ACTIONS(3747),
    [anon_sym_globallycoherent] = ACTIONS(3747),
    [anon_sym_centroid] = ACTIONS(3747),
    [anon_sym_noperspective] = ACTIONS(3747),
    [anon_sym_nointerpolation] = ACTIONS(3747),
    [anon_sym_sample] = ACTIONS(3747),
    [anon_sym_linear] = ACTIONS(3747),
    [anon_sym_snorm] = ACTIONS(3747),
    [anon_sym_unorm] = ACTIONS(3747),
    [anon_sym_point] = ACTIONS(3747),
    [anon_sym_line] = ACTIONS(3747),
    [anon_sym_triangleadj] = ACTIONS(3747),
    [anon_sym_lineadj] = ACTIONS(3747),
    [anon_sym_triangle] = ACTIONS(3747),
    [anon_sym_cbuffer] = ACTIONS(3747),
    [anon_sym_interface] = ACTIONS(3747),
    [anon_sym_extension] = ACTIONS(3747),
  },
  [1060] = {
    [sym_identifier] = ACTIONS(3897),
    [aux_sym_preproc_include_token1] = ACTIONS(3897),
    [aux_sym_preproc_def_token1] = ACTIONS(3897),
    [aux_sym_preproc_if_token1] = ACTIONS(3897),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3897),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3897),
    [sym_preproc_directive] = ACTIONS(3897),
    [anon_sym_LPAREN2] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3899),
    [anon_sym_TILDE] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3897),
    [anon_sym_PLUS] = ACTIONS(3897),
    [anon_sym_STAR] = ACTIONS(3899),
    [anon_sym_AMP_AMP] = ACTIONS(3899),
    [anon_sym_AMP] = ACTIONS(3897),
    [anon_sym_SEMI] = ACTIONS(3899),
    [anon_sym___extension__] = ACTIONS(3897),
    [anon_sym_typedef] = ACTIONS(3897),
    [anon_sym_in] = ACTIONS(3897),
    [anon_sym_out] = ACTIONS(3897),
    [anon_sym_inout] = ACTIONS(3897),
    [anon_sym_virtual] = ACTIONS(3897),
    [anon_sym_extern] = ACTIONS(3897),
    [anon_sym___attribute__] = ACTIONS(3897),
    [anon_sym___attribute] = ACTIONS(3897),
    [anon_sym_using] = ACTIONS(3897),
    [anon_sym_COLON_COLON] = ACTIONS(3899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3899),
    [anon_sym___declspec] = ACTIONS(3897),
    [anon_sym___based] = ACTIONS(3897),
    [anon_sym___cdecl] = ACTIONS(3897),
    [anon_sym___clrcall] = ACTIONS(3897),
    [anon_sym___stdcall] = ACTIONS(3897),
    [anon_sym___fastcall] = ACTIONS(3897),
    [anon_sym___thiscall] = ACTIONS(3897),
    [anon_sym___vectorcall] = ACTIONS(3897),
    [anon_sym_LBRACE] = ACTIONS(3899),
    [anon_sym_RBRACE] = ACTIONS(3899),
    [anon_sym_signed] = ACTIONS(3897),
    [anon_sym_unsigned] = ACTIONS(3897),
    [anon_sym_long] = ACTIONS(3897),
    [anon_sym_short] = ACTIONS(3897),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_static] = ACTIONS(3897),
    [anon_sym_register] = ACTIONS(3897),
    [anon_sym_inline] = ACTIONS(3897),
    [anon_sym___inline] = ACTIONS(3897),
    [anon_sym___inline__] = ACTIONS(3897),
    [anon_sym___forceinline] = ACTIONS(3897),
    [anon_sym_thread_local] = ACTIONS(3897),
    [anon_sym___thread] = ACTIONS(3897),
    [anon_sym_const] = ACTIONS(3897),
    [anon_sym_constexpr] = ACTIONS(3897),
    [anon_sym_volatile] = ACTIONS(3897),
    [anon_sym_restrict] = ACTIONS(3897),
    [anon_sym___restrict__] = ACTIONS(3897),
    [anon_sym__Atomic] = ACTIONS(3897),
    [anon_sym__Noreturn] = ACTIONS(3897),
    [anon_sym_noreturn] = ACTIONS(3897),
    [anon_sym__Nonnull] = ACTIONS(3897),
    [anon_sym_mutable] = ACTIONS(3897),
    [anon_sym_constinit] = ACTIONS(3897),
    [anon_sym_consteval] = ACTIONS(3897),
    [anon_sym_alignas] = ACTIONS(3897),
    [anon_sym__Alignas] = ACTIONS(3897),
    [sym_primitive_type] = ACTIONS(3897),
    [anon_sym_enum] = ACTIONS(3897),
    [anon_sym_class] = ACTIONS(3897),
    [anon_sym_struct] = ACTIONS(3897),
    [anon_sym_union] = ACTIONS(3897),
    [anon_sym_if] = ACTIONS(3897),
    [anon_sym_switch] = ACTIONS(3897),
    [anon_sym_case] = ACTIONS(3897),
    [anon_sym_default] = ACTIONS(3897),
    [anon_sym_while] = ACTIONS(3897),
    [anon_sym_do] = ACTIONS(3897),
    [anon_sym_for] = ACTIONS(3897),
    [anon_sym_return] = ACTIONS(3897),
    [anon_sym_break] = ACTIONS(3897),
    [anon_sym_continue] = ACTIONS(3897),
    [anon_sym_goto] = ACTIONS(3897),
    [anon_sym___try] = ACTIONS(3897),
    [anon_sym___leave] = ACTIONS(3897),
    [anon_sym_not] = ACTIONS(3897),
    [anon_sym_compl] = ACTIONS(3897),
    [anon_sym_DASH_DASH] = ACTIONS(3899),
    [anon_sym_PLUS_PLUS] = ACTIONS(3899),
    [anon_sym_sizeof] = ACTIONS(3897),
    [anon_sym___alignof__] = ACTIONS(3897),
    [anon_sym___alignof] = ACTIONS(3897),
    [anon_sym__alignof] = ACTIONS(3897),
    [anon_sym_alignof] = ACTIONS(3897),
    [anon_sym__Alignof] = ACTIONS(3897),
    [anon_sym_offsetof] = ACTIONS(3897),
    [anon_sym__Generic] = ACTIONS(3897),
    [anon_sym_asm] = ACTIONS(3897),
    [anon_sym___asm__] = ACTIONS(3897),
    [anon_sym___asm] = ACTIONS(3897),
    [sym_number_literal] = ACTIONS(3899),
    [anon_sym_L_SQUOTE] = ACTIONS(3899),
    [anon_sym_u_SQUOTE] = ACTIONS(3899),
    [anon_sym_U_SQUOTE] = ACTIONS(3899),
    [anon_sym_u8_SQUOTE] = ACTIONS(3899),
    [anon_sym_SQUOTE] = ACTIONS(3899),
    [anon_sym_L_DQUOTE] = ACTIONS(3899),
    [anon_sym_u_DQUOTE] = ACTIONS(3899),
    [anon_sym_U_DQUOTE] = ACTIONS(3899),
    [anon_sym_u8_DQUOTE] = ACTIONS(3899),
    [anon_sym_DQUOTE] = ACTIONS(3899),
    [sym_true] = ACTIONS(3897),
    [sym_false] = ACTIONS(3897),
    [anon_sym_NULL] = ACTIONS(3897),
    [anon_sym_nullptr] = ACTIONS(3897),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3897),
    [anon_sym_let] = ACTIONS(3897),
    [anon_sym_This] = ACTIONS(3897),
    [anon_sym_decltype] = ACTIONS(3897),
    [anon_sym_explicit] = ACTIONS(3897),
    [anon_sym_typename] = ACTIONS(3897),
    [anon_sym_template] = ACTIONS(3897),
    [anon_sym_operator] = ACTIONS(3897),
    [anon_sym_try] = ACTIONS(3897),
    [anon_sym_delete] = ACTIONS(3897),
    [anon_sym_throw] = ACTIONS(3897),
    [anon_sym_namespace] = ACTIONS(3897),
    [anon_sym_static_assert] = ACTIONS(3897),
    [anon_sym_concept] = ACTIONS(3897),
    [anon_sym_co_return] = ACTIONS(3897),
    [anon_sym_co_yield] = ACTIONS(3897),
    [anon_sym_R_DQUOTE] = ACTIONS(3899),
    [anon_sym_LR_DQUOTE] = ACTIONS(3899),
    [anon_sym_uR_DQUOTE] = ACTIONS(3899),
    [anon_sym_UR_DQUOTE] = ACTIONS(3899),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3899),
    [anon_sym_co_await] = ACTIONS(3897),
    [anon_sym_new] = ACTIONS(3897),
    [anon_sym_requires] = ACTIONS(3897),
    [sym_this] = ACTIONS(3897),
    [anon_sym_discard] = ACTIONS(3897),
    [anon_sym_precise] = ACTIONS(3897),
    [anon_sym_shared] = ACTIONS(3897),
    [anon_sym_groupshared] = ACTIONS(3897),
    [anon_sym_uniform] = ACTIONS(3897),
    [anon_sym_row_major] = ACTIONS(3897),
    [anon_sym_column_major] = ACTIONS(3897),
    [anon_sym_globallycoherent] = ACTIONS(3897),
    [anon_sym_centroid] = ACTIONS(3897),
    [anon_sym_noperspective] = ACTIONS(3897),
    [anon_sym_nointerpolation] = ACTIONS(3897),
    [anon_sym_sample] = ACTIONS(3897),
    [anon_sym_linear] = ACTIONS(3897),
    [anon_sym_snorm] = ACTIONS(3897),
    [anon_sym_unorm] = ACTIONS(3897),
    [anon_sym_point] = ACTIONS(3897),
    [anon_sym_line] = ACTIONS(3897),
    [anon_sym_triangleadj] = ACTIONS(3897),
    [anon_sym_lineadj] = ACTIONS(3897),
    [anon_sym_triangle] = ACTIONS(3897),
    [anon_sym_cbuffer] = ACTIONS(3897),
    [anon_sym_interface] = ACTIONS(3897),
    [anon_sym_extension] = ACTIONS(3897),
  },
  [1061] = {
    [sym_identifier] = ACTIONS(3971),
    [aux_sym_preproc_include_token1] = ACTIONS(3971),
    [aux_sym_preproc_def_token1] = ACTIONS(3971),
    [aux_sym_preproc_if_token1] = ACTIONS(3971),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3971),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3971),
    [sym_preproc_directive] = ACTIONS(3971),
    [anon_sym_LPAREN2] = ACTIONS(3974),
    [anon_sym_BANG] = ACTIONS(3974),
    [anon_sym_TILDE] = ACTIONS(3974),
    [anon_sym_DASH] = ACTIONS(3971),
    [anon_sym_PLUS] = ACTIONS(3971),
    [anon_sym_STAR] = ACTIONS(3974),
    [anon_sym_AMP_AMP] = ACTIONS(3974),
    [anon_sym_AMP] = ACTIONS(3971),
    [anon_sym_SEMI] = ACTIONS(3974),
    [anon_sym___extension__] = ACTIONS(3971),
    [anon_sym_typedef] = ACTIONS(3971),
    [anon_sym_in] = ACTIONS(3971),
    [anon_sym_out] = ACTIONS(3971),
    [anon_sym_inout] = ACTIONS(3971),
    [anon_sym_virtual] = ACTIONS(3971),
    [anon_sym_extern] = ACTIONS(3971),
    [anon_sym___attribute__] = ACTIONS(3971),
    [anon_sym___attribute] = ACTIONS(3971),
    [anon_sym_using] = ACTIONS(3971),
    [anon_sym_COLON_COLON] = ACTIONS(3974),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3974),
    [anon_sym___declspec] = ACTIONS(3971),
    [anon_sym___based] = ACTIONS(3971),
    [anon_sym___cdecl] = ACTIONS(3971),
    [anon_sym___clrcall] = ACTIONS(3971),
    [anon_sym___stdcall] = ACTIONS(3971),
    [anon_sym___fastcall] = ACTIONS(3971),
    [anon_sym___thiscall] = ACTIONS(3971),
    [anon_sym___vectorcall] = ACTIONS(3971),
    [anon_sym_LBRACE] = ACTIONS(3974),
    [anon_sym_RBRACE] = ACTIONS(3974),
    [anon_sym_signed] = ACTIONS(3971),
    [anon_sym_unsigned] = ACTIONS(3971),
    [anon_sym_long] = ACTIONS(3971),
    [anon_sym_short] = ACTIONS(3971),
    [anon_sym_LBRACK] = ACTIONS(3971),
    [anon_sym_static] = ACTIONS(3971),
    [anon_sym_register] = ACTIONS(3971),
    [anon_sym_inline] = ACTIONS(3971),
    [anon_sym___inline] = ACTIONS(3971),
    [anon_sym___inline__] = ACTIONS(3971),
    [anon_sym___forceinline] = ACTIONS(3971),
    [anon_sym_thread_local] = ACTIONS(3971),
    [anon_sym___thread] = ACTIONS(3971),
    [anon_sym_const] = ACTIONS(3971),
    [anon_sym_constexpr] = ACTIONS(3971),
    [anon_sym_volatile] = ACTIONS(3971),
    [anon_sym_restrict] = ACTIONS(3971),
    [anon_sym___restrict__] = ACTIONS(3971),
    [anon_sym__Atomic] = ACTIONS(3971),
    [anon_sym__Noreturn] = ACTIONS(3971),
    [anon_sym_noreturn] = ACTIONS(3971),
    [anon_sym__Nonnull] = ACTIONS(3971),
    [anon_sym_mutable] = ACTIONS(3971),
    [anon_sym_constinit] = ACTIONS(3971),
    [anon_sym_consteval] = ACTIONS(3971),
    [anon_sym_alignas] = ACTIONS(3971),
    [anon_sym__Alignas] = ACTIONS(3971),
    [sym_primitive_type] = ACTIONS(3971),
    [anon_sym_enum] = ACTIONS(3971),
    [anon_sym_class] = ACTIONS(3971),
    [anon_sym_struct] = ACTIONS(3971),
    [anon_sym_union] = ACTIONS(3971),
    [anon_sym_if] = ACTIONS(3971),
    [anon_sym_switch] = ACTIONS(3971),
    [anon_sym_case] = ACTIONS(3971),
    [anon_sym_default] = ACTIONS(3971),
    [anon_sym_while] = ACTIONS(3971),
    [anon_sym_do] = ACTIONS(3971),
    [anon_sym_for] = ACTIONS(3971),
    [anon_sym_return] = ACTIONS(3971),
    [anon_sym_break] = ACTIONS(3971),
    [anon_sym_continue] = ACTIONS(3971),
    [anon_sym_goto] = ACTIONS(3971),
    [anon_sym___try] = ACTIONS(3971),
    [anon_sym___leave] = ACTIONS(3971),
    [anon_sym_not] = ACTIONS(3971),
    [anon_sym_compl] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3974),
    [anon_sym_PLUS_PLUS] = ACTIONS(3974),
    [anon_sym_sizeof] = ACTIONS(3971),
    [anon_sym___alignof__] = ACTIONS(3971),
    [anon_sym___alignof] = ACTIONS(3971),
    [anon_sym__alignof] = ACTIONS(3971),
    [anon_sym_alignof] = ACTIONS(3971),
    [anon_sym__Alignof] = ACTIONS(3971),
    [anon_sym_offsetof] = ACTIONS(3971),
    [anon_sym__Generic] = ACTIONS(3971),
    [anon_sym_asm] = ACTIONS(3971),
    [anon_sym___asm__] = ACTIONS(3971),
    [anon_sym___asm] = ACTIONS(3971),
    [sym_number_literal] = ACTIONS(3974),
    [anon_sym_L_SQUOTE] = ACTIONS(3974),
    [anon_sym_u_SQUOTE] = ACTIONS(3974),
    [anon_sym_U_SQUOTE] = ACTIONS(3974),
    [anon_sym_u8_SQUOTE] = ACTIONS(3974),
    [anon_sym_SQUOTE] = ACTIONS(3974),
    [anon_sym_L_DQUOTE] = ACTIONS(3974),
    [anon_sym_u_DQUOTE] = ACTIONS(3974),
    [anon_sym_U_DQUOTE] = ACTIONS(3974),
    [anon_sym_u8_DQUOTE] = ACTIONS(3974),
    [anon_sym_DQUOTE] = ACTIONS(3974),
    [sym_true] = ACTIONS(3971),
    [sym_false] = ACTIONS(3971),
    [anon_sym_NULL] = ACTIONS(3971),
    [anon_sym_nullptr] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3971),
    [anon_sym_let] = ACTIONS(3971),
    [anon_sym_This] = ACTIONS(3971),
    [anon_sym_decltype] = ACTIONS(3971),
    [anon_sym_explicit] = ACTIONS(3971),
    [anon_sym_typename] = ACTIONS(3971),
    [anon_sym_template] = ACTIONS(3971),
    [anon_sym_operator] = ACTIONS(3971),
    [anon_sym_try] = ACTIONS(3971),
    [anon_sym_delete] = ACTIONS(3971),
    [anon_sym_throw] = ACTIONS(3971),
    [anon_sym_namespace] = ACTIONS(3971),
    [anon_sym_static_assert] = ACTIONS(3971),
    [anon_sym_concept] = ACTIONS(3971),
    [anon_sym_co_return] = ACTIONS(3971),
    [anon_sym_co_yield] = ACTIONS(3971),
    [anon_sym_R_DQUOTE] = ACTIONS(3974),
    [anon_sym_LR_DQUOTE] = ACTIONS(3974),
    [anon_sym_uR_DQUOTE] = ACTIONS(3974),
    [anon_sym_UR_DQUOTE] = ACTIONS(3974),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3974),
    [anon_sym_co_await] = ACTIONS(3971),
    [anon_sym_new] = ACTIONS(3971),
    [anon_sym_requires] = ACTIONS(3971),
    [sym_this] = ACTIONS(3971),
    [anon_sym_discard] = ACTIONS(3971),
    [anon_sym_precise] = ACTIONS(3971),
    [anon_sym_shared] = ACTIONS(3971),
    [anon_sym_groupshared] = ACTIONS(3971),
    [anon_sym_uniform] = ACTIONS(3971),
    [anon_sym_row_major] = ACTIONS(3971),
    [anon_sym_column_major] = ACTIONS(3971),
    [anon_sym_globallycoherent] = ACTIONS(3971),
    [anon_sym_centroid] = ACTIONS(3971),
    [anon_sym_noperspective] = ACTIONS(3971),
    [anon_sym_nointerpolation] = ACTIONS(3971),
    [anon_sym_sample] = ACTIONS(3971),
    [anon_sym_linear] = ACTIONS(3971),
    [anon_sym_snorm] = ACTIONS(3971),
    [anon_sym_unorm] = ACTIONS(3971),
    [anon_sym_point] = ACTIONS(3971),
    [anon_sym_line] = ACTIONS(3971),
    [anon_sym_triangleadj] = ACTIONS(3971),
    [anon_sym_lineadj] = ACTIONS(3971),
    [anon_sym_triangle] = ACTIONS(3971),
    [anon_sym_cbuffer] = ACTIONS(3971),
    [anon_sym_interface] = ACTIONS(3971),
    [anon_sym_extension] = ACTIONS(3971),
  },
  [1062] = {
    [ts_builtin_sym_end] = ACTIONS(3745),
    [sym_identifier] = ACTIONS(3743),
    [aux_sym_preproc_include_token1] = ACTIONS(3743),
    [aux_sym_preproc_def_token1] = ACTIONS(3743),
    [aux_sym_preproc_if_token1] = ACTIONS(3743),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3743),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3743),
    [sym_preproc_directive] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3745),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_STAR] = ACTIONS(3745),
    [anon_sym_AMP_AMP] = ACTIONS(3745),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_SEMI] = ACTIONS(3745),
    [anon_sym___extension__] = ACTIONS(3743),
    [anon_sym_typedef] = ACTIONS(3743),
    [anon_sym_in] = ACTIONS(3743),
    [anon_sym_out] = ACTIONS(3743),
    [anon_sym_inout] = ACTIONS(3743),
    [anon_sym_virtual] = ACTIONS(3743),
    [anon_sym_extern] = ACTIONS(3743),
    [anon_sym___attribute__] = ACTIONS(3743),
    [anon_sym___attribute] = ACTIONS(3743),
    [anon_sym_using] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3745),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3745),
    [anon_sym___declspec] = ACTIONS(3743),
    [anon_sym___based] = ACTIONS(3743),
    [anon_sym___cdecl] = ACTIONS(3743),
    [anon_sym___clrcall] = ACTIONS(3743),
    [anon_sym___stdcall] = ACTIONS(3743),
    [anon_sym___fastcall] = ACTIONS(3743),
    [anon_sym___thiscall] = ACTIONS(3743),
    [anon_sym___vectorcall] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_signed] = ACTIONS(3743),
    [anon_sym_unsigned] = ACTIONS(3743),
    [anon_sym_long] = ACTIONS(3743),
    [anon_sym_short] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_static] = ACTIONS(3743),
    [anon_sym_register] = ACTIONS(3743),
    [anon_sym_inline] = ACTIONS(3743),
    [anon_sym___inline] = ACTIONS(3743),
    [anon_sym___inline__] = ACTIONS(3743),
    [anon_sym___forceinline] = ACTIONS(3743),
    [anon_sym_thread_local] = ACTIONS(3743),
    [anon_sym___thread] = ACTIONS(3743),
    [anon_sym_const] = ACTIONS(3743),
    [anon_sym_constexpr] = ACTIONS(3743),
    [anon_sym_volatile] = ACTIONS(3743),
    [anon_sym_restrict] = ACTIONS(3743),
    [anon_sym___restrict__] = ACTIONS(3743),
    [anon_sym__Atomic] = ACTIONS(3743),
    [anon_sym__Noreturn] = ACTIONS(3743),
    [anon_sym_noreturn] = ACTIONS(3743),
    [anon_sym__Nonnull] = ACTIONS(3743),
    [anon_sym_mutable] = ACTIONS(3743),
    [anon_sym_constinit] = ACTIONS(3743),
    [anon_sym_consteval] = ACTIONS(3743),
    [anon_sym_alignas] = ACTIONS(3743),
    [anon_sym__Alignas] = ACTIONS(3743),
    [sym_primitive_type] = ACTIONS(3743),
    [anon_sym_enum] = ACTIONS(3743),
    [anon_sym_class] = ACTIONS(3743),
    [anon_sym_struct] = ACTIONS(3743),
    [anon_sym_union] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_switch] = ACTIONS(3743),
    [anon_sym_case] = ACTIONS(3743),
    [anon_sym_default] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_break] = ACTIONS(3743),
    [anon_sym_continue] = ACTIONS(3743),
    [anon_sym_goto] = ACTIONS(3743),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_compl] = ACTIONS(3743),
    [anon_sym_DASH_DASH] = ACTIONS(3745),
    [anon_sym_PLUS_PLUS] = ACTIONS(3745),
    [anon_sym_sizeof] = ACTIONS(3743),
    [anon_sym___alignof__] = ACTIONS(3743),
    [anon_sym___alignof] = ACTIONS(3743),
    [anon_sym__alignof] = ACTIONS(3743),
    [anon_sym_alignof] = ACTIONS(3743),
    [anon_sym__Alignof] = ACTIONS(3743),
    [anon_sym_offsetof] = ACTIONS(3743),
    [anon_sym__Generic] = ACTIONS(3743),
    [anon_sym_asm] = ACTIONS(3743),
    [anon_sym___asm__] = ACTIONS(3743),
    [anon_sym___asm] = ACTIONS(3743),
    [sym_number_literal] = ACTIONS(3745),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3745),
    [anon_sym_u_DQUOTE] = ACTIONS(3745),
    [anon_sym_U_DQUOTE] = ACTIONS(3745),
    [anon_sym_u8_DQUOTE] = ACTIONS(3745),
    [anon_sym_DQUOTE] = ACTIONS(3745),
    [sym_true] = ACTIONS(3743),
    [sym_false] = ACTIONS(3743),
    [anon_sym_NULL] = ACTIONS(3743),
    [anon_sym_nullptr] = ACTIONS(3743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_This] = ACTIONS(3743),
    [anon_sym_decltype] = ACTIONS(3743),
    [anon_sym_explicit] = ACTIONS(3743),
    [anon_sym_typename] = ACTIONS(3743),
    [anon_sym_export] = ACTIONS(3743),
    [anon_sym_module] = ACTIONS(3743),
    [anon_sym_import] = ACTIONS(3743),
    [anon_sym_template] = ACTIONS(3743),
    [anon_sym_operator] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_delete] = ACTIONS(3743),
    [anon_sym_throw] = ACTIONS(3743),
    [anon_sym_namespace] = ACTIONS(3743),
    [anon_sym_static_assert] = ACTIONS(3743),
    [anon_sym_concept] = ACTIONS(3743),
    [anon_sym_co_return] = ACTIONS(3743),
    [anon_sym_co_yield] = ACTIONS(3743),
    [anon_sym_R_DQUOTE] = ACTIONS(3745),
    [anon_sym_LR_DQUOTE] = ACTIONS(3745),
    [anon_sym_uR_DQUOTE] = ACTIONS(3745),
    [anon_sym_UR_DQUOTE] = ACTIONS(3745),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3745),
    [anon_sym_co_await] = ACTIONS(3743),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_requires] = ACTIONS(3743),
    [sym_this] = ACTIONS(3743),
    [anon_sym_precise] = ACTIONS(3743),
    [anon_sym_shared] = ACTIONS(3743),
    [anon_sym_groupshared] = ACTIONS(3743),
    [anon_sym_uniform] = ACTIONS(3743),
    [anon_sym_row_major] = ACTIONS(3743),
    [anon_sym_column_major] = ACTIONS(3743),
    [anon_sym_globallycoherent] = ACTIONS(3743),
    [anon_sym_centroid] = ACTIONS(3743),
    [anon_sym_noperspective] = ACTIONS(3743),
    [anon_sym_nointerpolation] = ACTIONS(3743),
    [anon_sym_sample] = ACTIONS(3743),
    [anon_sym_linear] = ACTIONS(3743),
    [anon_sym_snorm] = ACTIONS(3743),
    [anon_sym_unorm] = ACTIONS(3743),
    [anon_sym_point] = ACTIONS(3743),
    [anon_sym_line] = ACTIONS(3743),
    [anon_sym_triangleadj] = ACTIONS(3743),
    [anon_sym_lineadj] = ACTIONS(3743),
    [anon_sym_triangle] = ACTIONS(3743),
    [anon_sym_interface] = ACTIONS(3743),
    [anon_sym_extension] = ACTIONS(3743),
    [anon_sym___exported] = ACTIONS(3743),
  },
  [1063] = {
    [ts_builtin_sym_end] = ACTIONS(4333),
    [sym_identifier] = ACTIONS(4335),
    [aux_sym_preproc_include_token1] = ACTIONS(4335),
    [aux_sym_preproc_def_token1] = ACTIONS(4335),
    [aux_sym_preproc_if_token1] = ACTIONS(4335),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4335),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4335),
    [sym_preproc_directive] = ACTIONS(4335),
    [anon_sym_LPAREN2] = ACTIONS(4333),
    [anon_sym_BANG] = ACTIONS(4333),
    [anon_sym_TILDE] = ACTIONS(4333),
    [anon_sym_DASH] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(4335),
    [anon_sym_STAR] = ACTIONS(4333),
    [anon_sym_AMP_AMP] = ACTIONS(4333),
    [anon_sym_AMP] = ACTIONS(4335),
    [anon_sym_SEMI] = ACTIONS(4333),
    [anon_sym___extension__] = ACTIONS(4335),
    [anon_sym_typedef] = ACTIONS(4335),
    [anon_sym_in] = ACTIONS(4335),
    [anon_sym_out] = ACTIONS(4335),
    [anon_sym_inout] = ACTIONS(4335),
    [anon_sym_virtual] = ACTIONS(4335),
    [anon_sym_extern] = ACTIONS(4335),
    [anon_sym___attribute__] = ACTIONS(4335),
    [anon_sym___attribute] = ACTIONS(4335),
    [anon_sym_using] = ACTIONS(4335),
    [anon_sym_COLON_COLON] = ACTIONS(4333),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4333),
    [anon_sym___declspec] = ACTIONS(4335),
    [anon_sym___based] = ACTIONS(4335),
    [anon_sym___cdecl] = ACTIONS(4335),
    [anon_sym___clrcall] = ACTIONS(4335),
    [anon_sym___stdcall] = ACTIONS(4335),
    [anon_sym___fastcall] = ACTIONS(4335),
    [anon_sym___thiscall] = ACTIONS(4335),
    [anon_sym___vectorcall] = ACTIONS(4335),
    [anon_sym_LBRACE] = ACTIONS(4333),
    [anon_sym_signed] = ACTIONS(4335),
    [anon_sym_unsigned] = ACTIONS(4335),
    [anon_sym_long] = ACTIONS(4335),
    [anon_sym_short] = ACTIONS(4335),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_static] = ACTIONS(4335),
    [anon_sym_register] = ACTIONS(4335),
    [anon_sym_inline] = ACTIONS(4335),
    [anon_sym___inline] = ACTIONS(4335),
    [anon_sym___inline__] = ACTIONS(4335),
    [anon_sym___forceinline] = ACTIONS(4335),
    [anon_sym_thread_local] = ACTIONS(4335),
    [anon_sym___thread] = ACTIONS(4335),
    [anon_sym_const] = ACTIONS(4335),
    [anon_sym_constexpr] = ACTIONS(4335),
    [anon_sym_volatile] = ACTIONS(4335),
    [anon_sym_restrict] = ACTIONS(4335),
    [anon_sym___restrict__] = ACTIONS(4335),
    [anon_sym__Atomic] = ACTIONS(4335),
    [anon_sym__Noreturn] = ACTIONS(4335),
    [anon_sym_noreturn] = ACTIONS(4335),
    [anon_sym__Nonnull] = ACTIONS(4335),
    [anon_sym_mutable] = ACTIONS(4335),
    [anon_sym_constinit] = ACTIONS(4335),
    [anon_sym_consteval] = ACTIONS(4335),
    [anon_sym_alignas] = ACTIONS(4335),
    [anon_sym__Alignas] = ACTIONS(4335),
    [sym_primitive_type] = ACTIONS(4335),
    [anon_sym_enum] = ACTIONS(4335),
    [anon_sym_class] = ACTIONS(4335),
    [anon_sym_struct] = ACTIONS(4335),
    [anon_sym_union] = ACTIONS(4335),
    [anon_sym_if] = ACTIONS(4335),
    [anon_sym_switch] = ACTIONS(4335),
    [anon_sym_case] = ACTIONS(4335),
    [anon_sym_default] = ACTIONS(4335),
    [anon_sym_while] = ACTIONS(4335),
    [anon_sym_do] = ACTIONS(4335),
    [anon_sym_for] = ACTIONS(4335),
    [anon_sym_return] = ACTIONS(4335),
    [anon_sym_break] = ACTIONS(4335),
    [anon_sym_continue] = ACTIONS(4335),
    [anon_sym_goto] = ACTIONS(4335),
    [anon_sym_not] = ACTIONS(4335),
    [anon_sym_compl] = ACTIONS(4335),
    [anon_sym_DASH_DASH] = ACTIONS(4333),
    [anon_sym_PLUS_PLUS] = ACTIONS(4333),
    [anon_sym_sizeof] = ACTIONS(4335),
    [anon_sym___alignof__] = ACTIONS(4335),
    [anon_sym___alignof] = ACTIONS(4335),
    [anon_sym__alignof] = ACTIONS(4335),
    [anon_sym_alignof] = ACTIONS(4335),
    [anon_sym__Alignof] = ACTIONS(4335),
    [anon_sym_offsetof] = ACTIONS(4335),
    [anon_sym__Generic] = ACTIONS(4335),
    [anon_sym_asm] = ACTIONS(4335),
    [anon_sym___asm__] = ACTIONS(4335),
    [anon_sym___asm] = ACTIONS(4335),
    [sym_number_literal] = ACTIONS(4333),
    [anon_sym_L_SQUOTE] = ACTIONS(4333),
    [anon_sym_u_SQUOTE] = ACTIONS(4333),
    [anon_sym_U_SQUOTE] = ACTIONS(4333),
    [anon_sym_u8_SQUOTE] = ACTIONS(4333),
    [anon_sym_SQUOTE] = ACTIONS(4333),
    [anon_sym_L_DQUOTE] = ACTIONS(4333),
    [anon_sym_u_DQUOTE] = ACTIONS(4333),
    [anon_sym_U_DQUOTE] = ACTIONS(4333),
    [anon_sym_u8_DQUOTE] = ACTIONS(4333),
    [anon_sym_DQUOTE] = ACTIONS(4333),
    [sym_true] = ACTIONS(4335),
    [sym_false] = ACTIONS(4335),
    [anon_sym_NULL] = ACTIONS(4335),
    [anon_sym_nullptr] = ACTIONS(4335),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4335),
    [anon_sym_let] = ACTIONS(4335),
    [anon_sym_This] = ACTIONS(4335),
    [anon_sym_decltype] = ACTIONS(4335),
    [anon_sym_explicit] = ACTIONS(4335),
    [anon_sym_typename] = ACTIONS(4335),
    [anon_sym_export] = ACTIONS(4335),
    [anon_sym_module] = ACTIONS(4335),
    [anon_sym_import] = ACTIONS(4335),
    [anon_sym_template] = ACTIONS(4335),
    [anon_sym_operator] = ACTIONS(4335),
    [anon_sym_try] = ACTIONS(4335),
    [anon_sym_delete] = ACTIONS(4335),
    [anon_sym_throw] = ACTIONS(4335),
    [anon_sym_namespace] = ACTIONS(4335),
    [anon_sym_static_assert] = ACTIONS(4335),
    [anon_sym_concept] = ACTIONS(4335),
    [anon_sym_co_return] = ACTIONS(4335),
    [anon_sym_co_yield] = ACTIONS(4335),
    [anon_sym_R_DQUOTE] = ACTIONS(4333),
    [anon_sym_LR_DQUOTE] = ACTIONS(4333),
    [anon_sym_uR_DQUOTE] = ACTIONS(4333),
    [anon_sym_UR_DQUOTE] = ACTIONS(4333),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4333),
    [anon_sym_co_await] = ACTIONS(4335),
    [anon_sym_new] = ACTIONS(4335),
    [anon_sym_requires] = ACTIONS(4335),
    [sym_this] = ACTIONS(4335),
    [anon_sym_precise] = ACTIONS(4335),
    [anon_sym_shared] = ACTIONS(4335),
    [anon_sym_groupshared] = ACTIONS(4335),
    [anon_sym_uniform] = ACTIONS(4335),
    [anon_sym_row_major] = ACTIONS(4335),
    [anon_sym_column_major] = ACTIONS(4335),
    [anon_sym_globallycoherent] = ACTIONS(4335),
    [anon_sym_centroid] = ACTIONS(4335),
    [anon_sym_noperspective] = ACTIONS(4335),
    [anon_sym_nointerpolation] = ACTIONS(4335),
    [anon_sym_sample] = ACTIONS(4335),
    [anon_sym_linear] = ACTIONS(4335),
    [anon_sym_snorm] = ACTIONS(4335),
    [anon_sym_unorm] = ACTIONS(4335),
    [anon_sym_point] = ACTIONS(4335),
    [anon_sym_line] = ACTIONS(4335),
    [anon_sym_triangleadj] = ACTIONS(4335),
    [anon_sym_lineadj] = ACTIONS(4335),
    [anon_sym_triangle] = ACTIONS(4335),
    [anon_sym_interface] = ACTIONS(4335),
    [anon_sym_extension] = ACTIONS(4335),
    [anon_sym___exported] = ACTIONS(4335),
  },
  [1064] = {
    [ts_builtin_sym_end] = ACTIONS(3879),
    [sym_identifier] = ACTIONS(3877),
    [aux_sym_preproc_include_token1] = ACTIONS(3877),
    [aux_sym_preproc_def_token1] = ACTIONS(3877),
    [aux_sym_preproc_if_token1] = ACTIONS(3877),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3877),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3877),
    [sym_preproc_directive] = ACTIONS(3877),
    [anon_sym_LPAREN2] = ACTIONS(3879),
    [anon_sym_BANG] = ACTIONS(3879),
    [anon_sym_TILDE] = ACTIONS(3879),
    [anon_sym_DASH] = ACTIONS(3877),
    [anon_sym_PLUS] = ACTIONS(3877),
    [anon_sym_STAR] = ACTIONS(3879),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3877),
    [anon_sym_SEMI] = ACTIONS(3879),
    [anon_sym___extension__] = ACTIONS(3877),
    [anon_sym_typedef] = ACTIONS(3877),
    [anon_sym_in] = ACTIONS(3877),
    [anon_sym_out] = ACTIONS(3877),
    [anon_sym_inout] = ACTIONS(3877),
    [anon_sym_virtual] = ACTIONS(3877),
    [anon_sym_extern] = ACTIONS(3877),
    [anon_sym___attribute__] = ACTIONS(3877),
    [anon_sym___attribute] = ACTIONS(3877),
    [anon_sym_using] = ACTIONS(3877),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3879),
    [anon_sym___declspec] = ACTIONS(3877),
    [anon_sym___based] = ACTIONS(3877),
    [anon_sym___cdecl] = ACTIONS(3877),
    [anon_sym___clrcall] = ACTIONS(3877),
    [anon_sym___stdcall] = ACTIONS(3877),
    [anon_sym___fastcall] = ACTIONS(3877),
    [anon_sym___thiscall] = ACTIONS(3877),
    [anon_sym___vectorcall] = ACTIONS(3877),
    [anon_sym_LBRACE] = ACTIONS(3879),
    [anon_sym_signed] = ACTIONS(3877),
    [anon_sym_unsigned] = ACTIONS(3877),
    [anon_sym_long] = ACTIONS(3877),
    [anon_sym_short] = ACTIONS(3877),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_static] = ACTIONS(3877),
    [anon_sym_register] = ACTIONS(3877),
    [anon_sym_inline] = ACTIONS(3877),
    [anon_sym___inline] = ACTIONS(3877),
    [anon_sym___inline__] = ACTIONS(3877),
    [anon_sym___forceinline] = ACTIONS(3877),
    [anon_sym_thread_local] = ACTIONS(3877),
    [anon_sym___thread] = ACTIONS(3877),
    [anon_sym_const] = ACTIONS(3877),
    [anon_sym_constexpr] = ACTIONS(3877),
    [anon_sym_volatile] = ACTIONS(3877),
    [anon_sym_restrict] = ACTIONS(3877),
    [anon_sym___restrict__] = ACTIONS(3877),
    [anon_sym__Atomic] = ACTIONS(3877),
    [anon_sym__Noreturn] = ACTIONS(3877),
    [anon_sym_noreturn] = ACTIONS(3877),
    [anon_sym__Nonnull] = ACTIONS(3877),
    [anon_sym_mutable] = ACTIONS(3877),
    [anon_sym_constinit] = ACTIONS(3877),
    [anon_sym_consteval] = ACTIONS(3877),
    [anon_sym_alignas] = ACTIONS(3877),
    [anon_sym__Alignas] = ACTIONS(3877),
    [sym_primitive_type] = ACTIONS(3877),
    [anon_sym_enum] = ACTIONS(3877),
    [anon_sym_class] = ACTIONS(3877),
    [anon_sym_struct] = ACTIONS(3877),
    [anon_sym_union] = ACTIONS(3877),
    [anon_sym_if] = ACTIONS(3877),
    [anon_sym_switch] = ACTIONS(3877),
    [anon_sym_case] = ACTIONS(3877),
    [anon_sym_default] = ACTIONS(3877),
    [anon_sym_while] = ACTIONS(3877),
    [anon_sym_do] = ACTIONS(3877),
    [anon_sym_for] = ACTIONS(3877),
    [anon_sym_return] = ACTIONS(3877),
    [anon_sym_break] = ACTIONS(3877),
    [anon_sym_continue] = ACTIONS(3877),
    [anon_sym_goto] = ACTIONS(3877),
    [anon_sym_not] = ACTIONS(3877),
    [anon_sym_compl] = ACTIONS(3877),
    [anon_sym_DASH_DASH] = ACTIONS(3879),
    [anon_sym_PLUS_PLUS] = ACTIONS(3879),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(3877),
    [anon_sym___alignof] = ACTIONS(3877),
    [anon_sym__alignof] = ACTIONS(3877),
    [anon_sym_alignof] = ACTIONS(3877),
    [anon_sym__Alignof] = ACTIONS(3877),
    [anon_sym_offsetof] = ACTIONS(3877),
    [anon_sym__Generic] = ACTIONS(3877),
    [anon_sym_asm] = ACTIONS(3877),
    [anon_sym___asm__] = ACTIONS(3877),
    [anon_sym___asm] = ACTIONS(3877),
    [sym_number_literal] = ACTIONS(3879),
    [anon_sym_L_SQUOTE] = ACTIONS(3879),
    [anon_sym_u_SQUOTE] = ACTIONS(3879),
    [anon_sym_U_SQUOTE] = ACTIONS(3879),
    [anon_sym_u8_SQUOTE] = ACTIONS(3879),
    [anon_sym_SQUOTE] = ACTIONS(3879),
    [anon_sym_L_DQUOTE] = ACTIONS(3879),
    [anon_sym_u_DQUOTE] = ACTIONS(3879),
    [anon_sym_U_DQUOTE] = ACTIONS(3879),
    [anon_sym_u8_DQUOTE] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [sym_true] = ACTIONS(3877),
    [sym_false] = ACTIONS(3877),
    [anon_sym_NULL] = ACTIONS(3877),
    [anon_sym_nullptr] = ACTIONS(3877),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3877),
    [anon_sym_let] = ACTIONS(3877),
    [anon_sym_This] = ACTIONS(3877),
    [anon_sym_decltype] = ACTIONS(3877),
    [anon_sym_explicit] = ACTIONS(3877),
    [anon_sym_typename] = ACTIONS(3877),
    [anon_sym_export] = ACTIONS(3877),
    [anon_sym_module] = ACTIONS(3877),
    [anon_sym_import] = ACTIONS(3877),
    [anon_sym_template] = ACTIONS(3877),
    [anon_sym_operator] = ACTIONS(3877),
    [anon_sym_try] = ACTIONS(3877),
    [anon_sym_delete] = ACTIONS(3877),
    [anon_sym_throw] = ACTIONS(3877),
    [anon_sym_namespace] = ACTIONS(3877),
    [anon_sym_static_assert] = ACTIONS(3877),
    [anon_sym_concept] = ACTIONS(3877),
    [anon_sym_co_return] = ACTIONS(3877),
    [anon_sym_co_yield] = ACTIONS(3877),
    [anon_sym_R_DQUOTE] = ACTIONS(3879),
    [anon_sym_LR_DQUOTE] = ACTIONS(3879),
    [anon_sym_uR_DQUOTE] = ACTIONS(3879),
    [anon_sym_UR_DQUOTE] = ACTIONS(3879),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3879),
    [anon_sym_co_await] = ACTIONS(3877),
    [anon_sym_new] = ACTIONS(3877),
    [anon_sym_requires] = ACTIONS(3877),
    [sym_this] = ACTIONS(3877),
    [anon_sym_precise] = ACTIONS(3877),
    [anon_sym_shared] = ACTIONS(3877),
    [anon_sym_groupshared] = ACTIONS(3877),
    [anon_sym_uniform] = ACTIONS(3877),
    [anon_sym_row_major] = ACTIONS(3877),
    [anon_sym_column_major] = ACTIONS(3877),
    [anon_sym_globallycoherent] = ACTIONS(3877),
    [anon_sym_centroid] = ACTIONS(3877),
    [anon_sym_noperspective] = ACTIONS(3877),
    [anon_sym_nointerpolation] = ACTIONS(3877),
    [anon_sym_sample] = ACTIONS(3877),
    [anon_sym_linear] = ACTIONS(3877),
    [anon_sym_snorm] = ACTIONS(3877),
    [anon_sym_unorm] = ACTIONS(3877),
    [anon_sym_point] = ACTIONS(3877),
    [anon_sym_line] = ACTIONS(3877),
    [anon_sym_triangleadj] = ACTIONS(3877),
    [anon_sym_lineadj] = ACTIONS(3877),
    [anon_sym_triangle] = ACTIONS(3877),
    [anon_sym_interface] = ACTIONS(3877),
    [anon_sym_extension] = ACTIONS(3877),
    [anon_sym___exported] = ACTIONS(3877),
  },
  [1065] = {
    [ts_builtin_sym_end] = ACTIONS(4337),
    [sym_identifier] = ACTIONS(4339),
    [aux_sym_preproc_include_token1] = ACTIONS(4339),
    [aux_sym_preproc_def_token1] = ACTIONS(4339),
    [aux_sym_preproc_if_token1] = ACTIONS(4339),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4339),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4339),
    [sym_preproc_directive] = ACTIONS(4339),
    [anon_sym_LPAREN2] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4337),
    [anon_sym_TILDE] = ACTIONS(4337),
    [anon_sym_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4339),
    [anon_sym_STAR] = ACTIONS(4337),
    [anon_sym_AMP_AMP] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4339),
    [anon_sym_SEMI] = ACTIONS(4337),
    [anon_sym___extension__] = ACTIONS(4339),
    [anon_sym_typedef] = ACTIONS(4339),
    [anon_sym_in] = ACTIONS(4339),
    [anon_sym_out] = ACTIONS(4339),
    [anon_sym_inout] = ACTIONS(4339),
    [anon_sym_virtual] = ACTIONS(4339),
    [anon_sym_extern] = ACTIONS(4339),
    [anon_sym___attribute__] = ACTIONS(4339),
    [anon_sym___attribute] = ACTIONS(4339),
    [anon_sym_using] = ACTIONS(4339),
    [anon_sym_COLON_COLON] = ACTIONS(4337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4337),
    [anon_sym___declspec] = ACTIONS(4339),
    [anon_sym___based] = ACTIONS(4339),
    [anon_sym___cdecl] = ACTIONS(4339),
    [anon_sym___clrcall] = ACTIONS(4339),
    [anon_sym___stdcall] = ACTIONS(4339),
    [anon_sym___fastcall] = ACTIONS(4339),
    [anon_sym___thiscall] = ACTIONS(4339),
    [anon_sym___vectorcall] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4337),
    [anon_sym_signed] = ACTIONS(4339),
    [anon_sym_unsigned] = ACTIONS(4339),
    [anon_sym_long] = ACTIONS(4339),
    [anon_sym_short] = ACTIONS(4339),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_static] = ACTIONS(4339),
    [anon_sym_register] = ACTIONS(4339),
    [anon_sym_inline] = ACTIONS(4339),
    [anon_sym___inline] = ACTIONS(4339),
    [anon_sym___inline__] = ACTIONS(4339),
    [anon_sym___forceinline] = ACTIONS(4339),
    [anon_sym_thread_local] = ACTIONS(4339),
    [anon_sym___thread] = ACTIONS(4339),
    [anon_sym_const] = ACTIONS(4339),
    [anon_sym_constexpr] = ACTIONS(4339),
    [anon_sym_volatile] = ACTIONS(4339),
    [anon_sym_restrict] = ACTIONS(4339),
    [anon_sym___restrict__] = ACTIONS(4339),
    [anon_sym__Atomic] = ACTIONS(4339),
    [anon_sym__Noreturn] = ACTIONS(4339),
    [anon_sym_noreturn] = ACTIONS(4339),
    [anon_sym__Nonnull] = ACTIONS(4339),
    [anon_sym_mutable] = ACTIONS(4339),
    [anon_sym_constinit] = ACTIONS(4339),
    [anon_sym_consteval] = ACTIONS(4339),
    [anon_sym_alignas] = ACTIONS(4339),
    [anon_sym__Alignas] = ACTIONS(4339),
    [sym_primitive_type] = ACTIONS(4339),
    [anon_sym_enum] = ACTIONS(4339),
    [anon_sym_class] = ACTIONS(4339),
    [anon_sym_struct] = ACTIONS(4339),
    [anon_sym_union] = ACTIONS(4339),
    [anon_sym_if] = ACTIONS(4339),
    [anon_sym_switch] = ACTIONS(4339),
    [anon_sym_case] = ACTIONS(4339),
    [anon_sym_default] = ACTIONS(4339),
    [anon_sym_while] = ACTIONS(4339),
    [anon_sym_do] = ACTIONS(4339),
    [anon_sym_for] = ACTIONS(4339),
    [anon_sym_return] = ACTIONS(4339),
    [anon_sym_break] = ACTIONS(4339),
    [anon_sym_continue] = ACTIONS(4339),
    [anon_sym_goto] = ACTIONS(4339),
    [anon_sym_not] = ACTIONS(4339),
    [anon_sym_compl] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4337),
    [anon_sym_PLUS_PLUS] = ACTIONS(4337),
    [anon_sym_sizeof] = ACTIONS(4339),
    [anon_sym___alignof__] = ACTIONS(4339),
    [anon_sym___alignof] = ACTIONS(4339),
    [anon_sym__alignof] = ACTIONS(4339),
    [anon_sym_alignof] = ACTIONS(4339),
    [anon_sym__Alignof] = ACTIONS(4339),
    [anon_sym_offsetof] = ACTIONS(4339),
    [anon_sym__Generic] = ACTIONS(4339),
    [anon_sym_asm] = ACTIONS(4339),
    [anon_sym___asm__] = ACTIONS(4339),
    [anon_sym___asm] = ACTIONS(4339),
    [sym_number_literal] = ACTIONS(4337),
    [anon_sym_L_SQUOTE] = ACTIONS(4337),
    [anon_sym_u_SQUOTE] = ACTIONS(4337),
    [anon_sym_U_SQUOTE] = ACTIONS(4337),
    [anon_sym_u8_SQUOTE] = ACTIONS(4337),
    [anon_sym_SQUOTE] = ACTIONS(4337),
    [anon_sym_L_DQUOTE] = ACTIONS(4337),
    [anon_sym_u_DQUOTE] = ACTIONS(4337),
    [anon_sym_U_DQUOTE] = ACTIONS(4337),
    [anon_sym_u8_DQUOTE] = ACTIONS(4337),
    [anon_sym_DQUOTE] = ACTIONS(4337),
    [sym_true] = ACTIONS(4339),
    [sym_false] = ACTIONS(4339),
    [anon_sym_NULL] = ACTIONS(4339),
    [anon_sym_nullptr] = ACTIONS(4339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4339),
    [anon_sym_let] = ACTIONS(4339),
    [anon_sym_This] = ACTIONS(4339),
    [anon_sym_decltype] = ACTIONS(4339),
    [anon_sym_explicit] = ACTIONS(4339),
    [anon_sym_typename] = ACTIONS(4339),
    [anon_sym_export] = ACTIONS(4339),
    [anon_sym_module] = ACTIONS(4339),
    [anon_sym_import] = ACTIONS(4339),
    [anon_sym_template] = ACTIONS(4339),
    [anon_sym_operator] = ACTIONS(4339),
    [anon_sym_try] = ACTIONS(4339),
    [anon_sym_delete] = ACTIONS(4339),
    [anon_sym_throw] = ACTIONS(4339),
    [anon_sym_namespace] = ACTIONS(4339),
    [anon_sym_static_assert] = ACTIONS(4339),
    [anon_sym_concept] = ACTIONS(4339),
    [anon_sym_co_return] = ACTIONS(4339),
    [anon_sym_co_yield] = ACTIONS(4339),
    [anon_sym_R_DQUOTE] = ACTIONS(4337),
    [anon_sym_LR_DQUOTE] = ACTIONS(4337),
    [anon_sym_uR_DQUOTE] = ACTIONS(4337),
    [anon_sym_UR_DQUOTE] = ACTIONS(4337),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4337),
    [anon_sym_co_await] = ACTIONS(4339),
    [anon_sym_new] = ACTIONS(4339),
    [anon_sym_requires] = ACTIONS(4339),
    [sym_this] = ACTIONS(4339),
    [anon_sym_precise] = ACTIONS(4339),
    [anon_sym_shared] = ACTIONS(4339),
    [anon_sym_groupshared] = ACTIONS(4339),
    [anon_sym_uniform] = ACTIONS(4339),
    [anon_sym_row_major] = ACTIONS(4339),
    [anon_sym_column_major] = ACTIONS(4339),
    [anon_sym_globallycoherent] = ACTIONS(4339),
    [anon_sym_centroid] = ACTIONS(4339),
    [anon_sym_noperspective] = ACTIONS(4339),
    [anon_sym_nointerpolation] = ACTIONS(4339),
    [anon_sym_sample] = ACTIONS(4339),
    [anon_sym_linear] = ACTIONS(4339),
    [anon_sym_snorm] = ACTIONS(4339),
    [anon_sym_unorm] = ACTIONS(4339),
    [anon_sym_point] = ACTIONS(4339),
    [anon_sym_line] = ACTIONS(4339),
    [anon_sym_triangleadj] = ACTIONS(4339),
    [anon_sym_lineadj] = ACTIONS(4339),
    [anon_sym_triangle] = ACTIONS(4339),
    [anon_sym_interface] = ACTIONS(4339),
    [anon_sym_extension] = ACTIONS(4339),
    [anon_sym___exported] = ACTIONS(4339),
  },
  [1066] = {
    [ts_builtin_sym_end] = ACTIONS(3851),
    [sym_identifier] = ACTIONS(3849),
    [aux_sym_preproc_include_token1] = ACTIONS(3849),
    [aux_sym_preproc_def_token1] = ACTIONS(3849),
    [aux_sym_preproc_if_token1] = ACTIONS(3849),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3849),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3849),
    [sym_preproc_directive] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3851),
    [anon_sym_BANG] = ACTIONS(3851),
    [anon_sym_TILDE] = ACTIONS(3851),
    [anon_sym_DASH] = ACTIONS(3849),
    [anon_sym_PLUS] = ACTIONS(3849),
    [anon_sym_STAR] = ACTIONS(3851),
    [anon_sym_AMP_AMP] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3849),
    [anon_sym_SEMI] = ACTIONS(3851),
    [anon_sym___extension__] = ACTIONS(3849),
    [anon_sym_typedef] = ACTIONS(3849),
    [anon_sym_in] = ACTIONS(3849),
    [anon_sym_out] = ACTIONS(3849),
    [anon_sym_inout] = ACTIONS(3849),
    [anon_sym_virtual] = ACTIONS(3849),
    [anon_sym_extern] = ACTIONS(3849),
    [anon_sym___attribute__] = ACTIONS(3849),
    [anon_sym___attribute] = ACTIONS(3849),
    [anon_sym_using] = ACTIONS(3849),
    [anon_sym_COLON_COLON] = ACTIONS(3851),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3851),
    [anon_sym___declspec] = ACTIONS(3849),
    [anon_sym___based] = ACTIONS(3849),
    [anon_sym___cdecl] = ACTIONS(3849),
    [anon_sym___clrcall] = ACTIONS(3849),
    [anon_sym___stdcall] = ACTIONS(3849),
    [anon_sym___fastcall] = ACTIONS(3849),
    [anon_sym___thiscall] = ACTIONS(3849),
    [anon_sym___vectorcall] = ACTIONS(3849),
    [anon_sym_LBRACE] = ACTIONS(3851),
    [anon_sym_signed] = ACTIONS(3849),
    [anon_sym_unsigned] = ACTIONS(3849),
    [anon_sym_long] = ACTIONS(3849),
    [anon_sym_short] = ACTIONS(3849),
    [anon_sym_LBRACK] = ACTIONS(3849),
    [anon_sym_static] = ACTIONS(3849),
    [anon_sym_register] = ACTIONS(3849),
    [anon_sym_inline] = ACTIONS(3849),
    [anon_sym___inline] = ACTIONS(3849),
    [anon_sym___inline__] = ACTIONS(3849),
    [anon_sym___forceinline] = ACTIONS(3849),
    [anon_sym_thread_local] = ACTIONS(3849),
    [anon_sym___thread] = ACTIONS(3849),
    [anon_sym_const] = ACTIONS(3849),
    [anon_sym_constexpr] = ACTIONS(3849),
    [anon_sym_volatile] = ACTIONS(3849),
    [anon_sym_restrict] = ACTIONS(3849),
    [anon_sym___restrict__] = ACTIONS(3849),
    [anon_sym__Atomic] = ACTIONS(3849),
    [anon_sym__Noreturn] = ACTIONS(3849),
    [anon_sym_noreturn] = ACTIONS(3849),
    [anon_sym__Nonnull] = ACTIONS(3849),
    [anon_sym_mutable] = ACTIONS(3849),
    [anon_sym_constinit] = ACTIONS(3849),
    [anon_sym_consteval] = ACTIONS(3849),
    [anon_sym_alignas] = ACTIONS(3849),
    [anon_sym__Alignas] = ACTIONS(3849),
    [sym_primitive_type] = ACTIONS(3849),
    [anon_sym_enum] = ACTIONS(3849),
    [anon_sym_class] = ACTIONS(3849),
    [anon_sym_struct] = ACTIONS(3849),
    [anon_sym_union] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3849),
    [anon_sym_switch] = ACTIONS(3849),
    [anon_sym_case] = ACTIONS(3849),
    [anon_sym_default] = ACTIONS(3849),
    [anon_sym_while] = ACTIONS(3849),
    [anon_sym_do] = ACTIONS(3849),
    [anon_sym_for] = ACTIONS(3849),
    [anon_sym_return] = ACTIONS(3849),
    [anon_sym_break] = ACTIONS(3849),
    [anon_sym_continue] = ACTIONS(3849),
    [anon_sym_goto] = ACTIONS(3849),
    [anon_sym_not] = ACTIONS(3849),
    [anon_sym_compl] = ACTIONS(3849),
    [anon_sym_DASH_DASH] = ACTIONS(3851),
    [anon_sym_PLUS_PLUS] = ACTIONS(3851),
    [anon_sym_sizeof] = ACTIONS(3849),
    [anon_sym___alignof__] = ACTIONS(3849),
    [anon_sym___alignof] = ACTIONS(3849),
    [anon_sym__alignof] = ACTIONS(3849),
    [anon_sym_alignof] = ACTIONS(3849),
    [anon_sym__Alignof] = ACTIONS(3849),
    [anon_sym_offsetof] = ACTIONS(3849),
    [anon_sym__Generic] = ACTIONS(3849),
    [anon_sym_asm] = ACTIONS(3849),
    [anon_sym___asm__] = ACTIONS(3849),
    [anon_sym___asm] = ACTIONS(3849),
    [sym_number_literal] = ACTIONS(3851),
    [anon_sym_L_SQUOTE] = ACTIONS(3851),
    [anon_sym_u_SQUOTE] = ACTIONS(3851),
    [anon_sym_U_SQUOTE] = ACTIONS(3851),
    [anon_sym_u8_SQUOTE] = ACTIONS(3851),
    [anon_sym_SQUOTE] = ACTIONS(3851),
    [anon_sym_L_DQUOTE] = ACTIONS(3851),
    [anon_sym_u_DQUOTE] = ACTIONS(3851),
    [anon_sym_U_DQUOTE] = ACTIONS(3851),
    [anon_sym_u8_DQUOTE] = ACTIONS(3851),
    [anon_sym_DQUOTE] = ACTIONS(3851),
    [sym_true] = ACTIONS(3849),
    [sym_false] = ACTIONS(3849),
    [anon_sym_NULL] = ACTIONS(3849),
    [anon_sym_nullptr] = ACTIONS(3849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3849),
    [anon_sym_let] = ACTIONS(3849),
    [anon_sym_This] = ACTIONS(3849),
    [anon_sym_decltype] = ACTIONS(3849),
    [anon_sym_explicit] = ACTIONS(3849),
    [anon_sym_typename] = ACTIONS(3849),
    [anon_sym_export] = ACTIONS(3849),
    [anon_sym_module] = ACTIONS(3849),
    [anon_sym_import] = ACTIONS(3849),
    [anon_sym_template] = ACTIONS(3849),
    [anon_sym_operator] = ACTIONS(3849),
    [anon_sym_try] = ACTIONS(3849),
    [anon_sym_delete] = ACTIONS(3849),
    [anon_sym_throw] = ACTIONS(3849),
    [anon_sym_namespace] = ACTIONS(3849),
    [anon_sym_static_assert] = ACTIONS(3849),
    [anon_sym_concept] = ACTIONS(3849),
    [anon_sym_co_return] = ACTIONS(3849),
    [anon_sym_co_yield] = ACTIONS(3849),
    [anon_sym_R_DQUOTE] = ACTIONS(3851),
    [anon_sym_LR_DQUOTE] = ACTIONS(3851),
    [anon_sym_uR_DQUOTE] = ACTIONS(3851),
    [anon_sym_UR_DQUOTE] = ACTIONS(3851),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3851),
    [anon_sym_co_await] = ACTIONS(3849),
    [anon_sym_new] = ACTIONS(3849),
    [anon_sym_requires] = ACTIONS(3849),
    [sym_this] = ACTIONS(3849),
    [anon_sym_precise] = ACTIONS(3849),
    [anon_sym_shared] = ACTIONS(3849),
    [anon_sym_groupshared] = ACTIONS(3849),
    [anon_sym_uniform] = ACTIONS(3849),
    [anon_sym_row_major] = ACTIONS(3849),
    [anon_sym_column_major] = ACTIONS(3849),
    [anon_sym_globallycoherent] = ACTIONS(3849),
    [anon_sym_centroid] = ACTIONS(3849),
    [anon_sym_noperspective] = ACTIONS(3849),
    [anon_sym_nointerpolation] = ACTIONS(3849),
    [anon_sym_sample] = ACTIONS(3849),
    [anon_sym_linear] = ACTIONS(3849),
    [anon_sym_snorm] = ACTIONS(3849),
    [anon_sym_unorm] = ACTIONS(3849),
    [anon_sym_point] = ACTIONS(3849),
    [anon_sym_line] = ACTIONS(3849),
    [anon_sym_triangleadj] = ACTIONS(3849),
    [anon_sym_lineadj] = ACTIONS(3849),
    [anon_sym_triangle] = ACTIONS(3849),
    [anon_sym_interface] = ACTIONS(3849),
    [anon_sym_extension] = ACTIONS(3849),
    [anon_sym___exported] = ACTIONS(3849),
  },
  [1067] = {
    [ts_builtin_sym_end] = ACTIONS(4341),
    [sym_identifier] = ACTIONS(4343),
    [aux_sym_preproc_include_token1] = ACTIONS(4343),
    [aux_sym_preproc_def_token1] = ACTIONS(4343),
    [aux_sym_preproc_if_token1] = ACTIONS(4343),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4343),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4343),
    [sym_preproc_directive] = ACTIONS(4343),
    [anon_sym_LPAREN2] = ACTIONS(4341),
    [anon_sym_BANG] = ACTIONS(4341),
    [anon_sym_TILDE] = ACTIONS(4341),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4341),
    [anon_sym_AMP_AMP] = ACTIONS(4341),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_SEMI] = ACTIONS(4341),
    [anon_sym___extension__] = ACTIONS(4343),
    [anon_sym_typedef] = ACTIONS(4343),
    [anon_sym_in] = ACTIONS(4343),
    [anon_sym_out] = ACTIONS(4343),
    [anon_sym_inout] = ACTIONS(4343),
    [anon_sym_virtual] = ACTIONS(4343),
    [anon_sym_extern] = ACTIONS(4343),
    [anon_sym___attribute__] = ACTIONS(4343),
    [anon_sym___attribute] = ACTIONS(4343),
    [anon_sym_using] = ACTIONS(4343),
    [anon_sym_COLON_COLON] = ACTIONS(4341),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4341),
    [anon_sym___declspec] = ACTIONS(4343),
    [anon_sym___based] = ACTIONS(4343),
    [anon_sym___cdecl] = ACTIONS(4343),
    [anon_sym___clrcall] = ACTIONS(4343),
    [anon_sym___stdcall] = ACTIONS(4343),
    [anon_sym___fastcall] = ACTIONS(4343),
    [anon_sym___thiscall] = ACTIONS(4343),
    [anon_sym___vectorcall] = ACTIONS(4343),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_signed] = ACTIONS(4343),
    [anon_sym_unsigned] = ACTIONS(4343),
    [anon_sym_long] = ACTIONS(4343),
    [anon_sym_short] = ACTIONS(4343),
    [anon_sym_LBRACK] = ACTIONS(4343),
    [anon_sym_static] = ACTIONS(4343),
    [anon_sym_register] = ACTIONS(4343),
    [anon_sym_inline] = ACTIONS(4343),
    [anon_sym___inline] = ACTIONS(4343),
    [anon_sym___inline__] = ACTIONS(4343),
    [anon_sym___forceinline] = ACTIONS(4343),
    [anon_sym_thread_local] = ACTIONS(4343),
    [anon_sym___thread] = ACTIONS(4343),
    [anon_sym_const] = ACTIONS(4343),
    [anon_sym_constexpr] = ACTIONS(4343),
    [anon_sym_volatile] = ACTIONS(4343),
    [anon_sym_restrict] = ACTIONS(4343),
    [anon_sym___restrict__] = ACTIONS(4343),
    [anon_sym__Atomic] = ACTIONS(4343),
    [anon_sym__Noreturn] = ACTIONS(4343),
    [anon_sym_noreturn] = ACTIONS(4343),
    [anon_sym__Nonnull] = ACTIONS(4343),
    [anon_sym_mutable] = ACTIONS(4343),
    [anon_sym_constinit] = ACTIONS(4343),
    [anon_sym_consteval] = ACTIONS(4343),
    [anon_sym_alignas] = ACTIONS(4343),
    [anon_sym__Alignas] = ACTIONS(4343),
    [sym_primitive_type] = ACTIONS(4343),
    [anon_sym_enum] = ACTIONS(4343),
    [anon_sym_class] = ACTIONS(4343),
    [anon_sym_struct] = ACTIONS(4343),
    [anon_sym_union] = ACTIONS(4343),
    [anon_sym_if] = ACTIONS(4343),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_case] = ACTIONS(4343),
    [anon_sym_default] = ACTIONS(4343),
    [anon_sym_while] = ACTIONS(4343),
    [anon_sym_do] = ACTIONS(4343),
    [anon_sym_for] = ACTIONS(4343),
    [anon_sym_return] = ACTIONS(4343),
    [anon_sym_break] = ACTIONS(4343),
    [anon_sym_continue] = ACTIONS(4343),
    [anon_sym_goto] = ACTIONS(4343),
    [anon_sym_not] = ACTIONS(4343),
    [anon_sym_compl] = ACTIONS(4343),
    [anon_sym_DASH_DASH] = ACTIONS(4341),
    [anon_sym_PLUS_PLUS] = ACTIONS(4341),
    [anon_sym_sizeof] = ACTIONS(4343),
    [anon_sym___alignof__] = ACTIONS(4343),
    [anon_sym___alignof] = ACTIONS(4343),
    [anon_sym__alignof] = ACTIONS(4343),
    [anon_sym_alignof] = ACTIONS(4343),
    [anon_sym__Alignof] = ACTIONS(4343),
    [anon_sym_offsetof] = ACTIONS(4343),
    [anon_sym__Generic] = ACTIONS(4343),
    [anon_sym_asm] = ACTIONS(4343),
    [anon_sym___asm__] = ACTIONS(4343),
    [anon_sym___asm] = ACTIONS(4343),
    [sym_number_literal] = ACTIONS(4341),
    [anon_sym_L_SQUOTE] = ACTIONS(4341),
    [anon_sym_u_SQUOTE] = ACTIONS(4341),
    [anon_sym_U_SQUOTE] = ACTIONS(4341),
    [anon_sym_u8_SQUOTE] = ACTIONS(4341),
    [anon_sym_SQUOTE] = ACTIONS(4341),
    [anon_sym_L_DQUOTE] = ACTIONS(4341),
    [anon_sym_u_DQUOTE] = ACTIONS(4341),
    [anon_sym_U_DQUOTE] = ACTIONS(4341),
    [anon_sym_u8_DQUOTE] = ACTIONS(4341),
    [anon_sym_DQUOTE] = ACTIONS(4341),
    [sym_true] = ACTIONS(4343),
    [sym_false] = ACTIONS(4343),
    [anon_sym_NULL] = ACTIONS(4343),
    [anon_sym_nullptr] = ACTIONS(4343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4343),
    [anon_sym_let] = ACTIONS(4343),
    [anon_sym_This] = ACTIONS(4343),
    [anon_sym_decltype] = ACTIONS(4343),
    [anon_sym_explicit] = ACTIONS(4343),
    [anon_sym_typename] = ACTIONS(4343),
    [anon_sym_export] = ACTIONS(4343),
    [anon_sym_module] = ACTIONS(4343),
    [anon_sym_import] = ACTIONS(4343),
    [anon_sym_template] = ACTIONS(4343),
    [anon_sym_operator] = ACTIONS(4343),
    [anon_sym_try] = ACTIONS(4343),
    [anon_sym_delete] = ACTIONS(4343),
    [anon_sym_throw] = ACTIONS(4343),
    [anon_sym_namespace] = ACTIONS(4343),
    [anon_sym_static_assert] = ACTIONS(4343),
    [anon_sym_concept] = ACTIONS(4343),
    [anon_sym_co_return] = ACTIONS(4343),
    [anon_sym_co_yield] = ACTIONS(4343),
    [anon_sym_R_DQUOTE] = ACTIONS(4341),
    [anon_sym_LR_DQUOTE] = ACTIONS(4341),
    [anon_sym_uR_DQUOTE] = ACTIONS(4341),
    [anon_sym_UR_DQUOTE] = ACTIONS(4341),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4341),
    [anon_sym_co_await] = ACTIONS(4343),
    [anon_sym_new] = ACTIONS(4343),
    [anon_sym_requires] = ACTIONS(4343),
    [sym_this] = ACTIONS(4343),
    [anon_sym_precise] = ACTIONS(4343),
    [anon_sym_shared] = ACTIONS(4343),
    [anon_sym_groupshared] = ACTIONS(4343),
    [anon_sym_uniform] = ACTIONS(4343),
    [anon_sym_row_major] = ACTIONS(4343),
    [anon_sym_column_major] = ACTIONS(4343),
    [anon_sym_globallycoherent] = ACTIONS(4343),
    [anon_sym_centroid] = ACTIONS(4343),
    [anon_sym_noperspective] = ACTIONS(4343),
    [anon_sym_nointerpolation] = ACTIONS(4343),
    [anon_sym_sample] = ACTIONS(4343),
    [anon_sym_linear] = ACTIONS(4343),
    [anon_sym_snorm] = ACTIONS(4343),
    [anon_sym_unorm] = ACTIONS(4343),
    [anon_sym_point] = ACTIONS(4343),
    [anon_sym_line] = ACTIONS(4343),
    [anon_sym_triangleadj] = ACTIONS(4343),
    [anon_sym_lineadj] = ACTIONS(4343),
    [anon_sym_triangle] = ACTIONS(4343),
    [anon_sym_interface] = ACTIONS(4343),
    [anon_sym_extension] = ACTIONS(4343),
    [anon_sym___exported] = ACTIONS(4343),
  },
  [1068] = {
    [ts_builtin_sym_end] = ACTIONS(3847),
    [sym_identifier] = ACTIONS(3845),
    [aux_sym_preproc_include_token1] = ACTIONS(3845),
    [aux_sym_preproc_def_token1] = ACTIONS(3845),
    [aux_sym_preproc_if_token1] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3845),
    [sym_preproc_directive] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3847),
    [anon_sym_BANG] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_STAR] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_SEMI] = ACTIONS(3847),
    [anon_sym___extension__] = ACTIONS(3845),
    [anon_sym_typedef] = ACTIONS(3845),
    [anon_sym_in] = ACTIONS(3845),
    [anon_sym_out] = ACTIONS(3845),
    [anon_sym_inout] = ACTIONS(3845),
    [anon_sym_virtual] = ACTIONS(3845),
    [anon_sym_extern] = ACTIONS(3845),
    [anon_sym___attribute__] = ACTIONS(3845),
    [anon_sym___attribute] = ACTIONS(3845),
    [anon_sym_using] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3847),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3847),
    [anon_sym___declspec] = ACTIONS(3845),
    [anon_sym___based] = ACTIONS(3845),
    [anon_sym___cdecl] = ACTIONS(3845),
    [anon_sym___clrcall] = ACTIONS(3845),
    [anon_sym___stdcall] = ACTIONS(3845),
    [anon_sym___fastcall] = ACTIONS(3845),
    [anon_sym___thiscall] = ACTIONS(3845),
    [anon_sym___vectorcall] = ACTIONS(3845),
    [anon_sym_LBRACE] = ACTIONS(3847),
    [anon_sym_signed] = ACTIONS(3845),
    [anon_sym_unsigned] = ACTIONS(3845),
    [anon_sym_long] = ACTIONS(3845),
    [anon_sym_short] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_static] = ACTIONS(3845),
    [anon_sym_register] = ACTIONS(3845),
    [anon_sym_inline] = ACTIONS(3845),
    [anon_sym___inline] = ACTIONS(3845),
    [anon_sym___inline__] = ACTIONS(3845),
    [anon_sym___forceinline] = ACTIONS(3845),
    [anon_sym_thread_local] = ACTIONS(3845),
    [anon_sym___thread] = ACTIONS(3845),
    [anon_sym_const] = ACTIONS(3845),
    [anon_sym_constexpr] = ACTIONS(3845),
    [anon_sym_volatile] = ACTIONS(3845),
    [anon_sym_restrict] = ACTIONS(3845),
    [anon_sym___restrict__] = ACTIONS(3845),
    [anon_sym__Atomic] = ACTIONS(3845),
    [anon_sym__Noreturn] = ACTIONS(3845),
    [anon_sym_noreturn] = ACTIONS(3845),
    [anon_sym__Nonnull] = ACTIONS(3845),
    [anon_sym_mutable] = ACTIONS(3845),
    [anon_sym_constinit] = ACTIONS(3845),
    [anon_sym_consteval] = ACTIONS(3845),
    [anon_sym_alignas] = ACTIONS(3845),
    [anon_sym__Alignas] = ACTIONS(3845),
    [sym_primitive_type] = ACTIONS(3845),
    [anon_sym_enum] = ACTIONS(3845),
    [anon_sym_class] = ACTIONS(3845),
    [anon_sym_struct] = ACTIONS(3845),
    [anon_sym_union] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_switch] = ACTIONS(3845),
    [anon_sym_case] = ACTIONS(3845),
    [anon_sym_default] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_break] = ACTIONS(3845),
    [anon_sym_continue] = ACTIONS(3845),
    [anon_sym_goto] = ACTIONS(3845),
    [anon_sym_not] = ACTIONS(3845),
    [anon_sym_compl] = ACTIONS(3845),
    [anon_sym_DASH_DASH] = ACTIONS(3847),
    [anon_sym_PLUS_PLUS] = ACTIONS(3847),
    [anon_sym_sizeof] = ACTIONS(3845),
    [anon_sym___alignof__] = ACTIONS(3845),
    [anon_sym___alignof] = ACTIONS(3845),
    [anon_sym__alignof] = ACTIONS(3845),
    [anon_sym_alignof] = ACTIONS(3845),
    [anon_sym__Alignof] = ACTIONS(3845),
    [anon_sym_offsetof] = ACTIONS(3845),
    [anon_sym__Generic] = ACTIONS(3845),
    [anon_sym_asm] = ACTIONS(3845),
    [anon_sym___asm__] = ACTIONS(3845),
    [anon_sym___asm] = ACTIONS(3845),
    [sym_number_literal] = ACTIONS(3847),
    [anon_sym_L_SQUOTE] = ACTIONS(3847),
    [anon_sym_u_SQUOTE] = ACTIONS(3847),
    [anon_sym_U_SQUOTE] = ACTIONS(3847),
    [anon_sym_u8_SQUOTE] = ACTIONS(3847),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [anon_sym_L_DQUOTE] = ACTIONS(3847),
    [anon_sym_u_DQUOTE] = ACTIONS(3847),
    [anon_sym_U_DQUOTE] = ACTIONS(3847),
    [anon_sym_u8_DQUOTE] = ACTIONS(3847),
    [anon_sym_DQUOTE] = ACTIONS(3847),
    [sym_true] = ACTIONS(3845),
    [sym_false] = ACTIONS(3845),
    [anon_sym_NULL] = ACTIONS(3845),
    [anon_sym_nullptr] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_This] = ACTIONS(3845),
    [anon_sym_decltype] = ACTIONS(3845),
    [anon_sym_explicit] = ACTIONS(3845),
    [anon_sym_typename] = ACTIONS(3845),
    [anon_sym_export] = ACTIONS(3845),
    [anon_sym_module] = ACTIONS(3845),
    [anon_sym_import] = ACTIONS(3845),
    [anon_sym_template] = ACTIONS(3845),
    [anon_sym_operator] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_delete] = ACTIONS(3845),
    [anon_sym_throw] = ACTIONS(3845),
    [anon_sym_namespace] = ACTIONS(3845),
    [anon_sym_static_assert] = ACTIONS(3845),
    [anon_sym_concept] = ACTIONS(3845),
    [anon_sym_co_return] = ACTIONS(3845),
    [anon_sym_co_yield] = ACTIONS(3845),
    [anon_sym_R_DQUOTE] = ACTIONS(3847),
    [anon_sym_LR_DQUOTE] = ACTIONS(3847),
    [anon_sym_uR_DQUOTE] = ACTIONS(3847),
    [anon_sym_UR_DQUOTE] = ACTIONS(3847),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3847),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_requires] = ACTIONS(3845),
    [sym_this] = ACTIONS(3845),
    [anon_sym_precise] = ACTIONS(3845),
    [anon_sym_shared] = ACTIONS(3845),
    [anon_sym_groupshared] = ACTIONS(3845),
    [anon_sym_uniform] = ACTIONS(3845),
    [anon_sym_row_major] = ACTIONS(3845),
    [anon_sym_column_major] = ACTIONS(3845),
    [anon_sym_globallycoherent] = ACTIONS(3845),
    [anon_sym_centroid] = ACTIONS(3845),
    [anon_sym_noperspective] = ACTIONS(3845),
    [anon_sym_nointerpolation] = ACTIONS(3845),
    [anon_sym_sample] = ACTIONS(3845),
    [anon_sym_linear] = ACTIONS(3845),
    [anon_sym_snorm] = ACTIONS(3845),
    [anon_sym_unorm] = ACTIONS(3845),
    [anon_sym_point] = ACTIONS(3845),
    [anon_sym_line] = ACTIONS(3845),
    [anon_sym_triangleadj] = ACTIONS(3845),
    [anon_sym_lineadj] = ACTIONS(3845),
    [anon_sym_triangle] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3845),
    [anon_sym_extension] = ACTIONS(3845),
    [anon_sym___exported] = ACTIONS(3845),
  },
  [1069] = {
    [ts_builtin_sym_end] = ACTIONS(3847),
    [sym_identifier] = ACTIONS(3845),
    [aux_sym_preproc_include_token1] = ACTIONS(3845),
    [aux_sym_preproc_def_token1] = ACTIONS(3845),
    [aux_sym_preproc_if_token1] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3845),
    [sym_preproc_directive] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3847),
    [anon_sym_BANG] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_STAR] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_SEMI] = ACTIONS(3847),
    [anon_sym___extension__] = ACTIONS(3845),
    [anon_sym_typedef] = ACTIONS(3845),
    [anon_sym_in] = ACTIONS(3845),
    [anon_sym_out] = ACTIONS(3845),
    [anon_sym_inout] = ACTIONS(3845),
    [anon_sym_virtual] = ACTIONS(3845),
    [anon_sym_extern] = ACTIONS(3845),
    [anon_sym___attribute__] = ACTIONS(3845),
    [anon_sym___attribute] = ACTIONS(3845),
    [anon_sym_using] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3847),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3847),
    [anon_sym___declspec] = ACTIONS(3845),
    [anon_sym___based] = ACTIONS(3845),
    [anon_sym___cdecl] = ACTIONS(3845),
    [anon_sym___clrcall] = ACTIONS(3845),
    [anon_sym___stdcall] = ACTIONS(3845),
    [anon_sym___fastcall] = ACTIONS(3845),
    [anon_sym___thiscall] = ACTIONS(3845),
    [anon_sym___vectorcall] = ACTIONS(3845),
    [anon_sym_LBRACE] = ACTIONS(3847),
    [anon_sym_signed] = ACTIONS(3845),
    [anon_sym_unsigned] = ACTIONS(3845),
    [anon_sym_long] = ACTIONS(3845),
    [anon_sym_short] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_static] = ACTIONS(3845),
    [anon_sym_register] = ACTIONS(3845),
    [anon_sym_inline] = ACTIONS(3845),
    [anon_sym___inline] = ACTIONS(3845),
    [anon_sym___inline__] = ACTIONS(3845),
    [anon_sym___forceinline] = ACTIONS(3845),
    [anon_sym_thread_local] = ACTIONS(3845),
    [anon_sym___thread] = ACTIONS(3845),
    [anon_sym_const] = ACTIONS(3845),
    [anon_sym_constexpr] = ACTIONS(3845),
    [anon_sym_volatile] = ACTIONS(3845),
    [anon_sym_restrict] = ACTIONS(3845),
    [anon_sym___restrict__] = ACTIONS(3845),
    [anon_sym__Atomic] = ACTIONS(3845),
    [anon_sym__Noreturn] = ACTIONS(3845),
    [anon_sym_noreturn] = ACTIONS(3845),
    [anon_sym__Nonnull] = ACTIONS(3845),
    [anon_sym_mutable] = ACTIONS(3845),
    [anon_sym_constinit] = ACTIONS(3845),
    [anon_sym_consteval] = ACTIONS(3845),
    [anon_sym_alignas] = ACTIONS(3845),
    [anon_sym__Alignas] = ACTIONS(3845),
    [sym_primitive_type] = ACTIONS(3845),
    [anon_sym_enum] = ACTIONS(3845),
    [anon_sym_class] = ACTIONS(3845),
    [anon_sym_struct] = ACTIONS(3845),
    [anon_sym_union] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_switch] = ACTIONS(3845),
    [anon_sym_case] = ACTIONS(3845),
    [anon_sym_default] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_break] = ACTIONS(3845),
    [anon_sym_continue] = ACTIONS(3845),
    [anon_sym_goto] = ACTIONS(3845),
    [anon_sym_not] = ACTIONS(3845),
    [anon_sym_compl] = ACTIONS(3845),
    [anon_sym_DASH_DASH] = ACTIONS(3847),
    [anon_sym_PLUS_PLUS] = ACTIONS(3847),
    [anon_sym_sizeof] = ACTIONS(3845),
    [anon_sym___alignof__] = ACTIONS(3845),
    [anon_sym___alignof] = ACTIONS(3845),
    [anon_sym__alignof] = ACTIONS(3845),
    [anon_sym_alignof] = ACTIONS(3845),
    [anon_sym__Alignof] = ACTIONS(3845),
    [anon_sym_offsetof] = ACTIONS(3845),
    [anon_sym__Generic] = ACTIONS(3845),
    [anon_sym_asm] = ACTIONS(3845),
    [anon_sym___asm__] = ACTIONS(3845),
    [anon_sym___asm] = ACTIONS(3845),
    [sym_number_literal] = ACTIONS(3847),
    [anon_sym_L_SQUOTE] = ACTIONS(3847),
    [anon_sym_u_SQUOTE] = ACTIONS(3847),
    [anon_sym_U_SQUOTE] = ACTIONS(3847),
    [anon_sym_u8_SQUOTE] = ACTIONS(3847),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [anon_sym_L_DQUOTE] = ACTIONS(3847),
    [anon_sym_u_DQUOTE] = ACTIONS(3847),
    [anon_sym_U_DQUOTE] = ACTIONS(3847),
    [anon_sym_u8_DQUOTE] = ACTIONS(3847),
    [anon_sym_DQUOTE] = ACTIONS(3847),
    [sym_true] = ACTIONS(3845),
    [sym_false] = ACTIONS(3845),
    [anon_sym_NULL] = ACTIONS(3845),
    [anon_sym_nullptr] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_This] = ACTIONS(3845),
    [anon_sym_decltype] = ACTIONS(3845),
    [anon_sym_explicit] = ACTIONS(3845),
    [anon_sym_typename] = ACTIONS(3845),
    [anon_sym_export] = ACTIONS(3845),
    [anon_sym_module] = ACTIONS(3845),
    [anon_sym_import] = ACTIONS(3845),
    [anon_sym_template] = ACTIONS(3845),
    [anon_sym_operator] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_delete] = ACTIONS(3845),
    [anon_sym_throw] = ACTIONS(3845),
    [anon_sym_namespace] = ACTIONS(3845),
    [anon_sym_static_assert] = ACTIONS(3845),
    [anon_sym_concept] = ACTIONS(3845),
    [anon_sym_co_return] = ACTIONS(3845),
    [anon_sym_co_yield] = ACTIONS(3845),
    [anon_sym_R_DQUOTE] = ACTIONS(3847),
    [anon_sym_LR_DQUOTE] = ACTIONS(3847),
    [anon_sym_uR_DQUOTE] = ACTIONS(3847),
    [anon_sym_UR_DQUOTE] = ACTIONS(3847),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3847),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_requires] = ACTIONS(3845),
    [sym_this] = ACTIONS(3845),
    [anon_sym_precise] = ACTIONS(3845),
    [anon_sym_shared] = ACTIONS(3845),
    [anon_sym_groupshared] = ACTIONS(3845),
    [anon_sym_uniform] = ACTIONS(3845),
    [anon_sym_row_major] = ACTIONS(3845),
    [anon_sym_column_major] = ACTIONS(3845),
    [anon_sym_globallycoherent] = ACTIONS(3845),
    [anon_sym_centroid] = ACTIONS(3845),
    [anon_sym_noperspective] = ACTIONS(3845),
    [anon_sym_nointerpolation] = ACTIONS(3845),
    [anon_sym_sample] = ACTIONS(3845),
    [anon_sym_linear] = ACTIONS(3845),
    [anon_sym_snorm] = ACTIONS(3845),
    [anon_sym_unorm] = ACTIONS(3845),
    [anon_sym_point] = ACTIONS(3845),
    [anon_sym_line] = ACTIONS(3845),
    [anon_sym_triangleadj] = ACTIONS(3845),
    [anon_sym_lineadj] = ACTIONS(3845),
    [anon_sym_triangle] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3845),
    [anon_sym_extension] = ACTIONS(3845),
    [anon_sym___exported] = ACTIONS(3845),
  },
  [1070] = {
    [sym_identifier] = ACTIONS(3901),
    [aux_sym_preproc_include_token1] = ACTIONS(3901),
    [aux_sym_preproc_def_token1] = ACTIONS(3901),
    [aux_sym_preproc_if_token1] = ACTIONS(3901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3901),
    [sym_preproc_directive] = ACTIONS(3901),
    [anon_sym_LPAREN2] = ACTIONS(3903),
    [anon_sym_BANG] = ACTIONS(3903),
    [anon_sym_TILDE] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3901),
    [anon_sym_STAR] = ACTIONS(3903),
    [anon_sym_AMP_AMP] = ACTIONS(3903),
    [anon_sym_AMP] = ACTIONS(3901),
    [anon_sym_SEMI] = ACTIONS(3903),
    [anon_sym___extension__] = ACTIONS(3901),
    [anon_sym_typedef] = ACTIONS(3901),
    [anon_sym_in] = ACTIONS(3901),
    [anon_sym_out] = ACTIONS(3901),
    [anon_sym_inout] = ACTIONS(3901),
    [anon_sym_virtual] = ACTIONS(3901),
    [anon_sym_extern] = ACTIONS(3901),
    [anon_sym___attribute__] = ACTIONS(3901),
    [anon_sym___attribute] = ACTIONS(3901),
    [anon_sym_using] = ACTIONS(3901),
    [anon_sym_COLON_COLON] = ACTIONS(3903),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3903),
    [anon_sym___declspec] = ACTIONS(3901),
    [anon_sym___based] = ACTIONS(3901),
    [anon_sym___cdecl] = ACTIONS(3901),
    [anon_sym___clrcall] = ACTIONS(3901),
    [anon_sym___stdcall] = ACTIONS(3901),
    [anon_sym___fastcall] = ACTIONS(3901),
    [anon_sym___thiscall] = ACTIONS(3901),
    [anon_sym___vectorcall] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_RBRACE] = ACTIONS(3903),
    [anon_sym_signed] = ACTIONS(3901),
    [anon_sym_unsigned] = ACTIONS(3901),
    [anon_sym_long] = ACTIONS(3901),
    [anon_sym_short] = ACTIONS(3901),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_static] = ACTIONS(3901),
    [anon_sym_register] = ACTIONS(3901),
    [anon_sym_inline] = ACTIONS(3901),
    [anon_sym___inline] = ACTIONS(3901),
    [anon_sym___inline__] = ACTIONS(3901),
    [anon_sym___forceinline] = ACTIONS(3901),
    [anon_sym_thread_local] = ACTIONS(3901),
    [anon_sym___thread] = ACTIONS(3901),
    [anon_sym_const] = ACTIONS(3901),
    [anon_sym_constexpr] = ACTIONS(3901),
    [anon_sym_volatile] = ACTIONS(3901),
    [anon_sym_restrict] = ACTIONS(3901),
    [anon_sym___restrict__] = ACTIONS(3901),
    [anon_sym__Atomic] = ACTIONS(3901),
    [anon_sym__Noreturn] = ACTIONS(3901),
    [anon_sym_noreturn] = ACTIONS(3901),
    [anon_sym__Nonnull] = ACTIONS(3901),
    [anon_sym_mutable] = ACTIONS(3901),
    [anon_sym_constinit] = ACTIONS(3901),
    [anon_sym_consteval] = ACTIONS(3901),
    [anon_sym_alignas] = ACTIONS(3901),
    [anon_sym__Alignas] = ACTIONS(3901),
    [sym_primitive_type] = ACTIONS(3901),
    [anon_sym_enum] = ACTIONS(3901),
    [anon_sym_class] = ACTIONS(3901),
    [anon_sym_struct] = ACTIONS(3901),
    [anon_sym_union] = ACTIONS(3901),
    [anon_sym_if] = ACTIONS(3901),
    [anon_sym_switch] = ACTIONS(3901),
    [anon_sym_case] = ACTIONS(3901),
    [anon_sym_default] = ACTIONS(3901),
    [anon_sym_while] = ACTIONS(3901),
    [anon_sym_do] = ACTIONS(3901),
    [anon_sym_for] = ACTIONS(3901),
    [anon_sym_return] = ACTIONS(3901),
    [anon_sym_break] = ACTIONS(3901),
    [anon_sym_continue] = ACTIONS(3901),
    [anon_sym_goto] = ACTIONS(3901),
    [anon_sym___try] = ACTIONS(3901),
    [anon_sym___leave] = ACTIONS(3901),
    [anon_sym_not] = ACTIONS(3901),
    [anon_sym_compl] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3903),
    [anon_sym_PLUS_PLUS] = ACTIONS(3903),
    [anon_sym_sizeof] = ACTIONS(3901),
    [anon_sym___alignof__] = ACTIONS(3901),
    [anon_sym___alignof] = ACTIONS(3901),
    [anon_sym__alignof] = ACTIONS(3901),
    [anon_sym_alignof] = ACTIONS(3901),
    [anon_sym__Alignof] = ACTIONS(3901),
    [anon_sym_offsetof] = ACTIONS(3901),
    [anon_sym__Generic] = ACTIONS(3901),
    [anon_sym_asm] = ACTIONS(3901),
    [anon_sym___asm__] = ACTIONS(3901),
    [anon_sym___asm] = ACTIONS(3901),
    [sym_number_literal] = ACTIONS(3903),
    [anon_sym_L_SQUOTE] = ACTIONS(3903),
    [anon_sym_u_SQUOTE] = ACTIONS(3903),
    [anon_sym_U_SQUOTE] = ACTIONS(3903),
    [anon_sym_u8_SQUOTE] = ACTIONS(3903),
    [anon_sym_SQUOTE] = ACTIONS(3903),
    [anon_sym_L_DQUOTE] = ACTIONS(3903),
    [anon_sym_u_DQUOTE] = ACTIONS(3903),
    [anon_sym_U_DQUOTE] = ACTIONS(3903),
    [anon_sym_u8_DQUOTE] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(3903),
    [sym_true] = ACTIONS(3901),
    [sym_false] = ACTIONS(3901),
    [anon_sym_NULL] = ACTIONS(3901),
    [anon_sym_nullptr] = ACTIONS(3901),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3901),
    [anon_sym_let] = ACTIONS(3901),
    [anon_sym_This] = ACTIONS(3901),
    [anon_sym_decltype] = ACTIONS(3901),
    [anon_sym_explicit] = ACTIONS(3901),
    [anon_sym_typename] = ACTIONS(3901),
    [anon_sym_template] = ACTIONS(3901),
    [anon_sym_operator] = ACTIONS(3901),
    [anon_sym_try] = ACTIONS(3901),
    [anon_sym_delete] = ACTIONS(3901),
    [anon_sym_throw] = ACTIONS(3901),
    [anon_sym_namespace] = ACTIONS(3901),
    [anon_sym_static_assert] = ACTIONS(3901),
    [anon_sym_concept] = ACTIONS(3901),
    [anon_sym_co_return] = ACTIONS(3901),
    [anon_sym_co_yield] = ACTIONS(3901),
    [anon_sym_R_DQUOTE] = ACTIONS(3903),
    [anon_sym_LR_DQUOTE] = ACTIONS(3903),
    [anon_sym_uR_DQUOTE] = ACTIONS(3903),
    [anon_sym_UR_DQUOTE] = ACTIONS(3903),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3903),
    [anon_sym_co_await] = ACTIONS(3901),
    [anon_sym_new] = ACTIONS(3901),
    [anon_sym_requires] = ACTIONS(3901),
    [sym_this] = ACTIONS(3901),
    [anon_sym_discard] = ACTIONS(3901),
    [anon_sym_precise] = ACTIONS(3901),
    [anon_sym_shared] = ACTIONS(3901),
    [anon_sym_groupshared] = ACTIONS(3901),
    [anon_sym_uniform] = ACTIONS(3901),
    [anon_sym_row_major] = ACTIONS(3901),
    [anon_sym_column_major] = ACTIONS(3901),
    [anon_sym_globallycoherent] = ACTIONS(3901),
    [anon_sym_centroid] = ACTIONS(3901),
    [anon_sym_noperspective] = ACTIONS(3901),
    [anon_sym_nointerpolation] = ACTIONS(3901),
    [anon_sym_sample] = ACTIONS(3901),
    [anon_sym_linear] = ACTIONS(3901),
    [anon_sym_snorm] = ACTIONS(3901),
    [anon_sym_unorm] = ACTIONS(3901),
    [anon_sym_point] = ACTIONS(3901),
    [anon_sym_line] = ACTIONS(3901),
    [anon_sym_triangleadj] = ACTIONS(3901),
    [anon_sym_lineadj] = ACTIONS(3901),
    [anon_sym_triangle] = ACTIONS(3901),
    [anon_sym_cbuffer] = ACTIONS(3901),
    [anon_sym_interface] = ACTIONS(3901),
    [anon_sym_extension] = ACTIONS(3901),
  },
  [1071] = {
    [ts_builtin_sym_end] = ACTIONS(3733),
    [sym_identifier] = ACTIONS(3731),
    [aux_sym_preproc_include_token1] = ACTIONS(3731),
    [aux_sym_preproc_def_token1] = ACTIONS(3731),
    [aux_sym_preproc_if_token1] = ACTIONS(3731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3731),
    [sym_preproc_directive] = ACTIONS(3731),
    [anon_sym_LPAREN2] = ACTIONS(3733),
    [anon_sym_BANG] = ACTIONS(3733),
    [anon_sym_TILDE] = ACTIONS(3733),
    [anon_sym_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3731),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_AMP_AMP] = ACTIONS(3733),
    [anon_sym_AMP] = ACTIONS(3731),
    [anon_sym_SEMI] = ACTIONS(3733),
    [anon_sym___extension__] = ACTIONS(3731),
    [anon_sym_typedef] = ACTIONS(3731),
    [anon_sym_in] = ACTIONS(3731),
    [anon_sym_out] = ACTIONS(3731),
    [anon_sym_inout] = ACTIONS(3731),
    [anon_sym_virtual] = ACTIONS(3731),
    [anon_sym_extern] = ACTIONS(3731),
    [anon_sym___attribute__] = ACTIONS(3731),
    [anon_sym___attribute] = ACTIONS(3731),
    [anon_sym_using] = ACTIONS(3731),
    [anon_sym_COLON_COLON] = ACTIONS(3733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3733),
    [anon_sym___declspec] = ACTIONS(3731),
    [anon_sym___based] = ACTIONS(3731),
    [anon_sym___cdecl] = ACTIONS(3731),
    [anon_sym___clrcall] = ACTIONS(3731),
    [anon_sym___stdcall] = ACTIONS(3731),
    [anon_sym___fastcall] = ACTIONS(3731),
    [anon_sym___thiscall] = ACTIONS(3731),
    [anon_sym___vectorcall] = ACTIONS(3731),
    [anon_sym_LBRACE] = ACTIONS(3733),
    [anon_sym_signed] = ACTIONS(3731),
    [anon_sym_unsigned] = ACTIONS(3731),
    [anon_sym_long] = ACTIONS(3731),
    [anon_sym_short] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3731),
    [anon_sym_static] = ACTIONS(3731),
    [anon_sym_register] = ACTIONS(3731),
    [anon_sym_inline] = ACTIONS(3731),
    [anon_sym___inline] = ACTIONS(3731),
    [anon_sym___inline__] = ACTIONS(3731),
    [anon_sym___forceinline] = ACTIONS(3731),
    [anon_sym_thread_local] = ACTIONS(3731),
    [anon_sym___thread] = ACTIONS(3731),
    [anon_sym_const] = ACTIONS(3731),
    [anon_sym_constexpr] = ACTIONS(3731),
    [anon_sym_volatile] = ACTIONS(3731),
    [anon_sym_restrict] = ACTIONS(3731),
    [anon_sym___restrict__] = ACTIONS(3731),
    [anon_sym__Atomic] = ACTIONS(3731),
    [anon_sym__Noreturn] = ACTIONS(3731),
    [anon_sym_noreturn] = ACTIONS(3731),
    [anon_sym__Nonnull] = ACTIONS(3731),
    [anon_sym_mutable] = ACTIONS(3731),
    [anon_sym_constinit] = ACTIONS(3731),
    [anon_sym_consteval] = ACTIONS(3731),
    [anon_sym_alignas] = ACTIONS(3731),
    [anon_sym__Alignas] = ACTIONS(3731),
    [sym_primitive_type] = ACTIONS(3731),
    [anon_sym_enum] = ACTIONS(3731),
    [anon_sym_class] = ACTIONS(3731),
    [anon_sym_struct] = ACTIONS(3731),
    [anon_sym_union] = ACTIONS(3731),
    [anon_sym_if] = ACTIONS(3731),
    [anon_sym_switch] = ACTIONS(3731),
    [anon_sym_case] = ACTIONS(3731),
    [anon_sym_default] = ACTIONS(3731),
    [anon_sym_while] = ACTIONS(3731),
    [anon_sym_do] = ACTIONS(3731),
    [anon_sym_for] = ACTIONS(3731),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_break] = ACTIONS(3731),
    [anon_sym_continue] = ACTIONS(3731),
    [anon_sym_goto] = ACTIONS(3731),
    [anon_sym_not] = ACTIONS(3731),
    [anon_sym_compl] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3733),
    [anon_sym_PLUS_PLUS] = ACTIONS(3733),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3731),
    [anon_sym___alignof] = ACTIONS(3731),
    [anon_sym__alignof] = ACTIONS(3731),
    [anon_sym_alignof] = ACTIONS(3731),
    [anon_sym__Alignof] = ACTIONS(3731),
    [anon_sym_offsetof] = ACTIONS(3731),
    [anon_sym__Generic] = ACTIONS(3731),
    [anon_sym_asm] = ACTIONS(3731),
    [anon_sym___asm__] = ACTIONS(3731),
    [anon_sym___asm] = ACTIONS(3731),
    [sym_number_literal] = ACTIONS(3733),
    [anon_sym_L_SQUOTE] = ACTIONS(3733),
    [anon_sym_u_SQUOTE] = ACTIONS(3733),
    [anon_sym_U_SQUOTE] = ACTIONS(3733),
    [anon_sym_u8_SQUOTE] = ACTIONS(3733),
    [anon_sym_SQUOTE] = ACTIONS(3733),
    [anon_sym_L_DQUOTE] = ACTIONS(3733),
    [anon_sym_u_DQUOTE] = ACTIONS(3733),
    [anon_sym_U_DQUOTE] = ACTIONS(3733),
    [anon_sym_u8_DQUOTE] = ACTIONS(3733),
    [anon_sym_DQUOTE] = ACTIONS(3733),
    [sym_true] = ACTIONS(3731),
    [sym_false] = ACTIONS(3731),
    [anon_sym_NULL] = ACTIONS(3731),
    [anon_sym_nullptr] = ACTIONS(3731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3731),
    [anon_sym_let] = ACTIONS(3731),
    [anon_sym_This] = ACTIONS(3731),
    [anon_sym_decltype] = ACTIONS(3731),
    [anon_sym_explicit] = ACTIONS(3731),
    [anon_sym_typename] = ACTIONS(3731),
    [anon_sym_export] = ACTIONS(3731),
    [anon_sym_module] = ACTIONS(3731),
    [anon_sym_import] = ACTIONS(3731),
    [anon_sym_template] = ACTIONS(3731),
    [anon_sym_operator] = ACTIONS(3731),
    [anon_sym_try] = ACTIONS(3731),
    [anon_sym_delete] = ACTIONS(3731),
    [anon_sym_throw] = ACTIONS(3731),
    [anon_sym_namespace] = ACTIONS(3731),
    [anon_sym_static_assert] = ACTIONS(3731),
    [anon_sym_concept] = ACTIONS(3731),
    [anon_sym_co_return] = ACTIONS(3731),
    [anon_sym_co_yield] = ACTIONS(3731),
    [anon_sym_R_DQUOTE] = ACTIONS(3733),
    [anon_sym_LR_DQUOTE] = ACTIONS(3733),
    [anon_sym_uR_DQUOTE] = ACTIONS(3733),
    [anon_sym_UR_DQUOTE] = ACTIONS(3733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3733),
    [anon_sym_co_await] = ACTIONS(3731),
    [anon_sym_new] = ACTIONS(3731),
    [anon_sym_requires] = ACTIONS(3731),
    [sym_this] = ACTIONS(3731),
    [anon_sym_precise] = ACTIONS(3731),
    [anon_sym_shared] = ACTIONS(3731),
    [anon_sym_groupshared] = ACTIONS(3731),
    [anon_sym_uniform] = ACTIONS(3731),
    [anon_sym_row_major] = ACTIONS(3731),
    [anon_sym_column_major] = ACTIONS(3731),
    [anon_sym_globallycoherent] = ACTIONS(3731),
    [anon_sym_centroid] = ACTIONS(3731),
    [anon_sym_noperspective] = ACTIONS(3731),
    [anon_sym_nointerpolation] = ACTIONS(3731),
    [anon_sym_sample] = ACTIONS(3731),
    [anon_sym_linear] = ACTIONS(3731),
    [anon_sym_snorm] = ACTIONS(3731),
    [anon_sym_unorm] = ACTIONS(3731),
    [anon_sym_point] = ACTIONS(3731),
    [anon_sym_line] = ACTIONS(3731),
    [anon_sym_triangleadj] = ACTIONS(3731),
    [anon_sym_lineadj] = ACTIONS(3731),
    [anon_sym_triangle] = ACTIONS(3731),
    [anon_sym_interface] = ACTIONS(3731),
    [anon_sym_extension] = ACTIONS(3731),
    [anon_sym___exported] = ACTIONS(3731),
  },
  [1072] = {
    [ts_builtin_sym_end] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3665),
    [aux_sym_preproc_include_token1] = ACTIONS(3665),
    [aux_sym_preproc_def_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3665),
    [sym_preproc_directive] = ACTIONS(3665),
    [anon_sym_LPAREN2] = ACTIONS(3667),
    [anon_sym_BANG] = ACTIONS(3667),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_DASH] = ACTIONS(3665),
    [anon_sym_PLUS] = ACTIONS(3665),
    [anon_sym_STAR] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_SEMI] = ACTIONS(3667),
    [anon_sym___extension__] = ACTIONS(3665),
    [anon_sym_typedef] = ACTIONS(3665),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_out] = ACTIONS(3665),
    [anon_sym_inout] = ACTIONS(3665),
    [anon_sym_virtual] = ACTIONS(3665),
    [anon_sym_extern] = ACTIONS(3665),
    [anon_sym___attribute__] = ACTIONS(3665),
    [anon_sym___attribute] = ACTIONS(3665),
    [anon_sym_using] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(3667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3667),
    [anon_sym___declspec] = ACTIONS(3665),
    [anon_sym___based] = ACTIONS(3665),
    [anon_sym___cdecl] = ACTIONS(3665),
    [anon_sym___clrcall] = ACTIONS(3665),
    [anon_sym___stdcall] = ACTIONS(3665),
    [anon_sym___fastcall] = ACTIONS(3665),
    [anon_sym___thiscall] = ACTIONS(3665),
    [anon_sym___vectorcall] = ACTIONS(3665),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_signed] = ACTIONS(3665),
    [anon_sym_unsigned] = ACTIONS(3665),
    [anon_sym_long] = ACTIONS(3665),
    [anon_sym_short] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3665),
    [anon_sym_static] = ACTIONS(3665),
    [anon_sym_register] = ACTIONS(3665),
    [anon_sym_inline] = ACTIONS(3665),
    [anon_sym___inline] = ACTIONS(3665),
    [anon_sym___inline__] = ACTIONS(3665),
    [anon_sym___forceinline] = ACTIONS(3665),
    [anon_sym_thread_local] = ACTIONS(3665),
    [anon_sym___thread] = ACTIONS(3665),
    [anon_sym_const] = ACTIONS(3665),
    [anon_sym_constexpr] = ACTIONS(3665),
    [anon_sym_volatile] = ACTIONS(3665),
    [anon_sym_restrict] = ACTIONS(3665),
    [anon_sym___restrict__] = ACTIONS(3665),
    [anon_sym__Atomic] = ACTIONS(3665),
    [anon_sym__Noreturn] = ACTIONS(3665),
    [anon_sym_noreturn] = ACTIONS(3665),
    [anon_sym__Nonnull] = ACTIONS(3665),
    [anon_sym_mutable] = ACTIONS(3665),
    [anon_sym_constinit] = ACTIONS(3665),
    [anon_sym_consteval] = ACTIONS(3665),
    [anon_sym_alignas] = ACTIONS(3665),
    [anon_sym__Alignas] = ACTIONS(3665),
    [sym_primitive_type] = ACTIONS(3665),
    [anon_sym_enum] = ACTIONS(3665),
    [anon_sym_class] = ACTIONS(3665),
    [anon_sym_struct] = ACTIONS(3665),
    [anon_sym_union] = ACTIONS(3665),
    [anon_sym_if] = ACTIONS(3665),
    [anon_sym_switch] = ACTIONS(3665),
    [anon_sym_case] = ACTIONS(3665),
    [anon_sym_default] = ACTIONS(3665),
    [anon_sym_while] = ACTIONS(3665),
    [anon_sym_do] = ACTIONS(3665),
    [anon_sym_for] = ACTIONS(3665),
    [anon_sym_return] = ACTIONS(3665),
    [anon_sym_break] = ACTIONS(3665),
    [anon_sym_continue] = ACTIONS(3665),
    [anon_sym_goto] = ACTIONS(3665),
    [anon_sym_not] = ACTIONS(3665),
    [anon_sym_compl] = ACTIONS(3665),
    [anon_sym_DASH_DASH] = ACTIONS(3667),
    [anon_sym_PLUS_PLUS] = ACTIONS(3667),
    [anon_sym_sizeof] = ACTIONS(3665),
    [anon_sym___alignof__] = ACTIONS(3665),
    [anon_sym___alignof] = ACTIONS(3665),
    [anon_sym__alignof] = ACTIONS(3665),
    [anon_sym_alignof] = ACTIONS(3665),
    [anon_sym__Alignof] = ACTIONS(3665),
    [anon_sym_offsetof] = ACTIONS(3665),
    [anon_sym__Generic] = ACTIONS(3665),
    [anon_sym_asm] = ACTIONS(3665),
    [anon_sym___asm__] = ACTIONS(3665),
    [anon_sym___asm] = ACTIONS(3665),
    [sym_number_literal] = ACTIONS(3667),
    [anon_sym_L_SQUOTE] = ACTIONS(3667),
    [anon_sym_u_SQUOTE] = ACTIONS(3667),
    [anon_sym_U_SQUOTE] = ACTIONS(3667),
    [anon_sym_u8_SQUOTE] = ACTIONS(3667),
    [anon_sym_SQUOTE] = ACTIONS(3667),
    [anon_sym_L_DQUOTE] = ACTIONS(3667),
    [anon_sym_u_DQUOTE] = ACTIONS(3667),
    [anon_sym_U_DQUOTE] = ACTIONS(3667),
    [anon_sym_u8_DQUOTE] = ACTIONS(3667),
    [anon_sym_DQUOTE] = ACTIONS(3667),
    [sym_true] = ACTIONS(3665),
    [sym_false] = ACTIONS(3665),
    [anon_sym_NULL] = ACTIONS(3665),
    [anon_sym_nullptr] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3665),
    [anon_sym_let] = ACTIONS(3665),
    [anon_sym_This] = ACTIONS(3665),
    [anon_sym_decltype] = ACTIONS(3665),
    [anon_sym_explicit] = ACTIONS(3665),
    [anon_sym_typename] = ACTIONS(3665),
    [anon_sym_export] = ACTIONS(3665),
    [anon_sym_module] = ACTIONS(3665),
    [anon_sym_import] = ACTIONS(3665),
    [anon_sym_template] = ACTIONS(3665),
    [anon_sym_operator] = ACTIONS(3665),
    [anon_sym_try] = ACTIONS(3665),
    [anon_sym_delete] = ACTIONS(3665),
    [anon_sym_throw] = ACTIONS(3665),
    [anon_sym_namespace] = ACTIONS(3665),
    [anon_sym_static_assert] = ACTIONS(3665),
    [anon_sym_concept] = ACTIONS(3665),
    [anon_sym_co_return] = ACTIONS(3665),
    [anon_sym_co_yield] = ACTIONS(3665),
    [anon_sym_R_DQUOTE] = ACTIONS(3667),
    [anon_sym_LR_DQUOTE] = ACTIONS(3667),
    [anon_sym_uR_DQUOTE] = ACTIONS(3667),
    [anon_sym_UR_DQUOTE] = ACTIONS(3667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3667),
    [anon_sym_co_await] = ACTIONS(3665),
    [anon_sym_new] = ACTIONS(3665),
    [anon_sym_requires] = ACTIONS(3665),
    [sym_this] = ACTIONS(3665),
    [anon_sym_precise] = ACTIONS(3665),
    [anon_sym_shared] = ACTIONS(3665),
    [anon_sym_groupshared] = ACTIONS(3665),
    [anon_sym_uniform] = ACTIONS(3665),
    [anon_sym_row_major] = ACTIONS(3665),
    [anon_sym_column_major] = ACTIONS(3665),
    [anon_sym_globallycoherent] = ACTIONS(3665),
    [anon_sym_centroid] = ACTIONS(3665),
    [anon_sym_noperspective] = ACTIONS(3665),
    [anon_sym_nointerpolation] = ACTIONS(3665),
    [anon_sym_sample] = ACTIONS(3665),
    [anon_sym_linear] = ACTIONS(3665),
    [anon_sym_snorm] = ACTIONS(3665),
    [anon_sym_unorm] = ACTIONS(3665),
    [anon_sym_point] = ACTIONS(3665),
    [anon_sym_line] = ACTIONS(3665),
    [anon_sym_triangleadj] = ACTIONS(3665),
    [anon_sym_lineadj] = ACTIONS(3665),
    [anon_sym_triangle] = ACTIONS(3665),
    [anon_sym_interface] = ACTIONS(3665),
    [anon_sym_extension] = ACTIONS(3665),
    [anon_sym___exported] = ACTIONS(3665),
  },
  [1073] = {
    [ts_builtin_sym_end] = ACTIONS(3741),
    [sym_identifier] = ACTIONS(3739),
    [aux_sym_preproc_include_token1] = ACTIONS(3739),
    [aux_sym_preproc_def_token1] = ACTIONS(3739),
    [aux_sym_preproc_if_token1] = ACTIONS(3739),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3739),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3739),
    [sym_preproc_directive] = ACTIONS(3739),
    [anon_sym_LPAREN2] = ACTIONS(3741),
    [anon_sym_BANG] = ACTIONS(3741),
    [anon_sym_TILDE] = ACTIONS(3741),
    [anon_sym_DASH] = ACTIONS(3739),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_STAR] = ACTIONS(3741),
    [anon_sym_AMP_AMP] = ACTIONS(3741),
    [anon_sym_AMP] = ACTIONS(3739),
    [anon_sym_SEMI] = ACTIONS(3741),
    [anon_sym___extension__] = ACTIONS(3739),
    [anon_sym_typedef] = ACTIONS(3739),
    [anon_sym_in] = ACTIONS(3739),
    [anon_sym_out] = ACTIONS(3739),
    [anon_sym_inout] = ACTIONS(3739),
    [anon_sym_virtual] = ACTIONS(3739),
    [anon_sym_extern] = ACTIONS(3739),
    [anon_sym___attribute__] = ACTIONS(3739),
    [anon_sym___attribute] = ACTIONS(3739),
    [anon_sym_using] = ACTIONS(3739),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3741),
    [anon_sym___declspec] = ACTIONS(3739),
    [anon_sym___based] = ACTIONS(3739),
    [anon_sym___cdecl] = ACTIONS(3739),
    [anon_sym___clrcall] = ACTIONS(3739),
    [anon_sym___stdcall] = ACTIONS(3739),
    [anon_sym___fastcall] = ACTIONS(3739),
    [anon_sym___thiscall] = ACTIONS(3739),
    [anon_sym___vectorcall] = ACTIONS(3739),
    [anon_sym_LBRACE] = ACTIONS(3741),
    [anon_sym_signed] = ACTIONS(3739),
    [anon_sym_unsigned] = ACTIONS(3739),
    [anon_sym_long] = ACTIONS(3739),
    [anon_sym_short] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3739),
    [anon_sym_static] = ACTIONS(3739),
    [anon_sym_register] = ACTIONS(3739),
    [anon_sym_inline] = ACTIONS(3739),
    [anon_sym___inline] = ACTIONS(3739),
    [anon_sym___inline__] = ACTIONS(3739),
    [anon_sym___forceinline] = ACTIONS(3739),
    [anon_sym_thread_local] = ACTIONS(3739),
    [anon_sym___thread] = ACTIONS(3739),
    [anon_sym_const] = ACTIONS(3739),
    [anon_sym_constexpr] = ACTIONS(3739),
    [anon_sym_volatile] = ACTIONS(3739),
    [anon_sym_restrict] = ACTIONS(3739),
    [anon_sym___restrict__] = ACTIONS(3739),
    [anon_sym__Atomic] = ACTIONS(3739),
    [anon_sym__Noreturn] = ACTIONS(3739),
    [anon_sym_noreturn] = ACTIONS(3739),
    [anon_sym__Nonnull] = ACTIONS(3739),
    [anon_sym_mutable] = ACTIONS(3739),
    [anon_sym_constinit] = ACTIONS(3739),
    [anon_sym_consteval] = ACTIONS(3739),
    [anon_sym_alignas] = ACTIONS(3739),
    [anon_sym__Alignas] = ACTIONS(3739),
    [sym_primitive_type] = ACTIONS(3739),
    [anon_sym_enum] = ACTIONS(3739),
    [anon_sym_class] = ACTIONS(3739),
    [anon_sym_struct] = ACTIONS(3739),
    [anon_sym_union] = ACTIONS(3739),
    [anon_sym_if] = ACTIONS(3739),
    [anon_sym_switch] = ACTIONS(3739),
    [anon_sym_case] = ACTIONS(3739),
    [anon_sym_default] = ACTIONS(3739),
    [anon_sym_while] = ACTIONS(3739),
    [anon_sym_do] = ACTIONS(3739),
    [anon_sym_for] = ACTIONS(3739),
    [anon_sym_return] = ACTIONS(3739),
    [anon_sym_break] = ACTIONS(3739),
    [anon_sym_continue] = ACTIONS(3739),
    [anon_sym_goto] = ACTIONS(3739),
    [anon_sym_not] = ACTIONS(3739),
    [anon_sym_compl] = ACTIONS(3739),
    [anon_sym_DASH_DASH] = ACTIONS(3741),
    [anon_sym_PLUS_PLUS] = ACTIONS(3741),
    [anon_sym_sizeof] = ACTIONS(3739),
    [anon_sym___alignof__] = ACTIONS(3739),
    [anon_sym___alignof] = ACTIONS(3739),
    [anon_sym__alignof] = ACTIONS(3739),
    [anon_sym_alignof] = ACTIONS(3739),
    [anon_sym__Alignof] = ACTIONS(3739),
    [anon_sym_offsetof] = ACTIONS(3739),
    [anon_sym__Generic] = ACTIONS(3739),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [anon_sym___asm] = ACTIONS(3739),
    [sym_number_literal] = ACTIONS(3741),
    [anon_sym_L_SQUOTE] = ACTIONS(3741),
    [anon_sym_u_SQUOTE] = ACTIONS(3741),
    [anon_sym_U_SQUOTE] = ACTIONS(3741),
    [anon_sym_u8_SQUOTE] = ACTIONS(3741),
    [anon_sym_SQUOTE] = ACTIONS(3741),
    [anon_sym_L_DQUOTE] = ACTIONS(3741),
    [anon_sym_u_DQUOTE] = ACTIONS(3741),
    [anon_sym_U_DQUOTE] = ACTIONS(3741),
    [anon_sym_u8_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE] = ACTIONS(3741),
    [sym_true] = ACTIONS(3739),
    [sym_false] = ACTIONS(3739),
    [anon_sym_NULL] = ACTIONS(3739),
    [anon_sym_nullptr] = ACTIONS(3739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3739),
    [anon_sym_let] = ACTIONS(3739),
    [anon_sym_This] = ACTIONS(3739),
    [anon_sym_decltype] = ACTIONS(3739),
    [anon_sym_explicit] = ACTIONS(3739),
    [anon_sym_typename] = ACTIONS(3739),
    [anon_sym_export] = ACTIONS(3739),
    [anon_sym_module] = ACTIONS(3739),
    [anon_sym_import] = ACTIONS(3739),
    [anon_sym_template] = ACTIONS(3739),
    [anon_sym_operator] = ACTIONS(3739),
    [anon_sym_try] = ACTIONS(3739),
    [anon_sym_delete] = ACTIONS(3739),
    [anon_sym_throw] = ACTIONS(3739),
    [anon_sym_namespace] = ACTIONS(3739),
    [anon_sym_static_assert] = ACTIONS(3739),
    [anon_sym_concept] = ACTIONS(3739),
    [anon_sym_co_return] = ACTIONS(3739),
    [anon_sym_co_yield] = ACTIONS(3739),
    [anon_sym_R_DQUOTE] = ACTIONS(3741),
    [anon_sym_LR_DQUOTE] = ACTIONS(3741),
    [anon_sym_uR_DQUOTE] = ACTIONS(3741),
    [anon_sym_UR_DQUOTE] = ACTIONS(3741),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3741),
    [anon_sym_co_await] = ACTIONS(3739),
    [anon_sym_new] = ACTIONS(3739),
    [anon_sym_requires] = ACTIONS(3739),
    [sym_this] = ACTIONS(3739),
    [anon_sym_precise] = ACTIONS(3739),
    [anon_sym_shared] = ACTIONS(3739),
    [anon_sym_groupshared] = ACTIONS(3739),
    [anon_sym_uniform] = ACTIONS(3739),
    [anon_sym_row_major] = ACTIONS(3739),
    [anon_sym_column_major] = ACTIONS(3739),
    [anon_sym_globallycoherent] = ACTIONS(3739),
    [anon_sym_centroid] = ACTIONS(3739),
    [anon_sym_noperspective] = ACTIONS(3739),
    [anon_sym_nointerpolation] = ACTIONS(3739),
    [anon_sym_sample] = ACTIONS(3739),
    [anon_sym_linear] = ACTIONS(3739),
    [anon_sym_snorm] = ACTIONS(3739),
    [anon_sym_unorm] = ACTIONS(3739),
    [anon_sym_point] = ACTIONS(3739),
    [anon_sym_line] = ACTIONS(3739),
    [anon_sym_triangleadj] = ACTIONS(3739),
    [anon_sym_lineadj] = ACTIONS(3739),
    [anon_sym_triangle] = ACTIONS(3739),
    [anon_sym_interface] = ACTIONS(3739),
    [anon_sym_extension] = ACTIONS(3739),
    [anon_sym___exported] = ACTIONS(3739),
  },
  [1074] = {
    [ts_builtin_sym_end] = ACTIONS(4345),
    [sym_identifier] = ACTIONS(4347),
    [aux_sym_preproc_include_token1] = ACTIONS(4347),
    [aux_sym_preproc_def_token1] = ACTIONS(4347),
    [aux_sym_preproc_if_token1] = ACTIONS(4347),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4347),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4347),
    [sym_preproc_directive] = ACTIONS(4347),
    [anon_sym_LPAREN2] = ACTIONS(4345),
    [anon_sym_BANG] = ACTIONS(4345),
    [anon_sym_TILDE] = ACTIONS(4345),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4345),
    [anon_sym_AMP_AMP] = ACTIONS(4345),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_SEMI] = ACTIONS(4345),
    [anon_sym___extension__] = ACTIONS(4347),
    [anon_sym_typedef] = ACTIONS(4347),
    [anon_sym_in] = ACTIONS(4347),
    [anon_sym_out] = ACTIONS(4347),
    [anon_sym_inout] = ACTIONS(4347),
    [anon_sym_virtual] = ACTIONS(4347),
    [anon_sym_extern] = ACTIONS(4347),
    [anon_sym___attribute__] = ACTIONS(4347),
    [anon_sym___attribute] = ACTIONS(4347),
    [anon_sym_using] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(4345),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4345),
    [anon_sym___declspec] = ACTIONS(4347),
    [anon_sym___based] = ACTIONS(4347),
    [anon_sym___cdecl] = ACTIONS(4347),
    [anon_sym___clrcall] = ACTIONS(4347),
    [anon_sym___stdcall] = ACTIONS(4347),
    [anon_sym___fastcall] = ACTIONS(4347),
    [anon_sym___thiscall] = ACTIONS(4347),
    [anon_sym___vectorcall] = ACTIONS(4347),
    [anon_sym_LBRACE] = ACTIONS(4345),
    [anon_sym_signed] = ACTIONS(4347),
    [anon_sym_unsigned] = ACTIONS(4347),
    [anon_sym_long] = ACTIONS(4347),
    [anon_sym_short] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [anon_sym_static] = ACTIONS(4347),
    [anon_sym_register] = ACTIONS(4347),
    [anon_sym_inline] = ACTIONS(4347),
    [anon_sym___inline] = ACTIONS(4347),
    [anon_sym___inline__] = ACTIONS(4347),
    [anon_sym___forceinline] = ACTIONS(4347),
    [anon_sym_thread_local] = ACTIONS(4347),
    [anon_sym___thread] = ACTIONS(4347),
    [anon_sym_const] = ACTIONS(4347),
    [anon_sym_constexpr] = ACTIONS(4347),
    [anon_sym_volatile] = ACTIONS(4347),
    [anon_sym_restrict] = ACTIONS(4347),
    [anon_sym___restrict__] = ACTIONS(4347),
    [anon_sym__Atomic] = ACTIONS(4347),
    [anon_sym__Noreturn] = ACTIONS(4347),
    [anon_sym_noreturn] = ACTIONS(4347),
    [anon_sym__Nonnull] = ACTIONS(4347),
    [anon_sym_mutable] = ACTIONS(4347),
    [anon_sym_constinit] = ACTIONS(4347),
    [anon_sym_consteval] = ACTIONS(4347),
    [anon_sym_alignas] = ACTIONS(4347),
    [anon_sym__Alignas] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(4347),
    [anon_sym_enum] = ACTIONS(4347),
    [anon_sym_class] = ACTIONS(4347),
    [anon_sym_struct] = ACTIONS(4347),
    [anon_sym_union] = ACTIONS(4347),
    [anon_sym_if] = ACTIONS(4347),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_case] = ACTIONS(4347),
    [anon_sym_default] = ACTIONS(4347),
    [anon_sym_while] = ACTIONS(4347),
    [anon_sym_do] = ACTIONS(4347),
    [anon_sym_for] = ACTIONS(4347),
    [anon_sym_return] = ACTIONS(4347),
    [anon_sym_break] = ACTIONS(4347),
    [anon_sym_continue] = ACTIONS(4347),
    [anon_sym_goto] = ACTIONS(4347),
    [anon_sym_not] = ACTIONS(4347),
    [anon_sym_compl] = ACTIONS(4347),
    [anon_sym_DASH_DASH] = ACTIONS(4345),
    [anon_sym_PLUS_PLUS] = ACTIONS(4345),
    [anon_sym_sizeof] = ACTIONS(4347),
    [anon_sym___alignof__] = ACTIONS(4347),
    [anon_sym___alignof] = ACTIONS(4347),
    [anon_sym__alignof] = ACTIONS(4347),
    [anon_sym_alignof] = ACTIONS(4347),
    [anon_sym__Alignof] = ACTIONS(4347),
    [anon_sym_offsetof] = ACTIONS(4347),
    [anon_sym__Generic] = ACTIONS(4347),
    [anon_sym_asm] = ACTIONS(4347),
    [anon_sym___asm__] = ACTIONS(4347),
    [anon_sym___asm] = ACTIONS(4347),
    [sym_number_literal] = ACTIONS(4345),
    [anon_sym_L_SQUOTE] = ACTIONS(4345),
    [anon_sym_u_SQUOTE] = ACTIONS(4345),
    [anon_sym_U_SQUOTE] = ACTIONS(4345),
    [anon_sym_u8_SQUOTE] = ACTIONS(4345),
    [anon_sym_SQUOTE] = ACTIONS(4345),
    [anon_sym_L_DQUOTE] = ACTIONS(4345),
    [anon_sym_u_DQUOTE] = ACTIONS(4345),
    [anon_sym_U_DQUOTE] = ACTIONS(4345),
    [anon_sym_u8_DQUOTE] = ACTIONS(4345),
    [anon_sym_DQUOTE] = ACTIONS(4345),
    [sym_true] = ACTIONS(4347),
    [sym_false] = ACTIONS(4347),
    [anon_sym_NULL] = ACTIONS(4347),
    [anon_sym_nullptr] = ACTIONS(4347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4347),
    [anon_sym_let] = ACTIONS(4347),
    [anon_sym_This] = ACTIONS(4347),
    [anon_sym_decltype] = ACTIONS(4347),
    [anon_sym_explicit] = ACTIONS(4347),
    [anon_sym_typename] = ACTIONS(4347),
    [anon_sym_export] = ACTIONS(4347),
    [anon_sym_module] = ACTIONS(4347),
    [anon_sym_import] = ACTIONS(4347),
    [anon_sym_template] = ACTIONS(4347),
    [anon_sym_operator] = ACTIONS(4347),
    [anon_sym_try] = ACTIONS(4347),
    [anon_sym_delete] = ACTIONS(4347),
    [anon_sym_throw] = ACTIONS(4347),
    [anon_sym_namespace] = ACTIONS(4347),
    [anon_sym_static_assert] = ACTIONS(4347),
    [anon_sym_concept] = ACTIONS(4347),
    [anon_sym_co_return] = ACTIONS(4347),
    [anon_sym_co_yield] = ACTIONS(4347),
    [anon_sym_R_DQUOTE] = ACTIONS(4345),
    [anon_sym_LR_DQUOTE] = ACTIONS(4345),
    [anon_sym_uR_DQUOTE] = ACTIONS(4345),
    [anon_sym_UR_DQUOTE] = ACTIONS(4345),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4345),
    [anon_sym_co_await] = ACTIONS(4347),
    [anon_sym_new] = ACTIONS(4347),
    [anon_sym_requires] = ACTIONS(4347),
    [sym_this] = ACTIONS(4347),
    [anon_sym_precise] = ACTIONS(4347),
    [anon_sym_shared] = ACTIONS(4347),
    [anon_sym_groupshared] = ACTIONS(4347),
    [anon_sym_uniform] = ACTIONS(4347),
    [anon_sym_row_major] = ACTIONS(4347),
    [anon_sym_column_major] = ACTIONS(4347),
    [anon_sym_globallycoherent] = ACTIONS(4347),
    [anon_sym_centroid] = ACTIONS(4347),
    [anon_sym_noperspective] = ACTIONS(4347),
    [anon_sym_nointerpolation] = ACTIONS(4347),
    [anon_sym_sample] = ACTIONS(4347),
    [anon_sym_linear] = ACTIONS(4347),
    [anon_sym_snorm] = ACTIONS(4347),
    [anon_sym_unorm] = ACTIONS(4347),
    [anon_sym_point] = ACTIONS(4347),
    [anon_sym_line] = ACTIONS(4347),
    [anon_sym_triangleadj] = ACTIONS(4347),
    [anon_sym_lineadj] = ACTIONS(4347),
    [anon_sym_triangle] = ACTIONS(4347),
    [anon_sym_interface] = ACTIONS(4347),
    [anon_sym_extension] = ACTIONS(4347),
    [anon_sym___exported] = ACTIONS(4347),
  },
  [1075] = {
    [ts_builtin_sym_end] = ACTIONS(3761),
    [sym_identifier] = ACTIONS(3759),
    [aux_sym_preproc_include_token1] = ACTIONS(3759),
    [aux_sym_preproc_def_token1] = ACTIONS(3759),
    [aux_sym_preproc_if_token1] = ACTIONS(3759),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3759),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3759),
    [sym_preproc_directive] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_BANG] = ACTIONS(3761),
    [anon_sym_TILDE] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_STAR] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym___extension__] = ACTIONS(3759),
    [anon_sym_typedef] = ACTIONS(3759),
    [anon_sym_in] = ACTIONS(3759),
    [anon_sym_out] = ACTIONS(3759),
    [anon_sym_inout] = ACTIONS(3759),
    [anon_sym_virtual] = ACTIONS(3759),
    [anon_sym_extern] = ACTIONS(3759),
    [anon_sym___attribute__] = ACTIONS(3759),
    [anon_sym___attribute] = ACTIONS(3759),
    [anon_sym_using] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3761),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3761),
    [anon_sym___declspec] = ACTIONS(3759),
    [anon_sym___based] = ACTIONS(3759),
    [anon_sym___cdecl] = ACTIONS(3759),
    [anon_sym___clrcall] = ACTIONS(3759),
    [anon_sym___stdcall] = ACTIONS(3759),
    [anon_sym___fastcall] = ACTIONS(3759),
    [anon_sym___thiscall] = ACTIONS(3759),
    [anon_sym___vectorcall] = ACTIONS(3759),
    [anon_sym_LBRACE] = ACTIONS(3761),
    [anon_sym_signed] = ACTIONS(3759),
    [anon_sym_unsigned] = ACTIONS(3759),
    [anon_sym_long] = ACTIONS(3759),
    [anon_sym_short] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_register] = ACTIONS(3759),
    [anon_sym_inline] = ACTIONS(3759),
    [anon_sym___inline] = ACTIONS(3759),
    [anon_sym___inline__] = ACTIONS(3759),
    [anon_sym___forceinline] = ACTIONS(3759),
    [anon_sym_thread_local] = ACTIONS(3759),
    [anon_sym___thread] = ACTIONS(3759),
    [anon_sym_const] = ACTIONS(3759),
    [anon_sym_constexpr] = ACTIONS(3759),
    [anon_sym_volatile] = ACTIONS(3759),
    [anon_sym_restrict] = ACTIONS(3759),
    [anon_sym___restrict__] = ACTIONS(3759),
    [anon_sym__Atomic] = ACTIONS(3759),
    [anon_sym__Noreturn] = ACTIONS(3759),
    [anon_sym_noreturn] = ACTIONS(3759),
    [anon_sym__Nonnull] = ACTIONS(3759),
    [anon_sym_mutable] = ACTIONS(3759),
    [anon_sym_constinit] = ACTIONS(3759),
    [anon_sym_consteval] = ACTIONS(3759),
    [anon_sym_alignas] = ACTIONS(3759),
    [anon_sym__Alignas] = ACTIONS(3759),
    [sym_primitive_type] = ACTIONS(3759),
    [anon_sym_enum] = ACTIONS(3759),
    [anon_sym_class] = ACTIONS(3759),
    [anon_sym_struct] = ACTIONS(3759),
    [anon_sym_union] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_switch] = ACTIONS(3759),
    [anon_sym_case] = ACTIONS(3759),
    [anon_sym_default] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_break] = ACTIONS(3759),
    [anon_sym_continue] = ACTIONS(3759),
    [anon_sym_goto] = ACTIONS(3759),
    [anon_sym_not] = ACTIONS(3759),
    [anon_sym_compl] = ACTIONS(3759),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_sizeof] = ACTIONS(3759),
    [anon_sym___alignof__] = ACTIONS(3759),
    [anon_sym___alignof] = ACTIONS(3759),
    [anon_sym__alignof] = ACTIONS(3759),
    [anon_sym_alignof] = ACTIONS(3759),
    [anon_sym__Alignof] = ACTIONS(3759),
    [anon_sym_offsetof] = ACTIONS(3759),
    [anon_sym__Generic] = ACTIONS(3759),
    [anon_sym_asm] = ACTIONS(3759),
    [anon_sym___asm__] = ACTIONS(3759),
    [anon_sym___asm] = ACTIONS(3759),
    [sym_number_literal] = ACTIONS(3761),
    [anon_sym_L_SQUOTE] = ACTIONS(3761),
    [anon_sym_u_SQUOTE] = ACTIONS(3761),
    [anon_sym_U_SQUOTE] = ACTIONS(3761),
    [anon_sym_u8_SQUOTE] = ACTIONS(3761),
    [anon_sym_SQUOTE] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3761),
    [anon_sym_u_DQUOTE] = ACTIONS(3761),
    [anon_sym_U_DQUOTE] = ACTIONS(3761),
    [anon_sym_u8_DQUOTE] = ACTIONS(3761),
    [anon_sym_DQUOTE] = ACTIONS(3761),
    [sym_true] = ACTIONS(3759),
    [sym_false] = ACTIONS(3759),
    [anon_sym_NULL] = ACTIONS(3759),
    [anon_sym_nullptr] = ACTIONS(3759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_This] = ACTIONS(3759),
    [anon_sym_decltype] = ACTIONS(3759),
    [anon_sym_explicit] = ACTIONS(3759),
    [anon_sym_typename] = ACTIONS(3759),
    [anon_sym_export] = ACTIONS(3759),
    [anon_sym_module] = ACTIONS(3759),
    [anon_sym_import] = ACTIONS(3759),
    [anon_sym_template] = ACTIONS(3759),
    [anon_sym_operator] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_delete] = ACTIONS(3759),
    [anon_sym_throw] = ACTIONS(3759),
    [anon_sym_namespace] = ACTIONS(3759),
    [anon_sym_static_assert] = ACTIONS(3759),
    [anon_sym_concept] = ACTIONS(3759),
    [anon_sym_co_return] = ACTIONS(3759),
    [anon_sym_co_yield] = ACTIONS(3759),
    [anon_sym_R_DQUOTE] = ACTIONS(3761),
    [anon_sym_LR_DQUOTE] = ACTIONS(3761),
    [anon_sym_uR_DQUOTE] = ACTIONS(3761),
    [anon_sym_UR_DQUOTE] = ACTIONS(3761),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3761),
    [anon_sym_co_await] = ACTIONS(3759),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3759),
    [sym_this] = ACTIONS(3759),
    [anon_sym_precise] = ACTIONS(3759),
    [anon_sym_shared] = ACTIONS(3759),
    [anon_sym_groupshared] = ACTIONS(3759),
    [anon_sym_uniform] = ACTIONS(3759),
    [anon_sym_row_major] = ACTIONS(3759),
    [anon_sym_column_major] = ACTIONS(3759),
    [anon_sym_globallycoherent] = ACTIONS(3759),
    [anon_sym_centroid] = ACTIONS(3759),
    [anon_sym_noperspective] = ACTIONS(3759),
    [anon_sym_nointerpolation] = ACTIONS(3759),
    [anon_sym_sample] = ACTIONS(3759),
    [anon_sym_linear] = ACTIONS(3759),
    [anon_sym_snorm] = ACTIONS(3759),
    [anon_sym_unorm] = ACTIONS(3759),
    [anon_sym_point] = ACTIONS(3759),
    [anon_sym_line] = ACTIONS(3759),
    [anon_sym_triangleadj] = ACTIONS(3759),
    [anon_sym_lineadj] = ACTIONS(3759),
    [anon_sym_triangle] = ACTIONS(3759),
    [anon_sym_interface] = ACTIONS(3759),
    [anon_sym_extension] = ACTIONS(3759),
    [anon_sym___exported] = ACTIONS(3759),
  },
  [1076] = {
    [sym_identifier] = ACTIONS(3677),
    [aux_sym_preproc_include_token1] = ACTIONS(3677),
    [aux_sym_preproc_def_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token2] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3677),
    [sym_preproc_directive] = ACTIONS(3677),
    [anon_sym_LPAREN2] = ACTIONS(3679),
    [anon_sym_BANG] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3677),
    [anon_sym_PLUS] = ACTIONS(3677),
    [anon_sym_STAR] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_AMP] = ACTIONS(3677),
    [anon_sym_SEMI] = ACTIONS(3679),
    [anon_sym___extension__] = ACTIONS(3677),
    [anon_sym_typedef] = ACTIONS(3677),
    [anon_sym_in] = ACTIONS(3677),
    [anon_sym_out] = ACTIONS(3677),
    [anon_sym_inout] = ACTIONS(3677),
    [anon_sym_virtual] = ACTIONS(3677),
    [anon_sym_extern] = ACTIONS(3677),
    [anon_sym___attribute__] = ACTIONS(3677),
    [anon_sym___attribute] = ACTIONS(3677),
    [anon_sym_using] = ACTIONS(3677),
    [anon_sym_COLON_COLON] = ACTIONS(3679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3679),
    [anon_sym___declspec] = ACTIONS(3677),
    [anon_sym___based] = ACTIONS(3677),
    [anon_sym___cdecl] = ACTIONS(3677),
    [anon_sym___clrcall] = ACTIONS(3677),
    [anon_sym___stdcall] = ACTIONS(3677),
    [anon_sym___fastcall] = ACTIONS(3677),
    [anon_sym___thiscall] = ACTIONS(3677),
    [anon_sym___vectorcall] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_signed] = ACTIONS(3677),
    [anon_sym_unsigned] = ACTIONS(3677),
    [anon_sym_long] = ACTIONS(3677),
    [anon_sym_short] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3677),
    [anon_sym_static] = ACTIONS(3677),
    [anon_sym_register] = ACTIONS(3677),
    [anon_sym_inline] = ACTIONS(3677),
    [anon_sym___inline] = ACTIONS(3677),
    [anon_sym___inline__] = ACTIONS(3677),
    [anon_sym___forceinline] = ACTIONS(3677),
    [anon_sym_thread_local] = ACTIONS(3677),
    [anon_sym___thread] = ACTIONS(3677),
    [anon_sym_const] = ACTIONS(3677),
    [anon_sym_constexpr] = ACTIONS(3677),
    [anon_sym_volatile] = ACTIONS(3677),
    [anon_sym_restrict] = ACTIONS(3677),
    [anon_sym___restrict__] = ACTIONS(3677),
    [anon_sym__Atomic] = ACTIONS(3677),
    [anon_sym__Noreturn] = ACTIONS(3677),
    [anon_sym_noreturn] = ACTIONS(3677),
    [anon_sym__Nonnull] = ACTIONS(3677),
    [anon_sym_mutable] = ACTIONS(3677),
    [anon_sym_constinit] = ACTIONS(3677),
    [anon_sym_consteval] = ACTIONS(3677),
    [anon_sym_alignas] = ACTIONS(3677),
    [anon_sym__Alignas] = ACTIONS(3677),
    [sym_primitive_type] = ACTIONS(3677),
    [anon_sym_enum] = ACTIONS(3677),
    [anon_sym_class] = ACTIONS(3677),
    [anon_sym_struct] = ACTIONS(3677),
    [anon_sym_union] = ACTIONS(3677),
    [anon_sym_if] = ACTIONS(3677),
    [anon_sym_switch] = ACTIONS(3677),
    [anon_sym_case] = ACTIONS(3677),
    [anon_sym_default] = ACTIONS(3677),
    [anon_sym_while] = ACTIONS(3677),
    [anon_sym_do] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3677),
    [anon_sym_return] = ACTIONS(3677),
    [anon_sym_break] = ACTIONS(3677),
    [anon_sym_continue] = ACTIONS(3677),
    [anon_sym_goto] = ACTIONS(3677),
    [anon_sym___try] = ACTIONS(3677),
    [anon_sym___leave] = ACTIONS(3677),
    [anon_sym_not] = ACTIONS(3677),
    [anon_sym_compl] = ACTIONS(3677),
    [anon_sym_DASH_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_PLUS] = ACTIONS(3679),
    [anon_sym_sizeof] = ACTIONS(3677),
    [anon_sym___alignof__] = ACTIONS(3677),
    [anon_sym___alignof] = ACTIONS(3677),
    [anon_sym__alignof] = ACTIONS(3677),
    [anon_sym_alignof] = ACTIONS(3677),
    [anon_sym__Alignof] = ACTIONS(3677),
    [anon_sym_offsetof] = ACTIONS(3677),
    [anon_sym__Generic] = ACTIONS(3677),
    [anon_sym_asm] = ACTIONS(3677),
    [anon_sym___asm__] = ACTIONS(3677),
    [anon_sym___asm] = ACTIONS(3677),
    [sym_number_literal] = ACTIONS(3679),
    [anon_sym_L_SQUOTE] = ACTIONS(3679),
    [anon_sym_u_SQUOTE] = ACTIONS(3679),
    [anon_sym_U_SQUOTE] = ACTIONS(3679),
    [anon_sym_u8_SQUOTE] = ACTIONS(3679),
    [anon_sym_SQUOTE] = ACTIONS(3679),
    [anon_sym_L_DQUOTE] = ACTIONS(3679),
    [anon_sym_u_DQUOTE] = ACTIONS(3679),
    [anon_sym_U_DQUOTE] = ACTIONS(3679),
    [anon_sym_u8_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [sym_true] = ACTIONS(3677),
    [sym_false] = ACTIONS(3677),
    [anon_sym_NULL] = ACTIONS(3677),
    [anon_sym_nullptr] = ACTIONS(3677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3677),
    [anon_sym_let] = ACTIONS(3677),
    [anon_sym_This] = ACTIONS(3677),
    [anon_sym_decltype] = ACTIONS(3677),
    [anon_sym_explicit] = ACTIONS(3677),
    [anon_sym_typename] = ACTIONS(3677),
    [anon_sym_template] = ACTIONS(3677),
    [anon_sym_operator] = ACTIONS(3677),
    [anon_sym_try] = ACTIONS(3677),
    [anon_sym_delete] = ACTIONS(3677),
    [anon_sym_throw] = ACTIONS(3677),
    [anon_sym_namespace] = ACTIONS(3677),
    [anon_sym_static_assert] = ACTIONS(3677),
    [anon_sym_concept] = ACTIONS(3677),
    [anon_sym_co_return] = ACTIONS(3677),
    [anon_sym_co_yield] = ACTIONS(3677),
    [anon_sym_R_DQUOTE] = ACTIONS(3679),
    [anon_sym_LR_DQUOTE] = ACTIONS(3679),
    [anon_sym_uR_DQUOTE] = ACTIONS(3679),
    [anon_sym_UR_DQUOTE] = ACTIONS(3679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3679),
    [anon_sym_co_await] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3677),
    [anon_sym_requires] = ACTIONS(3677),
    [sym_this] = ACTIONS(3677),
    [anon_sym_discard] = ACTIONS(3677),
    [anon_sym_precise] = ACTIONS(3677),
    [anon_sym_shared] = ACTIONS(3677),
    [anon_sym_groupshared] = ACTIONS(3677),
    [anon_sym_uniform] = ACTIONS(3677),
    [anon_sym_row_major] = ACTIONS(3677),
    [anon_sym_column_major] = ACTIONS(3677),
    [anon_sym_globallycoherent] = ACTIONS(3677),
    [anon_sym_centroid] = ACTIONS(3677),
    [anon_sym_noperspective] = ACTIONS(3677),
    [anon_sym_nointerpolation] = ACTIONS(3677),
    [anon_sym_sample] = ACTIONS(3677),
    [anon_sym_linear] = ACTIONS(3677),
    [anon_sym_snorm] = ACTIONS(3677),
    [anon_sym_unorm] = ACTIONS(3677),
    [anon_sym_point] = ACTIONS(3677),
    [anon_sym_line] = ACTIONS(3677),
    [anon_sym_triangleadj] = ACTIONS(3677),
    [anon_sym_lineadj] = ACTIONS(3677),
    [anon_sym_triangle] = ACTIONS(3677),
    [anon_sym_cbuffer] = ACTIONS(3677),
    [anon_sym_interface] = ACTIONS(3677),
    [anon_sym_extension] = ACTIONS(3677),
  },
  [1077] = {
    [sym_identifier] = ACTIONS(3967),
    [aux_sym_preproc_include_token1] = ACTIONS(3967),
    [aux_sym_preproc_def_token1] = ACTIONS(3967),
    [aux_sym_preproc_if_token1] = ACTIONS(3967),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3967),
    [sym_preproc_directive] = ACTIONS(3967),
    [anon_sym_LPAREN2] = ACTIONS(3969),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_TILDE] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_STAR] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_AMP] = ACTIONS(3967),
    [anon_sym_SEMI] = ACTIONS(3969),
    [anon_sym___extension__] = ACTIONS(3967),
    [anon_sym_typedef] = ACTIONS(3967),
    [anon_sym_in] = ACTIONS(3967),
    [anon_sym_out] = ACTIONS(3967),
    [anon_sym_inout] = ACTIONS(3967),
    [anon_sym_virtual] = ACTIONS(3967),
    [anon_sym_extern] = ACTIONS(3967),
    [anon_sym___attribute__] = ACTIONS(3967),
    [anon_sym___attribute] = ACTIONS(3967),
    [anon_sym_using] = ACTIONS(3967),
    [anon_sym_COLON_COLON] = ACTIONS(3969),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3969),
    [anon_sym___declspec] = ACTIONS(3967),
    [anon_sym___based] = ACTIONS(3967),
    [anon_sym___cdecl] = ACTIONS(3967),
    [anon_sym___clrcall] = ACTIONS(3967),
    [anon_sym___stdcall] = ACTIONS(3967),
    [anon_sym___fastcall] = ACTIONS(3967),
    [anon_sym___thiscall] = ACTIONS(3967),
    [anon_sym___vectorcall] = ACTIONS(3967),
    [anon_sym_LBRACE] = ACTIONS(3969),
    [anon_sym_RBRACE] = ACTIONS(3969),
    [anon_sym_signed] = ACTIONS(3967),
    [anon_sym_unsigned] = ACTIONS(3967),
    [anon_sym_long] = ACTIONS(3967),
    [anon_sym_short] = ACTIONS(3967),
    [anon_sym_LBRACK] = ACTIONS(3967),
    [anon_sym_static] = ACTIONS(3967),
    [anon_sym_register] = ACTIONS(3967),
    [anon_sym_inline] = ACTIONS(3967),
    [anon_sym___inline] = ACTIONS(3967),
    [anon_sym___inline__] = ACTIONS(3967),
    [anon_sym___forceinline] = ACTIONS(3967),
    [anon_sym_thread_local] = ACTIONS(3967),
    [anon_sym___thread] = ACTIONS(3967),
    [anon_sym_const] = ACTIONS(3967),
    [anon_sym_constexpr] = ACTIONS(3967),
    [anon_sym_volatile] = ACTIONS(3967),
    [anon_sym_restrict] = ACTIONS(3967),
    [anon_sym___restrict__] = ACTIONS(3967),
    [anon_sym__Atomic] = ACTIONS(3967),
    [anon_sym__Noreturn] = ACTIONS(3967),
    [anon_sym_noreturn] = ACTIONS(3967),
    [anon_sym__Nonnull] = ACTIONS(3967),
    [anon_sym_mutable] = ACTIONS(3967),
    [anon_sym_constinit] = ACTIONS(3967),
    [anon_sym_consteval] = ACTIONS(3967),
    [anon_sym_alignas] = ACTIONS(3967),
    [anon_sym__Alignas] = ACTIONS(3967),
    [sym_primitive_type] = ACTIONS(3967),
    [anon_sym_enum] = ACTIONS(3967),
    [anon_sym_class] = ACTIONS(3967),
    [anon_sym_struct] = ACTIONS(3967),
    [anon_sym_union] = ACTIONS(3967),
    [anon_sym_if] = ACTIONS(3967),
    [anon_sym_switch] = ACTIONS(3967),
    [anon_sym_case] = ACTIONS(3967),
    [anon_sym_default] = ACTIONS(3967),
    [anon_sym_while] = ACTIONS(3967),
    [anon_sym_do] = ACTIONS(3967),
    [anon_sym_for] = ACTIONS(3967),
    [anon_sym_return] = ACTIONS(3967),
    [anon_sym_break] = ACTIONS(3967),
    [anon_sym_continue] = ACTIONS(3967),
    [anon_sym_goto] = ACTIONS(3967),
    [anon_sym___try] = ACTIONS(3967),
    [anon_sym___leave] = ACTIONS(3967),
    [anon_sym_not] = ACTIONS(3967),
    [anon_sym_compl] = ACTIONS(3967),
    [anon_sym_DASH_DASH] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3969),
    [anon_sym_sizeof] = ACTIONS(3967),
    [anon_sym___alignof__] = ACTIONS(3967),
    [anon_sym___alignof] = ACTIONS(3967),
    [anon_sym__alignof] = ACTIONS(3967),
    [anon_sym_alignof] = ACTIONS(3967),
    [anon_sym__Alignof] = ACTIONS(3967),
    [anon_sym_offsetof] = ACTIONS(3967),
    [anon_sym__Generic] = ACTIONS(3967),
    [anon_sym_asm] = ACTIONS(3967),
    [anon_sym___asm__] = ACTIONS(3967),
    [anon_sym___asm] = ACTIONS(3967),
    [sym_number_literal] = ACTIONS(3969),
    [anon_sym_L_SQUOTE] = ACTIONS(3969),
    [anon_sym_u_SQUOTE] = ACTIONS(3969),
    [anon_sym_U_SQUOTE] = ACTIONS(3969),
    [anon_sym_u8_SQUOTE] = ACTIONS(3969),
    [anon_sym_SQUOTE] = ACTIONS(3969),
    [anon_sym_L_DQUOTE] = ACTIONS(3969),
    [anon_sym_u_DQUOTE] = ACTIONS(3969),
    [anon_sym_U_DQUOTE] = ACTIONS(3969),
    [anon_sym_u8_DQUOTE] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(3969),
    [sym_true] = ACTIONS(3967),
    [sym_false] = ACTIONS(3967),
    [anon_sym_NULL] = ACTIONS(3967),
    [anon_sym_nullptr] = ACTIONS(3967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3967),
    [anon_sym_let] = ACTIONS(3967),
    [anon_sym_This] = ACTIONS(3967),
    [anon_sym_decltype] = ACTIONS(3967),
    [anon_sym_explicit] = ACTIONS(3967),
    [anon_sym_typename] = ACTIONS(3967),
    [anon_sym_template] = ACTIONS(3967),
    [anon_sym_operator] = ACTIONS(3967),
    [anon_sym_try] = ACTIONS(3967),
    [anon_sym_delete] = ACTIONS(3967),
    [anon_sym_throw] = ACTIONS(3967),
    [anon_sym_namespace] = ACTIONS(3967),
    [anon_sym_static_assert] = ACTIONS(3967),
    [anon_sym_concept] = ACTIONS(3967),
    [anon_sym_co_return] = ACTIONS(3967),
    [anon_sym_co_yield] = ACTIONS(3967),
    [anon_sym_R_DQUOTE] = ACTIONS(3969),
    [anon_sym_LR_DQUOTE] = ACTIONS(3969),
    [anon_sym_uR_DQUOTE] = ACTIONS(3969),
    [anon_sym_UR_DQUOTE] = ACTIONS(3969),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3969),
    [anon_sym_co_await] = ACTIONS(3967),
    [anon_sym_new] = ACTIONS(3967),
    [anon_sym_requires] = ACTIONS(3967),
    [sym_this] = ACTIONS(3967),
    [anon_sym_discard] = ACTIONS(3967),
    [anon_sym_precise] = ACTIONS(3967),
    [anon_sym_shared] = ACTIONS(3967),
    [anon_sym_groupshared] = ACTIONS(3967),
    [anon_sym_uniform] = ACTIONS(3967),
    [anon_sym_row_major] = ACTIONS(3967),
    [anon_sym_column_major] = ACTIONS(3967),
    [anon_sym_globallycoherent] = ACTIONS(3967),
    [anon_sym_centroid] = ACTIONS(3967),
    [anon_sym_noperspective] = ACTIONS(3967),
    [anon_sym_nointerpolation] = ACTIONS(3967),
    [anon_sym_sample] = ACTIONS(3967),
    [anon_sym_linear] = ACTIONS(3967),
    [anon_sym_snorm] = ACTIONS(3967),
    [anon_sym_unorm] = ACTIONS(3967),
    [anon_sym_point] = ACTIONS(3967),
    [anon_sym_line] = ACTIONS(3967),
    [anon_sym_triangleadj] = ACTIONS(3967),
    [anon_sym_lineadj] = ACTIONS(3967),
    [anon_sym_triangle] = ACTIONS(3967),
    [anon_sym_cbuffer] = ACTIONS(3967),
    [anon_sym_interface] = ACTIONS(3967),
    [anon_sym_extension] = ACTIONS(3967),
  },
  [1078] = {
    [ts_builtin_sym_end] = ACTIONS(4349),
    [sym_identifier] = ACTIONS(4351),
    [aux_sym_preproc_include_token1] = ACTIONS(4351),
    [aux_sym_preproc_def_token1] = ACTIONS(4351),
    [aux_sym_preproc_if_token1] = ACTIONS(4351),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4351),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4351),
    [sym_preproc_directive] = ACTIONS(4351),
    [anon_sym_LPAREN2] = ACTIONS(4349),
    [anon_sym_BANG] = ACTIONS(4349),
    [anon_sym_TILDE] = ACTIONS(4349),
    [anon_sym_DASH] = ACTIONS(4351),
    [anon_sym_PLUS] = ACTIONS(4351),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_AMP] = ACTIONS(4351),
    [anon_sym_SEMI] = ACTIONS(4349),
    [anon_sym___extension__] = ACTIONS(4351),
    [anon_sym_typedef] = ACTIONS(4351),
    [anon_sym_in] = ACTIONS(4351),
    [anon_sym_out] = ACTIONS(4351),
    [anon_sym_inout] = ACTIONS(4351),
    [anon_sym_virtual] = ACTIONS(4351),
    [anon_sym_extern] = ACTIONS(4351),
    [anon_sym___attribute__] = ACTIONS(4351),
    [anon_sym___attribute] = ACTIONS(4351),
    [anon_sym_using] = ACTIONS(4351),
    [anon_sym_COLON_COLON] = ACTIONS(4349),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4349),
    [anon_sym___declspec] = ACTIONS(4351),
    [anon_sym___based] = ACTIONS(4351),
    [anon_sym___cdecl] = ACTIONS(4351),
    [anon_sym___clrcall] = ACTIONS(4351),
    [anon_sym___stdcall] = ACTIONS(4351),
    [anon_sym___fastcall] = ACTIONS(4351),
    [anon_sym___thiscall] = ACTIONS(4351),
    [anon_sym___vectorcall] = ACTIONS(4351),
    [anon_sym_LBRACE] = ACTIONS(4349),
    [anon_sym_signed] = ACTIONS(4351),
    [anon_sym_unsigned] = ACTIONS(4351),
    [anon_sym_long] = ACTIONS(4351),
    [anon_sym_short] = ACTIONS(4351),
    [anon_sym_LBRACK] = ACTIONS(4351),
    [anon_sym_static] = ACTIONS(4351),
    [anon_sym_register] = ACTIONS(4351),
    [anon_sym_inline] = ACTIONS(4351),
    [anon_sym___inline] = ACTIONS(4351),
    [anon_sym___inline__] = ACTIONS(4351),
    [anon_sym___forceinline] = ACTIONS(4351),
    [anon_sym_thread_local] = ACTIONS(4351),
    [anon_sym___thread] = ACTIONS(4351),
    [anon_sym_const] = ACTIONS(4351),
    [anon_sym_constexpr] = ACTIONS(4351),
    [anon_sym_volatile] = ACTIONS(4351),
    [anon_sym_restrict] = ACTIONS(4351),
    [anon_sym___restrict__] = ACTIONS(4351),
    [anon_sym__Atomic] = ACTIONS(4351),
    [anon_sym__Noreturn] = ACTIONS(4351),
    [anon_sym_noreturn] = ACTIONS(4351),
    [anon_sym__Nonnull] = ACTIONS(4351),
    [anon_sym_mutable] = ACTIONS(4351),
    [anon_sym_constinit] = ACTIONS(4351),
    [anon_sym_consteval] = ACTIONS(4351),
    [anon_sym_alignas] = ACTIONS(4351),
    [anon_sym__Alignas] = ACTIONS(4351),
    [sym_primitive_type] = ACTIONS(4351),
    [anon_sym_enum] = ACTIONS(4351),
    [anon_sym_class] = ACTIONS(4351),
    [anon_sym_struct] = ACTIONS(4351),
    [anon_sym_union] = ACTIONS(4351),
    [anon_sym_if] = ACTIONS(4351),
    [anon_sym_switch] = ACTIONS(4351),
    [anon_sym_case] = ACTIONS(4351),
    [anon_sym_default] = ACTIONS(4351),
    [anon_sym_while] = ACTIONS(4351),
    [anon_sym_do] = ACTIONS(4351),
    [anon_sym_for] = ACTIONS(4351),
    [anon_sym_return] = ACTIONS(4351),
    [anon_sym_break] = ACTIONS(4351),
    [anon_sym_continue] = ACTIONS(4351),
    [anon_sym_goto] = ACTIONS(4351),
    [anon_sym_not] = ACTIONS(4351),
    [anon_sym_compl] = ACTIONS(4351),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_sizeof] = ACTIONS(4351),
    [anon_sym___alignof__] = ACTIONS(4351),
    [anon_sym___alignof] = ACTIONS(4351),
    [anon_sym__alignof] = ACTIONS(4351),
    [anon_sym_alignof] = ACTIONS(4351),
    [anon_sym__Alignof] = ACTIONS(4351),
    [anon_sym_offsetof] = ACTIONS(4351),
    [anon_sym__Generic] = ACTIONS(4351),
    [anon_sym_asm] = ACTIONS(4351),
    [anon_sym___asm__] = ACTIONS(4351),
    [anon_sym___asm] = ACTIONS(4351),
    [sym_number_literal] = ACTIONS(4349),
    [anon_sym_L_SQUOTE] = ACTIONS(4349),
    [anon_sym_u_SQUOTE] = ACTIONS(4349),
    [anon_sym_U_SQUOTE] = ACTIONS(4349),
    [anon_sym_u8_SQUOTE] = ACTIONS(4349),
    [anon_sym_SQUOTE] = ACTIONS(4349),
    [anon_sym_L_DQUOTE] = ACTIONS(4349),
    [anon_sym_u_DQUOTE] = ACTIONS(4349),
    [anon_sym_U_DQUOTE] = ACTIONS(4349),
    [anon_sym_u8_DQUOTE] = ACTIONS(4349),
    [anon_sym_DQUOTE] = ACTIONS(4349),
    [sym_true] = ACTIONS(4351),
    [sym_false] = ACTIONS(4351),
    [anon_sym_NULL] = ACTIONS(4351),
    [anon_sym_nullptr] = ACTIONS(4351),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4351),
    [anon_sym_let] = ACTIONS(4351),
    [anon_sym_This] = ACTIONS(4351),
    [anon_sym_decltype] = ACTIONS(4351),
    [anon_sym_explicit] = ACTIONS(4351),
    [anon_sym_typename] = ACTIONS(4351),
    [anon_sym_export] = ACTIONS(4351),
    [anon_sym_module] = ACTIONS(4351),
    [anon_sym_import] = ACTIONS(4351),
    [anon_sym_template] = ACTIONS(4351),
    [anon_sym_operator] = ACTIONS(4351),
    [anon_sym_try] = ACTIONS(4351),
    [anon_sym_delete] = ACTIONS(4351),
    [anon_sym_throw] = ACTIONS(4351),
    [anon_sym_namespace] = ACTIONS(4351),
    [anon_sym_static_assert] = ACTIONS(4351),
    [anon_sym_concept] = ACTIONS(4351),
    [anon_sym_co_return] = ACTIONS(4351),
    [anon_sym_co_yield] = ACTIONS(4351),
    [anon_sym_R_DQUOTE] = ACTIONS(4349),
    [anon_sym_LR_DQUOTE] = ACTIONS(4349),
    [anon_sym_uR_DQUOTE] = ACTIONS(4349),
    [anon_sym_UR_DQUOTE] = ACTIONS(4349),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4349),
    [anon_sym_co_await] = ACTIONS(4351),
    [anon_sym_new] = ACTIONS(4351),
    [anon_sym_requires] = ACTIONS(4351),
    [sym_this] = ACTIONS(4351),
    [anon_sym_precise] = ACTIONS(4351),
    [anon_sym_shared] = ACTIONS(4351),
    [anon_sym_groupshared] = ACTIONS(4351),
    [anon_sym_uniform] = ACTIONS(4351),
    [anon_sym_row_major] = ACTIONS(4351),
    [anon_sym_column_major] = ACTIONS(4351),
    [anon_sym_globallycoherent] = ACTIONS(4351),
    [anon_sym_centroid] = ACTIONS(4351),
    [anon_sym_noperspective] = ACTIONS(4351),
    [anon_sym_nointerpolation] = ACTIONS(4351),
    [anon_sym_sample] = ACTIONS(4351),
    [anon_sym_linear] = ACTIONS(4351),
    [anon_sym_snorm] = ACTIONS(4351),
    [anon_sym_unorm] = ACTIONS(4351),
    [anon_sym_point] = ACTIONS(4351),
    [anon_sym_line] = ACTIONS(4351),
    [anon_sym_triangleadj] = ACTIONS(4351),
    [anon_sym_lineadj] = ACTIONS(4351),
    [anon_sym_triangle] = ACTIONS(4351),
    [anon_sym_interface] = ACTIONS(4351),
    [anon_sym_extension] = ACTIONS(4351),
    [anon_sym___exported] = ACTIONS(4351),
  },
  [1079] = {
    [ts_builtin_sym_end] = ACTIONS(4353),
    [sym_identifier] = ACTIONS(4355),
    [aux_sym_preproc_include_token1] = ACTIONS(4355),
    [aux_sym_preproc_def_token1] = ACTIONS(4355),
    [aux_sym_preproc_if_token1] = ACTIONS(4355),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4355),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4355),
    [sym_preproc_directive] = ACTIONS(4355),
    [anon_sym_LPAREN2] = ACTIONS(4353),
    [anon_sym_BANG] = ACTIONS(4353),
    [anon_sym_TILDE] = ACTIONS(4353),
    [anon_sym_DASH] = ACTIONS(4355),
    [anon_sym_PLUS] = ACTIONS(4355),
    [anon_sym_STAR] = ACTIONS(4353),
    [anon_sym_AMP_AMP] = ACTIONS(4353),
    [anon_sym_AMP] = ACTIONS(4355),
    [anon_sym_SEMI] = ACTIONS(4353),
    [anon_sym___extension__] = ACTIONS(4355),
    [anon_sym_typedef] = ACTIONS(4355),
    [anon_sym_in] = ACTIONS(4355),
    [anon_sym_out] = ACTIONS(4355),
    [anon_sym_inout] = ACTIONS(4355),
    [anon_sym_virtual] = ACTIONS(4355),
    [anon_sym_extern] = ACTIONS(4355),
    [anon_sym___attribute__] = ACTIONS(4355),
    [anon_sym___attribute] = ACTIONS(4355),
    [anon_sym_using] = ACTIONS(4355),
    [anon_sym_COLON_COLON] = ACTIONS(4353),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4353),
    [anon_sym___declspec] = ACTIONS(4355),
    [anon_sym___based] = ACTIONS(4355),
    [anon_sym___cdecl] = ACTIONS(4355),
    [anon_sym___clrcall] = ACTIONS(4355),
    [anon_sym___stdcall] = ACTIONS(4355),
    [anon_sym___fastcall] = ACTIONS(4355),
    [anon_sym___thiscall] = ACTIONS(4355),
    [anon_sym___vectorcall] = ACTIONS(4355),
    [anon_sym_LBRACE] = ACTIONS(4353),
    [anon_sym_signed] = ACTIONS(4355),
    [anon_sym_unsigned] = ACTIONS(4355),
    [anon_sym_long] = ACTIONS(4355),
    [anon_sym_short] = ACTIONS(4355),
    [anon_sym_LBRACK] = ACTIONS(4355),
    [anon_sym_static] = ACTIONS(4355),
    [anon_sym_register] = ACTIONS(4355),
    [anon_sym_inline] = ACTIONS(4355),
    [anon_sym___inline] = ACTIONS(4355),
    [anon_sym___inline__] = ACTIONS(4355),
    [anon_sym___forceinline] = ACTIONS(4355),
    [anon_sym_thread_local] = ACTIONS(4355),
    [anon_sym___thread] = ACTIONS(4355),
    [anon_sym_const] = ACTIONS(4355),
    [anon_sym_constexpr] = ACTIONS(4355),
    [anon_sym_volatile] = ACTIONS(4355),
    [anon_sym_restrict] = ACTIONS(4355),
    [anon_sym___restrict__] = ACTIONS(4355),
    [anon_sym__Atomic] = ACTIONS(4355),
    [anon_sym__Noreturn] = ACTIONS(4355),
    [anon_sym_noreturn] = ACTIONS(4355),
    [anon_sym__Nonnull] = ACTIONS(4355),
    [anon_sym_mutable] = ACTIONS(4355),
    [anon_sym_constinit] = ACTIONS(4355),
    [anon_sym_consteval] = ACTIONS(4355),
    [anon_sym_alignas] = ACTIONS(4355),
    [anon_sym__Alignas] = ACTIONS(4355),
    [sym_primitive_type] = ACTIONS(4355),
    [anon_sym_enum] = ACTIONS(4355),
    [anon_sym_class] = ACTIONS(4355),
    [anon_sym_struct] = ACTIONS(4355),
    [anon_sym_union] = ACTIONS(4355),
    [anon_sym_if] = ACTIONS(4355),
    [anon_sym_switch] = ACTIONS(4355),
    [anon_sym_case] = ACTIONS(4355),
    [anon_sym_default] = ACTIONS(4355),
    [anon_sym_while] = ACTIONS(4355),
    [anon_sym_do] = ACTIONS(4355),
    [anon_sym_for] = ACTIONS(4355),
    [anon_sym_return] = ACTIONS(4355),
    [anon_sym_break] = ACTIONS(4355),
    [anon_sym_continue] = ACTIONS(4355),
    [anon_sym_goto] = ACTIONS(4355),
    [anon_sym_not] = ACTIONS(4355),
    [anon_sym_compl] = ACTIONS(4355),
    [anon_sym_DASH_DASH] = ACTIONS(4353),
    [anon_sym_PLUS_PLUS] = ACTIONS(4353),
    [anon_sym_sizeof] = ACTIONS(4355),
    [anon_sym___alignof__] = ACTIONS(4355),
    [anon_sym___alignof] = ACTIONS(4355),
    [anon_sym__alignof] = ACTIONS(4355),
    [anon_sym_alignof] = ACTIONS(4355),
    [anon_sym__Alignof] = ACTIONS(4355),
    [anon_sym_offsetof] = ACTIONS(4355),
    [anon_sym__Generic] = ACTIONS(4355),
    [anon_sym_asm] = ACTIONS(4355),
    [anon_sym___asm__] = ACTIONS(4355),
    [anon_sym___asm] = ACTIONS(4355),
    [sym_number_literal] = ACTIONS(4353),
    [anon_sym_L_SQUOTE] = ACTIONS(4353),
    [anon_sym_u_SQUOTE] = ACTIONS(4353),
    [anon_sym_U_SQUOTE] = ACTIONS(4353),
    [anon_sym_u8_SQUOTE] = ACTIONS(4353),
    [anon_sym_SQUOTE] = ACTIONS(4353),
    [anon_sym_L_DQUOTE] = ACTIONS(4353),
    [anon_sym_u_DQUOTE] = ACTIONS(4353),
    [anon_sym_U_DQUOTE] = ACTIONS(4353),
    [anon_sym_u8_DQUOTE] = ACTIONS(4353),
    [anon_sym_DQUOTE] = ACTIONS(4353),
    [sym_true] = ACTIONS(4355),
    [sym_false] = ACTIONS(4355),
    [anon_sym_NULL] = ACTIONS(4355),
    [anon_sym_nullptr] = ACTIONS(4355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4355),
    [anon_sym_let] = ACTIONS(4355),
    [anon_sym_This] = ACTIONS(4355),
    [anon_sym_decltype] = ACTIONS(4355),
    [anon_sym_explicit] = ACTIONS(4355),
    [anon_sym_typename] = ACTIONS(4355),
    [anon_sym_export] = ACTIONS(4355),
    [anon_sym_module] = ACTIONS(4355),
    [anon_sym_import] = ACTIONS(4355),
    [anon_sym_template] = ACTIONS(4355),
    [anon_sym_operator] = ACTIONS(4355),
    [anon_sym_try] = ACTIONS(4355),
    [anon_sym_delete] = ACTIONS(4355),
    [anon_sym_throw] = ACTIONS(4355),
    [anon_sym_namespace] = ACTIONS(4355),
    [anon_sym_static_assert] = ACTIONS(4355),
    [anon_sym_concept] = ACTIONS(4355),
    [anon_sym_co_return] = ACTIONS(4355),
    [anon_sym_co_yield] = ACTIONS(4355),
    [anon_sym_R_DQUOTE] = ACTIONS(4353),
    [anon_sym_LR_DQUOTE] = ACTIONS(4353),
    [anon_sym_uR_DQUOTE] = ACTIONS(4353),
    [anon_sym_UR_DQUOTE] = ACTIONS(4353),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4353),
    [anon_sym_co_await] = ACTIONS(4355),
    [anon_sym_new] = ACTIONS(4355),
    [anon_sym_requires] = ACTIONS(4355),
    [sym_this] = ACTIONS(4355),
    [anon_sym_precise] = ACTIONS(4355),
    [anon_sym_shared] = ACTIONS(4355),
    [anon_sym_groupshared] = ACTIONS(4355),
    [anon_sym_uniform] = ACTIONS(4355),
    [anon_sym_row_major] = ACTIONS(4355),
    [anon_sym_column_major] = ACTIONS(4355),
    [anon_sym_globallycoherent] = ACTIONS(4355),
    [anon_sym_centroid] = ACTIONS(4355),
    [anon_sym_noperspective] = ACTIONS(4355),
    [anon_sym_nointerpolation] = ACTIONS(4355),
    [anon_sym_sample] = ACTIONS(4355),
    [anon_sym_linear] = ACTIONS(4355),
    [anon_sym_snorm] = ACTIONS(4355),
    [anon_sym_unorm] = ACTIONS(4355),
    [anon_sym_point] = ACTIONS(4355),
    [anon_sym_line] = ACTIONS(4355),
    [anon_sym_triangleadj] = ACTIONS(4355),
    [anon_sym_lineadj] = ACTIONS(4355),
    [anon_sym_triangle] = ACTIONS(4355),
    [anon_sym_interface] = ACTIONS(4355),
    [anon_sym_extension] = ACTIONS(4355),
    [anon_sym___exported] = ACTIONS(4355),
  },
  [1080] = {
    [ts_builtin_sym_end] = ACTIONS(4357),
    [sym_identifier] = ACTIONS(4359),
    [aux_sym_preproc_include_token1] = ACTIONS(4359),
    [aux_sym_preproc_def_token1] = ACTIONS(4359),
    [aux_sym_preproc_if_token1] = ACTIONS(4359),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4359),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4359),
    [sym_preproc_directive] = ACTIONS(4359),
    [anon_sym_LPAREN2] = ACTIONS(4357),
    [anon_sym_BANG] = ACTIONS(4357),
    [anon_sym_TILDE] = ACTIONS(4357),
    [anon_sym_DASH] = ACTIONS(4359),
    [anon_sym_PLUS] = ACTIONS(4359),
    [anon_sym_STAR] = ACTIONS(4357),
    [anon_sym_AMP_AMP] = ACTIONS(4357),
    [anon_sym_AMP] = ACTIONS(4359),
    [anon_sym_SEMI] = ACTIONS(4357),
    [anon_sym___extension__] = ACTIONS(4359),
    [anon_sym_typedef] = ACTIONS(4359),
    [anon_sym_in] = ACTIONS(4359),
    [anon_sym_out] = ACTIONS(4359),
    [anon_sym_inout] = ACTIONS(4359),
    [anon_sym_virtual] = ACTIONS(4359),
    [anon_sym_extern] = ACTIONS(4359),
    [anon_sym___attribute__] = ACTIONS(4359),
    [anon_sym___attribute] = ACTIONS(4359),
    [anon_sym_using] = ACTIONS(4359),
    [anon_sym_COLON_COLON] = ACTIONS(4357),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4357),
    [anon_sym___declspec] = ACTIONS(4359),
    [anon_sym___based] = ACTIONS(4359),
    [anon_sym___cdecl] = ACTIONS(4359),
    [anon_sym___clrcall] = ACTIONS(4359),
    [anon_sym___stdcall] = ACTIONS(4359),
    [anon_sym___fastcall] = ACTIONS(4359),
    [anon_sym___thiscall] = ACTIONS(4359),
    [anon_sym___vectorcall] = ACTIONS(4359),
    [anon_sym_LBRACE] = ACTIONS(4357),
    [anon_sym_signed] = ACTIONS(4359),
    [anon_sym_unsigned] = ACTIONS(4359),
    [anon_sym_long] = ACTIONS(4359),
    [anon_sym_short] = ACTIONS(4359),
    [anon_sym_LBRACK] = ACTIONS(4359),
    [anon_sym_static] = ACTIONS(4359),
    [anon_sym_register] = ACTIONS(4359),
    [anon_sym_inline] = ACTIONS(4359),
    [anon_sym___inline] = ACTIONS(4359),
    [anon_sym___inline__] = ACTIONS(4359),
    [anon_sym___forceinline] = ACTIONS(4359),
    [anon_sym_thread_local] = ACTIONS(4359),
    [anon_sym___thread] = ACTIONS(4359),
    [anon_sym_const] = ACTIONS(4359),
    [anon_sym_constexpr] = ACTIONS(4359),
    [anon_sym_volatile] = ACTIONS(4359),
    [anon_sym_restrict] = ACTIONS(4359),
    [anon_sym___restrict__] = ACTIONS(4359),
    [anon_sym__Atomic] = ACTIONS(4359),
    [anon_sym__Noreturn] = ACTIONS(4359),
    [anon_sym_noreturn] = ACTIONS(4359),
    [anon_sym__Nonnull] = ACTIONS(4359),
    [anon_sym_mutable] = ACTIONS(4359),
    [anon_sym_constinit] = ACTIONS(4359),
    [anon_sym_consteval] = ACTIONS(4359),
    [anon_sym_alignas] = ACTIONS(4359),
    [anon_sym__Alignas] = ACTIONS(4359),
    [sym_primitive_type] = ACTIONS(4359),
    [anon_sym_enum] = ACTIONS(4359),
    [anon_sym_class] = ACTIONS(4359),
    [anon_sym_struct] = ACTIONS(4359),
    [anon_sym_union] = ACTIONS(4359),
    [anon_sym_if] = ACTIONS(4359),
    [anon_sym_switch] = ACTIONS(4359),
    [anon_sym_case] = ACTIONS(4359),
    [anon_sym_default] = ACTIONS(4359),
    [anon_sym_while] = ACTIONS(4359),
    [anon_sym_do] = ACTIONS(4359),
    [anon_sym_for] = ACTIONS(4359),
    [anon_sym_return] = ACTIONS(4359),
    [anon_sym_break] = ACTIONS(4359),
    [anon_sym_continue] = ACTIONS(4359),
    [anon_sym_goto] = ACTIONS(4359),
    [anon_sym_not] = ACTIONS(4359),
    [anon_sym_compl] = ACTIONS(4359),
    [anon_sym_DASH_DASH] = ACTIONS(4357),
    [anon_sym_PLUS_PLUS] = ACTIONS(4357),
    [anon_sym_sizeof] = ACTIONS(4359),
    [anon_sym___alignof__] = ACTIONS(4359),
    [anon_sym___alignof] = ACTIONS(4359),
    [anon_sym__alignof] = ACTIONS(4359),
    [anon_sym_alignof] = ACTIONS(4359),
    [anon_sym__Alignof] = ACTIONS(4359),
    [anon_sym_offsetof] = ACTIONS(4359),
    [anon_sym__Generic] = ACTIONS(4359),
    [anon_sym_asm] = ACTIONS(4359),
    [anon_sym___asm__] = ACTIONS(4359),
    [anon_sym___asm] = ACTIONS(4359),
    [sym_number_literal] = ACTIONS(4357),
    [anon_sym_L_SQUOTE] = ACTIONS(4357),
    [anon_sym_u_SQUOTE] = ACTIONS(4357),
    [anon_sym_U_SQUOTE] = ACTIONS(4357),
    [anon_sym_u8_SQUOTE] = ACTIONS(4357),
    [anon_sym_SQUOTE] = ACTIONS(4357),
    [anon_sym_L_DQUOTE] = ACTIONS(4357),
    [anon_sym_u_DQUOTE] = ACTIONS(4357),
    [anon_sym_U_DQUOTE] = ACTIONS(4357),
    [anon_sym_u8_DQUOTE] = ACTIONS(4357),
    [anon_sym_DQUOTE] = ACTIONS(4357),
    [sym_true] = ACTIONS(4359),
    [sym_false] = ACTIONS(4359),
    [anon_sym_NULL] = ACTIONS(4359),
    [anon_sym_nullptr] = ACTIONS(4359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4359),
    [anon_sym_let] = ACTIONS(4359),
    [anon_sym_This] = ACTIONS(4359),
    [anon_sym_decltype] = ACTIONS(4359),
    [anon_sym_explicit] = ACTIONS(4359),
    [anon_sym_typename] = ACTIONS(4359),
    [anon_sym_export] = ACTIONS(4359),
    [anon_sym_module] = ACTIONS(4359),
    [anon_sym_import] = ACTIONS(4359),
    [anon_sym_template] = ACTIONS(4359),
    [anon_sym_operator] = ACTIONS(4359),
    [anon_sym_try] = ACTIONS(4359),
    [anon_sym_delete] = ACTIONS(4359),
    [anon_sym_throw] = ACTIONS(4359),
    [anon_sym_namespace] = ACTIONS(4359),
    [anon_sym_static_assert] = ACTIONS(4359),
    [anon_sym_concept] = ACTIONS(4359),
    [anon_sym_co_return] = ACTIONS(4359),
    [anon_sym_co_yield] = ACTIONS(4359),
    [anon_sym_R_DQUOTE] = ACTIONS(4357),
    [anon_sym_LR_DQUOTE] = ACTIONS(4357),
    [anon_sym_uR_DQUOTE] = ACTIONS(4357),
    [anon_sym_UR_DQUOTE] = ACTIONS(4357),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4357),
    [anon_sym_co_await] = ACTIONS(4359),
    [anon_sym_new] = ACTIONS(4359),
    [anon_sym_requires] = ACTIONS(4359),
    [sym_this] = ACTIONS(4359),
    [anon_sym_precise] = ACTIONS(4359),
    [anon_sym_shared] = ACTIONS(4359),
    [anon_sym_groupshared] = ACTIONS(4359),
    [anon_sym_uniform] = ACTIONS(4359),
    [anon_sym_row_major] = ACTIONS(4359),
    [anon_sym_column_major] = ACTIONS(4359),
    [anon_sym_globallycoherent] = ACTIONS(4359),
    [anon_sym_centroid] = ACTIONS(4359),
    [anon_sym_noperspective] = ACTIONS(4359),
    [anon_sym_nointerpolation] = ACTIONS(4359),
    [anon_sym_sample] = ACTIONS(4359),
    [anon_sym_linear] = ACTIONS(4359),
    [anon_sym_snorm] = ACTIONS(4359),
    [anon_sym_unorm] = ACTIONS(4359),
    [anon_sym_point] = ACTIONS(4359),
    [anon_sym_line] = ACTIONS(4359),
    [anon_sym_triangleadj] = ACTIONS(4359),
    [anon_sym_lineadj] = ACTIONS(4359),
    [anon_sym_triangle] = ACTIONS(4359),
    [anon_sym_interface] = ACTIONS(4359),
    [anon_sym_extension] = ACTIONS(4359),
    [anon_sym___exported] = ACTIONS(4359),
  },
  [1081] = {
    [ts_builtin_sym_end] = ACTIONS(4361),
    [sym_identifier] = ACTIONS(4363),
    [aux_sym_preproc_include_token1] = ACTIONS(4363),
    [aux_sym_preproc_def_token1] = ACTIONS(4363),
    [aux_sym_preproc_if_token1] = ACTIONS(4363),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4363),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4363),
    [sym_preproc_directive] = ACTIONS(4363),
    [anon_sym_LPAREN2] = ACTIONS(4361),
    [anon_sym_BANG] = ACTIONS(4361),
    [anon_sym_TILDE] = ACTIONS(4361),
    [anon_sym_DASH] = ACTIONS(4363),
    [anon_sym_PLUS] = ACTIONS(4363),
    [anon_sym_STAR] = ACTIONS(4361),
    [anon_sym_AMP_AMP] = ACTIONS(4361),
    [anon_sym_AMP] = ACTIONS(4363),
    [anon_sym_SEMI] = ACTIONS(4361),
    [anon_sym___extension__] = ACTIONS(4363),
    [anon_sym_typedef] = ACTIONS(4363),
    [anon_sym_in] = ACTIONS(4363),
    [anon_sym_out] = ACTIONS(4363),
    [anon_sym_inout] = ACTIONS(4363),
    [anon_sym_virtual] = ACTIONS(4363),
    [anon_sym_extern] = ACTIONS(4363),
    [anon_sym___attribute__] = ACTIONS(4363),
    [anon_sym___attribute] = ACTIONS(4363),
    [anon_sym_using] = ACTIONS(4363),
    [anon_sym_COLON_COLON] = ACTIONS(4361),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4361),
    [anon_sym___declspec] = ACTIONS(4363),
    [anon_sym___based] = ACTIONS(4363),
    [anon_sym___cdecl] = ACTIONS(4363),
    [anon_sym___clrcall] = ACTIONS(4363),
    [anon_sym___stdcall] = ACTIONS(4363),
    [anon_sym___fastcall] = ACTIONS(4363),
    [anon_sym___thiscall] = ACTIONS(4363),
    [anon_sym___vectorcall] = ACTIONS(4363),
    [anon_sym_LBRACE] = ACTIONS(4361),
    [anon_sym_signed] = ACTIONS(4363),
    [anon_sym_unsigned] = ACTIONS(4363),
    [anon_sym_long] = ACTIONS(4363),
    [anon_sym_short] = ACTIONS(4363),
    [anon_sym_LBRACK] = ACTIONS(4363),
    [anon_sym_static] = ACTIONS(4363),
    [anon_sym_register] = ACTIONS(4363),
    [anon_sym_inline] = ACTIONS(4363),
    [anon_sym___inline] = ACTIONS(4363),
    [anon_sym___inline__] = ACTIONS(4363),
    [anon_sym___forceinline] = ACTIONS(4363),
    [anon_sym_thread_local] = ACTIONS(4363),
    [anon_sym___thread] = ACTIONS(4363),
    [anon_sym_const] = ACTIONS(4363),
    [anon_sym_constexpr] = ACTIONS(4363),
    [anon_sym_volatile] = ACTIONS(4363),
    [anon_sym_restrict] = ACTIONS(4363),
    [anon_sym___restrict__] = ACTIONS(4363),
    [anon_sym__Atomic] = ACTIONS(4363),
    [anon_sym__Noreturn] = ACTIONS(4363),
    [anon_sym_noreturn] = ACTIONS(4363),
    [anon_sym__Nonnull] = ACTIONS(4363),
    [anon_sym_mutable] = ACTIONS(4363),
    [anon_sym_constinit] = ACTIONS(4363),
    [anon_sym_consteval] = ACTIONS(4363),
    [anon_sym_alignas] = ACTIONS(4363),
    [anon_sym__Alignas] = ACTIONS(4363),
    [sym_primitive_type] = ACTIONS(4363),
    [anon_sym_enum] = ACTIONS(4363),
    [anon_sym_class] = ACTIONS(4363),
    [anon_sym_struct] = ACTIONS(4363),
    [anon_sym_union] = ACTIONS(4363),
    [anon_sym_if] = ACTIONS(4363),
    [anon_sym_switch] = ACTIONS(4363),
    [anon_sym_case] = ACTIONS(4363),
    [anon_sym_default] = ACTIONS(4363),
    [anon_sym_while] = ACTIONS(4363),
    [anon_sym_do] = ACTIONS(4363),
    [anon_sym_for] = ACTIONS(4363),
    [anon_sym_return] = ACTIONS(4363),
    [anon_sym_break] = ACTIONS(4363),
    [anon_sym_continue] = ACTIONS(4363),
    [anon_sym_goto] = ACTIONS(4363),
    [anon_sym_not] = ACTIONS(4363),
    [anon_sym_compl] = ACTIONS(4363),
    [anon_sym_DASH_DASH] = ACTIONS(4361),
    [anon_sym_PLUS_PLUS] = ACTIONS(4361),
    [anon_sym_sizeof] = ACTIONS(4363),
    [anon_sym___alignof__] = ACTIONS(4363),
    [anon_sym___alignof] = ACTIONS(4363),
    [anon_sym__alignof] = ACTIONS(4363),
    [anon_sym_alignof] = ACTIONS(4363),
    [anon_sym__Alignof] = ACTIONS(4363),
    [anon_sym_offsetof] = ACTIONS(4363),
    [anon_sym__Generic] = ACTIONS(4363),
    [anon_sym_asm] = ACTIONS(4363),
    [anon_sym___asm__] = ACTIONS(4363),
    [anon_sym___asm] = ACTIONS(4363),
    [sym_number_literal] = ACTIONS(4361),
    [anon_sym_L_SQUOTE] = ACTIONS(4361),
    [anon_sym_u_SQUOTE] = ACTIONS(4361),
    [anon_sym_U_SQUOTE] = ACTIONS(4361),
    [anon_sym_u8_SQUOTE] = ACTIONS(4361),
    [anon_sym_SQUOTE] = ACTIONS(4361),
    [anon_sym_L_DQUOTE] = ACTIONS(4361),
    [anon_sym_u_DQUOTE] = ACTIONS(4361),
    [anon_sym_U_DQUOTE] = ACTIONS(4361),
    [anon_sym_u8_DQUOTE] = ACTIONS(4361),
    [anon_sym_DQUOTE] = ACTIONS(4361),
    [sym_true] = ACTIONS(4363),
    [sym_false] = ACTIONS(4363),
    [anon_sym_NULL] = ACTIONS(4363),
    [anon_sym_nullptr] = ACTIONS(4363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4363),
    [anon_sym_let] = ACTIONS(4363),
    [anon_sym_This] = ACTIONS(4363),
    [anon_sym_decltype] = ACTIONS(4363),
    [anon_sym_explicit] = ACTIONS(4363),
    [anon_sym_typename] = ACTIONS(4363),
    [anon_sym_export] = ACTIONS(4363),
    [anon_sym_module] = ACTIONS(4363),
    [anon_sym_import] = ACTIONS(4363),
    [anon_sym_template] = ACTIONS(4363),
    [anon_sym_operator] = ACTIONS(4363),
    [anon_sym_try] = ACTIONS(4363),
    [anon_sym_delete] = ACTIONS(4363),
    [anon_sym_throw] = ACTIONS(4363),
    [anon_sym_namespace] = ACTIONS(4363),
    [anon_sym_static_assert] = ACTIONS(4363),
    [anon_sym_concept] = ACTIONS(4363),
    [anon_sym_co_return] = ACTIONS(4363),
    [anon_sym_co_yield] = ACTIONS(4363),
    [anon_sym_R_DQUOTE] = ACTIONS(4361),
    [anon_sym_LR_DQUOTE] = ACTIONS(4361),
    [anon_sym_uR_DQUOTE] = ACTIONS(4361),
    [anon_sym_UR_DQUOTE] = ACTIONS(4361),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4361),
    [anon_sym_co_await] = ACTIONS(4363),
    [anon_sym_new] = ACTIONS(4363),
    [anon_sym_requires] = ACTIONS(4363),
    [sym_this] = ACTIONS(4363),
    [anon_sym_precise] = ACTIONS(4363),
    [anon_sym_shared] = ACTIONS(4363),
    [anon_sym_groupshared] = ACTIONS(4363),
    [anon_sym_uniform] = ACTIONS(4363),
    [anon_sym_row_major] = ACTIONS(4363),
    [anon_sym_column_major] = ACTIONS(4363),
    [anon_sym_globallycoherent] = ACTIONS(4363),
    [anon_sym_centroid] = ACTIONS(4363),
    [anon_sym_noperspective] = ACTIONS(4363),
    [anon_sym_nointerpolation] = ACTIONS(4363),
    [anon_sym_sample] = ACTIONS(4363),
    [anon_sym_linear] = ACTIONS(4363),
    [anon_sym_snorm] = ACTIONS(4363),
    [anon_sym_unorm] = ACTIONS(4363),
    [anon_sym_point] = ACTIONS(4363),
    [anon_sym_line] = ACTIONS(4363),
    [anon_sym_triangleadj] = ACTIONS(4363),
    [anon_sym_lineadj] = ACTIONS(4363),
    [anon_sym_triangle] = ACTIONS(4363),
    [anon_sym_interface] = ACTIONS(4363),
    [anon_sym_extension] = ACTIONS(4363),
    [anon_sym___exported] = ACTIONS(4363),
  },
  [1082] = {
    [sym_identifier] = ACTIONS(3796),
    [aux_sym_preproc_include_token1] = ACTIONS(3796),
    [aux_sym_preproc_def_token1] = ACTIONS(3796),
    [aux_sym_preproc_if_token1] = ACTIONS(3796),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3796),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3796),
    [sym_preproc_directive] = ACTIONS(3796),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3798),
    [anon_sym_TILDE] = ACTIONS(3798),
    [anon_sym_DASH] = ACTIONS(3796),
    [anon_sym_PLUS] = ACTIONS(3796),
    [anon_sym_STAR] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_AMP] = ACTIONS(3796),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym___extension__] = ACTIONS(3796),
    [anon_sym_typedef] = ACTIONS(3796),
    [anon_sym_in] = ACTIONS(3796),
    [anon_sym_out] = ACTIONS(3796),
    [anon_sym_inout] = ACTIONS(3796),
    [anon_sym_virtual] = ACTIONS(3796),
    [anon_sym_extern] = ACTIONS(3796),
    [anon_sym___attribute__] = ACTIONS(3796),
    [anon_sym___attribute] = ACTIONS(3796),
    [anon_sym_using] = ACTIONS(3796),
    [anon_sym_COLON_COLON] = ACTIONS(3798),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3798),
    [anon_sym___declspec] = ACTIONS(3796),
    [anon_sym___based] = ACTIONS(3796),
    [anon_sym___cdecl] = ACTIONS(3796),
    [anon_sym___clrcall] = ACTIONS(3796),
    [anon_sym___stdcall] = ACTIONS(3796),
    [anon_sym___fastcall] = ACTIONS(3796),
    [anon_sym___thiscall] = ACTIONS(3796),
    [anon_sym___vectorcall] = ACTIONS(3796),
    [anon_sym_LBRACE] = ACTIONS(3798),
    [anon_sym_RBRACE] = ACTIONS(3798),
    [anon_sym_signed] = ACTIONS(3796),
    [anon_sym_unsigned] = ACTIONS(3796),
    [anon_sym_long] = ACTIONS(3796),
    [anon_sym_short] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3796),
    [anon_sym_static] = ACTIONS(3796),
    [anon_sym_register] = ACTIONS(3796),
    [anon_sym_inline] = ACTIONS(3796),
    [anon_sym___inline] = ACTIONS(3796),
    [anon_sym___inline__] = ACTIONS(3796),
    [anon_sym___forceinline] = ACTIONS(3796),
    [anon_sym_thread_local] = ACTIONS(3796),
    [anon_sym___thread] = ACTIONS(3796),
    [anon_sym_const] = ACTIONS(3796),
    [anon_sym_constexpr] = ACTIONS(3796),
    [anon_sym_volatile] = ACTIONS(3796),
    [anon_sym_restrict] = ACTIONS(3796),
    [anon_sym___restrict__] = ACTIONS(3796),
    [anon_sym__Atomic] = ACTIONS(3796),
    [anon_sym__Noreturn] = ACTIONS(3796),
    [anon_sym_noreturn] = ACTIONS(3796),
    [anon_sym__Nonnull] = ACTIONS(3796),
    [anon_sym_mutable] = ACTIONS(3796),
    [anon_sym_constinit] = ACTIONS(3796),
    [anon_sym_consteval] = ACTIONS(3796),
    [anon_sym_alignas] = ACTIONS(3796),
    [anon_sym__Alignas] = ACTIONS(3796),
    [sym_primitive_type] = ACTIONS(3796),
    [anon_sym_enum] = ACTIONS(3796),
    [anon_sym_class] = ACTIONS(3796),
    [anon_sym_struct] = ACTIONS(3796),
    [anon_sym_union] = ACTIONS(3796),
    [anon_sym_if] = ACTIONS(3796),
    [anon_sym_switch] = ACTIONS(3796),
    [anon_sym_case] = ACTIONS(3796),
    [anon_sym_default] = ACTIONS(3796),
    [anon_sym_while] = ACTIONS(3796),
    [anon_sym_do] = ACTIONS(3796),
    [anon_sym_for] = ACTIONS(3796),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_break] = ACTIONS(3796),
    [anon_sym_continue] = ACTIONS(3796),
    [anon_sym_goto] = ACTIONS(3796),
    [anon_sym___try] = ACTIONS(3796),
    [anon_sym___leave] = ACTIONS(3796),
    [anon_sym_not] = ACTIONS(3796),
    [anon_sym_compl] = ACTIONS(3796),
    [anon_sym_DASH_DASH] = ACTIONS(3798),
    [anon_sym_PLUS_PLUS] = ACTIONS(3798),
    [anon_sym_sizeof] = ACTIONS(3796),
    [anon_sym___alignof__] = ACTIONS(3796),
    [anon_sym___alignof] = ACTIONS(3796),
    [anon_sym__alignof] = ACTIONS(3796),
    [anon_sym_alignof] = ACTIONS(3796),
    [anon_sym__Alignof] = ACTIONS(3796),
    [anon_sym_offsetof] = ACTIONS(3796),
    [anon_sym__Generic] = ACTIONS(3796),
    [anon_sym_asm] = ACTIONS(3796),
    [anon_sym___asm__] = ACTIONS(3796),
    [anon_sym___asm] = ACTIONS(3796),
    [sym_number_literal] = ACTIONS(3798),
    [anon_sym_L_SQUOTE] = ACTIONS(3798),
    [anon_sym_u_SQUOTE] = ACTIONS(3798),
    [anon_sym_U_SQUOTE] = ACTIONS(3798),
    [anon_sym_u8_SQUOTE] = ACTIONS(3798),
    [anon_sym_SQUOTE] = ACTIONS(3798),
    [anon_sym_L_DQUOTE] = ACTIONS(3798),
    [anon_sym_u_DQUOTE] = ACTIONS(3798),
    [anon_sym_U_DQUOTE] = ACTIONS(3798),
    [anon_sym_u8_DQUOTE] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(3798),
    [sym_true] = ACTIONS(3796),
    [sym_false] = ACTIONS(3796),
    [anon_sym_NULL] = ACTIONS(3796),
    [anon_sym_nullptr] = ACTIONS(3796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3796),
    [anon_sym_let] = ACTIONS(3796),
    [anon_sym_This] = ACTIONS(3796),
    [anon_sym_decltype] = ACTIONS(3796),
    [anon_sym_explicit] = ACTIONS(3796),
    [anon_sym_typename] = ACTIONS(3796),
    [anon_sym_template] = ACTIONS(3796),
    [anon_sym_operator] = ACTIONS(3796),
    [anon_sym_try] = ACTIONS(3796),
    [anon_sym_delete] = ACTIONS(3796),
    [anon_sym_throw] = ACTIONS(3796),
    [anon_sym_namespace] = ACTIONS(3796),
    [anon_sym_static_assert] = ACTIONS(3796),
    [anon_sym_concept] = ACTIONS(3796),
    [anon_sym_co_return] = ACTIONS(3796),
    [anon_sym_co_yield] = ACTIONS(3796),
    [anon_sym_R_DQUOTE] = ACTIONS(3798),
    [anon_sym_LR_DQUOTE] = ACTIONS(3798),
    [anon_sym_uR_DQUOTE] = ACTIONS(3798),
    [anon_sym_UR_DQUOTE] = ACTIONS(3798),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3798),
    [anon_sym_co_await] = ACTIONS(3796),
    [anon_sym_new] = ACTIONS(3796),
    [anon_sym_requires] = ACTIONS(3796),
    [sym_this] = ACTIONS(3796),
    [anon_sym_discard] = ACTIONS(3796),
    [anon_sym_precise] = ACTIONS(3796),
    [anon_sym_shared] = ACTIONS(3796),
    [anon_sym_groupshared] = ACTIONS(3796),
    [anon_sym_uniform] = ACTIONS(3796),
    [anon_sym_row_major] = ACTIONS(3796),
    [anon_sym_column_major] = ACTIONS(3796),
    [anon_sym_globallycoherent] = ACTIONS(3796),
    [anon_sym_centroid] = ACTIONS(3796),
    [anon_sym_noperspective] = ACTIONS(3796),
    [anon_sym_nointerpolation] = ACTIONS(3796),
    [anon_sym_sample] = ACTIONS(3796),
    [anon_sym_linear] = ACTIONS(3796),
    [anon_sym_snorm] = ACTIONS(3796),
    [anon_sym_unorm] = ACTIONS(3796),
    [anon_sym_point] = ACTIONS(3796),
    [anon_sym_line] = ACTIONS(3796),
    [anon_sym_triangleadj] = ACTIONS(3796),
    [anon_sym_lineadj] = ACTIONS(3796),
    [anon_sym_triangle] = ACTIONS(3796),
    [anon_sym_cbuffer] = ACTIONS(3796),
    [anon_sym_interface] = ACTIONS(3796),
    [anon_sym_extension] = ACTIONS(3796),
  },
  [1083] = {
    [sym_identifier] = ACTIONS(3800),
    [aux_sym_preproc_include_token1] = ACTIONS(3800),
    [aux_sym_preproc_def_token1] = ACTIONS(3800),
    [aux_sym_preproc_if_token1] = ACTIONS(3800),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3800),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3800),
    [sym_preproc_directive] = ACTIONS(3800),
    [anon_sym_LPAREN2] = ACTIONS(3802),
    [anon_sym_BANG] = ACTIONS(3802),
    [anon_sym_TILDE] = ACTIONS(3802),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_STAR] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_SEMI] = ACTIONS(3802),
    [anon_sym___extension__] = ACTIONS(3800),
    [anon_sym_typedef] = ACTIONS(3800),
    [anon_sym_in] = ACTIONS(3800),
    [anon_sym_out] = ACTIONS(3800),
    [anon_sym_inout] = ACTIONS(3800),
    [anon_sym_virtual] = ACTIONS(3800),
    [anon_sym_extern] = ACTIONS(3800),
    [anon_sym___attribute__] = ACTIONS(3800),
    [anon_sym___attribute] = ACTIONS(3800),
    [anon_sym_using] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3802),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3802),
    [anon_sym___declspec] = ACTIONS(3800),
    [anon_sym___based] = ACTIONS(3800),
    [anon_sym___cdecl] = ACTIONS(3800),
    [anon_sym___clrcall] = ACTIONS(3800),
    [anon_sym___stdcall] = ACTIONS(3800),
    [anon_sym___fastcall] = ACTIONS(3800),
    [anon_sym___thiscall] = ACTIONS(3800),
    [anon_sym___vectorcall] = ACTIONS(3800),
    [anon_sym_LBRACE] = ACTIONS(3802),
    [anon_sym_RBRACE] = ACTIONS(3802),
    [anon_sym_signed] = ACTIONS(3800),
    [anon_sym_unsigned] = ACTIONS(3800),
    [anon_sym_long] = ACTIONS(3800),
    [anon_sym_short] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3800),
    [anon_sym_static] = ACTIONS(3800),
    [anon_sym_register] = ACTIONS(3800),
    [anon_sym_inline] = ACTIONS(3800),
    [anon_sym___inline] = ACTIONS(3800),
    [anon_sym___inline__] = ACTIONS(3800),
    [anon_sym___forceinline] = ACTIONS(3800),
    [anon_sym_thread_local] = ACTIONS(3800),
    [anon_sym___thread] = ACTIONS(3800),
    [anon_sym_const] = ACTIONS(3800),
    [anon_sym_constexpr] = ACTIONS(3800),
    [anon_sym_volatile] = ACTIONS(3800),
    [anon_sym_restrict] = ACTIONS(3800),
    [anon_sym___restrict__] = ACTIONS(3800),
    [anon_sym__Atomic] = ACTIONS(3800),
    [anon_sym__Noreturn] = ACTIONS(3800),
    [anon_sym_noreturn] = ACTIONS(3800),
    [anon_sym__Nonnull] = ACTIONS(3800),
    [anon_sym_mutable] = ACTIONS(3800),
    [anon_sym_constinit] = ACTIONS(3800),
    [anon_sym_consteval] = ACTIONS(3800),
    [anon_sym_alignas] = ACTIONS(3800),
    [anon_sym__Alignas] = ACTIONS(3800),
    [sym_primitive_type] = ACTIONS(3800),
    [anon_sym_enum] = ACTIONS(3800),
    [anon_sym_class] = ACTIONS(3800),
    [anon_sym_struct] = ACTIONS(3800),
    [anon_sym_union] = ACTIONS(3800),
    [anon_sym_if] = ACTIONS(3800),
    [anon_sym_switch] = ACTIONS(3800),
    [anon_sym_case] = ACTIONS(3800),
    [anon_sym_default] = ACTIONS(3800),
    [anon_sym_while] = ACTIONS(3800),
    [anon_sym_do] = ACTIONS(3800),
    [anon_sym_for] = ACTIONS(3800),
    [anon_sym_return] = ACTIONS(3800),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_continue] = ACTIONS(3800),
    [anon_sym_goto] = ACTIONS(3800),
    [anon_sym___try] = ACTIONS(3800),
    [anon_sym___leave] = ACTIONS(3800),
    [anon_sym_not] = ACTIONS(3800),
    [anon_sym_compl] = ACTIONS(3800),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3800),
    [anon_sym___alignof__] = ACTIONS(3800),
    [anon_sym___alignof] = ACTIONS(3800),
    [anon_sym__alignof] = ACTIONS(3800),
    [anon_sym_alignof] = ACTIONS(3800),
    [anon_sym__Alignof] = ACTIONS(3800),
    [anon_sym_offsetof] = ACTIONS(3800),
    [anon_sym__Generic] = ACTIONS(3800),
    [anon_sym_asm] = ACTIONS(3800),
    [anon_sym___asm__] = ACTIONS(3800),
    [anon_sym___asm] = ACTIONS(3800),
    [sym_number_literal] = ACTIONS(3802),
    [anon_sym_L_SQUOTE] = ACTIONS(3802),
    [anon_sym_u_SQUOTE] = ACTIONS(3802),
    [anon_sym_U_SQUOTE] = ACTIONS(3802),
    [anon_sym_u8_SQUOTE] = ACTIONS(3802),
    [anon_sym_SQUOTE] = ACTIONS(3802),
    [anon_sym_L_DQUOTE] = ACTIONS(3802),
    [anon_sym_u_DQUOTE] = ACTIONS(3802),
    [anon_sym_U_DQUOTE] = ACTIONS(3802),
    [anon_sym_u8_DQUOTE] = ACTIONS(3802),
    [anon_sym_DQUOTE] = ACTIONS(3802),
    [sym_true] = ACTIONS(3800),
    [sym_false] = ACTIONS(3800),
    [anon_sym_NULL] = ACTIONS(3800),
    [anon_sym_nullptr] = ACTIONS(3800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_This] = ACTIONS(3800),
    [anon_sym_decltype] = ACTIONS(3800),
    [anon_sym_explicit] = ACTIONS(3800),
    [anon_sym_typename] = ACTIONS(3800),
    [anon_sym_template] = ACTIONS(3800),
    [anon_sym_operator] = ACTIONS(3800),
    [anon_sym_try] = ACTIONS(3800),
    [anon_sym_delete] = ACTIONS(3800),
    [anon_sym_throw] = ACTIONS(3800),
    [anon_sym_namespace] = ACTIONS(3800),
    [anon_sym_static_assert] = ACTIONS(3800),
    [anon_sym_concept] = ACTIONS(3800),
    [anon_sym_co_return] = ACTIONS(3800),
    [anon_sym_co_yield] = ACTIONS(3800),
    [anon_sym_R_DQUOTE] = ACTIONS(3802),
    [anon_sym_LR_DQUOTE] = ACTIONS(3802),
    [anon_sym_uR_DQUOTE] = ACTIONS(3802),
    [anon_sym_UR_DQUOTE] = ACTIONS(3802),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3802),
    [anon_sym_co_await] = ACTIONS(3800),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_requires] = ACTIONS(3800),
    [sym_this] = ACTIONS(3800),
    [anon_sym_discard] = ACTIONS(3800),
    [anon_sym_precise] = ACTIONS(3800),
    [anon_sym_shared] = ACTIONS(3800),
    [anon_sym_groupshared] = ACTIONS(3800),
    [anon_sym_uniform] = ACTIONS(3800),
    [anon_sym_row_major] = ACTIONS(3800),
    [anon_sym_column_major] = ACTIONS(3800),
    [anon_sym_globallycoherent] = ACTIONS(3800),
    [anon_sym_centroid] = ACTIONS(3800),
    [anon_sym_noperspective] = ACTIONS(3800),
    [anon_sym_nointerpolation] = ACTIONS(3800),
    [anon_sym_sample] = ACTIONS(3800),
    [anon_sym_linear] = ACTIONS(3800),
    [anon_sym_snorm] = ACTIONS(3800),
    [anon_sym_unorm] = ACTIONS(3800),
    [anon_sym_point] = ACTIONS(3800),
    [anon_sym_line] = ACTIONS(3800),
    [anon_sym_triangleadj] = ACTIONS(3800),
    [anon_sym_lineadj] = ACTIONS(3800),
    [anon_sym_triangle] = ACTIONS(3800),
    [anon_sym_cbuffer] = ACTIONS(3800),
    [anon_sym_interface] = ACTIONS(3800),
    [anon_sym_extension] = ACTIONS(3800),
  },
  [1084] = {
    [ts_builtin_sym_end] = ACTIONS(4365),
    [sym_identifier] = ACTIONS(4367),
    [aux_sym_preproc_include_token1] = ACTIONS(4367),
    [aux_sym_preproc_def_token1] = ACTIONS(4367),
    [aux_sym_preproc_if_token1] = ACTIONS(4367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4367),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4367),
    [sym_preproc_directive] = ACTIONS(4367),
    [anon_sym_LPAREN2] = ACTIONS(4365),
    [anon_sym_BANG] = ACTIONS(4365),
    [anon_sym_TILDE] = ACTIONS(4365),
    [anon_sym_DASH] = ACTIONS(4367),
    [anon_sym_PLUS] = ACTIONS(4367),
    [anon_sym_STAR] = ACTIONS(4365),
    [anon_sym_AMP_AMP] = ACTIONS(4365),
    [anon_sym_AMP] = ACTIONS(4367),
    [anon_sym_SEMI] = ACTIONS(4365),
    [anon_sym___extension__] = ACTIONS(4367),
    [anon_sym_typedef] = ACTIONS(4367),
    [anon_sym_in] = ACTIONS(4367),
    [anon_sym_out] = ACTIONS(4367),
    [anon_sym_inout] = ACTIONS(4367),
    [anon_sym_virtual] = ACTIONS(4367),
    [anon_sym_extern] = ACTIONS(4367),
    [anon_sym___attribute__] = ACTIONS(4367),
    [anon_sym___attribute] = ACTIONS(4367),
    [anon_sym_using] = ACTIONS(4367),
    [anon_sym_COLON_COLON] = ACTIONS(4365),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4365),
    [anon_sym___declspec] = ACTIONS(4367),
    [anon_sym___based] = ACTIONS(4367),
    [anon_sym___cdecl] = ACTIONS(4367),
    [anon_sym___clrcall] = ACTIONS(4367),
    [anon_sym___stdcall] = ACTIONS(4367),
    [anon_sym___fastcall] = ACTIONS(4367),
    [anon_sym___thiscall] = ACTIONS(4367),
    [anon_sym___vectorcall] = ACTIONS(4367),
    [anon_sym_LBRACE] = ACTIONS(4365),
    [anon_sym_signed] = ACTIONS(4367),
    [anon_sym_unsigned] = ACTIONS(4367),
    [anon_sym_long] = ACTIONS(4367),
    [anon_sym_short] = ACTIONS(4367),
    [anon_sym_LBRACK] = ACTIONS(4367),
    [anon_sym_static] = ACTIONS(4367),
    [anon_sym_register] = ACTIONS(4367),
    [anon_sym_inline] = ACTIONS(4367),
    [anon_sym___inline] = ACTIONS(4367),
    [anon_sym___inline__] = ACTIONS(4367),
    [anon_sym___forceinline] = ACTIONS(4367),
    [anon_sym_thread_local] = ACTIONS(4367),
    [anon_sym___thread] = ACTIONS(4367),
    [anon_sym_const] = ACTIONS(4367),
    [anon_sym_constexpr] = ACTIONS(4367),
    [anon_sym_volatile] = ACTIONS(4367),
    [anon_sym_restrict] = ACTIONS(4367),
    [anon_sym___restrict__] = ACTIONS(4367),
    [anon_sym__Atomic] = ACTIONS(4367),
    [anon_sym__Noreturn] = ACTIONS(4367),
    [anon_sym_noreturn] = ACTIONS(4367),
    [anon_sym__Nonnull] = ACTIONS(4367),
    [anon_sym_mutable] = ACTIONS(4367),
    [anon_sym_constinit] = ACTIONS(4367),
    [anon_sym_consteval] = ACTIONS(4367),
    [anon_sym_alignas] = ACTIONS(4367),
    [anon_sym__Alignas] = ACTIONS(4367),
    [sym_primitive_type] = ACTIONS(4367),
    [anon_sym_enum] = ACTIONS(4367),
    [anon_sym_class] = ACTIONS(4367),
    [anon_sym_struct] = ACTIONS(4367),
    [anon_sym_union] = ACTIONS(4367),
    [anon_sym_if] = ACTIONS(4367),
    [anon_sym_switch] = ACTIONS(4367),
    [anon_sym_case] = ACTIONS(4367),
    [anon_sym_default] = ACTIONS(4367),
    [anon_sym_while] = ACTIONS(4367),
    [anon_sym_do] = ACTIONS(4367),
    [anon_sym_for] = ACTIONS(4367),
    [anon_sym_return] = ACTIONS(4367),
    [anon_sym_break] = ACTIONS(4367),
    [anon_sym_continue] = ACTIONS(4367),
    [anon_sym_goto] = ACTIONS(4367),
    [anon_sym_not] = ACTIONS(4367),
    [anon_sym_compl] = ACTIONS(4367),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_sizeof] = ACTIONS(4367),
    [anon_sym___alignof__] = ACTIONS(4367),
    [anon_sym___alignof] = ACTIONS(4367),
    [anon_sym__alignof] = ACTIONS(4367),
    [anon_sym_alignof] = ACTIONS(4367),
    [anon_sym__Alignof] = ACTIONS(4367),
    [anon_sym_offsetof] = ACTIONS(4367),
    [anon_sym__Generic] = ACTIONS(4367),
    [anon_sym_asm] = ACTIONS(4367),
    [anon_sym___asm__] = ACTIONS(4367),
    [anon_sym___asm] = ACTIONS(4367),
    [sym_number_literal] = ACTIONS(4365),
    [anon_sym_L_SQUOTE] = ACTIONS(4365),
    [anon_sym_u_SQUOTE] = ACTIONS(4365),
    [anon_sym_U_SQUOTE] = ACTIONS(4365),
    [anon_sym_u8_SQUOTE] = ACTIONS(4365),
    [anon_sym_SQUOTE] = ACTIONS(4365),
    [anon_sym_L_DQUOTE] = ACTIONS(4365),
    [anon_sym_u_DQUOTE] = ACTIONS(4365),
    [anon_sym_U_DQUOTE] = ACTIONS(4365),
    [anon_sym_u8_DQUOTE] = ACTIONS(4365),
    [anon_sym_DQUOTE] = ACTIONS(4365),
    [sym_true] = ACTIONS(4367),
    [sym_false] = ACTIONS(4367),
    [anon_sym_NULL] = ACTIONS(4367),
    [anon_sym_nullptr] = ACTIONS(4367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4367),
    [anon_sym_let] = ACTIONS(4367),
    [anon_sym_This] = ACTIONS(4367),
    [anon_sym_decltype] = ACTIONS(4367),
    [anon_sym_explicit] = ACTIONS(4367),
    [anon_sym_typename] = ACTIONS(4367),
    [anon_sym_export] = ACTIONS(4367),
    [anon_sym_module] = ACTIONS(4367),
    [anon_sym_import] = ACTIONS(4367),
    [anon_sym_template] = ACTIONS(4367),
    [anon_sym_operator] = ACTIONS(4367),
    [anon_sym_try] = ACTIONS(4367),
    [anon_sym_delete] = ACTIONS(4367),
    [anon_sym_throw] = ACTIONS(4367),
    [anon_sym_namespace] = ACTIONS(4367),
    [anon_sym_static_assert] = ACTIONS(4367),
    [anon_sym_concept] = ACTIONS(4367),
    [anon_sym_co_return] = ACTIONS(4367),
    [anon_sym_co_yield] = ACTIONS(4367),
    [anon_sym_R_DQUOTE] = ACTIONS(4365),
    [anon_sym_LR_DQUOTE] = ACTIONS(4365),
    [anon_sym_uR_DQUOTE] = ACTIONS(4365),
    [anon_sym_UR_DQUOTE] = ACTIONS(4365),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4365),
    [anon_sym_co_await] = ACTIONS(4367),
    [anon_sym_new] = ACTIONS(4367),
    [anon_sym_requires] = ACTIONS(4367),
    [sym_this] = ACTIONS(4367),
    [anon_sym_precise] = ACTIONS(4367),
    [anon_sym_shared] = ACTIONS(4367),
    [anon_sym_groupshared] = ACTIONS(4367),
    [anon_sym_uniform] = ACTIONS(4367),
    [anon_sym_row_major] = ACTIONS(4367),
    [anon_sym_column_major] = ACTIONS(4367),
    [anon_sym_globallycoherent] = ACTIONS(4367),
    [anon_sym_centroid] = ACTIONS(4367),
    [anon_sym_noperspective] = ACTIONS(4367),
    [anon_sym_nointerpolation] = ACTIONS(4367),
    [anon_sym_sample] = ACTIONS(4367),
    [anon_sym_linear] = ACTIONS(4367),
    [anon_sym_snorm] = ACTIONS(4367),
    [anon_sym_unorm] = ACTIONS(4367),
    [anon_sym_point] = ACTIONS(4367),
    [anon_sym_line] = ACTIONS(4367),
    [anon_sym_triangleadj] = ACTIONS(4367),
    [anon_sym_lineadj] = ACTIONS(4367),
    [anon_sym_triangle] = ACTIONS(4367),
    [anon_sym_interface] = ACTIONS(4367),
    [anon_sym_extension] = ACTIONS(4367),
    [anon_sym___exported] = ACTIONS(4367),
  },
  [1085] = {
    [ts_builtin_sym_end] = ACTIONS(3974),
    [sym_identifier] = ACTIONS(3971),
    [aux_sym_preproc_include_token1] = ACTIONS(3971),
    [aux_sym_preproc_def_token1] = ACTIONS(3971),
    [aux_sym_preproc_if_token1] = ACTIONS(3971),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3971),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3971),
    [sym_preproc_directive] = ACTIONS(3971),
    [anon_sym_LPAREN2] = ACTIONS(3974),
    [anon_sym_BANG] = ACTIONS(3974),
    [anon_sym_TILDE] = ACTIONS(3974),
    [anon_sym_DASH] = ACTIONS(3971),
    [anon_sym_PLUS] = ACTIONS(3971),
    [anon_sym_STAR] = ACTIONS(3974),
    [anon_sym_AMP_AMP] = ACTIONS(3974),
    [anon_sym_AMP] = ACTIONS(3971),
    [anon_sym_SEMI] = ACTIONS(3974),
    [anon_sym___extension__] = ACTIONS(3971),
    [anon_sym_typedef] = ACTIONS(3971),
    [anon_sym_in] = ACTIONS(3971),
    [anon_sym_out] = ACTIONS(3971),
    [anon_sym_inout] = ACTIONS(3971),
    [anon_sym_virtual] = ACTIONS(3971),
    [anon_sym_extern] = ACTIONS(3971),
    [anon_sym___attribute__] = ACTIONS(3971),
    [anon_sym___attribute] = ACTIONS(3971),
    [anon_sym_using] = ACTIONS(3971),
    [anon_sym_COLON_COLON] = ACTIONS(3974),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3974),
    [anon_sym___declspec] = ACTIONS(3971),
    [anon_sym___based] = ACTIONS(3971),
    [anon_sym___cdecl] = ACTIONS(3971),
    [anon_sym___clrcall] = ACTIONS(3971),
    [anon_sym___stdcall] = ACTIONS(3971),
    [anon_sym___fastcall] = ACTIONS(3971),
    [anon_sym___thiscall] = ACTIONS(3971),
    [anon_sym___vectorcall] = ACTIONS(3971),
    [anon_sym_LBRACE] = ACTIONS(3974),
    [anon_sym_signed] = ACTIONS(3971),
    [anon_sym_unsigned] = ACTIONS(3971),
    [anon_sym_long] = ACTIONS(3971),
    [anon_sym_short] = ACTIONS(3971),
    [anon_sym_LBRACK] = ACTIONS(3971),
    [anon_sym_static] = ACTIONS(3971),
    [anon_sym_register] = ACTIONS(3971),
    [anon_sym_inline] = ACTIONS(3971),
    [anon_sym___inline] = ACTIONS(3971),
    [anon_sym___inline__] = ACTIONS(3971),
    [anon_sym___forceinline] = ACTIONS(3971),
    [anon_sym_thread_local] = ACTIONS(3971),
    [anon_sym___thread] = ACTIONS(3971),
    [anon_sym_const] = ACTIONS(3971),
    [anon_sym_constexpr] = ACTIONS(3971),
    [anon_sym_volatile] = ACTIONS(3971),
    [anon_sym_restrict] = ACTIONS(3971),
    [anon_sym___restrict__] = ACTIONS(3971),
    [anon_sym__Atomic] = ACTIONS(3971),
    [anon_sym__Noreturn] = ACTIONS(3971),
    [anon_sym_noreturn] = ACTIONS(3971),
    [anon_sym__Nonnull] = ACTIONS(3971),
    [anon_sym_mutable] = ACTIONS(3971),
    [anon_sym_constinit] = ACTIONS(3971),
    [anon_sym_consteval] = ACTIONS(3971),
    [anon_sym_alignas] = ACTIONS(3971),
    [anon_sym__Alignas] = ACTIONS(3971),
    [sym_primitive_type] = ACTIONS(3971),
    [anon_sym_enum] = ACTIONS(3971),
    [anon_sym_class] = ACTIONS(3971),
    [anon_sym_struct] = ACTIONS(3971),
    [anon_sym_union] = ACTIONS(3971),
    [anon_sym_if] = ACTIONS(3971),
    [anon_sym_switch] = ACTIONS(3971),
    [anon_sym_case] = ACTIONS(3971),
    [anon_sym_default] = ACTIONS(3971),
    [anon_sym_while] = ACTIONS(3971),
    [anon_sym_do] = ACTIONS(3971),
    [anon_sym_for] = ACTIONS(3971),
    [anon_sym_return] = ACTIONS(3971),
    [anon_sym_break] = ACTIONS(3971),
    [anon_sym_continue] = ACTIONS(3971),
    [anon_sym_goto] = ACTIONS(3971),
    [anon_sym_not] = ACTIONS(3971),
    [anon_sym_compl] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3974),
    [anon_sym_PLUS_PLUS] = ACTIONS(3974),
    [anon_sym_sizeof] = ACTIONS(3971),
    [anon_sym___alignof__] = ACTIONS(3971),
    [anon_sym___alignof] = ACTIONS(3971),
    [anon_sym__alignof] = ACTIONS(3971),
    [anon_sym_alignof] = ACTIONS(3971),
    [anon_sym__Alignof] = ACTIONS(3971),
    [anon_sym_offsetof] = ACTIONS(3971),
    [anon_sym__Generic] = ACTIONS(3971),
    [anon_sym_asm] = ACTIONS(3971),
    [anon_sym___asm__] = ACTIONS(3971),
    [anon_sym___asm] = ACTIONS(3971),
    [sym_number_literal] = ACTIONS(3974),
    [anon_sym_L_SQUOTE] = ACTIONS(3974),
    [anon_sym_u_SQUOTE] = ACTIONS(3974),
    [anon_sym_U_SQUOTE] = ACTIONS(3974),
    [anon_sym_u8_SQUOTE] = ACTIONS(3974),
    [anon_sym_SQUOTE] = ACTIONS(3974),
    [anon_sym_L_DQUOTE] = ACTIONS(3974),
    [anon_sym_u_DQUOTE] = ACTIONS(3974),
    [anon_sym_U_DQUOTE] = ACTIONS(3974),
    [anon_sym_u8_DQUOTE] = ACTIONS(3974),
    [anon_sym_DQUOTE] = ACTIONS(3974),
    [sym_true] = ACTIONS(3971),
    [sym_false] = ACTIONS(3971),
    [anon_sym_NULL] = ACTIONS(3971),
    [anon_sym_nullptr] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3971),
    [anon_sym_let] = ACTIONS(3971),
    [anon_sym_This] = ACTIONS(3971),
    [anon_sym_decltype] = ACTIONS(3971),
    [anon_sym_explicit] = ACTIONS(3971),
    [anon_sym_typename] = ACTIONS(3971),
    [anon_sym_export] = ACTIONS(3971),
    [anon_sym_module] = ACTIONS(3971),
    [anon_sym_import] = ACTIONS(3971),
    [anon_sym_template] = ACTIONS(3971),
    [anon_sym_operator] = ACTIONS(3971),
    [anon_sym_try] = ACTIONS(3971),
    [anon_sym_delete] = ACTIONS(3971),
    [anon_sym_throw] = ACTIONS(3971),
    [anon_sym_namespace] = ACTIONS(3971),
    [anon_sym_static_assert] = ACTIONS(3971),
    [anon_sym_concept] = ACTIONS(3971),
    [anon_sym_co_return] = ACTIONS(3971),
    [anon_sym_co_yield] = ACTIONS(3971),
    [anon_sym_R_DQUOTE] = ACTIONS(3974),
    [anon_sym_LR_DQUOTE] = ACTIONS(3974),
    [anon_sym_uR_DQUOTE] = ACTIONS(3974),
    [anon_sym_UR_DQUOTE] = ACTIONS(3974),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3974),
    [anon_sym_co_await] = ACTIONS(3971),
    [anon_sym_new] = ACTIONS(3971),
    [anon_sym_requires] = ACTIONS(3971),
    [sym_this] = ACTIONS(3971),
    [anon_sym_precise] = ACTIONS(3971),
    [anon_sym_shared] = ACTIONS(3971),
    [anon_sym_groupshared] = ACTIONS(3971),
    [anon_sym_uniform] = ACTIONS(3971),
    [anon_sym_row_major] = ACTIONS(3971),
    [anon_sym_column_major] = ACTIONS(3971),
    [anon_sym_globallycoherent] = ACTIONS(3971),
    [anon_sym_centroid] = ACTIONS(3971),
    [anon_sym_noperspective] = ACTIONS(3971),
    [anon_sym_nointerpolation] = ACTIONS(3971),
    [anon_sym_sample] = ACTIONS(3971),
    [anon_sym_linear] = ACTIONS(3971),
    [anon_sym_snorm] = ACTIONS(3971),
    [anon_sym_unorm] = ACTIONS(3971),
    [anon_sym_point] = ACTIONS(3971),
    [anon_sym_line] = ACTIONS(3971),
    [anon_sym_triangleadj] = ACTIONS(3971),
    [anon_sym_lineadj] = ACTIONS(3971),
    [anon_sym_triangle] = ACTIONS(3971),
    [anon_sym_interface] = ACTIONS(3971),
    [anon_sym_extension] = ACTIONS(3971),
    [anon_sym___exported] = ACTIONS(3971),
  },
  [1086] = {
    [ts_builtin_sym_end] = ACTIONS(3883),
    [sym_identifier] = ACTIONS(3881),
    [aux_sym_preproc_include_token1] = ACTIONS(3881),
    [aux_sym_preproc_def_token1] = ACTIONS(3881),
    [aux_sym_preproc_if_token1] = ACTIONS(3881),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3881),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3881),
    [sym_preproc_directive] = ACTIONS(3881),
    [anon_sym_LPAREN2] = ACTIONS(3883),
    [anon_sym_BANG] = ACTIONS(3883),
    [anon_sym_TILDE] = ACTIONS(3883),
    [anon_sym_DASH] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(3881),
    [anon_sym_STAR] = ACTIONS(3883),
    [anon_sym_AMP_AMP] = ACTIONS(3883),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3883),
    [anon_sym___extension__] = ACTIONS(3881),
    [anon_sym_typedef] = ACTIONS(3881),
    [anon_sym_in] = ACTIONS(3881),
    [anon_sym_out] = ACTIONS(3881),
    [anon_sym_inout] = ACTIONS(3881),
    [anon_sym_virtual] = ACTIONS(3881),
    [anon_sym_extern] = ACTIONS(3881),
    [anon_sym___attribute__] = ACTIONS(3881),
    [anon_sym___attribute] = ACTIONS(3881),
    [anon_sym_using] = ACTIONS(3881),
    [anon_sym_COLON_COLON] = ACTIONS(3883),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3883),
    [anon_sym___declspec] = ACTIONS(3881),
    [anon_sym___based] = ACTIONS(3881),
    [anon_sym___cdecl] = ACTIONS(3881),
    [anon_sym___clrcall] = ACTIONS(3881),
    [anon_sym___stdcall] = ACTIONS(3881),
    [anon_sym___fastcall] = ACTIONS(3881),
    [anon_sym___thiscall] = ACTIONS(3881),
    [anon_sym___vectorcall] = ACTIONS(3881),
    [anon_sym_LBRACE] = ACTIONS(3883),
    [anon_sym_signed] = ACTIONS(3881),
    [anon_sym_unsigned] = ACTIONS(3881),
    [anon_sym_long] = ACTIONS(3881),
    [anon_sym_short] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_static] = ACTIONS(3881),
    [anon_sym_register] = ACTIONS(3881),
    [anon_sym_inline] = ACTIONS(3881),
    [anon_sym___inline] = ACTIONS(3881),
    [anon_sym___inline__] = ACTIONS(3881),
    [anon_sym___forceinline] = ACTIONS(3881),
    [anon_sym_thread_local] = ACTIONS(3881),
    [anon_sym___thread] = ACTIONS(3881),
    [anon_sym_const] = ACTIONS(3881),
    [anon_sym_constexpr] = ACTIONS(3881),
    [anon_sym_volatile] = ACTIONS(3881),
    [anon_sym_restrict] = ACTIONS(3881),
    [anon_sym___restrict__] = ACTIONS(3881),
    [anon_sym__Atomic] = ACTIONS(3881),
    [anon_sym__Noreturn] = ACTIONS(3881),
    [anon_sym_noreturn] = ACTIONS(3881),
    [anon_sym__Nonnull] = ACTIONS(3881),
    [anon_sym_mutable] = ACTIONS(3881),
    [anon_sym_constinit] = ACTIONS(3881),
    [anon_sym_consteval] = ACTIONS(3881),
    [anon_sym_alignas] = ACTIONS(3881),
    [anon_sym__Alignas] = ACTIONS(3881),
    [sym_primitive_type] = ACTIONS(3881),
    [anon_sym_enum] = ACTIONS(3881),
    [anon_sym_class] = ACTIONS(3881),
    [anon_sym_struct] = ACTIONS(3881),
    [anon_sym_union] = ACTIONS(3881),
    [anon_sym_if] = ACTIONS(3881),
    [anon_sym_switch] = ACTIONS(3881),
    [anon_sym_case] = ACTIONS(3881),
    [anon_sym_default] = ACTIONS(3881),
    [anon_sym_while] = ACTIONS(3881),
    [anon_sym_do] = ACTIONS(3881),
    [anon_sym_for] = ACTIONS(3881),
    [anon_sym_return] = ACTIONS(3881),
    [anon_sym_break] = ACTIONS(3881),
    [anon_sym_continue] = ACTIONS(3881),
    [anon_sym_goto] = ACTIONS(3881),
    [anon_sym_not] = ACTIONS(3881),
    [anon_sym_compl] = ACTIONS(3881),
    [anon_sym_DASH_DASH] = ACTIONS(3883),
    [anon_sym_PLUS_PLUS] = ACTIONS(3883),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(3881),
    [anon_sym___alignof] = ACTIONS(3881),
    [anon_sym__alignof] = ACTIONS(3881),
    [anon_sym_alignof] = ACTIONS(3881),
    [anon_sym__Alignof] = ACTIONS(3881),
    [anon_sym_offsetof] = ACTIONS(3881),
    [anon_sym__Generic] = ACTIONS(3881),
    [anon_sym_asm] = ACTIONS(3881),
    [anon_sym___asm__] = ACTIONS(3881),
    [anon_sym___asm] = ACTIONS(3881),
    [sym_number_literal] = ACTIONS(3883),
    [anon_sym_L_SQUOTE] = ACTIONS(3883),
    [anon_sym_u_SQUOTE] = ACTIONS(3883),
    [anon_sym_U_SQUOTE] = ACTIONS(3883),
    [anon_sym_u8_SQUOTE] = ACTIONS(3883),
    [anon_sym_SQUOTE] = ACTIONS(3883),
    [anon_sym_L_DQUOTE] = ACTIONS(3883),
    [anon_sym_u_DQUOTE] = ACTIONS(3883),
    [anon_sym_U_DQUOTE] = ACTIONS(3883),
    [anon_sym_u8_DQUOTE] = ACTIONS(3883),
    [anon_sym_DQUOTE] = ACTIONS(3883),
    [sym_true] = ACTIONS(3881),
    [sym_false] = ACTIONS(3881),
    [anon_sym_NULL] = ACTIONS(3881),
    [anon_sym_nullptr] = ACTIONS(3881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3881),
    [anon_sym_let] = ACTIONS(3881),
    [anon_sym_This] = ACTIONS(3881),
    [anon_sym_decltype] = ACTIONS(3881),
    [anon_sym_explicit] = ACTIONS(3881),
    [anon_sym_typename] = ACTIONS(3881),
    [anon_sym_export] = ACTIONS(3881),
    [anon_sym_module] = ACTIONS(3881),
    [anon_sym_import] = ACTIONS(3881),
    [anon_sym_template] = ACTIONS(3881),
    [anon_sym_operator] = ACTIONS(3881),
    [anon_sym_try] = ACTIONS(3881),
    [anon_sym_delete] = ACTIONS(3881),
    [anon_sym_throw] = ACTIONS(3881),
    [anon_sym_namespace] = ACTIONS(3881),
    [anon_sym_static_assert] = ACTIONS(3881),
    [anon_sym_concept] = ACTIONS(3881),
    [anon_sym_co_return] = ACTIONS(3881),
    [anon_sym_co_yield] = ACTIONS(3881),
    [anon_sym_R_DQUOTE] = ACTIONS(3883),
    [anon_sym_LR_DQUOTE] = ACTIONS(3883),
    [anon_sym_uR_DQUOTE] = ACTIONS(3883),
    [anon_sym_UR_DQUOTE] = ACTIONS(3883),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3883),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3881),
    [anon_sym_requires] = ACTIONS(3881),
    [sym_this] = ACTIONS(3881),
    [anon_sym_precise] = ACTIONS(3881),
    [anon_sym_shared] = ACTIONS(3881),
    [anon_sym_groupshared] = ACTIONS(3881),
    [anon_sym_uniform] = ACTIONS(3881),
    [anon_sym_row_major] = ACTIONS(3881),
    [anon_sym_column_major] = ACTIONS(3881),
    [anon_sym_globallycoherent] = ACTIONS(3881),
    [anon_sym_centroid] = ACTIONS(3881),
    [anon_sym_noperspective] = ACTIONS(3881),
    [anon_sym_nointerpolation] = ACTIONS(3881),
    [anon_sym_sample] = ACTIONS(3881),
    [anon_sym_linear] = ACTIONS(3881),
    [anon_sym_snorm] = ACTIONS(3881),
    [anon_sym_unorm] = ACTIONS(3881),
    [anon_sym_point] = ACTIONS(3881),
    [anon_sym_line] = ACTIONS(3881),
    [anon_sym_triangleadj] = ACTIONS(3881),
    [anon_sym_lineadj] = ACTIONS(3881),
    [anon_sym_triangle] = ACTIONS(3881),
    [anon_sym_interface] = ACTIONS(3881),
    [anon_sym_extension] = ACTIONS(3881),
    [anon_sym___exported] = ACTIONS(3881),
  },
  [1087] = {
    [sym_identifier] = ACTIONS(3677),
    [aux_sym_preproc_include_token1] = ACTIONS(3677),
    [aux_sym_preproc_def_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3677),
    [sym_preproc_directive] = ACTIONS(3677),
    [anon_sym_LPAREN2] = ACTIONS(3679),
    [anon_sym_BANG] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3677),
    [anon_sym_PLUS] = ACTIONS(3677),
    [anon_sym_STAR] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_AMP] = ACTIONS(3677),
    [anon_sym_SEMI] = ACTIONS(3679),
    [anon_sym___extension__] = ACTIONS(3677),
    [anon_sym_typedef] = ACTIONS(3677),
    [anon_sym_in] = ACTIONS(3677),
    [anon_sym_out] = ACTIONS(3677),
    [anon_sym_inout] = ACTIONS(3677),
    [anon_sym_virtual] = ACTIONS(3677),
    [anon_sym_extern] = ACTIONS(3677),
    [anon_sym___attribute__] = ACTIONS(3677),
    [anon_sym___attribute] = ACTIONS(3677),
    [anon_sym_using] = ACTIONS(3677),
    [anon_sym_COLON_COLON] = ACTIONS(3679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3679),
    [anon_sym___declspec] = ACTIONS(3677),
    [anon_sym___based] = ACTIONS(3677),
    [anon_sym___cdecl] = ACTIONS(3677),
    [anon_sym___clrcall] = ACTIONS(3677),
    [anon_sym___stdcall] = ACTIONS(3677),
    [anon_sym___fastcall] = ACTIONS(3677),
    [anon_sym___thiscall] = ACTIONS(3677),
    [anon_sym___vectorcall] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_RBRACE] = ACTIONS(3679),
    [anon_sym_signed] = ACTIONS(3677),
    [anon_sym_unsigned] = ACTIONS(3677),
    [anon_sym_long] = ACTIONS(3677),
    [anon_sym_short] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3677),
    [anon_sym_static] = ACTIONS(3677),
    [anon_sym_register] = ACTIONS(3677),
    [anon_sym_inline] = ACTIONS(3677),
    [anon_sym___inline] = ACTIONS(3677),
    [anon_sym___inline__] = ACTIONS(3677),
    [anon_sym___forceinline] = ACTIONS(3677),
    [anon_sym_thread_local] = ACTIONS(3677),
    [anon_sym___thread] = ACTIONS(3677),
    [anon_sym_const] = ACTIONS(3677),
    [anon_sym_constexpr] = ACTIONS(3677),
    [anon_sym_volatile] = ACTIONS(3677),
    [anon_sym_restrict] = ACTIONS(3677),
    [anon_sym___restrict__] = ACTIONS(3677),
    [anon_sym__Atomic] = ACTIONS(3677),
    [anon_sym__Noreturn] = ACTIONS(3677),
    [anon_sym_noreturn] = ACTIONS(3677),
    [anon_sym__Nonnull] = ACTIONS(3677),
    [anon_sym_mutable] = ACTIONS(3677),
    [anon_sym_constinit] = ACTIONS(3677),
    [anon_sym_consteval] = ACTIONS(3677),
    [anon_sym_alignas] = ACTIONS(3677),
    [anon_sym__Alignas] = ACTIONS(3677),
    [sym_primitive_type] = ACTIONS(3677),
    [anon_sym_enum] = ACTIONS(3677),
    [anon_sym_class] = ACTIONS(3677),
    [anon_sym_struct] = ACTIONS(3677),
    [anon_sym_union] = ACTIONS(3677),
    [anon_sym_if] = ACTIONS(3677),
    [anon_sym_switch] = ACTIONS(3677),
    [anon_sym_case] = ACTIONS(3677),
    [anon_sym_default] = ACTIONS(3677),
    [anon_sym_while] = ACTIONS(3677),
    [anon_sym_do] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3677),
    [anon_sym_return] = ACTIONS(3677),
    [anon_sym_break] = ACTIONS(3677),
    [anon_sym_continue] = ACTIONS(3677),
    [anon_sym_goto] = ACTIONS(3677),
    [anon_sym___try] = ACTIONS(3677),
    [anon_sym___leave] = ACTIONS(3677),
    [anon_sym_not] = ACTIONS(3677),
    [anon_sym_compl] = ACTIONS(3677),
    [anon_sym_DASH_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_PLUS] = ACTIONS(3679),
    [anon_sym_sizeof] = ACTIONS(3677),
    [anon_sym___alignof__] = ACTIONS(3677),
    [anon_sym___alignof] = ACTIONS(3677),
    [anon_sym__alignof] = ACTIONS(3677),
    [anon_sym_alignof] = ACTIONS(3677),
    [anon_sym__Alignof] = ACTIONS(3677),
    [anon_sym_offsetof] = ACTIONS(3677),
    [anon_sym__Generic] = ACTIONS(3677),
    [anon_sym_asm] = ACTIONS(3677),
    [anon_sym___asm__] = ACTIONS(3677),
    [anon_sym___asm] = ACTIONS(3677),
    [sym_number_literal] = ACTIONS(3679),
    [anon_sym_L_SQUOTE] = ACTIONS(3679),
    [anon_sym_u_SQUOTE] = ACTIONS(3679),
    [anon_sym_U_SQUOTE] = ACTIONS(3679),
    [anon_sym_u8_SQUOTE] = ACTIONS(3679),
    [anon_sym_SQUOTE] = ACTIONS(3679),
    [anon_sym_L_DQUOTE] = ACTIONS(3679),
    [anon_sym_u_DQUOTE] = ACTIONS(3679),
    [anon_sym_U_DQUOTE] = ACTIONS(3679),
    [anon_sym_u8_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [sym_true] = ACTIONS(3677),
    [sym_false] = ACTIONS(3677),
    [anon_sym_NULL] = ACTIONS(3677),
    [anon_sym_nullptr] = ACTIONS(3677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3677),
    [anon_sym_let] = ACTIONS(3677),
    [anon_sym_This] = ACTIONS(3677),
    [anon_sym_decltype] = ACTIONS(3677),
    [anon_sym_explicit] = ACTIONS(3677),
    [anon_sym_typename] = ACTIONS(3677),
    [anon_sym_template] = ACTIONS(3677),
    [anon_sym_operator] = ACTIONS(3677),
    [anon_sym_try] = ACTIONS(3677),
    [anon_sym_delete] = ACTIONS(3677),
    [anon_sym_throw] = ACTIONS(3677),
    [anon_sym_namespace] = ACTIONS(3677),
    [anon_sym_static_assert] = ACTIONS(3677),
    [anon_sym_concept] = ACTIONS(3677),
    [anon_sym_co_return] = ACTIONS(3677),
    [anon_sym_co_yield] = ACTIONS(3677),
    [anon_sym_R_DQUOTE] = ACTIONS(3679),
    [anon_sym_LR_DQUOTE] = ACTIONS(3679),
    [anon_sym_uR_DQUOTE] = ACTIONS(3679),
    [anon_sym_UR_DQUOTE] = ACTIONS(3679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3679),
    [anon_sym_co_await] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3677),
    [anon_sym_requires] = ACTIONS(3677),
    [sym_this] = ACTIONS(3677),
    [anon_sym_discard] = ACTIONS(3677),
    [anon_sym_precise] = ACTIONS(3677),
    [anon_sym_shared] = ACTIONS(3677),
    [anon_sym_groupshared] = ACTIONS(3677),
    [anon_sym_uniform] = ACTIONS(3677),
    [anon_sym_row_major] = ACTIONS(3677),
    [anon_sym_column_major] = ACTIONS(3677),
    [anon_sym_globallycoherent] = ACTIONS(3677),
    [anon_sym_centroid] = ACTIONS(3677),
    [anon_sym_noperspective] = ACTIONS(3677),
    [anon_sym_nointerpolation] = ACTIONS(3677),
    [anon_sym_sample] = ACTIONS(3677),
    [anon_sym_linear] = ACTIONS(3677),
    [anon_sym_snorm] = ACTIONS(3677),
    [anon_sym_unorm] = ACTIONS(3677),
    [anon_sym_point] = ACTIONS(3677),
    [anon_sym_line] = ACTIONS(3677),
    [anon_sym_triangleadj] = ACTIONS(3677),
    [anon_sym_lineadj] = ACTIONS(3677),
    [anon_sym_triangle] = ACTIONS(3677),
    [anon_sym_cbuffer] = ACTIONS(3677),
    [anon_sym_interface] = ACTIONS(3677),
    [anon_sym_extension] = ACTIONS(3677),
  },
  [1088] = {
    [sym_identifier] = ACTIONS(3923),
    [aux_sym_preproc_include_token1] = ACTIONS(3923),
    [aux_sym_preproc_def_token1] = ACTIONS(3923),
    [aux_sym_preproc_if_token1] = ACTIONS(3923),
    [aux_sym_preproc_if_token2] = ACTIONS(3923),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3923),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3923),
    [sym_preproc_directive] = ACTIONS(3923),
    [anon_sym_LPAREN2] = ACTIONS(3925),
    [anon_sym_BANG] = ACTIONS(3925),
    [anon_sym_TILDE] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_STAR] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_AMP] = ACTIONS(3923),
    [anon_sym_SEMI] = ACTIONS(3925),
    [anon_sym___extension__] = ACTIONS(3923),
    [anon_sym_typedef] = ACTIONS(3923),
    [anon_sym_in] = ACTIONS(3923),
    [anon_sym_out] = ACTIONS(3923),
    [anon_sym_inout] = ACTIONS(3923),
    [anon_sym_virtual] = ACTIONS(3923),
    [anon_sym_extern] = ACTIONS(3923),
    [anon_sym___attribute__] = ACTIONS(3923),
    [anon_sym___attribute] = ACTIONS(3923),
    [anon_sym_using] = ACTIONS(3923),
    [anon_sym_COLON_COLON] = ACTIONS(3925),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3925),
    [anon_sym___declspec] = ACTIONS(3923),
    [anon_sym___based] = ACTIONS(3923),
    [anon_sym___cdecl] = ACTIONS(3923),
    [anon_sym___clrcall] = ACTIONS(3923),
    [anon_sym___stdcall] = ACTIONS(3923),
    [anon_sym___fastcall] = ACTIONS(3923),
    [anon_sym___thiscall] = ACTIONS(3923),
    [anon_sym___vectorcall] = ACTIONS(3923),
    [anon_sym_LBRACE] = ACTIONS(3925),
    [anon_sym_signed] = ACTIONS(3923),
    [anon_sym_unsigned] = ACTIONS(3923),
    [anon_sym_long] = ACTIONS(3923),
    [anon_sym_short] = ACTIONS(3923),
    [anon_sym_LBRACK] = ACTIONS(3923),
    [anon_sym_static] = ACTIONS(3923),
    [anon_sym_register] = ACTIONS(3923),
    [anon_sym_inline] = ACTIONS(3923),
    [anon_sym___inline] = ACTIONS(3923),
    [anon_sym___inline__] = ACTIONS(3923),
    [anon_sym___forceinline] = ACTIONS(3923),
    [anon_sym_thread_local] = ACTIONS(3923),
    [anon_sym___thread] = ACTIONS(3923),
    [anon_sym_const] = ACTIONS(3923),
    [anon_sym_constexpr] = ACTIONS(3923),
    [anon_sym_volatile] = ACTIONS(3923),
    [anon_sym_restrict] = ACTIONS(3923),
    [anon_sym___restrict__] = ACTIONS(3923),
    [anon_sym__Atomic] = ACTIONS(3923),
    [anon_sym__Noreturn] = ACTIONS(3923),
    [anon_sym_noreturn] = ACTIONS(3923),
    [anon_sym__Nonnull] = ACTIONS(3923),
    [anon_sym_mutable] = ACTIONS(3923),
    [anon_sym_constinit] = ACTIONS(3923),
    [anon_sym_consteval] = ACTIONS(3923),
    [anon_sym_alignas] = ACTIONS(3923),
    [anon_sym__Alignas] = ACTIONS(3923),
    [sym_primitive_type] = ACTIONS(3923),
    [anon_sym_enum] = ACTIONS(3923),
    [anon_sym_class] = ACTIONS(3923),
    [anon_sym_struct] = ACTIONS(3923),
    [anon_sym_union] = ACTIONS(3923),
    [anon_sym_if] = ACTIONS(3923),
    [anon_sym_switch] = ACTIONS(3923),
    [anon_sym_case] = ACTIONS(3923),
    [anon_sym_default] = ACTIONS(3923),
    [anon_sym_while] = ACTIONS(3923),
    [anon_sym_do] = ACTIONS(3923),
    [anon_sym_for] = ACTIONS(3923),
    [anon_sym_return] = ACTIONS(3923),
    [anon_sym_break] = ACTIONS(3923),
    [anon_sym_continue] = ACTIONS(3923),
    [anon_sym_goto] = ACTIONS(3923),
    [anon_sym___try] = ACTIONS(3923),
    [anon_sym___leave] = ACTIONS(3923),
    [anon_sym_not] = ACTIONS(3923),
    [anon_sym_compl] = ACTIONS(3923),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3923),
    [anon_sym___alignof__] = ACTIONS(3923),
    [anon_sym___alignof] = ACTIONS(3923),
    [anon_sym__alignof] = ACTIONS(3923),
    [anon_sym_alignof] = ACTIONS(3923),
    [anon_sym__Alignof] = ACTIONS(3923),
    [anon_sym_offsetof] = ACTIONS(3923),
    [anon_sym__Generic] = ACTIONS(3923),
    [anon_sym_asm] = ACTIONS(3923),
    [anon_sym___asm__] = ACTIONS(3923),
    [anon_sym___asm] = ACTIONS(3923),
    [sym_number_literal] = ACTIONS(3925),
    [anon_sym_L_SQUOTE] = ACTIONS(3925),
    [anon_sym_u_SQUOTE] = ACTIONS(3925),
    [anon_sym_U_SQUOTE] = ACTIONS(3925),
    [anon_sym_u8_SQUOTE] = ACTIONS(3925),
    [anon_sym_SQUOTE] = ACTIONS(3925),
    [anon_sym_L_DQUOTE] = ACTIONS(3925),
    [anon_sym_u_DQUOTE] = ACTIONS(3925),
    [anon_sym_U_DQUOTE] = ACTIONS(3925),
    [anon_sym_u8_DQUOTE] = ACTIONS(3925),
    [anon_sym_DQUOTE] = ACTIONS(3925),
    [sym_true] = ACTIONS(3923),
    [sym_false] = ACTIONS(3923),
    [anon_sym_NULL] = ACTIONS(3923),
    [anon_sym_nullptr] = ACTIONS(3923),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3923),
    [anon_sym_let] = ACTIONS(3923),
    [anon_sym_This] = ACTIONS(3923),
    [anon_sym_decltype] = ACTIONS(3923),
    [anon_sym_explicit] = ACTIONS(3923),
    [anon_sym_typename] = ACTIONS(3923),
    [anon_sym_template] = ACTIONS(3923),
    [anon_sym_operator] = ACTIONS(3923),
    [anon_sym_try] = ACTIONS(3923),
    [anon_sym_delete] = ACTIONS(3923),
    [anon_sym_throw] = ACTIONS(3923),
    [anon_sym_namespace] = ACTIONS(3923),
    [anon_sym_static_assert] = ACTIONS(3923),
    [anon_sym_concept] = ACTIONS(3923),
    [anon_sym_co_return] = ACTIONS(3923),
    [anon_sym_co_yield] = ACTIONS(3923),
    [anon_sym_R_DQUOTE] = ACTIONS(3925),
    [anon_sym_LR_DQUOTE] = ACTIONS(3925),
    [anon_sym_uR_DQUOTE] = ACTIONS(3925),
    [anon_sym_UR_DQUOTE] = ACTIONS(3925),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3925),
    [anon_sym_co_await] = ACTIONS(3923),
    [anon_sym_new] = ACTIONS(3923),
    [anon_sym_requires] = ACTIONS(3923),
    [sym_this] = ACTIONS(3923),
    [anon_sym_discard] = ACTIONS(3923),
    [anon_sym_precise] = ACTIONS(3923),
    [anon_sym_shared] = ACTIONS(3923),
    [anon_sym_groupshared] = ACTIONS(3923),
    [anon_sym_uniform] = ACTIONS(3923),
    [anon_sym_row_major] = ACTIONS(3923),
    [anon_sym_column_major] = ACTIONS(3923),
    [anon_sym_globallycoherent] = ACTIONS(3923),
    [anon_sym_centroid] = ACTIONS(3923),
    [anon_sym_noperspective] = ACTIONS(3923),
    [anon_sym_nointerpolation] = ACTIONS(3923),
    [anon_sym_sample] = ACTIONS(3923),
    [anon_sym_linear] = ACTIONS(3923),
    [anon_sym_snorm] = ACTIONS(3923),
    [anon_sym_unorm] = ACTIONS(3923),
    [anon_sym_point] = ACTIONS(3923),
    [anon_sym_line] = ACTIONS(3923),
    [anon_sym_triangleadj] = ACTIONS(3923),
    [anon_sym_lineadj] = ACTIONS(3923),
    [anon_sym_triangle] = ACTIONS(3923),
    [anon_sym_cbuffer] = ACTIONS(3923),
    [anon_sym_interface] = ACTIONS(3923),
    [anon_sym_extension] = ACTIONS(3923),
  },
  [1089] = {
    [sym_identifier] = ACTIONS(3927),
    [aux_sym_preproc_include_token1] = ACTIONS(3927),
    [aux_sym_preproc_def_token1] = ACTIONS(3927),
    [aux_sym_preproc_if_token1] = ACTIONS(3927),
    [aux_sym_preproc_if_token2] = ACTIONS(3927),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3927),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3927),
    [sym_preproc_directive] = ACTIONS(3927),
    [anon_sym_LPAREN2] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3929),
    [anon_sym_TILDE] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_SEMI] = ACTIONS(3929),
    [anon_sym___extension__] = ACTIONS(3927),
    [anon_sym_typedef] = ACTIONS(3927),
    [anon_sym_in] = ACTIONS(3927),
    [anon_sym_out] = ACTIONS(3927),
    [anon_sym_inout] = ACTIONS(3927),
    [anon_sym_virtual] = ACTIONS(3927),
    [anon_sym_extern] = ACTIONS(3927),
    [anon_sym___attribute__] = ACTIONS(3927),
    [anon_sym___attribute] = ACTIONS(3927),
    [anon_sym_using] = ACTIONS(3927),
    [anon_sym_COLON_COLON] = ACTIONS(3929),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3929),
    [anon_sym___declspec] = ACTIONS(3927),
    [anon_sym___based] = ACTIONS(3927),
    [anon_sym___cdecl] = ACTIONS(3927),
    [anon_sym___clrcall] = ACTIONS(3927),
    [anon_sym___stdcall] = ACTIONS(3927),
    [anon_sym___fastcall] = ACTIONS(3927),
    [anon_sym___thiscall] = ACTIONS(3927),
    [anon_sym___vectorcall] = ACTIONS(3927),
    [anon_sym_LBRACE] = ACTIONS(3929),
    [anon_sym_signed] = ACTIONS(3927),
    [anon_sym_unsigned] = ACTIONS(3927),
    [anon_sym_long] = ACTIONS(3927),
    [anon_sym_short] = ACTIONS(3927),
    [anon_sym_LBRACK] = ACTIONS(3927),
    [anon_sym_static] = ACTIONS(3927),
    [anon_sym_register] = ACTIONS(3927),
    [anon_sym_inline] = ACTIONS(3927),
    [anon_sym___inline] = ACTIONS(3927),
    [anon_sym___inline__] = ACTIONS(3927),
    [anon_sym___forceinline] = ACTIONS(3927),
    [anon_sym_thread_local] = ACTIONS(3927),
    [anon_sym___thread] = ACTIONS(3927),
    [anon_sym_const] = ACTIONS(3927),
    [anon_sym_constexpr] = ACTIONS(3927),
    [anon_sym_volatile] = ACTIONS(3927),
    [anon_sym_restrict] = ACTIONS(3927),
    [anon_sym___restrict__] = ACTIONS(3927),
    [anon_sym__Atomic] = ACTIONS(3927),
    [anon_sym__Noreturn] = ACTIONS(3927),
    [anon_sym_noreturn] = ACTIONS(3927),
    [anon_sym__Nonnull] = ACTIONS(3927),
    [anon_sym_mutable] = ACTIONS(3927),
    [anon_sym_constinit] = ACTIONS(3927),
    [anon_sym_consteval] = ACTIONS(3927),
    [anon_sym_alignas] = ACTIONS(3927),
    [anon_sym__Alignas] = ACTIONS(3927),
    [sym_primitive_type] = ACTIONS(3927),
    [anon_sym_enum] = ACTIONS(3927),
    [anon_sym_class] = ACTIONS(3927),
    [anon_sym_struct] = ACTIONS(3927),
    [anon_sym_union] = ACTIONS(3927),
    [anon_sym_if] = ACTIONS(3927),
    [anon_sym_switch] = ACTIONS(3927),
    [anon_sym_case] = ACTIONS(3927),
    [anon_sym_default] = ACTIONS(3927),
    [anon_sym_while] = ACTIONS(3927),
    [anon_sym_do] = ACTIONS(3927),
    [anon_sym_for] = ACTIONS(3927),
    [anon_sym_return] = ACTIONS(3927),
    [anon_sym_break] = ACTIONS(3927),
    [anon_sym_continue] = ACTIONS(3927),
    [anon_sym_goto] = ACTIONS(3927),
    [anon_sym___try] = ACTIONS(3927),
    [anon_sym___leave] = ACTIONS(3927),
    [anon_sym_not] = ACTIONS(3927),
    [anon_sym_compl] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3929),
    [anon_sym_sizeof] = ACTIONS(3927),
    [anon_sym___alignof__] = ACTIONS(3927),
    [anon_sym___alignof] = ACTIONS(3927),
    [anon_sym__alignof] = ACTIONS(3927),
    [anon_sym_alignof] = ACTIONS(3927),
    [anon_sym__Alignof] = ACTIONS(3927),
    [anon_sym_offsetof] = ACTIONS(3927),
    [anon_sym__Generic] = ACTIONS(3927),
    [anon_sym_asm] = ACTIONS(3927),
    [anon_sym___asm__] = ACTIONS(3927),
    [anon_sym___asm] = ACTIONS(3927),
    [sym_number_literal] = ACTIONS(3929),
    [anon_sym_L_SQUOTE] = ACTIONS(3929),
    [anon_sym_u_SQUOTE] = ACTIONS(3929),
    [anon_sym_U_SQUOTE] = ACTIONS(3929),
    [anon_sym_u8_SQUOTE] = ACTIONS(3929),
    [anon_sym_SQUOTE] = ACTIONS(3929),
    [anon_sym_L_DQUOTE] = ACTIONS(3929),
    [anon_sym_u_DQUOTE] = ACTIONS(3929),
    [anon_sym_U_DQUOTE] = ACTIONS(3929),
    [anon_sym_u8_DQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [sym_true] = ACTIONS(3927),
    [sym_false] = ACTIONS(3927),
    [anon_sym_NULL] = ACTIONS(3927),
    [anon_sym_nullptr] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3927),
    [anon_sym_let] = ACTIONS(3927),
    [anon_sym_This] = ACTIONS(3927),
    [anon_sym_decltype] = ACTIONS(3927),
    [anon_sym_explicit] = ACTIONS(3927),
    [anon_sym_typename] = ACTIONS(3927),
    [anon_sym_template] = ACTIONS(3927),
    [anon_sym_operator] = ACTIONS(3927),
    [anon_sym_try] = ACTIONS(3927),
    [anon_sym_delete] = ACTIONS(3927),
    [anon_sym_throw] = ACTIONS(3927),
    [anon_sym_namespace] = ACTIONS(3927),
    [anon_sym_static_assert] = ACTIONS(3927),
    [anon_sym_concept] = ACTIONS(3927),
    [anon_sym_co_return] = ACTIONS(3927),
    [anon_sym_co_yield] = ACTIONS(3927),
    [anon_sym_R_DQUOTE] = ACTIONS(3929),
    [anon_sym_LR_DQUOTE] = ACTIONS(3929),
    [anon_sym_uR_DQUOTE] = ACTIONS(3929),
    [anon_sym_UR_DQUOTE] = ACTIONS(3929),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3929),
    [anon_sym_co_await] = ACTIONS(3927),
    [anon_sym_new] = ACTIONS(3927),
    [anon_sym_requires] = ACTIONS(3927),
    [sym_this] = ACTIONS(3927),
    [anon_sym_discard] = ACTIONS(3927),
    [anon_sym_precise] = ACTIONS(3927),
    [anon_sym_shared] = ACTIONS(3927),
    [anon_sym_groupshared] = ACTIONS(3927),
    [anon_sym_uniform] = ACTIONS(3927),
    [anon_sym_row_major] = ACTIONS(3927),
    [anon_sym_column_major] = ACTIONS(3927),
    [anon_sym_globallycoherent] = ACTIONS(3927),
    [anon_sym_centroid] = ACTIONS(3927),
    [anon_sym_noperspective] = ACTIONS(3927),
    [anon_sym_nointerpolation] = ACTIONS(3927),
    [anon_sym_sample] = ACTIONS(3927),
    [anon_sym_linear] = ACTIONS(3927),
    [anon_sym_snorm] = ACTIONS(3927),
    [anon_sym_unorm] = ACTIONS(3927),
    [anon_sym_point] = ACTIONS(3927),
    [anon_sym_line] = ACTIONS(3927),
    [anon_sym_triangleadj] = ACTIONS(3927),
    [anon_sym_lineadj] = ACTIONS(3927),
    [anon_sym_triangle] = ACTIONS(3927),
    [anon_sym_cbuffer] = ACTIONS(3927),
    [anon_sym_interface] = ACTIONS(3927),
    [anon_sym_extension] = ACTIONS(3927),
  },
  [1090] = {
    [sym_identifier] = ACTIONS(3935),
    [aux_sym_preproc_include_token1] = ACTIONS(3935),
    [aux_sym_preproc_def_token1] = ACTIONS(3935),
    [aux_sym_preproc_if_token1] = ACTIONS(3935),
    [aux_sym_preproc_if_token2] = ACTIONS(3935),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3935),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3935),
    [sym_preproc_directive] = ACTIONS(3935),
    [anon_sym_LPAREN2] = ACTIONS(3937),
    [anon_sym_BANG] = ACTIONS(3937),
    [anon_sym_TILDE] = ACTIONS(3937),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3935),
    [anon_sym_STAR] = ACTIONS(3937),
    [anon_sym_AMP_AMP] = ACTIONS(3937),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_SEMI] = ACTIONS(3937),
    [anon_sym___extension__] = ACTIONS(3935),
    [anon_sym_typedef] = ACTIONS(3935),
    [anon_sym_in] = ACTIONS(3935),
    [anon_sym_out] = ACTIONS(3935),
    [anon_sym_inout] = ACTIONS(3935),
    [anon_sym_virtual] = ACTIONS(3935),
    [anon_sym_extern] = ACTIONS(3935),
    [anon_sym___attribute__] = ACTIONS(3935),
    [anon_sym___attribute] = ACTIONS(3935),
    [anon_sym_using] = ACTIONS(3935),
    [anon_sym_COLON_COLON] = ACTIONS(3937),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3937),
    [anon_sym___declspec] = ACTIONS(3935),
    [anon_sym___based] = ACTIONS(3935),
    [anon_sym___cdecl] = ACTIONS(3935),
    [anon_sym___clrcall] = ACTIONS(3935),
    [anon_sym___stdcall] = ACTIONS(3935),
    [anon_sym___fastcall] = ACTIONS(3935),
    [anon_sym___thiscall] = ACTIONS(3935),
    [anon_sym___vectorcall] = ACTIONS(3935),
    [anon_sym_LBRACE] = ACTIONS(3937),
    [anon_sym_signed] = ACTIONS(3935),
    [anon_sym_unsigned] = ACTIONS(3935),
    [anon_sym_long] = ACTIONS(3935),
    [anon_sym_short] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3935),
    [anon_sym_static] = ACTIONS(3935),
    [anon_sym_register] = ACTIONS(3935),
    [anon_sym_inline] = ACTIONS(3935),
    [anon_sym___inline] = ACTIONS(3935),
    [anon_sym___inline__] = ACTIONS(3935),
    [anon_sym___forceinline] = ACTIONS(3935),
    [anon_sym_thread_local] = ACTIONS(3935),
    [anon_sym___thread] = ACTIONS(3935),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_constexpr] = ACTIONS(3935),
    [anon_sym_volatile] = ACTIONS(3935),
    [anon_sym_restrict] = ACTIONS(3935),
    [anon_sym___restrict__] = ACTIONS(3935),
    [anon_sym__Atomic] = ACTIONS(3935),
    [anon_sym__Noreturn] = ACTIONS(3935),
    [anon_sym_noreturn] = ACTIONS(3935),
    [anon_sym__Nonnull] = ACTIONS(3935),
    [anon_sym_mutable] = ACTIONS(3935),
    [anon_sym_constinit] = ACTIONS(3935),
    [anon_sym_consteval] = ACTIONS(3935),
    [anon_sym_alignas] = ACTIONS(3935),
    [anon_sym__Alignas] = ACTIONS(3935),
    [sym_primitive_type] = ACTIONS(3935),
    [anon_sym_enum] = ACTIONS(3935),
    [anon_sym_class] = ACTIONS(3935),
    [anon_sym_struct] = ACTIONS(3935),
    [anon_sym_union] = ACTIONS(3935),
    [anon_sym_if] = ACTIONS(3935),
    [anon_sym_switch] = ACTIONS(3935),
    [anon_sym_case] = ACTIONS(3935),
    [anon_sym_default] = ACTIONS(3935),
    [anon_sym_while] = ACTIONS(3935),
    [anon_sym_do] = ACTIONS(3935),
    [anon_sym_for] = ACTIONS(3935),
    [anon_sym_return] = ACTIONS(3935),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_continue] = ACTIONS(3935),
    [anon_sym_goto] = ACTIONS(3935),
    [anon_sym___try] = ACTIONS(3935),
    [anon_sym___leave] = ACTIONS(3935),
    [anon_sym_not] = ACTIONS(3935),
    [anon_sym_compl] = ACTIONS(3935),
    [anon_sym_DASH_DASH] = ACTIONS(3937),
    [anon_sym_PLUS_PLUS] = ACTIONS(3937),
    [anon_sym_sizeof] = ACTIONS(3935),
    [anon_sym___alignof__] = ACTIONS(3935),
    [anon_sym___alignof] = ACTIONS(3935),
    [anon_sym__alignof] = ACTIONS(3935),
    [anon_sym_alignof] = ACTIONS(3935),
    [anon_sym__Alignof] = ACTIONS(3935),
    [anon_sym_offsetof] = ACTIONS(3935),
    [anon_sym__Generic] = ACTIONS(3935),
    [anon_sym_asm] = ACTIONS(3935),
    [anon_sym___asm__] = ACTIONS(3935),
    [anon_sym___asm] = ACTIONS(3935),
    [sym_number_literal] = ACTIONS(3937),
    [anon_sym_L_SQUOTE] = ACTIONS(3937),
    [anon_sym_u_SQUOTE] = ACTIONS(3937),
    [anon_sym_U_SQUOTE] = ACTIONS(3937),
    [anon_sym_u8_SQUOTE] = ACTIONS(3937),
    [anon_sym_SQUOTE] = ACTIONS(3937),
    [anon_sym_L_DQUOTE] = ACTIONS(3937),
    [anon_sym_u_DQUOTE] = ACTIONS(3937),
    [anon_sym_U_DQUOTE] = ACTIONS(3937),
    [anon_sym_u8_DQUOTE] = ACTIONS(3937),
    [anon_sym_DQUOTE] = ACTIONS(3937),
    [sym_true] = ACTIONS(3935),
    [sym_false] = ACTIONS(3935),
    [anon_sym_NULL] = ACTIONS(3935),
    [anon_sym_nullptr] = ACTIONS(3935),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3935),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_This] = ACTIONS(3935),
    [anon_sym_decltype] = ACTIONS(3935),
    [anon_sym_explicit] = ACTIONS(3935),
    [anon_sym_typename] = ACTIONS(3935),
    [anon_sym_template] = ACTIONS(3935),
    [anon_sym_operator] = ACTIONS(3935),
    [anon_sym_try] = ACTIONS(3935),
    [anon_sym_delete] = ACTIONS(3935),
    [anon_sym_throw] = ACTIONS(3935),
    [anon_sym_namespace] = ACTIONS(3935),
    [anon_sym_static_assert] = ACTIONS(3935),
    [anon_sym_concept] = ACTIONS(3935),
    [anon_sym_co_return] = ACTIONS(3935),
    [anon_sym_co_yield] = ACTIONS(3935),
    [anon_sym_R_DQUOTE] = ACTIONS(3937),
    [anon_sym_LR_DQUOTE] = ACTIONS(3937),
    [anon_sym_uR_DQUOTE] = ACTIONS(3937),
    [anon_sym_UR_DQUOTE] = ACTIONS(3937),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3937),
    [anon_sym_co_await] = ACTIONS(3935),
    [anon_sym_new] = ACTIONS(3935),
    [anon_sym_requires] = ACTIONS(3935),
    [sym_this] = ACTIONS(3935),
    [anon_sym_discard] = ACTIONS(3935),
    [anon_sym_precise] = ACTIONS(3935),
    [anon_sym_shared] = ACTIONS(3935),
    [anon_sym_groupshared] = ACTIONS(3935),
    [anon_sym_uniform] = ACTIONS(3935),
    [anon_sym_row_major] = ACTIONS(3935),
    [anon_sym_column_major] = ACTIONS(3935),
    [anon_sym_globallycoherent] = ACTIONS(3935),
    [anon_sym_centroid] = ACTIONS(3935),
    [anon_sym_noperspective] = ACTIONS(3935),
    [anon_sym_nointerpolation] = ACTIONS(3935),
    [anon_sym_sample] = ACTIONS(3935),
    [anon_sym_linear] = ACTIONS(3935),
    [anon_sym_snorm] = ACTIONS(3935),
    [anon_sym_unorm] = ACTIONS(3935),
    [anon_sym_point] = ACTIONS(3935),
    [anon_sym_line] = ACTIONS(3935),
    [anon_sym_triangleadj] = ACTIONS(3935),
    [anon_sym_lineadj] = ACTIONS(3935),
    [anon_sym_triangle] = ACTIONS(3935),
    [anon_sym_cbuffer] = ACTIONS(3935),
    [anon_sym_interface] = ACTIONS(3935),
    [anon_sym_extension] = ACTIONS(3935),
  },
  [1091] = {
    [sym_identifier] = ACTIONS(3759),
    [aux_sym_preproc_include_token1] = ACTIONS(3759),
    [aux_sym_preproc_def_token1] = ACTIONS(3759),
    [aux_sym_preproc_if_token1] = ACTIONS(3759),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3759),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3759),
    [sym_preproc_directive] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_BANG] = ACTIONS(3761),
    [anon_sym_TILDE] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_STAR] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym___extension__] = ACTIONS(3759),
    [anon_sym_typedef] = ACTIONS(3759),
    [anon_sym_in] = ACTIONS(3759),
    [anon_sym_out] = ACTIONS(3759),
    [anon_sym_inout] = ACTIONS(3759),
    [anon_sym_virtual] = ACTIONS(3759),
    [anon_sym_extern] = ACTIONS(3759),
    [anon_sym___attribute__] = ACTIONS(3759),
    [anon_sym___attribute] = ACTIONS(3759),
    [anon_sym_using] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3761),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3761),
    [anon_sym___declspec] = ACTIONS(3759),
    [anon_sym___based] = ACTIONS(3759),
    [anon_sym___cdecl] = ACTIONS(3759),
    [anon_sym___clrcall] = ACTIONS(3759),
    [anon_sym___stdcall] = ACTIONS(3759),
    [anon_sym___fastcall] = ACTIONS(3759),
    [anon_sym___thiscall] = ACTIONS(3759),
    [anon_sym___vectorcall] = ACTIONS(3759),
    [anon_sym_LBRACE] = ACTIONS(3761),
    [anon_sym_RBRACE] = ACTIONS(3761),
    [anon_sym_signed] = ACTIONS(3759),
    [anon_sym_unsigned] = ACTIONS(3759),
    [anon_sym_long] = ACTIONS(3759),
    [anon_sym_short] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_register] = ACTIONS(3759),
    [anon_sym_inline] = ACTIONS(3759),
    [anon_sym___inline] = ACTIONS(3759),
    [anon_sym___inline__] = ACTIONS(3759),
    [anon_sym___forceinline] = ACTIONS(3759),
    [anon_sym_thread_local] = ACTIONS(3759),
    [anon_sym___thread] = ACTIONS(3759),
    [anon_sym_const] = ACTIONS(3759),
    [anon_sym_constexpr] = ACTIONS(3759),
    [anon_sym_volatile] = ACTIONS(3759),
    [anon_sym_restrict] = ACTIONS(3759),
    [anon_sym___restrict__] = ACTIONS(3759),
    [anon_sym__Atomic] = ACTIONS(3759),
    [anon_sym__Noreturn] = ACTIONS(3759),
    [anon_sym_noreturn] = ACTIONS(3759),
    [anon_sym__Nonnull] = ACTIONS(3759),
    [anon_sym_mutable] = ACTIONS(3759),
    [anon_sym_constinit] = ACTIONS(3759),
    [anon_sym_consteval] = ACTIONS(3759),
    [anon_sym_alignas] = ACTIONS(3759),
    [anon_sym__Alignas] = ACTIONS(3759),
    [sym_primitive_type] = ACTIONS(3759),
    [anon_sym_enum] = ACTIONS(3759),
    [anon_sym_class] = ACTIONS(3759),
    [anon_sym_struct] = ACTIONS(3759),
    [anon_sym_union] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_switch] = ACTIONS(3759),
    [anon_sym_case] = ACTIONS(3759),
    [anon_sym_default] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_break] = ACTIONS(3759),
    [anon_sym_continue] = ACTIONS(3759),
    [anon_sym_goto] = ACTIONS(3759),
    [anon_sym___try] = ACTIONS(3759),
    [anon_sym___leave] = ACTIONS(3759),
    [anon_sym_not] = ACTIONS(3759),
    [anon_sym_compl] = ACTIONS(3759),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_sizeof] = ACTIONS(3759),
    [anon_sym___alignof__] = ACTIONS(3759),
    [anon_sym___alignof] = ACTIONS(3759),
    [anon_sym__alignof] = ACTIONS(3759),
    [anon_sym_alignof] = ACTIONS(3759),
    [anon_sym__Alignof] = ACTIONS(3759),
    [anon_sym_offsetof] = ACTIONS(3759),
    [anon_sym__Generic] = ACTIONS(3759),
    [anon_sym_asm] = ACTIONS(3759),
    [anon_sym___asm__] = ACTIONS(3759),
    [anon_sym___asm] = ACTIONS(3759),
    [sym_number_literal] = ACTIONS(3761),
    [anon_sym_L_SQUOTE] = ACTIONS(3761),
    [anon_sym_u_SQUOTE] = ACTIONS(3761),
    [anon_sym_U_SQUOTE] = ACTIONS(3761),
    [anon_sym_u8_SQUOTE] = ACTIONS(3761),
    [anon_sym_SQUOTE] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3761),
    [anon_sym_u_DQUOTE] = ACTIONS(3761),
    [anon_sym_U_DQUOTE] = ACTIONS(3761),
    [anon_sym_u8_DQUOTE] = ACTIONS(3761),
    [anon_sym_DQUOTE] = ACTIONS(3761),
    [sym_true] = ACTIONS(3759),
    [sym_false] = ACTIONS(3759),
    [anon_sym_NULL] = ACTIONS(3759),
    [anon_sym_nullptr] = ACTIONS(3759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_This] = ACTIONS(3759),
    [anon_sym_decltype] = ACTIONS(3759),
    [anon_sym_explicit] = ACTIONS(3759),
    [anon_sym_typename] = ACTIONS(3759),
    [anon_sym_template] = ACTIONS(3759),
    [anon_sym_operator] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_delete] = ACTIONS(3759),
    [anon_sym_throw] = ACTIONS(3759),
    [anon_sym_namespace] = ACTIONS(3759),
    [anon_sym_static_assert] = ACTIONS(3759),
    [anon_sym_concept] = ACTIONS(3759),
    [anon_sym_co_return] = ACTIONS(3759),
    [anon_sym_co_yield] = ACTIONS(3759),
    [anon_sym_R_DQUOTE] = ACTIONS(3761),
    [anon_sym_LR_DQUOTE] = ACTIONS(3761),
    [anon_sym_uR_DQUOTE] = ACTIONS(3761),
    [anon_sym_UR_DQUOTE] = ACTIONS(3761),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3761),
    [anon_sym_co_await] = ACTIONS(3759),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3759),
    [sym_this] = ACTIONS(3759),
    [anon_sym_discard] = ACTIONS(3759),
    [anon_sym_precise] = ACTIONS(3759),
    [anon_sym_shared] = ACTIONS(3759),
    [anon_sym_groupshared] = ACTIONS(3759),
    [anon_sym_uniform] = ACTIONS(3759),
    [anon_sym_row_major] = ACTIONS(3759),
    [anon_sym_column_major] = ACTIONS(3759),
    [anon_sym_globallycoherent] = ACTIONS(3759),
    [anon_sym_centroid] = ACTIONS(3759),
    [anon_sym_noperspective] = ACTIONS(3759),
    [anon_sym_nointerpolation] = ACTIONS(3759),
    [anon_sym_sample] = ACTIONS(3759),
    [anon_sym_linear] = ACTIONS(3759),
    [anon_sym_snorm] = ACTIONS(3759),
    [anon_sym_unorm] = ACTIONS(3759),
    [anon_sym_point] = ACTIONS(3759),
    [anon_sym_line] = ACTIONS(3759),
    [anon_sym_triangleadj] = ACTIONS(3759),
    [anon_sym_lineadj] = ACTIONS(3759),
    [anon_sym_triangle] = ACTIONS(3759),
    [anon_sym_cbuffer] = ACTIONS(3759),
    [anon_sym_interface] = ACTIONS(3759),
    [anon_sym_extension] = ACTIONS(3759),
  },
  [1092] = {
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_include_token1] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token2] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_BANG] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym___cdecl] = ACTIONS(3942),
    [anon_sym___clrcall] = ACTIONS(3942),
    [anon_sym___stdcall] = ACTIONS(3942),
    [anon_sym___fastcall] = ACTIONS(3942),
    [anon_sym___thiscall] = ACTIONS(3942),
    [anon_sym___vectorcall] = ACTIONS(3942),
    [anon_sym_LBRACE] = ACTIONS(3944),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_switch] = ACTIONS(3942),
    [anon_sym_case] = ACTIONS(3942),
    [anon_sym_default] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_break] = ACTIONS(3942),
    [anon_sym_continue] = ACTIONS(3942),
    [anon_sym_goto] = ACTIONS(3942),
    [anon_sym___try] = ACTIONS(3942),
    [anon_sym___leave] = ACTIONS(3942),
    [anon_sym_not] = ACTIONS(3942),
    [anon_sym_compl] = ACTIONS(3942),
    [anon_sym_DASH_DASH] = ACTIONS(3944),
    [anon_sym_PLUS_PLUS] = ACTIONS(3944),
    [anon_sym_sizeof] = ACTIONS(3942),
    [anon_sym___alignof__] = ACTIONS(3942),
    [anon_sym___alignof] = ACTIONS(3942),
    [anon_sym__alignof] = ACTIONS(3942),
    [anon_sym_alignof] = ACTIONS(3942),
    [anon_sym__Alignof] = ACTIONS(3942),
    [anon_sym_offsetof] = ACTIONS(3942),
    [anon_sym__Generic] = ACTIONS(3942),
    [anon_sym_asm] = ACTIONS(3942),
    [anon_sym___asm__] = ACTIONS(3942),
    [anon_sym___asm] = ACTIONS(3942),
    [sym_number_literal] = ACTIONS(3944),
    [anon_sym_L_SQUOTE] = ACTIONS(3944),
    [anon_sym_u_SQUOTE] = ACTIONS(3944),
    [anon_sym_U_SQUOTE] = ACTIONS(3944),
    [anon_sym_u8_SQUOTE] = ACTIONS(3944),
    [anon_sym_SQUOTE] = ACTIONS(3944),
    [anon_sym_L_DQUOTE] = ACTIONS(3944),
    [anon_sym_u_DQUOTE] = ACTIONS(3944),
    [anon_sym_U_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE] = ACTIONS(3944),
    [sym_true] = ACTIONS(3942),
    [sym_false] = ACTIONS(3942),
    [anon_sym_NULL] = ACTIONS(3942),
    [anon_sym_nullptr] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_delete] = ACTIONS(3942),
    [anon_sym_throw] = ACTIONS(3942),
    [anon_sym_namespace] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_concept] = ACTIONS(3942),
    [anon_sym_co_return] = ACTIONS(3942),
    [anon_sym_co_yield] = ACTIONS(3942),
    [anon_sym_R_DQUOTE] = ACTIONS(3944),
    [anon_sym_LR_DQUOTE] = ACTIONS(3944),
    [anon_sym_uR_DQUOTE] = ACTIONS(3944),
    [anon_sym_UR_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3944),
    [anon_sym_co_await] = ACTIONS(3942),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_requires] = ACTIONS(3942),
    [sym_this] = ACTIONS(3942),
    [anon_sym_discard] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_cbuffer] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
  },
  [1093] = {
    [sym_identifier] = ACTIONS(3661),
    [aux_sym_preproc_include_token1] = ACTIONS(3661),
    [aux_sym_preproc_def_token1] = ACTIONS(3661),
    [aux_sym_preproc_if_token1] = ACTIONS(3661),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3661),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3661),
    [sym_preproc_directive] = ACTIONS(3661),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_BANG] = ACTIONS(3663),
    [anon_sym_TILDE] = ACTIONS(3663),
    [anon_sym_DASH] = ACTIONS(3661),
    [anon_sym_PLUS] = ACTIONS(3661),
    [anon_sym_STAR] = ACTIONS(3663),
    [anon_sym_AMP_AMP] = ACTIONS(3663),
    [anon_sym_AMP] = ACTIONS(3661),
    [anon_sym_SEMI] = ACTIONS(3663),
    [anon_sym___extension__] = ACTIONS(3661),
    [anon_sym_typedef] = ACTIONS(3661),
    [anon_sym_in] = ACTIONS(3661),
    [anon_sym_out] = ACTIONS(3661),
    [anon_sym_inout] = ACTIONS(3661),
    [anon_sym_virtual] = ACTIONS(3661),
    [anon_sym_extern] = ACTIONS(3661),
    [anon_sym___attribute__] = ACTIONS(3661),
    [anon_sym___attribute] = ACTIONS(3661),
    [anon_sym_using] = ACTIONS(3661),
    [anon_sym_COLON_COLON] = ACTIONS(3663),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3663),
    [anon_sym___declspec] = ACTIONS(3661),
    [anon_sym___based] = ACTIONS(3661),
    [anon_sym___cdecl] = ACTIONS(3661),
    [anon_sym___clrcall] = ACTIONS(3661),
    [anon_sym___stdcall] = ACTIONS(3661),
    [anon_sym___fastcall] = ACTIONS(3661),
    [anon_sym___thiscall] = ACTIONS(3661),
    [anon_sym___vectorcall] = ACTIONS(3661),
    [anon_sym_LBRACE] = ACTIONS(3663),
    [anon_sym_RBRACE] = ACTIONS(3663),
    [anon_sym_signed] = ACTIONS(3661),
    [anon_sym_unsigned] = ACTIONS(3661),
    [anon_sym_long] = ACTIONS(3661),
    [anon_sym_short] = ACTIONS(3661),
    [anon_sym_LBRACK] = ACTIONS(3661),
    [anon_sym_static] = ACTIONS(3661),
    [anon_sym_register] = ACTIONS(3661),
    [anon_sym_inline] = ACTIONS(3661),
    [anon_sym___inline] = ACTIONS(3661),
    [anon_sym___inline__] = ACTIONS(3661),
    [anon_sym___forceinline] = ACTIONS(3661),
    [anon_sym_thread_local] = ACTIONS(3661),
    [anon_sym___thread] = ACTIONS(3661),
    [anon_sym_const] = ACTIONS(3661),
    [anon_sym_constexpr] = ACTIONS(3661),
    [anon_sym_volatile] = ACTIONS(3661),
    [anon_sym_restrict] = ACTIONS(3661),
    [anon_sym___restrict__] = ACTIONS(3661),
    [anon_sym__Atomic] = ACTIONS(3661),
    [anon_sym__Noreturn] = ACTIONS(3661),
    [anon_sym_noreturn] = ACTIONS(3661),
    [anon_sym__Nonnull] = ACTIONS(3661),
    [anon_sym_mutable] = ACTIONS(3661),
    [anon_sym_constinit] = ACTIONS(3661),
    [anon_sym_consteval] = ACTIONS(3661),
    [anon_sym_alignas] = ACTIONS(3661),
    [anon_sym__Alignas] = ACTIONS(3661),
    [sym_primitive_type] = ACTIONS(3661),
    [anon_sym_enum] = ACTIONS(3661),
    [anon_sym_class] = ACTIONS(3661),
    [anon_sym_struct] = ACTIONS(3661),
    [anon_sym_union] = ACTIONS(3661),
    [anon_sym_if] = ACTIONS(3661),
    [anon_sym_switch] = ACTIONS(3661),
    [anon_sym_case] = ACTIONS(3661),
    [anon_sym_default] = ACTIONS(3661),
    [anon_sym_while] = ACTIONS(3661),
    [anon_sym_do] = ACTIONS(3661),
    [anon_sym_for] = ACTIONS(3661),
    [anon_sym_return] = ACTIONS(3661),
    [anon_sym_break] = ACTIONS(3661),
    [anon_sym_continue] = ACTIONS(3661),
    [anon_sym_goto] = ACTIONS(3661),
    [anon_sym___try] = ACTIONS(3661),
    [anon_sym___leave] = ACTIONS(3661),
    [anon_sym_not] = ACTIONS(3661),
    [anon_sym_compl] = ACTIONS(3661),
    [anon_sym_DASH_DASH] = ACTIONS(3663),
    [anon_sym_PLUS_PLUS] = ACTIONS(3663),
    [anon_sym_sizeof] = ACTIONS(3661),
    [anon_sym___alignof__] = ACTIONS(3661),
    [anon_sym___alignof] = ACTIONS(3661),
    [anon_sym__alignof] = ACTIONS(3661),
    [anon_sym_alignof] = ACTIONS(3661),
    [anon_sym__Alignof] = ACTIONS(3661),
    [anon_sym_offsetof] = ACTIONS(3661),
    [anon_sym__Generic] = ACTIONS(3661),
    [anon_sym_asm] = ACTIONS(3661),
    [anon_sym___asm__] = ACTIONS(3661),
    [anon_sym___asm] = ACTIONS(3661),
    [sym_number_literal] = ACTIONS(3663),
    [anon_sym_L_SQUOTE] = ACTIONS(3663),
    [anon_sym_u_SQUOTE] = ACTIONS(3663),
    [anon_sym_U_SQUOTE] = ACTIONS(3663),
    [anon_sym_u8_SQUOTE] = ACTIONS(3663),
    [anon_sym_SQUOTE] = ACTIONS(3663),
    [anon_sym_L_DQUOTE] = ACTIONS(3663),
    [anon_sym_u_DQUOTE] = ACTIONS(3663),
    [anon_sym_U_DQUOTE] = ACTIONS(3663),
    [anon_sym_u8_DQUOTE] = ACTIONS(3663),
    [anon_sym_DQUOTE] = ACTIONS(3663),
    [sym_true] = ACTIONS(3661),
    [sym_false] = ACTIONS(3661),
    [anon_sym_NULL] = ACTIONS(3661),
    [anon_sym_nullptr] = ACTIONS(3661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3661),
    [anon_sym_let] = ACTIONS(3661),
    [anon_sym_This] = ACTIONS(3661),
    [anon_sym_decltype] = ACTIONS(3661),
    [anon_sym_explicit] = ACTIONS(3661),
    [anon_sym_typename] = ACTIONS(3661),
    [anon_sym_template] = ACTIONS(3661),
    [anon_sym_operator] = ACTIONS(3661),
    [anon_sym_try] = ACTIONS(3661),
    [anon_sym_delete] = ACTIONS(3661),
    [anon_sym_throw] = ACTIONS(3661),
    [anon_sym_namespace] = ACTIONS(3661),
    [anon_sym_static_assert] = ACTIONS(3661),
    [anon_sym_concept] = ACTIONS(3661),
    [anon_sym_co_return] = ACTIONS(3661),
    [anon_sym_co_yield] = ACTIONS(3661),
    [anon_sym_R_DQUOTE] = ACTIONS(3663),
    [anon_sym_LR_DQUOTE] = ACTIONS(3663),
    [anon_sym_uR_DQUOTE] = ACTIONS(3663),
    [anon_sym_UR_DQUOTE] = ACTIONS(3663),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3663),
    [anon_sym_co_await] = ACTIONS(3661),
    [anon_sym_new] = ACTIONS(3661),
    [anon_sym_requires] = ACTIONS(3661),
    [sym_this] = ACTIONS(3661),
    [anon_sym_discard] = ACTIONS(3661),
    [anon_sym_precise] = ACTIONS(3661),
    [anon_sym_shared] = ACTIONS(3661),
    [anon_sym_groupshared] = ACTIONS(3661),
    [anon_sym_uniform] = ACTIONS(3661),
    [anon_sym_row_major] = ACTIONS(3661),
    [anon_sym_column_major] = ACTIONS(3661),
    [anon_sym_globallycoherent] = ACTIONS(3661),
    [anon_sym_centroid] = ACTIONS(3661),
    [anon_sym_noperspective] = ACTIONS(3661),
    [anon_sym_nointerpolation] = ACTIONS(3661),
    [anon_sym_sample] = ACTIONS(3661),
    [anon_sym_linear] = ACTIONS(3661),
    [anon_sym_snorm] = ACTIONS(3661),
    [anon_sym_unorm] = ACTIONS(3661),
    [anon_sym_point] = ACTIONS(3661),
    [anon_sym_line] = ACTIONS(3661),
    [anon_sym_triangleadj] = ACTIONS(3661),
    [anon_sym_lineadj] = ACTIONS(3661),
    [anon_sym_triangle] = ACTIONS(3661),
    [anon_sym_cbuffer] = ACTIONS(3661),
    [anon_sym_interface] = ACTIONS(3661),
    [anon_sym_extension] = ACTIONS(3661),
  },
  [1094] = {
    [sym_identifier] = ACTIONS(3784),
    [aux_sym_preproc_include_token1] = ACTIONS(3784),
    [aux_sym_preproc_def_token1] = ACTIONS(3784),
    [aux_sym_preproc_if_token1] = ACTIONS(3784),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3784),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3784),
    [sym_preproc_directive] = ACTIONS(3784),
    [anon_sym_LPAREN2] = ACTIONS(3786),
    [anon_sym_BANG] = ACTIONS(3786),
    [anon_sym_TILDE] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3784),
    [anon_sym_PLUS] = ACTIONS(3784),
    [anon_sym_STAR] = ACTIONS(3786),
    [anon_sym_AMP_AMP] = ACTIONS(3786),
    [anon_sym_AMP] = ACTIONS(3784),
    [anon_sym_SEMI] = ACTIONS(3786),
    [anon_sym___extension__] = ACTIONS(3784),
    [anon_sym_typedef] = ACTIONS(3784),
    [anon_sym_in] = ACTIONS(3784),
    [anon_sym_out] = ACTIONS(3784),
    [anon_sym_inout] = ACTIONS(3784),
    [anon_sym_virtual] = ACTIONS(3784),
    [anon_sym_extern] = ACTIONS(3784),
    [anon_sym___attribute__] = ACTIONS(3784),
    [anon_sym___attribute] = ACTIONS(3784),
    [anon_sym_using] = ACTIONS(3784),
    [anon_sym_COLON_COLON] = ACTIONS(3786),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3786),
    [anon_sym___declspec] = ACTIONS(3784),
    [anon_sym___based] = ACTIONS(3784),
    [anon_sym___cdecl] = ACTIONS(3784),
    [anon_sym___clrcall] = ACTIONS(3784),
    [anon_sym___stdcall] = ACTIONS(3784),
    [anon_sym___fastcall] = ACTIONS(3784),
    [anon_sym___thiscall] = ACTIONS(3784),
    [anon_sym___vectorcall] = ACTIONS(3784),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_RBRACE] = ACTIONS(3786),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3784),
    [anon_sym_static] = ACTIONS(3784),
    [anon_sym_register] = ACTIONS(3784),
    [anon_sym_inline] = ACTIONS(3784),
    [anon_sym___inline] = ACTIONS(3784),
    [anon_sym___inline__] = ACTIONS(3784),
    [anon_sym___forceinline] = ACTIONS(3784),
    [anon_sym_thread_local] = ACTIONS(3784),
    [anon_sym___thread] = ACTIONS(3784),
    [anon_sym_const] = ACTIONS(3784),
    [anon_sym_constexpr] = ACTIONS(3784),
    [anon_sym_volatile] = ACTIONS(3784),
    [anon_sym_restrict] = ACTIONS(3784),
    [anon_sym___restrict__] = ACTIONS(3784),
    [anon_sym__Atomic] = ACTIONS(3784),
    [anon_sym__Noreturn] = ACTIONS(3784),
    [anon_sym_noreturn] = ACTIONS(3784),
    [anon_sym__Nonnull] = ACTIONS(3784),
    [anon_sym_mutable] = ACTIONS(3784),
    [anon_sym_constinit] = ACTIONS(3784),
    [anon_sym_consteval] = ACTIONS(3784),
    [anon_sym_alignas] = ACTIONS(3784),
    [anon_sym__Alignas] = ACTIONS(3784),
    [sym_primitive_type] = ACTIONS(3784),
    [anon_sym_enum] = ACTIONS(3784),
    [anon_sym_class] = ACTIONS(3784),
    [anon_sym_struct] = ACTIONS(3784),
    [anon_sym_union] = ACTIONS(3784),
    [anon_sym_if] = ACTIONS(3784),
    [anon_sym_switch] = ACTIONS(3784),
    [anon_sym_case] = ACTIONS(3784),
    [anon_sym_default] = ACTIONS(3784),
    [anon_sym_while] = ACTIONS(3784),
    [anon_sym_do] = ACTIONS(3784),
    [anon_sym_for] = ACTIONS(3784),
    [anon_sym_return] = ACTIONS(3784),
    [anon_sym_break] = ACTIONS(3784),
    [anon_sym_continue] = ACTIONS(3784),
    [anon_sym_goto] = ACTIONS(3784),
    [anon_sym___try] = ACTIONS(3784),
    [anon_sym___leave] = ACTIONS(3784),
    [anon_sym_not] = ACTIONS(3784),
    [anon_sym_compl] = ACTIONS(3784),
    [anon_sym_DASH_DASH] = ACTIONS(3786),
    [anon_sym_PLUS_PLUS] = ACTIONS(3786),
    [anon_sym_sizeof] = ACTIONS(3784),
    [anon_sym___alignof__] = ACTIONS(3784),
    [anon_sym___alignof] = ACTIONS(3784),
    [anon_sym__alignof] = ACTIONS(3784),
    [anon_sym_alignof] = ACTIONS(3784),
    [anon_sym__Alignof] = ACTIONS(3784),
    [anon_sym_offsetof] = ACTIONS(3784),
    [anon_sym__Generic] = ACTIONS(3784),
    [anon_sym_asm] = ACTIONS(3784),
    [anon_sym___asm__] = ACTIONS(3784),
    [anon_sym___asm] = ACTIONS(3784),
    [sym_number_literal] = ACTIONS(3786),
    [anon_sym_L_SQUOTE] = ACTIONS(3786),
    [anon_sym_u_SQUOTE] = ACTIONS(3786),
    [anon_sym_U_SQUOTE] = ACTIONS(3786),
    [anon_sym_u8_SQUOTE] = ACTIONS(3786),
    [anon_sym_SQUOTE] = ACTIONS(3786),
    [anon_sym_L_DQUOTE] = ACTIONS(3786),
    [anon_sym_u_DQUOTE] = ACTIONS(3786),
    [anon_sym_U_DQUOTE] = ACTIONS(3786),
    [anon_sym_u8_DQUOTE] = ACTIONS(3786),
    [anon_sym_DQUOTE] = ACTIONS(3786),
    [sym_true] = ACTIONS(3784),
    [sym_false] = ACTIONS(3784),
    [anon_sym_NULL] = ACTIONS(3784),
    [anon_sym_nullptr] = ACTIONS(3784),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3784),
    [anon_sym_let] = ACTIONS(3784),
    [anon_sym_This] = ACTIONS(3784),
    [anon_sym_decltype] = ACTIONS(3784),
    [anon_sym_explicit] = ACTIONS(3784),
    [anon_sym_typename] = ACTIONS(3784),
    [anon_sym_template] = ACTIONS(3784),
    [anon_sym_operator] = ACTIONS(3784),
    [anon_sym_try] = ACTIONS(3784),
    [anon_sym_delete] = ACTIONS(3784),
    [anon_sym_throw] = ACTIONS(3784),
    [anon_sym_namespace] = ACTIONS(3784),
    [anon_sym_static_assert] = ACTIONS(3784),
    [anon_sym_concept] = ACTIONS(3784),
    [anon_sym_co_return] = ACTIONS(3784),
    [anon_sym_co_yield] = ACTIONS(3784),
    [anon_sym_R_DQUOTE] = ACTIONS(3786),
    [anon_sym_LR_DQUOTE] = ACTIONS(3786),
    [anon_sym_uR_DQUOTE] = ACTIONS(3786),
    [anon_sym_UR_DQUOTE] = ACTIONS(3786),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3786),
    [anon_sym_co_await] = ACTIONS(3784),
    [anon_sym_new] = ACTIONS(3784),
    [anon_sym_requires] = ACTIONS(3784),
    [sym_this] = ACTIONS(3784),
    [anon_sym_discard] = ACTIONS(3784),
    [anon_sym_precise] = ACTIONS(3784),
    [anon_sym_shared] = ACTIONS(3784),
    [anon_sym_groupshared] = ACTIONS(3784),
    [anon_sym_uniform] = ACTIONS(3784),
    [anon_sym_row_major] = ACTIONS(3784),
    [anon_sym_column_major] = ACTIONS(3784),
    [anon_sym_globallycoherent] = ACTIONS(3784),
    [anon_sym_centroid] = ACTIONS(3784),
    [anon_sym_noperspective] = ACTIONS(3784),
    [anon_sym_nointerpolation] = ACTIONS(3784),
    [anon_sym_sample] = ACTIONS(3784),
    [anon_sym_linear] = ACTIONS(3784),
    [anon_sym_snorm] = ACTIONS(3784),
    [anon_sym_unorm] = ACTIONS(3784),
    [anon_sym_point] = ACTIONS(3784),
    [anon_sym_line] = ACTIONS(3784),
    [anon_sym_triangleadj] = ACTIONS(3784),
    [anon_sym_lineadj] = ACTIONS(3784),
    [anon_sym_triangle] = ACTIONS(3784),
    [anon_sym_cbuffer] = ACTIONS(3784),
    [anon_sym_interface] = ACTIONS(3784),
    [anon_sym_extension] = ACTIONS(3784),
  },
  [1095] = {
    [sym_identifier] = ACTIONS(3828),
    [aux_sym_preproc_include_token1] = ACTIONS(3828),
    [aux_sym_preproc_def_token1] = ACTIONS(3828),
    [aux_sym_preproc_if_token1] = ACTIONS(3828),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3828),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3828),
    [sym_preproc_directive] = ACTIONS(3828),
    [anon_sym_LPAREN2] = ACTIONS(3830),
    [anon_sym_BANG] = ACTIONS(3830),
    [anon_sym_TILDE] = ACTIONS(3830),
    [anon_sym_DASH] = ACTIONS(3828),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_SEMI] = ACTIONS(3830),
    [anon_sym___extension__] = ACTIONS(3828),
    [anon_sym_typedef] = ACTIONS(3828),
    [anon_sym_in] = ACTIONS(3828),
    [anon_sym_out] = ACTIONS(3828),
    [anon_sym_inout] = ACTIONS(3828),
    [anon_sym_virtual] = ACTIONS(3828),
    [anon_sym_extern] = ACTIONS(3828),
    [anon_sym___attribute__] = ACTIONS(3828),
    [anon_sym___attribute] = ACTIONS(3828),
    [anon_sym_using] = ACTIONS(3828),
    [anon_sym_COLON_COLON] = ACTIONS(3830),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3830),
    [anon_sym___declspec] = ACTIONS(3828),
    [anon_sym___based] = ACTIONS(3828),
    [anon_sym___cdecl] = ACTIONS(3828),
    [anon_sym___clrcall] = ACTIONS(3828),
    [anon_sym___stdcall] = ACTIONS(3828),
    [anon_sym___fastcall] = ACTIONS(3828),
    [anon_sym___thiscall] = ACTIONS(3828),
    [anon_sym___vectorcall] = ACTIONS(3828),
    [anon_sym_LBRACE] = ACTIONS(3830),
    [anon_sym_RBRACE] = ACTIONS(3830),
    [anon_sym_signed] = ACTIONS(3828),
    [anon_sym_unsigned] = ACTIONS(3828),
    [anon_sym_long] = ACTIONS(3828),
    [anon_sym_short] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_static] = ACTIONS(3828),
    [anon_sym_register] = ACTIONS(3828),
    [anon_sym_inline] = ACTIONS(3828),
    [anon_sym___inline] = ACTIONS(3828),
    [anon_sym___inline__] = ACTIONS(3828),
    [anon_sym___forceinline] = ACTIONS(3828),
    [anon_sym_thread_local] = ACTIONS(3828),
    [anon_sym___thread] = ACTIONS(3828),
    [anon_sym_const] = ACTIONS(3828),
    [anon_sym_constexpr] = ACTIONS(3828),
    [anon_sym_volatile] = ACTIONS(3828),
    [anon_sym_restrict] = ACTIONS(3828),
    [anon_sym___restrict__] = ACTIONS(3828),
    [anon_sym__Atomic] = ACTIONS(3828),
    [anon_sym__Noreturn] = ACTIONS(3828),
    [anon_sym_noreturn] = ACTIONS(3828),
    [anon_sym__Nonnull] = ACTIONS(3828),
    [anon_sym_mutable] = ACTIONS(3828),
    [anon_sym_constinit] = ACTIONS(3828),
    [anon_sym_consteval] = ACTIONS(3828),
    [anon_sym_alignas] = ACTIONS(3828),
    [anon_sym__Alignas] = ACTIONS(3828),
    [sym_primitive_type] = ACTIONS(3828),
    [anon_sym_enum] = ACTIONS(3828),
    [anon_sym_class] = ACTIONS(3828),
    [anon_sym_struct] = ACTIONS(3828),
    [anon_sym_union] = ACTIONS(3828),
    [anon_sym_if] = ACTIONS(3828),
    [anon_sym_switch] = ACTIONS(3828),
    [anon_sym_case] = ACTIONS(3828),
    [anon_sym_default] = ACTIONS(3828),
    [anon_sym_while] = ACTIONS(3828),
    [anon_sym_do] = ACTIONS(3828),
    [anon_sym_for] = ACTIONS(3828),
    [anon_sym_return] = ACTIONS(3828),
    [anon_sym_break] = ACTIONS(3828),
    [anon_sym_continue] = ACTIONS(3828),
    [anon_sym_goto] = ACTIONS(3828),
    [anon_sym___try] = ACTIONS(3828),
    [anon_sym___leave] = ACTIONS(3828),
    [anon_sym_not] = ACTIONS(3828),
    [anon_sym_compl] = ACTIONS(3828),
    [anon_sym_DASH_DASH] = ACTIONS(3830),
    [anon_sym_PLUS_PLUS] = ACTIONS(3830),
    [anon_sym_sizeof] = ACTIONS(3828),
    [anon_sym___alignof__] = ACTIONS(3828),
    [anon_sym___alignof] = ACTIONS(3828),
    [anon_sym__alignof] = ACTIONS(3828),
    [anon_sym_alignof] = ACTIONS(3828),
    [anon_sym__Alignof] = ACTIONS(3828),
    [anon_sym_offsetof] = ACTIONS(3828),
    [anon_sym__Generic] = ACTIONS(3828),
    [anon_sym_asm] = ACTIONS(3828),
    [anon_sym___asm__] = ACTIONS(3828),
    [anon_sym___asm] = ACTIONS(3828),
    [sym_number_literal] = ACTIONS(3830),
    [anon_sym_L_SQUOTE] = ACTIONS(3830),
    [anon_sym_u_SQUOTE] = ACTIONS(3830),
    [anon_sym_U_SQUOTE] = ACTIONS(3830),
    [anon_sym_u8_SQUOTE] = ACTIONS(3830),
    [anon_sym_SQUOTE] = ACTIONS(3830),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3828),
    [sym_false] = ACTIONS(3828),
    [anon_sym_NULL] = ACTIONS(3828),
    [anon_sym_nullptr] = ACTIONS(3828),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_This] = ACTIONS(3828),
    [anon_sym_decltype] = ACTIONS(3828),
    [anon_sym_explicit] = ACTIONS(3828),
    [anon_sym_typename] = ACTIONS(3828),
    [anon_sym_template] = ACTIONS(3828),
    [anon_sym_operator] = ACTIONS(3828),
    [anon_sym_try] = ACTIONS(3828),
    [anon_sym_delete] = ACTIONS(3828),
    [anon_sym_throw] = ACTIONS(3828),
    [anon_sym_namespace] = ACTIONS(3828),
    [anon_sym_static_assert] = ACTIONS(3828),
    [anon_sym_concept] = ACTIONS(3828),
    [anon_sym_co_return] = ACTIONS(3828),
    [anon_sym_co_yield] = ACTIONS(3828),
    [anon_sym_R_DQUOTE] = ACTIONS(3830),
    [anon_sym_LR_DQUOTE] = ACTIONS(3830),
    [anon_sym_uR_DQUOTE] = ACTIONS(3830),
    [anon_sym_UR_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3830),
    [anon_sym_co_await] = ACTIONS(3828),
    [anon_sym_new] = ACTIONS(3828),
    [anon_sym_requires] = ACTIONS(3828),
    [sym_this] = ACTIONS(3828),
    [anon_sym_discard] = ACTIONS(3828),
    [anon_sym_precise] = ACTIONS(3828),
    [anon_sym_shared] = ACTIONS(3828),
    [anon_sym_groupshared] = ACTIONS(3828),
    [anon_sym_uniform] = ACTIONS(3828),
    [anon_sym_row_major] = ACTIONS(3828),
    [anon_sym_column_major] = ACTIONS(3828),
    [anon_sym_globallycoherent] = ACTIONS(3828),
    [anon_sym_centroid] = ACTIONS(3828),
    [anon_sym_noperspective] = ACTIONS(3828),
    [anon_sym_nointerpolation] = ACTIONS(3828),
    [anon_sym_sample] = ACTIONS(3828),
    [anon_sym_linear] = ACTIONS(3828),
    [anon_sym_snorm] = ACTIONS(3828),
    [anon_sym_unorm] = ACTIONS(3828),
    [anon_sym_point] = ACTIONS(3828),
    [anon_sym_line] = ACTIONS(3828),
    [anon_sym_triangleadj] = ACTIONS(3828),
    [anon_sym_lineadj] = ACTIONS(3828),
    [anon_sym_triangle] = ACTIONS(3828),
    [anon_sym_cbuffer] = ACTIONS(3828),
    [anon_sym_interface] = ACTIONS(3828),
    [anon_sym_extension] = ACTIONS(3828),
  },
  [1096] = {
    [sym_identifier] = ACTIONS(3919),
    [aux_sym_preproc_include_token1] = ACTIONS(3919),
    [aux_sym_preproc_def_token1] = ACTIONS(3919),
    [aux_sym_preproc_if_token1] = ACTIONS(3919),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3919),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3919),
    [sym_preproc_directive] = ACTIONS(3919),
    [anon_sym_LPAREN2] = ACTIONS(3921),
    [anon_sym_BANG] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_DASH] = ACTIONS(3919),
    [anon_sym_PLUS] = ACTIONS(3919),
    [anon_sym_STAR] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_AMP] = ACTIONS(3919),
    [anon_sym_SEMI] = ACTIONS(3921),
    [anon_sym___extension__] = ACTIONS(3919),
    [anon_sym_typedef] = ACTIONS(3919),
    [anon_sym_in] = ACTIONS(3919),
    [anon_sym_out] = ACTIONS(3919),
    [anon_sym_inout] = ACTIONS(3919),
    [anon_sym_virtual] = ACTIONS(3919),
    [anon_sym_extern] = ACTIONS(3919),
    [anon_sym___attribute__] = ACTIONS(3919),
    [anon_sym___attribute] = ACTIONS(3919),
    [anon_sym_using] = ACTIONS(3919),
    [anon_sym_COLON_COLON] = ACTIONS(3921),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3921),
    [anon_sym___declspec] = ACTIONS(3919),
    [anon_sym___based] = ACTIONS(3919),
    [anon_sym___cdecl] = ACTIONS(3919),
    [anon_sym___clrcall] = ACTIONS(3919),
    [anon_sym___stdcall] = ACTIONS(3919),
    [anon_sym___fastcall] = ACTIONS(3919),
    [anon_sym___thiscall] = ACTIONS(3919),
    [anon_sym___vectorcall] = ACTIONS(3919),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_RBRACE] = ACTIONS(3921),
    [anon_sym_signed] = ACTIONS(3919),
    [anon_sym_unsigned] = ACTIONS(3919),
    [anon_sym_long] = ACTIONS(3919),
    [anon_sym_short] = ACTIONS(3919),
    [anon_sym_LBRACK] = ACTIONS(3919),
    [anon_sym_static] = ACTIONS(3919),
    [anon_sym_register] = ACTIONS(3919),
    [anon_sym_inline] = ACTIONS(3919),
    [anon_sym___inline] = ACTIONS(3919),
    [anon_sym___inline__] = ACTIONS(3919),
    [anon_sym___forceinline] = ACTIONS(3919),
    [anon_sym_thread_local] = ACTIONS(3919),
    [anon_sym___thread] = ACTIONS(3919),
    [anon_sym_const] = ACTIONS(3919),
    [anon_sym_constexpr] = ACTIONS(3919),
    [anon_sym_volatile] = ACTIONS(3919),
    [anon_sym_restrict] = ACTIONS(3919),
    [anon_sym___restrict__] = ACTIONS(3919),
    [anon_sym__Atomic] = ACTIONS(3919),
    [anon_sym__Noreturn] = ACTIONS(3919),
    [anon_sym_noreturn] = ACTIONS(3919),
    [anon_sym__Nonnull] = ACTIONS(3919),
    [anon_sym_mutable] = ACTIONS(3919),
    [anon_sym_constinit] = ACTIONS(3919),
    [anon_sym_consteval] = ACTIONS(3919),
    [anon_sym_alignas] = ACTIONS(3919),
    [anon_sym__Alignas] = ACTIONS(3919),
    [sym_primitive_type] = ACTIONS(3919),
    [anon_sym_enum] = ACTIONS(3919),
    [anon_sym_class] = ACTIONS(3919),
    [anon_sym_struct] = ACTIONS(3919),
    [anon_sym_union] = ACTIONS(3919),
    [anon_sym_if] = ACTIONS(3919),
    [anon_sym_switch] = ACTIONS(3919),
    [anon_sym_case] = ACTIONS(3919),
    [anon_sym_default] = ACTIONS(3919),
    [anon_sym_while] = ACTIONS(3919),
    [anon_sym_do] = ACTIONS(3919),
    [anon_sym_for] = ACTIONS(3919),
    [anon_sym_return] = ACTIONS(3919),
    [anon_sym_break] = ACTIONS(3919),
    [anon_sym_continue] = ACTIONS(3919),
    [anon_sym_goto] = ACTIONS(3919),
    [anon_sym___try] = ACTIONS(3919),
    [anon_sym___leave] = ACTIONS(3919),
    [anon_sym_not] = ACTIONS(3919),
    [anon_sym_compl] = ACTIONS(3919),
    [anon_sym_DASH_DASH] = ACTIONS(3921),
    [anon_sym_PLUS_PLUS] = ACTIONS(3921),
    [anon_sym_sizeof] = ACTIONS(3919),
    [anon_sym___alignof__] = ACTIONS(3919),
    [anon_sym___alignof] = ACTIONS(3919),
    [anon_sym__alignof] = ACTIONS(3919),
    [anon_sym_alignof] = ACTIONS(3919),
    [anon_sym__Alignof] = ACTIONS(3919),
    [anon_sym_offsetof] = ACTIONS(3919),
    [anon_sym__Generic] = ACTIONS(3919),
    [anon_sym_asm] = ACTIONS(3919),
    [anon_sym___asm__] = ACTIONS(3919),
    [anon_sym___asm] = ACTIONS(3919),
    [sym_number_literal] = ACTIONS(3921),
    [anon_sym_L_SQUOTE] = ACTIONS(3921),
    [anon_sym_u_SQUOTE] = ACTIONS(3921),
    [anon_sym_U_SQUOTE] = ACTIONS(3921),
    [anon_sym_u8_SQUOTE] = ACTIONS(3921),
    [anon_sym_SQUOTE] = ACTIONS(3921),
    [anon_sym_L_DQUOTE] = ACTIONS(3921),
    [anon_sym_u_DQUOTE] = ACTIONS(3921),
    [anon_sym_U_DQUOTE] = ACTIONS(3921),
    [anon_sym_u8_DQUOTE] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(3921),
    [sym_true] = ACTIONS(3919),
    [sym_false] = ACTIONS(3919),
    [anon_sym_NULL] = ACTIONS(3919),
    [anon_sym_nullptr] = ACTIONS(3919),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3919),
    [anon_sym_let] = ACTIONS(3919),
    [anon_sym_This] = ACTIONS(3919),
    [anon_sym_decltype] = ACTIONS(3919),
    [anon_sym_explicit] = ACTIONS(3919),
    [anon_sym_typename] = ACTIONS(3919),
    [anon_sym_template] = ACTIONS(3919),
    [anon_sym_operator] = ACTIONS(3919),
    [anon_sym_try] = ACTIONS(3919),
    [anon_sym_delete] = ACTIONS(3919),
    [anon_sym_throw] = ACTIONS(3919),
    [anon_sym_namespace] = ACTIONS(3919),
    [anon_sym_static_assert] = ACTIONS(3919),
    [anon_sym_concept] = ACTIONS(3919),
    [anon_sym_co_return] = ACTIONS(3919),
    [anon_sym_co_yield] = ACTIONS(3919),
    [anon_sym_R_DQUOTE] = ACTIONS(3921),
    [anon_sym_LR_DQUOTE] = ACTIONS(3921),
    [anon_sym_uR_DQUOTE] = ACTIONS(3921),
    [anon_sym_UR_DQUOTE] = ACTIONS(3921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3921),
    [anon_sym_co_await] = ACTIONS(3919),
    [anon_sym_new] = ACTIONS(3919),
    [anon_sym_requires] = ACTIONS(3919),
    [sym_this] = ACTIONS(3919),
    [anon_sym_discard] = ACTIONS(3919),
    [anon_sym_precise] = ACTIONS(3919),
    [anon_sym_shared] = ACTIONS(3919),
    [anon_sym_groupshared] = ACTIONS(3919),
    [anon_sym_uniform] = ACTIONS(3919),
    [anon_sym_row_major] = ACTIONS(3919),
    [anon_sym_column_major] = ACTIONS(3919),
    [anon_sym_globallycoherent] = ACTIONS(3919),
    [anon_sym_centroid] = ACTIONS(3919),
    [anon_sym_noperspective] = ACTIONS(3919),
    [anon_sym_nointerpolation] = ACTIONS(3919),
    [anon_sym_sample] = ACTIONS(3919),
    [anon_sym_linear] = ACTIONS(3919),
    [anon_sym_snorm] = ACTIONS(3919),
    [anon_sym_unorm] = ACTIONS(3919),
    [anon_sym_point] = ACTIONS(3919),
    [anon_sym_line] = ACTIONS(3919),
    [anon_sym_triangleadj] = ACTIONS(3919),
    [anon_sym_lineadj] = ACTIONS(3919),
    [anon_sym_triangle] = ACTIONS(3919),
    [anon_sym_cbuffer] = ACTIONS(3919),
    [anon_sym_interface] = ACTIONS(3919),
    [anon_sym_extension] = ACTIONS(3919),
  },
  [1097] = {
    [sym_identifier] = ACTIONS(3949),
    [aux_sym_preproc_include_token1] = ACTIONS(3949),
    [aux_sym_preproc_def_token1] = ACTIONS(3949),
    [aux_sym_preproc_if_token1] = ACTIONS(3949),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3949),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3949),
    [sym_preproc_directive] = ACTIONS(3949),
    [anon_sym_LPAREN2] = ACTIONS(3951),
    [anon_sym_BANG] = ACTIONS(3951),
    [anon_sym_TILDE] = ACTIONS(3951),
    [anon_sym_DASH] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3949),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3949),
    [anon_sym_SEMI] = ACTIONS(3951),
    [anon_sym___extension__] = ACTIONS(3949),
    [anon_sym_typedef] = ACTIONS(3949),
    [anon_sym_in] = ACTIONS(3949),
    [anon_sym_out] = ACTIONS(3949),
    [anon_sym_inout] = ACTIONS(3949),
    [anon_sym_virtual] = ACTIONS(3949),
    [anon_sym_extern] = ACTIONS(3949),
    [anon_sym___attribute__] = ACTIONS(3949),
    [anon_sym___attribute] = ACTIONS(3949),
    [anon_sym_using] = ACTIONS(3949),
    [anon_sym_COLON_COLON] = ACTIONS(3951),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3951),
    [anon_sym___declspec] = ACTIONS(3949),
    [anon_sym___based] = ACTIONS(3949),
    [anon_sym___cdecl] = ACTIONS(3949),
    [anon_sym___clrcall] = ACTIONS(3949),
    [anon_sym___stdcall] = ACTIONS(3949),
    [anon_sym___fastcall] = ACTIONS(3949),
    [anon_sym___thiscall] = ACTIONS(3949),
    [anon_sym___vectorcall] = ACTIONS(3949),
    [anon_sym_LBRACE] = ACTIONS(3951),
    [anon_sym_RBRACE] = ACTIONS(3951),
    [anon_sym_signed] = ACTIONS(3949),
    [anon_sym_unsigned] = ACTIONS(3949),
    [anon_sym_long] = ACTIONS(3949),
    [anon_sym_short] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_static] = ACTIONS(3949),
    [anon_sym_register] = ACTIONS(3949),
    [anon_sym_inline] = ACTIONS(3949),
    [anon_sym___inline] = ACTIONS(3949),
    [anon_sym___inline__] = ACTIONS(3949),
    [anon_sym___forceinline] = ACTIONS(3949),
    [anon_sym_thread_local] = ACTIONS(3949),
    [anon_sym___thread] = ACTIONS(3949),
    [anon_sym_const] = ACTIONS(3949),
    [anon_sym_constexpr] = ACTIONS(3949),
    [anon_sym_volatile] = ACTIONS(3949),
    [anon_sym_restrict] = ACTIONS(3949),
    [anon_sym___restrict__] = ACTIONS(3949),
    [anon_sym__Atomic] = ACTIONS(3949),
    [anon_sym__Noreturn] = ACTIONS(3949),
    [anon_sym_noreturn] = ACTIONS(3949),
    [anon_sym__Nonnull] = ACTIONS(3949),
    [anon_sym_mutable] = ACTIONS(3949),
    [anon_sym_constinit] = ACTIONS(3949),
    [anon_sym_consteval] = ACTIONS(3949),
    [anon_sym_alignas] = ACTIONS(3949),
    [anon_sym__Alignas] = ACTIONS(3949),
    [sym_primitive_type] = ACTIONS(3949),
    [anon_sym_enum] = ACTIONS(3949),
    [anon_sym_class] = ACTIONS(3949),
    [anon_sym_struct] = ACTIONS(3949),
    [anon_sym_union] = ACTIONS(3949),
    [anon_sym_if] = ACTIONS(3949),
    [anon_sym_switch] = ACTIONS(3949),
    [anon_sym_case] = ACTIONS(3949),
    [anon_sym_default] = ACTIONS(3949),
    [anon_sym_while] = ACTIONS(3949),
    [anon_sym_do] = ACTIONS(3949),
    [anon_sym_for] = ACTIONS(3949),
    [anon_sym_return] = ACTIONS(3949),
    [anon_sym_break] = ACTIONS(3949),
    [anon_sym_continue] = ACTIONS(3949),
    [anon_sym_goto] = ACTIONS(3949),
    [anon_sym___try] = ACTIONS(3949),
    [anon_sym___leave] = ACTIONS(3949),
    [anon_sym_not] = ACTIONS(3949),
    [anon_sym_compl] = ACTIONS(3949),
    [anon_sym_DASH_DASH] = ACTIONS(3951),
    [anon_sym_PLUS_PLUS] = ACTIONS(3951),
    [anon_sym_sizeof] = ACTIONS(3949),
    [anon_sym___alignof__] = ACTIONS(3949),
    [anon_sym___alignof] = ACTIONS(3949),
    [anon_sym__alignof] = ACTIONS(3949),
    [anon_sym_alignof] = ACTIONS(3949),
    [anon_sym__Alignof] = ACTIONS(3949),
    [anon_sym_offsetof] = ACTIONS(3949),
    [anon_sym__Generic] = ACTIONS(3949),
    [anon_sym_asm] = ACTIONS(3949),
    [anon_sym___asm__] = ACTIONS(3949),
    [anon_sym___asm] = ACTIONS(3949),
    [sym_number_literal] = ACTIONS(3951),
    [anon_sym_L_SQUOTE] = ACTIONS(3951),
    [anon_sym_u_SQUOTE] = ACTIONS(3951),
    [anon_sym_U_SQUOTE] = ACTIONS(3951),
    [anon_sym_u8_SQUOTE] = ACTIONS(3951),
    [anon_sym_SQUOTE] = ACTIONS(3951),
    [anon_sym_L_DQUOTE] = ACTIONS(3951),
    [anon_sym_u_DQUOTE] = ACTIONS(3951),
    [anon_sym_U_DQUOTE] = ACTIONS(3951),
    [anon_sym_u8_DQUOTE] = ACTIONS(3951),
    [anon_sym_DQUOTE] = ACTIONS(3951),
    [sym_true] = ACTIONS(3949),
    [sym_false] = ACTIONS(3949),
    [anon_sym_NULL] = ACTIONS(3949),
    [anon_sym_nullptr] = ACTIONS(3949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_This] = ACTIONS(3949),
    [anon_sym_decltype] = ACTIONS(3949),
    [anon_sym_explicit] = ACTIONS(3949),
    [anon_sym_typename] = ACTIONS(3949),
    [anon_sym_template] = ACTIONS(3949),
    [anon_sym_operator] = ACTIONS(3949),
    [anon_sym_try] = ACTIONS(3949),
    [anon_sym_delete] = ACTIONS(3949),
    [anon_sym_throw] = ACTIONS(3949),
    [anon_sym_namespace] = ACTIONS(3949),
    [anon_sym_static_assert] = ACTIONS(3949),
    [anon_sym_concept] = ACTIONS(3949),
    [anon_sym_co_return] = ACTIONS(3949),
    [anon_sym_co_yield] = ACTIONS(3949),
    [anon_sym_R_DQUOTE] = ACTIONS(3951),
    [anon_sym_LR_DQUOTE] = ACTIONS(3951),
    [anon_sym_uR_DQUOTE] = ACTIONS(3951),
    [anon_sym_UR_DQUOTE] = ACTIONS(3951),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3951),
    [anon_sym_co_await] = ACTIONS(3949),
    [anon_sym_new] = ACTIONS(3949),
    [anon_sym_requires] = ACTIONS(3949),
    [sym_this] = ACTIONS(3949),
    [anon_sym_discard] = ACTIONS(3949),
    [anon_sym_precise] = ACTIONS(3949),
    [anon_sym_shared] = ACTIONS(3949),
    [anon_sym_groupshared] = ACTIONS(3949),
    [anon_sym_uniform] = ACTIONS(3949),
    [anon_sym_row_major] = ACTIONS(3949),
    [anon_sym_column_major] = ACTIONS(3949),
    [anon_sym_globallycoherent] = ACTIONS(3949),
    [anon_sym_centroid] = ACTIONS(3949),
    [anon_sym_noperspective] = ACTIONS(3949),
    [anon_sym_nointerpolation] = ACTIONS(3949),
    [anon_sym_sample] = ACTIONS(3949),
    [anon_sym_linear] = ACTIONS(3949),
    [anon_sym_snorm] = ACTIONS(3949),
    [anon_sym_unorm] = ACTIONS(3949),
    [anon_sym_point] = ACTIONS(3949),
    [anon_sym_line] = ACTIONS(3949),
    [anon_sym_triangleadj] = ACTIONS(3949),
    [anon_sym_lineadj] = ACTIONS(3949),
    [anon_sym_triangle] = ACTIONS(3949),
    [anon_sym_cbuffer] = ACTIONS(3949),
    [anon_sym_interface] = ACTIONS(3949),
    [anon_sym_extension] = ACTIONS(3949),
  },
  [1098] = {
    [sym_identifier] = ACTIONS(3751),
    [aux_sym_preproc_include_token1] = ACTIONS(3751),
    [aux_sym_preproc_def_token1] = ACTIONS(3751),
    [aux_sym_preproc_if_token1] = ACTIONS(3751),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3751),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3751),
    [sym_preproc_directive] = ACTIONS(3751),
    [anon_sym_LPAREN2] = ACTIONS(3753),
    [anon_sym_BANG] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3751),
    [anon_sym_PLUS] = ACTIONS(3751),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_AMP] = ACTIONS(3751),
    [anon_sym_SEMI] = ACTIONS(3753),
    [anon_sym___extension__] = ACTIONS(3751),
    [anon_sym_typedef] = ACTIONS(3751),
    [anon_sym_in] = ACTIONS(3751),
    [anon_sym_out] = ACTIONS(3751),
    [anon_sym_inout] = ACTIONS(3751),
    [anon_sym_virtual] = ACTIONS(3751),
    [anon_sym_extern] = ACTIONS(3751),
    [anon_sym___attribute__] = ACTIONS(3751),
    [anon_sym___attribute] = ACTIONS(3751),
    [anon_sym_using] = ACTIONS(3751),
    [anon_sym_COLON_COLON] = ACTIONS(3753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3753),
    [anon_sym___declspec] = ACTIONS(3751),
    [anon_sym___based] = ACTIONS(3751),
    [anon_sym___cdecl] = ACTIONS(3751),
    [anon_sym___clrcall] = ACTIONS(3751),
    [anon_sym___stdcall] = ACTIONS(3751),
    [anon_sym___fastcall] = ACTIONS(3751),
    [anon_sym___thiscall] = ACTIONS(3751),
    [anon_sym___vectorcall] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_RBRACE] = ACTIONS(3753),
    [anon_sym_signed] = ACTIONS(3751),
    [anon_sym_unsigned] = ACTIONS(3751),
    [anon_sym_long] = ACTIONS(3751),
    [anon_sym_short] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3751),
    [anon_sym_static] = ACTIONS(3751),
    [anon_sym_register] = ACTIONS(3751),
    [anon_sym_inline] = ACTIONS(3751),
    [anon_sym___inline] = ACTIONS(3751),
    [anon_sym___inline__] = ACTIONS(3751),
    [anon_sym___forceinline] = ACTIONS(3751),
    [anon_sym_thread_local] = ACTIONS(3751),
    [anon_sym___thread] = ACTIONS(3751),
    [anon_sym_const] = ACTIONS(3751),
    [anon_sym_constexpr] = ACTIONS(3751),
    [anon_sym_volatile] = ACTIONS(3751),
    [anon_sym_restrict] = ACTIONS(3751),
    [anon_sym___restrict__] = ACTIONS(3751),
    [anon_sym__Atomic] = ACTIONS(3751),
    [anon_sym__Noreturn] = ACTIONS(3751),
    [anon_sym_noreturn] = ACTIONS(3751),
    [anon_sym__Nonnull] = ACTIONS(3751),
    [anon_sym_mutable] = ACTIONS(3751),
    [anon_sym_constinit] = ACTIONS(3751),
    [anon_sym_consteval] = ACTIONS(3751),
    [anon_sym_alignas] = ACTIONS(3751),
    [anon_sym__Alignas] = ACTIONS(3751),
    [sym_primitive_type] = ACTIONS(3751),
    [anon_sym_enum] = ACTIONS(3751),
    [anon_sym_class] = ACTIONS(3751),
    [anon_sym_struct] = ACTIONS(3751),
    [anon_sym_union] = ACTIONS(3751),
    [anon_sym_if] = ACTIONS(3751),
    [anon_sym_switch] = ACTIONS(3751),
    [anon_sym_case] = ACTIONS(3751),
    [anon_sym_default] = ACTIONS(3751),
    [anon_sym_while] = ACTIONS(3751),
    [anon_sym_do] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3751),
    [anon_sym_return] = ACTIONS(3751),
    [anon_sym_break] = ACTIONS(3751),
    [anon_sym_continue] = ACTIONS(3751),
    [anon_sym_goto] = ACTIONS(3751),
    [anon_sym___try] = ACTIONS(3751),
    [anon_sym___leave] = ACTIONS(3751),
    [anon_sym_not] = ACTIONS(3751),
    [anon_sym_compl] = ACTIONS(3751),
    [anon_sym_DASH_DASH] = ACTIONS(3753),
    [anon_sym_PLUS_PLUS] = ACTIONS(3753),
    [anon_sym_sizeof] = ACTIONS(3751),
    [anon_sym___alignof__] = ACTIONS(3751),
    [anon_sym___alignof] = ACTIONS(3751),
    [anon_sym__alignof] = ACTIONS(3751),
    [anon_sym_alignof] = ACTIONS(3751),
    [anon_sym__Alignof] = ACTIONS(3751),
    [anon_sym_offsetof] = ACTIONS(3751),
    [anon_sym__Generic] = ACTIONS(3751),
    [anon_sym_asm] = ACTIONS(3751),
    [anon_sym___asm__] = ACTIONS(3751),
    [anon_sym___asm] = ACTIONS(3751),
    [sym_number_literal] = ACTIONS(3753),
    [anon_sym_L_SQUOTE] = ACTIONS(3753),
    [anon_sym_u_SQUOTE] = ACTIONS(3753),
    [anon_sym_U_SQUOTE] = ACTIONS(3753),
    [anon_sym_u8_SQUOTE] = ACTIONS(3753),
    [anon_sym_SQUOTE] = ACTIONS(3753),
    [anon_sym_L_DQUOTE] = ACTIONS(3753),
    [anon_sym_u_DQUOTE] = ACTIONS(3753),
    [anon_sym_U_DQUOTE] = ACTIONS(3753),
    [anon_sym_u8_DQUOTE] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [sym_true] = ACTIONS(3751),
    [sym_false] = ACTIONS(3751),
    [anon_sym_NULL] = ACTIONS(3751),
    [anon_sym_nullptr] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3751),
    [anon_sym_let] = ACTIONS(3751),
    [anon_sym_This] = ACTIONS(3751),
    [anon_sym_decltype] = ACTIONS(3751),
    [anon_sym_explicit] = ACTIONS(3751),
    [anon_sym_typename] = ACTIONS(3751),
    [anon_sym_template] = ACTIONS(3751),
    [anon_sym_operator] = ACTIONS(3751),
    [anon_sym_try] = ACTIONS(3751),
    [anon_sym_delete] = ACTIONS(3751),
    [anon_sym_throw] = ACTIONS(3751),
    [anon_sym_namespace] = ACTIONS(3751),
    [anon_sym_static_assert] = ACTIONS(3751),
    [anon_sym_concept] = ACTIONS(3751),
    [anon_sym_co_return] = ACTIONS(3751),
    [anon_sym_co_yield] = ACTIONS(3751),
    [anon_sym_R_DQUOTE] = ACTIONS(3753),
    [anon_sym_LR_DQUOTE] = ACTIONS(3753),
    [anon_sym_uR_DQUOTE] = ACTIONS(3753),
    [anon_sym_UR_DQUOTE] = ACTIONS(3753),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3753),
    [anon_sym_co_await] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3751),
    [anon_sym_requires] = ACTIONS(3751),
    [sym_this] = ACTIONS(3751),
    [anon_sym_discard] = ACTIONS(3751),
    [anon_sym_precise] = ACTIONS(3751),
    [anon_sym_shared] = ACTIONS(3751),
    [anon_sym_groupshared] = ACTIONS(3751),
    [anon_sym_uniform] = ACTIONS(3751),
    [anon_sym_row_major] = ACTIONS(3751),
    [anon_sym_column_major] = ACTIONS(3751),
    [anon_sym_globallycoherent] = ACTIONS(3751),
    [anon_sym_centroid] = ACTIONS(3751),
    [anon_sym_noperspective] = ACTIONS(3751),
    [anon_sym_nointerpolation] = ACTIONS(3751),
    [anon_sym_sample] = ACTIONS(3751),
    [anon_sym_linear] = ACTIONS(3751),
    [anon_sym_snorm] = ACTIONS(3751),
    [anon_sym_unorm] = ACTIONS(3751),
    [anon_sym_point] = ACTIONS(3751),
    [anon_sym_line] = ACTIONS(3751),
    [anon_sym_triangleadj] = ACTIONS(3751),
    [anon_sym_lineadj] = ACTIONS(3751),
    [anon_sym_triangle] = ACTIONS(3751),
    [anon_sym_cbuffer] = ACTIONS(3751),
    [anon_sym_interface] = ACTIONS(3751),
    [anon_sym_extension] = ACTIONS(3751),
  },
  [1099] = {
    [sym_identifier] = ACTIONS(3743),
    [aux_sym_preproc_include_token1] = ACTIONS(3743),
    [aux_sym_preproc_def_token1] = ACTIONS(3743),
    [aux_sym_preproc_if_token1] = ACTIONS(3743),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3743),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3743),
    [sym_preproc_directive] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3745),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_STAR] = ACTIONS(3745),
    [anon_sym_AMP_AMP] = ACTIONS(3745),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_SEMI] = ACTIONS(3745),
    [anon_sym___extension__] = ACTIONS(3743),
    [anon_sym_typedef] = ACTIONS(3743),
    [anon_sym_in] = ACTIONS(3743),
    [anon_sym_out] = ACTIONS(3743),
    [anon_sym_inout] = ACTIONS(3743),
    [anon_sym_virtual] = ACTIONS(3743),
    [anon_sym_extern] = ACTIONS(3743),
    [anon_sym___attribute__] = ACTIONS(3743),
    [anon_sym___attribute] = ACTIONS(3743),
    [anon_sym_using] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3745),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3745),
    [anon_sym___declspec] = ACTIONS(3743),
    [anon_sym___based] = ACTIONS(3743),
    [anon_sym___cdecl] = ACTIONS(3743),
    [anon_sym___clrcall] = ACTIONS(3743),
    [anon_sym___stdcall] = ACTIONS(3743),
    [anon_sym___fastcall] = ACTIONS(3743),
    [anon_sym___thiscall] = ACTIONS(3743),
    [anon_sym___vectorcall] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_RBRACE] = ACTIONS(3745),
    [anon_sym_signed] = ACTIONS(3743),
    [anon_sym_unsigned] = ACTIONS(3743),
    [anon_sym_long] = ACTIONS(3743),
    [anon_sym_short] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_static] = ACTIONS(3743),
    [anon_sym_register] = ACTIONS(3743),
    [anon_sym_inline] = ACTIONS(3743),
    [anon_sym___inline] = ACTIONS(3743),
    [anon_sym___inline__] = ACTIONS(3743),
    [anon_sym___forceinline] = ACTIONS(3743),
    [anon_sym_thread_local] = ACTIONS(3743),
    [anon_sym___thread] = ACTIONS(3743),
    [anon_sym_const] = ACTIONS(3743),
    [anon_sym_constexpr] = ACTIONS(3743),
    [anon_sym_volatile] = ACTIONS(3743),
    [anon_sym_restrict] = ACTIONS(3743),
    [anon_sym___restrict__] = ACTIONS(3743),
    [anon_sym__Atomic] = ACTIONS(3743),
    [anon_sym__Noreturn] = ACTIONS(3743),
    [anon_sym_noreturn] = ACTIONS(3743),
    [anon_sym__Nonnull] = ACTIONS(3743),
    [anon_sym_mutable] = ACTIONS(3743),
    [anon_sym_constinit] = ACTIONS(3743),
    [anon_sym_consteval] = ACTIONS(3743),
    [anon_sym_alignas] = ACTIONS(3743),
    [anon_sym__Alignas] = ACTIONS(3743),
    [sym_primitive_type] = ACTIONS(3743),
    [anon_sym_enum] = ACTIONS(3743),
    [anon_sym_class] = ACTIONS(3743),
    [anon_sym_struct] = ACTIONS(3743),
    [anon_sym_union] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_switch] = ACTIONS(3743),
    [anon_sym_case] = ACTIONS(3743),
    [anon_sym_default] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_break] = ACTIONS(3743),
    [anon_sym_continue] = ACTIONS(3743),
    [anon_sym_goto] = ACTIONS(3743),
    [anon_sym___try] = ACTIONS(3743),
    [anon_sym___leave] = ACTIONS(3743),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_compl] = ACTIONS(3743),
    [anon_sym_DASH_DASH] = ACTIONS(3745),
    [anon_sym_PLUS_PLUS] = ACTIONS(3745),
    [anon_sym_sizeof] = ACTIONS(3743),
    [anon_sym___alignof__] = ACTIONS(3743),
    [anon_sym___alignof] = ACTIONS(3743),
    [anon_sym__alignof] = ACTIONS(3743),
    [anon_sym_alignof] = ACTIONS(3743),
    [anon_sym__Alignof] = ACTIONS(3743),
    [anon_sym_offsetof] = ACTIONS(3743),
    [anon_sym__Generic] = ACTIONS(3743),
    [anon_sym_asm] = ACTIONS(3743),
    [anon_sym___asm__] = ACTIONS(3743),
    [anon_sym___asm] = ACTIONS(3743),
    [sym_number_literal] = ACTIONS(3745),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3745),
    [anon_sym_u_DQUOTE] = ACTIONS(3745),
    [anon_sym_U_DQUOTE] = ACTIONS(3745),
    [anon_sym_u8_DQUOTE] = ACTIONS(3745),
    [anon_sym_DQUOTE] = ACTIONS(3745),
    [sym_true] = ACTIONS(3743),
    [sym_false] = ACTIONS(3743),
    [anon_sym_NULL] = ACTIONS(3743),
    [anon_sym_nullptr] = ACTIONS(3743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_This] = ACTIONS(3743),
    [anon_sym_decltype] = ACTIONS(3743),
    [anon_sym_explicit] = ACTIONS(3743),
    [anon_sym_typename] = ACTIONS(3743),
    [anon_sym_template] = ACTIONS(3743),
    [anon_sym_operator] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_delete] = ACTIONS(3743),
    [anon_sym_throw] = ACTIONS(3743),
    [anon_sym_namespace] = ACTIONS(3743),
    [anon_sym_static_assert] = ACTIONS(3743),
    [anon_sym_concept] = ACTIONS(3743),
    [anon_sym_co_return] = ACTIONS(3743),
    [anon_sym_co_yield] = ACTIONS(3743),
    [anon_sym_R_DQUOTE] = ACTIONS(3745),
    [anon_sym_LR_DQUOTE] = ACTIONS(3745),
    [anon_sym_uR_DQUOTE] = ACTIONS(3745),
    [anon_sym_UR_DQUOTE] = ACTIONS(3745),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3745),
    [anon_sym_co_await] = ACTIONS(3743),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_requires] = ACTIONS(3743),
    [sym_this] = ACTIONS(3743),
    [anon_sym_discard] = ACTIONS(3743),
    [anon_sym_precise] = ACTIONS(3743),
    [anon_sym_shared] = ACTIONS(3743),
    [anon_sym_groupshared] = ACTIONS(3743),
    [anon_sym_uniform] = ACTIONS(3743),
    [anon_sym_row_major] = ACTIONS(3743),
    [anon_sym_column_major] = ACTIONS(3743),
    [anon_sym_globallycoherent] = ACTIONS(3743),
    [anon_sym_centroid] = ACTIONS(3743),
    [anon_sym_noperspective] = ACTIONS(3743),
    [anon_sym_nointerpolation] = ACTIONS(3743),
    [anon_sym_sample] = ACTIONS(3743),
    [anon_sym_linear] = ACTIONS(3743),
    [anon_sym_snorm] = ACTIONS(3743),
    [anon_sym_unorm] = ACTIONS(3743),
    [anon_sym_point] = ACTIONS(3743),
    [anon_sym_line] = ACTIONS(3743),
    [anon_sym_triangleadj] = ACTIONS(3743),
    [anon_sym_lineadj] = ACTIONS(3743),
    [anon_sym_triangle] = ACTIONS(3743),
    [anon_sym_cbuffer] = ACTIONS(3743),
    [anon_sym_interface] = ACTIONS(3743),
    [anon_sym_extension] = ACTIONS(3743),
  },
  [1100] = {
    [sym_identifier] = ACTIONS(3877),
    [aux_sym_preproc_include_token1] = ACTIONS(3877),
    [aux_sym_preproc_def_token1] = ACTIONS(3877),
    [aux_sym_preproc_if_token1] = ACTIONS(3877),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3877),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3877),
    [sym_preproc_directive] = ACTIONS(3877),
    [anon_sym_LPAREN2] = ACTIONS(3879),
    [anon_sym_BANG] = ACTIONS(3879),
    [anon_sym_TILDE] = ACTIONS(3879),
    [anon_sym_DASH] = ACTIONS(3877),
    [anon_sym_PLUS] = ACTIONS(3877),
    [anon_sym_STAR] = ACTIONS(3879),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3877),
    [anon_sym_SEMI] = ACTIONS(3879),
    [anon_sym___extension__] = ACTIONS(3877),
    [anon_sym_typedef] = ACTIONS(3877),
    [anon_sym_in] = ACTIONS(3877),
    [anon_sym_out] = ACTIONS(3877),
    [anon_sym_inout] = ACTIONS(3877),
    [anon_sym_virtual] = ACTIONS(3877),
    [anon_sym_extern] = ACTIONS(3877),
    [anon_sym___attribute__] = ACTIONS(3877),
    [anon_sym___attribute] = ACTIONS(3877),
    [anon_sym_using] = ACTIONS(3877),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3879),
    [anon_sym___declspec] = ACTIONS(3877),
    [anon_sym___based] = ACTIONS(3877),
    [anon_sym___cdecl] = ACTIONS(3877),
    [anon_sym___clrcall] = ACTIONS(3877),
    [anon_sym___stdcall] = ACTIONS(3877),
    [anon_sym___fastcall] = ACTIONS(3877),
    [anon_sym___thiscall] = ACTIONS(3877),
    [anon_sym___vectorcall] = ACTIONS(3877),
    [anon_sym_LBRACE] = ACTIONS(3879),
    [anon_sym_RBRACE] = ACTIONS(3879),
    [anon_sym_signed] = ACTIONS(3877),
    [anon_sym_unsigned] = ACTIONS(3877),
    [anon_sym_long] = ACTIONS(3877),
    [anon_sym_short] = ACTIONS(3877),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_static] = ACTIONS(3877),
    [anon_sym_register] = ACTIONS(3877),
    [anon_sym_inline] = ACTIONS(3877),
    [anon_sym___inline] = ACTIONS(3877),
    [anon_sym___inline__] = ACTIONS(3877),
    [anon_sym___forceinline] = ACTIONS(3877),
    [anon_sym_thread_local] = ACTIONS(3877),
    [anon_sym___thread] = ACTIONS(3877),
    [anon_sym_const] = ACTIONS(3877),
    [anon_sym_constexpr] = ACTIONS(3877),
    [anon_sym_volatile] = ACTIONS(3877),
    [anon_sym_restrict] = ACTIONS(3877),
    [anon_sym___restrict__] = ACTIONS(3877),
    [anon_sym__Atomic] = ACTIONS(3877),
    [anon_sym__Noreturn] = ACTIONS(3877),
    [anon_sym_noreturn] = ACTIONS(3877),
    [anon_sym__Nonnull] = ACTIONS(3877),
    [anon_sym_mutable] = ACTIONS(3877),
    [anon_sym_constinit] = ACTIONS(3877),
    [anon_sym_consteval] = ACTIONS(3877),
    [anon_sym_alignas] = ACTIONS(3877),
    [anon_sym__Alignas] = ACTIONS(3877),
    [sym_primitive_type] = ACTIONS(3877),
    [anon_sym_enum] = ACTIONS(3877),
    [anon_sym_class] = ACTIONS(3877),
    [anon_sym_struct] = ACTIONS(3877),
    [anon_sym_union] = ACTIONS(3877),
    [anon_sym_if] = ACTIONS(3877),
    [anon_sym_switch] = ACTIONS(3877),
    [anon_sym_case] = ACTIONS(3877),
    [anon_sym_default] = ACTIONS(3877),
    [anon_sym_while] = ACTIONS(3877),
    [anon_sym_do] = ACTIONS(3877),
    [anon_sym_for] = ACTIONS(3877),
    [anon_sym_return] = ACTIONS(3877),
    [anon_sym_break] = ACTIONS(3877),
    [anon_sym_continue] = ACTIONS(3877),
    [anon_sym_goto] = ACTIONS(3877),
    [anon_sym___try] = ACTIONS(3877),
    [anon_sym___leave] = ACTIONS(3877),
    [anon_sym_not] = ACTIONS(3877),
    [anon_sym_compl] = ACTIONS(3877),
    [anon_sym_DASH_DASH] = ACTIONS(3879),
    [anon_sym_PLUS_PLUS] = ACTIONS(3879),
    [anon_sym_sizeof] = ACTIONS(3877),
    [anon_sym___alignof__] = ACTIONS(3877),
    [anon_sym___alignof] = ACTIONS(3877),
    [anon_sym__alignof] = ACTIONS(3877),
    [anon_sym_alignof] = ACTIONS(3877),
    [anon_sym__Alignof] = ACTIONS(3877),
    [anon_sym_offsetof] = ACTIONS(3877),
    [anon_sym__Generic] = ACTIONS(3877),
    [anon_sym_asm] = ACTIONS(3877),
    [anon_sym___asm__] = ACTIONS(3877),
    [anon_sym___asm] = ACTIONS(3877),
    [sym_number_literal] = ACTIONS(3879),
    [anon_sym_L_SQUOTE] = ACTIONS(3879),
    [anon_sym_u_SQUOTE] = ACTIONS(3879),
    [anon_sym_U_SQUOTE] = ACTIONS(3879),
    [anon_sym_u8_SQUOTE] = ACTIONS(3879),
    [anon_sym_SQUOTE] = ACTIONS(3879),
    [anon_sym_L_DQUOTE] = ACTIONS(3879),
    [anon_sym_u_DQUOTE] = ACTIONS(3879),
    [anon_sym_U_DQUOTE] = ACTIONS(3879),
    [anon_sym_u8_DQUOTE] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [sym_true] = ACTIONS(3877),
    [sym_false] = ACTIONS(3877),
    [anon_sym_NULL] = ACTIONS(3877),
    [anon_sym_nullptr] = ACTIONS(3877),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3877),
    [anon_sym_let] = ACTIONS(3877),
    [anon_sym_This] = ACTIONS(3877),
    [anon_sym_decltype] = ACTIONS(3877),
    [anon_sym_explicit] = ACTIONS(3877),
    [anon_sym_typename] = ACTIONS(3877),
    [anon_sym_template] = ACTIONS(3877),
    [anon_sym_operator] = ACTIONS(3877),
    [anon_sym_try] = ACTIONS(3877),
    [anon_sym_delete] = ACTIONS(3877),
    [anon_sym_throw] = ACTIONS(3877),
    [anon_sym_namespace] = ACTIONS(3877),
    [anon_sym_static_assert] = ACTIONS(3877),
    [anon_sym_concept] = ACTIONS(3877),
    [anon_sym_co_return] = ACTIONS(3877),
    [anon_sym_co_yield] = ACTIONS(3877),
    [anon_sym_R_DQUOTE] = ACTIONS(3879),
    [anon_sym_LR_DQUOTE] = ACTIONS(3879),
    [anon_sym_uR_DQUOTE] = ACTIONS(3879),
    [anon_sym_UR_DQUOTE] = ACTIONS(3879),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3879),
    [anon_sym_co_await] = ACTIONS(3877),
    [anon_sym_new] = ACTIONS(3877),
    [anon_sym_requires] = ACTIONS(3877),
    [sym_this] = ACTIONS(3877),
    [anon_sym_discard] = ACTIONS(3877),
    [anon_sym_precise] = ACTIONS(3877),
    [anon_sym_shared] = ACTIONS(3877),
    [anon_sym_groupshared] = ACTIONS(3877),
    [anon_sym_uniform] = ACTIONS(3877),
    [anon_sym_row_major] = ACTIONS(3877),
    [anon_sym_column_major] = ACTIONS(3877),
    [anon_sym_globallycoherent] = ACTIONS(3877),
    [anon_sym_centroid] = ACTIONS(3877),
    [anon_sym_noperspective] = ACTIONS(3877),
    [anon_sym_nointerpolation] = ACTIONS(3877),
    [anon_sym_sample] = ACTIONS(3877),
    [anon_sym_linear] = ACTIONS(3877),
    [anon_sym_snorm] = ACTIONS(3877),
    [anon_sym_unorm] = ACTIONS(3877),
    [anon_sym_point] = ACTIONS(3877),
    [anon_sym_line] = ACTIONS(3877),
    [anon_sym_triangleadj] = ACTIONS(3877),
    [anon_sym_lineadj] = ACTIONS(3877),
    [anon_sym_triangle] = ACTIONS(3877),
    [anon_sym_cbuffer] = ACTIONS(3877),
    [anon_sym_interface] = ACTIONS(3877),
    [anon_sym_extension] = ACTIONS(3877),
  },
  [1101] = {
    [sym_identifier] = ACTIONS(3849),
    [aux_sym_preproc_include_token1] = ACTIONS(3849),
    [aux_sym_preproc_def_token1] = ACTIONS(3849),
    [aux_sym_preproc_if_token1] = ACTIONS(3849),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3849),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3849),
    [sym_preproc_directive] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3851),
    [anon_sym_BANG] = ACTIONS(3851),
    [anon_sym_TILDE] = ACTIONS(3851),
    [anon_sym_DASH] = ACTIONS(3849),
    [anon_sym_PLUS] = ACTIONS(3849),
    [anon_sym_STAR] = ACTIONS(3851),
    [anon_sym_AMP_AMP] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3849),
    [anon_sym_SEMI] = ACTIONS(3851),
    [anon_sym___extension__] = ACTIONS(3849),
    [anon_sym_typedef] = ACTIONS(3849),
    [anon_sym_in] = ACTIONS(3849),
    [anon_sym_out] = ACTIONS(3849),
    [anon_sym_inout] = ACTIONS(3849),
    [anon_sym_virtual] = ACTIONS(3849),
    [anon_sym_extern] = ACTIONS(3849),
    [anon_sym___attribute__] = ACTIONS(3849),
    [anon_sym___attribute] = ACTIONS(3849),
    [anon_sym_using] = ACTIONS(3849),
    [anon_sym_COLON_COLON] = ACTIONS(3851),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3851),
    [anon_sym___declspec] = ACTIONS(3849),
    [anon_sym___based] = ACTIONS(3849),
    [anon_sym___cdecl] = ACTIONS(3849),
    [anon_sym___clrcall] = ACTIONS(3849),
    [anon_sym___stdcall] = ACTIONS(3849),
    [anon_sym___fastcall] = ACTIONS(3849),
    [anon_sym___thiscall] = ACTIONS(3849),
    [anon_sym___vectorcall] = ACTIONS(3849),
    [anon_sym_LBRACE] = ACTIONS(3851),
    [anon_sym_RBRACE] = ACTIONS(3851),
    [anon_sym_signed] = ACTIONS(3849),
    [anon_sym_unsigned] = ACTIONS(3849),
    [anon_sym_long] = ACTIONS(3849),
    [anon_sym_short] = ACTIONS(3849),
    [anon_sym_LBRACK] = ACTIONS(3849),
    [anon_sym_static] = ACTIONS(3849),
    [anon_sym_register] = ACTIONS(3849),
    [anon_sym_inline] = ACTIONS(3849),
    [anon_sym___inline] = ACTIONS(3849),
    [anon_sym___inline__] = ACTIONS(3849),
    [anon_sym___forceinline] = ACTIONS(3849),
    [anon_sym_thread_local] = ACTIONS(3849),
    [anon_sym___thread] = ACTIONS(3849),
    [anon_sym_const] = ACTIONS(3849),
    [anon_sym_constexpr] = ACTIONS(3849),
    [anon_sym_volatile] = ACTIONS(3849),
    [anon_sym_restrict] = ACTIONS(3849),
    [anon_sym___restrict__] = ACTIONS(3849),
    [anon_sym__Atomic] = ACTIONS(3849),
    [anon_sym__Noreturn] = ACTIONS(3849),
    [anon_sym_noreturn] = ACTIONS(3849),
    [anon_sym__Nonnull] = ACTIONS(3849),
    [anon_sym_mutable] = ACTIONS(3849),
    [anon_sym_constinit] = ACTIONS(3849),
    [anon_sym_consteval] = ACTIONS(3849),
    [anon_sym_alignas] = ACTIONS(3849),
    [anon_sym__Alignas] = ACTIONS(3849),
    [sym_primitive_type] = ACTIONS(3849),
    [anon_sym_enum] = ACTIONS(3849),
    [anon_sym_class] = ACTIONS(3849),
    [anon_sym_struct] = ACTIONS(3849),
    [anon_sym_union] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3849),
    [anon_sym_switch] = ACTIONS(3849),
    [anon_sym_case] = ACTIONS(3849),
    [anon_sym_default] = ACTIONS(3849),
    [anon_sym_while] = ACTIONS(3849),
    [anon_sym_do] = ACTIONS(3849),
    [anon_sym_for] = ACTIONS(3849),
    [anon_sym_return] = ACTIONS(3849),
    [anon_sym_break] = ACTIONS(3849),
    [anon_sym_continue] = ACTIONS(3849),
    [anon_sym_goto] = ACTIONS(3849),
    [anon_sym___try] = ACTIONS(3849),
    [anon_sym___leave] = ACTIONS(3849),
    [anon_sym_not] = ACTIONS(3849),
    [anon_sym_compl] = ACTIONS(3849),
    [anon_sym_DASH_DASH] = ACTIONS(3851),
    [anon_sym_PLUS_PLUS] = ACTIONS(3851),
    [anon_sym_sizeof] = ACTIONS(3849),
    [anon_sym___alignof__] = ACTIONS(3849),
    [anon_sym___alignof] = ACTIONS(3849),
    [anon_sym__alignof] = ACTIONS(3849),
    [anon_sym_alignof] = ACTIONS(3849),
    [anon_sym__Alignof] = ACTIONS(3849),
    [anon_sym_offsetof] = ACTIONS(3849),
    [anon_sym__Generic] = ACTIONS(3849),
    [anon_sym_asm] = ACTIONS(3849),
    [anon_sym___asm__] = ACTIONS(3849),
    [anon_sym___asm] = ACTIONS(3849),
    [sym_number_literal] = ACTIONS(3851),
    [anon_sym_L_SQUOTE] = ACTIONS(3851),
    [anon_sym_u_SQUOTE] = ACTIONS(3851),
    [anon_sym_U_SQUOTE] = ACTIONS(3851),
    [anon_sym_u8_SQUOTE] = ACTIONS(3851),
    [anon_sym_SQUOTE] = ACTIONS(3851),
    [anon_sym_L_DQUOTE] = ACTIONS(3851),
    [anon_sym_u_DQUOTE] = ACTIONS(3851),
    [anon_sym_U_DQUOTE] = ACTIONS(3851),
    [anon_sym_u8_DQUOTE] = ACTIONS(3851),
    [anon_sym_DQUOTE] = ACTIONS(3851),
    [sym_true] = ACTIONS(3849),
    [sym_false] = ACTIONS(3849),
    [anon_sym_NULL] = ACTIONS(3849),
    [anon_sym_nullptr] = ACTIONS(3849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3849),
    [anon_sym_let] = ACTIONS(3849),
    [anon_sym_This] = ACTIONS(3849),
    [anon_sym_decltype] = ACTIONS(3849),
    [anon_sym_explicit] = ACTIONS(3849),
    [anon_sym_typename] = ACTIONS(3849),
    [anon_sym_template] = ACTIONS(3849),
    [anon_sym_operator] = ACTIONS(3849),
    [anon_sym_try] = ACTIONS(3849),
    [anon_sym_delete] = ACTIONS(3849),
    [anon_sym_throw] = ACTIONS(3849),
    [anon_sym_namespace] = ACTIONS(3849),
    [anon_sym_static_assert] = ACTIONS(3849),
    [anon_sym_concept] = ACTIONS(3849),
    [anon_sym_co_return] = ACTIONS(3849),
    [anon_sym_co_yield] = ACTIONS(3849),
    [anon_sym_R_DQUOTE] = ACTIONS(3851),
    [anon_sym_LR_DQUOTE] = ACTIONS(3851),
    [anon_sym_uR_DQUOTE] = ACTIONS(3851),
    [anon_sym_UR_DQUOTE] = ACTIONS(3851),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3851),
    [anon_sym_co_await] = ACTIONS(3849),
    [anon_sym_new] = ACTIONS(3849),
    [anon_sym_requires] = ACTIONS(3849),
    [sym_this] = ACTIONS(3849),
    [anon_sym_discard] = ACTIONS(3849),
    [anon_sym_precise] = ACTIONS(3849),
    [anon_sym_shared] = ACTIONS(3849),
    [anon_sym_groupshared] = ACTIONS(3849),
    [anon_sym_uniform] = ACTIONS(3849),
    [anon_sym_row_major] = ACTIONS(3849),
    [anon_sym_column_major] = ACTIONS(3849),
    [anon_sym_globallycoherent] = ACTIONS(3849),
    [anon_sym_centroid] = ACTIONS(3849),
    [anon_sym_noperspective] = ACTIONS(3849),
    [anon_sym_nointerpolation] = ACTIONS(3849),
    [anon_sym_sample] = ACTIONS(3849),
    [anon_sym_linear] = ACTIONS(3849),
    [anon_sym_snorm] = ACTIONS(3849),
    [anon_sym_unorm] = ACTIONS(3849),
    [anon_sym_point] = ACTIONS(3849),
    [anon_sym_line] = ACTIONS(3849),
    [anon_sym_triangleadj] = ACTIONS(3849),
    [anon_sym_lineadj] = ACTIONS(3849),
    [anon_sym_triangle] = ACTIONS(3849),
    [anon_sym_cbuffer] = ACTIONS(3849),
    [anon_sym_interface] = ACTIONS(3849),
    [anon_sym_extension] = ACTIONS(3849),
  },
  [1102] = {
    [sym_identifier] = ACTIONS(3893),
    [aux_sym_preproc_include_token1] = ACTIONS(3893),
    [aux_sym_preproc_def_token1] = ACTIONS(3893),
    [aux_sym_preproc_if_token1] = ACTIONS(3893),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3893),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3893),
    [sym_preproc_directive] = ACTIONS(3893),
    [anon_sym_LPAREN2] = ACTIONS(3895),
    [anon_sym_BANG] = ACTIONS(3895),
    [anon_sym_TILDE] = ACTIONS(3895),
    [anon_sym_DASH] = ACTIONS(3893),
    [anon_sym_PLUS] = ACTIONS(3893),
    [anon_sym_STAR] = ACTIONS(3895),
    [anon_sym_AMP_AMP] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3893),
    [anon_sym_SEMI] = ACTIONS(3895),
    [anon_sym___extension__] = ACTIONS(3893),
    [anon_sym_typedef] = ACTIONS(3893),
    [anon_sym_in] = ACTIONS(3893),
    [anon_sym_out] = ACTIONS(3893),
    [anon_sym_inout] = ACTIONS(3893),
    [anon_sym_virtual] = ACTIONS(3893),
    [anon_sym_extern] = ACTIONS(3893),
    [anon_sym___attribute__] = ACTIONS(3893),
    [anon_sym___attribute] = ACTIONS(3893),
    [anon_sym_using] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3895),
    [anon_sym___declspec] = ACTIONS(3893),
    [anon_sym___based] = ACTIONS(3893),
    [anon_sym___cdecl] = ACTIONS(3893),
    [anon_sym___clrcall] = ACTIONS(3893),
    [anon_sym___stdcall] = ACTIONS(3893),
    [anon_sym___fastcall] = ACTIONS(3893),
    [anon_sym___thiscall] = ACTIONS(3893),
    [anon_sym___vectorcall] = ACTIONS(3893),
    [anon_sym_LBRACE] = ACTIONS(3895),
    [anon_sym_RBRACE] = ACTIONS(3895),
    [anon_sym_signed] = ACTIONS(3893),
    [anon_sym_unsigned] = ACTIONS(3893),
    [anon_sym_long] = ACTIONS(3893),
    [anon_sym_short] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_static] = ACTIONS(3893),
    [anon_sym_register] = ACTIONS(3893),
    [anon_sym_inline] = ACTIONS(3893),
    [anon_sym___inline] = ACTIONS(3893),
    [anon_sym___inline__] = ACTIONS(3893),
    [anon_sym___forceinline] = ACTIONS(3893),
    [anon_sym_thread_local] = ACTIONS(3893),
    [anon_sym___thread] = ACTIONS(3893),
    [anon_sym_const] = ACTIONS(3893),
    [anon_sym_constexpr] = ACTIONS(3893),
    [anon_sym_volatile] = ACTIONS(3893),
    [anon_sym_restrict] = ACTIONS(3893),
    [anon_sym___restrict__] = ACTIONS(3893),
    [anon_sym__Atomic] = ACTIONS(3893),
    [anon_sym__Noreturn] = ACTIONS(3893),
    [anon_sym_noreturn] = ACTIONS(3893),
    [anon_sym__Nonnull] = ACTIONS(3893),
    [anon_sym_mutable] = ACTIONS(3893),
    [anon_sym_constinit] = ACTIONS(3893),
    [anon_sym_consteval] = ACTIONS(3893),
    [anon_sym_alignas] = ACTIONS(3893),
    [anon_sym__Alignas] = ACTIONS(3893),
    [sym_primitive_type] = ACTIONS(3893),
    [anon_sym_enum] = ACTIONS(3893),
    [anon_sym_class] = ACTIONS(3893),
    [anon_sym_struct] = ACTIONS(3893),
    [anon_sym_union] = ACTIONS(3893),
    [anon_sym_if] = ACTIONS(3893),
    [anon_sym_switch] = ACTIONS(3893),
    [anon_sym_case] = ACTIONS(3893),
    [anon_sym_default] = ACTIONS(3893),
    [anon_sym_while] = ACTIONS(3893),
    [anon_sym_do] = ACTIONS(3893),
    [anon_sym_for] = ACTIONS(3893),
    [anon_sym_return] = ACTIONS(3893),
    [anon_sym_break] = ACTIONS(3893),
    [anon_sym_continue] = ACTIONS(3893),
    [anon_sym_goto] = ACTIONS(3893),
    [anon_sym___try] = ACTIONS(3893),
    [anon_sym___leave] = ACTIONS(3893),
    [anon_sym_not] = ACTIONS(3893),
    [anon_sym_compl] = ACTIONS(3893),
    [anon_sym_DASH_DASH] = ACTIONS(3895),
    [anon_sym_PLUS_PLUS] = ACTIONS(3895),
    [anon_sym_sizeof] = ACTIONS(3893),
    [anon_sym___alignof__] = ACTIONS(3893),
    [anon_sym___alignof] = ACTIONS(3893),
    [anon_sym__alignof] = ACTIONS(3893),
    [anon_sym_alignof] = ACTIONS(3893),
    [anon_sym__Alignof] = ACTIONS(3893),
    [anon_sym_offsetof] = ACTIONS(3893),
    [anon_sym__Generic] = ACTIONS(3893),
    [anon_sym_asm] = ACTIONS(3893),
    [anon_sym___asm__] = ACTIONS(3893),
    [anon_sym___asm] = ACTIONS(3893),
    [sym_number_literal] = ACTIONS(3895),
    [anon_sym_L_SQUOTE] = ACTIONS(3895),
    [anon_sym_u_SQUOTE] = ACTIONS(3895),
    [anon_sym_U_SQUOTE] = ACTIONS(3895),
    [anon_sym_u8_SQUOTE] = ACTIONS(3895),
    [anon_sym_SQUOTE] = ACTIONS(3895),
    [anon_sym_L_DQUOTE] = ACTIONS(3895),
    [anon_sym_u_DQUOTE] = ACTIONS(3895),
    [anon_sym_U_DQUOTE] = ACTIONS(3895),
    [anon_sym_u8_DQUOTE] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(3895),
    [sym_true] = ACTIONS(3893),
    [sym_false] = ACTIONS(3893),
    [anon_sym_NULL] = ACTIONS(3893),
    [anon_sym_nullptr] = ACTIONS(3893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_This] = ACTIONS(3893),
    [anon_sym_decltype] = ACTIONS(3893),
    [anon_sym_explicit] = ACTIONS(3893),
    [anon_sym_typename] = ACTIONS(3893),
    [anon_sym_template] = ACTIONS(3893),
    [anon_sym_operator] = ACTIONS(3893),
    [anon_sym_try] = ACTIONS(3893),
    [anon_sym_delete] = ACTIONS(3893),
    [anon_sym_throw] = ACTIONS(3893),
    [anon_sym_namespace] = ACTIONS(3893),
    [anon_sym_static_assert] = ACTIONS(3893),
    [anon_sym_concept] = ACTIONS(3893),
    [anon_sym_co_return] = ACTIONS(3893),
    [anon_sym_co_yield] = ACTIONS(3893),
    [anon_sym_R_DQUOTE] = ACTIONS(3895),
    [anon_sym_LR_DQUOTE] = ACTIONS(3895),
    [anon_sym_uR_DQUOTE] = ACTIONS(3895),
    [anon_sym_UR_DQUOTE] = ACTIONS(3895),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3895),
    [anon_sym_co_await] = ACTIONS(3893),
    [anon_sym_new] = ACTIONS(3893),
    [anon_sym_requires] = ACTIONS(3893),
    [sym_this] = ACTIONS(3893),
    [anon_sym_discard] = ACTIONS(3893),
    [anon_sym_precise] = ACTIONS(3893),
    [anon_sym_shared] = ACTIONS(3893),
    [anon_sym_groupshared] = ACTIONS(3893),
    [anon_sym_uniform] = ACTIONS(3893),
    [anon_sym_row_major] = ACTIONS(3893),
    [anon_sym_column_major] = ACTIONS(3893),
    [anon_sym_globallycoherent] = ACTIONS(3893),
    [anon_sym_centroid] = ACTIONS(3893),
    [anon_sym_noperspective] = ACTIONS(3893),
    [anon_sym_nointerpolation] = ACTIONS(3893),
    [anon_sym_sample] = ACTIONS(3893),
    [anon_sym_linear] = ACTIONS(3893),
    [anon_sym_snorm] = ACTIONS(3893),
    [anon_sym_unorm] = ACTIONS(3893),
    [anon_sym_point] = ACTIONS(3893),
    [anon_sym_line] = ACTIONS(3893),
    [anon_sym_triangleadj] = ACTIONS(3893),
    [anon_sym_lineadj] = ACTIONS(3893),
    [anon_sym_triangle] = ACTIONS(3893),
    [anon_sym_cbuffer] = ACTIONS(3893),
    [anon_sym_interface] = ACTIONS(3893),
    [anon_sym_extension] = ACTIONS(3893),
  },
  [1103] = {
    [ts_builtin_sym_end] = ACTIONS(3887),
    [sym_identifier] = ACTIONS(3885),
    [aux_sym_preproc_include_token1] = ACTIONS(3885),
    [aux_sym_preproc_def_token1] = ACTIONS(3885),
    [aux_sym_preproc_if_token1] = ACTIONS(3885),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3885),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3885),
    [sym_preproc_directive] = ACTIONS(3885),
    [anon_sym_LPAREN2] = ACTIONS(3887),
    [anon_sym_BANG] = ACTIONS(3887),
    [anon_sym_TILDE] = ACTIONS(3887),
    [anon_sym_DASH] = ACTIONS(3885),
    [anon_sym_PLUS] = ACTIONS(3885),
    [anon_sym_STAR] = ACTIONS(3887),
    [anon_sym_AMP_AMP] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3885),
    [anon_sym_SEMI] = ACTIONS(3887),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_typedef] = ACTIONS(3885),
    [anon_sym_in] = ACTIONS(3885),
    [anon_sym_out] = ACTIONS(3885),
    [anon_sym_inout] = ACTIONS(3885),
    [anon_sym_virtual] = ACTIONS(3885),
    [anon_sym_extern] = ACTIONS(3885),
    [anon_sym___attribute__] = ACTIONS(3885),
    [anon_sym___attribute] = ACTIONS(3885),
    [anon_sym_using] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3887),
    [anon_sym___declspec] = ACTIONS(3885),
    [anon_sym___based] = ACTIONS(3885),
    [anon_sym___cdecl] = ACTIONS(3885),
    [anon_sym___clrcall] = ACTIONS(3885),
    [anon_sym___stdcall] = ACTIONS(3885),
    [anon_sym___fastcall] = ACTIONS(3885),
    [anon_sym___thiscall] = ACTIONS(3885),
    [anon_sym___vectorcall] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_signed] = ACTIONS(3885),
    [anon_sym_unsigned] = ACTIONS(3885),
    [anon_sym_long] = ACTIONS(3885),
    [anon_sym_short] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_static] = ACTIONS(3885),
    [anon_sym_register] = ACTIONS(3885),
    [anon_sym_inline] = ACTIONS(3885),
    [anon_sym___inline] = ACTIONS(3885),
    [anon_sym___inline__] = ACTIONS(3885),
    [anon_sym___forceinline] = ACTIONS(3885),
    [anon_sym_thread_local] = ACTIONS(3885),
    [anon_sym___thread] = ACTIONS(3885),
    [anon_sym_const] = ACTIONS(3885),
    [anon_sym_constexpr] = ACTIONS(3885),
    [anon_sym_volatile] = ACTIONS(3885),
    [anon_sym_restrict] = ACTIONS(3885),
    [anon_sym___restrict__] = ACTIONS(3885),
    [anon_sym__Atomic] = ACTIONS(3885),
    [anon_sym__Noreturn] = ACTIONS(3885),
    [anon_sym_noreturn] = ACTIONS(3885),
    [anon_sym__Nonnull] = ACTIONS(3885),
    [anon_sym_mutable] = ACTIONS(3885),
    [anon_sym_constinit] = ACTIONS(3885),
    [anon_sym_consteval] = ACTIONS(3885),
    [anon_sym_alignas] = ACTIONS(3885),
    [anon_sym__Alignas] = ACTIONS(3885),
    [sym_primitive_type] = ACTIONS(3885),
    [anon_sym_enum] = ACTIONS(3885),
    [anon_sym_class] = ACTIONS(3885),
    [anon_sym_struct] = ACTIONS(3885),
    [anon_sym_union] = ACTIONS(3885),
    [anon_sym_if] = ACTIONS(3885),
    [anon_sym_switch] = ACTIONS(3885),
    [anon_sym_case] = ACTIONS(3885),
    [anon_sym_default] = ACTIONS(3885),
    [anon_sym_while] = ACTIONS(3885),
    [anon_sym_do] = ACTIONS(3885),
    [anon_sym_for] = ACTIONS(3885),
    [anon_sym_return] = ACTIONS(3885),
    [anon_sym_break] = ACTIONS(3885),
    [anon_sym_continue] = ACTIONS(3885),
    [anon_sym_goto] = ACTIONS(3885),
    [anon_sym_not] = ACTIONS(3885),
    [anon_sym_compl] = ACTIONS(3885),
    [anon_sym_DASH_DASH] = ACTIONS(3887),
    [anon_sym_PLUS_PLUS] = ACTIONS(3887),
    [anon_sym_sizeof] = ACTIONS(3885),
    [anon_sym___alignof__] = ACTIONS(3885),
    [anon_sym___alignof] = ACTIONS(3885),
    [anon_sym__alignof] = ACTIONS(3885),
    [anon_sym_alignof] = ACTIONS(3885),
    [anon_sym__Alignof] = ACTIONS(3885),
    [anon_sym_offsetof] = ACTIONS(3885),
    [anon_sym__Generic] = ACTIONS(3885),
    [anon_sym_asm] = ACTIONS(3885),
    [anon_sym___asm__] = ACTIONS(3885),
    [anon_sym___asm] = ACTIONS(3885),
    [sym_number_literal] = ACTIONS(3887),
    [anon_sym_L_SQUOTE] = ACTIONS(3887),
    [anon_sym_u_SQUOTE] = ACTIONS(3887),
    [anon_sym_U_SQUOTE] = ACTIONS(3887),
    [anon_sym_u8_SQUOTE] = ACTIONS(3887),
    [anon_sym_SQUOTE] = ACTIONS(3887),
    [anon_sym_L_DQUOTE] = ACTIONS(3887),
    [anon_sym_u_DQUOTE] = ACTIONS(3887),
    [anon_sym_U_DQUOTE] = ACTIONS(3887),
    [anon_sym_u8_DQUOTE] = ACTIONS(3887),
    [anon_sym_DQUOTE] = ACTIONS(3887),
    [sym_true] = ACTIONS(3885),
    [sym_false] = ACTIONS(3885),
    [anon_sym_NULL] = ACTIONS(3885),
    [anon_sym_nullptr] = ACTIONS(3885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3885),
    [anon_sym_let] = ACTIONS(3885),
    [anon_sym_This] = ACTIONS(3885),
    [anon_sym_decltype] = ACTIONS(3885),
    [anon_sym_explicit] = ACTIONS(3885),
    [anon_sym_typename] = ACTIONS(3885),
    [anon_sym_export] = ACTIONS(3885),
    [anon_sym_module] = ACTIONS(3885),
    [anon_sym_import] = ACTIONS(3885),
    [anon_sym_template] = ACTIONS(3885),
    [anon_sym_operator] = ACTIONS(3885),
    [anon_sym_try] = ACTIONS(3885),
    [anon_sym_delete] = ACTIONS(3885),
    [anon_sym_throw] = ACTIONS(3885),
    [anon_sym_namespace] = ACTIONS(3885),
    [anon_sym_static_assert] = ACTIONS(3885),
    [anon_sym_concept] = ACTIONS(3885),
    [anon_sym_co_return] = ACTIONS(3885),
    [anon_sym_co_yield] = ACTIONS(3885),
    [anon_sym_R_DQUOTE] = ACTIONS(3887),
    [anon_sym_LR_DQUOTE] = ACTIONS(3887),
    [anon_sym_uR_DQUOTE] = ACTIONS(3887),
    [anon_sym_UR_DQUOTE] = ACTIONS(3887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3887),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3885),
    [anon_sym_requires] = ACTIONS(3885),
    [sym_this] = ACTIONS(3885),
    [anon_sym_precise] = ACTIONS(3885),
    [anon_sym_shared] = ACTIONS(3885),
    [anon_sym_groupshared] = ACTIONS(3885),
    [anon_sym_uniform] = ACTIONS(3885),
    [anon_sym_row_major] = ACTIONS(3885),
    [anon_sym_column_major] = ACTIONS(3885),
    [anon_sym_globallycoherent] = ACTIONS(3885),
    [anon_sym_centroid] = ACTIONS(3885),
    [anon_sym_noperspective] = ACTIONS(3885),
    [anon_sym_nointerpolation] = ACTIONS(3885),
    [anon_sym_sample] = ACTIONS(3885),
    [anon_sym_linear] = ACTIONS(3885),
    [anon_sym_snorm] = ACTIONS(3885),
    [anon_sym_unorm] = ACTIONS(3885),
    [anon_sym_point] = ACTIONS(3885),
    [anon_sym_line] = ACTIONS(3885),
    [anon_sym_triangleadj] = ACTIONS(3885),
    [anon_sym_lineadj] = ACTIONS(3885),
    [anon_sym_triangle] = ACTIONS(3885),
    [anon_sym_interface] = ACTIONS(3885),
    [anon_sym_extension] = ACTIONS(3885),
    [anon_sym___exported] = ACTIONS(3885),
  },
  [1104] = {
    [sym_identifier] = ACTIONS(3731),
    [aux_sym_preproc_include_token1] = ACTIONS(3731),
    [aux_sym_preproc_def_token1] = ACTIONS(3731),
    [aux_sym_preproc_if_token1] = ACTIONS(3731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3731),
    [sym_preproc_directive] = ACTIONS(3731),
    [anon_sym_LPAREN2] = ACTIONS(3733),
    [anon_sym_BANG] = ACTIONS(3733),
    [anon_sym_TILDE] = ACTIONS(3733),
    [anon_sym_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3731),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_AMP_AMP] = ACTIONS(3733),
    [anon_sym_AMP] = ACTIONS(3731),
    [anon_sym_SEMI] = ACTIONS(3733),
    [anon_sym___extension__] = ACTIONS(3731),
    [anon_sym_typedef] = ACTIONS(3731),
    [anon_sym_in] = ACTIONS(3731),
    [anon_sym_out] = ACTIONS(3731),
    [anon_sym_inout] = ACTIONS(3731),
    [anon_sym_virtual] = ACTIONS(3731),
    [anon_sym_extern] = ACTIONS(3731),
    [anon_sym___attribute__] = ACTIONS(3731),
    [anon_sym___attribute] = ACTIONS(3731),
    [anon_sym_using] = ACTIONS(3731),
    [anon_sym_COLON_COLON] = ACTIONS(3733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3733),
    [anon_sym___declspec] = ACTIONS(3731),
    [anon_sym___based] = ACTIONS(3731),
    [anon_sym___cdecl] = ACTIONS(3731),
    [anon_sym___clrcall] = ACTIONS(3731),
    [anon_sym___stdcall] = ACTIONS(3731),
    [anon_sym___fastcall] = ACTIONS(3731),
    [anon_sym___thiscall] = ACTIONS(3731),
    [anon_sym___vectorcall] = ACTIONS(3731),
    [anon_sym_LBRACE] = ACTIONS(3733),
    [anon_sym_RBRACE] = ACTIONS(3733),
    [anon_sym_signed] = ACTIONS(3731),
    [anon_sym_unsigned] = ACTIONS(3731),
    [anon_sym_long] = ACTIONS(3731),
    [anon_sym_short] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3731),
    [anon_sym_static] = ACTIONS(3731),
    [anon_sym_register] = ACTIONS(3731),
    [anon_sym_inline] = ACTIONS(3731),
    [anon_sym___inline] = ACTIONS(3731),
    [anon_sym___inline__] = ACTIONS(3731),
    [anon_sym___forceinline] = ACTIONS(3731),
    [anon_sym_thread_local] = ACTIONS(3731),
    [anon_sym___thread] = ACTIONS(3731),
    [anon_sym_const] = ACTIONS(3731),
    [anon_sym_constexpr] = ACTIONS(3731),
    [anon_sym_volatile] = ACTIONS(3731),
    [anon_sym_restrict] = ACTIONS(3731),
    [anon_sym___restrict__] = ACTIONS(3731),
    [anon_sym__Atomic] = ACTIONS(3731),
    [anon_sym__Noreturn] = ACTIONS(3731),
    [anon_sym_noreturn] = ACTIONS(3731),
    [anon_sym__Nonnull] = ACTIONS(3731),
    [anon_sym_mutable] = ACTIONS(3731),
    [anon_sym_constinit] = ACTIONS(3731),
    [anon_sym_consteval] = ACTIONS(3731),
    [anon_sym_alignas] = ACTIONS(3731),
    [anon_sym__Alignas] = ACTIONS(3731),
    [sym_primitive_type] = ACTIONS(3731),
    [anon_sym_enum] = ACTIONS(3731),
    [anon_sym_class] = ACTIONS(3731),
    [anon_sym_struct] = ACTIONS(3731),
    [anon_sym_union] = ACTIONS(3731),
    [anon_sym_if] = ACTIONS(3731),
    [anon_sym_switch] = ACTIONS(3731),
    [anon_sym_case] = ACTIONS(3731),
    [anon_sym_default] = ACTIONS(3731),
    [anon_sym_while] = ACTIONS(3731),
    [anon_sym_do] = ACTIONS(3731),
    [anon_sym_for] = ACTIONS(3731),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_break] = ACTIONS(3731),
    [anon_sym_continue] = ACTIONS(3731),
    [anon_sym_goto] = ACTIONS(3731),
    [anon_sym___try] = ACTIONS(3731),
    [anon_sym___leave] = ACTIONS(3731),
    [anon_sym_not] = ACTIONS(3731),
    [anon_sym_compl] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3733),
    [anon_sym_PLUS_PLUS] = ACTIONS(3733),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3731),
    [anon_sym___alignof] = ACTIONS(3731),
    [anon_sym__alignof] = ACTIONS(3731),
    [anon_sym_alignof] = ACTIONS(3731),
    [anon_sym__Alignof] = ACTIONS(3731),
    [anon_sym_offsetof] = ACTIONS(3731),
    [anon_sym__Generic] = ACTIONS(3731),
    [anon_sym_asm] = ACTIONS(3731),
    [anon_sym___asm__] = ACTIONS(3731),
    [anon_sym___asm] = ACTIONS(3731),
    [sym_number_literal] = ACTIONS(3733),
    [anon_sym_L_SQUOTE] = ACTIONS(3733),
    [anon_sym_u_SQUOTE] = ACTIONS(3733),
    [anon_sym_U_SQUOTE] = ACTIONS(3733),
    [anon_sym_u8_SQUOTE] = ACTIONS(3733),
    [anon_sym_SQUOTE] = ACTIONS(3733),
    [anon_sym_L_DQUOTE] = ACTIONS(3733),
    [anon_sym_u_DQUOTE] = ACTIONS(3733),
    [anon_sym_U_DQUOTE] = ACTIONS(3733),
    [anon_sym_u8_DQUOTE] = ACTIONS(3733),
    [anon_sym_DQUOTE] = ACTIONS(3733),
    [sym_true] = ACTIONS(3731),
    [sym_false] = ACTIONS(3731),
    [anon_sym_NULL] = ACTIONS(3731),
    [anon_sym_nullptr] = ACTIONS(3731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3731),
    [anon_sym_let] = ACTIONS(3731),
    [anon_sym_This] = ACTIONS(3731),
    [anon_sym_decltype] = ACTIONS(3731),
    [anon_sym_explicit] = ACTIONS(3731),
    [anon_sym_typename] = ACTIONS(3731),
    [anon_sym_template] = ACTIONS(3731),
    [anon_sym_operator] = ACTIONS(3731),
    [anon_sym_try] = ACTIONS(3731),
    [anon_sym_delete] = ACTIONS(3731),
    [anon_sym_throw] = ACTIONS(3731),
    [anon_sym_namespace] = ACTIONS(3731),
    [anon_sym_static_assert] = ACTIONS(3731),
    [anon_sym_concept] = ACTIONS(3731),
    [anon_sym_co_return] = ACTIONS(3731),
    [anon_sym_co_yield] = ACTIONS(3731),
    [anon_sym_R_DQUOTE] = ACTIONS(3733),
    [anon_sym_LR_DQUOTE] = ACTIONS(3733),
    [anon_sym_uR_DQUOTE] = ACTIONS(3733),
    [anon_sym_UR_DQUOTE] = ACTIONS(3733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3733),
    [anon_sym_co_await] = ACTIONS(3731),
    [anon_sym_new] = ACTIONS(3731),
    [anon_sym_requires] = ACTIONS(3731),
    [sym_this] = ACTIONS(3731),
    [anon_sym_discard] = ACTIONS(3731),
    [anon_sym_precise] = ACTIONS(3731),
    [anon_sym_shared] = ACTIONS(3731),
    [anon_sym_groupshared] = ACTIONS(3731),
    [anon_sym_uniform] = ACTIONS(3731),
    [anon_sym_row_major] = ACTIONS(3731),
    [anon_sym_column_major] = ACTIONS(3731),
    [anon_sym_globallycoherent] = ACTIONS(3731),
    [anon_sym_centroid] = ACTIONS(3731),
    [anon_sym_noperspective] = ACTIONS(3731),
    [anon_sym_nointerpolation] = ACTIONS(3731),
    [anon_sym_sample] = ACTIONS(3731),
    [anon_sym_linear] = ACTIONS(3731),
    [anon_sym_snorm] = ACTIONS(3731),
    [anon_sym_unorm] = ACTIONS(3731),
    [anon_sym_point] = ACTIONS(3731),
    [anon_sym_line] = ACTIONS(3731),
    [anon_sym_triangleadj] = ACTIONS(3731),
    [anon_sym_lineadj] = ACTIONS(3731),
    [anon_sym_triangle] = ACTIONS(3731),
    [anon_sym_cbuffer] = ACTIONS(3731),
    [anon_sym_interface] = ACTIONS(3731),
    [anon_sym_extension] = ACTIONS(3731),
  },
  [1105] = {
    [sym_identifier] = ACTIONS(3739),
    [aux_sym_preproc_include_token1] = ACTIONS(3739),
    [aux_sym_preproc_def_token1] = ACTIONS(3739),
    [aux_sym_preproc_if_token1] = ACTIONS(3739),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3739),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3739),
    [sym_preproc_directive] = ACTIONS(3739),
    [anon_sym_LPAREN2] = ACTIONS(3741),
    [anon_sym_BANG] = ACTIONS(3741),
    [anon_sym_TILDE] = ACTIONS(3741),
    [anon_sym_DASH] = ACTIONS(3739),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_STAR] = ACTIONS(3741),
    [anon_sym_AMP_AMP] = ACTIONS(3741),
    [anon_sym_AMP] = ACTIONS(3739),
    [anon_sym_SEMI] = ACTIONS(3741),
    [anon_sym___extension__] = ACTIONS(3739),
    [anon_sym_typedef] = ACTIONS(3739),
    [anon_sym_in] = ACTIONS(3739),
    [anon_sym_out] = ACTIONS(3739),
    [anon_sym_inout] = ACTIONS(3739),
    [anon_sym_virtual] = ACTIONS(3739),
    [anon_sym_extern] = ACTIONS(3739),
    [anon_sym___attribute__] = ACTIONS(3739),
    [anon_sym___attribute] = ACTIONS(3739),
    [anon_sym_using] = ACTIONS(3739),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3741),
    [anon_sym___declspec] = ACTIONS(3739),
    [anon_sym___based] = ACTIONS(3739),
    [anon_sym___cdecl] = ACTIONS(3739),
    [anon_sym___clrcall] = ACTIONS(3739),
    [anon_sym___stdcall] = ACTIONS(3739),
    [anon_sym___fastcall] = ACTIONS(3739),
    [anon_sym___thiscall] = ACTIONS(3739),
    [anon_sym___vectorcall] = ACTIONS(3739),
    [anon_sym_LBRACE] = ACTIONS(3741),
    [anon_sym_RBRACE] = ACTIONS(3741),
    [anon_sym_signed] = ACTIONS(3739),
    [anon_sym_unsigned] = ACTIONS(3739),
    [anon_sym_long] = ACTIONS(3739),
    [anon_sym_short] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3739),
    [anon_sym_static] = ACTIONS(3739),
    [anon_sym_register] = ACTIONS(3739),
    [anon_sym_inline] = ACTIONS(3739),
    [anon_sym___inline] = ACTIONS(3739),
    [anon_sym___inline__] = ACTIONS(3739),
    [anon_sym___forceinline] = ACTIONS(3739),
    [anon_sym_thread_local] = ACTIONS(3739),
    [anon_sym___thread] = ACTIONS(3739),
    [anon_sym_const] = ACTIONS(3739),
    [anon_sym_constexpr] = ACTIONS(3739),
    [anon_sym_volatile] = ACTIONS(3739),
    [anon_sym_restrict] = ACTIONS(3739),
    [anon_sym___restrict__] = ACTIONS(3739),
    [anon_sym__Atomic] = ACTIONS(3739),
    [anon_sym__Noreturn] = ACTIONS(3739),
    [anon_sym_noreturn] = ACTIONS(3739),
    [anon_sym__Nonnull] = ACTIONS(3739),
    [anon_sym_mutable] = ACTIONS(3739),
    [anon_sym_constinit] = ACTIONS(3739),
    [anon_sym_consteval] = ACTIONS(3739),
    [anon_sym_alignas] = ACTIONS(3739),
    [anon_sym__Alignas] = ACTIONS(3739),
    [sym_primitive_type] = ACTIONS(3739),
    [anon_sym_enum] = ACTIONS(3739),
    [anon_sym_class] = ACTIONS(3739),
    [anon_sym_struct] = ACTIONS(3739),
    [anon_sym_union] = ACTIONS(3739),
    [anon_sym_if] = ACTIONS(3739),
    [anon_sym_switch] = ACTIONS(3739),
    [anon_sym_case] = ACTIONS(3739),
    [anon_sym_default] = ACTIONS(3739),
    [anon_sym_while] = ACTIONS(3739),
    [anon_sym_do] = ACTIONS(3739),
    [anon_sym_for] = ACTIONS(3739),
    [anon_sym_return] = ACTIONS(3739),
    [anon_sym_break] = ACTIONS(3739),
    [anon_sym_continue] = ACTIONS(3739),
    [anon_sym_goto] = ACTIONS(3739),
    [anon_sym___try] = ACTIONS(3739),
    [anon_sym___leave] = ACTIONS(3739),
    [anon_sym_not] = ACTIONS(3739),
    [anon_sym_compl] = ACTIONS(3739),
    [anon_sym_DASH_DASH] = ACTIONS(3741),
    [anon_sym_PLUS_PLUS] = ACTIONS(3741),
    [anon_sym_sizeof] = ACTIONS(3739),
    [anon_sym___alignof__] = ACTIONS(3739),
    [anon_sym___alignof] = ACTIONS(3739),
    [anon_sym__alignof] = ACTIONS(3739),
    [anon_sym_alignof] = ACTIONS(3739),
    [anon_sym__Alignof] = ACTIONS(3739),
    [anon_sym_offsetof] = ACTIONS(3739),
    [anon_sym__Generic] = ACTIONS(3739),
    [anon_sym_asm] = ACTIONS(3739),
    [anon_sym___asm__] = ACTIONS(3739),
    [anon_sym___asm] = ACTIONS(3739),
    [sym_number_literal] = ACTIONS(3741),
    [anon_sym_L_SQUOTE] = ACTIONS(3741),
    [anon_sym_u_SQUOTE] = ACTIONS(3741),
    [anon_sym_U_SQUOTE] = ACTIONS(3741),
    [anon_sym_u8_SQUOTE] = ACTIONS(3741),
    [anon_sym_SQUOTE] = ACTIONS(3741),
    [anon_sym_L_DQUOTE] = ACTIONS(3741),
    [anon_sym_u_DQUOTE] = ACTIONS(3741),
    [anon_sym_U_DQUOTE] = ACTIONS(3741),
    [anon_sym_u8_DQUOTE] = ACTIONS(3741),
    [anon_sym_DQUOTE] = ACTIONS(3741),
    [sym_true] = ACTIONS(3739),
    [sym_false] = ACTIONS(3739),
    [anon_sym_NULL] = ACTIONS(3739),
    [anon_sym_nullptr] = ACTIONS(3739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3739),
    [anon_sym_let] = ACTIONS(3739),
    [anon_sym_This] = ACTIONS(3739),
    [anon_sym_decltype] = ACTIONS(3739),
    [anon_sym_explicit] = ACTIONS(3739),
    [anon_sym_typename] = ACTIONS(3739),
    [anon_sym_template] = ACTIONS(3739),
    [anon_sym_operator] = ACTIONS(3739),
    [anon_sym_try] = ACTIONS(3739),
    [anon_sym_delete] = ACTIONS(3739),
    [anon_sym_throw] = ACTIONS(3739),
    [anon_sym_namespace] = ACTIONS(3739),
    [anon_sym_static_assert] = ACTIONS(3739),
    [anon_sym_concept] = ACTIONS(3739),
    [anon_sym_co_return] = ACTIONS(3739),
    [anon_sym_co_yield] = ACTIONS(3739),
    [anon_sym_R_DQUOTE] = ACTIONS(3741),
    [anon_sym_LR_DQUOTE] = ACTIONS(3741),
    [anon_sym_uR_DQUOTE] = ACTIONS(3741),
    [anon_sym_UR_DQUOTE] = ACTIONS(3741),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3741),
    [anon_sym_co_await] = ACTIONS(3739),
    [anon_sym_new] = ACTIONS(3739),
    [anon_sym_requires] = ACTIONS(3739),
    [sym_this] = ACTIONS(3739),
    [anon_sym_discard] = ACTIONS(3739),
    [anon_sym_precise] = ACTIONS(3739),
    [anon_sym_shared] = ACTIONS(3739),
    [anon_sym_groupshared] = ACTIONS(3739),
    [anon_sym_uniform] = ACTIONS(3739),
    [anon_sym_row_major] = ACTIONS(3739),
    [anon_sym_column_major] = ACTIONS(3739),
    [anon_sym_globallycoherent] = ACTIONS(3739),
    [anon_sym_centroid] = ACTIONS(3739),
    [anon_sym_noperspective] = ACTIONS(3739),
    [anon_sym_nointerpolation] = ACTIONS(3739),
    [anon_sym_sample] = ACTIONS(3739),
    [anon_sym_linear] = ACTIONS(3739),
    [anon_sym_snorm] = ACTIONS(3739),
    [anon_sym_unorm] = ACTIONS(3739),
    [anon_sym_point] = ACTIONS(3739),
    [anon_sym_line] = ACTIONS(3739),
    [anon_sym_triangleadj] = ACTIONS(3739),
    [anon_sym_lineadj] = ACTIONS(3739),
    [anon_sym_triangle] = ACTIONS(3739),
    [anon_sym_cbuffer] = ACTIONS(3739),
    [anon_sym_interface] = ACTIONS(3739),
    [anon_sym_extension] = ACTIONS(3739),
  },
  [1106] = {
    [sym_identifier] = ACTIONS(3808),
    [aux_sym_preproc_include_token1] = ACTIONS(3808),
    [aux_sym_preproc_def_token1] = ACTIONS(3808),
    [aux_sym_preproc_if_token1] = ACTIONS(3808),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3808),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3808),
    [sym_preproc_directive] = ACTIONS(3808),
    [anon_sym_LPAREN2] = ACTIONS(3810),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [anon_sym_DASH] = ACTIONS(3808),
    [anon_sym_PLUS] = ACTIONS(3808),
    [anon_sym_STAR] = ACTIONS(3810),
    [anon_sym_AMP_AMP] = ACTIONS(3810),
    [anon_sym_AMP] = ACTIONS(3808),
    [anon_sym_SEMI] = ACTIONS(3810),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_typedef] = ACTIONS(3808),
    [anon_sym_in] = ACTIONS(3808),
    [anon_sym_out] = ACTIONS(3808),
    [anon_sym_inout] = ACTIONS(3808),
    [anon_sym_virtual] = ACTIONS(3808),
    [anon_sym_extern] = ACTIONS(3808),
    [anon_sym___attribute__] = ACTIONS(3808),
    [anon_sym___attribute] = ACTIONS(3808),
    [anon_sym_using] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3810),
    [anon_sym___declspec] = ACTIONS(3808),
    [anon_sym___based] = ACTIONS(3808),
    [anon_sym___cdecl] = ACTIONS(3808),
    [anon_sym___clrcall] = ACTIONS(3808),
    [anon_sym___stdcall] = ACTIONS(3808),
    [anon_sym___fastcall] = ACTIONS(3808),
    [anon_sym___thiscall] = ACTIONS(3808),
    [anon_sym___vectorcall] = ACTIONS(3808),
    [anon_sym_LBRACE] = ACTIONS(3810),
    [anon_sym_RBRACE] = ACTIONS(3810),
    [anon_sym_signed] = ACTIONS(3808),
    [anon_sym_unsigned] = ACTIONS(3808),
    [anon_sym_long] = ACTIONS(3808),
    [anon_sym_short] = ACTIONS(3808),
    [anon_sym_LBRACK] = ACTIONS(3808),
    [anon_sym_static] = ACTIONS(3808),
    [anon_sym_register] = ACTIONS(3808),
    [anon_sym_inline] = ACTIONS(3808),
    [anon_sym___inline] = ACTIONS(3808),
    [anon_sym___inline__] = ACTIONS(3808),
    [anon_sym___forceinline] = ACTIONS(3808),
    [anon_sym_thread_local] = ACTIONS(3808),
    [anon_sym___thread] = ACTIONS(3808),
    [anon_sym_const] = ACTIONS(3808),
    [anon_sym_constexpr] = ACTIONS(3808),
    [anon_sym_volatile] = ACTIONS(3808),
    [anon_sym_restrict] = ACTIONS(3808),
    [anon_sym___restrict__] = ACTIONS(3808),
    [anon_sym__Atomic] = ACTIONS(3808),
    [anon_sym__Noreturn] = ACTIONS(3808),
    [anon_sym_noreturn] = ACTIONS(3808),
    [anon_sym__Nonnull] = ACTIONS(3808),
    [anon_sym_mutable] = ACTIONS(3808),
    [anon_sym_constinit] = ACTIONS(3808),
    [anon_sym_consteval] = ACTIONS(3808),
    [anon_sym_alignas] = ACTIONS(3808),
    [anon_sym__Alignas] = ACTIONS(3808),
    [sym_primitive_type] = ACTIONS(3808),
    [anon_sym_enum] = ACTIONS(3808),
    [anon_sym_class] = ACTIONS(3808),
    [anon_sym_struct] = ACTIONS(3808),
    [anon_sym_union] = ACTIONS(3808),
    [anon_sym_if] = ACTIONS(3808),
    [anon_sym_switch] = ACTIONS(3808),
    [anon_sym_case] = ACTIONS(3808),
    [anon_sym_default] = ACTIONS(3808),
    [anon_sym_while] = ACTIONS(3808),
    [anon_sym_do] = ACTIONS(3808),
    [anon_sym_for] = ACTIONS(3808),
    [anon_sym_return] = ACTIONS(3808),
    [anon_sym_break] = ACTIONS(3808),
    [anon_sym_continue] = ACTIONS(3808),
    [anon_sym_goto] = ACTIONS(3808),
    [anon_sym___try] = ACTIONS(3808),
    [anon_sym___leave] = ACTIONS(3808),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_compl] = ACTIONS(3808),
    [anon_sym_DASH_DASH] = ACTIONS(3810),
    [anon_sym_PLUS_PLUS] = ACTIONS(3810),
    [anon_sym_sizeof] = ACTIONS(3808),
    [anon_sym___alignof__] = ACTIONS(3808),
    [anon_sym___alignof] = ACTIONS(3808),
    [anon_sym__alignof] = ACTIONS(3808),
    [anon_sym_alignof] = ACTIONS(3808),
    [anon_sym__Alignof] = ACTIONS(3808),
    [anon_sym_offsetof] = ACTIONS(3808),
    [anon_sym__Generic] = ACTIONS(3808),
    [anon_sym_asm] = ACTIONS(3808),
    [anon_sym___asm__] = ACTIONS(3808),
    [anon_sym___asm] = ACTIONS(3808),
    [sym_number_literal] = ACTIONS(3810),
    [anon_sym_L_SQUOTE] = ACTIONS(3810),
    [anon_sym_u_SQUOTE] = ACTIONS(3810),
    [anon_sym_U_SQUOTE] = ACTIONS(3810),
    [anon_sym_u8_SQUOTE] = ACTIONS(3810),
    [anon_sym_SQUOTE] = ACTIONS(3810),
    [anon_sym_L_DQUOTE] = ACTIONS(3810),
    [anon_sym_u_DQUOTE] = ACTIONS(3810),
    [anon_sym_U_DQUOTE] = ACTIONS(3810),
    [anon_sym_u8_DQUOTE] = ACTIONS(3810),
    [anon_sym_DQUOTE] = ACTIONS(3810),
    [sym_true] = ACTIONS(3808),
    [sym_false] = ACTIONS(3808),
    [anon_sym_NULL] = ACTIONS(3808),
    [anon_sym_nullptr] = ACTIONS(3808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3808),
    [anon_sym_let] = ACTIONS(3808),
    [anon_sym_This] = ACTIONS(3808),
    [anon_sym_decltype] = ACTIONS(3808),
    [anon_sym_explicit] = ACTIONS(3808),
    [anon_sym_typename] = ACTIONS(3808),
    [anon_sym_template] = ACTIONS(3808),
    [anon_sym_operator] = ACTIONS(3808),
    [anon_sym_try] = ACTIONS(3808),
    [anon_sym_delete] = ACTIONS(3808),
    [anon_sym_throw] = ACTIONS(3808),
    [anon_sym_namespace] = ACTIONS(3808),
    [anon_sym_static_assert] = ACTIONS(3808),
    [anon_sym_concept] = ACTIONS(3808),
    [anon_sym_co_return] = ACTIONS(3808),
    [anon_sym_co_yield] = ACTIONS(3808),
    [anon_sym_R_DQUOTE] = ACTIONS(3810),
    [anon_sym_LR_DQUOTE] = ACTIONS(3810),
    [anon_sym_uR_DQUOTE] = ACTIONS(3810),
    [anon_sym_UR_DQUOTE] = ACTIONS(3810),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3810),
    [anon_sym_co_await] = ACTIONS(3808),
    [anon_sym_new] = ACTIONS(3808),
    [anon_sym_requires] = ACTIONS(3808),
    [sym_this] = ACTIONS(3808),
    [anon_sym_discard] = ACTIONS(3808),
    [anon_sym_precise] = ACTIONS(3808),
    [anon_sym_shared] = ACTIONS(3808),
    [anon_sym_groupshared] = ACTIONS(3808),
    [anon_sym_uniform] = ACTIONS(3808),
    [anon_sym_row_major] = ACTIONS(3808),
    [anon_sym_column_major] = ACTIONS(3808),
    [anon_sym_globallycoherent] = ACTIONS(3808),
    [anon_sym_centroid] = ACTIONS(3808),
    [anon_sym_noperspective] = ACTIONS(3808),
    [anon_sym_nointerpolation] = ACTIONS(3808),
    [anon_sym_sample] = ACTIONS(3808),
    [anon_sym_linear] = ACTIONS(3808),
    [anon_sym_snorm] = ACTIONS(3808),
    [anon_sym_unorm] = ACTIONS(3808),
    [anon_sym_point] = ACTIONS(3808),
    [anon_sym_line] = ACTIONS(3808),
    [anon_sym_triangleadj] = ACTIONS(3808),
    [anon_sym_lineadj] = ACTIONS(3808),
    [anon_sym_triangle] = ACTIONS(3808),
    [anon_sym_cbuffer] = ACTIONS(3808),
    [anon_sym_interface] = ACTIONS(3808),
    [anon_sym_extension] = ACTIONS(3808),
  },
  [1107] = {
    [sym_identifier] = ACTIONS(3755),
    [aux_sym_preproc_include_token1] = ACTIONS(3755),
    [aux_sym_preproc_def_token1] = ACTIONS(3755),
    [aux_sym_preproc_if_token1] = ACTIONS(3755),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3755),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3755),
    [sym_preproc_directive] = ACTIONS(3755),
    [anon_sym_LPAREN2] = ACTIONS(3757),
    [anon_sym_BANG] = ACTIONS(3757),
    [anon_sym_TILDE] = ACTIONS(3757),
    [anon_sym_DASH] = ACTIONS(3755),
    [anon_sym_PLUS] = ACTIONS(3755),
    [anon_sym_STAR] = ACTIONS(3757),
    [anon_sym_AMP_AMP] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3755),
    [anon_sym_SEMI] = ACTIONS(3757),
    [anon_sym___extension__] = ACTIONS(3755),
    [anon_sym_typedef] = ACTIONS(3755),
    [anon_sym_in] = ACTIONS(3755),
    [anon_sym_out] = ACTIONS(3755),
    [anon_sym_inout] = ACTIONS(3755),
    [anon_sym_virtual] = ACTIONS(3755),
    [anon_sym_extern] = ACTIONS(3755),
    [anon_sym___attribute__] = ACTIONS(3755),
    [anon_sym___attribute] = ACTIONS(3755),
    [anon_sym_using] = ACTIONS(3755),
    [anon_sym_COLON_COLON] = ACTIONS(3757),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3757),
    [anon_sym___declspec] = ACTIONS(3755),
    [anon_sym___based] = ACTIONS(3755),
    [anon_sym___cdecl] = ACTIONS(3755),
    [anon_sym___clrcall] = ACTIONS(3755),
    [anon_sym___stdcall] = ACTIONS(3755),
    [anon_sym___fastcall] = ACTIONS(3755),
    [anon_sym___thiscall] = ACTIONS(3755),
    [anon_sym___vectorcall] = ACTIONS(3755),
    [anon_sym_LBRACE] = ACTIONS(3757),
    [anon_sym_RBRACE] = ACTIONS(3757),
    [anon_sym_signed] = ACTIONS(3755),
    [anon_sym_unsigned] = ACTIONS(3755),
    [anon_sym_long] = ACTIONS(3755),
    [anon_sym_short] = ACTIONS(3755),
    [anon_sym_LBRACK] = ACTIONS(3755),
    [anon_sym_static] = ACTIONS(3755),
    [anon_sym_register] = ACTIONS(3755),
    [anon_sym_inline] = ACTIONS(3755),
    [anon_sym___inline] = ACTIONS(3755),
    [anon_sym___inline__] = ACTIONS(3755),
    [anon_sym___forceinline] = ACTIONS(3755),
    [anon_sym_thread_local] = ACTIONS(3755),
    [anon_sym___thread] = ACTIONS(3755),
    [anon_sym_const] = ACTIONS(3755),
    [anon_sym_constexpr] = ACTIONS(3755),
    [anon_sym_volatile] = ACTIONS(3755),
    [anon_sym_restrict] = ACTIONS(3755),
    [anon_sym___restrict__] = ACTIONS(3755),
    [anon_sym__Atomic] = ACTIONS(3755),
    [anon_sym__Noreturn] = ACTIONS(3755),
    [anon_sym_noreturn] = ACTIONS(3755),
    [anon_sym__Nonnull] = ACTIONS(3755),
    [anon_sym_mutable] = ACTIONS(3755),
    [anon_sym_constinit] = ACTIONS(3755),
    [anon_sym_consteval] = ACTIONS(3755),
    [anon_sym_alignas] = ACTIONS(3755),
    [anon_sym__Alignas] = ACTIONS(3755),
    [sym_primitive_type] = ACTIONS(3755),
    [anon_sym_enum] = ACTIONS(3755),
    [anon_sym_class] = ACTIONS(3755),
    [anon_sym_struct] = ACTIONS(3755),
    [anon_sym_union] = ACTIONS(3755),
    [anon_sym_if] = ACTIONS(3755),
    [anon_sym_switch] = ACTIONS(3755),
    [anon_sym_case] = ACTIONS(3755),
    [anon_sym_default] = ACTIONS(3755),
    [anon_sym_while] = ACTIONS(3755),
    [anon_sym_do] = ACTIONS(3755),
    [anon_sym_for] = ACTIONS(3755),
    [anon_sym_return] = ACTIONS(3755),
    [anon_sym_break] = ACTIONS(3755),
    [anon_sym_continue] = ACTIONS(3755),
    [anon_sym_goto] = ACTIONS(3755),
    [anon_sym___try] = ACTIONS(3755),
    [anon_sym___leave] = ACTIONS(3755),
    [anon_sym_not] = ACTIONS(3755),
    [anon_sym_compl] = ACTIONS(3755),
    [anon_sym_DASH_DASH] = ACTIONS(3757),
    [anon_sym_PLUS_PLUS] = ACTIONS(3757),
    [anon_sym_sizeof] = ACTIONS(3755),
    [anon_sym___alignof__] = ACTIONS(3755),
    [anon_sym___alignof] = ACTIONS(3755),
    [anon_sym__alignof] = ACTIONS(3755),
    [anon_sym_alignof] = ACTIONS(3755),
    [anon_sym__Alignof] = ACTIONS(3755),
    [anon_sym_offsetof] = ACTIONS(3755),
    [anon_sym__Generic] = ACTIONS(3755),
    [anon_sym_asm] = ACTIONS(3755),
    [anon_sym___asm__] = ACTIONS(3755),
    [anon_sym___asm] = ACTIONS(3755),
    [sym_number_literal] = ACTIONS(3757),
    [anon_sym_L_SQUOTE] = ACTIONS(3757),
    [anon_sym_u_SQUOTE] = ACTIONS(3757),
    [anon_sym_U_SQUOTE] = ACTIONS(3757),
    [anon_sym_u8_SQUOTE] = ACTIONS(3757),
    [anon_sym_SQUOTE] = ACTIONS(3757),
    [anon_sym_L_DQUOTE] = ACTIONS(3757),
    [anon_sym_u_DQUOTE] = ACTIONS(3757),
    [anon_sym_U_DQUOTE] = ACTIONS(3757),
    [anon_sym_u8_DQUOTE] = ACTIONS(3757),
    [anon_sym_DQUOTE] = ACTIONS(3757),
    [sym_true] = ACTIONS(3755),
    [sym_false] = ACTIONS(3755),
    [anon_sym_NULL] = ACTIONS(3755),
    [anon_sym_nullptr] = ACTIONS(3755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3755),
    [anon_sym_let] = ACTIONS(3755),
    [anon_sym_This] = ACTIONS(3755),
    [anon_sym_decltype] = ACTIONS(3755),
    [anon_sym_explicit] = ACTIONS(3755),
    [anon_sym_typename] = ACTIONS(3755),
    [anon_sym_template] = ACTIONS(3755),
    [anon_sym_operator] = ACTIONS(3755),
    [anon_sym_try] = ACTIONS(3755),
    [anon_sym_delete] = ACTIONS(3755),
    [anon_sym_throw] = ACTIONS(3755),
    [anon_sym_namespace] = ACTIONS(3755),
    [anon_sym_static_assert] = ACTIONS(3755),
    [anon_sym_concept] = ACTIONS(3755),
    [anon_sym_co_return] = ACTIONS(3755),
    [anon_sym_co_yield] = ACTIONS(3755),
    [anon_sym_R_DQUOTE] = ACTIONS(3757),
    [anon_sym_LR_DQUOTE] = ACTIONS(3757),
    [anon_sym_uR_DQUOTE] = ACTIONS(3757),
    [anon_sym_UR_DQUOTE] = ACTIONS(3757),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3757),
    [anon_sym_co_await] = ACTIONS(3755),
    [anon_sym_new] = ACTIONS(3755),
    [anon_sym_requires] = ACTIONS(3755),
    [sym_this] = ACTIONS(3755),
    [anon_sym_discard] = ACTIONS(3755),
    [anon_sym_precise] = ACTIONS(3755),
    [anon_sym_shared] = ACTIONS(3755),
    [anon_sym_groupshared] = ACTIONS(3755),
    [anon_sym_uniform] = ACTIONS(3755),
    [anon_sym_row_major] = ACTIONS(3755),
    [anon_sym_column_major] = ACTIONS(3755),
    [anon_sym_globallycoherent] = ACTIONS(3755),
    [anon_sym_centroid] = ACTIONS(3755),
    [anon_sym_noperspective] = ACTIONS(3755),
    [anon_sym_nointerpolation] = ACTIONS(3755),
    [anon_sym_sample] = ACTIONS(3755),
    [anon_sym_linear] = ACTIONS(3755),
    [anon_sym_snorm] = ACTIONS(3755),
    [anon_sym_unorm] = ACTIONS(3755),
    [anon_sym_point] = ACTIONS(3755),
    [anon_sym_line] = ACTIONS(3755),
    [anon_sym_triangleadj] = ACTIONS(3755),
    [anon_sym_lineadj] = ACTIONS(3755),
    [anon_sym_triangle] = ACTIONS(3755),
    [anon_sym_cbuffer] = ACTIONS(3755),
    [anon_sym_interface] = ACTIONS(3755),
    [anon_sym_extension] = ACTIONS(3755),
  },
  [1108] = {
    [ts_builtin_sym_end] = ACTIONS(3671),
    [sym_identifier] = ACTIONS(3669),
    [aux_sym_preproc_include_token1] = ACTIONS(3669),
    [aux_sym_preproc_def_token1] = ACTIONS(3669),
    [aux_sym_preproc_if_token1] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3669),
    [sym_preproc_directive] = ACTIONS(3669),
    [anon_sym_LPAREN2] = ACTIONS(3671),
    [anon_sym_BANG] = ACTIONS(3671),
    [anon_sym_TILDE] = ACTIONS(3671),
    [anon_sym_DASH] = ACTIONS(3669),
    [anon_sym_PLUS] = ACTIONS(3669),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3671),
    [anon_sym_AMP] = ACTIONS(3669),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym___extension__] = ACTIONS(3669),
    [anon_sym_typedef] = ACTIONS(3669),
    [anon_sym_in] = ACTIONS(3669),
    [anon_sym_out] = ACTIONS(3669),
    [anon_sym_inout] = ACTIONS(3669),
    [anon_sym_virtual] = ACTIONS(3669),
    [anon_sym_extern] = ACTIONS(3669),
    [anon_sym___attribute__] = ACTIONS(3669),
    [anon_sym___attribute] = ACTIONS(3669),
    [anon_sym_using] = ACTIONS(3669),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3671),
    [anon_sym___declspec] = ACTIONS(3669),
    [anon_sym___based] = ACTIONS(3669),
    [anon_sym___cdecl] = ACTIONS(3669),
    [anon_sym___clrcall] = ACTIONS(3669),
    [anon_sym___stdcall] = ACTIONS(3669),
    [anon_sym___fastcall] = ACTIONS(3669),
    [anon_sym___thiscall] = ACTIONS(3669),
    [anon_sym___vectorcall] = ACTIONS(3669),
    [anon_sym_LBRACE] = ACTIONS(3671),
    [anon_sym_signed] = ACTIONS(3669),
    [anon_sym_unsigned] = ACTIONS(3669),
    [anon_sym_long] = ACTIONS(3669),
    [anon_sym_short] = ACTIONS(3669),
    [anon_sym_LBRACK] = ACTIONS(3669),
    [anon_sym_static] = ACTIONS(3669),
    [anon_sym_register] = ACTIONS(3669),
    [anon_sym_inline] = ACTIONS(3669),
    [anon_sym___inline] = ACTIONS(3669),
    [anon_sym___inline__] = ACTIONS(3669),
    [anon_sym___forceinline] = ACTIONS(3669),
    [anon_sym_thread_local] = ACTIONS(3669),
    [anon_sym___thread] = ACTIONS(3669),
    [anon_sym_const] = ACTIONS(3669),
    [anon_sym_constexpr] = ACTIONS(3669),
    [anon_sym_volatile] = ACTIONS(3669),
    [anon_sym_restrict] = ACTIONS(3669),
    [anon_sym___restrict__] = ACTIONS(3669),
    [anon_sym__Atomic] = ACTIONS(3669),
    [anon_sym__Noreturn] = ACTIONS(3669),
    [anon_sym_noreturn] = ACTIONS(3669),
    [anon_sym__Nonnull] = ACTIONS(3669),
    [anon_sym_mutable] = ACTIONS(3669),
    [anon_sym_constinit] = ACTIONS(3669),
    [anon_sym_consteval] = ACTIONS(3669),
    [anon_sym_alignas] = ACTIONS(3669),
    [anon_sym__Alignas] = ACTIONS(3669),
    [sym_primitive_type] = ACTIONS(3669),
    [anon_sym_enum] = ACTIONS(3669),
    [anon_sym_class] = ACTIONS(3669),
    [anon_sym_struct] = ACTIONS(3669),
    [anon_sym_union] = ACTIONS(3669),
    [anon_sym_if] = ACTIONS(3669),
    [anon_sym_switch] = ACTIONS(3669),
    [anon_sym_case] = ACTIONS(3669),
    [anon_sym_default] = ACTIONS(3669),
    [anon_sym_while] = ACTIONS(3669),
    [anon_sym_do] = ACTIONS(3669),
    [anon_sym_for] = ACTIONS(3669),
    [anon_sym_return] = ACTIONS(3669),
    [anon_sym_break] = ACTIONS(3669),
    [anon_sym_continue] = ACTIONS(3669),
    [anon_sym_goto] = ACTIONS(3669),
    [anon_sym_not] = ACTIONS(3669),
    [anon_sym_compl] = ACTIONS(3669),
    [anon_sym_DASH_DASH] = ACTIONS(3671),
    [anon_sym_PLUS_PLUS] = ACTIONS(3671),
    [anon_sym_sizeof] = ACTIONS(3669),
    [anon_sym___alignof__] = ACTIONS(3669),
    [anon_sym___alignof] = ACTIONS(3669),
    [anon_sym__alignof] = ACTIONS(3669),
    [anon_sym_alignof] = ACTIONS(3669),
    [anon_sym__Alignof] = ACTIONS(3669),
    [anon_sym_offsetof] = ACTIONS(3669),
    [anon_sym__Generic] = ACTIONS(3669),
    [anon_sym_asm] = ACTIONS(3669),
    [anon_sym___asm__] = ACTIONS(3669),
    [anon_sym___asm] = ACTIONS(3669),
    [sym_number_literal] = ACTIONS(3671),
    [anon_sym_L_SQUOTE] = ACTIONS(3671),
    [anon_sym_u_SQUOTE] = ACTIONS(3671),
    [anon_sym_U_SQUOTE] = ACTIONS(3671),
    [anon_sym_u8_SQUOTE] = ACTIONS(3671),
    [anon_sym_SQUOTE] = ACTIONS(3671),
    [anon_sym_L_DQUOTE] = ACTIONS(3671),
    [anon_sym_u_DQUOTE] = ACTIONS(3671),
    [anon_sym_U_DQUOTE] = ACTIONS(3671),
    [anon_sym_u8_DQUOTE] = ACTIONS(3671),
    [anon_sym_DQUOTE] = ACTIONS(3671),
    [sym_true] = ACTIONS(3669),
    [sym_false] = ACTIONS(3669),
    [anon_sym_NULL] = ACTIONS(3669),
    [anon_sym_nullptr] = ACTIONS(3669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3669),
    [anon_sym_let] = ACTIONS(3669),
    [anon_sym_This] = ACTIONS(3669),
    [anon_sym_decltype] = ACTIONS(3669),
    [anon_sym_explicit] = ACTIONS(3669),
    [anon_sym_typename] = ACTIONS(3669),
    [anon_sym_export] = ACTIONS(3669),
    [anon_sym_module] = ACTIONS(3669),
    [anon_sym_import] = ACTIONS(3669),
    [anon_sym_template] = ACTIONS(3669),
    [anon_sym_operator] = ACTIONS(3669),
    [anon_sym_try] = ACTIONS(3669),
    [anon_sym_delete] = ACTIONS(3669),
    [anon_sym_throw] = ACTIONS(3669),
    [anon_sym_namespace] = ACTIONS(3669),
    [anon_sym_static_assert] = ACTIONS(3669),
    [anon_sym_concept] = ACTIONS(3669),
    [anon_sym_co_return] = ACTIONS(3669),
    [anon_sym_co_yield] = ACTIONS(3669),
    [anon_sym_R_DQUOTE] = ACTIONS(3671),
    [anon_sym_LR_DQUOTE] = ACTIONS(3671),
    [anon_sym_uR_DQUOTE] = ACTIONS(3671),
    [anon_sym_UR_DQUOTE] = ACTIONS(3671),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3671),
    [anon_sym_co_await] = ACTIONS(3669),
    [anon_sym_new] = ACTIONS(3669),
    [anon_sym_requires] = ACTIONS(3669),
    [sym_this] = ACTIONS(3669),
    [anon_sym_precise] = ACTIONS(3669),
    [anon_sym_shared] = ACTIONS(3669),
    [anon_sym_groupshared] = ACTIONS(3669),
    [anon_sym_uniform] = ACTIONS(3669),
    [anon_sym_row_major] = ACTIONS(3669),
    [anon_sym_column_major] = ACTIONS(3669),
    [anon_sym_globallycoherent] = ACTIONS(3669),
    [anon_sym_centroid] = ACTIONS(3669),
    [anon_sym_noperspective] = ACTIONS(3669),
    [anon_sym_nointerpolation] = ACTIONS(3669),
    [anon_sym_sample] = ACTIONS(3669),
    [anon_sym_linear] = ACTIONS(3669),
    [anon_sym_snorm] = ACTIONS(3669),
    [anon_sym_unorm] = ACTIONS(3669),
    [anon_sym_point] = ACTIONS(3669),
    [anon_sym_line] = ACTIONS(3669),
    [anon_sym_triangleadj] = ACTIONS(3669),
    [anon_sym_lineadj] = ACTIONS(3669),
    [anon_sym_triangle] = ACTIONS(3669),
    [anon_sym_interface] = ACTIONS(3669),
    [anon_sym_extension] = ACTIONS(3669),
    [anon_sym___exported] = ACTIONS(3669),
  },
  [1109] = {
    [ts_builtin_sym_end] = ACTIONS(4369),
    [sym_identifier] = ACTIONS(4371),
    [aux_sym_preproc_include_token1] = ACTIONS(4371),
    [aux_sym_preproc_def_token1] = ACTIONS(4371),
    [aux_sym_preproc_if_token1] = ACTIONS(4371),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4371),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4371),
    [sym_preproc_directive] = ACTIONS(4371),
    [anon_sym_LPAREN2] = ACTIONS(4369),
    [anon_sym_BANG] = ACTIONS(4369),
    [anon_sym_TILDE] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4371),
    [anon_sym_PLUS] = ACTIONS(4371),
    [anon_sym_STAR] = ACTIONS(4369),
    [anon_sym_AMP_AMP] = ACTIONS(4369),
    [anon_sym_AMP] = ACTIONS(4371),
    [anon_sym_SEMI] = ACTIONS(4369),
    [anon_sym___extension__] = ACTIONS(4371),
    [anon_sym_typedef] = ACTIONS(4371),
    [anon_sym_in] = ACTIONS(4371),
    [anon_sym_out] = ACTIONS(4371),
    [anon_sym_inout] = ACTIONS(4371),
    [anon_sym_virtual] = ACTIONS(4371),
    [anon_sym_extern] = ACTIONS(4371),
    [anon_sym___attribute__] = ACTIONS(4371),
    [anon_sym___attribute] = ACTIONS(4371),
    [anon_sym_using] = ACTIONS(4371),
    [anon_sym_COLON_COLON] = ACTIONS(4369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4369),
    [anon_sym___declspec] = ACTIONS(4371),
    [anon_sym___based] = ACTIONS(4371),
    [anon_sym___cdecl] = ACTIONS(4371),
    [anon_sym___clrcall] = ACTIONS(4371),
    [anon_sym___stdcall] = ACTIONS(4371),
    [anon_sym___fastcall] = ACTIONS(4371),
    [anon_sym___thiscall] = ACTIONS(4371),
    [anon_sym___vectorcall] = ACTIONS(4371),
    [anon_sym_LBRACE] = ACTIONS(4369),
    [anon_sym_signed] = ACTIONS(4371),
    [anon_sym_unsigned] = ACTIONS(4371),
    [anon_sym_long] = ACTIONS(4371),
    [anon_sym_short] = ACTIONS(4371),
    [anon_sym_LBRACK] = ACTIONS(4371),
    [anon_sym_static] = ACTIONS(4371),
    [anon_sym_register] = ACTIONS(4371),
    [anon_sym_inline] = ACTIONS(4371),
    [anon_sym___inline] = ACTIONS(4371),
    [anon_sym___inline__] = ACTIONS(4371),
    [anon_sym___forceinline] = ACTIONS(4371),
    [anon_sym_thread_local] = ACTIONS(4371),
    [anon_sym___thread] = ACTIONS(4371),
    [anon_sym_const] = ACTIONS(4371),
    [anon_sym_constexpr] = ACTIONS(4371),
    [anon_sym_volatile] = ACTIONS(4371),
    [anon_sym_restrict] = ACTIONS(4371),
    [anon_sym___restrict__] = ACTIONS(4371),
    [anon_sym__Atomic] = ACTIONS(4371),
    [anon_sym__Noreturn] = ACTIONS(4371),
    [anon_sym_noreturn] = ACTIONS(4371),
    [anon_sym__Nonnull] = ACTIONS(4371),
    [anon_sym_mutable] = ACTIONS(4371),
    [anon_sym_constinit] = ACTIONS(4371),
    [anon_sym_consteval] = ACTIONS(4371),
    [anon_sym_alignas] = ACTIONS(4371),
    [anon_sym__Alignas] = ACTIONS(4371),
    [sym_primitive_type] = ACTIONS(4371),
    [anon_sym_enum] = ACTIONS(4371),
    [anon_sym_class] = ACTIONS(4371),
    [anon_sym_struct] = ACTIONS(4371),
    [anon_sym_union] = ACTIONS(4371),
    [anon_sym_if] = ACTIONS(4371),
    [anon_sym_switch] = ACTIONS(4371),
    [anon_sym_case] = ACTIONS(4371),
    [anon_sym_default] = ACTIONS(4371),
    [anon_sym_while] = ACTIONS(4371),
    [anon_sym_do] = ACTIONS(4371),
    [anon_sym_for] = ACTIONS(4371),
    [anon_sym_return] = ACTIONS(4371),
    [anon_sym_break] = ACTIONS(4371),
    [anon_sym_continue] = ACTIONS(4371),
    [anon_sym_goto] = ACTIONS(4371),
    [anon_sym_not] = ACTIONS(4371),
    [anon_sym_compl] = ACTIONS(4371),
    [anon_sym_DASH_DASH] = ACTIONS(4369),
    [anon_sym_PLUS_PLUS] = ACTIONS(4369),
    [anon_sym_sizeof] = ACTIONS(4371),
    [anon_sym___alignof__] = ACTIONS(4371),
    [anon_sym___alignof] = ACTIONS(4371),
    [anon_sym__alignof] = ACTIONS(4371),
    [anon_sym_alignof] = ACTIONS(4371),
    [anon_sym__Alignof] = ACTIONS(4371),
    [anon_sym_offsetof] = ACTIONS(4371),
    [anon_sym__Generic] = ACTIONS(4371),
    [anon_sym_asm] = ACTIONS(4371),
    [anon_sym___asm__] = ACTIONS(4371),
    [anon_sym___asm] = ACTIONS(4371),
    [sym_number_literal] = ACTIONS(4369),
    [anon_sym_L_SQUOTE] = ACTIONS(4369),
    [anon_sym_u_SQUOTE] = ACTIONS(4369),
    [anon_sym_U_SQUOTE] = ACTIONS(4369),
    [anon_sym_u8_SQUOTE] = ACTIONS(4369),
    [anon_sym_SQUOTE] = ACTIONS(4369),
    [anon_sym_L_DQUOTE] = ACTIONS(4369),
    [anon_sym_u_DQUOTE] = ACTIONS(4369),
    [anon_sym_U_DQUOTE] = ACTIONS(4369),
    [anon_sym_u8_DQUOTE] = ACTIONS(4369),
    [anon_sym_DQUOTE] = ACTIONS(4369),
    [sym_true] = ACTIONS(4371),
    [sym_false] = ACTIONS(4371),
    [anon_sym_NULL] = ACTIONS(4371),
    [anon_sym_nullptr] = ACTIONS(4371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4371),
    [anon_sym_let] = ACTIONS(4371),
    [anon_sym_This] = ACTIONS(4371),
    [anon_sym_decltype] = ACTIONS(4371),
    [anon_sym_explicit] = ACTIONS(4371),
    [anon_sym_typename] = ACTIONS(4371),
    [anon_sym_export] = ACTIONS(4371),
    [anon_sym_module] = ACTIONS(4371),
    [anon_sym_import] = ACTIONS(4371),
    [anon_sym_template] = ACTIONS(4371),
    [anon_sym_operator] = ACTIONS(4371),
    [anon_sym_try] = ACTIONS(4371),
    [anon_sym_delete] = ACTIONS(4371),
    [anon_sym_throw] = ACTIONS(4371),
    [anon_sym_namespace] = ACTIONS(4371),
    [anon_sym_static_assert] = ACTIONS(4371),
    [anon_sym_concept] = ACTIONS(4371),
    [anon_sym_co_return] = ACTIONS(4371),
    [anon_sym_co_yield] = ACTIONS(4371),
    [anon_sym_R_DQUOTE] = ACTIONS(4369),
    [anon_sym_LR_DQUOTE] = ACTIONS(4369),
    [anon_sym_uR_DQUOTE] = ACTIONS(4369),
    [anon_sym_UR_DQUOTE] = ACTIONS(4369),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4369),
    [anon_sym_co_await] = ACTIONS(4371),
    [anon_sym_new] = ACTIONS(4371),
    [anon_sym_requires] = ACTIONS(4371),
    [sym_this] = ACTIONS(4371),
    [anon_sym_precise] = ACTIONS(4371),
    [anon_sym_shared] = ACTIONS(4371),
    [anon_sym_groupshared] = ACTIONS(4371),
    [anon_sym_uniform] = ACTIONS(4371),
    [anon_sym_row_major] = ACTIONS(4371),
    [anon_sym_column_major] = ACTIONS(4371),
    [anon_sym_globallycoherent] = ACTIONS(4371),
    [anon_sym_centroid] = ACTIONS(4371),
    [anon_sym_noperspective] = ACTIONS(4371),
    [anon_sym_nointerpolation] = ACTIONS(4371),
    [anon_sym_sample] = ACTIONS(4371),
    [anon_sym_linear] = ACTIONS(4371),
    [anon_sym_snorm] = ACTIONS(4371),
    [anon_sym_unorm] = ACTIONS(4371),
    [anon_sym_point] = ACTIONS(4371),
    [anon_sym_line] = ACTIONS(4371),
    [anon_sym_triangleadj] = ACTIONS(4371),
    [anon_sym_lineadj] = ACTIONS(4371),
    [anon_sym_triangle] = ACTIONS(4371),
    [anon_sym_interface] = ACTIONS(4371),
    [anon_sym_extension] = ACTIONS(4371),
    [anon_sym___exported] = ACTIONS(4371),
  },
  [1110] = {
    [ts_builtin_sym_end] = ACTIONS(4373),
    [sym_identifier] = ACTIONS(4375),
    [aux_sym_preproc_include_token1] = ACTIONS(4375),
    [aux_sym_preproc_def_token1] = ACTIONS(4375),
    [aux_sym_preproc_if_token1] = ACTIONS(4375),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4375),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4375),
    [sym_preproc_directive] = ACTIONS(4375),
    [anon_sym_LPAREN2] = ACTIONS(4373),
    [anon_sym_BANG] = ACTIONS(4373),
    [anon_sym_TILDE] = ACTIONS(4373),
    [anon_sym_DASH] = ACTIONS(4375),
    [anon_sym_PLUS] = ACTIONS(4375),
    [anon_sym_STAR] = ACTIONS(4373),
    [anon_sym_AMP_AMP] = ACTIONS(4373),
    [anon_sym_AMP] = ACTIONS(4375),
    [anon_sym_SEMI] = ACTIONS(4373),
    [anon_sym___extension__] = ACTIONS(4375),
    [anon_sym_typedef] = ACTIONS(4375),
    [anon_sym_in] = ACTIONS(4375),
    [anon_sym_out] = ACTIONS(4375),
    [anon_sym_inout] = ACTIONS(4375),
    [anon_sym_virtual] = ACTIONS(4375),
    [anon_sym_extern] = ACTIONS(4375),
    [anon_sym___attribute__] = ACTIONS(4375),
    [anon_sym___attribute] = ACTIONS(4375),
    [anon_sym_using] = ACTIONS(4375),
    [anon_sym_COLON_COLON] = ACTIONS(4373),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4373),
    [anon_sym___declspec] = ACTIONS(4375),
    [anon_sym___based] = ACTIONS(4375),
    [anon_sym___cdecl] = ACTIONS(4375),
    [anon_sym___clrcall] = ACTIONS(4375),
    [anon_sym___stdcall] = ACTIONS(4375),
    [anon_sym___fastcall] = ACTIONS(4375),
    [anon_sym___thiscall] = ACTIONS(4375),
    [anon_sym___vectorcall] = ACTIONS(4375),
    [anon_sym_LBRACE] = ACTIONS(4373),
    [anon_sym_signed] = ACTIONS(4375),
    [anon_sym_unsigned] = ACTIONS(4375),
    [anon_sym_long] = ACTIONS(4375),
    [anon_sym_short] = ACTIONS(4375),
    [anon_sym_LBRACK] = ACTIONS(4375),
    [anon_sym_static] = ACTIONS(4375),
    [anon_sym_register] = ACTIONS(4375),
    [anon_sym_inline] = ACTIONS(4375),
    [anon_sym___inline] = ACTIONS(4375),
    [anon_sym___inline__] = ACTIONS(4375),
    [anon_sym___forceinline] = ACTIONS(4375),
    [anon_sym_thread_local] = ACTIONS(4375),
    [anon_sym___thread] = ACTIONS(4375),
    [anon_sym_const] = ACTIONS(4375),
    [anon_sym_constexpr] = ACTIONS(4375),
    [anon_sym_volatile] = ACTIONS(4375),
    [anon_sym_restrict] = ACTIONS(4375),
    [anon_sym___restrict__] = ACTIONS(4375),
    [anon_sym__Atomic] = ACTIONS(4375),
    [anon_sym__Noreturn] = ACTIONS(4375),
    [anon_sym_noreturn] = ACTIONS(4375),
    [anon_sym__Nonnull] = ACTIONS(4375),
    [anon_sym_mutable] = ACTIONS(4375),
    [anon_sym_constinit] = ACTIONS(4375),
    [anon_sym_consteval] = ACTIONS(4375),
    [anon_sym_alignas] = ACTIONS(4375),
    [anon_sym__Alignas] = ACTIONS(4375),
    [sym_primitive_type] = ACTIONS(4375),
    [anon_sym_enum] = ACTIONS(4375),
    [anon_sym_class] = ACTIONS(4375),
    [anon_sym_struct] = ACTIONS(4375),
    [anon_sym_union] = ACTIONS(4375),
    [anon_sym_if] = ACTIONS(4375),
    [anon_sym_switch] = ACTIONS(4375),
    [anon_sym_case] = ACTIONS(4375),
    [anon_sym_default] = ACTIONS(4375),
    [anon_sym_while] = ACTIONS(4375),
    [anon_sym_do] = ACTIONS(4375),
    [anon_sym_for] = ACTIONS(4375),
    [anon_sym_return] = ACTIONS(4375),
    [anon_sym_break] = ACTIONS(4375),
    [anon_sym_continue] = ACTIONS(4375),
    [anon_sym_goto] = ACTIONS(4375),
    [anon_sym_not] = ACTIONS(4375),
    [anon_sym_compl] = ACTIONS(4375),
    [anon_sym_DASH_DASH] = ACTIONS(4373),
    [anon_sym_PLUS_PLUS] = ACTIONS(4373),
    [anon_sym_sizeof] = ACTIONS(4375),
    [anon_sym___alignof__] = ACTIONS(4375),
    [anon_sym___alignof] = ACTIONS(4375),
    [anon_sym__alignof] = ACTIONS(4375),
    [anon_sym_alignof] = ACTIONS(4375),
    [anon_sym__Alignof] = ACTIONS(4375),
    [anon_sym_offsetof] = ACTIONS(4375),
    [anon_sym__Generic] = ACTIONS(4375),
    [anon_sym_asm] = ACTIONS(4375),
    [anon_sym___asm__] = ACTIONS(4375),
    [anon_sym___asm] = ACTIONS(4375),
    [sym_number_literal] = ACTIONS(4373),
    [anon_sym_L_SQUOTE] = ACTIONS(4373),
    [anon_sym_u_SQUOTE] = ACTIONS(4373),
    [anon_sym_U_SQUOTE] = ACTIONS(4373),
    [anon_sym_u8_SQUOTE] = ACTIONS(4373),
    [anon_sym_SQUOTE] = ACTIONS(4373),
    [anon_sym_L_DQUOTE] = ACTIONS(4373),
    [anon_sym_u_DQUOTE] = ACTIONS(4373),
    [anon_sym_U_DQUOTE] = ACTIONS(4373),
    [anon_sym_u8_DQUOTE] = ACTIONS(4373),
    [anon_sym_DQUOTE] = ACTIONS(4373),
    [sym_true] = ACTIONS(4375),
    [sym_false] = ACTIONS(4375),
    [anon_sym_NULL] = ACTIONS(4375),
    [anon_sym_nullptr] = ACTIONS(4375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4375),
    [anon_sym_let] = ACTIONS(4375),
    [anon_sym_This] = ACTIONS(4375),
    [anon_sym_decltype] = ACTIONS(4375),
    [anon_sym_explicit] = ACTIONS(4375),
    [anon_sym_typename] = ACTIONS(4375),
    [anon_sym_export] = ACTIONS(4375),
    [anon_sym_module] = ACTIONS(4375),
    [anon_sym_import] = ACTIONS(4375),
    [anon_sym_template] = ACTIONS(4375),
    [anon_sym_operator] = ACTIONS(4375),
    [anon_sym_try] = ACTIONS(4375),
    [anon_sym_delete] = ACTIONS(4375),
    [anon_sym_throw] = ACTIONS(4375),
    [anon_sym_namespace] = ACTIONS(4375),
    [anon_sym_static_assert] = ACTIONS(4375),
    [anon_sym_concept] = ACTIONS(4375),
    [anon_sym_co_return] = ACTIONS(4375),
    [anon_sym_co_yield] = ACTIONS(4375),
    [anon_sym_R_DQUOTE] = ACTIONS(4373),
    [anon_sym_LR_DQUOTE] = ACTIONS(4373),
    [anon_sym_uR_DQUOTE] = ACTIONS(4373),
    [anon_sym_UR_DQUOTE] = ACTIONS(4373),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4373),
    [anon_sym_co_await] = ACTIONS(4375),
    [anon_sym_new] = ACTIONS(4375),
    [anon_sym_requires] = ACTIONS(4375),
    [sym_this] = ACTIONS(4375),
    [anon_sym_precise] = ACTIONS(4375),
    [anon_sym_shared] = ACTIONS(4375),
    [anon_sym_groupshared] = ACTIONS(4375),
    [anon_sym_uniform] = ACTIONS(4375),
    [anon_sym_row_major] = ACTIONS(4375),
    [anon_sym_column_major] = ACTIONS(4375),
    [anon_sym_globallycoherent] = ACTIONS(4375),
    [anon_sym_centroid] = ACTIONS(4375),
    [anon_sym_noperspective] = ACTIONS(4375),
    [anon_sym_nointerpolation] = ACTIONS(4375),
    [anon_sym_sample] = ACTIONS(4375),
    [anon_sym_linear] = ACTIONS(4375),
    [anon_sym_snorm] = ACTIONS(4375),
    [anon_sym_unorm] = ACTIONS(4375),
    [anon_sym_point] = ACTIONS(4375),
    [anon_sym_line] = ACTIONS(4375),
    [anon_sym_triangleadj] = ACTIONS(4375),
    [anon_sym_lineadj] = ACTIONS(4375),
    [anon_sym_triangle] = ACTIONS(4375),
    [anon_sym_interface] = ACTIONS(4375),
    [anon_sym_extension] = ACTIONS(4375),
    [anon_sym___exported] = ACTIONS(4375),
  },
  [1111] = {
    [ts_builtin_sym_end] = ACTIONS(4377),
    [sym_identifier] = ACTIONS(4379),
    [aux_sym_preproc_include_token1] = ACTIONS(4379),
    [aux_sym_preproc_def_token1] = ACTIONS(4379),
    [aux_sym_preproc_if_token1] = ACTIONS(4379),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4379),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4379),
    [sym_preproc_directive] = ACTIONS(4379),
    [anon_sym_LPAREN2] = ACTIONS(4377),
    [anon_sym_BANG] = ACTIONS(4377),
    [anon_sym_TILDE] = ACTIONS(4377),
    [anon_sym_DASH] = ACTIONS(4379),
    [anon_sym_PLUS] = ACTIONS(4379),
    [anon_sym_STAR] = ACTIONS(4377),
    [anon_sym_AMP_AMP] = ACTIONS(4377),
    [anon_sym_AMP] = ACTIONS(4379),
    [anon_sym_SEMI] = ACTIONS(4377),
    [anon_sym___extension__] = ACTIONS(4379),
    [anon_sym_typedef] = ACTIONS(4379),
    [anon_sym_in] = ACTIONS(4379),
    [anon_sym_out] = ACTIONS(4379),
    [anon_sym_inout] = ACTIONS(4379),
    [anon_sym_virtual] = ACTIONS(4379),
    [anon_sym_extern] = ACTIONS(4379),
    [anon_sym___attribute__] = ACTIONS(4379),
    [anon_sym___attribute] = ACTIONS(4379),
    [anon_sym_using] = ACTIONS(4379),
    [anon_sym_COLON_COLON] = ACTIONS(4377),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4377),
    [anon_sym___declspec] = ACTIONS(4379),
    [anon_sym___based] = ACTIONS(4379),
    [anon_sym___cdecl] = ACTIONS(4379),
    [anon_sym___clrcall] = ACTIONS(4379),
    [anon_sym___stdcall] = ACTIONS(4379),
    [anon_sym___fastcall] = ACTIONS(4379),
    [anon_sym___thiscall] = ACTIONS(4379),
    [anon_sym___vectorcall] = ACTIONS(4379),
    [anon_sym_LBRACE] = ACTIONS(4377),
    [anon_sym_signed] = ACTIONS(4379),
    [anon_sym_unsigned] = ACTIONS(4379),
    [anon_sym_long] = ACTIONS(4379),
    [anon_sym_short] = ACTIONS(4379),
    [anon_sym_LBRACK] = ACTIONS(4379),
    [anon_sym_static] = ACTIONS(4379),
    [anon_sym_register] = ACTIONS(4379),
    [anon_sym_inline] = ACTIONS(4379),
    [anon_sym___inline] = ACTIONS(4379),
    [anon_sym___inline__] = ACTIONS(4379),
    [anon_sym___forceinline] = ACTIONS(4379),
    [anon_sym_thread_local] = ACTIONS(4379),
    [anon_sym___thread] = ACTIONS(4379),
    [anon_sym_const] = ACTIONS(4379),
    [anon_sym_constexpr] = ACTIONS(4379),
    [anon_sym_volatile] = ACTIONS(4379),
    [anon_sym_restrict] = ACTIONS(4379),
    [anon_sym___restrict__] = ACTIONS(4379),
    [anon_sym__Atomic] = ACTIONS(4379),
    [anon_sym__Noreturn] = ACTIONS(4379),
    [anon_sym_noreturn] = ACTIONS(4379),
    [anon_sym__Nonnull] = ACTIONS(4379),
    [anon_sym_mutable] = ACTIONS(4379),
    [anon_sym_constinit] = ACTIONS(4379),
    [anon_sym_consteval] = ACTIONS(4379),
    [anon_sym_alignas] = ACTIONS(4379),
    [anon_sym__Alignas] = ACTIONS(4379),
    [sym_primitive_type] = ACTIONS(4379),
    [anon_sym_enum] = ACTIONS(4379),
    [anon_sym_class] = ACTIONS(4379),
    [anon_sym_struct] = ACTIONS(4379),
    [anon_sym_union] = ACTIONS(4379),
    [anon_sym_if] = ACTIONS(4379),
    [anon_sym_switch] = ACTIONS(4379),
    [anon_sym_case] = ACTIONS(4379),
    [anon_sym_default] = ACTIONS(4379),
    [anon_sym_while] = ACTIONS(4379),
    [anon_sym_do] = ACTIONS(4379),
    [anon_sym_for] = ACTIONS(4379),
    [anon_sym_return] = ACTIONS(4379),
    [anon_sym_break] = ACTIONS(4379),
    [anon_sym_continue] = ACTIONS(4379),
    [anon_sym_goto] = ACTIONS(4379),
    [anon_sym_not] = ACTIONS(4379),
    [anon_sym_compl] = ACTIONS(4379),
    [anon_sym_DASH_DASH] = ACTIONS(4377),
    [anon_sym_PLUS_PLUS] = ACTIONS(4377),
    [anon_sym_sizeof] = ACTIONS(4379),
    [anon_sym___alignof__] = ACTIONS(4379),
    [anon_sym___alignof] = ACTIONS(4379),
    [anon_sym__alignof] = ACTIONS(4379),
    [anon_sym_alignof] = ACTIONS(4379),
    [anon_sym__Alignof] = ACTIONS(4379),
    [anon_sym_offsetof] = ACTIONS(4379),
    [anon_sym__Generic] = ACTIONS(4379),
    [anon_sym_asm] = ACTIONS(4379),
    [anon_sym___asm__] = ACTIONS(4379),
    [anon_sym___asm] = ACTIONS(4379),
    [sym_number_literal] = ACTIONS(4377),
    [anon_sym_L_SQUOTE] = ACTIONS(4377),
    [anon_sym_u_SQUOTE] = ACTIONS(4377),
    [anon_sym_U_SQUOTE] = ACTIONS(4377),
    [anon_sym_u8_SQUOTE] = ACTIONS(4377),
    [anon_sym_SQUOTE] = ACTIONS(4377),
    [anon_sym_L_DQUOTE] = ACTIONS(4377),
    [anon_sym_u_DQUOTE] = ACTIONS(4377),
    [anon_sym_U_DQUOTE] = ACTIONS(4377),
    [anon_sym_u8_DQUOTE] = ACTIONS(4377),
    [anon_sym_DQUOTE] = ACTIONS(4377),
    [sym_true] = ACTIONS(4379),
    [sym_false] = ACTIONS(4379),
    [anon_sym_NULL] = ACTIONS(4379),
    [anon_sym_nullptr] = ACTIONS(4379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4379),
    [anon_sym_let] = ACTIONS(4379),
    [anon_sym_This] = ACTIONS(4379),
    [anon_sym_decltype] = ACTIONS(4379),
    [anon_sym_explicit] = ACTIONS(4379),
    [anon_sym_typename] = ACTIONS(4379),
    [anon_sym_export] = ACTIONS(4379),
    [anon_sym_module] = ACTIONS(4379),
    [anon_sym_import] = ACTIONS(4379),
    [anon_sym_template] = ACTIONS(4379),
    [anon_sym_operator] = ACTIONS(4379),
    [anon_sym_try] = ACTIONS(4379),
    [anon_sym_delete] = ACTIONS(4379),
    [anon_sym_throw] = ACTIONS(4379),
    [anon_sym_namespace] = ACTIONS(4379),
    [anon_sym_static_assert] = ACTIONS(4379),
    [anon_sym_concept] = ACTIONS(4379),
    [anon_sym_co_return] = ACTIONS(4379),
    [anon_sym_co_yield] = ACTIONS(4379),
    [anon_sym_R_DQUOTE] = ACTIONS(4377),
    [anon_sym_LR_DQUOTE] = ACTIONS(4377),
    [anon_sym_uR_DQUOTE] = ACTIONS(4377),
    [anon_sym_UR_DQUOTE] = ACTIONS(4377),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4377),
    [anon_sym_co_await] = ACTIONS(4379),
    [anon_sym_new] = ACTIONS(4379),
    [anon_sym_requires] = ACTIONS(4379),
    [sym_this] = ACTIONS(4379),
    [anon_sym_precise] = ACTIONS(4379),
    [anon_sym_shared] = ACTIONS(4379),
    [anon_sym_groupshared] = ACTIONS(4379),
    [anon_sym_uniform] = ACTIONS(4379),
    [anon_sym_row_major] = ACTIONS(4379),
    [anon_sym_column_major] = ACTIONS(4379),
    [anon_sym_globallycoherent] = ACTIONS(4379),
    [anon_sym_centroid] = ACTIONS(4379),
    [anon_sym_noperspective] = ACTIONS(4379),
    [anon_sym_nointerpolation] = ACTIONS(4379),
    [anon_sym_sample] = ACTIONS(4379),
    [anon_sym_linear] = ACTIONS(4379),
    [anon_sym_snorm] = ACTIONS(4379),
    [anon_sym_unorm] = ACTIONS(4379),
    [anon_sym_point] = ACTIONS(4379),
    [anon_sym_line] = ACTIONS(4379),
    [anon_sym_triangleadj] = ACTIONS(4379),
    [anon_sym_lineadj] = ACTIONS(4379),
    [anon_sym_triangle] = ACTIONS(4379),
    [anon_sym_interface] = ACTIONS(4379),
    [anon_sym_extension] = ACTIONS(4379),
    [anon_sym___exported] = ACTIONS(4379),
  },
  [1112] = {
    [ts_builtin_sym_end] = ACTIONS(4381),
    [sym_identifier] = ACTIONS(4383),
    [aux_sym_preproc_include_token1] = ACTIONS(4383),
    [aux_sym_preproc_def_token1] = ACTIONS(4383),
    [aux_sym_preproc_if_token1] = ACTIONS(4383),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4383),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4383),
    [sym_preproc_directive] = ACTIONS(4383),
    [anon_sym_LPAREN2] = ACTIONS(4381),
    [anon_sym_BANG] = ACTIONS(4381),
    [anon_sym_TILDE] = ACTIONS(4381),
    [anon_sym_DASH] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_STAR] = ACTIONS(4381),
    [anon_sym_AMP_AMP] = ACTIONS(4381),
    [anon_sym_AMP] = ACTIONS(4383),
    [anon_sym_SEMI] = ACTIONS(4381),
    [anon_sym___extension__] = ACTIONS(4383),
    [anon_sym_typedef] = ACTIONS(4383),
    [anon_sym_in] = ACTIONS(4383),
    [anon_sym_out] = ACTIONS(4383),
    [anon_sym_inout] = ACTIONS(4383),
    [anon_sym_virtual] = ACTIONS(4383),
    [anon_sym_extern] = ACTIONS(4383),
    [anon_sym___attribute__] = ACTIONS(4383),
    [anon_sym___attribute] = ACTIONS(4383),
    [anon_sym_using] = ACTIONS(4383),
    [anon_sym_COLON_COLON] = ACTIONS(4381),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4381),
    [anon_sym___declspec] = ACTIONS(4383),
    [anon_sym___based] = ACTIONS(4383),
    [anon_sym___cdecl] = ACTIONS(4383),
    [anon_sym___clrcall] = ACTIONS(4383),
    [anon_sym___stdcall] = ACTIONS(4383),
    [anon_sym___fastcall] = ACTIONS(4383),
    [anon_sym___thiscall] = ACTIONS(4383),
    [anon_sym___vectorcall] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4381),
    [anon_sym_signed] = ACTIONS(4383),
    [anon_sym_unsigned] = ACTIONS(4383),
    [anon_sym_long] = ACTIONS(4383),
    [anon_sym_short] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4383),
    [anon_sym_static] = ACTIONS(4383),
    [anon_sym_register] = ACTIONS(4383),
    [anon_sym_inline] = ACTIONS(4383),
    [anon_sym___inline] = ACTIONS(4383),
    [anon_sym___inline__] = ACTIONS(4383),
    [anon_sym___forceinline] = ACTIONS(4383),
    [anon_sym_thread_local] = ACTIONS(4383),
    [anon_sym___thread] = ACTIONS(4383),
    [anon_sym_const] = ACTIONS(4383),
    [anon_sym_constexpr] = ACTIONS(4383),
    [anon_sym_volatile] = ACTIONS(4383),
    [anon_sym_restrict] = ACTIONS(4383),
    [anon_sym___restrict__] = ACTIONS(4383),
    [anon_sym__Atomic] = ACTIONS(4383),
    [anon_sym__Noreturn] = ACTIONS(4383),
    [anon_sym_noreturn] = ACTIONS(4383),
    [anon_sym__Nonnull] = ACTIONS(4383),
    [anon_sym_mutable] = ACTIONS(4383),
    [anon_sym_constinit] = ACTIONS(4383),
    [anon_sym_consteval] = ACTIONS(4383),
    [anon_sym_alignas] = ACTIONS(4383),
    [anon_sym__Alignas] = ACTIONS(4383),
    [sym_primitive_type] = ACTIONS(4383),
    [anon_sym_enum] = ACTIONS(4383),
    [anon_sym_class] = ACTIONS(4383),
    [anon_sym_struct] = ACTIONS(4383),
    [anon_sym_union] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_switch] = ACTIONS(4383),
    [anon_sym_case] = ACTIONS(4383),
    [anon_sym_default] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_for] = ACTIONS(4383),
    [anon_sym_return] = ACTIONS(4383),
    [anon_sym_break] = ACTIONS(4383),
    [anon_sym_continue] = ACTIONS(4383),
    [anon_sym_goto] = ACTIONS(4383),
    [anon_sym_not] = ACTIONS(4383),
    [anon_sym_compl] = ACTIONS(4383),
    [anon_sym_DASH_DASH] = ACTIONS(4381),
    [anon_sym_PLUS_PLUS] = ACTIONS(4381),
    [anon_sym_sizeof] = ACTIONS(4383),
    [anon_sym___alignof__] = ACTIONS(4383),
    [anon_sym___alignof] = ACTIONS(4383),
    [anon_sym__alignof] = ACTIONS(4383),
    [anon_sym_alignof] = ACTIONS(4383),
    [anon_sym__Alignof] = ACTIONS(4383),
    [anon_sym_offsetof] = ACTIONS(4383),
    [anon_sym__Generic] = ACTIONS(4383),
    [anon_sym_asm] = ACTIONS(4383),
    [anon_sym___asm__] = ACTIONS(4383),
    [anon_sym___asm] = ACTIONS(4383),
    [sym_number_literal] = ACTIONS(4381),
    [anon_sym_L_SQUOTE] = ACTIONS(4381),
    [anon_sym_u_SQUOTE] = ACTIONS(4381),
    [anon_sym_U_SQUOTE] = ACTIONS(4381),
    [anon_sym_u8_SQUOTE] = ACTIONS(4381),
    [anon_sym_SQUOTE] = ACTIONS(4381),
    [anon_sym_L_DQUOTE] = ACTIONS(4381),
    [anon_sym_u_DQUOTE] = ACTIONS(4381),
    [anon_sym_U_DQUOTE] = ACTIONS(4381),
    [anon_sym_u8_DQUOTE] = ACTIONS(4381),
    [anon_sym_DQUOTE] = ACTIONS(4381),
    [sym_true] = ACTIONS(4383),
    [sym_false] = ACTIONS(4383),
    [anon_sym_NULL] = ACTIONS(4383),
    [anon_sym_nullptr] = ACTIONS(4383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4383),
    [anon_sym_let] = ACTIONS(4383),
    [anon_sym_This] = ACTIONS(4383),
    [anon_sym_decltype] = ACTIONS(4383),
    [anon_sym_explicit] = ACTIONS(4383),
    [anon_sym_typename] = ACTIONS(4383),
    [anon_sym_export] = ACTIONS(4383),
    [anon_sym_module] = ACTIONS(4383),
    [anon_sym_import] = ACTIONS(4383),
    [anon_sym_template] = ACTIONS(4383),
    [anon_sym_operator] = ACTIONS(4383),
    [anon_sym_try] = ACTIONS(4383),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_throw] = ACTIONS(4383),
    [anon_sym_namespace] = ACTIONS(4383),
    [anon_sym_static_assert] = ACTIONS(4383),
    [anon_sym_concept] = ACTIONS(4383),
    [anon_sym_co_return] = ACTIONS(4383),
    [anon_sym_co_yield] = ACTIONS(4383),
    [anon_sym_R_DQUOTE] = ACTIONS(4381),
    [anon_sym_LR_DQUOTE] = ACTIONS(4381),
    [anon_sym_uR_DQUOTE] = ACTIONS(4381),
    [anon_sym_UR_DQUOTE] = ACTIONS(4381),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4381),
    [anon_sym_co_await] = ACTIONS(4383),
    [anon_sym_new] = ACTIONS(4383),
    [anon_sym_requires] = ACTIONS(4383),
    [sym_this] = ACTIONS(4383),
    [anon_sym_precise] = ACTIONS(4383),
    [anon_sym_shared] = ACTIONS(4383),
    [anon_sym_groupshared] = ACTIONS(4383),
    [anon_sym_uniform] = ACTIONS(4383),
    [anon_sym_row_major] = ACTIONS(4383),
    [anon_sym_column_major] = ACTIONS(4383),
    [anon_sym_globallycoherent] = ACTIONS(4383),
    [anon_sym_centroid] = ACTIONS(4383),
    [anon_sym_noperspective] = ACTIONS(4383),
    [anon_sym_nointerpolation] = ACTIONS(4383),
    [anon_sym_sample] = ACTIONS(4383),
    [anon_sym_linear] = ACTIONS(4383),
    [anon_sym_snorm] = ACTIONS(4383),
    [anon_sym_unorm] = ACTIONS(4383),
    [anon_sym_point] = ACTIONS(4383),
    [anon_sym_line] = ACTIONS(4383),
    [anon_sym_triangleadj] = ACTIONS(4383),
    [anon_sym_lineadj] = ACTIONS(4383),
    [anon_sym_triangle] = ACTIONS(4383),
    [anon_sym_interface] = ACTIONS(4383),
    [anon_sym_extension] = ACTIONS(4383),
    [anon_sym___exported] = ACTIONS(4383),
  },
  [1113] = {
    [sym_identifier] = ACTIONS(3804),
    [aux_sym_preproc_include_token1] = ACTIONS(3804),
    [aux_sym_preproc_def_token1] = ACTIONS(3804),
    [aux_sym_preproc_if_token1] = ACTIONS(3804),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3804),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3804),
    [sym_preproc_directive] = ACTIONS(3804),
    [anon_sym_LPAREN2] = ACTIONS(3806),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(3806),
    [anon_sym_AMP_AMP] = ACTIONS(3806),
    [anon_sym_AMP] = ACTIONS(3804),
    [anon_sym_SEMI] = ACTIONS(3806),
    [anon_sym___extension__] = ACTIONS(3804),
    [anon_sym_typedef] = ACTIONS(3804),
    [anon_sym_in] = ACTIONS(3804),
    [anon_sym_out] = ACTIONS(3804),
    [anon_sym_inout] = ACTIONS(3804),
    [anon_sym_virtual] = ACTIONS(3804),
    [anon_sym_extern] = ACTIONS(3804),
    [anon_sym___attribute__] = ACTIONS(3804),
    [anon_sym___attribute] = ACTIONS(3804),
    [anon_sym_using] = ACTIONS(3804),
    [anon_sym_COLON_COLON] = ACTIONS(3806),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3806),
    [anon_sym___declspec] = ACTIONS(3804),
    [anon_sym___based] = ACTIONS(3804),
    [anon_sym___cdecl] = ACTIONS(3804),
    [anon_sym___clrcall] = ACTIONS(3804),
    [anon_sym___stdcall] = ACTIONS(3804),
    [anon_sym___fastcall] = ACTIONS(3804),
    [anon_sym___thiscall] = ACTIONS(3804),
    [anon_sym___vectorcall] = ACTIONS(3804),
    [anon_sym_LBRACE] = ACTIONS(3806),
    [anon_sym_RBRACE] = ACTIONS(3806),
    [anon_sym_signed] = ACTIONS(3804),
    [anon_sym_unsigned] = ACTIONS(3804),
    [anon_sym_long] = ACTIONS(3804),
    [anon_sym_short] = ACTIONS(3804),
    [anon_sym_LBRACK] = ACTIONS(3804),
    [anon_sym_static] = ACTIONS(3804),
    [anon_sym_register] = ACTIONS(3804),
    [anon_sym_inline] = ACTIONS(3804),
    [anon_sym___inline] = ACTIONS(3804),
    [anon_sym___inline__] = ACTIONS(3804),
    [anon_sym___forceinline] = ACTIONS(3804),
    [anon_sym_thread_local] = ACTIONS(3804),
    [anon_sym___thread] = ACTIONS(3804),
    [anon_sym_const] = ACTIONS(3804),
    [anon_sym_constexpr] = ACTIONS(3804),
    [anon_sym_volatile] = ACTIONS(3804),
    [anon_sym_restrict] = ACTIONS(3804),
    [anon_sym___restrict__] = ACTIONS(3804),
    [anon_sym__Atomic] = ACTIONS(3804),
    [anon_sym__Noreturn] = ACTIONS(3804),
    [anon_sym_noreturn] = ACTIONS(3804),
    [anon_sym__Nonnull] = ACTIONS(3804),
    [anon_sym_mutable] = ACTIONS(3804),
    [anon_sym_constinit] = ACTIONS(3804),
    [anon_sym_consteval] = ACTIONS(3804),
    [anon_sym_alignas] = ACTIONS(3804),
    [anon_sym__Alignas] = ACTIONS(3804),
    [sym_primitive_type] = ACTIONS(3804),
    [anon_sym_enum] = ACTIONS(3804),
    [anon_sym_class] = ACTIONS(3804),
    [anon_sym_struct] = ACTIONS(3804),
    [anon_sym_union] = ACTIONS(3804),
    [anon_sym_if] = ACTIONS(3804),
    [anon_sym_switch] = ACTIONS(3804),
    [anon_sym_case] = ACTIONS(3804),
    [anon_sym_default] = ACTIONS(3804),
    [anon_sym_while] = ACTIONS(3804),
    [anon_sym_do] = ACTIONS(3804),
    [anon_sym_for] = ACTIONS(3804),
    [anon_sym_return] = ACTIONS(3804),
    [anon_sym_break] = ACTIONS(3804),
    [anon_sym_continue] = ACTIONS(3804),
    [anon_sym_goto] = ACTIONS(3804),
    [anon_sym___try] = ACTIONS(3804),
    [anon_sym___leave] = ACTIONS(3804),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(3806),
    [anon_sym_PLUS_PLUS] = ACTIONS(3806),
    [anon_sym_sizeof] = ACTIONS(3804),
    [anon_sym___alignof__] = ACTIONS(3804),
    [anon_sym___alignof] = ACTIONS(3804),
    [anon_sym__alignof] = ACTIONS(3804),
    [anon_sym_alignof] = ACTIONS(3804),
    [anon_sym__Alignof] = ACTIONS(3804),
    [anon_sym_offsetof] = ACTIONS(3804),
    [anon_sym__Generic] = ACTIONS(3804),
    [anon_sym_asm] = ACTIONS(3804),
    [anon_sym___asm__] = ACTIONS(3804),
    [anon_sym___asm] = ACTIONS(3804),
    [sym_number_literal] = ACTIONS(3806),
    [anon_sym_L_SQUOTE] = ACTIONS(3806),
    [anon_sym_u_SQUOTE] = ACTIONS(3806),
    [anon_sym_U_SQUOTE] = ACTIONS(3806),
    [anon_sym_u8_SQUOTE] = ACTIONS(3806),
    [anon_sym_SQUOTE] = ACTIONS(3806),
    [anon_sym_L_DQUOTE] = ACTIONS(3806),
    [anon_sym_u_DQUOTE] = ACTIONS(3806),
    [anon_sym_U_DQUOTE] = ACTIONS(3806),
    [anon_sym_u8_DQUOTE] = ACTIONS(3806),
    [anon_sym_DQUOTE] = ACTIONS(3806),
    [sym_true] = ACTIONS(3804),
    [sym_false] = ACTIONS(3804),
    [anon_sym_NULL] = ACTIONS(3804),
    [anon_sym_nullptr] = ACTIONS(3804),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3804),
    [anon_sym_let] = ACTIONS(3804),
    [anon_sym_This] = ACTIONS(3804),
    [anon_sym_decltype] = ACTIONS(3804),
    [anon_sym_explicit] = ACTIONS(3804),
    [anon_sym_typename] = ACTIONS(3804),
    [anon_sym_template] = ACTIONS(3804),
    [anon_sym_operator] = ACTIONS(3804),
    [anon_sym_try] = ACTIONS(3804),
    [anon_sym_delete] = ACTIONS(3804),
    [anon_sym_throw] = ACTIONS(3804),
    [anon_sym_namespace] = ACTIONS(3804),
    [anon_sym_static_assert] = ACTIONS(3804),
    [anon_sym_concept] = ACTIONS(3804),
    [anon_sym_co_return] = ACTIONS(3804),
    [anon_sym_co_yield] = ACTIONS(3804),
    [anon_sym_R_DQUOTE] = ACTIONS(3806),
    [anon_sym_LR_DQUOTE] = ACTIONS(3806),
    [anon_sym_uR_DQUOTE] = ACTIONS(3806),
    [anon_sym_UR_DQUOTE] = ACTIONS(3806),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3806),
    [anon_sym_co_await] = ACTIONS(3804),
    [anon_sym_new] = ACTIONS(3804),
    [anon_sym_requires] = ACTIONS(3804),
    [sym_this] = ACTIONS(3804),
    [anon_sym_discard] = ACTIONS(3804),
    [anon_sym_precise] = ACTIONS(3804),
    [anon_sym_shared] = ACTIONS(3804),
    [anon_sym_groupshared] = ACTIONS(3804),
    [anon_sym_uniform] = ACTIONS(3804),
    [anon_sym_row_major] = ACTIONS(3804),
    [anon_sym_column_major] = ACTIONS(3804),
    [anon_sym_globallycoherent] = ACTIONS(3804),
    [anon_sym_centroid] = ACTIONS(3804),
    [anon_sym_noperspective] = ACTIONS(3804),
    [anon_sym_nointerpolation] = ACTIONS(3804),
    [anon_sym_sample] = ACTIONS(3804),
    [anon_sym_linear] = ACTIONS(3804),
    [anon_sym_snorm] = ACTIONS(3804),
    [anon_sym_unorm] = ACTIONS(3804),
    [anon_sym_point] = ACTIONS(3804),
    [anon_sym_line] = ACTIONS(3804),
    [anon_sym_triangleadj] = ACTIONS(3804),
    [anon_sym_lineadj] = ACTIONS(3804),
    [anon_sym_triangle] = ACTIONS(3804),
    [anon_sym_cbuffer] = ACTIONS(3804),
    [anon_sym_interface] = ACTIONS(3804),
    [anon_sym_extension] = ACTIONS(3804),
  },
  [1114] = {
    [sym_identifier] = ACTIONS(3832),
    [aux_sym_preproc_include_token1] = ACTIONS(3832),
    [aux_sym_preproc_def_token1] = ACTIONS(3832),
    [aux_sym_preproc_if_token1] = ACTIONS(3832),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3832),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3832),
    [sym_preproc_directive] = ACTIONS(3832),
    [anon_sym_LPAREN2] = ACTIONS(3834),
    [anon_sym_BANG] = ACTIONS(3834),
    [anon_sym_TILDE] = ACTIONS(3834),
    [anon_sym_DASH] = ACTIONS(3832),
    [anon_sym_PLUS] = ACTIONS(3832),
    [anon_sym_STAR] = ACTIONS(3834),
    [anon_sym_AMP_AMP] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3834),
    [anon_sym___extension__] = ACTIONS(3832),
    [anon_sym_typedef] = ACTIONS(3832),
    [anon_sym_in] = ACTIONS(3832),
    [anon_sym_out] = ACTIONS(3832),
    [anon_sym_inout] = ACTIONS(3832),
    [anon_sym_virtual] = ACTIONS(3832),
    [anon_sym_extern] = ACTIONS(3832),
    [anon_sym___attribute__] = ACTIONS(3832),
    [anon_sym___attribute] = ACTIONS(3832),
    [anon_sym_using] = ACTIONS(3832),
    [anon_sym_COLON_COLON] = ACTIONS(3834),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3834),
    [anon_sym___declspec] = ACTIONS(3832),
    [anon_sym___based] = ACTIONS(3832),
    [anon_sym___cdecl] = ACTIONS(3832),
    [anon_sym___clrcall] = ACTIONS(3832),
    [anon_sym___stdcall] = ACTIONS(3832),
    [anon_sym___fastcall] = ACTIONS(3832),
    [anon_sym___thiscall] = ACTIONS(3832),
    [anon_sym___vectorcall] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_RBRACE] = ACTIONS(3834),
    [anon_sym_signed] = ACTIONS(3832),
    [anon_sym_unsigned] = ACTIONS(3832),
    [anon_sym_long] = ACTIONS(3832),
    [anon_sym_short] = ACTIONS(3832),
    [anon_sym_LBRACK] = ACTIONS(3832),
    [anon_sym_static] = ACTIONS(3832),
    [anon_sym_register] = ACTIONS(3832),
    [anon_sym_inline] = ACTIONS(3832),
    [anon_sym___inline] = ACTIONS(3832),
    [anon_sym___inline__] = ACTIONS(3832),
    [anon_sym___forceinline] = ACTIONS(3832),
    [anon_sym_thread_local] = ACTIONS(3832),
    [anon_sym___thread] = ACTIONS(3832),
    [anon_sym_const] = ACTIONS(3832),
    [anon_sym_constexpr] = ACTIONS(3832),
    [anon_sym_volatile] = ACTIONS(3832),
    [anon_sym_restrict] = ACTIONS(3832),
    [anon_sym___restrict__] = ACTIONS(3832),
    [anon_sym__Atomic] = ACTIONS(3832),
    [anon_sym__Noreturn] = ACTIONS(3832),
    [anon_sym_noreturn] = ACTIONS(3832),
    [anon_sym__Nonnull] = ACTIONS(3832),
    [anon_sym_mutable] = ACTIONS(3832),
    [anon_sym_constinit] = ACTIONS(3832),
    [anon_sym_consteval] = ACTIONS(3832),
    [anon_sym_alignas] = ACTIONS(3832),
    [anon_sym__Alignas] = ACTIONS(3832),
    [sym_primitive_type] = ACTIONS(3832),
    [anon_sym_enum] = ACTIONS(3832),
    [anon_sym_class] = ACTIONS(3832),
    [anon_sym_struct] = ACTIONS(3832),
    [anon_sym_union] = ACTIONS(3832),
    [anon_sym_if] = ACTIONS(3832),
    [anon_sym_switch] = ACTIONS(3832),
    [anon_sym_case] = ACTIONS(3832),
    [anon_sym_default] = ACTIONS(3832),
    [anon_sym_while] = ACTIONS(3832),
    [anon_sym_do] = ACTIONS(3832),
    [anon_sym_for] = ACTIONS(3832),
    [anon_sym_return] = ACTIONS(3832),
    [anon_sym_break] = ACTIONS(3832),
    [anon_sym_continue] = ACTIONS(3832),
    [anon_sym_goto] = ACTIONS(3832),
    [anon_sym___try] = ACTIONS(3832),
    [anon_sym___leave] = ACTIONS(3832),
    [anon_sym_not] = ACTIONS(3832),
    [anon_sym_compl] = ACTIONS(3832),
    [anon_sym_DASH_DASH] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(3834),
    [anon_sym_sizeof] = ACTIONS(3832),
    [anon_sym___alignof__] = ACTIONS(3832),
    [anon_sym___alignof] = ACTIONS(3832),
    [anon_sym__alignof] = ACTIONS(3832),
    [anon_sym_alignof] = ACTIONS(3832),
    [anon_sym__Alignof] = ACTIONS(3832),
    [anon_sym_offsetof] = ACTIONS(3832),
    [anon_sym__Generic] = ACTIONS(3832),
    [anon_sym_asm] = ACTIONS(3832),
    [anon_sym___asm__] = ACTIONS(3832),
    [anon_sym___asm] = ACTIONS(3832),
    [sym_number_literal] = ACTIONS(3834),
    [anon_sym_L_SQUOTE] = ACTIONS(3834),
    [anon_sym_u_SQUOTE] = ACTIONS(3834),
    [anon_sym_U_SQUOTE] = ACTIONS(3834),
    [anon_sym_u8_SQUOTE] = ACTIONS(3834),
    [anon_sym_SQUOTE] = ACTIONS(3834),
    [anon_sym_L_DQUOTE] = ACTIONS(3834),
    [anon_sym_u_DQUOTE] = ACTIONS(3834),
    [anon_sym_U_DQUOTE] = ACTIONS(3834),
    [anon_sym_u8_DQUOTE] = ACTIONS(3834),
    [anon_sym_DQUOTE] = ACTIONS(3834),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3832),
    [anon_sym_nullptr] = ACTIONS(3832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3832),
    [anon_sym_let] = ACTIONS(3832),
    [anon_sym_This] = ACTIONS(3832),
    [anon_sym_decltype] = ACTIONS(3832),
    [anon_sym_explicit] = ACTIONS(3832),
    [anon_sym_typename] = ACTIONS(3832),
    [anon_sym_template] = ACTIONS(3832),
    [anon_sym_operator] = ACTIONS(3832),
    [anon_sym_try] = ACTIONS(3832),
    [anon_sym_delete] = ACTIONS(3832),
    [anon_sym_throw] = ACTIONS(3832),
    [anon_sym_namespace] = ACTIONS(3832),
    [anon_sym_static_assert] = ACTIONS(3832),
    [anon_sym_concept] = ACTIONS(3832),
    [anon_sym_co_return] = ACTIONS(3832),
    [anon_sym_co_yield] = ACTIONS(3832),
    [anon_sym_R_DQUOTE] = ACTIONS(3834),
    [anon_sym_LR_DQUOTE] = ACTIONS(3834),
    [anon_sym_uR_DQUOTE] = ACTIONS(3834),
    [anon_sym_UR_DQUOTE] = ACTIONS(3834),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3834),
    [anon_sym_co_await] = ACTIONS(3832),
    [anon_sym_new] = ACTIONS(3832),
    [anon_sym_requires] = ACTIONS(3832),
    [sym_this] = ACTIONS(3832),
    [anon_sym_discard] = ACTIONS(3832),
    [anon_sym_precise] = ACTIONS(3832),
    [anon_sym_shared] = ACTIONS(3832),
    [anon_sym_groupshared] = ACTIONS(3832),
    [anon_sym_uniform] = ACTIONS(3832),
    [anon_sym_row_major] = ACTIONS(3832),
    [anon_sym_column_major] = ACTIONS(3832),
    [anon_sym_globallycoherent] = ACTIONS(3832),
    [anon_sym_centroid] = ACTIONS(3832),
    [anon_sym_noperspective] = ACTIONS(3832),
    [anon_sym_nointerpolation] = ACTIONS(3832),
    [anon_sym_sample] = ACTIONS(3832),
    [anon_sym_linear] = ACTIONS(3832),
    [anon_sym_snorm] = ACTIONS(3832),
    [anon_sym_unorm] = ACTIONS(3832),
    [anon_sym_point] = ACTIONS(3832),
    [anon_sym_line] = ACTIONS(3832),
    [anon_sym_triangleadj] = ACTIONS(3832),
    [anon_sym_lineadj] = ACTIONS(3832),
    [anon_sym_triangle] = ACTIONS(3832),
    [anon_sym_cbuffer] = ACTIONS(3832),
    [anon_sym_interface] = ACTIONS(3832),
    [anon_sym_extension] = ACTIONS(3832),
  },
  [1115] = {
    [ts_builtin_sym_end] = ACTIONS(3675),
    [sym_identifier] = ACTIONS(3673),
    [aux_sym_preproc_include_token1] = ACTIONS(3673),
    [aux_sym_preproc_def_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token1] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3673),
    [sym_preproc_directive] = ACTIONS(3673),
    [anon_sym_LPAREN2] = ACTIONS(3675),
    [anon_sym_BANG] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3673),
    [anon_sym_PLUS] = ACTIONS(3673),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3673),
    [anon_sym_SEMI] = ACTIONS(3675),
    [anon_sym___extension__] = ACTIONS(3673),
    [anon_sym_typedef] = ACTIONS(3673),
    [anon_sym_in] = ACTIONS(3673),
    [anon_sym_out] = ACTIONS(3673),
    [anon_sym_inout] = ACTIONS(3673),
    [anon_sym_virtual] = ACTIONS(3673),
    [anon_sym_extern] = ACTIONS(3673),
    [anon_sym___attribute__] = ACTIONS(3673),
    [anon_sym___attribute] = ACTIONS(3673),
    [anon_sym_using] = ACTIONS(3673),
    [anon_sym_COLON_COLON] = ACTIONS(3675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3675),
    [anon_sym___declspec] = ACTIONS(3673),
    [anon_sym___based] = ACTIONS(3673),
    [anon_sym___cdecl] = ACTIONS(3673),
    [anon_sym___clrcall] = ACTIONS(3673),
    [anon_sym___stdcall] = ACTIONS(3673),
    [anon_sym___fastcall] = ACTIONS(3673),
    [anon_sym___thiscall] = ACTIONS(3673),
    [anon_sym___vectorcall] = ACTIONS(3673),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_signed] = ACTIONS(3673),
    [anon_sym_unsigned] = ACTIONS(3673),
    [anon_sym_long] = ACTIONS(3673),
    [anon_sym_short] = ACTIONS(3673),
    [anon_sym_LBRACK] = ACTIONS(3673),
    [anon_sym_static] = ACTIONS(3673),
    [anon_sym_register] = ACTIONS(3673),
    [anon_sym_inline] = ACTIONS(3673),
    [anon_sym___inline] = ACTIONS(3673),
    [anon_sym___inline__] = ACTIONS(3673),
    [anon_sym___forceinline] = ACTIONS(3673),
    [anon_sym_thread_local] = ACTIONS(3673),
    [anon_sym___thread] = ACTIONS(3673),
    [anon_sym_const] = ACTIONS(3673),
    [anon_sym_constexpr] = ACTIONS(3673),
    [anon_sym_volatile] = ACTIONS(3673),
    [anon_sym_restrict] = ACTIONS(3673),
    [anon_sym___restrict__] = ACTIONS(3673),
    [anon_sym__Atomic] = ACTIONS(3673),
    [anon_sym__Noreturn] = ACTIONS(3673),
    [anon_sym_noreturn] = ACTIONS(3673),
    [anon_sym__Nonnull] = ACTIONS(3673),
    [anon_sym_mutable] = ACTIONS(3673),
    [anon_sym_constinit] = ACTIONS(3673),
    [anon_sym_consteval] = ACTIONS(3673),
    [anon_sym_alignas] = ACTIONS(3673),
    [anon_sym__Alignas] = ACTIONS(3673),
    [sym_primitive_type] = ACTIONS(3673),
    [anon_sym_enum] = ACTIONS(3673),
    [anon_sym_class] = ACTIONS(3673),
    [anon_sym_struct] = ACTIONS(3673),
    [anon_sym_union] = ACTIONS(3673),
    [anon_sym_if] = ACTIONS(3673),
    [anon_sym_switch] = ACTIONS(3673),
    [anon_sym_case] = ACTIONS(3673),
    [anon_sym_default] = ACTIONS(3673),
    [anon_sym_while] = ACTIONS(3673),
    [anon_sym_do] = ACTIONS(3673),
    [anon_sym_for] = ACTIONS(3673),
    [anon_sym_return] = ACTIONS(3673),
    [anon_sym_break] = ACTIONS(3673),
    [anon_sym_continue] = ACTIONS(3673),
    [anon_sym_goto] = ACTIONS(3673),
    [anon_sym_not] = ACTIONS(3673),
    [anon_sym_compl] = ACTIONS(3673),
    [anon_sym_DASH_DASH] = ACTIONS(3675),
    [anon_sym_PLUS_PLUS] = ACTIONS(3675),
    [anon_sym_sizeof] = ACTIONS(3673),
    [anon_sym___alignof__] = ACTIONS(3673),
    [anon_sym___alignof] = ACTIONS(3673),
    [anon_sym__alignof] = ACTIONS(3673),
    [anon_sym_alignof] = ACTIONS(3673),
    [anon_sym__Alignof] = ACTIONS(3673),
    [anon_sym_offsetof] = ACTIONS(3673),
    [anon_sym__Generic] = ACTIONS(3673),
    [anon_sym_asm] = ACTIONS(3673),
    [anon_sym___asm__] = ACTIONS(3673),
    [anon_sym___asm] = ACTIONS(3673),
    [sym_number_literal] = ACTIONS(3675),
    [anon_sym_L_SQUOTE] = ACTIONS(3675),
    [anon_sym_u_SQUOTE] = ACTIONS(3675),
    [anon_sym_U_SQUOTE] = ACTIONS(3675),
    [anon_sym_u8_SQUOTE] = ACTIONS(3675),
    [anon_sym_SQUOTE] = ACTIONS(3675),
    [anon_sym_L_DQUOTE] = ACTIONS(3675),
    [anon_sym_u_DQUOTE] = ACTIONS(3675),
    [anon_sym_U_DQUOTE] = ACTIONS(3675),
    [anon_sym_u8_DQUOTE] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(3675),
    [sym_true] = ACTIONS(3673),
    [sym_false] = ACTIONS(3673),
    [anon_sym_NULL] = ACTIONS(3673),
    [anon_sym_nullptr] = ACTIONS(3673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3673),
    [anon_sym_let] = ACTIONS(3673),
    [anon_sym_This] = ACTIONS(3673),
    [anon_sym_decltype] = ACTIONS(3673),
    [anon_sym_explicit] = ACTIONS(3673),
    [anon_sym_typename] = ACTIONS(3673),
    [anon_sym_export] = ACTIONS(3673),
    [anon_sym_module] = ACTIONS(3673),
    [anon_sym_import] = ACTIONS(3673),
    [anon_sym_template] = ACTIONS(3673),
    [anon_sym_operator] = ACTIONS(3673),
    [anon_sym_try] = ACTIONS(3673),
    [anon_sym_delete] = ACTIONS(3673),
    [anon_sym_throw] = ACTIONS(3673),
    [anon_sym_namespace] = ACTIONS(3673),
    [anon_sym_static_assert] = ACTIONS(3673),
    [anon_sym_concept] = ACTIONS(3673),
    [anon_sym_co_return] = ACTIONS(3673),
    [anon_sym_co_yield] = ACTIONS(3673),
    [anon_sym_R_DQUOTE] = ACTIONS(3675),
    [anon_sym_LR_DQUOTE] = ACTIONS(3675),
    [anon_sym_uR_DQUOTE] = ACTIONS(3675),
    [anon_sym_UR_DQUOTE] = ACTIONS(3675),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3675),
    [anon_sym_co_await] = ACTIONS(3673),
    [anon_sym_new] = ACTIONS(3673),
    [anon_sym_requires] = ACTIONS(3673),
    [sym_this] = ACTIONS(3673),
    [anon_sym_precise] = ACTIONS(3673),
    [anon_sym_shared] = ACTIONS(3673),
    [anon_sym_groupshared] = ACTIONS(3673),
    [anon_sym_uniform] = ACTIONS(3673),
    [anon_sym_row_major] = ACTIONS(3673),
    [anon_sym_column_major] = ACTIONS(3673),
    [anon_sym_globallycoherent] = ACTIONS(3673),
    [anon_sym_centroid] = ACTIONS(3673),
    [anon_sym_noperspective] = ACTIONS(3673),
    [anon_sym_nointerpolation] = ACTIONS(3673),
    [anon_sym_sample] = ACTIONS(3673),
    [anon_sym_linear] = ACTIONS(3673),
    [anon_sym_snorm] = ACTIONS(3673),
    [anon_sym_unorm] = ACTIONS(3673),
    [anon_sym_point] = ACTIONS(3673),
    [anon_sym_line] = ACTIONS(3673),
    [anon_sym_triangleadj] = ACTIONS(3673),
    [anon_sym_lineadj] = ACTIONS(3673),
    [anon_sym_triangle] = ACTIONS(3673),
    [anon_sym_interface] = ACTIONS(3673),
    [anon_sym_extension] = ACTIONS(3673),
    [anon_sym___exported] = ACTIONS(3673),
  },
  [1116] = {
    [ts_builtin_sym_end] = ACTIONS(4385),
    [sym_identifier] = ACTIONS(4387),
    [aux_sym_preproc_include_token1] = ACTIONS(4387),
    [aux_sym_preproc_def_token1] = ACTIONS(4387),
    [aux_sym_preproc_if_token1] = ACTIONS(4387),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4387),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4387),
    [sym_preproc_directive] = ACTIONS(4387),
    [anon_sym_LPAREN2] = ACTIONS(4385),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_TILDE] = ACTIONS(4385),
    [anon_sym_DASH] = ACTIONS(4387),
    [anon_sym_PLUS] = ACTIONS(4387),
    [anon_sym_STAR] = ACTIONS(4385),
    [anon_sym_AMP_AMP] = ACTIONS(4385),
    [anon_sym_AMP] = ACTIONS(4387),
    [anon_sym_SEMI] = ACTIONS(4385),
    [anon_sym___extension__] = ACTIONS(4387),
    [anon_sym_typedef] = ACTIONS(4387),
    [anon_sym_in] = ACTIONS(4387),
    [anon_sym_out] = ACTIONS(4387),
    [anon_sym_inout] = ACTIONS(4387),
    [anon_sym_virtual] = ACTIONS(4387),
    [anon_sym_extern] = ACTIONS(4387),
    [anon_sym___attribute__] = ACTIONS(4387),
    [anon_sym___attribute] = ACTIONS(4387),
    [anon_sym_using] = ACTIONS(4387),
    [anon_sym_COLON_COLON] = ACTIONS(4385),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4385),
    [anon_sym___declspec] = ACTIONS(4387),
    [anon_sym___based] = ACTIONS(4387),
    [anon_sym___cdecl] = ACTIONS(4387),
    [anon_sym___clrcall] = ACTIONS(4387),
    [anon_sym___stdcall] = ACTIONS(4387),
    [anon_sym___fastcall] = ACTIONS(4387),
    [anon_sym___thiscall] = ACTIONS(4387),
    [anon_sym___vectorcall] = ACTIONS(4387),
    [anon_sym_LBRACE] = ACTIONS(4385),
    [anon_sym_signed] = ACTIONS(4387),
    [anon_sym_unsigned] = ACTIONS(4387),
    [anon_sym_long] = ACTIONS(4387),
    [anon_sym_short] = ACTIONS(4387),
    [anon_sym_LBRACK] = ACTIONS(4387),
    [anon_sym_static] = ACTIONS(4387),
    [anon_sym_register] = ACTIONS(4387),
    [anon_sym_inline] = ACTIONS(4387),
    [anon_sym___inline] = ACTIONS(4387),
    [anon_sym___inline__] = ACTIONS(4387),
    [anon_sym___forceinline] = ACTIONS(4387),
    [anon_sym_thread_local] = ACTIONS(4387),
    [anon_sym___thread] = ACTIONS(4387),
    [anon_sym_const] = ACTIONS(4387),
    [anon_sym_constexpr] = ACTIONS(4387),
    [anon_sym_volatile] = ACTIONS(4387),
    [anon_sym_restrict] = ACTIONS(4387),
    [anon_sym___restrict__] = ACTIONS(4387),
    [anon_sym__Atomic] = ACTIONS(4387),
    [anon_sym__Noreturn] = ACTIONS(4387),
    [anon_sym_noreturn] = ACTIONS(4387),
    [anon_sym__Nonnull] = ACTIONS(4387),
    [anon_sym_mutable] = ACTIONS(4387),
    [anon_sym_constinit] = ACTIONS(4387),
    [anon_sym_consteval] = ACTIONS(4387),
    [anon_sym_alignas] = ACTIONS(4387),
    [anon_sym__Alignas] = ACTIONS(4387),
    [sym_primitive_type] = ACTIONS(4387),
    [anon_sym_enum] = ACTIONS(4387),
    [anon_sym_class] = ACTIONS(4387),
    [anon_sym_struct] = ACTIONS(4387),
    [anon_sym_union] = ACTIONS(4387),
    [anon_sym_if] = ACTIONS(4387),
    [anon_sym_switch] = ACTIONS(4387),
    [anon_sym_case] = ACTIONS(4387),
    [anon_sym_default] = ACTIONS(4387),
    [anon_sym_while] = ACTIONS(4387),
    [anon_sym_do] = ACTIONS(4387),
    [anon_sym_for] = ACTIONS(4387),
    [anon_sym_return] = ACTIONS(4387),
    [anon_sym_break] = ACTIONS(4387),
    [anon_sym_continue] = ACTIONS(4387),
    [anon_sym_goto] = ACTIONS(4387),
    [anon_sym_not] = ACTIONS(4387),
    [anon_sym_compl] = ACTIONS(4387),
    [anon_sym_DASH_DASH] = ACTIONS(4385),
    [anon_sym_PLUS_PLUS] = ACTIONS(4385),
    [anon_sym_sizeof] = ACTIONS(4387),
    [anon_sym___alignof__] = ACTIONS(4387),
    [anon_sym___alignof] = ACTIONS(4387),
    [anon_sym__alignof] = ACTIONS(4387),
    [anon_sym_alignof] = ACTIONS(4387),
    [anon_sym__Alignof] = ACTIONS(4387),
    [anon_sym_offsetof] = ACTIONS(4387),
    [anon_sym__Generic] = ACTIONS(4387),
    [anon_sym_asm] = ACTIONS(4387),
    [anon_sym___asm__] = ACTIONS(4387),
    [anon_sym___asm] = ACTIONS(4387),
    [sym_number_literal] = ACTIONS(4385),
    [anon_sym_L_SQUOTE] = ACTIONS(4385),
    [anon_sym_u_SQUOTE] = ACTIONS(4385),
    [anon_sym_U_SQUOTE] = ACTIONS(4385),
    [anon_sym_u8_SQUOTE] = ACTIONS(4385),
    [anon_sym_SQUOTE] = ACTIONS(4385),
    [anon_sym_L_DQUOTE] = ACTIONS(4385),
    [anon_sym_u_DQUOTE] = ACTIONS(4385),
    [anon_sym_U_DQUOTE] = ACTIONS(4385),
    [anon_sym_u8_DQUOTE] = ACTIONS(4385),
    [anon_sym_DQUOTE] = ACTIONS(4385),
    [sym_true] = ACTIONS(4387),
    [sym_false] = ACTIONS(4387),
    [anon_sym_NULL] = ACTIONS(4387),
    [anon_sym_nullptr] = ACTIONS(4387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4387),
    [anon_sym_let] = ACTIONS(4387),
    [anon_sym_This] = ACTIONS(4387),
    [anon_sym_decltype] = ACTIONS(4387),
    [anon_sym_explicit] = ACTIONS(4387),
    [anon_sym_typename] = ACTIONS(4387),
    [anon_sym_export] = ACTIONS(4387),
    [anon_sym_module] = ACTIONS(4387),
    [anon_sym_import] = ACTIONS(4387),
    [anon_sym_template] = ACTIONS(4387),
    [anon_sym_operator] = ACTIONS(4387),
    [anon_sym_try] = ACTIONS(4387),
    [anon_sym_delete] = ACTIONS(4387),
    [anon_sym_throw] = ACTIONS(4387),
    [anon_sym_namespace] = ACTIONS(4387),
    [anon_sym_static_assert] = ACTIONS(4387),
    [anon_sym_concept] = ACTIONS(4387),
    [anon_sym_co_return] = ACTIONS(4387),
    [anon_sym_co_yield] = ACTIONS(4387),
    [anon_sym_R_DQUOTE] = ACTIONS(4385),
    [anon_sym_LR_DQUOTE] = ACTIONS(4385),
    [anon_sym_uR_DQUOTE] = ACTIONS(4385),
    [anon_sym_UR_DQUOTE] = ACTIONS(4385),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4385),
    [anon_sym_co_await] = ACTIONS(4387),
    [anon_sym_new] = ACTIONS(4387),
    [anon_sym_requires] = ACTIONS(4387),
    [sym_this] = ACTIONS(4387),
    [anon_sym_precise] = ACTIONS(4387),
    [anon_sym_shared] = ACTIONS(4387),
    [anon_sym_groupshared] = ACTIONS(4387),
    [anon_sym_uniform] = ACTIONS(4387),
    [anon_sym_row_major] = ACTIONS(4387),
    [anon_sym_column_major] = ACTIONS(4387),
    [anon_sym_globallycoherent] = ACTIONS(4387),
    [anon_sym_centroid] = ACTIONS(4387),
    [anon_sym_noperspective] = ACTIONS(4387),
    [anon_sym_nointerpolation] = ACTIONS(4387),
    [anon_sym_sample] = ACTIONS(4387),
    [anon_sym_linear] = ACTIONS(4387),
    [anon_sym_snorm] = ACTIONS(4387),
    [anon_sym_unorm] = ACTIONS(4387),
    [anon_sym_point] = ACTIONS(4387),
    [anon_sym_line] = ACTIONS(4387),
    [anon_sym_triangleadj] = ACTIONS(4387),
    [anon_sym_lineadj] = ACTIONS(4387),
    [anon_sym_triangle] = ACTIONS(4387),
    [anon_sym_interface] = ACTIONS(4387),
    [anon_sym_extension] = ACTIONS(4387),
    [anon_sym___exported] = ACTIONS(4387),
  },
  [1117] = {
    [ts_builtin_sym_end] = ACTIONS(4389),
    [sym_identifier] = ACTIONS(4391),
    [aux_sym_preproc_include_token1] = ACTIONS(4391),
    [aux_sym_preproc_def_token1] = ACTIONS(4391),
    [aux_sym_preproc_if_token1] = ACTIONS(4391),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4391),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4391),
    [sym_preproc_directive] = ACTIONS(4391),
    [anon_sym_LPAREN2] = ACTIONS(4389),
    [anon_sym_BANG] = ACTIONS(4389),
    [anon_sym_TILDE] = ACTIONS(4389),
    [anon_sym_DASH] = ACTIONS(4391),
    [anon_sym_PLUS] = ACTIONS(4391),
    [anon_sym_STAR] = ACTIONS(4389),
    [anon_sym_AMP_AMP] = ACTIONS(4389),
    [anon_sym_AMP] = ACTIONS(4391),
    [anon_sym_SEMI] = ACTIONS(4389),
    [anon_sym___extension__] = ACTIONS(4391),
    [anon_sym_typedef] = ACTIONS(4391),
    [anon_sym_in] = ACTIONS(4391),
    [anon_sym_out] = ACTIONS(4391),
    [anon_sym_inout] = ACTIONS(4391),
    [anon_sym_virtual] = ACTIONS(4391),
    [anon_sym_extern] = ACTIONS(4391),
    [anon_sym___attribute__] = ACTIONS(4391),
    [anon_sym___attribute] = ACTIONS(4391),
    [anon_sym_using] = ACTIONS(4391),
    [anon_sym_COLON_COLON] = ACTIONS(4389),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4389),
    [anon_sym___declspec] = ACTIONS(4391),
    [anon_sym___based] = ACTIONS(4391),
    [anon_sym___cdecl] = ACTIONS(4391),
    [anon_sym___clrcall] = ACTIONS(4391),
    [anon_sym___stdcall] = ACTIONS(4391),
    [anon_sym___fastcall] = ACTIONS(4391),
    [anon_sym___thiscall] = ACTIONS(4391),
    [anon_sym___vectorcall] = ACTIONS(4391),
    [anon_sym_LBRACE] = ACTIONS(4389),
    [anon_sym_signed] = ACTIONS(4391),
    [anon_sym_unsigned] = ACTIONS(4391),
    [anon_sym_long] = ACTIONS(4391),
    [anon_sym_short] = ACTIONS(4391),
    [anon_sym_LBRACK] = ACTIONS(4391),
    [anon_sym_static] = ACTIONS(4391),
    [anon_sym_register] = ACTIONS(4391),
    [anon_sym_inline] = ACTIONS(4391),
    [anon_sym___inline] = ACTIONS(4391),
    [anon_sym___inline__] = ACTIONS(4391),
    [anon_sym___forceinline] = ACTIONS(4391),
    [anon_sym_thread_local] = ACTIONS(4391),
    [anon_sym___thread] = ACTIONS(4391),
    [anon_sym_const] = ACTIONS(4391),
    [anon_sym_constexpr] = ACTIONS(4391),
    [anon_sym_volatile] = ACTIONS(4391),
    [anon_sym_restrict] = ACTIONS(4391),
    [anon_sym___restrict__] = ACTIONS(4391),
    [anon_sym__Atomic] = ACTIONS(4391),
    [anon_sym__Noreturn] = ACTIONS(4391),
    [anon_sym_noreturn] = ACTIONS(4391),
    [anon_sym__Nonnull] = ACTIONS(4391),
    [anon_sym_mutable] = ACTIONS(4391),
    [anon_sym_constinit] = ACTIONS(4391),
    [anon_sym_consteval] = ACTIONS(4391),
    [anon_sym_alignas] = ACTIONS(4391),
    [anon_sym__Alignas] = ACTIONS(4391),
    [sym_primitive_type] = ACTIONS(4391),
    [anon_sym_enum] = ACTIONS(4391),
    [anon_sym_class] = ACTIONS(4391),
    [anon_sym_struct] = ACTIONS(4391),
    [anon_sym_union] = ACTIONS(4391),
    [anon_sym_if] = ACTIONS(4391),
    [anon_sym_switch] = ACTIONS(4391),
    [anon_sym_case] = ACTIONS(4391),
    [anon_sym_default] = ACTIONS(4391),
    [anon_sym_while] = ACTIONS(4391),
    [anon_sym_do] = ACTIONS(4391),
    [anon_sym_for] = ACTIONS(4391),
    [anon_sym_return] = ACTIONS(4391),
    [anon_sym_break] = ACTIONS(4391),
    [anon_sym_continue] = ACTIONS(4391),
    [anon_sym_goto] = ACTIONS(4391),
    [anon_sym_not] = ACTIONS(4391),
    [anon_sym_compl] = ACTIONS(4391),
    [anon_sym_DASH_DASH] = ACTIONS(4389),
    [anon_sym_PLUS_PLUS] = ACTIONS(4389),
    [anon_sym_sizeof] = ACTIONS(4391),
    [anon_sym___alignof__] = ACTIONS(4391),
    [anon_sym___alignof] = ACTIONS(4391),
    [anon_sym__alignof] = ACTIONS(4391),
    [anon_sym_alignof] = ACTIONS(4391),
    [anon_sym__Alignof] = ACTIONS(4391),
    [anon_sym_offsetof] = ACTIONS(4391),
    [anon_sym__Generic] = ACTIONS(4391),
    [anon_sym_asm] = ACTIONS(4391),
    [anon_sym___asm__] = ACTIONS(4391),
    [anon_sym___asm] = ACTIONS(4391),
    [sym_number_literal] = ACTIONS(4389),
    [anon_sym_L_SQUOTE] = ACTIONS(4389),
    [anon_sym_u_SQUOTE] = ACTIONS(4389),
    [anon_sym_U_SQUOTE] = ACTIONS(4389),
    [anon_sym_u8_SQUOTE] = ACTIONS(4389),
    [anon_sym_SQUOTE] = ACTIONS(4389),
    [anon_sym_L_DQUOTE] = ACTIONS(4389),
    [anon_sym_u_DQUOTE] = ACTIONS(4389),
    [anon_sym_U_DQUOTE] = ACTIONS(4389),
    [anon_sym_u8_DQUOTE] = ACTIONS(4389),
    [anon_sym_DQUOTE] = ACTIONS(4389),
    [sym_true] = ACTIONS(4391),
    [sym_false] = ACTIONS(4391),
    [anon_sym_NULL] = ACTIONS(4391),
    [anon_sym_nullptr] = ACTIONS(4391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4391),
    [anon_sym_let] = ACTIONS(4391),
    [anon_sym_This] = ACTIONS(4391),
    [anon_sym_decltype] = ACTIONS(4391),
    [anon_sym_explicit] = ACTIONS(4391),
    [anon_sym_typename] = ACTIONS(4391),
    [anon_sym_export] = ACTIONS(4391),
    [anon_sym_module] = ACTIONS(4391),
    [anon_sym_import] = ACTIONS(4391),
    [anon_sym_template] = ACTIONS(4391),
    [anon_sym_operator] = ACTIONS(4391),
    [anon_sym_try] = ACTIONS(4391),
    [anon_sym_delete] = ACTIONS(4391),
    [anon_sym_throw] = ACTIONS(4391),
    [anon_sym_namespace] = ACTIONS(4391),
    [anon_sym_static_assert] = ACTIONS(4391),
    [anon_sym_concept] = ACTIONS(4391),
    [anon_sym_co_return] = ACTIONS(4391),
    [anon_sym_co_yield] = ACTIONS(4391),
    [anon_sym_R_DQUOTE] = ACTIONS(4389),
    [anon_sym_LR_DQUOTE] = ACTIONS(4389),
    [anon_sym_uR_DQUOTE] = ACTIONS(4389),
    [anon_sym_UR_DQUOTE] = ACTIONS(4389),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4389),
    [anon_sym_co_await] = ACTIONS(4391),
    [anon_sym_new] = ACTIONS(4391),
    [anon_sym_requires] = ACTIONS(4391),
    [sym_this] = ACTIONS(4391),
    [anon_sym_precise] = ACTIONS(4391),
    [anon_sym_shared] = ACTIONS(4391),
    [anon_sym_groupshared] = ACTIONS(4391),
    [anon_sym_uniform] = ACTIONS(4391),
    [anon_sym_row_major] = ACTIONS(4391),
    [anon_sym_column_major] = ACTIONS(4391),
    [anon_sym_globallycoherent] = ACTIONS(4391),
    [anon_sym_centroid] = ACTIONS(4391),
    [anon_sym_noperspective] = ACTIONS(4391),
    [anon_sym_nointerpolation] = ACTIONS(4391),
    [anon_sym_sample] = ACTIONS(4391),
    [anon_sym_linear] = ACTIONS(4391),
    [anon_sym_snorm] = ACTIONS(4391),
    [anon_sym_unorm] = ACTIONS(4391),
    [anon_sym_point] = ACTIONS(4391),
    [anon_sym_line] = ACTIONS(4391),
    [anon_sym_triangleadj] = ACTIONS(4391),
    [anon_sym_lineadj] = ACTIONS(4391),
    [anon_sym_triangle] = ACTIONS(4391),
    [anon_sym_interface] = ACTIONS(4391),
    [anon_sym_extension] = ACTIONS(4391),
    [anon_sym___exported] = ACTIONS(4391),
  },
  [1118] = {
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_include_token1] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token2] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_BANG] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym___cdecl] = ACTIONS(3942),
    [anon_sym___clrcall] = ACTIONS(3942),
    [anon_sym___stdcall] = ACTIONS(3942),
    [anon_sym___fastcall] = ACTIONS(3942),
    [anon_sym___thiscall] = ACTIONS(3942),
    [anon_sym___vectorcall] = ACTIONS(3942),
    [anon_sym_LBRACE] = ACTIONS(3944),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_switch] = ACTIONS(3942),
    [anon_sym_case] = ACTIONS(3942),
    [anon_sym_default] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_break] = ACTIONS(3942),
    [anon_sym_continue] = ACTIONS(3942),
    [anon_sym_goto] = ACTIONS(3942),
    [anon_sym___try] = ACTIONS(3942),
    [anon_sym___leave] = ACTIONS(3942),
    [anon_sym_not] = ACTIONS(3942),
    [anon_sym_compl] = ACTIONS(3942),
    [anon_sym_DASH_DASH] = ACTIONS(3944),
    [anon_sym_PLUS_PLUS] = ACTIONS(3944),
    [anon_sym_sizeof] = ACTIONS(3942),
    [anon_sym___alignof__] = ACTIONS(3942),
    [anon_sym___alignof] = ACTIONS(3942),
    [anon_sym__alignof] = ACTIONS(3942),
    [anon_sym_alignof] = ACTIONS(3942),
    [anon_sym__Alignof] = ACTIONS(3942),
    [anon_sym_offsetof] = ACTIONS(3942),
    [anon_sym__Generic] = ACTIONS(3942),
    [anon_sym_asm] = ACTIONS(3942),
    [anon_sym___asm__] = ACTIONS(3942),
    [anon_sym___asm] = ACTIONS(3942),
    [sym_number_literal] = ACTIONS(3944),
    [anon_sym_L_SQUOTE] = ACTIONS(3944),
    [anon_sym_u_SQUOTE] = ACTIONS(3944),
    [anon_sym_U_SQUOTE] = ACTIONS(3944),
    [anon_sym_u8_SQUOTE] = ACTIONS(3944),
    [anon_sym_SQUOTE] = ACTIONS(3944),
    [anon_sym_L_DQUOTE] = ACTIONS(3944),
    [anon_sym_u_DQUOTE] = ACTIONS(3944),
    [anon_sym_U_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE] = ACTIONS(3944),
    [sym_true] = ACTIONS(3942),
    [sym_false] = ACTIONS(3942),
    [anon_sym_NULL] = ACTIONS(3942),
    [anon_sym_nullptr] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_delete] = ACTIONS(3942),
    [anon_sym_throw] = ACTIONS(3942),
    [anon_sym_namespace] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_concept] = ACTIONS(3942),
    [anon_sym_co_return] = ACTIONS(3942),
    [anon_sym_co_yield] = ACTIONS(3942),
    [anon_sym_R_DQUOTE] = ACTIONS(3944),
    [anon_sym_LR_DQUOTE] = ACTIONS(3944),
    [anon_sym_uR_DQUOTE] = ACTIONS(3944),
    [anon_sym_UR_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3944),
    [anon_sym_co_await] = ACTIONS(3942),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_requires] = ACTIONS(3942),
    [sym_this] = ACTIONS(3942),
    [anon_sym_discard] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_cbuffer] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
  },
  [1119] = {
    [sym_identifier] = ACTIONS(3971),
    [aux_sym_preproc_include_token1] = ACTIONS(3971),
    [aux_sym_preproc_def_token1] = ACTIONS(3971),
    [aux_sym_preproc_if_token1] = ACTIONS(3971),
    [aux_sym_preproc_if_token2] = ACTIONS(3971),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3971),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3971),
    [sym_preproc_directive] = ACTIONS(3971),
    [anon_sym_LPAREN2] = ACTIONS(3974),
    [anon_sym_BANG] = ACTIONS(3974),
    [anon_sym_TILDE] = ACTIONS(3974),
    [anon_sym_DASH] = ACTIONS(3971),
    [anon_sym_PLUS] = ACTIONS(3971),
    [anon_sym_STAR] = ACTIONS(3974),
    [anon_sym_AMP_AMP] = ACTIONS(3974),
    [anon_sym_AMP] = ACTIONS(3971),
    [anon_sym_SEMI] = ACTIONS(3974),
    [anon_sym___extension__] = ACTIONS(3971),
    [anon_sym_typedef] = ACTIONS(3971),
    [anon_sym_in] = ACTIONS(3971),
    [anon_sym_out] = ACTIONS(3971),
    [anon_sym_inout] = ACTIONS(3971),
    [anon_sym_virtual] = ACTIONS(3971),
    [anon_sym_extern] = ACTIONS(3971),
    [anon_sym___attribute__] = ACTIONS(3971),
    [anon_sym___attribute] = ACTIONS(3971),
    [anon_sym_using] = ACTIONS(3971),
    [anon_sym_COLON_COLON] = ACTIONS(3974),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3974),
    [anon_sym___declspec] = ACTIONS(3971),
    [anon_sym___based] = ACTIONS(3971),
    [anon_sym___cdecl] = ACTIONS(3971),
    [anon_sym___clrcall] = ACTIONS(3971),
    [anon_sym___stdcall] = ACTIONS(3971),
    [anon_sym___fastcall] = ACTIONS(3971),
    [anon_sym___thiscall] = ACTIONS(3971),
    [anon_sym___vectorcall] = ACTIONS(3971),
    [anon_sym_LBRACE] = ACTIONS(3974),
    [anon_sym_signed] = ACTIONS(3971),
    [anon_sym_unsigned] = ACTIONS(3971),
    [anon_sym_long] = ACTIONS(3971),
    [anon_sym_short] = ACTIONS(3971),
    [anon_sym_LBRACK] = ACTIONS(3971),
    [anon_sym_static] = ACTIONS(3971),
    [anon_sym_register] = ACTIONS(3971),
    [anon_sym_inline] = ACTIONS(3971),
    [anon_sym___inline] = ACTIONS(3971),
    [anon_sym___inline__] = ACTIONS(3971),
    [anon_sym___forceinline] = ACTIONS(3971),
    [anon_sym_thread_local] = ACTIONS(3971),
    [anon_sym___thread] = ACTIONS(3971),
    [anon_sym_const] = ACTIONS(3971),
    [anon_sym_constexpr] = ACTIONS(3971),
    [anon_sym_volatile] = ACTIONS(3971),
    [anon_sym_restrict] = ACTIONS(3971),
    [anon_sym___restrict__] = ACTIONS(3971),
    [anon_sym__Atomic] = ACTIONS(3971),
    [anon_sym__Noreturn] = ACTIONS(3971),
    [anon_sym_noreturn] = ACTIONS(3971),
    [anon_sym__Nonnull] = ACTIONS(3971),
    [anon_sym_mutable] = ACTIONS(3971),
    [anon_sym_constinit] = ACTIONS(3971),
    [anon_sym_consteval] = ACTIONS(3971),
    [anon_sym_alignas] = ACTIONS(3971),
    [anon_sym__Alignas] = ACTIONS(3971),
    [sym_primitive_type] = ACTIONS(3971),
    [anon_sym_enum] = ACTIONS(3971),
    [anon_sym_class] = ACTIONS(3971),
    [anon_sym_struct] = ACTIONS(3971),
    [anon_sym_union] = ACTIONS(3971),
    [anon_sym_if] = ACTIONS(3971),
    [anon_sym_switch] = ACTIONS(3971),
    [anon_sym_case] = ACTIONS(3971),
    [anon_sym_default] = ACTIONS(3971),
    [anon_sym_while] = ACTIONS(3971),
    [anon_sym_do] = ACTIONS(3971),
    [anon_sym_for] = ACTIONS(3971),
    [anon_sym_return] = ACTIONS(3971),
    [anon_sym_break] = ACTIONS(3971),
    [anon_sym_continue] = ACTIONS(3971),
    [anon_sym_goto] = ACTIONS(3971),
    [anon_sym___try] = ACTIONS(3971),
    [anon_sym___leave] = ACTIONS(3971),
    [anon_sym_not] = ACTIONS(3971),
    [anon_sym_compl] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3974),
    [anon_sym_PLUS_PLUS] = ACTIONS(3974),
    [anon_sym_sizeof] = ACTIONS(3971),
    [anon_sym___alignof__] = ACTIONS(3971),
    [anon_sym___alignof] = ACTIONS(3971),
    [anon_sym__alignof] = ACTIONS(3971),
    [anon_sym_alignof] = ACTIONS(3971),
    [anon_sym__Alignof] = ACTIONS(3971),
    [anon_sym_offsetof] = ACTIONS(3971),
    [anon_sym__Generic] = ACTIONS(3971),
    [anon_sym_asm] = ACTIONS(3971),
    [anon_sym___asm__] = ACTIONS(3971),
    [anon_sym___asm] = ACTIONS(3971),
    [sym_number_literal] = ACTIONS(3974),
    [anon_sym_L_SQUOTE] = ACTIONS(3974),
    [anon_sym_u_SQUOTE] = ACTIONS(3974),
    [anon_sym_U_SQUOTE] = ACTIONS(3974),
    [anon_sym_u8_SQUOTE] = ACTIONS(3974),
    [anon_sym_SQUOTE] = ACTIONS(3974),
    [anon_sym_L_DQUOTE] = ACTIONS(3974),
    [anon_sym_u_DQUOTE] = ACTIONS(3974),
    [anon_sym_U_DQUOTE] = ACTIONS(3974),
    [anon_sym_u8_DQUOTE] = ACTIONS(3974),
    [anon_sym_DQUOTE] = ACTIONS(3974),
    [sym_true] = ACTIONS(3971),
    [sym_false] = ACTIONS(3971),
    [anon_sym_NULL] = ACTIONS(3971),
    [anon_sym_nullptr] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3971),
    [anon_sym_let] = ACTIONS(3971),
    [anon_sym_This] = ACTIONS(3971),
    [anon_sym_decltype] = ACTIONS(3971),
    [anon_sym_explicit] = ACTIONS(3971),
    [anon_sym_typename] = ACTIONS(3971),
    [anon_sym_template] = ACTIONS(3971),
    [anon_sym_operator] = ACTIONS(3971),
    [anon_sym_try] = ACTIONS(3971),
    [anon_sym_delete] = ACTIONS(3971),
    [anon_sym_throw] = ACTIONS(3971),
    [anon_sym_namespace] = ACTIONS(3971),
    [anon_sym_static_assert] = ACTIONS(3971),
    [anon_sym_concept] = ACTIONS(3971),
    [anon_sym_co_return] = ACTIONS(3971),
    [anon_sym_co_yield] = ACTIONS(3971),
    [anon_sym_R_DQUOTE] = ACTIONS(3974),
    [anon_sym_LR_DQUOTE] = ACTIONS(3974),
    [anon_sym_uR_DQUOTE] = ACTIONS(3974),
    [anon_sym_UR_DQUOTE] = ACTIONS(3974),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3974),
    [anon_sym_co_await] = ACTIONS(3971),
    [anon_sym_new] = ACTIONS(3971),
    [anon_sym_requires] = ACTIONS(3971),
    [sym_this] = ACTIONS(3971),
    [anon_sym_discard] = ACTIONS(3971),
    [anon_sym_precise] = ACTIONS(3971),
    [anon_sym_shared] = ACTIONS(3971),
    [anon_sym_groupshared] = ACTIONS(3971),
    [anon_sym_uniform] = ACTIONS(3971),
    [anon_sym_row_major] = ACTIONS(3971),
    [anon_sym_column_major] = ACTIONS(3971),
    [anon_sym_globallycoherent] = ACTIONS(3971),
    [anon_sym_centroid] = ACTIONS(3971),
    [anon_sym_noperspective] = ACTIONS(3971),
    [anon_sym_nointerpolation] = ACTIONS(3971),
    [anon_sym_sample] = ACTIONS(3971),
    [anon_sym_linear] = ACTIONS(3971),
    [anon_sym_snorm] = ACTIONS(3971),
    [anon_sym_unorm] = ACTIONS(3971),
    [anon_sym_point] = ACTIONS(3971),
    [anon_sym_line] = ACTIONS(3971),
    [anon_sym_triangleadj] = ACTIONS(3971),
    [anon_sym_lineadj] = ACTIONS(3971),
    [anon_sym_triangle] = ACTIONS(3971),
    [anon_sym_cbuffer] = ACTIONS(3971),
    [anon_sym_interface] = ACTIONS(3971),
    [anon_sym_extension] = ACTIONS(3971),
  },
  [1120] = {
    [sym_identifier] = ACTIONS(3913),
    [aux_sym_preproc_include_token1] = ACTIONS(3913),
    [aux_sym_preproc_def_token1] = ACTIONS(3913),
    [aux_sym_preproc_if_token1] = ACTIONS(3913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3913),
    [sym_preproc_directive] = ACTIONS(3913),
    [anon_sym_LPAREN2] = ACTIONS(3915),
    [anon_sym_BANG] = ACTIONS(3915),
    [anon_sym_TILDE] = ACTIONS(3915),
    [anon_sym_DASH] = ACTIONS(3913),
    [anon_sym_PLUS] = ACTIONS(3913),
    [anon_sym_STAR] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3913),
    [anon_sym_SEMI] = ACTIONS(3915),
    [anon_sym___extension__] = ACTIONS(3913),
    [anon_sym_typedef] = ACTIONS(3913),
    [anon_sym_in] = ACTIONS(3913),
    [anon_sym_out] = ACTIONS(3913),
    [anon_sym_inout] = ACTIONS(3913),
    [anon_sym_virtual] = ACTIONS(3913),
    [anon_sym_extern] = ACTIONS(3913),
    [anon_sym___attribute__] = ACTIONS(3913),
    [anon_sym___attribute] = ACTIONS(3913),
    [anon_sym_using] = ACTIONS(3913),
    [anon_sym_COLON_COLON] = ACTIONS(3915),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3915),
    [anon_sym___declspec] = ACTIONS(3913),
    [anon_sym___based] = ACTIONS(3913),
    [anon_sym___cdecl] = ACTIONS(3913),
    [anon_sym___clrcall] = ACTIONS(3913),
    [anon_sym___stdcall] = ACTIONS(3913),
    [anon_sym___fastcall] = ACTIONS(3913),
    [anon_sym___thiscall] = ACTIONS(3913),
    [anon_sym___vectorcall] = ACTIONS(3913),
    [anon_sym_LBRACE] = ACTIONS(3915),
    [anon_sym_RBRACE] = ACTIONS(3915),
    [anon_sym_signed] = ACTIONS(3913),
    [anon_sym_unsigned] = ACTIONS(3913),
    [anon_sym_long] = ACTIONS(3913),
    [anon_sym_short] = ACTIONS(3913),
    [anon_sym_LBRACK] = ACTIONS(3913),
    [anon_sym_static] = ACTIONS(3913),
    [anon_sym_register] = ACTIONS(3913),
    [anon_sym_inline] = ACTIONS(3913),
    [anon_sym___inline] = ACTIONS(3913),
    [anon_sym___inline__] = ACTIONS(3913),
    [anon_sym___forceinline] = ACTIONS(3913),
    [anon_sym_thread_local] = ACTIONS(3913),
    [anon_sym___thread] = ACTIONS(3913),
    [anon_sym_const] = ACTIONS(3913),
    [anon_sym_constexpr] = ACTIONS(3913),
    [anon_sym_volatile] = ACTIONS(3913),
    [anon_sym_restrict] = ACTIONS(3913),
    [anon_sym___restrict__] = ACTIONS(3913),
    [anon_sym__Atomic] = ACTIONS(3913),
    [anon_sym__Noreturn] = ACTIONS(3913),
    [anon_sym_noreturn] = ACTIONS(3913),
    [anon_sym__Nonnull] = ACTIONS(3913),
    [anon_sym_mutable] = ACTIONS(3913),
    [anon_sym_constinit] = ACTIONS(3913),
    [anon_sym_consteval] = ACTIONS(3913),
    [anon_sym_alignas] = ACTIONS(3913),
    [anon_sym__Alignas] = ACTIONS(3913),
    [sym_primitive_type] = ACTIONS(3913),
    [anon_sym_enum] = ACTIONS(3913),
    [anon_sym_class] = ACTIONS(3913),
    [anon_sym_struct] = ACTIONS(3913),
    [anon_sym_union] = ACTIONS(3913),
    [anon_sym_if] = ACTIONS(3913),
    [anon_sym_switch] = ACTIONS(3913),
    [anon_sym_case] = ACTIONS(3913),
    [anon_sym_default] = ACTIONS(3913),
    [anon_sym_while] = ACTIONS(3913),
    [anon_sym_do] = ACTIONS(3913),
    [anon_sym_for] = ACTIONS(3913),
    [anon_sym_return] = ACTIONS(3913),
    [anon_sym_break] = ACTIONS(3913),
    [anon_sym_continue] = ACTIONS(3913),
    [anon_sym_goto] = ACTIONS(3913),
    [anon_sym___try] = ACTIONS(3913),
    [anon_sym___leave] = ACTIONS(3913),
    [anon_sym_not] = ACTIONS(3913),
    [anon_sym_compl] = ACTIONS(3913),
    [anon_sym_DASH_DASH] = ACTIONS(3915),
    [anon_sym_PLUS_PLUS] = ACTIONS(3915),
    [anon_sym_sizeof] = ACTIONS(3913),
    [anon_sym___alignof__] = ACTIONS(3913),
    [anon_sym___alignof] = ACTIONS(3913),
    [anon_sym__alignof] = ACTIONS(3913),
    [anon_sym_alignof] = ACTIONS(3913),
    [anon_sym__Alignof] = ACTIONS(3913),
    [anon_sym_offsetof] = ACTIONS(3913),
    [anon_sym__Generic] = ACTIONS(3913),
    [anon_sym_asm] = ACTIONS(3913),
    [anon_sym___asm__] = ACTIONS(3913),
    [anon_sym___asm] = ACTIONS(3913),
    [sym_number_literal] = ACTIONS(3915),
    [anon_sym_L_SQUOTE] = ACTIONS(3915),
    [anon_sym_u_SQUOTE] = ACTIONS(3915),
    [anon_sym_U_SQUOTE] = ACTIONS(3915),
    [anon_sym_u8_SQUOTE] = ACTIONS(3915),
    [anon_sym_SQUOTE] = ACTIONS(3915),
    [anon_sym_L_DQUOTE] = ACTIONS(3915),
    [anon_sym_u_DQUOTE] = ACTIONS(3915),
    [anon_sym_U_DQUOTE] = ACTIONS(3915),
    [anon_sym_u8_DQUOTE] = ACTIONS(3915),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [sym_true] = ACTIONS(3913),
    [sym_false] = ACTIONS(3913),
    [anon_sym_NULL] = ACTIONS(3913),
    [anon_sym_nullptr] = ACTIONS(3913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3913),
    [anon_sym_let] = ACTIONS(3913),
    [anon_sym_This] = ACTIONS(3913),
    [anon_sym_decltype] = ACTIONS(3913),
    [anon_sym_explicit] = ACTIONS(3913),
    [anon_sym_typename] = ACTIONS(3913),
    [anon_sym_template] = ACTIONS(3913),
    [anon_sym_operator] = ACTIONS(3913),
    [anon_sym_try] = ACTIONS(3913),
    [anon_sym_delete] = ACTIONS(3913),
    [anon_sym_throw] = ACTIONS(3913),
    [anon_sym_namespace] = ACTIONS(3913),
    [anon_sym_static_assert] = ACTIONS(3913),
    [anon_sym_concept] = ACTIONS(3913),
    [anon_sym_co_return] = ACTIONS(3913),
    [anon_sym_co_yield] = ACTIONS(3913),
    [anon_sym_R_DQUOTE] = ACTIONS(3915),
    [anon_sym_LR_DQUOTE] = ACTIONS(3915),
    [anon_sym_uR_DQUOTE] = ACTIONS(3915),
    [anon_sym_UR_DQUOTE] = ACTIONS(3915),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3915),
    [anon_sym_co_await] = ACTIONS(3913),
    [anon_sym_new] = ACTIONS(3913),
    [anon_sym_requires] = ACTIONS(3913),
    [sym_this] = ACTIONS(3913),
    [anon_sym_discard] = ACTIONS(3913),
    [anon_sym_precise] = ACTIONS(3913),
    [anon_sym_shared] = ACTIONS(3913),
    [anon_sym_groupshared] = ACTIONS(3913),
    [anon_sym_uniform] = ACTIONS(3913),
    [anon_sym_row_major] = ACTIONS(3913),
    [anon_sym_column_major] = ACTIONS(3913),
    [anon_sym_globallycoherent] = ACTIONS(3913),
    [anon_sym_centroid] = ACTIONS(3913),
    [anon_sym_noperspective] = ACTIONS(3913),
    [anon_sym_nointerpolation] = ACTIONS(3913),
    [anon_sym_sample] = ACTIONS(3913),
    [anon_sym_linear] = ACTIONS(3913),
    [anon_sym_snorm] = ACTIONS(3913),
    [anon_sym_unorm] = ACTIONS(3913),
    [anon_sym_point] = ACTIONS(3913),
    [anon_sym_line] = ACTIONS(3913),
    [anon_sym_triangleadj] = ACTIONS(3913),
    [anon_sym_lineadj] = ACTIONS(3913),
    [anon_sym_triangle] = ACTIONS(3913),
    [anon_sym_cbuffer] = ACTIONS(3913),
    [anon_sym_interface] = ACTIONS(3913),
    [anon_sym_extension] = ACTIONS(3913),
  },
  [1121] = {
    [ts_builtin_sym_end] = ACTIONS(3769),
    [sym_identifier] = ACTIONS(3767),
    [aux_sym_preproc_include_token1] = ACTIONS(3767),
    [aux_sym_preproc_def_token1] = ACTIONS(3767),
    [aux_sym_preproc_if_token1] = ACTIONS(3767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3767),
    [sym_preproc_directive] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3769),
    [anon_sym_BANG] = ACTIONS(3769),
    [anon_sym_TILDE] = ACTIONS(3769),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_AMP_AMP] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_SEMI] = ACTIONS(3769),
    [anon_sym___extension__] = ACTIONS(3767),
    [anon_sym_typedef] = ACTIONS(3767),
    [anon_sym_in] = ACTIONS(3767),
    [anon_sym_out] = ACTIONS(3767),
    [anon_sym_inout] = ACTIONS(3767),
    [anon_sym_virtual] = ACTIONS(3767),
    [anon_sym_extern] = ACTIONS(3767),
    [anon_sym___attribute__] = ACTIONS(3767),
    [anon_sym___attribute] = ACTIONS(3767),
    [anon_sym_using] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3769),
    [anon_sym___declspec] = ACTIONS(3767),
    [anon_sym___based] = ACTIONS(3767),
    [anon_sym___cdecl] = ACTIONS(3767),
    [anon_sym___clrcall] = ACTIONS(3767),
    [anon_sym___stdcall] = ACTIONS(3767),
    [anon_sym___fastcall] = ACTIONS(3767),
    [anon_sym___thiscall] = ACTIONS(3767),
    [anon_sym___vectorcall] = ACTIONS(3767),
    [anon_sym_LBRACE] = ACTIONS(3769),
    [anon_sym_signed] = ACTIONS(3767),
    [anon_sym_unsigned] = ACTIONS(3767),
    [anon_sym_long] = ACTIONS(3767),
    [anon_sym_short] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_static] = ACTIONS(3767),
    [anon_sym_register] = ACTIONS(3767),
    [anon_sym_inline] = ACTIONS(3767),
    [anon_sym___inline] = ACTIONS(3767),
    [anon_sym___inline__] = ACTIONS(3767),
    [anon_sym___forceinline] = ACTIONS(3767),
    [anon_sym_thread_local] = ACTIONS(3767),
    [anon_sym___thread] = ACTIONS(3767),
    [anon_sym_const] = ACTIONS(3767),
    [anon_sym_constexpr] = ACTIONS(3767),
    [anon_sym_volatile] = ACTIONS(3767),
    [anon_sym_restrict] = ACTIONS(3767),
    [anon_sym___restrict__] = ACTIONS(3767),
    [anon_sym__Atomic] = ACTIONS(3767),
    [anon_sym__Noreturn] = ACTIONS(3767),
    [anon_sym_noreturn] = ACTIONS(3767),
    [anon_sym__Nonnull] = ACTIONS(3767),
    [anon_sym_mutable] = ACTIONS(3767),
    [anon_sym_constinit] = ACTIONS(3767),
    [anon_sym_consteval] = ACTIONS(3767),
    [anon_sym_alignas] = ACTIONS(3767),
    [anon_sym__Alignas] = ACTIONS(3767),
    [sym_primitive_type] = ACTIONS(3767),
    [anon_sym_enum] = ACTIONS(3767),
    [anon_sym_class] = ACTIONS(3767),
    [anon_sym_struct] = ACTIONS(3767),
    [anon_sym_union] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_switch] = ACTIONS(3767),
    [anon_sym_case] = ACTIONS(3767),
    [anon_sym_default] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_break] = ACTIONS(3767),
    [anon_sym_continue] = ACTIONS(3767),
    [anon_sym_goto] = ACTIONS(3767),
    [anon_sym_not] = ACTIONS(3767),
    [anon_sym_compl] = ACTIONS(3767),
    [anon_sym_DASH_DASH] = ACTIONS(3769),
    [anon_sym_PLUS_PLUS] = ACTIONS(3769),
    [anon_sym_sizeof] = ACTIONS(3767),
    [anon_sym___alignof__] = ACTIONS(3767),
    [anon_sym___alignof] = ACTIONS(3767),
    [anon_sym__alignof] = ACTIONS(3767),
    [anon_sym_alignof] = ACTIONS(3767),
    [anon_sym__Alignof] = ACTIONS(3767),
    [anon_sym_offsetof] = ACTIONS(3767),
    [anon_sym__Generic] = ACTIONS(3767),
    [anon_sym_asm] = ACTIONS(3767),
    [anon_sym___asm__] = ACTIONS(3767),
    [anon_sym___asm] = ACTIONS(3767),
    [sym_number_literal] = ACTIONS(3769),
    [anon_sym_L_SQUOTE] = ACTIONS(3769),
    [anon_sym_u_SQUOTE] = ACTIONS(3769),
    [anon_sym_U_SQUOTE] = ACTIONS(3769),
    [anon_sym_u8_SQUOTE] = ACTIONS(3769),
    [anon_sym_SQUOTE] = ACTIONS(3769),
    [anon_sym_L_DQUOTE] = ACTIONS(3769),
    [anon_sym_u_DQUOTE] = ACTIONS(3769),
    [anon_sym_U_DQUOTE] = ACTIONS(3769),
    [anon_sym_u8_DQUOTE] = ACTIONS(3769),
    [anon_sym_DQUOTE] = ACTIONS(3769),
    [sym_true] = ACTIONS(3767),
    [sym_false] = ACTIONS(3767),
    [anon_sym_NULL] = ACTIONS(3767),
    [anon_sym_nullptr] = ACTIONS(3767),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_This] = ACTIONS(3767),
    [anon_sym_decltype] = ACTIONS(3767),
    [anon_sym_explicit] = ACTIONS(3767),
    [anon_sym_typename] = ACTIONS(3767),
    [anon_sym_export] = ACTIONS(3767),
    [anon_sym_module] = ACTIONS(3767),
    [anon_sym_import] = ACTIONS(3767),
    [anon_sym_template] = ACTIONS(3767),
    [anon_sym_operator] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_delete] = ACTIONS(3767),
    [anon_sym_throw] = ACTIONS(3767),
    [anon_sym_namespace] = ACTIONS(3767),
    [anon_sym_static_assert] = ACTIONS(3767),
    [anon_sym_concept] = ACTIONS(3767),
    [anon_sym_co_return] = ACTIONS(3767),
    [anon_sym_co_yield] = ACTIONS(3767),
    [anon_sym_R_DQUOTE] = ACTIONS(3769),
    [anon_sym_LR_DQUOTE] = ACTIONS(3769),
    [anon_sym_uR_DQUOTE] = ACTIONS(3769),
    [anon_sym_UR_DQUOTE] = ACTIONS(3769),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3769),
    [anon_sym_co_await] = ACTIONS(3767),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_requires] = ACTIONS(3767),
    [sym_this] = ACTIONS(3767),
    [anon_sym_precise] = ACTIONS(3767),
    [anon_sym_shared] = ACTIONS(3767),
    [anon_sym_groupshared] = ACTIONS(3767),
    [anon_sym_uniform] = ACTIONS(3767),
    [anon_sym_row_major] = ACTIONS(3767),
    [anon_sym_column_major] = ACTIONS(3767),
    [anon_sym_globallycoherent] = ACTIONS(3767),
    [anon_sym_centroid] = ACTIONS(3767),
    [anon_sym_noperspective] = ACTIONS(3767),
    [anon_sym_nointerpolation] = ACTIONS(3767),
    [anon_sym_sample] = ACTIONS(3767),
    [anon_sym_linear] = ACTIONS(3767),
    [anon_sym_snorm] = ACTIONS(3767),
    [anon_sym_unorm] = ACTIONS(3767),
    [anon_sym_point] = ACTIONS(3767),
    [anon_sym_line] = ACTIONS(3767),
    [anon_sym_triangleadj] = ACTIONS(3767),
    [anon_sym_lineadj] = ACTIONS(3767),
    [anon_sym_triangle] = ACTIONS(3767),
    [anon_sym_interface] = ACTIONS(3767),
    [anon_sym_extension] = ACTIONS(3767),
    [anon_sym___exported] = ACTIONS(3767),
  },
  [1122] = {
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_include_token1] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token2] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_BANG] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym___cdecl] = ACTIONS(3942),
    [anon_sym___clrcall] = ACTIONS(3942),
    [anon_sym___stdcall] = ACTIONS(3942),
    [anon_sym___fastcall] = ACTIONS(3942),
    [anon_sym___thiscall] = ACTIONS(3942),
    [anon_sym___vectorcall] = ACTIONS(3942),
    [anon_sym_LBRACE] = ACTIONS(3944),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_switch] = ACTIONS(3942),
    [anon_sym_case] = ACTIONS(3942),
    [anon_sym_default] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_break] = ACTIONS(3942),
    [anon_sym_continue] = ACTIONS(3942),
    [anon_sym_goto] = ACTIONS(3942),
    [anon_sym___try] = ACTIONS(3942),
    [anon_sym___leave] = ACTIONS(3942),
    [anon_sym_not] = ACTIONS(3942),
    [anon_sym_compl] = ACTIONS(3942),
    [anon_sym_DASH_DASH] = ACTIONS(3944),
    [anon_sym_PLUS_PLUS] = ACTIONS(3944),
    [anon_sym_sizeof] = ACTIONS(3942),
    [anon_sym___alignof__] = ACTIONS(3942),
    [anon_sym___alignof] = ACTIONS(3942),
    [anon_sym__alignof] = ACTIONS(3942),
    [anon_sym_alignof] = ACTIONS(3942),
    [anon_sym__Alignof] = ACTIONS(3942),
    [anon_sym_offsetof] = ACTIONS(3942),
    [anon_sym__Generic] = ACTIONS(3942),
    [anon_sym_asm] = ACTIONS(3942),
    [anon_sym___asm__] = ACTIONS(3942),
    [anon_sym___asm] = ACTIONS(3942),
    [sym_number_literal] = ACTIONS(3944),
    [anon_sym_L_SQUOTE] = ACTIONS(3944),
    [anon_sym_u_SQUOTE] = ACTIONS(3944),
    [anon_sym_U_SQUOTE] = ACTIONS(3944),
    [anon_sym_u8_SQUOTE] = ACTIONS(3944),
    [anon_sym_SQUOTE] = ACTIONS(3944),
    [anon_sym_L_DQUOTE] = ACTIONS(3944),
    [anon_sym_u_DQUOTE] = ACTIONS(3944),
    [anon_sym_U_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE] = ACTIONS(3944),
    [sym_true] = ACTIONS(3942),
    [sym_false] = ACTIONS(3942),
    [anon_sym_NULL] = ACTIONS(3942),
    [anon_sym_nullptr] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_delete] = ACTIONS(3942),
    [anon_sym_throw] = ACTIONS(3942),
    [anon_sym_namespace] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_concept] = ACTIONS(3942),
    [anon_sym_co_return] = ACTIONS(3942),
    [anon_sym_co_yield] = ACTIONS(3942),
    [anon_sym_R_DQUOTE] = ACTIONS(3944),
    [anon_sym_LR_DQUOTE] = ACTIONS(3944),
    [anon_sym_uR_DQUOTE] = ACTIONS(3944),
    [anon_sym_UR_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3944),
    [anon_sym_co_await] = ACTIONS(3942),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_requires] = ACTIONS(3942),
    [sym_this] = ACTIONS(3942),
    [anon_sym_discard] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_cbuffer] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
  },
  [1123] = {
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_include_token1] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token2] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_BANG] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(3942),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym___cdecl] = ACTIONS(3942),
    [anon_sym___clrcall] = ACTIONS(3942),
    [anon_sym___stdcall] = ACTIONS(3942),
    [anon_sym___fastcall] = ACTIONS(3942),
    [anon_sym___thiscall] = ACTIONS(3942),
    [anon_sym___vectorcall] = ACTIONS(3942),
    [anon_sym_LBRACE] = ACTIONS(3944),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [anon_sym_if] = ACTIONS(3942),
    [anon_sym_switch] = ACTIONS(3942),
    [anon_sym_case] = ACTIONS(3942),
    [anon_sym_default] = ACTIONS(3942),
    [anon_sym_while] = ACTIONS(3942),
    [anon_sym_do] = ACTIONS(3942),
    [anon_sym_for] = ACTIONS(3942),
    [anon_sym_return] = ACTIONS(3942),
    [anon_sym_break] = ACTIONS(3942),
    [anon_sym_continue] = ACTIONS(3942),
    [anon_sym_goto] = ACTIONS(3942),
    [anon_sym___try] = ACTIONS(3942),
    [anon_sym___leave] = ACTIONS(3942),
    [anon_sym_not] = ACTIONS(3942),
    [anon_sym_compl] = ACTIONS(3942),
    [anon_sym_DASH_DASH] = ACTIONS(3944),
    [anon_sym_PLUS_PLUS] = ACTIONS(3944),
    [anon_sym_sizeof] = ACTIONS(3942),
    [anon_sym___alignof__] = ACTIONS(3942),
    [anon_sym___alignof] = ACTIONS(3942),
    [anon_sym__alignof] = ACTIONS(3942),
    [anon_sym_alignof] = ACTIONS(3942),
    [anon_sym__Alignof] = ACTIONS(3942),
    [anon_sym_offsetof] = ACTIONS(3942),
    [anon_sym__Generic] = ACTIONS(3942),
    [anon_sym_asm] = ACTIONS(3942),
    [anon_sym___asm__] = ACTIONS(3942),
    [anon_sym___asm] = ACTIONS(3942),
    [sym_number_literal] = ACTIONS(3944),
    [anon_sym_L_SQUOTE] = ACTIONS(3944),
    [anon_sym_u_SQUOTE] = ACTIONS(3944),
    [anon_sym_U_SQUOTE] = ACTIONS(3944),
    [anon_sym_u8_SQUOTE] = ACTIONS(3944),
    [anon_sym_SQUOTE] = ACTIONS(3944),
    [anon_sym_L_DQUOTE] = ACTIONS(3944),
    [anon_sym_u_DQUOTE] = ACTIONS(3944),
    [anon_sym_U_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8_DQUOTE] = ACTIONS(3944),
    [anon_sym_DQUOTE] = ACTIONS(3944),
    [sym_true] = ACTIONS(3942),
    [sym_false] = ACTIONS(3942),
    [anon_sym_NULL] = ACTIONS(3942),
    [anon_sym_nullptr] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_try] = ACTIONS(3942),
    [anon_sym_delete] = ACTIONS(3942),
    [anon_sym_throw] = ACTIONS(3942),
    [anon_sym_namespace] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_concept] = ACTIONS(3942),
    [anon_sym_co_return] = ACTIONS(3942),
    [anon_sym_co_yield] = ACTIONS(3942),
    [anon_sym_R_DQUOTE] = ACTIONS(3944),
    [anon_sym_LR_DQUOTE] = ACTIONS(3944),
    [anon_sym_uR_DQUOTE] = ACTIONS(3944),
    [anon_sym_UR_DQUOTE] = ACTIONS(3944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3944),
    [anon_sym_co_await] = ACTIONS(3942),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_requires] = ACTIONS(3942),
    [sym_this] = ACTIONS(3942),
    [anon_sym_discard] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_cbuffer] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
  },
  [1124] = {
    [sym_identifier] = ACTIONS(3759),
    [aux_sym_preproc_include_token1] = ACTIONS(3759),
    [aux_sym_preproc_def_token1] = ACTIONS(3759),
    [aux_sym_preproc_if_token1] = ACTIONS(3759),
    [aux_sym_preproc_if_token2] = ACTIONS(3759),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3759),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3759),
    [sym_preproc_directive] = ACTIONS(3759),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_BANG] = ACTIONS(3761),
    [anon_sym_TILDE] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_STAR] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym___extension__] = ACTIONS(3759),
    [anon_sym_typedef] = ACTIONS(3759),
    [anon_sym_in] = ACTIONS(3759),
    [anon_sym_out] = ACTIONS(3759),
    [anon_sym_inout] = ACTIONS(3759),
    [anon_sym_virtual] = ACTIONS(3759),
    [anon_sym_extern] = ACTIONS(3759),
    [anon_sym___attribute__] = ACTIONS(3759),
    [anon_sym___attribute] = ACTIONS(3759),
    [anon_sym_using] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3761),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3761),
    [anon_sym___declspec] = ACTIONS(3759),
    [anon_sym___based] = ACTIONS(3759),
    [anon_sym___cdecl] = ACTIONS(3759),
    [anon_sym___clrcall] = ACTIONS(3759),
    [anon_sym___stdcall] = ACTIONS(3759),
    [anon_sym___fastcall] = ACTIONS(3759),
    [anon_sym___thiscall] = ACTIONS(3759),
    [anon_sym___vectorcall] = ACTIONS(3759),
    [anon_sym_LBRACE] = ACTIONS(3761),
    [anon_sym_signed] = ACTIONS(3759),
    [anon_sym_unsigned] = ACTIONS(3759),
    [anon_sym_long] = ACTIONS(3759),
    [anon_sym_short] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_register] = ACTIONS(3759),
    [anon_sym_inline] = ACTIONS(3759),
    [anon_sym___inline] = ACTIONS(3759),
    [anon_sym___inline__] = ACTIONS(3759),
    [anon_sym___forceinline] = ACTIONS(3759),
    [anon_sym_thread_local] = ACTIONS(3759),
    [anon_sym___thread] = ACTIONS(3759),
    [anon_sym_const] = ACTIONS(3759),
    [anon_sym_constexpr] = ACTIONS(3759),
    [anon_sym_volatile] = ACTIONS(3759),
    [anon_sym_restrict] = ACTIONS(3759),
    [anon_sym___restrict__] = ACTIONS(3759),
    [anon_sym__Atomic] = ACTIONS(3759),
    [anon_sym__Noreturn] = ACTIONS(3759),
    [anon_sym_noreturn] = ACTIONS(3759),
    [anon_sym__Nonnull] = ACTIONS(3759),
    [anon_sym_mutable] = ACTIONS(3759),
    [anon_sym_constinit] = ACTIONS(3759),
    [anon_sym_consteval] = ACTIONS(3759),
    [anon_sym_alignas] = ACTIONS(3759),
    [anon_sym__Alignas] = ACTIONS(3759),
    [sym_primitive_type] = ACTIONS(3759),
    [anon_sym_enum] = ACTIONS(3759),
    [anon_sym_class] = ACTIONS(3759),
    [anon_sym_struct] = ACTIONS(3759),
    [anon_sym_union] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_switch] = ACTIONS(3759),
    [anon_sym_case] = ACTIONS(3759),
    [anon_sym_default] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_break] = ACTIONS(3759),
    [anon_sym_continue] = ACTIONS(3759),
    [anon_sym_goto] = ACTIONS(3759),
    [anon_sym___try] = ACTIONS(3759),
    [anon_sym___leave] = ACTIONS(3759),
    [anon_sym_not] = ACTIONS(3759),
    [anon_sym_compl] = ACTIONS(3759),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_sizeof] = ACTIONS(3759),
    [anon_sym___alignof__] = ACTIONS(3759),
    [anon_sym___alignof] = ACTIONS(3759),
    [anon_sym__alignof] = ACTIONS(3759),
    [anon_sym_alignof] = ACTIONS(3759),
    [anon_sym__Alignof] = ACTIONS(3759),
    [anon_sym_offsetof] = ACTIONS(3759),
    [anon_sym__Generic] = ACTIONS(3759),
    [anon_sym_asm] = ACTIONS(3759),
    [anon_sym___asm__] = ACTIONS(3759),
    [anon_sym___asm] = ACTIONS(3759),
    [sym_number_literal] = ACTIONS(3761),
    [anon_sym_L_SQUOTE] = ACTIONS(3761),
    [anon_sym_u_SQUOTE] = ACTIONS(3761),
    [anon_sym_U_SQUOTE] = ACTIONS(3761),
    [anon_sym_u8_SQUOTE] = ACTIONS(3761),
    [anon_sym_SQUOTE] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3761),
    [anon_sym_u_DQUOTE] = ACTIONS(3761),
    [anon_sym_U_DQUOTE] = ACTIONS(3761),
    [anon_sym_u8_DQUOTE] = ACTIONS(3761),
    [anon_sym_DQUOTE] = ACTIONS(3761),
    [sym_true] = ACTIONS(3759),
    [sym_false] = ACTIONS(3759),
    [anon_sym_NULL] = ACTIONS(3759),
    [anon_sym_nullptr] = ACTIONS(3759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_This] = ACTIONS(3759),
    [anon_sym_decltype] = ACTIONS(3759),
    [anon_sym_explicit] = ACTIONS(3759),
    [anon_sym_typename] = ACTIONS(3759),
    [anon_sym_template] = ACTIONS(3759),
    [anon_sym_operator] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_delete] = ACTIONS(3759),
    [anon_sym_throw] = ACTIONS(3759),
    [anon_sym_namespace] = ACTIONS(3759),
    [anon_sym_static_assert] = ACTIONS(3759),
    [anon_sym_concept] = ACTIONS(3759),
    [anon_sym_co_return] = ACTIONS(3759),
    [anon_sym_co_yield] = ACTIONS(3759),
    [anon_sym_R_DQUOTE] = ACTIONS(3761),
    [anon_sym_LR_DQUOTE] = ACTIONS(3761),
    [anon_sym_uR_DQUOTE] = ACTIONS(3761),
    [anon_sym_UR_DQUOTE] = ACTIONS(3761),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3761),
    [anon_sym_co_await] = ACTIONS(3759),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_requires] = ACTIONS(3759),
    [sym_this] = ACTIONS(3759),
    [anon_sym_discard] = ACTIONS(3759),
    [anon_sym_precise] = ACTIONS(3759),
    [anon_sym_shared] = ACTIONS(3759),
    [anon_sym_groupshared] = ACTIONS(3759),
    [anon_sym_uniform] = ACTIONS(3759),
    [anon_sym_row_major] = ACTIONS(3759),
    [anon_sym_column_major] = ACTIONS(3759),
    [anon_sym_globallycoherent] = ACTIONS(3759),
    [anon_sym_centroid] = ACTIONS(3759),
    [anon_sym_noperspective] = ACTIONS(3759),
    [anon_sym_nointerpolation] = ACTIONS(3759),
    [anon_sym_sample] = ACTIONS(3759),
    [anon_sym_linear] = ACTIONS(3759),
    [anon_sym_snorm] = ACTIONS(3759),
    [anon_sym_unorm] = ACTIONS(3759),
    [anon_sym_point] = ACTIONS(3759),
    [anon_sym_line] = ACTIONS(3759),
    [anon_sym_triangleadj] = ACTIONS(3759),
    [anon_sym_lineadj] = ACTIONS(3759),
    [anon_sym_triangle] = ACTIONS(3759),
    [anon_sym_cbuffer] = ACTIONS(3759),
    [anon_sym_interface] = ACTIONS(3759),
    [anon_sym_extension] = ACTIONS(3759),
  },
  [1125] = {
    [sym_identifier] = ACTIONS(3953),
    [aux_sym_preproc_include_token1] = ACTIONS(3953),
    [aux_sym_preproc_def_token1] = ACTIONS(3953),
    [aux_sym_preproc_if_token1] = ACTIONS(3953),
    [aux_sym_preproc_if_token2] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3953),
    [sym_preproc_directive] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_BANG] = ACTIONS(3955),
    [anon_sym_TILDE] = ACTIONS(3955),
    [anon_sym_DASH] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3953),
    [anon_sym_STAR] = ACTIONS(3955),
    [anon_sym_AMP_AMP] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_SEMI] = ACTIONS(3955),
    [anon_sym___extension__] = ACTIONS(3953),
    [anon_sym_typedef] = ACTIONS(3953),
    [anon_sym_in] = ACTIONS(3953),
    [anon_sym_out] = ACTIONS(3953),
    [anon_sym_inout] = ACTIONS(3953),
    [anon_sym_virtual] = ACTIONS(3953),
    [anon_sym_extern] = ACTIONS(3953),
    [anon_sym___attribute__] = ACTIONS(3953),
    [anon_sym___attribute] = ACTIONS(3953),
    [anon_sym_using] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3955),
    [anon_sym___declspec] = ACTIONS(3953),
    [anon_sym___based] = ACTIONS(3953),
    [anon_sym___cdecl] = ACTIONS(3953),
    [anon_sym___clrcall] = ACTIONS(3953),
    [anon_sym___stdcall] = ACTIONS(3953),
    [anon_sym___fastcall] = ACTIONS(3953),
    [anon_sym___thiscall] = ACTIONS(3953),
    [anon_sym___vectorcall] = ACTIONS(3953),
    [anon_sym_LBRACE] = ACTIONS(3955),
    [anon_sym_signed] = ACTIONS(3953),
    [anon_sym_unsigned] = ACTIONS(3953),
    [anon_sym_long] = ACTIONS(3953),
    [anon_sym_short] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_static] = ACTIONS(3953),
    [anon_sym_register] = ACTIONS(3953),
    [anon_sym_inline] = ACTIONS(3953),
    [anon_sym___inline] = ACTIONS(3953),
    [anon_sym___inline__] = ACTIONS(3953),
    [anon_sym___forceinline] = ACTIONS(3953),
    [anon_sym_thread_local] = ACTIONS(3953),
    [anon_sym___thread] = ACTIONS(3953),
    [anon_sym_const] = ACTIONS(3953),
    [anon_sym_constexpr] = ACTIONS(3953),
    [anon_sym_volatile] = ACTIONS(3953),
    [anon_sym_restrict] = ACTIONS(3953),
    [anon_sym___restrict__] = ACTIONS(3953),
    [anon_sym__Atomic] = ACTIONS(3953),
    [anon_sym__Noreturn] = ACTIONS(3953),
    [anon_sym_noreturn] = ACTIONS(3953),
    [anon_sym__Nonnull] = ACTIONS(3953),
    [anon_sym_mutable] = ACTIONS(3953),
    [anon_sym_constinit] = ACTIONS(3953),
    [anon_sym_consteval] = ACTIONS(3953),
    [anon_sym_alignas] = ACTIONS(3953),
    [anon_sym__Alignas] = ACTIONS(3953),
    [sym_primitive_type] = ACTIONS(3953),
    [anon_sym_enum] = ACTIONS(3953),
    [anon_sym_class] = ACTIONS(3953),
    [anon_sym_struct] = ACTIONS(3953),
    [anon_sym_union] = ACTIONS(3953),
    [anon_sym_if] = ACTIONS(3953),
    [anon_sym_switch] = ACTIONS(3953),
    [anon_sym_case] = ACTIONS(3953),
    [anon_sym_default] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3953),
    [anon_sym_do] = ACTIONS(3953),
    [anon_sym_for] = ACTIONS(3953),
    [anon_sym_return] = ACTIONS(3953),
    [anon_sym_break] = ACTIONS(3953),
    [anon_sym_continue] = ACTIONS(3953),
    [anon_sym_goto] = ACTIONS(3953),
    [anon_sym___try] = ACTIONS(3953),
    [anon_sym___leave] = ACTIONS(3953),
    [anon_sym_not] = ACTIONS(3953),
    [anon_sym_compl] = ACTIONS(3953),
    [anon_sym_DASH_DASH] = ACTIONS(3955),
    [anon_sym_PLUS_PLUS] = ACTIONS(3955),
    [anon_sym_sizeof] = ACTIONS(3953),
    [anon_sym___alignof__] = ACTIONS(3953),
    [anon_sym___alignof] = ACTIONS(3953),
    [anon_sym__alignof] = ACTIONS(3953),
    [anon_sym_alignof] = ACTIONS(3953),
    [anon_sym__Alignof] = ACTIONS(3953),
    [anon_sym_offsetof] = ACTIONS(3953),
    [anon_sym__Generic] = ACTIONS(3953),
    [anon_sym_asm] = ACTIONS(3953),
    [anon_sym___asm__] = ACTIONS(3953),
    [anon_sym___asm] = ACTIONS(3953),
    [sym_number_literal] = ACTIONS(3955),
    [anon_sym_L_SQUOTE] = ACTIONS(3955),
    [anon_sym_u_SQUOTE] = ACTIONS(3955),
    [anon_sym_U_SQUOTE] = ACTIONS(3955),
    [anon_sym_u8_SQUOTE] = ACTIONS(3955),
    [anon_sym_SQUOTE] = ACTIONS(3955),
    [anon_sym_L_DQUOTE] = ACTIONS(3955),
    [anon_sym_u_DQUOTE] = ACTIONS(3955),
    [anon_sym_U_DQUOTE] = ACTIONS(3955),
    [anon_sym_u8_DQUOTE] = ACTIONS(3955),
    [anon_sym_DQUOTE] = ACTIONS(3955),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [anon_sym_NULL] = ACTIONS(3953),
    [anon_sym_nullptr] = ACTIONS(3953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_This] = ACTIONS(3953),
    [anon_sym_decltype] = ACTIONS(3953),
    [anon_sym_explicit] = ACTIONS(3953),
    [anon_sym_typename] = ACTIONS(3953),
    [anon_sym_template] = ACTIONS(3953),
    [anon_sym_operator] = ACTIONS(3953),
    [anon_sym_try] = ACTIONS(3953),
    [anon_sym_delete] = ACTIONS(3953),
    [anon_sym_throw] = ACTIONS(3953),
    [anon_sym_namespace] = ACTIONS(3953),
    [anon_sym_static_assert] = ACTIONS(3953),
    [anon_sym_concept] = ACTIONS(3953),
    [anon_sym_co_return] = ACTIONS(3953),
    [anon_sym_co_yield] = ACTIONS(3953),
    [anon_sym_R_DQUOTE] = ACTIONS(3955),
    [anon_sym_LR_DQUOTE] = ACTIONS(3955),
    [anon_sym_uR_DQUOTE] = ACTIONS(3955),
    [anon_sym_UR_DQUOTE] = ACTIONS(3955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3955),
    [anon_sym_co_await] = ACTIONS(3953),
    [anon_sym_new] = ACTIONS(3953),
    [anon_sym_requires] = ACTIONS(3953),
    [sym_this] = ACTIONS(3953),
    [anon_sym_discard] = ACTIONS(3953),
    [anon_sym_precise] = ACTIONS(3953),
    [anon_sym_shared] = ACTIONS(3953),
    [anon_sym_groupshared] = ACTIONS(3953),
    [anon_sym_uniform] = ACTIONS(3953),
    [anon_sym_row_major] = ACTIONS(3953),
    [anon_sym_column_major] = ACTIONS(3953),
    [anon_sym_globallycoherent] = ACTIONS(3953),
    [anon_sym_centroid] = ACTIONS(3953),
    [anon_sym_noperspective] = ACTIONS(3953),
    [anon_sym_nointerpolation] = ACTIONS(3953),
    [anon_sym_sample] = ACTIONS(3953),
    [anon_sym_linear] = ACTIONS(3953),
    [anon_sym_snorm] = ACTIONS(3953),
    [anon_sym_unorm] = ACTIONS(3953),
    [anon_sym_point] = ACTIONS(3953),
    [anon_sym_line] = ACTIONS(3953),
    [anon_sym_triangleadj] = ACTIONS(3953),
    [anon_sym_lineadj] = ACTIONS(3953),
    [anon_sym_triangle] = ACTIONS(3953),
    [anon_sym_cbuffer] = ACTIONS(3953),
    [anon_sym_interface] = ACTIONS(3953),
    [anon_sym_extension] = ACTIONS(3953),
  },
  [1126] = {
    [sym_identifier] = ACTIONS(3828),
    [aux_sym_preproc_include_token1] = ACTIONS(3828),
    [aux_sym_preproc_def_token1] = ACTIONS(3828),
    [aux_sym_preproc_if_token1] = ACTIONS(3828),
    [aux_sym_preproc_if_token2] = ACTIONS(3828),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3828),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3828),
    [sym_preproc_directive] = ACTIONS(3828),
    [anon_sym_LPAREN2] = ACTIONS(3830),
    [anon_sym_BANG] = ACTIONS(3830),
    [anon_sym_TILDE] = ACTIONS(3830),
    [anon_sym_DASH] = ACTIONS(3828),
    [anon_sym_PLUS] = ACTIONS(3828),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_SEMI] = ACTIONS(3830),
    [anon_sym___extension__] = ACTIONS(3828),
    [anon_sym_typedef] = ACTIONS(3828),
    [anon_sym_in] = ACTIONS(3828),
    [anon_sym_out] = ACTIONS(3828),
    [anon_sym_inout] = ACTIONS(3828),
    [anon_sym_virtual] = ACTIONS(3828),
    [anon_sym_extern] = ACTIONS(3828),
    [anon_sym___attribute__] = ACTIONS(3828),
    [anon_sym___attribute] = ACTIONS(3828),
    [anon_sym_using] = ACTIONS(3828),
    [anon_sym_COLON_COLON] = ACTIONS(3830),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3830),
    [anon_sym___declspec] = ACTIONS(3828),
    [anon_sym___based] = ACTIONS(3828),
    [anon_sym___cdecl] = ACTIONS(3828),
    [anon_sym___clrcall] = ACTIONS(3828),
    [anon_sym___stdcall] = ACTIONS(3828),
    [anon_sym___fastcall] = ACTIONS(3828),
    [anon_sym___thiscall] = ACTIONS(3828),
    [anon_sym___vectorcall] = ACTIONS(3828),
    [anon_sym_LBRACE] = ACTIONS(3830),
    [anon_sym_signed] = ACTIONS(3828),
    [anon_sym_unsigned] = ACTIONS(3828),
    [anon_sym_long] = ACTIONS(3828),
    [anon_sym_short] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_static] = ACTIONS(3828),
    [anon_sym_register] = ACTIONS(3828),
    [anon_sym_inline] = ACTIONS(3828),
    [anon_sym___inline] = ACTIONS(3828),
    [anon_sym___inline__] = ACTIONS(3828),
    [anon_sym___forceinline] = ACTIONS(3828),
    [anon_sym_thread_local] = ACTIONS(3828),
    [anon_sym___thread] = ACTIONS(3828),
    [anon_sym_const] = ACTIONS(3828),
    [anon_sym_constexpr] = ACTIONS(3828),
    [anon_sym_volatile] = ACTIONS(3828),
    [anon_sym_restrict] = ACTIONS(3828),
    [anon_sym___restrict__] = ACTIONS(3828),
    [anon_sym__Atomic] = ACTIONS(3828),
    [anon_sym__Noreturn] = ACTIONS(3828),
    [anon_sym_noreturn] = ACTIONS(3828),
    [anon_sym__Nonnull] = ACTIONS(3828),
    [anon_sym_mutable] = ACTIONS(3828),
    [anon_sym_constinit] = ACTIONS(3828),
    [anon_sym_consteval] = ACTIONS(3828),
    [anon_sym_alignas] = ACTIONS(3828),
    [anon_sym__Alignas] = ACTIONS(3828),
    [sym_primitive_type] = ACTIONS(3828),
    [anon_sym_enum] = ACTIONS(3828),
    [anon_sym_class] = ACTIONS(3828),
    [anon_sym_struct] = ACTIONS(3828),
    [anon_sym_union] = ACTIONS(3828),
    [anon_sym_if] = ACTIONS(3828),
    [anon_sym_switch] = ACTIONS(3828),
    [anon_sym_case] = ACTIONS(3828),
    [anon_sym_default] = ACTIONS(3828),
    [anon_sym_while] = ACTIONS(3828),
    [anon_sym_do] = ACTIONS(3828),
    [anon_sym_for] = ACTIONS(3828),
    [anon_sym_return] = ACTIONS(3828),
    [anon_sym_break] = ACTIONS(3828),
    [anon_sym_continue] = ACTIONS(3828),
    [anon_sym_goto] = ACTIONS(3828),
    [anon_sym___try] = ACTIONS(3828),
    [anon_sym___leave] = ACTIONS(3828),
    [anon_sym_not] = ACTIONS(3828),
    [anon_sym_compl] = ACTIONS(3828),
    [anon_sym_DASH_DASH] = ACTIONS(3830),
    [anon_sym_PLUS_PLUS] = ACTIONS(3830),
    [anon_sym_sizeof] = ACTIONS(3828),
    [anon_sym___alignof__] = ACTIONS(3828),
    [anon_sym___alignof] = ACTIONS(3828),
    [anon_sym__alignof] = ACTIONS(3828),
    [anon_sym_alignof] = ACTIONS(3828),
    [anon_sym__Alignof] = ACTIONS(3828),
    [anon_sym_offsetof] = ACTIONS(3828),
    [anon_sym__Generic] = ACTIONS(3828),
    [anon_sym_asm] = ACTIONS(3828),
    [anon_sym___asm__] = ACTIONS(3828),
    [anon_sym___asm] = ACTIONS(3828),
    [sym_number_literal] = ACTIONS(3830),
    [anon_sym_L_SQUOTE] = ACTIONS(3830),
    [anon_sym_u_SQUOTE] = ACTIONS(3830),
    [anon_sym_U_SQUOTE] = ACTIONS(3830),
    [anon_sym_u8_SQUOTE] = ACTIONS(3830),
    [anon_sym_SQUOTE] = ACTIONS(3830),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3828),
    [sym_false] = ACTIONS(3828),
    [anon_sym_NULL] = ACTIONS(3828),
    [anon_sym_nullptr] = ACTIONS(3828),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_This] = ACTIONS(3828),
    [anon_sym_decltype] = ACTIONS(3828),
    [anon_sym_explicit] = ACTIONS(3828),
    [anon_sym_typename] = ACTIONS(3828),
    [anon_sym_template] = ACTIONS(3828),
    [anon_sym_operator] = ACTIONS(3828),
    [anon_sym_try] = ACTIONS(3828),
    [anon_sym_delete] = ACTIONS(3828),
    [anon_sym_throw] = ACTIONS(3828),
    [anon_sym_namespace] = ACTIONS(3828),
    [anon_sym_static_assert] = ACTIONS(3828),
    [anon_sym_concept] = ACTIONS(3828),
    [anon_sym_co_return] = ACTIONS(3828),
    [anon_sym_co_yield] = ACTIONS(3828),
    [anon_sym_R_DQUOTE] = ACTIONS(3830),
    [anon_sym_LR_DQUOTE] = ACTIONS(3830),
    [anon_sym_uR_DQUOTE] = ACTIONS(3830),
    [anon_sym_UR_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3830),
    [anon_sym_co_await] = ACTIONS(3828),
    [anon_sym_new] = ACTIONS(3828),
    [anon_sym_requires] = ACTIONS(3828),
    [sym_this] = ACTIONS(3828),
    [anon_sym_discard] = ACTIONS(3828),
    [anon_sym_precise] = ACTIONS(3828),
    [anon_sym_shared] = ACTIONS(3828),
    [anon_sym_groupshared] = ACTIONS(3828),
    [anon_sym_uniform] = ACTIONS(3828),
    [anon_sym_row_major] = ACTIONS(3828),
    [anon_sym_column_major] = ACTIONS(3828),
    [anon_sym_globallycoherent] = ACTIONS(3828),
    [anon_sym_centroid] = ACTIONS(3828),
    [anon_sym_noperspective] = ACTIONS(3828),
    [anon_sym_nointerpolation] = ACTIONS(3828),
    [anon_sym_sample] = ACTIONS(3828),
    [anon_sym_linear] = ACTIONS(3828),
    [anon_sym_snorm] = ACTIONS(3828),
    [anon_sym_unorm] = ACTIONS(3828),
    [anon_sym_point] = ACTIONS(3828),
    [anon_sym_line] = ACTIONS(3828),
    [anon_sym_triangleadj] = ACTIONS(3828),
    [anon_sym_lineadj] = ACTIONS(3828),
    [anon_sym_triangle] = ACTIONS(3828),
    [anon_sym_cbuffer] = ACTIONS(3828),
    [anon_sym_interface] = ACTIONS(3828),
    [anon_sym_extension] = ACTIONS(3828),
  },
  [1127] = {
    [sym_identifier] = ACTIONS(3953),
    [aux_sym_preproc_include_token1] = ACTIONS(3953),
    [aux_sym_preproc_def_token1] = ACTIONS(3953),
    [aux_sym_preproc_if_token1] = ACTIONS(3953),
    [aux_sym_preproc_if_token2] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3953),
    [sym_preproc_directive] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_BANG] = ACTIONS(3955),
    [anon_sym_TILDE] = ACTIONS(3955),
    [anon_sym_DASH] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3953),
    [anon_sym_STAR] = ACTIONS(3955),
    [anon_sym_AMP_AMP] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_SEMI] = ACTIONS(3955),
    [anon_sym___extension__] = ACTIONS(3953),
    [anon_sym_typedef] = ACTIONS(3953),
    [anon_sym_in] = ACTIONS(3953),
    [anon_sym_out] = ACTIONS(3953),
    [anon_sym_inout] = ACTIONS(3953),
    [anon_sym_virtual] = ACTIONS(3953),
    [anon_sym_extern] = ACTIONS(3953),
    [anon_sym___attribute__] = ACTIONS(3953),
    [anon_sym___attribute] = ACTIONS(3953),
    [anon_sym_using] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3955),
    [anon_sym___declspec] = ACTIONS(3953),
    [anon_sym___based] = ACTIONS(3953),
    [anon_sym___cdecl] = ACTIONS(3953),
    [anon_sym___clrcall] = ACTIONS(3953),
    [anon_sym___stdcall] = ACTIONS(3953),
    [anon_sym___fastcall] = ACTIONS(3953),
    [anon_sym___thiscall] = ACTIONS(3953),
    [anon_sym___vectorcall] = ACTIONS(3953),
    [anon_sym_LBRACE] = ACTIONS(3955),
    [anon_sym_signed] = ACTIONS(3953),
    [anon_sym_unsigned] = ACTIONS(3953),
    [anon_sym_long] = ACTIONS(3953),
    [anon_sym_short] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_static] = ACTIONS(3953),
    [anon_sym_register] = ACTIONS(3953),
    [anon_sym_inline] = ACTIONS(3953),
    [anon_sym___inline] = ACTIONS(3953),
    [anon_sym___inline__] = ACTIONS(3953),
    [anon_sym___forceinline] = ACTIONS(3953),
    [anon_sym_thread_local] = ACTIONS(3953),
    [anon_sym___thread] = ACTIONS(3953),
    [anon_sym_const] = ACTIONS(3953),
    [anon_sym_constexpr] = ACTIONS(3953),
    [anon_sym_volatile] = ACTIONS(3953),
    [anon_sym_restrict] = ACTIONS(3953),
    [anon_sym___restrict__] = ACTIONS(3953),
    [anon_sym__Atomic] = ACTIONS(3953),
    [anon_sym__Noreturn] = ACTIONS(3953),
    [anon_sym_noreturn] = ACTIONS(3953),
    [anon_sym__Nonnull] = ACTIONS(3953),
    [anon_sym_mutable] = ACTIONS(3953),
    [anon_sym_constinit] = ACTIONS(3953),
    [anon_sym_consteval] = ACTIONS(3953),
    [anon_sym_alignas] = ACTIONS(3953),
    [anon_sym__Alignas] = ACTIONS(3953),
    [sym_primitive_type] = ACTIONS(3953),
    [anon_sym_enum] = ACTIONS(3953),
    [anon_sym_class] = ACTIONS(3953),
    [anon_sym_struct] = ACTIONS(3953),
    [anon_sym_union] = ACTIONS(3953),
    [anon_sym_if] = ACTIONS(3953),
    [anon_sym_switch] = ACTIONS(3953),
    [anon_sym_case] = ACTIONS(3953),
    [anon_sym_default] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3953),
    [anon_sym_do] = ACTIONS(3953),
    [anon_sym_for] = ACTIONS(3953),
    [anon_sym_return] = ACTIONS(3953),
    [anon_sym_break] = ACTIONS(3953),
    [anon_sym_continue] = ACTIONS(3953),
    [anon_sym_goto] = ACTIONS(3953),
    [anon_sym___try] = ACTIONS(3953),
    [anon_sym___leave] = ACTIONS(3953),
    [anon_sym_not] = ACTIONS(3953),
    [anon_sym_compl] = ACTIONS(3953),
    [anon_sym_DASH_DASH] = ACTIONS(3955),
    [anon_sym_PLUS_PLUS] = ACTIONS(3955),
    [anon_sym_sizeof] = ACTIONS(3953),
    [anon_sym___alignof__] = ACTIONS(3953),
    [anon_sym___alignof] = ACTIONS(3953),
    [anon_sym__alignof] = ACTIONS(3953),
    [anon_sym_alignof] = ACTIONS(3953),
    [anon_sym__Alignof] = ACTIONS(3953),
    [anon_sym_offsetof] = ACTIONS(3953),
    [anon_sym__Generic] = ACTIONS(3953),
    [anon_sym_asm] = ACTIONS(3953),
    [anon_sym___asm__] = ACTIONS(3953),
    [anon_sym___asm] = ACTIONS(3953),
    [sym_number_literal] = ACTIONS(3955),
    [anon_sym_L_SQUOTE] = ACTIONS(3955),
    [anon_sym_u_SQUOTE] = ACTIONS(3955),
    [anon_sym_U_SQUOTE] = ACTIONS(3955),
    [anon_sym_u8_SQUOTE] = ACTIONS(3955),
    [anon_sym_SQUOTE] = ACTIONS(3955),
    [anon_sym_L_DQUOTE] = ACTIONS(3955),
    [anon_sym_u_DQUOTE] = ACTIONS(3955),
    [anon_sym_U_DQUOTE] = ACTIONS(3955),
    [anon_sym_u8_DQUOTE] = ACTIONS(3955),
    [anon_sym_DQUOTE] = ACTIONS(3955),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [anon_sym_NULL] = ACTIONS(3953),
    [anon_sym_nullptr] = ACTIONS(3953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_This] = ACTIONS(3953),
    [anon_sym_decltype] = ACTIONS(3953),
    [anon_sym_explicit] = ACTIONS(3953),
    [anon_sym_typename] = ACTIONS(3953),
    [anon_sym_template] = ACTIONS(3953),
    [anon_sym_operator] = ACTIONS(3953),
    [anon_sym_try] = ACTIONS(3953),
    [anon_sym_delete] = ACTIONS(3953),
    [anon_sym_throw] = ACTIONS(3953),
    [anon_sym_namespace] = ACTIONS(3953),
    [anon_sym_static_assert] = ACTIONS(3953),
    [anon_sym_concept] = ACTIONS(3953),
    [anon_sym_co_return] = ACTIONS(3953),
    [anon_sym_co_yield] = ACTIONS(3953),
    [anon_sym_R_DQUOTE] = ACTIONS(3955),
    [anon_sym_LR_DQUOTE] = ACTIONS(3955),
    [anon_sym_uR_DQUOTE] = ACTIONS(3955),
    [anon_sym_UR_DQUOTE] = ACTIONS(3955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3955),
    [anon_sym_co_await] = ACTIONS(3953),
    [anon_sym_new] = ACTIONS(3953),
    [anon_sym_requires] = ACTIONS(3953),
    [sym_this] = ACTIONS(3953),
    [anon_sym_discard] = ACTIONS(3953),
    [anon_sym_precise] = ACTIONS(3953),
    [anon_sym_shared] = ACTIONS(3953),
    [anon_sym_groupshared] = ACTIONS(3953),
    [anon_sym_uniform] = ACTIONS(3953),
    [anon_sym_row_major] = ACTIONS(3953),
    [anon_sym_column_major] = ACTIONS(3953),
    [anon_sym_globallycoherent] = ACTIONS(3953),
    [anon_sym_centroid] = ACTIONS(3953),
    [anon_sym_noperspective] = ACTIONS(3953),
    [anon_sym_nointerpolation] = ACTIONS(3953),
    [anon_sym_sample] = ACTIONS(3953),
    [anon_sym_linear] = ACTIONS(3953),
    [anon_sym_snorm] = ACTIONS(3953),
    [anon_sym_unorm] = ACTIONS(3953),
    [anon_sym_point] = ACTIONS(3953),
    [anon_sym_line] = ACTIONS(3953),
    [anon_sym_triangleadj] = ACTIONS(3953),
    [anon_sym_lineadj] = ACTIONS(3953),
    [anon_sym_triangle] = ACTIONS(3953),
    [anon_sym_cbuffer] = ACTIONS(3953),
    [anon_sym_interface] = ACTIONS(3953),
    [anon_sym_extension] = ACTIONS(3953),
  },
  [1128] = {
    [sym_identifier] = ACTIONS(3743),
    [aux_sym_preproc_include_token1] = ACTIONS(3743),
    [aux_sym_preproc_def_token1] = ACTIONS(3743),
    [aux_sym_preproc_if_token1] = ACTIONS(3743),
    [aux_sym_preproc_if_token2] = ACTIONS(3743),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3743),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3743),
    [sym_preproc_directive] = ACTIONS(3743),
    [anon_sym_LPAREN2] = ACTIONS(3745),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_STAR] = ACTIONS(3745),
    [anon_sym_AMP_AMP] = ACTIONS(3745),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_SEMI] = ACTIONS(3745),
    [anon_sym___extension__] = ACTIONS(3743),
    [anon_sym_typedef] = ACTIONS(3743),
    [anon_sym_in] = ACTIONS(3743),
    [anon_sym_out] = ACTIONS(3743),
    [anon_sym_inout] = ACTIONS(3743),
    [anon_sym_virtual] = ACTIONS(3743),
    [anon_sym_extern] = ACTIONS(3743),
    [anon_sym___attribute__] = ACTIONS(3743),
    [anon_sym___attribute] = ACTIONS(3743),
    [anon_sym_using] = ACTIONS(3743),
    [anon_sym_COLON_COLON] = ACTIONS(3745),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3745),
    [anon_sym___declspec] = ACTIONS(3743),
    [anon_sym___based] = ACTIONS(3743),
    [anon_sym___cdecl] = ACTIONS(3743),
    [anon_sym___clrcall] = ACTIONS(3743),
    [anon_sym___stdcall] = ACTIONS(3743),
    [anon_sym___fastcall] = ACTIONS(3743),
    [anon_sym___thiscall] = ACTIONS(3743),
    [anon_sym___vectorcall] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_signed] = ACTIONS(3743),
    [anon_sym_unsigned] = ACTIONS(3743),
    [anon_sym_long] = ACTIONS(3743),
    [anon_sym_short] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3743),
    [anon_sym_static] = ACTIONS(3743),
    [anon_sym_register] = ACTIONS(3743),
    [anon_sym_inline] = ACTIONS(3743),
    [anon_sym___inline] = ACTIONS(3743),
    [anon_sym___inline__] = ACTIONS(3743),
    [anon_sym___forceinline] = ACTIONS(3743),
    [anon_sym_thread_local] = ACTIONS(3743),
    [anon_sym___thread] = ACTIONS(3743),
    [anon_sym_const] = ACTIONS(3743),
    [anon_sym_constexpr] = ACTIONS(3743),
    [anon_sym_volatile] = ACTIONS(3743),
    [anon_sym_restrict] = ACTIONS(3743),
    [anon_sym___restrict__] = ACTIONS(3743),
    [anon_sym__Atomic] = ACTIONS(3743),
    [anon_sym__Noreturn] = ACTIONS(3743),
    [anon_sym_noreturn] = ACTIONS(3743),
    [anon_sym__Nonnull] = ACTIONS(3743),
    [anon_sym_mutable] = ACTIONS(3743),
    [anon_sym_constinit] = ACTIONS(3743),
    [anon_sym_consteval] = ACTIONS(3743),
    [anon_sym_alignas] = ACTIONS(3743),
    [anon_sym__Alignas] = ACTIONS(3743),
    [sym_primitive_type] = ACTIONS(3743),
    [anon_sym_enum] = ACTIONS(3743),
    [anon_sym_class] = ACTIONS(3743),
    [anon_sym_struct] = ACTIONS(3743),
    [anon_sym_union] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_switch] = ACTIONS(3743),
    [anon_sym_case] = ACTIONS(3743),
    [anon_sym_default] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_break] = ACTIONS(3743),
    [anon_sym_continue] = ACTIONS(3743),
    [anon_sym_goto] = ACTIONS(3743),
    [anon_sym___try] = ACTIONS(3743),
    [anon_sym___leave] = ACTIONS(3743),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_compl] = ACTIONS(3743),
    [anon_sym_DASH_DASH] = ACTIONS(3745),
    [anon_sym_PLUS_PLUS] = ACTIONS(3745),
    [anon_sym_sizeof] = ACTIONS(3743),
    [anon_sym___alignof__] = ACTIONS(3743),
    [anon_sym___alignof] = ACTIONS(3743),
    [anon_sym__alignof] = ACTIONS(3743),
    [anon_sym_alignof] = ACTIONS(3743),
    [anon_sym__Alignof] = ACTIONS(3743),
    [anon_sym_offsetof] = ACTIONS(3743),
    [anon_sym__Generic] = ACTIONS(3743),
    [anon_sym_asm] = ACTIONS(3743),
    [anon_sym___asm__] = ACTIONS(3743),
    [anon_sym___asm] = ACTIONS(3743),
    [sym_number_literal] = ACTIONS(3745),
    [anon_sym_L_SQUOTE] = ACTIONS(3745),
    [anon_sym_u_SQUOTE] = ACTIONS(3745),
    [anon_sym_U_SQUOTE] = ACTIONS(3745),
    [anon_sym_u8_SQUOTE] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [anon_sym_L_DQUOTE] = ACTIONS(3745),
    [anon_sym_u_DQUOTE] = ACTIONS(3745),
    [anon_sym_U_DQUOTE] = ACTIONS(3745),
    [anon_sym_u8_DQUOTE] = ACTIONS(3745),
    [anon_sym_DQUOTE] = ACTIONS(3745),
    [sym_true] = ACTIONS(3743),
    [sym_false] = ACTIONS(3743),
    [anon_sym_NULL] = ACTIONS(3743),
    [anon_sym_nullptr] = ACTIONS(3743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_This] = ACTIONS(3743),
    [anon_sym_decltype] = ACTIONS(3743),
    [anon_sym_explicit] = ACTIONS(3743),
    [anon_sym_typename] = ACTIONS(3743),
    [anon_sym_template] = ACTIONS(3743),
    [anon_sym_operator] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_delete] = ACTIONS(3743),
    [anon_sym_throw] = ACTIONS(3743),
    [anon_sym_namespace] = ACTIONS(3743),
    [anon_sym_static_assert] = ACTIONS(3743),
    [anon_sym_concept] = ACTIONS(3743),
    [anon_sym_co_return] = ACTIONS(3743),
    [anon_sym_co_yield] = ACTIONS(3743),
    [anon_sym_R_DQUOTE] = ACTIONS(3745),
    [anon_sym_LR_DQUOTE] = ACTIONS(3745),
    [anon_sym_uR_DQUOTE] = ACTIONS(3745),
    [anon_sym_UR_DQUOTE] = ACTIONS(3745),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3745),
    [anon_sym_co_await] = ACTIONS(3743),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_requires] = ACTIONS(3743),
    [sym_this] = ACTIONS(3743),
    [anon_sym_discard] = ACTIONS(3743),
    [anon_sym_precise] = ACTIONS(3743),
    [anon_sym_shared] = ACTIONS(3743),
    [anon_sym_groupshared] = ACTIONS(3743),
    [anon_sym_uniform] = ACTIONS(3743),
    [anon_sym_row_major] = ACTIONS(3743),
    [anon_sym_column_major] = ACTIONS(3743),
    [anon_sym_globallycoherent] = ACTIONS(3743),
    [anon_sym_centroid] = ACTIONS(3743),
    [anon_sym_noperspective] = ACTIONS(3743),
    [anon_sym_nointerpolation] = ACTIONS(3743),
    [anon_sym_sample] = ACTIONS(3743),
    [anon_sym_linear] = ACTIONS(3743),
    [anon_sym_snorm] = ACTIONS(3743),
    [anon_sym_unorm] = ACTIONS(3743),
    [anon_sym_point] = ACTIONS(3743),
    [anon_sym_line] = ACTIONS(3743),
    [anon_sym_triangleadj] = ACTIONS(3743),
    [anon_sym_lineadj] = ACTIONS(3743),
    [anon_sym_triangle] = ACTIONS(3743),
    [anon_sym_cbuffer] = ACTIONS(3743),
    [anon_sym_interface] = ACTIONS(3743),
    [anon_sym_extension] = ACTIONS(3743),
  },
  [1129] = {
    [sym_identifier] = ACTIONS(3849),
    [aux_sym_preproc_include_token1] = ACTIONS(3849),
    [aux_sym_preproc_def_token1] = ACTIONS(3849),
    [aux_sym_preproc_if_token1] = ACTIONS(3849),
    [aux_sym_preproc_if_token2] = ACTIONS(3849),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3849),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3849),
    [sym_preproc_directive] = ACTIONS(3849),
    [anon_sym_LPAREN2] = ACTIONS(3851),
    [anon_sym_BANG] = ACTIONS(3851),
    [anon_sym_TILDE] = ACTIONS(3851),
    [anon_sym_DASH] = ACTIONS(3849),
    [anon_sym_PLUS] = ACTIONS(3849),
    [anon_sym_STAR] = ACTIONS(3851),
    [anon_sym_AMP_AMP] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3849),
    [anon_sym_SEMI] = ACTIONS(3851),
    [anon_sym___extension__] = ACTIONS(3849),
    [anon_sym_typedef] = ACTIONS(3849),
    [anon_sym_in] = ACTIONS(3849),
    [anon_sym_out] = ACTIONS(3849),
    [anon_sym_inout] = ACTIONS(3849),
    [anon_sym_virtual] = ACTIONS(3849),
    [anon_sym_extern] = ACTIONS(3849),
    [anon_sym___attribute__] = ACTIONS(3849),
    [anon_sym___attribute] = ACTIONS(3849),
    [anon_sym_using] = ACTIONS(3849),
    [anon_sym_COLON_COLON] = ACTIONS(3851),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3851),
    [anon_sym___declspec] = ACTIONS(3849),
    [anon_sym___based] = ACTIONS(3849),
    [anon_sym___cdecl] = ACTIONS(3849),
    [anon_sym___clrcall] = ACTIONS(3849),
    [anon_sym___stdcall] = ACTIONS(3849),
    [anon_sym___fastcall] = ACTIONS(3849),
    [anon_sym___thiscall] = ACTIONS(3849),
    [anon_sym___vectorcall] = ACTIONS(3849),
    [anon_sym_LBRACE] = ACTIONS(3851),
    [anon_sym_signed] = ACTIONS(3849),
    [anon_sym_unsigned] = ACTIONS(3849),
    [anon_sym_long] = ACTIONS(3849),
    [anon_sym_short] = ACTIONS(3849),
    [anon_sym_LBRACK] = ACTIONS(3849),
    [anon_sym_static] = ACTIONS(3849),
    [anon_sym_register] = ACTIONS(3849),
    [anon_sym_inline] = ACTIONS(3849),
    [anon_sym___inline] = ACTIONS(3849),
    [anon_sym___inline__] = ACTIONS(3849),
    [anon_sym___forceinline] = ACTIONS(3849),
    [anon_sym_thread_local] = ACTIONS(3849),
    [anon_sym___thread] = ACTIONS(3849),
    [anon_sym_const] = ACTIONS(3849),
    [anon_sym_constexpr] = ACTIONS(3849),
    [anon_sym_volatile] = ACTIONS(3849),
    [anon_sym_restrict] = ACTIONS(3849),
    [anon_sym___restrict__] = ACTIONS(3849),
    [anon_sym__Atomic] = ACTIONS(3849),
    [anon_sym__Noreturn] = ACTIONS(3849),
    [anon_sym_noreturn] = ACTIONS(3849),
    [anon_sym__Nonnull] = ACTIONS(3849),
    [anon_sym_mutable] = ACTIONS(3849),
    [anon_sym_constinit] = ACTIONS(3849),
    [anon_sym_consteval] = ACTIONS(3849),
    [anon_sym_alignas] = ACTIONS(3849),
    [anon_sym__Alignas] = ACTIONS(3849),
    [sym_primitive_type] = ACTIONS(3849),
    [anon_sym_enum] = ACTIONS(3849),
    [anon_sym_class] = ACTIONS(3849),
    [anon_sym_struct] = ACTIONS(3849),
    [anon_sym_union] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3849),
    [anon_sym_switch] = ACTIONS(3849),
    [anon_sym_case] = ACTIONS(3849),
    [anon_sym_default] = ACTIONS(3849),
    [anon_sym_while] = ACTIONS(3849),
    [anon_sym_do] = ACTIONS(3849),
    [anon_sym_for] = ACTIONS(3849),
    [anon_sym_return] = ACTIONS(3849),
    [anon_sym_break] = ACTIONS(3849),
    [anon_sym_continue] = ACTIONS(3849),
    [anon_sym_goto] = ACTIONS(3849),
    [anon_sym___try] = ACTIONS(3849),
    [anon_sym___leave] = ACTIONS(3849),
    [anon_sym_not] = ACTIONS(3849),
    [anon_sym_compl] = ACTIONS(3849),
    [anon_sym_DASH_DASH] = ACTIONS(3851),
    [anon_sym_PLUS_PLUS] = ACTIONS(3851),
    [anon_sym_sizeof] = ACTIONS(3849),
    [anon_sym___alignof__] = ACTIONS(3849),
    [anon_sym___alignof] = ACTIONS(3849),
    [anon_sym__alignof] = ACTIONS(3849),
    [anon_sym_alignof] = ACTIONS(3849),
    [anon_sym__Alignof] = ACTIONS(3849),
    [anon_sym_offsetof] = ACTIONS(3849),
    [anon_sym__Generic] = ACTIONS(3849),
    [anon_sym_asm] = ACTIONS(3849),
    [anon_sym___asm__] = ACTIONS(3849),
    [anon_sym___asm] = ACTIONS(3849),
    [sym_number_literal] = ACTIONS(3851),
    [anon_sym_L_SQUOTE] = ACTIONS(3851),
    [anon_sym_u_SQUOTE] = ACTIONS(3851),
    [anon_sym_U_SQUOTE] = ACTIONS(3851),
    [anon_sym_u8_SQUOTE] = ACTIONS(3851),
    [anon_sym_SQUOTE] = ACTIONS(3851),
    [anon_sym_L_DQUOTE] = ACTIONS(3851),
    [anon_sym_u_DQUOTE] = ACTIONS(3851),
    [anon_sym_U_DQUOTE] = ACTIONS(3851),
    [anon_sym_u8_DQUOTE] = ACTIONS(3851),
    [anon_sym_DQUOTE] = ACTIONS(3851),
    [sym_true] = ACTIONS(3849),
    [sym_false] = ACTIONS(3849),
    [anon_sym_NULL] = ACTIONS(3849),
    [anon_sym_nullptr] = ACTIONS(3849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3849),
    [anon_sym_let] = ACTIONS(3849),
    [anon_sym_This] = ACTIONS(3849),
    [anon_sym_decltype] = ACTIONS(3849),
    [anon_sym_explicit] = ACTIONS(3849),
    [anon_sym_typename] = ACTIONS(3849),
    [anon_sym_template] = ACTIONS(3849),
    [anon_sym_operator] = ACTIONS(3849),
    [anon_sym_try] = ACTIONS(3849),
    [anon_sym_delete] = ACTIONS(3849),
    [anon_sym_throw] = ACTIONS(3849),
    [anon_sym_namespace] = ACTIONS(3849),
    [anon_sym_static_assert] = ACTIONS(3849),
    [anon_sym_concept] = ACTIONS(3849),
    [anon_sym_co_return] = ACTIONS(3849),
    [anon_sym_co_yield] = ACTIONS(3849),
    [anon_sym_R_DQUOTE] = ACTIONS(3851),
    [anon_sym_LR_DQUOTE] = ACTIONS(3851),
    [anon_sym_uR_DQUOTE] = ACTIONS(3851),
    [anon_sym_UR_DQUOTE] = ACTIONS(3851),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3851),
    [anon_sym_co_await] = ACTIONS(3849),
    [anon_sym_new] = ACTIONS(3849),
    [anon_sym_requires] = ACTIONS(3849),
    [sym_this] = ACTIONS(3849),
    [anon_sym_discard] = ACTIONS(3849),
    [anon_sym_precise] = ACTIONS(3849),
    [anon_sym_shared] = ACTIONS(3849),
    [anon_sym_groupshared] = ACTIONS(3849),
    [anon_sym_uniform] = ACTIONS(3849),
    [anon_sym_row_major] = ACTIONS(3849),
    [anon_sym_column_major] = ACTIONS(3849),
    [anon_sym_globallycoherent] = ACTIONS(3849),
    [anon_sym_centroid] = ACTIONS(3849),
    [anon_sym_noperspective] = ACTIONS(3849),
    [anon_sym_nointerpolation] = ACTIONS(3849),
    [anon_sym_sample] = ACTIONS(3849),
    [anon_sym_linear] = ACTIONS(3849),
    [anon_sym_snorm] = ACTIONS(3849),
    [anon_sym_unorm] = ACTIONS(3849),
    [anon_sym_point] = ACTIONS(3849),
    [anon_sym_line] = ACTIONS(3849),
    [anon_sym_triangleadj] = ACTIONS(3849),
    [anon_sym_lineadj] = ACTIONS(3849),
    [anon_sym_triangle] = ACTIONS(3849),
    [anon_sym_cbuffer] = ACTIONS(3849),
    [anon_sym_interface] = ACTIONS(3849),
    [anon_sym_extension] = ACTIONS(3849),
  },
  [1130] = {
    [sym_identifier] = ACTIONS(3731),
    [aux_sym_preproc_include_token1] = ACTIONS(3731),
    [aux_sym_preproc_def_token1] = ACTIONS(3731),
    [aux_sym_preproc_if_token1] = ACTIONS(3731),
    [aux_sym_preproc_if_token2] = ACTIONS(3731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3731),
    [sym_preproc_directive] = ACTIONS(3731),
    [anon_sym_LPAREN2] = ACTIONS(3733),
    [anon_sym_BANG] = ACTIONS(3733),
    [anon_sym_TILDE] = ACTIONS(3733),
    [anon_sym_DASH] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3731),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_AMP_AMP] = ACTIONS(3733),
    [anon_sym_AMP] = ACTIONS(3731),
    [anon_sym_SEMI] = ACTIONS(3733),
    [anon_sym___extension__] = ACTIONS(3731),
    [anon_sym_typedef] = ACTIONS(3731),
    [anon_sym_in] = ACTIONS(3731),
    [anon_sym_out] = ACTIONS(3731),
    [anon_sym_inout] = ACTIONS(3731),
    [anon_sym_virtual] = ACTIONS(3731),
    [anon_sym_extern] = ACTIONS(3731),
    [anon_sym___attribute__] = ACTIONS(3731),
    [anon_sym___attribute] = ACTIONS(3731),
    [anon_sym_using] = ACTIONS(3731),
    [anon_sym_COLON_COLON] = ACTIONS(3733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3733),
    [anon_sym___declspec] = ACTIONS(3731),
    [anon_sym___based] = ACTIONS(3731),
    [anon_sym___cdecl] = ACTIONS(3731),
    [anon_sym___clrcall] = ACTIONS(3731),
    [anon_sym___stdcall] = ACTIONS(3731),
    [anon_sym___fastcall] = ACTIONS(3731),
    [anon_sym___thiscall] = ACTIONS(3731),
    [anon_sym___vectorcall] = ACTIONS(3731),
    [anon_sym_LBRACE] = ACTIONS(3733),
    [anon_sym_signed] = ACTIONS(3731),
    [anon_sym_unsigned] = ACTIONS(3731),
    [anon_sym_long] = ACTIONS(3731),
    [anon_sym_short] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3731),
    [anon_sym_static] = ACTIONS(3731),
    [anon_sym_register] = ACTIONS(3731),
    [anon_sym_inline] = ACTIONS(3731),
    [anon_sym___inline] = ACTIONS(3731),
    [anon_sym___inline__] = ACTIONS(3731),
    [anon_sym___forceinline] = ACTIONS(3731),
    [anon_sym_thread_local] = ACTIONS(3731),
    [anon_sym___thread] = ACTIONS(3731),
    [anon_sym_const] = ACTIONS(3731),
    [anon_sym_constexpr] = ACTIONS(3731),
    [anon_sym_volatile] = ACTIONS(3731),
    [anon_sym_restrict] = ACTIONS(3731),
    [anon_sym___restrict__] = ACTIONS(3731),
    [anon_sym__Atomic] = ACTIONS(3731),
    [anon_sym__Noreturn] = ACTIONS(3731),
    [anon_sym_noreturn] = ACTIONS(3731),
    [anon_sym__Nonnull] = ACTIONS(3731),
    [anon_sym_mutable] = ACTIONS(3731),
    [anon_sym_constinit] = ACTIONS(3731),
    [anon_sym_consteval] = ACTIONS(3731),
    [anon_sym_alignas] = ACTIONS(3731),
    [anon_sym__Alignas] = ACTIONS(3731),
    [sym_primitive_type] = ACTIONS(3731),
    [anon_sym_enum] = ACTIONS(3731),
    [anon_sym_class] = ACTIONS(3731),
    [anon_sym_struct] = ACTIONS(3731),
    [anon_sym_union] = ACTIONS(3731),
    [anon_sym_if] = ACTIONS(3731),
    [anon_sym_switch] = ACTIONS(3731),
    [anon_sym_case] = ACTIONS(3731),
    [anon_sym_default] = ACTIONS(3731),
    [anon_sym_while] = ACTIONS(3731),
    [anon_sym_do] = ACTIONS(3731),
    [anon_sym_for] = ACTIONS(3731),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_break] = ACTIONS(3731),
    [anon_sym_continue] = ACTIONS(3731),
    [anon_sym_goto] = ACTIONS(3731),
    [anon_sym___try] = ACTIONS(3731),
    [anon_sym___leave] = ACTIONS(3731),
    [anon_sym_not] = ACTIONS(3731),
    [anon_sym_compl] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3733),
    [anon_sym_PLUS_PLUS] = ACTIONS(3733),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym___alignof__] = ACTIONS(3731),
    [anon_sym___alignof] = ACTIONS(3731),
    [anon_sym__alignof] = ACTIONS(3731),
    [anon_sym_alignof] = ACTIONS(3731),
    [anon_sym__Alignof] = ACTIONS(3731),
    [anon_sym_offsetof] = ACTIONS(3731),
    [anon_sym__Generic] = ACTIONS(3731),
    [anon_sym_asm] = ACTIONS(3731),
    [anon_sym___asm__] = ACTIONS(3731),
    [anon_sym___asm] = ACTIONS(3731),
    [sym_number_literal] = ACTIONS(3733),
    [anon_sym_L_SQUOTE] = ACTIONS(3733),
    [anon_sym_u_SQUOTE] = ACTIONS(3733),
    [anon_sym_U_SQUOTE] = ACTIONS(3733),
    [anon_sym_u8_SQUOTE] = ACTIONS(3733),
    [anon_sym_SQUOTE] = ACTIONS(3733),
    [anon_sym_L_DQUOTE] = ACTIONS(3733),
    [anon_sym_u_DQUOTE] = ACTIONS(3733),
    [anon_sym_U_DQUOTE] = ACTIONS(3733),
    [anon_sym_u8_DQUOTE] = ACTIONS(3733),
    [anon_sym_DQUOTE] = ACTIONS(3733),
    [sym_true] = ACTIONS(3731),
    [sym_false] = ACTIONS(3731),
    [anon_sym_NULL] = ACTIONS(3731),
    [anon_sym_nullptr] = ACTIONS(3731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3731),
    [anon_sym_let] = ACTIONS(3731),
    [anon_sym_This] = ACTIONS(3731),
    [anon_sym_decltype] = ACTIONS(3731),
    [anon_sym_explicit] = ACTIONS(3731),
    [anon_sym_typename] = ACTIONS(3731),
    [anon_sym_template] = ACTIONS(3731),
    [anon_sym_operator] = ACTIONS(3731),
    [anon_sym_try] = ACTIONS(3731),
    [anon_sym_delete] = ACTIONS(3731),
    [anon_sym_throw] = ACTIONS(3731),
    [anon_sym_namespace] = ACTIONS(3731),
    [anon_sym_static_assert] = ACTIONS(3731),
    [anon_sym_concept] = ACTIONS(3731),
    [anon_sym_co_return] = ACTIONS(3731),
    [anon_sym_co_yield] = ACTIONS(3731),
    [anon_sym_R_DQUOTE] = ACTIONS(3733),
    [anon_sym_LR_DQUOTE] = ACTIONS(3733),
    [anon_sym_uR_DQUOTE] = ACTIONS(3733),
    [anon_sym_UR_DQUOTE] = ACTIONS(3733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3733),
    [anon_sym_co_await] = ACTIONS(3731),
    [anon_sym_new] = ACTIONS(3731),
    [anon_sym_requires] = ACTIONS(3731),
    [sym_this] = ACTIONS(3731),
    [anon_sym_discard] = ACTIONS(3731),
    [anon_sym_precise] = ACTIONS(3731),
    [anon_sym_shared] = ACTIONS(3731),
    [anon_sym_groupshared] = ACTIONS(3731),
    [anon_sym_uniform] = ACTIONS(3731),
    [anon_sym_row_major] = ACTIONS(3731),
    [anon_sym_column_major] = ACTIONS(3731),
    [anon_sym_globallycoherent] = ACTIONS(3731),
    [anon_sym_centroid] = ACTIONS(3731),
    [anon_sym_noperspective] = ACTIONS(3731),
    [anon_sym_nointerpolation] = ACTIONS(3731),
    [anon_sym_sample] = ACTIONS(3731),
    [anon_sym_linear] = ACTIONS(3731),
    [anon_sym_snorm] = ACTIONS(3731),
    [anon_sym_unorm] = ACTIONS(3731),
    [anon_sym_point] = ACTIONS(3731),
    [anon_sym_line] = ACTIONS(3731),
    [anon_sym_triangleadj] = ACTIONS(3731),
    [anon_sym_lineadj] = ACTIONS(3731),
    [anon_sym_triangle] = ACTIONS(3731),
    [anon_sym_cbuffer] = ACTIONS(3731),
    [anon_sym_interface] = ACTIONS(3731),
    [anon_sym_extension] = ACTIONS(3731),
  },
  [1131] = {
    [sym_identifier] = ACTIONS(3977),
    [aux_sym_preproc_include_token1] = ACTIONS(3977),
    [aux_sym_preproc_def_token1] = ACTIONS(3977),
    [aux_sym_preproc_if_token1] = ACTIONS(3977),
    [aux_sym_preproc_if_token2] = ACTIONS(3977),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3977),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3977),
    [sym_preproc_directive] = ACTIONS(3977),
    [anon_sym_LPAREN2] = ACTIONS(3979),
    [anon_sym_BANG] = ACTIONS(3979),
    [anon_sym_TILDE] = ACTIONS(3979),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_PLUS] = ACTIONS(3977),
    [anon_sym_STAR] = ACTIONS(3979),
    [anon_sym_AMP_AMP] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3977),
    [anon_sym_SEMI] = ACTIONS(3979),
    [anon_sym___extension__] = ACTIONS(3977),
    [anon_sym_typedef] = ACTIONS(3977),
    [anon_sym_in] = ACTIONS(3977),
    [anon_sym_out] = ACTIONS(3977),
    [anon_sym_inout] = ACTIONS(3977),
    [anon_sym_virtual] = ACTIONS(3977),
    [anon_sym_extern] = ACTIONS(3977),
    [anon_sym___attribute__] = ACTIONS(3977),
    [anon_sym___attribute] = ACTIONS(3977),
    [anon_sym_using] = ACTIONS(3977),
    [anon_sym_COLON_COLON] = ACTIONS(3979),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3979),
    [anon_sym___declspec] = ACTIONS(3977),
    [anon_sym___based] = ACTIONS(3977),
    [anon_sym___cdecl] = ACTIONS(3977),
    [anon_sym___clrcall] = ACTIONS(3977),
    [anon_sym___stdcall] = ACTIONS(3977),
    [anon_sym___fastcall] = ACTIONS(3977),
    [anon_sym___thiscall] = ACTIONS(3977),
    [anon_sym___vectorcall] = ACTIONS(3977),
    [anon_sym_LBRACE] = ACTIONS(3979),
    [anon_sym_signed] = ACTIONS(3977),
    [anon_sym_unsigned] = ACTIONS(3977),
    [anon_sym_long] = ACTIONS(3977),
    [anon_sym_short] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3977),
    [anon_sym_static] = ACTIONS(3977),
    [anon_sym_register] = ACTIONS(3977),
    [anon_sym_inline] = ACTIONS(3977),
    [anon_sym___inline] = ACTIONS(3977),
    [anon_sym___inline__] = ACTIONS(3977),
    [anon_sym___forceinline] = ACTIONS(3977),
    [anon_sym_thread_local] = ACTIONS(3977),
    [anon_sym___thread] = ACTIONS(3977),
    [anon_sym_const] = ACTIONS(3977),
    [anon_sym_constexpr] = ACTIONS(3977),
    [anon_sym_volatile] = ACTIONS(3977),
    [anon_sym_restrict] = ACTIONS(3977),
    [anon_sym___restrict__] = ACTIONS(3977),
    [anon_sym__Atomic] = ACTIONS(3977),
    [anon_sym__Noreturn] = ACTIONS(3977),
    [anon_sym_noreturn] = ACTIONS(3977),
    [anon_sym__Nonnull] = ACTIONS(3977),
    [anon_sym_mutable] = ACTIONS(3977),
    [anon_sym_constinit] = ACTIONS(3977),
    [anon_sym_consteval] = ACTIONS(3977),
    [anon_sym_alignas] = ACTIONS(3977),
    [anon_sym__Alignas] = ACTIONS(3977),
    [sym_primitive_type] = ACTIONS(3977),
    [anon_sym_enum] = ACTIONS(3977),
    [anon_sym_class] = ACTIONS(3977),
    [anon_sym_struct] = ACTIONS(3977),
    [anon_sym_union] = ACTIONS(3977),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_switch] = ACTIONS(3977),
    [anon_sym_case] = ACTIONS(3977),
    [anon_sym_default] = ACTIONS(3977),
    [anon_sym_while] = ACTIONS(3977),
    [anon_sym_do] = ACTIONS(3977),
    [anon_sym_for] = ACTIONS(3977),
    [anon_sym_return] = ACTIONS(3977),
    [anon_sym_break] = ACTIONS(3977),
    [anon_sym_continue] = ACTIONS(3977),
    [anon_sym_goto] = ACTIONS(3977),
    [anon_sym___try] = ACTIONS(3977),
    [anon_sym___leave] = ACTIONS(3977),
    [anon_sym_not] = ACTIONS(3977),
    [anon_sym_compl] = ACTIONS(3977),
    [anon_sym_DASH_DASH] = ACTIONS(3979),
    [anon_sym_PLUS_PLUS] = ACTIONS(3979),
    [anon_sym_sizeof] = ACTIONS(3977),
    [anon_sym___alignof__] = ACTIONS(3977),
    [anon_sym___alignof] = ACTIONS(3977),
    [anon_sym__alignof] = ACTIONS(3977),
    [anon_sym_alignof] = ACTIONS(3977),
    [anon_sym__Alignof] = ACTIONS(3977),
    [anon_sym_offsetof] = ACTIONS(3977),
    [anon_sym__Generic] = ACTIONS(3977),
    [anon_sym_asm] = ACTIONS(3977),
    [anon_sym___asm__] = ACTIONS(3977),
    [anon_sym___asm] = ACTIONS(3977),
    [sym_number_literal] = ACTIONS(3979),
    [anon_sym_L_SQUOTE] = ACTIONS(3979),
    [anon_sym_u_SQUOTE] = ACTIONS(3979),
    [anon_sym_U_SQUOTE] = ACTIONS(3979),
    [anon_sym_u8_SQUOTE] = ACTIONS(3979),
    [anon_sym_SQUOTE] = ACTIONS(3979),
    [anon_sym_L_DQUOTE] = ACTIONS(3979),
    [anon_sym_u_DQUOTE] = ACTIONS(3979),
    [anon_sym_U_DQUOTE] = ACTIONS(3979),
    [anon_sym_u8_DQUOTE] = ACTIONS(3979),
    [anon_sym_DQUOTE] = ACTIONS(3979),
    [sym_true] = ACTIONS(3977),
    [sym_false] = ACTIONS(3977),
    [anon_sym_NULL] = ACTIONS(3977),
    [anon_sym_nullptr] = ACTIONS(3977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3977),
    [anon_sym_let] = ACTIONS(3977),
    [anon_sym_This] = ACTIONS(3977),
    [anon_sym_decltype] = ACTIONS(3977),
    [anon_sym_explicit] = ACTIONS(3977),
    [anon_sym_typename] = ACTIONS(3977),
    [anon_sym_template] = ACTIONS(3977),
    [anon_sym_operator] = ACTIONS(3977),
    [anon_sym_try] = ACTIONS(3977),
    [anon_sym_delete] = ACTIONS(3977),
    [anon_sym_throw] = ACTIONS(3977),
    [anon_sym_namespace] = ACTIONS(3977),
    [anon_sym_static_assert] = ACTIONS(3977),
    [anon_sym_concept] = ACTIONS(3977),
    [anon_sym_co_return] = ACTIONS(3977),
    [anon_sym_co_yield] = ACTIONS(3977),
    [anon_sym_R_DQUOTE] = ACTIONS(3979),
    [anon_sym_LR_DQUOTE] = ACTIONS(3979),
    [anon_sym_uR_DQUOTE] = ACTIONS(3979),
    [anon_sym_UR_DQUOTE] = ACTIONS(3979),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3979),
    [anon_sym_co_await] = ACTIONS(3977),
    [anon_sym_new] = ACTIONS(3977),
    [anon_sym_requires] = ACTIONS(3977),
    [sym_this] = ACTIONS(3977),
    [anon_sym_discard] = ACTIONS(3977),
    [anon_sym_precise] = ACTIONS(3977),
    [anon_sym_shared] = ACTIONS(3977),
    [anon_sym_groupshared] = ACTIONS(3977),
    [anon_sym_uniform] = ACTIONS(3977),
    [anon_sym_row_major] = ACTIONS(3977),
    [anon_sym_column_major] = ACTIONS(3977),
    [anon_sym_globallycoherent] = ACTIONS(3977),
    [anon_sym_centroid] = ACTIONS(3977),
    [anon_sym_noperspective] = ACTIONS(3977),
    [anon_sym_nointerpolation] = ACTIONS(3977),
    [anon_sym_sample] = ACTIONS(3977),
    [anon_sym_linear] = ACTIONS(3977),
    [anon_sym_snorm] = ACTIONS(3977),
    [anon_sym_unorm] = ACTIONS(3977),
    [anon_sym_point] = ACTIONS(3977),
    [anon_sym_line] = ACTIONS(3977),
    [anon_sym_triangleadj] = ACTIONS(3977),
    [anon_sym_lineadj] = ACTIONS(3977),
    [anon_sym_triangle] = ACTIONS(3977),
    [anon_sym_cbuffer] = ACTIONS(3977),
    [anon_sym_interface] = ACTIONS(3977),
    [anon_sym_extension] = ACTIONS(3977),
  },
  [1132] = {
    [sym_identifier] = ACTIONS(3677),
    [aux_sym_preproc_include_token1] = ACTIONS(3677),
    [aux_sym_preproc_def_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token2] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3677),
    [sym_preproc_directive] = ACTIONS(3677),
    [anon_sym_LPAREN2] = ACTIONS(3679),
    [anon_sym_BANG] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3677),
    [anon_sym_PLUS] = ACTIONS(3677),
    [anon_sym_STAR] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_AMP] = ACTIONS(3677),
    [anon_sym_SEMI] = ACTIONS(3679),
    [anon_sym___extension__] = ACTIONS(3677),
    [anon_sym_typedef] = ACTIONS(3677),
    [anon_sym_in] = ACTIONS(3677),
    [anon_sym_out] = ACTIONS(3677),
    [anon_sym_inout] = ACTIONS(3677),
    [anon_sym_virtual] = ACTIONS(3677),
    [anon_sym_extern] = ACTIONS(3677),
    [anon_sym___attribute__] = ACTIONS(3677),
    [anon_sym___attribute] = ACTIONS(3677),
    [anon_sym_using] = ACTIONS(3677),
    [anon_sym_COLON_COLON] = ACTIONS(3679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3679),
    [anon_sym___declspec] = ACTIONS(3677),
    [anon_sym___based] = ACTIONS(3677),
    [anon_sym___cdecl] = ACTIONS(3677),
    [anon_sym___clrcall] = ACTIONS(3677),
    [anon_sym___stdcall] = ACTIONS(3677),
    [anon_sym___fastcall] = ACTIONS(3677),
    [anon_sym___thiscall] = ACTIONS(3677),
    [anon_sym___vectorcall] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_signed] = ACTIONS(3677),
    [anon_sym_unsigned] = ACTIONS(3677),
    [anon_sym_long] = ACTIONS(3677),
    [anon_sym_short] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3677),
    [anon_sym_static] = ACTIONS(3677),
    [anon_sym_register] = ACTIONS(3677),
    [anon_sym_inline] = ACTIONS(3677),
    [anon_sym___inline] = ACTIONS(3677),
    [anon_sym___inline__] = ACTIONS(3677),
    [anon_sym___forceinline] = ACTIONS(3677),
    [anon_sym_thread_local] = ACTIONS(3677),
    [anon_sym___thread] = ACTIONS(3677),
    [anon_sym_const] = ACTIONS(3677),
    [anon_sym_constexpr] = ACTIONS(3677),
    [anon_sym_volatile] = ACTIONS(3677),
    [anon_sym_restrict] = ACTIONS(3677),
    [anon_sym___restrict__] = ACTIONS(3677),
    [anon_sym__Atomic] = ACTIONS(3677),
    [anon_sym__Noreturn] = ACTIONS(3677),
    [anon_sym_noreturn] = ACTIONS(3677),
    [anon_sym__Nonnull] = ACTIONS(3677),
    [anon_sym_mutable] = ACTIONS(3677),
    [anon_sym_constinit] = ACTIONS(3677),
    [anon_sym_consteval] = ACTIONS(3677),
    [anon_sym_alignas] = ACTIONS(3677),
    [anon_sym__Alignas] = ACTIONS(3677),
    [sym_primitive_type] = ACTIONS(3677),
    [anon_sym_enum] = ACTIONS(3677),
    [anon_sym_class] = ACTIONS(3677),
    [anon_sym_struct] = ACTIONS(3677),
    [anon_sym_union] = ACTIONS(3677),
    [anon_sym_if] = ACTIONS(3677),
    [anon_sym_switch] = ACTIONS(3677),
    [anon_sym_case] = ACTIONS(3677),
    [anon_sym_default] = ACTIONS(3677),
    [anon_sym_while] = ACTIONS(3677),
    [anon_sym_do] = ACTIONS(3677),
    [anon_sym_for] = ACTIONS(3677),
    [anon_sym_return] = ACTIONS(3677),
    [anon_sym_break] = ACTIONS(3677),
    [anon_sym_continue] = ACTIONS(3677),
    [anon_sym_goto] = ACTIONS(3677),
    [anon_sym___try] = ACTIONS(3677),
    [anon_sym___leave] = ACTIONS(3677),
    [anon_sym_not] = ACTIONS(3677),
    [anon_sym_compl] = ACTIONS(3677),
    [anon_sym_DASH_DASH] = ACTIONS(3679),
    [anon_sym_PLUS_PLUS] = ACTIONS(3679),
    [anon_sym_sizeof] = ACTIONS(3677),
    [anon_sym___alignof__] = ACTIONS(3677),
    [anon_sym___alignof] = ACTIONS(3677),
    [anon_sym__alignof] = ACTIONS(3677),
    [anon_sym_alignof] = ACTIONS(3677),
    [anon_sym__Alignof] = ACTIONS(3677),
    [anon_sym_offsetof] = ACTIONS(3677),
    [anon_sym__Generic] = ACTIONS(3677),
    [anon_sym_asm] = ACTIONS(3677),
    [anon_sym___asm__] = ACTIONS(3677),
    [anon_sym___asm] = ACTIONS(3677),
    [sym_number_literal] = ACTIONS(3679),
    [anon_sym_L_SQUOTE] = ACTIONS(3679),
    [anon_sym_u_SQUOTE] = ACTIONS(3679),
    [anon_sym_U_SQUOTE] = ACTIONS(3679),
    [anon_sym_u8_SQUOTE] = ACTIONS(3679),
    [anon_sym_SQUOTE] = ACTIONS(3679),
    [anon_sym_L_DQUOTE] = ACTIONS(3679),
    [anon_sym_u_DQUOTE] = ACTIONS(3679),
    [anon_sym_U_DQUOTE] = ACTIONS(3679),
    [anon_sym_u8_DQUOTE] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [sym_true] = ACTIONS(3677),
    [sym_false] = ACTIONS(3677),
    [anon_sym_NULL] = ACTIONS(3677),
    [anon_sym_nullptr] = ACTIONS(3677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3677),
    [anon_sym_let] = ACTIONS(3677),
    [anon_sym_This] = ACTIONS(3677),
    [anon_sym_decltype] = ACTIONS(3677),
    [anon_sym_explicit] = ACTIONS(3677),
    [anon_sym_typename] = ACTIONS(3677),
    [anon_sym_template] = ACTIONS(3677),
    [anon_sym_operator] = ACTIONS(3677),
    [anon_sym_try] = ACTIONS(3677),
    [anon_sym_delete] = ACTIONS(3677),
    [anon_sym_throw] = ACTIONS(3677),
    [anon_sym_namespace] = ACTIONS(3677),
    [anon_sym_static_assert] = ACTIONS(3677),
    [anon_sym_concept] = ACTIONS(3677),
    [anon_sym_co_return] = ACTIONS(3677),
    [anon_sym_co_yield] = ACTIONS(3677),
    [anon_sym_R_DQUOTE] = ACTIONS(3679),
    [anon_sym_LR_DQUOTE] = ACTIONS(3679),
    [anon_sym_uR_DQUOTE] = ACTIONS(3679),
    [anon_sym_UR_DQUOTE] = ACTIONS(3679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3679),
    [anon_sym_co_await] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3677),
    [anon_sym_requires] = ACTIONS(3677),
    [sym_this] = ACTIONS(3677),
    [anon_sym_discard] = ACTIONS(3677),
    [anon_sym_precise] = ACTIONS(3677),
    [anon_sym_shared] = ACTIONS(3677),
    [anon_sym_groupshared] = ACTIONS(3677),
    [anon_sym_uniform] = ACTIONS(3677),
    [anon_sym_row_major] = ACTIONS(3677),
    [anon_sym_column_major] = ACTIONS(3677),
    [anon_sym_globallycoherent] = ACTIONS(3677),
    [anon_sym_centroid] = ACTIONS(3677),
    [anon_sym_noperspective] = ACTIONS(3677),
    [anon_sym_nointerpolation] = ACTIONS(3677),
    [anon_sym_sample] = ACTIONS(3677),
    [anon_sym_linear] = ACTIONS(3677),
    [anon_sym_snorm] = ACTIONS(3677),
    [anon_sym_unorm] = ACTIONS(3677),
    [anon_sym_point] = ACTIONS(3677),
    [anon_sym_line] = ACTIONS(3677),
    [anon_sym_triangleadj] = ACTIONS(3677),
    [anon_sym_lineadj] = ACTIONS(3677),
    [anon_sym_triangle] = ACTIONS(3677),
    [anon_sym_cbuffer] = ACTIONS(3677),
    [anon_sym_interface] = ACTIONS(3677),
    [anon_sym_extension] = ACTIONS(3677),
  },
  [1133] = {
    [ts_builtin_sym_end] = ACTIONS(3773),
    [sym_identifier] = ACTIONS(3771),
    [aux_sym_preproc_include_token1] = ACTIONS(3771),
    [aux_sym_preproc_def_token1] = ACTIONS(3771),
    [aux_sym_preproc_if_token1] = ACTIONS(3771),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3771),
    [sym_preproc_directive] = ACTIONS(3771),
    [anon_sym_LPAREN2] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(3773),
    [anon_sym_TILDE] = ACTIONS(3773),
    [anon_sym_DASH] = ACTIONS(3771),
    [anon_sym_PLUS] = ACTIONS(3771),
    [anon_sym_STAR] = ACTIONS(3773),
    [anon_sym_AMP_AMP] = ACTIONS(3773),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_SEMI] = ACTIONS(3773),
    [anon_sym___extension__] = ACTIONS(3771),
    [anon_sym_typedef] = ACTIONS(3771),
    [anon_sym_in] = ACTIONS(3771),
    [anon_sym_out] = ACTIONS(3771),
    [anon_sym_inout] = ACTIONS(3771),
    [anon_sym_virtual] = ACTIONS(3771),
    [anon_sym_extern] = ACTIONS(3771),
    [anon_sym___attribute__] = ACTIONS(3771),
    [anon_sym___attribute] = ACTIONS(3771),
    [anon_sym_using] = ACTIONS(3771),
    [anon_sym_COLON_COLON] = ACTIONS(3773),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3773),
    [anon_sym___declspec] = ACTIONS(3771),
    [anon_sym___based] = ACTIONS(3771),
    [anon_sym___cdecl] = ACTIONS(3771),
    [anon_sym___clrcall] = ACTIONS(3771),
    [anon_sym___stdcall] = ACTIONS(3771),
    [anon_sym___fastcall] = ACTIONS(3771),
    [anon_sym___thiscall] = ACTIONS(3771),
    [anon_sym___vectorcall] = ACTIONS(3771),
    [anon_sym_LBRACE] = ACTIONS(3773),
    [anon_sym_signed] = ACTIONS(3771),
    [anon_sym_unsigned] = ACTIONS(3771),
    [anon_sym_long] = ACTIONS(3771),
    [anon_sym_short] = ACTIONS(3771),
    [anon_sym_LBRACK] = ACTIONS(3771),
    [anon_sym_static] = ACTIONS(3771),
    [anon_sym_register] = ACTIONS(3771),
    [anon_sym_inline] = ACTIONS(3771),
    [anon_sym___inline] = ACTIONS(3771),
    [anon_sym___inline__] = ACTIONS(3771),
    [anon_sym___forceinline] = ACTIONS(3771),
    [anon_sym_thread_local] = ACTIONS(3771),
    [anon_sym___thread] = ACTIONS(3771),
    [anon_sym_const] = ACTIONS(3771),
    [anon_sym_constexpr] = ACTIONS(3771),
    [anon_sym_volatile] = ACTIONS(3771),
    [anon_sym_restrict] = ACTIONS(3771),
    [anon_sym___restrict__] = ACTIONS(3771),
    [anon_sym__Atomic] = ACTIONS(3771),
    [anon_sym__Noreturn] = ACTIONS(3771),
    [anon_sym_noreturn] = ACTIONS(3771),
    [anon_sym__Nonnull] = ACTIONS(3771),
    [anon_sym_mutable] = ACTIONS(3771),
    [anon_sym_constinit] = ACTIONS(3771),
    [anon_sym_consteval] = ACTIONS(3771),
    [anon_sym_alignas] = ACTIONS(3771),
    [anon_sym__Alignas] = ACTIONS(3771),
    [sym_primitive_type] = ACTIONS(3771),
    [anon_sym_enum] = ACTIONS(3771),
    [anon_sym_class] = ACTIONS(3771),
    [anon_sym_struct] = ACTIONS(3771),
    [anon_sym_union] = ACTIONS(3771),
    [anon_sym_if] = ACTIONS(3771),
    [anon_sym_switch] = ACTIONS(3771),
    [anon_sym_case] = ACTIONS(3771),
    [anon_sym_default] = ACTIONS(3771),
    [anon_sym_while] = ACTIONS(3771),
    [anon_sym_do] = ACTIONS(3771),
    [anon_sym_for] = ACTIONS(3771),
    [anon_sym_return] = ACTIONS(3771),
    [anon_sym_break] = ACTIONS(3771),
    [anon_sym_continue] = ACTIONS(3771),
    [anon_sym_goto] = ACTIONS(3771),
    [anon_sym_not] = ACTIONS(3771),
    [anon_sym_compl] = ACTIONS(3771),
    [anon_sym_DASH_DASH] = ACTIONS(3773),
    [anon_sym_PLUS_PLUS] = ACTIONS(3773),
    [anon_sym_sizeof] = ACTIONS(3771),
    [anon_sym___alignof__] = ACTIONS(3771),
    [anon_sym___alignof] = ACTIONS(3771),
    [anon_sym__alignof] = ACTIONS(3771),
    [anon_sym_alignof] = ACTIONS(3771),
    [anon_sym__Alignof] = ACTIONS(3771),
    [anon_sym_offsetof] = ACTIONS(3771),
    [anon_sym__Generic] = ACTIONS(3771),
    [anon_sym_asm] = ACTIONS(3771),
    [anon_sym___asm__] = ACTIONS(3771),
    [anon_sym___asm] = ACTIONS(3771),
    [sym_number_literal] = ACTIONS(3773),
    [anon_sym_L_SQUOTE] = ACTIONS(3773),
    [anon_sym_u_SQUOTE] = ACTIONS(3773),
    [anon_sym_U_SQUOTE] = ACTIONS(3773),
    [anon_sym_u8_SQUOTE] = ACTIONS(3773),
    [anon_sym_SQUOTE] = ACTIONS(3773),
    [anon_sym_L_DQUOTE] = ACTIONS(3773),
    [anon_sym_u_DQUOTE] = ACTIONS(3773),
    [anon_sym_U_DQUOTE] = ACTIONS(3773),
    [anon_sym_u8_DQUOTE] = ACTIONS(3773),
    [anon_sym_DQUOTE] = ACTIONS(3773),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [anon_sym_NULL] = ACTIONS(3771),
    [anon_sym_nullptr] = ACTIONS(3771),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3771),
    [anon_sym_let] = ACTIONS(3771),
    [anon_sym_This] = ACTIONS(3771),
    [anon_sym_decltype] = ACTIONS(3771),
    [anon_sym_explicit] = ACTIONS(3771),
    [anon_sym_typename] = ACTIONS(3771),
    [anon_sym_export] = ACTIONS(3771),
    [anon_sym_module] = ACTIONS(3771),
    [anon_sym_import] = ACTIONS(3771),
    [anon_sym_template] = ACTIONS(3771),
    [anon_sym_operator] = ACTIONS(3771),
    [anon_sym_try] = ACTIONS(3771),
    [anon_sym_delete] = ACTIONS(3771),
    [anon_sym_throw] = ACTIONS(3771),
    [anon_sym_namespace] = ACTIONS(3771),
    [anon_sym_static_assert] = ACTIONS(3771),
    [anon_sym_concept] = ACTIONS(3771),
    [anon_sym_co_return] = ACTIONS(3771),
    [anon_sym_co_yield] = ACTIONS(3771),
    [anon_sym_R_DQUOTE] = ACTIONS(3773),
    [anon_sym_LR_DQUOTE] = ACTIONS(3773),
    [anon_sym_uR_DQUOTE] = ACTIONS(3773),
    [anon_sym_UR_DQUOTE] = ACTIONS(3773),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3773),
    [anon_sym_co_await] = ACTIONS(3771),
    [anon_sym_new] = ACTIONS(3771),
    [anon_sym_requires] = ACTIONS(3771),
    [sym_this] = ACTIONS(3771),
    [anon_sym_precise] = ACTIONS(3771),
    [anon_sym_shared] = ACTIONS(3771),
    [anon_sym_groupshared] = ACTIONS(3771),
    [anon_sym_uniform] = ACTIONS(3771),
    [anon_sym_row_major] = ACTIONS(3771),
    [anon_sym_column_major] = ACTIONS(3771),
    [anon_sym_globallycoherent] = ACTIONS(3771),
    [anon_sym_centroid] = ACTIONS(3771),
    [anon_sym_noperspective] = ACTIONS(3771),
    [anon_sym_nointerpolation] = ACTIONS(3771),
    [anon_sym_sample] = ACTIONS(3771),
    [anon_sym_linear] = ACTIONS(3771),
    [anon_sym_snorm] = ACTIONS(3771),
    [anon_sym_unorm] = ACTIONS(3771),
    [anon_sym_point] = ACTIONS(3771),
    [anon_sym_line] = ACTIONS(3771),
    [anon_sym_triangleadj] = ACTIONS(3771),
    [anon_sym_lineadj] = ACTIONS(3771),
    [anon_sym_triangle] = ACTIONS(3771),
    [anon_sym_interface] = ACTIONS(3771),
    [anon_sym_extension] = ACTIONS(3771),
    [anon_sym___exported] = ACTIONS(3771),
  },
  [1134] = {
    [ts_builtin_sym_end] = ACTIONS(4393),
    [sym_identifier] = ACTIONS(4395),
    [aux_sym_preproc_include_token1] = ACTIONS(4395),
    [aux_sym_preproc_def_token1] = ACTIONS(4395),
    [aux_sym_preproc_if_token1] = ACTIONS(4395),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4395),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4395),
    [sym_preproc_directive] = ACTIONS(4395),
    [anon_sym_LPAREN2] = ACTIONS(4393),
    [anon_sym_BANG] = ACTIONS(4393),
    [anon_sym_TILDE] = ACTIONS(4393),
    [anon_sym_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4395),
    [anon_sym_STAR] = ACTIONS(4393),
    [anon_sym_AMP_AMP] = ACTIONS(4393),
    [anon_sym_AMP] = ACTIONS(4395),
    [anon_sym_SEMI] = ACTIONS(4393),
    [anon_sym___extension__] = ACTIONS(4395),
    [anon_sym_typedef] = ACTIONS(4395),
    [anon_sym_in] = ACTIONS(4395),
    [anon_sym_out] = ACTIONS(4395),
    [anon_sym_inout] = ACTIONS(4395),
    [anon_sym_virtual] = ACTIONS(4395),
    [anon_sym_extern] = ACTIONS(4395),
    [anon_sym___attribute__] = ACTIONS(4395),
    [anon_sym___attribute] = ACTIONS(4395),
    [anon_sym_using] = ACTIONS(4395),
    [anon_sym_COLON_COLON] = ACTIONS(4393),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4393),
    [anon_sym___declspec] = ACTIONS(4395),
    [anon_sym___based] = ACTIONS(4395),
    [anon_sym___cdecl] = ACTIONS(4395),
    [anon_sym___clrcall] = ACTIONS(4395),
    [anon_sym___stdcall] = ACTIONS(4395),
    [anon_sym___fastcall] = ACTIONS(4395),
    [anon_sym___thiscall] = ACTIONS(4395),
    [anon_sym___vectorcall] = ACTIONS(4395),
    [anon_sym_LBRACE] = ACTIONS(4393),
    [anon_sym_signed] = ACTIONS(4395),
    [anon_sym_unsigned] = ACTIONS(4395),
    [anon_sym_long] = ACTIONS(4395),
    [anon_sym_short] = ACTIONS(4395),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_static] = ACTIONS(4395),
    [anon_sym_register] = ACTIONS(4395),
    [anon_sym_inline] = ACTIONS(4395),
    [anon_sym___inline] = ACTIONS(4395),
    [anon_sym___inline__] = ACTIONS(4395),
    [anon_sym___forceinline] = ACTIONS(4395),
    [anon_sym_thread_local] = ACTIONS(4395),
    [anon_sym___thread] = ACTIONS(4395),
    [anon_sym_const] = ACTIONS(4395),
    [anon_sym_constexpr] = ACTIONS(4395),
    [anon_sym_volatile] = ACTIONS(4395),
    [anon_sym_restrict] = ACTIONS(4395),
    [anon_sym___restrict__] = ACTIONS(4395),
    [anon_sym__Atomic] = ACTIONS(4395),
    [anon_sym__Noreturn] = ACTIONS(4395),
    [anon_sym_noreturn] = ACTIONS(4395),
    [anon_sym__Nonnull] = ACTIONS(4395),
    [anon_sym_mutable] = ACTIONS(4395),
    [anon_sym_constinit] = ACTIONS(4395),
    [anon_sym_consteval] = ACTIONS(4395),
    [anon_sym_alignas] = ACTIONS(4395),
    [anon_sym__Alignas] = ACTIONS(4395),
    [sym_primitive_type] = ACTIONS(4395),
    [anon_sym_enum] = ACTIONS(4395),
    [anon_sym_class] = ACTIONS(4395),
    [anon_sym_struct] = ACTIONS(4395),
    [anon_sym_union] = ACTIONS(4395),
    [anon_sym_if] = ACTIONS(4395),
    [anon_sym_switch] = ACTIONS(4395),
    [anon_sym_case] = ACTIONS(4395),
    [anon_sym_default] = ACTIONS(4395),
    [anon_sym_while] = ACTIONS(4395),
    [anon_sym_do] = ACTIONS(4395),
    [anon_sym_for] = ACTIONS(4395),
    [anon_sym_return] = ACTIONS(4395),
    [anon_sym_break] = ACTIONS(4395),
    [anon_sym_continue] = ACTIONS(4395),
    [anon_sym_goto] = ACTIONS(4395),
    [anon_sym_not] = ACTIONS(4395),
    [anon_sym_compl] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4393),
    [anon_sym_PLUS_PLUS] = ACTIONS(4393),
    [anon_sym_sizeof] = ACTIONS(4395),
    [anon_sym___alignof__] = ACTIONS(4395),
    [anon_sym___alignof] = ACTIONS(4395),
    [anon_sym__alignof] = ACTIONS(4395),
    [anon_sym_alignof] = ACTIONS(4395),
    [anon_sym__Alignof] = ACTIONS(4395),
    [anon_sym_offsetof] = ACTIONS(4395),
    [anon_sym__Generic] = ACTIONS(4395),
    [anon_sym_asm] = ACTIONS(4395),
    [anon_sym___asm__] = ACTIONS(4395),
    [anon_sym___asm] = ACTIONS(4395),
    [sym_number_literal] = ACTIONS(4393),
    [anon_sym_L_SQUOTE] = ACTIONS(4393),
    [anon_sym_u_SQUOTE] = ACTIONS(4393),
    [anon_sym_U_SQUOTE] = ACTIONS(4393),
    [anon_sym_u8_SQUOTE] = ACTIONS(4393),
    [anon_sym_SQUOTE] = ACTIONS(4393),
    [anon_sym_L_DQUOTE] = ACTIONS(4393),
    [anon_sym_u_DQUOTE] = ACTIONS(4393),
    [anon_sym_U_DQUOTE] = ACTIONS(4393),
    [anon_sym_u8_DQUOTE] = ACTIONS(4393),
    [anon_sym_DQUOTE] = ACTIONS(4393),
    [sym_true] = ACTIONS(4395),
    [sym_false] = ACTIONS(4395),
    [anon_sym_NULL] = ACTIONS(4395),
    [anon_sym_nullptr] = ACTIONS(4395),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4395),
    [anon_sym_let] = ACTIONS(4395),
    [anon_sym_This] = ACTIONS(4395),
    [anon_sym_decltype] = ACTIONS(4395),
    [anon_sym_explicit] = ACTIONS(4395),
    [anon_sym_typename] = ACTIONS(4395),
    [anon_sym_export] = ACTIONS(4395),
    [anon_sym_module] = ACTIONS(4395),
    [anon_sym_import] = ACTIONS(4395),
    [anon_sym_template] = ACTIONS(4395),
    [anon_sym_operator] = ACTIONS(4395),
    [anon_sym_try] = ACTIONS(4395),
    [anon_sym_delete] = ACTIONS(4395),
    [anon_sym_throw] = ACTIONS(4395),
    [anon_sym_namespace] = ACTIONS(4395),
    [anon_sym_static_assert] = ACTIONS(4395),
    [anon_sym_concept] = ACTIONS(4395),
    [anon_sym_co_return] = ACTIONS(4395),
    [anon_sym_co_yield] = ACTIONS(4395),
    [anon_sym_R_DQUOTE] = ACTIONS(4393),
    [anon_sym_LR_DQUOTE] = ACTIONS(4393),
    [anon_sym_uR_DQUOTE] = ACTIONS(4393),
    [anon_sym_UR_DQUOTE] = ACTIONS(4393),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4393),
    [anon_sym_co_await] = ACTIONS(4395),
    [anon_sym_new] = ACTIONS(4395),
    [anon_sym_requires] = ACTIONS(4395),
    [sym_this] = ACTIONS(4395),
    [anon_sym_precise] = ACTIONS(4395),
    [anon_sym_shared] = ACTIONS(4395),
    [anon_sym_groupshared] = ACTIONS(4395),
    [anon_sym_uniform] = ACTIONS(4395),
    [anon_sym_row_major] = ACTIONS(4395),
    [anon_sym_column_major] = ACTIONS(4395),
    [anon_sym_globallycoherent] = ACTIONS(4395),
    [anon_sym_centroid] = ACTIONS(4395),
    [anon_sym_noperspective] = ACTIONS(4395),
    [anon_sym_nointerpolation] = ACTIONS(4395),
    [anon_sym_sample] = ACTIONS(4395),
    [anon_sym_linear] = ACTIONS(4395),
    [anon_sym_snorm] = ACTIONS(4395),
    [anon_sym_unorm] = ACTIONS(4395),
    [anon_sym_point] = ACTIONS(4395),
    [anon_sym_line] = ACTIONS(4395),
    [anon_sym_triangleadj] = ACTIONS(4395),
    [anon_sym_lineadj] = ACTIONS(4395),
    [anon_sym_triangle] = ACTIONS(4395),
    [anon_sym_interface] = ACTIONS(4395),
    [anon_sym_extension] = ACTIONS(4395),
    [anon_sym___exported] = ACTIONS(4395),
  },
  [1135] = {
    [ts_builtin_sym_end] = ACTIONS(4397),
    [sym_identifier] = ACTIONS(4399),
    [aux_sym_preproc_include_token1] = ACTIONS(4399),
    [aux_sym_preproc_def_token1] = ACTIONS(4399),
    [aux_sym_preproc_if_token1] = ACTIONS(4399),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4399),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4399),
    [sym_preproc_directive] = ACTIONS(4399),
    [anon_sym_LPAREN2] = ACTIONS(4397),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_TILDE] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(4399),
    [anon_sym_STAR] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4399),
    [anon_sym_SEMI] = ACTIONS(4397),
    [anon_sym___extension__] = ACTIONS(4399),
    [anon_sym_typedef] = ACTIONS(4399),
    [anon_sym_in] = ACTIONS(4399),
    [anon_sym_out] = ACTIONS(4399),
    [anon_sym_inout] = ACTIONS(4399),
    [anon_sym_virtual] = ACTIONS(4399),
    [anon_sym_extern] = ACTIONS(4399),
    [anon_sym___attribute__] = ACTIONS(4399),
    [anon_sym___attribute] = ACTIONS(4399),
    [anon_sym_using] = ACTIONS(4399),
    [anon_sym_COLON_COLON] = ACTIONS(4397),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4397),
    [anon_sym___declspec] = ACTIONS(4399),
    [anon_sym___based] = ACTIONS(4399),
    [anon_sym___cdecl] = ACTIONS(4399),
    [anon_sym___clrcall] = ACTIONS(4399),
    [anon_sym___stdcall] = ACTIONS(4399),
    [anon_sym___fastcall] = ACTIONS(4399),
    [anon_sym___thiscall] = ACTIONS(4399),
    [anon_sym___vectorcall] = ACTIONS(4399),
    [anon_sym_LBRACE] = ACTIONS(4397),
    [anon_sym_signed] = ACTIONS(4399),
    [anon_sym_unsigned] = ACTIONS(4399),
    [anon_sym_long] = ACTIONS(4399),
    [anon_sym_short] = ACTIONS(4399),
    [anon_sym_LBRACK] = ACTIONS(4399),
    [anon_sym_static] = ACTIONS(4399),
    [anon_sym_register] = ACTIONS(4399),
    [anon_sym_inline] = ACTIONS(4399),
    [anon_sym___inline] = ACTIONS(4399),
    [anon_sym___inline__] = ACTIONS(4399),
    [anon_sym___forceinline] = ACTIONS(4399),
    [anon_sym_thread_local] = ACTIONS(4399),
    [anon_sym___thread] = ACTIONS(4399),
    [anon_sym_const] = ACTIONS(4399),
    [anon_sym_constexpr] = ACTIONS(4399),
    [anon_sym_volatile] = ACTIONS(4399),
    [anon_sym_restrict] = ACTIONS(4399),
    [anon_sym___restrict__] = ACTIONS(4399),
    [anon_sym__Atomic] = ACTIONS(4399),
    [anon_sym__Noreturn] = ACTIONS(4399),
    [anon_sym_noreturn] = ACTIONS(4399),
    [anon_sym__Nonnull] = ACTIONS(4399),
    [anon_sym_mutable] = ACTIONS(4399),
    [anon_sym_constinit] = ACTIONS(4399),
    [anon_sym_consteval] = ACTIONS(4399),
    [anon_sym_alignas] = ACTIONS(4399),
    [anon_sym__Alignas] = ACTIONS(4399),
    [sym_primitive_type] = ACTIONS(4399),
    [anon_sym_enum] = ACTIONS(4399),
    [anon_sym_class] = ACTIONS(4399),
    [anon_sym_struct] = ACTIONS(4399),
    [anon_sym_union] = ACTIONS(4399),
    [anon_sym_if] = ACTIONS(4399),
    [anon_sym_switch] = ACTIONS(4399),
    [anon_sym_case] = ACTIONS(4399),
    [anon_sym_default] = ACTIONS(4399),
    [anon_sym_while] = ACTIONS(4399),
    [anon_sym_do] = ACTIONS(4399),
    [anon_sym_for] = ACTIONS(4399),
    [anon_sym_return] = ACTIONS(4399),
    [anon_sym_break] = ACTIONS(4399),
    [anon_sym_continue] = ACTIONS(4399),
    [anon_sym_goto] = ACTIONS(4399),
    [anon_sym_not] = ACTIONS(4399),
    [anon_sym_compl] = ACTIONS(4399),
    [anon_sym_DASH_DASH] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4397),
    [anon_sym_sizeof] = ACTIONS(4399),
    [anon_sym___alignof__] = ACTIONS(4399),
    [anon_sym___alignof] = ACTIONS(4399),
    [anon_sym__alignof] = ACTIONS(4399),
    [anon_sym_alignof] = ACTIONS(4399),
    [anon_sym__Alignof] = ACTIONS(4399),
    [anon_sym_offsetof] = ACTIONS(4399),
    [anon_sym__Generic] = ACTIONS(4399),
    [anon_sym_asm] = ACTIONS(4399),
    [anon_sym___asm__] = ACTIONS(4399),
    [anon_sym___asm] = ACTIONS(4399),
    [sym_number_literal] = ACTIONS(4397),
    [anon_sym_L_SQUOTE] = ACTIONS(4397),
    [anon_sym_u_SQUOTE] = ACTIONS(4397),
    [anon_sym_U_SQUOTE] = ACTIONS(4397),
    [anon_sym_u8_SQUOTE] = ACTIONS(4397),
    [anon_sym_SQUOTE] = ACTIONS(4397),
    [anon_sym_L_DQUOTE] = ACTIONS(4397),
    [anon_sym_u_DQUOTE] = ACTIONS(4397),
    [anon_sym_U_DQUOTE] = ACTIONS(4397),
    [anon_sym_u8_DQUOTE] = ACTIONS(4397),
    [anon_sym_DQUOTE] = ACTIONS(4397),
    [sym_true] = ACTIONS(4399),
    [sym_false] = ACTIONS(4399),
    [anon_sym_NULL] = ACTIONS(4399),
    [anon_sym_nullptr] = ACTIONS(4399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4399),
    [anon_sym_let] = ACTIONS(4399),
    [anon_sym_This] = ACTIONS(4399),
    [anon_sym_decltype] = ACTIONS(4399),
    [anon_sym_explicit] = ACTIONS(4399),
    [anon_sym_typename] = ACTIONS(4399),
    [anon_sym_export] = ACTIONS(4399),
    [anon_sym_module] = ACTIONS(4399),
    [anon_sym_import] = ACTIONS(4399),
    [anon_sym_template] = ACTIONS(4399),
    [anon_sym_operator] = ACTIONS(4399),
    [anon_sym_try] = ACTIONS(4399),
    [anon_sym_delete] = ACTIONS(4399),
    [anon_sym_throw] = ACTIONS(4399),
    [anon_sym_namespace] = ACTIONS(4399),
    [anon_sym_static_assert] = ACTIONS(4399),
    [anon_sym_concept] = ACTIONS(4399),
    [anon_sym_co_return] = ACTIONS(4399),
    [anon_sym_co_yield] = ACTIONS(4399),
    [anon_sym_R_DQUOTE] = ACTIONS(4397),
    [anon_sym_LR_DQUOTE] = ACTIONS(4397),
    [anon_sym_uR_DQUOTE] = ACTIONS(4397),
    [anon_sym_UR_DQUOTE] = ACTIONS(4397),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4397),
    [anon_sym_co_await] = ACTIONS(4399),
    [anon_sym_new] = ACTIONS(4399),
    [anon_sym_requires] = ACTIONS(4399),
    [sym_this] = ACTIONS(4399),
    [anon_sym_precise] = ACTIONS(4399),
    [anon_sym_shared] = ACTIONS(4399),
    [anon_sym_groupshared] = ACTIONS(4399),
    [anon_sym_uniform] = ACTIONS(4399),
    [anon_sym_row_major] = ACTIONS(4399),
    [anon_sym_column_major] = ACTIONS(4399),
    [anon_sym_globallycoherent] = ACTIONS(4399),
    [anon_sym_centroid] = ACTIONS(4399),
    [anon_sym_noperspective] = ACTIONS(4399),
    [anon_sym_nointerpolation] = ACTIONS(4399),
    [anon_sym_sample] = ACTIONS(4399),
    [anon_sym_linear] = ACTIONS(4399),
    [anon_sym_snorm] = ACTIONS(4399),
    [anon_sym_unorm] = ACTIONS(4399),
    [anon_sym_point] = ACTIONS(4399),
    [anon_sym_line] = ACTIONS(4399),
    [anon_sym_triangleadj] = ACTIONS(4399),
    [anon_sym_lineadj] = ACTIONS(4399),
    [anon_sym_triangle] = ACTIONS(4399),
    [anon_sym_interface] = ACTIONS(4399),
    [anon_sym_extension] = ACTIONS(4399),
    [anon_sym___exported] = ACTIONS(4399),
  },
  [1136] = {
    [sym_identifier] = ACTIONS(3804),
    [aux_sym_preproc_include_token1] = ACTIONS(3804),
    [aux_sym_preproc_def_token1] = ACTIONS(3804),
    [aux_sym_preproc_if_token1] = ACTIONS(3804),
    [aux_sym_preproc_if_token2] = ACTIONS(3804),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3804),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3804),
    [sym_preproc_directive] = ACTIONS(3804),
    [anon_sym_LPAREN2] = ACTIONS(3806),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(3806),
    [anon_sym_AMP_AMP] = ACTIONS(3806),
    [anon_sym_AMP] = ACTIONS(3804),
    [anon_sym_SEMI] = ACTIONS(3806),
    [anon_sym___extension__] = ACTIONS(3804),
    [anon_sym_typedef] = ACTIONS(3804),
    [anon_sym_in] = ACTIONS(3804),
    [anon_sym_out] = ACTIONS(3804),
    [anon_sym_inout] = ACTIONS(3804),
    [anon_sym_virtual] = ACTIONS(3804),
    [anon_sym_extern] = ACTIONS(3804),
    [anon_sym___attribute__] = ACTIONS(3804),
    [anon_sym___attribute] = ACTIONS(3804),
    [anon_sym_using] = ACTIONS(3804),
    [anon_sym_COLON_COLON] = ACTIONS(3806),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3806),
    [anon_sym___declspec] = ACTIONS(3804),
    [anon_sym___based] = ACTIONS(3804),
    [anon_sym___cdecl] = ACTIONS(3804),
    [anon_sym___clrcall] = ACTIONS(3804),
    [anon_sym___stdcall] = ACTIONS(3804),
    [anon_sym___fastcall] = ACTIONS(3804),
    [anon_sym___thiscall] = ACTIONS(3804),
    [anon_sym___vectorcall] = ACTIONS(3804),
    [anon_sym_LBRACE] = ACTIONS(3806),
    [anon_sym_signed] = ACTIONS(3804),
    [anon_sym_unsigned] = ACTIONS(3804),
    [anon_sym_long] = ACTIONS(3804),
    [anon_sym_short] = ACTIONS(3804),
    [anon_sym_LBRACK] = ACTIONS(3804),
    [anon_sym_static] = ACTIONS(3804),
    [anon_sym_register] = ACTIONS(3804),
    [anon_sym_inline] = ACTIONS(3804),
    [anon_sym___inline] = ACTIONS(3804),
    [anon_sym___inline__] = ACTIONS(3804),
    [anon_sym___forceinline] = ACTIONS(3804),
    [anon_sym_thread_local] = ACTIONS(3804),
    [anon_sym___thread] = ACTIONS(3804),
    [anon_sym_const] = ACTIONS(3804),
    [anon_sym_constexpr] = ACTIONS(3804),
    [anon_sym_volatile] = ACTIONS(3804),
    [anon_sym_restrict] = ACTIONS(3804),
    [anon_sym___restrict__] = ACTIONS(3804),
    [anon_sym__Atomic] = ACTIONS(3804),
    [anon_sym__Noreturn] = ACTIONS(3804),
    [anon_sym_noreturn] = ACTIONS(3804),
    [anon_sym__Nonnull] = ACTIONS(3804),
    [anon_sym_mutable] = ACTIONS(3804),
    [anon_sym_constinit] = ACTIONS(3804),
    [anon_sym_consteval] = ACTIONS(3804),
    [anon_sym_alignas] = ACTIONS(3804),
    [anon_sym__Alignas] = ACTIONS(3804),
    [sym_primitive_type] = ACTIONS(3804),
    [anon_sym_enum] = ACTIONS(3804),
    [anon_sym_class] = ACTIONS(3804),
    [anon_sym_struct] = ACTIONS(3804),
    [anon_sym_union] = ACTIONS(3804),
    [anon_sym_if] = ACTIONS(3804),
    [anon_sym_switch] = ACTIONS(3804),
    [anon_sym_case] = ACTIONS(3804),
    [anon_sym_default] = ACTIONS(3804),
    [anon_sym_while] = ACTIONS(3804),
    [anon_sym_do] = ACTIONS(3804),
    [anon_sym_for] = ACTIONS(3804),
    [anon_sym_return] = ACTIONS(3804),
    [anon_sym_break] = ACTIONS(3804),
    [anon_sym_continue] = ACTIONS(3804),
    [anon_sym_goto] = ACTIONS(3804),
    [anon_sym___try] = ACTIONS(3804),
    [anon_sym___leave] = ACTIONS(3804),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(3806),
    [anon_sym_PLUS_PLUS] = ACTIONS(3806),
    [anon_sym_sizeof] = ACTIONS(3804),
    [anon_sym___alignof__] = ACTIONS(3804),
    [anon_sym___alignof] = ACTIONS(3804),
    [anon_sym__alignof] = ACTIONS(3804),
    [anon_sym_alignof] = ACTIONS(3804),
    [anon_sym__Alignof] = ACTIONS(3804),
    [anon_sym_offsetof] = ACTIONS(3804),
    [anon_sym__Generic] = ACTIONS(3804),
    [anon_sym_asm] = ACTIONS(3804),
    [anon_sym___asm__] = ACTIONS(3804),
    [anon_sym___asm] = ACTIONS(3804),
    [sym_number_literal] = ACTIONS(3806),
    [anon_sym_L_SQUOTE] = ACTIONS(3806),
    [anon_sym_u_SQUOTE] = ACTIONS(3806),
    [anon_sym_U_SQUOTE] = ACTIONS(3806),
    [anon_sym_u8_SQUOTE] = ACTIONS(3806),
    [anon_sym_SQUOTE] = ACTIONS(3806),
    [anon_sym_L_DQUOTE] = ACTIONS(3806),
    [anon_sym_u_DQUOTE] = ACTIONS(3806),
    [anon_sym_U_DQUOTE] = ACTIONS(3806),
    [anon_sym_u8_DQUOTE] = ACTIONS(3806),
    [anon_sym_DQUOTE] = ACTIONS(3806),
    [sym_true] = ACTIONS(3804),
    [sym_false] = ACTIONS(3804),
    [anon_sym_NULL] = ACTIONS(3804),
    [anon_sym_nullptr] = ACTIONS(3804),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3804),
    [anon_sym_let] = ACTIONS(3804),
    [anon_sym_This] = ACTIONS(3804),
    [anon_sym_decltype] = ACTIONS(3804),
    [anon_sym_explicit] = ACTIONS(3804),
    [anon_sym_typename] = ACTIONS(3804),
    [anon_sym_template] = ACTIONS(3804),
    [anon_sym_operator] = ACTIONS(3804),
    [anon_sym_try] = ACTIONS(3804),
    [anon_sym_delete] = ACTIONS(3804),
    [anon_sym_throw] = ACTIONS(3804),
    [anon_sym_namespace] = ACTIONS(3804),
    [anon_sym_static_assert] = ACTIONS(3804),
    [anon_sym_concept] = ACTIONS(3804),
    [anon_sym_co_return] = ACTIONS(3804),
    [anon_sym_co_yield] = ACTIONS(3804),
    [anon_sym_R_DQUOTE] = ACTIONS(3806),
    [anon_sym_LR_DQUOTE] = ACTIONS(3806),
    [anon_sym_uR_DQUOTE] = ACTIONS(3806),
    [anon_sym_UR_DQUOTE] = ACTIONS(3806),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3806),
    [anon_sym_co_await] = ACTIONS(3804),
    [anon_sym_new] = ACTIONS(3804),
    [anon_sym_requires] = ACTIONS(3804),
    [sym_this] = ACTIONS(3804),
    [anon_sym_discard] = ACTIONS(3804),
    [anon_sym_precise] = ACTIONS(3804),
    [anon_sym_shared] = ACTIONS(3804),
    [anon_sym_groupshared] = ACTIONS(3804),
    [anon_sym_uniform] = ACTIONS(3804),
    [anon_sym_row_major] = ACTIONS(3804),
    [anon_sym_column_major] = ACTIONS(3804),
    [anon_sym_globallycoherent] = ACTIONS(3804),
    [anon_sym_centroid] = ACTIONS(3804),
    [anon_sym_noperspective] = ACTIONS(3804),
    [anon_sym_nointerpolation] = ACTIONS(3804),
    [anon_sym_sample] = ACTIONS(3804),
    [anon_sym_linear] = ACTIONS(3804),
    [anon_sym_snorm] = ACTIONS(3804),
    [anon_sym_unorm] = ACTIONS(3804),
    [anon_sym_point] = ACTIONS(3804),
    [anon_sym_line] = ACTIONS(3804),
    [anon_sym_triangleadj] = ACTIONS(3804),
    [anon_sym_lineadj] = ACTIONS(3804),
    [anon_sym_triangle] = ACTIONS(3804),
    [anon_sym_cbuffer] = ACTIONS(3804),
    [anon_sym_interface] = ACTIONS(3804),
    [anon_sym_extension] = ACTIONS(3804),
  },
  [1137] = {
    [ts_builtin_sym_end] = ACTIONS(3899),
    [sym_identifier] = ACTIONS(3897),
    [aux_sym_preproc_include_token1] = ACTIONS(3897),
    [aux_sym_preproc_def_token1] = ACTIONS(3897),
    [aux_sym_preproc_if_token1] = ACTIONS(3897),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3897),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3897),
    [sym_preproc_directive] = ACTIONS(3897),
    [anon_sym_LPAREN2] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3899),
    [anon_sym_TILDE] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3897),
    [anon_sym_PLUS] = ACTIONS(3897),
    [anon_sym_STAR] = ACTIONS(3899),
    [anon_sym_AMP_AMP] = ACTIONS(3899),
    [anon_sym_AMP] = ACTIONS(3897),
    [anon_sym_SEMI] = ACTIONS(3899),
    [anon_sym___extension__] = ACTIONS(3897),
    [anon_sym_typedef] = ACTIONS(3897),
    [anon_sym_in] = ACTIONS(3897),
    [anon_sym_out] = ACTIONS(3897),
    [anon_sym_inout] = ACTIONS(3897),
    [anon_sym_virtual] = ACTIONS(3897),
    [anon_sym_extern] = ACTIONS(3897),
    [anon_sym___attribute__] = ACTIONS(3897),
    [anon_sym___attribute] = ACTIONS(3897),
    [anon_sym_using] = ACTIONS(3897),
    [anon_sym_COLON_COLON] = ACTIONS(3899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3899),
    [anon_sym___declspec] = ACTIONS(3897),
    [anon_sym___based] = ACTIONS(3897),
    [anon_sym___cdecl] = ACTIONS(3897),
    [anon_sym___clrcall] = ACTIONS(3897),
    [anon_sym___stdcall] = ACTIONS(3897),
    [anon_sym___fastcall] = ACTIONS(3897),
    [anon_sym___thiscall] = ACTIONS(3897),
    [anon_sym___vectorcall] = ACTIONS(3897),
    [anon_sym_LBRACE] = ACTIONS(3899),
    [anon_sym_signed] = ACTIONS(3897),
    [anon_sym_unsigned] = ACTIONS(3897),
    [anon_sym_long] = ACTIONS(3897),
    [anon_sym_short] = ACTIONS(3897),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_static] = ACTIONS(3897),
    [anon_sym_register] = ACTIONS(3897),
    [anon_sym_inline] = ACTIONS(3897),
    [anon_sym___inline] = ACTIONS(3897),
    [anon_sym___inline__] = ACTIONS(3897),
    [anon_sym___forceinline] = ACTIONS(3897),
    [anon_sym_thread_local] = ACTIONS(3897),
    [anon_sym___thread] = ACTIONS(3897),
    [anon_sym_const] = ACTIONS(3897),
    [anon_sym_constexpr] = ACTIONS(3897),
    [anon_sym_volatile] = ACTIONS(3897),
    [anon_sym_restrict] = ACTIONS(3897),
    [anon_sym___restrict__] = ACTIONS(3897),
    [anon_sym__Atomic] = ACTIONS(3897),
    [anon_sym__Noreturn] = ACTIONS(3897),
    [anon_sym_noreturn] = ACTIONS(3897),
    [anon_sym__Nonnull] = ACTIONS(3897),
    [anon_sym_mutable] = ACTIONS(3897),
    [anon_sym_constinit] = ACTIONS(3897),
    [anon_sym_consteval] = ACTIONS(3897),
    [anon_sym_alignas] = ACTIONS(3897),
    [anon_sym__Alignas] = ACTIONS(3897),
    [sym_primitive_type] = ACTIONS(3897),
    [anon_sym_enum] = ACTIONS(3897),
    [anon_sym_class] = ACTIONS(3897),
    [anon_sym_struct] = ACTIONS(3897),
    [anon_sym_union] = ACTIONS(3897),
    [anon_sym_if] = ACTIONS(3897),
    [anon_sym_switch] = ACTIONS(3897),
    [anon_sym_case] = ACTIONS(3897),
    [anon_sym_default] = ACTIONS(3897),
    [anon_sym_while] = ACTIONS(3897),
    [anon_sym_do] = ACTIONS(3897),
    [anon_sym_for] = ACTIONS(3897),
    [anon_sym_return] = ACTIONS(3897),
    [anon_sym_break] = ACTIONS(3897),
    [anon_sym_continue] = ACTIONS(3897),
    [anon_sym_goto] = ACTIONS(3897),
    [anon_sym_not] = ACTIONS(3897),
    [anon_sym_compl] = ACTIONS(3897),
    [anon_sym_DASH_DASH] = ACTIONS(3899),
    [anon_sym_PLUS_PLUS] = ACTIONS(3899),
    [anon_sym_sizeof] = ACTIONS(3897),
    [anon_sym___alignof__] = ACTIONS(3897),
    [anon_sym___alignof] = ACTIONS(3897),
    [anon_sym__alignof] = ACTIONS(3897),
    [anon_sym_alignof] = ACTIONS(3897),
    [anon_sym__Alignof] = ACTIONS(3897),
    [anon_sym_offsetof] = ACTIONS(3897),
    [anon_sym__Generic] = ACTIONS(3897),
    [anon_sym_asm] = ACTIONS(3897),
    [anon_sym___asm__] = ACTIONS(3897),
    [anon_sym___asm] = ACTIONS(3897),
    [sym_number_literal] = ACTIONS(3899),
    [anon_sym_L_SQUOTE] = ACTIONS(3899),
    [anon_sym_u_SQUOTE] = ACTIONS(3899),
    [anon_sym_U_SQUOTE] = ACTIONS(3899),
    [anon_sym_u8_SQUOTE] = ACTIONS(3899),
    [anon_sym_SQUOTE] = ACTIONS(3899),
    [anon_sym_L_DQUOTE] = ACTIONS(3899),
    [anon_sym_u_DQUOTE] = ACTIONS(3899),
    [anon_sym_U_DQUOTE] = ACTIONS(3899),
    [anon_sym_u8_DQUOTE] = ACTIONS(3899),
    [anon_sym_DQUOTE] = ACTIONS(3899),
    [sym_true] = ACTIONS(3897),
    [sym_false] = ACTIONS(3897),
    [anon_sym_NULL] = ACTIONS(3897),
    [anon_sym_nullptr] = ACTIONS(3897),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3897),
    [anon_sym_let] = ACTIONS(3897),
    [anon_sym_This] = ACTIONS(3897),
    [anon_sym_decltype] = ACTIONS(3897),
    [anon_sym_explicit] = ACTIONS(3897),
    [anon_sym_typename] = ACTIONS(3897),
    [anon_sym_export] = ACTIONS(3897),
    [anon_sym_module] = ACTIONS(3897),
    [anon_sym_import] = ACTIONS(3897),
    [anon_sym_template] = ACTIONS(3897),
    [anon_sym_operator] = ACTIONS(3897),
    [anon_sym_try] = ACTIONS(3897),
    [anon_sym_delete] = ACTIONS(3897),
    [anon_sym_throw] = ACTIONS(3897),
    [anon_sym_namespace] = ACTIONS(3897),
    [anon_sym_static_assert] = ACTIONS(3897),
    [anon_sym_concept] = ACTIONS(3897),
    [anon_sym_co_return] = ACTIONS(3897),
    [anon_sym_co_yield] = ACTIONS(3897),
    [anon_sym_R_DQUOTE] = ACTIONS(3899),
    [anon_sym_LR_DQUOTE] = ACTIONS(3899),
    [anon_sym_uR_DQUOTE] = ACTIONS(3899),
    [anon_sym_UR_DQUOTE] = ACTIONS(3899),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3899),
    [anon_sym_co_await] = ACTIONS(3897),
    [anon_sym_new] = ACTIONS(3897),
    [anon_sym_requires] = ACTIONS(3897),
    [sym_this] = ACTIONS(3897),
    [anon_sym_precise] = ACTIONS(3897),
    [anon_sym_shared] = ACTIONS(3897),
    [anon_sym_groupshared] = ACTIONS(3897),
    [anon_sym_uniform] = ACTIONS(3897),
    [anon_sym_row_major] = ACTIONS(3897),
    [anon_sym_column_major] = ACTIONS(3897),
    [anon_sym_globallycoherent] = ACTIONS(3897),
    [anon_sym_centroid] = ACTIONS(3897),
    [anon_sym_noperspective] = ACTIONS(3897),
    [anon_sym_nointerpolation] = ACTIONS(3897),
    [anon_sym_sample] = ACTIONS(3897),
    [anon_sym_linear] = ACTIONS(3897),
    [anon_sym_snorm] = ACTIONS(3897),
    [anon_sym_unorm] = ACTIONS(3897),
    [anon_sym_point] = ACTIONS(3897),
    [anon_sym_line] = ACTIONS(3897),
    [anon_sym_triangleadj] = ACTIONS(3897),
    [anon_sym_lineadj] = ACTIONS(3897),
    [anon_sym_triangle] = ACTIONS(3897),
    [anon_sym_interface] = ACTIONS(3897),
    [anon_sym_extension] = ACTIONS(3897),
    [anon_sym___exported] = ACTIONS(3897),
  },
  [1138] = {
    [sym_identifier] = ACTIONS(3767),
    [aux_sym_preproc_include_token1] = ACTIONS(3767),
    [aux_sym_preproc_def_token1] = ACTIONS(3767),
    [aux_sym_preproc_if_token1] = ACTIONS(3767),
    [aux_sym_preproc_if_token2] = ACTIONS(3767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3767),
    [sym_preproc_directive] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3769),
    [anon_sym_BANG] = ACTIONS(3769),
    [anon_sym_TILDE] = ACTIONS(3769),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_AMP_AMP] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_SEMI] = ACTIONS(3769),
    [anon_sym___extension__] = ACTIONS(3767),
    [anon_sym_typedef] = ACTIONS(3767),
    [anon_sym_in] = ACTIONS(3767),
    [anon_sym_out] = ACTIONS(3767),
    [anon_sym_inout] = ACTIONS(3767),
    [anon_sym_virtual] = ACTIONS(3767),
    [anon_sym_extern] = ACTIONS(3767),
    [anon_sym___attribute__] = ACTIONS(3767),
    [anon_sym___attribute] = ACTIONS(3767),
    [anon_sym_using] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3769),
    [anon_sym___declspec] = ACTIONS(3767),
    [anon_sym___based] = ACTIONS(3767),
    [anon_sym___cdecl] = ACTIONS(3767),
    [anon_sym___clrcall] = ACTIONS(3767),
    [anon_sym___stdcall] = ACTIONS(3767),
    [anon_sym___fastcall] = ACTIONS(3767),
    [anon_sym___thiscall] = ACTIONS(3767),
    [anon_sym___vectorcall] = ACTIONS(3767),
    [anon_sym_LBRACE] = ACTIONS(3769),
    [anon_sym_signed] = ACTIONS(3767),
    [anon_sym_unsigned] = ACTIONS(3767),
    [anon_sym_long] = ACTIONS(3767),
    [anon_sym_short] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_static] = ACTIONS(3767),
    [anon_sym_register] = ACTIONS(3767),
    [anon_sym_inline] = ACTIONS(3767),
    [anon_sym___inline] = ACTIONS(3767),
    [anon_sym___inline__] = ACTIONS(3767),
    [anon_sym___forceinline] = ACTIONS(3767),
    [anon_sym_thread_local] = ACTIONS(3767),
    [anon_sym___thread] = ACTIONS(3767),
    [anon_sym_const] = ACTIONS(3767),
    [anon_sym_constexpr] = ACTIONS(3767),
    [anon_sym_volatile] = ACTIONS(3767),
    [anon_sym_restrict] = ACTIONS(3767),
    [anon_sym___restrict__] = ACTIONS(3767),
    [anon_sym__Atomic] = ACTIONS(3767),
    [anon_sym__Noreturn] = ACTIONS(3767),
    [anon_sym_noreturn] = ACTIONS(3767),
    [anon_sym__Nonnull] = ACTIONS(3767),
    [anon_sym_mutable] = ACTIONS(3767),
    [anon_sym_constinit] = ACTIONS(3767),
    [anon_sym_consteval] = ACTIONS(3767),
    [anon_sym_alignas] = ACTIONS(3767),
    [anon_sym__Alignas] = ACTIONS(3767),
    [sym_primitive_type] = ACTIONS(3767),
    [anon_sym_enum] = ACTIONS(3767),
    [anon_sym_class] = ACTIONS(3767),
    [anon_sym_struct] = ACTIONS(3767),
    [anon_sym_union] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_switch] = ACTIONS(3767),
    [anon_sym_case] = ACTIONS(3767),
    [anon_sym_default] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_break] = ACTIONS(3767),
    [anon_sym_continue] = ACTIONS(3767),
    [anon_sym_goto] = ACTIONS(3767),
    [anon_sym___try] = ACTIONS(3767),
    [anon_sym___leave] = ACTIONS(3767),
    [anon_sym_not] = ACTIONS(3767),
    [anon_sym_compl] = ACTIONS(3767),
    [anon_sym_DASH_DASH] = ACTIONS(3769),
    [anon_sym_PLUS_PLUS] = ACTIONS(3769),
    [anon_sym_sizeof] = ACTIONS(3767),
    [anon_sym___alignof__] = ACTIONS(3767),
    [anon_sym___alignof] = ACTIONS(3767),
    [anon_sym__alignof] = ACTIONS(3767),
    [anon_sym_alignof] = ACTIONS(3767),
    [anon_sym__Alignof] = ACTIONS(3767),
    [anon_sym_offsetof] = ACTIONS(3767),
    [anon_sym__Generic] = ACTIONS(3767),
    [anon_sym_asm] = ACTIONS(3767),
    [anon_sym___asm__] = ACTIONS(3767),
    [anon_sym___asm] = ACTIONS(3767),
    [sym_number_literal] = ACTIONS(3769),
    [anon_sym_L_SQUOTE] = ACTIONS(3769),
    [anon_sym_u_SQUOTE] = ACTIONS(3769),
    [anon_sym_U_SQUOTE] = ACTIONS(3769),
    [anon_sym_u8_SQUOTE] = ACTIONS(3769),
    [anon_sym_SQUOTE] = ACTIONS(3769),
    [anon_sym_L_DQUOTE] = ACTIONS(3769),
    [anon_sym_u_DQUOTE] = ACTIONS(3769),
    [anon_sym_U_DQUOTE] = ACTIONS(3769),
    [anon_sym_u8_DQUOTE] = ACTIONS(3769),
    [anon_sym_DQUOTE] = ACTIONS(3769),
    [sym_true] = ACTIONS(3767),
    [sym_false] = ACTIONS(3767),
    [anon_sym_NULL] = ACTIONS(3767),
    [anon_sym_nullptr] = ACTIONS(3767),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_This] = ACTIONS(3767),
    [anon_sym_decltype] = ACTIONS(3767),
    [anon_sym_explicit] = ACTIONS(3767),
    [anon_sym_typename] = ACTIONS(3767),
    [anon_sym_template] = ACTIONS(3767),
    [anon_sym_operator] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_delete] = ACTIONS(3767),
    [anon_sym_throw] = ACTIONS(3767),
    [anon_sym_namespace] = ACTIONS(3767),
    [anon_sym_static_assert] = ACTIONS(3767),
    [anon_sym_concept] = ACTIONS(3767),
    [anon_sym_co_return] = ACTIONS(3767),
    [anon_sym_co_yield] = ACTIONS(3767),
    [anon_sym_R_DQUOTE] = ACTIONS(3769),
    [anon_sym_LR_DQUOTE] = ACTIONS(3769),
    [anon_sym_uR_DQUOTE] = ACTIONS(3769),
    [anon_sym_UR_DQUOTE] = ACTIONS(3769),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3769),
    [anon_sym_co_await] = ACTIONS(3767),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_requires] = ACTIONS(3767),
    [sym_this] = ACTIONS(3767),
    [anon_sym_discard] = ACTIONS(3767),
    [anon_sym_precise] = ACTIONS(3767),
    [anon_sym_shared] = ACTIONS(3767),
    [anon_sym_groupshared] = ACTIONS(3767),
    [anon_sym_uniform] = ACTIONS(3767),
    [anon_sym_row_major] = ACTIONS(3767),
    [anon_sym_column_major] = ACTIONS(3767),
    [anon_sym_globallycoherent] = ACTIONS(3767),
    [anon_sym_centroid] = ACTIONS(3767),
    [anon_sym_noperspective] = ACTIONS(3767),
    [anon_sym_nointerpolation] = ACTIONS(3767),
    [anon_sym_sample] = ACTIONS(3767),
    [anon_sym_linear] = ACTIONS(3767),
    [anon_sym_snorm] = ACTIONS(3767),
    [anon_sym_unorm] = ACTIONS(3767),
    [anon_sym_point] = ACTIONS(3767),
    [anon_sym_line] = ACTIONS(3767),
    [anon_sym_triangleadj] = ACTIONS(3767),
    [anon_sym_lineadj] = ACTIONS(3767),
    [anon_sym_triangle] = ACTIONS(3767),
    [anon_sym_cbuffer] = ACTIONS(3767),
    [anon_sym_interface] = ACTIONS(3767),
    [anon_sym_extension] = ACTIONS(3767),
  },
  [1139] = {
    [sym_identifier] = ACTIONS(3885),
    [aux_sym_preproc_include_token1] = ACTIONS(3885),
    [aux_sym_preproc_def_token1] = ACTIONS(3885),
    [aux_sym_preproc_if_token1] = ACTIONS(3885),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3885),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3885),
    [sym_preproc_directive] = ACTIONS(3885),
    [anon_sym_LPAREN2] = ACTIONS(3887),
    [anon_sym_BANG] = ACTIONS(3887),
    [anon_sym_TILDE] = ACTIONS(3887),
    [anon_sym_DASH] = ACTIONS(3885),
    [anon_sym_PLUS] = ACTIONS(3885),
    [anon_sym_STAR] = ACTIONS(3887),
    [anon_sym_AMP_AMP] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3885),
    [anon_sym_SEMI] = ACTIONS(3887),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_typedef] = ACTIONS(3885),
    [anon_sym_in] = ACTIONS(3885),
    [anon_sym_out] = ACTIONS(3885),
    [anon_sym_inout] = ACTIONS(3885),
    [anon_sym_virtual] = ACTIONS(3885),
    [anon_sym_extern] = ACTIONS(3885),
    [anon_sym___attribute__] = ACTIONS(3885),
    [anon_sym___attribute] = ACTIONS(3885),
    [anon_sym_using] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3887),
    [anon_sym___declspec] = ACTIONS(3885),
    [anon_sym___based] = ACTIONS(3885),
    [anon_sym___cdecl] = ACTIONS(3885),
    [anon_sym___clrcall] = ACTIONS(3885),
    [anon_sym___stdcall] = ACTIONS(3885),
    [anon_sym___fastcall] = ACTIONS(3885),
    [anon_sym___thiscall] = ACTIONS(3885),
    [anon_sym___vectorcall] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_RBRACE] = ACTIONS(3887),
    [anon_sym_signed] = ACTIONS(3885),
    [anon_sym_unsigned] = ACTIONS(3885),
    [anon_sym_long] = ACTIONS(3885),
    [anon_sym_short] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_static] = ACTIONS(3885),
    [anon_sym_register] = ACTIONS(3885),
    [anon_sym_inline] = ACTIONS(3885),
    [anon_sym___inline] = ACTIONS(3885),
    [anon_sym___inline__] = ACTIONS(3885),
    [anon_sym___forceinline] = ACTIONS(3885),
    [anon_sym_thread_local] = ACTIONS(3885),
    [anon_sym___thread] = ACTIONS(3885),
    [anon_sym_const] = ACTIONS(3885),
    [anon_sym_constexpr] = ACTIONS(3885),
    [anon_sym_volatile] = ACTIONS(3885),
    [anon_sym_restrict] = ACTIONS(3885),
    [anon_sym___restrict__] = ACTIONS(3885),
    [anon_sym__Atomic] = ACTIONS(3885),
    [anon_sym__Noreturn] = ACTIONS(3885),
    [anon_sym_noreturn] = ACTIONS(3885),
    [anon_sym__Nonnull] = ACTIONS(3885),
    [anon_sym_mutable] = ACTIONS(3885),
    [anon_sym_constinit] = ACTIONS(3885),
    [anon_sym_consteval] = ACTIONS(3885),
    [anon_sym_alignas] = ACTIONS(3885),
    [anon_sym__Alignas] = ACTIONS(3885),
    [sym_primitive_type] = ACTIONS(3885),
    [anon_sym_enum] = ACTIONS(3885),
    [anon_sym_class] = ACTIONS(3885),
    [anon_sym_struct] = ACTIONS(3885),
    [anon_sym_union] = ACTIONS(3885),
    [anon_sym_if] = ACTIONS(3885),
    [anon_sym_switch] = ACTIONS(3885),
    [anon_sym_case] = ACTIONS(3885),
    [anon_sym_default] = ACTIONS(3885),
    [anon_sym_while] = ACTIONS(3885),
    [anon_sym_do] = ACTIONS(3885),
    [anon_sym_for] = ACTIONS(3885),
    [anon_sym_return] = ACTIONS(3885),
    [anon_sym_break] = ACTIONS(3885),
    [anon_sym_continue] = ACTIONS(3885),
    [anon_sym_goto] = ACTIONS(3885),
    [anon_sym___try] = ACTIONS(3885),
    [anon_sym___leave] = ACTIONS(3885),
    [anon_sym_not] = ACTIONS(3885),
    [anon_sym_compl] = ACTIONS(3885),
    [anon_sym_DASH_DASH] = ACTIONS(3887),
    [anon_sym_PLUS_PLUS] = ACTIONS(3887),
    [anon_sym_sizeof] = ACTIONS(3885),
    [anon_sym___alignof__] = ACTIONS(3885),
    [anon_sym___alignof] = ACTIONS(3885),
    [anon_sym__alignof] = ACTIONS(3885),
    [anon_sym_alignof] = ACTIONS(3885),
    [anon_sym__Alignof] = ACTIONS(3885),
    [anon_sym_offsetof] = ACTIONS(3885),
    [anon_sym__Generic] = ACTIONS(3885),
    [anon_sym_asm] = ACTIONS(3885),
    [anon_sym___asm__] = ACTIONS(3885),
    [anon_sym___asm] = ACTIONS(3885),
    [sym_number_literal] = ACTIONS(3887),
    [anon_sym_L_SQUOTE] = ACTIONS(3887),
    [anon_sym_u_SQUOTE] = ACTIONS(3887),
    [anon_sym_U_SQUOTE] = ACTIONS(3887),
    [anon_sym_u8_SQUOTE] = ACTIONS(3887),
    [anon_sym_SQUOTE] = ACTIONS(3887),
    [anon_sym_L_DQUOTE] = ACTIONS(3887),
    [anon_sym_u_DQUOTE] = ACTIONS(3887),
    [anon_sym_U_DQUOTE] = ACTIONS(3887),
    [anon_sym_u8_DQUOTE] = ACTIONS(3887),
    [anon_sym_DQUOTE] = ACTIONS(3887),
    [sym_true] = ACTIONS(3885),
    [sym_false] = ACTIONS(3885),
    [anon_sym_NULL] = ACTIONS(3885),
    [anon_sym_nullptr] = ACTIONS(3885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3885),
    [anon_sym_let] = ACTIONS(3885),
    [anon_sym_This] = ACTIONS(3885),
    [anon_sym_decltype] = ACTIONS(3885),
    [anon_sym_explicit] = ACTIONS(3885),
    [anon_sym_typename] = ACTIONS(3885),
    [anon_sym_template] = ACTIONS(3885),
    [anon_sym_operator] = ACTIONS(3885),
    [anon_sym_try] = ACTIONS(3885),
    [anon_sym_delete] = ACTIONS(3885),
    [anon_sym_throw] = ACTIONS(3885),
    [anon_sym_namespace] = ACTIONS(3885),
    [anon_sym_static_assert] = ACTIONS(3885),
    [anon_sym_concept] = ACTIONS(3885),
    [anon_sym_co_return] = ACTIONS(3885),
    [anon_sym_co_yield] = ACTIONS(3885),
    [anon_sym_R_DQUOTE] = ACTIONS(3887),
    [anon_sym_LR_DQUOTE] = ACTIONS(3887),
    [anon_sym_uR_DQUOTE] = ACTIONS(3887),
    [anon_sym_UR_DQUOTE] = ACTIONS(3887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3887),
    [anon_sym_co_await] = ACTIONS(3885),
    [anon_sym_new] = ACTIONS(3885),
    [anon_sym_requires] = ACTIONS(3885),
    [sym_this] = ACTIONS(3885),
    [anon_sym_discard] = ACTIONS(3885),
    [anon_sym_precise] = ACTIONS(3885),
    [anon_sym_shared] = ACTIONS(3885),
    [anon_sym_groupshared] = ACTIONS(3885),
    [anon_sym_uniform] = ACTIONS(3885),
    [anon_sym_row_major] = ACTIONS(3885),
    [anon_sym_column_major] = ACTIONS(3885),
    [anon_sym_globallycoherent] = ACTIONS(3885),
    [anon_sym_centroid] = ACTIONS(3885),
    [anon_sym_noperspective] = ACTIONS(3885),
    [anon_sym_nointerpolation] = ACTIONS(3885),
    [anon_sym_sample] = ACTIONS(3885),
    [anon_sym_linear] = ACTIONS(3885),
    [anon_sym_snorm] = ACTIONS(3885),
    [anon_sym_unorm] = ACTIONS(3885),
    [anon_sym_point] = ACTIONS(3885),
    [anon_sym_line] = ACTIONS(3885),
    [anon_sym_triangleadj] = ACTIONS(3885),
    [anon_sym_lineadj] = ACTIONS(3885),
    [anon_sym_triangle] = ACTIONS(3885),
    [anon_sym_cbuffer] = ACTIONS(3885),
    [anon_sym_interface] = ACTIONS(3885),
    [anon_sym_extension] = ACTIONS(3885),
  },
  [1140] = {
    [sym_identifier] = ACTIONS(3788),
    [aux_sym_preproc_include_token1] = ACTIONS(3788),
    [aux_sym_preproc_def_token1] = ACTIONS(3788),
    [aux_sym_preproc_if_token1] = ACTIONS(3788),
    [aux_sym_preproc_if_token2] = ACTIONS(3788),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3788),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3788),
    [sym_preproc_directive] = ACTIONS(3788),
    [anon_sym_LPAREN2] = ACTIONS(3790),
    [anon_sym_BANG] = ACTIONS(3790),
    [anon_sym_TILDE] = ACTIONS(3790),
    [anon_sym_DASH] = ACTIONS(3788),
    [anon_sym_PLUS] = ACTIONS(3788),
    [anon_sym_STAR] = ACTIONS(3790),
    [anon_sym_AMP_AMP] = ACTIONS(3790),
    [anon_sym_AMP] = ACTIONS(3788),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym___extension__] = ACTIONS(3788),
    [anon_sym_typedef] = ACTIONS(3788),
    [anon_sym_in] = ACTIONS(3788),
    [anon_sym_out] = ACTIONS(3788),
    [anon_sym_inout] = ACTIONS(3788),
    [anon_sym_virtual] = ACTIONS(3788),
    [anon_sym_extern] = ACTIONS(3788),
    [anon_sym___attribute__] = ACTIONS(3788),
    [anon_sym___attribute] = ACTIONS(3788),
    [anon_sym_using] = ACTIONS(3788),
    [anon_sym_COLON_COLON] = ACTIONS(3790),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3790),
    [anon_sym___declspec] = ACTIONS(3788),
    [anon_sym___based] = ACTIONS(3788),
    [anon_sym___cdecl] = ACTIONS(3788),
    [anon_sym___clrcall] = ACTIONS(3788),
    [anon_sym___stdcall] = ACTIONS(3788),
    [anon_sym___fastcall] = ACTIONS(3788),
    [anon_sym___thiscall] = ACTIONS(3788),
    [anon_sym___vectorcall] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_signed] = ACTIONS(3788),
    [anon_sym_unsigned] = ACTIONS(3788),
    [anon_sym_long] = ACTIONS(3788),
    [anon_sym_short] = ACTIONS(3788),
    [anon_sym_LBRACK] = ACTIONS(3788),
    [anon_sym_static] = ACTIONS(3788),
    [anon_sym_register] = ACTIONS(3788),
    [anon_sym_inline] = ACTIONS(3788),
    [anon_sym___inline] = ACTIONS(3788),
    [anon_sym___inline__] = ACTIONS(3788),
    [anon_sym___forceinline] = ACTIONS(3788),
    [anon_sym_thread_local] = ACTIONS(3788),
    [anon_sym___thread] = ACTIONS(3788),
    [anon_sym_const] = ACTIONS(3788),
    [anon_sym_constexpr] = ACTIONS(3788),
    [anon_sym_volatile] = ACTIONS(3788),
    [anon_sym_restrict] = ACTIONS(3788),
    [anon_sym___restrict__] = ACTIONS(3788),
    [anon_sym__Atomic] = ACTIONS(3788),
    [anon_sym__Noreturn] = ACTIONS(3788),
    [anon_sym_noreturn] = ACTIONS(3788),
    [anon_sym__Nonnull] = ACTIONS(3788),
    [anon_sym_mutable] = ACTIONS(3788),
    [anon_sym_constinit] = ACTIONS(3788),
    [anon_sym_consteval] = ACTIONS(3788),
    [anon_sym_alignas] = ACTIONS(3788),
    [anon_sym__Alignas] = ACTIONS(3788),
    [sym_primitive_type] = ACTIONS(3788),
    [anon_sym_enum] = ACTIONS(3788),
    [anon_sym_class] = ACTIONS(3788),
    [anon_sym_struct] = ACTIONS(3788),
    [anon_sym_union] = ACTIONS(3788),
    [anon_sym_if] = ACTIONS(3788),
    [anon_sym_switch] = ACTIONS(3788),
    [anon_sym_case] = ACTIONS(3788),
    [anon_sym_default] = ACTIONS(3788),
    [anon_sym_while] = ACTIONS(3788),
    [anon_sym_do] = ACTIONS(3788),
    [anon_sym_for] = ACTIONS(3788),
    [anon_sym_return] = ACTIONS(3788),
    [anon_sym_break] = ACTIONS(3788),
    [anon_sym_continue] = ACTIONS(3788),
    [anon_sym_goto] = ACTIONS(3788),
    [anon_sym___try] = ACTIONS(3788),
    [anon_sym___leave] = ACTIONS(3788),
    [anon_sym_not] = ACTIONS(3788),
    [anon_sym_compl] = ACTIONS(3788),
    [anon_sym_DASH_DASH] = ACTIONS(3790),
    [anon_sym_PLUS_PLUS] = ACTIONS(3790),
    [anon_sym_sizeof] = ACTIONS(3788),
    [anon_sym___alignof__] = ACTIONS(3788),
    [anon_sym___alignof] = ACTIONS(3788),
    [anon_sym__alignof] = ACTIONS(3788),
    [anon_sym_alignof] = ACTIONS(3788),
    [anon_sym__Alignof] = ACTIONS(3788),
    [anon_sym_offsetof] = ACTIONS(3788),
    [anon_sym__Generic] = ACTIONS(3788),
    [anon_sym_asm] = ACTIONS(3788),
    [anon_sym___asm__] = ACTIONS(3788),
    [anon_sym___asm] = ACTIONS(3788),
    [sym_number_literal] = ACTIONS(3790),
    [anon_sym_L_SQUOTE] = ACTIONS(3790),
    [anon_sym_u_SQUOTE] = ACTIONS(3790),
    [anon_sym_U_SQUOTE] = ACTIONS(3790),
    [anon_sym_u8_SQUOTE] = ACTIONS(3790),
    [anon_sym_SQUOTE] = ACTIONS(3790),
    [anon_sym_L_DQUOTE] = ACTIONS(3790),
    [anon_sym_u_DQUOTE] = ACTIONS(3790),
    [anon_sym_U_DQUOTE] = ACTIONS(3790),
    [anon_sym_u8_DQUOTE] = ACTIONS(3790),
    [anon_sym_DQUOTE] = ACTIONS(3790),
    [sym_true] = ACTIONS(3788),
    [sym_false] = ACTIONS(3788),
    [anon_sym_NULL] = ACTIONS(3788),
    [anon_sym_nullptr] = ACTIONS(3788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3788),
    [anon_sym_let] = ACTIONS(3788),
    [anon_sym_This] = ACTIONS(3788),
    [anon_sym_decltype] = ACTIONS(3788),
    [anon_sym_explicit] = ACTIONS(3788),
    [anon_sym_typename] = ACTIONS(3788),
    [anon_sym_template] = ACTIONS(3788),
    [anon_sym_operator] = ACTIONS(3788),
    [anon_sym_try] = ACTIONS(3788),
    [anon_sym_delete] = ACTIONS(3788),
    [anon_sym_throw] = ACTIONS(3788),
    [anon_sym_namespace] = ACTIONS(3788),
    [anon_sym_static_assert] = ACTIONS(3788),
    [anon_sym_concept] = ACTIONS(3788),
    [anon_sym_co_return] = ACTIONS(3788),
    [anon_sym_co_yield] = ACTIONS(3788),
    [anon_sym_R_DQUOTE] = ACTIONS(3790),
    [anon_sym_LR_DQUOTE] = ACTIONS(3790),
    [anon_sym_uR_DQUOTE] = ACTIONS(3790),
    [anon_sym_UR_DQUOTE] = ACTIONS(3790),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3790),
    [anon_sym_co_await] = ACTIONS(3788),
    [anon_sym_new] = ACTIONS(3788),
    [anon_sym_requires] = ACTIONS(3788),
    [sym_this] = ACTIONS(3788),
    [anon_sym_discard] = ACTIONS(3788),
    [anon_sym_precise] = ACTIONS(3788),
    [anon_sym_shared] = ACTIONS(3788),
    [anon_sym_groupshared] = ACTIONS(3788),
    [anon_sym_uniform] = ACTIONS(3788),
    [anon_sym_row_major] = ACTIONS(3788),
    [anon_sym_column_major] = ACTIONS(3788),
    [anon_sym_globallycoherent] = ACTIONS(3788),
    [anon_sym_centroid] = ACTIONS(3788),
    [anon_sym_noperspective] = ACTIONS(3788),
    [anon_sym_nointerpolation] = ACTIONS(3788),
    [anon_sym_sample] = ACTIONS(3788),
    [anon_sym_linear] = ACTIONS(3788),
    [anon_sym_snorm] = ACTIONS(3788),
    [anon_sym_unorm] = ACTIONS(3788),
    [anon_sym_point] = ACTIONS(3788),
    [anon_sym_line] = ACTIONS(3788),
    [anon_sym_triangleadj] = ACTIONS(3788),
    [anon_sym_lineadj] = ACTIONS(3788),
    [anon_sym_triangle] = ACTIONS(3788),
    [anon_sym_cbuffer] = ACTIONS(3788),
    [anon_sym_interface] = ACTIONS(3788),
    [anon_sym_extension] = ACTIONS(3788),
  },
  [1141] = {
    [sym_identifier] = ACTIONS(3792),
    [aux_sym_preproc_include_token1] = ACTIONS(3792),
    [aux_sym_preproc_def_token1] = ACTIONS(3792),
    [aux_sym_preproc_if_token1] = ACTIONS(3792),
    [aux_sym_preproc_if_token2] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3792),
    [sym_preproc_directive] = ACTIONS(3792),
    [anon_sym_LPAREN2] = ACTIONS(3794),
    [anon_sym_BANG] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3794),
    [anon_sym_DASH] = ACTIONS(3792),
    [anon_sym_PLUS] = ACTIONS(3792),
    [anon_sym_STAR] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_AMP] = ACTIONS(3792),
    [anon_sym_SEMI] = ACTIONS(3794),
    [anon_sym___extension__] = ACTIONS(3792),
    [anon_sym_typedef] = ACTIONS(3792),
    [anon_sym_in] = ACTIONS(3792),
    [anon_sym_out] = ACTIONS(3792),
    [anon_sym_inout] = ACTIONS(3792),
    [anon_sym_virtual] = ACTIONS(3792),
    [anon_sym_extern] = ACTIONS(3792),
    [anon_sym___attribute__] = ACTIONS(3792),
    [anon_sym___attribute] = ACTIONS(3792),
    [anon_sym_using] = ACTIONS(3792),
    [anon_sym_COLON_COLON] = ACTIONS(3794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3794),
    [anon_sym___declspec] = ACTIONS(3792),
    [anon_sym___based] = ACTIONS(3792),
    [anon_sym___cdecl] = ACTIONS(3792),
    [anon_sym___clrcall] = ACTIONS(3792),
    [anon_sym___stdcall] = ACTIONS(3792),
    [anon_sym___fastcall] = ACTIONS(3792),
    [anon_sym___thiscall] = ACTIONS(3792),
    [anon_sym___vectorcall] = ACTIONS(3792),
    [anon_sym_LBRACE] = ACTIONS(3794),
    [anon_sym_signed] = ACTIONS(3792),
    [anon_sym_unsigned] = ACTIONS(3792),
    [anon_sym_long] = ACTIONS(3792),
    [anon_sym_short] = ACTIONS(3792),
    [anon_sym_LBRACK] = ACTIONS(3792),
    [anon_sym_static] = ACTIONS(3792),
    [anon_sym_register] = ACTIONS(3792),
    [anon_sym_inline] = ACTIONS(3792),
    [anon_sym___inline] = ACTIONS(3792),
    [anon_sym___inline__] = ACTIONS(3792),
    [anon_sym___forceinline] = ACTIONS(3792),
    [anon_sym_thread_local] = ACTIONS(3792),
    [anon_sym___thread] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3792),
    [anon_sym_constexpr] = ACTIONS(3792),
    [anon_sym_volatile] = ACTIONS(3792),
    [anon_sym_restrict] = ACTIONS(3792),
    [anon_sym___restrict__] = ACTIONS(3792),
    [anon_sym__Atomic] = ACTIONS(3792),
    [anon_sym__Noreturn] = ACTIONS(3792),
    [anon_sym_noreturn] = ACTIONS(3792),
    [anon_sym__Nonnull] = ACTIONS(3792),
    [anon_sym_mutable] = ACTIONS(3792),
    [anon_sym_constinit] = ACTIONS(3792),
    [anon_sym_consteval] = ACTIONS(3792),
    [anon_sym_alignas] = ACTIONS(3792),
    [anon_sym__Alignas] = ACTIONS(3792),
    [sym_primitive_type] = ACTIONS(3792),
    [anon_sym_enum] = ACTIONS(3792),
    [anon_sym_class] = ACTIONS(3792),
    [anon_sym_struct] = ACTIONS(3792),
    [anon_sym_union] = ACTIONS(3792),
    [anon_sym_if] = ACTIONS(3792),
    [anon_sym_switch] = ACTIONS(3792),
    [anon_sym_case] = ACTIONS(3792),
    [anon_sym_default] = ACTIONS(3792),
    [anon_sym_while] = ACTIONS(3792),
    [anon_sym_do] = ACTIONS(3792),
    [anon_sym_for] = ACTIONS(3792),
    [anon_sym_return] = ACTIONS(3792),
    [anon_sym_break] = ACTIONS(3792),
    [anon_sym_continue] = ACTIONS(3792),
    [anon_sym_goto] = ACTIONS(3792),
    [anon_sym___try] = ACTIONS(3792),
    [anon_sym___leave] = ACTIONS(3792),
    [anon_sym_not] = ACTIONS(3792),
    [anon_sym_compl] = ACTIONS(3792),
    [anon_sym_DASH_DASH] = ACTIONS(3794),
    [anon_sym_PLUS_PLUS] = ACTIONS(3794),
    [anon_sym_sizeof] = ACTIONS(3792),
    [anon_sym___alignof__] = ACTIONS(3792),
    [anon_sym___alignof] = ACTIONS(3792),
    [anon_sym__alignof] = ACTIONS(3792),
    [anon_sym_alignof] = ACTIONS(3792),
    [anon_sym__Alignof] = ACTIONS(3792),
    [anon_sym_offsetof] = ACTIONS(3792),
    [anon_sym__Generic] = ACTIONS(3792),
    [anon_sym_asm] = ACTIONS(3792),
    [anon_sym___asm__] = ACTIONS(3792),
    [anon_sym___asm] = ACTIONS(3792),
    [sym_number_literal] = ACTIONS(3794),
    [anon_sym_L_SQUOTE] = ACTIONS(3794),
    [anon_sym_u_SQUOTE] = ACTIONS(3794),
    [anon_sym_U_SQUOTE] = ACTIONS(3794),
    [anon_sym_u8_SQUOTE] = ACTIONS(3794),
    [anon_sym_SQUOTE] = ACTIONS(3794),
    [anon_sym_L_DQUOTE] = ACTIONS(3794),
    [anon_sym_u_DQUOTE] = ACTIONS(3794),
    [anon_sym_U_DQUOTE] = ACTIONS(3794),
    [anon_sym_u8_DQUOTE] = ACTIONS(3794),
    [anon_sym_DQUOTE] = ACTIONS(3794),
    [sym_true] = ACTIONS(3792),
    [sym_false] = ACTIONS(3792),
    [anon_sym_NULL] = ACTIONS(3792),
    [anon_sym_nullptr] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3792),
    [anon_sym_let] = ACTIONS(3792),
    [anon_sym_This] = ACTIONS(3792),
    [anon_sym_decltype] = ACTIONS(3792),
    [anon_sym_explicit] = ACTIONS(3792),
    [anon_sym_typename] = ACTIONS(3792),
    [anon_sym_template] = ACTIONS(3792),
    [anon_sym_operator] = ACTIONS(3792),
    [anon_sym_try] = ACTIONS(3792),
    [anon_sym_delete] = ACTIONS(3792),
    [anon_sym_throw] = ACTIONS(3792),
    [anon_sym_namespace] = ACTIONS(3792),
    [anon_sym_static_assert] = ACTIONS(3792),
    [anon_sym_concept] = ACTIONS(3792),
    [anon_sym_co_return] = ACTIONS(3792),
    [anon_sym_co_yield] = ACTIONS(3792),
    [anon_sym_R_DQUOTE] = ACTIONS(3794),
    [anon_sym_LR_DQUOTE] = ACTIONS(3794),
    [anon_sym_uR_DQUOTE] = ACTIONS(3794),
    [anon_sym_UR_DQUOTE] = ACTIONS(3794),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3794),
    [anon_sym_co_await] = ACTIONS(3792),
    [anon_sym_new] = ACTIONS(3792),
    [anon_sym_requires] = ACTIONS(3792),
    [sym_this] = ACTIONS(3792),
    [anon_sym_discard] = ACTIONS(3792),
    [anon_sym_precise] = ACTIONS(3792),
    [anon_sym_shared] = ACTIONS(3792),
    [anon_sym_groupshared] = ACTIONS(3792),
    [anon_sym_uniform] = ACTIONS(3792),
    [anon_sym_row_major] = ACTIONS(3792),
    [anon_sym_column_major] = ACTIONS(3792),
    [anon_sym_globallycoherent] = ACTIONS(3792),
    [anon_sym_centroid] = ACTIONS(3792),
    [anon_sym_noperspective] = ACTIONS(3792),
    [anon_sym_nointerpolation] = ACTIONS(3792),
    [anon_sym_sample] = ACTIONS(3792),
    [anon_sym_linear] = ACTIONS(3792),
    [anon_sym_snorm] = ACTIONS(3792),
    [anon_sym_unorm] = ACTIONS(3792),
    [anon_sym_point] = ACTIONS(3792),
    [anon_sym_line] = ACTIONS(3792),
    [anon_sym_triangleadj] = ACTIONS(3792),
    [anon_sym_lineadj] = ACTIONS(3792),
    [anon_sym_triangle] = ACTIONS(3792),
    [anon_sym_cbuffer] = ACTIONS(3792),
    [anon_sym_interface] = ACTIONS(3792),
    [anon_sym_extension] = ACTIONS(3792),
  },
  [1142] = {
    [sym_identifier] = ACTIONS(3673),
    [aux_sym_preproc_include_token1] = ACTIONS(3673),
    [aux_sym_preproc_def_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token2] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3673),
    [sym_preproc_directive] = ACTIONS(3673),
    [anon_sym_LPAREN2] = ACTIONS(3675),
    [anon_sym_BANG] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3673),
    [anon_sym_PLUS] = ACTIONS(3673),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3673),
    [anon_sym_SEMI] = ACTIONS(3675),
    [anon_sym___extension__] = ACTIONS(3673),
    [anon_sym_typedef] = ACTIONS(3673),
    [anon_sym_in] = ACTIONS(3673),
    [anon_sym_out] = ACTIONS(3673),
    [anon_sym_inout] = ACTIONS(3673),
    [anon_sym_virtual] = ACTIONS(3673),
    [anon_sym_extern] = ACTIONS(3673),
    [anon_sym___attribute__] = ACTIONS(3673),
    [anon_sym___attribute] = ACTIONS(3673),
    [anon_sym_using] = ACTIONS(3673),
    [anon_sym_COLON_COLON] = ACTIONS(3675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3675),
    [anon_sym___declspec] = ACTIONS(3673),
    [anon_sym___based] = ACTIONS(3673),
    [anon_sym___cdecl] = ACTIONS(3673),
    [anon_sym___clrcall] = ACTIONS(3673),
    [anon_sym___stdcall] = ACTIONS(3673),
    [anon_sym___fastcall] = ACTIONS(3673),
    [anon_sym___thiscall] = ACTIONS(3673),
    [anon_sym___vectorcall] = ACTIONS(3673),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_signed] = ACTIONS(3673),
    [anon_sym_unsigned] = ACTIONS(3673),
    [anon_sym_long] = ACTIONS(3673),
    [anon_sym_short] = ACTIONS(3673),
    [anon_sym_LBRACK] = ACTIONS(3673),
    [anon_sym_static] = ACTIONS(3673),
    [anon_sym_register] = ACTIONS(3673),
    [anon_sym_inline] = ACTIONS(3673),
    [anon_sym___inline] = ACTIONS(3673),
    [anon_sym___inline__] = ACTIONS(3673),
    [anon_sym___forceinline] = ACTIONS(3673),
    [anon_sym_thread_local] = ACTIONS(3673),
    [anon_sym___thread] = ACTIONS(3673),
    [anon_sym_const] = ACTIONS(3673),
    [anon_sym_constexpr] = ACTIONS(3673),
    [anon_sym_volatile] = ACTIONS(3673),
    [anon_sym_restrict] = ACTIONS(3673),
    [anon_sym___restrict__] = ACTIONS(3673),
    [anon_sym__Atomic] = ACTIONS(3673),
    [anon_sym__Noreturn] = ACTIONS(3673),
    [anon_sym_noreturn] = ACTIONS(3673),
    [anon_sym__Nonnull] = ACTIONS(3673),
    [anon_sym_mutable] = ACTIONS(3673),
    [anon_sym_constinit] = ACTIONS(3673),
    [anon_sym_consteval] = ACTIONS(3673),
    [anon_sym_alignas] = ACTIONS(3673),
    [anon_sym__Alignas] = ACTIONS(3673),
    [sym_primitive_type] = ACTIONS(3673),
    [anon_sym_enum] = ACTIONS(3673),
    [anon_sym_class] = ACTIONS(3673),
    [anon_sym_struct] = ACTIONS(3673),
    [anon_sym_union] = ACTIONS(3673),
    [anon_sym_if] = ACTIONS(3673),
    [anon_sym_switch] = ACTIONS(3673),
    [anon_sym_case] = ACTIONS(3673),
    [anon_sym_default] = ACTIONS(3673),
    [anon_sym_while] = ACTIONS(3673),
    [anon_sym_do] = ACTIONS(3673),
    [anon_sym_for] = ACTIONS(3673),
    [anon_sym_return] = ACTIONS(3673),
    [anon_sym_break] = ACTIONS(3673),
    [anon_sym_continue] = ACTIONS(3673),
    [anon_sym_goto] = ACTIONS(3673),
    [anon_sym___try] = ACTIONS(3673),
    [anon_sym___leave] = ACTIONS(3673),
    [anon_sym_not] = ACTIONS(3673),
    [anon_sym_compl] = ACTIONS(3673),
    [anon_sym_DASH_DASH] = ACTIONS(3675),
    [anon_sym_PLUS_PLUS] = ACTIONS(3675),
    [anon_sym_sizeof] = ACTIONS(3673),
    [anon_sym___alignof__] = ACTIONS(3673),
    [anon_sym___alignof] = ACTIONS(3673),
    [anon_sym__alignof] = ACTIONS(3673),
    [anon_sym_alignof] = ACTIONS(3673),
    [anon_sym__Alignof] = ACTIONS(3673),
    [anon_sym_offsetof] = ACTIONS(3673),
    [anon_sym__Generic] = ACTIONS(3673),
    [anon_sym_asm] = ACTIONS(3673),
    [anon_sym___asm__] = ACTIONS(3673),
    [anon_sym___asm] = ACTIONS(3673),
    [sym_number_literal] = ACTIONS(3675),
    [anon_sym_L_SQUOTE] = ACTIONS(3675),
    [anon_sym_u_SQUOTE] = ACTIONS(3675),
    [anon_sym_U_SQUOTE] = ACTIONS(3675),
    [anon_sym_u8_SQUOTE] = ACTIONS(3675),
    [anon_sym_SQUOTE] = ACTIONS(3675),
    [anon_sym_L_DQUOTE] = ACTIONS(3675),
    [anon_sym_u_DQUOTE] = ACTIONS(3675),
    [anon_sym_U_DQUOTE] = ACTIONS(3675),
    [anon_sym_u8_DQUOTE] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(3675),
    [sym_true] = ACTIONS(3673),
    [sym_false] = ACTIONS(3673),
    [anon_sym_NULL] = ACTIONS(3673),
    [anon_sym_nullptr] = ACTIONS(3673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3673),
    [anon_sym_let] = ACTIONS(3673),
    [anon_sym_This] = ACTIONS(3673),
    [anon_sym_decltype] = ACTIONS(3673),
    [anon_sym_explicit] = ACTIONS(3673),
    [anon_sym_typename] = ACTIONS(3673),
    [anon_sym_template] = ACTIONS(3673),
    [anon_sym_operator] = ACTIONS(3673),
    [anon_sym_try] = ACTIONS(3673),
    [anon_sym_delete] = ACTIONS(3673),
    [anon_sym_throw] = ACTIONS(3673),
    [anon_sym_namespace] = ACTIONS(3673),
    [anon_sym_static_assert] = ACTIONS(3673),
    [anon_sym_concept] = ACTIONS(3673),
    [anon_sym_co_return] = ACTIONS(3673),
    [anon_sym_co_yield] = ACTIONS(3673),
    [anon_sym_R_DQUOTE] = ACTIONS(3675),
    [anon_sym_LR_DQUOTE] = ACTIONS(3675),
    [anon_sym_uR_DQUOTE] = ACTIONS(3675),
    [anon_sym_UR_DQUOTE] = ACTIONS(3675),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3675),
    [anon_sym_co_await] = ACTIONS(3673),
    [anon_sym_new] = ACTIONS(3673),
    [anon_sym_requires] = ACTIONS(3673),
    [sym_this] = ACTIONS(3673),
    [anon_sym_discard] = ACTIONS(3673),
    [anon_sym_precise] = ACTIONS(3673),
    [anon_sym_shared] = ACTIONS(3673),
    [anon_sym_groupshared] = ACTIONS(3673),
    [anon_sym_uniform] = ACTIONS(3673),
    [anon_sym_row_major] = ACTIONS(3673),
    [anon_sym_column_major] = ACTIONS(3673),
    [anon_sym_globallycoherent] = ACTIONS(3673),
    [anon_sym_centroid] = ACTIONS(3673),
    [anon_sym_noperspective] = ACTIONS(3673),
    [anon_sym_nointerpolation] = ACTIONS(3673),
    [anon_sym_sample] = ACTIONS(3673),
    [anon_sym_linear] = ACTIONS(3673),
    [anon_sym_snorm] = ACTIONS(3673),
    [anon_sym_unorm] = ACTIONS(3673),
    [anon_sym_point] = ACTIONS(3673),
    [anon_sym_line] = ACTIONS(3673),
    [anon_sym_triangleadj] = ACTIONS(3673),
    [anon_sym_lineadj] = ACTIONS(3673),
    [anon_sym_triangle] = ACTIONS(3673),
    [anon_sym_cbuffer] = ACTIONS(3673),
    [anon_sym_interface] = ACTIONS(3673),
    [anon_sym_extension] = ACTIONS(3673),
  },
  [1143] = {
    [sym_identifier] = ACTIONS(3792),
    [aux_sym_preproc_include_token1] = ACTIONS(3792),
    [aux_sym_preproc_def_token1] = ACTIONS(3792),
    [aux_sym_preproc_if_token1] = ACTIONS(3792),
    [aux_sym_preproc_if_token2] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3792),
    [sym_preproc_directive] = ACTIONS(3792),
    [anon_sym_LPAREN2] = ACTIONS(3794),
    [anon_sym_BANG] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3794),
    [anon_sym_DASH] = ACTIONS(3792),
    [anon_sym_PLUS] = ACTIONS(3792),
    [anon_sym_STAR] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_AMP] = ACTIONS(3792),
    [anon_sym_SEMI] = ACTIONS(3794),
    [anon_sym___extension__] = ACTIONS(3792),
    [anon_sym_typedef] = ACTIONS(3792),
    [anon_sym_in] = ACTIONS(3792),
    [anon_sym_out] = ACTIONS(3792),
    [anon_sym_inout] = ACTIONS(3792),
    [anon_sym_virtual] = ACTIONS(3792),
    [anon_sym_extern] = ACTIONS(3792),
    [anon_sym___attribute__] = ACTIONS(3792),
    [anon_sym___attribute] = ACTIONS(3792),
    [anon_sym_using] = ACTIONS(3792),
    [anon_sym_COLON_COLON] = ACTIONS(3794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3794),
    [anon_sym___declspec] = ACTIONS(3792),
    [anon_sym___based] = ACTIONS(3792),
    [anon_sym___cdecl] = ACTIONS(3792),
    [anon_sym___clrcall] = ACTIONS(3792),
    [anon_sym___stdcall] = ACTIONS(3792),
    [anon_sym___fastcall] = ACTIONS(3792),
    [anon_sym___thiscall] = ACTIONS(3792),
    [anon_sym___vectorcall] = ACTIONS(3792),
    [anon_sym_LBRACE] = ACTIONS(3794),
    [anon_sym_signed] = ACTIONS(3792),
    [anon_sym_unsigned] = ACTIONS(3792),
    [anon_sym_long] = ACTIONS(3792),
    [anon_sym_short] = ACTIONS(3792),
    [anon_sym_LBRACK] = ACTIONS(3792),
    [anon_sym_static] = ACTIONS(3792),
    [anon_sym_register] = ACTIONS(3792),
    [anon_sym_inline] = ACTIONS(3792),
    [anon_sym___inline] = ACTIONS(3792),
    [anon_sym___inline__] = ACTIONS(3792),
    [anon_sym___forceinline] = ACTIONS(3792),
    [anon_sym_thread_local] = ACTIONS(3792),
    [anon_sym___thread] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3792),
    [anon_sym_constexpr] = ACTIONS(3792),
    [anon_sym_volatile] = ACTIONS(3792),
    [anon_sym_restrict] = ACTIONS(3792),
    [anon_sym___restrict__] = ACTIONS(3792),
    [anon_sym__Atomic] = ACTIONS(3792),
    [anon_sym__Noreturn] = ACTIONS(3792),
    [anon_sym_noreturn] = ACTIONS(3792),
    [anon_sym__Nonnull] = ACTIONS(3792),
    [anon_sym_mutable] = ACTIONS(3792),
    [anon_sym_constinit] = ACTIONS(3792),
    [anon_sym_consteval] = ACTIONS(3792),
    [anon_sym_alignas] = ACTIONS(3792),
    [anon_sym__Alignas] = ACTIONS(3792),
    [sym_primitive_type] = ACTIONS(3792),
    [anon_sym_enum] = ACTIONS(3792),
    [anon_sym_class] = ACTIONS(3792),
    [anon_sym_struct] = ACTIONS(3792),
    [anon_sym_union] = ACTIONS(3792),
    [anon_sym_if] = ACTIONS(3792),
    [anon_sym_switch] = ACTIONS(3792),
    [anon_sym_case] = ACTIONS(3792),
    [anon_sym_default] = ACTIONS(3792),
    [anon_sym_while] = ACTIONS(3792),
    [anon_sym_do] = ACTIONS(3792),
    [anon_sym_for] = ACTIONS(3792),
    [anon_sym_return] = ACTIONS(3792),
    [anon_sym_break] = ACTIONS(3792),
    [anon_sym_continue] = ACTIONS(3792),
    [anon_sym_goto] = ACTIONS(3792),
    [anon_sym___try] = ACTIONS(3792),
    [anon_sym___leave] = ACTIONS(3792),
    [anon_sym_not] = ACTIONS(3792),
    [anon_sym_compl] = ACTIONS(3792),
    [anon_sym_DASH_DASH] = ACTIONS(3794),
    [anon_sym_PLUS_PLUS] = ACTIONS(3794),
    [anon_sym_sizeof] = ACTIONS(3792),
    [anon_sym___alignof__] = ACTIONS(3792),
    [anon_sym___alignof] = ACTIONS(3792),
    [anon_sym__alignof] = ACTIONS(3792),
    [anon_sym_alignof] = ACTIONS(3792),
    [anon_sym__Alignof] = ACTIONS(3792),
    [anon_sym_offsetof] = ACTIONS(3792),
    [anon_sym__Generic] = ACTIONS(3792),
    [anon_sym_asm] = ACTIONS(3792),
    [anon_sym___asm__] = ACTIONS(3792),
    [anon_sym___asm] = ACTIONS(3792),
    [sym_number_literal] = ACTIONS(3794),
    [anon_sym_L_SQUOTE] = ACTIONS(3794),
    [anon_sym_u_SQUOTE] = ACTIONS(3794),
    [anon_sym_U_SQUOTE] = ACTIONS(3794),
    [anon_sym_u8_SQUOTE] = ACTIONS(3794),
    [anon_sym_SQUOTE] = ACTIONS(3794),
    [anon_sym_L_DQUOTE] = ACTIONS(3794),
    [anon_sym_u_DQUOTE] = ACTIONS(3794),
    [anon_sym_U_DQUOTE] = ACTIONS(3794),
    [anon_sym_u8_DQUOTE] = ACTIONS(3794),
    [anon_sym_DQUOTE] = ACTIONS(3794),
    [sym_true] = ACTIONS(3792),
    [sym_false] = ACTIONS(3792),
    [anon_sym_NULL] = ACTIONS(3792),
    [anon_sym_nullptr] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3792),
    [anon_sym_let] = ACTIONS(3792),
    [anon_sym_This] = ACTIONS(3792),
    [anon_sym_decltype] = ACTIONS(3792),
    [anon_sym_explicit] = ACTIONS(3792),
    [anon_sym_typename] = ACTIONS(3792),
    [anon_sym_template] = ACTIONS(3792),
    [anon_sym_operator] = ACTIONS(3792),
    [anon_sym_try] = ACTIONS(3792),
    [anon_sym_delete] = ACTIONS(3792),
    [anon_sym_throw] = ACTIONS(3792),
    [anon_sym_namespace] = ACTIONS(3792),
    [anon_sym_static_assert] = ACTIONS(3792),
    [anon_sym_concept] = ACTIONS(3792),
    [anon_sym_co_return] = ACTIONS(3792),
    [anon_sym_co_yield] = ACTIONS(3792),
    [anon_sym_R_DQUOTE] = ACTIONS(3794),
    [anon_sym_LR_DQUOTE] = ACTIONS(3794),
    [anon_sym_uR_DQUOTE] = ACTIONS(3794),
    [anon_sym_UR_DQUOTE] = ACTIONS(3794),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3794),
    [anon_sym_co_await] = ACTIONS(3792),
    [anon_sym_new] = ACTIONS(3792),
    [anon_sym_requires] = ACTIONS(3792),
    [sym_this] = ACTIONS(3792),
    [anon_sym_discard] = ACTIONS(3792),
    [anon_sym_precise] = ACTIONS(3792),
    [anon_sym_shared] = ACTIONS(3792),
    [anon_sym_groupshared] = ACTIONS(3792),
    [anon_sym_uniform] = ACTIONS(3792),
    [anon_sym_row_major] = ACTIONS(3792),
    [anon_sym_column_major] = ACTIONS(3792),
    [anon_sym_globallycoherent] = ACTIONS(3792),
    [anon_sym_centroid] = ACTIONS(3792),
    [anon_sym_noperspective] = ACTIONS(3792),
    [anon_sym_nointerpolation] = ACTIONS(3792),
    [anon_sym_sample] = ACTIONS(3792),
    [anon_sym_linear] = ACTIONS(3792),
    [anon_sym_snorm] = ACTIONS(3792),
    [anon_sym_unorm] = ACTIONS(3792),
    [anon_sym_point] = ACTIONS(3792),
    [anon_sym_line] = ACTIONS(3792),
    [anon_sym_triangleadj] = ACTIONS(3792),
    [anon_sym_lineadj] = ACTIONS(3792),
    [anon_sym_triangle] = ACTIONS(3792),
    [anon_sym_cbuffer] = ACTIONS(3792),
    [anon_sym_interface] = ACTIONS(3792),
    [anon_sym_extension] = ACTIONS(3792),
  },
  [1144] = {
    [sym_identifier] = ACTIONS(3881),
    [aux_sym_preproc_include_token1] = ACTIONS(3881),
    [aux_sym_preproc_def_token1] = ACTIONS(3881),
    [aux_sym_preproc_if_token1] = ACTIONS(3881),
    [aux_sym_preproc_if_token2] = ACTIONS(3881),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3881),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3881),
    [sym_preproc_directive] = ACTIONS(3881),
    [anon_sym_LPAREN2] = ACTIONS(3883),
    [anon_sym_BANG] = ACTIONS(3883),
    [anon_sym_TILDE] = ACTIONS(3883),
    [anon_sym_DASH] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(3881),
    [anon_sym_STAR] = ACTIONS(3883),
    [anon_sym_AMP_AMP] = ACTIONS(3883),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3883),
    [anon_sym___extension__] = ACTIONS(3881),
    [anon_sym_typedef] = ACTIONS(3881),
    [anon_sym_in] = ACTIONS(3881),
    [anon_sym_out] = ACTIONS(3881),
    [anon_sym_inout] = ACTIONS(3881),
    [anon_sym_virtual] = ACTIONS(3881),
    [anon_sym_extern] = ACTIONS(3881),
    [anon_sym___attribute__] = ACTIONS(3881),
    [anon_sym___attribute] = ACTIONS(3881),
    [anon_sym_using] = ACTIONS(3881),
    [anon_sym_COLON_COLON] = ACTIONS(3883),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3883),
    [anon_sym___declspec] = ACTIONS(3881),
    [anon_sym___based] = ACTIONS(3881),
    [anon_sym___cdecl] = ACTIONS(3881),
    [anon_sym___clrcall] = ACTIONS(3881),
    [anon_sym___stdcall] = ACTIONS(3881),
    [anon_sym___fastcall] = ACTIONS(3881),
    [anon_sym___thiscall] = ACTIONS(3881),
    [anon_sym___vectorcall] = ACTIONS(3881),
    [anon_sym_LBRACE] = ACTIONS(3883),
    [anon_sym_signed] = ACTIONS(3881),
    [anon_sym_unsigned] = ACTIONS(3881),
    [anon_sym_long] = ACTIONS(3881),
    [anon_sym_short] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_static] = ACTIONS(3881),
    [anon_sym_register] = ACTIONS(3881),
    [anon_sym_inline] = ACTIONS(3881),
    [anon_sym___inline] = ACTIONS(3881),
    [anon_sym___inline__] = ACTIONS(3881),
    [anon_sym___forceinline] = ACTIONS(3881),
    [anon_sym_thread_local] = ACTIONS(3881),
    [anon_sym___thread] = ACTIONS(3881),
    [anon_sym_const] = ACTIONS(3881),
    [anon_sym_constexpr] = ACTIONS(3881),
    [anon_sym_volatile] = ACTIONS(3881),
    [anon_sym_restrict] = ACTIONS(3881),
    [anon_sym___restrict__] = ACTIONS(3881),
    [anon_sym__Atomic] = ACTIONS(3881),
    [anon_sym__Noreturn] = ACTIONS(3881),
    [anon_sym_noreturn] = ACTIONS(3881),
    [anon_sym__Nonnull] = ACTIONS(3881),
    [anon_sym_mutable] = ACTIONS(3881),
    [anon_sym_constinit] = ACTIONS(3881),
    [anon_sym_consteval] = ACTIONS(3881),
    [anon_sym_alignas] = ACTIONS(3881),
    [anon_sym__Alignas] = ACTIONS(3881),
    [sym_primitive_type] = ACTIONS(3881),
    [anon_sym_enum] = ACTIONS(3881),
    [anon_sym_class] = ACTIONS(3881),
    [anon_sym_struct] = ACTIONS(3881),
    [anon_sym_union] = ACTIONS(3881),
    [anon_sym_if] = ACTIONS(3881),
    [anon_sym_switch] = ACTIONS(3881),
    [anon_sym_case] = ACTIONS(3881),
    [anon_sym_default] = ACTIONS(3881),
    [anon_sym_while] = ACTIONS(3881),
    [anon_sym_do] = ACTIONS(3881),
    [anon_sym_for] = ACTIONS(3881),
    [anon_sym_return] = ACTIONS(3881),
    [anon_sym_break] = ACTIONS(3881),
    [anon_sym_continue] = ACTIONS(3881),
    [anon_sym_goto] = ACTIONS(3881),
    [anon_sym___try] = ACTIONS(3881),
    [anon_sym___leave] = ACTIONS(3881),
    [anon_sym_not] = ACTIONS(3881),
    [anon_sym_compl] = ACTIONS(3881),
    [anon_sym_DASH_DASH] = ACTIONS(3883),
    [anon_sym_PLUS_PLUS] = ACTIONS(3883),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(3881),
    [anon_sym___alignof] = ACTIONS(3881),
    [anon_sym__alignof] = ACTIONS(3881),
    [anon_sym_alignof] = ACTIONS(3881),
    [anon_sym__Alignof] = ACTIONS(3881),
    [anon_sym_offsetof] = ACTIONS(3881),
    [anon_sym__Generic] = ACTIONS(3881),
    [anon_sym_asm] = ACTIONS(3881),
    [anon_sym___asm__] = ACTIONS(3881),
    [anon_sym___asm] = ACTIONS(3881),
    [sym_number_literal] = ACTIONS(3883),
    [anon_sym_L_SQUOTE] = ACTIONS(3883),
    [anon_sym_u_SQUOTE] = ACTIONS(3883),
    [anon_sym_U_SQUOTE] = ACTIONS(3883),
    [anon_sym_u8_SQUOTE] = ACTIONS(3883),
    [anon_sym_SQUOTE] = ACTIONS(3883),
    [anon_sym_L_DQUOTE] = ACTIONS(3883),
    [anon_sym_u_DQUOTE] = ACTIONS(3883),
    [anon_sym_U_DQUOTE] = ACTIONS(3883),
    [anon_sym_u8_DQUOTE] = ACTIONS(3883),
    [anon_sym_DQUOTE] = ACTIONS(3883),
    [sym_true] = ACTIONS(3881),
    [sym_false] = ACTIONS(3881),
    [anon_sym_NULL] = ACTIONS(3881),
    [anon_sym_nullptr] = ACTIONS(3881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3881),
    [anon_sym_let] = ACTIONS(3881),
    [anon_sym_This] = ACTIONS(3881),
    [anon_sym_decltype] = ACTIONS(3881),
    [anon_sym_explicit] = ACTIONS(3881),
    [anon_sym_typename] = ACTIONS(3881),
    [anon_sym_template] = ACTIONS(3881),
    [anon_sym_operator] = ACTIONS(3881),
    [anon_sym_try] = ACTIONS(3881),
    [anon_sym_delete] = ACTIONS(3881),
    [anon_sym_throw] = ACTIONS(3881),
    [anon_sym_namespace] = ACTIONS(3881),
    [anon_sym_static_assert] = ACTIONS(3881),
    [anon_sym_concept] = ACTIONS(3881),
    [anon_sym_co_return] = ACTIONS(3881),
    [anon_sym_co_yield] = ACTIONS(3881),
    [anon_sym_R_DQUOTE] = ACTIONS(3883),
    [anon_sym_LR_DQUOTE] = ACTIONS(3883),
    [anon_sym_uR_DQUOTE] = ACTIONS(3883),
    [anon_sym_UR_DQUOTE] = ACTIONS(3883),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3883),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3881),
    [anon_sym_requires] = ACTIONS(3881),
    [sym_this] = ACTIONS(3881),
    [anon_sym_discard] = ACTIONS(3881),
    [anon_sym_precise] = ACTIONS(3881),
    [anon_sym_shared] = ACTIONS(3881),
    [anon_sym_groupshared] = ACTIONS(3881),
    [anon_sym_uniform] = ACTIONS(3881),
    [anon_sym_row_major] = ACTIONS(3881),
    [anon_sym_column_major] = ACTIONS(3881),
    [anon_sym_globallycoherent] = ACTIONS(3881),
    [anon_sym_centroid] = ACTIONS(3881),
    [anon_sym_noperspective] = ACTIONS(3881),
    [anon_sym_nointerpolation] = ACTIONS(3881),
    [anon_sym_sample] = ACTIONS(3881),
    [anon_sym_linear] = ACTIONS(3881),
    [anon_sym_snorm] = ACTIONS(3881),
    [anon_sym_unorm] = ACTIONS(3881),
    [anon_sym_point] = ACTIONS(3881),
    [anon_sym_line] = ACTIONS(3881),
    [anon_sym_triangleadj] = ACTIONS(3881),
    [anon_sym_lineadj] = ACTIONS(3881),
    [anon_sym_triangle] = ACTIONS(3881),
    [anon_sym_cbuffer] = ACTIONS(3881),
    [anon_sym_interface] = ACTIONS(3881),
    [anon_sym_extension] = ACTIONS(3881),
  },
  [1145] = {
    [sym_identifier] = ACTIONS(3881),
    [aux_sym_preproc_include_token1] = ACTIONS(3881),
    [aux_sym_preproc_def_token1] = ACTIONS(3881),
    [aux_sym_preproc_if_token1] = ACTIONS(3881),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3881),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3881),
    [sym_preproc_directive] = ACTIONS(3881),
    [anon_sym_LPAREN2] = ACTIONS(3883),
    [anon_sym_BANG] = ACTIONS(3883),
    [anon_sym_TILDE] = ACTIONS(3883),
    [anon_sym_DASH] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(3881),
    [anon_sym_STAR] = ACTIONS(3883),
    [anon_sym_AMP_AMP] = ACTIONS(3883),
    [anon_sym_AMP] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3883),
    [anon_sym___extension__] = ACTIONS(3881),
    [anon_sym_typedef] = ACTIONS(3881),
    [anon_sym_in] = ACTIONS(3881),
    [anon_sym_out] = ACTIONS(3881),
    [anon_sym_inout] = ACTIONS(3881),
    [anon_sym_virtual] = ACTIONS(3881),
    [anon_sym_extern] = ACTIONS(3881),
    [anon_sym___attribute__] = ACTIONS(3881),
    [anon_sym___attribute] = ACTIONS(3881),
    [anon_sym_using] = ACTIONS(3881),
    [anon_sym_COLON_COLON] = ACTIONS(3883),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3883),
    [anon_sym___declspec] = ACTIONS(3881),
    [anon_sym___based] = ACTIONS(3881),
    [anon_sym___cdecl] = ACTIONS(3881),
    [anon_sym___clrcall] = ACTIONS(3881),
    [anon_sym___stdcall] = ACTIONS(3881),
    [anon_sym___fastcall] = ACTIONS(3881),
    [anon_sym___thiscall] = ACTIONS(3881),
    [anon_sym___vectorcall] = ACTIONS(3881),
    [anon_sym_LBRACE] = ACTIONS(3883),
    [anon_sym_RBRACE] = ACTIONS(3883),
    [anon_sym_signed] = ACTIONS(3881),
    [anon_sym_unsigned] = ACTIONS(3881),
    [anon_sym_long] = ACTIONS(3881),
    [anon_sym_short] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_static] = ACTIONS(3881),
    [anon_sym_register] = ACTIONS(3881),
    [anon_sym_inline] = ACTIONS(3881),
    [anon_sym___inline] = ACTIONS(3881),
    [anon_sym___inline__] = ACTIONS(3881),
    [anon_sym___forceinline] = ACTIONS(3881),
    [anon_sym_thread_local] = ACTIONS(3881),
    [anon_sym___thread] = ACTIONS(3881),
    [anon_sym_const] = ACTIONS(3881),
    [anon_sym_constexpr] = ACTIONS(3881),
    [anon_sym_volatile] = ACTIONS(3881),
    [anon_sym_restrict] = ACTIONS(3881),
    [anon_sym___restrict__] = ACTIONS(3881),
    [anon_sym__Atomic] = ACTIONS(3881),
    [anon_sym__Noreturn] = ACTIONS(3881),
    [anon_sym_noreturn] = ACTIONS(3881),
    [anon_sym__Nonnull] = ACTIONS(3881),
    [anon_sym_mutable] = ACTIONS(3881),
    [anon_sym_constinit] = ACTIONS(3881),
    [anon_sym_consteval] = ACTIONS(3881),
    [anon_sym_alignas] = ACTIONS(3881),
    [anon_sym__Alignas] = ACTIONS(3881),
    [sym_primitive_type] = ACTIONS(3881),
    [anon_sym_enum] = ACTIONS(3881),
    [anon_sym_class] = ACTIONS(3881),
    [anon_sym_struct] = ACTIONS(3881),
    [anon_sym_union] = ACTIONS(3881),
    [anon_sym_if] = ACTIONS(3881),
    [anon_sym_switch] = ACTIONS(3881),
    [anon_sym_case] = ACTIONS(3881),
    [anon_sym_default] = ACTIONS(3881),
    [anon_sym_while] = ACTIONS(3881),
    [anon_sym_do] = ACTIONS(3881),
    [anon_sym_for] = ACTIONS(3881),
    [anon_sym_return] = ACTIONS(3881),
    [anon_sym_break] = ACTIONS(3881),
    [anon_sym_continue] = ACTIONS(3881),
    [anon_sym_goto] = ACTIONS(3881),
    [anon_sym___try] = ACTIONS(3881),
    [anon_sym___leave] = ACTIONS(3881),
    [anon_sym_not] = ACTIONS(3881),
    [anon_sym_compl] = ACTIONS(3881),
    [anon_sym_DASH_DASH] = ACTIONS(3883),
    [anon_sym_PLUS_PLUS] = ACTIONS(3883),
    [anon_sym_sizeof] = ACTIONS(3881),
    [anon_sym___alignof__] = ACTIONS(3881),
    [anon_sym___alignof] = ACTIONS(3881),
    [anon_sym__alignof] = ACTIONS(3881),
    [anon_sym_alignof] = ACTIONS(3881),
    [anon_sym__Alignof] = ACTIONS(3881),
    [anon_sym_offsetof] = ACTIONS(3881),
    [anon_sym__Generic] = ACTIONS(3881),
    [anon_sym_asm] = ACTIONS(3881),
    [anon_sym___asm__] = ACTIONS(3881),
    [anon_sym___asm] = ACTIONS(3881),
    [sym_number_literal] = ACTIONS(3883),
    [anon_sym_L_SQUOTE] = ACTIONS(3883),
    [anon_sym_u_SQUOTE] = ACTIONS(3883),
    [anon_sym_U_SQUOTE] = ACTIONS(3883),
    [anon_sym_u8_SQUOTE] = ACTIONS(3883),
    [anon_sym_SQUOTE] = ACTIONS(3883),
    [anon_sym_L_DQUOTE] = ACTIONS(3883),
    [anon_sym_u_DQUOTE] = ACTIONS(3883),
    [anon_sym_U_DQUOTE] = ACTIONS(3883),
    [anon_sym_u8_DQUOTE] = ACTIONS(3883),
    [anon_sym_DQUOTE] = ACTIONS(3883),
    [sym_true] = ACTIONS(3881),
    [sym_false] = ACTIONS(3881),
    [anon_sym_NULL] = ACTIONS(3881),
    [anon_sym_nullptr] = ACTIONS(3881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3881),
    [anon_sym_let] = ACTIONS(3881),
    [anon_sym_This] = ACTIONS(3881),
    [anon_sym_decltype] = ACTIONS(3881),
    [anon_sym_explicit] = ACTIONS(3881),
    [anon_sym_typename] = ACTIONS(3881),
    [anon_sym_template] = ACTIONS(3881),
    [anon_sym_operator] = ACTIONS(3881),
    [anon_sym_try] = ACTIONS(3881),
    [anon_sym_delete] = ACTIONS(3881),
    [anon_sym_throw] = ACTIONS(3881),
    [anon_sym_namespace] = ACTIONS(3881),
    [anon_sym_static_assert] = ACTIONS(3881),
    [anon_sym_concept] = ACTIONS(3881),
    [anon_sym_co_return] = ACTIONS(3881),
    [anon_sym_co_yield] = ACTIONS(3881),
    [anon_sym_R_DQUOTE] = ACTIONS(3883),
    [anon_sym_LR_DQUOTE] = ACTIONS(3883),
    [anon_sym_uR_DQUOTE] = ACTIONS(3883),
    [anon_sym_UR_DQUOTE] = ACTIONS(3883),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3883),
    [anon_sym_co_await] = ACTIONS(3881),
    [anon_sym_new] = ACTIONS(3881),
    [anon_sym_requires] = ACTIONS(3881),
    [sym_this] = ACTIONS(3881),
    [anon_sym_discard] = ACTIONS(3881),
    [anon_sym_precise] = ACTIONS(3881),
    [anon_sym_shared] = ACTIONS(3881),
    [anon_sym_groupshared] = ACTIONS(3881),
    [anon_sym_uniform] = ACTIONS(3881),
    [anon_sym_row_major] = ACTIONS(3881),
    [anon_sym_column_major] = ACTIONS(3881),
    [anon_sym_globallycoherent] = ACTIONS(3881),
    [anon_sym_centroid] = ACTIONS(3881),
    [anon_sym_noperspective] = ACTIONS(3881),
    [anon_sym_nointerpolation] = ACTIONS(3881),
    [anon_sym_sample] = ACTIONS(3881),
    [anon_sym_linear] = ACTIONS(3881),
    [anon_sym_snorm] = ACTIONS(3881),
    [anon_sym_unorm] = ACTIONS(3881),
    [anon_sym_point] = ACTIONS(3881),
    [anon_sym_line] = ACTIONS(3881),
    [anon_sym_triangleadj] = ACTIONS(3881),
    [anon_sym_lineadj] = ACTIONS(3881),
    [anon_sym_triangle] = ACTIONS(3881),
    [anon_sym_cbuffer] = ACTIONS(3881),
    [anon_sym_interface] = ACTIONS(3881),
    [anon_sym_extension] = ACTIONS(3881),
  },
  [1146] = {
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_include_token1] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token2] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_BANG] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3812),
    [anon_sym_PLUS] = ACTIONS(3812),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym___cdecl] = ACTIONS(3812),
    [anon_sym___clrcall] = ACTIONS(3812),
    [anon_sym___stdcall] = ACTIONS(3812),
    [anon_sym___fastcall] = ACTIONS(3812),
    [anon_sym___thiscall] = ACTIONS(3812),
    [anon_sym___vectorcall] = ACTIONS(3812),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [anon_sym_if] = ACTIONS(3812),
    [anon_sym_switch] = ACTIONS(3812),
    [anon_sym_case] = ACTIONS(3812),
    [anon_sym_default] = ACTIONS(3812),
    [anon_sym_while] = ACTIONS(3812),
    [anon_sym_do] = ACTIONS(3812),
    [anon_sym_for] = ACTIONS(3812),
    [anon_sym_return] = ACTIONS(3812),
    [anon_sym_break] = ACTIONS(3812),
    [anon_sym_continue] = ACTIONS(3812),
    [anon_sym_goto] = ACTIONS(3812),
    [anon_sym___try] = ACTIONS(3812),
    [anon_sym___leave] = ACTIONS(3812),
    [anon_sym_not] = ACTIONS(3812),
    [anon_sym_compl] = ACTIONS(3812),
    [anon_sym_DASH_DASH] = ACTIONS(3814),
    [anon_sym_PLUS_PLUS] = ACTIONS(3814),
    [anon_sym_sizeof] = ACTIONS(3812),
    [anon_sym___alignof__] = ACTIONS(3812),
    [anon_sym___alignof] = ACTIONS(3812),
    [anon_sym__alignof] = ACTIONS(3812),
    [anon_sym_alignof] = ACTIONS(3812),
    [anon_sym__Alignof] = ACTIONS(3812),
    [anon_sym_offsetof] = ACTIONS(3812),
    [anon_sym__Generic] = ACTIONS(3812),
    [anon_sym_asm] = ACTIONS(3812),
    [anon_sym___asm__] = ACTIONS(3812),
    [anon_sym___asm] = ACTIONS(3812),
    [sym_number_literal] = ACTIONS(3814),
    [anon_sym_L_SQUOTE] = ACTIONS(3814),
    [anon_sym_u_SQUOTE] = ACTIONS(3814),
    [anon_sym_U_SQUOTE] = ACTIONS(3814),
    [anon_sym_u8_SQUOTE] = ACTIONS(3814),
    [anon_sym_SQUOTE] = ACTIONS(3814),
    [anon_sym_L_DQUOTE] = ACTIONS(3814),
    [anon_sym_u_DQUOTE] = ACTIONS(3814),
    [anon_sym_U_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8_DQUOTE] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3814),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [anon_sym_NULL] = ACTIONS(3812),
    [anon_sym_nullptr] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_try] = ACTIONS(3812),
    [anon_sym_delete] = ACTIONS(3812),
    [anon_sym_throw] = ACTIONS(3812),
    [anon_sym_namespace] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_concept] = ACTIONS(3812),
    [anon_sym_co_return] = ACTIONS(3812),
    [anon_sym_co_yield] = ACTIONS(3812),
    [anon_sym_R_DQUOTE] = ACTIONS(3814),
    [anon_sym_LR_DQUOTE] = ACTIONS(3814),
    [anon_sym_uR_DQUOTE] = ACTIONS(3814),
    [anon_sym_UR_DQUOTE] = ACTIONS(3814),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3814),
    [anon_sym_co_await] = ACTIONS(3812),
    [anon_sym_new] = ACTIONS(3812),
    [anon_sym_requires] = ACTIONS(3812),
    [sym_this] = ACTIONS(3812),
    [anon_sym_discard] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_cbuffer] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
  },
  [1147] = {
    [sym_identifier] = ACTIONS(3897),
    [aux_sym_preproc_include_token1] = ACTIONS(3897),
    [aux_sym_preproc_def_token1] = ACTIONS(3897),
    [aux_sym_preproc_if_token1] = ACTIONS(3897),
    [aux_sym_preproc_if_token2] = ACTIONS(3897),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3897),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3897),
    [sym_preproc_directive] = ACTIONS(3897),
    [anon_sym_LPAREN2] = ACTIONS(3899),
    [anon_sym_BANG] = ACTIONS(3899),
    [anon_sym_TILDE] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3897),
    [anon_sym_PLUS] = ACTIONS(3897),
    [anon_sym_STAR] = ACTIONS(3899),
    [anon_sym_AMP_AMP] = ACTIONS(3899),
    [anon_sym_AMP] = ACTIONS(3897),
    [anon_sym_SEMI] = ACTIONS(3899),
    [anon_sym___extension__] = ACTIONS(3897),
    [anon_sym_typedef] = ACTIONS(3897),
    [anon_sym_in] = ACTIONS(3897),
    [anon_sym_out] = ACTIONS(3897),
    [anon_sym_inout] = ACTIONS(3897),
    [anon_sym_virtual] = ACTIONS(3897),
    [anon_sym_extern] = ACTIONS(3897),
    [anon_sym___attribute__] = ACTIONS(3897),
    [anon_sym___attribute] = ACTIONS(3897),
    [anon_sym_using] = ACTIONS(3897),
    [anon_sym_COLON_COLON] = ACTIONS(3899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3899),
    [anon_sym___declspec] = ACTIONS(3897),
    [anon_sym___based] = ACTIONS(3897),
    [anon_sym___cdecl] = ACTIONS(3897),
    [anon_sym___clrcall] = ACTIONS(3897),
    [anon_sym___stdcall] = ACTIONS(3897),
    [anon_sym___fastcall] = ACTIONS(3897),
    [anon_sym___thiscall] = ACTIONS(3897),
    [anon_sym___vectorcall] = ACTIONS(3897),
    [anon_sym_LBRACE] = ACTIONS(3899),
    [anon_sym_signed] = ACTIONS(3897),
    [anon_sym_unsigned] = ACTIONS(3897),
    [anon_sym_long] = ACTIONS(3897),
    [anon_sym_short] = ACTIONS(3897),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_static] = ACTIONS(3897),
    [anon_sym_register] = ACTIONS(3897),
    [anon_sym_inline] = ACTIONS(3897),
    [anon_sym___inline] = ACTIONS(3897),
    [anon_sym___inline__] = ACTIONS(3897),
    [anon_sym___forceinline] = ACTIONS(3897),
    [anon_sym_thread_local] = ACTIONS(3897),
    [anon_sym___thread] = ACTIONS(3897),
    [anon_sym_const] = ACTIONS(3897),
    [anon_sym_constexpr] = ACTIONS(3897),
    [anon_sym_volatile] = ACTIONS(3897),
    [anon_sym_restrict] = ACTIONS(3897),
    [anon_sym___restrict__] = ACTIONS(3897),
    [anon_sym__Atomic] = ACTIONS(3897),
    [anon_sym__Noreturn] = ACTIONS(3897),
    [anon_sym_noreturn] = ACTIONS(3897),
    [anon_sym__Nonnull] = ACTIONS(3897),
    [anon_sym_mutable] = ACTIONS(3897),
    [anon_sym_constinit] = ACTIONS(3897),
    [anon_sym_consteval] = ACTIONS(3897),
    [anon_sym_alignas] = ACTIONS(3897),
    [anon_sym__Alignas] = ACTIONS(3897),
    [sym_primitive_type] = ACTIONS(3897),
    [anon_sym_enum] = ACTIONS(3897),
    [anon_sym_class] = ACTIONS(3897),
    [anon_sym_struct] = ACTIONS(3897),
    [anon_sym_union] = ACTIONS(3897),
    [anon_sym_if] = ACTIONS(3897),
    [anon_sym_switch] = ACTIONS(3897),
    [anon_sym_case] = ACTIONS(3897),
    [anon_sym_default] = ACTIONS(3897),
    [anon_sym_while] = ACTIONS(3897),
    [anon_sym_do] = ACTIONS(3897),
    [anon_sym_for] = ACTIONS(3897),
    [anon_sym_return] = ACTIONS(3897),
    [anon_sym_break] = ACTIONS(3897),
    [anon_sym_continue] = ACTIONS(3897),
    [anon_sym_goto] = ACTIONS(3897),
    [anon_sym___try] = ACTIONS(3897),
    [anon_sym___leave] = ACTIONS(3897),
    [anon_sym_not] = ACTIONS(3897),
    [anon_sym_compl] = ACTIONS(3897),
    [anon_sym_DASH_DASH] = ACTIONS(3899),
    [anon_sym_PLUS_PLUS] = ACTIONS(3899),
    [anon_sym_sizeof] = ACTIONS(3897),
    [anon_sym___alignof__] = ACTIONS(3897),
    [anon_sym___alignof] = ACTIONS(3897),
    [anon_sym__alignof] = ACTIONS(3897),
    [anon_sym_alignof] = ACTIONS(3897),
    [anon_sym__Alignof] = ACTIONS(3897),
    [anon_sym_offsetof] = ACTIONS(3897),
    [anon_sym__Generic] = ACTIONS(3897),
    [anon_sym_asm] = ACTIONS(3897),
    [anon_sym___asm__] = ACTIONS(3897),
    [anon_sym___asm] = ACTIONS(3897),
    [sym_number_literal] = ACTIONS(3899),
    [anon_sym_L_SQUOTE] = ACTIONS(3899),
    [anon_sym_u_SQUOTE] = ACTIONS(3899),
    [anon_sym_U_SQUOTE] = ACTIONS(3899),
    [anon_sym_u8_SQUOTE] = ACTIONS(3899),
    [anon_sym_SQUOTE] = ACTIONS(3899),
    [anon_sym_L_DQUOTE] = ACTIONS(3899),
    [anon_sym_u_DQUOTE] = ACTIONS(3899),
    [anon_sym_U_DQUOTE] = ACTIONS(3899),
    [anon_sym_u8_DQUOTE] = ACTIONS(3899),
    [anon_sym_DQUOTE] = ACTIONS(3899),
    [sym_true] = ACTIONS(3897),
    [sym_false] = ACTIONS(3897),
    [anon_sym_NULL] = ACTIONS(3897),
    [anon_sym_nullptr] = ACTIONS(3897),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3897),
    [anon_sym_let] = ACTIONS(3897),
    [anon_sym_This] = ACTIONS(3897),
    [anon_sym_decltype] = ACTIONS(3897),
    [anon_sym_explicit] = ACTIONS(3897),
    [anon_sym_typename] = ACTIONS(3897),
    [anon_sym_template] = ACTIONS(3897),
    [anon_sym_operator] = ACTIONS(3897),
    [anon_sym_try] = ACTIONS(3897),
    [anon_sym_delete] = ACTIONS(3897),
    [anon_sym_throw] = ACTIONS(3897),
    [anon_sym_namespace] = ACTIONS(3897),
    [anon_sym_static_assert] = ACTIONS(3897),
    [anon_sym_concept] = ACTIONS(3897),
    [anon_sym_co_return] = ACTIONS(3897),
    [anon_sym_co_yield] = ACTIONS(3897),
    [anon_sym_R_DQUOTE] = ACTIONS(3899),
    [anon_sym_LR_DQUOTE] = ACTIONS(3899),
    [anon_sym_uR_DQUOTE] = ACTIONS(3899),
    [anon_sym_UR_DQUOTE] = ACTIONS(3899),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3899),
    [anon_sym_co_await] = ACTIONS(3897),
    [anon_sym_new] = ACTIONS(3897),
    [anon_sym_requires] = ACTIONS(3897),
    [sym_this] = ACTIONS(3897),
    [anon_sym_discard] = ACTIONS(3897),
    [anon_sym_precise] = ACTIONS(3897),
    [anon_sym_shared] = ACTIONS(3897),
    [anon_sym_groupshared] = ACTIONS(3897),
    [anon_sym_uniform] = ACTIONS(3897),
    [anon_sym_row_major] = ACTIONS(3897),
    [anon_sym_column_major] = ACTIONS(3897),
    [anon_sym_globallycoherent] = ACTIONS(3897),
    [anon_sym_centroid] = ACTIONS(3897),
    [anon_sym_noperspective] = ACTIONS(3897),
    [anon_sym_nointerpolation] = ACTIONS(3897),
    [anon_sym_sample] = ACTIONS(3897),
    [anon_sym_linear] = ACTIONS(3897),
    [anon_sym_snorm] = ACTIONS(3897),
    [anon_sym_unorm] = ACTIONS(3897),
    [anon_sym_point] = ACTIONS(3897),
    [anon_sym_line] = ACTIONS(3897),
    [anon_sym_triangleadj] = ACTIONS(3897),
    [anon_sym_lineadj] = ACTIONS(3897),
    [anon_sym_triangle] = ACTIONS(3897),
    [anon_sym_cbuffer] = ACTIONS(3897),
    [anon_sym_interface] = ACTIONS(3897),
    [anon_sym_extension] = ACTIONS(3897),
  },
  [1148] = {
    [sym_identifier] = ACTIONS(3901),
    [aux_sym_preproc_include_token1] = ACTIONS(3901),
    [aux_sym_preproc_def_token1] = ACTIONS(3901),
    [aux_sym_preproc_if_token1] = ACTIONS(3901),
    [aux_sym_preproc_if_token2] = ACTIONS(3901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3901),
    [sym_preproc_directive] = ACTIONS(3901),
    [anon_sym_LPAREN2] = ACTIONS(3903),
    [anon_sym_BANG] = ACTIONS(3903),
    [anon_sym_TILDE] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3901),
    [anon_sym_STAR] = ACTIONS(3903),
    [anon_sym_AMP_AMP] = ACTIONS(3903),
    [anon_sym_AMP] = ACTIONS(3901),
    [anon_sym_SEMI] = ACTIONS(3903),
    [anon_sym___extension__] = ACTIONS(3901),
    [anon_sym_typedef] = ACTIONS(3901),
    [anon_sym_in] = ACTIONS(3901),
    [anon_sym_out] = ACTIONS(3901),
    [anon_sym_inout] = ACTIONS(3901),
    [anon_sym_virtual] = ACTIONS(3901),
    [anon_sym_extern] = ACTIONS(3901),
    [anon_sym___attribute__] = ACTIONS(3901),
    [anon_sym___attribute] = ACTIONS(3901),
    [anon_sym_using] = ACTIONS(3901),
    [anon_sym_COLON_COLON] = ACTIONS(3903),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3903),
    [anon_sym___declspec] = ACTIONS(3901),
    [anon_sym___based] = ACTIONS(3901),
    [anon_sym___cdecl] = ACTIONS(3901),
    [anon_sym___clrcall] = ACTIONS(3901),
    [anon_sym___stdcall] = ACTIONS(3901),
    [anon_sym___fastcall] = ACTIONS(3901),
    [anon_sym___thiscall] = ACTIONS(3901),
    [anon_sym___vectorcall] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_signed] = ACTIONS(3901),
    [anon_sym_unsigned] = ACTIONS(3901),
    [anon_sym_long] = ACTIONS(3901),
    [anon_sym_short] = ACTIONS(3901),
    [anon_sym_LBRACK] = ACTIONS(3901),
    [anon_sym_static] = ACTIONS(3901),
    [anon_sym_register] = ACTIONS(3901),
    [anon_sym_inline] = ACTIONS(3901),
    [anon_sym___inline] = ACTIONS(3901),
    [anon_sym___inline__] = ACTIONS(3901),
    [anon_sym___forceinline] = ACTIONS(3901),
    [anon_sym_thread_local] = ACTIONS(3901),
    [anon_sym___thread] = ACTIONS(3901),
    [anon_sym_const] = ACTIONS(3901),
    [anon_sym_constexpr] = ACTIONS(3901),
    [anon_sym_volatile] = ACTIONS(3901),
    [anon_sym_restrict] = ACTIONS(3901),
    [anon_sym___restrict__] = ACTIONS(3901),
    [anon_sym__Atomic] = ACTIONS(3901),
    [anon_sym__Noreturn] = ACTIONS(3901),
    [anon_sym_noreturn] = ACTIONS(3901),
    [anon_sym__Nonnull] = ACTIONS(3901),
    [anon_sym_mutable] = ACTIONS(3901),
    [anon_sym_constinit] = ACTIONS(3901),
    [anon_sym_consteval] = ACTIONS(3901),
    [anon_sym_alignas] = ACTIONS(3901),
    [anon_sym__Alignas] = ACTIONS(3901),
    [sym_primitive_type] = ACTIONS(3901),
    [anon_sym_enum] = ACTIONS(3901),
    [anon_sym_class] = ACTIONS(3901),
    [anon_sym_struct] = ACTIONS(3901),
    [anon_sym_union] = ACTIONS(3901),
    [anon_sym_if] = ACTIONS(3901),
    [anon_sym_switch] = ACTIONS(3901),
    [anon_sym_case] = ACTIONS(3901),
    [anon_sym_default] = ACTIONS(3901),
    [anon_sym_while] = ACTIONS(3901),
    [anon_sym_do] = ACTIONS(3901),
    [anon_sym_for] = ACTIONS(3901),
    [anon_sym_return] = ACTIONS(3901),
    [anon_sym_break] = ACTIONS(3901),
    [anon_sym_continue] = ACTIONS(3901),
    [anon_sym_goto] = ACTIONS(3901),
    [anon_sym___try] = ACTIONS(3901),
    [anon_sym___leave] = ACTIONS(3901),
    [anon_sym_not] = ACTIONS(3901),
    [anon_sym_compl] = ACTIONS(3901),
    [anon_sym_DASH_DASH] = ACTIONS(3903),
    [anon_sym_PLUS_PLUS] = ACTIONS(3903),
    [anon_sym_sizeof] = ACTIONS(3901),
    [anon_sym___alignof__] = ACTIONS(3901),
    [anon_sym___alignof] = ACTIONS(3901),
    [anon_sym__alignof] = ACTIONS(3901),
    [anon_sym_alignof] = ACTIONS(3901),
    [anon_sym__Alignof] = ACTIONS(3901),
    [anon_sym_offsetof] = ACTIONS(3901),
    [anon_sym__Generic] = ACTIONS(3901),
    [anon_sym_asm] = ACTIONS(3901),
    [anon_sym___asm__] = ACTIONS(3901),
    [anon_sym___asm] = ACTIONS(3901),
    [sym_number_literal] = ACTIONS(3903),
    [anon_sym_L_SQUOTE] = ACTIONS(3903),
    [anon_sym_u_SQUOTE] = ACTIONS(3903),
    [anon_sym_U_SQUOTE] = ACTIONS(3903),
    [anon_sym_u8_SQUOTE] = ACTIONS(3903),
    [anon_sym_SQUOTE] = ACTIONS(3903),
    [anon_sym_L_DQUOTE] = ACTIONS(3903),
    [anon_sym_u_DQUOTE] = ACTIONS(3903),
    [anon_sym_U_DQUOTE] = ACTIONS(3903),
    [anon_sym_u8_DQUOTE] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(3903),
    [sym_true] = ACTIONS(3901),
    [sym_false] = ACTIONS(3901),
    [anon_sym_NULL] = ACTIONS(3901),
    [anon_sym_nullptr] = ACTIONS(3901),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3901),
    [anon_sym_let] = ACTIONS(3901),
    [anon_sym_This] = ACTIONS(3901),
    [anon_sym_decltype] = ACTIONS(3901),
    [anon_sym_explicit] = ACTIONS(3901),
    [anon_sym_typename] = ACTIONS(3901),
    [anon_sym_template] = ACTIONS(3901),
    [anon_sym_operator] = ACTIONS(3901),
    [anon_sym_try] = ACTIONS(3901),
    [anon_sym_delete] = ACTIONS(3901),
    [anon_sym_throw] = ACTIONS(3901),
    [anon_sym_namespace] = ACTIONS(3901),
    [anon_sym_static_assert] = ACTIONS(3901),
    [anon_sym_concept] = ACTIONS(3901),
    [anon_sym_co_return] = ACTIONS(3901),
    [anon_sym_co_yield] = ACTIONS(3901),
    [anon_sym_R_DQUOTE] = ACTIONS(3903),
    [anon_sym_LR_DQUOTE] = ACTIONS(3903),
    [anon_sym_uR_DQUOTE] = ACTIONS(3903),
    [anon_sym_UR_DQUOTE] = ACTIONS(3903),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3903),
    [anon_sym_co_await] = ACTIONS(3901),
    [anon_sym_new] = ACTIONS(3901),
    [anon_sym_requires] = ACTIONS(3901),
    [sym_this] = ACTIONS(3901),
    [anon_sym_discard] = ACTIONS(3901),
    [anon_sym_precise] = ACTIONS(3901),
    [anon_sym_shared] = ACTIONS(3901),
    [anon_sym_groupshared] = ACTIONS(3901),
    [anon_sym_uniform] = ACTIONS(3901),
    [anon_sym_row_major] = ACTIONS(3901),
    [anon_sym_column_major] = ACTIONS(3901),
    [anon_sym_globallycoherent] = ACTIONS(3901),
    [anon_sym_centroid] = ACTIONS(3901),
    [anon_sym_noperspective] = ACTIONS(3901),
    [anon_sym_nointerpolation] = ACTIONS(3901),
    [anon_sym_sample] = ACTIONS(3901),
    [anon_sym_linear] = ACTIONS(3901),
    [anon_sym_snorm] = ACTIONS(3901),
    [anon_sym_unorm] = ACTIONS(3901),
    [anon_sym_point] = ACTIONS(3901),
    [anon_sym_line] = ACTIONS(3901),
    [anon_sym_triangleadj] = ACTIONS(3901),
    [anon_sym_lineadj] = ACTIONS(3901),
    [anon_sym_triangle] = ACTIONS(3901),
    [anon_sym_cbuffer] = ACTIONS(3901),
    [anon_sym_interface] = ACTIONS(3901),
    [anon_sym_extension] = ACTIONS(3901),
  },
  [1149] = {
    [sym_identifier] = ACTIONS(3845),
    [aux_sym_preproc_include_token1] = ACTIONS(3845),
    [aux_sym_preproc_def_token1] = ACTIONS(3845),
    [aux_sym_preproc_if_token1] = ACTIONS(3845),
    [aux_sym_preproc_if_token2] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3845),
    [sym_preproc_directive] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3847),
    [anon_sym_BANG] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_STAR] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_SEMI] = ACTIONS(3847),
    [anon_sym___extension__] = ACTIONS(3845),
    [anon_sym_typedef] = ACTIONS(3845),
    [anon_sym_in] = ACTIONS(3845),
    [anon_sym_out] = ACTIONS(3845),
    [anon_sym_inout] = ACTIONS(3845),
    [anon_sym_virtual] = ACTIONS(3845),
    [anon_sym_extern] = ACTIONS(3845),
    [anon_sym___attribute__] = ACTIONS(3845),
    [anon_sym___attribute] = ACTIONS(3845),
    [anon_sym_using] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3847),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3847),
    [anon_sym___declspec] = ACTIONS(3845),
    [anon_sym___based] = ACTIONS(3845),
    [anon_sym___cdecl] = ACTIONS(3845),
    [anon_sym___clrcall] = ACTIONS(3845),
    [anon_sym___stdcall] = ACTIONS(3845),
    [anon_sym___fastcall] = ACTIONS(3845),
    [anon_sym___thiscall] = ACTIONS(3845),
    [anon_sym___vectorcall] = ACTIONS(3845),
    [anon_sym_LBRACE] = ACTIONS(3847),
    [anon_sym_signed] = ACTIONS(3845),
    [anon_sym_unsigned] = ACTIONS(3845),
    [anon_sym_long] = ACTIONS(3845),
    [anon_sym_short] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_static] = ACTIONS(3845),
    [anon_sym_register] = ACTIONS(3845),
    [anon_sym_inline] = ACTIONS(3845),
    [anon_sym___inline] = ACTIONS(3845),
    [anon_sym___inline__] = ACTIONS(3845),
    [anon_sym___forceinline] = ACTIONS(3845),
    [anon_sym_thread_local] = ACTIONS(3845),
    [anon_sym___thread] = ACTIONS(3845),
    [anon_sym_const] = ACTIONS(3845),
    [anon_sym_constexpr] = ACTIONS(3845),
    [anon_sym_volatile] = ACTIONS(3845),
    [anon_sym_restrict] = ACTIONS(3845),
    [anon_sym___restrict__] = ACTIONS(3845),
    [anon_sym__Atomic] = ACTIONS(3845),
    [anon_sym__Noreturn] = ACTIONS(3845),
    [anon_sym_noreturn] = ACTIONS(3845),
    [anon_sym__Nonnull] = ACTIONS(3845),
    [anon_sym_mutable] = ACTIONS(3845),
    [anon_sym_constinit] = ACTIONS(3845),
    [anon_sym_consteval] = ACTIONS(3845),
    [anon_sym_alignas] = ACTIONS(3845),
    [anon_sym__Alignas] = ACTIONS(3845),
    [sym_primitive_type] = ACTIONS(3845),
    [anon_sym_enum] = ACTIONS(3845),
    [anon_sym_class] = ACTIONS(3845),
    [anon_sym_struct] = ACTIONS(3845),
    [anon_sym_union] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_switch] = ACTIONS(3845),
    [anon_sym_case] = ACTIONS(3845),
    [anon_sym_default] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_break] = ACTIONS(3845),
    [anon_sym_continue] = ACTIONS(3845),
    [anon_sym_goto] = ACTIONS(3845),
    [anon_sym___try] = ACTIONS(3845),
    [anon_sym___leave] = ACTIONS(3845),
    [anon_sym_not] = ACTIONS(3845),
    [anon_sym_compl] = ACTIONS(3845),
    [anon_sym_DASH_DASH] = ACTIONS(3847),
    [anon_sym_PLUS_PLUS] = ACTIONS(3847),
    [anon_sym_sizeof] = ACTIONS(3845),
    [anon_sym___alignof__] = ACTIONS(3845),
    [anon_sym___alignof] = ACTIONS(3845),
    [anon_sym__alignof] = ACTIONS(3845),
    [anon_sym_alignof] = ACTIONS(3845),
    [anon_sym__Alignof] = ACTIONS(3845),
    [anon_sym_offsetof] = ACTIONS(3845),
    [anon_sym__Generic] = ACTIONS(3845),
    [anon_sym_asm] = ACTIONS(3845),
    [anon_sym___asm__] = ACTIONS(3845),
    [anon_sym___asm] = ACTIONS(3845),
    [sym_number_literal] = ACTIONS(3847),
    [anon_sym_L_SQUOTE] = ACTIONS(3847),
    [anon_sym_u_SQUOTE] = ACTIONS(3847),
    [anon_sym_U_SQUOTE] = ACTIONS(3847),
    [anon_sym_u8_SQUOTE] = ACTIONS(3847),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [anon_sym_L_DQUOTE] = ACTIONS(3847),
    [anon_sym_u_DQUOTE] = ACTIONS(3847),
    [anon_sym_U_DQUOTE] = ACTIONS(3847),
    [anon_sym_u8_DQUOTE] = ACTIONS(3847),
    [anon_sym_DQUOTE] = ACTIONS(3847),
    [sym_true] = ACTIONS(3845),
    [sym_false] = ACTIONS(3845),
    [anon_sym_NULL] = ACTIONS(3845),
    [anon_sym_nullptr] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_This] = ACTIONS(3845),
    [anon_sym_decltype] = ACTIONS(3845),
    [anon_sym_explicit] = ACTIONS(3845),
    [anon_sym_typename] = ACTIONS(3845),
    [anon_sym_template] = ACTIONS(3845),
    [anon_sym_operator] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_delete] = ACTIONS(3845),
    [anon_sym_throw] = ACTIONS(3845),
    [anon_sym_namespace] = ACTIONS(3845),
    [anon_sym_static_assert] = ACTIONS(3845),
    [anon_sym_concept] = ACTIONS(3845),
    [anon_sym_co_return] = ACTIONS(3845),
    [anon_sym_co_yield] = ACTIONS(3845),
    [anon_sym_R_DQUOTE] = ACTIONS(3847),
    [anon_sym_LR_DQUOTE] = ACTIONS(3847),
    [anon_sym_uR_DQUOTE] = ACTIONS(3847),
    [anon_sym_UR_DQUOTE] = ACTIONS(3847),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3847),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_requires] = ACTIONS(3845),
    [sym_this] = ACTIONS(3845),
    [anon_sym_discard] = ACTIONS(3845),
    [anon_sym_precise] = ACTIONS(3845),
    [anon_sym_shared] = ACTIONS(3845),
    [anon_sym_groupshared] = ACTIONS(3845),
    [anon_sym_uniform] = ACTIONS(3845),
    [anon_sym_row_major] = ACTIONS(3845),
    [anon_sym_column_major] = ACTIONS(3845),
    [anon_sym_globallycoherent] = ACTIONS(3845),
    [anon_sym_centroid] = ACTIONS(3845),
    [anon_sym_noperspective] = ACTIONS(3845),
    [anon_sym_nointerpolation] = ACTIONS(3845),
    [anon_sym_sample] = ACTIONS(3845),
    [anon_sym_linear] = ACTIONS(3845),
    [anon_sym_snorm] = ACTIONS(3845),
    [anon_sym_unorm] = ACTIONS(3845),
    [anon_sym_point] = ACTIONS(3845),
    [anon_sym_line] = ACTIONS(3845),
    [anon_sym_triangleadj] = ACTIONS(3845),
    [anon_sym_lineadj] = ACTIONS(3845),
    [anon_sym_triangle] = ACTIONS(3845),
    [anon_sym_cbuffer] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3845),
    [anon_sym_extension] = ACTIONS(3845),
  },
  [1150] = {
    [sym_identifier] = ACTIONS(3913),
    [aux_sym_preproc_include_token1] = ACTIONS(3913),
    [aux_sym_preproc_def_token1] = ACTIONS(3913),
    [aux_sym_preproc_if_token1] = ACTIONS(3913),
    [aux_sym_preproc_if_token2] = ACTIONS(3913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3913),
    [sym_preproc_directive] = ACTIONS(3913),
    [anon_sym_LPAREN2] = ACTIONS(3915),
    [anon_sym_BANG] = ACTIONS(3915),
    [anon_sym_TILDE] = ACTIONS(3915),
    [anon_sym_DASH] = ACTIONS(3913),
    [anon_sym_PLUS] = ACTIONS(3913),
    [anon_sym_STAR] = ACTIONS(3915),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(3913),
    [anon_sym_SEMI] = ACTIONS(3915),
    [anon_sym___extension__] = ACTIONS(3913),
    [anon_sym_typedef] = ACTIONS(3913),
    [anon_sym_in] = ACTIONS(3913),
    [anon_sym_out] = ACTIONS(3913),
    [anon_sym_inout] = ACTIONS(3913),
    [anon_sym_virtual] = ACTIONS(3913),
    [anon_sym_extern] = ACTIONS(3913),
    [anon_sym___attribute__] = ACTIONS(3913),
    [anon_sym___attribute] = ACTIONS(3913),
    [anon_sym_using] = ACTIONS(3913),
    [anon_sym_COLON_COLON] = ACTIONS(3915),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3915),
    [anon_sym___declspec] = ACTIONS(3913),
    [anon_sym___based] = ACTIONS(3913),
    [anon_sym___cdecl] = ACTIONS(3913),
    [anon_sym___clrcall] = ACTIONS(3913),
    [anon_sym___stdcall] = ACTIONS(3913),
    [anon_sym___fastcall] = ACTIONS(3913),
    [anon_sym___thiscall] = ACTIONS(3913),
    [anon_sym___vectorcall] = ACTIONS(3913),
    [anon_sym_LBRACE] = ACTIONS(3915),
    [anon_sym_signed] = ACTIONS(3913),
    [anon_sym_unsigned] = ACTIONS(3913),
    [anon_sym_long] = ACTIONS(3913),
    [anon_sym_short] = ACTIONS(3913),
    [anon_sym_LBRACK] = ACTIONS(3913),
    [anon_sym_static] = ACTIONS(3913),
    [anon_sym_register] = ACTIONS(3913),
    [anon_sym_inline] = ACTIONS(3913),
    [anon_sym___inline] = ACTIONS(3913),
    [anon_sym___inline__] = ACTIONS(3913),
    [anon_sym___forceinline] = ACTIONS(3913),
    [anon_sym_thread_local] = ACTIONS(3913),
    [anon_sym___thread] = ACTIONS(3913),
    [anon_sym_const] = ACTIONS(3913),
    [anon_sym_constexpr] = ACTIONS(3913),
    [anon_sym_volatile] = ACTIONS(3913),
    [anon_sym_restrict] = ACTIONS(3913),
    [anon_sym___restrict__] = ACTIONS(3913),
    [anon_sym__Atomic] = ACTIONS(3913),
    [anon_sym__Noreturn] = ACTIONS(3913),
    [anon_sym_noreturn] = ACTIONS(3913),
    [anon_sym__Nonnull] = ACTIONS(3913),
    [anon_sym_mutable] = ACTIONS(3913),
    [anon_sym_constinit] = ACTIONS(3913),
    [anon_sym_consteval] = ACTIONS(3913),
    [anon_sym_alignas] = ACTIONS(3913),
    [anon_sym__Alignas] = ACTIONS(3913),
    [sym_primitive_type] = ACTIONS(3913),
    [anon_sym_enum] = ACTIONS(3913),
    [anon_sym_class] = ACTIONS(3913),
    [anon_sym_struct] = ACTIONS(3913),
    [anon_sym_union] = ACTIONS(3913),
    [anon_sym_if] = ACTIONS(3913),
    [anon_sym_switch] = ACTIONS(3913),
    [anon_sym_case] = ACTIONS(3913),
    [anon_sym_default] = ACTIONS(3913),
    [anon_sym_while] = ACTIONS(3913),
    [anon_sym_do] = ACTIONS(3913),
    [anon_sym_for] = ACTIONS(3913),
    [anon_sym_return] = ACTIONS(3913),
    [anon_sym_break] = ACTIONS(3913),
    [anon_sym_continue] = ACTIONS(3913),
    [anon_sym_goto] = ACTIONS(3913),
    [anon_sym___try] = ACTIONS(3913),
    [anon_sym___leave] = ACTIONS(3913),
    [anon_sym_not] = ACTIONS(3913),
    [anon_sym_compl] = ACTIONS(3913),
    [anon_sym_DASH_DASH] = ACTIONS(3915),
    [anon_sym_PLUS_PLUS] = ACTIONS(3915),
    [anon_sym_sizeof] = ACTIONS(3913),
    [anon_sym___alignof__] = ACTIONS(3913),
    [anon_sym___alignof] = ACTIONS(3913),
    [anon_sym__alignof] = ACTIONS(3913),
    [anon_sym_alignof] = ACTIONS(3913),
    [anon_sym__Alignof] = ACTIONS(3913),
    [anon_sym_offsetof] = ACTIONS(3913),
    [anon_sym__Generic] = ACTIONS(3913),
    [anon_sym_asm] = ACTIONS(3913),
    [anon_sym___asm__] = ACTIONS(3913),
    [anon_sym___asm] = ACTIONS(3913),
    [sym_number_literal] = ACTIONS(3915),
    [anon_sym_L_SQUOTE] = ACTIONS(3915),
    [anon_sym_u_SQUOTE] = ACTIONS(3915),
    [anon_sym_U_SQUOTE] = ACTIONS(3915),
    [anon_sym_u8_SQUOTE] = ACTIONS(3915),
    [anon_sym_SQUOTE] = ACTIONS(3915),
    [anon_sym_L_DQUOTE] = ACTIONS(3915),
    [anon_sym_u_DQUOTE] = ACTIONS(3915),
    [anon_sym_U_DQUOTE] = ACTIONS(3915),
    [anon_sym_u8_DQUOTE] = ACTIONS(3915),
    [anon_sym_DQUOTE] = ACTIONS(3915),
    [sym_true] = ACTIONS(3913),
    [sym_false] = ACTIONS(3913),
    [anon_sym_NULL] = ACTIONS(3913),
    [anon_sym_nullptr] = ACTIONS(3913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3913),
    [anon_sym_let] = ACTIONS(3913),
    [anon_sym_This] = ACTIONS(3913),
    [anon_sym_decltype] = ACTIONS(3913),
    [anon_sym_explicit] = ACTIONS(3913),
    [anon_sym_typename] = ACTIONS(3913),
    [anon_sym_template] = ACTIONS(3913),
    [anon_sym_operator] = ACTIONS(3913),
    [anon_sym_try] = ACTIONS(3913),
    [anon_sym_delete] = ACTIONS(3913),
    [anon_sym_throw] = ACTIONS(3913),
    [anon_sym_namespace] = ACTIONS(3913),
    [anon_sym_static_assert] = ACTIONS(3913),
    [anon_sym_concept] = ACTIONS(3913),
    [anon_sym_co_return] = ACTIONS(3913),
    [anon_sym_co_yield] = ACTIONS(3913),
    [anon_sym_R_DQUOTE] = ACTIONS(3915),
    [anon_sym_LR_DQUOTE] = ACTIONS(3915),
    [anon_sym_uR_DQUOTE] = ACTIONS(3915),
    [anon_sym_UR_DQUOTE] = ACTIONS(3915),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3915),
    [anon_sym_co_await] = ACTIONS(3913),
    [anon_sym_new] = ACTIONS(3913),
    [anon_sym_requires] = ACTIONS(3913),
    [sym_this] = ACTIONS(3913),
    [anon_sym_discard] = ACTIONS(3913),
    [anon_sym_precise] = ACTIONS(3913),
    [anon_sym_shared] = ACTIONS(3913),
    [anon_sym_groupshared] = ACTIONS(3913),
    [anon_sym_uniform] = ACTIONS(3913),
    [anon_sym_row_major] = ACTIONS(3913),
    [anon_sym_column_major] = ACTIONS(3913),
    [anon_sym_globallycoherent] = ACTIONS(3913),
    [anon_sym_centroid] = ACTIONS(3913),
    [anon_sym_noperspective] = ACTIONS(3913),
    [anon_sym_nointerpolation] = ACTIONS(3913),
    [anon_sym_sample] = ACTIONS(3913),
    [anon_sym_linear] = ACTIONS(3913),
    [anon_sym_snorm] = ACTIONS(3913),
    [anon_sym_unorm] = ACTIONS(3913),
    [anon_sym_point] = ACTIONS(3913),
    [anon_sym_line] = ACTIONS(3913),
    [anon_sym_triangleadj] = ACTIONS(3913),
    [anon_sym_lineadj] = ACTIONS(3913),
    [anon_sym_triangle] = ACTIONS(3913),
    [anon_sym_cbuffer] = ACTIONS(3913),
    [anon_sym_interface] = ACTIONS(3913),
    [anon_sym_extension] = ACTIONS(3913),
  },
  [1151] = {
    [sym_identifier] = ACTIONS(3845),
    [aux_sym_preproc_include_token1] = ACTIONS(3845),
    [aux_sym_preproc_def_token1] = ACTIONS(3845),
    [aux_sym_preproc_if_token1] = ACTIONS(3845),
    [aux_sym_preproc_if_token2] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3845),
    [sym_preproc_directive] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3847),
    [anon_sym_BANG] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3845),
    [anon_sym_STAR] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_SEMI] = ACTIONS(3847),
    [anon_sym___extension__] = ACTIONS(3845),
    [anon_sym_typedef] = ACTIONS(3845),
    [anon_sym_in] = ACTIONS(3845),
    [anon_sym_out] = ACTIONS(3845),
    [anon_sym_inout] = ACTIONS(3845),
    [anon_sym_virtual] = ACTIONS(3845),
    [anon_sym_extern] = ACTIONS(3845),
    [anon_sym___attribute__] = ACTIONS(3845),
    [anon_sym___attribute] = ACTIONS(3845),
    [anon_sym_using] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3847),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3847),
    [anon_sym___declspec] = ACTIONS(3845),
    [anon_sym___based] = ACTIONS(3845),
    [anon_sym___cdecl] = ACTIONS(3845),
    [anon_sym___clrcall] = ACTIONS(3845),
    [anon_sym___stdcall] = ACTIONS(3845),
    [anon_sym___fastcall] = ACTIONS(3845),
    [anon_sym___thiscall] = ACTIONS(3845),
    [anon_sym___vectorcall] = ACTIONS(3845),
    [anon_sym_LBRACE] = ACTIONS(3847),
    [anon_sym_signed] = ACTIONS(3845),
    [anon_sym_unsigned] = ACTIONS(3845),
    [anon_sym_long] = ACTIONS(3845),
    [anon_sym_short] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_static] = ACTIONS(3845),
    [anon_sym_register] = ACTIONS(3845),
    [anon_sym_inline] = ACTIONS(3845),
    [anon_sym___inline] = ACTIONS(3845),
    [anon_sym___inline__] = ACTIONS(3845),
    [anon_sym___forceinline] = ACTIONS(3845),
    [anon_sym_thread_local] = ACTIONS(3845),
    [anon_sym___thread] = ACTIONS(3845),
    [anon_sym_const] = ACTIONS(3845),
    [anon_sym_constexpr] = ACTIONS(3845),
    [anon_sym_volatile] = ACTIONS(3845),
    [anon_sym_restrict] = ACTIONS(3845),
    [anon_sym___restrict__] = ACTIONS(3845),
    [anon_sym__Atomic] = ACTIONS(3845),
    [anon_sym__Noreturn] = ACTIONS(3845),
    [anon_sym_noreturn] = ACTIONS(3845),
    [anon_sym__Nonnull] = ACTIONS(3845),
    [anon_sym_mutable] = ACTIONS(3845),
    [anon_sym_constinit] = ACTIONS(3845),
    [anon_sym_consteval] = ACTIONS(3845),
    [anon_sym_alignas] = ACTIONS(3845),
    [anon_sym__Alignas] = ACTIONS(3845),
    [sym_primitive_type] = ACTIONS(3845),
    [anon_sym_enum] = ACTIONS(3845),
    [anon_sym_class] = ACTIONS(3845),
    [anon_sym_struct] = ACTIONS(3845),
    [anon_sym_union] = ACTIONS(3845),
    [anon_sym_if] = ACTIONS(3845),
    [anon_sym_switch] = ACTIONS(3845),
    [anon_sym_case] = ACTIONS(3845),
    [anon_sym_default] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3845),
    [anon_sym_do] = ACTIONS(3845),
    [anon_sym_for] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3845),
    [anon_sym_break] = ACTIONS(3845),
    [anon_sym_continue] = ACTIONS(3845),
    [anon_sym_goto] = ACTIONS(3845),
    [anon_sym___try] = ACTIONS(3845),
    [anon_sym___leave] = ACTIONS(3845),
    [anon_sym_not] = ACTIONS(3845),
    [anon_sym_compl] = ACTIONS(3845),
    [anon_sym_DASH_DASH] = ACTIONS(3847),
    [anon_sym_PLUS_PLUS] = ACTIONS(3847),
    [anon_sym_sizeof] = ACTIONS(3845),
    [anon_sym___alignof__] = ACTIONS(3845),
    [anon_sym___alignof] = ACTIONS(3845),
    [anon_sym__alignof] = ACTIONS(3845),
    [anon_sym_alignof] = ACTIONS(3845),
    [anon_sym__Alignof] = ACTIONS(3845),
    [anon_sym_offsetof] = ACTIONS(3845),
    [anon_sym__Generic] = ACTIONS(3845),
    [anon_sym_asm] = ACTIONS(3845),
    [anon_sym___asm__] = ACTIONS(3845),
    [anon_sym___asm] = ACTIONS(3845),
    [sym_number_literal] = ACTIONS(3847),
    [anon_sym_L_SQUOTE] = ACTIONS(3847),
    [anon_sym_u_SQUOTE] = ACTIONS(3847),
    [anon_sym_U_SQUOTE] = ACTIONS(3847),
    [anon_sym_u8_SQUOTE] = ACTIONS(3847),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [anon_sym_L_DQUOTE] = ACTIONS(3847),
    [anon_sym_u_DQUOTE] = ACTIONS(3847),
    [anon_sym_U_DQUOTE] = ACTIONS(3847),
    [anon_sym_u8_DQUOTE] = ACTIONS(3847),
    [anon_sym_DQUOTE] = ACTIONS(3847),
    [sym_true] = ACTIONS(3845),
    [sym_false] = ACTIONS(3845),
    [anon_sym_NULL] = ACTIONS(3845),
    [anon_sym_nullptr] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_This] = ACTIONS(3845),
    [anon_sym_decltype] = ACTIONS(3845),
    [anon_sym_explicit] = ACTIONS(3845),
    [anon_sym_typename] = ACTIONS(3845),
    [anon_sym_template] = ACTIONS(3845),
    [anon_sym_operator] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3845),
    [anon_sym_delete] = ACTIONS(3845),
    [anon_sym_throw] = ACTIONS(3845),
    [anon_sym_namespace] = ACTIONS(3845),
    [anon_sym_static_assert] = ACTIONS(3845),
    [anon_sym_concept] = ACTIONS(3845),
    [anon_sym_co_return] = ACTIONS(3845),
    [anon_sym_co_yield] = ACTIONS(3845),
    [anon_sym_R_DQUOTE] = ACTIONS(3847),
    [anon_sym_LR_DQUOTE] = ACTIONS(3847),
    [anon_sym_uR_DQUOTE] = ACTIONS(3847),
    [anon_sym_UR_DQUOTE] = ACTIONS(3847),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3847),
    [anon_sym_co_await] = ACTIONS(3845),
    [anon_sym_new] = ACTIONS(3845),
    [anon_sym_requires] = ACTIONS(3845),
    [sym_this] = ACTIONS(3845),
    [anon_sym_discard] = ACTIONS(3845),
    [anon_sym_precise] = ACTIONS(3845),
    [anon_sym_shared] = ACTIONS(3845),
    [anon_sym_groupshared] = ACTIONS(3845),
    [anon_sym_uniform] = ACTIONS(3845),
    [anon_sym_row_major] = ACTIONS(3845),
    [anon_sym_column_major] = ACTIONS(3845),
    [anon_sym_globallycoherent] = ACTIONS(3845),
    [anon_sym_centroid] = ACTIONS(3845),
    [anon_sym_noperspective] = ACTIONS(3845),
    [anon_sym_nointerpolation] = ACTIONS(3845),
    [anon_sym_sample] = ACTIONS(3845),
    [anon_sym_linear] = ACTIONS(3845),
    [anon_sym_snorm] = ACTIONS(3845),
    [anon_sym_unorm] = ACTIONS(3845),
    [anon_sym_point] = ACTIONS(3845),
    [anon_sym_line] = ACTIONS(3845),
    [anon_sym_triangleadj] = ACTIONS(3845),
    [anon_sym_lineadj] = ACTIONS(3845),
    [anon_sym_triangle] = ACTIONS(3845),
    [anon_sym_cbuffer] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3845),
    [anon_sym_extension] = ACTIONS(3845),
  },
  [1152] = {
    [sym_identifier] = ACTIONS(3767),
    [aux_sym_preproc_include_token1] = ACTIONS(3767),
    [aux_sym_preproc_def_token1] = ACTIONS(3767),
    [aux_sym_preproc_if_token1] = ACTIONS(3767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3767),
    [sym_preproc_directive] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3769),
    [anon_sym_BANG] = ACTIONS(3769),
    [anon_sym_TILDE] = ACTIONS(3769),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_AMP_AMP] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3767),
    [anon_sym_SEMI] = ACTIONS(3769),
    [anon_sym___extension__] = ACTIONS(3767),
    [anon_sym_typedef] = ACTIONS(3767),
    [anon_sym_in] = ACTIONS(3767),
    [anon_sym_out] = ACTIONS(3767),
    [anon_sym_inout] = ACTIONS(3767),
    [anon_sym_virtual] = ACTIONS(3767),
    [anon_sym_extern] = ACTIONS(3767),
    [anon_sym___attribute__] = ACTIONS(3767),
    [anon_sym___attribute] = ACTIONS(3767),
    [anon_sym_using] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3769),
    [anon_sym___declspec] = ACTIONS(3767),
    [anon_sym___based] = ACTIONS(3767),
    [anon_sym___cdecl] = ACTIONS(3767),
    [anon_sym___clrcall] = ACTIONS(3767),
    [anon_sym___stdcall] = ACTIONS(3767),
    [anon_sym___fastcall] = ACTIONS(3767),
    [anon_sym___thiscall] = ACTIONS(3767),
    [anon_sym___vectorcall] = ACTIONS(3767),
    [anon_sym_LBRACE] = ACTIONS(3769),
    [anon_sym_RBRACE] = ACTIONS(3769),
    [anon_sym_signed] = ACTIONS(3767),
    [anon_sym_unsigned] = ACTIONS(3767),
    [anon_sym_long] = ACTIONS(3767),
    [anon_sym_short] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_static] = ACTIONS(3767),
    [anon_sym_register] = ACTIONS(3767),
    [anon_sym_inline] = ACTIONS(3767),
    [anon_sym___inline] = ACTIONS(3767),
    [anon_sym___inline__] = ACTIONS(3767),
    [anon_sym___forceinline] = ACTIONS(3767),
    [anon_sym_thread_local] = ACTIONS(3767),
    [anon_sym___thread] = ACTIONS(3767),
    [anon_sym_const] = ACTIONS(3767),
    [anon_sym_constexpr] = ACTIONS(3767),
    [anon_sym_volatile] = ACTIONS(3767),
    [anon_sym_restrict] = ACTIONS(3767),
    [anon_sym___restrict__] = ACTIONS(3767),
    [anon_sym__Atomic] = ACTIONS(3767),
    [anon_sym__Noreturn] = ACTIONS(3767),
    [anon_sym_noreturn] = ACTIONS(3767),
    [anon_sym__Nonnull] = ACTIONS(3767),
    [anon_sym_mutable] = ACTIONS(3767),
    [anon_sym_constinit] = ACTIONS(3767),
    [anon_sym_consteval] = ACTIONS(3767),
    [anon_sym_alignas] = ACTIONS(3767),
    [anon_sym__Alignas] = ACTIONS(3767),
    [sym_primitive_type] = ACTIONS(3767),
    [anon_sym_enum] = ACTIONS(3767),
    [anon_sym_class] = ACTIONS(3767),
    [anon_sym_struct] = ACTIONS(3767),
    [anon_sym_union] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_switch] = ACTIONS(3767),
    [anon_sym_case] = ACTIONS(3767),
    [anon_sym_default] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_break] = ACTIONS(3767),
    [anon_sym_continue] = ACTIONS(3767),
    [anon_sym_goto] = ACTIONS(3767),
    [anon_sym___try] = ACTIONS(3767),
    [anon_sym___leave] = ACTIONS(3767),
    [anon_sym_not] = ACTIONS(3767),
    [anon_sym_compl] = ACTIONS(3767),
    [anon_sym_DASH_DASH] = ACTIONS(3769),
    [anon_sym_PLUS_PLUS] = ACTIONS(3769),
    [anon_sym_sizeof] = ACTIONS(3767),
    [anon_sym___alignof__] = ACTIONS(3767),
    [anon_sym___alignof] = ACTIONS(3767),
    [anon_sym__alignof] = ACTIONS(3767),
    [anon_sym_alignof] = ACTIONS(3767),
    [anon_sym__Alignof] = ACTIONS(3767),
    [anon_sym_offsetof] = ACTIONS(3767),
    [anon_sym__Generic] = ACTIONS(3767),
    [anon_sym_asm] = ACTIONS(3767),
    [anon_sym___asm__] = ACTIONS(3767),
    [anon_sym___asm] = ACTIONS(3767),
    [sym_number_literal] = ACTIONS(3769),
    [anon_sym_L_SQUOTE] = ACTIONS(3769),
    [anon_sym_u_SQUOTE] = ACTIONS(3769),
    [anon_sym_U_SQUOTE] = ACTIONS(3769),
    [anon_sym_u8_SQUOTE] = ACTIONS(3769),
    [anon_sym_SQUOTE] = ACTIONS(3769),
    [anon_sym_L_DQUOTE] = ACTIONS(3769),
    [anon_sym_u_DQUOTE] = ACTIONS(3769),
    [anon_sym_U_DQUOTE] = ACTIONS(3769),
    [anon_sym_u8_DQUOTE] = ACTIONS(3769),
    [anon_sym_DQUOTE] = ACTIONS(3769),
    [sym_true] = ACTIONS(3767),
    [sym_false] = ACTIONS(3767),
    [anon_sym_NULL] = ACTIONS(3767),
    [anon_sym_nullptr] = ACTIONS(3767),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_This] = ACTIONS(3767),
    [anon_sym_decltype] = ACTIONS(3767),
    [anon_sym_explicit] = ACTIONS(3767),
    [anon_sym_typename] = ACTIONS(3767),
    [anon_sym_template] = ACTIONS(3767),
    [anon_sym_operator] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_delete] = ACTIONS(3767),
    [anon_sym_throw] = ACTIONS(3767),
    [anon_sym_namespace] = ACTIONS(3767),
    [anon_sym_static_assert] = ACTIONS(3767),
    [anon_sym_concept] = ACTIONS(3767),
    [anon_sym_co_return] = ACTIONS(3767),
    [anon_sym_co_yield] = ACTIONS(3767),
    [anon_sym_R_DQUOTE] = ACTIONS(3769),
    [anon_sym_LR_DQUOTE] = ACTIONS(3769),
    [anon_sym_uR_DQUOTE] = ACTIONS(3769),
    [anon_sym_UR_DQUOTE] = ACTIONS(3769),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3769),
    [anon_sym_co_await] = ACTIONS(3767),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_requires] = ACTIONS(3767),
    [sym_this] = ACTIONS(3767),
    [anon_sym_discard] = ACTIONS(3767),
    [anon_sym_precise] = ACTIONS(3767),
    [anon_sym_shared] = ACTIONS(3767),
    [anon_sym_groupshared] = ACTIONS(3767),
    [anon_sym_uniform] = ACTIONS(3767),
    [anon_sym_row_major] = ACTIONS(3767),
    [anon_sym_column_major] = ACTIONS(3767),
    [anon_sym_globallycoherent] = ACTIONS(3767),
    [anon_sym_centroid] = ACTIONS(3767),
    [anon_sym_noperspective] = ACTIONS(3767),
    [anon_sym_nointerpolation] = ACTIONS(3767),
    [anon_sym_sample] = ACTIONS(3767),
    [anon_sym_linear] = ACTIONS(3767),
    [anon_sym_snorm] = ACTIONS(3767),
    [anon_sym_unorm] = ACTIONS(3767),
    [anon_sym_point] = ACTIONS(3767),
    [anon_sym_line] = ACTIONS(3767),
    [anon_sym_triangleadj] = ACTIONS(3767),
    [anon_sym_lineadj] = ACTIONS(3767),
    [anon_sym_triangle] = ACTIONS(3767),
    [anon_sym_cbuffer] = ACTIONS(3767),
    [anon_sym_interface] = ACTIONS(3767),
    [anon_sym_extension] = ACTIONS(3767),
  },
  [1153] = {
    [sym_identifier] = ACTIONS(3669),
    [aux_sym_preproc_include_token1] = ACTIONS(3669),
    [aux_sym_preproc_def_token1] = ACTIONS(3669),
    [aux_sym_preproc_if_token1] = ACTIONS(3669),
    [aux_sym_preproc_if_token2] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3669),
    [sym_preproc_directive] = ACTIONS(3669),
    [anon_sym_LPAREN2] = ACTIONS(3671),
    [anon_sym_BANG] = ACTIONS(3671),
    [anon_sym_TILDE] = ACTIONS(3671),
    [anon_sym_DASH] = ACTIONS(3669),
    [anon_sym_PLUS] = ACTIONS(3669),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3671),
    [anon_sym_AMP] = ACTIONS(3669),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym___extension__] = ACTIONS(3669),
    [anon_sym_typedef] = ACTIONS(3669),
    [anon_sym_in] = ACTIONS(3669),
    [anon_sym_out] = ACTIONS(3669),
    [anon_sym_inout] = ACTIONS(3669),
    [anon_sym_virtual] = ACTIONS(3669),
    [anon_sym_extern] = ACTIONS(3669),
    [anon_sym___attribute__] = ACTIONS(3669),
    [anon_sym___attribute] = ACTIONS(3669),
    [anon_sym_using] = ACTIONS(3669),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3671),
    [anon_sym___declspec] = ACTIONS(3669),
    [anon_sym___based] = ACTIONS(3669),
    [anon_sym___cdecl] = ACTIONS(3669),
    [anon_sym___clrcall] = ACTIONS(3669),
    [anon_sym___stdcall] = ACTIONS(3669),
    [anon_sym___fastcall] = ACTIONS(3669),
    [anon_sym___thiscall] = ACTIONS(3669),
    [anon_sym___vectorcall] = ACTIONS(3669),
    [anon_sym_LBRACE] = ACTIONS(3671),
    [anon_sym_signed] = ACTIONS(3669),
    [anon_sym_unsigned] = ACTIONS(3669),
    [anon_sym_long] = ACTIONS(3669),
    [anon_sym_short] = ACTIONS(3669),
    [anon_sym_LBRACK] = ACTIONS(3669),
    [anon_sym_static] = ACTIONS(3669),
    [anon_sym_register] = ACTIONS(3669),
    [anon_sym_inline] = ACTIONS(3669),
    [anon_sym___inline] = ACTIONS(3669),
    [anon_sym___inline__] = ACTIONS(3669),
    [anon_sym___forceinline] = ACTIONS(3669),
    [anon_sym_thread_local] = ACTIONS(3669),
    [anon_sym___thread] = ACTIONS(3669),
    [anon_sym_const] = ACTIONS(3669),
    [anon_sym_constexpr] = ACTIONS(3669),
    [anon_sym_volatile] = ACTIONS(3669),
    [anon_sym_restrict] = ACTIONS(3669),
    [anon_sym___restrict__] = ACTIONS(3669),
    [anon_sym__Atomic] = ACTIONS(3669),
    [anon_sym__Noreturn] = ACTIONS(3669),
    [anon_sym_noreturn] = ACTIONS(3669),
    [anon_sym__Nonnull] = ACTIONS(3669),
    [anon_sym_mutable] = ACTIONS(3669),
    [anon_sym_constinit] = ACTIONS(3669),
    [anon_sym_consteval] = ACTIONS(3669),
    [anon_sym_alignas] = ACTIONS(3669),
    [anon_sym__Alignas] = ACTIONS(3669),
    [sym_primitive_type] = ACTIONS(3669),
    [anon_sym_enum] = ACTIONS(3669),
    [anon_sym_class] = ACTIONS(3669),
    [anon_sym_struct] = ACTIONS(3669),
    [anon_sym_union] = ACTIONS(3669),
    [anon_sym_if] = ACTIONS(3669),
    [anon_sym_switch] = ACTIONS(3669),
    [anon_sym_case] = ACTIONS(3669),
    [anon_sym_default] = ACTIONS(3669),
    [anon_sym_while] = ACTIONS(3669),
    [anon_sym_do] = ACTIONS(3669),
    [anon_sym_for] = ACTIONS(3669),
    [anon_sym_return] = ACTIONS(3669),
    [anon_sym_break] = ACTIONS(3669),
    [anon_sym_continue] = ACTIONS(3669),
    [anon_sym_goto] = ACTIONS(3669),
    [anon_sym___try] = ACTIONS(3669),
    [anon_sym___leave] = ACTIONS(3669),
    [anon_sym_not] = ACTIONS(3669),
    [anon_sym_compl] = ACTIONS(3669),
    [anon_sym_DASH_DASH] = ACTIONS(3671),
    [anon_sym_PLUS_PLUS] = ACTIONS(3671),
    [anon_sym_sizeof] = ACTIONS(3669),
    [anon_sym___alignof__] = ACTIONS(3669),
    [anon_sym___alignof] = ACTIONS(3669),
    [anon_sym__alignof] = ACTIONS(3669),
    [anon_sym_alignof] = ACTIONS(3669),
    [anon_sym__Alignof] = ACTIONS(3669),
    [anon_sym_offsetof] = ACTIONS(3669),
    [anon_sym__Generic] = ACTIONS(3669),
    [anon_sym_asm] = ACTIONS(3669),
    [anon_sym___asm__] = ACTIONS(3669),
    [anon_sym___asm] = ACTIONS(3669),
    [sym_number_literal] = ACTIONS(3671),
    [anon_sym_L_SQUOTE] = ACTIONS(3671),
    [anon_sym_u_SQUOTE] = ACTIONS(3671),
    [anon_sym_U_SQUOTE] = ACTIONS(3671),
    [anon_sym_u8_SQUOTE] = ACTIONS(3671),
    [anon_sym_SQUOTE] = ACTIONS(3671),
    [anon_sym_L_DQUOTE] = ACTIONS(3671),
    [anon_sym_u_DQUOTE] = ACTIONS(3671),
    [anon_sym_U_DQUOTE] = ACTIONS(3671),
    [anon_sym_u8_DQUOTE] = ACTIONS(3671),
    [anon_sym_DQUOTE] = ACTIONS(3671),
    [sym_true] = ACTIONS(3669),
    [sym_false] = ACTIONS(3669),
    [anon_sym_NULL] = ACTIONS(3669),
    [anon_sym_nullptr] = ACTIONS(3669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3669),
    [anon_sym_let] = ACTIONS(3669),
    [anon_sym_This] = ACTIONS(3669),
    [anon_sym_decltype] = ACTIONS(3669),
    [anon_sym_explicit] = ACTIONS(3669),
    [anon_sym_typename] = ACTIONS(3669),
    [anon_sym_template] = ACTIONS(3669),
    [anon_sym_operator] = ACTIONS(3669),
    [anon_sym_try] = ACTIONS(3669),
    [anon_sym_delete] = ACTIONS(3669),
    [anon_sym_throw] = ACTIONS(3669),
    [anon_sym_namespace] = ACTIONS(3669),
    [anon_sym_static_assert] = ACTIONS(3669),
    [anon_sym_concept] = ACTIONS(3669),
    [anon_sym_co_return] = ACTIONS(3669),
    [anon_sym_co_yield] = ACTIONS(3669),
    [anon_sym_R_DQUOTE] = ACTIONS(3671),
    [anon_sym_LR_DQUOTE] = ACTIONS(3671),
    [anon_sym_uR_DQUOTE] = ACTIONS(3671),
    [anon_sym_UR_DQUOTE] = ACTIONS(3671),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3671),
    [anon_sym_co_await] = ACTIONS(3669),
    [anon_sym_new] = ACTIONS(3669),
    [anon_sym_requires] = ACTIONS(3669),
    [sym_this] = ACTIONS(3669),
    [anon_sym_discard] = ACTIONS(3669),
    [anon_sym_precise] = ACTIONS(3669),
    [anon_sym_shared] = ACTIONS(3669),
    [anon_sym_groupshared] = ACTIONS(3669),
    [anon_sym_uniform] = ACTIONS(3669),
    [anon_sym_row_major] = ACTIONS(3669),
    [anon_sym_column_major] = ACTIONS(3669),
    [anon_sym_globallycoherent] = ACTIONS(3669),
    [anon_sym_centroid] = ACTIONS(3669),
    [anon_sym_noperspective] = ACTIONS(3669),
    [anon_sym_nointerpolation] = ACTIONS(3669),
    [anon_sym_sample] = ACTIONS(3669),
    [anon_sym_linear] = ACTIONS(3669),
    [anon_sym_snorm] = ACTIONS(3669),
    [anon_sym_unorm] = ACTIONS(3669),
    [anon_sym_point] = ACTIONS(3669),
    [anon_sym_line] = ACTIONS(3669),
    [anon_sym_triangleadj] = ACTIONS(3669),
    [anon_sym_lineadj] = ACTIONS(3669),
    [anon_sym_triangle] = ACTIONS(3669),
    [anon_sym_cbuffer] = ACTIONS(3669),
    [anon_sym_interface] = ACTIONS(3669),
    [anon_sym_extension] = ACTIONS(3669),
  },
  [1154] = {
    [sym_identifier] = ACTIONS(3909),
    [aux_sym_preproc_include_token1] = ACTIONS(3909),
    [aux_sym_preproc_def_token1] = ACTIONS(3909),
    [aux_sym_preproc_if_token1] = ACTIONS(3909),
    [aux_sym_preproc_if_token2] = ACTIONS(3909),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3909),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3909),
    [sym_preproc_directive] = ACTIONS(3909),
    [anon_sym_LPAREN2] = ACTIONS(3911),
    [anon_sym_BANG] = ACTIONS(3911),
    [anon_sym_TILDE] = ACTIONS(3911),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_SEMI] = ACTIONS(3911),
    [anon_sym___extension__] = ACTIONS(3909),
    [anon_sym_typedef] = ACTIONS(3909),
    [anon_sym_in] = ACTIONS(3909),
    [anon_sym_out] = ACTIONS(3909),
    [anon_sym_inout] = ACTIONS(3909),
    [anon_sym_virtual] = ACTIONS(3909),
    [anon_sym_extern] = ACTIONS(3909),
    [anon_sym___attribute__] = ACTIONS(3909),
    [anon_sym___attribute] = ACTIONS(3909),
    [anon_sym_using] = ACTIONS(3909),
    [anon_sym_COLON_COLON] = ACTIONS(3911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3911),
    [anon_sym___declspec] = ACTIONS(3909),
    [anon_sym___based] = ACTIONS(3909),
    [anon_sym___cdecl] = ACTIONS(3909),
    [anon_sym___clrcall] = ACTIONS(3909),
    [anon_sym___stdcall] = ACTIONS(3909),
    [anon_sym___fastcall] = ACTIONS(3909),
    [anon_sym___thiscall] = ACTIONS(3909),
    [anon_sym___vectorcall] = ACTIONS(3909),
    [anon_sym_LBRACE] = ACTIONS(3911),
    [anon_sym_signed] = ACTIONS(3909),
    [anon_sym_unsigned] = ACTIONS(3909),
    [anon_sym_long] = ACTIONS(3909),
    [anon_sym_short] = ACTIONS(3909),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_static] = ACTIONS(3909),
    [anon_sym_register] = ACTIONS(3909),
    [anon_sym_inline] = ACTIONS(3909),
    [anon_sym___inline] = ACTIONS(3909),
    [anon_sym___inline__] = ACTIONS(3909),
    [anon_sym___forceinline] = ACTIONS(3909),
    [anon_sym_thread_local] = ACTIONS(3909),
    [anon_sym___thread] = ACTIONS(3909),
    [anon_sym_const] = ACTIONS(3909),
    [anon_sym_constexpr] = ACTIONS(3909),
    [anon_sym_volatile] = ACTIONS(3909),
    [anon_sym_restrict] = ACTIONS(3909),
    [anon_sym___restrict__] = ACTIONS(3909),
    [anon_sym__Atomic] = ACTIONS(3909),
    [anon_sym__Noreturn] = ACTIONS(3909),
    [anon_sym_noreturn] = ACTIONS(3909),
    [anon_sym__Nonnull] = ACTIONS(3909),
    [anon_sym_mutable] = ACTIONS(3909),
    [anon_sym_constinit] = ACTIONS(3909),
    [anon_sym_consteval] = ACTIONS(3909),
    [anon_sym_alignas] = ACTIONS(3909),
    [anon_sym__Alignas] = ACTIONS(3909),
    [sym_primitive_type] = ACTIONS(3909),
    [anon_sym_enum] = ACTIONS(3909),
    [anon_sym_class] = ACTIONS(3909),
    [anon_sym_struct] = ACTIONS(3909),
    [anon_sym_union] = ACTIONS(3909),
    [anon_sym_if] = ACTIONS(3909),
    [anon_sym_switch] = ACTIONS(3909),
    [anon_sym_case] = ACTIONS(3909),
    [anon_sym_default] = ACTIONS(3909),
    [anon_sym_while] = ACTIONS(3909),
    [anon_sym_do] = ACTIONS(3909),
    [anon_sym_for] = ACTIONS(3909),
    [anon_sym_return] = ACTIONS(3909),
    [anon_sym_break] = ACTIONS(3909),
    [anon_sym_continue] = ACTIONS(3909),
    [anon_sym_goto] = ACTIONS(3909),
    [anon_sym___try] = ACTIONS(3909),
    [anon_sym___leave] = ACTIONS(3909),
    [anon_sym_not] = ACTIONS(3909),
    [anon_sym_compl] = ACTIONS(3909),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_sizeof] = ACTIONS(3909),
    [anon_sym___alignof__] = ACTIONS(3909),
    [anon_sym___alignof] = ACTIONS(3909),
    [anon_sym__alignof] = ACTIONS(3909),
    [anon_sym_alignof] = ACTIONS(3909),
    [anon_sym__Alignof] = ACTIONS(3909),
    [anon_sym_offsetof] = ACTIONS(3909),
    [anon_sym__Generic] = ACTIONS(3909),
    [anon_sym_asm] = ACTIONS(3909),
    [anon_sym___asm__] = ACTIONS(3909),
    [anon_sym___asm] = ACTIONS(3909),
    [sym_number_literal] = ACTIONS(3911),
    [anon_sym_L_SQUOTE] = ACTIONS(3911),
    [anon_sym_u_SQUOTE] = ACTIONS(3911),
    [anon_sym_U_SQUOTE] = ACTIONS(3911),
    [anon_sym_u8_SQUOTE] = ACTIONS(3911),
    [anon_sym_SQUOTE] = ACTIONS(3911),
    [anon_sym_L_DQUOTE] = ACTIONS(3911),
    [anon_sym_u_DQUOTE] = ACTIONS(3911),
    [anon_sym_U_DQUOTE] = ACTIONS(3911),
    [anon_sym_u8_DQUOTE] = ACTIONS(3911),
    [anon_sym_DQUOTE] = ACTIONS(3911),
    [sym_true] = ACTIONS(3909),
    [sym_false] = ACTIONS(3909),
    [anon_sym_NULL] = ACTIONS(3909),
    [anon_sym_nullptr] = ACTIONS(3909),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3909),
    [anon_sym_let] = ACTIONS(3909),
    [anon_sym_This] = ACTIONS(3909),
    [anon_sym_decltype] = ACTIONS(3909),
    [anon_sym_explicit] = ACTIONS(3909),
    [anon_sym_typename] = ACTIONS(3909),
    [anon_sym_template] = ACTIONS(3909),
    [anon_sym_operator] = ACTIONS(3909),
    [anon_sym_try] = ACTIONS(3909),
    [anon_sym_delete] = ACTIONS(3909),
    [anon_sym_throw] = ACTIONS(3909),
    [anon_sym_namespace] = ACTIONS(3909),
    [anon_sym_static_assert] = ACTIONS(3909),
    [anon_sym_concept] = ACTIONS(3909),
    [anon_sym_co_return] = ACTIONS(3909),
    [anon_sym_co_yield] = ACTIONS(3909),
    [anon_sym_R_DQUOTE] = ACTIONS(3911),
    [anon_sym_LR_DQUOTE] = ACTIONS(3911),
    [anon_sym_uR_DQUOTE] = ACTIONS(3911),
    [anon_sym_UR_DQUOTE] = ACTIONS(3911),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3911),
    [anon_sym_co_await] = ACTIONS(3909),
    [anon_sym_new] = ACTIONS(3909),
    [anon_sym_requires] = ACTIONS(3909),
    [sym_this] = ACTIONS(3909),
    [anon_sym_discard] = ACTIONS(3909),
    [anon_sym_precise] = ACTIONS(3909),
    [anon_sym_shared] = ACTIONS(3909),
    [anon_sym_groupshared] = ACTIONS(3909),
    [anon_sym_uniform] = ACTIONS(3909),
    [anon_sym_row_major] = ACTIONS(3909),
    [anon_sym_column_major] = ACTIONS(3909),
    [anon_sym_globallycoherent] = ACTIONS(3909),
    [anon_sym_centroid] = ACTIONS(3909),
    [anon_sym_noperspective] = ACTIONS(3909),
    [anon_sym_nointerpolation] = ACTIONS(3909),
    [anon_sym_sample] = ACTIONS(3909),
    [anon_sym_linear] = ACTIONS(3909),
    [anon_sym_snorm] = ACTIONS(3909),
    [anon_sym_unorm] = ACTIONS(3909),
    [anon_sym_point] = ACTIONS(3909),
    [anon_sym_line] = ACTIONS(3909),
    [anon_sym_triangleadj] = ACTIONS(3909),
    [anon_sym_lineadj] = ACTIONS(3909),
    [anon_sym_triangle] = ACTIONS(3909),
    [anon_sym_cbuffer] = ACTIONS(3909),
    [anon_sym_interface] = ACTIONS(3909),
    [anon_sym_extension] = ACTIONS(3909),
  },
  [1155] = {
    [sym__declaration_modifiers] = STATE(2662),
    [sym__declaration_specifiers] = STATE(8124),
    [sym_attribute_specifier] = STATE(2662),
    [sym_attribute_declaration] = STATE(2662),
    [sym_ms_declspec_modifier] = STATE(2662),
    [sym_storage_class_specifier] = STATE(2662),
    [sym_type_qualifier] = STATE(2662),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3136),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2662),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2662),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3101),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym_COMMA] = ACTIONS(4403),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_TILDE] = ACTIONS(4403),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4405),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4405),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_CARET] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4405),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4405),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(4407),
    [anon_sym_out] = ACTIONS(4407),
    [anon_sym_inout] = ACTIONS(4407),
    [anon_sym_virtual] = ACTIONS(4407),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(4411),
    [anon_sym_unsigned] = ACTIONS(4411),
    [anon_sym_long] = ACTIONS(4411),
    [anon_sym_short] = ACTIONS(4411),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_EQ] = ACTIONS(4405),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(4413),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [anon_sym_STAR_EQ] = ACTIONS(4403),
    [anon_sym_SLASH_EQ] = ACTIONS(4403),
    [anon_sym_PERCENT_EQ] = ACTIONS(4403),
    [anon_sym_PLUS_EQ] = ACTIONS(4403),
    [anon_sym_DASH_EQ] = ACTIONS(4403),
    [anon_sym_LT_LT_EQ] = ACTIONS(4403),
    [anon_sym_GT_GT_EQ] = ACTIONS(4403),
    [anon_sym_AMP_EQ] = ACTIONS(4403),
    [anon_sym_CARET_EQ] = ACTIONS(4403),
    [anon_sym_PIPE_EQ] = ACTIONS(4403),
    [anon_sym_and_eq] = ACTIONS(4405),
    [anon_sym_or_eq] = ACTIONS(4405),
    [anon_sym_xor_eq] = ACTIONS(4405),
    [anon_sym_not] = ACTIONS(4405),
    [anon_sym_compl] = ACTIONS(4405),
    [anon_sym_LT_EQ_GT] = ACTIONS(4403),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_bitor] = ACTIONS(4405),
    [anon_sym_xor] = ACTIONS(4405),
    [anon_sym_bitand] = ACTIONS(4405),
    [anon_sym_not_eq] = ACTIONS(4405),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_GT] = ACTIONS(4405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(4415),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4417),
    [anon_sym_co_await] = ACTIONS(4405),
    [anon_sym_new] = ACTIONS(4417),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4403),
    [anon_sym_LPAREN_RPAREN] = ACTIONS(4403),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4403),
    [anon_sym_DQUOTE_DQUOTE] = ACTIONS(4419),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
  },
  [1156] = {
    [sym__declaration_modifiers] = STATE(2662),
    [sym__declaration_specifiers] = STATE(8124),
    [sym_attribute_specifier] = STATE(2662),
    [sym_attribute_declaration] = STATE(2662),
    [sym_ms_declspec_modifier] = STATE(2662),
    [sym_storage_class_specifier] = STATE(2662),
    [sym_type_qualifier] = STATE(2662),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3136),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2662),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2662),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3101),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym_COMMA] = ACTIONS(4421),
    [anon_sym_BANG] = ACTIONS(4423),
    [anon_sym_TILDE] = ACTIONS(4421),
    [anon_sym_DASH] = ACTIONS(4423),
    [anon_sym_PLUS] = ACTIONS(4423),
    [anon_sym_STAR] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(4423),
    [anon_sym_PERCENT] = ACTIONS(4423),
    [anon_sym_PIPE_PIPE] = ACTIONS(4421),
    [anon_sym_AMP_AMP] = ACTIONS(4421),
    [anon_sym_PIPE] = ACTIONS(4423),
    [anon_sym_CARET] = ACTIONS(4423),
    [anon_sym_AMP] = ACTIONS(4423),
    [anon_sym_EQ_EQ] = ACTIONS(4421),
    [anon_sym_BANG_EQ] = ACTIONS(4421),
    [anon_sym_GT] = ACTIONS(4423),
    [anon_sym_GT_EQ] = ACTIONS(4421),
    [anon_sym_LT_EQ] = ACTIONS(4423),
    [anon_sym_LT] = ACTIONS(4423),
    [anon_sym_LT_LT] = ACTIONS(4423),
    [anon_sym_GT_GT] = ACTIONS(4423),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(4407),
    [anon_sym_out] = ACTIONS(4407),
    [anon_sym_inout] = ACTIONS(4407),
    [anon_sym_virtual] = ACTIONS(4407),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(4411),
    [anon_sym_unsigned] = ACTIONS(4411),
    [anon_sym_long] = ACTIONS(4411),
    [anon_sym_short] = ACTIONS(4411),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_EQ] = ACTIONS(4423),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(4413),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [anon_sym_STAR_EQ] = ACTIONS(4421),
    [anon_sym_SLASH_EQ] = ACTIONS(4421),
    [anon_sym_PERCENT_EQ] = ACTIONS(4421),
    [anon_sym_PLUS_EQ] = ACTIONS(4421),
    [anon_sym_DASH_EQ] = ACTIONS(4421),
    [anon_sym_LT_LT_EQ] = ACTIONS(4421),
    [anon_sym_GT_GT_EQ] = ACTIONS(4421),
    [anon_sym_AMP_EQ] = ACTIONS(4421),
    [anon_sym_CARET_EQ] = ACTIONS(4421),
    [anon_sym_PIPE_EQ] = ACTIONS(4421),
    [anon_sym_and_eq] = ACTIONS(4423),
    [anon_sym_or_eq] = ACTIONS(4423),
    [anon_sym_xor_eq] = ACTIONS(4423),
    [anon_sym_not] = ACTIONS(4423),
    [anon_sym_compl] = ACTIONS(4423),
    [anon_sym_LT_EQ_GT] = ACTIONS(4421),
    [anon_sym_or] = ACTIONS(4423),
    [anon_sym_and] = ACTIONS(4423),
    [anon_sym_bitor] = ACTIONS(4423),
    [anon_sym_xor] = ACTIONS(4423),
    [anon_sym_bitand] = ACTIONS(4423),
    [anon_sym_not_eq] = ACTIONS(4423),
    [anon_sym_DASH_DASH] = ACTIONS(4421),
    [anon_sym_PLUS_PLUS] = ACTIONS(4421),
    [anon_sym_DASH_GT] = ACTIONS(4423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(4415),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4425),
    [anon_sym_co_await] = ACTIONS(4423),
    [anon_sym_new] = ACTIONS(4425),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4421),
    [anon_sym_LPAREN_RPAREN] = ACTIONS(4421),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4421),
    [anon_sym_DQUOTE_DQUOTE] = ACTIONS(4427),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
  },
  [1157] = {
    [sym_compound_statement] = STATE(11152),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3789),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11152),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(11492),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(11567),
    [sym__unary_right_fold] = STATE(11568),
    [sym__binary_fold] = STATE(11569),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(10925),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1158] = {
    [sym_compound_statement] = STATE(11152),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3789),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11152),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(10809),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(10862),
    [sym__unary_right_fold] = STATE(10885),
    [sym__binary_fold] = STATE(10914),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(10925),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1159] = {
    [sym_compound_statement] = STATE(11152),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3789),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11152),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(11631),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(10862),
    [sym__unary_right_fold] = STATE(10885),
    [sym__binary_fold] = STATE(10914),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(10925),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1160] = {
    [sym_compound_statement] = STATE(11505),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3721),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11505),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(10796),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(10798),
    [sym__unary_right_fold] = STATE(10800),
    [sym__binary_fold] = STATE(10803),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(11555),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1161] = {
    [sym_compound_statement] = STATE(11505),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3721),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11505),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(11118),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(10798),
    [sym__unary_right_fold] = STATE(10800),
    [sym__binary_fold] = STATE(10803),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(11555),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1162] = {
    [sym_compound_statement] = STATE(11563),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3745),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11563),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(11674),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(10792),
    [sym__unary_right_fold] = STATE(10804),
    [sym__binary_fold] = STATE(10813),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(11571),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1163] = {
    [sym_compound_statement] = STATE(11563),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3745),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11563),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(11414),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(10792),
    [sym__unary_right_fold] = STATE(10804),
    [sym__binary_fold] = STATE(10813),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(11571),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1164] = {
    [sym_compound_statement] = STATE(11152),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3789),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11152),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(10867),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(11567),
    [sym__unary_right_fold] = STATE(11568),
    [sym__binary_fold] = STATE(11569),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(10925),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1165] = {
    [sym_compound_statement] = STATE(11152),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3789),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11152),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(10853),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(11567),
    [sym__unary_right_fold] = STATE(11568),
    [sym__binary_fold] = STATE(11569),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(10925),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1166] = {
    [sym_compound_statement] = STATE(11152),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3789),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11152),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(11566),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(11567),
    [sym__unary_right_fold] = STATE(11568),
    [sym__binary_fold] = STATE(11569),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(10925),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1167] = {
    [sym_compound_statement] = STATE(11152),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3789),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11152),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(11033),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(11567),
    [sym__unary_right_fold] = STATE(11568),
    [sym__binary_fold] = STATE(11569),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(10925),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1168] = {
    [sym_compound_statement] = STATE(11505),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3721),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11505),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(11515),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(11529),
    [sym__unary_right_fold] = STATE(11538),
    [sym__binary_fold] = STATE(11549),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(11555),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1169] = {
    [sym_compound_statement] = STATE(11152),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3789),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11152),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(11629),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(10862),
    [sym__unary_right_fold] = STATE(10885),
    [sym__binary_fold] = STATE(10914),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(10925),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1170] = {
    [sym_compound_statement] = STATE(11152),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3789),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11152),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(11123),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(10862),
    [sym__unary_right_fold] = STATE(10885),
    [sym__binary_fold] = STATE(10914),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(10925),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1171] = {
    [sym_compound_statement] = STATE(11152),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3789),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11152),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(10974),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(11567),
    [sym__unary_right_fold] = STATE(11568),
    [sym__binary_fold] = STATE(11569),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(10925),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1172] = {
    [sym_compound_statement] = STATE(11152),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3789),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11152),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(11270),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(10862),
    [sym__unary_right_fold] = STATE(10885),
    [sym__binary_fold] = STATE(10914),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(10925),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1173] = {
    [sym_compound_statement] = STATE(11152),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3789),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11152),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(10913),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(10862),
    [sym__unary_right_fold] = STATE(10885),
    [sym__binary_fold] = STATE(10914),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(10925),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1174] = {
    [sym_compound_statement] = STATE(11152),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3789),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11152),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(11303),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(10862),
    [sym__unary_right_fold] = STATE(10885),
    [sym__binary_fold] = STATE(10914),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(10925),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1175] = {
    [sym_compound_statement] = STATE(11152),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3789),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11152),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(11230),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(10862),
    [sym__unary_right_fold] = STATE(10885),
    [sym__binary_fold] = STATE(10914),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(10925),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1176] = {
    [sym_compound_statement] = STATE(11505),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3721),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11505),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(10886),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(11529),
    [sym__unary_right_fold] = STATE(11538),
    [sym__binary_fold] = STATE(11549),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(11555),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1177] = {
    [sym_compound_statement] = STATE(11563),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3745),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11563),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(11640),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(11157),
    [sym__unary_right_fold] = STATE(11175),
    [sym__binary_fold] = STATE(11179),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(11571),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1178] = {
    [sym_compound_statement] = STATE(11152),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3789),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11152),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(10952),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(10862),
    [sym__unary_right_fold] = STATE(10885),
    [sym__binary_fold] = STATE(10914),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(10925),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1179] = {
    [sym_compound_statement] = STATE(11152),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3789),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11152),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(11580),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(11567),
    [sym__unary_right_fold] = STATE(11568),
    [sym__binary_fold] = STATE(11569),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(10925),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1180] = {
    [sym_compound_statement] = STATE(11152),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3789),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11152),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(11173),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(11567),
    [sym__unary_right_fold] = STATE(11568),
    [sym__binary_fold] = STATE(11569),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(10925),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1181] = {
    [sym_compound_statement] = STATE(11563),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3745),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11563),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(11155),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(11157),
    [sym__unary_right_fold] = STATE(11175),
    [sym__binary_fold] = STATE(11179),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(11571),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1182] = {
    [sym_compound_statement] = STATE(11152),
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(3789),
    [sym__string] = STATE(4338),
    [sym_comma_expression] = STATE(11152),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_type_descriptor] = STATE(11251),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10441),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym__unary_left_fold] = STATE(10862),
    [sym__unary_right_fold] = STATE(10885),
    [sym__binary_fold] = STATE(10914),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7284),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym__assignment_expression_lhs] = STATE(10925),
    [sym_user_defined_literal] = STATE(4519),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(4429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2823),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1183] = {
    [sym_attribute_declaration] = STATE(1196),
    [sym_compound_statement] = STATE(857),
    [sym_attributed_statement] = STATE(857),
    [sym_statement] = STATE(864),
    [sym_labeled_statement] = STATE(857),
    [sym_expression_statement] = STATE(857),
    [sym_if_statement] = STATE(857),
    [sym_switch_statement] = STATE(857),
    [sym_case_statement] = STATE(857),
    [sym_while_statement] = STATE(857),
    [sym_do_statement] = STATE(857),
    [sym_for_statement] = STATE(857),
    [sym_return_statement] = STATE(857),
    [sym_break_statement] = STATE(857),
    [sym_continue_statement] = STATE(857),
    [sym_goto_statement] = STATE(857),
    [sym_seh_try_statement] = STATE(857),
    [sym_seh_leave_statement] = STATE(857),
    [sym_expression] = STATE(5773),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10871),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(857),
    [sym_co_return_statement] = STATE(857),
    [sym_co_yield_statement] = STATE(857),
    [sym_throw_statement] = STATE(857),
    [sym_try_statement] = STATE(857),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(857),
    [sym_cbuffer_specifier] = STATE(857),
    [sym_hlsl_attribute] = STATE(10474),
    [aux_sym_attributed_declarator_repeat1] = STATE(1196),
    [sym_identifier] = ACTIONS(4435),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1083),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_using] = ACTIONS(4439),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_case] = ACTIONS(1101),
    [anon_sym_default] = ACTIONS(1103),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1107),
    [anon_sym_for] = ACTIONS(1109),
    [anon_sym_return] = ACTIONS(1111),
    [anon_sym_break] = ACTIONS(1113),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_goto] = ACTIONS(1117),
    [anon_sym___try] = ACTIONS(1119),
    [anon_sym___leave] = ACTIONS(1121),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(1125),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_co_return] = ACTIONS(1135),
    [anon_sym_co_yield] = ACTIONS(1137),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1139),
    [anon_sym_cbuffer] = ACTIONS(1141),
  },
  [1184] = {
    [sym_function_definition] = STATE(2091),
    [sym_declaration] = STATE(2091),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6104),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2919),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2607),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2781),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__empty_declaration] = STATE(2091),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(2091),
    [sym_operator_cast] = STATE(9099),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(2091),
    [sym_operator_cast_declaration] = STATE(2091),
    [sym_constructor_or_destructor_definition] = STATE(2091),
    [sym_constructor_or_destructor_declaration] = STATE(2091),
    [sym_friend_declaration] = STATE(2091),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_alias_declaration] = STATE(2091),
    [sym_concept_definition] = STATE(2091),
    [sym_requires_clause] = STATE(1269),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6972),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_hlsl_attribute] = STATE(1643),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(4445),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(4447),
    [anon_sym_COLON_COLON] = ACTIONS(4449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(4451),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_concept] = ACTIONS(4453),
    [anon_sym_requires] = ACTIONS(4455),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1185] = {
    [sym_function_definition] = STATE(2239),
    [sym_declaration] = STATE(2239),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6111),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2919),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2613),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7985),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2787),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__empty_declaration] = STATE(2239),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2676),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(2239),
    [sym_operator_cast] = STATE(9196),
    [sym__constructor_specifiers] = STATE(2676),
    [sym_operator_cast_definition] = STATE(2239),
    [sym_operator_cast_declaration] = STATE(2239),
    [sym_constructor_or_destructor_definition] = STATE(2239),
    [sym_constructor_or_destructor_declaration] = STATE(2239),
    [sym_friend_declaration] = STATE(2239),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_alias_declaration] = STATE(2239),
    [sym_concept_definition] = STATE(2239),
    [sym_requires_clause] = STATE(1266),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6972),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9196),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_hlsl_attribute] = STATE(1640),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2676),
    [sym_identifier] = ACTIONS(4445),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(4457),
    [anon_sym_COLON_COLON] = ACTIONS(4449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(4451),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3170),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(3172),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3174),
    [anon_sym_concept] = ACTIONS(4459),
    [anon_sym_requires] = ACTIONS(4455),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1186] = {
    [sym_attribute_declaration] = STATE(1186),
    [sym_compound_statement] = STATE(515),
    [sym_attributed_statement] = STATE(515),
    [sym_statement] = STATE(505),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(10675),
    [aux_sym_attributed_declarator_repeat1] = STATE(1186),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(4464),
    [anon_sym_BANG] = ACTIONS(4467),
    [anon_sym_TILDE] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4470),
    [anon_sym_PLUS] = ACTIONS(4470),
    [anon_sym_STAR] = ACTIONS(4473),
    [anon_sym_AMP] = ACTIONS(4473),
    [anon_sym_SEMI] = ACTIONS(4476),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_using] = ACTIONS(4482),
    [anon_sym_COLON_COLON] = ACTIONS(4484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4487),
    [anon_sym_LBRACE] = ACTIONS(4490),
    [anon_sym_LBRACK] = ACTIONS(4493),
    [sym_primitive_type] = ACTIONS(4496),
    [anon_sym_if] = ACTIONS(4499),
    [anon_sym_switch] = ACTIONS(4502),
    [anon_sym_case] = ACTIONS(4505),
    [anon_sym_default] = ACTIONS(4508),
    [anon_sym_while] = ACTIONS(4511),
    [anon_sym_do] = ACTIONS(4514),
    [anon_sym_for] = ACTIONS(4517),
    [anon_sym_return] = ACTIONS(4520),
    [anon_sym_break] = ACTIONS(4523),
    [anon_sym_continue] = ACTIONS(4526),
    [anon_sym_goto] = ACTIONS(4529),
    [anon_sym___try] = ACTIONS(4532),
    [anon_sym___leave] = ACTIONS(4535),
    [anon_sym_not] = ACTIONS(4470),
    [anon_sym_compl] = ACTIONS(4470),
    [anon_sym_DASH_DASH] = ACTIONS(4538),
    [anon_sym_PLUS_PLUS] = ACTIONS(4538),
    [anon_sym_sizeof] = ACTIONS(4541),
    [anon_sym___alignof__] = ACTIONS(4544),
    [anon_sym___alignof] = ACTIONS(4544),
    [anon_sym__alignof] = ACTIONS(4544),
    [anon_sym_alignof] = ACTIONS(4544),
    [anon_sym__Alignof] = ACTIONS(4544),
    [anon_sym_offsetof] = ACTIONS(4547),
    [anon_sym__Generic] = ACTIONS(4550),
    [anon_sym_asm] = ACTIONS(4553),
    [anon_sym___asm__] = ACTIONS(4553),
    [anon_sym___asm] = ACTIONS(4553),
    [sym_number_literal] = ACTIONS(4556),
    [anon_sym_L_SQUOTE] = ACTIONS(4559),
    [anon_sym_u_SQUOTE] = ACTIONS(4559),
    [anon_sym_U_SQUOTE] = ACTIONS(4559),
    [anon_sym_u8_SQUOTE] = ACTIONS(4559),
    [anon_sym_SQUOTE] = ACTIONS(4559),
    [anon_sym_L_DQUOTE] = ACTIONS(4562),
    [anon_sym_u_DQUOTE] = ACTIONS(4562),
    [anon_sym_U_DQUOTE] = ACTIONS(4562),
    [anon_sym_u8_DQUOTE] = ACTIONS(4562),
    [anon_sym_DQUOTE] = ACTIONS(4562),
    [sym_true] = ACTIONS(4565),
    [sym_false] = ACTIONS(4565),
    [anon_sym_NULL] = ACTIONS(4568),
    [anon_sym_nullptr] = ACTIONS(4568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4571),
    [anon_sym_template] = ACTIONS(4574),
    [anon_sym_try] = ACTIONS(4577),
    [anon_sym_delete] = ACTIONS(4580),
    [anon_sym_throw] = ACTIONS(4583),
    [anon_sym_co_return] = ACTIONS(4586),
    [anon_sym_co_yield] = ACTIONS(4589),
    [anon_sym_R_DQUOTE] = ACTIONS(4592),
    [anon_sym_LR_DQUOTE] = ACTIONS(4592),
    [anon_sym_uR_DQUOTE] = ACTIONS(4592),
    [anon_sym_UR_DQUOTE] = ACTIONS(4592),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4592),
    [anon_sym_co_await] = ACTIONS(4595),
    [anon_sym_new] = ACTIONS(4598),
    [anon_sym_requires] = ACTIONS(4601),
    [sym_this] = ACTIONS(4565),
    [anon_sym_discard] = ACTIONS(4604),
    [anon_sym_cbuffer] = ACTIONS(4607),
  },
  [1187] = {
    [sym_function_definition] = STATE(1103),
    [sym_declaration] = STATE(1103),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6100),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2919),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2234),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7927),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2791),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__empty_declaration] = STATE(1103),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2669),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(1103),
    [sym_operator_cast] = STATE(9025),
    [sym__constructor_specifiers] = STATE(2669),
    [sym_operator_cast_definition] = STATE(1103),
    [sym_operator_cast_declaration] = STATE(1103),
    [sym_constructor_or_destructor_definition] = STATE(1103),
    [sym_constructor_or_destructor_declaration] = STATE(1103),
    [sym_friend_declaration] = STATE(1103),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_alias_declaration] = STATE(1103),
    [sym_concept_definition] = STATE(1103),
    [sym_requires_clause] = STATE(1268),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6972),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9025),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_hlsl_attribute] = STATE(1636),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2669),
    [sym_identifier] = ACTIONS(4445),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(4610),
    [anon_sym_COLON_COLON] = ACTIONS(4449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(4451),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(4612),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(4614),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(4616),
    [anon_sym_concept] = ACTIONS(153),
    [anon_sym_requires] = ACTIONS(4455),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1188] = {
    [sym_attribute_declaration] = STATE(1186),
    [sym_compound_statement] = STATE(515),
    [sym_attributed_statement] = STATE(515),
    [sym_statement] = STATE(505),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(10675),
    [aux_sym_attributed_declarator_repeat1] = STATE(1186),
    [sym_identifier] = ACTIONS(4618),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_using] = ACTIONS(4620),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_cbuffer] = ACTIONS(365),
  },
  [1189] = {
    [sym_attribute_declaration] = STATE(1198),
    [sym_compound_statement] = STATE(480),
    [sym_attributed_statement] = STATE(480),
    [sym_statement] = STATE(443),
    [sym_labeled_statement] = STATE(480),
    [sym_expression_statement] = STATE(480),
    [sym_if_statement] = STATE(480),
    [sym_switch_statement] = STATE(480),
    [sym_case_statement] = STATE(480),
    [sym_while_statement] = STATE(480),
    [sym_do_statement] = STATE(480),
    [sym_for_statement] = STATE(480),
    [sym_return_statement] = STATE(480),
    [sym_break_statement] = STATE(480),
    [sym_continue_statement] = STATE(480),
    [sym_goto_statement] = STATE(480),
    [sym_seh_try_statement] = STATE(480),
    [sym_seh_leave_statement] = STATE(480),
    [sym_expression] = STATE(5655),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10869),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(480),
    [sym_co_return_statement] = STATE(480),
    [sym_co_yield_statement] = STATE(480),
    [sym_throw_statement] = STATE(480),
    [sym_try_statement] = STATE(480),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(480),
    [sym_cbuffer_specifier] = STATE(480),
    [sym_hlsl_attribute] = STATE(10450),
    [aux_sym_attributed_declarator_repeat1] = STATE(1198),
    [sym_identifier] = ACTIONS(4622),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_using] = ACTIONS(4624),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1157),
    [anon_sym___leave] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1165),
    [anon_sym_cbuffer] = ACTIONS(1167),
  },
  [1190] = {
    [sym_attribute_declaration] = STATE(1190),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(851),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10697),
    [aux_sym_attributed_declarator_repeat1] = STATE(1190),
    [sym_identifier] = ACTIONS(4626),
    [anon_sym_LPAREN2] = ACTIONS(4464),
    [anon_sym_BANG] = ACTIONS(4467),
    [anon_sym_TILDE] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4470),
    [anon_sym_PLUS] = ACTIONS(4470),
    [anon_sym_STAR] = ACTIONS(4473),
    [anon_sym_AMP] = ACTIONS(4473),
    [anon_sym_SEMI] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_using] = ACTIONS(4482),
    [anon_sym_COLON_COLON] = ACTIONS(4484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4487),
    [anon_sym_LBRACE] = ACTIONS(4632),
    [anon_sym_LBRACK] = ACTIONS(4493),
    [sym_primitive_type] = ACTIONS(4496),
    [anon_sym_if] = ACTIONS(4635),
    [anon_sym_switch] = ACTIONS(4638),
    [anon_sym_case] = ACTIONS(4641),
    [anon_sym_default] = ACTIONS(4644),
    [anon_sym_while] = ACTIONS(4647),
    [anon_sym_do] = ACTIONS(4650),
    [anon_sym_for] = ACTIONS(4653),
    [anon_sym_return] = ACTIONS(4656),
    [anon_sym_break] = ACTIONS(4659),
    [anon_sym_continue] = ACTIONS(4662),
    [anon_sym_goto] = ACTIONS(4665),
    [anon_sym___try] = ACTIONS(4668),
    [anon_sym___leave] = ACTIONS(4671),
    [anon_sym_not] = ACTIONS(4470),
    [anon_sym_compl] = ACTIONS(4470),
    [anon_sym_DASH_DASH] = ACTIONS(4538),
    [anon_sym_PLUS_PLUS] = ACTIONS(4538),
    [anon_sym_sizeof] = ACTIONS(4541),
    [anon_sym___alignof__] = ACTIONS(4544),
    [anon_sym___alignof] = ACTIONS(4544),
    [anon_sym__alignof] = ACTIONS(4544),
    [anon_sym_alignof] = ACTIONS(4544),
    [anon_sym__Alignof] = ACTIONS(4544),
    [anon_sym_offsetof] = ACTIONS(4547),
    [anon_sym__Generic] = ACTIONS(4550),
    [anon_sym_asm] = ACTIONS(4553),
    [anon_sym___asm__] = ACTIONS(4553),
    [anon_sym___asm] = ACTIONS(4553),
    [sym_number_literal] = ACTIONS(4556),
    [anon_sym_L_SQUOTE] = ACTIONS(4559),
    [anon_sym_u_SQUOTE] = ACTIONS(4559),
    [anon_sym_U_SQUOTE] = ACTIONS(4559),
    [anon_sym_u8_SQUOTE] = ACTIONS(4559),
    [anon_sym_SQUOTE] = ACTIONS(4559),
    [anon_sym_L_DQUOTE] = ACTIONS(4562),
    [anon_sym_u_DQUOTE] = ACTIONS(4562),
    [anon_sym_U_DQUOTE] = ACTIONS(4562),
    [anon_sym_u8_DQUOTE] = ACTIONS(4562),
    [anon_sym_DQUOTE] = ACTIONS(4562),
    [sym_true] = ACTIONS(4565),
    [sym_false] = ACTIONS(4565),
    [anon_sym_NULL] = ACTIONS(4568),
    [anon_sym_nullptr] = ACTIONS(4568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4571),
    [anon_sym_template] = ACTIONS(4574),
    [anon_sym_try] = ACTIONS(4674),
    [anon_sym_delete] = ACTIONS(4580),
    [anon_sym_throw] = ACTIONS(4677),
    [anon_sym_co_return] = ACTIONS(4680),
    [anon_sym_co_yield] = ACTIONS(4683),
    [anon_sym_R_DQUOTE] = ACTIONS(4592),
    [anon_sym_LR_DQUOTE] = ACTIONS(4592),
    [anon_sym_uR_DQUOTE] = ACTIONS(4592),
    [anon_sym_UR_DQUOTE] = ACTIONS(4592),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4592),
    [anon_sym_co_await] = ACTIONS(4595),
    [anon_sym_new] = ACTIONS(4598),
    [anon_sym_requires] = ACTIONS(4601),
    [sym_this] = ACTIONS(4565),
    [anon_sym_discard] = ACTIONS(4686),
    [anon_sym_cbuffer] = ACTIONS(4689),
  },
  [1191] = {
    [sym_function_definition] = STATE(915),
    [sym_declaration] = STATE(915),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6092),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2919),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2604),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7934),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__empty_declaration] = STATE(915),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2675),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(915),
    [sym_operator_cast] = STATE(9109),
    [sym__constructor_specifiers] = STATE(2675),
    [sym_operator_cast_definition] = STATE(915),
    [sym_operator_cast_declaration] = STATE(915),
    [sym_constructor_or_destructor_definition] = STATE(915),
    [sym_constructor_or_destructor_declaration] = STATE(915),
    [sym_friend_declaration] = STATE(915),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_alias_declaration] = STATE(915),
    [sym_concept_definition] = STATE(915),
    [sym_requires_clause] = STATE(1264),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6972),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9109),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_hlsl_attribute] = STATE(1642),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2675),
    [sym_identifier] = ACTIONS(4445),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(4692),
    [anon_sym_COLON_COLON] = ACTIONS(4449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(4451),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(4694),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(4696),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(4698),
    [anon_sym_concept] = ACTIONS(1133),
    [anon_sym_requires] = ACTIONS(4455),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1192] = {
    [sym_function_definition] = STATE(1139),
    [sym_declaration] = STATE(1139),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2919),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7999),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__empty_declaration] = STATE(1139),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2671),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(1139),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2671),
    [sym_operator_cast_definition] = STATE(1139),
    [sym_operator_cast_declaration] = STATE(1139),
    [sym_constructor_or_destructor_definition] = STATE(1139),
    [sym_constructor_or_destructor_declaration] = STATE(1139),
    [sym_friend_declaration] = STATE(1139),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_alias_declaration] = STATE(1139),
    [sym_concept_definition] = STATE(1139),
    [sym_requires_clause] = STATE(1263),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6972),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_hlsl_attribute] = STATE(1637),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(4445),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(4700),
    [anon_sym_COLON_COLON] = ACTIONS(4449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(4451),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(4702),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(4704),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(4706),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_requires] = ACTIONS(4455),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1193] = {
    [sym_function_definition] = STATE(599),
    [sym_declaration] = STATE(599),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2919),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2601),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7896),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2792),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__empty_declaration] = STATE(599),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2674),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(599),
    [sym_operator_cast] = STATE(9172),
    [sym__constructor_specifiers] = STATE(2674),
    [sym_operator_cast_definition] = STATE(599),
    [sym_operator_cast_declaration] = STATE(599),
    [sym_constructor_or_destructor_definition] = STATE(599),
    [sym_constructor_or_destructor_declaration] = STATE(599),
    [sym_friend_declaration] = STATE(599),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_alias_declaration] = STATE(599),
    [sym_concept_definition] = STATE(599),
    [sym_requires_clause] = STATE(1265),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6972),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9172),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_hlsl_attribute] = STATE(1645),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2674),
    [sym_identifier] = ACTIONS(4445),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(4708),
    [anon_sym_COLON_COLON] = ACTIONS(4449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(4451),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(4710),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(4712),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(4714),
    [anon_sym_concept] = ACTIONS(357),
    [anon_sym_requires] = ACTIONS(4455),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1194] = {
    [sym_identifier] = ACTIONS(4716),
    [anon_sym_COMMA] = ACTIONS(4718),
    [anon_sym_RPAREN] = ACTIONS(4718),
    [anon_sym_LPAREN2] = ACTIONS(4718),
    [anon_sym_BANG] = ACTIONS(4718),
    [anon_sym_TILDE] = ACTIONS(4718),
    [anon_sym_DASH] = ACTIONS(4716),
    [anon_sym_PLUS] = ACTIONS(4716),
    [anon_sym_STAR] = ACTIONS(4718),
    [anon_sym_AMP_AMP] = ACTIONS(4718),
    [anon_sym_AMP] = ACTIONS(4716),
    [anon_sym_SEMI] = ACTIONS(4718),
    [anon_sym___extension__] = ACTIONS(4716),
    [anon_sym_in] = ACTIONS(4716),
    [anon_sym_out] = ACTIONS(4716),
    [anon_sym_inout] = ACTIONS(4716),
    [anon_sym_virtual] = ACTIONS(4716),
    [anon_sym_extern] = ACTIONS(4716),
    [anon_sym___attribute__] = ACTIONS(4716),
    [anon_sym___attribute] = ACTIONS(4716),
    [anon_sym_using] = ACTIONS(4716),
    [anon_sym_COLON_COLON] = ACTIONS(4718),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4718),
    [anon_sym___declspec] = ACTIONS(4716),
    [anon_sym___based] = ACTIONS(4716),
    [anon_sym_LBRACE] = ACTIONS(4718),
    [anon_sym_signed] = ACTIONS(4716),
    [anon_sym_unsigned] = ACTIONS(4716),
    [anon_sym_long] = ACTIONS(4716),
    [anon_sym_short] = ACTIONS(4716),
    [anon_sym_LBRACK] = ACTIONS(4716),
    [anon_sym_static] = ACTIONS(4716),
    [anon_sym_RBRACK] = ACTIONS(4718),
    [anon_sym_EQ] = ACTIONS(4718),
    [anon_sym_register] = ACTIONS(4716),
    [anon_sym_inline] = ACTIONS(4716),
    [anon_sym___inline] = ACTIONS(4716),
    [anon_sym___inline__] = ACTIONS(4716),
    [anon_sym___forceinline] = ACTIONS(4716),
    [anon_sym_thread_local] = ACTIONS(4716),
    [anon_sym___thread] = ACTIONS(4716),
    [anon_sym_const] = ACTIONS(4716),
    [anon_sym_constexpr] = ACTIONS(4716),
    [anon_sym_volatile] = ACTIONS(4716),
    [anon_sym_restrict] = ACTIONS(4716),
    [anon_sym___restrict__] = ACTIONS(4716),
    [anon_sym__Atomic] = ACTIONS(4716),
    [anon_sym__Noreturn] = ACTIONS(4716),
    [anon_sym_noreturn] = ACTIONS(4716),
    [anon_sym__Nonnull] = ACTIONS(4716),
    [anon_sym_mutable] = ACTIONS(4716),
    [anon_sym_constinit] = ACTIONS(4716),
    [anon_sym_consteval] = ACTIONS(4716),
    [anon_sym_alignas] = ACTIONS(4716),
    [anon_sym__Alignas] = ACTIONS(4716),
    [sym_primitive_type] = ACTIONS(4716),
    [anon_sym_enum] = ACTIONS(4716),
    [anon_sym_class] = ACTIONS(4716),
    [anon_sym_struct] = ACTIONS(4716),
    [anon_sym_union] = ACTIONS(4716),
    [anon_sym_if] = ACTIONS(4716),
    [anon_sym_switch] = ACTIONS(4716),
    [anon_sym_case] = ACTIONS(4716),
    [anon_sym_default] = ACTIONS(4716),
    [anon_sym_while] = ACTIONS(4716),
    [anon_sym_do] = ACTIONS(4716),
    [anon_sym_for] = ACTIONS(4716),
    [anon_sym_return] = ACTIONS(4716),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_continue] = ACTIONS(4716),
    [anon_sym_goto] = ACTIONS(4716),
    [anon_sym___try] = ACTIONS(4716),
    [anon_sym___leave] = ACTIONS(4716),
    [anon_sym_not] = ACTIONS(4716),
    [anon_sym_compl] = ACTIONS(4716),
    [anon_sym_DASH_DASH] = ACTIONS(4718),
    [anon_sym_PLUS_PLUS] = ACTIONS(4718),
    [anon_sym_sizeof] = ACTIONS(4716),
    [anon_sym___alignof__] = ACTIONS(4716),
    [anon_sym___alignof] = ACTIONS(4716),
    [anon_sym__alignof] = ACTIONS(4716),
    [anon_sym_alignof] = ACTIONS(4716),
    [anon_sym__Alignof] = ACTIONS(4716),
    [anon_sym_offsetof] = ACTIONS(4716),
    [anon_sym__Generic] = ACTIONS(4716),
    [anon_sym_asm] = ACTIONS(4716),
    [anon_sym___asm__] = ACTIONS(4716),
    [anon_sym___asm] = ACTIONS(4716),
    [sym_number_literal] = ACTIONS(4718),
    [anon_sym_L_SQUOTE] = ACTIONS(4718),
    [anon_sym_u_SQUOTE] = ACTIONS(4718),
    [anon_sym_U_SQUOTE] = ACTIONS(4718),
    [anon_sym_u8_SQUOTE] = ACTIONS(4718),
    [anon_sym_SQUOTE] = ACTIONS(4718),
    [anon_sym_L_DQUOTE] = ACTIONS(4718),
    [anon_sym_u_DQUOTE] = ACTIONS(4718),
    [anon_sym_U_DQUOTE] = ACTIONS(4718),
    [anon_sym_u8_DQUOTE] = ACTIONS(4718),
    [anon_sym_DQUOTE] = ACTIONS(4718),
    [sym_true] = ACTIONS(4716),
    [sym_false] = ACTIONS(4716),
    [anon_sym_NULL] = ACTIONS(4716),
    [anon_sym_nullptr] = ACTIONS(4716),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4716),
    [anon_sym_let] = ACTIONS(4716),
    [anon_sym_This] = ACTIONS(4716),
    [anon_sym_decltype] = ACTIONS(4716),
    [anon_sym_explicit] = ACTIONS(4716),
    [anon_sym_typename] = ACTIONS(4716),
    [anon_sym_template] = ACTIONS(4716),
    [anon_sym_operator] = ACTIONS(4716),
    [anon_sym_try] = ACTIONS(4716),
    [anon_sym_delete] = ACTIONS(4716),
    [anon_sym_throw] = ACTIONS(4716),
    [anon_sym_co_return] = ACTIONS(4716),
    [anon_sym_co_yield] = ACTIONS(4716),
    [anon_sym_R_DQUOTE] = ACTIONS(4718),
    [anon_sym_LR_DQUOTE] = ACTIONS(4718),
    [anon_sym_uR_DQUOTE] = ACTIONS(4718),
    [anon_sym_UR_DQUOTE] = ACTIONS(4718),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4718),
    [anon_sym_co_await] = ACTIONS(4716),
    [anon_sym_new] = ACTIONS(4716),
    [anon_sym_requires] = ACTIONS(4716),
    [sym_this] = ACTIONS(4716),
    [anon_sym_discard] = ACTIONS(4716),
    [anon_sym_precise] = ACTIONS(4716),
    [anon_sym_shared] = ACTIONS(4716),
    [anon_sym_groupshared] = ACTIONS(4716),
    [anon_sym_uniform] = ACTIONS(4716),
    [anon_sym_row_major] = ACTIONS(4716),
    [anon_sym_column_major] = ACTIONS(4716),
    [anon_sym_globallycoherent] = ACTIONS(4716),
    [anon_sym_centroid] = ACTIONS(4716),
    [anon_sym_noperspective] = ACTIONS(4716),
    [anon_sym_nointerpolation] = ACTIONS(4716),
    [anon_sym_sample] = ACTIONS(4716),
    [anon_sym_linear] = ACTIONS(4716),
    [anon_sym_snorm] = ACTIONS(4716),
    [anon_sym_unorm] = ACTIONS(4716),
    [anon_sym_point] = ACTIONS(4716),
    [anon_sym_line] = ACTIONS(4716),
    [anon_sym_triangleadj] = ACTIONS(4716),
    [anon_sym_lineadj] = ACTIONS(4716),
    [anon_sym_triangle] = ACTIONS(4716),
    [anon_sym_cbuffer] = ACTIONS(4716),
    [anon_sym_interface] = ACTIONS(4716),
    [anon_sym_extension] = ACTIONS(4716),
  },
  [1195] = {
    [sym_attribute_declaration] = STATE(1190),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(851),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10697),
    [aux_sym_attributed_declarator_repeat1] = STATE(1190),
    [sym_identifier] = ACTIONS(4720),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_using] = ACTIONS(4722),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_cbuffer] = ACTIONS(275),
  },
  [1196] = {
    [sym_attribute_declaration] = STATE(1196),
    [sym_compound_statement] = STATE(857),
    [sym_attributed_statement] = STATE(857),
    [sym_statement] = STATE(864),
    [sym_labeled_statement] = STATE(857),
    [sym_expression_statement] = STATE(857),
    [sym_if_statement] = STATE(857),
    [sym_switch_statement] = STATE(857),
    [sym_case_statement] = STATE(857),
    [sym_while_statement] = STATE(857),
    [sym_do_statement] = STATE(857),
    [sym_for_statement] = STATE(857),
    [sym_return_statement] = STATE(857),
    [sym_break_statement] = STATE(857),
    [sym_continue_statement] = STATE(857),
    [sym_goto_statement] = STATE(857),
    [sym_seh_try_statement] = STATE(857),
    [sym_seh_leave_statement] = STATE(857),
    [sym_expression] = STATE(5773),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10871),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(857),
    [sym_co_return_statement] = STATE(857),
    [sym_co_yield_statement] = STATE(857),
    [sym_throw_statement] = STATE(857),
    [sym_try_statement] = STATE(857),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(857),
    [sym_cbuffer_specifier] = STATE(857),
    [sym_hlsl_attribute] = STATE(10474),
    [aux_sym_attributed_declarator_repeat1] = STATE(1196),
    [sym_identifier] = ACTIONS(4724),
    [anon_sym_LPAREN2] = ACTIONS(4464),
    [anon_sym_BANG] = ACTIONS(4467),
    [anon_sym_TILDE] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4470),
    [anon_sym_PLUS] = ACTIONS(4470),
    [anon_sym_STAR] = ACTIONS(4473),
    [anon_sym_AMP] = ACTIONS(4473),
    [anon_sym_SEMI] = ACTIONS(4727),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_using] = ACTIONS(4482),
    [anon_sym_COLON_COLON] = ACTIONS(4484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4487),
    [anon_sym_LBRACE] = ACTIONS(4730),
    [anon_sym_LBRACK] = ACTIONS(4493),
    [sym_primitive_type] = ACTIONS(4496),
    [anon_sym_if] = ACTIONS(4733),
    [anon_sym_switch] = ACTIONS(4736),
    [anon_sym_case] = ACTIONS(4739),
    [anon_sym_default] = ACTIONS(4742),
    [anon_sym_while] = ACTIONS(4745),
    [anon_sym_do] = ACTIONS(4748),
    [anon_sym_for] = ACTIONS(4751),
    [anon_sym_return] = ACTIONS(4754),
    [anon_sym_break] = ACTIONS(4757),
    [anon_sym_continue] = ACTIONS(4760),
    [anon_sym_goto] = ACTIONS(4763),
    [anon_sym___try] = ACTIONS(4766),
    [anon_sym___leave] = ACTIONS(4769),
    [anon_sym_not] = ACTIONS(4470),
    [anon_sym_compl] = ACTIONS(4470),
    [anon_sym_DASH_DASH] = ACTIONS(4538),
    [anon_sym_PLUS_PLUS] = ACTIONS(4538),
    [anon_sym_sizeof] = ACTIONS(4541),
    [anon_sym___alignof__] = ACTIONS(4544),
    [anon_sym___alignof] = ACTIONS(4544),
    [anon_sym__alignof] = ACTIONS(4544),
    [anon_sym_alignof] = ACTIONS(4544),
    [anon_sym__Alignof] = ACTIONS(4544),
    [anon_sym_offsetof] = ACTIONS(4547),
    [anon_sym__Generic] = ACTIONS(4550),
    [anon_sym_asm] = ACTIONS(4553),
    [anon_sym___asm__] = ACTIONS(4553),
    [anon_sym___asm] = ACTIONS(4553),
    [sym_number_literal] = ACTIONS(4556),
    [anon_sym_L_SQUOTE] = ACTIONS(4559),
    [anon_sym_u_SQUOTE] = ACTIONS(4559),
    [anon_sym_U_SQUOTE] = ACTIONS(4559),
    [anon_sym_u8_SQUOTE] = ACTIONS(4559),
    [anon_sym_SQUOTE] = ACTIONS(4559),
    [anon_sym_L_DQUOTE] = ACTIONS(4562),
    [anon_sym_u_DQUOTE] = ACTIONS(4562),
    [anon_sym_U_DQUOTE] = ACTIONS(4562),
    [anon_sym_u8_DQUOTE] = ACTIONS(4562),
    [anon_sym_DQUOTE] = ACTIONS(4562),
    [sym_true] = ACTIONS(4565),
    [sym_false] = ACTIONS(4565),
    [anon_sym_NULL] = ACTIONS(4568),
    [anon_sym_nullptr] = ACTIONS(4568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4571),
    [anon_sym_template] = ACTIONS(4574),
    [anon_sym_try] = ACTIONS(4772),
    [anon_sym_delete] = ACTIONS(4580),
    [anon_sym_throw] = ACTIONS(4775),
    [anon_sym_co_return] = ACTIONS(4778),
    [anon_sym_co_yield] = ACTIONS(4781),
    [anon_sym_R_DQUOTE] = ACTIONS(4592),
    [anon_sym_LR_DQUOTE] = ACTIONS(4592),
    [anon_sym_uR_DQUOTE] = ACTIONS(4592),
    [anon_sym_UR_DQUOTE] = ACTIONS(4592),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4592),
    [anon_sym_co_await] = ACTIONS(4595),
    [anon_sym_new] = ACTIONS(4598),
    [anon_sym_requires] = ACTIONS(4601),
    [sym_this] = ACTIONS(4565),
    [anon_sym_discard] = ACTIONS(4784),
    [anon_sym_cbuffer] = ACTIONS(4787),
  },
  [1197] = {
    [sym_function_definition] = STATE(1757),
    [sym_declaration] = STATE(1757),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6107),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2919),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2610),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7905),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2785),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__empty_declaration] = STATE(1757),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2677),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(1757),
    [sym_operator_cast] = STATE(9116),
    [sym__constructor_specifiers] = STATE(2677),
    [sym_operator_cast_definition] = STATE(1757),
    [sym_operator_cast_declaration] = STATE(1757),
    [sym_constructor_or_destructor_definition] = STATE(1757),
    [sym_constructor_or_destructor_declaration] = STATE(1757),
    [sym_friend_declaration] = STATE(1757),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_alias_declaration] = STATE(1757),
    [sym_concept_definition] = STATE(1757),
    [sym_requires_clause] = STATE(1267),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6972),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9116),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_hlsl_attribute] = STATE(1639),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2677),
    [sym_identifier] = ACTIONS(4445),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(4790),
    [anon_sym_COLON_COLON] = ACTIONS(4449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(4451),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2468),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(2484),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2486),
    [anon_sym_concept] = ACTIONS(4792),
    [anon_sym_requires] = ACTIONS(4455),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1198] = {
    [sym_attribute_declaration] = STATE(1198),
    [sym_compound_statement] = STATE(480),
    [sym_attributed_statement] = STATE(480),
    [sym_statement] = STATE(443),
    [sym_labeled_statement] = STATE(480),
    [sym_expression_statement] = STATE(480),
    [sym_if_statement] = STATE(480),
    [sym_switch_statement] = STATE(480),
    [sym_case_statement] = STATE(480),
    [sym_while_statement] = STATE(480),
    [sym_do_statement] = STATE(480),
    [sym_for_statement] = STATE(480),
    [sym_return_statement] = STATE(480),
    [sym_break_statement] = STATE(480),
    [sym_continue_statement] = STATE(480),
    [sym_goto_statement] = STATE(480),
    [sym_seh_try_statement] = STATE(480),
    [sym_seh_leave_statement] = STATE(480),
    [sym_expression] = STATE(5655),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10869),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(480),
    [sym_co_return_statement] = STATE(480),
    [sym_co_yield_statement] = STATE(480),
    [sym_throw_statement] = STATE(480),
    [sym_try_statement] = STATE(480),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(480),
    [sym_cbuffer_specifier] = STATE(480),
    [sym_hlsl_attribute] = STATE(10450),
    [aux_sym_attributed_declarator_repeat1] = STATE(1198),
    [sym_identifier] = ACTIONS(4794),
    [anon_sym_LPAREN2] = ACTIONS(4464),
    [anon_sym_BANG] = ACTIONS(4467),
    [anon_sym_TILDE] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4470),
    [anon_sym_PLUS] = ACTIONS(4470),
    [anon_sym_STAR] = ACTIONS(4473),
    [anon_sym_AMP] = ACTIONS(4473),
    [anon_sym_SEMI] = ACTIONS(4797),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_using] = ACTIONS(4482),
    [anon_sym_COLON_COLON] = ACTIONS(4484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4487),
    [anon_sym_LBRACE] = ACTIONS(4800),
    [anon_sym_LBRACK] = ACTIONS(4493),
    [sym_primitive_type] = ACTIONS(4496),
    [anon_sym_if] = ACTIONS(4803),
    [anon_sym_switch] = ACTIONS(4806),
    [anon_sym_case] = ACTIONS(4809),
    [anon_sym_default] = ACTIONS(4812),
    [anon_sym_while] = ACTIONS(4815),
    [anon_sym_do] = ACTIONS(4818),
    [anon_sym_for] = ACTIONS(4821),
    [anon_sym_return] = ACTIONS(4824),
    [anon_sym_break] = ACTIONS(4827),
    [anon_sym_continue] = ACTIONS(4830),
    [anon_sym_goto] = ACTIONS(4833),
    [anon_sym___try] = ACTIONS(4836),
    [anon_sym___leave] = ACTIONS(4839),
    [anon_sym_not] = ACTIONS(4470),
    [anon_sym_compl] = ACTIONS(4470),
    [anon_sym_DASH_DASH] = ACTIONS(4538),
    [anon_sym_PLUS_PLUS] = ACTIONS(4538),
    [anon_sym_sizeof] = ACTIONS(4541),
    [anon_sym___alignof__] = ACTIONS(4544),
    [anon_sym___alignof] = ACTIONS(4544),
    [anon_sym__alignof] = ACTIONS(4544),
    [anon_sym_alignof] = ACTIONS(4544),
    [anon_sym__Alignof] = ACTIONS(4544),
    [anon_sym_offsetof] = ACTIONS(4547),
    [anon_sym__Generic] = ACTIONS(4550),
    [anon_sym_asm] = ACTIONS(4553),
    [anon_sym___asm__] = ACTIONS(4553),
    [anon_sym___asm] = ACTIONS(4553),
    [sym_number_literal] = ACTIONS(4556),
    [anon_sym_L_SQUOTE] = ACTIONS(4559),
    [anon_sym_u_SQUOTE] = ACTIONS(4559),
    [anon_sym_U_SQUOTE] = ACTIONS(4559),
    [anon_sym_u8_SQUOTE] = ACTIONS(4559),
    [anon_sym_SQUOTE] = ACTIONS(4559),
    [anon_sym_L_DQUOTE] = ACTIONS(4562),
    [anon_sym_u_DQUOTE] = ACTIONS(4562),
    [anon_sym_U_DQUOTE] = ACTIONS(4562),
    [anon_sym_u8_DQUOTE] = ACTIONS(4562),
    [anon_sym_DQUOTE] = ACTIONS(4562),
    [sym_true] = ACTIONS(4565),
    [sym_false] = ACTIONS(4565),
    [anon_sym_NULL] = ACTIONS(4568),
    [anon_sym_nullptr] = ACTIONS(4568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4571),
    [anon_sym_template] = ACTIONS(4574),
    [anon_sym_try] = ACTIONS(4842),
    [anon_sym_delete] = ACTIONS(4580),
    [anon_sym_throw] = ACTIONS(4845),
    [anon_sym_co_return] = ACTIONS(4848),
    [anon_sym_co_yield] = ACTIONS(4851),
    [anon_sym_R_DQUOTE] = ACTIONS(4592),
    [anon_sym_LR_DQUOTE] = ACTIONS(4592),
    [anon_sym_uR_DQUOTE] = ACTIONS(4592),
    [anon_sym_UR_DQUOTE] = ACTIONS(4592),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4592),
    [anon_sym_co_await] = ACTIONS(4595),
    [anon_sym_new] = ACTIONS(4598),
    [anon_sym_requires] = ACTIONS(4601),
    [sym_this] = ACTIONS(4565),
    [anon_sym_discard] = ACTIONS(4854),
    [anon_sym_cbuffer] = ACTIONS(4857),
  },
  [1199] = {
    [sym_identifier] = ACTIONS(4860),
    [anon_sym_COMMA] = ACTIONS(4862),
    [anon_sym_RPAREN] = ACTIONS(4862),
    [anon_sym_LPAREN2] = ACTIONS(4862),
    [anon_sym_BANG] = ACTIONS(4862),
    [anon_sym_TILDE] = ACTIONS(4862),
    [anon_sym_DASH] = ACTIONS(4860),
    [anon_sym_PLUS] = ACTIONS(4860),
    [anon_sym_STAR] = ACTIONS(4862),
    [anon_sym_AMP_AMP] = ACTIONS(4862),
    [anon_sym_AMP] = ACTIONS(4860),
    [anon_sym_SEMI] = ACTIONS(4862),
    [anon_sym___extension__] = ACTIONS(4860),
    [anon_sym_in] = ACTIONS(4860),
    [anon_sym_out] = ACTIONS(4860),
    [anon_sym_inout] = ACTIONS(4860),
    [anon_sym_virtual] = ACTIONS(4860),
    [anon_sym_extern] = ACTIONS(4860),
    [anon_sym___attribute__] = ACTIONS(4860),
    [anon_sym___attribute] = ACTIONS(4860),
    [anon_sym_using] = ACTIONS(4860),
    [anon_sym_COLON_COLON] = ACTIONS(4862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4862),
    [anon_sym___declspec] = ACTIONS(4860),
    [anon_sym___based] = ACTIONS(4860),
    [anon_sym_LBRACE] = ACTIONS(4862),
    [anon_sym_signed] = ACTIONS(4860),
    [anon_sym_unsigned] = ACTIONS(4860),
    [anon_sym_long] = ACTIONS(4860),
    [anon_sym_short] = ACTIONS(4860),
    [anon_sym_LBRACK] = ACTIONS(4860),
    [anon_sym_static] = ACTIONS(4860),
    [anon_sym_RBRACK] = ACTIONS(4862),
    [anon_sym_EQ] = ACTIONS(4862),
    [anon_sym_register] = ACTIONS(4860),
    [anon_sym_inline] = ACTIONS(4860),
    [anon_sym___inline] = ACTIONS(4860),
    [anon_sym___inline__] = ACTIONS(4860),
    [anon_sym___forceinline] = ACTIONS(4860),
    [anon_sym_thread_local] = ACTIONS(4860),
    [anon_sym___thread] = ACTIONS(4860),
    [anon_sym_const] = ACTIONS(4860),
    [anon_sym_constexpr] = ACTIONS(4860),
    [anon_sym_volatile] = ACTIONS(4860),
    [anon_sym_restrict] = ACTIONS(4860),
    [anon_sym___restrict__] = ACTIONS(4860),
    [anon_sym__Atomic] = ACTIONS(4860),
    [anon_sym__Noreturn] = ACTIONS(4860),
    [anon_sym_noreturn] = ACTIONS(4860),
    [anon_sym__Nonnull] = ACTIONS(4860),
    [anon_sym_mutable] = ACTIONS(4860),
    [anon_sym_constinit] = ACTIONS(4860),
    [anon_sym_consteval] = ACTIONS(4860),
    [anon_sym_alignas] = ACTIONS(4860),
    [anon_sym__Alignas] = ACTIONS(4860),
    [sym_primitive_type] = ACTIONS(4860),
    [anon_sym_enum] = ACTIONS(4860),
    [anon_sym_class] = ACTIONS(4860),
    [anon_sym_struct] = ACTIONS(4860),
    [anon_sym_union] = ACTIONS(4860),
    [anon_sym_if] = ACTIONS(4860),
    [anon_sym_switch] = ACTIONS(4860),
    [anon_sym_case] = ACTIONS(4860),
    [anon_sym_default] = ACTIONS(4860),
    [anon_sym_while] = ACTIONS(4860),
    [anon_sym_do] = ACTIONS(4860),
    [anon_sym_for] = ACTIONS(4860),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_break] = ACTIONS(4860),
    [anon_sym_continue] = ACTIONS(4860),
    [anon_sym_goto] = ACTIONS(4860),
    [anon_sym___try] = ACTIONS(4860),
    [anon_sym___leave] = ACTIONS(4860),
    [anon_sym_not] = ACTIONS(4860),
    [anon_sym_compl] = ACTIONS(4860),
    [anon_sym_DASH_DASH] = ACTIONS(4862),
    [anon_sym_PLUS_PLUS] = ACTIONS(4862),
    [anon_sym_sizeof] = ACTIONS(4860),
    [anon_sym___alignof__] = ACTIONS(4860),
    [anon_sym___alignof] = ACTIONS(4860),
    [anon_sym__alignof] = ACTIONS(4860),
    [anon_sym_alignof] = ACTIONS(4860),
    [anon_sym__Alignof] = ACTIONS(4860),
    [anon_sym_offsetof] = ACTIONS(4860),
    [anon_sym__Generic] = ACTIONS(4860),
    [anon_sym_asm] = ACTIONS(4860),
    [anon_sym___asm__] = ACTIONS(4860),
    [anon_sym___asm] = ACTIONS(4860),
    [sym_number_literal] = ACTIONS(4862),
    [anon_sym_L_SQUOTE] = ACTIONS(4862),
    [anon_sym_u_SQUOTE] = ACTIONS(4862),
    [anon_sym_U_SQUOTE] = ACTIONS(4862),
    [anon_sym_u8_SQUOTE] = ACTIONS(4862),
    [anon_sym_SQUOTE] = ACTIONS(4862),
    [anon_sym_L_DQUOTE] = ACTIONS(4862),
    [anon_sym_u_DQUOTE] = ACTIONS(4862),
    [anon_sym_U_DQUOTE] = ACTIONS(4862),
    [anon_sym_u8_DQUOTE] = ACTIONS(4862),
    [anon_sym_DQUOTE] = ACTIONS(4862),
    [sym_true] = ACTIONS(4860),
    [sym_false] = ACTIONS(4860),
    [anon_sym_NULL] = ACTIONS(4860),
    [anon_sym_nullptr] = ACTIONS(4860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4860),
    [anon_sym_let] = ACTIONS(4860),
    [anon_sym_This] = ACTIONS(4860),
    [anon_sym_decltype] = ACTIONS(4860),
    [anon_sym_explicit] = ACTIONS(4860),
    [anon_sym_typename] = ACTIONS(4860),
    [anon_sym_template] = ACTIONS(4860),
    [anon_sym_operator] = ACTIONS(4860),
    [anon_sym_try] = ACTIONS(4860),
    [anon_sym_delete] = ACTIONS(4860),
    [anon_sym_throw] = ACTIONS(4860),
    [anon_sym_co_return] = ACTIONS(4860),
    [anon_sym_co_yield] = ACTIONS(4860),
    [anon_sym_R_DQUOTE] = ACTIONS(4862),
    [anon_sym_LR_DQUOTE] = ACTIONS(4862),
    [anon_sym_uR_DQUOTE] = ACTIONS(4862),
    [anon_sym_UR_DQUOTE] = ACTIONS(4862),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4862),
    [anon_sym_co_await] = ACTIONS(4860),
    [anon_sym_new] = ACTIONS(4860),
    [anon_sym_requires] = ACTIONS(4860),
    [sym_this] = ACTIONS(4860),
    [anon_sym_discard] = ACTIONS(4860),
    [anon_sym_precise] = ACTIONS(4860),
    [anon_sym_shared] = ACTIONS(4860),
    [anon_sym_groupshared] = ACTIONS(4860),
    [anon_sym_uniform] = ACTIONS(4860),
    [anon_sym_row_major] = ACTIONS(4860),
    [anon_sym_column_major] = ACTIONS(4860),
    [anon_sym_globallycoherent] = ACTIONS(4860),
    [anon_sym_centroid] = ACTIONS(4860),
    [anon_sym_noperspective] = ACTIONS(4860),
    [anon_sym_nointerpolation] = ACTIONS(4860),
    [anon_sym_sample] = ACTIONS(4860),
    [anon_sym_linear] = ACTIONS(4860),
    [anon_sym_snorm] = ACTIONS(4860),
    [anon_sym_unorm] = ACTIONS(4860),
    [anon_sym_point] = ACTIONS(4860),
    [anon_sym_line] = ACTIONS(4860),
    [anon_sym_triangleadj] = ACTIONS(4860),
    [anon_sym_lineadj] = ACTIONS(4860),
    [anon_sym_triangle] = ACTIONS(4860),
    [anon_sym_cbuffer] = ACTIONS(4860),
    [anon_sym_interface] = ACTIONS(4860),
    [anon_sym_extension] = ACTIONS(4860),
  },
  [1200] = {
    [sym_attribute_declaration] = STATE(1252),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(476),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10419),
    [aux_sym_attributed_declarator_repeat1] = STATE(1252),
    [sym_identifier] = ACTIONS(4864),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(2092),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2094),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(2096),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(2098),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_cbuffer] = ACTIONS(2100),
  },
  [1201] = {
    [sym_attribute_declaration] = STATE(1252),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(11355),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10419),
    [aux_sym_attributed_declarator_repeat1] = STATE(1252),
    [sym_identifier] = ACTIONS(4864),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(2092),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2094),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(2096),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(2098),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_cbuffer] = ACTIONS(2100),
  },
  [1202] = {
    [sym_attribute_declaration] = STATE(1252),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(9835),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10419),
    [aux_sym_attributed_declarator_repeat1] = STATE(1252),
    [sym_identifier] = ACTIONS(4864),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(2092),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2094),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(2096),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(2098),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_cbuffer] = ACTIONS(2100),
  },
  [1203] = {
    [sym_attribute_declaration] = STATE(1243),
    [sym_compound_statement] = STATE(1415),
    [sym_attributed_statement] = STATE(1415),
    [sym_statement] = STATE(1386),
    [sym_labeled_statement] = STATE(1415),
    [sym_expression_statement] = STATE(1415),
    [sym_if_statement] = STATE(1415),
    [sym_switch_statement] = STATE(1415),
    [sym_case_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_do_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_break_statement] = STATE(1415),
    [sym_continue_statement] = STATE(1415),
    [sym_goto_statement] = STATE(1415),
    [sym_seh_try_statement] = STATE(1415),
    [sym_seh_leave_statement] = STATE(1415),
    [sym_expression] = STATE(5664),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11323),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(1415),
    [sym_co_return_statement] = STATE(1415),
    [sym_co_yield_statement] = STATE(1415),
    [sym_throw_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(1415),
    [sym_cbuffer_specifier] = STATE(1415),
    [sym_hlsl_attribute] = STATE(10401),
    [aux_sym_attributed_declarator_repeat1] = STATE(1243),
    [sym_identifier] = ACTIONS(4866),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2044),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_switch] = ACTIONS(2050),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2058),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2062),
    [anon_sym_break] = ACTIONS(2064),
    [anon_sym_continue] = ACTIONS(2066),
    [anon_sym_goto] = ACTIONS(2068),
    [anon_sym___try] = ACTIONS(2070),
    [anon_sym___leave] = ACTIONS(2072),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(2074),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(2076),
    [anon_sym_co_return] = ACTIONS(2078),
    [anon_sym_co_yield] = ACTIONS(2080),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(2082),
    [anon_sym_cbuffer] = ACTIONS(2084),
  },
  [1204] = {
    [sym_attribute_declaration] = STATE(1252),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(501),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10419),
    [aux_sym_attributed_declarator_repeat1] = STATE(1252),
    [sym_identifier] = ACTIONS(4864),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(2092),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2094),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(2096),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(2098),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_cbuffer] = ACTIONS(2100),
  },
  [1205] = {
    [sym_attribute_declaration] = STATE(1243),
    [sym_compound_statement] = STATE(1415),
    [sym_attributed_statement] = STATE(1415),
    [sym_statement] = STATE(1388),
    [sym_labeled_statement] = STATE(1415),
    [sym_expression_statement] = STATE(1415),
    [sym_if_statement] = STATE(1415),
    [sym_switch_statement] = STATE(1415),
    [sym_case_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_do_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_break_statement] = STATE(1415),
    [sym_continue_statement] = STATE(1415),
    [sym_goto_statement] = STATE(1415),
    [sym_seh_try_statement] = STATE(1415),
    [sym_seh_leave_statement] = STATE(1415),
    [sym_expression] = STATE(5664),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11323),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(1415),
    [sym_co_return_statement] = STATE(1415),
    [sym_co_yield_statement] = STATE(1415),
    [sym_throw_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(1415),
    [sym_cbuffer_specifier] = STATE(1415),
    [sym_hlsl_attribute] = STATE(10401),
    [aux_sym_attributed_declarator_repeat1] = STATE(1243),
    [sym_identifier] = ACTIONS(4866),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2044),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_switch] = ACTIONS(2050),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2058),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2062),
    [anon_sym_break] = ACTIONS(2064),
    [anon_sym_continue] = ACTIONS(2066),
    [anon_sym_goto] = ACTIONS(2068),
    [anon_sym___try] = ACTIONS(2070),
    [anon_sym___leave] = ACTIONS(2072),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(2074),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(2076),
    [anon_sym_co_return] = ACTIONS(2078),
    [anon_sym_co_yield] = ACTIONS(2080),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(2082),
    [anon_sym_cbuffer] = ACTIONS(2084),
  },
  [1206] = {
    [sym_attribute_declaration] = STATE(1206),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(443),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10419),
    [aux_sym_attributed_declarator_repeat1] = STATE(1206),
    [sym_identifier] = ACTIONS(4868),
    [anon_sym_LPAREN2] = ACTIONS(4464),
    [anon_sym_BANG] = ACTIONS(4467),
    [anon_sym_TILDE] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4470),
    [anon_sym_PLUS] = ACTIONS(4470),
    [anon_sym_STAR] = ACTIONS(4473),
    [anon_sym_AMP] = ACTIONS(4473),
    [anon_sym_SEMI] = ACTIONS(4629),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_COLON_COLON] = ACTIONS(4484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4487),
    [anon_sym_LBRACE] = ACTIONS(4800),
    [anon_sym_LBRACK] = ACTIONS(4493),
    [sym_primitive_type] = ACTIONS(4496),
    [anon_sym_if] = ACTIONS(4871),
    [anon_sym_switch] = ACTIONS(4806),
    [anon_sym_case] = ACTIONS(4874),
    [anon_sym_default] = ACTIONS(4877),
    [anon_sym_while] = ACTIONS(4880),
    [anon_sym_do] = ACTIONS(4818),
    [anon_sym_for] = ACTIONS(4883),
    [anon_sym_return] = ACTIONS(4824),
    [anon_sym_break] = ACTIONS(4827),
    [anon_sym_continue] = ACTIONS(4830),
    [anon_sym_goto] = ACTIONS(4833),
    [anon_sym___try] = ACTIONS(4886),
    [anon_sym___leave] = ACTIONS(4671),
    [anon_sym_not] = ACTIONS(4470),
    [anon_sym_compl] = ACTIONS(4470),
    [anon_sym_DASH_DASH] = ACTIONS(4538),
    [anon_sym_PLUS_PLUS] = ACTIONS(4538),
    [anon_sym_sizeof] = ACTIONS(4541),
    [anon_sym___alignof__] = ACTIONS(4544),
    [anon_sym___alignof] = ACTIONS(4544),
    [anon_sym__alignof] = ACTIONS(4544),
    [anon_sym_alignof] = ACTIONS(4544),
    [anon_sym__Alignof] = ACTIONS(4544),
    [anon_sym_offsetof] = ACTIONS(4547),
    [anon_sym__Generic] = ACTIONS(4550),
    [anon_sym_asm] = ACTIONS(4553),
    [anon_sym___asm__] = ACTIONS(4553),
    [anon_sym___asm] = ACTIONS(4553),
    [sym_number_literal] = ACTIONS(4556),
    [anon_sym_L_SQUOTE] = ACTIONS(4559),
    [anon_sym_u_SQUOTE] = ACTIONS(4559),
    [anon_sym_U_SQUOTE] = ACTIONS(4559),
    [anon_sym_u8_SQUOTE] = ACTIONS(4559),
    [anon_sym_SQUOTE] = ACTIONS(4559),
    [anon_sym_L_DQUOTE] = ACTIONS(4562),
    [anon_sym_u_DQUOTE] = ACTIONS(4562),
    [anon_sym_U_DQUOTE] = ACTIONS(4562),
    [anon_sym_u8_DQUOTE] = ACTIONS(4562),
    [anon_sym_DQUOTE] = ACTIONS(4562),
    [sym_true] = ACTIONS(4565),
    [sym_false] = ACTIONS(4565),
    [anon_sym_NULL] = ACTIONS(4568),
    [anon_sym_nullptr] = ACTIONS(4568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4571),
    [anon_sym_template] = ACTIONS(4574),
    [anon_sym_try] = ACTIONS(4842),
    [anon_sym_delete] = ACTIONS(4580),
    [anon_sym_throw] = ACTIONS(4845),
    [anon_sym_co_return] = ACTIONS(4848),
    [anon_sym_co_yield] = ACTIONS(4851),
    [anon_sym_R_DQUOTE] = ACTIONS(4592),
    [anon_sym_LR_DQUOTE] = ACTIONS(4592),
    [anon_sym_uR_DQUOTE] = ACTIONS(4592),
    [anon_sym_UR_DQUOTE] = ACTIONS(4592),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4592),
    [anon_sym_co_await] = ACTIONS(4595),
    [anon_sym_new] = ACTIONS(4598),
    [anon_sym_requires] = ACTIONS(4601),
    [sym_this] = ACTIONS(4565),
    [anon_sym_discard] = ACTIONS(4686),
    [anon_sym_cbuffer] = ACTIONS(4889),
  },
  [1207] = {
    [sym_attribute_declaration] = STATE(1252),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(9927),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10419),
    [aux_sym_attributed_declarator_repeat1] = STATE(1252),
    [sym_identifier] = ACTIONS(4864),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(2092),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2094),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(2096),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(2098),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_cbuffer] = ACTIONS(2100),
  },
  [1208] = {
    [sym_attribute_declaration] = STATE(1252),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(461),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10419),
    [aux_sym_attributed_declarator_repeat1] = STATE(1252),
    [sym_identifier] = ACTIONS(4864),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(2092),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2094),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(2096),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(2098),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_cbuffer] = ACTIONS(2100),
  },
  [1209] = {
    [sym_attribute_declaration] = STATE(1252),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(463),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10419),
    [aux_sym_attributed_declarator_repeat1] = STATE(1252),
    [sym_identifier] = ACTIONS(4864),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(2092),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2094),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(2096),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(2098),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_cbuffer] = ACTIONS(2100),
  },
  [1210] = {
    [sym_attribute_declaration] = STATE(1252),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(464),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10419),
    [aux_sym_attributed_declarator_repeat1] = STATE(1252),
    [sym_identifier] = ACTIONS(4864),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(2092),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2094),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(2096),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(2098),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_cbuffer] = ACTIONS(2100),
  },
  [1211] = {
    [sym_attribute_declaration] = STATE(1252),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(10071),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10419),
    [aux_sym_attributed_declarator_repeat1] = STATE(1252),
    [sym_identifier] = ACTIONS(4864),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(2092),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2094),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(2096),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(2098),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_cbuffer] = ACTIONS(2100),
  },
  [1212] = {
    [sym_attribute_declaration] = STATE(1243),
    [sym_compound_statement] = STATE(1415),
    [sym_attributed_statement] = STATE(1415),
    [sym_statement] = STATE(1360),
    [sym_labeled_statement] = STATE(1415),
    [sym_expression_statement] = STATE(1415),
    [sym_if_statement] = STATE(1415),
    [sym_switch_statement] = STATE(1415),
    [sym_case_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_do_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_break_statement] = STATE(1415),
    [sym_continue_statement] = STATE(1415),
    [sym_goto_statement] = STATE(1415),
    [sym_seh_try_statement] = STATE(1415),
    [sym_seh_leave_statement] = STATE(1415),
    [sym_expression] = STATE(5664),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11323),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(1415),
    [sym_co_return_statement] = STATE(1415),
    [sym_co_yield_statement] = STATE(1415),
    [sym_throw_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(1415),
    [sym_cbuffer_specifier] = STATE(1415),
    [sym_hlsl_attribute] = STATE(10401),
    [aux_sym_attributed_declarator_repeat1] = STATE(1243),
    [sym_identifier] = ACTIONS(4866),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2044),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_switch] = ACTIONS(2050),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2058),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2062),
    [anon_sym_break] = ACTIONS(2064),
    [anon_sym_continue] = ACTIONS(2066),
    [anon_sym_goto] = ACTIONS(2068),
    [anon_sym___try] = ACTIONS(2070),
    [anon_sym___leave] = ACTIONS(2072),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(2074),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(2076),
    [anon_sym_co_return] = ACTIONS(2078),
    [anon_sym_co_yield] = ACTIONS(2080),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(2082),
    [anon_sym_cbuffer] = ACTIONS(2084),
  },
  [1213] = {
    [sym_attribute_declaration] = STATE(1244),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(676),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10697),
    [aux_sym_attributed_declarator_repeat1] = STATE(1244),
    [sym_identifier] = ACTIONS(4720),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_cbuffer] = ACTIONS(275),
  },
  [1214] = {
    [sym_attribute_declaration] = STATE(1196),
    [sym_compound_statement] = STATE(857),
    [sym_attributed_statement] = STATE(857),
    [sym_statement] = STATE(864),
    [sym_labeled_statement] = STATE(857),
    [sym_expression_statement] = STATE(857),
    [sym_if_statement] = STATE(857),
    [sym_switch_statement] = STATE(857),
    [sym_case_statement] = STATE(857),
    [sym_while_statement] = STATE(857),
    [sym_do_statement] = STATE(857),
    [sym_for_statement] = STATE(857),
    [sym_return_statement] = STATE(857),
    [sym_break_statement] = STATE(857),
    [sym_continue_statement] = STATE(857),
    [sym_goto_statement] = STATE(857),
    [sym_seh_try_statement] = STATE(857),
    [sym_seh_leave_statement] = STATE(857),
    [sym_expression] = STATE(5773),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10871),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(857),
    [sym_co_return_statement] = STATE(857),
    [sym_co_yield_statement] = STATE(857),
    [sym_throw_statement] = STATE(857),
    [sym_try_statement] = STATE(857),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(857),
    [sym_cbuffer_specifier] = STATE(857),
    [sym_hlsl_attribute] = STATE(10474),
    [aux_sym_attributed_declarator_repeat1] = STATE(1196),
    [sym_identifier] = ACTIONS(4435),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1083),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_case] = ACTIONS(1101),
    [anon_sym_default] = ACTIONS(1103),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1107),
    [anon_sym_for] = ACTIONS(1109),
    [anon_sym_return] = ACTIONS(1111),
    [anon_sym_break] = ACTIONS(1113),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_goto] = ACTIONS(1117),
    [anon_sym___try] = ACTIONS(1119),
    [anon_sym___leave] = ACTIONS(1121),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(1125),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_co_return] = ACTIONS(1135),
    [anon_sym_co_yield] = ACTIONS(1137),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1139),
    [anon_sym_cbuffer] = ACTIONS(1141),
  },
  [1215] = {
    [sym_attribute_declaration] = STATE(1252),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(10984),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10419),
    [aux_sym_attributed_declarator_repeat1] = STATE(1252),
    [sym_identifier] = ACTIONS(4864),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(2092),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2094),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(2096),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(2098),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_cbuffer] = ACTIONS(2100),
  },
  [1216] = {
    [sym_attribute_declaration] = STATE(1243),
    [sym_compound_statement] = STATE(1415),
    [sym_attributed_statement] = STATE(1415),
    [sym_statement] = STATE(1389),
    [sym_labeled_statement] = STATE(1415),
    [sym_expression_statement] = STATE(1415),
    [sym_if_statement] = STATE(1415),
    [sym_switch_statement] = STATE(1415),
    [sym_case_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_do_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_break_statement] = STATE(1415),
    [sym_continue_statement] = STATE(1415),
    [sym_goto_statement] = STATE(1415),
    [sym_seh_try_statement] = STATE(1415),
    [sym_seh_leave_statement] = STATE(1415),
    [sym_expression] = STATE(5664),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11323),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(1415),
    [sym_co_return_statement] = STATE(1415),
    [sym_co_yield_statement] = STATE(1415),
    [sym_throw_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(1415),
    [sym_cbuffer_specifier] = STATE(1415),
    [sym_hlsl_attribute] = STATE(10401),
    [aux_sym_attributed_declarator_repeat1] = STATE(1243),
    [sym_identifier] = ACTIONS(4866),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2044),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_switch] = ACTIONS(2050),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2058),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2062),
    [anon_sym_break] = ACTIONS(2064),
    [anon_sym_continue] = ACTIONS(2066),
    [anon_sym_goto] = ACTIONS(2068),
    [anon_sym___try] = ACTIONS(2070),
    [anon_sym___leave] = ACTIONS(2072),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(2074),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(2076),
    [anon_sym_co_return] = ACTIONS(2078),
    [anon_sym_co_yield] = ACTIONS(2080),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(2082),
    [anon_sym_cbuffer] = ACTIONS(2084),
  },
  [1217] = {
    [sym_attribute_declaration] = STATE(1243),
    [sym_compound_statement] = STATE(1415),
    [sym_attributed_statement] = STATE(1415),
    [sym_statement] = STATE(1353),
    [sym_labeled_statement] = STATE(1415),
    [sym_expression_statement] = STATE(1415),
    [sym_if_statement] = STATE(1415),
    [sym_switch_statement] = STATE(1415),
    [sym_case_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_do_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_break_statement] = STATE(1415),
    [sym_continue_statement] = STATE(1415),
    [sym_goto_statement] = STATE(1415),
    [sym_seh_try_statement] = STATE(1415),
    [sym_seh_leave_statement] = STATE(1415),
    [sym_expression] = STATE(5664),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11323),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(1415),
    [sym_co_return_statement] = STATE(1415),
    [sym_co_yield_statement] = STATE(1415),
    [sym_throw_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(1415),
    [sym_cbuffer_specifier] = STATE(1415),
    [sym_hlsl_attribute] = STATE(10401),
    [aux_sym_attributed_declarator_repeat1] = STATE(1243),
    [sym_identifier] = ACTIONS(4866),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2044),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_switch] = ACTIONS(2050),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2058),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2062),
    [anon_sym_break] = ACTIONS(2064),
    [anon_sym_continue] = ACTIONS(2066),
    [anon_sym_goto] = ACTIONS(2068),
    [anon_sym___try] = ACTIONS(2070),
    [anon_sym___leave] = ACTIONS(2072),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(2074),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(2076),
    [anon_sym_co_return] = ACTIONS(2078),
    [anon_sym_co_yield] = ACTIONS(2080),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(2082),
    [anon_sym_cbuffer] = ACTIONS(2084),
  },
  [1218] = {
    [sym_attribute_declaration] = STATE(1243),
    [sym_compound_statement] = STATE(1415),
    [sym_attributed_statement] = STATE(1415),
    [sym_statement] = STATE(1396),
    [sym_labeled_statement] = STATE(1415),
    [sym_expression_statement] = STATE(1415),
    [sym_if_statement] = STATE(1415),
    [sym_switch_statement] = STATE(1415),
    [sym_case_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_do_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_break_statement] = STATE(1415),
    [sym_continue_statement] = STATE(1415),
    [sym_goto_statement] = STATE(1415),
    [sym_seh_try_statement] = STATE(1415),
    [sym_seh_leave_statement] = STATE(1415),
    [sym_expression] = STATE(5664),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11323),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(1415),
    [sym_co_return_statement] = STATE(1415),
    [sym_co_yield_statement] = STATE(1415),
    [sym_throw_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(1415),
    [sym_cbuffer_specifier] = STATE(1415),
    [sym_hlsl_attribute] = STATE(10401),
    [aux_sym_attributed_declarator_repeat1] = STATE(1243),
    [sym_identifier] = ACTIONS(4866),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2044),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_switch] = ACTIONS(2050),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2058),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2062),
    [anon_sym_break] = ACTIONS(2064),
    [anon_sym_continue] = ACTIONS(2066),
    [anon_sym_goto] = ACTIONS(2068),
    [anon_sym___try] = ACTIONS(2070),
    [anon_sym___leave] = ACTIONS(2072),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(2074),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(2076),
    [anon_sym_co_return] = ACTIONS(2078),
    [anon_sym_co_yield] = ACTIONS(2080),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(2082),
    [anon_sym_cbuffer] = ACTIONS(2084),
  },
  [1219] = {
    [sym_attribute_declaration] = STATE(1226),
    [sym_compound_statement] = STATE(480),
    [sym_attributed_statement] = STATE(480),
    [sym_statement] = STATE(476),
    [sym_labeled_statement] = STATE(480),
    [sym_expression_statement] = STATE(480),
    [sym_if_statement] = STATE(480),
    [sym_switch_statement] = STATE(480),
    [sym_case_statement] = STATE(480),
    [sym_while_statement] = STATE(480),
    [sym_do_statement] = STATE(480),
    [sym_for_statement] = STATE(480),
    [sym_return_statement] = STATE(480),
    [sym_break_statement] = STATE(480),
    [sym_continue_statement] = STATE(480),
    [sym_goto_statement] = STATE(480),
    [sym_seh_try_statement] = STATE(480),
    [sym_seh_leave_statement] = STATE(480),
    [sym_expression] = STATE(5655),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10869),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(480),
    [sym_co_return_statement] = STATE(480),
    [sym_co_yield_statement] = STATE(480),
    [sym_throw_statement] = STATE(480),
    [sym_try_statement] = STATE(480),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(480),
    [sym_cbuffer_specifier] = STATE(480),
    [sym_hlsl_attribute] = STATE(10450),
    [aux_sym_attributed_declarator_repeat1] = STATE(1226),
    [sym_identifier] = ACTIONS(4622),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1157),
    [anon_sym___leave] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1165),
    [anon_sym_cbuffer] = ACTIONS(1167),
  },
  [1220] = {
    [sym_attribute_declaration] = STATE(1186),
    [sym_compound_statement] = STATE(515),
    [sym_attributed_statement] = STATE(515),
    [sym_statement] = STATE(505),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(10675),
    [aux_sym_attributed_declarator_repeat1] = STATE(1186),
    [sym_identifier] = ACTIONS(4618),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_cbuffer] = ACTIONS(365),
  },
  [1221] = {
    [sym_attribute_declaration] = STATE(1214),
    [sym_compound_statement] = STATE(857),
    [sym_attributed_statement] = STATE(857),
    [sym_statement] = STATE(655),
    [sym_labeled_statement] = STATE(857),
    [sym_expression_statement] = STATE(857),
    [sym_if_statement] = STATE(857),
    [sym_switch_statement] = STATE(857),
    [sym_case_statement] = STATE(857),
    [sym_while_statement] = STATE(857),
    [sym_do_statement] = STATE(857),
    [sym_for_statement] = STATE(857),
    [sym_return_statement] = STATE(857),
    [sym_break_statement] = STATE(857),
    [sym_continue_statement] = STATE(857),
    [sym_goto_statement] = STATE(857),
    [sym_seh_try_statement] = STATE(857),
    [sym_seh_leave_statement] = STATE(857),
    [sym_expression] = STATE(5773),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10871),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(857),
    [sym_co_return_statement] = STATE(857),
    [sym_co_yield_statement] = STATE(857),
    [sym_throw_statement] = STATE(857),
    [sym_try_statement] = STATE(857),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(857),
    [sym_cbuffer_specifier] = STATE(857),
    [sym_hlsl_attribute] = STATE(10474),
    [aux_sym_attributed_declarator_repeat1] = STATE(1214),
    [sym_identifier] = ACTIONS(4435),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1083),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_case] = ACTIONS(1101),
    [anon_sym_default] = ACTIONS(1103),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1107),
    [anon_sym_for] = ACTIONS(1109),
    [anon_sym_return] = ACTIONS(1111),
    [anon_sym_break] = ACTIONS(1113),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_goto] = ACTIONS(1117),
    [anon_sym___try] = ACTIONS(1119),
    [anon_sym___leave] = ACTIONS(1121),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(1125),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_co_return] = ACTIONS(1135),
    [anon_sym_co_yield] = ACTIONS(1137),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1139),
    [anon_sym_cbuffer] = ACTIONS(1141),
  },
  [1222] = {
    [sym_attribute_declaration] = STATE(1214),
    [sym_compound_statement] = STATE(857),
    [sym_attributed_statement] = STATE(857),
    [sym_statement] = STATE(873),
    [sym_labeled_statement] = STATE(857),
    [sym_expression_statement] = STATE(857),
    [sym_if_statement] = STATE(857),
    [sym_switch_statement] = STATE(857),
    [sym_case_statement] = STATE(857),
    [sym_while_statement] = STATE(857),
    [sym_do_statement] = STATE(857),
    [sym_for_statement] = STATE(857),
    [sym_return_statement] = STATE(857),
    [sym_break_statement] = STATE(857),
    [sym_continue_statement] = STATE(857),
    [sym_goto_statement] = STATE(857),
    [sym_seh_try_statement] = STATE(857),
    [sym_seh_leave_statement] = STATE(857),
    [sym_expression] = STATE(5773),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10871),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(857),
    [sym_co_return_statement] = STATE(857),
    [sym_co_yield_statement] = STATE(857),
    [sym_throw_statement] = STATE(857),
    [sym_try_statement] = STATE(857),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(857),
    [sym_cbuffer_specifier] = STATE(857),
    [sym_hlsl_attribute] = STATE(10474),
    [aux_sym_attributed_declarator_repeat1] = STATE(1214),
    [sym_identifier] = ACTIONS(4435),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1083),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_case] = ACTIONS(1101),
    [anon_sym_default] = ACTIONS(1103),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1107),
    [anon_sym_for] = ACTIONS(1109),
    [anon_sym_return] = ACTIONS(1111),
    [anon_sym_break] = ACTIONS(1113),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_goto] = ACTIONS(1117),
    [anon_sym___try] = ACTIONS(1119),
    [anon_sym___leave] = ACTIONS(1121),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(1125),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_co_return] = ACTIONS(1135),
    [anon_sym_co_yield] = ACTIONS(1137),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1139),
    [anon_sym_cbuffer] = ACTIONS(1141),
  },
  [1223] = {
    [sym_attribute_declaration] = STATE(1244),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(883),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10697),
    [aux_sym_attributed_declarator_repeat1] = STATE(1244),
    [sym_identifier] = ACTIONS(4720),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_cbuffer] = ACTIONS(275),
  },
  [1224] = {
    [sym_attribute_declaration] = STATE(1220),
    [sym_compound_statement] = STATE(515),
    [sym_attributed_statement] = STATE(515),
    [sym_statement] = STATE(348),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(10675),
    [aux_sym_attributed_declarator_repeat1] = STATE(1220),
    [sym_identifier] = ACTIONS(4618),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_cbuffer] = ACTIONS(365),
  },
  [1225] = {
    [sym_attribute_declaration] = STATE(1226),
    [sym_compound_statement] = STATE(480),
    [sym_attributed_statement] = STATE(480),
    [sym_statement] = STATE(331),
    [sym_labeled_statement] = STATE(480),
    [sym_expression_statement] = STATE(480),
    [sym_if_statement] = STATE(480),
    [sym_switch_statement] = STATE(480),
    [sym_case_statement] = STATE(480),
    [sym_while_statement] = STATE(480),
    [sym_do_statement] = STATE(480),
    [sym_for_statement] = STATE(480),
    [sym_return_statement] = STATE(480),
    [sym_break_statement] = STATE(480),
    [sym_continue_statement] = STATE(480),
    [sym_goto_statement] = STATE(480),
    [sym_seh_try_statement] = STATE(480),
    [sym_seh_leave_statement] = STATE(480),
    [sym_expression] = STATE(5655),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10869),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(480),
    [sym_co_return_statement] = STATE(480),
    [sym_co_yield_statement] = STATE(480),
    [sym_throw_statement] = STATE(480),
    [sym_try_statement] = STATE(480),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(480),
    [sym_cbuffer_specifier] = STATE(480),
    [sym_hlsl_attribute] = STATE(10450),
    [aux_sym_attributed_declarator_repeat1] = STATE(1226),
    [sym_identifier] = ACTIONS(4622),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1157),
    [anon_sym___leave] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1165),
    [anon_sym_cbuffer] = ACTIONS(1167),
  },
  [1226] = {
    [sym_attribute_declaration] = STATE(1198),
    [sym_compound_statement] = STATE(480),
    [sym_attributed_statement] = STATE(480),
    [sym_statement] = STATE(443),
    [sym_labeled_statement] = STATE(480),
    [sym_expression_statement] = STATE(480),
    [sym_if_statement] = STATE(480),
    [sym_switch_statement] = STATE(480),
    [sym_case_statement] = STATE(480),
    [sym_while_statement] = STATE(480),
    [sym_do_statement] = STATE(480),
    [sym_for_statement] = STATE(480),
    [sym_return_statement] = STATE(480),
    [sym_break_statement] = STATE(480),
    [sym_continue_statement] = STATE(480),
    [sym_goto_statement] = STATE(480),
    [sym_seh_try_statement] = STATE(480),
    [sym_seh_leave_statement] = STATE(480),
    [sym_expression] = STATE(5655),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10869),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(480),
    [sym_co_return_statement] = STATE(480),
    [sym_co_yield_statement] = STATE(480),
    [sym_throw_statement] = STATE(480),
    [sym_try_statement] = STATE(480),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(480),
    [sym_cbuffer_specifier] = STATE(480),
    [sym_hlsl_attribute] = STATE(10450),
    [aux_sym_attributed_declarator_repeat1] = STATE(1198),
    [sym_identifier] = ACTIONS(4622),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1157),
    [anon_sym___leave] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1165),
    [anon_sym_cbuffer] = ACTIONS(1167),
  },
  [1227] = {
    [sym_attribute_declaration] = STATE(1227),
    [sym_compound_statement] = STATE(1415),
    [sym_attributed_statement] = STATE(1415),
    [sym_statement] = STATE(1377),
    [sym_labeled_statement] = STATE(1415),
    [sym_expression_statement] = STATE(1415),
    [sym_if_statement] = STATE(1415),
    [sym_switch_statement] = STATE(1415),
    [sym_case_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_do_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_break_statement] = STATE(1415),
    [sym_continue_statement] = STATE(1415),
    [sym_goto_statement] = STATE(1415),
    [sym_seh_try_statement] = STATE(1415),
    [sym_seh_leave_statement] = STATE(1415),
    [sym_expression] = STATE(5664),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11323),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(1415),
    [sym_co_return_statement] = STATE(1415),
    [sym_co_yield_statement] = STATE(1415),
    [sym_throw_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(1415),
    [sym_cbuffer_specifier] = STATE(1415),
    [sym_hlsl_attribute] = STATE(10401),
    [aux_sym_attributed_declarator_repeat1] = STATE(1227),
    [sym_identifier] = ACTIONS(4892),
    [anon_sym_LPAREN2] = ACTIONS(4464),
    [anon_sym_BANG] = ACTIONS(4467),
    [anon_sym_TILDE] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4470),
    [anon_sym_PLUS] = ACTIONS(4470),
    [anon_sym_STAR] = ACTIONS(4473),
    [anon_sym_AMP] = ACTIONS(4473),
    [anon_sym_SEMI] = ACTIONS(4895),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_COLON_COLON] = ACTIONS(4484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4487),
    [anon_sym_LBRACE] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(4493),
    [sym_primitive_type] = ACTIONS(4496),
    [anon_sym_if] = ACTIONS(4901),
    [anon_sym_switch] = ACTIONS(4904),
    [anon_sym_case] = ACTIONS(4874),
    [anon_sym_default] = ACTIONS(4877),
    [anon_sym_while] = ACTIONS(4907),
    [anon_sym_do] = ACTIONS(4910),
    [anon_sym_for] = ACTIONS(4913),
    [anon_sym_return] = ACTIONS(4916),
    [anon_sym_break] = ACTIONS(4919),
    [anon_sym_continue] = ACTIONS(4922),
    [anon_sym_goto] = ACTIONS(4925),
    [anon_sym___try] = ACTIONS(4928),
    [anon_sym___leave] = ACTIONS(4931),
    [anon_sym_not] = ACTIONS(4470),
    [anon_sym_compl] = ACTIONS(4470),
    [anon_sym_DASH_DASH] = ACTIONS(4538),
    [anon_sym_PLUS_PLUS] = ACTIONS(4538),
    [anon_sym_sizeof] = ACTIONS(4541),
    [anon_sym___alignof__] = ACTIONS(4544),
    [anon_sym___alignof] = ACTIONS(4544),
    [anon_sym__alignof] = ACTIONS(4544),
    [anon_sym_alignof] = ACTIONS(4544),
    [anon_sym__Alignof] = ACTIONS(4544),
    [anon_sym_offsetof] = ACTIONS(4547),
    [anon_sym__Generic] = ACTIONS(4550),
    [anon_sym_asm] = ACTIONS(4553),
    [anon_sym___asm__] = ACTIONS(4553),
    [anon_sym___asm] = ACTIONS(4553),
    [sym_number_literal] = ACTIONS(4556),
    [anon_sym_L_SQUOTE] = ACTIONS(4559),
    [anon_sym_u_SQUOTE] = ACTIONS(4559),
    [anon_sym_U_SQUOTE] = ACTIONS(4559),
    [anon_sym_u8_SQUOTE] = ACTIONS(4559),
    [anon_sym_SQUOTE] = ACTIONS(4559),
    [anon_sym_L_DQUOTE] = ACTIONS(4562),
    [anon_sym_u_DQUOTE] = ACTIONS(4562),
    [anon_sym_U_DQUOTE] = ACTIONS(4562),
    [anon_sym_u8_DQUOTE] = ACTIONS(4562),
    [anon_sym_DQUOTE] = ACTIONS(4562),
    [sym_true] = ACTIONS(4565),
    [sym_false] = ACTIONS(4565),
    [anon_sym_NULL] = ACTIONS(4568),
    [anon_sym_nullptr] = ACTIONS(4568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4571),
    [anon_sym_template] = ACTIONS(4574),
    [anon_sym_try] = ACTIONS(4934),
    [anon_sym_delete] = ACTIONS(4580),
    [anon_sym_throw] = ACTIONS(4937),
    [anon_sym_co_return] = ACTIONS(4940),
    [anon_sym_co_yield] = ACTIONS(4943),
    [anon_sym_R_DQUOTE] = ACTIONS(4592),
    [anon_sym_LR_DQUOTE] = ACTIONS(4592),
    [anon_sym_uR_DQUOTE] = ACTIONS(4592),
    [anon_sym_UR_DQUOTE] = ACTIONS(4592),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4592),
    [anon_sym_co_await] = ACTIONS(4595),
    [anon_sym_new] = ACTIONS(4598),
    [anon_sym_requires] = ACTIONS(4601),
    [sym_this] = ACTIONS(4565),
    [anon_sym_discard] = ACTIONS(4946),
    [anon_sym_cbuffer] = ACTIONS(4949),
  },
  [1228] = {
    [sym_expression] = STATE(3353),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_initializer_list] = STATE(3384),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4954),
    [anon_sym_COMMA] = ACTIONS(4954),
    [aux_sym_preproc_if_token2] = ACTIONS(4954),
    [aux_sym_preproc_else_token1] = ACTIONS(4954),
    [aux_sym_preproc_elif_token1] = ACTIONS(4952),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4954),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4954),
    [anon_sym_LPAREN2] = ACTIONS(4954),
    [anon_sym_BANG] = ACTIONS(4956),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4952),
    [anon_sym_PLUS] = ACTIONS(4952),
    [anon_sym_STAR] = ACTIONS(4952),
    [anon_sym_SLASH] = ACTIONS(4952),
    [anon_sym_PERCENT] = ACTIONS(4952),
    [anon_sym_PIPE_PIPE] = ACTIONS(4954),
    [anon_sym_AMP_AMP] = ACTIONS(4954),
    [anon_sym_PIPE] = ACTIONS(4952),
    [anon_sym_CARET] = ACTIONS(4952),
    [anon_sym_AMP] = ACTIONS(4952),
    [anon_sym_EQ_EQ] = ACTIONS(4954),
    [anon_sym_BANG_EQ] = ACTIONS(4954),
    [anon_sym_GT] = ACTIONS(4952),
    [anon_sym_GT_EQ] = ACTIONS(4954),
    [anon_sym_LT_EQ] = ACTIONS(4952),
    [anon_sym_LT] = ACTIONS(4952),
    [anon_sym_LT_LT] = ACTIONS(4952),
    [anon_sym_GT_GT] = ACTIONS(4952),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACE] = ACTIONS(4964),
    [anon_sym_LBRACK] = ACTIONS(4954),
    [anon_sym_EQ] = ACTIONS(4952),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_QMARK] = ACTIONS(4954),
    [anon_sym_STAR_EQ] = ACTIONS(4954),
    [anon_sym_SLASH_EQ] = ACTIONS(4954),
    [anon_sym_PERCENT_EQ] = ACTIONS(4954),
    [anon_sym_PLUS_EQ] = ACTIONS(4954),
    [anon_sym_DASH_EQ] = ACTIONS(4954),
    [anon_sym_LT_LT_EQ] = ACTIONS(4954),
    [anon_sym_GT_GT_EQ] = ACTIONS(4954),
    [anon_sym_AMP_EQ] = ACTIONS(4954),
    [anon_sym_CARET_EQ] = ACTIONS(4954),
    [anon_sym_PIPE_EQ] = ACTIONS(4954),
    [anon_sym_and_eq] = ACTIONS(4952),
    [anon_sym_or_eq] = ACTIONS(4952),
    [anon_sym_xor_eq] = ACTIONS(4952),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_LT_EQ_GT] = ACTIONS(4954),
    [anon_sym_or] = ACTIONS(4952),
    [anon_sym_and] = ACTIONS(4952),
    [anon_sym_bitor] = ACTIONS(4952),
    [anon_sym_xor] = ACTIONS(4952),
    [anon_sym_bitand] = ACTIONS(4952),
    [anon_sym_not_eq] = ACTIONS(4952),
    [anon_sym_is] = ACTIONS(4952),
    [anon_sym_as] = ACTIONS(4952),
    [anon_sym_DASH_DASH] = ACTIONS(4954),
    [anon_sym_PLUS_PLUS] = ACTIONS(4954),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [anon_sym_DOT] = ACTIONS(4952),
    [anon_sym_DOT_STAR] = ACTIONS(4954),
    [anon_sym_DASH_GT] = ACTIONS(4954),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1229] = {
    [sym_attribute_declaration] = STATE(1226),
    [sym_compound_statement] = STATE(480),
    [sym_attributed_statement] = STATE(480),
    [sym_statement] = STATE(501),
    [sym_labeled_statement] = STATE(480),
    [sym_expression_statement] = STATE(480),
    [sym_if_statement] = STATE(480),
    [sym_switch_statement] = STATE(480),
    [sym_case_statement] = STATE(480),
    [sym_while_statement] = STATE(480),
    [sym_do_statement] = STATE(480),
    [sym_for_statement] = STATE(480),
    [sym_return_statement] = STATE(480),
    [sym_break_statement] = STATE(480),
    [sym_continue_statement] = STATE(480),
    [sym_goto_statement] = STATE(480),
    [sym_seh_try_statement] = STATE(480),
    [sym_seh_leave_statement] = STATE(480),
    [sym_expression] = STATE(5655),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10869),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(480),
    [sym_co_return_statement] = STATE(480),
    [sym_co_yield_statement] = STATE(480),
    [sym_throw_statement] = STATE(480),
    [sym_try_statement] = STATE(480),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(480),
    [sym_cbuffer_specifier] = STATE(480),
    [sym_hlsl_attribute] = STATE(10450),
    [aux_sym_attributed_declarator_repeat1] = STATE(1226),
    [sym_identifier] = ACTIONS(4622),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1157),
    [anon_sym___leave] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1165),
    [anon_sym_cbuffer] = ACTIONS(1167),
  },
  [1230] = {
    [sym_attribute_declaration] = STATE(1226),
    [sym_compound_statement] = STATE(480),
    [sym_attributed_statement] = STATE(480),
    [sym_statement] = STATE(346),
    [sym_labeled_statement] = STATE(480),
    [sym_expression_statement] = STATE(480),
    [sym_if_statement] = STATE(480),
    [sym_switch_statement] = STATE(480),
    [sym_case_statement] = STATE(480),
    [sym_while_statement] = STATE(480),
    [sym_do_statement] = STATE(480),
    [sym_for_statement] = STATE(480),
    [sym_return_statement] = STATE(480),
    [sym_break_statement] = STATE(480),
    [sym_continue_statement] = STATE(480),
    [sym_goto_statement] = STATE(480),
    [sym_seh_try_statement] = STATE(480),
    [sym_seh_leave_statement] = STATE(480),
    [sym_expression] = STATE(5655),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10869),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(480),
    [sym_co_return_statement] = STATE(480),
    [sym_co_yield_statement] = STATE(480),
    [sym_throw_statement] = STATE(480),
    [sym_try_statement] = STATE(480),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(480),
    [sym_cbuffer_specifier] = STATE(480),
    [sym_hlsl_attribute] = STATE(10450),
    [aux_sym_attributed_declarator_repeat1] = STATE(1226),
    [sym_identifier] = ACTIONS(4622),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1157),
    [anon_sym___leave] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1165),
    [anon_sym_cbuffer] = ACTIONS(1167),
  },
  [1231] = {
    [sym_attribute_declaration] = STATE(1226),
    [sym_compound_statement] = STATE(480),
    [sym_attributed_statement] = STATE(480),
    [sym_statement] = STATE(356),
    [sym_labeled_statement] = STATE(480),
    [sym_expression_statement] = STATE(480),
    [sym_if_statement] = STATE(480),
    [sym_switch_statement] = STATE(480),
    [sym_case_statement] = STATE(480),
    [sym_while_statement] = STATE(480),
    [sym_do_statement] = STATE(480),
    [sym_for_statement] = STATE(480),
    [sym_return_statement] = STATE(480),
    [sym_break_statement] = STATE(480),
    [sym_continue_statement] = STATE(480),
    [sym_goto_statement] = STATE(480),
    [sym_seh_try_statement] = STATE(480),
    [sym_seh_leave_statement] = STATE(480),
    [sym_expression] = STATE(5655),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10869),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(480),
    [sym_co_return_statement] = STATE(480),
    [sym_co_yield_statement] = STATE(480),
    [sym_throw_statement] = STATE(480),
    [sym_try_statement] = STATE(480),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(480),
    [sym_cbuffer_specifier] = STATE(480),
    [sym_hlsl_attribute] = STATE(10450),
    [aux_sym_attributed_declarator_repeat1] = STATE(1226),
    [sym_identifier] = ACTIONS(4622),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1157),
    [anon_sym___leave] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1165),
    [anon_sym_cbuffer] = ACTIONS(1167),
  },
  [1232] = {
    [sym_attribute_declaration] = STATE(1214),
    [sym_compound_statement] = STATE(857),
    [sym_attributed_statement] = STATE(857),
    [sym_statement] = STATE(645),
    [sym_labeled_statement] = STATE(857),
    [sym_expression_statement] = STATE(857),
    [sym_if_statement] = STATE(857),
    [sym_switch_statement] = STATE(857),
    [sym_case_statement] = STATE(857),
    [sym_while_statement] = STATE(857),
    [sym_do_statement] = STATE(857),
    [sym_for_statement] = STATE(857),
    [sym_return_statement] = STATE(857),
    [sym_break_statement] = STATE(857),
    [sym_continue_statement] = STATE(857),
    [sym_goto_statement] = STATE(857),
    [sym_seh_try_statement] = STATE(857),
    [sym_seh_leave_statement] = STATE(857),
    [sym_expression] = STATE(5773),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10871),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(857),
    [sym_co_return_statement] = STATE(857),
    [sym_co_yield_statement] = STATE(857),
    [sym_throw_statement] = STATE(857),
    [sym_try_statement] = STATE(857),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(857),
    [sym_cbuffer_specifier] = STATE(857),
    [sym_hlsl_attribute] = STATE(10474),
    [aux_sym_attributed_declarator_repeat1] = STATE(1214),
    [sym_identifier] = ACTIONS(4435),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1083),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_case] = ACTIONS(1101),
    [anon_sym_default] = ACTIONS(1103),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1107),
    [anon_sym_for] = ACTIONS(1109),
    [anon_sym_return] = ACTIONS(1111),
    [anon_sym_break] = ACTIONS(1113),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_goto] = ACTIONS(1117),
    [anon_sym___try] = ACTIONS(1119),
    [anon_sym___leave] = ACTIONS(1121),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(1125),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_co_return] = ACTIONS(1135),
    [anon_sym_co_yield] = ACTIONS(1137),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1139),
    [anon_sym_cbuffer] = ACTIONS(1141),
  },
  [1233] = {
    [sym_attribute_declaration] = STATE(1220),
    [sym_compound_statement] = STATE(515),
    [sym_attributed_statement] = STATE(515),
    [sym_statement] = STATE(366),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(10675),
    [aux_sym_attributed_declarator_repeat1] = STATE(1220),
    [sym_identifier] = ACTIONS(4618),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_cbuffer] = ACTIONS(365),
  },
  [1234] = {
    [sym_attribute_declaration] = STATE(1244),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(868),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10697),
    [aux_sym_attributed_declarator_repeat1] = STATE(1244),
    [sym_identifier] = ACTIONS(4720),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_cbuffer] = ACTIONS(275),
  },
  [1235] = {
    [sym_attribute_declaration] = STATE(1220),
    [sym_compound_statement] = STATE(515),
    [sym_attributed_statement] = STATE(515),
    [sym_statement] = STATE(415),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(10675),
    [aux_sym_attributed_declarator_repeat1] = STATE(1220),
    [sym_identifier] = ACTIONS(4618),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_cbuffer] = ACTIONS(365),
  },
  [1236] = {
    [sym_attribute_declaration] = STATE(1214),
    [sym_compound_statement] = STATE(857),
    [sym_attributed_statement] = STATE(857),
    [sym_statement] = STATE(730),
    [sym_labeled_statement] = STATE(857),
    [sym_expression_statement] = STATE(857),
    [sym_if_statement] = STATE(857),
    [sym_switch_statement] = STATE(857),
    [sym_case_statement] = STATE(857),
    [sym_while_statement] = STATE(857),
    [sym_do_statement] = STATE(857),
    [sym_for_statement] = STATE(857),
    [sym_return_statement] = STATE(857),
    [sym_break_statement] = STATE(857),
    [sym_continue_statement] = STATE(857),
    [sym_goto_statement] = STATE(857),
    [sym_seh_try_statement] = STATE(857),
    [sym_seh_leave_statement] = STATE(857),
    [sym_expression] = STATE(5773),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10871),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(857),
    [sym_co_return_statement] = STATE(857),
    [sym_co_yield_statement] = STATE(857),
    [sym_throw_statement] = STATE(857),
    [sym_try_statement] = STATE(857),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(857),
    [sym_cbuffer_specifier] = STATE(857),
    [sym_hlsl_attribute] = STATE(10474),
    [aux_sym_attributed_declarator_repeat1] = STATE(1214),
    [sym_identifier] = ACTIONS(4435),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1083),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_case] = ACTIONS(1101),
    [anon_sym_default] = ACTIONS(1103),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1107),
    [anon_sym_for] = ACTIONS(1109),
    [anon_sym_return] = ACTIONS(1111),
    [anon_sym_break] = ACTIONS(1113),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_goto] = ACTIONS(1117),
    [anon_sym___try] = ACTIONS(1119),
    [anon_sym___leave] = ACTIONS(1121),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(1125),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_co_return] = ACTIONS(1135),
    [anon_sym_co_yield] = ACTIONS(1137),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1139),
    [anon_sym_cbuffer] = ACTIONS(1141),
  },
  [1237] = {
    [sym_attribute_declaration] = STATE(1220),
    [sym_compound_statement] = STATE(515),
    [sym_attributed_statement] = STATE(515),
    [sym_statement] = STATE(492),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(10675),
    [aux_sym_attributed_declarator_repeat1] = STATE(1220),
    [sym_identifier] = ACTIONS(4618),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_cbuffer] = ACTIONS(365),
  },
  [1238] = {
    [sym_attribute_declaration] = STATE(1244),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(809),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10697),
    [aux_sym_attributed_declarator_repeat1] = STATE(1244),
    [sym_identifier] = ACTIONS(4720),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_cbuffer] = ACTIONS(275),
  },
  [1239] = {
    [sym_attribute_declaration] = STATE(1220),
    [sym_compound_statement] = STATE(515),
    [sym_attributed_statement] = STATE(515),
    [sym_statement] = STATE(495),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(10675),
    [aux_sym_attributed_declarator_repeat1] = STATE(1220),
    [sym_identifier] = ACTIONS(4618),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_cbuffer] = ACTIONS(365),
  },
  [1240] = {
    [sym_attribute_declaration] = STATE(1214),
    [sym_compound_statement] = STATE(857),
    [sym_attributed_statement] = STATE(857),
    [sym_statement] = STATE(732),
    [sym_labeled_statement] = STATE(857),
    [sym_expression_statement] = STATE(857),
    [sym_if_statement] = STATE(857),
    [sym_switch_statement] = STATE(857),
    [sym_case_statement] = STATE(857),
    [sym_while_statement] = STATE(857),
    [sym_do_statement] = STATE(857),
    [sym_for_statement] = STATE(857),
    [sym_return_statement] = STATE(857),
    [sym_break_statement] = STATE(857),
    [sym_continue_statement] = STATE(857),
    [sym_goto_statement] = STATE(857),
    [sym_seh_try_statement] = STATE(857),
    [sym_seh_leave_statement] = STATE(857),
    [sym_expression] = STATE(5773),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10871),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(857),
    [sym_co_return_statement] = STATE(857),
    [sym_co_yield_statement] = STATE(857),
    [sym_throw_statement] = STATE(857),
    [sym_try_statement] = STATE(857),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(857),
    [sym_cbuffer_specifier] = STATE(857),
    [sym_hlsl_attribute] = STATE(10474),
    [aux_sym_attributed_declarator_repeat1] = STATE(1214),
    [sym_identifier] = ACTIONS(4435),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1083),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_case] = ACTIONS(1101),
    [anon_sym_default] = ACTIONS(1103),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1107),
    [anon_sym_for] = ACTIONS(1109),
    [anon_sym_return] = ACTIONS(1111),
    [anon_sym_break] = ACTIONS(1113),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_goto] = ACTIONS(1117),
    [anon_sym___try] = ACTIONS(1119),
    [anon_sym___leave] = ACTIONS(1121),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(1125),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_co_return] = ACTIONS(1135),
    [anon_sym_co_yield] = ACTIONS(1137),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1139),
    [anon_sym_cbuffer] = ACTIONS(1141),
  },
  [1241] = {
    [sym_attribute_declaration] = STATE(1214),
    [sym_compound_statement] = STATE(857),
    [sym_attributed_statement] = STATE(857),
    [sym_statement] = STATE(733),
    [sym_labeled_statement] = STATE(857),
    [sym_expression_statement] = STATE(857),
    [sym_if_statement] = STATE(857),
    [sym_switch_statement] = STATE(857),
    [sym_case_statement] = STATE(857),
    [sym_while_statement] = STATE(857),
    [sym_do_statement] = STATE(857),
    [sym_for_statement] = STATE(857),
    [sym_return_statement] = STATE(857),
    [sym_break_statement] = STATE(857),
    [sym_continue_statement] = STATE(857),
    [sym_goto_statement] = STATE(857),
    [sym_seh_try_statement] = STATE(857),
    [sym_seh_leave_statement] = STATE(857),
    [sym_expression] = STATE(5773),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10871),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(857),
    [sym_co_return_statement] = STATE(857),
    [sym_co_yield_statement] = STATE(857),
    [sym_throw_statement] = STATE(857),
    [sym_try_statement] = STATE(857),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(857),
    [sym_cbuffer_specifier] = STATE(857),
    [sym_hlsl_attribute] = STATE(10474),
    [aux_sym_attributed_declarator_repeat1] = STATE(1214),
    [sym_identifier] = ACTIONS(4435),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1083),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_case] = ACTIONS(1101),
    [anon_sym_default] = ACTIONS(1103),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1107),
    [anon_sym_for] = ACTIONS(1109),
    [anon_sym_return] = ACTIONS(1111),
    [anon_sym_break] = ACTIONS(1113),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_goto] = ACTIONS(1117),
    [anon_sym___try] = ACTIONS(1119),
    [anon_sym___leave] = ACTIONS(1121),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(1125),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_co_return] = ACTIONS(1135),
    [anon_sym_co_yield] = ACTIONS(1137),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1139),
    [anon_sym_cbuffer] = ACTIONS(1141),
  },
  [1242] = {
    [sym_attribute_declaration] = STATE(1214),
    [sym_compound_statement] = STATE(857),
    [sym_attributed_statement] = STATE(857),
    [sym_statement] = STATE(677),
    [sym_labeled_statement] = STATE(857),
    [sym_expression_statement] = STATE(857),
    [sym_if_statement] = STATE(857),
    [sym_switch_statement] = STATE(857),
    [sym_case_statement] = STATE(857),
    [sym_while_statement] = STATE(857),
    [sym_do_statement] = STATE(857),
    [sym_for_statement] = STATE(857),
    [sym_return_statement] = STATE(857),
    [sym_break_statement] = STATE(857),
    [sym_continue_statement] = STATE(857),
    [sym_goto_statement] = STATE(857),
    [sym_seh_try_statement] = STATE(857),
    [sym_seh_leave_statement] = STATE(857),
    [sym_expression] = STATE(5773),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10871),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(857),
    [sym_co_return_statement] = STATE(857),
    [sym_co_yield_statement] = STATE(857),
    [sym_throw_statement] = STATE(857),
    [sym_try_statement] = STATE(857),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(857),
    [sym_cbuffer_specifier] = STATE(857),
    [sym_hlsl_attribute] = STATE(10474),
    [aux_sym_attributed_declarator_repeat1] = STATE(1214),
    [sym_identifier] = ACTIONS(4435),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1083),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_case] = ACTIONS(1101),
    [anon_sym_default] = ACTIONS(1103),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1107),
    [anon_sym_for] = ACTIONS(1109),
    [anon_sym_return] = ACTIONS(1111),
    [anon_sym_break] = ACTIONS(1113),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_goto] = ACTIONS(1117),
    [anon_sym___try] = ACTIONS(1119),
    [anon_sym___leave] = ACTIONS(1121),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(1125),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_co_return] = ACTIONS(1135),
    [anon_sym_co_yield] = ACTIONS(1137),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1139),
    [anon_sym_cbuffer] = ACTIONS(1141),
  },
  [1243] = {
    [sym_attribute_declaration] = STATE(1227),
    [sym_compound_statement] = STATE(1415),
    [sym_attributed_statement] = STATE(1415),
    [sym_statement] = STATE(1377),
    [sym_labeled_statement] = STATE(1415),
    [sym_expression_statement] = STATE(1415),
    [sym_if_statement] = STATE(1415),
    [sym_switch_statement] = STATE(1415),
    [sym_case_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_do_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_break_statement] = STATE(1415),
    [sym_continue_statement] = STATE(1415),
    [sym_goto_statement] = STATE(1415),
    [sym_seh_try_statement] = STATE(1415),
    [sym_seh_leave_statement] = STATE(1415),
    [sym_expression] = STATE(5664),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11323),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(1415),
    [sym_co_return_statement] = STATE(1415),
    [sym_co_yield_statement] = STATE(1415),
    [sym_throw_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(1415),
    [sym_cbuffer_specifier] = STATE(1415),
    [sym_hlsl_attribute] = STATE(10401),
    [aux_sym_attributed_declarator_repeat1] = STATE(1227),
    [sym_identifier] = ACTIONS(4866),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2044),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_switch] = ACTIONS(2050),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2058),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2062),
    [anon_sym_break] = ACTIONS(2064),
    [anon_sym_continue] = ACTIONS(2066),
    [anon_sym_goto] = ACTIONS(2068),
    [anon_sym___try] = ACTIONS(2070),
    [anon_sym___leave] = ACTIONS(2072),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(2074),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(2076),
    [anon_sym_co_return] = ACTIONS(2078),
    [anon_sym_co_yield] = ACTIONS(2080),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(2082),
    [anon_sym_cbuffer] = ACTIONS(2084),
  },
  [1244] = {
    [sym_attribute_declaration] = STATE(1190),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(851),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10697),
    [aux_sym_attributed_declarator_repeat1] = STATE(1190),
    [sym_identifier] = ACTIONS(4720),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_cbuffer] = ACTIONS(275),
  },
  [1245] = {
    [sym_attribute_declaration] = STATE(1226),
    [sym_compound_statement] = STATE(480),
    [sym_attributed_statement] = STATE(480),
    [sym_statement] = STATE(464),
    [sym_labeled_statement] = STATE(480),
    [sym_expression_statement] = STATE(480),
    [sym_if_statement] = STATE(480),
    [sym_switch_statement] = STATE(480),
    [sym_case_statement] = STATE(480),
    [sym_while_statement] = STATE(480),
    [sym_do_statement] = STATE(480),
    [sym_for_statement] = STATE(480),
    [sym_return_statement] = STATE(480),
    [sym_break_statement] = STATE(480),
    [sym_continue_statement] = STATE(480),
    [sym_goto_statement] = STATE(480),
    [sym_seh_try_statement] = STATE(480),
    [sym_seh_leave_statement] = STATE(480),
    [sym_expression] = STATE(5655),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10869),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(480),
    [sym_co_return_statement] = STATE(480),
    [sym_co_yield_statement] = STATE(480),
    [sym_throw_statement] = STATE(480),
    [sym_try_statement] = STATE(480),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(480),
    [sym_cbuffer_specifier] = STATE(480),
    [sym_hlsl_attribute] = STATE(10450),
    [aux_sym_attributed_declarator_repeat1] = STATE(1226),
    [sym_identifier] = ACTIONS(4622),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1157),
    [anon_sym___leave] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1165),
    [anon_sym_cbuffer] = ACTIONS(1167),
  },
  [1246] = {
    [sym_attribute_declaration] = STATE(1244),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(811),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10697),
    [aux_sym_attributed_declarator_repeat1] = STATE(1244),
    [sym_identifier] = ACTIONS(4720),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_cbuffer] = ACTIONS(275),
  },
  [1247] = {
    [sym_attribute_declaration] = STATE(1220),
    [sym_compound_statement] = STATE(515),
    [sym_attributed_statement] = STATE(515),
    [sym_statement] = STATE(497),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(10675),
    [aux_sym_attributed_declarator_repeat1] = STATE(1220),
    [sym_identifier] = ACTIONS(4618),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_cbuffer] = ACTIONS(365),
  },
  [1248] = {
    [sym_attribute_declaration] = STATE(1243),
    [sym_compound_statement] = STATE(1415),
    [sym_attributed_statement] = STATE(1415),
    [sym_statement] = STATE(1349),
    [sym_labeled_statement] = STATE(1415),
    [sym_expression_statement] = STATE(1415),
    [sym_if_statement] = STATE(1415),
    [sym_switch_statement] = STATE(1415),
    [sym_case_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_do_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_break_statement] = STATE(1415),
    [sym_continue_statement] = STATE(1415),
    [sym_goto_statement] = STATE(1415),
    [sym_seh_try_statement] = STATE(1415),
    [sym_seh_leave_statement] = STATE(1415),
    [sym_expression] = STATE(5664),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11323),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(1415),
    [sym_co_return_statement] = STATE(1415),
    [sym_co_yield_statement] = STATE(1415),
    [sym_throw_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(1415),
    [sym_cbuffer_specifier] = STATE(1415),
    [sym_hlsl_attribute] = STATE(10401),
    [aux_sym_attributed_declarator_repeat1] = STATE(1243),
    [sym_identifier] = ACTIONS(4866),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2044),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_switch] = ACTIONS(2050),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2058),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2062),
    [anon_sym_break] = ACTIONS(2064),
    [anon_sym_continue] = ACTIONS(2066),
    [anon_sym_goto] = ACTIONS(2068),
    [anon_sym___try] = ACTIONS(2070),
    [anon_sym___leave] = ACTIONS(2072),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(2074),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(2076),
    [anon_sym_co_return] = ACTIONS(2078),
    [anon_sym_co_yield] = ACTIONS(2080),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(2082),
    [anon_sym_cbuffer] = ACTIONS(2084),
  },
  [1249] = {
    [sym_attribute_declaration] = STATE(1214),
    [sym_compound_statement] = STATE(857),
    [sym_attributed_statement] = STATE(857),
    [sym_statement] = STATE(741),
    [sym_labeled_statement] = STATE(857),
    [sym_expression_statement] = STATE(857),
    [sym_if_statement] = STATE(857),
    [sym_switch_statement] = STATE(857),
    [sym_case_statement] = STATE(857),
    [sym_while_statement] = STATE(857),
    [sym_do_statement] = STATE(857),
    [sym_for_statement] = STATE(857),
    [sym_return_statement] = STATE(857),
    [sym_break_statement] = STATE(857),
    [sym_continue_statement] = STATE(857),
    [sym_goto_statement] = STATE(857),
    [sym_seh_try_statement] = STATE(857),
    [sym_seh_leave_statement] = STATE(857),
    [sym_expression] = STATE(5773),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10871),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(857),
    [sym_co_return_statement] = STATE(857),
    [sym_co_yield_statement] = STATE(857),
    [sym_throw_statement] = STATE(857),
    [sym_try_statement] = STATE(857),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(857),
    [sym_cbuffer_specifier] = STATE(857),
    [sym_hlsl_attribute] = STATE(10474),
    [aux_sym_attributed_declarator_repeat1] = STATE(1214),
    [sym_identifier] = ACTIONS(4435),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1083),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_case] = ACTIONS(1101),
    [anon_sym_default] = ACTIONS(1103),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1107),
    [anon_sym_for] = ACTIONS(1109),
    [anon_sym_return] = ACTIONS(1111),
    [anon_sym_break] = ACTIONS(1113),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_goto] = ACTIONS(1117),
    [anon_sym___try] = ACTIONS(1119),
    [anon_sym___leave] = ACTIONS(1121),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(1125),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_co_return] = ACTIONS(1135),
    [anon_sym_co_yield] = ACTIONS(1137),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1139),
    [anon_sym_cbuffer] = ACTIONS(1141),
  },
  [1250] = {
    [sym_attribute_declaration] = STATE(1220),
    [sym_compound_statement] = STATE(515),
    [sym_attributed_statement] = STATE(515),
    [sym_statement] = STATE(339),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(10675),
    [aux_sym_attributed_declarator_repeat1] = STATE(1220),
    [sym_identifier] = ACTIONS(4618),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_cbuffer] = ACTIONS(365),
  },
  [1251] = {
    [sym_attribute_declaration] = STATE(1252),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(10922),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10419),
    [aux_sym_attributed_declarator_repeat1] = STATE(1252),
    [sym_identifier] = ACTIONS(4864),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(2092),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2094),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(2096),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(2098),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_cbuffer] = ACTIONS(2100),
  },
  [1252] = {
    [sym_attribute_declaration] = STATE(1206),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(443),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10419),
    [aux_sym_attributed_declarator_repeat1] = STATE(1206),
    [sym_identifier] = ACTIONS(4864),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(2092),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2094),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(2096),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(2098),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_cbuffer] = ACTIONS(2100),
  },
  [1253] = {
    [sym_attribute_declaration] = STATE(1226),
    [sym_compound_statement] = STATE(480),
    [sym_attributed_statement] = STATE(480),
    [sym_statement] = STATE(463),
    [sym_labeled_statement] = STATE(480),
    [sym_expression_statement] = STATE(480),
    [sym_if_statement] = STATE(480),
    [sym_switch_statement] = STATE(480),
    [sym_case_statement] = STATE(480),
    [sym_while_statement] = STATE(480),
    [sym_do_statement] = STATE(480),
    [sym_for_statement] = STATE(480),
    [sym_return_statement] = STATE(480),
    [sym_break_statement] = STATE(480),
    [sym_continue_statement] = STATE(480),
    [sym_goto_statement] = STATE(480),
    [sym_seh_try_statement] = STATE(480),
    [sym_seh_leave_statement] = STATE(480),
    [sym_expression] = STATE(5655),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10869),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(480),
    [sym_co_return_statement] = STATE(480),
    [sym_co_yield_statement] = STATE(480),
    [sym_throw_statement] = STATE(480),
    [sym_try_statement] = STATE(480),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(480),
    [sym_cbuffer_specifier] = STATE(480),
    [sym_hlsl_attribute] = STATE(10450),
    [aux_sym_attributed_declarator_repeat1] = STATE(1226),
    [sym_identifier] = ACTIONS(4622),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1157),
    [anon_sym___leave] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1165),
    [anon_sym_cbuffer] = ACTIONS(1167),
  },
  [1254] = {
    [sym_attribute_declaration] = STATE(1244),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(823),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10697),
    [aux_sym_attributed_declarator_repeat1] = STATE(1244),
    [sym_identifier] = ACTIONS(4720),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_cbuffer] = ACTIONS(275),
  },
  [1255] = {
    [sym_attribute_declaration] = STATE(1244),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(697),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10697),
    [aux_sym_attributed_declarator_repeat1] = STATE(1244),
    [sym_identifier] = ACTIONS(4720),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_cbuffer] = ACTIONS(275),
  },
  [1256] = {
    [sym_attribute_declaration] = STATE(1252),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(11234),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10419),
    [aux_sym_attributed_declarator_repeat1] = STATE(1252),
    [sym_identifier] = ACTIONS(4864),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(2092),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2094),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(2096),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(2098),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_cbuffer] = ACTIONS(2100),
  },
  [1257] = {
    [sym_attribute_declaration] = STATE(1220),
    [sym_compound_statement] = STATE(515),
    [sym_attributed_statement] = STATE(515),
    [sym_statement] = STATE(385),
    [sym_labeled_statement] = STATE(515),
    [sym_expression_statement] = STATE(515),
    [sym_if_statement] = STATE(515),
    [sym_switch_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_do_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_return_statement] = STATE(515),
    [sym_break_statement] = STATE(515),
    [sym_continue_statement] = STATE(515),
    [sym_goto_statement] = STATE(515),
    [sym_seh_try_statement] = STATE(515),
    [sym_seh_leave_statement] = STATE(515),
    [sym_expression] = STATE(5654),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11615),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(515),
    [sym_co_return_statement] = STATE(515),
    [sym_co_yield_statement] = STATE(515),
    [sym_throw_statement] = STATE(515),
    [sym_try_statement] = STATE(515),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(515),
    [sym_cbuffer_specifier] = STATE(515),
    [sym_hlsl_attribute] = STATE(10675),
    [aux_sym_attributed_declarator_repeat1] = STATE(1220),
    [sym_identifier] = ACTIONS(4618),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(321),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(325),
    [anon_sym_default] = ACTIONS(327),
    [anon_sym_while] = ACTIONS(329),
    [anon_sym_do] = ACTIONS(331),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(335),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(339),
    [anon_sym_goto] = ACTIONS(341),
    [anon_sym___try] = ACTIONS(343),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(351),
    [anon_sym_co_return] = ACTIONS(359),
    [anon_sym_co_yield] = ACTIONS(361),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(363),
    [anon_sym_cbuffer] = ACTIONS(365),
  },
  [1258] = {
    [sym_attribute_declaration] = STATE(1244),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(660),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10697),
    [aux_sym_attributed_declarator_repeat1] = STATE(1244),
    [sym_identifier] = ACTIONS(4720),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_switch] = ACTIONS(221),
    [anon_sym_case] = ACTIONS(223),
    [anon_sym_default] = ACTIONS(225),
    [anon_sym_while] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(231),
    [anon_sym_return] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_goto] = ACTIONS(239),
    [anon_sym___try] = ACTIONS(241),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(259),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(261),
    [anon_sym_co_return] = ACTIONS(269),
    [anon_sym_co_yield] = ACTIONS(271),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_cbuffer] = ACTIONS(275),
  },
  [1259] = {
    [sym_attribute_declaration] = STATE(1252),
    [sym_compound_statement] = STATE(842),
    [sym_attributed_statement] = STATE(842),
    [sym_statement] = STATE(11313),
    [sym_labeled_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_switch_statement] = STATE(842),
    [sym_case_statement] = STATE(842),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_return_statement] = STATE(842),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(842),
    [sym_goto_statement] = STATE(842),
    [sym_seh_try_statement] = STATE(842),
    [sym_seh_leave_statement] = STATE(842),
    [sym_expression] = STATE(5821),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10942),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(842),
    [sym_co_return_statement] = STATE(842),
    [sym_co_yield_statement] = STATE(842),
    [sym_throw_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(842),
    [sym_cbuffer_specifier] = STATE(842),
    [sym_hlsl_attribute] = STATE(10419),
    [aux_sym_attributed_declarator_repeat1] = STATE(1252),
    [sym_identifier] = ACTIONS(4864),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(2092),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2094),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(2096),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(2098),
    [anon_sym___leave] = ACTIONS(243),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(273),
    [anon_sym_cbuffer] = ACTIONS(2100),
  },
  [1260] = {
    [sym_attribute_declaration] = STATE(1243),
    [sym_compound_statement] = STATE(1415),
    [sym_attributed_statement] = STATE(1415),
    [sym_statement] = STATE(1348),
    [sym_labeled_statement] = STATE(1415),
    [sym_expression_statement] = STATE(1415),
    [sym_if_statement] = STATE(1415),
    [sym_switch_statement] = STATE(1415),
    [sym_case_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_do_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_break_statement] = STATE(1415),
    [sym_continue_statement] = STATE(1415),
    [sym_goto_statement] = STATE(1415),
    [sym_seh_try_statement] = STATE(1415),
    [sym_seh_leave_statement] = STATE(1415),
    [sym_expression] = STATE(5664),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11323),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(1415),
    [sym_co_return_statement] = STATE(1415),
    [sym_co_yield_statement] = STATE(1415),
    [sym_throw_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(1415),
    [sym_cbuffer_specifier] = STATE(1415),
    [sym_hlsl_attribute] = STATE(10401),
    [aux_sym_attributed_declarator_repeat1] = STATE(1243),
    [sym_identifier] = ACTIONS(4866),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(2044),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_switch] = ACTIONS(2050),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2058),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2062),
    [anon_sym_break] = ACTIONS(2064),
    [anon_sym_continue] = ACTIONS(2066),
    [anon_sym_goto] = ACTIONS(2068),
    [anon_sym___try] = ACTIONS(2070),
    [anon_sym___leave] = ACTIONS(2072),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(2074),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(2076),
    [anon_sym_co_return] = ACTIONS(2078),
    [anon_sym_co_yield] = ACTIONS(2080),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(2082),
    [anon_sym_cbuffer] = ACTIONS(2084),
  },
  [1261] = {
    [sym_attribute_declaration] = STATE(1226),
    [sym_compound_statement] = STATE(480),
    [sym_attributed_statement] = STATE(480),
    [sym_statement] = STATE(461),
    [sym_labeled_statement] = STATE(480),
    [sym_expression_statement] = STATE(480),
    [sym_if_statement] = STATE(480),
    [sym_switch_statement] = STATE(480),
    [sym_case_statement] = STATE(480),
    [sym_while_statement] = STATE(480),
    [sym_do_statement] = STATE(480),
    [sym_for_statement] = STATE(480),
    [sym_return_statement] = STATE(480),
    [sym_break_statement] = STATE(480),
    [sym_continue_statement] = STATE(480),
    [sym_goto_statement] = STATE(480),
    [sym_seh_try_statement] = STATE(480),
    [sym_seh_leave_statement] = STATE(480),
    [sym_expression] = STATE(5655),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10869),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_for_range_loop] = STATE(480),
    [sym_co_return_statement] = STATE(480),
    [sym_co_yield_statement] = STATE(480),
    [sym_throw_statement] = STATE(480),
    [sym_try_statement] = STATE(480),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_discard_statement] = STATE(480),
    [sym_cbuffer_specifier] = STATE(480),
    [sym_hlsl_attribute] = STATE(10450),
    [aux_sym_attributed_declarator_repeat1] = STATE(1226),
    [sym_identifier] = ACTIONS(4622),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1157),
    [anon_sym___leave] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_discard] = ACTIONS(1165),
    [anon_sym_cbuffer] = ACTIONS(1167),
  },
  [1262] = {
    [sym_expression] = STATE(3353),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_initializer_list] = STATE(3384),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4954),
    [anon_sym_COMMA] = ACTIONS(4954),
    [anon_sym_RPAREN] = ACTIONS(4954),
    [anon_sym_LPAREN2] = ACTIONS(4954),
    [anon_sym_BANG] = ACTIONS(5000),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(4952),
    [anon_sym_PLUS] = ACTIONS(4952),
    [anon_sym_STAR] = ACTIONS(4952),
    [anon_sym_SLASH] = ACTIONS(4952),
    [anon_sym_PERCENT] = ACTIONS(4952),
    [anon_sym_PIPE_PIPE] = ACTIONS(4954),
    [anon_sym_AMP_AMP] = ACTIONS(4954),
    [anon_sym_PIPE] = ACTIONS(4952),
    [anon_sym_CARET] = ACTIONS(4952),
    [anon_sym_AMP] = ACTIONS(4952),
    [anon_sym_EQ_EQ] = ACTIONS(4954),
    [anon_sym_BANG_EQ] = ACTIONS(4954),
    [anon_sym_GT] = ACTIONS(4952),
    [anon_sym_GT_EQ] = ACTIONS(4954),
    [anon_sym_LT_EQ] = ACTIONS(4952),
    [anon_sym_LT] = ACTIONS(4952),
    [anon_sym_LT_LT] = ACTIONS(4952),
    [anon_sym_GT_GT] = ACTIONS(4952),
    [anon_sym_SEMI] = ACTIONS(4954),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACE] = ACTIONS(4964),
    [anon_sym_RBRACE] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(4954),
    [anon_sym_RBRACK] = ACTIONS(4954),
    [anon_sym_EQ] = ACTIONS(4952),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_QMARK] = ACTIONS(4954),
    [anon_sym_STAR_EQ] = ACTIONS(4954),
    [anon_sym_SLASH_EQ] = ACTIONS(4954),
    [anon_sym_PERCENT_EQ] = ACTIONS(4954),
    [anon_sym_PLUS_EQ] = ACTIONS(4954),
    [anon_sym_DASH_EQ] = ACTIONS(4954),
    [anon_sym_LT_LT_EQ] = ACTIONS(4954),
    [anon_sym_GT_GT_EQ] = ACTIONS(4954),
    [anon_sym_AMP_EQ] = ACTIONS(4954),
    [anon_sym_CARET_EQ] = ACTIONS(4954),
    [anon_sym_PIPE_EQ] = ACTIONS(4954),
    [anon_sym_and_eq] = ACTIONS(4952),
    [anon_sym_or_eq] = ACTIONS(4952),
    [anon_sym_xor_eq] = ACTIONS(4952),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_LT_EQ_GT] = ACTIONS(4954),
    [anon_sym_or] = ACTIONS(4952),
    [anon_sym_and] = ACTIONS(4952),
    [anon_sym_bitor] = ACTIONS(4952),
    [anon_sym_xor] = ACTIONS(4952),
    [anon_sym_bitand] = ACTIONS(4952),
    [anon_sym_not_eq] = ACTIONS(4952),
    [anon_sym_is] = ACTIONS(4952),
    [anon_sym_as] = ACTIONS(4952),
    [anon_sym_DASH_DASH] = ACTIONS(4954),
    [anon_sym_PLUS_PLUS] = ACTIONS(4954),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [anon_sym_DOT] = ACTIONS(4952),
    [anon_sym_DOT_STAR] = ACTIONS(4954),
    [anon_sym_DASH_GT] = ACTIONS(4954),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1263] = {
    [sym_function_definition] = STATE(886),
    [sym_declaration] = STATE(886),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2919),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2594),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7999),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2786),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__empty_declaration] = STATE(886),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2671),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(886),
    [sym_operator_cast] = STATE(9201),
    [sym__constructor_specifiers] = STATE(2671),
    [sym_operator_cast_definition] = STATE(886),
    [sym_operator_cast_declaration] = STATE(886),
    [sym_constructor_or_destructor_definition] = STATE(886),
    [sym_constructor_or_destructor_declaration] = STATE(886),
    [sym_friend_declaration] = STATE(886),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_alias_declaration] = STATE(886),
    [sym_concept_definition] = STATE(886),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6972),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9201),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_hlsl_attribute] = STATE(1637),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(4445),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(4700),
    [anon_sym_COLON_COLON] = ACTIONS(4449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(4451),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(4702),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(4704),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(4706),
    [anon_sym_concept] = ACTIONS(267),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1264] = {
    [sym_function_definition] = STATE(965),
    [sym_declaration] = STATE(965),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6092),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2919),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2604),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7934),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__empty_declaration] = STATE(965),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2675),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(965),
    [sym_operator_cast] = STATE(9109),
    [sym__constructor_specifiers] = STATE(2675),
    [sym_operator_cast_definition] = STATE(965),
    [sym_operator_cast_declaration] = STATE(965),
    [sym_constructor_or_destructor_definition] = STATE(965),
    [sym_constructor_or_destructor_declaration] = STATE(965),
    [sym_friend_declaration] = STATE(965),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_alias_declaration] = STATE(965),
    [sym_concept_definition] = STATE(965),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6972),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9109),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_hlsl_attribute] = STATE(1642),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2675),
    [sym_identifier] = ACTIONS(4445),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(4692),
    [anon_sym_COLON_COLON] = ACTIONS(4449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(4451),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(4694),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(4696),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(4698),
    [anon_sym_concept] = ACTIONS(1133),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1265] = {
    [sym_function_definition] = STATE(552),
    [sym_declaration] = STATE(552),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2919),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2601),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7896),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2792),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__empty_declaration] = STATE(552),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2674),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(552),
    [sym_operator_cast] = STATE(9172),
    [sym__constructor_specifiers] = STATE(2674),
    [sym_operator_cast_definition] = STATE(552),
    [sym_operator_cast_declaration] = STATE(552),
    [sym_constructor_or_destructor_definition] = STATE(552),
    [sym_constructor_or_destructor_declaration] = STATE(552),
    [sym_friend_declaration] = STATE(552),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_alias_declaration] = STATE(552),
    [sym_concept_definition] = STATE(552),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6972),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9172),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_hlsl_attribute] = STATE(1645),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2674),
    [sym_identifier] = ACTIONS(4445),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(4708),
    [anon_sym_COLON_COLON] = ACTIONS(4449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(4451),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(4710),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(4712),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(4714),
    [anon_sym_concept] = ACTIONS(357),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1266] = {
    [sym_function_definition] = STATE(2253),
    [sym_declaration] = STATE(2253),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6111),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2919),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2613),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7985),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2787),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__empty_declaration] = STATE(2253),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2676),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(2253),
    [sym_operator_cast] = STATE(9196),
    [sym__constructor_specifiers] = STATE(2676),
    [sym_operator_cast_definition] = STATE(2253),
    [sym_operator_cast_declaration] = STATE(2253),
    [sym_constructor_or_destructor_definition] = STATE(2253),
    [sym_constructor_or_destructor_declaration] = STATE(2253),
    [sym_friend_declaration] = STATE(2253),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_alias_declaration] = STATE(2253),
    [sym_concept_definition] = STATE(2253),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6972),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9196),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_hlsl_attribute] = STATE(1640),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2676),
    [sym_identifier] = ACTIONS(4445),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(4457),
    [anon_sym_COLON_COLON] = ACTIONS(4449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(4451),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3170),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(3172),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3174),
    [anon_sym_concept] = ACTIONS(4459),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1267] = {
    [sym_function_definition] = STATE(1807),
    [sym_declaration] = STATE(1807),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6107),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2919),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2610),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7905),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2785),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__empty_declaration] = STATE(1807),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2677),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(1807),
    [sym_operator_cast] = STATE(9116),
    [sym__constructor_specifiers] = STATE(2677),
    [sym_operator_cast_definition] = STATE(1807),
    [sym_operator_cast_declaration] = STATE(1807),
    [sym_constructor_or_destructor_definition] = STATE(1807),
    [sym_constructor_or_destructor_declaration] = STATE(1807),
    [sym_friend_declaration] = STATE(1807),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_alias_declaration] = STATE(1807),
    [sym_concept_definition] = STATE(1807),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6972),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9116),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_hlsl_attribute] = STATE(1639),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2677),
    [sym_identifier] = ACTIONS(4445),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(4790),
    [anon_sym_COLON_COLON] = ACTIONS(4449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(4451),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2468),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(2484),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2486),
    [anon_sym_concept] = ACTIONS(4792),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1268] = {
    [sym_function_definition] = STATE(1133),
    [sym_declaration] = STATE(1133),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6100),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2919),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2234),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7927),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2791),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__empty_declaration] = STATE(1133),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2669),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(1133),
    [sym_operator_cast] = STATE(9025),
    [sym__constructor_specifiers] = STATE(2669),
    [sym_operator_cast_definition] = STATE(1133),
    [sym_operator_cast_declaration] = STATE(1133),
    [sym_constructor_or_destructor_definition] = STATE(1133),
    [sym_constructor_or_destructor_declaration] = STATE(1133),
    [sym_friend_declaration] = STATE(1133),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_alias_declaration] = STATE(1133),
    [sym_concept_definition] = STATE(1133),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6972),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9025),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_hlsl_attribute] = STATE(1636),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2669),
    [sym_identifier] = ACTIONS(4445),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(4610),
    [anon_sym_COLON_COLON] = ACTIONS(4449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(4451),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(4612),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(4614),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(4616),
    [anon_sym_concept] = ACTIONS(153),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1269] = {
    [sym_function_definition] = STATE(2107),
    [sym_declaration] = STATE(2107),
    [sym__declaration_modifiers] = STATE(2919),
    [sym__declaration_specifiers] = STATE(6104),
    [sym_attribute_specifier] = STATE(2919),
    [sym_attribute_declaration] = STATE(2919),
    [sym_ms_declspec_modifier] = STATE(2919),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(2607),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7899),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2919),
    [sym_type_qualifier] = STATE(2919),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2781),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym__empty_declaration] = STATE(2107),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_explicit_function_specifier] = STATE(2668),
    [sym_dependent_type] = STATE(2839),
    [sym_template_declaration] = STATE(2107),
    [sym_operator_cast] = STATE(9099),
    [sym__constructor_specifiers] = STATE(2668),
    [sym_operator_cast_definition] = STATE(2107),
    [sym_operator_cast_declaration] = STATE(2107),
    [sym_constructor_or_destructor_definition] = STATE(2107),
    [sym_constructor_or_destructor_declaration] = STATE(2107),
    [sym_friend_declaration] = STATE(2107),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_alias_declaration] = STATE(2107),
    [sym_concept_definition] = STATE(2107),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(6972),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualified_operator_cast_identifier] = STATE(9099),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2919),
    [sym_hlsl_attribute] = STATE(1643),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2668),
    [sym_identifier] = ACTIONS(4445),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(4447),
    [anon_sym_COLON_COLON] = ACTIONS(4449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(4451),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(3080),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_concept] = ACTIONS(4453),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1270] = {
    [sym_field_declaration_list] = STATE(1416),
    [sym_virtual_specifier] = STATE(9388),
    [sym_base_class_clause] = STATE(10686),
    [sym_identifier] = ACTIONS(2556),
    [anon_sym_LPAREN2] = ACTIONS(2558),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_TILDE] = ACTIONS(2558),
    [anon_sym_DASH] = ACTIONS(2556),
    [anon_sym_PLUS] = ACTIONS(2556),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_AMP] = ACTIONS(2558),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym___extension__] = ACTIONS(2556),
    [anon_sym_typedef] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2556),
    [anon_sym_out] = ACTIONS(2556),
    [anon_sym_inout] = ACTIONS(2556),
    [anon_sym_virtual] = ACTIONS(2556),
    [anon_sym_extern] = ACTIONS(2556),
    [anon_sym___attribute__] = ACTIONS(2556),
    [anon_sym___attribute] = ACTIONS(2556),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2558),
    [anon_sym___declspec] = ACTIONS(2556),
    [anon_sym_LBRACE] = ACTIONS(5024),
    [anon_sym_signed] = ACTIONS(2556),
    [anon_sym_unsigned] = ACTIONS(2556),
    [anon_sym_long] = ACTIONS(2556),
    [anon_sym_short] = ACTIONS(2556),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_static] = ACTIONS(2556),
    [anon_sym_register] = ACTIONS(2556),
    [anon_sym_inline] = ACTIONS(2556),
    [anon_sym___inline] = ACTIONS(2556),
    [anon_sym___inline__] = ACTIONS(2556),
    [anon_sym___forceinline] = ACTIONS(2556),
    [anon_sym_thread_local] = ACTIONS(2556),
    [anon_sym___thread] = ACTIONS(2556),
    [anon_sym_const] = ACTIONS(2556),
    [anon_sym_constexpr] = ACTIONS(2556),
    [anon_sym_volatile] = ACTIONS(2556),
    [anon_sym_restrict] = ACTIONS(2556),
    [anon_sym___restrict__] = ACTIONS(2556),
    [anon_sym__Atomic] = ACTIONS(2556),
    [anon_sym__Noreturn] = ACTIONS(2556),
    [anon_sym_noreturn] = ACTIONS(2556),
    [anon_sym__Nonnull] = ACTIONS(2556),
    [anon_sym_mutable] = ACTIONS(2556),
    [anon_sym_constinit] = ACTIONS(2556),
    [anon_sym_consteval] = ACTIONS(2556),
    [anon_sym_alignas] = ACTIONS(2556),
    [anon_sym__Alignas] = ACTIONS(2556),
    [sym_primitive_type] = ACTIONS(2556),
    [anon_sym_enum] = ACTIONS(2556),
    [anon_sym_class] = ACTIONS(2556),
    [anon_sym_struct] = ACTIONS(2556),
    [anon_sym_union] = ACTIONS(2556),
    [anon_sym_if] = ACTIONS(2556),
    [anon_sym_else] = ACTIONS(2556),
    [anon_sym_switch] = ACTIONS(2556),
    [anon_sym_while] = ACTIONS(2556),
    [anon_sym_do] = ACTIONS(2556),
    [anon_sym_for] = ACTIONS(2556),
    [anon_sym_return] = ACTIONS(2556),
    [anon_sym_break] = ACTIONS(2556),
    [anon_sym_continue] = ACTIONS(2556),
    [anon_sym_goto] = ACTIONS(2556),
    [anon_sym___try] = ACTIONS(2556),
    [anon_sym___leave] = ACTIONS(2556),
    [anon_sym_not] = ACTIONS(2556),
    [anon_sym_compl] = ACTIONS(2556),
    [anon_sym_DASH_DASH] = ACTIONS(2558),
    [anon_sym_PLUS_PLUS] = ACTIONS(2558),
    [anon_sym_sizeof] = ACTIONS(2556),
    [anon_sym___alignof__] = ACTIONS(2556),
    [anon_sym___alignof] = ACTIONS(2556),
    [anon_sym__alignof] = ACTIONS(2556),
    [anon_sym_alignof] = ACTIONS(2556),
    [anon_sym__Alignof] = ACTIONS(2556),
    [anon_sym_offsetof] = ACTIONS(2556),
    [anon_sym__Generic] = ACTIONS(2556),
    [anon_sym_asm] = ACTIONS(2556),
    [anon_sym___asm__] = ACTIONS(2556),
    [anon_sym___asm] = ACTIONS(2556),
    [sym_number_literal] = ACTIONS(2558),
    [anon_sym_L_SQUOTE] = ACTIONS(2558),
    [anon_sym_u_SQUOTE] = ACTIONS(2558),
    [anon_sym_U_SQUOTE] = ACTIONS(2558),
    [anon_sym_u8_SQUOTE] = ACTIONS(2558),
    [anon_sym_SQUOTE] = ACTIONS(2558),
    [anon_sym_L_DQUOTE] = ACTIONS(2558),
    [anon_sym_u_DQUOTE] = ACTIONS(2558),
    [anon_sym_U_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8_DQUOTE] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2558),
    [sym_true] = ACTIONS(2556),
    [sym_false] = ACTIONS(2556),
    [anon_sym_NULL] = ACTIONS(2556),
    [anon_sym_nullptr] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2556),
    [anon_sym_let] = ACTIONS(2556),
    [anon_sym_This] = ACTIONS(2556),
    [anon_sym_decltype] = ACTIONS(2556),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_typename] = ACTIONS(2556),
    [anon_sym_template] = ACTIONS(2556),
    [anon_sym_try] = ACTIONS(2556),
    [anon_sym_delete] = ACTIONS(2556),
    [anon_sym_throw] = ACTIONS(2556),
    [anon_sym_co_return] = ACTIONS(2556),
    [anon_sym_co_yield] = ACTIONS(2556),
    [anon_sym_R_DQUOTE] = ACTIONS(2558),
    [anon_sym_LR_DQUOTE] = ACTIONS(2558),
    [anon_sym_uR_DQUOTE] = ACTIONS(2558),
    [anon_sym_UR_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2558),
    [anon_sym_co_await] = ACTIONS(2556),
    [anon_sym_new] = ACTIONS(2556),
    [anon_sym_requires] = ACTIONS(2556),
    [sym_this] = ACTIONS(2556),
    [anon_sym_discard] = ACTIONS(2556),
    [anon_sym_precise] = ACTIONS(2556),
    [anon_sym_shared] = ACTIONS(2556),
    [anon_sym_groupshared] = ACTIONS(2556),
    [anon_sym_uniform] = ACTIONS(2556),
    [anon_sym_row_major] = ACTIONS(2556),
    [anon_sym_column_major] = ACTIONS(2556),
    [anon_sym_globallycoherent] = ACTIONS(2556),
    [anon_sym_centroid] = ACTIONS(2556),
    [anon_sym_noperspective] = ACTIONS(2556),
    [anon_sym_nointerpolation] = ACTIONS(2556),
    [anon_sym_sample] = ACTIONS(2556),
    [anon_sym_linear] = ACTIONS(2556),
    [anon_sym_snorm] = ACTIONS(2556),
    [anon_sym_unorm] = ACTIONS(2556),
    [anon_sym_point] = ACTIONS(2556),
    [anon_sym_line] = ACTIONS(2556),
    [anon_sym_triangleadj] = ACTIONS(2556),
    [anon_sym_lineadj] = ACTIONS(2556),
    [anon_sym_triangle] = ACTIONS(2556),
    [anon_sym_cbuffer] = ACTIONS(2556),
    [anon_sym_interface] = ACTIONS(2556),
    [anon_sym_extension] = ACTIONS(2556),
  },
  [1271] = {
    [sym_expression] = STATE(3353),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_initializer_list] = STATE(3384),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4954),
    [anon_sym_COMMA] = ACTIONS(4954),
    [anon_sym_LPAREN2] = ACTIONS(4954),
    [anon_sym_BANG] = ACTIONS(5028),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(4952),
    [anon_sym_PLUS] = ACTIONS(4952),
    [anon_sym_STAR] = ACTIONS(4952),
    [anon_sym_SLASH] = ACTIONS(4952),
    [anon_sym_PERCENT] = ACTIONS(4952),
    [anon_sym_PIPE_PIPE] = ACTIONS(4954),
    [anon_sym_AMP_AMP] = ACTIONS(4954),
    [anon_sym_PIPE] = ACTIONS(4952),
    [anon_sym_CARET] = ACTIONS(4952),
    [anon_sym_AMP] = ACTIONS(4952),
    [anon_sym_EQ_EQ] = ACTIONS(4954),
    [anon_sym_BANG_EQ] = ACTIONS(4954),
    [anon_sym_GT] = ACTIONS(4952),
    [anon_sym_GT_EQ] = ACTIONS(4954),
    [anon_sym_LT_EQ] = ACTIONS(4952),
    [anon_sym_LT] = ACTIONS(4952),
    [anon_sym_LT_LT] = ACTIONS(4952),
    [anon_sym_GT_GT] = ACTIONS(4952),
    [anon_sym_SEMI] = ACTIONS(4954),
    [anon_sym___extension__] = ACTIONS(5032),
    [anon_sym___attribute__] = ACTIONS(4952),
    [anon_sym___attribute] = ACTIONS(4952),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACE] = ACTIONS(4964),
    [anon_sym_LBRACK] = ACTIONS(4954),
    [anon_sym_EQ] = ACTIONS(4952),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_QMARK] = ACTIONS(4954),
    [anon_sym_STAR_EQ] = ACTIONS(4954),
    [anon_sym_SLASH_EQ] = ACTIONS(4954),
    [anon_sym_PERCENT_EQ] = ACTIONS(4954),
    [anon_sym_PLUS_EQ] = ACTIONS(4954),
    [anon_sym_DASH_EQ] = ACTIONS(4954),
    [anon_sym_LT_LT_EQ] = ACTIONS(4954),
    [anon_sym_GT_GT_EQ] = ACTIONS(4954),
    [anon_sym_AMP_EQ] = ACTIONS(4954),
    [anon_sym_CARET_EQ] = ACTIONS(4954),
    [anon_sym_PIPE_EQ] = ACTIONS(4954),
    [anon_sym_and_eq] = ACTIONS(4952),
    [anon_sym_or_eq] = ACTIONS(4952),
    [anon_sym_xor_eq] = ACTIONS(4952),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_LT_EQ_GT] = ACTIONS(4954),
    [anon_sym_or] = ACTIONS(4952),
    [anon_sym_and] = ACTIONS(4952),
    [anon_sym_bitor] = ACTIONS(4952),
    [anon_sym_xor] = ACTIONS(4952),
    [anon_sym_bitand] = ACTIONS(4952),
    [anon_sym_not_eq] = ACTIONS(4952),
    [anon_sym_is] = ACTIONS(4952),
    [anon_sym_as] = ACTIONS(4952),
    [anon_sym_DASH_DASH] = ACTIONS(4954),
    [anon_sym_PLUS_PLUS] = ACTIONS(4954),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [anon_sym_DOT] = ACTIONS(4952),
    [anon_sym_DOT_STAR] = ACTIONS(4954),
    [anon_sym_DASH_GT] = ACTIONS(4954),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1272] = {
    [sym_field_declaration_list] = STATE(1372),
    [sym_virtual_specifier] = STATE(9383),
    [sym_base_class_clause] = STATE(10730),
    [sym_identifier] = ACTIONS(2566),
    [anon_sym_LPAREN2] = ACTIONS(2568),
    [anon_sym_BANG] = ACTIONS(2568),
    [anon_sym_TILDE] = ACTIONS(2568),
    [anon_sym_DASH] = ACTIONS(2566),
    [anon_sym_PLUS] = ACTIONS(2566),
    [anon_sym_STAR] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2568),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2568),
    [anon_sym___extension__] = ACTIONS(2566),
    [anon_sym_typedef] = ACTIONS(2566),
    [anon_sym_in] = ACTIONS(2566),
    [anon_sym_out] = ACTIONS(2566),
    [anon_sym_inout] = ACTIONS(2566),
    [anon_sym_virtual] = ACTIONS(2566),
    [anon_sym_extern] = ACTIONS(2566),
    [anon_sym___attribute__] = ACTIONS(2566),
    [anon_sym___attribute] = ACTIONS(2566),
    [anon_sym_COLON_COLON] = ACTIONS(2568),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2568),
    [anon_sym___declspec] = ACTIONS(2566),
    [anon_sym_LBRACE] = ACTIONS(5024),
    [anon_sym_signed] = ACTIONS(2566),
    [anon_sym_unsigned] = ACTIONS(2566),
    [anon_sym_long] = ACTIONS(2566),
    [anon_sym_short] = ACTIONS(2566),
    [anon_sym_LBRACK] = ACTIONS(2566),
    [anon_sym_static] = ACTIONS(2566),
    [anon_sym_register] = ACTIONS(2566),
    [anon_sym_inline] = ACTIONS(2566),
    [anon_sym___inline] = ACTIONS(2566),
    [anon_sym___inline__] = ACTIONS(2566),
    [anon_sym___forceinline] = ACTIONS(2566),
    [anon_sym_thread_local] = ACTIONS(2566),
    [anon_sym___thread] = ACTIONS(2566),
    [anon_sym_const] = ACTIONS(2566),
    [anon_sym_constexpr] = ACTIONS(2566),
    [anon_sym_volatile] = ACTIONS(2566),
    [anon_sym_restrict] = ACTIONS(2566),
    [anon_sym___restrict__] = ACTIONS(2566),
    [anon_sym__Atomic] = ACTIONS(2566),
    [anon_sym__Noreturn] = ACTIONS(2566),
    [anon_sym_noreturn] = ACTIONS(2566),
    [anon_sym__Nonnull] = ACTIONS(2566),
    [anon_sym_mutable] = ACTIONS(2566),
    [anon_sym_constinit] = ACTIONS(2566),
    [anon_sym_consteval] = ACTIONS(2566),
    [anon_sym_alignas] = ACTIONS(2566),
    [anon_sym__Alignas] = ACTIONS(2566),
    [sym_primitive_type] = ACTIONS(2566),
    [anon_sym_enum] = ACTIONS(2566),
    [anon_sym_class] = ACTIONS(2566),
    [anon_sym_struct] = ACTIONS(2566),
    [anon_sym_union] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2566),
    [anon_sym_else] = ACTIONS(2566),
    [anon_sym_switch] = ACTIONS(2566),
    [anon_sym_while] = ACTIONS(2566),
    [anon_sym_do] = ACTIONS(2566),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_break] = ACTIONS(2566),
    [anon_sym_continue] = ACTIONS(2566),
    [anon_sym_goto] = ACTIONS(2566),
    [anon_sym___try] = ACTIONS(2566),
    [anon_sym___leave] = ACTIONS(2566),
    [anon_sym_not] = ACTIONS(2566),
    [anon_sym_compl] = ACTIONS(2566),
    [anon_sym_DASH_DASH] = ACTIONS(2568),
    [anon_sym_PLUS_PLUS] = ACTIONS(2568),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2566),
    [anon_sym___alignof] = ACTIONS(2566),
    [anon_sym__alignof] = ACTIONS(2566),
    [anon_sym_alignof] = ACTIONS(2566),
    [anon_sym__Alignof] = ACTIONS(2566),
    [anon_sym_offsetof] = ACTIONS(2566),
    [anon_sym__Generic] = ACTIONS(2566),
    [anon_sym_asm] = ACTIONS(2566),
    [anon_sym___asm__] = ACTIONS(2566),
    [anon_sym___asm] = ACTIONS(2566),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2568),
    [anon_sym_u_SQUOTE] = ACTIONS(2568),
    [anon_sym_U_SQUOTE] = ACTIONS(2568),
    [anon_sym_u8_SQUOTE] = ACTIONS(2568),
    [anon_sym_SQUOTE] = ACTIONS(2568),
    [anon_sym_L_DQUOTE] = ACTIONS(2568),
    [anon_sym_u_DQUOTE] = ACTIONS(2568),
    [anon_sym_U_DQUOTE] = ACTIONS(2568),
    [anon_sym_u8_DQUOTE] = ACTIONS(2568),
    [anon_sym_DQUOTE] = ACTIONS(2568),
    [sym_true] = ACTIONS(2566),
    [sym_false] = ACTIONS(2566),
    [anon_sym_NULL] = ACTIONS(2566),
    [anon_sym_nullptr] = ACTIONS(2566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2566),
    [anon_sym_let] = ACTIONS(2566),
    [anon_sym_This] = ACTIONS(2566),
    [anon_sym_decltype] = ACTIONS(2566),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_typename] = ACTIONS(2566),
    [anon_sym_template] = ACTIONS(2566),
    [anon_sym_try] = ACTIONS(2566),
    [anon_sym_delete] = ACTIONS(2566),
    [anon_sym_throw] = ACTIONS(2566),
    [anon_sym_co_return] = ACTIONS(2566),
    [anon_sym_co_yield] = ACTIONS(2566),
    [anon_sym_R_DQUOTE] = ACTIONS(2568),
    [anon_sym_LR_DQUOTE] = ACTIONS(2568),
    [anon_sym_uR_DQUOTE] = ACTIONS(2568),
    [anon_sym_UR_DQUOTE] = ACTIONS(2568),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2568),
    [anon_sym_co_await] = ACTIONS(2566),
    [anon_sym_new] = ACTIONS(2566),
    [anon_sym_requires] = ACTIONS(2566),
    [sym_this] = ACTIONS(2566),
    [anon_sym_discard] = ACTIONS(2566),
    [anon_sym_precise] = ACTIONS(2566),
    [anon_sym_shared] = ACTIONS(2566),
    [anon_sym_groupshared] = ACTIONS(2566),
    [anon_sym_uniform] = ACTIONS(2566),
    [anon_sym_row_major] = ACTIONS(2566),
    [anon_sym_column_major] = ACTIONS(2566),
    [anon_sym_globallycoherent] = ACTIONS(2566),
    [anon_sym_centroid] = ACTIONS(2566),
    [anon_sym_noperspective] = ACTIONS(2566),
    [anon_sym_nointerpolation] = ACTIONS(2566),
    [anon_sym_sample] = ACTIONS(2566),
    [anon_sym_linear] = ACTIONS(2566),
    [anon_sym_snorm] = ACTIONS(2566),
    [anon_sym_unorm] = ACTIONS(2566),
    [anon_sym_point] = ACTIONS(2566),
    [anon_sym_line] = ACTIONS(2566),
    [anon_sym_triangleadj] = ACTIONS(2566),
    [anon_sym_lineadj] = ACTIONS(2566),
    [anon_sym_triangle] = ACTIONS(2566),
    [anon_sym_cbuffer] = ACTIONS(2566),
    [anon_sym_interface] = ACTIONS(2566),
    [anon_sym_extension] = ACTIONS(2566),
  },
  [1273] = {
    [sym_template_argument_list] = STATE(1307),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_LPAREN2] = ACTIONS(2408),
    [anon_sym_BANG] = ACTIONS(2408),
    [anon_sym_TILDE] = ACTIONS(2408),
    [anon_sym_DASH] = ACTIONS(2410),
    [anon_sym_PLUS] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(2408),
    [anon_sym_AMP] = ACTIONS(2408),
    [anon_sym_LT] = ACTIONS(5050),
    [anon_sym_COLON] = ACTIONS(2410),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym___extension__] = ACTIONS(2410),
    [anon_sym_typedef] = ACTIONS(2410),
    [anon_sym_in] = ACTIONS(2410),
    [anon_sym_out] = ACTIONS(2410),
    [anon_sym_inout] = ACTIONS(2410),
    [anon_sym_virtual] = ACTIONS(2410),
    [anon_sym_extern] = ACTIONS(2410),
    [anon_sym___attribute__] = ACTIONS(2410),
    [anon_sym___attribute] = ACTIONS(2410),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2408),
    [anon_sym___declspec] = ACTIONS(2410),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_signed] = ACTIONS(2410),
    [anon_sym_unsigned] = ACTIONS(2410),
    [anon_sym_long] = ACTIONS(2410),
    [anon_sym_short] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_static] = ACTIONS(2410),
    [anon_sym_register] = ACTIONS(2410),
    [anon_sym_inline] = ACTIONS(2410),
    [anon_sym___inline] = ACTIONS(2410),
    [anon_sym___inline__] = ACTIONS(2410),
    [anon_sym___forceinline] = ACTIONS(2410),
    [anon_sym_thread_local] = ACTIONS(2410),
    [anon_sym___thread] = ACTIONS(2410),
    [anon_sym_const] = ACTIONS(2410),
    [anon_sym_constexpr] = ACTIONS(2410),
    [anon_sym_volatile] = ACTIONS(2410),
    [anon_sym_restrict] = ACTIONS(2410),
    [anon_sym___restrict__] = ACTIONS(2410),
    [anon_sym__Atomic] = ACTIONS(2410),
    [anon_sym__Noreturn] = ACTIONS(2410),
    [anon_sym_noreturn] = ACTIONS(2410),
    [anon_sym__Nonnull] = ACTIONS(2410),
    [anon_sym_mutable] = ACTIONS(2410),
    [anon_sym_constinit] = ACTIONS(2410),
    [anon_sym_consteval] = ACTIONS(2410),
    [anon_sym_alignas] = ACTIONS(2410),
    [anon_sym__Alignas] = ACTIONS(2410),
    [sym_primitive_type] = ACTIONS(2410),
    [anon_sym_enum] = ACTIONS(2410),
    [anon_sym_class] = ACTIONS(2410),
    [anon_sym_struct] = ACTIONS(2410),
    [anon_sym_union] = ACTIONS(2410),
    [anon_sym_if] = ACTIONS(2410),
    [anon_sym_else] = ACTIONS(2410),
    [anon_sym_switch] = ACTIONS(2410),
    [anon_sym_while] = ACTIONS(2410),
    [anon_sym_do] = ACTIONS(2410),
    [anon_sym_for] = ACTIONS(2410),
    [anon_sym_return] = ACTIONS(2410),
    [anon_sym_break] = ACTIONS(2410),
    [anon_sym_continue] = ACTIONS(2410),
    [anon_sym_goto] = ACTIONS(2410),
    [anon_sym___try] = ACTIONS(2410),
    [anon_sym___leave] = ACTIONS(2410),
    [anon_sym_not] = ACTIONS(2410),
    [anon_sym_compl] = ACTIONS(2410),
    [anon_sym_DASH_DASH] = ACTIONS(2408),
    [anon_sym_PLUS_PLUS] = ACTIONS(2408),
    [anon_sym_sizeof] = ACTIONS(2410),
    [anon_sym___alignof__] = ACTIONS(2410),
    [anon_sym___alignof] = ACTIONS(2410),
    [anon_sym__alignof] = ACTIONS(2410),
    [anon_sym_alignof] = ACTIONS(2410),
    [anon_sym__Alignof] = ACTIONS(2410),
    [anon_sym_offsetof] = ACTIONS(2410),
    [anon_sym__Generic] = ACTIONS(2410),
    [anon_sym_asm] = ACTIONS(2410),
    [anon_sym___asm__] = ACTIONS(2410),
    [anon_sym___asm] = ACTIONS(2410),
    [sym_number_literal] = ACTIONS(2408),
    [anon_sym_L_SQUOTE] = ACTIONS(2408),
    [anon_sym_u_SQUOTE] = ACTIONS(2408),
    [anon_sym_U_SQUOTE] = ACTIONS(2408),
    [anon_sym_u8_SQUOTE] = ACTIONS(2408),
    [anon_sym_SQUOTE] = ACTIONS(2408),
    [anon_sym_L_DQUOTE] = ACTIONS(2408),
    [anon_sym_u_DQUOTE] = ACTIONS(2408),
    [anon_sym_U_DQUOTE] = ACTIONS(2408),
    [anon_sym_u8_DQUOTE] = ACTIONS(2408),
    [anon_sym_DQUOTE] = ACTIONS(2408),
    [sym_true] = ACTIONS(2410),
    [sym_false] = ACTIONS(2410),
    [anon_sym_NULL] = ACTIONS(2410),
    [anon_sym_nullptr] = ACTIONS(2410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2410),
    [anon_sym_let] = ACTIONS(2410),
    [anon_sym_This] = ACTIONS(2410),
    [anon_sym_decltype] = ACTIONS(2410),
    [anon_sym_final] = ACTIONS(2410),
    [anon_sym_override] = ACTIONS(2410),
    [anon_sym_typename] = ACTIONS(2410),
    [anon_sym_template] = ACTIONS(2410),
    [anon_sym_try] = ACTIONS(2410),
    [anon_sym_delete] = ACTIONS(2410),
    [anon_sym_throw] = ACTIONS(2410),
    [anon_sym_co_return] = ACTIONS(2410),
    [anon_sym_co_yield] = ACTIONS(2410),
    [anon_sym_R_DQUOTE] = ACTIONS(2408),
    [anon_sym_LR_DQUOTE] = ACTIONS(2408),
    [anon_sym_uR_DQUOTE] = ACTIONS(2408),
    [anon_sym_UR_DQUOTE] = ACTIONS(2408),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2408),
    [anon_sym_co_await] = ACTIONS(2410),
    [anon_sym_new] = ACTIONS(2410),
    [anon_sym_requires] = ACTIONS(2410),
    [sym_this] = ACTIONS(2410),
    [anon_sym_discard] = ACTIONS(2410),
    [anon_sym_precise] = ACTIONS(2410),
    [anon_sym_shared] = ACTIONS(2410),
    [anon_sym_groupshared] = ACTIONS(2410),
    [anon_sym_uniform] = ACTIONS(2410),
    [anon_sym_row_major] = ACTIONS(2410),
    [anon_sym_column_major] = ACTIONS(2410),
    [anon_sym_globallycoherent] = ACTIONS(2410),
    [anon_sym_centroid] = ACTIONS(2410),
    [anon_sym_noperspective] = ACTIONS(2410),
    [anon_sym_nointerpolation] = ACTIONS(2410),
    [anon_sym_sample] = ACTIONS(2410),
    [anon_sym_linear] = ACTIONS(2410),
    [anon_sym_snorm] = ACTIONS(2410),
    [anon_sym_unorm] = ACTIONS(2410),
    [anon_sym_point] = ACTIONS(2410),
    [anon_sym_line] = ACTIONS(2410),
    [anon_sym_triangleadj] = ACTIONS(2410),
    [anon_sym_lineadj] = ACTIONS(2410),
    [anon_sym_triangle] = ACTIONS(2410),
    [anon_sym_cbuffer] = ACTIONS(2410),
    [anon_sym_interface] = ACTIONS(2410),
    [anon_sym_extension] = ACTIONS(2410),
  },
  [1274] = {
    [sym_expression] = STATE(4157),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_initializer_list] = STATE(4641),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4954),
    [anon_sym_COMMA] = ACTIONS(4954),
    [anon_sym_RPAREN] = ACTIONS(4954),
    [anon_sym_LPAREN2] = ACTIONS(4954),
    [anon_sym_BANG] = ACTIONS(2807),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(4952),
    [anon_sym_PLUS] = ACTIONS(4952),
    [anon_sym_STAR] = ACTIONS(4952),
    [anon_sym_SLASH] = ACTIONS(4952),
    [anon_sym_PERCENT] = ACTIONS(4952),
    [anon_sym_PIPE_PIPE] = ACTIONS(4954),
    [anon_sym_AMP_AMP] = ACTIONS(4954),
    [anon_sym_PIPE] = ACTIONS(4952),
    [anon_sym_CARET] = ACTIONS(4952),
    [anon_sym_AMP] = ACTIONS(4952),
    [anon_sym_EQ_EQ] = ACTIONS(4954),
    [anon_sym_BANG_EQ] = ACTIONS(4954),
    [anon_sym_GT] = ACTIONS(4952),
    [anon_sym_GT_EQ] = ACTIONS(4954),
    [anon_sym_LT_EQ] = ACTIONS(4952),
    [anon_sym_LT] = ACTIONS(4952),
    [anon_sym_LT_LT] = ACTIONS(4952),
    [anon_sym_GT_GT] = ACTIONS(4952),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(5056),
    [anon_sym_LBRACK] = ACTIONS(4954),
    [anon_sym_EQ] = ACTIONS(4952),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_QMARK] = ACTIONS(4954),
    [anon_sym_STAR_EQ] = ACTIONS(4954),
    [anon_sym_SLASH_EQ] = ACTIONS(4954),
    [anon_sym_PERCENT_EQ] = ACTIONS(4954),
    [anon_sym_PLUS_EQ] = ACTIONS(4954),
    [anon_sym_DASH_EQ] = ACTIONS(4954),
    [anon_sym_LT_LT_EQ] = ACTIONS(4954),
    [anon_sym_GT_GT_EQ] = ACTIONS(4954),
    [anon_sym_AMP_EQ] = ACTIONS(4954),
    [anon_sym_CARET_EQ] = ACTIONS(4954),
    [anon_sym_PIPE_EQ] = ACTIONS(4954),
    [anon_sym_and_eq] = ACTIONS(4952),
    [anon_sym_or_eq] = ACTIONS(4952),
    [anon_sym_xor_eq] = ACTIONS(4952),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(4954),
    [anon_sym_or] = ACTIONS(4952),
    [anon_sym_and] = ACTIONS(4952),
    [anon_sym_bitor] = ACTIONS(4952),
    [anon_sym_xor] = ACTIONS(4952),
    [anon_sym_bitand] = ACTIONS(4952),
    [anon_sym_not_eq] = ACTIONS(4952),
    [anon_sym_is] = ACTIONS(4952),
    [anon_sym_as] = ACTIONS(4952),
    [anon_sym_DASH_DASH] = ACTIONS(4954),
    [anon_sym_PLUS_PLUS] = ACTIONS(4954),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [anon_sym_DOT] = ACTIONS(4952),
    [anon_sym_DOT_STAR] = ACTIONS(4954),
    [anon_sym_DASH_GT] = ACTIONS(4952),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4954),
    [sym_this] = ACTIONS(2851),
  },
  [1275] = {
    [sym_template_argument_list] = STATE(1307),
    [sym_identifier] = ACTIONS(2222),
    [anon_sym_LPAREN2] = ACTIONS(2229),
    [anon_sym_BANG] = ACTIONS(2229),
    [anon_sym_TILDE] = ACTIONS(2229),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2229),
    [anon_sym_LT] = ACTIONS(5050),
    [anon_sym_COLON] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(2229),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_typedef] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_virtual] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym___attribute] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2229),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_signed] = ACTIONS(2222),
    [anon_sym_unsigned] = ACTIONS(2222),
    [anon_sym_long] = ACTIONS(2222),
    [anon_sym_short] = ACTIONS(2222),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym__Nonnull] = ACTIONS(2222),
    [anon_sym_mutable] = ACTIONS(2222),
    [anon_sym_constinit] = ACTIONS(2222),
    [anon_sym_consteval] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [sym_primitive_type] = ACTIONS(2222),
    [anon_sym_enum] = ACTIONS(2222),
    [anon_sym_class] = ACTIONS(2222),
    [anon_sym_struct] = ACTIONS(2222),
    [anon_sym_union] = ACTIONS(2222),
    [anon_sym_if] = ACTIONS(2222),
    [anon_sym_else] = ACTIONS(2222),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_while] = ACTIONS(2222),
    [anon_sym_do] = ACTIONS(2222),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_return] = ACTIONS(2222),
    [anon_sym_break] = ACTIONS(2222),
    [anon_sym_continue] = ACTIONS(2222),
    [anon_sym_goto] = ACTIONS(2222),
    [anon_sym___try] = ACTIONS(2222),
    [anon_sym___leave] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_compl] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2229),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(2222),
    [anon_sym___alignof] = ACTIONS(2222),
    [anon_sym__alignof] = ACTIONS(2222),
    [anon_sym_alignof] = ACTIONS(2222),
    [anon_sym__Alignof] = ACTIONS(2222),
    [anon_sym_offsetof] = ACTIONS(2222),
    [anon_sym__Generic] = ACTIONS(2222),
    [anon_sym_asm] = ACTIONS(2222),
    [anon_sym___asm__] = ACTIONS(2222),
    [anon_sym___asm] = ACTIONS(2222),
    [sym_number_literal] = ACTIONS(2229),
    [anon_sym_L_SQUOTE] = ACTIONS(2229),
    [anon_sym_u_SQUOTE] = ACTIONS(2229),
    [anon_sym_U_SQUOTE] = ACTIONS(2229),
    [anon_sym_u8_SQUOTE] = ACTIONS(2229),
    [anon_sym_SQUOTE] = ACTIONS(2229),
    [anon_sym_L_DQUOTE] = ACTIONS(2229),
    [anon_sym_u_DQUOTE] = ACTIONS(2229),
    [anon_sym_U_DQUOTE] = ACTIONS(2229),
    [anon_sym_u8_DQUOTE] = ACTIONS(2229),
    [anon_sym_DQUOTE] = ACTIONS(2229),
    [sym_true] = ACTIONS(2222),
    [sym_false] = ACTIONS(2222),
    [anon_sym_NULL] = ACTIONS(2222),
    [anon_sym_nullptr] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2222),
    [anon_sym_let] = ACTIONS(2222),
    [anon_sym_This] = ACTIONS(2222),
    [anon_sym_decltype] = ACTIONS(2222),
    [anon_sym_final] = ACTIONS(2222),
    [anon_sym_override] = ACTIONS(2222),
    [anon_sym_typename] = ACTIONS(2222),
    [anon_sym_template] = ACTIONS(2222),
    [anon_sym_try] = ACTIONS(2222),
    [anon_sym_delete] = ACTIONS(2222),
    [anon_sym_throw] = ACTIONS(2222),
    [anon_sym_co_return] = ACTIONS(2222),
    [anon_sym_co_yield] = ACTIONS(2222),
    [anon_sym_R_DQUOTE] = ACTIONS(2229),
    [anon_sym_LR_DQUOTE] = ACTIONS(2229),
    [anon_sym_uR_DQUOTE] = ACTIONS(2229),
    [anon_sym_UR_DQUOTE] = ACTIONS(2229),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2229),
    [anon_sym_co_await] = ACTIONS(2222),
    [anon_sym_new] = ACTIONS(2222),
    [anon_sym_requires] = ACTIONS(2222),
    [sym_this] = ACTIONS(2222),
    [anon_sym_discard] = ACTIONS(2222),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_groupshared] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_row_major] = ACTIONS(2222),
    [anon_sym_column_major] = ACTIONS(2222),
    [anon_sym_globallycoherent] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym_nointerpolation] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_linear] = ACTIONS(2222),
    [anon_sym_snorm] = ACTIONS(2222),
    [anon_sym_unorm] = ACTIONS(2222),
    [anon_sym_point] = ACTIONS(2222),
    [anon_sym_line] = ACTIONS(2222),
    [anon_sym_triangleadj] = ACTIONS(2222),
    [anon_sym_lineadj] = ACTIONS(2222),
    [anon_sym_triangle] = ACTIONS(2222),
    [anon_sym_cbuffer] = ACTIONS(2222),
    [anon_sym_interface] = ACTIONS(2222),
    [anon_sym_extension] = ACTIONS(2222),
  },
  [1276] = {
    [sym_identifier] = ACTIONS(5060),
    [anon_sym_LPAREN2] = ACTIONS(5063),
    [anon_sym_BANG] = ACTIONS(5066),
    [anon_sym_TILDE] = ACTIONS(5063),
    [anon_sym_DASH] = ACTIONS(5068),
    [anon_sym_PLUS] = ACTIONS(5068),
    [anon_sym_STAR] = ACTIONS(5063),
    [anon_sym_AMP_AMP] = ACTIONS(5070),
    [anon_sym_AMP] = ACTIONS(5060),
    [anon_sym_SEMI] = ACTIONS(5066),
    [anon_sym___extension__] = ACTIONS(5060),
    [anon_sym_in] = ACTIONS(5072),
    [anon_sym_out] = ACTIONS(5072),
    [anon_sym_inout] = ACTIONS(5072),
    [anon_sym_virtual] = ACTIONS(5072),
    [anon_sym_extern] = ACTIONS(5072),
    [anon_sym___attribute__] = ACTIONS(5072),
    [anon_sym___attribute] = ACTIONS(5072),
    [anon_sym_using] = ACTIONS(5068),
    [anon_sym_COLON_COLON] = ACTIONS(5063),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5063),
    [anon_sym___declspec] = ACTIONS(5072),
    [anon_sym___based] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(5066),
    [anon_sym_signed] = ACTIONS(5072),
    [anon_sym_unsigned] = ACTIONS(5072),
    [anon_sym_long] = ACTIONS(5072),
    [anon_sym_short] = ACTIONS(5072),
    [anon_sym_LBRACK] = ACTIONS(5060),
    [anon_sym_static] = ACTIONS(5072),
    [anon_sym_register] = ACTIONS(5072),
    [anon_sym_inline] = ACTIONS(5072),
    [anon_sym___inline] = ACTIONS(5072),
    [anon_sym___inline__] = ACTIONS(5072),
    [anon_sym___forceinline] = ACTIONS(5072),
    [anon_sym_thread_local] = ACTIONS(5072),
    [anon_sym___thread] = ACTIONS(5072),
    [anon_sym_const] = ACTIONS(5072),
    [anon_sym_constexpr] = ACTIONS(5072),
    [anon_sym_volatile] = ACTIONS(5072),
    [anon_sym_restrict] = ACTIONS(5072),
    [anon_sym___restrict__] = ACTIONS(5072),
    [anon_sym__Atomic] = ACTIONS(5072),
    [anon_sym__Noreturn] = ACTIONS(5072),
    [anon_sym_noreturn] = ACTIONS(5072),
    [anon_sym__Nonnull] = ACTIONS(5072),
    [anon_sym_mutable] = ACTIONS(5072),
    [anon_sym_constinit] = ACTIONS(5072),
    [anon_sym_consteval] = ACTIONS(5072),
    [anon_sym_alignas] = ACTIONS(5072),
    [anon_sym__Alignas] = ACTIONS(5072),
    [sym_primitive_type] = ACTIONS(5060),
    [anon_sym_enum] = ACTIONS(5072),
    [anon_sym_class] = ACTIONS(5072),
    [anon_sym_struct] = ACTIONS(5072),
    [anon_sym_union] = ACTIONS(5072),
    [anon_sym_if] = ACTIONS(5068),
    [anon_sym_switch] = ACTIONS(5068),
    [anon_sym_case] = ACTIONS(5068),
    [anon_sym_default] = ACTIONS(5068),
    [anon_sym_while] = ACTIONS(5068),
    [anon_sym_do] = ACTIONS(5068),
    [anon_sym_for] = ACTIONS(5068),
    [anon_sym_return] = ACTIONS(5068),
    [anon_sym_break] = ACTIONS(5068),
    [anon_sym_continue] = ACTIONS(5068),
    [anon_sym_goto] = ACTIONS(5068),
    [anon_sym___try] = ACTIONS(5068),
    [anon_sym___leave] = ACTIONS(5068),
    [anon_sym_not] = ACTIONS(5068),
    [anon_sym_compl] = ACTIONS(5068),
    [anon_sym_DASH_DASH] = ACTIONS(5066),
    [anon_sym_PLUS_PLUS] = ACTIONS(5066),
    [anon_sym_sizeof] = ACTIONS(5068),
    [anon_sym___alignof__] = ACTIONS(5068),
    [anon_sym___alignof] = ACTIONS(5068),
    [anon_sym__alignof] = ACTIONS(5068),
    [anon_sym_alignof] = ACTIONS(5068),
    [anon_sym__Alignof] = ACTIONS(5068),
    [anon_sym_offsetof] = ACTIONS(5068),
    [anon_sym__Generic] = ACTIONS(5068),
    [anon_sym_asm] = ACTIONS(5068),
    [anon_sym___asm__] = ACTIONS(5068),
    [anon_sym___asm] = ACTIONS(5068),
    [sym_number_literal] = ACTIONS(5066),
    [anon_sym_L_SQUOTE] = ACTIONS(5066),
    [anon_sym_u_SQUOTE] = ACTIONS(5066),
    [anon_sym_U_SQUOTE] = ACTIONS(5066),
    [anon_sym_u8_SQUOTE] = ACTIONS(5066),
    [anon_sym_SQUOTE] = ACTIONS(5066),
    [anon_sym_L_DQUOTE] = ACTIONS(5066),
    [anon_sym_u_DQUOTE] = ACTIONS(5066),
    [anon_sym_U_DQUOTE] = ACTIONS(5066),
    [anon_sym_u8_DQUOTE] = ACTIONS(5066),
    [anon_sym_DQUOTE] = ACTIONS(5066),
    [sym_true] = ACTIONS(5068),
    [sym_false] = ACTIONS(5068),
    [anon_sym_NULL] = ACTIONS(5068),
    [anon_sym_nullptr] = ACTIONS(5068),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5072),
    [anon_sym_let] = ACTIONS(5072),
    [anon_sym_This] = ACTIONS(5072),
    [anon_sym_decltype] = ACTIONS(5060),
    [anon_sym_explicit] = ACTIONS(5072),
    [anon_sym_typename] = ACTIONS(5072),
    [anon_sym_template] = ACTIONS(5060),
    [anon_sym_operator] = ACTIONS(5072),
    [anon_sym_try] = ACTIONS(5068),
    [anon_sym_delete] = ACTIONS(5068),
    [anon_sym_throw] = ACTIONS(5068),
    [anon_sym_co_return] = ACTIONS(5068),
    [anon_sym_co_yield] = ACTIONS(5068),
    [anon_sym_R_DQUOTE] = ACTIONS(5066),
    [anon_sym_LR_DQUOTE] = ACTIONS(5066),
    [anon_sym_uR_DQUOTE] = ACTIONS(5066),
    [anon_sym_UR_DQUOTE] = ACTIONS(5066),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5066),
    [anon_sym_co_await] = ACTIONS(5068),
    [anon_sym_new] = ACTIONS(5068),
    [anon_sym_requires] = ACTIONS(5068),
    [sym_this] = ACTIONS(5068),
    [anon_sym_discard] = ACTIONS(5068),
    [anon_sym_precise] = ACTIONS(5072),
    [anon_sym_shared] = ACTIONS(5072),
    [anon_sym_groupshared] = ACTIONS(5072),
    [anon_sym_uniform] = ACTIONS(5072),
    [anon_sym_row_major] = ACTIONS(5072),
    [anon_sym_column_major] = ACTIONS(5072),
    [anon_sym_globallycoherent] = ACTIONS(5072),
    [anon_sym_centroid] = ACTIONS(5072),
    [anon_sym_noperspective] = ACTIONS(5072),
    [anon_sym_nointerpolation] = ACTIONS(5072),
    [anon_sym_sample] = ACTIONS(5072),
    [anon_sym_linear] = ACTIONS(5072),
    [anon_sym_snorm] = ACTIONS(5072),
    [anon_sym_unorm] = ACTIONS(5072),
    [anon_sym_point] = ACTIONS(5072),
    [anon_sym_line] = ACTIONS(5072),
    [anon_sym_triangleadj] = ACTIONS(5072),
    [anon_sym_lineadj] = ACTIONS(5072),
    [anon_sym_triangle] = ACTIONS(5072),
    [anon_sym_cbuffer] = ACTIONS(5068),
    [anon_sym_interface] = ACTIONS(5072),
    [anon_sym_extension] = ACTIONS(5072),
  },
  [1277] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5582),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(8981),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(10124),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5124),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5130),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1278] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5491),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(8908),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(10040),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5146),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5148),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1279] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5571),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(8902),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(9857),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5150),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5152),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1280] = {
    [sym_expression] = STATE(4494),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_initializer_list] = STATE(3384),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4954),
    [anon_sym_COMMA] = ACTIONS(4954),
    [anon_sym_LPAREN2] = ACTIONS(4954),
    [anon_sym_BANG] = ACTIONS(5154),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(4952),
    [anon_sym_PLUS] = ACTIONS(4952),
    [anon_sym_STAR] = ACTIONS(4952),
    [anon_sym_SLASH] = ACTIONS(4952),
    [anon_sym_PERCENT] = ACTIONS(4952),
    [anon_sym_PIPE_PIPE] = ACTIONS(4954),
    [anon_sym_AMP_AMP] = ACTIONS(4954),
    [anon_sym_PIPE] = ACTIONS(4952),
    [anon_sym_CARET] = ACTIONS(4952),
    [anon_sym_AMP] = ACTIONS(4952),
    [anon_sym_EQ_EQ] = ACTIONS(4954),
    [anon_sym_BANG_EQ] = ACTIONS(4954),
    [anon_sym_GT] = ACTIONS(4952),
    [anon_sym_GT_EQ] = ACTIONS(4954),
    [anon_sym_LT_EQ] = ACTIONS(4952),
    [anon_sym_LT] = ACTIONS(4952),
    [anon_sym_LT_LT] = ACTIONS(4952),
    [anon_sym_GT_GT] = ACTIONS(4952),
    [anon_sym_COLON] = ACTIONS(4952),
    [anon_sym___extension__] = ACTIONS(5158),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACE] = ACTIONS(4964),
    [anon_sym_LBRACK] = ACTIONS(4954),
    [anon_sym_EQ] = ACTIONS(4952),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_QMARK] = ACTIONS(4954),
    [anon_sym_STAR_EQ] = ACTIONS(4954),
    [anon_sym_SLASH_EQ] = ACTIONS(4954),
    [anon_sym_PERCENT_EQ] = ACTIONS(4954),
    [anon_sym_PLUS_EQ] = ACTIONS(4954),
    [anon_sym_DASH_EQ] = ACTIONS(4954),
    [anon_sym_LT_LT_EQ] = ACTIONS(4954),
    [anon_sym_GT_GT_EQ] = ACTIONS(4954),
    [anon_sym_AMP_EQ] = ACTIONS(4954),
    [anon_sym_CARET_EQ] = ACTIONS(4954),
    [anon_sym_PIPE_EQ] = ACTIONS(4954),
    [anon_sym_and_eq] = ACTIONS(4952),
    [anon_sym_or_eq] = ACTIONS(4952),
    [anon_sym_xor_eq] = ACTIONS(4952),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_LT_EQ_GT] = ACTIONS(4954),
    [anon_sym_or] = ACTIONS(4952),
    [anon_sym_and] = ACTIONS(4952),
    [anon_sym_bitor] = ACTIONS(4952),
    [anon_sym_xor] = ACTIONS(4952),
    [anon_sym_bitand] = ACTIONS(4952),
    [anon_sym_not_eq] = ACTIONS(4952),
    [anon_sym_is] = ACTIONS(4952),
    [anon_sym_as] = ACTIONS(4952),
    [anon_sym_DASH_DASH] = ACTIONS(4954),
    [anon_sym_PLUS_PLUS] = ACTIONS(4954),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [anon_sym_DOT] = ACTIONS(4952),
    [anon_sym_DOT_STAR] = ACTIONS(4954),
    [anon_sym_DASH_GT] = ACTIONS(4954),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1281] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5581),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(8962),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(9634),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5168),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5170),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1282] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5485),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(8937),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(10140),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5172),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5174),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1283] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5505),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(8909),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(9626),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5176),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5178),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1284] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5516),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(8978),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(9743),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5180),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5182),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1285] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5525),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(8910),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(9867),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5184),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5186),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1286] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5531),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(8923),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(9962),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5188),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5190),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1287] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5541),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(8940),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(10046),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5192),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5194),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1288] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5624),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(8914),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(10085),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5196),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5198),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1289] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5550),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(8976),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(10125),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5200),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5202),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1290] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5554),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(8899),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(10155),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5204),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5206),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1291] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5558),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(8941),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(10185),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5208),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5210),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1292] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5561),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(8975),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(10217),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5212),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5214),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1293] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5569),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(9024),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(10241),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5216),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5218),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1294] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5575),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(8956),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(10276),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5220),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5222),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1295] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5578),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(9023),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(10310),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5224),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5226),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1296] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5585),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(8982),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(10091),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5228),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5230),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1297] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5590),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(8990),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(10329),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5232),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5234),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1298] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5594),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(9008),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(9685),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5236),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5238),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1299] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5597),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(9009),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(9725),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5240),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5242),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1300] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5600),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(9010),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(9813),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5244),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5246),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1301] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5603),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(9015),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(9913),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5248),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5250),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1302] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5609),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(9016),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(9971),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5252),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5254),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1303] = {
    [sym_expression] = STATE(4475),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_initializer_list] = STATE(4775),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4954),
    [anon_sym_COMMA] = ACTIONS(4954),
    [anon_sym_LPAREN2] = ACTIONS(4954),
    [anon_sym_BANG] = ACTIONS(5258),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(4952),
    [anon_sym_PLUS] = ACTIONS(4952),
    [anon_sym_STAR] = ACTIONS(4952),
    [anon_sym_SLASH] = ACTIONS(4952),
    [anon_sym_PERCENT] = ACTIONS(4952),
    [anon_sym_PIPE_PIPE] = ACTIONS(4954),
    [anon_sym_AMP_AMP] = ACTIONS(4954),
    [anon_sym_PIPE] = ACTIONS(4952),
    [anon_sym_CARET] = ACTIONS(4952),
    [anon_sym_AMP] = ACTIONS(4952),
    [anon_sym_EQ_EQ] = ACTIONS(4954),
    [anon_sym_BANG_EQ] = ACTIONS(4954),
    [anon_sym_GT] = ACTIONS(4952),
    [anon_sym_GT_EQ] = ACTIONS(4952),
    [anon_sym_LT_EQ] = ACTIONS(4952),
    [anon_sym_LT] = ACTIONS(4952),
    [anon_sym_LT_LT] = ACTIONS(4952),
    [anon_sym_GT_GT] = ACTIONS(4952),
    [anon_sym___extension__] = ACTIONS(5262),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACE] = ACTIONS(5266),
    [anon_sym_LBRACK] = ACTIONS(4954),
    [anon_sym_EQ] = ACTIONS(4952),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_QMARK] = ACTIONS(4954),
    [anon_sym_STAR_EQ] = ACTIONS(4954),
    [anon_sym_SLASH_EQ] = ACTIONS(4954),
    [anon_sym_PERCENT_EQ] = ACTIONS(4954),
    [anon_sym_PLUS_EQ] = ACTIONS(4954),
    [anon_sym_DASH_EQ] = ACTIONS(4954),
    [anon_sym_LT_LT_EQ] = ACTIONS(4954),
    [anon_sym_GT_GT_EQ] = ACTIONS(4952),
    [anon_sym_AMP_EQ] = ACTIONS(4954),
    [anon_sym_CARET_EQ] = ACTIONS(4954),
    [anon_sym_PIPE_EQ] = ACTIONS(4954),
    [anon_sym_and_eq] = ACTIONS(4952),
    [anon_sym_or_eq] = ACTIONS(4952),
    [anon_sym_xor_eq] = ACTIONS(4952),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_LT_EQ_GT] = ACTIONS(4954),
    [anon_sym_or] = ACTIONS(4952),
    [anon_sym_and] = ACTIONS(4952),
    [anon_sym_bitor] = ACTIONS(4952),
    [anon_sym_xor] = ACTIONS(4952),
    [anon_sym_bitand] = ACTIONS(4952),
    [anon_sym_not_eq] = ACTIONS(4952),
    [anon_sym_is] = ACTIONS(4952),
    [anon_sym_as] = ACTIONS(4952),
    [anon_sym_DASH_DASH] = ACTIONS(4954),
    [anon_sym_PLUS_PLUS] = ACTIONS(4954),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [anon_sym_DOT] = ACTIONS(4952),
    [anon_sym_DOT_STAR] = ACTIONS(4954),
    [anon_sym_DASH_GT] = ACTIONS(4954),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(4954),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [1304] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5568),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(8966),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(9907),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5300),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(5302),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1305] = {
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2416),
    [anon_sym_TILDE] = ACTIONS(2416),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2416),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym___extension__] = ACTIONS(2418),
    [anon_sym_typedef] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(2418),
    [anon_sym_out] = ACTIONS(2418),
    [anon_sym_inout] = ACTIONS(2418),
    [anon_sym_virtual] = ACTIONS(2418),
    [anon_sym_extern] = ACTIONS(2418),
    [anon_sym___attribute__] = ACTIONS(2418),
    [anon_sym___attribute] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2416),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2416),
    [anon_sym___declspec] = ACTIONS(2418),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_signed] = ACTIONS(2418),
    [anon_sym_unsigned] = ACTIONS(2418),
    [anon_sym_long] = ACTIONS(2418),
    [anon_sym_short] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2418),
    [anon_sym_register] = ACTIONS(2418),
    [anon_sym_inline] = ACTIONS(2418),
    [anon_sym___inline] = ACTIONS(2418),
    [anon_sym___inline__] = ACTIONS(2418),
    [anon_sym___forceinline] = ACTIONS(2418),
    [anon_sym_thread_local] = ACTIONS(2418),
    [anon_sym___thread] = ACTIONS(2418),
    [anon_sym_const] = ACTIONS(2418),
    [anon_sym_constexpr] = ACTIONS(2418),
    [anon_sym_volatile] = ACTIONS(2418),
    [anon_sym_restrict] = ACTIONS(2418),
    [anon_sym___restrict__] = ACTIONS(2418),
    [anon_sym__Atomic] = ACTIONS(2418),
    [anon_sym__Noreturn] = ACTIONS(2418),
    [anon_sym_noreturn] = ACTIONS(2418),
    [anon_sym__Nonnull] = ACTIONS(2418),
    [anon_sym_mutable] = ACTIONS(2418),
    [anon_sym_constinit] = ACTIONS(2418),
    [anon_sym_consteval] = ACTIONS(2418),
    [anon_sym_alignas] = ACTIONS(2418),
    [anon_sym__Alignas] = ACTIONS(2418),
    [sym_primitive_type] = ACTIONS(2418),
    [anon_sym_enum] = ACTIONS(2418),
    [anon_sym_class] = ACTIONS(2418),
    [anon_sym_struct] = ACTIONS(2418),
    [anon_sym_union] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_else] = ACTIONS(2418),
    [anon_sym_switch] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_break] = ACTIONS(2418),
    [anon_sym_continue] = ACTIONS(2418),
    [anon_sym_goto] = ACTIONS(2418),
    [anon_sym___try] = ACTIONS(2418),
    [anon_sym___leave] = ACTIONS(2418),
    [anon_sym_not] = ACTIONS(2418),
    [anon_sym_compl] = ACTIONS(2418),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_sizeof] = ACTIONS(2418),
    [anon_sym___alignof__] = ACTIONS(2418),
    [anon_sym___alignof] = ACTIONS(2418),
    [anon_sym__alignof] = ACTIONS(2418),
    [anon_sym_alignof] = ACTIONS(2418),
    [anon_sym__Alignof] = ACTIONS(2418),
    [anon_sym_offsetof] = ACTIONS(2418),
    [anon_sym__Generic] = ACTIONS(2418),
    [anon_sym_asm] = ACTIONS(2418),
    [anon_sym___asm__] = ACTIONS(2418),
    [anon_sym___asm] = ACTIONS(2418),
    [sym_number_literal] = ACTIONS(2416),
    [anon_sym_L_SQUOTE] = ACTIONS(2416),
    [anon_sym_u_SQUOTE] = ACTIONS(2416),
    [anon_sym_U_SQUOTE] = ACTIONS(2416),
    [anon_sym_u8_SQUOTE] = ACTIONS(2416),
    [anon_sym_SQUOTE] = ACTIONS(2416),
    [anon_sym_L_DQUOTE] = ACTIONS(2416),
    [anon_sym_u_DQUOTE] = ACTIONS(2416),
    [anon_sym_U_DQUOTE] = ACTIONS(2416),
    [anon_sym_u8_DQUOTE] = ACTIONS(2416),
    [anon_sym_DQUOTE] = ACTIONS(2416),
    [sym_true] = ACTIONS(2418),
    [sym_false] = ACTIONS(2418),
    [anon_sym_NULL] = ACTIONS(2418),
    [anon_sym_nullptr] = ACTIONS(2418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_This] = ACTIONS(2418),
    [anon_sym_decltype] = ACTIONS(2418),
    [anon_sym_final] = ACTIONS(2418),
    [anon_sym_override] = ACTIONS(2418),
    [anon_sym_typename] = ACTIONS(2418),
    [anon_sym_template] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_delete] = ACTIONS(2418),
    [anon_sym_throw] = ACTIONS(2418),
    [anon_sym_co_return] = ACTIONS(2418),
    [anon_sym_co_yield] = ACTIONS(2418),
    [anon_sym_R_DQUOTE] = ACTIONS(2416),
    [anon_sym_LR_DQUOTE] = ACTIONS(2416),
    [anon_sym_uR_DQUOTE] = ACTIONS(2416),
    [anon_sym_UR_DQUOTE] = ACTIONS(2416),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2416),
    [anon_sym_co_await] = ACTIONS(2418),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_requires] = ACTIONS(2418),
    [sym_this] = ACTIONS(2418),
    [anon_sym_discard] = ACTIONS(2418),
    [anon_sym_precise] = ACTIONS(2418),
    [anon_sym_shared] = ACTIONS(2418),
    [anon_sym_groupshared] = ACTIONS(2418),
    [anon_sym_uniform] = ACTIONS(2418),
    [anon_sym_row_major] = ACTIONS(2418),
    [anon_sym_column_major] = ACTIONS(2418),
    [anon_sym_globallycoherent] = ACTIONS(2418),
    [anon_sym_centroid] = ACTIONS(2418),
    [anon_sym_noperspective] = ACTIONS(2418),
    [anon_sym_nointerpolation] = ACTIONS(2418),
    [anon_sym_sample] = ACTIONS(2418),
    [anon_sym_linear] = ACTIONS(2418),
    [anon_sym_snorm] = ACTIONS(2418),
    [anon_sym_unorm] = ACTIONS(2418),
    [anon_sym_point] = ACTIONS(2418),
    [anon_sym_line] = ACTIONS(2418),
    [anon_sym_triangleadj] = ACTIONS(2418),
    [anon_sym_lineadj] = ACTIONS(2418),
    [anon_sym_triangle] = ACTIONS(2418),
    [anon_sym_cbuffer] = ACTIONS(2418),
    [anon_sym_interface] = ACTIONS(2418),
    [anon_sym_extension] = ACTIONS(2418),
  },
  [1306] = {
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym_typedef] = ACTIONS(2422),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_out] = ACTIONS(2422),
    [anon_sym_inout] = ACTIONS(2422),
    [anon_sym_virtual] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2422),
    [anon_sym_unsigned] = ACTIONS(2422),
    [anon_sym_long] = ACTIONS(2422),
    [anon_sym_short] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_register] = ACTIONS(2422),
    [anon_sym_inline] = ACTIONS(2422),
    [anon_sym___inline] = ACTIONS(2422),
    [anon_sym___inline__] = ACTIONS(2422),
    [anon_sym___forceinline] = ACTIONS(2422),
    [anon_sym_thread_local] = ACTIONS(2422),
    [anon_sym___thread] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [sym_primitive_type] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
    [anon_sym_class] = ACTIONS(2422),
    [anon_sym_struct] = ACTIONS(2422),
    [anon_sym_union] = ACTIONS(2422),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(2422),
    [anon_sym_switch] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_break] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(2422),
    [anon_sym_goto] = ACTIONS(2422),
    [anon_sym___try] = ACTIONS(2422),
    [anon_sym___leave] = ACTIONS(2422),
    [anon_sym_not] = ACTIONS(2422),
    [anon_sym_compl] = ACTIONS(2422),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_sizeof] = ACTIONS(2422),
    [anon_sym___alignof__] = ACTIONS(2422),
    [anon_sym___alignof] = ACTIONS(2422),
    [anon_sym__alignof] = ACTIONS(2422),
    [anon_sym_alignof] = ACTIONS(2422),
    [anon_sym__Alignof] = ACTIONS(2422),
    [anon_sym_offsetof] = ACTIONS(2422),
    [anon_sym__Generic] = ACTIONS(2422),
    [anon_sym_asm] = ACTIONS(2422),
    [anon_sym___asm__] = ACTIONS(2422),
    [anon_sym___asm] = ACTIONS(2422),
    [sym_number_literal] = ACTIONS(2420),
    [anon_sym_L_SQUOTE] = ACTIONS(2420),
    [anon_sym_u_SQUOTE] = ACTIONS(2420),
    [anon_sym_U_SQUOTE] = ACTIONS(2420),
    [anon_sym_u8_SQUOTE] = ACTIONS(2420),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [anon_sym_L_DQUOTE] = ACTIONS(2420),
    [anon_sym_u_DQUOTE] = ACTIONS(2420),
    [anon_sym_U_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [sym_true] = ACTIONS(2422),
    [sym_false] = ACTIONS(2422),
    [anon_sym_NULL] = ACTIONS(2422),
    [anon_sym_nullptr] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_decltype] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_typename] = ACTIONS(2422),
    [anon_sym_template] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_delete] = ACTIONS(2422),
    [anon_sym_throw] = ACTIONS(2422),
    [anon_sym_co_return] = ACTIONS(2422),
    [anon_sym_co_yield] = ACTIONS(2422),
    [anon_sym_R_DQUOTE] = ACTIONS(2420),
    [anon_sym_LR_DQUOTE] = ACTIONS(2420),
    [anon_sym_uR_DQUOTE] = ACTIONS(2420),
    [anon_sym_UR_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2420),
    [anon_sym_co_await] = ACTIONS(2422),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_requires] = ACTIONS(2422),
    [sym_this] = ACTIONS(2422),
    [anon_sym_discard] = ACTIONS(2422),
    [anon_sym_precise] = ACTIONS(2422),
    [anon_sym_shared] = ACTIONS(2422),
    [anon_sym_groupshared] = ACTIONS(2422),
    [anon_sym_uniform] = ACTIONS(2422),
    [anon_sym_row_major] = ACTIONS(2422),
    [anon_sym_column_major] = ACTIONS(2422),
    [anon_sym_globallycoherent] = ACTIONS(2422),
    [anon_sym_centroid] = ACTIONS(2422),
    [anon_sym_noperspective] = ACTIONS(2422),
    [anon_sym_nointerpolation] = ACTIONS(2422),
    [anon_sym_sample] = ACTIONS(2422),
    [anon_sym_linear] = ACTIONS(2422),
    [anon_sym_snorm] = ACTIONS(2422),
    [anon_sym_unorm] = ACTIONS(2422),
    [anon_sym_point] = ACTIONS(2422),
    [anon_sym_line] = ACTIONS(2422),
    [anon_sym_triangleadj] = ACTIONS(2422),
    [anon_sym_lineadj] = ACTIONS(2422),
    [anon_sym_triangle] = ACTIONS(2422),
    [anon_sym_cbuffer] = ACTIONS(2422),
    [anon_sym_interface] = ACTIONS(2422),
    [anon_sym_extension] = ACTIONS(2422),
  },
  [1307] = {
    [sym_identifier] = ACTIONS(2243),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2243),
    [anon_sym_PLUS] = ACTIONS(2243),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_COLON] = ACTIONS(2243),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym_typedef] = ACTIONS(2243),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_out] = ACTIONS(2243),
    [anon_sym_inout] = ACTIONS(2243),
    [anon_sym_virtual] = ACTIONS(2243),
    [anon_sym_extern] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym___attribute] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2243),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_signed] = ACTIONS(2243),
    [anon_sym_unsigned] = ACTIONS(2243),
    [anon_sym_long] = ACTIONS(2243),
    [anon_sym_short] = ACTIONS(2243),
    [anon_sym_LBRACK] = ACTIONS(2243),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_register] = ACTIONS(2243),
    [anon_sym_inline] = ACTIONS(2243),
    [anon_sym___inline] = ACTIONS(2243),
    [anon_sym___inline__] = ACTIONS(2243),
    [anon_sym___forceinline] = ACTIONS(2243),
    [anon_sym_thread_local] = ACTIONS(2243),
    [anon_sym___thread] = ACTIONS(2243),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym__Nonnull] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [sym_primitive_type] = ACTIONS(2243),
    [anon_sym_enum] = ACTIONS(2243),
    [anon_sym_class] = ACTIONS(2243),
    [anon_sym_struct] = ACTIONS(2243),
    [anon_sym_union] = ACTIONS(2243),
    [anon_sym_if] = ACTIONS(2243),
    [anon_sym_else] = ACTIONS(2243),
    [anon_sym_switch] = ACTIONS(2243),
    [anon_sym_while] = ACTIONS(2243),
    [anon_sym_do] = ACTIONS(2243),
    [anon_sym_for] = ACTIONS(2243),
    [anon_sym_return] = ACTIONS(2243),
    [anon_sym_break] = ACTIONS(2243),
    [anon_sym_continue] = ACTIONS(2243),
    [anon_sym_goto] = ACTIONS(2243),
    [anon_sym___try] = ACTIONS(2243),
    [anon_sym___leave] = ACTIONS(2243),
    [anon_sym_not] = ACTIONS(2243),
    [anon_sym_compl] = ACTIONS(2243),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_sizeof] = ACTIONS(2243),
    [anon_sym___alignof__] = ACTIONS(2243),
    [anon_sym___alignof] = ACTIONS(2243),
    [anon_sym__alignof] = ACTIONS(2243),
    [anon_sym_alignof] = ACTIONS(2243),
    [anon_sym__Alignof] = ACTIONS(2243),
    [anon_sym_offsetof] = ACTIONS(2243),
    [anon_sym__Generic] = ACTIONS(2243),
    [anon_sym_asm] = ACTIONS(2243),
    [anon_sym___asm__] = ACTIONS(2243),
    [anon_sym___asm] = ACTIONS(2243),
    [sym_number_literal] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2250),
    [anon_sym_u_SQUOTE] = ACTIONS(2250),
    [anon_sym_U_SQUOTE] = ACTIONS(2250),
    [anon_sym_u8_SQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_L_DQUOTE] = ACTIONS(2250),
    [anon_sym_u_DQUOTE] = ACTIONS(2250),
    [anon_sym_U_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [sym_true] = ACTIONS(2243),
    [sym_false] = ACTIONS(2243),
    [anon_sym_NULL] = ACTIONS(2243),
    [anon_sym_nullptr] = ACTIONS(2243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2243),
    [anon_sym_let] = ACTIONS(2243),
    [anon_sym_This] = ACTIONS(2243),
    [anon_sym_decltype] = ACTIONS(2243),
    [anon_sym_final] = ACTIONS(2243),
    [anon_sym_override] = ACTIONS(2243),
    [anon_sym_typename] = ACTIONS(2243),
    [anon_sym_template] = ACTIONS(2243),
    [anon_sym_try] = ACTIONS(2243),
    [anon_sym_delete] = ACTIONS(2243),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_co_return] = ACTIONS(2243),
    [anon_sym_co_yield] = ACTIONS(2243),
    [anon_sym_R_DQUOTE] = ACTIONS(2250),
    [anon_sym_LR_DQUOTE] = ACTIONS(2250),
    [anon_sym_uR_DQUOTE] = ACTIONS(2250),
    [anon_sym_UR_DQUOTE] = ACTIONS(2250),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2250),
    [anon_sym_co_await] = ACTIONS(2243),
    [anon_sym_new] = ACTIONS(2243),
    [anon_sym_requires] = ACTIONS(2243),
    [sym_this] = ACTIONS(2243),
    [anon_sym_discard] = ACTIONS(2243),
    [anon_sym_precise] = ACTIONS(2243),
    [anon_sym_shared] = ACTIONS(2243),
    [anon_sym_groupshared] = ACTIONS(2243),
    [anon_sym_uniform] = ACTIONS(2243),
    [anon_sym_row_major] = ACTIONS(2243),
    [anon_sym_column_major] = ACTIONS(2243),
    [anon_sym_globallycoherent] = ACTIONS(2243),
    [anon_sym_centroid] = ACTIONS(2243),
    [anon_sym_noperspective] = ACTIONS(2243),
    [anon_sym_nointerpolation] = ACTIONS(2243),
    [anon_sym_sample] = ACTIONS(2243),
    [anon_sym_linear] = ACTIONS(2243),
    [anon_sym_snorm] = ACTIONS(2243),
    [anon_sym_unorm] = ACTIONS(2243),
    [anon_sym_point] = ACTIONS(2243),
    [anon_sym_line] = ACTIONS(2243),
    [anon_sym_triangleadj] = ACTIONS(2243),
    [anon_sym_lineadj] = ACTIONS(2243),
    [anon_sym_triangle] = ACTIONS(2243),
    [anon_sym_cbuffer] = ACTIONS(2243),
    [anon_sym_interface] = ACTIONS(2243),
    [anon_sym_extension] = ACTIONS(2243),
  },
  [1308] = {
    [sym_identifier] = ACTIONS(2428),
    [anon_sym_LPAREN2] = ACTIONS(2426),
    [anon_sym_BANG] = ACTIONS(2426),
    [anon_sym_TILDE] = ACTIONS(2426),
    [anon_sym_DASH] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2428),
    [anon_sym_STAR] = ACTIONS(2426),
    [anon_sym_AMP] = ACTIONS(2426),
    [anon_sym_COLON] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2426),
    [anon_sym___extension__] = ACTIONS(2428),
    [anon_sym_typedef] = ACTIONS(2428),
    [anon_sym_in] = ACTIONS(2428),
    [anon_sym_out] = ACTIONS(2428),
    [anon_sym_inout] = ACTIONS(2428),
    [anon_sym_virtual] = ACTIONS(2428),
    [anon_sym_extern] = ACTIONS(2428),
    [anon_sym___attribute__] = ACTIONS(2428),
    [anon_sym___attribute] = ACTIONS(2428),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2426),
    [anon_sym___declspec] = ACTIONS(2428),
    [anon_sym_LBRACE] = ACTIONS(2426),
    [anon_sym_signed] = ACTIONS(2428),
    [anon_sym_unsigned] = ACTIONS(2428),
    [anon_sym_long] = ACTIONS(2428),
    [anon_sym_short] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_static] = ACTIONS(2428),
    [anon_sym_register] = ACTIONS(2428),
    [anon_sym_inline] = ACTIONS(2428),
    [anon_sym___inline] = ACTIONS(2428),
    [anon_sym___inline__] = ACTIONS(2428),
    [anon_sym___forceinline] = ACTIONS(2428),
    [anon_sym_thread_local] = ACTIONS(2428),
    [anon_sym___thread] = ACTIONS(2428),
    [anon_sym_const] = ACTIONS(2428),
    [anon_sym_constexpr] = ACTIONS(2428),
    [anon_sym_volatile] = ACTIONS(2428),
    [anon_sym_restrict] = ACTIONS(2428),
    [anon_sym___restrict__] = ACTIONS(2428),
    [anon_sym__Atomic] = ACTIONS(2428),
    [anon_sym__Noreturn] = ACTIONS(2428),
    [anon_sym_noreturn] = ACTIONS(2428),
    [anon_sym__Nonnull] = ACTIONS(2428),
    [anon_sym_mutable] = ACTIONS(2428),
    [anon_sym_constinit] = ACTIONS(2428),
    [anon_sym_consteval] = ACTIONS(2428),
    [anon_sym_alignas] = ACTIONS(2428),
    [anon_sym__Alignas] = ACTIONS(2428),
    [sym_primitive_type] = ACTIONS(2428),
    [anon_sym_enum] = ACTIONS(2428),
    [anon_sym_class] = ACTIONS(2428),
    [anon_sym_struct] = ACTIONS(2428),
    [anon_sym_union] = ACTIONS(2428),
    [anon_sym_if] = ACTIONS(2428),
    [anon_sym_else] = ACTIONS(2428),
    [anon_sym_switch] = ACTIONS(2428),
    [anon_sym_while] = ACTIONS(2428),
    [anon_sym_do] = ACTIONS(2428),
    [anon_sym_for] = ACTIONS(2428),
    [anon_sym_return] = ACTIONS(2428),
    [anon_sym_break] = ACTIONS(2428),
    [anon_sym_continue] = ACTIONS(2428),
    [anon_sym_goto] = ACTIONS(2428),
    [anon_sym___try] = ACTIONS(2428),
    [anon_sym___leave] = ACTIONS(2428),
    [anon_sym_not] = ACTIONS(2428),
    [anon_sym_compl] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2426),
    [anon_sym_PLUS_PLUS] = ACTIONS(2426),
    [anon_sym_sizeof] = ACTIONS(2428),
    [anon_sym___alignof__] = ACTIONS(2428),
    [anon_sym___alignof] = ACTIONS(2428),
    [anon_sym__alignof] = ACTIONS(2428),
    [anon_sym_alignof] = ACTIONS(2428),
    [anon_sym__Alignof] = ACTIONS(2428),
    [anon_sym_offsetof] = ACTIONS(2428),
    [anon_sym__Generic] = ACTIONS(2428),
    [anon_sym_asm] = ACTIONS(2428),
    [anon_sym___asm__] = ACTIONS(2428),
    [anon_sym___asm] = ACTIONS(2428),
    [sym_number_literal] = ACTIONS(2426),
    [anon_sym_L_SQUOTE] = ACTIONS(2426),
    [anon_sym_u_SQUOTE] = ACTIONS(2426),
    [anon_sym_U_SQUOTE] = ACTIONS(2426),
    [anon_sym_u8_SQUOTE] = ACTIONS(2426),
    [anon_sym_SQUOTE] = ACTIONS(2426),
    [anon_sym_L_DQUOTE] = ACTIONS(2426),
    [anon_sym_u_DQUOTE] = ACTIONS(2426),
    [anon_sym_U_DQUOTE] = ACTIONS(2426),
    [anon_sym_u8_DQUOTE] = ACTIONS(2426),
    [anon_sym_DQUOTE] = ACTIONS(2426),
    [sym_true] = ACTIONS(2428),
    [sym_false] = ACTIONS(2428),
    [anon_sym_NULL] = ACTIONS(2428),
    [anon_sym_nullptr] = ACTIONS(2428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2428),
    [anon_sym_let] = ACTIONS(2428),
    [anon_sym_This] = ACTIONS(2428),
    [anon_sym_decltype] = ACTIONS(2428),
    [anon_sym_final] = ACTIONS(2428),
    [anon_sym_override] = ACTIONS(2428),
    [anon_sym_typename] = ACTIONS(2428),
    [anon_sym_template] = ACTIONS(2428),
    [anon_sym_try] = ACTIONS(2428),
    [anon_sym_delete] = ACTIONS(2428),
    [anon_sym_throw] = ACTIONS(2428),
    [anon_sym_co_return] = ACTIONS(2428),
    [anon_sym_co_yield] = ACTIONS(2428),
    [anon_sym_R_DQUOTE] = ACTIONS(2426),
    [anon_sym_LR_DQUOTE] = ACTIONS(2426),
    [anon_sym_uR_DQUOTE] = ACTIONS(2426),
    [anon_sym_UR_DQUOTE] = ACTIONS(2426),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2426),
    [anon_sym_co_await] = ACTIONS(2428),
    [anon_sym_new] = ACTIONS(2428),
    [anon_sym_requires] = ACTIONS(2428),
    [sym_this] = ACTIONS(2428),
    [anon_sym_discard] = ACTIONS(2428),
    [anon_sym_precise] = ACTIONS(2428),
    [anon_sym_shared] = ACTIONS(2428),
    [anon_sym_groupshared] = ACTIONS(2428),
    [anon_sym_uniform] = ACTIONS(2428),
    [anon_sym_row_major] = ACTIONS(2428),
    [anon_sym_column_major] = ACTIONS(2428),
    [anon_sym_globallycoherent] = ACTIONS(2428),
    [anon_sym_centroid] = ACTIONS(2428),
    [anon_sym_noperspective] = ACTIONS(2428),
    [anon_sym_nointerpolation] = ACTIONS(2428),
    [anon_sym_sample] = ACTIONS(2428),
    [anon_sym_linear] = ACTIONS(2428),
    [anon_sym_snorm] = ACTIONS(2428),
    [anon_sym_unorm] = ACTIONS(2428),
    [anon_sym_point] = ACTIONS(2428),
    [anon_sym_line] = ACTIONS(2428),
    [anon_sym_triangleadj] = ACTIONS(2428),
    [anon_sym_lineadj] = ACTIONS(2428),
    [anon_sym_triangle] = ACTIONS(2428),
    [anon_sym_cbuffer] = ACTIONS(2428),
    [anon_sym_interface] = ACTIONS(2428),
    [anon_sym_extension] = ACTIONS(2428),
  },
  [1309] = {
    [sym_identifier] = ACTIONS(2268),
    [anon_sym_LPAREN2] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2270),
    [anon_sym_TILDE] = ACTIONS(2270),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(2270),
    [anon_sym_COLON] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym___extension__] = ACTIONS(2268),
    [anon_sym_typedef] = ACTIONS(2268),
    [anon_sym_in] = ACTIONS(2268),
    [anon_sym_out] = ACTIONS(2268),
    [anon_sym_inout] = ACTIONS(2268),
    [anon_sym_virtual] = ACTIONS(2268),
    [anon_sym_extern] = ACTIONS(2268),
    [anon_sym___attribute__] = ACTIONS(2268),
    [anon_sym___attribute] = ACTIONS(2268),
    [anon_sym_COLON_COLON] = ACTIONS(2270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2270),
    [anon_sym___declspec] = ACTIONS(2268),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_signed] = ACTIONS(2268),
    [anon_sym_unsigned] = ACTIONS(2268),
    [anon_sym_long] = ACTIONS(2268),
    [anon_sym_short] = ACTIONS(2268),
    [anon_sym_LBRACK] = ACTIONS(2268),
    [anon_sym_static] = ACTIONS(2268),
    [anon_sym_register] = ACTIONS(2268),
    [anon_sym_inline] = ACTIONS(2268),
    [anon_sym___inline] = ACTIONS(2268),
    [anon_sym___inline__] = ACTIONS(2268),
    [anon_sym___forceinline] = ACTIONS(2268),
    [anon_sym_thread_local] = ACTIONS(2268),
    [anon_sym___thread] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_constexpr] = ACTIONS(2268),
    [anon_sym_volatile] = ACTIONS(2268),
    [anon_sym_restrict] = ACTIONS(2268),
    [anon_sym___restrict__] = ACTIONS(2268),
    [anon_sym__Atomic] = ACTIONS(2268),
    [anon_sym__Noreturn] = ACTIONS(2268),
    [anon_sym_noreturn] = ACTIONS(2268),
    [anon_sym__Nonnull] = ACTIONS(2268),
    [anon_sym_mutable] = ACTIONS(2268),
    [anon_sym_constinit] = ACTIONS(2268),
    [anon_sym_consteval] = ACTIONS(2268),
    [anon_sym_alignas] = ACTIONS(2268),
    [anon_sym__Alignas] = ACTIONS(2268),
    [sym_primitive_type] = ACTIONS(2268),
    [anon_sym_enum] = ACTIONS(2268),
    [anon_sym_class] = ACTIONS(2268),
    [anon_sym_struct] = ACTIONS(2268),
    [anon_sym_union] = ACTIONS(2268),
    [anon_sym_if] = ACTIONS(2268),
    [anon_sym_else] = ACTIONS(2268),
    [anon_sym_switch] = ACTIONS(2268),
    [anon_sym_while] = ACTIONS(2268),
    [anon_sym_do] = ACTIONS(2268),
    [anon_sym_for] = ACTIONS(2268),
    [anon_sym_return] = ACTIONS(2268),
    [anon_sym_break] = ACTIONS(2268),
    [anon_sym_continue] = ACTIONS(2268),
    [anon_sym_goto] = ACTIONS(2268),
    [anon_sym___try] = ACTIONS(2268),
    [anon_sym___leave] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2268),
    [anon_sym_compl] = ACTIONS(2268),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_sizeof] = ACTIONS(2268),
    [anon_sym___alignof__] = ACTIONS(2268),
    [anon_sym___alignof] = ACTIONS(2268),
    [anon_sym__alignof] = ACTIONS(2268),
    [anon_sym_alignof] = ACTIONS(2268),
    [anon_sym__Alignof] = ACTIONS(2268),
    [anon_sym_offsetof] = ACTIONS(2268),
    [anon_sym__Generic] = ACTIONS(2268),
    [anon_sym_asm] = ACTIONS(2268),
    [anon_sym___asm__] = ACTIONS(2268),
    [anon_sym___asm] = ACTIONS(2268),
    [sym_number_literal] = ACTIONS(2270),
    [anon_sym_L_SQUOTE] = ACTIONS(2270),
    [anon_sym_u_SQUOTE] = ACTIONS(2270),
    [anon_sym_U_SQUOTE] = ACTIONS(2270),
    [anon_sym_u8_SQUOTE] = ACTIONS(2270),
    [anon_sym_SQUOTE] = ACTIONS(2270),
    [anon_sym_L_DQUOTE] = ACTIONS(2270),
    [anon_sym_u_DQUOTE] = ACTIONS(2270),
    [anon_sym_U_DQUOTE] = ACTIONS(2270),
    [anon_sym_u8_DQUOTE] = ACTIONS(2270),
    [anon_sym_DQUOTE] = ACTIONS(2270),
    [sym_true] = ACTIONS(2268),
    [sym_false] = ACTIONS(2268),
    [anon_sym_NULL] = ACTIONS(2268),
    [anon_sym_nullptr] = ACTIONS(2268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_This] = ACTIONS(2268),
    [anon_sym_decltype] = ACTIONS(2268),
    [anon_sym_final] = ACTIONS(2268),
    [anon_sym_override] = ACTIONS(2268),
    [anon_sym_typename] = ACTIONS(2268),
    [anon_sym_template] = ACTIONS(2268),
    [anon_sym_try] = ACTIONS(2268),
    [anon_sym_delete] = ACTIONS(2268),
    [anon_sym_throw] = ACTIONS(2268),
    [anon_sym_co_return] = ACTIONS(2268),
    [anon_sym_co_yield] = ACTIONS(2268),
    [anon_sym_R_DQUOTE] = ACTIONS(2270),
    [anon_sym_LR_DQUOTE] = ACTIONS(2270),
    [anon_sym_uR_DQUOTE] = ACTIONS(2270),
    [anon_sym_UR_DQUOTE] = ACTIONS(2270),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2270),
    [anon_sym_co_await] = ACTIONS(2268),
    [anon_sym_new] = ACTIONS(2268),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2268),
    [anon_sym_discard] = ACTIONS(2268),
    [anon_sym_precise] = ACTIONS(2268),
    [anon_sym_shared] = ACTIONS(2268),
    [anon_sym_groupshared] = ACTIONS(2268),
    [anon_sym_uniform] = ACTIONS(2268),
    [anon_sym_row_major] = ACTIONS(2268),
    [anon_sym_column_major] = ACTIONS(2268),
    [anon_sym_globallycoherent] = ACTIONS(2268),
    [anon_sym_centroid] = ACTIONS(2268),
    [anon_sym_noperspective] = ACTIONS(2268),
    [anon_sym_nointerpolation] = ACTIONS(2268),
    [anon_sym_sample] = ACTIONS(2268),
    [anon_sym_linear] = ACTIONS(2268),
    [anon_sym_snorm] = ACTIONS(2268),
    [anon_sym_unorm] = ACTIONS(2268),
    [anon_sym_point] = ACTIONS(2268),
    [anon_sym_line] = ACTIONS(2268),
    [anon_sym_triangleadj] = ACTIONS(2268),
    [anon_sym_lineadj] = ACTIONS(2268),
    [anon_sym_triangle] = ACTIONS(2268),
    [anon_sym_cbuffer] = ACTIONS(2268),
    [anon_sym_interface] = ACTIONS(2268),
    [anon_sym_extension] = ACTIONS(2268),
  },
  [1310] = {
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_LPAREN2] = ACTIONS(2274),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2274),
    [anon_sym_AMP] = ACTIONS(2274),
    [anon_sym_COLON] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym___extension__] = ACTIONS(2272),
    [anon_sym_typedef] = ACTIONS(2272),
    [anon_sym_in] = ACTIONS(2272),
    [anon_sym_out] = ACTIONS(2272),
    [anon_sym_inout] = ACTIONS(2272),
    [anon_sym_virtual] = ACTIONS(2272),
    [anon_sym_extern] = ACTIONS(2272),
    [anon_sym___attribute__] = ACTIONS(2272),
    [anon_sym___attribute] = ACTIONS(2272),
    [anon_sym_COLON_COLON] = ACTIONS(2274),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2274),
    [anon_sym___declspec] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_signed] = ACTIONS(2272),
    [anon_sym_unsigned] = ACTIONS(2272),
    [anon_sym_long] = ACTIONS(2272),
    [anon_sym_short] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_register] = ACTIONS(2272),
    [anon_sym_inline] = ACTIONS(2272),
    [anon_sym___inline] = ACTIONS(2272),
    [anon_sym___inline__] = ACTIONS(2272),
    [anon_sym___forceinline] = ACTIONS(2272),
    [anon_sym_thread_local] = ACTIONS(2272),
    [anon_sym___thread] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_constexpr] = ACTIONS(2272),
    [anon_sym_volatile] = ACTIONS(2272),
    [anon_sym_restrict] = ACTIONS(2272),
    [anon_sym___restrict__] = ACTIONS(2272),
    [anon_sym__Atomic] = ACTIONS(2272),
    [anon_sym__Noreturn] = ACTIONS(2272),
    [anon_sym_noreturn] = ACTIONS(2272),
    [anon_sym__Nonnull] = ACTIONS(2272),
    [anon_sym_mutable] = ACTIONS(2272),
    [anon_sym_constinit] = ACTIONS(2272),
    [anon_sym_consteval] = ACTIONS(2272),
    [anon_sym_alignas] = ACTIONS(2272),
    [anon_sym__Alignas] = ACTIONS(2272),
    [sym_primitive_type] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_struct] = ACTIONS(2272),
    [anon_sym_union] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_else] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_goto] = ACTIONS(2272),
    [anon_sym___try] = ACTIONS(2272),
    [anon_sym___leave] = ACTIONS(2272),
    [anon_sym_not] = ACTIONS(2272),
    [anon_sym_compl] = ACTIONS(2272),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_sizeof] = ACTIONS(2272),
    [anon_sym___alignof__] = ACTIONS(2272),
    [anon_sym___alignof] = ACTIONS(2272),
    [anon_sym__alignof] = ACTIONS(2272),
    [anon_sym_alignof] = ACTIONS(2272),
    [anon_sym__Alignof] = ACTIONS(2272),
    [anon_sym_offsetof] = ACTIONS(2272),
    [anon_sym__Generic] = ACTIONS(2272),
    [anon_sym_asm] = ACTIONS(2272),
    [anon_sym___asm__] = ACTIONS(2272),
    [anon_sym___asm] = ACTIONS(2272),
    [sym_number_literal] = ACTIONS(2274),
    [anon_sym_L_SQUOTE] = ACTIONS(2274),
    [anon_sym_u_SQUOTE] = ACTIONS(2274),
    [anon_sym_U_SQUOTE] = ACTIONS(2274),
    [anon_sym_u8_SQUOTE] = ACTIONS(2274),
    [anon_sym_SQUOTE] = ACTIONS(2274),
    [anon_sym_L_DQUOTE] = ACTIONS(2274),
    [anon_sym_u_DQUOTE] = ACTIONS(2274),
    [anon_sym_U_DQUOTE] = ACTIONS(2274),
    [anon_sym_u8_DQUOTE] = ACTIONS(2274),
    [anon_sym_DQUOTE] = ACTIONS(2274),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [anon_sym_NULL] = ACTIONS(2272),
    [anon_sym_nullptr] = ACTIONS(2272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_This] = ACTIONS(2272),
    [anon_sym_decltype] = ACTIONS(2272),
    [anon_sym_final] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_typename] = ACTIONS(2272),
    [anon_sym_template] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_co_return] = ACTIONS(2272),
    [anon_sym_co_yield] = ACTIONS(2272),
    [anon_sym_R_DQUOTE] = ACTIONS(2274),
    [anon_sym_LR_DQUOTE] = ACTIONS(2274),
    [anon_sym_uR_DQUOTE] = ACTIONS(2274),
    [anon_sym_UR_DQUOTE] = ACTIONS(2274),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2274),
    [anon_sym_co_await] = ACTIONS(2272),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_requires] = ACTIONS(2272),
    [sym_this] = ACTIONS(2272),
    [anon_sym_discard] = ACTIONS(2272),
    [anon_sym_precise] = ACTIONS(2272),
    [anon_sym_shared] = ACTIONS(2272),
    [anon_sym_groupshared] = ACTIONS(2272),
    [anon_sym_uniform] = ACTIONS(2272),
    [anon_sym_row_major] = ACTIONS(2272),
    [anon_sym_column_major] = ACTIONS(2272),
    [anon_sym_globallycoherent] = ACTIONS(2272),
    [anon_sym_centroid] = ACTIONS(2272),
    [anon_sym_noperspective] = ACTIONS(2272),
    [anon_sym_nointerpolation] = ACTIONS(2272),
    [anon_sym_sample] = ACTIONS(2272),
    [anon_sym_linear] = ACTIONS(2272),
    [anon_sym_snorm] = ACTIONS(2272),
    [anon_sym_unorm] = ACTIONS(2272),
    [anon_sym_point] = ACTIONS(2272),
    [anon_sym_line] = ACTIONS(2272),
    [anon_sym_triangleadj] = ACTIONS(2272),
    [anon_sym_lineadj] = ACTIONS(2272),
    [anon_sym_triangle] = ACTIONS(2272),
    [anon_sym_cbuffer] = ACTIONS(2272),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_extension] = ACTIONS(2272),
  },
  [1311] = {
    [sym_identifier] = ACTIONS(2276),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_PLUS] = ACTIONS(2276),
    [anon_sym_STAR] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(2278),
    [anon_sym_COLON] = ACTIONS(2276),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym___extension__] = ACTIONS(2276),
    [anon_sym_typedef] = ACTIONS(2276),
    [anon_sym_in] = ACTIONS(2276),
    [anon_sym_out] = ACTIONS(2276),
    [anon_sym_inout] = ACTIONS(2276),
    [anon_sym_virtual] = ACTIONS(2276),
    [anon_sym_extern] = ACTIONS(2276),
    [anon_sym___attribute__] = ACTIONS(2276),
    [anon_sym___attribute] = ACTIONS(2276),
    [anon_sym_COLON_COLON] = ACTIONS(2278),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2278),
    [anon_sym___declspec] = ACTIONS(2276),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_signed] = ACTIONS(2276),
    [anon_sym_unsigned] = ACTIONS(2276),
    [anon_sym_long] = ACTIONS(2276),
    [anon_sym_short] = ACTIONS(2276),
    [anon_sym_LBRACK] = ACTIONS(2276),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_register] = ACTIONS(2276),
    [anon_sym_inline] = ACTIONS(2276),
    [anon_sym___inline] = ACTIONS(2276),
    [anon_sym___inline__] = ACTIONS(2276),
    [anon_sym___forceinline] = ACTIONS(2276),
    [anon_sym_thread_local] = ACTIONS(2276),
    [anon_sym___thread] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_constexpr] = ACTIONS(2276),
    [anon_sym_volatile] = ACTIONS(2276),
    [anon_sym_restrict] = ACTIONS(2276),
    [anon_sym___restrict__] = ACTIONS(2276),
    [anon_sym__Atomic] = ACTIONS(2276),
    [anon_sym__Noreturn] = ACTIONS(2276),
    [anon_sym_noreturn] = ACTIONS(2276),
    [anon_sym__Nonnull] = ACTIONS(2276),
    [anon_sym_mutable] = ACTIONS(2276),
    [anon_sym_constinit] = ACTIONS(2276),
    [anon_sym_consteval] = ACTIONS(2276),
    [anon_sym_alignas] = ACTIONS(2276),
    [anon_sym__Alignas] = ACTIONS(2276),
    [sym_primitive_type] = ACTIONS(2276),
    [anon_sym_enum] = ACTIONS(2276),
    [anon_sym_class] = ACTIONS(2276),
    [anon_sym_struct] = ACTIONS(2276),
    [anon_sym_union] = ACTIONS(2276),
    [anon_sym_if] = ACTIONS(2276),
    [anon_sym_else] = ACTIONS(2276),
    [anon_sym_switch] = ACTIONS(2276),
    [anon_sym_while] = ACTIONS(2276),
    [anon_sym_do] = ACTIONS(2276),
    [anon_sym_for] = ACTIONS(2276),
    [anon_sym_return] = ACTIONS(2276),
    [anon_sym_break] = ACTIONS(2276),
    [anon_sym_continue] = ACTIONS(2276),
    [anon_sym_goto] = ACTIONS(2276),
    [anon_sym___try] = ACTIONS(2276),
    [anon_sym___leave] = ACTIONS(2276),
    [anon_sym_not] = ACTIONS(2276),
    [anon_sym_compl] = ACTIONS(2276),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_sizeof] = ACTIONS(2276),
    [anon_sym___alignof__] = ACTIONS(2276),
    [anon_sym___alignof] = ACTIONS(2276),
    [anon_sym__alignof] = ACTIONS(2276),
    [anon_sym_alignof] = ACTIONS(2276),
    [anon_sym__Alignof] = ACTIONS(2276),
    [anon_sym_offsetof] = ACTIONS(2276),
    [anon_sym__Generic] = ACTIONS(2276),
    [anon_sym_asm] = ACTIONS(2276),
    [anon_sym___asm__] = ACTIONS(2276),
    [anon_sym___asm] = ACTIONS(2276),
    [sym_number_literal] = ACTIONS(2278),
    [anon_sym_L_SQUOTE] = ACTIONS(2278),
    [anon_sym_u_SQUOTE] = ACTIONS(2278),
    [anon_sym_U_SQUOTE] = ACTIONS(2278),
    [anon_sym_u8_SQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_L_DQUOTE] = ACTIONS(2278),
    [anon_sym_u_DQUOTE] = ACTIONS(2278),
    [anon_sym_U_DQUOTE] = ACTIONS(2278),
    [anon_sym_u8_DQUOTE] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [sym_true] = ACTIONS(2276),
    [sym_false] = ACTIONS(2276),
    [anon_sym_NULL] = ACTIONS(2276),
    [anon_sym_nullptr] = ACTIONS(2276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_This] = ACTIONS(2276),
    [anon_sym_decltype] = ACTIONS(2276),
    [anon_sym_final] = ACTIONS(2276),
    [anon_sym_override] = ACTIONS(2276),
    [anon_sym_typename] = ACTIONS(2276),
    [anon_sym_template] = ACTIONS(2276),
    [anon_sym_try] = ACTIONS(2276),
    [anon_sym_delete] = ACTIONS(2276),
    [anon_sym_throw] = ACTIONS(2276),
    [anon_sym_co_return] = ACTIONS(2276),
    [anon_sym_co_yield] = ACTIONS(2276),
    [anon_sym_R_DQUOTE] = ACTIONS(2278),
    [anon_sym_LR_DQUOTE] = ACTIONS(2278),
    [anon_sym_uR_DQUOTE] = ACTIONS(2278),
    [anon_sym_UR_DQUOTE] = ACTIONS(2278),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2278),
    [anon_sym_co_await] = ACTIONS(2276),
    [anon_sym_new] = ACTIONS(2276),
    [anon_sym_requires] = ACTIONS(2276),
    [sym_this] = ACTIONS(2276),
    [anon_sym_discard] = ACTIONS(2276),
    [anon_sym_precise] = ACTIONS(2276),
    [anon_sym_shared] = ACTIONS(2276),
    [anon_sym_groupshared] = ACTIONS(2276),
    [anon_sym_uniform] = ACTIONS(2276),
    [anon_sym_row_major] = ACTIONS(2276),
    [anon_sym_column_major] = ACTIONS(2276),
    [anon_sym_globallycoherent] = ACTIONS(2276),
    [anon_sym_centroid] = ACTIONS(2276),
    [anon_sym_noperspective] = ACTIONS(2276),
    [anon_sym_nointerpolation] = ACTIONS(2276),
    [anon_sym_sample] = ACTIONS(2276),
    [anon_sym_linear] = ACTIONS(2276),
    [anon_sym_snorm] = ACTIONS(2276),
    [anon_sym_unorm] = ACTIONS(2276),
    [anon_sym_point] = ACTIONS(2276),
    [anon_sym_line] = ACTIONS(2276),
    [anon_sym_triangleadj] = ACTIONS(2276),
    [anon_sym_lineadj] = ACTIONS(2276),
    [anon_sym_triangle] = ACTIONS(2276),
    [anon_sym_cbuffer] = ACTIONS(2276),
    [anon_sym_interface] = ACTIONS(2276),
    [anon_sym_extension] = ACTIONS(2276),
  },
  [1312] = {
    [sym_identifier] = ACTIONS(2239),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2239),
    [anon_sym_PLUS] = ACTIONS(2239),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_AMP] = ACTIONS(2241),
    [anon_sym_COLON] = ACTIONS(2239),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym_typedef] = ACTIONS(2239),
    [anon_sym_in] = ACTIONS(2239),
    [anon_sym_out] = ACTIONS(2239),
    [anon_sym_inout] = ACTIONS(2239),
    [anon_sym_virtual] = ACTIONS(2239),
    [anon_sym_extern] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym___attribute] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2241),
    [anon_sym___declspec] = ACTIONS(2239),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_signed] = ACTIONS(2239),
    [anon_sym_unsigned] = ACTIONS(2239),
    [anon_sym_long] = ACTIONS(2239),
    [anon_sym_short] = ACTIONS(2239),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2239),
    [anon_sym_register] = ACTIONS(2239),
    [anon_sym_inline] = ACTIONS(2239),
    [anon_sym___inline] = ACTIONS(2239),
    [anon_sym___inline__] = ACTIONS(2239),
    [anon_sym___forceinline] = ACTIONS(2239),
    [anon_sym_thread_local] = ACTIONS(2239),
    [anon_sym___thread] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym__Nonnull] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [sym_primitive_type] = ACTIONS(2239),
    [anon_sym_enum] = ACTIONS(2239),
    [anon_sym_class] = ACTIONS(2239),
    [anon_sym_struct] = ACTIONS(2239),
    [anon_sym_union] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(2239),
    [anon_sym_else] = ACTIONS(2239),
    [anon_sym_switch] = ACTIONS(2239),
    [anon_sym_while] = ACTIONS(2239),
    [anon_sym_do] = ACTIONS(2239),
    [anon_sym_for] = ACTIONS(2239),
    [anon_sym_return] = ACTIONS(2239),
    [anon_sym_break] = ACTIONS(2239),
    [anon_sym_continue] = ACTIONS(2239),
    [anon_sym_goto] = ACTIONS(2239),
    [anon_sym___try] = ACTIONS(2239),
    [anon_sym___leave] = ACTIONS(2239),
    [anon_sym_not] = ACTIONS(2239),
    [anon_sym_compl] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_sizeof] = ACTIONS(2239),
    [anon_sym___alignof__] = ACTIONS(2239),
    [anon_sym___alignof] = ACTIONS(2239),
    [anon_sym__alignof] = ACTIONS(2239),
    [anon_sym_alignof] = ACTIONS(2239),
    [anon_sym__Alignof] = ACTIONS(2239),
    [anon_sym_offsetof] = ACTIONS(2239),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2239),
    [anon_sym___asm__] = ACTIONS(2239),
    [anon_sym___asm] = ACTIONS(2239),
    [sym_number_literal] = ACTIONS(2241),
    [anon_sym_L_SQUOTE] = ACTIONS(2241),
    [anon_sym_u_SQUOTE] = ACTIONS(2241),
    [anon_sym_U_SQUOTE] = ACTIONS(2241),
    [anon_sym_u8_SQUOTE] = ACTIONS(2241),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_L_DQUOTE] = ACTIONS(2241),
    [anon_sym_u_DQUOTE] = ACTIONS(2241),
    [anon_sym_U_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8_DQUOTE] = ACTIONS(2241),
    [anon_sym_DQUOTE] = ACTIONS(2241),
    [sym_true] = ACTIONS(2239),
    [sym_false] = ACTIONS(2239),
    [anon_sym_NULL] = ACTIONS(2239),
    [anon_sym_nullptr] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2239),
    [anon_sym_let] = ACTIONS(2239),
    [anon_sym_This] = ACTIONS(2239),
    [anon_sym_decltype] = ACTIONS(2239),
    [anon_sym_final] = ACTIONS(2239),
    [anon_sym_override] = ACTIONS(2239),
    [anon_sym_typename] = ACTIONS(2239),
    [anon_sym_template] = ACTIONS(2239),
    [anon_sym_try] = ACTIONS(2239),
    [anon_sym_delete] = ACTIONS(2239),
    [anon_sym_throw] = ACTIONS(2239),
    [anon_sym_co_return] = ACTIONS(2239),
    [anon_sym_co_yield] = ACTIONS(2239),
    [anon_sym_R_DQUOTE] = ACTIONS(2241),
    [anon_sym_LR_DQUOTE] = ACTIONS(2241),
    [anon_sym_uR_DQUOTE] = ACTIONS(2241),
    [anon_sym_UR_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2241),
    [anon_sym_co_await] = ACTIONS(2239),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_requires] = ACTIONS(2239),
    [sym_this] = ACTIONS(2239),
    [anon_sym_discard] = ACTIONS(2239),
    [anon_sym_precise] = ACTIONS(2239),
    [anon_sym_shared] = ACTIONS(2239),
    [anon_sym_groupshared] = ACTIONS(2239),
    [anon_sym_uniform] = ACTIONS(2239),
    [anon_sym_row_major] = ACTIONS(2239),
    [anon_sym_column_major] = ACTIONS(2239),
    [anon_sym_globallycoherent] = ACTIONS(2239),
    [anon_sym_centroid] = ACTIONS(2239),
    [anon_sym_noperspective] = ACTIONS(2239),
    [anon_sym_nointerpolation] = ACTIONS(2239),
    [anon_sym_sample] = ACTIONS(2239),
    [anon_sym_linear] = ACTIONS(2239),
    [anon_sym_snorm] = ACTIONS(2239),
    [anon_sym_unorm] = ACTIONS(2239),
    [anon_sym_point] = ACTIONS(2239),
    [anon_sym_line] = ACTIONS(2239),
    [anon_sym_triangleadj] = ACTIONS(2239),
    [anon_sym_lineadj] = ACTIONS(2239),
    [anon_sym_triangle] = ACTIONS(2239),
    [anon_sym_cbuffer] = ACTIONS(2239),
    [anon_sym_interface] = ACTIONS(2239),
    [anon_sym_extension] = ACTIONS(2239),
  },
  [1313] = {
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_LPAREN2] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(2282),
    [anon_sym_TILDE] = ACTIONS(2282),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2282),
    [anon_sym_AMP] = ACTIONS(2282),
    [anon_sym_COLON] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(2280),
    [anon_sym_typedef] = ACTIONS(2280),
    [anon_sym_in] = ACTIONS(2280),
    [anon_sym_out] = ACTIONS(2280),
    [anon_sym_inout] = ACTIONS(2280),
    [anon_sym_virtual] = ACTIONS(2280),
    [anon_sym_extern] = ACTIONS(2280),
    [anon_sym___attribute__] = ACTIONS(2280),
    [anon_sym___attribute] = ACTIONS(2280),
    [anon_sym_COLON_COLON] = ACTIONS(2282),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2282),
    [anon_sym___declspec] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_signed] = ACTIONS(2280),
    [anon_sym_unsigned] = ACTIONS(2280),
    [anon_sym_long] = ACTIONS(2280),
    [anon_sym_short] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_register] = ACTIONS(2280),
    [anon_sym_inline] = ACTIONS(2280),
    [anon_sym___inline] = ACTIONS(2280),
    [anon_sym___inline__] = ACTIONS(2280),
    [anon_sym___forceinline] = ACTIONS(2280),
    [anon_sym_thread_local] = ACTIONS(2280),
    [anon_sym___thread] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_constexpr] = ACTIONS(2280),
    [anon_sym_volatile] = ACTIONS(2280),
    [anon_sym_restrict] = ACTIONS(2280),
    [anon_sym___restrict__] = ACTIONS(2280),
    [anon_sym__Atomic] = ACTIONS(2280),
    [anon_sym__Noreturn] = ACTIONS(2280),
    [anon_sym_noreturn] = ACTIONS(2280),
    [anon_sym__Nonnull] = ACTIONS(2280),
    [anon_sym_mutable] = ACTIONS(2280),
    [anon_sym_constinit] = ACTIONS(2280),
    [anon_sym_consteval] = ACTIONS(2280),
    [anon_sym_alignas] = ACTIONS(2280),
    [anon_sym__Alignas] = ACTIONS(2280),
    [sym_primitive_type] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_struct] = ACTIONS(2280),
    [anon_sym_union] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_goto] = ACTIONS(2280),
    [anon_sym___try] = ACTIONS(2280),
    [anon_sym___leave] = ACTIONS(2280),
    [anon_sym_not] = ACTIONS(2280),
    [anon_sym_compl] = ACTIONS(2280),
    [anon_sym_DASH_DASH] = ACTIONS(2282),
    [anon_sym_PLUS_PLUS] = ACTIONS(2282),
    [anon_sym_sizeof] = ACTIONS(2280),
    [anon_sym___alignof__] = ACTIONS(2280),
    [anon_sym___alignof] = ACTIONS(2280),
    [anon_sym__alignof] = ACTIONS(2280),
    [anon_sym_alignof] = ACTIONS(2280),
    [anon_sym__Alignof] = ACTIONS(2280),
    [anon_sym_offsetof] = ACTIONS(2280),
    [anon_sym__Generic] = ACTIONS(2280),
    [anon_sym_asm] = ACTIONS(2280),
    [anon_sym___asm__] = ACTIONS(2280),
    [anon_sym___asm] = ACTIONS(2280),
    [sym_number_literal] = ACTIONS(2282),
    [anon_sym_L_SQUOTE] = ACTIONS(2282),
    [anon_sym_u_SQUOTE] = ACTIONS(2282),
    [anon_sym_U_SQUOTE] = ACTIONS(2282),
    [anon_sym_u8_SQUOTE] = ACTIONS(2282),
    [anon_sym_SQUOTE] = ACTIONS(2282),
    [anon_sym_L_DQUOTE] = ACTIONS(2282),
    [anon_sym_u_DQUOTE] = ACTIONS(2282),
    [anon_sym_U_DQUOTE] = ACTIONS(2282),
    [anon_sym_u8_DQUOTE] = ACTIONS(2282),
    [anon_sym_DQUOTE] = ACTIONS(2282),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [anon_sym_NULL] = ACTIONS(2280),
    [anon_sym_nullptr] = ACTIONS(2280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_This] = ACTIONS(2280),
    [anon_sym_decltype] = ACTIONS(2280),
    [anon_sym_final] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_typename] = ACTIONS(2280),
    [anon_sym_template] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_co_return] = ACTIONS(2280),
    [anon_sym_co_yield] = ACTIONS(2280),
    [anon_sym_R_DQUOTE] = ACTIONS(2282),
    [anon_sym_LR_DQUOTE] = ACTIONS(2282),
    [anon_sym_uR_DQUOTE] = ACTIONS(2282),
    [anon_sym_UR_DQUOTE] = ACTIONS(2282),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2282),
    [anon_sym_co_await] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_requires] = ACTIONS(2280),
    [sym_this] = ACTIONS(2280),
    [anon_sym_discard] = ACTIONS(2280),
    [anon_sym_precise] = ACTIONS(2280),
    [anon_sym_shared] = ACTIONS(2280),
    [anon_sym_groupshared] = ACTIONS(2280),
    [anon_sym_uniform] = ACTIONS(2280),
    [anon_sym_row_major] = ACTIONS(2280),
    [anon_sym_column_major] = ACTIONS(2280),
    [anon_sym_globallycoherent] = ACTIONS(2280),
    [anon_sym_centroid] = ACTIONS(2280),
    [anon_sym_noperspective] = ACTIONS(2280),
    [anon_sym_nointerpolation] = ACTIONS(2280),
    [anon_sym_sample] = ACTIONS(2280),
    [anon_sym_linear] = ACTIONS(2280),
    [anon_sym_snorm] = ACTIONS(2280),
    [anon_sym_unorm] = ACTIONS(2280),
    [anon_sym_point] = ACTIONS(2280),
    [anon_sym_line] = ACTIONS(2280),
    [anon_sym_triangleadj] = ACTIONS(2280),
    [anon_sym_lineadj] = ACTIONS(2280),
    [anon_sym_triangle] = ACTIONS(2280),
    [anon_sym_cbuffer] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_extension] = ACTIONS(2280),
  },
  [1314] = {
    [sym_identifier] = ACTIONS(2284),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2286),
    [anon_sym_COLON] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_typedef] = ACTIONS(2284),
    [anon_sym_in] = ACTIONS(2284),
    [anon_sym_out] = ACTIONS(2284),
    [anon_sym_inout] = ACTIONS(2284),
    [anon_sym_virtual] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_signed] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_else] = ACTIONS(2284),
    [anon_sym_switch] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_goto] = ACTIONS(2284),
    [anon_sym___try] = ACTIONS(2284),
    [anon_sym___leave] = ACTIONS(2284),
    [anon_sym_not] = ACTIONS(2284),
    [anon_sym_compl] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_sizeof] = ACTIONS(2284),
    [anon_sym___alignof__] = ACTIONS(2284),
    [anon_sym___alignof] = ACTIONS(2284),
    [anon_sym__alignof] = ACTIONS(2284),
    [anon_sym_alignof] = ACTIONS(2284),
    [anon_sym__Alignof] = ACTIONS(2284),
    [anon_sym_offsetof] = ACTIONS(2284),
    [anon_sym__Generic] = ACTIONS(2284),
    [anon_sym_asm] = ACTIONS(2284),
    [anon_sym___asm__] = ACTIONS(2284),
    [anon_sym___asm] = ACTIONS(2284),
    [sym_number_literal] = ACTIONS(2286),
    [anon_sym_L_SQUOTE] = ACTIONS(2286),
    [anon_sym_u_SQUOTE] = ACTIONS(2286),
    [anon_sym_U_SQUOTE] = ACTIONS(2286),
    [anon_sym_u8_SQUOTE] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_L_DQUOTE] = ACTIONS(2286),
    [anon_sym_u_DQUOTE] = ACTIONS(2286),
    [anon_sym_U_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8_DQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [sym_true] = ACTIONS(2284),
    [sym_false] = ACTIONS(2284),
    [anon_sym_NULL] = ACTIONS(2284),
    [anon_sym_nullptr] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_This] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [anon_sym_final] = ACTIONS(2284),
    [anon_sym_override] = ACTIONS(2284),
    [anon_sym_typename] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_delete] = ACTIONS(2284),
    [anon_sym_throw] = ACTIONS(2284),
    [anon_sym_co_return] = ACTIONS(2284),
    [anon_sym_co_yield] = ACTIONS(2284),
    [anon_sym_R_DQUOTE] = ACTIONS(2286),
    [anon_sym_LR_DQUOTE] = ACTIONS(2286),
    [anon_sym_uR_DQUOTE] = ACTIONS(2286),
    [anon_sym_UR_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2286),
    [anon_sym_co_await] = ACTIONS(2284),
    [anon_sym_new] = ACTIONS(2284),
    [anon_sym_requires] = ACTIONS(2284),
    [sym_this] = ACTIONS(2284),
    [anon_sym_discard] = ACTIONS(2284),
    [anon_sym_precise] = ACTIONS(2284),
    [anon_sym_shared] = ACTIONS(2284),
    [anon_sym_groupshared] = ACTIONS(2284),
    [anon_sym_uniform] = ACTIONS(2284),
    [anon_sym_row_major] = ACTIONS(2284),
    [anon_sym_column_major] = ACTIONS(2284),
    [anon_sym_globallycoherent] = ACTIONS(2284),
    [anon_sym_centroid] = ACTIONS(2284),
    [anon_sym_noperspective] = ACTIONS(2284),
    [anon_sym_nointerpolation] = ACTIONS(2284),
    [anon_sym_sample] = ACTIONS(2284),
    [anon_sym_linear] = ACTIONS(2284),
    [anon_sym_snorm] = ACTIONS(2284),
    [anon_sym_unorm] = ACTIONS(2284),
    [anon_sym_point] = ACTIONS(2284),
    [anon_sym_line] = ACTIONS(2284),
    [anon_sym_triangleadj] = ACTIONS(2284),
    [anon_sym_lineadj] = ACTIONS(2284),
    [anon_sym_triangle] = ACTIONS(2284),
    [anon_sym_cbuffer] = ACTIONS(2284),
    [anon_sym_interface] = ACTIONS(2284),
    [anon_sym_extension] = ACTIONS(2284),
  },
  [1315] = {
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2290),
    [anon_sym_COLON] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_out] = ACTIONS(2288),
    [anon_sym_inout] = ACTIONS(2288),
    [anon_sym_virtual] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_signed] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym___try] = ACTIONS(2288),
    [anon_sym___leave] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2288),
    [anon_sym_compl] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_sizeof] = ACTIONS(2288),
    [anon_sym___alignof__] = ACTIONS(2288),
    [anon_sym___alignof] = ACTIONS(2288),
    [anon_sym__alignof] = ACTIONS(2288),
    [anon_sym_alignof] = ACTIONS(2288),
    [anon_sym__Alignof] = ACTIONS(2288),
    [anon_sym_offsetof] = ACTIONS(2288),
    [anon_sym__Generic] = ACTIONS(2288),
    [anon_sym_asm] = ACTIONS(2288),
    [anon_sym___asm__] = ACTIONS(2288),
    [anon_sym___asm] = ACTIONS(2288),
    [sym_number_literal] = ACTIONS(2290),
    [anon_sym_L_SQUOTE] = ACTIONS(2290),
    [anon_sym_u_SQUOTE] = ACTIONS(2290),
    [anon_sym_U_SQUOTE] = ACTIONS(2290),
    [anon_sym_u8_SQUOTE] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [anon_sym_L_DQUOTE] = ACTIONS(2290),
    [anon_sym_u_DQUOTE] = ACTIONS(2290),
    [anon_sym_U_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8_DQUOTE] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [anon_sym_NULL] = ACTIONS(2288),
    [anon_sym_nullptr] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_This] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [anon_sym_final] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_co_return] = ACTIONS(2288),
    [anon_sym_co_yield] = ACTIONS(2288),
    [anon_sym_R_DQUOTE] = ACTIONS(2290),
    [anon_sym_LR_DQUOTE] = ACTIONS(2290),
    [anon_sym_uR_DQUOTE] = ACTIONS(2290),
    [anon_sym_UR_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2290),
    [anon_sym_co_await] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_requires] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [anon_sym_discard] = ACTIONS(2288),
    [anon_sym_precise] = ACTIONS(2288),
    [anon_sym_shared] = ACTIONS(2288),
    [anon_sym_groupshared] = ACTIONS(2288),
    [anon_sym_uniform] = ACTIONS(2288),
    [anon_sym_row_major] = ACTIONS(2288),
    [anon_sym_column_major] = ACTIONS(2288),
    [anon_sym_globallycoherent] = ACTIONS(2288),
    [anon_sym_centroid] = ACTIONS(2288),
    [anon_sym_noperspective] = ACTIONS(2288),
    [anon_sym_nointerpolation] = ACTIONS(2288),
    [anon_sym_sample] = ACTIONS(2288),
    [anon_sym_linear] = ACTIONS(2288),
    [anon_sym_snorm] = ACTIONS(2288),
    [anon_sym_unorm] = ACTIONS(2288),
    [anon_sym_point] = ACTIONS(2288),
    [anon_sym_line] = ACTIONS(2288),
    [anon_sym_triangleadj] = ACTIONS(2288),
    [anon_sym_lineadj] = ACTIONS(2288),
    [anon_sym_triangle] = ACTIONS(2288),
    [anon_sym_cbuffer] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_extension] = ACTIONS(2288),
  },
  [1316] = {
    [sym_catch_clause] = STATE(1328),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1328),
    [sym_identifier] = ACTIONS(2885),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_BANG] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2887),
    [anon_sym_DASH] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2887),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym___extension__] = ACTIONS(2885),
    [anon_sym_typedef] = ACTIONS(2885),
    [anon_sym_in] = ACTIONS(2885),
    [anon_sym_out] = ACTIONS(2885),
    [anon_sym_inout] = ACTIONS(2885),
    [anon_sym_virtual] = ACTIONS(2885),
    [anon_sym_extern] = ACTIONS(2885),
    [anon_sym___attribute__] = ACTIONS(2885),
    [anon_sym___attribute] = ACTIONS(2885),
    [anon_sym_COLON_COLON] = ACTIONS(2887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2887),
    [anon_sym___declspec] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_signed] = ACTIONS(2885),
    [anon_sym_unsigned] = ACTIONS(2885),
    [anon_sym_long] = ACTIONS(2885),
    [anon_sym_short] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_static] = ACTIONS(2885),
    [anon_sym_register] = ACTIONS(2885),
    [anon_sym_inline] = ACTIONS(2885),
    [anon_sym___inline] = ACTIONS(2885),
    [anon_sym___inline__] = ACTIONS(2885),
    [anon_sym___forceinline] = ACTIONS(2885),
    [anon_sym_thread_local] = ACTIONS(2885),
    [anon_sym___thread] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_constexpr] = ACTIONS(2885),
    [anon_sym_volatile] = ACTIONS(2885),
    [anon_sym_restrict] = ACTIONS(2885),
    [anon_sym___restrict__] = ACTIONS(2885),
    [anon_sym__Atomic] = ACTIONS(2885),
    [anon_sym__Noreturn] = ACTIONS(2885),
    [anon_sym_noreturn] = ACTIONS(2885),
    [anon_sym__Nonnull] = ACTIONS(2885),
    [anon_sym_mutable] = ACTIONS(2885),
    [anon_sym_constinit] = ACTIONS(2885),
    [anon_sym_consteval] = ACTIONS(2885),
    [anon_sym_alignas] = ACTIONS(2885),
    [anon_sym__Alignas] = ACTIONS(2885),
    [sym_primitive_type] = ACTIONS(2885),
    [anon_sym_enum] = ACTIONS(2885),
    [anon_sym_class] = ACTIONS(2885),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_union] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_else] = ACTIONS(2885),
    [anon_sym_switch] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [anon_sym_do] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_break] = ACTIONS(2885),
    [anon_sym_continue] = ACTIONS(2885),
    [anon_sym_goto] = ACTIONS(2885),
    [anon_sym___try] = ACTIONS(2885),
    [anon_sym___leave] = ACTIONS(2885),
    [anon_sym_not] = ACTIONS(2885),
    [anon_sym_compl] = ACTIONS(2885),
    [anon_sym_DASH_DASH] = ACTIONS(2887),
    [anon_sym_PLUS_PLUS] = ACTIONS(2887),
    [anon_sym_sizeof] = ACTIONS(2885),
    [anon_sym___alignof__] = ACTIONS(2885),
    [anon_sym___alignof] = ACTIONS(2885),
    [anon_sym__alignof] = ACTIONS(2885),
    [anon_sym_alignof] = ACTIONS(2885),
    [anon_sym__Alignof] = ACTIONS(2885),
    [anon_sym_offsetof] = ACTIONS(2885),
    [anon_sym__Generic] = ACTIONS(2885),
    [anon_sym_asm] = ACTIONS(2885),
    [anon_sym___asm__] = ACTIONS(2885),
    [anon_sym___asm] = ACTIONS(2885),
    [sym_number_literal] = ACTIONS(2887),
    [anon_sym_L_SQUOTE] = ACTIONS(2887),
    [anon_sym_u_SQUOTE] = ACTIONS(2887),
    [anon_sym_U_SQUOTE] = ACTIONS(2887),
    [anon_sym_u8_SQUOTE] = ACTIONS(2887),
    [anon_sym_SQUOTE] = ACTIONS(2887),
    [anon_sym_L_DQUOTE] = ACTIONS(2887),
    [anon_sym_u_DQUOTE] = ACTIONS(2887),
    [anon_sym_U_DQUOTE] = ACTIONS(2887),
    [anon_sym_u8_DQUOTE] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [sym_true] = ACTIONS(2885),
    [sym_false] = ACTIONS(2885),
    [anon_sym_NULL] = ACTIONS(2885),
    [anon_sym_nullptr] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2885),
    [anon_sym_let] = ACTIONS(2885),
    [anon_sym_This] = ACTIONS(2885),
    [anon_sym_decltype] = ACTIONS(2885),
    [anon_sym_typename] = ACTIONS(2885),
    [anon_sym_template] = ACTIONS(2885),
    [anon_sym_try] = ACTIONS(2885),
    [anon_sym_delete] = ACTIONS(2885),
    [anon_sym_throw] = ACTIONS(2885),
    [anon_sym_co_return] = ACTIONS(2885),
    [anon_sym_co_yield] = ACTIONS(2885),
    [anon_sym_catch] = ACTIONS(5304),
    [anon_sym_R_DQUOTE] = ACTIONS(2887),
    [anon_sym_LR_DQUOTE] = ACTIONS(2887),
    [anon_sym_uR_DQUOTE] = ACTIONS(2887),
    [anon_sym_UR_DQUOTE] = ACTIONS(2887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2887),
    [anon_sym_co_await] = ACTIONS(2885),
    [anon_sym_new] = ACTIONS(2885),
    [anon_sym_requires] = ACTIONS(2885),
    [sym_this] = ACTIONS(2885),
    [anon_sym_discard] = ACTIONS(2885),
    [anon_sym_precise] = ACTIONS(2885),
    [anon_sym_shared] = ACTIONS(2885),
    [anon_sym_groupshared] = ACTIONS(2885),
    [anon_sym_uniform] = ACTIONS(2885),
    [anon_sym_row_major] = ACTIONS(2885),
    [anon_sym_column_major] = ACTIONS(2885),
    [anon_sym_globallycoherent] = ACTIONS(2885),
    [anon_sym_centroid] = ACTIONS(2885),
    [anon_sym_noperspective] = ACTIONS(2885),
    [anon_sym_nointerpolation] = ACTIONS(2885),
    [anon_sym_sample] = ACTIONS(2885),
    [anon_sym_linear] = ACTIONS(2885),
    [anon_sym_snorm] = ACTIONS(2885),
    [anon_sym_unorm] = ACTIONS(2885),
    [anon_sym_point] = ACTIONS(2885),
    [anon_sym_line] = ACTIONS(2885),
    [anon_sym_triangleadj] = ACTIONS(2885),
    [anon_sym_lineadj] = ACTIONS(2885),
    [anon_sym_triangle] = ACTIONS(2885),
    [anon_sym_cbuffer] = ACTIONS(2885),
    [anon_sym_interface] = ACTIONS(2885),
    [anon_sym_extension] = ACTIONS(2885),
  },
  [1317] = {
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2294),
    [anon_sym_COLON] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym_typedef] = ACTIONS(2292),
    [anon_sym_in] = ACTIONS(2292),
    [anon_sym_out] = ACTIONS(2292),
    [anon_sym_inout] = ACTIONS(2292),
    [anon_sym_virtual] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym___attribute] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2294),
    [anon_sym___declspec] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_signed] = ACTIONS(2292),
    [anon_sym_unsigned] = ACTIONS(2292),
    [anon_sym_long] = ACTIONS(2292),
    [anon_sym_short] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym___inline] = ACTIONS(2292),
    [anon_sym___inline__] = ACTIONS(2292),
    [anon_sym___forceinline] = ACTIONS(2292),
    [anon_sym_thread_local] = ACTIONS(2292),
    [anon_sym___thread] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym__Nonnull] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [sym_primitive_type] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_struct] = ACTIONS(2292),
    [anon_sym_union] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_else] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_goto] = ACTIONS(2292),
    [anon_sym___try] = ACTIONS(2292),
    [anon_sym___leave] = ACTIONS(2292),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_compl] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_sizeof] = ACTIONS(2292),
    [anon_sym___alignof__] = ACTIONS(2292),
    [anon_sym___alignof] = ACTIONS(2292),
    [anon_sym__alignof] = ACTIONS(2292),
    [anon_sym_alignof] = ACTIONS(2292),
    [anon_sym__Alignof] = ACTIONS(2292),
    [anon_sym_offsetof] = ACTIONS(2292),
    [anon_sym__Generic] = ACTIONS(2292),
    [anon_sym_asm] = ACTIONS(2292),
    [anon_sym___asm__] = ACTIONS(2292),
    [anon_sym___asm] = ACTIONS(2292),
    [sym_number_literal] = ACTIONS(2294),
    [anon_sym_L_SQUOTE] = ACTIONS(2294),
    [anon_sym_u_SQUOTE] = ACTIONS(2294),
    [anon_sym_U_SQUOTE] = ACTIONS(2294),
    [anon_sym_u8_SQUOTE] = ACTIONS(2294),
    [anon_sym_SQUOTE] = ACTIONS(2294),
    [anon_sym_L_DQUOTE] = ACTIONS(2294),
    [anon_sym_u_DQUOTE] = ACTIONS(2294),
    [anon_sym_U_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8_DQUOTE] = ACTIONS(2294),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [anon_sym_NULL] = ACTIONS(2292),
    [anon_sym_nullptr] = ACTIONS(2292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_This] = ACTIONS(2292),
    [anon_sym_decltype] = ACTIONS(2292),
    [anon_sym_final] = ACTIONS(2292),
    [anon_sym_override] = ACTIONS(2292),
    [anon_sym_typename] = ACTIONS(2292),
    [anon_sym_template] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_co_return] = ACTIONS(2292),
    [anon_sym_co_yield] = ACTIONS(2292),
    [anon_sym_R_DQUOTE] = ACTIONS(2294),
    [anon_sym_LR_DQUOTE] = ACTIONS(2294),
    [anon_sym_uR_DQUOTE] = ACTIONS(2294),
    [anon_sym_UR_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2294),
    [anon_sym_co_await] = ACTIONS(2292),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_requires] = ACTIONS(2292),
    [sym_this] = ACTIONS(2292),
    [anon_sym_discard] = ACTIONS(2292),
    [anon_sym_precise] = ACTIONS(2292),
    [anon_sym_shared] = ACTIONS(2292),
    [anon_sym_groupshared] = ACTIONS(2292),
    [anon_sym_uniform] = ACTIONS(2292),
    [anon_sym_row_major] = ACTIONS(2292),
    [anon_sym_column_major] = ACTIONS(2292),
    [anon_sym_globallycoherent] = ACTIONS(2292),
    [anon_sym_centroid] = ACTIONS(2292),
    [anon_sym_noperspective] = ACTIONS(2292),
    [anon_sym_nointerpolation] = ACTIONS(2292),
    [anon_sym_sample] = ACTIONS(2292),
    [anon_sym_linear] = ACTIONS(2292),
    [anon_sym_snorm] = ACTIONS(2292),
    [anon_sym_unorm] = ACTIONS(2292),
    [anon_sym_point] = ACTIONS(2292),
    [anon_sym_line] = ACTIONS(2292),
    [anon_sym_triangleadj] = ACTIONS(2292),
    [anon_sym_lineadj] = ACTIONS(2292),
    [anon_sym_triangle] = ACTIONS(2292),
    [anon_sym_cbuffer] = ACTIONS(2292),
    [anon_sym_interface] = ACTIONS(2292),
    [anon_sym_extension] = ACTIONS(2292),
  },
  [1318] = {
    [sym_identifier] = ACTIONS(2296),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_BANG] = ACTIONS(2298),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2298),
    [anon_sym_COLON] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2298),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym_typedef] = ACTIONS(2296),
    [anon_sym_in] = ACTIONS(2296),
    [anon_sym_out] = ACTIONS(2296),
    [anon_sym_inout] = ACTIONS(2296),
    [anon_sym_virtual] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym___attribute] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2298),
    [anon_sym___declspec] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_signed] = ACTIONS(2296),
    [anon_sym_unsigned] = ACTIONS(2296),
    [anon_sym_long] = ACTIONS(2296),
    [anon_sym_short] = ACTIONS(2296),
    [anon_sym_LBRACK] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_register] = ACTIONS(2296),
    [anon_sym_inline] = ACTIONS(2296),
    [anon_sym___inline] = ACTIONS(2296),
    [anon_sym___inline__] = ACTIONS(2296),
    [anon_sym___forceinline] = ACTIONS(2296),
    [anon_sym_thread_local] = ACTIONS(2296),
    [anon_sym___thread] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym__Nonnull] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [sym_primitive_type] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2296),
    [anon_sym_class] = ACTIONS(2296),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_union] = ACTIONS(2296),
    [anon_sym_if] = ACTIONS(2296),
    [anon_sym_else] = ACTIONS(2296),
    [anon_sym_switch] = ACTIONS(2296),
    [anon_sym_while] = ACTIONS(2296),
    [anon_sym_do] = ACTIONS(2296),
    [anon_sym_for] = ACTIONS(2296),
    [anon_sym_return] = ACTIONS(2296),
    [anon_sym_break] = ACTIONS(2296),
    [anon_sym_continue] = ACTIONS(2296),
    [anon_sym_goto] = ACTIONS(2296),
    [anon_sym___try] = ACTIONS(2296),
    [anon_sym___leave] = ACTIONS(2296),
    [anon_sym_not] = ACTIONS(2296),
    [anon_sym_compl] = ACTIONS(2296),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_sizeof] = ACTIONS(2296),
    [anon_sym___alignof__] = ACTIONS(2296),
    [anon_sym___alignof] = ACTIONS(2296),
    [anon_sym__alignof] = ACTIONS(2296),
    [anon_sym_alignof] = ACTIONS(2296),
    [anon_sym__Alignof] = ACTIONS(2296),
    [anon_sym_offsetof] = ACTIONS(2296),
    [anon_sym__Generic] = ACTIONS(2296),
    [anon_sym_asm] = ACTIONS(2296),
    [anon_sym___asm__] = ACTIONS(2296),
    [anon_sym___asm] = ACTIONS(2296),
    [sym_number_literal] = ACTIONS(2298),
    [anon_sym_L_SQUOTE] = ACTIONS(2298),
    [anon_sym_u_SQUOTE] = ACTIONS(2298),
    [anon_sym_U_SQUOTE] = ACTIONS(2298),
    [anon_sym_u8_SQUOTE] = ACTIONS(2298),
    [anon_sym_SQUOTE] = ACTIONS(2298),
    [anon_sym_L_DQUOTE] = ACTIONS(2298),
    [anon_sym_u_DQUOTE] = ACTIONS(2298),
    [anon_sym_U_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8_DQUOTE] = ACTIONS(2298),
    [anon_sym_DQUOTE] = ACTIONS(2298),
    [sym_true] = ACTIONS(2296),
    [sym_false] = ACTIONS(2296),
    [anon_sym_NULL] = ACTIONS(2296),
    [anon_sym_nullptr] = ACTIONS(2296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_This] = ACTIONS(2296),
    [anon_sym_decltype] = ACTIONS(2296),
    [anon_sym_final] = ACTIONS(2296),
    [anon_sym_override] = ACTIONS(2296),
    [anon_sym_typename] = ACTIONS(2296),
    [anon_sym_template] = ACTIONS(2296),
    [anon_sym_try] = ACTIONS(2296),
    [anon_sym_delete] = ACTIONS(2296),
    [anon_sym_throw] = ACTIONS(2296),
    [anon_sym_co_return] = ACTIONS(2296),
    [anon_sym_co_yield] = ACTIONS(2296),
    [anon_sym_R_DQUOTE] = ACTIONS(2298),
    [anon_sym_LR_DQUOTE] = ACTIONS(2298),
    [anon_sym_uR_DQUOTE] = ACTIONS(2298),
    [anon_sym_UR_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2298),
    [anon_sym_co_await] = ACTIONS(2296),
    [anon_sym_new] = ACTIONS(2296),
    [anon_sym_requires] = ACTIONS(2296),
    [sym_this] = ACTIONS(2296),
    [anon_sym_discard] = ACTIONS(2296),
    [anon_sym_precise] = ACTIONS(2296),
    [anon_sym_shared] = ACTIONS(2296),
    [anon_sym_groupshared] = ACTIONS(2296),
    [anon_sym_uniform] = ACTIONS(2296),
    [anon_sym_row_major] = ACTIONS(2296),
    [anon_sym_column_major] = ACTIONS(2296),
    [anon_sym_globallycoherent] = ACTIONS(2296),
    [anon_sym_centroid] = ACTIONS(2296),
    [anon_sym_noperspective] = ACTIONS(2296),
    [anon_sym_nointerpolation] = ACTIONS(2296),
    [anon_sym_sample] = ACTIONS(2296),
    [anon_sym_linear] = ACTIONS(2296),
    [anon_sym_snorm] = ACTIONS(2296),
    [anon_sym_unorm] = ACTIONS(2296),
    [anon_sym_point] = ACTIONS(2296),
    [anon_sym_line] = ACTIONS(2296),
    [anon_sym_triangleadj] = ACTIONS(2296),
    [anon_sym_lineadj] = ACTIONS(2296),
    [anon_sym_triangle] = ACTIONS(2296),
    [anon_sym_cbuffer] = ACTIONS(2296),
    [anon_sym_interface] = ACTIONS(2296),
    [anon_sym_extension] = ACTIONS(2296),
  },
  [1319] = {
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_LPAREN2] = ACTIONS(2266),
    [anon_sym_BANG] = ACTIONS(2266),
    [anon_sym_TILDE] = ACTIONS(2266),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2266),
    [anon_sym_AMP] = ACTIONS(2266),
    [anon_sym_COLON] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2266),
    [anon_sym___extension__] = ACTIONS(2264),
    [anon_sym_typedef] = ACTIONS(2264),
    [anon_sym_in] = ACTIONS(2264),
    [anon_sym_out] = ACTIONS(2264),
    [anon_sym_inout] = ACTIONS(2264),
    [anon_sym_virtual] = ACTIONS(2264),
    [anon_sym_extern] = ACTIONS(2264),
    [anon_sym___attribute__] = ACTIONS(2264),
    [anon_sym___attribute] = ACTIONS(2264),
    [anon_sym_COLON_COLON] = ACTIONS(2266),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2266),
    [anon_sym___declspec] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_signed] = ACTIONS(2264),
    [anon_sym_unsigned] = ACTIONS(2264),
    [anon_sym_long] = ACTIONS(2264),
    [anon_sym_short] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_register] = ACTIONS(2264),
    [anon_sym_inline] = ACTIONS(2264),
    [anon_sym___inline] = ACTIONS(2264),
    [anon_sym___inline__] = ACTIONS(2264),
    [anon_sym___forceinline] = ACTIONS(2264),
    [anon_sym_thread_local] = ACTIONS(2264),
    [anon_sym___thread] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_constexpr] = ACTIONS(2264),
    [anon_sym_volatile] = ACTIONS(2264),
    [anon_sym_restrict] = ACTIONS(2264),
    [anon_sym___restrict__] = ACTIONS(2264),
    [anon_sym__Atomic] = ACTIONS(2264),
    [anon_sym__Noreturn] = ACTIONS(2264),
    [anon_sym_noreturn] = ACTIONS(2264),
    [anon_sym__Nonnull] = ACTIONS(2264),
    [anon_sym_mutable] = ACTIONS(2264),
    [anon_sym_constinit] = ACTIONS(2264),
    [anon_sym_consteval] = ACTIONS(2264),
    [anon_sym_alignas] = ACTIONS(2264),
    [anon_sym__Alignas] = ACTIONS(2264),
    [sym_primitive_type] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
    [anon_sym_class] = ACTIONS(2264),
    [anon_sym_struct] = ACTIONS(2264),
    [anon_sym_union] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_else] = ACTIONS(2264),
    [anon_sym_switch] = ACTIONS(2264),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_do] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_goto] = ACTIONS(2264),
    [anon_sym___try] = ACTIONS(2264),
    [anon_sym___leave] = ACTIONS(2264),
    [anon_sym_not] = ACTIONS(2264),
    [anon_sym_compl] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2266),
    [anon_sym_PLUS_PLUS] = ACTIONS(2266),
    [anon_sym_sizeof] = ACTIONS(2264),
    [anon_sym___alignof__] = ACTIONS(2264),
    [anon_sym___alignof] = ACTIONS(2264),
    [anon_sym__alignof] = ACTIONS(2264),
    [anon_sym_alignof] = ACTIONS(2264),
    [anon_sym__Alignof] = ACTIONS(2264),
    [anon_sym_offsetof] = ACTIONS(2264),
    [anon_sym__Generic] = ACTIONS(2264),
    [anon_sym_asm] = ACTIONS(2264),
    [anon_sym___asm__] = ACTIONS(2264),
    [anon_sym___asm] = ACTIONS(2264),
    [sym_number_literal] = ACTIONS(2266),
    [anon_sym_L_SQUOTE] = ACTIONS(2266),
    [anon_sym_u_SQUOTE] = ACTIONS(2266),
    [anon_sym_U_SQUOTE] = ACTIONS(2266),
    [anon_sym_u8_SQUOTE] = ACTIONS(2266),
    [anon_sym_SQUOTE] = ACTIONS(2266),
    [anon_sym_L_DQUOTE] = ACTIONS(2266),
    [anon_sym_u_DQUOTE] = ACTIONS(2266),
    [anon_sym_U_DQUOTE] = ACTIONS(2266),
    [anon_sym_u8_DQUOTE] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(2266),
    [sym_true] = ACTIONS(2264),
    [sym_false] = ACTIONS(2264),
    [anon_sym_NULL] = ACTIONS(2264),
    [anon_sym_nullptr] = ACTIONS(2264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_This] = ACTIONS(2264),
    [anon_sym_decltype] = ACTIONS(2264),
    [anon_sym_final] = ACTIONS(2264),
    [anon_sym_override] = ACTIONS(2264),
    [anon_sym_typename] = ACTIONS(2264),
    [anon_sym_template] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [anon_sym_delete] = ACTIONS(2264),
    [anon_sym_throw] = ACTIONS(2264),
    [anon_sym_co_return] = ACTIONS(2264),
    [anon_sym_co_yield] = ACTIONS(2264),
    [anon_sym_R_DQUOTE] = ACTIONS(2266),
    [anon_sym_LR_DQUOTE] = ACTIONS(2266),
    [anon_sym_uR_DQUOTE] = ACTIONS(2266),
    [anon_sym_UR_DQUOTE] = ACTIONS(2266),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2266),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2264),
    [anon_sym_requires] = ACTIONS(2264),
    [sym_this] = ACTIONS(2264),
    [anon_sym_discard] = ACTIONS(2264),
    [anon_sym_precise] = ACTIONS(2264),
    [anon_sym_shared] = ACTIONS(2264),
    [anon_sym_groupshared] = ACTIONS(2264),
    [anon_sym_uniform] = ACTIONS(2264),
    [anon_sym_row_major] = ACTIONS(2264),
    [anon_sym_column_major] = ACTIONS(2264),
    [anon_sym_globallycoherent] = ACTIONS(2264),
    [anon_sym_centroid] = ACTIONS(2264),
    [anon_sym_noperspective] = ACTIONS(2264),
    [anon_sym_nointerpolation] = ACTIONS(2264),
    [anon_sym_sample] = ACTIONS(2264),
    [anon_sym_linear] = ACTIONS(2264),
    [anon_sym_snorm] = ACTIONS(2264),
    [anon_sym_unorm] = ACTIONS(2264),
    [anon_sym_point] = ACTIONS(2264),
    [anon_sym_line] = ACTIONS(2264),
    [anon_sym_triangleadj] = ACTIONS(2264),
    [anon_sym_lineadj] = ACTIONS(2264),
    [anon_sym_triangle] = ACTIONS(2264),
    [anon_sym_cbuffer] = ACTIONS(2264),
    [anon_sym_interface] = ACTIONS(2264),
    [anon_sym_extension] = ACTIONS(2264),
  },
  [1320] = {
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_BANG] = ACTIONS(2302),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2302),
    [anon_sym_AMP] = ACTIONS(2302),
    [anon_sym_COLON] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym_typedef] = ACTIONS(2300),
    [anon_sym_in] = ACTIONS(2300),
    [anon_sym_out] = ACTIONS(2300),
    [anon_sym_inout] = ACTIONS(2300),
    [anon_sym_virtual] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym___attribute] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2302),
    [anon_sym___declspec] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_signed] = ACTIONS(2300),
    [anon_sym_unsigned] = ACTIONS(2300),
    [anon_sym_long] = ACTIONS(2300),
    [anon_sym_short] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_register] = ACTIONS(2300),
    [anon_sym_inline] = ACTIONS(2300),
    [anon_sym___inline] = ACTIONS(2300),
    [anon_sym___inline__] = ACTIONS(2300),
    [anon_sym___forceinline] = ACTIONS(2300),
    [anon_sym_thread_local] = ACTIONS(2300),
    [anon_sym___thread] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym__Nonnull] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [sym_primitive_type] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_struct] = ACTIONS(2300),
    [anon_sym_union] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_else] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_goto] = ACTIONS(2300),
    [anon_sym___try] = ACTIONS(2300),
    [anon_sym___leave] = ACTIONS(2300),
    [anon_sym_not] = ACTIONS(2300),
    [anon_sym_compl] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_sizeof] = ACTIONS(2300),
    [anon_sym___alignof__] = ACTIONS(2300),
    [anon_sym___alignof] = ACTIONS(2300),
    [anon_sym__alignof] = ACTIONS(2300),
    [anon_sym_alignof] = ACTIONS(2300),
    [anon_sym__Alignof] = ACTIONS(2300),
    [anon_sym_offsetof] = ACTIONS(2300),
    [anon_sym__Generic] = ACTIONS(2300),
    [anon_sym_asm] = ACTIONS(2300),
    [anon_sym___asm__] = ACTIONS(2300),
    [anon_sym___asm] = ACTIONS(2300),
    [sym_number_literal] = ACTIONS(2302),
    [anon_sym_L_SQUOTE] = ACTIONS(2302),
    [anon_sym_u_SQUOTE] = ACTIONS(2302),
    [anon_sym_U_SQUOTE] = ACTIONS(2302),
    [anon_sym_u8_SQUOTE] = ACTIONS(2302),
    [anon_sym_SQUOTE] = ACTIONS(2302),
    [anon_sym_L_DQUOTE] = ACTIONS(2302),
    [anon_sym_u_DQUOTE] = ACTIONS(2302),
    [anon_sym_U_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8_DQUOTE] = ACTIONS(2302),
    [anon_sym_DQUOTE] = ACTIONS(2302),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [anon_sym_NULL] = ACTIONS(2300),
    [anon_sym_nullptr] = ACTIONS(2300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_This] = ACTIONS(2300),
    [anon_sym_decltype] = ACTIONS(2300),
    [anon_sym_final] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_typename] = ACTIONS(2300),
    [anon_sym_template] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_co_return] = ACTIONS(2300),
    [anon_sym_co_yield] = ACTIONS(2300),
    [anon_sym_R_DQUOTE] = ACTIONS(2302),
    [anon_sym_LR_DQUOTE] = ACTIONS(2302),
    [anon_sym_uR_DQUOTE] = ACTIONS(2302),
    [anon_sym_UR_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2302),
    [anon_sym_co_await] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_requires] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [anon_sym_discard] = ACTIONS(2300),
    [anon_sym_precise] = ACTIONS(2300),
    [anon_sym_shared] = ACTIONS(2300),
    [anon_sym_groupshared] = ACTIONS(2300),
    [anon_sym_uniform] = ACTIONS(2300),
    [anon_sym_row_major] = ACTIONS(2300),
    [anon_sym_column_major] = ACTIONS(2300),
    [anon_sym_globallycoherent] = ACTIONS(2300),
    [anon_sym_centroid] = ACTIONS(2300),
    [anon_sym_noperspective] = ACTIONS(2300),
    [anon_sym_nointerpolation] = ACTIONS(2300),
    [anon_sym_sample] = ACTIONS(2300),
    [anon_sym_linear] = ACTIONS(2300),
    [anon_sym_snorm] = ACTIONS(2300),
    [anon_sym_unorm] = ACTIONS(2300),
    [anon_sym_point] = ACTIONS(2300),
    [anon_sym_line] = ACTIONS(2300),
    [anon_sym_triangleadj] = ACTIONS(2300),
    [anon_sym_lineadj] = ACTIONS(2300),
    [anon_sym_triangle] = ACTIONS(2300),
    [anon_sym_cbuffer] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_extension] = ACTIONS(2300),
  },
  [1321] = {
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_LPAREN2] = ACTIONS(2262),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2262),
    [anon_sym_COLON] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym___extension__] = ACTIONS(2260),
    [anon_sym_typedef] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(2260),
    [anon_sym_out] = ACTIONS(2260),
    [anon_sym_inout] = ACTIONS(2260),
    [anon_sym_virtual] = ACTIONS(2260),
    [anon_sym_extern] = ACTIONS(2260),
    [anon_sym___attribute__] = ACTIONS(2260),
    [anon_sym___attribute] = ACTIONS(2260),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2262),
    [anon_sym___declspec] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_signed] = ACTIONS(2260),
    [anon_sym_unsigned] = ACTIONS(2260),
    [anon_sym_long] = ACTIONS(2260),
    [anon_sym_short] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_register] = ACTIONS(2260),
    [anon_sym_inline] = ACTIONS(2260),
    [anon_sym___inline] = ACTIONS(2260),
    [anon_sym___inline__] = ACTIONS(2260),
    [anon_sym___forceinline] = ACTIONS(2260),
    [anon_sym_thread_local] = ACTIONS(2260),
    [anon_sym___thread] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_constexpr] = ACTIONS(2260),
    [anon_sym_volatile] = ACTIONS(2260),
    [anon_sym_restrict] = ACTIONS(2260),
    [anon_sym___restrict__] = ACTIONS(2260),
    [anon_sym__Atomic] = ACTIONS(2260),
    [anon_sym__Noreturn] = ACTIONS(2260),
    [anon_sym_noreturn] = ACTIONS(2260),
    [anon_sym__Nonnull] = ACTIONS(2260),
    [anon_sym_mutable] = ACTIONS(2260),
    [anon_sym_constinit] = ACTIONS(2260),
    [anon_sym_consteval] = ACTIONS(2260),
    [anon_sym_alignas] = ACTIONS(2260),
    [anon_sym__Alignas] = ACTIONS(2260),
    [sym_primitive_type] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
    [anon_sym_class] = ACTIONS(2260),
    [anon_sym_struct] = ACTIONS(2260),
    [anon_sym_union] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_else] = ACTIONS(2260),
    [anon_sym_switch] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_do] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_goto] = ACTIONS(2260),
    [anon_sym___try] = ACTIONS(2260),
    [anon_sym___leave] = ACTIONS(2260),
    [anon_sym_not] = ACTIONS(2260),
    [anon_sym_compl] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_sizeof] = ACTIONS(2260),
    [anon_sym___alignof__] = ACTIONS(2260),
    [anon_sym___alignof] = ACTIONS(2260),
    [anon_sym__alignof] = ACTIONS(2260),
    [anon_sym_alignof] = ACTIONS(2260),
    [anon_sym__Alignof] = ACTIONS(2260),
    [anon_sym_offsetof] = ACTIONS(2260),
    [anon_sym__Generic] = ACTIONS(2260),
    [anon_sym_asm] = ACTIONS(2260),
    [anon_sym___asm__] = ACTIONS(2260),
    [anon_sym___asm] = ACTIONS(2260),
    [sym_number_literal] = ACTIONS(2262),
    [anon_sym_L_SQUOTE] = ACTIONS(2262),
    [anon_sym_u_SQUOTE] = ACTIONS(2262),
    [anon_sym_U_SQUOTE] = ACTIONS(2262),
    [anon_sym_u8_SQUOTE] = ACTIONS(2262),
    [anon_sym_SQUOTE] = ACTIONS(2262),
    [anon_sym_L_DQUOTE] = ACTIONS(2262),
    [anon_sym_u_DQUOTE] = ACTIONS(2262),
    [anon_sym_U_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8_DQUOTE] = ACTIONS(2262),
    [anon_sym_DQUOTE] = ACTIONS(2262),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [anon_sym_NULL] = ACTIONS(2260),
    [anon_sym_nullptr] = ACTIONS(2260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_This] = ACTIONS(2260),
    [anon_sym_decltype] = ACTIONS(2260),
    [anon_sym_final] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
    [anon_sym_typename] = ACTIONS(2260),
    [anon_sym_template] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_throw] = ACTIONS(2260),
    [anon_sym_co_return] = ACTIONS(2260),
    [anon_sym_co_yield] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2260),
    [anon_sym_new] = ACTIONS(2260),
    [anon_sym_requires] = ACTIONS(2260),
    [sym_this] = ACTIONS(2260),
    [anon_sym_discard] = ACTIONS(2260),
    [anon_sym_precise] = ACTIONS(2260),
    [anon_sym_shared] = ACTIONS(2260),
    [anon_sym_groupshared] = ACTIONS(2260),
    [anon_sym_uniform] = ACTIONS(2260),
    [anon_sym_row_major] = ACTIONS(2260),
    [anon_sym_column_major] = ACTIONS(2260),
    [anon_sym_globallycoherent] = ACTIONS(2260),
    [anon_sym_centroid] = ACTIONS(2260),
    [anon_sym_noperspective] = ACTIONS(2260),
    [anon_sym_nointerpolation] = ACTIONS(2260),
    [anon_sym_sample] = ACTIONS(2260),
    [anon_sym_linear] = ACTIONS(2260),
    [anon_sym_snorm] = ACTIONS(2260),
    [anon_sym_unorm] = ACTIONS(2260),
    [anon_sym_point] = ACTIONS(2260),
    [anon_sym_line] = ACTIONS(2260),
    [anon_sym_triangleadj] = ACTIONS(2260),
    [anon_sym_lineadj] = ACTIONS(2260),
    [anon_sym_triangle] = ACTIONS(2260),
    [anon_sym_cbuffer] = ACTIONS(2260),
    [anon_sym_interface] = ACTIONS(2260),
    [anon_sym_extension] = ACTIONS(2260),
  },
  [1322] = {
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_BANG] = ACTIONS(2306),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2306),
    [anon_sym_COLON] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2306),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym_typedef] = ACTIONS(2304),
    [anon_sym_in] = ACTIONS(2304),
    [anon_sym_out] = ACTIONS(2304),
    [anon_sym_inout] = ACTIONS(2304),
    [anon_sym_virtual] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym___attribute] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2306),
    [anon_sym___declspec] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_signed] = ACTIONS(2304),
    [anon_sym_unsigned] = ACTIONS(2304),
    [anon_sym_long] = ACTIONS(2304),
    [anon_sym_short] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_register] = ACTIONS(2304),
    [anon_sym_inline] = ACTIONS(2304),
    [anon_sym___inline] = ACTIONS(2304),
    [anon_sym___inline__] = ACTIONS(2304),
    [anon_sym___forceinline] = ACTIONS(2304),
    [anon_sym_thread_local] = ACTIONS(2304),
    [anon_sym___thread] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym__Nonnull] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [sym_primitive_type] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_struct] = ACTIONS(2304),
    [anon_sym_union] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_else] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_goto] = ACTIONS(2304),
    [anon_sym___try] = ACTIONS(2304),
    [anon_sym___leave] = ACTIONS(2304),
    [anon_sym_not] = ACTIONS(2304),
    [anon_sym_compl] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_sizeof] = ACTIONS(2304),
    [anon_sym___alignof__] = ACTIONS(2304),
    [anon_sym___alignof] = ACTIONS(2304),
    [anon_sym__alignof] = ACTIONS(2304),
    [anon_sym_alignof] = ACTIONS(2304),
    [anon_sym__Alignof] = ACTIONS(2304),
    [anon_sym_offsetof] = ACTIONS(2304),
    [anon_sym__Generic] = ACTIONS(2304),
    [anon_sym_asm] = ACTIONS(2304),
    [anon_sym___asm__] = ACTIONS(2304),
    [anon_sym___asm] = ACTIONS(2304),
    [sym_number_literal] = ACTIONS(2306),
    [anon_sym_L_SQUOTE] = ACTIONS(2306),
    [anon_sym_u_SQUOTE] = ACTIONS(2306),
    [anon_sym_U_SQUOTE] = ACTIONS(2306),
    [anon_sym_u8_SQUOTE] = ACTIONS(2306),
    [anon_sym_SQUOTE] = ACTIONS(2306),
    [anon_sym_L_DQUOTE] = ACTIONS(2306),
    [anon_sym_u_DQUOTE] = ACTIONS(2306),
    [anon_sym_U_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8_DQUOTE] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [anon_sym_NULL] = ACTIONS(2304),
    [anon_sym_nullptr] = ACTIONS(2304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_This] = ACTIONS(2304),
    [anon_sym_decltype] = ACTIONS(2304),
    [anon_sym_final] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_typename] = ACTIONS(2304),
    [anon_sym_template] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_co_return] = ACTIONS(2304),
    [anon_sym_co_yield] = ACTIONS(2304),
    [anon_sym_R_DQUOTE] = ACTIONS(2306),
    [anon_sym_LR_DQUOTE] = ACTIONS(2306),
    [anon_sym_uR_DQUOTE] = ACTIONS(2306),
    [anon_sym_UR_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2306),
    [anon_sym_co_await] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_requires] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [anon_sym_discard] = ACTIONS(2304),
    [anon_sym_precise] = ACTIONS(2304),
    [anon_sym_shared] = ACTIONS(2304),
    [anon_sym_groupshared] = ACTIONS(2304),
    [anon_sym_uniform] = ACTIONS(2304),
    [anon_sym_row_major] = ACTIONS(2304),
    [anon_sym_column_major] = ACTIONS(2304),
    [anon_sym_globallycoherent] = ACTIONS(2304),
    [anon_sym_centroid] = ACTIONS(2304),
    [anon_sym_noperspective] = ACTIONS(2304),
    [anon_sym_nointerpolation] = ACTIONS(2304),
    [anon_sym_sample] = ACTIONS(2304),
    [anon_sym_linear] = ACTIONS(2304),
    [anon_sym_snorm] = ACTIONS(2304),
    [anon_sym_unorm] = ACTIONS(2304),
    [anon_sym_point] = ACTIONS(2304),
    [anon_sym_line] = ACTIONS(2304),
    [anon_sym_triangleadj] = ACTIONS(2304),
    [anon_sym_lineadj] = ACTIONS(2304),
    [anon_sym_triangle] = ACTIONS(2304),
    [anon_sym_cbuffer] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_extension] = ACTIONS(2304),
  },
  [1323] = {
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_LPAREN2] = ACTIONS(2310),
    [anon_sym_BANG] = ACTIONS(2310),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2310),
    [anon_sym_COLON] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(2308),
    [anon_sym_typedef] = ACTIONS(2308),
    [anon_sym_in] = ACTIONS(2308),
    [anon_sym_out] = ACTIONS(2308),
    [anon_sym_inout] = ACTIONS(2308),
    [anon_sym_virtual] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2308),
    [anon_sym___attribute__] = ACTIONS(2308),
    [anon_sym___attribute] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2310),
    [anon_sym___declspec] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_signed] = ACTIONS(2308),
    [anon_sym_unsigned] = ACTIONS(2308),
    [anon_sym_long] = ACTIONS(2308),
    [anon_sym_short] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_register] = ACTIONS(2308),
    [anon_sym_inline] = ACTIONS(2308),
    [anon_sym___inline] = ACTIONS(2308),
    [anon_sym___inline__] = ACTIONS(2308),
    [anon_sym___forceinline] = ACTIONS(2308),
    [anon_sym_thread_local] = ACTIONS(2308),
    [anon_sym___thread] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_constexpr] = ACTIONS(2308),
    [anon_sym_volatile] = ACTIONS(2308),
    [anon_sym_restrict] = ACTIONS(2308),
    [anon_sym___restrict__] = ACTIONS(2308),
    [anon_sym__Atomic] = ACTIONS(2308),
    [anon_sym__Noreturn] = ACTIONS(2308),
    [anon_sym_noreturn] = ACTIONS(2308),
    [anon_sym__Nonnull] = ACTIONS(2308),
    [anon_sym_mutable] = ACTIONS(2308),
    [anon_sym_constinit] = ACTIONS(2308),
    [anon_sym_consteval] = ACTIONS(2308),
    [anon_sym_alignas] = ACTIONS(2308),
    [anon_sym__Alignas] = ACTIONS(2308),
    [sym_primitive_type] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_struct] = ACTIONS(2308),
    [anon_sym_union] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_else] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_goto] = ACTIONS(2308),
    [anon_sym___try] = ACTIONS(2308),
    [anon_sym___leave] = ACTIONS(2308),
    [anon_sym_not] = ACTIONS(2308),
    [anon_sym_compl] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_sizeof] = ACTIONS(2308),
    [anon_sym___alignof__] = ACTIONS(2308),
    [anon_sym___alignof] = ACTIONS(2308),
    [anon_sym__alignof] = ACTIONS(2308),
    [anon_sym_alignof] = ACTIONS(2308),
    [anon_sym__Alignof] = ACTIONS(2308),
    [anon_sym_offsetof] = ACTIONS(2308),
    [anon_sym__Generic] = ACTIONS(2308),
    [anon_sym_asm] = ACTIONS(2308),
    [anon_sym___asm__] = ACTIONS(2308),
    [anon_sym___asm] = ACTIONS(2308),
    [sym_number_literal] = ACTIONS(2310),
    [anon_sym_L_SQUOTE] = ACTIONS(2310),
    [anon_sym_u_SQUOTE] = ACTIONS(2310),
    [anon_sym_U_SQUOTE] = ACTIONS(2310),
    [anon_sym_u8_SQUOTE] = ACTIONS(2310),
    [anon_sym_SQUOTE] = ACTIONS(2310),
    [anon_sym_L_DQUOTE] = ACTIONS(2310),
    [anon_sym_u_DQUOTE] = ACTIONS(2310),
    [anon_sym_U_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8_DQUOTE] = ACTIONS(2310),
    [anon_sym_DQUOTE] = ACTIONS(2310),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [anon_sym_NULL] = ACTIONS(2308),
    [anon_sym_nullptr] = ACTIONS(2308),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_This] = ACTIONS(2308),
    [anon_sym_decltype] = ACTIONS(2308),
    [anon_sym_final] = ACTIONS(2308),
    [anon_sym_override] = ACTIONS(2308),
    [anon_sym_typename] = ACTIONS(2308),
    [anon_sym_template] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_delete] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_co_return] = ACTIONS(2308),
    [anon_sym_co_yield] = ACTIONS(2308),
    [anon_sym_R_DQUOTE] = ACTIONS(2310),
    [anon_sym_LR_DQUOTE] = ACTIONS(2310),
    [anon_sym_uR_DQUOTE] = ACTIONS(2310),
    [anon_sym_UR_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2310),
    [anon_sym_co_await] = ACTIONS(2308),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_requires] = ACTIONS(2308),
    [sym_this] = ACTIONS(2308),
    [anon_sym_discard] = ACTIONS(2308),
    [anon_sym_precise] = ACTIONS(2308),
    [anon_sym_shared] = ACTIONS(2308),
    [anon_sym_groupshared] = ACTIONS(2308),
    [anon_sym_uniform] = ACTIONS(2308),
    [anon_sym_row_major] = ACTIONS(2308),
    [anon_sym_column_major] = ACTIONS(2308),
    [anon_sym_globallycoherent] = ACTIONS(2308),
    [anon_sym_centroid] = ACTIONS(2308),
    [anon_sym_noperspective] = ACTIONS(2308),
    [anon_sym_nointerpolation] = ACTIONS(2308),
    [anon_sym_sample] = ACTIONS(2308),
    [anon_sym_linear] = ACTIONS(2308),
    [anon_sym_snorm] = ACTIONS(2308),
    [anon_sym_unorm] = ACTIONS(2308),
    [anon_sym_point] = ACTIONS(2308),
    [anon_sym_line] = ACTIONS(2308),
    [anon_sym_triangleadj] = ACTIONS(2308),
    [anon_sym_lineadj] = ACTIONS(2308),
    [anon_sym_triangle] = ACTIONS(2308),
    [anon_sym_cbuffer] = ACTIONS(2308),
    [anon_sym_interface] = ACTIONS(2308),
    [anon_sym_extension] = ACTIONS(2308),
  },
  [1324] = {
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2314),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2314),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym___extension__] = ACTIONS(2312),
    [anon_sym_typedef] = ACTIONS(2312),
    [anon_sym_in] = ACTIONS(2312),
    [anon_sym_out] = ACTIONS(2312),
    [anon_sym_inout] = ACTIONS(2312),
    [anon_sym_virtual] = ACTIONS(2312),
    [anon_sym_extern] = ACTIONS(2312),
    [anon_sym___attribute__] = ACTIONS(2312),
    [anon_sym___attribute] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2314),
    [anon_sym___declspec] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_signed] = ACTIONS(2312),
    [anon_sym_unsigned] = ACTIONS(2312),
    [anon_sym_long] = ACTIONS(2312),
    [anon_sym_short] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_register] = ACTIONS(2312),
    [anon_sym_inline] = ACTIONS(2312),
    [anon_sym___inline] = ACTIONS(2312),
    [anon_sym___inline__] = ACTIONS(2312),
    [anon_sym___forceinline] = ACTIONS(2312),
    [anon_sym_thread_local] = ACTIONS(2312),
    [anon_sym___thread] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_constexpr] = ACTIONS(2312),
    [anon_sym_volatile] = ACTIONS(2312),
    [anon_sym_restrict] = ACTIONS(2312),
    [anon_sym___restrict__] = ACTIONS(2312),
    [anon_sym__Atomic] = ACTIONS(2312),
    [anon_sym__Noreturn] = ACTIONS(2312),
    [anon_sym_noreturn] = ACTIONS(2312),
    [anon_sym__Nonnull] = ACTIONS(2312),
    [anon_sym_mutable] = ACTIONS(2312),
    [anon_sym_constinit] = ACTIONS(2312),
    [anon_sym_consteval] = ACTIONS(2312),
    [anon_sym_alignas] = ACTIONS(2312),
    [anon_sym__Alignas] = ACTIONS(2312),
    [sym_primitive_type] = ACTIONS(2312),
    [anon_sym_enum] = ACTIONS(2312),
    [anon_sym_class] = ACTIONS(2312),
    [anon_sym_struct] = ACTIONS(2312),
    [anon_sym_union] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_else] = ACTIONS(2312),
    [anon_sym_switch] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_break] = ACTIONS(2312),
    [anon_sym_continue] = ACTIONS(2312),
    [anon_sym_goto] = ACTIONS(2312),
    [anon_sym___try] = ACTIONS(2312),
    [anon_sym___leave] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2312),
    [anon_sym_compl] = ACTIONS(2312),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_sizeof] = ACTIONS(2312),
    [anon_sym___alignof__] = ACTIONS(2312),
    [anon_sym___alignof] = ACTIONS(2312),
    [anon_sym__alignof] = ACTIONS(2312),
    [anon_sym_alignof] = ACTIONS(2312),
    [anon_sym__Alignof] = ACTIONS(2312),
    [anon_sym_offsetof] = ACTIONS(2312),
    [anon_sym__Generic] = ACTIONS(2312),
    [anon_sym_asm] = ACTIONS(2312),
    [anon_sym___asm__] = ACTIONS(2312),
    [anon_sym___asm] = ACTIONS(2312),
    [sym_number_literal] = ACTIONS(2314),
    [anon_sym_L_SQUOTE] = ACTIONS(2314),
    [anon_sym_u_SQUOTE] = ACTIONS(2314),
    [anon_sym_U_SQUOTE] = ACTIONS(2314),
    [anon_sym_u8_SQUOTE] = ACTIONS(2314),
    [anon_sym_SQUOTE] = ACTIONS(2314),
    [anon_sym_L_DQUOTE] = ACTIONS(2314),
    [anon_sym_u_DQUOTE] = ACTIONS(2314),
    [anon_sym_U_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE] = ACTIONS(2314),
    [sym_true] = ACTIONS(2312),
    [sym_false] = ACTIONS(2312),
    [anon_sym_NULL] = ACTIONS(2312),
    [anon_sym_nullptr] = ACTIONS(2312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_This] = ACTIONS(2312),
    [anon_sym_decltype] = ACTIONS(2312),
    [anon_sym_final] = ACTIONS(2312),
    [anon_sym_override] = ACTIONS(2312),
    [anon_sym_typename] = ACTIONS(2312),
    [anon_sym_template] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_delete] = ACTIONS(2312),
    [anon_sym_throw] = ACTIONS(2312),
    [anon_sym_co_return] = ACTIONS(2312),
    [anon_sym_co_yield] = ACTIONS(2312),
    [anon_sym_R_DQUOTE] = ACTIONS(2314),
    [anon_sym_LR_DQUOTE] = ACTIONS(2314),
    [anon_sym_uR_DQUOTE] = ACTIONS(2314),
    [anon_sym_UR_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2314),
    [anon_sym_co_await] = ACTIONS(2312),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_requires] = ACTIONS(2312),
    [sym_this] = ACTIONS(2312),
    [anon_sym_discard] = ACTIONS(2312),
    [anon_sym_precise] = ACTIONS(2312),
    [anon_sym_shared] = ACTIONS(2312),
    [anon_sym_groupshared] = ACTIONS(2312),
    [anon_sym_uniform] = ACTIONS(2312),
    [anon_sym_row_major] = ACTIONS(2312),
    [anon_sym_column_major] = ACTIONS(2312),
    [anon_sym_globallycoherent] = ACTIONS(2312),
    [anon_sym_centroid] = ACTIONS(2312),
    [anon_sym_noperspective] = ACTIONS(2312),
    [anon_sym_nointerpolation] = ACTIONS(2312),
    [anon_sym_sample] = ACTIONS(2312),
    [anon_sym_linear] = ACTIONS(2312),
    [anon_sym_snorm] = ACTIONS(2312),
    [anon_sym_unorm] = ACTIONS(2312),
    [anon_sym_point] = ACTIONS(2312),
    [anon_sym_line] = ACTIONS(2312),
    [anon_sym_triangleadj] = ACTIONS(2312),
    [anon_sym_lineadj] = ACTIONS(2312),
    [anon_sym_triangle] = ACTIONS(2312),
    [anon_sym_cbuffer] = ACTIONS(2312),
    [anon_sym_interface] = ACTIONS(2312),
    [anon_sym_extension] = ACTIONS(2312),
  },
  [1325] = {
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym_typedef] = ACTIONS(2422),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_out] = ACTIONS(2422),
    [anon_sym_inout] = ACTIONS(2422),
    [anon_sym_virtual] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2422),
    [anon_sym_unsigned] = ACTIONS(2422),
    [anon_sym_long] = ACTIONS(2422),
    [anon_sym_short] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_register] = ACTIONS(2422),
    [anon_sym_inline] = ACTIONS(2422),
    [anon_sym___inline] = ACTIONS(2422),
    [anon_sym___inline__] = ACTIONS(2422),
    [anon_sym___forceinline] = ACTIONS(2422),
    [anon_sym_thread_local] = ACTIONS(2422),
    [anon_sym___thread] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [sym_primitive_type] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
    [anon_sym_class] = ACTIONS(2422),
    [anon_sym_struct] = ACTIONS(2422),
    [anon_sym_union] = ACTIONS(2422),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(2422),
    [anon_sym_switch] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_break] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(2422),
    [anon_sym_goto] = ACTIONS(2422),
    [anon_sym___try] = ACTIONS(2422),
    [anon_sym___leave] = ACTIONS(2422),
    [anon_sym_not] = ACTIONS(2422),
    [anon_sym_compl] = ACTIONS(2422),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_sizeof] = ACTIONS(2422),
    [anon_sym___alignof__] = ACTIONS(2422),
    [anon_sym___alignof] = ACTIONS(2422),
    [anon_sym__alignof] = ACTIONS(2422),
    [anon_sym_alignof] = ACTIONS(2422),
    [anon_sym__Alignof] = ACTIONS(2422),
    [anon_sym_offsetof] = ACTIONS(2422),
    [anon_sym__Generic] = ACTIONS(2422),
    [anon_sym_asm] = ACTIONS(2422),
    [anon_sym___asm__] = ACTIONS(2422),
    [anon_sym___asm] = ACTIONS(2422),
    [sym_number_literal] = ACTIONS(2420),
    [anon_sym_L_SQUOTE] = ACTIONS(2420),
    [anon_sym_u_SQUOTE] = ACTIONS(2420),
    [anon_sym_U_SQUOTE] = ACTIONS(2420),
    [anon_sym_u8_SQUOTE] = ACTIONS(2420),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [anon_sym_L_DQUOTE] = ACTIONS(2420),
    [anon_sym_u_DQUOTE] = ACTIONS(2420),
    [anon_sym_U_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [sym_true] = ACTIONS(2422),
    [sym_false] = ACTIONS(2422),
    [anon_sym_NULL] = ACTIONS(2422),
    [anon_sym_nullptr] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_decltype] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_typename] = ACTIONS(2422),
    [anon_sym_template] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_delete] = ACTIONS(2422),
    [anon_sym_throw] = ACTIONS(2422),
    [anon_sym_co_return] = ACTIONS(2422),
    [anon_sym_co_yield] = ACTIONS(2422),
    [anon_sym_R_DQUOTE] = ACTIONS(2420),
    [anon_sym_LR_DQUOTE] = ACTIONS(2420),
    [anon_sym_uR_DQUOTE] = ACTIONS(2420),
    [anon_sym_UR_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2420),
    [anon_sym_co_await] = ACTIONS(2422),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_requires] = ACTIONS(2422),
    [sym_this] = ACTIONS(2422),
    [anon_sym_discard] = ACTIONS(2422),
    [anon_sym_precise] = ACTIONS(2422),
    [anon_sym_shared] = ACTIONS(2422),
    [anon_sym_groupshared] = ACTIONS(2422),
    [anon_sym_uniform] = ACTIONS(2422),
    [anon_sym_row_major] = ACTIONS(2422),
    [anon_sym_column_major] = ACTIONS(2422),
    [anon_sym_globallycoherent] = ACTIONS(2422),
    [anon_sym_centroid] = ACTIONS(2422),
    [anon_sym_noperspective] = ACTIONS(2422),
    [anon_sym_nointerpolation] = ACTIONS(2422),
    [anon_sym_sample] = ACTIONS(2422),
    [anon_sym_linear] = ACTIONS(2422),
    [anon_sym_snorm] = ACTIONS(2422),
    [anon_sym_unorm] = ACTIONS(2422),
    [anon_sym_point] = ACTIONS(2422),
    [anon_sym_line] = ACTIONS(2422),
    [anon_sym_triangleadj] = ACTIONS(2422),
    [anon_sym_lineadj] = ACTIONS(2422),
    [anon_sym_triangle] = ACTIONS(2422),
    [anon_sym_cbuffer] = ACTIONS(2422),
    [anon_sym_interface] = ACTIONS(2422),
    [anon_sym_extension] = ACTIONS(2422),
  },
  [1326] = {
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym_typedef] = ACTIONS(2422),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_out] = ACTIONS(2422),
    [anon_sym_inout] = ACTIONS(2422),
    [anon_sym_virtual] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2422),
    [anon_sym_unsigned] = ACTIONS(2422),
    [anon_sym_long] = ACTIONS(2422),
    [anon_sym_short] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_register] = ACTIONS(2422),
    [anon_sym_inline] = ACTIONS(2422),
    [anon_sym___inline] = ACTIONS(2422),
    [anon_sym___inline__] = ACTIONS(2422),
    [anon_sym___forceinline] = ACTIONS(2422),
    [anon_sym_thread_local] = ACTIONS(2422),
    [anon_sym___thread] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [sym_primitive_type] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
    [anon_sym_class] = ACTIONS(2422),
    [anon_sym_struct] = ACTIONS(2422),
    [anon_sym_union] = ACTIONS(2422),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(2422),
    [anon_sym_switch] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_break] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(2422),
    [anon_sym_goto] = ACTIONS(2422),
    [anon_sym___try] = ACTIONS(2422),
    [anon_sym___leave] = ACTIONS(2422),
    [anon_sym_not] = ACTIONS(2422),
    [anon_sym_compl] = ACTIONS(2422),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_sizeof] = ACTIONS(2422),
    [anon_sym___alignof__] = ACTIONS(2422),
    [anon_sym___alignof] = ACTIONS(2422),
    [anon_sym__alignof] = ACTIONS(2422),
    [anon_sym_alignof] = ACTIONS(2422),
    [anon_sym__Alignof] = ACTIONS(2422),
    [anon_sym_offsetof] = ACTIONS(2422),
    [anon_sym__Generic] = ACTIONS(2422),
    [anon_sym_asm] = ACTIONS(2422),
    [anon_sym___asm__] = ACTIONS(2422),
    [anon_sym___asm] = ACTIONS(2422),
    [sym_number_literal] = ACTIONS(2420),
    [anon_sym_L_SQUOTE] = ACTIONS(2420),
    [anon_sym_u_SQUOTE] = ACTIONS(2420),
    [anon_sym_U_SQUOTE] = ACTIONS(2420),
    [anon_sym_u8_SQUOTE] = ACTIONS(2420),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [anon_sym_L_DQUOTE] = ACTIONS(2420),
    [anon_sym_u_DQUOTE] = ACTIONS(2420),
    [anon_sym_U_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [sym_true] = ACTIONS(2422),
    [sym_false] = ACTIONS(2422),
    [anon_sym_NULL] = ACTIONS(2422),
    [anon_sym_nullptr] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_decltype] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_typename] = ACTIONS(2422),
    [anon_sym_template] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_delete] = ACTIONS(2422),
    [anon_sym_throw] = ACTIONS(2422),
    [anon_sym_co_return] = ACTIONS(2422),
    [anon_sym_co_yield] = ACTIONS(2422),
    [anon_sym_R_DQUOTE] = ACTIONS(2420),
    [anon_sym_LR_DQUOTE] = ACTIONS(2420),
    [anon_sym_uR_DQUOTE] = ACTIONS(2420),
    [anon_sym_UR_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2420),
    [anon_sym_co_await] = ACTIONS(2422),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_requires] = ACTIONS(2422),
    [sym_this] = ACTIONS(2422),
    [anon_sym_discard] = ACTIONS(2422),
    [anon_sym_precise] = ACTIONS(2422),
    [anon_sym_shared] = ACTIONS(2422),
    [anon_sym_groupshared] = ACTIONS(2422),
    [anon_sym_uniform] = ACTIONS(2422),
    [anon_sym_row_major] = ACTIONS(2422),
    [anon_sym_column_major] = ACTIONS(2422),
    [anon_sym_globallycoherent] = ACTIONS(2422),
    [anon_sym_centroid] = ACTIONS(2422),
    [anon_sym_noperspective] = ACTIONS(2422),
    [anon_sym_nointerpolation] = ACTIONS(2422),
    [anon_sym_sample] = ACTIONS(2422),
    [anon_sym_linear] = ACTIONS(2422),
    [anon_sym_snorm] = ACTIONS(2422),
    [anon_sym_unorm] = ACTIONS(2422),
    [anon_sym_point] = ACTIONS(2422),
    [anon_sym_line] = ACTIONS(2422),
    [anon_sym_triangleadj] = ACTIONS(2422),
    [anon_sym_lineadj] = ACTIONS(2422),
    [anon_sym_triangle] = ACTIONS(2422),
    [anon_sym_cbuffer] = ACTIONS(2422),
    [anon_sym_interface] = ACTIONS(2422),
    [anon_sym_extension] = ACTIONS(2422),
  },
  [1327] = {
    [sym_type_qualifier] = STATE(4345),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5248),
    [sym_sized_type_specifier] = STATE(5702),
    [sym_enum_specifier] = STATE(5702),
    [sym_struct_specifier] = STATE(5702),
    [sym_union_specifier] = STATE(5702),
    [sym_expression] = STATE(5768),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_type_descriptor] = STATE(9037),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_placeholder_type_specifier] = STATE(5702),
    [sym_decltype] = STATE(5498),
    [sym_class_specifier] = STATE(5702),
    [sym__class_name] = STATE(10404),
    [sym_dependent_type] = STATE(5702),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_type_parameter_pack_expansion] = STATE(10395),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7346),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4674),
    [sym_interface_specifier] = STATE(5702),
    [sym_extension_specifier] = STATE(5702),
    [sym_associatedtype_specifier] = STATE(5702),
    [aux_sym__type_definition_type_repeat1] = STATE(4345),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4970),
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5084),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_signed] = ACTIONS(5088),
    [anon_sym_unsigned] = ACTIONS(5088),
    [anon_sym_long] = ACTIONS(5088),
    [anon_sym_short] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5096),
    [anon_sym_union] = ACTIONS(5098),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5306),
    [anon_sym_This] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5128),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_extension] = ACTIONS(5144),
  },
  [1328] = {
    [sym_catch_clause] = STATE(1328),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1328),
    [sym_identifier] = ACTIONS(2901),
    [anon_sym_LPAREN2] = ACTIONS(2903),
    [anon_sym_BANG] = ACTIONS(2903),
    [anon_sym_TILDE] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2901),
    [anon_sym_STAR] = ACTIONS(2903),
    [anon_sym_AMP] = ACTIONS(2903),
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym___extension__] = ACTIONS(2901),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_in] = ACTIONS(2901),
    [anon_sym_out] = ACTIONS(2901),
    [anon_sym_inout] = ACTIONS(2901),
    [anon_sym_virtual] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(2901),
    [anon_sym___attribute__] = ACTIONS(2901),
    [anon_sym___attribute] = ACTIONS(2901),
    [anon_sym_COLON_COLON] = ACTIONS(2903),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2903),
    [anon_sym___declspec] = ACTIONS(2901),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_signed] = ACTIONS(2901),
    [anon_sym_unsigned] = ACTIONS(2901),
    [anon_sym_long] = ACTIONS(2901),
    [anon_sym_short] = ACTIONS(2901),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_static] = ACTIONS(2901),
    [anon_sym_register] = ACTIONS(2901),
    [anon_sym_inline] = ACTIONS(2901),
    [anon_sym___inline] = ACTIONS(2901),
    [anon_sym___inline__] = ACTIONS(2901),
    [anon_sym___forceinline] = ACTIONS(2901),
    [anon_sym_thread_local] = ACTIONS(2901),
    [anon_sym___thread] = ACTIONS(2901),
    [anon_sym_const] = ACTIONS(2901),
    [anon_sym_constexpr] = ACTIONS(2901),
    [anon_sym_volatile] = ACTIONS(2901),
    [anon_sym_restrict] = ACTIONS(2901),
    [anon_sym___restrict__] = ACTIONS(2901),
    [anon_sym__Atomic] = ACTIONS(2901),
    [anon_sym__Noreturn] = ACTIONS(2901),
    [anon_sym_noreturn] = ACTIONS(2901),
    [anon_sym__Nonnull] = ACTIONS(2901),
    [anon_sym_mutable] = ACTIONS(2901),
    [anon_sym_constinit] = ACTIONS(2901),
    [anon_sym_consteval] = ACTIONS(2901),
    [anon_sym_alignas] = ACTIONS(2901),
    [anon_sym__Alignas] = ACTIONS(2901),
    [sym_primitive_type] = ACTIONS(2901),
    [anon_sym_enum] = ACTIONS(2901),
    [anon_sym_class] = ACTIONS(2901),
    [anon_sym_struct] = ACTIONS(2901),
    [anon_sym_union] = ACTIONS(2901),
    [anon_sym_if] = ACTIONS(2901),
    [anon_sym_else] = ACTIONS(2901),
    [anon_sym_switch] = ACTIONS(2901),
    [anon_sym_while] = ACTIONS(2901),
    [anon_sym_do] = ACTIONS(2901),
    [anon_sym_for] = ACTIONS(2901),
    [anon_sym_return] = ACTIONS(2901),
    [anon_sym_break] = ACTIONS(2901),
    [anon_sym_continue] = ACTIONS(2901),
    [anon_sym_goto] = ACTIONS(2901),
    [anon_sym___try] = ACTIONS(2901),
    [anon_sym___leave] = ACTIONS(2901),
    [anon_sym_not] = ACTIONS(2901),
    [anon_sym_compl] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2903),
    [anon_sym_PLUS_PLUS] = ACTIONS(2903),
    [anon_sym_sizeof] = ACTIONS(2901),
    [anon_sym___alignof__] = ACTIONS(2901),
    [anon_sym___alignof] = ACTIONS(2901),
    [anon_sym__alignof] = ACTIONS(2901),
    [anon_sym_alignof] = ACTIONS(2901),
    [anon_sym__Alignof] = ACTIONS(2901),
    [anon_sym_offsetof] = ACTIONS(2901),
    [anon_sym__Generic] = ACTIONS(2901),
    [anon_sym_asm] = ACTIONS(2901),
    [anon_sym___asm__] = ACTIONS(2901),
    [anon_sym___asm] = ACTIONS(2901),
    [sym_number_literal] = ACTIONS(2903),
    [anon_sym_L_SQUOTE] = ACTIONS(2903),
    [anon_sym_u_SQUOTE] = ACTIONS(2903),
    [anon_sym_U_SQUOTE] = ACTIONS(2903),
    [anon_sym_u8_SQUOTE] = ACTIONS(2903),
    [anon_sym_SQUOTE] = ACTIONS(2903),
    [anon_sym_L_DQUOTE] = ACTIONS(2903),
    [anon_sym_u_DQUOTE] = ACTIONS(2903),
    [anon_sym_U_DQUOTE] = ACTIONS(2903),
    [anon_sym_u8_DQUOTE] = ACTIONS(2903),
    [anon_sym_DQUOTE] = ACTIONS(2903),
    [sym_true] = ACTIONS(2901),
    [sym_false] = ACTIONS(2901),
    [anon_sym_NULL] = ACTIONS(2901),
    [anon_sym_nullptr] = ACTIONS(2901),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2901),
    [anon_sym_let] = ACTIONS(2901),
    [anon_sym_This] = ACTIONS(2901),
    [anon_sym_decltype] = ACTIONS(2901),
    [anon_sym_typename] = ACTIONS(2901),
    [anon_sym_template] = ACTIONS(2901),
    [anon_sym_try] = ACTIONS(2901),
    [anon_sym_delete] = ACTIONS(2901),
    [anon_sym_throw] = ACTIONS(2901),
    [anon_sym_co_return] = ACTIONS(2901),
    [anon_sym_co_yield] = ACTIONS(2901),
    [anon_sym_catch] = ACTIONS(5308),
    [anon_sym_R_DQUOTE] = ACTIONS(2903),
    [anon_sym_LR_DQUOTE] = ACTIONS(2903),
    [anon_sym_uR_DQUOTE] = ACTIONS(2903),
    [anon_sym_UR_DQUOTE] = ACTIONS(2903),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2903),
    [anon_sym_co_await] = ACTIONS(2901),
    [anon_sym_new] = ACTIONS(2901),
    [anon_sym_requires] = ACTIONS(2901),
    [sym_this] = ACTIONS(2901),
    [anon_sym_discard] = ACTIONS(2901),
    [anon_sym_precise] = ACTIONS(2901),
    [anon_sym_shared] = ACTIONS(2901),
    [anon_sym_groupshared] = ACTIONS(2901),
    [anon_sym_uniform] = ACTIONS(2901),
    [anon_sym_row_major] = ACTIONS(2901),
    [anon_sym_column_major] = ACTIONS(2901),
    [anon_sym_globallycoherent] = ACTIONS(2901),
    [anon_sym_centroid] = ACTIONS(2901),
    [anon_sym_noperspective] = ACTIONS(2901),
    [anon_sym_nointerpolation] = ACTIONS(2901),
    [anon_sym_sample] = ACTIONS(2901),
    [anon_sym_linear] = ACTIONS(2901),
    [anon_sym_snorm] = ACTIONS(2901),
    [anon_sym_unorm] = ACTIONS(2901),
    [anon_sym_point] = ACTIONS(2901),
    [anon_sym_line] = ACTIONS(2901),
    [anon_sym_triangleadj] = ACTIONS(2901),
    [anon_sym_lineadj] = ACTIONS(2901),
    [anon_sym_triangle] = ACTIONS(2901),
    [anon_sym_cbuffer] = ACTIONS(2901),
    [anon_sym_interface] = ACTIONS(2901),
    [anon_sym_extension] = ACTIONS(2901),
  },
  [1329] = {
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(5999),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_type_descriptor] = STATE(11077),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7299),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4315),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5313),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5315),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1330] = {
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(5924),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_type_descriptor] = STATE(11525),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7299),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4315),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5313),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5315),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1331] = {
    [sym_expression] = STATE(4664),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_initializer_list] = STATE(4903),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4954),
    [anon_sym_COMMA] = ACTIONS(4954),
    [anon_sym_RPAREN] = ACTIONS(4954),
    [anon_sym_LPAREN2] = ACTIONS(4954),
    [anon_sym_BANG] = ACTIONS(2342),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(4952),
    [anon_sym_PLUS] = ACTIONS(4952),
    [anon_sym_STAR] = ACTIONS(4952),
    [anon_sym_SLASH] = ACTIONS(4952),
    [anon_sym_PERCENT] = ACTIONS(4952),
    [anon_sym_PIPE_PIPE] = ACTIONS(4954),
    [anon_sym_AMP_AMP] = ACTIONS(4954),
    [anon_sym_PIPE] = ACTIONS(4952),
    [anon_sym_CARET] = ACTIONS(4952),
    [anon_sym_AMP] = ACTIONS(4952),
    [anon_sym_EQ_EQ] = ACTIONS(4954),
    [anon_sym_BANG_EQ] = ACTIONS(4954),
    [anon_sym_GT] = ACTIONS(4952),
    [anon_sym_GT_EQ] = ACTIONS(4954),
    [anon_sym_LT_EQ] = ACTIONS(4952),
    [anon_sym_LT] = ACTIONS(4952),
    [anon_sym_LT_LT] = ACTIONS(4952),
    [anon_sym_GT_GT] = ACTIONS(4952),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACE] = ACTIONS(5321),
    [anon_sym_LBRACK] = ACTIONS(4954),
    [anon_sym_EQ] = ACTIONS(4952),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_QMARK] = ACTIONS(4954),
    [anon_sym_STAR_EQ] = ACTIONS(4954),
    [anon_sym_SLASH_EQ] = ACTIONS(4954),
    [anon_sym_PERCENT_EQ] = ACTIONS(4954),
    [anon_sym_PLUS_EQ] = ACTIONS(4954),
    [anon_sym_DASH_EQ] = ACTIONS(4954),
    [anon_sym_LT_LT_EQ] = ACTIONS(4954),
    [anon_sym_GT_GT_EQ] = ACTIONS(4954),
    [anon_sym_AMP_EQ] = ACTIONS(4954),
    [anon_sym_CARET_EQ] = ACTIONS(4954),
    [anon_sym_PIPE_EQ] = ACTIONS(4954),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_LT_EQ_GT] = ACTIONS(4954),
    [anon_sym_or] = ACTIONS(4952),
    [anon_sym_and] = ACTIONS(4952),
    [anon_sym_bitor] = ACTIONS(4952),
    [anon_sym_xor] = ACTIONS(4952),
    [anon_sym_bitand] = ACTIONS(4952),
    [anon_sym_not_eq] = ACTIONS(4952),
    [anon_sym_is] = ACTIONS(4952),
    [anon_sym_as] = ACTIONS(4952),
    [anon_sym_DASH_DASH] = ACTIONS(4954),
    [anon_sym_PLUS_PLUS] = ACTIONS(4954),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [anon_sym_DOT] = ACTIONS(4952),
    [anon_sym_DOT_STAR] = ACTIONS(4954),
    [anon_sym_DASH_GT] = ACTIONS(4952),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4954),
    [sym_this] = ACTIONS(2380),
  },
  [1332] = {
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(5906),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_type_descriptor] = STATE(11592),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7299),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4315),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5313),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5315),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1333] = {
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(6004),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_type_descriptor] = STATE(10906),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7299),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4315),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5313),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5315),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1334] = {
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(6011),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_type_descriptor] = STATE(11010),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7299),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4315),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5313),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5315),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1335] = {
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(5920),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_type_descriptor] = STATE(11213),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7299),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4315),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5313),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5315),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1336] = {
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(5991),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_type_descriptor] = STATE(11245),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7299),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4315),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5313),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5315),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1337] = {
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(6024),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_type_descriptor] = STATE(11085),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7299),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4315),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5313),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5315),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1338] = {
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(5932),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_type_descriptor] = STATE(10954),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7299),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4315),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5313),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5315),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1339] = {
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(5962),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_type_descriptor] = STATE(11439),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7299),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4315),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5313),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5315),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1340] = {
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(5993),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_type_descriptor] = STATE(10879),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7299),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4315),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5313),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5315),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1341] = {
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(6010),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_type_descriptor] = STATE(11017),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7299),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4315),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5313),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5315),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1342] = {
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(6027),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_type_descriptor] = STATE(11104),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7299),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4315),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5313),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5315),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1343] = {
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(6052),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_type_descriptor] = STATE(11167),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7299),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4315),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5313),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5315),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1344] = {
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(5887),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_type_descriptor] = STATE(11238),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7299),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4315),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5313),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5315),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1345] = {
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(5897),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_type_descriptor] = STATE(11312),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7299),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4315),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5313),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5315),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1346] = {
    [sym_type_qualifier] = STATE(4383),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(5893),
    [sym_sized_type_specifier] = STATE(3062),
    [sym_enum_specifier] = STATE(3062),
    [sym_struct_specifier] = STATE(3062),
    [sym_union_specifier] = STATE(3062),
    [sym_expression] = STATE(5910),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_type_descriptor] = STATE(11402),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_placeholder_type_specifier] = STATE(3062),
    [sym_decltype] = STATE(2997),
    [sym_class_specifier] = STATE(3062),
    [sym__class_name] = STATE(10558),
    [sym_dependent_type] = STATE(3062),
    [sym_template_type] = STATE(6569),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7299),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(6685),
    [sym_user_defined_literal] = STATE(4315),
    [sym_interface_specifier] = STATE(3062),
    [sym_extension_specifier] = STATE(3062),
    [sym_associatedtype_specifier] = STATE(3062),
    [aux_sym__type_definition_type_repeat1] = STATE(4383),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5163),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5313),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(5315),
    [anon_sym_enum] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2829),
    [anon_sym_union] = ACTIONS(2831),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_This] = ACTIONS(2855),
    [anon_sym_decltype] = ACTIONS(2857),
    [anon_sym_typename] = ACTIONS(2859),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_extension] = ACTIONS(2875),
  },
  [1347] = {
    [sym_identifier] = ACTIONS(2414),
    [anon_sym_LPAREN2] = ACTIONS(2412),
    [anon_sym_BANG] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2412),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym___extension__] = ACTIONS(2414),
    [anon_sym_typedef] = ACTIONS(2414),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_out] = ACTIONS(2414),
    [anon_sym_inout] = ACTIONS(2414),
    [anon_sym_virtual] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym___attribute__] = ACTIONS(2414),
    [anon_sym___attribute] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2412),
    [anon_sym___declspec] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(2412),
    [anon_sym_signed] = ACTIONS(2414),
    [anon_sym_unsigned] = ACTIONS(2414),
    [anon_sym_long] = ACTIONS(2414),
    [anon_sym_short] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_register] = ACTIONS(2414),
    [anon_sym_inline] = ACTIONS(2414),
    [anon_sym___inline] = ACTIONS(2414),
    [anon_sym___inline__] = ACTIONS(2414),
    [anon_sym___forceinline] = ACTIONS(2414),
    [anon_sym_thread_local] = ACTIONS(2414),
    [anon_sym___thread] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_constexpr] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym_restrict] = ACTIONS(2414),
    [anon_sym___restrict__] = ACTIONS(2414),
    [anon_sym__Atomic] = ACTIONS(2414),
    [anon_sym__Noreturn] = ACTIONS(2414),
    [anon_sym_noreturn] = ACTIONS(2414),
    [anon_sym__Nonnull] = ACTIONS(2414),
    [anon_sym_mutable] = ACTIONS(2414),
    [anon_sym_constinit] = ACTIONS(2414),
    [anon_sym_consteval] = ACTIONS(2414),
    [anon_sym_alignas] = ACTIONS(2414),
    [anon_sym__Alignas] = ACTIONS(2414),
    [sym_primitive_type] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [anon_sym_if] = ACTIONS(2414),
    [anon_sym_else] = ACTIONS(2414),
    [anon_sym_switch] = ACTIONS(2414),
    [anon_sym_while] = ACTIONS(2414),
    [anon_sym_do] = ACTIONS(2414),
    [anon_sym_for] = ACTIONS(2414),
    [anon_sym_return] = ACTIONS(2414),
    [anon_sym_break] = ACTIONS(2414),
    [anon_sym_continue] = ACTIONS(2414),
    [anon_sym_goto] = ACTIONS(2414),
    [anon_sym___try] = ACTIONS(2414),
    [anon_sym___leave] = ACTIONS(2414),
    [anon_sym_not] = ACTIONS(2414),
    [anon_sym_compl] = ACTIONS(2414),
    [anon_sym_DASH_DASH] = ACTIONS(2412),
    [anon_sym_PLUS_PLUS] = ACTIONS(2412),
    [anon_sym_sizeof] = ACTIONS(2414),
    [anon_sym___alignof__] = ACTIONS(2414),
    [anon_sym___alignof] = ACTIONS(2414),
    [anon_sym__alignof] = ACTIONS(2414),
    [anon_sym_alignof] = ACTIONS(2414),
    [anon_sym__Alignof] = ACTIONS(2414),
    [anon_sym_offsetof] = ACTIONS(2414),
    [anon_sym__Generic] = ACTIONS(2414),
    [anon_sym_asm] = ACTIONS(2414),
    [anon_sym___asm__] = ACTIONS(2414),
    [anon_sym___asm] = ACTIONS(2414),
    [sym_number_literal] = ACTIONS(2412),
    [anon_sym_L_SQUOTE] = ACTIONS(2412),
    [anon_sym_u_SQUOTE] = ACTIONS(2412),
    [anon_sym_U_SQUOTE] = ACTIONS(2412),
    [anon_sym_u8_SQUOTE] = ACTIONS(2412),
    [anon_sym_SQUOTE] = ACTIONS(2412),
    [anon_sym_L_DQUOTE] = ACTIONS(2412),
    [anon_sym_u_DQUOTE] = ACTIONS(2412),
    [anon_sym_U_DQUOTE] = ACTIONS(2412),
    [anon_sym_u8_DQUOTE] = ACTIONS(2412),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [sym_true] = ACTIONS(2414),
    [sym_false] = ACTIONS(2414),
    [anon_sym_NULL] = ACTIONS(2414),
    [anon_sym_nullptr] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2414),
    [anon_sym_let] = ACTIONS(2414),
    [anon_sym_This] = ACTIONS(2414),
    [anon_sym_decltype] = ACTIONS(2414),
    [anon_sym_typename] = ACTIONS(2414),
    [anon_sym_template] = ACTIONS(2414),
    [anon_sym_try] = ACTIONS(2414),
    [anon_sym_delete] = ACTIONS(2414),
    [anon_sym_throw] = ACTIONS(2414),
    [anon_sym_co_return] = ACTIONS(2414),
    [anon_sym_co_yield] = ACTIONS(2414),
    [anon_sym_catch] = ACTIONS(2414),
    [anon_sym_R_DQUOTE] = ACTIONS(2412),
    [anon_sym_LR_DQUOTE] = ACTIONS(2412),
    [anon_sym_uR_DQUOTE] = ACTIONS(2412),
    [anon_sym_UR_DQUOTE] = ACTIONS(2412),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2412),
    [anon_sym_co_await] = ACTIONS(2414),
    [anon_sym_new] = ACTIONS(2414),
    [anon_sym_requires] = ACTIONS(2414),
    [sym_this] = ACTIONS(2414),
    [anon_sym_discard] = ACTIONS(2414),
    [anon_sym_precise] = ACTIONS(2414),
    [anon_sym_shared] = ACTIONS(2414),
    [anon_sym_groupshared] = ACTIONS(2414),
    [anon_sym_uniform] = ACTIONS(2414),
    [anon_sym_row_major] = ACTIONS(2414),
    [anon_sym_column_major] = ACTIONS(2414),
    [anon_sym_globallycoherent] = ACTIONS(2414),
    [anon_sym_centroid] = ACTIONS(2414),
    [anon_sym_noperspective] = ACTIONS(2414),
    [anon_sym_nointerpolation] = ACTIONS(2414),
    [anon_sym_sample] = ACTIONS(2414),
    [anon_sym_linear] = ACTIONS(2414),
    [anon_sym_snorm] = ACTIONS(2414),
    [anon_sym_unorm] = ACTIONS(2414),
    [anon_sym_point] = ACTIONS(2414),
    [anon_sym_line] = ACTIONS(2414),
    [anon_sym_triangleadj] = ACTIONS(2414),
    [anon_sym_lineadj] = ACTIONS(2414),
    [anon_sym_triangle] = ACTIONS(2414),
    [anon_sym_cbuffer] = ACTIONS(2414),
    [anon_sym_interface] = ACTIONS(2414),
    [anon_sym_extension] = ACTIONS(2414),
  },
  [1348] = {
    [sym_else_clause] = STATE(1374),
    [sym_identifier] = ACTIONS(3240),
    [anon_sym_LPAREN2] = ACTIONS(3238),
    [anon_sym_BANG] = ACTIONS(3238),
    [anon_sym_TILDE] = ACTIONS(3238),
    [anon_sym_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3240),
    [anon_sym_STAR] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3238),
    [anon_sym_SEMI] = ACTIONS(3238),
    [anon_sym___extension__] = ACTIONS(3240),
    [anon_sym_typedef] = ACTIONS(3240),
    [anon_sym_in] = ACTIONS(3240),
    [anon_sym_out] = ACTIONS(3240),
    [anon_sym_inout] = ACTIONS(3240),
    [anon_sym_virtual] = ACTIONS(3240),
    [anon_sym_extern] = ACTIONS(3240),
    [anon_sym___attribute__] = ACTIONS(3240),
    [anon_sym___attribute] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3238),
    [anon_sym___declspec] = ACTIONS(3240),
    [anon_sym_LBRACE] = ACTIONS(3238),
    [anon_sym_signed] = ACTIONS(3240),
    [anon_sym_unsigned] = ACTIONS(3240),
    [anon_sym_long] = ACTIONS(3240),
    [anon_sym_short] = ACTIONS(3240),
    [anon_sym_LBRACK] = ACTIONS(3240),
    [anon_sym_static] = ACTIONS(3240),
    [anon_sym_register] = ACTIONS(3240),
    [anon_sym_inline] = ACTIONS(3240),
    [anon_sym___inline] = ACTIONS(3240),
    [anon_sym___inline__] = ACTIONS(3240),
    [anon_sym___forceinline] = ACTIONS(3240),
    [anon_sym_thread_local] = ACTIONS(3240),
    [anon_sym___thread] = ACTIONS(3240),
    [anon_sym_const] = ACTIONS(3240),
    [anon_sym_constexpr] = ACTIONS(3240),
    [anon_sym_volatile] = ACTIONS(3240),
    [anon_sym_restrict] = ACTIONS(3240),
    [anon_sym___restrict__] = ACTIONS(3240),
    [anon_sym__Atomic] = ACTIONS(3240),
    [anon_sym__Noreturn] = ACTIONS(3240),
    [anon_sym_noreturn] = ACTIONS(3240),
    [anon_sym__Nonnull] = ACTIONS(3240),
    [anon_sym_mutable] = ACTIONS(3240),
    [anon_sym_constinit] = ACTIONS(3240),
    [anon_sym_consteval] = ACTIONS(3240),
    [anon_sym_alignas] = ACTIONS(3240),
    [anon_sym__Alignas] = ACTIONS(3240),
    [sym_primitive_type] = ACTIONS(3240),
    [anon_sym_enum] = ACTIONS(3240),
    [anon_sym_class] = ACTIONS(3240),
    [anon_sym_struct] = ACTIONS(3240),
    [anon_sym_union] = ACTIONS(3240),
    [anon_sym_if] = ACTIONS(3240),
    [anon_sym_else] = ACTIONS(5325),
    [anon_sym_switch] = ACTIONS(3240),
    [anon_sym_while] = ACTIONS(3240),
    [anon_sym_do] = ACTIONS(3240),
    [anon_sym_for] = ACTIONS(3240),
    [anon_sym_return] = ACTIONS(3240),
    [anon_sym_break] = ACTIONS(3240),
    [anon_sym_continue] = ACTIONS(3240),
    [anon_sym_goto] = ACTIONS(3240),
    [anon_sym___try] = ACTIONS(3240),
    [anon_sym___leave] = ACTIONS(3240),
    [anon_sym_not] = ACTIONS(3240),
    [anon_sym_compl] = ACTIONS(3240),
    [anon_sym_DASH_DASH] = ACTIONS(3238),
    [anon_sym_PLUS_PLUS] = ACTIONS(3238),
    [anon_sym_sizeof] = ACTIONS(3240),
    [anon_sym___alignof__] = ACTIONS(3240),
    [anon_sym___alignof] = ACTIONS(3240),
    [anon_sym__alignof] = ACTIONS(3240),
    [anon_sym_alignof] = ACTIONS(3240),
    [anon_sym__Alignof] = ACTIONS(3240),
    [anon_sym_offsetof] = ACTIONS(3240),
    [anon_sym__Generic] = ACTIONS(3240),
    [anon_sym_asm] = ACTIONS(3240),
    [anon_sym___asm__] = ACTIONS(3240),
    [anon_sym___asm] = ACTIONS(3240),
    [sym_number_literal] = ACTIONS(3238),
    [anon_sym_L_SQUOTE] = ACTIONS(3238),
    [anon_sym_u_SQUOTE] = ACTIONS(3238),
    [anon_sym_U_SQUOTE] = ACTIONS(3238),
    [anon_sym_u8_SQUOTE] = ACTIONS(3238),
    [anon_sym_SQUOTE] = ACTIONS(3238),
    [anon_sym_L_DQUOTE] = ACTIONS(3238),
    [anon_sym_u_DQUOTE] = ACTIONS(3238),
    [anon_sym_U_DQUOTE] = ACTIONS(3238),
    [anon_sym_u8_DQUOTE] = ACTIONS(3238),
    [anon_sym_DQUOTE] = ACTIONS(3238),
    [sym_true] = ACTIONS(3240),
    [sym_false] = ACTIONS(3240),
    [anon_sym_NULL] = ACTIONS(3240),
    [anon_sym_nullptr] = ACTIONS(3240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3240),
    [anon_sym_let] = ACTIONS(3240),
    [anon_sym_This] = ACTIONS(3240),
    [anon_sym_decltype] = ACTIONS(3240),
    [anon_sym_typename] = ACTIONS(3240),
    [anon_sym_template] = ACTIONS(3240),
    [anon_sym_try] = ACTIONS(3240),
    [anon_sym_delete] = ACTIONS(3240),
    [anon_sym_throw] = ACTIONS(3240),
    [anon_sym_co_return] = ACTIONS(3240),
    [anon_sym_co_yield] = ACTIONS(3240),
    [anon_sym_R_DQUOTE] = ACTIONS(3238),
    [anon_sym_LR_DQUOTE] = ACTIONS(3238),
    [anon_sym_uR_DQUOTE] = ACTIONS(3238),
    [anon_sym_UR_DQUOTE] = ACTIONS(3238),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3238),
    [anon_sym_co_await] = ACTIONS(3240),
    [anon_sym_new] = ACTIONS(3240),
    [anon_sym_requires] = ACTIONS(3240),
    [sym_this] = ACTIONS(3240),
    [anon_sym_discard] = ACTIONS(3240),
    [anon_sym_precise] = ACTIONS(3240),
    [anon_sym_shared] = ACTIONS(3240),
    [anon_sym_groupshared] = ACTIONS(3240),
    [anon_sym_uniform] = ACTIONS(3240),
    [anon_sym_row_major] = ACTIONS(3240),
    [anon_sym_column_major] = ACTIONS(3240),
    [anon_sym_globallycoherent] = ACTIONS(3240),
    [anon_sym_centroid] = ACTIONS(3240),
    [anon_sym_noperspective] = ACTIONS(3240),
    [anon_sym_nointerpolation] = ACTIONS(3240),
    [anon_sym_sample] = ACTIONS(3240),
    [anon_sym_linear] = ACTIONS(3240),
    [anon_sym_snorm] = ACTIONS(3240),
    [anon_sym_unorm] = ACTIONS(3240),
    [anon_sym_point] = ACTIONS(3240),
    [anon_sym_line] = ACTIONS(3240),
    [anon_sym_triangleadj] = ACTIONS(3240),
    [anon_sym_lineadj] = ACTIONS(3240),
    [anon_sym_triangle] = ACTIONS(3240),
    [anon_sym_cbuffer] = ACTIONS(3240),
    [anon_sym_interface] = ACTIONS(3240),
    [anon_sym_extension] = ACTIONS(3240),
  },
  [1349] = {
    [sym_else_clause] = STATE(1385),
    [sym_identifier] = ACTIONS(3214),
    [anon_sym_LPAREN2] = ACTIONS(3212),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3214),
    [anon_sym_STAR] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3212),
    [anon_sym_SEMI] = ACTIONS(3212),
    [anon_sym___extension__] = ACTIONS(3214),
    [anon_sym_typedef] = ACTIONS(3214),
    [anon_sym_in] = ACTIONS(3214),
    [anon_sym_out] = ACTIONS(3214),
    [anon_sym_inout] = ACTIONS(3214),
    [anon_sym_virtual] = ACTIONS(3214),
    [anon_sym_extern] = ACTIONS(3214),
    [anon_sym___attribute__] = ACTIONS(3214),
    [anon_sym___attribute] = ACTIONS(3214),
    [anon_sym_COLON_COLON] = ACTIONS(3212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3212),
    [anon_sym___declspec] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_signed] = ACTIONS(3214),
    [anon_sym_unsigned] = ACTIONS(3214),
    [anon_sym_long] = ACTIONS(3214),
    [anon_sym_short] = ACTIONS(3214),
    [anon_sym_LBRACK] = ACTIONS(3214),
    [anon_sym_static] = ACTIONS(3214),
    [anon_sym_register] = ACTIONS(3214),
    [anon_sym_inline] = ACTIONS(3214),
    [anon_sym___inline] = ACTIONS(3214),
    [anon_sym___inline__] = ACTIONS(3214),
    [anon_sym___forceinline] = ACTIONS(3214),
    [anon_sym_thread_local] = ACTIONS(3214),
    [anon_sym___thread] = ACTIONS(3214),
    [anon_sym_const] = ACTIONS(3214),
    [anon_sym_constexpr] = ACTIONS(3214),
    [anon_sym_volatile] = ACTIONS(3214),
    [anon_sym_restrict] = ACTIONS(3214),
    [anon_sym___restrict__] = ACTIONS(3214),
    [anon_sym__Atomic] = ACTIONS(3214),
    [anon_sym__Noreturn] = ACTIONS(3214),
    [anon_sym_noreturn] = ACTIONS(3214),
    [anon_sym__Nonnull] = ACTIONS(3214),
    [anon_sym_mutable] = ACTIONS(3214),
    [anon_sym_constinit] = ACTIONS(3214),
    [anon_sym_consteval] = ACTIONS(3214),
    [anon_sym_alignas] = ACTIONS(3214),
    [anon_sym__Alignas] = ACTIONS(3214),
    [sym_primitive_type] = ACTIONS(3214),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3214),
    [anon_sym_struct] = ACTIONS(3214),
    [anon_sym_union] = ACTIONS(3214),
    [anon_sym_if] = ACTIONS(3214),
    [anon_sym_else] = ACTIONS(5325),
    [anon_sym_switch] = ACTIONS(3214),
    [anon_sym_while] = ACTIONS(3214),
    [anon_sym_do] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3214),
    [anon_sym_return] = ACTIONS(3214),
    [anon_sym_break] = ACTIONS(3214),
    [anon_sym_continue] = ACTIONS(3214),
    [anon_sym_goto] = ACTIONS(3214),
    [anon_sym___try] = ACTIONS(3214),
    [anon_sym___leave] = ACTIONS(3214),
    [anon_sym_not] = ACTIONS(3214),
    [anon_sym_compl] = ACTIONS(3214),
    [anon_sym_DASH_DASH] = ACTIONS(3212),
    [anon_sym_PLUS_PLUS] = ACTIONS(3212),
    [anon_sym_sizeof] = ACTIONS(3214),
    [anon_sym___alignof__] = ACTIONS(3214),
    [anon_sym___alignof] = ACTIONS(3214),
    [anon_sym__alignof] = ACTIONS(3214),
    [anon_sym_alignof] = ACTIONS(3214),
    [anon_sym__Alignof] = ACTIONS(3214),
    [anon_sym_offsetof] = ACTIONS(3214),
    [anon_sym__Generic] = ACTIONS(3214),
    [anon_sym_asm] = ACTIONS(3214),
    [anon_sym___asm__] = ACTIONS(3214),
    [anon_sym___asm] = ACTIONS(3214),
    [sym_number_literal] = ACTIONS(3212),
    [anon_sym_L_SQUOTE] = ACTIONS(3212),
    [anon_sym_u_SQUOTE] = ACTIONS(3212),
    [anon_sym_U_SQUOTE] = ACTIONS(3212),
    [anon_sym_u8_SQUOTE] = ACTIONS(3212),
    [anon_sym_SQUOTE] = ACTIONS(3212),
    [anon_sym_L_DQUOTE] = ACTIONS(3212),
    [anon_sym_u_DQUOTE] = ACTIONS(3212),
    [anon_sym_U_DQUOTE] = ACTIONS(3212),
    [anon_sym_u8_DQUOTE] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [sym_true] = ACTIONS(3214),
    [sym_false] = ACTIONS(3214),
    [anon_sym_NULL] = ACTIONS(3214),
    [anon_sym_nullptr] = ACTIONS(3214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3214),
    [anon_sym_let] = ACTIONS(3214),
    [anon_sym_This] = ACTIONS(3214),
    [anon_sym_decltype] = ACTIONS(3214),
    [anon_sym_typename] = ACTIONS(3214),
    [anon_sym_template] = ACTIONS(3214),
    [anon_sym_try] = ACTIONS(3214),
    [anon_sym_delete] = ACTIONS(3214),
    [anon_sym_throw] = ACTIONS(3214),
    [anon_sym_co_return] = ACTIONS(3214),
    [anon_sym_co_yield] = ACTIONS(3214),
    [anon_sym_R_DQUOTE] = ACTIONS(3212),
    [anon_sym_LR_DQUOTE] = ACTIONS(3212),
    [anon_sym_uR_DQUOTE] = ACTIONS(3212),
    [anon_sym_UR_DQUOTE] = ACTIONS(3212),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3212),
    [anon_sym_co_await] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3214),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(3214),
    [anon_sym_discard] = ACTIONS(3214),
    [anon_sym_precise] = ACTIONS(3214),
    [anon_sym_shared] = ACTIONS(3214),
    [anon_sym_groupshared] = ACTIONS(3214),
    [anon_sym_uniform] = ACTIONS(3214),
    [anon_sym_row_major] = ACTIONS(3214),
    [anon_sym_column_major] = ACTIONS(3214),
    [anon_sym_globallycoherent] = ACTIONS(3214),
    [anon_sym_centroid] = ACTIONS(3214),
    [anon_sym_noperspective] = ACTIONS(3214),
    [anon_sym_nointerpolation] = ACTIONS(3214),
    [anon_sym_sample] = ACTIONS(3214),
    [anon_sym_linear] = ACTIONS(3214),
    [anon_sym_snorm] = ACTIONS(3214),
    [anon_sym_unorm] = ACTIONS(3214),
    [anon_sym_point] = ACTIONS(3214),
    [anon_sym_line] = ACTIONS(3214),
    [anon_sym_triangleadj] = ACTIONS(3214),
    [anon_sym_lineadj] = ACTIONS(3214),
    [anon_sym_triangle] = ACTIONS(3214),
    [anon_sym_cbuffer] = ACTIONS(3214),
    [anon_sym_interface] = ACTIONS(3214),
    [anon_sym_extension] = ACTIONS(3214),
  },
  [1350] = {
    [sym_identifier] = ACTIONS(2404),
    [anon_sym_LPAREN2] = ACTIONS(2402),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_TILDE] = ACTIONS(2402),
    [anon_sym_DASH] = ACTIONS(2404),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_STAR] = ACTIONS(2402),
    [anon_sym_AMP] = ACTIONS(2402),
    [anon_sym_SEMI] = ACTIONS(2402),
    [anon_sym___extension__] = ACTIONS(2404),
    [anon_sym_typedef] = ACTIONS(2404),
    [anon_sym_in] = ACTIONS(2404),
    [anon_sym_out] = ACTIONS(2404),
    [anon_sym_inout] = ACTIONS(2404),
    [anon_sym_virtual] = ACTIONS(2404),
    [anon_sym_extern] = ACTIONS(2404),
    [anon_sym___attribute__] = ACTIONS(2404),
    [anon_sym___attribute] = ACTIONS(2404),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2402),
    [anon_sym___declspec] = ACTIONS(2404),
    [anon_sym_LBRACE] = ACTIONS(2402),
    [anon_sym_signed] = ACTIONS(2404),
    [anon_sym_unsigned] = ACTIONS(2404),
    [anon_sym_long] = ACTIONS(2404),
    [anon_sym_short] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_register] = ACTIONS(2404),
    [anon_sym_inline] = ACTIONS(2404),
    [anon_sym___inline] = ACTIONS(2404),
    [anon_sym___inline__] = ACTIONS(2404),
    [anon_sym___forceinline] = ACTIONS(2404),
    [anon_sym_thread_local] = ACTIONS(2404),
    [anon_sym___thread] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [anon_sym_constexpr] = ACTIONS(2404),
    [anon_sym_volatile] = ACTIONS(2404),
    [anon_sym_restrict] = ACTIONS(2404),
    [anon_sym___restrict__] = ACTIONS(2404),
    [anon_sym__Atomic] = ACTIONS(2404),
    [anon_sym__Noreturn] = ACTIONS(2404),
    [anon_sym_noreturn] = ACTIONS(2404),
    [anon_sym__Nonnull] = ACTIONS(2404),
    [anon_sym_mutable] = ACTIONS(2404),
    [anon_sym_constinit] = ACTIONS(2404),
    [anon_sym_consteval] = ACTIONS(2404),
    [anon_sym_alignas] = ACTIONS(2404),
    [anon_sym__Alignas] = ACTIONS(2404),
    [sym_primitive_type] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
    [anon_sym_class] = ACTIONS(2404),
    [anon_sym_struct] = ACTIONS(2404),
    [anon_sym_union] = ACTIONS(2404),
    [anon_sym_if] = ACTIONS(2404),
    [anon_sym_else] = ACTIONS(2404),
    [anon_sym_switch] = ACTIONS(2404),
    [anon_sym_while] = ACTIONS(2404),
    [anon_sym_do] = ACTIONS(2404),
    [anon_sym_for] = ACTIONS(2404),
    [anon_sym_return] = ACTIONS(2404),
    [anon_sym_break] = ACTIONS(2404),
    [anon_sym_continue] = ACTIONS(2404),
    [anon_sym_goto] = ACTIONS(2404),
    [anon_sym___try] = ACTIONS(2404),
    [anon_sym___leave] = ACTIONS(2404),
    [anon_sym_not] = ACTIONS(2404),
    [anon_sym_compl] = ACTIONS(2404),
    [anon_sym_DASH_DASH] = ACTIONS(2402),
    [anon_sym_PLUS_PLUS] = ACTIONS(2402),
    [anon_sym_sizeof] = ACTIONS(2404),
    [anon_sym___alignof__] = ACTIONS(2404),
    [anon_sym___alignof] = ACTIONS(2404),
    [anon_sym__alignof] = ACTIONS(2404),
    [anon_sym_alignof] = ACTIONS(2404),
    [anon_sym__Alignof] = ACTIONS(2404),
    [anon_sym_offsetof] = ACTIONS(2404),
    [anon_sym__Generic] = ACTIONS(2404),
    [anon_sym_asm] = ACTIONS(2404),
    [anon_sym___asm__] = ACTIONS(2404),
    [anon_sym___asm] = ACTIONS(2404),
    [sym_number_literal] = ACTIONS(2402),
    [anon_sym_L_SQUOTE] = ACTIONS(2402),
    [anon_sym_u_SQUOTE] = ACTIONS(2402),
    [anon_sym_U_SQUOTE] = ACTIONS(2402),
    [anon_sym_u8_SQUOTE] = ACTIONS(2402),
    [anon_sym_SQUOTE] = ACTIONS(2402),
    [anon_sym_L_DQUOTE] = ACTIONS(2402),
    [anon_sym_u_DQUOTE] = ACTIONS(2402),
    [anon_sym_U_DQUOTE] = ACTIONS(2402),
    [anon_sym_u8_DQUOTE] = ACTIONS(2402),
    [anon_sym_DQUOTE] = ACTIONS(2402),
    [sym_true] = ACTIONS(2404),
    [sym_false] = ACTIONS(2404),
    [anon_sym_NULL] = ACTIONS(2404),
    [anon_sym_nullptr] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2404),
    [anon_sym_let] = ACTIONS(2404),
    [anon_sym_This] = ACTIONS(2404),
    [anon_sym_decltype] = ACTIONS(2404),
    [anon_sym_typename] = ACTIONS(2404),
    [anon_sym_template] = ACTIONS(2404),
    [anon_sym_try] = ACTIONS(2404),
    [anon_sym_delete] = ACTIONS(2404),
    [anon_sym_throw] = ACTIONS(2404),
    [anon_sym_co_return] = ACTIONS(2404),
    [anon_sym_co_yield] = ACTIONS(2404),
    [anon_sym_catch] = ACTIONS(2404),
    [anon_sym_R_DQUOTE] = ACTIONS(2402),
    [anon_sym_LR_DQUOTE] = ACTIONS(2402),
    [anon_sym_uR_DQUOTE] = ACTIONS(2402),
    [anon_sym_UR_DQUOTE] = ACTIONS(2402),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2402),
    [anon_sym_co_await] = ACTIONS(2404),
    [anon_sym_new] = ACTIONS(2404),
    [anon_sym_requires] = ACTIONS(2404),
    [sym_this] = ACTIONS(2404),
    [anon_sym_discard] = ACTIONS(2404),
    [anon_sym_precise] = ACTIONS(2404),
    [anon_sym_shared] = ACTIONS(2404),
    [anon_sym_groupshared] = ACTIONS(2404),
    [anon_sym_uniform] = ACTIONS(2404),
    [anon_sym_row_major] = ACTIONS(2404),
    [anon_sym_column_major] = ACTIONS(2404),
    [anon_sym_globallycoherent] = ACTIONS(2404),
    [anon_sym_centroid] = ACTIONS(2404),
    [anon_sym_noperspective] = ACTIONS(2404),
    [anon_sym_nointerpolation] = ACTIONS(2404),
    [anon_sym_sample] = ACTIONS(2404),
    [anon_sym_linear] = ACTIONS(2404),
    [anon_sym_snorm] = ACTIONS(2404),
    [anon_sym_unorm] = ACTIONS(2404),
    [anon_sym_point] = ACTIONS(2404),
    [anon_sym_line] = ACTIONS(2404),
    [anon_sym_triangleadj] = ACTIONS(2404),
    [anon_sym_lineadj] = ACTIONS(2404),
    [anon_sym_triangle] = ACTIONS(2404),
    [anon_sym_cbuffer] = ACTIONS(2404),
    [anon_sym_interface] = ACTIONS(2404),
    [anon_sym_extension] = ACTIONS(2404),
  },
  [1351] = {
    [sym_identifier] = ACTIONS(3148),
    [anon_sym_LPAREN2] = ACTIONS(3150),
    [anon_sym_BANG] = ACTIONS(3150),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_DASH] = ACTIONS(3148),
    [anon_sym_PLUS] = ACTIONS(3148),
    [anon_sym_STAR] = ACTIONS(3150),
    [anon_sym_AMP] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym___extension__] = ACTIONS(3148),
    [anon_sym_typedef] = ACTIONS(3148),
    [anon_sym_in] = ACTIONS(3148),
    [anon_sym_out] = ACTIONS(3148),
    [anon_sym_inout] = ACTIONS(3148),
    [anon_sym_virtual] = ACTIONS(3148),
    [anon_sym_extern] = ACTIONS(3148),
    [anon_sym___attribute__] = ACTIONS(3148),
    [anon_sym___attribute] = ACTIONS(3148),
    [anon_sym_COLON_COLON] = ACTIONS(3150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3150),
    [anon_sym___declspec] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3150),
    [anon_sym_signed] = ACTIONS(3148),
    [anon_sym_unsigned] = ACTIONS(3148),
    [anon_sym_long] = ACTIONS(3148),
    [anon_sym_short] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_static] = ACTIONS(3148),
    [anon_sym_register] = ACTIONS(3148),
    [anon_sym_inline] = ACTIONS(3148),
    [anon_sym___inline] = ACTIONS(3148),
    [anon_sym___inline__] = ACTIONS(3148),
    [anon_sym___forceinline] = ACTIONS(3148),
    [anon_sym_thread_local] = ACTIONS(3148),
    [anon_sym___thread] = ACTIONS(3148),
    [anon_sym_const] = ACTIONS(3148),
    [anon_sym_constexpr] = ACTIONS(3148),
    [anon_sym_volatile] = ACTIONS(3148),
    [anon_sym_restrict] = ACTIONS(3148),
    [anon_sym___restrict__] = ACTIONS(3148),
    [anon_sym__Atomic] = ACTIONS(3148),
    [anon_sym__Noreturn] = ACTIONS(3148),
    [anon_sym_noreturn] = ACTIONS(3148),
    [anon_sym__Nonnull] = ACTIONS(3148),
    [anon_sym_mutable] = ACTIONS(3148),
    [anon_sym_constinit] = ACTIONS(3148),
    [anon_sym_consteval] = ACTIONS(3148),
    [anon_sym_alignas] = ACTIONS(3148),
    [anon_sym__Alignas] = ACTIONS(3148),
    [sym_primitive_type] = ACTIONS(3148),
    [anon_sym_enum] = ACTIONS(3148),
    [anon_sym_class] = ACTIONS(3148),
    [anon_sym_struct] = ACTIONS(3148),
    [anon_sym_union] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_switch] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_for] = ACTIONS(3148),
    [anon_sym_return] = ACTIONS(3148),
    [anon_sym_break] = ACTIONS(3148),
    [anon_sym_continue] = ACTIONS(3148),
    [anon_sym_goto] = ACTIONS(3148),
    [anon_sym___try] = ACTIONS(3148),
    [anon_sym___leave] = ACTIONS(3148),
    [anon_sym_not] = ACTIONS(3148),
    [anon_sym_compl] = ACTIONS(3148),
    [anon_sym_DASH_DASH] = ACTIONS(3150),
    [anon_sym_PLUS_PLUS] = ACTIONS(3150),
    [anon_sym_sizeof] = ACTIONS(3148),
    [anon_sym___alignof__] = ACTIONS(3148),
    [anon_sym___alignof] = ACTIONS(3148),
    [anon_sym__alignof] = ACTIONS(3148),
    [anon_sym_alignof] = ACTIONS(3148),
    [anon_sym__Alignof] = ACTIONS(3148),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3148),
    [anon_sym_asm] = ACTIONS(3148),
    [anon_sym___asm__] = ACTIONS(3148),
    [anon_sym___asm] = ACTIONS(3148),
    [sym_number_literal] = ACTIONS(3150),
    [anon_sym_L_SQUOTE] = ACTIONS(3150),
    [anon_sym_u_SQUOTE] = ACTIONS(3150),
    [anon_sym_U_SQUOTE] = ACTIONS(3150),
    [anon_sym_u8_SQUOTE] = ACTIONS(3150),
    [anon_sym_SQUOTE] = ACTIONS(3150),
    [anon_sym_L_DQUOTE] = ACTIONS(3150),
    [anon_sym_u_DQUOTE] = ACTIONS(3150),
    [anon_sym_U_DQUOTE] = ACTIONS(3150),
    [anon_sym_u8_DQUOTE] = ACTIONS(3150),
    [anon_sym_DQUOTE] = ACTIONS(3150),
    [sym_true] = ACTIONS(3148),
    [sym_false] = ACTIONS(3148),
    [anon_sym_NULL] = ACTIONS(3148),
    [anon_sym_nullptr] = ACTIONS(3148),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3148),
    [anon_sym_let] = ACTIONS(3148),
    [anon_sym_This] = ACTIONS(3148),
    [anon_sym_decltype] = ACTIONS(3148),
    [anon_sym_typename] = ACTIONS(3148),
    [anon_sym_template] = ACTIONS(3148),
    [anon_sym_try] = ACTIONS(3148),
    [anon_sym_delete] = ACTIONS(3148),
    [anon_sym_throw] = ACTIONS(3148),
    [anon_sym_co_return] = ACTIONS(3148),
    [anon_sym_co_yield] = ACTIONS(3148),
    [anon_sym_catch] = ACTIONS(3148),
    [anon_sym_R_DQUOTE] = ACTIONS(3150),
    [anon_sym_LR_DQUOTE] = ACTIONS(3150),
    [anon_sym_uR_DQUOTE] = ACTIONS(3150),
    [anon_sym_UR_DQUOTE] = ACTIONS(3150),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3150),
    [anon_sym_co_await] = ACTIONS(3148),
    [anon_sym_new] = ACTIONS(3148),
    [anon_sym_requires] = ACTIONS(3148),
    [sym_this] = ACTIONS(3148),
    [anon_sym_discard] = ACTIONS(3148),
    [anon_sym_precise] = ACTIONS(3148),
    [anon_sym_shared] = ACTIONS(3148),
    [anon_sym_groupshared] = ACTIONS(3148),
    [anon_sym_uniform] = ACTIONS(3148),
    [anon_sym_row_major] = ACTIONS(3148),
    [anon_sym_column_major] = ACTIONS(3148),
    [anon_sym_globallycoherent] = ACTIONS(3148),
    [anon_sym_centroid] = ACTIONS(3148),
    [anon_sym_noperspective] = ACTIONS(3148),
    [anon_sym_nointerpolation] = ACTIONS(3148),
    [anon_sym_sample] = ACTIONS(3148),
    [anon_sym_linear] = ACTIONS(3148),
    [anon_sym_snorm] = ACTIONS(3148),
    [anon_sym_unorm] = ACTIONS(3148),
    [anon_sym_point] = ACTIONS(3148),
    [anon_sym_line] = ACTIONS(3148),
    [anon_sym_triangleadj] = ACTIONS(3148),
    [anon_sym_lineadj] = ACTIONS(3148),
    [anon_sym_triangle] = ACTIONS(3148),
    [anon_sym_cbuffer] = ACTIONS(3148),
    [anon_sym_interface] = ACTIONS(3148),
    [anon_sym_extension] = ACTIONS(3148),
  },
  [1352] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(1605),
    [sym_raw_string_literal] = STATE(3527),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2764),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2172),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(5330),
    [anon_sym_SEMI] = ACTIONS(2183),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2193),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym___cdecl] = ACTIONS(2168),
    [anon_sym___clrcall] = ACTIONS(2168),
    [anon_sym___stdcall] = ACTIONS(2168),
    [anon_sym___fastcall] = ACTIONS(2168),
    [anon_sym___thiscall] = ACTIONS(2168),
    [anon_sym___vectorcall] = ACTIONS(2168),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_RBRACE] = ACTIONS(2170),
    [anon_sym_signed] = ACTIONS(5332),
    [anon_sym_unsigned] = ACTIONS(5332),
    [anon_sym_long] = ACTIONS(5332),
    [anon_sym_short] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2207),
    [anon_sym_SLASH_EQ] = ACTIONS(2207),
    [anon_sym_PERCENT_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_GT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_EQ] = ACTIONS(2207),
    [anon_sym_CARET_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_EQ] = ACTIONS(2207),
    [anon_sym_and_eq] = ACTIONS(2205),
    [anon_sym_or_eq] = ACTIONS(2205),
    [anon_sym_xor_eq] = ACTIONS(2205),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_decltype] = ACTIONS(2168),
    [anon_sym_template] = ACTIONS(2168),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
  },
  [1353] = {
    [sym_else_clause] = STATE(1354),
    [sym_identifier] = ACTIONS(3096),
    [anon_sym_LPAREN2] = ACTIONS(3094),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_TILDE] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3096),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_STAR] = ACTIONS(3094),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3094),
    [anon_sym___extension__] = ACTIONS(3096),
    [anon_sym_typedef] = ACTIONS(3096),
    [anon_sym_in] = ACTIONS(3096),
    [anon_sym_out] = ACTIONS(3096),
    [anon_sym_inout] = ACTIONS(3096),
    [anon_sym_virtual] = ACTIONS(3096),
    [anon_sym_extern] = ACTIONS(3096),
    [anon_sym___attribute__] = ACTIONS(3096),
    [anon_sym___attribute] = ACTIONS(3096),
    [anon_sym_COLON_COLON] = ACTIONS(3094),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3094),
    [anon_sym___declspec] = ACTIONS(3096),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_signed] = ACTIONS(3096),
    [anon_sym_unsigned] = ACTIONS(3096),
    [anon_sym_long] = ACTIONS(3096),
    [anon_sym_short] = ACTIONS(3096),
    [anon_sym_LBRACK] = ACTIONS(3096),
    [anon_sym_static] = ACTIONS(3096),
    [anon_sym_register] = ACTIONS(3096),
    [anon_sym_inline] = ACTIONS(3096),
    [anon_sym___inline] = ACTIONS(3096),
    [anon_sym___inline__] = ACTIONS(3096),
    [anon_sym___forceinline] = ACTIONS(3096),
    [anon_sym_thread_local] = ACTIONS(3096),
    [anon_sym___thread] = ACTIONS(3096),
    [anon_sym_const] = ACTIONS(3096),
    [anon_sym_constexpr] = ACTIONS(3096),
    [anon_sym_volatile] = ACTIONS(3096),
    [anon_sym_restrict] = ACTIONS(3096),
    [anon_sym___restrict__] = ACTIONS(3096),
    [anon_sym__Atomic] = ACTIONS(3096),
    [anon_sym__Noreturn] = ACTIONS(3096),
    [anon_sym_noreturn] = ACTIONS(3096),
    [anon_sym__Nonnull] = ACTIONS(3096),
    [anon_sym_mutable] = ACTIONS(3096),
    [anon_sym_constinit] = ACTIONS(3096),
    [anon_sym_consteval] = ACTIONS(3096),
    [anon_sym_alignas] = ACTIONS(3096),
    [anon_sym__Alignas] = ACTIONS(3096),
    [sym_primitive_type] = ACTIONS(3096),
    [anon_sym_enum] = ACTIONS(3096),
    [anon_sym_class] = ACTIONS(3096),
    [anon_sym_struct] = ACTIONS(3096),
    [anon_sym_union] = ACTIONS(3096),
    [anon_sym_if] = ACTIONS(3096),
    [anon_sym_else] = ACTIONS(5325),
    [anon_sym_switch] = ACTIONS(3096),
    [anon_sym_while] = ACTIONS(3096),
    [anon_sym_do] = ACTIONS(3096),
    [anon_sym_for] = ACTIONS(3096),
    [anon_sym_return] = ACTIONS(3096),
    [anon_sym_break] = ACTIONS(3096),
    [anon_sym_continue] = ACTIONS(3096),
    [anon_sym_goto] = ACTIONS(3096),
    [anon_sym___try] = ACTIONS(3096),
    [anon_sym___leave] = ACTIONS(3096),
    [anon_sym_not] = ACTIONS(3096),
    [anon_sym_compl] = ACTIONS(3096),
    [anon_sym_DASH_DASH] = ACTIONS(3094),
    [anon_sym_PLUS_PLUS] = ACTIONS(3094),
    [anon_sym_sizeof] = ACTIONS(3096),
    [anon_sym___alignof__] = ACTIONS(3096),
    [anon_sym___alignof] = ACTIONS(3096),
    [anon_sym__alignof] = ACTIONS(3096),
    [anon_sym_alignof] = ACTIONS(3096),
    [anon_sym__Alignof] = ACTIONS(3096),
    [anon_sym_offsetof] = ACTIONS(3096),
    [anon_sym__Generic] = ACTIONS(3096),
    [anon_sym_asm] = ACTIONS(3096),
    [anon_sym___asm__] = ACTIONS(3096),
    [anon_sym___asm] = ACTIONS(3096),
    [sym_number_literal] = ACTIONS(3094),
    [anon_sym_L_SQUOTE] = ACTIONS(3094),
    [anon_sym_u_SQUOTE] = ACTIONS(3094),
    [anon_sym_U_SQUOTE] = ACTIONS(3094),
    [anon_sym_u8_SQUOTE] = ACTIONS(3094),
    [anon_sym_SQUOTE] = ACTIONS(3094),
    [anon_sym_L_DQUOTE] = ACTIONS(3094),
    [anon_sym_u_DQUOTE] = ACTIONS(3094),
    [anon_sym_U_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8_DQUOTE] = ACTIONS(3094),
    [anon_sym_DQUOTE] = ACTIONS(3094),
    [sym_true] = ACTIONS(3096),
    [sym_false] = ACTIONS(3096),
    [anon_sym_NULL] = ACTIONS(3096),
    [anon_sym_nullptr] = ACTIONS(3096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3096),
    [anon_sym_let] = ACTIONS(3096),
    [anon_sym_This] = ACTIONS(3096),
    [anon_sym_decltype] = ACTIONS(3096),
    [anon_sym_typename] = ACTIONS(3096),
    [anon_sym_template] = ACTIONS(3096),
    [anon_sym_try] = ACTIONS(3096),
    [anon_sym_delete] = ACTIONS(3096),
    [anon_sym_throw] = ACTIONS(3096),
    [anon_sym_co_return] = ACTIONS(3096),
    [anon_sym_co_yield] = ACTIONS(3096),
    [anon_sym_R_DQUOTE] = ACTIONS(3094),
    [anon_sym_LR_DQUOTE] = ACTIONS(3094),
    [anon_sym_uR_DQUOTE] = ACTIONS(3094),
    [anon_sym_UR_DQUOTE] = ACTIONS(3094),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3094),
    [anon_sym_co_await] = ACTIONS(3096),
    [anon_sym_new] = ACTIONS(3096),
    [anon_sym_requires] = ACTIONS(3096),
    [sym_this] = ACTIONS(3096),
    [anon_sym_discard] = ACTIONS(3096),
    [anon_sym_precise] = ACTIONS(3096),
    [anon_sym_shared] = ACTIONS(3096),
    [anon_sym_groupshared] = ACTIONS(3096),
    [anon_sym_uniform] = ACTIONS(3096),
    [anon_sym_row_major] = ACTIONS(3096),
    [anon_sym_column_major] = ACTIONS(3096),
    [anon_sym_globallycoherent] = ACTIONS(3096),
    [anon_sym_centroid] = ACTIONS(3096),
    [anon_sym_noperspective] = ACTIONS(3096),
    [anon_sym_nointerpolation] = ACTIONS(3096),
    [anon_sym_sample] = ACTIONS(3096),
    [anon_sym_linear] = ACTIONS(3096),
    [anon_sym_snorm] = ACTIONS(3096),
    [anon_sym_unorm] = ACTIONS(3096),
    [anon_sym_point] = ACTIONS(3096),
    [anon_sym_line] = ACTIONS(3096),
    [anon_sym_triangleadj] = ACTIONS(3096),
    [anon_sym_lineadj] = ACTIONS(3096),
    [anon_sym_triangle] = ACTIONS(3096),
    [anon_sym_cbuffer] = ACTIONS(3096),
    [anon_sym_interface] = ACTIONS(3096),
    [anon_sym_extension] = ACTIONS(3096),
  },
  [1354] = {
    [sym_identifier] = ACTIONS(3403),
    [anon_sym_LPAREN2] = ACTIONS(3405),
    [anon_sym_BANG] = ACTIONS(3405),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_DASH] = ACTIONS(3403),
    [anon_sym_PLUS] = ACTIONS(3403),
    [anon_sym_STAR] = ACTIONS(3405),
    [anon_sym_AMP] = ACTIONS(3405),
    [anon_sym_SEMI] = ACTIONS(3405),
    [anon_sym___extension__] = ACTIONS(3403),
    [anon_sym_typedef] = ACTIONS(3403),
    [anon_sym_in] = ACTIONS(3403),
    [anon_sym_out] = ACTIONS(3403),
    [anon_sym_inout] = ACTIONS(3403),
    [anon_sym_virtual] = ACTIONS(3403),
    [anon_sym_extern] = ACTIONS(3403),
    [anon_sym___attribute__] = ACTIONS(3403),
    [anon_sym___attribute] = ACTIONS(3403),
    [anon_sym_COLON_COLON] = ACTIONS(3405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3405),
    [anon_sym___declspec] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3405),
    [anon_sym_signed] = ACTIONS(3403),
    [anon_sym_unsigned] = ACTIONS(3403),
    [anon_sym_long] = ACTIONS(3403),
    [anon_sym_short] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3403),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_register] = ACTIONS(3403),
    [anon_sym_inline] = ACTIONS(3403),
    [anon_sym___inline] = ACTIONS(3403),
    [anon_sym___inline__] = ACTIONS(3403),
    [anon_sym___forceinline] = ACTIONS(3403),
    [anon_sym_thread_local] = ACTIONS(3403),
    [anon_sym___thread] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_constexpr] = ACTIONS(3403),
    [anon_sym_volatile] = ACTIONS(3403),
    [anon_sym_restrict] = ACTIONS(3403),
    [anon_sym___restrict__] = ACTIONS(3403),
    [anon_sym__Atomic] = ACTIONS(3403),
    [anon_sym__Noreturn] = ACTIONS(3403),
    [anon_sym_noreturn] = ACTIONS(3403),
    [anon_sym__Nonnull] = ACTIONS(3403),
    [anon_sym_mutable] = ACTIONS(3403),
    [anon_sym_constinit] = ACTIONS(3403),
    [anon_sym_consteval] = ACTIONS(3403),
    [anon_sym_alignas] = ACTIONS(3403),
    [anon_sym__Alignas] = ACTIONS(3403),
    [sym_primitive_type] = ACTIONS(3403),
    [anon_sym_enum] = ACTIONS(3403),
    [anon_sym_class] = ACTIONS(3403),
    [anon_sym_struct] = ACTIONS(3403),
    [anon_sym_union] = ACTIONS(3403),
    [anon_sym_if] = ACTIONS(3403),
    [anon_sym_else] = ACTIONS(3403),
    [anon_sym_switch] = ACTIONS(3403),
    [anon_sym_while] = ACTIONS(3403),
    [anon_sym_do] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3403),
    [anon_sym_return] = ACTIONS(3403),
    [anon_sym_break] = ACTIONS(3403),
    [anon_sym_continue] = ACTIONS(3403),
    [anon_sym_goto] = ACTIONS(3403),
    [anon_sym___try] = ACTIONS(3403),
    [anon_sym___leave] = ACTIONS(3403),
    [anon_sym_not] = ACTIONS(3403),
    [anon_sym_compl] = ACTIONS(3403),
    [anon_sym_DASH_DASH] = ACTIONS(3405),
    [anon_sym_PLUS_PLUS] = ACTIONS(3405),
    [anon_sym_sizeof] = ACTIONS(3403),
    [anon_sym___alignof__] = ACTIONS(3403),
    [anon_sym___alignof] = ACTIONS(3403),
    [anon_sym__alignof] = ACTIONS(3403),
    [anon_sym_alignof] = ACTIONS(3403),
    [anon_sym__Alignof] = ACTIONS(3403),
    [anon_sym_offsetof] = ACTIONS(3403),
    [anon_sym__Generic] = ACTIONS(3403),
    [anon_sym_asm] = ACTIONS(3403),
    [anon_sym___asm__] = ACTIONS(3403),
    [anon_sym___asm] = ACTIONS(3403),
    [sym_number_literal] = ACTIONS(3405),
    [anon_sym_L_SQUOTE] = ACTIONS(3405),
    [anon_sym_u_SQUOTE] = ACTIONS(3405),
    [anon_sym_U_SQUOTE] = ACTIONS(3405),
    [anon_sym_u8_SQUOTE] = ACTIONS(3405),
    [anon_sym_SQUOTE] = ACTIONS(3405),
    [anon_sym_L_DQUOTE] = ACTIONS(3405),
    [anon_sym_u_DQUOTE] = ACTIONS(3405),
    [anon_sym_U_DQUOTE] = ACTIONS(3405),
    [anon_sym_u8_DQUOTE] = ACTIONS(3405),
    [anon_sym_DQUOTE] = ACTIONS(3405),
    [sym_true] = ACTIONS(3403),
    [sym_false] = ACTIONS(3403),
    [anon_sym_NULL] = ACTIONS(3403),
    [anon_sym_nullptr] = ACTIONS(3403),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3403),
    [anon_sym_let] = ACTIONS(3403),
    [anon_sym_This] = ACTIONS(3403),
    [anon_sym_decltype] = ACTIONS(3403),
    [anon_sym_typename] = ACTIONS(3403),
    [anon_sym_template] = ACTIONS(3403),
    [anon_sym_try] = ACTIONS(3403),
    [anon_sym_delete] = ACTIONS(3403),
    [anon_sym_throw] = ACTIONS(3403),
    [anon_sym_co_return] = ACTIONS(3403),
    [anon_sym_co_yield] = ACTIONS(3403),
    [anon_sym_R_DQUOTE] = ACTIONS(3405),
    [anon_sym_LR_DQUOTE] = ACTIONS(3405),
    [anon_sym_uR_DQUOTE] = ACTIONS(3405),
    [anon_sym_UR_DQUOTE] = ACTIONS(3405),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3405),
    [anon_sym_co_await] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3403),
    [anon_sym_requires] = ACTIONS(3403),
    [sym_this] = ACTIONS(3403),
    [anon_sym_discard] = ACTIONS(3403),
    [anon_sym_precise] = ACTIONS(3403),
    [anon_sym_shared] = ACTIONS(3403),
    [anon_sym_groupshared] = ACTIONS(3403),
    [anon_sym_uniform] = ACTIONS(3403),
    [anon_sym_row_major] = ACTIONS(3403),
    [anon_sym_column_major] = ACTIONS(3403),
    [anon_sym_globallycoherent] = ACTIONS(3403),
    [anon_sym_centroid] = ACTIONS(3403),
    [anon_sym_noperspective] = ACTIONS(3403),
    [anon_sym_nointerpolation] = ACTIONS(3403),
    [anon_sym_sample] = ACTIONS(3403),
    [anon_sym_linear] = ACTIONS(3403),
    [anon_sym_snorm] = ACTIONS(3403),
    [anon_sym_unorm] = ACTIONS(3403),
    [anon_sym_point] = ACTIONS(3403),
    [anon_sym_line] = ACTIONS(3403),
    [anon_sym_triangleadj] = ACTIONS(3403),
    [anon_sym_lineadj] = ACTIONS(3403),
    [anon_sym_triangle] = ACTIONS(3403),
    [anon_sym_cbuffer] = ACTIONS(3403),
    [anon_sym_interface] = ACTIONS(3403),
    [anon_sym_extension] = ACTIONS(3403),
  },
  [1355] = {
    [sym_identifier] = ACTIONS(3466),
    [anon_sym_LPAREN2] = ACTIONS(3468),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3466),
    [anon_sym_PLUS] = ACTIONS(3466),
    [anon_sym_STAR] = ACTIONS(3468),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_SEMI] = ACTIONS(3468),
    [anon_sym___extension__] = ACTIONS(3466),
    [anon_sym_typedef] = ACTIONS(3466),
    [anon_sym_in] = ACTIONS(3466),
    [anon_sym_out] = ACTIONS(3466),
    [anon_sym_inout] = ACTIONS(3466),
    [anon_sym_virtual] = ACTIONS(3466),
    [anon_sym_extern] = ACTIONS(3466),
    [anon_sym___attribute__] = ACTIONS(3466),
    [anon_sym___attribute] = ACTIONS(3466),
    [anon_sym_COLON_COLON] = ACTIONS(3468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3468),
    [anon_sym___declspec] = ACTIONS(3466),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_signed] = ACTIONS(3466),
    [anon_sym_unsigned] = ACTIONS(3466),
    [anon_sym_long] = ACTIONS(3466),
    [anon_sym_short] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(3466),
    [anon_sym_static] = ACTIONS(3466),
    [anon_sym_register] = ACTIONS(3466),
    [anon_sym_inline] = ACTIONS(3466),
    [anon_sym___inline] = ACTIONS(3466),
    [anon_sym___inline__] = ACTIONS(3466),
    [anon_sym___forceinline] = ACTIONS(3466),
    [anon_sym_thread_local] = ACTIONS(3466),
    [anon_sym___thread] = ACTIONS(3466),
    [anon_sym_const] = ACTIONS(3466),
    [anon_sym_constexpr] = ACTIONS(3466),
    [anon_sym_volatile] = ACTIONS(3466),
    [anon_sym_restrict] = ACTIONS(3466),
    [anon_sym___restrict__] = ACTIONS(3466),
    [anon_sym__Atomic] = ACTIONS(3466),
    [anon_sym__Noreturn] = ACTIONS(3466),
    [anon_sym_noreturn] = ACTIONS(3466),
    [anon_sym__Nonnull] = ACTIONS(3466),
    [anon_sym_mutable] = ACTIONS(3466),
    [anon_sym_constinit] = ACTIONS(3466),
    [anon_sym_consteval] = ACTIONS(3466),
    [anon_sym_alignas] = ACTIONS(3466),
    [anon_sym__Alignas] = ACTIONS(3466),
    [sym_primitive_type] = ACTIONS(3466),
    [anon_sym_enum] = ACTIONS(3466),
    [anon_sym_class] = ACTIONS(3466),
    [anon_sym_struct] = ACTIONS(3466),
    [anon_sym_union] = ACTIONS(3466),
    [anon_sym_if] = ACTIONS(3466),
    [anon_sym_else] = ACTIONS(3466),
    [anon_sym_switch] = ACTIONS(3466),
    [anon_sym_while] = ACTIONS(3466),
    [anon_sym_do] = ACTIONS(3466),
    [anon_sym_for] = ACTIONS(3466),
    [anon_sym_return] = ACTIONS(3466),
    [anon_sym_break] = ACTIONS(3466),
    [anon_sym_continue] = ACTIONS(3466),
    [anon_sym_goto] = ACTIONS(3466),
    [anon_sym___try] = ACTIONS(3466),
    [anon_sym___leave] = ACTIONS(3466),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_compl] = ACTIONS(3466),
    [anon_sym_DASH_DASH] = ACTIONS(3468),
    [anon_sym_PLUS_PLUS] = ACTIONS(3468),
    [anon_sym_sizeof] = ACTIONS(3466),
    [anon_sym___alignof__] = ACTIONS(3466),
    [anon_sym___alignof] = ACTIONS(3466),
    [anon_sym__alignof] = ACTIONS(3466),
    [anon_sym_alignof] = ACTIONS(3466),
    [anon_sym__Alignof] = ACTIONS(3466),
    [anon_sym_offsetof] = ACTIONS(3466),
    [anon_sym__Generic] = ACTIONS(3466),
    [anon_sym_asm] = ACTIONS(3466),
    [anon_sym___asm__] = ACTIONS(3466),
    [anon_sym___asm] = ACTIONS(3466),
    [sym_number_literal] = ACTIONS(3468),
    [anon_sym_L_SQUOTE] = ACTIONS(3468),
    [anon_sym_u_SQUOTE] = ACTIONS(3468),
    [anon_sym_U_SQUOTE] = ACTIONS(3468),
    [anon_sym_u8_SQUOTE] = ACTIONS(3468),
    [anon_sym_SQUOTE] = ACTIONS(3468),
    [anon_sym_L_DQUOTE] = ACTIONS(3468),
    [anon_sym_u_DQUOTE] = ACTIONS(3468),
    [anon_sym_U_DQUOTE] = ACTIONS(3468),
    [anon_sym_u8_DQUOTE] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(3468),
    [sym_true] = ACTIONS(3466),
    [sym_false] = ACTIONS(3466),
    [anon_sym_NULL] = ACTIONS(3466),
    [anon_sym_nullptr] = ACTIONS(3466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3466),
    [anon_sym_let] = ACTIONS(3466),
    [anon_sym_This] = ACTIONS(3466),
    [anon_sym_decltype] = ACTIONS(3466),
    [anon_sym_typename] = ACTIONS(3466),
    [anon_sym_template] = ACTIONS(3466),
    [anon_sym_try] = ACTIONS(3466),
    [anon_sym_delete] = ACTIONS(3466),
    [anon_sym_throw] = ACTIONS(3466),
    [anon_sym_co_return] = ACTIONS(3466),
    [anon_sym_co_yield] = ACTIONS(3466),
    [anon_sym_R_DQUOTE] = ACTIONS(3468),
    [anon_sym_LR_DQUOTE] = ACTIONS(3468),
    [anon_sym_uR_DQUOTE] = ACTIONS(3468),
    [anon_sym_UR_DQUOTE] = ACTIONS(3468),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3468),
    [anon_sym_co_await] = ACTIONS(3466),
    [anon_sym_new] = ACTIONS(3466),
    [anon_sym_requires] = ACTIONS(3466),
    [sym_this] = ACTIONS(3466),
    [anon_sym_discard] = ACTIONS(3466),
    [anon_sym_precise] = ACTIONS(3466),
    [anon_sym_shared] = ACTIONS(3466),
    [anon_sym_groupshared] = ACTIONS(3466),
    [anon_sym_uniform] = ACTIONS(3466),
    [anon_sym_row_major] = ACTIONS(3466),
    [anon_sym_column_major] = ACTIONS(3466),
    [anon_sym_globallycoherent] = ACTIONS(3466),
    [anon_sym_centroid] = ACTIONS(3466),
    [anon_sym_noperspective] = ACTIONS(3466),
    [anon_sym_nointerpolation] = ACTIONS(3466),
    [anon_sym_sample] = ACTIONS(3466),
    [anon_sym_linear] = ACTIONS(3466),
    [anon_sym_snorm] = ACTIONS(3466),
    [anon_sym_unorm] = ACTIONS(3466),
    [anon_sym_point] = ACTIONS(3466),
    [anon_sym_line] = ACTIONS(3466),
    [anon_sym_triangleadj] = ACTIONS(3466),
    [anon_sym_lineadj] = ACTIONS(3466),
    [anon_sym_triangle] = ACTIONS(3466),
    [anon_sym_cbuffer] = ACTIONS(3466),
    [anon_sym_interface] = ACTIONS(3466),
    [anon_sym_extension] = ACTIONS(3466),
  },
  [1356] = {
    [sym_identifier] = ACTIONS(3470),
    [anon_sym_LPAREN2] = ACTIONS(3472),
    [anon_sym_BANG] = ACTIONS(3472),
    [anon_sym_TILDE] = ACTIONS(3472),
    [anon_sym_DASH] = ACTIONS(3470),
    [anon_sym_PLUS] = ACTIONS(3470),
    [anon_sym_STAR] = ACTIONS(3472),
    [anon_sym_AMP] = ACTIONS(3472),
    [anon_sym_SEMI] = ACTIONS(3472),
    [anon_sym___extension__] = ACTIONS(3470),
    [anon_sym_typedef] = ACTIONS(3470),
    [anon_sym_in] = ACTIONS(3470),
    [anon_sym_out] = ACTIONS(3470),
    [anon_sym_inout] = ACTIONS(3470),
    [anon_sym_virtual] = ACTIONS(3470),
    [anon_sym_extern] = ACTIONS(3470),
    [anon_sym___attribute__] = ACTIONS(3470),
    [anon_sym___attribute] = ACTIONS(3470),
    [anon_sym_COLON_COLON] = ACTIONS(3472),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3472),
    [anon_sym___declspec] = ACTIONS(3470),
    [anon_sym_LBRACE] = ACTIONS(3472),
    [anon_sym_signed] = ACTIONS(3470),
    [anon_sym_unsigned] = ACTIONS(3470),
    [anon_sym_long] = ACTIONS(3470),
    [anon_sym_short] = ACTIONS(3470),
    [anon_sym_LBRACK] = ACTIONS(3470),
    [anon_sym_static] = ACTIONS(3470),
    [anon_sym_register] = ACTIONS(3470),
    [anon_sym_inline] = ACTIONS(3470),
    [anon_sym___inline] = ACTIONS(3470),
    [anon_sym___inline__] = ACTIONS(3470),
    [anon_sym___forceinline] = ACTIONS(3470),
    [anon_sym_thread_local] = ACTIONS(3470),
    [anon_sym___thread] = ACTIONS(3470),
    [anon_sym_const] = ACTIONS(3470),
    [anon_sym_constexpr] = ACTIONS(3470),
    [anon_sym_volatile] = ACTIONS(3470),
    [anon_sym_restrict] = ACTIONS(3470),
    [anon_sym___restrict__] = ACTIONS(3470),
    [anon_sym__Atomic] = ACTIONS(3470),
    [anon_sym__Noreturn] = ACTIONS(3470),
    [anon_sym_noreturn] = ACTIONS(3470),
    [anon_sym__Nonnull] = ACTIONS(3470),
    [anon_sym_mutable] = ACTIONS(3470),
    [anon_sym_constinit] = ACTIONS(3470),
    [anon_sym_consteval] = ACTIONS(3470),
    [anon_sym_alignas] = ACTIONS(3470),
    [anon_sym__Alignas] = ACTIONS(3470),
    [sym_primitive_type] = ACTIONS(3470),
    [anon_sym_enum] = ACTIONS(3470),
    [anon_sym_class] = ACTIONS(3470),
    [anon_sym_struct] = ACTIONS(3470),
    [anon_sym_union] = ACTIONS(3470),
    [anon_sym_if] = ACTIONS(3470),
    [anon_sym_else] = ACTIONS(3470),
    [anon_sym_switch] = ACTIONS(3470),
    [anon_sym_while] = ACTIONS(3470),
    [anon_sym_do] = ACTIONS(3470),
    [anon_sym_for] = ACTIONS(3470),
    [anon_sym_return] = ACTIONS(3470),
    [anon_sym_break] = ACTIONS(3470),
    [anon_sym_continue] = ACTIONS(3470),
    [anon_sym_goto] = ACTIONS(3470),
    [anon_sym___try] = ACTIONS(3470),
    [anon_sym___leave] = ACTIONS(3470),
    [anon_sym_not] = ACTIONS(3470),
    [anon_sym_compl] = ACTIONS(3470),
    [anon_sym_DASH_DASH] = ACTIONS(3472),
    [anon_sym_PLUS_PLUS] = ACTIONS(3472),
    [anon_sym_sizeof] = ACTIONS(3470),
    [anon_sym___alignof__] = ACTIONS(3470),
    [anon_sym___alignof] = ACTIONS(3470),
    [anon_sym__alignof] = ACTIONS(3470),
    [anon_sym_alignof] = ACTIONS(3470),
    [anon_sym__Alignof] = ACTIONS(3470),
    [anon_sym_offsetof] = ACTIONS(3470),
    [anon_sym__Generic] = ACTIONS(3470),
    [anon_sym_asm] = ACTIONS(3470),
    [anon_sym___asm__] = ACTIONS(3470),
    [anon_sym___asm] = ACTIONS(3470),
    [sym_number_literal] = ACTIONS(3472),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3472),
    [anon_sym_u_DQUOTE] = ACTIONS(3472),
    [anon_sym_U_DQUOTE] = ACTIONS(3472),
    [anon_sym_u8_DQUOTE] = ACTIONS(3472),
    [anon_sym_DQUOTE] = ACTIONS(3472),
    [sym_true] = ACTIONS(3470),
    [sym_false] = ACTIONS(3470),
    [anon_sym_NULL] = ACTIONS(3470),
    [anon_sym_nullptr] = ACTIONS(3470),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3470),
    [anon_sym_let] = ACTIONS(3470),
    [anon_sym_This] = ACTIONS(3470),
    [anon_sym_decltype] = ACTIONS(3470),
    [anon_sym_typename] = ACTIONS(3470),
    [anon_sym_template] = ACTIONS(3470),
    [anon_sym_try] = ACTIONS(3470),
    [anon_sym_delete] = ACTIONS(3470),
    [anon_sym_throw] = ACTIONS(3470),
    [anon_sym_co_return] = ACTIONS(3470),
    [anon_sym_co_yield] = ACTIONS(3470),
    [anon_sym_R_DQUOTE] = ACTIONS(3472),
    [anon_sym_LR_DQUOTE] = ACTIONS(3472),
    [anon_sym_uR_DQUOTE] = ACTIONS(3472),
    [anon_sym_UR_DQUOTE] = ACTIONS(3472),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3472),
    [anon_sym_co_await] = ACTIONS(3470),
    [anon_sym_new] = ACTIONS(3470),
    [anon_sym_requires] = ACTIONS(3470),
    [sym_this] = ACTIONS(3470),
    [anon_sym_discard] = ACTIONS(3470),
    [anon_sym_precise] = ACTIONS(3470),
    [anon_sym_shared] = ACTIONS(3470),
    [anon_sym_groupshared] = ACTIONS(3470),
    [anon_sym_uniform] = ACTIONS(3470),
    [anon_sym_row_major] = ACTIONS(3470),
    [anon_sym_column_major] = ACTIONS(3470),
    [anon_sym_globallycoherent] = ACTIONS(3470),
    [anon_sym_centroid] = ACTIONS(3470),
    [anon_sym_noperspective] = ACTIONS(3470),
    [anon_sym_nointerpolation] = ACTIONS(3470),
    [anon_sym_sample] = ACTIONS(3470),
    [anon_sym_linear] = ACTIONS(3470),
    [anon_sym_snorm] = ACTIONS(3470),
    [anon_sym_unorm] = ACTIONS(3470),
    [anon_sym_point] = ACTIONS(3470),
    [anon_sym_line] = ACTIONS(3470),
    [anon_sym_triangleadj] = ACTIONS(3470),
    [anon_sym_lineadj] = ACTIONS(3470),
    [anon_sym_triangle] = ACTIONS(3470),
    [anon_sym_cbuffer] = ACTIONS(3470),
    [anon_sym_interface] = ACTIONS(3470),
    [anon_sym_extension] = ACTIONS(3470),
  },
  [1357] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(1605),
    [sym_raw_string_literal] = STATE(3527),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2764),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2172),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(2216),
    [anon_sym_SEMI] = ACTIONS(2183),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2193),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym___cdecl] = ACTIONS(2168),
    [anon_sym___clrcall] = ACTIONS(2168),
    [anon_sym___stdcall] = ACTIONS(2168),
    [anon_sym___fastcall] = ACTIONS(2168),
    [anon_sym___thiscall] = ACTIONS(2168),
    [anon_sym___vectorcall] = ACTIONS(2168),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_signed] = ACTIONS(5332),
    [anon_sym_unsigned] = ACTIONS(5332),
    [anon_sym_long] = ACTIONS(5332),
    [anon_sym_short] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2207),
    [anon_sym_SLASH_EQ] = ACTIONS(2207),
    [anon_sym_PERCENT_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_GT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_EQ] = ACTIONS(2207),
    [anon_sym_CARET_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_EQ] = ACTIONS(2207),
    [anon_sym_and_eq] = ACTIONS(2205),
    [anon_sym_or_eq] = ACTIONS(2205),
    [anon_sym_xor_eq] = ACTIONS(2205),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_decltype] = ACTIONS(2168),
    [anon_sym_template] = ACTIONS(2168),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
  },
  [1358] = {
    [sym_identifier] = ACTIONS(3421),
    [anon_sym_LPAREN2] = ACTIONS(3419),
    [anon_sym_BANG] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_SEMI] = ACTIONS(3419),
    [anon_sym___extension__] = ACTIONS(3421),
    [anon_sym_typedef] = ACTIONS(3421),
    [anon_sym_in] = ACTIONS(3421),
    [anon_sym_out] = ACTIONS(3421),
    [anon_sym_inout] = ACTIONS(3421),
    [anon_sym_virtual] = ACTIONS(3421),
    [anon_sym_extern] = ACTIONS(3421),
    [anon_sym___attribute__] = ACTIONS(3421),
    [anon_sym___attribute] = ACTIONS(3421),
    [anon_sym_COLON_COLON] = ACTIONS(3419),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3419),
    [anon_sym___declspec] = ACTIONS(3421),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_signed] = ACTIONS(3421),
    [anon_sym_unsigned] = ACTIONS(3421),
    [anon_sym_long] = ACTIONS(3421),
    [anon_sym_short] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3421),
    [anon_sym_static] = ACTIONS(3421),
    [anon_sym_register] = ACTIONS(3421),
    [anon_sym_inline] = ACTIONS(3421),
    [anon_sym___inline] = ACTIONS(3421),
    [anon_sym___inline__] = ACTIONS(3421),
    [anon_sym___forceinline] = ACTIONS(3421),
    [anon_sym_thread_local] = ACTIONS(3421),
    [anon_sym___thread] = ACTIONS(3421),
    [anon_sym_const] = ACTIONS(3421),
    [anon_sym_constexpr] = ACTIONS(3421),
    [anon_sym_volatile] = ACTIONS(3421),
    [anon_sym_restrict] = ACTIONS(3421),
    [anon_sym___restrict__] = ACTIONS(3421),
    [anon_sym__Atomic] = ACTIONS(3421),
    [anon_sym__Noreturn] = ACTIONS(3421),
    [anon_sym_noreturn] = ACTIONS(3421),
    [anon_sym__Nonnull] = ACTIONS(3421),
    [anon_sym_mutable] = ACTIONS(3421),
    [anon_sym_constinit] = ACTIONS(3421),
    [anon_sym_consteval] = ACTIONS(3421),
    [anon_sym_alignas] = ACTIONS(3421),
    [anon_sym__Alignas] = ACTIONS(3421),
    [sym_primitive_type] = ACTIONS(3421),
    [anon_sym_enum] = ACTIONS(3421),
    [anon_sym_class] = ACTIONS(3421),
    [anon_sym_struct] = ACTIONS(3421),
    [anon_sym_union] = ACTIONS(3421),
    [anon_sym_if] = ACTIONS(3421),
    [anon_sym_else] = ACTIONS(3421),
    [anon_sym_switch] = ACTIONS(3421),
    [anon_sym_while] = ACTIONS(3421),
    [anon_sym_do] = ACTIONS(3421),
    [anon_sym_for] = ACTIONS(3421),
    [anon_sym_return] = ACTIONS(3421),
    [anon_sym_break] = ACTIONS(3421),
    [anon_sym_continue] = ACTIONS(3421),
    [anon_sym_goto] = ACTIONS(3421),
    [anon_sym___try] = ACTIONS(3421),
    [anon_sym___leave] = ACTIONS(3421),
    [anon_sym_not] = ACTIONS(3421),
    [anon_sym_compl] = ACTIONS(3421),
    [anon_sym_DASH_DASH] = ACTIONS(3419),
    [anon_sym_PLUS_PLUS] = ACTIONS(3419),
    [anon_sym_sizeof] = ACTIONS(3421),
    [anon_sym___alignof__] = ACTIONS(3421),
    [anon_sym___alignof] = ACTIONS(3421),
    [anon_sym__alignof] = ACTIONS(3421),
    [anon_sym_alignof] = ACTIONS(3421),
    [anon_sym__Alignof] = ACTIONS(3421),
    [anon_sym_offsetof] = ACTIONS(3421),
    [anon_sym__Generic] = ACTIONS(3421),
    [anon_sym_asm] = ACTIONS(3421),
    [anon_sym___asm__] = ACTIONS(3421),
    [anon_sym___asm] = ACTIONS(3421),
    [sym_number_literal] = ACTIONS(3419),
    [anon_sym_L_SQUOTE] = ACTIONS(3419),
    [anon_sym_u_SQUOTE] = ACTIONS(3419),
    [anon_sym_U_SQUOTE] = ACTIONS(3419),
    [anon_sym_u8_SQUOTE] = ACTIONS(3419),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym_L_DQUOTE] = ACTIONS(3419),
    [anon_sym_u_DQUOTE] = ACTIONS(3419),
    [anon_sym_U_DQUOTE] = ACTIONS(3419),
    [anon_sym_u8_DQUOTE] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [sym_true] = ACTIONS(3421),
    [sym_false] = ACTIONS(3421),
    [anon_sym_NULL] = ACTIONS(3421),
    [anon_sym_nullptr] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3421),
    [anon_sym_let] = ACTIONS(3421),
    [anon_sym_This] = ACTIONS(3421),
    [anon_sym_decltype] = ACTIONS(3421),
    [anon_sym_typename] = ACTIONS(3421),
    [anon_sym_template] = ACTIONS(3421),
    [anon_sym_try] = ACTIONS(3421),
    [anon_sym_delete] = ACTIONS(3421),
    [anon_sym_throw] = ACTIONS(3421),
    [anon_sym_co_return] = ACTIONS(3421),
    [anon_sym_co_yield] = ACTIONS(3421),
    [anon_sym_R_DQUOTE] = ACTIONS(3419),
    [anon_sym_LR_DQUOTE] = ACTIONS(3419),
    [anon_sym_uR_DQUOTE] = ACTIONS(3419),
    [anon_sym_UR_DQUOTE] = ACTIONS(3419),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3419),
    [anon_sym_co_await] = ACTIONS(3421),
    [anon_sym_new] = ACTIONS(3421),
    [anon_sym_requires] = ACTIONS(3421),
    [sym_this] = ACTIONS(3421),
    [anon_sym_discard] = ACTIONS(3421),
    [anon_sym_precise] = ACTIONS(3421),
    [anon_sym_shared] = ACTIONS(3421),
    [anon_sym_groupshared] = ACTIONS(3421),
    [anon_sym_uniform] = ACTIONS(3421),
    [anon_sym_row_major] = ACTIONS(3421),
    [anon_sym_column_major] = ACTIONS(3421),
    [anon_sym_globallycoherent] = ACTIONS(3421),
    [anon_sym_centroid] = ACTIONS(3421),
    [anon_sym_noperspective] = ACTIONS(3421),
    [anon_sym_nointerpolation] = ACTIONS(3421),
    [anon_sym_sample] = ACTIONS(3421),
    [anon_sym_linear] = ACTIONS(3421),
    [anon_sym_snorm] = ACTIONS(3421),
    [anon_sym_unorm] = ACTIONS(3421),
    [anon_sym_point] = ACTIONS(3421),
    [anon_sym_line] = ACTIONS(3421),
    [anon_sym_triangleadj] = ACTIONS(3421),
    [anon_sym_lineadj] = ACTIONS(3421),
    [anon_sym_triangle] = ACTIONS(3421),
    [anon_sym_cbuffer] = ACTIONS(3421),
    [anon_sym_interface] = ACTIONS(3421),
    [anon_sym_extension] = ACTIONS(3421),
  },
  [1359] = {
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(3496),
    [anon_sym_BANG] = ACTIONS(3496),
    [anon_sym_TILDE] = ACTIONS(3496),
    [anon_sym_DASH] = ACTIONS(3494),
    [anon_sym_PLUS] = ACTIONS(3494),
    [anon_sym_STAR] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3496),
    [anon_sym_SEMI] = ACTIONS(3496),
    [anon_sym___extension__] = ACTIONS(3494),
    [anon_sym_typedef] = ACTIONS(3494),
    [anon_sym_in] = ACTIONS(3494),
    [anon_sym_out] = ACTIONS(3494),
    [anon_sym_inout] = ACTIONS(3494),
    [anon_sym_virtual] = ACTIONS(3494),
    [anon_sym_extern] = ACTIONS(3494),
    [anon_sym___attribute__] = ACTIONS(3494),
    [anon_sym___attribute] = ACTIONS(3494),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3496),
    [anon_sym___declspec] = ACTIONS(3494),
    [anon_sym_LBRACE] = ACTIONS(3496),
    [anon_sym_signed] = ACTIONS(3494),
    [anon_sym_unsigned] = ACTIONS(3494),
    [anon_sym_long] = ACTIONS(3494),
    [anon_sym_short] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_static] = ACTIONS(3494),
    [anon_sym_register] = ACTIONS(3494),
    [anon_sym_inline] = ACTIONS(3494),
    [anon_sym___inline] = ACTIONS(3494),
    [anon_sym___inline__] = ACTIONS(3494),
    [anon_sym___forceinline] = ACTIONS(3494),
    [anon_sym_thread_local] = ACTIONS(3494),
    [anon_sym___thread] = ACTIONS(3494),
    [anon_sym_const] = ACTIONS(3494),
    [anon_sym_constexpr] = ACTIONS(3494),
    [anon_sym_volatile] = ACTIONS(3494),
    [anon_sym_restrict] = ACTIONS(3494),
    [anon_sym___restrict__] = ACTIONS(3494),
    [anon_sym__Atomic] = ACTIONS(3494),
    [anon_sym__Noreturn] = ACTIONS(3494),
    [anon_sym_noreturn] = ACTIONS(3494),
    [anon_sym__Nonnull] = ACTIONS(3494),
    [anon_sym_mutable] = ACTIONS(3494),
    [anon_sym_constinit] = ACTIONS(3494),
    [anon_sym_consteval] = ACTIONS(3494),
    [anon_sym_alignas] = ACTIONS(3494),
    [anon_sym__Alignas] = ACTIONS(3494),
    [sym_primitive_type] = ACTIONS(3494),
    [anon_sym_enum] = ACTIONS(3494),
    [anon_sym_class] = ACTIONS(3494),
    [anon_sym_struct] = ACTIONS(3494),
    [anon_sym_union] = ACTIONS(3494),
    [anon_sym_if] = ACTIONS(3494),
    [anon_sym_else] = ACTIONS(3494),
    [anon_sym_switch] = ACTIONS(3494),
    [anon_sym_while] = ACTIONS(3494),
    [anon_sym_do] = ACTIONS(3494),
    [anon_sym_for] = ACTIONS(3494),
    [anon_sym_return] = ACTIONS(3494),
    [anon_sym_break] = ACTIONS(3494),
    [anon_sym_continue] = ACTIONS(3494),
    [anon_sym_goto] = ACTIONS(3494),
    [anon_sym___try] = ACTIONS(3494),
    [anon_sym___leave] = ACTIONS(3494),
    [anon_sym_not] = ACTIONS(3494),
    [anon_sym_compl] = ACTIONS(3494),
    [anon_sym_DASH_DASH] = ACTIONS(3496),
    [anon_sym_PLUS_PLUS] = ACTIONS(3496),
    [anon_sym_sizeof] = ACTIONS(3494),
    [anon_sym___alignof__] = ACTIONS(3494),
    [anon_sym___alignof] = ACTIONS(3494),
    [anon_sym__alignof] = ACTIONS(3494),
    [anon_sym_alignof] = ACTIONS(3494),
    [anon_sym__Alignof] = ACTIONS(3494),
    [anon_sym_offsetof] = ACTIONS(3494),
    [anon_sym__Generic] = ACTIONS(3494),
    [anon_sym_asm] = ACTIONS(3494),
    [anon_sym___asm__] = ACTIONS(3494),
    [anon_sym___asm] = ACTIONS(3494),
    [sym_number_literal] = ACTIONS(3496),
    [anon_sym_L_SQUOTE] = ACTIONS(3496),
    [anon_sym_u_SQUOTE] = ACTIONS(3496),
    [anon_sym_U_SQUOTE] = ACTIONS(3496),
    [anon_sym_u8_SQUOTE] = ACTIONS(3496),
    [anon_sym_SQUOTE] = ACTIONS(3496),
    [anon_sym_L_DQUOTE] = ACTIONS(3496),
    [anon_sym_u_DQUOTE] = ACTIONS(3496),
    [anon_sym_U_DQUOTE] = ACTIONS(3496),
    [anon_sym_u8_DQUOTE] = ACTIONS(3496),
    [anon_sym_DQUOTE] = ACTIONS(3496),
    [sym_true] = ACTIONS(3494),
    [sym_false] = ACTIONS(3494),
    [anon_sym_NULL] = ACTIONS(3494),
    [anon_sym_nullptr] = ACTIONS(3494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_This] = ACTIONS(3494),
    [anon_sym_decltype] = ACTIONS(3494),
    [anon_sym_typename] = ACTIONS(3494),
    [anon_sym_template] = ACTIONS(3494),
    [anon_sym_try] = ACTIONS(3494),
    [anon_sym_delete] = ACTIONS(3494),
    [anon_sym_throw] = ACTIONS(3494),
    [anon_sym_co_return] = ACTIONS(3494),
    [anon_sym_co_yield] = ACTIONS(3494),
    [anon_sym_R_DQUOTE] = ACTIONS(3496),
    [anon_sym_LR_DQUOTE] = ACTIONS(3496),
    [anon_sym_uR_DQUOTE] = ACTIONS(3496),
    [anon_sym_UR_DQUOTE] = ACTIONS(3496),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3496),
    [anon_sym_co_await] = ACTIONS(3494),
    [anon_sym_new] = ACTIONS(3494),
    [anon_sym_requires] = ACTIONS(3494),
    [sym_this] = ACTIONS(3494),
    [anon_sym_discard] = ACTIONS(3494),
    [anon_sym_precise] = ACTIONS(3494),
    [anon_sym_shared] = ACTIONS(3494),
    [anon_sym_groupshared] = ACTIONS(3494),
    [anon_sym_uniform] = ACTIONS(3494),
    [anon_sym_row_major] = ACTIONS(3494),
    [anon_sym_column_major] = ACTIONS(3494),
    [anon_sym_globallycoherent] = ACTIONS(3494),
    [anon_sym_centroid] = ACTIONS(3494),
    [anon_sym_noperspective] = ACTIONS(3494),
    [anon_sym_nointerpolation] = ACTIONS(3494),
    [anon_sym_sample] = ACTIONS(3494),
    [anon_sym_linear] = ACTIONS(3494),
    [anon_sym_snorm] = ACTIONS(3494),
    [anon_sym_unorm] = ACTIONS(3494),
    [anon_sym_point] = ACTIONS(3494),
    [anon_sym_line] = ACTIONS(3494),
    [anon_sym_triangleadj] = ACTIONS(3494),
    [anon_sym_lineadj] = ACTIONS(3494),
    [anon_sym_triangle] = ACTIONS(3494),
    [anon_sym_cbuffer] = ACTIONS(3494),
    [anon_sym_interface] = ACTIONS(3494),
    [anon_sym_extension] = ACTIONS(3494),
  },
  [1360] = {
    [sym_identifier] = ACTIONS(3506),
    [anon_sym_LPAREN2] = ACTIONS(3508),
    [anon_sym_BANG] = ACTIONS(3508),
    [anon_sym_TILDE] = ACTIONS(3508),
    [anon_sym_DASH] = ACTIONS(3506),
    [anon_sym_PLUS] = ACTIONS(3506),
    [anon_sym_STAR] = ACTIONS(3508),
    [anon_sym_AMP] = ACTIONS(3508),
    [anon_sym_SEMI] = ACTIONS(3508),
    [anon_sym___extension__] = ACTIONS(3506),
    [anon_sym_typedef] = ACTIONS(3506),
    [anon_sym_in] = ACTIONS(3506),
    [anon_sym_out] = ACTIONS(3506),
    [anon_sym_inout] = ACTIONS(3506),
    [anon_sym_virtual] = ACTIONS(3506),
    [anon_sym_extern] = ACTIONS(3506),
    [anon_sym___attribute__] = ACTIONS(3506),
    [anon_sym___attribute] = ACTIONS(3506),
    [anon_sym_COLON_COLON] = ACTIONS(3508),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3508),
    [anon_sym___declspec] = ACTIONS(3506),
    [anon_sym_LBRACE] = ACTIONS(3508),
    [anon_sym_signed] = ACTIONS(3506),
    [anon_sym_unsigned] = ACTIONS(3506),
    [anon_sym_long] = ACTIONS(3506),
    [anon_sym_short] = ACTIONS(3506),
    [anon_sym_LBRACK] = ACTIONS(3506),
    [anon_sym_static] = ACTIONS(3506),
    [anon_sym_register] = ACTIONS(3506),
    [anon_sym_inline] = ACTIONS(3506),
    [anon_sym___inline] = ACTIONS(3506),
    [anon_sym___inline__] = ACTIONS(3506),
    [anon_sym___forceinline] = ACTIONS(3506),
    [anon_sym_thread_local] = ACTIONS(3506),
    [anon_sym___thread] = ACTIONS(3506),
    [anon_sym_const] = ACTIONS(3506),
    [anon_sym_constexpr] = ACTIONS(3506),
    [anon_sym_volatile] = ACTIONS(3506),
    [anon_sym_restrict] = ACTIONS(3506),
    [anon_sym___restrict__] = ACTIONS(3506),
    [anon_sym__Atomic] = ACTIONS(3506),
    [anon_sym__Noreturn] = ACTIONS(3506),
    [anon_sym_noreturn] = ACTIONS(3506),
    [anon_sym__Nonnull] = ACTIONS(3506),
    [anon_sym_mutable] = ACTIONS(3506),
    [anon_sym_constinit] = ACTIONS(3506),
    [anon_sym_consteval] = ACTIONS(3506),
    [anon_sym_alignas] = ACTIONS(3506),
    [anon_sym__Alignas] = ACTIONS(3506),
    [sym_primitive_type] = ACTIONS(3506),
    [anon_sym_enum] = ACTIONS(3506),
    [anon_sym_class] = ACTIONS(3506),
    [anon_sym_struct] = ACTIONS(3506),
    [anon_sym_union] = ACTIONS(3506),
    [anon_sym_if] = ACTIONS(3506),
    [anon_sym_else] = ACTIONS(3506),
    [anon_sym_switch] = ACTIONS(3506),
    [anon_sym_while] = ACTIONS(3506),
    [anon_sym_do] = ACTIONS(3506),
    [anon_sym_for] = ACTIONS(3506),
    [anon_sym_return] = ACTIONS(3506),
    [anon_sym_break] = ACTIONS(3506),
    [anon_sym_continue] = ACTIONS(3506),
    [anon_sym_goto] = ACTIONS(3506),
    [anon_sym___try] = ACTIONS(3506),
    [anon_sym___leave] = ACTIONS(3506),
    [anon_sym_not] = ACTIONS(3506),
    [anon_sym_compl] = ACTIONS(3506),
    [anon_sym_DASH_DASH] = ACTIONS(3508),
    [anon_sym_PLUS_PLUS] = ACTIONS(3508),
    [anon_sym_sizeof] = ACTIONS(3506),
    [anon_sym___alignof__] = ACTIONS(3506),
    [anon_sym___alignof] = ACTIONS(3506),
    [anon_sym__alignof] = ACTIONS(3506),
    [anon_sym_alignof] = ACTIONS(3506),
    [anon_sym__Alignof] = ACTIONS(3506),
    [anon_sym_offsetof] = ACTIONS(3506),
    [anon_sym__Generic] = ACTIONS(3506),
    [anon_sym_asm] = ACTIONS(3506),
    [anon_sym___asm__] = ACTIONS(3506),
    [anon_sym___asm] = ACTIONS(3506),
    [sym_number_literal] = ACTIONS(3508),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3508),
    [anon_sym_u_DQUOTE] = ACTIONS(3508),
    [anon_sym_U_DQUOTE] = ACTIONS(3508),
    [anon_sym_u8_DQUOTE] = ACTIONS(3508),
    [anon_sym_DQUOTE] = ACTIONS(3508),
    [sym_true] = ACTIONS(3506),
    [sym_false] = ACTIONS(3506),
    [anon_sym_NULL] = ACTIONS(3506),
    [anon_sym_nullptr] = ACTIONS(3506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3506),
    [anon_sym_let] = ACTIONS(3506),
    [anon_sym_This] = ACTIONS(3506),
    [anon_sym_decltype] = ACTIONS(3506),
    [anon_sym_typename] = ACTIONS(3506),
    [anon_sym_template] = ACTIONS(3506),
    [anon_sym_try] = ACTIONS(3506),
    [anon_sym_delete] = ACTIONS(3506),
    [anon_sym_throw] = ACTIONS(3506),
    [anon_sym_co_return] = ACTIONS(3506),
    [anon_sym_co_yield] = ACTIONS(3506),
    [anon_sym_R_DQUOTE] = ACTIONS(3508),
    [anon_sym_LR_DQUOTE] = ACTIONS(3508),
    [anon_sym_uR_DQUOTE] = ACTIONS(3508),
    [anon_sym_UR_DQUOTE] = ACTIONS(3508),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3508),
    [anon_sym_co_await] = ACTIONS(3506),
    [anon_sym_new] = ACTIONS(3506),
    [anon_sym_requires] = ACTIONS(3506),
    [sym_this] = ACTIONS(3506),
    [anon_sym_discard] = ACTIONS(3506),
    [anon_sym_precise] = ACTIONS(3506),
    [anon_sym_shared] = ACTIONS(3506),
    [anon_sym_groupshared] = ACTIONS(3506),
    [anon_sym_uniform] = ACTIONS(3506),
    [anon_sym_row_major] = ACTIONS(3506),
    [anon_sym_column_major] = ACTIONS(3506),
    [anon_sym_globallycoherent] = ACTIONS(3506),
    [anon_sym_centroid] = ACTIONS(3506),
    [anon_sym_noperspective] = ACTIONS(3506),
    [anon_sym_nointerpolation] = ACTIONS(3506),
    [anon_sym_sample] = ACTIONS(3506),
    [anon_sym_linear] = ACTIONS(3506),
    [anon_sym_snorm] = ACTIONS(3506),
    [anon_sym_unorm] = ACTIONS(3506),
    [anon_sym_point] = ACTIONS(3506),
    [anon_sym_line] = ACTIONS(3506),
    [anon_sym_triangleadj] = ACTIONS(3506),
    [anon_sym_lineadj] = ACTIONS(3506),
    [anon_sym_triangle] = ACTIONS(3506),
    [anon_sym_cbuffer] = ACTIONS(3506),
    [anon_sym_interface] = ACTIONS(3506),
    [anon_sym_extension] = ACTIONS(3506),
  },
  [1361] = {
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3560),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym___extension__] = ACTIONS(3562),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_in] = ACTIONS(3562),
    [anon_sym_out] = ACTIONS(3562),
    [anon_sym_inout] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym___attribute__] = ACTIONS(3562),
    [anon_sym___attribute] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3560),
    [anon_sym___declspec] = ACTIONS(3562),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_signed] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym___inline] = ACTIONS(3562),
    [anon_sym___inline__] = ACTIONS(3562),
    [anon_sym___forceinline] = ACTIONS(3562),
    [anon_sym_thread_local] = ACTIONS(3562),
    [anon_sym___thread] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_constexpr] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym___restrict__] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym__Noreturn] = ACTIONS(3562),
    [anon_sym_noreturn] = ACTIONS(3562),
    [anon_sym__Nonnull] = ACTIONS(3562),
    [anon_sym_mutable] = ACTIONS(3562),
    [anon_sym_constinit] = ACTIONS(3562),
    [anon_sym_consteval] = ACTIONS(3562),
    [anon_sym_alignas] = ACTIONS(3562),
    [anon_sym__Alignas] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_else] = ACTIONS(3562),
    [anon_sym_switch] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_goto] = ACTIONS(3562),
    [anon_sym___try] = ACTIONS(3562),
    [anon_sym___leave] = ACTIONS(3562),
    [anon_sym_not] = ACTIONS(3562),
    [anon_sym_compl] = ACTIONS(3562),
    [anon_sym_DASH_DASH] = ACTIONS(3560),
    [anon_sym_PLUS_PLUS] = ACTIONS(3560),
    [anon_sym_sizeof] = ACTIONS(3562),
    [anon_sym___alignof__] = ACTIONS(3562),
    [anon_sym___alignof] = ACTIONS(3562),
    [anon_sym__alignof] = ACTIONS(3562),
    [anon_sym_alignof] = ACTIONS(3562),
    [anon_sym__Alignof] = ACTIONS(3562),
    [anon_sym_offsetof] = ACTIONS(3562),
    [anon_sym__Generic] = ACTIONS(3562),
    [anon_sym_asm] = ACTIONS(3562),
    [anon_sym___asm__] = ACTIONS(3562),
    [anon_sym___asm] = ACTIONS(3562),
    [sym_number_literal] = ACTIONS(3560),
    [anon_sym_L_SQUOTE] = ACTIONS(3560),
    [anon_sym_u_SQUOTE] = ACTIONS(3560),
    [anon_sym_U_SQUOTE] = ACTIONS(3560),
    [anon_sym_u8_SQUOTE] = ACTIONS(3560),
    [anon_sym_SQUOTE] = ACTIONS(3560),
    [anon_sym_L_DQUOTE] = ACTIONS(3560),
    [anon_sym_u_DQUOTE] = ACTIONS(3560),
    [anon_sym_U_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE] = ACTIONS(3560),
    [sym_true] = ACTIONS(3562),
    [sym_false] = ACTIONS(3562),
    [anon_sym_NULL] = ACTIONS(3562),
    [anon_sym_nullptr] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_This] = ACTIONS(3562),
    [anon_sym_decltype] = ACTIONS(3562),
    [anon_sym_typename] = ACTIONS(3562),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_delete] = ACTIONS(3562),
    [anon_sym_throw] = ACTIONS(3562),
    [anon_sym_co_return] = ACTIONS(3562),
    [anon_sym_co_yield] = ACTIONS(3562),
    [anon_sym_R_DQUOTE] = ACTIONS(3560),
    [anon_sym_LR_DQUOTE] = ACTIONS(3560),
    [anon_sym_uR_DQUOTE] = ACTIONS(3560),
    [anon_sym_UR_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3560),
    [anon_sym_co_await] = ACTIONS(3562),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_requires] = ACTIONS(3562),
    [sym_this] = ACTIONS(3562),
    [anon_sym_discard] = ACTIONS(3562),
    [anon_sym_precise] = ACTIONS(3562),
    [anon_sym_shared] = ACTIONS(3562),
    [anon_sym_groupshared] = ACTIONS(3562),
    [anon_sym_uniform] = ACTIONS(3562),
    [anon_sym_row_major] = ACTIONS(3562),
    [anon_sym_column_major] = ACTIONS(3562),
    [anon_sym_globallycoherent] = ACTIONS(3562),
    [anon_sym_centroid] = ACTIONS(3562),
    [anon_sym_noperspective] = ACTIONS(3562),
    [anon_sym_nointerpolation] = ACTIONS(3562),
    [anon_sym_sample] = ACTIONS(3562),
    [anon_sym_linear] = ACTIONS(3562),
    [anon_sym_snorm] = ACTIONS(3562),
    [anon_sym_unorm] = ACTIONS(3562),
    [anon_sym_point] = ACTIONS(3562),
    [anon_sym_line] = ACTIONS(3562),
    [anon_sym_triangleadj] = ACTIONS(3562),
    [anon_sym_lineadj] = ACTIONS(3562),
    [anon_sym_triangle] = ACTIONS(3562),
    [anon_sym_cbuffer] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_extension] = ACTIONS(3562),
  },
  [1362] = {
    [sym_identifier] = ACTIONS(3488),
    [anon_sym_LPAREN2] = ACTIONS(3486),
    [anon_sym_BANG] = ACTIONS(3486),
    [anon_sym_TILDE] = ACTIONS(3486),
    [anon_sym_DASH] = ACTIONS(3488),
    [anon_sym_PLUS] = ACTIONS(3488),
    [anon_sym_STAR] = ACTIONS(3486),
    [anon_sym_AMP] = ACTIONS(3486),
    [anon_sym_SEMI] = ACTIONS(3486),
    [anon_sym___extension__] = ACTIONS(3488),
    [anon_sym_typedef] = ACTIONS(3488),
    [anon_sym_in] = ACTIONS(3488),
    [anon_sym_out] = ACTIONS(3488),
    [anon_sym_inout] = ACTIONS(3488),
    [anon_sym_virtual] = ACTIONS(3488),
    [anon_sym_extern] = ACTIONS(3488),
    [anon_sym___attribute__] = ACTIONS(3488),
    [anon_sym___attribute] = ACTIONS(3488),
    [anon_sym_COLON_COLON] = ACTIONS(3486),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3486),
    [anon_sym___declspec] = ACTIONS(3488),
    [anon_sym_LBRACE] = ACTIONS(3486),
    [anon_sym_signed] = ACTIONS(3488),
    [anon_sym_unsigned] = ACTIONS(3488),
    [anon_sym_long] = ACTIONS(3488),
    [anon_sym_short] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(3488),
    [anon_sym_static] = ACTIONS(3488),
    [anon_sym_register] = ACTIONS(3488),
    [anon_sym_inline] = ACTIONS(3488),
    [anon_sym___inline] = ACTIONS(3488),
    [anon_sym___inline__] = ACTIONS(3488),
    [anon_sym___forceinline] = ACTIONS(3488),
    [anon_sym_thread_local] = ACTIONS(3488),
    [anon_sym___thread] = ACTIONS(3488),
    [anon_sym_const] = ACTIONS(3488),
    [anon_sym_constexpr] = ACTIONS(3488),
    [anon_sym_volatile] = ACTIONS(3488),
    [anon_sym_restrict] = ACTIONS(3488),
    [anon_sym___restrict__] = ACTIONS(3488),
    [anon_sym__Atomic] = ACTIONS(3488),
    [anon_sym__Noreturn] = ACTIONS(3488),
    [anon_sym_noreturn] = ACTIONS(3488),
    [anon_sym__Nonnull] = ACTIONS(3488),
    [anon_sym_mutable] = ACTIONS(3488),
    [anon_sym_constinit] = ACTIONS(3488),
    [anon_sym_consteval] = ACTIONS(3488),
    [anon_sym_alignas] = ACTIONS(3488),
    [anon_sym__Alignas] = ACTIONS(3488),
    [sym_primitive_type] = ACTIONS(3488),
    [anon_sym_enum] = ACTIONS(3488),
    [anon_sym_class] = ACTIONS(3488),
    [anon_sym_struct] = ACTIONS(3488),
    [anon_sym_union] = ACTIONS(3488),
    [anon_sym_if] = ACTIONS(3488),
    [anon_sym_else] = ACTIONS(3488),
    [anon_sym_switch] = ACTIONS(3488),
    [anon_sym_while] = ACTIONS(3488),
    [anon_sym_do] = ACTIONS(3488),
    [anon_sym_for] = ACTIONS(3488),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_break] = ACTIONS(3488),
    [anon_sym_continue] = ACTIONS(3488),
    [anon_sym_goto] = ACTIONS(3488),
    [anon_sym___try] = ACTIONS(3488),
    [anon_sym___leave] = ACTIONS(3488),
    [anon_sym_not] = ACTIONS(3488),
    [anon_sym_compl] = ACTIONS(3488),
    [anon_sym_DASH_DASH] = ACTIONS(3486),
    [anon_sym_PLUS_PLUS] = ACTIONS(3486),
    [anon_sym_sizeof] = ACTIONS(3488),
    [anon_sym___alignof__] = ACTIONS(3488),
    [anon_sym___alignof] = ACTIONS(3488),
    [anon_sym__alignof] = ACTIONS(3488),
    [anon_sym_alignof] = ACTIONS(3488),
    [anon_sym__Alignof] = ACTIONS(3488),
    [anon_sym_offsetof] = ACTIONS(3488),
    [anon_sym__Generic] = ACTIONS(3488),
    [anon_sym_asm] = ACTIONS(3488),
    [anon_sym___asm__] = ACTIONS(3488),
    [anon_sym___asm] = ACTIONS(3488),
    [sym_number_literal] = ACTIONS(3486),
    [anon_sym_L_SQUOTE] = ACTIONS(3486),
    [anon_sym_u_SQUOTE] = ACTIONS(3486),
    [anon_sym_U_SQUOTE] = ACTIONS(3486),
    [anon_sym_u8_SQUOTE] = ACTIONS(3486),
    [anon_sym_SQUOTE] = ACTIONS(3486),
    [anon_sym_L_DQUOTE] = ACTIONS(3486),
    [anon_sym_u_DQUOTE] = ACTIONS(3486),
    [anon_sym_U_DQUOTE] = ACTIONS(3486),
    [anon_sym_u8_DQUOTE] = ACTIONS(3486),
    [anon_sym_DQUOTE] = ACTIONS(3486),
    [sym_true] = ACTIONS(3488),
    [sym_false] = ACTIONS(3488),
    [anon_sym_NULL] = ACTIONS(3488),
    [anon_sym_nullptr] = ACTIONS(3488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3488),
    [anon_sym_let] = ACTIONS(3488),
    [anon_sym_This] = ACTIONS(3488),
    [anon_sym_decltype] = ACTIONS(3488),
    [anon_sym_typename] = ACTIONS(3488),
    [anon_sym_template] = ACTIONS(3488),
    [anon_sym_try] = ACTIONS(3488),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_throw] = ACTIONS(3488),
    [anon_sym_co_return] = ACTIONS(3488),
    [anon_sym_co_yield] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(3486),
    [anon_sym_LR_DQUOTE] = ACTIONS(3486),
    [anon_sym_uR_DQUOTE] = ACTIONS(3486),
    [anon_sym_UR_DQUOTE] = ACTIONS(3486),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3486),
    [anon_sym_co_await] = ACTIONS(3488),
    [anon_sym_new] = ACTIONS(3488),
    [anon_sym_requires] = ACTIONS(3488),
    [sym_this] = ACTIONS(3488),
    [anon_sym_discard] = ACTIONS(3488),
    [anon_sym_precise] = ACTIONS(3488),
    [anon_sym_shared] = ACTIONS(3488),
    [anon_sym_groupshared] = ACTIONS(3488),
    [anon_sym_uniform] = ACTIONS(3488),
    [anon_sym_row_major] = ACTIONS(3488),
    [anon_sym_column_major] = ACTIONS(3488),
    [anon_sym_globallycoherent] = ACTIONS(3488),
    [anon_sym_centroid] = ACTIONS(3488),
    [anon_sym_noperspective] = ACTIONS(3488),
    [anon_sym_nointerpolation] = ACTIONS(3488),
    [anon_sym_sample] = ACTIONS(3488),
    [anon_sym_linear] = ACTIONS(3488),
    [anon_sym_snorm] = ACTIONS(3488),
    [anon_sym_unorm] = ACTIONS(3488),
    [anon_sym_point] = ACTIONS(3488),
    [anon_sym_line] = ACTIONS(3488),
    [anon_sym_triangleadj] = ACTIONS(3488),
    [anon_sym_lineadj] = ACTIONS(3488),
    [anon_sym_triangle] = ACTIONS(3488),
    [anon_sym_cbuffer] = ACTIONS(3488),
    [anon_sym_interface] = ACTIONS(3488),
    [anon_sym_extension] = ACTIONS(3488),
  },
  [1363] = {
    [sym_identifier] = ACTIONS(3500),
    [anon_sym_LPAREN2] = ACTIONS(3498),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3500),
    [anon_sym_PLUS] = ACTIONS(3500),
    [anon_sym_STAR] = ACTIONS(3498),
    [anon_sym_AMP] = ACTIONS(3498),
    [anon_sym_SEMI] = ACTIONS(3498),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_typedef] = ACTIONS(3500),
    [anon_sym_in] = ACTIONS(3500),
    [anon_sym_out] = ACTIONS(3500),
    [anon_sym_inout] = ACTIONS(3500),
    [anon_sym_virtual] = ACTIONS(3500),
    [anon_sym_extern] = ACTIONS(3500),
    [anon_sym___attribute__] = ACTIONS(3500),
    [anon_sym___attribute] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3498),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3498),
    [anon_sym___declspec] = ACTIONS(3500),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_signed] = ACTIONS(3500),
    [anon_sym_unsigned] = ACTIONS(3500),
    [anon_sym_long] = ACTIONS(3500),
    [anon_sym_short] = ACTIONS(3500),
    [anon_sym_LBRACK] = ACTIONS(3500),
    [anon_sym_static] = ACTIONS(3500),
    [anon_sym_register] = ACTIONS(3500),
    [anon_sym_inline] = ACTIONS(3500),
    [anon_sym___inline] = ACTIONS(3500),
    [anon_sym___inline__] = ACTIONS(3500),
    [anon_sym___forceinline] = ACTIONS(3500),
    [anon_sym_thread_local] = ACTIONS(3500),
    [anon_sym___thread] = ACTIONS(3500),
    [anon_sym_const] = ACTIONS(3500),
    [anon_sym_constexpr] = ACTIONS(3500),
    [anon_sym_volatile] = ACTIONS(3500),
    [anon_sym_restrict] = ACTIONS(3500),
    [anon_sym___restrict__] = ACTIONS(3500),
    [anon_sym__Atomic] = ACTIONS(3500),
    [anon_sym__Noreturn] = ACTIONS(3500),
    [anon_sym_noreturn] = ACTIONS(3500),
    [anon_sym__Nonnull] = ACTIONS(3500),
    [anon_sym_mutable] = ACTIONS(3500),
    [anon_sym_constinit] = ACTIONS(3500),
    [anon_sym_consteval] = ACTIONS(3500),
    [anon_sym_alignas] = ACTIONS(3500),
    [anon_sym__Alignas] = ACTIONS(3500),
    [sym_primitive_type] = ACTIONS(3500),
    [anon_sym_enum] = ACTIONS(3500),
    [anon_sym_class] = ACTIONS(3500),
    [anon_sym_struct] = ACTIONS(3500),
    [anon_sym_union] = ACTIONS(3500),
    [anon_sym_if] = ACTIONS(3500),
    [anon_sym_else] = ACTIONS(3500),
    [anon_sym_switch] = ACTIONS(3500),
    [anon_sym_while] = ACTIONS(3500),
    [anon_sym_do] = ACTIONS(3500),
    [anon_sym_for] = ACTIONS(3500),
    [anon_sym_return] = ACTIONS(3500),
    [anon_sym_break] = ACTIONS(3500),
    [anon_sym_continue] = ACTIONS(3500),
    [anon_sym_goto] = ACTIONS(3500),
    [anon_sym___try] = ACTIONS(3500),
    [anon_sym___leave] = ACTIONS(3500),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_compl] = ACTIONS(3500),
    [anon_sym_DASH_DASH] = ACTIONS(3498),
    [anon_sym_PLUS_PLUS] = ACTIONS(3498),
    [anon_sym_sizeof] = ACTIONS(3500),
    [anon_sym___alignof__] = ACTIONS(3500),
    [anon_sym___alignof] = ACTIONS(3500),
    [anon_sym__alignof] = ACTIONS(3500),
    [anon_sym_alignof] = ACTIONS(3500),
    [anon_sym__Alignof] = ACTIONS(3500),
    [anon_sym_offsetof] = ACTIONS(3500),
    [anon_sym__Generic] = ACTIONS(3500),
    [anon_sym_asm] = ACTIONS(3500),
    [anon_sym___asm__] = ACTIONS(3500),
    [anon_sym___asm] = ACTIONS(3500),
    [sym_number_literal] = ACTIONS(3498),
    [anon_sym_L_SQUOTE] = ACTIONS(3498),
    [anon_sym_u_SQUOTE] = ACTIONS(3498),
    [anon_sym_U_SQUOTE] = ACTIONS(3498),
    [anon_sym_u8_SQUOTE] = ACTIONS(3498),
    [anon_sym_SQUOTE] = ACTIONS(3498),
    [anon_sym_L_DQUOTE] = ACTIONS(3498),
    [anon_sym_u_DQUOTE] = ACTIONS(3498),
    [anon_sym_U_DQUOTE] = ACTIONS(3498),
    [anon_sym_u8_DQUOTE] = ACTIONS(3498),
    [anon_sym_DQUOTE] = ACTIONS(3498),
    [sym_true] = ACTIONS(3500),
    [sym_false] = ACTIONS(3500),
    [anon_sym_NULL] = ACTIONS(3500),
    [anon_sym_nullptr] = ACTIONS(3500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3500),
    [anon_sym_let] = ACTIONS(3500),
    [anon_sym_This] = ACTIONS(3500),
    [anon_sym_decltype] = ACTIONS(3500),
    [anon_sym_typename] = ACTIONS(3500),
    [anon_sym_template] = ACTIONS(3500),
    [anon_sym_try] = ACTIONS(3500),
    [anon_sym_delete] = ACTIONS(3500),
    [anon_sym_throw] = ACTIONS(3500),
    [anon_sym_co_return] = ACTIONS(3500),
    [anon_sym_co_yield] = ACTIONS(3500),
    [anon_sym_R_DQUOTE] = ACTIONS(3498),
    [anon_sym_LR_DQUOTE] = ACTIONS(3498),
    [anon_sym_uR_DQUOTE] = ACTIONS(3498),
    [anon_sym_UR_DQUOTE] = ACTIONS(3498),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3498),
    [anon_sym_co_await] = ACTIONS(3500),
    [anon_sym_new] = ACTIONS(3500),
    [anon_sym_requires] = ACTIONS(3500),
    [sym_this] = ACTIONS(3500),
    [anon_sym_discard] = ACTIONS(3500),
    [anon_sym_precise] = ACTIONS(3500),
    [anon_sym_shared] = ACTIONS(3500),
    [anon_sym_groupshared] = ACTIONS(3500),
    [anon_sym_uniform] = ACTIONS(3500),
    [anon_sym_row_major] = ACTIONS(3500),
    [anon_sym_column_major] = ACTIONS(3500),
    [anon_sym_globallycoherent] = ACTIONS(3500),
    [anon_sym_centroid] = ACTIONS(3500),
    [anon_sym_noperspective] = ACTIONS(3500),
    [anon_sym_nointerpolation] = ACTIONS(3500),
    [anon_sym_sample] = ACTIONS(3500),
    [anon_sym_linear] = ACTIONS(3500),
    [anon_sym_snorm] = ACTIONS(3500),
    [anon_sym_unorm] = ACTIONS(3500),
    [anon_sym_point] = ACTIONS(3500),
    [anon_sym_line] = ACTIONS(3500),
    [anon_sym_triangleadj] = ACTIONS(3500),
    [anon_sym_lineadj] = ACTIONS(3500),
    [anon_sym_triangle] = ACTIONS(3500),
    [anon_sym_cbuffer] = ACTIONS(3500),
    [anon_sym_interface] = ACTIONS(3500),
    [anon_sym_extension] = ACTIONS(3500),
  },
  [1364] = {
    [sym_identifier] = ACTIONS(3510),
    [anon_sym_LPAREN2] = ACTIONS(3512),
    [anon_sym_BANG] = ACTIONS(3512),
    [anon_sym_TILDE] = ACTIONS(3512),
    [anon_sym_DASH] = ACTIONS(3510),
    [anon_sym_PLUS] = ACTIONS(3510),
    [anon_sym_STAR] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3512),
    [anon_sym_SEMI] = ACTIONS(3512),
    [anon_sym___extension__] = ACTIONS(3510),
    [anon_sym_typedef] = ACTIONS(3510),
    [anon_sym_in] = ACTIONS(3510),
    [anon_sym_out] = ACTIONS(3510),
    [anon_sym_inout] = ACTIONS(3510),
    [anon_sym_virtual] = ACTIONS(3510),
    [anon_sym_extern] = ACTIONS(3510),
    [anon_sym___attribute__] = ACTIONS(3510),
    [anon_sym___attribute] = ACTIONS(3510),
    [anon_sym_COLON_COLON] = ACTIONS(3512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3512),
    [anon_sym___declspec] = ACTIONS(3510),
    [anon_sym_LBRACE] = ACTIONS(3512),
    [anon_sym_signed] = ACTIONS(3510),
    [anon_sym_unsigned] = ACTIONS(3510),
    [anon_sym_long] = ACTIONS(3510),
    [anon_sym_short] = ACTIONS(3510),
    [anon_sym_LBRACK] = ACTIONS(3510),
    [anon_sym_static] = ACTIONS(3510),
    [anon_sym_register] = ACTIONS(3510),
    [anon_sym_inline] = ACTIONS(3510),
    [anon_sym___inline] = ACTIONS(3510),
    [anon_sym___inline__] = ACTIONS(3510),
    [anon_sym___forceinline] = ACTIONS(3510),
    [anon_sym_thread_local] = ACTIONS(3510),
    [anon_sym___thread] = ACTIONS(3510),
    [anon_sym_const] = ACTIONS(3510),
    [anon_sym_constexpr] = ACTIONS(3510),
    [anon_sym_volatile] = ACTIONS(3510),
    [anon_sym_restrict] = ACTIONS(3510),
    [anon_sym___restrict__] = ACTIONS(3510),
    [anon_sym__Atomic] = ACTIONS(3510),
    [anon_sym__Noreturn] = ACTIONS(3510),
    [anon_sym_noreturn] = ACTIONS(3510),
    [anon_sym__Nonnull] = ACTIONS(3510),
    [anon_sym_mutable] = ACTIONS(3510),
    [anon_sym_constinit] = ACTIONS(3510),
    [anon_sym_consteval] = ACTIONS(3510),
    [anon_sym_alignas] = ACTIONS(3510),
    [anon_sym__Alignas] = ACTIONS(3510),
    [sym_primitive_type] = ACTIONS(3510),
    [anon_sym_enum] = ACTIONS(3510),
    [anon_sym_class] = ACTIONS(3510),
    [anon_sym_struct] = ACTIONS(3510),
    [anon_sym_union] = ACTIONS(3510),
    [anon_sym_if] = ACTIONS(3510),
    [anon_sym_else] = ACTIONS(3510),
    [anon_sym_switch] = ACTIONS(3510),
    [anon_sym_while] = ACTIONS(3510),
    [anon_sym_do] = ACTIONS(3510),
    [anon_sym_for] = ACTIONS(3510),
    [anon_sym_return] = ACTIONS(3510),
    [anon_sym_break] = ACTIONS(3510),
    [anon_sym_continue] = ACTIONS(3510),
    [anon_sym_goto] = ACTIONS(3510),
    [anon_sym___try] = ACTIONS(3510),
    [anon_sym___leave] = ACTIONS(3510),
    [anon_sym_not] = ACTIONS(3510),
    [anon_sym_compl] = ACTIONS(3510),
    [anon_sym_DASH_DASH] = ACTIONS(3512),
    [anon_sym_PLUS_PLUS] = ACTIONS(3512),
    [anon_sym_sizeof] = ACTIONS(3510),
    [anon_sym___alignof__] = ACTIONS(3510),
    [anon_sym___alignof] = ACTIONS(3510),
    [anon_sym__alignof] = ACTIONS(3510),
    [anon_sym_alignof] = ACTIONS(3510),
    [anon_sym__Alignof] = ACTIONS(3510),
    [anon_sym_offsetof] = ACTIONS(3510),
    [anon_sym__Generic] = ACTIONS(3510),
    [anon_sym_asm] = ACTIONS(3510),
    [anon_sym___asm__] = ACTIONS(3510),
    [anon_sym___asm] = ACTIONS(3510),
    [sym_number_literal] = ACTIONS(3512),
    [anon_sym_L_SQUOTE] = ACTIONS(3512),
    [anon_sym_u_SQUOTE] = ACTIONS(3512),
    [anon_sym_U_SQUOTE] = ACTIONS(3512),
    [anon_sym_u8_SQUOTE] = ACTIONS(3512),
    [anon_sym_SQUOTE] = ACTIONS(3512),
    [anon_sym_L_DQUOTE] = ACTIONS(3512),
    [anon_sym_u_DQUOTE] = ACTIONS(3512),
    [anon_sym_U_DQUOTE] = ACTIONS(3512),
    [anon_sym_u8_DQUOTE] = ACTIONS(3512),
    [anon_sym_DQUOTE] = ACTIONS(3512),
    [sym_true] = ACTIONS(3510),
    [sym_false] = ACTIONS(3510),
    [anon_sym_NULL] = ACTIONS(3510),
    [anon_sym_nullptr] = ACTIONS(3510),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3510),
    [anon_sym_let] = ACTIONS(3510),
    [anon_sym_This] = ACTIONS(3510),
    [anon_sym_decltype] = ACTIONS(3510),
    [anon_sym_typename] = ACTIONS(3510),
    [anon_sym_template] = ACTIONS(3510),
    [anon_sym_try] = ACTIONS(3510),
    [anon_sym_delete] = ACTIONS(3510),
    [anon_sym_throw] = ACTIONS(3510),
    [anon_sym_co_return] = ACTIONS(3510),
    [anon_sym_co_yield] = ACTIONS(3510),
    [anon_sym_R_DQUOTE] = ACTIONS(3512),
    [anon_sym_LR_DQUOTE] = ACTIONS(3512),
    [anon_sym_uR_DQUOTE] = ACTIONS(3512),
    [anon_sym_UR_DQUOTE] = ACTIONS(3512),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3512),
    [anon_sym_co_await] = ACTIONS(3510),
    [anon_sym_new] = ACTIONS(3510),
    [anon_sym_requires] = ACTIONS(3510),
    [sym_this] = ACTIONS(3510),
    [anon_sym_discard] = ACTIONS(3510),
    [anon_sym_precise] = ACTIONS(3510),
    [anon_sym_shared] = ACTIONS(3510),
    [anon_sym_groupshared] = ACTIONS(3510),
    [anon_sym_uniform] = ACTIONS(3510),
    [anon_sym_row_major] = ACTIONS(3510),
    [anon_sym_column_major] = ACTIONS(3510),
    [anon_sym_globallycoherent] = ACTIONS(3510),
    [anon_sym_centroid] = ACTIONS(3510),
    [anon_sym_noperspective] = ACTIONS(3510),
    [anon_sym_nointerpolation] = ACTIONS(3510),
    [anon_sym_sample] = ACTIONS(3510),
    [anon_sym_linear] = ACTIONS(3510),
    [anon_sym_snorm] = ACTIONS(3510),
    [anon_sym_unorm] = ACTIONS(3510),
    [anon_sym_point] = ACTIONS(3510),
    [anon_sym_line] = ACTIONS(3510),
    [anon_sym_triangleadj] = ACTIONS(3510),
    [anon_sym_lineadj] = ACTIONS(3510),
    [anon_sym_triangle] = ACTIONS(3510),
    [anon_sym_cbuffer] = ACTIONS(3510),
    [anon_sym_interface] = ACTIONS(3510),
    [anon_sym_extension] = ACTIONS(3510),
  },
  [1365] = {
    [sym_identifier] = ACTIONS(3417),
    [anon_sym_LPAREN2] = ACTIONS(3415),
    [anon_sym_BANG] = ACTIONS(3415),
    [anon_sym_TILDE] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_STAR] = ACTIONS(3415),
    [anon_sym_AMP] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym___extension__] = ACTIONS(3417),
    [anon_sym_typedef] = ACTIONS(3417),
    [anon_sym_in] = ACTIONS(3417),
    [anon_sym_out] = ACTIONS(3417),
    [anon_sym_inout] = ACTIONS(3417),
    [anon_sym_virtual] = ACTIONS(3417),
    [anon_sym_extern] = ACTIONS(3417),
    [anon_sym___attribute__] = ACTIONS(3417),
    [anon_sym___attribute] = ACTIONS(3417),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3415),
    [anon_sym___declspec] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3415),
    [anon_sym_signed] = ACTIONS(3417),
    [anon_sym_unsigned] = ACTIONS(3417),
    [anon_sym_long] = ACTIONS(3417),
    [anon_sym_short] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_static] = ACTIONS(3417),
    [anon_sym_register] = ACTIONS(3417),
    [anon_sym_inline] = ACTIONS(3417),
    [anon_sym___inline] = ACTIONS(3417),
    [anon_sym___inline__] = ACTIONS(3417),
    [anon_sym___forceinline] = ACTIONS(3417),
    [anon_sym_thread_local] = ACTIONS(3417),
    [anon_sym___thread] = ACTIONS(3417),
    [anon_sym_const] = ACTIONS(3417),
    [anon_sym_constexpr] = ACTIONS(3417),
    [anon_sym_volatile] = ACTIONS(3417),
    [anon_sym_restrict] = ACTIONS(3417),
    [anon_sym___restrict__] = ACTIONS(3417),
    [anon_sym__Atomic] = ACTIONS(3417),
    [anon_sym__Noreturn] = ACTIONS(3417),
    [anon_sym_noreturn] = ACTIONS(3417),
    [anon_sym__Nonnull] = ACTIONS(3417),
    [anon_sym_mutable] = ACTIONS(3417),
    [anon_sym_constinit] = ACTIONS(3417),
    [anon_sym_consteval] = ACTIONS(3417),
    [anon_sym_alignas] = ACTIONS(3417),
    [anon_sym__Alignas] = ACTIONS(3417),
    [sym_primitive_type] = ACTIONS(3417),
    [anon_sym_enum] = ACTIONS(3417),
    [anon_sym_class] = ACTIONS(3417),
    [anon_sym_struct] = ACTIONS(3417),
    [anon_sym_union] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_else] = ACTIONS(3417),
    [anon_sym_switch] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_break] = ACTIONS(3417),
    [anon_sym_continue] = ACTIONS(3417),
    [anon_sym_goto] = ACTIONS(3417),
    [anon_sym___try] = ACTIONS(3417),
    [anon_sym___leave] = ACTIONS(3417),
    [anon_sym_not] = ACTIONS(3417),
    [anon_sym_compl] = ACTIONS(3417),
    [anon_sym_DASH_DASH] = ACTIONS(3415),
    [anon_sym_PLUS_PLUS] = ACTIONS(3415),
    [anon_sym_sizeof] = ACTIONS(3417),
    [anon_sym___alignof__] = ACTIONS(3417),
    [anon_sym___alignof] = ACTIONS(3417),
    [anon_sym__alignof] = ACTIONS(3417),
    [anon_sym_alignof] = ACTIONS(3417),
    [anon_sym__Alignof] = ACTIONS(3417),
    [anon_sym_offsetof] = ACTIONS(3417),
    [anon_sym__Generic] = ACTIONS(3417),
    [anon_sym_asm] = ACTIONS(3417),
    [anon_sym___asm__] = ACTIONS(3417),
    [anon_sym___asm] = ACTIONS(3417),
    [sym_number_literal] = ACTIONS(3415),
    [anon_sym_L_SQUOTE] = ACTIONS(3415),
    [anon_sym_u_SQUOTE] = ACTIONS(3415),
    [anon_sym_U_SQUOTE] = ACTIONS(3415),
    [anon_sym_u8_SQUOTE] = ACTIONS(3415),
    [anon_sym_SQUOTE] = ACTIONS(3415),
    [anon_sym_L_DQUOTE] = ACTIONS(3415),
    [anon_sym_u_DQUOTE] = ACTIONS(3415),
    [anon_sym_U_DQUOTE] = ACTIONS(3415),
    [anon_sym_u8_DQUOTE] = ACTIONS(3415),
    [anon_sym_DQUOTE] = ACTIONS(3415),
    [sym_true] = ACTIONS(3417),
    [sym_false] = ACTIONS(3417),
    [anon_sym_NULL] = ACTIONS(3417),
    [anon_sym_nullptr] = ACTIONS(3417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_This] = ACTIONS(3417),
    [anon_sym_decltype] = ACTIONS(3417),
    [anon_sym_typename] = ACTIONS(3417),
    [anon_sym_template] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_delete] = ACTIONS(3417),
    [anon_sym_throw] = ACTIONS(3417),
    [anon_sym_co_return] = ACTIONS(3417),
    [anon_sym_co_yield] = ACTIONS(3417),
    [anon_sym_R_DQUOTE] = ACTIONS(3415),
    [anon_sym_LR_DQUOTE] = ACTIONS(3415),
    [anon_sym_uR_DQUOTE] = ACTIONS(3415),
    [anon_sym_UR_DQUOTE] = ACTIONS(3415),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3415),
    [anon_sym_co_await] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_requires] = ACTIONS(3417),
    [sym_this] = ACTIONS(3417),
    [anon_sym_discard] = ACTIONS(3417),
    [anon_sym_precise] = ACTIONS(3417),
    [anon_sym_shared] = ACTIONS(3417),
    [anon_sym_groupshared] = ACTIONS(3417),
    [anon_sym_uniform] = ACTIONS(3417),
    [anon_sym_row_major] = ACTIONS(3417),
    [anon_sym_column_major] = ACTIONS(3417),
    [anon_sym_globallycoherent] = ACTIONS(3417),
    [anon_sym_centroid] = ACTIONS(3417),
    [anon_sym_noperspective] = ACTIONS(3417),
    [anon_sym_nointerpolation] = ACTIONS(3417),
    [anon_sym_sample] = ACTIONS(3417),
    [anon_sym_linear] = ACTIONS(3417),
    [anon_sym_snorm] = ACTIONS(3417),
    [anon_sym_unorm] = ACTIONS(3417),
    [anon_sym_point] = ACTIONS(3417),
    [anon_sym_line] = ACTIONS(3417),
    [anon_sym_triangleadj] = ACTIONS(3417),
    [anon_sym_lineadj] = ACTIONS(3417),
    [anon_sym_triangle] = ACTIONS(3417),
    [anon_sym_cbuffer] = ACTIONS(3417),
    [anon_sym_interface] = ACTIONS(3417),
    [anon_sym_extension] = ACTIONS(3417),
  },
  [1366] = {
    [sym_identifier] = ACTIONS(3444),
    [anon_sym_LPAREN2] = ACTIONS(3442),
    [anon_sym_BANG] = ACTIONS(3442),
    [anon_sym_TILDE] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3444),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_STAR] = ACTIONS(3442),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_SEMI] = ACTIONS(3442),
    [anon_sym___extension__] = ACTIONS(3444),
    [anon_sym_typedef] = ACTIONS(3444),
    [anon_sym_in] = ACTIONS(3444),
    [anon_sym_out] = ACTIONS(3444),
    [anon_sym_inout] = ACTIONS(3444),
    [anon_sym_virtual] = ACTIONS(3444),
    [anon_sym_extern] = ACTIONS(3444),
    [anon_sym___attribute__] = ACTIONS(3444),
    [anon_sym___attribute] = ACTIONS(3444),
    [anon_sym_COLON_COLON] = ACTIONS(3442),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3442),
    [anon_sym___declspec] = ACTIONS(3444),
    [anon_sym_LBRACE] = ACTIONS(3442),
    [anon_sym_signed] = ACTIONS(3444),
    [anon_sym_unsigned] = ACTIONS(3444),
    [anon_sym_long] = ACTIONS(3444),
    [anon_sym_short] = ACTIONS(3444),
    [anon_sym_LBRACK] = ACTIONS(3444),
    [anon_sym_static] = ACTIONS(3444),
    [anon_sym_register] = ACTIONS(3444),
    [anon_sym_inline] = ACTIONS(3444),
    [anon_sym___inline] = ACTIONS(3444),
    [anon_sym___inline__] = ACTIONS(3444),
    [anon_sym___forceinline] = ACTIONS(3444),
    [anon_sym_thread_local] = ACTIONS(3444),
    [anon_sym___thread] = ACTIONS(3444),
    [anon_sym_const] = ACTIONS(3444),
    [anon_sym_constexpr] = ACTIONS(3444),
    [anon_sym_volatile] = ACTIONS(3444),
    [anon_sym_restrict] = ACTIONS(3444),
    [anon_sym___restrict__] = ACTIONS(3444),
    [anon_sym__Atomic] = ACTIONS(3444),
    [anon_sym__Noreturn] = ACTIONS(3444),
    [anon_sym_noreturn] = ACTIONS(3444),
    [anon_sym__Nonnull] = ACTIONS(3444),
    [anon_sym_mutable] = ACTIONS(3444),
    [anon_sym_constinit] = ACTIONS(3444),
    [anon_sym_consteval] = ACTIONS(3444),
    [anon_sym_alignas] = ACTIONS(3444),
    [anon_sym__Alignas] = ACTIONS(3444),
    [sym_primitive_type] = ACTIONS(3444),
    [anon_sym_enum] = ACTIONS(3444),
    [anon_sym_class] = ACTIONS(3444),
    [anon_sym_struct] = ACTIONS(3444),
    [anon_sym_union] = ACTIONS(3444),
    [anon_sym_if] = ACTIONS(3444),
    [anon_sym_else] = ACTIONS(3444),
    [anon_sym_switch] = ACTIONS(3444),
    [anon_sym_while] = ACTIONS(3444),
    [anon_sym_do] = ACTIONS(3444),
    [anon_sym_for] = ACTIONS(3444),
    [anon_sym_return] = ACTIONS(3444),
    [anon_sym_break] = ACTIONS(3444),
    [anon_sym_continue] = ACTIONS(3444),
    [anon_sym_goto] = ACTIONS(3444),
    [anon_sym___try] = ACTIONS(3444),
    [anon_sym___leave] = ACTIONS(3444),
    [anon_sym_not] = ACTIONS(3444),
    [anon_sym_compl] = ACTIONS(3444),
    [anon_sym_DASH_DASH] = ACTIONS(3442),
    [anon_sym_PLUS_PLUS] = ACTIONS(3442),
    [anon_sym_sizeof] = ACTIONS(3444),
    [anon_sym___alignof__] = ACTIONS(3444),
    [anon_sym___alignof] = ACTIONS(3444),
    [anon_sym__alignof] = ACTIONS(3444),
    [anon_sym_alignof] = ACTIONS(3444),
    [anon_sym__Alignof] = ACTIONS(3444),
    [anon_sym_offsetof] = ACTIONS(3444),
    [anon_sym__Generic] = ACTIONS(3444),
    [anon_sym_asm] = ACTIONS(3444),
    [anon_sym___asm__] = ACTIONS(3444),
    [anon_sym___asm] = ACTIONS(3444),
    [sym_number_literal] = ACTIONS(3442),
    [anon_sym_L_SQUOTE] = ACTIONS(3442),
    [anon_sym_u_SQUOTE] = ACTIONS(3442),
    [anon_sym_U_SQUOTE] = ACTIONS(3442),
    [anon_sym_u8_SQUOTE] = ACTIONS(3442),
    [anon_sym_SQUOTE] = ACTIONS(3442),
    [anon_sym_L_DQUOTE] = ACTIONS(3442),
    [anon_sym_u_DQUOTE] = ACTIONS(3442),
    [anon_sym_U_DQUOTE] = ACTIONS(3442),
    [anon_sym_u8_DQUOTE] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(3442),
    [sym_true] = ACTIONS(3444),
    [sym_false] = ACTIONS(3444),
    [anon_sym_NULL] = ACTIONS(3444),
    [anon_sym_nullptr] = ACTIONS(3444),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3444),
    [anon_sym_let] = ACTIONS(3444),
    [anon_sym_This] = ACTIONS(3444),
    [anon_sym_decltype] = ACTIONS(3444),
    [anon_sym_typename] = ACTIONS(3444),
    [anon_sym_template] = ACTIONS(3444),
    [anon_sym_try] = ACTIONS(3444),
    [anon_sym_delete] = ACTIONS(3444),
    [anon_sym_throw] = ACTIONS(3444),
    [anon_sym_co_return] = ACTIONS(3444),
    [anon_sym_co_yield] = ACTIONS(3444),
    [anon_sym_R_DQUOTE] = ACTIONS(3442),
    [anon_sym_LR_DQUOTE] = ACTIONS(3442),
    [anon_sym_uR_DQUOTE] = ACTIONS(3442),
    [anon_sym_UR_DQUOTE] = ACTIONS(3442),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3442),
    [anon_sym_co_await] = ACTIONS(3444),
    [anon_sym_new] = ACTIONS(3444),
    [anon_sym_requires] = ACTIONS(3444),
    [sym_this] = ACTIONS(3444),
    [anon_sym_discard] = ACTIONS(3444),
    [anon_sym_precise] = ACTIONS(3444),
    [anon_sym_shared] = ACTIONS(3444),
    [anon_sym_groupshared] = ACTIONS(3444),
    [anon_sym_uniform] = ACTIONS(3444),
    [anon_sym_row_major] = ACTIONS(3444),
    [anon_sym_column_major] = ACTIONS(3444),
    [anon_sym_globallycoherent] = ACTIONS(3444),
    [anon_sym_centroid] = ACTIONS(3444),
    [anon_sym_noperspective] = ACTIONS(3444),
    [anon_sym_nointerpolation] = ACTIONS(3444),
    [anon_sym_sample] = ACTIONS(3444),
    [anon_sym_linear] = ACTIONS(3444),
    [anon_sym_snorm] = ACTIONS(3444),
    [anon_sym_unorm] = ACTIONS(3444),
    [anon_sym_point] = ACTIONS(3444),
    [anon_sym_line] = ACTIONS(3444),
    [anon_sym_triangleadj] = ACTIONS(3444),
    [anon_sym_lineadj] = ACTIONS(3444),
    [anon_sym_triangle] = ACTIONS(3444),
    [anon_sym_cbuffer] = ACTIONS(3444),
    [anon_sym_interface] = ACTIONS(3444),
    [anon_sym_extension] = ACTIONS(3444),
  },
  [1367] = {
    [sym_identifier] = ACTIONS(3448),
    [anon_sym_LPAREN2] = ACTIONS(3446),
    [anon_sym_BANG] = ACTIONS(3446),
    [anon_sym_TILDE] = ACTIONS(3446),
    [anon_sym_DASH] = ACTIONS(3448),
    [anon_sym_PLUS] = ACTIONS(3448),
    [anon_sym_STAR] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_SEMI] = ACTIONS(3446),
    [anon_sym___extension__] = ACTIONS(3448),
    [anon_sym_typedef] = ACTIONS(3448),
    [anon_sym_in] = ACTIONS(3448),
    [anon_sym_out] = ACTIONS(3448),
    [anon_sym_inout] = ACTIONS(3448),
    [anon_sym_virtual] = ACTIONS(3448),
    [anon_sym_extern] = ACTIONS(3448),
    [anon_sym___attribute__] = ACTIONS(3448),
    [anon_sym___attribute] = ACTIONS(3448),
    [anon_sym_COLON_COLON] = ACTIONS(3446),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3446),
    [anon_sym___declspec] = ACTIONS(3448),
    [anon_sym_LBRACE] = ACTIONS(3446),
    [anon_sym_signed] = ACTIONS(3448),
    [anon_sym_unsigned] = ACTIONS(3448),
    [anon_sym_long] = ACTIONS(3448),
    [anon_sym_short] = ACTIONS(3448),
    [anon_sym_LBRACK] = ACTIONS(3448),
    [anon_sym_static] = ACTIONS(3448),
    [anon_sym_register] = ACTIONS(3448),
    [anon_sym_inline] = ACTIONS(3448),
    [anon_sym___inline] = ACTIONS(3448),
    [anon_sym___inline__] = ACTIONS(3448),
    [anon_sym___forceinline] = ACTIONS(3448),
    [anon_sym_thread_local] = ACTIONS(3448),
    [anon_sym___thread] = ACTIONS(3448),
    [anon_sym_const] = ACTIONS(3448),
    [anon_sym_constexpr] = ACTIONS(3448),
    [anon_sym_volatile] = ACTIONS(3448),
    [anon_sym_restrict] = ACTIONS(3448),
    [anon_sym___restrict__] = ACTIONS(3448),
    [anon_sym__Atomic] = ACTIONS(3448),
    [anon_sym__Noreturn] = ACTIONS(3448),
    [anon_sym_noreturn] = ACTIONS(3448),
    [anon_sym__Nonnull] = ACTIONS(3448),
    [anon_sym_mutable] = ACTIONS(3448),
    [anon_sym_constinit] = ACTIONS(3448),
    [anon_sym_consteval] = ACTIONS(3448),
    [anon_sym_alignas] = ACTIONS(3448),
    [anon_sym__Alignas] = ACTIONS(3448),
    [sym_primitive_type] = ACTIONS(3448),
    [anon_sym_enum] = ACTIONS(3448),
    [anon_sym_class] = ACTIONS(3448),
    [anon_sym_struct] = ACTIONS(3448),
    [anon_sym_union] = ACTIONS(3448),
    [anon_sym_if] = ACTIONS(3448),
    [anon_sym_else] = ACTIONS(3448),
    [anon_sym_switch] = ACTIONS(3448),
    [anon_sym_while] = ACTIONS(3448),
    [anon_sym_do] = ACTIONS(3448),
    [anon_sym_for] = ACTIONS(3448),
    [anon_sym_return] = ACTIONS(3448),
    [anon_sym_break] = ACTIONS(3448),
    [anon_sym_continue] = ACTIONS(3448),
    [anon_sym_goto] = ACTIONS(3448),
    [anon_sym___try] = ACTIONS(3448),
    [anon_sym___leave] = ACTIONS(3448),
    [anon_sym_not] = ACTIONS(3448),
    [anon_sym_compl] = ACTIONS(3448),
    [anon_sym_DASH_DASH] = ACTIONS(3446),
    [anon_sym_PLUS_PLUS] = ACTIONS(3446),
    [anon_sym_sizeof] = ACTIONS(3448),
    [anon_sym___alignof__] = ACTIONS(3448),
    [anon_sym___alignof] = ACTIONS(3448),
    [anon_sym__alignof] = ACTIONS(3448),
    [anon_sym_alignof] = ACTIONS(3448),
    [anon_sym__Alignof] = ACTIONS(3448),
    [anon_sym_offsetof] = ACTIONS(3448),
    [anon_sym__Generic] = ACTIONS(3448),
    [anon_sym_asm] = ACTIONS(3448),
    [anon_sym___asm__] = ACTIONS(3448),
    [anon_sym___asm] = ACTIONS(3448),
    [sym_number_literal] = ACTIONS(3446),
    [anon_sym_L_SQUOTE] = ACTIONS(3446),
    [anon_sym_u_SQUOTE] = ACTIONS(3446),
    [anon_sym_U_SQUOTE] = ACTIONS(3446),
    [anon_sym_u8_SQUOTE] = ACTIONS(3446),
    [anon_sym_SQUOTE] = ACTIONS(3446),
    [anon_sym_L_DQUOTE] = ACTIONS(3446),
    [anon_sym_u_DQUOTE] = ACTIONS(3446),
    [anon_sym_U_DQUOTE] = ACTIONS(3446),
    [anon_sym_u8_DQUOTE] = ACTIONS(3446),
    [anon_sym_DQUOTE] = ACTIONS(3446),
    [sym_true] = ACTIONS(3448),
    [sym_false] = ACTIONS(3448),
    [anon_sym_NULL] = ACTIONS(3448),
    [anon_sym_nullptr] = ACTIONS(3448),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3448),
    [anon_sym_let] = ACTIONS(3448),
    [anon_sym_This] = ACTIONS(3448),
    [anon_sym_decltype] = ACTIONS(3448),
    [anon_sym_typename] = ACTIONS(3448),
    [anon_sym_template] = ACTIONS(3448),
    [anon_sym_try] = ACTIONS(3448),
    [anon_sym_delete] = ACTIONS(3448),
    [anon_sym_throw] = ACTIONS(3448),
    [anon_sym_co_return] = ACTIONS(3448),
    [anon_sym_co_yield] = ACTIONS(3448),
    [anon_sym_R_DQUOTE] = ACTIONS(3446),
    [anon_sym_LR_DQUOTE] = ACTIONS(3446),
    [anon_sym_uR_DQUOTE] = ACTIONS(3446),
    [anon_sym_UR_DQUOTE] = ACTIONS(3446),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3446),
    [anon_sym_co_await] = ACTIONS(3448),
    [anon_sym_new] = ACTIONS(3448),
    [anon_sym_requires] = ACTIONS(3448),
    [sym_this] = ACTIONS(3448),
    [anon_sym_discard] = ACTIONS(3448),
    [anon_sym_precise] = ACTIONS(3448),
    [anon_sym_shared] = ACTIONS(3448),
    [anon_sym_groupshared] = ACTIONS(3448),
    [anon_sym_uniform] = ACTIONS(3448),
    [anon_sym_row_major] = ACTIONS(3448),
    [anon_sym_column_major] = ACTIONS(3448),
    [anon_sym_globallycoherent] = ACTIONS(3448),
    [anon_sym_centroid] = ACTIONS(3448),
    [anon_sym_noperspective] = ACTIONS(3448),
    [anon_sym_nointerpolation] = ACTIONS(3448),
    [anon_sym_sample] = ACTIONS(3448),
    [anon_sym_linear] = ACTIONS(3448),
    [anon_sym_snorm] = ACTIONS(3448),
    [anon_sym_unorm] = ACTIONS(3448),
    [anon_sym_point] = ACTIONS(3448),
    [anon_sym_line] = ACTIONS(3448),
    [anon_sym_triangleadj] = ACTIONS(3448),
    [anon_sym_lineadj] = ACTIONS(3448),
    [anon_sym_triangle] = ACTIONS(3448),
    [anon_sym_cbuffer] = ACTIONS(3448),
    [anon_sym_interface] = ACTIONS(3448),
    [anon_sym_extension] = ACTIONS(3448),
  },
  [1368] = {
    [sym_identifier] = ACTIONS(3460),
    [anon_sym_LPAREN2] = ACTIONS(3458),
    [anon_sym_BANG] = ACTIONS(3458),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3460),
    [anon_sym_PLUS] = ACTIONS(3460),
    [anon_sym_STAR] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3458),
    [anon_sym_SEMI] = ACTIONS(3458),
    [anon_sym___extension__] = ACTIONS(3460),
    [anon_sym_typedef] = ACTIONS(3460),
    [anon_sym_in] = ACTIONS(3460),
    [anon_sym_out] = ACTIONS(3460),
    [anon_sym_inout] = ACTIONS(3460),
    [anon_sym_virtual] = ACTIONS(3460),
    [anon_sym_extern] = ACTIONS(3460),
    [anon_sym___attribute__] = ACTIONS(3460),
    [anon_sym___attribute] = ACTIONS(3460),
    [anon_sym_COLON_COLON] = ACTIONS(3458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3458),
    [anon_sym___declspec] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(3458),
    [anon_sym_signed] = ACTIONS(3460),
    [anon_sym_unsigned] = ACTIONS(3460),
    [anon_sym_long] = ACTIONS(3460),
    [anon_sym_short] = ACTIONS(3460),
    [anon_sym_LBRACK] = ACTIONS(3460),
    [anon_sym_static] = ACTIONS(3460),
    [anon_sym_register] = ACTIONS(3460),
    [anon_sym_inline] = ACTIONS(3460),
    [anon_sym___inline] = ACTIONS(3460),
    [anon_sym___inline__] = ACTIONS(3460),
    [anon_sym___forceinline] = ACTIONS(3460),
    [anon_sym_thread_local] = ACTIONS(3460),
    [anon_sym___thread] = ACTIONS(3460),
    [anon_sym_const] = ACTIONS(3460),
    [anon_sym_constexpr] = ACTIONS(3460),
    [anon_sym_volatile] = ACTIONS(3460),
    [anon_sym_restrict] = ACTIONS(3460),
    [anon_sym___restrict__] = ACTIONS(3460),
    [anon_sym__Atomic] = ACTIONS(3460),
    [anon_sym__Noreturn] = ACTIONS(3460),
    [anon_sym_noreturn] = ACTIONS(3460),
    [anon_sym__Nonnull] = ACTIONS(3460),
    [anon_sym_mutable] = ACTIONS(3460),
    [anon_sym_constinit] = ACTIONS(3460),
    [anon_sym_consteval] = ACTIONS(3460),
    [anon_sym_alignas] = ACTIONS(3460),
    [anon_sym__Alignas] = ACTIONS(3460),
    [sym_primitive_type] = ACTIONS(3460),
    [anon_sym_enum] = ACTIONS(3460),
    [anon_sym_class] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(3460),
    [anon_sym_union] = ACTIONS(3460),
    [anon_sym_if] = ACTIONS(3460),
    [anon_sym_else] = ACTIONS(3460),
    [anon_sym_switch] = ACTIONS(3460),
    [anon_sym_while] = ACTIONS(3460),
    [anon_sym_do] = ACTIONS(3460),
    [anon_sym_for] = ACTIONS(3460),
    [anon_sym_return] = ACTIONS(3460),
    [anon_sym_break] = ACTIONS(3460),
    [anon_sym_continue] = ACTIONS(3460),
    [anon_sym_goto] = ACTIONS(3460),
    [anon_sym___try] = ACTIONS(3460),
    [anon_sym___leave] = ACTIONS(3460),
    [anon_sym_not] = ACTIONS(3460),
    [anon_sym_compl] = ACTIONS(3460),
    [anon_sym_DASH_DASH] = ACTIONS(3458),
    [anon_sym_PLUS_PLUS] = ACTIONS(3458),
    [anon_sym_sizeof] = ACTIONS(3460),
    [anon_sym___alignof__] = ACTIONS(3460),
    [anon_sym___alignof] = ACTIONS(3460),
    [anon_sym__alignof] = ACTIONS(3460),
    [anon_sym_alignof] = ACTIONS(3460),
    [anon_sym__Alignof] = ACTIONS(3460),
    [anon_sym_offsetof] = ACTIONS(3460),
    [anon_sym__Generic] = ACTIONS(3460),
    [anon_sym_asm] = ACTIONS(3460),
    [anon_sym___asm__] = ACTIONS(3460),
    [anon_sym___asm] = ACTIONS(3460),
    [sym_number_literal] = ACTIONS(3458),
    [anon_sym_L_SQUOTE] = ACTIONS(3458),
    [anon_sym_u_SQUOTE] = ACTIONS(3458),
    [anon_sym_U_SQUOTE] = ACTIONS(3458),
    [anon_sym_u8_SQUOTE] = ACTIONS(3458),
    [anon_sym_SQUOTE] = ACTIONS(3458),
    [anon_sym_L_DQUOTE] = ACTIONS(3458),
    [anon_sym_u_DQUOTE] = ACTIONS(3458),
    [anon_sym_U_DQUOTE] = ACTIONS(3458),
    [anon_sym_u8_DQUOTE] = ACTIONS(3458),
    [anon_sym_DQUOTE] = ACTIONS(3458),
    [sym_true] = ACTIONS(3460),
    [sym_false] = ACTIONS(3460),
    [anon_sym_NULL] = ACTIONS(3460),
    [anon_sym_nullptr] = ACTIONS(3460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3460),
    [anon_sym_let] = ACTIONS(3460),
    [anon_sym_This] = ACTIONS(3460),
    [anon_sym_decltype] = ACTIONS(3460),
    [anon_sym_typename] = ACTIONS(3460),
    [anon_sym_template] = ACTIONS(3460),
    [anon_sym_try] = ACTIONS(3460),
    [anon_sym_delete] = ACTIONS(3460),
    [anon_sym_throw] = ACTIONS(3460),
    [anon_sym_co_return] = ACTIONS(3460),
    [anon_sym_co_yield] = ACTIONS(3460),
    [anon_sym_R_DQUOTE] = ACTIONS(3458),
    [anon_sym_LR_DQUOTE] = ACTIONS(3458),
    [anon_sym_uR_DQUOTE] = ACTIONS(3458),
    [anon_sym_UR_DQUOTE] = ACTIONS(3458),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3458),
    [anon_sym_co_await] = ACTIONS(3460),
    [anon_sym_new] = ACTIONS(3460),
    [anon_sym_requires] = ACTIONS(3460),
    [sym_this] = ACTIONS(3460),
    [anon_sym_discard] = ACTIONS(3460),
    [anon_sym_precise] = ACTIONS(3460),
    [anon_sym_shared] = ACTIONS(3460),
    [anon_sym_groupshared] = ACTIONS(3460),
    [anon_sym_uniform] = ACTIONS(3460),
    [anon_sym_row_major] = ACTIONS(3460),
    [anon_sym_column_major] = ACTIONS(3460),
    [anon_sym_globallycoherent] = ACTIONS(3460),
    [anon_sym_centroid] = ACTIONS(3460),
    [anon_sym_noperspective] = ACTIONS(3460),
    [anon_sym_nointerpolation] = ACTIONS(3460),
    [anon_sym_sample] = ACTIONS(3460),
    [anon_sym_linear] = ACTIONS(3460),
    [anon_sym_snorm] = ACTIONS(3460),
    [anon_sym_unorm] = ACTIONS(3460),
    [anon_sym_point] = ACTIONS(3460),
    [anon_sym_line] = ACTIONS(3460),
    [anon_sym_triangleadj] = ACTIONS(3460),
    [anon_sym_lineadj] = ACTIONS(3460),
    [anon_sym_triangle] = ACTIONS(3460),
    [anon_sym_cbuffer] = ACTIONS(3460),
    [anon_sym_interface] = ACTIONS(3460),
    [anon_sym_extension] = ACTIONS(3460),
  },
  [1369] = {
    [sym_identifier] = ACTIONS(4860),
    [anon_sym_LPAREN2] = ACTIONS(4862),
    [anon_sym_BANG] = ACTIONS(4862),
    [anon_sym_TILDE] = ACTIONS(4862),
    [anon_sym_DASH] = ACTIONS(4860),
    [anon_sym_PLUS] = ACTIONS(4860),
    [anon_sym_STAR] = ACTIONS(4862),
    [anon_sym_AMP] = ACTIONS(4862),
    [anon_sym_SEMI] = ACTIONS(4862),
    [anon_sym___extension__] = ACTIONS(4860),
    [anon_sym_in] = ACTIONS(4860),
    [anon_sym_out] = ACTIONS(4860),
    [anon_sym_inout] = ACTIONS(4860),
    [anon_sym_virtual] = ACTIONS(4860),
    [anon_sym_extern] = ACTIONS(4860),
    [anon_sym___attribute__] = ACTIONS(4860),
    [anon_sym___attribute] = ACTIONS(4860),
    [anon_sym_COLON_COLON] = ACTIONS(4862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4862),
    [anon_sym___declspec] = ACTIONS(4860),
    [anon_sym_LBRACE] = ACTIONS(4862),
    [anon_sym_signed] = ACTIONS(4860),
    [anon_sym_unsigned] = ACTIONS(4860),
    [anon_sym_long] = ACTIONS(4860),
    [anon_sym_short] = ACTIONS(4860),
    [anon_sym_LBRACK] = ACTIONS(4860),
    [anon_sym_static] = ACTIONS(4860),
    [anon_sym_register] = ACTIONS(4860),
    [anon_sym_inline] = ACTIONS(4860),
    [anon_sym___inline] = ACTIONS(4860),
    [anon_sym___inline__] = ACTIONS(4860),
    [anon_sym___forceinline] = ACTIONS(4860),
    [anon_sym_thread_local] = ACTIONS(4860),
    [anon_sym___thread] = ACTIONS(4860),
    [anon_sym_const] = ACTIONS(4860),
    [anon_sym_constexpr] = ACTIONS(4860),
    [anon_sym_volatile] = ACTIONS(4860),
    [anon_sym_restrict] = ACTIONS(4860),
    [anon_sym___restrict__] = ACTIONS(4860),
    [anon_sym__Atomic] = ACTIONS(4860),
    [anon_sym__Noreturn] = ACTIONS(4860),
    [anon_sym_noreturn] = ACTIONS(4860),
    [anon_sym__Nonnull] = ACTIONS(4860),
    [anon_sym_mutable] = ACTIONS(4860),
    [anon_sym_constinit] = ACTIONS(4860),
    [anon_sym_consteval] = ACTIONS(4860),
    [anon_sym_alignas] = ACTIONS(4860),
    [anon_sym__Alignas] = ACTIONS(4860),
    [sym_primitive_type] = ACTIONS(4860),
    [anon_sym_enum] = ACTIONS(4860),
    [anon_sym_class] = ACTIONS(4860),
    [anon_sym_struct] = ACTIONS(4860),
    [anon_sym_union] = ACTIONS(4860),
    [anon_sym_if] = ACTIONS(4860),
    [anon_sym_switch] = ACTIONS(4860),
    [anon_sym_case] = ACTIONS(4860),
    [anon_sym_default] = ACTIONS(4860),
    [anon_sym_while] = ACTIONS(4860),
    [anon_sym_do] = ACTIONS(4860),
    [anon_sym_for] = ACTIONS(4860),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_break] = ACTIONS(4860),
    [anon_sym_continue] = ACTIONS(4860),
    [anon_sym_goto] = ACTIONS(4860),
    [anon_sym___try] = ACTIONS(4860),
    [anon_sym___leave] = ACTIONS(4860),
    [anon_sym_not] = ACTIONS(4860),
    [anon_sym_compl] = ACTIONS(4860),
    [anon_sym_DASH_DASH] = ACTIONS(4862),
    [anon_sym_PLUS_PLUS] = ACTIONS(4862),
    [anon_sym_sizeof] = ACTIONS(4860),
    [anon_sym___alignof__] = ACTIONS(4860),
    [anon_sym___alignof] = ACTIONS(4860),
    [anon_sym__alignof] = ACTIONS(4860),
    [anon_sym_alignof] = ACTIONS(4860),
    [anon_sym__Alignof] = ACTIONS(4860),
    [anon_sym_offsetof] = ACTIONS(4860),
    [anon_sym__Generic] = ACTIONS(4860),
    [anon_sym_asm] = ACTIONS(4860),
    [anon_sym___asm__] = ACTIONS(4860),
    [anon_sym___asm] = ACTIONS(4860),
    [sym_number_literal] = ACTIONS(4862),
    [anon_sym_L_SQUOTE] = ACTIONS(4862),
    [anon_sym_u_SQUOTE] = ACTIONS(4862),
    [anon_sym_U_SQUOTE] = ACTIONS(4862),
    [anon_sym_u8_SQUOTE] = ACTIONS(4862),
    [anon_sym_SQUOTE] = ACTIONS(4862),
    [anon_sym_L_DQUOTE] = ACTIONS(4862),
    [anon_sym_u_DQUOTE] = ACTIONS(4862),
    [anon_sym_U_DQUOTE] = ACTIONS(4862),
    [anon_sym_u8_DQUOTE] = ACTIONS(4862),
    [anon_sym_DQUOTE] = ACTIONS(4862),
    [sym_true] = ACTIONS(4860),
    [sym_false] = ACTIONS(4860),
    [anon_sym_NULL] = ACTIONS(4860),
    [anon_sym_nullptr] = ACTIONS(4860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4860),
    [anon_sym_let] = ACTIONS(4860),
    [anon_sym_This] = ACTIONS(4860),
    [anon_sym_decltype] = ACTIONS(4860),
    [anon_sym_typename] = ACTIONS(4860),
    [anon_sym_template] = ACTIONS(4860),
    [anon_sym_try] = ACTIONS(4860),
    [anon_sym_delete] = ACTIONS(4860),
    [anon_sym_throw] = ACTIONS(4860),
    [anon_sym_co_return] = ACTIONS(4860),
    [anon_sym_co_yield] = ACTIONS(4860),
    [anon_sym_R_DQUOTE] = ACTIONS(4862),
    [anon_sym_LR_DQUOTE] = ACTIONS(4862),
    [anon_sym_uR_DQUOTE] = ACTIONS(4862),
    [anon_sym_UR_DQUOTE] = ACTIONS(4862),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4862),
    [anon_sym_co_await] = ACTIONS(4860),
    [anon_sym_new] = ACTIONS(4860),
    [anon_sym_requires] = ACTIONS(4860),
    [sym_this] = ACTIONS(4860),
    [anon_sym_discard] = ACTIONS(4860),
    [anon_sym_precise] = ACTIONS(4860),
    [anon_sym_shared] = ACTIONS(4860),
    [anon_sym_groupshared] = ACTIONS(4860),
    [anon_sym_uniform] = ACTIONS(4860),
    [anon_sym_row_major] = ACTIONS(4860),
    [anon_sym_column_major] = ACTIONS(4860),
    [anon_sym_globallycoherent] = ACTIONS(4860),
    [anon_sym_centroid] = ACTIONS(4860),
    [anon_sym_noperspective] = ACTIONS(4860),
    [anon_sym_nointerpolation] = ACTIONS(4860),
    [anon_sym_sample] = ACTIONS(4860),
    [anon_sym_linear] = ACTIONS(4860),
    [anon_sym_snorm] = ACTIONS(4860),
    [anon_sym_unorm] = ACTIONS(4860),
    [anon_sym_point] = ACTIONS(4860),
    [anon_sym_line] = ACTIONS(4860),
    [anon_sym_triangleadj] = ACTIONS(4860),
    [anon_sym_lineadj] = ACTIONS(4860),
    [anon_sym_triangle] = ACTIONS(4860),
    [anon_sym_cbuffer] = ACTIONS(4860),
    [anon_sym_interface] = ACTIONS(4860),
    [anon_sym_extension] = ACTIONS(4860),
  },
  [1370] = {
    [sym_identifier] = ACTIONS(3655),
    [anon_sym_LPAREN2] = ACTIONS(3653),
    [anon_sym_BANG] = ACTIONS(3653),
    [anon_sym_TILDE] = ACTIONS(3653),
    [anon_sym_DASH] = ACTIONS(3655),
    [anon_sym_PLUS] = ACTIONS(3655),
    [anon_sym_STAR] = ACTIONS(3653),
    [anon_sym_AMP] = ACTIONS(3653),
    [anon_sym_SEMI] = ACTIONS(3653),
    [anon_sym___extension__] = ACTIONS(3655),
    [anon_sym_typedef] = ACTIONS(3655),
    [anon_sym_in] = ACTIONS(3655),
    [anon_sym_out] = ACTIONS(3655),
    [anon_sym_inout] = ACTIONS(3655),
    [anon_sym_virtual] = ACTIONS(3655),
    [anon_sym_extern] = ACTIONS(3655),
    [anon_sym___attribute__] = ACTIONS(3655),
    [anon_sym___attribute] = ACTIONS(3655),
    [anon_sym_COLON_COLON] = ACTIONS(3653),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3653),
    [anon_sym___declspec] = ACTIONS(3655),
    [anon_sym_LBRACE] = ACTIONS(3653),
    [anon_sym_signed] = ACTIONS(3655),
    [anon_sym_unsigned] = ACTIONS(3655),
    [anon_sym_long] = ACTIONS(3655),
    [anon_sym_short] = ACTIONS(3655),
    [anon_sym_LBRACK] = ACTIONS(3655),
    [anon_sym_static] = ACTIONS(3655),
    [anon_sym_register] = ACTIONS(3655),
    [anon_sym_inline] = ACTIONS(3655),
    [anon_sym___inline] = ACTIONS(3655),
    [anon_sym___inline__] = ACTIONS(3655),
    [anon_sym___forceinline] = ACTIONS(3655),
    [anon_sym_thread_local] = ACTIONS(3655),
    [anon_sym___thread] = ACTIONS(3655),
    [anon_sym_const] = ACTIONS(3655),
    [anon_sym_constexpr] = ACTIONS(3655),
    [anon_sym_volatile] = ACTIONS(3655),
    [anon_sym_restrict] = ACTIONS(3655),
    [anon_sym___restrict__] = ACTIONS(3655),
    [anon_sym__Atomic] = ACTIONS(3655),
    [anon_sym__Noreturn] = ACTIONS(3655),
    [anon_sym_noreturn] = ACTIONS(3655),
    [anon_sym__Nonnull] = ACTIONS(3655),
    [anon_sym_mutable] = ACTIONS(3655),
    [anon_sym_constinit] = ACTIONS(3655),
    [anon_sym_consteval] = ACTIONS(3655),
    [anon_sym_alignas] = ACTIONS(3655),
    [anon_sym__Alignas] = ACTIONS(3655),
    [sym_primitive_type] = ACTIONS(3655),
    [anon_sym_enum] = ACTIONS(3655),
    [anon_sym_class] = ACTIONS(3655),
    [anon_sym_struct] = ACTIONS(3655),
    [anon_sym_union] = ACTIONS(3655),
    [anon_sym_if] = ACTIONS(3655),
    [anon_sym_else] = ACTIONS(3655),
    [anon_sym_switch] = ACTIONS(3655),
    [anon_sym_while] = ACTIONS(3655),
    [anon_sym_do] = ACTIONS(3655),
    [anon_sym_for] = ACTIONS(3655),
    [anon_sym_return] = ACTIONS(3655),
    [anon_sym_break] = ACTIONS(3655),
    [anon_sym_continue] = ACTIONS(3655),
    [anon_sym_goto] = ACTIONS(3655),
    [anon_sym___try] = ACTIONS(3655),
    [anon_sym___leave] = ACTIONS(3655),
    [anon_sym_not] = ACTIONS(3655),
    [anon_sym_compl] = ACTIONS(3655),
    [anon_sym_DASH_DASH] = ACTIONS(3653),
    [anon_sym_PLUS_PLUS] = ACTIONS(3653),
    [anon_sym_sizeof] = ACTIONS(3655),
    [anon_sym___alignof__] = ACTIONS(3655),
    [anon_sym___alignof] = ACTIONS(3655),
    [anon_sym__alignof] = ACTIONS(3655),
    [anon_sym_alignof] = ACTIONS(3655),
    [anon_sym__Alignof] = ACTIONS(3655),
    [anon_sym_offsetof] = ACTIONS(3655),
    [anon_sym__Generic] = ACTIONS(3655),
    [anon_sym_asm] = ACTIONS(3655),
    [anon_sym___asm__] = ACTIONS(3655),
    [anon_sym___asm] = ACTIONS(3655),
    [sym_number_literal] = ACTIONS(3653),
    [anon_sym_L_SQUOTE] = ACTIONS(3653),
    [anon_sym_u_SQUOTE] = ACTIONS(3653),
    [anon_sym_U_SQUOTE] = ACTIONS(3653),
    [anon_sym_u8_SQUOTE] = ACTIONS(3653),
    [anon_sym_SQUOTE] = ACTIONS(3653),
    [anon_sym_L_DQUOTE] = ACTIONS(3653),
    [anon_sym_u_DQUOTE] = ACTIONS(3653),
    [anon_sym_U_DQUOTE] = ACTIONS(3653),
    [anon_sym_u8_DQUOTE] = ACTIONS(3653),
    [anon_sym_DQUOTE] = ACTIONS(3653),
    [sym_true] = ACTIONS(3655),
    [sym_false] = ACTIONS(3655),
    [anon_sym_NULL] = ACTIONS(3655),
    [anon_sym_nullptr] = ACTIONS(3655),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3655),
    [anon_sym_let] = ACTIONS(3655),
    [anon_sym_This] = ACTIONS(3655),
    [anon_sym_decltype] = ACTIONS(3655),
    [anon_sym_typename] = ACTIONS(3655),
    [anon_sym_template] = ACTIONS(3655),
    [anon_sym_try] = ACTIONS(3655),
    [anon_sym_delete] = ACTIONS(3655),
    [anon_sym_throw] = ACTIONS(3655),
    [anon_sym_co_return] = ACTIONS(3655),
    [anon_sym_co_yield] = ACTIONS(3655),
    [anon_sym_R_DQUOTE] = ACTIONS(3653),
    [anon_sym_LR_DQUOTE] = ACTIONS(3653),
    [anon_sym_uR_DQUOTE] = ACTIONS(3653),
    [anon_sym_UR_DQUOTE] = ACTIONS(3653),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3653),
    [anon_sym_co_await] = ACTIONS(3655),
    [anon_sym_new] = ACTIONS(3655),
    [anon_sym_requires] = ACTIONS(3655),
    [sym_this] = ACTIONS(3655),
    [anon_sym_discard] = ACTIONS(3655),
    [anon_sym_precise] = ACTIONS(3655),
    [anon_sym_shared] = ACTIONS(3655),
    [anon_sym_groupshared] = ACTIONS(3655),
    [anon_sym_uniform] = ACTIONS(3655),
    [anon_sym_row_major] = ACTIONS(3655),
    [anon_sym_column_major] = ACTIONS(3655),
    [anon_sym_globallycoherent] = ACTIONS(3655),
    [anon_sym_centroid] = ACTIONS(3655),
    [anon_sym_noperspective] = ACTIONS(3655),
    [anon_sym_nointerpolation] = ACTIONS(3655),
    [anon_sym_sample] = ACTIONS(3655),
    [anon_sym_linear] = ACTIONS(3655),
    [anon_sym_snorm] = ACTIONS(3655),
    [anon_sym_unorm] = ACTIONS(3655),
    [anon_sym_point] = ACTIONS(3655),
    [anon_sym_line] = ACTIONS(3655),
    [anon_sym_triangleadj] = ACTIONS(3655),
    [anon_sym_lineadj] = ACTIONS(3655),
    [anon_sym_triangle] = ACTIONS(3655),
    [anon_sym_cbuffer] = ACTIONS(3655),
    [anon_sym_interface] = ACTIONS(3655),
    [anon_sym_extension] = ACTIONS(3655),
  },
  [1371] = {
    [sym_identifier] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(3587),
    [anon_sym_BANG] = ACTIONS(3587),
    [anon_sym_TILDE] = ACTIONS(3587),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_STAR] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3587),
    [anon_sym_SEMI] = ACTIONS(3587),
    [anon_sym___extension__] = ACTIONS(3585),
    [anon_sym_typedef] = ACTIONS(3585),
    [anon_sym_in] = ACTIONS(3585),
    [anon_sym_out] = ACTIONS(3585),
    [anon_sym_inout] = ACTIONS(3585),
    [anon_sym_virtual] = ACTIONS(3585),
    [anon_sym_extern] = ACTIONS(3585),
    [anon_sym___attribute__] = ACTIONS(3585),
    [anon_sym___attribute] = ACTIONS(3585),
    [anon_sym_COLON_COLON] = ACTIONS(3587),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3587),
    [anon_sym___declspec] = ACTIONS(3585),
    [anon_sym_LBRACE] = ACTIONS(3587),
    [anon_sym_signed] = ACTIONS(3585),
    [anon_sym_unsigned] = ACTIONS(3585),
    [anon_sym_long] = ACTIONS(3585),
    [anon_sym_short] = ACTIONS(3585),
    [anon_sym_LBRACK] = ACTIONS(3585),
    [anon_sym_static] = ACTIONS(3585),
    [anon_sym_register] = ACTIONS(3585),
    [anon_sym_inline] = ACTIONS(3585),
    [anon_sym___inline] = ACTIONS(3585),
    [anon_sym___inline__] = ACTIONS(3585),
    [anon_sym___forceinline] = ACTIONS(3585),
    [anon_sym_thread_local] = ACTIONS(3585),
    [anon_sym___thread] = ACTIONS(3585),
    [anon_sym_const] = ACTIONS(3585),
    [anon_sym_constexpr] = ACTIONS(3585),
    [anon_sym_volatile] = ACTIONS(3585),
    [anon_sym_restrict] = ACTIONS(3585),
    [anon_sym___restrict__] = ACTIONS(3585),
    [anon_sym__Atomic] = ACTIONS(3585),
    [anon_sym__Noreturn] = ACTIONS(3585),
    [anon_sym_noreturn] = ACTIONS(3585),
    [anon_sym__Nonnull] = ACTIONS(3585),
    [anon_sym_mutable] = ACTIONS(3585),
    [anon_sym_constinit] = ACTIONS(3585),
    [anon_sym_consteval] = ACTIONS(3585),
    [anon_sym_alignas] = ACTIONS(3585),
    [anon_sym__Alignas] = ACTIONS(3585),
    [sym_primitive_type] = ACTIONS(3585),
    [anon_sym_enum] = ACTIONS(3585),
    [anon_sym_class] = ACTIONS(3585),
    [anon_sym_struct] = ACTIONS(3585),
    [anon_sym_union] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(3585),
    [anon_sym_else] = ACTIONS(3585),
    [anon_sym_switch] = ACTIONS(3585),
    [anon_sym_while] = ACTIONS(3585),
    [anon_sym_do] = ACTIONS(3585),
    [anon_sym_for] = ACTIONS(3585),
    [anon_sym_return] = ACTIONS(3585),
    [anon_sym_break] = ACTIONS(3585),
    [anon_sym_continue] = ACTIONS(3585),
    [anon_sym_goto] = ACTIONS(3585),
    [anon_sym___try] = ACTIONS(3585),
    [anon_sym___leave] = ACTIONS(3585),
    [anon_sym_not] = ACTIONS(3585),
    [anon_sym_compl] = ACTIONS(3585),
    [anon_sym_DASH_DASH] = ACTIONS(3587),
    [anon_sym_PLUS_PLUS] = ACTIONS(3587),
    [anon_sym_sizeof] = ACTIONS(3585),
    [anon_sym___alignof__] = ACTIONS(3585),
    [anon_sym___alignof] = ACTIONS(3585),
    [anon_sym__alignof] = ACTIONS(3585),
    [anon_sym_alignof] = ACTIONS(3585),
    [anon_sym__Alignof] = ACTIONS(3585),
    [anon_sym_offsetof] = ACTIONS(3585),
    [anon_sym__Generic] = ACTIONS(3585),
    [anon_sym_asm] = ACTIONS(3585),
    [anon_sym___asm__] = ACTIONS(3585),
    [anon_sym___asm] = ACTIONS(3585),
    [sym_number_literal] = ACTIONS(3587),
    [anon_sym_L_SQUOTE] = ACTIONS(3587),
    [anon_sym_u_SQUOTE] = ACTIONS(3587),
    [anon_sym_U_SQUOTE] = ACTIONS(3587),
    [anon_sym_u8_SQUOTE] = ACTIONS(3587),
    [anon_sym_SQUOTE] = ACTIONS(3587),
    [anon_sym_L_DQUOTE] = ACTIONS(3587),
    [anon_sym_u_DQUOTE] = ACTIONS(3587),
    [anon_sym_U_DQUOTE] = ACTIONS(3587),
    [anon_sym_u8_DQUOTE] = ACTIONS(3587),
    [anon_sym_DQUOTE] = ACTIONS(3587),
    [sym_true] = ACTIONS(3585),
    [sym_false] = ACTIONS(3585),
    [anon_sym_NULL] = ACTIONS(3585),
    [anon_sym_nullptr] = ACTIONS(3585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3585),
    [anon_sym_let] = ACTIONS(3585),
    [anon_sym_This] = ACTIONS(3585),
    [anon_sym_decltype] = ACTIONS(3585),
    [anon_sym_typename] = ACTIONS(3585),
    [anon_sym_template] = ACTIONS(3585),
    [anon_sym_try] = ACTIONS(3585),
    [anon_sym_delete] = ACTIONS(3585),
    [anon_sym_throw] = ACTIONS(3585),
    [anon_sym_co_return] = ACTIONS(3585),
    [anon_sym_co_yield] = ACTIONS(3585),
    [anon_sym_R_DQUOTE] = ACTIONS(3587),
    [anon_sym_LR_DQUOTE] = ACTIONS(3587),
    [anon_sym_uR_DQUOTE] = ACTIONS(3587),
    [anon_sym_UR_DQUOTE] = ACTIONS(3587),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3587),
    [anon_sym_co_await] = ACTIONS(3585),
    [anon_sym_new] = ACTIONS(3585),
    [anon_sym_requires] = ACTIONS(3585),
    [sym_this] = ACTIONS(3585),
    [anon_sym_discard] = ACTIONS(3585),
    [anon_sym_precise] = ACTIONS(3585),
    [anon_sym_shared] = ACTIONS(3585),
    [anon_sym_groupshared] = ACTIONS(3585),
    [anon_sym_uniform] = ACTIONS(3585),
    [anon_sym_row_major] = ACTIONS(3585),
    [anon_sym_column_major] = ACTIONS(3585),
    [anon_sym_globallycoherent] = ACTIONS(3585),
    [anon_sym_centroid] = ACTIONS(3585),
    [anon_sym_noperspective] = ACTIONS(3585),
    [anon_sym_nointerpolation] = ACTIONS(3585),
    [anon_sym_sample] = ACTIONS(3585),
    [anon_sym_linear] = ACTIONS(3585),
    [anon_sym_snorm] = ACTIONS(3585),
    [anon_sym_unorm] = ACTIONS(3585),
    [anon_sym_point] = ACTIONS(3585),
    [anon_sym_line] = ACTIONS(3585),
    [anon_sym_triangleadj] = ACTIONS(3585),
    [anon_sym_lineadj] = ACTIONS(3585),
    [anon_sym_triangle] = ACTIONS(3585),
    [anon_sym_cbuffer] = ACTIONS(3585),
    [anon_sym_interface] = ACTIONS(3585),
    [anon_sym_extension] = ACTIONS(3585),
  },
  [1372] = {
    [sym_identifier] = ACTIONS(3593),
    [anon_sym_LPAREN2] = ACTIONS(3595),
    [anon_sym_BANG] = ACTIONS(3595),
    [anon_sym_TILDE] = ACTIONS(3595),
    [anon_sym_DASH] = ACTIONS(3593),
    [anon_sym_PLUS] = ACTIONS(3593),
    [anon_sym_STAR] = ACTIONS(3595),
    [anon_sym_AMP] = ACTIONS(3595),
    [anon_sym_SEMI] = ACTIONS(3595),
    [anon_sym___extension__] = ACTIONS(3593),
    [anon_sym_typedef] = ACTIONS(3593),
    [anon_sym_in] = ACTIONS(3593),
    [anon_sym_out] = ACTIONS(3593),
    [anon_sym_inout] = ACTIONS(3593),
    [anon_sym_virtual] = ACTIONS(3593),
    [anon_sym_extern] = ACTIONS(3593),
    [anon_sym___attribute__] = ACTIONS(3593),
    [anon_sym___attribute] = ACTIONS(3593),
    [anon_sym_COLON_COLON] = ACTIONS(3595),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3595),
    [anon_sym___declspec] = ACTIONS(3593),
    [anon_sym_LBRACE] = ACTIONS(3595),
    [anon_sym_signed] = ACTIONS(3593),
    [anon_sym_unsigned] = ACTIONS(3593),
    [anon_sym_long] = ACTIONS(3593),
    [anon_sym_short] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(3593),
    [anon_sym_static] = ACTIONS(3593),
    [anon_sym_register] = ACTIONS(3593),
    [anon_sym_inline] = ACTIONS(3593),
    [anon_sym___inline] = ACTIONS(3593),
    [anon_sym___inline__] = ACTIONS(3593),
    [anon_sym___forceinline] = ACTIONS(3593),
    [anon_sym_thread_local] = ACTIONS(3593),
    [anon_sym___thread] = ACTIONS(3593),
    [anon_sym_const] = ACTIONS(3593),
    [anon_sym_constexpr] = ACTIONS(3593),
    [anon_sym_volatile] = ACTIONS(3593),
    [anon_sym_restrict] = ACTIONS(3593),
    [anon_sym___restrict__] = ACTIONS(3593),
    [anon_sym__Atomic] = ACTIONS(3593),
    [anon_sym__Noreturn] = ACTIONS(3593),
    [anon_sym_noreturn] = ACTIONS(3593),
    [anon_sym__Nonnull] = ACTIONS(3593),
    [anon_sym_mutable] = ACTIONS(3593),
    [anon_sym_constinit] = ACTIONS(3593),
    [anon_sym_consteval] = ACTIONS(3593),
    [anon_sym_alignas] = ACTIONS(3593),
    [anon_sym__Alignas] = ACTIONS(3593),
    [sym_primitive_type] = ACTIONS(3593),
    [anon_sym_enum] = ACTIONS(3593),
    [anon_sym_class] = ACTIONS(3593),
    [anon_sym_struct] = ACTIONS(3593),
    [anon_sym_union] = ACTIONS(3593),
    [anon_sym_if] = ACTIONS(3593),
    [anon_sym_else] = ACTIONS(3593),
    [anon_sym_switch] = ACTIONS(3593),
    [anon_sym_while] = ACTIONS(3593),
    [anon_sym_do] = ACTIONS(3593),
    [anon_sym_for] = ACTIONS(3593),
    [anon_sym_return] = ACTIONS(3593),
    [anon_sym_break] = ACTIONS(3593),
    [anon_sym_continue] = ACTIONS(3593),
    [anon_sym_goto] = ACTIONS(3593),
    [anon_sym___try] = ACTIONS(3593),
    [anon_sym___leave] = ACTIONS(3593),
    [anon_sym_not] = ACTIONS(3593),
    [anon_sym_compl] = ACTIONS(3593),
    [anon_sym_DASH_DASH] = ACTIONS(3595),
    [anon_sym_PLUS_PLUS] = ACTIONS(3595),
    [anon_sym_sizeof] = ACTIONS(3593),
    [anon_sym___alignof__] = ACTIONS(3593),
    [anon_sym___alignof] = ACTIONS(3593),
    [anon_sym__alignof] = ACTIONS(3593),
    [anon_sym_alignof] = ACTIONS(3593),
    [anon_sym__Alignof] = ACTIONS(3593),
    [anon_sym_offsetof] = ACTIONS(3593),
    [anon_sym__Generic] = ACTIONS(3593),
    [anon_sym_asm] = ACTIONS(3593),
    [anon_sym___asm__] = ACTIONS(3593),
    [anon_sym___asm] = ACTIONS(3593),
    [sym_number_literal] = ACTIONS(3595),
    [anon_sym_L_SQUOTE] = ACTIONS(3595),
    [anon_sym_u_SQUOTE] = ACTIONS(3595),
    [anon_sym_U_SQUOTE] = ACTIONS(3595),
    [anon_sym_u8_SQUOTE] = ACTIONS(3595),
    [anon_sym_SQUOTE] = ACTIONS(3595),
    [anon_sym_L_DQUOTE] = ACTIONS(3595),
    [anon_sym_u_DQUOTE] = ACTIONS(3595),
    [anon_sym_U_DQUOTE] = ACTIONS(3595),
    [anon_sym_u8_DQUOTE] = ACTIONS(3595),
    [anon_sym_DQUOTE] = ACTIONS(3595),
    [sym_true] = ACTIONS(3593),
    [sym_false] = ACTIONS(3593),
    [anon_sym_NULL] = ACTIONS(3593),
    [anon_sym_nullptr] = ACTIONS(3593),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3593),
    [anon_sym_let] = ACTIONS(3593),
    [anon_sym_This] = ACTIONS(3593),
    [anon_sym_decltype] = ACTIONS(3593),
    [anon_sym_typename] = ACTIONS(3593),
    [anon_sym_template] = ACTIONS(3593),
    [anon_sym_try] = ACTIONS(3593),
    [anon_sym_delete] = ACTIONS(3593),
    [anon_sym_throw] = ACTIONS(3593),
    [anon_sym_co_return] = ACTIONS(3593),
    [anon_sym_co_yield] = ACTIONS(3593),
    [anon_sym_R_DQUOTE] = ACTIONS(3595),
    [anon_sym_LR_DQUOTE] = ACTIONS(3595),
    [anon_sym_uR_DQUOTE] = ACTIONS(3595),
    [anon_sym_UR_DQUOTE] = ACTIONS(3595),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3595),
    [anon_sym_co_await] = ACTIONS(3593),
    [anon_sym_new] = ACTIONS(3593),
    [anon_sym_requires] = ACTIONS(3593),
    [sym_this] = ACTIONS(3593),
    [anon_sym_discard] = ACTIONS(3593),
    [anon_sym_precise] = ACTIONS(3593),
    [anon_sym_shared] = ACTIONS(3593),
    [anon_sym_groupshared] = ACTIONS(3593),
    [anon_sym_uniform] = ACTIONS(3593),
    [anon_sym_row_major] = ACTIONS(3593),
    [anon_sym_column_major] = ACTIONS(3593),
    [anon_sym_globallycoherent] = ACTIONS(3593),
    [anon_sym_centroid] = ACTIONS(3593),
    [anon_sym_noperspective] = ACTIONS(3593),
    [anon_sym_nointerpolation] = ACTIONS(3593),
    [anon_sym_sample] = ACTIONS(3593),
    [anon_sym_linear] = ACTIONS(3593),
    [anon_sym_snorm] = ACTIONS(3593),
    [anon_sym_unorm] = ACTIONS(3593),
    [anon_sym_point] = ACTIONS(3593),
    [anon_sym_line] = ACTIONS(3593),
    [anon_sym_triangleadj] = ACTIONS(3593),
    [anon_sym_lineadj] = ACTIONS(3593),
    [anon_sym_triangle] = ACTIONS(3593),
    [anon_sym_cbuffer] = ACTIONS(3593),
    [anon_sym_interface] = ACTIONS(3593),
    [anon_sym_extension] = ACTIONS(3593),
  },
  [1373] = {
    [sym_identifier] = ACTIONS(3456),
    [anon_sym_LPAREN2] = ACTIONS(3454),
    [anon_sym_BANG] = ACTIONS(3454),
    [anon_sym_TILDE] = ACTIONS(3454),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3454),
    [anon_sym_AMP] = ACTIONS(3454),
    [anon_sym_SEMI] = ACTIONS(3454),
    [anon_sym___extension__] = ACTIONS(3456),
    [anon_sym_typedef] = ACTIONS(3456),
    [anon_sym_in] = ACTIONS(3456),
    [anon_sym_out] = ACTIONS(3456),
    [anon_sym_inout] = ACTIONS(3456),
    [anon_sym_virtual] = ACTIONS(3456),
    [anon_sym_extern] = ACTIONS(3456),
    [anon_sym___attribute__] = ACTIONS(3456),
    [anon_sym___attribute] = ACTIONS(3456),
    [anon_sym_COLON_COLON] = ACTIONS(3454),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3454),
    [anon_sym___declspec] = ACTIONS(3456),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_signed] = ACTIONS(3456),
    [anon_sym_unsigned] = ACTIONS(3456),
    [anon_sym_long] = ACTIONS(3456),
    [anon_sym_short] = ACTIONS(3456),
    [anon_sym_LBRACK] = ACTIONS(3456),
    [anon_sym_static] = ACTIONS(3456),
    [anon_sym_register] = ACTIONS(3456),
    [anon_sym_inline] = ACTIONS(3456),
    [anon_sym___inline] = ACTIONS(3456),
    [anon_sym___inline__] = ACTIONS(3456),
    [anon_sym___forceinline] = ACTIONS(3456),
    [anon_sym_thread_local] = ACTIONS(3456),
    [anon_sym___thread] = ACTIONS(3456),
    [anon_sym_const] = ACTIONS(3456),
    [anon_sym_constexpr] = ACTIONS(3456),
    [anon_sym_volatile] = ACTIONS(3456),
    [anon_sym_restrict] = ACTIONS(3456),
    [anon_sym___restrict__] = ACTIONS(3456),
    [anon_sym__Atomic] = ACTIONS(3456),
    [anon_sym__Noreturn] = ACTIONS(3456),
    [anon_sym_noreturn] = ACTIONS(3456),
    [anon_sym__Nonnull] = ACTIONS(3456),
    [anon_sym_mutable] = ACTIONS(3456),
    [anon_sym_constinit] = ACTIONS(3456),
    [anon_sym_consteval] = ACTIONS(3456),
    [anon_sym_alignas] = ACTIONS(3456),
    [anon_sym__Alignas] = ACTIONS(3456),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_enum] = ACTIONS(3456),
    [anon_sym_class] = ACTIONS(3456),
    [anon_sym_struct] = ACTIONS(3456),
    [anon_sym_union] = ACTIONS(3456),
    [anon_sym_if] = ACTIONS(3456),
    [anon_sym_else] = ACTIONS(3456),
    [anon_sym_switch] = ACTIONS(3456),
    [anon_sym_while] = ACTIONS(3456),
    [anon_sym_do] = ACTIONS(3456),
    [anon_sym_for] = ACTIONS(3456),
    [anon_sym_return] = ACTIONS(3456),
    [anon_sym_break] = ACTIONS(3456),
    [anon_sym_continue] = ACTIONS(3456),
    [anon_sym_goto] = ACTIONS(3456),
    [anon_sym___try] = ACTIONS(3456),
    [anon_sym___leave] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(3456),
    [anon_sym_compl] = ACTIONS(3456),
    [anon_sym_DASH_DASH] = ACTIONS(3454),
    [anon_sym_PLUS_PLUS] = ACTIONS(3454),
    [anon_sym_sizeof] = ACTIONS(3456),
    [anon_sym___alignof__] = ACTIONS(3456),
    [anon_sym___alignof] = ACTIONS(3456),
    [anon_sym__alignof] = ACTIONS(3456),
    [anon_sym_alignof] = ACTIONS(3456),
    [anon_sym__Alignof] = ACTIONS(3456),
    [anon_sym_offsetof] = ACTIONS(3456),
    [anon_sym__Generic] = ACTIONS(3456),
    [anon_sym_asm] = ACTIONS(3456),
    [anon_sym___asm__] = ACTIONS(3456),
    [anon_sym___asm] = ACTIONS(3456),
    [sym_number_literal] = ACTIONS(3454),
    [anon_sym_L_SQUOTE] = ACTIONS(3454),
    [anon_sym_u_SQUOTE] = ACTIONS(3454),
    [anon_sym_U_SQUOTE] = ACTIONS(3454),
    [anon_sym_u8_SQUOTE] = ACTIONS(3454),
    [anon_sym_SQUOTE] = ACTIONS(3454),
    [anon_sym_L_DQUOTE] = ACTIONS(3454),
    [anon_sym_u_DQUOTE] = ACTIONS(3454),
    [anon_sym_U_DQUOTE] = ACTIONS(3454),
    [anon_sym_u8_DQUOTE] = ACTIONS(3454),
    [anon_sym_DQUOTE] = ACTIONS(3454),
    [sym_true] = ACTIONS(3456),
    [sym_false] = ACTIONS(3456),
    [anon_sym_NULL] = ACTIONS(3456),
    [anon_sym_nullptr] = ACTIONS(3456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3456),
    [anon_sym_let] = ACTIONS(3456),
    [anon_sym_This] = ACTIONS(3456),
    [anon_sym_decltype] = ACTIONS(3456),
    [anon_sym_typename] = ACTIONS(3456),
    [anon_sym_template] = ACTIONS(3456),
    [anon_sym_try] = ACTIONS(3456),
    [anon_sym_delete] = ACTIONS(3456),
    [anon_sym_throw] = ACTIONS(3456),
    [anon_sym_co_return] = ACTIONS(3456),
    [anon_sym_co_yield] = ACTIONS(3456),
    [anon_sym_R_DQUOTE] = ACTIONS(3454),
    [anon_sym_LR_DQUOTE] = ACTIONS(3454),
    [anon_sym_uR_DQUOTE] = ACTIONS(3454),
    [anon_sym_UR_DQUOTE] = ACTIONS(3454),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3454),
    [anon_sym_co_await] = ACTIONS(3456),
    [anon_sym_new] = ACTIONS(3456),
    [anon_sym_requires] = ACTIONS(3456),
    [sym_this] = ACTIONS(3456),
    [anon_sym_discard] = ACTIONS(3456),
    [anon_sym_precise] = ACTIONS(3456),
    [anon_sym_shared] = ACTIONS(3456),
    [anon_sym_groupshared] = ACTIONS(3456),
    [anon_sym_uniform] = ACTIONS(3456),
    [anon_sym_row_major] = ACTIONS(3456),
    [anon_sym_column_major] = ACTIONS(3456),
    [anon_sym_globallycoherent] = ACTIONS(3456),
    [anon_sym_centroid] = ACTIONS(3456),
    [anon_sym_noperspective] = ACTIONS(3456),
    [anon_sym_nointerpolation] = ACTIONS(3456),
    [anon_sym_sample] = ACTIONS(3456),
    [anon_sym_linear] = ACTIONS(3456),
    [anon_sym_snorm] = ACTIONS(3456),
    [anon_sym_unorm] = ACTIONS(3456),
    [anon_sym_point] = ACTIONS(3456),
    [anon_sym_line] = ACTIONS(3456),
    [anon_sym_triangleadj] = ACTIONS(3456),
    [anon_sym_lineadj] = ACTIONS(3456),
    [anon_sym_triangle] = ACTIONS(3456),
    [anon_sym_cbuffer] = ACTIONS(3456),
    [anon_sym_interface] = ACTIONS(3456),
    [anon_sym_extension] = ACTIONS(3456),
  },
  [1374] = {
    [sym_identifier] = ACTIONS(3520),
    [anon_sym_LPAREN2] = ACTIONS(3518),
    [anon_sym_BANG] = ACTIONS(3518),
    [anon_sym_TILDE] = ACTIONS(3518),
    [anon_sym_DASH] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3520),
    [anon_sym_STAR] = ACTIONS(3518),
    [anon_sym_AMP] = ACTIONS(3518),
    [anon_sym_SEMI] = ACTIONS(3518),
    [anon_sym___extension__] = ACTIONS(3520),
    [anon_sym_typedef] = ACTIONS(3520),
    [anon_sym_in] = ACTIONS(3520),
    [anon_sym_out] = ACTIONS(3520),
    [anon_sym_inout] = ACTIONS(3520),
    [anon_sym_virtual] = ACTIONS(3520),
    [anon_sym_extern] = ACTIONS(3520),
    [anon_sym___attribute__] = ACTIONS(3520),
    [anon_sym___attribute] = ACTIONS(3520),
    [anon_sym_COLON_COLON] = ACTIONS(3518),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3518),
    [anon_sym___declspec] = ACTIONS(3520),
    [anon_sym_LBRACE] = ACTIONS(3518),
    [anon_sym_signed] = ACTIONS(3520),
    [anon_sym_unsigned] = ACTIONS(3520),
    [anon_sym_long] = ACTIONS(3520),
    [anon_sym_short] = ACTIONS(3520),
    [anon_sym_LBRACK] = ACTIONS(3520),
    [anon_sym_static] = ACTIONS(3520),
    [anon_sym_register] = ACTIONS(3520),
    [anon_sym_inline] = ACTIONS(3520),
    [anon_sym___inline] = ACTIONS(3520),
    [anon_sym___inline__] = ACTIONS(3520),
    [anon_sym___forceinline] = ACTIONS(3520),
    [anon_sym_thread_local] = ACTIONS(3520),
    [anon_sym___thread] = ACTIONS(3520),
    [anon_sym_const] = ACTIONS(3520),
    [anon_sym_constexpr] = ACTIONS(3520),
    [anon_sym_volatile] = ACTIONS(3520),
    [anon_sym_restrict] = ACTIONS(3520),
    [anon_sym___restrict__] = ACTIONS(3520),
    [anon_sym__Atomic] = ACTIONS(3520),
    [anon_sym__Noreturn] = ACTIONS(3520),
    [anon_sym_noreturn] = ACTIONS(3520),
    [anon_sym__Nonnull] = ACTIONS(3520),
    [anon_sym_mutable] = ACTIONS(3520),
    [anon_sym_constinit] = ACTIONS(3520),
    [anon_sym_consteval] = ACTIONS(3520),
    [anon_sym_alignas] = ACTIONS(3520),
    [anon_sym__Alignas] = ACTIONS(3520),
    [sym_primitive_type] = ACTIONS(3520),
    [anon_sym_enum] = ACTIONS(3520),
    [anon_sym_class] = ACTIONS(3520),
    [anon_sym_struct] = ACTIONS(3520),
    [anon_sym_union] = ACTIONS(3520),
    [anon_sym_if] = ACTIONS(3520),
    [anon_sym_else] = ACTIONS(3520),
    [anon_sym_switch] = ACTIONS(3520),
    [anon_sym_while] = ACTIONS(3520),
    [anon_sym_do] = ACTIONS(3520),
    [anon_sym_for] = ACTIONS(3520),
    [anon_sym_return] = ACTIONS(3520),
    [anon_sym_break] = ACTIONS(3520),
    [anon_sym_continue] = ACTIONS(3520),
    [anon_sym_goto] = ACTIONS(3520),
    [anon_sym___try] = ACTIONS(3520),
    [anon_sym___leave] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3520),
    [anon_sym_compl] = ACTIONS(3520),
    [anon_sym_DASH_DASH] = ACTIONS(3518),
    [anon_sym_PLUS_PLUS] = ACTIONS(3518),
    [anon_sym_sizeof] = ACTIONS(3520),
    [anon_sym___alignof__] = ACTIONS(3520),
    [anon_sym___alignof] = ACTIONS(3520),
    [anon_sym__alignof] = ACTIONS(3520),
    [anon_sym_alignof] = ACTIONS(3520),
    [anon_sym__Alignof] = ACTIONS(3520),
    [anon_sym_offsetof] = ACTIONS(3520),
    [anon_sym__Generic] = ACTIONS(3520),
    [anon_sym_asm] = ACTIONS(3520),
    [anon_sym___asm__] = ACTIONS(3520),
    [anon_sym___asm] = ACTIONS(3520),
    [sym_number_literal] = ACTIONS(3518),
    [anon_sym_L_SQUOTE] = ACTIONS(3518),
    [anon_sym_u_SQUOTE] = ACTIONS(3518),
    [anon_sym_U_SQUOTE] = ACTIONS(3518),
    [anon_sym_u8_SQUOTE] = ACTIONS(3518),
    [anon_sym_SQUOTE] = ACTIONS(3518),
    [anon_sym_L_DQUOTE] = ACTIONS(3518),
    [anon_sym_u_DQUOTE] = ACTIONS(3518),
    [anon_sym_U_DQUOTE] = ACTIONS(3518),
    [anon_sym_u8_DQUOTE] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(3518),
    [sym_true] = ACTIONS(3520),
    [sym_false] = ACTIONS(3520),
    [anon_sym_NULL] = ACTIONS(3520),
    [anon_sym_nullptr] = ACTIONS(3520),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3520),
    [anon_sym_let] = ACTIONS(3520),
    [anon_sym_This] = ACTIONS(3520),
    [anon_sym_decltype] = ACTIONS(3520),
    [anon_sym_typename] = ACTIONS(3520),
    [anon_sym_template] = ACTIONS(3520),
    [anon_sym_try] = ACTIONS(3520),
    [anon_sym_delete] = ACTIONS(3520),
    [anon_sym_throw] = ACTIONS(3520),
    [anon_sym_co_return] = ACTIONS(3520),
    [anon_sym_co_yield] = ACTIONS(3520),
    [anon_sym_R_DQUOTE] = ACTIONS(3518),
    [anon_sym_LR_DQUOTE] = ACTIONS(3518),
    [anon_sym_uR_DQUOTE] = ACTIONS(3518),
    [anon_sym_UR_DQUOTE] = ACTIONS(3518),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3518),
    [anon_sym_co_await] = ACTIONS(3520),
    [anon_sym_new] = ACTIONS(3520),
    [anon_sym_requires] = ACTIONS(3520),
    [sym_this] = ACTIONS(3520),
    [anon_sym_discard] = ACTIONS(3520),
    [anon_sym_precise] = ACTIONS(3520),
    [anon_sym_shared] = ACTIONS(3520),
    [anon_sym_groupshared] = ACTIONS(3520),
    [anon_sym_uniform] = ACTIONS(3520),
    [anon_sym_row_major] = ACTIONS(3520),
    [anon_sym_column_major] = ACTIONS(3520),
    [anon_sym_globallycoherent] = ACTIONS(3520),
    [anon_sym_centroid] = ACTIONS(3520),
    [anon_sym_noperspective] = ACTIONS(3520),
    [anon_sym_nointerpolation] = ACTIONS(3520),
    [anon_sym_sample] = ACTIONS(3520),
    [anon_sym_linear] = ACTIONS(3520),
    [anon_sym_snorm] = ACTIONS(3520),
    [anon_sym_unorm] = ACTIONS(3520),
    [anon_sym_point] = ACTIONS(3520),
    [anon_sym_line] = ACTIONS(3520),
    [anon_sym_triangleadj] = ACTIONS(3520),
    [anon_sym_lineadj] = ACTIONS(3520),
    [anon_sym_triangle] = ACTIONS(3520),
    [anon_sym_cbuffer] = ACTIONS(3520),
    [anon_sym_interface] = ACTIONS(3520),
    [anon_sym_extension] = ACTIONS(3520),
  },
  [1375] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(1605),
    [sym_raw_string_literal] = STATE(3527),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2764),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2172),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(5334),
    [anon_sym_SEMI] = ACTIONS(2183),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2193),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym___cdecl] = ACTIONS(2168),
    [anon_sym___clrcall] = ACTIONS(2168),
    [anon_sym___stdcall] = ACTIONS(2168),
    [anon_sym___fastcall] = ACTIONS(2168),
    [anon_sym___thiscall] = ACTIONS(2168),
    [anon_sym___vectorcall] = ACTIONS(2168),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_signed] = ACTIONS(5332),
    [anon_sym_unsigned] = ACTIONS(5332),
    [anon_sym_long] = ACTIONS(5332),
    [anon_sym_short] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2207),
    [anon_sym_SLASH_EQ] = ACTIONS(2207),
    [anon_sym_PERCENT_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_GT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_EQ] = ACTIONS(2207),
    [anon_sym_CARET_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_EQ] = ACTIONS(2207),
    [anon_sym_and_eq] = ACTIONS(2205),
    [anon_sym_or_eq] = ACTIONS(2205),
    [anon_sym_xor_eq] = ACTIONS(2205),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_decltype] = ACTIONS(2168),
    [anon_sym_template] = ACTIONS(2168),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
  },
  [1376] = {
    [sym_identifier] = ACTIONS(5060),
    [anon_sym_LPAREN2] = ACTIONS(5066),
    [anon_sym_BANG] = ACTIONS(5066),
    [anon_sym_TILDE] = ACTIONS(5066),
    [anon_sym_DASH] = ACTIONS(5068),
    [anon_sym_PLUS] = ACTIONS(5068),
    [anon_sym_STAR] = ACTIONS(5066),
    [anon_sym_AMP] = ACTIONS(5066),
    [anon_sym_SEMI] = ACTIONS(5066),
    [anon_sym___extension__] = ACTIONS(5060),
    [anon_sym_in] = ACTIONS(5072),
    [anon_sym_out] = ACTIONS(5072),
    [anon_sym_inout] = ACTIONS(5072),
    [anon_sym_virtual] = ACTIONS(5072),
    [anon_sym_extern] = ACTIONS(5072),
    [anon_sym___attribute__] = ACTIONS(5072),
    [anon_sym___attribute] = ACTIONS(5072),
    [anon_sym_COLON_COLON] = ACTIONS(5063),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5063),
    [anon_sym___declspec] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(5066),
    [anon_sym_signed] = ACTIONS(5072),
    [anon_sym_unsigned] = ACTIONS(5072),
    [anon_sym_long] = ACTIONS(5072),
    [anon_sym_short] = ACTIONS(5072),
    [anon_sym_LBRACK] = ACTIONS(5068),
    [anon_sym_static] = ACTIONS(5072),
    [anon_sym_register] = ACTIONS(5072),
    [anon_sym_inline] = ACTIONS(5072),
    [anon_sym___inline] = ACTIONS(5072),
    [anon_sym___inline__] = ACTIONS(5072),
    [anon_sym___forceinline] = ACTIONS(5072),
    [anon_sym_thread_local] = ACTIONS(5072),
    [anon_sym___thread] = ACTIONS(5072),
    [anon_sym_const] = ACTIONS(5072),
    [anon_sym_constexpr] = ACTIONS(5072),
    [anon_sym_volatile] = ACTIONS(5072),
    [anon_sym_restrict] = ACTIONS(5072),
    [anon_sym___restrict__] = ACTIONS(5072),
    [anon_sym__Atomic] = ACTIONS(5072),
    [anon_sym__Noreturn] = ACTIONS(5072),
    [anon_sym_noreturn] = ACTIONS(5072),
    [anon_sym__Nonnull] = ACTIONS(5072),
    [anon_sym_mutable] = ACTIONS(5072),
    [anon_sym_constinit] = ACTIONS(5072),
    [anon_sym_consteval] = ACTIONS(5072),
    [anon_sym_alignas] = ACTIONS(5072),
    [anon_sym__Alignas] = ACTIONS(5072),
    [sym_primitive_type] = ACTIONS(5060),
    [anon_sym_enum] = ACTIONS(5072),
    [anon_sym_class] = ACTIONS(5072),
    [anon_sym_struct] = ACTIONS(5072),
    [anon_sym_union] = ACTIONS(5072),
    [anon_sym_if] = ACTIONS(5068),
    [anon_sym_switch] = ACTIONS(5068),
    [anon_sym_case] = ACTIONS(5068),
    [anon_sym_default] = ACTIONS(5068),
    [anon_sym_while] = ACTIONS(5068),
    [anon_sym_do] = ACTIONS(5068),
    [anon_sym_for] = ACTIONS(5068),
    [anon_sym_return] = ACTIONS(5068),
    [anon_sym_break] = ACTIONS(5068),
    [anon_sym_continue] = ACTIONS(5068),
    [anon_sym_goto] = ACTIONS(5068),
    [anon_sym___try] = ACTIONS(5068),
    [anon_sym___leave] = ACTIONS(5068),
    [anon_sym_not] = ACTIONS(5068),
    [anon_sym_compl] = ACTIONS(5068),
    [anon_sym_DASH_DASH] = ACTIONS(5066),
    [anon_sym_PLUS_PLUS] = ACTIONS(5066),
    [anon_sym_sizeof] = ACTIONS(5068),
    [anon_sym___alignof__] = ACTIONS(5068),
    [anon_sym___alignof] = ACTIONS(5068),
    [anon_sym__alignof] = ACTIONS(5068),
    [anon_sym_alignof] = ACTIONS(5068),
    [anon_sym__Alignof] = ACTIONS(5068),
    [anon_sym_offsetof] = ACTIONS(5068),
    [anon_sym__Generic] = ACTIONS(5068),
    [anon_sym_asm] = ACTIONS(5068),
    [anon_sym___asm__] = ACTIONS(5068),
    [anon_sym___asm] = ACTIONS(5068),
    [sym_number_literal] = ACTIONS(5066),
    [anon_sym_L_SQUOTE] = ACTIONS(5066),
    [anon_sym_u_SQUOTE] = ACTIONS(5066),
    [anon_sym_U_SQUOTE] = ACTIONS(5066),
    [anon_sym_u8_SQUOTE] = ACTIONS(5066),
    [anon_sym_SQUOTE] = ACTIONS(5066),
    [anon_sym_L_DQUOTE] = ACTIONS(5066),
    [anon_sym_u_DQUOTE] = ACTIONS(5066),
    [anon_sym_U_DQUOTE] = ACTIONS(5066),
    [anon_sym_u8_DQUOTE] = ACTIONS(5066),
    [anon_sym_DQUOTE] = ACTIONS(5066),
    [sym_true] = ACTIONS(5068),
    [sym_false] = ACTIONS(5068),
    [anon_sym_NULL] = ACTIONS(5068),
    [anon_sym_nullptr] = ACTIONS(5068),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5072),
    [anon_sym_let] = ACTIONS(5072),
    [anon_sym_This] = ACTIONS(5072),
    [anon_sym_decltype] = ACTIONS(5060),
    [anon_sym_typename] = ACTIONS(5072),
    [anon_sym_template] = ACTIONS(5060),
    [anon_sym_try] = ACTIONS(5068),
    [anon_sym_delete] = ACTIONS(5068),
    [anon_sym_throw] = ACTIONS(5068),
    [anon_sym_co_return] = ACTIONS(5068),
    [anon_sym_co_yield] = ACTIONS(5068),
    [anon_sym_R_DQUOTE] = ACTIONS(5066),
    [anon_sym_LR_DQUOTE] = ACTIONS(5066),
    [anon_sym_uR_DQUOTE] = ACTIONS(5066),
    [anon_sym_UR_DQUOTE] = ACTIONS(5066),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5066),
    [anon_sym_co_await] = ACTIONS(5068),
    [anon_sym_new] = ACTIONS(5068),
    [anon_sym_requires] = ACTIONS(5068),
    [sym_this] = ACTIONS(5068),
    [anon_sym_discard] = ACTIONS(5068),
    [anon_sym_precise] = ACTIONS(5072),
    [anon_sym_shared] = ACTIONS(5072),
    [anon_sym_groupshared] = ACTIONS(5072),
    [anon_sym_uniform] = ACTIONS(5072),
    [anon_sym_row_major] = ACTIONS(5072),
    [anon_sym_column_major] = ACTIONS(5072),
    [anon_sym_globallycoherent] = ACTIONS(5072),
    [anon_sym_centroid] = ACTIONS(5072),
    [anon_sym_noperspective] = ACTIONS(5072),
    [anon_sym_nointerpolation] = ACTIONS(5072),
    [anon_sym_sample] = ACTIONS(5072),
    [anon_sym_linear] = ACTIONS(5072),
    [anon_sym_snorm] = ACTIONS(5072),
    [anon_sym_unorm] = ACTIONS(5072),
    [anon_sym_point] = ACTIONS(5072),
    [anon_sym_line] = ACTIONS(5072),
    [anon_sym_triangleadj] = ACTIONS(5072),
    [anon_sym_lineadj] = ACTIONS(5072),
    [anon_sym_triangle] = ACTIONS(5072),
    [anon_sym_cbuffer] = ACTIONS(5068),
    [anon_sym_interface] = ACTIONS(5072),
    [anon_sym_extension] = ACTIONS(5072),
  },
  [1377] = {
    [sym_identifier] = ACTIONS(3558),
    [anon_sym_LPAREN2] = ACTIONS(3556),
    [anon_sym_BANG] = ACTIONS(3556),
    [anon_sym_TILDE] = ACTIONS(3556),
    [anon_sym_DASH] = ACTIONS(3558),
    [anon_sym_PLUS] = ACTIONS(3558),
    [anon_sym_STAR] = ACTIONS(3556),
    [anon_sym_AMP] = ACTIONS(3556),
    [anon_sym_SEMI] = ACTIONS(3556),
    [anon_sym___extension__] = ACTIONS(3558),
    [anon_sym_typedef] = ACTIONS(3558),
    [anon_sym_in] = ACTIONS(3558),
    [anon_sym_out] = ACTIONS(3558),
    [anon_sym_inout] = ACTIONS(3558),
    [anon_sym_virtual] = ACTIONS(3558),
    [anon_sym_extern] = ACTIONS(3558),
    [anon_sym___attribute__] = ACTIONS(3558),
    [anon_sym___attribute] = ACTIONS(3558),
    [anon_sym_COLON_COLON] = ACTIONS(3556),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3556),
    [anon_sym___declspec] = ACTIONS(3558),
    [anon_sym_LBRACE] = ACTIONS(3556),
    [anon_sym_signed] = ACTIONS(3558),
    [anon_sym_unsigned] = ACTIONS(3558),
    [anon_sym_long] = ACTIONS(3558),
    [anon_sym_short] = ACTIONS(3558),
    [anon_sym_LBRACK] = ACTIONS(3558),
    [anon_sym_static] = ACTIONS(3558),
    [anon_sym_register] = ACTIONS(3558),
    [anon_sym_inline] = ACTIONS(3558),
    [anon_sym___inline] = ACTIONS(3558),
    [anon_sym___inline__] = ACTIONS(3558),
    [anon_sym___forceinline] = ACTIONS(3558),
    [anon_sym_thread_local] = ACTIONS(3558),
    [anon_sym___thread] = ACTIONS(3558),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_constexpr] = ACTIONS(3558),
    [anon_sym_volatile] = ACTIONS(3558),
    [anon_sym_restrict] = ACTIONS(3558),
    [anon_sym___restrict__] = ACTIONS(3558),
    [anon_sym__Atomic] = ACTIONS(3558),
    [anon_sym__Noreturn] = ACTIONS(3558),
    [anon_sym_noreturn] = ACTIONS(3558),
    [anon_sym__Nonnull] = ACTIONS(3558),
    [anon_sym_mutable] = ACTIONS(3558),
    [anon_sym_constinit] = ACTIONS(3558),
    [anon_sym_consteval] = ACTIONS(3558),
    [anon_sym_alignas] = ACTIONS(3558),
    [anon_sym__Alignas] = ACTIONS(3558),
    [sym_primitive_type] = ACTIONS(3558),
    [anon_sym_enum] = ACTIONS(3558),
    [anon_sym_class] = ACTIONS(3558),
    [anon_sym_struct] = ACTIONS(3558),
    [anon_sym_union] = ACTIONS(3558),
    [anon_sym_if] = ACTIONS(3558),
    [anon_sym_else] = ACTIONS(3558),
    [anon_sym_switch] = ACTIONS(3558),
    [anon_sym_while] = ACTIONS(3558),
    [anon_sym_do] = ACTIONS(3558),
    [anon_sym_for] = ACTIONS(3558),
    [anon_sym_return] = ACTIONS(3558),
    [anon_sym_break] = ACTIONS(3558),
    [anon_sym_continue] = ACTIONS(3558),
    [anon_sym_goto] = ACTIONS(3558),
    [anon_sym___try] = ACTIONS(3558),
    [anon_sym___leave] = ACTIONS(3558),
    [anon_sym_not] = ACTIONS(3558),
    [anon_sym_compl] = ACTIONS(3558),
    [anon_sym_DASH_DASH] = ACTIONS(3556),
    [anon_sym_PLUS_PLUS] = ACTIONS(3556),
    [anon_sym_sizeof] = ACTIONS(3558),
    [anon_sym___alignof__] = ACTIONS(3558),
    [anon_sym___alignof] = ACTIONS(3558),
    [anon_sym__alignof] = ACTIONS(3558),
    [anon_sym_alignof] = ACTIONS(3558),
    [anon_sym__Alignof] = ACTIONS(3558),
    [anon_sym_offsetof] = ACTIONS(3558),
    [anon_sym__Generic] = ACTIONS(3558),
    [anon_sym_asm] = ACTIONS(3558),
    [anon_sym___asm__] = ACTIONS(3558),
    [anon_sym___asm] = ACTIONS(3558),
    [sym_number_literal] = ACTIONS(3556),
    [anon_sym_L_SQUOTE] = ACTIONS(3556),
    [anon_sym_u_SQUOTE] = ACTIONS(3556),
    [anon_sym_U_SQUOTE] = ACTIONS(3556),
    [anon_sym_u8_SQUOTE] = ACTIONS(3556),
    [anon_sym_SQUOTE] = ACTIONS(3556),
    [anon_sym_L_DQUOTE] = ACTIONS(3556),
    [anon_sym_u_DQUOTE] = ACTIONS(3556),
    [anon_sym_U_DQUOTE] = ACTIONS(3556),
    [anon_sym_u8_DQUOTE] = ACTIONS(3556),
    [anon_sym_DQUOTE] = ACTIONS(3556),
    [sym_true] = ACTIONS(3558),
    [sym_false] = ACTIONS(3558),
    [anon_sym_NULL] = ACTIONS(3558),
    [anon_sym_nullptr] = ACTIONS(3558),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3558),
    [anon_sym_let] = ACTIONS(3558),
    [anon_sym_This] = ACTIONS(3558),
    [anon_sym_decltype] = ACTIONS(3558),
    [anon_sym_typename] = ACTIONS(3558),
    [anon_sym_template] = ACTIONS(3558),
    [anon_sym_try] = ACTIONS(3558),
    [anon_sym_delete] = ACTIONS(3558),
    [anon_sym_throw] = ACTIONS(3558),
    [anon_sym_co_return] = ACTIONS(3558),
    [anon_sym_co_yield] = ACTIONS(3558),
    [anon_sym_R_DQUOTE] = ACTIONS(3556),
    [anon_sym_LR_DQUOTE] = ACTIONS(3556),
    [anon_sym_uR_DQUOTE] = ACTIONS(3556),
    [anon_sym_UR_DQUOTE] = ACTIONS(3556),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3556),
    [anon_sym_co_await] = ACTIONS(3558),
    [anon_sym_new] = ACTIONS(3558),
    [anon_sym_requires] = ACTIONS(3558),
    [sym_this] = ACTIONS(3558),
    [anon_sym_discard] = ACTIONS(3558),
    [anon_sym_precise] = ACTIONS(3558),
    [anon_sym_shared] = ACTIONS(3558),
    [anon_sym_groupshared] = ACTIONS(3558),
    [anon_sym_uniform] = ACTIONS(3558),
    [anon_sym_row_major] = ACTIONS(3558),
    [anon_sym_column_major] = ACTIONS(3558),
    [anon_sym_globallycoherent] = ACTIONS(3558),
    [anon_sym_centroid] = ACTIONS(3558),
    [anon_sym_noperspective] = ACTIONS(3558),
    [anon_sym_nointerpolation] = ACTIONS(3558),
    [anon_sym_sample] = ACTIONS(3558),
    [anon_sym_linear] = ACTIONS(3558),
    [anon_sym_snorm] = ACTIONS(3558),
    [anon_sym_unorm] = ACTIONS(3558),
    [anon_sym_point] = ACTIONS(3558),
    [anon_sym_line] = ACTIONS(3558),
    [anon_sym_triangleadj] = ACTIONS(3558),
    [anon_sym_lineadj] = ACTIONS(3558),
    [anon_sym_triangle] = ACTIONS(3558),
    [anon_sym_cbuffer] = ACTIONS(3558),
    [anon_sym_interface] = ACTIONS(3558),
    [anon_sym_extension] = ACTIONS(3558),
  },
  [1378] = {
    [sym_identifier] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(3579),
    [anon_sym_BANG] = ACTIONS(3579),
    [anon_sym_TILDE] = ACTIONS(3579),
    [anon_sym_DASH] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3581),
    [anon_sym_STAR] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3579),
    [anon_sym_SEMI] = ACTIONS(3579),
    [anon_sym___extension__] = ACTIONS(3581),
    [anon_sym_typedef] = ACTIONS(3581),
    [anon_sym_in] = ACTIONS(3581),
    [anon_sym_out] = ACTIONS(3581),
    [anon_sym_inout] = ACTIONS(3581),
    [anon_sym_virtual] = ACTIONS(3581),
    [anon_sym_extern] = ACTIONS(3581),
    [anon_sym___attribute__] = ACTIONS(3581),
    [anon_sym___attribute] = ACTIONS(3581),
    [anon_sym_COLON_COLON] = ACTIONS(3579),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3579),
    [anon_sym___declspec] = ACTIONS(3581),
    [anon_sym_LBRACE] = ACTIONS(3579),
    [anon_sym_signed] = ACTIONS(3581),
    [anon_sym_unsigned] = ACTIONS(3581),
    [anon_sym_long] = ACTIONS(3581),
    [anon_sym_short] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_static] = ACTIONS(3581),
    [anon_sym_register] = ACTIONS(3581),
    [anon_sym_inline] = ACTIONS(3581),
    [anon_sym___inline] = ACTIONS(3581),
    [anon_sym___inline__] = ACTIONS(3581),
    [anon_sym___forceinline] = ACTIONS(3581),
    [anon_sym_thread_local] = ACTIONS(3581),
    [anon_sym___thread] = ACTIONS(3581),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_constexpr] = ACTIONS(3581),
    [anon_sym_volatile] = ACTIONS(3581),
    [anon_sym_restrict] = ACTIONS(3581),
    [anon_sym___restrict__] = ACTIONS(3581),
    [anon_sym__Atomic] = ACTIONS(3581),
    [anon_sym__Noreturn] = ACTIONS(3581),
    [anon_sym_noreturn] = ACTIONS(3581),
    [anon_sym__Nonnull] = ACTIONS(3581),
    [anon_sym_mutable] = ACTIONS(3581),
    [anon_sym_constinit] = ACTIONS(3581),
    [anon_sym_consteval] = ACTIONS(3581),
    [anon_sym_alignas] = ACTIONS(3581),
    [anon_sym__Alignas] = ACTIONS(3581),
    [sym_primitive_type] = ACTIONS(3581),
    [anon_sym_enum] = ACTIONS(3581),
    [anon_sym_class] = ACTIONS(3581),
    [anon_sym_struct] = ACTIONS(3581),
    [anon_sym_union] = ACTIONS(3581),
    [anon_sym_if] = ACTIONS(3581),
    [anon_sym_else] = ACTIONS(3581),
    [anon_sym_switch] = ACTIONS(3581),
    [anon_sym_while] = ACTIONS(3581),
    [anon_sym_do] = ACTIONS(3581),
    [anon_sym_for] = ACTIONS(3581),
    [anon_sym_return] = ACTIONS(3581),
    [anon_sym_break] = ACTIONS(3581),
    [anon_sym_continue] = ACTIONS(3581),
    [anon_sym_goto] = ACTIONS(3581),
    [anon_sym___try] = ACTIONS(3581),
    [anon_sym___leave] = ACTIONS(3581),
    [anon_sym_not] = ACTIONS(3581),
    [anon_sym_compl] = ACTIONS(3581),
    [anon_sym_DASH_DASH] = ACTIONS(3579),
    [anon_sym_PLUS_PLUS] = ACTIONS(3579),
    [anon_sym_sizeof] = ACTIONS(3581),
    [anon_sym___alignof__] = ACTIONS(3581),
    [anon_sym___alignof] = ACTIONS(3581),
    [anon_sym__alignof] = ACTIONS(3581),
    [anon_sym_alignof] = ACTIONS(3581),
    [anon_sym__Alignof] = ACTIONS(3581),
    [anon_sym_offsetof] = ACTIONS(3581),
    [anon_sym__Generic] = ACTIONS(3581),
    [anon_sym_asm] = ACTIONS(3581),
    [anon_sym___asm__] = ACTIONS(3581),
    [anon_sym___asm] = ACTIONS(3581),
    [sym_number_literal] = ACTIONS(3579),
    [anon_sym_L_SQUOTE] = ACTIONS(3579),
    [anon_sym_u_SQUOTE] = ACTIONS(3579),
    [anon_sym_U_SQUOTE] = ACTIONS(3579),
    [anon_sym_u8_SQUOTE] = ACTIONS(3579),
    [anon_sym_SQUOTE] = ACTIONS(3579),
    [anon_sym_L_DQUOTE] = ACTIONS(3579),
    [anon_sym_u_DQUOTE] = ACTIONS(3579),
    [anon_sym_U_DQUOTE] = ACTIONS(3579),
    [anon_sym_u8_DQUOTE] = ACTIONS(3579),
    [anon_sym_DQUOTE] = ACTIONS(3579),
    [sym_true] = ACTIONS(3581),
    [sym_false] = ACTIONS(3581),
    [anon_sym_NULL] = ACTIONS(3581),
    [anon_sym_nullptr] = ACTIONS(3581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_This] = ACTIONS(3581),
    [anon_sym_decltype] = ACTIONS(3581),
    [anon_sym_typename] = ACTIONS(3581),
    [anon_sym_template] = ACTIONS(3581),
    [anon_sym_try] = ACTIONS(3581),
    [anon_sym_delete] = ACTIONS(3581),
    [anon_sym_throw] = ACTIONS(3581),
    [anon_sym_co_return] = ACTIONS(3581),
    [anon_sym_co_yield] = ACTIONS(3581),
    [anon_sym_R_DQUOTE] = ACTIONS(3579),
    [anon_sym_LR_DQUOTE] = ACTIONS(3579),
    [anon_sym_uR_DQUOTE] = ACTIONS(3579),
    [anon_sym_UR_DQUOTE] = ACTIONS(3579),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3579),
    [anon_sym_co_await] = ACTIONS(3581),
    [anon_sym_new] = ACTIONS(3581),
    [anon_sym_requires] = ACTIONS(3581),
    [sym_this] = ACTIONS(3581),
    [anon_sym_discard] = ACTIONS(3581),
    [anon_sym_precise] = ACTIONS(3581),
    [anon_sym_shared] = ACTIONS(3581),
    [anon_sym_groupshared] = ACTIONS(3581),
    [anon_sym_uniform] = ACTIONS(3581),
    [anon_sym_row_major] = ACTIONS(3581),
    [anon_sym_column_major] = ACTIONS(3581),
    [anon_sym_globallycoherent] = ACTIONS(3581),
    [anon_sym_centroid] = ACTIONS(3581),
    [anon_sym_noperspective] = ACTIONS(3581),
    [anon_sym_nointerpolation] = ACTIONS(3581),
    [anon_sym_sample] = ACTIONS(3581),
    [anon_sym_linear] = ACTIONS(3581),
    [anon_sym_snorm] = ACTIONS(3581),
    [anon_sym_unorm] = ACTIONS(3581),
    [anon_sym_point] = ACTIONS(3581),
    [anon_sym_line] = ACTIONS(3581),
    [anon_sym_triangleadj] = ACTIONS(3581),
    [anon_sym_lineadj] = ACTIONS(3581),
    [anon_sym_triangle] = ACTIONS(3581),
    [anon_sym_cbuffer] = ACTIONS(3581),
    [anon_sym_interface] = ACTIONS(3581),
    [anon_sym_extension] = ACTIONS(3581),
  },
  [1379] = {
    [sym_identifier] = ACTIONS(3591),
    [anon_sym_LPAREN2] = ACTIONS(3589),
    [anon_sym_BANG] = ACTIONS(3589),
    [anon_sym_TILDE] = ACTIONS(3589),
    [anon_sym_DASH] = ACTIONS(3591),
    [anon_sym_PLUS] = ACTIONS(3591),
    [anon_sym_STAR] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3589),
    [anon_sym_SEMI] = ACTIONS(3589),
    [anon_sym___extension__] = ACTIONS(3591),
    [anon_sym_typedef] = ACTIONS(3591),
    [anon_sym_in] = ACTIONS(3591),
    [anon_sym_out] = ACTIONS(3591),
    [anon_sym_inout] = ACTIONS(3591),
    [anon_sym_virtual] = ACTIONS(3591),
    [anon_sym_extern] = ACTIONS(3591),
    [anon_sym___attribute__] = ACTIONS(3591),
    [anon_sym___attribute] = ACTIONS(3591),
    [anon_sym_COLON_COLON] = ACTIONS(3589),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3589),
    [anon_sym___declspec] = ACTIONS(3591),
    [anon_sym_LBRACE] = ACTIONS(3589),
    [anon_sym_signed] = ACTIONS(3591),
    [anon_sym_unsigned] = ACTIONS(3591),
    [anon_sym_long] = ACTIONS(3591),
    [anon_sym_short] = ACTIONS(3591),
    [anon_sym_LBRACK] = ACTIONS(3591),
    [anon_sym_static] = ACTIONS(3591),
    [anon_sym_register] = ACTIONS(3591),
    [anon_sym_inline] = ACTIONS(3591),
    [anon_sym___inline] = ACTIONS(3591),
    [anon_sym___inline__] = ACTIONS(3591),
    [anon_sym___forceinline] = ACTIONS(3591),
    [anon_sym_thread_local] = ACTIONS(3591),
    [anon_sym___thread] = ACTIONS(3591),
    [anon_sym_const] = ACTIONS(3591),
    [anon_sym_constexpr] = ACTIONS(3591),
    [anon_sym_volatile] = ACTIONS(3591),
    [anon_sym_restrict] = ACTIONS(3591),
    [anon_sym___restrict__] = ACTIONS(3591),
    [anon_sym__Atomic] = ACTIONS(3591),
    [anon_sym__Noreturn] = ACTIONS(3591),
    [anon_sym_noreturn] = ACTIONS(3591),
    [anon_sym__Nonnull] = ACTIONS(3591),
    [anon_sym_mutable] = ACTIONS(3591),
    [anon_sym_constinit] = ACTIONS(3591),
    [anon_sym_consteval] = ACTIONS(3591),
    [anon_sym_alignas] = ACTIONS(3591),
    [anon_sym__Alignas] = ACTIONS(3591),
    [sym_primitive_type] = ACTIONS(3591),
    [anon_sym_enum] = ACTIONS(3591),
    [anon_sym_class] = ACTIONS(3591),
    [anon_sym_struct] = ACTIONS(3591),
    [anon_sym_union] = ACTIONS(3591),
    [anon_sym_if] = ACTIONS(3591),
    [anon_sym_else] = ACTIONS(3591),
    [anon_sym_switch] = ACTIONS(3591),
    [anon_sym_while] = ACTIONS(3591),
    [anon_sym_do] = ACTIONS(3591),
    [anon_sym_for] = ACTIONS(3591),
    [anon_sym_return] = ACTIONS(3591),
    [anon_sym_break] = ACTIONS(3591),
    [anon_sym_continue] = ACTIONS(3591),
    [anon_sym_goto] = ACTIONS(3591),
    [anon_sym___try] = ACTIONS(3591),
    [anon_sym___leave] = ACTIONS(3591),
    [anon_sym_not] = ACTIONS(3591),
    [anon_sym_compl] = ACTIONS(3591),
    [anon_sym_DASH_DASH] = ACTIONS(3589),
    [anon_sym_PLUS_PLUS] = ACTIONS(3589),
    [anon_sym_sizeof] = ACTIONS(3591),
    [anon_sym___alignof__] = ACTIONS(3591),
    [anon_sym___alignof] = ACTIONS(3591),
    [anon_sym__alignof] = ACTIONS(3591),
    [anon_sym_alignof] = ACTIONS(3591),
    [anon_sym__Alignof] = ACTIONS(3591),
    [anon_sym_offsetof] = ACTIONS(3591),
    [anon_sym__Generic] = ACTIONS(3591),
    [anon_sym_asm] = ACTIONS(3591),
    [anon_sym___asm__] = ACTIONS(3591),
    [anon_sym___asm] = ACTIONS(3591),
    [sym_number_literal] = ACTIONS(3589),
    [anon_sym_L_SQUOTE] = ACTIONS(3589),
    [anon_sym_u_SQUOTE] = ACTIONS(3589),
    [anon_sym_U_SQUOTE] = ACTIONS(3589),
    [anon_sym_u8_SQUOTE] = ACTIONS(3589),
    [anon_sym_SQUOTE] = ACTIONS(3589),
    [anon_sym_L_DQUOTE] = ACTIONS(3589),
    [anon_sym_u_DQUOTE] = ACTIONS(3589),
    [anon_sym_U_DQUOTE] = ACTIONS(3589),
    [anon_sym_u8_DQUOTE] = ACTIONS(3589),
    [anon_sym_DQUOTE] = ACTIONS(3589),
    [sym_true] = ACTIONS(3591),
    [sym_false] = ACTIONS(3591),
    [anon_sym_NULL] = ACTIONS(3591),
    [anon_sym_nullptr] = ACTIONS(3591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3591),
    [anon_sym_let] = ACTIONS(3591),
    [anon_sym_This] = ACTIONS(3591),
    [anon_sym_decltype] = ACTIONS(3591),
    [anon_sym_typename] = ACTIONS(3591),
    [anon_sym_template] = ACTIONS(3591),
    [anon_sym_try] = ACTIONS(3591),
    [anon_sym_delete] = ACTIONS(3591),
    [anon_sym_throw] = ACTIONS(3591),
    [anon_sym_co_return] = ACTIONS(3591),
    [anon_sym_co_yield] = ACTIONS(3591),
    [anon_sym_R_DQUOTE] = ACTIONS(3589),
    [anon_sym_LR_DQUOTE] = ACTIONS(3589),
    [anon_sym_uR_DQUOTE] = ACTIONS(3589),
    [anon_sym_UR_DQUOTE] = ACTIONS(3589),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3589),
    [anon_sym_co_await] = ACTIONS(3591),
    [anon_sym_new] = ACTIONS(3591),
    [anon_sym_requires] = ACTIONS(3591),
    [sym_this] = ACTIONS(3591),
    [anon_sym_discard] = ACTIONS(3591),
    [anon_sym_precise] = ACTIONS(3591),
    [anon_sym_shared] = ACTIONS(3591),
    [anon_sym_groupshared] = ACTIONS(3591),
    [anon_sym_uniform] = ACTIONS(3591),
    [anon_sym_row_major] = ACTIONS(3591),
    [anon_sym_column_major] = ACTIONS(3591),
    [anon_sym_globallycoherent] = ACTIONS(3591),
    [anon_sym_centroid] = ACTIONS(3591),
    [anon_sym_noperspective] = ACTIONS(3591),
    [anon_sym_nointerpolation] = ACTIONS(3591),
    [anon_sym_sample] = ACTIONS(3591),
    [anon_sym_linear] = ACTIONS(3591),
    [anon_sym_snorm] = ACTIONS(3591),
    [anon_sym_unorm] = ACTIONS(3591),
    [anon_sym_point] = ACTIONS(3591),
    [anon_sym_line] = ACTIONS(3591),
    [anon_sym_triangleadj] = ACTIONS(3591),
    [anon_sym_lineadj] = ACTIONS(3591),
    [anon_sym_triangle] = ACTIONS(3591),
    [anon_sym_cbuffer] = ACTIONS(3591),
    [anon_sym_interface] = ACTIONS(3591),
    [anon_sym_extension] = ACTIONS(3591),
  },
  [1380] = {
    [sym_identifier] = ACTIONS(3631),
    [anon_sym_LPAREN2] = ACTIONS(3629),
    [anon_sym_BANG] = ACTIONS(3629),
    [anon_sym_TILDE] = ACTIONS(3629),
    [anon_sym_DASH] = ACTIONS(3631),
    [anon_sym_PLUS] = ACTIONS(3631),
    [anon_sym_STAR] = ACTIONS(3629),
    [anon_sym_AMP] = ACTIONS(3629),
    [anon_sym_SEMI] = ACTIONS(3629),
    [anon_sym___extension__] = ACTIONS(3631),
    [anon_sym_typedef] = ACTIONS(3631),
    [anon_sym_in] = ACTIONS(3631),
    [anon_sym_out] = ACTIONS(3631),
    [anon_sym_inout] = ACTIONS(3631),
    [anon_sym_virtual] = ACTIONS(3631),
    [anon_sym_extern] = ACTIONS(3631),
    [anon_sym___attribute__] = ACTIONS(3631),
    [anon_sym___attribute] = ACTIONS(3631),
    [anon_sym_COLON_COLON] = ACTIONS(3629),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3629),
    [anon_sym___declspec] = ACTIONS(3631),
    [anon_sym_LBRACE] = ACTIONS(3629),
    [anon_sym_signed] = ACTIONS(3631),
    [anon_sym_unsigned] = ACTIONS(3631),
    [anon_sym_long] = ACTIONS(3631),
    [anon_sym_short] = ACTIONS(3631),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_static] = ACTIONS(3631),
    [anon_sym_register] = ACTIONS(3631),
    [anon_sym_inline] = ACTIONS(3631),
    [anon_sym___inline] = ACTIONS(3631),
    [anon_sym___inline__] = ACTIONS(3631),
    [anon_sym___forceinline] = ACTIONS(3631),
    [anon_sym_thread_local] = ACTIONS(3631),
    [anon_sym___thread] = ACTIONS(3631),
    [anon_sym_const] = ACTIONS(3631),
    [anon_sym_constexpr] = ACTIONS(3631),
    [anon_sym_volatile] = ACTIONS(3631),
    [anon_sym_restrict] = ACTIONS(3631),
    [anon_sym___restrict__] = ACTIONS(3631),
    [anon_sym__Atomic] = ACTIONS(3631),
    [anon_sym__Noreturn] = ACTIONS(3631),
    [anon_sym_noreturn] = ACTIONS(3631),
    [anon_sym__Nonnull] = ACTIONS(3631),
    [anon_sym_mutable] = ACTIONS(3631),
    [anon_sym_constinit] = ACTIONS(3631),
    [anon_sym_consteval] = ACTIONS(3631),
    [anon_sym_alignas] = ACTIONS(3631),
    [anon_sym__Alignas] = ACTIONS(3631),
    [sym_primitive_type] = ACTIONS(3631),
    [anon_sym_enum] = ACTIONS(3631),
    [anon_sym_class] = ACTIONS(3631),
    [anon_sym_struct] = ACTIONS(3631),
    [anon_sym_union] = ACTIONS(3631),
    [anon_sym_if] = ACTIONS(3631),
    [anon_sym_else] = ACTIONS(3631),
    [anon_sym_switch] = ACTIONS(3631),
    [anon_sym_while] = ACTIONS(3631),
    [anon_sym_do] = ACTIONS(3631),
    [anon_sym_for] = ACTIONS(3631),
    [anon_sym_return] = ACTIONS(3631),
    [anon_sym_break] = ACTIONS(3631),
    [anon_sym_continue] = ACTIONS(3631),
    [anon_sym_goto] = ACTIONS(3631),
    [anon_sym___try] = ACTIONS(3631),
    [anon_sym___leave] = ACTIONS(3631),
    [anon_sym_not] = ACTIONS(3631),
    [anon_sym_compl] = ACTIONS(3631),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_sizeof] = ACTIONS(3631),
    [anon_sym___alignof__] = ACTIONS(3631),
    [anon_sym___alignof] = ACTIONS(3631),
    [anon_sym__alignof] = ACTIONS(3631),
    [anon_sym_alignof] = ACTIONS(3631),
    [anon_sym__Alignof] = ACTIONS(3631),
    [anon_sym_offsetof] = ACTIONS(3631),
    [anon_sym__Generic] = ACTIONS(3631),
    [anon_sym_asm] = ACTIONS(3631),
    [anon_sym___asm__] = ACTIONS(3631),
    [anon_sym___asm] = ACTIONS(3631),
    [sym_number_literal] = ACTIONS(3629),
    [anon_sym_L_SQUOTE] = ACTIONS(3629),
    [anon_sym_u_SQUOTE] = ACTIONS(3629),
    [anon_sym_U_SQUOTE] = ACTIONS(3629),
    [anon_sym_u8_SQUOTE] = ACTIONS(3629),
    [anon_sym_SQUOTE] = ACTIONS(3629),
    [anon_sym_L_DQUOTE] = ACTIONS(3629),
    [anon_sym_u_DQUOTE] = ACTIONS(3629),
    [anon_sym_U_DQUOTE] = ACTIONS(3629),
    [anon_sym_u8_DQUOTE] = ACTIONS(3629),
    [anon_sym_DQUOTE] = ACTIONS(3629),
    [sym_true] = ACTIONS(3631),
    [sym_false] = ACTIONS(3631),
    [anon_sym_NULL] = ACTIONS(3631),
    [anon_sym_nullptr] = ACTIONS(3631),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3631),
    [anon_sym_let] = ACTIONS(3631),
    [anon_sym_This] = ACTIONS(3631),
    [anon_sym_decltype] = ACTIONS(3631),
    [anon_sym_typename] = ACTIONS(3631),
    [anon_sym_template] = ACTIONS(3631),
    [anon_sym_try] = ACTIONS(3631),
    [anon_sym_delete] = ACTIONS(3631),
    [anon_sym_throw] = ACTIONS(3631),
    [anon_sym_co_return] = ACTIONS(3631),
    [anon_sym_co_yield] = ACTIONS(3631),
    [anon_sym_R_DQUOTE] = ACTIONS(3629),
    [anon_sym_LR_DQUOTE] = ACTIONS(3629),
    [anon_sym_uR_DQUOTE] = ACTIONS(3629),
    [anon_sym_UR_DQUOTE] = ACTIONS(3629),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3629),
    [anon_sym_co_await] = ACTIONS(3631),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_requires] = ACTIONS(3631),
    [sym_this] = ACTIONS(3631),
    [anon_sym_discard] = ACTIONS(3631),
    [anon_sym_precise] = ACTIONS(3631),
    [anon_sym_shared] = ACTIONS(3631),
    [anon_sym_groupshared] = ACTIONS(3631),
    [anon_sym_uniform] = ACTIONS(3631),
    [anon_sym_row_major] = ACTIONS(3631),
    [anon_sym_column_major] = ACTIONS(3631),
    [anon_sym_globallycoherent] = ACTIONS(3631),
    [anon_sym_centroid] = ACTIONS(3631),
    [anon_sym_noperspective] = ACTIONS(3631),
    [anon_sym_nointerpolation] = ACTIONS(3631),
    [anon_sym_sample] = ACTIONS(3631),
    [anon_sym_linear] = ACTIONS(3631),
    [anon_sym_snorm] = ACTIONS(3631),
    [anon_sym_unorm] = ACTIONS(3631),
    [anon_sym_point] = ACTIONS(3631),
    [anon_sym_line] = ACTIONS(3631),
    [anon_sym_triangleadj] = ACTIONS(3631),
    [anon_sym_lineadj] = ACTIONS(3631),
    [anon_sym_triangle] = ACTIONS(3631),
    [anon_sym_cbuffer] = ACTIONS(3631),
    [anon_sym_interface] = ACTIONS(3631),
    [anon_sym_extension] = ACTIONS(3631),
  },
  [1381] = {
    [sym_identifier] = ACTIONS(3637),
    [anon_sym_LPAREN2] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(3639),
    [anon_sym_TILDE] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3637),
    [anon_sym_STAR] = ACTIONS(3639),
    [anon_sym_AMP] = ACTIONS(3639),
    [anon_sym_SEMI] = ACTIONS(3639),
    [anon_sym___extension__] = ACTIONS(3637),
    [anon_sym_typedef] = ACTIONS(3637),
    [anon_sym_in] = ACTIONS(3637),
    [anon_sym_out] = ACTIONS(3637),
    [anon_sym_inout] = ACTIONS(3637),
    [anon_sym_virtual] = ACTIONS(3637),
    [anon_sym_extern] = ACTIONS(3637),
    [anon_sym___attribute__] = ACTIONS(3637),
    [anon_sym___attribute] = ACTIONS(3637),
    [anon_sym_COLON_COLON] = ACTIONS(3639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3639),
    [anon_sym___declspec] = ACTIONS(3637),
    [anon_sym_LBRACE] = ACTIONS(3639),
    [anon_sym_signed] = ACTIONS(3637),
    [anon_sym_unsigned] = ACTIONS(3637),
    [anon_sym_long] = ACTIONS(3637),
    [anon_sym_short] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(3637),
    [anon_sym_static] = ACTIONS(3637),
    [anon_sym_register] = ACTIONS(3637),
    [anon_sym_inline] = ACTIONS(3637),
    [anon_sym___inline] = ACTIONS(3637),
    [anon_sym___inline__] = ACTIONS(3637),
    [anon_sym___forceinline] = ACTIONS(3637),
    [anon_sym_thread_local] = ACTIONS(3637),
    [anon_sym___thread] = ACTIONS(3637),
    [anon_sym_const] = ACTIONS(3637),
    [anon_sym_constexpr] = ACTIONS(3637),
    [anon_sym_volatile] = ACTIONS(3637),
    [anon_sym_restrict] = ACTIONS(3637),
    [anon_sym___restrict__] = ACTIONS(3637),
    [anon_sym__Atomic] = ACTIONS(3637),
    [anon_sym__Noreturn] = ACTIONS(3637),
    [anon_sym_noreturn] = ACTIONS(3637),
    [anon_sym__Nonnull] = ACTIONS(3637),
    [anon_sym_mutable] = ACTIONS(3637),
    [anon_sym_constinit] = ACTIONS(3637),
    [anon_sym_consteval] = ACTIONS(3637),
    [anon_sym_alignas] = ACTIONS(3637),
    [anon_sym__Alignas] = ACTIONS(3637),
    [sym_primitive_type] = ACTIONS(3637),
    [anon_sym_enum] = ACTIONS(3637),
    [anon_sym_class] = ACTIONS(3637),
    [anon_sym_struct] = ACTIONS(3637),
    [anon_sym_union] = ACTIONS(3637),
    [anon_sym_if] = ACTIONS(3637),
    [anon_sym_else] = ACTIONS(3637),
    [anon_sym_switch] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3637),
    [anon_sym_do] = ACTIONS(3637),
    [anon_sym_for] = ACTIONS(3637),
    [anon_sym_return] = ACTIONS(3637),
    [anon_sym_break] = ACTIONS(3637),
    [anon_sym_continue] = ACTIONS(3637),
    [anon_sym_goto] = ACTIONS(3637),
    [anon_sym___try] = ACTIONS(3637),
    [anon_sym___leave] = ACTIONS(3637),
    [anon_sym_not] = ACTIONS(3637),
    [anon_sym_compl] = ACTIONS(3637),
    [anon_sym_DASH_DASH] = ACTIONS(3639),
    [anon_sym_PLUS_PLUS] = ACTIONS(3639),
    [anon_sym_sizeof] = ACTIONS(3637),
    [anon_sym___alignof__] = ACTIONS(3637),
    [anon_sym___alignof] = ACTIONS(3637),
    [anon_sym__alignof] = ACTIONS(3637),
    [anon_sym_alignof] = ACTIONS(3637),
    [anon_sym__Alignof] = ACTIONS(3637),
    [anon_sym_offsetof] = ACTIONS(3637),
    [anon_sym__Generic] = ACTIONS(3637),
    [anon_sym_asm] = ACTIONS(3637),
    [anon_sym___asm__] = ACTIONS(3637),
    [anon_sym___asm] = ACTIONS(3637),
    [sym_number_literal] = ACTIONS(3639),
    [anon_sym_L_SQUOTE] = ACTIONS(3639),
    [anon_sym_u_SQUOTE] = ACTIONS(3639),
    [anon_sym_U_SQUOTE] = ACTIONS(3639),
    [anon_sym_u8_SQUOTE] = ACTIONS(3639),
    [anon_sym_SQUOTE] = ACTIONS(3639),
    [anon_sym_L_DQUOTE] = ACTIONS(3639),
    [anon_sym_u_DQUOTE] = ACTIONS(3639),
    [anon_sym_U_DQUOTE] = ACTIONS(3639),
    [anon_sym_u8_DQUOTE] = ACTIONS(3639),
    [anon_sym_DQUOTE] = ACTIONS(3639),
    [sym_true] = ACTIONS(3637),
    [sym_false] = ACTIONS(3637),
    [anon_sym_NULL] = ACTIONS(3637),
    [anon_sym_nullptr] = ACTIONS(3637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3637),
    [anon_sym_let] = ACTIONS(3637),
    [anon_sym_This] = ACTIONS(3637),
    [anon_sym_decltype] = ACTIONS(3637),
    [anon_sym_typename] = ACTIONS(3637),
    [anon_sym_template] = ACTIONS(3637),
    [anon_sym_try] = ACTIONS(3637),
    [anon_sym_delete] = ACTIONS(3637),
    [anon_sym_throw] = ACTIONS(3637),
    [anon_sym_co_return] = ACTIONS(3637),
    [anon_sym_co_yield] = ACTIONS(3637),
    [anon_sym_R_DQUOTE] = ACTIONS(3639),
    [anon_sym_LR_DQUOTE] = ACTIONS(3639),
    [anon_sym_uR_DQUOTE] = ACTIONS(3639),
    [anon_sym_UR_DQUOTE] = ACTIONS(3639),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3639),
    [anon_sym_co_await] = ACTIONS(3637),
    [anon_sym_new] = ACTIONS(3637),
    [anon_sym_requires] = ACTIONS(3637),
    [sym_this] = ACTIONS(3637),
    [anon_sym_discard] = ACTIONS(3637),
    [anon_sym_precise] = ACTIONS(3637),
    [anon_sym_shared] = ACTIONS(3637),
    [anon_sym_groupshared] = ACTIONS(3637),
    [anon_sym_uniform] = ACTIONS(3637),
    [anon_sym_row_major] = ACTIONS(3637),
    [anon_sym_column_major] = ACTIONS(3637),
    [anon_sym_globallycoherent] = ACTIONS(3637),
    [anon_sym_centroid] = ACTIONS(3637),
    [anon_sym_noperspective] = ACTIONS(3637),
    [anon_sym_nointerpolation] = ACTIONS(3637),
    [anon_sym_sample] = ACTIONS(3637),
    [anon_sym_linear] = ACTIONS(3637),
    [anon_sym_snorm] = ACTIONS(3637),
    [anon_sym_unorm] = ACTIONS(3637),
    [anon_sym_point] = ACTIONS(3637),
    [anon_sym_line] = ACTIONS(3637),
    [anon_sym_triangleadj] = ACTIONS(3637),
    [anon_sym_lineadj] = ACTIONS(3637),
    [anon_sym_triangle] = ACTIONS(3637),
    [anon_sym_cbuffer] = ACTIONS(3637),
    [anon_sym_interface] = ACTIONS(3637),
    [anon_sym_extension] = ACTIONS(3637),
  },
  [1382] = {
    [sym_identifier] = ACTIONS(3462),
    [anon_sym_LPAREN2] = ACTIONS(3464),
    [anon_sym_BANG] = ACTIONS(3464),
    [anon_sym_TILDE] = ACTIONS(3464),
    [anon_sym_DASH] = ACTIONS(3462),
    [anon_sym_PLUS] = ACTIONS(3462),
    [anon_sym_STAR] = ACTIONS(3464),
    [anon_sym_AMP] = ACTIONS(3464),
    [anon_sym_SEMI] = ACTIONS(3464),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_typedef] = ACTIONS(3462),
    [anon_sym_in] = ACTIONS(3462),
    [anon_sym_out] = ACTIONS(3462),
    [anon_sym_inout] = ACTIONS(3462),
    [anon_sym_virtual] = ACTIONS(3462),
    [anon_sym_extern] = ACTIONS(3462),
    [anon_sym___attribute__] = ACTIONS(3462),
    [anon_sym___attribute] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3464),
    [anon_sym___declspec] = ACTIONS(3462),
    [anon_sym_LBRACE] = ACTIONS(3464),
    [anon_sym_signed] = ACTIONS(3462),
    [anon_sym_unsigned] = ACTIONS(3462),
    [anon_sym_long] = ACTIONS(3462),
    [anon_sym_short] = ACTIONS(3462),
    [anon_sym_LBRACK] = ACTIONS(3462),
    [anon_sym_static] = ACTIONS(3462),
    [anon_sym_register] = ACTIONS(3462),
    [anon_sym_inline] = ACTIONS(3462),
    [anon_sym___inline] = ACTIONS(3462),
    [anon_sym___inline__] = ACTIONS(3462),
    [anon_sym___forceinline] = ACTIONS(3462),
    [anon_sym_thread_local] = ACTIONS(3462),
    [anon_sym___thread] = ACTIONS(3462),
    [anon_sym_const] = ACTIONS(3462),
    [anon_sym_constexpr] = ACTIONS(3462),
    [anon_sym_volatile] = ACTIONS(3462),
    [anon_sym_restrict] = ACTIONS(3462),
    [anon_sym___restrict__] = ACTIONS(3462),
    [anon_sym__Atomic] = ACTIONS(3462),
    [anon_sym__Noreturn] = ACTIONS(3462),
    [anon_sym_noreturn] = ACTIONS(3462),
    [anon_sym__Nonnull] = ACTIONS(3462),
    [anon_sym_mutable] = ACTIONS(3462),
    [anon_sym_constinit] = ACTIONS(3462),
    [anon_sym_consteval] = ACTIONS(3462),
    [anon_sym_alignas] = ACTIONS(3462),
    [anon_sym__Alignas] = ACTIONS(3462),
    [sym_primitive_type] = ACTIONS(3462),
    [anon_sym_enum] = ACTIONS(3462),
    [anon_sym_class] = ACTIONS(3462),
    [anon_sym_struct] = ACTIONS(3462),
    [anon_sym_union] = ACTIONS(3462),
    [anon_sym_if] = ACTIONS(3462),
    [anon_sym_else] = ACTIONS(3462),
    [anon_sym_switch] = ACTIONS(3462),
    [anon_sym_while] = ACTIONS(3462),
    [anon_sym_do] = ACTIONS(3462),
    [anon_sym_for] = ACTIONS(3462),
    [anon_sym_return] = ACTIONS(3462),
    [anon_sym_break] = ACTIONS(3462),
    [anon_sym_continue] = ACTIONS(3462),
    [anon_sym_goto] = ACTIONS(3462),
    [anon_sym___try] = ACTIONS(3462),
    [anon_sym___leave] = ACTIONS(3462),
    [anon_sym_not] = ACTIONS(3462),
    [anon_sym_compl] = ACTIONS(3462),
    [anon_sym_DASH_DASH] = ACTIONS(3464),
    [anon_sym_PLUS_PLUS] = ACTIONS(3464),
    [anon_sym_sizeof] = ACTIONS(3462),
    [anon_sym___alignof__] = ACTIONS(3462),
    [anon_sym___alignof] = ACTIONS(3462),
    [anon_sym__alignof] = ACTIONS(3462),
    [anon_sym_alignof] = ACTIONS(3462),
    [anon_sym__Alignof] = ACTIONS(3462),
    [anon_sym_offsetof] = ACTIONS(3462),
    [anon_sym__Generic] = ACTIONS(3462),
    [anon_sym_asm] = ACTIONS(3462),
    [anon_sym___asm__] = ACTIONS(3462),
    [anon_sym___asm] = ACTIONS(3462),
    [sym_number_literal] = ACTIONS(3464),
    [anon_sym_L_SQUOTE] = ACTIONS(3464),
    [anon_sym_u_SQUOTE] = ACTIONS(3464),
    [anon_sym_U_SQUOTE] = ACTIONS(3464),
    [anon_sym_u8_SQUOTE] = ACTIONS(3464),
    [anon_sym_SQUOTE] = ACTIONS(3464),
    [anon_sym_L_DQUOTE] = ACTIONS(3464),
    [anon_sym_u_DQUOTE] = ACTIONS(3464),
    [anon_sym_U_DQUOTE] = ACTIONS(3464),
    [anon_sym_u8_DQUOTE] = ACTIONS(3464),
    [anon_sym_DQUOTE] = ACTIONS(3464),
    [sym_true] = ACTIONS(3462),
    [sym_false] = ACTIONS(3462),
    [anon_sym_NULL] = ACTIONS(3462),
    [anon_sym_nullptr] = ACTIONS(3462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3462),
    [anon_sym_let] = ACTIONS(3462),
    [anon_sym_This] = ACTIONS(3462),
    [anon_sym_decltype] = ACTIONS(3462),
    [anon_sym_typename] = ACTIONS(3462),
    [anon_sym_template] = ACTIONS(3462),
    [anon_sym_try] = ACTIONS(3462),
    [anon_sym_delete] = ACTIONS(3462),
    [anon_sym_throw] = ACTIONS(3462),
    [anon_sym_co_return] = ACTIONS(3462),
    [anon_sym_co_yield] = ACTIONS(3462),
    [anon_sym_R_DQUOTE] = ACTIONS(3464),
    [anon_sym_LR_DQUOTE] = ACTIONS(3464),
    [anon_sym_uR_DQUOTE] = ACTIONS(3464),
    [anon_sym_UR_DQUOTE] = ACTIONS(3464),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3464),
    [anon_sym_co_await] = ACTIONS(3462),
    [anon_sym_new] = ACTIONS(3462),
    [anon_sym_requires] = ACTIONS(3462),
    [sym_this] = ACTIONS(3462),
    [anon_sym_discard] = ACTIONS(3462),
    [anon_sym_precise] = ACTIONS(3462),
    [anon_sym_shared] = ACTIONS(3462),
    [anon_sym_groupshared] = ACTIONS(3462),
    [anon_sym_uniform] = ACTIONS(3462),
    [anon_sym_row_major] = ACTIONS(3462),
    [anon_sym_column_major] = ACTIONS(3462),
    [anon_sym_globallycoherent] = ACTIONS(3462),
    [anon_sym_centroid] = ACTIONS(3462),
    [anon_sym_noperspective] = ACTIONS(3462),
    [anon_sym_nointerpolation] = ACTIONS(3462),
    [anon_sym_sample] = ACTIONS(3462),
    [anon_sym_linear] = ACTIONS(3462),
    [anon_sym_snorm] = ACTIONS(3462),
    [anon_sym_unorm] = ACTIONS(3462),
    [anon_sym_point] = ACTIONS(3462),
    [anon_sym_line] = ACTIONS(3462),
    [anon_sym_triangleadj] = ACTIONS(3462),
    [anon_sym_lineadj] = ACTIONS(3462),
    [anon_sym_triangle] = ACTIONS(3462),
    [anon_sym_cbuffer] = ACTIONS(3462),
    [anon_sym_interface] = ACTIONS(3462),
    [anon_sym_extension] = ACTIONS(3462),
  },
  [1383] = {
    [sym_identifier] = ACTIONS(3645),
    [anon_sym_LPAREN2] = ACTIONS(3647),
    [anon_sym_BANG] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3647),
    [anon_sym_DASH] = ACTIONS(3645),
    [anon_sym_PLUS] = ACTIONS(3645),
    [anon_sym_STAR] = ACTIONS(3647),
    [anon_sym_AMP] = ACTIONS(3647),
    [anon_sym_SEMI] = ACTIONS(3647),
    [anon_sym___extension__] = ACTIONS(3645),
    [anon_sym_typedef] = ACTIONS(3645),
    [anon_sym_in] = ACTIONS(3645),
    [anon_sym_out] = ACTIONS(3645),
    [anon_sym_inout] = ACTIONS(3645),
    [anon_sym_virtual] = ACTIONS(3645),
    [anon_sym_extern] = ACTIONS(3645),
    [anon_sym___attribute__] = ACTIONS(3645),
    [anon_sym___attribute] = ACTIONS(3645),
    [anon_sym_COLON_COLON] = ACTIONS(3647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3647),
    [anon_sym___declspec] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(3647),
    [anon_sym_signed] = ACTIONS(3645),
    [anon_sym_unsigned] = ACTIONS(3645),
    [anon_sym_long] = ACTIONS(3645),
    [anon_sym_short] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_static] = ACTIONS(3645),
    [anon_sym_register] = ACTIONS(3645),
    [anon_sym_inline] = ACTIONS(3645),
    [anon_sym___inline] = ACTIONS(3645),
    [anon_sym___inline__] = ACTIONS(3645),
    [anon_sym___forceinline] = ACTIONS(3645),
    [anon_sym_thread_local] = ACTIONS(3645),
    [anon_sym___thread] = ACTIONS(3645),
    [anon_sym_const] = ACTIONS(3645),
    [anon_sym_constexpr] = ACTIONS(3645),
    [anon_sym_volatile] = ACTIONS(3645),
    [anon_sym_restrict] = ACTIONS(3645),
    [anon_sym___restrict__] = ACTIONS(3645),
    [anon_sym__Atomic] = ACTIONS(3645),
    [anon_sym__Noreturn] = ACTIONS(3645),
    [anon_sym_noreturn] = ACTIONS(3645),
    [anon_sym__Nonnull] = ACTIONS(3645),
    [anon_sym_mutable] = ACTIONS(3645),
    [anon_sym_constinit] = ACTIONS(3645),
    [anon_sym_consteval] = ACTIONS(3645),
    [anon_sym_alignas] = ACTIONS(3645),
    [anon_sym__Alignas] = ACTIONS(3645),
    [sym_primitive_type] = ACTIONS(3645),
    [anon_sym_enum] = ACTIONS(3645),
    [anon_sym_class] = ACTIONS(3645),
    [anon_sym_struct] = ACTIONS(3645),
    [anon_sym_union] = ACTIONS(3645),
    [anon_sym_if] = ACTIONS(3645),
    [anon_sym_else] = ACTIONS(3645),
    [anon_sym_switch] = ACTIONS(3645),
    [anon_sym_while] = ACTIONS(3645),
    [anon_sym_do] = ACTIONS(3645),
    [anon_sym_for] = ACTIONS(3645),
    [anon_sym_return] = ACTIONS(3645),
    [anon_sym_break] = ACTIONS(3645),
    [anon_sym_continue] = ACTIONS(3645),
    [anon_sym_goto] = ACTIONS(3645),
    [anon_sym___try] = ACTIONS(3645),
    [anon_sym___leave] = ACTIONS(3645),
    [anon_sym_not] = ACTIONS(3645),
    [anon_sym_compl] = ACTIONS(3645),
    [anon_sym_DASH_DASH] = ACTIONS(3647),
    [anon_sym_PLUS_PLUS] = ACTIONS(3647),
    [anon_sym_sizeof] = ACTIONS(3645),
    [anon_sym___alignof__] = ACTIONS(3645),
    [anon_sym___alignof] = ACTIONS(3645),
    [anon_sym__alignof] = ACTIONS(3645),
    [anon_sym_alignof] = ACTIONS(3645),
    [anon_sym__Alignof] = ACTIONS(3645),
    [anon_sym_offsetof] = ACTIONS(3645),
    [anon_sym__Generic] = ACTIONS(3645),
    [anon_sym_asm] = ACTIONS(3645),
    [anon_sym___asm__] = ACTIONS(3645),
    [anon_sym___asm] = ACTIONS(3645),
    [sym_number_literal] = ACTIONS(3647),
    [anon_sym_L_SQUOTE] = ACTIONS(3647),
    [anon_sym_u_SQUOTE] = ACTIONS(3647),
    [anon_sym_U_SQUOTE] = ACTIONS(3647),
    [anon_sym_u8_SQUOTE] = ACTIONS(3647),
    [anon_sym_SQUOTE] = ACTIONS(3647),
    [anon_sym_L_DQUOTE] = ACTIONS(3647),
    [anon_sym_u_DQUOTE] = ACTIONS(3647),
    [anon_sym_U_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8_DQUOTE] = ACTIONS(3647),
    [anon_sym_DQUOTE] = ACTIONS(3647),
    [sym_true] = ACTIONS(3645),
    [sym_false] = ACTIONS(3645),
    [anon_sym_NULL] = ACTIONS(3645),
    [anon_sym_nullptr] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3645),
    [anon_sym_let] = ACTIONS(3645),
    [anon_sym_This] = ACTIONS(3645),
    [anon_sym_decltype] = ACTIONS(3645),
    [anon_sym_typename] = ACTIONS(3645),
    [anon_sym_template] = ACTIONS(3645),
    [anon_sym_try] = ACTIONS(3645),
    [anon_sym_delete] = ACTIONS(3645),
    [anon_sym_throw] = ACTIONS(3645),
    [anon_sym_co_return] = ACTIONS(3645),
    [anon_sym_co_yield] = ACTIONS(3645),
    [anon_sym_R_DQUOTE] = ACTIONS(3647),
    [anon_sym_LR_DQUOTE] = ACTIONS(3647),
    [anon_sym_uR_DQUOTE] = ACTIONS(3647),
    [anon_sym_UR_DQUOTE] = ACTIONS(3647),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3647),
    [anon_sym_co_await] = ACTIONS(3645),
    [anon_sym_new] = ACTIONS(3645),
    [anon_sym_requires] = ACTIONS(3645),
    [sym_this] = ACTIONS(3645),
    [anon_sym_discard] = ACTIONS(3645),
    [anon_sym_precise] = ACTIONS(3645),
    [anon_sym_shared] = ACTIONS(3645),
    [anon_sym_groupshared] = ACTIONS(3645),
    [anon_sym_uniform] = ACTIONS(3645),
    [anon_sym_row_major] = ACTIONS(3645),
    [anon_sym_column_major] = ACTIONS(3645),
    [anon_sym_globallycoherent] = ACTIONS(3645),
    [anon_sym_centroid] = ACTIONS(3645),
    [anon_sym_noperspective] = ACTIONS(3645),
    [anon_sym_nointerpolation] = ACTIONS(3645),
    [anon_sym_sample] = ACTIONS(3645),
    [anon_sym_linear] = ACTIONS(3645),
    [anon_sym_snorm] = ACTIONS(3645),
    [anon_sym_unorm] = ACTIONS(3645),
    [anon_sym_point] = ACTIONS(3645),
    [anon_sym_line] = ACTIONS(3645),
    [anon_sym_triangleadj] = ACTIONS(3645),
    [anon_sym_lineadj] = ACTIONS(3645),
    [anon_sym_triangle] = ACTIONS(3645),
    [anon_sym_cbuffer] = ACTIONS(3645),
    [anon_sym_interface] = ACTIONS(3645),
    [anon_sym_extension] = ACTIONS(3645),
  },
  [1384] = {
    [sym_identifier] = ACTIONS(3649),
    [anon_sym_LPAREN2] = ACTIONS(3651),
    [anon_sym_BANG] = ACTIONS(3651),
    [anon_sym_TILDE] = ACTIONS(3651),
    [anon_sym_DASH] = ACTIONS(3649),
    [anon_sym_PLUS] = ACTIONS(3649),
    [anon_sym_STAR] = ACTIONS(3651),
    [anon_sym_AMP] = ACTIONS(3651),
    [anon_sym_SEMI] = ACTIONS(3651),
    [anon_sym___extension__] = ACTIONS(3649),
    [anon_sym_typedef] = ACTIONS(3649),
    [anon_sym_in] = ACTIONS(3649),
    [anon_sym_out] = ACTIONS(3649),
    [anon_sym_inout] = ACTIONS(3649),
    [anon_sym_virtual] = ACTIONS(3649),
    [anon_sym_extern] = ACTIONS(3649),
    [anon_sym___attribute__] = ACTIONS(3649),
    [anon_sym___attribute] = ACTIONS(3649),
    [anon_sym_COLON_COLON] = ACTIONS(3651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3651),
    [anon_sym___declspec] = ACTIONS(3649),
    [anon_sym_LBRACE] = ACTIONS(3651),
    [anon_sym_signed] = ACTIONS(3649),
    [anon_sym_unsigned] = ACTIONS(3649),
    [anon_sym_long] = ACTIONS(3649),
    [anon_sym_short] = ACTIONS(3649),
    [anon_sym_LBRACK] = ACTIONS(3649),
    [anon_sym_static] = ACTIONS(3649),
    [anon_sym_register] = ACTIONS(3649),
    [anon_sym_inline] = ACTIONS(3649),
    [anon_sym___inline] = ACTIONS(3649),
    [anon_sym___inline__] = ACTIONS(3649),
    [anon_sym___forceinline] = ACTIONS(3649),
    [anon_sym_thread_local] = ACTIONS(3649),
    [anon_sym___thread] = ACTIONS(3649),
    [anon_sym_const] = ACTIONS(3649),
    [anon_sym_constexpr] = ACTIONS(3649),
    [anon_sym_volatile] = ACTIONS(3649),
    [anon_sym_restrict] = ACTIONS(3649),
    [anon_sym___restrict__] = ACTIONS(3649),
    [anon_sym__Atomic] = ACTIONS(3649),
    [anon_sym__Noreturn] = ACTIONS(3649),
    [anon_sym_noreturn] = ACTIONS(3649),
    [anon_sym__Nonnull] = ACTIONS(3649),
    [anon_sym_mutable] = ACTIONS(3649),
    [anon_sym_constinit] = ACTIONS(3649),
    [anon_sym_consteval] = ACTIONS(3649),
    [anon_sym_alignas] = ACTIONS(3649),
    [anon_sym__Alignas] = ACTIONS(3649),
    [sym_primitive_type] = ACTIONS(3649),
    [anon_sym_enum] = ACTIONS(3649),
    [anon_sym_class] = ACTIONS(3649),
    [anon_sym_struct] = ACTIONS(3649),
    [anon_sym_union] = ACTIONS(3649),
    [anon_sym_if] = ACTIONS(3649),
    [anon_sym_else] = ACTIONS(3649),
    [anon_sym_switch] = ACTIONS(3649),
    [anon_sym_while] = ACTIONS(3649),
    [anon_sym_do] = ACTIONS(3649),
    [anon_sym_for] = ACTIONS(3649),
    [anon_sym_return] = ACTIONS(3649),
    [anon_sym_break] = ACTIONS(3649),
    [anon_sym_continue] = ACTIONS(3649),
    [anon_sym_goto] = ACTIONS(3649),
    [anon_sym___try] = ACTIONS(3649),
    [anon_sym___leave] = ACTIONS(3649),
    [anon_sym_not] = ACTIONS(3649),
    [anon_sym_compl] = ACTIONS(3649),
    [anon_sym_DASH_DASH] = ACTIONS(3651),
    [anon_sym_PLUS_PLUS] = ACTIONS(3651),
    [anon_sym_sizeof] = ACTIONS(3649),
    [anon_sym___alignof__] = ACTIONS(3649),
    [anon_sym___alignof] = ACTIONS(3649),
    [anon_sym__alignof] = ACTIONS(3649),
    [anon_sym_alignof] = ACTIONS(3649),
    [anon_sym__Alignof] = ACTIONS(3649),
    [anon_sym_offsetof] = ACTIONS(3649),
    [anon_sym__Generic] = ACTIONS(3649),
    [anon_sym_asm] = ACTIONS(3649),
    [anon_sym___asm__] = ACTIONS(3649),
    [anon_sym___asm] = ACTIONS(3649),
    [sym_number_literal] = ACTIONS(3651),
    [anon_sym_L_SQUOTE] = ACTIONS(3651),
    [anon_sym_u_SQUOTE] = ACTIONS(3651),
    [anon_sym_U_SQUOTE] = ACTIONS(3651),
    [anon_sym_u8_SQUOTE] = ACTIONS(3651),
    [anon_sym_SQUOTE] = ACTIONS(3651),
    [anon_sym_L_DQUOTE] = ACTIONS(3651),
    [anon_sym_u_DQUOTE] = ACTIONS(3651),
    [anon_sym_U_DQUOTE] = ACTIONS(3651),
    [anon_sym_u8_DQUOTE] = ACTIONS(3651),
    [anon_sym_DQUOTE] = ACTIONS(3651),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [anon_sym_NULL] = ACTIONS(3649),
    [anon_sym_nullptr] = ACTIONS(3649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3649),
    [anon_sym_let] = ACTIONS(3649),
    [anon_sym_This] = ACTIONS(3649),
    [anon_sym_decltype] = ACTIONS(3649),
    [anon_sym_typename] = ACTIONS(3649),
    [anon_sym_template] = ACTIONS(3649),
    [anon_sym_try] = ACTIONS(3649),
    [anon_sym_delete] = ACTIONS(3649),
    [anon_sym_throw] = ACTIONS(3649),
    [anon_sym_co_return] = ACTIONS(3649),
    [anon_sym_co_yield] = ACTIONS(3649),
    [anon_sym_R_DQUOTE] = ACTIONS(3651),
    [anon_sym_LR_DQUOTE] = ACTIONS(3651),
    [anon_sym_uR_DQUOTE] = ACTIONS(3651),
    [anon_sym_UR_DQUOTE] = ACTIONS(3651),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3651),
    [anon_sym_co_await] = ACTIONS(3649),
    [anon_sym_new] = ACTIONS(3649),
    [anon_sym_requires] = ACTIONS(3649),
    [sym_this] = ACTIONS(3649),
    [anon_sym_discard] = ACTIONS(3649),
    [anon_sym_precise] = ACTIONS(3649),
    [anon_sym_shared] = ACTIONS(3649),
    [anon_sym_groupshared] = ACTIONS(3649),
    [anon_sym_uniform] = ACTIONS(3649),
    [anon_sym_row_major] = ACTIONS(3649),
    [anon_sym_column_major] = ACTIONS(3649),
    [anon_sym_globallycoherent] = ACTIONS(3649),
    [anon_sym_centroid] = ACTIONS(3649),
    [anon_sym_noperspective] = ACTIONS(3649),
    [anon_sym_nointerpolation] = ACTIONS(3649),
    [anon_sym_sample] = ACTIONS(3649),
    [anon_sym_linear] = ACTIONS(3649),
    [anon_sym_snorm] = ACTIONS(3649),
    [anon_sym_unorm] = ACTIONS(3649),
    [anon_sym_point] = ACTIONS(3649),
    [anon_sym_line] = ACTIONS(3649),
    [anon_sym_triangleadj] = ACTIONS(3649),
    [anon_sym_lineadj] = ACTIONS(3649),
    [anon_sym_triangle] = ACTIONS(3649),
    [anon_sym_cbuffer] = ACTIONS(3649),
    [anon_sym_interface] = ACTIONS(3649),
    [anon_sym_extension] = ACTIONS(3649),
  },
  [1385] = {
    [sym_identifier] = ACTIONS(3603),
    [anon_sym_LPAREN2] = ACTIONS(3601),
    [anon_sym_BANG] = ACTIONS(3601),
    [anon_sym_TILDE] = ACTIONS(3601),
    [anon_sym_DASH] = ACTIONS(3603),
    [anon_sym_PLUS] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(3601),
    [anon_sym_AMP] = ACTIONS(3601),
    [anon_sym_SEMI] = ACTIONS(3601),
    [anon_sym___extension__] = ACTIONS(3603),
    [anon_sym_typedef] = ACTIONS(3603),
    [anon_sym_in] = ACTIONS(3603),
    [anon_sym_out] = ACTIONS(3603),
    [anon_sym_inout] = ACTIONS(3603),
    [anon_sym_virtual] = ACTIONS(3603),
    [anon_sym_extern] = ACTIONS(3603),
    [anon_sym___attribute__] = ACTIONS(3603),
    [anon_sym___attribute] = ACTIONS(3603),
    [anon_sym_COLON_COLON] = ACTIONS(3601),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3601),
    [anon_sym___declspec] = ACTIONS(3603),
    [anon_sym_LBRACE] = ACTIONS(3601),
    [anon_sym_signed] = ACTIONS(3603),
    [anon_sym_unsigned] = ACTIONS(3603),
    [anon_sym_long] = ACTIONS(3603),
    [anon_sym_short] = ACTIONS(3603),
    [anon_sym_LBRACK] = ACTIONS(3603),
    [anon_sym_static] = ACTIONS(3603),
    [anon_sym_register] = ACTIONS(3603),
    [anon_sym_inline] = ACTIONS(3603),
    [anon_sym___inline] = ACTIONS(3603),
    [anon_sym___inline__] = ACTIONS(3603),
    [anon_sym___forceinline] = ACTIONS(3603),
    [anon_sym_thread_local] = ACTIONS(3603),
    [anon_sym___thread] = ACTIONS(3603),
    [anon_sym_const] = ACTIONS(3603),
    [anon_sym_constexpr] = ACTIONS(3603),
    [anon_sym_volatile] = ACTIONS(3603),
    [anon_sym_restrict] = ACTIONS(3603),
    [anon_sym___restrict__] = ACTIONS(3603),
    [anon_sym__Atomic] = ACTIONS(3603),
    [anon_sym__Noreturn] = ACTIONS(3603),
    [anon_sym_noreturn] = ACTIONS(3603),
    [anon_sym__Nonnull] = ACTIONS(3603),
    [anon_sym_mutable] = ACTIONS(3603),
    [anon_sym_constinit] = ACTIONS(3603),
    [anon_sym_consteval] = ACTIONS(3603),
    [anon_sym_alignas] = ACTIONS(3603),
    [anon_sym__Alignas] = ACTIONS(3603),
    [sym_primitive_type] = ACTIONS(3603),
    [anon_sym_enum] = ACTIONS(3603),
    [anon_sym_class] = ACTIONS(3603),
    [anon_sym_struct] = ACTIONS(3603),
    [anon_sym_union] = ACTIONS(3603),
    [anon_sym_if] = ACTIONS(3603),
    [anon_sym_else] = ACTIONS(3603),
    [anon_sym_switch] = ACTIONS(3603),
    [anon_sym_while] = ACTIONS(3603),
    [anon_sym_do] = ACTIONS(3603),
    [anon_sym_for] = ACTIONS(3603),
    [anon_sym_return] = ACTIONS(3603),
    [anon_sym_break] = ACTIONS(3603),
    [anon_sym_continue] = ACTIONS(3603),
    [anon_sym_goto] = ACTIONS(3603),
    [anon_sym___try] = ACTIONS(3603),
    [anon_sym___leave] = ACTIONS(3603),
    [anon_sym_not] = ACTIONS(3603),
    [anon_sym_compl] = ACTIONS(3603),
    [anon_sym_DASH_DASH] = ACTIONS(3601),
    [anon_sym_PLUS_PLUS] = ACTIONS(3601),
    [anon_sym_sizeof] = ACTIONS(3603),
    [anon_sym___alignof__] = ACTIONS(3603),
    [anon_sym___alignof] = ACTIONS(3603),
    [anon_sym__alignof] = ACTIONS(3603),
    [anon_sym_alignof] = ACTIONS(3603),
    [anon_sym__Alignof] = ACTIONS(3603),
    [anon_sym_offsetof] = ACTIONS(3603),
    [anon_sym__Generic] = ACTIONS(3603),
    [anon_sym_asm] = ACTIONS(3603),
    [anon_sym___asm__] = ACTIONS(3603),
    [anon_sym___asm] = ACTIONS(3603),
    [sym_number_literal] = ACTIONS(3601),
    [anon_sym_L_SQUOTE] = ACTIONS(3601),
    [anon_sym_u_SQUOTE] = ACTIONS(3601),
    [anon_sym_U_SQUOTE] = ACTIONS(3601),
    [anon_sym_u8_SQUOTE] = ACTIONS(3601),
    [anon_sym_SQUOTE] = ACTIONS(3601),
    [anon_sym_L_DQUOTE] = ACTIONS(3601),
    [anon_sym_u_DQUOTE] = ACTIONS(3601),
    [anon_sym_U_DQUOTE] = ACTIONS(3601),
    [anon_sym_u8_DQUOTE] = ACTIONS(3601),
    [anon_sym_DQUOTE] = ACTIONS(3601),
    [sym_true] = ACTIONS(3603),
    [sym_false] = ACTIONS(3603),
    [anon_sym_NULL] = ACTIONS(3603),
    [anon_sym_nullptr] = ACTIONS(3603),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3603),
    [anon_sym_let] = ACTIONS(3603),
    [anon_sym_This] = ACTIONS(3603),
    [anon_sym_decltype] = ACTIONS(3603),
    [anon_sym_typename] = ACTIONS(3603),
    [anon_sym_template] = ACTIONS(3603),
    [anon_sym_try] = ACTIONS(3603),
    [anon_sym_delete] = ACTIONS(3603),
    [anon_sym_throw] = ACTIONS(3603),
    [anon_sym_co_return] = ACTIONS(3603),
    [anon_sym_co_yield] = ACTIONS(3603),
    [anon_sym_R_DQUOTE] = ACTIONS(3601),
    [anon_sym_LR_DQUOTE] = ACTIONS(3601),
    [anon_sym_uR_DQUOTE] = ACTIONS(3601),
    [anon_sym_UR_DQUOTE] = ACTIONS(3601),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3601),
    [anon_sym_co_await] = ACTIONS(3603),
    [anon_sym_new] = ACTIONS(3603),
    [anon_sym_requires] = ACTIONS(3603),
    [sym_this] = ACTIONS(3603),
    [anon_sym_discard] = ACTIONS(3603),
    [anon_sym_precise] = ACTIONS(3603),
    [anon_sym_shared] = ACTIONS(3603),
    [anon_sym_groupshared] = ACTIONS(3603),
    [anon_sym_uniform] = ACTIONS(3603),
    [anon_sym_row_major] = ACTIONS(3603),
    [anon_sym_column_major] = ACTIONS(3603),
    [anon_sym_globallycoherent] = ACTIONS(3603),
    [anon_sym_centroid] = ACTIONS(3603),
    [anon_sym_noperspective] = ACTIONS(3603),
    [anon_sym_nointerpolation] = ACTIONS(3603),
    [anon_sym_sample] = ACTIONS(3603),
    [anon_sym_linear] = ACTIONS(3603),
    [anon_sym_snorm] = ACTIONS(3603),
    [anon_sym_unorm] = ACTIONS(3603),
    [anon_sym_point] = ACTIONS(3603),
    [anon_sym_line] = ACTIONS(3603),
    [anon_sym_triangleadj] = ACTIONS(3603),
    [anon_sym_lineadj] = ACTIONS(3603),
    [anon_sym_triangle] = ACTIONS(3603),
    [anon_sym_cbuffer] = ACTIONS(3603),
    [anon_sym_interface] = ACTIONS(3603),
    [anon_sym_extension] = ACTIONS(3603),
  },
  [1386] = {
    [sym_identifier] = ACTIONS(3607),
    [anon_sym_LPAREN2] = ACTIONS(3605),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(3605),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym_SEMI] = ACTIONS(3605),
    [anon_sym___extension__] = ACTIONS(3607),
    [anon_sym_typedef] = ACTIONS(3607),
    [anon_sym_in] = ACTIONS(3607),
    [anon_sym_out] = ACTIONS(3607),
    [anon_sym_inout] = ACTIONS(3607),
    [anon_sym_virtual] = ACTIONS(3607),
    [anon_sym_extern] = ACTIONS(3607),
    [anon_sym___attribute__] = ACTIONS(3607),
    [anon_sym___attribute] = ACTIONS(3607),
    [anon_sym_COLON_COLON] = ACTIONS(3605),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3605),
    [anon_sym___declspec] = ACTIONS(3607),
    [anon_sym_LBRACE] = ACTIONS(3605),
    [anon_sym_signed] = ACTIONS(3607),
    [anon_sym_unsigned] = ACTIONS(3607),
    [anon_sym_long] = ACTIONS(3607),
    [anon_sym_short] = ACTIONS(3607),
    [anon_sym_LBRACK] = ACTIONS(3607),
    [anon_sym_static] = ACTIONS(3607),
    [anon_sym_register] = ACTIONS(3607),
    [anon_sym_inline] = ACTIONS(3607),
    [anon_sym___inline] = ACTIONS(3607),
    [anon_sym___inline__] = ACTIONS(3607),
    [anon_sym___forceinline] = ACTIONS(3607),
    [anon_sym_thread_local] = ACTIONS(3607),
    [anon_sym___thread] = ACTIONS(3607),
    [anon_sym_const] = ACTIONS(3607),
    [anon_sym_constexpr] = ACTIONS(3607),
    [anon_sym_volatile] = ACTIONS(3607),
    [anon_sym_restrict] = ACTIONS(3607),
    [anon_sym___restrict__] = ACTIONS(3607),
    [anon_sym__Atomic] = ACTIONS(3607),
    [anon_sym__Noreturn] = ACTIONS(3607),
    [anon_sym_noreturn] = ACTIONS(3607),
    [anon_sym__Nonnull] = ACTIONS(3607),
    [anon_sym_mutable] = ACTIONS(3607),
    [anon_sym_constinit] = ACTIONS(3607),
    [anon_sym_consteval] = ACTIONS(3607),
    [anon_sym_alignas] = ACTIONS(3607),
    [anon_sym__Alignas] = ACTIONS(3607),
    [sym_primitive_type] = ACTIONS(3607),
    [anon_sym_enum] = ACTIONS(3607),
    [anon_sym_class] = ACTIONS(3607),
    [anon_sym_struct] = ACTIONS(3607),
    [anon_sym_union] = ACTIONS(3607),
    [anon_sym_if] = ACTIONS(3607),
    [anon_sym_else] = ACTIONS(3607),
    [anon_sym_switch] = ACTIONS(3607),
    [anon_sym_while] = ACTIONS(3607),
    [anon_sym_do] = ACTIONS(3607),
    [anon_sym_for] = ACTIONS(3607),
    [anon_sym_return] = ACTIONS(3607),
    [anon_sym_break] = ACTIONS(3607),
    [anon_sym_continue] = ACTIONS(3607),
    [anon_sym_goto] = ACTIONS(3607),
    [anon_sym___try] = ACTIONS(3607),
    [anon_sym___leave] = ACTIONS(3607),
    [anon_sym_not] = ACTIONS(3607),
    [anon_sym_compl] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(3605),
    [anon_sym_PLUS_PLUS] = ACTIONS(3605),
    [anon_sym_sizeof] = ACTIONS(3607),
    [anon_sym___alignof__] = ACTIONS(3607),
    [anon_sym___alignof] = ACTIONS(3607),
    [anon_sym__alignof] = ACTIONS(3607),
    [anon_sym_alignof] = ACTIONS(3607),
    [anon_sym__Alignof] = ACTIONS(3607),
    [anon_sym_offsetof] = ACTIONS(3607),
    [anon_sym__Generic] = ACTIONS(3607),
    [anon_sym_asm] = ACTIONS(3607),
    [anon_sym___asm__] = ACTIONS(3607),
    [anon_sym___asm] = ACTIONS(3607),
    [sym_number_literal] = ACTIONS(3605),
    [anon_sym_L_SQUOTE] = ACTIONS(3605),
    [anon_sym_u_SQUOTE] = ACTIONS(3605),
    [anon_sym_U_SQUOTE] = ACTIONS(3605),
    [anon_sym_u8_SQUOTE] = ACTIONS(3605),
    [anon_sym_SQUOTE] = ACTIONS(3605),
    [anon_sym_L_DQUOTE] = ACTIONS(3605),
    [anon_sym_u_DQUOTE] = ACTIONS(3605),
    [anon_sym_U_DQUOTE] = ACTIONS(3605),
    [anon_sym_u8_DQUOTE] = ACTIONS(3605),
    [anon_sym_DQUOTE] = ACTIONS(3605),
    [sym_true] = ACTIONS(3607),
    [sym_false] = ACTIONS(3607),
    [anon_sym_NULL] = ACTIONS(3607),
    [anon_sym_nullptr] = ACTIONS(3607),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3607),
    [anon_sym_let] = ACTIONS(3607),
    [anon_sym_This] = ACTIONS(3607),
    [anon_sym_decltype] = ACTIONS(3607),
    [anon_sym_typename] = ACTIONS(3607),
    [anon_sym_template] = ACTIONS(3607),
    [anon_sym_try] = ACTIONS(3607),
    [anon_sym_delete] = ACTIONS(3607),
    [anon_sym_throw] = ACTIONS(3607),
    [anon_sym_co_return] = ACTIONS(3607),
    [anon_sym_co_yield] = ACTIONS(3607),
    [anon_sym_R_DQUOTE] = ACTIONS(3605),
    [anon_sym_LR_DQUOTE] = ACTIONS(3605),
    [anon_sym_uR_DQUOTE] = ACTIONS(3605),
    [anon_sym_UR_DQUOTE] = ACTIONS(3605),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3605),
    [anon_sym_co_await] = ACTIONS(3607),
    [anon_sym_new] = ACTIONS(3607),
    [anon_sym_requires] = ACTIONS(3607),
    [sym_this] = ACTIONS(3607),
    [anon_sym_discard] = ACTIONS(3607),
    [anon_sym_precise] = ACTIONS(3607),
    [anon_sym_shared] = ACTIONS(3607),
    [anon_sym_groupshared] = ACTIONS(3607),
    [anon_sym_uniform] = ACTIONS(3607),
    [anon_sym_row_major] = ACTIONS(3607),
    [anon_sym_column_major] = ACTIONS(3607),
    [anon_sym_globallycoherent] = ACTIONS(3607),
    [anon_sym_centroid] = ACTIONS(3607),
    [anon_sym_noperspective] = ACTIONS(3607),
    [anon_sym_nointerpolation] = ACTIONS(3607),
    [anon_sym_sample] = ACTIONS(3607),
    [anon_sym_linear] = ACTIONS(3607),
    [anon_sym_snorm] = ACTIONS(3607),
    [anon_sym_unorm] = ACTIONS(3607),
    [anon_sym_point] = ACTIONS(3607),
    [anon_sym_line] = ACTIONS(3607),
    [anon_sym_triangleadj] = ACTIONS(3607),
    [anon_sym_lineadj] = ACTIONS(3607),
    [anon_sym_triangle] = ACTIONS(3607),
    [anon_sym_cbuffer] = ACTIONS(3607),
    [anon_sym_interface] = ACTIONS(3607),
    [anon_sym_extension] = ACTIONS(3607),
  },
  [1387] = {
    [sym_identifier] = ACTIONS(3611),
    [anon_sym_LPAREN2] = ACTIONS(3609),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3611),
    [anon_sym_PLUS] = ACTIONS(3611),
    [anon_sym_STAR] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(3609),
    [anon_sym_SEMI] = ACTIONS(3609),
    [anon_sym___extension__] = ACTIONS(3611),
    [anon_sym_typedef] = ACTIONS(3611),
    [anon_sym_in] = ACTIONS(3611),
    [anon_sym_out] = ACTIONS(3611),
    [anon_sym_inout] = ACTIONS(3611),
    [anon_sym_virtual] = ACTIONS(3611),
    [anon_sym_extern] = ACTIONS(3611),
    [anon_sym___attribute__] = ACTIONS(3611),
    [anon_sym___attribute] = ACTIONS(3611),
    [anon_sym_COLON_COLON] = ACTIONS(3609),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3609),
    [anon_sym___declspec] = ACTIONS(3611),
    [anon_sym_LBRACE] = ACTIONS(3609),
    [anon_sym_signed] = ACTIONS(3611),
    [anon_sym_unsigned] = ACTIONS(3611),
    [anon_sym_long] = ACTIONS(3611),
    [anon_sym_short] = ACTIONS(3611),
    [anon_sym_LBRACK] = ACTIONS(3611),
    [anon_sym_static] = ACTIONS(3611),
    [anon_sym_register] = ACTIONS(3611),
    [anon_sym_inline] = ACTIONS(3611),
    [anon_sym___inline] = ACTIONS(3611),
    [anon_sym___inline__] = ACTIONS(3611),
    [anon_sym___forceinline] = ACTIONS(3611),
    [anon_sym_thread_local] = ACTIONS(3611),
    [anon_sym___thread] = ACTIONS(3611),
    [anon_sym_const] = ACTIONS(3611),
    [anon_sym_constexpr] = ACTIONS(3611),
    [anon_sym_volatile] = ACTIONS(3611),
    [anon_sym_restrict] = ACTIONS(3611),
    [anon_sym___restrict__] = ACTIONS(3611),
    [anon_sym__Atomic] = ACTIONS(3611),
    [anon_sym__Noreturn] = ACTIONS(3611),
    [anon_sym_noreturn] = ACTIONS(3611),
    [anon_sym__Nonnull] = ACTIONS(3611),
    [anon_sym_mutable] = ACTIONS(3611),
    [anon_sym_constinit] = ACTIONS(3611),
    [anon_sym_consteval] = ACTIONS(3611),
    [anon_sym_alignas] = ACTIONS(3611),
    [anon_sym__Alignas] = ACTIONS(3611),
    [sym_primitive_type] = ACTIONS(3611),
    [anon_sym_enum] = ACTIONS(3611),
    [anon_sym_class] = ACTIONS(3611),
    [anon_sym_struct] = ACTIONS(3611),
    [anon_sym_union] = ACTIONS(3611),
    [anon_sym_if] = ACTIONS(3611),
    [anon_sym_else] = ACTIONS(3611),
    [anon_sym_switch] = ACTIONS(3611),
    [anon_sym_while] = ACTIONS(3611),
    [anon_sym_do] = ACTIONS(3611),
    [anon_sym_for] = ACTIONS(3611),
    [anon_sym_return] = ACTIONS(3611),
    [anon_sym_break] = ACTIONS(3611),
    [anon_sym_continue] = ACTIONS(3611),
    [anon_sym_goto] = ACTIONS(3611),
    [anon_sym___try] = ACTIONS(3611),
    [anon_sym___leave] = ACTIONS(3611),
    [anon_sym_not] = ACTIONS(3611),
    [anon_sym_compl] = ACTIONS(3611),
    [anon_sym_DASH_DASH] = ACTIONS(3609),
    [anon_sym_PLUS_PLUS] = ACTIONS(3609),
    [anon_sym_sizeof] = ACTIONS(3611),
    [anon_sym___alignof__] = ACTIONS(3611),
    [anon_sym___alignof] = ACTIONS(3611),
    [anon_sym__alignof] = ACTIONS(3611),
    [anon_sym_alignof] = ACTIONS(3611),
    [anon_sym__Alignof] = ACTIONS(3611),
    [anon_sym_offsetof] = ACTIONS(3611),
    [anon_sym__Generic] = ACTIONS(3611),
    [anon_sym_asm] = ACTIONS(3611),
    [anon_sym___asm__] = ACTIONS(3611),
    [anon_sym___asm] = ACTIONS(3611),
    [sym_number_literal] = ACTIONS(3609),
    [anon_sym_L_SQUOTE] = ACTIONS(3609),
    [anon_sym_u_SQUOTE] = ACTIONS(3609),
    [anon_sym_U_SQUOTE] = ACTIONS(3609),
    [anon_sym_u8_SQUOTE] = ACTIONS(3609),
    [anon_sym_SQUOTE] = ACTIONS(3609),
    [anon_sym_L_DQUOTE] = ACTIONS(3609),
    [anon_sym_u_DQUOTE] = ACTIONS(3609),
    [anon_sym_U_DQUOTE] = ACTIONS(3609),
    [anon_sym_u8_DQUOTE] = ACTIONS(3609),
    [anon_sym_DQUOTE] = ACTIONS(3609),
    [sym_true] = ACTIONS(3611),
    [sym_false] = ACTIONS(3611),
    [anon_sym_NULL] = ACTIONS(3611),
    [anon_sym_nullptr] = ACTIONS(3611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3611),
    [anon_sym_let] = ACTIONS(3611),
    [anon_sym_This] = ACTIONS(3611),
    [anon_sym_decltype] = ACTIONS(3611),
    [anon_sym_typename] = ACTIONS(3611),
    [anon_sym_template] = ACTIONS(3611),
    [anon_sym_try] = ACTIONS(3611),
    [anon_sym_delete] = ACTIONS(3611),
    [anon_sym_throw] = ACTIONS(3611),
    [anon_sym_co_return] = ACTIONS(3611),
    [anon_sym_co_yield] = ACTIONS(3611),
    [anon_sym_R_DQUOTE] = ACTIONS(3609),
    [anon_sym_LR_DQUOTE] = ACTIONS(3609),
    [anon_sym_uR_DQUOTE] = ACTIONS(3609),
    [anon_sym_UR_DQUOTE] = ACTIONS(3609),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3609),
    [anon_sym_co_await] = ACTIONS(3611),
    [anon_sym_new] = ACTIONS(3611),
    [anon_sym_requires] = ACTIONS(3611),
    [sym_this] = ACTIONS(3611),
    [anon_sym_discard] = ACTIONS(3611),
    [anon_sym_precise] = ACTIONS(3611),
    [anon_sym_shared] = ACTIONS(3611),
    [anon_sym_groupshared] = ACTIONS(3611),
    [anon_sym_uniform] = ACTIONS(3611),
    [anon_sym_row_major] = ACTIONS(3611),
    [anon_sym_column_major] = ACTIONS(3611),
    [anon_sym_globallycoherent] = ACTIONS(3611),
    [anon_sym_centroid] = ACTIONS(3611),
    [anon_sym_noperspective] = ACTIONS(3611),
    [anon_sym_nointerpolation] = ACTIONS(3611),
    [anon_sym_sample] = ACTIONS(3611),
    [anon_sym_linear] = ACTIONS(3611),
    [anon_sym_snorm] = ACTIONS(3611),
    [anon_sym_unorm] = ACTIONS(3611),
    [anon_sym_point] = ACTIONS(3611),
    [anon_sym_line] = ACTIONS(3611),
    [anon_sym_triangleadj] = ACTIONS(3611),
    [anon_sym_lineadj] = ACTIONS(3611),
    [anon_sym_triangle] = ACTIONS(3611),
    [anon_sym_cbuffer] = ACTIONS(3611),
    [anon_sym_interface] = ACTIONS(3611),
    [anon_sym_extension] = ACTIONS(3611),
  },
  [1388] = {
    [sym_identifier] = ACTIONS(3615),
    [anon_sym_LPAREN2] = ACTIONS(3613),
    [anon_sym_BANG] = ACTIONS(3613),
    [anon_sym_TILDE] = ACTIONS(3613),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3613),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_SEMI] = ACTIONS(3613),
    [anon_sym___extension__] = ACTIONS(3615),
    [anon_sym_typedef] = ACTIONS(3615),
    [anon_sym_in] = ACTIONS(3615),
    [anon_sym_out] = ACTIONS(3615),
    [anon_sym_inout] = ACTIONS(3615),
    [anon_sym_virtual] = ACTIONS(3615),
    [anon_sym_extern] = ACTIONS(3615),
    [anon_sym___attribute__] = ACTIONS(3615),
    [anon_sym___attribute] = ACTIONS(3615),
    [anon_sym_COLON_COLON] = ACTIONS(3613),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3613),
    [anon_sym___declspec] = ACTIONS(3615),
    [anon_sym_LBRACE] = ACTIONS(3613),
    [anon_sym_signed] = ACTIONS(3615),
    [anon_sym_unsigned] = ACTIONS(3615),
    [anon_sym_long] = ACTIONS(3615),
    [anon_sym_short] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(3615),
    [anon_sym_static] = ACTIONS(3615),
    [anon_sym_register] = ACTIONS(3615),
    [anon_sym_inline] = ACTIONS(3615),
    [anon_sym___inline] = ACTIONS(3615),
    [anon_sym___inline__] = ACTIONS(3615),
    [anon_sym___forceinline] = ACTIONS(3615),
    [anon_sym_thread_local] = ACTIONS(3615),
    [anon_sym___thread] = ACTIONS(3615),
    [anon_sym_const] = ACTIONS(3615),
    [anon_sym_constexpr] = ACTIONS(3615),
    [anon_sym_volatile] = ACTIONS(3615),
    [anon_sym_restrict] = ACTIONS(3615),
    [anon_sym___restrict__] = ACTIONS(3615),
    [anon_sym__Atomic] = ACTIONS(3615),
    [anon_sym__Noreturn] = ACTIONS(3615),
    [anon_sym_noreturn] = ACTIONS(3615),
    [anon_sym__Nonnull] = ACTIONS(3615),
    [anon_sym_mutable] = ACTIONS(3615),
    [anon_sym_constinit] = ACTIONS(3615),
    [anon_sym_consteval] = ACTIONS(3615),
    [anon_sym_alignas] = ACTIONS(3615),
    [anon_sym__Alignas] = ACTIONS(3615),
    [sym_primitive_type] = ACTIONS(3615),
    [anon_sym_enum] = ACTIONS(3615),
    [anon_sym_class] = ACTIONS(3615),
    [anon_sym_struct] = ACTIONS(3615),
    [anon_sym_union] = ACTIONS(3615),
    [anon_sym_if] = ACTIONS(3615),
    [anon_sym_else] = ACTIONS(3615),
    [anon_sym_switch] = ACTIONS(3615),
    [anon_sym_while] = ACTIONS(3615),
    [anon_sym_do] = ACTIONS(3615),
    [anon_sym_for] = ACTIONS(3615),
    [anon_sym_return] = ACTIONS(3615),
    [anon_sym_break] = ACTIONS(3615),
    [anon_sym_continue] = ACTIONS(3615),
    [anon_sym_goto] = ACTIONS(3615),
    [anon_sym___try] = ACTIONS(3615),
    [anon_sym___leave] = ACTIONS(3615),
    [anon_sym_not] = ACTIONS(3615),
    [anon_sym_compl] = ACTIONS(3615),
    [anon_sym_DASH_DASH] = ACTIONS(3613),
    [anon_sym_PLUS_PLUS] = ACTIONS(3613),
    [anon_sym_sizeof] = ACTIONS(3615),
    [anon_sym___alignof__] = ACTIONS(3615),
    [anon_sym___alignof] = ACTIONS(3615),
    [anon_sym__alignof] = ACTIONS(3615),
    [anon_sym_alignof] = ACTIONS(3615),
    [anon_sym__Alignof] = ACTIONS(3615),
    [anon_sym_offsetof] = ACTIONS(3615),
    [anon_sym__Generic] = ACTIONS(3615),
    [anon_sym_asm] = ACTIONS(3615),
    [anon_sym___asm__] = ACTIONS(3615),
    [anon_sym___asm] = ACTIONS(3615),
    [sym_number_literal] = ACTIONS(3613),
    [anon_sym_L_SQUOTE] = ACTIONS(3613),
    [anon_sym_u_SQUOTE] = ACTIONS(3613),
    [anon_sym_U_SQUOTE] = ACTIONS(3613),
    [anon_sym_u8_SQUOTE] = ACTIONS(3613),
    [anon_sym_SQUOTE] = ACTIONS(3613),
    [anon_sym_L_DQUOTE] = ACTIONS(3613),
    [anon_sym_u_DQUOTE] = ACTIONS(3613),
    [anon_sym_U_DQUOTE] = ACTIONS(3613),
    [anon_sym_u8_DQUOTE] = ACTIONS(3613),
    [anon_sym_DQUOTE] = ACTIONS(3613),
    [sym_true] = ACTIONS(3615),
    [sym_false] = ACTIONS(3615),
    [anon_sym_NULL] = ACTIONS(3615),
    [anon_sym_nullptr] = ACTIONS(3615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3615),
    [anon_sym_let] = ACTIONS(3615),
    [anon_sym_This] = ACTIONS(3615),
    [anon_sym_decltype] = ACTIONS(3615),
    [anon_sym_typename] = ACTIONS(3615),
    [anon_sym_template] = ACTIONS(3615),
    [anon_sym_try] = ACTIONS(3615),
    [anon_sym_delete] = ACTIONS(3615),
    [anon_sym_throw] = ACTIONS(3615),
    [anon_sym_co_return] = ACTIONS(3615),
    [anon_sym_co_yield] = ACTIONS(3615),
    [anon_sym_R_DQUOTE] = ACTIONS(3613),
    [anon_sym_LR_DQUOTE] = ACTIONS(3613),
    [anon_sym_uR_DQUOTE] = ACTIONS(3613),
    [anon_sym_UR_DQUOTE] = ACTIONS(3613),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3613),
    [anon_sym_co_await] = ACTIONS(3615),
    [anon_sym_new] = ACTIONS(3615),
    [anon_sym_requires] = ACTIONS(3615),
    [sym_this] = ACTIONS(3615),
    [anon_sym_discard] = ACTIONS(3615),
    [anon_sym_precise] = ACTIONS(3615),
    [anon_sym_shared] = ACTIONS(3615),
    [anon_sym_groupshared] = ACTIONS(3615),
    [anon_sym_uniform] = ACTIONS(3615),
    [anon_sym_row_major] = ACTIONS(3615),
    [anon_sym_column_major] = ACTIONS(3615),
    [anon_sym_globallycoherent] = ACTIONS(3615),
    [anon_sym_centroid] = ACTIONS(3615),
    [anon_sym_noperspective] = ACTIONS(3615),
    [anon_sym_nointerpolation] = ACTIONS(3615),
    [anon_sym_sample] = ACTIONS(3615),
    [anon_sym_linear] = ACTIONS(3615),
    [anon_sym_snorm] = ACTIONS(3615),
    [anon_sym_unorm] = ACTIONS(3615),
    [anon_sym_point] = ACTIONS(3615),
    [anon_sym_line] = ACTIONS(3615),
    [anon_sym_triangleadj] = ACTIONS(3615),
    [anon_sym_lineadj] = ACTIONS(3615),
    [anon_sym_triangle] = ACTIONS(3615),
    [anon_sym_cbuffer] = ACTIONS(3615),
    [anon_sym_interface] = ACTIONS(3615),
    [anon_sym_extension] = ACTIONS(3615),
  },
  [1389] = {
    [sym_identifier] = ACTIONS(3619),
    [anon_sym_LPAREN2] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_DASH] = ACTIONS(3619),
    [anon_sym_PLUS] = ACTIONS(3619),
    [anon_sym_STAR] = ACTIONS(3617),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym___extension__] = ACTIONS(3619),
    [anon_sym_typedef] = ACTIONS(3619),
    [anon_sym_in] = ACTIONS(3619),
    [anon_sym_out] = ACTIONS(3619),
    [anon_sym_inout] = ACTIONS(3619),
    [anon_sym_virtual] = ACTIONS(3619),
    [anon_sym_extern] = ACTIONS(3619),
    [anon_sym___attribute__] = ACTIONS(3619),
    [anon_sym___attribute] = ACTIONS(3619),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3617),
    [anon_sym___declspec] = ACTIONS(3619),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_signed] = ACTIONS(3619),
    [anon_sym_unsigned] = ACTIONS(3619),
    [anon_sym_long] = ACTIONS(3619),
    [anon_sym_short] = ACTIONS(3619),
    [anon_sym_LBRACK] = ACTIONS(3619),
    [anon_sym_static] = ACTIONS(3619),
    [anon_sym_register] = ACTIONS(3619),
    [anon_sym_inline] = ACTIONS(3619),
    [anon_sym___inline] = ACTIONS(3619),
    [anon_sym___inline__] = ACTIONS(3619),
    [anon_sym___forceinline] = ACTIONS(3619),
    [anon_sym_thread_local] = ACTIONS(3619),
    [anon_sym___thread] = ACTIONS(3619),
    [anon_sym_const] = ACTIONS(3619),
    [anon_sym_constexpr] = ACTIONS(3619),
    [anon_sym_volatile] = ACTIONS(3619),
    [anon_sym_restrict] = ACTIONS(3619),
    [anon_sym___restrict__] = ACTIONS(3619),
    [anon_sym__Atomic] = ACTIONS(3619),
    [anon_sym__Noreturn] = ACTIONS(3619),
    [anon_sym_noreturn] = ACTIONS(3619),
    [anon_sym__Nonnull] = ACTIONS(3619),
    [anon_sym_mutable] = ACTIONS(3619),
    [anon_sym_constinit] = ACTIONS(3619),
    [anon_sym_consteval] = ACTIONS(3619),
    [anon_sym_alignas] = ACTIONS(3619),
    [anon_sym__Alignas] = ACTIONS(3619),
    [sym_primitive_type] = ACTIONS(3619),
    [anon_sym_enum] = ACTIONS(3619),
    [anon_sym_class] = ACTIONS(3619),
    [anon_sym_struct] = ACTIONS(3619),
    [anon_sym_union] = ACTIONS(3619),
    [anon_sym_if] = ACTIONS(3619),
    [anon_sym_else] = ACTIONS(3619),
    [anon_sym_switch] = ACTIONS(3619),
    [anon_sym_while] = ACTIONS(3619),
    [anon_sym_do] = ACTIONS(3619),
    [anon_sym_for] = ACTIONS(3619),
    [anon_sym_return] = ACTIONS(3619),
    [anon_sym_break] = ACTIONS(3619),
    [anon_sym_continue] = ACTIONS(3619),
    [anon_sym_goto] = ACTIONS(3619),
    [anon_sym___try] = ACTIONS(3619),
    [anon_sym___leave] = ACTIONS(3619),
    [anon_sym_not] = ACTIONS(3619),
    [anon_sym_compl] = ACTIONS(3619),
    [anon_sym_DASH_DASH] = ACTIONS(3617),
    [anon_sym_PLUS_PLUS] = ACTIONS(3617),
    [anon_sym_sizeof] = ACTIONS(3619),
    [anon_sym___alignof__] = ACTIONS(3619),
    [anon_sym___alignof] = ACTIONS(3619),
    [anon_sym__alignof] = ACTIONS(3619),
    [anon_sym_alignof] = ACTIONS(3619),
    [anon_sym__Alignof] = ACTIONS(3619),
    [anon_sym_offsetof] = ACTIONS(3619),
    [anon_sym__Generic] = ACTIONS(3619),
    [anon_sym_asm] = ACTIONS(3619),
    [anon_sym___asm__] = ACTIONS(3619),
    [anon_sym___asm] = ACTIONS(3619),
    [sym_number_literal] = ACTIONS(3617),
    [anon_sym_L_SQUOTE] = ACTIONS(3617),
    [anon_sym_u_SQUOTE] = ACTIONS(3617),
    [anon_sym_U_SQUOTE] = ACTIONS(3617),
    [anon_sym_u8_SQUOTE] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3617),
    [anon_sym_L_DQUOTE] = ACTIONS(3617),
    [anon_sym_u_DQUOTE] = ACTIONS(3617),
    [anon_sym_U_DQUOTE] = ACTIONS(3617),
    [anon_sym_u8_DQUOTE] = ACTIONS(3617),
    [anon_sym_DQUOTE] = ACTIONS(3617),
    [sym_true] = ACTIONS(3619),
    [sym_false] = ACTIONS(3619),
    [anon_sym_NULL] = ACTIONS(3619),
    [anon_sym_nullptr] = ACTIONS(3619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3619),
    [anon_sym_let] = ACTIONS(3619),
    [anon_sym_This] = ACTIONS(3619),
    [anon_sym_decltype] = ACTIONS(3619),
    [anon_sym_typename] = ACTIONS(3619),
    [anon_sym_template] = ACTIONS(3619),
    [anon_sym_try] = ACTIONS(3619),
    [anon_sym_delete] = ACTIONS(3619),
    [anon_sym_throw] = ACTIONS(3619),
    [anon_sym_co_return] = ACTIONS(3619),
    [anon_sym_co_yield] = ACTIONS(3619),
    [anon_sym_R_DQUOTE] = ACTIONS(3617),
    [anon_sym_LR_DQUOTE] = ACTIONS(3617),
    [anon_sym_uR_DQUOTE] = ACTIONS(3617),
    [anon_sym_UR_DQUOTE] = ACTIONS(3617),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3617),
    [anon_sym_co_await] = ACTIONS(3619),
    [anon_sym_new] = ACTIONS(3619),
    [anon_sym_requires] = ACTIONS(3619),
    [sym_this] = ACTIONS(3619),
    [anon_sym_discard] = ACTIONS(3619),
    [anon_sym_precise] = ACTIONS(3619),
    [anon_sym_shared] = ACTIONS(3619),
    [anon_sym_groupshared] = ACTIONS(3619),
    [anon_sym_uniform] = ACTIONS(3619),
    [anon_sym_row_major] = ACTIONS(3619),
    [anon_sym_column_major] = ACTIONS(3619),
    [anon_sym_globallycoherent] = ACTIONS(3619),
    [anon_sym_centroid] = ACTIONS(3619),
    [anon_sym_noperspective] = ACTIONS(3619),
    [anon_sym_nointerpolation] = ACTIONS(3619),
    [anon_sym_sample] = ACTIONS(3619),
    [anon_sym_linear] = ACTIONS(3619),
    [anon_sym_snorm] = ACTIONS(3619),
    [anon_sym_unorm] = ACTIONS(3619),
    [anon_sym_point] = ACTIONS(3619),
    [anon_sym_line] = ACTIONS(3619),
    [anon_sym_triangleadj] = ACTIONS(3619),
    [anon_sym_lineadj] = ACTIONS(3619),
    [anon_sym_triangle] = ACTIONS(3619),
    [anon_sym_cbuffer] = ACTIONS(3619),
    [anon_sym_interface] = ACTIONS(3619),
    [anon_sym_extension] = ACTIONS(3619),
  },
  [1390] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(1605),
    [sym_raw_string_literal] = STATE(3527),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2764),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2172),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(5336),
    [anon_sym_SEMI] = ACTIONS(2183),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2193),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym___cdecl] = ACTIONS(2168),
    [anon_sym___clrcall] = ACTIONS(2168),
    [anon_sym___stdcall] = ACTIONS(2168),
    [anon_sym___fastcall] = ACTIONS(2168),
    [anon_sym___thiscall] = ACTIONS(2168),
    [anon_sym___vectorcall] = ACTIONS(2168),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_signed] = ACTIONS(5332),
    [anon_sym_unsigned] = ACTIONS(5332),
    [anon_sym_long] = ACTIONS(5332),
    [anon_sym_short] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2207),
    [anon_sym_SLASH_EQ] = ACTIONS(2207),
    [anon_sym_PERCENT_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_GT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_EQ] = ACTIONS(2207),
    [anon_sym_CARET_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_EQ] = ACTIONS(2207),
    [anon_sym_and_eq] = ACTIONS(2205),
    [anon_sym_or_eq] = ACTIONS(2205),
    [anon_sym_xor_eq] = ACTIONS(2205),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_decltype] = ACTIONS(2168),
    [anon_sym_template] = ACTIONS(2168),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
  },
  [1391] = {
    [sym_identifier] = ACTIONS(3379),
    [anon_sym_LPAREN2] = ACTIONS(3381),
    [anon_sym_BANG] = ACTIONS(3381),
    [anon_sym_TILDE] = ACTIONS(3381),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_STAR] = ACTIONS(3381),
    [anon_sym_AMP] = ACTIONS(3381),
    [anon_sym_SEMI] = ACTIONS(3381),
    [anon_sym___extension__] = ACTIONS(3379),
    [anon_sym_typedef] = ACTIONS(3379),
    [anon_sym_in] = ACTIONS(3379),
    [anon_sym_out] = ACTIONS(3379),
    [anon_sym_inout] = ACTIONS(3379),
    [anon_sym_virtual] = ACTIONS(3379),
    [anon_sym_extern] = ACTIONS(3379),
    [anon_sym___attribute__] = ACTIONS(3379),
    [anon_sym___attribute] = ACTIONS(3379),
    [anon_sym_COLON_COLON] = ACTIONS(3381),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3381),
    [anon_sym___declspec] = ACTIONS(3379),
    [anon_sym_LBRACE] = ACTIONS(3381),
    [anon_sym_signed] = ACTIONS(3379),
    [anon_sym_unsigned] = ACTIONS(3379),
    [anon_sym_long] = ACTIONS(3379),
    [anon_sym_short] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_register] = ACTIONS(3379),
    [anon_sym_inline] = ACTIONS(3379),
    [anon_sym___inline] = ACTIONS(3379),
    [anon_sym___inline__] = ACTIONS(3379),
    [anon_sym___forceinline] = ACTIONS(3379),
    [anon_sym_thread_local] = ACTIONS(3379),
    [anon_sym___thread] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_constexpr] = ACTIONS(3379),
    [anon_sym_volatile] = ACTIONS(3379),
    [anon_sym_restrict] = ACTIONS(3379),
    [anon_sym___restrict__] = ACTIONS(3379),
    [anon_sym__Atomic] = ACTIONS(3379),
    [anon_sym__Noreturn] = ACTIONS(3379),
    [anon_sym_noreturn] = ACTIONS(3379),
    [anon_sym__Nonnull] = ACTIONS(3379),
    [anon_sym_mutable] = ACTIONS(3379),
    [anon_sym_constinit] = ACTIONS(3379),
    [anon_sym_consteval] = ACTIONS(3379),
    [anon_sym_alignas] = ACTIONS(3379),
    [anon_sym__Alignas] = ACTIONS(3379),
    [sym_primitive_type] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_struct] = ACTIONS(3379),
    [anon_sym_union] = ACTIONS(3379),
    [anon_sym_if] = ACTIONS(3379),
    [anon_sym_else] = ACTIONS(3379),
    [anon_sym_switch] = ACTIONS(3379),
    [anon_sym_while] = ACTIONS(3379),
    [anon_sym_do] = ACTIONS(3379),
    [anon_sym_for] = ACTIONS(3379),
    [anon_sym_return] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(3379),
    [anon_sym_continue] = ACTIONS(3379),
    [anon_sym_goto] = ACTIONS(3379),
    [anon_sym___try] = ACTIONS(3379),
    [anon_sym___leave] = ACTIONS(3379),
    [anon_sym_not] = ACTIONS(3379),
    [anon_sym_compl] = ACTIONS(3379),
    [anon_sym_DASH_DASH] = ACTIONS(3381),
    [anon_sym_PLUS_PLUS] = ACTIONS(3381),
    [anon_sym_sizeof] = ACTIONS(3379),
    [anon_sym___alignof__] = ACTIONS(3379),
    [anon_sym___alignof] = ACTIONS(3379),
    [anon_sym__alignof] = ACTIONS(3379),
    [anon_sym_alignof] = ACTIONS(3379),
    [anon_sym__Alignof] = ACTIONS(3379),
    [anon_sym_offsetof] = ACTIONS(3379),
    [anon_sym__Generic] = ACTIONS(3379),
    [anon_sym_asm] = ACTIONS(3379),
    [anon_sym___asm__] = ACTIONS(3379),
    [anon_sym___asm] = ACTIONS(3379),
    [sym_number_literal] = ACTIONS(3381),
    [anon_sym_L_SQUOTE] = ACTIONS(3381),
    [anon_sym_u_SQUOTE] = ACTIONS(3381),
    [anon_sym_U_SQUOTE] = ACTIONS(3381),
    [anon_sym_u8_SQUOTE] = ACTIONS(3381),
    [anon_sym_SQUOTE] = ACTIONS(3381),
    [anon_sym_L_DQUOTE] = ACTIONS(3381),
    [anon_sym_u_DQUOTE] = ACTIONS(3381),
    [anon_sym_U_DQUOTE] = ACTIONS(3381),
    [anon_sym_u8_DQUOTE] = ACTIONS(3381),
    [anon_sym_DQUOTE] = ACTIONS(3381),
    [sym_true] = ACTIONS(3379),
    [sym_false] = ACTIONS(3379),
    [anon_sym_NULL] = ACTIONS(3379),
    [anon_sym_nullptr] = ACTIONS(3379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3379),
    [anon_sym_let] = ACTIONS(3379),
    [anon_sym_This] = ACTIONS(3379),
    [anon_sym_decltype] = ACTIONS(3379),
    [anon_sym_typename] = ACTIONS(3379),
    [anon_sym_template] = ACTIONS(3379),
    [anon_sym_try] = ACTIONS(3379),
    [anon_sym_delete] = ACTIONS(3379),
    [anon_sym_throw] = ACTIONS(3379),
    [anon_sym_co_return] = ACTIONS(3379),
    [anon_sym_co_yield] = ACTIONS(3379),
    [anon_sym_R_DQUOTE] = ACTIONS(3381),
    [anon_sym_LR_DQUOTE] = ACTIONS(3381),
    [anon_sym_uR_DQUOTE] = ACTIONS(3381),
    [anon_sym_UR_DQUOTE] = ACTIONS(3381),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3381),
    [anon_sym_co_await] = ACTIONS(3379),
    [anon_sym_new] = ACTIONS(3379),
    [anon_sym_requires] = ACTIONS(3379),
    [sym_this] = ACTIONS(3379),
    [anon_sym_discard] = ACTIONS(3379),
    [anon_sym_precise] = ACTIONS(3379),
    [anon_sym_shared] = ACTIONS(3379),
    [anon_sym_groupshared] = ACTIONS(3379),
    [anon_sym_uniform] = ACTIONS(3379),
    [anon_sym_row_major] = ACTIONS(3379),
    [anon_sym_column_major] = ACTIONS(3379),
    [anon_sym_globallycoherent] = ACTIONS(3379),
    [anon_sym_centroid] = ACTIONS(3379),
    [anon_sym_noperspective] = ACTIONS(3379),
    [anon_sym_nointerpolation] = ACTIONS(3379),
    [anon_sym_sample] = ACTIONS(3379),
    [anon_sym_linear] = ACTIONS(3379),
    [anon_sym_snorm] = ACTIONS(3379),
    [anon_sym_unorm] = ACTIONS(3379),
    [anon_sym_point] = ACTIONS(3379),
    [anon_sym_line] = ACTIONS(3379),
    [anon_sym_triangleadj] = ACTIONS(3379),
    [anon_sym_lineadj] = ACTIONS(3379),
    [anon_sym_triangle] = ACTIONS(3379),
    [anon_sym_cbuffer] = ACTIONS(3379),
    [anon_sym_interface] = ACTIONS(3379),
    [anon_sym_extension] = ACTIONS(3379),
  },
  [1392] = {
    [sym_identifier] = ACTIONS(3383),
    [anon_sym_LPAREN2] = ACTIONS(3385),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_TILDE] = ACTIONS(3385),
    [anon_sym_DASH] = ACTIONS(3383),
    [anon_sym_PLUS] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(3385),
    [anon_sym_AMP] = ACTIONS(3385),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym___extension__] = ACTIONS(3383),
    [anon_sym_typedef] = ACTIONS(3383),
    [anon_sym_in] = ACTIONS(3383),
    [anon_sym_out] = ACTIONS(3383),
    [anon_sym_inout] = ACTIONS(3383),
    [anon_sym_virtual] = ACTIONS(3383),
    [anon_sym_extern] = ACTIONS(3383),
    [anon_sym___attribute__] = ACTIONS(3383),
    [anon_sym___attribute] = ACTIONS(3383),
    [anon_sym_COLON_COLON] = ACTIONS(3385),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3385),
    [anon_sym___declspec] = ACTIONS(3383),
    [anon_sym_LBRACE] = ACTIONS(3385),
    [anon_sym_signed] = ACTIONS(3383),
    [anon_sym_unsigned] = ACTIONS(3383),
    [anon_sym_long] = ACTIONS(3383),
    [anon_sym_short] = ACTIONS(3383),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_static] = ACTIONS(3383),
    [anon_sym_register] = ACTIONS(3383),
    [anon_sym_inline] = ACTIONS(3383),
    [anon_sym___inline] = ACTIONS(3383),
    [anon_sym___inline__] = ACTIONS(3383),
    [anon_sym___forceinline] = ACTIONS(3383),
    [anon_sym_thread_local] = ACTIONS(3383),
    [anon_sym___thread] = ACTIONS(3383),
    [anon_sym_const] = ACTIONS(3383),
    [anon_sym_constexpr] = ACTIONS(3383),
    [anon_sym_volatile] = ACTIONS(3383),
    [anon_sym_restrict] = ACTIONS(3383),
    [anon_sym___restrict__] = ACTIONS(3383),
    [anon_sym__Atomic] = ACTIONS(3383),
    [anon_sym__Noreturn] = ACTIONS(3383),
    [anon_sym_noreturn] = ACTIONS(3383),
    [anon_sym__Nonnull] = ACTIONS(3383),
    [anon_sym_mutable] = ACTIONS(3383),
    [anon_sym_constinit] = ACTIONS(3383),
    [anon_sym_consteval] = ACTIONS(3383),
    [anon_sym_alignas] = ACTIONS(3383),
    [anon_sym__Alignas] = ACTIONS(3383),
    [sym_primitive_type] = ACTIONS(3383),
    [anon_sym_enum] = ACTIONS(3383),
    [anon_sym_class] = ACTIONS(3383),
    [anon_sym_struct] = ACTIONS(3383),
    [anon_sym_union] = ACTIONS(3383),
    [anon_sym_if] = ACTIONS(3383),
    [anon_sym_else] = ACTIONS(3383),
    [anon_sym_switch] = ACTIONS(3383),
    [anon_sym_while] = ACTIONS(3383),
    [anon_sym_do] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3383),
    [anon_sym_return] = ACTIONS(3383),
    [anon_sym_break] = ACTIONS(3383),
    [anon_sym_continue] = ACTIONS(3383),
    [anon_sym_goto] = ACTIONS(3383),
    [anon_sym___try] = ACTIONS(3383),
    [anon_sym___leave] = ACTIONS(3383),
    [anon_sym_not] = ACTIONS(3383),
    [anon_sym_compl] = ACTIONS(3383),
    [anon_sym_DASH_DASH] = ACTIONS(3385),
    [anon_sym_PLUS_PLUS] = ACTIONS(3385),
    [anon_sym_sizeof] = ACTIONS(3383),
    [anon_sym___alignof__] = ACTIONS(3383),
    [anon_sym___alignof] = ACTIONS(3383),
    [anon_sym__alignof] = ACTIONS(3383),
    [anon_sym_alignof] = ACTIONS(3383),
    [anon_sym__Alignof] = ACTIONS(3383),
    [anon_sym_offsetof] = ACTIONS(3383),
    [anon_sym__Generic] = ACTIONS(3383),
    [anon_sym_asm] = ACTIONS(3383),
    [anon_sym___asm__] = ACTIONS(3383),
    [anon_sym___asm] = ACTIONS(3383),
    [sym_number_literal] = ACTIONS(3385),
    [anon_sym_L_SQUOTE] = ACTIONS(3385),
    [anon_sym_u_SQUOTE] = ACTIONS(3385),
    [anon_sym_U_SQUOTE] = ACTIONS(3385),
    [anon_sym_u8_SQUOTE] = ACTIONS(3385),
    [anon_sym_SQUOTE] = ACTIONS(3385),
    [anon_sym_L_DQUOTE] = ACTIONS(3385),
    [anon_sym_u_DQUOTE] = ACTIONS(3385),
    [anon_sym_U_DQUOTE] = ACTIONS(3385),
    [anon_sym_u8_DQUOTE] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(3385),
    [sym_true] = ACTIONS(3383),
    [sym_false] = ACTIONS(3383),
    [anon_sym_NULL] = ACTIONS(3383),
    [anon_sym_nullptr] = ACTIONS(3383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3383),
    [anon_sym_let] = ACTIONS(3383),
    [anon_sym_This] = ACTIONS(3383),
    [anon_sym_decltype] = ACTIONS(3383),
    [anon_sym_typename] = ACTIONS(3383),
    [anon_sym_template] = ACTIONS(3383),
    [anon_sym_try] = ACTIONS(3383),
    [anon_sym_delete] = ACTIONS(3383),
    [anon_sym_throw] = ACTIONS(3383),
    [anon_sym_co_return] = ACTIONS(3383),
    [anon_sym_co_yield] = ACTIONS(3383),
    [anon_sym_R_DQUOTE] = ACTIONS(3385),
    [anon_sym_LR_DQUOTE] = ACTIONS(3385),
    [anon_sym_uR_DQUOTE] = ACTIONS(3385),
    [anon_sym_UR_DQUOTE] = ACTIONS(3385),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3385),
    [anon_sym_co_await] = ACTIONS(3383),
    [anon_sym_new] = ACTIONS(3383),
    [anon_sym_requires] = ACTIONS(3383),
    [sym_this] = ACTIONS(3383),
    [anon_sym_discard] = ACTIONS(3383),
    [anon_sym_precise] = ACTIONS(3383),
    [anon_sym_shared] = ACTIONS(3383),
    [anon_sym_groupshared] = ACTIONS(3383),
    [anon_sym_uniform] = ACTIONS(3383),
    [anon_sym_row_major] = ACTIONS(3383),
    [anon_sym_column_major] = ACTIONS(3383),
    [anon_sym_globallycoherent] = ACTIONS(3383),
    [anon_sym_centroid] = ACTIONS(3383),
    [anon_sym_noperspective] = ACTIONS(3383),
    [anon_sym_nointerpolation] = ACTIONS(3383),
    [anon_sym_sample] = ACTIONS(3383),
    [anon_sym_linear] = ACTIONS(3383),
    [anon_sym_snorm] = ACTIONS(3383),
    [anon_sym_unorm] = ACTIONS(3383),
    [anon_sym_point] = ACTIONS(3383),
    [anon_sym_line] = ACTIONS(3383),
    [anon_sym_triangleadj] = ACTIONS(3383),
    [anon_sym_lineadj] = ACTIONS(3383),
    [anon_sym_triangle] = ACTIONS(3383),
    [anon_sym_cbuffer] = ACTIONS(3383),
    [anon_sym_interface] = ACTIONS(3383),
    [anon_sym_extension] = ACTIONS(3383),
  },
  [1393] = {
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_LPAREN2] = ACTIONS(3389),
    [anon_sym_BANG] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_STAR] = ACTIONS(3389),
    [anon_sym_AMP] = ACTIONS(3389),
    [anon_sym_SEMI] = ACTIONS(3389),
    [anon_sym___extension__] = ACTIONS(3387),
    [anon_sym_typedef] = ACTIONS(3387),
    [anon_sym_in] = ACTIONS(3387),
    [anon_sym_out] = ACTIONS(3387),
    [anon_sym_inout] = ACTIONS(3387),
    [anon_sym_virtual] = ACTIONS(3387),
    [anon_sym_extern] = ACTIONS(3387),
    [anon_sym___attribute__] = ACTIONS(3387),
    [anon_sym___attribute] = ACTIONS(3387),
    [anon_sym_COLON_COLON] = ACTIONS(3389),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3389),
    [anon_sym___declspec] = ACTIONS(3387),
    [anon_sym_LBRACE] = ACTIONS(3389),
    [anon_sym_signed] = ACTIONS(3387),
    [anon_sym_unsigned] = ACTIONS(3387),
    [anon_sym_long] = ACTIONS(3387),
    [anon_sym_short] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_register] = ACTIONS(3387),
    [anon_sym_inline] = ACTIONS(3387),
    [anon_sym___inline] = ACTIONS(3387),
    [anon_sym___inline__] = ACTIONS(3387),
    [anon_sym___forceinline] = ACTIONS(3387),
    [anon_sym_thread_local] = ACTIONS(3387),
    [anon_sym___thread] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_constexpr] = ACTIONS(3387),
    [anon_sym_volatile] = ACTIONS(3387),
    [anon_sym_restrict] = ACTIONS(3387),
    [anon_sym___restrict__] = ACTIONS(3387),
    [anon_sym__Atomic] = ACTIONS(3387),
    [anon_sym__Noreturn] = ACTIONS(3387),
    [anon_sym_noreturn] = ACTIONS(3387),
    [anon_sym__Nonnull] = ACTIONS(3387),
    [anon_sym_mutable] = ACTIONS(3387),
    [anon_sym_constinit] = ACTIONS(3387),
    [anon_sym_consteval] = ACTIONS(3387),
    [anon_sym_alignas] = ACTIONS(3387),
    [anon_sym__Alignas] = ACTIONS(3387),
    [sym_primitive_type] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [anon_sym_class] = ACTIONS(3387),
    [anon_sym_struct] = ACTIONS(3387),
    [anon_sym_union] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_else] = ACTIONS(3387),
    [anon_sym_switch] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_break] = ACTIONS(3387),
    [anon_sym_continue] = ACTIONS(3387),
    [anon_sym_goto] = ACTIONS(3387),
    [anon_sym___try] = ACTIONS(3387),
    [anon_sym___leave] = ACTIONS(3387),
    [anon_sym_not] = ACTIONS(3387),
    [anon_sym_compl] = ACTIONS(3387),
    [anon_sym_DASH_DASH] = ACTIONS(3389),
    [anon_sym_PLUS_PLUS] = ACTIONS(3389),
    [anon_sym_sizeof] = ACTIONS(3387),
    [anon_sym___alignof__] = ACTIONS(3387),
    [anon_sym___alignof] = ACTIONS(3387),
    [anon_sym__alignof] = ACTIONS(3387),
    [anon_sym_alignof] = ACTIONS(3387),
    [anon_sym__Alignof] = ACTIONS(3387),
    [anon_sym_offsetof] = ACTIONS(3387),
    [anon_sym__Generic] = ACTIONS(3387),
    [anon_sym_asm] = ACTIONS(3387),
    [anon_sym___asm__] = ACTIONS(3387),
    [anon_sym___asm] = ACTIONS(3387),
    [sym_number_literal] = ACTIONS(3389),
    [anon_sym_L_SQUOTE] = ACTIONS(3389),
    [anon_sym_u_SQUOTE] = ACTIONS(3389),
    [anon_sym_U_SQUOTE] = ACTIONS(3389),
    [anon_sym_u8_SQUOTE] = ACTIONS(3389),
    [anon_sym_SQUOTE] = ACTIONS(3389),
    [anon_sym_L_DQUOTE] = ACTIONS(3389),
    [anon_sym_u_DQUOTE] = ACTIONS(3389),
    [anon_sym_U_DQUOTE] = ACTIONS(3389),
    [anon_sym_u8_DQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE] = ACTIONS(3389),
    [sym_true] = ACTIONS(3387),
    [sym_false] = ACTIONS(3387),
    [anon_sym_NULL] = ACTIONS(3387),
    [anon_sym_nullptr] = ACTIONS(3387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_This] = ACTIONS(3387),
    [anon_sym_decltype] = ACTIONS(3387),
    [anon_sym_typename] = ACTIONS(3387),
    [anon_sym_template] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_delete] = ACTIONS(3387),
    [anon_sym_throw] = ACTIONS(3387),
    [anon_sym_co_return] = ACTIONS(3387),
    [anon_sym_co_yield] = ACTIONS(3387),
    [anon_sym_R_DQUOTE] = ACTIONS(3389),
    [anon_sym_LR_DQUOTE] = ACTIONS(3389),
    [anon_sym_uR_DQUOTE] = ACTIONS(3389),
    [anon_sym_UR_DQUOTE] = ACTIONS(3389),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3389),
    [anon_sym_co_await] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_requires] = ACTIONS(3387),
    [sym_this] = ACTIONS(3387),
    [anon_sym_discard] = ACTIONS(3387),
    [anon_sym_precise] = ACTIONS(3387),
    [anon_sym_shared] = ACTIONS(3387),
    [anon_sym_groupshared] = ACTIONS(3387),
    [anon_sym_uniform] = ACTIONS(3387),
    [anon_sym_row_major] = ACTIONS(3387),
    [anon_sym_column_major] = ACTIONS(3387),
    [anon_sym_globallycoherent] = ACTIONS(3387),
    [anon_sym_centroid] = ACTIONS(3387),
    [anon_sym_noperspective] = ACTIONS(3387),
    [anon_sym_nointerpolation] = ACTIONS(3387),
    [anon_sym_sample] = ACTIONS(3387),
    [anon_sym_linear] = ACTIONS(3387),
    [anon_sym_snorm] = ACTIONS(3387),
    [anon_sym_unorm] = ACTIONS(3387),
    [anon_sym_point] = ACTIONS(3387),
    [anon_sym_line] = ACTIONS(3387),
    [anon_sym_triangleadj] = ACTIONS(3387),
    [anon_sym_lineadj] = ACTIONS(3387),
    [anon_sym_triangle] = ACTIONS(3387),
    [anon_sym_cbuffer] = ACTIONS(3387),
    [anon_sym_interface] = ACTIONS(3387),
    [anon_sym_extension] = ACTIONS(3387),
  },
  [1394] = {
    [sym_identifier] = ACTIONS(3391),
    [anon_sym_LPAREN2] = ACTIONS(3393),
    [anon_sym_BANG] = ACTIONS(3393),
    [anon_sym_TILDE] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_STAR] = ACTIONS(3393),
    [anon_sym_AMP] = ACTIONS(3393),
    [anon_sym_SEMI] = ACTIONS(3393),
    [anon_sym___extension__] = ACTIONS(3391),
    [anon_sym_typedef] = ACTIONS(3391),
    [anon_sym_in] = ACTIONS(3391),
    [anon_sym_out] = ACTIONS(3391),
    [anon_sym_inout] = ACTIONS(3391),
    [anon_sym_virtual] = ACTIONS(3391),
    [anon_sym_extern] = ACTIONS(3391),
    [anon_sym___attribute__] = ACTIONS(3391),
    [anon_sym___attribute] = ACTIONS(3391),
    [anon_sym_COLON_COLON] = ACTIONS(3393),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3393),
    [anon_sym___declspec] = ACTIONS(3391),
    [anon_sym_LBRACE] = ACTIONS(3393),
    [anon_sym_signed] = ACTIONS(3391),
    [anon_sym_unsigned] = ACTIONS(3391),
    [anon_sym_long] = ACTIONS(3391),
    [anon_sym_short] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(3391),
    [anon_sym_static] = ACTIONS(3391),
    [anon_sym_register] = ACTIONS(3391),
    [anon_sym_inline] = ACTIONS(3391),
    [anon_sym___inline] = ACTIONS(3391),
    [anon_sym___inline__] = ACTIONS(3391),
    [anon_sym___forceinline] = ACTIONS(3391),
    [anon_sym_thread_local] = ACTIONS(3391),
    [anon_sym___thread] = ACTIONS(3391),
    [anon_sym_const] = ACTIONS(3391),
    [anon_sym_constexpr] = ACTIONS(3391),
    [anon_sym_volatile] = ACTIONS(3391),
    [anon_sym_restrict] = ACTIONS(3391),
    [anon_sym___restrict__] = ACTIONS(3391),
    [anon_sym__Atomic] = ACTIONS(3391),
    [anon_sym__Noreturn] = ACTIONS(3391),
    [anon_sym_noreturn] = ACTIONS(3391),
    [anon_sym__Nonnull] = ACTIONS(3391),
    [anon_sym_mutable] = ACTIONS(3391),
    [anon_sym_constinit] = ACTIONS(3391),
    [anon_sym_consteval] = ACTIONS(3391),
    [anon_sym_alignas] = ACTIONS(3391),
    [anon_sym__Alignas] = ACTIONS(3391),
    [sym_primitive_type] = ACTIONS(3391),
    [anon_sym_enum] = ACTIONS(3391),
    [anon_sym_class] = ACTIONS(3391),
    [anon_sym_struct] = ACTIONS(3391),
    [anon_sym_union] = ACTIONS(3391),
    [anon_sym_if] = ACTIONS(3391),
    [anon_sym_else] = ACTIONS(3391),
    [anon_sym_switch] = ACTIONS(3391),
    [anon_sym_while] = ACTIONS(3391),
    [anon_sym_do] = ACTIONS(3391),
    [anon_sym_for] = ACTIONS(3391),
    [anon_sym_return] = ACTIONS(3391),
    [anon_sym_break] = ACTIONS(3391),
    [anon_sym_continue] = ACTIONS(3391),
    [anon_sym_goto] = ACTIONS(3391),
    [anon_sym___try] = ACTIONS(3391),
    [anon_sym___leave] = ACTIONS(3391),
    [anon_sym_not] = ACTIONS(3391),
    [anon_sym_compl] = ACTIONS(3391),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_sizeof] = ACTIONS(3391),
    [anon_sym___alignof__] = ACTIONS(3391),
    [anon_sym___alignof] = ACTIONS(3391),
    [anon_sym__alignof] = ACTIONS(3391),
    [anon_sym_alignof] = ACTIONS(3391),
    [anon_sym__Alignof] = ACTIONS(3391),
    [anon_sym_offsetof] = ACTIONS(3391),
    [anon_sym__Generic] = ACTIONS(3391),
    [anon_sym_asm] = ACTIONS(3391),
    [anon_sym___asm__] = ACTIONS(3391),
    [anon_sym___asm] = ACTIONS(3391),
    [sym_number_literal] = ACTIONS(3393),
    [anon_sym_L_SQUOTE] = ACTIONS(3393),
    [anon_sym_u_SQUOTE] = ACTIONS(3393),
    [anon_sym_U_SQUOTE] = ACTIONS(3393),
    [anon_sym_u8_SQUOTE] = ACTIONS(3393),
    [anon_sym_SQUOTE] = ACTIONS(3393),
    [anon_sym_L_DQUOTE] = ACTIONS(3393),
    [anon_sym_u_DQUOTE] = ACTIONS(3393),
    [anon_sym_U_DQUOTE] = ACTIONS(3393),
    [anon_sym_u8_DQUOTE] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3393),
    [sym_true] = ACTIONS(3391),
    [sym_false] = ACTIONS(3391),
    [anon_sym_NULL] = ACTIONS(3391),
    [anon_sym_nullptr] = ACTIONS(3391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3391),
    [anon_sym_let] = ACTIONS(3391),
    [anon_sym_This] = ACTIONS(3391),
    [anon_sym_decltype] = ACTIONS(3391),
    [anon_sym_typename] = ACTIONS(3391),
    [anon_sym_template] = ACTIONS(3391),
    [anon_sym_try] = ACTIONS(3391),
    [anon_sym_delete] = ACTIONS(3391),
    [anon_sym_throw] = ACTIONS(3391),
    [anon_sym_co_return] = ACTIONS(3391),
    [anon_sym_co_yield] = ACTIONS(3391),
    [anon_sym_R_DQUOTE] = ACTIONS(3393),
    [anon_sym_LR_DQUOTE] = ACTIONS(3393),
    [anon_sym_uR_DQUOTE] = ACTIONS(3393),
    [anon_sym_UR_DQUOTE] = ACTIONS(3393),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3393),
    [anon_sym_co_await] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(3391),
    [anon_sym_requires] = ACTIONS(3391),
    [sym_this] = ACTIONS(3391),
    [anon_sym_discard] = ACTIONS(3391),
    [anon_sym_precise] = ACTIONS(3391),
    [anon_sym_shared] = ACTIONS(3391),
    [anon_sym_groupshared] = ACTIONS(3391),
    [anon_sym_uniform] = ACTIONS(3391),
    [anon_sym_row_major] = ACTIONS(3391),
    [anon_sym_column_major] = ACTIONS(3391),
    [anon_sym_globallycoherent] = ACTIONS(3391),
    [anon_sym_centroid] = ACTIONS(3391),
    [anon_sym_noperspective] = ACTIONS(3391),
    [anon_sym_nointerpolation] = ACTIONS(3391),
    [anon_sym_sample] = ACTIONS(3391),
    [anon_sym_linear] = ACTIONS(3391),
    [anon_sym_snorm] = ACTIONS(3391),
    [anon_sym_unorm] = ACTIONS(3391),
    [anon_sym_point] = ACTIONS(3391),
    [anon_sym_line] = ACTIONS(3391),
    [anon_sym_triangleadj] = ACTIONS(3391),
    [anon_sym_lineadj] = ACTIONS(3391),
    [anon_sym_triangle] = ACTIONS(3391),
    [anon_sym_cbuffer] = ACTIONS(3391),
    [anon_sym_interface] = ACTIONS(3391),
    [anon_sym_extension] = ACTIONS(3391),
  },
  [1395] = {
    [sym_identifier] = ACTIONS(3395),
    [anon_sym_LPAREN2] = ACTIONS(3397),
    [anon_sym_BANG] = ACTIONS(3397),
    [anon_sym_TILDE] = ACTIONS(3397),
    [anon_sym_DASH] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3395),
    [anon_sym_STAR] = ACTIONS(3397),
    [anon_sym_AMP] = ACTIONS(3397),
    [anon_sym_SEMI] = ACTIONS(3397),
    [anon_sym___extension__] = ACTIONS(3395),
    [anon_sym_typedef] = ACTIONS(3395),
    [anon_sym_in] = ACTIONS(3395),
    [anon_sym_out] = ACTIONS(3395),
    [anon_sym_inout] = ACTIONS(3395),
    [anon_sym_virtual] = ACTIONS(3395),
    [anon_sym_extern] = ACTIONS(3395),
    [anon_sym___attribute__] = ACTIONS(3395),
    [anon_sym___attribute] = ACTIONS(3395),
    [anon_sym_COLON_COLON] = ACTIONS(3397),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3397),
    [anon_sym___declspec] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3397),
    [anon_sym_signed] = ACTIONS(3395),
    [anon_sym_unsigned] = ACTIONS(3395),
    [anon_sym_long] = ACTIONS(3395),
    [anon_sym_short] = ACTIONS(3395),
    [anon_sym_LBRACK] = ACTIONS(3395),
    [anon_sym_static] = ACTIONS(3395),
    [anon_sym_register] = ACTIONS(3395),
    [anon_sym_inline] = ACTIONS(3395),
    [anon_sym___inline] = ACTIONS(3395),
    [anon_sym___inline__] = ACTIONS(3395),
    [anon_sym___forceinline] = ACTIONS(3395),
    [anon_sym_thread_local] = ACTIONS(3395),
    [anon_sym___thread] = ACTIONS(3395),
    [anon_sym_const] = ACTIONS(3395),
    [anon_sym_constexpr] = ACTIONS(3395),
    [anon_sym_volatile] = ACTIONS(3395),
    [anon_sym_restrict] = ACTIONS(3395),
    [anon_sym___restrict__] = ACTIONS(3395),
    [anon_sym__Atomic] = ACTIONS(3395),
    [anon_sym__Noreturn] = ACTIONS(3395),
    [anon_sym_noreturn] = ACTIONS(3395),
    [anon_sym__Nonnull] = ACTIONS(3395),
    [anon_sym_mutable] = ACTIONS(3395),
    [anon_sym_constinit] = ACTIONS(3395),
    [anon_sym_consteval] = ACTIONS(3395),
    [anon_sym_alignas] = ACTIONS(3395),
    [anon_sym__Alignas] = ACTIONS(3395),
    [sym_primitive_type] = ACTIONS(3395),
    [anon_sym_enum] = ACTIONS(3395),
    [anon_sym_class] = ACTIONS(3395),
    [anon_sym_struct] = ACTIONS(3395),
    [anon_sym_union] = ACTIONS(3395),
    [anon_sym_if] = ACTIONS(3395),
    [anon_sym_else] = ACTIONS(3395),
    [anon_sym_switch] = ACTIONS(3395),
    [anon_sym_while] = ACTIONS(3395),
    [anon_sym_do] = ACTIONS(3395),
    [anon_sym_for] = ACTIONS(3395),
    [anon_sym_return] = ACTIONS(3395),
    [anon_sym_break] = ACTIONS(3395),
    [anon_sym_continue] = ACTIONS(3395),
    [anon_sym_goto] = ACTIONS(3395),
    [anon_sym___try] = ACTIONS(3395),
    [anon_sym___leave] = ACTIONS(3395),
    [anon_sym_not] = ACTIONS(3395),
    [anon_sym_compl] = ACTIONS(3395),
    [anon_sym_DASH_DASH] = ACTIONS(3397),
    [anon_sym_PLUS_PLUS] = ACTIONS(3397),
    [anon_sym_sizeof] = ACTIONS(3395),
    [anon_sym___alignof__] = ACTIONS(3395),
    [anon_sym___alignof] = ACTIONS(3395),
    [anon_sym__alignof] = ACTIONS(3395),
    [anon_sym_alignof] = ACTIONS(3395),
    [anon_sym__Alignof] = ACTIONS(3395),
    [anon_sym_offsetof] = ACTIONS(3395),
    [anon_sym__Generic] = ACTIONS(3395),
    [anon_sym_asm] = ACTIONS(3395),
    [anon_sym___asm__] = ACTIONS(3395),
    [anon_sym___asm] = ACTIONS(3395),
    [sym_number_literal] = ACTIONS(3397),
    [anon_sym_L_SQUOTE] = ACTIONS(3397),
    [anon_sym_u_SQUOTE] = ACTIONS(3397),
    [anon_sym_U_SQUOTE] = ACTIONS(3397),
    [anon_sym_u8_SQUOTE] = ACTIONS(3397),
    [anon_sym_SQUOTE] = ACTIONS(3397),
    [anon_sym_L_DQUOTE] = ACTIONS(3397),
    [anon_sym_u_DQUOTE] = ACTIONS(3397),
    [anon_sym_U_DQUOTE] = ACTIONS(3397),
    [anon_sym_u8_DQUOTE] = ACTIONS(3397),
    [anon_sym_DQUOTE] = ACTIONS(3397),
    [sym_true] = ACTIONS(3395),
    [sym_false] = ACTIONS(3395),
    [anon_sym_NULL] = ACTIONS(3395),
    [anon_sym_nullptr] = ACTIONS(3395),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3395),
    [anon_sym_let] = ACTIONS(3395),
    [anon_sym_This] = ACTIONS(3395),
    [anon_sym_decltype] = ACTIONS(3395),
    [anon_sym_typename] = ACTIONS(3395),
    [anon_sym_template] = ACTIONS(3395),
    [anon_sym_try] = ACTIONS(3395),
    [anon_sym_delete] = ACTIONS(3395),
    [anon_sym_throw] = ACTIONS(3395),
    [anon_sym_co_return] = ACTIONS(3395),
    [anon_sym_co_yield] = ACTIONS(3395),
    [anon_sym_R_DQUOTE] = ACTIONS(3397),
    [anon_sym_LR_DQUOTE] = ACTIONS(3397),
    [anon_sym_uR_DQUOTE] = ACTIONS(3397),
    [anon_sym_UR_DQUOTE] = ACTIONS(3397),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3397),
    [anon_sym_co_await] = ACTIONS(3395),
    [anon_sym_new] = ACTIONS(3395),
    [anon_sym_requires] = ACTIONS(3395),
    [sym_this] = ACTIONS(3395),
    [anon_sym_discard] = ACTIONS(3395),
    [anon_sym_precise] = ACTIONS(3395),
    [anon_sym_shared] = ACTIONS(3395),
    [anon_sym_groupshared] = ACTIONS(3395),
    [anon_sym_uniform] = ACTIONS(3395),
    [anon_sym_row_major] = ACTIONS(3395),
    [anon_sym_column_major] = ACTIONS(3395),
    [anon_sym_globallycoherent] = ACTIONS(3395),
    [anon_sym_centroid] = ACTIONS(3395),
    [anon_sym_noperspective] = ACTIONS(3395),
    [anon_sym_nointerpolation] = ACTIONS(3395),
    [anon_sym_sample] = ACTIONS(3395),
    [anon_sym_linear] = ACTIONS(3395),
    [anon_sym_snorm] = ACTIONS(3395),
    [anon_sym_unorm] = ACTIONS(3395),
    [anon_sym_point] = ACTIONS(3395),
    [anon_sym_line] = ACTIONS(3395),
    [anon_sym_triangleadj] = ACTIONS(3395),
    [anon_sym_lineadj] = ACTIONS(3395),
    [anon_sym_triangle] = ACTIONS(3395),
    [anon_sym_cbuffer] = ACTIONS(3395),
    [anon_sym_interface] = ACTIONS(3395),
    [anon_sym_extension] = ACTIONS(3395),
  },
  [1396] = {
    [sym_identifier] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3409),
    [anon_sym_TILDE] = ACTIONS(3409),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_SEMI] = ACTIONS(3409),
    [anon_sym___extension__] = ACTIONS(3407),
    [anon_sym_typedef] = ACTIONS(3407),
    [anon_sym_in] = ACTIONS(3407),
    [anon_sym_out] = ACTIONS(3407),
    [anon_sym_inout] = ACTIONS(3407),
    [anon_sym_virtual] = ACTIONS(3407),
    [anon_sym_extern] = ACTIONS(3407),
    [anon_sym___attribute__] = ACTIONS(3407),
    [anon_sym___attribute] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3409),
    [anon_sym___declspec] = ACTIONS(3407),
    [anon_sym_LBRACE] = ACTIONS(3409),
    [anon_sym_signed] = ACTIONS(3407),
    [anon_sym_unsigned] = ACTIONS(3407),
    [anon_sym_long] = ACTIONS(3407),
    [anon_sym_short] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_register] = ACTIONS(3407),
    [anon_sym_inline] = ACTIONS(3407),
    [anon_sym___inline] = ACTIONS(3407),
    [anon_sym___inline__] = ACTIONS(3407),
    [anon_sym___forceinline] = ACTIONS(3407),
    [anon_sym_thread_local] = ACTIONS(3407),
    [anon_sym___thread] = ACTIONS(3407),
    [anon_sym_const] = ACTIONS(3407),
    [anon_sym_constexpr] = ACTIONS(3407),
    [anon_sym_volatile] = ACTIONS(3407),
    [anon_sym_restrict] = ACTIONS(3407),
    [anon_sym___restrict__] = ACTIONS(3407),
    [anon_sym__Atomic] = ACTIONS(3407),
    [anon_sym__Noreturn] = ACTIONS(3407),
    [anon_sym_noreturn] = ACTIONS(3407),
    [anon_sym__Nonnull] = ACTIONS(3407),
    [anon_sym_mutable] = ACTIONS(3407),
    [anon_sym_constinit] = ACTIONS(3407),
    [anon_sym_consteval] = ACTIONS(3407),
    [anon_sym_alignas] = ACTIONS(3407),
    [anon_sym__Alignas] = ACTIONS(3407),
    [sym_primitive_type] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3407),
    [anon_sym_class] = ACTIONS(3407),
    [anon_sym_struct] = ACTIONS(3407),
    [anon_sym_union] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_else] = ACTIONS(3407),
    [anon_sym_switch] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_break] = ACTIONS(3407),
    [anon_sym_continue] = ACTIONS(3407),
    [anon_sym_goto] = ACTIONS(3407),
    [anon_sym___try] = ACTIONS(3407),
    [anon_sym___leave] = ACTIONS(3407),
    [anon_sym_not] = ACTIONS(3407),
    [anon_sym_compl] = ACTIONS(3407),
    [anon_sym_DASH_DASH] = ACTIONS(3409),
    [anon_sym_PLUS_PLUS] = ACTIONS(3409),
    [anon_sym_sizeof] = ACTIONS(3407),
    [anon_sym___alignof__] = ACTIONS(3407),
    [anon_sym___alignof] = ACTIONS(3407),
    [anon_sym__alignof] = ACTIONS(3407),
    [anon_sym_alignof] = ACTIONS(3407),
    [anon_sym__Alignof] = ACTIONS(3407),
    [anon_sym_offsetof] = ACTIONS(3407),
    [anon_sym__Generic] = ACTIONS(3407),
    [anon_sym_asm] = ACTIONS(3407),
    [anon_sym___asm__] = ACTIONS(3407),
    [anon_sym___asm] = ACTIONS(3407),
    [sym_number_literal] = ACTIONS(3409),
    [anon_sym_L_SQUOTE] = ACTIONS(3409),
    [anon_sym_u_SQUOTE] = ACTIONS(3409),
    [anon_sym_U_SQUOTE] = ACTIONS(3409),
    [anon_sym_u8_SQUOTE] = ACTIONS(3409),
    [anon_sym_SQUOTE] = ACTIONS(3409),
    [anon_sym_L_DQUOTE] = ACTIONS(3409),
    [anon_sym_u_DQUOTE] = ACTIONS(3409),
    [anon_sym_U_DQUOTE] = ACTIONS(3409),
    [anon_sym_u8_DQUOTE] = ACTIONS(3409),
    [anon_sym_DQUOTE] = ACTIONS(3409),
    [sym_true] = ACTIONS(3407),
    [sym_false] = ACTIONS(3407),
    [anon_sym_NULL] = ACTIONS(3407),
    [anon_sym_nullptr] = ACTIONS(3407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_This] = ACTIONS(3407),
    [anon_sym_decltype] = ACTIONS(3407),
    [anon_sym_typename] = ACTIONS(3407),
    [anon_sym_template] = ACTIONS(3407),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_delete] = ACTIONS(3407),
    [anon_sym_throw] = ACTIONS(3407),
    [anon_sym_co_return] = ACTIONS(3407),
    [anon_sym_co_yield] = ACTIONS(3407),
    [anon_sym_R_DQUOTE] = ACTIONS(3409),
    [anon_sym_LR_DQUOTE] = ACTIONS(3409),
    [anon_sym_uR_DQUOTE] = ACTIONS(3409),
    [anon_sym_UR_DQUOTE] = ACTIONS(3409),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3409),
    [anon_sym_co_await] = ACTIONS(3407),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_requires] = ACTIONS(3407),
    [sym_this] = ACTIONS(3407),
    [anon_sym_discard] = ACTIONS(3407),
    [anon_sym_precise] = ACTIONS(3407),
    [anon_sym_shared] = ACTIONS(3407),
    [anon_sym_groupshared] = ACTIONS(3407),
    [anon_sym_uniform] = ACTIONS(3407),
    [anon_sym_row_major] = ACTIONS(3407),
    [anon_sym_column_major] = ACTIONS(3407),
    [anon_sym_globallycoherent] = ACTIONS(3407),
    [anon_sym_centroid] = ACTIONS(3407),
    [anon_sym_noperspective] = ACTIONS(3407),
    [anon_sym_nointerpolation] = ACTIONS(3407),
    [anon_sym_sample] = ACTIONS(3407),
    [anon_sym_linear] = ACTIONS(3407),
    [anon_sym_snorm] = ACTIONS(3407),
    [anon_sym_unorm] = ACTIONS(3407),
    [anon_sym_point] = ACTIONS(3407),
    [anon_sym_line] = ACTIONS(3407),
    [anon_sym_triangleadj] = ACTIONS(3407),
    [anon_sym_lineadj] = ACTIONS(3407),
    [anon_sym_triangle] = ACTIONS(3407),
    [anon_sym_cbuffer] = ACTIONS(3407),
    [anon_sym_interface] = ACTIONS(3407),
    [anon_sym_extension] = ACTIONS(3407),
  },
  [1397] = {
    [sym_identifier] = ACTIONS(3411),
    [anon_sym_LPAREN2] = ACTIONS(3413),
    [anon_sym_BANG] = ACTIONS(3413),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_DASH] = ACTIONS(3411),
    [anon_sym_PLUS] = ACTIONS(3411),
    [anon_sym_STAR] = ACTIONS(3413),
    [anon_sym_AMP] = ACTIONS(3413),
    [anon_sym_SEMI] = ACTIONS(3413),
    [anon_sym___extension__] = ACTIONS(3411),
    [anon_sym_typedef] = ACTIONS(3411),
    [anon_sym_in] = ACTIONS(3411),
    [anon_sym_out] = ACTIONS(3411),
    [anon_sym_inout] = ACTIONS(3411),
    [anon_sym_virtual] = ACTIONS(3411),
    [anon_sym_extern] = ACTIONS(3411),
    [anon_sym___attribute__] = ACTIONS(3411),
    [anon_sym___attribute] = ACTIONS(3411),
    [anon_sym_COLON_COLON] = ACTIONS(3413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3413),
    [anon_sym___declspec] = ACTIONS(3411),
    [anon_sym_LBRACE] = ACTIONS(3413),
    [anon_sym_signed] = ACTIONS(3411),
    [anon_sym_unsigned] = ACTIONS(3411),
    [anon_sym_long] = ACTIONS(3411),
    [anon_sym_short] = ACTIONS(3411),
    [anon_sym_LBRACK] = ACTIONS(3411),
    [anon_sym_static] = ACTIONS(3411),
    [anon_sym_register] = ACTIONS(3411),
    [anon_sym_inline] = ACTIONS(3411),
    [anon_sym___inline] = ACTIONS(3411),
    [anon_sym___inline__] = ACTIONS(3411),
    [anon_sym___forceinline] = ACTIONS(3411),
    [anon_sym_thread_local] = ACTIONS(3411),
    [anon_sym___thread] = ACTIONS(3411),
    [anon_sym_const] = ACTIONS(3411),
    [anon_sym_constexpr] = ACTIONS(3411),
    [anon_sym_volatile] = ACTIONS(3411),
    [anon_sym_restrict] = ACTIONS(3411),
    [anon_sym___restrict__] = ACTIONS(3411),
    [anon_sym__Atomic] = ACTIONS(3411),
    [anon_sym__Noreturn] = ACTIONS(3411),
    [anon_sym_noreturn] = ACTIONS(3411),
    [anon_sym__Nonnull] = ACTIONS(3411),
    [anon_sym_mutable] = ACTIONS(3411),
    [anon_sym_constinit] = ACTIONS(3411),
    [anon_sym_consteval] = ACTIONS(3411),
    [anon_sym_alignas] = ACTIONS(3411),
    [anon_sym__Alignas] = ACTIONS(3411),
    [sym_primitive_type] = ACTIONS(3411),
    [anon_sym_enum] = ACTIONS(3411),
    [anon_sym_class] = ACTIONS(3411),
    [anon_sym_struct] = ACTIONS(3411),
    [anon_sym_union] = ACTIONS(3411),
    [anon_sym_if] = ACTIONS(3411),
    [anon_sym_else] = ACTIONS(3411),
    [anon_sym_switch] = ACTIONS(3411),
    [anon_sym_while] = ACTIONS(3411),
    [anon_sym_do] = ACTIONS(3411),
    [anon_sym_for] = ACTIONS(3411),
    [anon_sym_return] = ACTIONS(3411),
    [anon_sym_break] = ACTIONS(3411),
    [anon_sym_continue] = ACTIONS(3411),
    [anon_sym_goto] = ACTIONS(3411),
    [anon_sym___try] = ACTIONS(3411),
    [anon_sym___leave] = ACTIONS(3411),
    [anon_sym_not] = ACTIONS(3411),
    [anon_sym_compl] = ACTIONS(3411),
    [anon_sym_DASH_DASH] = ACTIONS(3413),
    [anon_sym_PLUS_PLUS] = ACTIONS(3413),
    [anon_sym_sizeof] = ACTIONS(3411),
    [anon_sym___alignof__] = ACTIONS(3411),
    [anon_sym___alignof] = ACTIONS(3411),
    [anon_sym__alignof] = ACTIONS(3411),
    [anon_sym_alignof] = ACTIONS(3411),
    [anon_sym__Alignof] = ACTIONS(3411),
    [anon_sym_offsetof] = ACTIONS(3411),
    [anon_sym__Generic] = ACTIONS(3411),
    [anon_sym_asm] = ACTIONS(3411),
    [anon_sym___asm__] = ACTIONS(3411),
    [anon_sym___asm] = ACTIONS(3411),
    [sym_number_literal] = ACTIONS(3413),
    [anon_sym_L_SQUOTE] = ACTIONS(3413),
    [anon_sym_u_SQUOTE] = ACTIONS(3413),
    [anon_sym_U_SQUOTE] = ACTIONS(3413),
    [anon_sym_u8_SQUOTE] = ACTIONS(3413),
    [anon_sym_SQUOTE] = ACTIONS(3413),
    [anon_sym_L_DQUOTE] = ACTIONS(3413),
    [anon_sym_u_DQUOTE] = ACTIONS(3413),
    [anon_sym_U_DQUOTE] = ACTIONS(3413),
    [anon_sym_u8_DQUOTE] = ACTIONS(3413),
    [anon_sym_DQUOTE] = ACTIONS(3413),
    [sym_true] = ACTIONS(3411),
    [sym_false] = ACTIONS(3411),
    [anon_sym_NULL] = ACTIONS(3411),
    [anon_sym_nullptr] = ACTIONS(3411),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3411),
    [anon_sym_let] = ACTIONS(3411),
    [anon_sym_This] = ACTIONS(3411),
    [anon_sym_decltype] = ACTIONS(3411),
    [anon_sym_typename] = ACTIONS(3411),
    [anon_sym_template] = ACTIONS(3411),
    [anon_sym_try] = ACTIONS(3411),
    [anon_sym_delete] = ACTIONS(3411),
    [anon_sym_throw] = ACTIONS(3411),
    [anon_sym_co_return] = ACTIONS(3411),
    [anon_sym_co_yield] = ACTIONS(3411),
    [anon_sym_R_DQUOTE] = ACTIONS(3413),
    [anon_sym_LR_DQUOTE] = ACTIONS(3413),
    [anon_sym_uR_DQUOTE] = ACTIONS(3413),
    [anon_sym_UR_DQUOTE] = ACTIONS(3413),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3413),
    [anon_sym_co_await] = ACTIONS(3411),
    [anon_sym_new] = ACTIONS(3411),
    [anon_sym_requires] = ACTIONS(3411),
    [sym_this] = ACTIONS(3411),
    [anon_sym_discard] = ACTIONS(3411),
    [anon_sym_precise] = ACTIONS(3411),
    [anon_sym_shared] = ACTIONS(3411),
    [anon_sym_groupshared] = ACTIONS(3411),
    [anon_sym_uniform] = ACTIONS(3411),
    [anon_sym_row_major] = ACTIONS(3411),
    [anon_sym_column_major] = ACTIONS(3411),
    [anon_sym_globallycoherent] = ACTIONS(3411),
    [anon_sym_centroid] = ACTIONS(3411),
    [anon_sym_noperspective] = ACTIONS(3411),
    [anon_sym_nointerpolation] = ACTIONS(3411),
    [anon_sym_sample] = ACTIONS(3411),
    [anon_sym_linear] = ACTIONS(3411),
    [anon_sym_snorm] = ACTIONS(3411),
    [anon_sym_unorm] = ACTIONS(3411),
    [anon_sym_point] = ACTIONS(3411),
    [anon_sym_line] = ACTIONS(3411),
    [anon_sym_triangleadj] = ACTIONS(3411),
    [anon_sym_lineadj] = ACTIONS(3411),
    [anon_sym_triangle] = ACTIONS(3411),
    [anon_sym_cbuffer] = ACTIONS(3411),
    [anon_sym_interface] = ACTIONS(3411),
    [anon_sym_extension] = ACTIONS(3411),
  },
  [1398] = {
    [sym_identifier] = ACTIONS(3474),
    [anon_sym_LPAREN2] = ACTIONS(3476),
    [anon_sym_BANG] = ACTIONS(3476),
    [anon_sym_TILDE] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3474),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_SEMI] = ACTIONS(3476),
    [anon_sym___extension__] = ACTIONS(3474),
    [anon_sym_typedef] = ACTIONS(3474),
    [anon_sym_in] = ACTIONS(3474),
    [anon_sym_out] = ACTIONS(3474),
    [anon_sym_inout] = ACTIONS(3474),
    [anon_sym_virtual] = ACTIONS(3474),
    [anon_sym_extern] = ACTIONS(3474),
    [anon_sym___attribute__] = ACTIONS(3474),
    [anon_sym___attribute] = ACTIONS(3474),
    [anon_sym_COLON_COLON] = ACTIONS(3476),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3476),
    [anon_sym___declspec] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_signed] = ACTIONS(3474),
    [anon_sym_unsigned] = ACTIONS(3474),
    [anon_sym_long] = ACTIONS(3474),
    [anon_sym_short] = ACTIONS(3474),
    [anon_sym_LBRACK] = ACTIONS(3474),
    [anon_sym_static] = ACTIONS(3474),
    [anon_sym_register] = ACTIONS(3474),
    [anon_sym_inline] = ACTIONS(3474),
    [anon_sym___inline] = ACTIONS(3474),
    [anon_sym___inline__] = ACTIONS(3474),
    [anon_sym___forceinline] = ACTIONS(3474),
    [anon_sym_thread_local] = ACTIONS(3474),
    [anon_sym___thread] = ACTIONS(3474),
    [anon_sym_const] = ACTIONS(3474),
    [anon_sym_constexpr] = ACTIONS(3474),
    [anon_sym_volatile] = ACTIONS(3474),
    [anon_sym_restrict] = ACTIONS(3474),
    [anon_sym___restrict__] = ACTIONS(3474),
    [anon_sym__Atomic] = ACTIONS(3474),
    [anon_sym__Noreturn] = ACTIONS(3474),
    [anon_sym_noreturn] = ACTIONS(3474),
    [anon_sym__Nonnull] = ACTIONS(3474),
    [anon_sym_mutable] = ACTIONS(3474),
    [anon_sym_constinit] = ACTIONS(3474),
    [anon_sym_consteval] = ACTIONS(3474),
    [anon_sym_alignas] = ACTIONS(3474),
    [anon_sym__Alignas] = ACTIONS(3474),
    [sym_primitive_type] = ACTIONS(3474),
    [anon_sym_enum] = ACTIONS(3474),
    [anon_sym_class] = ACTIONS(3474),
    [anon_sym_struct] = ACTIONS(3474),
    [anon_sym_union] = ACTIONS(3474),
    [anon_sym_if] = ACTIONS(3474),
    [anon_sym_else] = ACTIONS(3474),
    [anon_sym_switch] = ACTIONS(3474),
    [anon_sym_while] = ACTIONS(3474),
    [anon_sym_do] = ACTIONS(3474),
    [anon_sym_for] = ACTIONS(3474),
    [anon_sym_return] = ACTIONS(3474),
    [anon_sym_break] = ACTIONS(3474),
    [anon_sym_continue] = ACTIONS(3474),
    [anon_sym_goto] = ACTIONS(3474),
    [anon_sym___try] = ACTIONS(3474),
    [anon_sym___leave] = ACTIONS(3474),
    [anon_sym_not] = ACTIONS(3474),
    [anon_sym_compl] = ACTIONS(3474),
    [anon_sym_DASH_DASH] = ACTIONS(3476),
    [anon_sym_PLUS_PLUS] = ACTIONS(3476),
    [anon_sym_sizeof] = ACTIONS(3474),
    [anon_sym___alignof__] = ACTIONS(3474),
    [anon_sym___alignof] = ACTIONS(3474),
    [anon_sym__alignof] = ACTIONS(3474),
    [anon_sym_alignof] = ACTIONS(3474),
    [anon_sym__Alignof] = ACTIONS(3474),
    [anon_sym_offsetof] = ACTIONS(3474),
    [anon_sym__Generic] = ACTIONS(3474),
    [anon_sym_asm] = ACTIONS(3474),
    [anon_sym___asm__] = ACTIONS(3474),
    [anon_sym___asm] = ACTIONS(3474),
    [sym_number_literal] = ACTIONS(3476),
    [anon_sym_L_SQUOTE] = ACTIONS(3476),
    [anon_sym_u_SQUOTE] = ACTIONS(3476),
    [anon_sym_U_SQUOTE] = ACTIONS(3476),
    [anon_sym_u8_SQUOTE] = ACTIONS(3476),
    [anon_sym_SQUOTE] = ACTIONS(3476),
    [anon_sym_L_DQUOTE] = ACTIONS(3476),
    [anon_sym_u_DQUOTE] = ACTIONS(3476),
    [anon_sym_U_DQUOTE] = ACTIONS(3476),
    [anon_sym_u8_DQUOTE] = ACTIONS(3476),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [sym_true] = ACTIONS(3474),
    [sym_false] = ACTIONS(3474),
    [anon_sym_NULL] = ACTIONS(3474),
    [anon_sym_nullptr] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3474),
    [anon_sym_let] = ACTIONS(3474),
    [anon_sym_This] = ACTIONS(3474),
    [anon_sym_decltype] = ACTIONS(3474),
    [anon_sym_typename] = ACTIONS(3474),
    [anon_sym_template] = ACTIONS(3474),
    [anon_sym_try] = ACTIONS(3474),
    [anon_sym_delete] = ACTIONS(3474),
    [anon_sym_throw] = ACTIONS(3474),
    [anon_sym_co_return] = ACTIONS(3474),
    [anon_sym_co_yield] = ACTIONS(3474),
    [anon_sym_R_DQUOTE] = ACTIONS(3476),
    [anon_sym_LR_DQUOTE] = ACTIONS(3476),
    [anon_sym_uR_DQUOTE] = ACTIONS(3476),
    [anon_sym_UR_DQUOTE] = ACTIONS(3476),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3476),
    [anon_sym_co_await] = ACTIONS(3474),
    [anon_sym_new] = ACTIONS(3474),
    [anon_sym_requires] = ACTIONS(3474),
    [sym_this] = ACTIONS(3474),
    [anon_sym_discard] = ACTIONS(3474),
    [anon_sym_precise] = ACTIONS(3474),
    [anon_sym_shared] = ACTIONS(3474),
    [anon_sym_groupshared] = ACTIONS(3474),
    [anon_sym_uniform] = ACTIONS(3474),
    [anon_sym_row_major] = ACTIONS(3474),
    [anon_sym_column_major] = ACTIONS(3474),
    [anon_sym_globallycoherent] = ACTIONS(3474),
    [anon_sym_centroid] = ACTIONS(3474),
    [anon_sym_noperspective] = ACTIONS(3474),
    [anon_sym_nointerpolation] = ACTIONS(3474),
    [anon_sym_sample] = ACTIONS(3474),
    [anon_sym_linear] = ACTIONS(3474),
    [anon_sym_snorm] = ACTIONS(3474),
    [anon_sym_unorm] = ACTIONS(3474),
    [anon_sym_point] = ACTIONS(3474),
    [anon_sym_line] = ACTIONS(3474),
    [anon_sym_triangleadj] = ACTIONS(3474),
    [anon_sym_lineadj] = ACTIONS(3474),
    [anon_sym_triangle] = ACTIONS(3474),
    [anon_sym_cbuffer] = ACTIONS(3474),
    [anon_sym_interface] = ACTIONS(3474),
    [anon_sym_extension] = ACTIONS(3474),
  },
  [1399] = {
    [sym_identifier] = ACTIONS(3627),
    [anon_sym_LPAREN2] = ACTIONS(3625),
    [anon_sym_BANG] = ACTIONS(3625),
    [anon_sym_TILDE] = ACTIONS(3625),
    [anon_sym_DASH] = ACTIONS(3627),
    [anon_sym_PLUS] = ACTIONS(3627),
    [anon_sym_STAR] = ACTIONS(3625),
    [anon_sym_AMP] = ACTIONS(3625),
    [anon_sym_SEMI] = ACTIONS(3625),
    [anon_sym___extension__] = ACTIONS(3627),
    [anon_sym_typedef] = ACTIONS(3627),
    [anon_sym_in] = ACTIONS(3627),
    [anon_sym_out] = ACTIONS(3627),
    [anon_sym_inout] = ACTIONS(3627),
    [anon_sym_virtual] = ACTIONS(3627),
    [anon_sym_extern] = ACTIONS(3627),
    [anon_sym___attribute__] = ACTIONS(3627),
    [anon_sym___attribute] = ACTIONS(3627),
    [anon_sym_COLON_COLON] = ACTIONS(3625),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3625),
    [anon_sym___declspec] = ACTIONS(3627),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_signed] = ACTIONS(3627),
    [anon_sym_unsigned] = ACTIONS(3627),
    [anon_sym_long] = ACTIONS(3627),
    [anon_sym_short] = ACTIONS(3627),
    [anon_sym_LBRACK] = ACTIONS(3627),
    [anon_sym_static] = ACTIONS(3627),
    [anon_sym_register] = ACTIONS(3627),
    [anon_sym_inline] = ACTIONS(3627),
    [anon_sym___inline] = ACTIONS(3627),
    [anon_sym___inline__] = ACTIONS(3627),
    [anon_sym___forceinline] = ACTIONS(3627),
    [anon_sym_thread_local] = ACTIONS(3627),
    [anon_sym___thread] = ACTIONS(3627),
    [anon_sym_const] = ACTIONS(3627),
    [anon_sym_constexpr] = ACTIONS(3627),
    [anon_sym_volatile] = ACTIONS(3627),
    [anon_sym_restrict] = ACTIONS(3627),
    [anon_sym___restrict__] = ACTIONS(3627),
    [anon_sym__Atomic] = ACTIONS(3627),
    [anon_sym__Noreturn] = ACTIONS(3627),
    [anon_sym_noreturn] = ACTIONS(3627),
    [anon_sym__Nonnull] = ACTIONS(3627),
    [anon_sym_mutable] = ACTIONS(3627),
    [anon_sym_constinit] = ACTIONS(3627),
    [anon_sym_consteval] = ACTIONS(3627),
    [anon_sym_alignas] = ACTIONS(3627),
    [anon_sym__Alignas] = ACTIONS(3627),
    [sym_primitive_type] = ACTIONS(3627),
    [anon_sym_enum] = ACTIONS(3627),
    [anon_sym_class] = ACTIONS(3627),
    [anon_sym_struct] = ACTIONS(3627),
    [anon_sym_union] = ACTIONS(3627),
    [anon_sym_if] = ACTIONS(3627),
    [anon_sym_else] = ACTIONS(3627),
    [anon_sym_switch] = ACTIONS(3627),
    [anon_sym_while] = ACTIONS(3627),
    [anon_sym_do] = ACTIONS(3627),
    [anon_sym_for] = ACTIONS(3627),
    [anon_sym_return] = ACTIONS(3627),
    [anon_sym_break] = ACTIONS(3627),
    [anon_sym_continue] = ACTIONS(3627),
    [anon_sym_goto] = ACTIONS(3627),
    [anon_sym___try] = ACTIONS(3627),
    [anon_sym___leave] = ACTIONS(3627),
    [anon_sym_not] = ACTIONS(3627),
    [anon_sym_compl] = ACTIONS(3627),
    [anon_sym_DASH_DASH] = ACTIONS(3625),
    [anon_sym_PLUS_PLUS] = ACTIONS(3625),
    [anon_sym_sizeof] = ACTIONS(3627),
    [anon_sym___alignof__] = ACTIONS(3627),
    [anon_sym___alignof] = ACTIONS(3627),
    [anon_sym__alignof] = ACTIONS(3627),
    [anon_sym_alignof] = ACTIONS(3627),
    [anon_sym__Alignof] = ACTIONS(3627),
    [anon_sym_offsetof] = ACTIONS(3627),
    [anon_sym__Generic] = ACTIONS(3627),
    [anon_sym_asm] = ACTIONS(3627),
    [anon_sym___asm__] = ACTIONS(3627),
    [anon_sym___asm] = ACTIONS(3627),
    [sym_number_literal] = ACTIONS(3625),
    [anon_sym_L_SQUOTE] = ACTIONS(3625),
    [anon_sym_u_SQUOTE] = ACTIONS(3625),
    [anon_sym_U_SQUOTE] = ACTIONS(3625),
    [anon_sym_u8_SQUOTE] = ACTIONS(3625),
    [anon_sym_SQUOTE] = ACTIONS(3625),
    [anon_sym_L_DQUOTE] = ACTIONS(3625),
    [anon_sym_u_DQUOTE] = ACTIONS(3625),
    [anon_sym_U_DQUOTE] = ACTIONS(3625),
    [anon_sym_u8_DQUOTE] = ACTIONS(3625),
    [anon_sym_DQUOTE] = ACTIONS(3625),
    [sym_true] = ACTIONS(3627),
    [sym_false] = ACTIONS(3627),
    [anon_sym_NULL] = ACTIONS(3627),
    [anon_sym_nullptr] = ACTIONS(3627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3627),
    [anon_sym_let] = ACTIONS(3627),
    [anon_sym_This] = ACTIONS(3627),
    [anon_sym_decltype] = ACTIONS(3627),
    [anon_sym_typename] = ACTIONS(3627),
    [anon_sym_template] = ACTIONS(3627),
    [anon_sym_try] = ACTIONS(3627),
    [anon_sym_delete] = ACTIONS(3627),
    [anon_sym_throw] = ACTIONS(3627),
    [anon_sym_co_return] = ACTIONS(3627),
    [anon_sym_co_yield] = ACTIONS(3627),
    [anon_sym_R_DQUOTE] = ACTIONS(3625),
    [anon_sym_LR_DQUOTE] = ACTIONS(3625),
    [anon_sym_uR_DQUOTE] = ACTIONS(3625),
    [anon_sym_UR_DQUOTE] = ACTIONS(3625),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3625),
    [anon_sym_co_await] = ACTIONS(3627),
    [anon_sym_new] = ACTIONS(3627),
    [anon_sym_requires] = ACTIONS(3627),
    [sym_this] = ACTIONS(3627),
    [anon_sym_discard] = ACTIONS(3627),
    [anon_sym_precise] = ACTIONS(3627),
    [anon_sym_shared] = ACTIONS(3627),
    [anon_sym_groupshared] = ACTIONS(3627),
    [anon_sym_uniform] = ACTIONS(3627),
    [anon_sym_row_major] = ACTIONS(3627),
    [anon_sym_column_major] = ACTIONS(3627),
    [anon_sym_globallycoherent] = ACTIONS(3627),
    [anon_sym_centroid] = ACTIONS(3627),
    [anon_sym_noperspective] = ACTIONS(3627),
    [anon_sym_nointerpolation] = ACTIONS(3627),
    [anon_sym_sample] = ACTIONS(3627),
    [anon_sym_linear] = ACTIONS(3627),
    [anon_sym_snorm] = ACTIONS(3627),
    [anon_sym_unorm] = ACTIONS(3627),
    [anon_sym_point] = ACTIONS(3627),
    [anon_sym_line] = ACTIONS(3627),
    [anon_sym_triangleadj] = ACTIONS(3627),
    [anon_sym_lineadj] = ACTIONS(3627),
    [anon_sym_triangle] = ACTIONS(3627),
    [anon_sym_cbuffer] = ACTIONS(3627),
    [anon_sym_interface] = ACTIONS(3627),
    [anon_sym_extension] = ACTIONS(3627),
  },
  [1400] = {
    [sym_identifier] = ACTIONS(3623),
    [anon_sym_LPAREN2] = ACTIONS(3621),
    [anon_sym_BANG] = ACTIONS(3621),
    [anon_sym_TILDE] = ACTIONS(3621),
    [anon_sym_DASH] = ACTIONS(3623),
    [anon_sym_PLUS] = ACTIONS(3623),
    [anon_sym_STAR] = ACTIONS(3621),
    [anon_sym_AMP] = ACTIONS(3621),
    [anon_sym_SEMI] = ACTIONS(3621),
    [anon_sym___extension__] = ACTIONS(3623),
    [anon_sym_typedef] = ACTIONS(3623),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_out] = ACTIONS(3623),
    [anon_sym_inout] = ACTIONS(3623),
    [anon_sym_virtual] = ACTIONS(3623),
    [anon_sym_extern] = ACTIONS(3623),
    [anon_sym___attribute__] = ACTIONS(3623),
    [anon_sym___attribute] = ACTIONS(3623),
    [anon_sym_COLON_COLON] = ACTIONS(3621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3621),
    [anon_sym___declspec] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3621),
    [anon_sym_signed] = ACTIONS(3623),
    [anon_sym_unsigned] = ACTIONS(3623),
    [anon_sym_long] = ACTIONS(3623),
    [anon_sym_short] = ACTIONS(3623),
    [anon_sym_LBRACK] = ACTIONS(3623),
    [anon_sym_static] = ACTIONS(3623),
    [anon_sym_register] = ACTIONS(3623),
    [anon_sym_inline] = ACTIONS(3623),
    [anon_sym___inline] = ACTIONS(3623),
    [anon_sym___inline__] = ACTIONS(3623),
    [anon_sym___forceinline] = ACTIONS(3623),
    [anon_sym_thread_local] = ACTIONS(3623),
    [anon_sym___thread] = ACTIONS(3623),
    [anon_sym_const] = ACTIONS(3623),
    [anon_sym_constexpr] = ACTIONS(3623),
    [anon_sym_volatile] = ACTIONS(3623),
    [anon_sym_restrict] = ACTIONS(3623),
    [anon_sym___restrict__] = ACTIONS(3623),
    [anon_sym__Atomic] = ACTIONS(3623),
    [anon_sym__Noreturn] = ACTIONS(3623),
    [anon_sym_noreturn] = ACTIONS(3623),
    [anon_sym__Nonnull] = ACTIONS(3623),
    [anon_sym_mutable] = ACTIONS(3623),
    [anon_sym_constinit] = ACTIONS(3623),
    [anon_sym_consteval] = ACTIONS(3623),
    [anon_sym_alignas] = ACTIONS(3623),
    [anon_sym__Alignas] = ACTIONS(3623),
    [sym_primitive_type] = ACTIONS(3623),
    [anon_sym_enum] = ACTIONS(3623),
    [anon_sym_class] = ACTIONS(3623),
    [anon_sym_struct] = ACTIONS(3623),
    [anon_sym_union] = ACTIONS(3623),
    [anon_sym_if] = ACTIONS(3623),
    [anon_sym_else] = ACTIONS(3623),
    [anon_sym_switch] = ACTIONS(3623),
    [anon_sym_while] = ACTIONS(3623),
    [anon_sym_do] = ACTIONS(3623),
    [anon_sym_for] = ACTIONS(3623),
    [anon_sym_return] = ACTIONS(3623),
    [anon_sym_break] = ACTIONS(3623),
    [anon_sym_continue] = ACTIONS(3623),
    [anon_sym_goto] = ACTIONS(3623),
    [anon_sym___try] = ACTIONS(3623),
    [anon_sym___leave] = ACTIONS(3623),
    [anon_sym_not] = ACTIONS(3623),
    [anon_sym_compl] = ACTIONS(3623),
    [anon_sym_DASH_DASH] = ACTIONS(3621),
    [anon_sym_PLUS_PLUS] = ACTIONS(3621),
    [anon_sym_sizeof] = ACTIONS(3623),
    [anon_sym___alignof__] = ACTIONS(3623),
    [anon_sym___alignof] = ACTIONS(3623),
    [anon_sym__alignof] = ACTIONS(3623),
    [anon_sym_alignof] = ACTIONS(3623),
    [anon_sym__Alignof] = ACTIONS(3623),
    [anon_sym_offsetof] = ACTIONS(3623),
    [anon_sym__Generic] = ACTIONS(3623),
    [anon_sym_asm] = ACTIONS(3623),
    [anon_sym___asm__] = ACTIONS(3623),
    [anon_sym___asm] = ACTIONS(3623),
    [sym_number_literal] = ACTIONS(3621),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3621),
    [anon_sym_u_DQUOTE] = ACTIONS(3621),
    [anon_sym_U_DQUOTE] = ACTIONS(3621),
    [anon_sym_u8_DQUOTE] = ACTIONS(3621),
    [anon_sym_DQUOTE] = ACTIONS(3621),
    [sym_true] = ACTIONS(3623),
    [sym_false] = ACTIONS(3623),
    [anon_sym_NULL] = ACTIONS(3623),
    [anon_sym_nullptr] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3623),
    [anon_sym_let] = ACTIONS(3623),
    [anon_sym_This] = ACTIONS(3623),
    [anon_sym_decltype] = ACTIONS(3623),
    [anon_sym_typename] = ACTIONS(3623),
    [anon_sym_template] = ACTIONS(3623),
    [anon_sym_try] = ACTIONS(3623),
    [anon_sym_delete] = ACTIONS(3623),
    [anon_sym_throw] = ACTIONS(3623),
    [anon_sym_co_return] = ACTIONS(3623),
    [anon_sym_co_yield] = ACTIONS(3623),
    [anon_sym_R_DQUOTE] = ACTIONS(3621),
    [anon_sym_LR_DQUOTE] = ACTIONS(3621),
    [anon_sym_uR_DQUOTE] = ACTIONS(3621),
    [anon_sym_UR_DQUOTE] = ACTIONS(3621),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3621),
    [anon_sym_co_await] = ACTIONS(3623),
    [anon_sym_new] = ACTIONS(3623),
    [anon_sym_requires] = ACTIONS(3623),
    [sym_this] = ACTIONS(3623),
    [anon_sym_discard] = ACTIONS(3623),
    [anon_sym_precise] = ACTIONS(3623),
    [anon_sym_shared] = ACTIONS(3623),
    [anon_sym_groupshared] = ACTIONS(3623),
    [anon_sym_uniform] = ACTIONS(3623),
    [anon_sym_row_major] = ACTIONS(3623),
    [anon_sym_column_major] = ACTIONS(3623),
    [anon_sym_globallycoherent] = ACTIONS(3623),
    [anon_sym_centroid] = ACTIONS(3623),
    [anon_sym_noperspective] = ACTIONS(3623),
    [anon_sym_nointerpolation] = ACTIONS(3623),
    [anon_sym_sample] = ACTIONS(3623),
    [anon_sym_linear] = ACTIONS(3623),
    [anon_sym_snorm] = ACTIONS(3623),
    [anon_sym_unorm] = ACTIONS(3623),
    [anon_sym_point] = ACTIONS(3623),
    [anon_sym_line] = ACTIONS(3623),
    [anon_sym_triangleadj] = ACTIONS(3623),
    [anon_sym_lineadj] = ACTIONS(3623),
    [anon_sym_triangle] = ACTIONS(3623),
    [anon_sym_cbuffer] = ACTIONS(3623),
    [anon_sym_interface] = ACTIONS(3623),
    [anon_sym_extension] = ACTIONS(3623),
  },
  [1401] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(1605),
    [sym_raw_string_literal] = STATE(3527),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2764),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2172),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2183),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2193),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym___cdecl] = ACTIONS(2168),
    [anon_sym___clrcall] = ACTIONS(2168),
    [anon_sym___stdcall] = ACTIONS(2168),
    [anon_sym___fastcall] = ACTIONS(2168),
    [anon_sym___thiscall] = ACTIONS(2168),
    [anon_sym___vectorcall] = ACTIONS(2168),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_signed] = ACTIONS(5332),
    [anon_sym_unsigned] = ACTIONS(5332),
    [anon_sym_long] = ACTIONS(5332),
    [anon_sym_short] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2207),
    [anon_sym_SLASH_EQ] = ACTIONS(2207),
    [anon_sym_PERCENT_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_GT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_EQ] = ACTIONS(2207),
    [anon_sym_CARET_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_EQ] = ACTIONS(2207),
    [anon_sym_and_eq] = ACTIONS(2205),
    [anon_sym_or_eq] = ACTIONS(2205),
    [anon_sym_xor_eq] = ACTIONS(2205),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_decltype] = ACTIONS(2168),
    [anon_sym_template] = ACTIONS(2168),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
  },
  [1402] = {
    [sym_identifier] = ACTIONS(3623),
    [anon_sym_LPAREN2] = ACTIONS(3621),
    [anon_sym_BANG] = ACTIONS(3621),
    [anon_sym_TILDE] = ACTIONS(3621),
    [anon_sym_DASH] = ACTIONS(3623),
    [anon_sym_PLUS] = ACTIONS(3623),
    [anon_sym_STAR] = ACTIONS(3621),
    [anon_sym_AMP] = ACTIONS(3621),
    [anon_sym_SEMI] = ACTIONS(3621),
    [anon_sym___extension__] = ACTIONS(3623),
    [anon_sym_typedef] = ACTIONS(3623),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_out] = ACTIONS(3623),
    [anon_sym_inout] = ACTIONS(3623),
    [anon_sym_virtual] = ACTIONS(3623),
    [anon_sym_extern] = ACTIONS(3623),
    [anon_sym___attribute__] = ACTIONS(3623),
    [anon_sym___attribute] = ACTIONS(3623),
    [anon_sym_COLON_COLON] = ACTIONS(3621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3621),
    [anon_sym___declspec] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3621),
    [anon_sym_signed] = ACTIONS(3623),
    [anon_sym_unsigned] = ACTIONS(3623),
    [anon_sym_long] = ACTIONS(3623),
    [anon_sym_short] = ACTIONS(3623),
    [anon_sym_LBRACK] = ACTIONS(3623),
    [anon_sym_static] = ACTIONS(3623),
    [anon_sym_register] = ACTIONS(3623),
    [anon_sym_inline] = ACTIONS(3623),
    [anon_sym___inline] = ACTIONS(3623),
    [anon_sym___inline__] = ACTIONS(3623),
    [anon_sym___forceinline] = ACTIONS(3623),
    [anon_sym_thread_local] = ACTIONS(3623),
    [anon_sym___thread] = ACTIONS(3623),
    [anon_sym_const] = ACTIONS(3623),
    [anon_sym_constexpr] = ACTIONS(3623),
    [anon_sym_volatile] = ACTIONS(3623),
    [anon_sym_restrict] = ACTIONS(3623),
    [anon_sym___restrict__] = ACTIONS(3623),
    [anon_sym__Atomic] = ACTIONS(3623),
    [anon_sym__Noreturn] = ACTIONS(3623),
    [anon_sym_noreturn] = ACTIONS(3623),
    [anon_sym__Nonnull] = ACTIONS(3623),
    [anon_sym_mutable] = ACTIONS(3623),
    [anon_sym_constinit] = ACTIONS(3623),
    [anon_sym_consteval] = ACTIONS(3623),
    [anon_sym_alignas] = ACTIONS(3623),
    [anon_sym__Alignas] = ACTIONS(3623),
    [sym_primitive_type] = ACTIONS(3623),
    [anon_sym_enum] = ACTIONS(3623),
    [anon_sym_class] = ACTIONS(3623),
    [anon_sym_struct] = ACTIONS(3623),
    [anon_sym_union] = ACTIONS(3623),
    [anon_sym_if] = ACTIONS(3623),
    [anon_sym_else] = ACTIONS(3623),
    [anon_sym_switch] = ACTIONS(3623),
    [anon_sym_while] = ACTIONS(3623),
    [anon_sym_do] = ACTIONS(3623),
    [anon_sym_for] = ACTIONS(3623),
    [anon_sym_return] = ACTIONS(3623),
    [anon_sym_break] = ACTIONS(3623),
    [anon_sym_continue] = ACTIONS(3623),
    [anon_sym_goto] = ACTIONS(3623),
    [anon_sym___try] = ACTIONS(3623),
    [anon_sym___leave] = ACTIONS(3623),
    [anon_sym_not] = ACTIONS(3623),
    [anon_sym_compl] = ACTIONS(3623),
    [anon_sym_DASH_DASH] = ACTIONS(3621),
    [anon_sym_PLUS_PLUS] = ACTIONS(3621),
    [anon_sym_sizeof] = ACTIONS(3623),
    [anon_sym___alignof__] = ACTIONS(3623),
    [anon_sym___alignof] = ACTIONS(3623),
    [anon_sym__alignof] = ACTIONS(3623),
    [anon_sym_alignof] = ACTIONS(3623),
    [anon_sym__Alignof] = ACTIONS(3623),
    [anon_sym_offsetof] = ACTIONS(3623),
    [anon_sym__Generic] = ACTIONS(3623),
    [anon_sym_asm] = ACTIONS(3623),
    [anon_sym___asm__] = ACTIONS(3623),
    [anon_sym___asm] = ACTIONS(3623),
    [sym_number_literal] = ACTIONS(3621),
    [anon_sym_L_SQUOTE] = ACTIONS(3621),
    [anon_sym_u_SQUOTE] = ACTIONS(3621),
    [anon_sym_U_SQUOTE] = ACTIONS(3621),
    [anon_sym_u8_SQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [anon_sym_L_DQUOTE] = ACTIONS(3621),
    [anon_sym_u_DQUOTE] = ACTIONS(3621),
    [anon_sym_U_DQUOTE] = ACTIONS(3621),
    [anon_sym_u8_DQUOTE] = ACTIONS(3621),
    [anon_sym_DQUOTE] = ACTIONS(3621),
    [sym_true] = ACTIONS(3623),
    [sym_false] = ACTIONS(3623),
    [anon_sym_NULL] = ACTIONS(3623),
    [anon_sym_nullptr] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3623),
    [anon_sym_let] = ACTIONS(3623),
    [anon_sym_This] = ACTIONS(3623),
    [anon_sym_decltype] = ACTIONS(3623),
    [anon_sym_typename] = ACTIONS(3623),
    [anon_sym_template] = ACTIONS(3623),
    [anon_sym_try] = ACTIONS(3623),
    [anon_sym_delete] = ACTIONS(3623),
    [anon_sym_throw] = ACTIONS(3623),
    [anon_sym_co_return] = ACTIONS(3623),
    [anon_sym_co_yield] = ACTIONS(3623),
    [anon_sym_R_DQUOTE] = ACTIONS(3621),
    [anon_sym_LR_DQUOTE] = ACTIONS(3621),
    [anon_sym_uR_DQUOTE] = ACTIONS(3621),
    [anon_sym_UR_DQUOTE] = ACTIONS(3621),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3621),
    [anon_sym_co_await] = ACTIONS(3623),
    [anon_sym_new] = ACTIONS(3623),
    [anon_sym_requires] = ACTIONS(3623),
    [sym_this] = ACTIONS(3623),
    [anon_sym_discard] = ACTIONS(3623),
    [anon_sym_precise] = ACTIONS(3623),
    [anon_sym_shared] = ACTIONS(3623),
    [anon_sym_groupshared] = ACTIONS(3623),
    [anon_sym_uniform] = ACTIONS(3623),
    [anon_sym_row_major] = ACTIONS(3623),
    [anon_sym_column_major] = ACTIONS(3623),
    [anon_sym_globallycoherent] = ACTIONS(3623),
    [anon_sym_centroid] = ACTIONS(3623),
    [anon_sym_noperspective] = ACTIONS(3623),
    [anon_sym_nointerpolation] = ACTIONS(3623),
    [anon_sym_sample] = ACTIONS(3623),
    [anon_sym_linear] = ACTIONS(3623),
    [anon_sym_snorm] = ACTIONS(3623),
    [anon_sym_unorm] = ACTIONS(3623),
    [anon_sym_point] = ACTIONS(3623),
    [anon_sym_line] = ACTIONS(3623),
    [anon_sym_triangleadj] = ACTIONS(3623),
    [anon_sym_lineadj] = ACTIONS(3623),
    [anon_sym_triangle] = ACTIONS(3623),
    [anon_sym_cbuffer] = ACTIONS(3623),
    [anon_sym_interface] = ACTIONS(3623),
    [anon_sym_extension] = ACTIONS(3623),
  },
  [1403] = {
    [sym_identifier] = ACTIONS(3399),
    [anon_sym_LPAREN2] = ACTIONS(3401),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_STAR] = ACTIONS(3401),
    [anon_sym_AMP] = ACTIONS(3401),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym___extension__] = ACTIONS(3399),
    [anon_sym_typedef] = ACTIONS(3399),
    [anon_sym_in] = ACTIONS(3399),
    [anon_sym_out] = ACTIONS(3399),
    [anon_sym_inout] = ACTIONS(3399),
    [anon_sym_virtual] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym___attribute__] = ACTIONS(3399),
    [anon_sym___attribute] = ACTIONS(3399),
    [anon_sym_COLON_COLON] = ACTIONS(3401),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3401),
    [anon_sym___declspec] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_signed] = ACTIONS(3399),
    [anon_sym_unsigned] = ACTIONS(3399),
    [anon_sym_long] = ACTIONS(3399),
    [anon_sym_short] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_register] = ACTIONS(3399),
    [anon_sym_inline] = ACTIONS(3399),
    [anon_sym___inline] = ACTIONS(3399),
    [anon_sym___inline__] = ACTIONS(3399),
    [anon_sym___forceinline] = ACTIONS(3399),
    [anon_sym_thread_local] = ACTIONS(3399),
    [anon_sym___thread] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_constexpr] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym_restrict] = ACTIONS(3399),
    [anon_sym___restrict__] = ACTIONS(3399),
    [anon_sym__Atomic] = ACTIONS(3399),
    [anon_sym__Noreturn] = ACTIONS(3399),
    [anon_sym_noreturn] = ACTIONS(3399),
    [anon_sym__Nonnull] = ACTIONS(3399),
    [anon_sym_mutable] = ACTIONS(3399),
    [anon_sym_constinit] = ACTIONS(3399),
    [anon_sym_consteval] = ACTIONS(3399),
    [anon_sym_alignas] = ACTIONS(3399),
    [anon_sym__Alignas] = ACTIONS(3399),
    [sym_primitive_type] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_union] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_else] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_goto] = ACTIONS(3399),
    [anon_sym___try] = ACTIONS(3399),
    [anon_sym___leave] = ACTIONS(3399),
    [anon_sym_not] = ACTIONS(3399),
    [anon_sym_compl] = ACTIONS(3399),
    [anon_sym_DASH_DASH] = ACTIONS(3401),
    [anon_sym_PLUS_PLUS] = ACTIONS(3401),
    [anon_sym_sizeof] = ACTIONS(3399),
    [anon_sym___alignof__] = ACTIONS(3399),
    [anon_sym___alignof] = ACTIONS(3399),
    [anon_sym__alignof] = ACTIONS(3399),
    [anon_sym_alignof] = ACTIONS(3399),
    [anon_sym__Alignof] = ACTIONS(3399),
    [anon_sym_offsetof] = ACTIONS(3399),
    [anon_sym__Generic] = ACTIONS(3399),
    [anon_sym_asm] = ACTIONS(3399),
    [anon_sym___asm__] = ACTIONS(3399),
    [anon_sym___asm] = ACTIONS(3399),
    [sym_number_literal] = ACTIONS(3401),
    [anon_sym_L_SQUOTE] = ACTIONS(3401),
    [anon_sym_u_SQUOTE] = ACTIONS(3401),
    [anon_sym_U_SQUOTE] = ACTIONS(3401),
    [anon_sym_u8_SQUOTE] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(3401),
    [anon_sym_L_DQUOTE] = ACTIONS(3401),
    [anon_sym_u_DQUOTE] = ACTIONS(3401),
    [anon_sym_U_DQUOTE] = ACTIONS(3401),
    [anon_sym_u8_DQUOTE] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [sym_true] = ACTIONS(3399),
    [sym_false] = ACTIONS(3399),
    [anon_sym_NULL] = ACTIONS(3399),
    [anon_sym_nullptr] = ACTIONS(3399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_This] = ACTIONS(3399),
    [anon_sym_decltype] = ACTIONS(3399),
    [anon_sym_typename] = ACTIONS(3399),
    [anon_sym_template] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_delete] = ACTIONS(3399),
    [anon_sym_throw] = ACTIONS(3399),
    [anon_sym_co_return] = ACTIONS(3399),
    [anon_sym_co_yield] = ACTIONS(3399),
    [anon_sym_R_DQUOTE] = ACTIONS(3401),
    [anon_sym_LR_DQUOTE] = ACTIONS(3401),
    [anon_sym_uR_DQUOTE] = ACTIONS(3401),
    [anon_sym_UR_DQUOTE] = ACTIONS(3401),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3401),
    [anon_sym_co_await] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_requires] = ACTIONS(3399),
    [sym_this] = ACTIONS(3399),
    [anon_sym_discard] = ACTIONS(3399),
    [anon_sym_precise] = ACTIONS(3399),
    [anon_sym_shared] = ACTIONS(3399),
    [anon_sym_groupshared] = ACTIONS(3399),
    [anon_sym_uniform] = ACTIONS(3399),
    [anon_sym_row_major] = ACTIONS(3399),
    [anon_sym_column_major] = ACTIONS(3399),
    [anon_sym_globallycoherent] = ACTIONS(3399),
    [anon_sym_centroid] = ACTIONS(3399),
    [anon_sym_noperspective] = ACTIONS(3399),
    [anon_sym_nointerpolation] = ACTIONS(3399),
    [anon_sym_sample] = ACTIONS(3399),
    [anon_sym_linear] = ACTIONS(3399),
    [anon_sym_snorm] = ACTIONS(3399),
    [anon_sym_unorm] = ACTIONS(3399),
    [anon_sym_point] = ACTIONS(3399),
    [anon_sym_line] = ACTIONS(3399),
    [anon_sym_triangleadj] = ACTIONS(3399),
    [anon_sym_lineadj] = ACTIONS(3399),
    [anon_sym_triangle] = ACTIONS(3399),
    [anon_sym_cbuffer] = ACTIONS(3399),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_extension] = ACTIONS(3399),
  },
  [1404] = {
    [sym_identifier] = ACTIONS(3399),
    [anon_sym_LPAREN2] = ACTIONS(3401),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_STAR] = ACTIONS(3401),
    [anon_sym_AMP] = ACTIONS(3401),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym___extension__] = ACTIONS(3399),
    [anon_sym_typedef] = ACTIONS(3399),
    [anon_sym_in] = ACTIONS(3399),
    [anon_sym_out] = ACTIONS(3399),
    [anon_sym_inout] = ACTIONS(3399),
    [anon_sym_virtual] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym___attribute__] = ACTIONS(3399),
    [anon_sym___attribute] = ACTIONS(3399),
    [anon_sym_COLON_COLON] = ACTIONS(3401),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3401),
    [anon_sym___declspec] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_signed] = ACTIONS(3399),
    [anon_sym_unsigned] = ACTIONS(3399),
    [anon_sym_long] = ACTIONS(3399),
    [anon_sym_short] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_register] = ACTIONS(3399),
    [anon_sym_inline] = ACTIONS(3399),
    [anon_sym___inline] = ACTIONS(3399),
    [anon_sym___inline__] = ACTIONS(3399),
    [anon_sym___forceinline] = ACTIONS(3399),
    [anon_sym_thread_local] = ACTIONS(3399),
    [anon_sym___thread] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_constexpr] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym_restrict] = ACTIONS(3399),
    [anon_sym___restrict__] = ACTIONS(3399),
    [anon_sym__Atomic] = ACTIONS(3399),
    [anon_sym__Noreturn] = ACTIONS(3399),
    [anon_sym_noreturn] = ACTIONS(3399),
    [anon_sym__Nonnull] = ACTIONS(3399),
    [anon_sym_mutable] = ACTIONS(3399),
    [anon_sym_constinit] = ACTIONS(3399),
    [anon_sym_consteval] = ACTIONS(3399),
    [anon_sym_alignas] = ACTIONS(3399),
    [anon_sym__Alignas] = ACTIONS(3399),
    [sym_primitive_type] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_union] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_else] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_goto] = ACTIONS(3399),
    [anon_sym___try] = ACTIONS(3399),
    [anon_sym___leave] = ACTIONS(3399),
    [anon_sym_not] = ACTIONS(3399),
    [anon_sym_compl] = ACTIONS(3399),
    [anon_sym_DASH_DASH] = ACTIONS(3401),
    [anon_sym_PLUS_PLUS] = ACTIONS(3401),
    [anon_sym_sizeof] = ACTIONS(3399),
    [anon_sym___alignof__] = ACTIONS(3399),
    [anon_sym___alignof] = ACTIONS(3399),
    [anon_sym__alignof] = ACTIONS(3399),
    [anon_sym_alignof] = ACTIONS(3399),
    [anon_sym__Alignof] = ACTIONS(3399),
    [anon_sym_offsetof] = ACTIONS(3399),
    [anon_sym__Generic] = ACTIONS(3399),
    [anon_sym_asm] = ACTIONS(3399),
    [anon_sym___asm__] = ACTIONS(3399),
    [anon_sym___asm] = ACTIONS(3399),
    [sym_number_literal] = ACTIONS(3401),
    [anon_sym_L_SQUOTE] = ACTIONS(3401),
    [anon_sym_u_SQUOTE] = ACTIONS(3401),
    [anon_sym_U_SQUOTE] = ACTIONS(3401),
    [anon_sym_u8_SQUOTE] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(3401),
    [anon_sym_L_DQUOTE] = ACTIONS(3401),
    [anon_sym_u_DQUOTE] = ACTIONS(3401),
    [anon_sym_U_DQUOTE] = ACTIONS(3401),
    [anon_sym_u8_DQUOTE] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [sym_true] = ACTIONS(3399),
    [sym_false] = ACTIONS(3399),
    [anon_sym_NULL] = ACTIONS(3399),
    [anon_sym_nullptr] = ACTIONS(3399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_This] = ACTIONS(3399),
    [anon_sym_decltype] = ACTIONS(3399),
    [anon_sym_typename] = ACTIONS(3399),
    [anon_sym_template] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_delete] = ACTIONS(3399),
    [anon_sym_throw] = ACTIONS(3399),
    [anon_sym_co_return] = ACTIONS(3399),
    [anon_sym_co_yield] = ACTIONS(3399),
    [anon_sym_R_DQUOTE] = ACTIONS(3401),
    [anon_sym_LR_DQUOTE] = ACTIONS(3401),
    [anon_sym_uR_DQUOTE] = ACTIONS(3401),
    [anon_sym_UR_DQUOTE] = ACTIONS(3401),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3401),
    [anon_sym_co_await] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_requires] = ACTIONS(3399),
    [sym_this] = ACTIONS(3399),
    [anon_sym_discard] = ACTIONS(3399),
    [anon_sym_precise] = ACTIONS(3399),
    [anon_sym_shared] = ACTIONS(3399),
    [anon_sym_groupshared] = ACTIONS(3399),
    [anon_sym_uniform] = ACTIONS(3399),
    [anon_sym_row_major] = ACTIONS(3399),
    [anon_sym_column_major] = ACTIONS(3399),
    [anon_sym_globallycoherent] = ACTIONS(3399),
    [anon_sym_centroid] = ACTIONS(3399),
    [anon_sym_noperspective] = ACTIONS(3399),
    [anon_sym_nointerpolation] = ACTIONS(3399),
    [anon_sym_sample] = ACTIONS(3399),
    [anon_sym_linear] = ACTIONS(3399),
    [anon_sym_snorm] = ACTIONS(3399),
    [anon_sym_unorm] = ACTIONS(3399),
    [anon_sym_point] = ACTIONS(3399),
    [anon_sym_line] = ACTIONS(3399),
    [anon_sym_triangleadj] = ACTIONS(3399),
    [anon_sym_lineadj] = ACTIONS(3399),
    [anon_sym_triangle] = ACTIONS(3399),
    [anon_sym_cbuffer] = ACTIONS(3399),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_extension] = ACTIONS(3399),
  },
  [1405] = {
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(3450),
    [anon_sym_BANG] = ACTIONS(3450),
    [anon_sym_TILDE] = ACTIONS(3450),
    [anon_sym_DASH] = ACTIONS(3452),
    [anon_sym_PLUS] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_AMP] = ACTIONS(3450),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym___extension__] = ACTIONS(3452),
    [anon_sym_typedef] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_out] = ACTIONS(3452),
    [anon_sym_inout] = ACTIONS(3452),
    [anon_sym_virtual] = ACTIONS(3452),
    [anon_sym_extern] = ACTIONS(3452),
    [anon_sym___attribute__] = ACTIONS(3452),
    [anon_sym___attribute] = ACTIONS(3452),
    [anon_sym_COLON_COLON] = ACTIONS(3450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3450),
    [anon_sym___declspec] = ACTIONS(3452),
    [anon_sym_LBRACE] = ACTIONS(3450),
    [anon_sym_signed] = ACTIONS(3452),
    [anon_sym_unsigned] = ACTIONS(3452),
    [anon_sym_long] = ACTIONS(3452),
    [anon_sym_short] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3452),
    [anon_sym_static] = ACTIONS(3452),
    [anon_sym_register] = ACTIONS(3452),
    [anon_sym_inline] = ACTIONS(3452),
    [anon_sym___inline] = ACTIONS(3452),
    [anon_sym___inline__] = ACTIONS(3452),
    [anon_sym___forceinline] = ACTIONS(3452),
    [anon_sym_thread_local] = ACTIONS(3452),
    [anon_sym___thread] = ACTIONS(3452),
    [anon_sym_const] = ACTIONS(3452),
    [anon_sym_constexpr] = ACTIONS(3452),
    [anon_sym_volatile] = ACTIONS(3452),
    [anon_sym_restrict] = ACTIONS(3452),
    [anon_sym___restrict__] = ACTIONS(3452),
    [anon_sym__Atomic] = ACTIONS(3452),
    [anon_sym__Noreturn] = ACTIONS(3452),
    [anon_sym_noreturn] = ACTIONS(3452),
    [anon_sym__Nonnull] = ACTIONS(3452),
    [anon_sym_mutable] = ACTIONS(3452),
    [anon_sym_constinit] = ACTIONS(3452),
    [anon_sym_consteval] = ACTIONS(3452),
    [anon_sym_alignas] = ACTIONS(3452),
    [anon_sym__Alignas] = ACTIONS(3452),
    [sym_primitive_type] = ACTIONS(3452),
    [anon_sym_enum] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(3452),
    [anon_sym_union] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_else] = ACTIONS(3452),
    [anon_sym_switch] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_do] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3452),
    [anon_sym_return] = ACTIONS(3452),
    [anon_sym_break] = ACTIONS(3452),
    [anon_sym_continue] = ACTIONS(3452),
    [anon_sym_goto] = ACTIONS(3452),
    [anon_sym___try] = ACTIONS(3452),
    [anon_sym___leave] = ACTIONS(3452),
    [anon_sym_not] = ACTIONS(3452),
    [anon_sym_compl] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3450),
    [anon_sym_PLUS_PLUS] = ACTIONS(3450),
    [anon_sym_sizeof] = ACTIONS(3452),
    [anon_sym___alignof__] = ACTIONS(3452),
    [anon_sym___alignof] = ACTIONS(3452),
    [anon_sym__alignof] = ACTIONS(3452),
    [anon_sym_alignof] = ACTIONS(3452),
    [anon_sym__Alignof] = ACTIONS(3452),
    [anon_sym_offsetof] = ACTIONS(3452),
    [anon_sym__Generic] = ACTIONS(3452),
    [anon_sym_asm] = ACTIONS(3452),
    [anon_sym___asm__] = ACTIONS(3452),
    [anon_sym___asm] = ACTIONS(3452),
    [sym_number_literal] = ACTIONS(3450),
    [anon_sym_L_SQUOTE] = ACTIONS(3450),
    [anon_sym_u_SQUOTE] = ACTIONS(3450),
    [anon_sym_U_SQUOTE] = ACTIONS(3450),
    [anon_sym_u8_SQUOTE] = ACTIONS(3450),
    [anon_sym_SQUOTE] = ACTIONS(3450),
    [anon_sym_L_DQUOTE] = ACTIONS(3450),
    [anon_sym_u_DQUOTE] = ACTIONS(3450),
    [anon_sym_U_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8_DQUOTE] = ACTIONS(3450),
    [anon_sym_DQUOTE] = ACTIONS(3450),
    [sym_true] = ACTIONS(3452),
    [sym_false] = ACTIONS(3452),
    [anon_sym_NULL] = ACTIONS(3452),
    [anon_sym_nullptr] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3452),
    [anon_sym_let] = ACTIONS(3452),
    [anon_sym_This] = ACTIONS(3452),
    [anon_sym_decltype] = ACTIONS(3452),
    [anon_sym_typename] = ACTIONS(3452),
    [anon_sym_template] = ACTIONS(3452),
    [anon_sym_try] = ACTIONS(3452),
    [anon_sym_delete] = ACTIONS(3452),
    [anon_sym_throw] = ACTIONS(3452),
    [anon_sym_co_return] = ACTIONS(3452),
    [anon_sym_co_yield] = ACTIONS(3452),
    [anon_sym_R_DQUOTE] = ACTIONS(3450),
    [anon_sym_LR_DQUOTE] = ACTIONS(3450),
    [anon_sym_uR_DQUOTE] = ACTIONS(3450),
    [anon_sym_UR_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3450),
    [anon_sym_co_await] = ACTIONS(3452),
    [anon_sym_new] = ACTIONS(3452),
    [anon_sym_requires] = ACTIONS(3452),
    [sym_this] = ACTIONS(3452),
    [anon_sym_discard] = ACTIONS(3452),
    [anon_sym_precise] = ACTIONS(3452),
    [anon_sym_shared] = ACTIONS(3452),
    [anon_sym_groupshared] = ACTIONS(3452),
    [anon_sym_uniform] = ACTIONS(3452),
    [anon_sym_row_major] = ACTIONS(3452),
    [anon_sym_column_major] = ACTIONS(3452),
    [anon_sym_globallycoherent] = ACTIONS(3452),
    [anon_sym_centroid] = ACTIONS(3452),
    [anon_sym_noperspective] = ACTIONS(3452),
    [anon_sym_nointerpolation] = ACTIONS(3452),
    [anon_sym_sample] = ACTIONS(3452),
    [anon_sym_linear] = ACTIONS(3452),
    [anon_sym_snorm] = ACTIONS(3452),
    [anon_sym_unorm] = ACTIONS(3452),
    [anon_sym_point] = ACTIONS(3452),
    [anon_sym_line] = ACTIONS(3452),
    [anon_sym_triangleadj] = ACTIONS(3452),
    [anon_sym_lineadj] = ACTIONS(3452),
    [anon_sym_triangle] = ACTIONS(3452),
    [anon_sym_cbuffer] = ACTIONS(3452),
    [anon_sym_interface] = ACTIONS(3452),
    [anon_sym_extension] = ACTIONS(3452),
  },
  [1406] = {
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(3450),
    [anon_sym_BANG] = ACTIONS(3450),
    [anon_sym_TILDE] = ACTIONS(3450),
    [anon_sym_DASH] = ACTIONS(3452),
    [anon_sym_PLUS] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_AMP] = ACTIONS(3450),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym___extension__] = ACTIONS(3452),
    [anon_sym_typedef] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_out] = ACTIONS(3452),
    [anon_sym_inout] = ACTIONS(3452),
    [anon_sym_virtual] = ACTIONS(3452),
    [anon_sym_extern] = ACTIONS(3452),
    [anon_sym___attribute__] = ACTIONS(3452),
    [anon_sym___attribute] = ACTIONS(3452),
    [anon_sym_COLON_COLON] = ACTIONS(3450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3450),
    [anon_sym___declspec] = ACTIONS(3452),
    [anon_sym_LBRACE] = ACTIONS(3450),
    [anon_sym_signed] = ACTIONS(3452),
    [anon_sym_unsigned] = ACTIONS(3452),
    [anon_sym_long] = ACTIONS(3452),
    [anon_sym_short] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3452),
    [anon_sym_static] = ACTIONS(3452),
    [anon_sym_register] = ACTIONS(3452),
    [anon_sym_inline] = ACTIONS(3452),
    [anon_sym___inline] = ACTIONS(3452),
    [anon_sym___inline__] = ACTIONS(3452),
    [anon_sym___forceinline] = ACTIONS(3452),
    [anon_sym_thread_local] = ACTIONS(3452),
    [anon_sym___thread] = ACTIONS(3452),
    [anon_sym_const] = ACTIONS(3452),
    [anon_sym_constexpr] = ACTIONS(3452),
    [anon_sym_volatile] = ACTIONS(3452),
    [anon_sym_restrict] = ACTIONS(3452),
    [anon_sym___restrict__] = ACTIONS(3452),
    [anon_sym__Atomic] = ACTIONS(3452),
    [anon_sym__Noreturn] = ACTIONS(3452),
    [anon_sym_noreturn] = ACTIONS(3452),
    [anon_sym__Nonnull] = ACTIONS(3452),
    [anon_sym_mutable] = ACTIONS(3452),
    [anon_sym_constinit] = ACTIONS(3452),
    [anon_sym_consteval] = ACTIONS(3452),
    [anon_sym_alignas] = ACTIONS(3452),
    [anon_sym__Alignas] = ACTIONS(3452),
    [sym_primitive_type] = ACTIONS(3452),
    [anon_sym_enum] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(3452),
    [anon_sym_union] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_else] = ACTIONS(3452),
    [anon_sym_switch] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_do] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3452),
    [anon_sym_return] = ACTIONS(3452),
    [anon_sym_break] = ACTIONS(3452),
    [anon_sym_continue] = ACTIONS(3452),
    [anon_sym_goto] = ACTIONS(3452),
    [anon_sym___try] = ACTIONS(3452),
    [anon_sym___leave] = ACTIONS(3452),
    [anon_sym_not] = ACTIONS(3452),
    [anon_sym_compl] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3450),
    [anon_sym_PLUS_PLUS] = ACTIONS(3450),
    [anon_sym_sizeof] = ACTIONS(3452),
    [anon_sym___alignof__] = ACTIONS(3452),
    [anon_sym___alignof] = ACTIONS(3452),
    [anon_sym__alignof] = ACTIONS(3452),
    [anon_sym_alignof] = ACTIONS(3452),
    [anon_sym__Alignof] = ACTIONS(3452),
    [anon_sym_offsetof] = ACTIONS(3452),
    [anon_sym__Generic] = ACTIONS(3452),
    [anon_sym_asm] = ACTIONS(3452),
    [anon_sym___asm__] = ACTIONS(3452),
    [anon_sym___asm] = ACTIONS(3452),
    [sym_number_literal] = ACTIONS(3450),
    [anon_sym_L_SQUOTE] = ACTIONS(3450),
    [anon_sym_u_SQUOTE] = ACTIONS(3450),
    [anon_sym_U_SQUOTE] = ACTIONS(3450),
    [anon_sym_u8_SQUOTE] = ACTIONS(3450),
    [anon_sym_SQUOTE] = ACTIONS(3450),
    [anon_sym_L_DQUOTE] = ACTIONS(3450),
    [anon_sym_u_DQUOTE] = ACTIONS(3450),
    [anon_sym_U_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8_DQUOTE] = ACTIONS(3450),
    [anon_sym_DQUOTE] = ACTIONS(3450),
    [sym_true] = ACTIONS(3452),
    [sym_false] = ACTIONS(3452),
    [anon_sym_NULL] = ACTIONS(3452),
    [anon_sym_nullptr] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3452),
    [anon_sym_let] = ACTIONS(3452),
    [anon_sym_This] = ACTIONS(3452),
    [anon_sym_decltype] = ACTIONS(3452),
    [anon_sym_typename] = ACTIONS(3452),
    [anon_sym_template] = ACTIONS(3452),
    [anon_sym_try] = ACTIONS(3452),
    [anon_sym_delete] = ACTIONS(3452),
    [anon_sym_throw] = ACTIONS(3452),
    [anon_sym_co_return] = ACTIONS(3452),
    [anon_sym_co_yield] = ACTIONS(3452),
    [anon_sym_R_DQUOTE] = ACTIONS(3450),
    [anon_sym_LR_DQUOTE] = ACTIONS(3450),
    [anon_sym_uR_DQUOTE] = ACTIONS(3450),
    [anon_sym_UR_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3450),
    [anon_sym_co_await] = ACTIONS(3452),
    [anon_sym_new] = ACTIONS(3452),
    [anon_sym_requires] = ACTIONS(3452),
    [sym_this] = ACTIONS(3452),
    [anon_sym_discard] = ACTIONS(3452),
    [anon_sym_precise] = ACTIONS(3452),
    [anon_sym_shared] = ACTIONS(3452),
    [anon_sym_groupshared] = ACTIONS(3452),
    [anon_sym_uniform] = ACTIONS(3452),
    [anon_sym_row_major] = ACTIONS(3452),
    [anon_sym_column_major] = ACTIONS(3452),
    [anon_sym_globallycoherent] = ACTIONS(3452),
    [anon_sym_centroid] = ACTIONS(3452),
    [anon_sym_noperspective] = ACTIONS(3452),
    [anon_sym_nointerpolation] = ACTIONS(3452),
    [anon_sym_sample] = ACTIONS(3452),
    [anon_sym_linear] = ACTIONS(3452),
    [anon_sym_snorm] = ACTIONS(3452),
    [anon_sym_unorm] = ACTIONS(3452),
    [anon_sym_point] = ACTIONS(3452),
    [anon_sym_line] = ACTIONS(3452),
    [anon_sym_triangleadj] = ACTIONS(3452),
    [anon_sym_lineadj] = ACTIONS(3452),
    [anon_sym_triangle] = ACTIONS(3452),
    [anon_sym_cbuffer] = ACTIONS(3452),
    [anon_sym_interface] = ACTIONS(3452),
    [anon_sym_extension] = ACTIONS(3452),
  },
  [1407] = {
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(3450),
    [anon_sym_BANG] = ACTIONS(3450),
    [anon_sym_TILDE] = ACTIONS(3450),
    [anon_sym_DASH] = ACTIONS(3452),
    [anon_sym_PLUS] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_AMP] = ACTIONS(3450),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym___extension__] = ACTIONS(3452),
    [anon_sym_typedef] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_out] = ACTIONS(3452),
    [anon_sym_inout] = ACTIONS(3452),
    [anon_sym_virtual] = ACTIONS(3452),
    [anon_sym_extern] = ACTIONS(3452),
    [anon_sym___attribute__] = ACTIONS(3452),
    [anon_sym___attribute] = ACTIONS(3452),
    [anon_sym_COLON_COLON] = ACTIONS(3450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3450),
    [anon_sym___declspec] = ACTIONS(3452),
    [anon_sym_LBRACE] = ACTIONS(3450),
    [anon_sym_signed] = ACTIONS(3452),
    [anon_sym_unsigned] = ACTIONS(3452),
    [anon_sym_long] = ACTIONS(3452),
    [anon_sym_short] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3452),
    [anon_sym_static] = ACTIONS(3452),
    [anon_sym_register] = ACTIONS(3452),
    [anon_sym_inline] = ACTIONS(3452),
    [anon_sym___inline] = ACTIONS(3452),
    [anon_sym___inline__] = ACTIONS(3452),
    [anon_sym___forceinline] = ACTIONS(3452),
    [anon_sym_thread_local] = ACTIONS(3452),
    [anon_sym___thread] = ACTIONS(3452),
    [anon_sym_const] = ACTIONS(3452),
    [anon_sym_constexpr] = ACTIONS(3452),
    [anon_sym_volatile] = ACTIONS(3452),
    [anon_sym_restrict] = ACTIONS(3452),
    [anon_sym___restrict__] = ACTIONS(3452),
    [anon_sym__Atomic] = ACTIONS(3452),
    [anon_sym__Noreturn] = ACTIONS(3452),
    [anon_sym_noreturn] = ACTIONS(3452),
    [anon_sym__Nonnull] = ACTIONS(3452),
    [anon_sym_mutable] = ACTIONS(3452),
    [anon_sym_constinit] = ACTIONS(3452),
    [anon_sym_consteval] = ACTIONS(3452),
    [anon_sym_alignas] = ACTIONS(3452),
    [anon_sym__Alignas] = ACTIONS(3452),
    [sym_primitive_type] = ACTIONS(3452),
    [anon_sym_enum] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(3452),
    [anon_sym_union] = ACTIONS(3452),
    [anon_sym_if] = ACTIONS(3452),
    [anon_sym_else] = ACTIONS(3452),
    [anon_sym_switch] = ACTIONS(3452),
    [anon_sym_while] = ACTIONS(3452),
    [anon_sym_do] = ACTIONS(3452),
    [anon_sym_for] = ACTIONS(3452),
    [anon_sym_return] = ACTIONS(3452),
    [anon_sym_break] = ACTIONS(3452),
    [anon_sym_continue] = ACTIONS(3452),
    [anon_sym_goto] = ACTIONS(3452),
    [anon_sym___try] = ACTIONS(3452),
    [anon_sym___leave] = ACTIONS(3452),
    [anon_sym_not] = ACTIONS(3452),
    [anon_sym_compl] = ACTIONS(3452),
    [anon_sym_DASH_DASH] = ACTIONS(3450),
    [anon_sym_PLUS_PLUS] = ACTIONS(3450),
    [anon_sym_sizeof] = ACTIONS(3452),
    [anon_sym___alignof__] = ACTIONS(3452),
    [anon_sym___alignof] = ACTIONS(3452),
    [anon_sym__alignof] = ACTIONS(3452),
    [anon_sym_alignof] = ACTIONS(3452),
    [anon_sym__Alignof] = ACTIONS(3452),
    [anon_sym_offsetof] = ACTIONS(3452),
    [anon_sym__Generic] = ACTIONS(3452),
    [anon_sym_asm] = ACTIONS(3452),
    [anon_sym___asm__] = ACTIONS(3452),
    [anon_sym___asm] = ACTIONS(3452),
    [sym_number_literal] = ACTIONS(3450),
    [anon_sym_L_SQUOTE] = ACTIONS(3450),
    [anon_sym_u_SQUOTE] = ACTIONS(3450),
    [anon_sym_U_SQUOTE] = ACTIONS(3450),
    [anon_sym_u8_SQUOTE] = ACTIONS(3450),
    [anon_sym_SQUOTE] = ACTIONS(3450),
    [anon_sym_L_DQUOTE] = ACTIONS(3450),
    [anon_sym_u_DQUOTE] = ACTIONS(3450),
    [anon_sym_U_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8_DQUOTE] = ACTIONS(3450),
    [anon_sym_DQUOTE] = ACTIONS(3450),
    [sym_true] = ACTIONS(3452),
    [sym_false] = ACTIONS(3452),
    [anon_sym_NULL] = ACTIONS(3452),
    [anon_sym_nullptr] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3452),
    [anon_sym_let] = ACTIONS(3452),
    [anon_sym_This] = ACTIONS(3452),
    [anon_sym_decltype] = ACTIONS(3452),
    [anon_sym_typename] = ACTIONS(3452),
    [anon_sym_template] = ACTIONS(3452),
    [anon_sym_try] = ACTIONS(3452),
    [anon_sym_delete] = ACTIONS(3452),
    [anon_sym_throw] = ACTIONS(3452),
    [anon_sym_co_return] = ACTIONS(3452),
    [anon_sym_co_yield] = ACTIONS(3452),
    [anon_sym_R_DQUOTE] = ACTIONS(3450),
    [anon_sym_LR_DQUOTE] = ACTIONS(3450),
    [anon_sym_uR_DQUOTE] = ACTIONS(3450),
    [anon_sym_UR_DQUOTE] = ACTIONS(3450),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3450),
    [anon_sym_co_await] = ACTIONS(3452),
    [anon_sym_new] = ACTIONS(3452),
    [anon_sym_requires] = ACTIONS(3452),
    [sym_this] = ACTIONS(3452),
    [anon_sym_discard] = ACTIONS(3452),
    [anon_sym_precise] = ACTIONS(3452),
    [anon_sym_shared] = ACTIONS(3452),
    [anon_sym_groupshared] = ACTIONS(3452),
    [anon_sym_uniform] = ACTIONS(3452),
    [anon_sym_row_major] = ACTIONS(3452),
    [anon_sym_column_major] = ACTIONS(3452),
    [anon_sym_globallycoherent] = ACTIONS(3452),
    [anon_sym_centroid] = ACTIONS(3452),
    [anon_sym_noperspective] = ACTIONS(3452),
    [anon_sym_nointerpolation] = ACTIONS(3452),
    [anon_sym_sample] = ACTIONS(3452),
    [anon_sym_linear] = ACTIONS(3452),
    [anon_sym_snorm] = ACTIONS(3452),
    [anon_sym_unorm] = ACTIONS(3452),
    [anon_sym_point] = ACTIONS(3452),
    [anon_sym_line] = ACTIONS(3452),
    [anon_sym_triangleadj] = ACTIONS(3452),
    [anon_sym_lineadj] = ACTIONS(3452),
    [anon_sym_triangle] = ACTIONS(3452),
    [anon_sym_cbuffer] = ACTIONS(3452),
    [anon_sym_interface] = ACTIONS(3452),
    [anon_sym_extension] = ACTIONS(3452),
  },
  [1408] = {
    [sym_identifier] = ACTIONS(3597),
    [anon_sym_LPAREN2] = ACTIONS(3599),
    [anon_sym_BANG] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3599),
    [anon_sym_DASH] = ACTIONS(3597),
    [anon_sym_PLUS] = ACTIONS(3597),
    [anon_sym_STAR] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3599),
    [anon_sym_SEMI] = ACTIONS(3599),
    [anon_sym___extension__] = ACTIONS(3597),
    [anon_sym_typedef] = ACTIONS(3597),
    [anon_sym_in] = ACTIONS(3597),
    [anon_sym_out] = ACTIONS(3597),
    [anon_sym_inout] = ACTIONS(3597),
    [anon_sym_virtual] = ACTIONS(3597),
    [anon_sym_extern] = ACTIONS(3597),
    [anon_sym___attribute__] = ACTIONS(3597),
    [anon_sym___attribute] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3599),
    [anon_sym___declspec] = ACTIONS(3597),
    [anon_sym_LBRACE] = ACTIONS(3599),
    [anon_sym_signed] = ACTIONS(3597),
    [anon_sym_unsigned] = ACTIONS(3597),
    [anon_sym_long] = ACTIONS(3597),
    [anon_sym_short] = ACTIONS(3597),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_static] = ACTIONS(3597),
    [anon_sym_register] = ACTIONS(3597),
    [anon_sym_inline] = ACTIONS(3597),
    [anon_sym___inline] = ACTIONS(3597),
    [anon_sym___inline__] = ACTIONS(3597),
    [anon_sym___forceinline] = ACTIONS(3597),
    [anon_sym_thread_local] = ACTIONS(3597),
    [anon_sym___thread] = ACTIONS(3597),
    [anon_sym_const] = ACTIONS(3597),
    [anon_sym_constexpr] = ACTIONS(3597),
    [anon_sym_volatile] = ACTIONS(3597),
    [anon_sym_restrict] = ACTIONS(3597),
    [anon_sym___restrict__] = ACTIONS(3597),
    [anon_sym__Atomic] = ACTIONS(3597),
    [anon_sym__Noreturn] = ACTIONS(3597),
    [anon_sym_noreturn] = ACTIONS(3597),
    [anon_sym__Nonnull] = ACTIONS(3597),
    [anon_sym_mutable] = ACTIONS(3597),
    [anon_sym_constinit] = ACTIONS(3597),
    [anon_sym_consteval] = ACTIONS(3597),
    [anon_sym_alignas] = ACTIONS(3597),
    [anon_sym__Alignas] = ACTIONS(3597),
    [sym_primitive_type] = ACTIONS(3597),
    [anon_sym_enum] = ACTIONS(3597),
    [anon_sym_class] = ACTIONS(3597),
    [anon_sym_struct] = ACTIONS(3597),
    [anon_sym_union] = ACTIONS(3597),
    [anon_sym_if] = ACTIONS(3597),
    [anon_sym_else] = ACTIONS(3597),
    [anon_sym_switch] = ACTIONS(3597),
    [anon_sym_while] = ACTIONS(3597),
    [anon_sym_do] = ACTIONS(3597),
    [anon_sym_for] = ACTIONS(3597),
    [anon_sym_return] = ACTIONS(3597),
    [anon_sym_break] = ACTIONS(3597),
    [anon_sym_continue] = ACTIONS(3597),
    [anon_sym_goto] = ACTIONS(3597),
    [anon_sym___try] = ACTIONS(3597),
    [anon_sym___leave] = ACTIONS(3597),
    [anon_sym_not] = ACTIONS(3597),
    [anon_sym_compl] = ACTIONS(3597),
    [anon_sym_DASH_DASH] = ACTIONS(3599),
    [anon_sym_PLUS_PLUS] = ACTIONS(3599),
    [anon_sym_sizeof] = ACTIONS(3597),
    [anon_sym___alignof__] = ACTIONS(3597),
    [anon_sym___alignof] = ACTIONS(3597),
    [anon_sym__alignof] = ACTIONS(3597),
    [anon_sym_alignof] = ACTIONS(3597),
    [anon_sym__Alignof] = ACTIONS(3597),
    [anon_sym_offsetof] = ACTIONS(3597),
    [anon_sym__Generic] = ACTIONS(3597),
    [anon_sym_asm] = ACTIONS(3597),
    [anon_sym___asm__] = ACTIONS(3597),
    [anon_sym___asm] = ACTIONS(3597),
    [sym_number_literal] = ACTIONS(3599),
    [anon_sym_L_SQUOTE] = ACTIONS(3599),
    [anon_sym_u_SQUOTE] = ACTIONS(3599),
    [anon_sym_U_SQUOTE] = ACTIONS(3599),
    [anon_sym_u8_SQUOTE] = ACTIONS(3599),
    [anon_sym_SQUOTE] = ACTIONS(3599),
    [anon_sym_L_DQUOTE] = ACTIONS(3599),
    [anon_sym_u_DQUOTE] = ACTIONS(3599),
    [anon_sym_U_DQUOTE] = ACTIONS(3599),
    [anon_sym_u8_DQUOTE] = ACTIONS(3599),
    [anon_sym_DQUOTE] = ACTIONS(3599),
    [sym_true] = ACTIONS(3597),
    [sym_false] = ACTIONS(3597),
    [anon_sym_NULL] = ACTIONS(3597),
    [anon_sym_nullptr] = ACTIONS(3597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3597),
    [anon_sym_let] = ACTIONS(3597),
    [anon_sym_This] = ACTIONS(3597),
    [anon_sym_decltype] = ACTIONS(3597),
    [anon_sym_typename] = ACTIONS(3597),
    [anon_sym_template] = ACTIONS(3597),
    [anon_sym_try] = ACTIONS(3597),
    [anon_sym_delete] = ACTIONS(3597),
    [anon_sym_throw] = ACTIONS(3597),
    [anon_sym_co_return] = ACTIONS(3597),
    [anon_sym_co_yield] = ACTIONS(3597),
    [anon_sym_R_DQUOTE] = ACTIONS(3599),
    [anon_sym_LR_DQUOTE] = ACTIONS(3599),
    [anon_sym_uR_DQUOTE] = ACTIONS(3599),
    [anon_sym_UR_DQUOTE] = ACTIONS(3599),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3599),
    [anon_sym_co_await] = ACTIONS(3597),
    [anon_sym_new] = ACTIONS(3597),
    [anon_sym_requires] = ACTIONS(3597),
    [sym_this] = ACTIONS(3597),
    [anon_sym_discard] = ACTIONS(3597),
    [anon_sym_precise] = ACTIONS(3597),
    [anon_sym_shared] = ACTIONS(3597),
    [anon_sym_groupshared] = ACTIONS(3597),
    [anon_sym_uniform] = ACTIONS(3597),
    [anon_sym_row_major] = ACTIONS(3597),
    [anon_sym_column_major] = ACTIONS(3597),
    [anon_sym_globallycoherent] = ACTIONS(3597),
    [anon_sym_centroid] = ACTIONS(3597),
    [anon_sym_noperspective] = ACTIONS(3597),
    [anon_sym_nointerpolation] = ACTIONS(3597),
    [anon_sym_sample] = ACTIONS(3597),
    [anon_sym_linear] = ACTIONS(3597),
    [anon_sym_snorm] = ACTIONS(3597),
    [anon_sym_unorm] = ACTIONS(3597),
    [anon_sym_point] = ACTIONS(3597),
    [anon_sym_line] = ACTIONS(3597),
    [anon_sym_triangleadj] = ACTIONS(3597),
    [anon_sym_lineadj] = ACTIONS(3597),
    [anon_sym_triangle] = ACTIONS(3597),
    [anon_sym_cbuffer] = ACTIONS(3597),
    [anon_sym_interface] = ACTIONS(3597),
    [anon_sym_extension] = ACTIONS(3597),
  },
  [1409] = {
    [sym_identifier] = ACTIONS(3490),
    [anon_sym_LPAREN2] = ACTIONS(3492),
    [anon_sym_BANG] = ACTIONS(3492),
    [anon_sym_TILDE] = ACTIONS(3492),
    [anon_sym_DASH] = ACTIONS(3490),
    [anon_sym_PLUS] = ACTIONS(3490),
    [anon_sym_STAR] = ACTIONS(3492),
    [anon_sym_AMP] = ACTIONS(3492),
    [anon_sym_SEMI] = ACTIONS(3492),
    [anon_sym___extension__] = ACTIONS(3490),
    [anon_sym_typedef] = ACTIONS(3490),
    [anon_sym_in] = ACTIONS(3490),
    [anon_sym_out] = ACTIONS(3490),
    [anon_sym_inout] = ACTIONS(3490),
    [anon_sym_virtual] = ACTIONS(3490),
    [anon_sym_extern] = ACTIONS(3490),
    [anon_sym___attribute__] = ACTIONS(3490),
    [anon_sym___attribute] = ACTIONS(3490),
    [anon_sym_COLON_COLON] = ACTIONS(3492),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3492),
    [anon_sym___declspec] = ACTIONS(3490),
    [anon_sym_LBRACE] = ACTIONS(3492),
    [anon_sym_signed] = ACTIONS(3490),
    [anon_sym_unsigned] = ACTIONS(3490),
    [anon_sym_long] = ACTIONS(3490),
    [anon_sym_short] = ACTIONS(3490),
    [anon_sym_LBRACK] = ACTIONS(3490),
    [anon_sym_static] = ACTIONS(3490),
    [anon_sym_register] = ACTIONS(3490),
    [anon_sym_inline] = ACTIONS(3490),
    [anon_sym___inline] = ACTIONS(3490),
    [anon_sym___inline__] = ACTIONS(3490),
    [anon_sym___forceinline] = ACTIONS(3490),
    [anon_sym_thread_local] = ACTIONS(3490),
    [anon_sym___thread] = ACTIONS(3490),
    [anon_sym_const] = ACTIONS(3490),
    [anon_sym_constexpr] = ACTIONS(3490),
    [anon_sym_volatile] = ACTIONS(3490),
    [anon_sym_restrict] = ACTIONS(3490),
    [anon_sym___restrict__] = ACTIONS(3490),
    [anon_sym__Atomic] = ACTIONS(3490),
    [anon_sym__Noreturn] = ACTIONS(3490),
    [anon_sym_noreturn] = ACTIONS(3490),
    [anon_sym__Nonnull] = ACTIONS(3490),
    [anon_sym_mutable] = ACTIONS(3490),
    [anon_sym_constinit] = ACTIONS(3490),
    [anon_sym_consteval] = ACTIONS(3490),
    [anon_sym_alignas] = ACTIONS(3490),
    [anon_sym__Alignas] = ACTIONS(3490),
    [sym_primitive_type] = ACTIONS(3490),
    [anon_sym_enum] = ACTIONS(3490),
    [anon_sym_class] = ACTIONS(3490),
    [anon_sym_struct] = ACTIONS(3490),
    [anon_sym_union] = ACTIONS(3490),
    [anon_sym_if] = ACTIONS(3490),
    [anon_sym_else] = ACTIONS(3490),
    [anon_sym_switch] = ACTIONS(3490),
    [anon_sym_while] = ACTIONS(3490),
    [anon_sym_do] = ACTIONS(3490),
    [anon_sym_for] = ACTIONS(3490),
    [anon_sym_return] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3490),
    [anon_sym_continue] = ACTIONS(3490),
    [anon_sym_goto] = ACTIONS(3490),
    [anon_sym___try] = ACTIONS(3490),
    [anon_sym___leave] = ACTIONS(3490),
    [anon_sym_not] = ACTIONS(3490),
    [anon_sym_compl] = ACTIONS(3490),
    [anon_sym_DASH_DASH] = ACTIONS(3492),
    [anon_sym_PLUS_PLUS] = ACTIONS(3492),
    [anon_sym_sizeof] = ACTIONS(3490),
    [anon_sym___alignof__] = ACTIONS(3490),
    [anon_sym___alignof] = ACTIONS(3490),
    [anon_sym__alignof] = ACTIONS(3490),
    [anon_sym_alignof] = ACTIONS(3490),
    [anon_sym__Alignof] = ACTIONS(3490),
    [anon_sym_offsetof] = ACTIONS(3490),
    [anon_sym__Generic] = ACTIONS(3490),
    [anon_sym_asm] = ACTIONS(3490),
    [anon_sym___asm__] = ACTIONS(3490),
    [anon_sym___asm] = ACTIONS(3490),
    [sym_number_literal] = ACTIONS(3492),
    [anon_sym_L_SQUOTE] = ACTIONS(3492),
    [anon_sym_u_SQUOTE] = ACTIONS(3492),
    [anon_sym_U_SQUOTE] = ACTIONS(3492),
    [anon_sym_u8_SQUOTE] = ACTIONS(3492),
    [anon_sym_SQUOTE] = ACTIONS(3492),
    [anon_sym_L_DQUOTE] = ACTIONS(3492),
    [anon_sym_u_DQUOTE] = ACTIONS(3492),
    [anon_sym_U_DQUOTE] = ACTIONS(3492),
    [anon_sym_u8_DQUOTE] = ACTIONS(3492),
    [anon_sym_DQUOTE] = ACTIONS(3492),
    [sym_true] = ACTIONS(3490),
    [sym_false] = ACTIONS(3490),
    [anon_sym_NULL] = ACTIONS(3490),
    [anon_sym_nullptr] = ACTIONS(3490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3490),
    [anon_sym_let] = ACTIONS(3490),
    [anon_sym_This] = ACTIONS(3490),
    [anon_sym_decltype] = ACTIONS(3490),
    [anon_sym_typename] = ACTIONS(3490),
    [anon_sym_template] = ACTIONS(3490),
    [anon_sym_try] = ACTIONS(3490),
    [anon_sym_delete] = ACTIONS(3490),
    [anon_sym_throw] = ACTIONS(3490),
    [anon_sym_co_return] = ACTIONS(3490),
    [anon_sym_co_yield] = ACTIONS(3490),
    [anon_sym_R_DQUOTE] = ACTIONS(3492),
    [anon_sym_LR_DQUOTE] = ACTIONS(3492),
    [anon_sym_uR_DQUOTE] = ACTIONS(3492),
    [anon_sym_UR_DQUOTE] = ACTIONS(3492),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3492),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3490),
    [anon_sym_requires] = ACTIONS(3490),
    [sym_this] = ACTIONS(3490),
    [anon_sym_discard] = ACTIONS(3490),
    [anon_sym_precise] = ACTIONS(3490),
    [anon_sym_shared] = ACTIONS(3490),
    [anon_sym_groupshared] = ACTIONS(3490),
    [anon_sym_uniform] = ACTIONS(3490),
    [anon_sym_row_major] = ACTIONS(3490),
    [anon_sym_column_major] = ACTIONS(3490),
    [anon_sym_globallycoherent] = ACTIONS(3490),
    [anon_sym_centroid] = ACTIONS(3490),
    [anon_sym_noperspective] = ACTIONS(3490),
    [anon_sym_nointerpolation] = ACTIONS(3490),
    [anon_sym_sample] = ACTIONS(3490),
    [anon_sym_linear] = ACTIONS(3490),
    [anon_sym_snorm] = ACTIONS(3490),
    [anon_sym_unorm] = ACTIONS(3490),
    [anon_sym_point] = ACTIONS(3490),
    [anon_sym_line] = ACTIONS(3490),
    [anon_sym_triangleadj] = ACTIONS(3490),
    [anon_sym_lineadj] = ACTIONS(3490),
    [anon_sym_triangle] = ACTIONS(3490),
    [anon_sym_cbuffer] = ACTIONS(3490),
    [anon_sym_interface] = ACTIONS(3490),
    [anon_sym_extension] = ACTIONS(3490),
  },
  [1410] = {
    [sym_identifier] = ACTIONS(2550),
    [anon_sym_LPAREN2] = ACTIONS(2548),
    [anon_sym_BANG] = ACTIONS(2548),
    [anon_sym_TILDE] = ACTIONS(2548),
    [anon_sym_DASH] = ACTIONS(2550),
    [anon_sym_PLUS] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(2548),
    [anon_sym_AMP] = ACTIONS(2548),
    [anon_sym_SEMI] = ACTIONS(2548),
    [anon_sym___extension__] = ACTIONS(2550),
    [anon_sym_typedef] = ACTIONS(2550),
    [anon_sym_in] = ACTIONS(2550),
    [anon_sym_out] = ACTIONS(2550),
    [anon_sym_inout] = ACTIONS(2550),
    [anon_sym_virtual] = ACTIONS(2550),
    [anon_sym_extern] = ACTIONS(2550),
    [anon_sym___attribute__] = ACTIONS(2550),
    [anon_sym___attribute] = ACTIONS(2550),
    [anon_sym_COLON_COLON] = ACTIONS(2548),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2548),
    [anon_sym___declspec] = ACTIONS(2550),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_signed] = ACTIONS(2550),
    [anon_sym_unsigned] = ACTIONS(2550),
    [anon_sym_long] = ACTIONS(2550),
    [anon_sym_short] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_static] = ACTIONS(2550),
    [anon_sym_register] = ACTIONS(2550),
    [anon_sym_inline] = ACTIONS(2550),
    [anon_sym___inline] = ACTIONS(2550),
    [anon_sym___inline__] = ACTIONS(2550),
    [anon_sym___forceinline] = ACTIONS(2550),
    [anon_sym_thread_local] = ACTIONS(2550),
    [anon_sym___thread] = ACTIONS(2550),
    [anon_sym_const] = ACTIONS(2550),
    [anon_sym_constexpr] = ACTIONS(2550),
    [anon_sym_volatile] = ACTIONS(2550),
    [anon_sym_restrict] = ACTIONS(2550),
    [anon_sym___restrict__] = ACTIONS(2550),
    [anon_sym__Atomic] = ACTIONS(2550),
    [anon_sym__Noreturn] = ACTIONS(2550),
    [anon_sym_noreturn] = ACTIONS(2550),
    [anon_sym__Nonnull] = ACTIONS(2550),
    [anon_sym_mutable] = ACTIONS(2550),
    [anon_sym_constinit] = ACTIONS(2550),
    [anon_sym_consteval] = ACTIONS(2550),
    [anon_sym_alignas] = ACTIONS(2550),
    [anon_sym__Alignas] = ACTIONS(2550),
    [sym_primitive_type] = ACTIONS(2550),
    [anon_sym_enum] = ACTIONS(2550),
    [anon_sym_class] = ACTIONS(2550),
    [anon_sym_struct] = ACTIONS(2550),
    [anon_sym_union] = ACTIONS(2550),
    [anon_sym_if] = ACTIONS(2550),
    [anon_sym_else] = ACTIONS(2550),
    [anon_sym_switch] = ACTIONS(2550),
    [anon_sym_while] = ACTIONS(2550),
    [anon_sym_do] = ACTIONS(2550),
    [anon_sym_for] = ACTIONS(2550),
    [anon_sym_return] = ACTIONS(2550),
    [anon_sym_break] = ACTIONS(2550),
    [anon_sym_continue] = ACTIONS(2550),
    [anon_sym_goto] = ACTIONS(2550),
    [anon_sym___try] = ACTIONS(2550),
    [anon_sym___leave] = ACTIONS(2550),
    [anon_sym_not] = ACTIONS(2550),
    [anon_sym_compl] = ACTIONS(2550),
    [anon_sym_DASH_DASH] = ACTIONS(2548),
    [anon_sym_PLUS_PLUS] = ACTIONS(2548),
    [anon_sym_sizeof] = ACTIONS(2550),
    [anon_sym___alignof__] = ACTIONS(2550),
    [anon_sym___alignof] = ACTIONS(2550),
    [anon_sym__alignof] = ACTIONS(2550),
    [anon_sym_alignof] = ACTIONS(2550),
    [anon_sym__Alignof] = ACTIONS(2550),
    [anon_sym_offsetof] = ACTIONS(2550),
    [anon_sym__Generic] = ACTIONS(2550),
    [anon_sym_asm] = ACTIONS(2550),
    [anon_sym___asm__] = ACTIONS(2550),
    [anon_sym___asm] = ACTIONS(2550),
    [sym_number_literal] = ACTIONS(2548),
    [anon_sym_L_SQUOTE] = ACTIONS(2548),
    [anon_sym_u_SQUOTE] = ACTIONS(2548),
    [anon_sym_U_SQUOTE] = ACTIONS(2548),
    [anon_sym_u8_SQUOTE] = ACTIONS(2548),
    [anon_sym_SQUOTE] = ACTIONS(2548),
    [anon_sym_L_DQUOTE] = ACTIONS(2548),
    [anon_sym_u_DQUOTE] = ACTIONS(2548),
    [anon_sym_U_DQUOTE] = ACTIONS(2548),
    [anon_sym_u8_DQUOTE] = ACTIONS(2548),
    [anon_sym_DQUOTE] = ACTIONS(2548),
    [sym_true] = ACTIONS(2550),
    [sym_false] = ACTIONS(2550),
    [anon_sym_NULL] = ACTIONS(2550),
    [anon_sym_nullptr] = ACTIONS(2550),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(2550),
    [anon_sym_This] = ACTIONS(2550),
    [anon_sym_decltype] = ACTIONS(2550),
    [anon_sym_typename] = ACTIONS(2550),
    [anon_sym_template] = ACTIONS(2550),
    [anon_sym_try] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(2550),
    [anon_sym_throw] = ACTIONS(2550),
    [anon_sym_co_return] = ACTIONS(2550),
    [anon_sym_co_yield] = ACTIONS(2550),
    [anon_sym_R_DQUOTE] = ACTIONS(2548),
    [anon_sym_LR_DQUOTE] = ACTIONS(2548),
    [anon_sym_uR_DQUOTE] = ACTIONS(2548),
    [anon_sym_UR_DQUOTE] = ACTIONS(2548),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2548),
    [anon_sym_co_await] = ACTIONS(2550),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2550),
    [sym_this] = ACTIONS(2550),
    [anon_sym_discard] = ACTIONS(2550),
    [anon_sym_precise] = ACTIONS(2550),
    [anon_sym_shared] = ACTIONS(2550),
    [anon_sym_groupshared] = ACTIONS(2550),
    [anon_sym_uniform] = ACTIONS(2550),
    [anon_sym_row_major] = ACTIONS(2550),
    [anon_sym_column_major] = ACTIONS(2550),
    [anon_sym_globallycoherent] = ACTIONS(2550),
    [anon_sym_centroid] = ACTIONS(2550),
    [anon_sym_noperspective] = ACTIONS(2550),
    [anon_sym_nointerpolation] = ACTIONS(2550),
    [anon_sym_sample] = ACTIONS(2550),
    [anon_sym_linear] = ACTIONS(2550),
    [anon_sym_snorm] = ACTIONS(2550),
    [anon_sym_unorm] = ACTIONS(2550),
    [anon_sym_point] = ACTIONS(2550),
    [anon_sym_line] = ACTIONS(2550),
    [anon_sym_triangleadj] = ACTIONS(2550),
    [anon_sym_lineadj] = ACTIONS(2550),
    [anon_sym_triangle] = ACTIONS(2550),
    [anon_sym_cbuffer] = ACTIONS(2550),
    [anon_sym_interface] = ACTIONS(2550),
    [anon_sym_extension] = ACTIONS(2550),
  },
  [1411] = {
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_LPAREN2] = ACTIONS(2552),
    [anon_sym_BANG] = ACTIONS(2552),
    [anon_sym_TILDE] = ACTIONS(2552),
    [anon_sym_DASH] = ACTIONS(2554),
    [anon_sym_PLUS] = ACTIONS(2554),
    [anon_sym_STAR] = ACTIONS(2552),
    [anon_sym_AMP] = ACTIONS(2552),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym___extension__] = ACTIONS(2554),
    [anon_sym_typedef] = ACTIONS(2554),
    [anon_sym_in] = ACTIONS(2554),
    [anon_sym_out] = ACTIONS(2554),
    [anon_sym_inout] = ACTIONS(2554),
    [anon_sym_virtual] = ACTIONS(2554),
    [anon_sym_extern] = ACTIONS(2554),
    [anon_sym___attribute__] = ACTIONS(2554),
    [anon_sym___attribute] = ACTIONS(2554),
    [anon_sym_COLON_COLON] = ACTIONS(2552),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2552),
    [anon_sym___declspec] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(2552),
    [anon_sym_signed] = ACTIONS(2554),
    [anon_sym_unsigned] = ACTIONS(2554),
    [anon_sym_long] = ACTIONS(2554),
    [anon_sym_short] = ACTIONS(2554),
    [anon_sym_LBRACK] = ACTIONS(2554),
    [anon_sym_static] = ACTIONS(2554),
    [anon_sym_register] = ACTIONS(2554),
    [anon_sym_inline] = ACTIONS(2554),
    [anon_sym___inline] = ACTIONS(2554),
    [anon_sym___inline__] = ACTIONS(2554),
    [anon_sym___forceinline] = ACTIONS(2554),
    [anon_sym_thread_local] = ACTIONS(2554),
    [anon_sym___thread] = ACTIONS(2554),
    [anon_sym_const] = ACTIONS(2554),
    [anon_sym_constexpr] = ACTIONS(2554),
    [anon_sym_volatile] = ACTIONS(2554),
    [anon_sym_restrict] = ACTIONS(2554),
    [anon_sym___restrict__] = ACTIONS(2554),
    [anon_sym__Atomic] = ACTIONS(2554),
    [anon_sym__Noreturn] = ACTIONS(2554),
    [anon_sym_noreturn] = ACTIONS(2554),
    [anon_sym__Nonnull] = ACTIONS(2554),
    [anon_sym_mutable] = ACTIONS(2554),
    [anon_sym_constinit] = ACTIONS(2554),
    [anon_sym_consteval] = ACTIONS(2554),
    [anon_sym_alignas] = ACTIONS(2554),
    [anon_sym__Alignas] = ACTIONS(2554),
    [sym_primitive_type] = ACTIONS(2554),
    [anon_sym_enum] = ACTIONS(2554),
    [anon_sym_class] = ACTIONS(2554),
    [anon_sym_struct] = ACTIONS(2554),
    [anon_sym_union] = ACTIONS(2554),
    [anon_sym_if] = ACTIONS(2554),
    [anon_sym_else] = ACTIONS(2554),
    [anon_sym_switch] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2554),
    [anon_sym_do] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2554),
    [anon_sym_return] = ACTIONS(2554),
    [anon_sym_break] = ACTIONS(2554),
    [anon_sym_continue] = ACTIONS(2554),
    [anon_sym_goto] = ACTIONS(2554),
    [anon_sym___try] = ACTIONS(2554),
    [anon_sym___leave] = ACTIONS(2554),
    [anon_sym_not] = ACTIONS(2554),
    [anon_sym_compl] = ACTIONS(2554),
    [anon_sym_DASH_DASH] = ACTIONS(2552),
    [anon_sym_PLUS_PLUS] = ACTIONS(2552),
    [anon_sym_sizeof] = ACTIONS(2554),
    [anon_sym___alignof__] = ACTIONS(2554),
    [anon_sym___alignof] = ACTIONS(2554),
    [anon_sym__alignof] = ACTIONS(2554),
    [anon_sym_alignof] = ACTIONS(2554),
    [anon_sym__Alignof] = ACTIONS(2554),
    [anon_sym_offsetof] = ACTIONS(2554),
    [anon_sym__Generic] = ACTIONS(2554),
    [anon_sym_asm] = ACTIONS(2554),
    [anon_sym___asm__] = ACTIONS(2554),
    [anon_sym___asm] = ACTIONS(2554),
    [sym_number_literal] = ACTIONS(2552),
    [anon_sym_L_SQUOTE] = ACTIONS(2552),
    [anon_sym_u_SQUOTE] = ACTIONS(2552),
    [anon_sym_U_SQUOTE] = ACTIONS(2552),
    [anon_sym_u8_SQUOTE] = ACTIONS(2552),
    [anon_sym_SQUOTE] = ACTIONS(2552),
    [anon_sym_L_DQUOTE] = ACTIONS(2552),
    [anon_sym_u_DQUOTE] = ACTIONS(2552),
    [anon_sym_U_DQUOTE] = ACTIONS(2552),
    [anon_sym_u8_DQUOTE] = ACTIONS(2552),
    [anon_sym_DQUOTE] = ACTIONS(2552),
    [sym_true] = ACTIONS(2554),
    [sym_false] = ACTIONS(2554),
    [anon_sym_NULL] = ACTIONS(2554),
    [anon_sym_nullptr] = ACTIONS(2554),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2554),
    [anon_sym_let] = ACTIONS(2554),
    [anon_sym_This] = ACTIONS(2554),
    [anon_sym_decltype] = ACTIONS(2554),
    [anon_sym_typename] = ACTIONS(2554),
    [anon_sym_template] = ACTIONS(2554),
    [anon_sym_try] = ACTIONS(2554),
    [anon_sym_delete] = ACTIONS(2554),
    [anon_sym_throw] = ACTIONS(2554),
    [anon_sym_co_return] = ACTIONS(2554),
    [anon_sym_co_yield] = ACTIONS(2554),
    [anon_sym_R_DQUOTE] = ACTIONS(2552),
    [anon_sym_LR_DQUOTE] = ACTIONS(2552),
    [anon_sym_uR_DQUOTE] = ACTIONS(2552),
    [anon_sym_UR_DQUOTE] = ACTIONS(2552),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2552),
    [anon_sym_co_await] = ACTIONS(2554),
    [anon_sym_new] = ACTIONS(2554),
    [anon_sym_requires] = ACTIONS(2554),
    [sym_this] = ACTIONS(2554),
    [anon_sym_discard] = ACTIONS(2554),
    [anon_sym_precise] = ACTIONS(2554),
    [anon_sym_shared] = ACTIONS(2554),
    [anon_sym_groupshared] = ACTIONS(2554),
    [anon_sym_uniform] = ACTIONS(2554),
    [anon_sym_row_major] = ACTIONS(2554),
    [anon_sym_column_major] = ACTIONS(2554),
    [anon_sym_globallycoherent] = ACTIONS(2554),
    [anon_sym_centroid] = ACTIONS(2554),
    [anon_sym_noperspective] = ACTIONS(2554),
    [anon_sym_nointerpolation] = ACTIONS(2554),
    [anon_sym_sample] = ACTIONS(2554),
    [anon_sym_linear] = ACTIONS(2554),
    [anon_sym_snorm] = ACTIONS(2554),
    [anon_sym_unorm] = ACTIONS(2554),
    [anon_sym_point] = ACTIONS(2554),
    [anon_sym_line] = ACTIONS(2554),
    [anon_sym_triangleadj] = ACTIONS(2554),
    [anon_sym_lineadj] = ACTIONS(2554),
    [anon_sym_triangle] = ACTIONS(2554),
    [anon_sym_cbuffer] = ACTIONS(2554),
    [anon_sym_interface] = ACTIONS(2554),
    [anon_sym_extension] = ACTIONS(2554),
  },
  [1412] = {
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3560),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym___extension__] = ACTIONS(3562),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_in] = ACTIONS(3562),
    [anon_sym_out] = ACTIONS(3562),
    [anon_sym_inout] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym___attribute__] = ACTIONS(3562),
    [anon_sym___attribute] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3560),
    [anon_sym___declspec] = ACTIONS(3562),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_signed] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym___inline] = ACTIONS(3562),
    [anon_sym___inline__] = ACTIONS(3562),
    [anon_sym___forceinline] = ACTIONS(3562),
    [anon_sym_thread_local] = ACTIONS(3562),
    [anon_sym___thread] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_constexpr] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym___restrict__] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym__Noreturn] = ACTIONS(3562),
    [anon_sym_noreturn] = ACTIONS(3562),
    [anon_sym__Nonnull] = ACTIONS(3562),
    [anon_sym_mutable] = ACTIONS(3562),
    [anon_sym_constinit] = ACTIONS(3562),
    [anon_sym_consteval] = ACTIONS(3562),
    [anon_sym_alignas] = ACTIONS(3562),
    [anon_sym__Alignas] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_else] = ACTIONS(3562),
    [anon_sym_switch] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_goto] = ACTIONS(3562),
    [anon_sym___try] = ACTIONS(3562),
    [anon_sym___leave] = ACTIONS(3562),
    [anon_sym_not] = ACTIONS(3562),
    [anon_sym_compl] = ACTIONS(3562),
    [anon_sym_DASH_DASH] = ACTIONS(3560),
    [anon_sym_PLUS_PLUS] = ACTIONS(3560),
    [anon_sym_sizeof] = ACTIONS(3562),
    [anon_sym___alignof__] = ACTIONS(3562),
    [anon_sym___alignof] = ACTIONS(3562),
    [anon_sym__alignof] = ACTIONS(3562),
    [anon_sym_alignof] = ACTIONS(3562),
    [anon_sym__Alignof] = ACTIONS(3562),
    [anon_sym_offsetof] = ACTIONS(3562),
    [anon_sym__Generic] = ACTIONS(3562),
    [anon_sym_asm] = ACTIONS(3562),
    [anon_sym___asm__] = ACTIONS(3562),
    [anon_sym___asm] = ACTIONS(3562),
    [sym_number_literal] = ACTIONS(3560),
    [anon_sym_L_SQUOTE] = ACTIONS(3560),
    [anon_sym_u_SQUOTE] = ACTIONS(3560),
    [anon_sym_U_SQUOTE] = ACTIONS(3560),
    [anon_sym_u8_SQUOTE] = ACTIONS(3560),
    [anon_sym_SQUOTE] = ACTIONS(3560),
    [anon_sym_L_DQUOTE] = ACTIONS(3560),
    [anon_sym_u_DQUOTE] = ACTIONS(3560),
    [anon_sym_U_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE] = ACTIONS(3560),
    [sym_true] = ACTIONS(3562),
    [sym_false] = ACTIONS(3562),
    [anon_sym_NULL] = ACTIONS(3562),
    [anon_sym_nullptr] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_This] = ACTIONS(3562),
    [anon_sym_decltype] = ACTIONS(3562),
    [anon_sym_typename] = ACTIONS(3562),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_delete] = ACTIONS(3562),
    [anon_sym_throw] = ACTIONS(3562),
    [anon_sym_co_return] = ACTIONS(3562),
    [anon_sym_co_yield] = ACTIONS(3562),
    [anon_sym_R_DQUOTE] = ACTIONS(3560),
    [anon_sym_LR_DQUOTE] = ACTIONS(3560),
    [anon_sym_uR_DQUOTE] = ACTIONS(3560),
    [anon_sym_UR_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3560),
    [anon_sym_co_await] = ACTIONS(3562),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_requires] = ACTIONS(3562),
    [sym_this] = ACTIONS(3562),
    [anon_sym_discard] = ACTIONS(3562),
    [anon_sym_precise] = ACTIONS(3562),
    [anon_sym_shared] = ACTIONS(3562),
    [anon_sym_groupshared] = ACTIONS(3562),
    [anon_sym_uniform] = ACTIONS(3562),
    [anon_sym_row_major] = ACTIONS(3562),
    [anon_sym_column_major] = ACTIONS(3562),
    [anon_sym_globallycoherent] = ACTIONS(3562),
    [anon_sym_centroid] = ACTIONS(3562),
    [anon_sym_noperspective] = ACTIONS(3562),
    [anon_sym_nointerpolation] = ACTIONS(3562),
    [anon_sym_sample] = ACTIONS(3562),
    [anon_sym_linear] = ACTIONS(3562),
    [anon_sym_snorm] = ACTIONS(3562),
    [anon_sym_unorm] = ACTIONS(3562),
    [anon_sym_point] = ACTIONS(3562),
    [anon_sym_line] = ACTIONS(3562),
    [anon_sym_triangleadj] = ACTIONS(3562),
    [anon_sym_lineadj] = ACTIONS(3562),
    [anon_sym_triangle] = ACTIONS(3562),
    [anon_sym_cbuffer] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_extension] = ACTIONS(3562),
  },
  [1413] = {
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3560),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym___extension__] = ACTIONS(3562),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_in] = ACTIONS(3562),
    [anon_sym_out] = ACTIONS(3562),
    [anon_sym_inout] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym___attribute__] = ACTIONS(3562),
    [anon_sym___attribute] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3560),
    [anon_sym___declspec] = ACTIONS(3562),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_signed] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym___inline] = ACTIONS(3562),
    [anon_sym___inline__] = ACTIONS(3562),
    [anon_sym___forceinline] = ACTIONS(3562),
    [anon_sym_thread_local] = ACTIONS(3562),
    [anon_sym___thread] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_constexpr] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym___restrict__] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym__Noreturn] = ACTIONS(3562),
    [anon_sym_noreturn] = ACTIONS(3562),
    [anon_sym__Nonnull] = ACTIONS(3562),
    [anon_sym_mutable] = ACTIONS(3562),
    [anon_sym_constinit] = ACTIONS(3562),
    [anon_sym_consteval] = ACTIONS(3562),
    [anon_sym_alignas] = ACTIONS(3562),
    [anon_sym__Alignas] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_else] = ACTIONS(3562),
    [anon_sym_switch] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_do] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_goto] = ACTIONS(3562),
    [anon_sym___try] = ACTIONS(3562),
    [anon_sym___leave] = ACTIONS(3562),
    [anon_sym_not] = ACTIONS(3562),
    [anon_sym_compl] = ACTIONS(3562),
    [anon_sym_DASH_DASH] = ACTIONS(3560),
    [anon_sym_PLUS_PLUS] = ACTIONS(3560),
    [anon_sym_sizeof] = ACTIONS(3562),
    [anon_sym___alignof__] = ACTIONS(3562),
    [anon_sym___alignof] = ACTIONS(3562),
    [anon_sym__alignof] = ACTIONS(3562),
    [anon_sym_alignof] = ACTIONS(3562),
    [anon_sym__Alignof] = ACTIONS(3562),
    [anon_sym_offsetof] = ACTIONS(3562),
    [anon_sym__Generic] = ACTIONS(3562),
    [anon_sym_asm] = ACTIONS(3562),
    [anon_sym___asm__] = ACTIONS(3562),
    [anon_sym___asm] = ACTIONS(3562),
    [sym_number_literal] = ACTIONS(3560),
    [anon_sym_L_SQUOTE] = ACTIONS(3560),
    [anon_sym_u_SQUOTE] = ACTIONS(3560),
    [anon_sym_U_SQUOTE] = ACTIONS(3560),
    [anon_sym_u8_SQUOTE] = ACTIONS(3560),
    [anon_sym_SQUOTE] = ACTIONS(3560),
    [anon_sym_L_DQUOTE] = ACTIONS(3560),
    [anon_sym_u_DQUOTE] = ACTIONS(3560),
    [anon_sym_U_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8_DQUOTE] = ACTIONS(3560),
    [anon_sym_DQUOTE] = ACTIONS(3560),
    [sym_true] = ACTIONS(3562),
    [sym_false] = ACTIONS(3562),
    [anon_sym_NULL] = ACTIONS(3562),
    [anon_sym_nullptr] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_This] = ACTIONS(3562),
    [anon_sym_decltype] = ACTIONS(3562),
    [anon_sym_typename] = ACTIONS(3562),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3562),
    [anon_sym_delete] = ACTIONS(3562),
    [anon_sym_throw] = ACTIONS(3562),
    [anon_sym_co_return] = ACTIONS(3562),
    [anon_sym_co_yield] = ACTIONS(3562),
    [anon_sym_R_DQUOTE] = ACTIONS(3560),
    [anon_sym_LR_DQUOTE] = ACTIONS(3560),
    [anon_sym_uR_DQUOTE] = ACTIONS(3560),
    [anon_sym_UR_DQUOTE] = ACTIONS(3560),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3560),
    [anon_sym_co_await] = ACTIONS(3562),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_requires] = ACTIONS(3562),
    [sym_this] = ACTIONS(3562),
    [anon_sym_discard] = ACTIONS(3562),
    [anon_sym_precise] = ACTIONS(3562),
    [anon_sym_shared] = ACTIONS(3562),
    [anon_sym_groupshared] = ACTIONS(3562),
    [anon_sym_uniform] = ACTIONS(3562),
    [anon_sym_row_major] = ACTIONS(3562),
    [anon_sym_column_major] = ACTIONS(3562),
    [anon_sym_globallycoherent] = ACTIONS(3562),
    [anon_sym_centroid] = ACTIONS(3562),
    [anon_sym_noperspective] = ACTIONS(3562),
    [anon_sym_nointerpolation] = ACTIONS(3562),
    [anon_sym_sample] = ACTIONS(3562),
    [anon_sym_linear] = ACTIONS(3562),
    [anon_sym_snorm] = ACTIONS(3562),
    [anon_sym_unorm] = ACTIONS(3562),
    [anon_sym_point] = ACTIONS(3562),
    [anon_sym_line] = ACTIONS(3562),
    [anon_sym_triangleadj] = ACTIONS(3562),
    [anon_sym_lineadj] = ACTIONS(3562),
    [anon_sym_triangle] = ACTIONS(3562),
    [anon_sym_cbuffer] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_extension] = ACTIONS(3562),
  },
  [1414] = {
    [sym_identifier] = ACTIONS(4716),
    [anon_sym_LPAREN2] = ACTIONS(4718),
    [anon_sym_BANG] = ACTIONS(4718),
    [anon_sym_TILDE] = ACTIONS(4718),
    [anon_sym_DASH] = ACTIONS(4716),
    [anon_sym_PLUS] = ACTIONS(4716),
    [anon_sym_STAR] = ACTIONS(4718),
    [anon_sym_AMP] = ACTIONS(4718),
    [anon_sym_SEMI] = ACTIONS(4718),
    [anon_sym___extension__] = ACTIONS(4716),
    [anon_sym_in] = ACTIONS(4716),
    [anon_sym_out] = ACTIONS(4716),
    [anon_sym_inout] = ACTIONS(4716),
    [anon_sym_virtual] = ACTIONS(4716),
    [anon_sym_extern] = ACTIONS(4716),
    [anon_sym___attribute__] = ACTIONS(4716),
    [anon_sym___attribute] = ACTIONS(4716),
    [anon_sym_COLON_COLON] = ACTIONS(4718),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4718),
    [anon_sym___declspec] = ACTIONS(4716),
    [anon_sym_LBRACE] = ACTIONS(4718),
    [anon_sym_signed] = ACTIONS(4716),
    [anon_sym_unsigned] = ACTIONS(4716),
    [anon_sym_long] = ACTIONS(4716),
    [anon_sym_short] = ACTIONS(4716),
    [anon_sym_LBRACK] = ACTIONS(4716),
    [anon_sym_static] = ACTIONS(4716),
    [anon_sym_register] = ACTIONS(4716),
    [anon_sym_inline] = ACTIONS(4716),
    [anon_sym___inline] = ACTIONS(4716),
    [anon_sym___inline__] = ACTIONS(4716),
    [anon_sym___forceinline] = ACTIONS(4716),
    [anon_sym_thread_local] = ACTIONS(4716),
    [anon_sym___thread] = ACTIONS(4716),
    [anon_sym_const] = ACTIONS(4716),
    [anon_sym_constexpr] = ACTIONS(4716),
    [anon_sym_volatile] = ACTIONS(4716),
    [anon_sym_restrict] = ACTIONS(4716),
    [anon_sym___restrict__] = ACTIONS(4716),
    [anon_sym__Atomic] = ACTIONS(4716),
    [anon_sym__Noreturn] = ACTIONS(4716),
    [anon_sym_noreturn] = ACTIONS(4716),
    [anon_sym__Nonnull] = ACTIONS(4716),
    [anon_sym_mutable] = ACTIONS(4716),
    [anon_sym_constinit] = ACTIONS(4716),
    [anon_sym_consteval] = ACTIONS(4716),
    [anon_sym_alignas] = ACTIONS(4716),
    [anon_sym__Alignas] = ACTIONS(4716),
    [sym_primitive_type] = ACTIONS(4716),
    [anon_sym_enum] = ACTIONS(4716),
    [anon_sym_class] = ACTIONS(4716),
    [anon_sym_struct] = ACTIONS(4716),
    [anon_sym_union] = ACTIONS(4716),
    [anon_sym_if] = ACTIONS(4716),
    [anon_sym_switch] = ACTIONS(4716),
    [anon_sym_case] = ACTIONS(4716),
    [anon_sym_default] = ACTIONS(4716),
    [anon_sym_while] = ACTIONS(4716),
    [anon_sym_do] = ACTIONS(4716),
    [anon_sym_for] = ACTIONS(4716),
    [anon_sym_return] = ACTIONS(4716),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_continue] = ACTIONS(4716),
    [anon_sym_goto] = ACTIONS(4716),
    [anon_sym___try] = ACTIONS(4716),
    [anon_sym___leave] = ACTIONS(4716),
    [anon_sym_not] = ACTIONS(4716),
    [anon_sym_compl] = ACTIONS(4716),
    [anon_sym_DASH_DASH] = ACTIONS(4718),
    [anon_sym_PLUS_PLUS] = ACTIONS(4718),
    [anon_sym_sizeof] = ACTIONS(4716),
    [anon_sym___alignof__] = ACTIONS(4716),
    [anon_sym___alignof] = ACTIONS(4716),
    [anon_sym__alignof] = ACTIONS(4716),
    [anon_sym_alignof] = ACTIONS(4716),
    [anon_sym__Alignof] = ACTIONS(4716),
    [anon_sym_offsetof] = ACTIONS(4716),
    [anon_sym__Generic] = ACTIONS(4716),
    [anon_sym_asm] = ACTIONS(4716),
    [anon_sym___asm__] = ACTIONS(4716),
    [anon_sym___asm] = ACTIONS(4716),
    [sym_number_literal] = ACTIONS(4718),
    [anon_sym_L_SQUOTE] = ACTIONS(4718),
    [anon_sym_u_SQUOTE] = ACTIONS(4718),
    [anon_sym_U_SQUOTE] = ACTIONS(4718),
    [anon_sym_u8_SQUOTE] = ACTIONS(4718),
    [anon_sym_SQUOTE] = ACTIONS(4718),
    [anon_sym_L_DQUOTE] = ACTIONS(4718),
    [anon_sym_u_DQUOTE] = ACTIONS(4718),
    [anon_sym_U_DQUOTE] = ACTIONS(4718),
    [anon_sym_u8_DQUOTE] = ACTIONS(4718),
    [anon_sym_DQUOTE] = ACTIONS(4718),
    [sym_true] = ACTIONS(4716),
    [sym_false] = ACTIONS(4716),
    [anon_sym_NULL] = ACTIONS(4716),
    [anon_sym_nullptr] = ACTIONS(4716),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4716),
    [anon_sym_let] = ACTIONS(4716),
    [anon_sym_This] = ACTIONS(4716),
    [anon_sym_decltype] = ACTIONS(4716),
    [anon_sym_typename] = ACTIONS(4716),
    [anon_sym_template] = ACTIONS(4716),
    [anon_sym_try] = ACTIONS(4716),
    [anon_sym_delete] = ACTIONS(4716),
    [anon_sym_throw] = ACTIONS(4716),
    [anon_sym_co_return] = ACTIONS(4716),
    [anon_sym_co_yield] = ACTIONS(4716),
    [anon_sym_R_DQUOTE] = ACTIONS(4718),
    [anon_sym_LR_DQUOTE] = ACTIONS(4718),
    [anon_sym_uR_DQUOTE] = ACTIONS(4718),
    [anon_sym_UR_DQUOTE] = ACTIONS(4718),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4718),
    [anon_sym_co_await] = ACTIONS(4716),
    [anon_sym_new] = ACTIONS(4716),
    [anon_sym_requires] = ACTIONS(4716),
    [sym_this] = ACTIONS(4716),
    [anon_sym_discard] = ACTIONS(4716),
    [anon_sym_precise] = ACTIONS(4716),
    [anon_sym_shared] = ACTIONS(4716),
    [anon_sym_groupshared] = ACTIONS(4716),
    [anon_sym_uniform] = ACTIONS(4716),
    [anon_sym_row_major] = ACTIONS(4716),
    [anon_sym_column_major] = ACTIONS(4716),
    [anon_sym_globallycoherent] = ACTIONS(4716),
    [anon_sym_centroid] = ACTIONS(4716),
    [anon_sym_noperspective] = ACTIONS(4716),
    [anon_sym_nointerpolation] = ACTIONS(4716),
    [anon_sym_sample] = ACTIONS(4716),
    [anon_sym_linear] = ACTIONS(4716),
    [anon_sym_snorm] = ACTIONS(4716),
    [anon_sym_unorm] = ACTIONS(4716),
    [anon_sym_point] = ACTIONS(4716),
    [anon_sym_line] = ACTIONS(4716),
    [anon_sym_triangleadj] = ACTIONS(4716),
    [anon_sym_lineadj] = ACTIONS(4716),
    [anon_sym_triangle] = ACTIONS(4716),
    [anon_sym_cbuffer] = ACTIONS(4716),
    [anon_sym_interface] = ACTIONS(4716),
    [anon_sym_extension] = ACTIONS(4716),
  },
  [1415] = {
    [sym_identifier] = ACTIONS(3635),
    [anon_sym_LPAREN2] = ACTIONS(3633),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_TILDE] = ACTIONS(3633),
    [anon_sym_DASH] = ACTIONS(3635),
    [anon_sym_PLUS] = ACTIONS(3635),
    [anon_sym_STAR] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_SEMI] = ACTIONS(3633),
    [anon_sym___extension__] = ACTIONS(3635),
    [anon_sym_typedef] = ACTIONS(3635),
    [anon_sym_in] = ACTIONS(3635),
    [anon_sym_out] = ACTIONS(3635),
    [anon_sym_inout] = ACTIONS(3635),
    [anon_sym_virtual] = ACTIONS(3635),
    [anon_sym_extern] = ACTIONS(3635),
    [anon_sym___attribute__] = ACTIONS(3635),
    [anon_sym___attribute] = ACTIONS(3635),
    [anon_sym_COLON_COLON] = ACTIONS(3633),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3633),
    [anon_sym___declspec] = ACTIONS(3635),
    [anon_sym_LBRACE] = ACTIONS(3633),
    [anon_sym_signed] = ACTIONS(3635),
    [anon_sym_unsigned] = ACTIONS(3635),
    [anon_sym_long] = ACTIONS(3635),
    [anon_sym_short] = ACTIONS(3635),
    [anon_sym_LBRACK] = ACTIONS(3635),
    [anon_sym_static] = ACTIONS(3635),
    [anon_sym_register] = ACTIONS(3635),
    [anon_sym_inline] = ACTIONS(3635),
    [anon_sym___inline] = ACTIONS(3635),
    [anon_sym___inline__] = ACTIONS(3635),
    [anon_sym___forceinline] = ACTIONS(3635),
    [anon_sym_thread_local] = ACTIONS(3635),
    [anon_sym___thread] = ACTIONS(3635),
    [anon_sym_const] = ACTIONS(3635),
    [anon_sym_constexpr] = ACTIONS(3635),
    [anon_sym_volatile] = ACTIONS(3635),
    [anon_sym_restrict] = ACTIONS(3635),
    [anon_sym___restrict__] = ACTIONS(3635),
    [anon_sym__Atomic] = ACTIONS(3635),
    [anon_sym__Noreturn] = ACTIONS(3635),
    [anon_sym_noreturn] = ACTIONS(3635),
    [anon_sym__Nonnull] = ACTIONS(3635),
    [anon_sym_mutable] = ACTIONS(3635),
    [anon_sym_constinit] = ACTIONS(3635),
    [anon_sym_consteval] = ACTIONS(3635),
    [anon_sym_alignas] = ACTIONS(3635),
    [anon_sym__Alignas] = ACTIONS(3635),
    [sym_primitive_type] = ACTIONS(3635),
    [anon_sym_enum] = ACTIONS(3635),
    [anon_sym_class] = ACTIONS(3635),
    [anon_sym_struct] = ACTIONS(3635),
    [anon_sym_union] = ACTIONS(3635),
    [anon_sym_if] = ACTIONS(3635),
    [anon_sym_else] = ACTIONS(3635),
    [anon_sym_switch] = ACTIONS(3635),
    [anon_sym_while] = ACTIONS(3635),
    [anon_sym_do] = ACTIONS(3635),
    [anon_sym_for] = ACTIONS(3635),
    [anon_sym_return] = ACTIONS(3635),
    [anon_sym_break] = ACTIONS(3635),
    [anon_sym_continue] = ACTIONS(3635),
    [anon_sym_goto] = ACTIONS(3635),
    [anon_sym___try] = ACTIONS(3635),
    [anon_sym___leave] = ACTIONS(3635),
    [anon_sym_not] = ACTIONS(3635),
    [anon_sym_compl] = ACTIONS(3635),
    [anon_sym_DASH_DASH] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3633),
    [anon_sym_sizeof] = ACTIONS(3635),
    [anon_sym___alignof__] = ACTIONS(3635),
    [anon_sym___alignof] = ACTIONS(3635),
    [anon_sym__alignof] = ACTIONS(3635),
    [anon_sym_alignof] = ACTIONS(3635),
    [anon_sym__Alignof] = ACTIONS(3635),
    [anon_sym_offsetof] = ACTIONS(3635),
    [anon_sym__Generic] = ACTIONS(3635),
    [anon_sym_asm] = ACTIONS(3635),
    [anon_sym___asm__] = ACTIONS(3635),
    [anon_sym___asm] = ACTIONS(3635),
    [sym_number_literal] = ACTIONS(3633),
    [anon_sym_L_SQUOTE] = ACTIONS(3633),
    [anon_sym_u_SQUOTE] = ACTIONS(3633),
    [anon_sym_U_SQUOTE] = ACTIONS(3633),
    [anon_sym_u8_SQUOTE] = ACTIONS(3633),
    [anon_sym_SQUOTE] = ACTIONS(3633),
    [anon_sym_L_DQUOTE] = ACTIONS(3633),
    [anon_sym_u_DQUOTE] = ACTIONS(3633),
    [anon_sym_U_DQUOTE] = ACTIONS(3633),
    [anon_sym_u8_DQUOTE] = ACTIONS(3633),
    [anon_sym_DQUOTE] = ACTIONS(3633),
    [sym_true] = ACTIONS(3635),
    [sym_false] = ACTIONS(3635),
    [anon_sym_NULL] = ACTIONS(3635),
    [anon_sym_nullptr] = ACTIONS(3635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3635),
    [anon_sym_let] = ACTIONS(3635),
    [anon_sym_This] = ACTIONS(3635),
    [anon_sym_decltype] = ACTIONS(3635),
    [anon_sym_typename] = ACTIONS(3635),
    [anon_sym_template] = ACTIONS(3635),
    [anon_sym_try] = ACTIONS(3635),
    [anon_sym_delete] = ACTIONS(3635),
    [anon_sym_throw] = ACTIONS(3635),
    [anon_sym_co_return] = ACTIONS(3635),
    [anon_sym_co_yield] = ACTIONS(3635),
    [anon_sym_R_DQUOTE] = ACTIONS(3633),
    [anon_sym_LR_DQUOTE] = ACTIONS(3633),
    [anon_sym_uR_DQUOTE] = ACTIONS(3633),
    [anon_sym_UR_DQUOTE] = ACTIONS(3633),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3633),
    [anon_sym_co_await] = ACTIONS(3635),
    [anon_sym_new] = ACTIONS(3635),
    [anon_sym_requires] = ACTIONS(3635),
    [sym_this] = ACTIONS(3635),
    [anon_sym_discard] = ACTIONS(3635),
    [anon_sym_precise] = ACTIONS(3635),
    [anon_sym_shared] = ACTIONS(3635),
    [anon_sym_groupshared] = ACTIONS(3635),
    [anon_sym_uniform] = ACTIONS(3635),
    [anon_sym_row_major] = ACTIONS(3635),
    [anon_sym_column_major] = ACTIONS(3635),
    [anon_sym_globallycoherent] = ACTIONS(3635),
    [anon_sym_centroid] = ACTIONS(3635),
    [anon_sym_noperspective] = ACTIONS(3635),
    [anon_sym_nointerpolation] = ACTIONS(3635),
    [anon_sym_sample] = ACTIONS(3635),
    [anon_sym_linear] = ACTIONS(3635),
    [anon_sym_snorm] = ACTIONS(3635),
    [anon_sym_unorm] = ACTIONS(3635),
    [anon_sym_point] = ACTIONS(3635),
    [anon_sym_line] = ACTIONS(3635),
    [anon_sym_triangleadj] = ACTIONS(3635),
    [anon_sym_lineadj] = ACTIONS(3635),
    [anon_sym_triangle] = ACTIONS(3635),
    [anon_sym_cbuffer] = ACTIONS(3635),
    [anon_sym_interface] = ACTIONS(3635),
    [anon_sym_extension] = ACTIONS(3635),
  },
  [1416] = {
    [sym_identifier] = ACTIONS(3641),
    [anon_sym_LPAREN2] = ACTIONS(3643),
    [anon_sym_BANG] = ACTIONS(3643),
    [anon_sym_TILDE] = ACTIONS(3643),
    [anon_sym_DASH] = ACTIONS(3641),
    [anon_sym_PLUS] = ACTIONS(3641),
    [anon_sym_STAR] = ACTIONS(3643),
    [anon_sym_AMP] = ACTIONS(3643),
    [anon_sym_SEMI] = ACTIONS(3643),
    [anon_sym___extension__] = ACTIONS(3641),
    [anon_sym_typedef] = ACTIONS(3641),
    [anon_sym_in] = ACTIONS(3641),
    [anon_sym_out] = ACTIONS(3641),
    [anon_sym_inout] = ACTIONS(3641),
    [anon_sym_virtual] = ACTIONS(3641),
    [anon_sym_extern] = ACTIONS(3641),
    [anon_sym___attribute__] = ACTIONS(3641),
    [anon_sym___attribute] = ACTIONS(3641),
    [anon_sym_COLON_COLON] = ACTIONS(3643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3643),
    [anon_sym___declspec] = ACTIONS(3641),
    [anon_sym_LBRACE] = ACTIONS(3643),
    [anon_sym_signed] = ACTIONS(3641),
    [anon_sym_unsigned] = ACTIONS(3641),
    [anon_sym_long] = ACTIONS(3641),
    [anon_sym_short] = ACTIONS(3641),
    [anon_sym_LBRACK] = ACTIONS(3641),
    [anon_sym_static] = ACTIONS(3641),
    [anon_sym_register] = ACTIONS(3641),
    [anon_sym_inline] = ACTIONS(3641),
    [anon_sym___inline] = ACTIONS(3641),
    [anon_sym___inline__] = ACTIONS(3641),
    [anon_sym___forceinline] = ACTIONS(3641),
    [anon_sym_thread_local] = ACTIONS(3641),
    [anon_sym___thread] = ACTIONS(3641),
    [anon_sym_const] = ACTIONS(3641),
    [anon_sym_constexpr] = ACTIONS(3641),
    [anon_sym_volatile] = ACTIONS(3641),
    [anon_sym_restrict] = ACTIONS(3641),
    [anon_sym___restrict__] = ACTIONS(3641),
    [anon_sym__Atomic] = ACTIONS(3641),
    [anon_sym__Noreturn] = ACTIONS(3641),
    [anon_sym_noreturn] = ACTIONS(3641),
    [anon_sym__Nonnull] = ACTIONS(3641),
    [anon_sym_mutable] = ACTIONS(3641),
    [anon_sym_constinit] = ACTIONS(3641),
    [anon_sym_consteval] = ACTIONS(3641),
    [anon_sym_alignas] = ACTIONS(3641),
    [anon_sym__Alignas] = ACTIONS(3641),
    [sym_primitive_type] = ACTIONS(3641),
    [anon_sym_enum] = ACTIONS(3641),
    [anon_sym_class] = ACTIONS(3641),
    [anon_sym_struct] = ACTIONS(3641),
    [anon_sym_union] = ACTIONS(3641),
    [anon_sym_if] = ACTIONS(3641),
    [anon_sym_else] = ACTIONS(3641),
    [anon_sym_switch] = ACTIONS(3641),
    [anon_sym_while] = ACTIONS(3641),
    [anon_sym_do] = ACTIONS(3641),
    [anon_sym_for] = ACTIONS(3641),
    [anon_sym_return] = ACTIONS(3641),
    [anon_sym_break] = ACTIONS(3641),
    [anon_sym_continue] = ACTIONS(3641),
    [anon_sym_goto] = ACTIONS(3641),
    [anon_sym___try] = ACTIONS(3641),
    [anon_sym___leave] = ACTIONS(3641),
    [anon_sym_not] = ACTIONS(3641),
    [anon_sym_compl] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3643),
    [anon_sym_PLUS_PLUS] = ACTIONS(3643),
    [anon_sym_sizeof] = ACTIONS(3641),
    [anon_sym___alignof__] = ACTIONS(3641),
    [anon_sym___alignof] = ACTIONS(3641),
    [anon_sym__alignof] = ACTIONS(3641),
    [anon_sym_alignof] = ACTIONS(3641),
    [anon_sym__Alignof] = ACTIONS(3641),
    [anon_sym_offsetof] = ACTIONS(3641),
    [anon_sym__Generic] = ACTIONS(3641),
    [anon_sym_asm] = ACTIONS(3641),
    [anon_sym___asm__] = ACTIONS(3641),
    [anon_sym___asm] = ACTIONS(3641),
    [sym_number_literal] = ACTIONS(3643),
    [anon_sym_L_SQUOTE] = ACTIONS(3643),
    [anon_sym_u_SQUOTE] = ACTIONS(3643),
    [anon_sym_U_SQUOTE] = ACTIONS(3643),
    [anon_sym_u8_SQUOTE] = ACTIONS(3643),
    [anon_sym_SQUOTE] = ACTIONS(3643),
    [anon_sym_L_DQUOTE] = ACTIONS(3643),
    [anon_sym_u_DQUOTE] = ACTIONS(3643),
    [anon_sym_U_DQUOTE] = ACTIONS(3643),
    [anon_sym_u8_DQUOTE] = ACTIONS(3643),
    [anon_sym_DQUOTE] = ACTIONS(3643),
    [sym_true] = ACTIONS(3641),
    [sym_false] = ACTIONS(3641),
    [anon_sym_NULL] = ACTIONS(3641),
    [anon_sym_nullptr] = ACTIONS(3641),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3641),
    [anon_sym_let] = ACTIONS(3641),
    [anon_sym_This] = ACTIONS(3641),
    [anon_sym_decltype] = ACTIONS(3641),
    [anon_sym_typename] = ACTIONS(3641),
    [anon_sym_template] = ACTIONS(3641),
    [anon_sym_try] = ACTIONS(3641),
    [anon_sym_delete] = ACTIONS(3641),
    [anon_sym_throw] = ACTIONS(3641),
    [anon_sym_co_return] = ACTIONS(3641),
    [anon_sym_co_yield] = ACTIONS(3641),
    [anon_sym_R_DQUOTE] = ACTIONS(3643),
    [anon_sym_LR_DQUOTE] = ACTIONS(3643),
    [anon_sym_uR_DQUOTE] = ACTIONS(3643),
    [anon_sym_UR_DQUOTE] = ACTIONS(3643),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3643),
    [anon_sym_co_await] = ACTIONS(3641),
    [anon_sym_new] = ACTIONS(3641),
    [anon_sym_requires] = ACTIONS(3641),
    [sym_this] = ACTIONS(3641),
    [anon_sym_discard] = ACTIONS(3641),
    [anon_sym_precise] = ACTIONS(3641),
    [anon_sym_shared] = ACTIONS(3641),
    [anon_sym_groupshared] = ACTIONS(3641),
    [anon_sym_uniform] = ACTIONS(3641),
    [anon_sym_row_major] = ACTIONS(3641),
    [anon_sym_column_major] = ACTIONS(3641),
    [anon_sym_globallycoherent] = ACTIONS(3641),
    [anon_sym_centroid] = ACTIONS(3641),
    [anon_sym_noperspective] = ACTIONS(3641),
    [anon_sym_nointerpolation] = ACTIONS(3641),
    [anon_sym_sample] = ACTIONS(3641),
    [anon_sym_linear] = ACTIONS(3641),
    [anon_sym_snorm] = ACTIONS(3641),
    [anon_sym_unorm] = ACTIONS(3641),
    [anon_sym_point] = ACTIONS(3641),
    [anon_sym_line] = ACTIONS(3641),
    [anon_sym_triangleadj] = ACTIONS(3641),
    [anon_sym_lineadj] = ACTIONS(3641),
    [anon_sym_triangle] = ACTIONS(3641),
    [anon_sym_cbuffer] = ACTIONS(3641),
    [anon_sym_interface] = ACTIONS(3641),
    [anon_sym_extension] = ACTIONS(3641),
  },
  [1417] = {
    [sym__declaration_modifiers] = STATE(2667),
    [sym__declaration_specifiers] = STATE(4972),
    [sym_attribute_specifier] = STATE(2667),
    [sym_attribute_declaration] = STATE(2667),
    [sym_ms_declspec_modifier] = STATE(2667),
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_call_modifier] = STATE(6229),
    [sym__declarator] = STATE(8849),
    [sym__abstract_declarator] = STATE(9311),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_abstract_parenthesized_declarator] = STATE(7454),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_abstract_pointer_declarator] = STATE(7454),
    [sym_function_declarator] = STATE(8054),
    [sym_abstract_function_declarator] = STATE(7454),
    [sym_array_declarator] = STATE(8054),
    [sym_abstract_array_declarator] = STATE(7454),
    [sym_storage_class_specifier] = STATE(2667),
    [sym_type_qualifier] = STATE(2667),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2793),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_parameter_list] = STATE(3873),
    [sym_parameter_declaration] = STATE(10006),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_optional_parameter_declaration] = STATE(10006),
    [sym_variadic_parameter_declaration] = STATE(10006),
    [sym_reference_declarator] = STATE(8054),
    [sym_abstract_reference_declarator] = STATE(7454),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym__function_declarator_seq] = STATE(7543),
    [sym_template_type] = STATE(2842),
    [sym_template_function] = STATE(8054),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7241),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2667),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2667),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5340),
    [anon_sym_RPAREN] = ACTIONS(5342),
    [anon_sym_LPAREN2] = ACTIONS(5344),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(5346),
    [anon_sym_AMP_AMP] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(2348),
    [anon_sym_out] = ACTIONS(2348),
    [anon_sym_inout] = ACTIONS(2348),
    [anon_sym_virtual] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5352),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(2817),
    [anon_sym___clrcall] = ACTIONS(2817),
    [anon_sym___stdcall] = ACTIONS(2817),
    [anon_sym___fastcall] = ACTIONS(2817),
    [anon_sym___thiscall] = ACTIONS(2817),
    [anon_sym___vectorcall] = ACTIONS(2817),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(5354),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(2861),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_extension] = ACTIONS(2398),
  },
  [1418] = {
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_unaligned_ptr_modifier] = STATE(5091),
    [sym_ms_pointer_modifier] = STATE(3975),
    [sym__declarator] = STATE(8468),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8054),
    [sym_array_declarator] = STATE(8054),
    [sym_type_qualifier] = STATE(5040),
    [sym_alignas_qualifier] = STATE(5539),
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4316),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7351),
    [sym_qualified_identifier] = STATE(4317),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(3402),
    [aux_sym__type_definition_type_repeat1] = STATE(5040),
    [aux_sym_pointer_declarator_repeat1] = STATE(3975),
    [sym_identifier] = ACTIONS(5356),
    [anon_sym_LPAREN2] = ACTIONS(5358),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5360),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(5362),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(5364),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(5364),
    [sym_ms_signed_ptr_modifier] = ACTIONS(5364),
    [anon_sym__unaligned] = ACTIONS(5366),
    [anon_sym___unaligned] = ACTIONS(5366),
    [anon_sym_LBRACK] = ACTIONS(2821),
    [anon_sym_const] = ACTIONS(5368),
    [anon_sym_constexpr] = ACTIONS(5368),
    [anon_sym_volatile] = ACTIONS(5368),
    [anon_sym_restrict] = ACTIONS(5368),
    [anon_sym___restrict__] = ACTIONS(5368),
    [anon_sym__Atomic] = ACTIONS(5368),
    [anon_sym__Noreturn] = ACTIONS(5368),
    [anon_sym_noreturn] = ACTIONS(5368),
    [anon_sym__Nonnull] = ACTIONS(5368),
    [anon_sym_mutable] = ACTIONS(5368),
    [anon_sym_constinit] = ACTIONS(5368),
    [anon_sym_consteval] = ACTIONS(5368),
    [anon_sym_alignas] = ACTIONS(5370),
    [anon_sym__Alignas] = ACTIONS(5370),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(2861),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1419] = {
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_unaligned_ptr_modifier] = STATE(5091),
    [sym_ms_pointer_modifier] = STATE(3975),
    [sym__declarator] = STATE(8468),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8054),
    [sym_array_declarator] = STATE(8054),
    [sym_type_qualifier] = STATE(5040),
    [sym_alignas_qualifier] = STATE(5539),
    [sym_expression] = STATE(4246),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4356),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7263),
    [sym_qualified_identifier] = STATE(4377),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4519),
    [aux_sym__type_definition_type_repeat1] = STATE(5040),
    [aux_sym_pointer_declarator_repeat1] = STATE(3975),
    [sym_identifier] = ACTIONS(5374),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2811),
    [anon_sym___extension__] = ACTIONS(5376),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(5364),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(5364),
    [sym_ms_signed_ptr_modifier] = ACTIONS(5364),
    [anon_sym__unaligned] = ACTIONS(5366),
    [anon_sym___unaligned] = ACTIONS(5366),
    [anon_sym_LBRACK] = ACTIONS(2821),
    [anon_sym_const] = ACTIONS(5368),
    [anon_sym_constexpr] = ACTIONS(5368),
    [anon_sym_volatile] = ACTIONS(5368),
    [anon_sym_restrict] = ACTIONS(5368),
    [anon_sym___restrict__] = ACTIONS(5368),
    [anon_sym__Atomic] = ACTIONS(5368),
    [anon_sym__Noreturn] = ACTIONS(5368),
    [anon_sym_noreturn] = ACTIONS(5368),
    [anon_sym__Nonnull] = ACTIONS(5368),
    [anon_sym_mutable] = ACTIONS(5368),
    [anon_sym_constinit] = ACTIONS(5368),
    [anon_sym_consteval] = ACTIONS(5368),
    [anon_sym_alignas] = ACTIONS(5370),
    [anon_sym__Alignas] = ACTIONS(5370),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(2861),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1420] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(1652),
    [sym_raw_string_literal] = STATE(3527),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2764),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2176),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_RBRACE] = ACTIONS(2170),
    [anon_sym_signed] = ACTIONS(5332),
    [anon_sym_unsigned] = ACTIONS(5332),
    [anon_sym_long] = ACTIONS(5332),
    [anon_sym_short] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2207),
    [anon_sym_SLASH_EQ] = ACTIONS(2207),
    [anon_sym_PERCENT_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_GT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_EQ] = ACTIONS(2207),
    [anon_sym_CARET_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_EQ] = ACTIONS(2207),
    [anon_sym_and_eq] = ACTIONS(2205),
    [anon_sym_or_eq] = ACTIONS(2205),
    [anon_sym_xor_eq] = ACTIONS(2205),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_decltype] = ACTIONS(2168),
    [anon_sym_template] = ACTIONS(2168),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
  },
  [1421] = {
    [sym_string_literal] = STATE(3337),
    [sym_template_argument_list] = STATE(1532),
    [sym_raw_string_literal] = STATE(3337),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2764),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2183),
    [anon_sym_COMMA] = ACTIONS(2183),
    [anon_sym_RPAREN] = ACTIONS(2183),
    [anon_sym_LPAREN2] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(5378),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(2168),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2176),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_signed] = ACTIONS(5332),
    [anon_sym_unsigned] = ACTIONS(5332),
    [anon_sym_long] = ACTIONS(5332),
    [anon_sym_short] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_EQ] = ACTIONS(2178),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2170),
    [anon_sym_SLASH_EQ] = ACTIONS(2170),
    [anon_sym_PERCENT_EQ] = ACTIONS(2170),
    [anon_sym_PLUS_EQ] = ACTIONS(2170),
    [anon_sym_DASH_EQ] = ACTIONS(2170),
    [anon_sym_LT_LT_EQ] = ACTIONS(2170),
    [anon_sym_GT_GT_EQ] = ACTIONS(2170),
    [anon_sym_AMP_EQ] = ACTIONS(2170),
    [anon_sym_CARET_EQ] = ACTIONS(2170),
    [anon_sym_PIPE_EQ] = ACTIONS(2170),
    [anon_sym_and_eq] = ACTIONS(5381),
    [anon_sym_or_eq] = ACTIONS(5381),
    [anon_sym_xor_eq] = ACTIONS(5381),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2181),
    [anon_sym_L_DQUOTE] = ACTIONS(5383),
    [anon_sym_u_DQUOTE] = ACTIONS(5383),
    [anon_sym_U_DQUOTE] = ACTIONS(5383),
    [anon_sym_u8_DQUOTE] = ACTIONS(5383),
    [anon_sym_DQUOTE] = ACTIONS(5383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_decltype] = ACTIONS(2168),
    [anon_sym_template] = ACTIONS(2168),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_R_DQUOTE] = ACTIONS(5385),
    [anon_sym_LR_DQUOTE] = ACTIONS(5385),
    [anon_sym_uR_DQUOTE] = ACTIONS(5385),
    [anon_sym_UR_DQUOTE] = ACTIONS(5385),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5385),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2170),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
  },
  [1422] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(1652),
    [sym_raw_string_literal] = STATE(3527),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2764),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_RPAREN] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2176),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_signed] = ACTIONS(5332),
    [anon_sym_unsigned] = ACTIONS(5332),
    [anon_sym_long] = ACTIONS(5332),
    [anon_sym_short] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2207),
    [anon_sym_SLASH_EQ] = ACTIONS(2207),
    [anon_sym_PERCENT_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_GT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_EQ] = ACTIONS(2207),
    [anon_sym_CARET_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_EQ] = ACTIONS(2207),
    [anon_sym_and_eq] = ACTIONS(2205),
    [anon_sym_or_eq] = ACTIONS(2205),
    [anon_sym_xor_eq] = ACTIONS(2205),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_decltype] = ACTIONS(2168),
    [anon_sym_template] = ACTIONS(2168),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
  },
  [1423] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(1652),
    [sym_raw_string_literal] = STATE(3527),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2764),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(5334),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2176),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_signed] = ACTIONS(5332),
    [anon_sym_unsigned] = ACTIONS(5332),
    [anon_sym_long] = ACTIONS(5332),
    [anon_sym_short] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2207),
    [anon_sym_SLASH_EQ] = ACTIONS(2207),
    [anon_sym_PERCENT_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_GT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_EQ] = ACTIONS(2207),
    [anon_sym_CARET_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_EQ] = ACTIONS(2207),
    [anon_sym_and_eq] = ACTIONS(2205),
    [anon_sym_or_eq] = ACTIONS(2205),
    [anon_sym_xor_eq] = ACTIONS(2205),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_decltype] = ACTIONS(2168),
    [anon_sym_template] = ACTIONS(2168),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
  },
  [1424] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(1652),
    [sym_raw_string_literal] = STATE(3527),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2764),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(5336),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2176),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_signed] = ACTIONS(5332),
    [anon_sym_unsigned] = ACTIONS(5332),
    [anon_sym_long] = ACTIONS(5332),
    [anon_sym_short] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2207),
    [anon_sym_SLASH_EQ] = ACTIONS(2207),
    [anon_sym_PERCENT_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_GT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_EQ] = ACTIONS(2207),
    [anon_sym_CARET_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_EQ] = ACTIONS(2207),
    [anon_sym_and_eq] = ACTIONS(2205),
    [anon_sym_or_eq] = ACTIONS(2205),
    [anon_sym_xor_eq] = ACTIONS(2205),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_decltype] = ACTIONS(2168),
    [anon_sym_template] = ACTIONS(2168),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
  },
  [1425] = {
    [sym_expression] = STATE(4811),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_initializer_list] = STATE(4889),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(4952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4954),
    [anon_sym_COMMA] = ACTIONS(4954),
    [aux_sym_preproc_if_token2] = ACTIONS(4954),
    [aux_sym_preproc_else_token1] = ACTIONS(4954),
    [aux_sym_preproc_elif_token1] = ACTIONS(4952),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4954),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4954),
    [anon_sym_LPAREN2] = ACTIONS(4954),
    [anon_sym_BANG] = ACTIONS(5387),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(4952),
    [anon_sym_PLUS] = ACTIONS(4952),
    [anon_sym_STAR] = ACTIONS(4954),
    [anon_sym_SLASH] = ACTIONS(4952),
    [anon_sym_PERCENT] = ACTIONS(4954),
    [anon_sym_PIPE_PIPE] = ACTIONS(4954),
    [anon_sym_AMP_AMP] = ACTIONS(4954),
    [anon_sym_PIPE] = ACTIONS(4952),
    [anon_sym_CARET] = ACTIONS(4954),
    [anon_sym_AMP] = ACTIONS(4952),
    [anon_sym_EQ_EQ] = ACTIONS(4954),
    [anon_sym_BANG_EQ] = ACTIONS(4954),
    [anon_sym_GT] = ACTIONS(4952),
    [anon_sym_GT_EQ] = ACTIONS(4954),
    [anon_sym_LT_EQ] = ACTIONS(4952),
    [anon_sym_LT] = ACTIONS(4952),
    [anon_sym_LT_LT] = ACTIONS(4954),
    [anon_sym_GT_GT] = ACTIONS(4954),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4954),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_QMARK] = ACTIONS(4954),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_LT_EQ_GT] = ACTIONS(4954),
    [anon_sym_or] = ACTIONS(4952),
    [anon_sym_and] = ACTIONS(4952),
    [anon_sym_bitor] = ACTIONS(4952),
    [anon_sym_xor] = ACTIONS(4952),
    [anon_sym_bitand] = ACTIONS(4952),
    [anon_sym_not_eq] = ACTIONS(4952),
    [anon_sym_is] = ACTIONS(4952),
    [anon_sym_as] = ACTIONS(4952),
    [anon_sym_DASH_DASH] = ACTIONS(4954),
    [anon_sym_PLUS_PLUS] = ACTIONS(4954),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(4952),
    [anon_sym_DOT_STAR] = ACTIONS(4954),
    [anon_sym_DASH_GT] = ACTIONS(4954),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [1426] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(1652),
    [sym_raw_string_literal] = STATE(3527),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2764),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(5411),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2176),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_signed] = ACTIONS(5332),
    [anon_sym_unsigned] = ACTIONS(5332),
    [anon_sym_long] = ACTIONS(5332),
    [anon_sym_short] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2207),
    [anon_sym_SLASH_EQ] = ACTIONS(2207),
    [anon_sym_PERCENT_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_GT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_EQ] = ACTIONS(2207),
    [anon_sym_CARET_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_EQ] = ACTIONS(2207),
    [anon_sym_and_eq] = ACTIONS(2205),
    [anon_sym_or_eq] = ACTIONS(2205),
    [anon_sym_xor_eq] = ACTIONS(2205),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_decltype] = ACTIONS(2168),
    [anon_sym_template] = ACTIONS(2168),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
  },
  [1427] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(1652),
    [sym_raw_string_literal] = STATE(3527),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2764),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(5413),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2176),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_signed] = ACTIONS(5332),
    [anon_sym_unsigned] = ACTIONS(5332),
    [anon_sym_long] = ACTIONS(5332),
    [anon_sym_short] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2207),
    [anon_sym_SLASH_EQ] = ACTIONS(2207),
    [anon_sym_PERCENT_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_GT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_EQ] = ACTIONS(2207),
    [anon_sym_CARET_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_EQ] = ACTIONS(2207),
    [anon_sym_and_eq] = ACTIONS(2205),
    [anon_sym_or_eq] = ACTIONS(2205),
    [anon_sym_xor_eq] = ACTIONS(2205),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_decltype] = ACTIONS(2168),
    [anon_sym_template] = ACTIONS(2168),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
  },
  [1428] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(1652),
    [sym_raw_string_literal] = STATE(3527),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2764),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(2216),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2176),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_signed] = ACTIONS(5332),
    [anon_sym_unsigned] = ACTIONS(5332),
    [anon_sym_long] = ACTIONS(5332),
    [anon_sym_short] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2207),
    [anon_sym_SLASH_EQ] = ACTIONS(2207),
    [anon_sym_PERCENT_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_GT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_EQ] = ACTIONS(2207),
    [anon_sym_CARET_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_EQ] = ACTIONS(2207),
    [anon_sym_and_eq] = ACTIONS(2205),
    [anon_sym_or_eq] = ACTIONS(2205),
    [anon_sym_xor_eq] = ACTIONS(2205),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_decltype] = ACTIONS(2168),
    [anon_sym_template] = ACTIONS(2168),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
  },
  [1429] = {
    [sym_expression] = STATE(4811),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(4889),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4954),
    [anon_sym_COMMA] = ACTIONS(4954),
    [anon_sym_RPAREN] = ACTIONS(4954),
    [anon_sym_LPAREN2] = ACTIONS(4954),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(4952),
    [anon_sym_PLUS] = ACTIONS(4952),
    [anon_sym_STAR] = ACTIONS(4954),
    [anon_sym_SLASH] = ACTIONS(4952),
    [anon_sym_PERCENT] = ACTIONS(4954),
    [anon_sym_PIPE_PIPE] = ACTIONS(4954),
    [anon_sym_AMP_AMP] = ACTIONS(4954),
    [anon_sym_PIPE] = ACTIONS(4952),
    [anon_sym_CARET] = ACTIONS(4954),
    [anon_sym_AMP] = ACTIONS(4952),
    [anon_sym_EQ_EQ] = ACTIONS(4954),
    [anon_sym_BANG_EQ] = ACTIONS(4954),
    [anon_sym_GT] = ACTIONS(4952),
    [anon_sym_GT_EQ] = ACTIONS(4954),
    [anon_sym_LT_EQ] = ACTIONS(4952),
    [anon_sym_LT] = ACTIONS(4952),
    [anon_sym_LT_LT] = ACTIONS(4954),
    [anon_sym_GT_GT] = ACTIONS(4954),
    [anon_sym_SEMI] = ACTIONS(4954),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_RBRACE] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(4954),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_QMARK] = ACTIONS(4954),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_LT_EQ_GT] = ACTIONS(4954),
    [anon_sym_or] = ACTIONS(4952),
    [anon_sym_and] = ACTIONS(4952),
    [anon_sym_bitor] = ACTIONS(4952),
    [anon_sym_xor] = ACTIONS(4952),
    [anon_sym_bitand] = ACTIONS(4952),
    [anon_sym_not_eq] = ACTIONS(4952),
    [anon_sym_is] = ACTIONS(4952),
    [anon_sym_as] = ACTIONS(4952),
    [anon_sym_DASH_DASH] = ACTIONS(4954),
    [anon_sym_PLUS_PLUS] = ACTIONS(4954),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(4952),
    [anon_sym_DOT_STAR] = ACTIONS(4954),
    [anon_sym_DASH_GT] = ACTIONS(4954),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1430] = {
    [sym_expression] = STATE(4811),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_initializer_list] = STATE(4889),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4954),
    [anon_sym_COMMA] = ACTIONS(4954),
    [anon_sym_LPAREN2] = ACTIONS(4954),
    [anon_sym_BANG] = ACTIONS(5419),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(4952),
    [anon_sym_PLUS] = ACTIONS(4952),
    [anon_sym_STAR] = ACTIONS(4954),
    [anon_sym_SLASH] = ACTIONS(4952),
    [anon_sym_PERCENT] = ACTIONS(4954),
    [anon_sym_PIPE_PIPE] = ACTIONS(4954),
    [anon_sym_AMP_AMP] = ACTIONS(4954),
    [anon_sym_PIPE] = ACTIONS(4952),
    [anon_sym_CARET] = ACTIONS(4954),
    [anon_sym_AMP] = ACTIONS(4952),
    [anon_sym_EQ_EQ] = ACTIONS(4954),
    [anon_sym_BANG_EQ] = ACTIONS(4954),
    [anon_sym_GT] = ACTIONS(4952),
    [anon_sym_GT_EQ] = ACTIONS(4954),
    [anon_sym_LT_EQ] = ACTIONS(4952),
    [anon_sym_LT] = ACTIONS(4952),
    [anon_sym_LT_LT] = ACTIONS(4954),
    [anon_sym_GT_GT] = ACTIONS(4954),
    [anon_sym_SEMI] = ACTIONS(4954),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym___attribute__] = ACTIONS(4952),
    [anon_sym___attribute] = ACTIONS(4952),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4954),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_QMARK] = ACTIONS(4954),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_LT_EQ_GT] = ACTIONS(4954),
    [anon_sym_or] = ACTIONS(4952),
    [anon_sym_and] = ACTIONS(4952),
    [anon_sym_bitor] = ACTIONS(4952),
    [anon_sym_xor] = ACTIONS(4952),
    [anon_sym_bitand] = ACTIONS(4952),
    [anon_sym_not_eq] = ACTIONS(4952),
    [anon_sym_is] = ACTIONS(4952),
    [anon_sym_as] = ACTIONS(4952),
    [anon_sym_DASH_DASH] = ACTIONS(4954),
    [anon_sym_PLUS_PLUS] = ACTIONS(4954),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(4952),
    [anon_sym_DOT_STAR] = ACTIONS(4954),
    [anon_sym_DASH_GT] = ACTIONS(4954),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1431] = {
    [sym_expression] = STATE(5765),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_initializer_list] = STATE(4889),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4954),
    [anon_sym_COMMA] = ACTIONS(4954),
    [anon_sym_LPAREN2] = ACTIONS(4954),
    [anon_sym_BANG] = ACTIONS(5443),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(4952),
    [anon_sym_PLUS] = ACTIONS(4952),
    [anon_sym_STAR] = ACTIONS(4954),
    [anon_sym_SLASH] = ACTIONS(4952),
    [anon_sym_PERCENT] = ACTIONS(4954),
    [anon_sym_PIPE_PIPE] = ACTIONS(4954),
    [anon_sym_AMP_AMP] = ACTIONS(4954),
    [anon_sym_PIPE] = ACTIONS(4952),
    [anon_sym_CARET] = ACTIONS(4954),
    [anon_sym_AMP] = ACTIONS(4952),
    [anon_sym_EQ_EQ] = ACTIONS(4954),
    [anon_sym_BANG_EQ] = ACTIONS(4954),
    [anon_sym_GT] = ACTIONS(4952),
    [anon_sym_GT_EQ] = ACTIONS(4954),
    [anon_sym_LT_EQ] = ACTIONS(4952),
    [anon_sym_LT] = ACTIONS(4952),
    [anon_sym_LT_LT] = ACTIONS(4954),
    [anon_sym_GT_GT] = ACTIONS(4954),
    [anon_sym_COLON] = ACTIONS(4952),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4954),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_QMARK] = ACTIONS(4954),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_LT_EQ_GT] = ACTIONS(4954),
    [anon_sym_or] = ACTIONS(4952),
    [anon_sym_and] = ACTIONS(4952),
    [anon_sym_bitor] = ACTIONS(4952),
    [anon_sym_xor] = ACTIONS(4952),
    [anon_sym_bitand] = ACTIONS(4952),
    [anon_sym_not_eq] = ACTIONS(4952),
    [anon_sym_is] = ACTIONS(4952),
    [anon_sym_as] = ACTIONS(4952),
    [anon_sym_DASH_DASH] = ACTIONS(4954),
    [anon_sym_PLUS_PLUS] = ACTIONS(4954),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(4952),
    [anon_sym_DOT_STAR] = ACTIONS(4954),
    [anon_sym_DASH_GT] = ACTIONS(4954),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1432] = {
    [sym_expression] = STATE(4811),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_initializer_list] = STATE(4889),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4954),
    [anon_sym_COMMA] = ACTIONS(4954),
    [anon_sym_LPAREN2] = ACTIONS(4954),
    [anon_sym_BANG] = ACTIONS(5461),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(4952),
    [anon_sym_PLUS] = ACTIONS(4952),
    [anon_sym_STAR] = ACTIONS(4954),
    [anon_sym_SLASH] = ACTIONS(4952),
    [anon_sym_PERCENT] = ACTIONS(4954),
    [anon_sym_PIPE_PIPE] = ACTIONS(4954),
    [anon_sym_AMP_AMP] = ACTIONS(4954),
    [anon_sym_PIPE] = ACTIONS(4952),
    [anon_sym_CARET] = ACTIONS(4954),
    [anon_sym_AMP] = ACTIONS(4952),
    [anon_sym_EQ_EQ] = ACTIONS(4954),
    [anon_sym_BANG_EQ] = ACTIONS(4954),
    [anon_sym_GT] = ACTIONS(4952),
    [anon_sym_GT_EQ] = ACTIONS(4954),
    [anon_sym_LT_EQ] = ACTIONS(4952),
    [anon_sym_LT] = ACTIONS(4952),
    [anon_sym_LT_LT] = ACTIONS(4954),
    [anon_sym_GT_GT] = ACTIONS(4954),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4954),
    [anon_sym_RBRACK] = ACTIONS(4954),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_QMARK] = ACTIONS(4954),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_LT_EQ_GT] = ACTIONS(4954),
    [anon_sym_or] = ACTIONS(4952),
    [anon_sym_and] = ACTIONS(4952),
    [anon_sym_bitor] = ACTIONS(4952),
    [anon_sym_xor] = ACTIONS(4952),
    [anon_sym_bitand] = ACTIONS(4952),
    [anon_sym_not_eq] = ACTIONS(4952),
    [anon_sym_is] = ACTIONS(4952),
    [anon_sym_as] = ACTIONS(4952),
    [anon_sym_DASH_DASH] = ACTIONS(4954),
    [anon_sym_PLUS_PLUS] = ACTIONS(4954),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(4952),
    [anon_sym_DOT_STAR] = ACTIONS(4954),
    [anon_sym_DASH_GT] = ACTIONS(4954),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1433] = {
    [sym_expression] = STATE(5708),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_initializer_list] = STATE(6116),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4954),
    [anon_sym_COMMA] = ACTIONS(4954),
    [anon_sym_LPAREN2] = ACTIONS(4954),
    [anon_sym_BANG] = ACTIONS(5080),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(4952),
    [anon_sym_PLUS] = ACTIONS(4952),
    [anon_sym_STAR] = ACTIONS(4954),
    [anon_sym_SLASH] = ACTIONS(4952),
    [anon_sym_PERCENT] = ACTIONS(4954),
    [anon_sym_PIPE_PIPE] = ACTIONS(4954),
    [anon_sym_AMP_AMP] = ACTIONS(4954),
    [anon_sym_PIPE] = ACTIONS(4952),
    [anon_sym_CARET] = ACTIONS(4954),
    [anon_sym_AMP] = ACTIONS(4952),
    [anon_sym_EQ_EQ] = ACTIONS(4954),
    [anon_sym_BANG_EQ] = ACTIONS(4954),
    [anon_sym_GT] = ACTIONS(4952),
    [anon_sym_GT_EQ] = ACTIONS(4952),
    [anon_sym_LT_EQ] = ACTIONS(4952),
    [anon_sym_LT] = ACTIONS(4952),
    [anon_sym_LT_LT] = ACTIONS(4954),
    [anon_sym_GT_GT] = ACTIONS(4952),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACE] = ACTIONS(5479),
    [anon_sym_LBRACK] = ACTIONS(4954),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_QMARK] = ACTIONS(4954),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_LT_EQ_GT] = ACTIONS(4954),
    [anon_sym_or] = ACTIONS(4952),
    [anon_sym_and] = ACTIONS(4952),
    [anon_sym_bitor] = ACTIONS(4952),
    [anon_sym_xor] = ACTIONS(4952),
    [anon_sym_bitand] = ACTIONS(4952),
    [anon_sym_not_eq] = ACTIONS(4952),
    [anon_sym_is] = ACTIONS(4952),
    [anon_sym_as] = ACTIONS(4952),
    [anon_sym_DASH_DASH] = ACTIONS(4954),
    [anon_sym_PLUS_PLUS] = ACTIONS(4954),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [anon_sym_DOT] = ACTIONS(4952),
    [anon_sym_DOT_STAR] = ACTIONS(4954),
    [anon_sym_DASH_GT] = ACTIONS(4954),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(4954),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [1434] = {
    [sym_expression] = STATE(6048),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5483),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5461),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_SLASH] = ACTIONS(5487),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_PIPE_PIPE] = ACTIONS(5483),
    [anon_sym_AMP_AMP] = ACTIONS(5483),
    [anon_sym_PIPE] = ACTIONS(5487),
    [anon_sym_CARET] = ACTIONS(5483),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_EQ_EQ] = ACTIONS(5483),
    [anon_sym_BANG_EQ] = ACTIONS(5483),
    [anon_sym_GT] = ACTIONS(5487),
    [anon_sym_GT_EQ] = ACTIONS(5483),
    [anon_sym_LT_EQ] = ACTIONS(5487),
    [anon_sym_LT] = ACTIONS(5487),
    [anon_sym_LT_LT] = ACTIONS(5483),
    [anon_sym_GT_GT] = ACTIONS(5483),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(5483),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_QMARK] = ACTIONS(5483),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_LT_EQ_GT] = ACTIONS(5483),
    [anon_sym_or] = ACTIONS(5487),
    [anon_sym_and] = ACTIONS(5487),
    [anon_sym_bitor] = ACTIONS(5487),
    [anon_sym_xor] = ACTIONS(5487),
    [anon_sym_bitand] = ACTIONS(5487),
    [anon_sym_not_eq] = ACTIONS(5487),
    [anon_sym_is] = ACTIONS(5487),
    [anon_sym_as] = ACTIONS(5487),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(5487),
    [anon_sym_DOT_STAR] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1435] = {
    [sym_expression] = STATE(5666),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5491),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5494),
    [anon_sym_COLON_COLON] = ACTIONS(5497),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(5500),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3373),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3376),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [1436] = {
    [sym_expression] = STATE(5382),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(3357),
    [anon_sym_COLON_COLON] = ACTIONS(3364),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3370),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3373),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3376),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [1437] = {
    [sym_expression] = STATE(4254),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5503),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5506),
    [anon_sym_COLON_COLON] = ACTIONS(5509),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(5512),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3373),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3376),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [1438] = {
    [sym__declaration_modifiers] = STATE(2667),
    [sym__declaration_specifiers] = STATE(4972),
    [sym_attribute_specifier] = STATE(2667),
    [sym_attribute_declaration] = STATE(2667),
    [sym_ms_declspec_modifier] = STATE(2667),
    [sym_ms_call_modifier] = STATE(8157),
    [sym__abstract_declarator] = STATE(9283),
    [sym_abstract_parenthesized_declarator] = STATE(7454),
    [sym_abstract_pointer_declarator] = STATE(7454),
    [sym_abstract_function_declarator] = STATE(7454),
    [sym_abstract_array_declarator] = STATE(7454),
    [sym_storage_class_specifier] = STATE(2667),
    [sym_type_qualifier] = STATE(2667),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2793),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_parameter_list] = STATE(3873),
    [sym_parameter_declaration] = STATE(10006),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_optional_parameter_declaration] = STATE(10006),
    [sym_variadic_parameter_declaration] = STATE(10006),
    [sym_abstract_reference_declarator] = STATE(7454),
    [sym__function_declarator_seq] = STATE(7543),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8769),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2667),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2667),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5340),
    [anon_sym_RPAREN] = ACTIONS(5342),
    [anon_sym_LPAREN2] = ACTIONS(5517),
    [anon_sym_STAR] = ACTIONS(5519),
    [anon_sym_AMP_AMP] = ACTIONS(5521),
    [anon_sym_AMP] = ACTIONS(5523),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(2348),
    [anon_sym_out] = ACTIONS(2348),
    [anon_sym_inout] = ACTIONS(2348),
    [anon_sym_virtual] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5525),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(2817),
    [anon_sym___clrcall] = ACTIONS(2817),
    [anon_sym___stdcall] = ACTIONS(2817),
    [anon_sym___fastcall] = ACTIONS(2817),
    [anon_sym___thiscall] = ACTIONS(2817),
    [anon_sym___vectorcall] = ACTIONS(2817),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(5527),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_extension] = ACTIONS(2398),
  },
  [1439] = {
    [sym__declaration_modifiers] = STATE(2667),
    [sym__declaration_specifiers] = STATE(4972),
    [sym_attribute_specifier] = STATE(2667),
    [sym_attribute_declaration] = STATE(2667),
    [sym_ms_declspec_modifier] = STATE(2667),
    [sym_ms_call_modifier] = STATE(8093),
    [sym__abstract_declarator] = STATE(9311),
    [sym_abstract_parenthesized_declarator] = STATE(7454),
    [sym_abstract_pointer_declarator] = STATE(7454),
    [sym_abstract_function_declarator] = STATE(7454),
    [sym_abstract_array_declarator] = STATE(7454),
    [sym_storage_class_specifier] = STATE(2667),
    [sym_type_qualifier] = STATE(2667),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2793),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_parameter_list] = STATE(3873),
    [sym_parameter_declaration] = STATE(10006),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_optional_parameter_declaration] = STATE(10006),
    [sym_variadic_parameter_declaration] = STATE(10006),
    [sym_abstract_reference_declarator] = STATE(7454),
    [sym__function_declarator_seq] = STATE(7543),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8769),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2667),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2667),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5340),
    [anon_sym_RPAREN] = ACTIONS(5342),
    [anon_sym_LPAREN2] = ACTIONS(5517),
    [anon_sym_STAR] = ACTIONS(5519),
    [anon_sym_AMP_AMP] = ACTIONS(5521),
    [anon_sym_AMP] = ACTIONS(5523),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(2348),
    [anon_sym_out] = ACTIONS(2348),
    [anon_sym_inout] = ACTIONS(2348),
    [anon_sym_virtual] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5525),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(2817),
    [anon_sym___clrcall] = ACTIONS(2817),
    [anon_sym___stdcall] = ACTIONS(2817),
    [anon_sym___fastcall] = ACTIONS(2817),
    [anon_sym___thiscall] = ACTIONS(2817),
    [anon_sym___vectorcall] = ACTIONS(2817),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(5527),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_extension] = ACTIONS(2398),
  },
  [1440] = {
    [sym_identifier] = ACTIONS(2296),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2298),
    [anon_sym_COMMA] = ACTIONS(2298),
    [anon_sym_RPAREN] = ACTIONS(2298),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2296),
    [anon_sym_SLASH] = ACTIONS(2296),
    [anon_sym_PERCENT] = ACTIONS(2296),
    [anon_sym_PIPE_PIPE] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_PIPE] = ACTIONS(2296),
    [anon_sym_CARET] = ACTIONS(2296),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_EQ_EQ] = ACTIONS(2298),
    [anon_sym_BANG_EQ] = ACTIONS(2298),
    [anon_sym_GT] = ACTIONS(2296),
    [anon_sym_GT_EQ] = ACTIONS(2298),
    [anon_sym_LT_EQ] = ACTIONS(2296),
    [anon_sym_LT] = ACTIONS(2296),
    [anon_sym_LT_LT] = ACTIONS(2296),
    [anon_sym_GT_GT] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2298),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym_in] = ACTIONS(2296),
    [anon_sym_out] = ACTIONS(2296),
    [anon_sym_inout] = ACTIONS(2296),
    [anon_sym_virtual] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym___attribute] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2298),
    [anon_sym___declspec] = ACTIONS(2296),
    [anon_sym___based] = ACTIONS(2296),
    [anon_sym___cdecl] = ACTIONS(2296),
    [anon_sym___clrcall] = ACTIONS(2296),
    [anon_sym___stdcall] = ACTIONS(2296),
    [anon_sym___fastcall] = ACTIONS(2296),
    [anon_sym___thiscall] = ACTIONS(2296),
    [anon_sym___vectorcall] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_RBRACE] = ACTIONS(2298),
    [anon_sym_LBRACK] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_EQ] = ACTIONS(2296),
    [anon_sym_register] = ACTIONS(2296),
    [anon_sym_inline] = ACTIONS(2296),
    [anon_sym___inline] = ACTIONS(2296),
    [anon_sym___inline__] = ACTIONS(2296),
    [anon_sym___forceinline] = ACTIONS(2296),
    [anon_sym_thread_local] = ACTIONS(2296),
    [anon_sym___thread] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym__Nonnull] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [anon_sym_QMARK] = ACTIONS(2298),
    [anon_sym_STAR_EQ] = ACTIONS(2298),
    [anon_sym_SLASH_EQ] = ACTIONS(2298),
    [anon_sym_PERCENT_EQ] = ACTIONS(2298),
    [anon_sym_PLUS_EQ] = ACTIONS(2298),
    [anon_sym_DASH_EQ] = ACTIONS(2298),
    [anon_sym_LT_LT_EQ] = ACTIONS(2298),
    [anon_sym_GT_GT_EQ] = ACTIONS(2298),
    [anon_sym_AMP_EQ] = ACTIONS(2298),
    [anon_sym_CARET_EQ] = ACTIONS(2298),
    [anon_sym_PIPE_EQ] = ACTIONS(2298),
    [anon_sym_and_eq] = ACTIONS(2296),
    [anon_sym_or_eq] = ACTIONS(2296),
    [anon_sym_xor_eq] = ACTIONS(2296),
    [anon_sym_LT_EQ_GT] = ACTIONS(2298),
    [anon_sym_or] = ACTIONS(2296),
    [anon_sym_and] = ACTIONS(2296),
    [anon_sym_bitor] = ACTIONS(2296),
    [anon_sym_xor] = ACTIONS(2296),
    [anon_sym_bitand] = ACTIONS(2296),
    [anon_sym_not_eq] = ACTIONS(2296),
    [anon_sym_is] = ACTIONS(2296),
    [anon_sym_as] = ACTIONS(2296),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_DOT] = ACTIONS(2296),
    [anon_sym_DOT_STAR] = ACTIONS(2298),
    [anon_sym_DASH_GT] = ACTIONS(2298),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_This] = ACTIONS(2296),
    [anon_sym_decltype] = ACTIONS(2296),
    [anon_sym_template] = ACTIONS(2296),
    [anon_sym_operator] = ACTIONS(2296),
    [anon_sym_precise] = ACTIONS(2296),
    [anon_sym_shared] = ACTIONS(2296),
    [anon_sym_groupshared] = ACTIONS(2296),
    [anon_sym_uniform] = ACTIONS(2296),
    [anon_sym_row_major] = ACTIONS(2296),
    [anon_sym_column_major] = ACTIONS(2296),
    [anon_sym_globallycoherent] = ACTIONS(2296),
    [anon_sym_centroid] = ACTIONS(2296),
    [anon_sym_noperspective] = ACTIONS(2296),
    [anon_sym_nointerpolation] = ACTIONS(2296),
    [anon_sym_sample] = ACTIONS(2296),
    [anon_sym_linear] = ACTIONS(2296),
    [anon_sym_snorm] = ACTIONS(2296),
    [anon_sym_unorm] = ACTIONS(2296),
    [anon_sym_point] = ACTIONS(2296),
    [anon_sym_line] = ACTIONS(2296),
    [anon_sym_triangleadj] = ACTIONS(2296),
    [anon_sym_lineadj] = ACTIONS(2296),
    [anon_sym_triangle] = ACTIONS(2296),
  },
  [1441] = {
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2266),
    [anon_sym_COMMA] = ACTIONS(2266),
    [anon_sym_RPAREN] = ACTIONS(2266),
    [anon_sym_LPAREN2] = ACTIONS(2266),
    [anon_sym_TILDE] = ACTIONS(2266),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2264),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_PERCENT] = ACTIONS(2264),
    [anon_sym_PIPE_PIPE] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2266),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_CARET] = ACTIONS(2264),
    [anon_sym_AMP] = ACTIONS(2264),
    [anon_sym_EQ_EQ] = ACTIONS(2266),
    [anon_sym_BANG_EQ] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(2264),
    [anon_sym_GT_EQ] = ACTIONS(2266),
    [anon_sym_LT_EQ] = ACTIONS(2264),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_LT_LT] = ACTIONS(2264),
    [anon_sym_GT_GT] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2266),
    [anon_sym___extension__] = ACTIONS(2264),
    [anon_sym_in] = ACTIONS(2264),
    [anon_sym_out] = ACTIONS(2264),
    [anon_sym_inout] = ACTIONS(2264),
    [anon_sym_virtual] = ACTIONS(2264),
    [anon_sym_extern] = ACTIONS(2264),
    [anon_sym___attribute__] = ACTIONS(2264),
    [anon_sym___attribute] = ACTIONS(2264),
    [anon_sym_COLON_COLON] = ACTIONS(2266),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2266),
    [anon_sym___declspec] = ACTIONS(2264),
    [anon_sym___based] = ACTIONS(2264),
    [anon_sym___cdecl] = ACTIONS(2264),
    [anon_sym___clrcall] = ACTIONS(2264),
    [anon_sym___stdcall] = ACTIONS(2264),
    [anon_sym___fastcall] = ACTIONS(2264),
    [anon_sym___thiscall] = ACTIONS(2264),
    [anon_sym___vectorcall] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_RBRACE] = ACTIONS(2266),
    [anon_sym_LBRACK] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_EQ] = ACTIONS(2264),
    [anon_sym_register] = ACTIONS(2264),
    [anon_sym_inline] = ACTIONS(2264),
    [anon_sym___inline] = ACTIONS(2264),
    [anon_sym___inline__] = ACTIONS(2264),
    [anon_sym___forceinline] = ACTIONS(2264),
    [anon_sym_thread_local] = ACTIONS(2264),
    [anon_sym___thread] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_constexpr] = ACTIONS(2264),
    [anon_sym_volatile] = ACTIONS(2264),
    [anon_sym_restrict] = ACTIONS(2264),
    [anon_sym___restrict__] = ACTIONS(2264),
    [anon_sym__Atomic] = ACTIONS(2264),
    [anon_sym__Noreturn] = ACTIONS(2264),
    [anon_sym_noreturn] = ACTIONS(2264),
    [anon_sym__Nonnull] = ACTIONS(2264),
    [anon_sym_mutable] = ACTIONS(2264),
    [anon_sym_constinit] = ACTIONS(2264),
    [anon_sym_consteval] = ACTIONS(2264),
    [anon_sym_alignas] = ACTIONS(2264),
    [anon_sym__Alignas] = ACTIONS(2264),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_STAR_EQ] = ACTIONS(2266),
    [anon_sym_SLASH_EQ] = ACTIONS(2266),
    [anon_sym_PERCENT_EQ] = ACTIONS(2266),
    [anon_sym_PLUS_EQ] = ACTIONS(2266),
    [anon_sym_DASH_EQ] = ACTIONS(2266),
    [anon_sym_LT_LT_EQ] = ACTIONS(2266),
    [anon_sym_GT_GT_EQ] = ACTIONS(2266),
    [anon_sym_AMP_EQ] = ACTIONS(2266),
    [anon_sym_CARET_EQ] = ACTIONS(2266),
    [anon_sym_PIPE_EQ] = ACTIONS(2266),
    [anon_sym_and_eq] = ACTIONS(2264),
    [anon_sym_or_eq] = ACTIONS(2264),
    [anon_sym_xor_eq] = ACTIONS(2264),
    [anon_sym_LT_EQ_GT] = ACTIONS(2266),
    [anon_sym_or] = ACTIONS(2264),
    [anon_sym_and] = ACTIONS(2264),
    [anon_sym_bitor] = ACTIONS(2264),
    [anon_sym_xor] = ACTIONS(2264),
    [anon_sym_bitand] = ACTIONS(2264),
    [anon_sym_not_eq] = ACTIONS(2264),
    [anon_sym_is] = ACTIONS(2264),
    [anon_sym_as] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2266),
    [anon_sym_PLUS_PLUS] = ACTIONS(2266),
    [anon_sym_DOT] = ACTIONS(2264),
    [anon_sym_DOT_STAR] = ACTIONS(2266),
    [anon_sym_DASH_GT] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_This] = ACTIONS(2264),
    [anon_sym_decltype] = ACTIONS(2264),
    [anon_sym_template] = ACTIONS(2264),
    [anon_sym_operator] = ACTIONS(2264),
    [anon_sym_precise] = ACTIONS(2264),
    [anon_sym_shared] = ACTIONS(2264),
    [anon_sym_groupshared] = ACTIONS(2264),
    [anon_sym_uniform] = ACTIONS(2264),
    [anon_sym_row_major] = ACTIONS(2264),
    [anon_sym_column_major] = ACTIONS(2264),
    [anon_sym_globallycoherent] = ACTIONS(2264),
    [anon_sym_centroid] = ACTIONS(2264),
    [anon_sym_noperspective] = ACTIONS(2264),
    [anon_sym_nointerpolation] = ACTIONS(2264),
    [anon_sym_sample] = ACTIONS(2264),
    [anon_sym_linear] = ACTIONS(2264),
    [anon_sym_snorm] = ACTIONS(2264),
    [anon_sym_unorm] = ACTIONS(2264),
    [anon_sym_point] = ACTIONS(2264),
    [anon_sym_line] = ACTIONS(2264),
    [anon_sym_triangleadj] = ACTIONS(2264),
    [anon_sym_lineadj] = ACTIONS(2264),
    [anon_sym_triangle] = ACTIONS(2264),
  },
  [1442] = {
    [sym_template_argument_list] = STATE(1456),
    [sym_identifier] = ACTIONS(2222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2224),
    [anon_sym_COMMA] = ACTIONS(2224),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2229),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2231),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_PIPE_PIPE] = ACTIONS(2224),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_EQ_EQ] = ACTIONS(2224),
    [anon_sym_BANG_EQ] = ACTIONS(2224),
    [anon_sym_GT] = ACTIONS(2234),
    [anon_sym_GT_EQ] = ACTIONS(2224),
    [anon_sym_LT_EQ] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(5529),
    [anon_sym_LT_LT] = ACTIONS(2234),
    [anon_sym_GT_GT] = ACTIONS(2234),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_virtual] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym___attribute] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2226),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym___based] = ACTIONS(2222),
    [anon_sym___cdecl] = ACTIONS(2222),
    [anon_sym___clrcall] = ACTIONS(2222),
    [anon_sym___stdcall] = ACTIONS(2222),
    [anon_sym___fastcall] = ACTIONS(2222),
    [anon_sym___thiscall] = ACTIONS(2222),
    [anon_sym___vectorcall] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_RBRACE] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2231),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym__Nonnull] = ACTIONS(2222),
    [anon_sym_mutable] = ACTIONS(2222),
    [anon_sym_constinit] = ACTIONS(2222),
    [anon_sym_consteval] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [anon_sym_QMARK] = ACTIONS(2224),
    [anon_sym_STAR_EQ] = ACTIONS(2224),
    [anon_sym_SLASH_EQ] = ACTIONS(2224),
    [anon_sym_PERCENT_EQ] = ACTIONS(2224),
    [anon_sym_PLUS_EQ] = ACTIONS(2224),
    [anon_sym_DASH_EQ] = ACTIONS(2224),
    [anon_sym_LT_LT_EQ] = ACTIONS(2224),
    [anon_sym_GT_GT_EQ] = ACTIONS(2224),
    [anon_sym_AMP_EQ] = ACTIONS(2224),
    [anon_sym_CARET_EQ] = ACTIONS(2224),
    [anon_sym_PIPE_EQ] = ACTIONS(2224),
    [anon_sym_and_eq] = ACTIONS(2234),
    [anon_sym_or_eq] = ACTIONS(2234),
    [anon_sym_xor_eq] = ACTIONS(2234),
    [anon_sym_LT_EQ_GT] = ACTIONS(2224),
    [anon_sym_or] = ACTIONS(2234),
    [anon_sym_and] = ACTIONS(2234),
    [anon_sym_bitor] = ACTIONS(2234),
    [anon_sym_xor] = ACTIONS(2234),
    [anon_sym_bitand] = ACTIONS(2234),
    [anon_sym_not_eq] = ACTIONS(2234),
    [anon_sym_is] = ACTIONS(2234),
    [anon_sym_as] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2224),
    [anon_sym_PLUS_PLUS] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(2231),
    [anon_sym_DOT_STAR] = ACTIONS(2224),
    [anon_sym_DASH_GT] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2222),
    [anon_sym_let] = ACTIONS(2222),
    [anon_sym_This] = ACTIONS(2222),
    [anon_sym_decltype] = ACTIONS(2222),
    [anon_sym_template] = ACTIONS(2222),
    [anon_sym_operator] = ACTIONS(2222),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_groupshared] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_row_major] = ACTIONS(2222),
    [anon_sym_column_major] = ACTIONS(2222),
    [anon_sym_globallycoherent] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym_nointerpolation] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_linear] = ACTIONS(2222),
    [anon_sym_snorm] = ACTIONS(2222),
    [anon_sym_unorm] = ACTIONS(2222),
    [anon_sym_point] = ACTIONS(2222),
    [anon_sym_line] = ACTIONS(2222),
    [anon_sym_triangleadj] = ACTIONS(2222),
    [anon_sym_lineadj] = ACTIONS(2222),
    [anon_sym_triangle] = ACTIONS(2222),
  },
  [1443] = {
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2302),
    [anon_sym_COMMA] = ACTIONS(2302),
    [anon_sym_RPAREN] = ACTIONS(2302),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_PIPE_PIPE] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_PIPE] = ACTIONS(2300),
    [anon_sym_CARET] = ACTIONS(2300),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_EQ_EQ] = ACTIONS(2302),
    [anon_sym_BANG_EQ] = ACTIONS(2302),
    [anon_sym_GT] = ACTIONS(2300),
    [anon_sym_GT_EQ] = ACTIONS(2302),
    [anon_sym_LT_EQ] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_LT_LT] = ACTIONS(2300),
    [anon_sym_GT_GT] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym_in] = ACTIONS(2300),
    [anon_sym_out] = ACTIONS(2300),
    [anon_sym_inout] = ACTIONS(2300),
    [anon_sym_virtual] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym___attribute] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2302),
    [anon_sym___declspec] = ACTIONS(2300),
    [anon_sym___based] = ACTIONS(2300),
    [anon_sym___cdecl] = ACTIONS(2300),
    [anon_sym___clrcall] = ACTIONS(2300),
    [anon_sym___stdcall] = ACTIONS(2300),
    [anon_sym___fastcall] = ACTIONS(2300),
    [anon_sym___thiscall] = ACTIONS(2300),
    [anon_sym___vectorcall] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_RBRACE] = ACTIONS(2302),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_EQ] = ACTIONS(2300),
    [anon_sym_register] = ACTIONS(2300),
    [anon_sym_inline] = ACTIONS(2300),
    [anon_sym___inline] = ACTIONS(2300),
    [anon_sym___inline__] = ACTIONS(2300),
    [anon_sym___forceinline] = ACTIONS(2300),
    [anon_sym_thread_local] = ACTIONS(2300),
    [anon_sym___thread] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym__Nonnull] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [anon_sym_QMARK] = ACTIONS(2302),
    [anon_sym_STAR_EQ] = ACTIONS(2302),
    [anon_sym_SLASH_EQ] = ACTIONS(2302),
    [anon_sym_PERCENT_EQ] = ACTIONS(2302),
    [anon_sym_PLUS_EQ] = ACTIONS(2302),
    [anon_sym_DASH_EQ] = ACTIONS(2302),
    [anon_sym_LT_LT_EQ] = ACTIONS(2302),
    [anon_sym_GT_GT_EQ] = ACTIONS(2302),
    [anon_sym_AMP_EQ] = ACTIONS(2302),
    [anon_sym_CARET_EQ] = ACTIONS(2302),
    [anon_sym_PIPE_EQ] = ACTIONS(2302),
    [anon_sym_and_eq] = ACTIONS(2300),
    [anon_sym_or_eq] = ACTIONS(2300),
    [anon_sym_xor_eq] = ACTIONS(2300),
    [anon_sym_LT_EQ_GT] = ACTIONS(2302),
    [anon_sym_or] = ACTIONS(2300),
    [anon_sym_and] = ACTIONS(2300),
    [anon_sym_bitor] = ACTIONS(2300),
    [anon_sym_xor] = ACTIONS(2300),
    [anon_sym_bitand] = ACTIONS(2300),
    [anon_sym_not_eq] = ACTIONS(2300),
    [anon_sym_is] = ACTIONS(2300),
    [anon_sym_as] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_DOT] = ACTIONS(2300),
    [anon_sym_DOT_STAR] = ACTIONS(2302),
    [anon_sym_DASH_GT] = ACTIONS(2302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_This] = ACTIONS(2300),
    [anon_sym_decltype] = ACTIONS(2300),
    [anon_sym_template] = ACTIONS(2300),
    [anon_sym_operator] = ACTIONS(2300),
    [anon_sym_precise] = ACTIONS(2300),
    [anon_sym_shared] = ACTIONS(2300),
    [anon_sym_groupshared] = ACTIONS(2300),
    [anon_sym_uniform] = ACTIONS(2300),
    [anon_sym_row_major] = ACTIONS(2300),
    [anon_sym_column_major] = ACTIONS(2300),
    [anon_sym_globallycoherent] = ACTIONS(2300),
    [anon_sym_centroid] = ACTIONS(2300),
    [anon_sym_noperspective] = ACTIONS(2300),
    [anon_sym_nointerpolation] = ACTIONS(2300),
    [anon_sym_sample] = ACTIONS(2300),
    [anon_sym_linear] = ACTIONS(2300),
    [anon_sym_snorm] = ACTIONS(2300),
    [anon_sym_unorm] = ACTIONS(2300),
    [anon_sym_point] = ACTIONS(2300),
    [anon_sym_line] = ACTIONS(2300),
    [anon_sym_triangleadj] = ACTIONS(2300),
    [anon_sym_lineadj] = ACTIONS(2300),
    [anon_sym_triangle] = ACTIONS(2300),
  },
  [1444] = {
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_COMMA] = ACTIONS(2262),
    [anon_sym_RPAREN] = ACTIONS(2262),
    [anon_sym_LPAREN2] = ACTIONS(2262),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2260),
    [anon_sym_PERCENT] = ACTIONS(2260),
    [anon_sym_PIPE_PIPE] = ACTIONS(2262),
    [anon_sym_AMP_AMP] = ACTIONS(2262),
    [anon_sym_PIPE] = ACTIONS(2260),
    [anon_sym_CARET] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_EQ_EQ] = ACTIONS(2262),
    [anon_sym_BANG_EQ] = ACTIONS(2262),
    [anon_sym_GT] = ACTIONS(2260),
    [anon_sym_GT_EQ] = ACTIONS(2262),
    [anon_sym_LT_EQ] = ACTIONS(2260),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_LT_LT] = ACTIONS(2260),
    [anon_sym_GT_GT] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym___extension__] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(2260),
    [anon_sym_out] = ACTIONS(2260),
    [anon_sym_inout] = ACTIONS(2260),
    [anon_sym_virtual] = ACTIONS(2260),
    [anon_sym_extern] = ACTIONS(2260),
    [anon_sym___attribute__] = ACTIONS(2260),
    [anon_sym___attribute] = ACTIONS(2260),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2262),
    [anon_sym___declspec] = ACTIONS(2260),
    [anon_sym___based] = ACTIONS(2260),
    [anon_sym___cdecl] = ACTIONS(2260),
    [anon_sym___clrcall] = ACTIONS(2260),
    [anon_sym___stdcall] = ACTIONS(2260),
    [anon_sym___fastcall] = ACTIONS(2260),
    [anon_sym___thiscall] = ACTIONS(2260),
    [anon_sym___vectorcall] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_RBRACE] = ACTIONS(2262),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_EQ] = ACTIONS(2260),
    [anon_sym_register] = ACTIONS(2260),
    [anon_sym_inline] = ACTIONS(2260),
    [anon_sym___inline] = ACTIONS(2260),
    [anon_sym___inline__] = ACTIONS(2260),
    [anon_sym___forceinline] = ACTIONS(2260),
    [anon_sym_thread_local] = ACTIONS(2260),
    [anon_sym___thread] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_constexpr] = ACTIONS(2260),
    [anon_sym_volatile] = ACTIONS(2260),
    [anon_sym_restrict] = ACTIONS(2260),
    [anon_sym___restrict__] = ACTIONS(2260),
    [anon_sym__Atomic] = ACTIONS(2260),
    [anon_sym__Noreturn] = ACTIONS(2260),
    [anon_sym_noreturn] = ACTIONS(2260),
    [anon_sym__Nonnull] = ACTIONS(2260),
    [anon_sym_mutable] = ACTIONS(2260),
    [anon_sym_constinit] = ACTIONS(2260),
    [anon_sym_consteval] = ACTIONS(2260),
    [anon_sym_alignas] = ACTIONS(2260),
    [anon_sym__Alignas] = ACTIONS(2260),
    [anon_sym_QMARK] = ACTIONS(2262),
    [anon_sym_STAR_EQ] = ACTIONS(2262),
    [anon_sym_SLASH_EQ] = ACTIONS(2262),
    [anon_sym_PERCENT_EQ] = ACTIONS(2262),
    [anon_sym_PLUS_EQ] = ACTIONS(2262),
    [anon_sym_DASH_EQ] = ACTIONS(2262),
    [anon_sym_LT_LT_EQ] = ACTIONS(2262),
    [anon_sym_GT_GT_EQ] = ACTIONS(2262),
    [anon_sym_AMP_EQ] = ACTIONS(2262),
    [anon_sym_CARET_EQ] = ACTIONS(2262),
    [anon_sym_PIPE_EQ] = ACTIONS(2262),
    [anon_sym_and_eq] = ACTIONS(2260),
    [anon_sym_or_eq] = ACTIONS(2260),
    [anon_sym_xor_eq] = ACTIONS(2260),
    [anon_sym_LT_EQ_GT] = ACTIONS(2262),
    [anon_sym_or] = ACTIONS(2260),
    [anon_sym_and] = ACTIONS(2260),
    [anon_sym_bitor] = ACTIONS(2260),
    [anon_sym_xor] = ACTIONS(2260),
    [anon_sym_bitand] = ACTIONS(2260),
    [anon_sym_not_eq] = ACTIONS(2260),
    [anon_sym_is] = ACTIONS(2260),
    [anon_sym_as] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_DOT] = ACTIONS(2260),
    [anon_sym_DOT_STAR] = ACTIONS(2262),
    [anon_sym_DASH_GT] = ACTIONS(2262),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_This] = ACTIONS(2260),
    [anon_sym_decltype] = ACTIONS(2260),
    [anon_sym_template] = ACTIONS(2260),
    [anon_sym_operator] = ACTIONS(2260),
    [anon_sym_precise] = ACTIONS(2260),
    [anon_sym_shared] = ACTIONS(2260),
    [anon_sym_groupshared] = ACTIONS(2260),
    [anon_sym_uniform] = ACTIONS(2260),
    [anon_sym_row_major] = ACTIONS(2260),
    [anon_sym_column_major] = ACTIONS(2260),
    [anon_sym_globallycoherent] = ACTIONS(2260),
    [anon_sym_centroid] = ACTIONS(2260),
    [anon_sym_noperspective] = ACTIONS(2260),
    [anon_sym_nointerpolation] = ACTIONS(2260),
    [anon_sym_sample] = ACTIONS(2260),
    [anon_sym_linear] = ACTIONS(2260),
    [anon_sym_snorm] = ACTIONS(2260),
    [anon_sym_unorm] = ACTIONS(2260),
    [anon_sym_point] = ACTIONS(2260),
    [anon_sym_line] = ACTIONS(2260),
    [anon_sym_triangleadj] = ACTIONS(2260),
    [anon_sym_lineadj] = ACTIONS(2260),
    [anon_sym_triangle] = ACTIONS(2260),
  },
  [1445] = {
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_COMMA] = ACTIONS(2306),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2304),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_PERCENT] = ACTIONS(2304),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE] = ACTIONS(2304),
    [anon_sym_CARET] = ACTIONS(2304),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_GT] = ACTIONS(2304),
    [anon_sym_GT_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_LT_LT] = ACTIONS(2304),
    [anon_sym_GT_GT] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2306),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym_in] = ACTIONS(2304),
    [anon_sym_out] = ACTIONS(2304),
    [anon_sym_inout] = ACTIONS(2304),
    [anon_sym_virtual] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym___attribute] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2306),
    [anon_sym___declspec] = ACTIONS(2304),
    [anon_sym___based] = ACTIONS(2304),
    [anon_sym___cdecl] = ACTIONS(2304),
    [anon_sym___clrcall] = ACTIONS(2304),
    [anon_sym___stdcall] = ACTIONS(2304),
    [anon_sym___fastcall] = ACTIONS(2304),
    [anon_sym___thiscall] = ACTIONS(2304),
    [anon_sym___vectorcall] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_EQ] = ACTIONS(2304),
    [anon_sym_register] = ACTIONS(2304),
    [anon_sym_inline] = ACTIONS(2304),
    [anon_sym___inline] = ACTIONS(2304),
    [anon_sym___inline__] = ACTIONS(2304),
    [anon_sym___forceinline] = ACTIONS(2304),
    [anon_sym_thread_local] = ACTIONS(2304),
    [anon_sym___thread] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym__Nonnull] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [anon_sym_QMARK] = ACTIONS(2306),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_and_eq] = ACTIONS(2304),
    [anon_sym_or_eq] = ACTIONS(2304),
    [anon_sym_xor_eq] = ACTIONS(2304),
    [anon_sym_LT_EQ_GT] = ACTIONS(2306),
    [anon_sym_or] = ACTIONS(2304),
    [anon_sym_and] = ACTIONS(2304),
    [anon_sym_bitor] = ACTIONS(2304),
    [anon_sym_xor] = ACTIONS(2304),
    [anon_sym_bitand] = ACTIONS(2304),
    [anon_sym_not_eq] = ACTIONS(2304),
    [anon_sym_is] = ACTIONS(2304),
    [anon_sym_as] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DOT] = ACTIONS(2304),
    [anon_sym_DOT_STAR] = ACTIONS(2306),
    [anon_sym_DASH_GT] = ACTIONS(2306),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_This] = ACTIONS(2304),
    [anon_sym_decltype] = ACTIONS(2304),
    [anon_sym_template] = ACTIONS(2304),
    [anon_sym_operator] = ACTIONS(2304),
    [anon_sym_precise] = ACTIONS(2304),
    [anon_sym_shared] = ACTIONS(2304),
    [anon_sym_groupshared] = ACTIONS(2304),
    [anon_sym_uniform] = ACTIONS(2304),
    [anon_sym_row_major] = ACTIONS(2304),
    [anon_sym_column_major] = ACTIONS(2304),
    [anon_sym_globallycoherent] = ACTIONS(2304),
    [anon_sym_centroid] = ACTIONS(2304),
    [anon_sym_noperspective] = ACTIONS(2304),
    [anon_sym_nointerpolation] = ACTIONS(2304),
    [anon_sym_sample] = ACTIONS(2304),
    [anon_sym_linear] = ACTIONS(2304),
    [anon_sym_snorm] = ACTIONS(2304),
    [anon_sym_unorm] = ACTIONS(2304),
    [anon_sym_point] = ACTIONS(2304),
    [anon_sym_line] = ACTIONS(2304),
    [anon_sym_triangleadj] = ACTIONS(2304),
    [anon_sym_lineadj] = ACTIONS(2304),
    [anon_sym_triangle] = ACTIONS(2304),
  },
  [1446] = {
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2310),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_RPAREN] = ACTIONS(2310),
    [anon_sym_LPAREN2] = ACTIONS(2310),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2308),
    [anon_sym_SLASH] = ACTIONS(2308),
    [anon_sym_PERCENT] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_CARET] = ACTIONS(2308),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2310),
    [anon_sym_BANG_EQ] = ACTIONS(2310),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_EQ] = ACTIONS(2310),
    [anon_sym_LT_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(2308),
    [anon_sym_in] = ACTIONS(2308),
    [anon_sym_out] = ACTIONS(2308),
    [anon_sym_inout] = ACTIONS(2308),
    [anon_sym_virtual] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2308),
    [anon_sym___attribute__] = ACTIONS(2308),
    [anon_sym___attribute] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2310),
    [anon_sym___declspec] = ACTIONS(2308),
    [anon_sym___based] = ACTIONS(2308),
    [anon_sym___cdecl] = ACTIONS(2308),
    [anon_sym___clrcall] = ACTIONS(2308),
    [anon_sym___stdcall] = ACTIONS(2308),
    [anon_sym___fastcall] = ACTIONS(2308),
    [anon_sym___thiscall] = ACTIONS(2308),
    [anon_sym___vectorcall] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_RBRACE] = ACTIONS(2310),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_EQ] = ACTIONS(2308),
    [anon_sym_register] = ACTIONS(2308),
    [anon_sym_inline] = ACTIONS(2308),
    [anon_sym___inline] = ACTIONS(2308),
    [anon_sym___inline__] = ACTIONS(2308),
    [anon_sym___forceinline] = ACTIONS(2308),
    [anon_sym_thread_local] = ACTIONS(2308),
    [anon_sym___thread] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_constexpr] = ACTIONS(2308),
    [anon_sym_volatile] = ACTIONS(2308),
    [anon_sym_restrict] = ACTIONS(2308),
    [anon_sym___restrict__] = ACTIONS(2308),
    [anon_sym__Atomic] = ACTIONS(2308),
    [anon_sym__Noreturn] = ACTIONS(2308),
    [anon_sym_noreturn] = ACTIONS(2308),
    [anon_sym__Nonnull] = ACTIONS(2308),
    [anon_sym_mutable] = ACTIONS(2308),
    [anon_sym_constinit] = ACTIONS(2308),
    [anon_sym_consteval] = ACTIONS(2308),
    [anon_sym_alignas] = ACTIONS(2308),
    [anon_sym__Alignas] = ACTIONS(2308),
    [anon_sym_QMARK] = ACTIONS(2310),
    [anon_sym_STAR_EQ] = ACTIONS(2310),
    [anon_sym_SLASH_EQ] = ACTIONS(2310),
    [anon_sym_PERCENT_EQ] = ACTIONS(2310),
    [anon_sym_PLUS_EQ] = ACTIONS(2310),
    [anon_sym_DASH_EQ] = ACTIONS(2310),
    [anon_sym_LT_LT_EQ] = ACTIONS(2310),
    [anon_sym_GT_GT_EQ] = ACTIONS(2310),
    [anon_sym_AMP_EQ] = ACTIONS(2310),
    [anon_sym_CARET_EQ] = ACTIONS(2310),
    [anon_sym_PIPE_EQ] = ACTIONS(2310),
    [anon_sym_and_eq] = ACTIONS(2308),
    [anon_sym_or_eq] = ACTIONS(2308),
    [anon_sym_xor_eq] = ACTIONS(2308),
    [anon_sym_LT_EQ_GT] = ACTIONS(2310),
    [anon_sym_or] = ACTIONS(2308),
    [anon_sym_and] = ACTIONS(2308),
    [anon_sym_bitor] = ACTIONS(2308),
    [anon_sym_xor] = ACTIONS(2308),
    [anon_sym_bitand] = ACTIONS(2308),
    [anon_sym_not_eq] = ACTIONS(2308),
    [anon_sym_is] = ACTIONS(2308),
    [anon_sym_as] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_DOT] = ACTIONS(2308),
    [anon_sym_DOT_STAR] = ACTIONS(2310),
    [anon_sym_DASH_GT] = ACTIONS(2310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_This] = ACTIONS(2308),
    [anon_sym_decltype] = ACTIONS(2308),
    [anon_sym_template] = ACTIONS(2308),
    [anon_sym_operator] = ACTIONS(2308),
    [anon_sym_precise] = ACTIONS(2308),
    [anon_sym_shared] = ACTIONS(2308),
    [anon_sym_groupshared] = ACTIONS(2308),
    [anon_sym_uniform] = ACTIONS(2308),
    [anon_sym_row_major] = ACTIONS(2308),
    [anon_sym_column_major] = ACTIONS(2308),
    [anon_sym_globallycoherent] = ACTIONS(2308),
    [anon_sym_centroid] = ACTIONS(2308),
    [anon_sym_noperspective] = ACTIONS(2308),
    [anon_sym_nointerpolation] = ACTIONS(2308),
    [anon_sym_sample] = ACTIONS(2308),
    [anon_sym_linear] = ACTIONS(2308),
    [anon_sym_snorm] = ACTIONS(2308),
    [anon_sym_unorm] = ACTIONS(2308),
    [anon_sym_point] = ACTIONS(2308),
    [anon_sym_line] = ACTIONS(2308),
    [anon_sym_triangleadj] = ACTIONS(2308),
    [anon_sym_lineadj] = ACTIONS(2308),
    [anon_sym_triangle] = ACTIONS(2308),
  },
  [1447] = {
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2314),
    [anon_sym_COMMA] = ACTIONS(2314),
    [anon_sym_RPAREN] = ACTIONS(2314),
    [anon_sym_LPAREN2] = ACTIONS(2314),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_SLASH] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2312),
    [anon_sym_PIPE_PIPE] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2314),
    [anon_sym_PIPE] = ACTIONS(2312),
    [anon_sym_CARET] = ACTIONS(2312),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_EQ_EQ] = ACTIONS(2314),
    [anon_sym_BANG_EQ] = ACTIONS(2314),
    [anon_sym_GT] = ACTIONS(2312),
    [anon_sym_GT_EQ] = ACTIONS(2314),
    [anon_sym_LT_EQ] = ACTIONS(2312),
    [anon_sym_LT] = ACTIONS(2312),
    [anon_sym_LT_LT] = ACTIONS(2312),
    [anon_sym_GT_GT] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym___extension__] = ACTIONS(2312),
    [anon_sym_in] = ACTIONS(2312),
    [anon_sym_out] = ACTIONS(2312),
    [anon_sym_inout] = ACTIONS(2312),
    [anon_sym_virtual] = ACTIONS(2312),
    [anon_sym_extern] = ACTIONS(2312),
    [anon_sym___attribute__] = ACTIONS(2312),
    [anon_sym___attribute] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2314),
    [anon_sym___declspec] = ACTIONS(2312),
    [anon_sym___based] = ACTIONS(2312),
    [anon_sym___cdecl] = ACTIONS(2312),
    [anon_sym___clrcall] = ACTIONS(2312),
    [anon_sym___stdcall] = ACTIONS(2312),
    [anon_sym___fastcall] = ACTIONS(2312),
    [anon_sym___thiscall] = ACTIONS(2312),
    [anon_sym___vectorcall] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_RBRACE] = ACTIONS(2314),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_EQ] = ACTIONS(2312),
    [anon_sym_register] = ACTIONS(2312),
    [anon_sym_inline] = ACTIONS(2312),
    [anon_sym___inline] = ACTIONS(2312),
    [anon_sym___inline__] = ACTIONS(2312),
    [anon_sym___forceinline] = ACTIONS(2312),
    [anon_sym_thread_local] = ACTIONS(2312),
    [anon_sym___thread] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_constexpr] = ACTIONS(2312),
    [anon_sym_volatile] = ACTIONS(2312),
    [anon_sym_restrict] = ACTIONS(2312),
    [anon_sym___restrict__] = ACTIONS(2312),
    [anon_sym__Atomic] = ACTIONS(2312),
    [anon_sym__Noreturn] = ACTIONS(2312),
    [anon_sym_noreturn] = ACTIONS(2312),
    [anon_sym__Nonnull] = ACTIONS(2312),
    [anon_sym_mutable] = ACTIONS(2312),
    [anon_sym_constinit] = ACTIONS(2312),
    [anon_sym_consteval] = ACTIONS(2312),
    [anon_sym_alignas] = ACTIONS(2312),
    [anon_sym__Alignas] = ACTIONS(2312),
    [anon_sym_QMARK] = ACTIONS(2314),
    [anon_sym_STAR_EQ] = ACTIONS(2314),
    [anon_sym_SLASH_EQ] = ACTIONS(2314),
    [anon_sym_PERCENT_EQ] = ACTIONS(2314),
    [anon_sym_PLUS_EQ] = ACTIONS(2314),
    [anon_sym_DASH_EQ] = ACTIONS(2314),
    [anon_sym_LT_LT_EQ] = ACTIONS(2314),
    [anon_sym_GT_GT_EQ] = ACTIONS(2314),
    [anon_sym_AMP_EQ] = ACTIONS(2314),
    [anon_sym_CARET_EQ] = ACTIONS(2314),
    [anon_sym_PIPE_EQ] = ACTIONS(2314),
    [anon_sym_and_eq] = ACTIONS(2312),
    [anon_sym_or_eq] = ACTIONS(2312),
    [anon_sym_xor_eq] = ACTIONS(2312),
    [anon_sym_LT_EQ_GT] = ACTIONS(2314),
    [anon_sym_or] = ACTIONS(2312),
    [anon_sym_and] = ACTIONS(2312),
    [anon_sym_bitor] = ACTIONS(2312),
    [anon_sym_xor] = ACTIONS(2312),
    [anon_sym_bitand] = ACTIONS(2312),
    [anon_sym_not_eq] = ACTIONS(2312),
    [anon_sym_is] = ACTIONS(2312),
    [anon_sym_as] = ACTIONS(2312),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_DOT] = ACTIONS(2312),
    [anon_sym_DOT_STAR] = ACTIONS(2314),
    [anon_sym_DASH_GT] = ACTIONS(2314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_This] = ACTIONS(2312),
    [anon_sym_decltype] = ACTIONS(2312),
    [anon_sym_template] = ACTIONS(2312),
    [anon_sym_operator] = ACTIONS(2312),
    [anon_sym_precise] = ACTIONS(2312),
    [anon_sym_shared] = ACTIONS(2312),
    [anon_sym_groupshared] = ACTIONS(2312),
    [anon_sym_uniform] = ACTIONS(2312),
    [anon_sym_row_major] = ACTIONS(2312),
    [anon_sym_column_major] = ACTIONS(2312),
    [anon_sym_globallycoherent] = ACTIONS(2312),
    [anon_sym_centroid] = ACTIONS(2312),
    [anon_sym_noperspective] = ACTIONS(2312),
    [anon_sym_nointerpolation] = ACTIONS(2312),
    [anon_sym_sample] = ACTIONS(2312),
    [anon_sym_linear] = ACTIONS(2312),
    [anon_sym_snorm] = ACTIONS(2312),
    [anon_sym_unorm] = ACTIONS(2312),
    [anon_sym_point] = ACTIONS(2312),
    [anon_sym_line] = ACTIONS(2312),
    [anon_sym_triangleadj] = ACTIONS(2312),
    [anon_sym_lineadj] = ACTIONS(2312),
    [anon_sym_triangle] = ACTIONS(2312),
  },
  [1448] = {
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2294),
    [anon_sym_COMMA] = ACTIONS(2294),
    [anon_sym_RPAREN] = ACTIONS(2294),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2292),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_PERCENT] = ACTIONS(2292),
    [anon_sym_PIPE_PIPE] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_PIPE] = ACTIONS(2292),
    [anon_sym_CARET] = ACTIONS(2292),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_EQ_EQ] = ACTIONS(2294),
    [anon_sym_BANG_EQ] = ACTIONS(2294),
    [anon_sym_GT] = ACTIONS(2292),
    [anon_sym_GT_EQ] = ACTIONS(2294),
    [anon_sym_LT_EQ] = ACTIONS(2292),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_LT_LT] = ACTIONS(2292),
    [anon_sym_GT_GT] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym_in] = ACTIONS(2292),
    [anon_sym_out] = ACTIONS(2292),
    [anon_sym_inout] = ACTIONS(2292),
    [anon_sym_virtual] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym___attribute] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2294),
    [anon_sym___declspec] = ACTIONS(2292),
    [anon_sym___based] = ACTIONS(2292),
    [anon_sym___cdecl] = ACTIONS(2292),
    [anon_sym___clrcall] = ACTIONS(2292),
    [anon_sym___stdcall] = ACTIONS(2292),
    [anon_sym___fastcall] = ACTIONS(2292),
    [anon_sym___thiscall] = ACTIONS(2292),
    [anon_sym___vectorcall] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_EQ] = ACTIONS(2292),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym___inline] = ACTIONS(2292),
    [anon_sym___inline__] = ACTIONS(2292),
    [anon_sym___forceinline] = ACTIONS(2292),
    [anon_sym_thread_local] = ACTIONS(2292),
    [anon_sym___thread] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym__Nonnull] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [anon_sym_QMARK] = ACTIONS(2294),
    [anon_sym_STAR_EQ] = ACTIONS(2294),
    [anon_sym_SLASH_EQ] = ACTIONS(2294),
    [anon_sym_PERCENT_EQ] = ACTIONS(2294),
    [anon_sym_PLUS_EQ] = ACTIONS(2294),
    [anon_sym_DASH_EQ] = ACTIONS(2294),
    [anon_sym_LT_LT_EQ] = ACTIONS(2294),
    [anon_sym_GT_GT_EQ] = ACTIONS(2294),
    [anon_sym_AMP_EQ] = ACTIONS(2294),
    [anon_sym_CARET_EQ] = ACTIONS(2294),
    [anon_sym_PIPE_EQ] = ACTIONS(2294),
    [anon_sym_and_eq] = ACTIONS(2292),
    [anon_sym_or_eq] = ACTIONS(2292),
    [anon_sym_xor_eq] = ACTIONS(2292),
    [anon_sym_LT_EQ_GT] = ACTIONS(2294),
    [anon_sym_or] = ACTIONS(2292),
    [anon_sym_and] = ACTIONS(2292),
    [anon_sym_bitor] = ACTIONS(2292),
    [anon_sym_xor] = ACTIONS(2292),
    [anon_sym_bitand] = ACTIONS(2292),
    [anon_sym_not_eq] = ACTIONS(2292),
    [anon_sym_is] = ACTIONS(2292),
    [anon_sym_as] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_DOT] = ACTIONS(2292),
    [anon_sym_DOT_STAR] = ACTIONS(2294),
    [anon_sym_DASH_GT] = ACTIONS(2294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_This] = ACTIONS(2292),
    [anon_sym_decltype] = ACTIONS(2292),
    [anon_sym_template] = ACTIONS(2292),
    [anon_sym_operator] = ACTIONS(2292),
    [anon_sym_precise] = ACTIONS(2292),
    [anon_sym_shared] = ACTIONS(2292),
    [anon_sym_groupshared] = ACTIONS(2292),
    [anon_sym_uniform] = ACTIONS(2292),
    [anon_sym_row_major] = ACTIONS(2292),
    [anon_sym_column_major] = ACTIONS(2292),
    [anon_sym_globallycoherent] = ACTIONS(2292),
    [anon_sym_centroid] = ACTIONS(2292),
    [anon_sym_noperspective] = ACTIONS(2292),
    [anon_sym_nointerpolation] = ACTIONS(2292),
    [anon_sym_sample] = ACTIONS(2292),
    [anon_sym_linear] = ACTIONS(2292),
    [anon_sym_snorm] = ACTIONS(2292),
    [anon_sym_unorm] = ACTIONS(2292),
    [anon_sym_point] = ACTIONS(2292),
    [anon_sym_line] = ACTIONS(2292),
    [anon_sym_triangleadj] = ACTIONS(2292),
    [anon_sym_lineadj] = ACTIONS(2292),
    [anon_sym_triangle] = ACTIONS(2292),
  },
  [1449] = {
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2274),
    [anon_sym_COMMA] = ACTIONS(2274),
    [anon_sym_RPAREN] = ACTIONS(2274),
    [anon_sym_LPAREN2] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2272),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_PERCENT] = ACTIONS(2272),
    [anon_sym_PIPE_PIPE] = ACTIONS(2274),
    [anon_sym_AMP_AMP] = ACTIONS(2274),
    [anon_sym_PIPE] = ACTIONS(2272),
    [anon_sym_CARET] = ACTIONS(2272),
    [anon_sym_AMP] = ACTIONS(2272),
    [anon_sym_EQ_EQ] = ACTIONS(2274),
    [anon_sym_BANG_EQ] = ACTIONS(2274),
    [anon_sym_GT] = ACTIONS(2272),
    [anon_sym_GT_EQ] = ACTIONS(2274),
    [anon_sym_LT_EQ] = ACTIONS(2272),
    [anon_sym_LT] = ACTIONS(2272),
    [anon_sym_LT_LT] = ACTIONS(2272),
    [anon_sym_GT_GT] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym___extension__] = ACTIONS(2272),
    [anon_sym_in] = ACTIONS(2272),
    [anon_sym_out] = ACTIONS(2272),
    [anon_sym_inout] = ACTIONS(2272),
    [anon_sym_virtual] = ACTIONS(2272),
    [anon_sym_extern] = ACTIONS(2272),
    [anon_sym___attribute__] = ACTIONS(2272),
    [anon_sym___attribute] = ACTIONS(2272),
    [anon_sym_COLON_COLON] = ACTIONS(2274),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2274),
    [anon_sym___declspec] = ACTIONS(2272),
    [anon_sym___based] = ACTIONS(2272),
    [anon_sym___cdecl] = ACTIONS(2272),
    [anon_sym___clrcall] = ACTIONS(2272),
    [anon_sym___stdcall] = ACTIONS(2272),
    [anon_sym___fastcall] = ACTIONS(2272),
    [anon_sym___thiscall] = ACTIONS(2272),
    [anon_sym___vectorcall] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_RBRACE] = ACTIONS(2274),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_EQ] = ACTIONS(2272),
    [anon_sym_register] = ACTIONS(2272),
    [anon_sym_inline] = ACTIONS(2272),
    [anon_sym___inline] = ACTIONS(2272),
    [anon_sym___inline__] = ACTIONS(2272),
    [anon_sym___forceinline] = ACTIONS(2272),
    [anon_sym_thread_local] = ACTIONS(2272),
    [anon_sym___thread] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_constexpr] = ACTIONS(2272),
    [anon_sym_volatile] = ACTIONS(2272),
    [anon_sym_restrict] = ACTIONS(2272),
    [anon_sym___restrict__] = ACTIONS(2272),
    [anon_sym__Atomic] = ACTIONS(2272),
    [anon_sym__Noreturn] = ACTIONS(2272),
    [anon_sym_noreturn] = ACTIONS(2272),
    [anon_sym__Nonnull] = ACTIONS(2272),
    [anon_sym_mutable] = ACTIONS(2272),
    [anon_sym_constinit] = ACTIONS(2272),
    [anon_sym_consteval] = ACTIONS(2272),
    [anon_sym_alignas] = ACTIONS(2272),
    [anon_sym__Alignas] = ACTIONS(2272),
    [anon_sym_QMARK] = ACTIONS(2274),
    [anon_sym_STAR_EQ] = ACTIONS(2274),
    [anon_sym_SLASH_EQ] = ACTIONS(2274),
    [anon_sym_PERCENT_EQ] = ACTIONS(2274),
    [anon_sym_PLUS_EQ] = ACTIONS(2274),
    [anon_sym_DASH_EQ] = ACTIONS(2274),
    [anon_sym_LT_LT_EQ] = ACTIONS(2274),
    [anon_sym_GT_GT_EQ] = ACTIONS(2274),
    [anon_sym_AMP_EQ] = ACTIONS(2274),
    [anon_sym_CARET_EQ] = ACTIONS(2274),
    [anon_sym_PIPE_EQ] = ACTIONS(2274),
    [anon_sym_and_eq] = ACTIONS(2272),
    [anon_sym_or_eq] = ACTIONS(2272),
    [anon_sym_xor_eq] = ACTIONS(2272),
    [anon_sym_LT_EQ_GT] = ACTIONS(2274),
    [anon_sym_or] = ACTIONS(2272),
    [anon_sym_and] = ACTIONS(2272),
    [anon_sym_bitor] = ACTIONS(2272),
    [anon_sym_xor] = ACTIONS(2272),
    [anon_sym_bitand] = ACTIONS(2272),
    [anon_sym_not_eq] = ACTIONS(2272),
    [anon_sym_is] = ACTIONS(2272),
    [anon_sym_as] = ACTIONS(2272),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_DOT] = ACTIONS(2272),
    [anon_sym_DOT_STAR] = ACTIONS(2274),
    [anon_sym_DASH_GT] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_This] = ACTIONS(2272),
    [anon_sym_decltype] = ACTIONS(2272),
    [anon_sym_template] = ACTIONS(2272),
    [anon_sym_operator] = ACTIONS(2272),
    [anon_sym_precise] = ACTIONS(2272),
    [anon_sym_shared] = ACTIONS(2272),
    [anon_sym_groupshared] = ACTIONS(2272),
    [anon_sym_uniform] = ACTIONS(2272),
    [anon_sym_row_major] = ACTIONS(2272),
    [anon_sym_column_major] = ACTIONS(2272),
    [anon_sym_globallycoherent] = ACTIONS(2272),
    [anon_sym_centroid] = ACTIONS(2272),
    [anon_sym_noperspective] = ACTIONS(2272),
    [anon_sym_nointerpolation] = ACTIONS(2272),
    [anon_sym_sample] = ACTIONS(2272),
    [anon_sym_linear] = ACTIONS(2272),
    [anon_sym_snorm] = ACTIONS(2272),
    [anon_sym_unorm] = ACTIONS(2272),
    [anon_sym_point] = ACTIONS(2272),
    [anon_sym_line] = ACTIONS(2272),
    [anon_sym_triangleadj] = ACTIONS(2272),
    [anon_sym_lineadj] = ACTIONS(2272),
    [anon_sym_triangle] = ACTIONS(2272),
  },
  [1450] = {
    [sym_identifier] = ACTIONS(2276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2278),
    [anon_sym_COMMA] = ACTIONS(2278),
    [anon_sym_RPAREN] = ACTIONS(2278),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_PLUS] = ACTIONS(2276),
    [anon_sym_STAR] = ACTIONS(2276),
    [anon_sym_SLASH] = ACTIONS(2276),
    [anon_sym_PERCENT] = ACTIONS(2276),
    [anon_sym_PIPE_PIPE] = ACTIONS(2278),
    [anon_sym_AMP_AMP] = ACTIONS(2278),
    [anon_sym_PIPE] = ACTIONS(2276),
    [anon_sym_CARET] = ACTIONS(2276),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_EQ_EQ] = ACTIONS(2278),
    [anon_sym_BANG_EQ] = ACTIONS(2278),
    [anon_sym_GT] = ACTIONS(2276),
    [anon_sym_GT_EQ] = ACTIONS(2278),
    [anon_sym_LT_EQ] = ACTIONS(2276),
    [anon_sym_LT] = ACTIONS(2276),
    [anon_sym_LT_LT] = ACTIONS(2276),
    [anon_sym_GT_GT] = ACTIONS(2276),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym___extension__] = ACTIONS(2276),
    [anon_sym_in] = ACTIONS(2276),
    [anon_sym_out] = ACTIONS(2276),
    [anon_sym_inout] = ACTIONS(2276),
    [anon_sym_virtual] = ACTIONS(2276),
    [anon_sym_extern] = ACTIONS(2276),
    [anon_sym___attribute__] = ACTIONS(2276),
    [anon_sym___attribute] = ACTIONS(2276),
    [anon_sym_COLON_COLON] = ACTIONS(2278),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2278),
    [anon_sym___declspec] = ACTIONS(2276),
    [anon_sym___based] = ACTIONS(2276),
    [anon_sym___cdecl] = ACTIONS(2276),
    [anon_sym___clrcall] = ACTIONS(2276),
    [anon_sym___stdcall] = ACTIONS(2276),
    [anon_sym___fastcall] = ACTIONS(2276),
    [anon_sym___thiscall] = ACTIONS(2276),
    [anon_sym___vectorcall] = ACTIONS(2276),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_LBRACK] = ACTIONS(2276),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_EQ] = ACTIONS(2276),
    [anon_sym_register] = ACTIONS(2276),
    [anon_sym_inline] = ACTIONS(2276),
    [anon_sym___inline] = ACTIONS(2276),
    [anon_sym___inline__] = ACTIONS(2276),
    [anon_sym___forceinline] = ACTIONS(2276),
    [anon_sym_thread_local] = ACTIONS(2276),
    [anon_sym___thread] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_constexpr] = ACTIONS(2276),
    [anon_sym_volatile] = ACTIONS(2276),
    [anon_sym_restrict] = ACTIONS(2276),
    [anon_sym___restrict__] = ACTIONS(2276),
    [anon_sym__Atomic] = ACTIONS(2276),
    [anon_sym__Noreturn] = ACTIONS(2276),
    [anon_sym_noreturn] = ACTIONS(2276),
    [anon_sym__Nonnull] = ACTIONS(2276),
    [anon_sym_mutable] = ACTIONS(2276),
    [anon_sym_constinit] = ACTIONS(2276),
    [anon_sym_consteval] = ACTIONS(2276),
    [anon_sym_alignas] = ACTIONS(2276),
    [anon_sym__Alignas] = ACTIONS(2276),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_STAR_EQ] = ACTIONS(2278),
    [anon_sym_SLASH_EQ] = ACTIONS(2278),
    [anon_sym_PERCENT_EQ] = ACTIONS(2278),
    [anon_sym_PLUS_EQ] = ACTIONS(2278),
    [anon_sym_DASH_EQ] = ACTIONS(2278),
    [anon_sym_LT_LT_EQ] = ACTIONS(2278),
    [anon_sym_GT_GT_EQ] = ACTIONS(2278),
    [anon_sym_AMP_EQ] = ACTIONS(2278),
    [anon_sym_CARET_EQ] = ACTIONS(2278),
    [anon_sym_PIPE_EQ] = ACTIONS(2278),
    [anon_sym_and_eq] = ACTIONS(2276),
    [anon_sym_or_eq] = ACTIONS(2276),
    [anon_sym_xor_eq] = ACTIONS(2276),
    [anon_sym_LT_EQ_GT] = ACTIONS(2278),
    [anon_sym_or] = ACTIONS(2276),
    [anon_sym_and] = ACTIONS(2276),
    [anon_sym_bitor] = ACTIONS(2276),
    [anon_sym_xor] = ACTIONS(2276),
    [anon_sym_bitand] = ACTIONS(2276),
    [anon_sym_not_eq] = ACTIONS(2276),
    [anon_sym_is] = ACTIONS(2276),
    [anon_sym_as] = ACTIONS(2276),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DOT] = ACTIONS(2276),
    [anon_sym_DOT_STAR] = ACTIONS(2278),
    [anon_sym_DASH_GT] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_This] = ACTIONS(2276),
    [anon_sym_decltype] = ACTIONS(2276),
    [anon_sym_template] = ACTIONS(2276),
    [anon_sym_operator] = ACTIONS(2276),
    [anon_sym_precise] = ACTIONS(2276),
    [anon_sym_shared] = ACTIONS(2276),
    [anon_sym_groupshared] = ACTIONS(2276),
    [anon_sym_uniform] = ACTIONS(2276),
    [anon_sym_row_major] = ACTIONS(2276),
    [anon_sym_column_major] = ACTIONS(2276),
    [anon_sym_globallycoherent] = ACTIONS(2276),
    [anon_sym_centroid] = ACTIONS(2276),
    [anon_sym_noperspective] = ACTIONS(2276),
    [anon_sym_nointerpolation] = ACTIONS(2276),
    [anon_sym_sample] = ACTIONS(2276),
    [anon_sym_linear] = ACTIONS(2276),
    [anon_sym_snorm] = ACTIONS(2276),
    [anon_sym_unorm] = ACTIONS(2276),
    [anon_sym_point] = ACTIONS(2276),
    [anon_sym_line] = ACTIONS(2276),
    [anon_sym_triangleadj] = ACTIONS(2276),
    [anon_sym_lineadj] = ACTIONS(2276),
    [anon_sym_triangle] = ACTIONS(2276),
  },
  [1451] = {
    [sym_identifier] = ACTIONS(2239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2241),
    [anon_sym_COMMA] = ACTIONS(2241),
    [anon_sym_RPAREN] = ACTIONS(2241),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2239),
    [anon_sym_PLUS] = ACTIONS(2239),
    [anon_sym_STAR] = ACTIONS(2239),
    [anon_sym_SLASH] = ACTIONS(2239),
    [anon_sym_PERCENT] = ACTIONS(2239),
    [anon_sym_PIPE_PIPE] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_PIPE] = ACTIONS(2239),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_LT_EQ] = ACTIONS(2239),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_LT_LT] = ACTIONS(2239),
    [anon_sym_GT_GT] = ACTIONS(2239),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym_in] = ACTIONS(2239),
    [anon_sym_out] = ACTIONS(2239),
    [anon_sym_inout] = ACTIONS(2239),
    [anon_sym_virtual] = ACTIONS(2239),
    [anon_sym_extern] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym___attribute] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2241),
    [anon_sym___declspec] = ACTIONS(2239),
    [anon_sym___based] = ACTIONS(2239),
    [anon_sym___cdecl] = ACTIONS(2239),
    [anon_sym___clrcall] = ACTIONS(2239),
    [anon_sym___stdcall] = ACTIONS(2239),
    [anon_sym___fastcall] = ACTIONS(2239),
    [anon_sym___thiscall] = ACTIONS(2239),
    [anon_sym___vectorcall] = ACTIONS(2239),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_RBRACE] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2239),
    [anon_sym_EQ] = ACTIONS(2239),
    [anon_sym_register] = ACTIONS(2239),
    [anon_sym_inline] = ACTIONS(2239),
    [anon_sym___inline] = ACTIONS(2239),
    [anon_sym___inline__] = ACTIONS(2239),
    [anon_sym___forceinline] = ACTIONS(2239),
    [anon_sym_thread_local] = ACTIONS(2239),
    [anon_sym___thread] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym__Nonnull] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [anon_sym_QMARK] = ACTIONS(2241),
    [anon_sym_STAR_EQ] = ACTIONS(2241),
    [anon_sym_SLASH_EQ] = ACTIONS(2241),
    [anon_sym_PERCENT_EQ] = ACTIONS(2241),
    [anon_sym_PLUS_EQ] = ACTIONS(2241),
    [anon_sym_DASH_EQ] = ACTIONS(2241),
    [anon_sym_LT_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_GT_EQ] = ACTIONS(2241),
    [anon_sym_AMP_EQ] = ACTIONS(2241),
    [anon_sym_CARET_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_EQ] = ACTIONS(2241),
    [anon_sym_and_eq] = ACTIONS(2239),
    [anon_sym_or_eq] = ACTIONS(2239),
    [anon_sym_xor_eq] = ACTIONS(2239),
    [anon_sym_LT_EQ_GT] = ACTIONS(2241),
    [anon_sym_or] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(2239),
    [anon_sym_bitor] = ACTIONS(2239),
    [anon_sym_xor] = ACTIONS(2239),
    [anon_sym_bitand] = ACTIONS(2239),
    [anon_sym_not_eq] = ACTIONS(2239),
    [anon_sym_is] = ACTIONS(2239),
    [anon_sym_as] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2239),
    [anon_sym_DOT_STAR] = ACTIONS(2241),
    [anon_sym_DASH_GT] = ACTIONS(2241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2239),
    [anon_sym_let] = ACTIONS(2239),
    [anon_sym_This] = ACTIONS(2239),
    [anon_sym_decltype] = ACTIONS(2239),
    [anon_sym_template] = ACTIONS(2239),
    [anon_sym_operator] = ACTIONS(2239),
    [anon_sym_precise] = ACTIONS(2239),
    [anon_sym_shared] = ACTIONS(2239),
    [anon_sym_groupshared] = ACTIONS(2239),
    [anon_sym_uniform] = ACTIONS(2239),
    [anon_sym_row_major] = ACTIONS(2239),
    [anon_sym_column_major] = ACTIONS(2239),
    [anon_sym_globallycoherent] = ACTIONS(2239),
    [anon_sym_centroid] = ACTIONS(2239),
    [anon_sym_noperspective] = ACTIONS(2239),
    [anon_sym_nointerpolation] = ACTIONS(2239),
    [anon_sym_sample] = ACTIONS(2239),
    [anon_sym_linear] = ACTIONS(2239),
    [anon_sym_snorm] = ACTIONS(2239),
    [anon_sym_unorm] = ACTIONS(2239),
    [anon_sym_point] = ACTIONS(2239),
    [anon_sym_line] = ACTIONS(2239),
    [anon_sym_triangleadj] = ACTIONS(2239),
    [anon_sym_lineadj] = ACTIONS(2239),
    [anon_sym_triangle] = ACTIONS(2239),
  },
  [1452] = {
    [sym_identifier] = ACTIONS(2268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2270),
    [anon_sym_COMMA] = ACTIONS(2270),
    [anon_sym_RPAREN] = ACTIONS(2270),
    [anon_sym_LPAREN2] = ACTIONS(2270),
    [anon_sym_TILDE] = ACTIONS(2270),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2268),
    [anon_sym_SLASH] = ACTIONS(2268),
    [anon_sym_PERCENT] = ACTIONS(2268),
    [anon_sym_PIPE_PIPE] = ACTIONS(2270),
    [anon_sym_AMP_AMP] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2268),
    [anon_sym_CARET] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2268),
    [anon_sym_EQ_EQ] = ACTIONS(2270),
    [anon_sym_BANG_EQ] = ACTIONS(2270),
    [anon_sym_GT] = ACTIONS(2268),
    [anon_sym_GT_EQ] = ACTIONS(2270),
    [anon_sym_LT_EQ] = ACTIONS(2268),
    [anon_sym_LT] = ACTIONS(2268),
    [anon_sym_LT_LT] = ACTIONS(2268),
    [anon_sym_GT_GT] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym___extension__] = ACTIONS(2268),
    [anon_sym_in] = ACTIONS(2268),
    [anon_sym_out] = ACTIONS(2268),
    [anon_sym_inout] = ACTIONS(2268),
    [anon_sym_virtual] = ACTIONS(2268),
    [anon_sym_extern] = ACTIONS(2268),
    [anon_sym___attribute__] = ACTIONS(2268),
    [anon_sym___attribute] = ACTIONS(2268),
    [anon_sym_COLON_COLON] = ACTIONS(2270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2270),
    [anon_sym___declspec] = ACTIONS(2268),
    [anon_sym___based] = ACTIONS(2268),
    [anon_sym___cdecl] = ACTIONS(2268),
    [anon_sym___clrcall] = ACTIONS(2268),
    [anon_sym___stdcall] = ACTIONS(2268),
    [anon_sym___fastcall] = ACTIONS(2268),
    [anon_sym___thiscall] = ACTIONS(2268),
    [anon_sym___vectorcall] = ACTIONS(2268),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_RBRACE] = ACTIONS(2270),
    [anon_sym_LBRACK] = ACTIONS(2268),
    [anon_sym_static] = ACTIONS(2268),
    [anon_sym_EQ] = ACTIONS(2268),
    [anon_sym_register] = ACTIONS(2268),
    [anon_sym_inline] = ACTIONS(2268),
    [anon_sym___inline] = ACTIONS(2268),
    [anon_sym___inline__] = ACTIONS(2268),
    [anon_sym___forceinline] = ACTIONS(2268),
    [anon_sym_thread_local] = ACTIONS(2268),
    [anon_sym___thread] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_constexpr] = ACTIONS(2268),
    [anon_sym_volatile] = ACTIONS(2268),
    [anon_sym_restrict] = ACTIONS(2268),
    [anon_sym___restrict__] = ACTIONS(2268),
    [anon_sym__Atomic] = ACTIONS(2268),
    [anon_sym__Noreturn] = ACTIONS(2268),
    [anon_sym_noreturn] = ACTIONS(2268),
    [anon_sym__Nonnull] = ACTIONS(2268),
    [anon_sym_mutable] = ACTIONS(2268),
    [anon_sym_constinit] = ACTIONS(2268),
    [anon_sym_consteval] = ACTIONS(2268),
    [anon_sym_alignas] = ACTIONS(2268),
    [anon_sym__Alignas] = ACTIONS(2268),
    [anon_sym_QMARK] = ACTIONS(2270),
    [anon_sym_STAR_EQ] = ACTIONS(2270),
    [anon_sym_SLASH_EQ] = ACTIONS(2270),
    [anon_sym_PERCENT_EQ] = ACTIONS(2270),
    [anon_sym_PLUS_EQ] = ACTIONS(2270),
    [anon_sym_DASH_EQ] = ACTIONS(2270),
    [anon_sym_LT_LT_EQ] = ACTIONS(2270),
    [anon_sym_GT_GT_EQ] = ACTIONS(2270),
    [anon_sym_AMP_EQ] = ACTIONS(2270),
    [anon_sym_CARET_EQ] = ACTIONS(2270),
    [anon_sym_PIPE_EQ] = ACTIONS(2270),
    [anon_sym_and_eq] = ACTIONS(2268),
    [anon_sym_or_eq] = ACTIONS(2268),
    [anon_sym_xor_eq] = ACTIONS(2268),
    [anon_sym_LT_EQ_GT] = ACTIONS(2270),
    [anon_sym_or] = ACTIONS(2268),
    [anon_sym_and] = ACTIONS(2268),
    [anon_sym_bitor] = ACTIONS(2268),
    [anon_sym_xor] = ACTIONS(2268),
    [anon_sym_bitand] = ACTIONS(2268),
    [anon_sym_not_eq] = ACTIONS(2268),
    [anon_sym_is] = ACTIONS(2268),
    [anon_sym_as] = ACTIONS(2268),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_DOT] = ACTIONS(2268),
    [anon_sym_DOT_STAR] = ACTIONS(2270),
    [anon_sym_DASH_GT] = ACTIONS(2270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_This] = ACTIONS(2268),
    [anon_sym_decltype] = ACTIONS(2268),
    [anon_sym_template] = ACTIONS(2268),
    [anon_sym_operator] = ACTIONS(2268),
    [anon_sym_precise] = ACTIONS(2268),
    [anon_sym_shared] = ACTIONS(2268),
    [anon_sym_groupshared] = ACTIONS(2268),
    [anon_sym_uniform] = ACTIONS(2268),
    [anon_sym_row_major] = ACTIONS(2268),
    [anon_sym_column_major] = ACTIONS(2268),
    [anon_sym_globallycoherent] = ACTIONS(2268),
    [anon_sym_centroid] = ACTIONS(2268),
    [anon_sym_noperspective] = ACTIONS(2268),
    [anon_sym_nointerpolation] = ACTIONS(2268),
    [anon_sym_sample] = ACTIONS(2268),
    [anon_sym_linear] = ACTIONS(2268),
    [anon_sym_snorm] = ACTIONS(2268),
    [anon_sym_unorm] = ACTIONS(2268),
    [anon_sym_point] = ACTIONS(2268),
    [anon_sym_line] = ACTIONS(2268),
    [anon_sym_triangleadj] = ACTIONS(2268),
    [anon_sym_lineadj] = ACTIONS(2268),
    [anon_sym_triangle] = ACTIONS(2268),
  },
  [1453] = {
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_COMMA] = ACTIONS(2282),
    [anon_sym_RPAREN] = ACTIONS(2282),
    [anon_sym_LPAREN2] = ACTIONS(2282),
    [anon_sym_TILDE] = ACTIONS(2282),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2280),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_PERCENT] = ACTIONS(2280),
    [anon_sym_PIPE_PIPE] = ACTIONS(2282),
    [anon_sym_AMP_AMP] = ACTIONS(2282),
    [anon_sym_PIPE] = ACTIONS(2280),
    [anon_sym_CARET] = ACTIONS(2280),
    [anon_sym_AMP] = ACTIONS(2280),
    [anon_sym_EQ_EQ] = ACTIONS(2282),
    [anon_sym_BANG_EQ] = ACTIONS(2282),
    [anon_sym_GT] = ACTIONS(2280),
    [anon_sym_GT_EQ] = ACTIONS(2282),
    [anon_sym_LT_EQ] = ACTIONS(2280),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_LT_LT] = ACTIONS(2280),
    [anon_sym_GT_GT] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(2280),
    [anon_sym_in] = ACTIONS(2280),
    [anon_sym_out] = ACTIONS(2280),
    [anon_sym_inout] = ACTIONS(2280),
    [anon_sym_virtual] = ACTIONS(2280),
    [anon_sym_extern] = ACTIONS(2280),
    [anon_sym___attribute__] = ACTIONS(2280),
    [anon_sym___attribute] = ACTIONS(2280),
    [anon_sym_COLON_COLON] = ACTIONS(2282),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2282),
    [anon_sym___declspec] = ACTIONS(2280),
    [anon_sym___based] = ACTIONS(2280),
    [anon_sym___cdecl] = ACTIONS(2280),
    [anon_sym___clrcall] = ACTIONS(2280),
    [anon_sym___stdcall] = ACTIONS(2280),
    [anon_sym___fastcall] = ACTIONS(2280),
    [anon_sym___thiscall] = ACTIONS(2280),
    [anon_sym___vectorcall] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_RBRACE] = ACTIONS(2282),
    [anon_sym_LBRACK] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_EQ] = ACTIONS(2280),
    [anon_sym_register] = ACTIONS(2280),
    [anon_sym_inline] = ACTIONS(2280),
    [anon_sym___inline] = ACTIONS(2280),
    [anon_sym___inline__] = ACTIONS(2280),
    [anon_sym___forceinline] = ACTIONS(2280),
    [anon_sym_thread_local] = ACTIONS(2280),
    [anon_sym___thread] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_constexpr] = ACTIONS(2280),
    [anon_sym_volatile] = ACTIONS(2280),
    [anon_sym_restrict] = ACTIONS(2280),
    [anon_sym___restrict__] = ACTIONS(2280),
    [anon_sym__Atomic] = ACTIONS(2280),
    [anon_sym__Noreturn] = ACTIONS(2280),
    [anon_sym_noreturn] = ACTIONS(2280),
    [anon_sym__Nonnull] = ACTIONS(2280),
    [anon_sym_mutable] = ACTIONS(2280),
    [anon_sym_constinit] = ACTIONS(2280),
    [anon_sym_consteval] = ACTIONS(2280),
    [anon_sym_alignas] = ACTIONS(2280),
    [anon_sym__Alignas] = ACTIONS(2280),
    [anon_sym_QMARK] = ACTIONS(2282),
    [anon_sym_STAR_EQ] = ACTIONS(2282),
    [anon_sym_SLASH_EQ] = ACTIONS(2282),
    [anon_sym_PERCENT_EQ] = ACTIONS(2282),
    [anon_sym_PLUS_EQ] = ACTIONS(2282),
    [anon_sym_DASH_EQ] = ACTIONS(2282),
    [anon_sym_LT_LT_EQ] = ACTIONS(2282),
    [anon_sym_GT_GT_EQ] = ACTIONS(2282),
    [anon_sym_AMP_EQ] = ACTIONS(2282),
    [anon_sym_CARET_EQ] = ACTIONS(2282),
    [anon_sym_PIPE_EQ] = ACTIONS(2282),
    [anon_sym_and_eq] = ACTIONS(2280),
    [anon_sym_or_eq] = ACTIONS(2280),
    [anon_sym_xor_eq] = ACTIONS(2280),
    [anon_sym_LT_EQ_GT] = ACTIONS(2282),
    [anon_sym_or] = ACTIONS(2280),
    [anon_sym_and] = ACTIONS(2280),
    [anon_sym_bitor] = ACTIONS(2280),
    [anon_sym_xor] = ACTIONS(2280),
    [anon_sym_bitand] = ACTIONS(2280),
    [anon_sym_not_eq] = ACTIONS(2280),
    [anon_sym_is] = ACTIONS(2280),
    [anon_sym_as] = ACTIONS(2280),
    [anon_sym_DASH_DASH] = ACTIONS(2282),
    [anon_sym_PLUS_PLUS] = ACTIONS(2282),
    [anon_sym_DOT] = ACTIONS(2280),
    [anon_sym_DOT_STAR] = ACTIONS(2282),
    [anon_sym_DASH_GT] = ACTIONS(2282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_This] = ACTIONS(2280),
    [anon_sym_decltype] = ACTIONS(2280),
    [anon_sym_template] = ACTIONS(2280),
    [anon_sym_operator] = ACTIONS(2280),
    [anon_sym_precise] = ACTIONS(2280),
    [anon_sym_shared] = ACTIONS(2280),
    [anon_sym_groupshared] = ACTIONS(2280),
    [anon_sym_uniform] = ACTIONS(2280),
    [anon_sym_row_major] = ACTIONS(2280),
    [anon_sym_column_major] = ACTIONS(2280),
    [anon_sym_globallycoherent] = ACTIONS(2280),
    [anon_sym_centroid] = ACTIONS(2280),
    [anon_sym_noperspective] = ACTIONS(2280),
    [anon_sym_nointerpolation] = ACTIONS(2280),
    [anon_sym_sample] = ACTIONS(2280),
    [anon_sym_linear] = ACTIONS(2280),
    [anon_sym_snorm] = ACTIONS(2280),
    [anon_sym_unorm] = ACTIONS(2280),
    [anon_sym_point] = ACTIONS(2280),
    [anon_sym_line] = ACTIONS(2280),
    [anon_sym_triangleadj] = ACTIONS(2280),
    [anon_sym_lineadj] = ACTIONS(2280),
    [anon_sym_triangle] = ACTIONS(2280),
  },
  [1454] = {
    [sym_identifier] = ACTIONS(2284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2286),
    [anon_sym_COMMA] = ACTIONS(2286),
    [anon_sym_RPAREN] = ACTIONS(2286),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2284),
    [anon_sym_SLASH] = ACTIONS(2284),
    [anon_sym_PERCENT] = ACTIONS(2284),
    [anon_sym_PIPE_PIPE] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2284),
    [anon_sym_CARET] = ACTIONS(2284),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_EQ_EQ] = ACTIONS(2286),
    [anon_sym_BANG_EQ] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2284),
    [anon_sym_GT_EQ] = ACTIONS(2286),
    [anon_sym_LT_EQ] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2284),
    [anon_sym_LT_LT] = ACTIONS(2284),
    [anon_sym_GT_GT] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_in] = ACTIONS(2284),
    [anon_sym_out] = ACTIONS(2284),
    [anon_sym_inout] = ACTIONS(2284),
    [anon_sym_virtual] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym___cdecl] = ACTIONS(2284),
    [anon_sym___clrcall] = ACTIONS(2284),
    [anon_sym___stdcall] = ACTIONS(2284),
    [anon_sym___fastcall] = ACTIONS(2284),
    [anon_sym___thiscall] = ACTIONS(2284),
    [anon_sym___vectorcall] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_EQ] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [anon_sym_QMARK] = ACTIONS(2286),
    [anon_sym_STAR_EQ] = ACTIONS(2286),
    [anon_sym_SLASH_EQ] = ACTIONS(2286),
    [anon_sym_PERCENT_EQ] = ACTIONS(2286),
    [anon_sym_PLUS_EQ] = ACTIONS(2286),
    [anon_sym_DASH_EQ] = ACTIONS(2286),
    [anon_sym_LT_LT_EQ] = ACTIONS(2286),
    [anon_sym_GT_GT_EQ] = ACTIONS(2286),
    [anon_sym_AMP_EQ] = ACTIONS(2286),
    [anon_sym_CARET_EQ] = ACTIONS(2286),
    [anon_sym_PIPE_EQ] = ACTIONS(2286),
    [anon_sym_and_eq] = ACTIONS(2284),
    [anon_sym_or_eq] = ACTIONS(2284),
    [anon_sym_xor_eq] = ACTIONS(2284),
    [anon_sym_LT_EQ_GT] = ACTIONS(2286),
    [anon_sym_or] = ACTIONS(2284),
    [anon_sym_and] = ACTIONS(2284),
    [anon_sym_bitor] = ACTIONS(2284),
    [anon_sym_xor] = ACTIONS(2284),
    [anon_sym_bitand] = ACTIONS(2284),
    [anon_sym_not_eq] = ACTIONS(2284),
    [anon_sym_is] = ACTIONS(2284),
    [anon_sym_as] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_DOT] = ACTIONS(2284),
    [anon_sym_DOT_STAR] = ACTIONS(2286),
    [anon_sym_DASH_GT] = ACTIONS(2286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_This] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_precise] = ACTIONS(2284),
    [anon_sym_shared] = ACTIONS(2284),
    [anon_sym_groupshared] = ACTIONS(2284),
    [anon_sym_uniform] = ACTIONS(2284),
    [anon_sym_row_major] = ACTIONS(2284),
    [anon_sym_column_major] = ACTIONS(2284),
    [anon_sym_globallycoherent] = ACTIONS(2284),
    [anon_sym_centroid] = ACTIONS(2284),
    [anon_sym_noperspective] = ACTIONS(2284),
    [anon_sym_nointerpolation] = ACTIONS(2284),
    [anon_sym_sample] = ACTIONS(2284),
    [anon_sym_linear] = ACTIONS(2284),
    [anon_sym_snorm] = ACTIONS(2284),
    [anon_sym_unorm] = ACTIONS(2284),
    [anon_sym_point] = ACTIONS(2284),
    [anon_sym_line] = ACTIONS(2284),
    [anon_sym_triangleadj] = ACTIONS(2284),
    [anon_sym_lineadj] = ACTIONS(2284),
    [anon_sym_triangle] = ACTIONS(2284),
  },
  [1455] = {
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2290),
    [anon_sym_COMMA] = ACTIONS(2290),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_PERCENT] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_CARET] = ACTIONS(2288),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_EQ_EQ] = ACTIONS(2290),
    [anon_sym_BANG_EQ] = ACTIONS(2290),
    [anon_sym_GT] = ACTIONS(2288),
    [anon_sym_GT_EQ] = ACTIONS(2290),
    [anon_sym_LT_EQ] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(2288),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_out] = ACTIONS(2288),
    [anon_sym_inout] = ACTIONS(2288),
    [anon_sym_virtual] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym___cdecl] = ACTIONS(2288),
    [anon_sym___clrcall] = ACTIONS(2288),
    [anon_sym___stdcall] = ACTIONS(2288),
    [anon_sym___fastcall] = ACTIONS(2288),
    [anon_sym___thiscall] = ACTIONS(2288),
    [anon_sym___vectorcall] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_RBRACE] = ACTIONS(2290),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_EQ] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [anon_sym_QMARK] = ACTIONS(2290),
    [anon_sym_STAR_EQ] = ACTIONS(2290),
    [anon_sym_SLASH_EQ] = ACTIONS(2290),
    [anon_sym_PERCENT_EQ] = ACTIONS(2290),
    [anon_sym_PLUS_EQ] = ACTIONS(2290),
    [anon_sym_DASH_EQ] = ACTIONS(2290),
    [anon_sym_LT_LT_EQ] = ACTIONS(2290),
    [anon_sym_GT_GT_EQ] = ACTIONS(2290),
    [anon_sym_AMP_EQ] = ACTIONS(2290),
    [anon_sym_CARET_EQ] = ACTIONS(2290),
    [anon_sym_PIPE_EQ] = ACTIONS(2290),
    [anon_sym_and_eq] = ACTIONS(2288),
    [anon_sym_or_eq] = ACTIONS(2288),
    [anon_sym_xor_eq] = ACTIONS(2288),
    [anon_sym_LT_EQ_GT] = ACTIONS(2290),
    [anon_sym_or] = ACTIONS(2288),
    [anon_sym_and] = ACTIONS(2288),
    [anon_sym_bitor] = ACTIONS(2288),
    [anon_sym_xor] = ACTIONS(2288),
    [anon_sym_bitand] = ACTIONS(2288),
    [anon_sym_not_eq] = ACTIONS(2288),
    [anon_sym_is] = ACTIONS(2288),
    [anon_sym_as] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_DOT] = ACTIONS(2288),
    [anon_sym_DOT_STAR] = ACTIONS(2290),
    [anon_sym_DASH_GT] = ACTIONS(2290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_This] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_precise] = ACTIONS(2288),
    [anon_sym_shared] = ACTIONS(2288),
    [anon_sym_groupshared] = ACTIONS(2288),
    [anon_sym_uniform] = ACTIONS(2288),
    [anon_sym_row_major] = ACTIONS(2288),
    [anon_sym_column_major] = ACTIONS(2288),
    [anon_sym_globallycoherent] = ACTIONS(2288),
    [anon_sym_centroid] = ACTIONS(2288),
    [anon_sym_noperspective] = ACTIONS(2288),
    [anon_sym_nointerpolation] = ACTIONS(2288),
    [anon_sym_sample] = ACTIONS(2288),
    [anon_sym_linear] = ACTIONS(2288),
    [anon_sym_snorm] = ACTIONS(2288),
    [anon_sym_unorm] = ACTIONS(2288),
    [anon_sym_point] = ACTIONS(2288),
    [anon_sym_line] = ACTIONS(2288),
    [anon_sym_triangleadj] = ACTIONS(2288),
    [anon_sym_lineadj] = ACTIONS(2288),
    [anon_sym_triangle] = ACTIONS(2288),
  },
  [1456] = {
    [sym_identifier] = ACTIONS(2243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2245),
    [anon_sym_COMMA] = ACTIONS(2245),
    [anon_sym_LPAREN2] = ACTIONS(2247),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_SLASH] = ACTIONS(2255),
    [anon_sym_PERCENT] = ACTIONS(2255),
    [anon_sym_PIPE_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2255),
    [anon_sym_CARET] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2245),
    [anon_sym_BANG_EQ] = ACTIONS(2245),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_GT_EQ] = ACTIONS(2245),
    [anon_sym_LT_EQ] = ACTIONS(2255),
    [anon_sym_LT] = ACTIONS(2255),
    [anon_sym_LT_LT] = ACTIONS(2255),
    [anon_sym_GT_GT] = ACTIONS(2255),
    [anon_sym_SEMI] = ACTIONS(2247),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_out] = ACTIONS(2243),
    [anon_sym_inout] = ACTIONS(2243),
    [anon_sym_virtual] = ACTIONS(2243),
    [anon_sym_extern] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym___attribute] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2247),
    [anon_sym___declspec] = ACTIONS(2243),
    [anon_sym___based] = ACTIONS(2243),
    [anon_sym___cdecl] = ACTIONS(2243),
    [anon_sym___clrcall] = ACTIONS(2243),
    [anon_sym___stdcall] = ACTIONS(2243),
    [anon_sym___fastcall] = ACTIONS(2243),
    [anon_sym___thiscall] = ACTIONS(2243),
    [anon_sym___vectorcall] = ACTIONS(2243),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2245),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_EQ] = ACTIONS(2255),
    [anon_sym_register] = ACTIONS(2243),
    [anon_sym_inline] = ACTIONS(2243),
    [anon_sym___inline] = ACTIONS(2243),
    [anon_sym___inline__] = ACTIONS(2243),
    [anon_sym___forceinline] = ACTIONS(2243),
    [anon_sym_thread_local] = ACTIONS(2243),
    [anon_sym___thread] = ACTIONS(2243),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym__Nonnull] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [anon_sym_QMARK] = ACTIONS(2245),
    [anon_sym_STAR_EQ] = ACTIONS(2245),
    [anon_sym_SLASH_EQ] = ACTIONS(2245),
    [anon_sym_PERCENT_EQ] = ACTIONS(2245),
    [anon_sym_PLUS_EQ] = ACTIONS(2245),
    [anon_sym_DASH_EQ] = ACTIONS(2245),
    [anon_sym_LT_LT_EQ] = ACTIONS(2245),
    [anon_sym_GT_GT_EQ] = ACTIONS(2245),
    [anon_sym_AMP_EQ] = ACTIONS(2245),
    [anon_sym_CARET_EQ] = ACTIONS(2245),
    [anon_sym_PIPE_EQ] = ACTIONS(2245),
    [anon_sym_and_eq] = ACTIONS(2255),
    [anon_sym_or_eq] = ACTIONS(2255),
    [anon_sym_xor_eq] = ACTIONS(2255),
    [anon_sym_LT_EQ_GT] = ACTIONS(2245),
    [anon_sym_or] = ACTIONS(2255),
    [anon_sym_and] = ACTIONS(2255),
    [anon_sym_bitor] = ACTIONS(2255),
    [anon_sym_xor] = ACTIONS(2255),
    [anon_sym_bitand] = ACTIONS(2255),
    [anon_sym_not_eq] = ACTIONS(2255),
    [anon_sym_is] = ACTIONS(2255),
    [anon_sym_as] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2245),
    [anon_sym_PLUS_PLUS] = ACTIONS(2245),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2245),
    [anon_sym_DASH_GT] = ACTIONS(2245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2243),
    [anon_sym_let] = ACTIONS(2243),
    [anon_sym_This] = ACTIONS(2243),
    [anon_sym_decltype] = ACTIONS(2243),
    [anon_sym_template] = ACTIONS(2243),
    [anon_sym_operator] = ACTIONS(2243),
    [anon_sym_precise] = ACTIONS(2243),
    [anon_sym_shared] = ACTIONS(2243),
    [anon_sym_groupshared] = ACTIONS(2243),
    [anon_sym_uniform] = ACTIONS(2243),
    [anon_sym_row_major] = ACTIONS(2243),
    [anon_sym_column_major] = ACTIONS(2243),
    [anon_sym_globallycoherent] = ACTIONS(2243),
    [anon_sym_centroid] = ACTIONS(2243),
    [anon_sym_noperspective] = ACTIONS(2243),
    [anon_sym_nointerpolation] = ACTIONS(2243),
    [anon_sym_sample] = ACTIONS(2243),
    [anon_sym_linear] = ACTIONS(2243),
    [anon_sym_snorm] = ACTIONS(2243),
    [anon_sym_unorm] = ACTIONS(2243),
    [anon_sym_point] = ACTIONS(2243),
    [anon_sym_line] = ACTIONS(2243),
    [anon_sym_triangleadj] = ACTIONS(2243),
    [anon_sym_lineadj] = ACTIONS(2243),
    [anon_sym_triangle] = ACTIONS(2243),
  },
  [1457] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6848),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8895),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8054),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_parameter_list] = STATE(1193),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(3259),
    [sym_template_function] = STATE(8054),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7282),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5532),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5536),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(2861),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1458] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6824),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8806),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8054),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_parameter_list] = STATE(1191),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(3259),
    [sym_template_function] = STATE(8054),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7282),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5532),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5536),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(2861),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1459] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6844),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8874),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8054),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_parameter_list] = STATE(1192),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(3259),
    [sym_template_function] = STATE(8054),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7282),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5532),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5536),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(2861),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1460] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6864),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8834),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8054),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_parameter_list] = STATE(1187),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(3259),
    [sym_template_function] = STATE(8054),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7282),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5532),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5536),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(2861),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1461] = {
    [sym_identifier] = ACTIONS(3889),
    [anon_sym_LPAREN2] = ACTIONS(3891),
    [anon_sym_BANG] = ACTIONS(3891),
    [anon_sym_TILDE] = ACTIONS(3891),
    [anon_sym_DASH] = ACTIONS(3889),
    [anon_sym_PLUS] = ACTIONS(3889),
    [anon_sym_STAR] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3891),
    [anon_sym___extension__] = ACTIONS(3889),
    [anon_sym_in] = ACTIONS(3889),
    [anon_sym_out] = ACTIONS(3889),
    [anon_sym_inout] = ACTIONS(3889),
    [anon_sym_virtual] = ACTIONS(3889),
    [anon_sym_extern] = ACTIONS(3889),
    [anon_sym___attribute__] = ACTIONS(3889),
    [anon_sym___attribute] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3891),
    [anon_sym___declspec] = ACTIONS(3889),
    [anon_sym_signed] = ACTIONS(3889),
    [anon_sym_unsigned] = ACTIONS(3889),
    [anon_sym_long] = ACTIONS(3889),
    [anon_sym_short] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_static] = ACTIONS(3889),
    [anon_sym_register] = ACTIONS(3889),
    [anon_sym_inline] = ACTIONS(3889),
    [anon_sym___inline] = ACTIONS(3889),
    [anon_sym___inline__] = ACTIONS(3889),
    [anon_sym___forceinline] = ACTIONS(3889),
    [anon_sym_thread_local] = ACTIONS(3889),
    [anon_sym___thread] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3889),
    [anon_sym_constexpr] = ACTIONS(3889),
    [anon_sym_volatile] = ACTIONS(3889),
    [anon_sym_restrict] = ACTIONS(3889),
    [anon_sym___restrict__] = ACTIONS(3889),
    [anon_sym__Atomic] = ACTIONS(3889),
    [anon_sym__Noreturn] = ACTIONS(3889),
    [anon_sym_noreturn] = ACTIONS(3889),
    [anon_sym__Nonnull] = ACTIONS(3889),
    [anon_sym_mutable] = ACTIONS(3889),
    [anon_sym_constinit] = ACTIONS(3889),
    [anon_sym_consteval] = ACTIONS(3889),
    [anon_sym_alignas] = ACTIONS(3889),
    [anon_sym__Alignas] = ACTIONS(3889),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_enum] = ACTIONS(3889),
    [anon_sym_class] = ACTIONS(3889),
    [anon_sym_struct] = ACTIONS(3889),
    [anon_sym_union] = ACTIONS(3889),
    [anon_sym_not] = ACTIONS(3889),
    [anon_sym_compl] = ACTIONS(3889),
    [anon_sym_DASH_DASH] = ACTIONS(3891),
    [anon_sym_PLUS_PLUS] = ACTIONS(3891),
    [anon_sym_sizeof] = ACTIONS(3889),
    [anon_sym___alignof__] = ACTIONS(3889),
    [anon_sym___alignof] = ACTIONS(3889),
    [anon_sym__alignof] = ACTIONS(3889),
    [anon_sym_alignof] = ACTIONS(3889),
    [anon_sym__Alignof] = ACTIONS(3889),
    [anon_sym_offsetof] = ACTIONS(3889),
    [anon_sym__Generic] = ACTIONS(3889),
    [anon_sym_asm] = ACTIONS(3889),
    [anon_sym___asm__] = ACTIONS(3889),
    [anon_sym___asm] = ACTIONS(3889),
    [sym_number_literal] = ACTIONS(3891),
    [anon_sym_L_SQUOTE] = ACTIONS(3891),
    [anon_sym_u_SQUOTE] = ACTIONS(3891),
    [anon_sym_U_SQUOTE] = ACTIONS(3891),
    [anon_sym_u8_SQUOTE] = ACTIONS(3891),
    [anon_sym_SQUOTE] = ACTIONS(3891),
    [anon_sym_L_DQUOTE] = ACTIONS(3891),
    [anon_sym_u_DQUOTE] = ACTIONS(3891),
    [anon_sym_U_DQUOTE] = ACTIONS(3891),
    [anon_sym_u8_DQUOTE] = ACTIONS(3891),
    [anon_sym_DQUOTE] = ACTIONS(3891),
    [sym_true] = ACTIONS(3889),
    [sym_false] = ACTIONS(3889),
    [anon_sym_NULL] = ACTIONS(3889),
    [anon_sym_nullptr] = ACTIONS(3889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_This] = ACTIONS(3889),
    [anon_sym_decltype] = ACTIONS(3889),
    [anon_sym_typename] = ACTIONS(3889),
    [anon_sym_template] = ACTIONS(3889),
    [anon_sym_delete] = ACTIONS(3889),
    [anon_sym_R_DQUOTE] = ACTIONS(3891),
    [anon_sym_LR_DQUOTE] = ACTIONS(3891),
    [anon_sym_uR_DQUOTE] = ACTIONS(3891),
    [anon_sym_UR_DQUOTE] = ACTIONS(3891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3891),
    [anon_sym_co_await] = ACTIONS(3889),
    [anon_sym_new] = ACTIONS(3889),
    [anon_sym_requires] = ACTIONS(3889),
    [sym_this] = ACTIONS(3889),
    [anon_sym_precise] = ACTIONS(3889),
    [anon_sym_shared] = ACTIONS(3889),
    [anon_sym_groupshared] = ACTIONS(3889),
    [anon_sym_uniform] = ACTIONS(3889),
    [anon_sym_row_major] = ACTIONS(3889),
    [anon_sym_column_major] = ACTIONS(3889),
    [anon_sym_globallycoherent] = ACTIONS(3889),
    [anon_sym_centroid] = ACTIONS(3889),
    [anon_sym_noperspective] = ACTIONS(3889),
    [anon_sym_nointerpolation] = ACTIONS(3889),
    [anon_sym_sample] = ACTIONS(3889),
    [anon_sym_linear] = ACTIONS(3889),
    [anon_sym_snorm] = ACTIONS(3889),
    [anon_sym_unorm] = ACTIONS(3889),
    [anon_sym_point] = ACTIONS(3889),
    [anon_sym_line] = ACTIONS(3889),
    [anon_sym_triangleadj] = ACTIONS(3889),
    [anon_sym_lineadj] = ACTIONS(3889),
    [anon_sym_triangle] = ACTIONS(3889),
    [anon_sym_interface] = ACTIONS(3889),
    [anon_sym_extension] = ACTIONS(3889),
  },
  [1462] = {
    [sym_identifier] = ACTIONS(4024),
    [anon_sym_LPAREN2] = ACTIONS(4029),
    [anon_sym_BANG] = ACTIONS(4029),
    [anon_sym_TILDE] = ACTIONS(4029),
    [anon_sym_DASH] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4024),
    [anon_sym_STAR] = ACTIONS(4029),
    [anon_sym_AMP] = ACTIONS(4029),
    [anon_sym___extension__] = ACTIONS(4024),
    [anon_sym_in] = ACTIONS(4024),
    [anon_sym_out] = ACTIONS(4024),
    [anon_sym_inout] = ACTIONS(4024),
    [anon_sym_virtual] = ACTIONS(4024),
    [anon_sym_extern] = ACTIONS(4024),
    [anon_sym___attribute__] = ACTIONS(4024),
    [anon_sym___attribute] = ACTIONS(4024),
    [anon_sym_COLON_COLON] = ACTIONS(4029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4029),
    [anon_sym___declspec] = ACTIONS(4024),
    [anon_sym_signed] = ACTIONS(4024),
    [anon_sym_unsigned] = ACTIONS(4024),
    [anon_sym_long] = ACTIONS(4024),
    [anon_sym_short] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_static] = ACTIONS(4024),
    [anon_sym_register] = ACTIONS(4024),
    [anon_sym_inline] = ACTIONS(4024),
    [anon_sym___inline] = ACTIONS(4024),
    [anon_sym___inline__] = ACTIONS(4024),
    [anon_sym___forceinline] = ACTIONS(4024),
    [anon_sym_thread_local] = ACTIONS(4024),
    [anon_sym___thread] = ACTIONS(4024),
    [anon_sym_const] = ACTIONS(4024),
    [anon_sym_constexpr] = ACTIONS(4024),
    [anon_sym_volatile] = ACTIONS(4024),
    [anon_sym_restrict] = ACTIONS(4024),
    [anon_sym___restrict__] = ACTIONS(4024),
    [anon_sym__Atomic] = ACTIONS(4024),
    [anon_sym__Noreturn] = ACTIONS(4024),
    [anon_sym_noreturn] = ACTIONS(4024),
    [anon_sym__Nonnull] = ACTIONS(4024),
    [anon_sym_mutable] = ACTIONS(4024),
    [anon_sym_constinit] = ACTIONS(4024),
    [anon_sym_consteval] = ACTIONS(4024),
    [anon_sym_alignas] = ACTIONS(4024),
    [anon_sym__Alignas] = ACTIONS(4024),
    [sym_primitive_type] = ACTIONS(4024),
    [anon_sym_enum] = ACTIONS(4024),
    [anon_sym_class] = ACTIONS(4024),
    [anon_sym_struct] = ACTIONS(4024),
    [anon_sym_union] = ACTIONS(4024),
    [anon_sym_not] = ACTIONS(4024),
    [anon_sym_compl] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4029),
    [anon_sym_PLUS_PLUS] = ACTIONS(4029),
    [anon_sym_sizeof] = ACTIONS(4024),
    [anon_sym___alignof__] = ACTIONS(4024),
    [anon_sym___alignof] = ACTIONS(4024),
    [anon_sym__alignof] = ACTIONS(4024),
    [anon_sym_alignof] = ACTIONS(4024),
    [anon_sym__Alignof] = ACTIONS(4024),
    [anon_sym_offsetof] = ACTIONS(4024),
    [anon_sym__Generic] = ACTIONS(4024),
    [anon_sym_asm] = ACTIONS(4024),
    [anon_sym___asm__] = ACTIONS(4024),
    [anon_sym___asm] = ACTIONS(4024),
    [sym_number_literal] = ACTIONS(4029),
    [anon_sym_L_SQUOTE] = ACTIONS(4029),
    [anon_sym_u_SQUOTE] = ACTIONS(4029),
    [anon_sym_U_SQUOTE] = ACTIONS(4029),
    [anon_sym_u8_SQUOTE] = ACTIONS(4029),
    [anon_sym_SQUOTE] = ACTIONS(4029),
    [anon_sym_L_DQUOTE] = ACTIONS(4029),
    [anon_sym_u_DQUOTE] = ACTIONS(4029),
    [anon_sym_U_DQUOTE] = ACTIONS(4029),
    [anon_sym_u8_DQUOTE] = ACTIONS(4029),
    [anon_sym_DQUOTE] = ACTIONS(4029),
    [sym_true] = ACTIONS(4024),
    [sym_false] = ACTIONS(4024),
    [anon_sym_NULL] = ACTIONS(4024),
    [anon_sym_nullptr] = ACTIONS(4024),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4024),
    [anon_sym_let] = ACTIONS(4024),
    [anon_sym_This] = ACTIONS(4024),
    [anon_sym_decltype] = ACTIONS(4024),
    [anon_sym_typename] = ACTIONS(4024),
    [anon_sym_template] = ACTIONS(4024),
    [anon_sym_delete] = ACTIONS(4024),
    [anon_sym_R_DQUOTE] = ACTIONS(4029),
    [anon_sym_LR_DQUOTE] = ACTIONS(4029),
    [anon_sym_uR_DQUOTE] = ACTIONS(4029),
    [anon_sym_UR_DQUOTE] = ACTIONS(4029),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4029),
    [anon_sym_co_await] = ACTIONS(4024),
    [anon_sym_new] = ACTIONS(4024),
    [anon_sym_requires] = ACTIONS(4024),
    [sym_this] = ACTIONS(4024),
    [anon_sym_precise] = ACTIONS(4024),
    [anon_sym_shared] = ACTIONS(4024),
    [anon_sym_groupshared] = ACTIONS(4024),
    [anon_sym_uniform] = ACTIONS(4024),
    [anon_sym_row_major] = ACTIONS(4024),
    [anon_sym_column_major] = ACTIONS(4024),
    [anon_sym_globallycoherent] = ACTIONS(4024),
    [anon_sym_centroid] = ACTIONS(4024),
    [anon_sym_noperspective] = ACTIONS(4024),
    [anon_sym_nointerpolation] = ACTIONS(4024),
    [anon_sym_sample] = ACTIONS(4024),
    [anon_sym_linear] = ACTIONS(4024),
    [anon_sym_snorm] = ACTIONS(4024),
    [anon_sym_unorm] = ACTIONS(4024),
    [anon_sym_point] = ACTIONS(4024),
    [anon_sym_line] = ACTIONS(4024),
    [anon_sym_triangleadj] = ACTIONS(4024),
    [anon_sym_lineadj] = ACTIONS(4024),
    [anon_sym_triangle] = ACTIONS(4024),
    [anon_sym_interface] = ACTIONS(4024),
    [anon_sym_extension] = ACTIONS(4024),
  },
  [1463] = {
    [sym_identifier] = ACTIONS(3763),
    [anon_sym_LPAREN2] = ACTIONS(3765),
    [anon_sym_BANG] = ACTIONS(3765),
    [anon_sym_TILDE] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3763),
    [anon_sym_STAR] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3765),
    [anon_sym___extension__] = ACTIONS(3763),
    [anon_sym_in] = ACTIONS(3763),
    [anon_sym_out] = ACTIONS(3763),
    [anon_sym_inout] = ACTIONS(3763),
    [anon_sym_virtual] = ACTIONS(3763),
    [anon_sym_extern] = ACTIONS(3763),
    [anon_sym___attribute__] = ACTIONS(3763),
    [anon_sym___attribute] = ACTIONS(3763),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3765),
    [anon_sym___declspec] = ACTIONS(3763),
    [anon_sym_signed] = ACTIONS(3763),
    [anon_sym_unsigned] = ACTIONS(3763),
    [anon_sym_long] = ACTIONS(3763),
    [anon_sym_short] = ACTIONS(3763),
    [anon_sym_LBRACK] = ACTIONS(3763),
    [anon_sym_static] = ACTIONS(3763),
    [anon_sym_register] = ACTIONS(3763),
    [anon_sym_inline] = ACTIONS(3763),
    [anon_sym___inline] = ACTIONS(3763),
    [anon_sym___inline__] = ACTIONS(3763),
    [anon_sym___forceinline] = ACTIONS(3763),
    [anon_sym_thread_local] = ACTIONS(3763),
    [anon_sym___thread] = ACTIONS(3763),
    [anon_sym_const] = ACTIONS(3763),
    [anon_sym_constexpr] = ACTIONS(3763),
    [anon_sym_volatile] = ACTIONS(3763),
    [anon_sym_restrict] = ACTIONS(3763),
    [anon_sym___restrict__] = ACTIONS(3763),
    [anon_sym__Atomic] = ACTIONS(3763),
    [anon_sym__Noreturn] = ACTIONS(3763),
    [anon_sym_noreturn] = ACTIONS(3763),
    [anon_sym__Nonnull] = ACTIONS(3763),
    [anon_sym_mutable] = ACTIONS(3763),
    [anon_sym_constinit] = ACTIONS(3763),
    [anon_sym_consteval] = ACTIONS(3763),
    [anon_sym_alignas] = ACTIONS(3763),
    [anon_sym__Alignas] = ACTIONS(3763),
    [sym_primitive_type] = ACTIONS(3763),
    [anon_sym_enum] = ACTIONS(3763),
    [anon_sym_class] = ACTIONS(3763),
    [anon_sym_struct] = ACTIONS(3763),
    [anon_sym_union] = ACTIONS(3763),
    [anon_sym_not] = ACTIONS(3763),
    [anon_sym_compl] = ACTIONS(3763),
    [anon_sym_DASH_DASH] = ACTIONS(3765),
    [anon_sym_PLUS_PLUS] = ACTIONS(3765),
    [anon_sym_sizeof] = ACTIONS(3763),
    [anon_sym___alignof__] = ACTIONS(3763),
    [anon_sym___alignof] = ACTIONS(3763),
    [anon_sym__alignof] = ACTIONS(3763),
    [anon_sym_alignof] = ACTIONS(3763),
    [anon_sym__Alignof] = ACTIONS(3763),
    [anon_sym_offsetof] = ACTIONS(3763),
    [anon_sym__Generic] = ACTIONS(3763),
    [anon_sym_asm] = ACTIONS(3763),
    [anon_sym___asm__] = ACTIONS(3763),
    [anon_sym___asm] = ACTIONS(3763),
    [sym_number_literal] = ACTIONS(3765),
    [anon_sym_L_SQUOTE] = ACTIONS(3765),
    [anon_sym_u_SQUOTE] = ACTIONS(3765),
    [anon_sym_U_SQUOTE] = ACTIONS(3765),
    [anon_sym_u8_SQUOTE] = ACTIONS(3765),
    [anon_sym_SQUOTE] = ACTIONS(3765),
    [anon_sym_L_DQUOTE] = ACTIONS(3765),
    [anon_sym_u_DQUOTE] = ACTIONS(3765),
    [anon_sym_U_DQUOTE] = ACTIONS(3765),
    [anon_sym_u8_DQUOTE] = ACTIONS(3765),
    [anon_sym_DQUOTE] = ACTIONS(3765),
    [sym_true] = ACTIONS(3763),
    [sym_false] = ACTIONS(3763),
    [anon_sym_NULL] = ACTIONS(3763),
    [anon_sym_nullptr] = ACTIONS(3763),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3763),
    [anon_sym_let] = ACTIONS(3763),
    [anon_sym_This] = ACTIONS(3763),
    [anon_sym_decltype] = ACTIONS(3763),
    [anon_sym_typename] = ACTIONS(3763),
    [anon_sym_template] = ACTIONS(3763),
    [anon_sym_delete] = ACTIONS(3763),
    [anon_sym_R_DQUOTE] = ACTIONS(3765),
    [anon_sym_LR_DQUOTE] = ACTIONS(3765),
    [anon_sym_uR_DQUOTE] = ACTIONS(3765),
    [anon_sym_UR_DQUOTE] = ACTIONS(3765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3765),
    [anon_sym_co_await] = ACTIONS(3763),
    [anon_sym_new] = ACTIONS(3763),
    [anon_sym_requires] = ACTIONS(3763),
    [sym_this] = ACTIONS(3763),
    [anon_sym_precise] = ACTIONS(3763),
    [anon_sym_shared] = ACTIONS(3763),
    [anon_sym_groupshared] = ACTIONS(3763),
    [anon_sym_uniform] = ACTIONS(3763),
    [anon_sym_row_major] = ACTIONS(3763),
    [anon_sym_column_major] = ACTIONS(3763),
    [anon_sym_globallycoherent] = ACTIONS(3763),
    [anon_sym_centroid] = ACTIONS(3763),
    [anon_sym_noperspective] = ACTIONS(3763),
    [anon_sym_nointerpolation] = ACTIONS(3763),
    [anon_sym_sample] = ACTIONS(3763),
    [anon_sym_linear] = ACTIONS(3763),
    [anon_sym_snorm] = ACTIONS(3763),
    [anon_sym_unorm] = ACTIONS(3763),
    [anon_sym_point] = ACTIONS(3763),
    [anon_sym_line] = ACTIONS(3763),
    [anon_sym_triangleadj] = ACTIONS(3763),
    [anon_sym_lineadj] = ACTIONS(3763),
    [anon_sym_triangle] = ACTIONS(3763),
    [anon_sym_interface] = ACTIONS(3763),
    [anon_sym_extension] = ACTIONS(3763),
  },
  [1464] = {
    [sym_expression] = STATE(4697),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1465] = {
    [sym_expression] = STATE(5714),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [1466] = {
    [sym_expression] = STATE(3667),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4956),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_DASH_DASH] = ACTIONS(5544),
    [anon_sym_PLUS_PLUS] = ACTIONS(5544),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1467] = {
    [sym_expression] = STATE(3658),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4956),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_DASH_DASH] = ACTIONS(5544),
    [anon_sym_PLUS_PLUS] = ACTIONS(5544),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1468] = {
    [sym_expression] = STATE(3797),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1469] = {
    [sym_template_argument_list] = STATE(1514),
    [sym_identifier] = ACTIONS(2222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2226),
    [anon_sym_COMMA] = ACTIONS(2226),
    [anon_sym_RPAREN] = ACTIONS(2226),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2229),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2231),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_PIPE_PIPE] = ACTIONS(2224),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_EQ_EQ] = ACTIONS(2224),
    [anon_sym_BANG_EQ] = ACTIONS(2224),
    [anon_sym_GT] = ACTIONS(2234),
    [anon_sym_GT_EQ] = ACTIONS(2224),
    [anon_sym_LT_EQ] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(5546),
    [anon_sym_LT_LT] = ACTIONS(2234),
    [anon_sym_GT_GT] = ACTIONS(2234),
    [anon_sym_COLON] = ACTIONS(2222),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_virtual] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym___attribute] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2229),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym___based] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2231),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_EQ] = ACTIONS(2231),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym__Nonnull] = ACTIONS(2222),
    [anon_sym_mutable] = ACTIONS(2222),
    [anon_sym_constinit] = ACTIONS(2222),
    [anon_sym_consteval] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [anon_sym_QMARK] = ACTIONS(2224),
    [anon_sym_STAR_EQ] = ACTIONS(2224),
    [anon_sym_SLASH_EQ] = ACTIONS(2224),
    [anon_sym_PERCENT_EQ] = ACTIONS(2224),
    [anon_sym_PLUS_EQ] = ACTIONS(2224),
    [anon_sym_DASH_EQ] = ACTIONS(2224),
    [anon_sym_LT_LT_EQ] = ACTIONS(2224),
    [anon_sym_GT_GT_EQ] = ACTIONS(2224),
    [anon_sym_AMP_EQ] = ACTIONS(2224),
    [anon_sym_CARET_EQ] = ACTIONS(2224),
    [anon_sym_PIPE_EQ] = ACTIONS(2224),
    [anon_sym_and_eq] = ACTIONS(2234),
    [anon_sym_or_eq] = ACTIONS(2234),
    [anon_sym_xor_eq] = ACTIONS(2234),
    [anon_sym_LT_EQ_GT] = ACTIONS(2224),
    [anon_sym_or] = ACTIONS(2234),
    [anon_sym_and] = ACTIONS(2234),
    [anon_sym_bitor] = ACTIONS(2234),
    [anon_sym_xor] = ACTIONS(2234),
    [anon_sym_bitand] = ACTIONS(2234),
    [anon_sym_not_eq] = ACTIONS(2234),
    [anon_sym_is] = ACTIONS(2234),
    [anon_sym_as] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2224),
    [anon_sym_PLUS_PLUS] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(2231),
    [anon_sym_DOT_STAR] = ACTIONS(2224),
    [anon_sym_DASH_GT] = ACTIONS(2234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2222),
    [anon_sym_let] = ACTIONS(2222),
    [anon_sym_This] = ACTIONS(2222),
    [anon_sym_decltype] = ACTIONS(2222),
    [anon_sym_template] = ACTIONS(2222),
    [anon_sym_operator] = ACTIONS(2222),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2224),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_groupshared] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_row_major] = ACTIONS(2222),
    [anon_sym_column_major] = ACTIONS(2222),
    [anon_sym_globallycoherent] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym_nointerpolation] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_linear] = ACTIONS(2222),
    [anon_sym_snorm] = ACTIONS(2222),
    [anon_sym_unorm] = ACTIONS(2222),
    [anon_sym_point] = ACTIONS(2222),
    [anon_sym_line] = ACTIONS(2222),
    [anon_sym_triangleadj] = ACTIONS(2222),
    [anon_sym_lineadj] = ACTIONS(2222),
    [anon_sym_triangle] = ACTIONS(2222),
  },
  [1470] = {
    [sym_expression] = STATE(4284),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1471] = {
    [sym_expression] = STATE(5372),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1472] = {
    [sym_expression] = STATE(5208),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [1473] = {
    [sym_expression] = STATE(5440),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1474] = {
    [sym_expression] = STATE(5202),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [1475] = {
    [sym_expression] = STATE(3792),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1476] = {
    [sym_expression] = STATE(4247),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1477] = {
    [sym_template_argument_list] = STATE(1494),
    [sym_identifier] = ACTIONS(2222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2224),
    [anon_sym_COMMA] = ACTIONS(2224),
    [anon_sym_RPAREN] = ACTIONS(2224),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2229),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2231),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_PIPE_PIPE] = ACTIONS(2224),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_EQ_EQ] = ACTIONS(2224),
    [anon_sym_BANG_EQ] = ACTIONS(2224),
    [anon_sym_GT] = ACTIONS(2234),
    [anon_sym_GT_EQ] = ACTIONS(2224),
    [anon_sym_LT_EQ] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(5529),
    [anon_sym_LT_LT] = ACTIONS(2234),
    [anon_sym_GT_GT] = ACTIONS(2234),
    [anon_sym_SEMI] = ACTIONS(2224),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_virtual] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym___attribute] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2229),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym___based] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_RBRACE] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2231),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym__Nonnull] = ACTIONS(2222),
    [anon_sym_mutable] = ACTIONS(2222),
    [anon_sym_constinit] = ACTIONS(2222),
    [anon_sym_consteval] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [anon_sym_QMARK] = ACTIONS(2224),
    [anon_sym_STAR_EQ] = ACTIONS(2224),
    [anon_sym_SLASH_EQ] = ACTIONS(2224),
    [anon_sym_PERCENT_EQ] = ACTIONS(2224),
    [anon_sym_PLUS_EQ] = ACTIONS(2224),
    [anon_sym_DASH_EQ] = ACTIONS(2224),
    [anon_sym_LT_LT_EQ] = ACTIONS(2224),
    [anon_sym_GT_GT_EQ] = ACTIONS(2224),
    [anon_sym_AMP_EQ] = ACTIONS(2224),
    [anon_sym_CARET_EQ] = ACTIONS(2224),
    [anon_sym_PIPE_EQ] = ACTIONS(2224),
    [anon_sym_and_eq] = ACTIONS(2234),
    [anon_sym_or_eq] = ACTIONS(2234),
    [anon_sym_xor_eq] = ACTIONS(2234),
    [anon_sym_LT_EQ_GT] = ACTIONS(2224),
    [anon_sym_or] = ACTIONS(2234),
    [anon_sym_and] = ACTIONS(2234),
    [anon_sym_bitor] = ACTIONS(2234),
    [anon_sym_xor] = ACTIONS(2234),
    [anon_sym_bitand] = ACTIONS(2234),
    [anon_sym_not_eq] = ACTIONS(2234),
    [anon_sym_is] = ACTIONS(2234),
    [anon_sym_as] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2224),
    [anon_sym_PLUS_PLUS] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(2231),
    [anon_sym_DOT_STAR] = ACTIONS(2224),
    [anon_sym_DASH_GT] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2222),
    [anon_sym_let] = ACTIONS(2222),
    [anon_sym_This] = ACTIONS(2222),
    [anon_sym_decltype] = ACTIONS(2222),
    [anon_sym_template] = ACTIONS(2222),
    [anon_sym_operator] = ACTIONS(2222),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_groupshared] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_row_major] = ACTIONS(2222),
    [anon_sym_column_major] = ACTIONS(2222),
    [anon_sym_globallycoherent] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym_nointerpolation] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_linear] = ACTIONS(2222),
    [anon_sym_snorm] = ACTIONS(2222),
    [anon_sym_unorm] = ACTIONS(2222),
    [anon_sym_point] = ACTIONS(2222),
    [anon_sym_line] = ACTIONS(2222),
    [anon_sym_triangleadj] = ACTIONS(2222),
    [anon_sym_lineadj] = ACTIONS(2222),
    [anon_sym_triangle] = ACTIONS(2222),
  },
  [1478] = {
    [sym_expression] = STATE(3850),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1479] = {
    [sym_expression] = STATE(3879),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1480] = {
    [sym_expression] = STATE(5747),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [1481] = {
    [sym_expression] = STATE(4506),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_DASH_DASH] = ACTIONS(5557),
    [anon_sym_PLUS_PLUS] = ACTIONS(5557),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [1482] = {
    [sym_expression] = STATE(5650),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1483] = {
    [sym_expression] = STATE(5665),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1484] = {
    [sym_expression] = STATE(4310),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_DASH_DASH] = ACTIONS(5557),
    [anon_sym_PLUS_PLUS] = ACTIONS(5557),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [1485] = {
    [sym_expression] = STATE(4679),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1486] = {
    [sym_expression] = STATE(5456),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1487] = {
    [sym_expression] = STATE(5424),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1488] = {
    [sym_expression] = STATE(4495),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1489] = {
    [sym_expression] = STATE(4497),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1490] = {
    [sym_expression] = STATE(5801),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1491] = {
    [sym_expression] = STATE(5803),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(5540),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(5540),
    [anon_sym_constexpr] = ACTIONS(5540),
    [anon_sym_volatile] = ACTIONS(5540),
    [anon_sym_restrict] = ACTIONS(5540),
    [anon_sym___restrict__] = ACTIONS(5540),
    [anon_sym__Atomic] = ACTIONS(5540),
    [anon_sym__Noreturn] = ACTIONS(5540),
    [anon_sym_noreturn] = ACTIONS(5540),
    [anon_sym__Nonnull] = ACTIONS(5540),
    [anon_sym_mutable] = ACTIONS(5540),
    [anon_sym_constinit] = ACTIONS(5540),
    [anon_sym_consteval] = ACTIONS(5540),
    [anon_sym_alignas] = ACTIONS(5540),
    [anon_sym__Alignas] = ACTIONS(5540),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_noexcept] = ACTIONS(5540),
    [anon_sym_throw] = ACTIONS(5540),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1492] = {
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2274),
    [anon_sym_COMMA] = ACTIONS(2274),
    [anon_sym_RPAREN] = ACTIONS(2274),
    [anon_sym_LPAREN2] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2272),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_PERCENT] = ACTIONS(2272),
    [anon_sym_PIPE_PIPE] = ACTIONS(2274),
    [anon_sym_AMP_AMP] = ACTIONS(2274),
    [anon_sym_PIPE] = ACTIONS(2272),
    [anon_sym_CARET] = ACTIONS(2272),
    [anon_sym_AMP] = ACTIONS(2272),
    [anon_sym_EQ_EQ] = ACTIONS(2274),
    [anon_sym_BANG_EQ] = ACTIONS(2274),
    [anon_sym_GT] = ACTIONS(2272),
    [anon_sym_GT_EQ] = ACTIONS(2274),
    [anon_sym_LT_EQ] = ACTIONS(2272),
    [anon_sym_LT] = ACTIONS(2272),
    [anon_sym_LT_LT] = ACTIONS(2272),
    [anon_sym_GT_GT] = ACTIONS(2272),
    [anon_sym_COLON] = ACTIONS(2272),
    [anon_sym___extension__] = ACTIONS(2272),
    [anon_sym_in] = ACTIONS(2272),
    [anon_sym_out] = ACTIONS(2272),
    [anon_sym_inout] = ACTIONS(2272),
    [anon_sym_virtual] = ACTIONS(2272),
    [anon_sym_extern] = ACTIONS(2272),
    [anon_sym___attribute__] = ACTIONS(2272),
    [anon_sym___attribute] = ACTIONS(2272),
    [anon_sym_COLON_COLON] = ACTIONS(2274),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2274),
    [anon_sym___declspec] = ACTIONS(2272),
    [anon_sym___based] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_EQ] = ACTIONS(2272),
    [anon_sym_register] = ACTIONS(2272),
    [anon_sym_inline] = ACTIONS(2272),
    [anon_sym___inline] = ACTIONS(2272),
    [anon_sym___inline__] = ACTIONS(2272),
    [anon_sym___forceinline] = ACTIONS(2272),
    [anon_sym_thread_local] = ACTIONS(2272),
    [anon_sym___thread] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_constexpr] = ACTIONS(2272),
    [anon_sym_volatile] = ACTIONS(2272),
    [anon_sym_restrict] = ACTIONS(2272),
    [anon_sym___restrict__] = ACTIONS(2272),
    [anon_sym__Atomic] = ACTIONS(2272),
    [anon_sym__Noreturn] = ACTIONS(2272),
    [anon_sym_noreturn] = ACTIONS(2272),
    [anon_sym__Nonnull] = ACTIONS(2272),
    [anon_sym_mutable] = ACTIONS(2272),
    [anon_sym_constinit] = ACTIONS(2272),
    [anon_sym_consteval] = ACTIONS(2272),
    [anon_sym_alignas] = ACTIONS(2272),
    [anon_sym__Alignas] = ACTIONS(2272),
    [anon_sym_QMARK] = ACTIONS(2274),
    [anon_sym_STAR_EQ] = ACTIONS(2274),
    [anon_sym_SLASH_EQ] = ACTIONS(2274),
    [anon_sym_PERCENT_EQ] = ACTIONS(2274),
    [anon_sym_PLUS_EQ] = ACTIONS(2274),
    [anon_sym_DASH_EQ] = ACTIONS(2274),
    [anon_sym_LT_LT_EQ] = ACTIONS(2274),
    [anon_sym_GT_GT_EQ] = ACTIONS(2274),
    [anon_sym_AMP_EQ] = ACTIONS(2274),
    [anon_sym_CARET_EQ] = ACTIONS(2274),
    [anon_sym_PIPE_EQ] = ACTIONS(2274),
    [anon_sym_and_eq] = ACTIONS(2272),
    [anon_sym_or_eq] = ACTIONS(2272),
    [anon_sym_xor_eq] = ACTIONS(2272),
    [anon_sym_LT_EQ_GT] = ACTIONS(2274),
    [anon_sym_or] = ACTIONS(2272),
    [anon_sym_and] = ACTIONS(2272),
    [anon_sym_bitor] = ACTIONS(2272),
    [anon_sym_xor] = ACTIONS(2272),
    [anon_sym_bitand] = ACTIONS(2272),
    [anon_sym_not_eq] = ACTIONS(2272),
    [anon_sym_is] = ACTIONS(2272),
    [anon_sym_as] = ACTIONS(2272),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_DOT] = ACTIONS(2272),
    [anon_sym_DOT_STAR] = ACTIONS(2274),
    [anon_sym_DASH_GT] = ACTIONS(2272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_This] = ACTIONS(2272),
    [anon_sym_decltype] = ACTIONS(2272),
    [anon_sym_template] = ACTIONS(2272),
    [anon_sym_operator] = ACTIONS(2272),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2274),
    [anon_sym_precise] = ACTIONS(2272),
    [anon_sym_shared] = ACTIONS(2272),
    [anon_sym_groupshared] = ACTIONS(2272),
    [anon_sym_uniform] = ACTIONS(2272),
    [anon_sym_row_major] = ACTIONS(2272),
    [anon_sym_column_major] = ACTIONS(2272),
    [anon_sym_globallycoherent] = ACTIONS(2272),
    [anon_sym_centroid] = ACTIONS(2272),
    [anon_sym_noperspective] = ACTIONS(2272),
    [anon_sym_nointerpolation] = ACTIONS(2272),
    [anon_sym_sample] = ACTIONS(2272),
    [anon_sym_linear] = ACTIONS(2272),
    [anon_sym_snorm] = ACTIONS(2272),
    [anon_sym_unorm] = ACTIONS(2272),
    [anon_sym_point] = ACTIONS(2272),
    [anon_sym_line] = ACTIONS(2272),
    [anon_sym_triangleadj] = ACTIONS(2272),
    [anon_sym_lineadj] = ACTIONS(2272),
    [anon_sym_triangle] = ACTIONS(2272),
  },
  [1493] = {
    [sym_type_qualifier] = STATE(3072),
    [sym_alignas_qualifier] = STATE(3113),
    [sym_expression] = STATE(5900),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [aux_sym_array_declarator_repeat1] = STATE(3072),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(5567),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5569),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_static] = ACTIONS(5571),
    [anon_sym_RBRACK] = ACTIONS(5573),
    [anon_sym_const] = ACTIONS(5575),
    [anon_sym_constexpr] = ACTIONS(5575),
    [anon_sym_volatile] = ACTIONS(5575),
    [anon_sym_restrict] = ACTIONS(5575),
    [anon_sym___restrict__] = ACTIONS(5575),
    [anon_sym__Atomic] = ACTIONS(5575),
    [anon_sym__Noreturn] = ACTIONS(5575),
    [anon_sym_noreturn] = ACTIONS(5575),
    [anon_sym__Nonnull] = ACTIONS(5575),
    [anon_sym_mutable] = ACTIONS(5575),
    [anon_sym_constinit] = ACTIONS(5575),
    [anon_sym_consteval] = ACTIONS(5575),
    [anon_sym_alignas] = ACTIONS(5577),
    [anon_sym__Alignas] = ACTIONS(5577),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1494] = {
    [sym_identifier] = ACTIONS(2243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2245),
    [anon_sym_COMMA] = ACTIONS(2245),
    [anon_sym_RPAREN] = ACTIONS(2245),
    [anon_sym_LPAREN2] = ACTIONS(2247),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_SLASH] = ACTIONS(2255),
    [anon_sym_PERCENT] = ACTIONS(2255),
    [anon_sym_PIPE_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2255),
    [anon_sym_CARET] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2245),
    [anon_sym_BANG_EQ] = ACTIONS(2245),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_GT_EQ] = ACTIONS(2245),
    [anon_sym_LT_EQ] = ACTIONS(2255),
    [anon_sym_LT] = ACTIONS(2255),
    [anon_sym_LT_LT] = ACTIONS(2255),
    [anon_sym_GT_GT] = ACTIONS(2255),
    [anon_sym_SEMI] = ACTIONS(2245),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_out] = ACTIONS(2243),
    [anon_sym_inout] = ACTIONS(2243),
    [anon_sym_virtual] = ACTIONS(2243),
    [anon_sym_extern] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym___attribute] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2243),
    [anon_sym___based] = ACTIONS(2243),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2245),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_EQ] = ACTIONS(2255),
    [anon_sym_register] = ACTIONS(2243),
    [anon_sym_inline] = ACTIONS(2243),
    [anon_sym___inline] = ACTIONS(2243),
    [anon_sym___inline__] = ACTIONS(2243),
    [anon_sym___forceinline] = ACTIONS(2243),
    [anon_sym_thread_local] = ACTIONS(2243),
    [anon_sym___thread] = ACTIONS(2243),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym__Nonnull] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [anon_sym_QMARK] = ACTIONS(2245),
    [anon_sym_STAR_EQ] = ACTIONS(2245),
    [anon_sym_SLASH_EQ] = ACTIONS(2245),
    [anon_sym_PERCENT_EQ] = ACTIONS(2245),
    [anon_sym_PLUS_EQ] = ACTIONS(2245),
    [anon_sym_DASH_EQ] = ACTIONS(2245),
    [anon_sym_LT_LT_EQ] = ACTIONS(2245),
    [anon_sym_GT_GT_EQ] = ACTIONS(2245),
    [anon_sym_AMP_EQ] = ACTIONS(2245),
    [anon_sym_CARET_EQ] = ACTIONS(2245),
    [anon_sym_PIPE_EQ] = ACTIONS(2245),
    [anon_sym_and_eq] = ACTIONS(2255),
    [anon_sym_or_eq] = ACTIONS(2255),
    [anon_sym_xor_eq] = ACTIONS(2255),
    [anon_sym_LT_EQ_GT] = ACTIONS(2245),
    [anon_sym_or] = ACTIONS(2255),
    [anon_sym_and] = ACTIONS(2255),
    [anon_sym_bitor] = ACTIONS(2255),
    [anon_sym_xor] = ACTIONS(2255),
    [anon_sym_bitand] = ACTIONS(2255),
    [anon_sym_not_eq] = ACTIONS(2255),
    [anon_sym_is] = ACTIONS(2255),
    [anon_sym_as] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2245),
    [anon_sym_PLUS_PLUS] = ACTIONS(2245),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2245),
    [anon_sym_DASH_GT] = ACTIONS(2245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2243),
    [anon_sym_let] = ACTIONS(2243),
    [anon_sym_This] = ACTIONS(2243),
    [anon_sym_decltype] = ACTIONS(2243),
    [anon_sym_template] = ACTIONS(2243),
    [anon_sym_operator] = ACTIONS(2243),
    [anon_sym_precise] = ACTIONS(2243),
    [anon_sym_shared] = ACTIONS(2243),
    [anon_sym_groupshared] = ACTIONS(2243),
    [anon_sym_uniform] = ACTIONS(2243),
    [anon_sym_row_major] = ACTIONS(2243),
    [anon_sym_column_major] = ACTIONS(2243),
    [anon_sym_globallycoherent] = ACTIONS(2243),
    [anon_sym_centroid] = ACTIONS(2243),
    [anon_sym_noperspective] = ACTIONS(2243),
    [anon_sym_nointerpolation] = ACTIONS(2243),
    [anon_sym_sample] = ACTIONS(2243),
    [anon_sym_linear] = ACTIONS(2243),
    [anon_sym_snorm] = ACTIONS(2243),
    [anon_sym_unorm] = ACTIONS(2243),
    [anon_sym_point] = ACTIONS(2243),
    [anon_sym_line] = ACTIONS(2243),
    [anon_sym_triangleadj] = ACTIONS(2243),
    [anon_sym_lineadj] = ACTIONS(2243),
    [anon_sym_triangle] = ACTIONS(2243),
  },
  [1495] = {
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_COMMA] = ACTIONS(2306),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2304),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_PERCENT] = ACTIONS(2304),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE] = ACTIONS(2304),
    [anon_sym_CARET] = ACTIONS(2304),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_GT] = ACTIONS(2304),
    [anon_sym_GT_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_LT_LT] = ACTIONS(2304),
    [anon_sym_GT_GT] = ACTIONS(2304),
    [anon_sym_COLON] = ACTIONS(2304),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym_in] = ACTIONS(2304),
    [anon_sym_out] = ACTIONS(2304),
    [anon_sym_inout] = ACTIONS(2304),
    [anon_sym_virtual] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym___attribute] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2306),
    [anon_sym___declspec] = ACTIONS(2304),
    [anon_sym___based] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_EQ] = ACTIONS(2304),
    [anon_sym_register] = ACTIONS(2304),
    [anon_sym_inline] = ACTIONS(2304),
    [anon_sym___inline] = ACTIONS(2304),
    [anon_sym___inline__] = ACTIONS(2304),
    [anon_sym___forceinline] = ACTIONS(2304),
    [anon_sym_thread_local] = ACTIONS(2304),
    [anon_sym___thread] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym__Nonnull] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [anon_sym_QMARK] = ACTIONS(2306),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_and_eq] = ACTIONS(2304),
    [anon_sym_or_eq] = ACTIONS(2304),
    [anon_sym_xor_eq] = ACTIONS(2304),
    [anon_sym_LT_EQ_GT] = ACTIONS(2306),
    [anon_sym_or] = ACTIONS(2304),
    [anon_sym_and] = ACTIONS(2304),
    [anon_sym_bitor] = ACTIONS(2304),
    [anon_sym_xor] = ACTIONS(2304),
    [anon_sym_bitand] = ACTIONS(2304),
    [anon_sym_not_eq] = ACTIONS(2304),
    [anon_sym_is] = ACTIONS(2304),
    [anon_sym_as] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DOT] = ACTIONS(2304),
    [anon_sym_DOT_STAR] = ACTIONS(2306),
    [anon_sym_DASH_GT] = ACTIONS(2304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_This] = ACTIONS(2304),
    [anon_sym_decltype] = ACTIONS(2304),
    [anon_sym_template] = ACTIONS(2304),
    [anon_sym_operator] = ACTIONS(2304),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2306),
    [anon_sym_precise] = ACTIONS(2304),
    [anon_sym_shared] = ACTIONS(2304),
    [anon_sym_groupshared] = ACTIONS(2304),
    [anon_sym_uniform] = ACTIONS(2304),
    [anon_sym_row_major] = ACTIONS(2304),
    [anon_sym_column_major] = ACTIONS(2304),
    [anon_sym_globallycoherent] = ACTIONS(2304),
    [anon_sym_centroid] = ACTIONS(2304),
    [anon_sym_noperspective] = ACTIONS(2304),
    [anon_sym_nointerpolation] = ACTIONS(2304),
    [anon_sym_sample] = ACTIONS(2304),
    [anon_sym_linear] = ACTIONS(2304),
    [anon_sym_snorm] = ACTIONS(2304),
    [anon_sym_unorm] = ACTIONS(2304),
    [anon_sym_point] = ACTIONS(2304),
    [anon_sym_line] = ACTIONS(2304),
    [anon_sym_triangleadj] = ACTIONS(2304),
    [anon_sym_lineadj] = ACTIONS(2304),
    [anon_sym_triangle] = ACTIONS(2304),
  },
  [1496] = {
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2310),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_RPAREN] = ACTIONS(2310),
    [anon_sym_LPAREN2] = ACTIONS(2310),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2308),
    [anon_sym_SLASH] = ACTIONS(2308),
    [anon_sym_PERCENT] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_CARET] = ACTIONS(2308),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2310),
    [anon_sym_BANG_EQ] = ACTIONS(2310),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_EQ] = ACTIONS(2310),
    [anon_sym_LT_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2308),
    [anon_sym_COLON] = ACTIONS(2308),
    [anon_sym___extension__] = ACTIONS(2308),
    [anon_sym_in] = ACTIONS(2308),
    [anon_sym_out] = ACTIONS(2308),
    [anon_sym_inout] = ACTIONS(2308),
    [anon_sym_virtual] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2308),
    [anon_sym___attribute__] = ACTIONS(2308),
    [anon_sym___attribute] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2310),
    [anon_sym___declspec] = ACTIONS(2308),
    [anon_sym___based] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_EQ] = ACTIONS(2308),
    [anon_sym_register] = ACTIONS(2308),
    [anon_sym_inline] = ACTIONS(2308),
    [anon_sym___inline] = ACTIONS(2308),
    [anon_sym___inline__] = ACTIONS(2308),
    [anon_sym___forceinline] = ACTIONS(2308),
    [anon_sym_thread_local] = ACTIONS(2308),
    [anon_sym___thread] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_constexpr] = ACTIONS(2308),
    [anon_sym_volatile] = ACTIONS(2308),
    [anon_sym_restrict] = ACTIONS(2308),
    [anon_sym___restrict__] = ACTIONS(2308),
    [anon_sym__Atomic] = ACTIONS(2308),
    [anon_sym__Noreturn] = ACTIONS(2308),
    [anon_sym_noreturn] = ACTIONS(2308),
    [anon_sym__Nonnull] = ACTIONS(2308),
    [anon_sym_mutable] = ACTIONS(2308),
    [anon_sym_constinit] = ACTIONS(2308),
    [anon_sym_consteval] = ACTIONS(2308),
    [anon_sym_alignas] = ACTIONS(2308),
    [anon_sym__Alignas] = ACTIONS(2308),
    [anon_sym_QMARK] = ACTIONS(2310),
    [anon_sym_STAR_EQ] = ACTIONS(2310),
    [anon_sym_SLASH_EQ] = ACTIONS(2310),
    [anon_sym_PERCENT_EQ] = ACTIONS(2310),
    [anon_sym_PLUS_EQ] = ACTIONS(2310),
    [anon_sym_DASH_EQ] = ACTIONS(2310),
    [anon_sym_LT_LT_EQ] = ACTIONS(2310),
    [anon_sym_GT_GT_EQ] = ACTIONS(2310),
    [anon_sym_AMP_EQ] = ACTIONS(2310),
    [anon_sym_CARET_EQ] = ACTIONS(2310),
    [anon_sym_PIPE_EQ] = ACTIONS(2310),
    [anon_sym_and_eq] = ACTIONS(2308),
    [anon_sym_or_eq] = ACTIONS(2308),
    [anon_sym_xor_eq] = ACTIONS(2308),
    [anon_sym_LT_EQ_GT] = ACTIONS(2310),
    [anon_sym_or] = ACTIONS(2308),
    [anon_sym_and] = ACTIONS(2308),
    [anon_sym_bitor] = ACTIONS(2308),
    [anon_sym_xor] = ACTIONS(2308),
    [anon_sym_bitand] = ACTIONS(2308),
    [anon_sym_not_eq] = ACTIONS(2308),
    [anon_sym_is] = ACTIONS(2308),
    [anon_sym_as] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_DOT] = ACTIONS(2308),
    [anon_sym_DOT_STAR] = ACTIONS(2310),
    [anon_sym_DASH_GT] = ACTIONS(2308),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_This] = ACTIONS(2308),
    [anon_sym_decltype] = ACTIONS(2308),
    [anon_sym_template] = ACTIONS(2308),
    [anon_sym_operator] = ACTIONS(2308),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2310),
    [anon_sym_precise] = ACTIONS(2308),
    [anon_sym_shared] = ACTIONS(2308),
    [anon_sym_groupshared] = ACTIONS(2308),
    [anon_sym_uniform] = ACTIONS(2308),
    [anon_sym_row_major] = ACTIONS(2308),
    [anon_sym_column_major] = ACTIONS(2308),
    [anon_sym_globallycoherent] = ACTIONS(2308),
    [anon_sym_centroid] = ACTIONS(2308),
    [anon_sym_noperspective] = ACTIONS(2308),
    [anon_sym_nointerpolation] = ACTIONS(2308),
    [anon_sym_sample] = ACTIONS(2308),
    [anon_sym_linear] = ACTIONS(2308),
    [anon_sym_snorm] = ACTIONS(2308),
    [anon_sym_unorm] = ACTIONS(2308),
    [anon_sym_point] = ACTIONS(2308),
    [anon_sym_line] = ACTIONS(2308),
    [anon_sym_triangleadj] = ACTIONS(2308),
    [anon_sym_lineadj] = ACTIONS(2308),
    [anon_sym_triangle] = ACTIONS(2308),
  },
  [1497] = {
    [sym_type_qualifier] = STATE(1493),
    [sym_alignas_qualifier] = STATE(3113),
    [sym_expression] = STATE(6030),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [aux_sym_array_declarator_repeat1] = STATE(1493),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(5579),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5569),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_static] = ACTIONS(5581),
    [anon_sym_RBRACK] = ACTIONS(5583),
    [anon_sym_const] = ACTIONS(5575),
    [anon_sym_constexpr] = ACTIONS(5575),
    [anon_sym_volatile] = ACTIONS(5575),
    [anon_sym_restrict] = ACTIONS(5575),
    [anon_sym___restrict__] = ACTIONS(5575),
    [anon_sym__Atomic] = ACTIONS(5575),
    [anon_sym__Noreturn] = ACTIONS(5575),
    [anon_sym_noreturn] = ACTIONS(5575),
    [anon_sym__Nonnull] = ACTIONS(5575),
    [anon_sym_mutable] = ACTIONS(5575),
    [anon_sym_constinit] = ACTIONS(5575),
    [anon_sym_consteval] = ACTIONS(5575),
    [anon_sym_alignas] = ACTIONS(5577),
    [anon_sym__Alignas] = ACTIONS(5577),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1498] = {
    [sym_identifier] = ACTIONS(2284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2286),
    [anon_sym_COMMA] = ACTIONS(2286),
    [anon_sym_RPAREN] = ACTIONS(2286),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2284),
    [anon_sym_SLASH] = ACTIONS(2284),
    [anon_sym_PERCENT] = ACTIONS(2284),
    [anon_sym_PIPE_PIPE] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2284),
    [anon_sym_CARET] = ACTIONS(2284),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_EQ_EQ] = ACTIONS(2286),
    [anon_sym_BANG_EQ] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2284),
    [anon_sym_GT_EQ] = ACTIONS(2286),
    [anon_sym_LT_EQ] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2284),
    [anon_sym_LT_LT] = ACTIONS(2284),
    [anon_sym_GT_GT] = ACTIONS(2284),
    [anon_sym_COLON] = ACTIONS(2284),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_in] = ACTIONS(2284),
    [anon_sym_out] = ACTIONS(2284),
    [anon_sym_inout] = ACTIONS(2284),
    [anon_sym_virtual] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_EQ] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [anon_sym_QMARK] = ACTIONS(2286),
    [anon_sym_STAR_EQ] = ACTIONS(2286),
    [anon_sym_SLASH_EQ] = ACTIONS(2286),
    [anon_sym_PERCENT_EQ] = ACTIONS(2286),
    [anon_sym_PLUS_EQ] = ACTIONS(2286),
    [anon_sym_DASH_EQ] = ACTIONS(2286),
    [anon_sym_LT_LT_EQ] = ACTIONS(2286),
    [anon_sym_GT_GT_EQ] = ACTIONS(2286),
    [anon_sym_AMP_EQ] = ACTIONS(2286),
    [anon_sym_CARET_EQ] = ACTIONS(2286),
    [anon_sym_PIPE_EQ] = ACTIONS(2286),
    [anon_sym_and_eq] = ACTIONS(2284),
    [anon_sym_or_eq] = ACTIONS(2284),
    [anon_sym_xor_eq] = ACTIONS(2284),
    [anon_sym_LT_EQ_GT] = ACTIONS(2286),
    [anon_sym_or] = ACTIONS(2284),
    [anon_sym_and] = ACTIONS(2284),
    [anon_sym_bitor] = ACTIONS(2284),
    [anon_sym_xor] = ACTIONS(2284),
    [anon_sym_bitand] = ACTIONS(2284),
    [anon_sym_not_eq] = ACTIONS(2284),
    [anon_sym_is] = ACTIONS(2284),
    [anon_sym_as] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_DOT] = ACTIONS(2284),
    [anon_sym_DOT_STAR] = ACTIONS(2286),
    [anon_sym_DASH_GT] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_This] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2286),
    [anon_sym_precise] = ACTIONS(2284),
    [anon_sym_shared] = ACTIONS(2284),
    [anon_sym_groupshared] = ACTIONS(2284),
    [anon_sym_uniform] = ACTIONS(2284),
    [anon_sym_row_major] = ACTIONS(2284),
    [anon_sym_column_major] = ACTIONS(2284),
    [anon_sym_globallycoherent] = ACTIONS(2284),
    [anon_sym_centroid] = ACTIONS(2284),
    [anon_sym_noperspective] = ACTIONS(2284),
    [anon_sym_nointerpolation] = ACTIONS(2284),
    [anon_sym_sample] = ACTIONS(2284),
    [anon_sym_linear] = ACTIONS(2284),
    [anon_sym_snorm] = ACTIONS(2284),
    [anon_sym_unorm] = ACTIONS(2284),
    [anon_sym_point] = ACTIONS(2284),
    [anon_sym_line] = ACTIONS(2284),
    [anon_sym_triangleadj] = ACTIONS(2284),
    [anon_sym_lineadj] = ACTIONS(2284),
    [anon_sym_triangle] = ACTIONS(2284),
  },
  [1499] = {
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2314),
    [anon_sym_COMMA] = ACTIONS(2314),
    [anon_sym_RPAREN] = ACTIONS(2314),
    [anon_sym_LPAREN2] = ACTIONS(2314),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_SLASH] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2312),
    [anon_sym_PIPE_PIPE] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2314),
    [anon_sym_PIPE] = ACTIONS(2312),
    [anon_sym_CARET] = ACTIONS(2312),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_EQ_EQ] = ACTIONS(2314),
    [anon_sym_BANG_EQ] = ACTIONS(2314),
    [anon_sym_GT] = ACTIONS(2312),
    [anon_sym_GT_EQ] = ACTIONS(2314),
    [anon_sym_LT_EQ] = ACTIONS(2312),
    [anon_sym_LT] = ACTIONS(2312),
    [anon_sym_LT_LT] = ACTIONS(2312),
    [anon_sym_GT_GT] = ACTIONS(2312),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym___extension__] = ACTIONS(2312),
    [anon_sym_in] = ACTIONS(2312),
    [anon_sym_out] = ACTIONS(2312),
    [anon_sym_inout] = ACTIONS(2312),
    [anon_sym_virtual] = ACTIONS(2312),
    [anon_sym_extern] = ACTIONS(2312),
    [anon_sym___attribute__] = ACTIONS(2312),
    [anon_sym___attribute] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2314),
    [anon_sym___declspec] = ACTIONS(2312),
    [anon_sym___based] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_EQ] = ACTIONS(2312),
    [anon_sym_register] = ACTIONS(2312),
    [anon_sym_inline] = ACTIONS(2312),
    [anon_sym___inline] = ACTIONS(2312),
    [anon_sym___inline__] = ACTIONS(2312),
    [anon_sym___forceinline] = ACTIONS(2312),
    [anon_sym_thread_local] = ACTIONS(2312),
    [anon_sym___thread] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_constexpr] = ACTIONS(2312),
    [anon_sym_volatile] = ACTIONS(2312),
    [anon_sym_restrict] = ACTIONS(2312),
    [anon_sym___restrict__] = ACTIONS(2312),
    [anon_sym__Atomic] = ACTIONS(2312),
    [anon_sym__Noreturn] = ACTIONS(2312),
    [anon_sym_noreturn] = ACTIONS(2312),
    [anon_sym__Nonnull] = ACTIONS(2312),
    [anon_sym_mutable] = ACTIONS(2312),
    [anon_sym_constinit] = ACTIONS(2312),
    [anon_sym_consteval] = ACTIONS(2312),
    [anon_sym_alignas] = ACTIONS(2312),
    [anon_sym__Alignas] = ACTIONS(2312),
    [anon_sym_QMARK] = ACTIONS(2314),
    [anon_sym_STAR_EQ] = ACTIONS(2314),
    [anon_sym_SLASH_EQ] = ACTIONS(2314),
    [anon_sym_PERCENT_EQ] = ACTIONS(2314),
    [anon_sym_PLUS_EQ] = ACTIONS(2314),
    [anon_sym_DASH_EQ] = ACTIONS(2314),
    [anon_sym_LT_LT_EQ] = ACTIONS(2314),
    [anon_sym_GT_GT_EQ] = ACTIONS(2314),
    [anon_sym_AMP_EQ] = ACTIONS(2314),
    [anon_sym_CARET_EQ] = ACTIONS(2314),
    [anon_sym_PIPE_EQ] = ACTIONS(2314),
    [anon_sym_and_eq] = ACTIONS(2312),
    [anon_sym_or_eq] = ACTIONS(2312),
    [anon_sym_xor_eq] = ACTIONS(2312),
    [anon_sym_LT_EQ_GT] = ACTIONS(2314),
    [anon_sym_or] = ACTIONS(2312),
    [anon_sym_and] = ACTIONS(2312),
    [anon_sym_bitor] = ACTIONS(2312),
    [anon_sym_xor] = ACTIONS(2312),
    [anon_sym_bitand] = ACTIONS(2312),
    [anon_sym_not_eq] = ACTIONS(2312),
    [anon_sym_is] = ACTIONS(2312),
    [anon_sym_as] = ACTIONS(2312),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_DOT] = ACTIONS(2312),
    [anon_sym_DOT_STAR] = ACTIONS(2314),
    [anon_sym_DASH_GT] = ACTIONS(2312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_This] = ACTIONS(2312),
    [anon_sym_decltype] = ACTIONS(2312),
    [anon_sym_template] = ACTIONS(2312),
    [anon_sym_operator] = ACTIONS(2312),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2314),
    [anon_sym_precise] = ACTIONS(2312),
    [anon_sym_shared] = ACTIONS(2312),
    [anon_sym_groupshared] = ACTIONS(2312),
    [anon_sym_uniform] = ACTIONS(2312),
    [anon_sym_row_major] = ACTIONS(2312),
    [anon_sym_column_major] = ACTIONS(2312),
    [anon_sym_globallycoherent] = ACTIONS(2312),
    [anon_sym_centroid] = ACTIONS(2312),
    [anon_sym_noperspective] = ACTIONS(2312),
    [anon_sym_nointerpolation] = ACTIONS(2312),
    [anon_sym_sample] = ACTIONS(2312),
    [anon_sym_linear] = ACTIONS(2312),
    [anon_sym_snorm] = ACTIONS(2312),
    [anon_sym_unorm] = ACTIONS(2312),
    [anon_sym_point] = ACTIONS(2312),
    [anon_sym_line] = ACTIONS(2312),
    [anon_sym_triangleadj] = ACTIONS(2312),
    [anon_sym_lineadj] = ACTIONS(2312),
    [anon_sym_triangle] = ACTIONS(2312),
  },
  [1500] = {
    [sym_type_qualifier] = STATE(1501),
    [sym_alignas_qualifier] = STATE(3113),
    [sym_expression] = STATE(6037),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [aux_sym_array_declarator_repeat1] = STATE(1501),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(5585),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5569),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_static] = ACTIONS(5587),
    [anon_sym_RBRACK] = ACTIONS(5589),
    [anon_sym_const] = ACTIONS(5575),
    [anon_sym_constexpr] = ACTIONS(5575),
    [anon_sym_volatile] = ACTIONS(5575),
    [anon_sym_restrict] = ACTIONS(5575),
    [anon_sym___restrict__] = ACTIONS(5575),
    [anon_sym__Atomic] = ACTIONS(5575),
    [anon_sym__Noreturn] = ACTIONS(5575),
    [anon_sym_noreturn] = ACTIONS(5575),
    [anon_sym__Nonnull] = ACTIONS(5575),
    [anon_sym_mutable] = ACTIONS(5575),
    [anon_sym_constinit] = ACTIONS(5575),
    [anon_sym_consteval] = ACTIONS(5575),
    [anon_sym_alignas] = ACTIONS(5577),
    [anon_sym__Alignas] = ACTIONS(5577),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1501] = {
    [sym_type_qualifier] = STATE(3072),
    [sym_alignas_qualifier] = STATE(3113),
    [sym_expression] = STATE(5967),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [aux_sym_array_declarator_repeat1] = STATE(3072),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(5591),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5569),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_static] = ACTIONS(5571),
    [anon_sym_RBRACK] = ACTIONS(5593),
    [anon_sym_const] = ACTIONS(5575),
    [anon_sym_constexpr] = ACTIONS(5575),
    [anon_sym_volatile] = ACTIONS(5575),
    [anon_sym_restrict] = ACTIONS(5575),
    [anon_sym___restrict__] = ACTIONS(5575),
    [anon_sym__Atomic] = ACTIONS(5575),
    [anon_sym__Noreturn] = ACTIONS(5575),
    [anon_sym_noreturn] = ACTIONS(5575),
    [anon_sym__Nonnull] = ACTIONS(5575),
    [anon_sym_mutable] = ACTIONS(5575),
    [anon_sym_constinit] = ACTIONS(5575),
    [anon_sym_consteval] = ACTIONS(5575),
    [anon_sym_alignas] = ACTIONS(5577),
    [anon_sym__Alignas] = ACTIONS(5577),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1502] = {
    [sym_type_qualifier] = STATE(3072),
    [sym_alignas_qualifier] = STATE(3113),
    [sym_expression] = STATE(5949),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [aux_sym_array_declarator_repeat1] = STATE(3072),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(5595),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5569),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_static] = ACTIONS(5571),
    [anon_sym_RBRACK] = ACTIONS(5597),
    [anon_sym_const] = ACTIONS(5575),
    [anon_sym_constexpr] = ACTIONS(5575),
    [anon_sym_volatile] = ACTIONS(5575),
    [anon_sym_restrict] = ACTIONS(5575),
    [anon_sym___restrict__] = ACTIONS(5575),
    [anon_sym__Atomic] = ACTIONS(5575),
    [anon_sym__Noreturn] = ACTIONS(5575),
    [anon_sym_noreturn] = ACTIONS(5575),
    [anon_sym__Nonnull] = ACTIONS(5575),
    [anon_sym_mutable] = ACTIONS(5575),
    [anon_sym_constinit] = ACTIONS(5575),
    [anon_sym_consteval] = ACTIONS(5575),
    [anon_sym_alignas] = ACTIONS(5577),
    [anon_sym__Alignas] = ACTIONS(5577),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1503] = {
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_COMMA] = ACTIONS(2282),
    [anon_sym_RPAREN] = ACTIONS(2282),
    [anon_sym_LPAREN2] = ACTIONS(2282),
    [anon_sym_TILDE] = ACTIONS(2282),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2280),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_PERCENT] = ACTIONS(2280),
    [anon_sym_PIPE_PIPE] = ACTIONS(2282),
    [anon_sym_AMP_AMP] = ACTIONS(2282),
    [anon_sym_PIPE] = ACTIONS(2280),
    [anon_sym_CARET] = ACTIONS(2280),
    [anon_sym_AMP] = ACTIONS(2280),
    [anon_sym_EQ_EQ] = ACTIONS(2282),
    [anon_sym_BANG_EQ] = ACTIONS(2282),
    [anon_sym_GT] = ACTIONS(2280),
    [anon_sym_GT_EQ] = ACTIONS(2282),
    [anon_sym_LT_EQ] = ACTIONS(2280),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_LT_LT] = ACTIONS(2280),
    [anon_sym_GT_GT] = ACTIONS(2280),
    [anon_sym_COLON] = ACTIONS(2280),
    [anon_sym___extension__] = ACTIONS(2280),
    [anon_sym_in] = ACTIONS(2280),
    [anon_sym_out] = ACTIONS(2280),
    [anon_sym_inout] = ACTIONS(2280),
    [anon_sym_virtual] = ACTIONS(2280),
    [anon_sym_extern] = ACTIONS(2280),
    [anon_sym___attribute__] = ACTIONS(2280),
    [anon_sym___attribute] = ACTIONS(2280),
    [anon_sym_COLON_COLON] = ACTIONS(2282),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2282),
    [anon_sym___declspec] = ACTIONS(2280),
    [anon_sym___based] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_LBRACK] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_EQ] = ACTIONS(2280),
    [anon_sym_register] = ACTIONS(2280),
    [anon_sym_inline] = ACTIONS(2280),
    [anon_sym___inline] = ACTIONS(2280),
    [anon_sym___inline__] = ACTIONS(2280),
    [anon_sym___forceinline] = ACTIONS(2280),
    [anon_sym_thread_local] = ACTIONS(2280),
    [anon_sym___thread] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_constexpr] = ACTIONS(2280),
    [anon_sym_volatile] = ACTIONS(2280),
    [anon_sym_restrict] = ACTIONS(2280),
    [anon_sym___restrict__] = ACTIONS(2280),
    [anon_sym__Atomic] = ACTIONS(2280),
    [anon_sym__Noreturn] = ACTIONS(2280),
    [anon_sym_noreturn] = ACTIONS(2280),
    [anon_sym__Nonnull] = ACTIONS(2280),
    [anon_sym_mutable] = ACTIONS(2280),
    [anon_sym_constinit] = ACTIONS(2280),
    [anon_sym_consteval] = ACTIONS(2280),
    [anon_sym_alignas] = ACTIONS(2280),
    [anon_sym__Alignas] = ACTIONS(2280),
    [anon_sym_QMARK] = ACTIONS(2282),
    [anon_sym_STAR_EQ] = ACTIONS(2282),
    [anon_sym_SLASH_EQ] = ACTIONS(2282),
    [anon_sym_PERCENT_EQ] = ACTIONS(2282),
    [anon_sym_PLUS_EQ] = ACTIONS(2282),
    [anon_sym_DASH_EQ] = ACTIONS(2282),
    [anon_sym_LT_LT_EQ] = ACTIONS(2282),
    [anon_sym_GT_GT_EQ] = ACTIONS(2282),
    [anon_sym_AMP_EQ] = ACTIONS(2282),
    [anon_sym_CARET_EQ] = ACTIONS(2282),
    [anon_sym_PIPE_EQ] = ACTIONS(2282),
    [anon_sym_and_eq] = ACTIONS(2280),
    [anon_sym_or_eq] = ACTIONS(2280),
    [anon_sym_xor_eq] = ACTIONS(2280),
    [anon_sym_LT_EQ_GT] = ACTIONS(2282),
    [anon_sym_or] = ACTIONS(2280),
    [anon_sym_and] = ACTIONS(2280),
    [anon_sym_bitor] = ACTIONS(2280),
    [anon_sym_xor] = ACTIONS(2280),
    [anon_sym_bitand] = ACTIONS(2280),
    [anon_sym_not_eq] = ACTIONS(2280),
    [anon_sym_is] = ACTIONS(2280),
    [anon_sym_as] = ACTIONS(2280),
    [anon_sym_DASH_DASH] = ACTIONS(2282),
    [anon_sym_PLUS_PLUS] = ACTIONS(2282),
    [anon_sym_DOT] = ACTIONS(2280),
    [anon_sym_DOT_STAR] = ACTIONS(2282),
    [anon_sym_DASH_GT] = ACTIONS(2280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_This] = ACTIONS(2280),
    [anon_sym_decltype] = ACTIONS(2280),
    [anon_sym_template] = ACTIONS(2280),
    [anon_sym_operator] = ACTIONS(2280),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2282),
    [anon_sym_precise] = ACTIONS(2280),
    [anon_sym_shared] = ACTIONS(2280),
    [anon_sym_groupshared] = ACTIONS(2280),
    [anon_sym_uniform] = ACTIONS(2280),
    [anon_sym_row_major] = ACTIONS(2280),
    [anon_sym_column_major] = ACTIONS(2280),
    [anon_sym_globallycoherent] = ACTIONS(2280),
    [anon_sym_centroid] = ACTIONS(2280),
    [anon_sym_noperspective] = ACTIONS(2280),
    [anon_sym_nointerpolation] = ACTIONS(2280),
    [anon_sym_sample] = ACTIONS(2280),
    [anon_sym_linear] = ACTIONS(2280),
    [anon_sym_snorm] = ACTIONS(2280),
    [anon_sym_unorm] = ACTIONS(2280),
    [anon_sym_point] = ACTIONS(2280),
    [anon_sym_line] = ACTIONS(2280),
    [anon_sym_triangleadj] = ACTIONS(2280),
    [anon_sym_lineadj] = ACTIONS(2280),
    [anon_sym_triangle] = ACTIONS(2280),
  },
  [1504] = {
    [sym_identifier] = ACTIONS(2276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2278),
    [anon_sym_COMMA] = ACTIONS(2278),
    [anon_sym_RPAREN] = ACTIONS(2278),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_PLUS] = ACTIONS(2276),
    [anon_sym_STAR] = ACTIONS(2276),
    [anon_sym_SLASH] = ACTIONS(2276),
    [anon_sym_PERCENT] = ACTIONS(2276),
    [anon_sym_PIPE_PIPE] = ACTIONS(2278),
    [anon_sym_AMP_AMP] = ACTIONS(2278),
    [anon_sym_PIPE] = ACTIONS(2276),
    [anon_sym_CARET] = ACTIONS(2276),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_EQ_EQ] = ACTIONS(2278),
    [anon_sym_BANG_EQ] = ACTIONS(2278),
    [anon_sym_GT] = ACTIONS(2276),
    [anon_sym_GT_EQ] = ACTIONS(2278),
    [anon_sym_LT_EQ] = ACTIONS(2276),
    [anon_sym_LT] = ACTIONS(2276),
    [anon_sym_LT_LT] = ACTIONS(2276),
    [anon_sym_GT_GT] = ACTIONS(2276),
    [anon_sym_COLON] = ACTIONS(2276),
    [anon_sym___extension__] = ACTIONS(2276),
    [anon_sym_in] = ACTIONS(2276),
    [anon_sym_out] = ACTIONS(2276),
    [anon_sym_inout] = ACTIONS(2276),
    [anon_sym_virtual] = ACTIONS(2276),
    [anon_sym_extern] = ACTIONS(2276),
    [anon_sym___attribute__] = ACTIONS(2276),
    [anon_sym___attribute] = ACTIONS(2276),
    [anon_sym_COLON_COLON] = ACTIONS(2278),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2278),
    [anon_sym___declspec] = ACTIONS(2276),
    [anon_sym___based] = ACTIONS(2276),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_LBRACK] = ACTIONS(2276),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_EQ] = ACTIONS(2276),
    [anon_sym_register] = ACTIONS(2276),
    [anon_sym_inline] = ACTIONS(2276),
    [anon_sym___inline] = ACTIONS(2276),
    [anon_sym___inline__] = ACTIONS(2276),
    [anon_sym___forceinline] = ACTIONS(2276),
    [anon_sym_thread_local] = ACTIONS(2276),
    [anon_sym___thread] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_constexpr] = ACTIONS(2276),
    [anon_sym_volatile] = ACTIONS(2276),
    [anon_sym_restrict] = ACTIONS(2276),
    [anon_sym___restrict__] = ACTIONS(2276),
    [anon_sym__Atomic] = ACTIONS(2276),
    [anon_sym__Noreturn] = ACTIONS(2276),
    [anon_sym_noreturn] = ACTIONS(2276),
    [anon_sym__Nonnull] = ACTIONS(2276),
    [anon_sym_mutable] = ACTIONS(2276),
    [anon_sym_constinit] = ACTIONS(2276),
    [anon_sym_consteval] = ACTIONS(2276),
    [anon_sym_alignas] = ACTIONS(2276),
    [anon_sym__Alignas] = ACTIONS(2276),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_STAR_EQ] = ACTIONS(2278),
    [anon_sym_SLASH_EQ] = ACTIONS(2278),
    [anon_sym_PERCENT_EQ] = ACTIONS(2278),
    [anon_sym_PLUS_EQ] = ACTIONS(2278),
    [anon_sym_DASH_EQ] = ACTIONS(2278),
    [anon_sym_LT_LT_EQ] = ACTIONS(2278),
    [anon_sym_GT_GT_EQ] = ACTIONS(2278),
    [anon_sym_AMP_EQ] = ACTIONS(2278),
    [anon_sym_CARET_EQ] = ACTIONS(2278),
    [anon_sym_PIPE_EQ] = ACTIONS(2278),
    [anon_sym_and_eq] = ACTIONS(2276),
    [anon_sym_or_eq] = ACTIONS(2276),
    [anon_sym_xor_eq] = ACTIONS(2276),
    [anon_sym_LT_EQ_GT] = ACTIONS(2278),
    [anon_sym_or] = ACTIONS(2276),
    [anon_sym_and] = ACTIONS(2276),
    [anon_sym_bitor] = ACTIONS(2276),
    [anon_sym_xor] = ACTIONS(2276),
    [anon_sym_bitand] = ACTIONS(2276),
    [anon_sym_not_eq] = ACTIONS(2276),
    [anon_sym_is] = ACTIONS(2276),
    [anon_sym_as] = ACTIONS(2276),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DOT] = ACTIONS(2276),
    [anon_sym_DOT_STAR] = ACTIONS(2278),
    [anon_sym_DASH_GT] = ACTIONS(2276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_This] = ACTIONS(2276),
    [anon_sym_decltype] = ACTIONS(2276),
    [anon_sym_template] = ACTIONS(2276),
    [anon_sym_operator] = ACTIONS(2276),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2278),
    [anon_sym_precise] = ACTIONS(2276),
    [anon_sym_shared] = ACTIONS(2276),
    [anon_sym_groupshared] = ACTIONS(2276),
    [anon_sym_uniform] = ACTIONS(2276),
    [anon_sym_row_major] = ACTIONS(2276),
    [anon_sym_column_major] = ACTIONS(2276),
    [anon_sym_globallycoherent] = ACTIONS(2276),
    [anon_sym_centroid] = ACTIONS(2276),
    [anon_sym_noperspective] = ACTIONS(2276),
    [anon_sym_nointerpolation] = ACTIONS(2276),
    [anon_sym_sample] = ACTIONS(2276),
    [anon_sym_linear] = ACTIONS(2276),
    [anon_sym_snorm] = ACTIONS(2276),
    [anon_sym_unorm] = ACTIONS(2276),
    [anon_sym_point] = ACTIONS(2276),
    [anon_sym_line] = ACTIONS(2276),
    [anon_sym_triangleadj] = ACTIONS(2276),
    [anon_sym_lineadj] = ACTIONS(2276),
    [anon_sym_triangle] = ACTIONS(2276),
  },
  [1505] = {
    [sym_identifier] = ACTIONS(2239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2241),
    [anon_sym_COMMA] = ACTIONS(2241),
    [anon_sym_RPAREN] = ACTIONS(2241),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2239),
    [anon_sym_PLUS] = ACTIONS(2239),
    [anon_sym_STAR] = ACTIONS(2239),
    [anon_sym_SLASH] = ACTIONS(2239),
    [anon_sym_PERCENT] = ACTIONS(2239),
    [anon_sym_PIPE_PIPE] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_PIPE] = ACTIONS(2239),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_LT_EQ] = ACTIONS(2239),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_LT_LT] = ACTIONS(2239),
    [anon_sym_GT_GT] = ACTIONS(2239),
    [anon_sym_COLON] = ACTIONS(2239),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym_in] = ACTIONS(2239),
    [anon_sym_out] = ACTIONS(2239),
    [anon_sym_inout] = ACTIONS(2239),
    [anon_sym_virtual] = ACTIONS(2239),
    [anon_sym_extern] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym___attribute] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2241),
    [anon_sym___declspec] = ACTIONS(2239),
    [anon_sym___based] = ACTIONS(2239),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2239),
    [anon_sym_EQ] = ACTIONS(2239),
    [anon_sym_register] = ACTIONS(2239),
    [anon_sym_inline] = ACTIONS(2239),
    [anon_sym___inline] = ACTIONS(2239),
    [anon_sym___inline__] = ACTIONS(2239),
    [anon_sym___forceinline] = ACTIONS(2239),
    [anon_sym_thread_local] = ACTIONS(2239),
    [anon_sym___thread] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym__Nonnull] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [anon_sym_QMARK] = ACTIONS(2241),
    [anon_sym_STAR_EQ] = ACTIONS(2241),
    [anon_sym_SLASH_EQ] = ACTIONS(2241),
    [anon_sym_PERCENT_EQ] = ACTIONS(2241),
    [anon_sym_PLUS_EQ] = ACTIONS(2241),
    [anon_sym_DASH_EQ] = ACTIONS(2241),
    [anon_sym_LT_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_GT_EQ] = ACTIONS(2241),
    [anon_sym_AMP_EQ] = ACTIONS(2241),
    [anon_sym_CARET_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_EQ] = ACTIONS(2241),
    [anon_sym_and_eq] = ACTIONS(2239),
    [anon_sym_or_eq] = ACTIONS(2239),
    [anon_sym_xor_eq] = ACTIONS(2239),
    [anon_sym_LT_EQ_GT] = ACTIONS(2241),
    [anon_sym_or] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(2239),
    [anon_sym_bitor] = ACTIONS(2239),
    [anon_sym_xor] = ACTIONS(2239),
    [anon_sym_bitand] = ACTIONS(2239),
    [anon_sym_not_eq] = ACTIONS(2239),
    [anon_sym_is] = ACTIONS(2239),
    [anon_sym_as] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2239),
    [anon_sym_DOT_STAR] = ACTIONS(2241),
    [anon_sym_DASH_GT] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2239),
    [anon_sym_let] = ACTIONS(2239),
    [anon_sym_This] = ACTIONS(2239),
    [anon_sym_decltype] = ACTIONS(2239),
    [anon_sym_template] = ACTIONS(2239),
    [anon_sym_operator] = ACTIONS(2239),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2241),
    [anon_sym_precise] = ACTIONS(2239),
    [anon_sym_shared] = ACTIONS(2239),
    [anon_sym_groupshared] = ACTIONS(2239),
    [anon_sym_uniform] = ACTIONS(2239),
    [anon_sym_row_major] = ACTIONS(2239),
    [anon_sym_column_major] = ACTIONS(2239),
    [anon_sym_globallycoherent] = ACTIONS(2239),
    [anon_sym_centroid] = ACTIONS(2239),
    [anon_sym_noperspective] = ACTIONS(2239),
    [anon_sym_nointerpolation] = ACTIONS(2239),
    [anon_sym_sample] = ACTIONS(2239),
    [anon_sym_linear] = ACTIONS(2239),
    [anon_sym_snorm] = ACTIONS(2239),
    [anon_sym_unorm] = ACTIONS(2239),
    [anon_sym_point] = ACTIONS(2239),
    [anon_sym_line] = ACTIONS(2239),
    [anon_sym_triangleadj] = ACTIONS(2239),
    [anon_sym_lineadj] = ACTIONS(2239),
    [anon_sym_triangle] = ACTIONS(2239),
  },
  [1506] = {
    [sym_identifier] = ACTIONS(2296),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2298),
    [anon_sym_COMMA] = ACTIONS(2298),
    [anon_sym_RPAREN] = ACTIONS(2298),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2296),
    [anon_sym_SLASH] = ACTIONS(2296),
    [anon_sym_PERCENT] = ACTIONS(2296),
    [anon_sym_PIPE_PIPE] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_PIPE] = ACTIONS(2296),
    [anon_sym_CARET] = ACTIONS(2296),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_EQ_EQ] = ACTIONS(2298),
    [anon_sym_BANG_EQ] = ACTIONS(2298),
    [anon_sym_GT] = ACTIONS(2296),
    [anon_sym_GT_EQ] = ACTIONS(2298),
    [anon_sym_LT_EQ] = ACTIONS(2296),
    [anon_sym_LT] = ACTIONS(2296),
    [anon_sym_LT_LT] = ACTIONS(2296),
    [anon_sym_GT_GT] = ACTIONS(2296),
    [anon_sym_COLON] = ACTIONS(2296),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym_in] = ACTIONS(2296),
    [anon_sym_out] = ACTIONS(2296),
    [anon_sym_inout] = ACTIONS(2296),
    [anon_sym_virtual] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym___attribute] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2298),
    [anon_sym___declspec] = ACTIONS(2296),
    [anon_sym___based] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_LBRACK] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_EQ] = ACTIONS(2296),
    [anon_sym_register] = ACTIONS(2296),
    [anon_sym_inline] = ACTIONS(2296),
    [anon_sym___inline] = ACTIONS(2296),
    [anon_sym___inline__] = ACTIONS(2296),
    [anon_sym___forceinline] = ACTIONS(2296),
    [anon_sym_thread_local] = ACTIONS(2296),
    [anon_sym___thread] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym__Nonnull] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [anon_sym_QMARK] = ACTIONS(2298),
    [anon_sym_STAR_EQ] = ACTIONS(2298),
    [anon_sym_SLASH_EQ] = ACTIONS(2298),
    [anon_sym_PERCENT_EQ] = ACTIONS(2298),
    [anon_sym_PLUS_EQ] = ACTIONS(2298),
    [anon_sym_DASH_EQ] = ACTIONS(2298),
    [anon_sym_LT_LT_EQ] = ACTIONS(2298),
    [anon_sym_GT_GT_EQ] = ACTIONS(2298),
    [anon_sym_AMP_EQ] = ACTIONS(2298),
    [anon_sym_CARET_EQ] = ACTIONS(2298),
    [anon_sym_PIPE_EQ] = ACTIONS(2298),
    [anon_sym_and_eq] = ACTIONS(2296),
    [anon_sym_or_eq] = ACTIONS(2296),
    [anon_sym_xor_eq] = ACTIONS(2296),
    [anon_sym_LT_EQ_GT] = ACTIONS(2298),
    [anon_sym_or] = ACTIONS(2296),
    [anon_sym_and] = ACTIONS(2296),
    [anon_sym_bitor] = ACTIONS(2296),
    [anon_sym_xor] = ACTIONS(2296),
    [anon_sym_bitand] = ACTIONS(2296),
    [anon_sym_not_eq] = ACTIONS(2296),
    [anon_sym_is] = ACTIONS(2296),
    [anon_sym_as] = ACTIONS(2296),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_DOT] = ACTIONS(2296),
    [anon_sym_DOT_STAR] = ACTIONS(2298),
    [anon_sym_DASH_GT] = ACTIONS(2296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_This] = ACTIONS(2296),
    [anon_sym_decltype] = ACTIONS(2296),
    [anon_sym_template] = ACTIONS(2296),
    [anon_sym_operator] = ACTIONS(2296),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2298),
    [anon_sym_precise] = ACTIONS(2296),
    [anon_sym_shared] = ACTIONS(2296),
    [anon_sym_groupshared] = ACTIONS(2296),
    [anon_sym_uniform] = ACTIONS(2296),
    [anon_sym_row_major] = ACTIONS(2296),
    [anon_sym_column_major] = ACTIONS(2296),
    [anon_sym_globallycoherent] = ACTIONS(2296),
    [anon_sym_centroid] = ACTIONS(2296),
    [anon_sym_noperspective] = ACTIONS(2296),
    [anon_sym_nointerpolation] = ACTIONS(2296),
    [anon_sym_sample] = ACTIONS(2296),
    [anon_sym_linear] = ACTIONS(2296),
    [anon_sym_snorm] = ACTIONS(2296),
    [anon_sym_unorm] = ACTIONS(2296),
    [anon_sym_point] = ACTIONS(2296),
    [anon_sym_line] = ACTIONS(2296),
    [anon_sym_triangleadj] = ACTIONS(2296),
    [anon_sym_lineadj] = ACTIONS(2296),
    [anon_sym_triangle] = ACTIONS(2296),
  },
  [1507] = {
    [sym_type_qualifier] = STATE(1502),
    [sym_alignas_qualifier] = STATE(3113),
    [sym_expression] = STATE(5979),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [aux_sym_array_declarator_repeat1] = STATE(1502),
    [sym_identifier] = ACTIONS(5599),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(5601),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5569),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_static] = ACTIONS(5603),
    [anon_sym_RBRACK] = ACTIONS(5605),
    [anon_sym_const] = ACTIONS(5575),
    [anon_sym_constexpr] = ACTIONS(5575),
    [anon_sym_volatile] = ACTIONS(5575),
    [anon_sym_restrict] = ACTIONS(5575),
    [anon_sym___restrict__] = ACTIONS(5575),
    [anon_sym__Atomic] = ACTIONS(5575),
    [anon_sym__Noreturn] = ACTIONS(5575),
    [anon_sym_noreturn] = ACTIONS(5575),
    [anon_sym__Nonnull] = ACTIONS(5575),
    [anon_sym_mutable] = ACTIONS(5575),
    [anon_sym_constinit] = ACTIONS(5575),
    [anon_sym_consteval] = ACTIONS(5575),
    [anon_sym_alignas] = ACTIONS(5577),
    [anon_sym__Alignas] = ACTIONS(5577),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1508] = {
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2266),
    [anon_sym_COMMA] = ACTIONS(2266),
    [anon_sym_RPAREN] = ACTIONS(2266),
    [anon_sym_LPAREN2] = ACTIONS(2266),
    [anon_sym_TILDE] = ACTIONS(2266),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2264),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_PERCENT] = ACTIONS(2264),
    [anon_sym_PIPE_PIPE] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2266),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_CARET] = ACTIONS(2264),
    [anon_sym_AMP] = ACTIONS(2264),
    [anon_sym_EQ_EQ] = ACTIONS(2266),
    [anon_sym_BANG_EQ] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(2264),
    [anon_sym_GT_EQ] = ACTIONS(2266),
    [anon_sym_LT_EQ] = ACTIONS(2264),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_LT_LT] = ACTIONS(2264),
    [anon_sym_GT_GT] = ACTIONS(2264),
    [anon_sym_COLON] = ACTIONS(2264),
    [anon_sym___extension__] = ACTIONS(2264),
    [anon_sym_in] = ACTIONS(2264),
    [anon_sym_out] = ACTIONS(2264),
    [anon_sym_inout] = ACTIONS(2264),
    [anon_sym_virtual] = ACTIONS(2264),
    [anon_sym_extern] = ACTIONS(2264),
    [anon_sym___attribute__] = ACTIONS(2264),
    [anon_sym___attribute] = ACTIONS(2264),
    [anon_sym_COLON_COLON] = ACTIONS(2266),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2266),
    [anon_sym___declspec] = ACTIONS(2264),
    [anon_sym___based] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_LBRACK] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_EQ] = ACTIONS(2264),
    [anon_sym_register] = ACTIONS(2264),
    [anon_sym_inline] = ACTIONS(2264),
    [anon_sym___inline] = ACTIONS(2264),
    [anon_sym___inline__] = ACTIONS(2264),
    [anon_sym___forceinline] = ACTIONS(2264),
    [anon_sym_thread_local] = ACTIONS(2264),
    [anon_sym___thread] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_constexpr] = ACTIONS(2264),
    [anon_sym_volatile] = ACTIONS(2264),
    [anon_sym_restrict] = ACTIONS(2264),
    [anon_sym___restrict__] = ACTIONS(2264),
    [anon_sym__Atomic] = ACTIONS(2264),
    [anon_sym__Noreturn] = ACTIONS(2264),
    [anon_sym_noreturn] = ACTIONS(2264),
    [anon_sym__Nonnull] = ACTIONS(2264),
    [anon_sym_mutable] = ACTIONS(2264),
    [anon_sym_constinit] = ACTIONS(2264),
    [anon_sym_consteval] = ACTIONS(2264),
    [anon_sym_alignas] = ACTIONS(2264),
    [anon_sym__Alignas] = ACTIONS(2264),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_STAR_EQ] = ACTIONS(2266),
    [anon_sym_SLASH_EQ] = ACTIONS(2266),
    [anon_sym_PERCENT_EQ] = ACTIONS(2266),
    [anon_sym_PLUS_EQ] = ACTIONS(2266),
    [anon_sym_DASH_EQ] = ACTIONS(2266),
    [anon_sym_LT_LT_EQ] = ACTIONS(2266),
    [anon_sym_GT_GT_EQ] = ACTIONS(2266),
    [anon_sym_AMP_EQ] = ACTIONS(2266),
    [anon_sym_CARET_EQ] = ACTIONS(2266),
    [anon_sym_PIPE_EQ] = ACTIONS(2266),
    [anon_sym_and_eq] = ACTIONS(2264),
    [anon_sym_or_eq] = ACTIONS(2264),
    [anon_sym_xor_eq] = ACTIONS(2264),
    [anon_sym_LT_EQ_GT] = ACTIONS(2266),
    [anon_sym_or] = ACTIONS(2264),
    [anon_sym_and] = ACTIONS(2264),
    [anon_sym_bitor] = ACTIONS(2264),
    [anon_sym_xor] = ACTIONS(2264),
    [anon_sym_bitand] = ACTIONS(2264),
    [anon_sym_not_eq] = ACTIONS(2264),
    [anon_sym_is] = ACTIONS(2264),
    [anon_sym_as] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2266),
    [anon_sym_PLUS_PLUS] = ACTIONS(2266),
    [anon_sym_DOT] = ACTIONS(2264),
    [anon_sym_DOT_STAR] = ACTIONS(2266),
    [anon_sym_DASH_GT] = ACTIONS(2264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_This] = ACTIONS(2264),
    [anon_sym_decltype] = ACTIONS(2264),
    [anon_sym_template] = ACTIONS(2264),
    [anon_sym_operator] = ACTIONS(2264),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2266),
    [anon_sym_precise] = ACTIONS(2264),
    [anon_sym_shared] = ACTIONS(2264),
    [anon_sym_groupshared] = ACTIONS(2264),
    [anon_sym_uniform] = ACTIONS(2264),
    [anon_sym_row_major] = ACTIONS(2264),
    [anon_sym_column_major] = ACTIONS(2264),
    [anon_sym_globallycoherent] = ACTIONS(2264),
    [anon_sym_centroid] = ACTIONS(2264),
    [anon_sym_noperspective] = ACTIONS(2264),
    [anon_sym_nointerpolation] = ACTIONS(2264),
    [anon_sym_sample] = ACTIONS(2264),
    [anon_sym_linear] = ACTIONS(2264),
    [anon_sym_snorm] = ACTIONS(2264),
    [anon_sym_unorm] = ACTIONS(2264),
    [anon_sym_point] = ACTIONS(2264),
    [anon_sym_line] = ACTIONS(2264),
    [anon_sym_triangleadj] = ACTIONS(2264),
    [anon_sym_lineadj] = ACTIONS(2264),
    [anon_sym_triangle] = ACTIONS(2264),
  },
  [1509] = {
    [sym_type_qualifier] = STATE(3072),
    [sym_alignas_qualifier] = STATE(3113),
    [sym_expression] = STATE(5925),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [aux_sym_array_declarator_repeat1] = STATE(3072),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(5607),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5569),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_static] = ACTIONS(5571),
    [anon_sym_RBRACK] = ACTIONS(5609),
    [anon_sym_const] = ACTIONS(5575),
    [anon_sym_constexpr] = ACTIONS(5575),
    [anon_sym_volatile] = ACTIONS(5575),
    [anon_sym_restrict] = ACTIONS(5575),
    [anon_sym___restrict__] = ACTIONS(5575),
    [anon_sym__Atomic] = ACTIONS(5575),
    [anon_sym__Noreturn] = ACTIONS(5575),
    [anon_sym_noreturn] = ACTIONS(5575),
    [anon_sym__Nonnull] = ACTIONS(5575),
    [anon_sym_mutable] = ACTIONS(5575),
    [anon_sym_constinit] = ACTIONS(5575),
    [anon_sym_consteval] = ACTIONS(5575),
    [anon_sym_alignas] = ACTIONS(5577),
    [anon_sym__Alignas] = ACTIONS(5577),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1510] = {
    [sym_type_qualifier] = STATE(3072),
    [sym_alignas_qualifier] = STATE(3113),
    [sym_expression] = STATE(5971),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [aux_sym_array_declarator_repeat1] = STATE(3072),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(5611),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5569),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_static] = ACTIONS(5571),
    [anon_sym_RBRACK] = ACTIONS(5613),
    [anon_sym_const] = ACTIONS(5575),
    [anon_sym_constexpr] = ACTIONS(5575),
    [anon_sym_volatile] = ACTIONS(5575),
    [anon_sym_restrict] = ACTIONS(5575),
    [anon_sym___restrict__] = ACTIONS(5575),
    [anon_sym__Atomic] = ACTIONS(5575),
    [anon_sym__Noreturn] = ACTIONS(5575),
    [anon_sym_noreturn] = ACTIONS(5575),
    [anon_sym__Nonnull] = ACTIONS(5575),
    [anon_sym_mutable] = ACTIONS(5575),
    [anon_sym_constinit] = ACTIONS(5575),
    [anon_sym_consteval] = ACTIONS(5575),
    [anon_sym_alignas] = ACTIONS(5577),
    [anon_sym__Alignas] = ACTIONS(5577),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1511] = {
    [sym_type_qualifier] = STATE(3072),
    [sym_alignas_qualifier] = STATE(3113),
    [sym_expression] = STATE(6007),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [aux_sym_array_declarator_repeat1] = STATE(3072),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5569),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_static] = ACTIONS(5571),
    [anon_sym_RBRACK] = ACTIONS(5617),
    [anon_sym_const] = ACTIONS(5575),
    [anon_sym_constexpr] = ACTIONS(5575),
    [anon_sym_volatile] = ACTIONS(5575),
    [anon_sym_restrict] = ACTIONS(5575),
    [anon_sym___restrict__] = ACTIONS(5575),
    [anon_sym__Atomic] = ACTIONS(5575),
    [anon_sym__Noreturn] = ACTIONS(5575),
    [anon_sym_noreturn] = ACTIONS(5575),
    [anon_sym__Nonnull] = ACTIONS(5575),
    [anon_sym_mutable] = ACTIONS(5575),
    [anon_sym_constinit] = ACTIONS(5575),
    [anon_sym_consteval] = ACTIONS(5575),
    [anon_sym_alignas] = ACTIONS(5577),
    [anon_sym__Alignas] = ACTIONS(5577),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1512] = {
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2290),
    [anon_sym_COMMA] = ACTIONS(2290),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_PERCENT] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_CARET] = ACTIONS(2288),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_EQ_EQ] = ACTIONS(2290),
    [anon_sym_BANG_EQ] = ACTIONS(2290),
    [anon_sym_GT] = ACTIONS(2288),
    [anon_sym_GT_EQ] = ACTIONS(2290),
    [anon_sym_LT_EQ] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(2288),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_COLON] = ACTIONS(2288),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_out] = ACTIONS(2288),
    [anon_sym_inout] = ACTIONS(2288),
    [anon_sym_virtual] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_EQ] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [anon_sym_QMARK] = ACTIONS(2290),
    [anon_sym_STAR_EQ] = ACTIONS(2290),
    [anon_sym_SLASH_EQ] = ACTIONS(2290),
    [anon_sym_PERCENT_EQ] = ACTIONS(2290),
    [anon_sym_PLUS_EQ] = ACTIONS(2290),
    [anon_sym_DASH_EQ] = ACTIONS(2290),
    [anon_sym_LT_LT_EQ] = ACTIONS(2290),
    [anon_sym_GT_GT_EQ] = ACTIONS(2290),
    [anon_sym_AMP_EQ] = ACTIONS(2290),
    [anon_sym_CARET_EQ] = ACTIONS(2290),
    [anon_sym_PIPE_EQ] = ACTIONS(2290),
    [anon_sym_and_eq] = ACTIONS(2288),
    [anon_sym_or_eq] = ACTIONS(2288),
    [anon_sym_xor_eq] = ACTIONS(2288),
    [anon_sym_LT_EQ_GT] = ACTIONS(2290),
    [anon_sym_or] = ACTIONS(2288),
    [anon_sym_and] = ACTIONS(2288),
    [anon_sym_bitor] = ACTIONS(2288),
    [anon_sym_xor] = ACTIONS(2288),
    [anon_sym_bitand] = ACTIONS(2288),
    [anon_sym_not_eq] = ACTIONS(2288),
    [anon_sym_is] = ACTIONS(2288),
    [anon_sym_as] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_DOT] = ACTIONS(2288),
    [anon_sym_DOT_STAR] = ACTIONS(2290),
    [anon_sym_DASH_GT] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_This] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2290),
    [anon_sym_precise] = ACTIONS(2288),
    [anon_sym_shared] = ACTIONS(2288),
    [anon_sym_groupshared] = ACTIONS(2288),
    [anon_sym_uniform] = ACTIONS(2288),
    [anon_sym_row_major] = ACTIONS(2288),
    [anon_sym_column_major] = ACTIONS(2288),
    [anon_sym_globallycoherent] = ACTIONS(2288),
    [anon_sym_centroid] = ACTIONS(2288),
    [anon_sym_noperspective] = ACTIONS(2288),
    [anon_sym_nointerpolation] = ACTIONS(2288),
    [anon_sym_sample] = ACTIONS(2288),
    [anon_sym_linear] = ACTIONS(2288),
    [anon_sym_snorm] = ACTIONS(2288),
    [anon_sym_unorm] = ACTIONS(2288),
    [anon_sym_point] = ACTIONS(2288),
    [anon_sym_line] = ACTIONS(2288),
    [anon_sym_triangleadj] = ACTIONS(2288),
    [anon_sym_lineadj] = ACTIONS(2288),
    [anon_sym_triangle] = ACTIONS(2288),
  },
  [1513] = {
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2294),
    [anon_sym_COMMA] = ACTIONS(2294),
    [anon_sym_RPAREN] = ACTIONS(2294),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2292),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_PERCENT] = ACTIONS(2292),
    [anon_sym_PIPE_PIPE] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_PIPE] = ACTIONS(2292),
    [anon_sym_CARET] = ACTIONS(2292),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_EQ_EQ] = ACTIONS(2294),
    [anon_sym_BANG_EQ] = ACTIONS(2294),
    [anon_sym_GT] = ACTIONS(2292),
    [anon_sym_GT_EQ] = ACTIONS(2294),
    [anon_sym_LT_EQ] = ACTIONS(2292),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_LT_LT] = ACTIONS(2292),
    [anon_sym_GT_GT] = ACTIONS(2292),
    [anon_sym_COLON] = ACTIONS(2292),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym_in] = ACTIONS(2292),
    [anon_sym_out] = ACTIONS(2292),
    [anon_sym_inout] = ACTIONS(2292),
    [anon_sym_virtual] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym___attribute] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2294),
    [anon_sym___declspec] = ACTIONS(2292),
    [anon_sym___based] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_EQ] = ACTIONS(2292),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym___inline] = ACTIONS(2292),
    [anon_sym___inline__] = ACTIONS(2292),
    [anon_sym___forceinline] = ACTIONS(2292),
    [anon_sym_thread_local] = ACTIONS(2292),
    [anon_sym___thread] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym__Nonnull] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [anon_sym_QMARK] = ACTIONS(2294),
    [anon_sym_STAR_EQ] = ACTIONS(2294),
    [anon_sym_SLASH_EQ] = ACTIONS(2294),
    [anon_sym_PERCENT_EQ] = ACTIONS(2294),
    [anon_sym_PLUS_EQ] = ACTIONS(2294),
    [anon_sym_DASH_EQ] = ACTIONS(2294),
    [anon_sym_LT_LT_EQ] = ACTIONS(2294),
    [anon_sym_GT_GT_EQ] = ACTIONS(2294),
    [anon_sym_AMP_EQ] = ACTIONS(2294),
    [anon_sym_CARET_EQ] = ACTIONS(2294),
    [anon_sym_PIPE_EQ] = ACTIONS(2294),
    [anon_sym_and_eq] = ACTIONS(2292),
    [anon_sym_or_eq] = ACTIONS(2292),
    [anon_sym_xor_eq] = ACTIONS(2292),
    [anon_sym_LT_EQ_GT] = ACTIONS(2294),
    [anon_sym_or] = ACTIONS(2292),
    [anon_sym_and] = ACTIONS(2292),
    [anon_sym_bitor] = ACTIONS(2292),
    [anon_sym_xor] = ACTIONS(2292),
    [anon_sym_bitand] = ACTIONS(2292),
    [anon_sym_not_eq] = ACTIONS(2292),
    [anon_sym_is] = ACTIONS(2292),
    [anon_sym_as] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_DOT] = ACTIONS(2292),
    [anon_sym_DOT_STAR] = ACTIONS(2294),
    [anon_sym_DASH_GT] = ACTIONS(2292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_This] = ACTIONS(2292),
    [anon_sym_decltype] = ACTIONS(2292),
    [anon_sym_template] = ACTIONS(2292),
    [anon_sym_operator] = ACTIONS(2292),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2294),
    [anon_sym_precise] = ACTIONS(2292),
    [anon_sym_shared] = ACTIONS(2292),
    [anon_sym_groupshared] = ACTIONS(2292),
    [anon_sym_uniform] = ACTIONS(2292),
    [anon_sym_row_major] = ACTIONS(2292),
    [anon_sym_column_major] = ACTIONS(2292),
    [anon_sym_globallycoherent] = ACTIONS(2292),
    [anon_sym_centroid] = ACTIONS(2292),
    [anon_sym_noperspective] = ACTIONS(2292),
    [anon_sym_nointerpolation] = ACTIONS(2292),
    [anon_sym_sample] = ACTIONS(2292),
    [anon_sym_linear] = ACTIONS(2292),
    [anon_sym_snorm] = ACTIONS(2292),
    [anon_sym_unorm] = ACTIONS(2292),
    [anon_sym_point] = ACTIONS(2292),
    [anon_sym_line] = ACTIONS(2292),
    [anon_sym_triangleadj] = ACTIONS(2292),
    [anon_sym_lineadj] = ACTIONS(2292),
    [anon_sym_triangle] = ACTIONS(2292),
  },
  [1514] = {
    [sym_identifier] = ACTIONS(2243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2247),
    [anon_sym_COMMA] = ACTIONS(2247),
    [anon_sym_RPAREN] = ACTIONS(2247),
    [anon_sym_LPAREN2] = ACTIONS(2247),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_SLASH] = ACTIONS(2255),
    [anon_sym_PERCENT] = ACTIONS(2255),
    [anon_sym_PIPE_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2255),
    [anon_sym_CARET] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2245),
    [anon_sym_BANG_EQ] = ACTIONS(2245),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_GT_EQ] = ACTIONS(2245),
    [anon_sym_LT_EQ] = ACTIONS(2255),
    [anon_sym_LT] = ACTIONS(2255),
    [anon_sym_LT_LT] = ACTIONS(2255),
    [anon_sym_GT_GT] = ACTIONS(2255),
    [anon_sym_COLON] = ACTIONS(2243),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_out] = ACTIONS(2243),
    [anon_sym_inout] = ACTIONS(2243),
    [anon_sym_virtual] = ACTIONS(2243),
    [anon_sym_extern] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym___attribute] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2243),
    [anon_sym___based] = ACTIONS(2243),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_EQ] = ACTIONS(2252),
    [anon_sym_register] = ACTIONS(2243),
    [anon_sym_inline] = ACTIONS(2243),
    [anon_sym___inline] = ACTIONS(2243),
    [anon_sym___inline__] = ACTIONS(2243),
    [anon_sym___forceinline] = ACTIONS(2243),
    [anon_sym_thread_local] = ACTIONS(2243),
    [anon_sym___thread] = ACTIONS(2243),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym__Nonnull] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [anon_sym_QMARK] = ACTIONS(2245),
    [anon_sym_STAR_EQ] = ACTIONS(2245),
    [anon_sym_SLASH_EQ] = ACTIONS(2245),
    [anon_sym_PERCENT_EQ] = ACTIONS(2245),
    [anon_sym_PLUS_EQ] = ACTIONS(2245),
    [anon_sym_DASH_EQ] = ACTIONS(2245),
    [anon_sym_LT_LT_EQ] = ACTIONS(2245),
    [anon_sym_GT_GT_EQ] = ACTIONS(2245),
    [anon_sym_AMP_EQ] = ACTIONS(2245),
    [anon_sym_CARET_EQ] = ACTIONS(2245),
    [anon_sym_PIPE_EQ] = ACTIONS(2245),
    [anon_sym_and_eq] = ACTIONS(2255),
    [anon_sym_or_eq] = ACTIONS(2255),
    [anon_sym_xor_eq] = ACTIONS(2255),
    [anon_sym_LT_EQ_GT] = ACTIONS(2245),
    [anon_sym_or] = ACTIONS(2255),
    [anon_sym_and] = ACTIONS(2255),
    [anon_sym_bitor] = ACTIONS(2255),
    [anon_sym_xor] = ACTIONS(2255),
    [anon_sym_bitand] = ACTIONS(2255),
    [anon_sym_not_eq] = ACTIONS(2255),
    [anon_sym_is] = ACTIONS(2255),
    [anon_sym_as] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2245),
    [anon_sym_PLUS_PLUS] = ACTIONS(2245),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2245),
    [anon_sym_DASH_GT] = ACTIONS(2255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2243),
    [anon_sym_let] = ACTIONS(2243),
    [anon_sym_This] = ACTIONS(2243),
    [anon_sym_decltype] = ACTIONS(2243),
    [anon_sym_template] = ACTIONS(2243),
    [anon_sym_operator] = ACTIONS(2243),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2245),
    [anon_sym_precise] = ACTIONS(2243),
    [anon_sym_shared] = ACTIONS(2243),
    [anon_sym_groupshared] = ACTIONS(2243),
    [anon_sym_uniform] = ACTIONS(2243),
    [anon_sym_row_major] = ACTIONS(2243),
    [anon_sym_column_major] = ACTIONS(2243),
    [anon_sym_globallycoherent] = ACTIONS(2243),
    [anon_sym_centroid] = ACTIONS(2243),
    [anon_sym_noperspective] = ACTIONS(2243),
    [anon_sym_nointerpolation] = ACTIONS(2243),
    [anon_sym_sample] = ACTIONS(2243),
    [anon_sym_linear] = ACTIONS(2243),
    [anon_sym_snorm] = ACTIONS(2243),
    [anon_sym_unorm] = ACTIONS(2243),
    [anon_sym_point] = ACTIONS(2243),
    [anon_sym_line] = ACTIONS(2243),
    [anon_sym_triangleadj] = ACTIONS(2243),
    [anon_sym_lineadj] = ACTIONS(2243),
    [anon_sym_triangle] = ACTIONS(2243),
  },
  [1515] = {
    [sym_type_qualifier] = STATE(1502),
    [sym_alignas_qualifier] = STATE(3113),
    [sym_expression] = STATE(5979),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [aux_sym_array_declarator_repeat1] = STATE(1502),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(5601),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5569),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_static] = ACTIONS(5603),
    [anon_sym_RBRACK] = ACTIONS(5605),
    [anon_sym_const] = ACTIONS(5575),
    [anon_sym_constexpr] = ACTIONS(5575),
    [anon_sym_volatile] = ACTIONS(5575),
    [anon_sym_restrict] = ACTIONS(5575),
    [anon_sym___restrict__] = ACTIONS(5575),
    [anon_sym__Atomic] = ACTIONS(5575),
    [anon_sym__Noreturn] = ACTIONS(5575),
    [anon_sym_noreturn] = ACTIONS(5575),
    [anon_sym__Nonnull] = ACTIONS(5575),
    [anon_sym_mutable] = ACTIONS(5575),
    [anon_sym_constinit] = ACTIONS(5575),
    [anon_sym_consteval] = ACTIONS(5575),
    [anon_sym_alignas] = ACTIONS(5577),
    [anon_sym__Alignas] = ACTIONS(5577),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1516] = {
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2302),
    [anon_sym_COMMA] = ACTIONS(2302),
    [anon_sym_RPAREN] = ACTIONS(2302),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_PIPE_PIPE] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_PIPE] = ACTIONS(2300),
    [anon_sym_CARET] = ACTIONS(2300),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_EQ_EQ] = ACTIONS(2302),
    [anon_sym_BANG_EQ] = ACTIONS(2302),
    [anon_sym_GT] = ACTIONS(2300),
    [anon_sym_GT_EQ] = ACTIONS(2302),
    [anon_sym_LT_EQ] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_LT_LT] = ACTIONS(2300),
    [anon_sym_GT_GT] = ACTIONS(2300),
    [anon_sym_COLON] = ACTIONS(2300),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym_in] = ACTIONS(2300),
    [anon_sym_out] = ACTIONS(2300),
    [anon_sym_inout] = ACTIONS(2300),
    [anon_sym_virtual] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym___attribute] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2302),
    [anon_sym___declspec] = ACTIONS(2300),
    [anon_sym___based] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_EQ] = ACTIONS(2300),
    [anon_sym_register] = ACTIONS(2300),
    [anon_sym_inline] = ACTIONS(2300),
    [anon_sym___inline] = ACTIONS(2300),
    [anon_sym___inline__] = ACTIONS(2300),
    [anon_sym___forceinline] = ACTIONS(2300),
    [anon_sym_thread_local] = ACTIONS(2300),
    [anon_sym___thread] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym__Nonnull] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [anon_sym_QMARK] = ACTIONS(2302),
    [anon_sym_STAR_EQ] = ACTIONS(2302),
    [anon_sym_SLASH_EQ] = ACTIONS(2302),
    [anon_sym_PERCENT_EQ] = ACTIONS(2302),
    [anon_sym_PLUS_EQ] = ACTIONS(2302),
    [anon_sym_DASH_EQ] = ACTIONS(2302),
    [anon_sym_LT_LT_EQ] = ACTIONS(2302),
    [anon_sym_GT_GT_EQ] = ACTIONS(2302),
    [anon_sym_AMP_EQ] = ACTIONS(2302),
    [anon_sym_CARET_EQ] = ACTIONS(2302),
    [anon_sym_PIPE_EQ] = ACTIONS(2302),
    [anon_sym_and_eq] = ACTIONS(2300),
    [anon_sym_or_eq] = ACTIONS(2300),
    [anon_sym_xor_eq] = ACTIONS(2300),
    [anon_sym_LT_EQ_GT] = ACTIONS(2302),
    [anon_sym_or] = ACTIONS(2300),
    [anon_sym_and] = ACTIONS(2300),
    [anon_sym_bitor] = ACTIONS(2300),
    [anon_sym_xor] = ACTIONS(2300),
    [anon_sym_bitand] = ACTIONS(2300),
    [anon_sym_not_eq] = ACTIONS(2300),
    [anon_sym_is] = ACTIONS(2300),
    [anon_sym_as] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_DOT] = ACTIONS(2300),
    [anon_sym_DOT_STAR] = ACTIONS(2302),
    [anon_sym_DASH_GT] = ACTIONS(2300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_This] = ACTIONS(2300),
    [anon_sym_decltype] = ACTIONS(2300),
    [anon_sym_template] = ACTIONS(2300),
    [anon_sym_operator] = ACTIONS(2300),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2302),
    [anon_sym_precise] = ACTIONS(2300),
    [anon_sym_shared] = ACTIONS(2300),
    [anon_sym_groupshared] = ACTIONS(2300),
    [anon_sym_uniform] = ACTIONS(2300),
    [anon_sym_row_major] = ACTIONS(2300),
    [anon_sym_column_major] = ACTIONS(2300),
    [anon_sym_globallycoherent] = ACTIONS(2300),
    [anon_sym_centroid] = ACTIONS(2300),
    [anon_sym_noperspective] = ACTIONS(2300),
    [anon_sym_nointerpolation] = ACTIONS(2300),
    [anon_sym_sample] = ACTIONS(2300),
    [anon_sym_linear] = ACTIONS(2300),
    [anon_sym_snorm] = ACTIONS(2300),
    [anon_sym_unorm] = ACTIONS(2300),
    [anon_sym_point] = ACTIONS(2300),
    [anon_sym_line] = ACTIONS(2300),
    [anon_sym_triangleadj] = ACTIONS(2300),
    [anon_sym_lineadj] = ACTIONS(2300),
    [anon_sym_triangle] = ACTIONS(2300),
  },
  [1517] = {
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_COMMA] = ACTIONS(2262),
    [anon_sym_RPAREN] = ACTIONS(2262),
    [anon_sym_LPAREN2] = ACTIONS(2262),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2260),
    [anon_sym_PERCENT] = ACTIONS(2260),
    [anon_sym_PIPE_PIPE] = ACTIONS(2262),
    [anon_sym_AMP_AMP] = ACTIONS(2262),
    [anon_sym_PIPE] = ACTIONS(2260),
    [anon_sym_CARET] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_EQ_EQ] = ACTIONS(2262),
    [anon_sym_BANG_EQ] = ACTIONS(2262),
    [anon_sym_GT] = ACTIONS(2260),
    [anon_sym_GT_EQ] = ACTIONS(2262),
    [anon_sym_LT_EQ] = ACTIONS(2260),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_LT_LT] = ACTIONS(2260),
    [anon_sym_GT_GT] = ACTIONS(2260),
    [anon_sym_COLON] = ACTIONS(2260),
    [anon_sym___extension__] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(2260),
    [anon_sym_out] = ACTIONS(2260),
    [anon_sym_inout] = ACTIONS(2260),
    [anon_sym_virtual] = ACTIONS(2260),
    [anon_sym_extern] = ACTIONS(2260),
    [anon_sym___attribute__] = ACTIONS(2260),
    [anon_sym___attribute] = ACTIONS(2260),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2262),
    [anon_sym___declspec] = ACTIONS(2260),
    [anon_sym___based] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_EQ] = ACTIONS(2260),
    [anon_sym_register] = ACTIONS(2260),
    [anon_sym_inline] = ACTIONS(2260),
    [anon_sym___inline] = ACTIONS(2260),
    [anon_sym___inline__] = ACTIONS(2260),
    [anon_sym___forceinline] = ACTIONS(2260),
    [anon_sym_thread_local] = ACTIONS(2260),
    [anon_sym___thread] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_constexpr] = ACTIONS(2260),
    [anon_sym_volatile] = ACTIONS(2260),
    [anon_sym_restrict] = ACTIONS(2260),
    [anon_sym___restrict__] = ACTIONS(2260),
    [anon_sym__Atomic] = ACTIONS(2260),
    [anon_sym__Noreturn] = ACTIONS(2260),
    [anon_sym_noreturn] = ACTIONS(2260),
    [anon_sym__Nonnull] = ACTIONS(2260),
    [anon_sym_mutable] = ACTIONS(2260),
    [anon_sym_constinit] = ACTIONS(2260),
    [anon_sym_consteval] = ACTIONS(2260),
    [anon_sym_alignas] = ACTIONS(2260),
    [anon_sym__Alignas] = ACTIONS(2260),
    [anon_sym_QMARK] = ACTIONS(2262),
    [anon_sym_STAR_EQ] = ACTIONS(2262),
    [anon_sym_SLASH_EQ] = ACTIONS(2262),
    [anon_sym_PERCENT_EQ] = ACTIONS(2262),
    [anon_sym_PLUS_EQ] = ACTIONS(2262),
    [anon_sym_DASH_EQ] = ACTIONS(2262),
    [anon_sym_LT_LT_EQ] = ACTIONS(2262),
    [anon_sym_GT_GT_EQ] = ACTIONS(2262),
    [anon_sym_AMP_EQ] = ACTIONS(2262),
    [anon_sym_CARET_EQ] = ACTIONS(2262),
    [anon_sym_PIPE_EQ] = ACTIONS(2262),
    [anon_sym_and_eq] = ACTIONS(2260),
    [anon_sym_or_eq] = ACTIONS(2260),
    [anon_sym_xor_eq] = ACTIONS(2260),
    [anon_sym_LT_EQ_GT] = ACTIONS(2262),
    [anon_sym_or] = ACTIONS(2260),
    [anon_sym_and] = ACTIONS(2260),
    [anon_sym_bitor] = ACTIONS(2260),
    [anon_sym_xor] = ACTIONS(2260),
    [anon_sym_bitand] = ACTIONS(2260),
    [anon_sym_not_eq] = ACTIONS(2260),
    [anon_sym_is] = ACTIONS(2260),
    [anon_sym_as] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_DOT] = ACTIONS(2260),
    [anon_sym_DOT_STAR] = ACTIONS(2262),
    [anon_sym_DASH_GT] = ACTIONS(2260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_This] = ACTIONS(2260),
    [anon_sym_decltype] = ACTIONS(2260),
    [anon_sym_template] = ACTIONS(2260),
    [anon_sym_operator] = ACTIONS(2260),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2262),
    [anon_sym_precise] = ACTIONS(2260),
    [anon_sym_shared] = ACTIONS(2260),
    [anon_sym_groupshared] = ACTIONS(2260),
    [anon_sym_uniform] = ACTIONS(2260),
    [anon_sym_row_major] = ACTIONS(2260),
    [anon_sym_column_major] = ACTIONS(2260),
    [anon_sym_globallycoherent] = ACTIONS(2260),
    [anon_sym_centroid] = ACTIONS(2260),
    [anon_sym_noperspective] = ACTIONS(2260),
    [anon_sym_nointerpolation] = ACTIONS(2260),
    [anon_sym_sample] = ACTIONS(2260),
    [anon_sym_linear] = ACTIONS(2260),
    [anon_sym_snorm] = ACTIONS(2260),
    [anon_sym_unorm] = ACTIONS(2260),
    [anon_sym_point] = ACTIONS(2260),
    [anon_sym_line] = ACTIONS(2260),
    [anon_sym_triangleadj] = ACTIONS(2260),
    [anon_sym_lineadj] = ACTIONS(2260),
    [anon_sym_triangle] = ACTIONS(2260),
  },
  [1518] = {
    [sym_type_qualifier] = STATE(1509),
    [sym_alignas_qualifier] = STATE(3113),
    [sym_expression] = STATE(5937),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [aux_sym_array_declarator_repeat1] = STATE(1509),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(5619),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5569),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_static] = ACTIONS(5621),
    [anon_sym_RBRACK] = ACTIONS(5623),
    [anon_sym_const] = ACTIONS(5575),
    [anon_sym_constexpr] = ACTIONS(5575),
    [anon_sym_volatile] = ACTIONS(5575),
    [anon_sym_restrict] = ACTIONS(5575),
    [anon_sym___restrict__] = ACTIONS(5575),
    [anon_sym__Atomic] = ACTIONS(5575),
    [anon_sym__Noreturn] = ACTIONS(5575),
    [anon_sym_noreturn] = ACTIONS(5575),
    [anon_sym__Nonnull] = ACTIONS(5575),
    [anon_sym_mutable] = ACTIONS(5575),
    [anon_sym_constinit] = ACTIONS(5575),
    [anon_sym_consteval] = ACTIONS(5575),
    [anon_sym_alignas] = ACTIONS(5577),
    [anon_sym__Alignas] = ACTIONS(5577),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1519] = {
    [sym_type_qualifier] = STATE(1510),
    [sym_alignas_qualifier] = STATE(3113),
    [sym_expression] = STATE(6017),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [aux_sym_array_declarator_repeat1] = STATE(1510),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(5625),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5569),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_static] = ACTIONS(5627),
    [anon_sym_RBRACK] = ACTIONS(5629),
    [anon_sym_const] = ACTIONS(5575),
    [anon_sym_constexpr] = ACTIONS(5575),
    [anon_sym_volatile] = ACTIONS(5575),
    [anon_sym_restrict] = ACTIONS(5575),
    [anon_sym___restrict__] = ACTIONS(5575),
    [anon_sym__Atomic] = ACTIONS(5575),
    [anon_sym__Noreturn] = ACTIONS(5575),
    [anon_sym_noreturn] = ACTIONS(5575),
    [anon_sym__Nonnull] = ACTIONS(5575),
    [anon_sym_mutable] = ACTIONS(5575),
    [anon_sym_constinit] = ACTIONS(5575),
    [anon_sym_consteval] = ACTIONS(5575),
    [anon_sym_alignas] = ACTIONS(5577),
    [anon_sym__Alignas] = ACTIONS(5577),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1520] = {
    [sym_type_qualifier] = STATE(1522),
    [sym_alignas_qualifier] = STATE(3113),
    [sym_expression] = STATE(6065),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [aux_sym_array_declarator_repeat1] = STATE(1522),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(5631),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5569),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_static] = ACTIONS(5633),
    [anon_sym_RBRACK] = ACTIONS(5635),
    [anon_sym_const] = ACTIONS(5575),
    [anon_sym_constexpr] = ACTIONS(5575),
    [anon_sym_volatile] = ACTIONS(5575),
    [anon_sym_restrict] = ACTIONS(5575),
    [anon_sym___restrict__] = ACTIONS(5575),
    [anon_sym__Atomic] = ACTIONS(5575),
    [anon_sym__Noreturn] = ACTIONS(5575),
    [anon_sym_noreturn] = ACTIONS(5575),
    [anon_sym__Nonnull] = ACTIONS(5575),
    [anon_sym_mutable] = ACTIONS(5575),
    [anon_sym_constinit] = ACTIONS(5575),
    [anon_sym_consteval] = ACTIONS(5575),
    [anon_sym_alignas] = ACTIONS(5577),
    [anon_sym__Alignas] = ACTIONS(5577),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1521] = {
    [sym_type_qualifier] = STATE(3072),
    [sym_alignas_qualifier] = STATE(3113),
    [sym_expression] = STATE(5904),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [aux_sym_array_declarator_repeat1] = STATE(3072),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(5637),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5569),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_static] = ACTIONS(5571),
    [anon_sym_RBRACK] = ACTIONS(5639),
    [anon_sym_const] = ACTIONS(5575),
    [anon_sym_constexpr] = ACTIONS(5575),
    [anon_sym_volatile] = ACTIONS(5575),
    [anon_sym_restrict] = ACTIONS(5575),
    [anon_sym___restrict__] = ACTIONS(5575),
    [anon_sym__Atomic] = ACTIONS(5575),
    [anon_sym__Noreturn] = ACTIONS(5575),
    [anon_sym_noreturn] = ACTIONS(5575),
    [anon_sym__Nonnull] = ACTIONS(5575),
    [anon_sym_mutable] = ACTIONS(5575),
    [anon_sym_constinit] = ACTIONS(5575),
    [anon_sym_consteval] = ACTIONS(5575),
    [anon_sym_alignas] = ACTIONS(5577),
    [anon_sym__Alignas] = ACTIONS(5577),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1522] = {
    [sym_type_qualifier] = STATE(3072),
    [sym_alignas_qualifier] = STATE(3113),
    [sym_expression] = STATE(5985),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [aux_sym_array_declarator_repeat1] = STATE(3072),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(5641),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5569),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_static] = ACTIONS(5571),
    [anon_sym_RBRACK] = ACTIONS(5643),
    [anon_sym_const] = ACTIONS(5575),
    [anon_sym_constexpr] = ACTIONS(5575),
    [anon_sym_volatile] = ACTIONS(5575),
    [anon_sym_restrict] = ACTIONS(5575),
    [anon_sym___restrict__] = ACTIONS(5575),
    [anon_sym__Atomic] = ACTIONS(5575),
    [anon_sym__Noreturn] = ACTIONS(5575),
    [anon_sym_noreturn] = ACTIONS(5575),
    [anon_sym__Nonnull] = ACTIONS(5575),
    [anon_sym_mutable] = ACTIONS(5575),
    [anon_sym_constinit] = ACTIONS(5575),
    [anon_sym_consteval] = ACTIONS(5575),
    [anon_sym_alignas] = ACTIONS(5577),
    [anon_sym__Alignas] = ACTIONS(5577),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1523] = {
    [sym_type_qualifier] = STATE(1525),
    [sym_alignas_qualifier] = STATE(3113),
    [sym_expression] = STATE(5916),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [aux_sym_array_declarator_repeat1] = STATE(1525),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(5645),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5569),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_static] = ACTIONS(5647),
    [anon_sym_RBRACK] = ACTIONS(5649),
    [anon_sym_const] = ACTIONS(5575),
    [anon_sym_constexpr] = ACTIONS(5575),
    [anon_sym_volatile] = ACTIONS(5575),
    [anon_sym_restrict] = ACTIONS(5575),
    [anon_sym___restrict__] = ACTIONS(5575),
    [anon_sym__Atomic] = ACTIONS(5575),
    [anon_sym__Noreturn] = ACTIONS(5575),
    [anon_sym_noreturn] = ACTIONS(5575),
    [anon_sym__Nonnull] = ACTIONS(5575),
    [anon_sym_mutable] = ACTIONS(5575),
    [anon_sym_constinit] = ACTIONS(5575),
    [anon_sym_consteval] = ACTIONS(5575),
    [anon_sym_alignas] = ACTIONS(5577),
    [anon_sym__Alignas] = ACTIONS(5577),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1524] = {
    [sym_type_qualifier] = STATE(1526),
    [sym_alignas_qualifier] = STATE(3113),
    [sym_expression] = STATE(5919),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [aux_sym_array_declarator_repeat1] = STATE(1526),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(5651),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5569),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_static] = ACTIONS(5653),
    [anon_sym_RBRACK] = ACTIONS(5655),
    [anon_sym_const] = ACTIONS(5575),
    [anon_sym_constexpr] = ACTIONS(5575),
    [anon_sym_volatile] = ACTIONS(5575),
    [anon_sym_restrict] = ACTIONS(5575),
    [anon_sym___restrict__] = ACTIONS(5575),
    [anon_sym__Atomic] = ACTIONS(5575),
    [anon_sym__Noreturn] = ACTIONS(5575),
    [anon_sym_noreturn] = ACTIONS(5575),
    [anon_sym__Nonnull] = ACTIONS(5575),
    [anon_sym_mutable] = ACTIONS(5575),
    [anon_sym_constinit] = ACTIONS(5575),
    [anon_sym_consteval] = ACTIONS(5575),
    [anon_sym_alignas] = ACTIONS(5577),
    [anon_sym__Alignas] = ACTIONS(5577),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1525] = {
    [sym_type_qualifier] = STATE(3072),
    [sym_alignas_qualifier] = STATE(3113),
    [sym_expression] = STATE(5960),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [aux_sym_array_declarator_repeat1] = STATE(3072),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(5657),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5569),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_static] = ACTIONS(5571),
    [anon_sym_RBRACK] = ACTIONS(5659),
    [anon_sym_const] = ACTIONS(5575),
    [anon_sym_constexpr] = ACTIONS(5575),
    [anon_sym_volatile] = ACTIONS(5575),
    [anon_sym_restrict] = ACTIONS(5575),
    [anon_sym___restrict__] = ACTIONS(5575),
    [anon_sym__Atomic] = ACTIONS(5575),
    [anon_sym__Noreturn] = ACTIONS(5575),
    [anon_sym_noreturn] = ACTIONS(5575),
    [anon_sym__Nonnull] = ACTIONS(5575),
    [anon_sym_mutable] = ACTIONS(5575),
    [anon_sym_constinit] = ACTIONS(5575),
    [anon_sym_consteval] = ACTIONS(5575),
    [anon_sym_alignas] = ACTIONS(5577),
    [anon_sym__Alignas] = ACTIONS(5577),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1526] = {
    [sym_type_qualifier] = STATE(3072),
    [sym_alignas_qualifier] = STATE(3113),
    [sym_expression] = STATE(6034),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [aux_sym_array_declarator_repeat1] = STATE(3072),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(5661),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5569),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_static] = ACTIONS(5571),
    [anon_sym_RBRACK] = ACTIONS(5663),
    [anon_sym_const] = ACTIONS(5575),
    [anon_sym_constexpr] = ACTIONS(5575),
    [anon_sym_volatile] = ACTIONS(5575),
    [anon_sym_restrict] = ACTIONS(5575),
    [anon_sym___restrict__] = ACTIONS(5575),
    [anon_sym__Atomic] = ACTIONS(5575),
    [anon_sym__Noreturn] = ACTIONS(5575),
    [anon_sym_noreturn] = ACTIONS(5575),
    [anon_sym__Nonnull] = ACTIONS(5575),
    [anon_sym_mutable] = ACTIONS(5575),
    [anon_sym_constinit] = ACTIONS(5575),
    [anon_sym_consteval] = ACTIONS(5575),
    [anon_sym_alignas] = ACTIONS(5577),
    [anon_sym__Alignas] = ACTIONS(5577),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1527] = {
    [sym_type_qualifier] = STATE(1511),
    [sym_alignas_qualifier] = STATE(3113),
    [sym_expression] = STATE(5987),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [aux_sym_array_declarator_repeat1] = STATE(1511),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(5665),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5569),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_static] = ACTIONS(5667),
    [anon_sym_RBRACK] = ACTIONS(5669),
    [anon_sym_const] = ACTIONS(5575),
    [anon_sym_constexpr] = ACTIONS(5575),
    [anon_sym_volatile] = ACTIONS(5575),
    [anon_sym_restrict] = ACTIONS(5575),
    [anon_sym___restrict__] = ACTIONS(5575),
    [anon_sym__Atomic] = ACTIONS(5575),
    [anon_sym__Noreturn] = ACTIONS(5575),
    [anon_sym_noreturn] = ACTIONS(5575),
    [anon_sym__Nonnull] = ACTIONS(5575),
    [anon_sym_mutable] = ACTIONS(5575),
    [anon_sym_constinit] = ACTIONS(5575),
    [anon_sym_consteval] = ACTIONS(5575),
    [anon_sym_alignas] = ACTIONS(5577),
    [anon_sym__Alignas] = ACTIONS(5577),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1528] = {
    [sym_identifier] = ACTIONS(2268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2270),
    [anon_sym_COMMA] = ACTIONS(2270),
    [anon_sym_RPAREN] = ACTIONS(2270),
    [anon_sym_LPAREN2] = ACTIONS(2270),
    [anon_sym_TILDE] = ACTIONS(2270),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2268),
    [anon_sym_SLASH] = ACTIONS(2268),
    [anon_sym_PERCENT] = ACTIONS(2268),
    [anon_sym_PIPE_PIPE] = ACTIONS(2270),
    [anon_sym_AMP_AMP] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2268),
    [anon_sym_CARET] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2268),
    [anon_sym_EQ_EQ] = ACTIONS(2270),
    [anon_sym_BANG_EQ] = ACTIONS(2270),
    [anon_sym_GT] = ACTIONS(2268),
    [anon_sym_GT_EQ] = ACTIONS(2270),
    [anon_sym_LT_EQ] = ACTIONS(2268),
    [anon_sym_LT] = ACTIONS(2268),
    [anon_sym_LT_LT] = ACTIONS(2268),
    [anon_sym_GT_GT] = ACTIONS(2268),
    [anon_sym_COLON] = ACTIONS(2268),
    [anon_sym___extension__] = ACTIONS(2268),
    [anon_sym_in] = ACTIONS(2268),
    [anon_sym_out] = ACTIONS(2268),
    [anon_sym_inout] = ACTIONS(2268),
    [anon_sym_virtual] = ACTIONS(2268),
    [anon_sym_extern] = ACTIONS(2268),
    [anon_sym___attribute__] = ACTIONS(2268),
    [anon_sym___attribute] = ACTIONS(2268),
    [anon_sym_COLON_COLON] = ACTIONS(2270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2270),
    [anon_sym___declspec] = ACTIONS(2268),
    [anon_sym___based] = ACTIONS(2268),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_LBRACK] = ACTIONS(2268),
    [anon_sym_static] = ACTIONS(2268),
    [anon_sym_EQ] = ACTIONS(2268),
    [anon_sym_register] = ACTIONS(2268),
    [anon_sym_inline] = ACTIONS(2268),
    [anon_sym___inline] = ACTIONS(2268),
    [anon_sym___inline__] = ACTIONS(2268),
    [anon_sym___forceinline] = ACTIONS(2268),
    [anon_sym_thread_local] = ACTIONS(2268),
    [anon_sym___thread] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_constexpr] = ACTIONS(2268),
    [anon_sym_volatile] = ACTIONS(2268),
    [anon_sym_restrict] = ACTIONS(2268),
    [anon_sym___restrict__] = ACTIONS(2268),
    [anon_sym__Atomic] = ACTIONS(2268),
    [anon_sym__Noreturn] = ACTIONS(2268),
    [anon_sym_noreturn] = ACTIONS(2268),
    [anon_sym__Nonnull] = ACTIONS(2268),
    [anon_sym_mutable] = ACTIONS(2268),
    [anon_sym_constinit] = ACTIONS(2268),
    [anon_sym_consteval] = ACTIONS(2268),
    [anon_sym_alignas] = ACTIONS(2268),
    [anon_sym__Alignas] = ACTIONS(2268),
    [anon_sym_QMARK] = ACTIONS(2270),
    [anon_sym_STAR_EQ] = ACTIONS(2270),
    [anon_sym_SLASH_EQ] = ACTIONS(2270),
    [anon_sym_PERCENT_EQ] = ACTIONS(2270),
    [anon_sym_PLUS_EQ] = ACTIONS(2270),
    [anon_sym_DASH_EQ] = ACTIONS(2270),
    [anon_sym_LT_LT_EQ] = ACTIONS(2270),
    [anon_sym_GT_GT_EQ] = ACTIONS(2270),
    [anon_sym_AMP_EQ] = ACTIONS(2270),
    [anon_sym_CARET_EQ] = ACTIONS(2270),
    [anon_sym_PIPE_EQ] = ACTIONS(2270),
    [anon_sym_and_eq] = ACTIONS(2268),
    [anon_sym_or_eq] = ACTIONS(2268),
    [anon_sym_xor_eq] = ACTIONS(2268),
    [anon_sym_LT_EQ_GT] = ACTIONS(2270),
    [anon_sym_or] = ACTIONS(2268),
    [anon_sym_and] = ACTIONS(2268),
    [anon_sym_bitor] = ACTIONS(2268),
    [anon_sym_xor] = ACTIONS(2268),
    [anon_sym_bitand] = ACTIONS(2268),
    [anon_sym_not_eq] = ACTIONS(2268),
    [anon_sym_is] = ACTIONS(2268),
    [anon_sym_as] = ACTIONS(2268),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_DOT] = ACTIONS(2268),
    [anon_sym_DOT_STAR] = ACTIONS(2270),
    [anon_sym_DASH_GT] = ACTIONS(2268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_This] = ACTIONS(2268),
    [anon_sym_decltype] = ACTIONS(2268),
    [anon_sym_template] = ACTIONS(2268),
    [anon_sym_operator] = ACTIONS(2268),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2270),
    [anon_sym_precise] = ACTIONS(2268),
    [anon_sym_shared] = ACTIONS(2268),
    [anon_sym_groupshared] = ACTIONS(2268),
    [anon_sym_uniform] = ACTIONS(2268),
    [anon_sym_row_major] = ACTIONS(2268),
    [anon_sym_column_major] = ACTIONS(2268),
    [anon_sym_globallycoherent] = ACTIONS(2268),
    [anon_sym_centroid] = ACTIONS(2268),
    [anon_sym_noperspective] = ACTIONS(2268),
    [anon_sym_nointerpolation] = ACTIONS(2268),
    [anon_sym_sample] = ACTIONS(2268),
    [anon_sym_linear] = ACTIONS(2268),
    [anon_sym_snorm] = ACTIONS(2268),
    [anon_sym_unorm] = ACTIONS(2268),
    [anon_sym_point] = ACTIONS(2268),
    [anon_sym_line] = ACTIONS(2268),
    [anon_sym_triangleadj] = ACTIONS(2268),
    [anon_sym_lineadj] = ACTIONS(2268),
    [anon_sym_triangle] = ACTIONS(2268),
  },
  [1529] = {
    [sym_type_qualifier] = STATE(1521),
    [sym_alignas_qualifier] = STATE(3113),
    [sym_expression] = STATE(5881),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [aux_sym_array_declarator_repeat1] = STATE(1521),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(5671),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5569),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_static] = ACTIONS(5673),
    [anon_sym_RBRACK] = ACTIONS(5675),
    [anon_sym_const] = ACTIONS(5575),
    [anon_sym_constexpr] = ACTIONS(5575),
    [anon_sym_volatile] = ACTIONS(5575),
    [anon_sym_restrict] = ACTIONS(5575),
    [anon_sym___restrict__] = ACTIONS(5575),
    [anon_sym__Atomic] = ACTIONS(5575),
    [anon_sym__Noreturn] = ACTIONS(5575),
    [anon_sym_noreturn] = ACTIONS(5575),
    [anon_sym__Nonnull] = ACTIONS(5575),
    [anon_sym_mutable] = ACTIONS(5575),
    [anon_sym_constinit] = ACTIONS(5575),
    [anon_sym_consteval] = ACTIONS(5575),
    [anon_sym_alignas] = ACTIONS(5577),
    [anon_sym__Alignas] = ACTIONS(5577),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1530] = {
    [sym_expression] = STATE(3773),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5677),
    [anon_sym_LPAREN2] = ACTIONS(5680),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5683),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(3349),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3354),
    [anon_sym___extension__] = ACTIONS(5686),
    [anon_sym_COLON_COLON] = ACTIONS(5689),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(5692),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3373),
    [anon_sym_template] = ACTIONS(3376),
    [anon_sym_operator] = ACTIONS(3362),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1531] = {
    [sym_expression] = STATE(4254),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5503),
    [anon_sym_LPAREN2] = ACTIONS(5695),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(5704),
    [anon_sym___extension__] = ACTIONS(5506),
    [anon_sym_COLON_COLON] = ACTIONS(5509),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(5692),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3373),
    [anon_sym_template] = ACTIONS(3376),
    [anon_sym_operator] = ACTIONS(3362),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1532] = {
    [sym_identifier] = ACTIONS(2243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2247),
    [anon_sym_COMMA] = ACTIONS(2247),
    [anon_sym_RPAREN] = ACTIONS(2247),
    [anon_sym_LPAREN2] = ACTIONS(2247),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_SLASH] = ACTIONS(2255),
    [anon_sym_PERCENT] = ACTIONS(2255),
    [anon_sym_PIPE_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2255),
    [anon_sym_CARET] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2245),
    [anon_sym_BANG_EQ] = ACTIONS(2245),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_GT_EQ] = ACTIONS(2245),
    [anon_sym_LT_EQ] = ACTIONS(2255),
    [anon_sym_LT] = ACTIONS(2255),
    [anon_sym_LT_LT] = ACTIONS(2255),
    [anon_sym_GT_GT] = ACTIONS(2255),
    [anon_sym_COLON] = ACTIONS(2243),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_out] = ACTIONS(2243),
    [anon_sym_inout] = ACTIONS(2243),
    [anon_sym_virtual] = ACTIONS(2243),
    [anon_sym_extern] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym___attribute] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2243),
    [anon_sym___based] = ACTIONS(2243),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_EQ] = ACTIONS(2252),
    [anon_sym_register] = ACTIONS(2243),
    [anon_sym_inline] = ACTIONS(2243),
    [anon_sym___inline] = ACTIONS(2243),
    [anon_sym___inline__] = ACTIONS(2243),
    [anon_sym___forceinline] = ACTIONS(2243),
    [anon_sym_thread_local] = ACTIONS(2243),
    [anon_sym___thread] = ACTIONS(2243),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym__Nonnull] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [anon_sym_QMARK] = ACTIONS(2245),
    [anon_sym_STAR_EQ] = ACTIONS(2245),
    [anon_sym_SLASH_EQ] = ACTIONS(2245),
    [anon_sym_PERCENT_EQ] = ACTIONS(2245),
    [anon_sym_PLUS_EQ] = ACTIONS(2245),
    [anon_sym_DASH_EQ] = ACTIONS(2245),
    [anon_sym_LT_LT_EQ] = ACTIONS(2245),
    [anon_sym_GT_GT_EQ] = ACTIONS(2245),
    [anon_sym_AMP_EQ] = ACTIONS(2245),
    [anon_sym_CARET_EQ] = ACTIONS(2245),
    [anon_sym_PIPE_EQ] = ACTIONS(2245),
    [anon_sym_LT_EQ_GT] = ACTIONS(2245),
    [anon_sym_or] = ACTIONS(2255),
    [anon_sym_and] = ACTIONS(2255),
    [anon_sym_bitor] = ACTIONS(2255),
    [anon_sym_xor] = ACTIONS(2255),
    [anon_sym_bitand] = ACTIONS(2255),
    [anon_sym_not_eq] = ACTIONS(2255),
    [anon_sym_is] = ACTIONS(2255),
    [anon_sym_as] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2245),
    [anon_sym_PLUS_PLUS] = ACTIONS(2245),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2245),
    [anon_sym_DASH_GT] = ACTIONS(2255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2243),
    [anon_sym_let] = ACTIONS(2243),
    [anon_sym_This] = ACTIONS(2243),
    [anon_sym_decltype] = ACTIONS(2243),
    [anon_sym_template] = ACTIONS(2243),
    [anon_sym_operator] = ACTIONS(2243),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2245),
    [anon_sym_precise] = ACTIONS(2243),
    [anon_sym_shared] = ACTIONS(2243),
    [anon_sym_groupshared] = ACTIONS(2243),
    [anon_sym_uniform] = ACTIONS(2243),
    [anon_sym_row_major] = ACTIONS(2243),
    [anon_sym_column_major] = ACTIONS(2243),
    [anon_sym_globallycoherent] = ACTIONS(2243),
    [anon_sym_centroid] = ACTIONS(2243),
    [anon_sym_noperspective] = ACTIONS(2243),
    [anon_sym_nointerpolation] = ACTIONS(2243),
    [anon_sym_sample] = ACTIONS(2243),
    [anon_sym_linear] = ACTIONS(2243),
    [anon_sym_snorm] = ACTIONS(2243),
    [anon_sym_unorm] = ACTIONS(2243),
    [anon_sym_point] = ACTIONS(2243),
    [anon_sym_line] = ACTIONS(2243),
    [anon_sym_triangleadj] = ACTIONS(2243),
    [anon_sym_lineadj] = ACTIONS(2243),
    [anon_sym_triangle] = ACTIONS(2243),
  },
  [1533] = {
    [sym_identifier] = ACTIONS(2268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2270),
    [anon_sym_COMMA] = ACTIONS(2270),
    [anon_sym_RPAREN] = ACTIONS(2270),
    [anon_sym_LPAREN2] = ACTIONS(2270),
    [anon_sym_TILDE] = ACTIONS(2270),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2268),
    [anon_sym_SLASH] = ACTIONS(2268),
    [anon_sym_PERCENT] = ACTIONS(2268),
    [anon_sym_PIPE_PIPE] = ACTIONS(2270),
    [anon_sym_AMP_AMP] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2268),
    [anon_sym_CARET] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2268),
    [anon_sym_EQ_EQ] = ACTIONS(2270),
    [anon_sym_BANG_EQ] = ACTIONS(2270),
    [anon_sym_GT] = ACTIONS(2268),
    [anon_sym_GT_EQ] = ACTIONS(2270),
    [anon_sym_LT_EQ] = ACTIONS(2268),
    [anon_sym_LT] = ACTIONS(2268),
    [anon_sym_LT_LT] = ACTIONS(2268),
    [anon_sym_GT_GT] = ACTIONS(2268),
    [anon_sym_COLON] = ACTIONS(2268),
    [anon_sym___extension__] = ACTIONS(2268),
    [anon_sym_in] = ACTIONS(2268),
    [anon_sym_out] = ACTIONS(2268),
    [anon_sym_inout] = ACTIONS(2268),
    [anon_sym_virtual] = ACTIONS(2268),
    [anon_sym_extern] = ACTIONS(2268),
    [anon_sym___attribute__] = ACTIONS(2268),
    [anon_sym___attribute] = ACTIONS(2268),
    [anon_sym_COLON_COLON] = ACTIONS(2270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2270),
    [anon_sym___declspec] = ACTIONS(2268),
    [anon_sym___based] = ACTIONS(2268),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_LBRACK] = ACTIONS(2268),
    [anon_sym_static] = ACTIONS(2268),
    [anon_sym_EQ] = ACTIONS(2268),
    [anon_sym_register] = ACTIONS(2268),
    [anon_sym_inline] = ACTIONS(2268),
    [anon_sym___inline] = ACTIONS(2268),
    [anon_sym___inline__] = ACTIONS(2268),
    [anon_sym___forceinline] = ACTIONS(2268),
    [anon_sym_thread_local] = ACTIONS(2268),
    [anon_sym___thread] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_constexpr] = ACTIONS(2268),
    [anon_sym_volatile] = ACTIONS(2268),
    [anon_sym_restrict] = ACTIONS(2268),
    [anon_sym___restrict__] = ACTIONS(2268),
    [anon_sym__Atomic] = ACTIONS(2268),
    [anon_sym__Noreturn] = ACTIONS(2268),
    [anon_sym_noreturn] = ACTIONS(2268),
    [anon_sym__Nonnull] = ACTIONS(2268),
    [anon_sym_mutable] = ACTIONS(2268),
    [anon_sym_constinit] = ACTIONS(2268),
    [anon_sym_consteval] = ACTIONS(2268),
    [anon_sym_alignas] = ACTIONS(2268),
    [anon_sym__Alignas] = ACTIONS(2268),
    [anon_sym_QMARK] = ACTIONS(2270),
    [anon_sym_STAR_EQ] = ACTIONS(2270),
    [anon_sym_SLASH_EQ] = ACTIONS(2270),
    [anon_sym_PERCENT_EQ] = ACTIONS(2270),
    [anon_sym_PLUS_EQ] = ACTIONS(2270),
    [anon_sym_DASH_EQ] = ACTIONS(2270),
    [anon_sym_LT_LT_EQ] = ACTIONS(2270),
    [anon_sym_GT_GT_EQ] = ACTIONS(2270),
    [anon_sym_AMP_EQ] = ACTIONS(2270),
    [anon_sym_CARET_EQ] = ACTIONS(2270),
    [anon_sym_PIPE_EQ] = ACTIONS(2270),
    [anon_sym_LT_EQ_GT] = ACTIONS(2270),
    [anon_sym_or] = ACTIONS(2268),
    [anon_sym_and] = ACTIONS(2268),
    [anon_sym_bitor] = ACTIONS(2268),
    [anon_sym_xor] = ACTIONS(2268),
    [anon_sym_bitand] = ACTIONS(2268),
    [anon_sym_not_eq] = ACTIONS(2268),
    [anon_sym_is] = ACTIONS(2268),
    [anon_sym_as] = ACTIONS(2268),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_DOT] = ACTIONS(2268),
    [anon_sym_DOT_STAR] = ACTIONS(2270),
    [anon_sym_DASH_GT] = ACTIONS(2268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_This] = ACTIONS(2268),
    [anon_sym_decltype] = ACTIONS(2268),
    [anon_sym_template] = ACTIONS(2268),
    [anon_sym_operator] = ACTIONS(2268),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2270),
    [anon_sym_precise] = ACTIONS(2268),
    [anon_sym_shared] = ACTIONS(2268),
    [anon_sym_groupshared] = ACTIONS(2268),
    [anon_sym_uniform] = ACTIONS(2268),
    [anon_sym_row_major] = ACTIONS(2268),
    [anon_sym_column_major] = ACTIONS(2268),
    [anon_sym_globallycoherent] = ACTIONS(2268),
    [anon_sym_centroid] = ACTIONS(2268),
    [anon_sym_noperspective] = ACTIONS(2268),
    [anon_sym_nointerpolation] = ACTIONS(2268),
    [anon_sym_sample] = ACTIONS(2268),
    [anon_sym_linear] = ACTIONS(2268),
    [anon_sym_snorm] = ACTIONS(2268),
    [anon_sym_unorm] = ACTIONS(2268),
    [anon_sym_point] = ACTIONS(2268),
    [anon_sym_line] = ACTIONS(2268),
    [anon_sym_triangleadj] = ACTIONS(2268),
    [anon_sym_lineadj] = ACTIONS(2268),
    [anon_sym_triangle] = ACTIONS(2268),
  },
  [1534] = {
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2274),
    [anon_sym_COMMA] = ACTIONS(2274),
    [anon_sym_RPAREN] = ACTIONS(2274),
    [anon_sym_LPAREN2] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2272),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_PERCENT] = ACTIONS(2272),
    [anon_sym_PIPE_PIPE] = ACTIONS(2274),
    [anon_sym_AMP_AMP] = ACTIONS(2274),
    [anon_sym_PIPE] = ACTIONS(2272),
    [anon_sym_CARET] = ACTIONS(2272),
    [anon_sym_AMP] = ACTIONS(2272),
    [anon_sym_EQ_EQ] = ACTIONS(2274),
    [anon_sym_BANG_EQ] = ACTIONS(2274),
    [anon_sym_GT] = ACTIONS(2272),
    [anon_sym_GT_EQ] = ACTIONS(2274),
    [anon_sym_LT_EQ] = ACTIONS(2272),
    [anon_sym_LT] = ACTIONS(2272),
    [anon_sym_LT_LT] = ACTIONS(2272),
    [anon_sym_GT_GT] = ACTIONS(2272),
    [anon_sym_COLON] = ACTIONS(2272),
    [anon_sym___extension__] = ACTIONS(2272),
    [anon_sym_in] = ACTIONS(2272),
    [anon_sym_out] = ACTIONS(2272),
    [anon_sym_inout] = ACTIONS(2272),
    [anon_sym_virtual] = ACTIONS(2272),
    [anon_sym_extern] = ACTIONS(2272),
    [anon_sym___attribute__] = ACTIONS(2272),
    [anon_sym___attribute] = ACTIONS(2272),
    [anon_sym_COLON_COLON] = ACTIONS(2274),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2274),
    [anon_sym___declspec] = ACTIONS(2272),
    [anon_sym___based] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_EQ] = ACTIONS(2272),
    [anon_sym_register] = ACTIONS(2272),
    [anon_sym_inline] = ACTIONS(2272),
    [anon_sym___inline] = ACTIONS(2272),
    [anon_sym___inline__] = ACTIONS(2272),
    [anon_sym___forceinline] = ACTIONS(2272),
    [anon_sym_thread_local] = ACTIONS(2272),
    [anon_sym___thread] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_constexpr] = ACTIONS(2272),
    [anon_sym_volatile] = ACTIONS(2272),
    [anon_sym_restrict] = ACTIONS(2272),
    [anon_sym___restrict__] = ACTIONS(2272),
    [anon_sym__Atomic] = ACTIONS(2272),
    [anon_sym__Noreturn] = ACTIONS(2272),
    [anon_sym_noreturn] = ACTIONS(2272),
    [anon_sym__Nonnull] = ACTIONS(2272),
    [anon_sym_mutable] = ACTIONS(2272),
    [anon_sym_constinit] = ACTIONS(2272),
    [anon_sym_consteval] = ACTIONS(2272),
    [anon_sym_alignas] = ACTIONS(2272),
    [anon_sym__Alignas] = ACTIONS(2272),
    [anon_sym_QMARK] = ACTIONS(2274),
    [anon_sym_STAR_EQ] = ACTIONS(2274),
    [anon_sym_SLASH_EQ] = ACTIONS(2274),
    [anon_sym_PERCENT_EQ] = ACTIONS(2274),
    [anon_sym_PLUS_EQ] = ACTIONS(2274),
    [anon_sym_DASH_EQ] = ACTIONS(2274),
    [anon_sym_LT_LT_EQ] = ACTIONS(2274),
    [anon_sym_GT_GT_EQ] = ACTIONS(2274),
    [anon_sym_AMP_EQ] = ACTIONS(2274),
    [anon_sym_CARET_EQ] = ACTIONS(2274),
    [anon_sym_PIPE_EQ] = ACTIONS(2274),
    [anon_sym_LT_EQ_GT] = ACTIONS(2274),
    [anon_sym_or] = ACTIONS(2272),
    [anon_sym_and] = ACTIONS(2272),
    [anon_sym_bitor] = ACTIONS(2272),
    [anon_sym_xor] = ACTIONS(2272),
    [anon_sym_bitand] = ACTIONS(2272),
    [anon_sym_not_eq] = ACTIONS(2272),
    [anon_sym_is] = ACTIONS(2272),
    [anon_sym_as] = ACTIONS(2272),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_DOT] = ACTIONS(2272),
    [anon_sym_DOT_STAR] = ACTIONS(2274),
    [anon_sym_DASH_GT] = ACTIONS(2272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_This] = ACTIONS(2272),
    [anon_sym_decltype] = ACTIONS(2272),
    [anon_sym_template] = ACTIONS(2272),
    [anon_sym_operator] = ACTIONS(2272),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2274),
    [anon_sym_precise] = ACTIONS(2272),
    [anon_sym_shared] = ACTIONS(2272),
    [anon_sym_groupshared] = ACTIONS(2272),
    [anon_sym_uniform] = ACTIONS(2272),
    [anon_sym_row_major] = ACTIONS(2272),
    [anon_sym_column_major] = ACTIONS(2272),
    [anon_sym_globallycoherent] = ACTIONS(2272),
    [anon_sym_centroid] = ACTIONS(2272),
    [anon_sym_noperspective] = ACTIONS(2272),
    [anon_sym_nointerpolation] = ACTIONS(2272),
    [anon_sym_sample] = ACTIONS(2272),
    [anon_sym_linear] = ACTIONS(2272),
    [anon_sym_snorm] = ACTIONS(2272),
    [anon_sym_unorm] = ACTIONS(2272),
    [anon_sym_point] = ACTIONS(2272),
    [anon_sym_line] = ACTIONS(2272),
    [anon_sym_triangleadj] = ACTIONS(2272),
    [anon_sym_lineadj] = ACTIONS(2272),
    [anon_sym_triangle] = ACTIONS(2272),
  },
  [1535] = {
    [sym_identifier] = ACTIONS(2276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2278),
    [anon_sym_COMMA] = ACTIONS(2278),
    [anon_sym_RPAREN] = ACTIONS(2278),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_PLUS] = ACTIONS(2276),
    [anon_sym_STAR] = ACTIONS(2276),
    [anon_sym_SLASH] = ACTIONS(2276),
    [anon_sym_PERCENT] = ACTIONS(2276),
    [anon_sym_PIPE_PIPE] = ACTIONS(2278),
    [anon_sym_AMP_AMP] = ACTIONS(2278),
    [anon_sym_PIPE] = ACTIONS(2276),
    [anon_sym_CARET] = ACTIONS(2276),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_EQ_EQ] = ACTIONS(2278),
    [anon_sym_BANG_EQ] = ACTIONS(2278),
    [anon_sym_GT] = ACTIONS(2276),
    [anon_sym_GT_EQ] = ACTIONS(2278),
    [anon_sym_LT_EQ] = ACTIONS(2276),
    [anon_sym_LT] = ACTIONS(2276),
    [anon_sym_LT_LT] = ACTIONS(2276),
    [anon_sym_GT_GT] = ACTIONS(2276),
    [anon_sym_COLON] = ACTIONS(2276),
    [anon_sym___extension__] = ACTIONS(2276),
    [anon_sym_in] = ACTIONS(2276),
    [anon_sym_out] = ACTIONS(2276),
    [anon_sym_inout] = ACTIONS(2276),
    [anon_sym_virtual] = ACTIONS(2276),
    [anon_sym_extern] = ACTIONS(2276),
    [anon_sym___attribute__] = ACTIONS(2276),
    [anon_sym___attribute] = ACTIONS(2276),
    [anon_sym_COLON_COLON] = ACTIONS(2278),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2278),
    [anon_sym___declspec] = ACTIONS(2276),
    [anon_sym___based] = ACTIONS(2276),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_LBRACK] = ACTIONS(2276),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_EQ] = ACTIONS(2276),
    [anon_sym_register] = ACTIONS(2276),
    [anon_sym_inline] = ACTIONS(2276),
    [anon_sym___inline] = ACTIONS(2276),
    [anon_sym___inline__] = ACTIONS(2276),
    [anon_sym___forceinline] = ACTIONS(2276),
    [anon_sym_thread_local] = ACTIONS(2276),
    [anon_sym___thread] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_constexpr] = ACTIONS(2276),
    [anon_sym_volatile] = ACTIONS(2276),
    [anon_sym_restrict] = ACTIONS(2276),
    [anon_sym___restrict__] = ACTIONS(2276),
    [anon_sym__Atomic] = ACTIONS(2276),
    [anon_sym__Noreturn] = ACTIONS(2276),
    [anon_sym_noreturn] = ACTIONS(2276),
    [anon_sym__Nonnull] = ACTIONS(2276),
    [anon_sym_mutable] = ACTIONS(2276),
    [anon_sym_constinit] = ACTIONS(2276),
    [anon_sym_consteval] = ACTIONS(2276),
    [anon_sym_alignas] = ACTIONS(2276),
    [anon_sym__Alignas] = ACTIONS(2276),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_STAR_EQ] = ACTIONS(2278),
    [anon_sym_SLASH_EQ] = ACTIONS(2278),
    [anon_sym_PERCENT_EQ] = ACTIONS(2278),
    [anon_sym_PLUS_EQ] = ACTIONS(2278),
    [anon_sym_DASH_EQ] = ACTIONS(2278),
    [anon_sym_LT_LT_EQ] = ACTIONS(2278),
    [anon_sym_GT_GT_EQ] = ACTIONS(2278),
    [anon_sym_AMP_EQ] = ACTIONS(2278),
    [anon_sym_CARET_EQ] = ACTIONS(2278),
    [anon_sym_PIPE_EQ] = ACTIONS(2278),
    [anon_sym_LT_EQ_GT] = ACTIONS(2278),
    [anon_sym_or] = ACTIONS(2276),
    [anon_sym_and] = ACTIONS(2276),
    [anon_sym_bitor] = ACTIONS(2276),
    [anon_sym_xor] = ACTIONS(2276),
    [anon_sym_bitand] = ACTIONS(2276),
    [anon_sym_not_eq] = ACTIONS(2276),
    [anon_sym_is] = ACTIONS(2276),
    [anon_sym_as] = ACTIONS(2276),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DOT] = ACTIONS(2276),
    [anon_sym_DOT_STAR] = ACTIONS(2278),
    [anon_sym_DASH_GT] = ACTIONS(2276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_This] = ACTIONS(2276),
    [anon_sym_decltype] = ACTIONS(2276),
    [anon_sym_template] = ACTIONS(2276),
    [anon_sym_operator] = ACTIONS(2276),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2278),
    [anon_sym_precise] = ACTIONS(2276),
    [anon_sym_shared] = ACTIONS(2276),
    [anon_sym_groupshared] = ACTIONS(2276),
    [anon_sym_uniform] = ACTIONS(2276),
    [anon_sym_row_major] = ACTIONS(2276),
    [anon_sym_column_major] = ACTIONS(2276),
    [anon_sym_globallycoherent] = ACTIONS(2276),
    [anon_sym_centroid] = ACTIONS(2276),
    [anon_sym_noperspective] = ACTIONS(2276),
    [anon_sym_nointerpolation] = ACTIONS(2276),
    [anon_sym_sample] = ACTIONS(2276),
    [anon_sym_linear] = ACTIONS(2276),
    [anon_sym_snorm] = ACTIONS(2276),
    [anon_sym_unorm] = ACTIONS(2276),
    [anon_sym_point] = ACTIONS(2276),
    [anon_sym_line] = ACTIONS(2276),
    [anon_sym_triangleadj] = ACTIONS(2276),
    [anon_sym_lineadj] = ACTIONS(2276),
    [anon_sym_triangle] = ACTIONS(2276),
  },
  [1536] = {
    [sym_identifier] = ACTIONS(2239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2241),
    [anon_sym_COMMA] = ACTIONS(2241),
    [anon_sym_RPAREN] = ACTIONS(2241),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2239),
    [anon_sym_PLUS] = ACTIONS(2239),
    [anon_sym_STAR] = ACTIONS(2239),
    [anon_sym_SLASH] = ACTIONS(2239),
    [anon_sym_PERCENT] = ACTIONS(2239),
    [anon_sym_PIPE_PIPE] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_PIPE] = ACTIONS(2239),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_LT_EQ] = ACTIONS(2239),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_LT_LT] = ACTIONS(2239),
    [anon_sym_GT_GT] = ACTIONS(2239),
    [anon_sym_COLON] = ACTIONS(2239),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym_in] = ACTIONS(2239),
    [anon_sym_out] = ACTIONS(2239),
    [anon_sym_inout] = ACTIONS(2239),
    [anon_sym_virtual] = ACTIONS(2239),
    [anon_sym_extern] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym___attribute] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2241),
    [anon_sym___declspec] = ACTIONS(2239),
    [anon_sym___based] = ACTIONS(2239),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2239),
    [anon_sym_EQ] = ACTIONS(2239),
    [anon_sym_register] = ACTIONS(2239),
    [anon_sym_inline] = ACTIONS(2239),
    [anon_sym___inline] = ACTIONS(2239),
    [anon_sym___inline__] = ACTIONS(2239),
    [anon_sym___forceinline] = ACTIONS(2239),
    [anon_sym_thread_local] = ACTIONS(2239),
    [anon_sym___thread] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym__Nonnull] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [anon_sym_QMARK] = ACTIONS(2241),
    [anon_sym_STAR_EQ] = ACTIONS(2241),
    [anon_sym_SLASH_EQ] = ACTIONS(2241),
    [anon_sym_PERCENT_EQ] = ACTIONS(2241),
    [anon_sym_PLUS_EQ] = ACTIONS(2241),
    [anon_sym_DASH_EQ] = ACTIONS(2241),
    [anon_sym_LT_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_GT_EQ] = ACTIONS(2241),
    [anon_sym_AMP_EQ] = ACTIONS(2241),
    [anon_sym_CARET_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_EQ] = ACTIONS(2241),
    [anon_sym_LT_EQ_GT] = ACTIONS(2241),
    [anon_sym_or] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(2239),
    [anon_sym_bitor] = ACTIONS(2239),
    [anon_sym_xor] = ACTIONS(2239),
    [anon_sym_bitand] = ACTIONS(2239),
    [anon_sym_not_eq] = ACTIONS(2239),
    [anon_sym_is] = ACTIONS(2239),
    [anon_sym_as] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2239),
    [anon_sym_DOT_STAR] = ACTIONS(2241),
    [anon_sym_DASH_GT] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2239),
    [anon_sym_let] = ACTIONS(2239),
    [anon_sym_This] = ACTIONS(2239),
    [anon_sym_decltype] = ACTIONS(2239),
    [anon_sym_template] = ACTIONS(2239),
    [anon_sym_operator] = ACTIONS(2239),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2241),
    [anon_sym_precise] = ACTIONS(2239),
    [anon_sym_shared] = ACTIONS(2239),
    [anon_sym_groupshared] = ACTIONS(2239),
    [anon_sym_uniform] = ACTIONS(2239),
    [anon_sym_row_major] = ACTIONS(2239),
    [anon_sym_column_major] = ACTIONS(2239),
    [anon_sym_globallycoherent] = ACTIONS(2239),
    [anon_sym_centroid] = ACTIONS(2239),
    [anon_sym_noperspective] = ACTIONS(2239),
    [anon_sym_nointerpolation] = ACTIONS(2239),
    [anon_sym_sample] = ACTIONS(2239),
    [anon_sym_linear] = ACTIONS(2239),
    [anon_sym_snorm] = ACTIONS(2239),
    [anon_sym_unorm] = ACTIONS(2239),
    [anon_sym_point] = ACTIONS(2239),
    [anon_sym_line] = ACTIONS(2239),
    [anon_sym_triangleadj] = ACTIONS(2239),
    [anon_sym_lineadj] = ACTIONS(2239),
    [anon_sym_triangle] = ACTIONS(2239),
  },
  [1537] = {
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_COMMA] = ACTIONS(2282),
    [anon_sym_RPAREN] = ACTIONS(2282),
    [anon_sym_LPAREN2] = ACTIONS(2282),
    [anon_sym_TILDE] = ACTIONS(2282),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2280),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_PERCENT] = ACTIONS(2280),
    [anon_sym_PIPE_PIPE] = ACTIONS(2282),
    [anon_sym_AMP_AMP] = ACTIONS(2282),
    [anon_sym_PIPE] = ACTIONS(2280),
    [anon_sym_CARET] = ACTIONS(2280),
    [anon_sym_AMP] = ACTIONS(2280),
    [anon_sym_EQ_EQ] = ACTIONS(2282),
    [anon_sym_BANG_EQ] = ACTIONS(2282),
    [anon_sym_GT] = ACTIONS(2280),
    [anon_sym_GT_EQ] = ACTIONS(2282),
    [anon_sym_LT_EQ] = ACTIONS(2280),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_LT_LT] = ACTIONS(2280),
    [anon_sym_GT_GT] = ACTIONS(2280),
    [anon_sym_COLON] = ACTIONS(2280),
    [anon_sym___extension__] = ACTIONS(2280),
    [anon_sym_in] = ACTIONS(2280),
    [anon_sym_out] = ACTIONS(2280),
    [anon_sym_inout] = ACTIONS(2280),
    [anon_sym_virtual] = ACTIONS(2280),
    [anon_sym_extern] = ACTIONS(2280),
    [anon_sym___attribute__] = ACTIONS(2280),
    [anon_sym___attribute] = ACTIONS(2280),
    [anon_sym_COLON_COLON] = ACTIONS(2282),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2282),
    [anon_sym___declspec] = ACTIONS(2280),
    [anon_sym___based] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_LBRACK] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_EQ] = ACTIONS(2280),
    [anon_sym_register] = ACTIONS(2280),
    [anon_sym_inline] = ACTIONS(2280),
    [anon_sym___inline] = ACTIONS(2280),
    [anon_sym___inline__] = ACTIONS(2280),
    [anon_sym___forceinline] = ACTIONS(2280),
    [anon_sym_thread_local] = ACTIONS(2280),
    [anon_sym___thread] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_constexpr] = ACTIONS(2280),
    [anon_sym_volatile] = ACTIONS(2280),
    [anon_sym_restrict] = ACTIONS(2280),
    [anon_sym___restrict__] = ACTIONS(2280),
    [anon_sym__Atomic] = ACTIONS(2280),
    [anon_sym__Noreturn] = ACTIONS(2280),
    [anon_sym_noreturn] = ACTIONS(2280),
    [anon_sym__Nonnull] = ACTIONS(2280),
    [anon_sym_mutable] = ACTIONS(2280),
    [anon_sym_constinit] = ACTIONS(2280),
    [anon_sym_consteval] = ACTIONS(2280),
    [anon_sym_alignas] = ACTIONS(2280),
    [anon_sym__Alignas] = ACTIONS(2280),
    [anon_sym_QMARK] = ACTIONS(2282),
    [anon_sym_STAR_EQ] = ACTIONS(2282),
    [anon_sym_SLASH_EQ] = ACTIONS(2282),
    [anon_sym_PERCENT_EQ] = ACTIONS(2282),
    [anon_sym_PLUS_EQ] = ACTIONS(2282),
    [anon_sym_DASH_EQ] = ACTIONS(2282),
    [anon_sym_LT_LT_EQ] = ACTIONS(2282),
    [anon_sym_GT_GT_EQ] = ACTIONS(2282),
    [anon_sym_AMP_EQ] = ACTIONS(2282),
    [anon_sym_CARET_EQ] = ACTIONS(2282),
    [anon_sym_PIPE_EQ] = ACTIONS(2282),
    [anon_sym_LT_EQ_GT] = ACTIONS(2282),
    [anon_sym_or] = ACTIONS(2280),
    [anon_sym_and] = ACTIONS(2280),
    [anon_sym_bitor] = ACTIONS(2280),
    [anon_sym_xor] = ACTIONS(2280),
    [anon_sym_bitand] = ACTIONS(2280),
    [anon_sym_not_eq] = ACTIONS(2280),
    [anon_sym_is] = ACTIONS(2280),
    [anon_sym_as] = ACTIONS(2280),
    [anon_sym_DASH_DASH] = ACTIONS(2282),
    [anon_sym_PLUS_PLUS] = ACTIONS(2282),
    [anon_sym_DOT] = ACTIONS(2280),
    [anon_sym_DOT_STAR] = ACTIONS(2282),
    [anon_sym_DASH_GT] = ACTIONS(2280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_This] = ACTIONS(2280),
    [anon_sym_decltype] = ACTIONS(2280),
    [anon_sym_template] = ACTIONS(2280),
    [anon_sym_operator] = ACTIONS(2280),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2282),
    [anon_sym_precise] = ACTIONS(2280),
    [anon_sym_shared] = ACTIONS(2280),
    [anon_sym_groupshared] = ACTIONS(2280),
    [anon_sym_uniform] = ACTIONS(2280),
    [anon_sym_row_major] = ACTIONS(2280),
    [anon_sym_column_major] = ACTIONS(2280),
    [anon_sym_globallycoherent] = ACTIONS(2280),
    [anon_sym_centroid] = ACTIONS(2280),
    [anon_sym_noperspective] = ACTIONS(2280),
    [anon_sym_nointerpolation] = ACTIONS(2280),
    [anon_sym_sample] = ACTIONS(2280),
    [anon_sym_linear] = ACTIONS(2280),
    [anon_sym_snorm] = ACTIONS(2280),
    [anon_sym_unorm] = ACTIONS(2280),
    [anon_sym_point] = ACTIONS(2280),
    [anon_sym_line] = ACTIONS(2280),
    [anon_sym_triangleadj] = ACTIONS(2280),
    [anon_sym_lineadj] = ACTIONS(2280),
    [anon_sym_triangle] = ACTIONS(2280),
  },
  [1538] = {
    [sym_identifier] = ACTIONS(2284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2286),
    [anon_sym_COMMA] = ACTIONS(2286),
    [anon_sym_RPAREN] = ACTIONS(2286),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2284),
    [anon_sym_SLASH] = ACTIONS(2284),
    [anon_sym_PERCENT] = ACTIONS(2284),
    [anon_sym_PIPE_PIPE] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2284),
    [anon_sym_CARET] = ACTIONS(2284),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_EQ_EQ] = ACTIONS(2286),
    [anon_sym_BANG_EQ] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2284),
    [anon_sym_GT_EQ] = ACTIONS(2286),
    [anon_sym_LT_EQ] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2284),
    [anon_sym_LT_LT] = ACTIONS(2284),
    [anon_sym_GT_GT] = ACTIONS(2284),
    [anon_sym_COLON] = ACTIONS(2284),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_in] = ACTIONS(2284),
    [anon_sym_out] = ACTIONS(2284),
    [anon_sym_inout] = ACTIONS(2284),
    [anon_sym_virtual] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_EQ] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [anon_sym_QMARK] = ACTIONS(2286),
    [anon_sym_STAR_EQ] = ACTIONS(2286),
    [anon_sym_SLASH_EQ] = ACTIONS(2286),
    [anon_sym_PERCENT_EQ] = ACTIONS(2286),
    [anon_sym_PLUS_EQ] = ACTIONS(2286),
    [anon_sym_DASH_EQ] = ACTIONS(2286),
    [anon_sym_LT_LT_EQ] = ACTIONS(2286),
    [anon_sym_GT_GT_EQ] = ACTIONS(2286),
    [anon_sym_AMP_EQ] = ACTIONS(2286),
    [anon_sym_CARET_EQ] = ACTIONS(2286),
    [anon_sym_PIPE_EQ] = ACTIONS(2286),
    [anon_sym_LT_EQ_GT] = ACTIONS(2286),
    [anon_sym_or] = ACTIONS(2284),
    [anon_sym_and] = ACTIONS(2284),
    [anon_sym_bitor] = ACTIONS(2284),
    [anon_sym_xor] = ACTIONS(2284),
    [anon_sym_bitand] = ACTIONS(2284),
    [anon_sym_not_eq] = ACTIONS(2284),
    [anon_sym_is] = ACTIONS(2284),
    [anon_sym_as] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_DOT] = ACTIONS(2284),
    [anon_sym_DOT_STAR] = ACTIONS(2286),
    [anon_sym_DASH_GT] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_This] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2286),
    [anon_sym_precise] = ACTIONS(2284),
    [anon_sym_shared] = ACTIONS(2284),
    [anon_sym_groupshared] = ACTIONS(2284),
    [anon_sym_uniform] = ACTIONS(2284),
    [anon_sym_row_major] = ACTIONS(2284),
    [anon_sym_column_major] = ACTIONS(2284),
    [anon_sym_globallycoherent] = ACTIONS(2284),
    [anon_sym_centroid] = ACTIONS(2284),
    [anon_sym_noperspective] = ACTIONS(2284),
    [anon_sym_nointerpolation] = ACTIONS(2284),
    [anon_sym_sample] = ACTIONS(2284),
    [anon_sym_linear] = ACTIONS(2284),
    [anon_sym_snorm] = ACTIONS(2284),
    [anon_sym_unorm] = ACTIONS(2284),
    [anon_sym_point] = ACTIONS(2284),
    [anon_sym_line] = ACTIONS(2284),
    [anon_sym_triangleadj] = ACTIONS(2284),
    [anon_sym_lineadj] = ACTIONS(2284),
    [anon_sym_triangle] = ACTIONS(2284),
  },
  [1539] = {
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2290),
    [anon_sym_COMMA] = ACTIONS(2290),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_PERCENT] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_CARET] = ACTIONS(2288),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_EQ_EQ] = ACTIONS(2290),
    [anon_sym_BANG_EQ] = ACTIONS(2290),
    [anon_sym_GT] = ACTIONS(2288),
    [anon_sym_GT_EQ] = ACTIONS(2290),
    [anon_sym_LT_EQ] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(2288),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_COLON] = ACTIONS(2288),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_out] = ACTIONS(2288),
    [anon_sym_inout] = ACTIONS(2288),
    [anon_sym_virtual] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_EQ] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [anon_sym_QMARK] = ACTIONS(2290),
    [anon_sym_STAR_EQ] = ACTIONS(2290),
    [anon_sym_SLASH_EQ] = ACTIONS(2290),
    [anon_sym_PERCENT_EQ] = ACTIONS(2290),
    [anon_sym_PLUS_EQ] = ACTIONS(2290),
    [anon_sym_DASH_EQ] = ACTIONS(2290),
    [anon_sym_LT_LT_EQ] = ACTIONS(2290),
    [anon_sym_GT_GT_EQ] = ACTIONS(2290),
    [anon_sym_AMP_EQ] = ACTIONS(2290),
    [anon_sym_CARET_EQ] = ACTIONS(2290),
    [anon_sym_PIPE_EQ] = ACTIONS(2290),
    [anon_sym_LT_EQ_GT] = ACTIONS(2290),
    [anon_sym_or] = ACTIONS(2288),
    [anon_sym_and] = ACTIONS(2288),
    [anon_sym_bitor] = ACTIONS(2288),
    [anon_sym_xor] = ACTIONS(2288),
    [anon_sym_bitand] = ACTIONS(2288),
    [anon_sym_not_eq] = ACTIONS(2288),
    [anon_sym_is] = ACTIONS(2288),
    [anon_sym_as] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_DOT] = ACTIONS(2288),
    [anon_sym_DOT_STAR] = ACTIONS(2290),
    [anon_sym_DASH_GT] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_This] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2290),
    [anon_sym_precise] = ACTIONS(2288),
    [anon_sym_shared] = ACTIONS(2288),
    [anon_sym_groupshared] = ACTIONS(2288),
    [anon_sym_uniform] = ACTIONS(2288),
    [anon_sym_row_major] = ACTIONS(2288),
    [anon_sym_column_major] = ACTIONS(2288),
    [anon_sym_globallycoherent] = ACTIONS(2288),
    [anon_sym_centroid] = ACTIONS(2288),
    [anon_sym_noperspective] = ACTIONS(2288),
    [anon_sym_nointerpolation] = ACTIONS(2288),
    [anon_sym_sample] = ACTIONS(2288),
    [anon_sym_linear] = ACTIONS(2288),
    [anon_sym_snorm] = ACTIONS(2288),
    [anon_sym_unorm] = ACTIONS(2288),
    [anon_sym_point] = ACTIONS(2288),
    [anon_sym_line] = ACTIONS(2288),
    [anon_sym_triangleadj] = ACTIONS(2288),
    [anon_sym_lineadj] = ACTIONS(2288),
    [anon_sym_triangle] = ACTIONS(2288),
  },
  [1540] = {
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2294),
    [anon_sym_COMMA] = ACTIONS(2294),
    [anon_sym_RPAREN] = ACTIONS(2294),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2292),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_PERCENT] = ACTIONS(2292),
    [anon_sym_PIPE_PIPE] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_PIPE] = ACTIONS(2292),
    [anon_sym_CARET] = ACTIONS(2292),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_EQ_EQ] = ACTIONS(2294),
    [anon_sym_BANG_EQ] = ACTIONS(2294),
    [anon_sym_GT] = ACTIONS(2292),
    [anon_sym_GT_EQ] = ACTIONS(2294),
    [anon_sym_LT_EQ] = ACTIONS(2292),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_LT_LT] = ACTIONS(2292),
    [anon_sym_GT_GT] = ACTIONS(2292),
    [anon_sym_COLON] = ACTIONS(2292),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym_in] = ACTIONS(2292),
    [anon_sym_out] = ACTIONS(2292),
    [anon_sym_inout] = ACTIONS(2292),
    [anon_sym_virtual] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym___attribute] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2294),
    [anon_sym___declspec] = ACTIONS(2292),
    [anon_sym___based] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_EQ] = ACTIONS(2292),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym___inline] = ACTIONS(2292),
    [anon_sym___inline__] = ACTIONS(2292),
    [anon_sym___forceinline] = ACTIONS(2292),
    [anon_sym_thread_local] = ACTIONS(2292),
    [anon_sym___thread] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym__Nonnull] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [anon_sym_QMARK] = ACTIONS(2294),
    [anon_sym_STAR_EQ] = ACTIONS(2294),
    [anon_sym_SLASH_EQ] = ACTIONS(2294),
    [anon_sym_PERCENT_EQ] = ACTIONS(2294),
    [anon_sym_PLUS_EQ] = ACTIONS(2294),
    [anon_sym_DASH_EQ] = ACTIONS(2294),
    [anon_sym_LT_LT_EQ] = ACTIONS(2294),
    [anon_sym_GT_GT_EQ] = ACTIONS(2294),
    [anon_sym_AMP_EQ] = ACTIONS(2294),
    [anon_sym_CARET_EQ] = ACTIONS(2294),
    [anon_sym_PIPE_EQ] = ACTIONS(2294),
    [anon_sym_LT_EQ_GT] = ACTIONS(2294),
    [anon_sym_or] = ACTIONS(2292),
    [anon_sym_and] = ACTIONS(2292),
    [anon_sym_bitor] = ACTIONS(2292),
    [anon_sym_xor] = ACTIONS(2292),
    [anon_sym_bitand] = ACTIONS(2292),
    [anon_sym_not_eq] = ACTIONS(2292),
    [anon_sym_is] = ACTIONS(2292),
    [anon_sym_as] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_DOT] = ACTIONS(2292),
    [anon_sym_DOT_STAR] = ACTIONS(2294),
    [anon_sym_DASH_GT] = ACTIONS(2292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_This] = ACTIONS(2292),
    [anon_sym_decltype] = ACTIONS(2292),
    [anon_sym_template] = ACTIONS(2292),
    [anon_sym_operator] = ACTIONS(2292),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2294),
    [anon_sym_precise] = ACTIONS(2292),
    [anon_sym_shared] = ACTIONS(2292),
    [anon_sym_groupshared] = ACTIONS(2292),
    [anon_sym_uniform] = ACTIONS(2292),
    [anon_sym_row_major] = ACTIONS(2292),
    [anon_sym_column_major] = ACTIONS(2292),
    [anon_sym_globallycoherent] = ACTIONS(2292),
    [anon_sym_centroid] = ACTIONS(2292),
    [anon_sym_noperspective] = ACTIONS(2292),
    [anon_sym_nointerpolation] = ACTIONS(2292),
    [anon_sym_sample] = ACTIONS(2292),
    [anon_sym_linear] = ACTIONS(2292),
    [anon_sym_snorm] = ACTIONS(2292),
    [anon_sym_unorm] = ACTIONS(2292),
    [anon_sym_point] = ACTIONS(2292),
    [anon_sym_line] = ACTIONS(2292),
    [anon_sym_triangleadj] = ACTIONS(2292),
    [anon_sym_lineadj] = ACTIONS(2292),
    [anon_sym_triangle] = ACTIONS(2292),
  },
  [1541] = {
    [sym_identifier] = ACTIONS(2296),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2298),
    [anon_sym_COMMA] = ACTIONS(2298),
    [anon_sym_RPAREN] = ACTIONS(2298),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2296),
    [anon_sym_SLASH] = ACTIONS(2296),
    [anon_sym_PERCENT] = ACTIONS(2296),
    [anon_sym_PIPE_PIPE] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_PIPE] = ACTIONS(2296),
    [anon_sym_CARET] = ACTIONS(2296),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_EQ_EQ] = ACTIONS(2298),
    [anon_sym_BANG_EQ] = ACTIONS(2298),
    [anon_sym_GT] = ACTIONS(2296),
    [anon_sym_GT_EQ] = ACTIONS(2298),
    [anon_sym_LT_EQ] = ACTIONS(2296),
    [anon_sym_LT] = ACTIONS(2296),
    [anon_sym_LT_LT] = ACTIONS(2296),
    [anon_sym_GT_GT] = ACTIONS(2296),
    [anon_sym_COLON] = ACTIONS(2296),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym_in] = ACTIONS(2296),
    [anon_sym_out] = ACTIONS(2296),
    [anon_sym_inout] = ACTIONS(2296),
    [anon_sym_virtual] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym___attribute] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2298),
    [anon_sym___declspec] = ACTIONS(2296),
    [anon_sym___based] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_LBRACK] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_EQ] = ACTIONS(2296),
    [anon_sym_register] = ACTIONS(2296),
    [anon_sym_inline] = ACTIONS(2296),
    [anon_sym___inline] = ACTIONS(2296),
    [anon_sym___inline__] = ACTIONS(2296),
    [anon_sym___forceinline] = ACTIONS(2296),
    [anon_sym_thread_local] = ACTIONS(2296),
    [anon_sym___thread] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym__Nonnull] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [anon_sym_QMARK] = ACTIONS(2298),
    [anon_sym_STAR_EQ] = ACTIONS(2298),
    [anon_sym_SLASH_EQ] = ACTIONS(2298),
    [anon_sym_PERCENT_EQ] = ACTIONS(2298),
    [anon_sym_PLUS_EQ] = ACTIONS(2298),
    [anon_sym_DASH_EQ] = ACTIONS(2298),
    [anon_sym_LT_LT_EQ] = ACTIONS(2298),
    [anon_sym_GT_GT_EQ] = ACTIONS(2298),
    [anon_sym_AMP_EQ] = ACTIONS(2298),
    [anon_sym_CARET_EQ] = ACTIONS(2298),
    [anon_sym_PIPE_EQ] = ACTIONS(2298),
    [anon_sym_LT_EQ_GT] = ACTIONS(2298),
    [anon_sym_or] = ACTIONS(2296),
    [anon_sym_and] = ACTIONS(2296),
    [anon_sym_bitor] = ACTIONS(2296),
    [anon_sym_xor] = ACTIONS(2296),
    [anon_sym_bitand] = ACTIONS(2296),
    [anon_sym_not_eq] = ACTIONS(2296),
    [anon_sym_is] = ACTIONS(2296),
    [anon_sym_as] = ACTIONS(2296),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_DOT] = ACTIONS(2296),
    [anon_sym_DOT_STAR] = ACTIONS(2298),
    [anon_sym_DASH_GT] = ACTIONS(2296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_This] = ACTIONS(2296),
    [anon_sym_decltype] = ACTIONS(2296),
    [anon_sym_template] = ACTIONS(2296),
    [anon_sym_operator] = ACTIONS(2296),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2298),
    [anon_sym_precise] = ACTIONS(2296),
    [anon_sym_shared] = ACTIONS(2296),
    [anon_sym_groupshared] = ACTIONS(2296),
    [anon_sym_uniform] = ACTIONS(2296),
    [anon_sym_row_major] = ACTIONS(2296),
    [anon_sym_column_major] = ACTIONS(2296),
    [anon_sym_globallycoherent] = ACTIONS(2296),
    [anon_sym_centroid] = ACTIONS(2296),
    [anon_sym_noperspective] = ACTIONS(2296),
    [anon_sym_nointerpolation] = ACTIONS(2296),
    [anon_sym_sample] = ACTIONS(2296),
    [anon_sym_linear] = ACTIONS(2296),
    [anon_sym_snorm] = ACTIONS(2296),
    [anon_sym_unorm] = ACTIONS(2296),
    [anon_sym_point] = ACTIONS(2296),
    [anon_sym_line] = ACTIONS(2296),
    [anon_sym_triangleadj] = ACTIONS(2296),
    [anon_sym_lineadj] = ACTIONS(2296),
    [anon_sym_triangle] = ACTIONS(2296),
  },
  [1542] = {
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2266),
    [anon_sym_COMMA] = ACTIONS(2266),
    [anon_sym_RPAREN] = ACTIONS(2266),
    [anon_sym_LPAREN2] = ACTIONS(2266),
    [anon_sym_TILDE] = ACTIONS(2266),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2264),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_PERCENT] = ACTIONS(2264),
    [anon_sym_PIPE_PIPE] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2266),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_CARET] = ACTIONS(2264),
    [anon_sym_AMP] = ACTIONS(2264),
    [anon_sym_EQ_EQ] = ACTIONS(2266),
    [anon_sym_BANG_EQ] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(2264),
    [anon_sym_GT_EQ] = ACTIONS(2266),
    [anon_sym_LT_EQ] = ACTIONS(2264),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_LT_LT] = ACTIONS(2264),
    [anon_sym_GT_GT] = ACTIONS(2264),
    [anon_sym_COLON] = ACTIONS(2264),
    [anon_sym___extension__] = ACTIONS(2264),
    [anon_sym_in] = ACTIONS(2264),
    [anon_sym_out] = ACTIONS(2264),
    [anon_sym_inout] = ACTIONS(2264),
    [anon_sym_virtual] = ACTIONS(2264),
    [anon_sym_extern] = ACTIONS(2264),
    [anon_sym___attribute__] = ACTIONS(2264),
    [anon_sym___attribute] = ACTIONS(2264),
    [anon_sym_COLON_COLON] = ACTIONS(2266),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2266),
    [anon_sym___declspec] = ACTIONS(2264),
    [anon_sym___based] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_LBRACK] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_EQ] = ACTIONS(2264),
    [anon_sym_register] = ACTIONS(2264),
    [anon_sym_inline] = ACTIONS(2264),
    [anon_sym___inline] = ACTIONS(2264),
    [anon_sym___inline__] = ACTIONS(2264),
    [anon_sym___forceinline] = ACTIONS(2264),
    [anon_sym_thread_local] = ACTIONS(2264),
    [anon_sym___thread] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_constexpr] = ACTIONS(2264),
    [anon_sym_volatile] = ACTIONS(2264),
    [anon_sym_restrict] = ACTIONS(2264),
    [anon_sym___restrict__] = ACTIONS(2264),
    [anon_sym__Atomic] = ACTIONS(2264),
    [anon_sym__Noreturn] = ACTIONS(2264),
    [anon_sym_noreturn] = ACTIONS(2264),
    [anon_sym__Nonnull] = ACTIONS(2264),
    [anon_sym_mutable] = ACTIONS(2264),
    [anon_sym_constinit] = ACTIONS(2264),
    [anon_sym_consteval] = ACTIONS(2264),
    [anon_sym_alignas] = ACTIONS(2264),
    [anon_sym__Alignas] = ACTIONS(2264),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_STAR_EQ] = ACTIONS(2266),
    [anon_sym_SLASH_EQ] = ACTIONS(2266),
    [anon_sym_PERCENT_EQ] = ACTIONS(2266),
    [anon_sym_PLUS_EQ] = ACTIONS(2266),
    [anon_sym_DASH_EQ] = ACTIONS(2266),
    [anon_sym_LT_LT_EQ] = ACTIONS(2266),
    [anon_sym_GT_GT_EQ] = ACTIONS(2266),
    [anon_sym_AMP_EQ] = ACTIONS(2266),
    [anon_sym_CARET_EQ] = ACTIONS(2266),
    [anon_sym_PIPE_EQ] = ACTIONS(2266),
    [anon_sym_LT_EQ_GT] = ACTIONS(2266),
    [anon_sym_or] = ACTIONS(2264),
    [anon_sym_and] = ACTIONS(2264),
    [anon_sym_bitor] = ACTIONS(2264),
    [anon_sym_xor] = ACTIONS(2264),
    [anon_sym_bitand] = ACTIONS(2264),
    [anon_sym_not_eq] = ACTIONS(2264),
    [anon_sym_is] = ACTIONS(2264),
    [anon_sym_as] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2266),
    [anon_sym_PLUS_PLUS] = ACTIONS(2266),
    [anon_sym_DOT] = ACTIONS(2264),
    [anon_sym_DOT_STAR] = ACTIONS(2266),
    [anon_sym_DASH_GT] = ACTIONS(2264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_This] = ACTIONS(2264),
    [anon_sym_decltype] = ACTIONS(2264),
    [anon_sym_template] = ACTIONS(2264),
    [anon_sym_operator] = ACTIONS(2264),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2266),
    [anon_sym_precise] = ACTIONS(2264),
    [anon_sym_shared] = ACTIONS(2264),
    [anon_sym_groupshared] = ACTIONS(2264),
    [anon_sym_uniform] = ACTIONS(2264),
    [anon_sym_row_major] = ACTIONS(2264),
    [anon_sym_column_major] = ACTIONS(2264),
    [anon_sym_globallycoherent] = ACTIONS(2264),
    [anon_sym_centroid] = ACTIONS(2264),
    [anon_sym_noperspective] = ACTIONS(2264),
    [anon_sym_nointerpolation] = ACTIONS(2264),
    [anon_sym_sample] = ACTIONS(2264),
    [anon_sym_linear] = ACTIONS(2264),
    [anon_sym_snorm] = ACTIONS(2264),
    [anon_sym_unorm] = ACTIONS(2264),
    [anon_sym_point] = ACTIONS(2264),
    [anon_sym_line] = ACTIONS(2264),
    [anon_sym_triangleadj] = ACTIONS(2264),
    [anon_sym_lineadj] = ACTIONS(2264),
    [anon_sym_triangle] = ACTIONS(2264),
  },
  [1543] = {
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2302),
    [anon_sym_COMMA] = ACTIONS(2302),
    [anon_sym_RPAREN] = ACTIONS(2302),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_PIPE_PIPE] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_PIPE] = ACTIONS(2300),
    [anon_sym_CARET] = ACTIONS(2300),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_EQ_EQ] = ACTIONS(2302),
    [anon_sym_BANG_EQ] = ACTIONS(2302),
    [anon_sym_GT] = ACTIONS(2300),
    [anon_sym_GT_EQ] = ACTIONS(2302),
    [anon_sym_LT_EQ] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_LT_LT] = ACTIONS(2300),
    [anon_sym_GT_GT] = ACTIONS(2300),
    [anon_sym_COLON] = ACTIONS(2300),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym_in] = ACTIONS(2300),
    [anon_sym_out] = ACTIONS(2300),
    [anon_sym_inout] = ACTIONS(2300),
    [anon_sym_virtual] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym___attribute] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2302),
    [anon_sym___declspec] = ACTIONS(2300),
    [anon_sym___based] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_EQ] = ACTIONS(2300),
    [anon_sym_register] = ACTIONS(2300),
    [anon_sym_inline] = ACTIONS(2300),
    [anon_sym___inline] = ACTIONS(2300),
    [anon_sym___inline__] = ACTIONS(2300),
    [anon_sym___forceinline] = ACTIONS(2300),
    [anon_sym_thread_local] = ACTIONS(2300),
    [anon_sym___thread] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym__Nonnull] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [anon_sym_QMARK] = ACTIONS(2302),
    [anon_sym_STAR_EQ] = ACTIONS(2302),
    [anon_sym_SLASH_EQ] = ACTIONS(2302),
    [anon_sym_PERCENT_EQ] = ACTIONS(2302),
    [anon_sym_PLUS_EQ] = ACTIONS(2302),
    [anon_sym_DASH_EQ] = ACTIONS(2302),
    [anon_sym_LT_LT_EQ] = ACTIONS(2302),
    [anon_sym_GT_GT_EQ] = ACTIONS(2302),
    [anon_sym_AMP_EQ] = ACTIONS(2302),
    [anon_sym_CARET_EQ] = ACTIONS(2302),
    [anon_sym_PIPE_EQ] = ACTIONS(2302),
    [anon_sym_LT_EQ_GT] = ACTIONS(2302),
    [anon_sym_or] = ACTIONS(2300),
    [anon_sym_and] = ACTIONS(2300),
    [anon_sym_bitor] = ACTIONS(2300),
    [anon_sym_xor] = ACTIONS(2300),
    [anon_sym_bitand] = ACTIONS(2300),
    [anon_sym_not_eq] = ACTIONS(2300),
    [anon_sym_is] = ACTIONS(2300),
    [anon_sym_as] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_DOT] = ACTIONS(2300),
    [anon_sym_DOT_STAR] = ACTIONS(2302),
    [anon_sym_DASH_GT] = ACTIONS(2300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_This] = ACTIONS(2300),
    [anon_sym_decltype] = ACTIONS(2300),
    [anon_sym_template] = ACTIONS(2300),
    [anon_sym_operator] = ACTIONS(2300),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2302),
    [anon_sym_precise] = ACTIONS(2300),
    [anon_sym_shared] = ACTIONS(2300),
    [anon_sym_groupshared] = ACTIONS(2300),
    [anon_sym_uniform] = ACTIONS(2300),
    [anon_sym_row_major] = ACTIONS(2300),
    [anon_sym_column_major] = ACTIONS(2300),
    [anon_sym_globallycoherent] = ACTIONS(2300),
    [anon_sym_centroid] = ACTIONS(2300),
    [anon_sym_noperspective] = ACTIONS(2300),
    [anon_sym_nointerpolation] = ACTIONS(2300),
    [anon_sym_sample] = ACTIONS(2300),
    [anon_sym_linear] = ACTIONS(2300),
    [anon_sym_snorm] = ACTIONS(2300),
    [anon_sym_unorm] = ACTIONS(2300),
    [anon_sym_point] = ACTIONS(2300),
    [anon_sym_line] = ACTIONS(2300),
    [anon_sym_triangleadj] = ACTIONS(2300),
    [anon_sym_lineadj] = ACTIONS(2300),
    [anon_sym_triangle] = ACTIONS(2300),
  },
  [1544] = {
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_COMMA] = ACTIONS(2262),
    [anon_sym_RPAREN] = ACTIONS(2262),
    [anon_sym_LPAREN2] = ACTIONS(2262),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2260),
    [anon_sym_PERCENT] = ACTIONS(2260),
    [anon_sym_PIPE_PIPE] = ACTIONS(2262),
    [anon_sym_AMP_AMP] = ACTIONS(2262),
    [anon_sym_PIPE] = ACTIONS(2260),
    [anon_sym_CARET] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_EQ_EQ] = ACTIONS(2262),
    [anon_sym_BANG_EQ] = ACTIONS(2262),
    [anon_sym_GT] = ACTIONS(2260),
    [anon_sym_GT_EQ] = ACTIONS(2262),
    [anon_sym_LT_EQ] = ACTIONS(2260),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_LT_LT] = ACTIONS(2260),
    [anon_sym_GT_GT] = ACTIONS(2260),
    [anon_sym_COLON] = ACTIONS(2260),
    [anon_sym___extension__] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(2260),
    [anon_sym_out] = ACTIONS(2260),
    [anon_sym_inout] = ACTIONS(2260),
    [anon_sym_virtual] = ACTIONS(2260),
    [anon_sym_extern] = ACTIONS(2260),
    [anon_sym___attribute__] = ACTIONS(2260),
    [anon_sym___attribute] = ACTIONS(2260),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2262),
    [anon_sym___declspec] = ACTIONS(2260),
    [anon_sym___based] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_EQ] = ACTIONS(2260),
    [anon_sym_register] = ACTIONS(2260),
    [anon_sym_inline] = ACTIONS(2260),
    [anon_sym___inline] = ACTIONS(2260),
    [anon_sym___inline__] = ACTIONS(2260),
    [anon_sym___forceinline] = ACTIONS(2260),
    [anon_sym_thread_local] = ACTIONS(2260),
    [anon_sym___thread] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_constexpr] = ACTIONS(2260),
    [anon_sym_volatile] = ACTIONS(2260),
    [anon_sym_restrict] = ACTIONS(2260),
    [anon_sym___restrict__] = ACTIONS(2260),
    [anon_sym__Atomic] = ACTIONS(2260),
    [anon_sym__Noreturn] = ACTIONS(2260),
    [anon_sym_noreturn] = ACTIONS(2260),
    [anon_sym__Nonnull] = ACTIONS(2260),
    [anon_sym_mutable] = ACTIONS(2260),
    [anon_sym_constinit] = ACTIONS(2260),
    [anon_sym_consteval] = ACTIONS(2260),
    [anon_sym_alignas] = ACTIONS(2260),
    [anon_sym__Alignas] = ACTIONS(2260),
    [anon_sym_QMARK] = ACTIONS(2262),
    [anon_sym_STAR_EQ] = ACTIONS(2262),
    [anon_sym_SLASH_EQ] = ACTIONS(2262),
    [anon_sym_PERCENT_EQ] = ACTIONS(2262),
    [anon_sym_PLUS_EQ] = ACTIONS(2262),
    [anon_sym_DASH_EQ] = ACTIONS(2262),
    [anon_sym_LT_LT_EQ] = ACTIONS(2262),
    [anon_sym_GT_GT_EQ] = ACTIONS(2262),
    [anon_sym_AMP_EQ] = ACTIONS(2262),
    [anon_sym_CARET_EQ] = ACTIONS(2262),
    [anon_sym_PIPE_EQ] = ACTIONS(2262),
    [anon_sym_LT_EQ_GT] = ACTIONS(2262),
    [anon_sym_or] = ACTIONS(2260),
    [anon_sym_and] = ACTIONS(2260),
    [anon_sym_bitor] = ACTIONS(2260),
    [anon_sym_xor] = ACTIONS(2260),
    [anon_sym_bitand] = ACTIONS(2260),
    [anon_sym_not_eq] = ACTIONS(2260),
    [anon_sym_is] = ACTIONS(2260),
    [anon_sym_as] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_DOT] = ACTIONS(2260),
    [anon_sym_DOT_STAR] = ACTIONS(2262),
    [anon_sym_DASH_GT] = ACTIONS(2260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_This] = ACTIONS(2260),
    [anon_sym_decltype] = ACTIONS(2260),
    [anon_sym_template] = ACTIONS(2260),
    [anon_sym_operator] = ACTIONS(2260),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2262),
    [anon_sym_precise] = ACTIONS(2260),
    [anon_sym_shared] = ACTIONS(2260),
    [anon_sym_groupshared] = ACTIONS(2260),
    [anon_sym_uniform] = ACTIONS(2260),
    [anon_sym_row_major] = ACTIONS(2260),
    [anon_sym_column_major] = ACTIONS(2260),
    [anon_sym_globallycoherent] = ACTIONS(2260),
    [anon_sym_centroid] = ACTIONS(2260),
    [anon_sym_noperspective] = ACTIONS(2260),
    [anon_sym_nointerpolation] = ACTIONS(2260),
    [anon_sym_sample] = ACTIONS(2260),
    [anon_sym_linear] = ACTIONS(2260),
    [anon_sym_snorm] = ACTIONS(2260),
    [anon_sym_unorm] = ACTIONS(2260),
    [anon_sym_point] = ACTIONS(2260),
    [anon_sym_line] = ACTIONS(2260),
    [anon_sym_triangleadj] = ACTIONS(2260),
    [anon_sym_lineadj] = ACTIONS(2260),
    [anon_sym_triangle] = ACTIONS(2260),
  },
  [1545] = {
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_COMMA] = ACTIONS(2306),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2304),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_PERCENT] = ACTIONS(2304),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE] = ACTIONS(2304),
    [anon_sym_CARET] = ACTIONS(2304),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_GT] = ACTIONS(2304),
    [anon_sym_GT_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_LT_LT] = ACTIONS(2304),
    [anon_sym_GT_GT] = ACTIONS(2304),
    [anon_sym_COLON] = ACTIONS(2304),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym_in] = ACTIONS(2304),
    [anon_sym_out] = ACTIONS(2304),
    [anon_sym_inout] = ACTIONS(2304),
    [anon_sym_virtual] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym___attribute] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2306),
    [anon_sym___declspec] = ACTIONS(2304),
    [anon_sym___based] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_EQ] = ACTIONS(2304),
    [anon_sym_register] = ACTIONS(2304),
    [anon_sym_inline] = ACTIONS(2304),
    [anon_sym___inline] = ACTIONS(2304),
    [anon_sym___inline__] = ACTIONS(2304),
    [anon_sym___forceinline] = ACTIONS(2304),
    [anon_sym_thread_local] = ACTIONS(2304),
    [anon_sym___thread] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym__Nonnull] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [anon_sym_QMARK] = ACTIONS(2306),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ_GT] = ACTIONS(2306),
    [anon_sym_or] = ACTIONS(2304),
    [anon_sym_and] = ACTIONS(2304),
    [anon_sym_bitor] = ACTIONS(2304),
    [anon_sym_xor] = ACTIONS(2304),
    [anon_sym_bitand] = ACTIONS(2304),
    [anon_sym_not_eq] = ACTIONS(2304),
    [anon_sym_is] = ACTIONS(2304),
    [anon_sym_as] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DOT] = ACTIONS(2304),
    [anon_sym_DOT_STAR] = ACTIONS(2306),
    [anon_sym_DASH_GT] = ACTIONS(2304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_This] = ACTIONS(2304),
    [anon_sym_decltype] = ACTIONS(2304),
    [anon_sym_template] = ACTIONS(2304),
    [anon_sym_operator] = ACTIONS(2304),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2306),
    [anon_sym_precise] = ACTIONS(2304),
    [anon_sym_shared] = ACTIONS(2304),
    [anon_sym_groupshared] = ACTIONS(2304),
    [anon_sym_uniform] = ACTIONS(2304),
    [anon_sym_row_major] = ACTIONS(2304),
    [anon_sym_column_major] = ACTIONS(2304),
    [anon_sym_globallycoherent] = ACTIONS(2304),
    [anon_sym_centroid] = ACTIONS(2304),
    [anon_sym_noperspective] = ACTIONS(2304),
    [anon_sym_nointerpolation] = ACTIONS(2304),
    [anon_sym_sample] = ACTIONS(2304),
    [anon_sym_linear] = ACTIONS(2304),
    [anon_sym_snorm] = ACTIONS(2304),
    [anon_sym_unorm] = ACTIONS(2304),
    [anon_sym_point] = ACTIONS(2304),
    [anon_sym_line] = ACTIONS(2304),
    [anon_sym_triangleadj] = ACTIONS(2304),
    [anon_sym_lineadj] = ACTIONS(2304),
    [anon_sym_triangle] = ACTIONS(2304),
  },
  [1546] = {
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2310),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_RPAREN] = ACTIONS(2310),
    [anon_sym_LPAREN2] = ACTIONS(2310),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2308),
    [anon_sym_SLASH] = ACTIONS(2308),
    [anon_sym_PERCENT] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_CARET] = ACTIONS(2308),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2310),
    [anon_sym_BANG_EQ] = ACTIONS(2310),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_EQ] = ACTIONS(2310),
    [anon_sym_LT_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2308),
    [anon_sym_COLON] = ACTIONS(2308),
    [anon_sym___extension__] = ACTIONS(2308),
    [anon_sym_in] = ACTIONS(2308),
    [anon_sym_out] = ACTIONS(2308),
    [anon_sym_inout] = ACTIONS(2308),
    [anon_sym_virtual] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2308),
    [anon_sym___attribute__] = ACTIONS(2308),
    [anon_sym___attribute] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2310),
    [anon_sym___declspec] = ACTIONS(2308),
    [anon_sym___based] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_EQ] = ACTIONS(2308),
    [anon_sym_register] = ACTIONS(2308),
    [anon_sym_inline] = ACTIONS(2308),
    [anon_sym___inline] = ACTIONS(2308),
    [anon_sym___inline__] = ACTIONS(2308),
    [anon_sym___forceinline] = ACTIONS(2308),
    [anon_sym_thread_local] = ACTIONS(2308),
    [anon_sym___thread] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_constexpr] = ACTIONS(2308),
    [anon_sym_volatile] = ACTIONS(2308),
    [anon_sym_restrict] = ACTIONS(2308),
    [anon_sym___restrict__] = ACTIONS(2308),
    [anon_sym__Atomic] = ACTIONS(2308),
    [anon_sym__Noreturn] = ACTIONS(2308),
    [anon_sym_noreturn] = ACTIONS(2308),
    [anon_sym__Nonnull] = ACTIONS(2308),
    [anon_sym_mutable] = ACTIONS(2308),
    [anon_sym_constinit] = ACTIONS(2308),
    [anon_sym_consteval] = ACTIONS(2308),
    [anon_sym_alignas] = ACTIONS(2308),
    [anon_sym__Alignas] = ACTIONS(2308),
    [anon_sym_QMARK] = ACTIONS(2310),
    [anon_sym_STAR_EQ] = ACTIONS(2310),
    [anon_sym_SLASH_EQ] = ACTIONS(2310),
    [anon_sym_PERCENT_EQ] = ACTIONS(2310),
    [anon_sym_PLUS_EQ] = ACTIONS(2310),
    [anon_sym_DASH_EQ] = ACTIONS(2310),
    [anon_sym_LT_LT_EQ] = ACTIONS(2310),
    [anon_sym_GT_GT_EQ] = ACTIONS(2310),
    [anon_sym_AMP_EQ] = ACTIONS(2310),
    [anon_sym_CARET_EQ] = ACTIONS(2310),
    [anon_sym_PIPE_EQ] = ACTIONS(2310),
    [anon_sym_LT_EQ_GT] = ACTIONS(2310),
    [anon_sym_or] = ACTIONS(2308),
    [anon_sym_and] = ACTIONS(2308),
    [anon_sym_bitor] = ACTIONS(2308),
    [anon_sym_xor] = ACTIONS(2308),
    [anon_sym_bitand] = ACTIONS(2308),
    [anon_sym_not_eq] = ACTIONS(2308),
    [anon_sym_is] = ACTIONS(2308),
    [anon_sym_as] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_DOT] = ACTIONS(2308),
    [anon_sym_DOT_STAR] = ACTIONS(2310),
    [anon_sym_DASH_GT] = ACTIONS(2308),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_This] = ACTIONS(2308),
    [anon_sym_decltype] = ACTIONS(2308),
    [anon_sym_template] = ACTIONS(2308),
    [anon_sym_operator] = ACTIONS(2308),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2310),
    [anon_sym_precise] = ACTIONS(2308),
    [anon_sym_shared] = ACTIONS(2308),
    [anon_sym_groupshared] = ACTIONS(2308),
    [anon_sym_uniform] = ACTIONS(2308),
    [anon_sym_row_major] = ACTIONS(2308),
    [anon_sym_column_major] = ACTIONS(2308),
    [anon_sym_globallycoherent] = ACTIONS(2308),
    [anon_sym_centroid] = ACTIONS(2308),
    [anon_sym_noperspective] = ACTIONS(2308),
    [anon_sym_nointerpolation] = ACTIONS(2308),
    [anon_sym_sample] = ACTIONS(2308),
    [anon_sym_linear] = ACTIONS(2308),
    [anon_sym_snorm] = ACTIONS(2308),
    [anon_sym_unorm] = ACTIONS(2308),
    [anon_sym_point] = ACTIONS(2308),
    [anon_sym_line] = ACTIONS(2308),
    [anon_sym_triangleadj] = ACTIONS(2308),
    [anon_sym_lineadj] = ACTIONS(2308),
    [anon_sym_triangle] = ACTIONS(2308),
  },
  [1547] = {
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2314),
    [anon_sym_COMMA] = ACTIONS(2314),
    [anon_sym_RPAREN] = ACTIONS(2314),
    [anon_sym_LPAREN2] = ACTIONS(2314),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_SLASH] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2312),
    [anon_sym_PIPE_PIPE] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2314),
    [anon_sym_PIPE] = ACTIONS(2312),
    [anon_sym_CARET] = ACTIONS(2312),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_EQ_EQ] = ACTIONS(2314),
    [anon_sym_BANG_EQ] = ACTIONS(2314),
    [anon_sym_GT] = ACTIONS(2312),
    [anon_sym_GT_EQ] = ACTIONS(2314),
    [anon_sym_LT_EQ] = ACTIONS(2312),
    [anon_sym_LT] = ACTIONS(2312),
    [anon_sym_LT_LT] = ACTIONS(2312),
    [anon_sym_GT_GT] = ACTIONS(2312),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym___extension__] = ACTIONS(2312),
    [anon_sym_in] = ACTIONS(2312),
    [anon_sym_out] = ACTIONS(2312),
    [anon_sym_inout] = ACTIONS(2312),
    [anon_sym_virtual] = ACTIONS(2312),
    [anon_sym_extern] = ACTIONS(2312),
    [anon_sym___attribute__] = ACTIONS(2312),
    [anon_sym___attribute] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2314),
    [anon_sym___declspec] = ACTIONS(2312),
    [anon_sym___based] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_EQ] = ACTIONS(2312),
    [anon_sym_register] = ACTIONS(2312),
    [anon_sym_inline] = ACTIONS(2312),
    [anon_sym___inline] = ACTIONS(2312),
    [anon_sym___inline__] = ACTIONS(2312),
    [anon_sym___forceinline] = ACTIONS(2312),
    [anon_sym_thread_local] = ACTIONS(2312),
    [anon_sym___thread] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_constexpr] = ACTIONS(2312),
    [anon_sym_volatile] = ACTIONS(2312),
    [anon_sym_restrict] = ACTIONS(2312),
    [anon_sym___restrict__] = ACTIONS(2312),
    [anon_sym__Atomic] = ACTIONS(2312),
    [anon_sym__Noreturn] = ACTIONS(2312),
    [anon_sym_noreturn] = ACTIONS(2312),
    [anon_sym__Nonnull] = ACTIONS(2312),
    [anon_sym_mutable] = ACTIONS(2312),
    [anon_sym_constinit] = ACTIONS(2312),
    [anon_sym_consteval] = ACTIONS(2312),
    [anon_sym_alignas] = ACTIONS(2312),
    [anon_sym__Alignas] = ACTIONS(2312),
    [anon_sym_QMARK] = ACTIONS(2314),
    [anon_sym_STAR_EQ] = ACTIONS(2314),
    [anon_sym_SLASH_EQ] = ACTIONS(2314),
    [anon_sym_PERCENT_EQ] = ACTIONS(2314),
    [anon_sym_PLUS_EQ] = ACTIONS(2314),
    [anon_sym_DASH_EQ] = ACTIONS(2314),
    [anon_sym_LT_LT_EQ] = ACTIONS(2314),
    [anon_sym_GT_GT_EQ] = ACTIONS(2314),
    [anon_sym_AMP_EQ] = ACTIONS(2314),
    [anon_sym_CARET_EQ] = ACTIONS(2314),
    [anon_sym_PIPE_EQ] = ACTIONS(2314),
    [anon_sym_LT_EQ_GT] = ACTIONS(2314),
    [anon_sym_or] = ACTIONS(2312),
    [anon_sym_and] = ACTIONS(2312),
    [anon_sym_bitor] = ACTIONS(2312),
    [anon_sym_xor] = ACTIONS(2312),
    [anon_sym_bitand] = ACTIONS(2312),
    [anon_sym_not_eq] = ACTIONS(2312),
    [anon_sym_is] = ACTIONS(2312),
    [anon_sym_as] = ACTIONS(2312),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_DOT] = ACTIONS(2312),
    [anon_sym_DOT_STAR] = ACTIONS(2314),
    [anon_sym_DASH_GT] = ACTIONS(2312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_This] = ACTIONS(2312),
    [anon_sym_decltype] = ACTIONS(2312),
    [anon_sym_template] = ACTIONS(2312),
    [anon_sym_operator] = ACTIONS(2312),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2314),
    [anon_sym_precise] = ACTIONS(2312),
    [anon_sym_shared] = ACTIONS(2312),
    [anon_sym_groupshared] = ACTIONS(2312),
    [anon_sym_uniform] = ACTIONS(2312),
    [anon_sym_row_major] = ACTIONS(2312),
    [anon_sym_column_major] = ACTIONS(2312),
    [anon_sym_globallycoherent] = ACTIONS(2312),
    [anon_sym_centroid] = ACTIONS(2312),
    [anon_sym_noperspective] = ACTIONS(2312),
    [anon_sym_nointerpolation] = ACTIONS(2312),
    [anon_sym_sample] = ACTIONS(2312),
    [anon_sym_linear] = ACTIONS(2312),
    [anon_sym_snorm] = ACTIONS(2312),
    [anon_sym_unorm] = ACTIONS(2312),
    [anon_sym_point] = ACTIONS(2312),
    [anon_sym_line] = ACTIONS(2312),
    [anon_sym_triangleadj] = ACTIONS(2312),
    [anon_sym_lineadj] = ACTIONS(2312),
    [anon_sym_triangle] = ACTIONS(2312),
  },
  [1548] = {
    [sym_expression] = STATE(5759),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5707),
    [anon_sym_LPAREN2] = ACTIONS(5710),
    [anon_sym_BANG] = ACTIONS(5713),
    [anon_sym_TILDE] = ACTIONS(5713),
    [anon_sym_DASH] = ACTIONS(5716),
    [anon_sym_PLUS] = ACTIONS(5716),
    [anon_sym_STAR] = ACTIONS(3349),
    [anon_sym_AMP] = ACTIONS(3349),
    [anon_sym___extension__] = ACTIONS(5719),
    [anon_sym_COLON_COLON] = ACTIONS(5722),
    [anon_sym_LBRACK] = ACTIONS(5692),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_RBRACK] = ACTIONS(3352),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3370),
    [anon_sym_not] = ACTIONS(5716),
    [anon_sym_compl] = ACTIONS(5716),
    [anon_sym_DASH_DASH] = ACTIONS(5725),
    [anon_sym_PLUS_PLUS] = ACTIONS(5725),
    [anon_sym_sizeof] = ACTIONS(5728),
    [anon_sym___alignof__] = ACTIONS(5731),
    [anon_sym___alignof] = ACTIONS(5731),
    [anon_sym__alignof] = ACTIONS(5731),
    [anon_sym_alignof] = ACTIONS(5731),
    [anon_sym__Alignof] = ACTIONS(5731),
    [anon_sym_offsetof] = ACTIONS(5734),
    [anon_sym__Generic] = ACTIONS(5737),
    [anon_sym_asm] = ACTIONS(5740),
    [anon_sym___asm__] = ACTIONS(5740),
    [anon_sym___asm] = ACTIONS(5740),
    [sym_number_literal] = ACTIONS(5743),
    [anon_sym_L_SQUOTE] = ACTIONS(5746),
    [anon_sym_u_SQUOTE] = ACTIONS(5746),
    [anon_sym_U_SQUOTE] = ACTIONS(5746),
    [anon_sym_u8_SQUOTE] = ACTIONS(5746),
    [anon_sym_SQUOTE] = ACTIONS(5746),
    [anon_sym_L_DQUOTE] = ACTIONS(5749),
    [anon_sym_u_DQUOTE] = ACTIONS(5749),
    [anon_sym_U_DQUOTE] = ACTIONS(5749),
    [anon_sym_u8_DQUOTE] = ACTIONS(5749),
    [anon_sym_DQUOTE] = ACTIONS(5749),
    [sym_true] = ACTIONS(5752),
    [sym_false] = ACTIONS(5752),
    [anon_sym_NULL] = ACTIONS(5755),
    [anon_sym_nullptr] = ACTIONS(5755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3373),
    [anon_sym_template] = ACTIONS(3376),
    [anon_sym_delete] = ACTIONS(5758),
    [anon_sym_R_DQUOTE] = ACTIONS(5761),
    [anon_sym_LR_DQUOTE] = ACTIONS(5761),
    [anon_sym_uR_DQUOTE] = ACTIONS(5761),
    [anon_sym_UR_DQUOTE] = ACTIONS(5761),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5761),
    [anon_sym_co_await] = ACTIONS(5764),
    [anon_sym_new] = ACTIONS(5767),
    [anon_sym_requires] = ACTIONS(5770),
    [sym_this] = ACTIONS(5752),
  },
  [1549] = {
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2274),
    [anon_sym_COMMA] = ACTIONS(2274),
    [anon_sym_RPAREN] = ACTIONS(2274),
    [anon_sym_LPAREN2] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2274),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_PERCENT] = ACTIONS(2274),
    [anon_sym_PIPE_PIPE] = ACTIONS(2274),
    [anon_sym_AMP_AMP] = ACTIONS(2274),
    [anon_sym_PIPE] = ACTIONS(2272),
    [anon_sym_CARET] = ACTIONS(2274),
    [anon_sym_AMP] = ACTIONS(2272),
    [anon_sym_EQ_EQ] = ACTIONS(2274),
    [anon_sym_BANG_EQ] = ACTIONS(2274),
    [anon_sym_GT] = ACTIONS(2272),
    [anon_sym_GT_EQ] = ACTIONS(2274),
    [anon_sym_LT_EQ] = ACTIONS(2272),
    [anon_sym_LT] = ACTIONS(2272),
    [anon_sym_LT_LT] = ACTIONS(2274),
    [anon_sym_GT_GT] = ACTIONS(2274),
    [anon_sym_COLON] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym___extension__] = ACTIONS(2272),
    [anon_sym_in] = ACTIONS(2272),
    [anon_sym_out] = ACTIONS(2272),
    [anon_sym_inout] = ACTIONS(2272),
    [anon_sym_virtual] = ACTIONS(2272),
    [anon_sym_extern] = ACTIONS(2272),
    [anon_sym___attribute__] = ACTIONS(2272),
    [anon_sym___attribute] = ACTIONS(2272),
    [anon_sym_COLON_COLON] = ACTIONS(2274),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2274),
    [anon_sym___declspec] = ACTIONS(2272),
    [anon_sym___based] = ACTIONS(2272),
    [anon_sym___cdecl] = ACTIONS(2272),
    [anon_sym___clrcall] = ACTIONS(2272),
    [anon_sym___stdcall] = ACTIONS(2272),
    [anon_sym___fastcall] = ACTIONS(2272),
    [anon_sym___thiscall] = ACTIONS(2272),
    [anon_sym___vectorcall] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_RBRACE] = ACTIONS(2274),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_register] = ACTIONS(2272),
    [anon_sym_inline] = ACTIONS(2272),
    [anon_sym___inline] = ACTIONS(2272),
    [anon_sym___inline__] = ACTIONS(2272),
    [anon_sym___forceinline] = ACTIONS(2272),
    [anon_sym_thread_local] = ACTIONS(2272),
    [anon_sym___thread] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_constexpr] = ACTIONS(2272),
    [anon_sym_volatile] = ACTIONS(2272),
    [anon_sym_restrict] = ACTIONS(2272),
    [anon_sym___restrict__] = ACTIONS(2272),
    [anon_sym__Atomic] = ACTIONS(2272),
    [anon_sym__Noreturn] = ACTIONS(2272),
    [anon_sym_noreturn] = ACTIONS(2272),
    [anon_sym__Nonnull] = ACTIONS(2272),
    [anon_sym_mutable] = ACTIONS(2272),
    [anon_sym_constinit] = ACTIONS(2272),
    [anon_sym_consteval] = ACTIONS(2272),
    [anon_sym_alignas] = ACTIONS(2272),
    [anon_sym__Alignas] = ACTIONS(2272),
    [anon_sym_QMARK] = ACTIONS(2274),
    [anon_sym_LT_EQ_GT] = ACTIONS(2274),
    [anon_sym_or] = ACTIONS(2272),
    [anon_sym_and] = ACTIONS(2272),
    [anon_sym_bitor] = ACTIONS(2272),
    [anon_sym_xor] = ACTIONS(2272),
    [anon_sym_bitand] = ACTIONS(2272),
    [anon_sym_not_eq] = ACTIONS(2272),
    [anon_sym_is] = ACTIONS(2272),
    [anon_sym_as] = ACTIONS(2272),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_DOT] = ACTIONS(2272),
    [anon_sym_DOT_STAR] = ACTIONS(2274),
    [anon_sym_DASH_GT] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_This] = ACTIONS(2272),
    [anon_sym_decltype] = ACTIONS(2272),
    [anon_sym_final] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_template] = ACTIONS(2272),
    [anon_sym_operator] = ACTIONS(2272),
    [anon_sym_precise] = ACTIONS(2272),
    [anon_sym_shared] = ACTIONS(2272),
    [anon_sym_groupshared] = ACTIONS(2272),
    [anon_sym_uniform] = ACTIONS(2272),
    [anon_sym_row_major] = ACTIONS(2272),
    [anon_sym_column_major] = ACTIONS(2272),
    [anon_sym_globallycoherent] = ACTIONS(2272),
    [anon_sym_centroid] = ACTIONS(2272),
    [anon_sym_noperspective] = ACTIONS(2272),
    [anon_sym_nointerpolation] = ACTIONS(2272),
    [anon_sym_sample] = ACTIONS(2272),
    [anon_sym_linear] = ACTIONS(2272),
    [anon_sym_snorm] = ACTIONS(2272),
    [anon_sym_unorm] = ACTIONS(2272),
    [anon_sym_point] = ACTIONS(2272),
    [anon_sym_line] = ACTIONS(2272),
    [anon_sym_triangleadj] = ACTIONS(2272),
    [anon_sym_lineadj] = ACTIONS(2272),
    [anon_sym_triangle] = ACTIONS(2272),
  },
  [1550] = {
    [sym_identifier] = ACTIONS(2284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2286),
    [anon_sym_COMMA] = ACTIONS(2286),
    [anon_sym_RPAREN] = ACTIONS(2286),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_SLASH] = ACTIONS(2284),
    [anon_sym_PERCENT] = ACTIONS(2286),
    [anon_sym_PIPE_PIPE] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2284),
    [anon_sym_CARET] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_EQ_EQ] = ACTIONS(2286),
    [anon_sym_BANG_EQ] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2284),
    [anon_sym_GT_EQ] = ACTIONS(2286),
    [anon_sym_LT_EQ] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2284),
    [anon_sym_LT_LT] = ACTIONS(2286),
    [anon_sym_GT_GT] = ACTIONS(2286),
    [anon_sym_COLON] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_in] = ACTIONS(2284),
    [anon_sym_out] = ACTIONS(2284),
    [anon_sym_inout] = ACTIONS(2284),
    [anon_sym_virtual] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym___cdecl] = ACTIONS(2284),
    [anon_sym___clrcall] = ACTIONS(2284),
    [anon_sym___stdcall] = ACTIONS(2284),
    [anon_sym___fastcall] = ACTIONS(2284),
    [anon_sym___thiscall] = ACTIONS(2284),
    [anon_sym___vectorcall] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [anon_sym_QMARK] = ACTIONS(2286),
    [anon_sym_LT_EQ_GT] = ACTIONS(2286),
    [anon_sym_or] = ACTIONS(2284),
    [anon_sym_and] = ACTIONS(2284),
    [anon_sym_bitor] = ACTIONS(2284),
    [anon_sym_xor] = ACTIONS(2284),
    [anon_sym_bitand] = ACTIONS(2284),
    [anon_sym_not_eq] = ACTIONS(2284),
    [anon_sym_is] = ACTIONS(2284),
    [anon_sym_as] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_DOT] = ACTIONS(2284),
    [anon_sym_DOT_STAR] = ACTIONS(2286),
    [anon_sym_DASH_GT] = ACTIONS(2286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_This] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [anon_sym_final] = ACTIONS(2284),
    [anon_sym_override] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_precise] = ACTIONS(2284),
    [anon_sym_shared] = ACTIONS(2284),
    [anon_sym_groupshared] = ACTIONS(2284),
    [anon_sym_uniform] = ACTIONS(2284),
    [anon_sym_row_major] = ACTIONS(2284),
    [anon_sym_column_major] = ACTIONS(2284),
    [anon_sym_globallycoherent] = ACTIONS(2284),
    [anon_sym_centroid] = ACTIONS(2284),
    [anon_sym_noperspective] = ACTIONS(2284),
    [anon_sym_nointerpolation] = ACTIONS(2284),
    [anon_sym_sample] = ACTIONS(2284),
    [anon_sym_linear] = ACTIONS(2284),
    [anon_sym_snorm] = ACTIONS(2284),
    [anon_sym_unorm] = ACTIONS(2284),
    [anon_sym_point] = ACTIONS(2284),
    [anon_sym_line] = ACTIONS(2284),
    [anon_sym_triangleadj] = ACTIONS(2284),
    [anon_sym_lineadj] = ACTIONS(2284),
    [anon_sym_triangle] = ACTIONS(2284),
  },
  [1551] = {
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2302),
    [anon_sym_COMMA] = ACTIONS(2302),
    [anon_sym_RPAREN] = ACTIONS(2302),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2302),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2302),
    [anon_sym_PIPE_PIPE] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_PIPE] = ACTIONS(2300),
    [anon_sym_CARET] = ACTIONS(2302),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_EQ_EQ] = ACTIONS(2302),
    [anon_sym_BANG_EQ] = ACTIONS(2302),
    [anon_sym_GT] = ACTIONS(2300),
    [anon_sym_GT_EQ] = ACTIONS(2302),
    [anon_sym_LT_EQ] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_LT_LT] = ACTIONS(2302),
    [anon_sym_GT_GT] = ACTIONS(2302),
    [anon_sym_COLON] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym_in] = ACTIONS(2300),
    [anon_sym_out] = ACTIONS(2300),
    [anon_sym_inout] = ACTIONS(2300),
    [anon_sym_virtual] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym___attribute] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2302),
    [anon_sym___declspec] = ACTIONS(2300),
    [anon_sym___based] = ACTIONS(2300),
    [anon_sym___cdecl] = ACTIONS(2300),
    [anon_sym___clrcall] = ACTIONS(2300),
    [anon_sym___stdcall] = ACTIONS(2300),
    [anon_sym___fastcall] = ACTIONS(2300),
    [anon_sym___thiscall] = ACTIONS(2300),
    [anon_sym___vectorcall] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_RBRACE] = ACTIONS(2302),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_register] = ACTIONS(2300),
    [anon_sym_inline] = ACTIONS(2300),
    [anon_sym___inline] = ACTIONS(2300),
    [anon_sym___inline__] = ACTIONS(2300),
    [anon_sym___forceinline] = ACTIONS(2300),
    [anon_sym_thread_local] = ACTIONS(2300),
    [anon_sym___thread] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym__Nonnull] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [anon_sym_QMARK] = ACTIONS(2302),
    [anon_sym_LT_EQ_GT] = ACTIONS(2302),
    [anon_sym_or] = ACTIONS(2300),
    [anon_sym_and] = ACTIONS(2300),
    [anon_sym_bitor] = ACTIONS(2300),
    [anon_sym_xor] = ACTIONS(2300),
    [anon_sym_bitand] = ACTIONS(2300),
    [anon_sym_not_eq] = ACTIONS(2300),
    [anon_sym_is] = ACTIONS(2300),
    [anon_sym_as] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_DOT] = ACTIONS(2300),
    [anon_sym_DOT_STAR] = ACTIONS(2302),
    [anon_sym_DASH_GT] = ACTIONS(2302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_This] = ACTIONS(2300),
    [anon_sym_decltype] = ACTIONS(2300),
    [anon_sym_final] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_template] = ACTIONS(2300),
    [anon_sym_operator] = ACTIONS(2300),
    [anon_sym_precise] = ACTIONS(2300),
    [anon_sym_shared] = ACTIONS(2300),
    [anon_sym_groupshared] = ACTIONS(2300),
    [anon_sym_uniform] = ACTIONS(2300),
    [anon_sym_row_major] = ACTIONS(2300),
    [anon_sym_column_major] = ACTIONS(2300),
    [anon_sym_globallycoherent] = ACTIONS(2300),
    [anon_sym_centroid] = ACTIONS(2300),
    [anon_sym_noperspective] = ACTIONS(2300),
    [anon_sym_nointerpolation] = ACTIONS(2300),
    [anon_sym_sample] = ACTIONS(2300),
    [anon_sym_linear] = ACTIONS(2300),
    [anon_sym_snorm] = ACTIONS(2300),
    [anon_sym_unorm] = ACTIONS(2300),
    [anon_sym_point] = ACTIONS(2300),
    [anon_sym_line] = ACTIONS(2300),
    [anon_sym_triangleadj] = ACTIONS(2300),
    [anon_sym_lineadj] = ACTIONS(2300),
    [anon_sym_triangle] = ACTIONS(2300),
  },
  [1552] = {
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_COMMA] = ACTIONS(2262),
    [anon_sym_RPAREN] = ACTIONS(2262),
    [anon_sym_LPAREN2] = ACTIONS(2262),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2262),
    [anon_sym_SLASH] = ACTIONS(2260),
    [anon_sym_PERCENT] = ACTIONS(2262),
    [anon_sym_PIPE_PIPE] = ACTIONS(2262),
    [anon_sym_AMP_AMP] = ACTIONS(2262),
    [anon_sym_PIPE] = ACTIONS(2260),
    [anon_sym_CARET] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_EQ_EQ] = ACTIONS(2262),
    [anon_sym_BANG_EQ] = ACTIONS(2262),
    [anon_sym_GT] = ACTIONS(2260),
    [anon_sym_GT_EQ] = ACTIONS(2262),
    [anon_sym_LT_EQ] = ACTIONS(2260),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_LT_LT] = ACTIONS(2262),
    [anon_sym_GT_GT] = ACTIONS(2262),
    [anon_sym_COLON] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym___extension__] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(2260),
    [anon_sym_out] = ACTIONS(2260),
    [anon_sym_inout] = ACTIONS(2260),
    [anon_sym_virtual] = ACTIONS(2260),
    [anon_sym_extern] = ACTIONS(2260),
    [anon_sym___attribute__] = ACTIONS(2260),
    [anon_sym___attribute] = ACTIONS(2260),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2262),
    [anon_sym___declspec] = ACTIONS(2260),
    [anon_sym___based] = ACTIONS(2260),
    [anon_sym___cdecl] = ACTIONS(2260),
    [anon_sym___clrcall] = ACTIONS(2260),
    [anon_sym___stdcall] = ACTIONS(2260),
    [anon_sym___fastcall] = ACTIONS(2260),
    [anon_sym___thiscall] = ACTIONS(2260),
    [anon_sym___vectorcall] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_RBRACE] = ACTIONS(2262),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_register] = ACTIONS(2260),
    [anon_sym_inline] = ACTIONS(2260),
    [anon_sym___inline] = ACTIONS(2260),
    [anon_sym___inline__] = ACTIONS(2260),
    [anon_sym___forceinline] = ACTIONS(2260),
    [anon_sym_thread_local] = ACTIONS(2260),
    [anon_sym___thread] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_constexpr] = ACTIONS(2260),
    [anon_sym_volatile] = ACTIONS(2260),
    [anon_sym_restrict] = ACTIONS(2260),
    [anon_sym___restrict__] = ACTIONS(2260),
    [anon_sym__Atomic] = ACTIONS(2260),
    [anon_sym__Noreturn] = ACTIONS(2260),
    [anon_sym_noreturn] = ACTIONS(2260),
    [anon_sym__Nonnull] = ACTIONS(2260),
    [anon_sym_mutable] = ACTIONS(2260),
    [anon_sym_constinit] = ACTIONS(2260),
    [anon_sym_consteval] = ACTIONS(2260),
    [anon_sym_alignas] = ACTIONS(2260),
    [anon_sym__Alignas] = ACTIONS(2260),
    [anon_sym_QMARK] = ACTIONS(2262),
    [anon_sym_LT_EQ_GT] = ACTIONS(2262),
    [anon_sym_or] = ACTIONS(2260),
    [anon_sym_and] = ACTIONS(2260),
    [anon_sym_bitor] = ACTIONS(2260),
    [anon_sym_xor] = ACTIONS(2260),
    [anon_sym_bitand] = ACTIONS(2260),
    [anon_sym_not_eq] = ACTIONS(2260),
    [anon_sym_is] = ACTIONS(2260),
    [anon_sym_as] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_DOT] = ACTIONS(2260),
    [anon_sym_DOT_STAR] = ACTIONS(2262),
    [anon_sym_DASH_GT] = ACTIONS(2262),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_This] = ACTIONS(2260),
    [anon_sym_decltype] = ACTIONS(2260),
    [anon_sym_final] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
    [anon_sym_template] = ACTIONS(2260),
    [anon_sym_operator] = ACTIONS(2260),
    [anon_sym_precise] = ACTIONS(2260),
    [anon_sym_shared] = ACTIONS(2260),
    [anon_sym_groupshared] = ACTIONS(2260),
    [anon_sym_uniform] = ACTIONS(2260),
    [anon_sym_row_major] = ACTIONS(2260),
    [anon_sym_column_major] = ACTIONS(2260),
    [anon_sym_globallycoherent] = ACTIONS(2260),
    [anon_sym_centroid] = ACTIONS(2260),
    [anon_sym_noperspective] = ACTIONS(2260),
    [anon_sym_nointerpolation] = ACTIONS(2260),
    [anon_sym_sample] = ACTIONS(2260),
    [anon_sym_linear] = ACTIONS(2260),
    [anon_sym_snorm] = ACTIONS(2260),
    [anon_sym_unorm] = ACTIONS(2260),
    [anon_sym_point] = ACTIONS(2260),
    [anon_sym_line] = ACTIONS(2260),
    [anon_sym_triangleadj] = ACTIONS(2260),
    [anon_sym_lineadj] = ACTIONS(2260),
    [anon_sym_triangle] = ACTIONS(2260),
  },
  [1553] = {
    [sym_identifier] = ACTIONS(2276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2278),
    [anon_sym_COMMA] = ACTIONS(2278),
    [anon_sym_RPAREN] = ACTIONS(2278),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_PLUS] = ACTIONS(2276),
    [anon_sym_STAR] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2276),
    [anon_sym_PERCENT] = ACTIONS(2278),
    [anon_sym_PIPE_PIPE] = ACTIONS(2278),
    [anon_sym_AMP_AMP] = ACTIONS(2278),
    [anon_sym_PIPE] = ACTIONS(2276),
    [anon_sym_CARET] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_EQ_EQ] = ACTIONS(2278),
    [anon_sym_BANG_EQ] = ACTIONS(2278),
    [anon_sym_GT] = ACTIONS(2276),
    [anon_sym_GT_EQ] = ACTIONS(2278),
    [anon_sym_LT_EQ] = ACTIONS(2276),
    [anon_sym_LT] = ACTIONS(2276),
    [anon_sym_LT_LT] = ACTIONS(2278),
    [anon_sym_GT_GT] = ACTIONS(2278),
    [anon_sym_COLON] = ACTIONS(2276),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym___extension__] = ACTIONS(2276),
    [anon_sym_in] = ACTIONS(2276),
    [anon_sym_out] = ACTIONS(2276),
    [anon_sym_inout] = ACTIONS(2276),
    [anon_sym_virtual] = ACTIONS(2276),
    [anon_sym_extern] = ACTIONS(2276),
    [anon_sym___attribute__] = ACTIONS(2276),
    [anon_sym___attribute] = ACTIONS(2276),
    [anon_sym_COLON_COLON] = ACTIONS(2278),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2278),
    [anon_sym___declspec] = ACTIONS(2276),
    [anon_sym___based] = ACTIONS(2276),
    [anon_sym___cdecl] = ACTIONS(2276),
    [anon_sym___clrcall] = ACTIONS(2276),
    [anon_sym___stdcall] = ACTIONS(2276),
    [anon_sym___fastcall] = ACTIONS(2276),
    [anon_sym___thiscall] = ACTIONS(2276),
    [anon_sym___vectorcall] = ACTIONS(2276),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_LBRACK] = ACTIONS(2276),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_register] = ACTIONS(2276),
    [anon_sym_inline] = ACTIONS(2276),
    [anon_sym___inline] = ACTIONS(2276),
    [anon_sym___inline__] = ACTIONS(2276),
    [anon_sym___forceinline] = ACTIONS(2276),
    [anon_sym_thread_local] = ACTIONS(2276),
    [anon_sym___thread] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_constexpr] = ACTIONS(2276),
    [anon_sym_volatile] = ACTIONS(2276),
    [anon_sym_restrict] = ACTIONS(2276),
    [anon_sym___restrict__] = ACTIONS(2276),
    [anon_sym__Atomic] = ACTIONS(2276),
    [anon_sym__Noreturn] = ACTIONS(2276),
    [anon_sym_noreturn] = ACTIONS(2276),
    [anon_sym__Nonnull] = ACTIONS(2276),
    [anon_sym_mutable] = ACTIONS(2276),
    [anon_sym_constinit] = ACTIONS(2276),
    [anon_sym_consteval] = ACTIONS(2276),
    [anon_sym_alignas] = ACTIONS(2276),
    [anon_sym__Alignas] = ACTIONS(2276),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LT_EQ_GT] = ACTIONS(2278),
    [anon_sym_or] = ACTIONS(2276),
    [anon_sym_and] = ACTIONS(2276),
    [anon_sym_bitor] = ACTIONS(2276),
    [anon_sym_xor] = ACTIONS(2276),
    [anon_sym_bitand] = ACTIONS(2276),
    [anon_sym_not_eq] = ACTIONS(2276),
    [anon_sym_is] = ACTIONS(2276),
    [anon_sym_as] = ACTIONS(2276),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DOT] = ACTIONS(2276),
    [anon_sym_DOT_STAR] = ACTIONS(2278),
    [anon_sym_DASH_GT] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_This] = ACTIONS(2276),
    [anon_sym_decltype] = ACTIONS(2276),
    [anon_sym_final] = ACTIONS(2276),
    [anon_sym_override] = ACTIONS(2276),
    [anon_sym_template] = ACTIONS(2276),
    [anon_sym_operator] = ACTIONS(2276),
    [anon_sym_precise] = ACTIONS(2276),
    [anon_sym_shared] = ACTIONS(2276),
    [anon_sym_groupshared] = ACTIONS(2276),
    [anon_sym_uniform] = ACTIONS(2276),
    [anon_sym_row_major] = ACTIONS(2276),
    [anon_sym_column_major] = ACTIONS(2276),
    [anon_sym_globallycoherent] = ACTIONS(2276),
    [anon_sym_centroid] = ACTIONS(2276),
    [anon_sym_noperspective] = ACTIONS(2276),
    [anon_sym_nointerpolation] = ACTIONS(2276),
    [anon_sym_sample] = ACTIONS(2276),
    [anon_sym_linear] = ACTIONS(2276),
    [anon_sym_snorm] = ACTIONS(2276),
    [anon_sym_unorm] = ACTIONS(2276),
    [anon_sym_point] = ACTIONS(2276),
    [anon_sym_line] = ACTIONS(2276),
    [anon_sym_triangleadj] = ACTIONS(2276),
    [anon_sym_lineadj] = ACTIONS(2276),
    [anon_sym_triangle] = ACTIONS(2276),
  },
  [1554] = {
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8485),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8054),
    [sym_array_declarator] = STATE(8054),
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4316),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7351),
    [sym_qualified_identifier] = STATE(4317),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5356),
    [anon_sym_LPAREN2] = ACTIONS(5358),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5360),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2821),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(2861),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1555] = {
    [sym_identifier] = ACTIONS(2268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2270),
    [anon_sym_COMMA] = ACTIONS(2270),
    [anon_sym_RPAREN] = ACTIONS(2270),
    [anon_sym_LPAREN2] = ACTIONS(2270),
    [anon_sym_TILDE] = ACTIONS(2270),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2270),
    [anon_sym_SLASH] = ACTIONS(2268),
    [anon_sym_PERCENT] = ACTIONS(2270),
    [anon_sym_PIPE_PIPE] = ACTIONS(2270),
    [anon_sym_AMP_AMP] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2268),
    [anon_sym_CARET] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(2268),
    [anon_sym_EQ_EQ] = ACTIONS(2270),
    [anon_sym_BANG_EQ] = ACTIONS(2270),
    [anon_sym_GT] = ACTIONS(2268),
    [anon_sym_GT_EQ] = ACTIONS(2270),
    [anon_sym_LT_EQ] = ACTIONS(2268),
    [anon_sym_LT] = ACTIONS(2268),
    [anon_sym_LT_LT] = ACTIONS(2270),
    [anon_sym_GT_GT] = ACTIONS(2270),
    [anon_sym_COLON] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym___extension__] = ACTIONS(2268),
    [anon_sym_in] = ACTIONS(2268),
    [anon_sym_out] = ACTIONS(2268),
    [anon_sym_inout] = ACTIONS(2268),
    [anon_sym_virtual] = ACTIONS(2268),
    [anon_sym_extern] = ACTIONS(2268),
    [anon_sym___attribute__] = ACTIONS(2268),
    [anon_sym___attribute] = ACTIONS(2268),
    [anon_sym_COLON_COLON] = ACTIONS(2270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2270),
    [anon_sym___declspec] = ACTIONS(2268),
    [anon_sym___based] = ACTIONS(2268),
    [anon_sym___cdecl] = ACTIONS(2268),
    [anon_sym___clrcall] = ACTIONS(2268),
    [anon_sym___stdcall] = ACTIONS(2268),
    [anon_sym___fastcall] = ACTIONS(2268),
    [anon_sym___thiscall] = ACTIONS(2268),
    [anon_sym___vectorcall] = ACTIONS(2268),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_RBRACE] = ACTIONS(2270),
    [anon_sym_LBRACK] = ACTIONS(2268),
    [anon_sym_static] = ACTIONS(2268),
    [anon_sym_register] = ACTIONS(2268),
    [anon_sym_inline] = ACTIONS(2268),
    [anon_sym___inline] = ACTIONS(2268),
    [anon_sym___inline__] = ACTIONS(2268),
    [anon_sym___forceinline] = ACTIONS(2268),
    [anon_sym_thread_local] = ACTIONS(2268),
    [anon_sym___thread] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_constexpr] = ACTIONS(2268),
    [anon_sym_volatile] = ACTIONS(2268),
    [anon_sym_restrict] = ACTIONS(2268),
    [anon_sym___restrict__] = ACTIONS(2268),
    [anon_sym__Atomic] = ACTIONS(2268),
    [anon_sym__Noreturn] = ACTIONS(2268),
    [anon_sym_noreturn] = ACTIONS(2268),
    [anon_sym__Nonnull] = ACTIONS(2268),
    [anon_sym_mutable] = ACTIONS(2268),
    [anon_sym_constinit] = ACTIONS(2268),
    [anon_sym_consteval] = ACTIONS(2268),
    [anon_sym_alignas] = ACTIONS(2268),
    [anon_sym__Alignas] = ACTIONS(2268),
    [anon_sym_QMARK] = ACTIONS(2270),
    [anon_sym_LT_EQ_GT] = ACTIONS(2270),
    [anon_sym_or] = ACTIONS(2268),
    [anon_sym_and] = ACTIONS(2268),
    [anon_sym_bitor] = ACTIONS(2268),
    [anon_sym_xor] = ACTIONS(2268),
    [anon_sym_bitand] = ACTIONS(2268),
    [anon_sym_not_eq] = ACTIONS(2268),
    [anon_sym_is] = ACTIONS(2268),
    [anon_sym_as] = ACTIONS(2268),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_DOT] = ACTIONS(2268),
    [anon_sym_DOT_STAR] = ACTIONS(2270),
    [anon_sym_DASH_GT] = ACTIONS(2270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_This] = ACTIONS(2268),
    [anon_sym_decltype] = ACTIONS(2268),
    [anon_sym_final] = ACTIONS(2268),
    [anon_sym_override] = ACTIONS(2268),
    [anon_sym_template] = ACTIONS(2268),
    [anon_sym_operator] = ACTIONS(2268),
    [anon_sym_precise] = ACTIONS(2268),
    [anon_sym_shared] = ACTIONS(2268),
    [anon_sym_groupshared] = ACTIONS(2268),
    [anon_sym_uniform] = ACTIONS(2268),
    [anon_sym_row_major] = ACTIONS(2268),
    [anon_sym_column_major] = ACTIONS(2268),
    [anon_sym_globallycoherent] = ACTIONS(2268),
    [anon_sym_centroid] = ACTIONS(2268),
    [anon_sym_noperspective] = ACTIONS(2268),
    [anon_sym_nointerpolation] = ACTIONS(2268),
    [anon_sym_sample] = ACTIONS(2268),
    [anon_sym_linear] = ACTIONS(2268),
    [anon_sym_snorm] = ACTIONS(2268),
    [anon_sym_unorm] = ACTIONS(2268),
    [anon_sym_point] = ACTIONS(2268),
    [anon_sym_line] = ACTIONS(2268),
    [anon_sym_triangleadj] = ACTIONS(2268),
    [anon_sym_lineadj] = ACTIONS(2268),
    [anon_sym_triangle] = ACTIONS(2268),
  },
  [1556] = {
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_COMMA] = ACTIONS(2306),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_PERCENT] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE] = ACTIONS(2304),
    [anon_sym_CARET] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_GT] = ACTIONS(2304),
    [anon_sym_GT_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_LT_LT] = ACTIONS(2306),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_COLON] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2306),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym_in] = ACTIONS(2304),
    [anon_sym_out] = ACTIONS(2304),
    [anon_sym_inout] = ACTIONS(2304),
    [anon_sym_virtual] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym___attribute] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2306),
    [anon_sym___declspec] = ACTIONS(2304),
    [anon_sym___based] = ACTIONS(2304),
    [anon_sym___cdecl] = ACTIONS(2304),
    [anon_sym___clrcall] = ACTIONS(2304),
    [anon_sym___stdcall] = ACTIONS(2304),
    [anon_sym___fastcall] = ACTIONS(2304),
    [anon_sym___thiscall] = ACTIONS(2304),
    [anon_sym___vectorcall] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_register] = ACTIONS(2304),
    [anon_sym_inline] = ACTIONS(2304),
    [anon_sym___inline] = ACTIONS(2304),
    [anon_sym___inline__] = ACTIONS(2304),
    [anon_sym___forceinline] = ACTIONS(2304),
    [anon_sym_thread_local] = ACTIONS(2304),
    [anon_sym___thread] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym__Nonnull] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [anon_sym_QMARK] = ACTIONS(2306),
    [anon_sym_LT_EQ_GT] = ACTIONS(2306),
    [anon_sym_or] = ACTIONS(2304),
    [anon_sym_and] = ACTIONS(2304),
    [anon_sym_bitor] = ACTIONS(2304),
    [anon_sym_xor] = ACTIONS(2304),
    [anon_sym_bitand] = ACTIONS(2304),
    [anon_sym_not_eq] = ACTIONS(2304),
    [anon_sym_is] = ACTIONS(2304),
    [anon_sym_as] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DOT] = ACTIONS(2304),
    [anon_sym_DOT_STAR] = ACTIONS(2306),
    [anon_sym_DASH_GT] = ACTIONS(2306),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_This] = ACTIONS(2304),
    [anon_sym_decltype] = ACTIONS(2304),
    [anon_sym_final] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_template] = ACTIONS(2304),
    [anon_sym_operator] = ACTIONS(2304),
    [anon_sym_precise] = ACTIONS(2304),
    [anon_sym_shared] = ACTIONS(2304),
    [anon_sym_groupshared] = ACTIONS(2304),
    [anon_sym_uniform] = ACTIONS(2304),
    [anon_sym_row_major] = ACTIONS(2304),
    [anon_sym_column_major] = ACTIONS(2304),
    [anon_sym_globallycoherent] = ACTIONS(2304),
    [anon_sym_centroid] = ACTIONS(2304),
    [anon_sym_noperspective] = ACTIONS(2304),
    [anon_sym_nointerpolation] = ACTIONS(2304),
    [anon_sym_sample] = ACTIONS(2304),
    [anon_sym_linear] = ACTIONS(2304),
    [anon_sym_snorm] = ACTIONS(2304),
    [anon_sym_unorm] = ACTIONS(2304),
    [anon_sym_point] = ACTIONS(2304),
    [anon_sym_line] = ACTIONS(2304),
    [anon_sym_triangleadj] = ACTIONS(2304),
    [anon_sym_lineadj] = ACTIONS(2304),
    [anon_sym_triangle] = ACTIONS(2304),
  },
  [1557] = {
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2266),
    [anon_sym_COMMA] = ACTIONS(2266),
    [anon_sym_RPAREN] = ACTIONS(2266),
    [anon_sym_LPAREN2] = ACTIONS(2266),
    [anon_sym_TILDE] = ACTIONS(2266),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2266),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_PERCENT] = ACTIONS(2266),
    [anon_sym_PIPE_PIPE] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2266),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_CARET] = ACTIONS(2266),
    [anon_sym_AMP] = ACTIONS(2264),
    [anon_sym_EQ_EQ] = ACTIONS(2266),
    [anon_sym_BANG_EQ] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(2264),
    [anon_sym_GT_EQ] = ACTIONS(2266),
    [anon_sym_LT_EQ] = ACTIONS(2264),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_LT_LT] = ACTIONS(2266),
    [anon_sym_GT_GT] = ACTIONS(2266),
    [anon_sym_COLON] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2266),
    [anon_sym___extension__] = ACTIONS(2264),
    [anon_sym_in] = ACTIONS(2264),
    [anon_sym_out] = ACTIONS(2264),
    [anon_sym_inout] = ACTIONS(2264),
    [anon_sym_virtual] = ACTIONS(2264),
    [anon_sym_extern] = ACTIONS(2264),
    [anon_sym___attribute__] = ACTIONS(2264),
    [anon_sym___attribute] = ACTIONS(2264),
    [anon_sym_COLON_COLON] = ACTIONS(2266),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2266),
    [anon_sym___declspec] = ACTIONS(2264),
    [anon_sym___based] = ACTIONS(2264),
    [anon_sym___cdecl] = ACTIONS(2264),
    [anon_sym___clrcall] = ACTIONS(2264),
    [anon_sym___stdcall] = ACTIONS(2264),
    [anon_sym___fastcall] = ACTIONS(2264),
    [anon_sym___thiscall] = ACTIONS(2264),
    [anon_sym___vectorcall] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_RBRACE] = ACTIONS(2266),
    [anon_sym_LBRACK] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_register] = ACTIONS(2264),
    [anon_sym_inline] = ACTIONS(2264),
    [anon_sym___inline] = ACTIONS(2264),
    [anon_sym___inline__] = ACTIONS(2264),
    [anon_sym___forceinline] = ACTIONS(2264),
    [anon_sym_thread_local] = ACTIONS(2264),
    [anon_sym___thread] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_constexpr] = ACTIONS(2264),
    [anon_sym_volatile] = ACTIONS(2264),
    [anon_sym_restrict] = ACTIONS(2264),
    [anon_sym___restrict__] = ACTIONS(2264),
    [anon_sym__Atomic] = ACTIONS(2264),
    [anon_sym__Noreturn] = ACTIONS(2264),
    [anon_sym_noreturn] = ACTIONS(2264),
    [anon_sym__Nonnull] = ACTIONS(2264),
    [anon_sym_mutable] = ACTIONS(2264),
    [anon_sym_constinit] = ACTIONS(2264),
    [anon_sym_consteval] = ACTIONS(2264),
    [anon_sym_alignas] = ACTIONS(2264),
    [anon_sym__Alignas] = ACTIONS(2264),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_LT_EQ_GT] = ACTIONS(2266),
    [anon_sym_or] = ACTIONS(2264),
    [anon_sym_and] = ACTIONS(2264),
    [anon_sym_bitor] = ACTIONS(2264),
    [anon_sym_xor] = ACTIONS(2264),
    [anon_sym_bitand] = ACTIONS(2264),
    [anon_sym_not_eq] = ACTIONS(2264),
    [anon_sym_is] = ACTIONS(2264),
    [anon_sym_as] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2266),
    [anon_sym_PLUS_PLUS] = ACTIONS(2266),
    [anon_sym_DOT] = ACTIONS(2264),
    [anon_sym_DOT_STAR] = ACTIONS(2266),
    [anon_sym_DASH_GT] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_This] = ACTIONS(2264),
    [anon_sym_decltype] = ACTIONS(2264),
    [anon_sym_final] = ACTIONS(2264),
    [anon_sym_override] = ACTIONS(2264),
    [anon_sym_template] = ACTIONS(2264),
    [anon_sym_operator] = ACTIONS(2264),
    [anon_sym_precise] = ACTIONS(2264),
    [anon_sym_shared] = ACTIONS(2264),
    [anon_sym_groupshared] = ACTIONS(2264),
    [anon_sym_uniform] = ACTIONS(2264),
    [anon_sym_row_major] = ACTIONS(2264),
    [anon_sym_column_major] = ACTIONS(2264),
    [anon_sym_globallycoherent] = ACTIONS(2264),
    [anon_sym_centroid] = ACTIONS(2264),
    [anon_sym_noperspective] = ACTIONS(2264),
    [anon_sym_nointerpolation] = ACTIONS(2264),
    [anon_sym_sample] = ACTIONS(2264),
    [anon_sym_linear] = ACTIONS(2264),
    [anon_sym_snorm] = ACTIONS(2264),
    [anon_sym_unorm] = ACTIONS(2264),
    [anon_sym_point] = ACTIONS(2264),
    [anon_sym_line] = ACTIONS(2264),
    [anon_sym_triangleadj] = ACTIONS(2264),
    [anon_sym_lineadj] = ACTIONS(2264),
    [anon_sym_triangle] = ACTIONS(2264),
  },
  [1558] = {
    [sym_identifier] = ACTIONS(2239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2241),
    [anon_sym_COMMA] = ACTIONS(2241),
    [anon_sym_RPAREN] = ACTIONS(2241),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2239),
    [anon_sym_PLUS] = ACTIONS(2239),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_SLASH] = ACTIONS(2239),
    [anon_sym_PERCENT] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_PIPE] = ACTIONS(2239),
    [anon_sym_CARET] = ACTIONS(2241),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_LT_EQ] = ACTIONS(2239),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_LT_LT] = ACTIONS(2241),
    [anon_sym_GT_GT] = ACTIONS(2241),
    [anon_sym_COLON] = ACTIONS(2239),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym_in] = ACTIONS(2239),
    [anon_sym_out] = ACTIONS(2239),
    [anon_sym_inout] = ACTIONS(2239),
    [anon_sym_virtual] = ACTIONS(2239),
    [anon_sym_extern] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym___attribute] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2241),
    [anon_sym___declspec] = ACTIONS(2239),
    [anon_sym___based] = ACTIONS(2239),
    [anon_sym___cdecl] = ACTIONS(2239),
    [anon_sym___clrcall] = ACTIONS(2239),
    [anon_sym___stdcall] = ACTIONS(2239),
    [anon_sym___fastcall] = ACTIONS(2239),
    [anon_sym___thiscall] = ACTIONS(2239),
    [anon_sym___vectorcall] = ACTIONS(2239),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_RBRACE] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2239),
    [anon_sym_register] = ACTIONS(2239),
    [anon_sym_inline] = ACTIONS(2239),
    [anon_sym___inline] = ACTIONS(2239),
    [anon_sym___inline__] = ACTIONS(2239),
    [anon_sym___forceinline] = ACTIONS(2239),
    [anon_sym_thread_local] = ACTIONS(2239),
    [anon_sym___thread] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym__Nonnull] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [anon_sym_QMARK] = ACTIONS(2241),
    [anon_sym_LT_EQ_GT] = ACTIONS(2241),
    [anon_sym_or] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(2239),
    [anon_sym_bitor] = ACTIONS(2239),
    [anon_sym_xor] = ACTIONS(2239),
    [anon_sym_bitand] = ACTIONS(2239),
    [anon_sym_not_eq] = ACTIONS(2239),
    [anon_sym_is] = ACTIONS(2239),
    [anon_sym_as] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2239),
    [anon_sym_DOT_STAR] = ACTIONS(2241),
    [anon_sym_DASH_GT] = ACTIONS(2241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2239),
    [anon_sym_let] = ACTIONS(2239),
    [anon_sym_This] = ACTIONS(2239),
    [anon_sym_decltype] = ACTIONS(2239),
    [anon_sym_final] = ACTIONS(2239),
    [anon_sym_override] = ACTIONS(2239),
    [anon_sym_template] = ACTIONS(2239),
    [anon_sym_operator] = ACTIONS(2239),
    [anon_sym_precise] = ACTIONS(2239),
    [anon_sym_shared] = ACTIONS(2239),
    [anon_sym_groupshared] = ACTIONS(2239),
    [anon_sym_uniform] = ACTIONS(2239),
    [anon_sym_row_major] = ACTIONS(2239),
    [anon_sym_column_major] = ACTIONS(2239),
    [anon_sym_globallycoherent] = ACTIONS(2239),
    [anon_sym_centroid] = ACTIONS(2239),
    [anon_sym_noperspective] = ACTIONS(2239),
    [anon_sym_nointerpolation] = ACTIONS(2239),
    [anon_sym_sample] = ACTIONS(2239),
    [anon_sym_linear] = ACTIONS(2239),
    [anon_sym_snorm] = ACTIONS(2239),
    [anon_sym_unorm] = ACTIONS(2239),
    [anon_sym_point] = ACTIONS(2239),
    [anon_sym_line] = ACTIONS(2239),
    [anon_sym_triangleadj] = ACTIONS(2239),
    [anon_sym_lineadj] = ACTIONS(2239),
    [anon_sym_triangle] = ACTIONS(2239),
  },
  [1559] = {
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2310),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_RPAREN] = ACTIONS(2310),
    [anon_sym_LPAREN2] = ACTIONS(2310),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_SLASH] = ACTIONS(2308),
    [anon_sym_PERCENT] = ACTIONS(2310),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_CARET] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2310),
    [anon_sym_BANG_EQ] = ACTIONS(2310),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_EQ] = ACTIONS(2310),
    [anon_sym_LT_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_LT_LT] = ACTIONS(2310),
    [anon_sym_GT_GT] = ACTIONS(2310),
    [anon_sym_COLON] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(2308),
    [anon_sym_in] = ACTIONS(2308),
    [anon_sym_out] = ACTIONS(2308),
    [anon_sym_inout] = ACTIONS(2308),
    [anon_sym_virtual] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2308),
    [anon_sym___attribute__] = ACTIONS(2308),
    [anon_sym___attribute] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2310),
    [anon_sym___declspec] = ACTIONS(2308),
    [anon_sym___based] = ACTIONS(2308),
    [anon_sym___cdecl] = ACTIONS(2308),
    [anon_sym___clrcall] = ACTIONS(2308),
    [anon_sym___stdcall] = ACTIONS(2308),
    [anon_sym___fastcall] = ACTIONS(2308),
    [anon_sym___thiscall] = ACTIONS(2308),
    [anon_sym___vectorcall] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_RBRACE] = ACTIONS(2310),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_register] = ACTIONS(2308),
    [anon_sym_inline] = ACTIONS(2308),
    [anon_sym___inline] = ACTIONS(2308),
    [anon_sym___inline__] = ACTIONS(2308),
    [anon_sym___forceinline] = ACTIONS(2308),
    [anon_sym_thread_local] = ACTIONS(2308),
    [anon_sym___thread] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_constexpr] = ACTIONS(2308),
    [anon_sym_volatile] = ACTIONS(2308),
    [anon_sym_restrict] = ACTIONS(2308),
    [anon_sym___restrict__] = ACTIONS(2308),
    [anon_sym__Atomic] = ACTIONS(2308),
    [anon_sym__Noreturn] = ACTIONS(2308),
    [anon_sym_noreturn] = ACTIONS(2308),
    [anon_sym__Nonnull] = ACTIONS(2308),
    [anon_sym_mutable] = ACTIONS(2308),
    [anon_sym_constinit] = ACTIONS(2308),
    [anon_sym_consteval] = ACTIONS(2308),
    [anon_sym_alignas] = ACTIONS(2308),
    [anon_sym__Alignas] = ACTIONS(2308),
    [anon_sym_QMARK] = ACTIONS(2310),
    [anon_sym_LT_EQ_GT] = ACTIONS(2310),
    [anon_sym_or] = ACTIONS(2308),
    [anon_sym_and] = ACTIONS(2308),
    [anon_sym_bitor] = ACTIONS(2308),
    [anon_sym_xor] = ACTIONS(2308),
    [anon_sym_bitand] = ACTIONS(2308),
    [anon_sym_not_eq] = ACTIONS(2308),
    [anon_sym_is] = ACTIONS(2308),
    [anon_sym_as] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_DOT] = ACTIONS(2308),
    [anon_sym_DOT_STAR] = ACTIONS(2310),
    [anon_sym_DASH_GT] = ACTIONS(2310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_This] = ACTIONS(2308),
    [anon_sym_decltype] = ACTIONS(2308),
    [anon_sym_final] = ACTIONS(2308),
    [anon_sym_override] = ACTIONS(2308),
    [anon_sym_template] = ACTIONS(2308),
    [anon_sym_operator] = ACTIONS(2308),
    [anon_sym_precise] = ACTIONS(2308),
    [anon_sym_shared] = ACTIONS(2308),
    [anon_sym_groupshared] = ACTIONS(2308),
    [anon_sym_uniform] = ACTIONS(2308),
    [anon_sym_row_major] = ACTIONS(2308),
    [anon_sym_column_major] = ACTIONS(2308),
    [anon_sym_globallycoherent] = ACTIONS(2308),
    [anon_sym_centroid] = ACTIONS(2308),
    [anon_sym_noperspective] = ACTIONS(2308),
    [anon_sym_nointerpolation] = ACTIONS(2308),
    [anon_sym_sample] = ACTIONS(2308),
    [anon_sym_linear] = ACTIONS(2308),
    [anon_sym_snorm] = ACTIONS(2308),
    [anon_sym_unorm] = ACTIONS(2308),
    [anon_sym_point] = ACTIONS(2308),
    [anon_sym_line] = ACTIONS(2308),
    [anon_sym_triangleadj] = ACTIONS(2308),
    [anon_sym_lineadj] = ACTIONS(2308),
    [anon_sym_triangle] = ACTIONS(2308),
  },
  [1560] = {
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2294),
    [anon_sym_COMMA] = ACTIONS(2294),
    [anon_sym_RPAREN] = ACTIONS(2294),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_PERCENT] = ACTIONS(2294),
    [anon_sym_PIPE_PIPE] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_PIPE] = ACTIONS(2292),
    [anon_sym_CARET] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_EQ_EQ] = ACTIONS(2294),
    [anon_sym_BANG_EQ] = ACTIONS(2294),
    [anon_sym_GT] = ACTIONS(2292),
    [anon_sym_GT_EQ] = ACTIONS(2294),
    [anon_sym_LT_EQ] = ACTIONS(2292),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_LT_LT] = ACTIONS(2294),
    [anon_sym_GT_GT] = ACTIONS(2294),
    [anon_sym_COLON] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym_in] = ACTIONS(2292),
    [anon_sym_out] = ACTIONS(2292),
    [anon_sym_inout] = ACTIONS(2292),
    [anon_sym_virtual] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym___attribute] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2294),
    [anon_sym___declspec] = ACTIONS(2292),
    [anon_sym___based] = ACTIONS(2292),
    [anon_sym___cdecl] = ACTIONS(2292),
    [anon_sym___clrcall] = ACTIONS(2292),
    [anon_sym___stdcall] = ACTIONS(2292),
    [anon_sym___fastcall] = ACTIONS(2292),
    [anon_sym___thiscall] = ACTIONS(2292),
    [anon_sym___vectorcall] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym___inline] = ACTIONS(2292),
    [anon_sym___inline__] = ACTIONS(2292),
    [anon_sym___forceinline] = ACTIONS(2292),
    [anon_sym_thread_local] = ACTIONS(2292),
    [anon_sym___thread] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym__Nonnull] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [anon_sym_QMARK] = ACTIONS(2294),
    [anon_sym_LT_EQ_GT] = ACTIONS(2294),
    [anon_sym_or] = ACTIONS(2292),
    [anon_sym_and] = ACTIONS(2292),
    [anon_sym_bitor] = ACTIONS(2292),
    [anon_sym_xor] = ACTIONS(2292),
    [anon_sym_bitand] = ACTIONS(2292),
    [anon_sym_not_eq] = ACTIONS(2292),
    [anon_sym_is] = ACTIONS(2292),
    [anon_sym_as] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_DOT] = ACTIONS(2292),
    [anon_sym_DOT_STAR] = ACTIONS(2294),
    [anon_sym_DASH_GT] = ACTIONS(2294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_This] = ACTIONS(2292),
    [anon_sym_decltype] = ACTIONS(2292),
    [anon_sym_final] = ACTIONS(2292),
    [anon_sym_override] = ACTIONS(2292),
    [anon_sym_template] = ACTIONS(2292),
    [anon_sym_operator] = ACTIONS(2292),
    [anon_sym_precise] = ACTIONS(2292),
    [anon_sym_shared] = ACTIONS(2292),
    [anon_sym_groupshared] = ACTIONS(2292),
    [anon_sym_uniform] = ACTIONS(2292),
    [anon_sym_row_major] = ACTIONS(2292),
    [anon_sym_column_major] = ACTIONS(2292),
    [anon_sym_globallycoherent] = ACTIONS(2292),
    [anon_sym_centroid] = ACTIONS(2292),
    [anon_sym_noperspective] = ACTIONS(2292),
    [anon_sym_nointerpolation] = ACTIONS(2292),
    [anon_sym_sample] = ACTIONS(2292),
    [anon_sym_linear] = ACTIONS(2292),
    [anon_sym_snorm] = ACTIONS(2292),
    [anon_sym_unorm] = ACTIONS(2292),
    [anon_sym_point] = ACTIONS(2292),
    [anon_sym_line] = ACTIONS(2292),
    [anon_sym_triangleadj] = ACTIONS(2292),
    [anon_sym_lineadj] = ACTIONS(2292),
    [anon_sym_triangle] = ACTIONS(2292),
  },
  [1561] = {
    [sym_identifier] = ACTIONS(2296),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2298),
    [anon_sym_COMMA] = ACTIONS(2298),
    [anon_sym_RPAREN] = ACTIONS(2298),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2298),
    [anon_sym_SLASH] = ACTIONS(2296),
    [anon_sym_PERCENT] = ACTIONS(2298),
    [anon_sym_PIPE_PIPE] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_PIPE] = ACTIONS(2296),
    [anon_sym_CARET] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_EQ_EQ] = ACTIONS(2298),
    [anon_sym_BANG_EQ] = ACTIONS(2298),
    [anon_sym_GT] = ACTIONS(2296),
    [anon_sym_GT_EQ] = ACTIONS(2298),
    [anon_sym_LT_EQ] = ACTIONS(2296),
    [anon_sym_LT] = ACTIONS(2296),
    [anon_sym_LT_LT] = ACTIONS(2298),
    [anon_sym_GT_GT] = ACTIONS(2298),
    [anon_sym_COLON] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2298),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym_in] = ACTIONS(2296),
    [anon_sym_out] = ACTIONS(2296),
    [anon_sym_inout] = ACTIONS(2296),
    [anon_sym_virtual] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym___attribute] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2298),
    [anon_sym___declspec] = ACTIONS(2296),
    [anon_sym___based] = ACTIONS(2296),
    [anon_sym___cdecl] = ACTIONS(2296),
    [anon_sym___clrcall] = ACTIONS(2296),
    [anon_sym___stdcall] = ACTIONS(2296),
    [anon_sym___fastcall] = ACTIONS(2296),
    [anon_sym___thiscall] = ACTIONS(2296),
    [anon_sym___vectorcall] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_RBRACE] = ACTIONS(2298),
    [anon_sym_LBRACK] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_register] = ACTIONS(2296),
    [anon_sym_inline] = ACTIONS(2296),
    [anon_sym___inline] = ACTIONS(2296),
    [anon_sym___inline__] = ACTIONS(2296),
    [anon_sym___forceinline] = ACTIONS(2296),
    [anon_sym_thread_local] = ACTIONS(2296),
    [anon_sym___thread] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym__Nonnull] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [anon_sym_QMARK] = ACTIONS(2298),
    [anon_sym_LT_EQ_GT] = ACTIONS(2298),
    [anon_sym_or] = ACTIONS(2296),
    [anon_sym_and] = ACTIONS(2296),
    [anon_sym_bitor] = ACTIONS(2296),
    [anon_sym_xor] = ACTIONS(2296),
    [anon_sym_bitand] = ACTIONS(2296),
    [anon_sym_not_eq] = ACTIONS(2296),
    [anon_sym_is] = ACTIONS(2296),
    [anon_sym_as] = ACTIONS(2296),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_DOT] = ACTIONS(2296),
    [anon_sym_DOT_STAR] = ACTIONS(2298),
    [anon_sym_DASH_GT] = ACTIONS(2298),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_This] = ACTIONS(2296),
    [anon_sym_decltype] = ACTIONS(2296),
    [anon_sym_final] = ACTIONS(2296),
    [anon_sym_override] = ACTIONS(2296),
    [anon_sym_template] = ACTIONS(2296),
    [anon_sym_operator] = ACTIONS(2296),
    [anon_sym_precise] = ACTIONS(2296),
    [anon_sym_shared] = ACTIONS(2296),
    [anon_sym_groupshared] = ACTIONS(2296),
    [anon_sym_uniform] = ACTIONS(2296),
    [anon_sym_row_major] = ACTIONS(2296),
    [anon_sym_column_major] = ACTIONS(2296),
    [anon_sym_globallycoherent] = ACTIONS(2296),
    [anon_sym_centroid] = ACTIONS(2296),
    [anon_sym_noperspective] = ACTIONS(2296),
    [anon_sym_nointerpolation] = ACTIONS(2296),
    [anon_sym_sample] = ACTIONS(2296),
    [anon_sym_linear] = ACTIONS(2296),
    [anon_sym_snorm] = ACTIONS(2296),
    [anon_sym_unorm] = ACTIONS(2296),
    [anon_sym_point] = ACTIONS(2296),
    [anon_sym_line] = ACTIONS(2296),
    [anon_sym_triangleadj] = ACTIONS(2296),
    [anon_sym_lineadj] = ACTIONS(2296),
    [anon_sym_triangle] = ACTIONS(2296),
  },
  [1562] = {
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2290),
    [anon_sym_COMMA] = ACTIONS(2290),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_PERCENT] = ACTIONS(2290),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_CARET] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_EQ_EQ] = ACTIONS(2290),
    [anon_sym_BANG_EQ] = ACTIONS(2290),
    [anon_sym_GT] = ACTIONS(2288),
    [anon_sym_GT_EQ] = ACTIONS(2290),
    [anon_sym_LT_EQ] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(2290),
    [anon_sym_GT_GT] = ACTIONS(2290),
    [anon_sym_COLON] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_out] = ACTIONS(2288),
    [anon_sym_inout] = ACTIONS(2288),
    [anon_sym_virtual] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym___cdecl] = ACTIONS(2288),
    [anon_sym___clrcall] = ACTIONS(2288),
    [anon_sym___stdcall] = ACTIONS(2288),
    [anon_sym___fastcall] = ACTIONS(2288),
    [anon_sym___thiscall] = ACTIONS(2288),
    [anon_sym___vectorcall] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_RBRACE] = ACTIONS(2290),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [anon_sym_QMARK] = ACTIONS(2290),
    [anon_sym_LT_EQ_GT] = ACTIONS(2290),
    [anon_sym_or] = ACTIONS(2288),
    [anon_sym_and] = ACTIONS(2288),
    [anon_sym_bitor] = ACTIONS(2288),
    [anon_sym_xor] = ACTIONS(2288),
    [anon_sym_bitand] = ACTIONS(2288),
    [anon_sym_not_eq] = ACTIONS(2288),
    [anon_sym_is] = ACTIONS(2288),
    [anon_sym_as] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_DOT] = ACTIONS(2288),
    [anon_sym_DOT_STAR] = ACTIONS(2290),
    [anon_sym_DASH_GT] = ACTIONS(2290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_This] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [anon_sym_final] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_precise] = ACTIONS(2288),
    [anon_sym_shared] = ACTIONS(2288),
    [anon_sym_groupshared] = ACTIONS(2288),
    [anon_sym_uniform] = ACTIONS(2288),
    [anon_sym_row_major] = ACTIONS(2288),
    [anon_sym_column_major] = ACTIONS(2288),
    [anon_sym_globallycoherent] = ACTIONS(2288),
    [anon_sym_centroid] = ACTIONS(2288),
    [anon_sym_noperspective] = ACTIONS(2288),
    [anon_sym_nointerpolation] = ACTIONS(2288),
    [anon_sym_sample] = ACTIONS(2288),
    [anon_sym_linear] = ACTIONS(2288),
    [anon_sym_snorm] = ACTIONS(2288),
    [anon_sym_unorm] = ACTIONS(2288),
    [anon_sym_point] = ACTIONS(2288),
    [anon_sym_line] = ACTIONS(2288),
    [anon_sym_triangleadj] = ACTIONS(2288),
    [anon_sym_lineadj] = ACTIONS(2288),
    [anon_sym_triangle] = ACTIONS(2288),
  },
  [1563] = {
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_COMMA] = ACTIONS(2282),
    [anon_sym_RPAREN] = ACTIONS(2282),
    [anon_sym_LPAREN2] = ACTIONS(2282),
    [anon_sym_TILDE] = ACTIONS(2282),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2282),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_PERCENT] = ACTIONS(2282),
    [anon_sym_PIPE_PIPE] = ACTIONS(2282),
    [anon_sym_AMP_AMP] = ACTIONS(2282),
    [anon_sym_PIPE] = ACTIONS(2280),
    [anon_sym_CARET] = ACTIONS(2282),
    [anon_sym_AMP] = ACTIONS(2280),
    [anon_sym_EQ_EQ] = ACTIONS(2282),
    [anon_sym_BANG_EQ] = ACTIONS(2282),
    [anon_sym_GT] = ACTIONS(2280),
    [anon_sym_GT_EQ] = ACTIONS(2282),
    [anon_sym_LT_EQ] = ACTIONS(2280),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_LT_LT] = ACTIONS(2282),
    [anon_sym_GT_GT] = ACTIONS(2282),
    [anon_sym_COLON] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(2280),
    [anon_sym_in] = ACTIONS(2280),
    [anon_sym_out] = ACTIONS(2280),
    [anon_sym_inout] = ACTIONS(2280),
    [anon_sym_virtual] = ACTIONS(2280),
    [anon_sym_extern] = ACTIONS(2280),
    [anon_sym___attribute__] = ACTIONS(2280),
    [anon_sym___attribute] = ACTIONS(2280),
    [anon_sym_COLON_COLON] = ACTIONS(2282),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2282),
    [anon_sym___declspec] = ACTIONS(2280),
    [anon_sym___based] = ACTIONS(2280),
    [anon_sym___cdecl] = ACTIONS(2280),
    [anon_sym___clrcall] = ACTIONS(2280),
    [anon_sym___stdcall] = ACTIONS(2280),
    [anon_sym___fastcall] = ACTIONS(2280),
    [anon_sym___thiscall] = ACTIONS(2280),
    [anon_sym___vectorcall] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_RBRACE] = ACTIONS(2282),
    [anon_sym_LBRACK] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_register] = ACTIONS(2280),
    [anon_sym_inline] = ACTIONS(2280),
    [anon_sym___inline] = ACTIONS(2280),
    [anon_sym___inline__] = ACTIONS(2280),
    [anon_sym___forceinline] = ACTIONS(2280),
    [anon_sym_thread_local] = ACTIONS(2280),
    [anon_sym___thread] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_constexpr] = ACTIONS(2280),
    [anon_sym_volatile] = ACTIONS(2280),
    [anon_sym_restrict] = ACTIONS(2280),
    [anon_sym___restrict__] = ACTIONS(2280),
    [anon_sym__Atomic] = ACTIONS(2280),
    [anon_sym__Noreturn] = ACTIONS(2280),
    [anon_sym_noreturn] = ACTIONS(2280),
    [anon_sym__Nonnull] = ACTIONS(2280),
    [anon_sym_mutable] = ACTIONS(2280),
    [anon_sym_constinit] = ACTIONS(2280),
    [anon_sym_consteval] = ACTIONS(2280),
    [anon_sym_alignas] = ACTIONS(2280),
    [anon_sym__Alignas] = ACTIONS(2280),
    [anon_sym_QMARK] = ACTIONS(2282),
    [anon_sym_LT_EQ_GT] = ACTIONS(2282),
    [anon_sym_or] = ACTIONS(2280),
    [anon_sym_and] = ACTIONS(2280),
    [anon_sym_bitor] = ACTIONS(2280),
    [anon_sym_xor] = ACTIONS(2280),
    [anon_sym_bitand] = ACTIONS(2280),
    [anon_sym_not_eq] = ACTIONS(2280),
    [anon_sym_is] = ACTIONS(2280),
    [anon_sym_as] = ACTIONS(2280),
    [anon_sym_DASH_DASH] = ACTIONS(2282),
    [anon_sym_PLUS_PLUS] = ACTIONS(2282),
    [anon_sym_DOT] = ACTIONS(2280),
    [anon_sym_DOT_STAR] = ACTIONS(2282),
    [anon_sym_DASH_GT] = ACTIONS(2282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_This] = ACTIONS(2280),
    [anon_sym_decltype] = ACTIONS(2280),
    [anon_sym_final] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_template] = ACTIONS(2280),
    [anon_sym_operator] = ACTIONS(2280),
    [anon_sym_precise] = ACTIONS(2280),
    [anon_sym_shared] = ACTIONS(2280),
    [anon_sym_groupshared] = ACTIONS(2280),
    [anon_sym_uniform] = ACTIONS(2280),
    [anon_sym_row_major] = ACTIONS(2280),
    [anon_sym_column_major] = ACTIONS(2280),
    [anon_sym_globallycoherent] = ACTIONS(2280),
    [anon_sym_centroid] = ACTIONS(2280),
    [anon_sym_noperspective] = ACTIONS(2280),
    [anon_sym_nointerpolation] = ACTIONS(2280),
    [anon_sym_sample] = ACTIONS(2280),
    [anon_sym_linear] = ACTIONS(2280),
    [anon_sym_snorm] = ACTIONS(2280),
    [anon_sym_unorm] = ACTIONS(2280),
    [anon_sym_point] = ACTIONS(2280),
    [anon_sym_line] = ACTIONS(2280),
    [anon_sym_triangleadj] = ACTIONS(2280),
    [anon_sym_lineadj] = ACTIONS(2280),
    [anon_sym_triangle] = ACTIONS(2280),
  },
  [1564] = {
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2314),
    [anon_sym_COMMA] = ACTIONS(2314),
    [anon_sym_RPAREN] = ACTIONS(2314),
    [anon_sym_LPAREN2] = ACTIONS(2314),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_SLASH] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2314),
    [anon_sym_PIPE_PIPE] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2314),
    [anon_sym_PIPE] = ACTIONS(2312),
    [anon_sym_CARET] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_EQ_EQ] = ACTIONS(2314),
    [anon_sym_BANG_EQ] = ACTIONS(2314),
    [anon_sym_GT] = ACTIONS(2312),
    [anon_sym_GT_EQ] = ACTIONS(2314),
    [anon_sym_LT_EQ] = ACTIONS(2312),
    [anon_sym_LT] = ACTIONS(2312),
    [anon_sym_LT_LT] = ACTIONS(2314),
    [anon_sym_GT_GT] = ACTIONS(2314),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym___extension__] = ACTIONS(2312),
    [anon_sym_in] = ACTIONS(2312),
    [anon_sym_out] = ACTIONS(2312),
    [anon_sym_inout] = ACTIONS(2312),
    [anon_sym_virtual] = ACTIONS(2312),
    [anon_sym_extern] = ACTIONS(2312),
    [anon_sym___attribute__] = ACTIONS(2312),
    [anon_sym___attribute] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2314),
    [anon_sym___declspec] = ACTIONS(2312),
    [anon_sym___based] = ACTIONS(2312),
    [anon_sym___cdecl] = ACTIONS(2312),
    [anon_sym___clrcall] = ACTIONS(2312),
    [anon_sym___stdcall] = ACTIONS(2312),
    [anon_sym___fastcall] = ACTIONS(2312),
    [anon_sym___thiscall] = ACTIONS(2312),
    [anon_sym___vectorcall] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_RBRACE] = ACTIONS(2314),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_register] = ACTIONS(2312),
    [anon_sym_inline] = ACTIONS(2312),
    [anon_sym___inline] = ACTIONS(2312),
    [anon_sym___inline__] = ACTIONS(2312),
    [anon_sym___forceinline] = ACTIONS(2312),
    [anon_sym_thread_local] = ACTIONS(2312),
    [anon_sym___thread] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_constexpr] = ACTIONS(2312),
    [anon_sym_volatile] = ACTIONS(2312),
    [anon_sym_restrict] = ACTIONS(2312),
    [anon_sym___restrict__] = ACTIONS(2312),
    [anon_sym__Atomic] = ACTIONS(2312),
    [anon_sym__Noreturn] = ACTIONS(2312),
    [anon_sym_noreturn] = ACTIONS(2312),
    [anon_sym__Nonnull] = ACTIONS(2312),
    [anon_sym_mutable] = ACTIONS(2312),
    [anon_sym_constinit] = ACTIONS(2312),
    [anon_sym_consteval] = ACTIONS(2312),
    [anon_sym_alignas] = ACTIONS(2312),
    [anon_sym__Alignas] = ACTIONS(2312),
    [anon_sym_QMARK] = ACTIONS(2314),
    [anon_sym_LT_EQ_GT] = ACTIONS(2314),
    [anon_sym_or] = ACTIONS(2312),
    [anon_sym_and] = ACTIONS(2312),
    [anon_sym_bitor] = ACTIONS(2312),
    [anon_sym_xor] = ACTIONS(2312),
    [anon_sym_bitand] = ACTIONS(2312),
    [anon_sym_not_eq] = ACTIONS(2312),
    [anon_sym_is] = ACTIONS(2312),
    [anon_sym_as] = ACTIONS(2312),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_DOT] = ACTIONS(2312),
    [anon_sym_DOT_STAR] = ACTIONS(2314),
    [anon_sym_DASH_GT] = ACTIONS(2314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_This] = ACTIONS(2312),
    [anon_sym_decltype] = ACTIONS(2312),
    [anon_sym_final] = ACTIONS(2312),
    [anon_sym_override] = ACTIONS(2312),
    [anon_sym_template] = ACTIONS(2312),
    [anon_sym_operator] = ACTIONS(2312),
    [anon_sym_precise] = ACTIONS(2312),
    [anon_sym_shared] = ACTIONS(2312),
    [anon_sym_groupshared] = ACTIONS(2312),
    [anon_sym_uniform] = ACTIONS(2312),
    [anon_sym_row_major] = ACTIONS(2312),
    [anon_sym_column_major] = ACTIONS(2312),
    [anon_sym_globallycoherent] = ACTIONS(2312),
    [anon_sym_centroid] = ACTIONS(2312),
    [anon_sym_noperspective] = ACTIONS(2312),
    [anon_sym_nointerpolation] = ACTIONS(2312),
    [anon_sym_sample] = ACTIONS(2312),
    [anon_sym_linear] = ACTIONS(2312),
    [anon_sym_snorm] = ACTIONS(2312),
    [anon_sym_unorm] = ACTIONS(2312),
    [anon_sym_point] = ACTIONS(2312),
    [anon_sym_line] = ACTIONS(2312),
    [anon_sym_triangleadj] = ACTIONS(2312),
    [anon_sym_lineadj] = ACTIONS(2312),
    [anon_sym_triangle] = ACTIONS(2312),
  },
  [1565] = {
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8485),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8054),
    [sym_array_declarator] = STATE(8054),
    [sym_expression] = STATE(4246),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4356),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7263),
    [sym_qualified_identifier] = STATE(4377),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_operator_name] = STATE(8054),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5374),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2811),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2821),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(2861),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1566] = {
    [sym_function_definition] = STATE(542),
    [sym_declaration] = STATE(542),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2601),
    [sym_declaration_list] = STATE(542),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_hlsl_attribute] = STATE(1645),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(5773),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(5775),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1567] = {
    [sym_function_definition] = STATE(1130),
    [sym_declaration] = STATE(1130),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6092),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2604),
    [sym_declaration_list] = STATE(1130),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_hlsl_attribute] = STATE(1642),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(5777),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(5775),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1568] = {
    [sym_function_definition] = STATE(1104),
    [sym_declaration] = STATE(1104),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2594),
    [sym_declaration_list] = STATE(1104),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_hlsl_attribute] = STATE(1637),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(5779),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(5775),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1569] = {
    [sym_function_definition] = STATE(1071),
    [sym_declaration] = STATE(1071),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6100),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2234),
    [sym_declaration_list] = STATE(1071),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_hlsl_attribute] = STATE(1636),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(5781),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(5775),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1570] = {
    [sym_function_definition] = STATE(2442),
    [sym_declaration] = STATE(2442),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6104),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2607),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(11184),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(3025),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(3026),
    [sym_qualifiers] = STATE(2666),
    [sym_hlsl_attribute] = STATE(1643),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5783),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(5775),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(5785),
    [anon_sym_struct] = ACTIONS(5787),
    [anon_sym_union] = ACTIONS(5789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1571] = {
    [sym_function_definition] = STATE(1740),
    [sym_declaration] = STATE(1740),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6107),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2610),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(11289),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(3025),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(3026),
    [sym_qualifiers] = STATE(2666),
    [sym_hlsl_attribute] = STATE(1639),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5783),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(5775),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(5791),
    [anon_sym_struct] = ACTIONS(5793),
    [anon_sym_union] = ACTIONS(5795),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1572] = {
    [sym_function_definition] = STATE(574),
    [sym_declaration] = STATE(574),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2601),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(11554),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(3025),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(3026),
    [sym_qualifiers] = STATE(2666),
    [sym_hlsl_attribute] = STATE(1645),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5783),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(5775),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(5797),
    [anon_sym_struct] = ACTIONS(5799),
    [anon_sym_union] = ACTIONS(5801),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1573] = {
    [sym_function_definition] = STATE(1682),
    [sym_declaration] = STATE(1682),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6107),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2610),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(11418),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(3025),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(3026),
    [sym_qualifiers] = STATE(2666),
    [sym_hlsl_attribute] = STATE(1639),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5783),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(5775),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(5803),
    [anon_sym_struct] = ACTIONS(5805),
    [anon_sym_union] = ACTIONS(5807),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1574] = {
    [sym_function_definition] = STATE(2251),
    [sym_declaration] = STATE(2251),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6111),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2613),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(11295),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(3025),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(3026),
    [sym_qualifiers] = STATE(2666),
    [sym_hlsl_attribute] = STATE(1640),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5783),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(5775),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(5809),
    [anon_sym_struct] = ACTIONS(5811),
    [anon_sym_union] = ACTIONS(5813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1575] = {
    [sym_function_definition] = STATE(1082),
    [sym_declaration] = STATE(1082),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2594),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(11005),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(3025),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(3026),
    [sym_qualifiers] = STATE(2666),
    [sym_hlsl_attribute] = STATE(1637),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5783),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(5775),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(5815),
    [anon_sym_struct] = ACTIONS(5817),
    [anon_sym_union] = ACTIONS(5819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1576] = {
    [sym_function_definition] = STATE(934),
    [sym_declaration] = STATE(934),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6100),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2234),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(11565),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(3025),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(3026),
    [sym_qualifiers] = STATE(2666),
    [sym_hlsl_attribute] = STATE(1636),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5783),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(5775),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(5821),
    [anon_sym_struct] = ACTIONS(5823),
    [anon_sym_union] = ACTIONS(5825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1577] = {
    [sym_function_definition] = STATE(1108),
    [sym_declaration] = STATE(1108),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6100),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2234),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(11247),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(3025),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(3026),
    [sym_qualifiers] = STATE(2666),
    [sym_hlsl_attribute] = STATE(1636),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5783),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(5775),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(5827),
    [anon_sym_struct] = ACTIONS(5829),
    [anon_sym_union] = ACTIONS(5831),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1578] = {
    [sym_function_definition] = STATE(521),
    [sym_declaration] = STATE(521),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6085),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2601),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10793),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(3025),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(3026),
    [sym_qualifiers] = STATE(2666),
    [sym_hlsl_attribute] = STATE(1645),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5783),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(5775),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(5833),
    [anon_sym_struct] = ACTIONS(5835),
    [anon_sym_union] = ACTIONS(5837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1579] = {
    [sym_function_definition] = STATE(1153),
    [sym_declaration] = STATE(1153),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6092),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2604),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(10969),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(3025),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(3026),
    [sym_qualifiers] = STATE(2666),
    [sym_hlsl_attribute] = STATE(1642),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5783),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(5775),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(5839),
    [anon_sym_struct] = ACTIONS(5841),
    [anon_sym_union] = ACTIONS(5843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1580] = {
    [sym_function_definition] = STATE(2267),
    [sym_declaration] = STATE(2267),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6104),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2607),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(11416),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(3025),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(3026),
    [sym_qualifiers] = STATE(2666),
    [sym_hlsl_attribute] = STATE(1643),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5783),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(5775),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(5845),
    [anon_sym_struct] = ACTIONS(5847),
    [anon_sym_union] = ACTIONS(5849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1581] = {
    [sym_function_definition] = STATE(2268),
    [sym_declaration] = STATE(2268),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6111),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2613),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(11489),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(3025),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(3026),
    [sym_qualifiers] = STATE(2666),
    [sym_hlsl_attribute] = STATE(1640),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5783),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(5775),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(5851),
    [anon_sym_struct] = ACTIONS(5853),
    [anon_sym_union] = ACTIONS(5855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1582] = {
    [sym_function_definition] = STATE(1050),
    [sym_declaration] = STATE(1050),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6135),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2594),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(11034),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(3025),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(3026),
    [sym_qualifiers] = STATE(2666),
    [sym_hlsl_attribute] = STATE(1637),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5783),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(5775),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(5857),
    [anon_sym_struct] = ACTIONS(5859),
    [anon_sym_union] = ACTIONS(5861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1583] = {
    [sym_function_definition] = STATE(899),
    [sym_declaration] = STATE(899),
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6092),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2604),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym__class_name] = STATE(11166),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(3025),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(3026),
    [sym_qualifiers] = STATE(2666),
    [sym_hlsl_attribute] = STATE(1642),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5783),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(5775),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(5863),
    [anon_sym_struct] = ACTIONS(5865),
    [anon_sym_union] = ACTIONS(5867),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1584] = {
    [sym_expression_statement] = STATE(3670),
    [sym_expression] = STATE(5743),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11372),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_type_requirement] = STATE(1601),
    [sym_compound_requirement] = STATE(1601),
    [sym__requirement] = STATE(1601),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_requirement_seq_repeat1] = STATE(1601),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(5869),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5871),
    [anon_sym_RBRACE] = ACTIONS(5873),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(5875),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1585] = {
    [sym_expression] = STATE(5567),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(9805),
    [sym_initializer_pair] = STATE(9805),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [sym_identifier] = ACTIONS(5877),
    [anon_sym_COMMA] = ACTIONS(5879),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_RBRACE] = ACTIONS(5881),
    [anon_sym_LBRACK] = ACTIONS(5883),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1586] = {
    [sym_expression_statement] = STATE(3670),
    [sym_expression] = STATE(5743),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11372),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_type_requirement] = STATE(1601),
    [sym_compound_requirement] = STATE(1601),
    [sym__requirement] = STATE(1601),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_requirement_seq_repeat1] = STATE(1601),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(5869),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5871),
    [anon_sym_RBRACE] = ACTIONS(5885),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(5875),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1587] = {
    [sym_expression] = STATE(5484),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10117),
    [sym_initializer_pair] = STATE(10117),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [sym_identifier] = ACTIONS(5877),
    [anon_sym_COMMA] = ACTIONS(5887),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_RBRACE] = ACTIONS(5889),
    [anon_sym_LBRACK] = ACTIONS(5883),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1588] = {
    [sym_expression_statement] = STATE(3670),
    [sym_expression] = STATE(5743),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11372),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_type_requirement] = STATE(1589),
    [sym_compound_requirement] = STATE(1589),
    [sym__requirement] = STATE(1589),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_requirement_seq_repeat1] = STATE(1589),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(5869),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5871),
    [anon_sym_RBRACE] = ACTIONS(5891),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(5875),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1589] = {
    [sym_expression_statement] = STATE(3670),
    [sym_expression] = STATE(5743),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11372),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_type_requirement] = STATE(1601),
    [sym_compound_requirement] = STATE(1601),
    [sym__requirement] = STATE(1601),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_requirement_seq_repeat1] = STATE(1601),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(5869),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5871),
    [anon_sym_RBRACE] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(5875),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1590] = {
    [sym_expression_statement] = STATE(3670),
    [sym_expression] = STATE(5743),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11372),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_type_requirement] = STATE(1609),
    [sym_compound_requirement] = STATE(1609),
    [sym__requirement] = STATE(1609),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_requirement_seq_repeat1] = STATE(1609),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(5869),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5871),
    [anon_sym_RBRACE] = ACTIONS(5895),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(5875),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1591] = {
    [sym_expression] = STATE(5574),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(9619),
    [sym_initializer_pair] = STATE(9619),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [sym_identifier] = ACTIONS(5877),
    [anon_sym_COMMA] = ACTIONS(5897),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_RBRACE] = ACTIONS(5899),
    [anon_sym_LBRACK] = ACTIONS(5883),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1592] = {
    [sym_expression_statement] = STATE(3670),
    [sym_expression] = STATE(5743),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11372),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_type_requirement] = STATE(1601),
    [sym_compound_requirement] = STATE(1601),
    [sym__requirement] = STATE(1601),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_requirement_seq_repeat1] = STATE(1601),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(5869),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5871),
    [anon_sym_RBRACE] = ACTIONS(5901),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(5875),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1593] = {
    [sym_expression_statement] = STATE(3670),
    [sym_expression] = STATE(5743),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11372),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_type_requirement] = STATE(1595),
    [sym_compound_requirement] = STATE(1595),
    [sym__requirement] = STATE(1595),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_requirement_seq_repeat1] = STATE(1595),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(5869),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5871),
    [anon_sym_RBRACE] = ACTIONS(5903),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(5875),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1594] = {
    [sym_expression_statement] = STATE(3670),
    [sym_expression] = STATE(5743),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11372),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_type_requirement] = STATE(1599),
    [sym_compound_requirement] = STATE(1599),
    [sym__requirement] = STATE(1599),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_requirement_seq_repeat1] = STATE(1599),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(5869),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5871),
    [anon_sym_RBRACE] = ACTIONS(5905),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(5875),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1595] = {
    [sym_expression_statement] = STATE(3670),
    [sym_expression] = STATE(5743),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11372),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_type_requirement] = STATE(1601),
    [sym_compound_requirement] = STATE(1601),
    [sym__requirement] = STATE(1601),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_requirement_seq_repeat1] = STATE(1601),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(5869),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5871),
    [anon_sym_RBRACE] = ACTIONS(5907),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(5875),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1596] = {
    [sym_expression_statement] = STATE(3670),
    [sym_expression] = STATE(5743),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11372),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_type_requirement] = STATE(1597),
    [sym_compound_requirement] = STATE(1597),
    [sym__requirement] = STATE(1597),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_requirement_seq_repeat1] = STATE(1597),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(5869),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5871),
    [anon_sym_RBRACE] = ACTIONS(5909),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(5875),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1597] = {
    [sym_expression_statement] = STATE(3670),
    [sym_expression] = STATE(5743),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11372),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_type_requirement] = STATE(1601),
    [sym_compound_requirement] = STATE(1601),
    [sym__requirement] = STATE(1601),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_requirement_seq_repeat1] = STATE(1601),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(5869),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5871),
    [anon_sym_RBRACE] = ACTIONS(5911),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(5875),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1598] = {
    [sym_expression] = STATE(5548),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(9609),
    [sym_initializer_pair] = STATE(9609),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [sym_identifier] = ACTIONS(5877),
    [anon_sym_COMMA] = ACTIONS(5913),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_RBRACE] = ACTIONS(5915),
    [anon_sym_LBRACK] = ACTIONS(5883),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1599] = {
    [sym_expression_statement] = STATE(3670),
    [sym_expression] = STATE(5743),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11372),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_type_requirement] = STATE(1601),
    [sym_compound_requirement] = STATE(1601),
    [sym__requirement] = STATE(1601),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_requirement_seq_repeat1] = STATE(1601),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(5869),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5871),
    [anon_sym_RBRACE] = ACTIONS(5917),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(5875),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1600] = {
    [sym_expression_statement] = STATE(3670),
    [sym_expression] = STATE(5743),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11372),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_type_requirement] = STATE(1601),
    [sym_compound_requirement] = STATE(1601),
    [sym__requirement] = STATE(1601),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_requirement_seq_repeat1] = STATE(1601),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(5869),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5871),
    [anon_sym_RBRACE] = ACTIONS(5919),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(5875),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1601] = {
    [sym_expression_statement] = STATE(3670),
    [sym_expression] = STATE(5743),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11372),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_type_requirement] = STATE(1601),
    [sym_compound_requirement] = STATE(1601),
    [sym__requirement] = STATE(1601),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_requirement_seq_repeat1] = STATE(1601),
    [sym_identifier] = ACTIONS(5921),
    [anon_sym_LPAREN2] = ACTIONS(5924),
    [anon_sym_BANG] = ACTIONS(5927),
    [anon_sym_TILDE] = ACTIONS(5927),
    [anon_sym_DASH] = ACTIONS(5930),
    [anon_sym_PLUS] = ACTIONS(5930),
    [anon_sym_STAR] = ACTIONS(5933),
    [anon_sym_AMP] = ACTIONS(5933),
    [anon_sym_SEMI] = ACTIONS(5936),
    [anon_sym___extension__] = ACTIONS(5939),
    [anon_sym_COLON_COLON] = ACTIONS(5942),
    [anon_sym_LBRACE] = ACTIONS(5945),
    [anon_sym_RBRACE] = ACTIONS(5948),
    [anon_sym_LBRACK] = ACTIONS(5950),
    [sym_primitive_type] = ACTIONS(5953),
    [anon_sym_not] = ACTIONS(5930),
    [anon_sym_compl] = ACTIONS(5930),
    [anon_sym_DASH_DASH] = ACTIONS(5956),
    [anon_sym_PLUS_PLUS] = ACTIONS(5956),
    [anon_sym_sizeof] = ACTIONS(5959),
    [anon_sym___alignof__] = ACTIONS(5962),
    [anon_sym___alignof] = ACTIONS(5962),
    [anon_sym__alignof] = ACTIONS(5962),
    [anon_sym_alignof] = ACTIONS(5962),
    [anon_sym__Alignof] = ACTIONS(5962),
    [anon_sym_offsetof] = ACTIONS(5965),
    [anon_sym__Generic] = ACTIONS(5968),
    [anon_sym_asm] = ACTIONS(5971),
    [anon_sym___asm__] = ACTIONS(5971),
    [anon_sym___asm] = ACTIONS(5971),
    [sym_number_literal] = ACTIONS(5974),
    [anon_sym_L_SQUOTE] = ACTIONS(5977),
    [anon_sym_u_SQUOTE] = ACTIONS(5977),
    [anon_sym_U_SQUOTE] = ACTIONS(5977),
    [anon_sym_u8_SQUOTE] = ACTIONS(5977),
    [anon_sym_SQUOTE] = ACTIONS(5977),
    [anon_sym_L_DQUOTE] = ACTIONS(5980),
    [anon_sym_u_DQUOTE] = ACTIONS(5980),
    [anon_sym_U_DQUOTE] = ACTIONS(5980),
    [anon_sym_u8_DQUOTE] = ACTIONS(5980),
    [anon_sym_DQUOTE] = ACTIONS(5980),
    [sym_true] = ACTIONS(5983),
    [sym_false] = ACTIONS(5983),
    [anon_sym_NULL] = ACTIONS(5986),
    [anon_sym_nullptr] = ACTIONS(5986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5989),
    [anon_sym_typename] = ACTIONS(5992),
    [anon_sym_template] = ACTIONS(5995),
    [anon_sym_delete] = ACTIONS(5998),
    [anon_sym_R_DQUOTE] = ACTIONS(6001),
    [anon_sym_LR_DQUOTE] = ACTIONS(6001),
    [anon_sym_uR_DQUOTE] = ACTIONS(6001),
    [anon_sym_UR_DQUOTE] = ACTIONS(6001),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6001),
    [anon_sym_co_await] = ACTIONS(6004),
    [anon_sym_new] = ACTIONS(6007),
    [anon_sym_requires] = ACTIONS(6010),
    [sym_this] = ACTIONS(5983),
  },
  [1602] = {
    [sym_expression_statement] = STATE(3670),
    [sym_expression] = STATE(5743),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11372),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_type_requirement] = STATE(1600),
    [sym_compound_requirement] = STATE(1600),
    [sym__requirement] = STATE(1600),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_requirement_seq_repeat1] = STATE(1600),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(5869),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5871),
    [anon_sym_RBRACE] = ACTIONS(6013),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(5875),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1603] = {
    [sym_expression] = STATE(5565),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(9647),
    [sym_initializer_pair] = STATE(9647),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [sym_identifier] = ACTIONS(5877),
    [anon_sym_COMMA] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_RBRACE] = ACTIONS(6015),
    [anon_sym_LBRACK] = ACTIONS(5883),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1604] = {
    [sym_expression] = STATE(5504),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(9618),
    [sym_initializer_pair] = STATE(9618),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [sym_identifier] = ACTIONS(5877),
    [anon_sym_COMMA] = ACTIONS(6017),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_RBRACE] = ACTIONS(6019),
    [anon_sym_LBRACK] = ACTIONS(5883),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1605] = {
    [sym_identifier] = ACTIONS(2243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2245),
    [anon_sym_COMMA] = ACTIONS(2245),
    [anon_sym_LPAREN2] = ACTIONS(2247),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2247),
    [anon_sym_SLASH] = ACTIONS(2255),
    [anon_sym_PERCENT] = ACTIONS(2245),
    [anon_sym_PIPE_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2255),
    [anon_sym_CARET] = ACTIONS(2245),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2245),
    [anon_sym_BANG_EQ] = ACTIONS(2245),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_GT_EQ] = ACTIONS(2245),
    [anon_sym_LT_EQ] = ACTIONS(2255),
    [anon_sym_LT] = ACTIONS(2255),
    [anon_sym_LT_LT] = ACTIONS(2245),
    [anon_sym_GT_GT] = ACTIONS(2245),
    [anon_sym_SEMI] = ACTIONS(2247),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_out] = ACTIONS(2243),
    [anon_sym_inout] = ACTIONS(2243),
    [anon_sym_virtual] = ACTIONS(2243),
    [anon_sym_extern] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym___attribute] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2247),
    [anon_sym___declspec] = ACTIONS(2243),
    [anon_sym___based] = ACTIONS(2243),
    [anon_sym___cdecl] = ACTIONS(2243),
    [anon_sym___clrcall] = ACTIONS(2243),
    [anon_sym___stdcall] = ACTIONS(2243),
    [anon_sym___fastcall] = ACTIONS(2243),
    [anon_sym___thiscall] = ACTIONS(2243),
    [anon_sym___vectorcall] = ACTIONS(2243),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2245),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_register] = ACTIONS(2243),
    [anon_sym_inline] = ACTIONS(2243),
    [anon_sym___inline] = ACTIONS(2243),
    [anon_sym___inline__] = ACTIONS(2243),
    [anon_sym___forceinline] = ACTIONS(2243),
    [anon_sym_thread_local] = ACTIONS(2243),
    [anon_sym___thread] = ACTIONS(2243),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym__Nonnull] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [anon_sym_QMARK] = ACTIONS(2245),
    [anon_sym_LT_EQ_GT] = ACTIONS(2245),
    [anon_sym_or] = ACTIONS(2255),
    [anon_sym_and] = ACTIONS(2255),
    [anon_sym_bitor] = ACTIONS(2255),
    [anon_sym_xor] = ACTIONS(2255),
    [anon_sym_bitand] = ACTIONS(2255),
    [anon_sym_not_eq] = ACTIONS(2255),
    [anon_sym_is] = ACTIONS(2255),
    [anon_sym_as] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2245),
    [anon_sym_PLUS_PLUS] = ACTIONS(2245),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2245),
    [anon_sym_DASH_GT] = ACTIONS(2245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2243),
    [anon_sym_let] = ACTIONS(2243),
    [anon_sym_This] = ACTIONS(2243),
    [anon_sym_decltype] = ACTIONS(2243),
    [anon_sym_template] = ACTIONS(2243),
    [anon_sym_operator] = ACTIONS(2243),
    [anon_sym_precise] = ACTIONS(2243),
    [anon_sym_shared] = ACTIONS(2243),
    [anon_sym_groupshared] = ACTIONS(2243),
    [anon_sym_uniform] = ACTIONS(2243),
    [anon_sym_row_major] = ACTIONS(2243),
    [anon_sym_column_major] = ACTIONS(2243),
    [anon_sym_globallycoherent] = ACTIONS(2243),
    [anon_sym_centroid] = ACTIONS(2243),
    [anon_sym_noperspective] = ACTIONS(2243),
    [anon_sym_nointerpolation] = ACTIONS(2243),
    [anon_sym_sample] = ACTIONS(2243),
    [anon_sym_linear] = ACTIONS(2243),
    [anon_sym_snorm] = ACTIONS(2243),
    [anon_sym_unorm] = ACTIONS(2243),
    [anon_sym_point] = ACTIONS(2243),
    [anon_sym_line] = ACTIONS(2243),
    [anon_sym_triangleadj] = ACTIONS(2243),
    [anon_sym_lineadj] = ACTIONS(2243),
    [anon_sym_triangle] = ACTIONS(2243),
  },
  [1606] = {
    [sym_expression_statement] = STATE(3670),
    [sym_expression] = STATE(5743),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11372),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_type_requirement] = STATE(1592),
    [sym_compound_requirement] = STATE(1592),
    [sym__requirement] = STATE(1592),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_requirement_seq_repeat1] = STATE(1592),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(5869),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5871),
    [anon_sym_RBRACE] = ACTIONS(6021),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(5875),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1607] = {
    [sym_expression_statement] = STATE(3670),
    [sym_expression] = STATE(5743),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11372),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_type_requirement] = STATE(1586),
    [sym_compound_requirement] = STATE(1586),
    [sym__requirement] = STATE(1586),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_requirement_seq_repeat1] = STATE(1586),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(5869),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5871),
    [anon_sym_RBRACE] = ACTIONS(6023),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(5875),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1608] = {
    [sym_expression] = STATE(5464),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(9686),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10724),
    [sym_initializer_pair] = STATE(10724),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [sym_identifier] = ACTIONS(5877),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_RBRACE] = ACTIONS(6025),
    [anon_sym_LBRACK] = ACTIONS(5883),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1609] = {
    [sym_expression_statement] = STATE(3670),
    [sym_expression] = STATE(5743),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11372),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_type_requirement] = STATE(1601),
    [sym_compound_requirement] = STATE(1601),
    [sym__requirement] = STATE(1601),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_requirement_seq_repeat1] = STATE(1601),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(5869),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5871),
    [anon_sym_RBRACE] = ACTIONS(6027),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(5875),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1610] = {
    [sym_expression_statement] = STATE(3670),
    [sym_expression] = STATE(5743),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11372),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_type_requirement] = STATE(1584),
    [sym_compound_requirement] = STATE(1584),
    [sym__requirement] = STATE(1584),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_requirement_seq_repeat1] = STATE(1584),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(5869),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5871),
    [anon_sym_RBRACE] = ACTIONS(6029),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(5875),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1611] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6282),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2198),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(6031),
    [anon_sym_for] = ACTIONS(6033),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1612] = {
    [sym_expression] = STATE(5668),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10724),
    [sym_initializer_pair] = STATE(10724),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [sym_identifier] = ACTIONS(5877),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_RBRACE] = ACTIONS(6035),
    [anon_sym_LBRACK] = ACTIONS(5883),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1613] = {
    [sym_expression] = STATE(5668),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10724),
    [sym_initializer_pair] = STATE(10724),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [sym_identifier] = ACTIONS(5877),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_RBRACE] = ACTIONS(6037),
    [anon_sym_LBRACK] = ACTIONS(5883),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1614] = {
    [sym_expression] = STATE(5668),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10724),
    [sym_initializer_pair] = STATE(10724),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [sym_identifier] = ACTIONS(5877),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_RBRACE] = ACTIONS(6039),
    [anon_sym_LBRACK] = ACTIONS(5883),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1615] = {
    [sym_expression] = STATE(5668),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10724),
    [sym_initializer_pair] = STATE(10724),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [sym_identifier] = ACTIONS(5877),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_RBRACE] = ACTIONS(6041),
    [anon_sym_LBRACK] = ACTIONS(5883),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1616] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6356),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2603),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(6043),
    [anon_sym_for] = ACTIONS(6045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1617] = {
    [sym_expression] = STATE(5668),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10724),
    [sym_initializer_pair] = STATE(10724),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [sym_identifier] = ACTIONS(5877),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_RBRACE] = ACTIONS(6047),
    [anon_sym_LBRACK] = ACTIONS(5883),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1618] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6288),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2606),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(6049),
    [anon_sym_for] = ACTIONS(6051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1619] = {
    [sym_expression] = STATE(5668),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10724),
    [sym_initializer_pair] = STATE(10724),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [sym_identifier] = ACTIONS(5877),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_RBRACE] = ACTIONS(6025),
    [anon_sym_LBRACK] = ACTIONS(5883),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1620] = {
    [sym_expression] = STATE(5668),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10724),
    [sym_initializer_pair] = STATE(10724),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [sym_identifier] = ACTIONS(5877),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_RBRACE] = ACTIONS(6053),
    [anon_sym_LBRACK] = ACTIONS(5883),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1621] = {
    [sym_expression] = STATE(5668),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10724),
    [sym_initializer_pair] = STATE(10724),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [sym_identifier] = ACTIONS(5877),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_RBRACE] = ACTIONS(6055),
    [anon_sym_LBRACK] = ACTIONS(5883),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1622] = {
    [sym_expression] = STATE(5668),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10724),
    [sym_initializer_pair] = STATE(10724),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [sym_identifier] = ACTIONS(5877),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_RBRACE] = ACTIONS(6057),
    [anon_sym_LBRACK] = ACTIONS(5883),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1623] = {
    [sym_expression] = STATE(5668),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10724),
    [sym_initializer_pair] = STATE(10724),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [sym_identifier] = ACTIONS(5877),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_RBRACE] = ACTIONS(6059),
    [anon_sym_LBRACK] = ACTIONS(5883),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1624] = {
    [sym_expression] = STATE(5668),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10724),
    [sym_initializer_pair] = STATE(10724),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [sym_identifier] = ACTIONS(5877),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_RBRACE] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(5883),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1625] = {
    [sym_expression] = STATE(5668),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10724),
    [sym_initializer_pair] = STATE(10724),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [sym_identifier] = ACTIONS(5877),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_RBRACE] = ACTIONS(6063),
    [anon_sym_LBRACK] = ACTIONS(5883),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1626] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6312),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2597),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(6065),
    [anon_sym_for] = ACTIONS(6067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1627] = {
    [sym_expression] = STATE(5907),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_lambda_default_capture] = STATE(10432),
    [sym__lambda_capture_identifier] = STATE(9692),
    [sym_lambda_capture_initializer] = STATE(9692),
    [sym__lambda_capture] = STATE(9692),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_identifier_parameter_pack_expansion] = STATE(9692),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4703),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(6069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6071),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(6073),
    [anon_sym_AMP] = ACTIONS(6075),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6077),
    [anon_sym_EQ] = ACTIONS(6079),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(6081),
  },
  [1628] = {
    [sym_identifier] = ACTIONS(2414),
    [aux_sym_preproc_def_token1] = ACTIONS(2414),
    [aux_sym_preproc_if_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2414),
    [sym_preproc_directive] = ACTIONS(2414),
    [anon_sym_LPAREN2] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_PIPE_PIPE] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym___extension__] = ACTIONS(2414),
    [anon_sym_typedef] = ACTIONS(2414),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_out] = ACTIONS(2414),
    [anon_sym_inout] = ACTIONS(2414),
    [anon_sym_virtual] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym___attribute__] = ACTIONS(2414),
    [anon_sym___attribute] = ACTIONS(2414),
    [anon_sym_using] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2412),
    [anon_sym___declspec] = ACTIONS(2414),
    [anon_sym___based] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(2412),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [anon_sym_signed] = ACTIONS(2414),
    [anon_sym_unsigned] = ACTIONS(2414),
    [anon_sym_long] = ACTIONS(2414),
    [anon_sym_short] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_register] = ACTIONS(2414),
    [anon_sym_inline] = ACTIONS(2414),
    [anon_sym___inline] = ACTIONS(2414),
    [anon_sym___inline__] = ACTIONS(2414),
    [anon_sym___forceinline] = ACTIONS(2414),
    [anon_sym_thread_local] = ACTIONS(2414),
    [anon_sym___thread] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_constexpr] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym_restrict] = ACTIONS(2414),
    [anon_sym___restrict__] = ACTIONS(2414),
    [anon_sym__Atomic] = ACTIONS(2414),
    [anon_sym__Noreturn] = ACTIONS(2414),
    [anon_sym_noreturn] = ACTIONS(2414),
    [anon_sym__Nonnull] = ACTIONS(2414),
    [anon_sym_mutable] = ACTIONS(2414),
    [anon_sym_constinit] = ACTIONS(2414),
    [anon_sym_consteval] = ACTIONS(2414),
    [anon_sym_alignas] = ACTIONS(2414),
    [anon_sym__Alignas] = ACTIONS(2414),
    [sym_primitive_type] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [anon_sym_or] = ACTIONS(2414),
    [anon_sym_and] = ACTIONS(2414),
    [anon_sym_DASH_GT] = ACTIONS(2412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2414),
    [anon_sym_let] = ACTIONS(2414),
    [anon_sym_This] = ACTIONS(2414),
    [anon_sym_decltype] = ACTIONS(2414),
    [anon_sym_explicit] = ACTIONS(2414),
    [anon_sym_typename] = ACTIONS(2414),
    [anon_sym_private] = ACTIONS(2414),
    [anon_sym_template] = ACTIONS(2414),
    [anon_sym_operator] = ACTIONS(2414),
    [anon_sym_friend] = ACTIONS(2414),
    [anon_sym_public] = ACTIONS(2414),
    [anon_sym_protected] = ACTIONS(2414),
    [anon_sym_noexcept] = ACTIONS(2414),
    [anon_sym_throw] = ACTIONS(2414),
    [anon_sym_static_assert] = ACTIONS(2414),
    [anon_sym_catch] = ACTIONS(2414),
    [anon_sym_precise] = ACTIONS(2414),
    [anon_sym_shared] = ACTIONS(2414),
    [anon_sym_groupshared] = ACTIONS(2414),
    [anon_sym_uniform] = ACTIONS(2414),
    [anon_sym_row_major] = ACTIONS(2414),
    [anon_sym_column_major] = ACTIONS(2414),
    [anon_sym_globallycoherent] = ACTIONS(2414),
    [anon_sym_centroid] = ACTIONS(2414),
    [anon_sym_noperspective] = ACTIONS(2414),
    [anon_sym_nointerpolation] = ACTIONS(2414),
    [anon_sym_sample] = ACTIONS(2414),
    [anon_sym_linear] = ACTIONS(2414),
    [anon_sym_snorm] = ACTIONS(2414),
    [anon_sym_unorm] = ACTIONS(2414),
    [anon_sym_point] = ACTIONS(2414),
    [anon_sym_line] = ACTIONS(2414),
    [anon_sym_triangleadj] = ACTIONS(2414),
    [anon_sym_lineadj] = ACTIONS(2414),
    [anon_sym_triangle] = ACTIONS(2414),
    [anon_sym_interface] = ACTIONS(2414),
    [anon_sym_extension] = ACTIONS(2414),
    [anon_sym___init] = ACTIONS(2414),
    [anon_sym___subscript] = ACTIONS(2414),
    [anon_sym_property] = ACTIONS(2414),
    [anon_sym_associatedtype] = ACTIONS(2414),
  },
  [1629] = {
    [sym_expression] = STATE(5890),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_lambda_default_capture] = STATE(10432),
    [sym__lambda_capture_identifier] = STATE(9692),
    [sym_lambda_capture_initializer] = STATE(9692),
    [sym__lambda_capture] = STATE(9692),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_identifier_parameter_pack_expansion] = STATE(9692),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4703),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(6083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6071),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(6073),
    [anon_sym_AMP] = ACTIONS(6075),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6077),
    [anon_sym_EQ] = ACTIONS(6079),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(6081),
  },
  [1630] = {
    [sym_expression] = STATE(5885),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_lambda_default_capture] = STATE(10432),
    [sym__lambda_capture_identifier] = STATE(9692),
    [sym_lambda_capture_initializer] = STATE(9692),
    [sym__lambda_capture] = STATE(9692),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_identifier_parameter_pack_expansion] = STATE(9692),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4703),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(6083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6071),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(6073),
    [anon_sym_AMP] = ACTIONS(6075),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6077),
    [anon_sym_EQ] = ACTIONS(6079),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(6081),
  },
  [1631] = {
    [sym__declaration_modifiers] = STATE(2667),
    [sym__declaration_specifiers] = STATE(4965),
    [sym_attribute_specifier] = STATE(2667),
    [sym_attribute_declaration] = STATE(2667),
    [sym_ms_declspec_modifier] = STATE(2667),
    [sym_storage_class_specifier] = STATE(2667),
    [sym_type_qualifier] = STATE(2667),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2793),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_parameter_declaration] = STATE(10210),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_type_parameter_declaration] = STATE(10210),
    [sym_variadic_type_parameter_declaration] = STATE(10210),
    [sym_optional_type_parameter_declaration] = STATE(10210),
    [sym_template_template_parameter_declaration] = STATE(10210),
    [sym_optional_parameter_declaration] = STATE(10210),
    [sym_variadic_parameter_declaration] = STATE(10210),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8769),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2667),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2667),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5515),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(2348),
    [anon_sym_out] = ACTIONS(2348),
    [anon_sym_inout] = ACTIONS(2348),
    [anon_sym_virtual] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5525),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(6085),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(6087),
    [anon_sym_template] = ACTIONS(6089),
    [anon_sym_GT2] = ACTIONS(6091),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_extension] = ACTIONS(2398),
  },
  [1632] = {
    [sym_expression] = STATE(5885),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_lambda_default_capture] = STATE(10432),
    [sym__lambda_capture_identifier] = STATE(9692),
    [sym_lambda_capture_initializer] = STATE(9692),
    [sym__lambda_capture] = STATE(9692),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_identifier_parameter_pack_expansion] = STATE(9692),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4703),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(6069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6071),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(6073),
    [anon_sym_AMP] = ACTIONS(6075),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6077),
    [anon_sym_EQ] = ACTIONS(6079),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(6081),
  },
  [1633] = {
    [sym_expression] = STATE(5668),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10724),
    [sym_initializer_pair] = STATE(10724),
    [sym_subscript_designator] = STATE(8931),
    [sym_subscript_range_designator] = STATE(8931),
    [sym_field_designator] = STATE(8931),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [aux_sym_initializer_pair_repeat1] = STATE(8931),
    [sym_identifier] = ACTIONS(5877),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(5883),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(245),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1634] = {
    [sym_identifier] = ACTIONS(2404),
    [aux_sym_preproc_def_token1] = ACTIONS(2404),
    [aux_sym_preproc_if_token1] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2404),
    [sym_preproc_directive] = ACTIONS(2404),
    [anon_sym_LPAREN2] = ACTIONS(2402),
    [anon_sym_TILDE] = ACTIONS(2402),
    [anon_sym_STAR] = ACTIONS(2402),
    [anon_sym_PIPE_PIPE] = ACTIONS(2402),
    [anon_sym_AMP_AMP] = ACTIONS(2402),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2402),
    [anon_sym___extension__] = ACTIONS(2404),
    [anon_sym_typedef] = ACTIONS(2404),
    [anon_sym_in] = ACTIONS(2404),
    [anon_sym_out] = ACTIONS(2404),
    [anon_sym_inout] = ACTIONS(2404),
    [anon_sym_virtual] = ACTIONS(2404),
    [anon_sym_extern] = ACTIONS(2404),
    [anon_sym___attribute__] = ACTIONS(2404),
    [anon_sym___attribute] = ACTIONS(2404),
    [anon_sym_using] = ACTIONS(2404),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2402),
    [anon_sym___declspec] = ACTIONS(2404),
    [anon_sym___based] = ACTIONS(2404),
    [anon_sym_LBRACE] = ACTIONS(2402),
    [anon_sym_RBRACE] = ACTIONS(2402),
    [anon_sym_signed] = ACTIONS(2404),
    [anon_sym_unsigned] = ACTIONS(2404),
    [anon_sym_long] = ACTIONS(2404),
    [anon_sym_short] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_register] = ACTIONS(2404),
    [anon_sym_inline] = ACTIONS(2404),
    [anon_sym___inline] = ACTIONS(2404),
    [anon_sym___inline__] = ACTIONS(2404),
    [anon_sym___forceinline] = ACTIONS(2404),
    [anon_sym_thread_local] = ACTIONS(2404),
    [anon_sym___thread] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [anon_sym_constexpr] = ACTIONS(2404),
    [anon_sym_volatile] = ACTIONS(2404),
    [anon_sym_restrict] = ACTIONS(2404),
    [anon_sym___restrict__] = ACTIONS(2404),
    [anon_sym__Atomic] = ACTIONS(2404),
    [anon_sym__Noreturn] = ACTIONS(2404),
    [anon_sym_noreturn] = ACTIONS(2404),
    [anon_sym__Nonnull] = ACTIONS(2404),
    [anon_sym_mutable] = ACTIONS(2404),
    [anon_sym_constinit] = ACTIONS(2404),
    [anon_sym_consteval] = ACTIONS(2404),
    [anon_sym_alignas] = ACTIONS(2404),
    [anon_sym__Alignas] = ACTIONS(2404),
    [sym_primitive_type] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
    [anon_sym_class] = ACTIONS(2404),
    [anon_sym_struct] = ACTIONS(2404),
    [anon_sym_union] = ACTIONS(2404),
    [anon_sym_or] = ACTIONS(2404),
    [anon_sym_and] = ACTIONS(2404),
    [anon_sym_DASH_GT] = ACTIONS(2402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2404),
    [anon_sym_let] = ACTIONS(2404),
    [anon_sym_This] = ACTIONS(2404),
    [anon_sym_decltype] = ACTIONS(2404),
    [anon_sym_explicit] = ACTIONS(2404),
    [anon_sym_typename] = ACTIONS(2404),
    [anon_sym_private] = ACTIONS(2404),
    [anon_sym_template] = ACTIONS(2404),
    [anon_sym_operator] = ACTIONS(2404),
    [anon_sym_friend] = ACTIONS(2404),
    [anon_sym_public] = ACTIONS(2404),
    [anon_sym_protected] = ACTIONS(2404),
    [anon_sym_noexcept] = ACTIONS(2404),
    [anon_sym_throw] = ACTIONS(2404),
    [anon_sym_static_assert] = ACTIONS(2404),
    [anon_sym_catch] = ACTIONS(2404),
    [anon_sym_precise] = ACTIONS(2404),
    [anon_sym_shared] = ACTIONS(2404),
    [anon_sym_groupshared] = ACTIONS(2404),
    [anon_sym_uniform] = ACTIONS(2404),
    [anon_sym_row_major] = ACTIONS(2404),
    [anon_sym_column_major] = ACTIONS(2404),
    [anon_sym_globallycoherent] = ACTIONS(2404),
    [anon_sym_centroid] = ACTIONS(2404),
    [anon_sym_noperspective] = ACTIONS(2404),
    [anon_sym_nointerpolation] = ACTIONS(2404),
    [anon_sym_sample] = ACTIONS(2404),
    [anon_sym_linear] = ACTIONS(2404),
    [anon_sym_snorm] = ACTIONS(2404),
    [anon_sym_unorm] = ACTIONS(2404),
    [anon_sym_point] = ACTIONS(2404),
    [anon_sym_line] = ACTIONS(2404),
    [anon_sym_triangleadj] = ACTIONS(2404),
    [anon_sym_lineadj] = ACTIONS(2404),
    [anon_sym_triangle] = ACTIONS(2404),
    [anon_sym_interface] = ACTIONS(2404),
    [anon_sym_extension] = ACTIONS(2404),
    [anon_sym___init] = ACTIONS(2404),
    [anon_sym___subscript] = ACTIONS(2404),
    [anon_sym_property] = ACTIONS(2404),
    [anon_sym_associatedtype] = ACTIONS(2404),
  },
  [1635] = {
    [sym__declaration_modifiers] = STATE(2667),
    [sym__declaration_specifiers] = STATE(4965),
    [sym_attribute_specifier] = STATE(2667),
    [sym_attribute_declaration] = STATE(2667),
    [sym_ms_declspec_modifier] = STATE(2667),
    [sym_storage_class_specifier] = STATE(2667),
    [sym_type_qualifier] = STATE(2667),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2793),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_parameter_declaration] = STATE(10718),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_type_parameter_declaration] = STATE(10718),
    [sym_variadic_type_parameter_declaration] = STATE(10718),
    [sym_optional_type_parameter_declaration] = STATE(10718),
    [sym_template_template_parameter_declaration] = STATE(10718),
    [sym_optional_parameter_declaration] = STATE(10718),
    [sym_variadic_parameter_declaration] = STATE(10718),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8769),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2667),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2667),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5515),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(2348),
    [anon_sym_out] = ACTIONS(2348),
    [anon_sym_inout] = ACTIONS(2348),
    [anon_sym_virtual] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5525),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(6085),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(6087),
    [anon_sym_template] = ACTIONS(6089),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_extension] = ACTIONS(2398),
  },
  [1636] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6282),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2198),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1637] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6312),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2597),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1638] = {
    [sym_catch_clause] = STATE(1641),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1641),
    [sym_identifier] = ACTIONS(2968),
    [aux_sym_preproc_def_token1] = ACTIONS(2968),
    [aux_sym_preproc_if_token1] = ACTIONS(2968),
    [aux_sym_preproc_if_token2] = ACTIONS(2968),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2968),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2968),
    [aux_sym_preproc_else_token1] = ACTIONS(2968),
    [aux_sym_preproc_elif_token1] = ACTIONS(2968),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2968),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2968),
    [sym_preproc_directive] = ACTIONS(2968),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2970),
    [anon_sym_STAR] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_AMP] = ACTIONS(2968),
    [anon_sym_SEMI] = ACTIONS(2970),
    [anon_sym___extension__] = ACTIONS(2968),
    [anon_sym_typedef] = ACTIONS(2968),
    [anon_sym_in] = ACTIONS(2968),
    [anon_sym_out] = ACTIONS(2968),
    [anon_sym_inout] = ACTIONS(2968),
    [anon_sym_virtual] = ACTIONS(2968),
    [anon_sym_extern] = ACTIONS(2968),
    [anon_sym___attribute__] = ACTIONS(2968),
    [anon_sym___attribute] = ACTIONS(2968),
    [anon_sym_using] = ACTIONS(2968),
    [anon_sym_COLON_COLON] = ACTIONS(2970),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2970),
    [anon_sym___declspec] = ACTIONS(2968),
    [anon_sym___based] = ACTIONS(2968),
    [anon_sym_signed] = ACTIONS(2968),
    [anon_sym_unsigned] = ACTIONS(2968),
    [anon_sym_long] = ACTIONS(2968),
    [anon_sym_short] = ACTIONS(2968),
    [anon_sym_LBRACK] = ACTIONS(2968),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_register] = ACTIONS(2968),
    [anon_sym_inline] = ACTIONS(2968),
    [anon_sym___inline] = ACTIONS(2968),
    [anon_sym___inline__] = ACTIONS(2968),
    [anon_sym___forceinline] = ACTIONS(2968),
    [anon_sym_thread_local] = ACTIONS(2968),
    [anon_sym___thread] = ACTIONS(2968),
    [anon_sym_const] = ACTIONS(2968),
    [anon_sym_constexpr] = ACTIONS(2968),
    [anon_sym_volatile] = ACTIONS(2968),
    [anon_sym_restrict] = ACTIONS(2968),
    [anon_sym___restrict__] = ACTIONS(2968),
    [anon_sym__Atomic] = ACTIONS(2968),
    [anon_sym__Noreturn] = ACTIONS(2968),
    [anon_sym_noreturn] = ACTIONS(2968),
    [anon_sym__Nonnull] = ACTIONS(2968),
    [anon_sym_mutable] = ACTIONS(2968),
    [anon_sym_constinit] = ACTIONS(2968),
    [anon_sym_consteval] = ACTIONS(2968),
    [anon_sym_alignas] = ACTIONS(2968),
    [anon_sym__Alignas] = ACTIONS(2968),
    [sym_primitive_type] = ACTIONS(2968),
    [anon_sym_enum] = ACTIONS(2968),
    [anon_sym_class] = ACTIONS(2968),
    [anon_sym_struct] = ACTIONS(2968),
    [anon_sym_union] = ACTIONS(2968),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2968),
    [anon_sym_let] = ACTIONS(2968),
    [anon_sym_This] = ACTIONS(2968),
    [anon_sym_decltype] = ACTIONS(2968),
    [anon_sym_explicit] = ACTIONS(2968),
    [anon_sym_typename] = ACTIONS(2968),
    [anon_sym_private] = ACTIONS(2968),
    [anon_sym_template] = ACTIONS(2968),
    [anon_sym_operator] = ACTIONS(2968),
    [anon_sym_friend] = ACTIONS(2968),
    [anon_sym_public] = ACTIONS(2968),
    [anon_sym_protected] = ACTIONS(2968),
    [anon_sym_static_assert] = ACTIONS(2968),
    [anon_sym_catch] = ACTIONS(6093),
    [anon_sym_precise] = ACTIONS(2968),
    [anon_sym_shared] = ACTIONS(2968),
    [anon_sym_groupshared] = ACTIONS(2968),
    [anon_sym_uniform] = ACTIONS(2968),
    [anon_sym_row_major] = ACTIONS(2968),
    [anon_sym_column_major] = ACTIONS(2968),
    [anon_sym_globallycoherent] = ACTIONS(2968),
    [anon_sym_centroid] = ACTIONS(2968),
    [anon_sym_noperspective] = ACTIONS(2968),
    [anon_sym_nointerpolation] = ACTIONS(2968),
    [anon_sym_sample] = ACTIONS(2968),
    [anon_sym_linear] = ACTIONS(2968),
    [anon_sym_snorm] = ACTIONS(2968),
    [anon_sym_unorm] = ACTIONS(2968),
    [anon_sym_point] = ACTIONS(2968),
    [anon_sym_line] = ACTIONS(2968),
    [anon_sym_triangleadj] = ACTIONS(2968),
    [anon_sym_lineadj] = ACTIONS(2968),
    [anon_sym_triangle] = ACTIONS(2968),
    [anon_sym_interface] = ACTIONS(2968),
    [anon_sym_extension] = ACTIONS(2968),
    [anon_sym___init] = ACTIONS(2968),
    [anon_sym___subscript] = ACTIONS(2968),
    [anon_sym_property] = ACTIONS(2968),
    [anon_sym_associatedtype] = ACTIONS(2968),
  },
  [1639] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6341),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2612),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1640] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6245),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2615),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1641] = {
    [sym_catch_clause] = STATE(1641),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1641),
    [sym_identifier] = ACTIONS(2901),
    [aux_sym_preproc_def_token1] = ACTIONS(2901),
    [aux_sym_preproc_if_token1] = ACTIONS(2901),
    [aux_sym_preproc_if_token2] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2901),
    [aux_sym_preproc_else_token1] = ACTIONS(2901),
    [aux_sym_preproc_elif_token1] = ACTIONS(2901),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2901),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2901),
    [sym_preproc_directive] = ACTIONS(2901),
    [anon_sym_LPAREN2] = ACTIONS(2903),
    [anon_sym_TILDE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(2903),
    [anon_sym_AMP_AMP] = ACTIONS(2903),
    [anon_sym_AMP] = ACTIONS(2901),
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym___extension__] = ACTIONS(2901),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_in] = ACTIONS(2901),
    [anon_sym_out] = ACTIONS(2901),
    [anon_sym_inout] = ACTIONS(2901),
    [anon_sym_virtual] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(2901),
    [anon_sym___attribute__] = ACTIONS(2901),
    [anon_sym___attribute] = ACTIONS(2901),
    [anon_sym_using] = ACTIONS(2901),
    [anon_sym_COLON_COLON] = ACTIONS(2903),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2903),
    [anon_sym___declspec] = ACTIONS(2901),
    [anon_sym___based] = ACTIONS(2901),
    [anon_sym_signed] = ACTIONS(2901),
    [anon_sym_unsigned] = ACTIONS(2901),
    [anon_sym_long] = ACTIONS(2901),
    [anon_sym_short] = ACTIONS(2901),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_static] = ACTIONS(2901),
    [anon_sym_register] = ACTIONS(2901),
    [anon_sym_inline] = ACTIONS(2901),
    [anon_sym___inline] = ACTIONS(2901),
    [anon_sym___inline__] = ACTIONS(2901),
    [anon_sym___forceinline] = ACTIONS(2901),
    [anon_sym_thread_local] = ACTIONS(2901),
    [anon_sym___thread] = ACTIONS(2901),
    [anon_sym_const] = ACTIONS(2901),
    [anon_sym_constexpr] = ACTIONS(2901),
    [anon_sym_volatile] = ACTIONS(2901),
    [anon_sym_restrict] = ACTIONS(2901),
    [anon_sym___restrict__] = ACTIONS(2901),
    [anon_sym__Atomic] = ACTIONS(2901),
    [anon_sym__Noreturn] = ACTIONS(2901),
    [anon_sym_noreturn] = ACTIONS(2901),
    [anon_sym__Nonnull] = ACTIONS(2901),
    [anon_sym_mutable] = ACTIONS(2901),
    [anon_sym_constinit] = ACTIONS(2901),
    [anon_sym_consteval] = ACTIONS(2901),
    [anon_sym_alignas] = ACTIONS(2901),
    [anon_sym__Alignas] = ACTIONS(2901),
    [sym_primitive_type] = ACTIONS(2901),
    [anon_sym_enum] = ACTIONS(2901),
    [anon_sym_class] = ACTIONS(2901),
    [anon_sym_struct] = ACTIONS(2901),
    [anon_sym_union] = ACTIONS(2901),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2901),
    [anon_sym_let] = ACTIONS(2901),
    [anon_sym_This] = ACTIONS(2901),
    [anon_sym_decltype] = ACTIONS(2901),
    [anon_sym_explicit] = ACTIONS(2901),
    [anon_sym_typename] = ACTIONS(2901),
    [anon_sym_private] = ACTIONS(2901),
    [anon_sym_template] = ACTIONS(2901),
    [anon_sym_operator] = ACTIONS(2901),
    [anon_sym_friend] = ACTIONS(2901),
    [anon_sym_public] = ACTIONS(2901),
    [anon_sym_protected] = ACTIONS(2901),
    [anon_sym_static_assert] = ACTIONS(2901),
    [anon_sym_catch] = ACTIONS(6095),
    [anon_sym_precise] = ACTIONS(2901),
    [anon_sym_shared] = ACTIONS(2901),
    [anon_sym_groupshared] = ACTIONS(2901),
    [anon_sym_uniform] = ACTIONS(2901),
    [anon_sym_row_major] = ACTIONS(2901),
    [anon_sym_column_major] = ACTIONS(2901),
    [anon_sym_globallycoherent] = ACTIONS(2901),
    [anon_sym_centroid] = ACTIONS(2901),
    [anon_sym_noperspective] = ACTIONS(2901),
    [anon_sym_nointerpolation] = ACTIONS(2901),
    [anon_sym_sample] = ACTIONS(2901),
    [anon_sym_linear] = ACTIONS(2901),
    [anon_sym_snorm] = ACTIONS(2901),
    [anon_sym_unorm] = ACTIONS(2901),
    [anon_sym_point] = ACTIONS(2901),
    [anon_sym_line] = ACTIONS(2901),
    [anon_sym_triangleadj] = ACTIONS(2901),
    [anon_sym_lineadj] = ACTIONS(2901),
    [anon_sym_triangle] = ACTIONS(2901),
    [anon_sym_interface] = ACTIONS(2901),
    [anon_sym_extension] = ACTIONS(2901),
    [anon_sym___init] = ACTIONS(2901),
    [anon_sym___subscript] = ACTIONS(2901),
    [anon_sym_property] = ACTIONS(2901),
    [anon_sym_associatedtype] = ACTIONS(2901),
  },
  [1642] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6288),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2606),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1643] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6322),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2609),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1644] = {
    [sym_catch_clause] = STATE(1641),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1641),
    [sym_identifier] = ACTIONS(2920),
    [aux_sym_preproc_def_token1] = ACTIONS(2920),
    [aux_sym_preproc_if_token1] = ACTIONS(2920),
    [aux_sym_preproc_if_token2] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2920),
    [aux_sym_preproc_else_token1] = ACTIONS(2920),
    [aux_sym_preproc_elif_token1] = ACTIONS(2920),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2920),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2920),
    [sym_preproc_directive] = ACTIONS(2920),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2920),
    [anon_sym_SEMI] = ACTIONS(2922),
    [anon_sym___extension__] = ACTIONS(2920),
    [anon_sym_typedef] = ACTIONS(2920),
    [anon_sym_in] = ACTIONS(2920),
    [anon_sym_out] = ACTIONS(2920),
    [anon_sym_inout] = ACTIONS(2920),
    [anon_sym_virtual] = ACTIONS(2920),
    [anon_sym_extern] = ACTIONS(2920),
    [anon_sym___attribute__] = ACTIONS(2920),
    [anon_sym___attribute] = ACTIONS(2920),
    [anon_sym_using] = ACTIONS(2920),
    [anon_sym_COLON_COLON] = ACTIONS(2922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2922),
    [anon_sym___declspec] = ACTIONS(2920),
    [anon_sym___based] = ACTIONS(2920),
    [anon_sym_signed] = ACTIONS(2920),
    [anon_sym_unsigned] = ACTIONS(2920),
    [anon_sym_long] = ACTIONS(2920),
    [anon_sym_short] = ACTIONS(2920),
    [anon_sym_LBRACK] = ACTIONS(2920),
    [anon_sym_static] = ACTIONS(2920),
    [anon_sym_register] = ACTIONS(2920),
    [anon_sym_inline] = ACTIONS(2920),
    [anon_sym___inline] = ACTIONS(2920),
    [anon_sym___inline__] = ACTIONS(2920),
    [anon_sym___forceinline] = ACTIONS(2920),
    [anon_sym_thread_local] = ACTIONS(2920),
    [anon_sym___thread] = ACTIONS(2920),
    [anon_sym_const] = ACTIONS(2920),
    [anon_sym_constexpr] = ACTIONS(2920),
    [anon_sym_volatile] = ACTIONS(2920),
    [anon_sym_restrict] = ACTIONS(2920),
    [anon_sym___restrict__] = ACTIONS(2920),
    [anon_sym__Atomic] = ACTIONS(2920),
    [anon_sym__Noreturn] = ACTIONS(2920),
    [anon_sym_noreturn] = ACTIONS(2920),
    [anon_sym__Nonnull] = ACTIONS(2920),
    [anon_sym_mutable] = ACTIONS(2920),
    [anon_sym_constinit] = ACTIONS(2920),
    [anon_sym_consteval] = ACTIONS(2920),
    [anon_sym_alignas] = ACTIONS(2920),
    [anon_sym__Alignas] = ACTIONS(2920),
    [sym_primitive_type] = ACTIONS(2920),
    [anon_sym_enum] = ACTIONS(2920),
    [anon_sym_class] = ACTIONS(2920),
    [anon_sym_struct] = ACTIONS(2920),
    [anon_sym_union] = ACTIONS(2920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2920),
    [anon_sym_let] = ACTIONS(2920),
    [anon_sym_This] = ACTIONS(2920),
    [anon_sym_decltype] = ACTIONS(2920),
    [anon_sym_explicit] = ACTIONS(2920),
    [anon_sym_typename] = ACTIONS(2920),
    [anon_sym_private] = ACTIONS(2920),
    [anon_sym_template] = ACTIONS(2920),
    [anon_sym_operator] = ACTIONS(2920),
    [anon_sym_friend] = ACTIONS(2920),
    [anon_sym_public] = ACTIONS(2920),
    [anon_sym_protected] = ACTIONS(2920),
    [anon_sym_static_assert] = ACTIONS(2920),
    [anon_sym_catch] = ACTIONS(6093),
    [anon_sym_precise] = ACTIONS(2920),
    [anon_sym_shared] = ACTIONS(2920),
    [anon_sym_groupshared] = ACTIONS(2920),
    [anon_sym_uniform] = ACTIONS(2920),
    [anon_sym_row_major] = ACTIONS(2920),
    [anon_sym_column_major] = ACTIONS(2920),
    [anon_sym_globallycoherent] = ACTIONS(2920),
    [anon_sym_centroid] = ACTIONS(2920),
    [anon_sym_noperspective] = ACTIONS(2920),
    [anon_sym_nointerpolation] = ACTIONS(2920),
    [anon_sym_sample] = ACTIONS(2920),
    [anon_sym_linear] = ACTIONS(2920),
    [anon_sym_snorm] = ACTIONS(2920),
    [anon_sym_unorm] = ACTIONS(2920),
    [anon_sym_point] = ACTIONS(2920),
    [anon_sym_line] = ACTIONS(2920),
    [anon_sym_triangleadj] = ACTIONS(2920),
    [anon_sym_lineadj] = ACTIONS(2920),
    [anon_sym_triangle] = ACTIONS(2920),
    [anon_sym_interface] = ACTIONS(2920),
    [anon_sym_extension] = ACTIONS(2920),
    [anon_sym___init] = ACTIONS(2920),
    [anon_sym___subscript] = ACTIONS(2920),
    [anon_sym_property] = ACTIONS(2920),
    [anon_sym_associatedtype] = ACTIONS(2920),
  },
  [1645] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6356),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_ms_call_modifier] = STATE(2603),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [1646] = {
    [sym_catch_clause] = STATE(1641),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1641),
    [sym_identifier] = ACTIONS(2885),
    [aux_sym_preproc_def_token1] = ACTIONS(2885),
    [aux_sym_preproc_if_token1] = ACTIONS(2885),
    [aux_sym_preproc_if_token2] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2885),
    [aux_sym_preproc_else_token1] = ACTIONS(2885),
    [aux_sym_preproc_elif_token1] = ACTIONS(2885),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2885),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2885),
    [sym_preproc_directive] = ACTIONS(2885),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2887),
    [anon_sym_STAR] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym___extension__] = ACTIONS(2885),
    [anon_sym_typedef] = ACTIONS(2885),
    [anon_sym_in] = ACTIONS(2885),
    [anon_sym_out] = ACTIONS(2885),
    [anon_sym_inout] = ACTIONS(2885),
    [anon_sym_virtual] = ACTIONS(2885),
    [anon_sym_extern] = ACTIONS(2885),
    [anon_sym___attribute__] = ACTIONS(2885),
    [anon_sym___attribute] = ACTIONS(2885),
    [anon_sym_using] = ACTIONS(2885),
    [anon_sym_COLON_COLON] = ACTIONS(2887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2887),
    [anon_sym___declspec] = ACTIONS(2885),
    [anon_sym___based] = ACTIONS(2885),
    [anon_sym_signed] = ACTIONS(2885),
    [anon_sym_unsigned] = ACTIONS(2885),
    [anon_sym_long] = ACTIONS(2885),
    [anon_sym_short] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_static] = ACTIONS(2885),
    [anon_sym_register] = ACTIONS(2885),
    [anon_sym_inline] = ACTIONS(2885),
    [anon_sym___inline] = ACTIONS(2885),
    [anon_sym___inline__] = ACTIONS(2885),
    [anon_sym___forceinline] = ACTIONS(2885),
    [anon_sym_thread_local] = ACTIONS(2885),
    [anon_sym___thread] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_constexpr] = ACTIONS(2885),
    [anon_sym_volatile] = ACTIONS(2885),
    [anon_sym_restrict] = ACTIONS(2885),
    [anon_sym___restrict__] = ACTIONS(2885),
    [anon_sym__Atomic] = ACTIONS(2885),
    [anon_sym__Noreturn] = ACTIONS(2885),
    [anon_sym_noreturn] = ACTIONS(2885),
    [anon_sym__Nonnull] = ACTIONS(2885),
    [anon_sym_mutable] = ACTIONS(2885),
    [anon_sym_constinit] = ACTIONS(2885),
    [anon_sym_consteval] = ACTIONS(2885),
    [anon_sym_alignas] = ACTIONS(2885),
    [anon_sym__Alignas] = ACTIONS(2885),
    [sym_primitive_type] = ACTIONS(2885),
    [anon_sym_enum] = ACTIONS(2885),
    [anon_sym_class] = ACTIONS(2885),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_union] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2885),
    [anon_sym_let] = ACTIONS(2885),
    [anon_sym_This] = ACTIONS(2885),
    [anon_sym_decltype] = ACTIONS(2885),
    [anon_sym_explicit] = ACTIONS(2885),
    [anon_sym_typename] = ACTIONS(2885),
    [anon_sym_private] = ACTIONS(2885),
    [anon_sym_template] = ACTIONS(2885),
    [anon_sym_operator] = ACTIONS(2885),
    [anon_sym_friend] = ACTIONS(2885),
    [anon_sym_public] = ACTIONS(2885),
    [anon_sym_protected] = ACTIONS(2885),
    [anon_sym_static_assert] = ACTIONS(2885),
    [anon_sym_catch] = ACTIONS(6093),
    [anon_sym_precise] = ACTIONS(2885),
    [anon_sym_shared] = ACTIONS(2885),
    [anon_sym_groupshared] = ACTIONS(2885),
    [anon_sym_uniform] = ACTIONS(2885),
    [anon_sym_row_major] = ACTIONS(2885),
    [anon_sym_column_major] = ACTIONS(2885),
    [anon_sym_globallycoherent] = ACTIONS(2885),
    [anon_sym_centroid] = ACTIONS(2885),
    [anon_sym_noperspective] = ACTIONS(2885),
    [anon_sym_nointerpolation] = ACTIONS(2885),
    [anon_sym_sample] = ACTIONS(2885),
    [anon_sym_linear] = ACTIONS(2885),
    [anon_sym_snorm] = ACTIONS(2885),
    [anon_sym_unorm] = ACTIONS(2885),
    [anon_sym_point] = ACTIONS(2885),
    [anon_sym_line] = ACTIONS(2885),
    [anon_sym_triangleadj] = ACTIONS(2885),
    [anon_sym_lineadj] = ACTIONS(2885),
    [anon_sym_triangle] = ACTIONS(2885),
    [anon_sym_interface] = ACTIONS(2885),
    [anon_sym_extension] = ACTIONS(2885),
    [anon_sym___init] = ACTIONS(2885),
    [anon_sym___subscript] = ACTIONS(2885),
    [anon_sym_property] = ACTIONS(2885),
    [anon_sym_associatedtype] = ACTIONS(2885),
  },
  [1647] = {
    [sym__declaration_modifiers] = STATE(2667),
    [sym__declaration_specifiers] = STATE(4972),
    [sym_attribute_specifier] = STATE(2667),
    [sym_attribute_declaration] = STATE(2667),
    [sym_ms_declspec_modifier] = STATE(2667),
    [sym_storage_class_specifier] = STATE(2667),
    [sym_type_qualifier] = STATE(2667),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2793),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_parameter_declaration] = STATE(10179),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_optional_parameter_declaration] = STATE(10179),
    [sym_variadic_parameter_declaration] = STATE(10179),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8769),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2667),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2667),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6098),
    [anon_sym_RPAREN] = ACTIONS(6100),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(2348),
    [anon_sym_out] = ACTIONS(2348),
    [anon_sym_inout] = ACTIONS(2348),
    [anon_sym_virtual] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5525),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_extension] = ACTIONS(2398),
  },
  [1648] = {
    [sym__declaration_modifiers] = STATE(2667),
    [sym__declaration_specifiers] = STATE(4972),
    [sym_attribute_specifier] = STATE(2667),
    [sym_attribute_declaration] = STATE(2667),
    [sym_ms_declspec_modifier] = STATE(2667),
    [sym_storage_class_specifier] = STATE(2667),
    [sym_type_qualifier] = STATE(2667),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2793),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_parameter_declaration] = STATE(9655),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_optional_parameter_declaration] = STATE(9655),
    [sym_variadic_parameter_declaration] = STATE(9655),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8769),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2667),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2667),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6102),
    [anon_sym_RPAREN] = ACTIONS(6104),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(2348),
    [anon_sym_out] = ACTIONS(2348),
    [anon_sym_inout] = ACTIONS(2348),
    [anon_sym_virtual] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5525),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_extension] = ACTIONS(2398),
  },
  [1649] = {
    [sym_identifier] = ACTIONS(3148),
    [aux_sym_preproc_def_token1] = ACTIONS(3148),
    [aux_sym_preproc_if_token1] = ACTIONS(3148),
    [aux_sym_preproc_if_token2] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3148),
    [aux_sym_preproc_else_token1] = ACTIONS(3148),
    [aux_sym_preproc_elif_token1] = ACTIONS(3148),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3148),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3148),
    [sym_preproc_directive] = ACTIONS(3148),
    [anon_sym_LPAREN2] = ACTIONS(3150),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_STAR] = ACTIONS(3150),
    [anon_sym_AMP_AMP] = ACTIONS(3150),
    [anon_sym_AMP] = ACTIONS(3148),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym___extension__] = ACTIONS(3148),
    [anon_sym_typedef] = ACTIONS(3148),
    [anon_sym_in] = ACTIONS(3148),
    [anon_sym_out] = ACTIONS(3148),
    [anon_sym_inout] = ACTIONS(3148),
    [anon_sym_virtual] = ACTIONS(3148),
    [anon_sym_extern] = ACTIONS(3148),
    [anon_sym___attribute__] = ACTIONS(3148),
    [anon_sym___attribute] = ACTIONS(3148),
    [anon_sym_using] = ACTIONS(3148),
    [anon_sym_COLON_COLON] = ACTIONS(3150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3150),
    [anon_sym___declspec] = ACTIONS(3148),
    [anon_sym___based] = ACTIONS(3148),
    [anon_sym_signed] = ACTIONS(3148),
    [anon_sym_unsigned] = ACTIONS(3148),
    [anon_sym_long] = ACTIONS(3148),
    [anon_sym_short] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_static] = ACTIONS(3148),
    [anon_sym_register] = ACTIONS(3148),
    [anon_sym_inline] = ACTIONS(3148),
    [anon_sym___inline] = ACTIONS(3148),
    [anon_sym___inline__] = ACTIONS(3148),
    [anon_sym___forceinline] = ACTIONS(3148),
    [anon_sym_thread_local] = ACTIONS(3148),
    [anon_sym___thread] = ACTIONS(3148),
    [anon_sym_const] = ACTIONS(3148),
    [anon_sym_constexpr] = ACTIONS(3148),
    [anon_sym_volatile] = ACTIONS(3148),
    [anon_sym_restrict] = ACTIONS(3148),
    [anon_sym___restrict__] = ACTIONS(3148),
    [anon_sym__Atomic] = ACTIONS(3148),
    [anon_sym__Noreturn] = ACTIONS(3148),
    [anon_sym_noreturn] = ACTIONS(3148),
    [anon_sym__Nonnull] = ACTIONS(3148),
    [anon_sym_mutable] = ACTIONS(3148),
    [anon_sym_constinit] = ACTIONS(3148),
    [anon_sym_consteval] = ACTIONS(3148),
    [anon_sym_alignas] = ACTIONS(3148),
    [anon_sym__Alignas] = ACTIONS(3148),
    [sym_primitive_type] = ACTIONS(3148),
    [anon_sym_enum] = ACTIONS(3148),
    [anon_sym_class] = ACTIONS(3148),
    [anon_sym_struct] = ACTIONS(3148),
    [anon_sym_union] = ACTIONS(3148),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3148),
    [anon_sym_let] = ACTIONS(3148),
    [anon_sym_This] = ACTIONS(3148),
    [anon_sym_decltype] = ACTIONS(3148),
    [anon_sym_explicit] = ACTIONS(3148),
    [anon_sym_typename] = ACTIONS(3148),
    [anon_sym_private] = ACTIONS(3148),
    [anon_sym_template] = ACTIONS(3148),
    [anon_sym_operator] = ACTIONS(3148),
    [anon_sym_friend] = ACTIONS(3148),
    [anon_sym_public] = ACTIONS(3148),
    [anon_sym_protected] = ACTIONS(3148),
    [anon_sym_static_assert] = ACTIONS(3148),
    [anon_sym_catch] = ACTIONS(3148),
    [anon_sym_precise] = ACTIONS(3148),
    [anon_sym_shared] = ACTIONS(3148),
    [anon_sym_groupshared] = ACTIONS(3148),
    [anon_sym_uniform] = ACTIONS(3148),
    [anon_sym_row_major] = ACTIONS(3148),
    [anon_sym_column_major] = ACTIONS(3148),
    [anon_sym_globallycoherent] = ACTIONS(3148),
    [anon_sym_centroid] = ACTIONS(3148),
    [anon_sym_noperspective] = ACTIONS(3148),
    [anon_sym_nointerpolation] = ACTIONS(3148),
    [anon_sym_sample] = ACTIONS(3148),
    [anon_sym_linear] = ACTIONS(3148),
    [anon_sym_snorm] = ACTIONS(3148),
    [anon_sym_unorm] = ACTIONS(3148),
    [anon_sym_point] = ACTIONS(3148),
    [anon_sym_line] = ACTIONS(3148),
    [anon_sym_triangleadj] = ACTIONS(3148),
    [anon_sym_lineadj] = ACTIONS(3148),
    [anon_sym_triangle] = ACTIONS(3148),
    [anon_sym_interface] = ACTIONS(3148),
    [anon_sym_extension] = ACTIONS(3148),
    [anon_sym___init] = ACTIONS(3148),
    [anon_sym___subscript] = ACTIONS(3148),
    [anon_sym_property] = ACTIONS(3148),
    [anon_sym_associatedtype] = ACTIONS(3148),
  },
  [1650] = {
    [sym__declaration_modifiers] = STATE(2667),
    [sym__declaration_specifiers] = STATE(4972),
    [sym_attribute_specifier] = STATE(2667),
    [sym_attribute_declaration] = STATE(2667),
    [sym_ms_declspec_modifier] = STATE(2667),
    [sym_storage_class_specifier] = STATE(2667),
    [sym_type_qualifier] = STATE(2667),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2793),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_parameter_declaration] = STATE(10006),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_optional_parameter_declaration] = STATE(10006),
    [sym_variadic_parameter_declaration] = STATE(10006),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8769),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2667),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2667),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5340),
    [anon_sym_RPAREN] = ACTIONS(5342),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(2348),
    [anon_sym_out] = ACTIONS(2348),
    [anon_sym_inout] = ACTIONS(2348),
    [anon_sym_virtual] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5525),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_extension] = ACTIONS(2398),
  },
  [1651] = {
    [sym_identifier] = ACTIONS(2414),
    [aux_sym_preproc_def_token1] = ACTIONS(2414),
    [aux_sym_preproc_if_token1] = ACTIONS(2414),
    [aux_sym_preproc_if_token2] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2414),
    [aux_sym_preproc_else_token1] = ACTIONS(2414),
    [aux_sym_preproc_elif_token1] = ACTIONS(2414),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2414),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2414),
    [sym_preproc_directive] = ACTIONS(2414),
    [anon_sym_LPAREN2] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym___extension__] = ACTIONS(2414),
    [anon_sym_typedef] = ACTIONS(2414),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_out] = ACTIONS(2414),
    [anon_sym_inout] = ACTIONS(2414),
    [anon_sym_virtual] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym___attribute__] = ACTIONS(2414),
    [anon_sym___attribute] = ACTIONS(2414),
    [anon_sym_using] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2412),
    [anon_sym___declspec] = ACTIONS(2414),
    [anon_sym___based] = ACTIONS(2414),
    [anon_sym_signed] = ACTIONS(2414),
    [anon_sym_unsigned] = ACTIONS(2414),
    [anon_sym_long] = ACTIONS(2414),
    [anon_sym_short] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_register] = ACTIONS(2414),
    [anon_sym_inline] = ACTIONS(2414),
    [anon_sym___inline] = ACTIONS(2414),
    [anon_sym___inline__] = ACTIONS(2414),
    [anon_sym___forceinline] = ACTIONS(2414),
    [anon_sym_thread_local] = ACTIONS(2414),
    [anon_sym___thread] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_constexpr] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym_restrict] = ACTIONS(2414),
    [anon_sym___restrict__] = ACTIONS(2414),
    [anon_sym__Atomic] = ACTIONS(2414),
    [anon_sym__Noreturn] = ACTIONS(2414),
    [anon_sym_noreturn] = ACTIONS(2414),
    [anon_sym__Nonnull] = ACTIONS(2414),
    [anon_sym_mutable] = ACTIONS(2414),
    [anon_sym_constinit] = ACTIONS(2414),
    [anon_sym_consteval] = ACTIONS(2414),
    [anon_sym_alignas] = ACTIONS(2414),
    [anon_sym__Alignas] = ACTIONS(2414),
    [sym_primitive_type] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2414),
    [anon_sym_let] = ACTIONS(2414),
    [anon_sym_This] = ACTIONS(2414),
    [anon_sym_decltype] = ACTIONS(2414),
    [anon_sym_explicit] = ACTIONS(2414),
    [anon_sym_typename] = ACTIONS(2414),
    [anon_sym_private] = ACTIONS(2414),
    [anon_sym_template] = ACTIONS(2414),
    [anon_sym_operator] = ACTIONS(2414),
    [anon_sym_friend] = ACTIONS(2414),
    [anon_sym_public] = ACTIONS(2414),
    [anon_sym_protected] = ACTIONS(2414),
    [anon_sym_static_assert] = ACTIONS(2414),
    [anon_sym_catch] = ACTIONS(2414),
    [anon_sym_precise] = ACTIONS(2414),
    [anon_sym_shared] = ACTIONS(2414),
    [anon_sym_groupshared] = ACTIONS(2414),
    [anon_sym_uniform] = ACTIONS(2414),
    [anon_sym_row_major] = ACTIONS(2414),
    [anon_sym_column_major] = ACTIONS(2414),
    [anon_sym_globallycoherent] = ACTIONS(2414),
    [anon_sym_centroid] = ACTIONS(2414),
    [anon_sym_noperspective] = ACTIONS(2414),
    [anon_sym_nointerpolation] = ACTIONS(2414),
    [anon_sym_sample] = ACTIONS(2414),
    [anon_sym_linear] = ACTIONS(2414),
    [anon_sym_snorm] = ACTIONS(2414),
    [anon_sym_unorm] = ACTIONS(2414),
    [anon_sym_point] = ACTIONS(2414),
    [anon_sym_line] = ACTIONS(2414),
    [anon_sym_triangleadj] = ACTIONS(2414),
    [anon_sym_lineadj] = ACTIONS(2414),
    [anon_sym_triangle] = ACTIONS(2414),
    [anon_sym_interface] = ACTIONS(2414),
    [anon_sym_extension] = ACTIONS(2414),
    [anon_sym___init] = ACTIONS(2414),
    [anon_sym___subscript] = ACTIONS(2414),
    [anon_sym_property] = ACTIONS(2414),
    [anon_sym_associatedtype] = ACTIONS(2414),
  },
  [1652] = {
    [sym_identifier] = ACTIONS(2243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2245),
    [anon_sym_COMMA] = ACTIONS(2245),
    [anon_sym_RPAREN] = ACTIONS(2245),
    [anon_sym_LPAREN2] = ACTIONS(2247),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2247),
    [anon_sym_SLASH] = ACTIONS(2255),
    [anon_sym_PERCENT] = ACTIONS(2245),
    [anon_sym_PIPE_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2255),
    [anon_sym_CARET] = ACTIONS(2245),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2245),
    [anon_sym_BANG_EQ] = ACTIONS(2245),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_GT_EQ] = ACTIONS(2245),
    [anon_sym_LT_EQ] = ACTIONS(2255),
    [anon_sym_LT] = ACTIONS(2255),
    [anon_sym_LT_LT] = ACTIONS(2245),
    [anon_sym_GT_GT] = ACTIONS(2245),
    [anon_sym_SEMI] = ACTIONS(2245),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_out] = ACTIONS(2243),
    [anon_sym_inout] = ACTIONS(2243),
    [anon_sym_virtual] = ACTIONS(2243),
    [anon_sym_extern] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym___attribute] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2243),
    [anon_sym___based] = ACTIONS(2243),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2245),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_register] = ACTIONS(2243),
    [anon_sym_inline] = ACTIONS(2243),
    [anon_sym___inline] = ACTIONS(2243),
    [anon_sym___inline__] = ACTIONS(2243),
    [anon_sym___forceinline] = ACTIONS(2243),
    [anon_sym_thread_local] = ACTIONS(2243),
    [anon_sym___thread] = ACTIONS(2243),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym__Nonnull] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [anon_sym_QMARK] = ACTIONS(2245),
    [anon_sym_LT_EQ_GT] = ACTIONS(2245),
    [anon_sym_or] = ACTIONS(2255),
    [anon_sym_and] = ACTIONS(2255),
    [anon_sym_bitor] = ACTIONS(2255),
    [anon_sym_xor] = ACTIONS(2255),
    [anon_sym_bitand] = ACTIONS(2255),
    [anon_sym_not_eq] = ACTIONS(2255),
    [anon_sym_is] = ACTIONS(2255),
    [anon_sym_as] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2245),
    [anon_sym_PLUS_PLUS] = ACTIONS(2245),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2245),
    [anon_sym_DASH_GT] = ACTIONS(2245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2243),
    [anon_sym_let] = ACTIONS(2243),
    [anon_sym_This] = ACTIONS(2243),
    [anon_sym_decltype] = ACTIONS(2243),
    [anon_sym_template] = ACTIONS(2243),
    [anon_sym_operator] = ACTIONS(2243),
    [anon_sym_precise] = ACTIONS(2243),
    [anon_sym_shared] = ACTIONS(2243),
    [anon_sym_groupshared] = ACTIONS(2243),
    [anon_sym_uniform] = ACTIONS(2243),
    [anon_sym_row_major] = ACTIONS(2243),
    [anon_sym_column_major] = ACTIONS(2243),
    [anon_sym_globallycoherent] = ACTIONS(2243),
    [anon_sym_centroid] = ACTIONS(2243),
    [anon_sym_noperspective] = ACTIONS(2243),
    [anon_sym_nointerpolation] = ACTIONS(2243),
    [anon_sym_sample] = ACTIONS(2243),
    [anon_sym_linear] = ACTIONS(2243),
    [anon_sym_snorm] = ACTIONS(2243),
    [anon_sym_unorm] = ACTIONS(2243),
    [anon_sym_point] = ACTIONS(2243),
    [anon_sym_line] = ACTIONS(2243),
    [anon_sym_triangleadj] = ACTIONS(2243),
    [anon_sym_lineadj] = ACTIONS(2243),
    [anon_sym_triangle] = ACTIONS(2243),
  },
  [1653] = {
    [sym_identifier] = ACTIONS(2404),
    [aux_sym_preproc_def_token1] = ACTIONS(2404),
    [aux_sym_preproc_if_token1] = ACTIONS(2404),
    [aux_sym_preproc_if_token2] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2404),
    [aux_sym_preproc_else_token1] = ACTIONS(2404),
    [aux_sym_preproc_elif_token1] = ACTIONS(2404),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2404),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2404),
    [sym_preproc_directive] = ACTIONS(2404),
    [anon_sym_LPAREN2] = ACTIONS(2402),
    [anon_sym_TILDE] = ACTIONS(2402),
    [anon_sym_STAR] = ACTIONS(2402),
    [anon_sym_AMP_AMP] = ACTIONS(2402),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2402),
    [anon_sym___extension__] = ACTIONS(2404),
    [anon_sym_typedef] = ACTIONS(2404),
    [anon_sym_in] = ACTIONS(2404),
    [anon_sym_out] = ACTIONS(2404),
    [anon_sym_inout] = ACTIONS(2404),
    [anon_sym_virtual] = ACTIONS(2404),
    [anon_sym_extern] = ACTIONS(2404),
    [anon_sym___attribute__] = ACTIONS(2404),
    [anon_sym___attribute] = ACTIONS(2404),
    [anon_sym_using] = ACTIONS(2404),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2402),
    [anon_sym___declspec] = ACTIONS(2404),
    [anon_sym___based] = ACTIONS(2404),
    [anon_sym_signed] = ACTIONS(2404),
    [anon_sym_unsigned] = ACTIONS(2404),
    [anon_sym_long] = ACTIONS(2404),
    [anon_sym_short] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_register] = ACTIONS(2404),
    [anon_sym_inline] = ACTIONS(2404),
    [anon_sym___inline] = ACTIONS(2404),
    [anon_sym___inline__] = ACTIONS(2404),
    [anon_sym___forceinline] = ACTIONS(2404),
    [anon_sym_thread_local] = ACTIONS(2404),
    [anon_sym___thread] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [anon_sym_constexpr] = ACTIONS(2404),
    [anon_sym_volatile] = ACTIONS(2404),
    [anon_sym_restrict] = ACTIONS(2404),
    [anon_sym___restrict__] = ACTIONS(2404),
    [anon_sym__Atomic] = ACTIONS(2404),
    [anon_sym__Noreturn] = ACTIONS(2404),
    [anon_sym_noreturn] = ACTIONS(2404),
    [anon_sym__Nonnull] = ACTIONS(2404),
    [anon_sym_mutable] = ACTIONS(2404),
    [anon_sym_constinit] = ACTIONS(2404),
    [anon_sym_consteval] = ACTIONS(2404),
    [anon_sym_alignas] = ACTIONS(2404),
    [anon_sym__Alignas] = ACTIONS(2404),
    [sym_primitive_type] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
    [anon_sym_class] = ACTIONS(2404),
    [anon_sym_struct] = ACTIONS(2404),
    [anon_sym_union] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2404),
    [anon_sym_let] = ACTIONS(2404),
    [anon_sym_This] = ACTIONS(2404),
    [anon_sym_decltype] = ACTIONS(2404),
    [anon_sym_explicit] = ACTIONS(2404),
    [anon_sym_typename] = ACTIONS(2404),
    [anon_sym_private] = ACTIONS(2404),
    [anon_sym_template] = ACTIONS(2404),
    [anon_sym_operator] = ACTIONS(2404),
    [anon_sym_friend] = ACTIONS(2404),
    [anon_sym_public] = ACTIONS(2404),
    [anon_sym_protected] = ACTIONS(2404),
    [anon_sym_static_assert] = ACTIONS(2404),
    [anon_sym_catch] = ACTIONS(2404),
    [anon_sym_precise] = ACTIONS(2404),
    [anon_sym_shared] = ACTIONS(2404),
    [anon_sym_groupshared] = ACTIONS(2404),
    [anon_sym_uniform] = ACTIONS(2404),
    [anon_sym_row_major] = ACTIONS(2404),
    [anon_sym_column_major] = ACTIONS(2404),
    [anon_sym_globallycoherent] = ACTIONS(2404),
    [anon_sym_centroid] = ACTIONS(2404),
    [anon_sym_noperspective] = ACTIONS(2404),
    [anon_sym_nointerpolation] = ACTIONS(2404),
    [anon_sym_sample] = ACTIONS(2404),
    [anon_sym_linear] = ACTIONS(2404),
    [anon_sym_snorm] = ACTIONS(2404),
    [anon_sym_unorm] = ACTIONS(2404),
    [anon_sym_point] = ACTIONS(2404),
    [anon_sym_line] = ACTIONS(2404),
    [anon_sym_triangleadj] = ACTIONS(2404),
    [anon_sym_lineadj] = ACTIONS(2404),
    [anon_sym_triangle] = ACTIONS(2404),
    [anon_sym_interface] = ACTIONS(2404),
    [anon_sym_extension] = ACTIONS(2404),
    [anon_sym___init] = ACTIONS(2404),
    [anon_sym___subscript] = ACTIONS(2404),
    [anon_sym_property] = ACTIONS(2404),
    [anon_sym_associatedtype] = ACTIONS(2404),
  },
  [1654] = {
    [sym_identifier] = ACTIONS(2414),
    [aux_sym_preproc_def_token1] = ACTIONS(2414),
    [anon_sym_COMMA] = ACTIONS(4215),
    [aux_sym_preproc_if_token1] = ACTIONS(2414),
    [aux_sym_preproc_if_token2] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2414),
    [aux_sym_preproc_else_token1] = ACTIONS(2414),
    [aux_sym_preproc_elif_token1] = ACTIONS(2414),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2414),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2414),
    [sym_preproc_directive] = ACTIONS(2414),
    [anon_sym_LPAREN2] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(4215),
    [anon_sym___extension__] = ACTIONS(2414),
    [anon_sym_typedef] = ACTIONS(2414),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_out] = ACTIONS(2414),
    [anon_sym_inout] = ACTIONS(2414),
    [anon_sym_virtual] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym___attribute__] = ACTIONS(6106),
    [anon_sym___attribute] = ACTIONS(6106),
    [anon_sym_using] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2412),
    [anon_sym___declspec] = ACTIONS(2414),
    [anon_sym___based] = ACTIONS(2414),
    [anon_sym_signed] = ACTIONS(2414),
    [anon_sym_unsigned] = ACTIONS(2414),
    [anon_sym_long] = ACTIONS(2414),
    [anon_sym_short] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_register] = ACTIONS(2414),
    [anon_sym_inline] = ACTIONS(2414),
    [anon_sym___inline] = ACTIONS(2414),
    [anon_sym___inline__] = ACTIONS(2414),
    [anon_sym___forceinline] = ACTIONS(2414),
    [anon_sym_thread_local] = ACTIONS(2414),
    [anon_sym___thread] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_constexpr] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym_restrict] = ACTIONS(2414),
    [anon_sym___restrict__] = ACTIONS(2414),
    [anon_sym__Atomic] = ACTIONS(2414),
    [anon_sym__Noreturn] = ACTIONS(2414),
    [anon_sym_noreturn] = ACTIONS(2414),
    [anon_sym__Nonnull] = ACTIONS(2414),
    [anon_sym_mutable] = ACTIONS(2414),
    [anon_sym_constinit] = ACTIONS(2414),
    [anon_sym_consteval] = ACTIONS(2414),
    [anon_sym_alignas] = ACTIONS(2414),
    [anon_sym__Alignas] = ACTIONS(2414),
    [sym_primitive_type] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2414),
    [anon_sym_let] = ACTIONS(2414),
    [anon_sym_This] = ACTIONS(2414),
    [anon_sym_decltype] = ACTIONS(2414),
    [anon_sym_explicit] = ACTIONS(2414),
    [anon_sym_typename] = ACTIONS(2414),
    [anon_sym_private] = ACTIONS(2414),
    [anon_sym_template] = ACTIONS(2414),
    [anon_sym_operator] = ACTIONS(2414),
    [anon_sym_friend] = ACTIONS(2414),
    [anon_sym_public] = ACTIONS(2414),
    [anon_sym_protected] = ACTIONS(2414),
    [anon_sym_static_assert] = ACTIONS(2414),
    [anon_sym_precise] = ACTIONS(2414),
    [anon_sym_shared] = ACTIONS(2414),
    [anon_sym_groupshared] = ACTIONS(2414),
    [anon_sym_uniform] = ACTIONS(2414),
    [anon_sym_row_major] = ACTIONS(2414),
    [anon_sym_column_major] = ACTIONS(2414),
    [anon_sym_globallycoherent] = ACTIONS(2414),
    [anon_sym_centroid] = ACTIONS(2414),
    [anon_sym_noperspective] = ACTIONS(2414),
    [anon_sym_nointerpolation] = ACTIONS(2414),
    [anon_sym_sample] = ACTIONS(2414),
    [anon_sym_linear] = ACTIONS(2414),
    [anon_sym_snorm] = ACTIONS(2414),
    [anon_sym_unorm] = ACTIONS(2414),
    [anon_sym_point] = ACTIONS(2414),
    [anon_sym_line] = ACTIONS(2414),
    [anon_sym_triangleadj] = ACTIONS(2414),
    [anon_sym_lineadj] = ACTIONS(2414),
    [anon_sym_triangle] = ACTIONS(2414),
    [anon_sym_interface] = ACTIONS(2414),
    [anon_sym_extension] = ACTIONS(2414),
    [anon_sym___init] = ACTIONS(2414),
    [anon_sym___subscript] = ACTIONS(2414),
    [anon_sym_property] = ACTIONS(2414),
    [anon_sym_associatedtype] = ACTIONS(2414),
  },
  [1655] = {
    [sym__declaration_modifiers] = STATE(2667),
    [sym__declaration_specifiers] = STATE(4972),
    [sym_attribute_specifier] = STATE(2667),
    [sym_attribute_declaration] = STATE(2667),
    [sym_ms_declspec_modifier] = STATE(2667),
    [sym_storage_class_specifier] = STATE(2667),
    [sym_type_qualifier] = STATE(2667),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2793),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_parameter_declaration] = STATE(9875),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_optional_parameter_declaration] = STATE(9875),
    [sym_variadic_parameter_declaration] = STATE(9875),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8769),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2667),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2667),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6108),
    [anon_sym_RPAREN] = ACTIONS(6110),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(2348),
    [anon_sym_out] = ACTIONS(2348),
    [anon_sym_inout] = ACTIONS(2348),
    [anon_sym_virtual] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5525),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_extension] = ACTIONS(2398),
  },
  [1656] = {
    [sym_identifier] = ACTIONS(6112),
    [anon_sym_COMMA] = ACTIONS(6114),
    [anon_sym_RPAREN] = ACTIONS(6114),
    [anon_sym_LPAREN2] = ACTIONS(6114),
    [anon_sym_TILDE] = ACTIONS(6114),
    [anon_sym_STAR] = ACTIONS(6114),
    [anon_sym_PIPE_PIPE] = ACTIONS(6114),
    [anon_sym_AMP_AMP] = ACTIONS(6114),
    [anon_sym_AMP] = ACTIONS(6112),
    [anon_sym___extension__] = ACTIONS(6112),
    [anon_sym_in] = ACTIONS(6112),
    [anon_sym_out] = ACTIONS(6112),
    [anon_sym_inout] = ACTIONS(6112),
    [anon_sym_virtual] = ACTIONS(6112),
    [anon_sym_extern] = ACTIONS(6112),
    [anon_sym___attribute__] = ACTIONS(6112),
    [anon_sym___attribute] = ACTIONS(6112),
    [anon_sym_using] = ACTIONS(6112),
    [anon_sym_COLON_COLON] = ACTIONS(6114),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6114),
    [anon_sym___declspec] = ACTIONS(6112),
    [anon_sym___based] = ACTIONS(6112),
    [anon_sym___cdecl] = ACTIONS(6112),
    [anon_sym___clrcall] = ACTIONS(6112),
    [anon_sym___stdcall] = ACTIONS(6112),
    [anon_sym___fastcall] = ACTIONS(6112),
    [anon_sym___thiscall] = ACTIONS(6112),
    [anon_sym___vectorcall] = ACTIONS(6112),
    [anon_sym_LBRACE] = ACTIONS(6114),
    [anon_sym_signed] = ACTIONS(6112),
    [anon_sym_unsigned] = ACTIONS(6112),
    [anon_sym_long] = ACTIONS(6112),
    [anon_sym_short] = ACTIONS(6112),
    [anon_sym_LBRACK] = ACTIONS(6112),
    [anon_sym_static] = ACTIONS(6112),
    [anon_sym_register] = ACTIONS(6112),
    [anon_sym_inline] = ACTIONS(6112),
    [anon_sym___inline] = ACTIONS(6112),
    [anon_sym___inline__] = ACTIONS(6112),
    [anon_sym___forceinline] = ACTIONS(6112),
    [anon_sym_thread_local] = ACTIONS(6112),
    [anon_sym___thread] = ACTIONS(6112),
    [anon_sym_const] = ACTIONS(6112),
    [anon_sym_constexpr] = ACTIONS(6112),
    [anon_sym_volatile] = ACTIONS(6112),
    [anon_sym_restrict] = ACTIONS(6112),
    [anon_sym___restrict__] = ACTIONS(6112),
    [anon_sym__Atomic] = ACTIONS(6112),
    [anon_sym__Noreturn] = ACTIONS(6112),
    [anon_sym_noreturn] = ACTIONS(6112),
    [anon_sym__Nonnull] = ACTIONS(6112),
    [anon_sym_mutable] = ACTIONS(6112),
    [anon_sym_constinit] = ACTIONS(6112),
    [anon_sym_consteval] = ACTIONS(6112),
    [anon_sym_alignas] = ACTIONS(6112),
    [anon_sym__Alignas] = ACTIONS(6112),
    [sym_primitive_type] = ACTIONS(6112),
    [anon_sym_enum] = ACTIONS(6112),
    [anon_sym_class] = ACTIONS(6112),
    [anon_sym_struct] = ACTIONS(6112),
    [anon_sym_union] = ACTIONS(6112),
    [anon_sym_or] = ACTIONS(6112),
    [anon_sym_and] = ACTIONS(6112),
    [anon_sym_DASH_GT] = ACTIONS(6114),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6112),
    [anon_sym_let] = ACTIONS(6112),
    [anon_sym_This] = ACTIONS(6112),
    [anon_sym_decltype] = ACTIONS(6112),
    [anon_sym_final] = ACTIONS(6112),
    [anon_sym_override] = ACTIONS(6112),
    [anon_sym_explicit] = ACTIONS(6112),
    [anon_sym_typename] = ACTIONS(6112),
    [anon_sym_template] = ACTIONS(6112),
    [anon_sym_operator] = ACTIONS(6112),
    [anon_sym_friend] = ACTIONS(6112),
    [anon_sym_noexcept] = ACTIONS(6112),
    [anon_sym_throw] = ACTIONS(6112),
    [anon_sym_concept] = ACTIONS(6112),
    [anon_sym_requires] = ACTIONS(6112),
    [anon_sym_precise] = ACTIONS(6112),
    [anon_sym_shared] = ACTIONS(6112),
    [anon_sym_groupshared] = ACTIONS(6112),
    [anon_sym_uniform] = ACTIONS(6112),
    [anon_sym_row_major] = ACTIONS(6112),
    [anon_sym_column_major] = ACTIONS(6112),
    [anon_sym_globallycoherent] = ACTIONS(6112),
    [anon_sym_centroid] = ACTIONS(6112),
    [anon_sym_noperspective] = ACTIONS(6112),
    [anon_sym_nointerpolation] = ACTIONS(6112),
    [anon_sym_sample] = ACTIONS(6112),
    [anon_sym_linear] = ACTIONS(6112),
    [anon_sym_snorm] = ACTIONS(6112),
    [anon_sym_unorm] = ACTIONS(6112),
    [anon_sym_point] = ACTIONS(6112),
    [anon_sym_line] = ACTIONS(6112),
    [anon_sym_triangleadj] = ACTIONS(6112),
    [anon_sym_lineadj] = ACTIONS(6112),
    [anon_sym_triangle] = ACTIONS(6112),
    [anon_sym_interface] = ACTIONS(6112),
    [anon_sym_extension] = ACTIONS(6112),
    [anon_sym_where] = ACTIONS(6112),
  },
  [1657] = {
    [sym_identifier] = ACTIONS(3673),
    [aux_sym_preproc_def_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token2] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3673),
    [aux_sym_preproc_else_token1] = ACTIONS(3673),
    [aux_sym_preproc_elif_token1] = ACTIONS(3673),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3673),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3673),
    [sym_preproc_directive] = ACTIONS(3673),
    [anon_sym_LPAREN2] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3673),
    [anon_sym_SEMI] = ACTIONS(3675),
    [anon_sym___extension__] = ACTIONS(3673),
    [anon_sym_typedef] = ACTIONS(3673),
    [anon_sym_in] = ACTIONS(3673),
    [anon_sym_out] = ACTIONS(3673),
    [anon_sym_inout] = ACTIONS(3673),
    [anon_sym_virtual] = ACTIONS(3673),
    [anon_sym_extern] = ACTIONS(3673),
    [anon_sym___attribute__] = ACTIONS(3673),
    [anon_sym___attribute] = ACTIONS(3673),
    [anon_sym_using] = ACTIONS(3673),
    [anon_sym_COLON_COLON] = ACTIONS(3675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3675),
    [anon_sym___declspec] = ACTIONS(3673),
    [anon_sym___based] = ACTIONS(3673),
    [anon_sym_signed] = ACTIONS(3673),
    [anon_sym_unsigned] = ACTIONS(3673),
    [anon_sym_long] = ACTIONS(3673),
    [anon_sym_short] = ACTIONS(3673),
    [anon_sym_LBRACK] = ACTIONS(3673),
    [anon_sym_static] = ACTIONS(3673),
    [anon_sym_register] = ACTIONS(3673),
    [anon_sym_inline] = ACTIONS(3673),
    [anon_sym___inline] = ACTIONS(3673),
    [anon_sym___inline__] = ACTIONS(3673),
    [anon_sym___forceinline] = ACTIONS(3673),
    [anon_sym_thread_local] = ACTIONS(3673),
    [anon_sym___thread] = ACTIONS(3673),
    [anon_sym_const] = ACTIONS(3673),
    [anon_sym_constexpr] = ACTIONS(3673),
    [anon_sym_volatile] = ACTIONS(3673),
    [anon_sym_restrict] = ACTIONS(3673),
    [anon_sym___restrict__] = ACTIONS(3673),
    [anon_sym__Atomic] = ACTIONS(3673),
    [anon_sym__Noreturn] = ACTIONS(3673),
    [anon_sym_noreturn] = ACTIONS(3673),
    [anon_sym__Nonnull] = ACTIONS(3673),
    [anon_sym_mutable] = ACTIONS(3673),
    [anon_sym_constinit] = ACTIONS(3673),
    [anon_sym_consteval] = ACTIONS(3673),
    [anon_sym_alignas] = ACTIONS(3673),
    [anon_sym__Alignas] = ACTIONS(3673),
    [sym_primitive_type] = ACTIONS(3673),
    [anon_sym_enum] = ACTIONS(3673),
    [anon_sym_class] = ACTIONS(3673),
    [anon_sym_struct] = ACTIONS(3673),
    [anon_sym_union] = ACTIONS(3673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3673),
    [anon_sym_let] = ACTIONS(3673),
    [anon_sym_This] = ACTIONS(3673),
    [anon_sym_decltype] = ACTIONS(3673),
    [anon_sym_explicit] = ACTIONS(3673),
    [anon_sym_typename] = ACTIONS(3673),
    [anon_sym_private] = ACTIONS(3673),
    [anon_sym_template] = ACTIONS(3673),
    [anon_sym_operator] = ACTIONS(3673),
    [anon_sym_friend] = ACTIONS(3673),
    [anon_sym_public] = ACTIONS(3673),
    [anon_sym_protected] = ACTIONS(3673),
    [anon_sym_static_assert] = ACTIONS(3673),
    [anon_sym_precise] = ACTIONS(3673),
    [anon_sym_shared] = ACTIONS(3673),
    [anon_sym_groupshared] = ACTIONS(3673),
    [anon_sym_uniform] = ACTIONS(3673),
    [anon_sym_row_major] = ACTIONS(3673),
    [anon_sym_column_major] = ACTIONS(3673),
    [anon_sym_globallycoherent] = ACTIONS(3673),
    [anon_sym_centroid] = ACTIONS(3673),
    [anon_sym_noperspective] = ACTIONS(3673),
    [anon_sym_nointerpolation] = ACTIONS(3673),
    [anon_sym_sample] = ACTIONS(3673),
    [anon_sym_linear] = ACTIONS(3673),
    [anon_sym_snorm] = ACTIONS(3673),
    [anon_sym_unorm] = ACTIONS(3673),
    [anon_sym_point] = ACTIONS(3673),
    [anon_sym_line] = ACTIONS(3673),
    [anon_sym_triangleadj] = ACTIONS(3673),
    [anon_sym_lineadj] = ACTIONS(3673),
    [anon_sym_triangle] = ACTIONS(3673),
    [anon_sym_interface] = ACTIONS(3673),
    [anon_sym_extension] = ACTIONS(3673),
    [anon_sym___init] = ACTIONS(3673),
    [anon_sym___subscript] = ACTIONS(3673),
    [anon_sym_property] = ACTIONS(3673),
    [anon_sym_associatedtype] = ACTIONS(3673),
  },
  [1658] = {
    [sym_compound_statement] = STATE(11152),
    [sym_expression] = STATE(4434),
    [sym__string] = STATE(3741),
    [sym_comma_expression] = STATE(11152),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym__assignment_expression_lhs] = STATE(10925),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1659] = {
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token2] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [aux_sym_preproc_else_token1] = ACTIONS(3942),
    [aux_sym_preproc_elif_token1] = ACTIONS(3942),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_private] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_friend] = ACTIONS(3942),
    [anon_sym_public] = ACTIONS(3942),
    [anon_sym_protected] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
    [anon_sym___init] = ACTIONS(3942),
    [anon_sym___subscript] = ACTIONS(3942),
    [anon_sym_property] = ACTIONS(3942),
    [anon_sym_associatedtype] = ACTIONS(3942),
  },
  [1660] = {
    [sym_expression] = STATE(5671),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11651),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(11651),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(6118),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1661] = {
    [sym_identifier] = ACTIONS(6120),
    [anon_sym_COMMA] = ACTIONS(6122),
    [anon_sym_RPAREN] = ACTIONS(6122),
    [anon_sym_LPAREN2] = ACTIONS(6122),
    [anon_sym_TILDE] = ACTIONS(6122),
    [anon_sym_STAR] = ACTIONS(6122),
    [anon_sym_PIPE_PIPE] = ACTIONS(6122),
    [anon_sym_AMP_AMP] = ACTIONS(6122),
    [anon_sym_AMP] = ACTIONS(6120),
    [anon_sym___extension__] = ACTIONS(6120),
    [anon_sym_in] = ACTIONS(6120),
    [anon_sym_out] = ACTIONS(6120),
    [anon_sym_inout] = ACTIONS(6120),
    [anon_sym_virtual] = ACTIONS(6120),
    [anon_sym_extern] = ACTIONS(6120),
    [anon_sym___attribute__] = ACTIONS(6120),
    [anon_sym___attribute] = ACTIONS(6120),
    [anon_sym_using] = ACTIONS(6120),
    [anon_sym_COLON_COLON] = ACTIONS(6122),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6122),
    [anon_sym___declspec] = ACTIONS(6120),
    [anon_sym___based] = ACTIONS(6120),
    [anon_sym___cdecl] = ACTIONS(6120),
    [anon_sym___clrcall] = ACTIONS(6120),
    [anon_sym___stdcall] = ACTIONS(6120),
    [anon_sym___fastcall] = ACTIONS(6120),
    [anon_sym___thiscall] = ACTIONS(6120),
    [anon_sym___vectorcall] = ACTIONS(6120),
    [anon_sym_LBRACE] = ACTIONS(6122),
    [anon_sym_signed] = ACTIONS(6120),
    [anon_sym_unsigned] = ACTIONS(6120),
    [anon_sym_long] = ACTIONS(6120),
    [anon_sym_short] = ACTIONS(6120),
    [anon_sym_LBRACK] = ACTIONS(6120),
    [anon_sym_static] = ACTIONS(6120),
    [anon_sym_register] = ACTIONS(6120),
    [anon_sym_inline] = ACTIONS(6120),
    [anon_sym___inline] = ACTIONS(6120),
    [anon_sym___inline__] = ACTIONS(6120),
    [anon_sym___forceinline] = ACTIONS(6120),
    [anon_sym_thread_local] = ACTIONS(6120),
    [anon_sym___thread] = ACTIONS(6120),
    [anon_sym_const] = ACTIONS(6120),
    [anon_sym_constexpr] = ACTIONS(6120),
    [anon_sym_volatile] = ACTIONS(6120),
    [anon_sym_restrict] = ACTIONS(6120),
    [anon_sym___restrict__] = ACTIONS(6120),
    [anon_sym__Atomic] = ACTIONS(6120),
    [anon_sym__Noreturn] = ACTIONS(6120),
    [anon_sym_noreturn] = ACTIONS(6120),
    [anon_sym__Nonnull] = ACTIONS(6120),
    [anon_sym_mutable] = ACTIONS(6120),
    [anon_sym_constinit] = ACTIONS(6120),
    [anon_sym_consteval] = ACTIONS(6120),
    [anon_sym_alignas] = ACTIONS(6120),
    [anon_sym__Alignas] = ACTIONS(6120),
    [sym_primitive_type] = ACTIONS(6120),
    [anon_sym_enum] = ACTIONS(6120),
    [anon_sym_class] = ACTIONS(6120),
    [anon_sym_struct] = ACTIONS(6120),
    [anon_sym_union] = ACTIONS(6120),
    [anon_sym_or] = ACTIONS(6120),
    [anon_sym_and] = ACTIONS(6120),
    [anon_sym_DASH_GT] = ACTIONS(6122),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6120),
    [anon_sym_let] = ACTIONS(6120),
    [anon_sym_This] = ACTIONS(6120),
    [anon_sym_decltype] = ACTIONS(6120),
    [anon_sym_final] = ACTIONS(6120),
    [anon_sym_override] = ACTIONS(6120),
    [anon_sym_explicit] = ACTIONS(6120),
    [anon_sym_typename] = ACTIONS(6120),
    [anon_sym_template] = ACTIONS(6120),
    [anon_sym_operator] = ACTIONS(6120),
    [anon_sym_friend] = ACTIONS(6120),
    [anon_sym_noexcept] = ACTIONS(6120),
    [anon_sym_throw] = ACTIONS(6120),
    [anon_sym_concept] = ACTIONS(6120),
    [anon_sym_requires] = ACTIONS(6120),
    [anon_sym_precise] = ACTIONS(6120),
    [anon_sym_shared] = ACTIONS(6120),
    [anon_sym_groupshared] = ACTIONS(6120),
    [anon_sym_uniform] = ACTIONS(6120),
    [anon_sym_row_major] = ACTIONS(6120),
    [anon_sym_column_major] = ACTIONS(6120),
    [anon_sym_globallycoherent] = ACTIONS(6120),
    [anon_sym_centroid] = ACTIONS(6120),
    [anon_sym_noperspective] = ACTIONS(6120),
    [anon_sym_nointerpolation] = ACTIONS(6120),
    [anon_sym_sample] = ACTIONS(6120),
    [anon_sym_linear] = ACTIONS(6120),
    [anon_sym_snorm] = ACTIONS(6120),
    [anon_sym_unorm] = ACTIONS(6120),
    [anon_sym_point] = ACTIONS(6120),
    [anon_sym_line] = ACTIONS(6120),
    [anon_sym_triangleadj] = ACTIONS(6120),
    [anon_sym_lineadj] = ACTIONS(6120),
    [anon_sym_triangle] = ACTIONS(6120),
    [anon_sym_interface] = ACTIONS(6120),
    [anon_sym_extension] = ACTIONS(6120),
    [anon_sym_where] = ACTIONS(6120),
  },
  [1662] = {
    [sym_identifier] = ACTIONS(6124),
    [anon_sym_COMMA] = ACTIONS(6126),
    [anon_sym_RPAREN] = ACTIONS(6126),
    [anon_sym_LPAREN2] = ACTIONS(6126),
    [anon_sym_TILDE] = ACTIONS(6126),
    [anon_sym_STAR] = ACTIONS(6126),
    [anon_sym_PIPE_PIPE] = ACTIONS(6126),
    [anon_sym_AMP_AMP] = ACTIONS(6126),
    [anon_sym_AMP] = ACTIONS(6124),
    [anon_sym___extension__] = ACTIONS(6124),
    [anon_sym_in] = ACTIONS(6124),
    [anon_sym_out] = ACTIONS(6124),
    [anon_sym_inout] = ACTIONS(6124),
    [anon_sym_virtual] = ACTIONS(6124),
    [anon_sym_extern] = ACTIONS(6124),
    [anon_sym___attribute__] = ACTIONS(6124),
    [anon_sym___attribute] = ACTIONS(6124),
    [anon_sym_using] = ACTIONS(6124),
    [anon_sym_COLON_COLON] = ACTIONS(6126),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6126),
    [anon_sym___declspec] = ACTIONS(6124),
    [anon_sym___based] = ACTIONS(6124),
    [anon_sym___cdecl] = ACTIONS(6124),
    [anon_sym___clrcall] = ACTIONS(6124),
    [anon_sym___stdcall] = ACTIONS(6124),
    [anon_sym___fastcall] = ACTIONS(6124),
    [anon_sym___thiscall] = ACTIONS(6124),
    [anon_sym___vectorcall] = ACTIONS(6124),
    [anon_sym_LBRACE] = ACTIONS(6126),
    [anon_sym_signed] = ACTIONS(6124),
    [anon_sym_unsigned] = ACTIONS(6124),
    [anon_sym_long] = ACTIONS(6124),
    [anon_sym_short] = ACTIONS(6124),
    [anon_sym_LBRACK] = ACTIONS(6124),
    [anon_sym_static] = ACTIONS(6124),
    [anon_sym_register] = ACTIONS(6124),
    [anon_sym_inline] = ACTIONS(6124),
    [anon_sym___inline] = ACTIONS(6124),
    [anon_sym___inline__] = ACTIONS(6124),
    [anon_sym___forceinline] = ACTIONS(6124),
    [anon_sym_thread_local] = ACTIONS(6124),
    [anon_sym___thread] = ACTIONS(6124),
    [anon_sym_const] = ACTIONS(6124),
    [anon_sym_constexpr] = ACTIONS(6124),
    [anon_sym_volatile] = ACTIONS(6124),
    [anon_sym_restrict] = ACTIONS(6124),
    [anon_sym___restrict__] = ACTIONS(6124),
    [anon_sym__Atomic] = ACTIONS(6124),
    [anon_sym__Noreturn] = ACTIONS(6124),
    [anon_sym_noreturn] = ACTIONS(6124),
    [anon_sym__Nonnull] = ACTIONS(6124),
    [anon_sym_mutable] = ACTIONS(6124),
    [anon_sym_constinit] = ACTIONS(6124),
    [anon_sym_consteval] = ACTIONS(6124),
    [anon_sym_alignas] = ACTIONS(6124),
    [anon_sym__Alignas] = ACTIONS(6124),
    [sym_primitive_type] = ACTIONS(6124),
    [anon_sym_enum] = ACTIONS(6124),
    [anon_sym_class] = ACTIONS(6124),
    [anon_sym_struct] = ACTIONS(6124),
    [anon_sym_union] = ACTIONS(6124),
    [anon_sym_or] = ACTIONS(6124),
    [anon_sym_and] = ACTIONS(6124),
    [anon_sym_DASH_GT] = ACTIONS(6126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6124),
    [anon_sym_let] = ACTIONS(6124),
    [anon_sym_This] = ACTIONS(6124),
    [anon_sym_decltype] = ACTIONS(6124),
    [anon_sym_final] = ACTIONS(6124),
    [anon_sym_override] = ACTIONS(6124),
    [anon_sym_explicit] = ACTIONS(6124),
    [anon_sym_typename] = ACTIONS(6124),
    [anon_sym_template] = ACTIONS(6124),
    [anon_sym_operator] = ACTIONS(6124),
    [anon_sym_friend] = ACTIONS(6124),
    [anon_sym_noexcept] = ACTIONS(6124),
    [anon_sym_throw] = ACTIONS(6124),
    [anon_sym_concept] = ACTIONS(6124),
    [anon_sym_requires] = ACTIONS(6124),
    [anon_sym_precise] = ACTIONS(6124),
    [anon_sym_shared] = ACTIONS(6124),
    [anon_sym_groupshared] = ACTIONS(6124),
    [anon_sym_uniform] = ACTIONS(6124),
    [anon_sym_row_major] = ACTIONS(6124),
    [anon_sym_column_major] = ACTIONS(6124),
    [anon_sym_globallycoherent] = ACTIONS(6124),
    [anon_sym_centroid] = ACTIONS(6124),
    [anon_sym_noperspective] = ACTIONS(6124),
    [anon_sym_nointerpolation] = ACTIONS(6124),
    [anon_sym_sample] = ACTIONS(6124),
    [anon_sym_linear] = ACTIONS(6124),
    [anon_sym_snorm] = ACTIONS(6124),
    [anon_sym_unorm] = ACTIONS(6124),
    [anon_sym_point] = ACTIONS(6124),
    [anon_sym_line] = ACTIONS(6124),
    [anon_sym_triangleadj] = ACTIONS(6124),
    [anon_sym_lineadj] = ACTIONS(6124),
    [anon_sym_triangle] = ACTIONS(6124),
    [anon_sym_interface] = ACTIONS(6124),
    [anon_sym_extension] = ACTIONS(6124),
    [anon_sym_where] = ACTIONS(6124),
  },
  [1663] = {
    [sym_identifier] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(6130),
    [anon_sym_RPAREN] = ACTIONS(6130),
    [anon_sym_LPAREN2] = ACTIONS(6130),
    [anon_sym_TILDE] = ACTIONS(6130),
    [anon_sym_STAR] = ACTIONS(6130),
    [anon_sym_PIPE_PIPE] = ACTIONS(6130),
    [anon_sym_AMP_AMP] = ACTIONS(6130),
    [anon_sym_AMP] = ACTIONS(6128),
    [anon_sym___extension__] = ACTIONS(6128),
    [anon_sym_in] = ACTIONS(6128),
    [anon_sym_out] = ACTIONS(6128),
    [anon_sym_inout] = ACTIONS(6128),
    [anon_sym_virtual] = ACTIONS(6128),
    [anon_sym_extern] = ACTIONS(6128),
    [anon_sym___attribute__] = ACTIONS(6128),
    [anon_sym___attribute] = ACTIONS(6128),
    [anon_sym_using] = ACTIONS(6128),
    [anon_sym_COLON_COLON] = ACTIONS(6130),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6130),
    [anon_sym___declspec] = ACTIONS(6128),
    [anon_sym___based] = ACTIONS(6128),
    [anon_sym___cdecl] = ACTIONS(6128),
    [anon_sym___clrcall] = ACTIONS(6128),
    [anon_sym___stdcall] = ACTIONS(6128),
    [anon_sym___fastcall] = ACTIONS(6128),
    [anon_sym___thiscall] = ACTIONS(6128),
    [anon_sym___vectorcall] = ACTIONS(6128),
    [anon_sym_LBRACE] = ACTIONS(6130),
    [anon_sym_signed] = ACTIONS(6128),
    [anon_sym_unsigned] = ACTIONS(6128),
    [anon_sym_long] = ACTIONS(6128),
    [anon_sym_short] = ACTIONS(6128),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_static] = ACTIONS(6128),
    [anon_sym_register] = ACTIONS(6128),
    [anon_sym_inline] = ACTIONS(6128),
    [anon_sym___inline] = ACTIONS(6128),
    [anon_sym___inline__] = ACTIONS(6128),
    [anon_sym___forceinline] = ACTIONS(6128),
    [anon_sym_thread_local] = ACTIONS(6128),
    [anon_sym___thread] = ACTIONS(6128),
    [anon_sym_const] = ACTIONS(6128),
    [anon_sym_constexpr] = ACTIONS(6128),
    [anon_sym_volatile] = ACTIONS(6128),
    [anon_sym_restrict] = ACTIONS(6128),
    [anon_sym___restrict__] = ACTIONS(6128),
    [anon_sym__Atomic] = ACTIONS(6128),
    [anon_sym__Noreturn] = ACTIONS(6128),
    [anon_sym_noreturn] = ACTIONS(6128),
    [anon_sym__Nonnull] = ACTIONS(6128),
    [anon_sym_mutable] = ACTIONS(6128),
    [anon_sym_constinit] = ACTIONS(6128),
    [anon_sym_consteval] = ACTIONS(6128),
    [anon_sym_alignas] = ACTIONS(6128),
    [anon_sym__Alignas] = ACTIONS(6128),
    [sym_primitive_type] = ACTIONS(6128),
    [anon_sym_enum] = ACTIONS(6128),
    [anon_sym_class] = ACTIONS(6128),
    [anon_sym_struct] = ACTIONS(6128),
    [anon_sym_union] = ACTIONS(6128),
    [anon_sym_or] = ACTIONS(6128),
    [anon_sym_and] = ACTIONS(6128),
    [anon_sym_DASH_GT] = ACTIONS(6130),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6128),
    [anon_sym_let] = ACTIONS(6128),
    [anon_sym_This] = ACTIONS(6128),
    [anon_sym_decltype] = ACTIONS(6128),
    [anon_sym_final] = ACTIONS(6128),
    [anon_sym_override] = ACTIONS(6128),
    [anon_sym_explicit] = ACTIONS(6128),
    [anon_sym_typename] = ACTIONS(6128),
    [anon_sym_template] = ACTIONS(6128),
    [anon_sym_operator] = ACTIONS(6128),
    [anon_sym_friend] = ACTIONS(6128),
    [anon_sym_noexcept] = ACTIONS(6128),
    [anon_sym_throw] = ACTIONS(6128),
    [anon_sym_concept] = ACTIONS(6128),
    [anon_sym_requires] = ACTIONS(6128),
    [anon_sym_precise] = ACTIONS(6128),
    [anon_sym_shared] = ACTIONS(6128),
    [anon_sym_groupshared] = ACTIONS(6128),
    [anon_sym_uniform] = ACTIONS(6128),
    [anon_sym_row_major] = ACTIONS(6128),
    [anon_sym_column_major] = ACTIONS(6128),
    [anon_sym_globallycoherent] = ACTIONS(6128),
    [anon_sym_centroid] = ACTIONS(6128),
    [anon_sym_noperspective] = ACTIONS(6128),
    [anon_sym_nointerpolation] = ACTIONS(6128),
    [anon_sym_sample] = ACTIONS(6128),
    [anon_sym_linear] = ACTIONS(6128),
    [anon_sym_snorm] = ACTIONS(6128),
    [anon_sym_unorm] = ACTIONS(6128),
    [anon_sym_point] = ACTIONS(6128),
    [anon_sym_line] = ACTIONS(6128),
    [anon_sym_triangleadj] = ACTIONS(6128),
    [anon_sym_lineadj] = ACTIONS(6128),
    [anon_sym_triangle] = ACTIONS(6128),
    [anon_sym_interface] = ACTIONS(6128),
    [anon_sym_extension] = ACTIONS(6128),
    [anon_sym_where] = ACTIONS(6128),
  },
  [1664] = {
    [sym_compound_statement] = STATE(10183),
    [sym_expression] = STATE(5544),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10183),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_RPAREN] = ACTIONS(6132),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(6134),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1665] = {
    [sym_identifier] = ACTIONS(6136),
    [anon_sym_COMMA] = ACTIONS(6138),
    [anon_sym_RPAREN] = ACTIONS(6138),
    [anon_sym_LPAREN2] = ACTIONS(6138),
    [anon_sym_TILDE] = ACTIONS(6138),
    [anon_sym_STAR] = ACTIONS(6138),
    [anon_sym_PIPE_PIPE] = ACTIONS(6138),
    [anon_sym_AMP_AMP] = ACTIONS(6138),
    [anon_sym_AMP] = ACTIONS(6136),
    [anon_sym___extension__] = ACTIONS(6136),
    [anon_sym_in] = ACTIONS(6136),
    [anon_sym_out] = ACTIONS(6136),
    [anon_sym_inout] = ACTIONS(6136),
    [anon_sym_virtual] = ACTIONS(6136),
    [anon_sym_extern] = ACTIONS(6136),
    [anon_sym___attribute__] = ACTIONS(6136),
    [anon_sym___attribute] = ACTIONS(6136),
    [anon_sym_using] = ACTIONS(6136),
    [anon_sym_COLON_COLON] = ACTIONS(6138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6138),
    [anon_sym___declspec] = ACTIONS(6136),
    [anon_sym___based] = ACTIONS(6136),
    [anon_sym___cdecl] = ACTIONS(6136),
    [anon_sym___clrcall] = ACTIONS(6136),
    [anon_sym___stdcall] = ACTIONS(6136),
    [anon_sym___fastcall] = ACTIONS(6136),
    [anon_sym___thiscall] = ACTIONS(6136),
    [anon_sym___vectorcall] = ACTIONS(6136),
    [anon_sym_LBRACE] = ACTIONS(6138),
    [anon_sym_signed] = ACTIONS(6136),
    [anon_sym_unsigned] = ACTIONS(6136),
    [anon_sym_long] = ACTIONS(6136),
    [anon_sym_short] = ACTIONS(6136),
    [anon_sym_LBRACK] = ACTIONS(6136),
    [anon_sym_static] = ACTIONS(6136),
    [anon_sym_register] = ACTIONS(6136),
    [anon_sym_inline] = ACTIONS(6136),
    [anon_sym___inline] = ACTIONS(6136),
    [anon_sym___inline__] = ACTIONS(6136),
    [anon_sym___forceinline] = ACTIONS(6136),
    [anon_sym_thread_local] = ACTIONS(6136),
    [anon_sym___thread] = ACTIONS(6136),
    [anon_sym_const] = ACTIONS(6136),
    [anon_sym_constexpr] = ACTIONS(6136),
    [anon_sym_volatile] = ACTIONS(6136),
    [anon_sym_restrict] = ACTIONS(6136),
    [anon_sym___restrict__] = ACTIONS(6136),
    [anon_sym__Atomic] = ACTIONS(6136),
    [anon_sym__Noreturn] = ACTIONS(6136),
    [anon_sym_noreturn] = ACTIONS(6136),
    [anon_sym__Nonnull] = ACTIONS(6136),
    [anon_sym_mutable] = ACTIONS(6136),
    [anon_sym_constinit] = ACTIONS(6136),
    [anon_sym_consteval] = ACTIONS(6136),
    [anon_sym_alignas] = ACTIONS(6136),
    [anon_sym__Alignas] = ACTIONS(6136),
    [sym_primitive_type] = ACTIONS(6136),
    [anon_sym_enum] = ACTIONS(6136),
    [anon_sym_class] = ACTIONS(6136),
    [anon_sym_struct] = ACTIONS(6136),
    [anon_sym_union] = ACTIONS(6136),
    [anon_sym_or] = ACTIONS(6136),
    [anon_sym_and] = ACTIONS(6136),
    [anon_sym_DASH_GT] = ACTIONS(6138),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6136),
    [anon_sym_let] = ACTIONS(6136),
    [anon_sym_This] = ACTIONS(6136),
    [anon_sym_decltype] = ACTIONS(6136),
    [anon_sym_final] = ACTIONS(6136),
    [anon_sym_override] = ACTIONS(6136),
    [anon_sym_explicit] = ACTIONS(6136),
    [anon_sym_typename] = ACTIONS(6136),
    [anon_sym_template] = ACTIONS(6136),
    [anon_sym_operator] = ACTIONS(6136),
    [anon_sym_friend] = ACTIONS(6136),
    [anon_sym_noexcept] = ACTIONS(6136),
    [anon_sym_throw] = ACTIONS(6136),
    [anon_sym_concept] = ACTIONS(6136),
    [anon_sym_requires] = ACTIONS(6136),
    [anon_sym_precise] = ACTIONS(6136),
    [anon_sym_shared] = ACTIONS(6136),
    [anon_sym_groupshared] = ACTIONS(6136),
    [anon_sym_uniform] = ACTIONS(6136),
    [anon_sym_row_major] = ACTIONS(6136),
    [anon_sym_column_major] = ACTIONS(6136),
    [anon_sym_globallycoherent] = ACTIONS(6136),
    [anon_sym_centroid] = ACTIONS(6136),
    [anon_sym_noperspective] = ACTIONS(6136),
    [anon_sym_nointerpolation] = ACTIONS(6136),
    [anon_sym_sample] = ACTIONS(6136),
    [anon_sym_linear] = ACTIONS(6136),
    [anon_sym_snorm] = ACTIONS(6136),
    [anon_sym_unorm] = ACTIONS(6136),
    [anon_sym_point] = ACTIONS(6136),
    [anon_sym_line] = ACTIONS(6136),
    [anon_sym_triangleadj] = ACTIONS(6136),
    [anon_sym_lineadj] = ACTIONS(6136),
    [anon_sym_triangle] = ACTIONS(6136),
    [anon_sym_interface] = ACTIONS(6136),
    [anon_sym_extension] = ACTIONS(6136),
    [anon_sym_where] = ACTIONS(6136),
  },
  [1666] = {
    [sym_identifier] = ACTIONS(6140),
    [aux_sym_preproc_def_token1] = ACTIONS(6140),
    [aux_sym_preproc_if_token1] = ACTIONS(6140),
    [aux_sym_preproc_if_token2] = ACTIONS(6140),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6140),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6140),
    [aux_sym_preproc_else_token1] = ACTIONS(6140),
    [aux_sym_preproc_elif_token1] = ACTIONS(6140),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6140),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6140),
    [sym_preproc_directive] = ACTIONS(6140),
    [anon_sym_LPAREN2] = ACTIONS(6142),
    [anon_sym_TILDE] = ACTIONS(6142),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_AMP_AMP] = ACTIONS(6142),
    [anon_sym_AMP] = ACTIONS(6140),
    [anon_sym_SEMI] = ACTIONS(6142),
    [anon_sym___extension__] = ACTIONS(6140),
    [anon_sym_typedef] = ACTIONS(6140),
    [anon_sym_in] = ACTIONS(6140),
    [anon_sym_out] = ACTIONS(6140),
    [anon_sym_inout] = ACTIONS(6140),
    [anon_sym_virtual] = ACTIONS(6140),
    [anon_sym_extern] = ACTIONS(6140),
    [anon_sym___attribute__] = ACTIONS(6140),
    [anon_sym___attribute] = ACTIONS(6140),
    [anon_sym_using] = ACTIONS(6140),
    [anon_sym_COLON_COLON] = ACTIONS(6142),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6142),
    [anon_sym___declspec] = ACTIONS(6140),
    [anon_sym___based] = ACTIONS(6140),
    [anon_sym_signed] = ACTIONS(6140),
    [anon_sym_unsigned] = ACTIONS(6140),
    [anon_sym_long] = ACTIONS(6140),
    [anon_sym_short] = ACTIONS(6140),
    [anon_sym_LBRACK] = ACTIONS(6140),
    [anon_sym_static] = ACTIONS(6140),
    [anon_sym_register] = ACTIONS(6140),
    [anon_sym_inline] = ACTIONS(6140),
    [anon_sym___inline] = ACTIONS(6140),
    [anon_sym___inline__] = ACTIONS(6140),
    [anon_sym___forceinline] = ACTIONS(6140),
    [anon_sym_thread_local] = ACTIONS(6140),
    [anon_sym___thread] = ACTIONS(6140),
    [anon_sym_const] = ACTIONS(6140),
    [anon_sym_constexpr] = ACTIONS(6140),
    [anon_sym_volatile] = ACTIONS(6140),
    [anon_sym_restrict] = ACTIONS(6140),
    [anon_sym___restrict__] = ACTIONS(6140),
    [anon_sym__Atomic] = ACTIONS(6140),
    [anon_sym__Noreturn] = ACTIONS(6140),
    [anon_sym_noreturn] = ACTIONS(6140),
    [anon_sym__Nonnull] = ACTIONS(6140),
    [anon_sym_mutable] = ACTIONS(6140),
    [anon_sym_constinit] = ACTIONS(6140),
    [anon_sym_consteval] = ACTIONS(6140),
    [anon_sym_alignas] = ACTIONS(6140),
    [anon_sym__Alignas] = ACTIONS(6140),
    [sym_primitive_type] = ACTIONS(6140),
    [anon_sym_enum] = ACTIONS(6140),
    [anon_sym_class] = ACTIONS(6140),
    [anon_sym_struct] = ACTIONS(6140),
    [anon_sym_union] = ACTIONS(6140),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6140),
    [anon_sym_let] = ACTIONS(6140),
    [anon_sym_This] = ACTIONS(6140),
    [anon_sym_decltype] = ACTIONS(6140),
    [anon_sym_explicit] = ACTIONS(6140),
    [anon_sym_typename] = ACTIONS(6140),
    [anon_sym_private] = ACTIONS(6140),
    [anon_sym_template] = ACTIONS(6140),
    [anon_sym_operator] = ACTIONS(6140),
    [anon_sym_friend] = ACTIONS(6140),
    [anon_sym_public] = ACTIONS(6140),
    [anon_sym_protected] = ACTIONS(6140),
    [anon_sym_static_assert] = ACTIONS(6140),
    [anon_sym_precise] = ACTIONS(6140),
    [anon_sym_shared] = ACTIONS(6140),
    [anon_sym_groupshared] = ACTIONS(6140),
    [anon_sym_uniform] = ACTIONS(6140),
    [anon_sym_row_major] = ACTIONS(6140),
    [anon_sym_column_major] = ACTIONS(6140),
    [anon_sym_globallycoherent] = ACTIONS(6140),
    [anon_sym_centroid] = ACTIONS(6140),
    [anon_sym_noperspective] = ACTIONS(6140),
    [anon_sym_nointerpolation] = ACTIONS(6140),
    [anon_sym_sample] = ACTIONS(6140),
    [anon_sym_linear] = ACTIONS(6140),
    [anon_sym_snorm] = ACTIONS(6140),
    [anon_sym_unorm] = ACTIONS(6140),
    [anon_sym_point] = ACTIONS(6140),
    [anon_sym_line] = ACTIONS(6140),
    [anon_sym_triangleadj] = ACTIONS(6140),
    [anon_sym_lineadj] = ACTIONS(6140),
    [anon_sym_triangle] = ACTIONS(6140),
    [anon_sym_interface] = ACTIONS(6140),
    [anon_sym_extension] = ACTIONS(6140),
    [anon_sym___init] = ACTIONS(6140),
    [anon_sym___subscript] = ACTIONS(6140),
    [anon_sym_property] = ACTIONS(6140),
    [anon_sym_associatedtype] = ACTIONS(6140),
  },
  [1667] = {
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token2] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [aux_sym_preproc_else_token1] = ACTIONS(3812),
    [aux_sym_preproc_elif_token1] = ACTIONS(3812),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_private] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_friend] = ACTIONS(3812),
    [anon_sym_public] = ACTIONS(3812),
    [anon_sym_protected] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
    [anon_sym___init] = ACTIONS(3812),
    [anon_sym___subscript] = ACTIONS(3812),
    [anon_sym_property] = ACTIONS(3812),
    [anon_sym_associatedtype] = ACTIONS(3812),
  },
  [1668] = {
    [sym_identifier] = ACTIONS(6144),
    [anon_sym_COMMA] = ACTIONS(6146),
    [anon_sym_RPAREN] = ACTIONS(6146),
    [anon_sym_LPAREN2] = ACTIONS(6146),
    [anon_sym_TILDE] = ACTIONS(6146),
    [anon_sym_STAR] = ACTIONS(6146),
    [anon_sym_PIPE_PIPE] = ACTIONS(6146),
    [anon_sym_AMP_AMP] = ACTIONS(6146),
    [anon_sym_AMP] = ACTIONS(6144),
    [anon_sym___extension__] = ACTIONS(6144),
    [anon_sym_in] = ACTIONS(6144),
    [anon_sym_out] = ACTIONS(6144),
    [anon_sym_inout] = ACTIONS(6144),
    [anon_sym_virtual] = ACTIONS(6144),
    [anon_sym_extern] = ACTIONS(6144),
    [anon_sym___attribute__] = ACTIONS(6144),
    [anon_sym___attribute] = ACTIONS(6144),
    [anon_sym_using] = ACTIONS(6144),
    [anon_sym_COLON_COLON] = ACTIONS(6146),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6146),
    [anon_sym___declspec] = ACTIONS(6144),
    [anon_sym___based] = ACTIONS(6144),
    [anon_sym___cdecl] = ACTIONS(6144),
    [anon_sym___clrcall] = ACTIONS(6144),
    [anon_sym___stdcall] = ACTIONS(6144),
    [anon_sym___fastcall] = ACTIONS(6144),
    [anon_sym___thiscall] = ACTIONS(6144),
    [anon_sym___vectorcall] = ACTIONS(6144),
    [anon_sym_LBRACE] = ACTIONS(6146),
    [anon_sym_signed] = ACTIONS(6144),
    [anon_sym_unsigned] = ACTIONS(6144),
    [anon_sym_long] = ACTIONS(6144),
    [anon_sym_short] = ACTIONS(6144),
    [anon_sym_LBRACK] = ACTIONS(6144),
    [anon_sym_static] = ACTIONS(6144),
    [anon_sym_register] = ACTIONS(6144),
    [anon_sym_inline] = ACTIONS(6144),
    [anon_sym___inline] = ACTIONS(6144),
    [anon_sym___inline__] = ACTIONS(6144),
    [anon_sym___forceinline] = ACTIONS(6144),
    [anon_sym_thread_local] = ACTIONS(6144),
    [anon_sym___thread] = ACTIONS(6144),
    [anon_sym_const] = ACTIONS(6144),
    [anon_sym_constexpr] = ACTIONS(6144),
    [anon_sym_volatile] = ACTIONS(6144),
    [anon_sym_restrict] = ACTIONS(6144),
    [anon_sym___restrict__] = ACTIONS(6144),
    [anon_sym__Atomic] = ACTIONS(6144),
    [anon_sym__Noreturn] = ACTIONS(6144),
    [anon_sym_noreturn] = ACTIONS(6144),
    [anon_sym__Nonnull] = ACTIONS(6144),
    [anon_sym_mutable] = ACTIONS(6144),
    [anon_sym_constinit] = ACTIONS(6144),
    [anon_sym_consteval] = ACTIONS(6144),
    [anon_sym_alignas] = ACTIONS(6144),
    [anon_sym__Alignas] = ACTIONS(6144),
    [sym_primitive_type] = ACTIONS(6144),
    [anon_sym_enum] = ACTIONS(6144),
    [anon_sym_class] = ACTIONS(6144),
    [anon_sym_struct] = ACTIONS(6144),
    [anon_sym_union] = ACTIONS(6144),
    [anon_sym_or] = ACTIONS(6144),
    [anon_sym_and] = ACTIONS(6144),
    [anon_sym_DASH_GT] = ACTIONS(6146),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6144),
    [anon_sym_let] = ACTIONS(6144),
    [anon_sym_This] = ACTIONS(6144),
    [anon_sym_decltype] = ACTIONS(6144),
    [anon_sym_final] = ACTIONS(6144),
    [anon_sym_override] = ACTIONS(6144),
    [anon_sym_explicit] = ACTIONS(6144),
    [anon_sym_typename] = ACTIONS(6144),
    [anon_sym_template] = ACTIONS(6144),
    [anon_sym_operator] = ACTIONS(6144),
    [anon_sym_friend] = ACTIONS(6144),
    [anon_sym_noexcept] = ACTIONS(6144),
    [anon_sym_throw] = ACTIONS(6144),
    [anon_sym_concept] = ACTIONS(6144),
    [anon_sym_requires] = ACTIONS(6144),
    [anon_sym_precise] = ACTIONS(6144),
    [anon_sym_shared] = ACTIONS(6144),
    [anon_sym_groupshared] = ACTIONS(6144),
    [anon_sym_uniform] = ACTIONS(6144),
    [anon_sym_row_major] = ACTIONS(6144),
    [anon_sym_column_major] = ACTIONS(6144),
    [anon_sym_globallycoherent] = ACTIONS(6144),
    [anon_sym_centroid] = ACTIONS(6144),
    [anon_sym_noperspective] = ACTIONS(6144),
    [anon_sym_nointerpolation] = ACTIONS(6144),
    [anon_sym_sample] = ACTIONS(6144),
    [anon_sym_linear] = ACTIONS(6144),
    [anon_sym_snorm] = ACTIONS(6144),
    [anon_sym_unorm] = ACTIONS(6144),
    [anon_sym_point] = ACTIONS(6144),
    [anon_sym_line] = ACTIONS(6144),
    [anon_sym_triangleadj] = ACTIONS(6144),
    [anon_sym_lineadj] = ACTIONS(6144),
    [anon_sym_triangle] = ACTIONS(6144),
    [anon_sym_interface] = ACTIONS(6144),
    [anon_sym_extension] = ACTIONS(6144),
    [anon_sym_where] = ACTIONS(6144),
  },
  [1669] = {
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token2] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [aux_sym_preproc_else_token1] = ACTIONS(3942),
    [aux_sym_preproc_elif_token1] = ACTIONS(3942),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_private] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_friend] = ACTIONS(3942),
    [anon_sym_public] = ACTIONS(3942),
    [anon_sym_protected] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
    [anon_sym___init] = ACTIONS(3942),
    [anon_sym___subscript] = ACTIONS(3942),
    [anon_sym_property] = ACTIONS(3942),
    [anon_sym_associatedtype] = ACTIONS(3942),
  },
  [1670] = {
    [sym_identifier] = ACTIONS(6148),
    [aux_sym_preproc_def_token1] = ACTIONS(6148),
    [aux_sym_preproc_if_token1] = ACTIONS(6148),
    [aux_sym_preproc_if_token2] = ACTIONS(6148),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6148),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6148),
    [aux_sym_preproc_else_token1] = ACTIONS(6148),
    [aux_sym_preproc_elif_token1] = ACTIONS(6148),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6148),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6148),
    [sym_preproc_directive] = ACTIONS(6148),
    [anon_sym_LPAREN2] = ACTIONS(6150),
    [anon_sym_TILDE] = ACTIONS(6150),
    [anon_sym_STAR] = ACTIONS(6150),
    [anon_sym_AMP_AMP] = ACTIONS(6150),
    [anon_sym_AMP] = ACTIONS(6148),
    [anon_sym_SEMI] = ACTIONS(6150),
    [anon_sym___extension__] = ACTIONS(6148),
    [anon_sym_typedef] = ACTIONS(6148),
    [anon_sym_in] = ACTIONS(6148),
    [anon_sym_out] = ACTIONS(6148),
    [anon_sym_inout] = ACTIONS(6148),
    [anon_sym_virtual] = ACTIONS(6148),
    [anon_sym_extern] = ACTIONS(6148),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym___attribute] = ACTIONS(6148),
    [anon_sym_using] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6150),
    [anon_sym___declspec] = ACTIONS(6148),
    [anon_sym___based] = ACTIONS(6148),
    [anon_sym_signed] = ACTIONS(6148),
    [anon_sym_unsigned] = ACTIONS(6148),
    [anon_sym_long] = ACTIONS(6148),
    [anon_sym_short] = ACTIONS(6148),
    [anon_sym_LBRACK] = ACTIONS(6148),
    [anon_sym_static] = ACTIONS(6148),
    [anon_sym_register] = ACTIONS(6148),
    [anon_sym_inline] = ACTIONS(6148),
    [anon_sym___inline] = ACTIONS(6148),
    [anon_sym___inline__] = ACTIONS(6148),
    [anon_sym___forceinline] = ACTIONS(6148),
    [anon_sym_thread_local] = ACTIONS(6148),
    [anon_sym___thread] = ACTIONS(6148),
    [anon_sym_const] = ACTIONS(6148),
    [anon_sym_constexpr] = ACTIONS(6148),
    [anon_sym_volatile] = ACTIONS(6148),
    [anon_sym_restrict] = ACTIONS(6148),
    [anon_sym___restrict__] = ACTIONS(6148),
    [anon_sym__Atomic] = ACTIONS(6148),
    [anon_sym__Noreturn] = ACTIONS(6148),
    [anon_sym_noreturn] = ACTIONS(6148),
    [anon_sym__Nonnull] = ACTIONS(6148),
    [anon_sym_mutable] = ACTIONS(6148),
    [anon_sym_constinit] = ACTIONS(6148),
    [anon_sym_consteval] = ACTIONS(6148),
    [anon_sym_alignas] = ACTIONS(6148),
    [anon_sym__Alignas] = ACTIONS(6148),
    [sym_primitive_type] = ACTIONS(6148),
    [anon_sym_enum] = ACTIONS(6148),
    [anon_sym_class] = ACTIONS(6148),
    [anon_sym_struct] = ACTIONS(6148),
    [anon_sym_union] = ACTIONS(6148),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6148),
    [anon_sym_let] = ACTIONS(6148),
    [anon_sym_This] = ACTIONS(6148),
    [anon_sym_decltype] = ACTIONS(6148),
    [anon_sym_explicit] = ACTIONS(6148),
    [anon_sym_typename] = ACTIONS(6148),
    [anon_sym_private] = ACTIONS(6148),
    [anon_sym_template] = ACTIONS(6148),
    [anon_sym_operator] = ACTIONS(6148),
    [anon_sym_friend] = ACTIONS(6148),
    [anon_sym_public] = ACTIONS(6148),
    [anon_sym_protected] = ACTIONS(6148),
    [anon_sym_static_assert] = ACTIONS(6148),
    [anon_sym_precise] = ACTIONS(6148),
    [anon_sym_shared] = ACTIONS(6148),
    [anon_sym_groupshared] = ACTIONS(6148),
    [anon_sym_uniform] = ACTIONS(6148),
    [anon_sym_row_major] = ACTIONS(6148),
    [anon_sym_column_major] = ACTIONS(6148),
    [anon_sym_globallycoherent] = ACTIONS(6148),
    [anon_sym_centroid] = ACTIONS(6148),
    [anon_sym_noperspective] = ACTIONS(6148),
    [anon_sym_nointerpolation] = ACTIONS(6148),
    [anon_sym_sample] = ACTIONS(6148),
    [anon_sym_linear] = ACTIONS(6148),
    [anon_sym_snorm] = ACTIONS(6148),
    [anon_sym_unorm] = ACTIONS(6148),
    [anon_sym_point] = ACTIONS(6148),
    [anon_sym_line] = ACTIONS(6148),
    [anon_sym_triangleadj] = ACTIONS(6148),
    [anon_sym_lineadj] = ACTIONS(6148),
    [anon_sym_triangle] = ACTIONS(6148),
    [anon_sym_interface] = ACTIONS(6148),
    [anon_sym_extension] = ACTIONS(6148),
    [anon_sym___init] = ACTIONS(6148),
    [anon_sym___subscript] = ACTIONS(6148),
    [anon_sym_property] = ACTIONS(6148),
    [anon_sym_associatedtype] = ACTIONS(6148),
  },
  [1671] = {
    [sym_identifier] = ACTIONS(6152),
    [aux_sym_preproc_def_token1] = ACTIONS(6152),
    [aux_sym_preproc_if_token1] = ACTIONS(6152),
    [aux_sym_preproc_if_token2] = ACTIONS(6152),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6152),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6152),
    [aux_sym_preproc_else_token1] = ACTIONS(6152),
    [aux_sym_preproc_elif_token1] = ACTIONS(6152),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6152),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6152),
    [sym_preproc_directive] = ACTIONS(6152),
    [anon_sym_LPAREN2] = ACTIONS(6154),
    [anon_sym_TILDE] = ACTIONS(6154),
    [anon_sym_STAR] = ACTIONS(6154),
    [anon_sym_AMP_AMP] = ACTIONS(6154),
    [anon_sym_AMP] = ACTIONS(6152),
    [anon_sym_SEMI] = ACTIONS(6154),
    [anon_sym___extension__] = ACTIONS(6152),
    [anon_sym_typedef] = ACTIONS(6152),
    [anon_sym_in] = ACTIONS(6152),
    [anon_sym_out] = ACTIONS(6152),
    [anon_sym_inout] = ACTIONS(6152),
    [anon_sym_virtual] = ACTIONS(6152),
    [anon_sym_extern] = ACTIONS(6152),
    [anon_sym___attribute__] = ACTIONS(6152),
    [anon_sym___attribute] = ACTIONS(6152),
    [anon_sym_using] = ACTIONS(6152),
    [anon_sym_COLON_COLON] = ACTIONS(6154),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6154),
    [anon_sym___declspec] = ACTIONS(6152),
    [anon_sym___based] = ACTIONS(6152),
    [anon_sym_signed] = ACTIONS(6152),
    [anon_sym_unsigned] = ACTIONS(6152),
    [anon_sym_long] = ACTIONS(6152),
    [anon_sym_short] = ACTIONS(6152),
    [anon_sym_LBRACK] = ACTIONS(6152),
    [anon_sym_static] = ACTIONS(6152),
    [anon_sym_register] = ACTIONS(6152),
    [anon_sym_inline] = ACTIONS(6152),
    [anon_sym___inline] = ACTIONS(6152),
    [anon_sym___inline__] = ACTIONS(6152),
    [anon_sym___forceinline] = ACTIONS(6152),
    [anon_sym_thread_local] = ACTIONS(6152),
    [anon_sym___thread] = ACTIONS(6152),
    [anon_sym_const] = ACTIONS(6152),
    [anon_sym_constexpr] = ACTIONS(6152),
    [anon_sym_volatile] = ACTIONS(6152),
    [anon_sym_restrict] = ACTIONS(6152),
    [anon_sym___restrict__] = ACTIONS(6152),
    [anon_sym__Atomic] = ACTIONS(6152),
    [anon_sym__Noreturn] = ACTIONS(6152),
    [anon_sym_noreturn] = ACTIONS(6152),
    [anon_sym__Nonnull] = ACTIONS(6152),
    [anon_sym_mutable] = ACTIONS(6152),
    [anon_sym_constinit] = ACTIONS(6152),
    [anon_sym_consteval] = ACTIONS(6152),
    [anon_sym_alignas] = ACTIONS(6152),
    [anon_sym__Alignas] = ACTIONS(6152),
    [sym_primitive_type] = ACTIONS(6152),
    [anon_sym_enum] = ACTIONS(6152),
    [anon_sym_class] = ACTIONS(6152),
    [anon_sym_struct] = ACTIONS(6152),
    [anon_sym_union] = ACTIONS(6152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6152),
    [anon_sym_let] = ACTIONS(6152),
    [anon_sym_This] = ACTIONS(6152),
    [anon_sym_decltype] = ACTIONS(6152),
    [anon_sym_explicit] = ACTIONS(6152),
    [anon_sym_typename] = ACTIONS(6152),
    [anon_sym_private] = ACTIONS(6152),
    [anon_sym_template] = ACTIONS(6152),
    [anon_sym_operator] = ACTIONS(6152),
    [anon_sym_friend] = ACTIONS(6152),
    [anon_sym_public] = ACTIONS(6152),
    [anon_sym_protected] = ACTIONS(6152),
    [anon_sym_static_assert] = ACTIONS(6152),
    [anon_sym_precise] = ACTIONS(6152),
    [anon_sym_shared] = ACTIONS(6152),
    [anon_sym_groupshared] = ACTIONS(6152),
    [anon_sym_uniform] = ACTIONS(6152),
    [anon_sym_row_major] = ACTIONS(6152),
    [anon_sym_column_major] = ACTIONS(6152),
    [anon_sym_globallycoherent] = ACTIONS(6152),
    [anon_sym_centroid] = ACTIONS(6152),
    [anon_sym_noperspective] = ACTIONS(6152),
    [anon_sym_nointerpolation] = ACTIONS(6152),
    [anon_sym_sample] = ACTIONS(6152),
    [anon_sym_linear] = ACTIONS(6152),
    [anon_sym_snorm] = ACTIONS(6152),
    [anon_sym_unorm] = ACTIONS(6152),
    [anon_sym_point] = ACTIONS(6152),
    [anon_sym_line] = ACTIONS(6152),
    [anon_sym_triangleadj] = ACTIONS(6152),
    [anon_sym_lineadj] = ACTIONS(6152),
    [anon_sym_triangle] = ACTIONS(6152),
    [anon_sym_interface] = ACTIONS(6152),
    [anon_sym_extension] = ACTIONS(6152),
    [anon_sym___init] = ACTIONS(6152),
    [anon_sym___subscript] = ACTIONS(6152),
    [anon_sym_property] = ACTIONS(6152),
    [anon_sym_associatedtype] = ACTIONS(6152),
  },
  [1672] = {
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token2] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [aux_sym_preproc_else_token1] = ACTIONS(3942),
    [aux_sym_preproc_elif_token1] = ACTIONS(3942),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_private] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_friend] = ACTIONS(3942),
    [anon_sym_public] = ACTIONS(3942),
    [anon_sym_protected] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
    [anon_sym___init] = ACTIONS(3942),
    [anon_sym___subscript] = ACTIONS(3942),
    [anon_sym_property] = ACTIONS(3942),
    [anon_sym_associatedtype] = ACTIONS(3942),
  },
  [1673] = {
    [sym_identifier] = ACTIONS(3953),
    [aux_sym_preproc_def_token1] = ACTIONS(3953),
    [aux_sym_preproc_if_token1] = ACTIONS(3953),
    [aux_sym_preproc_if_token2] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3953),
    [aux_sym_preproc_else_token1] = ACTIONS(3953),
    [aux_sym_preproc_elif_token1] = ACTIONS(3953),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3953),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3953),
    [sym_preproc_directive] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_TILDE] = ACTIONS(3955),
    [anon_sym_STAR] = ACTIONS(3955),
    [anon_sym_AMP_AMP] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_SEMI] = ACTIONS(3955),
    [anon_sym___extension__] = ACTIONS(3953),
    [anon_sym_typedef] = ACTIONS(3953),
    [anon_sym_in] = ACTIONS(3953),
    [anon_sym_out] = ACTIONS(3953),
    [anon_sym_inout] = ACTIONS(3953),
    [anon_sym_virtual] = ACTIONS(3953),
    [anon_sym_extern] = ACTIONS(3953),
    [anon_sym___attribute__] = ACTIONS(3953),
    [anon_sym___attribute] = ACTIONS(3953),
    [anon_sym_using] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3955),
    [anon_sym___declspec] = ACTIONS(3953),
    [anon_sym___based] = ACTIONS(3953),
    [anon_sym_signed] = ACTIONS(3953),
    [anon_sym_unsigned] = ACTIONS(3953),
    [anon_sym_long] = ACTIONS(3953),
    [anon_sym_short] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_static] = ACTIONS(3953),
    [anon_sym_register] = ACTIONS(3953),
    [anon_sym_inline] = ACTIONS(3953),
    [anon_sym___inline] = ACTIONS(3953),
    [anon_sym___inline__] = ACTIONS(3953),
    [anon_sym___forceinline] = ACTIONS(3953),
    [anon_sym_thread_local] = ACTIONS(3953),
    [anon_sym___thread] = ACTIONS(3953),
    [anon_sym_const] = ACTIONS(3953),
    [anon_sym_constexpr] = ACTIONS(3953),
    [anon_sym_volatile] = ACTIONS(3953),
    [anon_sym_restrict] = ACTIONS(3953),
    [anon_sym___restrict__] = ACTIONS(3953),
    [anon_sym__Atomic] = ACTIONS(3953),
    [anon_sym__Noreturn] = ACTIONS(3953),
    [anon_sym_noreturn] = ACTIONS(3953),
    [anon_sym__Nonnull] = ACTIONS(3953),
    [anon_sym_mutable] = ACTIONS(3953),
    [anon_sym_constinit] = ACTIONS(3953),
    [anon_sym_consteval] = ACTIONS(3953),
    [anon_sym_alignas] = ACTIONS(3953),
    [anon_sym__Alignas] = ACTIONS(3953),
    [sym_primitive_type] = ACTIONS(3953),
    [anon_sym_enum] = ACTIONS(3953),
    [anon_sym_class] = ACTIONS(3953),
    [anon_sym_struct] = ACTIONS(3953),
    [anon_sym_union] = ACTIONS(3953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_This] = ACTIONS(3953),
    [anon_sym_decltype] = ACTIONS(3953),
    [anon_sym_explicit] = ACTIONS(3953),
    [anon_sym_typename] = ACTIONS(3953),
    [anon_sym_private] = ACTIONS(3953),
    [anon_sym_template] = ACTIONS(3953),
    [anon_sym_operator] = ACTIONS(3953),
    [anon_sym_friend] = ACTIONS(3953),
    [anon_sym_public] = ACTIONS(3953),
    [anon_sym_protected] = ACTIONS(3953),
    [anon_sym_static_assert] = ACTIONS(3953),
    [anon_sym_precise] = ACTIONS(3953),
    [anon_sym_shared] = ACTIONS(3953),
    [anon_sym_groupshared] = ACTIONS(3953),
    [anon_sym_uniform] = ACTIONS(3953),
    [anon_sym_row_major] = ACTIONS(3953),
    [anon_sym_column_major] = ACTIONS(3953),
    [anon_sym_globallycoherent] = ACTIONS(3953),
    [anon_sym_centroid] = ACTIONS(3953),
    [anon_sym_noperspective] = ACTIONS(3953),
    [anon_sym_nointerpolation] = ACTIONS(3953),
    [anon_sym_sample] = ACTIONS(3953),
    [anon_sym_linear] = ACTIONS(3953),
    [anon_sym_snorm] = ACTIONS(3953),
    [anon_sym_unorm] = ACTIONS(3953),
    [anon_sym_point] = ACTIONS(3953),
    [anon_sym_line] = ACTIONS(3953),
    [anon_sym_triangleadj] = ACTIONS(3953),
    [anon_sym_lineadj] = ACTIONS(3953),
    [anon_sym_triangle] = ACTIONS(3953),
    [anon_sym_interface] = ACTIONS(3953),
    [anon_sym_extension] = ACTIONS(3953),
    [anon_sym___init] = ACTIONS(3953),
    [anon_sym___subscript] = ACTIONS(3953),
    [anon_sym_property] = ACTIONS(3953),
    [anon_sym_associatedtype] = ACTIONS(3953),
  },
  [1674] = {
    [sym_identifier] = ACTIONS(6156),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(6158),
    [anon_sym_LPAREN2] = ACTIONS(6158),
    [anon_sym_TILDE] = ACTIONS(6158),
    [anon_sym_STAR] = ACTIONS(6158),
    [anon_sym_PIPE_PIPE] = ACTIONS(6158),
    [anon_sym_AMP_AMP] = ACTIONS(6158),
    [anon_sym_AMP] = ACTIONS(6156),
    [anon_sym___extension__] = ACTIONS(6156),
    [anon_sym_in] = ACTIONS(6156),
    [anon_sym_out] = ACTIONS(6156),
    [anon_sym_inout] = ACTIONS(6156),
    [anon_sym_virtual] = ACTIONS(6156),
    [anon_sym_extern] = ACTIONS(6156),
    [anon_sym___attribute__] = ACTIONS(6156),
    [anon_sym___attribute] = ACTIONS(6156),
    [anon_sym_using] = ACTIONS(6156),
    [anon_sym_COLON_COLON] = ACTIONS(6158),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6158),
    [anon_sym___declspec] = ACTIONS(6156),
    [anon_sym___based] = ACTIONS(6156),
    [anon_sym___cdecl] = ACTIONS(6156),
    [anon_sym___clrcall] = ACTIONS(6156),
    [anon_sym___stdcall] = ACTIONS(6156),
    [anon_sym___fastcall] = ACTIONS(6156),
    [anon_sym___thiscall] = ACTIONS(6156),
    [anon_sym___vectorcall] = ACTIONS(6156),
    [anon_sym_LBRACE] = ACTIONS(6158),
    [anon_sym_signed] = ACTIONS(6156),
    [anon_sym_unsigned] = ACTIONS(6156),
    [anon_sym_long] = ACTIONS(6156),
    [anon_sym_short] = ACTIONS(6156),
    [anon_sym_LBRACK] = ACTIONS(6156),
    [anon_sym_static] = ACTIONS(6156),
    [anon_sym_register] = ACTIONS(6156),
    [anon_sym_inline] = ACTIONS(6156),
    [anon_sym___inline] = ACTIONS(6156),
    [anon_sym___inline__] = ACTIONS(6156),
    [anon_sym___forceinline] = ACTIONS(6156),
    [anon_sym_thread_local] = ACTIONS(6156),
    [anon_sym___thread] = ACTIONS(6156),
    [anon_sym_const] = ACTIONS(6156),
    [anon_sym_constexpr] = ACTIONS(6156),
    [anon_sym_volatile] = ACTIONS(6156),
    [anon_sym_restrict] = ACTIONS(6156),
    [anon_sym___restrict__] = ACTIONS(6156),
    [anon_sym__Atomic] = ACTIONS(6156),
    [anon_sym__Noreturn] = ACTIONS(6156),
    [anon_sym_noreturn] = ACTIONS(6156),
    [anon_sym__Nonnull] = ACTIONS(6156),
    [anon_sym_mutable] = ACTIONS(6156),
    [anon_sym_constinit] = ACTIONS(6156),
    [anon_sym_consteval] = ACTIONS(6156),
    [anon_sym_alignas] = ACTIONS(6156),
    [anon_sym__Alignas] = ACTIONS(6156),
    [sym_primitive_type] = ACTIONS(6156),
    [anon_sym_enum] = ACTIONS(6156),
    [anon_sym_class] = ACTIONS(6156),
    [anon_sym_struct] = ACTIONS(6156),
    [anon_sym_union] = ACTIONS(6156),
    [anon_sym_or] = ACTIONS(6156),
    [anon_sym_and] = ACTIONS(6156),
    [anon_sym_DASH_GT] = ACTIONS(6158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6156),
    [anon_sym_let] = ACTIONS(6156),
    [anon_sym_This] = ACTIONS(6156),
    [anon_sym_decltype] = ACTIONS(6156),
    [anon_sym_final] = ACTIONS(6156),
    [anon_sym_override] = ACTIONS(6156),
    [anon_sym_explicit] = ACTIONS(6156),
    [anon_sym_typename] = ACTIONS(6156),
    [anon_sym_template] = ACTIONS(6156),
    [anon_sym_operator] = ACTIONS(6156),
    [anon_sym_friend] = ACTIONS(6156),
    [anon_sym_noexcept] = ACTIONS(6156),
    [anon_sym_throw] = ACTIONS(6156),
    [anon_sym_concept] = ACTIONS(6156),
    [anon_sym_requires] = ACTIONS(6156),
    [anon_sym_precise] = ACTIONS(6156),
    [anon_sym_shared] = ACTIONS(6156),
    [anon_sym_groupshared] = ACTIONS(6156),
    [anon_sym_uniform] = ACTIONS(6156),
    [anon_sym_row_major] = ACTIONS(6156),
    [anon_sym_column_major] = ACTIONS(6156),
    [anon_sym_globallycoherent] = ACTIONS(6156),
    [anon_sym_centroid] = ACTIONS(6156),
    [anon_sym_noperspective] = ACTIONS(6156),
    [anon_sym_nointerpolation] = ACTIONS(6156),
    [anon_sym_sample] = ACTIONS(6156),
    [anon_sym_linear] = ACTIONS(6156),
    [anon_sym_snorm] = ACTIONS(6156),
    [anon_sym_unorm] = ACTIONS(6156),
    [anon_sym_point] = ACTIONS(6156),
    [anon_sym_line] = ACTIONS(6156),
    [anon_sym_triangleadj] = ACTIONS(6156),
    [anon_sym_lineadj] = ACTIONS(6156),
    [anon_sym_triangle] = ACTIONS(6156),
    [anon_sym_interface] = ACTIONS(6156),
    [anon_sym_extension] = ACTIONS(6156),
    [anon_sym_where] = ACTIONS(6156),
  },
  [1675] = {
    [sym_identifier] = ACTIONS(6160),
    [anon_sym_COMMA] = ACTIONS(6162),
    [anon_sym_RPAREN] = ACTIONS(6162),
    [anon_sym_LPAREN2] = ACTIONS(6162),
    [anon_sym_TILDE] = ACTIONS(6162),
    [anon_sym_STAR] = ACTIONS(6162),
    [anon_sym_PIPE_PIPE] = ACTIONS(6162),
    [anon_sym_AMP_AMP] = ACTIONS(6162),
    [anon_sym_AMP] = ACTIONS(6160),
    [anon_sym___extension__] = ACTIONS(6160),
    [anon_sym_in] = ACTIONS(6160),
    [anon_sym_out] = ACTIONS(6160),
    [anon_sym_inout] = ACTIONS(6160),
    [anon_sym_virtual] = ACTIONS(6160),
    [anon_sym_extern] = ACTIONS(6160),
    [anon_sym___attribute__] = ACTIONS(6160),
    [anon_sym___attribute] = ACTIONS(6160),
    [anon_sym_using] = ACTIONS(6160),
    [anon_sym_COLON_COLON] = ACTIONS(6162),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6162),
    [anon_sym___declspec] = ACTIONS(6160),
    [anon_sym___based] = ACTIONS(6160),
    [anon_sym___cdecl] = ACTIONS(6160),
    [anon_sym___clrcall] = ACTIONS(6160),
    [anon_sym___stdcall] = ACTIONS(6160),
    [anon_sym___fastcall] = ACTIONS(6160),
    [anon_sym___thiscall] = ACTIONS(6160),
    [anon_sym___vectorcall] = ACTIONS(6160),
    [anon_sym_LBRACE] = ACTIONS(6162),
    [anon_sym_signed] = ACTIONS(6160),
    [anon_sym_unsigned] = ACTIONS(6160),
    [anon_sym_long] = ACTIONS(6160),
    [anon_sym_short] = ACTIONS(6160),
    [anon_sym_LBRACK] = ACTIONS(6160),
    [anon_sym_static] = ACTIONS(6160),
    [anon_sym_register] = ACTIONS(6160),
    [anon_sym_inline] = ACTIONS(6160),
    [anon_sym___inline] = ACTIONS(6160),
    [anon_sym___inline__] = ACTIONS(6160),
    [anon_sym___forceinline] = ACTIONS(6160),
    [anon_sym_thread_local] = ACTIONS(6160),
    [anon_sym___thread] = ACTIONS(6160),
    [anon_sym_const] = ACTIONS(6160),
    [anon_sym_constexpr] = ACTIONS(6160),
    [anon_sym_volatile] = ACTIONS(6160),
    [anon_sym_restrict] = ACTIONS(6160),
    [anon_sym___restrict__] = ACTIONS(6160),
    [anon_sym__Atomic] = ACTIONS(6160),
    [anon_sym__Noreturn] = ACTIONS(6160),
    [anon_sym_noreturn] = ACTIONS(6160),
    [anon_sym__Nonnull] = ACTIONS(6160),
    [anon_sym_mutable] = ACTIONS(6160),
    [anon_sym_constinit] = ACTIONS(6160),
    [anon_sym_consteval] = ACTIONS(6160),
    [anon_sym_alignas] = ACTIONS(6160),
    [anon_sym__Alignas] = ACTIONS(6160),
    [sym_primitive_type] = ACTIONS(6160),
    [anon_sym_enum] = ACTIONS(6160),
    [anon_sym_class] = ACTIONS(6160),
    [anon_sym_struct] = ACTIONS(6160),
    [anon_sym_union] = ACTIONS(6160),
    [anon_sym_or] = ACTIONS(6160),
    [anon_sym_and] = ACTIONS(6160),
    [anon_sym_DASH_GT] = ACTIONS(6162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6160),
    [anon_sym_let] = ACTIONS(6160),
    [anon_sym_This] = ACTIONS(6160),
    [anon_sym_decltype] = ACTIONS(6160),
    [anon_sym_final] = ACTIONS(6160),
    [anon_sym_override] = ACTIONS(6160),
    [anon_sym_explicit] = ACTIONS(6160),
    [anon_sym_typename] = ACTIONS(6160),
    [anon_sym_template] = ACTIONS(6160),
    [anon_sym_operator] = ACTIONS(6160),
    [anon_sym_friend] = ACTIONS(6160),
    [anon_sym_noexcept] = ACTIONS(6160),
    [anon_sym_throw] = ACTIONS(6160),
    [anon_sym_concept] = ACTIONS(6160),
    [anon_sym_requires] = ACTIONS(6160),
    [anon_sym_precise] = ACTIONS(6160),
    [anon_sym_shared] = ACTIONS(6160),
    [anon_sym_groupshared] = ACTIONS(6160),
    [anon_sym_uniform] = ACTIONS(6160),
    [anon_sym_row_major] = ACTIONS(6160),
    [anon_sym_column_major] = ACTIONS(6160),
    [anon_sym_globallycoherent] = ACTIONS(6160),
    [anon_sym_centroid] = ACTIONS(6160),
    [anon_sym_noperspective] = ACTIONS(6160),
    [anon_sym_nointerpolation] = ACTIONS(6160),
    [anon_sym_sample] = ACTIONS(6160),
    [anon_sym_linear] = ACTIONS(6160),
    [anon_sym_snorm] = ACTIONS(6160),
    [anon_sym_unorm] = ACTIONS(6160),
    [anon_sym_point] = ACTIONS(6160),
    [anon_sym_line] = ACTIONS(6160),
    [anon_sym_triangleadj] = ACTIONS(6160),
    [anon_sym_lineadj] = ACTIONS(6160),
    [anon_sym_triangle] = ACTIONS(6160),
    [anon_sym_interface] = ACTIONS(6160),
    [anon_sym_extension] = ACTIONS(6160),
    [anon_sym_where] = ACTIONS(6160),
  },
  [1676] = {
    [sym_identifier] = ACTIONS(6164),
    [anon_sym_COMMA] = ACTIONS(6166),
    [anon_sym_RPAREN] = ACTIONS(6166),
    [anon_sym_LPAREN2] = ACTIONS(6166),
    [anon_sym_TILDE] = ACTIONS(6166),
    [anon_sym_STAR] = ACTIONS(6166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6166),
    [anon_sym_AMP_AMP] = ACTIONS(6166),
    [anon_sym_AMP] = ACTIONS(6164),
    [anon_sym___extension__] = ACTIONS(6164),
    [anon_sym_in] = ACTIONS(6164),
    [anon_sym_out] = ACTIONS(6164),
    [anon_sym_inout] = ACTIONS(6164),
    [anon_sym_virtual] = ACTIONS(6164),
    [anon_sym_extern] = ACTIONS(6164),
    [anon_sym___attribute__] = ACTIONS(6164),
    [anon_sym___attribute] = ACTIONS(6164),
    [anon_sym_using] = ACTIONS(6164),
    [anon_sym_COLON_COLON] = ACTIONS(6166),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6166),
    [anon_sym___declspec] = ACTIONS(6164),
    [anon_sym___based] = ACTIONS(6164),
    [anon_sym___cdecl] = ACTIONS(6164),
    [anon_sym___clrcall] = ACTIONS(6164),
    [anon_sym___stdcall] = ACTIONS(6164),
    [anon_sym___fastcall] = ACTIONS(6164),
    [anon_sym___thiscall] = ACTIONS(6164),
    [anon_sym___vectorcall] = ACTIONS(6164),
    [anon_sym_LBRACE] = ACTIONS(6166),
    [anon_sym_signed] = ACTIONS(6164),
    [anon_sym_unsigned] = ACTIONS(6164),
    [anon_sym_long] = ACTIONS(6164),
    [anon_sym_short] = ACTIONS(6164),
    [anon_sym_LBRACK] = ACTIONS(6164),
    [anon_sym_static] = ACTIONS(6164),
    [anon_sym_register] = ACTIONS(6164),
    [anon_sym_inline] = ACTIONS(6164),
    [anon_sym___inline] = ACTIONS(6164),
    [anon_sym___inline__] = ACTIONS(6164),
    [anon_sym___forceinline] = ACTIONS(6164),
    [anon_sym_thread_local] = ACTIONS(6164),
    [anon_sym___thread] = ACTIONS(6164),
    [anon_sym_const] = ACTIONS(6164),
    [anon_sym_constexpr] = ACTIONS(6164),
    [anon_sym_volatile] = ACTIONS(6164),
    [anon_sym_restrict] = ACTIONS(6164),
    [anon_sym___restrict__] = ACTIONS(6164),
    [anon_sym__Atomic] = ACTIONS(6164),
    [anon_sym__Noreturn] = ACTIONS(6164),
    [anon_sym_noreturn] = ACTIONS(6164),
    [anon_sym__Nonnull] = ACTIONS(6164),
    [anon_sym_mutable] = ACTIONS(6164),
    [anon_sym_constinit] = ACTIONS(6164),
    [anon_sym_consteval] = ACTIONS(6164),
    [anon_sym_alignas] = ACTIONS(6164),
    [anon_sym__Alignas] = ACTIONS(6164),
    [sym_primitive_type] = ACTIONS(6164),
    [anon_sym_enum] = ACTIONS(6164),
    [anon_sym_class] = ACTIONS(6164),
    [anon_sym_struct] = ACTIONS(6164),
    [anon_sym_union] = ACTIONS(6164),
    [anon_sym_or] = ACTIONS(6164),
    [anon_sym_and] = ACTIONS(6164),
    [anon_sym_DASH_GT] = ACTIONS(6166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6164),
    [anon_sym_let] = ACTIONS(6164),
    [anon_sym_This] = ACTIONS(6164),
    [anon_sym_decltype] = ACTIONS(6164),
    [anon_sym_final] = ACTIONS(6164),
    [anon_sym_override] = ACTIONS(6164),
    [anon_sym_explicit] = ACTIONS(6164),
    [anon_sym_typename] = ACTIONS(6164),
    [anon_sym_template] = ACTIONS(6164),
    [anon_sym_operator] = ACTIONS(6164),
    [anon_sym_friend] = ACTIONS(6164),
    [anon_sym_noexcept] = ACTIONS(6164),
    [anon_sym_throw] = ACTIONS(6164),
    [anon_sym_concept] = ACTIONS(6164),
    [anon_sym_requires] = ACTIONS(6164),
    [anon_sym_precise] = ACTIONS(6164),
    [anon_sym_shared] = ACTIONS(6164),
    [anon_sym_groupshared] = ACTIONS(6164),
    [anon_sym_uniform] = ACTIONS(6164),
    [anon_sym_row_major] = ACTIONS(6164),
    [anon_sym_column_major] = ACTIONS(6164),
    [anon_sym_globallycoherent] = ACTIONS(6164),
    [anon_sym_centroid] = ACTIONS(6164),
    [anon_sym_noperspective] = ACTIONS(6164),
    [anon_sym_nointerpolation] = ACTIONS(6164),
    [anon_sym_sample] = ACTIONS(6164),
    [anon_sym_linear] = ACTIONS(6164),
    [anon_sym_snorm] = ACTIONS(6164),
    [anon_sym_unorm] = ACTIONS(6164),
    [anon_sym_point] = ACTIONS(6164),
    [anon_sym_line] = ACTIONS(6164),
    [anon_sym_triangleadj] = ACTIONS(6164),
    [anon_sym_lineadj] = ACTIONS(6164),
    [anon_sym_triangle] = ACTIONS(6164),
    [anon_sym_interface] = ACTIONS(6164),
    [anon_sym_extension] = ACTIONS(6164),
    [anon_sym_where] = ACTIONS(6164),
  },
  [1677] = {
    [sym_identifier] = ACTIONS(3953),
    [aux_sym_preproc_def_token1] = ACTIONS(3953),
    [aux_sym_preproc_if_token1] = ACTIONS(3953),
    [aux_sym_preproc_if_token2] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3953),
    [aux_sym_preproc_else_token1] = ACTIONS(3953),
    [aux_sym_preproc_elif_token1] = ACTIONS(3953),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3953),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3953),
    [sym_preproc_directive] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_TILDE] = ACTIONS(3955),
    [anon_sym_STAR] = ACTIONS(3955),
    [anon_sym_AMP_AMP] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_SEMI] = ACTIONS(3955),
    [anon_sym___extension__] = ACTIONS(3953),
    [anon_sym_typedef] = ACTIONS(3953),
    [anon_sym_in] = ACTIONS(3953),
    [anon_sym_out] = ACTIONS(3953),
    [anon_sym_inout] = ACTIONS(3953),
    [anon_sym_virtual] = ACTIONS(3953),
    [anon_sym_extern] = ACTIONS(3953),
    [anon_sym___attribute__] = ACTIONS(3953),
    [anon_sym___attribute] = ACTIONS(3953),
    [anon_sym_using] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3955),
    [anon_sym___declspec] = ACTIONS(3953),
    [anon_sym___based] = ACTIONS(3953),
    [anon_sym_signed] = ACTIONS(3953),
    [anon_sym_unsigned] = ACTIONS(3953),
    [anon_sym_long] = ACTIONS(3953),
    [anon_sym_short] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_static] = ACTIONS(3953),
    [anon_sym_register] = ACTIONS(3953),
    [anon_sym_inline] = ACTIONS(3953),
    [anon_sym___inline] = ACTIONS(3953),
    [anon_sym___inline__] = ACTIONS(3953),
    [anon_sym___forceinline] = ACTIONS(3953),
    [anon_sym_thread_local] = ACTIONS(3953),
    [anon_sym___thread] = ACTIONS(3953),
    [anon_sym_const] = ACTIONS(3953),
    [anon_sym_constexpr] = ACTIONS(3953),
    [anon_sym_volatile] = ACTIONS(3953),
    [anon_sym_restrict] = ACTIONS(3953),
    [anon_sym___restrict__] = ACTIONS(3953),
    [anon_sym__Atomic] = ACTIONS(3953),
    [anon_sym__Noreturn] = ACTIONS(3953),
    [anon_sym_noreturn] = ACTIONS(3953),
    [anon_sym__Nonnull] = ACTIONS(3953),
    [anon_sym_mutable] = ACTIONS(3953),
    [anon_sym_constinit] = ACTIONS(3953),
    [anon_sym_consteval] = ACTIONS(3953),
    [anon_sym_alignas] = ACTIONS(3953),
    [anon_sym__Alignas] = ACTIONS(3953),
    [sym_primitive_type] = ACTIONS(3953),
    [anon_sym_enum] = ACTIONS(3953),
    [anon_sym_class] = ACTIONS(3953),
    [anon_sym_struct] = ACTIONS(3953),
    [anon_sym_union] = ACTIONS(3953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_This] = ACTIONS(3953),
    [anon_sym_decltype] = ACTIONS(3953),
    [anon_sym_explicit] = ACTIONS(3953),
    [anon_sym_typename] = ACTIONS(3953),
    [anon_sym_private] = ACTIONS(3953),
    [anon_sym_template] = ACTIONS(3953),
    [anon_sym_operator] = ACTIONS(3953),
    [anon_sym_friend] = ACTIONS(3953),
    [anon_sym_public] = ACTIONS(3953),
    [anon_sym_protected] = ACTIONS(3953),
    [anon_sym_static_assert] = ACTIONS(3953),
    [anon_sym_precise] = ACTIONS(3953),
    [anon_sym_shared] = ACTIONS(3953),
    [anon_sym_groupshared] = ACTIONS(3953),
    [anon_sym_uniform] = ACTIONS(3953),
    [anon_sym_row_major] = ACTIONS(3953),
    [anon_sym_column_major] = ACTIONS(3953),
    [anon_sym_globallycoherent] = ACTIONS(3953),
    [anon_sym_centroid] = ACTIONS(3953),
    [anon_sym_noperspective] = ACTIONS(3953),
    [anon_sym_nointerpolation] = ACTIONS(3953),
    [anon_sym_sample] = ACTIONS(3953),
    [anon_sym_linear] = ACTIONS(3953),
    [anon_sym_snorm] = ACTIONS(3953),
    [anon_sym_unorm] = ACTIONS(3953),
    [anon_sym_point] = ACTIONS(3953),
    [anon_sym_line] = ACTIONS(3953),
    [anon_sym_triangleadj] = ACTIONS(3953),
    [anon_sym_lineadj] = ACTIONS(3953),
    [anon_sym_triangle] = ACTIONS(3953),
    [anon_sym_interface] = ACTIONS(3953),
    [anon_sym_extension] = ACTIONS(3953),
    [anon_sym___init] = ACTIONS(3953),
    [anon_sym___subscript] = ACTIONS(3953),
    [anon_sym_property] = ACTIONS(3953),
    [anon_sym_associatedtype] = ACTIONS(3953),
  },
  [1678] = {
    [sym_identifier] = ACTIONS(3963),
    [aux_sym_preproc_def_token1] = ACTIONS(3963),
    [aux_sym_preproc_if_token1] = ACTIONS(3963),
    [aux_sym_preproc_if_token2] = ACTIONS(3963),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3963),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3963),
    [aux_sym_preproc_else_token1] = ACTIONS(3963),
    [aux_sym_preproc_elif_token1] = ACTIONS(3963),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3963),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3963),
    [sym_preproc_directive] = ACTIONS(3963),
    [anon_sym_LPAREN2] = ACTIONS(3965),
    [anon_sym_TILDE] = ACTIONS(3965),
    [anon_sym_STAR] = ACTIONS(3965),
    [anon_sym_AMP_AMP] = ACTIONS(3965),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_SEMI] = ACTIONS(3965),
    [anon_sym___extension__] = ACTIONS(3963),
    [anon_sym_typedef] = ACTIONS(3963),
    [anon_sym_in] = ACTIONS(3963),
    [anon_sym_out] = ACTIONS(3963),
    [anon_sym_inout] = ACTIONS(3963),
    [anon_sym_virtual] = ACTIONS(3963),
    [anon_sym_extern] = ACTIONS(3963),
    [anon_sym___attribute__] = ACTIONS(3963),
    [anon_sym___attribute] = ACTIONS(3963),
    [anon_sym_using] = ACTIONS(3963),
    [anon_sym_COLON_COLON] = ACTIONS(3965),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3965),
    [anon_sym___declspec] = ACTIONS(3963),
    [anon_sym___based] = ACTIONS(3963),
    [anon_sym_signed] = ACTIONS(3963),
    [anon_sym_unsigned] = ACTIONS(3963),
    [anon_sym_long] = ACTIONS(3963),
    [anon_sym_short] = ACTIONS(3963),
    [anon_sym_LBRACK] = ACTIONS(3963),
    [anon_sym_static] = ACTIONS(3963),
    [anon_sym_register] = ACTIONS(3963),
    [anon_sym_inline] = ACTIONS(3963),
    [anon_sym___inline] = ACTIONS(3963),
    [anon_sym___inline__] = ACTIONS(3963),
    [anon_sym___forceinline] = ACTIONS(3963),
    [anon_sym_thread_local] = ACTIONS(3963),
    [anon_sym___thread] = ACTIONS(3963),
    [anon_sym_const] = ACTIONS(3963),
    [anon_sym_constexpr] = ACTIONS(3963),
    [anon_sym_volatile] = ACTIONS(3963),
    [anon_sym_restrict] = ACTIONS(3963),
    [anon_sym___restrict__] = ACTIONS(3963),
    [anon_sym__Atomic] = ACTIONS(3963),
    [anon_sym__Noreturn] = ACTIONS(3963),
    [anon_sym_noreturn] = ACTIONS(3963),
    [anon_sym__Nonnull] = ACTIONS(3963),
    [anon_sym_mutable] = ACTIONS(3963),
    [anon_sym_constinit] = ACTIONS(3963),
    [anon_sym_consteval] = ACTIONS(3963),
    [anon_sym_alignas] = ACTIONS(3963),
    [anon_sym__Alignas] = ACTIONS(3963),
    [sym_primitive_type] = ACTIONS(3963),
    [anon_sym_enum] = ACTIONS(3963),
    [anon_sym_class] = ACTIONS(3963),
    [anon_sym_struct] = ACTIONS(3963),
    [anon_sym_union] = ACTIONS(3963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3963),
    [anon_sym_let] = ACTIONS(3963),
    [anon_sym_This] = ACTIONS(3963),
    [anon_sym_decltype] = ACTIONS(3963),
    [anon_sym_explicit] = ACTIONS(3963),
    [anon_sym_typename] = ACTIONS(3963),
    [anon_sym_private] = ACTIONS(3963),
    [anon_sym_template] = ACTIONS(3963),
    [anon_sym_operator] = ACTIONS(3963),
    [anon_sym_friend] = ACTIONS(3963),
    [anon_sym_public] = ACTIONS(3963),
    [anon_sym_protected] = ACTIONS(3963),
    [anon_sym_static_assert] = ACTIONS(3963),
    [anon_sym_precise] = ACTIONS(3963),
    [anon_sym_shared] = ACTIONS(3963),
    [anon_sym_groupshared] = ACTIONS(3963),
    [anon_sym_uniform] = ACTIONS(3963),
    [anon_sym_row_major] = ACTIONS(3963),
    [anon_sym_column_major] = ACTIONS(3963),
    [anon_sym_globallycoherent] = ACTIONS(3963),
    [anon_sym_centroid] = ACTIONS(3963),
    [anon_sym_noperspective] = ACTIONS(3963),
    [anon_sym_nointerpolation] = ACTIONS(3963),
    [anon_sym_sample] = ACTIONS(3963),
    [anon_sym_linear] = ACTIONS(3963),
    [anon_sym_snorm] = ACTIONS(3963),
    [anon_sym_unorm] = ACTIONS(3963),
    [anon_sym_point] = ACTIONS(3963),
    [anon_sym_line] = ACTIONS(3963),
    [anon_sym_triangleadj] = ACTIONS(3963),
    [anon_sym_lineadj] = ACTIONS(3963),
    [anon_sym_triangle] = ACTIONS(3963),
    [anon_sym_interface] = ACTIONS(3963),
    [anon_sym_extension] = ACTIONS(3963),
    [anon_sym___init] = ACTIONS(3963),
    [anon_sym___subscript] = ACTIONS(3963),
    [anon_sym_property] = ACTIONS(3963),
    [anon_sym_associatedtype] = ACTIONS(3963),
  },
  [1679] = {
    [sym_identifier] = ACTIONS(3983),
    [aux_sym_preproc_def_token1] = ACTIONS(3983),
    [aux_sym_preproc_if_token1] = ACTIONS(3983),
    [aux_sym_preproc_if_token2] = ACTIONS(3983),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3983),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3983),
    [aux_sym_preproc_else_token1] = ACTIONS(3983),
    [aux_sym_preproc_elif_token1] = ACTIONS(3983),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3983),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3983),
    [sym_preproc_directive] = ACTIONS(3983),
    [anon_sym_LPAREN2] = ACTIONS(3985),
    [anon_sym_TILDE] = ACTIONS(3985),
    [anon_sym_STAR] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3983),
    [anon_sym_SEMI] = ACTIONS(3985),
    [anon_sym___extension__] = ACTIONS(3983),
    [anon_sym_typedef] = ACTIONS(3983),
    [anon_sym_in] = ACTIONS(3983),
    [anon_sym_out] = ACTIONS(3983),
    [anon_sym_inout] = ACTIONS(3983),
    [anon_sym_virtual] = ACTIONS(3983),
    [anon_sym_extern] = ACTIONS(3983),
    [anon_sym___attribute__] = ACTIONS(3983),
    [anon_sym___attribute] = ACTIONS(3983),
    [anon_sym_using] = ACTIONS(3983),
    [anon_sym_COLON_COLON] = ACTIONS(3985),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3985),
    [anon_sym___declspec] = ACTIONS(3983),
    [anon_sym___based] = ACTIONS(3983),
    [anon_sym_signed] = ACTIONS(3983),
    [anon_sym_unsigned] = ACTIONS(3983),
    [anon_sym_long] = ACTIONS(3983),
    [anon_sym_short] = ACTIONS(3983),
    [anon_sym_LBRACK] = ACTIONS(3983),
    [anon_sym_static] = ACTIONS(3983),
    [anon_sym_register] = ACTIONS(3983),
    [anon_sym_inline] = ACTIONS(3983),
    [anon_sym___inline] = ACTIONS(3983),
    [anon_sym___inline__] = ACTIONS(3983),
    [anon_sym___forceinline] = ACTIONS(3983),
    [anon_sym_thread_local] = ACTIONS(3983),
    [anon_sym___thread] = ACTIONS(3983),
    [anon_sym_const] = ACTIONS(3983),
    [anon_sym_constexpr] = ACTIONS(3983),
    [anon_sym_volatile] = ACTIONS(3983),
    [anon_sym_restrict] = ACTIONS(3983),
    [anon_sym___restrict__] = ACTIONS(3983),
    [anon_sym__Atomic] = ACTIONS(3983),
    [anon_sym__Noreturn] = ACTIONS(3983),
    [anon_sym_noreturn] = ACTIONS(3983),
    [anon_sym__Nonnull] = ACTIONS(3983),
    [anon_sym_mutable] = ACTIONS(3983),
    [anon_sym_constinit] = ACTIONS(3983),
    [anon_sym_consteval] = ACTIONS(3983),
    [anon_sym_alignas] = ACTIONS(3983),
    [anon_sym__Alignas] = ACTIONS(3983),
    [sym_primitive_type] = ACTIONS(3983),
    [anon_sym_enum] = ACTIONS(3983),
    [anon_sym_class] = ACTIONS(3983),
    [anon_sym_struct] = ACTIONS(3983),
    [anon_sym_union] = ACTIONS(3983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3983),
    [anon_sym_let] = ACTIONS(3983),
    [anon_sym_This] = ACTIONS(3983),
    [anon_sym_decltype] = ACTIONS(3983),
    [anon_sym_explicit] = ACTIONS(3983),
    [anon_sym_typename] = ACTIONS(3983),
    [anon_sym_private] = ACTIONS(3983),
    [anon_sym_template] = ACTIONS(3983),
    [anon_sym_operator] = ACTIONS(3983),
    [anon_sym_friend] = ACTIONS(3983),
    [anon_sym_public] = ACTIONS(3983),
    [anon_sym_protected] = ACTIONS(3983),
    [anon_sym_static_assert] = ACTIONS(3983),
    [anon_sym_precise] = ACTIONS(3983),
    [anon_sym_shared] = ACTIONS(3983),
    [anon_sym_groupshared] = ACTIONS(3983),
    [anon_sym_uniform] = ACTIONS(3983),
    [anon_sym_row_major] = ACTIONS(3983),
    [anon_sym_column_major] = ACTIONS(3983),
    [anon_sym_globallycoherent] = ACTIONS(3983),
    [anon_sym_centroid] = ACTIONS(3983),
    [anon_sym_noperspective] = ACTIONS(3983),
    [anon_sym_nointerpolation] = ACTIONS(3983),
    [anon_sym_sample] = ACTIONS(3983),
    [anon_sym_linear] = ACTIONS(3983),
    [anon_sym_snorm] = ACTIONS(3983),
    [anon_sym_unorm] = ACTIONS(3983),
    [anon_sym_point] = ACTIONS(3983),
    [anon_sym_line] = ACTIONS(3983),
    [anon_sym_triangleadj] = ACTIONS(3983),
    [anon_sym_lineadj] = ACTIONS(3983),
    [anon_sym_triangle] = ACTIONS(3983),
    [anon_sym_interface] = ACTIONS(3983),
    [anon_sym_extension] = ACTIONS(3983),
    [anon_sym___init] = ACTIONS(3983),
    [anon_sym___subscript] = ACTIONS(3983),
    [anon_sym_property] = ACTIONS(3983),
    [anon_sym_associatedtype] = ACTIONS(3983),
  },
  [1680] = {
    [sym_compound_statement] = STATE(9944),
    [sym_expression] = STATE(5588),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(9944),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_RPAREN] = ACTIONS(6168),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(6134),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1681] = {
    [sym_identifier] = ACTIONS(6170),
    [anon_sym_COMMA] = ACTIONS(6172),
    [anon_sym_RPAREN] = ACTIONS(6172),
    [anon_sym_LPAREN2] = ACTIONS(6172),
    [anon_sym_TILDE] = ACTIONS(6172),
    [anon_sym_STAR] = ACTIONS(6172),
    [anon_sym_PIPE_PIPE] = ACTIONS(6172),
    [anon_sym_AMP_AMP] = ACTIONS(6172),
    [anon_sym_AMP] = ACTIONS(6170),
    [anon_sym___extension__] = ACTIONS(6170),
    [anon_sym_in] = ACTIONS(6170),
    [anon_sym_out] = ACTIONS(6170),
    [anon_sym_inout] = ACTIONS(6170),
    [anon_sym_virtual] = ACTIONS(6170),
    [anon_sym_extern] = ACTIONS(6170),
    [anon_sym___attribute__] = ACTIONS(6170),
    [anon_sym___attribute] = ACTIONS(6170),
    [anon_sym_using] = ACTIONS(6170),
    [anon_sym_COLON_COLON] = ACTIONS(6172),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6172),
    [anon_sym___declspec] = ACTIONS(6170),
    [anon_sym___based] = ACTIONS(6170),
    [anon_sym___cdecl] = ACTIONS(6170),
    [anon_sym___clrcall] = ACTIONS(6170),
    [anon_sym___stdcall] = ACTIONS(6170),
    [anon_sym___fastcall] = ACTIONS(6170),
    [anon_sym___thiscall] = ACTIONS(6170),
    [anon_sym___vectorcall] = ACTIONS(6170),
    [anon_sym_LBRACE] = ACTIONS(6172),
    [anon_sym_signed] = ACTIONS(6170),
    [anon_sym_unsigned] = ACTIONS(6170),
    [anon_sym_long] = ACTIONS(6170),
    [anon_sym_short] = ACTIONS(6170),
    [anon_sym_LBRACK] = ACTIONS(6170),
    [anon_sym_static] = ACTIONS(6170),
    [anon_sym_register] = ACTIONS(6170),
    [anon_sym_inline] = ACTIONS(6170),
    [anon_sym___inline] = ACTIONS(6170),
    [anon_sym___inline__] = ACTIONS(6170),
    [anon_sym___forceinline] = ACTIONS(6170),
    [anon_sym_thread_local] = ACTIONS(6170),
    [anon_sym___thread] = ACTIONS(6170),
    [anon_sym_const] = ACTIONS(6170),
    [anon_sym_constexpr] = ACTIONS(6170),
    [anon_sym_volatile] = ACTIONS(6170),
    [anon_sym_restrict] = ACTIONS(6170),
    [anon_sym___restrict__] = ACTIONS(6170),
    [anon_sym__Atomic] = ACTIONS(6170),
    [anon_sym__Noreturn] = ACTIONS(6170),
    [anon_sym_noreturn] = ACTIONS(6170),
    [anon_sym__Nonnull] = ACTIONS(6170),
    [anon_sym_mutable] = ACTIONS(6170),
    [anon_sym_constinit] = ACTIONS(6170),
    [anon_sym_consteval] = ACTIONS(6170),
    [anon_sym_alignas] = ACTIONS(6170),
    [anon_sym__Alignas] = ACTIONS(6170),
    [sym_primitive_type] = ACTIONS(6170),
    [anon_sym_enum] = ACTIONS(6170),
    [anon_sym_class] = ACTIONS(6170),
    [anon_sym_struct] = ACTIONS(6170),
    [anon_sym_union] = ACTIONS(6170),
    [anon_sym_or] = ACTIONS(6170),
    [anon_sym_and] = ACTIONS(6170),
    [anon_sym_DASH_GT] = ACTIONS(6172),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6170),
    [anon_sym_let] = ACTIONS(6170),
    [anon_sym_This] = ACTIONS(6170),
    [anon_sym_decltype] = ACTIONS(6170),
    [anon_sym_final] = ACTIONS(6170),
    [anon_sym_override] = ACTIONS(6170),
    [anon_sym_explicit] = ACTIONS(6170),
    [anon_sym_typename] = ACTIONS(6170),
    [anon_sym_template] = ACTIONS(6170),
    [anon_sym_operator] = ACTIONS(6170),
    [anon_sym_friend] = ACTIONS(6170),
    [anon_sym_noexcept] = ACTIONS(6170),
    [anon_sym_throw] = ACTIONS(6170),
    [anon_sym_concept] = ACTIONS(6170),
    [anon_sym_requires] = ACTIONS(6170),
    [anon_sym_precise] = ACTIONS(6170),
    [anon_sym_shared] = ACTIONS(6170),
    [anon_sym_groupshared] = ACTIONS(6170),
    [anon_sym_uniform] = ACTIONS(6170),
    [anon_sym_row_major] = ACTIONS(6170),
    [anon_sym_column_major] = ACTIONS(6170),
    [anon_sym_globallycoherent] = ACTIONS(6170),
    [anon_sym_centroid] = ACTIONS(6170),
    [anon_sym_noperspective] = ACTIONS(6170),
    [anon_sym_nointerpolation] = ACTIONS(6170),
    [anon_sym_sample] = ACTIONS(6170),
    [anon_sym_linear] = ACTIONS(6170),
    [anon_sym_snorm] = ACTIONS(6170),
    [anon_sym_unorm] = ACTIONS(6170),
    [anon_sym_point] = ACTIONS(6170),
    [anon_sym_line] = ACTIONS(6170),
    [anon_sym_triangleadj] = ACTIONS(6170),
    [anon_sym_lineadj] = ACTIONS(6170),
    [anon_sym_triangle] = ACTIONS(6170),
    [anon_sym_interface] = ACTIONS(6170),
    [anon_sym_extension] = ACTIONS(6170),
    [anon_sym_where] = ACTIONS(6170),
  },
  [1682] = {
    [sym_identifier] = ACTIONS(3796),
    [aux_sym_preproc_def_token1] = ACTIONS(3796),
    [aux_sym_preproc_if_token1] = ACTIONS(3796),
    [aux_sym_preproc_if_token2] = ACTIONS(3796),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3796),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3796),
    [aux_sym_preproc_else_token1] = ACTIONS(3796),
    [aux_sym_preproc_elif_token1] = ACTIONS(3796),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3796),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3796),
    [sym_preproc_directive] = ACTIONS(3796),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_TILDE] = ACTIONS(3798),
    [anon_sym_STAR] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_AMP] = ACTIONS(3796),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym___extension__] = ACTIONS(3796),
    [anon_sym_typedef] = ACTIONS(3796),
    [anon_sym_in] = ACTIONS(3796),
    [anon_sym_out] = ACTIONS(3796),
    [anon_sym_inout] = ACTIONS(3796),
    [anon_sym_virtual] = ACTIONS(3796),
    [anon_sym_extern] = ACTIONS(3796),
    [anon_sym___attribute__] = ACTIONS(3796),
    [anon_sym___attribute] = ACTIONS(3796),
    [anon_sym_using] = ACTIONS(3796),
    [anon_sym_COLON_COLON] = ACTIONS(3798),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3798),
    [anon_sym___declspec] = ACTIONS(3796),
    [anon_sym___based] = ACTIONS(3796),
    [anon_sym_signed] = ACTIONS(3796),
    [anon_sym_unsigned] = ACTIONS(3796),
    [anon_sym_long] = ACTIONS(3796),
    [anon_sym_short] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3796),
    [anon_sym_static] = ACTIONS(3796),
    [anon_sym_register] = ACTIONS(3796),
    [anon_sym_inline] = ACTIONS(3796),
    [anon_sym___inline] = ACTIONS(3796),
    [anon_sym___inline__] = ACTIONS(3796),
    [anon_sym___forceinline] = ACTIONS(3796),
    [anon_sym_thread_local] = ACTIONS(3796),
    [anon_sym___thread] = ACTIONS(3796),
    [anon_sym_const] = ACTIONS(3796),
    [anon_sym_constexpr] = ACTIONS(3796),
    [anon_sym_volatile] = ACTIONS(3796),
    [anon_sym_restrict] = ACTIONS(3796),
    [anon_sym___restrict__] = ACTIONS(3796),
    [anon_sym__Atomic] = ACTIONS(3796),
    [anon_sym__Noreturn] = ACTIONS(3796),
    [anon_sym_noreturn] = ACTIONS(3796),
    [anon_sym__Nonnull] = ACTIONS(3796),
    [anon_sym_mutable] = ACTIONS(3796),
    [anon_sym_constinit] = ACTIONS(3796),
    [anon_sym_consteval] = ACTIONS(3796),
    [anon_sym_alignas] = ACTIONS(3796),
    [anon_sym__Alignas] = ACTIONS(3796),
    [sym_primitive_type] = ACTIONS(3796),
    [anon_sym_enum] = ACTIONS(3796),
    [anon_sym_class] = ACTIONS(3796),
    [anon_sym_struct] = ACTIONS(3796),
    [anon_sym_union] = ACTIONS(3796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3796),
    [anon_sym_let] = ACTIONS(3796),
    [anon_sym_This] = ACTIONS(3796),
    [anon_sym_decltype] = ACTIONS(3796),
    [anon_sym_explicit] = ACTIONS(3796),
    [anon_sym_typename] = ACTIONS(3796),
    [anon_sym_private] = ACTIONS(3796),
    [anon_sym_template] = ACTIONS(3796),
    [anon_sym_operator] = ACTIONS(3796),
    [anon_sym_friend] = ACTIONS(3796),
    [anon_sym_public] = ACTIONS(3796),
    [anon_sym_protected] = ACTIONS(3796),
    [anon_sym_static_assert] = ACTIONS(3796),
    [anon_sym_precise] = ACTIONS(3796),
    [anon_sym_shared] = ACTIONS(3796),
    [anon_sym_groupshared] = ACTIONS(3796),
    [anon_sym_uniform] = ACTIONS(3796),
    [anon_sym_row_major] = ACTIONS(3796),
    [anon_sym_column_major] = ACTIONS(3796),
    [anon_sym_globallycoherent] = ACTIONS(3796),
    [anon_sym_centroid] = ACTIONS(3796),
    [anon_sym_noperspective] = ACTIONS(3796),
    [anon_sym_nointerpolation] = ACTIONS(3796),
    [anon_sym_sample] = ACTIONS(3796),
    [anon_sym_linear] = ACTIONS(3796),
    [anon_sym_snorm] = ACTIONS(3796),
    [anon_sym_unorm] = ACTIONS(3796),
    [anon_sym_point] = ACTIONS(3796),
    [anon_sym_line] = ACTIONS(3796),
    [anon_sym_triangleadj] = ACTIONS(3796),
    [anon_sym_lineadj] = ACTIONS(3796),
    [anon_sym_triangle] = ACTIONS(3796),
    [anon_sym_interface] = ACTIONS(3796),
    [anon_sym_extension] = ACTIONS(3796),
    [anon_sym___init] = ACTIONS(3796),
    [anon_sym___subscript] = ACTIONS(3796),
    [anon_sym_property] = ACTIONS(3796),
    [anon_sym_associatedtype] = ACTIONS(3796),
  },
  [1683] = {
    [sym_identifier] = ACTIONS(3800),
    [aux_sym_preproc_def_token1] = ACTIONS(3800),
    [aux_sym_preproc_if_token1] = ACTIONS(3800),
    [aux_sym_preproc_if_token2] = ACTIONS(3800),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3800),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3800),
    [aux_sym_preproc_else_token1] = ACTIONS(3800),
    [aux_sym_preproc_elif_token1] = ACTIONS(3800),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3800),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3800),
    [sym_preproc_directive] = ACTIONS(3800),
    [anon_sym_LPAREN2] = ACTIONS(3802),
    [anon_sym_TILDE] = ACTIONS(3802),
    [anon_sym_STAR] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_SEMI] = ACTIONS(3802),
    [anon_sym___extension__] = ACTIONS(3800),
    [anon_sym_typedef] = ACTIONS(3800),
    [anon_sym_in] = ACTIONS(3800),
    [anon_sym_out] = ACTIONS(3800),
    [anon_sym_inout] = ACTIONS(3800),
    [anon_sym_virtual] = ACTIONS(3800),
    [anon_sym_extern] = ACTIONS(3800),
    [anon_sym___attribute__] = ACTIONS(3800),
    [anon_sym___attribute] = ACTIONS(3800),
    [anon_sym_using] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3802),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3802),
    [anon_sym___declspec] = ACTIONS(3800),
    [anon_sym___based] = ACTIONS(3800),
    [anon_sym_signed] = ACTIONS(3800),
    [anon_sym_unsigned] = ACTIONS(3800),
    [anon_sym_long] = ACTIONS(3800),
    [anon_sym_short] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3800),
    [anon_sym_static] = ACTIONS(3800),
    [anon_sym_register] = ACTIONS(3800),
    [anon_sym_inline] = ACTIONS(3800),
    [anon_sym___inline] = ACTIONS(3800),
    [anon_sym___inline__] = ACTIONS(3800),
    [anon_sym___forceinline] = ACTIONS(3800),
    [anon_sym_thread_local] = ACTIONS(3800),
    [anon_sym___thread] = ACTIONS(3800),
    [anon_sym_const] = ACTIONS(3800),
    [anon_sym_constexpr] = ACTIONS(3800),
    [anon_sym_volatile] = ACTIONS(3800),
    [anon_sym_restrict] = ACTIONS(3800),
    [anon_sym___restrict__] = ACTIONS(3800),
    [anon_sym__Atomic] = ACTIONS(3800),
    [anon_sym__Noreturn] = ACTIONS(3800),
    [anon_sym_noreturn] = ACTIONS(3800),
    [anon_sym__Nonnull] = ACTIONS(3800),
    [anon_sym_mutable] = ACTIONS(3800),
    [anon_sym_constinit] = ACTIONS(3800),
    [anon_sym_consteval] = ACTIONS(3800),
    [anon_sym_alignas] = ACTIONS(3800),
    [anon_sym__Alignas] = ACTIONS(3800),
    [sym_primitive_type] = ACTIONS(3800),
    [anon_sym_enum] = ACTIONS(3800),
    [anon_sym_class] = ACTIONS(3800),
    [anon_sym_struct] = ACTIONS(3800),
    [anon_sym_union] = ACTIONS(3800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_This] = ACTIONS(3800),
    [anon_sym_decltype] = ACTIONS(3800),
    [anon_sym_explicit] = ACTIONS(3800),
    [anon_sym_typename] = ACTIONS(3800),
    [anon_sym_private] = ACTIONS(3800),
    [anon_sym_template] = ACTIONS(3800),
    [anon_sym_operator] = ACTIONS(3800),
    [anon_sym_friend] = ACTIONS(3800),
    [anon_sym_public] = ACTIONS(3800),
    [anon_sym_protected] = ACTIONS(3800),
    [anon_sym_static_assert] = ACTIONS(3800),
    [anon_sym_precise] = ACTIONS(3800),
    [anon_sym_shared] = ACTIONS(3800),
    [anon_sym_groupshared] = ACTIONS(3800),
    [anon_sym_uniform] = ACTIONS(3800),
    [anon_sym_row_major] = ACTIONS(3800),
    [anon_sym_column_major] = ACTIONS(3800),
    [anon_sym_globallycoherent] = ACTIONS(3800),
    [anon_sym_centroid] = ACTIONS(3800),
    [anon_sym_noperspective] = ACTIONS(3800),
    [anon_sym_nointerpolation] = ACTIONS(3800),
    [anon_sym_sample] = ACTIONS(3800),
    [anon_sym_linear] = ACTIONS(3800),
    [anon_sym_snorm] = ACTIONS(3800),
    [anon_sym_unorm] = ACTIONS(3800),
    [anon_sym_point] = ACTIONS(3800),
    [anon_sym_line] = ACTIONS(3800),
    [anon_sym_triangleadj] = ACTIONS(3800),
    [anon_sym_lineadj] = ACTIONS(3800),
    [anon_sym_triangle] = ACTIONS(3800),
    [anon_sym_interface] = ACTIONS(3800),
    [anon_sym_extension] = ACTIONS(3800),
    [anon_sym___init] = ACTIONS(3800),
    [anon_sym___subscript] = ACTIONS(3800),
    [anon_sym_property] = ACTIONS(3800),
    [anon_sym_associatedtype] = ACTIONS(3800),
  },
  [1684] = {
    [sym_expression] = STATE(5751),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11665),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(11665),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(6174),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1685] = {
    [sym_identifier] = ACTIONS(6176),
    [aux_sym_preproc_def_token1] = ACTIONS(6176),
    [aux_sym_preproc_if_token1] = ACTIONS(6176),
    [aux_sym_preproc_if_token2] = ACTIONS(6176),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6176),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6176),
    [aux_sym_preproc_else_token1] = ACTIONS(6176),
    [aux_sym_preproc_elif_token1] = ACTIONS(6176),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6176),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6176),
    [sym_preproc_directive] = ACTIONS(6176),
    [anon_sym_LPAREN2] = ACTIONS(6178),
    [anon_sym_TILDE] = ACTIONS(6178),
    [anon_sym_STAR] = ACTIONS(6178),
    [anon_sym_AMP_AMP] = ACTIONS(6178),
    [anon_sym_AMP] = ACTIONS(6176),
    [anon_sym_SEMI] = ACTIONS(6178),
    [anon_sym___extension__] = ACTIONS(6176),
    [anon_sym_typedef] = ACTIONS(6176),
    [anon_sym_in] = ACTIONS(6176),
    [anon_sym_out] = ACTIONS(6176),
    [anon_sym_inout] = ACTIONS(6176),
    [anon_sym_virtual] = ACTIONS(6176),
    [anon_sym_extern] = ACTIONS(6176),
    [anon_sym___attribute__] = ACTIONS(6176),
    [anon_sym___attribute] = ACTIONS(6176),
    [anon_sym_using] = ACTIONS(6176),
    [anon_sym_COLON_COLON] = ACTIONS(6178),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6178),
    [anon_sym___declspec] = ACTIONS(6176),
    [anon_sym___based] = ACTIONS(6176),
    [anon_sym_signed] = ACTIONS(6176),
    [anon_sym_unsigned] = ACTIONS(6176),
    [anon_sym_long] = ACTIONS(6176),
    [anon_sym_short] = ACTIONS(6176),
    [anon_sym_LBRACK] = ACTIONS(6176),
    [anon_sym_static] = ACTIONS(6176),
    [anon_sym_register] = ACTIONS(6176),
    [anon_sym_inline] = ACTIONS(6176),
    [anon_sym___inline] = ACTIONS(6176),
    [anon_sym___inline__] = ACTIONS(6176),
    [anon_sym___forceinline] = ACTIONS(6176),
    [anon_sym_thread_local] = ACTIONS(6176),
    [anon_sym___thread] = ACTIONS(6176),
    [anon_sym_const] = ACTIONS(6176),
    [anon_sym_constexpr] = ACTIONS(6176),
    [anon_sym_volatile] = ACTIONS(6176),
    [anon_sym_restrict] = ACTIONS(6176),
    [anon_sym___restrict__] = ACTIONS(6176),
    [anon_sym__Atomic] = ACTIONS(6176),
    [anon_sym__Noreturn] = ACTIONS(6176),
    [anon_sym_noreturn] = ACTIONS(6176),
    [anon_sym__Nonnull] = ACTIONS(6176),
    [anon_sym_mutable] = ACTIONS(6176),
    [anon_sym_constinit] = ACTIONS(6176),
    [anon_sym_consteval] = ACTIONS(6176),
    [anon_sym_alignas] = ACTIONS(6176),
    [anon_sym__Alignas] = ACTIONS(6176),
    [sym_primitive_type] = ACTIONS(6176),
    [anon_sym_enum] = ACTIONS(6176),
    [anon_sym_class] = ACTIONS(6176),
    [anon_sym_struct] = ACTIONS(6176),
    [anon_sym_union] = ACTIONS(6176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6176),
    [anon_sym_let] = ACTIONS(6176),
    [anon_sym_This] = ACTIONS(6176),
    [anon_sym_decltype] = ACTIONS(6176),
    [anon_sym_explicit] = ACTIONS(6176),
    [anon_sym_typename] = ACTIONS(6176),
    [anon_sym_private] = ACTIONS(6176),
    [anon_sym_template] = ACTIONS(6176),
    [anon_sym_operator] = ACTIONS(6176),
    [anon_sym_friend] = ACTIONS(6176),
    [anon_sym_public] = ACTIONS(6176),
    [anon_sym_protected] = ACTIONS(6176),
    [anon_sym_static_assert] = ACTIONS(6176),
    [anon_sym_precise] = ACTIONS(6176),
    [anon_sym_shared] = ACTIONS(6176),
    [anon_sym_groupshared] = ACTIONS(6176),
    [anon_sym_uniform] = ACTIONS(6176),
    [anon_sym_row_major] = ACTIONS(6176),
    [anon_sym_column_major] = ACTIONS(6176),
    [anon_sym_globallycoherent] = ACTIONS(6176),
    [anon_sym_centroid] = ACTIONS(6176),
    [anon_sym_noperspective] = ACTIONS(6176),
    [anon_sym_nointerpolation] = ACTIONS(6176),
    [anon_sym_sample] = ACTIONS(6176),
    [anon_sym_linear] = ACTIONS(6176),
    [anon_sym_snorm] = ACTIONS(6176),
    [anon_sym_unorm] = ACTIONS(6176),
    [anon_sym_point] = ACTIONS(6176),
    [anon_sym_line] = ACTIONS(6176),
    [anon_sym_triangleadj] = ACTIONS(6176),
    [anon_sym_lineadj] = ACTIONS(6176),
    [anon_sym_triangle] = ACTIONS(6176),
    [anon_sym_interface] = ACTIONS(6176),
    [anon_sym_extension] = ACTIONS(6176),
    [anon_sym___init] = ACTIONS(6176),
    [anon_sym___subscript] = ACTIONS(6176),
    [anon_sym_property] = ACTIONS(6176),
    [anon_sym_associatedtype] = ACTIONS(6176),
  },
  [1686] = {
    [sym_compound_statement] = STATE(10301),
    [sym_expression] = STATE(5573),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10301),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_RPAREN] = ACTIONS(6180),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(6134),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1687] = {
    [sym_identifier] = ACTIONS(6182),
    [aux_sym_preproc_def_token1] = ACTIONS(6182),
    [aux_sym_preproc_if_token1] = ACTIONS(6182),
    [aux_sym_preproc_if_token2] = ACTIONS(6182),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6182),
    [aux_sym_preproc_else_token1] = ACTIONS(6182),
    [aux_sym_preproc_elif_token1] = ACTIONS(6182),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6182),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6182),
    [sym_preproc_directive] = ACTIONS(6182),
    [anon_sym_LPAREN2] = ACTIONS(6184),
    [anon_sym_TILDE] = ACTIONS(6184),
    [anon_sym_STAR] = ACTIONS(6184),
    [anon_sym_AMP_AMP] = ACTIONS(6184),
    [anon_sym_AMP] = ACTIONS(6182),
    [anon_sym_SEMI] = ACTIONS(6184),
    [anon_sym___extension__] = ACTIONS(6182),
    [anon_sym_typedef] = ACTIONS(6182),
    [anon_sym_in] = ACTIONS(6182),
    [anon_sym_out] = ACTIONS(6182),
    [anon_sym_inout] = ACTIONS(6182),
    [anon_sym_virtual] = ACTIONS(6182),
    [anon_sym_extern] = ACTIONS(6182),
    [anon_sym___attribute__] = ACTIONS(6182),
    [anon_sym___attribute] = ACTIONS(6182),
    [anon_sym_using] = ACTIONS(6182),
    [anon_sym_COLON_COLON] = ACTIONS(6184),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6184),
    [anon_sym___declspec] = ACTIONS(6182),
    [anon_sym___based] = ACTIONS(6182),
    [anon_sym_signed] = ACTIONS(6182),
    [anon_sym_unsigned] = ACTIONS(6182),
    [anon_sym_long] = ACTIONS(6182),
    [anon_sym_short] = ACTIONS(6182),
    [anon_sym_LBRACK] = ACTIONS(6182),
    [anon_sym_static] = ACTIONS(6182),
    [anon_sym_register] = ACTIONS(6182),
    [anon_sym_inline] = ACTIONS(6182),
    [anon_sym___inline] = ACTIONS(6182),
    [anon_sym___inline__] = ACTIONS(6182),
    [anon_sym___forceinline] = ACTIONS(6182),
    [anon_sym_thread_local] = ACTIONS(6182),
    [anon_sym___thread] = ACTIONS(6182),
    [anon_sym_const] = ACTIONS(6182),
    [anon_sym_constexpr] = ACTIONS(6182),
    [anon_sym_volatile] = ACTIONS(6182),
    [anon_sym_restrict] = ACTIONS(6182),
    [anon_sym___restrict__] = ACTIONS(6182),
    [anon_sym__Atomic] = ACTIONS(6182),
    [anon_sym__Noreturn] = ACTIONS(6182),
    [anon_sym_noreturn] = ACTIONS(6182),
    [anon_sym__Nonnull] = ACTIONS(6182),
    [anon_sym_mutable] = ACTIONS(6182),
    [anon_sym_constinit] = ACTIONS(6182),
    [anon_sym_consteval] = ACTIONS(6182),
    [anon_sym_alignas] = ACTIONS(6182),
    [anon_sym__Alignas] = ACTIONS(6182),
    [sym_primitive_type] = ACTIONS(6182),
    [anon_sym_enum] = ACTIONS(6182),
    [anon_sym_class] = ACTIONS(6182),
    [anon_sym_struct] = ACTIONS(6182),
    [anon_sym_union] = ACTIONS(6182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6182),
    [anon_sym_let] = ACTIONS(6182),
    [anon_sym_This] = ACTIONS(6182),
    [anon_sym_decltype] = ACTIONS(6182),
    [anon_sym_explicit] = ACTIONS(6182),
    [anon_sym_typename] = ACTIONS(6182),
    [anon_sym_private] = ACTIONS(6182),
    [anon_sym_template] = ACTIONS(6182),
    [anon_sym_operator] = ACTIONS(6182),
    [anon_sym_friend] = ACTIONS(6182),
    [anon_sym_public] = ACTIONS(6182),
    [anon_sym_protected] = ACTIONS(6182),
    [anon_sym_static_assert] = ACTIONS(6182),
    [anon_sym_precise] = ACTIONS(6182),
    [anon_sym_shared] = ACTIONS(6182),
    [anon_sym_groupshared] = ACTIONS(6182),
    [anon_sym_uniform] = ACTIONS(6182),
    [anon_sym_row_major] = ACTIONS(6182),
    [anon_sym_column_major] = ACTIONS(6182),
    [anon_sym_globallycoherent] = ACTIONS(6182),
    [anon_sym_centroid] = ACTIONS(6182),
    [anon_sym_noperspective] = ACTIONS(6182),
    [anon_sym_nointerpolation] = ACTIONS(6182),
    [anon_sym_sample] = ACTIONS(6182),
    [anon_sym_linear] = ACTIONS(6182),
    [anon_sym_snorm] = ACTIONS(6182),
    [anon_sym_unorm] = ACTIONS(6182),
    [anon_sym_point] = ACTIONS(6182),
    [anon_sym_line] = ACTIONS(6182),
    [anon_sym_triangleadj] = ACTIONS(6182),
    [anon_sym_lineadj] = ACTIONS(6182),
    [anon_sym_triangle] = ACTIONS(6182),
    [anon_sym_interface] = ACTIONS(6182),
    [anon_sym_extension] = ACTIONS(6182),
    [anon_sym___init] = ACTIONS(6182),
    [anon_sym___subscript] = ACTIONS(6182),
    [anon_sym_property] = ACTIONS(6182),
    [anon_sym_associatedtype] = ACTIONS(6182),
  },
  [1688] = {
    [sym_identifier] = ACTIONS(6186),
    [aux_sym_preproc_def_token1] = ACTIONS(6186),
    [aux_sym_preproc_if_token1] = ACTIONS(6186),
    [aux_sym_preproc_if_token2] = ACTIONS(6186),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6186),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6186),
    [aux_sym_preproc_else_token1] = ACTIONS(6186),
    [aux_sym_preproc_elif_token1] = ACTIONS(6186),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6186),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6186),
    [sym_preproc_directive] = ACTIONS(6186),
    [anon_sym_LPAREN2] = ACTIONS(6188),
    [anon_sym_TILDE] = ACTIONS(6188),
    [anon_sym_STAR] = ACTIONS(6188),
    [anon_sym_AMP_AMP] = ACTIONS(6188),
    [anon_sym_AMP] = ACTIONS(6186),
    [anon_sym_SEMI] = ACTIONS(6188),
    [anon_sym___extension__] = ACTIONS(6186),
    [anon_sym_typedef] = ACTIONS(6186),
    [anon_sym_in] = ACTIONS(6186),
    [anon_sym_out] = ACTIONS(6186),
    [anon_sym_inout] = ACTIONS(6186),
    [anon_sym_virtual] = ACTIONS(6186),
    [anon_sym_extern] = ACTIONS(6186),
    [anon_sym___attribute__] = ACTIONS(6186),
    [anon_sym___attribute] = ACTIONS(6186),
    [anon_sym_using] = ACTIONS(6186),
    [anon_sym_COLON_COLON] = ACTIONS(6188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6188),
    [anon_sym___declspec] = ACTIONS(6186),
    [anon_sym___based] = ACTIONS(6186),
    [anon_sym_signed] = ACTIONS(6186),
    [anon_sym_unsigned] = ACTIONS(6186),
    [anon_sym_long] = ACTIONS(6186),
    [anon_sym_short] = ACTIONS(6186),
    [anon_sym_LBRACK] = ACTIONS(6186),
    [anon_sym_static] = ACTIONS(6186),
    [anon_sym_register] = ACTIONS(6186),
    [anon_sym_inline] = ACTIONS(6186),
    [anon_sym___inline] = ACTIONS(6186),
    [anon_sym___inline__] = ACTIONS(6186),
    [anon_sym___forceinline] = ACTIONS(6186),
    [anon_sym_thread_local] = ACTIONS(6186),
    [anon_sym___thread] = ACTIONS(6186),
    [anon_sym_const] = ACTIONS(6186),
    [anon_sym_constexpr] = ACTIONS(6186),
    [anon_sym_volatile] = ACTIONS(6186),
    [anon_sym_restrict] = ACTIONS(6186),
    [anon_sym___restrict__] = ACTIONS(6186),
    [anon_sym__Atomic] = ACTIONS(6186),
    [anon_sym__Noreturn] = ACTIONS(6186),
    [anon_sym_noreturn] = ACTIONS(6186),
    [anon_sym__Nonnull] = ACTIONS(6186),
    [anon_sym_mutable] = ACTIONS(6186),
    [anon_sym_constinit] = ACTIONS(6186),
    [anon_sym_consteval] = ACTIONS(6186),
    [anon_sym_alignas] = ACTIONS(6186),
    [anon_sym__Alignas] = ACTIONS(6186),
    [sym_primitive_type] = ACTIONS(6186),
    [anon_sym_enum] = ACTIONS(6186),
    [anon_sym_class] = ACTIONS(6186),
    [anon_sym_struct] = ACTIONS(6186),
    [anon_sym_union] = ACTIONS(6186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6186),
    [anon_sym_let] = ACTIONS(6186),
    [anon_sym_This] = ACTIONS(6186),
    [anon_sym_decltype] = ACTIONS(6186),
    [anon_sym_explicit] = ACTIONS(6186),
    [anon_sym_typename] = ACTIONS(6186),
    [anon_sym_private] = ACTIONS(6186),
    [anon_sym_template] = ACTIONS(6186),
    [anon_sym_operator] = ACTIONS(6186),
    [anon_sym_friend] = ACTIONS(6186),
    [anon_sym_public] = ACTIONS(6186),
    [anon_sym_protected] = ACTIONS(6186),
    [anon_sym_static_assert] = ACTIONS(6186),
    [anon_sym_precise] = ACTIONS(6186),
    [anon_sym_shared] = ACTIONS(6186),
    [anon_sym_groupshared] = ACTIONS(6186),
    [anon_sym_uniform] = ACTIONS(6186),
    [anon_sym_row_major] = ACTIONS(6186),
    [anon_sym_column_major] = ACTIONS(6186),
    [anon_sym_globallycoherent] = ACTIONS(6186),
    [anon_sym_centroid] = ACTIONS(6186),
    [anon_sym_noperspective] = ACTIONS(6186),
    [anon_sym_nointerpolation] = ACTIONS(6186),
    [anon_sym_sample] = ACTIONS(6186),
    [anon_sym_linear] = ACTIONS(6186),
    [anon_sym_snorm] = ACTIONS(6186),
    [anon_sym_unorm] = ACTIONS(6186),
    [anon_sym_point] = ACTIONS(6186),
    [anon_sym_line] = ACTIONS(6186),
    [anon_sym_triangleadj] = ACTIONS(6186),
    [anon_sym_lineadj] = ACTIONS(6186),
    [anon_sym_triangle] = ACTIONS(6186),
    [anon_sym_interface] = ACTIONS(6186),
    [anon_sym_extension] = ACTIONS(6186),
    [anon_sym___init] = ACTIONS(6186),
    [anon_sym___subscript] = ACTIONS(6186),
    [anon_sym_property] = ACTIONS(6186),
    [anon_sym_associatedtype] = ACTIONS(6186),
  },
  [1689] = {
    [sym_identifier] = ACTIONS(6190),
    [aux_sym_preproc_def_token1] = ACTIONS(6190),
    [aux_sym_preproc_if_token1] = ACTIONS(6190),
    [aux_sym_preproc_if_token2] = ACTIONS(6190),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6190),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6190),
    [aux_sym_preproc_else_token1] = ACTIONS(6190),
    [aux_sym_preproc_elif_token1] = ACTIONS(6190),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6190),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6190),
    [sym_preproc_directive] = ACTIONS(6190),
    [anon_sym_LPAREN2] = ACTIONS(6192),
    [anon_sym_TILDE] = ACTIONS(6192),
    [anon_sym_STAR] = ACTIONS(6192),
    [anon_sym_AMP_AMP] = ACTIONS(6192),
    [anon_sym_AMP] = ACTIONS(6190),
    [anon_sym_SEMI] = ACTIONS(6192),
    [anon_sym___extension__] = ACTIONS(6190),
    [anon_sym_typedef] = ACTIONS(6190),
    [anon_sym_in] = ACTIONS(6190),
    [anon_sym_out] = ACTIONS(6190),
    [anon_sym_inout] = ACTIONS(6190),
    [anon_sym_virtual] = ACTIONS(6190),
    [anon_sym_extern] = ACTIONS(6190),
    [anon_sym___attribute__] = ACTIONS(6190),
    [anon_sym___attribute] = ACTIONS(6190),
    [anon_sym_using] = ACTIONS(6190),
    [anon_sym_COLON_COLON] = ACTIONS(6192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6192),
    [anon_sym___declspec] = ACTIONS(6190),
    [anon_sym___based] = ACTIONS(6190),
    [anon_sym_signed] = ACTIONS(6190),
    [anon_sym_unsigned] = ACTIONS(6190),
    [anon_sym_long] = ACTIONS(6190),
    [anon_sym_short] = ACTIONS(6190),
    [anon_sym_LBRACK] = ACTIONS(6190),
    [anon_sym_static] = ACTIONS(6190),
    [anon_sym_register] = ACTIONS(6190),
    [anon_sym_inline] = ACTIONS(6190),
    [anon_sym___inline] = ACTIONS(6190),
    [anon_sym___inline__] = ACTIONS(6190),
    [anon_sym___forceinline] = ACTIONS(6190),
    [anon_sym_thread_local] = ACTIONS(6190),
    [anon_sym___thread] = ACTIONS(6190),
    [anon_sym_const] = ACTIONS(6190),
    [anon_sym_constexpr] = ACTIONS(6190),
    [anon_sym_volatile] = ACTIONS(6190),
    [anon_sym_restrict] = ACTIONS(6190),
    [anon_sym___restrict__] = ACTIONS(6190),
    [anon_sym__Atomic] = ACTIONS(6190),
    [anon_sym__Noreturn] = ACTIONS(6190),
    [anon_sym_noreturn] = ACTIONS(6190),
    [anon_sym__Nonnull] = ACTIONS(6190),
    [anon_sym_mutable] = ACTIONS(6190),
    [anon_sym_constinit] = ACTIONS(6190),
    [anon_sym_consteval] = ACTIONS(6190),
    [anon_sym_alignas] = ACTIONS(6190),
    [anon_sym__Alignas] = ACTIONS(6190),
    [sym_primitive_type] = ACTIONS(6190),
    [anon_sym_enum] = ACTIONS(6190),
    [anon_sym_class] = ACTIONS(6190),
    [anon_sym_struct] = ACTIONS(6190),
    [anon_sym_union] = ACTIONS(6190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6190),
    [anon_sym_let] = ACTIONS(6190),
    [anon_sym_This] = ACTIONS(6190),
    [anon_sym_decltype] = ACTIONS(6190),
    [anon_sym_explicit] = ACTIONS(6190),
    [anon_sym_typename] = ACTIONS(6190),
    [anon_sym_private] = ACTIONS(6190),
    [anon_sym_template] = ACTIONS(6190),
    [anon_sym_operator] = ACTIONS(6190),
    [anon_sym_friend] = ACTIONS(6190),
    [anon_sym_public] = ACTIONS(6190),
    [anon_sym_protected] = ACTIONS(6190),
    [anon_sym_static_assert] = ACTIONS(6190),
    [anon_sym_precise] = ACTIONS(6190),
    [anon_sym_shared] = ACTIONS(6190),
    [anon_sym_groupshared] = ACTIONS(6190),
    [anon_sym_uniform] = ACTIONS(6190),
    [anon_sym_row_major] = ACTIONS(6190),
    [anon_sym_column_major] = ACTIONS(6190),
    [anon_sym_globallycoherent] = ACTIONS(6190),
    [anon_sym_centroid] = ACTIONS(6190),
    [anon_sym_noperspective] = ACTIONS(6190),
    [anon_sym_nointerpolation] = ACTIONS(6190),
    [anon_sym_sample] = ACTIONS(6190),
    [anon_sym_linear] = ACTIONS(6190),
    [anon_sym_snorm] = ACTIONS(6190),
    [anon_sym_unorm] = ACTIONS(6190),
    [anon_sym_point] = ACTIONS(6190),
    [anon_sym_line] = ACTIONS(6190),
    [anon_sym_triangleadj] = ACTIONS(6190),
    [anon_sym_lineadj] = ACTIONS(6190),
    [anon_sym_triangle] = ACTIONS(6190),
    [anon_sym_interface] = ACTIONS(6190),
    [anon_sym_extension] = ACTIONS(6190),
    [anon_sym___init] = ACTIONS(6190),
    [anon_sym___subscript] = ACTIONS(6190),
    [anon_sym_property] = ACTIONS(6190),
    [anon_sym_associatedtype] = ACTIONS(6190),
  },
  [1690] = {
    [sym_identifier] = ACTIONS(6194),
    [aux_sym_preproc_def_token1] = ACTIONS(6194),
    [aux_sym_preproc_if_token1] = ACTIONS(6194),
    [aux_sym_preproc_if_token2] = ACTIONS(6194),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6194),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6194),
    [aux_sym_preproc_else_token1] = ACTIONS(6194),
    [aux_sym_preproc_elif_token1] = ACTIONS(6194),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6194),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6194),
    [sym_preproc_directive] = ACTIONS(6194),
    [anon_sym_LPAREN2] = ACTIONS(6196),
    [anon_sym_TILDE] = ACTIONS(6196),
    [anon_sym_STAR] = ACTIONS(6196),
    [anon_sym_AMP_AMP] = ACTIONS(6196),
    [anon_sym_AMP] = ACTIONS(6194),
    [anon_sym_SEMI] = ACTIONS(6196),
    [anon_sym___extension__] = ACTIONS(6194),
    [anon_sym_typedef] = ACTIONS(6194),
    [anon_sym_in] = ACTIONS(6194),
    [anon_sym_out] = ACTIONS(6194),
    [anon_sym_inout] = ACTIONS(6194),
    [anon_sym_virtual] = ACTIONS(6194),
    [anon_sym_extern] = ACTIONS(6194),
    [anon_sym___attribute__] = ACTIONS(6194),
    [anon_sym___attribute] = ACTIONS(6194),
    [anon_sym_using] = ACTIONS(6194),
    [anon_sym_COLON_COLON] = ACTIONS(6196),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6196),
    [anon_sym___declspec] = ACTIONS(6194),
    [anon_sym___based] = ACTIONS(6194),
    [anon_sym_signed] = ACTIONS(6194),
    [anon_sym_unsigned] = ACTIONS(6194),
    [anon_sym_long] = ACTIONS(6194),
    [anon_sym_short] = ACTIONS(6194),
    [anon_sym_LBRACK] = ACTIONS(6194),
    [anon_sym_static] = ACTIONS(6194),
    [anon_sym_register] = ACTIONS(6194),
    [anon_sym_inline] = ACTIONS(6194),
    [anon_sym___inline] = ACTIONS(6194),
    [anon_sym___inline__] = ACTIONS(6194),
    [anon_sym___forceinline] = ACTIONS(6194),
    [anon_sym_thread_local] = ACTIONS(6194),
    [anon_sym___thread] = ACTIONS(6194),
    [anon_sym_const] = ACTIONS(6194),
    [anon_sym_constexpr] = ACTIONS(6194),
    [anon_sym_volatile] = ACTIONS(6194),
    [anon_sym_restrict] = ACTIONS(6194),
    [anon_sym___restrict__] = ACTIONS(6194),
    [anon_sym__Atomic] = ACTIONS(6194),
    [anon_sym__Noreturn] = ACTIONS(6194),
    [anon_sym_noreturn] = ACTIONS(6194),
    [anon_sym__Nonnull] = ACTIONS(6194),
    [anon_sym_mutable] = ACTIONS(6194),
    [anon_sym_constinit] = ACTIONS(6194),
    [anon_sym_consteval] = ACTIONS(6194),
    [anon_sym_alignas] = ACTIONS(6194),
    [anon_sym__Alignas] = ACTIONS(6194),
    [sym_primitive_type] = ACTIONS(6194),
    [anon_sym_enum] = ACTIONS(6194),
    [anon_sym_class] = ACTIONS(6194),
    [anon_sym_struct] = ACTIONS(6194),
    [anon_sym_union] = ACTIONS(6194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6194),
    [anon_sym_let] = ACTIONS(6194),
    [anon_sym_This] = ACTIONS(6194),
    [anon_sym_decltype] = ACTIONS(6194),
    [anon_sym_explicit] = ACTIONS(6194),
    [anon_sym_typename] = ACTIONS(6194),
    [anon_sym_private] = ACTIONS(6194),
    [anon_sym_template] = ACTIONS(6194),
    [anon_sym_operator] = ACTIONS(6194),
    [anon_sym_friend] = ACTIONS(6194),
    [anon_sym_public] = ACTIONS(6194),
    [anon_sym_protected] = ACTIONS(6194),
    [anon_sym_static_assert] = ACTIONS(6194),
    [anon_sym_precise] = ACTIONS(6194),
    [anon_sym_shared] = ACTIONS(6194),
    [anon_sym_groupshared] = ACTIONS(6194),
    [anon_sym_uniform] = ACTIONS(6194),
    [anon_sym_row_major] = ACTIONS(6194),
    [anon_sym_column_major] = ACTIONS(6194),
    [anon_sym_globallycoherent] = ACTIONS(6194),
    [anon_sym_centroid] = ACTIONS(6194),
    [anon_sym_noperspective] = ACTIONS(6194),
    [anon_sym_nointerpolation] = ACTIONS(6194),
    [anon_sym_sample] = ACTIONS(6194),
    [anon_sym_linear] = ACTIONS(6194),
    [anon_sym_snorm] = ACTIONS(6194),
    [anon_sym_unorm] = ACTIONS(6194),
    [anon_sym_point] = ACTIONS(6194),
    [anon_sym_line] = ACTIONS(6194),
    [anon_sym_triangleadj] = ACTIONS(6194),
    [anon_sym_lineadj] = ACTIONS(6194),
    [anon_sym_triangle] = ACTIONS(6194),
    [anon_sym_interface] = ACTIONS(6194),
    [anon_sym_extension] = ACTIONS(6194),
    [anon_sym___init] = ACTIONS(6194),
    [anon_sym___subscript] = ACTIONS(6194),
    [anon_sym_property] = ACTIONS(6194),
    [anon_sym_associatedtype] = ACTIONS(6194),
  },
  [1691] = {
    [sym_expression] = STATE(5282),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_initializer_list] = STATE(9106),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_default] = ACTIONS(6200),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(6202),
    [aux_sym_pure_virtual_clause_token1] = ACTIONS(6204),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1692] = {
    [sym_identifier] = ACTIONS(6206),
    [aux_sym_preproc_def_token1] = ACTIONS(6206),
    [aux_sym_preproc_if_token1] = ACTIONS(6206),
    [aux_sym_preproc_if_token2] = ACTIONS(6206),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6206),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6206),
    [aux_sym_preproc_else_token1] = ACTIONS(6206),
    [aux_sym_preproc_elif_token1] = ACTIONS(6206),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6206),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6206),
    [sym_preproc_directive] = ACTIONS(6206),
    [anon_sym_LPAREN2] = ACTIONS(6208),
    [anon_sym_TILDE] = ACTIONS(6208),
    [anon_sym_STAR] = ACTIONS(6208),
    [anon_sym_AMP_AMP] = ACTIONS(6208),
    [anon_sym_AMP] = ACTIONS(6206),
    [anon_sym_SEMI] = ACTIONS(6208),
    [anon_sym___extension__] = ACTIONS(6206),
    [anon_sym_typedef] = ACTIONS(6206),
    [anon_sym_in] = ACTIONS(6206),
    [anon_sym_out] = ACTIONS(6206),
    [anon_sym_inout] = ACTIONS(6206),
    [anon_sym_virtual] = ACTIONS(6206),
    [anon_sym_extern] = ACTIONS(6206),
    [anon_sym___attribute__] = ACTIONS(6206),
    [anon_sym___attribute] = ACTIONS(6206),
    [anon_sym_using] = ACTIONS(6206),
    [anon_sym_COLON_COLON] = ACTIONS(6208),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6208),
    [anon_sym___declspec] = ACTIONS(6206),
    [anon_sym___based] = ACTIONS(6206),
    [anon_sym_signed] = ACTIONS(6206),
    [anon_sym_unsigned] = ACTIONS(6206),
    [anon_sym_long] = ACTIONS(6206),
    [anon_sym_short] = ACTIONS(6206),
    [anon_sym_LBRACK] = ACTIONS(6206),
    [anon_sym_static] = ACTIONS(6206),
    [anon_sym_register] = ACTIONS(6206),
    [anon_sym_inline] = ACTIONS(6206),
    [anon_sym___inline] = ACTIONS(6206),
    [anon_sym___inline__] = ACTIONS(6206),
    [anon_sym___forceinline] = ACTIONS(6206),
    [anon_sym_thread_local] = ACTIONS(6206),
    [anon_sym___thread] = ACTIONS(6206),
    [anon_sym_const] = ACTIONS(6206),
    [anon_sym_constexpr] = ACTIONS(6206),
    [anon_sym_volatile] = ACTIONS(6206),
    [anon_sym_restrict] = ACTIONS(6206),
    [anon_sym___restrict__] = ACTIONS(6206),
    [anon_sym__Atomic] = ACTIONS(6206),
    [anon_sym__Noreturn] = ACTIONS(6206),
    [anon_sym_noreturn] = ACTIONS(6206),
    [anon_sym__Nonnull] = ACTIONS(6206),
    [anon_sym_mutable] = ACTIONS(6206),
    [anon_sym_constinit] = ACTIONS(6206),
    [anon_sym_consteval] = ACTIONS(6206),
    [anon_sym_alignas] = ACTIONS(6206),
    [anon_sym__Alignas] = ACTIONS(6206),
    [sym_primitive_type] = ACTIONS(6206),
    [anon_sym_enum] = ACTIONS(6206),
    [anon_sym_class] = ACTIONS(6206),
    [anon_sym_struct] = ACTIONS(6206),
    [anon_sym_union] = ACTIONS(6206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6206),
    [anon_sym_let] = ACTIONS(6206),
    [anon_sym_This] = ACTIONS(6206),
    [anon_sym_decltype] = ACTIONS(6206),
    [anon_sym_explicit] = ACTIONS(6206),
    [anon_sym_typename] = ACTIONS(6206),
    [anon_sym_private] = ACTIONS(6206),
    [anon_sym_template] = ACTIONS(6206),
    [anon_sym_operator] = ACTIONS(6206),
    [anon_sym_friend] = ACTIONS(6206),
    [anon_sym_public] = ACTIONS(6206),
    [anon_sym_protected] = ACTIONS(6206),
    [anon_sym_static_assert] = ACTIONS(6206),
    [anon_sym_precise] = ACTIONS(6206),
    [anon_sym_shared] = ACTIONS(6206),
    [anon_sym_groupshared] = ACTIONS(6206),
    [anon_sym_uniform] = ACTIONS(6206),
    [anon_sym_row_major] = ACTIONS(6206),
    [anon_sym_column_major] = ACTIONS(6206),
    [anon_sym_globallycoherent] = ACTIONS(6206),
    [anon_sym_centroid] = ACTIONS(6206),
    [anon_sym_noperspective] = ACTIONS(6206),
    [anon_sym_nointerpolation] = ACTIONS(6206),
    [anon_sym_sample] = ACTIONS(6206),
    [anon_sym_linear] = ACTIONS(6206),
    [anon_sym_snorm] = ACTIONS(6206),
    [anon_sym_unorm] = ACTIONS(6206),
    [anon_sym_point] = ACTIONS(6206),
    [anon_sym_line] = ACTIONS(6206),
    [anon_sym_triangleadj] = ACTIONS(6206),
    [anon_sym_lineadj] = ACTIONS(6206),
    [anon_sym_triangle] = ACTIONS(6206),
    [anon_sym_interface] = ACTIONS(6206),
    [anon_sym_extension] = ACTIONS(6206),
    [anon_sym___init] = ACTIONS(6206),
    [anon_sym___subscript] = ACTIONS(6206),
    [anon_sym_property] = ACTIONS(6206),
    [anon_sym_associatedtype] = ACTIONS(6206),
  },
  [1693] = {
    [sym_identifier] = ACTIONS(3845),
    [aux_sym_preproc_def_token1] = ACTIONS(3845),
    [aux_sym_preproc_if_token1] = ACTIONS(3845),
    [aux_sym_preproc_if_token2] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3845),
    [aux_sym_preproc_else_token1] = ACTIONS(3845),
    [aux_sym_preproc_elif_token1] = ACTIONS(3845),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3845),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3845),
    [sym_preproc_directive] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3847),
    [anon_sym_STAR] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_SEMI] = ACTIONS(3847),
    [anon_sym___extension__] = ACTIONS(3845),
    [anon_sym_typedef] = ACTIONS(3845),
    [anon_sym_in] = ACTIONS(3845),
    [anon_sym_out] = ACTIONS(3845),
    [anon_sym_inout] = ACTIONS(3845),
    [anon_sym_virtual] = ACTIONS(3845),
    [anon_sym_extern] = ACTIONS(3845),
    [anon_sym___attribute__] = ACTIONS(3845),
    [anon_sym___attribute] = ACTIONS(3845),
    [anon_sym_using] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3847),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3847),
    [anon_sym___declspec] = ACTIONS(3845),
    [anon_sym___based] = ACTIONS(3845),
    [anon_sym_signed] = ACTIONS(3845),
    [anon_sym_unsigned] = ACTIONS(3845),
    [anon_sym_long] = ACTIONS(3845),
    [anon_sym_short] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_static] = ACTIONS(3845),
    [anon_sym_register] = ACTIONS(3845),
    [anon_sym_inline] = ACTIONS(3845),
    [anon_sym___inline] = ACTIONS(3845),
    [anon_sym___inline__] = ACTIONS(3845),
    [anon_sym___forceinline] = ACTIONS(3845),
    [anon_sym_thread_local] = ACTIONS(3845),
    [anon_sym___thread] = ACTIONS(3845),
    [anon_sym_const] = ACTIONS(3845),
    [anon_sym_constexpr] = ACTIONS(3845),
    [anon_sym_volatile] = ACTIONS(3845),
    [anon_sym_restrict] = ACTIONS(3845),
    [anon_sym___restrict__] = ACTIONS(3845),
    [anon_sym__Atomic] = ACTIONS(3845),
    [anon_sym__Noreturn] = ACTIONS(3845),
    [anon_sym_noreturn] = ACTIONS(3845),
    [anon_sym__Nonnull] = ACTIONS(3845),
    [anon_sym_mutable] = ACTIONS(3845),
    [anon_sym_constinit] = ACTIONS(3845),
    [anon_sym_consteval] = ACTIONS(3845),
    [anon_sym_alignas] = ACTIONS(3845),
    [anon_sym__Alignas] = ACTIONS(3845),
    [sym_primitive_type] = ACTIONS(3845),
    [anon_sym_enum] = ACTIONS(3845),
    [anon_sym_class] = ACTIONS(3845),
    [anon_sym_struct] = ACTIONS(3845),
    [anon_sym_union] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_This] = ACTIONS(3845),
    [anon_sym_decltype] = ACTIONS(3845),
    [anon_sym_explicit] = ACTIONS(3845),
    [anon_sym_typename] = ACTIONS(3845),
    [anon_sym_private] = ACTIONS(3845),
    [anon_sym_template] = ACTIONS(3845),
    [anon_sym_operator] = ACTIONS(3845),
    [anon_sym_friend] = ACTIONS(3845),
    [anon_sym_public] = ACTIONS(3845),
    [anon_sym_protected] = ACTIONS(3845),
    [anon_sym_static_assert] = ACTIONS(3845),
    [anon_sym_precise] = ACTIONS(3845),
    [anon_sym_shared] = ACTIONS(3845),
    [anon_sym_groupshared] = ACTIONS(3845),
    [anon_sym_uniform] = ACTIONS(3845),
    [anon_sym_row_major] = ACTIONS(3845),
    [anon_sym_column_major] = ACTIONS(3845),
    [anon_sym_globallycoherent] = ACTIONS(3845),
    [anon_sym_centroid] = ACTIONS(3845),
    [anon_sym_noperspective] = ACTIONS(3845),
    [anon_sym_nointerpolation] = ACTIONS(3845),
    [anon_sym_sample] = ACTIONS(3845),
    [anon_sym_linear] = ACTIONS(3845),
    [anon_sym_snorm] = ACTIONS(3845),
    [anon_sym_unorm] = ACTIONS(3845),
    [anon_sym_point] = ACTIONS(3845),
    [anon_sym_line] = ACTIONS(3845),
    [anon_sym_triangleadj] = ACTIONS(3845),
    [anon_sym_lineadj] = ACTIONS(3845),
    [anon_sym_triangle] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3845),
    [anon_sym_extension] = ACTIONS(3845),
    [anon_sym___init] = ACTIONS(3845),
    [anon_sym___subscript] = ACTIONS(3845),
    [anon_sym_property] = ACTIONS(3845),
    [anon_sym_associatedtype] = ACTIONS(3845),
  },
  [1694] = {
    [sym_identifier] = ACTIONS(6210),
    [aux_sym_preproc_def_token1] = ACTIONS(6210),
    [aux_sym_preproc_if_token1] = ACTIONS(6210),
    [aux_sym_preproc_if_token2] = ACTIONS(6210),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6210),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6210),
    [aux_sym_preproc_else_token1] = ACTIONS(6210),
    [aux_sym_preproc_elif_token1] = ACTIONS(6210),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6210),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6210),
    [sym_preproc_directive] = ACTIONS(6210),
    [anon_sym_LPAREN2] = ACTIONS(6212),
    [anon_sym_TILDE] = ACTIONS(6212),
    [anon_sym_STAR] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6210),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym___extension__] = ACTIONS(6210),
    [anon_sym_typedef] = ACTIONS(6210),
    [anon_sym_in] = ACTIONS(6210),
    [anon_sym_out] = ACTIONS(6210),
    [anon_sym_inout] = ACTIONS(6210),
    [anon_sym_virtual] = ACTIONS(6210),
    [anon_sym_extern] = ACTIONS(6210),
    [anon_sym___attribute__] = ACTIONS(6210),
    [anon_sym___attribute] = ACTIONS(6210),
    [anon_sym_using] = ACTIONS(6210),
    [anon_sym_COLON_COLON] = ACTIONS(6212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6212),
    [anon_sym___declspec] = ACTIONS(6210),
    [anon_sym___based] = ACTIONS(6210),
    [anon_sym_signed] = ACTIONS(6210),
    [anon_sym_unsigned] = ACTIONS(6210),
    [anon_sym_long] = ACTIONS(6210),
    [anon_sym_short] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_static] = ACTIONS(6210),
    [anon_sym_register] = ACTIONS(6210),
    [anon_sym_inline] = ACTIONS(6210),
    [anon_sym___inline] = ACTIONS(6210),
    [anon_sym___inline__] = ACTIONS(6210),
    [anon_sym___forceinline] = ACTIONS(6210),
    [anon_sym_thread_local] = ACTIONS(6210),
    [anon_sym___thread] = ACTIONS(6210),
    [anon_sym_const] = ACTIONS(6210),
    [anon_sym_constexpr] = ACTIONS(6210),
    [anon_sym_volatile] = ACTIONS(6210),
    [anon_sym_restrict] = ACTIONS(6210),
    [anon_sym___restrict__] = ACTIONS(6210),
    [anon_sym__Atomic] = ACTIONS(6210),
    [anon_sym__Noreturn] = ACTIONS(6210),
    [anon_sym_noreturn] = ACTIONS(6210),
    [anon_sym__Nonnull] = ACTIONS(6210),
    [anon_sym_mutable] = ACTIONS(6210),
    [anon_sym_constinit] = ACTIONS(6210),
    [anon_sym_consteval] = ACTIONS(6210),
    [anon_sym_alignas] = ACTIONS(6210),
    [anon_sym__Alignas] = ACTIONS(6210),
    [sym_primitive_type] = ACTIONS(6210),
    [anon_sym_enum] = ACTIONS(6210),
    [anon_sym_class] = ACTIONS(6210),
    [anon_sym_struct] = ACTIONS(6210),
    [anon_sym_union] = ACTIONS(6210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6210),
    [anon_sym_let] = ACTIONS(6210),
    [anon_sym_This] = ACTIONS(6210),
    [anon_sym_decltype] = ACTIONS(6210),
    [anon_sym_explicit] = ACTIONS(6210),
    [anon_sym_typename] = ACTIONS(6210),
    [anon_sym_private] = ACTIONS(6210),
    [anon_sym_template] = ACTIONS(6210),
    [anon_sym_operator] = ACTIONS(6210),
    [anon_sym_friend] = ACTIONS(6210),
    [anon_sym_public] = ACTIONS(6210),
    [anon_sym_protected] = ACTIONS(6210),
    [anon_sym_static_assert] = ACTIONS(6210),
    [anon_sym_precise] = ACTIONS(6210),
    [anon_sym_shared] = ACTIONS(6210),
    [anon_sym_groupshared] = ACTIONS(6210),
    [anon_sym_uniform] = ACTIONS(6210),
    [anon_sym_row_major] = ACTIONS(6210),
    [anon_sym_column_major] = ACTIONS(6210),
    [anon_sym_globallycoherent] = ACTIONS(6210),
    [anon_sym_centroid] = ACTIONS(6210),
    [anon_sym_noperspective] = ACTIONS(6210),
    [anon_sym_nointerpolation] = ACTIONS(6210),
    [anon_sym_sample] = ACTIONS(6210),
    [anon_sym_linear] = ACTIONS(6210),
    [anon_sym_snorm] = ACTIONS(6210),
    [anon_sym_unorm] = ACTIONS(6210),
    [anon_sym_point] = ACTIONS(6210),
    [anon_sym_line] = ACTIONS(6210),
    [anon_sym_triangleadj] = ACTIONS(6210),
    [anon_sym_lineadj] = ACTIONS(6210),
    [anon_sym_triangle] = ACTIONS(6210),
    [anon_sym_interface] = ACTIONS(6210),
    [anon_sym_extension] = ACTIONS(6210),
    [anon_sym___init] = ACTIONS(6210),
    [anon_sym___subscript] = ACTIONS(6210),
    [anon_sym_property] = ACTIONS(6210),
    [anon_sym_associatedtype] = ACTIONS(6210),
  },
  [1695] = {
    [sym_identifier] = ACTIONS(6214),
    [aux_sym_preproc_def_token1] = ACTIONS(6214),
    [aux_sym_preproc_if_token1] = ACTIONS(6214),
    [aux_sym_preproc_if_token2] = ACTIONS(6214),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6214),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6214),
    [aux_sym_preproc_else_token1] = ACTIONS(6214),
    [aux_sym_preproc_elif_token1] = ACTIONS(6214),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6214),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6214),
    [sym_preproc_directive] = ACTIONS(6214),
    [anon_sym_LPAREN2] = ACTIONS(6216),
    [anon_sym_TILDE] = ACTIONS(6216),
    [anon_sym_STAR] = ACTIONS(6216),
    [anon_sym_AMP_AMP] = ACTIONS(6216),
    [anon_sym_AMP] = ACTIONS(6214),
    [anon_sym_SEMI] = ACTIONS(6216),
    [anon_sym___extension__] = ACTIONS(6214),
    [anon_sym_typedef] = ACTIONS(6214),
    [anon_sym_in] = ACTIONS(6214),
    [anon_sym_out] = ACTIONS(6214),
    [anon_sym_inout] = ACTIONS(6214),
    [anon_sym_virtual] = ACTIONS(6214),
    [anon_sym_extern] = ACTIONS(6214),
    [anon_sym___attribute__] = ACTIONS(6214),
    [anon_sym___attribute] = ACTIONS(6214),
    [anon_sym_using] = ACTIONS(6214),
    [anon_sym_COLON_COLON] = ACTIONS(6216),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6216),
    [anon_sym___declspec] = ACTIONS(6214),
    [anon_sym___based] = ACTIONS(6214),
    [anon_sym_signed] = ACTIONS(6214),
    [anon_sym_unsigned] = ACTIONS(6214),
    [anon_sym_long] = ACTIONS(6214),
    [anon_sym_short] = ACTIONS(6214),
    [anon_sym_LBRACK] = ACTIONS(6214),
    [anon_sym_static] = ACTIONS(6214),
    [anon_sym_register] = ACTIONS(6214),
    [anon_sym_inline] = ACTIONS(6214),
    [anon_sym___inline] = ACTIONS(6214),
    [anon_sym___inline__] = ACTIONS(6214),
    [anon_sym___forceinline] = ACTIONS(6214),
    [anon_sym_thread_local] = ACTIONS(6214),
    [anon_sym___thread] = ACTIONS(6214),
    [anon_sym_const] = ACTIONS(6214),
    [anon_sym_constexpr] = ACTIONS(6214),
    [anon_sym_volatile] = ACTIONS(6214),
    [anon_sym_restrict] = ACTIONS(6214),
    [anon_sym___restrict__] = ACTIONS(6214),
    [anon_sym__Atomic] = ACTIONS(6214),
    [anon_sym__Noreturn] = ACTIONS(6214),
    [anon_sym_noreturn] = ACTIONS(6214),
    [anon_sym__Nonnull] = ACTIONS(6214),
    [anon_sym_mutable] = ACTIONS(6214),
    [anon_sym_constinit] = ACTIONS(6214),
    [anon_sym_consteval] = ACTIONS(6214),
    [anon_sym_alignas] = ACTIONS(6214),
    [anon_sym__Alignas] = ACTIONS(6214),
    [sym_primitive_type] = ACTIONS(6214),
    [anon_sym_enum] = ACTIONS(6214),
    [anon_sym_class] = ACTIONS(6214),
    [anon_sym_struct] = ACTIONS(6214),
    [anon_sym_union] = ACTIONS(6214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6214),
    [anon_sym_let] = ACTIONS(6214),
    [anon_sym_This] = ACTIONS(6214),
    [anon_sym_decltype] = ACTIONS(6214),
    [anon_sym_explicit] = ACTIONS(6214),
    [anon_sym_typename] = ACTIONS(6214),
    [anon_sym_private] = ACTIONS(6214),
    [anon_sym_template] = ACTIONS(6214),
    [anon_sym_operator] = ACTIONS(6214),
    [anon_sym_friend] = ACTIONS(6214),
    [anon_sym_public] = ACTIONS(6214),
    [anon_sym_protected] = ACTIONS(6214),
    [anon_sym_static_assert] = ACTIONS(6214),
    [anon_sym_precise] = ACTIONS(6214),
    [anon_sym_shared] = ACTIONS(6214),
    [anon_sym_groupshared] = ACTIONS(6214),
    [anon_sym_uniform] = ACTIONS(6214),
    [anon_sym_row_major] = ACTIONS(6214),
    [anon_sym_column_major] = ACTIONS(6214),
    [anon_sym_globallycoherent] = ACTIONS(6214),
    [anon_sym_centroid] = ACTIONS(6214),
    [anon_sym_noperspective] = ACTIONS(6214),
    [anon_sym_nointerpolation] = ACTIONS(6214),
    [anon_sym_sample] = ACTIONS(6214),
    [anon_sym_linear] = ACTIONS(6214),
    [anon_sym_snorm] = ACTIONS(6214),
    [anon_sym_unorm] = ACTIONS(6214),
    [anon_sym_point] = ACTIONS(6214),
    [anon_sym_line] = ACTIONS(6214),
    [anon_sym_triangleadj] = ACTIONS(6214),
    [anon_sym_lineadj] = ACTIONS(6214),
    [anon_sym_triangle] = ACTIONS(6214),
    [anon_sym_interface] = ACTIONS(6214),
    [anon_sym_extension] = ACTIONS(6214),
    [anon_sym___init] = ACTIONS(6214),
    [anon_sym___subscript] = ACTIONS(6214),
    [anon_sym_property] = ACTIONS(6214),
    [anon_sym_associatedtype] = ACTIONS(6214),
  },
  [1696] = {
    [sym_identifier] = ACTIONS(3845),
    [aux_sym_preproc_def_token1] = ACTIONS(3845),
    [aux_sym_preproc_if_token1] = ACTIONS(3845),
    [aux_sym_preproc_if_token2] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3845),
    [aux_sym_preproc_else_token1] = ACTIONS(3845),
    [aux_sym_preproc_elif_token1] = ACTIONS(3845),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3845),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3845),
    [sym_preproc_directive] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3847),
    [anon_sym_STAR] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_SEMI] = ACTIONS(3847),
    [anon_sym___extension__] = ACTIONS(3845),
    [anon_sym_typedef] = ACTIONS(3845),
    [anon_sym_in] = ACTIONS(3845),
    [anon_sym_out] = ACTIONS(3845),
    [anon_sym_inout] = ACTIONS(3845),
    [anon_sym_virtual] = ACTIONS(3845),
    [anon_sym_extern] = ACTIONS(3845),
    [anon_sym___attribute__] = ACTIONS(3845),
    [anon_sym___attribute] = ACTIONS(3845),
    [anon_sym_using] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3847),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3847),
    [anon_sym___declspec] = ACTIONS(3845),
    [anon_sym___based] = ACTIONS(3845),
    [anon_sym_signed] = ACTIONS(3845),
    [anon_sym_unsigned] = ACTIONS(3845),
    [anon_sym_long] = ACTIONS(3845),
    [anon_sym_short] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_static] = ACTIONS(3845),
    [anon_sym_register] = ACTIONS(3845),
    [anon_sym_inline] = ACTIONS(3845),
    [anon_sym___inline] = ACTIONS(3845),
    [anon_sym___inline__] = ACTIONS(3845),
    [anon_sym___forceinline] = ACTIONS(3845),
    [anon_sym_thread_local] = ACTIONS(3845),
    [anon_sym___thread] = ACTIONS(3845),
    [anon_sym_const] = ACTIONS(3845),
    [anon_sym_constexpr] = ACTIONS(3845),
    [anon_sym_volatile] = ACTIONS(3845),
    [anon_sym_restrict] = ACTIONS(3845),
    [anon_sym___restrict__] = ACTIONS(3845),
    [anon_sym__Atomic] = ACTIONS(3845),
    [anon_sym__Noreturn] = ACTIONS(3845),
    [anon_sym_noreturn] = ACTIONS(3845),
    [anon_sym__Nonnull] = ACTIONS(3845),
    [anon_sym_mutable] = ACTIONS(3845),
    [anon_sym_constinit] = ACTIONS(3845),
    [anon_sym_consteval] = ACTIONS(3845),
    [anon_sym_alignas] = ACTIONS(3845),
    [anon_sym__Alignas] = ACTIONS(3845),
    [sym_primitive_type] = ACTIONS(3845),
    [anon_sym_enum] = ACTIONS(3845),
    [anon_sym_class] = ACTIONS(3845),
    [anon_sym_struct] = ACTIONS(3845),
    [anon_sym_union] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_This] = ACTIONS(3845),
    [anon_sym_decltype] = ACTIONS(3845),
    [anon_sym_explicit] = ACTIONS(3845),
    [anon_sym_typename] = ACTIONS(3845),
    [anon_sym_private] = ACTIONS(3845),
    [anon_sym_template] = ACTIONS(3845),
    [anon_sym_operator] = ACTIONS(3845),
    [anon_sym_friend] = ACTIONS(3845),
    [anon_sym_public] = ACTIONS(3845),
    [anon_sym_protected] = ACTIONS(3845),
    [anon_sym_static_assert] = ACTIONS(3845),
    [anon_sym_precise] = ACTIONS(3845),
    [anon_sym_shared] = ACTIONS(3845),
    [anon_sym_groupshared] = ACTIONS(3845),
    [anon_sym_uniform] = ACTIONS(3845),
    [anon_sym_row_major] = ACTIONS(3845),
    [anon_sym_column_major] = ACTIONS(3845),
    [anon_sym_globallycoherent] = ACTIONS(3845),
    [anon_sym_centroid] = ACTIONS(3845),
    [anon_sym_noperspective] = ACTIONS(3845),
    [anon_sym_nointerpolation] = ACTIONS(3845),
    [anon_sym_sample] = ACTIONS(3845),
    [anon_sym_linear] = ACTIONS(3845),
    [anon_sym_snorm] = ACTIONS(3845),
    [anon_sym_unorm] = ACTIONS(3845),
    [anon_sym_point] = ACTIONS(3845),
    [anon_sym_line] = ACTIONS(3845),
    [anon_sym_triangleadj] = ACTIONS(3845),
    [anon_sym_lineadj] = ACTIONS(3845),
    [anon_sym_triangle] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3845),
    [anon_sym_extension] = ACTIONS(3845),
    [anon_sym___init] = ACTIONS(3845),
    [anon_sym___subscript] = ACTIONS(3845),
    [anon_sym_property] = ACTIONS(3845),
    [anon_sym_associatedtype] = ACTIONS(3845),
  },
  [1697] = {
    [sym_identifier] = ACTIONS(6218),
    [aux_sym_preproc_def_token1] = ACTIONS(6218),
    [aux_sym_preproc_if_token1] = ACTIONS(6218),
    [aux_sym_preproc_if_token2] = ACTIONS(6218),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6218),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6218),
    [aux_sym_preproc_else_token1] = ACTIONS(6218),
    [aux_sym_preproc_elif_token1] = ACTIONS(6218),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6218),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6218),
    [sym_preproc_directive] = ACTIONS(6218),
    [anon_sym_LPAREN2] = ACTIONS(6220),
    [anon_sym_TILDE] = ACTIONS(6220),
    [anon_sym_STAR] = ACTIONS(6220),
    [anon_sym_AMP_AMP] = ACTIONS(6220),
    [anon_sym_AMP] = ACTIONS(6218),
    [anon_sym_SEMI] = ACTIONS(6220),
    [anon_sym___extension__] = ACTIONS(6218),
    [anon_sym_typedef] = ACTIONS(6218),
    [anon_sym_in] = ACTIONS(6218),
    [anon_sym_out] = ACTIONS(6218),
    [anon_sym_inout] = ACTIONS(6218),
    [anon_sym_virtual] = ACTIONS(6218),
    [anon_sym_extern] = ACTIONS(6218),
    [anon_sym___attribute__] = ACTIONS(6218),
    [anon_sym___attribute] = ACTIONS(6218),
    [anon_sym_using] = ACTIONS(6218),
    [anon_sym_COLON_COLON] = ACTIONS(6220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6220),
    [anon_sym___declspec] = ACTIONS(6218),
    [anon_sym___based] = ACTIONS(6218),
    [anon_sym_signed] = ACTIONS(6218),
    [anon_sym_unsigned] = ACTIONS(6218),
    [anon_sym_long] = ACTIONS(6218),
    [anon_sym_short] = ACTIONS(6218),
    [anon_sym_LBRACK] = ACTIONS(6218),
    [anon_sym_static] = ACTIONS(6218),
    [anon_sym_register] = ACTIONS(6218),
    [anon_sym_inline] = ACTIONS(6218),
    [anon_sym___inline] = ACTIONS(6218),
    [anon_sym___inline__] = ACTIONS(6218),
    [anon_sym___forceinline] = ACTIONS(6218),
    [anon_sym_thread_local] = ACTIONS(6218),
    [anon_sym___thread] = ACTIONS(6218),
    [anon_sym_const] = ACTIONS(6218),
    [anon_sym_constexpr] = ACTIONS(6218),
    [anon_sym_volatile] = ACTIONS(6218),
    [anon_sym_restrict] = ACTIONS(6218),
    [anon_sym___restrict__] = ACTIONS(6218),
    [anon_sym__Atomic] = ACTIONS(6218),
    [anon_sym__Noreturn] = ACTIONS(6218),
    [anon_sym_noreturn] = ACTIONS(6218),
    [anon_sym__Nonnull] = ACTIONS(6218),
    [anon_sym_mutable] = ACTIONS(6218),
    [anon_sym_constinit] = ACTIONS(6218),
    [anon_sym_consteval] = ACTIONS(6218),
    [anon_sym_alignas] = ACTIONS(6218),
    [anon_sym__Alignas] = ACTIONS(6218),
    [sym_primitive_type] = ACTIONS(6218),
    [anon_sym_enum] = ACTIONS(6218),
    [anon_sym_class] = ACTIONS(6218),
    [anon_sym_struct] = ACTIONS(6218),
    [anon_sym_union] = ACTIONS(6218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6218),
    [anon_sym_let] = ACTIONS(6218),
    [anon_sym_This] = ACTIONS(6218),
    [anon_sym_decltype] = ACTIONS(6218),
    [anon_sym_explicit] = ACTIONS(6218),
    [anon_sym_typename] = ACTIONS(6218),
    [anon_sym_private] = ACTIONS(6218),
    [anon_sym_template] = ACTIONS(6218),
    [anon_sym_operator] = ACTIONS(6218),
    [anon_sym_friend] = ACTIONS(6218),
    [anon_sym_public] = ACTIONS(6218),
    [anon_sym_protected] = ACTIONS(6218),
    [anon_sym_static_assert] = ACTIONS(6218),
    [anon_sym_precise] = ACTIONS(6218),
    [anon_sym_shared] = ACTIONS(6218),
    [anon_sym_groupshared] = ACTIONS(6218),
    [anon_sym_uniform] = ACTIONS(6218),
    [anon_sym_row_major] = ACTIONS(6218),
    [anon_sym_column_major] = ACTIONS(6218),
    [anon_sym_globallycoherent] = ACTIONS(6218),
    [anon_sym_centroid] = ACTIONS(6218),
    [anon_sym_noperspective] = ACTIONS(6218),
    [anon_sym_nointerpolation] = ACTIONS(6218),
    [anon_sym_sample] = ACTIONS(6218),
    [anon_sym_linear] = ACTIONS(6218),
    [anon_sym_snorm] = ACTIONS(6218),
    [anon_sym_unorm] = ACTIONS(6218),
    [anon_sym_point] = ACTIONS(6218),
    [anon_sym_line] = ACTIONS(6218),
    [anon_sym_triangleadj] = ACTIONS(6218),
    [anon_sym_lineadj] = ACTIONS(6218),
    [anon_sym_triangle] = ACTIONS(6218),
    [anon_sym_interface] = ACTIONS(6218),
    [anon_sym_extension] = ACTIONS(6218),
    [anon_sym___init] = ACTIONS(6218),
    [anon_sym___subscript] = ACTIONS(6218),
    [anon_sym_property] = ACTIONS(6218),
    [anon_sym_associatedtype] = ACTIONS(6218),
  },
  [1698] = {
    [sym_identifier] = ACTIONS(3808),
    [aux_sym_preproc_def_token1] = ACTIONS(3808),
    [aux_sym_preproc_if_token1] = ACTIONS(3808),
    [aux_sym_preproc_if_token2] = ACTIONS(3808),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3808),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3808),
    [aux_sym_preproc_else_token1] = ACTIONS(3808),
    [aux_sym_preproc_elif_token1] = ACTIONS(3808),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3808),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3808),
    [sym_preproc_directive] = ACTIONS(3808),
    [anon_sym_LPAREN2] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [anon_sym_STAR] = ACTIONS(3810),
    [anon_sym_AMP_AMP] = ACTIONS(3810),
    [anon_sym_AMP] = ACTIONS(3808),
    [anon_sym_SEMI] = ACTIONS(3810),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_typedef] = ACTIONS(3808),
    [anon_sym_in] = ACTIONS(3808),
    [anon_sym_out] = ACTIONS(3808),
    [anon_sym_inout] = ACTIONS(3808),
    [anon_sym_virtual] = ACTIONS(3808),
    [anon_sym_extern] = ACTIONS(3808),
    [anon_sym___attribute__] = ACTIONS(3808),
    [anon_sym___attribute] = ACTIONS(3808),
    [anon_sym_using] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3810),
    [anon_sym___declspec] = ACTIONS(3808),
    [anon_sym___based] = ACTIONS(3808),
    [anon_sym_signed] = ACTIONS(3808),
    [anon_sym_unsigned] = ACTIONS(3808),
    [anon_sym_long] = ACTIONS(3808),
    [anon_sym_short] = ACTIONS(3808),
    [anon_sym_LBRACK] = ACTIONS(3808),
    [anon_sym_static] = ACTIONS(3808),
    [anon_sym_register] = ACTIONS(3808),
    [anon_sym_inline] = ACTIONS(3808),
    [anon_sym___inline] = ACTIONS(3808),
    [anon_sym___inline__] = ACTIONS(3808),
    [anon_sym___forceinline] = ACTIONS(3808),
    [anon_sym_thread_local] = ACTIONS(3808),
    [anon_sym___thread] = ACTIONS(3808),
    [anon_sym_const] = ACTIONS(3808),
    [anon_sym_constexpr] = ACTIONS(3808),
    [anon_sym_volatile] = ACTIONS(3808),
    [anon_sym_restrict] = ACTIONS(3808),
    [anon_sym___restrict__] = ACTIONS(3808),
    [anon_sym__Atomic] = ACTIONS(3808),
    [anon_sym__Noreturn] = ACTIONS(3808),
    [anon_sym_noreturn] = ACTIONS(3808),
    [anon_sym__Nonnull] = ACTIONS(3808),
    [anon_sym_mutable] = ACTIONS(3808),
    [anon_sym_constinit] = ACTIONS(3808),
    [anon_sym_consteval] = ACTIONS(3808),
    [anon_sym_alignas] = ACTIONS(3808),
    [anon_sym__Alignas] = ACTIONS(3808),
    [sym_primitive_type] = ACTIONS(3808),
    [anon_sym_enum] = ACTIONS(3808),
    [anon_sym_class] = ACTIONS(3808),
    [anon_sym_struct] = ACTIONS(3808),
    [anon_sym_union] = ACTIONS(3808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3808),
    [anon_sym_let] = ACTIONS(3808),
    [anon_sym_This] = ACTIONS(3808),
    [anon_sym_decltype] = ACTIONS(3808),
    [anon_sym_explicit] = ACTIONS(3808),
    [anon_sym_typename] = ACTIONS(3808),
    [anon_sym_private] = ACTIONS(3808),
    [anon_sym_template] = ACTIONS(3808),
    [anon_sym_operator] = ACTIONS(3808),
    [anon_sym_friend] = ACTIONS(3808),
    [anon_sym_public] = ACTIONS(3808),
    [anon_sym_protected] = ACTIONS(3808),
    [anon_sym_static_assert] = ACTIONS(3808),
    [anon_sym_precise] = ACTIONS(3808),
    [anon_sym_shared] = ACTIONS(3808),
    [anon_sym_groupshared] = ACTIONS(3808),
    [anon_sym_uniform] = ACTIONS(3808),
    [anon_sym_row_major] = ACTIONS(3808),
    [anon_sym_column_major] = ACTIONS(3808),
    [anon_sym_globallycoherent] = ACTIONS(3808),
    [anon_sym_centroid] = ACTIONS(3808),
    [anon_sym_noperspective] = ACTIONS(3808),
    [anon_sym_nointerpolation] = ACTIONS(3808),
    [anon_sym_sample] = ACTIONS(3808),
    [anon_sym_linear] = ACTIONS(3808),
    [anon_sym_snorm] = ACTIONS(3808),
    [anon_sym_unorm] = ACTIONS(3808),
    [anon_sym_point] = ACTIONS(3808),
    [anon_sym_line] = ACTIONS(3808),
    [anon_sym_triangleadj] = ACTIONS(3808),
    [anon_sym_lineadj] = ACTIONS(3808),
    [anon_sym_triangle] = ACTIONS(3808),
    [anon_sym_interface] = ACTIONS(3808),
    [anon_sym_extension] = ACTIONS(3808),
    [anon_sym___init] = ACTIONS(3808),
    [anon_sym___subscript] = ACTIONS(3808),
    [anon_sym_property] = ACTIONS(3808),
    [anon_sym_associatedtype] = ACTIONS(3808),
  },
  [1699] = {
    [sym_identifier] = ACTIONS(6218),
    [aux_sym_preproc_def_token1] = ACTIONS(6218),
    [aux_sym_preproc_if_token1] = ACTIONS(6218),
    [aux_sym_preproc_if_token2] = ACTIONS(6218),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6218),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6218),
    [aux_sym_preproc_else_token1] = ACTIONS(6218),
    [aux_sym_preproc_elif_token1] = ACTIONS(6218),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6218),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6218),
    [sym_preproc_directive] = ACTIONS(6218),
    [anon_sym_LPAREN2] = ACTIONS(6220),
    [anon_sym_TILDE] = ACTIONS(6220),
    [anon_sym_STAR] = ACTIONS(6220),
    [anon_sym_AMP_AMP] = ACTIONS(6220),
    [anon_sym_AMP] = ACTIONS(6218),
    [anon_sym_SEMI] = ACTIONS(6220),
    [anon_sym___extension__] = ACTIONS(6218),
    [anon_sym_typedef] = ACTIONS(6218),
    [anon_sym_in] = ACTIONS(6218),
    [anon_sym_out] = ACTIONS(6218),
    [anon_sym_inout] = ACTIONS(6218),
    [anon_sym_virtual] = ACTIONS(6218),
    [anon_sym_extern] = ACTIONS(6218),
    [anon_sym___attribute__] = ACTIONS(6218),
    [anon_sym___attribute] = ACTIONS(6218),
    [anon_sym_using] = ACTIONS(6218),
    [anon_sym_COLON_COLON] = ACTIONS(6220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6220),
    [anon_sym___declspec] = ACTIONS(6218),
    [anon_sym___based] = ACTIONS(6218),
    [anon_sym_signed] = ACTIONS(6218),
    [anon_sym_unsigned] = ACTIONS(6218),
    [anon_sym_long] = ACTIONS(6218),
    [anon_sym_short] = ACTIONS(6218),
    [anon_sym_LBRACK] = ACTIONS(6218),
    [anon_sym_static] = ACTIONS(6218),
    [anon_sym_register] = ACTIONS(6218),
    [anon_sym_inline] = ACTIONS(6218),
    [anon_sym___inline] = ACTIONS(6218),
    [anon_sym___inline__] = ACTIONS(6218),
    [anon_sym___forceinline] = ACTIONS(6218),
    [anon_sym_thread_local] = ACTIONS(6218),
    [anon_sym___thread] = ACTIONS(6218),
    [anon_sym_const] = ACTIONS(6218),
    [anon_sym_constexpr] = ACTIONS(6218),
    [anon_sym_volatile] = ACTIONS(6218),
    [anon_sym_restrict] = ACTIONS(6218),
    [anon_sym___restrict__] = ACTIONS(6218),
    [anon_sym__Atomic] = ACTIONS(6218),
    [anon_sym__Noreturn] = ACTIONS(6218),
    [anon_sym_noreturn] = ACTIONS(6218),
    [anon_sym__Nonnull] = ACTIONS(6218),
    [anon_sym_mutable] = ACTIONS(6218),
    [anon_sym_constinit] = ACTIONS(6218),
    [anon_sym_consteval] = ACTIONS(6218),
    [anon_sym_alignas] = ACTIONS(6218),
    [anon_sym__Alignas] = ACTIONS(6218),
    [sym_primitive_type] = ACTIONS(6218),
    [anon_sym_enum] = ACTIONS(6218),
    [anon_sym_class] = ACTIONS(6218),
    [anon_sym_struct] = ACTIONS(6218),
    [anon_sym_union] = ACTIONS(6218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6218),
    [anon_sym_let] = ACTIONS(6218),
    [anon_sym_This] = ACTIONS(6218),
    [anon_sym_decltype] = ACTIONS(6218),
    [anon_sym_explicit] = ACTIONS(6218),
    [anon_sym_typename] = ACTIONS(6218),
    [anon_sym_private] = ACTIONS(6218),
    [anon_sym_template] = ACTIONS(6218),
    [anon_sym_operator] = ACTIONS(6218),
    [anon_sym_friend] = ACTIONS(6218),
    [anon_sym_public] = ACTIONS(6218),
    [anon_sym_protected] = ACTIONS(6218),
    [anon_sym_static_assert] = ACTIONS(6218),
    [anon_sym_precise] = ACTIONS(6218),
    [anon_sym_shared] = ACTIONS(6218),
    [anon_sym_groupshared] = ACTIONS(6218),
    [anon_sym_uniform] = ACTIONS(6218),
    [anon_sym_row_major] = ACTIONS(6218),
    [anon_sym_column_major] = ACTIONS(6218),
    [anon_sym_globallycoherent] = ACTIONS(6218),
    [anon_sym_centroid] = ACTIONS(6218),
    [anon_sym_noperspective] = ACTIONS(6218),
    [anon_sym_nointerpolation] = ACTIONS(6218),
    [anon_sym_sample] = ACTIONS(6218),
    [anon_sym_linear] = ACTIONS(6218),
    [anon_sym_snorm] = ACTIONS(6218),
    [anon_sym_unorm] = ACTIONS(6218),
    [anon_sym_point] = ACTIONS(6218),
    [anon_sym_line] = ACTIONS(6218),
    [anon_sym_triangleadj] = ACTIONS(6218),
    [anon_sym_lineadj] = ACTIONS(6218),
    [anon_sym_triangle] = ACTIONS(6218),
    [anon_sym_interface] = ACTIONS(6218),
    [anon_sym_extension] = ACTIONS(6218),
    [anon_sym___init] = ACTIONS(6218),
    [anon_sym___subscript] = ACTIONS(6218),
    [anon_sym_property] = ACTIONS(6218),
    [anon_sym_associatedtype] = ACTIONS(6218),
  },
  [1700] = {
    [sym_identifier] = ACTIONS(6222),
    [aux_sym_preproc_def_token1] = ACTIONS(6222),
    [aux_sym_preproc_if_token1] = ACTIONS(6222),
    [aux_sym_preproc_if_token2] = ACTIONS(6222),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6222),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6222),
    [aux_sym_preproc_else_token1] = ACTIONS(6222),
    [aux_sym_preproc_elif_token1] = ACTIONS(6222),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6222),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6222),
    [sym_preproc_directive] = ACTIONS(6222),
    [anon_sym_LPAREN2] = ACTIONS(6224),
    [anon_sym_TILDE] = ACTIONS(6224),
    [anon_sym_STAR] = ACTIONS(6224),
    [anon_sym_AMP_AMP] = ACTIONS(6224),
    [anon_sym_AMP] = ACTIONS(6222),
    [anon_sym_SEMI] = ACTIONS(6224),
    [anon_sym___extension__] = ACTIONS(6222),
    [anon_sym_typedef] = ACTIONS(6222),
    [anon_sym_in] = ACTIONS(6222),
    [anon_sym_out] = ACTIONS(6222),
    [anon_sym_inout] = ACTIONS(6222),
    [anon_sym_virtual] = ACTIONS(6222),
    [anon_sym_extern] = ACTIONS(6222),
    [anon_sym___attribute__] = ACTIONS(6222),
    [anon_sym___attribute] = ACTIONS(6222),
    [anon_sym_using] = ACTIONS(6222),
    [anon_sym_COLON_COLON] = ACTIONS(6224),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6224),
    [anon_sym___declspec] = ACTIONS(6222),
    [anon_sym___based] = ACTIONS(6222),
    [anon_sym_signed] = ACTIONS(6222),
    [anon_sym_unsigned] = ACTIONS(6222),
    [anon_sym_long] = ACTIONS(6222),
    [anon_sym_short] = ACTIONS(6222),
    [anon_sym_LBRACK] = ACTIONS(6222),
    [anon_sym_static] = ACTIONS(6222),
    [anon_sym_register] = ACTIONS(6222),
    [anon_sym_inline] = ACTIONS(6222),
    [anon_sym___inline] = ACTIONS(6222),
    [anon_sym___inline__] = ACTIONS(6222),
    [anon_sym___forceinline] = ACTIONS(6222),
    [anon_sym_thread_local] = ACTIONS(6222),
    [anon_sym___thread] = ACTIONS(6222),
    [anon_sym_const] = ACTIONS(6222),
    [anon_sym_constexpr] = ACTIONS(6222),
    [anon_sym_volatile] = ACTIONS(6222),
    [anon_sym_restrict] = ACTIONS(6222),
    [anon_sym___restrict__] = ACTIONS(6222),
    [anon_sym__Atomic] = ACTIONS(6222),
    [anon_sym__Noreturn] = ACTIONS(6222),
    [anon_sym_noreturn] = ACTIONS(6222),
    [anon_sym__Nonnull] = ACTIONS(6222),
    [anon_sym_mutable] = ACTIONS(6222),
    [anon_sym_constinit] = ACTIONS(6222),
    [anon_sym_consteval] = ACTIONS(6222),
    [anon_sym_alignas] = ACTIONS(6222),
    [anon_sym__Alignas] = ACTIONS(6222),
    [sym_primitive_type] = ACTIONS(6222),
    [anon_sym_enum] = ACTIONS(6222),
    [anon_sym_class] = ACTIONS(6222),
    [anon_sym_struct] = ACTIONS(6222),
    [anon_sym_union] = ACTIONS(6222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6222),
    [anon_sym_let] = ACTIONS(6222),
    [anon_sym_This] = ACTIONS(6222),
    [anon_sym_decltype] = ACTIONS(6222),
    [anon_sym_explicit] = ACTIONS(6222),
    [anon_sym_typename] = ACTIONS(6222),
    [anon_sym_private] = ACTIONS(6222),
    [anon_sym_template] = ACTIONS(6222),
    [anon_sym_operator] = ACTIONS(6222),
    [anon_sym_friend] = ACTIONS(6222),
    [anon_sym_public] = ACTIONS(6222),
    [anon_sym_protected] = ACTIONS(6222),
    [anon_sym_static_assert] = ACTIONS(6222),
    [anon_sym_precise] = ACTIONS(6222),
    [anon_sym_shared] = ACTIONS(6222),
    [anon_sym_groupshared] = ACTIONS(6222),
    [anon_sym_uniform] = ACTIONS(6222),
    [anon_sym_row_major] = ACTIONS(6222),
    [anon_sym_column_major] = ACTIONS(6222),
    [anon_sym_globallycoherent] = ACTIONS(6222),
    [anon_sym_centroid] = ACTIONS(6222),
    [anon_sym_noperspective] = ACTIONS(6222),
    [anon_sym_nointerpolation] = ACTIONS(6222),
    [anon_sym_sample] = ACTIONS(6222),
    [anon_sym_linear] = ACTIONS(6222),
    [anon_sym_snorm] = ACTIONS(6222),
    [anon_sym_unorm] = ACTIONS(6222),
    [anon_sym_point] = ACTIONS(6222),
    [anon_sym_line] = ACTIONS(6222),
    [anon_sym_triangleadj] = ACTIONS(6222),
    [anon_sym_lineadj] = ACTIONS(6222),
    [anon_sym_triangle] = ACTIONS(6222),
    [anon_sym_interface] = ACTIONS(6222),
    [anon_sym_extension] = ACTIONS(6222),
    [anon_sym___init] = ACTIONS(6222),
    [anon_sym___subscript] = ACTIONS(6222),
    [anon_sym_property] = ACTIONS(6222),
    [anon_sym_associatedtype] = ACTIONS(6222),
  },
  [1701] = {
    [sym_identifier] = ACTIONS(6226),
    [aux_sym_preproc_def_token1] = ACTIONS(6226),
    [aux_sym_preproc_if_token1] = ACTIONS(6226),
    [aux_sym_preproc_if_token2] = ACTIONS(6226),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6226),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6226),
    [aux_sym_preproc_else_token1] = ACTIONS(6226),
    [aux_sym_preproc_elif_token1] = ACTIONS(6226),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6226),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6226),
    [sym_preproc_directive] = ACTIONS(6226),
    [anon_sym_LPAREN2] = ACTIONS(6228),
    [anon_sym_TILDE] = ACTIONS(6228),
    [anon_sym_STAR] = ACTIONS(6228),
    [anon_sym_AMP_AMP] = ACTIONS(6228),
    [anon_sym_AMP] = ACTIONS(6226),
    [anon_sym_SEMI] = ACTIONS(6228),
    [anon_sym___extension__] = ACTIONS(6226),
    [anon_sym_typedef] = ACTIONS(6226),
    [anon_sym_in] = ACTIONS(6226),
    [anon_sym_out] = ACTIONS(6226),
    [anon_sym_inout] = ACTIONS(6226),
    [anon_sym_virtual] = ACTIONS(6226),
    [anon_sym_extern] = ACTIONS(6226),
    [anon_sym___attribute__] = ACTIONS(6226),
    [anon_sym___attribute] = ACTIONS(6226),
    [anon_sym_using] = ACTIONS(6226),
    [anon_sym_COLON_COLON] = ACTIONS(6228),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6228),
    [anon_sym___declspec] = ACTIONS(6226),
    [anon_sym___based] = ACTIONS(6226),
    [anon_sym_signed] = ACTIONS(6226),
    [anon_sym_unsigned] = ACTIONS(6226),
    [anon_sym_long] = ACTIONS(6226),
    [anon_sym_short] = ACTIONS(6226),
    [anon_sym_LBRACK] = ACTIONS(6226),
    [anon_sym_static] = ACTIONS(6226),
    [anon_sym_register] = ACTIONS(6226),
    [anon_sym_inline] = ACTIONS(6226),
    [anon_sym___inline] = ACTIONS(6226),
    [anon_sym___inline__] = ACTIONS(6226),
    [anon_sym___forceinline] = ACTIONS(6226),
    [anon_sym_thread_local] = ACTIONS(6226),
    [anon_sym___thread] = ACTIONS(6226),
    [anon_sym_const] = ACTIONS(6226),
    [anon_sym_constexpr] = ACTIONS(6226),
    [anon_sym_volatile] = ACTIONS(6226),
    [anon_sym_restrict] = ACTIONS(6226),
    [anon_sym___restrict__] = ACTIONS(6226),
    [anon_sym__Atomic] = ACTIONS(6226),
    [anon_sym__Noreturn] = ACTIONS(6226),
    [anon_sym_noreturn] = ACTIONS(6226),
    [anon_sym__Nonnull] = ACTIONS(6226),
    [anon_sym_mutable] = ACTIONS(6226),
    [anon_sym_constinit] = ACTIONS(6226),
    [anon_sym_consteval] = ACTIONS(6226),
    [anon_sym_alignas] = ACTIONS(6226),
    [anon_sym__Alignas] = ACTIONS(6226),
    [sym_primitive_type] = ACTIONS(6226),
    [anon_sym_enum] = ACTIONS(6226),
    [anon_sym_class] = ACTIONS(6226),
    [anon_sym_struct] = ACTIONS(6226),
    [anon_sym_union] = ACTIONS(6226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6226),
    [anon_sym_let] = ACTIONS(6226),
    [anon_sym_This] = ACTIONS(6226),
    [anon_sym_decltype] = ACTIONS(6226),
    [anon_sym_explicit] = ACTIONS(6226),
    [anon_sym_typename] = ACTIONS(6226),
    [anon_sym_private] = ACTIONS(6226),
    [anon_sym_template] = ACTIONS(6226),
    [anon_sym_operator] = ACTIONS(6226),
    [anon_sym_friend] = ACTIONS(6226),
    [anon_sym_public] = ACTIONS(6226),
    [anon_sym_protected] = ACTIONS(6226),
    [anon_sym_static_assert] = ACTIONS(6226),
    [anon_sym_precise] = ACTIONS(6226),
    [anon_sym_shared] = ACTIONS(6226),
    [anon_sym_groupshared] = ACTIONS(6226),
    [anon_sym_uniform] = ACTIONS(6226),
    [anon_sym_row_major] = ACTIONS(6226),
    [anon_sym_column_major] = ACTIONS(6226),
    [anon_sym_globallycoherent] = ACTIONS(6226),
    [anon_sym_centroid] = ACTIONS(6226),
    [anon_sym_noperspective] = ACTIONS(6226),
    [anon_sym_nointerpolation] = ACTIONS(6226),
    [anon_sym_sample] = ACTIONS(6226),
    [anon_sym_linear] = ACTIONS(6226),
    [anon_sym_snorm] = ACTIONS(6226),
    [anon_sym_unorm] = ACTIONS(6226),
    [anon_sym_point] = ACTIONS(6226),
    [anon_sym_line] = ACTIONS(6226),
    [anon_sym_triangleadj] = ACTIONS(6226),
    [anon_sym_lineadj] = ACTIONS(6226),
    [anon_sym_triangle] = ACTIONS(6226),
    [anon_sym_interface] = ACTIONS(6226),
    [anon_sym_extension] = ACTIONS(6226),
    [anon_sym___init] = ACTIONS(6226),
    [anon_sym___subscript] = ACTIONS(6226),
    [anon_sym_property] = ACTIONS(6226),
    [anon_sym_associatedtype] = ACTIONS(6226),
  },
  [1702] = {
    [sym_identifier] = ACTIONS(3857),
    [aux_sym_preproc_def_token1] = ACTIONS(3857),
    [aux_sym_preproc_if_token1] = ACTIONS(3857),
    [aux_sym_preproc_if_token2] = ACTIONS(3857),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3857),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3857),
    [aux_sym_preproc_else_token1] = ACTIONS(3857),
    [aux_sym_preproc_elif_token1] = ACTIONS(3857),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3857),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3857),
    [sym_preproc_directive] = ACTIONS(3857),
    [anon_sym_LPAREN2] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3859),
    [anon_sym_STAR] = ACTIONS(3859),
    [anon_sym_AMP_AMP] = ACTIONS(3859),
    [anon_sym_AMP] = ACTIONS(3857),
    [anon_sym_SEMI] = ACTIONS(3859),
    [anon_sym___extension__] = ACTIONS(3857),
    [anon_sym_typedef] = ACTIONS(3857),
    [anon_sym_in] = ACTIONS(3857),
    [anon_sym_out] = ACTIONS(3857),
    [anon_sym_inout] = ACTIONS(3857),
    [anon_sym_virtual] = ACTIONS(3857),
    [anon_sym_extern] = ACTIONS(3857),
    [anon_sym___attribute__] = ACTIONS(3857),
    [anon_sym___attribute] = ACTIONS(3857),
    [anon_sym_using] = ACTIONS(3857),
    [anon_sym_COLON_COLON] = ACTIONS(3859),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3859),
    [anon_sym___declspec] = ACTIONS(3857),
    [anon_sym___based] = ACTIONS(3857),
    [anon_sym_signed] = ACTIONS(3857),
    [anon_sym_unsigned] = ACTIONS(3857),
    [anon_sym_long] = ACTIONS(3857),
    [anon_sym_short] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(3857),
    [anon_sym_static] = ACTIONS(3857),
    [anon_sym_register] = ACTIONS(3857),
    [anon_sym_inline] = ACTIONS(3857),
    [anon_sym___inline] = ACTIONS(3857),
    [anon_sym___inline__] = ACTIONS(3857),
    [anon_sym___forceinline] = ACTIONS(3857),
    [anon_sym_thread_local] = ACTIONS(3857),
    [anon_sym___thread] = ACTIONS(3857),
    [anon_sym_const] = ACTIONS(3857),
    [anon_sym_constexpr] = ACTIONS(3857),
    [anon_sym_volatile] = ACTIONS(3857),
    [anon_sym_restrict] = ACTIONS(3857),
    [anon_sym___restrict__] = ACTIONS(3857),
    [anon_sym__Atomic] = ACTIONS(3857),
    [anon_sym__Noreturn] = ACTIONS(3857),
    [anon_sym_noreturn] = ACTIONS(3857),
    [anon_sym__Nonnull] = ACTIONS(3857),
    [anon_sym_mutable] = ACTIONS(3857),
    [anon_sym_constinit] = ACTIONS(3857),
    [anon_sym_consteval] = ACTIONS(3857),
    [anon_sym_alignas] = ACTIONS(3857),
    [anon_sym__Alignas] = ACTIONS(3857),
    [sym_primitive_type] = ACTIONS(3857),
    [anon_sym_enum] = ACTIONS(3857),
    [anon_sym_class] = ACTIONS(3857),
    [anon_sym_struct] = ACTIONS(3857),
    [anon_sym_union] = ACTIONS(3857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3857),
    [anon_sym_let] = ACTIONS(3857),
    [anon_sym_This] = ACTIONS(3857),
    [anon_sym_decltype] = ACTIONS(3857),
    [anon_sym_explicit] = ACTIONS(3857),
    [anon_sym_typename] = ACTIONS(3857),
    [anon_sym_private] = ACTIONS(3857),
    [anon_sym_template] = ACTIONS(3857),
    [anon_sym_operator] = ACTIONS(3857),
    [anon_sym_friend] = ACTIONS(3857),
    [anon_sym_public] = ACTIONS(3857),
    [anon_sym_protected] = ACTIONS(3857),
    [anon_sym_static_assert] = ACTIONS(3857),
    [anon_sym_precise] = ACTIONS(3857),
    [anon_sym_shared] = ACTIONS(3857),
    [anon_sym_groupshared] = ACTIONS(3857),
    [anon_sym_uniform] = ACTIONS(3857),
    [anon_sym_row_major] = ACTIONS(3857),
    [anon_sym_column_major] = ACTIONS(3857),
    [anon_sym_globallycoherent] = ACTIONS(3857),
    [anon_sym_centroid] = ACTIONS(3857),
    [anon_sym_noperspective] = ACTIONS(3857),
    [anon_sym_nointerpolation] = ACTIONS(3857),
    [anon_sym_sample] = ACTIONS(3857),
    [anon_sym_linear] = ACTIONS(3857),
    [anon_sym_snorm] = ACTIONS(3857),
    [anon_sym_unorm] = ACTIONS(3857),
    [anon_sym_point] = ACTIONS(3857),
    [anon_sym_line] = ACTIONS(3857),
    [anon_sym_triangleadj] = ACTIONS(3857),
    [anon_sym_lineadj] = ACTIONS(3857),
    [anon_sym_triangle] = ACTIONS(3857),
    [anon_sym_interface] = ACTIONS(3857),
    [anon_sym_extension] = ACTIONS(3857),
    [anon_sym___init] = ACTIONS(3857),
    [anon_sym___subscript] = ACTIONS(3857),
    [anon_sym_property] = ACTIONS(3857),
    [anon_sym_associatedtype] = ACTIONS(3857),
  },
  [1703] = {
    [sym_identifier] = ACTIONS(3665),
    [aux_sym_preproc_def_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token2] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3665),
    [aux_sym_preproc_else_token1] = ACTIONS(3665),
    [aux_sym_preproc_elif_token1] = ACTIONS(3665),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3665),
    [sym_preproc_directive] = ACTIONS(3665),
    [anon_sym_LPAREN2] = ACTIONS(3667),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_STAR] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_SEMI] = ACTIONS(3667),
    [anon_sym___extension__] = ACTIONS(3665),
    [anon_sym_typedef] = ACTIONS(3665),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_out] = ACTIONS(3665),
    [anon_sym_inout] = ACTIONS(3665),
    [anon_sym_virtual] = ACTIONS(3665),
    [anon_sym_extern] = ACTIONS(3665),
    [anon_sym___attribute__] = ACTIONS(3665),
    [anon_sym___attribute] = ACTIONS(3665),
    [anon_sym_using] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(3667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3667),
    [anon_sym___declspec] = ACTIONS(3665),
    [anon_sym___based] = ACTIONS(3665),
    [anon_sym_signed] = ACTIONS(3665),
    [anon_sym_unsigned] = ACTIONS(3665),
    [anon_sym_long] = ACTIONS(3665),
    [anon_sym_short] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3665),
    [anon_sym_static] = ACTIONS(3665),
    [anon_sym_register] = ACTIONS(3665),
    [anon_sym_inline] = ACTIONS(3665),
    [anon_sym___inline] = ACTIONS(3665),
    [anon_sym___inline__] = ACTIONS(3665),
    [anon_sym___forceinline] = ACTIONS(3665),
    [anon_sym_thread_local] = ACTIONS(3665),
    [anon_sym___thread] = ACTIONS(3665),
    [anon_sym_const] = ACTIONS(3665),
    [anon_sym_constexpr] = ACTIONS(3665),
    [anon_sym_volatile] = ACTIONS(3665),
    [anon_sym_restrict] = ACTIONS(3665),
    [anon_sym___restrict__] = ACTIONS(3665),
    [anon_sym__Atomic] = ACTIONS(3665),
    [anon_sym__Noreturn] = ACTIONS(3665),
    [anon_sym_noreturn] = ACTIONS(3665),
    [anon_sym__Nonnull] = ACTIONS(3665),
    [anon_sym_mutable] = ACTIONS(3665),
    [anon_sym_constinit] = ACTIONS(3665),
    [anon_sym_consteval] = ACTIONS(3665),
    [anon_sym_alignas] = ACTIONS(3665),
    [anon_sym__Alignas] = ACTIONS(3665),
    [sym_primitive_type] = ACTIONS(3665),
    [anon_sym_enum] = ACTIONS(3665),
    [anon_sym_class] = ACTIONS(3665),
    [anon_sym_struct] = ACTIONS(3665),
    [anon_sym_union] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3665),
    [anon_sym_let] = ACTIONS(3665),
    [anon_sym_This] = ACTIONS(3665),
    [anon_sym_decltype] = ACTIONS(3665),
    [anon_sym_explicit] = ACTIONS(3665),
    [anon_sym_typename] = ACTIONS(3665),
    [anon_sym_private] = ACTIONS(3665),
    [anon_sym_template] = ACTIONS(3665),
    [anon_sym_operator] = ACTIONS(3665),
    [anon_sym_friend] = ACTIONS(3665),
    [anon_sym_public] = ACTIONS(3665),
    [anon_sym_protected] = ACTIONS(3665),
    [anon_sym_static_assert] = ACTIONS(3665),
    [anon_sym_precise] = ACTIONS(3665),
    [anon_sym_shared] = ACTIONS(3665),
    [anon_sym_groupshared] = ACTIONS(3665),
    [anon_sym_uniform] = ACTIONS(3665),
    [anon_sym_row_major] = ACTIONS(3665),
    [anon_sym_column_major] = ACTIONS(3665),
    [anon_sym_globallycoherent] = ACTIONS(3665),
    [anon_sym_centroid] = ACTIONS(3665),
    [anon_sym_noperspective] = ACTIONS(3665),
    [anon_sym_nointerpolation] = ACTIONS(3665),
    [anon_sym_sample] = ACTIONS(3665),
    [anon_sym_linear] = ACTIONS(3665),
    [anon_sym_snorm] = ACTIONS(3665),
    [anon_sym_unorm] = ACTIONS(3665),
    [anon_sym_point] = ACTIONS(3665),
    [anon_sym_line] = ACTIONS(3665),
    [anon_sym_triangleadj] = ACTIONS(3665),
    [anon_sym_lineadj] = ACTIONS(3665),
    [anon_sym_triangle] = ACTIONS(3665),
    [anon_sym_interface] = ACTIONS(3665),
    [anon_sym_extension] = ACTIONS(3665),
    [anon_sym___init] = ACTIONS(3665),
    [anon_sym___subscript] = ACTIONS(3665),
    [anon_sym_property] = ACTIONS(3665),
    [anon_sym_associatedtype] = ACTIONS(3665),
  },
  [1704] = {
    [sym_identifier] = ACTIONS(6230),
    [aux_sym_preproc_def_token1] = ACTIONS(6230),
    [aux_sym_preproc_if_token1] = ACTIONS(6230),
    [aux_sym_preproc_if_token2] = ACTIONS(6230),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6230),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6230),
    [aux_sym_preproc_else_token1] = ACTIONS(6230),
    [aux_sym_preproc_elif_token1] = ACTIONS(6230),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6230),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6230),
    [sym_preproc_directive] = ACTIONS(6230),
    [anon_sym_LPAREN2] = ACTIONS(6232),
    [anon_sym_TILDE] = ACTIONS(6232),
    [anon_sym_STAR] = ACTIONS(6232),
    [anon_sym_AMP_AMP] = ACTIONS(6232),
    [anon_sym_AMP] = ACTIONS(6230),
    [anon_sym_SEMI] = ACTIONS(6232),
    [anon_sym___extension__] = ACTIONS(6230),
    [anon_sym_typedef] = ACTIONS(6230),
    [anon_sym_in] = ACTIONS(6230),
    [anon_sym_out] = ACTIONS(6230),
    [anon_sym_inout] = ACTIONS(6230),
    [anon_sym_virtual] = ACTIONS(6230),
    [anon_sym_extern] = ACTIONS(6230),
    [anon_sym___attribute__] = ACTIONS(6230),
    [anon_sym___attribute] = ACTIONS(6230),
    [anon_sym_using] = ACTIONS(6230),
    [anon_sym_COLON_COLON] = ACTIONS(6232),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6232),
    [anon_sym___declspec] = ACTIONS(6230),
    [anon_sym___based] = ACTIONS(6230),
    [anon_sym_signed] = ACTIONS(6230),
    [anon_sym_unsigned] = ACTIONS(6230),
    [anon_sym_long] = ACTIONS(6230),
    [anon_sym_short] = ACTIONS(6230),
    [anon_sym_LBRACK] = ACTIONS(6230),
    [anon_sym_static] = ACTIONS(6230),
    [anon_sym_register] = ACTIONS(6230),
    [anon_sym_inline] = ACTIONS(6230),
    [anon_sym___inline] = ACTIONS(6230),
    [anon_sym___inline__] = ACTIONS(6230),
    [anon_sym___forceinline] = ACTIONS(6230),
    [anon_sym_thread_local] = ACTIONS(6230),
    [anon_sym___thread] = ACTIONS(6230),
    [anon_sym_const] = ACTIONS(6230),
    [anon_sym_constexpr] = ACTIONS(6230),
    [anon_sym_volatile] = ACTIONS(6230),
    [anon_sym_restrict] = ACTIONS(6230),
    [anon_sym___restrict__] = ACTIONS(6230),
    [anon_sym__Atomic] = ACTIONS(6230),
    [anon_sym__Noreturn] = ACTIONS(6230),
    [anon_sym_noreturn] = ACTIONS(6230),
    [anon_sym__Nonnull] = ACTIONS(6230),
    [anon_sym_mutable] = ACTIONS(6230),
    [anon_sym_constinit] = ACTIONS(6230),
    [anon_sym_consteval] = ACTIONS(6230),
    [anon_sym_alignas] = ACTIONS(6230),
    [anon_sym__Alignas] = ACTIONS(6230),
    [sym_primitive_type] = ACTIONS(6230),
    [anon_sym_enum] = ACTIONS(6230),
    [anon_sym_class] = ACTIONS(6230),
    [anon_sym_struct] = ACTIONS(6230),
    [anon_sym_union] = ACTIONS(6230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6230),
    [anon_sym_let] = ACTIONS(6230),
    [anon_sym_This] = ACTIONS(6230),
    [anon_sym_decltype] = ACTIONS(6230),
    [anon_sym_explicit] = ACTIONS(6230),
    [anon_sym_typename] = ACTIONS(6230),
    [anon_sym_private] = ACTIONS(6230),
    [anon_sym_template] = ACTIONS(6230),
    [anon_sym_operator] = ACTIONS(6230),
    [anon_sym_friend] = ACTIONS(6230),
    [anon_sym_public] = ACTIONS(6230),
    [anon_sym_protected] = ACTIONS(6230),
    [anon_sym_static_assert] = ACTIONS(6230),
    [anon_sym_precise] = ACTIONS(6230),
    [anon_sym_shared] = ACTIONS(6230),
    [anon_sym_groupshared] = ACTIONS(6230),
    [anon_sym_uniform] = ACTIONS(6230),
    [anon_sym_row_major] = ACTIONS(6230),
    [anon_sym_column_major] = ACTIONS(6230),
    [anon_sym_globallycoherent] = ACTIONS(6230),
    [anon_sym_centroid] = ACTIONS(6230),
    [anon_sym_noperspective] = ACTIONS(6230),
    [anon_sym_nointerpolation] = ACTIONS(6230),
    [anon_sym_sample] = ACTIONS(6230),
    [anon_sym_linear] = ACTIONS(6230),
    [anon_sym_snorm] = ACTIONS(6230),
    [anon_sym_unorm] = ACTIONS(6230),
    [anon_sym_point] = ACTIONS(6230),
    [anon_sym_line] = ACTIONS(6230),
    [anon_sym_triangleadj] = ACTIONS(6230),
    [anon_sym_lineadj] = ACTIONS(6230),
    [anon_sym_triangle] = ACTIONS(6230),
    [anon_sym_interface] = ACTIONS(6230),
    [anon_sym_extension] = ACTIONS(6230),
    [anon_sym___init] = ACTIONS(6230),
    [anon_sym___subscript] = ACTIONS(6230),
    [anon_sym_property] = ACTIONS(6230),
    [anon_sym_associatedtype] = ACTIONS(6230),
  },
  [1705] = {
    [sym_expression] = STATE(5779),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10928),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10928),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(6234),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1706] = {
    [sym_identifier] = ACTIONS(6236),
    [aux_sym_preproc_def_token1] = ACTIONS(6236),
    [aux_sym_preproc_if_token1] = ACTIONS(6236),
    [aux_sym_preproc_if_token2] = ACTIONS(6236),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6236),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6236),
    [aux_sym_preproc_else_token1] = ACTIONS(6236),
    [aux_sym_preproc_elif_token1] = ACTIONS(6236),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6236),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6236),
    [sym_preproc_directive] = ACTIONS(6236),
    [anon_sym_LPAREN2] = ACTIONS(6238),
    [anon_sym_TILDE] = ACTIONS(6238),
    [anon_sym_STAR] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6236),
    [anon_sym_SEMI] = ACTIONS(6238),
    [anon_sym___extension__] = ACTIONS(6236),
    [anon_sym_typedef] = ACTIONS(6236),
    [anon_sym_in] = ACTIONS(6236),
    [anon_sym_out] = ACTIONS(6236),
    [anon_sym_inout] = ACTIONS(6236),
    [anon_sym_virtual] = ACTIONS(6236),
    [anon_sym_extern] = ACTIONS(6236),
    [anon_sym___attribute__] = ACTIONS(6236),
    [anon_sym___attribute] = ACTIONS(6236),
    [anon_sym_using] = ACTIONS(6236),
    [anon_sym_COLON_COLON] = ACTIONS(6238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6238),
    [anon_sym___declspec] = ACTIONS(6236),
    [anon_sym___based] = ACTIONS(6236),
    [anon_sym_signed] = ACTIONS(6236),
    [anon_sym_unsigned] = ACTIONS(6236),
    [anon_sym_long] = ACTIONS(6236),
    [anon_sym_short] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_static] = ACTIONS(6236),
    [anon_sym_register] = ACTIONS(6236),
    [anon_sym_inline] = ACTIONS(6236),
    [anon_sym___inline] = ACTIONS(6236),
    [anon_sym___inline__] = ACTIONS(6236),
    [anon_sym___forceinline] = ACTIONS(6236),
    [anon_sym_thread_local] = ACTIONS(6236),
    [anon_sym___thread] = ACTIONS(6236),
    [anon_sym_const] = ACTIONS(6236),
    [anon_sym_constexpr] = ACTIONS(6236),
    [anon_sym_volatile] = ACTIONS(6236),
    [anon_sym_restrict] = ACTIONS(6236),
    [anon_sym___restrict__] = ACTIONS(6236),
    [anon_sym__Atomic] = ACTIONS(6236),
    [anon_sym__Noreturn] = ACTIONS(6236),
    [anon_sym_noreturn] = ACTIONS(6236),
    [anon_sym__Nonnull] = ACTIONS(6236),
    [anon_sym_mutable] = ACTIONS(6236),
    [anon_sym_constinit] = ACTIONS(6236),
    [anon_sym_consteval] = ACTIONS(6236),
    [anon_sym_alignas] = ACTIONS(6236),
    [anon_sym__Alignas] = ACTIONS(6236),
    [sym_primitive_type] = ACTIONS(6236),
    [anon_sym_enum] = ACTIONS(6236),
    [anon_sym_class] = ACTIONS(6236),
    [anon_sym_struct] = ACTIONS(6236),
    [anon_sym_union] = ACTIONS(6236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6236),
    [anon_sym_let] = ACTIONS(6236),
    [anon_sym_This] = ACTIONS(6236),
    [anon_sym_decltype] = ACTIONS(6236),
    [anon_sym_explicit] = ACTIONS(6236),
    [anon_sym_typename] = ACTIONS(6236),
    [anon_sym_private] = ACTIONS(6236),
    [anon_sym_template] = ACTIONS(6236),
    [anon_sym_operator] = ACTIONS(6236),
    [anon_sym_friend] = ACTIONS(6236),
    [anon_sym_public] = ACTIONS(6236),
    [anon_sym_protected] = ACTIONS(6236),
    [anon_sym_static_assert] = ACTIONS(6236),
    [anon_sym_precise] = ACTIONS(6236),
    [anon_sym_shared] = ACTIONS(6236),
    [anon_sym_groupshared] = ACTIONS(6236),
    [anon_sym_uniform] = ACTIONS(6236),
    [anon_sym_row_major] = ACTIONS(6236),
    [anon_sym_column_major] = ACTIONS(6236),
    [anon_sym_globallycoherent] = ACTIONS(6236),
    [anon_sym_centroid] = ACTIONS(6236),
    [anon_sym_noperspective] = ACTIONS(6236),
    [anon_sym_nointerpolation] = ACTIONS(6236),
    [anon_sym_sample] = ACTIONS(6236),
    [anon_sym_linear] = ACTIONS(6236),
    [anon_sym_snorm] = ACTIONS(6236),
    [anon_sym_unorm] = ACTIONS(6236),
    [anon_sym_point] = ACTIONS(6236),
    [anon_sym_line] = ACTIONS(6236),
    [anon_sym_triangleadj] = ACTIONS(6236),
    [anon_sym_lineadj] = ACTIONS(6236),
    [anon_sym_triangle] = ACTIONS(6236),
    [anon_sym_interface] = ACTIONS(6236),
    [anon_sym_extension] = ACTIONS(6236),
    [anon_sym___init] = ACTIONS(6236),
    [anon_sym___subscript] = ACTIONS(6236),
    [anon_sym_property] = ACTIONS(6236),
    [anon_sym_associatedtype] = ACTIONS(6236),
  },
  [1707] = {
    [sym_compound_statement] = STATE(10112),
    [sym_expression] = STATE(5483),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10112),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_RPAREN] = ACTIONS(6240),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(6134),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1708] = {
    [sym_identifier] = ACTIONS(3832),
    [aux_sym_preproc_def_token1] = ACTIONS(3832),
    [aux_sym_preproc_if_token1] = ACTIONS(3832),
    [aux_sym_preproc_if_token2] = ACTIONS(3832),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3832),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3832),
    [aux_sym_preproc_else_token1] = ACTIONS(3832),
    [aux_sym_preproc_elif_token1] = ACTIONS(3832),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3832),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3832),
    [sym_preproc_directive] = ACTIONS(3832),
    [anon_sym_LPAREN2] = ACTIONS(3834),
    [anon_sym_TILDE] = ACTIONS(3834),
    [anon_sym_STAR] = ACTIONS(3834),
    [anon_sym_AMP_AMP] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3834),
    [anon_sym___extension__] = ACTIONS(3832),
    [anon_sym_typedef] = ACTIONS(3832),
    [anon_sym_in] = ACTIONS(3832),
    [anon_sym_out] = ACTIONS(3832),
    [anon_sym_inout] = ACTIONS(3832),
    [anon_sym_virtual] = ACTIONS(3832),
    [anon_sym_extern] = ACTIONS(3832),
    [anon_sym___attribute__] = ACTIONS(3832),
    [anon_sym___attribute] = ACTIONS(3832),
    [anon_sym_using] = ACTIONS(3832),
    [anon_sym_COLON_COLON] = ACTIONS(3834),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3834),
    [anon_sym___declspec] = ACTIONS(3832),
    [anon_sym___based] = ACTIONS(3832),
    [anon_sym_signed] = ACTIONS(3832),
    [anon_sym_unsigned] = ACTIONS(3832),
    [anon_sym_long] = ACTIONS(3832),
    [anon_sym_short] = ACTIONS(3832),
    [anon_sym_LBRACK] = ACTIONS(3832),
    [anon_sym_static] = ACTIONS(3832),
    [anon_sym_register] = ACTIONS(3832),
    [anon_sym_inline] = ACTIONS(3832),
    [anon_sym___inline] = ACTIONS(3832),
    [anon_sym___inline__] = ACTIONS(3832),
    [anon_sym___forceinline] = ACTIONS(3832),
    [anon_sym_thread_local] = ACTIONS(3832),
    [anon_sym___thread] = ACTIONS(3832),
    [anon_sym_const] = ACTIONS(3832),
    [anon_sym_constexpr] = ACTIONS(3832),
    [anon_sym_volatile] = ACTIONS(3832),
    [anon_sym_restrict] = ACTIONS(3832),
    [anon_sym___restrict__] = ACTIONS(3832),
    [anon_sym__Atomic] = ACTIONS(3832),
    [anon_sym__Noreturn] = ACTIONS(3832),
    [anon_sym_noreturn] = ACTIONS(3832),
    [anon_sym__Nonnull] = ACTIONS(3832),
    [anon_sym_mutable] = ACTIONS(3832),
    [anon_sym_constinit] = ACTIONS(3832),
    [anon_sym_consteval] = ACTIONS(3832),
    [anon_sym_alignas] = ACTIONS(3832),
    [anon_sym__Alignas] = ACTIONS(3832),
    [sym_primitive_type] = ACTIONS(3832),
    [anon_sym_enum] = ACTIONS(3832),
    [anon_sym_class] = ACTIONS(3832),
    [anon_sym_struct] = ACTIONS(3832),
    [anon_sym_union] = ACTIONS(3832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3832),
    [anon_sym_let] = ACTIONS(3832),
    [anon_sym_This] = ACTIONS(3832),
    [anon_sym_decltype] = ACTIONS(3832),
    [anon_sym_explicit] = ACTIONS(3832),
    [anon_sym_typename] = ACTIONS(3832),
    [anon_sym_private] = ACTIONS(3832),
    [anon_sym_template] = ACTIONS(3832),
    [anon_sym_operator] = ACTIONS(3832),
    [anon_sym_friend] = ACTIONS(3832),
    [anon_sym_public] = ACTIONS(3832),
    [anon_sym_protected] = ACTIONS(3832),
    [anon_sym_static_assert] = ACTIONS(3832),
    [anon_sym_precise] = ACTIONS(3832),
    [anon_sym_shared] = ACTIONS(3832),
    [anon_sym_groupshared] = ACTIONS(3832),
    [anon_sym_uniform] = ACTIONS(3832),
    [anon_sym_row_major] = ACTIONS(3832),
    [anon_sym_column_major] = ACTIONS(3832),
    [anon_sym_globallycoherent] = ACTIONS(3832),
    [anon_sym_centroid] = ACTIONS(3832),
    [anon_sym_noperspective] = ACTIONS(3832),
    [anon_sym_nointerpolation] = ACTIONS(3832),
    [anon_sym_sample] = ACTIONS(3832),
    [anon_sym_linear] = ACTIONS(3832),
    [anon_sym_snorm] = ACTIONS(3832),
    [anon_sym_unorm] = ACTIONS(3832),
    [anon_sym_point] = ACTIONS(3832),
    [anon_sym_line] = ACTIONS(3832),
    [anon_sym_triangleadj] = ACTIONS(3832),
    [anon_sym_lineadj] = ACTIONS(3832),
    [anon_sym_triangle] = ACTIONS(3832),
    [anon_sym_interface] = ACTIONS(3832),
    [anon_sym_extension] = ACTIONS(3832),
    [anon_sym___init] = ACTIONS(3832),
    [anon_sym___subscript] = ACTIONS(3832),
    [anon_sym_property] = ACTIONS(3832),
    [anon_sym_associatedtype] = ACTIONS(3832),
  },
  [1709] = {
    [sym_identifier] = ACTIONS(3452),
    [aux_sym_preproc_def_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token2] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3452),
    [aux_sym_preproc_else_token1] = ACTIONS(3452),
    [aux_sym_preproc_elif_token1] = ACTIONS(3452),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3452),
    [sym_preproc_directive] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(3450),
    [anon_sym_TILDE] = ACTIONS(3450),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_AMP_AMP] = ACTIONS(3450),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym___extension__] = ACTIONS(3452),
    [anon_sym_typedef] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_out] = ACTIONS(3452),
    [anon_sym_inout] = ACTIONS(3452),
    [anon_sym_virtual] = ACTIONS(3452),
    [anon_sym_extern] = ACTIONS(3452),
    [anon_sym___attribute__] = ACTIONS(3452),
    [anon_sym___attribute] = ACTIONS(3452),
    [anon_sym_using] = ACTIONS(3452),
    [anon_sym_COLON_COLON] = ACTIONS(3450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3450),
    [anon_sym___declspec] = ACTIONS(3452),
    [anon_sym___based] = ACTIONS(3452),
    [anon_sym_signed] = ACTIONS(3452),
    [anon_sym_unsigned] = ACTIONS(3452),
    [anon_sym_long] = ACTIONS(3452),
    [anon_sym_short] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3452),
    [anon_sym_static] = ACTIONS(3452),
    [anon_sym_register] = ACTIONS(3452),
    [anon_sym_inline] = ACTIONS(3452),
    [anon_sym___inline] = ACTIONS(3452),
    [anon_sym___inline__] = ACTIONS(3452),
    [anon_sym___forceinline] = ACTIONS(3452),
    [anon_sym_thread_local] = ACTIONS(3452),
    [anon_sym___thread] = ACTIONS(3452),
    [anon_sym_const] = ACTIONS(3452),
    [anon_sym_constexpr] = ACTIONS(3452),
    [anon_sym_volatile] = ACTIONS(3452),
    [anon_sym_restrict] = ACTIONS(3452),
    [anon_sym___restrict__] = ACTIONS(3452),
    [anon_sym__Atomic] = ACTIONS(3452),
    [anon_sym__Noreturn] = ACTIONS(3452),
    [anon_sym_noreturn] = ACTIONS(3452),
    [anon_sym__Nonnull] = ACTIONS(3452),
    [anon_sym_mutable] = ACTIONS(3452),
    [anon_sym_constinit] = ACTIONS(3452),
    [anon_sym_consteval] = ACTIONS(3452),
    [anon_sym_alignas] = ACTIONS(3452),
    [anon_sym__Alignas] = ACTIONS(3452),
    [sym_primitive_type] = ACTIONS(3452),
    [anon_sym_enum] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(3452),
    [anon_sym_union] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3452),
    [anon_sym_let] = ACTIONS(3452),
    [anon_sym_This] = ACTIONS(3452),
    [anon_sym_decltype] = ACTIONS(3452),
    [anon_sym_explicit] = ACTIONS(3452),
    [anon_sym_typename] = ACTIONS(3452),
    [anon_sym_private] = ACTIONS(3452),
    [anon_sym_template] = ACTIONS(3452),
    [anon_sym_operator] = ACTIONS(3452),
    [anon_sym_friend] = ACTIONS(3452),
    [anon_sym_public] = ACTIONS(3452),
    [anon_sym_protected] = ACTIONS(3452),
    [anon_sym_static_assert] = ACTIONS(3452),
    [anon_sym_precise] = ACTIONS(3452),
    [anon_sym_shared] = ACTIONS(3452),
    [anon_sym_groupshared] = ACTIONS(3452),
    [anon_sym_uniform] = ACTIONS(3452),
    [anon_sym_row_major] = ACTIONS(3452),
    [anon_sym_column_major] = ACTIONS(3452),
    [anon_sym_globallycoherent] = ACTIONS(3452),
    [anon_sym_centroid] = ACTIONS(3452),
    [anon_sym_noperspective] = ACTIONS(3452),
    [anon_sym_nointerpolation] = ACTIONS(3452),
    [anon_sym_sample] = ACTIONS(3452),
    [anon_sym_linear] = ACTIONS(3452),
    [anon_sym_snorm] = ACTIONS(3452),
    [anon_sym_unorm] = ACTIONS(3452),
    [anon_sym_point] = ACTIONS(3452),
    [anon_sym_line] = ACTIONS(3452),
    [anon_sym_triangleadj] = ACTIONS(3452),
    [anon_sym_lineadj] = ACTIONS(3452),
    [anon_sym_triangle] = ACTIONS(3452),
    [anon_sym_interface] = ACTIONS(3452),
    [anon_sym_extension] = ACTIONS(3452),
    [anon_sym___init] = ACTIONS(3452),
    [anon_sym___subscript] = ACTIONS(3452),
    [anon_sym_property] = ACTIONS(3452),
    [anon_sym_associatedtype] = ACTIONS(3452),
  },
  [1710] = {
    [sym_identifier] = ACTIONS(3452),
    [aux_sym_preproc_def_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token2] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3452),
    [aux_sym_preproc_else_token1] = ACTIONS(3452),
    [aux_sym_preproc_elif_token1] = ACTIONS(3452),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3452),
    [sym_preproc_directive] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(3450),
    [anon_sym_TILDE] = ACTIONS(3450),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_AMP_AMP] = ACTIONS(3450),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym___extension__] = ACTIONS(3452),
    [anon_sym_typedef] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_out] = ACTIONS(3452),
    [anon_sym_inout] = ACTIONS(3452),
    [anon_sym_virtual] = ACTIONS(3452),
    [anon_sym_extern] = ACTIONS(3452),
    [anon_sym___attribute__] = ACTIONS(3452),
    [anon_sym___attribute] = ACTIONS(3452),
    [anon_sym_using] = ACTIONS(3452),
    [anon_sym_COLON_COLON] = ACTIONS(3450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3450),
    [anon_sym___declspec] = ACTIONS(3452),
    [anon_sym___based] = ACTIONS(3452),
    [anon_sym_signed] = ACTIONS(3452),
    [anon_sym_unsigned] = ACTIONS(3452),
    [anon_sym_long] = ACTIONS(3452),
    [anon_sym_short] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3452),
    [anon_sym_static] = ACTIONS(3452),
    [anon_sym_register] = ACTIONS(3452),
    [anon_sym_inline] = ACTIONS(3452),
    [anon_sym___inline] = ACTIONS(3452),
    [anon_sym___inline__] = ACTIONS(3452),
    [anon_sym___forceinline] = ACTIONS(3452),
    [anon_sym_thread_local] = ACTIONS(3452),
    [anon_sym___thread] = ACTIONS(3452),
    [anon_sym_const] = ACTIONS(3452),
    [anon_sym_constexpr] = ACTIONS(3452),
    [anon_sym_volatile] = ACTIONS(3452),
    [anon_sym_restrict] = ACTIONS(3452),
    [anon_sym___restrict__] = ACTIONS(3452),
    [anon_sym__Atomic] = ACTIONS(3452),
    [anon_sym__Noreturn] = ACTIONS(3452),
    [anon_sym_noreturn] = ACTIONS(3452),
    [anon_sym__Nonnull] = ACTIONS(3452),
    [anon_sym_mutable] = ACTIONS(3452),
    [anon_sym_constinit] = ACTIONS(3452),
    [anon_sym_consteval] = ACTIONS(3452),
    [anon_sym_alignas] = ACTIONS(3452),
    [anon_sym__Alignas] = ACTIONS(3452),
    [sym_primitive_type] = ACTIONS(3452),
    [anon_sym_enum] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(3452),
    [anon_sym_union] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3452),
    [anon_sym_let] = ACTIONS(3452),
    [anon_sym_This] = ACTIONS(3452),
    [anon_sym_decltype] = ACTIONS(3452),
    [anon_sym_explicit] = ACTIONS(3452),
    [anon_sym_typename] = ACTIONS(3452),
    [anon_sym_private] = ACTIONS(3452),
    [anon_sym_template] = ACTIONS(3452),
    [anon_sym_operator] = ACTIONS(3452),
    [anon_sym_friend] = ACTIONS(3452),
    [anon_sym_public] = ACTIONS(3452),
    [anon_sym_protected] = ACTIONS(3452),
    [anon_sym_static_assert] = ACTIONS(3452),
    [anon_sym_precise] = ACTIONS(3452),
    [anon_sym_shared] = ACTIONS(3452),
    [anon_sym_groupshared] = ACTIONS(3452),
    [anon_sym_uniform] = ACTIONS(3452),
    [anon_sym_row_major] = ACTIONS(3452),
    [anon_sym_column_major] = ACTIONS(3452),
    [anon_sym_globallycoherent] = ACTIONS(3452),
    [anon_sym_centroid] = ACTIONS(3452),
    [anon_sym_noperspective] = ACTIONS(3452),
    [anon_sym_nointerpolation] = ACTIONS(3452),
    [anon_sym_sample] = ACTIONS(3452),
    [anon_sym_linear] = ACTIONS(3452),
    [anon_sym_snorm] = ACTIONS(3452),
    [anon_sym_unorm] = ACTIONS(3452),
    [anon_sym_point] = ACTIONS(3452),
    [anon_sym_line] = ACTIONS(3452),
    [anon_sym_triangleadj] = ACTIONS(3452),
    [anon_sym_lineadj] = ACTIONS(3452),
    [anon_sym_triangle] = ACTIONS(3452),
    [anon_sym_interface] = ACTIONS(3452),
    [anon_sym_extension] = ACTIONS(3452),
    [anon_sym___init] = ACTIONS(3452),
    [anon_sym___subscript] = ACTIONS(3452),
    [anon_sym_property] = ACTIONS(3452),
    [anon_sym_associatedtype] = ACTIONS(3452),
  },
  [1711] = {
    [sym_identifier] = ACTIONS(3452),
    [aux_sym_preproc_def_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token2] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3452),
    [aux_sym_preproc_else_token1] = ACTIONS(3452),
    [aux_sym_preproc_elif_token1] = ACTIONS(3452),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3452),
    [sym_preproc_directive] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(3450),
    [anon_sym_TILDE] = ACTIONS(3450),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_AMP_AMP] = ACTIONS(3450),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym___extension__] = ACTIONS(3452),
    [anon_sym_typedef] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_out] = ACTIONS(3452),
    [anon_sym_inout] = ACTIONS(3452),
    [anon_sym_virtual] = ACTIONS(3452),
    [anon_sym_extern] = ACTIONS(3452),
    [anon_sym___attribute__] = ACTIONS(3452),
    [anon_sym___attribute] = ACTIONS(3452),
    [anon_sym_using] = ACTIONS(3452),
    [anon_sym_COLON_COLON] = ACTIONS(3450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3450),
    [anon_sym___declspec] = ACTIONS(3452),
    [anon_sym___based] = ACTIONS(3452),
    [anon_sym_signed] = ACTIONS(3452),
    [anon_sym_unsigned] = ACTIONS(3452),
    [anon_sym_long] = ACTIONS(3452),
    [anon_sym_short] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3452),
    [anon_sym_static] = ACTIONS(3452),
    [anon_sym_register] = ACTIONS(3452),
    [anon_sym_inline] = ACTIONS(3452),
    [anon_sym___inline] = ACTIONS(3452),
    [anon_sym___inline__] = ACTIONS(3452),
    [anon_sym___forceinline] = ACTIONS(3452),
    [anon_sym_thread_local] = ACTIONS(3452),
    [anon_sym___thread] = ACTIONS(3452),
    [anon_sym_const] = ACTIONS(3452),
    [anon_sym_constexpr] = ACTIONS(3452),
    [anon_sym_volatile] = ACTIONS(3452),
    [anon_sym_restrict] = ACTIONS(3452),
    [anon_sym___restrict__] = ACTIONS(3452),
    [anon_sym__Atomic] = ACTIONS(3452),
    [anon_sym__Noreturn] = ACTIONS(3452),
    [anon_sym_noreturn] = ACTIONS(3452),
    [anon_sym__Nonnull] = ACTIONS(3452),
    [anon_sym_mutable] = ACTIONS(3452),
    [anon_sym_constinit] = ACTIONS(3452),
    [anon_sym_consteval] = ACTIONS(3452),
    [anon_sym_alignas] = ACTIONS(3452),
    [anon_sym__Alignas] = ACTIONS(3452),
    [sym_primitive_type] = ACTIONS(3452),
    [anon_sym_enum] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(3452),
    [anon_sym_union] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3452),
    [anon_sym_let] = ACTIONS(3452),
    [anon_sym_This] = ACTIONS(3452),
    [anon_sym_decltype] = ACTIONS(3452),
    [anon_sym_explicit] = ACTIONS(3452),
    [anon_sym_typename] = ACTIONS(3452),
    [anon_sym_private] = ACTIONS(3452),
    [anon_sym_template] = ACTIONS(3452),
    [anon_sym_operator] = ACTIONS(3452),
    [anon_sym_friend] = ACTIONS(3452),
    [anon_sym_public] = ACTIONS(3452),
    [anon_sym_protected] = ACTIONS(3452),
    [anon_sym_static_assert] = ACTIONS(3452),
    [anon_sym_precise] = ACTIONS(3452),
    [anon_sym_shared] = ACTIONS(3452),
    [anon_sym_groupshared] = ACTIONS(3452),
    [anon_sym_uniform] = ACTIONS(3452),
    [anon_sym_row_major] = ACTIONS(3452),
    [anon_sym_column_major] = ACTIONS(3452),
    [anon_sym_globallycoherent] = ACTIONS(3452),
    [anon_sym_centroid] = ACTIONS(3452),
    [anon_sym_noperspective] = ACTIONS(3452),
    [anon_sym_nointerpolation] = ACTIONS(3452),
    [anon_sym_sample] = ACTIONS(3452),
    [anon_sym_linear] = ACTIONS(3452),
    [anon_sym_snorm] = ACTIONS(3452),
    [anon_sym_unorm] = ACTIONS(3452),
    [anon_sym_point] = ACTIONS(3452),
    [anon_sym_line] = ACTIONS(3452),
    [anon_sym_triangleadj] = ACTIONS(3452),
    [anon_sym_lineadj] = ACTIONS(3452),
    [anon_sym_triangle] = ACTIONS(3452),
    [anon_sym_interface] = ACTIONS(3452),
    [anon_sym_extension] = ACTIONS(3452),
    [anon_sym___init] = ACTIONS(3452),
    [anon_sym___subscript] = ACTIONS(3452),
    [anon_sym_property] = ACTIONS(3452),
    [anon_sym_associatedtype] = ACTIONS(3452),
  },
  [1712] = {
    [sym_identifier] = ACTIONS(6242),
    [aux_sym_preproc_def_token1] = ACTIONS(6242),
    [aux_sym_preproc_if_token1] = ACTIONS(6242),
    [aux_sym_preproc_if_token2] = ACTIONS(6242),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6242),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6242),
    [aux_sym_preproc_else_token1] = ACTIONS(6242),
    [aux_sym_preproc_elif_token1] = ACTIONS(6242),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6242),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6242),
    [sym_preproc_directive] = ACTIONS(6242),
    [anon_sym_LPAREN2] = ACTIONS(6244),
    [anon_sym_TILDE] = ACTIONS(6244),
    [anon_sym_STAR] = ACTIONS(6244),
    [anon_sym_AMP_AMP] = ACTIONS(6244),
    [anon_sym_AMP] = ACTIONS(6242),
    [anon_sym_SEMI] = ACTIONS(6244),
    [anon_sym___extension__] = ACTIONS(6242),
    [anon_sym_typedef] = ACTIONS(6242),
    [anon_sym_in] = ACTIONS(6242),
    [anon_sym_out] = ACTIONS(6242),
    [anon_sym_inout] = ACTIONS(6242),
    [anon_sym_virtual] = ACTIONS(6242),
    [anon_sym_extern] = ACTIONS(6242),
    [anon_sym___attribute__] = ACTIONS(6242),
    [anon_sym___attribute] = ACTIONS(6242),
    [anon_sym_using] = ACTIONS(6242),
    [anon_sym_COLON_COLON] = ACTIONS(6244),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6244),
    [anon_sym___declspec] = ACTIONS(6242),
    [anon_sym___based] = ACTIONS(6242),
    [anon_sym_signed] = ACTIONS(6242),
    [anon_sym_unsigned] = ACTIONS(6242),
    [anon_sym_long] = ACTIONS(6242),
    [anon_sym_short] = ACTIONS(6242),
    [anon_sym_LBRACK] = ACTIONS(6242),
    [anon_sym_static] = ACTIONS(6242),
    [anon_sym_register] = ACTIONS(6242),
    [anon_sym_inline] = ACTIONS(6242),
    [anon_sym___inline] = ACTIONS(6242),
    [anon_sym___inline__] = ACTIONS(6242),
    [anon_sym___forceinline] = ACTIONS(6242),
    [anon_sym_thread_local] = ACTIONS(6242),
    [anon_sym___thread] = ACTIONS(6242),
    [anon_sym_const] = ACTIONS(6242),
    [anon_sym_constexpr] = ACTIONS(6242),
    [anon_sym_volatile] = ACTIONS(6242),
    [anon_sym_restrict] = ACTIONS(6242),
    [anon_sym___restrict__] = ACTIONS(6242),
    [anon_sym__Atomic] = ACTIONS(6242),
    [anon_sym__Noreturn] = ACTIONS(6242),
    [anon_sym_noreturn] = ACTIONS(6242),
    [anon_sym__Nonnull] = ACTIONS(6242),
    [anon_sym_mutable] = ACTIONS(6242),
    [anon_sym_constinit] = ACTIONS(6242),
    [anon_sym_consteval] = ACTIONS(6242),
    [anon_sym_alignas] = ACTIONS(6242),
    [anon_sym__Alignas] = ACTIONS(6242),
    [sym_primitive_type] = ACTIONS(6242),
    [anon_sym_enum] = ACTIONS(6242),
    [anon_sym_class] = ACTIONS(6242),
    [anon_sym_struct] = ACTIONS(6242),
    [anon_sym_union] = ACTIONS(6242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6242),
    [anon_sym_let] = ACTIONS(6242),
    [anon_sym_This] = ACTIONS(6242),
    [anon_sym_decltype] = ACTIONS(6242),
    [anon_sym_explicit] = ACTIONS(6242),
    [anon_sym_typename] = ACTIONS(6242),
    [anon_sym_private] = ACTIONS(6242),
    [anon_sym_template] = ACTIONS(6242),
    [anon_sym_operator] = ACTIONS(6242),
    [anon_sym_friend] = ACTIONS(6242),
    [anon_sym_public] = ACTIONS(6242),
    [anon_sym_protected] = ACTIONS(6242),
    [anon_sym_static_assert] = ACTIONS(6242),
    [anon_sym_precise] = ACTIONS(6242),
    [anon_sym_shared] = ACTIONS(6242),
    [anon_sym_groupshared] = ACTIONS(6242),
    [anon_sym_uniform] = ACTIONS(6242),
    [anon_sym_row_major] = ACTIONS(6242),
    [anon_sym_column_major] = ACTIONS(6242),
    [anon_sym_globallycoherent] = ACTIONS(6242),
    [anon_sym_centroid] = ACTIONS(6242),
    [anon_sym_noperspective] = ACTIONS(6242),
    [anon_sym_nointerpolation] = ACTIONS(6242),
    [anon_sym_sample] = ACTIONS(6242),
    [anon_sym_linear] = ACTIONS(6242),
    [anon_sym_snorm] = ACTIONS(6242),
    [anon_sym_unorm] = ACTIONS(6242),
    [anon_sym_point] = ACTIONS(6242),
    [anon_sym_line] = ACTIONS(6242),
    [anon_sym_triangleadj] = ACTIONS(6242),
    [anon_sym_lineadj] = ACTIONS(6242),
    [anon_sym_triangle] = ACTIONS(6242),
    [anon_sym_interface] = ACTIONS(6242),
    [anon_sym_extension] = ACTIONS(6242),
    [anon_sym___init] = ACTIONS(6242),
    [anon_sym___subscript] = ACTIONS(6242),
    [anon_sym_property] = ACTIONS(6242),
    [anon_sym_associatedtype] = ACTIONS(6242),
  },
  [1713] = {
    [sym_identifier] = ACTIONS(3861),
    [aux_sym_preproc_def_token1] = ACTIONS(3861),
    [aux_sym_preproc_if_token1] = ACTIONS(3861),
    [aux_sym_preproc_if_token2] = ACTIONS(3861),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3861),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3861),
    [aux_sym_preproc_else_token1] = ACTIONS(3861),
    [aux_sym_preproc_elif_token1] = ACTIONS(3861),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3861),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3861),
    [sym_preproc_directive] = ACTIONS(3861),
    [anon_sym_LPAREN2] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3863),
    [anon_sym_STAR] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_AMP] = ACTIONS(3861),
    [anon_sym_SEMI] = ACTIONS(3863),
    [anon_sym___extension__] = ACTIONS(3861),
    [anon_sym_typedef] = ACTIONS(3861),
    [anon_sym_in] = ACTIONS(3861),
    [anon_sym_out] = ACTIONS(3861),
    [anon_sym_inout] = ACTIONS(3861),
    [anon_sym_virtual] = ACTIONS(3861),
    [anon_sym_extern] = ACTIONS(3861),
    [anon_sym___attribute__] = ACTIONS(3861),
    [anon_sym___attribute] = ACTIONS(3861),
    [anon_sym_using] = ACTIONS(3861),
    [anon_sym_COLON_COLON] = ACTIONS(3863),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3863),
    [anon_sym___declspec] = ACTIONS(3861),
    [anon_sym___based] = ACTIONS(3861),
    [anon_sym_signed] = ACTIONS(3861),
    [anon_sym_unsigned] = ACTIONS(3861),
    [anon_sym_long] = ACTIONS(3861),
    [anon_sym_short] = ACTIONS(3861),
    [anon_sym_LBRACK] = ACTIONS(3861),
    [anon_sym_static] = ACTIONS(3861),
    [anon_sym_register] = ACTIONS(3861),
    [anon_sym_inline] = ACTIONS(3861),
    [anon_sym___inline] = ACTIONS(3861),
    [anon_sym___inline__] = ACTIONS(3861),
    [anon_sym___forceinline] = ACTIONS(3861),
    [anon_sym_thread_local] = ACTIONS(3861),
    [anon_sym___thread] = ACTIONS(3861),
    [anon_sym_const] = ACTIONS(3861),
    [anon_sym_constexpr] = ACTIONS(3861),
    [anon_sym_volatile] = ACTIONS(3861),
    [anon_sym_restrict] = ACTIONS(3861),
    [anon_sym___restrict__] = ACTIONS(3861),
    [anon_sym__Atomic] = ACTIONS(3861),
    [anon_sym__Noreturn] = ACTIONS(3861),
    [anon_sym_noreturn] = ACTIONS(3861),
    [anon_sym__Nonnull] = ACTIONS(3861),
    [anon_sym_mutable] = ACTIONS(3861),
    [anon_sym_constinit] = ACTIONS(3861),
    [anon_sym_consteval] = ACTIONS(3861),
    [anon_sym_alignas] = ACTIONS(3861),
    [anon_sym__Alignas] = ACTIONS(3861),
    [sym_primitive_type] = ACTIONS(3861),
    [anon_sym_enum] = ACTIONS(3861),
    [anon_sym_class] = ACTIONS(3861),
    [anon_sym_struct] = ACTIONS(3861),
    [anon_sym_union] = ACTIONS(3861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3861),
    [anon_sym_let] = ACTIONS(3861),
    [anon_sym_This] = ACTIONS(3861),
    [anon_sym_decltype] = ACTIONS(3861),
    [anon_sym_explicit] = ACTIONS(3861),
    [anon_sym_typename] = ACTIONS(3861),
    [anon_sym_private] = ACTIONS(3861),
    [anon_sym_template] = ACTIONS(3861),
    [anon_sym_operator] = ACTIONS(3861),
    [anon_sym_friend] = ACTIONS(3861),
    [anon_sym_public] = ACTIONS(3861),
    [anon_sym_protected] = ACTIONS(3861),
    [anon_sym_static_assert] = ACTIONS(3861),
    [anon_sym_precise] = ACTIONS(3861),
    [anon_sym_shared] = ACTIONS(3861),
    [anon_sym_groupshared] = ACTIONS(3861),
    [anon_sym_uniform] = ACTIONS(3861),
    [anon_sym_row_major] = ACTIONS(3861),
    [anon_sym_column_major] = ACTIONS(3861),
    [anon_sym_globallycoherent] = ACTIONS(3861),
    [anon_sym_centroid] = ACTIONS(3861),
    [anon_sym_noperspective] = ACTIONS(3861),
    [anon_sym_nointerpolation] = ACTIONS(3861),
    [anon_sym_sample] = ACTIONS(3861),
    [anon_sym_linear] = ACTIONS(3861),
    [anon_sym_snorm] = ACTIONS(3861),
    [anon_sym_unorm] = ACTIONS(3861),
    [anon_sym_point] = ACTIONS(3861),
    [anon_sym_line] = ACTIONS(3861),
    [anon_sym_triangleadj] = ACTIONS(3861),
    [anon_sym_lineadj] = ACTIONS(3861),
    [anon_sym_triangle] = ACTIONS(3861),
    [anon_sym_interface] = ACTIONS(3861),
    [anon_sym_extension] = ACTIONS(3861),
    [anon_sym___init] = ACTIONS(3861),
    [anon_sym___subscript] = ACTIONS(3861),
    [anon_sym_property] = ACTIONS(3861),
    [anon_sym_associatedtype] = ACTIONS(3861),
  },
  [1714] = {
    [sym_identifier] = ACTIONS(6246),
    [aux_sym_preproc_def_token1] = ACTIONS(6246),
    [aux_sym_preproc_if_token1] = ACTIONS(6246),
    [aux_sym_preproc_if_token2] = ACTIONS(6246),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6246),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6246),
    [aux_sym_preproc_else_token1] = ACTIONS(6246),
    [aux_sym_preproc_elif_token1] = ACTIONS(6246),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6246),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6246),
    [sym_preproc_directive] = ACTIONS(6246),
    [anon_sym_LPAREN2] = ACTIONS(6248),
    [anon_sym_TILDE] = ACTIONS(6248),
    [anon_sym_STAR] = ACTIONS(6248),
    [anon_sym_AMP_AMP] = ACTIONS(6248),
    [anon_sym_AMP] = ACTIONS(6246),
    [anon_sym_SEMI] = ACTIONS(6248),
    [anon_sym___extension__] = ACTIONS(6246),
    [anon_sym_typedef] = ACTIONS(6246),
    [anon_sym_in] = ACTIONS(6246),
    [anon_sym_out] = ACTIONS(6246),
    [anon_sym_inout] = ACTIONS(6246),
    [anon_sym_virtual] = ACTIONS(6246),
    [anon_sym_extern] = ACTIONS(6246),
    [anon_sym___attribute__] = ACTIONS(6246),
    [anon_sym___attribute] = ACTIONS(6246),
    [anon_sym_using] = ACTIONS(6246),
    [anon_sym_COLON_COLON] = ACTIONS(6248),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6248),
    [anon_sym___declspec] = ACTIONS(6246),
    [anon_sym___based] = ACTIONS(6246),
    [anon_sym_signed] = ACTIONS(6246),
    [anon_sym_unsigned] = ACTIONS(6246),
    [anon_sym_long] = ACTIONS(6246),
    [anon_sym_short] = ACTIONS(6246),
    [anon_sym_LBRACK] = ACTIONS(6246),
    [anon_sym_static] = ACTIONS(6246),
    [anon_sym_register] = ACTIONS(6246),
    [anon_sym_inline] = ACTIONS(6246),
    [anon_sym___inline] = ACTIONS(6246),
    [anon_sym___inline__] = ACTIONS(6246),
    [anon_sym___forceinline] = ACTIONS(6246),
    [anon_sym_thread_local] = ACTIONS(6246),
    [anon_sym___thread] = ACTIONS(6246),
    [anon_sym_const] = ACTIONS(6246),
    [anon_sym_constexpr] = ACTIONS(6246),
    [anon_sym_volatile] = ACTIONS(6246),
    [anon_sym_restrict] = ACTIONS(6246),
    [anon_sym___restrict__] = ACTIONS(6246),
    [anon_sym__Atomic] = ACTIONS(6246),
    [anon_sym__Noreturn] = ACTIONS(6246),
    [anon_sym_noreturn] = ACTIONS(6246),
    [anon_sym__Nonnull] = ACTIONS(6246),
    [anon_sym_mutable] = ACTIONS(6246),
    [anon_sym_constinit] = ACTIONS(6246),
    [anon_sym_consteval] = ACTIONS(6246),
    [anon_sym_alignas] = ACTIONS(6246),
    [anon_sym__Alignas] = ACTIONS(6246),
    [sym_primitive_type] = ACTIONS(6246),
    [anon_sym_enum] = ACTIONS(6246),
    [anon_sym_class] = ACTIONS(6246),
    [anon_sym_struct] = ACTIONS(6246),
    [anon_sym_union] = ACTIONS(6246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6246),
    [anon_sym_let] = ACTIONS(6246),
    [anon_sym_This] = ACTIONS(6246),
    [anon_sym_decltype] = ACTIONS(6246),
    [anon_sym_explicit] = ACTIONS(6246),
    [anon_sym_typename] = ACTIONS(6246),
    [anon_sym_private] = ACTIONS(6246),
    [anon_sym_template] = ACTIONS(6246),
    [anon_sym_operator] = ACTIONS(6246),
    [anon_sym_friend] = ACTIONS(6246),
    [anon_sym_public] = ACTIONS(6246),
    [anon_sym_protected] = ACTIONS(6246),
    [anon_sym_static_assert] = ACTIONS(6246),
    [anon_sym_precise] = ACTIONS(6246),
    [anon_sym_shared] = ACTIONS(6246),
    [anon_sym_groupshared] = ACTIONS(6246),
    [anon_sym_uniform] = ACTIONS(6246),
    [anon_sym_row_major] = ACTIONS(6246),
    [anon_sym_column_major] = ACTIONS(6246),
    [anon_sym_globallycoherent] = ACTIONS(6246),
    [anon_sym_centroid] = ACTIONS(6246),
    [anon_sym_noperspective] = ACTIONS(6246),
    [anon_sym_nointerpolation] = ACTIONS(6246),
    [anon_sym_sample] = ACTIONS(6246),
    [anon_sym_linear] = ACTIONS(6246),
    [anon_sym_snorm] = ACTIONS(6246),
    [anon_sym_unorm] = ACTIONS(6246),
    [anon_sym_point] = ACTIONS(6246),
    [anon_sym_line] = ACTIONS(6246),
    [anon_sym_triangleadj] = ACTIONS(6246),
    [anon_sym_lineadj] = ACTIONS(6246),
    [anon_sym_triangle] = ACTIONS(6246),
    [anon_sym_interface] = ACTIONS(6246),
    [anon_sym_extension] = ACTIONS(6246),
    [anon_sym___init] = ACTIONS(6246),
    [anon_sym___subscript] = ACTIONS(6246),
    [anon_sym_property] = ACTIONS(6246),
    [anon_sym_associatedtype] = ACTIONS(6246),
  },
  [1715] = {
    [sym__declaration_modifiers] = STATE(2667),
    [sym__declaration_specifiers] = STATE(4972),
    [sym_attribute_specifier] = STATE(2667),
    [sym_attribute_declaration] = STATE(2667),
    [sym_ms_declspec_modifier] = STATE(2667),
    [sym_storage_class_specifier] = STATE(2667),
    [sym_type_qualifier] = STATE(2667),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2793),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_parameter_declaration] = STATE(10306),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_optional_parameter_declaration] = STATE(10306),
    [sym_variadic_parameter_declaration] = STATE(10306),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8769),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2667),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2667),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5515),
    [anon_sym_RPAREN] = ACTIONS(2336),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(2348),
    [anon_sym_out] = ACTIONS(2348),
    [anon_sym_inout] = ACTIONS(2348),
    [anon_sym_virtual] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5525),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_extension] = ACTIONS(2398),
  },
  [1716] = {
    [sym_compound_statement] = STATE(9614),
    [sym_expression] = STATE(5503),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(9614),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_RPAREN] = ACTIONS(6250),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(6134),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1717] = {
    [sym_identifier] = ACTIONS(3967),
    [aux_sym_preproc_def_token1] = ACTIONS(3967),
    [aux_sym_preproc_if_token1] = ACTIONS(3967),
    [aux_sym_preproc_if_token2] = ACTIONS(3967),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3967),
    [aux_sym_preproc_else_token1] = ACTIONS(3967),
    [aux_sym_preproc_elif_token1] = ACTIONS(3967),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3967),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3967),
    [sym_preproc_directive] = ACTIONS(3967),
    [anon_sym_LPAREN2] = ACTIONS(3969),
    [anon_sym_TILDE] = ACTIONS(3969),
    [anon_sym_STAR] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_AMP] = ACTIONS(3967),
    [anon_sym_SEMI] = ACTIONS(3969),
    [anon_sym___extension__] = ACTIONS(3967),
    [anon_sym_typedef] = ACTIONS(3967),
    [anon_sym_in] = ACTIONS(3967),
    [anon_sym_out] = ACTIONS(3967),
    [anon_sym_inout] = ACTIONS(3967),
    [anon_sym_virtual] = ACTIONS(3967),
    [anon_sym_extern] = ACTIONS(3967),
    [anon_sym___attribute__] = ACTIONS(3967),
    [anon_sym___attribute] = ACTIONS(3967),
    [anon_sym_using] = ACTIONS(3967),
    [anon_sym_COLON_COLON] = ACTIONS(3969),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3969),
    [anon_sym___declspec] = ACTIONS(3967),
    [anon_sym___based] = ACTIONS(3967),
    [anon_sym_signed] = ACTIONS(3967),
    [anon_sym_unsigned] = ACTIONS(3967),
    [anon_sym_long] = ACTIONS(3967),
    [anon_sym_short] = ACTIONS(3967),
    [anon_sym_LBRACK] = ACTIONS(3967),
    [anon_sym_static] = ACTIONS(3967),
    [anon_sym_register] = ACTIONS(3967),
    [anon_sym_inline] = ACTIONS(3967),
    [anon_sym___inline] = ACTIONS(3967),
    [anon_sym___inline__] = ACTIONS(3967),
    [anon_sym___forceinline] = ACTIONS(3967),
    [anon_sym_thread_local] = ACTIONS(3967),
    [anon_sym___thread] = ACTIONS(3967),
    [anon_sym_const] = ACTIONS(3967),
    [anon_sym_constexpr] = ACTIONS(3967),
    [anon_sym_volatile] = ACTIONS(3967),
    [anon_sym_restrict] = ACTIONS(3967),
    [anon_sym___restrict__] = ACTIONS(3967),
    [anon_sym__Atomic] = ACTIONS(3967),
    [anon_sym__Noreturn] = ACTIONS(3967),
    [anon_sym_noreturn] = ACTIONS(3967),
    [anon_sym__Nonnull] = ACTIONS(3967),
    [anon_sym_mutable] = ACTIONS(3967),
    [anon_sym_constinit] = ACTIONS(3967),
    [anon_sym_consteval] = ACTIONS(3967),
    [anon_sym_alignas] = ACTIONS(3967),
    [anon_sym__Alignas] = ACTIONS(3967),
    [sym_primitive_type] = ACTIONS(3967),
    [anon_sym_enum] = ACTIONS(3967),
    [anon_sym_class] = ACTIONS(3967),
    [anon_sym_struct] = ACTIONS(3967),
    [anon_sym_union] = ACTIONS(3967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3967),
    [anon_sym_let] = ACTIONS(3967),
    [anon_sym_This] = ACTIONS(3967),
    [anon_sym_decltype] = ACTIONS(3967),
    [anon_sym_explicit] = ACTIONS(3967),
    [anon_sym_typename] = ACTIONS(3967),
    [anon_sym_private] = ACTIONS(3967),
    [anon_sym_template] = ACTIONS(3967),
    [anon_sym_operator] = ACTIONS(3967),
    [anon_sym_friend] = ACTIONS(3967),
    [anon_sym_public] = ACTIONS(3967),
    [anon_sym_protected] = ACTIONS(3967),
    [anon_sym_static_assert] = ACTIONS(3967),
    [anon_sym_precise] = ACTIONS(3967),
    [anon_sym_shared] = ACTIONS(3967),
    [anon_sym_groupshared] = ACTIONS(3967),
    [anon_sym_uniform] = ACTIONS(3967),
    [anon_sym_row_major] = ACTIONS(3967),
    [anon_sym_column_major] = ACTIONS(3967),
    [anon_sym_globallycoherent] = ACTIONS(3967),
    [anon_sym_centroid] = ACTIONS(3967),
    [anon_sym_noperspective] = ACTIONS(3967),
    [anon_sym_nointerpolation] = ACTIONS(3967),
    [anon_sym_sample] = ACTIONS(3967),
    [anon_sym_linear] = ACTIONS(3967),
    [anon_sym_snorm] = ACTIONS(3967),
    [anon_sym_unorm] = ACTIONS(3967),
    [anon_sym_point] = ACTIONS(3967),
    [anon_sym_line] = ACTIONS(3967),
    [anon_sym_triangleadj] = ACTIONS(3967),
    [anon_sym_lineadj] = ACTIONS(3967),
    [anon_sym_triangle] = ACTIONS(3967),
    [anon_sym_interface] = ACTIONS(3967),
    [anon_sym_extension] = ACTIONS(3967),
    [anon_sym___init] = ACTIONS(3967),
    [anon_sym___subscript] = ACTIONS(3967),
    [anon_sym_property] = ACTIONS(3967),
    [anon_sym_associatedtype] = ACTIONS(3967),
  },
  [1718] = {
    [sym_identifier] = ACTIONS(3460),
    [aux_sym_preproc_def_token1] = ACTIONS(3460),
    [aux_sym_preproc_if_token1] = ACTIONS(3460),
    [aux_sym_preproc_if_token2] = ACTIONS(3460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3460),
    [aux_sym_preproc_else_token1] = ACTIONS(3460),
    [aux_sym_preproc_elif_token1] = ACTIONS(3460),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3460),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3460),
    [sym_preproc_directive] = ACTIONS(3460),
    [anon_sym_LPAREN2] = ACTIONS(3458),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3458),
    [anon_sym_AMP_AMP] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3460),
    [anon_sym_SEMI] = ACTIONS(3458),
    [anon_sym___extension__] = ACTIONS(3460),
    [anon_sym_typedef] = ACTIONS(3460),
    [anon_sym_in] = ACTIONS(3460),
    [anon_sym_out] = ACTIONS(3460),
    [anon_sym_inout] = ACTIONS(3460),
    [anon_sym_virtual] = ACTIONS(3460),
    [anon_sym_extern] = ACTIONS(3460),
    [anon_sym___attribute__] = ACTIONS(3460),
    [anon_sym___attribute] = ACTIONS(3460),
    [anon_sym_using] = ACTIONS(3460),
    [anon_sym_COLON_COLON] = ACTIONS(3458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3458),
    [anon_sym___declspec] = ACTIONS(3460),
    [anon_sym___based] = ACTIONS(3460),
    [anon_sym_signed] = ACTIONS(3460),
    [anon_sym_unsigned] = ACTIONS(3460),
    [anon_sym_long] = ACTIONS(3460),
    [anon_sym_short] = ACTIONS(3460),
    [anon_sym_LBRACK] = ACTIONS(3460),
    [anon_sym_static] = ACTIONS(3460),
    [anon_sym_register] = ACTIONS(3460),
    [anon_sym_inline] = ACTIONS(3460),
    [anon_sym___inline] = ACTIONS(3460),
    [anon_sym___inline__] = ACTIONS(3460),
    [anon_sym___forceinline] = ACTIONS(3460),
    [anon_sym_thread_local] = ACTIONS(3460),
    [anon_sym___thread] = ACTIONS(3460),
    [anon_sym_const] = ACTIONS(3460),
    [anon_sym_constexpr] = ACTIONS(3460),
    [anon_sym_volatile] = ACTIONS(3460),
    [anon_sym_restrict] = ACTIONS(3460),
    [anon_sym___restrict__] = ACTIONS(3460),
    [anon_sym__Atomic] = ACTIONS(3460),
    [anon_sym__Noreturn] = ACTIONS(3460),
    [anon_sym_noreturn] = ACTIONS(3460),
    [anon_sym__Nonnull] = ACTIONS(3460),
    [anon_sym_mutable] = ACTIONS(3460),
    [anon_sym_constinit] = ACTIONS(3460),
    [anon_sym_consteval] = ACTIONS(3460),
    [anon_sym_alignas] = ACTIONS(3460),
    [anon_sym__Alignas] = ACTIONS(3460),
    [sym_primitive_type] = ACTIONS(3460),
    [anon_sym_enum] = ACTIONS(3460),
    [anon_sym_class] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(3460),
    [anon_sym_union] = ACTIONS(3460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3460),
    [anon_sym_let] = ACTIONS(3460),
    [anon_sym_This] = ACTIONS(3460),
    [anon_sym_decltype] = ACTIONS(3460),
    [anon_sym_explicit] = ACTIONS(3460),
    [anon_sym_typename] = ACTIONS(3460),
    [anon_sym_private] = ACTIONS(3460),
    [anon_sym_template] = ACTIONS(3460),
    [anon_sym_operator] = ACTIONS(3460),
    [anon_sym_friend] = ACTIONS(3460),
    [anon_sym_public] = ACTIONS(3460),
    [anon_sym_protected] = ACTIONS(3460),
    [anon_sym_static_assert] = ACTIONS(3460),
    [anon_sym_precise] = ACTIONS(3460),
    [anon_sym_shared] = ACTIONS(3460),
    [anon_sym_groupshared] = ACTIONS(3460),
    [anon_sym_uniform] = ACTIONS(3460),
    [anon_sym_row_major] = ACTIONS(3460),
    [anon_sym_column_major] = ACTIONS(3460),
    [anon_sym_globallycoherent] = ACTIONS(3460),
    [anon_sym_centroid] = ACTIONS(3460),
    [anon_sym_noperspective] = ACTIONS(3460),
    [anon_sym_nointerpolation] = ACTIONS(3460),
    [anon_sym_sample] = ACTIONS(3460),
    [anon_sym_linear] = ACTIONS(3460),
    [anon_sym_snorm] = ACTIONS(3460),
    [anon_sym_unorm] = ACTIONS(3460),
    [anon_sym_point] = ACTIONS(3460),
    [anon_sym_line] = ACTIONS(3460),
    [anon_sym_triangleadj] = ACTIONS(3460),
    [anon_sym_lineadj] = ACTIONS(3460),
    [anon_sym_triangle] = ACTIONS(3460),
    [anon_sym_interface] = ACTIONS(3460),
    [anon_sym_extension] = ACTIONS(3460),
    [anon_sym___init] = ACTIONS(3460),
    [anon_sym___subscript] = ACTIONS(3460),
    [anon_sym_property] = ACTIONS(3460),
    [anon_sym_associatedtype] = ACTIONS(3460),
  },
  [1719] = {
    [sym_identifier] = ACTIONS(6252),
    [aux_sym_preproc_def_token1] = ACTIONS(6252),
    [aux_sym_preproc_if_token1] = ACTIONS(6252),
    [aux_sym_preproc_if_token2] = ACTIONS(6252),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6252),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6252),
    [aux_sym_preproc_else_token1] = ACTIONS(6252),
    [aux_sym_preproc_elif_token1] = ACTIONS(6252),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6252),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6252),
    [sym_preproc_directive] = ACTIONS(6252),
    [anon_sym_LPAREN2] = ACTIONS(6254),
    [anon_sym_TILDE] = ACTIONS(6254),
    [anon_sym_STAR] = ACTIONS(6254),
    [anon_sym_AMP_AMP] = ACTIONS(6254),
    [anon_sym_AMP] = ACTIONS(6252),
    [anon_sym_SEMI] = ACTIONS(6254),
    [anon_sym___extension__] = ACTIONS(6252),
    [anon_sym_typedef] = ACTIONS(6252),
    [anon_sym_in] = ACTIONS(6252),
    [anon_sym_out] = ACTIONS(6252),
    [anon_sym_inout] = ACTIONS(6252),
    [anon_sym_virtual] = ACTIONS(6252),
    [anon_sym_extern] = ACTIONS(6252),
    [anon_sym___attribute__] = ACTIONS(6252),
    [anon_sym___attribute] = ACTIONS(6252),
    [anon_sym_using] = ACTIONS(6252),
    [anon_sym_COLON_COLON] = ACTIONS(6254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6254),
    [anon_sym___declspec] = ACTIONS(6252),
    [anon_sym___based] = ACTIONS(6252),
    [anon_sym_signed] = ACTIONS(6252),
    [anon_sym_unsigned] = ACTIONS(6252),
    [anon_sym_long] = ACTIONS(6252),
    [anon_sym_short] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_static] = ACTIONS(6252),
    [anon_sym_register] = ACTIONS(6252),
    [anon_sym_inline] = ACTIONS(6252),
    [anon_sym___inline] = ACTIONS(6252),
    [anon_sym___inline__] = ACTIONS(6252),
    [anon_sym___forceinline] = ACTIONS(6252),
    [anon_sym_thread_local] = ACTIONS(6252),
    [anon_sym___thread] = ACTIONS(6252),
    [anon_sym_const] = ACTIONS(6252),
    [anon_sym_constexpr] = ACTIONS(6252),
    [anon_sym_volatile] = ACTIONS(6252),
    [anon_sym_restrict] = ACTIONS(6252),
    [anon_sym___restrict__] = ACTIONS(6252),
    [anon_sym__Atomic] = ACTIONS(6252),
    [anon_sym__Noreturn] = ACTIONS(6252),
    [anon_sym_noreturn] = ACTIONS(6252),
    [anon_sym__Nonnull] = ACTIONS(6252),
    [anon_sym_mutable] = ACTIONS(6252),
    [anon_sym_constinit] = ACTIONS(6252),
    [anon_sym_consteval] = ACTIONS(6252),
    [anon_sym_alignas] = ACTIONS(6252),
    [anon_sym__Alignas] = ACTIONS(6252),
    [sym_primitive_type] = ACTIONS(6252),
    [anon_sym_enum] = ACTIONS(6252),
    [anon_sym_class] = ACTIONS(6252),
    [anon_sym_struct] = ACTIONS(6252),
    [anon_sym_union] = ACTIONS(6252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6252),
    [anon_sym_let] = ACTIONS(6252),
    [anon_sym_This] = ACTIONS(6252),
    [anon_sym_decltype] = ACTIONS(6252),
    [anon_sym_explicit] = ACTIONS(6252),
    [anon_sym_typename] = ACTIONS(6252),
    [anon_sym_private] = ACTIONS(6252),
    [anon_sym_template] = ACTIONS(6252),
    [anon_sym_operator] = ACTIONS(6252),
    [anon_sym_friend] = ACTIONS(6252),
    [anon_sym_public] = ACTIONS(6252),
    [anon_sym_protected] = ACTIONS(6252),
    [anon_sym_static_assert] = ACTIONS(6252),
    [anon_sym_precise] = ACTIONS(6252),
    [anon_sym_shared] = ACTIONS(6252),
    [anon_sym_groupshared] = ACTIONS(6252),
    [anon_sym_uniform] = ACTIONS(6252),
    [anon_sym_row_major] = ACTIONS(6252),
    [anon_sym_column_major] = ACTIONS(6252),
    [anon_sym_globallycoherent] = ACTIONS(6252),
    [anon_sym_centroid] = ACTIONS(6252),
    [anon_sym_noperspective] = ACTIONS(6252),
    [anon_sym_nointerpolation] = ACTIONS(6252),
    [anon_sym_sample] = ACTIONS(6252),
    [anon_sym_linear] = ACTIONS(6252),
    [anon_sym_snorm] = ACTIONS(6252),
    [anon_sym_unorm] = ACTIONS(6252),
    [anon_sym_point] = ACTIONS(6252),
    [anon_sym_line] = ACTIONS(6252),
    [anon_sym_triangleadj] = ACTIONS(6252),
    [anon_sym_lineadj] = ACTIONS(6252),
    [anon_sym_triangle] = ACTIONS(6252),
    [anon_sym_interface] = ACTIONS(6252),
    [anon_sym_extension] = ACTIONS(6252),
    [anon_sym___init] = ACTIONS(6252),
    [anon_sym___subscript] = ACTIONS(6252),
    [anon_sym_property] = ACTIONS(6252),
    [anon_sym_associatedtype] = ACTIONS(6252),
  },
  [1720] = {
    [sym_identifier] = ACTIONS(6256),
    [aux_sym_preproc_def_token1] = ACTIONS(6256),
    [aux_sym_preproc_if_token1] = ACTIONS(6256),
    [aux_sym_preproc_if_token2] = ACTIONS(6256),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6256),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6256),
    [aux_sym_preproc_else_token1] = ACTIONS(6256),
    [aux_sym_preproc_elif_token1] = ACTIONS(6256),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6256),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6256),
    [sym_preproc_directive] = ACTIONS(6256),
    [anon_sym_LPAREN2] = ACTIONS(6258),
    [anon_sym_TILDE] = ACTIONS(6258),
    [anon_sym_STAR] = ACTIONS(6258),
    [anon_sym_AMP_AMP] = ACTIONS(6258),
    [anon_sym_AMP] = ACTIONS(6256),
    [anon_sym_SEMI] = ACTIONS(6258),
    [anon_sym___extension__] = ACTIONS(6256),
    [anon_sym_typedef] = ACTIONS(6256),
    [anon_sym_in] = ACTIONS(6256),
    [anon_sym_out] = ACTIONS(6256),
    [anon_sym_inout] = ACTIONS(6256),
    [anon_sym_virtual] = ACTIONS(6256),
    [anon_sym_extern] = ACTIONS(6256),
    [anon_sym___attribute__] = ACTIONS(6256),
    [anon_sym___attribute] = ACTIONS(6256),
    [anon_sym_using] = ACTIONS(6256),
    [anon_sym_COLON_COLON] = ACTIONS(6258),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6258),
    [anon_sym___declspec] = ACTIONS(6256),
    [anon_sym___based] = ACTIONS(6256),
    [anon_sym_signed] = ACTIONS(6256),
    [anon_sym_unsigned] = ACTIONS(6256),
    [anon_sym_long] = ACTIONS(6256),
    [anon_sym_short] = ACTIONS(6256),
    [anon_sym_LBRACK] = ACTIONS(6256),
    [anon_sym_static] = ACTIONS(6256),
    [anon_sym_register] = ACTIONS(6256),
    [anon_sym_inline] = ACTIONS(6256),
    [anon_sym___inline] = ACTIONS(6256),
    [anon_sym___inline__] = ACTIONS(6256),
    [anon_sym___forceinline] = ACTIONS(6256),
    [anon_sym_thread_local] = ACTIONS(6256),
    [anon_sym___thread] = ACTIONS(6256),
    [anon_sym_const] = ACTIONS(6256),
    [anon_sym_constexpr] = ACTIONS(6256),
    [anon_sym_volatile] = ACTIONS(6256),
    [anon_sym_restrict] = ACTIONS(6256),
    [anon_sym___restrict__] = ACTIONS(6256),
    [anon_sym__Atomic] = ACTIONS(6256),
    [anon_sym__Noreturn] = ACTIONS(6256),
    [anon_sym_noreturn] = ACTIONS(6256),
    [anon_sym__Nonnull] = ACTIONS(6256),
    [anon_sym_mutable] = ACTIONS(6256),
    [anon_sym_constinit] = ACTIONS(6256),
    [anon_sym_consteval] = ACTIONS(6256),
    [anon_sym_alignas] = ACTIONS(6256),
    [anon_sym__Alignas] = ACTIONS(6256),
    [sym_primitive_type] = ACTIONS(6256),
    [anon_sym_enum] = ACTIONS(6256),
    [anon_sym_class] = ACTIONS(6256),
    [anon_sym_struct] = ACTIONS(6256),
    [anon_sym_union] = ACTIONS(6256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6256),
    [anon_sym_let] = ACTIONS(6256),
    [anon_sym_This] = ACTIONS(6256),
    [anon_sym_decltype] = ACTIONS(6256),
    [anon_sym_explicit] = ACTIONS(6256),
    [anon_sym_typename] = ACTIONS(6256),
    [anon_sym_private] = ACTIONS(6256),
    [anon_sym_template] = ACTIONS(6256),
    [anon_sym_operator] = ACTIONS(6256),
    [anon_sym_friend] = ACTIONS(6256),
    [anon_sym_public] = ACTIONS(6256),
    [anon_sym_protected] = ACTIONS(6256),
    [anon_sym_static_assert] = ACTIONS(6256),
    [anon_sym_precise] = ACTIONS(6256),
    [anon_sym_shared] = ACTIONS(6256),
    [anon_sym_groupshared] = ACTIONS(6256),
    [anon_sym_uniform] = ACTIONS(6256),
    [anon_sym_row_major] = ACTIONS(6256),
    [anon_sym_column_major] = ACTIONS(6256),
    [anon_sym_globallycoherent] = ACTIONS(6256),
    [anon_sym_centroid] = ACTIONS(6256),
    [anon_sym_noperspective] = ACTIONS(6256),
    [anon_sym_nointerpolation] = ACTIONS(6256),
    [anon_sym_sample] = ACTIONS(6256),
    [anon_sym_linear] = ACTIONS(6256),
    [anon_sym_snorm] = ACTIONS(6256),
    [anon_sym_unorm] = ACTIONS(6256),
    [anon_sym_point] = ACTIONS(6256),
    [anon_sym_line] = ACTIONS(6256),
    [anon_sym_triangleadj] = ACTIONS(6256),
    [anon_sym_lineadj] = ACTIONS(6256),
    [anon_sym_triangle] = ACTIONS(6256),
    [anon_sym_interface] = ACTIONS(6256),
    [anon_sym_extension] = ACTIONS(6256),
    [anon_sym___init] = ACTIONS(6256),
    [anon_sym___subscript] = ACTIONS(6256),
    [anon_sym_property] = ACTIONS(6256),
    [anon_sym_associatedtype] = ACTIONS(6256),
  },
  [1721] = {
    [sym_identifier] = ACTIONS(6260),
    [aux_sym_preproc_def_token1] = ACTIONS(6260),
    [aux_sym_preproc_if_token1] = ACTIONS(6260),
    [aux_sym_preproc_if_token2] = ACTIONS(6260),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6260),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6260),
    [aux_sym_preproc_else_token1] = ACTIONS(6260),
    [aux_sym_preproc_elif_token1] = ACTIONS(6260),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6260),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6260),
    [sym_preproc_directive] = ACTIONS(6260),
    [anon_sym_LPAREN2] = ACTIONS(6262),
    [anon_sym_TILDE] = ACTIONS(6262),
    [anon_sym_STAR] = ACTIONS(6262),
    [anon_sym_AMP_AMP] = ACTIONS(6262),
    [anon_sym_AMP] = ACTIONS(6260),
    [anon_sym_SEMI] = ACTIONS(6262),
    [anon_sym___extension__] = ACTIONS(6260),
    [anon_sym_typedef] = ACTIONS(6260),
    [anon_sym_in] = ACTIONS(6260),
    [anon_sym_out] = ACTIONS(6260),
    [anon_sym_inout] = ACTIONS(6260),
    [anon_sym_virtual] = ACTIONS(6260),
    [anon_sym_extern] = ACTIONS(6260),
    [anon_sym___attribute__] = ACTIONS(6260),
    [anon_sym___attribute] = ACTIONS(6260),
    [anon_sym_using] = ACTIONS(6260),
    [anon_sym_COLON_COLON] = ACTIONS(6262),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6262),
    [anon_sym___declspec] = ACTIONS(6260),
    [anon_sym___based] = ACTIONS(6260),
    [anon_sym_signed] = ACTIONS(6260),
    [anon_sym_unsigned] = ACTIONS(6260),
    [anon_sym_long] = ACTIONS(6260),
    [anon_sym_short] = ACTIONS(6260),
    [anon_sym_LBRACK] = ACTIONS(6260),
    [anon_sym_static] = ACTIONS(6260),
    [anon_sym_register] = ACTIONS(6260),
    [anon_sym_inline] = ACTIONS(6260),
    [anon_sym___inline] = ACTIONS(6260),
    [anon_sym___inline__] = ACTIONS(6260),
    [anon_sym___forceinline] = ACTIONS(6260),
    [anon_sym_thread_local] = ACTIONS(6260),
    [anon_sym___thread] = ACTIONS(6260),
    [anon_sym_const] = ACTIONS(6260),
    [anon_sym_constexpr] = ACTIONS(6260),
    [anon_sym_volatile] = ACTIONS(6260),
    [anon_sym_restrict] = ACTIONS(6260),
    [anon_sym___restrict__] = ACTIONS(6260),
    [anon_sym__Atomic] = ACTIONS(6260),
    [anon_sym__Noreturn] = ACTIONS(6260),
    [anon_sym_noreturn] = ACTIONS(6260),
    [anon_sym__Nonnull] = ACTIONS(6260),
    [anon_sym_mutable] = ACTIONS(6260),
    [anon_sym_constinit] = ACTIONS(6260),
    [anon_sym_consteval] = ACTIONS(6260),
    [anon_sym_alignas] = ACTIONS(6260),
    [anon_sym__Alignas] = ACTIONS(6260),
    [sym_primitive_type] = ACTIONS(6260),
    [anon_sym_enum] = ACTIONS(6260),
    [anon_sym_class] = ACTIONS(6260),
    [anon_sym_struct] = ACTIONS(6260),
    [anon_sym_union] = ACTIONS(6260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6260),
    [anon_sym_let] = ACTIONS(6260),
    [anon_sym_This] = ACTIONS(6260),
    [anon_sym_decltype] = ACTIONS(6260),
    [anon_sym_explicit] = ACTIONS(6260),
    [anon_sym_typename] = ACTIONS(6260),
    [anon_sym_private] = ACTIONS(6260),
    [anon_sym_template] = ACTIONS(6260),
    [anon_sym_operator] = ACTIONS(6260),
    [anon_sym_friend] = ACTIONS(6260),
    [anon_sym_public] = ACTIONS(6260),
    [anon_sym_protected] = ACTIONS(6260),
    [anon_sym_static_assert] = ACTIONS(6260),
    [anon_sym_precise] = ACTIONS(6260),
    [anon_sym_shared] = ACTIONS(6260),
    [anon_sym_groupshared] = ACTIONS(6260),
    [anon_sym_uniform] = ACTIONS(6260),
    [anon_sym_row_major] = ACTIONS(6260),
    [anon_sym_column_major] = ACTIONS(6260),
    [anon_sym_globallycoherent] = ACTIONS(6260),
    [anon_sym_centroid] = ACTIONS(6260),
    [anon_sym_noperspective] = ACTIONS(6260),
    [anon_sym_nointerpolation] = ACTIONS(6260),
    [anon_sym_sample] = ACTIONS(6260),
    [anon_sym_linear] = ACTIONS(6260),
    [anon_sym_snorm] = ACTIONS(6260),
    [anon_sym_unorm] = ACTIONS(6260),
    [anon_sym_point] = ACTIONS(6260),
    [anon_sym_line] = ACTIONS(6260),
    [anon_sym_triangleadj] = ACTIONS(6260),
    [anon_sym_lineadj] = ACTIONS(6260),
    [anon_sym_triangle] = ACTIONS(6260),
    [anon_sym_interface] = ACTIONS(6260),
    [anon_sym_extension] = ACTIONS(6260),
    [anon_sym___init] = ACTIONS(6260),
    [anon_sym___subscript] = ACTIONS(6260),
    [anon_sym_property] = ACTIONS(6260),
    [anon_sym_associatedtype] = ACTIONS(6260),
  },
  [1722] = {
    [sym_identifier] = ACTIONS(6264),
    [aux_sym_preproc_def_token1] = ACTIONS(6264),
    [aux_sym_preproc_if_token1] = ACTIONS(6264),
    [aux_sym_preproc_if_token2] = ACTIONS(6264),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6264),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6264),
    [aux_sym_preproc_else_token1] = ACTIONS(6264),
    [aux_sym_preproc_elif_token1] = ACTIONS(6264),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6264),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6264),
    [sym_preproc_directive] = ACTIONS(6264),
    [anon_sym_LPAREN2] = ACTIONS(6266),
    [anon_sym_TILDE] = ACTIONS(6266),
    [anon_sym_STAR] = ACTIONS(6266),
    [anon_sym_AMP_AMP] = ACTIONS(6266),
    [anon_sym_AMP] = ACTIONS(6264),
    [anon_sym_SEMI] = ACTIONS(6266),
    [anon_sym___extension__] = ACTIONS(6264),
    [anon_sym_typedef] = ACTIONS(6264),
    [anon_sym_in] = ACTIONS(6264),
    [anon_sym_out] = ACTIONS(6264),
    [anon_sym_inout] = ACTIONS(6264),
    [anon_sym_virtual] = ACTIONS(6264),
    [anon_sym_extern] = ACTIONS(6264),
    [anon_sym___attribute__] = ACTIONS(6264),
    [anon_sym___attribute] = ACTIONS(6264),
    [anon_sym_using] = ACTIONS(6264),
    [anon_sym_COLON_COLON] = ACTIONS(6266),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6266),
    [anon_sym___declspec] = ACTIONS(6264),
    [anon_sym___based] = ACTIONS(6264),
    [anon_sym_signed] = ACTIONS(6264),
    [anon_sym_unsigned] = ACTIONS(6264),
    [anon_sym_long] = ACTIONS(6264),
    [anon_sym_short] = ACTIONS(6264),
    [anon_sym_LBRACK] = ACTIONS(6264),
    [anon_sym_static] = ACTIONS(6264),
    [anon_sym_register] = ACTIONS(6264),
    [anon_sym_inline] = ACTIONS(6264),
    [anon_sym___inline] = ACTIONS(6264),
    [anon_sym___inline__] = ACTIONS(6264),
    [anon_sym___forceinline] = ACTIONS(6264),
    [anon_sym_thread_local] = ACTIONS(6264),
    [anon_sym___thread] = ACTIONS(6264),
    [anon_sym_const] = ACTIONS(6264),
    [anon_sym_constexpr] = ACTIONS(6264),
    [anon_sym_volatile] = ACTIONS(6264),
    [anon_sym_restrict] = ACTIONS(6264),
    [anon_sym___restrict__] = ACTIONS(6264),
    [anon_sym__Atomic] = ACTIONS(6264),
    [anon_sym__Noreturn] = ACTIONS(6264),
    [anon_sym_noreturn] = ACTIONS(6264),
    [anon_sym__Nonnull] = ACTIONS(6264),
    [anon_sym_mutable] = ACTIONS(6264),
    [anon_sym_constinit] = ACTIONS(6264),
    [anon_sym_consteval] = ACTIONS(6264),
    [anon_sym_alignas] = ACTIONS(6264),
    [anon_sym__Alignas] = ACTIONS(6264),
    [sym_primitive_type] = ACTIONS(6264),
    [anon_sym_enum] = ACTIONS(6264),
    [anon_sym_class] = ACTIONS(6264),
    [anon_sym_struct] = ACTIONS(6264),
    [anon_sym_union] = ACTIONS(6264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6264),
    [anon_sym_let] = ACTIONS(6264),
    [anon_sym_This] = ACTIONS(6264),
    [anon_sym_decltype] = ACTIONS(6264),
    [anon_sym_explicit] = ACTIONS(6264),
    [anon_sym_typename] = ACTIONS(6264),
    [anon_sym_private] = ACTIONS(6264),
    [anon_sym_template] = ACTIONS(6264),
    [anon_sym_operator] = ACTIONS(6264),
    [anon_sym_friend] = ACTIONS(6264),
    [anon_sym_public] = ACTIONS(6264),
    [anon_sym_protected] = ACTIONS(6264),
    [anon_sym_static_assert] = ACTIONS(6264),
    [anon_sym_precise] = ACTIONS(6264),
    [anon_sym_shared] = ACTIONS(6264),
    [anon_sym_groupshared] = ACTIONS(6264),
    [anon_sym_uniform] = ACTIONS(6264),
    [anon_sym_row_major] = ACTIONS(6264),
    [anon_sym_column_major] = ACTIONS(6264),
    [anon_sym_globallycoherent] = ACTIONS(6264),
    [anon_sym_centroid] = ACTIONS(6264),
    [anon_sym_noperspective] = ACTIONS(6264),
    [anon_sym_nointerpolation] = ACTIONS(6264),
    [anon_sym_sample] = ACTIONS(6264),
    [anon_sym_linear] = ACTIONS(6264),
    [anon_sym_snorm] = ACTIONS(6264),
    [anon_sym_unorm] = ACTIONS(6264),
    [anon_sym_point] = ACTIONS(6264),
    [anon_sym_line] = ACTIONS(6264),
    [anon_sym_triangleadj] = ACTIONS(6264),
    [anon_sym_lineadj] = ACTIONS(6264),
    [anon_sym_triangle] = ACTIONS(6264),
    [anon_sym_interface] = ACTIONS(6264),
    [anon_sym_extension] = ACTIONS(6264),
    [anon_sym___init] = ACTIONS(6264),
    [anon_sym___subscript] = ACTIONS(6264),
    [anon_sym_property] = ACTIONS(6264),
    [anon_sym_associatedtype] = ACTIONS(6264),
  },
  [1723] = {
    [sym_identifier] = ACTIONS(3562),
    [aux_sym_preproc_def_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token2] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3562),
    [aux_sym_preproc_else_token1] = ACTIONS(3562),
    [aux_sym_preproc_elif_token1] = ACTIONS(3562),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3562),
    [sym_preproc_directive] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym___extension__] = ACTIONS(3562),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_in] = ACTIONS(3562),
    [anon_sym_out] = ACTIONS(3562),
    [anon_sym_inout] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym___attribute__] = ACTIONS(3562),
    [anon_sym___attribute] = ACTIONS(3562),
    [anon_sym_using] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3560),
    [anon_sym___declspec] = ACTIONS(3562),
    [anon_sym___based] = ACTIONS(3562),
    [anon_sym_signed] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym___inline] = ACTIONS(3562),
    [anon_sym___inline__] = ACTIONS(3562),
    [anon_sym___forceinline] = ACTIONS(3562),
    [anon_sym_thread_local] = ACTIONS(3562),
    [anon_sym___thread] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_constexpr] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym___restrict__] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym__Noreturn] = ACTIONS(3562),
    [anon_sym_noreturn] = ACTIONS(3562),
    [anon_sym__Nonnull] = ACTIONS(3562),
    [anon_sym_mutable] = ACTIONS(3562),
    [anon_sym_constinit] = ACTIONS(3562),
    [anon_sym_consteval] = ACTIONS(3562),
    [anon_sym_alignas] = ACTIONS(3562),
    [anon_sym__Alignas] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_This] = ACTIONS(3562),
    [anon_sym_decltype] = ACTIONS(3562),
    [anon_sym_explicit] = ACTIONS(3562),
    [anon_sym_typename] = ACTIONS(3562),
    [anon_sym_private] = ACTIONS(3562),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(3562),
    [anon_sym_friend] = ACTIONS(3562),
    [anon_sym_public] = ACTIONS(3562),
    [anon_sym_protected] = ACTIONS(3562),
    [anon_sym_static_assert] = ACTIONS(3562),
    [anon_sym_precise] = ACTIONS(3562),
    [anon_sym_shared] = ACTIONS(3562),
    [anon_sym_groupshared] = ACTIONS(3562),
    [anon_sym_uniform] = ACTIONS(3562),
    [anon_sym_row_major] = ACTIONS(3562),
    [anon_sym_column_major] = ACTIONS(3562),
    [anon_sym_globallycoherent] = ACTIONS(3562),
    [anon_sym_centroid] = ACTIONS(3562),
    [anon_sym_noperspective] = ACTIONS(3562),
    [anon_sym_nointerpolation] = ACTIONS(3562),
    [anon_sym_sample] = ACTIONS(3562),
    [anon_sym_linear] = ACTIONS(3562),
    [anon_sym_snorm] = ACTIONS(3562),
    [anon_sym_unorm] = ACTIONS(3562),
    [anon_sym_point] = ACTIONS(3562),
    [anon_sym_line] = ACTIONS(3562),
    [anon_sym_triangleadj] = ACTIONS(3562),
    [anon_sym_lineadj] = ACTIONS(3562),
    [anon_sym_triangle] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_extension] = ACTIONS(3562),
    [anon_sym___init] = ACTIONS(3562),
    [anon_sym___subscript] = ACTIONS(3562),
    [anon_sym_property] = ACTIONS(3562),
    [anon_sym_associatedtype] = ACTIONS(3562),
  },
  [1724] = {
    [sym_identifier] = ACTIONS(3562),
    [aux_sym_preproc_def_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token2] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3562),
    [aux_sym_preproc_else_token1] = ACTIONS(3562),
    [aux_sym_preproc_elif_token1] = ACTIONS(3562),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3562),
    [sym_preproc_directive] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym___extension__] = ACTIONS(3562),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_in] = ACTIONS(3562),
    [anon_sym_out] = ACTIONS(3562),
    [anon_sym_inout] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym___attribute__] = ACTIONS(3562),
    [anon_sym___attribute] = ACTIONS(3562),
    [anon_sym_using] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3560),
    [anon_sym___declspec] = ACTIONS(3562),
    [anon_sym___based] = ACTIONS(3562),
    [anon_sym_signed] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym___inline] = ACTIONS(3562),
    [anon_sym___inline__] = ACTIONS(3562),
    [anon_sym___forceinline] = ACTIONS(3562),
    [anon_sym_thread_local] = ACTIONS(3562),
    [anon_sym___thread] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_constexpr] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym___restrict__] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym__Noreturn] = ACTIONS(3562),
    [anon_sym_noreturn] = ACTIONS(3562),
    [anon_sym__Nonnull] = ACTIONS(3562),
    [anon_sym_mutable] = ACTIONS(3562),
    [anon_sym_constinit] = ACTIONS(3562),
    [anon_sym_consteval] = ACTIONS(3562),
    [anon_sym_alignas] = ACTIONS(3562),
    [anon_sym__Alignas] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_This] = ACTIONS(3562),
    [anon_sym_decltype] = ACTIONS(3562),
    [anon_sym_explicit] = ACTIONS(3562),
    [anon_sym_typename] = ACTIONS(3562),
    [anon_sym_private] = ACTIONS(3562),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(3562),
    [anon_sym_friend] = ACTIONS(3562),
    [anon_sym_public] = ACTIONS(3562),
    [anon_sym_protected] = ACTIONS(3562),
    [anon_sym_static_assert] = ACTIONS(3562),
    [anon_sym_precise] = ACTIONS(3562),
    [anon_sym_shared] = ACTIONS(3562),
    [anon_sym_groupshared] = ACTIONS(3562),
    [anon_sym_uniform] = ACTIONS(3562),
    [anon_sym_row_major] = ACTIONS(3562),
    [anon_sym_column_major] = ACTIONS(3562),
    [anon_sym_globallycoherent] = ACTIONS(3562),
    [anon_sym_centroid] = ACTIONS(3562),
    [anon_sym_noperspective] = ACTIONS(3562),
    [anon_sym_nointerpolation] = ACTIONS(3562),
    [anon_sym_sample] = ACTIONS(3562),
    [anon_sym_linear] = ACTIONS(3562),
    [anon_sym_snorm] = ACTIONS(3562),
    [anon_sym_unorm] = ACTIONS(3562),
    [anon_sym_point] = ACTIONS(3562),
    [anon_sym_line] = ACTIONS(3562),
    [anon_sym_triangleadj] = ACTIONS(3562),
    [anon_sym_lineadj] = ACTIONS(3562),
    [anon_sym_triangle] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_extension] = ACTIONS(3562),
    [anon_sym___init] = ACTIONS(3562),
    [anon_sym___subscript] = ACTIONS(3562),
    [anon_sym_property] = ACTIONS(3562),
    [anon_sym_associatedtype] = ACTIONS(3562),
  },
  [1725] = {
    [sym_identifier] = ACTIONS(3562),
    [aux_sym_preproc_def_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token2] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3562),
    [aux_sym_preproc_else_token1] = ACTIONS(3562),
    [aux_sym_preproc_elif_token1] = ACTIONS(3562),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3562),
    [sym_preproc_directive] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym___extension__] = ACTIONS(3562),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_in] = ACTIONS(3562),
    [anon_sym_out] = ACTIONS(3562),
    [anon_sym_inout] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym___attribute__] = ACTIONS(3562),
    [anon_sym___attribute] = ACTIONS(3562),
    [anon_sym_using] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3560),
    [anon_sym___declspec] = ACTIONS(3562),
    [anon_sym___based] = ACTIONS(3562),
    [anon_sym_signed] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym___inline] = ACTIONS(3562),
    [anon_sym___inline__] = ACTIONS(3562),
    [anon_sym___forceinline] = ACTIONS(3562),
    [anon_sym_thread_local] = ACTIONS(3562),
    [anon_sym___thread] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_constexpr] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym___restrict__] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym__Noreturn] = ACTIONS(3562),
    [anon_sym_noreturn] = ACTIONS(3562),
    [anon_sym__Nonnull] = ACTIONS(3562),
    [anon_sym_mutable] = ACTIONS(3562),
    [anon_sym_constinit] = ACTIONS(3562),
    [anon_sym_consteval] = ACTIONS(3562),
    [anon_sym_alignas] = ACTIONS(3562),
    [anon_sym__Alignas] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_This] = ACTIONS(3562),
    [anon_sym_decltype] = ACTIONS(3562),
    [anon_sym_explicit] = ACTIONS(3562),
    [anon_sym_typename] = ACTIONS(3562),
    [anon_sym_private] = ACTIONS(3562),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(3562),
    [anon_sym_friend] = ACTIONS(3562),
    [anon_sym_public] = ACTIONS(3562),
    [anon_sym_protected] = ACTIONS(3562),
    [anon_sym_static_assert] = ACTIONS(3562),
    [anon_sym_precise] = ACTIONS(3562),
    [anon_sym_shared] = ACTIONS(3562),
    [anon_sym_groupshared] = ACTIONS(3562),
    [anon_sym_uniform] = ACTIONS(3562),
    [anon_sym_row_major] = ACTIONS(3562),
    [anon_sym_column_major] = ACTIONS(3562),
    [anon_sym_globallycoherent] = ACTIONS(3562),
    [anon_sym_centroid] = ACTIONS(3562),
    [anon_sym_noperspective] = ACTIONS(3562),
    [anon_sym_nointerpolation] = ACTIONS(3562),
    [anon_sym_sample] = ACTIONS(3562),
    [anon_sym_linear] = ACTIONS(3562),
    [anon_sym_snorm] = ACTIONS(3562),
    [anon_sym_unorm] = ACTIONS(3562),
    [anon_sym_point] = ACTIONS(3562),
    [anon_sym_line] = ACTIONS(3562),
    [anon_sym_triangleadj] = ACTIONS(3562),
    [anon_sym_lineadj] = ACTIONS(3562),
    [anon_sym_triangle] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_extension] = ACTIONS(3562),
    [anon_sym___init] = ACTIONS(3562),
    [anon_sym___subscript] = ACTIONS(3562),
    [anon_sym_property] = ACTIONS(3562),
    [anon_sym_associatedtype] = ACTIONS(3562),
  },
  [1726] = {
    [sym_identifier] = ACTIONS(6268),
    [aux_sym_preproc_def_token1] = ACTIONS(6268),
    [aux_sym_preproc_if_token1] = ACTIONS(6268),
    [aux_sym_preproc_if_token2] = ACTIONS(6268),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6268),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6268),
    [aux_sym_preproc_else_token1] = ACTIONS(6268),
    [aux_sym_preproc_elif_token1] = ACTIONS(6268),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6268),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6268),
    [sym_preproc_directive] = ACTIONS(6268),
    [anon_sym_LPAREN2] = ACTIONS(6270),
    [anon_sym_TILDE] = ACTIONS(6270),
    [anon_sym_STAR] = ACTIONS(6270),
    [anon_sym_AMP_AMP] = ACTIONS(6270),
    [anon_sym_AMP] = ACTIONS(6268),
    [anon_sym_SEMI] = ACTIONS(6270),
    [anon_sym___extension__] = ACTIONS(6268),
    [anon_sym_typedef] = ACTIONS(6268),
    [anon_sym_in] = ACTIONS(6268),
    [anon_sym_out] = ACTIONS(6268),
    [anon_sym_inout] = ACTIONS(6268),
    [anon_sym_virtual] = ACTIONS(6268),
    [anon_sym_extern] = ACTIONS(6268),
    [anon_sym___attribute__] = ACTIONS(6268),
    [anon_sym___attribute] = ACTIONS(6268),
    [anon_sym_using] = ACTIONS(6268),
    [anon_sym_COLON_COLON] = ACTIONS(6270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6270),
    [anon_sym___declspec] = ACTIONS(6268),
    [anon_sym___based] = ACTIONS(6268),
    [anon_sym_signed] = ACTIONS(6268),
    [anon_sym_unsigned] = ACTIONS(6268),
    [anon_sym_long] = ACTIONS(6268),
    [anon_sym_short] = ACTIONS(6268),
    [anon_sym_LBRACK] = ACTIONS(6268),
    [anon_sym_static] = ACTIONS(6268),
    [anon_sym_register] = ACTIONS(6268),
    [anon_sym_inline] = ACTIONS(6268),
    [anon_sym___inline] = ACTIONS(6268),
    [anon_sym___inline__] = ACTIONS(6268),
    [anon_sym___forceinline] = ACTIONS(6268),
    [anon_sym_thread_local] = ACTIONS(6268),
    [anon_sym___thread] = ACTIONS(6268),
    [anon_sym_const] = ACTIONS(6268),
    [anon_sym_constexpr] = ACTIONS(6268),
    [anon_sym_volatile] = ACTIONS(6268),
    [anon_sym_restrict] = ACTIONS(6268),
    [anon_sym___restrict__] = ACTIONS(6268),
    [anon_sym__Atomic] = ACTIONS(6268),
    [anon_sym__Noreturn] = ACTIONS(6268),
    [anon_sym_noreturn] = ACTIONS(6268),
    [anon_sym__Nonnull] = ACTIONS(6268),
    [anon_sym_mutable] = ACTIONS(6268),
    [anon_sym_constinit] = ACTIONS(6268),
    [anon_sym_consteval] = ACTIONS(6268),
    [anon_sym_alignas] = ACTIONS(6268),
    [anon_sym__Alignas] = ACTIONS(6268),
    [sym_primitive_type] = ACTIONS(6268),
    [anon_sym_enum] = ACTIONS(6268),
    [anon_sym_class] = ACTIONS(6268),
    [anon_sym_struct] = ACTIONS(6268),
    [anon_sym_union] = ACTIONS(6268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6268),
    [anon_sym_let] = ACTIONS(6268),
    [anon_sym_This] = ACTIONS(6268),
    [anon_sym_decltype] = ACTIONS(6268),
    [anon_sym_explicit] = ACTIONS(6268),
    [anon_sym_typename] = ACTIONS(6268),
    [anon_sym_private] = ACTIONS(6268),
    [anon_sym_template] = ACTIONS(6268),
    [anon_sym_operator] = ACTIONS(6268),
    [anon_sym_friend] = ACTIONS(6268),
    [anon_sym_public] = ACTIONS(6268),
    [anon_sym_protected] = ACTIONS(6268),
    [anon_sym_static_assert] = ACTIONS(6268),
    [anon_sym_precise] = ACTIONS(6268),
    [anon_sym_shared] = ACTIONS(6268),
    [anon_sym_groupshared] = ACTIONS(6268),
    [anon_sym_uniform] = ACTIONS(6268),
    [anon_sym_row_major] = ACTIONS(6268),
    [anon_sym_column_major] = ACTIONS(6268),
    [anon_sym_globallycoherent] = ACTIONS(6268),
    [anon_sym_centroid] = ACTIONS(6268),
    [anon_sym_noperspective] = ACTIONS(6268),
    [anon_sym_nointerpolation] = ACTIONS(6268),
    [anon_sym_sample] = ACTIONS(6268),
    [anon_sym_linear] = ACTIONS(6268),
    [anon_sym_snorm] = ACTIONS(6268),
    [anon_sym_unorm] = ACTIONS(6268),
    [anon_sym_point] = ACTIONS(6268),
    [anon_sym_line] = ACTIONS(6268),
    [anon_sym_triangleadj] = ACTIONS(6268),
    [anon_sym_lineadj] = ACTIONS(6268),
    [anon_sym_triangle] = ACTIONS(6268),
    [anon_sym_interface] = ACTIONS(6268),
    [anon_sym_extension] = ACTIONS(6268),
    [anon_sym___init] = ACTIONS(6268),
    [anon_sym___subscript] = ACTIONS(6268),
    [anon_sym_property] = ACTIONS(6268),
    [anon_sym_associatedtype] = ACTIONS(6268),
  },
  [1727] = {
    [sym_compound_statement] = STATE(9732),
    [sym_expression] = STATE(5515),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(9732),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_RPAREN] = ACTIONS(6272),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(6134),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1728] = {
    [sym_identifier] = ACTIONS(6264),
    [aux_sym_preproc_def_token1] = ACTIONS(6264),
    [aux_sym_preproc_if_token1] = ACTIONS(6264),
    [aux_sym_preproc_if_token2] = ACTIONS(6264),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6264),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6264),
    [aux_sym_preproc_else_token1] = ACTIONS(6264),
    [aux_sym_preproc_elif_token1] = ACTIONS(6264),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6264),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6264),
    [sym_preproc_directive] = ACTIONS(6264),
    [anon_sym_LPAREN2] = ACTIONS(6266),
    [anon_sym_TILDE] = ACTIONS(6266),
    [anon_sym_STAR] = ACTIONS(6266),
    [anon_sym_AMP_AMP] = ACTIONS(6266),
    [anon_sym_AMP] = ACTIONS(6264),
    [anon_sym_SEMI] = ACTIONS(6266),
    [anon_sym___extension__] = ACTIONS(6264),
    [anon_sym_typedef] = ACTIONS(6264),
    [anon_sym_in] = ACTIONS(6264),
    [anon_sym_out] = ACTIONS(6264),
    [anon_sym_inout] = ACTIONS(6264),
    [anon_sym_virtual] = ACTIONS(6264),
    [anon_sym_extern] = ACTIONS(6264),
    [anon_sym___attribute__] = ACTIONS(6264),
    [anon_sym___attribute] = ACTIONS(6264),
    [anon_sym_using] = ACTIONS(6264),
    [anon_sym_COLON_COLON] = ACTIONS(6266),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6266),
    [anon_sym___declspec] = ACTIONS(6264),
    [anon_sym___based] = ACTIONS(6264),
    [anon_sym_signed] = ACTIONS(6264),
    [anon_sym_unsigned] = ACTIONS(6264),
    [anon_sym_long] = ACTIONS(6264),
    [anon_sym_short] = ACTIONS(6264),
    [anon_sym_LBRACK] = ACTIONS(6264),
    [anon_sym_static] = ACTIONS(6264),
    [anon_sym_register] = ACTIONS(6264),
    [anon_sym_inline] = ACTIONS(6264),
    [anon_sym___inline] = ACTIONS(6264),
    [anon_sym___inline__] = ACTIONS(6264),
    [anon_sym___forceinline] = ACTIONS(6264),
    [anon_sym_thread_local] = ACTIONS(6264),
    [anon_sym___thread] = ACTIONS(6264),
    [anon_sym_const] = ACTIONS(6264),
    [anon_sym_constexpr] = ACTIONS(6264),
    [anon_sym_volatile] = ACTIONS(6264),
    [anon_sym_restrict] = ACTIONS(6264),
    [anon_sym___restrict__] = ACTIONS(6264),
    [anon_sym__Atomic] = ACTIONS(6264),
    [anon_sym__Noreturn] = ACTIONS(6264),
    [anon_sym_noreturn] = ACTIONS(6264),
    [anon_sym__Nonnull] = ACTIONS(6264),
    [anon_sym_mutable] = ACTIONS(6264),
    [anon_sym_constinit] = ACTIONS(6264),
    [anon_sym_consteval] = ACTIONS(6264),
    [anon_sym_alignas] = ACTIONS(6264),
    [anon_sym__Alignas] = ACTIONS(6264),
    [sym_primitive_type] = ACTIONS(6264),
    [anon_sym_enum] = ACTIONS(6264),
    [anon_sym_class] = ACTIONS(6264),
    [anon_sym_struct] = ACTIONS(6264),
    [anon_sym_union] = ACTIONS(6264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6264),
    [anon_sym_let] = ACTIONS(6264),
    [anon_sym_This] = ACTIONS(6264),
    [anon_sym_decltype] = ACTIONS(6264),
    [anon_sym_explicit] = ACTIONS(6264),
    [anon_sym_typename] = ACTIONS(6264),
    [anon_sym_private] = ACTIONS(6264),
    [anon_sym_template] = ACTIONS(6264),
    [anon_sym_operator] = ACTIONS(6264),
    [anon_sym_friend] = ACTIONS(6264),
    [anon_sym_public] = ACTIONS(6264),
    [anon_sym_protected] = ACTIONS(6264),
    [anon_sym_static_assert] = ACTIONS(6264),
    [anon_sym_precise] = ACTIONS(6264),
    [anon_sym_shared] = ACTIONS(6264),
    [anon_sym_groupshared] = ACTIONS(6264),
    [anon_sym_uniform] = ACTIONS(6264),
    [anon_sym_row_major] = ACTIONS(6264),
    [anon_sym_column_major] = ACTIONS(6264),
    [anon_sym_globallycoherent] = ACTIONS(6264),
    [anon_sym_centroid] = ACTIONS(6264),
    [anon_sym_noperspective] = ACTIONS(6264),
    [anon_sym_nointerpolation] = ACTIONS(6264),
    [anon_sym_sample] = ACTIONS(6264),
    [anon_sym_linear] = ACTIONS(6264),
    [anon_sym_snorm] = ACTIONS(6264),
    [anon_sym_unorm] = ACTIONS(6264),
    [anon_sym_point] = ACTIONS(6264),
    [anon_sym_line] = ACTIONS(6264),
    [anon_sym_triangleadj] = ACTIONS(6264),
    [anon_sym_lineadj] = ACTIONS(6264),
    [anon_sym_triangle] = ACTIONS(6264),
    [anon_sym_interface] = ACTIONS(6264),
    [anon_sym_extension] = ACTIONS(6264),
    [anon_sym___init] = ACTIONS(6264),
    [anon_sym___subscript] = ACTIONS(6264),
    [anon_sym_property] = ACTIONS(6264),
    [anon_sym_associatedtype] = ACTIONS(6264),
  },
  [1729] = {
    [sym_identifier] = ACTIONS(3581),
    [aux_sym_preproc_def_token1] = ACTIONS(3581),
    [aux_sym_preproc_if_token1] = ACTIONS(3581),
    [aux_sym_preproc_if_token2] = ACTIONS(3581),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3581),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3581),
    [aux_sym_preproc_else_token1] = ACTIONS(3581),
    [aux_sym_preproc_elif_token1] = ACTIONS(3581),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3581),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3581),
    [sym_preproc_directive] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(3579),
    [anon_sym_TILDE] = ACTIONS(3579),
    [anon_sym_STAR] = ACTIONS(3579),
    [anon_sym_AMP_AMP] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3581),
    [anon_sym_SEMI] = ACTIONS(3579),
    [anon_sym___extension__] = ACTIONS(3581),
    [anon_sym_typedef] = ACTIONS(3581),
    [anon_sym_in] = ACTIONS(3581),
    [anon_sym_out] = ACTIONS(3581),
    [anon_sym_inout] = ACTIONS(3581),
    [anon_sym_virtual] = ACTIONS(3581),
    [anon_sym_extern] = ACTIONS(3581),
    [anon_sym___attribute__] = ACTIONS(3581),
    [anon_sym___attribute] = ACTIONS(3581),
    [anon_sym_using] = ACTIONS(3581),
    [anon_sym_COLON_COLON] = ACTIONS(3579),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3579),
    [anon_sym___declspec] = ACTIONS(3581),
    [anon_sym___based] = ACTIONS(3581),
    [anon_sym_signed] = ACTIONS(3581),
    [anon_sym_unsigned] = ACTIONS(3581),
    [anon_sym_long] = ACTIONS(3581),
    [anon_sym_short] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_static] = ACTIONS(3581),
    [anon_sym_register] = ACTIONS(3581),
    [anon_sym_inline] = ACTIONS(3581),
    [anon_sym___inline] = ACTIONS(3581),
    [anon_sym___inline__] = ACTIONS(3581),
    [anon_sym___forceinline] = ACTIONS(3581),
    [anon_sym_thread_local] = ACTIONS(3581),
    [anon_sym___thread] = ACTIONS(3581),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_constexpr] = ACTIONS(3581),
    [anon_sym_volatile] = ACTIONS(3581),
    [anon_sym_restrict] = ACTIONS(3581),
    [anon_sym___restrict__] = ACTIONS(3581),
    [anon_sym__Atomic] = ACTIONS(3581),
    [anon_sym__Noreturn] = ACTIONS(3581),
    [anon_sym_noreturn] = ACTIONS(3581),
    [anon_sym__Nonnull] = ACTIONS(3581),
    [anon_sym_mutable] = ACTIONS(3581),
    [anon_sym_constinit] = ACTIONS(3581),
    [anon_sym_consteval] = ACTIONS(3581),
    [anon_sym_alignas] = ACTIONS(3581),
    [anon_sym__Alignas] = ACTIONS(3581),
    [sym_primitive_type] = ACTIONS(3581),
    [anon_sym_enum] = ACTIONS(3581),
    [anon_sym_class] = ACTIONS(3581),
    [anon_sym_struct] = ACTIONS(3581),
    [anon_sym_union] = ACTIONS(3581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_This] = ACTIONS(3581),
    [anon_sym_decltype] = ACTIONS(3581),
    [anon_sym_explicit] = ACTIONS(3581),
    [anon_sym_typename] = ACTIONS(3581),
    [anon_sym_private] = ACTIONS(3581),
    [anon_sym_template] = ACTIONS(3581),
    [anon_sym_operator] = ACTIONS(3581),
    [anon_sym_friend] = ACTIONS(3581),
    [anon_sym_public] = ACTIONS(3581),
    [anon_sym_protected] = ACTIONS(3581),
    [anon_sym_static_assert] = ACTIONS(3581),
    [anon_sym_precise] = ACTIONS(3581),
    [anon_sym_shared] = ACTIONS(3581),
    [anon_sym_groupshared] = ACTIONS(3581),
    [anon_sym_uniform] = ACTIONS(3581),
    [anon_sym_row_major] = ACTIONS(3581),
    [anon_sym_column_major] = ACTIONS(3581),
    [anon_sym_globallycoherent] = ACTIONS(3581),
    [anon_sym_centroid] = ACTIONS(3581),
    [anon_sym_noperspective] = ACTIONS(3581),
    [anon_sym_nointerpolation] = ACTIONS(3581),
    [anon_sym_sample] = ACTIONS(3581),
    [anon_sym_linear] = ACTIONS(3581),
    [anon_sym_snorm] = ACTIONS(3581),
    [anon_sym_unorm] = ACTIONS(3581),
    [anon_sym_point] = ACTIONS(3581),
    [anon_sym_line] = ACTIONS(3581),
    [anon_sym_triangleadj] = ACTIONS(3581),
    [anon_sym_lineadj] = ACTIONS(3581),
    [anon_sym_triangle] = ACTIONS(3581),
    [anon_sym_interface] = ACTIONS(3581),
    [anon_sym_extension] = ACTIONS(3581),
    [anon_sym___init] = ACTIONS(3581),
    [anon_sym___subscript] = ACTIONS(3581),
    [anon_sym_property] = ACTIONS(3581),
    [anon_sym_associatedtype] = ACTIONS(3581),
  },
  [1730] = {
    [sym_identifier] = ACTIONS(3591),
    [aux_sym_preproc_def_token1] = ACTIONS(3591),
    [aux_sym_preproc_if_token1] = ACTIONS(3591),
    [aux_sym_preproc_if_token2] = ACTIONS(3591),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3591),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3591),
    [aux_sym_preproc_else_token1] = ACTIONS(3591),
    [aux_sym_preproc_elif_token1] = ACTIONS(3591),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3591),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3591),
    [sym_preproc_directive] = ACTIONS(3591),
    [anon_sym_LPAREN2] = ACTIONS(3589),
    [anon_sym_TILDE] = ACTIONS(3589),
    [anon_sym_STAR] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(3589),
    [anon_sym___extension__] = ACTIONS(3591),
    [anon_sym_typedef] = ACTIONS(3591),
    [anon_sym_in] = ACTIONS(3591),
    [anon_sym_out] = ACTIONS(3591),
    [anon_sym_inout] = ACTIONS(3591),
    [anon_sym_virtual] = ACTIONS(3591),
    [anon_sym_extern] = ACTIONS(3591),
    [anon_sym___attribute__] = ACTIONS(3591),
    [anon_sym___attribute] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3591),
    [anon_sym_COLON_COLON] = ACTIONS(3589),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3589),
    [anon_sym___declspec] = ACTIONS(3591),
    [anon_sym___based] = ACTIONS(3591),
    [anon_sym_signed] = ACTIONS(3591),
    [anon_sym_unsigned] = ACTIONS(3591),
    [anon_sym_long] = ACTIONS(3591),
    [anon_sym_short] = ACTIONS(3591),
    [anon_sym_LBRACK] = ACTIONS(3591),
    [anon_sym_static] = ACTIONS(3591),
    [anon_sym_register] = ACTIONS(3591),
    [anon_sym_inline] = ACTIONS(3591),
    [anon_sym___inline] = ACTIONS(3591),
    [anon_sym___inline__] = ACTIONS(3591),
    [anon_sym___forceinline] = ACTIONS(3591),
    [anon_sym_thread_local] = ACTIONS(3591),
    [anon_sym___thread] = ACTIONS(3591),
    [anon_sym_const] = ACTIONS(3591),
    [anon_sym_constexpr] = ACTIONS(3591),
    [anon_sym_volatile] = ACTIONS(3591),
    [anon_sym_restrict] = ACTIONS(3591),
    [anon_sym___restrict__] = ACTIONS(3591),
    [anon_sym__Atomic] = ACTIONS(3591),
    [anon_sym__Noreturn] = ACTIONS(3591),
    [anon_sym_noreturn] = ACTIONS(3591),
    [anon_sym__Nonnull] = ACTIONS(3591),
    [anon_sym_mutable] = ACTIONS(3591),
    [anon_sym_constinit] = ACTIONS(3591),
    [anon_sym_consteval] = ACTIONS(3591),
    [anon_sym_alignas] = ACTIONS(3591),
    [anon_sym__Alignas] = ACTIONS(3591),
    [sym_primitive_type] = ACTIONS(3591),
    [anon_sym_enum] = ACTIONS(3591),
    [anon_sym_class] = ACTIONS(3591),
    [anon_sym_struct] = ACTIONS(3591),
    [anon_sym_union] = ACTIONS(3591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3591),
    [anon_sym_let] = ACTIONS(3591),
    [anon_sym_This] = ACTIONS(3591),
    [anon_sym_decltype] = ACTIONS(3591),
    [anon_sym_explicit] = ACTIONS(3591),
    [anon_sym_typename] = ACTIONS(3591),
    [anon_sym_private] = ACTIONS(3591),
    [anon_sym_template] = ACTIONS(3591),
    [anon_sym_operator] = ACTIONS(3591),
    [anon_sym_friend] = ACTIONS(3591),
    [anon_sym_public] = ACTIONS(3591),
    [anon_sym_protected] = ACTIONS(3591),
    [anon_sym_static_assert] = ACTIONS(3591),
    [anon_sym_precise] = ACTIONS(3591),
    [anon_sym_shared] = ACTIONS(3591),
    [anon_sym_groupshared] = ACTIONS(3591),
    [anon_sym_uniform] = ACTIONS(3591),
    [anon_sym_row_major] = ACTIONS(3591),
    [anon_sym_column_major] = ACTIONS(3591),
    [anon_sym_globallycoherent] = ACTIONS(3591),
    [anon_sym_centroid] = ACTIONS(3591),
    [anon_sym_noperspective] = ACTIONS(3591),
    [anon_sym_nointerpolation] = ACTIONS(3591),
    [anon_sym_sample] = ACTIONS(3591),
    [anon_sym_linear] = ACTIONS(3591),
    [anon_sym_snorm] = ACTIONS(3591),
    [anon_sym_unorm] = ACTIONS(3591),
    [anon_sym_point] = ACTIONS(3591),
    [anon_sym_line] = ACTIONS(3591),
    [anon_sym_triangleadj] = ACTIONS(3591),
    [anon_sym_lineadj] = ACTIONS(3591),
    [anon_sym_triangle] = ACTIONS(3591),
    [anon_sym_interface] = ACTIONS(3591),
    [anon_sym_extension] = ACTIONS(3591),
    [anon_sym___init] = ACTIONS(3591),
    [anon_sym___subscript] = ACTIONS(3591),
    [anon_sym_property] = ACTIONS(3591),
    [anon_sym_associatedtype] = ACTIONS(3591),
  },
  [1731] = {
    [sym_identifier] = ACTIONS(3889),
    [aux_sym_preproc_def_token1] = ACTIONS(3889),
    [aux_sym_preproc_if_token1] = ACTIONS(3889),
    [aux_sym_preproc_if_token2] = ACTIONS(3889),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3889),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3889),
    [aux_sym_preproc_else_token1] = ACTIONS(3889),
    [aux_sym_preproc_elif_token1] = ACTIONS(3889),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3889),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3889),
    [sym_preproc_directive] = ACTIONS(3889),
    [anon_sym_LPAREN2] = ACTIONS(3891),
    [anon_sym_TILDE] = ACTIONS(3891),
    [anon_sym_STAR] = ACTIONS(3891),
    [anon_sym_AMP_AMP] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3889),
    [anon_sym_SEMI] = ACTIONS(3891),
    [anon_sym___extension__] = ACTIONS(3889),
    [anon_sym_typedef] = ACTIONS(3889),
    [anon_sym_in] = ACTIONS(3889),
    [anon_sym_out] = ACTIONS(3889),
    [anon_sym_inout] = ACTIONS(3889),
    [anon_sym_virtual] = ACTIONS(3889),
    [anon_sym_extern] = ACTIONS(3889),
    [anon_sym___attribute__] = ACTIONS(3889),
    [anon_sym___attribute] = ACTIONS(3889),
    [anon_sym_using] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3891),
    [anon_sym___declspec] = ACTIONS(3889),
    [anon_sym___based] = ACTIONS(3889),
    [anon_sym_signed] = ACTIONS(3889),
    [anon_sym_unsigned] = ACTIONS(3889),
    [anon_sym_long] = ACTIONS(3889),
    [anon_sym_short] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_static] = ACTIONS(3889),
    [anon_sym_register] = ACTIONS(3889),
    [anon_sym_inline] = ACTIONS(3889),
    [anon_sym___inline] = ACTIONS(3889),
    [anon_sym___inline__] = ACTIONS(3889),
    [anon_sym___forceinline] = ACTIONS(3889),
    [anon_sym_thread_local] = ACTIONS(3889),
    [anon_sym___thread] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3889),
    [anon_sym_constexpr] = ACTIONS(3889),
    [anon_sym_volatile] = ACTIONS(3889),
    [anon_sym_restrict] = ACTIONS(3889),
    [anon_sym___restrict__] = ACTIONS(3889),
    [anon_sym__Atomic] = ACTIONS(3889),
    [anon_sym__Noreturn] = ACTIONS(3889),
    [anon_sym_noreturn] = ACTIONS(3889),
    [anon_sym__Nonnull] = ACTIONS(3889),
    [anon_sym_mutable] = ACTIONS(3889),
    [anon_sym_constinit] = ACTIONS(3889),
    [anon_sym_consteval] = ACTIONS(3889),
    [anon_sym_alignas] = ACTIONS(3889),
    [anon_sym__Alignas] = ACTIONS(3889),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_enum] = ACTIONS(3889),
    [anon_sym_class] = ACTIONS(3889),
    [anon_sym_struct] = ACTIONS(3889),
    [anon_sym_union] = ACTIONS(3889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_This] = ACTIONS(3889),
    [anon_sym_decltype] = ACTIONS(3889),
    [anon_sym_explicit] = ACTIONS(3889),
    [anon_sym_typename] = ACTIONS(3889),
    [anon_sym_private] = ACTIONS(3889),
    [anon_sym_template] = ACTIONS(3889),
    [anon_sym_operator] = ACTIONS(3889),
    [anon_sym_friend] = ACTIONS(3889),
    [anon_sym_public] = ACTIONS(3889),
    [anon_sym_protected] = ACTIONS(3889),
    [anon_sym_static_assert] = ACTIONS(3889),
    [anon_sym_precise] = ACTIONS(3889),
    [anon_sym_shared] = ACTIONS(3889),
    [anon_sym_groupshared] = ACTIONS(3889),
    [anon_sym_uniform] = ACTIONS(3889),
    [anon_sym_row_major] = ACTIONS(3889),
    [anon_sym_column_major] = ACTIONS(3889),
    [anon_sym_globallycoherent] = ACTIONS(3889),
    [anon_sym_centroid] = ACTIONS(3889),
    [anon_sym_noperspective] = ACTIONS(3889),
    [anon_sym_nointerpolation] = ACTIONS(3889),
    [anon_sym_sample] = ACTIONS(3889),
    [anon_sym_linear] = ACTIONS(3889),
    [anon_sym_snorm] = ACTIONS(3889),
    [anon_sym_unorm] = ACTIONS(3889),
    [anon_sym_point] = ACTIONS(3889),
    [anon_sym_line] = ACTIONS(3889),
    [anon_sym_triangleadj] = ACTIONS(3889),
    [anon_sym_lineadj] = ACTIONS(3889),
    [anon_sym_triangle] = ACTIONS(3889),
    [anon_sym_interface] = ACTIONS(3889),
    [anon_sym_extension] = ACTIONS(3889),
    [anon_sym___init] = ACTIONS(3889),
    [anon_sym___subscript] = ACTIONS(3889),
    [anon_sym_property] = ACTIONS(3889),
    [anon_sym_associatedtype] = ACTIONS(3889),
  },
  [1732] = {
    [sym_identifier] = ACTIONS(3623),
    [aux_sym_preproc_def_token1] = ACTIONS(3623),
    [aux_sym_preproc_if_token1] = ACTIONS(3623),
    [aux_sym_preproc_if_token2] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3623),
    [aux_sym_preproc_else_token1] = ACTIONS(3623),
    [aux_sym_preproc_elif_token1] = ACTIONS(3623),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3623),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3623),
    [sym_preproc_directive] = ACTIONS(3623),
    [anon_sym_LPAREN2] = ACTIONS(3621),
    [anon_sym_TILDE] = ACTIONS(3621),
    [anon_sym_STAR] = ACTIONS(3621),
    [anon_sym_AMP_AMP] = ACTIONS(3621),
    [anon_sym_AMP] = ACTIONS(3623),
    [anon_sym_SEMI] = ACTIONS(3621),
    [anon_sym___extension__] = ACTIONS(3623),
    [anon_sym_typedef] = ACTIONS(3623),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_out] = ACTIONS(3623),
    [anon_sym_inout] = ACTIONS(3623),
    [anon_sym_virtual] = ACTIONS(3623),
    [anon_sym_extern] = ACTIONS(3623),
    [anon_sym___attribute__] = ACTIONS(3623),
    [anon_sym___attribute] = ACTIONS(3623),
    [anon_sym_using] = ACTIONS(3623),
    [anon_sym_COLON_COLON] = ACTIONS(3621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3621),
    [anon_sym___declspec] = ACTIONS(3623),
    [anon_sym___based] = ACTIONS(3623),
    [anon_sym_signed] = ACTIONS(3623),
    [anon_sym_unsigned] = ACTIONS(3623),
    [anon_sym_long] = ACTIONS(3623),
    [anon_sym_short] = ACTIONS(3623),
    [anon_sym_LBRACK] = ACTIONS(3623),
    [anon_sym_static] = ACTIONS(3623),
    [anon_sym_register] = ACTIONS(3623),
    [anon_sym_inline] = ACTIONS(3623),
    [anon_sym___inline] = ACTIONS(3623),
    [anon_sym___inline__] = ACTIONS(3623),
    [anon_sym___forceinline] = ACTIONS(3623),
    [anon_sym_thread_local] = ACTIONS(3623),
    [anon_sym___thread] = ACTIONS(3623),
    [anon_sym_const] = ACTIONS(3623),
    [anon_sym_constexpr] = ACTIONS(3623),
    [anon_sym_volatile] = ACTIONS(3623),
    [anon_sym_restrict] = ACTIONS(3623),
    [anon_sym___restrict__] = ACTIONS(3623),
    [anon_sym__Atomic] = ACTIONS(3623),
    [anon_sym__Noreturn] = ACTIONS(3623),
    [anon_sym_noreturn] = ACTIONS(3623),
    [anon_sym__Nonnull] = ACTIONS(3623),
    [anon_sym_mutable] = ACTIONS(3623),
    [anon_sym_constinit] = ACTIONS(3623),
    [anon_sym_consteval] = ACTIONS(3623),
    [anon_sym_alignas] = ACTIONS(3623),
    [anon_sym__Alignas] = ACTIONS(3623),
    [sym_primitive_type] = ACTIONS(3623),
    [anon_sym_enum] = ACTIONS(3623),
    [anon_sym_class] = ACTIONS(3623),
    [anon_sym_struct] = ACTIONS(3623),
    [anon_sym_union] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3623),
    [anon_sym_let] = ACTIONS(3623),
    [anon_sym_This] = ACTIONS(3623),
    [anon_sym_decltype] = ACTIONS(3623),
    [anon_sym_explicit] = ACTIONS(3623),
    [anon_sym_typename] = ACTIONS(3623),
    [anon_sym_private] = ACTIONS(3623),
    [anon_sym_template] = ACTIONS(3623),
    [anon_sym_operator] = ACTIONS(3623),
    [anon_sym_friend] = ACTIONS(3623),
    [anon_sym_public] = ACTIONS(3623),
    [anon_sym_protected] = ACTIONS(3623),
    [anon_sym_static_assert] = ACTIONS(3623),
    [anon_sym_precise] = ACTIONS(3623),
    [anon_sym_shared] = ACTIONS(3623),
    [anon_sym_groupshared] = ACTIONS(3623),
    [anon_sym_uniform] = ACTIONS(3623),
    [anon_sym_row_major] = ACTIONS(3623),
    [anon_sym_column_major] = ACTIONS(3623),
    [anon_sym_globallycoherent] = ACTIONS(3623),
    [anon_sym_centroid] = ACTIONS(3623),
    [anon_sym_noperspective] = ACTIONS(3623),
    [anon_sym_nointerpolation] = ACTIONS(3623),
    [anon_sym_sample] = ACTIONS(3623),
    [anon_sym_linear] = ACTIONS(3623),
    [anon_sym_snorm] = ACTIONS(3623),
    [anon_sym_unorm] = ACTIONS(3623),
    [anon_sym_point] = ACTIONS(3623),
    [anon_sym_line] = ACTIONS(3623),
    [anon_sym_triangleadj] = ACTIONS(3623),
    [anon_sym_lineadj] = ACTIONS(3623),
    [anon_sym_triangle] = ACTIONS(3623),
    [anon_sym_interface] = ACTIONS(3623),
    [anon_sym_extension] = ACTIONS(3623),
    [anon_sym___init] = ACTIONS(3623),
    [anon_sym___subscript] = ACTIONS(3623),
    [anon_sym_property] = ACTIONS(3623),
    [anon_sym_associatedtype] = ACTIONS(3623),
  },
  [1733] = {
    [sym_identifier] = ACTIONS(3661),
    [aux_sym_preproc_def_token1] = ACTIONS(3661),
    [aux_sym_preproc_if_token1] = ACTIONS(3661),
    [aux_sym_preproc_if_token2] = ACTIONS(3661),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3661),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3661),
    [aux_sym_preproc_else_token1] = ACTIONS(3661),
    [aux_sym_preproc_elif_token1] = ACTIONS(3661),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3661),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3661),
    [sym_preproc_directive] = ACTIONS(3661),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_TILDE] = ACTIONS(3663),
    [anon_sym_STAR] = ACTIONS(3663),
    [anon_sym_AMP_AMP] = ACTIONS(3663),
    [anon_sym_AMP] = ACTIONS(3661),
    [anon_sym_SEMI] = ACTIONS(3663),
    [anon_sym___extension__] = ACTIONS(3661),
    [anon_sym_typedef] = ACTIONS(3661),
    [anon_sym_in] = ACTIONS(3661),
    [anon_sym_out] = ACTIONS(3661),
    [anon_sym_inout] = ACTIONS(3661),
    [anon_sym_virtual] = ACTIONS(3661),
    [anon_sym_extern] = ACTIONS(3661),
    [anon_sym___attribute__] = ACTIONS(3661),
    [anon_sym___attribute] = ACTIONS(3661),
    [anon_sym_using] = ACTIONS(3661),
    [anon_sym_COLON_COLON] = ACTIONS(3663),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3663),
    [anon_sym___declspec] = ACTIONS(3661),
    [anon_sym___based] = ACTIONS(3661),
    [anon_sym_signed] = ACTIONS(3661),
    [anon_sym_unsigned] = ACTIONS(3661),
    [anon_sym_long] = ACTIONS(3661),
    [anon_sym_short] = ACTIONS(3661),
    [anon_sym_LBRACK] = ACTIONS(3661),
    [anon_sym_static] = ACTIONS(3661),
    [anon_sym_register] = ACTIONS(3661),
    [anon_sym_inline] = ACTIONS(3661),
    [anon_sym___inline] = ACTIONS(3661),
    [anon_sym___inline__] = ACTIONS(3661),
    [anon_sym___forceinline] = ACTIONS(3661),
    [anon_sym_thread_local] = ACTIONS(3661),
    [anon_sym___thread] = ACTIONS(3661),
    [anon_sym_const] = ACTIONS(3661),
    [anon_sym_constexpr] = ACTIONS(3661),
    [anon_sym_volatile] = ACTIONS(3661),
    [anon_sym_restrict] = ACTIONS(3661),
    [anon_sym___restrict__] = ACTIONS(3661),
    [anon_sym__Atomic] = ACTIONS(3661),
    [anon_sym__Noreturn] = ACTIONS(3661),
    [anon_sym_noreturn] = ACTIONS(3661),
    [anon_sym__Nonnull] = ACTIONS(3661),
    [anon_sym_mutable] = ACTIONS(3661),
    [anon_sym_constinit] = ACTIONS(3661),
    [anon_sym_consteval] = ACTIONS(3661),
    [anon_sym_alignas] = ACTIONS(3661),
    [anon_sym__Alignas] = ACTIONS(3661),
    [sym_primitive_type] = ACTIONS(3661),
    [anon_sym_enum] = ACTIONS(3661),
    [anon_sym_class] = ACTIONS(3661),
    [anon_sym_struct] = ACTIONS(3661),
    [anon_sym_union] = ACTIONS(3661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3661),
    [anon_sym_let] = ACTIONS(3661),
    [anon_sym_This] = ACTIONS(3661),
    [anon_sym_decltype] = ACTIONS(3661),
    [anon_sym_explicit] = ACTIONS(3661),
    [anon_sym_typename] = ACTIONS(3661),
    [anon_sym_private] = ACTIONS(3661),
    [anon_sym_template] = ACTIONS(3661),
    [anon_sym_operator] = ACTIONS(3661),
    [anon_sym_friend] = ACTIONS(3661),
    [anon_sym_public] = ACTIONS(3661),
    [anon_sym_protected] = ACTIONS(3661),
    [anon_sym_static_assert] = ACTIONS(3661),
    [anon_sym_precise] = ACTIONS(3661),
    [anon_sym_shared] = ACTIONS(3661),
    [anon_sym_groupshared] = ACTIONS(3661),
    [anon_sym_uniform] = ACTIONS(3661),
    [anon_sym_row_major] = ACTIONS(3661),
    [anon_sym_column_major] = ACTIONS(3661),
    [anon_sym_globallycoherent] = ACTIONS(3661),
    [anon_sym_centroid] = ACTIONS(3661),
    [anon_sym_noperspective] = ACTIONS(3661),
    [anon_sym_nointerpolation] = ACTIONS(3661),
    [anon_sym_sample] = ACTIONS(3661),
    [anon_sym_linear] = ACTIONS(3661),
    [anon_sym_snorm] = ACTIONS(3661),
    [anon_sym_unorm] = ACTIONS(3661),
    [anon_sym_point] = ACTIONS(3661),
    [anon_sym_line] = ACTIONS(3661),
    [anon_sym_triangleadj] = ACTIONS(3661),
    [anon_sym_lineadj] = ACTIONS(3661),
    [anon_sym_triangle] = ACTIONS(3661),
    [anon_sym_interface] = ACTIONS(3661),
    [anon_sym_extension] = ACTIONS(3661),
    [anon_sym___init] = ACTIONS(3661),
    [anon_sym___subscript] = ACTIONS(3661),
    [anon_sym_property] = ACTIONS(3661),
    [anon_sym_associatedtype] = ACTIONS(3661),
  },
  [1734] = {
    [sym_identifier] = ACTIONS(3623),
    [aux_sym_preproc_def_token1] = ACTIONS(3623),
    [aux_sym_preproc_if_token1] = ACTIONS(3623),
    [aux_sym_preproc_if_token2] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3623),
    [aux_sym_preproc_else_token1] = ACTIONS(3623),
    [aux_sym_preproc_elif_token1] = ACTIONS(3623),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3623),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3623),
    [sym_preproc_directive] = ACTIONS(3623),
    [anon_sym_LPAREN2] = ACTIONS(3621),
    [anon_sym_TILDE] = ACTIONS(3621),
    [anon_sym_STAR] = ACTIONS(3621),
    [anon_sym_AMP_AMP] = ACTIONS(3621),
    [anon_sym_AMP] = ACTIONS(3623),
    [anon_sym_SEMI] = ACTIONS(3621),
    [anon_sym___extension__] = ACTIONS(3623),
    [anon_sym_typedef] = ACTIONS(3623),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_out] = ACTIONS(3623),
    [anon_sym_inout] = ACTIONS(3623),
    [anon_sym_virtual] = ACTIONS(3623),
    [anon_sym_extern] = ACTIONS(3623),
    [anon_sym___attribute__] = ACTIONS(3623),
    [anon_sym___attribute] = ACTIONS(3623),
    [anon_sym_using] = ACTIONS(3623),
    [anon_sym_COLON_COLON] = ACTIONS(3621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3621),
    [anon_sym___declspec] = ACTIONS(3623),
    [anon_sym___based] = ACTIONS(3623),
    [anon_sym_signed] = ACTIONS(3623),
    [anon_sym_unsigned] = ACTIONS(3623),
    [anon_sym_long] = ACTIONS(3623),
    [anon_sym_short] = ACTIONS(3623),
    [anon_sym_LBRACK] = ACTIONS(3623),
    [anon_sym_static] = ACTIONS(3623),
    [anon_sym_register] = ACTIONS(3623),
    [anon_sym_inline] = ACTIONS(3623),
    [anon_sym___inline] = ACTIONS(3623),
    [anon_sym___inline__] = ACTIONS(3623),
    [anon_sym___forceinline] = ACTIONS(3623),
    [anon_sym_thread_local] = ACTIONS(3623),
    [anon_sym___thread] = ACTIONS(3623),
    [anon_sym_const] = ACTIONS(3623),
    [anon_sym_constexpr] = ACTIONS(3623),
    [anon_sym_volatile] = ACTIONS(3623),
    [anon_sym_restrict] = ACTIONS(3623),
    [anon_sym___restrict__] = ACTIONS(3623),
    [anon_sym__Atomic] = ACTIONS(3623),
    [anon_sym__Noreturn] = ACTIONS(3623),
    [anon_sym_noreturn] = ACTIONS(3623),
    [anon_sym__Nonnull] = ACTIONS(3623),
    [anon_sym_mutable] = ACTIONS(3623),
    [anon_sym_constinit] = ACTIONS(3623),
    [anon_sym_consteval] = ACTIONS(3623),
    [anon_sym_alignas] = ACTIONS(3623),
    [anon_sym__Alignas] = ACTIONS(3623),
    [sym_primitive_type] = ACTIONS(3623),
    [anon_sym_enum] = ACTIONS(3623),
    [anon_sym_class] = ACTIONS(3623),
    [anon_sym_struct] = ACTIONS(3623),
    [anon_sym_union] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3623),
    [anon_sym_let] = ACTIONS(3623),
    [anon_sym_This] = ACTIONS(3623),
    [anon_sym_decltype] = ACTIONS(3623),
    [anon_sym_explicit] = ACTIONS(3623),
    [anon_sym_typename] = ACTIONS(3623),
    [anon_sym_private] = ACTIONS(3623),
    [anon_sym_template] = ACTIONS(3623),
    [anon_sym_operator] = ACTIONS(3623),
    [anon_sym_friend] = ACTIONS(3623),
    [anon_sym_public] = ACTIONS(3623),
    [anon_sym_protected] = ACTIONS(3623),
    [anon_sym_static_assert] = ACTIONS(3623),
    [anon_sym_precise] = ACTIONS(3623),
    [anon_sym_shared] = ACTIONS(3623),
    [anon_sym_groupshared] = ACTIONS(3623),
    [anon_sym_uniform] = ACTIONS(3623),
    [anon_sym_row_major] = ACTIONS(3623),
    [anon_sym_column_major] = ACTIONS(3623),
    [anon_sym_globallycoherent] = ACTIONS(3623),
    [anon_sym_centroid] = ACTIONS(3623),
    [anon_sym_noperspective] = ACTIONS(3623),
    [anon_sym_nointerpolation] = ACTIONS(3623),
    [anon_sym_sample] = ACTIONS(3623),
    [anon_sym_linear] = ACTIONS(3623),
    [anon_sym_snorm] = ACTIONS(3623),
    [anon_sym_unorm] = ACTIONS(3623),
    [anon_sym_point] = ACTIONS(3623),
    [anon_sym_line] = ACTIONS(3623),
    [anon_sym_triangleadj] = ACTIONS(3623),
    [anon_sym_lineadj] = ACTIONS(3623),
    [anon_sym_triangle] = ACTIONS(3623),
    [anon_sym_interface] = ACTIONS(3623),
    [anon_sym_extension] = ACTIONS(3623),
    [anon_sym___init] = ACTIONS(3623),
    [anon_sym___subscript] = ACTIONS(3623),
    [anon_sym_property] = ACTIONS(3623),
    [anon_sym_associatedtype] = ACTIONS(3623),
  },
  [1735] = {
    [sym_identifier] = ACTIONS(3784),
    [aux_sym_preproc_def_token1] = ACTIONS(3784),
    [aux_sym_preproc_if_token1] = ACTIONS(3784),
    [aux_sym_preproc_if_token2] = ACTIONS(3784),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3784),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3784),
    [aux_sym_preproc_else_token1] = ACTIONS(3784),
    [aux_sym_preproc_elif_token1] = ACTIONS(3784),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3784),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3784),
    [sym_preproc_directive] = ACTIONS(3784),
    [anon_sym_LPAREN2] = ACTIONS(3786),
    [anon_sym_TILDE] = ACTIONS(3786),
    [anon_sym_STAR] = ACTIONS(3786),
    [anon_sym_AMP_AMP] = ACTIONS(3786),
    [anon_sym_AMP] = ACTIONS(3784),
    [anon_sym_SEMI] = ACTIONS(3786),
    [anon_sym___extension__] = ACTIONS(3784),
    [anon_sym_typedef] = ACTIONS(3784),
    [anon_sym_in] = ACTIONS(3784),
    [anon_sym_out] = ACTIONS(3784),
    [anon_sym_inout] = ACTIONS(3784),
    [anon_sym_virtual] = ACTIONS(3784),
    [anon_sym_extern] = ACTIONS(3784),
    [anon_sym___attribute__] = ACTIONS(3784),
    [anon_sym___attribute] = ACTIONS(3784),
    [anon_sym_using] = ACTIONS(3784),
    [anon_sym_COLON_COLON] = ACTIONS(3786),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3786),
    [anon_sym___declspec] = ACTIONS(3784),
    [anon_sym___based] = ACTIONS(3784),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3784),
    [anon_sym_static] = ACTIONS(3784),
    [anon_sym_register] = ACTIONS(3784),
    [anon_sym_inline] = ACTIONS(3784),
    [anon_sym___inline] = ACTIONS(3784),
    [anon_sym___inline__] = ACTIONS(3784),
    [anon_sym___forceinline] = ACTIONS(3784),
    [anon_sym_thread_local] = ACTIONS(3784),
    [anon_sym___thread] = ACTIONS(3784),
    [anon_sym_const] = ACTIONS(3784),
    [anon_sym_constexpr] = ACTIONS(3784),
    [anon_sym_volatile] = ACTIONS(3784),
    [anon_sym_restrict] = ACTIONS(3784),
    [anon_sym___restrict__] = ACTIONS(3784),
    [anon_sym__Atomic] = ACTIONS(3784),
    [anon_sym__Noreturn] = ACTIONS(3784),
    [anon_sym_noreturn] = ACTIONS(3784),
    [anon_sym__Nonnull] = ACTIONS(3784),
    [anon_sym_mutable] = ACTIONS(3784),
    [anon_sym_constinit] = ACTIONS(3784),
    [anon_sym_consteval] = ACTIONS(3784),
    [anon_sym_alignas] = ACTIONS(3784),
    [anon_sym__Alignas] = ACTIONS(3784),
    [sym_primitive_type] = ACTIONS(3784),
    [anon_sym_enum] = ACTIONS(3784),
    [anon_sym_class] = ACTIONS(3784),
    [anon_sym_struct] = ACTIONS(3784),
    [anon_sym_union] = ACTIONS(3784),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3784),
    [anon_sym_let] = ACTIONS(3784),
    [anon_sym_This] = ACTIONS(3784),
    [anon_sym_decltype] = ACTIONS(3784),
    [anon_sym_explicit] = ACTIONS(3784),
    [anon_sym_typename] = ACTIONS(3784),
    [anon_sym_private] = ACTIONS(3784),
    [anon_sym_template] = ACTIONS(3784),
    [anon_sym_operator] = ACTIONS(3784),
    [anon_sym_friend] = ACTIONS(3784),
    [anon_sym_public] = ACTIONS(3784),
    [anon_sym_protected] = ACTIONS(3784),
    [anon_sym_static_assert] = ACTIONS(3784),
    [anon_sym_precise] = ACTIONS(3784),
    [anon_sym_shared] = ACTIONS(3784),
    [anon_sym_groupshared] = ACTIONS(3784),
    [anon_sym_uniform] = ACTIONS(3784),
    [anon_sym_row_major] = ACTIONS(3784),
    [anon_sym_column_major] = ACTIONS(3784),
    [anon_sym_globallycoherent] = ACTIONS(3784),
    [anon_sym_centroid] = ACTIONS(3784),
    [anon_sym_noperspective] = ACTIONS(3784),
    [anon_sym_nointerpolation] = ACTIONS(3784),
    [anon_sym_sample] = ACTIONS(3784),
    [anon_sym_linear] = ACTIONS(3784),
    [anon_sym_snorm] = ACTIONS(3784),
    [anon_sym_unorm] = ACTIONS(3784),
    [anon_sym_point] = ACTIONS(3784),
    [anon_sym_line] = ACTIONS(3784),
    [anon_sym_triangleadj] = ACTIONS(3784),
    [anon_sym_lineadj] = ACTIONS(3784),
    [anon_sym_triangle] = ACTIONS(3784),
    [anon_sym_interface] = ACTIONS(3784),
    [anon_sym_extension] = ACTIONS(3784),
    [anon_sym___init] = ACTIONS(3784),
    [anon_sym___subscript] = ACTIONS(3784),
    [anon_sym_property] = ACTIONS(3784),
    [anon_sym_associatedtype] = ACTIONS(3784),
  },
  [1736] = {
    [sym_identifier] = ACTIONS(3828),
    [aux_sym_preproc_def_token1] = ACTIONS(3828),
    [aux_sym_preproc_if_token1] = ACTIONS(3828),
    [aux_sym_preproc_if_token2] = ACTIONS(3828),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3828),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3828),
    [aux_sym_preproc_else_token1] = ACTIONS(3828),
    [aux_sym_preproc_elif_token1] = ACTIONS(3828),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3828),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3828),
    [sym_preproc_directive] = ACTIONS(3828),
    [anon_sym_LPAREN2] = ACTIONS(3830),
    [anon_sym_TILDE] = ACTIONS(3830),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_SEMI] = ACTIONS(3830),
    [anon_sym___extension__] = ACTIONS(3828),
    [anon_sym_typedef] = ACTIONS(3828),
    [anon_sym_in] = ACTIONS(3828),
    [anon_sym_out] = ACTIONS(3828),
    [anon_sym_inout] = ACTIONS(3828),
    [anon_sym_virtual] = ACTIONS(3828),
    [anon_sym_extern] = ACTIONS(3828),
    [anon_sym___attribute__] = ACTIONS(3828),
    [anon_sym___attribute] = ACTIONS(3828),
    [anon_sym_using] = ACTIONS(3828),
    [anon_sym_COLON_COLON] = ACTIONS(3830),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3830),
    [anon_sym___declspec] = ACTIONS(3828),
    [anon_sym___based] = ACTIONS(3828),
    [anon_sym_signed] = ACTIONS(3828),
    [anon_sym_unsigned] = ACTIONS(3828),
    [anon_sym_long] = ACTIONS(3828),
    [anon_sym_short] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_static] = ACTIONS(3828),
    [anon_sym_register] = ACTIONS(3828),
    [anon_sym_inline] = ACTIONS(3828),
    [anon_sym___inline] = ACTIONS(3828),
    [anon_sym___inline__] = ACTIONS(3828),
    [anon_sym___forceinline] = ACTIONS(3828),
    [anon_sym_thread_local] = ACTIONS(3828),
    [anon_sym___thread] = ACTIONS(3828),
    [anon_sym_const] = ACTIONS(3828),
    [anon_sym_constexpr] = ACTIONS(3828),
    [anon_sym_volatile] = ACTIONS(3828),
    [anon_sym_restrict] = ACTIONS(3828),
    [anon_sym___restrict__] = ACTIONS(3828),
    [anon_sym__Atomic] = ACTIONS(3828),
    [anon_sym__Noreturn] = ACTIONS(3828),
    [anon_sym_noreturn] = ACTIONS(3828),
    [anon_sym__Nonnull] = ACTIONS(3828),
    [anon_sym_mutable] = ACTIONS(3828),
    [anon_sym_constinit] = ACTIONS(3828),
    [anon_sym_consteval] = ACTIONS(3828),
    [anon_sym_alignas] = ACTIONS(3828),
    [anon_sym__Alignas] = ACTIONS(3828),
    [sym_primitive_type] = ACTIONS(3828),
    [anon_sym_enum] = ACTIONS(3828),
    [anon_sym_class] = ACTIONS(3828),
    [anon_sym_struct] = ACTIONS(3828),
    [anon_sym_union] = ACTIONS(3828),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_This] = ACTIONS(3828),
    [anon_sym_decltype] = ACTIONS(3828),
    [anon_sym_explicit] = ACTIONS(3828),
    [anon_sym_typename] = ACTIONS(3828),
    [anon_sym_private] = ACTIONS(3828),
    [anon_sym_template] = ACTIONS(3828),
    [anon_sym_operator] = ACTIONS(3828),
    [anon_sym_friend] = ACTIONS(3828),
    [anon_sym_public] = ACTIONS(3828),
    [anon_sym_protected] = ACTIONS(3828),
    [anon_sym_static_assert] = ACTIONS(3828),
    [anon_sym_precise] = ACTIONS(3828),
    [anon_sym_shared] = ACTIONS(3828),
    [anon_sym_groupshared] = ACTIONS(3828),
    [anon_sym_uniform] = ACTIONS(3828),
    [anon_sym_row_major] = ACTIONS(3828),
    [anon_sym_column_major] = ACTIONS(3828),
    [anon_sym_globallycoherent] = ACTIONS(3828),
    [anon_sym_centroid] = ACTIONS(3828),
    [anon_sym_noperspective] = ACTIONS(3828),
    [anon_sym_nointerpolation] = ACTIONS(3828),
    [anon_sym_sample] = ACTIONS(3828),
    [anon_sym_linear] = ACTIONS(3828),
    [anon_sym_snorm] = ACTIONS(3828),
    [anon_sym_unorm] = ACTIONS(3828),
    [anon_sym_point] = ACTIONS(3828),
    [anon_sym_line] = ACTIONS(3828),
    [anon_sym_triangleadj] = ACTIONS(3828),
    [anon_sym_lineadj] = ACTIONS(3828),
    [anon_sym_triangle] = ACTIONS(3828),
    [anon_sym_interface] = ACTIONS(3828),
    [anon_sym_extension] = ACTIONS(3828),
    [anon_sym___init] = ACTIONS(3828),
    [anon_sym___subscript] = ACTIONS(3828),
    [anon_sym_property] = ACTIONS(3828),
    [anon_sym_associatedtype] = ACTIONS(3828),
  },
  [1737] = {
    [sym_identifier] = ACTIONS(3379),
    [aux_sym_preproc_def_token1] = ACTIONS(3379),
    [aux_sym_preproc_if_token1] = ACTIONS(3379),
    [aux_sym_preproc_if_token2] = ACTIONS(3379),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3379),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3379),
    [aux_sym_preproc_else_token1] = ACTIONS(3379),
    [aux_sym_preproc_elif_token1] = ACTIONS(3379),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3379),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3379),
    [sym_preproc_directive] = ACTIONS(3379),
    [anon_sym_LPAREN2] = ACTIONS(3381),
    [anon_sym_TILDE] = ACTIONS(3381),
    [anon_sym_STAR] = ACTIONS(3381),
    [anon_sym_AMP_AMP] = ACTIONS(3381),
    [anon_sym_AMP] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3381),
    [anon_sym___extension__] = ACTIONS(3379),
    [anon_sym_typedef] = ACTIONS(3379),
    [anon_sym_in] = ACTIONS(3379),
    [anon_sym_out] = ACTIONS(3379),
    [anon_sym_inout] = ACTIONS(3379),
    [anon_sym_virtual] = ACTIONS(3379),
    [anon_sym_extern] = ACTIONS(3379),
    [anon_sym___attribute__] = ACTIONS(3379),
    [anon_sym___attribute] = ACTIONS(3379),
    [anon_sym_using] = ACTIONS(3379),
    [anon_sym_COLON_COLON] = ACTIONS(3381),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3381),
    [anon_sym___declspec] = ACTIONS(3379),
    [anon_sym___based] = ACTIONS(3379),
    [anon_sym_signed] = ACTIONS(3379),
    [anon_sym_unsigned] = ACTIONS(3379),
    [anon_sym_long] = ACTIONS(3379),
    [anon_sym_short] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_register] = ACTIONS(3379),
    [anon_sym_inline] = ACTIONS(3379),
    [anon_sym___inline] = ACTIONS(3379),
    [anon_sym___inline__] = ACTIONS(3379),
    [anon_sym___forceinline] = ACTIONS(3379),
    [anon_sym_thread_local] = ACTIONS(3379),
    [anon_sym___thread] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_constexpr] = ACTIONS(3379),
    [anon_sym_volatile] = ACTIONS(3379),
    [anon_sym_restrict] = ACTIONS(3379),
    [anon_sym___restrict__] = ACTIONS(3379),
    [anon_sym__Atomic] = ACTIONS(3379),
    [anon_sym__Noreturn] = ACTIONS(3379),
    [anon_sym_noreturn] = ACTIONS(3379),
    [anon_sym__Nonnull] = ACTIONS(3379),
    [anon_sym_mutable] = ACTIONS(3379),
    [anon_sym_constinit] = ACTIONS(3379),
    [anon_sym_consteval] = ACTIONS(3379),
    [anon_sym_alignas] = ACTIONS(3379),
    [anon_sym__Alignas] = ACTIONS(3379),
    [sym_primitive_type] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_struct] = ACTIONS(3379),
    [anon_sym_union] = ACTIONS(3379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3379),
    [anon_sym_let] = ACTIONS(3379),
    [anon_sym_This] = ACTIONS(3379),
    [anon_sym_decltype] = ACTIONS(3379),
    [anon_sym_explicit] = ACTIONS(3379),
    [anon_sym_typename] = ACTIONS(3379),
    [anon_sym_private] = ACTIONS(3379),
    [anon_sym_template] = ACTIONS(3379),
    [anon_sym_operator] = ACTIONS(3379),
    [anon_sym_friend] = ACTIONS(3379),
    [anon_sym_public] = ACTIONS(3379),
    [anon_sym_protected] = ACTIONS(3379),
    [anon_sym_static_assert] = ACTIONS(3379),
    [anon_sym_precise] = ACTIONS(3379),
    [anon_sym_shared] = ACTIONS(3379),
    [anon_sym_groupshared] = ACTIONS(3379),
    [anon_sym_uniform] = ACTIONS(3379),
    [anon_sym_row_major] = ACTIONS(3379),
    [anon_sym_column_major] = ACTIONS(3379),
    [anon_sym_globallycoherent] = ACTIONS(3379),
    [anon_sym_centroid] = ACTIONS(3379),
    [anon_sym_noperspective] = ACTIONS(3379),
    [anon_sym_nointerpolation] = ACTIONS(3379),
    [anon_sym_sample] = ACTIONS(3379),
    [anon_sym_linear] = ACTIONS(3379),
    [anon_sym_snorm] = ACTIONS(3379),
    [anon_sym_unorm] = ACTIONS(3379),
    [anon_sym_point] = ACTIONS(3379),
    [anon_sym_line] = ACTIONS(3379),
    [anon_sym_triangleadj] = ACTIONS(3379),
    [anon_sym_lineadj] = ACTIONS(3379),
    [anon_sym_triangle] = ACTIONS(3379),
    [anon_sym_interface] = ACTIONS(3379),
    [anon_sym_extension] = ACTIONS(3379),
    [anon_sym___init] = ACTIONS(3379),
    [anon_sym___subscript] = ACTIONS(3379),
    [anon_sym_property] = ACTIONS(3379),
    [anon_sym_associatedtype] = ACTIONS(3379),
  },
  [1738] = {
    [sym_identifier] = ACTIONS(3919),
    [aux_sym_preproc_def_token1] = ACTIONS(3919),
    [aux_sym_preproc_if_token1] = ACTIONS(3919),
    [aux_sym_preproc_if_token2] = ACTIONS(3919),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3919),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3919),
    [aux_sym_preproc_else_token1] = ACTIONS(3919),
    [aux_sym_preproc_elif_token1] = ACTIONS(3919),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3919),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3919),
    [sym_preproc_directive] = ACTIONS(3919),
    [anon_sym_LPAREN2] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_STAR] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_AMP] = ACTIONS(3919),
    [anon_sym_SEMI] = ACTIONS(3921),
    [anon_sym___extension__] = ACTIONS(3919),
    [anon_sym_typedef] = ACTIONS(3919),
    [anon_sym_in] = ACTIONS(3919),
    [anon_sym_out] = ACTIONS(3919),
    [anon_sym_inout] = ACTIONS(3919),
    [anon_sym_virtual] = ACTIONS(3919),
    [anon_sym_extern] = ACTIONS(3919),
    [anon_sym___attribute__] = ACTIONS(3919),
    [anon_sym___attribute] = ACTIONS(3919),
    [anon_sym_using] = ACTIONS(3919),
    [anon_sym_COLON_COLON] = ACTIONS(3921),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3921),
    [anon_sym___declspec] = ACTIONS(3919),
    [anon_sym___based] = ACTIONS(3919),
    [anon_sym_signed] = ACTIONS(3919),
    [anon_sym_unsigned] = ACTIONS(3919),
    [anon_sym_long] = ACTIONS(3919),
    [anon_sym_short] = ACTIONS(3919),
    [anon_sym_LBRACK] = ACTIONS(3919),
    [anon_sym_static] = ACTIONS(3919),
    [anon_sym_register] = ACTIONS(3919),
    [anon_sym_inline] = ACTIONS(3919),
    [anon_sym___inline] = ACTIONS(3919),
    [anon_sym___inline__] = ACTIONS(3919),
    [anon_sym___forceinline] = ACTIONS(3919),
    [anon_sym_thread_local] = ACTIONS(3919),
    [anon_sym___thread] = ACTIONS(3919),
    [anon_sym_const] = ACTIONS(3919),
    [anon_sym_constexpr] = ACTIONS(3919),
    [anon_sym_volatile] = ACTIONS(3919),
    [anon_sym_restrict] = ACTIONS(3919),
    [anon_sym___restrict__] = ACTIONS(3919),
    [anon_sym__Atomic] = ACTIONS(3919),
    [anon_sym__Noreturn] = ACTIONS(3919),
    [anon_sym_noreturn] = ACTIONS(3919),
    [anon_sym__Nonnull] = ACTIONS(3919),
    [anon_sym_mutable] = ACTIONS(3919),
    [anon_sym_constinit] = ACTIONS(3919),
    [anon_sym_consteval] = ACTIONS(3919),
    [anon_sym_alignas] = ACTIONS(3919),
    [anon_sym__Alignas] = ACTIONS(3919),
    [sym_primitive_type] = ACTIONS(3919),
    [anon_sym_enum] = ACTIONS(3919),
    [anon_sym_class] = ACTIONS(3919),
    [anon_sym_struct] = ACTIONS(3919),
    [anon_sym_union] = ACTIONS(3919),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3919),
    [anon_sym_let] = ACTIONS(3919),
    [anon_sym_This] = ACTIONS(3919),
    [anon_sym_decltype] = ACTIONS(3919),
    [anon_sym_explicit] = ACTIONS(3919),
    [anon_sym_typename] = ACTIONS(3919),
    [anon_sym_private] = ACTIONS(3919),
    [anon_sym_template] = ACTIONS(3919),
    [anon_sym_operator] = ACTIONS(3919),
    [anon_sym_friend] = ACTIONS(3919),
    [anon_sym_public] = ACTIONS(3919),
    [anon_sym_protected] = ACTIONS(3919),
    [anon_sym_static_assert] = ACTIONS(3919),
    [anon_sym_precise] = ACTIONS(3919),
    [anon_sym_shared] = ACTIONS(3919),
    [anon_sym_groupshared] = ACTIONS(3919),
    [anon_sym_uniform] = ACTIONS(3919),
    [anon_sym_row_major] = ACTIONS(3919),
    [anon_sym_column_major] = ACTIONS(3919),
    [anon_sym_globallycoherent] = ACTIONS(3919),
    [anon_sym_centroid] = ACTIONS(3919),
    [anon_sym_noperspective] = ACTIONS(3919),
    [anon_sym_nointerpolation] = ACTIONS(3919),
    [anon_sym_sample] = ACTIONS(3919),
    [anon_sym_linear] = ACTIONS(3919),
    [anon_sym_snorm] = ACTIONS(3919),
    [anon_sym_unorm] = ACTIONS(3919),
    [anon_sym_point] = ACTIONS(3919),
    [anon_sym_line] = ACTIONS(3919),
    [anon_sym_triangleadj] = ACTIONS(3919),
    [anon_sym_lineadj] = ACTIONS(3919),
    [anon_sym_triangle] = ACTIONS(3919),
    [anon_sym_interface] = ACTIONS(3919),
    [anon_sym_extension] = ACTIONS(3919),
    [anon_sym___init] = ACTIONS(3919),
    [anon_sym___subscript] = ACTIONS(3919),
    [anon_sym_property] = ACTIONS(3919),
    [anon_sym_associatedtype] = ACTIONS(3919),
  },
  [1739] = {
    [sym_identifier] = ACTIONS(3763),
    [aux_sym_preproc_def_token1] = ACTIONS(3763),
    [aux_sym_preproc_if_token1] = ACTIONS(3763),
    [aux_sym_preproc_if_token2] = ACTIONS(3763),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3763),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3763),
    [aux_sym_preproc_else_token1] = ACTIONS(3763),
    [aux_sym_preproc_elif_token1] = ACTIONS(3763),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3763),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3763),
    [sym_preproc_directive] = ACTIONS(3763),
    [anon_sym_LPAREN2] = ACTIONS(3765),
    [anon_sym_TILDE] = ACTIONS(3765),
    [anon_sym_STAR] = ACTIONS(3765),
    [anon_sym_AMP_AMP] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3763),
    [anon_sym_SEMI] = ACTIONS(3765),
    [anon_sym___extension__] = ACTIONS(3763),
    [anon_sym_typedef] = ACTIONS(3763),
    [anon_sym_in] = ACTIONS(3763),
    [anon_sym_out] = ACTIONS(3763),
    [anon_sym_inout] = ACTIONS(3763),
    [anon_sym_virtual] = ACTIONS(3763),
    [anon_sym_extern] = ACTIONS(3763),
    [anon_sym___attribute__] = ACTIONS(3763),
    [anon_sym___attribute] = ACTIONS(3763),
    [anon_sym_using] = ACTIONS(3763),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3765),
    [anon_sym___declspec] = ACTIONS(3763),
    [anon_sym___based] = ACTIONS(3763),
    [anon_sym_signed] = ACTIONS(3763),
    [anon_sym_unsigned] = ACTIONS(3763),
    [anon_sym_long] = ACTIONS(3763),
    [anon_sym_short] = ACTIONS(3763),
    [anon_sym_LBRACK] = ACTIONS(3763),
    [anon_sym_static] = ACTIONS(3763),
    [anon_sym_register] = ACTIONS(3763),
    [anon_sym_inline] = ACTIONS(3763),
    [anon_sym___inline] = ACTIONS(3763),
    [anon_sym___inline__] = ACTIONS(3763),
    [anon_sym___forceinline] = ACTIONS(3763),
    [anon_sym_thread_local] = ACTIONS(3763),
    [anon_sym___thread] = ACTIONS(3763),
    [anon_sym_const] = ACTIONS(3763),
    [anon_sym_constexpr] = ACTIONS(3763),
    [anon_sym_volatile] = ACTIONS(3763),
    [anon_sym_restrict] = ACTIONS(3763),
    [anon_sym___restrict__] = ACTIONS(3763),
    [anon_sym__Atomic] = ACTIONS(3763),
    [anon_sym__Noreturn] = ACTIONS(3763),
    [anon_sym_noreturn] = ACTIONS(3763),
    [anon_sym__Nonnull] = ACTIONS(3763),
    [anon_sym_mutable] = ACTIONS(3763),
    [anon_sym_constinit] = ACTIONS(3763),
    [anon_sym_consteval] = ACTIONS(3763),
    [anon_sym_alignas] = ACTIONS(3763),
    [anon_sym__Alignas] = ACTIONS(3763),
    [sym_primitive_type] = ACTIONS(3763),
    [anon_sym_enum] = ACTIONS(3763),
    [anon_sym_class] = ACTIONS(3763),
    [anon_sym_struct] = ACTIONS(3763),
    [anon_sym_union] = ACTIONS(3763),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3763),
    [anon_sym_let] = ACTIONS(3763),
    [anon_sym_This] = ACTIONS(3763),
    [anon_sym_decltype] = ACTIONS(3763),
    [anon_sym_explicit] = ACTIONS(3763),
    [anon_sym_typename] = ACTIONS(3763),
    [anon_sym_private] = ACTIONS(3763),
    [anon_sym_template] = ACTIONS(3763),
    [anon_sym_operator] = ACTIONS(3763),
    [anon_sym_friend] = ACTIONS(3763),
    [anon_sym_public] = ACTIONS(3763),
    [anon_sym_protected] = ACTIONS(3763),
    [anon_sym_static_assert] = ACTIONS(3763),
    [anon_sym_precise] = ACTIONS(3763),
    [anon_sym_shared] = ACTIONS(3763),
    [anon_sym_groupshared] = ACTIONS(3763),
    [anon_sym_uniform] = ACTIONS(3763),
    [anon_sym_row_major] = ACTIONS(3763),
    [anon_sym_column_major] = ACTIONS(3763),
    [anon_sym_globallycoherent] = ACTIONS(3763),
    [anon_sym_centroid] = ACTIONS(3763),
    [anon_sym_noperspective] = ACTIONS(3763),
    [anon_sym_nointerpolation] = ACTIONS(3763),
    [anon_sym_sample] = ACTIONS(3763),
    [anon_sym_linear] = ACTIONS(3763),
    [anon_sym_snorm] = ACTIONS(3763),
    [anon_sym_unorm] = ACTIONS(3763),
    [anon_sym_point] = ACTIONS(3763),
    [anon_sym_line] = ACTIONS(3763),
    [anon_sym_triangleadj] = ACTIONS(3763),
    [anon_sym_lineadj] = ACTIONS(3763),
    [anon_sym_triangle] = ACTIONS(3763),
    [anon_sym_interface] = ACTIONS(3763),
    [anon_sym_extension] = ACTIONS(3763),
    [anon_sym___init] = ACTIONS(3763),
    [anon_sym___subscript] = ACTIONS(3763),
    [anon_sym_property] = ACTIONS(3763),
    [anon_sym_associatedtype] = ACTIONS(3763),
  },
  [1740] = {
    [sym_identifier] = ACTIONS(3669),
    [aux_sym_preproc_def_token1] = ACTIONS(3669),
    [aux_sym_preproc_if_token1] = ACTIONS(3669),
    [aux_sym_preproc_if_token2] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3669),
    [aux_sym_preproc_else_token1] = ACTIONS(3669),
    [aux_sym_preproc_elif_token1] = ACTIONS(3669),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3669),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3669),
    [sym_preproc_directive] = ACTIONS(3669),
    [anon_sym_LPAREN2] = ACTIONS(3671),
    [anon_sym_TILDE] = ACTIONS(3671),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3671),
    [anon_sym_AMP] = ACTIONS(3669),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym___extension__] = ACTIONS(3669),
    [anon_sym_typedef] = ACTIONS(3669),
    [anon_sym_in] = ACTIONS(3669),
    [anon_sym_out] = ACTIONS(3669),
    [anon_sym_inout] = ACTIONS(3669),
    [anon_sym_virtual] = ACTIONS(3669),
    [anon_sym_extern] = ACTIONS(3669),
    [anon_sym___attribute__] = ACTIONS(3669),
    [anon_sym___attribute] = ACTIONS(3669),
    [anon_sym_using] = ACTIONS(3669),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3671),
    [anon_sym___declspec] = ACTIONS(3669),
    [anon_sym___based] = ACTIONS(3669),
    [anon_sym_signed] = ACTIONS(3669),
    [anon_sym_unsigned] = ACTIONS(3669),
    [anon_sym_long] = ACTIONS(3669),
    [anon_sym_short] = ACTIONS(3669),
    [anon_sym_LBRACK] = ACTIONS(3669),
    [anon_sym_static] = ACTIONS(3669),
    [anon_sym_register] = ACTIONS(3669),
    [anon_sym_inline] = ACTIONS(3669),
    [anon_sym___inline] = ACTIONS(3669),
    [anon_sym___inline__] = ACTIONS(3669),
    [anon_sym___forceinline] = ACTIONS(3669),
    [anon_sym_thread_local] = ACTIONS(3669),
    [anon_sym___thread] = ACTIONS(3669),
    [anon_sym_const] = ACTIONS(3669),
    [anon_sym_constexpr] = ACTIONS(3669),
    [anon_sym_volatile] = ACTIONS(3669),
    [anon_sym_restrict] = ACTIONS(3669),
    [anon_sym___restrict__] = ACTIONS(3669),
    [anon_sym__Atomic] = ACTIONS(3669),
    [anon_sym__Noreturn] = ACTIONS(3669),
    [anon_sym_noreturn] = ACTIONS(3669),
    [anon_sym__Nonnull] = ACTIONS(3669),
    [anon_sym_mutable] = ACTIONS(3669),
    [anon_sym_constinit] = ACTIONS(3669),
    [anon_sym_consteval] = ACTIONS(3669),
    [anon_sym_alignas] = ACTIONS(3669),
    [anon_sym__Alignas] = ACTIONS(3669),
    [sym_primitive_type] = ACTIONS(3669),
    [anon_sym_enum] = ACTIONS(3669),
    [anon_sym_class] = ACTIONS(3669),
    [anon_sym_struct] = ACTIONS(3669),
    [anon_sym_union] = ACTIONS(3669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3669),
    [anon_sym_let] = ACTIONS(3669),
    [anon_sym_This] = ACTIONS(3669),
    [anon_sym_decltype] = ACTIONS(3669),
    [anon_sym_explicit] = ACTIONS(3669),
    [anon_sym_typename] = ACTIONS(3669),
    [anon_sym_private] = ACTIONS(3669),
    [anon_sym_template] = ACTIONS(3669),
    [anon_sym_operator] = ACTIONS(3669),
    [anon_sym_friend] = ACTIONS(3669),
    [anon_sym_public] = ACTIONS(3669),
    [anon_sym_protected] = ACTIONS(3669),
    [anon_sym_static_assert] = ACTIONS(3669),
    [anon_sym_precise] = ACTIONS(3669),
    [anon_sym_shared] = ACTIONS(3669),
    [anon_sym_groupshared] = ACTIONS(3669),
    [anon_sym_uniform] = ACTIONS(3669),
    [anon_sym_row_major] = ACTIONS(3669),
    [anon_sym_column_major] = ACTIONS(3669),
    [anon_sym_globallycoherent] = ACTIONS(3669),
    [anon_sym_centroid] = ACTIONS(3669),
    [anon_sym_noperspective] = ACTIONS(3669),
    [anon_sym_nointerpolation] = ACTIONS(3669),
    [anon_sym_sample] = ACTIONS(3669),
    [anon_sym_linear] = ACTIONS(3669),
    [anon_sym_snorm] = ACTIONS(3669),
    [anon_sym_unorm] = ACTIONS(3669),
    [anon_sym_point] = ACTIONS(3669),
    [anon_sym_line] = ACTIONS(3669),
    [anon_sym_triangleadj] = ACTIONS(3669),
    [anon_sym_lineadj] = ACTIONS(3669),
    [anon_sym_triangle] = ACTIONS(3669),
    [anon_sym_interface] = ACTIONS(3669),
    [anon_sym_extension] = ACTIONS(3669),
    [anon_sym___init] = ACTIONS(3669),
    [anon_sym___subscript] = ACTIONS(3669),
    [anon_sym_property] = ACTIONS(3669),
    [anon_sym_associatedtype] = ACTIONS(3669),
  },
  [1741] = {
    [sym_identifier] = ACTIONS(3949),
    [aux_sym_preproc_def_token1] = ACTIONS(3949),
    [aux_sym_preproc_if_token1] = ACTIONS(3949),
    [aux_sym_preproc_if_token2] = ACTIONS(3949),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3949),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3949),
    [aux_sym_preproc_else_token1] = ACTIONS(3949),
    [aux_sym_preproc_elif_token1] = ACTIONS(3949),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3949),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3949),
    [sym_preproc_directive] = ACTIONS(3949),
    [anon_sym_LPAREN2] = ACTIONS(3951),
    [anon_sym_TILDE] = ACTIONS(3951),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3949),
    [anon_sym_SEMI] = ACTIONS(3951),
    [anon_sym___extension__] = ACTIONS(3949),
    [anon_sym_typedef] = ACTIONS(3949),
    [anon_sym_in] = ACTIONS(3949),
    [anon_sym_out] = ACTIONS(3949),
    [anon_sym_inout] = ACTIONS(3949),
    [anon_sym_virtual] = ACTIONS(3949),
    [anon_sym_extern] = ACTIONS(3949),
    [anon_sym___attribute__] = ACTIONS(3949),
    [anon_sym___attribute] = ACTIONS(3949),
    [anon_sym_using] = ACTIONS(3949),
    [anon_sym_COLON_COLON] = ACTIONS(3951),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3951),
    [anon_sym___declspec] = ACTIONS(3949),
    [anon_sym___based] = ACTIONS(3949),
    [anon_sym_signed] = ACTIONS(3949),
    [anon_sym_unsigned] = ACTIONS(3949),
    [anon_sym_long] = ACTIONS(3949),
    [anon_sym_short] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_static] = ACTIONS(3949),
    [anon_sym_register] = ACTIONS(3949),
    [anon_sym_inline] = ACTIONS(3949),
    [anon_sym___inline] = ACTIONS(3949),
    [anon_sym___inline__] = ACTIONS(3949),
    [anon_sym___forceinline] = ACTIONS(3949),
    [anon_sym_thread_local] = ACTIONS(3949),
    [anon_sym___thread] = ACTIONS(3949),
    [anon_sym_const] = ACTIONS(3949),
    [anon_sym_constexpr] = ACTIONS(3949),
    [anon_sym_volatile] = ACTIONS(3949),
    [anon_sym_restrict] = ACTIONS(3949),
    [anon_sym___restrict__] = ACTIONS(3949),
    [anon_sym__Atomic] = ACTIONS(3949),
    [anon_sym__Noreturn] = ACTIONS(3949),
    [anon_sym_noreturn] = ACTIONS(3949),
    [anon_sym__Nonnull] = ACTIONS(3949),
    [anon_sym_mutable] = ACTIONS(3949),
    [anon_sym_constinit] = ACTIONS(3949),
    [anon_sym_consteval] = ACTIONS(3949),
    [anon_sym_alignas] = ACTIONS(3949),
    [anon_sym__Alignas] = ACTIONS(3949),
    [sym_primitive_type] = ACTIONS(3949),
    [anon_sym_enum] = ACTIONS(3949),
    [anon_sym_class] = ACTIONS(3949),
    [anon_sym_struct] = ACTIONS(3949),
    [anon_sym_union] = ACTIONS(3949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_This] = ACTIONS(3949),
    [anon_sym_decltype] = ACTIONS(3949),
    [anon_sym_explicit] = ACTIONS(3949),
    [anon_sym_typename] = ACTIONS(3949),
    [anon_sym_private] = ACTIONS(3949),
    [anon_sym_template] = ACTIONS(3949),
    [anon_sym_operator] = ACTIONS(3949),
    [anon_sym_friend] = ACTIONS(3949),
    [anon_sym_public] = ACTIONS(3949),
    [anon_sym_protected] = ACTIONS(3949),
    [anon_sym_static_assert] = ACTIONS(3949),
    [anon_sym_precise] = ACTIONS(3949),
    [anon_sym_shared] = ACTIONS(3949),
    [anon_sym_groupshared] = ACTIONS(3949),
    [anon_sym_uniform] = ACTIONS(3949),
    [anon_sym_row_major] = ACTIONS(3949),
    [anon_sym_column_major] = ACTIONS(3949),
    [anon_sym_globallycoherent] = ACTIONS(3949),
    [anon_sym_centroid] = ACTIONS(3949),
    [anon_sym_noperspective] = ACTIONS(3949),
    [anon_sym_nointerpolation] = ACTIONS(3949),
    [anon_sym_sample] = ACTIONS(3949),
    [anon_sym_linear] = ACTIONS(3949),
    [anon_sym_snorm] = ACTIONS(3949),
    [anon_sym_unorm] = ACTIONS(3949),
    [anon_sym_point] = ACTIONS(3949),
    [anon_sym_line] = ACTIONS(3949),
    [anon_sym_triangleadj] = ACTIONS(3949),
    [anon_sym_lineadj] = ACTIONS(3949),
    [anon_sym_triangle] = ACTIONS(3949),
    [anon_sym_interface] = ACTIONS(3949),
    [anon_sym_extension] = ACTIONS(3949),
    [anon_sym___init] = ACTIONS(3949),
    [anon_sym___subscript] = ACTIONS(3949),
    [anon_sym_property] = ACTIONS(3949),
    [anon_sym_associatedtype] = ACTIONS(3949),
  },
  [1742] = {
    [sym_expression] = STATE(5691),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10958),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10958),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(6274),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1743] = {
    [sym_identifier] = ACTIONS(3399),
    [aux_sym_preproc_def_token1] = ACTIONS(3399),
    [aux_sym_preproc_if_token1] = ACTIONS(3399),
    [aux_sym_preproc_if_token2] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3399),
    [aux_sym_preproc_else_token1] = ACTIONS(3399),
    [aux_sym_preproc_elif_token1] = ACTIONS(3399),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3399),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3399),
    [sym_preproc_directive] = ACTIONS(3399),
    [anon_sym_LPAREN2] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_STAR] = ACTIONS(3401),
    [anon_sym_AMP_AMP] = ACTIONS(3401),
    [anon_sym_AMP] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym___extension__] = ACTIONS(3399),
    [anon_sym_typedef] = ACTIONS(3399),
    [anon_sym_in] = ACTIONS(3399),
    [anon_sym_out] = ACTIONS(3399),
    [anon_sym_inout] = ACTIONS(3399),
    [anon_sym_virtual] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym___attribute__] = ACTIONS(3399),
    [anon_sym___attribute] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_COLON_COLON] = ACTIONS(3401),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3401),
    [anon_sym___declspec] = ACTIONS(3399),
    [anon_sym___based] = ACTIONS(3399),
    [anon_sym_signed] = ACTIONS(3399),
    [anon_sym_unsigned] = ACTIONS(3399),
    [anon_sym_long] = ACTIONS(3399),
    [anon_sym_short] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_register] = ACTIONS(3399),
    [anon_sym_inline] = ACTIONS(3399),
    [anon_sym___inline] = ACTIONS(3399),
    [anon_sym___inline__] = ACTIONS(3399),
    [anon_sym___forceinline] = ACTIONS(3399),
    [anon_sym_thread_local] = ACTIONS(3399),
    [anon_sym___thread] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_constexpr] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym_restrict] = ACTIONS(3399),
    [anon_sym___restrict__] = ACTIONS(3399),
    [anon_sym__Atomic] = ACTIONS(3399),
    [anon_sym__Noreturn] = ACTIONS(3399),
    [anon_sym_noreturn] = ACTIONS(3399),
    [anon_sym__Nonnull] = ACTIONS(3399),
    [anon_sym_mutable] = ACTIONS(3399),
    [anon_sym_constinit] = ACTIONS(3399),
    [anon_sym_consteval] = ACTIONS(3399),
    [anon_sym_alignas] = ACTIONS(3399),
    [anon_sym__Alignas] = ACTIONS(3399),
    [sym_primitive_type] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_union] = ACTIONS(3399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_This] = ACTIONS(3399),
    [anon_sym_decltype] = ACTIONS(3399),
    [anon_sym_explicit] = ACTIONS(3399),
    [anon_sym_typename] = ACTIONS(3399),
    [anon_sym_private] = ACTIONS(3399),
    [anon_sym_template] = ACTIONS(3399),
    [anon_sym_operator] = ACTIONS(3399),
    [anon_sym_friend] = ACTIONS(3399),
    [anon_sym_public] = ACTIONS(3399),
    [anon_sym_protected] = ACTIONS(3399),
    [anon_sym_static_assert] = ACTIONS(3399),
    [anon_sym_precise] = ACTIONS(3399),
    [anon_sym_shared] = ACTIONS(3399),
    [anon_sym_groupshared] = ACTIONS(3399),
    [anon_sym_uniform] = ACTIONS(3399),
    [anon_sym_row_major] = ACTIONS(3399),
    [anon_sym_column_major] = ACTIONS(3399),
    [anon_sym_globallycoherent] = ACTIONS(3399),
    [anon_sym_centroid] = ACTIONS(3399),
    [anon_sym_noperspective] = ACTIONS(3399),
    [anon_sym_nointerpolation] = ACTIONS(3399),
    [anon_sym_sample] = ACTIONS(3399),
    [anon_sym_linear] = ACTIONS(3399),
    [anon_sym_snorm] = ACTIONS(3399),
    [anon_sym_unorm] = ACTIONS(3399),
    [anon_sym_point] = ACTIONS(3399),
    [anon_sym_line] = ACTIONS(3399),
    [anon_sym_triangleadj] = ACTIONS(3399),
    [anon_sym_lineadj] = ACTIONS(3399),
    [anon_sym_triangle] = ACTIONS(3399),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_extension] = ACTIONS(3399),
    [anon_sym___init] = ACTIONS(3399),
    [anon_sym___subscript] = ACTIONS(3399),
    [anon_sym_property] = ACTIONS(3399),
    [anon_sym_associatedtype] = ACTIONS(3399),
  },
  [1744] = {
    [sym_identifier] = ACTIONS(3877),
    [aux_sym_preproc_def_token1] = ACTIONS(3877),
    [aux_sym_preproc_if_token1] = ACTIONS(3877),
    [aux_sym_preproc_if_token2] = ACTIONS(3877),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3877),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3877),
    [aux_sym_preproc_else_token1] = ACTIONS(3877),
    [aux_sym_preproc_elif_token1] = ACTIONS(3877),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3877),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3877),
    [sym_preproc_directive] = ACTIONS(3877),
    [anon_sym_LPAREN2] = ACTIONS(3879),
    [anon_sym_TILDE] = ACTIONS(3879),
    [anon_sym_STAR] = ACTIONS(3879),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3877),
    [anon_sym_SEMI] = ACTIONS(3879),
    [anon_sym___extension__] = ACTIONS(3877),
    [anon_sym_typedef] = ACTIONS(3877),
    [anon_sym_in] = ACTIONS(3877),
    [anon_sym_out] = ACTIONS(3877),
    [anon_sym_inout] = ACTIONS(3877),
    [anon_sym_virtual] = ACTIONS(3877),
    [anon_sym_extern] = ACTIONS(3877),
    [anon_sym___attribute__] = ACTIONS(3877),
    [anon_sym___attribute] = ACTIONS(3877),
    [anon_sym_using] = ACTIONS(3877),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3879),
    [anon_sym___declspec] = ACTIONS(3877),
    [anon_sym___based] = ACTIONS(3877),
    [anon_sym_signed] = ACTIONS(3877),
    [anon_sym_unsigned] = ACTIONS(3877),
    [anon_sym_long] = ACTIONS(3877),
    [anon_sym_short] = ACTIONS(3877),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_static] = ACTIONS(3877),
    [anon_sym_register] = ACTIONS(3877),
    [anon_sym_inline] = ACTIONS(3877),
    [anon_sym___inline] = ACTIONS(3877),
    [anon_sym___inline__] = ACTIONS(3877),
    [anon_sym___forceinline] = ACTIONS(3877),
    [anon_sym_thread_local] = ACTIONS(3877),
    [anon_sym___thread] = ACTIONS(3877),
    [anon_sym_const] = ACTIONS(3877),
    [anon_sym_constexpr] = ACTIONS(3877),
    [anon_sym_volatile] = ACTIONS(3877),
    [anon_sym_restrict] = ACTIONS(3877),
    [anon_sym___restrict__] = ACTIONS(3877),
    [anon_sym__Atomic] = ACTIONS(3877),
    [anon_sym__Noreturn] = ACTIONS(3877),
    [anon_sym_noreturn] = ACTIONS(3877),
    [anon_sym__Nonnull] = ACTIONS(3877),
    [anon_sym_mutable] = ACTIONS(3877),
    [anon_sym_constinit] = ACTIONS(3877),
    [anon_sym_consteval] = ACTIONS(3877),
    [anon_sym_alignas] = ACTIONS(3877),
    [anon_sym__Alignas] = ACTIONS(3877),
    [sym_primitive_type] = ACTIONS(3877),
    [anon_sym_enum] = ACTIONS(3877),
    [anon_sym_class] = ACTIONS(3877),
    [anon_sym_struct] = ACTIONS(3877),
    [anon_sym_union] = ACTIONS(3877),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3877),
    [anon_sym_let] = ACTIONS(3877),
    [anon_sym_This] = ACTIONS(3877),
    [anon_sym_decltype] = ACTIONS(3877),
    [anon_sym_explicit] = ACTIONS(3877),
    [anon_sym_typename] = ACTIONS(3877),
    [anon_sym_private] = ACTIONS(3877),
    [anon_sym_template] = ACTIONS(3877),
    [anon_sym_operator] = ACTIONS(3877),
    [anon_sym_friend] = ACTIONS(3877),
    [anon_sym_public] = ACTIONS(3877),
    [anon_sym_protected] = ACTIONS(3877),
    [anon_sym_static_assert] = ACTIONS(3877),
    [anon_sym_precise] = ACTIONS(3877),
    [anon_sym_shared] = ACTIONS(3877),
    [anon_sym_groupshared] = ACTIONS(3877),
    [anon_sym_uniform] = ACTIONS(3877),
    [anon_sym_row_major] = ACTIONS(3877),
    [anon_sym_column_major] = ACTIONS(3877),
    [anon_sym_globallycoherent] = ACTIONS(3877),
    [anon_sym_centroid] = ACTIONS(3877),
    [anon_sym_noperspective] = ACTIONS(3877),
    [anon_sym_nointerpolation] = ACTIONS(3877),
    [anon_sym_sample] = ACTIONS(3877),
    [anon_sym_linear] = ACTIONS(3877),
    [anon_sym_snorm] = ACTIONS(3877),
    [anon_sym_unorm] = ACTIONS(3877),
    [anon_sym_point] = ACTIONS(3877),
    [anon_sym_line] = ACTIONS(3877),
    [anon_sym_triangleadj] = ACTIONS(3877),
    [anon_sym_lineadj] = ACTIONS(3877),
    [anon_sym_triangle] = ACTIONS(3877),
    [anon_sym_interface] = ACTIONS(3877),
    [anon_sym_extension] = ACTIONS(3877),
    [anon_sym___init] = ACTIONS(3877),
    [anon_sym___subscript] = ACTIONS(3877),
    [anon_sym_property] = ACTIONS(3877),
    [anon_sym_associatedtype] = ACTIONS(3877),
  },
  [1745] = {
    [sym_identifier] = ACTIONS(3893),
    [aux_sym_preproc_def_token1] = ACTIONS(3893),
    [aux_sym_preproc_if_token1] = ACTIONS(3893),
    [aux_sym_preproc_if_token2] = ACTIONS(3893),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3893),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3893),
    [aux_sym_preproc_else_token1] = ACTIONS(3893),
    [aux_sym_preproc_elif_token1] = ACTIONS(3893),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3893),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3893),
    [sym_preproc_directive] = ACTIONS(3893),
    [anon_sym_LPAREN2] = ACTIONS(3895),
    [anon_sym_TILDE] = ACTIONS(3895),
    [anon_sym_STAR] = ACTIONS(3895),
    [anon_sym_AMP_AMP] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3893),
    [anon_sym_SEMI] = ACTIONS(3895),
    [anon_sym___extension__] = ACTIONS(3893),
    [anon_sym_typedef] = ACTIONS(3893),
    [anon_sym_in] = ACTIONS(3893),
    [anon_sym_out] = ACTIONS(3893),
    [anon_sym_inout] = ACTIONS(3893),
    [anon_sym_virtual] = ACTIONS(3893),
    [anon_sym_extern] = ACTIONS(3893),
    [anon_sym___attribute__] = ACTIONS(3893),
    [anon_sym___attribute] = ACTIONS(3893),
    [anon_sym_using] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3895),
    [anon_sym___declspec] = ACTIONS(3893),
    [anon_sym___based] = ACTIONS(3893),
    [anon_sym_signed] = ACTIONS(3893),
    [anon_sym_unsigned] = ACTIONS(3893),
    [anon_sym_long] = ACTIONS(3893),
    [anon_sym_short] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_static] = ACTIONS(3893),
    [anon_sym_register] = ACTIONS(3893),
    [anon_sym_inline] = ACTIONS(3893),
    [anon_sym___inline] = ACTIONS(3893),
    [anon_sym___inline__] = ACTIONS(3893),
    [anon_sym___forceinline] = ACTIONS(3893),
    [anon_sym_thread_local] = ACTIONS(3893),
    [anon_sym___thread] = ACTIONS(3893),
    [anon_sym_const] = ACTIONS(3893),
    [anon_sym_constexpr] = ACTIONS(3893),
    [anon_sym_volatile] = ACTIONS(3893),
    [anon_sym_restrict] = ACTIONS(3893),
    [anon_sym___restrict__] = ACTIONS(3893),
    [anon_sym__Atomic] = ACTIONS(3893),
    [anon_sym__Noreturn] = ACTIONS(3893),
    [anon_sym_noreturn] = ACTIONS(3893),
    [anon_sym__Nonnull] = ACTIONS(3893),
    [anon_sym_mutable] = ACTIONS(3893),
    [anon_sym_constinit] = ACTIONS(3893),
    [anon_sym_consteval] = ACTIONS(3893),
    [anon_sym_alignas] = ACTIONS(3893),
    [anon_sym__Alignas] = ACTIONS(3893),
    [sym_primitive_type] = ACTIONS(3893),
    [anon_sym_enum] = ACTIONS(3893),
    [anon_sym_class] = ACTIONS(3893),
    [anon_sym_struct] = ACTIONS(3893),
    [anon_sym_union] = ACTIONS(3893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_This] = ACTIONS(3893),
    [anon_sym_decltype] = ACTIONS(3893),
    [anon_sym_explicit] = ACTIONS(3893),
    [anon_sym_typename] = ACTIONS(3893),
    [anon_sym_private] = ACTIONS(3893),
    [anon_sym_template] = ACTIONS(3893),
    [anon_sym_operator] = ACTIONS(3893),
    [anon_sym_friend] = ACTIONS(3893),
    [anon_sym_public] = ACTIONS(3893),
    [anon_sym_protected] = ACTIONS(3893),
    [anon_sym_static_assert] = ACTIONS(3893),
    [anon_sym_precise] = ACTIONS(3893),
    [anon_sym_shared] = ACTIONS(3893),
    [anon_sym_groupshared] = ACTIONS(3893),
    [anon_sym_uniform] = ACTIONS(3893),
    [anon_sym_row_major] = ACTIONS(3893),
    [anon_sym_column_major] = ACTIONS(3893),
    [anon_sym_globallycoherent] = ACTIONS(3893),
    [anon_sym_centroid] = ACTIONS(3893),
    [anon_sym_noperspective] = ACTIONS(3893),
    [anon_sym_nointerpolation] = ACTIONS(3893),
    [anon_sym_sample] = ACTIONS(3893),
    [anon_sym_linear] = ACTIONS(3893),
    [anon_sym_snorm] = ACTIONS(3893),
    [anon_sym_unorm] = ACTIONS(3893),
    [anon_sym_point] = ACTIONS(3893),
    [anon_sym_line] = ACTIONS(3893),
    [anon_sym_triangleadj] = ACTIONS(3893),
    [anon_sym_lineadj] = ACTIONS(3893),
    [anon_sym_triangle] = ACTIONS(3893),
    [anon_sym_interface] = ACTIONS(3893),
    [anon_sym_extension] = ACTIONS(3893),
    [anon_sym___init] = ACTIONS(3893),
    [anon_sym___subscript] = ACTIONS(3893),
    [anon_sym_property] = ACTIONS(3893),
    [anon_sym_associatedtype] = ACTIONS(3893),
  },
  [1746] = {
    [sym_identifier] = ACTIONS(6268),
    [aux_sym_preproc_def_token1] = ACTIONS(6268),
    [aux_sym_preproc_if_token1] = ACTIONS(6268),
    [aux_sym_preproc_if_token2] = ACTIONS(6268),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6268),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6268),
    [aux_sym_preproc_else_token1] = ACTIONS(6268),
    [aux_sym_preproc_elif_token1] = ACTIONS(6268),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6268),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6268),
    [sym_preproc_directive] = ACTIONS(6268),
    [anon_sym_LPAREN2] = ACTIONS(6270),
    [anon_sym_TILDE] = ACTIONS(6270),
    [anon_sym_STAR] = ACTIONS(6270),
    [anon_sym_AMP_AMP] = ACTIONS(6270),
    [anon_sym_AMP] = ACTIONS(6268),
    [anon_sym_SEMI] = ACTIONS(6270),
    [anon_sym___extension__] = ACTIONS(6268),
    [anon_sym_typedef] = ACTIONS(6268),
    [anon_sym_in] = ACTIONS(6268),
    [anon_sym_out] = ACTIONS(6268),
    [anon_sym_inout] = ACTIONS(6268),
    [anon_sym_virtual] = ACTIONS(6268),
    [anon_sym_extern] = ACTIONS(6268),
    [anon_sym___attribute__] = ACTIONS(6268),
    [anon_sym___attribute] = ACTIONS(6268),
    [anon_sym_using] = ACTIONS(6268),
    [anon_sym_COLON_COLON] = ACTIONS(6270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6270),
    [anon_sym___declspec] = ACTIONS(6268),
    [anon_sym___based] = ACTIONS(6268),
    [anon_sym_signed] = ACTIONS(6268),
    [anon_sym_unsigned] = ACTIONS(6268),
    [anon_sym_long] = ACTIONS(6268),
    [anon_sym_short] = ACTIONS(6268),
    [anon_sym_LBRACK] = ACTIONS(6268),
    [anon_sym_static] = ACTIONS(6268),
    [anon_sym_register] = ACTIONS(6268),
    [anon_sym_inline] = ACTIONS(6268),
    [anon_sym___inline] = ACTIONS(6268),
    [anon_sym___inline__] = ACTIONS(6268),
    [anon_sym___forceinline] = ACTIONS(6268),
    [anon_sym_thread_local] = ACTIONS(6268),
    [anon_sym___thread] = ACTIONS(6268),
    [anon_sym_const] = ACTIONS(6268),
    [anon_sym_constexpr] = ACTIONS(6268),
    [anon_sym_volatile] = ACTIONS(6268),
    [anon_sym_restrict] = ACTIONS(6268),
    [anon_sym___restrict__] = ACTIONS(6268),
    [anon_sym__Atomic] = ACTIONS(6268),
    [anon_sym__Noreturn] = ACTIONS(6268),
    [anon_sym_noreturn] = ACTIONS(6268),
    [anon_sym__Nonnull] = ACTIONS(6268),
    [anon_sym_mutable] = ACTIONS(6268),
    [anon_sym_constinit] = ACTIONS(6268),
    [anon_sym_consteval] = ACTIONS(6268),
    [anon_sym_alignas] = ACTIONS(6268),
    [anon_sym__Alignas] = ACTIONS(6268),
    [sym_primitive_type] = ACTIONS(6268),
    [anon_sym_enum] = ACTIONS(6268),
    [anon_sym_class] = ACTIONS(6268),
    [anon_sym_struct] = ACTIONS(6268),
    [anon_sym_union] = ACTIONS(6268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6268),
    [anon_sym_let] = ACTIONS(6268),
    [anon_sym_This] = ACTIONS(6268),
    [anon_sym_decltype] = ACTIONS(6268),
    [anon_sym_explicit] = ACTIONS(6268),
    [anon_sym_typename] = ACTIONS(6268),
    [anon_sym_private] = ACTIONS(6268),
    [anon_sym_template] = ACTIONS(6268),
    [anon_sym_operator] = ACTIONS(6268),
    [anon_sym_friend] = ACTIONS(6268),
    [anon_sym_public] = ACTIONS(6268),
    [anon_sym_protected] = ACTIONS(6268),
    [anon_sym_static_assert] = ACTIONS(6268),
    [anon_sym_precise] = ACTIONS(6268),
    [anon_sym_shared] = ACTIONS(6268),
    [anon_sym_groupshared] = ACTIONS(6268),
    [anon_sym_uniform] = ACTIONS(6268),
    [anon_sym_row_major] = ACTIONS(6268),
    [anon_sym_column_major] = ACTIONS(6268),
    [anon_sym_globallycoherent] = ACTIONS(6268),
    [anon_sym_centroid] = ACTIONS(6268),
    [anon_sym_noperspective] = ACTIONS(6268),
    [anon_sym_nointerpolation] = ACTIONS(6268),
    [anon_sym_sample] = ACTIONS(6268),
    [anon_sym_linear] = ACTIONS(6268),
    [anon_sym_snorm] = ACTIONS(6268),
    [anon_sym_unorm] = ACTIONS(6268),
    [anon_sym_point] = ACTIONS(6268),
    [anon_sym_line] = ACTIONS(6268),
    [anon_sym_triangleadj] = ACTIONS(6268),
    [anon_sym_lineadj] = ACTIONS(6268),
    [anon_sym_triangle] = ACTIONS(6268),
    [anon_sym_interface] = ACTIONS(6268),
    [anon_sym_extension] = ACTIONS(6268),
    [anon_sym___init] = ACTIONS(6268),
    [anon_sym___subscript] = ACTIONS(6268),
    [anon_sym_property] = ACTIONS(6268),
    [anon_sym_associatedtype] = ACTIONS(6268),
  },
  [1747] = {
    [sym_identifier] = ACTIONS(3739),
    [aux_sym_preproc_def_token1] = ACTIONS(3739),
    [aux_sym_preproc_if_token1] = ACTIONS(3739),
    [aux_sym_preproc_if_token2] = ACTIONS(3739),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3739),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3739),
    [aux_sym_preproc_else_token1] = ACTIONS(3739),
    [aux_sym_preproc_elif_token1] = ACTIONS(3739),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3739),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3739),
    [sym_preproc_directive] = ACTIONS(3739),
    [anon_sym_LPAREN2] = ACTIONS(3741),
    [anon_sym_TILDE] = ACTIONS(3741),
    [anon_sym_STAR] = ACTIONS(3741),
    [anon_sym_AMP_AMP] = ACTIONS(3741),
    [anon_sym_AMP] = ACTIONS(3739),
    [anon_sym_SEMI] = ACTIONS(3741),
    [anon_sym___extension__] = ACTIONS(3739),
    [anon_sym_typedef] = ACTIONS(3739),
    [anon_sym_in] = ACTIONS(3739),
    [anon_sym_out] = ACTIONS(3739),
    [anon_sym_inout] = ACTIONS(3739),
    [anon_sym_virtual] = ACTIONS(3739),
    [anon_sym_extern] = ACTIONS(3739),
    [anon_sym___attribute__] = ACTIONS(3739),
    [anon_sym___attribute] = ACTIONS(3739),
    [anon_sym_using] = ACTIONS(3739),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3741),
    [anon_sym___declspec] = ACTIONS(3739),
    [anon_sym___based] = ACTIONS(3739),
    [anon_sym_signed] = ACTIONS(3739),
    [anon_sym_unsigned] = ACTIONS(3739),
    [anon_sym_long] = ACTIONS(3739),
    [anon_sym_short] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3739),
    [anon_sym_static] = ACTIONS(3739),
    [anon_sym_register] = ACTIONS(3739),
    [anon_sym_inline] = ACTIONS(3739),
    [anon_sym___inline] = ACTIONS(3739),
    [anon_sym___inline__] = ACTIONS(3739),
    [anon_sym___forceinline] = ACTIONS(3739),
    [anon_sym_thread_local] = ACTIONS(3739),
    [anon_sym___thread] = ACTIONS(3739),
    [anon_sym_const] = ACTIONS(3739),
    [anon_sym_constexpr] = ACTIONS(3739),
    [anon_sym_volatile] = ACTIONS(3739),
    [anon_sym_restrict] = ACTIONS(3739),
    [anon_sym___restrict__] = ACTIONS(3739),
    [anon_sym__Atomic] = ACTIONS(3739),
    [anon_sym__Noreturn] = ACTIONS(3739),
    [anon_sym_noreturn] = ACTIONS(3739),
    [anon_sym__Nonnull] = ACTIONS(3739),
    [anon_sym_mutable] = ACTIONS(3739),
    [anon_sym_constinit] = ACTIONS(3739),
    [anon_sym_consteval] = ACTIONS(3739),
    [anon_sym_alignas] = ACTIONS(3739),
    [anon_sym__Alignas] = ACTIONS(3739),
    [sym_primitive_type] = ACTIONS(3739),
    [anon_sym_enum] = ACTIONS(3739),
    [anon_sym_class] = ACTIONS(3739),
    [anon_sym_struct] = ACTIONS(3739),
    [anon_sym_union] = ACTIONS(3739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3739),
    [anon_sym_let] = ACTIONS(3739),
    [anon_sym_This] = ACTIONS(3739),
    [anon_sym_decltype] = ACTIONS(3739),
    [anon_sym_explicit] = ACTIONS(3739),
    [anon_sym_typename] = ACTIONS(3739),
    [anon_sym_private] = ACTIONS(3739),
    [anon_sym_template] = ACTIONS(3739),
    [anon_sym_operator] = ACTIONS(3739),
    [anon_sym_friend] = ACTIONS(3739),
    [anon_sym_public] = ACTIONS(3739),
    [anon_sym_protected] = ACTIONS(3739),
    [anon_sym_static_assert] = ACTIONS(3739),
    [anon_sym_precise] = ACTIONS(3739),
    [anon_sym_shared] = ACTIONS(3739),
    [anon_sym_groupshared] = ACTIONS(3739),
    [anon_sym_uniform] = ACTIONS(3739),
    [anon_sym_row_major] = ACTIONS(3739),
    [anon_sym_column_major] = ACTIONS(3739),
    [anon_sym_globallycoherent] = ACTIONS(3739),
    [anon_sym_centroid] = ACTIONS(3739),
    [anon_sym_noperspective] = ACTIONS(3739),
    [anon_sym_nointerpolation] = ACTIONS(3739),
    [anon_sym_sample] = ACTIONS(3739),
    [anon_sym_linear] = ACTIONS(3739),
    [anon_sym_snorm] = ACTIONS(3739),
    [anon_sym_unorm] = ACTIONS(3739),
    [anon_sym_point] = ACTIONS(3739),
    [anon_sym_line] = ACTIONS(3739),
    [anon_sym_triangleadj] = ACTIONS(3739),
    [anon_sym_lineadj] = ACTIONS(3739),
    [anon_sym_triangle] = ACTIONS(3739),
    [anon_sym_interface] = ACTIONS(3739),
    [anon_sym_extension] = ACTIONS(3739),
    [anon_sym___init] = ACTIONS(3739),
    [anon_sym___subscript] = ACTIONS(3739),
    [anon_sym_property] = ACTIONS(3739),
    [anon_sym_associatedtype] = ACTIONS(3739),
  },
  [1748] = {
    [sym_expression] = STATE(4399),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym__unary_left_fold] = STATE(10875),
    [sym__unary_right_fold] = STATE(10882),
    [sym__binary_fold] = STATE(10884),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1749] = {
    [sym_identifier] = ACTIONS(3824),
    [aux_sym_preproc_def_token1] = ACTIONS(3824),
    [aux_sym_preproc_if_token1] = ACTIONS(3824),
    [aux_sym_preproc_if_token2] = ACTIONS(3824),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3824),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3824),
    [aux_sym_preproc_else_token1] = ACTIONS(3824),
    [aux_sym_preproc_elif_token1] = ACTIONS(3824),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3824),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3824),
    [sym_preproc_directive] = ACTIONS(3824),
    [anon_sym_LPAREN2] = ACTIONS(3826),
    [anon_sym_TILDE] = ACTIONS(3826),
    [anon_sym_STAR] = ACTIONS(3826),
    [anon_sym_AMP_AMP] = ACTIONS(3826),
    [anon_sym_AMP] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(3826),
    [anon_sym___extension__] = ACTIONS(3824),
    [anon_sym_typedef] = ACTIONS(3824),
    [anon_sym_in] = ACTIONS(3824),
    [anon_sym_out] = ACTIONS(3824),
    [anon_sym_inout] = ACTIONS(3824),
    [anon_sym_virtual] = ACTIONS(3824),
    [anon_sym_extern] = ACTIONS(3824),
    [anon_sym___attribute__] = ACTIONS(3824),
    [anon_sym___attribute] = ACTIONS(3824),
    [anon_sym_using] = ACTIONS(3824),
    [anon_sym_COLON_COLON] = ACTIONS(3826),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3826),
    [anon_sym___declspec] = ACTIONS(3824),
    [anon_sym___based] = ACTIONS(3824),
    [anon_sym_signed] = ACTIONS(3824),
    [anon_sym_unsigned] = ACTIONS(3824),
    [anon_sym_long] = ACTIONS(3824),
    [anon_sym_short] = ACTIONS(3824),
    [anon_sym_LBRACK] = ACTIONS(3824),
    [anon_sym_static] = ACTIONS(3824),
    [anon_sym_register] = ACTIONS(3824),
    [anon_sym_inline] = ACTIONS(3824),
    [anon_sym___inline] = ACTIONS(3824),
    [anon_sym___inline__] = ACTIONS(3824),
    [anon_sym___forceinline] = ACTIONS(3824),
    [anon_sym_thread_local] = ACTIONS(3824),
    [anon_sym___thread] = ACTIONS(3824),
    [anon_sym_const] = ACTIONS(3824),
    [anon_sym_constexpr] = ACTIONS(3824),
    [anon_sym_volatile] = ACTIONS(3824),
    [anon_sym_restrict] = ACTIONS(3824),
    [anon_sym___restrict__] = ACTIONS(3824),
    [anon_sym__Atomic] = ACTIONS(3824),
    [anon_sym__Noreturn] = ACTIONS(3824),
    [anon_sym_noreturn] = ACTIONS(3824),
    [anon_sym__Nonnull] = ACTIONS(3824),
    [anon_sym_mutable] = ACTIONS(3824),
    [anon_sym_constinit] = ACTIONS(3824),
    [anon_sym_consteval] = ACTIONS(3824),
    [anon_sym_alignas] = ACTIONS(3824),
    [anon_sym__Alignas] = ACTIONS(3824),
    [sym_primitive_type] = ACTIONS(3824),
    [anon_sym_enum] = ACTIONS(3824),
    [anon_sym_class] = ACTIONS(3824),
    [anon_sym_struct] = ACTIONS(3824),
    [anon_sym_union] = ACTIONS(3824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3824),
    [anon_sym_let] = ACTIONS(3824),
    [anon_sym_This] = ACTIONS(3824),
    [anon_sym_decltype] = ACTIONS(3824),
    [anon_sym_explicit] = ACTIONS(3824),
    [anon_sym_typename] = ACTIONS(3824),
    [anon_sym_private] = ACTIONS(3824),
    [anon_sym_template] = ACTIONS(3824),
    [anon_sym_operator] = ACTIONS(3824),
    [anon_sym_friend] = ACTIONS(3824),
    [anon_sym_public] = ACTIONS(3824),
    [anon_sym_protected] = ACTIONS(3824),
    [anon_sym_static_assert] = ACTIONS(3824),
    [anon_sym_precise] = ACTIONS(3824),
    [anon_sym_shared] = ACTIONS(3824),
    [anon_sym_groupshared] = ACTIONS(3824),
    [anon_sym_uniform] = ACTIONS(3824),
    [anon_sym_row_major] = ACTIONS(3824),
    [anon_sym_column_major] = ACTIONS(3824),
    [anon_sym_globallycoherent] = ACTIONS(3824),
    [anon_sym_centroid] = ACTIONS(3824),
    [anon_sym_noperspective] = ACTIONS(3824),
    [anon_sym_nointerpolation] = ACTIONS(3824),
    [anon_sym_sample] = ACTIONS(3824),
    [anon_sym_linear] = ACTIONS(3824),
    [anon_sym_snorm] = ACTIONS(3824),
    [anon_sym_unorm] = ACTIONS(3824),
    [anon_sym_point] = ACTIONS(3824),
    [anon_sym_line] = ACTIONS(3824),
    [anon_sym_triangleadj] = ACTIONS(3824),
    [anon_sym_lineadj] = ACTIONS(3824),
    [anon_sym_triangle] = ACTIONS(3824),
    [anon_sym_interface] = ACTIONS(3824),
    [anon_sym_extension] = ACTIONS(3824),
    [anon_sym___init] = ACTIONS(3824),
    [anon_sym___subscript] = ACTIONS(3824),
    [anon_sym_property] = ACTIONS(3824),
    [anon_sym_associatedtype] = ACTIONS(3824),
  },
  [1750] = {
    [sym_identifier] = ACTIONS(3820),
    [aux_sym_preproc_def_token1] = ACTIONS(3820),
    [aux_sym_preproc_if_token1] = ACTIONS(3820),
    [aux_sym_preproc_if_token2] = ACTIONS(3820),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3820),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3820),
    [aux_sym_preproc_else_token1] = ACTIONS(3820),
    [aux_sym_preproc_elif_token1] = ACTIONS(3820),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3820),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3820),
    [sym_preproc_directive] = ACTIONS(3820),
    [anon_sym_LPAREN2] = ACTIONS(3822),
    [anon_sym_TILDE] = ACTIONS(3822),
    [anon_sym_STAR] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3822),
    [anon_sym_AMP] = ACTIONS(3820),
    [anon_sym_SEMI] = ACTIONS(3822),
    [anon_sym___extension__] = ACTIONS(3820),
    [anon_sym_typedef] = ACTIONS(3820),
    [anon_sym_in] = ACTIONS(3820),
    [anon_sym_out] = ACTIONS(3820),
    [anon_sym_inout] = ACTIONS(3820),
    [anon_sym_virtual] = ACTIONS(3820),
    [anon_sym_extern] = ACTIONS(3820),
    [anon_sym___attribute__] = ACTIONS(3820),
    [anon_sym___attribute] = ACTIONS(3820),
    [anon_sym_using] = ACTIONS(3820),
    [anon_sym_COLON_COLON] = ACTIONS(3822),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3822),
    [anon_sym___declspec] = ACTIONS(3820),
    [anon_sym___based] = ACTIONS(3820),
    [anon_sym_signed] = ACTIONS(3820),
    [anon_sym_unsigned] = ACTIONS(3820),
    [anon_sym_long] = ACTIONS(3820),
    [anon_sym_short] = ACTIONS(3820),
    [anon_sym_LBRACK] = ACTIONS(3820),
    [anon_sym_static] = ACTIONS(3820),
    [anon_sym_register] = ACTIONS(3820),
    [anon_sym_inline] = ACTIONS(3820),
    [anon_sym___inline] = ACTIONS(3820),
    [anon_sym___inline__] = ACTIONS(3820),
    [anon_sym___forceinline] = ACTIONS(3820),
    [anon_sym_thread_local] = ACTIONS(3820),
    [anon_sym___thread] = ACTIONS(3820),
    [anon_sym_const] = ACTIONS(3820),
    [anon_sym_constexpr] = ACTIONS(3820),
    [anon_sym_volatile] = ACTIONS(3820),
    [anon_sym_restrict] = ACTIONS(3820),
    [anon_sym___restrict__] = ACTIONS(3820),
    [anon_sym__Atomic] = ACTIONS(3820),
    [anon_sym__Noreturn] = ACTIONS(3820),
    [anon_sym_noreturn] = ACTIONS(3820),
    [anon_sym__Nonnull] = ACTIONS(3820),
    [anon_sym_mutable] = ACTIONS(3820),
    [anon_sym_constinit] = ACTIONS(3820),
    [anon_sym_consteval] = ACTIONS(3820),
    [anon_sym_alignas] = ACTIONS(3820),
    [anon_sym__Alignas] = ACTIONS(3820),
    [sym_primitive_type] = ACTIONS(3820),
    [anon_sym_enum] = ACTIONS(3820),
    [anon_sym_class] = ACTIONS(3820),
    [anon_sym_struct] = ACTIONS(3820),
    [anon_sym_union] = ACTIONS(3820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3820),
    [anon_sym_let] = ACTIONS(3820),
    [anon_sym_This] = ACTIONS(3820),
    [anon_sym_decltype] = ACTIONS(3820),
    [anon_sym_explicit] = ACTIONS(3820),
    [anon_sym_typename] = ACTIONS(3820),
    [anon_sym_private] = ACTIONS(3820),
    [anon_sym_template] = ACTIONS(3820),
    [anon_sym_operator] = ACTIONS(3820),
    [anon_sym_friend] = ACTIONS(3820),
    [anon_sym_public] = ACTIONS(3820),
    [anon_sym_protected] = ACTIONS(3820),
    [anon_sym_static_assert] = ACTIONS(3820),
    [anon_sym_precise] = ACTIONS(3820),
    [anon_sym_shared] = ACTIONS(3820),
    [anon_sym_groupshared] = ACTIONS(3820),
    [anon_sym_uniform] = ACTIONS(3820),
    [anon_sym_row_major] = ACTIONS(3820),
    [anon_sym_column_major] = ACTIONS(3820),
    [anon_sym_globallycoherent] = ACTIONS(3820),
    [anon_sym_centroid] = ACTIONS(3820),
    [anon_sym_noperspective] = ACTIONS(3820),
    [anon_sym_nointerpolation] = ACTIONS(3820),
    [anon_sym_sample] = ACTIONS(3820),
    [anon_sym_linear] = ACTIONS(3820),
    [anon_sym_snorm] = ACTIONS(3820),
    [anon_sym_unorm] = ACTIONS(3820),
    [anon_sym_point] = ACTIONS(3820),
    [anon_sym_line] = ACTIONS(3820),
    [anon_sym_triangleadj] = ACTIONS(3820),
    [anon_sym_lineadj] = ACTIONS(3820),
    [anon_sym_triangle] = ACTIONS(3820),
    [anon_sym_interface] = ACTIONS(3820),
    [anon_sym_extension] = ACTIONS(3820),
    [anon_sym___init] = ACTIONS(3820),
    [anon_sym___subscript] = ACTIONS(3820),
    [anon_sym_property] = ACTIONS(3820),
    [anon_sym_associatedtype] = ACTIONS(3820),
  },
  [1751] = {
    [sym_compound_statement] = STATE(9794),
    [sym_expression] = STATE(5566),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(9794),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_RPAREN] = ACTIONS(6276),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(6134),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1752] = {
    [sym_identifier] = ACTIONS(6278),
    [aux_sym_preproc_def_token1] = ACTIONS(6278),
    [aux_sym_preproc_if_token1] = ACTIONS(6278),
    [aux_sym_preproc_if_token2] = ACTIONS(6278),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6278),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6278),
    [aux_sym_preproc_else_token1] = ACTIONS(6278),
    [aux_sym_preproc_elif_token1] = ACTIONS(6278),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6278),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6278),
    [sym_preproc_directive] = ACTIONS(6278),
    [anon_sym_LPAREN2] = ACTIONS(6280),
    [anon_sym_TILDE] = ACTIONS(6280),
    [anon_sym_STAR] = ACTIONS(6280),
    [anon_sym_AMP_AMP] = ACTIONS(6280),
    [anon_sym_AMP] = ACTIONS(6278),
    [anon_sym_SEMI] = ACTIONS(6280),
    [anon_sym___extension__] = ACTIONS(6278),
    [anon_sym_typedef] = ACTIONS(6278),
    [anon_sym_in] = ACTIONS(6278),
    [anon_sym_out] = ACTIONS(6278),
    [anon_sym_inout] = ACTIONS(6278),
    [anon_sym_virtual] = ACTIONS(6278),
    [anon_sym_extern] = ACTIONS(6278),
    [anon_sym___attribute__] = ACTIONS(6278),
    [anon_sym___attribute] = ACTIONS(6278),
    [anon_sym_using] = ACTIONS(6278),
    [anon_sym_COLON_COLON] = ACTIONS(6280),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6280),
    [anon_sym___declspec] = ACTIONS(6278),
    [anon_sym___based] = ACTIONS(6278),
    [anon_sym_signed] = ACTIONS(6278),
    [anon_sym_unsigned] = ACTIONS(6278),
    [anon_sym_long] = ACTIONS(6278),
    [anon_sym_short] = ACTIONS(6278),
    [anon_sym_LBRACK] = ACTIONS(6278),
    [anon_sym_static] = ACTIONS(6278),
    [anon_sym_register] = ACTIONS(6278),
    [anon_sym_inline] = ACTIONS(6278),
    [anon_sym___inline] = ACTIONS(6278),
    [anon_sym___inline__] = ACTIONS(6278),
    [anon_sym___forceinline] = ACTIONS(6278),
    [anon_sym_thread_local] = ACTIONS(6278),
    [anon_sym___thread] = ACTIONS(6278),
    [anon_sym_const] = ACTIONS(6278),
    [anon_sym_constexpr] = ACTIONS(6278),
    [anon_sym_volatile] = ACTIONS(6278),
    [anon_sym_restrict] = ACTIONS(6278),
    [anon_sym___restrict__] = ACTIONS(6278),
    [anon_sym__Atomic] = ACTIONS(6278),
    [anon_sym__Noreturn] = ACTIONS(6278),
    [anon_sym_noreturn] = ACTIONS(6278),
    [anon_sym__Nonnull] = ACTIONS(6278),
    [anon_sym_mutable] = ACTIONS(6278),
    [anon_sym_constinit] = ACTIONS(6278),
    [anon_sym_consteval] = ACTIONS(6278),
    [anon_sym_alignas] = ACTIONS(6278),
    [anon_sym__Alignas] = ACTIONS(6278),
    [sym_primitive_type] = ACTIONS(6278),
    [anon_sym_enum] = ACTIONS(6278),
    [anon_sym_class] = ACTIONS(6278),
    [anon_sym_struct] = ACTIONS(6278),
    [anon_sym_union] = ACTIONS(6278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6278),
    [anon_sym_let] = ACTIONS(6278),
    [anon_sym_This] = ACTIONS(6278),
    [anon_sym_decltype] = ACTIONS(6278),
    [anon_sym_explicit] = ACTIONS(6278),
    [anon_sym_typename] = ACTIONS(6278),
    [anon_sym_private] = ACTIONS(6278),
    [anon_sym_template] = ACTIONS(6278),
    [anon_sym_operator] = ACTIONS(6278),
    [anon_sym_friend] = ACTIONS(6278),
    [anon_sym_public] = ACTIONS(6278),
    [anon_sym_protected] = ACTIONS(6278),
    [anon_sym_static_assert] = ACTIONS(6278),
    [anon_sym_precise] = ACTIONS(6278),
    [anon_sym_shared] = ACTIONS(6278),
    [anon_sym_groupshared] = ACTIONS(6278),
    [anon_sym_uniform] = ACTIONS(6278),
    [anon_sym_row_major] = ACTIONS(6278),
    [anon_sym_column_major] = ACTIONS(6278),
    [anon_sym_globallycoherent] = ACTIONS(6278),
    [anon_sym_centroid] = ACTIONS(6278),
    [anon_sym_noperspective] = ACTIONS(6278),
    [anon_sym_nointerpolation] = ACTIONS(6278),
    [anon_sym_sample] = ACTIONS(6278),
    [anon_sym_linear] = ACTIONS(6278),
    [anon_sym_snorm] = ACTIONS(6278),
    [anon_sym_unorm] = ACTIONS(6278),
    [anon_sym_point] = ACTIONS(6278),
    [anon_sym_line] = ACTIONS(6278),
    [anon_sym_triangleadj] = ACTIONS(6278),
    [anon_sym_lineadj] = ACTIONS(6278),
    [anon_sym_triangle] = ACTIONS(6278),
    [anon_sym_interface] = ACTIONS(6278),
    [anon_sym_extension] = ACTIONS(6278),
    [anon_sym___init] = ACTIONS(6278),
    [anon_sym___subscript] = ACTIONS(6278),
    [anon_sym_property] = ACTIONS(6278),
    [anon_sym_associatedtype] = ACTIONS(6278),
  },
  [1753] = {
    [sym_identifier] = ACTIONS(3853),
    [aux_sym_preproc_def_token1] = ACTIONS(3853),
    [aux_sym_preproc_if_token1] = ACTIONS(3853),
    [aux_sym_preproc_if_token2] = ACTIONS(3853),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3853),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3853),
    [aux_sym_preproc_else_token1] = ACTIONS(3853),
    [aux_sym_preproc_elif_token1] = ACTIONS(3853),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3853),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3853),
    [sym_preproc_directive] = ACTIONS(3853),
    [anon_sym_LPAREN2] = ACTIONS(3855),
    [anon_sym_TILDE] = ACTIONS(3855),
    [anon_sym_STAR] = ACTIONS(3855),
    [anon_sym_AMP_AMP] = ACTIONS(3855),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_SEMI] = ACTIONS(3855),
    [anon_sym___extension__] = ACTIONS(3853),
    [anon_sym_typedef] = ACTIONS(3853),
    [anon_sym_in] = ACTIONS(3853),
    [anon_sym_out] = ACTIONS(3853),
    [anon_sym_inout] = ACTIONS(3853),
    [anon_sym_virtual] = ACTIONS(3853),
    [anon_sym_extern] = ACTIONS(3853),
    [anon_sym___attribute__] = ACTIONS(3853),
    [anon_sym___attribute] = ACTIONS(3853),
    [anon_sym_using] = ACTIONS(3853),
    [anon_sym_COLON_COLON] = ACTIONS(3855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3855),
    [anon_sym___declspec] = ACTIONS(3853),
    [anon_sym___based] = ACTIONS(3853),
    [anon_sym_signed] = ACTIONS(3853),
    [anon_sym_unsigned] = ACTIONS(3853),
    [anon_sym_long] = ACTIONS(3853),
    [anon_sym_short] = ACTIONS(3853),
    [anon_sym_LBRACK] = ACTIONS(3853),
    [anon_sym_static] = ACTIONS(3853),
    [anon_sym_register] = ACTIONS(3853),
    [anon_sym_inline] = ACTIONS(3853),
    [anon_sym___inline] = ACTIONS(3853),
    [anon_sym___inline__] = ACTIONS(3853),
    [anon_sym___forceinline] = ACTIONS(3853),
    [anon_sym_thread_local] = ACTIONS(3853),
    [anon_sym___thread] = ACTIONS(3853),
    [anon_sym_const] = ACTIONS(3853),
    [anon_sym_constexpr] = ACTIONS(3853),
    [anon_sym_volatile] = ACTIONS(3853),
    [anon_sym_restrict] = ACTIONS(3853),
    [anon_sym___restrict__] = ACTIONS(3853),
    [anon_sym__Atomic] = ACTIONS(3853),
    [anon_sym__Noreturn] = ACTIONS(3853),
    [anon_sym_noreturn] = ACTIONS(3853),
    [anon_sym__Nonnull] = ACTIONS(3853),
    [anon_sym_mutable] = ACTIONS(3853),
    [anon_sym_constinit] = ACTIONS(3853),
    [anon_sym_consteval] = ACTIONS(3853),
    [anon_sym_alignas] = ACTIONS(3853),
    [anon_sym__Alignas] = ACTIONS(3853),
    [sym_primitive_type] = ACTIONS(3853),
    [anon_sym_enum] = ACTIONS(3853),
    [anon_sym_class] = ACTIONS(3853),
    [anon_sym_struct] = ACTIONS(3853),
    [anon_sym_union] = ACTIONS(3853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3853),
    [anon_sym_let] = ACTIONS(3853),
    [anon_sym_This] = ACTIONS(3853),
    [anon_sym_decltype] = ACTIONS(3853),
    [anon_sym_explicit] = ACTIONS(3853),
    [anon_sym_typename] = ACTIONS(3853),
    [anon_sym_private] = ACTIONS(3853),
    [anon_sym_template] = ACTIONS(3853),
    [anon_sym_operator] = ACTIONS(3853),
    [anon_sym_friend] = ACTIONS(3853),
    [anon_sym_public] = ACTIONS(3853),
    [anon_sym_protected] = ACTIONS(3853),
    [anon_sym_static_assert] = ACTIONS(3853),
    [anon_sym_precise] = ACTIONS(3853),
    [anon_sym_shared] = ACTIONS(3853),
    [anon_sym_groupshared] = ACTIONS(3853),
    [anon_sym_uniform] = ACTIONS(3853),
    [anon_sym_row_major] = ACTIONS(3853),
    [anon_sym_column_major] = ACTIONS(3853),
    [anon_sym_globallycoherent] = ACTIONS(3853),
    [anon_sym_centroid] = ACTIONS(3853),
    [anon_sym_noperspective] = ACTIONS(3853),
    [anon_sym_nointerpolation] = ACTIONS(3853),
    [anon_sym_sample] = ACTIONS(3853),
    [anon_sym_linear] = ACTIONS(3853),
    [anon_sym_snorm] = ACTIONS(3853),
    [anon_sym_unorm] = ACTIONS(3853),
    [anon_sym_point] = ACTIONS(3853),
    [anon_sym_line] = ACTIONS(3853),
    [anon_sym_triangleadj] = ACTIONS(3853),
    [anon_sym_lineadj] = ACTIONS(3853),
    [anon_sym_triangle] = ACTIONS(3853),
    [anon_sym_interface] = ACTIONS(3853),
    [anon_sym_extension] = ACTIONS(3853),
    [anon_sym___init] = ACTIONS(3853),
    [anon_sym___subscript] = ACTIONS(3853),
    [anon_sym_property] = ACTIONS(3853),
    [anon_sym_associatedtype] = ACTIONS(3853),
  },
  [1754] = {
    [sym_expression] = STATE(5667),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11240),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(11240),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(6282),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1755] = {
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token2] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [aux_sym_preproc_else_token1] = ACTIONS(3812),
    [aux_sym_preproc_elif_token1] = ACTIONS(3812),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_private] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_friend] = ACTIONS(3812),
    [anon_sym_public] = ACTIONS(3812),
    [anon_sym_protected] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
    [anon_sym___init] = ACTIONS(3812),
    [anon_sym___subscript] = ACTIONS(3812),
    [anon_sym_property] = ACTIONS(3812),
    [anon_sym_associatedtype] = ACTIONS(3812),
  },
  [1756] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_identifier_parameter_pack_expansion] = STATE(10764),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4748),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(6284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6286),
    [anon_sym_COMMA] = ACTIONS(6288),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6288),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1757] = {
    [sym_identifier] = ACTIONS(3885),
    [aux_sym_preproc_def_token1] = ACTIONS(3885),
    [aux_sym_preproc_if_token1] = ACTIONS(3885),
    [aux_sym_preproc_if_token2] = ACTIONS(3885),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3885),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3885),
    [aux_sym_preproc_else_token1] = ACTIONS(3885),
    [aux_sym_preproc_elif_token1] = ACTIONS(3885),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3885),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3885),
    [sym_preproc_directive] = ACTIONS(3885),
    [anon_sym_LPAREN2] = ACTIONS(3887),
    [anon_sym_TILDE] = ACTIONS(3887),
    [anon_sym_STAR] = ACTIONS(3887),
    [anon_sym_AMP_AMP] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3885),
    [anon_sym_SEMI] = ACTIONS(3887),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_typedef] = ACTIONS(3885),
    [anon_sym_in] = ACTIONS(3885),
    [anon_sym_out] = ACTIONS(3885),
    [anon_sym_inout] = ACTIONS(3885),
    [anon_sym_virtual] = ACTIONS(3885),
    [anon_sym_extern] = ACTIONS(3885),
    [anon_sym___attribute__] = ACTIONS(3885),
    [anon_sym___attribute] = ACTIONS(3885),
    [anon_sym_using] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3887),
    [anon_sym___declspec] = ACTIONS(3885),
    [anon_sym___based] = ACTIONS(3885),
    [anon_sym_signed] = ACTIONS(3885),
    [anon_sym_unsigned] = ACTIONS(3885),
    [anon_sym_long] = ACTIONS(3885),
    [anon_sym_short] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_static] = ACTIONS(3885),
    [anon_sym_register] = ACTIONS(3885),
    [anon_sym_inline] = ACTIONS(3885),
    [anon_sym___inline] = ACTIONS(3885),
    [anon_sym___inline__] = ACTIONS(3885),
    [anon_sym___forceinline] = ACTIONS(3885),
    [anon_sym_thread_local] = ACTIONS(3885),
    [anon_sym___thread] = ACTIONS(3885),
    [anon_sym_const] = ACTIONS(3885),
    [anon_sym_constexpr] = ACTIONS(3885),
    [anon_sym_volatile] = ACTIONS(3885),
    [anon_sym_restrict] = ACTIONS(3885),
    [anon_sym___restrict__] = ACTIONS(3885),
    [anon_sym__Atomic] = ACTIONS(3885),
    [anon_sym__Noreturn] = ACTIONS(3885),
    [anon_sym_noreturn] = ACTIONS(3885),
    [anon_sym__Nonnull] = ACTIONS(3885),
    [anon_sym_mutable] = ACTIONS(3885),
    [anon_sym_constinit] = ACTIONS(3885),
    [anon_sym_consteval] = ACTIONS(3885),
    [anon_sym_alignas] = ACTIONS(3885),
    [anon_sym__Alignas] = ACTIONS(3885),
    [sym_primitive_type] = ACTIONS(3885),
    [anon_sym_enum] = ACTIONS(3885),
    [anon_sym_class] = ACTIONS(3885),
    [anon_sym_struct] = ACTIONS(3885),
    [anon_sym_union] = ACTIONS(3885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3885),
    [anon_sym_let] = ACTIONS(3885),
    [anon_sym_This] = ACTIONS(3885),
    [anon_sym_decltype] = ACTIONS(3885),
    [anon_sym_explicit] = ACTIONS(3885),
    [anon_sym_typename] = ACTIONS(3885),
    [anon_sym_private] = ACTIONS(3885),
    [anon_sym_template] = ACTIONS(3885),
    [anon_sym_operator] = ACTIONS(3885),
    [anon_sym_friend] = ACTIONS(3885),
    [anon_sym_public] = ACTIONS(3885),
    [anon_sym_protected] = ACTIONS(3885),
    [anon_sym_static_assert] = ACTIONS(3885),
    [anon_sym_precise] = ACTIONS(3885),
    [anon_sym_shared] = ACTIONS(3885),
    [anon_sym_groupshared] = ACTIONS(3885),
    [anon_sym_uniform] = ACTIONS(3885),
    [anon_sym_row_major] = ACTIONS(3885),
    [anon_sym_column_major] = ACTIONS(3885),
    [anon_sym_globallycoherent] = ACTIONS(3885),
    [anon_sym_centroid] = ACTIONS(3885),
    [anon_sym_noperspective] = ACTIONS(3885),
    [anon_sym_nointerpolation] = ACTIONS(3885),
    [anon_sym_sample] = ACTIONS(3885),
    [anon_sym_linear] = ACTIONS(3885),
    [anon_sym_snorm] = ACTIONS(3885),
    [anon_sym_unorm] = ACTIONS(3885),
    [anon_sym_point] = ACTIONS(3885),
    [anon_sym_line] = ACTIONS(3885),
    [anon_sym_triangleadj] = ACTIONS(3885),
    [anon_sym_lineadj] = ACTIONS(3885),
    [anon_sym_triangle] = ACTIONS(3885),
    [anon_sym_interface] = ACTIONS(3885),
    [anon_sym_extension] = ACTIONS(3885),
    [anon_sym___init] = ACTIONS(3885),
    [anon_sym___subscript] = ACTIONS(3885),
    [anon_sym_property] = ACTIONS(3885),
    [anon_sym_associatedtype] = ACTIONS(3885),
  },
  [1758] = {
    [sym_identifier] = ACTIONS(3931),
    [aux_sym_preproc_def_token1] = ACTIONS(3931),
    [aux_sym_preproc_if_token1] = ACTIONS(3931),
    [aux_sym_preproc_if_token2] = ACTIONS(3931),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3931),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3931),
    [aux_sym_preproc_else_token1] = ACTIONS(3931),
    [aux_sym_preproc_elif_token1] = ACTIONS(3931),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3931),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3931),
    [sym_preproc_directive] = ACTIONS(3931),
    [anon_sym_LPAREN2] = ACTIONS(3933),
    [anon_sym_TILDE] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_SEMI] = ACTIONS(3933),
    [anon_sym___extension__] = ACTIONS(3931),
    [anon_sym_typedef] = ACTIONS(3931),
    [anon_sym_in] = ACTIONS(3931),
    [anon_sym_out] = ACTIONS(3931),
    [anon_sym_inout] = ACTIONS(3931),
    [anon_sym_virtual] = ACTIONS(3931),
    [anon_sym_extern] = ACTIONS(3931),
    [anon_sym___attribute__] = ACTIONS(3931),
    [anon_sym___attribute] = ACTIONS(3931),
    [anon_sym_using] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3933),
    [anon_sym___declspec] = ACTIONS(3931),
    [anon_sym___based] = ACTIONS(3931),
    [anon_sym_signed] = ACTIONS(3931),
    [anon_sym_unsigned] = ACTIONS(3931),
    [anon_sym_long] = ACTIONS(3931),
    [anon_sym_short] = ACTIONS(3931),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_static] = ACTIONS(3931),
    [anon_sym_register] = ACTIONS(3931),
    [anon_sym_inline] = ACTIONS(3931),
    [anon_sym___inline] = ACTIONS(3931),
    [anon_sym___inline__] = ACTIONS(3931),
    [anon_sym___forceinline] = ACTIONS(3931),
    [anon_sym_thread_local] = ACTIONS(3931),
    [anon_sym___thread] = ACTIONS(3931),
    [anon_sym_const] = ACTIONS(3931),
    [anon_sym_constexpr] = ACTIONS(3931),
    [anon_sym_volatile] = ACTIONS(3931),
    [anon_sym_restrict] = ACTIONS(3931),
    [anon_sym___restrict__] = ACTIONS(3931),
    [anon_sym__Atomic] = ACTIONS(3931),
    [anon_sym__Noreturn] = ACTIONS(3931),
    [anon_sym_noreturn] = ACTIONS(3931),
    [anon_sym__Nonnull] = ACTIONS(3931),
    [anon_sym_mutable] = ACTIONS(3931),
    [anon_sym_constinit] = ACTIONS(3931),
    [anon_sym_consteval] = ACTIONS(3931),
    [anon_sym_alignas] = ACTIONS(3931),
    [anon_sym__Alignas] = ACTIONS(3931),
    [sym_primitive_type] = ACTIONS(3931),
    [anon_sym_enum] = ACTIONS(3931),
    [anon_sym_class] = ACTIONS(3931),
    [anon_sym_struct] = ACTIONS(3931),
    [anon_sym_union] = ACTIONS(3931),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3931),
    [anon_sym_let] = ACTIONS(3931),
    [anon_sym_This] = ACTIONS(3931),
    [anon_sym_decltype] = ACTIONS(3931),
    [anon_sym_explicit] = ACTIONS(3931),
    [anon_sym_typename] = ACTIONS(3931),
    [anon_sym_private] = ACTIONS(3931),
    [anon_sym_template] = ACTIONS(3931),
    [anon_sym_operator] = ACTIONS(3931),
    [anon_sym_friend] = ACTIONS(3931),
    [anon_sym_public] = ACTIONS(3931),
    [anon_sym_protected] = ACTIONS(3931),
    [anon_sym_static_assert] = ACTIONS(3931),
    [anon_sym_precise] = ACTIONS(3931),
    [anon_sym_shared] = ACTIONS(3931),
    [anon_sym_groupshared] = ACTIONS(3931),
    [anon_sym_uniform] = ACTIONS(3931),
    [anon_sym_row_major] = ACTIONS(3931),
    [anon_sym_column_major] = ACTIONS(3931),
    [anon_sym_globallycoherent] = ACTIONS(3931),
    [anon_sym_centroid] = ACTIONS(3931),
    [anon_sym_noperspective] = ACTIONS(3931),
    [anon_sym_nointerpolation] = ACTIONS(3931),
    [anon_sym_sample] = ACTIONS(3931),
    [anon_sym_linear] = ACTIONS(3931),
    [anon_sym_snorm] = ACTIONS(3931),
    [anon_sym_unorm] = ACTIONS(3931),
    [anon_sym_point] = ACTIONS(3931),
    [anon_sym_line] = ACTIONS(3931),
    [anon_sym_triangleadj] = ACTIONS(3931),
    [anon_sym_lineadj] = ACTIONS(3931),
    [anon_sym_triangle] = ACTIONS(3931),
    [anon_sym_interface] = ACTIONS(3931),
    [anon_sym_extension] = ACTIONS(3931),
    [anon_sym___init] = ACTIONS(3931),
    [anon_sym___subscript] = ACTIONS(3931),
    [anon_sym_property] = ACTIONS(3931),
    [anon_sym_associatedtype] = ACTIONS(3931),
  },
  [1759] = {
    [sym_identifier] = ACTIONS(6290),
    [aux_sym_preproc_def_token1] = ACTIONS(6290),
    [aux_sym_preproc_if_token1] = ACTIONS(6290),
    [aux_sym_preproc_if_token2] = ACTIONS(6290),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6290),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6290),
    [aux_sym_preproc_else_token1] = ACTIONS(6290),
    [aux_sym_preproc_elif_token1] = ACTIONS(6290),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6290),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6290),
    [sym_preproc_directive] = ACTIONS(6290),
    [anon_sym_LPAREN2] = ACTIONS(6292),
    [anon_sym_TILDE] = ACTIONS(6292),
    [anon_sym_STAR] = ACTIONS(6292),
    [anon_sym_AMP_AMP] = ACTIONS(6292),
    [anon_sym_AMP] = ACTIONS(6290),
    [anon_sym_SEMI] = ACTIONS(6292),
    [anon_sym___extension__] = ACTIONS(6290),
    [anon_sym_typedef] = ACTIONS(6290),
    [anon_sym_in] = ACTIONS(6290),
    [anon_sym_out] = ACTIONS(6290),
    [anon_sym_inout] = ACTIONS(6290),
    [anon_sym_virtual] = ACTIONS(6290),
    [anon_sym_extern] = ACTIONS(6290),
    [anon_sym___attribute__] = ACTIONS(6290),
    [anon_sym___attribute] = ACTIONS(6290),
    [anon_sym_using] = ACTIONS(6290),
    [anon_sym_COLON_COLON] = ACTIONS(6292),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6292),
    [anon_sym___declspec] = ACTIONS(6290),
    [anon_sym___based] = ACTIONS(6290),
    [anon_sym_signed] = ACTIONS(6290),
    [anon_sym_unsigned] = ACTIONS(6290),
    [anon_sym_long] = ACTIONS(6290),
    [anon_sym_short] = ACTIONS(6290),
    [anon_sym_LBRACK] = ACTIONS(6290),
    [anon_sym_static] = ACTIONS(6290),
    [anon_sym_register] = ACTIONS(6290),
    [anon_sym_inline] = ACTIONS(6290),
    [anon_sym___inline] = ACTIONS(6290),
    [anon_sym___inline__] = ACTIONS(6290),
    [anon_sym___forceinline] = ACTIONS(6290),
    [anon_sym_thread_local] = ACTIONS(6290),
    [anon_sym___thread] = ACTIONS(6290),
    [anon_sym_const] = ACTIONS(6290),
    [anon_sym_constexpr] = ACTIONS(6290),
    [anon_sym_volatile] = ACTIONS(6290),
    [anon_sym_restrict] = ACTIONS(6290),
    [anon_sym___restrict__] = ACTIONS(6290),
    [anon_sym__Atomic] = ACTIONS(6290),
    [anon_sym__Noreturn] = ACTIONS(6290),
    [anon_sym_noreturn] = ACTIONS(6290),
    [anon_sym__Nonnull] = ACTIONS(6290),
    [anon_sym_mutable] = ACTIONS(6290),
    [anon_sym_constinit] = ACTIONS(6290),
    [anon_sym_consteval] = ACTIONS(6290),
    [anon_sym_alignas] = ACTIONS(6290),
    [anon_sym__Alignas] = ACTIONS(6290),
    [sym_primitive_type] = ACTIONS(6290),
    [anon_sym_enum] = ACTIONS(6290),
    [anon_sym_class] = ACTIONS(6290),
    [anon_sym_struct] = ACTIONS(6290),
    [anon_sym_union] = ACTIONS(6290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6290),
    [anon_sym_let] = ACTIONS(6290),
    [anon_sym_This] = ACTIONS(6290),
    [anon_sym_decltype] = ACTIONS(6290),
    [anon_sym_explicit] = ACTIONS(6290),
    [anon_sym_typename] = ACTIONS(6290),
    [anon_sym_private] = ACTIONS(6290),
    [anon_sym_template] = ACTIONS(6290),
    [anon_sym_operator] = ACTIONS(6290),
    [anon_sym_friend] = ACTIONS(6290),
    [anon_sym_public] = ACTIONS(6290),
    [anon_sym_protected] = ACTIONS(6290),
    [anon_sym_static_assert] = ACTIONS(6290),
    [anon_sym_precise] = ACTIONS(6290),
    [anon_sym_shared] = ACTIONS(6290),
    [anon_sym_groupshared] = ACTIONS(6290),
    [anon_sym_uniform] = ACTIONS(6290),
    [anon_sym_row_major] = ACTIONS(6290),
    [anon_sym_column_major] = ACTIONS(6290),
    [anon_sym_globallycoherent] = ACTIONS(6290),
    [anon_sym_centroid] = ACTIONS(6290),
    [anon_sym_noperspective] = ACTIONS(6290),
    [anon_sym_nointerpolation] = ACTIONS(6290),
    [anon_sym_sample] = ACTIONS(6290),
    [anon_sym_linear] = ACTIONS(6290),
    [anon_sym_snorm] = ACTIONS(6290),
    [anon_sym_unorm] = ACTIONS(6290),
    [anon_sym_point] = ACTIONS(6290),
    [anon_sym_line] = ACTIONS(6290),
    [anon_sym_triangleadj] = ACTIONS(6290),
    [anon_sym_lineadj] = ACTIONS(6290),
    [anon_sym_triangle] = ACTIONS(6290),
    [anon_sym_interface] = ACTIONS(6290),
    [anon_sym_extension] = ACTIONS(6290),
    [anon_sym___init] = ACTIONS(6290),
    [anon_sym___subscript] = ACTIONS(6290),
    [anon_sym_property] = ACTIONS(6290),
    [anon_sym_associatedtype] = ACTIONS(6290),
  },
  [1760] = {
    [sym_identifier] = ACTIONS(3677),
    [aux_sym_preproc_def_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token2] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3677),
    [aux_sym_preproc_else_token1] = ACTIONS(3677),
    [aux_sym_preproc_elif_token1] = ACTIONS(3677),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3677),
    [sym_preproc_directive] = ACTIONS(3677),
    [anon_sym_LPAREN2] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3679),
    [anon_sym_STAR] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_AMP] = ACTIONS(3677),
    [anon_sym_SEMI] = ACTIONS(3679),
    [anon_sym___extension__] = ACTIONS(3677),
    [anon_sym_typedef] = ACTIONS(3677),
    [anon_sym_in] = ACTIONS(3677),
    [anon_sym_out] = ACTIONS(3677),
    [anon_sym_inout] = ACTIONS(3677),
    [anon_sym_virtual] = ACTIONS(3677),
    [anon_sym_extern] = ACTIONS(3677),
    [anon_sym___attribute__] = ACTIONS(3677),
    [anon_sym___attribute] = ACTIONS(3677),
    [anon_sym_using] = ACTIONS(3677),
    [anon_sym_COLON_COLON] = ACTIONS(3679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3679),
    [anon_sym___declspec] = ACTIONS(3677),
    [anon_sym___based] = ACTIONS(3677),
    [anon_sym_signed] = ACTIONS(3677),
    [anon_sym_unsigned] = ACTIONS(3677),
    [anon_sym_long] = ACTIONS(3677),
    [anon_sym_short] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3677),
    [anon_sym_static] = ACTIONS(3677),
    [anon_sym_register] = ACTIONS(3677),
    [anon_sym_inline] = ACTIONS(3677),
    [anon_sym___inline] = ACTIONS(3677),
    [anon_sym___inline__] = ACTIONS(3677),
    [anon_sym___forceinline] = ACTIONS(3677),
    [anon_sym_thread_local] = ACTIONS(3677),
    [anon_sym___thread] = ACTIONS(3677),
    [anon_sym_const] = ACTIONS(3677),
    [anon_sym_constexpr] = ACTIONS(3677),
    [anon_sym_volatile] = ACTIONS(3677),
    [anon_sym_restrict] = ACTIONS(3677),
    [anon_sym___restrict__] = ACTIONS(3677),
    [anon_sym__Atomic] = ACTIONS(3677),
    [anon_sym__Noreturn] = ACTIONS(3677),
    [anon_sym_noreturn] = ACTIONS(3677),
    [anon_sym__Nonnull] = ACTIONS(3677),
    [anon_sym_mutable] = ACTIONS(3677),
    [anon_sym_constinit] = ACTIONS(3677),
    [anon_sym_consteval] = ACTIONS(3677),
    [anon_sym_alignas] = ACTIONS(3677),
    [anon_sym__Alignas] = ACTIONS(3677),
    [sym_primitive_type] = ACTIONS(3677),
    [anon_sym_enum] = ACTIONS(3677),
    [anon_sym_class] = ACTIONS(3677),
    [anon_sym_struct] = ACTIONS(3677),
    [anon_sym_union] = ACTIONS(3677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3677),
    [anon_sym_let] = ACTIONS(3677),
    [anon_sym_This] = ACTIONS(3677),
    [anon_sym_decltype] = ACTIONS(3677),
    [anon_sym_explicit] = ACTIONS(3677),
    [anon_sym_typename] = ACTIONS(3677),
    [anon_sym_private] = ACTIONS(3677),
    [anon_sym_template] = ACTIONS(3677),
    [anon_sym_operator] = ACTIONS(3677),
    [anon_sym_friend] = ACTIONS(3677),
    [anon_sym_public] = ACTIONS(3677),
    [anon_sym_protected] = ACTIONS(3677),
    [anon_sym_static_assert] = ACTIONS(3677),
    [anon_sym_precise] = ACTIONS(3677),
    [anon_sym_shared] = ACTIONS(3677),
    [anon_sym_groupshared] = ACTIONS(3677),
    [anon_sym_uniform] = ACTIONS(3677),
    [anon_sym_row_major] = ACTIONS(3677),
    [anon_sym_column_major] = ACTIONS(3677),
    [anon_sym_globallycoherent] = ACTIONS(3677),
    [anon_sym_centroid] = ACTIONS(3677),
    [anon_sym_noperspective] = ACTIONS(3677),
    [anon_sym_nointerpolation] = ACTIONS(3677),
    [anon_sym_sample] = ACTIONS(3677),
    [anon_sym_linear] = ACTIONS(3677),
    [anon_sym_snorm] = ACTIONS(3677),
    [anon_sym_unorm] = ACTIONS(3677),
    [anon_sym_point] = ACTIONS(3677),
    [anon_sym_line] = ACTIONS(3677),
    [anon_sym_triangleadj] = ACTIONS(3677),
    [anon_sym_lineadj] = ACTIONS(3677),
    [anon_sym_triangle] = ACTIONS(3677),
    [anon_sym_interface] = ACTIONS(3677),
    [anon_sym_extension] = ACTIONS(3677),
    [anon_sym___init] = ACTIONS(3677),
    [anon_sym___subscript] = ACTIONS(3677),
    [anon_sym_property] = ACTIONS(3677),
    [anon_sym_associatedtype] = ACTIONS(3677),
  },
  [1761] = {
    [sym_identifier] = ACTIONS(3677),
    [aux_sym_preproc_def_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token2] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3677),
    [aux_sym_preproc_else_token1] = ACTIONS(3677),
    [aux_sym_preproc_elif_token1] = ACTIONS(3677),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3677),
    [sym_preproc_directive] = ACTIONS(3677),
    [anon_sym_LPAREN2] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3679),
    [anon_sym_STAR] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_AMP] = ACTIONS(3677),
    [anon_sym_SEMI] = ACTIONS(3679),
    [anon_sym___extension__] = ACTIONS(3677),
    [anon_sym_typedef] = ACTIONS(3677),
    [anon_sym_in] = ACTIONS(3677),
    [anon_sym_out] = ACTIONS(3677),
    [anon_sym_inout] = ACTIONS(3677),
    [anon_sym_virtual] = ACTIONS(3677),
    [anon_sym_extern] = ACTIONS(3677),
    [anon_sym___attribute__] = ACTIONS(3677),
    [anon_sym___attribute] = ACTIONS(3677),
    [anon_sym_using] = ACTIONS(3677),
    [anon_sym_COLON_COLON] = ACTIONS(3679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3679),
    [anon_sym___declspec] = ACTIONS(3677),
    [anon_sym___based] = ACTIONS(3677),
    [anon_sym_signed] = ACTIONS(3677),
    [anon_sym_unsigned] = ACTIONS(3677),
    [anon_sym_long] = ACTIONS(3677),
    [anon_sym_short] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3677),
    [anon_sym_static] = ACTIONS(3677),
    [anon_sym_register] = ACTIONS(3677),
    [anon_sym_inline] = ACTIONS(3677),
    [anon_sym___inline] = ACTIONS(3677),
    [anon_sym___inline__] = ACTIONS(3677),
    [anon_sym___forceinline] = ACTIONS(3677),
    [anon_sym_thread_local] = ACTIONS(3677),
    [anon_sym___thread] = ACTIONS(3677),
    [anon_sym_const] = ACTIONS(3677),
    [anon_sym_constexpr] = ACTIONS(3677),
    [anon_sym_volatile] = ACTIONS(3677),
    [anon_sym_restrict] = ACTIONS(3677),
    [anon_sym___restrict__] = ACTIONS(3677),
    [anon_sym__Atomic] = ACTIONS(3677),
    [anon_sym__Noreturn] = ACTIONS(3677),
    [anon_sym_noreturn] = ACTIONS(3677),
    [anon_sym__Nonnull] = ACTIONS(3677),
    [anon_sym_mutable] = ACTIONS(3677),
    [anon_sym_constinit] = ACTIONS(3677),
    [anon_sym_consteval] = ACTIONS(3677),
    [anon_sym_alignas] = ACTIONS(3677),
    [anon_sym__Alignas] = ACTIONS(3677),
    [sym_primitive_type] = ACTIONS(3677),
    [anon_sym_enum] = ACTIONS(3677),
    [anon_sym_class] = ACTIONS(3677),
    [anon_sym_struct] = ACTIONS(3677),
    [anon_sym_union] = ACTIONS(3677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3677),
    [anon_sym_let] = ACTIONS(3677),
    [anon_sym_This] = ACTIONS(3677),
    [anon_sym_decltype] = ACTIONS(3677),
    [anon_sym_explicit] = ACTIONS(3677),
    [anon_sym_typename] = ACTIONS(3677),
    [anon_sym_private] = ACTIONS(3677),
    [anon_sym_template] = ACTIONS(3677),
    [anon_sym_operator] = ACTIONS(3677),
    [anon_sym_friend] = ACTIONS(3677),
    [anon_sym_public] = ACTIONS(3677),
    [anon_sym_protected] = ACTIONS(3677),
    [anon_sym_static_assert] = ACTIONS(3677),
    [anon_sym_precise] = ACTIONS(3677),
    [anon_sym_shared] = ACTIONS(3677),
    [anon_sym_groupshared] = ACTIONS(3677),
    [anon_sym_uniform] = ACTIONS(3677),
    [anon_sym_row_major] = ACTIONS(3677),
    [anon_sym_column_major] = ACTIONS(3677),
    [anon_sym_globallycoherent] = ACTIONS(3677),
    [anon_sym_centroid] = ACTIONS(3677),
    [anon_sym_noperspective] = ACTIONS(3677),
    [anon_sym_nointerpolation] = ACTIONS(3677),
    [anon_sym_sample] = ACTIONS(3677),
    [anon_sym_linear] = ACTIONS(3677),
    [anon_sym_snorm] = ACTIONS(3677),
    [anon_sym_unorm] = ACTIONS(3677),
    [anon_sym_point] = ACTIONS(3677),
    [anon_sym_line] = ACTIONS(3677),
    [anon_sym_triangleadj] = ACTIONS(3677),
    [anon_sym_lineadj] = ACTIONS(3677),
    [anon_sym_triangle] = ACTIONS(3677),
    [anon_sym_interface] = ACTIONS(3677),
    [anon_sym_extension] = ACTIONS(3677),
    [anon_sym___init] = ACTIONS(3677),
    [anon_sym___subscript] = ACTIONS(3677),
    [anon_sym_property] = ACTIONS(3677),
    [anon_sym_associatedtype] = ACTIONS(3677),
  },
  [1762] = {
    [sym_identifier] = ACTIONS(6294),
    [aux_sym_preproc_def_token1] = ACTIONS(6294),
    [aux_sym_preproc_if_token1] = ACTIONS(6294),
    [aux_sym_preproc_if_token2] = ACTIONS(6294),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6294),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6294),
    [aux_sym_preproc_else_token1] = ACTIONS(6294),
    [aux_sym_preproc_elif_token1] = ACTIONS(6294),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6294),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6294),
    [sym_preproc_directive] = ACTIONS(6294),
    [anon_sym_LPAREN2] = ACTIONS(6296),
    [anon_sym_TILDE] = ACTIONS(6296),
    [anon_sym_STAR] = ACTIONS(6296),
    [anon_sym_AMP_AMP] = ACTIONS(6296),
    [anon_sym_AMP] = ACTIONS(6294),
    [anon_sym_SEMI] = ACTIONS(6296),
    [anon_sym___extension__] = ACTIONS(6294),
    [anon_sym_typedef] = ACTIONS(6294),
    [anon_sym_in] = ACTIONS(6294),
    [anon_sym_out] = ACTIONS(6294),
    [anon_sym_inout] = ACTIONS(6294),
    [anon_sym_virtual] = ACTIONS(6294),
    [anon_sym_extern] = ACTIONS(6294),
    [anon_sym___attribute__] = ACTIONS(6294),
    [anon_sym___attribute] = ACTIONS(6294),
    [anon_sym_using] = ACTIONS(6294),
    [anon_sym_COLON_COLON] = ACTIONS(6296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6296),
    [anon_sym___declspec] = ACTIONS(6294),
    [anon_sym___based] = ACTIONS(6294),
    [anon_sym_signed] = ACTIONS(6294),
    [anon_sym_unsigned] = ACTIONS(6294),
    [anon_sym_long] = ACTIONS(6294),
    [anon_sym_short] = ACTIONS(6294),
    [anon_sym_LBRACK] = ACTIONS(6294),
    [anon_sym_static] = ACTIONS(6294),
    [anon_sym_register] = ACTIONS(6294),
    [anon_sym_inline] = ACTIONS(6294),
    [anon_sym___inline] = ACTIONS(6294),
    [anon_sym___inline__] = ACTIONS(6294),
    [anon_sym___forceinline] = ACTIONS(6294),
    [anon_sym_thread_local] = ACTIONS(6294),
    [anon_sym___thread] = ACTIONS(6294),
    [anon_sym_const] = ACTIONS(6294),
    [anon_sym_constexpr] = ACTIONS(6294),
    [anon_sym_volatile] = ACTIONS(6294),
    [anon_sym_restrict] = ACTIONS(6294),
    [anon_sym___restrict__] = ACTIONS(6294),
    [anon_sym__Atomic] = ACTIONS(6294),
    [anon_sym__Noreturn] = ACTIONS(6294),
    [anon_sym_noreturn] = ACTIONS(6294),
    [anon_sym__Nonnull] = ACTIONS(6294),
    [anon_sym_mutable] = ACTIONS(6294),
    [anon_sym_constinit] = ACTIONS(6294),
    [anon_sym_consteval] = ACTIONS(6294),
    [anon_sym_alignas] = ACTIONS(6294),
    [anon_sym__Alignas] = ACTIONS(6294),
    [sym_primitive_type] = ACTIONS(6294),
    [anon_sym_enum] = ACTIONS(6294),
    [anon_sym_class] = ACTIONS(6294),
    [anon_sym_struct] = ACTIONS(6294),
    [anon_sym_union] = ACTIONS(6294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6294),
    [anon_sym_let] = ACTIONS(6294),
    [anon_sym_This] = ACTIONS(6294),
    [anon_sym_decltype] = ACTIONS(6294),
    [anon_sym_explicit] = ACTIONS(6294),
    [anon_sym_typename] = ACTIONS(6294),
    [anon_sym_private] = ACTIONS(6294),
    [anon_sym_template] = ACTIONS(6294),
    [anon_sym_operator] = ACTIONS(6294),
    [anon_sym_friend] = ACTIONS(6294),
    [anon_sym_public] = ACTIONS(6294),
    [anon_sym_protected] = ACTIONS(6294),
    [anon_sym_static_assert] = ACTIONS(6294),
    [anon_sym_precise] = ACTIONS(6294),
    [anon_sym_shared] = ACTIONS(6294),
    [anon_sym_groupshared] = ACTIONS(6294),
    [anon_sym_uniform] = ACTIONS(6294),
    [anon_sym_row_major] = ACTIONS(6294),
    [anon_sym_column_major] = ACTIONS(6294),
    [anon_sym_globallycoherent] = ACTIONS(6294),
    [anon_sym_centroid] = ACTIONS(6294),
    [anon_sym_noperspective] = ACTIONS(6294),
    [anon_sym_nointerpolation] = ACTIONS(6294),
    [anon_sym_sample] = ACTIONS(6294),
    [anon_sym_linear] = ACTIONS(6294),
    [anon_sym_snorm] = ACTIONS(6294),
    [anon_sym_unorm] = ACTIONS(6294),
    [anon_sym_point] = ACTIONS(6294),
    [anon_sym_line] = ACTIONS(6294),
    [anon_sym_triangleadj] = ACTIONS(6294),
    [anon_sym_lineadj] = ACTIONS(6294),
    [anon_sym_triangle] = ACTIONS(6294),
    [anon_sym_interface] = ACTIONS(6294),
    [anon_sym_extension] = ACTIONS(6294),
    [anon_sym___init] = ACTIONS(6294),
    [anon_sym___subscript] = ACTIONS(6294),
    [anon_sym_property] = ACTIONS(6294),
    [anon_sym_associatedtype] = ACTIONS(6294),
  },
  [1763] = {
    [sym_identifier] = ACTIONS(3691),
    [aux_sym_preproc_def_token1] = ACTIONS(3691),
    [aux_sym_preproc_if_token1] = ACTIONS(3691),
    [aux_sym_preproc_if_token2] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3691),
    [aux_sym_preproc_else_token1] = ACTIONS(3691),
    [aux_sym_preproc_elif_token1] = ACTIONS(3691),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3691),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3691),
    [sym_preproc_directive] = ACTIONS(3691),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3693),
    [anon_sym_STAR] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_AMP] = ACTIONS(3691),
    [anon_sym_SEMI] = ACTIONS(3693),
    [anon_sym___extension__] = ACTIONS(3691),
    [anon_sym_typedef] = ACTIONS(3691),
    [anon_sym_in] = ACTIONS(3691),
    [anon_sym_out] = ACTIONS(3691),
    [anon_sym_inout] = ACTIONS(3691),
    [anon_sym_virtual] = ACTIONS(3691),
    [anon_sym_extern] = ACTIONS(3691),
    [anon_sym___attribute__] = ACTIONS(3691),
    [anon_sym___attribute] = ACTIONS(3691),
    [anon_sym_using] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3693),
    [anon_sym___declspec] = ACTIONS(3691),
    [anon_sym___based] = ACTIONS(3691),
    [anon_sym_signed] = ACTIONS(3691),
    [anon_sym_unsigned] = ACTIONS(3691),
    [anon_sym_long] = ACTIONS(3691),
    [anon_sym_short] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(3691),
    [anon_sym_static] = ACTIONS(3691),
    [anon_sym_register] = ACTIONS(3691),
    [anon_sym_inline] = ACTIONS(3691),
    [anon_sym___inline] = ACTIONS(3691),
    [anon_sym___inline__] = ACTIONS(3691),
    [anon_sym___forceinline] = ACTIONS(3691),
    [anon_sym_thread_local] = ACTIONS(3691),
    [anon_sym___thread] = ACTIONS(3691),
    [anon_sym_const] = ACTIONS(3691),
    [anon_sym_constexpr] = ACTIONS(3691),
    [anon_sym_volatile] = ACTIONS(3691),
    [anon_sym_restrict] = ACTIONS(3691),
    [anon_sym___restrict__] = ACTIONS(3691),
    [anon_sym__Atomic] = ACTIONS(3691),
    [anon_sym__Noreturn] = ACTIONS(3691),
    [anon_sym_noreturn] = ACTIONS(3691),
    [anon_sym__Nonnull] = ACTIONS(3691),
    [anon_sym_mutable] = ACTIONS(3691),
    [anon_sym_constinit] = ACTIONS(3691),
    [anon_sym_consteval] = ACTIONS(3691),
    [anon_sym_alignas] = ACTIONS(3691),
    [anon_sym__Alignas] = ACTIONS(3691),
    [sym_primitive_type] = ACTIONS(3691),
    [anon_sym_enum] = ACTIONS(3691),
    [anon_sym_class] = ACTIONS(3691),
    [anon_sym_struct] = ACTIONS(3691),
    [anon_sym_union] = ACTIONS(3691),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3691),
    [anon_sym_let] = ACTIONS(3691),
    [anon_sym_This] = ACTIONS(3691),
    [anon_sym_decltype] = ACTIONS(3691),
    [anon_sym_explicit] = ACTIONS(3691),
    [anon_sym_typename] = ACTIONS(3691),
    [anon_sym_private] = ACTIONS(3691),
    [anon_sym_template] = ACTIONS(3691),
    [anon_sym_operator] = ACTIONS(3691),
    [anon_sym_friend] = ACTIONS(3691),
    [anon_sym_public] = ACTIONS(3691),
    [anon_sym_protected] = ACTIONS(3691),
    [anon_sym_static_assert] = ACTIONS(3691),
    [anon_sym_precise] = ACTIONS(3691),
    [anon_sym_shared] = ACTIONS(3691),
    [anon_sym_groupshared] = ACTIONS(3691),
    [anon_sym_uniform] = ACTIONS(3691),
    [anon_sym_row_major] = ACTIONS(3691),
    [anon_sym_column_major] = ACTIONS(3691),
    [anon_sym_globallycoherent] = ACTIONS(3691),
    [anon_sym_centroid] = ACTIONS(3691),
    [anon_sym_noperspective] = ACTIONS(3691),
    [anon_sym_nointerpolation] = ACTIONS(3691),
    [anon_sym_sample] = ACTIONS(3691),
    [anon_sym_linear] = ACTIONS(3691),
    [anon_sym_snorm] = ACTIONS(3691),
    [anon_sym_unorm] = ACTIONS(3691),
    [anon_sym_point] = ACTIONS(3691),
    [anon_sym_line] = ACTIONS(3691),
    [anon_sym_triangleadj] = ACTIONS(3691),
    [anon_sym_lineadj] = ACTIONS(3691),
    [anon_sym_triangle] = ACTIONS(3691),
    [anon_sym_interface] = ACTIONS(3691),
    [anon_sym_extension] = ACTIONS(3691),
    [anon_sym___init] = ACTIONS(3691),
    [anon_sym___subscript] = ACTIONS(3691),
    [anon_sym_property] = ACTIONS(3691),
    [anon_sym_associatedtype] = ACTIONS(3691),
  },
  [1764] = {
    [sym_identifier] = ACTIONS(3695),
    [aux_sym_preproc_def_token1] = ACTIONS(3695),
    [aux_sym_preproc_if_token1] = ACTIONS(3695),
    [aux_sym_preproc_if_token2] = ACTIONS(3695),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3695),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3695),
    [aux_sym_preproc_else_token1] = ACTIONS(3695),
    [aux_sym_preproc_elif_token1] = ACTIONS(3695),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3695),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3695),
    [sym_preproc_directive] = ACTIONS(3695),
    [anon_sym_LPAREN2] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3697),
    [anon_sym_STAR] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3695),
    [anon_sym_SEMI] = ACTIONS(3697),
    [anon_sym___extension__] = ACTIONS(3695),
    [anon_sym_typedef] = ACTIONS(3695),
    [anon_sym_in] = ACTIONS(3695),
    [anon_sym_out] = ACTIONS(3695),
    [anon_sym_inout] = ACTIONS(3695),
    [anon_sym_virtual] = ACTIONS(3695),
    [anon_sym_extern] = ACTIONS(3695),
    [anon_sym___attribute__] = ACTIONS(3695),
    [anon_sym___attribute] = ACTIONS(3695),
    [anon_sym_using] = ACTIONS(3695),
    [anon_sym_COLON_COLON] = ACTIONS(3697),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3697),
    [anon_sym___declspec] = ACTIONS(3695),
    [anon_sym___based] = ACTIONS(3695),
    [anon_sym_signed] = ACTIONS(3695),
    [anon_sym_unsigned] = ACTIONS(3695),
    [anon_sym_long] = ACTIONS(3695),
    [anon_sym_short] = ACTIONS(3695),
    [anon_sym_LBRACK] = ACTIONS(3695),
    [anon_sym_static] = ACTIONS(3695),
    [anon_sym_register] = ACTIONS(3695),
    [anon_sym_inline] = ACTIONS(3695),
    [anon_sym___inline] = ACTIONS(3695),
    [anon_sym___inline__] = ACTIONS(3695),
    [anon_sym___forceinline] = ACTIONS(3695),
    [anon_sym_thread_local] = ACTIONS(3695),
    [anon_sym___thread] = ACTIONS(3695),
    [anon_sym_const] = ACTIONS(3695),
    [anon_sym_constexpr] = ACTIONS(3695),
    [anon_sym_volatile] = ACTIONS(3695),
    [anon_sym_restrict] = ACTIONS(3695),
    [anon_sym___restrict__] = ACTIONS(3695),
    [anon_sym__Atomic] = ACTIONS(3695),
    [anon_sym__Noreturn] = ACTIONS(3695),
    [anon_sym_noreturn] = ACTIONS(3695),
    [anon_sym__Nonnull] = ACTIONS(3695),
    [anon_sym_mutable] = ACTIONS(3695),
    [anon_sym_constinit] = ACTIONS(3695),
    [anon_sym_consteval] = ACTIONS(3695),
    [anon_sym_alignas] = ACTIONS(3695),
    [anon_sym__Alignas] = ACTIONS(3695),
    [sym_primitive_type] = ACTIONS(3695),
    [anon_sym_enum] = ACTIONS(3695),
    [anon_sym_class] = ACTIONS(3695),
    [anon_sym_struct] = ACTIONS(3695),
    [anon_sym_union] = ACTIONS(3695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3695),
    [anon_sym_let] = ACTIONS(3695),
    [anon_sym_This] = ACTIONS(3695),
    [anon_sym_decltype] = ACTIONS(3695),
    [anon_sym_explicit] = ACTIONS(3695),
    [anon_sym_typename] = ACTIONS(3695),
    [anon_sym_private] = ACTIONS(3695),
    [anon_sym_template] = ACTIONS(3695),
    [anon_sym_operator] = ACTIONS(3695),
    [anon_sym_friend] = ACTIONS(3695),
    [anon_sym_public] = ACTIONS(3695),
    [anon_sym_protected] = ACTIONS(3695),
    [anon_sym_static_assert] = ACTIONS(3695),
    [anon_sym_precise] = ACTIONS(3695),
    [anon_sym_shared] = ACTIONS(3695),
    [anon_sym_groupshared] = ACTIONS(3695),
    [anon_sym_uniform] = ACTIONS(3695),
    [anon_sym_row_major] = ACTIONS(3695),
    [anon_sym_column_major] = ACTIONS(3695),
    [anon_sym_globallycoherent] = ACTIONS(3695),
    [anon_sym_centroid] = ACTIONS(3695),
    [anon_sym_noperspective] = ACTIONS(3695),
    [anon_sym_nointerpolation] = ACTIONS(3695),
    [anon_sym_sample] = ACTIONS(3695),
    [anon_sym_linear] = ACTIONS(3695),
    [anon_sym_snorm] = ACTIONS(3695),
    [anon_sym_unorm] = ACTIONS(3695),
    [anon_sym_point] = ACTIONS(3695),
    [anon_sym_line] = ACTIONS(3695),
    [anon_sym_triangleadj] = ACTIONS(3695),
    [anon_sym_lineadj] = ACTIONS(3695),
    [anon_sym_triangle] = ACTIONS(3695),
    [anon_sym_interface] = ACTIONS(3695),
    [anon_sym_extension] = ACTIONS(3695),
    [anon_sym___init] = ACTIONS(3695),
    [anon_sym___subscript] = ACTIONS(3695),
    [anon_sym_property] = ACTIONS(3695),
    [anon_sym_associatedtype] = ACTIONS(3695),
  },
  [1765] = {
    [sym_identifier] = ACTIONS(6298),
    [anon_sym_COMMA] = ACTIONS(6300),
    [anon_sym_RPAREN] = ACTIONS(6300),
    [anon_sym_LPAREN2] = ACTIONS(6300),
    [anon_sym_TILDE] = ACTIONS(6300),
    [anon_sym_STAR] = ACTIONS(6300),
    [anon_sym_PIPE_PIPE] = ACTIONS(6300),
    [anon_sym_AMP_AMP] = ACTIONS(6300),
    [anon_sym_AMP] = ACTIONS(6298),
    [anon_sym___extension__] = ACTIONS(6298),
    [anon_sym_in] = ACTIONS(6298),
    [anon_sym_out] = ACTIONS(6298),
    [anon_sym_inout] = ACTIONS(6298),
    [anon_sym_virtual] = ACTIONS(6298),
    [anon_sym_extern] = ACTIONS(6298),
    [anon_sym___attribute__] = ACTIONS(6298),
    [anon_sym___attribute] = ACTIONS(6298),
    [anon_sym_using] = ACTIONS(6298),
    [anon_sym_COLON_COLON] = ACTIONS(6300),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6300),
    [anon_sym___declspec] = ACTIONS(6298),
    [anon_sym___based] = ACTIONS(6298),
    [anon_sym___cdecl] = ACTIONS(6298),
    [anon_sym___clrcall] = ACTIONS(6298),
    [anon_sym___stdcall] = ACTIONS(6298),
    [anon_sym___fastcall] = ACTIONS(6298),
    [anon_sym___thiscall] = ACTIONS(6298),
    [anon_sym___vectorcall] = ACTIONS(6298),
    [anon_sym_LBRACE] = ACTIONS(6300),
    [anon_sym_signed] = ACTIONS(6298),
    [anon_sym_unsigned] = ACTIONS(6298),
    [anon_sym_long] = ACTIONS(6298),
    [anon_sym_short] = ACTIONS(6298),
    [anon_sym_LBRACK] = ACTIONS(6298),
    [anon_sym_static] = ACTIONS(6298),
    [anon_sym_register] = ACTIONS(6298),
    [anon_sym_inline] = ACTIONS(6298),
    [anon_sym___inline] = ACTIONS(6298),
    [anon_sym___inline__] = ACTIONS(6298),
    [anon_sym___forceinline] = ACTIONS(6298),
    [anon_sym_thread_local] = ACTIONS(6298),
    [anon_sym___thread] = ACTIONS(6298),
    [anon_sym_const] = ACTIONS(6298),
    [anon_sym_constexpr] = ACTIONS(6298),
    [anon_sym_volatile] = ACTIONS(6298),
    [anon_sym_restrict] = ACTIONS(6298),
    [anon_sym___restrict__] = ACTIONS(6298),
    [anon_sym__Atomic] = ACTIONS(6298),
    [anon_sym__Noreturn] = ACTIONS(6298),
    [anon_sym_noreturn] = ACTIONS(6298),
    [anon_sym__Nonnull] = ACTIONS(6298),
    [anon_sym_mutable] = ACTIONS(6298),
    [anon_sym_constinit] = ACTIONS(6298),
    [anon_sym_consteval] = ACTIONS(6298),
    [anon_sym_alignas] = ACTIONS(6298),
    [anon_sym__Alignas] = ACTIONS(6298),
    [sym_primitive_type] = ACTIONS(6298),
    [anon_sym_enum] = ACTIONS(6298),
    [anon_sym_class] = ACTIONS(6298),
    [anon_sym_struct] = ACTIONS(6298),
    [anon_sym_union] = ACTIONS(6298),
    [anon_sym_or] = ACTIONS(6298),
    [anon_sym_and] = ACTIONS(6298),
    [anon_sym_DASH_GT] = ACTIONS(6300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6298),
    [anon_sym_let] = ACTIONS(6298),
    [anon_sym_This] = ACTIONS(6298),
    [anon_sym_decltype] = ACTIONS(6298),
    [anon_sym_final] = ACTIONS(6298),
    [anon_sym_override] = ACTIONS(6298),
    [anon_sym_explicit] = ACTIONS(6298),
    [anon_sym_typename] = ACTIONS(6298),
    [anon_sym_template] = ACTIONS(6298),
    [anon_sym_operator] = ACTIONS(6298),
    [anon_sym_friend] = ACTIONS(6298),
    [anon_sym_noexcept] = ACTIONS(6298),
    [anon_sym_throw] = ACTIONS(6298),
    [anon_sym_concept] = ACTIONS(6298),
    [anon_sym_requires] = ACTIONS(6298),
    [anon_sym_precise] = ACTIONS(6298),
    [anon_sym_shared] = ACTIONS(6298),
    [anon_sym_groupshared] = ACTIONS(6298),
    [anon_sym_uniform] = ACTIONS(6298),
    [anon_sym_row_major] = ACTIONS(6298),
    [anon_sym_column_major] = ACTIONS(6298),
    [anon_sym_globallycoherent] = ACTIONS(6298),
    [anon_sym_centroid] = ACTIONS(6298),
    [anon_sym_noperspective] = ACTIONS(6298),
    [anon_sym_nointerpolation] = ACTIONS(6298),
    [anon_sym_sample] = ACTIONS(6298),
    [anon_sym_linear] = ACTIONS(6298),
    [anon_sym_snorm] = ACTIONS(6298),
    [anon_sym_unorm] = ACTIONS(6298),
    [anon_sym_point] = ACTIONS(6298),
    [anon_sym_line] = ACTIONS(6298),
    [anon_sym_triangleadj] = ACTIONS(6298),
    [anon_sym_lineadj] = ACTIONS(6298),
    [anon_sym_triangle] = ACTIONS(6298),
    [anon_sym_interface] = ACTIONS(6298),
    [anon_sym_extension] = ACTIONS(6298),
    [anon_sym_where] = ACTIONS(6298),
  },
  [1766] = {
    [sym_identifier] = ACTIONS(3699),
    [aux_sym_preproc_def_token1] = ACTIONS(3699),
    [aux_sym_preproc_if_token1] = ACTIONS(3699),
    [aux_sym_preproc_if_token2] = ACTIONS(3699),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3699),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3699),
    [aux_sym_preproc_else_token1] = ACTIONS(3699),
    [aux_sym_preproc_elif_token1] = ACTIONS(3699),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3699),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3699),
    [sym_preproc_directive] = ACTIONS(3699),
    [anon_sym_LPAREN2] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3701),
    [anon_sym_AMP_AMP] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(3701),
    [anon_sym___extension__] = ACTIONS(3699),
    [anon_sym_typedef] = ACTIONS(3699),
    [anon_sym_in] = ACTIONS(3699),
    [anon_sym_out] = ACTIONS(3699),
    [anon_sym_inout] = ACTIONS(3699),
    [anon_sym_virtual] = ACTIONS(3699),
    [anon_sym_extern] = ACTIONS(3699),
    [anon_sym___attribute__] = ACTIONS(3699),
    [anon_sym___attribute] = ACTIONS(3699),
    [anon_sym_using] = ACTIONS(3699),
    [anon_sym_COLON_COLON] = ACTIONS(3701),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3701),
    [anon_sym___declspec] = ACTIONS(3699),
    [anon_sym___based] = ACTIONS(3699),
    [anon_sym_signed] = ACTIONS(3699),
    [anon_sym_unsigned] = ACTIONS(3699),
    [anon_sym_long] = ACTIONS(3699),
    [anon_sym_short] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(3699),
    [anon_sym_static] = ACTIONS(3699),
    [anon_sym_register] = ACTIONS(3699),
    [anon_sym_inline] = ACTIONS(3699),
    [anon_sym___inline] = ACTIONS(3699),
    [anon_sym___inline__] = ACTIONS(3699),
    [anon_sym___forceinline] = ACTIONS(3699),
    [anon_sym_thread_local] = ACTIONS(3699),
    [anon_sym___thread] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3699),
    [anon_sym_constexpr] = ACTIONS(3699),
    [anon_sym_volatile] = ACTIONS(3699),
    [anon_sym_restrict] = ACTIONS(3699),
    [anon_sym___restrict__] = ACTIONS(3699),
    [anon_sym__Atomic] = ACTIONS(3699),
    [anon_sym__Noreturn] = ACTIONS(3699),
    [anon_sym_noreturn] = ACTIONS(3699),
    [anon_sym__Nonnull] = ACTIONS(3699),
    [anon_sym_mutable] = ACTIONS(3699),
    [anon_sym_constinit] = ACTIONS(3699),
    [anon_sym_consteval] = ACTIONS(3699),
    [anon_sym_alignas] = ACTIONS(3699),
    [anon_sym__Alignas] = ACTIONS(3699),
    [sym_primitive_type] = ACTIONS(3699),
    [anon_sym_enum] = ACTIONS(3699),
    [anon_sym_class] = ACTIONS(3699),
    [anon_sym_struct] = ACTIONS(3699),
    [anon_sym_union] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3699),
    [anon_sym_let] = ACTIONS(3699),
    [anon_sym_This] = ACTIONS(3699),
    [anon_sym_decltype] = ACTIONS(3699),
    [anon_sym_explicit] = ACTIONS(3699),
    [anon_sym_typename] = ACTIONS(3699),
    [anon_sym_private] = ACTIONS(3699),
    [anon_sym_template] = ACTIONS(3699),
    [anon_sym_operator] = ACTIONS(3699),
    [anon_sym_friend] = ACTIONS(3699),
    [anon_sym_public] = ACTIONS(3699),
    [anon_sym_protected] = ACTIONS(3699),
    [anon_sym_static_assert] = ACTIONS(3699),
    [anon_sym_precise] = ACTIONS(3699),
    [anon_sym_shared] = ACTIONS(3699),
    [anon_sym_groupshared] = ACTIONS(3699),
    [anon_sym_uniform] = ACTIONS(3699),
    [anon_sym_row_major] = ACTIONS(3699),
    [anon_sym_column_major] = ACTIONS(3699),
    [anon_sym_globallycoherent] = ACTIONS(3699),
    [anon_sym_centroid] = ACTIONS(3699),
    [anon_sym_noperspective] = ACTIONS(3699),
    [anon_sym_nointerpolation] = ACTIONS(3699),
    [anon_sym_sample] = ACTIONS(3699),
    [anon_sym_linear] = ACTIONS(3699),
    [anon_sym_snorm] = ACTIONS(3699),
    [anon_sym_unorm] = ACTIONS(3699),
    [anon_sym_point] = ACTIONS(3699),
    [anon_sym_line] = ACTIONS(3699),
    [anon_sym_triangleadj] = ACTIONS(3699),
    [anon_sym_lineadj] = ACTIONS(3699),
    [anon_sym_triangle] = ACTIONS(3699),
    [anon_sym_interface] = ACTIONS(3699),
    [anon_sym_extension] = ACTIONS(3699),
    [anon_sym___init] = ACTIONS(3699),
    [anon_sym___subscript] = ACTIONS(3699),
    [anon_sym_property] = ACTIONS(3699),
    [anon_sym_associatedtype] = ACTIONS(3699),
  },
  [1767] = {
    [sym_identifier] = ACTIONS(6302),
    [anon_sym_COMMA] = ACTIONS(6304),
    [anon_sym_RPAREN] = ACTIONS(6304),
    [anon_sym_LPAREN2] = ACTIONS(6304),
    [anon_sym_TILDE] = ACTIONS(6304),
    [anon_sym_STAR] = ACTIONS(6304),
    [anon_sym_PIPE_PIPE] = ACTIONS(6304),
    [anon_sym_AMP_AMP] = ACTIONS(6304),
    [anon_sym_AMP] = ACTIONS(6302),
    [anon_sym___extension__] = ACTIONS(6302),
    [anon_sym_in] = ACTIONS(6302),
    [anon_sym_out] = ACTIONS(6302),
    [anon_sym_inout] = ACTIONS(6302),
    [anon_sym_virtual] = ACTIONS(6302),
    [anon_sym_extern] = ACTIONS(6302),
    [anon_sym___attribute__] = ACTIONS(6302),
    [anon_sym___attribute] = ACTIONS(6302),
    [anon_sym_using] = ACTIONS(6302),
    [anon_sym_COLON_COLON] = ACTIONS(6304),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6304),
    [anon_sym___declspec] = ACTIONS(6302),
    [anon_sym___based] = ACTIONS(6302),
    [anon_sym___cdecl] = ACTIONS(6302),
    [anon_sym___clrcall] = ACTIONS(6302),
    [anon_sym___stdcall] = ACTIONS(6302),
    [anon_sym___fastcall] = ACTIONS(6302),
    [anon_sym___thiscall] = ACTIONS(6302),
    [anon_sym___vectorcall] = ACTIONS(6302),
    [anon_sym_LBRACE] = ACTIONS(6304),
    [anon_sym_signed] = ACTIONS(6302),
    [anon_sym_unsigned] = ACTIONS(6302),
    [anon_sym_long] = ACTIONS(6302),
    [anon_sym_short] = ACTIONS(6302),
    [anon_sym_LBRACK] = ACTIONS(6302),
    [anon_sym_static] = ACTIONS(6302),
    [anon_sym_register] = ACTIONS(6302),
    [anon_sym_inline] = ACTIONS(6302),
    [anon_sym___inline] = ACTIONS(6302),
    [anon_sym___inline__] = ACTIONS(6302),
    [anon_sym___forceinline] = ACTIONS(6302),
    [anon_sym_thread_local] = ACTIONS(6302),
    [anon_sym___thread] = ACTIONS(6302),
    [anon_sym_const] = ACTIONS(6302),
    [anon_sym_constexpr] = ACTIONS(6302),
    [anon_sym_volatile] = ACTIONS(6302),
    [anon_sym_restrict] = ACTIONS(6302),
    [anon_sym___restrict__] = ACTIONS(6302),
    [anon_sym__Atomic] = ACTIONS(6302),
    [anon_sym__Noreturn] = ACTIONS(6302),
    [anon_sym_noreturn] = ACTIONS(6302),
    [anon_sym__Nonnull] = ACTIONS(6302),
    [anon_sym_mutable] = ACTIONS(6302),
    [anon_sym_constinit] = ACTIONS(6302),
    [anon_sym_consteval] = ACTIONS(6302),
    [anon_sym_alignas] = ACTIONS(6302),
    [anon_sym__Alignas] = ACTIONS(6302),
    [sym_primitive_type] = ACTIONS(6302),
    [anon_sym_enum] = ACTIONS(6302),
    [anon_sym_class] = ACTIONS(6302),
    [anon_sym_struct] = ACTIONS(6302),
    [anon_sym_union] = ACTIONS(6302),
    [anon_sym_or] = ACTIONS(6302),
    [anon_sym_and] = ACTIONS(6302),
    [anon_sym_DASH_GT] = ACTIONS(6304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6302),
    [anon_sym_let] = ACTIONS(6302),
    [anon_sym_This] = ACTIONS(6302),
    [anon_sym_decltype] = ACTIONS(6302),
    [anon_sym_final] = ACTIONS(6302),
    [anon_sym_override] = ACTIONS(6302),
    [anon_sym_explicit] = ACTIONS(6302),
    [anon_sym_typename] = ACTIONS(6302),
    [anon_sym_template] = ACTIONS(6302),
    [anon_sym_operator] = ACTIONS(6302),
    [anon_sym_friend] = ACTIONS(6302),
    [anon_sym_noexcept] = ACTIONS(6302),
    [anon_sym_throw] = ACTIONS(6302),
    [anon_sym_concept] = ACTIONS(6302),
    [anon_sym_requires] = ACTIONS(6302),
    [anon_sym_precise] = ACTIONS(6302),
    [anon_sym_shared] = ACTIONS(6302),
    [anon_sym_groupshared] = ACTIONS(6302),
    [anon_sym_uniform] = ACTIONS(6302),
    [anon_sym_row_major] = ACTIONS(6302),
    [anon_sym_column_major] = ACTIONS(6302),
    [anon_sym_globallycoherent] = ACTIONS(6302),
    [anon_sym_centroid] = ACTIONS(6302),
    [anon_sym_noperspective] = ACTIONS(6302),
    [anon_sym_nointerpolation] = ACTIONS(6302),
    [anon_sym_sample] = ACTIONS(6302),
    [anon_sym_linear] = ACTIONS(6302),
    [anon_sym_snorm] = ACTIONS(6302),
    [anon_sym_unorm] = ACTIONS(6302),
    [anon_sym_point] = ACTIONS(6302),
    [anon_sym_line] = ACTIONS(6302),
    [anon_sym_triangleadj] = ACTIONS(6302),
    [anon_sym_lineadj] = ACTIONS(6302),
    [anon_sym_triangle] = ACTIONS(6302),
    [anon_sym_interface] = ACTIONS(6302),
    [anon_sym_extension] = ACTIONS(6302),
    [anon_sym_where] = ACTIONS(6302),
  },
  [1768] = {
    [sym_identifier] = ACTIONS(6306),
    [aux_sym_preproc_def_token1] = ACTIONS(6306),
    [aux_sym_preproc_if_token1] = ACTIONS(6306),
    [aux_sym_preproc_if_token2] = ACTIONS(6306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6306),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6306),
    [aux_sym_preproc_else_token1] = ACTIONS(6306),
    [aux_sym_preproc_elif_token1] = ACTIONS(6306),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6306),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6306),
    [sym_preproc_directive] = ACTIONS(6306),
    [anon_sym_LPAREN2] = ACTIONS(6308),
    [anon_sym_TILDE] = ACTIONS(6308),
    [anon_sym_STAR] = ACTIONS(6308),
    [anon_sym_AMP_AMP] = ACTIONS(6308),
    [anon_sym_AMP] = ACTIONS(6306),
    [anon_sym_SEMI] = ACTIONS(6308),
    [anon_sym___extension__] = ACTIONS(6306),
    [anon_sym_typedef] = ACTIONS(6306),
    [anon_sym_in] = ACTIONS(6306),
    [anon_sym_out] = ACTIONS(6306),
    [anon_sym_inout] = ACTIONS(6306),
    [anon_sym_virtual] = ACTIONS(6306),
    [anon_sym_extern] = ACTIONS(6306),
    [anon_sym___attribute__] = ACTIONS(6306),
    [anon_sym___attribute] = ACTIONS(6306),
    [anon_sym_using] = ACTIONS(6306),
    [anon_sym_COLON_COLON] = ACTIONS(6308),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6308),
    [anon_sym___declspec] = ACTIONS(6306),
    [anon_sym___based] = ACTIONS(6306),
    [anon_sym_signed] = ACTIONS(6306),
    [anon_sym_unsigned] = ACTIONS(6306),
    [anon_sym_long] = ACTIONS(6306),
    [anon_sym_short] = ACTIONS(6306),
    [anon_sym_LBRACK] = ACTIONS(6306),
    [anon_sym_static] = ACTIONS(6306),
    [anon_sym_register] = ACTIONS(6306),
    [anon_sym_inline] = ACTIONS(6306),
    [anon_sym___inline] = ACTIONS(6306),
    [anon_sym___inline__] = ACTIONS(6306),
    [anon_sym___forceinline] = ACTIONS(6306),
    [anon_sym_thread_local] = ACTIONS(6306),
    [anon_sym___thread] = ACTIONS(6306),
    [anon_sym_const] = ACTIONS(6306),
    [anon_sym_constexpr] = ACTIONS(6306),
    [anon_sym_volatile] = ACTIONS(6306),
    [anon_sym_restrict] = ACTIONS(6306),
    [anon_sym___restrict__] = ACTIONS(6306),
    [anon_sym__Atomic] = ACTIONS(6306),
    [anon_sym__Noreturn] = ACTIONS(6306),
    [anon_sym_noreturn] = ACTIONS(6306),
    [anon_sym__Nonnull] = ACTIONS(6306),
    [anon_sym_mutable] = ACTIONS(6306),
    [anon_sym_constinit] = ACTIONS(6306),
    [anon_sym_consteval] = ACTIONS(6306),
    [anon_sym_alignas] = ACTIONS(6306),
    [anon_sym__Alignas] = ACTIONS(6306),
    [sym_primitive_type] = ACTIONS(6306),
    [anon_sym_enum] = ACTIONS(6306),
    [anon_sym_class] = ACTIONS(6306),
    [anon_sym_struct] = ACTIONS(6306),
    [anon_sym_union] = ACTIONS(6306),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6306),
    [anon_sym_let] = ACTIONS(6306),
    [anon_sym_This] = ACTIONS(6306),
    [anon_sym_decltype] = ACTIONS(6306),
    [anon_sym_explicit] = ACTIONS(6306),
    [anon_sym_typename] = ACTIONS(6306),
    [anon_sym_private] = ACTIONS(6306),
    [anon_sym_template] = ACTIONS(6306),
    [anon_sym_operator] = ACTIONS(6306),
    [anon_sym_friend] = ACTIONS(6306),
    [anon_sym_public] = ACTIONS(6306),
    [anon_sym_protected] = ACTIONS(6306),
    [anon_sym_static_assert] = ACTIONS(6306),
    [anon_sym_precise] = ACTIONS(6306),
    [anon_sym_shared] = ACTIONS(6306),
    [anon_sym_groupshared] = ACTIONS(6306),
    [anon_sym_uniform] = ACTIONS(6306),
    [anon_sym_row_major] = ACTIONS(6306),
    [anon_sym_column_major] = ACTIONS(6306),
    [anon_sym_globallycoherent] = ACTIONS(6306),
    [anon_sym_centroid] = ACTIONS(6306),
    [anon_sym_noperspective] = ACTIONS(6306),
    [anon_sym_nointerpolation] = ACTIONS(6306),
    [anon_sym_sample] = ACTIONS(6306),
    [anon_sym_linear] = ACTIONS(6306),
    [anon_sym_snorm] = ACTIONS(6306),
    [anon_sym_unorm] = ACTIONS(6306),
    [anon_sym_point] = ACTIONS(6306),
    [anon_sym_line] = ACTIONS(6306),
    [anon_sym_triangleadj] = ACTIONS(6306),
    [anon_sym_lineadj] = ACTIONS(6306),
    [anon_sym_triangle] = ACTIONS(6306),
    [anon_sym_interface] = ACTIONS(6306),
    [anon_sym_extension] = ACTIONS(6306),
    [anon_sym___init] = ACTIONS(6306),
    [anon_sym___subscript] = ACTIONS(6306),
    [anon_sym_property] = ACTIONS(6306),
    [anon_sym_associatedtype] = ACTIONS(6306),
  },
  [1769] = {
    [sym_identifier] = ACTIONS(6310),
    [aux_sym_preproc_def_token1] = ACTIONS(6310),
    [aux_sym_preproc_if_token1] = ACTIONS(6310),
    [aux_sym_preproc_if_token2] = ACTIONS(6310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6310),
    [aux_sym_preproc_else_token1] = ACTIONS(6310),
    [aux_sym_preproc_elif_token1] = ACTIONS(6310),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6310),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6310),
    [sym_preproc_directive] = ACTIONS(6310),
    [anon_sym_LPAREN2] = ACTIONS(6312),
    [anon_sym_TILDE] = ACTIONS(6312),
    [anon_sym_STAR] = ACTIONS(6312),
    [anon_sym_AMP_AMP] = ACTIONS(6312),
    [anon_sym_AMP] = ACTIONS(6310),
    [anon_sym_SEMI] = ACTIONS(6312),
    [anon_sym___extension__] = ACTIONS(6310),
    [anon_sym_typedef] = ACTIONS(6310),
    [anon_sym_in] = ACTIONS(6310),
    [anon_sym_out] = ACTIONS(6310),
    [anon_sym_inout] = ACTIONS(6310),
    [anon_sym_virtual] = ACTIONS(6310),
    [anon_sym_extern] = ACTIONS(6310),
    [anon_sym___attribute__] = ACTIONS(6310),
    [anon_sym___attribute] = ACTIONS(6310),
    [anon_sym_using] = ACTIONS(6310),
    [anon_sym_COLON_COLON] = ACTIONS(6312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6312),
    [anon_sym___declspec] = ACTIONS(6310),
    [anon_sym___based] = ACTIONS(6310),
    [anon_sym_signed] = ACTIONS(6310),
    [anon_sym_unsigned] = ACTIONS(6310),
    [anon_sym_long] = ACTIONS(6310),
    [anon_sym_short] = ACTIONS(6310),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_static] = ACTIONS(6310),
    [anon_sym_register] = ACTIONS(6310),
    [anon_sym_inline] = ACTIONS(6310),
    [anon_sym___inline] = ACTIONS(6310),
    [anon_sym___inline__] = ACTIONS(6310),
    [anon_sym___forceinline] = ACTIONS(6310),
    [anon_sym_thread_local] = ACTIONS(6310),
    [anon_sym___thread] = ACTIONS(6310),
    [anon_sym_const] = ACTIONS(6310),
    [anon_sym_constexpr] = ACTIONS(6310),
    [anon_sym_volatile] = ACTIONS(6310),
    [anon_sym_restrict] = ACTIONS(6310),
    [anon_sym___restrict__] = ACTIONS(6310),
    [anon_sym__Atomic] = ACTIONS(6310),
    [anon_sym__Noreturn] = ACTIONS(6310),
    [anon_sym_noreturn] = ACTIONS(6310),
    [anon_sym__Nonnull] = ACTIONS(6310),
    [anon_sym_mutable] = ACTIONS(6310),
    [anon_sym_constinit] = ACTIONS(6310),
    [anon_sym_consteval] = ACTIONS(6310),
    [anon_sym_alignas] = ACTIONS(6310),
    [anon_sym__Alignas] = ACTIONS(6310),
    [sym_primitive_type] = ACTIONS(6310),
    [anon_sym_enum] = ACTIONS(6310),
    [anon_sym_class] = ACTIONS(6310),
    [anon_sym_struct] = ACTIONS(6310),
    [anon_sym_union] = ACTIONS(6310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6310),
    [anon_sym_let] = ACTIONS(6310),
    [anon_sym_This] = ACTIONS(6310),
    [anon_sym_decltype] = ACTIONS(6310),
    [anon_sym_explicit] = ACTIONS(6310),
    [anon_sym_typename] = ACTIONS(6310),
    [anon_sym_private] = ACTIONS(6310),
    [anon_sym_template] = ACTIONS(6310),
    [anon_sym_operator] = ACTIONS(6310),
    [anon_sym_friend] = ACTIONS(6310),
    [anon_sym_public] = ACTIONS(6310),
    [anon_sym_protected] = ACTIONS(6310),
    [anon_sym_static_assert] = ACTIONS(6310),
    [anon_sym_precise] = ACTIONS(6310),
    [anon_sym_shared] = ACTIONS(6310),
    [anon_sym_groupshared] = ACTIONS(6310),
    [anon_sym_uniform] = ACTIONS(6310),
    [anon_sym_row_major] = ACTIONS(6310),
    [anon_sym_column_major] = ACTIONS(6310),
    [anon_sym_globallycoherent] = ACTIONS(6310),
    [anon_sym_centroid] = ACTIONS(6310),
    [anon_sym_noperspective] = ACTIONS(6310),
    [anon_sym_nointerpolation] = ACTIONS(6310),
    [anon_sym_sample] = ACTIONS(6310),
    [anon_sym_linear] = ACTIONS(6310),
    [anon_sym_snorm] = ACTIONS(6310),
    [anon_sym_unorm] = ACTIONS(6310),
    [anon_sym_point] = ACTIONS(6310),
    [anon_sym_line] = ACTIONS(6310),
    [anon_sym_triangleadj] = ACTIONS(6310),
    [anon_sym_lineadj] = ACTIONS(6310),
    [anon_sym_triangle] = ACTIONS(6310),
    [anon_sym_interface] = ACTIONS(6310),
    [anon_sym_extension] = ACTIONS(6310),
    [anon_sym___init] = ACTIONS(6310),
    [anon_sym___subscript] = ACTIONS(6310),
    [anon_sym_property] = ACTIONS(6310),
    [anon_sym_associatedtype] = ACTIONS(6310),
  },
  [1770] = {
    [sym_identifier] = ACTIONS(6314),
    [aux_sym_preproc_def_token1] = ACTIONS(6314),
    [aux_sym_preproc_if_token1] = ACTIONS(6314),
    [aux_sym_preproc_if_token2] = ACTIONS(6314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6314),
    [aux_sym_preproc_else_token1] = ACTIONS(6314),
    [aux_sym_preproc_elif_token1] = ACTIONS(6314),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6314),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6314),
    [sym_preproc_directive] = ACTIONS(6314),
    [anon_sym_LPAREN2] = ACTIONS(6316),
    [anon_sym_TILDE] = ACTIONS(6316),
    [anon_sym_STAR] = ACTIONS(6316),
    [anon_sym_AMP_AMP] = ACTIONS(6316),
    [anon_sym_AMP] = ACTIONS(6314),
    [anon_sym_SEMI] = ACTIONS(6316),
    [anon_sym___extension__] = ACTIONS(6314),
    [anon_sym_typedef] = ACTIONS(6314),
    [anon_sym_in] = ACTIONS(6314),
    [anon_sym_out] = ACTIONS(6314),
    [anon_sym_inout] = ACTIONS(6314),
    [anon_sym_virtual] = ACTIONS(6314),
    [anon_sym_extern] = ACTIONS(6314),
    [anon_sym___attribute__] = ACTIONS(6314),
    [anon_sym___attribute] = ACTIONS(6314),
    [anon_sym_using] = ACTIONS(6314),
    [anon_sym_COLON_COLON] = ACTIONS(6316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6316),
    [anon_sym___declspec] = ACTIONS(6314),
    [anon_sym___based] = ACTIONS(6314),
    [anon_sym_signed] = ACTIONS(6314),
    [anon_sym_unsigned] = ACTIONS(6314),
    [anon_sym_long] = ACTIONS(6314),
    [anon_sym_short] = ACTIONS(6314),
    [anon_sym_LBRACK] = ACTIONS(6314),
    [anon_sym_static] = ACTIONS(6314),
    [anon_sym_register] = ACTIONS(6314),
    [anon_sym_inline] = ACTIONS(6314),
    [anon_sym___inline] = ACTIONS(6314),
    [anon_sym___inline__] = ACTIONS(6314),
    [anon_sym___forceinline] = ACTIONS(6314),
    [anon_sym_thread_local] = ACTIONS(6314),
    [anon_sym___thread] = ACTIONS(6314),
    [anon_sym_const] = ACTIONS(6314),
    [anon_sym_constexpr] = ACTIONS(6314),
    [anon_sym_volatile] = ACTIONS(6314),
    [anon_sym_restrict] = ACTIONS(6314),
    [anon_sym___restrict__] = ACTIONS(6314),
    [anon_sym__Atomic] = ACTIONS(6314),
    [anon_sym__Noreturn] = ACTIONS(6314),
    [anon_sym_noreturn] = ACTIONS(6314),
    [anon_sym__Nonnull] = ACTIONS(6314),
    [anon_sym_mutable] = ACTIONS(6314),
    [anon_sym_constinit] = ACTIONS(6314),
    [anon_sym_consteval] = ACTIONS(6314),
    [anon_sym_alignas] = ACTIONS(6314),
    [anon_sym__Alignas] = ACTIONS(6314),
    [sym_primitive_type] = ACTIONS(6314),
    [anon_sym_enum] = ACTIONS(6314),
    [anon_sym_class] = ACTIONS(6314),
    [anon_sym_struct] = ACTIONS(6314),
    [anon_sym_union] = ACTIONS(6314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6314),
    [anon_sym_let] = ACTIONS(6314),
    [anon_sym_This] = ACTIONS(6314),
    [anon_sym_decltype] = ACTIONS(6314),
    [anon_sym_explicit] = ACTIONS(6314),
    [anon_sym_typename] = ACTIONS(6314),
    [anon_sym_private] = ACTIONS(6314),
    [anon_sym_template] = ACTIONS(6314),
    [anon_sym_operator] = ACTIONS(6314),
    [anon_sym_friend] = ACTIONS(6314),
    [anon_sym_public] = ACTIONS(6314),
    [anon_sym_protected] = ACTIONS(6314),
    [anon_sym_static_assert] = ACTIONS(6314),
    [anon_sym_precise] = ACTIONS(6314),
    [anon_sym_shared] = ACTIONS(6314),
    [anon_sym_groupshared] = ACTIONS(6314),
    [anon_sym_uniform] = ACTIONS(6314),
    [anon_sym_row_major] = ACTIONS(6314),
    [anon_sym_column_major] = ACTIONS(6314),
    [anon_sym_globallycoherent] = ACTIONS(6314),
    [anon_sym_centroid] = ACTIONS(6314),
    [anon_sym_noperspective] = ACTIONS(6314),
    [anon_sym_nointerpolation] = ACTIONS(6314),
    [anon_sym_sample] = ACTIONS(6314),
    [anon_sym_linear] = ACTIONS(6314),
    [anon_sym_snorm] = ACTIONS(6314),
    [anon_sym_unorm] = ACTIONS(6314),
    [anon_sym_point] = ACTIONS(6314),
    [anon_sym_line] = ACTIONS(6314),
    [anon_sym_triangleadj] = ACTIONS(6314),
    [anon_sym_lineadj] = ACTIONS(6314),
    [anon_sym_triangle] = ACTIONS(6314),
    [anon_sym_interface] = ACTIONS(6314),
    [anon_sym_extension] = ACTIONS(6314),
    [anon_sym___init] = ACTIONS(6314),
    [anon_sym___subscript] = ACTIONS(6314),
    [anon_sym_property] = ACTIONS(6314),
    [anon_sym_associatedtype] = ACTIONS(6314),
  },
  [1771] = {
    [sym_identifier] = ACTIONS(3703),
    [aux_sym_preproc_def_token1] = ACTIONS(3703),
    [aux_sym_preproc_if_token1] = ACTIONS(3703),
    [aux_sym_preproc_if_token2] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3703),
    [aux_sym_preproc_else_token1] = ACTIONS(3703),
    [aux_sym_preproc_elif_token1] = ACTIONS(3703),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3703),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3703),
    [sym_preproc_directive] = ACTIONS(3703),
    [anon_sym_LPAREN2] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3705),
    [anon_sym_STAR] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_AMP] = ACTIONS(3703),
    [anon_sym_SEMI] = ACTIONS(3705),
    [anon_sym___extension__] = ACTIONS(3703),
    [anon_sym_typedef] = ACTIONS(3703),
    [anon_sym_in] = ACTIONS(3703),
    [anon_sym_out] = ACTIONS(3703),
    [anon_sym_inout] = ACTIONS(3703),
    [anon_sym_virtual] = ACTIONS(3703),
    [anon_sym_extern] = ACTIONS(3703),
    [anon_sym___attribute__] = ACTIONS(3703),
    [anon_sym___attribute] = ACTIONS(3703),
    [anon_sym_using] = ACTIONS(3703),
    [anon_sym_COLON_COLON] = ACTIONS(3705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3705),
    [anon_sym___declspec] = ACTIONS(3703),
    [anon_sym___based] = ACTIONS(3703),
    [anon_sym_signed] = ACTIONS(3703),
    [anon_sym_unsigned] = ACTIONS(3703),
    [anon_sym_long] = ACTIONS(3703),
    [anon_sym_short] = ACTIONS(3703),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_static] = ACTIONS(3703),
    [anon_sym_register] = ACTIONS(3703),
    [anon_sym_inline] = ACTIONS(3703),
    [anon_sym___inline] = ACTIONS(3703),
    [anon_sym___inline__] = ACTIONS(3703),
    [anon_sym___forceinline] = ACTIONS(3703),
    [anon_sym_thread_local] = ACTIONS(3703),
    [anon_sym___thread] = ACTIONS(3703),
    [anon_sym_const] = ACTIONS(3703),
    [anon_sym_constexpr] = ACTIONS(3703),
    [anon_sym_volatile] = ACTIONS(3703),
    [anon_sym_restrict] = ACTIONS(3703),
    [anon_sym___restrict__] = ACTIONS(3703),
    [anon_sym__Atomic] = ACTIONS(3703),
    [anon_sym__Noreturn] = ACTIONS(3703),
    [anon_sym_noreturn] = ACTIONS(3703),
    [anon_sym__Nonnull] = ACTIONS(3703),
    [anon_sym_mutable] = ACTIONS(3703),
    [anon_sym_constinit] = ACTIONS(3703),
    [anon_sym_consteval] = ACTIONS(3703),
    [anon_sym_alignas] = ACTIONS(3703),
    [anon_sym__Alignas] = ACTIONS(3703),
    [sym_primitive_type] = ACTIONS(3703),
    [anon_sym_enum] = ACTIONS(3703),
    [anon_sym_class] = ACTIONS(3703),
    [anon_sym_struct] = ACTIONS(3703),
    [anon_sym_union] = ACTIONS(3703),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3703),
    [anon_sym_let] = ACTIONS(3703),
    [anon_sym_This] = ACTIONS(3703),
    [anon_sym_decltype] = ACTIONS(3703),
    [anon_sym_explicit] = ACTIONS(3703),
    [anon_sym_typename] = ACTIONS(3703),
    [anon_sym_private] = ACTIONS(3703),
    [anon_sym_template] = ACTIONS(3703),
    [anon_sym_operator] = ACTIONS(3703),
    [anon_sym_friend] = ACTIONS(3703),
    [anon_sym_public] = ACTIONS(3703),
    [anon_sym_protected] = ACTIONS(3703),
    [anon_sym_static_assert] = ACTIONS(3703),
    [anon_sym_precise] = ACTIONS(3703),
    [anon_sym_shared] = ACTIONS(3703),
    [anon_sym_groupshared] = ACTIONS(3703),
    [anon_sym_uniform] = ACTIONS(3703),
    [anon_sym_row_major] = ACTIONS(3703),
    [anon_sym_column_major] = ACTIONS(3703),
    [anon_sym_globallycoherent] = ACTIONS(3703),
    [anon_sym_centroid] = ACTIONS(3703),
    [anon_sym_noperspective] = ACTIONS(3703),
    [anon_sym_nointerpolation] = ACTIONS(3703),
    [anon_sym_sample] = ACTIONS(3703),
    [anon_sym_linear] = ACTIONS(3703),
    [anon_sym_snorm] = ACTIONS(3703),
    [anon_sym_unorm] = ACTIONS(3703),
    [anon_sym_point] = ACTIONS(3703),
    [anon_sym_line] = ACTIONS(3703),
    [anon_sym_triangleadj] = ACTIONS(3703),
    [anon_sym_lineadj] = ACTIONS(3703),
    [anon_sym_triangle] = ACTIONS(3703),
    [anon_sym_interface] = ACTIONS(3703),
    [anon_sym_extension] = ACTIONS(3703),
    [anon_sym___init] = ACTIONS(3703),
    [anon_sym___subscript] = ACTIONS(3703),
    [anon_sym_property] = ACTIONS(3703),
    [anon_sym_associatedtype] = ACTIONS(3703),
  },
  [1772] = {
    [sym_identifier] = ACTIONS(3707),
    [aux_sym_preproc_def_token1] = ACTIONS(3707),
    [aux_sym_preproc_if_token1] = ACTIONS(3707),
    [aux_sym_preproc_if_token2] = ACTIONS(3707),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3707),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3707),
    [aux_sym_preproc_else_token1] = ACTIONS(3707),
    [aux_sym_preproc_elif_token1] = ACTIONS(3707),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3707),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3707),
    [sym_preproc_directive] = ACTIONS(3707),
    [anon_sym_LPAREN2] = ACTIONS(3709),
    [anon_sym_TILDE] = ACTIONS(3709),
    [anon_sym_STAR] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(3707),
    [anon_sym_SEMI] = ACTIONS(3709),
    [anon_sym___extension__] = ACTIONS(3707),
    [anon_sym_typedef] = ACTIONS(3707),
    [anon_sym_in] = ACTIONS(3707),
    [anon_sym_out] = ACTIONS(3707),
    [anon_sym_inout] = ACTIONS(3707),
    [anon_sym_virtual] = ACTIONS(3707),
    [anon_sym_extern] = ACTIONS(3707),
    [anon_sym___attribute__] = ACTIONS(3707),
    [anon_sym___attribute] = ACTIONS(3707),
    [anon_sym_using] = ACTIONS(3707),
    [anon_sym_COLON_COLON] = ACTIONS(3709),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3709),
    [anon_sym___declspec] = ACTIONS(3707),
    [anon_sym___based] = ACTIONS(3707),
    [anon_sym_signed] = ACTIONS(3707),
    [anon_sym_unsigned] = ACTIONS(3707),
    [anon_sym_long] = ACTIONS(3707),
    [anon_sym_short] = ACTIONS(3707),
    [anon_sym_LBRACK] = ACTIONS(3707),
    [anon_sym_static] = ACTIONS(3707),
    [anon_sym_register] = ACTIONS(3707),
    [anon_sym_inline] = ACTIONS(3707),
    [anon_sym___inline] = ACTIONS(3707),
    [anon_sym___inline__] = ACTIONS(3707),
    [anon_sym___forceinline] = ACTIONS(3707),
    [anon_sym_thread_local] = ACTIONS(3707),
    [anon_sym___thread] = ACTIONS(3707),
    [anon_sym_const] = ACTIONS(3707),
    [anon_sym_constexpr] = ACTIONS(3707),
    [anon_sym_volatile] = ACTIONS(3707),
    [anon_sym_restrict] = ACTIONS(3707),
    [anon_sym___restrict__] = ACTIONS(3707),
    [anon_sym__Atomic] = ACTIONS(3707),
    [anon_sym__Noreturn] = ACTIONS(3707),
    [anon_sym_noreturn] = ACTIONS(3707),
    [anon_sym__Nonnull] = ACTIONS(3707),
    [anon_sym_mutable] = ACTIONS(3707),
    [anon_sym_constinit] = ACTIONS(3707),
    [anon_sym_consteval] = ACTIONS(3707),
    [anon_sym_alignas] = ACTIONS(3707),
    [anon_sym__Alignas] = ACTIONS(3707),
    [sym_primitive_type] = ACTIONS(3707),
    [anon_sym_enum] = ACTIONS(3707),
    [anon_sym_class] = ACTIONS(3707),
    [anon_sym_struct] = ACTIONS(3707),
    [anon_sym_union] = ACTIONS(3707),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3707),
    [anon_sym_let] = ACTIONS(3707),
    [anon_sym_This] = ACTIONS(3707),
    [anon_sym_decltype] = ACTIONS(3707),
    [anon_sym_explicit] = ACTIONS(3707),
    [anon_sym_typename] = ACTIONS(3707),
    [anon_sym_private] = ACTIONS(3707),
    [anon_sym_template] = ACTIONS(3707),
    [anon_sym_operator] = ACTIONS(3707),
    [anon_sym_friend] = ACTIONS(3707),
    [anon_sym_public] = ACTIONS(3707),
    [anon_sym_protected] = ACTIONS(3707),
    [anon_sym_static_assert] = ACTIONS(3707),
    [anon_sym_precise] = ACTIONS(3707),
    [anon_sym_shared] = ACTIONS(3707),
    [anon_sym_groupshared] = ACTIONS(3707),
    [anon_sym_uniform] = ACTIONS(3707),
    [anon_sym_row_major] = ACTIONS(3707),
    [anon_sym_column_major] = ACTIONS(3707),
    [anon_sym_globallycoherent] = ACTIONS(3707),
    [anon_sym_centroid] = ACTIONS(3707),
    [anon_sym_noperspective] = ACTIONS(3707),
    [anon_sym_nointerpolation] = ACTIONS(3707),
    [anon_sym_sample] = ACTIONS(3707),
    [anon_sym_linear] = ACTIONS(3707),
    [anon_sym_snorm] = ACTIONS(3707),
    [anon_sym_unorm] = ACTIONS(3707),
    [anon_sym_point] = ACTIONS(3707),
    [anon_sym_line] = ACTIONS(3707),
    [anon_sym_triangleadj] = ACTIONS(3707),
    [anon_sym_lineadj] = ACTIONS(3707),
    [anon_sym_triangle] = ACTIONS(3707),
    [anon_sym_interface] = ACTIONS(3707),
    [anon_sym_extension] = ACTIONS(3707),
    [anon_sym___init] = ACTIONS(3707),
    [anon_sym___subscript] = ACTIONS(3707),
    [anon_sym_property] = ACTIONS(3707),
    [anon_sym_associatedtype] = ACTIONS(3707),
  },
  [1773] = {
    [sym_identifier] = ACTIONS(6318),
    [aux_sym_preproc_def_token1] = ACTIONS(6318),
    [aux_sym_preproc_if_token1] = ACTIONS(6318),
    [aux_sym_preproc_if_token2] = ACTIONS(6318),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6318),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6318),
    [aux_sym_preproc_else_token1] = ACTIONS(6318),
    [aux_sym_preproc_elif_token1] = ACTIONS(6318),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6318),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6318),
    [sym_preproc_directive] = ACTIONS(6318),
    [anon_sym_LPAREN2] = ACTIONS(6320),
    [anon_sym_TILDE] = ACTIONS(6320),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_AMP_AMP] = ACTIONS(6320),
    [anon_sym_AMP] = ACTIONS(6318),
    [anon_sym_SEMI] = ACTIONS(6320),
    [anon_sym___extension__] = ACTIONS(6318),
    [anon_sym_typedef] = ACTIONS(6318),
    [anon_sym_in] = ACTIONS(6318),
    [anon_sym_out] = ACTIONS(6318),
    [anon_sym_inout] = ACTIONS(6318),
    [anon_sym_virtual] = ACTIONS(6318),
    [anon_sym_extern] = ACTIONS(6318),
    [anon_sym___attribute__] = ACTIONS(6318),
    [anon_sym___attribute] = ACTIONS(6318),
    [anon_sym_using] = ACTIONS(6318),
    [anon_sym_COLON_COLON] = ACTIONS(6320),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6320),
    [anon_sym___declspec] = ACTIONS(6318),
    [anon_sym___based] = ACTIONS(6318),
    [anon_sym_signed] = ACTIONS(6318),
    [anon_sym_unsigned] = ACTIONS(6318),
    [anon_sym_long] = ACTIONS(6318),
    [anon_sym_short] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6318),
    [anon_sym_static] = ACTIONS(6318),
    [anon_sym_register] = ACTIONS(6318),
    [anon_sym_inline] = ACTIONS(6318),
    [anon_sym___inline] = ACTIONS(6318),
    [anon_sym___inline__] = ACTIONS(6318),
    [anon_sym___forceinline] = ACTIONS(6318),
    [anon_sym_thread_local] = ACTIONS(6318),
    [anon_sym___thread] = ACTIONS(6318),
    [anon_sym_const] = ACTIONS(6318),
    [anon_sym_constexpr] = ACTIONS(6318),
    [anon_sym_volatile] = ACTIONS(6318),
    [anon_sym_restrict] = ACTIONS(6318),
    [anon_sym___restrict__] = ACTIONS(6318),
    [anon_sym__Atomic] = ACTIONS(6318),
    [anon_sym__Noreturn] = ACTIONS(6318),
    [anon_sym_noreturn] = ACTIONS(6318),
    [anon_sym__Nonnull] = ACTIONS(6318),
    [anon_sym_mutable] = ACTIONS(6318),
    [anon_sym_constinit] = ACTIONS(6318),
    [anon_sym_consteval] = ACTIONS(6318),
    [anon_sym_alignas] = ACTIONS(6318),
    [anon_sym__Alignas] = ACTIONS(6318),
    [sym_primitive_type] = ACTIONS(6318),
    [anon_sym_enum] = ACTIONS(6318),
    [anon_sym_class] = ACTIONS(6318),
    [anon_sym_struct] = ACTIONS(6318),
    [anon_sym_union] = ACTIONS(6318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6318),
    [anon_sym_let] = ACTIONS(6318),
    [anon_sym_This] = ACTIONS(6318),
    [anon_sym_decltype] = ACTIONS(6318),
    [anon_sym_explicit] = ACTIONS(6318),
    [anon_sym_typename] = ACTIONS(6318),
    [anon_sym_private] = ACTIONS(6318),
    [anon_sym_template] = ACTIONS(6318),
    [anon_sym_operator] = ACTIONS(6318),
    [anon_sym_friend] = ACTIONS(6318),
    [anon_sym_public] = ACTIONS(6318),
    [anon_sym_protected] = ACTIONS(6318),
    [anon_sym_static_assert] = ACTIONS(6318),
    [anon_sym_precise] = ACTIONS(6318),
    [anon_sym_shared] = ACTIONS(6318),
    [anon_sym_groupshared] = ACTIONS(6318),
    [anon_sym_uniform] = ACTIONS(6318),
    [anon_sym_row_major] = ACTIONS(6318),
    [anon_sym_column_major] = ACTIONS(6318),
    [anon_sym_globallycoherent] = ACTIONS(6318),
    [anon_sym_centroid] = ACTIONS(6318),
    [anon_sym_noperspective] = ACTIONS(6318),
    [anon_sym_nointerpolation] = ACTIONS(6318),
    [anon_sym_sample] = ACTIONS(6318),
    [anon_sym_linear] = ACTIONS(6318),
    [anon_sym_snorm] = ACTIONS(6318),
    [anon_sym_unorm] = ACTIONS(6318),
    [anon_sym_point] = ACTIONS(6318),
    [anon_sym_line] = ACTIONS(6318),
    [anon_sym_triangleadj] = ACTIONS(6318),
    [anon_sym_lineadj] = ACTIONS(6318),
    [anon_sym_triangle] = ACTIONS(6318),
    [anon_sym_interface] = ACTIONS(6318),
    [anon_sym_extension] = ACTIONS(6318),
    [anon_sym___init] = ACTIONS(6318),
    [anon_sym___subscript] = ACTIONS(6318),
    [anon_sym_property] = ACTIONS(6318),
    [anon_sym_associatedtype] = ACTIONS(6318),
  },
  [1774] = {
    [sym_identifier] = ACTIONS(3711),
    [aux_sym_preproc_def_token1] = ACTIONS(3711),
    [aux_sym_preproc_if_token1] = ACTIONS(3711),
    [aux_sym_preproc_if_token2] = ACTIONS(3711),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3711),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3711),
    [aux_sym_preproc_else_token1] = ACTIONS(3711),
    [aux_sym_preproc_elif_token1] = ACTIONS(3711),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3711),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3711),
    [sym_preproc_directive] = ACTIONS(3711),
    [anon_sym_LPAREN2] = ACTIONS(3713),
    [anon_sym_TILDE] = ACTIONS(3713),
    [anon_sym_STAR] = ACTIONS(3713),
    [anon_sym_AMP_AMP] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(3711),
    [anon_sym_SEMI] = ACTIONS(3713),
    [anon_sym___extension__] = ACTIONS(3711),
    [anon_sym_typedef] = ACTIONS(3711),
    [anon_sym_in] = ACTIONS(3711),
    [anon_sym_out] = ACTIONS(3711),
    [anon_sym_inout] = ACTIONS(3711),
    [anon_sym_virtual] = ACTIONS(3711),
    [anon_sym_extern] = ACTIONS(3711),
    [anon_sym___attribute__] = ACTIONS(3711),
    [anon_sym___attribute] = ACTIONS(3711),
    [anon_sym_using] = ACTIONS(3711),
    [anon_sym_COLON_COLON] = ACTIONS(3713),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3713),
    [anon_sym___declspec] = ACTIONS(3711),
    [anon_sym___based] = ACTIONS(3711),
    [anon_sym_signed] = ACTIONS(3711),
    [anon_sym_unsigned] = ACTIONS(3711),
    [anon_sym_long] = ACTIONS(3711),
    [anon_sym_short] = ACTIONS(3711),
    [anon_sym_LBRACK] = ACTIONS(3711),
    [anon_sym_static] = ACTIONS(3711),
    [anon_sym_register] = ACTIONS(3711),
    [anon_sym_inline] = ACTIONS(3711),
    [anon_sym___inline] = ACTIONS(3711),
    [anon_sym___inline__] = ACTIONS(3711),
    [anon_sym___forceinline] = ACTIONS(3711),
    [anon_sym_thread_local] = ACTIONS(3711),
    [anon_sym___thread] = ACTIONS(3711),
    [anon_sym_const] = ACTIONS(3711),
    [anon_sym_constexpr] = ACTIONS(3711),
    [anon_sym_volatile] = ACTIONS(3711),
    [anon_sym_restrict] = ACTIONS(3711),
    [anon_sym___restrict__] = ACTIONS(3711),
    [anon_sym__Atomic] = ACTIONS(3711),
    [anon_sym__Noreturn] = ACTIONS(3711),
    [anon_sym_noreturn] = ACTIONS(3711),
    [anon_sym__Nonnull] = ACTIONS(3711),
    [anon_sym_mutable] = ACTIONS(3711),
    [anon_sym_constinit] = ACTIONS(3711),
    [anon_sym_consteval] = ACTIONS(3711),
    [anon_sym_alignas] = ACTIONS(3711),
    [anon_sym__Alignas] = ACTIONS(3711),
    [sym_primitive_type] = ACTIONS(3711),
    [anon_sym_enum] = ACTIONS(3711),
    [anon_sym_class] = ACTIONS(3711),
    [anon_sym_struct] = ACTIONS(3711),
    [anon_sym_union] = ACTIONS(3711),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_This] = ACTIONS(3711),
    [anon_sym_decltype] = ACTIONS(3711),
    [anon_sym_explicit] = ACTIONS(3711),
    [anon_sym_typename] = ACTIONS(3711),
    [anon_sym_private] = ACTIONS(3711),
    [anon_sym_template] = ACTIONS(3711),
    [anon_sym_operator] = ACTIONS(3711),
    [anon_sym_friend] = ACTIONS(3711),
    [anon_sym_public] = ACTIONS(3711),
    [anon_sym_protected] = ACTIONS(3711),
    [anon_sym_static_assert] = ACTIONS(3711),
    [anon_sym_precise] = ACTIONS(3711),
    [anon_sym_shared] = ACTIONS(3711),
    [anon_sym_groupshared] = ACTIONS(3711),
    [anon_sym_uniform] = ACTIONS(3711),
    [anon_sym_row_major] = ACTIONS(3711),
    [anon_sym_column_major] = ACTIONS(3711),
    [anon_sym_globallycoherent] = ACTIONS(3711),
    [anon_sym_centroid] = ACTIONS(3711),
    [anon_sym_noperspective] = ACTIONS(3711),
    [anon_sym_nointerpolation] = ACTIONS(3711),
    [anon_sym_sample] = ACTIONS(3711),
    [anon_sym_linear] = ACTIONS(3711),
    [anon_sym_snorm] = ACTIONS(3711),
    [anon_sym_unorm] = ACTIONS(3711),
    [anon_sym_point] = ACTIONS(3711),
    [anon_sym_line] = ACTIONS(3711),
    [anon_sym_triangleadj] = ACTIONS(3711),
    [anon_sym_lineadj] = ACTIONS(3711),
    [anon_sym_triangle] = ACTIONS(3711),
    [anon_sym_interface] = ACTIONS(3711),
    [anon_sym_extension] = ACTIONS(3711),
    [anon_sym___init] = ACTIONS(3711),
    [anon_sym___subscript] = ACTIONS(3711),
    [anon_sym_property] = ACTIONS(3711),
    [anon_sym_associatedtype] = ACTIONS(3711),
  },
  [1775] = {
    [sym_identifier] = ACTIONS(3715),
    [aux_sym_preproc_def_token1] = ACTIONS(3715),
    [aux_sym_preproc_if_token1] = ACTIONS(3715),
    [aux_sym_preproc_if_token2] = ACTIONS(3715),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3715),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3715),
    [aux_sym_preproc_else_token1] = ACTIONS(3715),
    [aux_sym_preproc_elif_token1] = ACTIONS(3715),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3715),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3715),
    [sym_preproc_directive] = ACTIONS(3715),
    [anon_sym_LPAREN2] = ACTIONS(3717),
    [anon_sym_TILDE] = ACTIONS(3717),
    [anon_sym_STAR] = ACTIONS(3717),
    [anon_sym_AMP_AMP] = ACTIONS(3717),
    [anon_sym_AMP] = ACTIONS(3715),
    [anon_sym_SEMI] = ACTIONS(3717),
    [anon_sym___extension__] = ACTIONS(3715),
    [anon_sym_typedef] = ACTIONS(3715),
    [anon_sym_in] = ACTIONS(3715),
    [anon_sym_out] = ACTIONS(3715),
    [anon_sym_inout] = ACTIONS(3715),
    [anon_sym_virtual] = ACTIONS(3715),
    [anon_sym_extern] = ACTIONS(3715),
    [anon_sym___attribute__] = ACTIONS(3715),
    [anon_sym___attribute] = ACTIONS(3715),
    [anon_sym_using] = ACTIONS(3715),
    [anon_sym_COLON_COLON] = ACTIONS(3717),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3717),
    [anon_sym___declspec] = ACTIONS(3715),
    [anon_sym___based] = ACTIONS(3715),
    [anon_sym_signed] = ACTIONS(3715),
    [anon_sym_unsigned] = ACTIONS(3715),
    [anon_sym_long] = ACTIONS(3715),
    [anon_sym_short] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_static] = ACTIONS(3715),
    [anon_sym_register] = ACTIONS(3715),
    [anon_sym_inline] = ACTIONS(3715),
    [anon_sym___inline] = ACTIONS(3715),
    [anon_sym___inline__] = ACTIONS(3715),
    [anon_sym___forceinline] = ACTIONS(3715),
    [anon_sym_thread_local] = ACTIONS(3715),
    [anon_sym___thread] = ACTIONS(3715),
    [anon_sym_const] = ACTIONS(3715),
    [anon_sym_constexpr] = ACTIONS(3715),
    [anon_sym_volatile] = ACTIONS(3715),
    [anon_sym_restrict] = ACTIONS(3715),
    [anon_sym___restrict__] = ACTIONS(3715),
    [anon_sym__Atomic] = ACTIONS(3715),
    [anon_sym__Noreturn] = ACTIONS(3715),
    [anon_sym_noreturn] = ACTIONS(3715),
    [anon_sym__Nonnull] = ACTIONS(3715),
    [anon_sym_mutable] = ACTIONS(3715),
    [anon_sym_constinit] = ACTIONS(3715),
    [anon_sym_consteval] = ACTIONS(3715),
    [anon_sym_alignas] = ACTIONS(3715),
    [anon_sym__Alignas] = ACTIONS(3715),
    [sym_primitive_type] = ACTIONS(3715),
    [anon_sym_enum] = ACTIONS(3715),
    [anon_sym_class] = ACTIONS(3715),
    [anon_sym_struct] = ACTIONS(3715),
    [anon_sym_union] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3715),
    [anon_sym_let] = ACTIONS(3715),
    [anon_sym_This] = ACTIONS(3715),
    [anon_sym_decltype] = ACTIONS(3715),
    [anon_sym_explicit] = ACTIONS(3715),
    [anon_sym_typename] = ACTIONS(3715),
    [anon_sym_private] = ACTIONS(3715),
    [anon_sym_template] = ACTIONS(3715),
    [anon_sym_operator] = ACTIONS(3715),
    [anon_sym_friend] = ACTIONS(3715),
    [anon_sym_public] = ACTIONS(3715),
    [anon_sym_protected] = ACTIONS(3715),
    [anon_sym_static_assert] = ACTIONS(3715),
    [anon_sym_precise] = ACTIONS(3715),
    [anon_sym_shared] = ACTIONS(3715),
    [anon_sym_groupshared] = ACTIONS(3715),
    [anon_sym_uniform] = ACTIONS(3715),
    [anon_sym_row_major] = ACTIONS(3715),
    [anon_sym_column_major] = ACTIONS(3715),
    [anon_sym_globallycoherent] = ACTIONS(3715),
    [anon_sym_centroid] = ACTIONS(3715),
    [anon_sym_noperspective] = ACTIONS(3715),
    [anon_sym_nointerpolation] = ACTIONS(3715),
    [anon_sym_sample] = ACTIONS(3715),
    [anon_sym_linear] = ACTIONS(3715),
    [anon_sym_snorm] = ACTIONS(3715),
    [anon_sym_unorm] = ACTIONS(3715),
    [anon_sym_point] = ACTIONS(3715),
    [anon_sym_line] = ACTIONS(3715),
    [anon_sym_triangleadj] = ACTIONS(3715),
    [anon_sym_lineadj] = ACTIONS(3715),
    [anon_sym_triangle] = ACTIONS(3715),
    [anon_sym_interface] = ACTIONS(3715),
    [anon_sym_extension] = ACTIONS(3715),
    [anon_sym___init] = ACTIONS(3715),
    [anon_sym___subscript] = ACTIONS(3715),
    [anon_sym_property] = ACTIONS(3715),
    [anon_sym_associatedtype] = ACTIONS(3715),
  },
  [1776] = {
    [sym_identifier] = ACTIONS(6310),
    [aux_sym_preproc_def_token1] = ACTIONS(6310),
    [aux_sym_preproc_if_token1] = ACTIONS(6310),
    [aux_sym_preproc_if_token2] = ACTIONS(6310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6310),
    [aux_sym_preproc_else_token1] = ACTIONS(6310),
    [aux_sym_preproc_elif_token1] = ACTIONS(6310),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6310),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6310),
    [sym_preproc_directive] = ACTIONS(6310),
    [anon_sym_LPAREN2] = ACTIONS(6312),
    [anon_sym_TILDE] = ACTIONS(6312),
    [anon_sym_STAR] = ACTIONS(6312),
    [anon_sym_AMP_AMP] = ACTIONS(6312),
    [anon_sym_AMP] = ACTIONS(6310),
    [anon_sym_SEMI] = ACTIONS(6312),
    [anon_sym___extension__] = ACTIONS(6310),
    [anon_sym_typedef] = ACTIONS(6310),
    [anon_sym_in] = ACTIONS(6310),
    [anon_sym_out] = ACTIONS(6310),
    [anon_sym_inout] = ACTIONS(6310),
    [anon_sym_virtual] = ACTIONS(6310),
    [anon_sym_extern] = ACTIONS(6310),
    [anon_sym___attribute__] = ACTIONS(6310),
    [anon_sym___attribute] = ACTIONS(6310),
    [anon_sym_using] = ACTIONS(6310),
    [anon_sym_COLON_COLON] = ACTIONS(6312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6312),
    [anon_sym___declspec] = ACTIONS(6310),
    [anon_sym___based] = ACTIONS(6310),
    [anon_sym_signed] = ACTIONS(6310),
    [anon_sym_unsigned] = ACTIONS(6310),
    [anon_sym_long] = ACTIONS(6310),
    [anon_sym_short] = ACTIONS(6310),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_static] = ACTIONS(6310),
    [anon_sym_register] = ACTIONS(6310),
    [anon_sym_inline] = ACTIONS(6310),
    [anon_sym___inline] = ACTIONS(6310),
    [anon_sym___inline__] = ACTIONS(6310),
    [anon_sym___forceinline] = ACTIONS(6310),
    [anon_sym_thread_local] = ACTIONS(6310),
    [anon_sym___thread] = ACTIONS(6310),
    [anon_sym_const] = ACTIONS(6310),
    [anon_sym_constexpr] = ACTIONS(6310),
    [anon_sym_volatile] = ACTIONS(6310),
    [anon_sym_restrict] = ACTIONS(6310),
    [anon_sym___restrict__] = ACTIONS(6310),
    [anon_sym__Atomic] = ACTIONS(6310),
    [anon_sym__Noreturn] = ACTIONS(6310),
    [anon_sym_noreturn] = ACTIONS(6310),
    [anon_sym__Nonnull] = ACTIONS(6310),
    [anon_sym_mutable] = ACTIONS(6310),
    [anon_sym_constinit] = ACTIONS(6310),
    [anon_sym_consteval] = ACTIONS(6310),
    [anon_sym_alignas] = ACTIONS(6310),
    [anon_sym__Alignas] = ACTIONS(6310),
    [sym_primitive_type] = ACTIONS(6310),
    [anon_sym_enum] = ACTIONS(6310),
    [anon_sym_class] = ACTIONS(6310),
    [anon_sym_struct] = ACTIONS(6310),
    [anon_sym_union] = ACTIONS(6310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6310),
    [anon_sym_let] = ACTIONS(6310),
    [anon_sym_This] = ACTIONS(6310),
    [anon_sym_decltype] = ACTIONS(6310),
    [anon_sym_explicit] = ACTIONS(6310),
    [anon_sym_typename] = ACTIONS(6310),
    [anon_sym_private] = ACTIONS(6310),
    [anon_sym_template] = ACTIONS(6310),
    [anon_sym_operator] = ACTIONS(6310),
    [anon_sym_friend] = ACTIONS(6310),
    [anon_sym_public] = ACTIONS(6310),
    [anon_sym_protected] = ACTIONS(6310),
    [anon_sym_static_assert] = ACTIONS(6310),
    [anon_sym_precise] = ACTIONS(6310),
    [anon_sym_shared] = ACTIONS(6310),
    [anon_sym_groupshared] = ACTIONS(6310),
    [anon_sym_uniform] = ACTIONS(6310),
    [anon_sym_row_major] = ACTIONS(6310),
    [anon_sym_column_major] = ACTIONS(6310),
    [anon_sym_globallycoherent] = ACTIONS(6310),
    [anon_sym_centroid] = ACTIONS(6310),
    [anon_sym_noperspective] = ACTIONS(6310),
    [anon_sym_nointerpolation] = ACTIONS(6310),
    [anon_sym_sample] = ACTIONS(6310),
    [anon_sym_linear] = ACTIONS(6310),
    [anon_sym_snorm] = ACTIONS(6310),
    [anon_sym_unorm] = ACTIONS(6310),
    [anon_sym_point] = ACTIONS(6310),
    [anon_sym_line] = ACTIONS(6310),
    [anon_sym_triangleadj] = ACTIONS(6310),
    [anon_sym_lineadj] = ACTIONS(6310),
    [anon_sym_triangle] = ACTIONS(6310),
    [anon_sym_interface] = ACTIONS(6310),
    [anon_sym_extension] = ACTIONS(6310),
    [anon_sym___init] = ACTIONS(6310),
    [anon_sym___subscript] = ACTIONS(6310),
    [anon_sym_property] = ACTIONS(6310),
    [anon_sym_associatedtype] = ACTIONS(6310),
  },
  [1777] = {
    [sym_identifier] = ACTIONS(3735),
    [aux_sym_preproc_def_token1] = ACTIONS(3735),
    [aux_sym_preproc_if_token1] = ACTIONS(3735),
    [aux_sym_preproc_if_token2] = ACTIONS(3735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3735),
    [aux_sym_preproc_else_token1] = ACTIONS(3735),
    [aux_sym_preproc_elif_token1] = ACTIONS(3735),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3735),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3735),
    [sym_preproc_directive] = ACTIONS(3735),
    [anon_sym_LPAREN2] = ACTIONS(3737),
    [anon_sym_TILDE] = ACTIONS(3737),
    [anon_sym_STAR] = ACTIONS(3737),
    [anon_sym_AMP_AMP] = ACTIONS(3737),
    [anon_sym_AMP] = ACTIONS(3735),
    [anon_sym_SEMI] = ACTIONS(3737),
    [anon_sym___extension__] = ACTIONS(3735),
    [anon_sym_typedef] = ACTIONS(3735),
    [anon_sym_in] = ACTIONS(3735),
    [anon_sym_out] = ACTIONS(3735),
    [anon_sym_inout] = ACTIONS(3735),
    [anon_sym_virtual] = ACTIONS(3735),
    [anon_sym_extern] = ACTIONS(3735),
    [anon_sym___attribute__] = ACTIONS(3735),
    [anon_sym___attribute] = ACTIONS(3735),
    [anon_sym_using] = ACTIONS(3735),
    [anon_sym_COLON_COLON] = ACTIONS(3737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3737),
    [anon_sym___declspec] = ACTIONS(3735),
    [anon_sym___based] = ACTIONS(3735),
    [anon_sym_signed] = ACTIONS(3735),
    [anon_sym_unsigned] = ACTIONS(3735),
    [anon_sym_long] = ACTIONS(3735),
    [anon_sym_short] = ACTIONS(3735),
    [anon_sym_LBRACK] = ACTIONS(3735),
    [anon_sym_static] = ACTIONS(3735),
    [anon_sym_register] = ACTIONS(3735),
    [anon_sym_inline] = ACTIONS(3735),
    [anon_sym___inline] = ACTIONS(3735),
    [anon_sym___inline__] = ACTIONS(3735),
    [anon_sym___forceinline] = ACTIONS(3735),
    [anon_sym_thread_local] = ACTIONS(3735),
    [anon_sym___thread] = ACTIONS(3735),
    [anon_sym_const] = ACTIONS(3735),
    [anon_sym_constexpr] = ACTIONS(3735),
    [anon_sym_volatile] = ACTIONS(3735),
    [anon_sym_restrict] = ACTIONS(3735),
    [anon_sym___restrict__] = ACTIONS(3735),
    [anon_sym__Atomic] = ACTIONS(3735),
    [anon_sym__Noreturn] = ACTIONS(3735),
    [anon_sym_noreturn] = ACTIONS(3735),
    [anon_sym__Nonnull] = ACTIONS(3735),
    [anon_sym_mutable] = ACTIONS(3735),
    [anon_sym_constinit] = ACTIONS(3735),
    [anon_sym_consteval] = ACTIONS(3735),
    [anon_sym_alignas] = ACTIONS(3735),
    [anon_sym__Alignas] = ACTIONS(3735),
    [sym_primitive_type] = ACTIONS(3735),
    [anon_sym_enum] = ACTIONS(3735),
    [anon_sym_class] = ACTIONS(3735),
    [anon_sym_struct] = ACTIONS(3735),
    [anon_sym_union] = ACTIONS(3735),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3735),
    [anon_sym_let] = ACTIONS(3735),
    [anon_sym_This] = ACTIONS(3735),
    [anon_sym_decltype] = ACTIONS(3735),
    [anon_sym_explicit] = ACTIONS(3735),
    [anon_sym_typename] = ACTIONS(3735),
    [anon_sym_private] = ACTIONS(3735),
    [anon_sym_template] = ACTIONS(3735),
    [anon_sym_operator] = ACTIONS(3735),
    [anon_sym_friend] = ACTIONS(3735),
    [anon_sym_public] = ACTIONS(3735),
    [anon_sym_protected] = ACTIONS(3735),
    [anon_sym_static_assert] = ACTIONS(3735),
    [anon_sym_precise] = ACTIONS(3735),
    [anon_sym_shared] = ACTIONS(3735),
    [anon_sym_groupshared] = ACTIONS(3735),
    [anon_sym_uniform] = ACTIONS(3735),
    [anon_sym_row_major] = ACTIONS(3735),
    [anon_sym_column_major] = ACTIONS(3735),
    [anon_sym_globallycoherent] = ACTIONS(3735),
    [anon_sym_centroid] = ACTIONS(3735),
    [anon_sym_noperspective] = ACTIONS(3735),
    [anon_sym_nointerpolation] = ACTIONS(3735),
    [anon_sym_sample] = ACTIONS(3735),
    [anon_sym_linear] = ACTIONS(3735),
    [anon_sym_snorm] = ACTIONS(3735),
    [anon_sym_unorm] = ACTIONS(3735),
    [anon_sym_point] = ACTIONS(3735),
    [anon_sym_line] = ACTIONS(3735),
    [anon_sym_triangleadj] = ACTIONS(3735),
    [anon_sym_lineadj] = ACTIONS(3735),
    [anon_sym_triangle] = ACTIONS(3735),
    [anon_sym_interface] = ACTIONS(3735),
    [anon_sym_extension] = ACTIONS(3735),
    [anon_sym___init] = ACTIONS(3735),
    [anon_sym___subscript] = ACTIONS(3735),
    [anon_sym_property] = ACTIONS(3735),
    [anon_sym_associatedtype] = ACTIONS(3735),
  },
  [1778] = {
    [sym_identifier] = ACTIONS(6322),
    [anon_sym_COMMA] = ACTIONS(6324),
    [anon_sym_RPAREN] = ACTIONS(6324),
    [anon_sym_LPAREN2] = ACTIONS(6324),
    [anon_sym_TILDE] = ACTIONS(6324),
    [anon_sym_STAR] = ACTIONS(6324),
    [anon_sym_PIPE_PIPE] = ACTIONS(6324),
    [anon_sym_AMP_AMP] = ACTIONS(6324),
    [anon_sym_AMP] = ACTIONS(6322),
    [anon_sym___extension__] = ACTIONS(6322),
    [anon_sym_in] = ACTIONS(6322),
    [anon_sym_out] = ACTIONS(6322),
    [anon_sym_inout] = ACTIONS(6322),
    [anon_sym_virtual] = ACTIONS(6322),
    [anon_sym_extern] = ACTIONS(6322),
    [anon_sym___attribute__] = ACTIONS(6322),
    [anon_sym___attribute] = ACTIONS(6322),
    [anon_sym_using] = ACTIONS(6322),
    [anon_sym_COLON_COLON] = ACTIONS(6324),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6324),
    [anon_sym___declspec] = ACTIONS(6322),
    [anon_sym___based] = ACTIONS(6322),
    [anon_sym___cdecl] = ACTIONS(6322),
    [anon_sym___clrcall] = ACTIONS(6322),
    [anon_sym___stdcall] = ACTIONS(6322),
    [anon_sym___fastcall] = ACTIONS(6322),
    [anon_sym___thiscall] = ACTIONS(6322),
    [anon_sym___vectorcall] = ACTIONS(6322),
    [anon_sym_LBRACE] = ACTIONS(6324),
    [anon_sym_signed] = ACTIONS(6322),
    [anon_sym_unsigned] = ACTIONS(6322),
    [anon_sym_long] = ACTIONS(6322),
    [anon_sym_short] = ACTIONS(6322),
    [anon_sym_LBRACK] = ACTIONS(6322),
    [anon_sym_static] = ACTIONS(6322),
    [anon_sym_register] = ACTIONS(6322),
    [anon_sym_inline] = ACTIONS(6322),
    [anon_sym___inline] = ACTIONS(6322),
    [anon_sym___inline__] = ACTIONS(6322),
    [anon_sym___forceinline] = ACTIONS(6322),
    [anon_sym_thread_local] = ACTIONS(6322),
    [anon_sym___thread] = ACTIONS(6322),
    [anon_sym_const] = ACTIONS(6322),
    [anon_sym_constexpr] = ACTIONS(6322),
    [anon_sym_volatile] = ACTIONS(6322),
    [anon_sym_restrict] = ACTIONS(6322),
    [anon_sym___restrict__] = ACTIONS(6322),
    [anon_sym__Atomic] = ACTIONS(6322),
    [anon_sym__Noreturn] = ACTIONS(6322),
    [anon_sym_noreturn] = ACTIONS(6322),
    [anon_sym__Nonnull] = ACTIONS(6322),
    [anon_sym_mutable] = ACTIONS(6322),
    [anon_sym_constinit] = ACTIONS(6322),
    [anon_sym_consteval] = ACTIONS(6322),
    [anon_sym_alignas] = ACTIONS(6322),
    [anon_sym__Alignas] = ACTIONS(6322),
    [sym_primitive_type] = ACTIONS(6322),
    [anon_sym_enum] = ACTIONS(6322),
    [anon_sym_class] = ACTIONS(6322),
    [anon_sym_struct] = ACTIONS(6322),
    [anon_sym_union] = ACTIONS(6322),
    [anon_sym_or] = ACTIONS(6322),
    [anon_sym_and] = ACTIONS(6322),
    [anon_sym_DASH_GT] = ACTIONS(6324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6322),
    [anon_sym_let] = ACTIONS(6322),
    [anon_sym_This] = ACTIONS(6322),
    [anon_sym_decltype] = ACTIONS(6322),
    [anon_sym_final] = ACTIONS(6322),
    [anon_sym_override] = ACTIONS(6322),
    [anon_sym_explicit] = ACTIONS(6322),
    [anon_sym_typename] = ACTIONS(6322),
    [anon_sym_template] = ACTIONS(6322),
    [anon_sym_operator] = ACTIONS(6322),
    [anon_sym_friend] = ACTIONS(6322),
    [anon_sym_noexcept] = ACTIONS(6322),
    [anon_sym_throw] = ACTIONS(6322),
    [anon_sym_concept] = ACTIONS(6322),
    [anon_sym_requires] = ACTIONS(6322),
    [anon_sym_precise] = ACTIONS(6322),
    [anon_sym_shared] = ACTIONS(6322),
    [anon_sym_groupshared] = ACTIONS(6322),
    [anon_sym_uniform] = ACTIONS(6322),
    [anon_sym_row_major] = ACTIONS(6322),
    [anon_sym_column_major] = ACTIONS(6322),
    [anon_sym_globallycoherent] = ACTIONS(6322),
    [anon_sym_centroid] = ACTIONS(6322),
    [anon_sym_noperspective] = ACTIONS(6322),
    [anon_sym_nointerpolation] = ACTIONS(6322),
    [anon_sym_sample] = ACTIONS(6322),
    [anon_sym_linear] = ACTIONS(6322),
    [anon_sym_snorm] = ACTIONS(6322),
    [anon_sym_unorm] = ACTIONS(6322),
    [anon_sym_point] = ACTIONS(6322),
    [anon_sym_line] = ACTIONS(6322),
    [anon_sym_triangleadj] = ACTIONS(6322),
    [anon_sym_lineadj] = ACTIONS(6322),
    [anon_sym_triangle] = ACTIONS(6322),
    [anon_sym_interface] = ACTIONS(6322),
    [anon_sym_extension] = ACTIONS(6322),
    [anon_sym_where] = ACTIONS(6322),
  },
  [1779] = {
    [sym_expression] = STATE(4409),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym__unary_left_fold] = STATE(10857),
    [sym__unary_right_fold] = STATE(10859),
    [sym__binary_fold] = STATE(10860),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1780] = {
    [sym_expression] = STATE(5232),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_initializer_list] = STATE(9149),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_default] = ACTIONS(6326),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(6328),
    [aux_sym_pure_virtual_clause_token1] = ACTIONS(6330),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1781] = {
    [sym_identifier] = ACTIONS(6322),
    [anon_sym_COMMA] = ACTIONS(6324),
    [anon_sym_RPAREN] = ACTIONS(6324),
    [anon_sym_LPAREN2] = ACTIONS(6324),
    [anon_sym_TILDE] = ACTIONS(6324),
    [anon_sym_STAR] = ACTIONS(6324),
    [anon_sym_PIPE_PIPE] = ACTIONS(6324),
    [anon_sym_AMP_AMP] = ACTIONS(6324),
    [anon_sym_AMP] = ACTIONS(6322),
    [anon_sym___extension__] = ACTIONS(6322),
    [anon_sym_in] = ACTIONS(6322),
    [anon_sym_out] = ACTIONS(6322),
    [anon_sym_inout] = ACTIONS(6322),
    [anon_sym_virtual] = ACTIONS(6322),
    [anon_sym_extern] = ACTIONS(6322),
    [anon_sym___attribute__] = ACTIONS(6322),
    [anon_sym___attribute] = ACTIONS(6322),
    [anon_sym_using] = ACTIONS(6322),
    [anon_sym_COLON_COLON] = ACTIONS(6324),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6324),
    [anon_sym___declspec] = ACTIONS(6322),
    [anon_sym___based] = ACTIONS(6322),
    [anon_sym___cdecl] = ACTIONS(6322),
    [anon_sym___clrcall] = ACTIONS(6322),
    [anon_sym___stdcall] = ACTIONS(6322),
    [anon_sym___fastcall] = ACTIONS(6322),
    [anon_sym___thiscall] = ACTIONS(6322),
    [anon_sym___vectorcall] = ACTIONS(6322),
    [anon_sym_LBRACE] = ACTIONS(6324),
    [anon_sym_signed] = ACTIONS(6322),
    [anon_sym_unsigned] = ACTIONS(6322),
    [anon_sym_long] = ACTIONS(6322),
    [anon_sym_short] = ACTIONS(6322),
    [anon_sym_LBRACK] = ACTIONS(6322),
    [anon_sym_static] = ACTIONS(6322),
    [anon_sym_register] = ACTIONS(6322),
    [anon_sym_inline] = ACTIONS(6322),
    [anon_sym___inline] = ACTIONS(6322),
    [anon_sym___inline__] = ACTIONS(6322),
    [anon_sym___forceinline] = ACTIONS(6322),
    [anon_sym_thread_local] = ACTIONS(6322),
    [anon_sym___thread] = ACTIONS(6322),
    [anon_sym_const] = ACTIONS(6322),
    [anon_sym_constexpr] = ACTIONS(6322),
    [anon_sym_volatile] = ACTIONS(6322),
    [anon_sym_restrict] = ACTIONS(6322),
    [anon_sym___restrict__] = ACTIONS(6322),
    [anon_sym__Atomic] = ACTIONS(6322),
    [anon_sym__Noreturn] = ACTIONS(6322),
    [anon_sym_noreturn] = ACTIONS(6322),
    [anon_sym__Nonnull] = ACTIONS(6322),
    [anon_sym_mutable] = ACTIONS(6322),
    [anon_sym_constinit] = ACTIONS(6322),
    [anon_sym_consteval] = ACTIONS(6322),
    [anon_sym_alignas] = ACTIONS(6322),
    [anon_sym__Alignas] = ACTIONS(6322),
    [sym_primitive_type] = ACTIONS(6322),
    [anon_sym_enum] = ACTIONS(6322),
    [anon_sym_class] = ACTIONS(6322),
    [anon_sym_struct] = ACTIONS(6322),
    [anon_sym_union] = ACTIONS(6322),
    [anon_sym_or] = ACTIONS(6322),
    [anon_sym_and] = ACTIONS(6322),
    [anon_sym_DASH_GT] = ACTIONS(6324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6322),
    [anon_sym_let] = ACTIONS(6322),
    [anon_sym_This] = ACTIONS(6322),
    [anon_sym_decltype] = ACTIONS(6322),
    [anon_sym_final] = ACTIONS(6322),
    [anon_sym_override] = ACTIONS(6322),
    [anon_sym_explicit] = ACTIONS(6322),
    [anon_sym_typename] = ACTIONS(6322),
    [anon_sym_template] = ACTIONS(6322),
    [anon_sym_operator] = ACTIONS(6322),
    [anon_sym_friend] = ACTIONS(6322),
    [anon_sym_noexcept] = ACTIONS(6322),
    [anon_sym_throw] = ACTIONS(6322),
    [anon_sym_concept] = ACTIONS(6322),
    [anon_sym_requires] = ACTIONS(6322),
    [anon_sym_precise] = ACTIONS(6322),
    [anon_sym_shared] = ACTIONS(6322),
    [anon_sym_groupshared] = ACTIONS(6322),
    [anon_sym_uniform] = ACTIONS(6322),
    [anon_sym_row_major] = ACTIONS(6322),
    [anon_sym_column_major] = ACTIONS(6322),
    [anon_sym_globallycoherent] = ACTIONS(6322),
    [anon_sym_centroid] = ACTIONS(6322),
    [anon_sym_noperspective] = ACTIONS(6322),
    [anon_sym_nointerpolation] = ACTIONS(6322),
    [anon_sym_sample] = ACTIONS(6322),
    [anon_sym_linear] = ACTIONS(6322),
    [anon_sym_snorm] = ACTIONS(6322),
    [anon_sym_unorm] = ACTIONS(6322),
    [anon_sym_point] = ACTIONS(6322),
    [anon_sym_line] = ACTIONS(6322),
    [anon_sym_triangleadj] = ACTIONS(6322),
    [anon_sym_lineadj] = ACTIONS(6322),
    [anon_sym_triangle] = ACTIONS(6322),
    [anon_sym_interface] = ACTIONS(6322),
    [anon_sym_extension] = ACTIONS(6322),
    [anon_sym_where] = ACTIONS(6322),
  },
  [1782] = {
    [sym__declaration_modifiers] = STATE(2667),
    [sym__declaration_specifiers] = STATE(4972),
    [sym_attribute_specifier] = STATE(2667),
    [sym_attribute_declaration] = STATE(2667),
    [sym_ms_declspec_modifier] = STATE(2667),
    [sym_storage_class_specifier] = STATE(2667),
    [sym_type_qualifier] = STATE(2667),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2793),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_parameter_declaration] = STATE(10532),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_optional_parameter_declaration] = STATE(10532),
    [sym_variadic_parameter_declaration] = STATE(10532),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8769),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2667),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2667),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6332),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(2348),
    [anon_sym_out] = ACTIONS(2348),
    [anon_sym_inout] = ACTIONS(2348),
    [anon_sym_virtual] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5525),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_extension] = ACTIONS(2398),
  },
  [1783] = {
    [sym_expression] = STATE(4354),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym__unary_left_fold] = STATE(11529),
    [sym__unary_right_fold] = STATE(11538),
    [sym__binary_fold] = STATE(11549),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1784] = {
    [sym_expression] = STATE(5279),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_initializer_list] = STATE(9032),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_default] = ACTIONS(6334),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(6336),
    [aux_sym_pure_virtual_clause_token1] = ACTIONS(6338),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1785] = {
    [sym_identifier] = ACTIONS(6340),
    [aux_sym_preproc_def_token1] = ACTIONS(6340),
    [aux_sym_preproc_if_token1] = ACTIONS(6340),
    [aux_sym_preproc_if_token2] = ACTIONS(6340),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6340),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6340),
    [aux_sym_preproc_else_token1] = ACTIONS(6340),
    [aux_sym_preproc_elif_token1] = ACTIONS(6340),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6340),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6340),
    [sym_preproc_directive] = ACTIONS(6340),
    [anon_sym_LPAREN2] = ACTIONS(6342),
    [anon_sym_TILDE] = ACTIONS(6342),
    [anon_sym_STAR] = ACTIONS(6342),
    [anon_sym_AMP_AMP] = ACTIONS(6342),
    [anon_sym_AMP] = ACTIONS(6340),
    [anon_sym_SEMI] = ACTIONS(6342),
    [anon_sym___extension__] = ACTIONS(6340),
    [anon_sym_typedef] = ACTIONS(6340),
    [anon_sym_in] = ACTIONS(6340),
    [anon_sym_out] = ACTIONS(6340),
    [anon_sym_inout] = ACTIONS(6340),
    [anon_sym_virtual] = ACTIONS(6340),
    [anon_sym_extern] = ACTIONS(6340),
    [anon_sym___attribute__] = ACTIONS(6340),
    [anon_sym___attribute] = ACTIONS(6340),
    [anon_sym_using] = ACTIONS(6340),
    [anon_sym_COLON_COLON] = ACTIONS(6342),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6342),
    [anon_sym___declspec] = ACTIONS(6340),
    [anon_sym___based] = ACTIONS(6340),
    [anon_sym_signed] = ACTIONS(6340),
    [anon_sym_unsigned] = ACTIONS(6340),
    [anon_sym_long] = ACTIONS(6340),
    [anon_sym_short] = ACTIONS(6340),
    [anon_sym_LBRACK] = ACTIONS(6340),
    [anon_sym_static] = ACTIONS(6340),
    [anon_sym_register] = ACTIONS(6340),
    [anon_sym_inline] = ACTIONS(6340),
    [anon_sym___inline] = ACTIONS(6340),
    [anon_sym___inline__] = ACTIONS(6340),
    [anon_sym___forceinline] = ACTIONS(6340),
    [anon_sym_thread_local] = ACTIONS(6340),
    [anon_sym___thread] = ACTIONS(6340),
    [anon_sym_const] = ACTIONS(6340),
    [anon_sym_constexpr] = ACTIONS(6340),
    [anon_sym_volatile] = ACTIONS(6340),
    [anon_sym_restrict] = ACTIONS(6340),
    [anon_sym___restrict__] = ACTIONS(6340),
    [anon_sym__Atomic] = ACTIONS(6340),
    [anon_sym__Noreturn] = ACTIONS(6340),
    [anon_sym_noreturn] = ACTIONS(6340),
    [anon_sym__Nonnull] = ACTIONS(6340),
    [anon_sym_mutable] = ACTIONS(6340),
    [anon_sym_constinit] = ACTIONS(6340),
    [anon_sym_consteval] = ACTIONS(6340),
    [anon_sym_alignas] = ACTIONS(6340),
    [anon_sym__Alignas] = ACTIONS(6340),
    [sym_primitive_type] = ACTIONS(6340),
    [anon_sym_enum] = ACTIONS(6340),
    [anon_sym_class] = ACTIONS(6340),
    [anon_sym_struct] = ACTIONS(6340),
    [anon_sym_union] = ACTIONS(6340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6340),
    [anon_sym_let] = ACTIONS(6340),
    [anon_sym_This] = ACTIONS(6340),
    [anon_sym_decltype] = ACTIONS(6340),
    [anon_sym_explicit] = ACTIONS(6340),
    [anon_sym_typename] = ACTIONS(6340),
    [anon_sym_private] = ACTIONS(6340),
    [anon_sym_template] = ACTIONS(6340),
    [anon_sym_operator] = ACTIONS(6340),
    [anon_sym_friend] = ACTIONS(6340),
    [anon_sym_public] = ACTIONS(6340),
    [anon_sym_protected] = ACTIONS(6340),
    [anon_sym_static_assert] = ACTIONS(6340),
    [anon_sym_precise] = ACTIONS(6340),
    [anon_sym_shared] = ACTIONS(6340),
    [anon_sym_groupshared] = ACTIONS(6340),
    [anon_sym_uniform] = ACTIONS(6340),
    [anon_sym_row_major] = ACTIONS(6340),
    [anon_sym_column_major] = ACTIONS(6340),
    [anon_sym_globallycoherent] = ACTIONS(6340),
    [anon_sym_centroid] = ACTIONS(6340),
    [anon_sym_noperspective] = ACTIONS(6340),
    [anon_sym_nointerpolation] = ACTIONS(6340),
    [anon_sym_sample] = ACTIONS(6340),
    [anon_sym_linear] = ACTIONS(6340),
    [anon_sym_snorm] = ACTIONS(6340),
    [anon_sym_unorm] = ACTIONS(6340),
    [anon_sym_point] = ACTIONS(6340),
    [anon_sym_line] = ACTIONS(6340),
    [anon_sym_triangleadj] = ACTIONS(6340),
    [anon_sym_lineadj] = ACTIONS(6340),
    [anon_sym_triangle] = ACTIONS(6340),
    [anon_sym_interface] = ACTIONS(6340),
    [anon_sym_extension] = ACTIONS(6340),
    [anon_sym___init] = ACTIONS(6340),
    [anon_sym___subscript] = ACTIONS(6340),
    [anon_sym_property] = ACTIONS(6340),
    [anon_sym_associatedtype] = ACTIONS(6340),
  },
  [1786] = {
    [sym_expression] = STATE(4385),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym__unary_left_fold] = STATE(11567),
    [sym__unary_right_fold] = STATE(11568),
    [sym__binary_fold] = STATE(11569),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1787] = {
    [sym_expression] = STATE(4416),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym__unary_left_fold] = STATE(11305),
    [sym__unary_right_fold] = STATE(11316),
    [sym__binary_fold] = STATE(11317),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1788] = {
    [sym_expression] = STATE(4394),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym__unary_left_fold] = STATE(11157),
    [sym__unary_right_fold] = STATE(11175),
    [sym__binary_fold] = STATE(11179),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1789] = {
    [sym_expression] = STATE(4403),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym__unary_left_fold] = STATE(10798),
    [sym__unary_right_fold] = STATE(10800),
    [sym__binary_fold] = STATE(10803),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1790] = {
    [sym_expression] = STATE(4414),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym__unary_left_fold] = STATE(10792),
    [sym__unary_right_fold] = STATE(10804),
    [sym__binary_fold] = STATE(10813),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1791] = {
    [sym_identifier] = ACTIONS(6322),
    [anon_sym_COMMA] = ACTIONS(6324),
    [anon_sym_RPAREN] = ACTIONS(6324),
    [anon_sym_LPAREN2] = ACTIONS(6324),
    [anon_sym_TILDE] = ACTIONS(6324),
    [anon_sym_STAR] = ACTIONS(6324),
    [anon_sym_PIPE_PIPE] = ACTIONS(6324),
    [anon_sym_AMP_AMP] = ACTIONS(6324),
    [anon_sym_AMP] = ACTIONS(6322),
    [anon_sym___extension__] = ACTIONS(6322),
    [anon_sym_in] = ACTIONS(6322),
    [anon_sym_out] = ACTIONS(6322),
    [anon_sym_inout] = ACTIONS(6322),
    [anon_sym_virtual] = ACTIONS(6322),
    [anon_sym_extern] = ACTIONS(6322),
    [anon_sym___attribute__] = ACTIONS(6322),
    [anon_sym___attribute] = ACTIONS(6322),
    [anon_sym_using] = ACTIONS(6322),
    [anon_sym_COLON_COLON] = ACTIONS(6324),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6324),
    [anon_sym___declspec] = ACTIONS(6322),
    [anon_sym___based] = ACTIONS(6322),
    [anon_sym___cdecl] = ACTIONS(6322),
    [anon_sym___clrcall] = ACTIONS(6322),
    [anon_sym___stdcall] = ACTIONS(6322),
    [anon_sym___fastcall] = ACTIONS(6322),
    [anon_sym___thiscall] = ACTIONS(6322),
    [anon_sym___vectorcall] = ACTIONS(6322),
    [anon_sym_LBRACE] = ACTIONS(6324),
    [anon_sym_signed] = ACTIONS(6322),
    [anon_sym_unsigned] = ACTIONS(6322),
    [anon_sym_long] = ACTIONS(6322),
    [anon_sym_short] = ACTIONS(6322),
    [anon_sym_LBRACK] = ACTIONS(6322),
    [anon_sym_static] = ACTIONS(6322),
    [anon_sym_register] = ACTIONS(6322),
    [anon_sym_inline] = ACTIONS(6322),
    [anon_sym___inline] = ACTIONS(6322),
    [anon_sym___inline__] = ACTIONS(6322),
    [anon_sym___forceinline] = ACTIONS(6322),
    [anon_sym_thread_local] = ACTIONS(6322),
    [anon_sym___thread] = ACTIONS(6322),
    [anon_sym_const] = ACTIONS(6322),
    [anon_sym_constexpr] = ACTIONS(6322),
    [anon_sym_volatile] = ACTIONS(6322),
    [anon_sym_restrict] = ACTIONS(6322),
    [anon_sym___restrict__] = ACTIONS(6322),
    [anon_sym__Atomic] = ACTIONS(6322),
    [anon_sym__Noreturn] = ACTIONS(6322),
    [anon_sym_noreturn] = ACTIONS(6322),
    [anon_sym__Nonnull] = ACTIONS(6322),
    [anon_sym_mutable] = ACTIONS(6322),
    [anon_sym_constinit] = ACTIONS(6322),
    [anon_sym_consteval] = ACTIONS(6322),
    [anon_sym_alignas] = ACTIONS(6322),
    [anon_sym__Alignas] = ACTIONS(6322),
    [sym_primitive_type] = ACTIONS(6322),
    [anon_sym_enum] = ACTIONS(6322),
    [anon_sym_class] = ACTIONS(6322),
    [anon_sym_struct] = ACTIONS(6322),
    [anon_sym_union] = ACTIONS(6322),
    [anon_sym_or] = ACTIONS(6322),
    [anon_sym_and] = ACTIONS(6322),
    [anon_sym_DASH_GT] = ACTIONS(6324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6322),
    [anon_sym_let] = ACTIONS(6322),
    [anon_sym_This] = ACTIONS(6322),
    [anon_sym_decltype] = ACTIONS(6322),
    [anon_sym_final] = ACTIONS(6322),
    [anon_sym_override] = ACTIONS(6322),
    [anon_sym_explicit] = ACTIONS(6322),
    [anon_sym_typename] = ACTIONS(6322),
    [anon_sym_template] = ACTIONS(6322),
    [anon_sym_operator] = ACTIONS(6322),
    [anon_sym_friend] = ACTIONS(6322),
    [anon_sym_noexcept] = ACTIONS(6322),
    [anon_sym_throw] = ACTIONS(6322),
    [anon_sym_concept] = ACTIONS(6322),
    [anon_sym_requires] = ACTIONS(6322),
    [anon_sym_precise] = ACTIONS(6322),
    [anon_sym_shared] = ACTIONS(6322),
    [anon_sym_groupshared] = ACTIONS(6322),
    [anon_sym_uniform] = ACTIONS(6322),
    [anon_sym_row_major] = ACTIONS(6322),
    [anon_sym_column_major] = ACTIONS(6322),
    [anon_sym_globallycoherent] = ACTIONS(6322),
    [anon_sym_centroid] = ACTIONS(6322),
    [anon_sym_noperspective] = ACTIONS(6322),
    [anon_sym_nointerpolation] = ACTIONS(6322),
    [anon_sym_sample] = ACTIONS(6322),
    [anon_sym_linear] = ACTIONS(6322),
    [anon_sym_snorm] = ACTIONS(6322),
    [anon_sym_unorm] = ACTIONS(6322),
    [anon_sym_point] = ACTIONS(6322),
    [anon_sym_line] = ACTIONS(6322),
    [anon_sym_triangleadj] = ACTIONS(6322),
    [anon_sym_lineadj] = ACTIONS(6322),
    [anon_sym_triangle] = ACTIONS(6322),
    [anon_sym_interface] = ACTIONS(6322),
    [anon_sym_extension] = ACTIONS(6322),
    [anon_sym_where] = ACTIONS(6322),
  },
  [1792] = {
    [sym_expression] = STATE(4355),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym__unary_left_fold] = STATE(10862),
    [sym__unary_right_fold] = STATE(10885),
    [sym__binary_fold] = STATE(10914),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1793] = {
    [sym_identifier] = ACTIONS(6344),
    [aux_sym_preproc_def_token1] = ACTIONS(6344),
    [aux_sym_preproc_if_token1] = ACTIONS(6344),
    [aux_sym_preproc_if_token2] = ACTIONS(6344),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6344),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6344),
    [aux_sym_preproc_else_token1] = ACTIONS(6344),
    [aux_sym_preproc_elif_token1] = ACTIONS(6344),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6344),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6344),
    [sym_preproc_directive] = ACTIONS(6344),
    [anon_sym_LPAREN2] = ACTIONS(6346),
    [anon_sym_TILDE] = ACTIONS(6346),
    [anon_sym_STAR] = ACTIONS(6346),
    [anon_sym_AMP_AMP] = ACTIONS(6346),
    [anon_sym_AMP] = ACTIONS(6344),
    [anon_sym_SEMI] = ACTIONS(6346),
    [anon_sym___extension__] = ACTIONS(6344),
    [anon_sym_typedef] = ACTIONS(6344),
    [anon_sym_in] = ACTIONS(6344),
    [anon_sym_out] = ACTIONS(6344),
    [anon_sym_inout] = ACTIONS(6344),
    [anon_sym_virtual] = ACTIONS(6344),
    [anon_sym_extern] = ACTIONS(6344),
    [anon_sym___attribute__] = ACTIONS(6344),
    [anon_sym___attribute] = ACTIONS(6344),
    [anon_sym_using] = ACTIONS(6344),
    [anon_sym_COLON_COLON] = ACTIONS(6346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6346),
    [anon_sym___declspec] = ACTIONS(6344),
    [anon_sym___based] = ACTIONS(6344),
    [anon_sym_signed] = ACTIONS(6344),
    [anon_sym_unsigned] = ACTIONS(6344),
    [anon_sym_long] = ACTIONS(6344),
    [anon_sym_short] = ACTIONS(6344),
    [anon_sym_LBRACK] = ACTIONS(6344),
    [anon_sym_static] = ACTIONS(6344),
    [anon_sym_register] = ACTIONS(6344),
    [anon_sym_inline] = ACTIONS(6344),
    [anon_sym___inline] = ACTIONS(6344),
    [anon_sym___inline__] = ACTIONS(6344),
    [anon_sym___forceinline] = ACTIONS(6344),
    [anon_sym_thread_local] = ACTIONS(6344),
    [anon_sym___thread] = ACTIONS(6344),
    [anon_sym_const] = ACTIONS(6344),
    [anon_sym_constexpr] = ACTIONS(6344),
    [anon_sym_volatile] = ACTIONS(6344),
    [anon_sym_restrict] = ACTIONS(6344),
    [anon_sym___restrict__] = ACTIONS(6344),
    [anon_sym__Atomic] = ACTIONS(6344),
    [anon_sym__Noreturn] = ACTIONS(6344),
    [anon_sym_noreturn] = ACTIONS(6344),
    [anon_sym__Nonnull] = ACTIONS(6344),
    [anon_sym_mutable] = ACTIONS(6344),
    [anon_sym_constinit] = ACTIONS(6344),
    [anon_sym_consteval] = ACTIONS(6344),
    [anon_sym_alignas] = ACTIONS(6344),
    [anon_sym__Alignas] = ACTIONS(6344),
    [sym_primitive_type] = ACTIONS(6344),
    [anon_sym_enum] = ACTIONS(6344),
    [anon_sym_class] = ACTIONS(6344),
    [anon_sym_struct] = ACTIONS(6344),
    [anon_sym_union] = ACTIONS(6344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6344),
    [anon_sym_let] = ACTIONS(6344),
    [anon_sym_This] = ACTIONS(6344),
    [anon_sym_decltype] = ACTIONS(6344),
    [anon_sym_explicit] = ACTIONS(6344),
    [anon_sym_typename] = ACTIONS(6344),
    [anon_sym_private] = ACTIONS(6344),
    [anon_sym_template] = ACTIONS(6344),
    [anon_sym_operator] = ACTIONS(6344),
    [anon_sym_friend] = ACTIONS(6344),
    [anon_sym_public] = ACTIONS(6344),
    [anon_sym_protected] = ACTIONS(6344),
    [anon_sym_static_assert] = ACTIONS(6344),
    [anon_sym_precise] = ACTIONS(6344),
    [anon_sym_shared] = ACTIONS(6344),
    [anon_sym_groupshared] = ACTIONS(6344),
    [anon_sym_uniform] = ACTIONS(6344),
    [anon_sym_row_major] = ACTIONS(6344),
    [anon_sym_column_major] = ACTIONS(6344),
    [anon_sym_globallycoherent] = ACTIONS(6344),
    [anon_sym_centroid] = ACTIONS(6344),
    [anon_sym_noperspective] = ACTIONS(6344),
    [anon_sym_nointerpolation] = ACTIONS(6344),
    [anon_sym_sample] = ACTIONS(6344),
    [anon_sym_linear] = ACTIONS(6344),
    [anon_sym_snorm] = ACTIONS(6344),
    [anon_sym_unorm] = ACTIONS(6344),
    [anon_sym_point] = ACTIONS(6344),
    [anon_sym_line] = ACTIONS(6344),
    [anon_sym_triangleadj] = ACTIONS(6344),
    [anon_sym_lineadj] = ACTIONS(6344),
    [anon_sym_triangle] = ACTIONS(6344),
    [anon_sym_interface] = ACTIONS(6344),
    [anon_sym_extension] = ACTIONS(6344),
    [anon_sym___init] = ACTIONS(6344),
    [anon_sym___subscript] = ACTIONS(6344),
    [anon_sym_property] = ACTIONS(6344),
    [anon_sym_associatedtype] = ACTIONS(6344),
  },
  [1794] = {
    [sym_identifier] = ACTIONS(6348),
    [aux_sym_preproc_def_token1] = ACTIONS(6348),
    [aux_sym_preproc_if_token1] = ACTIONS(6348),
    [aux_sym_preproc_if_token2] = ACTIONS(6348),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6348),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6348),
    [aux_sym_preproc_else_token1] = ACTIONS(6348),
    [aux_sym_preproc_elif_token1] = ACTIONS(6348),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6348),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6348),
    [sym_preproc_directive] = ACTIONS(6348),
    [anon_sym_LPAREN2] = ACTIONS(6350),
    [anon_sym_TILDE] = ACTIONS(6350),
    [anon_sym_STAR] = ACTIONS(6350),
    [anon_sym_AMP_AMP] = ACTIONS(6350),
    [anon_sym_AMP] = ACTIONS(6348),
    [anon_sym_SEMI] = ACTIONS(6350),
    [anon_sym___extension__] = ACTIONS(6348),
    [anon_sym_typedef] = ACTIONS(6348),
    [anon_sym_in] = ACTIONS(6348),
    [anon_sym_out] = ACTIONS(6348),
    [anon_sym_inout] = ACTIONS(6348),
    [anon_sym_virtual] = ACTIONS(6348),
    [anon_sym_extern] = ACTIONS(6348),
    [anon_sym___attribute__] = ACTIONS(6348),
    [anon_sym___attribute] = ACTIONS(6348),
    [anon_sym_using] = ACTIONS(6348),
    [anon_sym_COLON_COLON] = ACTIONS(6350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6350),
    [anon_sym___declspec] = ACTIONS(6348),
    [anon_sym___based] = ACTIONS(6348),
    [anon_sym_signed] = ACTIONS(6348),
    [anon_sym_unsigned] = ACTIONS(6348),
    [anon_sym_long] = ACTIONS(6348),
    [anon_sym_short] = ACTIONS(6348),
    [anon_sym_LBRACK] = ACTIONS(6348),
    [anon_sym_static] = ACTIONS(6348),
    [anon_sym_register] = ACTIONS(6348),
    [anon_sym_inline] = ACTIONS(6348),
    [anon_sym___inline] = ACTIONS(6348),
    [anon_sym___inline__] = ACTIONS(6348),
    [anon_sym___forceinline] = ACTIONS(6348),
    [anon_sym_thread_local] = ACTIONS(6348),
    [anon_sym___thread] = ACTIONS(6348),
    [anon_sym_const] = ACTIONS(6348),
    [anon_sym_constexpr] = ACTIONS(6348),
    [anon_sym_volatile] = ACTIONS(6348),
    [anon_sym_restrict] = ACTIONS(6348),
    [anon_sym___restrict__] = ACTIONS(6348),
    [anon_sym__Atomic] = ACTIONS(6348),
    [anon_sym__Noreturn] = ACTIONS(6348),
    [anon_sym_noreturn] = ACTIONS(6348),
    [anon_sym__Nonnull] = ACTIONS(6348),
    [anon_sym_mutable] = ACTIONS(6348),
    [anon_sym_constinit] = ACTIONS(6348),
    [anon_sym_consteval] = ACTIONS(6348),
    [anon_sym_alignas] = ACTIONS(6348),
    [anon_sym__Alignas] = ACTIONS(6348),
    [sym_primitive_type] = ACTIONS(6348),
    [anon_sym_enum] = ACTIONS(6348),
    [anon_sym_class] = ACTIONS(6348),
    [anon_sym_struct] = ACTIONS(6348),
    [anon_sym_union] = ACTIONS(6348),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6348),
    [anon_sym_let] = ACTIONS(6348),
    [anon_sym_This] = ACTIONS(6348),
    [anon_sym_decltype] = ACTIONS(6348),
    [anon_sym_explicit] = ACTIONS(6348),
    [anon_sym_typename] = ACTIONS(6348),
    [anon_sym_private] = ACTIONS(6348),
    [anon_sym_template] = ACTIONS(6348),
    [anon_sym_operator] = ACTIONS(6348),
    [anon_sym_friend] = ACTIONS(6348),
    [anon_sym_public] = ACTIONS(6348),
    [anon_sym_protected] = ACTIONS(6348),
    [anon_sym_static_assert] = ACTIONS(6348),
    [anon_sym_precise] = ACTIONS(6348),
    [anon_sym_shared] = ACTIONS(6348),
    [anon_sym_groupshared] = ACTIONS(6348),
    [anon_sym_uniform] = ACTIONS(6348),
    [anon_sym_row_major] = ACTIONS(6348),
    [anon_sym_column_major] = ACTIONS(6348),
    [anon_sym_globallycoherent] = ACTIONS(6348),
    [anon_sym_centroid] = ACTIONS(6348),
    [anon_sym_noperspective] = ACTIONS(6348),
    [anon_sym_nointerpolation] = ACTIONS(6348),
    [anon_sym_sample] = ACTIONS(6348),
    [anon_sym_linear] = ACTIONS(6348),
    [anon_sym_snorm] = ACTIONS(6348),
    [anon_sym_unorm] = ACTIONS(6348),
    [anon_sym_point] = ACTIONS(6348),
    [anon_sym_line] = ACTIONS(6348),
    [anon_sym_triangleadj] = ACTIONS(6348),
    [anon_sym_lineadj] = ACTIONS(6348),
    [anon_sym_triangle] = ACTIONS(6348),
    [anon_sym_interface] = ACTIONS(6348),
    [anon_sym_extension] = ACTIONS(6348),
    [anon_sym___init] = ACTIONS(6348),
    [anon_sym___subscript] = ACTIONS(6348),
    [anon_sym_property] = ACTIONS(6348),
    [anon_sym_associatedtype] = ACTIONS(6348),
  },
  [1795] = {
    [sym_identifier] = ACTIONS(6352),
    [aux_sym_preproc_def_token1] = ACTIONS(6352),
    [aux_sym_preproc_if_token1] = ACTIONS(6352),
    [aux_sym_preproc_if_token2] = ACTIONS(6352),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6352),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6352),
    [aux_sym_preproc_else_token1] = ACTIONS(6352),
    [aux_sym_preproc_elif_token1] = ACTIONS(6352),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6352),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6352),
    [sym_preproc_directive] = ACTIONS(6352),
    [anon_sym_LPAREN2] = ACTIONS(6354),
    [anon_sym_TILDE] = ACTIONS(6354),
    [anon_sym_STAR] = ACTIONS(6354),
    [anon_sym_AMP_AMP] = ACTIONS(6354),
    [anon_sym_AMP] = ACTIONS(6352),
    [anon_sym_SEMI] = ACTIONS(6354),
    [anon_sym___extension__] = ACTIONS(6352),
    [anon_sym_typedef] = ACTIONS(6352),
    [anon_sym_in] = ACTIONS(6352),
    [anon_sym_out] = ACTIONS(6352),
    [anon_sym_inout] = ACTIONS(6352),
    [anon_sym_virtual] = ACTIONS(6352),
    [anon_sym_extern] = ACTIONS(6352),
    [anon_sym___attribute__] = ACTIONS(6352),
    [anon_sym___attribute] = ACTIONS(6352),
    [anon_sym_using] = ACTIONS(6352),
    [anon_sym_COLON_COLON] = ACTIONS(6354),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6354),
    [anon_sym___declspec] = ACTIONS(6352),
    [anon_sym___based] = ACTIONS(6352),
    [anon_sym_signed] = ACTIONS(6352),
    [anon_sym_unsigned] = ACTIONS(6352),
    [anon_sym_long] = ACTIONS(6352),
    [anon_sym_short] = ACTIONS(6352),
    [anon_sym_LBRACK] = ACTIONS(6352),
    [anon_sym_static] = ACTIONS(6352),
    [anon_sym_register] = ACTIONS(6352),
    [anon_sym_inline] = ACTIONS(6352),
    [anon_sym___inline] = ACTIONS(6352),
    [anon_sym___inline__] = ACTIONS(6352),
    [anon_sym___forceinline] = ACTIONS(6352),
    [anon_sym_thread_local] = ACTIONS(6352),
    [anon_sym___thread] = ACTIONS(6352),
    [anon_sym_const] = ACTIONS(6352),
    [anon_sym_constexpr] = ACTIONS(6352),
    [anon_sym_volatile] = ACTIONS(6352),
    [anon_sym_restrict] = ACTIONS(6352),
    [anon_sym___restrict__] = ACTIONS(6352),
    [anon_sym__Atomic] = ACTIONS(6352),
    [anon_sym__Noreturn] = ACTIONS(6352),
    [anon_sym_noreturn] = ACTIONS(6352),
    [anon_sym__Nonnull] = ACTIONS(6352),
    [anon_sym_mutable] = ACTIONS(6352),
    [anon_sym_constinit] = ACTIONS(6352),
    [anon_sym_consteval] = ACTIONS(6352),
    [anon_sym_alignas] = ACTIONS(6352),
    [anon_sym__Alignas] = ACTIONS(6352),
    [sym_primitive_type] = ACTIONS(6352),
    [anon_sym_enum] = ACTIONS(6352),
    [anon_sym_class] = ACTIONS(6352),
    [anon_sym_struct] = ACTIONS(6352),
    [anon_sym_union] = ACTIONS(6352),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6352),
    [anon_sym_let] = ACTIONS(6352),
    [anon_sym_This] = ACTIONS(6352),
    [anon_sym_decltype] = ACTIONS(6352),
    [anon_sym_explicit] = ACTIONS(6352),
    [anon_sym_typename] = ACTIONS(6352),
    [anon_sym_private] = ACTIONS(6352),
    [anon_sym_template] = ACTIONS(6352),
    [anon_sym_operator] = ACTIONS(6352),
    [anon_sym_friend] = ACTIONS(6352),
    [anon_sym_public] = ACTIONS(6352),
    [anon_sym_protected] = ACTIONS(6352),
    [anon_sym_static_assert] = ACTIONS(6352),
    [anon_sym_precise] = ACTIONS(6352),
    [anon_sym_shared] = ACTIONS(6352),
    [anon_sym_groupshared] = ACTIONS(6352),
    [anon_sym_uniform] = ACTIONS(6352),
    [anon_sym_row_major] = ACTIONS(6352),
    [anon_sym_column_major] = ACTIONS(6352),
    [anon_sym_globallycoherent] = ACTIONS(6352),
    [anon_sym_centroid] = ACTIONS(6352),
    [anon_sym_noperspective] = ACTIONS(6352),
    [anon_sym_nointerpolation] = ACTIONS(6352),
    [anon_sym_sample] = ACTIONS(6352),
    [anon_sym_linear] = ACTIONS(6352),
    [anon_sym_snorm] = ACTIONS(6352),
    [anon_sym_unorm] = ACTIONS(6352),
    [anon_sym_point] = ACTIONS(6352),
    [anon_sym_line] = ACTIONS(6352),
    [anon_sym_triangleadj] = ACTIONS(6352),
    [anon_sym_lineadj] = ACTIONS(6352),
    [anon_sym_triangle] = ACTIONS(6352),
    [anon_sym_interface] = ACTIONS(6352),
    [anon_sym_extension] = ACTIONS(6352),
    [anon_sym___init] = ACTIONS(6352),
    [anon_sym___subscript] = ACTIONS(6352),
    [anon_sym_property] = ACTIONS(6352),
    [anon_sym_associatedtype] = ACTIONS(6352),
  },
  [1796] = {
    [sym_identifier] = ACTIONS(6356),
    [aux_sym_preproc_def_token1] = ACTIONS(6356),
    [aux_sym_preproc_if_token1] = ACTIONS(6356),
    [aux_sym_preproc_if_token2] = ACTIONS(6356),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6356),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6356),
    [aux_sym_preproc_else_token1] = ACTIONS(6356),
    [aux_sym_preproc_elif_token1] = ACTIONS(6356),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6356),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6356),
    [sym_preproc_directive] = ACTIONS(6356),
    [anon_sym_LPAREN2] = ACTIONS(6358),
    [anon_sym_TILDE] = ACTIONS(6358),
    [anon_sym_STAR] = ACTIONS(6358),
    [anon_sym_AMP_AMP] = ACTIONS(6358),
    [anon_sym_AMP] = ACTIONS(6356),
    [anon_sym_SEMI] = ACTIONS(6358),
    [anon_sym___extension__] = ACTIONS(6356),
    [anon_sym_typedef] = ACTIONS(6356),
    [anon_sym_in] = ACTIONS(6356),
    [anon_sym_out] = ACTIONS(6356),
    [anon_sym_inout] = ACTIONS(6356),
    [anon_sym_virtual] = ACTIONS(6356),
    [anon_sym_extern] = ACTIONS(6356),
    [anon_sym___attribute__] = ACTIONS(6356),
    [anon_sym___attribute] = ACTIONS(6356),
    [anon_sym_using] = ACTIONS(6356),
    [anon_sym_COLON_COLON] = ACTIONS(6358),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6358),
    [anon_sym___declspec] = ACTIONS(6356),
    [anon_sym___based] = ACTIONS(6356),
    [anon_sym_signed] = ACTIONS(6356),
    [anon_sym_unsigned] = ACTIONS(6356),
    [anon_sym_long] = ACTIONS(6356),
    [anon_sym_short] = ACTIONS(6356),
    [anon_sym_LBRACK] = ACTIONS(6356),
    [anon_sym_static] = ACTIONS(6356),
    [anon_sym_register] = ACTIONS(6356),
    [anon_sym_inline] = ACTIONS(6356),
    [anon_sym___inline] = ACTIONS(6356),
    [anon_sym___inline__] = ACTIONS(6356),
    [anon_sym___forceinline] = ACTIONS(6356),
    [anon_sym_thread_local] = ACTIONS(6356),
    [anon_sym___thread] = ACTIONS(6356),
    [anon_sym_const] = ACTIONS(6356),
    [anon_sym_constexpr] = ACTIONS(6356),
    [anon_sym_volatile] = ACTIONS(6356),
    [anon_sym_restrict] = ACTIONS(6356),
    [anon_sym___restrict__] = ACTIONS(6356),
    [anon_sym__Atomic] = ACTIONS(6356),
    [anon_sym__Noreturn] = ACTIONS(6356),
    [anon_sym_noreturn] = ACTIONS(6356),
    [anon_sym__Nonnull] = ACTIONS(6356),
    [anon_sym_mutable] = ACTIONS(6356),
    [anon_sym_constinit] = ACTIONS(6356),
    [anon_sym_consteval] = ACTIONS(6356),
    [anon_sym_alignas] = ACTIONS(6356),
    [anon_sym__Alignas] = ACTIONS(6356),
    [sym_primitive_type] = ACTIONS(6356),
    [anon_sym_enum] = ACTIONS(6356),
    [anon_sym_class] = ACTIONS(6356),
    [anon_sym_struct] = ACTIONS(6356),
    [anon_sym_union] = ACTIONS(6356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6356),
    [anon_sym_let] = ACTIONS(6356),
    [anon_sym_This] = ACTIONS(6356),
    [anon_sym_decltype] = ACTIONS(6356),
    [anon_sym_explicit] = ACTIONS(6356),
    [anon_sym_typename] = ACTIONS(6356),
    [anon_sym_private] = ACTIONS(6356),
    [anon_sym_template] = ACTIONS(6356),
    [anon_sym_operator] = ACTIONS(6356),
    [anon_sym_friend] = ACTIONS(6356),
    [anon_sym_public] = ACTIONS(6356),
    [anon_sym_protected] = ACTIONS(6356),
    [anon_sym_static_assert] = ACTIONS(6356),
    [anon_sym_precise] = ACTIONS(6356),
    [anon_sym_shared] = ACTIONS(6356),
    [anon_sym_groupshared] = ACTIONS(6356),
    [anon_sym_uniform] = ACTIONS(6356),
    [anon_sym_row_major] = ACTIONS(6356),
    [anon_sym_column_major] = ACTIONS(6356),
    [anon_sym_globallycoherent] = ACTIONS(6356),
    [anon_sym_centroid] = ACTIONS(6356),
    [anon_sym_noperspective] = ACTIONS(6356),
    [anon_sym_nointerpolation] = ACTIONS(6356),
    [anon_sym_sample] = ACTIONS(6356),
    [anon_sym_linear] = ACTIONS(6356),
    [anon_sym_snorm] = ACTIONS(6356),
    [anon_sym_unorm] = ACTIONS(6356),
    [anon_sym_point] = ACTIONS(6356),
    [anon_sym_line] = ACTIONS(6356),
    [anon_sym_triangleadj] = ACTIONS(6356),
    [anon_sym_lineadj] = ACTIONS(6356),
    [anon_sym_triangle] = ACTIONS(6356),
    [anon_sym_interface] = ACTIONS(6356),
    [anon_sym_extension] = ACTIONS(6356),
    [anon_sym___init] = ACTIONS(6356),
    [anon_sym___subscript] = ACTIONS(6356),
    [anon_sym_property] = ACTIONS(6356),
    [anon_sym_associatedtype] = ACTIONS(6356),
  },
  [1797] = {
    [sym_identifier] = ACTIONS(6360),
    [aux_sym_preproc_def_token1] = ACTIONS(6360),
    [aux_sym_preproc_if_token1] = ACTIONS(6360),
    [aux_sym_preproc_if_token2] = ACTIONS(6360),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6360),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6360),
    [aux_sym_preproc_else_token1] = ACTIONS(6360),
    [aux_sym_preproc_elif_token1] = ACTIONS(6360),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6360),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6360),
    [sym_preproc_directive] = ACTIONS(6360),
    [anon_sym_LPAREN2] = ACTIONS(6362),
    [anon_sym_TILDE] = ACTIONS(6362),
    [anon_sym_STAR] = ACTIONS(6362),
    [anon_sym_AMP_AMP] = ACTIONS(6362),
    [anon_sym_AMP] = ACTIONS(6360),
    [anon_sym_SEMI] = ACTIONS(6362),
    [anon_sym___extension__] = ACTIONS(6360),
    [anon_sym_typedef] = ACTIONS(6360),
    [anon_sym_in] = ACTIONS(6360),
    [anon_sym_out] = ACTIONS(6360),
    [anon_sym_inout] = ACTIONS(6360),
    [anon_sym_virtual] = ACTIONS(6360),
    [anon_sym_extern] = ACTIONS(6360),
    [anon_sym___attribute__] = ACTIONS(6360),
    [anon_sym___attribute] = ACTIONS(6360),
    [anon_sym_using] = ACTIONS(6360),
    [anon_sym_COLON_COLON] = ACTIONS(6362),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6362),
    [anon_sym___declspec] = ACTIONS(6360),
    [anon_sym___based] = ACTIONS(6360),
    [anon_sym_signed] = ACTIONS(6360),
    [anon_sym_unsigned] = ACTIONS(6360),
    [anon_sym_long] = ACTIONS(6360),
    [anon_sym_short] = ACTIONS(6360),
    [anon_sym_LBRACK] = ACTIONS(6360),
    [anon_sym_static] = ACTIONS(6360),
    [anon_sym_register] = ACTIONS(6360),
    [anon_sym_inline] = ACTIONS(6360),
    [anon_sym___inline] = ACTIONS(6360),
    [anon_sym___inline__] = ACTIONS(6360),
    [anon_sym___forceinline] = ACTIONS(6360),
    [anon_sym_thread_local] = ACTIONS(6360),
    [anon_sym___thread] = ACTIONS(6360),
    [anon_sym_const] = ACTIONS(6360),
    [anon_sym_constexpr] = ACTIONS(6360),
    [anon_sym_volatile] = ACTIONS(6360),
    [anon_sym_restrict] = ACTIONS(6360),
    [anon_sym___restrict__] = ACTIONS(6360),
    [anon_sym__Atomic] = ACTIONS(6360),
    [anon_sym__Noreturn] = ACTIONS(6360),
    [anon_sym_noreturn] = ACTIONS(6360),
    [anon_sym__Nonnull] = ACTIONS(6360),
    [anon_sym_mutable] = ACTIONS(6360),
    [anon_sym_constinit] = ACTIONS(6360),
    [anon_sym_consteval] = ACTIONS(6360),
    [anon_sym_alignas] = ACTIONS(6360),
    [anon_sym__Alignas] = ACTIONS(6360),
    [sym_primitive_type] = ACTIONS(6360),
    [anon_sym_enum] = ACTIONS(6360),
    [anon_sym_class] = ACTIONS(6360),
    [anon_sym_struct] = ACTIONS(6360),
    [anon_sym_union] = ACTIONS(6360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6360),
    [anon_sym_let] = ACTIONS(6360),
    [anon_sym_This] = ACTIONS(6360),
    [anon_sym_decltype] = ACTIONS(6360),
    [anon_sym_explicit] = ACTIONS(6360),
    [anon_sym_typename] = ACTIONS(6360),
    [anon_sym_private] = ACTIONS(6360),
    [anon_sym_template] = ACTIONS(6360),
    [anon_sym_operator] = ACTIONS(6360),
    [anon_sym_friend] = ACTIONS(6360),
    [anon_sym_public] = ACTIONS(6360),
    [anon_sym_protected] = ACTIONS(6360),
    [anon_sym_static_assert] = ACTIONS(6360),
    [anon_sym_precise] = ACTIONS(6360),
    [anon_sym_shared] = ACTIONS(6360),
    [anon_sym_groupshared] = ACTIONS(6360),
    [anon_sym_uniform] = ACTIONS(6360),
    [anon_sym_row_major] = ACTIONS(6360),
    [anon_sym_column_major] = ACTIONS(6360),
    [anon_sym_globallycoherent] = ACTIONS(6360),
    [anon_sym_centroid] = ACTIONS(6360),
    [anon_sym_noperspective] = ACTIONS(6360),
    [anon_sym_nointerpolation] = ACTIONS(6360),
    [anon_sym_sample] = ACTIONS(6360),
    [anon_sym_linear] = ACTIONS(6360),
    [anon_sym_snorm] = ACTIONS(6360),
    [anon_sym_unorm] = ACTIONS(6360),
    [anon_sym_point] = ACTIONS(6360),
    [anon_sym_line] = ACTIONS(6360),
    [anon_sym_triangleadj] = ACTIONS(6360),
    [anon_sym_lineadj] = ACTIONS(6360),
    [anon_sym_triangle] = ACTIONS(6360),
    [anon_sym_interface] = ACTIONS(6360),
    [anon_sym_extension] = ACTIONS(6360),
    [anon_sym___init] = ACTIONS(6360),
    [anon_sym___subscript] = ACTIONS(6360),
    [anon_sym_property] = ACTIONS(6360),
    [anon_sym_associatedtype] = ACTIONS(6360),
  },
  [1798] = {
    [sym_identifier] = ACTIONS(6364),
    [aux_sym_preproc_def_token1] = ACTIONS(6364),
    [aux_sym_preproc_if_token1] = ACTIONS(6364),
    [aux_sym_preproc_if_token2] = ACTIONS(6364),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6364),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6364),
    [aux_sym_preproc_else_token1] = ACTIONS(6364),
    [aux_sym_preproc_elif_token1] = ACTIONS(6364),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6364),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6364),
    [sym_preproc_directive] = ACTIONS(6364),
    [anon_sym_LPAREN2] = ACTIONS(6366),
    [anon_sym_TILDE] = ACTIONS(6366),
    [anon_sym_STAR] = ACTIONS(6366),
    [anon_sym_AMP_AMP] = ACTIONS(6366),
    [anon_sym_AMP] = ACTIONS(6364),
    [anon_sym_SEMI] = ACTIONS(6366),
    [anon_sym___extension__] = ACTIONS(6364),
    [anon_sym_typedef] = ACTIONS(6364),
    [anon_sym_in] = ACTIONS(6364),
    [anon_sym_out] = ACTIONS(6364),
    [anon_sym_inout] = ACTIONS(6364),
    [anon_sym_virtual] = ACTIONS(6364),
    [anon_sym_extern] = ACTIONS(6364),
    [anon_sym___attribute__] = ACTIONS(6364),
    [anon_sym___attribute] = ACTIONS(6364),
    [anon_sym_using] = ACTIONS(6364),
    [anon_sym_COLON_COLON] = ACTIONS(6366),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6366),
    [anon_sym___declspec] = ACTIONS(6364),
    [anon_sym___based] = ACTIONS(6364),
    [anon_sym_signed] = ACTIONS(6364),
    [anon_sym_unsigned] = ACTIONS(6364),
    [anon_sym_long] = ACTIONS(6364),
    [anon_sym_short] = ACTIONS(6364),
    [anon_sym_LBRACK] = ACTIONS(6364),
    [anon_sym_static] = ACTIONS(6364),
    [anon_sym_register] = ACTIONS(6364),
    [anon_sym_inline] = ACTIONS(6364),
    [anon_sym___inline] = ACTIONS(6364),
    [anon_sym___inline__] = ACTIONS(6364),
    [anon_sym___forceinline] = ACTIONS(6364),
    [anon_sym_thread_local] = ACTIONS(6364),
    [anon_sym___thread] = ACTIONS(6364),
    [anon_sym_const] = ACTIONS(6364),
    [anon_sym_constexpr] = ACTIONS(6364),
    [anon_sym_volatile] = ACTIONS(6364),
    [anon_sym_restrict] = ACTIONS(6364),
    [anon_sym___restrict__] = ACTIONS(6364),
    [anon_sym__Atomic] = ACTIONS(6364),
    [anon_sym__Noreturn] = ACTIONS(6364),
    [anon_sym_noreturn] = ACTIONS(6364),
    [anon_sym__Nonnull] = ACTIONS(6364),
    [anon_sym_mutable] = ACTIONS(6364),
    [anon_sym_constinit] = ACTIONS(6364),
    [anon_sym_consteval] = ACTIONS(6364),
    [anon_sym_alignas] = ACTIONS(6364),
    [anon_sym__Alignas] = ACTIONS(6364),
    [sym_primitive_type] = ACTIONS(6364),
    [anon_sym_enum] = ACTIONS(6364),
    [anon_sym_class] = ACTIONS(6364),
    [anon_sym_struct] = ACTIONS(6364),
    [anon_sym_union] = ACTIONS(6364),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6364),
    [anon_sym_let] = ACTIONS(6364),
    [anon_sym_This] = ACTIONS(6364),
    [anon_sym_decltype] = ACTIONS(6364),
    [anon_sym_explicit] = ACTIONS(6364),
    [anon_sym_typename] = ACTIONS(6364),
    [anon_sym_private] = ACTIONS(6364),
    [anon_sym_template] = ACTIONS(6364),
    [anon_sym_operator] = ACTIONS(6364),
    [anon_sym_friend] = ACTIONS(6364),
    [anon_sym_public] = ACTIONS(6364),
    [anon_sym_protected] = ACTIONS(6364),
    [anon_sym_static_assert] = ACTIONS(6364),
    [anon_sym_precise] = ACTIONS(6364),
    [anon_sym_shared] = ACTIONS(6364),
    [anon_sym_groupshared] = ACTIONS(6364),
    [anon_sym_uniform] = ACTIONS(6364),
    [anon_sym_row_major] = ACTIONS(6364),
    [anon_sym_column_major] = ACTIONS(6364),
    [anon_sym_globallycoherent] = ACTIONS(6364),
    [anon_sym_centroid] = ACTIONS(6364),
    [anon_sym_noperspective] = ACTIONS(6364),
    [anon_sym_nointerpolation] = ACTIONS(6364),
    [anon_sym_sample] = ACTIONS(6364),
    [anon_sym_linear] = ACTIONS(6364),
    [anon_sym_snorm] = ACTIONS(6364),
    [anon_sym_unorm] = ACTIONS(6364),
    [anon_sym_point] = ACTIONS(6364),
    [anon_sym_line] = ACTIONS(6364),
    [anon_sym_triangleadj] = ACTIONS(6364),
    [anon_sym_lineadj] = ACTIONS(6364),
    [anon_sym_triangle] = ACTIONS(6364),
    [anon_sym_interface] = ACTIONS(6364),
    [anon_sym_extension] = ACTIONS(6364),
    [anon_sym___init] = ACTIONS(6364),
    [anon_sym___subscript] = ACTIONS(6364),
    [anon_sym_property] = ACTIONS(6364),
    [anon_sym_associatedtype] = ACTIONS(6364),
  },
  [1799] = {
    [sym_identifier] = ACTIONS(6368),
    [aux_sym_preproc_def_token1] = ACTIONS(6368),
    [aux_sym_preproc_if_token1] = ACTIONS(6368),
    [aux_sym_preproc_if_token2] = ACTIONS(6368),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6368),
    [aux_sym_preproc_else_token1] = ACTIONS(6368),
    [aux_sym_preproc_elif_token1] = ACTIONS(6368),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6368),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6368),
    [sym_preproc_directive] = ACTIONS(6368),
    [anon_sym_LPAREN2] = ACTIONS(6370),
    [anon_sym_TILDE] = ACTIONS(6370),
    [anon_sym_STAR] = ACTIONS(6370),
    [anon_sym_AMP_AMP] = ACTIONS(6370),
    [anon_sym_AMP] = ACTIONS(6368),
    [anon_sym_SEMI] = ACTIONS(6370),
    [anon_sym___extension__] = ACTIONS(6368),
    [anon_sym_typedef] = ACTIONS(6368),
    [anon_sym_in] = ACTIONS(6368),
    [anon_sym_out] = ACTIONS(6368),
    [anon_sym_inout] = ACTIONS(6368),
    [anon_sym_virtual] = ACTIONS(6368),
    [anon_sym_extern] = ACTIONS(6368),
    [anon_sym___attribute__] = ACTIONS(6368),
    [anon_sym___attribute] = ACTIONS(6368),
    [anon_sym_using] = ACTIONS(6368),
    [anon_sym_COLON_COLON] = ACTIONS(6370),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6370),
    [anon_sym___declspec] = ACTIONS(6368),
    [anon_sym___based] = ACTIONS(6368),
    [anon_sym_signed] = ACTIONS(6368),
    [anon_sym_unsigned] = ACTIONS(6368),
    [anon_sym_long] = ACTIONS(6368),
    [anon_sym_short] = ACTIONS(6368),
    [anon_sym_LBRACK] = ACTIONS(6368),
    [anon_sym_static] = ACTIONS(6368),
    [anon_sym_register] = ACTIONS(6368),
    [anon_sym_inline] = ACTIONS(6368),
    [anon_sym___inline] = ACTIONS(6368),
    [anon_sym___inline__] = ACTIONS(6368),
    [anon_sym___forceinline] = ACTIONS(6368),
    [anon_sym_thread_local] = ACTIONS(6368),
    [anon_sym___thread] = ACTIONS(6368),
    [anon_sym_const] = ACTIONS(6368),
    [anon_sym_constexpr] = ACTIONS(6368),
    [anon_sym_volatile] = ACTIONS(6368),
    [anon_sym_restrict] = ACTIONS(6368),
    [anon_sym___restrict__] = ACTIONS(6368),
    [anon_sym__Atomic] = ACTIONS(6368),
    [anon_sym__Noreturn] = ACTIONS(6368),
    [anon_sym_noreturn] = ACTIONS(6368),
    [anon_sym__Nonnull] = ACTIONS(6368),
    [anon_sym_mutable] = ACTIONS(6368),
    [anon_sym_constinit] = ACTIONS(6368),
    [anon_sym_consteval] = ACTIONS(6368),
    [anon_sym_alignas] = ACTIONS(6368),
    [anon_sym__Alignas] = ACTIONS(6368),
    [sym_primitive_type] = ACTIONS(6368),
    [anon_sym_enum] = ACTIONS(6368),
    [anon_sym_class] = ACTIONS(6368),
    [anon_sym_struct] = ACTIONS(6368),
    [anon_sym_union] = ACTIONS(6368),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6368),
    [anon_sym_let] = ACTIONS(6368),
    [anon_sym_This] = ACTIONS(6368),
    [anon_sym_decltype] = ACTIONS(6368),
    [anon_sym_explicit] = ACTIONS(6368),
    [anon_sym_typename] = ACTIONS(6368),
    [anon_sym_private] = ACTIONS(6368),
    [anon_sym_template] = ACTIONS(6368),
    [anon_sym_operator] = ACTIONS(6368),
    [anon_sym_friend] = ACTIONS(6368),
    [anon_sym_public] = ACTIONS(6368),
    [anon_sym_protected] = ACTIONS(6368),
    [anon_sym_static_assert] = ACTIONS(6368),
    [anon_sym_precise] = ACTIONS(6368),
    [anon_sym_shared] = ACTIONS(6368),
    [anon_sym_groupshared] = ACTIONS(6368),
    [anon_sym_uniform] = ACTIONS(6368),
    [anon_sym_row_major] = ACTIONS(6368),
    [anon_sym_column_major] = ACTIONS(6368),
    [anon_sym_globallycoherent] = ACTIONS(6368),
    [anon_sym_centroid] = ACTIONS(6368),
    [anon_sym_noperspective] = ACTIONS(6368),
    [anon_sym_nointerpolation] = ACTIONS(6368),
    [anon_sym_sample] = ACTIONS(6368),
    [anon_sym_linear] = ACTIONS(6368),
    [anon_sym_snorm] = ACTIONS(6368),
    [anon_sym_unorm] = ACTIONS(6368),
    [anon_sym_point] = ACTIONS(6368),
    [anon_sym_line] = ACTIONS(6368),
    [anon_sym_triangleadj] = ACTIONS(6368),
    [anon_sym_lineadj] = ACTIONS(6368),
    [anon_sym_triangle] = ACTIONS(6368),
    [anon_sym_interface] = ACTIONS(6368),
    [anon_sym_extension] = ACTIONS(6368),
    [anon_sym___init] = ACTIONS(6368),
    [anon_sym___subscript] = ACTIONS(6368),
    [anon_sym_property] = ACTIONS(6368),
    [anon_sym_associatedtype] = ACTIONS(6368),
  },
  [1800] = {
    [sym_identifier] = ACTIONS(6372),
    [aux_sym_preproc_def_token1] = ACTIONS(6372),
    [aux_sym_preproc_if_token1] = ACTIONS(6372),
    [aux_sym_preproc_if_token2] = ACTIONS(6372),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6372),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6372),
    [aux_sym_preproc_else_token1] = ACTIONS(6372),
    [aux_sym_preproc_elif_token1] = ACTIONS(6372),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6372),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6372),
    [sym_preproc_directive] = ACTIONS(6372),
    [anon_sym_LPAREN2] = ACTIONS(6374),
    [anon_sym_TILDE] = ACTIONS(6374),
    [anon_sym_STAR] = ACTIONS(6374),
    [anon_sym_AMP_AMP] = ACTIONS(6374),
    [anon_sym_AMP] = ACTIONS(6372),
    [anon_sym_SEMI] = ACTIONS(6374),
    [anon_sym___extension__] = ACTIONS(6372),
    [anon_sym_typedef] = ACTIONS(6372),
    [anon_sym_in] = ACTIONS(6372),
    [anon_sym_out] = ACTIONS(6372),
    [anon_sym_inout] = ACTIONS(6372),
    [anon_sym_virtual] = ACTIONS(6372),
    [anon_sym_extern] = ACTIONS(6372),
    [anon_sym___attribute__] = ACTIONS(6372),
    [anon_sym___attribute] = ACTIONS(6372),
    [anon_sym_using] = ACTIONS(6372),
    [anon_sym_COLON_COLON] = ACTIONS(6374),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6374),
    [anon_sym___declspec] = ACTIONS(6372),
    [anon_sym___based] = ACTIONS(6372),
    [anon_sym_signed] = ACTIONS(6372),
    [anon_sym_unsigned] = ACTIONS(6372),
    [anon_sym_long] = ACTIONS(6372),
    [anon_sym_short] = ACTIONS(6372),
    [anon_sym_LBRACK] = ACTIONS(6372),
    [anon_sym_static] = ACTIONS(6372),
    [anon_sym_register] = ACTIONS(6372),
    [anon_sym_inline] = ACTIONS(6372),
    [anon_sym___inline] = ACTIONS(6372),
    [anon_sym___inline__] = ACTIONS(6372),
    [anon_sym___forceinline] = ACTIONS(6372),
    [anon_sym_thread_local] = ACTIONS(6372),
    [anon_sym___thread] = ACTIONS(6372),
    [anon_sym_const] = ACTIONS(6372),
    [anon_sym_constexpr] = ACTIONS(6372),
    [anon_sym_volatile] = ACTIONS(6372),
    [anon_sym_restrict] = ACTIONS(6372),
    [anon_sym___restrict__] = ACTIONS(6372),
    [anon_sym__Atomic] = ACTIONS(6372),
    [anon_sym__Noreturn] = ACTIONS(6372),
    [anon_sym_noreturn] = ACTIONS(6372),
    [anon_sym__Nonnull] = ACTIONS(6372),
    [anon_sym_mutable] = ACTIONS(6372),
    [anon_sym_constinit] = ACTIONS(6372),
    [anon_sym_consteval] = ACTIONS(6372),
    [anon_sym_alignas] = ACTIONS(6372),
    [anon_sym__Alignas] = ACTIONS(6372),
    [sym_primitive_type] = ACTIONS(6372),
    [anon_sym_enum] = ACTIONS(6372),
    [anon_sym_class] = ACTIONS(6372),
    [anon_sym_struct] = ACTIONS(6372),
    [anon_sym_union] = ACTIONS(6372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6372),
    [anon_sym_let] = ACTIONS(6372),
    [anon_sym_This] = ACTIONS(6372),
    [anon_sym_decltype] = ACTIONS(6372),
    [anon_sym_explicit] = ACTIONS(6372),
    [anon_sym_typename] = ACTIONS(6372),
    [anon_sym_private] = ACTIONS(6372),
    [anon_sym_template] = ACTIONS(6372),
    [anon_sym_operator] = ACTIONS(6372),
    [anon_sym_friend] = ACTIONS(6372),
    [anon_sym_public] = ACTIONS(6372),
    [anon_sym_protected] = ACTIONS(6372),
    [anon_sym_static_assert] = ACTIONS(6372),
    [anon_sym_precise] = ACTIONS(6372),
    [anon_sym_shared] = ACTIONS(6372),
    [anon_sym_groupshared] = ACTIONS(6372),
    [anon_sym_uniform] = ACTIONS(6372),
    [anon_sym_row_major] = ACTIONS(6372),
    [anon_sym_column_major] = ACTIONS(6372),
    [anon_sym_globallycoherent] = ACTIONS(6372),
    [anon_sym_centroid] = ACTIONS(6372),
    [anon_sym_noperspective] = ACTIONS(6372),
    [anon_sym_nointerpolation] = ACTIONS(6372),
    [anon_sym_sample] = ACTIONS(6372),
    [anon_sym_linear] = ACTIONS(6372),
    [anon_sym_snorm] = ACTIONS(6372),
    [anon_sym_unorm] = ACTIONS(6372),
    [anon_sym_point] = ACTIONS(6372),
    [anon_sym_line] = ACTIONS(6372),
    [anon_sym_triangleadj] = ACTIONS(6372),
    [anon_sym_lineadj] = ACTIONS(6372),
    [anon_sym_triangle] = ACTIONS(6372),
    [anon_sym_interface] = ACTIONS(6372),
    [anon_sym_extension] = ACTIONS(6372),
    [anon_sym___init] = ACTIONS(6372),
    [anon_sym___subscript] = ACTIONS(6372),
    [anon_sym_property] = ACTIONS(6372),
    [anon_sym_associatedtype] = ACTIONS(6372),
  },
  [1801] = {
    [sym_identifier] = ACTIONS(6372),
    [aux_sym_preproc_def_token1] = ACTIONS(6372),
    [aux_sym_preproc_if_token1] = ACTIONS(6372),
    [aux_sym_preproc_if_token2] = ACTIONS(6372),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6372),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6372),
    [aux_sym_preproc_else_token1] = ACTIONS(6372),
    [aux_sym_preproc_elif_token1] = ACTIONS(6372),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6372),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6372),
    [sym_preproc_directive] = ACTIONS(6372),
    [anon_sym_LPAREN2] = ACTIONS(6374),
    [anon_sym_TILDE] = ACTIONS(6374),
    [anon_sym_STAR] = ACTIONS(6374),
    [anon_sym_AMP_AMP] = ACTIONS(6374),
    [anon_sym_AMP] = ACTIONS(6372),
    [anon_sym_SEMI] = ACTIONS(6374),
    [anon_sym___extension__] = ACTIONS(6372),
    [anon_sym_typedef] = ACTIONS(6372),
    [anon_sym_in] = ACTIONS(6372),
    [anon_sym_out] = ACTIONS(6372),
    [anon_sym_inout] = ACTIONS(6372),
    [anon_sym_virtual] = ACTIONS(6372),
    [anon_sym_extern] = ACTIONS(6372),
    [anon_sym___attribute__] = ACTIONS(6372),
    [anon_sym___attribute] = ACTIONS(6372),
    [anon_sym_using] = ACTIONS(6372),
    [anon_sym_COLON_COLON] = ACTIONS(6374),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6374),
    [anon_sym___declspec] = ACTIONS(6372),
    [anon_sym___based] = ACTIONS(6372),
    [anon_sym_signed] = ACTIONS(6372),
    [anon_sym_unsigned] = ACTIONS(6372),
    [anon_sym_long] = ACTIONS(6372),
    [anon_sym_short] = ACTIONS(6372),
    [anon_sym_LBRACK] = ACTIONS(6372),
    [anon_sym_static] = ACTIONS(6372),
    [anon_sym_register] = ACTIONS(6372),
    [anon_sym_inline] = ACTIONS(6372),
    [anon_sym___inline] = ACTIONS(6372),
    [anon_sym___inline__] = ACTIONS(6372),
    [anon_sym___forceinline] = ACTIONS(6372),
    [anon_sym_thread_local] = ACTIONS(6372),
    [anon_sym___thread] = ACTIONS(6372),
    [anon_sym_const] = ACTIONS(6372),
    [anon_sym_constexpr] = ACTIONS(6372),
    [anon_sym_volatile] = ACTIONS(6372),
    [anon_sym_restrict] = ACTIONS(6372),
    [anon_sym___restrict__] = ACTIONS(6372),
    [anon_sym__Atomic] = ACTIONS(6372),
    [anon_sym__Noreturn] = ACTIONS(6372),
    [anon_sym_noreturn] = ACTIONS(6372),
    [anon_sym__Nonnull] = ACTIONS(6372),
    [anon_sym_mutable] = ACTIONS(6372),
    [anon_sym_constinit] = ACTIONS(6372),
    [anon_sym_consteval] = ACTIONS(6372),
    [anon_sym_alignas] = ACTIONS(6372),
    [anon_sym__Alignas] = ACTIONS(6372),
    [sym_primitive_type] = ACTIONS(6372),
    [anon_sym_enum] = ACTIONS(6372),
    [anon_sym_class] = ACTIONS(6372),
    [anon_sym_struct] = ACTIONS(6372),
    [anon_sym_union] = ACTIONS(6372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6372),
    [anon_sym_let] = ACTIONS(6372),
    [anon_sym_This] = ACTIONS(6372),
    [anon_sym_decltype] = ACTIONS(6372),
    [anon_sym_explicit] = ACTIONS(6372),
    [anon_sym_typename] = ACTIONS(6372),
    [anon_sym_private] = ACTIONS(6372),
    [anon_sym_template] = ACTIONS(6372),
    [anon_sym_operator] = ACTIONS(6372),
    [anon_sym_friend] = ACTIONS(6372),
    [anon_sym_public] = ACTIONS(6372),
    [anon_sym_protected] = ACTIONS(6372),
    [anon_sym_static_assert] = ACTIONS(6372),
    [anon_sym_precise] = ACTIONS(6372),
    [anon_sym_shared] = ACTIONS(6372),
    [anon_sym_groupshared] = ACTIONS(6372),
    [anon_sym_uniform] = ACTIONS(6372),
    [anon_sym_row_major] = ACTIONS(6372),
    [anon_sym_column_major] = ACTIONS(6372),
    [anon_sym_globallycoherent] = ACTIONS(6372),
    [anon_sym_centroid] = ACTIONS(6372),
    [anon_sym_noperspective] = ACTIONS(6372),
    [anon_sym_nointerpolation] = ACTIONS(6372),
    [anon_sym_sample] = ACTIONS(6372),
    [anon_sym_linear] = ACTIONS(6372),
    [anon_sym_snorm] = ACTIONS(6372),
    [anon_sym_unorm] = ACTIONS(6372),
    [anon_sym_point] = ACTIONS(6372),
    [anon_sym_line] = ACTIONS(6372),
    [anon_sym_triangleadj] = ACTIONS(6372),
    [anon_sym_lineadj] = ACTIONS(6372),
    [anon_sym_triangle] = ACTIONS(6372),
    [anon_sym_interface] = ACTIONS(6372),
    [anon_sym_extension] = ACTIONS(6372),
    [anon_sym___init] = ACTIONS(6372),
    [anon_sym___subscript] = ACTIONS(6372),
    [anon_sym_property] = ACTIONS(6372),
    [anon_sym_associatedtype] = ACTIONS(6372),
  },
  [1802] = {
    [sym_identifier] = ACTIONS(6372),
    [aux_sym_preproc_def_token1] = ACTIONS(6372),
    [aux_sym_preproc_if_token1] = ACTIONS(6372),
    [aux_sym_preproc_if_token2] = ACTIONS(6372),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6372),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6372),
    [aux_sym_preproc_else_token1] = ACTIONS(6372),
    [aux_sym_preproc_elif_token1] = ACTIONS(6372),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6372),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6372),
    [sym_preproc_directive] = ACTIONS(6372),
    [anon_sym_LPAREN2] = ACTIONS(6374),
    [anon_sym_TILDE] = ACTIONS(6374),
    [anon_sym_STAR] = ACTIONS(6374),
    [anon_sym_AMP_AMP] = ACTIONS(6374),
    [anon_sym_AMP] = ACTIONS(6372),
    [anon_sym_SEMI] = ACTIONS(6374),
    [anon_sym___extension__] = ACTIONS(6372),
    [anon_sym_typedef] = ACTIONS(6372),
    [anon_sym_in] = ACTIONS(6372),
    [anon_sym_out] = ACTIONS(6372),
    [anon_sym_inout] = ACTIONS(6372),
    [anon_sym_virtual] = ACTIONS(6372),
    [anon_sym_extern] = ACTIONS(6372),
    [anon_sym___attribute__] = ACTIONS(6372),
    [anon_sym___attribute] = ACTIONS(6372),
    [anon_sym_using] = ACTIONS(6372),
    [anon_sym_COLON_COLON] = ACTIONS(6374),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6374),
    [anon_sym___declspec] = ACTIONS(6372),
    [anon_sym___based] = ACTIONS(6372),
    [anon_sym_signed] = ACTIONS(6372),
    [anon_sym_unsigned] = ACTIONS(6372),
    [anon_sym_long] = ACTIONS(6372),
    [anon_sym_short] = ACTIONS(6372),
    [anon_sym_LBRACK] = ACTIONS(6372),
    [anon_sym_static] = ACTIONS(6372),
    [anon_sym_register] = ACTIONS(6372),
    [anon_sym_inline] = ACTIONS(6372),
    [anon_sym___inline] = ACTIONS(6372),
    [anon_sym___inline__] = ACTIONS(6372),
    [anon_sym___forceinline] = ACTIONS(6372),
    [anon_sym_thread_local] = ACTIONS(6372),
    [anon_sym___thread] = ACTIONS(6372),
    [anon_sym_const] = ACTIONS(6372),
    [anon_sym_constexpr] = ACTIONS(6372),
    [anon_sym_volatile] = ACTIONS(6372),
    [anon_sym_restrict] = ACTIONS(6372),
    [anon_sym___restrict__] = ACTIONS(6372),
    [anon_sym__Atomic] = ACTIONS(6372),
    [anon_sym__Noreturn] = ACTIONS(6372),
    [anon_sym_noreturn] = ACTIONS(6372),
    [anon_sym__Nonnull] = ACTIONS(6372),
    [anon_sym_mutable] = ACTIONS(6372),
    [anon_sym_constinit] = ACTIONS(6372),
    [anon_sym_consteval] = ACTIONS(6372),
    [anon_sym_alignas] = ACTIONS(6372),
    [anon_sym__Alignas] = ACTIONS(6372),
    [sym_primitive_type] = ACTIONS(6372),
    [anon_sym_enum] = ACTIONS(6372),
    [anon_sym_class] = ACTIONS(6372),
    [anon_sym_struct] = ACTIONS(6372),
    [anon_sym_union] = ACTIONS(6372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6372),
    [anon_sym_let] = ACTIONS(6372),
    [anon_sym_This] = ACTIONS(6372),
    [anon_sym_decltype] = ACTIONS(6372),
    [anon_sym_explicit] = ACTIONS(6372),
    [anon_sym_typename] = ACTIONS(6372),
    [anon_sym_private] = ACTIONS(6372),
    [anon_sym_template] = ACTIONS(6372),
    [anon_sym_operator] = ACTIONS(6372),
    [anon_sym_friend] = ACTIONS(6372),
    [anon_sym_public] = ACTIONS(6372),
    [anon_sym_protected] = ACTIONS(6372),
    [anon_sym_static_assert] = ACTIONS(6372),
    [anon_sym_precise] = ACTIONS(6372),
    [anon_sym_shared] = ACTIONS(6372),
    [anon_sym_groupshared] = ACTIONS(6372),
    [anon_sym_uniform] = ACTIONS(6372),
    [anon_sym_row_major] = ACTIONS(6372),
    [anon_sym_column_major] = ACTIONS(6372),
    [anon_sym_globallycoherent] = ACTIONS(6372),
    [anon_sym_centroid] = ACTIONS(6372),
    [anon_sym_noperspective] = ACTIONS(6372),
    [anon_sym_nointerpolation] = ACTIONS(6372),
    [anon_sym_sample] = ACTIONS(6372),
    [anon_sym_linear] = ACTIONS(6372),
    [anon_sym_snorm] = ACTIONS(6372),
    [anon_sym_unorm] = ACTIONS(6372),
    [anon_sym_point] = ACTIONS(6372),
    [anon_sym_line] = ACTIONS(6372),
    [anon_sym_triangleadj] = ACTIONS(6372),
    [anon_sym_lineadj] = ACTIONS(6372),
    [anon_sym_triangle] = ACTIONS(6372),
    [anon_sym_interface] = ACTIONS(6372),
    [anon_sym_extension] = ACTIONS(6372),
    [anon_sym___init] = ACTIONS(6372),
    [anon_sym___subscript] = ACTIONS(6372),
    [anon_sym_property] = ACTIONS(6372),
    [anon_sym_associatedtype] = ACTIONS(6372),
  },
  [1803] = {
    [sym_identifier] = ACTIONS(6368),
    [aux_sym_preproc_def_token1] = ACTIONS(6368),
    [aux_sym_preproc_if_token1] = ACTIONS(6368),
    [aux_sym_preproc_if_token2] = ACTIONS(6368),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6368),
    [aux_sym_preproc_else_token1] = ACTIONS(6368),
    [aux_sym_preproc_elif_token1] = ACTIONS(6368),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6368),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6368),
    [sym_preproc_directive] = ACTIONS(6368),
    [anon_sym_LPAREN2] = ACTIONS(6370),
    [anon_sym_TILDE] = ACTIONS(6370),
    [anon_sym_STAR] = ACTIONS(6370),
    [anon_sym_AMP_AMP] = ACTIONS(6370),
    [anon_sym_AMP] = ACTIONS(6368),
    [anon_sym_SEMI] = ACTIONS(6370),
    [anon_sym___extension__] = ACTIONS(6368),
    [anon_sym_typedef] = ACTIONS(6368),
    [anon_sym_in] = ACTIONS(6368),
    [anon_sym_out] = ACTIONS(6368),
    [anon_sym_inout] = ACTIONS(6368),
    [anon_sym_virtual] = ACTIONS(6368),
    [anon_sym_extern] = ACTIONS(6368),
    [anon_sym___attribute__] = ACTIONS(6368),
    [anon_sym___attribute] = ACTIONS(6368),
    [anon_sym_using] = ACTIONS(6368),
    [anon_sym_COLON_COLON] = ACTIONS(6370),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6370),
    [anon_sym___declspec] = ACTIONS(6368),
    [anon_sym___based] = ACTIONS(6368),
    [anon_sym_signed] = ACTIONS(6368),
    [anon_sym_unsigned] = ACTIONS(6368),
    [anon_sym_long] = ACTIONS(6368),
    [anon_sym_short] = ACTIONS(6368),
    [anon_sym_LBRACK] = ACTIONS(6368),
    [anon_sym_static] = ACTIONS(6368),
    [anon_sym_register] = ACTIONS(6368),
    [anon_sym_inline] = ACTIONS(6368),
    [anon_sym___inline] = ACTIONS(6368),
    [anon_sym___inline__] = ACTIONS(6368),
    [anon_sym___forceinline] = ACTIONS(6368),
    [anon_sym_thread_local] = ACTIONS(6368),
    [anon_sym___thread] = ACTIONS(6368),
    [anon_sym_const] = ACTIONS(6368),
    [anon_sym_constexpr] = ACTIONS(6368),
    [anon_sym_volatile] = ACTIONS(6368),
    [anon_sym_restrict] = ACTIONS(6368),
    [anon_sym___restrict__] = ACTIONS(6368),
    [anon_sym__Atomic] = ACTIONS(6368),
    [anon_sym__Noreturn] = ACTIONS(6368),
    [anon_sym_noreturn] = ACTIONS(6368),
    [anon_sym__Nonnull] = ACTIONS(6368),
    [anon_sym_mutable] = ACTIONS(6368),
    [anon_sym_constinit] = ACTIONS(6368),
    [anon_sym_consteval] = ACTIONS(6368),
    [anon_sym_alignas] = ACTIONS(6368),
    [anon_sym__Alignas] = ACTIONS(6368),
    [sym_primitive_type] = ACTIONS(6368),
    [anon_sym_enum] = ACTIONS(6368),
    [anon_sym_class] = ACTIONS(6368),
    [anon_sym_struct] = ACTIONS(6368),
    [anon_sym_union] = ACTIONS(6368),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6368),
    [anon_sym_let] = ACTIONS(6368),
    [anon_sym_This] = ACTIONS(6368),
    [anon_sym_decltype] = ACTIONS(6368),
    [anon_sym_explicit] = ACTIONS(6368),
    [anon_sym_typename] = ACTIONS(6368),
    [anon_sym_private] = ACTIONS(6368),
    [anon_sym_template] = ACTIONS(6368),
    [anon_sym_operator] = ACTIONS(6368),
    [anon_sym_friend] = ACTIONS(6368),
    [anon_sym_public] = ACTIONS(6368),
    [anon_sym_protected] = ACTIONS(6368),
    [anon_sym_static_assert] = ACTIONS(6368),
    [anon_sym_precise] = ACTIONS(6368),
    [anon_sym_shared] = ACTIONS(6368),
    [anon_sym_groupshared] = ACTIONS(6368),
    [anon_sym_uniform] = ACTIONS(6368),
    [anon_sym_row_major] = ACTIONS(6368),
    [anon_sym_column_major] = ACTIONS(6368),
    [anon_sym_globallycoherent] = ACTIONS(6368),
    [anon_sym_centroid] = ACTIONS(6368),
    [anon_sym_noperspective] = ACTIONS(6368),
    [anon_sym_nointerpolation] = ACTIONS(6368),
    [anon_sym_sample] = ACTIONS(6368),
    [anon_sym_linear] = ACTIONS(6368),
    [anon_sym_snorm] = ACTIONS(6368),
    [anon_sym_unorm] = ACTIONS(6368),
    [anon_sym_point] = ACTIONS(6368),
    [anon_sym_line] = ACTIONS(6368),
    [anon_sym_triangleadj] = ACTIONS(6368),
    [anon_sym_lineadj] = ACTIONS(6368),
    [anon_sym_triangle] = ACTIONS(6368),
    [anon_sym_interface] = ACTIONS(6368),
    [anon_sym_extension] = ACTIONS(6368),
    [anon_sym___init] = ACTIONS(6368),
    [anon_sym___subscript] = ACTIONS(6368),
    [anon_sym_property] = ACTIONS(6368),
    [anon_sym_associatedtype] = ACTIONS(6368),
  },
  [1804] = {
    [sym_identifier] = ACTIONS(3935),
    [aux_sym_preproc_def_token1] = ACTIONS(3935),
    [aux_sym_preproc_if_token1] = ACTIONS(3935),
    [aux_sym_preproc_if_token2] = ACTIONS(3935),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3935),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3935),
    [aux_sym_preproc_else_token1] = ACTIONS(3935),
    [aux_sym_preproc_elif_token1] = ACTIONS(3935),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3935),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3935),
    [sym_preproc_directive] = ACTIONS(3935),
    [anon_sym_LPAREN2] = ACTIONS(3937),
    [anon_sym_TILDE] = ACTIONS(3937),
    [anon_sym_STAR] = ACTIONS(3937),
    [anon_sym_AMP_AMP] = ACTIONS(3937),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_SEMI] = ACTIONS(3937),
    [anon_sym___extension__] = ACTIONS(3935),
    [anon_sym_typedef] = ACTIONS(3935),
    [anon_sym_in] = ACTIONS(3935),
    [anon_sym_out] = ACTIONS(3935),
    [anon_sym_inout] = ACTIONS(3935),
    [anon_sym_virtual] = ACTIONS(3935),
    [anon_sym_extern] = ACTIONS(3935),
    [anon_sym___attribute__] = ACTIONS(3935),
    [anon_sym___attribute] = ACTIONS(3935),
    [anon_sym_using] = ACTIONS(3935),
    [anon_sym_COLON_COLON] = ACTIONS(3937),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3937),
    [anon_sym___declspec] = ACTIONS(3935),
    [anon_sym___based] = ACTIONS(3935),
    [anon_sym_signed] = ACTIONS(3935),
    [anon_sym_unsigned] = ACTIONS(3935),
    [anon_sym_long] = ACTIONS(3935),
    [anon_sym_short] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3935),
    [anon_sym_static] = ACTIONS(3935),
    [anon_sym_register] = ACTIONS(3935),
    [anon_sym_inline] = ACTIONS(3935),
    [anon_sym___inline] = ACTIONS(3935),
    [anon_sym___inline__] = ACTIONS(3935),
    [anon_sym___forceinline] = ACTIONS(3935),
    [anon_sym_thread_local] = ACTIONS(3935),
    [anon_sym___thread] = ACTIONS(3935),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_constexpr] = ACTIONS(3935),
    [anon_sym_volatile] = ACTIONS(3935),
    [anon_sym_restrict] = ACTIONS(3935),
    [anon_sym___restrict__] = ACTIONS(3935),
    [anon_sym__Atomic] = ACTIONS(3935),
    [anon_sym__Noreturn] = ACTIONS(3935),
    [anon_sym_noreturn] = ACTIONS(3935),
    [anon_sym__Nonnull] = ACTIONS(3935),
    [anon_sym_mutable] = ACTIONS(3935),
    [anon_sym_constinit] = ACTIONS(3935),
    [anon_sym_consteval] = ACTIONS(3935),
    [anon_sym_alignas] = ACTIONS(3935),
    [anon_sym__Alignas] = ACTIONS(3935),
    [sym_primitive_type] = ACTIONS(3935),
    [anon_sym_enum] = ACTIONS(3935),
    [anon_sym_class] = ACTIONS(3935),
    [anon_sym_struct] = ACTIONS(3935),
    [anon_sym_union] = ACTIONS(3935),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3935),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_This] = ACTIONS(3935),
    [anon_sym_decltype] = ACTIONS(3935),
    [anon_sym_explicit] = ACTIONS(3935),
    [anon_sym_typename] = ACTIONS(3935),
    [anon_sym_private] = ACTIONS(3935),
    [anon_sym_template] = ACTIONS(3935),
    [anon_sym_operator] = ACTIONS(3935),
    [anon_sym_friend] = ACTIONS(3935),
    [anon_sym_public] = ACTIONS(3935),
    [anon_sym_protected] = ACTIONS(3935),
    [anon_sym_static_assert] = ACTIONS(3935),
    [anon_sym_precise] = ACTIONS(3935),
    [anon_sym_shared] = ACTIONS(3935),
    [anon_sym_groupshared] = ACTIONS(3935),
    [anon_sym_uniform] = ACTIONS(3935),
    [anon_sym_row_major] = ACTIONS(3935),
    [anon_sym_column_major] = ACTIONS(3935),
    [anon_sym_globallycoherent] = ACTIONS(3935),
    [anon_sym_centroid] = ACTIONS(3935),
    [anon_sym_noperspective] = ACTIONS(3935),
    [anon_sym_nointerpolation] = ACTIONS(3935),
    [anon_sym_sample] = ACTIONS(3935),
    [anon_sym_linear] = ACTIONS(3935),
    [anon_sym_snorm] = ACTIONS(3935),
    [anon_sym_unorm] = ACTIONS(3935),
    [anon_sym_point] = ACTIONS(3935),
    [anon_sym_line] = ACTIONS(3935),
    [anon_sym_triangleadj] = ACTIONS(3935),
    [anon_sym_lineadj] = ACTIONS(3935),
    [anon_sym_triangle] = ACTIONS(3935),
    [anon_sym_interface] = ACTIONS(3935),
    [anon_sym_extension] = ACTIONS(3935),
    [anon_sym___init] = ACTIONS(3935),
    [anon_sym___subscript] = ACTIONS(3935),
    [anon_sym_property] = ACTIONS(3935),
    [anon_sym_associatedtype] = ACTIONS(3935),
  },
  [1805] = {
    [sym_identifier] = ACTIONS(6140),
    [aux_sym_preproc_def_token1] = ACTIONS(6140),
    [aux_sym_preproc_if_token1] = ACTIONS(6140),
    [aux_sym_preproc_if_token2] = ACTIONS(6140),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6140),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6140),
    [aux_sym_preproc_else_token1] = ACTIONS(6140),
    [aux_sym_preproc_elif_token1] = ACTIONS(6140),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6140),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6140),
    [sym_preproc_directive] = ACTIONS(6140),
    [anon_sym_LPAREN2] = ACTIONS(6142),
    [anon_sym_TILDE] = ACTIONS(6142),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_AMP_AMP] = ACTIONS(6142),
    [anon_sym_AMP] = ACTIONS(6140),
    [anon_sym_SEMI] = ACTIONS(6142),
    [anon_sym___extension__] = ACTIONS(6140),
    [anon_sym_typedef] = ACTIONS(6140),
    [anon_sym_in] = ACTIONS(6140),
    [anon_sym_out] = ACTIONS(6140),
    [anon_sym_inout] = ACTIONS(6140),
    [anon_sym_virtual] = ACTIONS(6140),
    [anon_sym_extern] = ACTIONS(6140),
    [anon_sym___attribute__] = ACTIONS(6140),
    [anon_sym___attribute] = ACTIONS(6140),
    [anon_sym_using] = ACTIONS(6140),
    [anon_sym_COLON_COLON] = ACTIONS(6142),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6142),
    [anon_sym___declspec] = ACTIONS(6140),
    [anon_sym___based] = ACTIONS(6140),
    [anon_sym_signed] = ACTIONS(6140),
    [anon_sym_unsigned] = ACTIONS(6140),
    [anon_sym_long] = ACTIONS(6140),
    [anon_sym_short] = ACTIONS(6140),
    [anon_sym_LBRACK] = ACTIONS(6140),
    [anon_sym_static] = ACTIONS(6140),
    [anon_sym_register] = ACTIONS(6140),
    [anon_sym_inline] = ACTIONS(6140),
    [anon_sym___inline] = ACTIONS(6140),
    [anon_sym___inline__] = ACTIONS(6140),
    [anon_sym___forceinline] = ACTIONS(6140),
    [anon_sym_thread_local] = ACTIONS(6140),
    [anon_sym___thread] = ACTIONS(6140),
    [anon_sym_const] = ACTIONS(6140),
    [anon_sym_constexpr] = ACTIONS(6140),
    [anon_sym_volatile] = ACTIONS(6140),
    [anon_sym_restrict] = ACTIONS(6140),
    [anon_sym___restrict__] = ACTIONS(6140),
    [anon_sym__Atomic] = ACTIONS(6140),
    [anon_sym__Noreturn] = ACTIONS(6140),
    [anon_sym_noreturn] = ACTIONS(6140),
    [anon_sym__Nonnull] = ACTIONS(6140),
    [anon_sym_mutable] = ACTIONS(6140),
    [anon_sym_constinit] = ACTIONS(6140),
    [anon_sym_consteval] = ACTIONS(6140),
    [anon_sym_alignas] = ACTIONS(6140),
    [anon_sym__Alignas] = ACTIONS(6140),
    [sym_primitive_type] = ACTIONS(6140),
    [anon_sym_enum] = ACTIONS(6140),
    [anon_sym_class] = ACTIONS(6140),
    [anon_sym_struct] = ACTIONS(6140),
    [anon_sym_union] = ACTIONS(6140),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6140),
    [anon_sym_let] = ACTIONS(6140),
    [anon_sym_This] = ACTIONS(6140),
    [anon_sym_decltype] = ACTIONS(6140),
    [anon_sym_explicit] = ACTIONS(6140),
    [anon_sym_typename] = ACTIONS(6140),
    [anon_sym_private] = ACTIONS(6140),
    [anon_sym_template] = ACTIONS(6140),
    [anon_sym_operator] = ACTIONS(6140),
    [anon_sym_friend] = ACTIONS(6140),
    [anon_sym_public] = ACTIONS(6140),
    [anon_sym_protected] = ACTIONS(6140),
    [anon_sym_static_assert] = ACTIONS(6140),
    [anon_sym_precise] = ACTIONS(6140),
    [anon_sym_shared] = ACTIONS(6140),
    [anon_sym_groupshared] = ACTIONS(6140),
    [anon_sym_uniform] = ACTIONS(6140),
    [anon_sym_row_major] = ACTIONS(6140),
    [anon_sym_column_major] = ACTIONS(6140),
    [anon_sym_globallycoherent] = ACTIONS(6140),
    [anon_sym_centroid] = ACTIONS(6140),
    [anon_sym_noperspective] = ACTIONS(6140),
    [anon_sym_nointerpolation] = ACTIONS(6140),
    [anon_sym_sample] = ACTIONS(6140),
    [anon_sym_linear] = ACTIONS(6140),
    [anon_sym_snorm] = ACTIONS(6140),
    [anon_sym_unorm] = ACTIONS(6140),
    [anon_sym_point] = ACTIONS(6140),
    [anon_sym_line] = ACTIONS(6140),
    [anon_sym_triangleadj] = ACTIONS(6140),
    [anon_sym_lineadj] = ACTIONS(6140),
    [anon_sym_triangle] = ACTIONS(6140),
    [anon_sym_interface] = ACTIONS(6140),
    [anon_sym_extension] = ACTIONS(6140),
    [anon_sym___init] = ACTIONS(6140),
    [anon_sym___subscript] = ACTIONS(6140),
    [anon_sym_property] = ACTIONS(6140),
    [anon_sym_associatedtype] = ACTIONS(6140),
  },
  [1806] = {
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token2] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [aux_sym_preproc_else_token1] = ACTIONS(3942),
    [aux_sym_preproc_elif_token1] = ACTIONS(3942),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_private] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_friend] = ACTIONS(3942),
    [anon_sym_public] = ACTIONS(3942),
    [anon_sym_protected] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
    [anon_sym___init] = ACTIONS(3942),
    [anon_sym___subscript] = ACTIONS(3942),
    [anon_sym_property] = ACTIONS(3942),
    [anon_sym_associatedtype] = ACTIONS(3942),
  },
  [1807] = {
    [sym_identifier] = ACTIONS(3771),
    [aux_sym_preproc_def_token1] = ACTIONS(3771),
    [aux_sym_preproc_if_token1] = ACTIONS(3771),
    [aux_sym_preproc_if_token2] = ACTIONS(3771),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3771),
    [aux_sym_preproc_else_token1] = ACTIONS(3771),
    [aux_sym_preproc_elif_token1] = ACTIONS(3771),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3771),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3771),
    [sym_preproc_directive] = ACTIONS(3771),
    [anon_sym_LPAREN2] = ACTIONS(3773),
    [anon_sym_TILDE] = ACTIONS(3773),
    [anon_sym_STAR] = ACTIONS(3773),
    [anon_sym_AMP_AMP] = ACTIONS(3773),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_SEMI] = ACTIONS(3773),
    [anon_sym___extension__] = ACTIONS(3771),
    [anon_sym_typedef] = ACTIONS(3771),
    [anon_sym_in] = ACTIONS(3771),
    [anon_sym_out] = ACTIONS(3771),
    [anon_sym_inout] = ACTIONS(3771),
    [anon_sym_virtual] = ACTIONS(3771),
    [anon_sym_extern] = ACTIONS(3771),
    [anon_sym___attribute__] = ACTIONS(3771),
    [anon_sym___attribute] = ACTIONS(3771),
    [anon_sym_using] = ACTIONS(3771),
    [anon_sym_COLON_COLON] = ACTIONS(3773),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3773),
    [anon_sym___declspec] = ACTIONS(3771),
    [anon_sym___based] = ACTIONS(3771),
    [anon_sym_signed] = ACTIONS(3771),
    [anon_sym_unsigned] = ACTIONS(3771),
    [anon_sym_long] = ACTIONS(3771),
    [anon_sym_short] = ACTIONS(3771),
    [anon_sym_LBRACK] = ACTIONS(3771),
    [anon_sym_static] = ACTIONS(3771),
    [anon_sym_register] = ACTIONS(3771),
    [anon_sym_inline] = ACTIONS(3771),
    [anon_sym___inline] = ACTIONS(3771),
    [anon_sym___inline__] = ACTIONS(3771),
    [anon_sym___forceinline] = ACTIONS(3771),
    [anon_sym_thread_local] = ACTIONS(3771),
    [anon_sym___thread] = ACTIONS(3771),
    [anon_sym_const] = ACTIONS(3771),
    [anon_sym_constexpr] = ACTIONS(3771),
    [anon_sym_volatile] = ACTIONS(3771),
    [anon_sym_restrict] = ACTIONS(3771),
    [anon_sym___restrict__] = ACTIONS(3771),
    [anon_sym__Atomic] = ACTIONS(3771),
    [anon_sym__Noreturn] = ACTIONS(3771),
    [anon_sym_noreturn] = ACTIONS(3771),
    [anon_sym__Nonnull] = ACTIONS(3771),
    [anon_sym_mutable] = ACTIONS(3771),
    [anon_sym_constinit] = ACTIONS(3771),
    [anon_sym_consteval] = ACTIONS(3771),
    [anon_sym_alignas] = ACTIONS(3771),
    [anon_sym__Alignas] = ACTIONS(3771),
    [sym_primitive_type] = ACTIONS(3771),
    [anon_sym_enum] = ACTIONS(3771),
    [anon_sym_class] = ACTIONS(3771),
    [anon_sym_struct] = ACTIONS(3771),
    [anon_sym_union] = ACTIONS(3771),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3771),
    [anon_sym_let] = ACTIONS(3771),
    [anon_sym_This] = ACTIONS(3771),
    [anon_sym_decltype] = ACTIONS(3771),
    [anon_sym_explicit] = ACTIONS(3771),
    [anon_sym_typename] = ACTIONS(3771),
    [anon_sym_private] = ACTIONS(3771),
    [anon_sym_template] = ACTIONS(3771),
    [anon_sym_operator] = ACTIONS(3771),
    [anon_sym_friend] = ACTIONS(3771),
    [anon_sym_public] = ACTIONS(3771),
    [anon_sym_protected] = ACTIONS(3771),
    [anon_sym_static_assert] = ACTIONS(3771),
    [anon_sym_precise] = ACTIONS(3771),
    [anon_sym_shared] = ACTIONS(3771),
    [anon_sym_groupshared] = ACTIONS(3771),
    [anon_sym_uniform] = ACTIONS(3771),
    [anon_sym_row_major] = ACTIONS(3771),
    [anon_sym_column_major] = ACTIONS(3771),
    [anon_sym_globallycoherent] = ACTIONS(3771),
    [anon_sym_centroid] = ACTIONS(3771),
    [anon_sym_noperspective] = ACTIONS(3771),
    [anon_sym_nointerpolation] = ACTIONS(3771),
    [anon_sym_sample] = ACTIONS(3771),
    [anon_sym_linear] = ACTIONS(3771),
    [anon_sym_snorm] = ACTIONS(3771),
    [anon_sym_unorm] = ACTIONS(3771),
    [anon_sym_point] = ACTIONS(3771),
    [anon_sym_line] = ACTIONS(3771),
    [anon_sym_triangleadj] = ACTIONS(3771),
    [anon_sym_lineadj] = ACTIONS(3771),
    [anon_sym_triangle] = ACTIONS(3771),
    [anon_sym_interface] = ACTIONS(3771),
    [anon_sym_extension] = ACTIONS(3771),
    [anon_sym___init] = ACTIONS(3771),
    [anon_sym___subscript] = ACTIONS(3771),
    [anon_sym_property] = ACTIONS(3771),
    [anon_sym_associatedtype] = ACTIONS(3771),
  },
  [1808] = {
    [sym_identifier] = ACTIONS(3792),
    [aux_sym_preproc_def_token1] = ACTIONS(3792),
    [aux_sym_preproc_if_token1] = ACTIONS(3792),
    [aux_sym_preproc_if_token2] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3792),
    [aux_sym_preproc_else_token1] = ACTIONS(3792),
    [aux_sym_preproc_elif_token1] = ACTIONS(3792),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3792),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3792),
    [sym_preproc_directive] = ACTIONS(3792),
    [anon_sym_LPAREN2] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3794),
    [anon_sym_STAR] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_AMP] = ACTIONS(3792),
    [anon_sym_SEMI] = ACTIONS(3794),
    [anon_sym___extension__] = ACTIONS(3792),
    [anon_sym_typedef] = ACTIONS(3792),
    [anon_sym_in] = ACTIONS(3792),
    [anon_sym_out] = ACTIONS(3792),
    [anon_sym_inout] = ACTIONS(3792),
    [anon_sym_virtual] = ACTIONS(3792),
    [anon_sym_extern] = ACTIONS(3792),
    [anon_sym___attribute__] = ACTIONS(3792),
    [anon_sym___attribute] = ACTIONS(3792),
    [anon_sym_using] = ACTIONS(3792),
    [anon_sym_COLON_COLON] = ACTIONS(3794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3794),
    [anon_sym___declspec] = ACTIONS(3792),
    [anon_sym___based] = ACTIONS(3792),
    [anon_sym_signed] = ACTIONS(3792),
    [anon_sym_unsigned] = ACTIONS(3792),
    [anon_sym_long] = ACTIONS(3792),
    [anon_sym_short] = ACTIONS(3792),
    [anon_sym_LBRACK] = ACTIONS(3792),
    [anon_sym_static] = ACTIONS(3792),
    [anon_sym_register] = ACTIONS(3792),
    [anon_sym_inline] = ACTIONS(3792),
    [anon_sym___inline] = ACTIONS(3792),
    [anon_sym___inline__] = ACTIONS(3792),
    [anon_sym___forceinline] = ACTIONS(3792),
    [anon_sym_thread_local] = ACTIONS(3792),
    [anon_sym___thread] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3792),
    [anon_sym_constexpr] = ACTIONS(3792),
    [anon_sym_volatile] = ACTIONS(3792),
    [anon_sym_restrict] = ACTIONS(3792),
    [anon_sym___restrict__] = ACTIONS(3792),
    [anon_sym__Atomic] = ACTIONS(3792),
    [anon_sym__Noreturn] = ACTIONS(3792),
    [anon_sym_noreturn] = ACTIONS(3792),
    [anon_sym__Nonnull] = ACTIONS(3792),
    [anon_sym_mutable] = ACTIONS(3792),
    [anon_sym_constinit] = ACTIONS(3792),
    [anon_sym_consteval] = ACTIONS(3792),
    [anon_sym_alignas] = ACTIONS(3792),
    [anon_sym__Alignas] = ACTIONS(3792),
    [sym_primitive_type] = ACTIONS(3792),
    [anon_sym_enum] = ACTIONS(3792),
    [anon_sym_class] = ACTIONS(3792),
    [anon_sym_struct] = ACTIONS(3792),
    [anon_sym_union] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3792),
    [anon_sym_let] = ACTIONS(3792),
    [anon_sym_This] = ACTIONS(3792),
    [anon_sym_decltype] = ACTIONS(3792),
    [anon_sym_explicit] = ACTIONS(3792),
    [anon_sym_typename] = ACTIONS(3792),
    [anon_sym_private] = ACTIONS(3792),
    [anon_sym_template] = ACTIONS(3792),
    [anon_sym_operator] = ACTIONS(3792),
    [anon_sym_friend] = ACTIONS(3792),
    [anon_sym_public] = ACTIONS(3792),
    [anon_sym_protected] = ACTIONS(3792),
    [anon_sym_static_assert] = ACTIONS(3792),
    [anon_sym_precise] = ACTIONS(3792),
    [anon_sym_shared] = ACTIONS(3792),
    [anon_sym_groupshared] = ACTIONS(3792),
    [anon_sym_uniform] = ACTIONS(3792),
    [anon_sym_row_major] = ACTIONS(3792),
    [anon_sym_column_major] = ACTIONS(3792),
    [anon_sym_globallycoherent] = ACTIONS(3792),
    [anon_sym_centroid] = ACTIONS(3792),
    [anon_sym_noperspective] = ACTIONS(3792),
    [anon_sym_nointerpolation] = ACTIONS(3792),
    [anon_sym_sample] = ACTIONS(3792),
    [anon_sym_linear] = ACTIONS(3792),
    [anon_sym_snorm] = ACTIONS(3792),
    [anon_sym_unorm] = ACTIONS(3792),
    [anon_sym_point] = ACTIONS(3792),
    [anon_sym_line] = ACTIONS(3792),
    [anon_sym_triangleadj] = ACTIONS(3792),
    [anon_sym_lineadj] = ACTIONS(3792),
    [anon_sym_triangle] = ACTIONS(3792),
    [anon_sym_interface] = ACTIONS(3792),
    [anon_sym_extension] = ACTIONS(3792),
    [anon_sym___init] = ACTIONS(3792),
    [anon_sym___subscript] = ACTIONS(3792),
    [anon_sym_property] = ACTIONS(3792),
    [anon_sym_associatedtype] = ACTIONS(3792),
  },
  [1809] = {
    [sym_identifier] = ACTIONS(3792),
    [aux_sym_preproc_def_token1] = ACTIONS(3792),
    [aux_sym_preproc_if_token1] = ACTIONS(3792),
    [aux_sym_preproc_if_token2] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3792),
    [aux_sym_preproc_else_token1] = ACTIONS(3792),
    [aux_sym_preproc_elif_token1] = ACTIONS(3792),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3792),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3792),
    [sym_preproc_directive] = ACTIONS(3792),
    [anon_sym_LPAREN2] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3794),
    [anon_sym_STAR] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_AMP] = ACTIONS(3792),
    [anon_sym_SEMI] = ACTIONS(3794),
    [anon_sym___extension__] = ACTIONS(3792),
    [anon_sym_typedef] = ACTIONS(3792),
    [anon_sym_in] = ACTIONS(3792),
    [anon_sym_out] = ACTIONS(3792),
    [anon_sym_inout] = ACTIONS(3792),
    [anon_sym_virtual] = ACTIONS(3792),
    [anon_sym_extern] = ACTIONS(3792),
    [anon_sym___attribute__] = ACTIONS(3792),
    [anon_sym___attribute] = ACTIONS(3792),
    [anon_sym_using] = ACTIONS(3792),
    [anon_sym_COLON_COLON] = ACTIONS(3794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3794),
    [anon_sym___declspec] = ACTIONS(3792),
    [anon_sym___based] = ACTIONS(3792),
    [anon_sym_signed] = ACTIONS(3792),
    [anon_sym_unsigned] = ACTIONS(3792),
    [anon_sym_long] = ACTIONS(3792),
    [anon_sym_short] = ACTIONS(3792),
    [anon_sym_LBRACK] = ACTIONS(3792),
    [anon_sym_static] = ACTIONS(3792),
    [anon_sym_register] = ACTIONS(3792),
    [anon_sym_inline] = ACTIONS(3792),
    [anon_sym___inline] = ACTIONS(3792),
    [anon_sym___inline__] = ACTIONS(3792),
    [anon_sym___forceinline] = ACTIONS(3792),
    [anon_sym_thread_local] = ACTIONS(3792),
    [anon_sym___thread] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3792),
    [anon_sym_constexpr] = ACTIONS(3792),
    [anon_sym_volatile] = ACTIONS(3792),
    [anon_sym_restrict] = ACTIONS(3792),
    [anon_sym___restrict__] = ACTIONS(3792),
    [anon_sym__Atomic] = ACTIONS(3792),
    [anon_sym__Noreturn] = ACTIONS(3792),
    [anon_sym_noreturn] = ACTIONS(3792),
    [anon_sym__Nonnull] = ACTIONS(3792),
    [anon_sym_mutable] = ACTIONS(3792),
    [anon_sym_constinit] = ACTIONS(3792),
    [anon_sym_consteval] = ACTIONS(3792),
    [anon_sym_alignas] = ACTIONS(3792),
    [anon_sym__Alignas] = ACTIONS(3792),
    [sym_primitive_type] = ACTIONS(3792),
    [anon_sym_enum] = ACTIONS(3792),
    [anon_sym_class] = ACTIONS(3792),
    [anon_sym_struct] = ACTIONS(3792),
    [anon_sym_union] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3792),
    [anon_sym_let] = ACTIONS(3792),
    [anon_sym_This] = ACTIONS(3792),
    [anon_sym_decltype] = ACTIONS(3792),
    [anon_sym_explicit] = ACTIONS(3792),
    [anon_sym_typename] = ACTIONS(3792),
    [anon_sym_private] = ACTIONS(3792),
    [anon_sym_template] = ACTIONS(3792),
    [anon_sym_operator] = ACTIONS(3792),
    [anon_sym_friend] = ACTIONS(3792),
    [anon_sym_public] = ACTIONS(3792),
    [anon_sym_protected] = ACTIONS(3792),
    [anon_sym_static_assert] = ACTIONS(3792),
    [anon_sym_precise] = ACTIONS(3792),
    [anon_sym_shared] = ACTIONS(3792),
    [anon_sym_groupshared] = ACTIONS(3792),
    [anon_sym_uniform] = ACTIONS(3792),
    [anon_sym_row_major] = ACTIONS(3792),
    [anon_sym_column_major] = ACTIONS(3792),
    [anon_sym_globallycoherent] = ACTIONS(3792),
    [anon_sym_centroid] = ACTIONS(3792),
    [anon_sym_noperspective] = ACTIONS(3792),
    [anon_sym_nointerpolation] = ACTIONS(3792),
    [anon_sym_sample] = ACTIONS(3792),
    [anon_sym_linear] = ACTIONS(3792),
    [anon_sym_snorm] = ACTIONS(3792),
    [anon_sym_unorm] = ACTIONS(3792),
    [anon_sym_point] = ACTIONS(3792),
    [anon_sym_line] = ACTIONS(3792),
    [anon_sym_triangleadj] = ACTIONS(3792),
    [anon_sym_lineadj] = ACTIONS(3792),
    [anon_sym_triangle] = ACTIONS(3792),
    [anon_sym_interface] = ACTIONS(3792),
    [anon_sym_extension] = ACTIONS(3792),
    [anon_sym___init] = ACTIONS(3792),
    [anon_sym___subscript] = ACTIONS(3792),
    [anon_sym_property] = ACTIONS(3792),
    [anon_sym_associatedtype] = ACTIONS(3792),
  },
  [1810] = {
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token2] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [aux_sym_preproc_else_token1] = ACTIONS(3812),
    [aux_sym_preproc_elif_token1] = ACTIONS(3812),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_private] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_friend] = ACTIONS(3812),
    [anon_sym_public] = ACTIONS(3812),
    [anon_sym_protected] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
    [anon_sym___init] = ACTIONS(3812),
    [anon_sym___subscript] = ACTIONS(3812),
    [anon_sym_property] = ACTIONS(3812),
    [anon_sym_associatedtype] = ACTIONS(3812),
  },
  [1811] = {
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token2] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [aux_sym_preproc_else_token1] = ACTIONS(3812),
    [aux_sym_preproc_elif_token1] = ACTIONS(3812),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_private] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_friend] = ACTIONS(3812),
    [anon_sym_public] = ACTIONS(3812),
    [anon_sym_protected] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
    [anon_sym___init] = ACTIONS(3812),
    [anon_sym___subscript] = ACTIONS(3812),
    [anon_sym_property] = ACTIONS(3812),
    [anon_sym_associatedtype] = ACTIONS(3812),
  },
  [1812] = {
    [sym_identifier] = ACTIONS(3816),
    [aux_sym_preproc_def_token1] = ACTIONS(3816),
    [aux_sym_preproc_if_token1] = ACTIONS(3816),
    [aux_sym_preproc_if_token2] = ACTIONS(3816),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3816),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3816),
    [aux_sym_preproc_else_token1] = ACTIONS(3816),
    [aux_sym_preproc_elif_token1] = ACTIONS(3816),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3816),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3816),
    [sym_preproc_directive] = ACTIONS(3816),
    [anon_sym_LPAREN2] = ACTIONS(3818),
    [anon_sym_TILDE] = ACTIONS(3818),
    [anon_sym_STAR] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_SEMI] = ACTIONS(3818),
    [anon_sym___extension__] = ACTIONS(3816),
    [anon_sym_typedef] = ACTIONS(3816),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_out] = ACTIONS(3816),
    [anon_sym_inout] = ACTIONS(3816),
    [anon_sym_virtual] = ACTIONS(3816),
    [anon_sym_extern] = ACTIONS(3816),
    [anon_sym___attribute__] = ACTIONS(3816),
    [anon_sym___attribute] = ACTIONS(3816),
    [anon_sym_using] = ACTIONS(3816),
    [anon_sym_COLON_COLON] = ACTIONS(3818),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3818),
    [anon_sym___declspec] = ACTIONS(3816),
    [anon_sym___based] = ACTIONS(3816),
    [anon_sym_signed] = ACTIONS(3816),
    [anon_sym_unsigned] = ACTIONS(3816),
    [anon_sym_long] = ACTIONS(3816),
    [anon_sym_short] = ACTIONS(3816),
    [anon_sym_LBRACK] = ACTIONS(3816),
    [anon_sym_static] = ACTIONS(3816),
    [anon_sym_register] = ACTIONS(3816),
    [anon_sym_inline] = ACTIONS(3816),
    [anon_sym___inline] = ACTIONS(3816),
    [anon_sym___inline__] = ACTIONS(3816),
    [anon_sym___forceinline] = ACTIONS(3816),
    [anon_sym_thread_local] = ACTIONS(3816),
    [anon_sym___thread] = ACTIONS(3816),
    [anon_sym_const] = ACTIONS(3816),
    [anon_sym_constexpr] = ACTIONS(3816),
    [anon_sym_volatile] = ACTIONS(3816),
    [anon_sym_restrict] = ACTIONS(3816),
    [anon_sym___restrict__] = ACTIONS(3816),
    [anon_sym__Atomic] = ACTIONS(3816),
    [anon_sym__Noreturn] = ACTIONS(3816),
    [anon_sym_noreturn] = ACTIONS(3816),
    [anon_sym__Nonnull] = ACTIONS(3816),
    [anon_sym_mutable] = ACTIONS(3816),
    [anon_sym_constinit] = ACTIONS(3816),
    [anon_sym_consteval] = ACTIONS(3816),
    [anon_sym_alignas] = ACTIONS(3816),
    [anon_sym__Alignas] = ACTIONS(3816),
    [sym_primitive_type] = ACTIONS(3816),
    [anon_sym_enum] = ACTIONS(3816),
    [anon_sym_class] = ACTIONS(3816),
    [anon_sym_struct] = ACTIONS(3816),
    [anon_sym_union] = ACTIONS(3816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3816),
    [anon_sym_let] = ACTIONS(3816),
    [anon_sym_This] = ACTIONS(3816),
    [anon_sym_decltype] = ACTIONS(3816),
    [anon_sym_explicit] = ACTIONS(3816),
    [anon_sym_typename] = ACTIONS(3816),
    [anon_sym_private] = ACTIONS(3816),
    [anon_sym_template] = ACTIONS(3816),
    [anon_sym_operator] = ACTIONS(3816),
    [anon_sym_friend] = ACTIONS(3816),
    [anon_sym_public] = ACTIONS(3816),
    [anon_sym_protected] = ACTIONS(3816),
    [anon_sym_static_assert] = ACTIONS(3816),
    [anon_sym_precise] = ACTIONS(3816),
    [anon_sym_shared] = ACTIONS(3816),
    [anon_sym_groupshared] = ACTIONS(3816),
    [anon_sym_uniform] = ACTIONS(3816),
    [anon_sym_row_major] = ACTIONS(3816),
    [anon_sym_column_major] = ACTIONS(3816),
    [anon_sym_globallycoherent] = ACTIONS(3816),
    [anon_sym_centroid] = ACTIONS(3816),
    [anon_sym_noperspective] = ACTIONS(3816),
    [anon_sym_nointerpolation] = ACTIONS(3816),
    [anon_sym_sample] = ACTIONS(3816),
    [anon_sym_linear] = ACTIONS(3816),
    [anon_sym_snorm] = ACTIONS(3816),
    [anon_sym_unorm] = ACTIONS(3816),
    [anon_sym_point] = ACTIONS(3816),
    [anon_sym_line] = ACTIONS(3816),
    [anon_sym_triangleadj] = ACTIONS(3816),
    [anon_sym_lineadj] = ACTIONS(3816),
    [anon_sym_triangle] = ACTIONS(3816),
    [anon_sym_interface] = ACTIONS(3816),
    [anon_sym_extension] = ACTIONS(3816),
    [anon_sym___init] = ACTIONS(3816),
    [anon_sym___subscript] = ACTIONS(3816),
    [anon_sym_property] = ACTIONS(3816),
    [anon_sym_associatedtype] = ACTIONS(3816),
  },
  [1813] = {
    [sym_identifier] = ACTIONS(3399),
    [aux_sym_preproc_def_token1] = ACTIONS(3399),
    [aux_sym_preproc_if_token1] = ACTIONS(3399),
    [aux_sym_preproc_if_token2] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3399),
    [aux_sym_preproc_else_token1] = ACTIONS(3399),
    [aux_sym_preproc_elif_token1] = ACTIONS(3399),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3399),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3399),
    [sym_preproc_directive] = ACTIONS(3399),
    [anon_sym_LPAREN2] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_STAR] = ACTIONS(3401),
    [anon_sym_AMP_AMP] = ACTIONS(3401),
    [anon_sym_AMP] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym___extension__] = ACTIONS(3399),
    [anon_sym_typedef] = ACTIONS(3399),
    [anon_sym_in] = ACTIONS(3399),
    [anon_sym_out] = ACTIONS(3399),
    [anon_sym_inout] = ACTIONS(3399),
    [anon_sym_virtual] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym___attribute__] = ACTIONS(3399),
    [anon_sym___attribute] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_COLON_COLON] = ACTIONS(3401),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3401),
    [anon_sym___declspec] = ACTIONS(3399),
    [anon_sym___based] = ACTIONS(3399),
    [anon_sym_signed] = ACTIONS(3399),
    [anon_sym_unsigned] = ACTIONS(3399),
    [anon_sym_long] = ACTIONS(3399),
    [anon_sym_short] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_register] = ACTIONS(3399),
    [anon_sym_inline] = ACTIONS(3399),
    [anon_sym___inline] = ACTIONS(3399),
    [anon_sym___inline__] = ACTIONS(3399),
    [anon_sym___forceinline] = ACTIONS(3399),
    [anon_sym_thread_local] = ACTIONS(3399),
    [anon_sym___thread] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_constexpr] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym_restrict] = ACTIONS(3399),
    [anon_sym___restrict__] = ACTIONS(3399),
    [anon_sym__Atomic] = ACTIONS(3399),
    [anon_sym__Noreturn] = ACTIONS(3399),
    [anon_sym_noreturn] = ACTIONS(3399),
    [anon_sym__Nonnull] = ACTIONS(3399),
    [anon_sym_mutable] = ACTIONS(3399),
    [anon_sym_constinit] = ACTIONS(3399),
    [anon_sym_consteval] = ACTIONS(3399),
    [anon_sym_alignas] = ACTIONS(3399),
    [anon_sym__Alignas] = ACTIONS(3399),
    [sym_primitive_type] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_union] = ACTIONS(3399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_This] = ACTIONS(3399),
    [anon_sym_decltype] = ACTIONS(3399),
    [anon_sym_explicit] = ACTIONS(3399),
    [anon_sym_typename] = ACTIONS(3399),
    [anon_sym_private] = ACTIONS(3399),
    [anon_sym_template] = ACTIONS(3399),
    [anon_sym_operator] = ACTIONS(3399),
    [anon_sym_friend] = ACTIONS(3399),
    [anon_sym_public] = ACTIONS(3399),
    [anon_sym_protected] = ACTIONS(3399),
    [anon_sym_static_assert] = ACTIONS(3399),
    [anon_sym_precise] = ACTIONS(3399),
    [anon_sym_shared] = ACTIONS(3399),
    [anon_sym_groupshared] = ACTIONS(3399),
    [anon_sym_uniform] = ACTIONS(3399),
    [anon_sym_row_major] = ACTIONS(3399),
    [anon_sym_column_major] = ACTIONS(3399),
    [anon_sym_globallycoherent] = ACTIONS(3399),
    [anon_sym_centroid] = ACTIONS(3399),
    [anon_sym_noperspective] = ACTIONS(3399),
    [anon_sym_nointerpolation] = ACTIONS(3399),
    [anon_sym_sample] = ACTIONS(3399),
    [anon_sym_linear] = ACTIONS(3399),
    [anon_sym_snorm] = ACTIONS(3399),
    [anon_sym_unorm] = ACTIONS(3399),
    [anon_sym_point] = ACTIONS(3399),
    [anon_sym_line] = ACTIONS(3399),
    [anon_sym_triangleadj] = ACTIONS(3399),
    [anon_sym_lineadj] = ACTIONS(3399),
    [anon_sym_triangle] = ACTIONS(3399),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_extension] = ACTIONS(3399),
    [anon_sym___init] = ACTIONS(3399),
    [anon_sym___subscript] = ACTIONS(3399),
    [anon_sym_property] = ACTIONS(3399),
    [anon_sym_associatedtype] = ACTIONS(3399),
  },
  [1814] = {
    [sym_expression] = STATE(5511),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_initializer_list] = STATE(10172),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6376),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1815] = {
    [sym_catch_clause] = STATE(1836),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1836),
    [sym_identifier] = ACTIONS(2920),
    [aux_sym_preproc_def_token1] = ACTIONS(2920),
    [aux_sym_preproc_if_token1] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2920),
    [sym_preproc_directive] = ACTIONS(2920),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2920),
    [anon_sym_SEMI] = ACTIONS(2922),
    [anon_sym___extension__] = ACTIONS(2920),
    [anon_sym_typedef] = ACTIONS(2920),
    [anon_sym_in] = ACTIONS(2920),
    [anon_sym_out] = ACTIONS(2920),
    [anon_sym_inout] = ACTIONS(2920),
    [anon_sym_virtual] = ACTIONS(2920),
    [anon_sym_extern] = ACTIONS(2920),
    [anon_sym___attribute__] = ACTIONS(2920),
    [anon_sym___attribute] = ACTIONS(2920),
    [anon_sym_using] = ACTIONS(2920),
    [anon_sym_COLON_COLON] = ACTIONS(2922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2922),
    [anon_sym___declspec] = ACTIONS(2920),
    [anon_sym___based] = ACTIONS(2920),
    [anon_sym_RBRACE] = ACTIONS(2922),
    [anon_sym_signed] = ACTIONS(2920),
    [anon_sym_unsigned] = ACTIONS(2920),
    [anon_sym_long] = ACTIONS(2920),
    [anon_sym_short] = ACTIONS(2920),
    [anon_sym_LBRACK] = ACTIONS(2920),
    [anon_sym_static] = ACTIONS(2920),
    [anon_sym_register] = ACTIONS(2920),
    [anon_sym_inline] = ACTIONS(2920),
    [anon_sym___inline] = ACTIONS(2920),
    [anon_sym___inline__] = ACTIONS(2920),
    [anon_sym___forceinline] = ACTIONS(2920),
    [anon_sym_thread_local] = ACTIONS(2920),
    [anon_sym___thread] = ACTIONS(2920),
    [anon_sym_const] = ACTIONS(2920),
    [anon_sym_constexpr] = ACTIONS(2920),
    [anon_sym_volatile] = ACTIONS(2920),
    [anon_sym_restrict] = ACTIONS(2920),
    [anon_sym___restrict__] = ACTIONS(2920),
    [anon_sym__Atomic] = ACTIONS(2920),
    [anon_sym__Noreturn] = ACTIONS(2920),
    [anon_sym_noreturn] = ACTIONS(2920),
    [anon_sym__Nonnull] = ACTIONS(2920),
    [anon_sym_mutable] = ACTIONS(2920),
    [anon_sym_constinit] = ACTIONS(2920),
    [anon_sym_consteval] = ACTIONS(2920),
    [anon_sym_alignas] = ACTIONS(2920),
    [anon_sym__Alignas] = ACTIONS(2920),
    [sym_primitive_type] = ACTIONS(2920),
    [anon_sym_enum] = ACTIONS(2920),
    [anon_sym_class] = ACTIONS(2920),
    [anon_sym_struct] = ACTIONS(2920),
    [anon_sym_union] = ACTIONS(2920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2920),
    [anon_sym_let] = ACTIONS(2920),
    [anon_sym_This] = ACTIONS(2920),
    [anon_sym_decltype] = ACTIONS(2920),
    [anon_sym_explicit] = ACTIONS(2920),
    [anon_sym_typename] = ACTIONS(2920),
    [anon_sym_private] = ACTIONS(2920),
    [anon_sym_template] = ACTIONS(2920),
    [anon_sym_operator] = ACTIONS(2920),
    [anon_sym_friend] = ACTIONS(2920),
    [anon_sym_public] = ACTIONS(2920),
    [anon_sym_protected] = ACTIONS(2920),
    [anon_sym_static_assert] = ACTIONS(2920),
    [anon_sym_catch] = ACTIONS(6378),
    [anon_sym_precise] = ACTIONS(2920),
    [anon_sym_shared] = ACTIONS(2920),
    [anon_sym_groupshared] = ACTIONS(2920),
    [anon_sym_uniform] = ACTIONS(2920),
    [anon_sym_row_major] = ACTIONS(2920),
    [anon_sym_column_major] = ACTIONS(2920),
    [anon_sym_globallycoherent] = ACTIONS(2920),
    [anon_sym_centroid] = ACTIONS(2920),
    [anon_sym_noperspective] = ACTIONS(2920),
    [anon_sym_nointerpolation] = ACTIONS(2920),
    [anon_sym_sample] = ACTIONS(2920),
    [anon_sym_linear] = ACTIONS(2920),
    [anon_sym_snorm] = ACTIONS(2920),
    [anon_sym_unorm] = ACTIONS(2920),
    [anon_sym_point] = ACTIONS(2920),
    [anon_sym_line] = ACTIONS(2920),
    [anon_sym_triangleadj] = ACTIONS(2920),
    [anon_sym_lineadj] = ACTIONS(2920),
    [anon_sym_triangle] = ACTIONS(2920),
    [anon_sym_interface] = ACTIONS(2920),
    [anon_sym_extension] = ACTIONS(2920),
    [anon_sym___init] = ACTIONS(2920),
    [anon_sym___subscript] = ACTIONS(2920),
    [anon_sym_property] = ACTIONS(2920),
    [anon_sym_associatedtype] = ACTIONS(2920),
  },
  [1816] = {
    [sym__declaration_modifiers] = STATE(2667),
    [sym__declaration_specifiers] = STATE(4972),
    [sym_attribute_specifier] = STATE(2667),
    [sym_attribute_declaration] = STATE(2667),
    [sym_ms_declspec_modifier] = STATE(2667),
    [sym_storage_class_specifier] = STATE(2667),
    [sym_type_qualifier] = STATE(2667),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2793),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_parameter_declaration] = STATE(10552),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_optional_parameter_declaration] = STATE(10552),
    [sym_variadic_parameter_declaration] = STATE(10552),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8769),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2667),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2667),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5515),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(2348),
    [anon_sym_out] = ACTIONS(2348),
    [anon_sym_inout] = ACTIONS(2348),
    [anon_sym_virtual] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5525),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_extension] = ACTIONS(2398),
  },
  [1817] = {
    [sym_catch_clause] = STATE(1836),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1836),
    [sym_identifier] = ACTIONS(2968),
    [aux_sym_preproc_def_token1] = ACTIONS(2968),
    [aux_sym_preproc_if_token1] = ACTIONS(2968),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2968),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2968),
    [sym_preproc_directive] = ACTIONS(2968),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2970),
    [anon_sym_STAR] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_AMP] = ACTIONS(2968),
    [anon_sym_SEMI] = ACTIONS(2970),
    [anon_sym___extension__] = ACTIONS(2968),
    [anon_sym_typedef] = ACTIONS(2968),
    [anon_sym_in] = ACTIONS(2968),
    [anon_sym_out] = ACTIONS(2968),
    [anon_sym_inout] = ACTIONS(2968),
    [anon_sym_virtual] = ACTIONS(2968),
    [anon_sym_extern] = ACTIONS(2968),
    [anon_sym___attribute__] = ACTIONS(2968),
    [anon_sym___attribute] = ACTIONS(2968),
    [anon_sym_using] = ACTIONS(2968),
    [anon_sym_COLON_COLON] = ACTIONS(2970),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2970),
    [anon_sym___declspec] = ACTIONS(2968),
    [anon_sym___based] = ACTIONS(2968),
    [anon_sym_RBRACE] = ACTIONS(2970),
    [anon_sym_signed] = ACTIONS(2968),
    [anon_sym_unsigned] = ACTIONS(2968),
    [anon_sym_long] = ACTIONS(2968),
    [anon_sym_short] = ACTIONS(2968),
    [anon_sym_LBRACK] = ACTIONS(2968),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_register] = ACTIONS(2968),
    [anon_sym_inline] = ACTIONS(2968),
    [anon_sym___inline] = ACTIONS(2968),
    [anon_sym___inline__] = ACTIONS(2968),
    [anon_sym___forceinline] = ACTIONS(2968),
    [anon_sym_thread_local] = ACTIONS(2968),
    [anon_sym___thread] = ACTIONS(2968),
    [anon_sym_const] = ACTIONS(2968),
    [anon_sym_constexpr] = ACTIONS(2968),
    [anon_sym_volatile] = ACTIONS(2968),
    [anon_sym_restrict] = ACTIONS(2968),
    [anon_sym___restrict__] = ACTIONS(2968),
    [anon_sym__Atomic] = ACTIONS(2968),
    [anon_sym__Noreturn] = ACTIONS(2968),
    [anon_sym_noreturn] = ACTIONS(2968),
    [anon_sym__Nonnull] = ACTIONS(2968),
    [anon_sym_mutable] = ACTIONS(2968),
    [anon_sym_constinit] = ACTIONS(2968),
    [anon_sym_consteval] = ACTIONS(2968),
    [anon_sym_alignas] = ACTIONS(2968),
    [anon_sym__Alignas] = ACTIONS(2968),
    [sym_primitive_type] = ACTIONS(2968),
    [anon_sym_enum] = ACTIONS(2968),
    [anon_sym_class] = ACTIONS(2968),
    [anon_sym_struct] = ACTIONS(2968),
    [anon_sym_union] = ACTIONS(2968),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2968),
    [anon_sym_let] = ACTIONS(2968),
    [anon_sym_This] = ACTIONS(2968),
    [anon_sym_decltype] = ACTIONS(2968),
    [anon_sym_explicit] = ACTIONS(2968),
    [anon_sym_typename] = ACTIONS(2968),
    [anon_sym_private] = ACTIONS(2968),
    [anon_sym_template] = ACTIONS(2968),
    [anon_sym_operator] = ACTIONS(2968),
    [anon_sym_friend] = ACTIONS(2968),
    [anon_sym_public] = ACTIONS(2968),
    [anon_sym_protected] = ACTIONS(2968),
    [anon_sym_static_assert] = ACTIONS(2968),
    [anon_sym_catch] = ACTIONS(6378),
    [anon_sym_precise] = ACTIONS(2968),
    [anon_sym_shared] = ACTIONS(2968),
    [anon_sym_groupshared] = ACTIONS(2968),
    [anon_sym_uniform] = ACTIONS(2968),
    [anon_sym_row_major] = ACTIONS(2968),
    [anon_sym_column_major] = ACTIONS(2968),
    [anon_sym_globallycoherent] = ACTIONS(2968),
    [anon_sym_centroid] = ACTIONS(2968),
    [anon_sym_noperspective] = ACTIONS(2968),
    [anon_sym_nointerpolation] = ACTIONS(2968),
    [anon_sym_sample] = ACTIONS(2968),
    [anon_sym_linear] = ACTIONS(2968),
    [anon_sym_snorm] = ACTIONS(2968),
    [anon_sym_unorm] = ACTIONS(2968),
    [anon_sym_point] = ACTIONS(2968),
    [anon_sym_line] = ACTIONS(2968),
    [anon_sym_triangleadj] = ACTIONS(2968),
    [anon_sym_lineadj] = ACTIONS(2968),
    [anon_sym_triangle] = ACTIONS(2968),
    [anon_sym_interface] = ACTIONS(2968),
    [anon_sym_extension] = ACTIONS(2968),
    [anon_sym___init] = ACTIONS(2968),
    [anon_sym___subscript] = ACTIONS(2968),
    [anon_sym_property] = ACTIONS(2968),
    [anon_sym_associatedtype] = ACTIONS(2968),
  },
  [1818] = {
    [sym_catch_clause] = STATE(1829),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1829),
    [sym_identifier] = ACTIONS(2920),
    [aux_sym_preproc_def_token1] = ACTIONS(2920),
    [aux_sym_preproc_if_token1] = ACTIONS(2920),
    [aux_sym_preproc_if_token2] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2920),
    [sym_preproc_directive] = ACTIONS(2920),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2920),
    [anon_sym_SEMI] = ACTIONS(2922),
    [anon_sym___extension__] = ACTIONS(2920),
    [anon_sym_typedef] = ACTIONS(2920),
    [anon_sym_in] = ACTIONS(2920),
    [anon_sym_out] = ACTIONS(2920),
    [anon_sym_inout] = ACTIONS(2920),
    [anon_sym_virtual] = ACTIONS(2920),
    [anon_sym_extern] = ACTIONS(2920),
    [anon_sym___attribute__] = ACTIONS(2920),
    [anon_sym___attribute] = ACTIONS(2920),
    [anon_sym_using] = ACTIONS(2920),
    [anon_sym_COLON_COLON] = ACTIONS(2922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2922),
    [anon_sym___declspec] = ACTIONS(2920),
    [anon_sym___based] = ACTIONS(2920),
    [anon_sym_signed] = ACTIONS(2920),
    [anon_sym_unsigned] = ACTIONS(2920),
    [anon_sym_long] = ACTIONS(2920),
    [anon_sym_short] = ACTIONS(2920),
    [anon_sym_LBRACK] = ACTIONS(2920),
    [anon_sym_static] = ACTIONS(2920),
    [anon_sym_register] = ACTIONS(2920),
    [anon_sym_inline] = ACTIONS(2920),
    [anon_sym___inline] = ACTIONS(2920),
    [anon_sym___inline__] = ACTIONS(2920),
    [anon_sym___forceinline] = ACTIONS(2920),
    [anon_sym_thread_local] = ACTIONS(2920),
    [anon_sym___thread] = ACTIONS(2920),
    [anon_sym_const] = ACTIONS(2920),
    [anon_sym_constexpr] = ACTIONS(2920),
    [anon_sym_volatile] = ACTIONS(2920),
    [anon_sym_restrict] = ACTIONS(2920),
    [anon_sym___restrict__] = ACTIONS(2920),
    [anon_sym__Atomic] = ACTIONS(2920),
    [anon_sym__Noreturn] = ACTIONS(2920),
    [anon_sym_noreturn] = ACTIONS(2920),
    [anon_sym__Nonnull] = ACTIONS(2920),
    [anon_sym_mutable] = ACTIONS(2920),
    [anon_sym_constinit] = ACTIONS(2920),
    [anon_sym_consteval] = ACTIONS(2920),
    [anon_sym_alignas] = ACTIONS(2920),
    [anon_sym__Alignas] = ACTIONS(2920),
    [sym_primitive_type] = ACTIONS(2920),
    [anon_sym_enum] = ACTIONS(2920),
    [anon_sym_class] = ACTIONS(2920),
    [anon_sym_struct] = ACTIONS(2920),
    [anon_sym_union] = ACTIONS(2920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2920),
    [anon_sym_let] = ACTIONS(2920),
    [anon_sym_This] = ACTIONS(2920),
    [anon_sym_decltype] = ACTIONS(2920),
    [anon_sym_explicit] = ACTIONS(2920),
    [anon_sym_typename] = ACTIONS(2920),
    [anon_sym_private] = ACTIONS(2920),
    [anon_sym_template] = ACTIONS(2920),
    [anon_sym_operator] = ACTIONS(2920),
    [anon_sym_friend] = ACTIONS(2920),
    [anon_sym_public] = ACTIONS(2920),
    [anon_sym_protected] = ACTIONS(2920),
    [anon_sym_static_assert] = ACTIONS(2920),
    [anon_sym_catch] = ACTIONS(6380),
    [anon_sym_precise] = ACTIONS(2920),
    [anon_sym_shared] = ACTIONS(2920),
    [anon_sym_groupshared] = ACTIONS(2920),
    [anon_sym_uniform] = ACTIONS(2920),
    [anon_sym_row_major] = ACTIONS(2920),
    [anon_sym_column_major] = ACTIONS(2920),
    [anon_sym_globallycoherent] = ACTIONS(2920),
    [anon_sym_centroid] = ACTIONS(2920),
    [anon_sym_noperspective] = ACTIONS(2920),
    [anon_sym_nointerpolation] = ACTIONS(2920),
    [anon_sym_sample] = ACTIONS(2920),
    [anon_sym_linear] = ACTIONS(2920),
    [anon_sym_snorm] = ACTIONS(2920),
    [anon_sym_unorm] = ACTIONS(2920),
    [anon_sym_point] = ACTIONS(2920),
    [anon_sym_line] = ACTIONS(2920),
    [anon_sym_triangleadj] = ACTIONS(2920),
    [anon_sym_lineadj] = ACTIONS(2920),
    [anon_sym_triangle] = ACTIONS(2920),
    [anon_sym_interface] = ACTIONS(2920),
    [anon_sym_extension] = ACTIONS(2920),
    [anon_sym___init] = ACTIONS(2920),
    [anon_sym___subscript] = ACTIONS(2920),
    [anon_sym_property] = ACTIONS(2920),
    [anon_sym_associatedtype] = ACTIONS(2920),
  },
  [1819] = {
    [sym_catch_clause] = STATE(1829),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1829),
    [sym_identifier] = ACTIONS(2968),
    [aux_sym_preproc_def_token1] = ACTIONS(2968),
    [aux_sym_preproc_if_token1] = ACTIONS(2968),
    [aux_sym_preproc_if_token2] = ACTIONS(2968),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2968),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2968),
    [sym_preproc_directive] = ACTIONS(2968),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2970),
    [anon_sym_STAR] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_AMP] = ACTIONS(2968),
    [anon_sym_SEMI] = ACTIONS(2970),
    [anon_sym___extension__] = ACTIONS(2968),
    [anon_sym_typedef] = ACTIONS(2968),
    [anon_sym_in] = ACTIONS(2968),
    [anon_sym_out] = ACTIONS(2968),
    [anon_sym_inout] = ACTIONS(2968),
    [anon_sym_virtual] = ACTIONS(2968),
    [anon_sym_extern] = ACTIONS(2968),
    [anon_sym___attribute__] = ACTIONS(2968),
    [anon_sym___attribute] = ACTIONS(2968),
    [anon_sym_using] = ACTIONS(2968),
    [anon_sym_COLON_COLON] = ACTIONS(2970),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2970),
    [anon_sym___declspec] = ACTIONS(2968),
    [anon_sym___based] = ACTIONS(2968),
    [anon_sym_signed] = ACTIONS(2968),
    [anon_sym_unsigned] = ACTIONS(2968),
    [anon_sym_long] = ACTIONS(2968),
    [anon_sym_short] = ACTIONS(2968),
    [anon_sym_LBRACK] = ACTIONS(2968),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_register] = ACTIONS(2968),
    [anon_sym_inline] = ACTIONS(2968),
    [anon_sym___inline] = ACTIONS(2968),
    [anon_sym___inline__] = ACTIONS(2968),
    [anon_sym___forceinline] = ACTIONS(2968),
    [anon_sym_thread_local] = ACTIONS(2968),
    [anon_sym___thread] = ACTIONS(2968),
    [anon_sym_const] = ACTIONS(2968),
    [anon_sym_constexpr] = ACTIONS(2968),
    [anon_sym_volatile] = ACTIONS(2968),
    [anon_sym_restrict] = ACTIONS(2968),
    [anon_sym___restrict__] = ACTIONS(2968),
    [anon_sym__Atomic] = ACTIONS(2968),
    [anon_sym__Noreturn] = ACTIONS(2968),
    [anon_sym_noreturn] = ACTIONS(2968),
    [anon_sym__Nonnull] = ACTIONS(2968),
    [anon_sym_mutable] = ACTIONS(2968),
    [anon_sym_constinit] = ACTIONS(2968),
    [anon_sym_consteval] = ACTIONS(2968),
    [anon_sym_alignas] = ACTIONS(2968),
    [anon_sym__Alignas] = ACTIONS(2968),
    [sym_primitive_type] = ACTIONS(2968),
    [anon_sym_enum] = ACTIONS(2968),
    [anon_sym_class] = ACTIONS(2968),
    [anon_sym_struct] = ACTIONS(2968),
    [anon_sym_union] = ACTIONS(2968),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2968),
    [anon_sym_let] = ACTIONS(2968),
    [anon_sym_This] = ACTIONS(2968),
    [anon_sym_decltype] = ACTIONS(2968),
    [anon_sym_explicit] = ACTIONS(2968),
    [anon_sym_typename] = ACTIONS(2968),
    [anon_sym_private] = ACTIONS(2968),
    [anon_sym_template] = ACTIONS(2968),
    [anon_sym_operator] = ACTIONS(2968),
    [anon_sym_friend] = ACTIONS(2968),
    [anon_sym_public] = ACTIONS(2968),
    [anon_sym_protected] = ACTIONS(2968),
    [anon_sym_static_assert] = ACTIONS(2968),
    [anon_sym_catch] = ACTIONS(6380),
    [anon_sym_precise] = ACTIONS(2968),
    [anon_sym_shared] = ACTIONS(2968),
    [anon_sym_groupshared] = ACTIONS(2968),
    [anon_sym_uniform] = ACTIONS(2968),
    [anon_sym_row_major] = ACTIONS(2968),
    [anon_sym_column_major] = ACTIONS(2968),
    [anon_sym_globallycoherent] = ACTIONS(2968),
    [anon_sym_centroid] = ACTIONS(2968),
    [anon_sym_noperspective] = ACTIONS(2968),
    [anon_sym_nointerpolation] = ACTIONS(2968),
    [anon_sym_sample] = ACTIONS(2968),
    [anon_sym_linear] = ACTIONS(2968),
    [anon_sym_snorm] = ACTIONS(2968),
    [anon_sym_unorm] = ACTIONS(2968),
    [anon_sym_point] = ACTIONS(2968),
    [anon_sym_line] = ACTIONS(2968),
    [anon_sym_triangleadj] = ACTIONS(2968),
    [anon_sym_lineadj] = ACTIONS(2968),
    [anon_sym_triangle] = ACTIONS(2968),
    [anon_sym_interface] = ACTIONS(2968),
    [anon_sym_extension] = ACTIONS(2968),
    [anon_sym___init] = ACTIONS(2968),
    [anon_sym___subscript] = ACTIONS(2968),
    [anon_sym_property] = ACTIONS(2968),
    [anon_sym_associatedtype] = ACTIONS(2968),
  },
  [1820] = {
    [sym_expression] = STATE(5990),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(11657),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6382),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1821] = {
    [sym_catch_clause] = STATE(1829),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1829),
    [sym_identifier] = ACTIONS(2885),
    [aux_sym_preproc_def_token1] = ACTIONS(2885),
    [aux_sym_preproc_if_token1] = ACTIONS(2885),
    [aux_sym_preproc_if_token2] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2885),
    [sym_preproc_directive] = ACTIONS(2885),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2887),
    [anon_sym_STAR] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym___extension__] = ACTIONS(2885),
    [anon_sym_typedef] = ACTIONS(2885),
    [anon_sym_in] = ACTIONS(2885),
    [anon_sym_out] = ACTIONS(2885),
    [anon_sym_inout] = ACTIONS(2885),
    [anon_sym_virtual] = ACTIONS(2885),
    [anon_sym_extern] = ACTIONS(2885),
    [anon_sym___attribute__] = ACTIONS(2885),
    [anon_sym___attribute] = ACTIONS(2885),
    [anon_sym_using] = ACTIONS(2885),
    [anon_sym_COLON_COLON] = ACTIONS(2887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2887),
    [anon_sym___declspec] = ACTIONS(2885),
    [anon_sym___based] = ACTIONS(2885),
    [anon_sym_signed] = ACTIONS(2885),
    [anon_sym_unsigned] = ACTIONS(2885),
    [anon_sym_long] = ACTIONS(2885),
    [anon_sym_short] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_static] = ACTIONS(2885),
    [anon_sym_register] = ACTIONS(2885),
    [anon_sym_inline] = ACTIONS(2885),
    [anon_sym___inline] = ACTIONS(2885),
    [anon_sym___inline__] = ACTIONS(2885),
    [anon_sym___forceinline] = ACTIONS(2885),
    [anon_sym_thread_local] = ACTIONS(2885),
    [anon_sym___thread] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_constexpr] = ACTIONS(2885),
    [anon_sym_volatile] = ACTIONS(2885),
    [anon_sym_restrict] = ACTIONS(2885),
    [anon_sym___restrict__] = ACTIONS(2885),
    [anon_sym__Atomic] = ACTIONS(2885),
    [anon_sym__Noreturn] = ACTIONS(2885),
    [anon_sym_noreturn] = ACTIONS(2885),
    [anon_sym__Nonnull] = ACTIONS(2885),
    [anon_sym_mutable] = ACTIONS(2885),
    [anon_sym_constinit] = ACTIONS(2885),
    [anon_sym_consteval] = ACTIONS(2885),
    [anon_sym_alignas] = ACTIONS(2885),
    [anon_sym__Alignas] = ACTIONS(2885),
    [sym_primitive_type] = ACTIONS(2885),
    [anon_sym_enum] = ACTIONS(2885),
    [anon_sym_class] = ACTIONS(2885),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_union] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2885),
    [anon_sym_let] = ACTIONS(2885),
    [anon_sym_This] = ACTIONS(2885),
    [anon_sym_decltype] = ACTIONS(2885),
    [anon_sym_explicit] = ACTIONS(2885),
    [anon_sym_typename] = ACTIONS(2885),
    [anon_sym_private] = ACTIONS(2885),
    [anon_sym_template] = ACTIONS(2885),
    [anon_sym_operator] = ACTIONS(2885),
    [anon_sym_friend] = ACTIONS(2885),
    [anon_sym_public] = ACTIONS(2885),
    [anon_sym_protected] = ACTIONS(2885),
    [anon_sym_static_assert] = ACTIONS(2885),
    [anon_sym_catch] = ACTIONS(6380),
    [anon_sym_precise] = ACTIONS(2885),
    [anon_sym_shared] = ACTIONS(2885),
    [anon_sym_groupshared] = ACTIONS(2885),
    [anon_sym_uniform] = ACTIONS(2885),
    [anon_sym_row_major] = ACTIONS(2885),
    [anon_sym_column_major] = ACTIONS(2885),
    [anon_sym_globallycoherent] = ACTIONS(2885),
    [anon_sym_centroid] = ACTIONS(2885),
    [anon_sym_noperspective] = ACTIONS(2885),
    [anon_sym_nointerpolation] = ACTIONS(2885),
    [anon_sym_sample] = ACTIONS(2885),
    [anon_sym_linear] = ACTIONS(2885),
    [anon_sym_snorm] = ACTIONS(2885),
    [anon_sym_unorm] = ACTIONS(2885),
    [anon_sym_point] = ACTIONS(2885),
    [anon_sym_line] = ACTIONS(2885),
    [anon_sym_triangleadj] = ACTIONS(2885),
    [anon_sym_lineadj] = ACTIONS(2885),
    [anon_sym_triangle] = ACTIONS(2885),
    [anon_sym_interface] = ACTIONS(2885),
    [anon_sym_extension] = ACTIONS(2885),
    [anon_sym___init] = ACTIONS(2885),
    [anon_sym___subscript] = ACTIONS(2885),
    [anon_sym_property] = ACTIONS(2885),
    [anon_sym_associatedtype] = ACTIONS(2885),
  },
  [1822] = {
    [sym_expression] = STATE(5990),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(11657),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6385),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1823] = {
    [sym_expression] = STATE(5463),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_initializer_list] = STATE(10161),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6388),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1824] = {
    [sym_expression] = STATE(5990),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(11657),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6390),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1825] = {
    [sym_expression] = STATE(5622),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_initializer_list] = STATE(9883),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6393),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1826] = {
    [sym_expression] = STATE(5990),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(11657),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6395),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1827] = {
    [sym_expression] = STATE(5990),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(11657),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6398),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1828] = {
    [sym_catch_clause] = STATE(1836),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1836),
    [sym_identifier] = ACTIONS(2885),
    [aux_sym_preproc_def_token1] = ACTIONS(2885),
    [aux_sym_preproc_if_token1] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2885),
    [sym_preproc_directive] = ACTIONS(2885),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2887),
    [anon_sym_STAR] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym___extension__] = ACTIONS(2885),
    [anon_sym_typedef] = ACTIONS(2885),
    [anon_sym_in] = ACTIONS(2885),
    [anon_sym_out] = ACTIONS(2885),
    [anon_sym_inout] = ACTIONS(2885),
    [anon_sym_virtual] = ACTIONS(2885),
    [anon_sym_extern] = ACTIONS(2885),
    [anon_sym___attribute__] = ACTIONS(2885),
    [anon_sym___attribute] = ACTIONS(2885),
    [anon_sym_using] = ACTIONS(2885),
    [anon_sym_COLON_COLON] = ACTIONS(2887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2887),
    [anon_sym___declspec] = ACTIONS(2885),
    [anon_sym___based] = ACTIONS(2885),
    [anon_sym_RBRACE] = ACTIONS(2887),
    [anon_sym_signed] = ACTIONS(2885),
    [anon_sym_unsigned] = ACTIONS(2885),
    [anon_sym_long] = ACTIONS(2885),
    [anon_sym_short] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_static] = ACTIONS(2885),
    [anon_sym_register] = ACTIONS(2885),
    [anon_sym_inline] = ACTIONS(2885),
    [anon_sym___inline] = ACTIONS(2885),
    [anon_sym___inline__] = ACTIONS(2885),
    [anon_sym___forceinline] = ACTIONS(2885),
    [anon_sym_thread_local] = ACTIONS(2885),
    [anon_sym___thread] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_constexpr] = ACTIONS(2885),
    [anon_sym_volatile] = ACTIONS(2885),
    [anon_sym_restrict] = ACTIONS(2885),
    [anon_sym___restrict__] = ACTIONS(2885),
    [anon_sym__Atomic] = ACTIONS(2885),
    [anon_sym__Noreturn] = ACTIONS(2885),
    [anon_sym_noreturn] = ACTIONS(2885),
    [anon_sym__Nonnull] = ACTIONS(2885),
    [anon_sym_mutable] = ACTIONS(2885),
    [anon_sym_constinit] = ACTIONS(2885),
    [anon_sym_consteval] = ACTIONS(2885),
    [anon_sym_alignas] = ACTIONS(2885),
    [anon_sym__Alignas] = ACTIONS(2885),
    [sym_primitive_type] = ACTIONS(2885),
    [anon_sym_enum] = ACTIONS(2885),
    [anon_sym_class] = ACTIONS(2885),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_union] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2885),
    [anon_sym_let] = ACTIONS(2885),
    [anon_sym_This] = ACTIONS(2885),
    [anon_sym_decltype] = ACTIONS(2885),
    [anon_sym_explicit] = ACTIONS(2885),
    [anon_sym_typename] = ACTIONS(2885),
    [anon_sym_private] = ACTIONS(2885),
    [anon_sym_template] = ACTIONS(2885),
    [anon_sym_operator] = ACTIONS(2885),
    [anon_sym_friend] = ACTIONS(2885),
    [anon_sym_public] = ACTIONS(2885),
    [anon_sym_protected] = ACTIONS(2885),
    [anon_sym_static_assert] = ACTIONS(2885),
    [anon_sym_catch] = ACTIONS(6378),
    [anon_sym_precise] = ACTIONS(2885),
    [anon_sym_shared] = ACTIONS(2885),
    [anon_sym_groupshared] = ACTIONS(2885),
    [anon_sym_uniform] = ACTIONS(2885),
    [anon_sym_row_major] = ACTIONS(2885),
    [anon_sym_column_major] = ACTIONS(2885),
    [anon_sym_globallycoherent] = ACTIONS(2885),
    [anon_sym_centroid] = ACTIONS(2885),
    [anon_sym_noperspective] = ACTIONS(2885),
    [anon_sym_nointerpolation] = ACTIONS(2885),
    [anon_sym_sample] = ACTIONS(2885),
    [anon_sym_linear] = ACTIONS(2885),
    [anon_sym_snorm] = ACTIONS(2885),
    [anon_sym_unorm] = ACTIONS(2885),
    [anon_sym_point] = ACTIONS(2885),
    [anon_sym_line] = ACTIONS(2885),
    [anon_sym_triangleadj] = ACTIONS(2885),
    [anon_sym_lineadj] = ACTIONS(2885),
    [anon_sym_triangle] = ACTIONS(2885),
    [anon_sym_interface] = ACTIONS(2885),
    [anon_sym_extension] = ACTIONS(2885),
    [anon_sym___init] = ACTIONS(2885),
    [anon_sym___subscript] = ACTIONS(2885),
    [anon_sym_property] = ACTIONS(2885),
    [anon_sym_associatedtype] = ACTIONS(2885),
  },
  [1829] = {
    [sym_catch_clause] = STATE(1829),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1829),
    [sym_identifier] = ACTIONS(2901),
    [aux_sym_preproc_def_token1] = ACTIONS(2901),
    [aux_sym_preproc_if_token1] = ACTIONS(2901),
    [aux_sym_preproc_if_token2] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2901),
    [sym_preproc_directive] = ACTIONS(2901),
    [anon_sym_LPAREN2] = ACTIONS(2903),
    [anon_sym_TILDE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(2903),
    [anon_sym_AMP_AMP] = ACTIONS(2903),
    [anon_sym_AMP] = ACTIONS(2901),
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym___extension__] = ACTIONS(2901),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_in] = ACTIONS(2901),
    [anon_sym_out] = ACTIONS(2901),
    [anon_sym_inout] = ACTIONS(2901),
    [anon_sym_virtual] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(2901),
    [anon_sym___attribute__] = ACTIONS(2901),
    [anon_sym___attribute] = ACTIONS(2901),
    [anon_sym_using] = ACTIONS(2901),
    [anon_sym_COLON_COLON] = ACTIONS(2903),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2903),
    [anon_sym___declspec] = ACTIONS(2901),
    [anon_sym___based] = ACTIONS(2901),
    [anon_sym_signed] = ACTIONS(2901),
    [anon_sym_unsigned] = ACTIONS(2901),
    [anon_sym_long] = ACTIONS(2901),
    [anon_sym_short] = ACTIONS(2901),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_static] = ACTIONS(2901),
    [anon_sym_register] = ACTIONS(2901),
    [anon_sym_inline] = ACTIONS(2901),
    [anon_sym___inline] = ACTIONS(2901),
    [anon_sym___inline__] = ACTIONS(2901),
    [anon_sym___forceinline] = ACTIONS(2901),
    [anon_sym_thread_local] = ACTIONS(2901),
    [anon_sym___thread] = ACTIONS(2901),
    [anon_sym_const] = ACTIONS(2901),
    [anon_sym_constexpr] = ACTIONS(2901),
    [anon_sym_volatile] = ACTIONS(2901),
    [anon_sym_restrict] = ACTIONS(2901),
    [anon_sym___restrict__] = ACTIONS(2901),
    [anon_sym__Atomic] = ACTIONS(2901),
    [anon_sym__Noreturn] = ACTIONS(2901),
    [anon_sym_noreturn] = ACTIONS(2901),
    [anon_sym__Nonnull] = ACTIONS(2901),
    [anon_sym_mutable] = ACTIONS(2901),
    [anon_sym_constinit] = ACTIONS(2901),
    [anon_sym_consteval] = ACTIONS(2901),
    [anon_sym_alignas] = ACTIONS(2901),
    [anon_sym__Alignas] = ACTIONS(2901),
    [sym_primitive_type] = ACTIONS(2901),
    [anon_sym_enum] = ACTIONS(2901),
    [anon_sym_class] = ACTIONS(2901),
    [anon_sym_struct] = ACTIONS(2901),
    [anon_sym_union] = ACTIONS(2901),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2901),
    [anon_sym_let] = ACTIONS(2901),
    [anon_sym_This] = ACTIONS(2901),
    [anon_sym_decltype] = ACTIONS(2901),
    [anon_sym_explicit] = ACTIONS(2901),
    [anon_sym_typename] = ACTIONS(2901),
    [anon_sym_private] = ACTIONS(2901),
    [anon_sym_template] = ACTIONS(2901),
    [anon_sym_operator] = ACTIONS(2901),
    [anon_sym_friend] = ACTIONS(2901),
    [anon_sym_public] = ACTIONS(2901),
    [anon_sym_protected] = ACTIONS(2901),
    [anon_sym_static_assert] = ACTIONS(2901),
    [anon_sym_catch] = ACTIONS(6401),
    [anon_sym_precise] = ACTIONS(2901),
    [anon_sym_shared] = ACTIONS(2901),
    [anon_sym_groupshared] = ACTIONS(2901),
    [anon_sym_uniform] = ACTIONS(2901),
    [anon_sym_row_major] = ACTIONS(2901),
    [anon_sym_column_major] = ACTIONS(2901),
    [anon_sym_globallycoherent] = ACTIONS(2901),
    [anon_sym_centroid] = ACTIONS(2901),
    [anon_sym_noperspective] = ACTIONS(2901),
    [anon_sym_nointerpolation] = ACTIONS(2901),
    [anon_sym_sample] = ACTIONS(2901),
    [anon_sym_linear] = ACTIONS(2901),
    [anon_sym_snorm] = ACTIONS(2901),
    [anon_sym_unorm] = ACTIONS(2901),
    [anon_sym_point] = ACTIONS(2901),
    [anon_sym_line] = ACTIONS(2901),
    [anon_sym_triangleadj] = ACTIONS(2901),
    [anon_sym_lineadj] = ACTIONS(2901),
    [anon_sym_triangle] = ACTIONS(2901),
    [anon_sym_interface] = ACTIONS(2901),
    [anon_sym_extension] = ACTIONS(2901),
    [anon_sym___init] = ACTIONS(2901),
    [anon_sym___subscript] = ACTIONS(2901),
    [anon_sym_property] = ACTIONS(2901),
    [anon_sym_associatedtype] = ACTIONS(2901),
  },
  [1830] = {
    [sym_expression] = STATE(5990),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(11657),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6404),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1831] = {
    [sym_expression] = STATE(5990),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(11657),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6407),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1832] = {
    [sym_expression] = STATE(5990),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(11657),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6410),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1833] = {
    [sym_expression] = STATE(5990),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(11657),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6413),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1834] = {
    [sym_expression] = STATE(5990),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(11657),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6416),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1835] = {
    [sym_compound_statement] = STATE(10711),
    [sym_expression] = STATE(5805),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10711),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(6134),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1836] = {
    [sym_catch_clause] = STATE(1836),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1836),
    [sym_identifier] = ACTIONS(2901),
    [aux_sym_preproc_def_token1] = ACTIONS(2901),
    [aux_sym_preproc_if_token1] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2901),
    [sym_preproc_directive] = ACTIONS(2901),
    [anon_sym_LPAREN2] = ACTIONS(2903),
    [anon_sym_TILDE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(2903),
    [anon_sym_AMP_AMP] = ACTIONS(2903),
    [anon_sym_AMP] = ACTIONS(2901),
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym___extension__] = ACTIONS(2901),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_in] = ACTIONS(2901),
    [anon_sym_out] = ACTIONS(2901),
    [anon_sym_inout] = ACTIONS(2901),
    [anon_sym_virtual] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(2901),
    [anon_sym___attribute__] = ACTIONS(2901),
    [anon_sym___attribute] = ACTIONS(2901),
    [anon_sym_using] = ACTIONS(2901),
    [anon_sym_COLON_COLON] = ACTIONS(2903),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2903),
    [anon_sym___declspec] = ACTIONS(2901),
    [anon_sym___based] = ACTIONS(2901),
    [anon_sym_RBRACE] = ACTIONS(2903),
    [anon_sym_signed] = ACTIONS(2901),
    [anon_sym_unsigned] = ACTIONS(2901),
    [anon_sym_long] = ACTIONS(2901),
    [anon_sym_short] = ACTIONS(2901),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_static] = ACTIONS(2901),
    [anon_sym_register] = ACTIONS(2901),
    [anon_sym_inline] = ACTIONS(2901),
    [anon_sym___inline] = ACTIONS(2901),
    [anon_sym___inline__] = ACTIONS(2901),
    [anon_sym___forceinline] = ACTIONS(2901),
    [anon_sym_thread_local] = ACTIONS(2901),
    [anon_sym___thread] = ACTIONS(2901),
    [anon_sym_const] = ACTIONS(2901),
    [anon_sym_constexpr] = ACTIONS(2901),
    [anon_sym_volatile] = ACTIONS(2901),
    [anon_sym_restrict] = ACTIONS(2901),
    [anon_sym___restrict__] = ACTIONS(2901),
    [anon_sym__Atomic] = ACTIONS(2901),
    [anon_sym__Noreturn] = ACTIONS(2901),
    [anon_sym_noreturn] = ACTIONS(2901),
    [anon_sym__Nonnull] = ACTIONS(2901),
    [anon_sym_mutable] = ACTIONS(2901),
    [anon_sym_constinit] = ACTIONS(2901),
    [anon_sym_consteval] = ACTIONS(2901),
    [anon_sym_alignas] = ACTIONS(2901),
    [anon_sym__Alignas] = ACTIONS(2901),
    [sym_primitive_type] = ACTIONS(2901),
    [anon_sym_enum] = ACTIONS(2901),
    [anon_sym_class] = ACTIONS(2901),
    [anon_sym_struct] = ACTIONS(2901),
    [anon_sym_union] = ACTIONS(2901),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2901),
    [anon_sym_let] = ACTIONS(2901),
    [anon_sym_This] = ACTIONS(2901),
    [anon_sym_decltype] = ACTIONS(2901),
    [anon_sym_explicit] = ACTIONS(2901),
    [anon_sym_typename] = ACTIONS(2901),
    [anon_sym_private] = ACTIONS(2901),
    [anon_sym_template] = ACTIONS(2901),
    [anon_sym_operator] = ACTIONS(2901),
    [anon_sym_friend] = ACTIONS(2901),
    [anon_sym_public] = ACTIONS(2901),
    [anon_sym_protected] = ACTIONS(2901),
    [anon_sym_static_assert] = ACTIONS(2901),
    [anon_sym_catch] = ACTIONS(6419),
    [anon_sym_precise] = ACTIONS(2901),
    [anon_sym_shared] = ACTIONS(2901),
    [anon_sym_groupshared] = ACTIONS(2901),
    [anon_sym_uniform] = ACTIONS(2901),
    [anon_sym_row_major] = ACTIONS(2901),
    [anon_sym_column_major] = ACTIONS(2901),
    [anon_sym_globallycoherent] = ACTIONS(2901),
    [anon_sym_centroid] = ACTIONS(2901),
    [anon_sym_noperspective] = ACTIONS(2901),
    [anon_sym_nointerpolation] = ACTIONS(2901),
    [anon_sym_sample] = ACTIONS(2901),
    [anon_sym_linear] = ACTIONS(2901),
    [anon_sym_snorm] = ACTIONS(2901),
    [anon_sym_unorm] = ACTIONS(2901),
    [anon_sym_point] = ACTIONS(2901),
    [anon_sym_line] = ACTIONS(2901),
    [anon_sym_triangleadj] = ACTIONS(2901),
    [anon_sym_lineadj] = ACTIONS(2901),
    [anon_sym_triangle] = ACTIONS(2901),
    [anon_sym_interface] = ACTIONS(2901),
    [anon_sym_extension] = ACTIONS(2901),
    [anon_sym___init] = ACTIONS(2901),
    [anon_sym___subscript] = ACTIONS(2901),
    [anon_sym_property] = ACTIONS(2901),
    [anon_sym_associatedtype] = ACTIONS(2901),
  },
  [1837] = {
    [sym_expression] = STATE(5990),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(11657),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6422),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1838] = {
    [sym_expression] = STATE(6023),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(11081),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1839] = {
    [sym_expression] = STATE(5651),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11301),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(4220),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1840] = {
    [sym_expression] = STATE(5656),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11333),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(4019),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1841] = {
    [sym_expression] = STATE(4475),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_initializer_list] = STATE(4775),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(6425),
    [anon_sym_BANG] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5262),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACE] = ACTIONS(5266),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_DASH_DASH] = ACTIONS(5557),
    [anon_sym_PLUS_PLUS] = ACTIONS(5557),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [1842] = {
    [sym_expression] = STATE(5658),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11079),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_RPAREN] = ACTIONS(6427),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1843] = {
    [sym_expression] = STATE(3353),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_initializer_list] = STATE(3384),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACE] = ACTIONS(4964),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1844] = {
    [sym_expression] = STATE(5348),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10865),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1845] = {
    [sym_expression] = STATE(5688),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11148),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym_COLON] = ACTIONS(6431),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1846] = {
    [sym_expression] = STATE(5733),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11248),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym_COLON] = ACTIONS(6433),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1847] = {
    [sym_expression] = STATE(5482),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10590),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1848] = {
    [sym_expression] = STATE(5445),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_initializer_list] = STATE(9328),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1849] = {
    [sym_expression] = STATE(5638),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10890),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_RPAREN] = ACTIONS(6435),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1850] = {
    [sym_expression] = STATE(5475),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(9686),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6437),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1851] = {
    [sym_expression] = STATE(5377),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_initializer_list] = STATE(4901),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1852] = {
    [sym_expression] = STATE(4716),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_initializer_list] = STATE(4860),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACE] = ACTIONS(5321),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1853] = {
    [sym_expression] = STATE(5785),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10396),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1854] = {
    [sym_expression] = STATE(5708),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_initializer_list] = STATE(6116),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACE] = ACTIONS(5479),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [1855] = {
    [sym_expression] = STATE(5868),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11075),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym_COLON] = ACTIONS(6440),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1856] = {
    [sym_expression] = STATE(5855),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11190),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym_COLON] = ACTIONS(6442),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1857] = {
    [sym_expression] = STATE(4157),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_initializer_list] = STATE(4641),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(5056),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1858] = {
    [sym_expression] = STATE(5856),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_initializer_list] = STATE(6121),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACE] = ACTIONS(5479),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [1859] = {
    [sym_expression] = STATE(5746),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_initializer_list] = STATE(4901),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1860] = {
    [sym_expression] = STATE(5857),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10821),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym_COLON] = ACTIONS(6444),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1861] = {
    [sym_expression] = STATE(4811),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_initializer_list] = STATE(4889),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1862] = {
    [sym_expression] = STATE(4811),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_initializer_list] = STATE(4889),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1863] = {
    [sym_expression] = STATE(3353),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_initializer_list] = STATE(3384),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5032),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACE] = ACTIONS(4964),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1864] = {
    [sym_expression] = STATE(5677),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11661),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_RPAREN] = ACTIONS(6448),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1865] = {
    [sym_expression] = STATE(5669),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10352),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1866] = {
    [sym_expression] = STATE(5854),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11491),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym_COLON] = ACTIONS(6450),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1867] = {
    [sym_expression] = STATE(4664),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_initializer_list] = STATE(4903),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACE] = ACTIONS(5321),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1868] = {
    [sym_expression] = STATE(4811),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_initializer_list] = STATE(4889),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(6452),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [1869] = {
    [sym_expression] = STATE(5680),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11700),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym_COLON] = ACTIONS(6454),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1870] = {
    [sym_expression] = STATE(5699),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(10590),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1871] = {
    [sym_expression] = STATE(5636),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11116),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_RPAREN] = ACTIONS(6456),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1872] = {
    [sym_expression] = STATE(5764),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10963),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym_COLON] = ACTIONS(6458),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1873] = {
    [sym_expression] = STATE(4811),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(4889),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1874] = {
    [sym_expression] = STATE(5765),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_initializer_list] = STATE(4889),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1875] = {
    [sym_expression] = STATE(5710),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11264),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(4134),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1876] = {
    [sym_expression] = STATE(5450),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(4901),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1877] = {
    [sym_expression] = STATE(5179),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_initializer_list] = STATE(4901),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(6452),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [1878] = {
    [sym_expression] = STATE(3353),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_initializer_list] = STATE(3384),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6460),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4956),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACE] = ACTIONS(4964),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_DASH_DASH] = ACTIONS(5544),
    [anon_sym_PLUS_PLUS] = ACTIONS(5544),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1879] = {
    [sym_expression] = STATE(5990),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_initializer_list] = STATE(11657),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1880] = {
    [sym_expression] = STATE(5705),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11194),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym_COLON] = ACTIONS(6462),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1881] = {
    [sym_expression] = STATE(5863),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_initializer_list] = STATE(4901),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1882] = {
    [sym_expression] = STATE(4494),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_initializer_list] = STATE(3384),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6464),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5158),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACE] = ACTIONS(4964),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1883] = {
    [sym_expression] = STATE(5823),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_initializer_list] = STATE(10504),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1884] = {
    [sym_expression] = STATE(5860),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11587),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym_COLON] = ACTIONS(6466),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1885] = {
    [sym_expression] = STATE(5790),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_initializer_list] = STATE(4901),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1886] = {
    [sym_expression] = STATE(5824),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10957),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_RPAREN] = ACTIONS(6468),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1887] = {
    [sym_expression] = STATE(5717),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(10824),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_RPAREN] = ACTIONS(6470),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1888] = {
    [sym_expression] = STATE(5866),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11623),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym_COLON] = ACTIONS(6472),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1889] = {
    [sym_expression] = STATE(5845),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11273),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym_COLON] = ACTIONS(6474),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1890] = {
    [sym_expression] = STATE(5720),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(11024),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym_COLON] = ACTIONS(6476),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1891] = {
    [sym_expression] = STATE(3892),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6478),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1892] = {
    [sym_expression] = STATE(5421),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym_SEMI] = ACTIONS(6481),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(6483),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1893] = {
    [sym_expression] = STATE(5997),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(6485),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1894] = {
    [sym_expression] = STATE(5963),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(6487),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1895] = {
    [sym_expression] = STATE(4773),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6489),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1896] = {
    [sym_expression] = STATE(4304),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6492),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1897] = {
    [sym_expression] = STATE(4262),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6495),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1898] = {
    [sym_expression] = STATE(4266),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6498),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1899] = {
    [sym_expression] = STATE(3379),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6501),
    [anon_sym_LPAREN2] = ACTIONS(6503),
    [anon_sym_BANG] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5032),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1900] = {
    [sym_expression] = STATE(4288),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6505),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1901] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6508),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1902] = {
    [sym_expression] = STATE(4238),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6510),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1903] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6513),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1904] = {
    [sym_expression] = STATE(4764),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6515),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1905] = {
    [sym_expression] = STATE(4221),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6518),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1906] = {
    [sym_expression] = STATE(5914),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(6521),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1907] = {
    [sym_expression] = STATE(5639),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(9686),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1908] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6523),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1909] = {
    [sym_expression] = STATE(6016),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_RPAREN] = ACTIONS(6525),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1910] = {
    [sym_expression] = STATE(5872),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6527),
    [anon_sym_LPAREN2] = ACTIONS(6529),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [1911] = {
    [sym_expression] = STATE(6025),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(6531),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1912] = {
    [sym_expression] = STATE(4439),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6533),
    [anon_sym_LPAREN2] = ACTIONS(6535),
    [anon_sym_BANG] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5262),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_DASH_DASH] = ACTIONS(5557),
    [anon_sym_PLUS_PLUS] = ACTIONS(5557),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [1913] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6537),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1914] = {
    [sym_expression] = STATE(4765),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6518),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1915] = {
    [sym_expression] = STATE(6040),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(6539),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1916] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6541),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1917] = {
    [sym_expression] = STATE(4093),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6543),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1918] = {
    [sym_expression] = STATE(4766),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6510),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1919] = {
    [sym_expression] = STATE(4093),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6546),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1920] = {
    [sym_expression] = STATE(4238),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6549),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1921] = {
    [sym_expression] = STATE(4262),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1922] = {
    [sym_expression] = STATE(4767),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6495),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1923] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6555),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1924] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6557),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1925] = {
    [sym_expression] = STATE(4288),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6489),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1926] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6559),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1927] = {
    [sym_expression] = STATE(4093),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6561),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1928] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6564),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1929] = {
    [sym_expression] = STATE(4771),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6498),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1930] = {
    [sym_expression] = STATE(4217),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1931] = {
    [sym_expression] = STATE(4773),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6505),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1932] = {
    [sym_expression] = STATE(4304),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6569),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1933] = {
    [sym_expression] = STATE(4774),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6569),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1934] = {
    [sym_expression] = STATE(4219),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6572),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1935] = {
    [sym_expression] = STATE(4774),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6492),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1936] = {
    [sym_expression] = STATE(4766),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6549),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1937] = {
    [sym_expression] = STATE(4779),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6543),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1938] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6575),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1939] = {
    [sym_expression] = STATE(4093),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6577),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1940] = {
    [sym_expression] = STATE(3379),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6501),
    [anon_sym_LPAREN2] = ACTIONS(6580),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1941] = {
    [sym_expression] = STATE(3892),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6582),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1942] = {
    [sym_expression] = STATE(4219),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6515),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1943] = {
    [sym_expression] = STATE(5421),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym_SEMI] = ACTIONS(6585),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(6483),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1944] = {
    [sym_identifier] = ACTIONS(2414),
    [aux_sym_preproc_def_token1] = ACTIONS(2414),
    [anon_sym_COMMA] = ACTIONS(4215),
    [aux_sym_preproc_if_token1] = ACTIONS(2414),
    [aux_sym_preproc_if_token2] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2414),
    [sym_preproc_directive] = ACTIONS(2414),
    [anon_sym_LPAREN2] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(4215),
    [anon_sym___extension__] = ACTIONS(2414),
    [anon_sym_typedef] = ACTIONS(2414),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_out] = ACTIONS(2414),
    [anon_sym_inout] = ACTIONS(2414),
    [anon_sym_virtual] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym___attribute__] = ACTIONS(6106),
    [anon_sym___attribute] = ACTIONS(6106),
    [anon_sym_using] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2412),
    [anon_sym___declspec] = ACTIONS(2414),
    [anon_sym___based] = ACTIONS(2414),
    [anon_sym_signed] = ACTIONS(2414),
    [anon_sym_unsigned] = ACTIONS(2414),
    [anon_sym_long] = ACTIONS(2414),
    [anon_sym_short] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_register] = ACTIONS(2414),
    [anon_sym_inline] = ACTIONS(2414),
    [anon_sym___inline] = ACTIONS(2414),
    [anon_sym___inline__] = ACTIONS(2414),
    [anon_sym___forceinline] = ACTIONS(2414),
    [anon_sym_thread_local] = ACTIONS(2414),
    [anon_sym___thread] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_constexpr] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym_restrict] = ACTIONS(2414),
    [anon_sym___restrict__] = ACTIONS(2414),
    [anon_sym__Atomic] = ACTIONS(2414),
    [anon_sym__Noreturn] = ACTIONS(2414),
    [anon_sym_noreturn] = ACTIONS(2414),
    [anon_sym__Nonnull] = ACTIONS(2414),
    [anon_sym_mutable] = ACTIONS(2414),
    [anon_sym_constinit] = ACTIONS(2414),
    [anon_sym_consteval] = ACTIONS(2414),
    [anon_sym_alignas] = ACTIONS(2414),
    [anon_sym__Alignas] = ACTIONS(2414),
    [sym_primitive_type] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2414),
    [anon_sym_let] = ACTIONS(2414),
    [anon_sym_This] = ACTIONS(2414),
    [anon_sym_decltype] = ACTIONS(2414),
    [anon_sym_explicit] = ACTIONS(2414),
    [anon_sym_typename] = ACTIONS(2414),
    [anon_sym_private] = ACTIONS(2414),
    [anon_sym_template] = ACTIONS(2414),
    [anon_sym_operator] = ACTIONS(2414),
    [anon_sym_friend] = ACTIONS(2414),
    [anon_sym_public] = ACTIONS(2414),
    [anon_sym_protected] = ACTIONS(2414),
    [anon_sym_static_assert] = ACTIONS(2414),
    [anon_sym_precise] = ACTIONS(2414),
    [anon_sym_shared] = ACTIONS(2414),
    [anon_sym_groupshared] = ACTIONS(2414),
    [anon_sym_uniform] = ACTIONS(2414),
    [anon_sym_row_major] = ACTIONS(2414),
    [anon_sym_column_major] = ACTIONS(2414),
    [anon_sym_globallycoherent] = ACTIONS(2414),
    [anon_sym_centroid] = ACTIONS(2414),
    [anon_sym_noperspective] = ACTIONS(2414),
    [anon_sym_nointerpolation] = ACTIONS(2414),
    [anon_sym_sample] = ACTIONS(2414),
    [anon_sym_linear] = ACTIONS(2414),
    [anon_sym_snorm] = ACTIONS(2414),
    [anon_sym_unorm] = ACTIONS(2414),
    [anon_sym_point] = ACTIONS(2414),
    [anon_sym_line] = ACTIONS(2414),
    [anon_sym_triangleadj] = ACTIONS(2414),
    [anon_sym_lineadj] = ACTIONS(2414),
    [anon_sym_triangle] = ACTIONS(2414),
    [anon_sym_interface] = ACTIONS(2414),
    [anon_sym_extension] = ACTIONS(2414),
    [anon_sym___init] = ACTIONS(2414),
    [anon_sym___subscript] = ACTIONS(2414),
    [anon_sym_property] = ACTIONS(2414),
    [anon_sym_associatedtype] = ACTIONS(2414),
  },
  [1945] = {
    [sym_expression] = STATE(4764),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6587),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1946] = {
    [sym_expression] = STATE(5950),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(6590),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1947] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6592),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1948] = {
    [sym_expression] = STATE(4824),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6594),
    [anon_sym_LPAREN2] = ACTIONS(6596),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1949] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6598),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1950] = {
    [sym_expression] = STATE(4763),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6566),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1951] = {
    [sym_identifier] = ACTIONS(3148),
    [aux_sym_preproc_def_token1] = ACTIONS(3148),
    [aux_sym_preproc_if_token1] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3148),
    [sym_preproc_directive] = ACTIONS(3148),
    [anon_sym_LPAREN2] = ACTIONS(3150),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_STAR] = ACTIONS(3150),
    [anon_sym_AMP_AMP] = ACTIONS(3150),
    [anon_sym_AMP] = ACTIONS(3148),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym___extension__] = ACTIONS(3148),
    [anon_sym_typedef] = ACTIONS(3148),
    [anon_sym_in] = ACTIONS(3148),
    [anon_sym_out] = ACTIONS(3148),
    [anon_sym_inout] = ACTIONS(3148),
    [anon_sym_virtual] = ACTIONS(3148),
    [anon_sym_extern] = ACTIONS(3148),
    [anon_sym___attribute__] = ACTIONS(3148),
    [anon_sym___attribute] = ACTIONS(3148),
    [anon_sym_using] = ACTIONS(3148),
    [anon_sym_COLON_COLON] = ACTIONS(3150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3150),
    [anon_sym___declspec] = ACTIONS(3148),
    [anon_sym___based] = ACTIONS(3148),
    [anon_sym_RBRACE] = ACTIONS(3150),
    [anon_sym_signed] = ACTIONS(3148),
    [anon_sym_unsigned] = ACTIONS(3148),
    [anon_sym_long] = ACTIONS(3148),
    [anon_sym_short] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_static] = ACTIONS(3148),
    [anon_sym_register] = ACTIONS(3148),
    [anon_sym_inline] = ACTIONS(3148),
    [anon_sym___inline] = ACTIONS(3148),
    [anon_sym___inline__] = ACTIONS(3148),
    [anon_sym___forceinline] = ACTIONS(3148),
    [anon_sym_thread_local] = ACTIONS(3148),
    [anon_sym___thread] = ACTIONS(3148),
    [anon_sym_const] = ACTIONS(3148),
    [anon_sym_constexpr] = ACTIONS(3148),
    [anon_sym_volatile] = ACTIONS(3148),
    [anon_sym_restrict] = ACTIONS(3148),
    [anon_sym___restrict__] = ACTIONS(3148),
    [anon_sym__Atomic] = ACTIONS(3148),
    [anon_sym__Noreturn] = ACTIONS(3148),
    [anon_sym_noreturn] = ACTIONS(3148),
    [anon_sym__Nonnull] = ACTIONS(3148),
    [anon_sym_mutable] = ACTIONS(3148),
    [anon_sym_constinit] = ACTIONS(3148),
    [anon_sym_consteval] = ACTIONS(3148),
    [anon_sym_alignas] = ACTIONS(3148),
    [anon_sym__Alignas] = ACTIONS(3148),
    [sym_primitive_type] = ACTIONS(3148),
    [anon_sym_enum] = ACTIONS(3148),
    [anon_sym_class] = ACTIONS(3148),
    [anon_sym_struct] = ACTIONS(3148),
    [anon_sym_union] = ACTIONS(3148),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3148),
    [anon_sym_let] = ACTIONS(3148),
    [anon_sym_This] = ACTIONS(3148),
    [anon_sym_decltype] = ACTIONS(3148),
    [anon_sym_explicit] = ACTIONS(3148),
    [anon_sym_typename] = ACTIONS(3148),
    [anon_sym_private] = ACTIONS(3148),
    [anon_sym_template] = ACTIONS(3148),
    [anon_sym_operator] = ACTIONS(3148),
    [anon_sym_friend] = ACTIONS(3148),
    [anon_sym_public] = ACTIONS(3148),
    [anon_sym_protected] = ACTIONS(3148),
    [anon_sym_static_assert] = ACTIONS(3148),
    [anon_sym_catch] = ACTIONS(3148),
    [anon_sym_precise] = ACTIONS(3148),
    [anon_sym_shared] = ACTIONS(3148),
    [anon_sym_groupshared] = ACTIONS(3148),
    [anon_sym_uniform] = ACTIONS(3148),
    [anon_sym_row_major] = ACTIONS(3148),
    [anon_sym_column_major] = ACTIONS(3148),
    [anon_sym_globallycoherent] = ACTIONS(3148),
    [anon_sym_centroid] = ACTIONS(3148),
    [anon_sym_noperspective] = ACTIONS(3148),
    [anon_sym_nointerpolation] = ACTIONS(3148),
    [anon_sym_sample] = ACTIONS(3148),
    [anon_sym_linear] = ACTIONS(3148),
    [anon_sym_snorm] = ACTIONS(3148),
    [anon_sym_unorm] = ACTIONS(3148),
    [anon_sym_point] = ACTIONS(3148),
    [anon_sym_line] = ACTIONS(3148),
    [anon_sym_triangleadj] = ACTIONS(3148),
    [anon_sym_lineadj] = ACTIONS(3148),
    [anon_sym_triangle] = ACTIONS(3148),
    [anon_sym_interface] = ACTIONS(3148),
    [anon_sym_extension] = ACTIONS(3148),
    [anon_sym___init] = ACTIONS(3148),
    [anon_sym___subscript] = ACTIONS(3148),
    [anon_sym_property] = ACTIONS(3148),
    [anon_sym_associatedtype] = ACTIONS(3148),
  },
  [1952] = {
    [sym_expression] = STATE(4304),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1953] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6603),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1954] = {
    [sym_expression] = STATE(4824),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6594),
    [anon_sym_LPAREN2] = ACTIONS(6605),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1955] = {
    [sym_expression] = STATE(4824),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6594),
    [anon_sym_LPAREN2] = ACTIONS(6607),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1956] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6609),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1957] = {
    [sym_expression] = STATE(4478),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6501),
    [anon_sym_LPAREN2] = ACTIONS(6611),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5158),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1958] = {
    [sym_expression] = STATE(5475),
    [sym__string] = STATE(5341),
    [sym_comma_expression] = STATE(9686),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1959] = {
    [sym_expression] = STATE(4779),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6546),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1960] = {
    [sym_expression] = STATE(5934),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(6613),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1961] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6615),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1962] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6617),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1963] = {
    [sym_expression] = STATE(4764),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6572),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1964] = {
    [sym_expression] = STATE(4767),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6552),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1965] = {
    [sym_expression] = STATE(4777),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6619),
    [anon_sym_LPAREN2] = ACTIONS(6621),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1966] = {
    [sym_expression] = STATE(5923),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(6623),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1967] = {
    [sym_identifier] = ACTIONS(3148),
    [aux_sym_preproc_def_token1] = ACTIONS(3148),
    [aux_sym_preproc_if_token1] = ACTIONS(3148),
    [aux_sym_preproc_if_token2] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3148),
    [sym_preproc_directive] = ACTIONS(3148),
    [anon_sym_LPAREN2] = ACTIONS(3150),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_STAR] = ACTIONS(3150),
    [anon_sym_AMP_AMP] = ACTIONS(3150),
    [anon_sym_AMP] = ACTIONS(3148),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym___extension__] = ACTIONS(3148),
    [anon_sym_typedef] = ACTIONS(3148),
    [anon_sym_in] = ACTIONS(3148),
    [anon_sym_out] = ACTIONS(3148),
    [anon_sym_inout] = ACTIONS(3148),
    [anon_sym_virtual] = ACTIONS(3148),
    [anon_sym_extern] = ACTIONS(3148),
    [anon_sym___attribute__] = ACTIONS(3148),
    [anon_sym___attribute] = ACTIONS(3148),
    [anon_sym_using] = ACTIONS(3148),
    [anon_sym_COLON_COLON] = ACTIONS(3150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3150),
    [anon_sym___declspec] = ACTIONS(3148),
    [anon_sym___based] = ACTIONS(3148),
    [anon_sym_signed] = ACTIONS(3148),
    [anon_sym_unsigned] = ACTIONS(3148),
    [anon_sym_long] = ACTIONS(3148),
    [anon_sym_short] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_static] = ACTIONS(3148),
    [anon_sym_register] = ACTIONS(3148),
    [anon_sym_inline] = ACTIONS(3148),
    [anon_sym___inline] = ACTIONS(3148),
    [anon_sym___inline__] = ACTIONS(3148),
    [anon_sym___forceinline] = ACTIONS(3148),
    [anon_sym_thread_local] = ACTIONS(3148),
    [anon_sym___thread] = ACTIONS(3148),
    [anon_sym_const] = ACTIONS(3148),
    [anon_sym_constexpr] = ACTIONS(3148),
    [anon_sym_volatile] = ACTIONS(3148),
    [anon_sym_restrict] = ACTIONS(3148),
    [anon_sym___restrict__] = ACTIONS(3148),
    [anon_sym__Atomic] = ACTIONS(3148),
    [anon_sym__Noreturn] = ACTIONS(3148),
    [anon_sym_noreturn] = ACTIONS(3148),
    [anon_sym__Nonnull] = ACTIONS(3148),
    [anon_sym_mutable] = ACTIONS(3148),
    [anon_sym_constinit] = ACTIONS(3148),
    [anon_sym_consteval] = ACTIONS(3148),
    [anon_sym_alignas] = ACTIONS(3148),
    [anon_sym__Alignas] = ACTIONS(3148),
    [sym_primitive_type] = ACTIONS(3148),
    [anon_sym_enum] = ACTIONS(3148),
    [anon_sym_class] = ACTIONS(3148),
    [anon_sym_struct] = ACTIONS(3148),
    [anon_sym_union] = ACTIONS(3148),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3148),
    [anon_sym_let] = ACTIONS(3148),
    [anon_sym_This] = ACTIONS(3148),
    [anon_sym_decltype] = ACTIONS(3148),
    [anon_sym_explicit] = ACTIONS(3148),
    [anon_sym_typename] = ACTIONS(3148),
    [anon_sym_private] = ACTIONS(3148),
    [anon_sym_template] = ACTIONS(3148),
    [anon_sym_operator] = ACTIONS(3148),
    [anon_sym_friend] = ACTIONS(3148),
    [anon_sym_public] = ACTIONS(3148),
    [anon_sym_protected] = ACTIONS(3148),
    [anon_sym_static_assert] = ACTIONS(3148),
    [anon_sym_catch] = ACTIONS(3148),
    [anon_sym_precise] = ACTIONS(3148),
    [anon_sym_shared] = ACTIONS(3148),
    [anon_sym_groupshared] = ACTIONS(3148),
    [anon_sym_uniform] = ACTIONS(3148),
    [anon_sym_row_major] = ACTIONS(3148),
    [anon_sym_column_major] = ACTIONS(3148),
    [anon_sym_globallycoherent] = ACTIONS(3148),
    [anon_sym_centroid] = ACTIONS(3148),
    [anon_sym_noperspective] = ACTIONS(3148),
    [anon_sym_nointerpolation] = ACTIONS(3148),
    [anon_sym_sample] = ACTIONS(3148),
    [anon_sym_linear] = ACTIONS(3148),
    [anon_sym_snorm] = ACTIONS(3148),
    [anon_sym_unorm] = ACTIONS(3148),
    [anon_sym_point] = ACTIONS(3148),
    [anon_sym_line] = ACTIONS(3148),
    [anon_sym_triangleadj] = ACTIONS(3148),
    [anon_sym_lineadj] = ACTIONS(3148),
    [anon_sym_triangle] = ACTIONS(3148),
    [anon_sym_interface] = ACTIONS(3148),
    [anon_sym_extension] = ACTIONS(3148),
    [anon_sym___init] = ACTIONS(3148),
    [anon_sym___subscript] = ACTIONS(3148),
    [anon_sym_property] = ACTIONS(3148),
    [anon_sym_associatedtype] = ACTIONS(3148),
  },
  [1968] = {
    [sym_expression] = STATE(4779),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6561),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1969] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6625),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1970] = {
    [sym_expression] = STATE(5927),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(6627),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1971] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6629),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1972] = {
    [sym_expression] = STATE(4765),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6631),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1973] = {
    [sym_expression] = STATE(3379),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6501),
    [anon_sym_LPAREN2] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4956),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_DASH_DASH] = ACTIONS(5544),
    [anon_sym_PLUS_PLUS] = ACTIONS(5544),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1974] = {
    [sym_expression] = STATE(5421),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym_SEMI] = ACTIONS(6636),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(6483),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1975] = {
    [sym_expression] = STATE(4779),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6577),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1976] = {
    [sym_expression] = STATE(4782),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6582),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1977] = {
    [sym_expression] = STATE(4774),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6600),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1978] = {
    [sym_identifier] = ACTIONS(2414),
    [aux_sym_preproc_def_token1] = ACTIONS(2414),
    [anon_sym_COMMA] = ACTIONS(4215),
    [aux_sym_preproc_if_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2414),
    [sym_preproc_directive] = ACTIONS(2414),
    [anon_sym_LPAREN2] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(4215),
    [anon_sym___extension__] = ACTIONS(2414),
    [anon_sym_typedef] = ACTIONS(2414),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_out] = ACTIONS(2414),
    [anon_sym_inout] = ACTIONS(2414),
    [anon_sym_virtual] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym___attribute__] = ACTIONS(6106),
    [anon_sym___attribute] = ACTIONS(6106),
    [anon_sym_using] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2412),
    [anon_sym___declspec] = ACTIONS(2414),
    [anon_sym___based] = ACTIONS(2414),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [anon_sym_signed] = ACTIONS(2414),
    [anon_sym_unsigned] = ACTIONS(2414),
    [anon_sym_long] = ACTIONS(2414),
    [anon_sym_short] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_register] = ACTIONS(2414),
    [anon_sym_inline] = ACTIONS(2414),
    [anon_sym___inline] = ACTIONS(2414),
    [anon_sym___inline__] = ACTIONS(2414),
    [anon_sym___forceinline] = ACTIONS(2414),
    [anon_sym_thread_local] = ACTIONS(2414),
    [anon_sym___thread] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_constexpr] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym_restrict] = ACTIONS(2414),
    [anon_sym___restrict__] = ACTIONS(2414),
    [anon_sym__Atomic] = ACTIONS(2414),
    [anon_sym__Noreturn] = ACTIONS(2414),
    [anon_sym_noreturn] = ACTIONS(2414),
    [anon_sym__Nonnull] = ACTIONS(2414),
    [anon_sym_mutable] = ACTIONS(2414),
    [anon_sym_constinit] = ACTIONS(2414),
    [anon_sym_consteval] = ACTIONS(2414),
    [anon_sym_alignas] = ACTIONS(2414),
    [anon_sym__Alignas] = ACTIONS(2414),
    [sym_primitive_type] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2414),
    [anon_sym_let] = ACTIONS(2414),
    [anon_sym_This] = ACTIONS(2414),
    [anon_sym_decltype] = ACTIONS(2414),
    [anon_sym_explicit] = ACTIONS(2414),
    [anon_sym_typename] = ACTIONS(2414),
    [anon_sym_private] = ACTIONS(2414),
    [anon_sym_template] = ACTIONS(2414),
    [anon_sym_operator] = ACTIONS(2414),
    [anon_sym_friend] = ACTIONS(2414),
    [anon_sym_public] = ACTIONS(2414),
    [anon_sym_protected] = ACTIONS(2414),
    [anon_sym_static_assert] = ACTIONS(2414),
    [anon_sym_precise] = ACTIONS(2414),
    [anon_sym_shared] = ACTIONS(2414),
    [anon_sym_groupshared] = ACTIONS(2414),
    [anon_sym_uniform] = ACTIONS(2414),
    [anon_sym_row_major] = ACTIONS(2414),
    [anon_sym_column_major] = ACTIONS(2414),
    [anon_sym_globallycoherent] = ACTIONS(2414),
    [anon_sym_centroid] = ACTIONS(2414),
    [anon_sym_noperspective] = ACTIONS(2414),
    [anon_sym_nointerpolation] = ACTIONS(2414),
    [anon_sym_sample] = ACTIONS(2414),
    [anon_sym_linear] = ACTIONS(2414),
    [anon_sym_snorm] = ACTIONS(2414),
    [anon_sym_unorm] = ACTIONS(2414),
    [anon_sym_point] = ACTIONS(2414),
    [anon_sym_line] = ACTIONS(2414),
    [anon_sym_triangleadj] = ACTIONS(2414),
    [anon_sym_lineadj] = ACTIONS(2414),
    [anon_sym_triangle] = ACTIONS(2414),
    [anon_sym_interface] = ACTIONS(2414),
    [anon_sym_extension] = ACTIONS(2414),
    [anon_sym___init] = ACTIONS(2414),
    [anon_sym___subscript] = ACTIONS(2414),
    [anon_sym_property] = ACTIONS(2414),
    [anon_sym_associatedtype] = ACTIONS(2414),
  },
  [1979] = {
    [sym_expression] = STATE(4217),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6638),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1980] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6641),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1981] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(6643),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [1982] = {
    [sym_expression] = STATE(5832),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6594),
    [anon_sym_LPAREN2] = ACTIONS(6645),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1983] = {
    [sym_expression] = STATE(4135),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6647),
    [anon_sym_LPAREN2] = ACTIONS(6649),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1984] = {
    [sym_identifier] = ACTIONS(2414),
    [aux_sym_preproc_def_token1] = ACTIONS(2414),
    [aux_sym_preproc_if_token1] = ACTIONS(2414),
    [aux_sym_preproc_if_token2] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2414),
    [sym_preproc_directive] = ACTIONS(2414),
    [anon_sym_LPAREN2] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym___extension__] = ACTIONS(2414),
    [anon_sym_typedef] = ACTIONS(2414),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_out] = ACTIONS(2414),
    [anon_sym_inout] = ACTIONS(2414),
    [anon_sym_virtual] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym___attribute__] = ACTIONS(2414),
    [anon_sym___attribute] = ACTIONS(2414),
    [anon_sym_using] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2412),
    [anon_sym___declspec] = ACTIONS(2414),
    [anon_sym___based] = ACTIONS(2414),
    [anon_sym_signed] = ACTIONS(2414),
    [anon_sym_unsigned] = ACTIONS(2414),
    [anon_sym_long] = ACTIONS(2414),
    [anon_sym_short] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_register] = ACTIONS(2414),
    [anon_sym_inline] = ACTIONS(2414),
    [anon_sym___inline] = ACTIONS(2414),
    [anon_sym___inline__] = ACTIONS(2414),
    [anon_sym___forceinline] = ACTIONS(2414),
    [anon_sym_thread_local] = ACTIONS(2414),
    [anon_sym___thread] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_constexpr] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym_restrict] = ACTIONS(2414),
    [anon_sym___restrict__] = ACTIONS(2414),
    [anon_sym__Atomic] = ACTIONS(2414),
    [anon_sym__Noreturn] = ACTIONS(2414),
    [anon_sym_noreturn] = ACTIONS(2414),
    [anon_sym__Nonnull] = ACTIONS(2414),
    [anon_sym_mutable] = ACTIONS(2414),
    [anon_sym_constinit] = ACTIONS(2414),
    [anon_sym_consteval] = ACTIONS(2414),
    [anon_sym_alignas] = ACTIONS(2414),
    [anon_sym__Alignas] = ACTIONS(2414),
    [sym_primitive_type] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2414),
    [anon_sym_let] = ACTIONS(2414),
    [anon_sym_This] = ACTIONS(2414),
    [anon_sym_decltype] = ACTIONS(2414),
    [anon_sym_explicit] = ACTIONS(2414),
    [anon_sym_typename] = ACTIONS(2414),
    [anon_sym_private] = ACTIONS(2414),
    [anon_sym_template] = ACTIONS(2414),
    [anon_sym_operator] = ACTIONS(2414),
    [anon_sym_friend] = ACTIONS(2414),
    [anon_sym_public] = ACTIONS(2414),
    [anon_sym_protected] = ACTIONS(2414),
    [anon_sym_static_assert] = ACTIONS(2414),
    [anon_sym_catch] = ACTIONS(2414),
    [anon_sym_precise] = ACTIONS(2414),
    [anon_sym_shared] = ACTIONS(2414),
    [anon_sym_groupshared] = ACTIONS(2414),
    [anon_sym_uniform] = ACTIONS(2414),
    [anon_sym_row_major] = ACTIONS(2414),
    [anon_sym_column_major] = ACTIONS(2414),
    [anon_sym_globallycoherent] = ACTIONS(2414),
    [anon_sym_centroid] = ACTIONS(2414),
    [anon_sym_noperspective] = ACTIONS(2414),
    [anon_sym_nointerpolation] = ACTIONS(2414),
    [anon_sym_sample] = ACTIONS(2414),
    [anon_sym_linear] = ACTIONS(2414),
    [anon_sym_snorm] = ACTIONS(2414),
    [anon_sym_unorm] = ACTIONS(2414),
    [anon_sym_point] = ACTIONS(2414),
    [anon_sym_line] = ACTIONS(2414),
    [anon_sym_triangleadj] = ACTIONS(2414),
    [anon_sym_lineadj] = ACTIONS(2414),
    [anon_sym_triangle] = ACTIONS(2414),
    [anon_sym_interface] = ACTIONS(2414),
    [anon_sym_extension] = ACTIONS(2414),
    [anon_sym___init] = ACTIONS(2414),
    [anon_sym___subscript] = ACTIONS(2414),
    [anon_sym_property] = ACTIONS(2414),
    [anon_sym_associatedtype] = ACTIONS(2414),
  },
  [1985] = {
    [sym_expression] = STATE(4763),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6638),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1986] = {
    [sym_expression] = STATE(4824),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6594),
    [anon_sym_LPAREN2] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [1987] = {
    [sym_expression] = STATE(4782),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6478),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1988] = {
    [sym_expression] = STATE(4266),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6653),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1989] = {
    [sym_expression] = STATE(4221),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6631),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1990] = {
    [sym_identifier] = ACTIONS(2404),
    [aux_sym_preproc_def_token1] = ACTIONS(2404),
    [aux_sym_preproc_if_token1] = ACTIONS(2404),
    [aux_sym_preproc_if_token2] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2404),
    [sym_preproc_directive] = ACTIONS(2404),
    [anon_sym_LPAREN2] = ACTIONS(2402),
    [anon_sym_TILDE] = ACTIONS(2402),
    [anon_sym_STAR] = ACTIONS(2402),
    [anon_sym_AMP_AMP] = ACTIONS(2402),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2402),
    [anon_sym___extension__] = ACTIONS(2404),
    [anon_sym_typedef] = ACTIONS(2404),
    [anon_sym_in] = ACTIONS(2404),
    [anon_sym_out] = ACTIONS(2404),
    [anon_sym_inout] = ACTIONS(2404),
    [anon_sym_virtual] = ACTIONS(2404),
    [anon_sym_extern] = ACTIONS(2404),
    [anon_sym___attribute__] = ACTIONS(2404),
    [anon_sym___attribute] = ACTIONS(2404),
    [anon_sym_using] = ACTIONS(2404),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2402),
    [anon_sym___declspec] = ACTIONS(2404),
    [anon_sym___based] = ACTIONS(2404),
    [anon_sym_signed] = ACTIONS(2404),
    [anon_sym_unsigned] = ACTIONS(2404),
    [anon_sym_long] = ACTIONS(2404),
    [anon_sym_short] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_register] = ACTIONS(2404),
    [anon_sym_inline] = ACTIONS(2404),
    [anon_sym___inline] = ACTIONS(2404),
    [anon_sym___inline__] = ACTIONS(2404),
    [anon_sym___forceinline] = ACTIONS(2404),
    [anon_sym_thread_local] = ACTIONS(2404),
    [anon_sym___thread] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [anon_sym_constexpr] = ACTIONS(2404),
    [anon_sym_volatile] = ACTIONS(2404),
    [anon_sym_restrict] = ACTIONS(2404),
    [anon_sym___restrict__] = ACTIONS(2404),
    [anon_sym__Atomic] = ACTIONS(2404),
    [anon_sym__Noreturn] = ACTIONS(2404),
    [anon_sym_noreturn] = ACTIONS(2404),
    [anon_sym__Nonnull] = ACTIONS(2404),
    [anon_sym_mutable] = ACTIONS(2404),
    [anon_sym_constinit] = ACTIONS(2404),
    [anon_sym_consteval] = ACTIONS(2404),
    [anon_sym_alignas] = ACTIONS(2404),
    [anon_sym__Alignas] = ACTIONS(2404),
    [sym_primitive_type] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
    [anon_sym_class] = ACTIONS(2404),
    [anon_sym_struct] = ACTIONS(2404),
    [anon_sym_union] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2404),
    [anon_sym_let] = ACTIONS(2404),
    [anon_sym_This] = ACTIONS(2404),
    [anon_sym_decltype] = ACTIONS(2404),
    [anon_sym_explicit] = ACTIONS(2404),
    [anon_sym_typename] = ACTIONS(2404),
    [anon_sym_private] = ACTIONS(2404),
    [anon_sym_template] = ACTIONS(2404),
    [anon_sym_operator] = ACTIONS(2404),
    [anon_sym_friend] = ACTIONS(2404),
    [anon_sym_public] = ACTIONS(2404),
    [anon_sym_protected] = ACTIONS(2404),
    [anon_sym_static_assert] = ACTIONS(2404),
    [anon_sym_catch] = ACTIONS(2404),
    [anon_sym_precise] = ACTIONS(2404),
    [anon_sym_shared] = ACTIONS(2404),
    [anon_sym_groupshared] = ACTIONS(2404),
    [anon_sym_uniform] = ACTIONS(2404),
    [anon_sym_row_major] = ACTIONS(2404),
    [anon_sym_column_major] = ACTIONS(2404),
    [anon_sym_globallycoherent] = ACTIONS(2404),
    [anon_sym_centroid] = ACTIONS(2404),
    [anon_sym_noperspective] = ACTIONS(2404),
    [anon_sym_nointerpolation] = ACTIONS(2404),
    [anon_sym_sample] = ACTIONS(2404),
    [anon_sym_linear] = ACTIONS(2404),
    [anon_sym_snorm] = ACTIONS(2404),
    [anon_sym_unorm] = ACTIONS(2404),
    [anon_sym_point] = ACTIONS(2404),
    [anon_sym_line] = ACTIONS(2404),
    [anon_sym_triangleadj] = ACTIONS(2404),
    [anon_sym_lineadj] = ACTIONS(2404),
    [anon_sym_triangle] = ACTIONS(2404),
    [anon_sym_interface] = ACTIONS(2404),
    [anon_sym_extension] = ACTIONS(2404),
    [anon_sym___init] = ACTIONS(2404),
    [anon_sym___subscript] = ACTIONS(2404),
    [anon_sym_property] = ACTIONS(2404),
    [anon_sym_associatedtype] = ACTIONS(2404),
  },
  [1991] = {
    [sym_expression] = STATE(4219),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6587),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [1992] = {
    [sym_expression] = STATE(4771),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6653),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [1993] = {
    [sym_expression] = STATE(5882),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_SEMI] = ACTIONS(6656),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1994] = {
    [sym_identifier] = ACTIONS(6372),
    [aux_sym_preproc_def_token1] = ACTIONS(6372),
    [aux_sym_preproc_if_token1] = ACTIONS(6372),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6372),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6372),
    [sym_preproc_directive] = ACTIONS(6372),
    [anon_sym_LPAREN2] = ACTIONS(6374),
    [anon_sym_TILDE] = ACTIONS(6374),
    [anon_sym_STAR] = ACTIONS(6374),
    [anon_sym_AMP_AMP] = ACTIONS(6374),
    [anon_sym_AMP] = ACTIONS(6372),
    [anon_sym_SEMI] = ACTIONS(6374),
    [anon_sym___extension__] = ACTIONS(6372),
    [anon_sym_typedef] = ACTIONS(6372),
    [anon_sym_in] = ACTIONS(6372),
    [anon_sym_out] = ACTIONS(6372),
    [anon_sym_inout] = ACTIONS(6372),
    [anon_sym_virtual] = ACTIONS(6372),
    [anon_sym_extern] = ACTIONS(6372),
    [anon_sym___attribute__] = ACTIONS(6372),
    [anon_sym___attribute] = ACTIONS(6372),
    [anon_sym_using] = ACTIONS(6372),
    [anon_sym_COLON_COLON] = ACTIONS(6374),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6374),
    [anon_sym___declspec] = ACTIONS(6372),
    [anon_sym___based] = ACTIONS(6372),
    [anon_sym_RBRACE] = ACTIONS(6374),
    [anon_sym_signed] = ACTIONS(6372),
    [anon_sym_unsigned] = ACTIONS(6372),
    [anon_sym_long] = ACTIONS(6372),
    [anon_sym_short] = ACTIONS(6372),
    [anon_sym_LBRACK] = ACTIONS(6372),
    [anon_sym_static] = ACTIONS(6372),
    [anon_sym_register] = ACTIONS(6372),
    [anon_sym_inline] = ACTIONS(6372),
    [anon_sym___inline] = ACTIONS(6372),
    [anon_sym___inline__] = ACTIONS(6372),
    [anon_sym___forceinline] = ACTIONS(6372),
    [anon_sym_thread_local] = ACTIONS(6372),
    [anon_sym___thread] = ACTIONS(6372),
    [anon_sym_const] = ACTIONS(6372),
    [anon_sym_constexpr] = ACTIONS(6372),
    [anon_sym_volatile] = ACTIONS(6372),
    [anon_sym_restrict] = ACTIONS(6372),
    [anon_sym___restrict__] = ACTIONS(6372),
    [anon_sym__Atomic] = ACTIONS(6372),
    [anon_sym__Noreturn] = ACTIONS(6372),
    [anon_sym_noreturn] = ACTIONS(6372),
    [anon_sym__Nonnull] = ACTIONS(6372),
    [anon_sym_mutable] = ACTIONS(6372),
    [anon_sym_constinit] = ACTIONS(6372),
    [anon_sym_consteval] = ACTIONS(6372),
    [anon_sym_alignas] = ACTIONS(6372),
    [anon_sym__Alignas] = ACTIONS(6372),
    [sym_primitive_type] = ACTIONS(6372),
    [anon_sym_enum] = ACTIONS(6372),
    [anon_sym_class] = ACTIONS(6372),
    [anon_sym_struct] = ACTIONS(6372),
    [anon_sym_union] = ACTIONS(6372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6372),
    [anon_sym_let] = ACTIONS(6372),
    [anon_sym_This] = ACTIONS(6372),
    [anon_sym_decltype] = ACTIONS(6372),
    [anon_sym_explicit] = ACTIONS(6372),
    [anon_sym_typename] = ACTIONS(6372),
    [anon_sym_private] = ACTIONS(6372),
    [anon_sym_template] = ACTIONS(6372),
    [anon_sym_operator] = ACTIONS(6372),
    [anon_sym_friend] = ACTIONS(6372),
    [anon_sym_public] = ACTIONS(6372),
    [anon_sym_protected] = ACTIONS(6372),
    [anon_sym_static_assert] = ACTIONS(6372),
    [anon_sym_precise] = ACTIONS(6372),
    [anon_sym_shared] = ACTIONS(6372),
    [anon_sym_groupshared] = ACTIONS(6372),
    [anon_sym_uniform] = ACTIONS(6372),
    [anon_sym_row_major] = ACTIONS(6372),
    [anon_sym_column_major] = ACTIONS(6372),
    [anon_sym_globallycoherent] = ACTIONS(6372),
    [anon_sym_centroid] = ACTIONS(6372),
    [anon_sym_noperspective] = ACTIONS(6372),
    [anon_sym_nointerpolation] = ACTIONS(6372),
    [anon_sym_sample] = ACTIONS(6372),
    [anon_sym_linear] = ACTIONS(6372),
    [anon_sym_snorm] = ACTIONS(6372),
    [anon_sym_unorm] = ACTIONS(6372),
    [anon_sym_point] = ACTIONS(6372),
    [anon_sym_line] = ACTIONS(6372),
    [anon_sym_triangleadj] = ACTIONS(6372),
    [anon_sym_lineadj] = ACTIONS(6372),
    [anon_sym_triangle] = ACTIONS(6372),
    [anon_sym_interface] = ACTIONS(6372),
    [anon_sym_extension] = ACTIONS(6372),
    [anon_sym___init] = ACTIONS(6372),
    [anon_sym___subscript] = ACTIONS(6372),
    [anon_sym_property] = ACTIONS(6372),
    [anon_sym_associatedtype] = ACTIONS(6372),
  },
  [1995] = {
    [sym_expression] = STATE(5787),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [1996] = {
    [sym_expression] = STATE(5395),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1997] = {
    [sym_identifier] = ACTIONS(6340),
    [aux_sym_preproc_def_token1] = ACTIONS(6340),
    [aux_sym_preproc_if_token1] = ACTIONS(6340),
    [aux_sym_preproc_if_token2] = ACTIONS(6340),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6340),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6340),
    [sym_preproc_directive] = ACTIONS(6340),
    [anon_sym_LPAREN2] = ACTIONS(6342),
    [anon_sym_TILDE] = ACTIONS(6342),
    [anon_sym_STAR] = ACTIONS(6342),
    [anon_sym_AMP_AMP] = ACTIONS(6342),
    [anon_sym_AMP] = ACTIONS(6340),
    [anon_sym_SEMI] = ACTIONS(6342),
    [anon_sym___extension__] = ACTIONS(6340),
    [anon_sym_typedef] = ACTIONS(6340),
    [anon_sym_in] = ACTIONS(6340),
    [anon_sym_out] = ACTIONS(6340),
    [anon_sym_inout] = ACTIONS(6340),
    [anon_sym_virtual] = ACTIONS(6340),
    [anon_sym_extern] = ACTIONS(6340),
    [anon_sym___attribute__] = ACTIONS(6340),
    [anon_sym___attribute] = ACTIONS(6340),
    [anon_sym_using] = ACTIONS(6340),
    [anon_sym_COLON_COLON] = ACTIONS(6342),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6342),
    [anon_sym___declspec] = ACTIONS(6340),
    [anon_sym___based] = ACTIONS(6340),
    [anon_sym_signed] = ACTIONS(6340),
    [anon_sym_unsigned] = ACTIONS(6340),
    [anon_sym_long] = ACTIONS(6340),
    [anon_sym_short] = ACTIONS(6340),
    [anon_sym_LBRACK] = ACTIONS(6340),
    [anon_sym_static] = ACTIONS(6340),
    [anon_sym_register] = ACTIONS(6340),
    [anon_sym_inline] = ACTIONS(6340),
    [anon_sym___inline] = ACTIONS(6340),
    [anon_sym___inline__] = ACTIONS(6340),
    [anon_sym___forceinline] = ACTIONS(6340),
    [anon_sym_thread_local] = ACTIONS(6340),
    [anon_sym___thread] = ACTIONS(6340),
    [anon_sym_const] = ACTIONS(6340),
    [anon_sym_constexpr] = ACTIONS(6340),
    [anon_sym_volatile] = ACTIONS(6340),
    [anon_sym_restrict] = ACTIONS(6340),
    [anon_sym___restrict__] = ACTIONS(6340),
    [anon_sym__Atomic] = ACTIONS(6340),
    [anon_sym__Noreturn] = ACTIONS(6340),
    [anon_sym_noreturn] = ACTIONS(6340),
    [anon_sym__Nonnull] = ACTIONS(6340),
    [anon_sym_mutable] = ACTIONS(6340),
    [anon_sym_constinit] = ACTIONS(6340),
    [anon_sym_consteval] = ACTIONS(6340),
    [anon_sym_alignas] = ACTIONS(6340),
    [anon_sym__Alignas] = ACTIONS(6340),
    [sym_primitive_type] = ACTIONS(6340),
    [anon_sym_enum] = ACTIONS(6340),
    [anon_sym_class] = ACTIONS(6340),
    [anon_sym_struct] = ACTIONS(6340),
    [anon_sym_union] = ACTIONS(6340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6340),
    [anon_sym_let] = ACTIONS(6340),
    [anon_sym_This] = ACTIONS(6340),
    [anon_sym_decltype] = ACTIONS(6340),
    [anon_sym_explicit] = ACTIONS(6340),
    [anon_sym_typename] = ACTIONS(6340),
    [anon_sym_private] = ACTIONS(6340),
    [anon_sym_template] = ACTIONS(6340),
    [anon_sym_operator] = ACTIONS(6340),
    [anon_sym_friend] = ACTIONS(6340),
    [anon_sym_public] = ACTIONS(6340),
    [anon_sym_protected] = ACTIONS(6340),
    [anon_sym_static_assert] = ACTIONS(6340),
    [anon_sym_precise] = ACTIONS(6340),
    [anon_sym_shared] = ACTIONS(6340),
    [anon_sym_groupshared] = ACTIONS(6340),
    [anon_sym_uniform] = ACTIONS(6340),
    [anon_sym_row_major] = ACTIONS(6340),
    [anon_sym_column_major] = ACTIONS(6340),
    [anon_sym_globallycoherent] = ACTIONS(6340),
    [anon_sym_centroid] = ACTIONS(6340),
    [anon_sym_noperspective] = ACTIONS(6340),
    [anon_sym_nointerpolation] = ACTIONS(6340),
    [anon_sym_sample] = ACTIONS(6340),
    [anon_sym_linear] = ACTIONS(6340),
    [anon_sym_snorm] = ACTIONS(6340),
    [anon_sym_unorm] = ACTIONS(6340),
    [anon_sym_point] = ACTIONS(6340),
    [anon_sym_line] = ACTIONS(6340),
    [anon_sym_triangleadj] = ACTIONS(6340),
    [anon_sym_lineadj] = ACTIONS(6340),
    [anon_sym_triangle] = ACTIONS(6340),
    [anon_sym_interface] = ACTIONS(6340),
    [anon_sym_extension] = ACTIONS(6340),
    [anon_sym___init] = ACTIONS(6340),
    [anon_sym___subscript] = ACTIONS(6340),
    [anon_sym_property] = ACTIONS(6340),
    [anon_sym_associatedtype] = ACTIONS(6340),
  },
  [1998] = {
    [sym_expression] = STATE(5885),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5599),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [1999] = {
    [sym_identifier] = ACTIONS(6348),
    [aux_sym_preproc_def_token1] = ACTIONS(6348),
    [aux_sym_preproc_if_token1] = ACTIONS(6348),
    [aux_sym_preproc_if_token2] = ACTIONS(6348),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6348),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6348),
    [sym_preproc_directive] = ACTIONS(6348),
    [anon_sym_LPAREN2] = ACTIONS(6350),
    [anon_sym_TILDE] = ACTIONS(6350),
    [anon_sym_STAR] = ACTIONS(6350),
    [anon_sym_AMP_AMP] = ACTIONS(6350),
    [anon_sym_AMP] = ACTIONS(6348),
    [anon_sym_SEMI] = ACTIONS(6350),
    [anon_sym___extension__] = ACTIONS(6348),
    [anon_sym_typedef] = ACTIONS(6348),
    [anon_sym_in] = ACTIONS(6348),
    [anon_sym_out] = ACTIONS(6348),
    [anon_sym_inout] = ACTIONS(6348),
    [anon_sym_virtual] = ACTIONS(6348),
    [anon_sym_extern] = ACTIONS(6348),
    [anon_sym___attribute__] = ACTIONS(6348),
    [anon_sym___attribute] = ACTIONS(6348),
    [anon_sym_using] = ACTIONS(6348),
    [anon_sym_COLON_COLON] = ACTIONS(6350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6350),
    [anon_sym___declspec] = ACTIONS(6348),
    [anon_sym___based] = ACTIONS(6348),
    [anon_sym_signed] = ACTIONS(6348),
    [anon_sym_unsigned] = ACTIONS(6348),
    [anon_sym_long] = ACTIONS(6348),
    [anon_sym_short] = ACTIONS(6348),
    [anon_sym_LBRACK] = ACTIONS(6348),
    [anon_sym_static] = ACTIONS(6348),
    [anon_sym_register] = ACTIONS(6348),
    [anon_sym_inline] = ACTIONS(6348),
    [anon_sym___inline] = ACTIONS(6348),
    [anon_sym___inline__] = ACTIONS(6348),
    [anon_sym___forceinline] = ACTIONS(6348),
    [anon_sym_thread_local] = ACTIONS(6348),
    [anon_sym___thread] = ACTIONS(6348),
    [anon_sym_const] = ACTIONS(6348),
    [anon_sym_constexpr] = ACTIONS(6348),
    [anon_sym_volatile] = ACTIONS(6348),
    [anon_sym_restrict] = ACTIONS(6348),
    [anon_sym___restrict__] = ACTIONS(6348),
    [anon_sym__Atomic] = ACTIONS(6348),
    [anon_sym__Noreturn] = ACTIONS(6348),
    [anon_sym_noreturn] = ACTIONS(6348),
    [anon_sym__Nonnull] = ACTIONS(6348),
    [anon_sym_mutable] = ACTIONS(6348),
    [anon_sym_constinit] = ACTIONS(6348),
    [anon_sym_consteval] = ACTIONS(6348),
    [anon_sym_alignas] = ACTIONS(6348),
    [anon_sym__Alignas] = ACTIONS(6348),
    [sym_primitive_type] = ACTIONS(6348),
    [anon_sym_enum] = ACTIONS(6348),
    [anon_sym_class] = ACTIONS(6348),
    [anon_sym_struct] = ACTIONS(6348),
    [anon_sym_union] = ACTIONS(6348),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6348),
    [anon_sym_let] = ACTIONS(6348),
    [anon_sym_This] = ACTIONS(6348),
    [anon_sym_decltype] = ACTIONS(6348),
    [anon_sym_explicit] = ACTIONS(6348),
    [anon_sym_typename] = ACTIONS(6348),
    [anon_sym_private] = ACTIONS(6348),
    [anon_sym_template] = ACTIONS(6348),
    [anon_sym_operator] = ACTIONS(6348),
    [anon_sym_friend] = ACTIONS(6348),
    [anon_sym_public] = ACTIONS(6348),
    [anon_sym_protected] = ACTIONS(6348),
    [anon_sym_static_assert] = ACTIONS(6348),
    [anon_sym_precise] = ACTIONS(6348),
    [anon_sym_shared] = ACTIONS(6348),
    [anon_sym_groupshared] = ACTIONS(6348),
    [anon_sym_uniform] = ACTIONS(6348),
    [anon_sym_row_major] = ACTIONS(6348),
    [anon_sym_column_major] = ACTIONS(6348),
    [anon_sym_globallycoherent] = ACTIONS(6348),
    [anon_sym_centroid] = ACTIONS(6348),
    [anon_sym_noperspective] = ACTIONS(6348),
    [anon_sym_nointerpolation] = ACTIONS(6348),
    [anon_sym_sample] = ACTIONS(6348),
    [anon_sym_linear] = ACTIONS(6348),
    [anon_sym_snorm] = ACTIONS(6348),
    [anon_sym_unorm] = ACTIONS(6348),
    [anon_sym_point] = ACTIONS(6348),
    [anon_sym_line] = ACTIONS(6348),
    [anon_sym_triangleadj] = ACTIONS(6348),
    [anon_sym_lineadj] = ACTIONS(6348),
    [anon_sym_triangle] = ACTIONS(6348),
    [anon_sym_interface] = ACTIONS(6348),
    [anon_sym_extension] = ACTIONS(6348),
    [anon_sym___init] = ACTIONS(6348),
    [anon_sym___subscript] = ACTIONS(6348),
    [anon_sym_property] = ACTIONS(6348),
    [anon_sym_associatedtype] = ACTIONS(6348),
  },
  [2000] = {
    [sym_identifier] = ACTIONS(6352),
    [aux_sym_preproc_def_token1] = ACTIONS(6352),
    [aux_sym_preproc_if_token1] = ACTIONS(6352),
    [aux_sym_preproc_if_token2] = ACTIONS(6352),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6352),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6352),
    [sym_preproc_directive] = ACTIONS(6352),
    [anon_sym_LPAREN2] = ACTIONS(6354),
    [anon_sym_TILDE] = ACTIONS(6354),
    [anon_sym_STAR] = ACTIONS(6354),
    [anon_sym_AMP_AMP] = ACTIONS(6354),
    [anon_sym_AMP] = ACTIONS(6352),
    [anon_sym_SEMI] = ACTIONS(6354),
    [anon_sym___extension__] = ACTIONS(6352),
    [anon_sym_typedef] = ACTIONS(6352),
    [anon_sym_in] = ACTIONS(6352),
    [anon_sym_out] = ACTIONS(6352),
    [anon_sym_inout] = ACTIONS(6352),
    [anon_sym_virtual] = ACTIONS(6352),
    [anon_sym_extern] = ACTIONS(6352),
    [anon_sym___attribute__] = ACTIONS(6352),
    [anon_sym___attribute] = ACTIONS(6352),
    [anon_sym_using] = ACTIONS(6352),
    [anon_sym_COLON_COLON] = ACTIONS(6354),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6354),
    [anon_sym___declspec] = ACTIONS(6352),
    [anon_sym___based] = ACTIONS(6352),
    [anon_sym_signed] = ACTIONS(6352),
    [anon_sym_unsigned] = ACTIONS(6352),
    [anon_sym_long] = ACTIONS(6352),
    [anon_sym_short] = ACTIONS(6352),
    [anon_sym_LBRACK] = ACTIONS(6352),
    [anon_sym_static] = ACTIONS(6352),
    [anon_sym_register] = ACTIONS(6352),
    [anon_sym_inline] = ACTIONS(6352),
    [anon_sym___inline] = ACTIONS(6352),
    [anon_sym___inline__] = ACTIONS(6352),
    [anon_sym___forceinline] = ACTIONS(6352),
    [anon_sym_thread_local] = ACTIONS(6352),
    [anon_sym___thread] = ACTIONS(6352),
    [anon_sym_const] = ACTIONS(6352),
    [anon_sym_constexpr] = ACTIONS(6352),
    [anon_sym_volatile] = ACTIONS(6352),
    [anon_sym_restrict] = ACTIONS(6352),
    [anon_sym___restrict__] = ACTIONS(6352),
    [anon_sym__Atomic] = ACTIONS(6352),
    [anon_sym__Noreturn] = ACTIONS(6352),
    [anon_sym_noreturn] = ACTIONS(6352),
    [anon_sym__Nonnull] = ACTIONS(6352),
    [anon_sym_mutable] = ACTIONS(6352),
    [anon_sym_constinit] = ACTIONS(6352),
    [anon_sym_consteval] = ACTIONS(6352),
    [anon_sym_alignas] = ACTIONS(6352),
    [anon_sym__Alignas] = ACTIONS(6352),
    [sym_primitive_type] = ACTIONS(6352),
    [anon_sym_enum] = ACTIONS(6352),
    [anon_sym_class] = ACTIONS(6352),
    [anon_sym_struct] = ACTIONS(6352),
    [anon_sym_union] = ACTIONS(6352),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6352),
    [anon_sym_let] = ACTIONS(6352),
    [anon_sym_This] = ACTIONS(6352),
    [anon_sym_decltype] = ACTIONS(6352),
    [anon_sym_explicit] = ACTIONS(6352),
    [anon_sym_typename] = ACTIONS(6352),
    [anon_sym_private] = ACTIONS(6352),
    [anon_sym_template] = ACTIONS(6352),
    [anon_sym_operator] = ACTIONS(6352),
    [anon_sym_friend] = ACTIONS(6352),
    [anon_sym_public] = ACTIONS(6352),
    [anon_sym_protected] = ACTIONS(6352),
    [anon_sym_static_assert] = ACTIONS(6352),
    [anon_sym_precise] = ACTIONS(6352),
    [anon_sym_shared] = ACTIONS(6352),
    [anon_sym_groupshared] = ACTIONS(6352),
    [anon_sym_uniform] = ACTIONS(6352),
    [anon_sym_row_major] = ACTIONS(6352),
    [anon_sym_column_major] = ACTIONS(6352),
    [anon_sym_globallycoherent] = ACTIONS(6352),
    [anon_sym_centroid] = ACTIONS(6352),
    [anon_sym_noperspective] = ACTIONS(6352),
    [anon_sym_nointerpolation] = ACTIONS(6352),
    [anon_sym_sample] = ACTIONS(6352),
    [anon_sym_linear] = ACTIONS(6352),
    [anon_sym_snorm] = ACTIONS(6352),
    [anon_sym_unorm] = ACTIONS(6352),
    [anon_sym_point] = ACTIONS(6352),
    [anon_sym_line] = ACTIONS(6352),
    [anon_sym_triangleadj] = ACTIONS(6352),
    [anon_sym_lineadj] = ACTIONS(6352),
    [anon_sym_triangle] = ACTIONS(6352),
    [anon_sym_interface] = ACTIONS(6352),
    [anon_sym_extension] = ACTIONS(6352),
    [anon_sym___init] = ACTIONS(6352),
    [anon_sym___subscript] = ACTIONS(6352),
    [anon_sym_property] = ACTIONS(6352),
    [anon_sym_associatedtype] = ACTIONS(6352),
  },
  [2001] = {
    [sym_identifier] = ACTIONS(6356),
    [aux_sym_preproc_def_token1] = ACTIONS(6356),
    [aux_sym_preproc_if_token1] = ACTIONS(6356),
    [aux_sym_preproc_if_token2] = ACTIONS(6356),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6356),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6356),
    [sym_preproc_directive] = ACTIONS(6356),
    [anon_sym_LPAREN2] = ACTIONS(6358),
    [anon_sym_TILDE] = ACTIONS(6358),
    [anon_sym_STAR] = ACTIONS(6358),
    [anon_sym_AMP_AMP] = ACTIONS(6358),
    [anon_sym_AMP] = ACTIONS(6356),
    [anon_sym_SEMI] = ACTIONS(6358),
    [anon_sym___extension__] = ACTIONS(6356),
    [anon_sym_typedef] = ACTIONS(6356),
    [anon_sym_in] = ACTIONS(6356),
    [anon_sym_out] = ACTIONS(6356),
    [anon_sym_inout] = ACTIONS(6356),
    [anon_sym_virtual] = ACTIONS(6356),
    [anon_sym_extern] = ACTIONS(6356),
    [anon_sym___attribute__] = ACTIONS(6356),
    [anon_sym___attribute] = ACTIONS(6356),
    [anon_sym_using] = ACTIONS(6356),
    [anon_sym_COLON_COLON] = ACTIONS(6358),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6358),
    [anon_sym___declspec] = ACTIONS(6356),
    [anon_sym___based] = ACTIONS(6356),
    [anon_sym_signed] = ACTIONS(6356),
    [anon_sym_unsigned] = ACTIONS(6356),
    [anon_sym_long] = ACTIONS(6356),
    [anon_sym_short] = ACTIONS(6356),
    [anon_sym_LBRACK] = ACTIONS(6356),
    [anon_sym_static] = ACTIONS(6356),
    [anon_sym_register] = ACTIONS(6356),
    [anon_sym_inline] = ACTIONS(6356),
    [anon_sym___inline] = ACTIONS(6356),
    [anon_sym___inline__] = ACTIONS(6356),
    [anon_sym___forceinline] = ACTIONS(6356),
    [anon_sym_thread_local] = ACTIONS(6356),
    [anon_sym___thread] = ACTIONS(6356),
    [anon_sym_const] = ACTIONS(6356),
    [anon_sym_constexpr] = ACTIONS(6356),
    [anon_sym_volatile] = ACTIONS(6356),
    [anon_sym_restrict] = ACTIONS(6356),
    [anon_sym___restrict__] = ACTIONS(6356),
    [anon_sym__Atomic] = ACTIONS(6356),
    [anon_sym__Noreturn] = ACTIONS(6356),
    [anon_sym_noreturn] = ACTIONS(6356),
    [anon_sym__Nonnull] = ACTIONS(6356),
    [anon_sym_mutable] = ACTIONS(6356),
    [anon_sym_constinit] = ACTIONS(6356),
    [anon_sym_consteval] = ACTIONS(6356),
    [anon_sym_alignas] = ACTIONS(6356),
    [anon_sym__Alignas] = ACTIONS(6356),
    [sym_primitive_type] = ACTIONS(6356),
    [anon_sym_enum] = ACTIONS(6356),
    [anon_sym_class] = ACTIONS(6356),
    [anon_sym_struct] = ACTIONS(6356),
    [anon_sym_union] = ACTIONS(6356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6356),
    [anon_sym_let] = ACTIONS(6356),
    [anon_sym_This] = ACTIONS(6356),
    [anon_sym_decltype] = ACTIONS(6356),
    [anon_sym_explicit] = ACTIONS(6356),
    [anon_sym_typename] = ACTIONS(6356),
    [anon_sym_private] = ACTIONS(6356),
    [anon_sym_template] = ACTIONS(6356),
    [anon_sym_operator] = ACTIONS(6356),
    [anon_sym_friend] = ACTIONS(6356),
    [anon_sym_public] = ACTIONS(6356),
    [anon_sym_protected] = ACTIONS(6356),
    [anon_sym_static_assert] = ACTIONS(6356),
    [anon_sym_precise] = ACTIONS(6356),
    [anon_sym_shared] = ACTIONS(6356),
    [anon_sym_groupshared] = ACTIONS(6356),
    [anon_sym_uniform] = ACTIONS(6356),
    [anon_sym_row_major] = ACTIONS(6356),
    [anon_sym_column_major] = ACTIONS(6356),
    [anon_sym_globallycoherent] = ACTIONS(6356),
    [anon_sym_centroid] = ACTIONS(6356),
    [anon_sym_noperspective] = ACTIONS(6356),
    [anon_sym_nointerpolation] = ACTIONS(6356),
    [anon_sym_sample] = ACTIONS(6356),
    [anon_sym_linear] = ACTIONS(6356),
    [anon_sym_snorm] = ACTIONS(6356),
    [anon_sym_unorm] = ACTIONS(6356),
    [anon_sym_point] = ACTIONS(6356),
    [anon_sym_line] = ACTIONS(6356),
    [anon_sym_triangleadj] = ACTIONS(6356),
    [anon_sym_lineadj] = ACTIONS(6356),
    [anon_sym_triangle] = ACTIONS(6356),
    [anon_sym_interface] = ACTIONS(6356),
    [anon_sym_extension] = ACTIONS(6356),
    [anon_sym___init] = ACTIONS(6356),
    [anon_sym___subscript] = ACTIONS(6356),
    [anon_sym_property] = ACTIONS(6356),
    [anon_sym_associatedtype] = ACTIONS(6356),
  },
  [2002] = {
    [sym_identifier] = ACTIONS(6360),
    [aux_sym_preproc_def_token1] = ACTIONS(6360),
    [aux_sym_preproc_if_token1] = ACTIONS(6360),
    [aux_sym_preproc_if_token2] = ACTIONS(6360),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6360),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6360),
    [sym_preproc_directive] = ACTIONS(6360),
    [anon_sym_LPAREN2] = ACTIONS(6362),
    [anon_sym_TILDE] = ACTIONS(6362),
    [anon_sym_STAR] = ACTIONS(6362),
    [anon_sym_AMP_AMP] = ACTIONS(6362),
    [anon_sym_AMP] = ACTIONS(6360),
    [anon_sym_SEMI] = ACTIONS(6362),
    [anon_sym___extension__] = ACTIONS(6360),
    [anon_sym_typedef] = ACTIONS(6360),
    [anon_sym_in] = ACTIONS(6360),
    [anon_sym_out] = ACTIONS(6360),
    [anon_sym_inout] = ACTIONS(6360),
    [anon_sym_virtual] = ACTIONS(6360),
    [anon_sym_extern] = ACTIONS(6360),
    [anon_sym___attribute__] = ACTIONS(6360),
    [anon_sym___attribute] = ACTIONS(6360),
    [anon_sym_using] = ACTIONS(6360),
    [anon_sym_COLON_COLON] = ACTIONS(6362),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6362),
    [anon_sym___declspec] = ACTIONS(6360),
    [anon_sym___based] = ACTIONS(6360),
    [anon_sym_signed] = ACTIONS(6360),
    [anon_sym_unsigned] = ACTIONS(6360),
    [anon_sym_long] = ACTIONS(6360),
    [anon_sym_short] = ACTIONS(6360),
    [anon_sym_LBRACK] = ACTIONS(6360),
    [anon_sym_static] = ACTIONS(6360),
    [anon_sym_register] = ACTIONS(6360),
    [anon_sym_inline] = ACTIONS(6360),
    [anon_sym___inline] = ACTIONS(6360),
    [anon_sym___inline__] = ACTIONS(6360),
    [anon_sym___forceinline] = ACTIONS(6360),
    [anon_sym_thread_local] = ACTIONS(6360),
    [anon_sym___thread] = ACTIONS(6360),
    [anon_sym_const] = ACTIONS(6360),
    [anon_sym_constexpr] = ACTIONS(6360),
    [anon_sym_volatile] = ACTIONS(6360),
    [anon_sym_restrict] = ACTIONS(6360),
    [anon_sym___restrict__] = ACTIONS(6360),
    [anon_sym__Atomic] = ACTIONS(6360),
    [anon_sym__Noreturn] = ACTIONS(6360),
    [anon_sym_noreturn] = ACTIONS(6360),
    [anon_sym__Nonnull] = ACTIONS(6360),
    [anon_sym_mutable] = ACTIONS(6360),
    [anon_sym_constinit] = ACTIONS(6360),
    [anon_sym_consteval] = ACTIONS(6360),
    [anon_sym_alignas] = ACTIONS(6360),
    [anon_sym__Alignas] = ACTIONS(6360),
    [sym_primitive_type] = ACTIONS(6360),
    [anon_sym_enum] = ACTIONS(6360),
    [anon_sym_class] = ACTIONS(6360),
    [anon_sym_struct] = ACTIONS(6360),
    [anon_sym_union] = ACTIONS(6360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6360),
    [anon_sym_let] = ACTIONS(6360),
    [anon_sym_This] = ACTIONS(6360),
    [anon_sym_decltype] = ACTIONS(6360),
    [anon_sym_explicit] = ACTIONS(6360),
    [anon_sym_typename] = ACTIONS(6360),
    [anon_sym_private] = ACTIONS(6360),
    [anon_sym_template] = ACTIONS(6360),
    [anon_sym_operator] = ACTIONS(6360),
    [anon_sym_friend] = ACTIONS(6360),
    [anon_sym_public] = ACTIONS(6360),
    [anon_sym_protected] = ACTIONS(6360),
    [anon_sym_static_assert] = ACTIONS(6360),
    [anon_sym_precise] = ACTIONS(6360),
    [anon_sym_shared] = ACTIONS(6360),
    [anon_sym_groupshared] = ACTIONS(6360),
    [anon_sym_uniform] = ACTIONS(6360),
    [anon_sym_row_major] = ACTIONS(6360),
    [anon_sym_column_major] = ACTIONS(6360),
    [anon_sym_globallycoherent] = ACTIONS(6360),
    [anon_sym_centroid] = ACTIONS(6360),
    [anon_sym_noperspective] = ACTIONS(6360),
    [anon_sym_nointerpolation] = ACTIONS(6360),
    [anon_sym_sample] = ACTIONS(6360),
    [anon_sym_linear] = ACTIONS(6360),
    [anon_sym_snorm] = ACTIONS(6360),
    [anon_sym_unorm] = ACTIONS(6360),
    [anon_sym_point] = ACTIONS(6360),
    [anon_sym_line] = ACTIONS(6360),
    [anon_sym_triangleadj] = ACTIONS(6360),
    [anon_sym_lineadj] = ACTIONS(6360),
    [anon_sym_triangle] = ACTIONS(6360),
    [anon_sym_interface] = ACTIONS(6360),
    [anon_sym_extension] = ACTIONS(6360),
    [anon_sym___init] = ACTIONS(6360),
    [anon_sym___subscript] = ACTIONS(6360),
    [anon_sym_property] = ACTIONS(6360),
    [anon_sym_associatedtype] = ACTIONS(6360),
  },
  [2003] = {
    [sym_identifier] = ACTIONS(6368),
    [aux_sym_preproc_def_token1] = ACTIONS(6368),
    [aux_sym_preproc_if_token1] = ACTIONS(6368),
    [aux_sym_preproc_if_token2] = ACTIONS(6368),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6368),
    [sym_preproc_directive] = ACTIONS(6368),
    [anon_sym_LPAREN2] = ACTIONS(6370),
    [anon_sym_TILDE] = ACTIONS(6370),
    [anon_sym_STAR] = ACTIONS(6370),
    [anon_sym_AMP_AMP] = ACTIONS(6370),
    [anon_sym_AMP] = ACTIONS(6368),
    [anon_sym_SEMI] = ACTIONS(6370),
    [anon_sym___extension__] = ACTIONS(6368),
    [anon_sym_typedef] = ACTIONS(6368),
    [anon_sym_in] = ACTIONS(6368),
    [anon_sym_out] = ACTIONS(6368),
    [anon_sym_inout] = ACTIONS(6368),
    [anon_sym_virtual] = ACTIONS(6368),
    [anon_sym_extern] = ACTIONS(6368),
    [anon_sym___attribute__] = ACTIONS(6368),
    [anon_sym___attribute] = ACTIONS(6368),
    [anon_sym_using] = ACTIONS(6368),
    [anon_sym_COLON_COLON] = ACTIONS(6370),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6370),
    [anon_sym___declspec] = ACTIONS(6368),
    [anon_sym___based] = ACTIONS(6368),
    [anon_sym_signed] = ACTIONS(6368),
    [anon_sym_unsigned] = ACTIONS(6368),
    [anon_sym_long] = ACTIONS(6368),
    [anon_sym_short] = ACTIONS(6368),
    [anon_sym_LBRACK] = ACTIONS(6368),
    [anon_sym_static] = ACTIONS(6368),
    [anon_sym_register] = ACTIONS(6368),
    [anon_sym_inline] = ACTIONS(6368),
    [anon_sym___inline] = ACTIONS(6368),
    [anon_sym___inline__] = ACTIONS(6368),
    [anon_sym___forceinline] = ACTIONS(6368),
    [anon_sym_thread_local] = ACTIONS(6368),
    [anon_sym___thread] = ACTIONS(6368),
    [anon_sym_const] = ACTIONS(6368),
    [anon_sym_constexpr] = ACTIONS(6368),
    [anon_sym_volatile] = ACTIONS(6368),
    [anon_sym_restrict] = ACTIONS(6368),
    [anon_sym___restrict__] = ACTIONS(6368),
    [anon_sym__Atomic] = ACTIONS(6368),
    [anon_sym__Noreturn] = ACTIONS(6368),
    [anon_sym_noreturn] = ACTIONS(6368),
    [anon_sym__Nonnull] = ACTIONS(6368),
    [anon_sym_mutable] = ACTIONS(6368),
    [anon_sym_constinit] = ACTIONS(6368),
    [anon_sym_consteval] = ACTIONS(6368),
    [anon_sym_alignas] = ACTIONS(6368),
    [anon_sym__Alignas] = ACTIONS(6368),
    [sym_primitive_type] = ACTIONS(6368),
    [anon_sym_enum] = ACTIONS(6368),
    [anon_sym_class] = ACTIONS(6368),
    [anon_sym_struct] = ACTIONS(6368),
    [anon_sym_union] = ACTIONS(6368),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6368),
    [anon_sym_let] = ACTIONS(6368),
    [anon_sym_This] = ACTIONS(6368),
    [anon_sym_decltype] = ACTIONS(6368),
    [anon_sym_explicit] = ACTIONS(6368),
    [anon_sym_typename] = ACTIONS(6368),
    [anon_sym_private] = ACTIONS(6368),
    [anon_sym_template] = ACTIONS(6368),
    [anon_sym_operator] = ACTIONS(6368),
    [anon_sym_friend] = ACTIONS(6368),
    [anon_sym_public] = ACTIONS(6368),
    [anon_sym_protected] = ACTIONS(6368),
    [anon_sym_static_assert] = ACTIONS(6368),
    [anon_sym_precise] = ACTIONS(6368),
    [anon_sym_shared] = ACTIONS(6368),
    [anon_sym_groupshared] = ACTIONS(6368),
    [anon_sym_uniform] = ACTIONS(6368),
    [anon_sym_row_major] = ACTIONS(6368),
    [anon_sym_column_major] = ACTIONS(6368),
    [anon_sym_globallycoherent] = ACTIONS(6368),
    [anon_sym_centroid] = ACTIONS(6368),
    [anon_sym_noperspective] = ACTIONS(6368),
    [anon_sym_nointerpolation] = ACTIONS(6368),
    [anon_sym_sample] = ACTIONS(6368),
    [anon_sym_linear] = ACTIONS(6368),
    [anon_sym_snorm] = ACTIONS(6368),
    [anon_sym_unorm] = ACTIONS(6368),
    [anon_sym_point] = ACTIONS(6368),
    [anon_sym_line] = ACTIONS(6368),
    [anon_sym_triangleadj] = ACTIONS(6368),
    [anon_sym_lineadj] = ACTIONS(6368),
    [anon_sym_triangle] = ACTIONS(6368),
    [anon_sym_interface] = ACTIONS(6368),
    [anon_sym_extension] = ACTIONS(6368),
    [anon_sym___init] = ACTIONS(6368),
    [anon_sym___subscript] = ACTIONS(6368),
    [anon_sym_property] = ACTIONS(6368),
    [anon_sym_associatedtype] = ACTIONS(6368),
  },
  [2004] = {
    [sym_identifier] = ACTIONS(6372),
    [aux_sym_preproc_def_token1] = ACTIONS(6372),
    [aux_sym_preproc_if_token1] = ACTIONS(6372),
    [aux_sym_preproc_if_token2] = ACTIONS(6372),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6372),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6372),
    [sym_preproc_directive] = ACTIONS(6372),
    [anon_sym_LPAREN2] = ACTIONS(6374),
    [anon_sym_TILDE] = ACTIONS(6374),
    [anon_sym_STAR] = ACTIONS(6374),
    [anon_sym_AMP_AMP] = ACTIONS(6374),
    [anon_sym_AMP] = ACTIONS(6372),
    [anon_sym_SEMI] = ACTIONS(6374),
    [anon_sym___extension__] = ACTIONS(6372),
    [anon_sym_typedef] = ACTIONS(6372),
    [anon_sym_in] = ACTIONS(6372),
    [anon_sym_out] = ACTIONS(6372),
    [anon_sym_inout] = ACTIONS(6372),
    [anon_sym_virtual] = ACTIONS(6372),
    [anon_sym_extern] = ACTIONS(6372),
    [anon_sym___attribute__] = ACTIONS(6372),
    [anon_sym___attribute] = ACTIONS(6372),
    [anon_sym_using] = ACTIONS(6372),
    [anon_sym_COLON_COLON] = ACTIONS(6374),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6374),
    [anon_sym___declspec] = ACTIONS(6372),
    [anon_sym___based] = ACTIONS(6372),
    [anon_sym_signed] = ACTIONS(6372),
    [anon_sym_unsigned] = ACTIONS(6372),
    [anon_sym_long] = ACTIONS(6372),
    [anon_sym_short] = ACTIONS(6372),
    [anon_sym_LBRACK] = ACTIONS(6372),
    [anon_sym_static] = ACTIONS(6372),
    [anon_sym_register] = ACTIONS(6372),
    [anon_sym_inline] = ACTIONS(6372),
    [anon_sym___inline] = ACTIONS(6372),
    [anon_sym___inline__] = ACTIONS(6372),
    [anon_sym___forceinline] = ACTIONS(6372),
    [anon_sym_thread_local] = ACTIONS(6372),
    [anon_sym___thread] = ACTIONS(6372),
    [anon_sym_const] = ACTIONS(6372),
    [anon_sym_constexpr] = ACTIONS(6372),
    [anon_sym_volatile] = ACTIONS(6372),
    [anon_sym_restrict] = ACTIONS(6372),
    [anon_sym___restrict__] = ACTIONS(6372),
    [anon_sym__Atomic] = ACTIONS(6372),
    [anon_sym__Noreturn] = ACTIONS(6372),
    [anon_sym_noreturn] = ACTIONS(6372),
    [anon_sym__Nonnull] = ACTIONS(6372),
    [anon_sym_mutable] = ACTIONS(6372),
    [anon_sym_constinit] = ACTIONS(6372),
    [anon_sym_consteval] = ACTIONS(6372),
    [anon_sym_alignas] = ACTIONS(6372),
    [anon_sym__Alignas] = ACTIONS(6372),
    [sym_primitive_type] = ACTIONS(6372),
    [anon_sym_enum] = ACTIONS(6372),
    [anon_sym_class] = ACTIONS(6372),
    [anon_sym_struct] = ACTIONS(6372),
    [anon_sym_union] = ACTIONS(6372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6372),
    [anon_sym_let] = ACTIONS(6372),
    [anon_sym_This] = ACTIONS(6372),
    [anon_sym_decltype] = ACTIONS(6372),
    [anon_sym_explicit] = ACTIONS(6372),
    [anon_sym_typename] = ACTIONS(6372),
    [anon_sym_private] = ACTIONS(6372),
    [anon_sym_template] = ACTIONS(6372),
    [anon_sym_operator] = ACTIONS(6372),
    [anon_sym_friend] = ACTIONS(6372),
    [anon_sym_public] = ACTIONS(6372),
    [anon_sym_protected] = ACTIONS(6372),
    [anon_sym_static_assert] = ACTIONS(6372),
    [anon_sym_precise] = ACTIONS(6372),
    [anon_sym_shared] = ACTIONS(6372),
    [anon_sym_groupshared] = ACTIONS(6372),
    [anon_sym_uniform] = ACTIONS(6372),
    [anon_sym_row_major] = ACTIONS(6372),
    [anon_sym_column_major] = ACTIONS(6372),
    [anon_sym_globallycoherent] = ACTIONS(6372),
    [anon_sym_centroid] = ACTIONS(6372),
    [anon_sym_noperspective] = ACTIONS(6372),
    [anon_sym_nointerpolation] = ACTIONS(6372),
    [anon_sym_sample] = ACTIONS(6372),
    [anon_sym_linear] = ACTIONS(6372),
    [anon_sym_snorm] = ACTIONS(6372),
    [anon_sym_unorm] = ACTIONS(6372),
    [anon_sym_point] = ACTIONS(6372),
    [anon_sym_line] = ACTIONS(6372),
    [anon_sym_triangleadj] = ACTIONS(6372),
    [anon_sym_lineadj] = ACTIONS(6372),
    [anon_sym_triangle] = ACTIONS(6372),
    [anon_sym_interface] = ACTIONS(6372),
    [anon_sym_extension] = ACTIONS(6372),
    [anon_sym___init] = ACTIONS(6372),
    [anon_sym___subscript] = ACTIONS(6372),
    [anon_sym_property] = ACTIONS(6372),
    [anon_sym_associatedtype] = ACTIONS(6372),
  },
  [2005] = {
    [sym_identifier] = ACTIONS(6372),
    [aux_sym_preproc_def_token1] = ACTIONS(6372),
    [aux_sym_preproc_if_token1] = ACTIONS(6372),
    [aux_sym_preproc_if_token2] = ACTIONS(6372),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6372),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6372),
    [sym_preproc_directive] = ACTIONS(6372),
    [anon_sym_LPAREN2] = ACTIONS(6374),
    [anon_sym_TILDE] = ACTIONS(6374),
    [anon_sym_STAR] = ACTIONS(6374),
    [anon_sym_AMP_AMP] = ACTIONS(6374),
    [anon_sym_AMP] = ACTIONS(6372),
    [anon_sym_SEMI] = ACTIONS(6374),
    [anon_sym___extension__] = ACTIONS(6372),
    [anon_sym_typedef] = ACTIONS(6372),
    [anon_sym_in] = ACTIONS(6372),
    [anon_sym_out] = ACTIONS(6372),
    [anon_sym_inout] = ACTIONS(6372),
    [anon_sym_virtual] = ACTIONS(6372),
    [anon_sym_extern] = ACTIONS(6372),
    [anon_sym___attribute__] = ACTIONS(6372),
    [anon_sym___attribute] = ACTIONS(6372),
    [anon_sym_using] = ACTIONS(6372),
    [anon_sym_COLON_COLON] = ACTIONS(6374),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6374),
    [anon_sym___declspec] = ACTIONS(6372),
    [anon_sym___based] = ACTIONS(6372),
    [anon_sym_signed] = ACTIONS(6372),
    [anon_sym_unsigned] = ACTIONS(6372),
    [anon_sym_long] = ACTIONS(6372),
    [anon_sym_short] = ACTIONS(6372),
    [anon_sym_LBRACK] = ACTIONS(6372),
    [anon_sym_static] = ACTIONS(6372),
    [anon_sym_register] = ACTIONS(6372),
    [anon_sym_inline] = ACTIONS(6372),
    [anon_sym___inline] = ACTIONS(6372),
    [anon_sym___inline__] = ACTIONS(6372),
    [anon_sym___forceinline] = ACTIONS(6372),
    [anon_sym_thread_local] = ACTIONS(6372),
    [anon_sym___thread] = ACTIONS(6372),
    [anon_sym_const] = ACTIONS(6372),
    [anon_sym_constexpr] = ACTIONS(6372),
    [anon_sym_volatile] = ACTIONS(6372),
    [anon_sym_restrict] = ACTIONS(6372),
    [anon_sym___restrict__] = ACTIONS(6372),
    [anon_sym__Atomic] = ACTIONS(6372),
    [anon_sym__Noreturn] = ACTIONS(6372),
    [anon_sym_noreturn] = ACTIONS(6372),
    [anon_sym__Nonnull] = ACTIONS(6372),
    [anon_sym_mutable] = ACTIONS(6372),
    [anon_sym_constinit] = ACTIONS(6372),
    [anon_sym_consteval] = ACTIONS(6372),
    [anon_sym_alignas] = ACTIONS(6372),
    [anon_sym__Alignas] = ACTIONS(6372),
    [sym_primitive_type] = ACTIONS(6372),
    [anon_sym_enum] = ACTIONS(6372),
    [anon_sym_class] = ACTIONS(6372),
    [anon_sym_struct] = ACTIONS(6372),
    [anon_sym_union] = ACTIONS(6372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6372),
    [anon_sym_let] = ACTIONS(6372),
    [anon_sym_This] = ACTIONS(6372),
    [anon_sym_decltype] = ACTIONS(6372),
    [anon_sym_explicit] = ACTIONS(6372),
    [anon_sym_typename] = ACTIONS(6372),
    [anon_sym_private] = ACTIONS(6372),
    [anon_sym_template] = ACTIONS(6372),
    [anon_sym_operator] = ACTIONS(6372),
    [anon_sym_friend] = ACTIONS(6372),
    [anon_sym_public] = ACTIONS(6372),
    [anon_sym_protected] = ACTIONS(6372),
    [anon_sym_static_assert] = ACTIONS(6372),
    [anon_sym_precise] = ACTIONS(6372),
    [anon_sym_shared] = ACTIONS(6372),
    [anon_sym_groupshared] = ACTIONS(6372),
    [anon_sym_uniform] = ACTIONS(6372),
    [anon_sym_row_major] = ACTIONS(6372),
    [anon_sym_column_major] = ACTIONS(6372),
    [anon_sym_globallycoherent] = ACTIONS(6372),
    [anon_sym_centroid] = ACTIONS(6372),
    [anon_sym_noperspective] = ACTIONS(6372),
    [anon_sym_nointerpolation] = ACTIONS(6372),
    [anon_sym_sample] = ACTIONS(6372),
    [anon_sym_linear] = ACTIONS(6372),
    [anon_sym_snorm] = ACTIONS(6372),
    [anon_sym_unorm] = ACTIONS(6372),
    [anon_sym_point] = ACTIONS(6372),
    [anon_sym_line] = ACTIONS(6372),
    [anon_sym_triangleadj] = ACTIONS(6372),
    [anon_sym_lineadj] = ACTIONS(6372),
    [anon_sym_triangle] = ACTIONS(6372),
    [anon_sym_interface] = ACTIONS(6372),
    [anon_sym_extension] = ACTIONS(6372),
    [anon_sym___init] = ACTIONS(6372),
    [anon_sym___subscript] = ACTIONS(6372),
    [anon_sym_property] = ACTIONS(6372),
    [anon_sym_associatedtype] = ACTIONS(6372),
  },
  [2006] = {
    [sym_identifier] = ACTIONS(6372),
    [aux_sym_preproc_def_token1] = ACTIONS(6372),
    [aux_sym_preproc_if_token1] = ACTIONS(6372),
    [aux_sym_preproc_if_token2] = ACTIONS(6372),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6372),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6372),
    [sym_preproc_directive] = ACTIONS(6372),
    [anon_sym_LPAREN2] = ACTIONS(6374),
    [anon_sym_TILDE] = ACTIONS(6374),
    [anon_sym_STAR] = ACTIONS(6374),
    [anon_sym_AMP_AMP] = ACTIONS(6374),
    [anon_sym_AMP] = ACTIONS(6372),
    [anon_sym_SEMI] = ACTIONS(6374),
    [anon_sym___extension__] = ACTIONS(6372),
    [anon_sym_typedef] = ACTIONS(6372),
    [anon_sym_in] = ACTIONS(6372),
    [anon_sym_out] = ACTIONS(6372),
    [anon_sym_inout] = ACTIONS(6372),
    [anon_sym_virtual] = ACTIONS(6372),
    [anon_sym_extern] = ACTIONS(6372),
    [anon_sym___attribute__] = ACTIONS(6372),
    [anon_sym___attribute] = ACTIONS(6372),
    [anon_sym_using] = ACTIONS(6372),
    [anon_sym_COLON_COLON] = ACTIONS(6374),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6374),
    [anon_sym___declspec] = ACTIONS(6372),
    [anon_sym___based] = ACTIONS(6372),
    [anon_sym_signed] = ACTIONS(6372),
    [anon_sym_unsigned] = ACTIONS(6372),
    [anon_sym_long] = ACTIONS(6372),
    [anon_sym_short] = ACTIONS(6372),
    [anon_sym_LBRACK] = ACTIONS(6372),
    [anon_sym_static] = ACTIONS(6372),
    [anon_sym_register] = ACTIONS(6372),
    [anon_sym_inline] = ACTIONS(6372),
    [anon_sym___inline] = ACTIONS(6372),
    [anon_sym___inline__] = ACTIONS(6372),
    [anon_sym___forceinline] = ACTIONS(6372),
    [anon_sym_thread_local] = ACTIONS(6372),
    [anon_sym___thread] = ACTIONS(6372),
    [anon_sym_const] = ACTIONS(6372),
    [anon_sym_constexpr] = ACTIONS(6372),
    [anon_sym_volatile] = ACTIONS(6372),
    [anon_sym_restrict] = ACTIONS(6372),
    [anon_sym___restrict__] = ACTIONS(6372),
    [anon_sym__Atomic] = ACTIONS(6372),
    [anon_sym__Noreturn] = ACTIONS(6372),
    [anon_sym_noreturn] = ACTIONS(6372),
    [anon_sym__Nonnull] = ACTIONS(6372),
    [anon_sym_mutable] = ACTIONS(6372),
    [anon_sym_constinit] = ACTIONS(6372),
    [anon_sym_consteval] = ACTIONS(6372),
    [anon_sym_alignas] = ACTIONS(6372),
    [anon_sym__Alignas] = ACTIONS(6372),
    [sym_primitive_type] = ACTIONS(6372),
    [anon_sym_enum] = ACTIONS(6372),
    [anon_sym_class] = ACTIONS(6372),
    [anon_sym_struct] = ACTIONS(6372),
    [anon_sym_union] = ACTIONS(6372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6372),
    [anon_sym_let] = ACTIONS(6372),
    [anon_sym_This] = ACTIONS(6372),
    [anon_sym_decltype] = ACTIONS(6372),
    [anon_sym_explicit] = ACTIONS(6372),
    [anon_sym_typename] = ACTIONS(6372),
    [anon_sym_private] = ACTIONS(6372),
    [anon_sym_template] = ACTIONS(6372),
    [anon_sym_operator] = ACTIONS(6372),
    [anon_sym_friend] = ACTIONS(6372),
    [anon_sym_public] = ACTIONS(6372),
    [anon_sym_protected] = ACTIONS(6372),
    [anon_sym_static_assert] = ACTIONS(6372),
    [anon_sym_precise] = ACTIONS(6372),
    [anon_sym_shared] = ACTIONS(6372),
    [anon_sym_groupshared] = ACTIONS(6372),
    [anon_sym_uniform] = ACTIONS(6372),
    [anon_sym_row_major] = ACTIONS(6372),
    [anon_sym_column_major] = ACTIONS(6372),
    [anon_sym_globallycoherent] = ACTIONS(6372),
    [anon_sym_centroid] = ACTIONS(6372),
    [anon_sym_noperspective] = ACTIONS(6372),
    [anon_sym_nointerpolation] = ACTIONS(6372),
    [anon_sym_sample] = ACTIONS(6372),
    [anon_sym_linear] = ACTIONS(6372),
    [anon_sym_snorm] = ACTIONS(6372),
    [anon_sym_unorm] = ACTIONS(6372),
    [anon_sym_point] = ACTIONS(6372),
    [anon_sym_line] = ACTIONS(6372),
    [anon_sym_triangleadj] = ACTIONS(6372),
    [anon_sym_lineadj] = ACTIONS(6372),
    [anon_sym_triangle] = ACTIONS(6372),
    [anon_sym_interface] = ACTIONS(6372),
    [anon_sym_extension] = ACTIONS(6372),
    [anon_sym___init] = ACTIONS(6372),
    [anon_sym___subscript] = ACTIONS(6372),
    [anon_sym_property] = ACTIONS(6372),
    [anon_sym_associatedtype] = ACTIONS(6372),
  },
  [2007] = {
    [sym_identifier] = ACTIONS(6368),
    [aux_sym_preproc_def_token1] = ACTIONS(6368),
    [aux_sym_preproc_if_token1] = ACTIONS(6368),
    [aux_sym_preproc_if_token2] = ACTIONS(6368),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6368),
    [sym_preproc_directive] = ACTIONS(6368),
    [anon_sym_LPAREN2] = ACTIONS(6370),
    [anon_sym_TILDE] = ACTIONS(6370),
    [anon_sym_STAR] = ACTIONS(6370),
    [anon_sym_AMP_AMP] = ACTIONS(6370),
    [anon_sym_AMP] = ACTIONS(6368),
    [anon_sym_SEMI] = ACTIONS(6370),
    [anon_sym___extension__] = ACTIONS(6368),
    [anon_sym_typedef] = ACTIONS(6368),
    [anon_sym_in] = ACTIONS(6368),
    [anon_sym_out] = ACTIONS(6368),
    [anon_sym_inout] = ACTIONS(6368),
    [anon_sym_virtual] = ACTIONS(6368),
    [anon_sym_extern] = ACTIONS(6368),
    [anon_sym___attribute__] = ACTIONS(6368),
    [anon_sym___attribute] = ACTIONS(6368),
    [anon_sym_using] = ACTIONS(6368),
    [anon_sym_COLON_COLON] = ACTIONS(6370),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6370),
    [anon_sym___declspec] = ACTIONS(6368),
    [anon_sym___based] = ACTIONS(6368),
    [anon_sym_signed] = ACTIONS(6368),
    [anon_sym_unsigned] = ACTIONS(6368),
    [anon_sym_long] = ACTIONS(6368),
    [anon_sym_short] = ACTIONS(6368),
    [anon_sym_LBRACK] = ACTIONS(6368),
    [anon_sym_static] = ACTIONS(6368),
    [anon_sym_register] = ACTIONS(6368),
    [anon_sym_inline] = ACTIONS(6368),
    [anon_sym___inline] = ACTIONS(6368),
    [anon_sym___inline__] = ACTIONS(6368),
    [anon_sym___forceinline] = ACTIONS(6368),
    [anon_sym_thread_local] = ACTIONS(6368),
    [anon_sym___thread] = ACTIONS(6368),
    [anon_sym_const] = ACTIONS(6368),
    [anon_sym_constexpr] = ACTIONS(6368),
    [anon_sym_volatile] = ACTIONS(6368),
    [anon_sym_restrict] = ACTIONS(6368),
    [anon_sym___restrict__] = ACTIONS(6368),
    [anon_sym__Atomic] = ACTIONS(6368),
    [anon_sym__Noreturn] = ACTIONS(6368),
    [anon_sym_noreturn] = ACTIONS(6368),
    [anon_sym__Nonnull] = ACTIONS(6368),
    [anon_sym_mutable] = ACTIONS(6368),
    [anon_sym_constinit] = ACTIONS(6368),
    [anon_sym_consteval] = ACTIONS(6368),
    [anon_sym_alignas] = ACTIONS(6368),
    [anon_sym__Alignas] = ACTIONS(6368),
    [sym_primitive_type] = ACTIONS(6368),
    [anon_sym_enum] = ACTIONS(6368),
    [anon_sym_class] = ACTIONS(6368),
    [anon_sym_struct] = ACTIONS(6368),
    [anon_sym_union] = ACTIONS(6368),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6368),
    [anon_sym_let] = ACTIONS(6368),
    [anon_sym_This] = ACTIONS(6368),
    [anon_sym_decltype] = ACTIONS(6368),
    [anon_sym_explicit] = ACTIONS(6368),
    [anon_sym_typename] = ACTIONS(6368),
    [anon_sym_private] = ACTIONS(6368),
    [anon_sym_template] = ACTIONS(6368),
    [anon_sym_operator] = ACTIONS(6368),
    [anon_sym_friend] = ACTIONS(6368),
    [anon_sym_public] = ACTIONS(6368),
    [anon_sym_protected] = ACTIONS(6368),
    [anon_sym_static_assert] = ACTIONS(6368),
    [anon_sym_precise] = ACTIONS(6368),
    [anon_sym_shared] = ACTIONS(6368),
    [anon_sym_groupshared] = ACTIONS(6368),
    [anon_sym_uniform] = ACTIONS(6368),
    [anon_sym_row_major] = ACTIONS(6368),
    [anon_sym_column_major] = ACTIONS(6368),
    [anon_sym_globallycoherent] = ACTIONS(6368),
    [anon_sym_centroid] = ACTIONS(6368),
    [anon_sym_noperspective] = ACTIONS(6368),
    [anon_sym_nointerpolation] = ACTIONS(6368),
    [anon_sym_sample] = ACTIONS(6368),
    [anon_sym_linear] = ACTIONS(6368),
    [anon_sym_snorm] = ACTIONS(6368),
    [anon_sym_unorm] = ACTIONS(6368),
    [anon_sym_point] = ACTIONS(6368),
    [anon_sym_line] = ACTIONS(6368),
    [anon_sym_triangleadj] = ACTIONS(6368),
    [anon_sym_lineadj] = ACTIONS(6368),
    [anon_sym_triangle] = ACTIONS(6368),
    [anon_sym_interface] = ACTIONS(6368),
    [anon_sym_extension] = ACTIONS(6368),
    [anon_sym___init] = ACTIONS(6368),
    [anon_sym___subscript] = ACTIONS(6368),
    [anon_sym_property] = ACTIONS(6368),
    [anon_sym_associatedtype] = ACTIONS(6368),
  },
  [2008] = {
    [sym_expression] = STATE(5383),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2009] = {
    [sym_expression] = STATE(5815),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2010] = {
    [sym_expression] = STATE(5446),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2011] = {
    [sym_expression] = STATE(5431),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2012] = {
    [sym_expression] = STATE(5346),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2013] = {
    [sym_expression] = STATE(5363),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2014] = {
    [sym_expression] = STATE(5386),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2015] = {
    [sym_expression] = STATE(5357),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2016] = {
    [sym_expression] = STATE(5978),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2017] = {
    [sym_identifier] = ACTIONS(6290),
    [aux_sym_preproc_def_token1] = ACTIONS(6290),
    [aux_sym_preproc_if_token1] = ACTIONS(6290),
    [aux_sym_preproc_if_token2] = ACTIONS(6290),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6290),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6290),
    [sym_preproc_directive] = ACTIONS(6290),
    [anon_sym_LPAREN2] = ACTIONS(6292),
    [anon_sym_TILDE] = ACTIONS(6292),
    [anon_sym_STAR] = ACTIONS(6292),
    [anon_sym_AMP_AMP] = ACTIONS(6292),
    [anon_sym_AMP] = ACTIONS(6290),
    [anon_sym_SEMI] = ACTIONS(6292),
    [anon_sym___extension__] = ACTIONS(6290),
    [anon_sym_typedef] = ACTIONS(6290),
    [anon_sym_in] = ACTIONS(6290),
    [anon_sym_out] = ACTIONS(6290),
    [anon_sym_inout] = ACTIONS(6290),
    [anon_sym_virtual] = ACTIONS(6290),
    [anon_sym_extern] = ACTIONS(6290),
    [anon_sym___attribute__] = ACTIONS(6290),
    [anon_sym___attribute] = ACTIONS(6290),
    [anon_sym_using] = ACTIONS(6290),
    [anon_sym_COLON_COLON] = ACTIONS(6292),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6292),
    [anon_sym___declspec] = ACTIONS(6290),
    [anon_sym___based] = ACTIONS(6290),
    [anon_sym_signed] = ACTIONS(6290),
    [anon_sym_unsigned] = ACTIONS(6290),
    [anon_sym_long] = ACTIONS(6290),
    [anon_sym_short] = ACTIONS(6290),
    [anon_sym_LBRACK] = ACTIONS(6290),
    [anon_sym_static] = ACTIONS(6290),
    [anon_sym_register] = ACTIONS(6290),
    [anon_sym_inline] = ACTIONS(6290),
    [anon_sym___inline] = ACTIONS(6290),
    [anon_sym___inline__] = ACTIONS(6290),
    [anon_sym___forceinline] = ACTIONS(6290),
    [anon_sym_thread_local] = ACTIONS(6290),
    [anon_sym___thread] = ACTIONS(6290),
    [anon_sym_const] = ACTIONS(6290),
    [anon_sym_constexpr] = ACTIONS(6290),
    [anon_sym_volatile] = ACTIONS(6290),
    [anon_sym_restrict] = ACTIONS(6290),
    [anon_sym___restrict__] = ACTIONS(6290),
    [anon_sym__Atomic] = ACTIONS(6290),
    [anon_sym__Noreturn] = ACTIONS(6290),
    [anon_sym_noreturn] = ACTIONS(6290),
    [anon_sym__Nonnull] = ACTIONS(6290),
    [anon_sym_mutable] = ACTIONS(6290),
    [anon_sym_constinit] = ACTIONS(6290),
    [anon_sym_consteval] = ACTIONS(6290),
    [anon_sym_alignas] = ACTIONS(6290),
    [anon_sym__Alignas] = ACTIONS(6290),
    [sym_primitive_type] = ACTIONS(6290),
    [anon_sym_enum] = ACTIONS(6290),
    [anon_sym_class] = ACTIONS(6290),
    [anon_sym_struct] = ACTIONS(6290),
    [anon_sym_union] = ACTIONS(6290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6290),
    [anon_sym_let] = ACTIONS(6290),
    [anon_sym_This] = ACTIONS(6290),
    [anon_sym_decltype] = ACTIONS(6290),
    [anon_sym_explicit] = ACTIONS(6290),
    [anon_sym_typename] = ACTIONS(6290),
    [anon_sym_private] = ACTIONS(6290),
    [anon_sym_template] = ACTIONS(6290),
    [anon_sym_operator] = ACTIONS(6290),
    [anon_sym_friend] = ACTIONS(6290),
    [anon_sym_public] = ACTIONS(6290),
    [anon_sym_protected] = ACTIONS(6290),
    [anon_sym_static_assert] = ACTIONS(6290),
    [anon_sym_precise] = ACTIONS(6290),
    [anon_sym_shared] = ACTIONS(6290),
    [anon_sym_groupshared] = ACTIONS(6290),
    [anon_sym_uniform] = ACTIONS(6290),
    [anon_sym_row_major] = ACTIONS(6290),
    [anon_sym_column_major] = ACTIONS(6290),
    [anon_sym_globallycoherent] = ACTIONS(6290),
    [anon_sym_centroid] = ACTIONS(6290),
    [anon_sym_noperspective] = ACTIONS(6290),
    [anon_sym_nointerpolation] = ACTIONS(6290),
    [anon_sym_sample] = ACTIONS(6290),
    [anon_sym_linear] = ACTIONS(6290),
    [anon_sym_snorm] = ACTIONS(6290),
    [anon_sym_unorm] = ACTIONS(6290),
    [anon_sym_point] = ACTIONS(6290),
    [anon_sym_line] = ACTIONS(6290),
    [anon_sym_triangleadj] = ACTIONS(6290),
    [anon_sym_lineadj] = ACTIONS(6290),
    [anon_sym_triangle] = ACTIONS(6290),
    [anon_sym_interface] = ACTIONS(6290),
    [anon_sym_extension] = ACTIONS(6290),
    [anon_sym___init] = ACTIONS(6290),
    [anon_sym___subscript] = ACTIONS(6290),
    [anon_sym_property] = ACTIONS(6290),
    [anon_sym_associatedtype] = ACTIONS(6290),
  },
  [2018] = {
    [sym_identifier] = ACTIONS(6314),
    [aux_sym_preproc_def_token1] = ACTIONS(6314),
    [aux_sym_preproc_if_token1] = ACTIONS(6314),
    [aux_sym_preproc_if_token2] = ACTIONS(6314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6314),
    [sym_preproc_directive] = ACTIONS(6314),
    [anon_sym_LPAREN2] = ACTIONS(6316),
    [anon_sym_TILDE] = ACTIONS(6316),
    [anon_sym_STAR] = ACTIONS(6316),
    [anon_sym_AMP_AMP] = ACTIONS(6316),
    [anon_sym_AMP] = ACTIONS(6314),
    [anon_sym_SEMI] = ACTIONS(6316),
    [anon_sym___extension__] = ACTIONS(6314),
    [anon_sym_typedef] = ACTIONS(6314),
    [anon_sym_in] = ACTIONS(6314),
    [anon_sym_out] = ACTIONS(6314),
    [anon_sym_inout] = ACTIONS(6314),
    [anon_sym_virtual] = ACTIONS(6314),
    [anon_sym_extern] = ACTIONS(6314),
    [anon_sym___attribute__] = ACTIONS(6314),
    [anon_sym___attribute] = ACTIONS(6314),
    [anon_sym_using] = ACTIONS(6314),
    [anon_sym_COLON_COLON] = ACTIONS(6316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6316),
    [anon_sym___declspec] = ACTIONS(6314),
    [anon_sym___based] = ACTIONS(6314),
    [anon_sym_signed] = ACTIONS(6314),
    [anon_sym_unsigned] = ACTIONS(6314),
    [anon_sym_long] = ACTIONS(6314),
    [anon_sym_short] = ACTIONS(6314),
    [anon_sym_LBRACK] = ACTIONS(6314),
    [anon_sym_static] = ACTIONS(6314),
    [anon_sym_register] = ACTIONS(6314),
    [anon_sym_inline] = ACTIONS(6314),
    [anon_sym___inline] = ACTIONS(6314),
    [anon_sym___inline__] = ACTIONS(6314),
    [anon_sym___forceinline] = ACTIONS(6314),
    [anon_sym_thread_local] = ACTIONS(6314),
    [anon_sym___thread] = ACTIONS(6314),
    [anon_sym_const] = ACTIONS(6314),
    [anon_sym_constexpr] = ACTIONS(6314),
    [anon_sym_volatile] = ACTIONS(6314),
    [anon_sym_restrict] = ACTIONS(6314),
    [anon_sym___restrict__] = ACTIONS(6314),
    [anon_sym__Atomic] = ACTIONS(6314),
    [anon_sym__Noreturn] = ACTIONS(6314),
    [anon_sym_noreturn] = ACTIONS(6314),
    [anon_sym__Nonnull] = ACTIONS(6314),
    [anon_sym_mutable] = ACTIONS(6314),
    [anon_sym_constinit] = ACTIONS(6314),
    [anon_sym_consteval] = ACTIONS(6314),
    [anon_sym_alignas] = ACTIONS(6314),
    [anon_sym__Alignas] = ACTIONS(6314),
    [sym_primitive_type] = ACTIONS(6314),
    [anon_sym_enum] = ACTIONS(6314),
    [anon_sym_class] = ACTIONS(6314),
    [anon_sym_struct] = ACTIONS(6314),
    [anon_sym_union] = ACTIONS(6314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6314),
    [anon_sym_let] = ACTIONS(6314),
    [anon_sym_This] = ACTIONS(6314),
    [anon_sym_decltype] = ACTIONS(6314),
    [anon_sym_explicit] = ACTIONS(6314),
    [anon_sym_typename] = ACTIONS(6314),
    [anon_sym_private] = ACTIONS(6314),
    [anon_sym_template] = ACTIONS(6314),
    [anon_sym_operator] = ACTIONS(6314),
    [anon_sym_friend] = ACTIONS(6314),
    [anon_sym_public] = ACTIONS(6314),
    [anon_sym_protected] = ACTIONS(6314),
    [anon_sym_static_assert] = ACTIONS(6314),
    [anon_sym_precise] = ACTIONS(6314),
    [anon_sym_shared] = ACTIONS(6314),
    [anon_sym_groupshared] = ACTIONS(6314),
    [anon_sym_uniform] = ACTIONS(6314),
    [anon_sym_row_major] = ACTIONS(6314),
    [anon_sym_column_major] = ACTIONS(6314),
    [anon_sym_globallycoherent] = ACTIONS(6314),
    [anon_sym_centroid] = ACTIONS(6314),
    [anon_sym_noperspective] = ACTIONS(6314),
    [anon_sym_nointerpolation] = ACTIONS(6314),
    [anon_sym_sample] = ACTIONS(6314),
    [anon_sym_linear] = ACTIONS(6314),
    [anon_sym_snorm] = ACTIONS(6314),
    [anon_sym_unorm] = ACTIONS(6314),
    [anon_sym_point] = ACTIONS(6314),
    [anon_sym_line] = ACTIONS(6314),
    [anon_sym_triangleadj] = ACTIONS(6314),
    [anon_sym_lineadj] = ACTIONS(6314),
    [anon_sym_triangle] = ACTIONS(6314),
    [anon_sym_interface] = ACTIONS(6314),
    [anon_sym_extension] = ACTIONS(6314),
    [anon_sym___init] = ACTIONS(6314),
    [anon_sym___subscript] = ACTIONS(6314),
    [anon_sym_property] = ACTIONS(6314),
    [anon_sym_associatedtype] = ACTIONS(6314),
  },
  [2019] = {
    [sym_identifier] = ACTIONS(6318),
    [aux_sym_preproc_def_token1] = ACTIONS(6318),
    [aux_sym_preproc_if_token1] = ACTIONS(6318),
    [aux_sym_preproc_if_token2] = ACTIONS(6318),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6318),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6318),
    [sym_preproc_directive] = ACTIONS(6318),
    [anon_sym_LPAREN2] = ACTIONS(6320),
    [anon_sym_TILDE] = ACTIONS(6320),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_AMP_AMP] = ACTIONS(6320),
    [anon_sym_AMP] = ACTIONS(6318),
    [anon_sym_SEMI] = ACTIONS(6320),
    [anon_sym___extension__] = ACTIONS(6318),
    [anon_sym_typedef] = ACTIONS(6318),
    [anon_sym_in] = ACTIONS(6318),
    [anon_sym_out] = ACTIONS(6318),
    [anon_sym_inout] = ACTIONS(6318),
    [anon_sym_virtual] = ACTIONS(6318),
    [anon_sym_extern] = ACTIONS(6318),
    [anon_sym___attribute__] = ACTIONS(6318),
    [anon_sym___attribute] = ACTIONS(6318),
    [anon_sym_using] = ACTIONS(6318),
    [anon_sym_COLON_COLON] = ACTIONS(6320),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6320),
    [anon_sym___declspec] = ACTIONS(6318),
    [anon_sym___based] = ACTIONS(6318),
    [anon_sym_signed] = ACTIONS(6318),
    [anon_sym_unsigned] = ACTIONS(6318),
    [anon_sym_long] = ACTIONS(6318),
    [anon_sym_short] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6318),
    [anon_sym_static] = ACTIONS(6318),
    [anon_sym_register] = ACTIONS(6318),
    [anon_sym_inline] = ACTIONS(6318),
    [anon_sym___inline] = ACTIONS(6318),
    [anon_sym___inline__] = ACTIONS(6318),
    [anon_sym___forceinline] = ACTIONS(6318),
    [anon_sym_thread_local] = ACTIONS(6318),
    [anon_sym___thread] = ACTIONS(6318),
    [anon_sym_const] = ACTIONS(6318),
    [anon_sym_constexpr] = ACTIONS(6318),
    [anon_sym_volatile] = ACTIONS(6318),
    [anon_sym_restrict] = ACTIONS(6318),
    [anon_sym___restrict__] = ACTIONS(6318),
    [anon_sym__Atomic] = ACTIONS(6318),
    [anon_sym__Noreturn] = ACTIONS(6318),
    [anon_sym_noreturn] = ACTIONS(6318),
    [anon_sym__Nonnull] = ACTIONS(6318),
    [anon_sym_mutable] = ACTIONS(6318),
    [anon_sym_constinit] = ACTIONS(6318),
    [anon_sym_consteval] = ACTIONS(6318),
    [anon_sym_alignas] = ACTIONS(6318),
    [anon_sym__Alignas] = ACTIONS(6318),
    [sym_primitive_type] = ACTIONS(6318),
    [anon_sym_enum] = ACTIONS(6318),
    [anon_sym_class] = ACTIONS(6318),
    [anon_sym_struct] = ACTIONS(6318),
    [anon_sym_union] = ACTIONS(6318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6318),
    [anon_sym_let] = ACTIONS(6318),
    [anon_sym_This] = ACTIONS(6318),
    [anon_sym_decltype] = ACTIONS(6318),
    [anon_sym_explicit] = ACTIONS(6318),
    [anon_sym_typename] = ACTIONS(6318),
    [anon_sym_private] = ACTIONS(6318),
    [anon_sym_template] = ACTIONS(6318),
    [anon_sym_operator] = ACTIONS(6318),
    [anon_sym_friend] = ACTIONS(6318),
    [anon_sym_public] = ACTIONS(6318),
    [anon_sym_protected] = ACTIONS(6318),
    [anon_sym_static_assert] = ACTIONS(6318),
    [anon_sym_precise] = ACTIONS(6318),
    [anon_sym_shared] = ACTIONS(6318),
    [anon_sym_groupshared] = ACTIONS(6318),
    [anon_sym_uniform] = ACTIONS(6318),
    [anon_sym_row_major] = ACTIONS(6318),
    [anon_sym_column_major] = ACTIONS(6318),
    [anon_sym_globallycoherent] = ACTIONS(6318),
    [anon_sym_centroid] = ACTIONS(6318),
    [anon_sym_noperspective] = ACTIONS(6318),
    [anon_sym_nointerpolation] = ACTIONS(6318),
    [anon_sym_sample] = ACTIONS(6318),
    [anon_sym_linear] = ACTIONS(6318),
    [anon_sym_snorm] = ACTIONS(6318),
    [anon_sym_unorm] = ACTIONS(6318),
    [anon_sym_point] = ACTIONS(6318),
    [anon_sym_line] = ACTIONS(6318),
    [anon_sym_triangleadj] = ACTIONS(6318),
    [anon_sym_lineadj] = ACTIONS(6318),
    [anon_sym_triangle] = ACTIONS(6318),
    [anon_sym_interface] = ACTIONS(6318),
    [anon_sym_extension] = ACTIONS(6318),
    [anon_sym___init] = ACTIONS(6318),
    [anon_sym___subscript] = ACTIONS(6318),
    [anon_sym_property] = ACTIONS(6318),
    [anon_sym_associatedtype] = ACTIONS(6318),
  },
  [2020] = {
    [sym_identifier] = ACTIONS(6344),
    [aux_sym_preproc_def_token1] = ACTIONS(6344),
    [aux_sym_preproc_if_token1] = ACTIONS(6344),
    [aux_sym_preproc_if_token2] = ACTIONS(6344),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6344),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6344),
    [sym_preproc_directive] = ACTIONS(6344),
    [anon_sym_LPAREN2] = ACTIONS(6346),
    [anon_sym_TILDE] = ACTIONS(6346),
    [anon_sym_STAR] = ACTIONS(6346),
    [anon_sym_AMP_AMP] = ACTIONS(6346),
    [anon_sym_AMP] = ACTIONS(6344),
    [anon_sym_SEMI] = ACTIONS(6346),
    [anon_sym___extension__] = ACTIONS(6344),
    [anon_sym_typedef] = ACTIONS(6344),
    [anon_sym_in] = ACTIONS(6344),
    [anon_sym_out] = ACTIONS(6344),
    [anon_sym_inout] = ACTIONS(6344),
    [anon_sym_virtual] = ACTIONS(6344),
    [anon_sym_extern] = ACTIONS(6344),
    [anon_sym___attribute__] = ACTIONS(6344),
    [anon_sym___attribute] = ACTIONS(6344),
    [anon_sym_using] = ACTIONS(6344),
    [anon_sym_COLON_COLON] = ACTIONS(6346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6346),
    [anon_sym___declspec] = ACTIONS(6344),
    [anon_sym___based] = ACTIONS(6344),
    [anon_sym_signed] = ACTIONS(6344),
    [anon_sym_unsigned] = ACTIONS(6344),
    [anon_sym_long] = ACTIONS(6344),
    [anon_sym_short] = ACTIONS(6344),
    [anon_sym_LBRACK] = ACTIONS(6344),
    [anon_sym_static] = ACTIONS(6344),
    [anon_sym_register] = ACTIONS(6344),
    [anon_sym_inline] = ACTIONS(6344),
    [anon_sym___inline] = ACTIONS(6344),
    [anon_sym___inline__] = ACTIONS(6344),
    [anon_sym___forceinline] = ACTIONS(6344),
    [anon_sym_thread_local] = ACTIONS(6344),
    [anon_sym___thread] = ACTIONS(6344),
    [anon_sym_const] = ACTIONS(6344),
    [anon_sym_constexpr] = ACTIONS(6344),
    [anon_sym_volatile] = ACTIONS(6344),
    [anon_sym_restrict] = ACTIONS(6344),
    [anon_sym___restrict__] = ACTIONS(6344),
    [anon_sym__Atomic] = ACTIONS(6344),
    [anon_sym__Noreturn] = ACTIONS(6344),
    [anon_sym_noreturn] = ACTIONS(6344),
    [anon_sym__Nonnull] = ACTIONS(6344),
    [anon_sym_mutable] = ACTIONS(6344),
    [anon_sym_constinit] = ACTIONS(6344),
    [anon_sym_consteval] = ACTIONS(6344),
    [anon_sym_alignas] = ACTIONS(6344),
    [anon_sym__Alignas] = ACTIONS(6344),
    [sym_primitive_type] = ACTIONS(6344),
    [anon_sym_enum] = ACTIONS(6344),
    [anon_sym_class] = ACTIONS(6344),
    [anon_sym_struct] = ACTIONS(6344),
    [anon_sym_union] = ACTIONS(6344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6344),
    [anon_sym_let] = ACTIONS(6344),
    [anon_sym_This] = ACTIONS(6344),
    [anon_sym_decltype] = ACTIONS(6344),
    [anon_sym_explicit] = ACTIONS(6344),
    [anon_sym_typename] = ACTIONS(6344),
    [anon_sym_private] = ACTIONS(6344),
    [anon_sym_template] = ACTIONS(6344),
    [anon_sym_operator] = ACTIONS(6344),
    [anon_sym_friend] = ACTIONS(6344),
    [anon_sym_public] = ACTIONS(6344),
    [anon_sym_protected] = ACTIONS(6344),
    [anon_sym_static_assert] = ACTIONS(6344),
    [anon_sym_precise] = ACTIONS(6344),
    [anon_sym_shared] = ACTIONS(6344),
    [anon_sym_groupshared] = ACTIONS(6344),
    [anon_sym_uniform] = ACTIONS(6344),
    [anon_sym_row_major] = ACTIONS(6344),
    [anon_sym_column_major] = ACTIONS(6344),
    [anon_sym_globallycoherent] = ACTIONS(6344),
    [anon_sym_centroid] = ACTIONS(6344),
    [anon_sym_noperspective] = ACTIONS(6344),
    [anon_sym_nointerpolation] = ACTIONS(6344),
    [anon_sym_sample] = ACTIONS(6344),
    [anon_sym_linear] = ACTIONS(6344),
    [anon_sym_snorm] = ACTIONS(6344),
    [anon_sym_unorm] = ACTIONS(6344),
    [anon_sym_point] = ACTIONS(6344),
    [anon_sym_line] = ACTIONS(6344),
    [anon_sym_triangleadj] = ACTIONS(6344),
    [anon_sym_lineadj] = ACTIONS(6344),
    [anon_sym_triangle] = ACTIONS(6344),
    [anon_sym_interface] = ACTIONS(6344),
    [anon_sym_extension] = ACTIONS(6344),
    [anon_sym___init] = ACTIONS(6344),
    [anon_sym___subscript] = ACTIONS(6344),
    [anon_sym_property] = ACTIONS(6344),
    [anon_sym_associatedtype] = ACTIONS(6344),
  },
  [2021] = {
    [sym_identifier] = ACTIONS(6364),
    [aux_sym_preproc_def_token1] = ACTIONS(6364),
    [aux_sym_preproc_if_token1] = ACTIONS(6364),
    [aux_sym_preproc_if_token2] = ACTIONS(6364),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6364),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6364),
    [sym_preproc_directive] = ACTIONS(6364),
    [anon_sym_LPAREN2] = ACTIONS(6366),
    [anon_sym_TILDE] = ACTIONS(6366),
    [anon_sym_STAR] = ACTIONS(6366),
    [anon_sym_AMP_AMP] = ACTIONS(6366),
    [anon_sym_AMP] = ACTIONS(6364),
    [anon_sym_SEMI] = ACTIONS(6366),
    [anon_sym___extension__] = ACTIONS(6364),
    [anon_sym_typedef] = ACTIONS(6364),
    [anon_sym_in] = ACTIONS(6364),
    [anon_sym_out] = ACTIONS(6364),
    [anon_sym_inout] = ACTIONS(6364),
    [anon_sym_virtual] = ACTIONS(6364),
    [anon_sym_extern] = ACTIONS(6364),
    [anon_sym___attribute__] = ACTIONS(6364),
    [anon_sym___attribute] = ACTIONS(6364),
    [anon_sym_using] = ACTIONS(6364),
    [anon_sym_COLON_COLON] = ACTIONS(6366),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6366),
    [anon_sym___declspec] = ACTIONS(6364),
    [anon_sym___based] = ACTIONS(6364),
    [anon_sym_signed] = ACTIONS(6364),
    [anon_sym_unsigned] = ACTIONS(6364),
    [anon_sym_long] = ACTIONS(6364),
    [anon_sym_short] = ACTIONS(6364),
    [anon_sym_LBRACK] = ACTIONS(6364),
    [anon_sym_static] = ACTIONS(6364),
    [anon_sym_register] = ACTIONS(6364),
    [anon_sym_inline] = ACTIONS(6364),
    [anon_sym___inline] = ACTIONS(6364),
    [anon_sym___inline__] = ACTIONS(6364),
    [anon_sym___forceinline] = ACTIONS(6364),
    [anon_sym_thread_local] = ACTIONS(6364),
    [anon_sym___thread] = ACTIONS(6364),
    [anon_sym_const] = ACTIONS(6364),
    [anon_sym_constexpr] = ACTIONS(6364),
    [anon_sym_volatile] = ACTIONS(6364),
    [anon_sym_restrict] = ACTIONS(6364),
    [anon_sym___restrict__] = ACTIONS(6364),
    [anon_sym__Atomic] = ACTIONS(6364),
    [anon_sym__Noreturn] = ACTIONS(6364),
    [anon_sym_noreturn] = ACTIONS(6364),
    [anon_sym__Nonnull] = ACTIONS(6364),
    [anon_sym_mutable] = ACTIONS(6364),
    [anon_sym_constinit] = ACTIONS(6364),
    [anon_sym_consteval] = ACTIONS(6364),
    [anon_sym_alignas] = ACTIONS(6364),
    [anon_sym__Alignas] = ACTIONS(6364),
    [sym_primitive_type] = ACTIONS(6364),
    [anon_sym_enum] = ACTIONS(6364),
    [anon_sym_class] = ACTIONS(6364),
    [anon_sym_struct] = ACTIONS(6364),
    [anon_sym_union] = ACTIONS(6364),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6364),
    [anon_sym_let] = ACTIONS(6364),
    [anon_sym_This] = ACTIONS(6364),
    [anon_sym_decltype] = ACTIONS(6364),
    [anon_sym_explicit] = ACTIONS(6364),
    [anon_sym_typename] = ACTIONS(6364),
    [anon_sym_private] = ACTIONS(6364),
    [anon_sym_template] = ACTIONS(6364),
    [anon_sym_operator] = ACTIONS(6364),
    [anon_sym_friend] = ACTIONS(6364),
    [anon_sym_public] = ACTIONS(6364),
    [anon_sym_protected] = ACTIONS(6364),
    [anon_sym_static_assert] = ACTIONS(6364),
    [anon_sym_precise] = ACTIONS(6364),
    [anon_sym_shared] = ACTIONS(6364),
    [anon_sym_groupshared] = ACTIONS(6364),
    [anon_sym_uniform] = ACTIONS(6364),
    [anon_sym_row_major] = ACTIONS(6364),
    [anon_sym_column_major] = ACTIONS(6364),
    [anon_sym_globallycoherent] = ACTIONS(6364),
    [anon_sym_centroid] = ACTIONS(6364),
    [anon_sym_noperspective] = ACTIONS(6364),
    [anon_sym_nointerpolation] = ACTIONS(6364),
    [anon_sym_sample] = ACTIONS(6364),
    [anon_sym_linear] = ACTIONS(6364),
    [anon_sym_snorm] = ACTIONS(6364),
    [anon_sym_unorm] = ACTIONS(6364),
    [anon_sym_point] = ACTIONS(6364),
    [anon_sym_line] = ACTIONS(6364),
    [anon_sym_triangleadj] = ACTIONS(6364),
    [anon_sym_lineadj] = ACTIONS(6364),
    [anon_sym_triangle] = ACTIONS(6364),
    [anon_sym_interface] = ACTIONS(6364),
    [anon_sym_extension] = ACTIONS(6364),
    [anon_sym___init] = ACTIONS(6364),
    [anon_sym___subscript] = ACTIONS(6364),
    [anon_sym_property] = ACTIONS(6364),
    [anon_sym_associatedtype] = ACTIONS(6364),
  },
  [2022] = {
    [sym_identifier] = ACTIONS(6140),
    [aux_sym_preproc_def_token1] = ACTIONS(6140),
    [aux_sym_preproc_if_token1] = ACTIONS(6140),
    [aux_sym_preproc_if_token2] = ACTIONS(6140),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6140),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6140),
    [sym_preproc_directive] = ACTIONS(6140),
    [anon_sym_LPAREN2] = ACTIONS(6142),
    [anon_sym_TILDE] = ACTIONS(6142),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_AMP_AMP] = ACTIONS(6142),
    [anon_sym_AMP] = ACTIONS(6140),
    [anon_sym_SEMI] = ACTIONS(6142),
    [anon_sym___extension__] = ACTIONS(6140),
    [anon_sym_typedef] = ACTIONS(6140),
    [anon_sym_in] = ACTIONS(6140),
    [anon_sym_out] = ACTIONS(6140),
    [anon_sym_inout] = ACTIONS(6140),
    [anon_sym_virtual] = ACTIONS(6140),
    [anon_sym_extern] = ACTIONS(6140),
    [anon_sym___attribute__] = ACTIONS(6140),
    [anon_sym___attribute] = ACTIONS(6140),
    [anon_sym_using] = ACTIONS(6140),
    [anon_sym_COLON_COLON] = ACTIONS(6142),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6142),
    [anon_sym___declspec] = ACTIONS(6140),
    [anon_sym___based] = ACTIONS(6140),
    [anon_sym_signed] = ACTIONS(6140),
    [anon_sym_unsigned] = ACTIONS(6140),
    [anon_sym_long] = ACTIONS(6140),
    [anon_sym_short] = ACTIONS(6140),
    [anon_sym_LBRACK] = ACTIONS(6140),
    [anon_sym_static] = ACTIONS(6140),
    [anon_sym_register] = ACTIONS(6140),
    [anon_sym_inline] = ACTIONS(6140),
    [anon_sym___inline] = ACTIONS(6140),
    [anon_sym___inline__] = ACTIONS(6140),
    [anon_sym___forceinline] = ACTIONS(6140),
    [anon_sym_thread_local] = ACTIONS(6140),
    [anon_sym___thread] = ACTIONS(6140),
    [anon_sym_const] = ACTIONS(6140),
    [anon_sym_constexpr] = ACTIONS(6140),
    [anon_sym_volatile] = ACTIONS(6140),
    [anon_sym_restrict] = ACTIONS(6140),
    [anon_sym___restrict__] = ACTIONS(6140),
    [anon_sym__Atomic] = ACTIONS(6140),
    [anon_sym__Noreturn] = ACTIONS(6140),
    [anon_sym_noreturn] = ACTIONS(6140),
    [anon_sym__Nonnull] = ACTIONS(6140),
    [anon_sym_mutable] = ACTIONS(6140),
    [anon_sym_constinit] = ACTIONS(6140),
    [anon_sym_consteval] = ACTIONS(6140),
    [anon_sym_alignas] = ACTIONS(6140),
    [anon_sym__Alignas] = ACTIONS(6140),
    [sym_primitive_type] = ACTIONS(6140),
    [anon_sym_enum] = ACTIONS(6140),
    [anon_sym_class] = ACTIONS(6140),
    [anon_sym_struct] = ACTIONS(6140),
    [anon_sym_union] = ACTIONS(6140),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6140),
    [anon_sym_let] = ACTIONS(6140),
    [anon_sym_This] = ACTIONS(6140),
    [anon_sym_decltype] = ACTIONS(6140),
    [anon_sym_explicit] = ACTIONS(6140),
    [anon_sym_typename] = ACTIONS(6140),
    [anon_sym_private] = ACTIONS(6140),
    [anon_sym_template] = ACTIONS(6140),
    [anon_sym_operator] = ACTIONS(6140),
    [anon_sym_friend] = ACTIONS(6140),
    [anon_sym_public] = ACTIONS(6140),
    [anon_sym_protected] = ACTIONS(6140),
    [anon_sym_static_assert] = ACTIONS(6140),
    [anon_sym_precise] = ACTIONS(6140),
    [anon_sym_shared] = ACTIONS(6140),
    [anon_sym_groupshared] = ACTIONS(6140),
    [anon_sym_uniform] = ACTIONS(6140),
    [anon_sym_row_major] = ACTIONS(6140),
    [anon_sym_column_major] = ACTIONS(6140),
    [anon_sym_globallycoherent] = ACTIONS(6140),
    [anon_sym_centroid] = ACTIONS(6140),
    [anon_sym_noperspective] = ACTIONS(6140),
    [anon_sym_nointerpolation] = ACTIONS(6140),
    [anon_sym_sample] = ACTIONS(6140),
    [anon_sym_linear] = ACTIONS(6140),
    [anon_sym_snorm] = ACTIONS(6140),
    [anon_sym_unorm] = ACTIONS(6140),
    [anon_sym_point] = ACTIONS(6140),
    [anon_sym_line] = ACTIONS(6140),
    [anon_sym_triangleadj] = ACTIONS(6140),
    [anon_sym_lineadj] = ACTIONS(6140),
    [anon_sym_triangle] = ACTIONS(6140),
    [anon_sym_interface] = ACTIONS(6140),
    [anon_sym_extension] = ACTIONS(6140),
    [anon_sym___init] = ACTIONS(6140),
    [anon_sym___subscript] = ACTIONS(6140),
    [anon_sym_property] = ACTIONS(6140),
    [anon_sym_associatedtype] = ACTIONS(6140),
  },
  [2023] = {
    [sym_identifier] = ACTIONS(6140),
    [aux_sym_preproc_def_token1] = ACTIONS(6140),
    [aux_sym_preproc_if_token1] = ACTIONS(6140),
    [aux_sym_preproc_if_token2] = ACTIONS(6140),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6140),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6140),
    [sym_preproc_directive] = ACTIONS(6140),
    [anon_sym_LPAREN2] = ACTIONS(6142),
    [anon_sym_TILDE] = ACTIONS(6142),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_AMP_AMP] = ACTIONS(6142),
    [anon_sym_AMP] = ACTIONS(6140),
    [anon_sym_SEMI] = ACTIONS(6142),
    [anon_sym___extension__] = ACTIONS(6140),
    [anon_sym_typedef] = ACTIONS(6140),
    [anon_sym_in] = ACTIONS(6140),
    [anon_sym_out] = ACTIONS(6140),
    [anon_sym_inout] = ACTIONS(6140),
    [anon_sym_virtual] = ACTIONS(6140),
    [anon_sym_extern] = ACTIONS(6140),
    [anon_sym___attribute__] = ACTIONS(6140),
    [anon_sym___attribute] = ACTIONS(6140),
    [anon_sym_using] = ACTIONS(6140),
    [anon_sym_COLON_COLON] = ACTIONS(6142),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6142),
    [anon_sym___declspec] = ACTIONS(6140),
    [anon_sym___based] = ACTIONS(6140),
    [anon_sym_signed] = ACTIONS(6140),
    [anon_sym_unsigned] = ACTIONS(6140),
    [anon_sym_long] = ACTIONS(6140),
    [anon_sym_short] = ACTIONS(6140),
    [anon_sym_LBRACK] = ACTIONS(6140),
    [anon_sym_static] = ACTIONS(6140),
    [anon_sym_register] = ACTIONS(6140),
    [anon_sym_inline] = ACTIONS(6140),
    [anon_sym___inline] = ACTIONS(6140),
    [anon_sym___inline__] = ACTIONS(6140),
    [anon_sym___forceinline] = ACTIONS(6140),
    [anon_sym_thread_local] = ACTIONS(6140),
    [anon_sym___thread] = ACTIONS(6140),
    [anon_sym_const] = ACTIONS(6140),
    [anon_sym_constexpr] = ACTIONS(6140),
    [anon_sym_volatile] = ACTIONS(6140),
    [anon_sym_restrict] = ACTIONS(6140),
    [anon_sym___restrict__] = ACTIONS(6140),
    [anon_sym__Atomic] = ACTIONS(6140),
    [anon_sym__Noreturn] = ACTIONS(6140),
    [anon_sym_noreturn] = ACTIONS(6140),
    [anon_sym__Nonnull] = ACTIONS(6140),
    [anon_sym_mutable] = ACTIONS(6140),
    [anon_sym_constinit] = ACTIONS(6140),
    [anon_sym_consteval] = ACTIONS(6140),
    [anon_sym_alignas] = ACTIONS(6140),
    [anon_sym__Alignas] = ACTIONS(6140),
    [sym_primitive_type] = ACTIONS(6140),
    [anon_sym_enum] = ACTIONS(6140),
    [anon_sym_class] = ACTIONS(6140),
    [anon_sym_struct] = ACTIONS(6140),
    [anon_sym_union] = ACTIONS(6140),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6140),
    [anon_sym_let] = ACTIONS(6140),
    [anon_sym_This] = ACTIONS(6140),
    [anon_sym_decltype] = ACTIONS(6140),
    [anon_sym_explicit] = ACTIONS(6140),
    [anon_sym_typename] = ACTIONS(6140),
    [anon_sym_private] = ACTIONS(6140),
    [anon_sym_template] = ACTIONS(6140),
    [anon_sym_operator] = ACTIONS(6140),
    [anon_sym_friend] = ACTIONS(6140),
    [anon_sym_public] = ACTIONS(6140),
    [anon_sym_protected] = ACTIONS(6140),
    [anon_sym_static_assert] = ACTIONS(6140),
    [anon_sym_precise] = ACTIONS(6140),
    [anon_sym_shared] = ACTIONS(6140),
    [anon_sym_groupshared] = ACTIONS(6140),
    [anon_sym_uniform] = ACTIONS(6140),
    [anon_sym_row_major] = ACTIONS(6140),
    [anon_sym_column_major] = ACTIONS(6140),
    [anon_sym_globallycoherent] = ACTIONS(6140),
    [anon_sym_centroid] = ACTIONS(6140),
    [anon_sym_noperspective] = ACTIONS(6140),
    [anon_sym_nointerpolation] = ACTIONS(6140),
    [anon_sym_sample] = ACTIONS(6140),
    [anon_sym_linear] = ACTIONS(6140),
    [anon_sym_snorm] = ACTIONS(6140),
    [anon_sym_unorm] = ACTIONS(6140),
    [anon_sym_point] = ACTIONS(6140),
    [anon_sym_line] = ACTIONS(6140),
    [anon_sym_triangleadj] = ACTIONS(6140),
    [anon_sym_lineadj] = ACTIONS(6140),
    [anon_sym_triangle] = ACTIONS(6140),
    [anon_sym_interface] = ACTIONS(6140),
    [anon_sym_extension] = ACTIONS(6140),
    [anon_sym___init] = ACTIONS(6140),
    [anon_sym___subscript] = ACTIONS(6140),
    [anon_sym_property] = ACTIONS(6140),
    [anon_sym_associatedtype] = ACTIONS(6140),
  },
  [2024] = {
    [sym_identifier] = ACTIONS(6148),
    [aux_sym_preproc_def_token1] = ACTIONS(6148),
    [aux_sym_preproc_if_token1] = ACTIONS(6148),
    [aux_sym_preproc_if_token2] = ACTIONS(6148),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6148),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6148),
    [sym_preproc_directive] = ACTIONS(6148),
    [anon_sym_LPAREN2] = ACTIONS(6150),
    [anon_sym_TILDE] = ACTIONS(6150),
    [anon_sym_STAR] = ACTIONS(6150),
    [anon_sym_AMP_AMP] = ACTIONS(6150),
    [anon_sym_AMP] = ACTIONS(6148),
    [anon_sym_SEMI] = ACTIONS(6150),
    [anon_sym___extension__] = ACTIONS(6148),
    [anon_sym_typedef] = ACTIONS(6148),
    [anon_sym_in] = ACTIONS(6148),
    [anon_sym_out] = ACTIONS(6148),
    [anon_sym_inout] = ACTIONS(6148),
    [anon_sym_virtual] = ACTIONS(6148),
    [anon_sym_extern] = ACTIONS(6148),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym___attribute] = ACTIONS(6148),
    [anon_sym_using] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6150),
    [anon_sym___declspec] = ACTIONS(6148),
    [anon_sym___based] = ACTIONS(6148),
    [anon_sym_signed] = ACTIONS(6148),
    [anon_sym_unsigned] = ACTIONS(6148),
    [anon_sym_long] = ACTIONS(6148),
    [anon_sym_short] = ACTIONS(6148),
    [anon_sym_LBRACK] = ACTIONS(6148),
    [anon_sym_static] = ACTIONS(6148),
    [anon_sym_register] = ACTIONS(6148),
    [anon_sym_inline] = ACTIONS(6148),
    [anon_sym___inline] = ACTIONS(6148),
    [anon_sym___inline__] = ACTIONS(6148),
    [anon_sym___forceinline] = ACTIONS(6148),
    [anon_sym_thread_local] = ACTIONS(6148),
    [anon_sym___thread] = ACTIONS(6148),
    [anon_sym_const] = ACTIONS(6148),
    [anon_sym_constexpr] = ACTIONS(6148),
    [anon_sym_volatile] = ACTIONS(6148),
    [anon_sym_restrict] = ACTIONS(6148),
    [anon_sym___restrict__] = ACTIONS(6148),
    [anon_sym__Atomic] = ACTIONS(6148),
    [anon_sym__Noreturn] = ACTIONS(6148),
    [anon_sym_noreturn] = ACTIONS(6148),
    [anon_sym__Nonnull] = ACTIONS(6148),
    [anon_sym_mutable] = ACTIONS(6148),
    [anon_sym_constinit] = ACTIONS(6148),
    [anon_sym_consteval] = ACTIONS(6148),
    [anon_sym_alignas] = ACTIONS(6148),
    [anon_sym__Alignas] = ACTIONS(6148),
    [sym_primitive_type] = ACTIONS(6148),
    [anon_sym_enum] = ACTIONS(6148),
    [anon_sym_class] = ACTIONS(6148),
    [anon_sym_struct] = ACTIONS(6148),
    [anon_sym_union] = ACTIONS(6148),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6148),
    [anon_sym_let] = ACTIONS(6148),
    [anon_sym_This] = ACTIONS(6148),
    [anon_sym_decltype] = ACTIONS(6148),
    [anon_sym_explicit] = ACTIONS(6148),
    [anon_sym_typename] = ACTIONS(6148),
    [anon_sym_private] = ACTIONS(6148),
    [anon_sym_template] = ACTIONS(6148),
    [anon_sym_operator] = ACTIONS(6148),
    [anon_sym_friend] = ACTIONS(6148),
    [anon_sym_public] = ACTIONS(6148),
    [anon_sym_protected] = ACTIONS(6148),
    [anon_sym_static_assert] = ACTIONS(6148),
    [anon_sym_precise] = ACTIONS(6148),
    [anon_sym_shared] = ACTIONS(6148),
    [anon_sym_groupshared] = ACTIONS(6148),
    [anon_sym_uniform] = ACTIONS(6148),
    [anon_sym_row_major] = ACTIONS(6148),
    [anon_sym_column_major] = ACTIONS(6148),
    [anon_sym_globallycoherent] = ACTIONS(6148),
    [anon_sym_centroid] = ACTIONS(6148),
    [anon_sym_noperspective] = ACTIONS(6148),
    [anon_sym_nointerpolation] = ACTIONS(6148),
    [anon_sym_sample] = ACTIONS(6148),
    [anon_sym_linear] = ACTIONS(6148),
    [anon_sym_snorm] = ACTIONS(6148),
    [anon_sym_unorm] = ACTIONS(6148),
    [anon_sym_point] = ACTIONS(6148),
    [anon_sym_line] = ACTIONS(6148),
    [anon_sym_triangleadj] = ACTIONS(6148),
    [anon_sym_lineadj] = ACTIONS(6148),
    [anon_sym_triangle] = ACTIONS(6148),
    [anon_sym_interface] = ACTIONS(6148),
    [anon_sym_extension] = ACTIONS(6148),
    [anon_sym___init] = ACTIONS(6148),
    [anon_sym___subscript] = ACTIONS(6148),
    [anon_sym_property] = ACTIONS(6148),
    [anon_sym_associatedtype] = ACTIONS(6148),
  },
  [2025] = {
    [sym_identifier] = ACTIONS(6152),
    [aux_sym_preproc_def_token1] = ACTIONS(6152),
    [aux_sym_preproc_if_token1] = ACTIONS(6152),
    [aux_sym_preproc_if_token2] = ACTIONS(6152),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6152),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6152),
    [sym_preproc_directive] = ACTIONS(6152),
    [anon_sym_LPAREN2] = ACTIONS(6154),
    [anon_sym_TILDE] = ACTIONS(6154),
    [anon_sym_STAR] = ACTIONS(6154),
    [anon_sym_AMP_AMP] = ACTIONS(6154),
    [anon_sym_AMP] = ACTIONS(6152),
    [anon_sym_SEMI] = ACTIONS(6154),
    [anon_sym___extension__] = ACTIONS(6152),
    [anon_sym_typedef] = ACTIONS(6152),
    [anon_sym_in] = ACTIONS(6152),
    [anon_sym_out] = ACTIONS(6152),
    [anon_sym_inout] = ACTIONS(6152),
    [anon_sym_virtual] = ACTIONS(6152),
    [anon_sym_extern] = ACTIONS(6152),
    [anon_sym___attribute__] = ACTIONS(6152),
    [anon_sym___attribute] = ACTIONS(6152),
    [anon_sym_using] = ACTIONS(6152),
    [anon_sym_COLON_COLON] = ACTIONS(6154),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6154),
    [anon_sym___declspec] = ACTIONS(6152),
    [anon_sym___based] = ACTIONS(6152),
    [anon_sym_signed] = ACTIONS(6152),
    [anon_sym_unsigned] = ACTIONS(6152),
    [anon_sym_long] = ACTIONS(6152),
    [anon_sym_short] = ACTIONS(6152),
    [anon_sym_LBRACK] = ACTIONS(6152),
    [anon_sym_static] = ACTIONS(6152),
    [anon_sym_register] = ACTIONS(6152),
    [anon_sym_inline] = ACTIONS(6152),
    [anon_sym___inline] = ACTIONS(6152),
    [anon_sym___inline__] = ACTIONS(6152),
    [anon_sym___forceinline] = ACTIONS(6152),
    [anon_sym_thread_local] = ACTIONS(6152),
    [anon_sym___thread] = ACTIONS(6152),
    [anon_sym_const] = ACTIONS(6152),
    [anon_sym_constexpr] = ACTIONS(6152),
    [anon_sym_volatile] = ACTIONS(6152),
    [anon_sym_restrict] = ACTIONS(6152),
    [anon_sym___restrict__] = ACTIONS(6152),
    [anon_sym__Atomic] = ACTIONS(6152),
    [anon_sym__Noreturn] = ACTIONS(6152),
    [anon_sym_noreturn] = ACTIONS(6152),
    [anon_sym__Nonnull] = ACTIONS(6152),
    [anon_sym_mutable] = ACTIONS(6152),
    [anon_sym_constinit] = ACTIONS(6152),
    [anon_sym_consteval] = ACTIONS(6152),
    [anon_sym_alignas] = ACTIONS(6152),
    [anon_sym__Alignas] = ACTIONS(6152),
    [sym_primitive_type] = ACTIONS(6152),
    [anon_sym_enum] = ACTIONS(6152),
    [anon_sym_class] = ACTIONS(6152),
    [anon_sym_struct] = ACTIONS(6152),
    [anon_sym_union] = ACTIONS(6152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6152),
    [anon_sym_let] = ACTIONS(6152),
    [anon_sym_This] = ACTIONS(6152),
    [anon_sym_decltype] = ACTIONS(6152),
    [anon_sym_explicit] = ACTIONS(6152),
    [anon_sym_typename] = ACTIONS(6152),
    [anon_sym_private] = ACTIONS(6152),
    [anon_sym_template] = ACTIONS(6152),
    [anon_sym_operator] = ACTIONS(6152),
    [anon_sym_friend] = ACTIONS(6152),
    [anon_sym_public] = ACTIONS(6152),
    [anon_sym_protected] = ACTIONS(6152),
    [anon_sym_static_assert] = ACTIONS(6152),
    [anon_sym_precise] = ACTIONS(6152),
    [anon_sym_shared] = ACTIONS(6152),
    [anon_sym_groupshared] = ACTIONS(6152),
    [anon_sym_uniform] = ACTIONS(6152),
    [anon_sym_row_major] = ACTIONS(6152),
    [anon_sym_column_major] = ACTIONS(6152),
    [anon_sym_globallycoherent] = ACTIONS(6152),
    [anon_sym_centroid] = ACTIONS(6152),
    [anon_sym_noperspective] = ACTIONS(6152),
    [anon_sym_nointerpolation] = ACTIONS(6152),
    [anon_sym_sample] = ACTIONS(6152),
    [anon_sym_linear] = ACTIONS(6152),
    [anon_sym_snorm] = ACTIONS(6152),
    [anon_sym_unorm] = ACTIONS(6152),
    [anon_sym_point] = ACTIONS(6152),
    [anon_sym_line] = ACTIONS(6152),
    [anon_sym_triangleadj] = ACTIONS(6152),
    [anon_sym_lineadj] = ACTIONS(6152),
    [anon_sym_triangle] = ACTIONS(6152),
    [anon_sym_interface] = ACTIONS(6152),
    [anon_sym_extension] = ACTIONS(6152),
    [anon_sym___init] = ACTIONS(6152),
    [anon_sym___subscript] = ACTIONS(6152),
    [anon_sym_property] = ACTIONS(6152),
    [anon_sym_associatedtype] = ACTIONS(6152),
  },
  [2026] = {
    [sym_expression] = STATE(6054),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2027] = {
    [sym_identifier] = ACTIONS(6176),
    [aux_sym_preproc_def_token1] = ACTIONS(6176),
    [aux_sym_preproc_if_token1] = ACTIONS(6176),
    [aux_sym_preproc_if_token2] = ACTIONS(6176),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6176),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6176),
    [sym_preproc_directive] = ACTIONS(6176),
    [anon_sym_LPAREN2] = ACTIONS(6178),
    [anon_sym_TILDE] = ACTIONS(6178),
    [anon_sym_STAR] = ACTIONS(6178),
    [anon_sym_AMP_AMP] = ACTIONS(6178),
    [anon_sym_AMP] = ACTIONS(6176),
    [anon_sym_SEMI] = ACTIONS(6178),
    [anon_sym___extension__] = ACTIONS(6176),
    [anon_sym_typedef] = ACTIONS(6176),
    [anon_sym_in] = ACTIONS(6176),
    [anon_sym_out] = ACTIONS(6176),
    [anon_sym_inout] = ACTIONS(6176),
    [anon_sym_virtual] = ACTIONS(6176),
    [anon_sym_extern] = ACTIONS(6176),
    [anon_sym___attribute__] = ACTIONS(6176),
    [anon_sym___attribute] = ACTIONS(6176),
    [anon_sym_using] = ACTIONS(6176),
    [anon_sym_COLON_COLON] = ACTIONS(6178),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6178),
    [anon_sym___declspec] = ACTIONS(6176),
    [anon_sym___based] = ACTIONS(6176),
    [anon_sym_signed] = ACTIONS(6176),
    [anon_sym_unsigned] = ACTIONS(6176),
    [anon_sym_long] = ACTIONS(6176),
    [anon_sym_short] = ACTIONS(6176),
    [anon_sym_LBRACK] = ACTIONS(6176),
    [anon_sym_static] = ACTIONS(6176),
    [anon_sym_register] = ACTIONS(6176),
    [anon_sym_inline] = ACTIONS(6176),
    [anon_sym___inline] = ACTIONS(6176),
    [anon_sym___inline__] = ACTIONS(6176),
    [anon_sym___forceinline] = ACTIONS(6176),
    [anon_sym_thread_local] = ACTIONS(6176),
    [anon_sym___thread] = ACTIONS(6176),
    [anon_sym_const] = ACTIONS(6176),
    [anon_sym_constexpr] = ACTIONS(6176),
    [anon_sym_volatile] = ACTIONS(6176),
    [anon_sym_restrict] = ACTIONS(6176),
    [anon_sym___restrict__] = ACTIONS(6176),
    [anon_sym__Atomic] = ACTIONS(6176),
    [anon_sym__Noreturn] = ACTIONS(6176),
    [anon_sym_noreturn] = ACTIONS(6176),
    [anon_sym__Nonnull] = ACTIONS(6176),
    [anon_sym_mutable] = ACTIONS(6176),
    [anon_sym_constinit] = ACTIONS(6176),
    [anon_sym_consteval] = ACTIONS(6176),
    [anon_sym_alignas] = ACTIONS(6176),
    [anon_sym__Alignas] = ACTIONS(6176),
    [sym_primitive_type] = ACTIONS(6176),
    [anon_sym_enum] = ACTIONS(6176),
    [anon_sym_class] = ACTIONS(6176),
    [anon_sym_struct] = ACTIONS(6176),
    [anon_sym_union] = ACTIONS(6176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6176),
    [anon_sym_let] = ACTIONS(6176),
    [anon_sym_This] = ACTIONS(6176),
    [anon_sym_decltype] = ACTIONS(6176),
    [anon_sym_explicit] = ACTIONS(6176),
    [anon_sym_typename] = ACTIONS(6176),
    [anon_sym_private] = ACTIONS(6176),
    [anon_sym_template] = ACTIONS(6176),
    [anon_sym_operator] = ACTIONS(6176),
    [anon_sym_friend] = ACTIONS(6176),
    [anon_sym_public] = ACTIONS(6176),
    [anon_sym_protected] = ACTIONS(6176),
    [anon_sym_static_assert] = ACTIONS(6176),
    [anon_sym_precise] = ACTIONS(6176),
    [anon_sym_shared] = ACTIONS(6176),
    [anon_sym_groupshared] = ACTIONS(6176),
    [anon_sym_uniform] = ACTIONS(6176),
    [anon_sym_row_major] = ACTIONS(6176),
    [anon_sym_column_major] = ACTIONS(6176),
    [anon_sym_globallycoherent] = ACTIONS(6176),
    [anon_sym_centroid] = ACTIONS(6176),
    [anon_sym_noperspective] = ACTIONS(6176),
    [anon_sym_nointerpolation] = ACTIONS(6176),
    [anon_sym_sample] = ACTIONS(6176),
    [anon_sym_linear] = ACTIONS(6176),
    [anon_sym_snorm] = ACTIONS(6176),
    [anon_sym_unorm] = ACTIONS(6176),
    [anon_sym_point] = ACTIONS(6176),
    [anon_sym_line] = ACTIONS(6176),
    [anon_sym_triangleadj] = ACTIONS(6176),
    [anon_sym_lineadj] = ACTIONS(6176),
    [anon_sym_triangle] = ACTIONS(6176),
    [anon_sym_interface] = ACTIONS(6176),
    [anon_sym_extension] = ACTIONS(6176),
    [anon_sym___init] = ACTIONS(6176),
    [anon_sym___subscript] = ACTIONS(6176),
    [anon_sym_property] = ACTIONS(6176),
    [anon_sym_associatedtype] = ACTIONS(6176),
  },
  [2028] = {
    [sym_identifier] = ACTIONS(6182),
    [aux_sym_preproc_def_token1] = ACTIONS(6182),
    [aux_sym_preproc_if_token1] = ACTIONS(6182),
    [aux_sym_preproc_if_token2] = ACTIONS(6182),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6182),
    [sym_preproc_directive] = ACTIONS(6182),
    [anon_sym_LPAREN2] = ACTIONS(6184),
    [anon_sym_TILDE] = ACTIONS(6184),
    [anon_sym_STAR] = ACTIONS(6184),
    [anon_sym_AMP_AMP] = ACTIONS(6184),
    [anon_sym_AMP] = ACTIONS(6182),
    [anon_sym_SEMI] = ACTIONS(6184),
    [anon_sym___extension__] = ACTIONS(6182),
    [anon_sym_typedef] = ACTIONS(6182),
    [anon_sym_in] = ACTIONS(6182),
    [anon_sym_out] = ACTIONS(6182),
    [anon_sym_inout] = ACTIONS(6182),
    [anon_sym_virtual] = ACTIONS(6182),
    [anon_sym_extern] = ACTIONS(6182),
    [anon_sym___attribute__] = ACTIONS(6182),
    [anon_sym___attribute] = ACTIONS(6182),
    [anon_sym_using] = ACTIONS(6182),
    [anon_sym_COLON_COLON] = ACTIONS(6184),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6184),
    [anon_sym___declspec] = ACTIONS(6182),
    [anon_sym___based] = ACTIONS(6182),
    [anon_sym_signed] = ACTIONS(6182),
    [anon_sym_unsigned] = ACTIONS(6182),
    [anon_sym_long] = ACTIONS(6182),
    [anon_sym_short] = ACTIONS(6182),
    [anon_sym_LBRACK] = ACTIONS(6182),
    [anon_sym_static] = ACTIONS(6182),
    [anon_sym_register] = ACTIONS(6182),
    [anon_sym_inline] = ACTIONS(6182),
    [anon_sym___inline] = ACTIONS(6182),
    [anon_sym___inline__] = ACTIONS(6182),
    [anon_sym___forceinline] = ACTIONS(6182),
    [anon_sym_thread_local] = ACTIONS(6182),
    [anon_sym___thread] = ACTIONS(6182),
    [anon_sym_const] = ACTIONS(6182),
    [anon_sym_constexpr] = ACTIONS(6182),
    [anon_sym_volatile] = ACTIONS(6182),
    [anon_sym_restrict] = ACTIONS(6182),
    [anon_sym___restrict__] = ACTIONS(6182),
    [anon_sym__Atomic] = ACTIONS(6182),
    [anon_sym__Noreturn] = ACTIONS(6182),
    [anon_sym_noreturn] = ACTIONS(6182),
    [anon_sym__Nonnull] = ACTIONS(6182),
    [anon_sym_mutable] = ACTIONS(6182),
    [anon_sym_constinit] = ACTIONS(6182),
    [anon_sym_consteval] = ACTIONS(6182),
    [anon_sym_alignas] = ACTIONS(6182),
    [anon_sym__Alignas] = ACTIONS(6182),
    [sym_primitive_type] = ACTIONS(6182),
    [anon_sym_enum] = ACTIONS(6182),
    [anon_sym_class] = ACTIONS(6182),
    [anon_sym_struct] = ACTIONS(6182),
    [anon_sym_union] = ACTIONS(6182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6182),
    [anon_sym_let] = ACTIONS(6182),
    [anon_sym_This] = ACTIONS(6182),
    [anon_sym_decltype] = ACTIONS(6182),
    [anon_sym_explicit] = ACTIONS(6182),
    [anon_sym_typename] = ACTIONS(6182),
    [anon_sym_private] = ACTIONS(6182),
    [anon_sym_template] = ACTIONS(6182),
    [anon_sym_operator] = ACTIONS(6182),
    [anon_sym_friend] = ACTIONS(6182),
    [anon_sym_public] = ACTIONS(6182),
    [anon_sym_protected] = ACTIONS(6182),
    [anon_sym_static_assert] = ACTIONS(6182),
    [anon_sym_precise] = ACTIONS(6182),
    [anon_sym_shared] = ACTIONS(6182),
    [anon_sym_groupshared] = ACTIONS(6182),
    [anon_sym_uniform] = ACTIONS(6182),
    [anon_sym_row_major] = ACTIONS(6182),
    [anon_sym_column_major] = ACTIONS(6182),
    [anon_sym_globallycoherent] = ACTIONS(6182),
    [anon_sym_centroid] = ACTIONS(6182),
    [anon_sym_noperspective] = ACTIONS(6182),
    [anon_sym_nointerpolation] = ACTIONS(6182),
    [anon_sym_sample] = ACTIONS(6182),
    [anon_sym_linear] = ACTIONS(6182),
    [anon_sym_snorm] = ACTIONS(6182),
    [anon_sym_unorm] = ACTIONS(6182),
    [anon_sym_point] = ACTIONS(6182),
    [anon_sym_line] = ACTIONS(6182),
    [anon_sym_triangleadj] = ACTIONS(6182),
    [anon_sym_lineadj] = ACTIONS(6182),
    [anon_sym_triangle] = ACTIONS(6182),
    [anon_sym_interface] = ACTIONS(6182),
    [anon_sym_extension] = ACTIONS(6182),
    [anon_sym___init] = ACTIONS(6182),
    [anon_sym___subscript] = ACTIONS(6182),
    [anon_sym_property] = ACTIONS(6182),
    [anon_sym_associatedtype] = ACTIONS(6182),
  },
  [2029] = {
    [sym_identifier] = ACTIONS(6186),
    [aux_sym_preproc_def_token1] = ACTIONS(6186),
    [aux_sym_preproc_if_token1] = ACTIONS(6186),
    [aux_sym_preproc_if_token2] = ACTIONS(6186),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6186),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6186),
    [sym_preproc_directive] = ACTIONS(6186),
    [anon_sym_LPAREN2] = ACTIONS(6188),
    [anon_sym_TILDE] = ACTIONS(6188),
    [anon_sym_STAR] = ACTIONS(6188),
    [anon_sym_AMP_AMP] = ACTIONS(6188),
    [anon_sym_AMP] = ACTIONS(6186),
    [anon_sym_SEMI] = ACTIONS(6188),
    [anon_sym___extension__] = ACTIONS(6186),
    [anon_sym_typedef] = ACTIONS(6186),
    [anon_sym_in] = ACTIONS(6186),
    [anon_sym_out] = ACTIONS(6186),
    [anon_sym_inout] = ACTIONS(6186),
    [anon_sym_virtual] = ACTIONS(6186),
    [anon_sym_extern] = ACTIONS(6186),
    [anon_sym___attribute__] = ACTIONS(6186),
    [anon_sym___attribute] = ACTIONS(6186),
    [anon_sym_using] = ACTIONS(6186),
    [anon_sym_COLON_COLON] = ACTIONS(6188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6188),
    [anon_sym___declspec] = ACTIONS(6186),
    [anon_sym___based] = ACTIONS(6186),
    [anon_sym_signed] = ACTIONS(6186),
    [anon_sym_unsigned] = ACTIONS(6186),
    [anon_sym_long] = ACTIONS(6186),
    [anon_sym_short] = ACTIONS(6186),
    [anon_sym_LBRACK] = ACTIONS(6186),
    [anon_sym_static] = ACTIONS(6186),
    [anon_sym_register] = ACTIONS(6186),
    [anon_sym_inline] = ACTIONS(6186),
    [anon_sym___inline] = ACTIONS(6186),
    [anon_sym___inline__] = ACTIONS(6186),
    [anon_sym___forceinline] = ACTIONS(6186),
    [anon_sym_thread_local] = ACTIONS(6186),
    [anon_sym___thread] = ACTIONS(6186),
    [anon_sym_const] = ACTIONS(6186),
    [anon_sym_constexpr] = ACTIONS(6186),
    [anon_sym_volatile] = ACTIONS(6186),
    [anon_sym_restrict] = ACTIONS(6186),
    [anon_sym___restrict__] = ACTIONS(6186),
    [anon_sym__Atomic] = ACTIONS(6186),
    [anon_sym__Noreturn] = ACTIONS(6186),
    [anon_sym_noreturn] = ACTIONS(6186),
    [anon_sym__Nonnull] = ACTIONS(6186),
    [anon_sym_mutable] = ACTIONS(6186),
    [anon_sym_constinit] = ACTIONS(6186),
    [anon_sym_consteval] = ACTIONS(6186),
    [anon_sym_alignas] = ACTIONS(6186),
    [anon_sym__Alignas] = ACTIONS(6186),
    [sym_primitive_type] = ACTIONS(6186),
    [anon_sym_enum] = ACTIONS(6186),
    [anon_sym_class] = ACTIONS(6186),
    [anon_sym_struct] = ACTIONS(6186),
    [anon_sym_union] = ACTIONS(6186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6186),
    [anon_sym_let] = ACTIONS(6186),
    [anon_sym_This] = ACTIONS(6186),
    [anon_sym_decltype] = ACTIONS(6186),
    [anon_sym_explicit] = ACTIONS(6186),
    [anon_sym_typename] = ACTIONS(6186),
    [anon_sym_private] = ACTIONS(6186),
    [anon_sym_template] = ACTIONS(6186),
    [anon_sym_operator] = ACTIONS(6186),
    [anon_sym_friend] = ACTIONS(6186),
    [anon_sym_public] = ACTIONS(6186),
    [anon_sym_protected] = ACTIONS(6186),
    [anon_sym_static_assert] = ACTIONS(6186),
    [anon_sym_precise] = ACTIONS(6186),
    [anon_sym_shared] = ACTIONS(6186),
    [anon_sym_groupshared] = ACTIONS(6186),
    [anon_sym_uniform] = ACTIONS(6186),
    [anon_sym_row_major] = ACTIONS(6186),
    [anon_sym_column_major] = ACTIONS(6186),
    [anon_sym_globallycoherent] = ACTIONS(6186),
    [anon_sym_centroid] = ACTIONS(6186),
    [anon_sym_noperspective] = ACTIONS(6186),
    [anon_sym_nointerpolation] = ACTIONS(6186),
    [anon_sym_sample] = ACTIONS(6186),
    [anon_sym_linear] = ACTIONS(6186),
    [anon_sym_snorm] = ACTIONS(6186),
    [anon_sym_unorm] = ACTIONS(6186),
    [anon_sym_point] = ACTIONS(6186),
    [anon_sym_line] = ACTIONS(6186),
    [anon_sym_triangleadj] = ACTIONS(6186),
    [anon_sym_lineadj] = ACTIONS(6186),
    [anon_sym_triangle] = ACTIONS(6186),
    [anon_sym_interface] = ACTIONS(6186),
    [anon_sym_extension] = ACTIONS(6186),
    [anon_sym___init] = ACTIONS(6186),
    [anon_sym___subscript] = ACTIONS(6186),
    [anon_sym_property] = ACTIONS(6186),
    [anon_sym_associatedtype] = ACTIONS(6186),
  },
  [2030] = {
    [sym_identifier] = ACTIONS(6190),
    [aux_sym_preproc_def_token1] = ACTIONS(6190),
    [aux_sym_preproc_if_token1] = ACTIONS(6190),
    [aux_sym_preproc_if_token2] = ACTIONS(6190),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6190),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6190),
    [sym_preproc_directive] = ACTIONS(6190),
    [anon_sym_LPAREN2] = ACTIONS(6192),
    [anon_sym_TILDE] = ACTIONS(6192),
    [anon_sym_STAR] = ACTIONS(6192),
    [anon_sym_AMP_AMP] = ACTIONS(6192),
    [anon_sym_AMP] = ACTIONS(6190),
    [anon_sym_SEMI] = ACTIONS(6192),
    [anon_sym___extension__] = ACTIONS(6190),
    [anon_sym_typedef] = ACTIONS(6190),
    [anon_sym_in] = ACTIONS(6190),
    [anon_sym_out] = ACTIONS(6190),
    [anon_sym_inout] = ACTIONS(6190),
    [anon_sym_virtual] = ACTIONS(6190),
    [anon_sym_extern] = ACTIONS(6190),
    [anon_sym___attribute__] = ACTIONS(6190),
    [anon_sym___attribute] = ACTIONS(6190),
    [anon_sym_using] = ACTIONS(6190),
    [anon_sym_COLON_COLON] = ACTIONS(6192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6192),
    [anon_sym___declspec] = ACTIONS(6190),
    [anon_sym___based] = ACTIONS(6190),
    [anon_sym_signed] = ACTIONS(6190),
    [anon_sym_unsigned] = ACTIONS(6190),
    [anon_sym_long] = ACTIONS(6190),
    [anon_sym_short] = ACTIONS(6190),
    [anon_sym_LBRACK] = ACTIONS(6190),
    [anon_sym_static] = ACTIONS(6190),
    [anon_sym_register] = ACTIONS(6190),
    [anon_sym_inline] = ACTIONS(6190),
    [anon_sym___inline] = ACTIONS(6190),
    [anon_sym___inline__] = ACTIONS(6190),
    [anon_sym___forceinline] = ACTIONS(6190),
    [anon_sym_thread_local] = ACTIONS(6190),
    [anon_sym___thread] = ACTIONS(6190),
    [anon_sym_const] = ACTIONS(6190),
    [anon_sym_constexpr] = ACTIONS(6190),
    [anon_sym_volatile] = ACTIONS(6190),
    [anon_sym_restrict] = ACTIONS(6190),
    [anon_sym___restrict__] = ACTIONS(6190),
    [anon_sym__Atomic] = ACTIONS(6190),
    [anon_sym__Noreturn] = ACTIONS(6190),
    [anon_sym_noreturn] = ACTIONS(6190),
    [anon_sym__Nonnull] = ACTIONS(6190),
    [anon_sym_mutable] = ACTIONS(6190),
    [anon_sym_constinit] = ACTIONS(6190),
    [anon_sym_consteval] = ACTIONS(6190),
    [anon_sym_alignas] = ACTIONS(6190),
    [anon_sym__Alignas] = ACTIONS(6190),
    [sym_primitive_type] = ACTIONS(6190),
    [anon_sym_enum] = ACTIONS(6190),
    [anon_sym_class] = ACTIONS(6190),
    [anon_sym_struct] = ACTIONS(6190),
    [anon_sym_union] = ACTIONS(6190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6190),
    [anon_sym_let] = ACTIONS(6190),
    [anon_sym_This] = ACTIONS(6190),
    [anon_sym_decltype] = ACTIONS(6190),
    [anon_sym_explicit] = ACTIONS(6190),
    [anon_sym_typename] = ACTIONS(6190),
    [anon_sym_private] = ACTIONS(6190),
    [anon_sym_template] = ACTIONS(6190),
    [anon_sym_operator] = ACTIONS(6190),
    [anon_sym_friend] = ACTIONS(6190),
    [anon_sym_public] = ACTIONS(6190),
    [anon_sym_protected] = ACTIONS(6190),
    [anon_sym_static_assert] = ACTIONS(6190),
    [anon_sym_precise] = ACTIONS(6190),
    [anon_sym_shared] = ACTIONS(6190),
    [anon_sym_groupshared] = ACTIONS(6190),
    [anon_sym_uniform] = ACTIONS(6190),
    [anon_sym_row_major] = ACTIONS(6190),
    [anon_sym_column_major] = ACTIONS(6190),
    [anon_sym_globallycoherent] = ACTIONS(6190),
    [anon_sym_centroid] = ACTIONS(6190),
    [anon_sym_noperspective] = ACTIONS(6190),
    [anon_sym_nointerpolation] = ACTIONS(6190),
    [anon_sym_sample] = ACTIONS(6190),
    [anon_sym_linear] = ACTIONS(6190),
    [anon_sym_snorm] = ACTIONS(6190),
    [anon_sym_unorm] = ACTIONS(6190),
    [anon_sym_point] = ACTIONS(6190),
    [anon_sym_line] = ACTIONS(6190),
    [anon_sym_triangleadj] = ACTIONS(6190),
    [anon_sym_lineadj] = ACTIONS(6190),
    [anon_sym_triangle] = ACTIONS(6190),
    [anon_sym_interface] = ACTIONS(6190),
    [anon_sym_extension] = ACTIONS(6190),
    [anon_sym___init] = ACTIONS(6190),
    [anon_sym___subscript] = ACTIONS(6190),
    [anon_sym_property] = ACTIONS(6190),
    [anon_sym_associatedtype] = ACTIONS(6190),
  },
  [2031] = {
    [sym_identifier] = ACTIONS(6194),
    [aux_sym_preproc_def_token1] = ACTIONS(6194),
    [aux_sym_preproc_if_token1] = ACTIONS(6194),
    [aux_sym_preproc_if_token2] = ACTIONS(6194),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6194),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6194),
    [sym_preproc_directive] = ACTIONS(6194),
    [anon_sym_LPAREN2] = ACTIONS(6196),
    [anon_sym_TILDE] = ACTIONS(6196),
    [anon_sym_STAR] = ACTIONS(6196),
    [anon_sym_AMP_AMP] = ACTIONS(6196),
    [anon_sym_AMP] = ACTIONS(6194),
    [anon_sym_SEMI] = ACTIONS(6196),
    [anon_sym___extension__] = ACTIONS(6194),
    [anon_sym_typedef] = ACTIONS(6194),
    [anon_sym_in] = ACTIONS(6194),
    [anon_sym_out] = ACTIONS(6194),
    [anon_sym_inout] = ACTIONS(6194),
    [anon_sym_virtual] = ACTIONS(6194),
    [anon_sym_extern] = ACTIONS(6194),
    [anon_sym___attribute__] = ACTIONS(6194),
    [anon_sym___attribute] = ACTIONS(6194),
    [anon_sym_using] = ACTIONS(6194),
    [anon_sym_COLON_COLON] = ACTIONS(6196),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6196),
    [anon_sym___declspec] = ACTIONS(6194),
    [anon_sym___based] = ACTIONS(6194),
    [anon_sym_signed] = ACTIONS(6194),
    [anon_sym_unsigned] = ACTIONS(6194),
    [anon_sym_long] = ACTIONS(6194),
    [anon_sym_short] = ACTIONS(6194),
    [anon_sym_LBRACK] = ACTIONS(6194),
    [anon_sym_static] = ACTIONS(6194),
    [anon_sym_register] = ACTIONS(6194),
    [anon_sym_inline] = ACTIONS(6194),
    [anon_sym___inline] = ACTIONS(6194),
    [anon_sym___inline__] = ACTIONS(6194),
    [anon_sym___forceinline] = ACTIONS(6194),
    [anon_sym_thread_local] = ACTIONS(6194),
    [anon_sym___thread] = ACTIONS(6194),
    [anon_sym_const] = ACTIONS(6194),
    [anon_sym_constexpr] = ACTIONS(6194),
    [anon_sym_volatile] = ACTIONS(6194),
    [anon_sym_restrict] = ACTIONS(6194),
    [anon_sym___restrict__] = ACTIONS(6194),
    [anon_sym__Atomic] = ACTIONS(6194),
    [anon_sym__Noreturn] = ACTIONS(6194),
    [anon_sym_noreturn] = ACTIONS(6194),
    [anon_sym__Nonnull] = ACTIONS(6194),
    [anon_sym_mutable] = ACTIONS(6194),
    [anon_sym_constinit] = ACTIONS(6194),
    [anon_sym_consteval] = ACTIONS(6194),
    [anon_sym_alignas] = ACTIONS(6194),
    [anon_sym__Alignas] = ACTIONS(6194),
    [sym_primitive_type] = ACTIONS(6194),
    [anon_sym_enum] = ACTIONS(6194),
    [anon_sym_class] = ACTIONS(6194),
    [anon_sym_struct] = ACTIONS(6194),
    [anon_sym_union] = ACTIONS(6194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6194),
    [anon_sym_let] = ACTIONS(6194),
    [anon_sym_This] = ACTIONS(6194),
    [anon_sym_decltype] = ACTIONS(6194),
    [anon_sym_explicit] = ACTIONS(6194),
    [anon_sym_typename] = ACTIONS(6194),
    [anon_sym_private] = ACTIONS(6194),
    [anon_sym_template] = ACTIONS(6194),
    [anon_sym_operator] = ACTIONS(6194),
    [anon_sym_friend] = ACTIONS(6194),
    [anon_sym_public] = ACTIONS(6194),
    [anon_sym_protected] = ACTIONS(6194),
    [anon_sym_static_assert] = ACTIONS(6194),
    [anon_sym_precise] = ACTIONS(6194),
    [anon_sym_shared] = ACTIONS(6194),
    [anon_sym_groupshared] = ACTIONS(6194),
    [anon_sym_uniform] = ACTIONS(6194),
    [anon_sym_row_major] = ACTIONS(6194),
    [anon_sym_column_major] = ACTIONS(6194),
    [anon_sym_globallycoherent] = ACTIONS(6194),
    [anon_sym_centroid] = ACTIONS(6194),
    [anon_sym_noperspective] = ACTIONS(6194),
    [anon_sym_nointerpolation] = ACTIONS(6194),
    [anon_sym_sample] = ACTIONS(6194),
    [anon_sym_linear] = ACTIONS(6194),
    [anon_sym_snorm] = ACTIONS(6194),
    [anon_sym_unorm] = ACTIONS(6194),
    [anon_sym_point] = ACTIONS(6194),
    [anon_sym_line] = ACTIONS(6194),
    [anon_sym_triangleadj] = ACTIONS(6194),
    [anon_sym_lineadj] = ACTIONS(6194),
    [anon_sym_triangle] = ACTIONS(6194),
    [anon_sym_interface] = ACTIONS(6194),
    [anon_sym_extension] = ACTIONS(6194),
    [anon_sym___init] = ACTIONS(6194),
    [anon_sym___subscript] = ACTIONS(6194),
    [anon_sym_property] = ACTIONS(6194),
    [anon_sym_associatedtype] = ACTIONS(6194),
  },
  [2032] = {
    [sym_identifier] = ACTIONS(6210),
    [aux_sym_preproc_def_token1] = ACTIONS(6210),
    [aux_sym_preproc_if_token1] = ACTIONS(6210),
    [aux_sym_preproc_if_token2] = ACTIONS(6210),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6210),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6210),
    [sym_preproc_directive] = ACTIONS(6210),
    [anon_sym_LPAREN2] = ACTIONS(6212),
    [anon_sym_TILDE] = ACTIONS(6212),
    [anon_sym_STAR] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6210),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym___extension__] = ACTIONS(6210),
    [anon_sym_typedef] = ACTIONS(6210),
    [anon_sym_in] = ACTIONS(6210),
    [anon_sym_out] = ACTIONS(6210),
    [anon_sym_inout] = ACTIONS(6210),
    [anon_sym_virtual] = ACTIONS(6210),
    [anon_sym_extern] = ACTIONS(6210),
    [anon_sym___attribute__] = ACTIONS(6210),
    [anon_sym___attribute] = ACTIONS(6210),
    [anon_sym_using] = ACTIONS(6210),
    [anon_sym_COLON_COLON] = ACTIONS(6212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6212),
    [anon_sym___declspec] = ACTIONS(6210),
    [anon_sym___based] = ACTIONS(6210),
    [anon_sym_signed] = ACTIONS(6210),
    [anon_sym_unsigned] = ACTIONS(6210),
    [anon_sym_long] = ACTIONS(6210),
    [anon_sym_short] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_static] = ACTIONS(6210),
    [anon_sym_register] = ACTIONS(6210),
    [anon_sym_inline] = ACTIONS(6210),
    [anon_sym___inline] = ACTIONS(6210),
    [anon_sym___inline__] = ACTIONS(6210),
    [anon_sym___forceinline] = ACTIONS(6210),
    [anon_sym_thread_local] = ACTIONS(6210),
    [anon_sym___thread] = ACTIONS(6210),
    [anon_sym_const] = ACTIONS(6210),
    [anon_sym_constexpr] = ACTIONS(6210),
    [anon_sym_volatile] = ACTIONS(6210),
    [anon_sym_restrict] = ACTIONS(6210),
    [anon_sym___restrict__] = ACTIONS(6210),
    [anon_sym__Atomic] = ACTIONS(6210),
    [anon_sym__Noreturn] = ACTIONS(6210),
    [anon_sym_noreturn] = ACTIONS(6210),
    [anon_sym__Nonnull] = ACTIONS(6210),
    [anon_sym_mutable] = ACTIONS(6210),
    [anon_sym_constinit] = ACTIONS(6210),
    [anon_sym_consteval] = ACTIONS(6210),
    [anon_sym_alignas] = ACTIONS(6210),
    [anon_sym__Alignas] = ACTIONS(6210),
    [sym_primitive_type] = ACTIONS(6210),
    [anon_sym_enum] = ACTIONS(6210),
    [anon_sym_class] = ACTIONS(6210),
    [anon_sym_struct] = ACTIONS(6210),
    [anon_sym_union] = ACTIONS(6210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6210),
    [anon_sym_let] = ACTIONS(6210),
    [anon_sym_This] = ACTIONS(6210),
    [anon_sym_decltype] = ACTIONS(6210),
    [anon_sym_explicit] = ACTIONS(6210),
    [anon_sym_typename] = ACTIONS(6210),
    [anon_sym_private] = ACTIONS(6210),
    [anon_sym_template] = ACTIONS(6210),
    [anon_sym_operator] = ACTIONS(6210),
    [anon_sym_friend] = ACTIONS(6210),
    [anon_sym_public] = ACTIONS(6210),
    [anon_sym_protected] = ACTIONS(6210),
    [anon_sym_static_assert] = ACTIONS(6210),
    [anon_sym_precise] = ACTIONS(6210),
    [anon_sym_shared] = ACTIONS(6210),
    [anon_sym_groupshared] = ACTIONS(6210),
    [anon_sym_uniform] = ACTIONS(6210),
    [anon_sym_row_major] = ACTIONS(6210),
    [anon_sym_column_major] = ACTIONS(6210),
    [anon_sym_globallycoherent] = ACTIONS(6210),
    [anon_sym_centroid] = ACTIONS(6210),
    [anon_sym_noperspective] = ACTIONS(6210),
    [anon_sym_nointerpolation] = ACTIONS(6210),
    [anon_sym_sample] = ACTIONS(6210),
    [anon_sym_linear] = ACTIONS(6210),
    [anon_sym_snorm] = ACTIONS(6210),
    [anon_sym_unorm] = ACTIONS(6210),
    [anon_sym_point] = ACTIONS(6210),
    [anon_sym_line] = ACTIONS(6210),
    [anon_sym_triangleadj] = ACTIONS(6210),
    [anon_sym_lineadj] = ACTIONS(6210),
    [anon_sym_triangle] = ACTIONS(6210),
    [anon_sym_interface] = ACTIONS(6210),
    [anon_sym_extension] = ACTIONS(6210),
    [anon_sym___init] = ACTIONS(6210),
    [anon_sym___subscript] = ACTIONS(6210),
    [anon_sym_property] = ACTIONS(6210),
    [anon_sym_associatedtype] = ACTIONS(6210),
  },
  [2033] = {
    [sym_identifier] = ACTIONS(6218),
    [aux_sym_preproc_def_token1] = ACTIONS(6218),
    [aux_sym_preproc_if_token1] = ACTIONS(6218),
    [aux_sym_preproc_if_token2] = ACTIONS(6218),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6218),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6218),
    [sym_preproc_directive] = ACTIONS(6218),
    [anon_sym_LPAREN2] = ACTIONS(6220),
    [anon_sym_TILDE] = ACTIONS(6220),
    [anon_sym_STAR] = ACTIONS(6220),
    [anon_sym_AMP_AMP] = ACTIONS(6220),
    [anon_sym_AMP] = ACTIONS(6218),
    [anon_sym_SEMI] = ACTIONS(6220),
    [anon_sym___extension__] = ACTIONS(6218),
    [anon_sym_typedef] = ACTIONS(6218),
    [anon_sym_in] = ACTIONS(6218),
    [anon_sym_out] = ACTIONS(6218),
    [anon_sym_inout] = ACTIONS(6218),
    [anon_sym_virtual] = ACTIONS(6218),
    [anon_sym_extern] = ACTIONS(6218),
    [anon_sym___attribute__] = ACTIONS(6218),
    [anon_sym___attribute] = ACTIONS(6218),
    [anon_sym_using] = ACTIONS(6218),
    [anon_sym_COLON_COLON] = ACTIONS(6220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6220),
    [anon_sym___declspec] = ACTIONS(6218),
    [anon_sym___based] = ACTIONS(6218),
    [anon_sym_signed] = ACTIONS(6218),
    [anon_sym_unsigned] = ACTIONS(6218),
    [anon_sym_long] = ACTIONS(6218),
    [anon_sym_short] = ACTIONS(6218),
    [anon_sym_LBRACK] = ACTIONS(6218),
    [anon_sym_static] = ACTIONS(6218),
    [anon_sym_register] = ACTIONS(6218),
    [anon_sym_inline] = ACTIONS(6218),
    [anon_sym___inline] = ACTIONS(6218),
    [anon_sym___inline__] = ACTIONS(6218),
    [anon_sym___forceinline] = ACTIONS(6218),
    [anon_sym_thread_local] = ACTIONS(6218),
    [anon_sym___thread] = ACTIONS(6218),
    [anon_sym_const] = ACTIONS(6218),
    [anon_sym_constexpr] = ACTIONS(6218),
    [anon_sym_volatile] = ACTIONS(6218),
    [anon_sym_restrict] = ACTIONS(6218),
    [anon_sym___restrict__] = ACTIONS(6218),
    [anon_sym__Atomic] = ACTIONS(6218),
    [anon_sym__Noreturn] = ACTIONS(6218),
    [anon_sym_noreturn] = ACTIONS(6218),
    [anon_sym__Nonnull] = ACTIONS(6218),
    [anon_sym_mutable] = ACTIONS(6218),
    [anon_sym_constinit] = ACTIONS(6218),
    [anon_sym_consteval] = ACTIONS(6218),
    [anon_sym_alignas] = ACTIONS(6218),
    [anon_sym__Alignas] = ACTIONS(6218),
    [sym_primitive_type] = ACTIONS(6218),
    [anon_sym_enum] = ACTIONS(6218),
    [anon_sym_class] = ACTIONS(6218),
    [anon_sym_struct] = ACTIONS(6218),
    [anon_sym_union] = ACTIONS(6218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6218),
    [anon_sym_let] = ACTIONS(6218),
    [anon_sym_This] = ACTIONS(6218),
    [anon_sym_decltype] = ACTIONS(6218),
    [anon_sym_explicit] = ACTIONS(6218),
    [anon_sym_typename] = ACTIONS(6218),
    [anon_sym_private] = ACTIONS(6218),
    [anon_sym_template] = ACTIONS(6218),
    [anon_sym_operator] = ACTIONS(6218),
    [anon_sym_friend] = ACTIONS(6218),
    [anon_sym_public] = ACTIONS(6218),
    [anon_sym_protected] = ACTIONS(6218),
    [anon_sym_static_assert] = ACTIONS(6218),
    [anon_sym_precise] = ACTIONS(6218),
    [anon_sym_shared] = ACTIONS(6218),
    [anon_sym_groupshared] = ACTIONS(6218),
    [anon_sym_uniform] = ACTIONS(6218),
    [anon_sym_row_major] = ACTIONS(6218),
    [anon_sym_column_major] = ACTIONS(6218),
    [anon_sym_globallycoherent] = ACTIONS(6218),
    [anon_sym_centroid] = ACTIONS(6218),
    [anon_sym_noperspective] = ACTIONS(6218),
    [anon_sym_nointerpolation] = ACTIONS(6218),
    [anon_sym_sample] = ACTIONS(6218),
    [anon_sym_linear] = ACTIONS(6218),
    [anon_sym_snorm] = ACTIONS(6218),
    [anon_sym_unorm] = ACTIONS(6218),
    [anon_sym_point] = ACTIONS(6218),
    [anon_sym_line] = ACTIONS(6218),
    [anon_sym_triangleadj] = ACTIONS(6218),
    [anon_sym_lineadj] = ACTIONS(6218),
    [anon_sym_triangle] = ACTIONS(6218),
    [anon_sym_interface] = ACTIONS(6218),
    [anon_sym_extension] = ACTIONS(6218),
    [anon_sym___init] = ACTIONS(6218),
    [anon_sym___subscript] = ACTIONS(6218),
    [anon_sym_property] = ACTIONS(6218),
    [anon_sym_associatedtype] = ACTIONS(6218),
  },
  [2034] = {
    [sym_identifier] = ACTIONS(6218),
    [aux_sym_preproc_def_token1] = ACTIONS(6218),
    [aux_sym_preproc_if_token1] = ACTIONS(6218),
    [aux_sym_preproc_if_token2] = ACTIONS(6218),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6218),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6218),
    [sym_preproc_directive] = ACTIONS(6218),
    [anon_sym_LPAREN2] = ACTIONS(6220),
    [anon_sym_TILDE] = ACTIONS(6220),
    [anon_sym_STAR] = ACTIONS(6220),
    [anon_sym_AMP_AMP] = ACTIONS(6220),
    [anon_sym_AMP] = ACTIONS(6218),
    [anon_sym_SEMI] = ACTIONS(6220),
    [anon_sym___extension__] = ACTIONS(6218),
    [anon_sym_typedef] = ACTIONS(6218),
    [anon_sym_in] = ACTIONS(6218),
    [anon_sym_out] = ACTIONS(6218),
    [anon_sym_inout] = ACTIONS(6218),
    [anon_sym_virtual] = ACTIONS(6218),
    [anon_sym_extern] = ACTIONS(6218),
    [anon_sym___attribute__] = ACTIONS(6218),
    [anon_sym___attribute] = ACTIONS(6218),
    [anon_sym_using] = ACTIONS(6218),
    [anon_sym_COLON_COLON] = ACTIONS(6220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6220),
    [anon_sym___declspec] = ACTIONS(6218),
    [anon_sym___based] = ACTIONS(6218),
    [anon_sym_signed] = ACTIONS(6218),
    [anon_sym_unsigned] = ACTIONS(6218),
    [anon_sym_long] = ACTIONS(6218),
    [anon_sym_short] = ACTIONS(6218),
    [anon_sym_LBRACK] = ACTIONS(6218),
    [anon_sym_static] = ACTIONS(6218),
    [anon_sym_register] = ACTIONS(6218),
    [anon_sym_inline] = ACTIONS(6218),
    [anon_sym___inline] = ACTIONS(6218),
    [anon_sym___inline__] = ACTIONS(6218),
    [anon_sym___forceinline] = ACTIONS(6218),
    [anon_sym_thread_local] = ACTIONS(6218),
    [anon_sym___thread] = ACTIONS(6218),
    [anon_sym_const] = ACTIONS(6218),
    [anon_sym_constexpr] = ACTIONS(6218),
    [anon_sym_volatile] = ACTIONS(6218),
    [anon_sym_restrict] = ACTIONS(6218),
    [anon_sym___restrict__] = ACTIONS(6218),
    [anon_sym__Atomic] = ACTIONS(6218),
    [anon_sym__Noreturn] = ACTIONS(6218),
    [anon_sym_noreturn] = ACTIONS(6218),
    [anon_sym__Nonnull] = ACTIONS(6218),
    [anon_sym_mutable] = ACTIONS(6218),
    [anon_sym_constinit] = ACTIONS(6218),
    [anon_sym_consteval] = ACTIONS(6218),
    [anon_sym_alignas] = ACTIONS(6218),
    [anon_sym__Alignas] = ACTIONS(6218),
    [sym_primitive_type] = ACTIONS(6218),
    [anon_sym_enum] = ACTIONS(6218),
    [anon_sym_class] = ACTIONS(6218),
    [anon_sym_struct] = ACTIONS(6218),
    [anon_sym_union] = ACTIONS(6218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6218),
    [anon_sym_let] = ACTIONS(6218),
    [anon_sym_This] = ACTIONS(6218),
    [anon_sym_decltype] = ACTIONS(6218),
    [anon_sym_explicit] = ACTIONS(6218),
    [anon_sym_typename] = ACTIONS(6218),
    [anon_sym_private] = ACTIONS(6218),
    [anon_sym_template] = ACTIONS(6218),
    [anon_sym_operator] = ACTIONS(6218),
    [anon_sym_friend] = ACTIONS(6218),
    [anon_sym_public] = ACTIONS(6218),
    [anon_sym_protected] = ACTIONS(6218),
    [anon_sym_static_assert] = ACTIONS(6218),
    [anon_sym_precise] = ACTIONS(6218),
    [anon_sym_shared] = ACTIONS(6218),
    [anon_sym_groupshared] = ACTIONS(6218),
    [anon_sym_uniform] = ACTIONS(6218),
    [anon_sym_row_major] = ACTIONS(6218),
    [anon_sym_column_major] = ACTIONS(6218),
    [anon_sym_globallycoherent] = ACTIONS(6218),
    [anon_sym_centroid] = ACTIONS(6218),
    [anon_sym_noperspective] = ACTIONS(6218),
    [anon_sym_nointerpolation] = ACTIONS(6218),
    [anon_sym_sample] = ACTIONS(6218),
    [anon_sym_linear] = ACTIONS(6218),
    [anon_sym_snorm] = ACTIONS(6218),
    [anon_sym_unorm] = ACTIONS(6218),
    [anon_sym_point] = ACTIONS(6218),
    [anon_sym_line] = ACTIONS(6218),
    [anon_sym_triangleadj] = ACTIONS(6218),
    [anon_sym_lineadj] = ACTIONS(6218),
    [anon_sym_triangle] = ACTIONS(6218),
    [anon_sym_interface] = ACTIONS(6218),
    [anon_sym_extension] = ACTIONS(6218),
    [anon_sym___init] = ACTIONS(6218),
    [anon_sym___subscript] = ACTIONS(6218),
    [anon_sym_property] = ACTIONS(6218),
    [anon_sym_associatedtype] = ACTIONS(6218),
  },
  [2035] = {
    [sym_identifier] = ACTIONS(6222),
    [aux_sym_preproc_def_token1] = ACTIONS(6222),
    [aux_sym_preproc_if_token1] = ACTIONS(6222),
    [aux_sym_preproc_if_token2] = ACTIONS(6222),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6222),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6222),
    [sym_preproc_directive] = ACTIONS(6222),
    [anon_sym_LPAREN2] = ACTIONS(6224),
    [anon_sym_TILDE] = ACTIONS(6224),
    [anon_sym_STAR] = ACTIONS(6224),
    [anon_sym_AMP_AMP] = ACTIONS(6224),
    [anon_sym_AMP] = ACTIONS(6222),
    [anon_sym_SEMI] = ACTIONS(6224),
    [anon_sym___extension__] = ACTIONS(6222),
    [anon_sym_typedef] = ACTIONS(6222),
    [anon_sym_in] = ACTIONS(6222),
    [anon_sym_out] = ACTIONS(6222),
    [anon_sym_inout] = ACTIONS(6222),
    [anon_sym_virtual] = ACTIONS(6222),
    [anon_sym_extern] = ACTIONS(6222),
    [anon_sym___attribute__] = ACTIONS(6222),
    [anon_sym___attribute] = ACTIONS(6222),
    [anon_sym_using] = ACTIONS(6222),
    [anon_sym_COLON_COLON] = ACTIONS(6224),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6224),
    [anon_sym___declspec] = ACTIONS(6222),
    [anon_sym___based] = ACTIONS(6222),
    [anon_sym_signed] = ACTIONS(6222),
    [anon_sym_unsigned] = ACTIONS(6222),
    [anon_sym_long] = ACTIONS(6222),
    [anon_sym_short] = ACTIONS(6222),
    [anon_sym_LBRACK] = ACTIONS(6222),
    [anon_sym_static] = ACTIONS(6222),
    [anon_sym_register] = ACTIONS(6222),
    [anon_sym_inline] = ACTIONS(6222),
    [anon_sym___inline] = ACTIONS(6222),
    [anon_sym___inline__] = ACTIONS(6222),
    [anon_sym___forceinline] = ACTIONS(6222),
    [anon_sym_thread_local] = ACTIONS(6222),
    [anon_sym___thread] = ACTIONS(6222),
    [anon_sym_const] = ACTIONS(6222),
    [anon_sym_constexpr] = ACTIONS(6222),
    [anon_sym_volatile] = ACTIONS(6222),
    [anon_sym_restrict] = ACTIONS(6222),
    [anon_sym___restrict__] = ACTIONS(6222),
    [anon_sym__Atomic] = ACTIONS(6222),
    [anon_sym__Noreturn] = ACTIONS(6222),
    [anon_sym_noreturn] = ACTIONS(6222),
    [anon_sym__Nonnull] = ACTIONS(6222),
    [anon_sym_mutable] = ACTIONS(6222),
    [anon_sym_constinit] = ACTIONS(6222),
    [anon_sym_consteval] = ACTIONS(6222),
    [anon_sym_alignas] = ACTIONS(6222),
    [anon_sym__Alignas] = ACTIONS(6222),
    [sym_primitive_type] = ACTIONS(6222),
    [anon_sym_enum] = ACTIONS(6222),
    [anon_sym_class] = ACTIONS(6222),
    [anon_sym_struct] = ACTIONS(6222),
    [anon_sym_union] = ACTIONS(6222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6222),
    [anon_sym_let] = ACTIONS(6222),
    [anon_sym_This] = ACTIONS(6222),
    [anon_sym_decltype] = ACTIONS(6222),
    [anon_sym_explicit] = ACTIONS(6222),
    [anon_sym_typename] = ACTIONS(6222),
    [anon_sym_private] = ACTIONS(6222),
    [anon_sym_template] = ACTIONS(6222),
    [anon_sym_operator] = ACTIONS(6222),
    [anon_sym_friend] = ACTIONS(6222),
    [anon_sym_public] = ACTIONS(6222),
    [anon_sym_protected] = ACTIONS(6222),
    [anon_sym_static_assert] = ACTIONS(6222),
    [anon_sym_precise] = ACTIONS(6222),
    [anon_sym_shared] = ACTIONS(6222),
    [anon_sym_groupshared] = ACTIONS(6222),
    [anon_sym_uniform] = ACTIONS(6222),
    [anon_sym_row_major] = ACTIONS(6222),
    [anon_sym_column_major] = ACTIONS(6222),
    [anon_sym_globallycoherent] = ACTIONS(6222),
    [anon_sym_centroid] = ACTIONS(6222),
    [anon_sym_noperspective] = ACTIONS(6222),
    [anon_sym_nointerpolation] = ACTIONS(6222),
    [anon_sym_sample] = ACTIONS(6222),
    [anon_sym_linear] = ACTIONS(6222),
    [anon_sym_snorm] = ACTIONS(6222),
    [anon_sym_unorm] = ACTIONS(6222),
    [anon_sym_point] = ACTIONS(6222),
    [anon_sym_line] = ACTIONS(6222),
    [anon_sym_triangleadj] = ACTIONS(6222),
    [anon_sym_lineadj] = ACTIONS(6222),
    [anon_sym_triangle] = ACTIONS(6222),
    [anon_sym_interface] = ACTIONS(6222),
    [anon_sym_extension] = ACTIONS(6222),
    [anon_sym___init] = ACTIONS(6222),
    [anon_sym___subscript] = ACTIONS(6222),
    [anon_sym_property] = ACTIONS(6222),
    [anon_sym_associatedtype] = ACTIONS(6222),
  },
  [2036] = {
    [sym_identifier] = ACTIONS(6226),
    [aux_sym_preproc_def_token1] = ACTIONS(6226),
    [aux_sym_preproc_if_token1] = ACTIONS(6226),
    [aux_sym_preproc_if_token2] = ACTIONS(6226),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6226),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6226),
    [sym_preproc_directive] = ACTIONS(6226),
    [anon_sym_LPAREN2] = ACTIONS(6228),
    [anon_sym_TILDE] = ACTIONS(6228),
    [anon_sym_STAR] = ACTIONS(6228),
    [anon_sym_AMP_AMP] = ACTIONS(6228),
    [anon_sym_AMP] = ACTIONS(6226),
    [anon_sym_SEMI] = ACTIONS(6228),
    [anon_sym___extension__] = ACTIONS(6226),
    [anon_sym_typedef] = ACTIONS(6226),
    [anon_sym_in] = ACTIONS(6226),
    [anon_sym_out] = ACTIONS(6226),
    [anon_sym_inout] = ACTIONS(6226),
    [anon_sym_virtual] = ACTIONS(6226),
    [anon_sym_extern] = ACTIONS(6226),
    [anon_sym___attribute__] = ACTIONS(6226),
    [anon_sym___attribute] = ACTIONS(6226),
    [anon_sym_using] = ACTIONS(6226),
    [anon_sym_COLON_COLON] = ACTIONS(6228),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6228),
    [anon_sym___declspec] = ACTIONS(6226),
    [anon_sym___based] = ACTIONS(6226),
    [anon_sym_signed] = ACTIONS(6226),
    [anon_sym_unsigned] = ACTIONS(6226),
    [anon_sym_long] = ACTIONS(6226),
    [anon_sym_short] = ACTIONS(6226),
    [anon_sym_LBRACK] = ACTIONS(6226),
    [anon_sym_static] = ACTIONS(6226),
    [anon_sym_register] = ACTIONS(6226),
    [anon_sym_inline] = ACTIONS(6226),
    [anon_sym___inline] = ACTIONS(6226),
    [anon_sym___inline__] = ACTIONS(6226),
    [anon_sym___forceinline] = ACTIONS(6226),
    [anon_sym_thread_local] = ACTIONS(6226),
    [anon_sym___thread] = ACTIONS(6226),
    [anon_sym_const] = ACTIONS(6226),
    [anon_sym_constexpr] = ACTIONS(6226),
    [anon_sym_volatile] = ACTIONS(6226),
    [anon_sym_restrict] = ACTIONS(6226),
    [anon_sym___restrict__] = ACTIONS(6226),
    [anon_sym__Atomic] = ACTIONS(6226),
    [anon_sym__Noreturn] = ACTIONS(6226),
    [anon_sym_noreturn] = ACTIONS(6226),
    [anon_sym__Nonnull] = ACTIONS(6226),
    [anon_sym_mutable] = ACTIONS(6226),
    [anon_sym_constinit] = ACTIONS(6226),
    [anon_sym_consteval] = ACTIONS(6226),
    [anon_sym_alignas] = ACTIONS(6226),
    [anon_sym__Alignas] = ACTIONS(6226),
    [sym_primitive_type] = ACTIONS(6226),
    [anon_sym_enum] = ACTIONS(6226),
    [anon_sym_class] = ACTIONS(6226),
    [anon_sym_struct] = ACTIONS(6226),
    [anon_sym_union] = ACTIONS(6226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6226),
    [anon_sym_let] = ACTIONS(6226),
    [anon_sym_This] = ACTIONS(6226),
    [anon_sym_decltype] = ACTIONS(6226),
    [anon_sym_explicit] = ACTIONS(6226),
    [anon_sym_typename] = ACTIONS(6226),
    [anon_sym_private] = ACTIONS(6226),
    [anon_sym_template] = ACTIONS(6226),
    [anon_sym_operator] = ACTIONS(6226),
    [anon_sym_friend] = ACTIONS(6226),
    [anon_sym_public] = ACTIONS(6226),
    [anon_sym_protected] = ACTIONS(6226),
    [anon_sym_static_assert] = ACTIONS(6226),
    [anon_sym_precise] = ACTIONS(6226),
    [anon_sym_shared] = ACTIONS(6226),
    [anon_sym_groupshared] = ACTIONS(6226),
    [anon_sym_uniform] = ACTIONS(6226),
    [anon_sym_row_major] = ACTIONS(6226),
    [anon_sym_column_major] = ACTIONS(6226),
    [anon_sym_globallycoherent] = ACTIONS(6226),
    [anon_sym_centroid] = ACTIONS(6226),
    [anon_sym_noperspective] = ACTIONS(6226),
    [anon_sym_nointerpolation] = ACTIONS(6226),
    [anon_sym_sample] = ACTIONS(6226),
    [anon_sym_linear] = ACTIONS(6226),
    [anon_sym_snorm] = ACTIONS(6226),
    [anon_sym_unorm] = ACTIONS(6226),
    [anon_sym_point] = ACTIONS(6226),
    [anon_sym_line] = ACTIONS(6226),
    [anon_sym_triangleadj] = ACTIONS(6226),
    [anon_sym_lineadj] = ACTIONS(6226),
    [anon_sym_triangle] = ACTIONS(6226),
    [anon_sym_interface] = ACTIONS(6226),
    [anon_sym_extension] = ACTIONS(6226),
    [anon_sym___init] = ACTIONS(6226),
    [anon_sym___subscript] = ACTIONS(6226),
    [anon_sym_property] = ACTIONS(6226),
    [anon_sym_associatedtype] = ACTIONS(6226),
  },
  [2037] = {
    [sym_identifier] = ACTIONS(6230),
    [aux_sym_preproc_def_token1] = ACTIONS(6230),
    [aux_sym_preproc_if_token1] = ACTIONS(6230),
    [aux_sym_preproc_if_token2] = ACTIONS(6230),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6230),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6230),
    [sym_preproc_directive] = ACTIONS(6230),
    [anon_sym_LPAREN2] = ACTIONS(6232),
    [anon_sym_TILDE] = ACTIONS(6232),
    [anon_sym_STAR] = ACTIONS(6232),
    [anon_sym_AMP_AMP] = ACTIONS(6232),
    [anon_sym_AMP] = ACTIONS(6230),
    [anon_sym_SEMI] = ACTIONS(6232),
    [anon_sym___extension__] = ACTIONS(6230),
    [anon_sym_typedef] = ACTIONS(6230),
    [anon_sym_in] = ACTIONS(6230),
    [anon_sym_out] = ACTIONS(6230),
    [anon_sym_inout] = ACTIONS(6230),
    [anon_sym_virtual] = ACTIONS(6230),
    [anon_sym_extern] = ACTIONS(6230),
    [anon_sym___attribute__] = ACTIONS(6230),
    [anon_sym___attribute] = ACTIONS(6230),
    [anon_sym_using] = ACTIONS(6230),
    [anon_sym_COLON_COLON] = ACTIONS(6232),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6232),
    [anon_sym___declspec] = ACTIONS(6230),
    [anon_sym___based] = ACTIONS(6230),
    [anon_sym_signed] = ACTIONS(6230),
    [anon_sym_unsigned] = ACTIONS(6230),
    [anon_sym_long] = ACTIONS(6230),
    [anon_sym_short] = ACTIONS(6230),
    [anon_sym_LBRACK] = ACTIONS(6230),
    [anon_sym_static] = ACTIONS(6230),
    [anon_sym_register] = ACTIONS(6230),
    [anon_sym_inline] = ACTIONS(6230),
    [anon_sym___inline] = ACTIONS(6230),
    [anon_sym___inline__] = ACTIONS(6230),
    [anon_sym___forceinline] = ACTIONS(6230),
    [anon_sym_thread_local] = ACTIONS(6230),
    [anon_sym___thread] = ACTIONS(6230),
    [anon_sym_const] = ACTIONS(6230),
    [anon_sym_constexpr] = ACTIONS(6230),
    [anon_sym_volatile] = ACTIONS(6230),
    [anon_sym_restrict] = ACTIONS(6230),
    [anon_sym___restrict__] = ACTIONS(6230),
    [anon_sym__Atomic] = ACTIONS(6230),
    [anon_sym__Noreturn] = ACTIONS(6230),
    [anon_sym_noreturn] = ACTIONS(6230),
    [anon_sym__Nonnull] = ACTIONS(6230),
    [anon_sym_mutable] = ACTIONS(6230),
    [anon_sym_constinit] = ACTIONS(6230),
    [anon_sym_consteval] = ACTIONS(6230),
    [anon_sym_alignas] = ACTIONS(6230),
    [anon_sym__Alignas] = ACTIONS(6230),
    [sym_primitive_type] = ACTIONS(6230),
    [anon_sym_enum] = ACTIONS(6230),
    [anon_sym_class] = ACTIONS(6230),
    [anon_sym_struct] = ACTIONS(6230),
    [anon_sym_union] = ACTIONS(6230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6230),
    [anon_sym_let] = ACTIONS(6230),
    [anon_sym_This] = ACTIONS(6230),
    [anon_sym_decltype] = ACTIONS(6230),
    [anon_sym_explicit] = ACTIONS(6230),
    [anon_sym_typename] = ACTIONS(6230),
    [anon_sym_private] = ACTIONS(6230),
    [anon_sym_template] = ACTIONS(6230),
    [anon_sym_operator] = ACTIONS(6230),
    [anon_sym_friend] = ACTIONS(6230),
    [anon_sym_public] = ACTIONS(6230),
    [anon_sym_protected] = ACTIONS(6230),
    [anon_sym_static_assert] = ACTIONS(6230),
    [anon_sym_precise] = ACTIONS(6230),
    [anon_sym_shared] = ACTIONS(6230),
    [anon_sym_groupshared] = ACTIONS(6230),
    [anon_sym_uniform] = ACTIONS(6230),
    [anon_sym_row_major] = ACTIONS(6230),
    [anon_sym_column_major] = ACTIONS(6230),
    [anon_sym_globallycoherent] = ACTIONS(6230),
    [anon_sym_centroid] = ACTIONS(6230),
    [anon_sym_noperspective] = ACTIONS(6230),
    [anon_sym_nointerpolation] = ACTIONS(6230),
    [anon_sym_sample] = ACTIONS(6230),
    [anon_sym_linear] = ACTIONS(6230),
    [anon_sym_snorm] = ACTIONS(6230),
    [anon_sym_unorm] = ACTIONS(6230),
    [anon_sym_point] = ACTIONS(6230),
    [anon_sym_line] = ACTIONS(6230),
    [anon_sym_triangleadj] = ACTIONS(6230),
    [anon_sym_lineadj] = ACTIONS(6230),
    [anon_sym_triangle] = ACTIONS(6230),
    [anon_sym_interface] = ACTIONS(6230),
    [anon_sym_extension] = ACTIONS(6230),
    [anon_sym___init] = ACTIONS(6230),
    [anon_sym___subscript] = ACTIONS(6230),
    [anon_sym_property] = ACTIONS(6230),
    [anon_sym_associatedtype] = ACTIONS(6230),
  },
  [2038] = {
    [sym_identifier] = ACTIONS(6236),
    [aux_sym_preproc_def_token1] = ACTIONS(6236),
    [aux_sym_preproc_if_token1] = ACTIONS(6236),
    [aux_sym_preproc_if_token2] = ACTIONS(6236),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6236),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6236),
    [sym_preproc_directive] = ACTIONS(6236),
    [anon_sym_LPAREN2] = ACTIONS(6238),
    [anon_sym_TILDE] = ACTIONS(6238),
    [anon_sym_STAR] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6236),
    [anon_sym_SEMI] = ACTIONS(6238),
    [anon_sym___extension__] = ACTIONS(6236),
    [anon_sym_typedef] = ACTIONS(6236),
    [anon_sym_in] = ACTIONS(6236),
    [anon_sym_out] = ACTIONS(6236),
    [anon_sym_inout] = ACTIONS(6236),
    [anon_sym_virtual] = ACTIONS(6236),
    [anon_sym_extern] = ACTIONS(6236),
    [anon_sym___attribute__] = ACTIONS(6236),
    [anon_sym___attribute] = ACTIONS(6236),
    [anon_sym_using] = ACTIONS(6236),
    [anon_sym_COLON_COLON] = ACTIONS(6238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6238),
    [anon_sym___declspec] = ACTIONS(6236),
    [anon_sym___based] = ACTIONS(6236),
    [anon_sym_signed] = ACTIONS(6236),
    [anon_sym_unsigned] = ACTIONS(6236),
    [anon_sym_long] = ACTIONS(6236),
    [anon_sym_short] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_static] = ACTIONS(6236),
    [anon_sym_register] = ACTIONS(6236),
    [anon_sym_inline] = ACTIONS(6236),
    [anon_sym___inline] = ACTIONS(6236),
    [anon_sym___inline__] = ACTIONS(6236),
    [anon_sym___forceinline] = ACTIONS(6236),
    [anon_sym_thread_local] = ACTIONS(6236),
    [anon_sym___thread] = ACTIONS(6236),
    [anon_sym_const] = ACTIONS(6236),
    [anon_sym_constexpr] = ACTIONS(6236),
    [anon_sym_volatile] = ACTIONS(6236),
    [anon_sym_restrict] = ACTIONS(6236),
    [anon_sym___restrict__] = ACTIONS(6236),
    [anon_sym__Atomic] = ACTIONS(6236),
    [anon_sym__Noreturn] = ACTIONS(6236),
    [anon_sym_noreturn] = ACTIONS(6236),
    [anon_sym__Nonnull] = ACTIONS(6236),
    [anon_sym_mutable] = ACTIONS(6236),
    [anon_sym_constinit] = ACTIONS(6236),
    [anon_sym_consteval] = ACTIONS(6236),
    [anon_sym_alignas] = ACTIONS(6236),
    [anon_sym__Alignas] = ACTIONS(6236),
    [sym_primitive_type] = ACTIONS(6236),
    [anon_sym_enum] = ACTIONS(6236),
    [anon_sym_class] = ACTIONS(6236),
    [anon_sym_struct] = ACTIONS(6236),
    [anon_sym_union] = ACTIONS(6236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6236),
    [anon_sym_let] = ACTIONS(6236),
    [anon_sym_This] = ACTIONS(6236),
    [anon_sym_decltype] = ACTIONS(6236),
    [anon_sym_explicit] = ACTIONS(6236),
    [anon_sym_typename] = ACTIONS(6236),
    [anon_sym_private] = ACTIONS(6236),
    [anon_sym_template] = ACTIONS(6236),
    [anon_sym_operator] = ACTIONS(6236),
    [anon_sym_friend] = ACTIONS(6236),
    [anon_sym_public] = ACTIONS(6236),
    [anon_sym_protected] = ACTIONS(6236),
    [anon_sym_static_assert] = ACTIONS(6236),
    [anon_sym_precise] = ACTIONS(6236),
    [anon_sym_shared] = ACTIONS(6236),
    [anon_sym_groupshared] = ACTIONS(6236),
    [anon_sym_uniform] = ACTIONS(6236),
    [anon_sym_row_major] = ACTIONS(6236),
    [anon_sym_column_major] = ACTIONS(6236),
    [anon_sym_globallycoherent] = ACTIONS(6236),
    [anon_sym_centroid] = ACTIONS(6236),
    [anon_sym_noperspective] = ACTIONS(6236),
    [anon_sym_nointerpolation] = ACTIONS(6236),
    [anon_sym_sample] = ACTIONS(6236),
    [anon_sym_linear] = ACTIONS(6236),
    [anon_sym_snorm] = ACTIONS(6236),
    [anon_sym_unorm] = ACTIONS(6236),
    [anon_sym_point] = ACTIONS(6236),
    [anon_sym_line] = ACTIONS(6236),
    [anon_sym_triangleadj] = ACTIONS(6236),
    [anon_sym_lineadj] = ACTIONS(6236),
    [anon_sym_triangle] = ACTIONS(6236),
    [anon_sym_interface] = ACTIONS(6236),
    [anon_sym_extension] = ACTIONS(6236),
    [anon_sym___init] = ACTIONS(6236),
    [anon_sym___subscript] = ACTIONS(6236),
    [anon_sym_property] = ACTIONS(6236),
    [anon_sym_associatedtype] = ACTIONS(6236),
  },
  [2039] = {
    [sym_identifier] = ACTIONS(6242),
    [aux_sym_preproc_def_token1] = ACTIONS(6242),
    [aux_sym_preproc_if_token1] = ACTIONS(6242),
    [aux_sym_preproc_if_token2] = ACTIONS(6242),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6242),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6242),
    [sym_preproc_directive] = ACTIONS(6242),
    [anon_sym_LPAREN2] = ACTIONS(6244),
    [anon_sym_TILDE] = ACTIONS(6244),
    [anon_sym_STAR] = ACTIONS(6244),
    [anon_sym_AMP_AMP] = ACTIONS(6244),
    [anon_sym_AMP] = ACTIONS(6242),
    [anon_sym_SEMI] = ACTIONS(6244),
    [anon_sym___extension__] = ACTIONS(6242),
    [anon_sym_typedef] = ACTIONS(6242),
    [anon_sym_in] = ACTIONS(6242),
    [anon_sym_out] = ACTIONS(6242),
    [anon_sym_inout] = ACTIONS(6242),
    [anon_sym_virtual] = ACTIONS(6242),
    [anon_sym_extern] = ACTIONS(6242),
    [anon_sym___attribute__] = ACTIONS(6242),
    [anon_sym___attribute] = ACTIONS(6242),
    [anon_sym_using] = ACTIONS(6242),
    [anon_sym_COLON_COLON] = ACTIONS(6244),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6244),
    [anon_sym___declspec] = ACTIONS(6242),
    [anon_sym___based] = ACTIONS(6242),
    [anon_sym_signed] = ACTIONS(6242),
    [anon_sym_unsigned] = ACTIONS(6242),
    [anon_sym_long] = ACTIONS(6242),
    [anon_sym_short] = ACTIONS(6242),
    [anon_sym_LBRACK] = ACTIONS(6242),
    [anon_sym_static] = ACTIONS(6242),
    [anon_sym_register] = ACTIONS(6242),
    [anon_sym_inline] = ACTIONS(6242),
    [anon_sym___inline] = ACTIONS(6242),
    [anon_sym___inline__] = ACTIONS(6242),
    [anon_sym___forceinline] = ACTIONS(6242),
    [anon_sym_thread_local] = ACTIONS(6242),
    [anon_sym___thread] = ACTIONS(6242),
    [anon_sym_const] = ACTIONS(6242),
    [anon_sym_constexpr] = ACTIONS(6242),
    [anon_sym_volatile] = ACTIONS(6242),
    [anon_sym_restrict] = ACTIONS(6242),
    [anon_sym___restrict__] = ACTIONS(6242),
    [anon_sym__Atomic] = ACTIONS(6242),
    [anon_sym__Noreturn] = ACTIONS(6242),
    [anon_sym_noreturn] = ACTIONS(6242),
    [anon_sym__Nonnull] = ACTIONS(6242),
    [anon_sym_mutable] = ACTIONS(6242),
    [anon_sym_constinit] = ACTIONS(6242),
    [anon_sym_consteval] = ACTIONS(6242),
    [anon_sym_alignas] = ACTIONS(6242),
    [anon_sym__Alignas] = ACTIONS(6242),
    [sym_primitive_type] = ACTIONS(6242),
    [anon_sym_enum] = ACTIONS(6242),
    [anon_sym_class] = ACTIONS(6242),
    [anon_sym_struct] = ACTIONS(6242),
    [anon_sym_union] = ACTIONS(6242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6242),
    [anon_sym_let] = ACTIONS(6242),
    [anon_sym_This] = ACTIONS(6242),
    [anon_sym_decltype] = ACTIONS(6242),
    [anon_sym_explicit] = ACTIONS(6242),
    [anon_sym_typename] = ACTIONS(6242),
    [anon_sym_private] = ACTIONS(6242),
    [anon_sym_template] = ACTIONS(6242),
    [anon_sym_operator] = ACTIONS(6242),
    [anon_sym_friend] = ACTIONS(6242),
    [anon_sym_public] = ACTIONS(6242),
    [anon_sym_protected] = ACTIONS(6242),
    [anon_sym_static_assert] = ACTIONS(6242),
    [anon_sym_precise] = ACTIONS(6242),
    [anon_sym_shared] = ACTIONS(6242),
    [anon_sym_groupshared] = ACTIONS(6242),
    [anon_sym_uniform] = ACTIONS(6242),
    [anon_sym_row_major] = ACTIONS(6242),
    [anon_sym_column_major] = ACTIONS(6242),
    [anon_sym_globallycoherent] = ACTIONS(6242),
    [anon_sym_centroid] = ACTIONS(6242),
    [anon_sym_noperspective] = ACTIONS(6242),
    [anon_sym_nointerpolation] = ACTIONS(6242),
    [anon_sym_sample] = ACTIONS(6242),
    [anon_sym_linear] = ACTIONS(6242),
    [anon_sym_snorm] = ACTIONS(6242),
    [anon_sym_unorm] = ACTIONS(6242),
    [anon_sym_point] = ACTIONS(6242),
    [anon_sym_line] = ACTIONS(6242),
    [anon_sym_triangleadj] = ACTIONS(6242),
    [anon_sym_lineadj] = ACTIONS(6242),
    [anon_sym_triangle] = ACTIONS(6242),
    [anon_sym_interface] = ACTIONS(6242),
    [anon_sym_extension] = ACTIONS(6242),
    [anon_sym___init] = ACTIONS(6242),
    [anon_sym___subscript] = ACTIONS(6242),
    [anon_sym_property] = ACTIONS(6242),
    [anon_sym_associatedtype] = ACTIONS(6242),
  },
  [2040] = {
    [sym_expression] = STATE(5903),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2041] = {
    [sym_identifier] = ACTIONS(6246),
    [aux_sym_preproc_def_token1] = ACTIONS(6246),
    [aux_sym_preproc_if_token1] = ACTIONS(6246),
    [aux_sym_preproc_if_token2] = ACTIONS(6246),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6246),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6246),
    [sym_preproc_directive] = ACTIONS(6246),
    [anon_sym_LPAREN2] = ACTIONS(6248),
    [anon_sym_TILDE] = ACTIONS(6248),
    [anon_sym_STAR] = ACTIONS(6248),
    [anon_sym_AMP_AMP] = ACTIONS(6248),
    [anon_sym_AMP] = ACTIONS(6246),
    [anon_sym_SEMI] = ACTIONS(6248),
    [anon_sym___extension__] = ACTIONS(6246),
    [anon_sym_typedef] = ACTIONS(6246),
    [anon_sym_in] = ACTIONS(6246),
    [anon_sym_out] = ACTIONS(6246),
    [anon_sym_inout] = ACTIONS(6246),
    [anon_sym_virtual] = ACTIONS(6246),
    [anon_sym_extern] = ACTIONS(6246),
    [anon_sym___attribute__] = ACTIONS(6246),
    [anon_sym___attribute] = ACTIONS(6246),
    [anon_sym_using] = ACTIONS(6246),
    [anon_sym_COLON_COLON] = ACTIONS(6248),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6248),
    [anon_sym___declspec] = ACTIONS(6246),
    [anon_sym___based] = ACTIONS(6246),
    [anon_sym_signed] = ACTIONS(6246),
    [anon_sym_unsigned] = ACTIONS(6246),
    [anon_sym_long] = ACTIONS(6246),
    [anon_sym_short] = ACTIONS(6246),
    [anon_sym_LBRACK] = ACTIONS(6246),
    [anon_sym_static] = ACTIONS(6246),
    [anon_sym_register] = ACTIONS(6246),
    [anon_sym_inline] = ACTIONS(6246),
    [anon_sym___inline] = ACTIONS(6246),
    [anon_sym___inline__] = ACTIONS(6246),
    [anon_sym___forceinline] = ACTIONS(6246),
    [anon_sym_thread_local] = ACTIONS(6246),
    [anon_sym___thread] = ACTIONS(6246),
    [anon_sym_const] = ACTIONS(6246),
    [anon_sym_constexpr] = ACTIONS(6246),
    [anon_sym_volatile] = ACTIONS(6246),
    [anon_sym_restrict] = ACTIONS(6246),
    [anon_sym___restrict__] = ACTIONS(6246),
    [anon_sym__Atomic] = ACTIONS(6246),
    [anon_sym__Noreturn] = ACTIONS(6246),
    [anon_sym_noreturn] = ACTIONS(6246),
    [anon_sym__Nonnull] = ACTIONS(6246),
    [anon_sym_mutable] = ACTIONS(6246),
    [anon_sym_constinit] = ACTIONS(6246),
    [anon_sym_consteval] = ACTIONS(6246),
    [anon_sym_alignas] = ACTIONS(6246),
    [anon_sym__Alignas] = ACTIONS(6246),
    [sym_primitive_type] = ACTIONS(6246),
    [anon_sym_enum] = ACTIONS(6246),
    [anon_sym_class] = ACTIONS(6246),
    [anon_sym_struct] = ACTIONS(6246),
    [anon_sym_union] = ACTIONS(6246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6246),
    [anon_sym_let] = ACTIONS(6246),
    [anon_sym_This] = ACTIONS(6246),
    [anon_sym_decltype] = ACTIONS(6246),
    [anon_sym_explicit] = ACTIONS(6246),
    [anon_sym_typename] = ACTIONS(6246),
    [anon_sym_private] = ACTIONS(6246),
    [anon_sym_template] = ACTIONS(6246),
    [anon_sym_operator] = ACTIONS(6246),
    [anon_sym_friend] = ACTIONS(6246),
    [anon_sym_public] = ACTIONS(6246),
    [anon_sym_protected] = ACTIONS(6246),
    [anon_sym_static_assert] = ACTIONS(6246),
    [anon_sym_precise] = ACTIONS(6246),
    [anon_sym_shared] = ACTIONS(6246),
    [anon_sym_groupshared] = ACTIONS(6246),
    [anon_sym_uniform] = ACTIONS(6246),
    [anon_sym_row_major] = ACTIONS(6246),
    [anon_sym_column_major] = ACTIONS(6246),
    [anon_sym_globallycoherent] = ACTIONS(6246),
    [anon_sym_centroid] = ACTIONS(6246),
    [anon_sym_noperspective] = ACTIONS(6246),
    [anon_sym_nointerpolation] = ACTIONS(6246),
    [anon_sym_sample] = ACTIONS(6246),
    [anon_sym_linear] = ACTIONS(6246),
    [anon_sym_snorm] = ACTIONS(6246),
    [anon_sym_unorm] = ACTIONS(6246),
    [anon_sym_point] = ACTIONS(6246),
    [anon_sym_line] = ACTIONS(6246),
    [anon_sym_triangleadj] = ACTIONS(6246),
    [anon_sym_lineadj] = ACTIONS(6246),
    [anon_sym_triangle] = ACTIONS(6246),
    [anon_sym_interface] = ACTIONS(6246),
    [anon_sym_extension] = ACTIONS(6246),
    [anon_sym___init] = ACTIONS(6246),
    [anon_sym___subscript] = ACTIONS(6246),
    [anon_sym_property] = ACTIONS(6246),
    [anon_sym_associatedtype] = ACTIONS(6246),
  },
  [2042] = {
    [sym_identifier] = ACTIONS(6252),
    [aux_sym_preproc_def_token1] = ACTIONS(6252),
    [aux_sym_preproc_if_token1] = ACTIONS(6252),
    [aux_sym_preproc_if_token2] = ACTIONS(6252),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6252),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6252),
    [sym_preproc_directive] = ACTIONS(6252),
    [anon_sym_LPAREN2] = ACTIONS(6254),
    [anon_sym_TILDE] = ACTIONS(6254),
    [anon_sym_STAR] = ACTIONS(6254),
    [anon_sym_AMP_AMP] = ACTIONS(6254),
    [anon_sym_AMP] = ACTIONS(6252),
    [anon_sym_SEMI] = ACTIONS(6254),
    [anon_sym___extension__] = ACTIONS(6252),
    [anon_sym_typedef] = ACTIONS(6252),
    [anon_sym_in] = ACTIONS(6252),
    [anon_sym_out] = ACTIONS(6252),
    [anon_sym_inout] = ACTIONS(6252),
    [anon_sym_virtual] = ACTIONS(6252),
    [anon_sym_extern] = ACTIONS(6252),
    [anon_sym___attribute__] = ACTIONS(6252),
    [anon_sym___attribute] = ACTIONS(6252),
    [anon_sym_using] = ACTIONS(6252),
    [anon_sym_COLON_COLON] = ACTIONS(6254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6254),
    [anon_sym___declspec] = ACTIONS(6252),
    [anon_sym___based] = ACTIONS(6252),
    [anon_sym_signed] = ACTIONS(6252),
    [anon_sym_unsigned] = ACTIONS(6252),
    [anon_sym_long] = ACTIONS(6252),
    [anon_sym_short] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_static] = ACTIONS(6252),
    [anon_sym_register] = ACTIONS(6252),
    [anon_sym_inline] = ACTIONS(6252),
    [anon_sym___inline] = ACTIONS(6252),
    [anon_sym___inline__] = ACTIONS(6252),
    [anon_sym___forceinline] = ACTIONS(6252),
    [anon_sym_thread_local] = ACTIONS(6252),
    [anon_sym___thread] = ACTIONS(6252),
    [anon_sym_const] = ACTIONS(6252),
    [anon_sym_constexpr] = ACTIONS(6252),
    [anon_sym_volatile] = ACTIONS(6252),
    [anon_sym_restrict] = ACTIONS(6252),
    [anon_sym___restrict__] = ACTIONS(6252),
    [anon_sym__Atomic] = ACTIONS(6252),
    [anon_sym__Noreturn] = ACTIONS(6252),
    [anon_sym_noreturn] = ACTIONS(6252),
    [anon_sym__Nonnull] = ACTIONS(6252),
    [anon_sym_mutable] = ACTIONS(6252),
    [anon_sym_constinit] = ACTIONS(6252),
    [anon_sym_consteval] = ACTIONS(6252),
    [anon_sym_alignas] = ACTIONS(6252),
    [anon_sym__Alignas] = ACTIONS(6252),
    [sym_primitive_type] = ACTIONS(6252),
    [anon_sym_enum] = ACTIONS(6252),
    [anon_sym_class] = ACTIONS(6252),
    [anon_sym_struct] = ACTIONS(6252),
    [anon_sym_union] = ACTIONS(6252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6252),
    [anon_sym_let] = ACTIONS(6252),
    [anon_sym_This] = ACTIONS(6252),
    [anon_sym_decltype] = ACTIONS(6252),
    [anon_sym_explicit] = ACTIONS(6252),
    [anon_sym_typename] = ACTIONS(6252),
    [anon_sym_private] = ACTIONS(6252),
    [anon_sym_template] = ACTIONS(6252),
    [anon_sym_operator] = ACTIONS(6252),
    [anon_sym_friend] = ACTIONS(6252),
    [anon_sym_public] = ACTIONS(6252),
    [anon_sym_protected] = ACTIONS(6252),
    [anon_sym_static_assert] = ACTIONS(6252),
    [anon_sym_precise] = ACTIONS(6252),
    [anon_sym_shared] = ACTIONS(6252),
    [anon_sym_groupshared] = ACTIONS(6252),
    [anon_sym_uniform] = ACTIONS(6252),
    [anon_sym_row_major] = ACTIONS(6252),
    [anon_sym_column_major] = ACTIONS(6252),
    [anon_sym_globallycoherent] = ACTIONS(6252),
    [anon_sym_centroid] = ACTIONS(6252),
    [anon_sym_noperspective] = ACTIONS(6252),
    [anon_sym_nointerpolation] = ACTIONS(6252),
    [anon_sym_sample] = ACTIONS(6252),
    [anon_sym_linear] = ACTIONS(6252),
    [anon_sym_snorm] = ACTIONS(6252),
    [anon_sym_unorm] = ACTIONS(6252),
    [anon_sym_point] = ACTIONS(6252),
    [anon_sym_line] = ACTIONS(6252),
    [anon_sym_triangleadj] = ACTIONS(6252),
    [anon_sym_lineadj] = ACTIONS(6252),
    [anon_sym_triangle] = ACTIONS(6252),
    [anon_sym_interface] = ACTIONS(6252),
    [anon_sym_extension] = ACTIONS(6252),
    [anon_sym___init] = ACTIONS(6252),
    [anon_sym___subscript] = ACTIONS(6252),
    [anon_sym_property] = ACTIONS(6252),
    [anon_sym_associatedtype] = ACTIONS(6252),
  },
  [2043] = {
    [sym_identifier] = ACTIONS(6256),
    [aux_sym_preproc_def_token1] = ACTIONS(6256),
    [aux_sym_preproc_if_token1] = ACTIONS(6256),
    [aux_sym_preproc_if_token2] = ACTIONS(6256),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6256),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6256),
    [sym_preproc_directive] = ACTIONS(6256),
    [anon_sym_LPAREN2] = ACTIONS(6258),
    [anon_sym_TILDE] = ACTIONS(6258),
    [anon_sym_STAR] = ACTIONS(6258),
    [anon_sym_AMP_AMP] = ACTIONS(6258),
    [anon_sym_AMP] = ACTIONS(6256),
    [anon_sym_SEMI] = ACTIONS(6258),
    [anon_sym___extension__] = ACTIONS(6256),
    [anon_sym_typedef] = ACTIONS(6256),
    [anon_sym_in] = ACTIONS(6256),
    [anon_sym_out] = ACTIONS(6256),
    [anon_sym_inout] = ACTIONS(6256),
    [anon_sym_virtual] = ACTIONS(6256),
    [anon_sym_extern] = ACTIONS(6256),
    [anon_sym___attribute__] = ACTIONS(6256),
    [anon_sym___attribute] = ACTIONS(6256),
    [anon_sym_using] = ACTIONS(6256),
    [anon_sym_COLON_COLON] = ACTIONS(6258),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6258),
    [anon_sym___declspec] = ACTIONS(6256),
    [anon_sym___based] = ACTIONS(6256),
    [anon_sym_signed] = ACTIONS(6256),
    [anon_sym_unsigned] = ACTIONS(6256),
    [anon_sym_long] = ACTIONS(6256),
    [anon_sym_short] = ACTIONS(6256),
    [anon_sym_LBRACK] = ACTIONS(6256),
    [anon_sym_static] = ACTIONS(6256),
    [anon_sym_register] = ACTIONS(6256),
    [anon_sym_inline] = ACTIONS(6256),
    [anon_sym___inline] = ACTIONS(6256),
    [anon_sym___inline__] = ACTIONS(6256),
    [anon_sym___forceinline] = ACTIONS(6256),
    [anon_sym_thread_local] = ACTIONS(6256),
    [anon_sym___thread] = ACTIONS(6256),
    [anon_sym_const] = ACTIONS(6256),
    [anon_sym_constexpr] = ACTIONS(6256),
    [anon_sym_volatile] = ACTIONS(6256),
    [anon_sym_restrict] = ACTIONS(6256),
    [anon_sym___restrict__] = ACTIONS(6256),
    [anon_sym__Atomic] = ACTIONS(6256),
    [anon_sym__Noreturn] = ACTIONS(6256),
    [anon_sym_noreturn] = ACTIONS(6256),
    [anon_sym__Nonnull] = ACTIONS(6256),
    [anon_sym_mutable] = ACTIONS(6256),
    [anon_sym_constinit] = ACTIONS(6256),
    [anon_sym_consteval] = ACTIONS(6256),
    [anon_sym_alignas] = ACTIONS(6256),
    [anon_sym__Alignas] = ACTIONS(6256),
    [sym_primitive_type] = ACTIONS(6256),
    [anon_sym_enum] = ACTIONS(6256),
    [anon_sym_class] = ACTIONS(6256),
    [anon_sym_struct] = ACTIONS(6256),
    [anon_sym_union] = ACTIONS(6256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6256),
    [anon_sym_let] = ACTIONS(6256),
    [anon_sym_This] = ACTIONS(6256),
    [anon_sym_decltype] = ACTIONS(6256),
    [anon_sym_explicit] = ACTIONS(6256),
    [anon_sym_typename] = ACTIONS(6256),
    [anon_sym_private] = ACTIONS(6256),
    [anon_sym_template] = ACTIONS(6256),
    [anon_sym_operator] = ACTIONS(6256),
    [anon_sym_friend] = ACTIONS(6256),
    [anon_sym_public] = ACTIONS(6256),
    [anon_sym_protected] = ACTIONS(6256),
    [anon_sym_static_assert] = ACTIONS(6256),
    [anon_sym_precise] = ACTIONS(6256),
    [anon_sym_shared] = ACTIONS(6256),
    [anon_sym_groupshared] = ACTIONS(6256),
    [anon_sym_uniform] = ACTIONS(6256),
    [anon_sym_row_major] = ACTIONS(6256),
    [anon_sym_column_major] = ACTIONS(6256),
    [anon_sym_globallycoherent] = ACTIONS(6256),
    [anon_sym_centroid] = ACTIONS(6256),
    [anon_sym_noperspective] = ACTIONS(6256),
    [anon_sym_nointerpolation] = ACTIONS(6256),
    [anon_sym_sample] = ACTIONS(6256),
    [anon_sym_linear] = ACTIONS(6256),
    [anon_sym_snorm] = ACTIONS(6256),
    [anon_sym_unorm] = ACTIONS(6256),
    [anon_sym_point] = ACTIONS(6256),
    [anon_sym_line] = ACTIONS(6256),
    [anon_sym_triangleadj] = ACTIONS(6256),
    [anon_sym_lineadj] = ACTIONS(6256),
    [anon_sym_triangle] = ACTIONS(6256),
    [anon_sym_interface] = ACTIONS(6256),
    [anon_sym_extension] = ACTIONS(6256),
    [anon_sym___init] = ACTIONS(6256),
    [anon_sym___subscript] = ACTIONS(6256),
    [anon_sym_property] = ACTIONS(6256),
    [anon_sym_associatedtype] = ACTIONS(6256),
  },
  [2044] = {
    [sym_identifier] = ACTIONS(6260),
    [aux_sym_preproc_def_token1] = ACTIONS(6260),
    [aux_sym_preproc_if_token1] = ACTIONS(6260),
    [aux_sym_preproc_if_token2] = ACTIONS(6260),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6260),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6260),
    [sym_preproc_directive] = ACTIONS(6260),
    [anon_sym_LPAREN2] = ACTIONS(6262),
    [anon_sym_TILDE] = ACTIONS(6262),
    [anon_sym_STAR] = ACTIONS(6262),
    [anon_sym_AMP_AMP] = ACTIONS(6262),
    [anon_sym_AMP] = ACTIONS(6260),
    [anon_sym_SEMI] = ACTIONS(6262),
    [anon_sym___extension__] = ACTIONS(6260),
    [anon_sym_typedef] = ACTIONS(6260),
    [anon_sym_in] = ACTIONS(6260),
    [anon_sym_out] = ACTIONS(6260),
    [anon_sym_inout] = ACTIONS(6260),
    [anon_sym_virtual] = ACTIONS(6260),
    [anon_sym_extern] = ACTIONS(6260),
    [anon_sym___attribute__] = ACTIONS(6260),
    [anon_sym___attribute] = ACTIONS(6260),
    [anon_sym_using] = ACTIONS(6260),
    [anon_sym_COLON_COLON] = ACTIONS(6262),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6262),
    [anon_sym___declspec] = ACTIONS(6260),
    [anon_sym___based] = ACTIONS(6260),
    [anon_sym_signed] = ACTIONS(6260),
    [anon_sym_unsigned] = ACTIONS(6260),
    [anon_sym_long] = ACTIONS(6260),
    [anon_sym_short] = ACTIONS(6260),
    [anon_sym_LBRACK] = ACTIONS(6260),
    [anon_sym_static] = ACTIONS(6260),
    [anon_sym_register] = ACTIONS(6260),
    [anon_sym_inline] = ACTIONS(6260),
    [anon_sym___inline] = ACTIONS(6260),
    [anon_sym___inline__] = ACTIONS(6260),
    [anon_sym___forceinline] = ACTIONS(6260),
    [anon_sym_thread_local] = ACTIONS(6260),
    [anon_sym___thread] = ACTIONS(6260),
    [anon_sym_const] = ACTIONS(6260),
    [anon_sym_constexpr] = ACTIONS(6260),
    [anon_sym_volatile] = ACTIONS(6260),
    [anon_sym_restrict] = ACTIONS(6260),
    [anon_sym___restrict__] = ACTIONS(6260),
    [anon_sym__Atomic] = ACTIONS(6260),
    [anon_sym__Noreturn] = ACTIONS(6260),
    [anon_sym_noreturn] = ACTIONS(6260),
    [anon_sym__Nonnull] = ACTIONS(6260),
    [anon_sym_mutable] = ACTIONS(6260),
    [anon_sym_constinit] = ACTIONS(6260),
    [anon_sym_consteval] = ACTIONS(6260),
    [anon_sym_alignas] = ACTIONS(6260),
    [anon_sym__Alignas] = ACTIONS(6260),
    [sym_primitive_type] = ACTIONS(6260),
    [anon_sym_enum] = ACTIONS(6260),
    [anon_sym_class] = ACTIONS(6260),
    [anon_sym_struct] = ACTIONS(6260),
    [anon_sym_union] = ACTIONS(6260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6260),
    [anon_sym_let] = ACTIONS(6260),
    [anon_sym_This] = ACTIONS(6260),
    [anon_sym_decltype] = ACTIONS(6260),
    [anon_sym_explicit] = ACTIONS(6260),
    [anon_sym_typename] = ACTIONS(6260),
    [anon_sym_private] = ACTIONS(6260),
    [anon_sym_template] = ACTIONS(6260),
    [anon_sym_operator] = ACTIONS(6260),
    [anon_sym_friend] = ACTIONS(6260),
    [anon_sym_public] = ACTIONS(6260),
    [anon_sym_protected] = ACTIONS(6260),
    [anon_sym_static_assert] = ACTIONS(6260),
    [anon_sym_precise] = ACTIONS(6260),
    [anon_sym_shared] = ACTIONS(6260),
    [anon_sym_groupshared] = ACTIONS(6260),
    [anon_sym_uniform] = ACTIONS(6260),
    [anon_sym_row_major] = ACTIONS(6260),
    [anon_sym_column_major] = ACTIONS(6260),
    [anon_sym_globallycoherent] = ACTIONS(6260),
    [anon_sym_centroid] = ACTIONS(6260),
    [anon_sym_noperspective] = ACTIONS(6260),
    [anon_sym_nointerpolation] = ACTIONS(6260),
    [anon_sym_sample] = ACTIONS(6260),
    [anon_sym_linear] = ACTIONS(6260),
    [anon_sym_snorm] = ACTIONS(6260),
    [anon_sym_unorm] = ACTIONS(6260),
    [anon_sym_point] = ACTIONS(6260),
    [anon_sym_line] = ACTIONS(6260),
    [anon_sym_triangleadj] = ACTIONS(6260),
    [anon_sym_lineadj] = ACTIONS(6260),
    [anon_sym_triangle] = ACTIONS(6260),
    [anon_sym_interface] = ACTIONS(6260),
    [anon_sym_extension] = ACTIONS(6260),
    [anon_sym___init] = ACTIONS(6260),
    [anon_sym___subscript] = ACTIONS(6260),
    [anon_sym_property] = ACTIONS(6260),
    [anon_sym_associatedtype] = ACTIONS(6260),
  },
  [2045] = {
    [sym_expression] = STATE(6062),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2046] = {
    [sym_identifier] = ACTIONS(6268),
    [aux_sym_preproc_def_token1] = ACTIONS(6268),
    [aux_sym_preproc_if_token1] = ACTIONS(6268),
    [aux_sym_preproc_if_token2] = ACTIONS(6268),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6268),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6268),
    [sym_preproc_directive] = ACTIONS(6268),
    [anon_sym_LPAREN2] = ACTIONS(6270),
    [anon_sym_TILDE] = ACTIONS(6270),
    [anon_sym_STAR] = ACTIONS(6270),
    [anon_sym_AMP_AMP] = ACTIONS(6270),
    [anon_sym_AMP] = ACTIONS(6268),
    [anon_sym_SEMI] = ACTIONS(6270),
    [anon_sym___extension__] = ACTIONS(6268),
    [anon_sym_typedef] = ACTIONS(6268),
    [anon_sym_in] = ACTIONS(6268),
    [anon_sym_out] = ACTIONS(6268),
    [anon_sym_inout] = ACTIONS(6268),
    [anon_sym_virtual] = ACTIONS(6268),
    [anon_sym_extern] = ACTIONS(6268),
    [anon_sym___attribute__] = ACTIONS(6268),
    [anon_sym___attribute] = ACTIONS(6268),
    [anon_sym_using] = ACTIONS(6268),
    [anon_sym_COLON_COLON] = ACTIONS(6270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6270),
    [anon_sym___declspec] = ACTIONS(6268),
    [anon_sym___based] = ACTIONS(6268),
    [anon_sym_signed] = ACTIONS(6268),
    [anon_sym_unsigned] = ACTIONS(6268),
    [anon_sym_long] = ACTIONS(6268),
    [anon_sym_short] = ACTIONS(6268),
    [anon_sym_LBRACK] = ACTIONS(6268),
    [anon_sym_static] = ACTIONS(6268),
    [anon_sym_register] = ACTIONS(6268),
    [anon_sym_inline] = ACTIONS(6268),
    [anon_sym___inline] = ACTIONS(6268),
    [anon_sym___inline__] = ACTIONS(6268),
    [anon_sym___forceinline] = ACTIONS(6268),
    [anon_sym_thread_local] = ACTIONS(6268),
    [anon_sym___thread] = ACTIONS(6268),
    [anon_sym_const] = ACTIONS(6268),
    [anon_sym_constexpr] = ACTIONS(6268),
    [anon_sym_volatile] = ACTIONS(6268),
    [anon_sym_restrict] = ACTIONS(6268),
    [anon_sym___restrict__] = ACTIONS(6268),
    [anon_sym__Atomic] = ACTIONS(6268),
    [anon_sym__Noreturn] = ACTIONS(6268),
    [anon_sym_noreturn] = ACTIONS(6268),
    [anon_sym__Nonnull] = ACTIONS(6268),
    [anon_sym_mutable] = ACTIONS(6268),
    [anon_sym_constinit] = ACTIONS(6268),
    [anon_sym_consteval] = ACTIONS(6268),
    [anon_sym_alignas] = ACTIONS(6268),
    [anon_sym__Alignas] = ACTIONS(6268),
    [sym_primitive_type] = ACTIONS(6268),
    [anon_sym_enum] = ACTIONS(6268),
    [anon_sym_class] = ACTIONS(6268),
    [anon_sym_struct] = ACTIONS(6268),
    [anon_sym_union] = ACTIONS(6268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6268),
    [anon_sym_let] = ACTIONS(6268),
    [anon_sym_This] = ACTIONS(6268),
    [anon_sym_decltype] = ACTIONS(6268),
    [anon_sym_explicit] = ACTIONS(6268),
    [anon_sym_typename] = ACTIONS(6268),
    [anon_sym_private] = ACTIONS(6268),
    [anon_sym_template] = ACTIONS(6268),
    [anon_sym_operator] = ACTIONS(6268),
    [anon_sym_friend] = ACTIONS(6268),
    [anon_sym_public] = ACTIONS(6268),
    [anon_sym_protected] = ACTIONS(6268),
    [anon_sym_static_assert] = ACTIONS(6268),
    [anon_sym_precise] = ACTIONS(6268),
    [anon_sym_shared] = ACTIONS(6268),
    [anon_sym_groupshared] = ACTIONS(6268),
    [anon_sym_uniform] = ACTIONS(6268),
    [anon_sym_row_major] = ACTIONS(6268),
    [anon_sym_column_major] = ACTIONS(6268),
    [anon_sym_globallycoherent] = ACTIONS(6268),
    [anon_sym_centroid] = ACTIONS(6268),
    [anon_sym_noperspective] = ACTIONS(6268),
    [anon_sym_nointerpolation] = ACTIONS(6268),
    [anon_sym_sample] = ACTIONS(6268),
    [anon_sym_linear] = ACTIONS(6268),
    [anon_sym_snorm] = ACTIONS(6268),
    [anon_sym_unorm] = ACTIONS(6268),
    [anon_sym_point] = ACTIONS(6268),
    [anon_sym_line] = ACTIONS(6268),
    [anon_sym_triangleadj] = ACTIONS(6268),
    [anon_sym_lineadj] = ACTIONS(6268),
    [anon_sym_triangle] = ACTIONS(6268),
    [anon_sym_interface] = ACTIONS(6268),
    [anon_sym_extension] = ACTIONS(6268),
    [anon_sym___init] = ACTIONS(6268),
    [anon_sym___subscript] = ACTIONS(6268),
    [anon_sym_property] = ACTIONS(6268),
    [anon_sym_associatedtype] = ACTIONS(6268),
  },
  [2047] = {
    [sym_identifier] = ACTIONS(6264),
    [aux_sym_preproc_def_token1] = ACTIONS(6264),
    [aux_sym_preproc_if_token1] = ACTIONS(6264),
    [aux_sym_preproc_if_token2] = ACTIONS(6264),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6264),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6264),
    [sym_preproc_directive] = ACTIONS(6264),
    [anon_sym_LPAREN2] = ACTIONS(6266),
    [anon_sym_TILDE] = ACTIONS(6266),
    [anon_sym_STAR] = ACTIONS(6266),
    [anon_sym_AMP_AMP] = ACTIONS(6266),
    [anon_sym_AMP] = ACTIONS(6264),
    [anon_sym_SEMI] = ACTIONS(6266),
    [anon_sym___extension__] = ACTIONS(6264),
    [anon_sym_typedef] = ACTIONS(6264),
    [anon_sym_in] = ACTIONS(6264),
    [anon_sym_out] = ACTIONS(6264),
    [anon_sym_inout] = ACTIONS(6264),
    [anon_sym_virtual] = ACTIONS(6264),
    [anon_sym_extern] = ACTIONS(6264),
    [anon_sym___attribute__] = ACTIONS(6264),
    [anon_sym___attribute] = ACTIONS(6264),
    [anon_sym_using] = ACTIONS(6264),
    [anon_sym_COLON_COLON] = ACTIONS(6266),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6266),
    [anon_sym___declspec] = ACTIONS(6264),
    [anon_sym___based] = ACTIONS(6264),
    [anon_sym_signed] = ACTIONS(6264),
    [anon_sym_unsigned] = ACTIONS(6264),
    [anon_sym_long] = ACTIONS(6264),
    [anon_sym_short] = ACTIONS(6264),
    [anon_sym_LBRACK] = ACTIONS(6264),
    [anon_sym_static] = ACTIONS(6264),
    [anon_sym_register] = ACTIONS(6264),
    [anon_sym_inline] = ACTIONS(6264),
    [anon_sym___inline] = ACTIONS(6264),
    [anon_sym___inline__] = ACTIONS(6264),
    [anon_sym___forceinline] = ACTIONS(6264),
    [anon_sym_thread_local] = ACTIONS(6264),
    [anon_sym___thread] = ACTIONS(6264),
    [anon_sym_const] = ACTIONS(6264),
    [anon_sym_constexpr] = ACTIONS(6264),
    [anon_sym_volatile] = ACTIONS(6264),
    [anon_sym_restrict] = ACTIONS(6264),
    [anon_sym___restrict__] = ACTIONS(6264),
    [anon_sym__Atomic] = ACTIONS(6264),
    [anon_sym__Noreturn] = ACTIONS(6264),
    [anon_sym_noreturn] = ACTIONS(6264),
    [anon_sym__Nonnull] = ACTIONS(6264),
    [anon_sym_mutable] = ACTIONS(6264),
    [anon_sym_constinit] = ACTIONS(6264),
    [anon_sym_consteval] = ACTIONS(6264),
    [anon_sym_alignas] = ACTIONS(6264),
    [anon_sym__Alignas] = ACTIONS(6264),
    [sym_primitive_type] = ACTIONS(6264),
    [anon_sym_enum] = ACTIONS(6264),
    [anon_sym_class] = ACTIONS(6264),
    [anon_sym_struct] = ACTIONS(6264),
    [anon_sym_union] = ACTIONS(6264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6264),
    [anon_sym_let] = ACTIONS(6264),
    [anon_sym_This] = ACTIONS(6264),
    [anon_sym_decltype] = ACTIONS(6264),
    [anon_sym_explicit] = ACTIONS(6264),
    [anon_sym_typename] = ACTIONS(6264),
    [anon_sym_private] = ACTIONS(6264),
    [anon_sym_template] = ACTIONS(6264),
    [anon_sym_operator] = ACTIONS(6264),
    [anon_sym_friend] = ACTIONS(6264),
    [anon_sym_public] = ACTIONS(6264),
    [anon_sym_protected] = ACTIONS(6264),
    [anon_sym_static_assert] = ACTIONS(6264),
    [anon_sym_precise] = ACTIONS(6264),
    [anon_sym_shared] = ACTIONS(6264),
    [anon_sym_groupshared] = ACTIONS(6264),
    [anon_sym_uniform] = ACTIONS(6264),
    [anon_sym_row_major] = ACTIONS(6264),
    [anon_sym_column_major] = ACTIONS(6264),
    [anon_sym_globallycoherent] = ACTIONS(6264),
    [anon_sym_centroid] = ACTIONS(6264),
    [anon_sym_noperspective] = ACTIONS(6264),
    [anon_sym_nointerpolation] = ACTIONS(6264),
    [anon_sym_sample] = ACTIONS(6264),
    [anon_sym_linear] = ACTIONS(6264),
    [anon_sym_snorm] = ACTIONS(6264),
    [anon_sym_unorm] = ACTIONS(6264),
    [anon_sym_point] = ACTIONS(6264),
    [anon_sym_line] = ACTIONS(6264),
    [anon_sym_triangleadj] = ACTIONS(6264),
    [anon_sym_lineadj] = ACTIONS(6264),
    [anon_sym_triangle] = ACTIONS(6264),
    [anon_sym_interface] = ACTIONS(6264),
    [anon_sym_extension] = ACTIONS(6264),
    [anon_sym___init] = ACTIONS(6264),
    [anon_sym___subscript] = ACTIONS(6264),
    [anon_sym_property] = ACTIONS(6264),
    [anon_sym_associatedtype] = ACTIONS(6264),
  },
  [2048] = {
    [sym_identifier] = ACTIONS(6268),
    [aux_sym_preproc_def_token1] = ACTIONS(6268),
    [aux_sym_preproc_if_token1] = ACTIONS(6268),
    [aux_sym_preproc_if_token2] = ACTIONS(6268),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6268),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6268),
    [sym_preproc_directive] = ACTIONS(6268),
    [anon_sym_LPAREN2] = ACTIONS(6270),
    [anon_sym_TILDE] = ACTIONS(6270),
    [anon_sym_STAR] = ACTIONS(6270),
    [anon_sym_AMP_AMP] = ACTIONS(6270),
    [anon_sym_AMP] = ACTIONS(6268),
    [anon_sym_SEMI] = ACTIONS(6270),
    [anon_sym___extension__] = ACTIONS(6268),
    [anon_sym_typedef] = ACTIONS(6268),
    [anon_sym_in] = ACTIONS(6268),
    [anon_sym_out] = ACTIONS(6268),
    [anon_sym_inout] = ACTIONS(6268),
    [anon_sym_virtual] = ACTIONS(6268),
    [anon_sym_extern] = ACTIONS(6268),
    [anon_sym___attribute__] = ACTIONS(6268),
    [anon_sym___attribute] = ACTIONS(6268),
    [anon_sym_using] = ACTIONS(6268),
    [anon_sym_COLON_COLON] = ACTIONS(6270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6270),
    [anon_sym___declspec] = ACTIONS(6268),
    [anon_sym___based] = ACTIONS(6268),
    [anon_sym_signed] = ACTIONS(6268),
    [anon_sym_unsigned] = ACTIONS(6268),
    [anon_sym_long] = ACTIONS(6268),
    [anon_sym_short] = ACTIONS(6268),
    [anon_sym_LBRACK] = ACTIONS(6268),
    [anon_sym_static] = ACTIONS(6268),
    [anon_sym_register] = ACTIONS(6268),
    [anon_sym_inline] = ACTIONS(6268),
    [anon_sym___inline] = ACTIONS(6268),
    [anon_sym___inline__] = ACTIONS(6268),
    [anon_sym___forceinline] = ACTIONS(6268),
    [anon_sym_thread_local] = ACTIONS(6268),
    [anon_sym___thread] = ACTIONS(6268),
    [anon_sym_const] = ACTIONS(6268),
    [anon_sym_constexpr] = ACTIONS(6268),
    [anon_sym_volatile] = ACTIONS(6268),
    [anon_sym_restrict] = ACTIONS(6268),
    [anon_sym___restrict__] = ACTIONS(6268),
    [anon_sym__Atomic] = ACTIONS(6268),
    [anon_sym__Noreturn] = ACTIONS(6268),
    [anon_sym_noreturn] = ACTIONS(6268),
    [anon_sym__Nonnull] = ACTIONS(6268),
    [anon_sym_mutable] = ACTIONS(6268),
    [anon_sym_constinit] = ACTIONS(6268),
    [anon_sym_consteval] = ACTIONS(6268),
    [anon_sym_alignas] = ACTIONS(6268),
    [anon_sym__Alignas] = ACTIONS(6268),
    [sym_primitive_type] = ACTIONS(6268),
    [anon_sym_enum] = ACTIONS(6268),
    [anon_sym_class] = ACTIONS(6268),
    [anon_sym_struct] = ACTIONS(6268),
    [anon_sym_union] = ACTIONS(6268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6268),
    [anon_sym_let] = ACTIONS(6268),
    [anon_sym_This] = ACTIONS(6268),
    [anon_sym_decltype] = ACTIONS(6268),
    [anon_sym_explicit] = ACTIONS(6268),
    [anon_sym_typename] = ACTIONS(6268),
    [anon_sym_private] = ACTIONS(6268),
    [anon_sym_template] = ACTIONS(6268),
    [anon_sym_operator] = ACTIONS(6268),
    [anon_sym_friend] = ACTIONS(6268),
    [anon_sym_public] = ACTIONS(6268),
    [anon_sym_protected] = ACTIONS(6268),
    [anon_sym_static_assert] = ACTIONS(6268),
    [anon_sym_precise] = ACTIONS(6268),
    [anon_sym_shared] = ACTIONS(6268),
    [anon_sym_groupshared] = ACTIONS(6268),
    [anon_sym_uniform] = ACTIONS(6268),
    [anon_sym_row_major] = ACTIONS(6268),
    [anon_sym_column_major] = ACTIONS(6268),
    [anon_sym_globallycoherent] = ACTIONS(6268),
    [anon_sym_centroid] = ACTIONS(6268),
    [anon_sym_noperspective] = ACTIONS(6268),
    [anon_sym_nointerpolation] = ACTIONS(6268),
    [anon_sym_sample] = ACTIONS(6268),
    [anon_sym_linear] = ACTIONS(6268),
    [anon_sym_snorm] = ACTIONS(6268),
    [anon_sym_unorm] = ACTIONS(6268),
    [anon_sym_point] = ACTIONS(6268),
    [anon_sym_line] = ACTIONS(6268),
    [anon_sym_triangleadj] = ACTIONS(6268),
    [anon_sym_lineadj] = ACTIONS(6268),
    [anon_sym_triangle] = ACTIONS(6268),
    [anon_sym_interface] = ACTIONS(6268),
    [anon_sym_extension] = ACTIONS(6268),
    [anon_sym___init] = ACTIONS(6268),
    [anon_sym___subscript] = ACTIONS(6268),
    [anon_sym_property] = ACTIONS(6268),
    [anon_sym_associatedtype] = ACTIONS(6268),
  },
  [2049] = {
    [sym_identifier] = ACTIONS(6278),
    [aux_sym_preproc_def_token1] = ACTIONS(6278),
    [aux_sym_preproc_if_token1] = ACTIONS(6278),
    [aux_sym_preproc_if_token2] = ACTIONS(6278),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6278),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6278),
    [sym_preproc_directive] = ACTIONS(6278),
    [anon_sym_LPAREN2] = ACTIONS(6280),
    [anon_sym_TILDE] = ACTIONS(6280),
    [anon_sym_STAR] = ACTIONS(6280),
    [anon_sym_AMP_AMP] = ACTIONS(6280),
    [anon_sym_AMP] = ACTIONS(6278),
    [anon_sym_SEMI] = ACTIONS(6280),
    [anon_sym___extension__] = ACTIONS(6278),
    [anon_sym_typedef] = ACTIONS(6278),
    [anon_sym_in] = ACTIONS(6278),
    [anon_sym_out] = ACTIONS(6278),
    [anon_sym_inout] = ACTIONS(6278),
    [anon_sym_virtual] = ACTIONS(6278),
    [anon_sym_extern] = ACTIONS(6278),
    [anon_sym___attribute__] = ACTIONS(6278),
    [anon_sym___attribute] = ACTIONS(6278),
    [anon_sym_using] = ACTIONS(6278),
    [anon_sym_COLON_COLON] = ACTIONS(6280),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6280),
    [anon_sym___declspec] = ACTIONS(6278),
    [anon_sym___based] = ACTIONS(6278),
    [anon_sym_signed] = ACTIONS(6278),
    [anon_sym_unsigned] = ACTIONS(6278),
    [anon_sym_long] = ACTIONS(6278),
    [anon_sym_short] = ACTIONS(6278),
    [anon_sym_LBRACK] = ACTIONS(6278),
    [anon_sym_static] = ACTIONS(6278),
    [anon_sym_register] = ACTIONS(6278),
    [anon_sym_inline] = ACTIONS(6278),
    [anon_sym___inline] = ACTIONS(6278),
    [anon_sym___inline__] = ACTIONS(6278),
    [anon_sym___forceinline] = ACTIONS(6278),
    [anon_sym_thread_local] = ACTIONS(6278),
    [anon_sym___thread] = ACTIONS(6278),
    [anon_sym_const] = ACTIONS(6278),
    [anon_sym_constexpr] = ACTIONS(6278),
    [anon_sym_volatile] = ACTIONS(6278),
    [anon_sym_restrict] = ACTIONS(6278),
    [anon_sym___restrict__] = ACTIONS(6278),
    [anon_sym__Atomic] = ACTIONS(6278),
    [anon_sym__Noreturn] = ACTIONS(6278),
    [anon_sym_noreturn] = ACTIONS(6278),
    [anon_sym__Nonnull] = ACTIONS(6278),
    [anon_sym_mutable] = ACTIONS(6278),
    [anon_sym_constinit] = ACTIONS(6278),
    [anon_sym_consteval] = ACTIONS(6278),
    [anon_sym_alignas] = ACTIONS(6278),
    [anon_sym__Alignas] = ACTIONS(6278),
    [sym_primitive_type] = ACTIONS(6278),
    [anon_sym_enum] = ACTIONS(6278),
    [anon_sym_class] = ACTIONS(6278),
    [anon_sym_struct] = ACTIONS(6278),
    [anon_sym_union] = ACTIONS(6278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6278),
    [anon_sym_let] = ACTIONS(6278),
    [anon_sym_This] = ACTIONS(6278),
    [anon_sym_decltype] = ACTIONS(6278),
    [anon_sym_explicit] = ACTIONS(6278),
    [anon_sym_typename] = ACTIONS(6278),
    [anon_sym_private] = ACTIONS(6278),
    [anon_sym_template] = ACTIONS(6278),
    [anon_sym_operator] = ACTIONS(6278),
    [anon_sym_friend] = ACTIONS(6278),
    [anon_sym_public] = ACTIONS(6278),
    [anon_sym_protected] = ACTIONS(6278),
    [anon_sym_static_assert] = ACTIONS(6278),
    [anon_sym_precise] = ACTIONS(6278),
    [anon_sym_shared] = ACTIONS(6278),
    [anon_sym_groupshared] = ACTIONS(6278),
    [anon_sym_uniform] = ACTIONS(6278),
    [anon_sym_row_major] = ACTIONS(6278),
    [anon_sym_column_major] = ACTIONS(6278),
    [anon_sym_globallycoherent] = ACTIONS(6278),
    [anon_sym_centroid] = ACTIONS(6278),
    [anon_sym_noperspective] = ACTIONS(6278),
    [anon_sym_nointerpolation] = ACTIONS(6278),
    [anon_sym_sample] = ACTIONS(6278),
    [anon_sym_linear] = ACTIONS(6278),
    [anon_sym_snorm] = ACTIONS(6278),
    [anon_sym_unorm] = ACTIONS(6278),
    [anon_sym_point] = ACTIONS(6278),
    [anon_sym_line] = ACTIONS(6278),
    [anon_sym_triangleadj] = ACTIONS(6278),
    [anon_sym_lineadj] = ACTIONS(6278),
    [anon_sym_triangle] = ACTIONS(6278),
    [anon_sym_interface] = ACTIONS(6278),
    [anon_sym_extension] = ACTIONS(6278),
    [anon_sym___init] = ACTIONS(6278),
    [anon_sym___subscript] = ACTIONS(6278),
    [anon_sym_property] = ACTIONS(6278),
    [anon_sym_associatedtype] = ACTIONS(6278),
  },
  [2050] = {
    [sym_identifier] = ACTIONS(6294),
    [aux_sym_preproc_def_token1] = ACTIONS(6294),
    [aux_sym_preproc_if_token1] = ACTIONS(6294),
    [aux_sym_preproc_if_token2] = ACTIONS(6294),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6294),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6294),
    [sym_preproc_directive] = ACTIONS(6294),
    [anon_sym_LPAREN2] = ACTIONS(6296),
    [anon_sym_TILDE] = ACTIONS(6296),
    [anon_sym_STAR] = ACTIONS(6296),
    [anon_sym_AMP_AMP] = ACTIONS(6296),
    [anon_sym_AMP] = ACTIONS(6294),
    [anon_sym_SEMI] = ACTIONS(6296),
    [anon_sym___extension__] = ACTIONS(6294),
    [anon_sym_typedef] = ACTIONS(6294),
    [anon_sym_in] = ACTIONS(6294),
    [anon_sym_out] = ACTIONS(6294),
    [anon_sym_inout] = ACTIONS(6294),
    [anon_sym_virtual] = ACTIONS(6294),
    [anon_sym_extern] = ACTIONS(6294),
    [anon_sym___attribute__] = ACTIONS(6294),
    [anon_sym___attribute] = ACTIONS(6294),
    [anon_sym_using] = ACTIONS(6294),
    [anon_sym_COLON_COLON] = ACTIONS(6296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6296),
    [anon_sym___declspec] = ACTIONS(6294),
    [anon_sym___based] = ACTIONS(6294),
    [anon_sym_signed] = ACTIONS(6294),
    [anon_sym_unsigned] = ACTIONS(6294),
    [anon_sym_long] = ACTIONS(6294),
    [anon_sym_short] = ACTIONS(6294),
    [anon_sym_LBRACK] = ACTIONS(6294),
    [anon_sym_static] = ACTIONS(6294),
    [anon_sym_register] = ACTIONS(6294),
    [anon_sym_inline] = ACTIONS(6294),
    [anon_sym___inline] = ACTIONS(6294),
    [anon_sym___inline__] = ACTIONS(6294),
    [anon_sym___forceinline] = ACTIONS(6294),
    [anon_sym_thread_local] = ACTIONS(6294),
    [anon_sym___thread] = ACTIONS(6294),
    [anon_sym_const] = ACTIONS(6294),
    [anon_sym_constexpr] = ACTIONS(6294),
    [anon_sym_volatile] = ACTIONS(6294),
    [anon_sym_restrict] = ACTIONS(6294),
    [anon_sym___restrict__] = ACTIONS(6294),
    [anon_sym__Atomic] = ACTIONS(6294),
    [anon_sym__Noreturn] = ACTIONS(6294),
    [anon_sym_noreturn] = ACTIONS(6294),
    [anon_sym__Nonnull] = ACTIONS(6294),
    [anon_sym_mutable] = ACTIONS(6294),
    [anon_sym_constinit] = ACTIONS(6294),
    [anon_sym_consteval] = ACTIONS(6294),
    [anon_sym_alignas] = ACTIONS(6294),
    [anon_sym__Alignas] = ACTIONS(6294),
    [sym_primitive_type] = ACTIONS(6294),
    [anon_sym_enum] = ACTIONS(6294),
    [anon_sym_class] = ACTIONS(6294),
    [anon_sym_struct] = ACTIONS(6294),
    [anon_sym_union] = ACTIONS(6294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6294),
    [anon_sym_let] = ACTIONS(6294),
    [anon_sym_This] = ACTIONS(6294),
    [anon_sym_decltype] = ACTIONS(6294),
    [anon_sym_explicit] = ACTIONS(6294),
    [anon_sym_typename] = ACTIONS(6294),
    [anon_sym_private] = ACTIONS(6294),
    [anon_sym_template] = ACTIONS(6294),
    [anon_sym_operator] = ACTIONS(6294),
    [anon_sym_friend] = ACTIONS(6294),
    [anon_sym_public] = ACTIONS(6294),
    [anon_sym_protected] = ACTIONS(6294),
    [anon_sym_static_assert] = ACTIONS(6294),
    [anon_sym_precise] = ACTIONS(6294),
    [anon_sym_shared] = ACTIONS(6294),
    [anon_sym_groupshared] = ACTIONS(6294),
    [anon_sym_uniform] = ACTIONS(6294),
    [anon_sym_row_major] = ACTIONS(6294),
    [anon_sym_column_major] = ACTIONS(6294),
    [anon_sym_globallycoherent] = ACTIONS(6294),
    [anon_sym_centroid] = ACTIONS(6294),
    [anon_sym_noperspective] = ACTIONS(6294),
    [anon_sym_nointerpolation] = ACTIONS(6294),
    [anon_sym_sample] = ACTIONS(6294),
    [anon_sym_linear] = ACTIONS(6294),
    [anon_sym_snorm] = ACTIONS(6294),
    [anon_sym_unorm] = ACTIONS(6294),
    [anon_sym_point] = ACTIONS(6294),
    [anon_sym_line] = ACTIONS(6294),
    [anon_sym_triangleadj] = ACTIONS(6294),
    [anon_sym_lineadj] = ACTIONS(6294),
    [anon_sym_triangle] = ACTIONS(6294),
    [anon_sym_interface] = ACTIONS(6294),
    [anon_sym_extension] = ACTIONS(6294),
    [anon_sym___init] = ACTIONS(6294),
    [anon_sym___subscript] = ACTIONS(6294),
    [anon_sym_property] = ACTIONS(6294),
    [anon_sym_associatedtype] = ACTIONS(6294),
  },
  [2051] = {
    [sym_identifier] = ACTIONS(6306),
    [aux_sym_preproc_def_token1] = ACTIONS(6306),
    [aux_sym_preproc_if_token1] = ACTIONS(6306),
    [aux_sym_preproc_if_token2] = ACTIONS(6306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6306),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6306),
    [sym_preproc_directive] = ACTIONS(6306),
    [anon_sym_LPAREN2] = ACTIONS(6308),
    [anon_sym_TILDE] = ACTIONS(6308),
    [anon_sym_STAR] = ACTIONS(6308),
    [anon_sym_AMP_AMP] = ACTIONS(6308),
    [anon_sym_AMP] = ACTIONS(6306),
    [anon_sym_SEMI] = ACTIONS(6308),
    [anon_sym___extension__] = ACTIONS(6306),
    [anon_sym_typedef] = ACTIONS(6306),
    [anon_sym_in] = ACTIONS(6306),
    [anon_sym_out] = ACTIONS(6306),
    [anon_sym_inout] = ACTIONS(6306),
    [anon_sym_virtual] = ACTIONS(6306),
    [anon_sym_extern] = ACTIONS(6306),
    [anon_sym___attribute__] = ACTIONS(6306),
    [anon_sym___attribute] = ACTIONS(6306),
    [anon_sym_using] = ACTIONS(6306),
    [anon_sym_COLON_COLON] = ACTIONS(6308),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6308),
    [anon_sym___declspec] = ACTIONS(6306),
    [anon_sym___based] = ACTIONS(6306),
    [anon_sym_signed] = ACTIONS(6306),
    [anon_sym_unsigned] = ACTIONS(6306),
    [anon_sym_long] = ACTIONS(6306),
    [anon_sym_short] = ACTIONS(6306),
    [anon_sym_LBRACK] = ACTIONS(6306),
    [anon_sym_static] = ACTIONS(6306),
    [anon_sym_register] = ACTIONS(6306),
    [anon_sym_inline] = ACTIONS(6306),
    [anon_sym___inline] = ACTIONS(6306),
    [anon_sym___inline__] = ACTIONS(6306),
    [anon_sym___forceinline] = ACTIONS(6306),
    [anon_sym_thread_local] = ACTIONS(6306),
    [anon_sym___thread] = ACTIONS(6306),
    [anon_sym_const] = ACTIONS(6306),
    [anon_sym_constexpr] = ACTIONS(6306),
    [anon_sym_volatile] = ACTIONS(6306),
    [anon_sym_restrict] = ACTIONS(6306),
    [anon_sym___restrict__] = ACTIONS(6306),
    [anon_sym__Atomic] = ACTIONS(6306),
    [anon_sym__Noreturn] = ACTIONS(6306),
    [anon_sym_noreturn] = ACTIONS(6306),
    [anon_sym__Nonnull] = ACTIONS(6306),
    [anon_sym_mutable] = ACTIONS(6306),
    [anon_sym_constinit] = ACTIONS(6306),
    [anon_sym_consteval] = ACTIONS(6306),
    [anon_sym_alignas] = ACTIONS(6306),
    [anon_sym__Alignas] = ACTIONS(6306),
    [sym_primitive_type] = ACTIONS(6306),
    [anon_sym_enum] = ACTIONS(6306),
    [anon_sym_class] = ACTIONS(6306),
    [anon_sym_struct] = ACTIONS(6306),
    [anon_sym_union] = ACTIONS(6306),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6306),
    [anon_sym_let] = ACTIONS(6306),
    [anon_sym_This] = ACTIONS(6306),
    [anon_sym_decltype] = ACTIONS(6306),
    [anon_sym_explicit] = ACTIONS(6306),
    [anon_sym_typename] = ACTIONS(6306),
    [anon_sym_private] = ACTIONS(6306),
    [anon_sym_template] = ACTIONS(6306),
    [anon_sym_operator] = ACTIONS(6306),
    [anon_sym_friend] = ACTIONS(6306),
    [anon_sym_public] = ACTIONS(6306),
    [anon_sym_protected] = ACTIONS(6306),
    [anon_sym_static_assert] = ACTIONS(6306),
    [anon_sym_precise] = ACTIONS(6306),
    [anon_sym_shared] = ACTIONS(6306),
    [anon_sym_groupshared] = ACTIONS(6306),
    [anon_sym_uniform] = ACTIONS(6306),
    [anon_sym_row_major] = ACTIONS(6306),
    [anon_sym_column_major] = ACTIONS(6306),
    [anon_sym_globallycoherent] = ACTIONS(6306),
    [anon_sym_centroid] = ACTIONS(6306),
    [anon_sym_noperspective] = ACTIONS(6306),
    [anon_sym_nointerpolation] = ACTIONS(6306),
    [anon_sym_sample] = ACTIONS(6306),
    [anon_sym_linear] = ACTIONS(6306),
    [anon_sym_snorm] = ACTIONS(6306),
    [anon_sym_unorm] = ACTIONS(6306),
    [anon_sym_point] = ACTIONS(6306),
    [anon_sym_line] = ACTIONS(6306),
    [anon_sym_triangleadj] = ACTIONS(6306),
    [anon_sym_lineadj] = ACTIONS(6306),
    [anon_sym_triangle] = ACTIONS(6306),
    [anon_sym_interface] = ACTIONS(6306),
    [anon_sym_extension] = ACTIONS(6306),
    [anon_sym___init] = ACTIONS(6306),
    [anon_sym___subscript] = ACTIONS(6306),
    [anon_sym_property] = ACTIONS(6306),
    [anon_sym_associatedtype] = ACTIONS(6306),
  },
  [2052] = {
    [sym_identifier] = ACTIONS(6310),
    [aux_sym_preproc_def_token1] = ACTIONS(6310),
    [aux_sym_preproc_if_token1] = ACTIONS(6310),
    [aux_sym_preproc_if_token2] = ACTIONS(6310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6310),
    [sym_preproc_directive] = ACTIONS(6310),
    [anon_sym_LPAREN2] = ACTIONS(6312),
    [anon_sym_TILDE] = ACTIONS(6312),
    [anon_sym_STAR] = ACTIONS(6312),
    [anon_sym_AMP_AMP] = ACTIONS(6312),
    [anon_sym_AMP] = ACTIONS(6310),
    [anon_sym_SEMI] = ACTIONS(6312),
    [anon_sym___extension__] = ACTIONS(6310),
    [anon_sym_typedef] = ACTIONS(6310),
    [anon_sym_in] = ACTIONS(6310),
    [anon_sym_out] = ACTIONS(6310),
    [anon_sym_inout] = ACTIONS(6310),
    [anon_sym_virtual] = ACTIONS(6310),
    [anon_sym_extern] = ACTIONS(6310),
    [anon_sym___attribute__] = ACTIONS(6310),
    [anon_sym___attribute] = ACTIONS(6310),
    [anon_sym_using] = ACTIONS(6310),
    [anon_sym_COLON_COLON] = ACTIONS(6312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6312),
    [anon_sym___declspec] = ACTIONS(6310),
    [anon_sym___based] = ACTIONS(6310),
    [anon_sym_signed] = ACTIONS(6310),
    [anon_sym_unsigned] = ACTIONS(6310),
    [anon_sym_long] = ACTIONS(6310),
    [anon_sym_short] = ACTIONS(6310),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_static] = ACTIONS(6310),
    [anon_sym_register] = ACTIONS(6310),
    [anon_sym_inline] = ACTIONS(6310),
    [anon_sym___inline] = ACTIONS(6310),
    [anon_sym___inline__] = ACTIONS(6310),
    [anon_sym___forceinline] = ACTIONS(6310),
    [anon_sym_thread_local] = ACTIONS(6310),
    [anon_sym___thread] = ACTIONS(6310),
    [anon_sym_const] = ACTIONS(6310),
    [anon_sym_constexpr] = ACTIONS(6310),
    [anon_sym_volatile] = ACTIONS(6310),
    [anon_sym_restrict] = ACTIONS(6310),
    [anon_sym___restrict__] = ACTIONS(6310),
    [anon_sym__Atomic] = ACTIONS(6310),
    [anon_sym__Noreturn] = ACTIONS(6310),
    [anon_sym_noreturn] = ACTIONS(6310),
    [anon_sym__Nonnull] = ACTIONS(6310),
    [anon_sym_mutable] = ACTIONS(6310),
    [anon_sym_constinit] = ACTIONS(6310),
    [anon_sym_consteval] = ACTIONS(6310),
    [anon_sym_alignas] = ACTIONS(6310),
    [anon_sym__Alignas] = ACTIONS(6310),
    [sym_primitive_type] = ACTIONS(6310),
    [anon_sym_enum] = ACTIONS(6310),
    [anon_sym_class] = ACTIONS(6310),
    [anon_sym_struct] = ACTIONS(6310),
    [anon_sym_union] = ACTIONS(6310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6310),
    [anon_sym_let] = ACTIONS(6310),
    [anon_sym_This] = ACTIONS(6310),
    [anon_sym_decltype] = ACTIONS(6310),
    [anon_sym_explicit] = ACTIONS(6310),
    [anon_sym_typename] = ACTIONS(6310),
    [anon_sym_private] = ACTIONS(6310),
    [anon_sym_template] = ACTIONS(6310),
    [anon_sym_operator] = ACTIONS(6310),
    [anon_sym_friend] = ACTIONS(6310),
    [anon_sym_public] = ACTIONS(6310),
    [anon_sym_protected] = ACTIONS(6310),
    [anon_sym_static_assert] = ACTIONS(6310),
    [anon_sym_precise] = ACTIONS(6310),
    [anon_sym_shared] = ACTIONS(6310),
    [anon_sym_groupshared] = ACTIONS(6310),
    [anon_sym_uniform] = ACTIONS(6310),
    [anon_sym_row_major] = ACTIONS(6310),
    [anon_sym_column_major] = ACTIONS(6310),
    [anon_sym_globallycoherent] = ACTIONS(6310),
    [anon_sym_centroid] = ACTIONS(6310),
    [anon_sym_noperspective] = ACTIONS(6310),
    [anon_sym_nointerpolation] = ACTIONS(6310),
    [anon_sym_sample] = ACTIONS(6310),
    [anon_sym_linear] = ACTIONS(6310),
    [anon_sym_snorm] = ACTIONS(6310),
    [anon_sym_unorm] = ACTIONS(6310),
    [anon_sym_point] = ACTIONS(6310),
    [anon_sym_line] = ACTIONS(6310),
    [anon_sym_triangleadj] = ACTIONS(6310),
    [anon_sym_lineadj] = ACTIONS(6310),
    [anon_sym_triangle] = ACTIONS(6310),
    [anon_sym_interface] = ACTIONS(6310),
    [anon_sym_extension] = ACTIONS(6310),
    [anon_sym___init] = ACTIONS(6310),
    [anon_sym___subscript] = ACTIONS(6310),
    [anon_sym_property] = ACTIONS(6310),
    [anon_sym_associatedtype] = ACTIONS(6310),
  },
  [2053] = {
    [sym_identifier] = ACTIONS(6310),
    [aux_sym_preproc_def_token1] = ACTIONS(6310),
    [aux_sym_preproc_if_token1] = ACTIONS(6310),
    [aux_sym_preproc_if_token2] = ACTIONS(6310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6310),
    [sym_preproc_directive] = ACTIONS(6310),
    [anon_sym_LPAREN2] = ACTIONS(6312),
    [anon_sym_TILDE] = ACTIONS(6312),
    [anon_sym_STAR] = ACTIONS(6312),
    [anon_sym_AMP_AMP] = ACTIONS(6312),
    [anon_sym_AMP] = ACTIONS(6310),
    [anon_sym_SEMI] = ACTIONS(6312),
    [anon_sym___extension__] = ACTIONS(6310),
    [anon_sym_typedef] = ACTIONS(6310),
    [anon_sym_in] = ACTIONS(6310),
    [anon_sym_out] = ACTIONS(6310),
    [anon_sym_inout] = ACTIONS(6310),
    [anon_sym_virtual] = ACTIONS(6310),
    [anon_sym_extern] = ACTIONS(6310),
    [anon_sym___attribute__] = ACTIONS(6310),
    [anon_sym___attribute] = ACTIONS(6310),
    [anon_sym_using] = ACTIONS(6310),
    [anon_sym_COLON_COLON] = ACTIONS(6312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6312),
    [anon_sym___declspec] = ACTIONS(6310),
    [anon_sym___based] = ACTIONS(6310),
    [anon_sym_signed] = ACTIONS(6310),
    [anon_sym_unsigned] = ACTIONS(6310),
    [anon_sym_long] = ACTIONS(6310),
    [anon_sym_short] = ACTIONS(6310),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_static] = ACTIONS(6310),
    [anon_sym_register] = ACTIONS(6310),
    [anon_sym_inline] = ACTIONS(6310),
    [anon_sym___inline] = ACTIONS(6310),
    [anon_sym___inline__] = ACTIONS(6310),
    [anon_sym___forceinline] = ACTIONS(6310),
    [anon_sym_thread_local] = ACTIONS(6310),
    [anon_sym___thread] = ACTIONS(6310),
    [anon_sym_const] = ACTIONS(6310),
    [anon_sym_constexpr] = ACTIONS(6310),
    [anon_sym_volatile] = ACTIONS(6310),
    [anon_sym_restrict] = ACTIONS(6310),
    [anon_sym___restrict__] = ACTIONS(6310),
    [anon_sym__Atomic] = ACTIONS(6310),
    [anon_sym__Noreturn] = ACTIONS(6310),
    [anon_sym_noreturn] = ACTIONS(6310),
    [anon_sym__Nonnull] = ACTIONS(6310),
    [anon_sym_mutable] = ACTIONS(6310),
    [anon_sym_constinit] = ACTIONS(6310),
    [anon_sym_consteval] = ACTIONS(6310),
    [anon_sym_alignas] = ACTIONS(6310),
    [anon_sym__Alignas] = ACTIONS(6310),
    [sym_primitive_type] = ACTIONS(6310),
    [anon_sym_enum] = ACTIONS(6310),
    [anon_sym_class] = ACTIONS(6310),
    [anon_sym_struct] = ACTIONS(6310),
    [anon_sym_union] = ACTIONS(6310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6310),
    [anon_sym_let] = ACTIONS(6310),
    [anon_sym_This] = ACTIONS(6310),
    [anon_sym_decltype] = ACTIONS(6310),
    [anon_sym_explicit] = ACTIONS(6310),
    [anon_sym_typename] = ACTIONS(6310),
    [anon_sym_private] = ACTIONS(6310),
    [anon_sym_template] = ACTIONS(6310),
    [anon_sym_operator] = ACTIONS(6310),
    [anon_sym_friend] = ACTIONS(6310),
    [anon_sym_public] = ACTIONS(6310),
    [anon_sym_protected] = ACTIONS(6310),
    [anon_sym_static_assert] = ACTIONS(6310),
    [anon_sym_precise] = ACTIONS(6310),
    [anon_sym_shared] = ACTIONS(6310),
    [anon_sym_groupshared] = ACTIONS(6310),
    [anon_sym_uniform] = ACTIONS(6310),
    [anon_sym_row_major] = ACTIONS(6310),
    [anon_sym_column_major] = ACTIONS(6310),
    [anon_sym_globallycoherent] = ACTIONS(6310),
    [anon_sym_centroid] = ACTIONS(6310),
    [anon_sym_noperspective] = ACTIONS(6310),
    [anon_sym_nointerpolation] = ACTIONS(6310),
    [anon_sym_sample] = ACTIONS(6310),
    [anon_sym_linear] = ACTIONS(6310),
    [anon_sym_snorm] = ACTIONS(6310),
    [anon_sym_unorm] = ACTIONS(6310),
    [anon_sym_point] = ACTIONS(6310),
    [anon_sym_line] = ACTIONS(6310),
    [anon_sym_triangleadj] = ACTIONS(6310),
    [anon_sym_lineadj] = ACTIONS(6310),
    [anon_sym_triangle] = ACTIONS(6310),
    [anon_sym_interface] = ACTIONS(6310),
    [anon_sym_extension] = ACTIONS(6310),
    [anon_sym___init] = ACTIONS(6310),
    [anon_sym___subscript] = ACTIONS(6310),
    [anon_sym_property] = ACTIONS(6310),
    [anon_sym_associatedtype] = ACTIONS(6310),
  },
  [2054] = {
    [sym_expression] = STATE(5679),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(6658),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2055] = {
    [sym_expression] = STATE(5766),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2056] = {
    [sym_identifier] = ACTIONS(3967),
    [aux_sym_preproc_def_token1] = ACTIONS(3967),
    [aux_sym_preproc_if_token1] = ACTIONS(3967),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3967),
    [sym_preproc_directive] = ACTIONS(3967),
    [anon_sym_LPAREN2] = ACTIONS(3969),
    [anon_sym_TILDE] = ACTIONS(3969),
    [anon_sym_STAR] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_AMP] = ACTIONS(3967),
    [anon_sym_SEMI] = ACTIONS(3969),
    [anon_sym___extension__] = ACTIONS(3967),
    [anon_sym_typedef] = ACTIONS(3967),
    [anon_sym_in] = ACTIONS(3967),
    [anon_sym_out] = ACTIONS(3967),
    [anon_sym_inout] = ACTIONS(3967),
    [anon_sym_virtual] = ACTIONS(3967),
    [anon_sym_extern] = ACTIONS(3967),
    [anon_sym___attribute__] = ACTIONS(3967),
    [anon_sym___attribute] = ACTIONS(3967),
    [anon_sym_using] = ACTIONS(3967),
    [anon_sym_COLON_COLON] = ACTIONS(3969),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3969),
    [anon_sym___declspec] = ACTIONS(3967),
    [anon_sym___based] = ACTIONS(3967),
    [anon_sym_RBRACE] = ACTIONS(3969),
    [anon_sym_signed] = ACTIONS(3967),
    [anon_sym_unsigned] = ACTIONS(3967),
    [anon_sym_long] = ACTIONS(3967),
    [anon_sym_short] = ACTIONS(3967),
    [anon_sym_LBRACK] = ACTIONS(3967),
    [anon_sym_static] = ACTIONS(3967),
    [anon_sym_register] = ACTIONS(3967),
    [anon_sym_inline] = ACTIONS(3967),
    [anon_sym___inline] = ACTIONS(3967),
    [anon_sym___inline__] = ACTIONS(3967),
    [anon_sym___forceinline] = ACTIONS(3967),
    [anon_sym_thread_local] = ACTIONS(3967),
    [anon_sym___thread] = ACTIONS(3967),
    [anon_sym_const] = ACTIONS(3967),
    [anon_sym_constexpr] = ACTIONS(3967),
    [anon_sym_volatile] = ACTIONS(3967),
    [anon_sym_restrict] = ACTIONS(3967),
    [anon_sym___restrict__] = ACTIONS(3967),
    [anon_sym__Atomic] = ACTIONS(3967),
    [anon_sym__Noreturn] = ACTIONS(3967),
    [anon_sym_noreturn] = ACTIONS(3967),
    [anon_sym__Nonnull] = ACTIONS(3967),
    [anon_sym_mutable] = ACTIONS(3967),
    [anon_sym_constinit] = ACTIONS(3967),
    [anon_sym_consteval] = ACTIONS(3967),
    [anon_sym_alignas] = ACTIONS(3967),
    [anon_sym__Alignas] = ACTIONS(3967),
    [sym_primitive_type] = ACTIONS(3967),
    [anon_sym_enum] = ACTIONS(3967),
    [anon_sym_class] = ACTIONS(3967),
    [anon_sym_struct] = ACTIONS(3967),
    [anon_sym_union] = ACTIONS(3967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3967),
    [anon_sym_let] = ACTIONS(3967),
    [anon_sym_This] = ACTIONS(3967),
    [anon_sym_decltype] = ACTIONS(3967),
    [anon_sym_explicit] = ACTIONS(3967),
    [anon_sym_typename] = ACTIONS(3967),
    [anon_sym_private] = ACTIONS(3967),
    [anon_sym_template] = ACTIONS(3967),
    [anon_sym_operator] = ACTIONS(3967),
    [anon_sym_friend] = ACTIONS(3967),
    [anon_sym_public] = ACTIONS(3967),
    [anon_sym_protected] = ACTIONS(3967),
    [anon_sym_static_assert] = ACTIONS(3967),
    [anon_sym_precise] = ACTIONS(3967),
    [anon_sym_shared] = ACTIONS(3967),
    [anon_sym_groupshared] = ACTIONS(3967),
    [anon_sym_uniform] = ACTIONS(3967),
    [anon_sym_row_major] = ACTIONS(3967),
    [anon_sym_column_major] = ACTIONS(3967),
    [anon_sym_globallycoherent] = ACTIONS(3967),
    [anon_sym_centroid] = ACTIONS(3967),
    [anon_sym_noperspective] = ACTIONS(3967),
    [anon_sym_nointerpolation] = ACTIONS(3967),
    [anon_sym_sample] = ACTIONS(3967),
    [anon_sym_linear] = ACTIONS(3967),
    [anon_sym_snorm] = ACTIONS(3967),
    [anon_sym_unorm] = ACTIONS(3967),
    [anon_sym_point] = ACTIONS(3967),
    [anon_sym_line] = ACTIONS(3967),
    [anon_sym_triangleadj] = ACTIONS(3967),
    [anon_sym_lineadj] = ACTIONS(3967),
    [anon_sym_triangle] = ACTIONS(3967),
    [anon_sym_interface] = ACTIONS(3967),
    [anon_sym_extension] = ACTIONS(3967),
    [anon_sym___init] = ACTIONS(3967),
    [anon_sym___subscript] = ACTIONS(3967),
    [anon_sym_property] = ACTIONS(3967),
    [anon_sym_associatedtype] = ACTIONS(3967),
  },
  [2057] = {
    [sym_expression] = STATE(4754),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [2058] = {
    [sym_expression] = STATE(5674),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(6660),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2059] = {
    [sym_expression] = STATE(5918),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2060] = {
    [sym_expression] = STATE(5512),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2061] = {
    [sym_identifier] = ACTIONS(6290),
    [aux_sym_preproc_def_token1] = ACTIONS(6290),
    [aux_sym_preproc_if_token1] = ACTIONS(6290),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6290),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6290),
    [sym_preproc_directive] = ACTIONS(6290),
    [anon_sym_LPAREN2] = ACTIONS(6292),
    [anon_sym_TILDE] = ACTIONS(6292),
    [anon_sym_STAR] = ACTIONS(6292),
    [anon_sym_AMP_AMP] = ACTIONS(6292),
    [anon_sym_AMP] = ACTIONS(6290),
    [anon_sym_SEMI] = ACTIONS(6292),
    [anon_sym___extension__] = ACTIONS(6290),
    [anon_sym_typedef] = ACTIONS(6290),
    [anon_sym_in] = ACTIONS(6290),
    [anon_sym_out] = ACTIONS(6290),
    [anon_sym_inout] = ACTIONS(6290),
    [anon_sym_virtual] = ACTIONS(6290),
    [anon_sym_extern] = ACTIONS(6290),
    [anon_sym___attribute__] = ACTIONS(6290),
    [anon_sym___attribute] = ACTIONS(6290),
    [anon_sym_using] = ACTIONS(6290),
    [anon_sym_COLON_COLON] = ACTIONS(6292),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6292),
    [anon_sym___declspec] = ACTIONS(6290),
    [anon_sym___based] = ACTIONS(6290),
    [anon_sym_RBRACE] = ACTIONS(6292),
    [anon_sym_signed] = ACTIONS(6290),
    [anon_sym_unsigned] = ACTIONS(6290),
    [anon_sym_long] = ACTIONS(6290),
    [anon_sym_short] = ACTIONS(6290),
    [anon_sym_LBRACK] = ACTIONS(6290),
    [anon_sym_static] = ACTIONS(6290),
    [anon_sym_register] = ACTIONS(6290),
    [anon_sym_inline] = ACTIONS(6290),
    [anon_sym___inline] = ACTIONS(6290),
    [anon_sym___inline__] = ACTIONS(6290),
    [anon_sym___forceinline] = ACTIONS(6290),
    [anon_sym_thread_local] = ACTIONS(6290),
    [anon_sym___thread] = ACTIONS(6290),
    [anon_sym_const] = ACTIONS(6290),
    [anon_sym_constexpr] = ACTIONS(6290),
    [anon_sym_volatile] = ACTIONS(6290),
    [anon_sym_restrict] = ACTIONS(6290),
    [anon_sym___restrict__] = ACTIONS(6290),
    [anon_sym__Atomic] = ACTIONS(6290),
    [anon_sym__Noreturn] = ACTIONS(6290),
    [anon_sym_noreturn] = ACTIONS(6290),
    [anon_sym__Nonnull] = ACTIONS(6290),
    [anon_sym_mutable] = ACTIONS(6290),
    [anon_sym_constinit] = ACTIONS(6290),
    [anon_sym_consteval] = ACTIONS(6290),
    [anon_sym_alignas] = ACTIONS(6290),
    [anon_sym__Alignas] = ACTIONS(6290),
    [sym_primitive_type] = ACTIONS(6290),
    [anon_sym_enum] = ACTIONS(6290),
    [anon_sym_class] = ACTIONS(6290),
    [anon_sym_struct] = ACTIONS(6290),
    [anon_sym_union] = ACTIONS(6290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6290),
    [anon_sym_let] = ACTIONS(6290),
    [anon_sym_This] = ACTIONS(6290),
    [anon_sym_decltype] = ACTIONS(6290),
    [anon_sym_explicit] = ACTIONS(6290),
    [anon_sym_typename] = ACTIONS(6290),
    [anon_sym_private] = ACTIONS(6290),
    [anon_sym_template] = ACTIONS(6290),
    [anon_sym_operator] = ACTIONS(6290),
    [anon_sym_friend] = ACTIONS(6290),
    [anon_sym_public] = ACTIONS(6290),
    [anon_sym_protected] = ACTIONS(6290),
    [anon_sym_static_assert] = ACTIONS(6290),
    [anon_sym_precise] = ACTIONS(6290),
    [anon_sym_shared] = ACTIONS(6290),
    [anon_sym_groupshared] = ACTIONS(6290),
    [anon_sym_uniform] = ACTIONS(6290),
    [anon_sym_row_major] = ACTIONS(6290),
    [anon_sym_column_major] = ACTIONS(6290),
    [anon_sym_globallycoherent] = ACTIONS(6290),
    [anon_sym_centroid] = ACTIONS(6290),
    [anon_sym_noperspective] = ACTIONS(6290),
    [anon_sym_nointerpolation] = ACTIONS(6290),
    [anon_sym_sample] = ACTIONS(6290),
    [anon_sym_linear] = ACTIONS(6290),
    [anon_sym_snorm] = ACTIONS(6290),
    [anon_sym_unorm] = ACTIONS(6290),
    [anon_sym_point] = ACTIONS(6290),
    [anon_sym_line] = ACTIONS(6290),
    [anon_sym_triangleadj] = ACTIONS(6290),
    [anon_sym_lineadj] = ACTIONS(6290),
    [anon_sym_triangle] = ACTIONS(6290),
    [anon_sym_interface] = ACTIONS(6290),
    [anon_sym_extension] = ACTIONS(6290),
    [anon_sym___init] = ACTIONS(6290),
    [anon_sym___subscript] = ACTIONS(6290),
    [anon_sym_property] = ACTIONS(6290),
    [anon_sym_associatedtype] = ACTIONS(6290),
  },
  [2062] = {
    [sym_identifier] = ACTIONS(3661),
    [aux_sym_preproc_def_token1] = ACTIONS(3661),
    [aux_sym_preproc_if_token1] = ACTIONS(3661),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3661),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3661),
    [sym_preproc_directive] = ACTIONS(3661),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_TILDE] = ACTIONS(3663),
    [anon_sym_STAR] = ACTIONS(3663),
    [anon_sym_AMP_AMP] = ACTIONS(3663),
    [anon_sym_AMP] = ACTIONS(3661),
    [anon_sym_SEMI] = ACTIONS(3663),
    [anon_sym___extension__] = ACTIONS(3661),
    [anon_sym_typedef] = ACTIONS(3661),
    [anon_sym_in] = ACTIONS(3661),
    [anon_sym_out] = ACTIONS(3661),
    [anon_sym_inout] = ACTIONS(3661),
    [anon_sym_virtual] = ACTIONS(3661),
    [anon_sym_extern] = ACTIONS(3661),
    [anon_sym___attribute__] = ACTIONS(3661),
    [anon_sym___attribute] = ACTIONS(3661),
    [anon_sym_using] = ACTIONS(3661),
    [anon_sym_COLON_COLON] = ACTIONS(3663),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3663),
    [anon_sym___declspec] = ACTIONS(3661),
    [anon_sym___based] = ACTIONS(3661),
    [anon_sym_RBRACE] = ACTIONS(3663),
    [anon_sym_signed] = ACTIONS(3661),
    [anon_sym_unsigned] = ACTIONS(3661),
    [anon_sym_long] = ACTIONS(3661),
    [anon_sym_short] = ACTIONS(3661),
    [anon_sym_LBRACK] = ACTIONS(3661),
    [anon_sym_static] = ACTIONS(3661),
    [anon_sym_register] = ACTIONS(3661),
    [anon_sym_inline] = ACTIONS(3661),
    [anon_sym___inline] = ACTIONS(3661),
    [anon_sym___inline__] = ACTIONS(3661),
    [anon_sym___forceinline] = ACTIONS(3661),
    [anon_sym_thread_local] = ACTIONS(3661),
    [anon_sym___thread] = ACTIONS(3661),
    [anon_sym_const] = ACTIONS(3661),
    [anon_sym_constexpr] = ACTIONS(3661),
    [anon_sym_volatile] = ACTIONS(3661),
    [anon_sym_restrict] = ACTIONS(3661),
    [anon_sym___restrict__] = ACTIONS(3661),
    [anon_sym__Atomic] = ACTIONS(3661),
    [anon_sym__Noreturn] = ACTIONS(3661),
    [anon_sym_noreturn] = ACTIONS(3661),
    [anon_sym__Nonnull] = ACTIONS(3661),
    [anon_sym_mutable] = ACTIONS(3661),
    [anon_sym_constinit] = ACTIONS(3661),
    [anon_sym_consteval] = ACTIONS(3661),
    [anon_sym_alignas] = ACTIONS(3661),
    [anon_sym__Alignas] = ACTIONS(3661),
    [sym_primitive_type] = ACTIONS(3661),
    [anon_sym_enum] = ACTIONS(3661),
    [anon_sym_class] = ACTIONS(3661),
    [anon_sym_struct] = ACTIONS(3661),
    [anon_sym_union] = ACTIONS(3661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3661),
    [anon_sym_let] = ACTIONS(3661),
    [anon_sym_This] = ACTIONS(3661),
    [anon_sym_decltype] = ACTIONS(3661),
    [anon_sym_explicit] = ACTIONS(3661),
    [anon_sym_typename] = ACTIONS(3661),
    [anon_sym_private] = ACTIONS(3661),
    [anon_sym_template] = ACTIONS(3661),
    [anon_sym_operator] = ACTIONS(3661),
    [anon_sym_friend] = ACTIONS(3661),
    [anon_sym_public] = ACTIONS(3661),
    [anon_sym_protected] = ACTIONS(3661),
    [anon_sym_static_assert] = ACTIONS(3661),
    [anon_sym_precise] = ACTIONS(3661),
    [anon_sym_shared] = ACTIONS(3661),
    [anon_sym_groupshared] = ACTIONS(3661),
    [anon_sym_uniform] = ACTIONS(3661),
    [anon_sym_row_major] = ACTIONS(3661),
    [anon_sym_column_major] = ACTIONS(3661),
    [anon_sym_globallycoherent] = ACTIONS(3661),
    [anon_sym_centroid] = ACTIONS(3661),
    [anon_sym_noperspective] = ACTIONS(3661),
    [anon_sym_nointerpolation] = ACTIONS(3661),
    [anon_sym_sample] = ACTIONS(3661),
    [anon_sym_linear] = ACTIONS(3661),
    [anon_sym_snorm] = ACTIONS(3661),
    [anon_sym_unorm] = ACTIONS(3661),
    [anon_sym_point] = ACTIONS(3661),
    [anon_sym_line] = ACTIONS(3661),
    [anon_sym_triangleadj] = ACTIONS(3661),
    [anon_sym_lineadj] = ACTIONS(3661),
    [anon_sym_triangle] = ACTIONS(3661),
    [anon_sym_interface] = ACTIONS(3661),
    [anon_sym_extension] = ACTIONS(3661),
    [anon_sym___init] = ACTIONS(3661),
    [anon_sym___subscript] = ACTIONS(3661),
    [anon_sym_property] = ACTIONS(3661),
    [anon_sym_associatedtype] = ACTIONS(3661),
  },
  [2063] = {
    [sym_identifier] = ACTIONS(3784),
    [aux_sym_preproc_def_token1] = ACTIONS(3784),
    [aux_sym_preproc_if_token1] = ACTIONS(3784),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3784),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3784),
    [sym_preproc_directive] = ACTIONS(3784),
    [anon_sym_LPAREN2] = ACTIONS(3786),
    [anon_sym_TILDE] = ACTIONS(3786),
    [anon_sym_STAR] = ACTIONS(3786),
    [anon_sym_AMP_AMP] = ACTIONS(3786),
    [anon_sym_AMP] = ACTIONS(3784),
    [anon_sym_SEMI] = ACTIONS(3786),
    [anon_sym___extension__] = ACTIONS(3784),
    [anon_sym_typedef] = ACTIONS(3784),
    [anon_sym_in] = ACTIONS(3784),
    [anon_sym_out] = ACTIONS(3784),
    [anon_sym_inout] = ACTIONS(3784),
    [anon_sym_virtual] = ACTIONS(3784),
    [anon_sym_extern] = ACTIONS(3784),
    [anon_sym___attribute__] = ACTIONS(3784),
    [anon_sym___attribute] = ACTIONS(3784),
    [anon_sym_using] = ACTIONS(3784),
    [anon_sym_COLON_COLON] = ACTIONS(3786),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3786),
    [anon_sym___declspec] = ACTIONS(3784),
    [anon_sym___based] = ACTIONS(3784),
    [anon_sym_RBRACE] = ACTIONS(3786),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3784),
    [anon_sym_static] = ACTIONS(3784),
    [anon_sym_register] = ACTIONS(3784),
    [anon_sym_inline] = ACTIONS(3784),
    [anon_sym___inline] = ACTIONS(3784),
    [anon_sym___inline__] = ACTIONS(3784),
    [anon_sym___forceinline] = ACTIONS(3784),
    [anon_sym_thread_local] = ACTIONS(3784),
    [anon_sym___thread] = ACTIONS(3784),
    [anon_sym_const] = ACTIONS(3784),
    [anon_sym_constexpr] = ACTIONS(3784),
    [anon_sym_volatile] = ACTIONS(3784),
    [anon_sym_restrict] = ACTIONS(3784),
    [anon_sym___restrict__] = ACTIONS(3784),
    [anon_sym__Atomic] = ACTIONS(3784),
    [anon_sym__Noreturn] = ACTIONS(3784),
    [anon_sym_noreturn] = ACTIONS(3784),
    [anon_sym__Nonnull] = ACTIONS(3784),
    [anon_sym_mutable] = ACTIONS(3784),
    [anon_sym_constinit] = ACTIONS(3784),
    [anon_sym_consteval] = ACTIONS(3784),
    [anon_sym_alignas] = ACTIONS(3784),
    [anon_sym__Alignas] = ACTIONS(3784),
    [sym_primitive_type] = ACTIONS(3784),
    [anon_sym_enum] = ACTIONS(3784),
    [anon_sym_class] = ACTIONS(3784),
    [anon_sym_struct] = ACTIONS(3784),
    [anon_sym_union] = ACTIONS(3784),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3784),
    [anon_sym_let] = ACTIONS(3784),
    [anon_sym_This] = ACTIONS(3784),
    [anon_sym_decltype] = ACTIONS(3784),
    [anon_sym_explicit] = ACTIONS(3784),
    [anon_sym_typename] = ACTIONS(3784),
    [anon_sym_private] = ACTIONS(3784),
    [anon_sym_template] = ACTIONS(3784),
    [anon_sym_operator] = ACTIONS(3784),
    [anon_sym_friend] = ACTIONS(3784),
    [anon_sym_public] = ACTIONS(3784),
    [anon_sym_protected] = ACTIONS(3784),
    [anon_sym_static_assert] = ACTIONS(3784),
    [anon_sym_precise] = ACTIONS(3784),
    [anon_sym_shared] = ACTIONS(3784),
    [anon_sym_groupshared] = ACTIONS(3784),
    [anon_sym_uniform] = ACTIONS(3784),
    [anon_sym_row_major] = ACTIONS(3784),
    [anon_sym_column_major] = ACTIONS(3784),
    [anon_sym_globallycoherent] = ACTIONS(3784),
    [anon_sym_centroid] = ACTIONS(3784),
    [anon_sym_noperspective] = ACTIONS(3784),
    [anon_sym_nointerpolation] = ACTIONS(3784),
    [anon_sym_sample] = ACTIONS(3784),
    [anon_sym_linear] = ACTIONS(3784),
    [anon_sym_snorm] = ACTIONS(3784),
    [anon_sym_unorm] = ACTIONS(3784),
    [anon_sym_point] = ACTIONS(3784),
    [anon_sym_line] = ACTIONS(3784),
    [anon_sym_triangleadj] = ACTIONS(3784),
    [anon_sym_lineadj] = ACTIONS(3784),
    [anon_sym_triangle] = ACTIONS(3784),
    [anon_sym_interface] = ACTIONS(3784),
    [anon_sym_extension] = ACTIONS(3784),
    [anon_sym___init] = ACTIONS(3784),
    [anon_sym___subscript] = ACTIONS(3784),
    [anon_sym_property] = ACTIONS(3784),
    [anon_sym_associatedtype] = ACTIONS(3784),
  },
  [2064] = {
    [sym_expression] = STATE(4763),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [2065] = {
    [sym_expression] = STATE(4764),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [2066] = {
    [sym_expression] = STATE(4765),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [2067] = {
    [sym_expression] = STATE(4766),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [2068] = {
    [sym_expression] = STATE(4767),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [2069] = {
    [sym_expression] = STATE(4771),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [2070] = {
    [sym_expression] = STATE(4773),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [2071] = {
    [sym_expression] = STATE(4774),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [2072] = {
    [sym_expression] = STATE(4779),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [2073] = {
    [sym_expression] = STATE(4782),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [2074] = {
    [sym_expression] = STATE(5711),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2075] = {
    [sym_identifier] = ACTIONS(3919),
    [aux_sym_preproc_def_token1] = ACTIONS(3919),
    [aux_sym_preproc_if_token1] = ACTIONS(3919),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3919),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3919),
    [sym_preproc_directive] = ACTIONS(3919),
    [anon_sym_LPAREN2] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_STAR] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_AMP] = ACTIONS(3919),
    [anon_sym_SEMI] = ACTIONS(3921),
    [anon_sym___extension__] = ACTIONS(3919),
    [anon_sym_typedef] = ACTIONS(3919),
    [anon_sym_in] = ACTIONS(3919),
    [anon_sym_out] = ACTIONS(3919),
    [anon_sym_inout] = ACTIONS(3919),
    [anon_sym_virtual] = ACTIONS(3919),
    [anon_sym_extern] = ACTIONS(3919),
    [anon_sym___attribute__] = ACTIONS(3919),
    [anon_sym___attribute] = ACTIONS(3919),
    [anon_sym_using] = ACTIONS(3919),
    [anon_sym_COLON_COLON] = ACTIONS(3921),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3921),
    [anon_sym___declspec] = ACTIONS(3919),
    [anon_sym___based] = ACTIONS(3919),
    [anon_sym_RBRACE] = ACTIONS(3921),
    [anon_sym_signed] = ACTIONS(3919),
    [anon_sym_unsigned] = ACTIONS(3919),
    [anon_sym_long] = ACTIONS(3919),
    [anon_sym_short] = ACTIONS(3919),
    [anon_sym_LBRACK] = ACTIONS(3919),
    [anon_sym_static] = ACTIONS(3919),
    [anon_sym_register] = ACTIONS(3919),
    [anon_sym_inline] = ACTIONS(3919),
    [anon_sym___inline] = ACTIONS(3919),
    [anon_sym___inline__] = ACTIONS(3919),
    [anon_sym___forceinline] = ACTIONS(3919),
    [anon_sym_thread_local] = ACTIONS(3919),
    [anon_sym___thread] = ACTIONS(3919),
    [anon_sym_const] = ACTIONS(3919),
    [anon_sym_constexpr] = ACTIONS(3919),
    [anon_sym_volatile] = ACTIONS(3919),
    [anon_sym_restrict] = ACTIONS(3919),
    [anon_sym___restrict__] = ACTIONS(3919),
    [anon_sym__Atomic] = ACTIONS(3919),
    [anon_sym__Noreturn] = ACTIONS(3919),
    [anon_sym_noreturn] = ACTIONS(3919),
    [anon_sym__Nonnull] = ACTIONS(3919),
    [anon_sym_mutable] = ACTIONS(3919),
    [anon_sym_constinit] = ACTIONS(3919),
    [anon_sym_consteval] = ACTIONS(3919),
    [anon_sym_alignas] = ACTIONS(3919),
    [anon_sym__Alignas] = ACTIONS(3919),
    [sym_primitive_type] = ACTIONS(3919),
    [anon_sym_enum] = ACTIONS(3919),
    [anon_sym_class] = ACTIONS(3919),
    [anon_sym_struct] = ACTIONS(3919),
    [anon_sym_union] = ACTIONS(3919),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3919),
    [anon_sym_let] = ACTIONS(3919),
    [anon_sym_This] = ACTIONS(3919),
    [anon_sym_decltype] = ACTIONS(3919),
    [anon_sym_explicit] = ACTIONS(3919),
    [anon_sym_typename] = ACTIONS(3919),
    [anon_sym_private] = ACTIONS(3919),
    [anon_sym_template] = ACTIONS(3919),
    [anon_sym_operator] = ACTIONS(3919),
    [anon_sym_friend] = ACTIONS(3919),
    [anon_sym_public] = ACTIONS(3919),
    [anon_sym_protected] = ACTIONS(3919),
    [anon_sym_static_assert] = ACTIONS(3919),
    [anon_sym_precise] = ACTIONS(3919),
    [anon_sym_shared] = ACTIONS(3919),
    [anon_sym_groupshared] = ACTIONS(3919),
    [anon_sym_uniform] = ACTIONS(3919),
    [anon_sym_row_major] = ACTIONS(3919),
    [anon_sym_column_major] = ACTIONS(3919),
    [anon_sym_globallycoherent] = ACTIONS(3919),
    [anon_sym_centroid] = ACTIONS(3919),
    [anon_sym_noperspective] = ACTIONS(3919),
    [anon_sym_nointerpolation] = ACTIONS(3919),
    [anon_sym_sample] = ACTIONS(3919),
    [anon_sym_linear] = ACTIONS(3919),
    [anon_sym_snorm] = ACTIONS(3919),
    [anon_sym_unorm] = ACTIONS(3919),
    [anon_sym_point] = ACTIONS(3919),
    [anon_sym_line] = ACTIONS(3919),
    [anon_sym_triangleadj] = ACTIONS(3919),
    [anon_sym_lineadj] = ACTIONS(3919),
    [anon_sym_triangle] = ACTIONS(3919),
    [anon_sym_interface] = ACTIONS(3919),
    [anon_sym_extension] = ACTIONS(3919),
    [anon_sym___init] = ACTIONS(3919),
    [anon_sym___subscript] = ACTIONS(3919),
    [anon_sym_property] = ACTIONS(3919),
    [anon_sym_associatedtype] = ACTIONS(3919),
  },
  [2076] = {
    [sym_identifier] = ACTIONS(3949),
    [aux_sym_preproc_def_token1] = ACTIONS(3949),
    [aux_sym_preproc_if_token1] = ACTIONS(3949),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3949),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3949),
    [sym_preproc_directive] = ACTIONS(3949),
    [anon_sym_LPAREN2] = ACTIONS(3951),
    [anon_sym_TILDE] = ACTIONS(3951),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3949),
    [anon_sym_SEMI] = ACTIONS(3951),
    [anon_sym___extension__] = ACTIONS(3949),
    [anon_sym_typedef] = ACTIONS(3949),
    [anon_sym_in] = ACTIONS(3949),
    [anon_sym_out] = ACTIONS(3949),
    [anon_sym_inout] = ACTIONS(3949),
    [anon_sym_virtual] = ACTIONS(3949),
    [anon_sym_extern] = ACTIONS(3949),
    [anon_sym___attribute__] = ACTIONS(3949),
    [anon_sym___attribute] = ACTIONS(3949),
    [anon_sym_using] = ACTIONS(3949),
    [anon_sym_COLON_COLON] = ACTIONS(3951),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3951),
    [anon_sym___declspec] = ACTIONS(3949),
    [anon_sym___based] = ACTIONS(3949),
    [anon_sym_RBRACE] = ACTIONS(3951),
    [anon_sym_signed] = ACTIONS(3949),
    [anon_sym_unsigned] = ACTIONS(3949),
    [anon_sym_long] = ACTIONS(3949),
    [anon_sym_short] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_static] = ACTIONS(3949),
    [anon_sym_register] = ACTIONS(3949),
    [anon_sym_inline] = ACTIONS(3949),
    [anon_sym___inline] = ACTIONS(3949),
    [anon_sym___inline__] = ACTIONS(3949),
    [anon_sym___forceinline] = ACTIONS(3949),
    [anon_sym_thread_local] = ACTIONS(3949),
    [anon_sym___thread] = ACTIONS(3949),
    [anon_sym_const] = ACTIONS(3949),
    [anon_sym_constexpr] = ACTIONS(3949),
    [anon_sym_volatile] = ACTIONS(3949),
    [anon_sym_restrict] = ACTIONS(3949),
    [anon_sym___restrict__] = ACTIONS(3949),
    [anon_sym__Atomic] = ACTIONS(3949),
    [anon_sym__Noreturn] = ACTIONS(3949),
    [anon_sym_noreturn] = ACTIONS(3949),
    [anon_sym__Nonnull] = ACTIONS(3949),
    [anon_sym_mutable] = ACTIONS(3949),
    [anon_sym_constinit] = ACTIONS(3949),
    [anon_sym_consteval] = ACTIONS(3949),
    [anon_sym_alignas] = ACTIONS(3949),
    [anon_sym__Alignas] = ACTIONS(3949),
    [sym_primitive_type] = ACTIONS(3949),
    [anon_sym_enum] = ACTIONS(3949),
    [anon_sym_class] = ACTIONS(3949),
    [anon_sym_struct] = ACTIONS(3949),
    [anon_sym_union] = ACTIONS(3949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_This] = ACTIONS(3949),
    [anon_sym_decltype] = ACTIONS(3949),
    [anon_sym_explicit] = ACTIONS(3949),
    [anon_sym_typename] = ACTIONS(3949),
    [anon_sym_private] = ACTIONS(3949),
    [anon_sym_template] = ACTIONS(3949),
    [anon_sym_operator] = ACTIONS(3949),
    [anon_sym_friend] = ACTIONS(3949),
    [anon_sym_public] = ACTIONS(3949),
    [anon_sym_protected] = ACTIONS(3949),
    [anon_sym_static_assert] = ACTIONS(3949),
    [anon_sym_precise] = ACTIONS(3949),
    [anon_sym_shared] = ACTIONS(3949),
    [anon_sym_groupshared] = ACTIONS(3949),
    [anon_sym_uniform] = ACTIONS(3949),
    [anon_sym_row_major] = ACTIONS(3949),
    [anon_sym_column_major] = ACTIONS(3949),
    [anon_sym_globallycoherent] = ACTIONS(3949),
    [anon_sym_centroid] = ACTIONS(3949),
    [anon_sym_noperspective] = ACTIONS(3949),
    [anon_sym_nointerpolation] = ACTIONS(3949),
    [anon_sym_sample] = ACTIONS(3949),
    [anon_sym_linear] = ACTIONS(3949),
    [anon_sym_snorm] = ACTIONS(3949),
    [anon_sym_unorm] = ACTIONS(3949),
    [anon_sym_point] = ACTIONS(3949),
    [anon_sym_line] = ACTIONS(3949),
    [anon_sym_triangleadj] = ACTIONS(3949),
    [anon_sym_lineadj] = ACTIONS(3949),
    [anon_sym_triangle] = ACTIONS(3949),
    [anon_sym_interface] = ACTIONS(3949),
    [anon_sym_extension] = ACTIONS(3949),
    [anon_sym___init] = ACTIONS(3949),
    [anon_sym___subscript] = ACTIONS(3949),
    [anon_sym_property] = ACTIONS(3949),
    [anon_sym_associatedtype] = ACTIONS(3949),
  },
  [2077] = {
    [sym_identifier] = ACTIONS(3877),
    [aux_sym_preproc_def_token1] = ACTIONS(3877),
    [aux_sym_preproc_if_token1] = ACTIONS(3877),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3877),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3877),
    [sym_preproc_directive] = ACTIONS(3877),
    [anon_sym_LPAREN2] = ACTIONS(3879),
    [anon_sym_TILDE] = ACTIONS(3879),
    [anon_sym_STAR] = ACTIONS(3879),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3877),
    [anon_sym_SEMI] = ACTIONS(3879),
    [anon_sym___extension__] = ACTIONS(3877),
    [anon_sym_typedef] = ACTIONS(3877),
    [anon_sym_in] = ACTIONS(3877),
    [anon_sym_out] = ACTIONS(3877),
    [anon_sym_inout] = ACTIONS(3877),
    [anon_sym_virtual] = ACTIONS(3877),
    [anon_sym_extern] = ACTIONS(3877),
    [anon_sym___attribute__] = ACTIONS(3877),
    [anon_sym___attribute] = ACTIONS(3877),
    [anon_sym_using] = ACTIONS(3877),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3879),
    [anon_sym___declspec] = ACTIONS(3877),
    [anon_sym___based] = ACTIONS(3877),
    [anon_sym_RBRACE] = ACTIONS(3879),
    [anon_sym_signed] = ACTIONS(3877),
    [anon_sym_unsigned] = ACTIONS(3877),
    [anon_sym_long] = ACTIONS(3877),
    [anon_sym_short] = ACTIONS(3877),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_static] = ACTIONS(3877),
    [anon_sym_register] = ACTIONS(3877),
    [anon_sym_inline] = ACTIONS(3877),
    [anon_sym___inline] = ACTIONS(3877),
    [anon_sym___inline__] = ACTIONS(3877),
    [anon_sym___forceinline] = ACTIONS(3877),
    [anon_sym_thread_local] = ACTIONS(3877),
    [anon_sym___thread] = ACTIONS(3877),
    [anon_sym_const] = ACTIONS(3877),
    [anon_sym_constexpr] = ACTIONS(3877),
    [anon_sym_volatile] = ACTIONS(3877),
    [anon_sym_restrict] = ACTIONS(3877),
    [anon_sym___restrict__] = ACTIONS(3877),
    [anon_sym__Atomic] = ACTIONS(3877),
    [anon_sym__Noreturn] = ACTIONS(3877),
    [anon_sym_noreturn] = ACTIONS(3877),
    [anon_sym__Nonnull] = ACTIONS(3877),
    [anon_sym_mutable] = ACTIONS(3877),
    [anon_sym_constinit] = ACTIONS(3877),
    [anon_sym_consteval] = ACTIONS(3877),
    [anon_sym_alignas] = ACTIONS(3877),
    [anon_sym__Alignas] = ACTIONS(3877),
    [sym_primitive_type] = ACTIONS(3877),
    [anon_sym_enum] = ACTIONS(3877),
    [anon_sym_class] = ACTIONS(3877),
    [anon_sym_struct] = ACTIONS(3877),
    [anon_sym_union] = ACTIONS(3877),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3877),
    [anon_sym_let] = ACTIONS(3877),
    [anon_sym_This] = ACTIONS(3877),
    [anon_sym_decltype] = ACTIONS(3877),
    [anon_sym_explicit] = ACTIONS(3877),
    [anon_sym_typename] = ACTIONS(3877),
    [anon_sym_private] = ACTIONS(3877),
    [anon_sym_template] = ACTIONS(3877),
    [anon_sym_operator] = ACTIONS(3877),
    [anon_sym_friend] = ACTIONS(3877),
    [anon_sym_public] = ACTIONS(3877),
    [anon_sym_protected] = ACTIONS(3877),
    [anon_sym_static_assert] = ACTIONS(3877),
    [anon_sym_precise] = ACTIONS(3877),
    [anon_sym_shared] = ACTIONS(3877),
    [anon_sym_groupshared] = ACTIONS(3877),
    [anon_sym_uniform] = ACTIONS(3877),
    [anon_sym_row_major] = ACTIONS(3877),
    [anon_sym_column_major] = ACTIONS(3877),
    [anon_sym_globallycoherent] = ACTIONS(3877),
    [anon_sym_centroid] = ACTIONS(3877),
    [anon_sym_noperspective] = ACTIONS(3877),
    [anon_sym_nointerpolation] = ACTIONS(3877),
    [anon_sym_sample] = ACTIONS(3877),
    [anon_sym_linear] = ACTIONS(3877),
    [anon_sym_snorm] = ACTIONS(3877),
    [anon_sym_unorm] = ACTIONS(3877),
    [anon_sym_point] = ACTIONS(3877),
    [anon_sym_line] = ACTIONS(3877),
    [anon_sym_triangleadj] = ACTIONS(3877),
    [anon_sym_lineadj] = ACTIONS(3877),
    [anon_sym_triangle] = ACTIONS(3877),
    [anon_sym_interface] = ACTIONS(3877),
    [anon_sym_extension] = ACTIONS(3877),
    [anon_sym___init] = ACTIONS(3877),
    [anon_sym___subscript] = ACTIONS(3877),
    [anon_sym_property] = ACTIONS(3877),
    [anon_sym_associatedtype] = ACTIONS(3877),
  },
  [2078] = {
    [sym_identifier] = ACTIONS(6314),
    [aux_sym_preproc_def_token1] = ACTIONS(6314),
    [aux_sym_preproc_if_token1] = ACTIONS(6314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6314),
    [sym_preproc_directive] = ACTIONS(6314),
    [anon_sym_LPAREN2] = ACTIONS(6316),
    [anon_sym_TILDE] = ACTIONS(6316),
    [anon_sym_STAR] = ACTIONS(6316),
    [anon_sym_AMP_AMP] = ACTIONS(6316),
    [anon_sym_AMP] = ACTIONS(6314),
    [anon_sym_SEMI] = ACTIONS(6316),
    [anon_sym___extension__] = ACTIONS(6314),
    [anon_sym_typedef] = ACTIONS(6314),
    [anon_sym_in] = ACTIONS(6314),
    [anon_sym_out] = ACTIONS(6314),
    [anon_sym_inout] = ACTIONS(6314),
    [anon_sym_virtual] = ACTIONS(6314),
    [anon_sym_extern] = ACTIONS(6314),
    [anon_sym___attribute__] = ACTIONS(6314),
    [anon_sym___attribute] = ACTIONS(6314),
    [anon_sym_using] = ACTIONS(6314),
    [anon_sym_COLON_COLON] = ACTIONS(6316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6316),
    [anon_sym___declspec] = ACTIONS(6314),
    [anon_sym___based] = ACTIONS(6314),
    [anon_sym_RBRACE] = ACTIONS(6316),
    [anon_sym_signed] = ACTIONS(6314),
    [anon_sym_unsigned] = ACTIONS(6314),
    [anon_sym_long] = ACTIONS(6314),
    [anon_sym_short] = ACTIONS(6314),
    [anon_sym_LBRACK] = ACTIONS(6314),
    [anon_sym_static] = ACTIONS(6314),
    [anon_sym_register] = ACTIONS(6314),
    [anon_sym_inline] = ACTIONS(6314),
    [anon_sym___inline] = ACTIONS(6314),
    [anon_sym___inline__] = ACTIONS(6314),
    [anon_sym___forceinline] = ACTIONS(6314),
    [anon_sym_thread_local] = ACTIONS(6314),
    [anon_sym___thread] = ACTIONS(6314),
    [anon_sym_const] = ACTIONS(6314),
    [anon_sym_constexpr] = ACTIONS(6314),
    [anon_sym_volatile] = ACTIONS(6314),
    [anon_sym_restrict] = ACTIONS(6314),
    [anon_sym___restrict__] = ACTIONS(6314),
    [anon_sym__Atomic] = ACTIONS(6314),
    [anon_sym__Noreturn] = ACTIONS(6314),
    [anon_sym_noreturn] = ACTIONS(6314),
    [anon_sym__Nonnull] = ACTIONS(6314),
    [anon_sym_mutable] = ACTIONS(6314),
    [anon_sym_constinit] = ACTIONS(6314),
    [anon_sym_consteval] = ACTIONS(6314),
    [anon_sym_alignas] = ACTIONS(6314),
    [anon_sym__Alignas] = ACTIONS(6314),
    [sym_primitive_type] = ACTIONS(6314),
    [anon_sym_enum] = ACTIONS(6314),
    [anon_sym_class] = ACTIONS(6314),
    [anon_sym_struct] = ACTIONS(6314),
    [anon_sym_union] = ACTIONS(6314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6314),
    [anon_sym_let] = ACTIONS(6314),
    [anon_sym_This] = ACTIONS(6314),
    [anon_sym_decltype] = ACTIONS(6314),
    [anon_sym_explicit] = ACTIONS(6314),
    [anon_sym_typename] = ACTIONS(6314),
    [anon_sym_private] = ACTIONS(6314),
    [anon_sym_template] = ACTIONS(6314),
    [anon_sym_operator] = ACTIONS(6314),
    [anon_sym_friend] = ACTIONS(6314),
    [anon_sym_public] = ACTIONS(6314),
    [anon_sym_protected] = ACTIONS(6314),
    [anon_sym_static_assert] = ACTIONS(6314),
    [anon_sym_precise] = ACTIONS(6314),
    [anon_sym_shared] = ACTIONS(6314),
    [anon_sym_groupshared] = ACTIONS(6314),
    [anon_sym_uniform] = ACTIONS(6314),
    [anon_sym_row_major] = ACTIONS(6314),
    [anon_sym_column_major] = ACTIONS(6314),
    [anon_sym_globallycoherent] = ACTIONS(6314),
    [anon_sym_centroid] = ACTIONS(6314),
    [anon_sym_noperspective] = ACTIONS(6314),
    [anon_sym_nointerpolation] = ACTIONS(6314),
    [anon_sym_sample] = ACTIONS(6314),
    [anon_sym_linear] = ACTIONS(6314),
    [anon_sym_snorm] = ACTIONS(6314),
    [anon_sym_unorm] = ACTIONS(6314),
    [anon_sym_point] = ACTIONS(6314),
    [anon_sym_line] = ACTIONS(6314),
    [anon_sym_triangleadj] = ACTIONS(6314),
    [anon_sym_lineadj] = ACTIONS(6314),
    [anon_sym_triangle] = ACTIONS(6314),
    [anon_sym_interface] = ACTIONS(6314),
    [anon_sym_extension] = ACTIONS(6314),
    [anon_sym___init] = ACTIONS(6314),
    [anon_sym___subscript] = ACTIONS(6314),
    [anon_sym_property] = ACTIONS(6314),
    [anon_sym_associatedtype] = ACTIONS(6314),
  },
  [2079] = {
    [sym_identifier] = ACTIONS(3893),
    [aux_sym_preproc_def_token1] = ACTIONS(3893),
    [aux_sym_preproc_if_token1] = ACTIONS(3893),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3893),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3893),
    [sym_preproc_directive] = ACTIONS(3893),
    [anon_sym_LPAREN2] = ACTIONS(3895),
    [anon_sym_TILDE] = ACTIONS(3895),
    [anon_sym_STAR] = ACTIONS(3895),
    [anon_sym_AMP_AMP] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3893),
    [anon_sym_SEMI] = ACTIONS(3895),
    [anon_sym___extension__] = ACTIONS(3893),
    [anon_sym_typedef] = ACTIONS(3893),
    [anon_sym_in] = ACTIONS(3893),
    [anon_sym_out] = ACTIONS(3893),
    [anon_sym_inout] = ACTIONS(3893),
    [anon_sym_virtual] = ACTIONS(3893),
    [anon_sym_extern] = ACTIONS(3893),
    [anon_sym___attribute__] = ACTIONS(3893),
    [anon_sym___attribute] = ACTIONS(3893),
    [anon_sym_using] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3895),
    [anon_sym___declspec] = ACTIONS(3893),
    [anon_sym___based] = ACTIONS(3893),
    [anon_sym_RBRACE] = ACTIONS(3895),
    [anon_sym_signed] = ACTIONS(3893),
    [anon_sym_unsigned] = ACTIONS(3893),
    [anon_sym_long] = ACTIONS(3893),
    [anon_sym_short] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_static] = ACTIONS(3893),
    [anon_sym_register] = ACTIONS(3893),
    [anon_sym_inline] = ACTIONS(3893),
    [anon_sym___inline] = ACTIONS(3893),
    [anon_sym___inline__] = ACTIONS(3893),
    [anon_sym___forceinline] = ACTIONS(3893),
    [anon_sym_thread_local] = ACTIONS(3893),
    [anon_sym___thread] = ACTIONS(3893),
    [anon_sym_const] = ACTIONS(3893),
    [anon_sym_constexpr] = ACTIONS(3893),
    [anon_sym_volatile] = ACTIONS(3893),
    [anon_sym_restrict] = ACTIONS(3893),
    [anon_sym___restrict__] = ACTIONS(3893),
    [anon_sym__Atomic] = ACTIONS(3893),
    [anon_sym__Noreturn] = ACTIONS(3893),
    [anon_sym_noreturn] = ACTIONS(3893),
    [anon_sym__Nonnull] = ACTIONS(3893),
    [anon_sym_mutable] = ACTIONS(3893),
    [anon_sym_constinit] = ACTIONS(3893),
    [anon_sym_consteval] = ACTIONS(3893),
    [anon_sym_alignas] = ACTIONS(3893),
    [anon_sym__Alignas] = ACTIONS(3893),
    [sym_primitive_type] = ACTIONS(3893),
    [anon_sym_enum] = ACTIONS(3893),
    [anon_sym_class] = ACTIONS(3893),
    [anon_sym_struct] = ACTIONS(3893),
    [anon_sym_union] = ACTIONS(3893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_This] = ACTIONS(3893),
    [anon_sym_decltype] = ACTIONS(3893),
    [anon_sym_explicit] = ACTIONS(3893),
    [anon_sym_typename] = ACTIONS(3893),
    [anon_sym_private] = ACTIONS(3893),
    [anon_sym_template] = ACTIONS(3893),
    [anon_sym_operator] = ACTIONS(3893),
    [anon_sym_friend] = ACTIONS(3893),
    [anon_sym_public] = ACTIONS(3893),
    [anon_sym_protected] = ACTIONS(3893),
    [anon_sym_static_assert] = ACTIONS(3893),
    [anon_sym_precise] = ACTIONS(3893),
    [anon_sym_shared] = ACTIONS(3893),
    [anon_sym_groupshared] = ACTIONS(3893),
    [anon_sym_uniform] = ACTIONS(3893),
    [anon_sym_row_major] = ACTIONS(3893),
    [anon_sym_column_major] = ACTIONS(3893),
    [anon_sym_globallycoherent] = ACTIONS(3893),
    [anon_sym_centroid] = ACTIONS(3893),
    [anon_sym_noperspective] = ACTIONS(3893),
    [anon_sym_nointerpolation] = ACTIONS(3893),
    [anon_sym_sample] = ACTIONS(3893),
    [anon_sym_linear] = ACTIONS(3893),
    [anon_sym_snorm] = ACTIONS(3893),
    [anon_sym_unorm] = ACTIONS(3893),
    [anon_sym_point] = ACTIONS(3893),
    [anon_sym_line] = ACTIONS(3893),
    [anon_sym_triangleadj] = ACTIONS(3893),
    [anon_sym_lineadj] = ACTIONS(3893),
    [anon_sym_triangle] = ACTIONS(3893),
    [anon_sym_interface] = ACTIONS(3893),
    [anon_sym_extension] = ACTIONS(3893),
    [anon_sym___init] = ACTIONS(3893),
    [anon_sym___subscript] = ACTIONS(3893),
    [anon_sym_property] = ACTIONS(3893),
    [anon_sym_associatedtype] = ACTIONS(3893),
  },
  [2080] = {
    [sym_identifier] = ACTIONS(6318),
    [aux_sym_preproc_def_token1] = ACTIONS(6318),
    [aux_sym_preproc_if_token1] = ACTIONS(6318),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6318),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6318),
    [sym_preproc_directive] = ACTIONS(6318),
    [anon_sym_LPAREN2] = ACTIONS(6320),
    [anon_sym_TILDE] = ACTIONS(6320),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_AMP_AMP] = ACTIONS(6320),
    [anon_sym_AMP] = ACTIONS(6318),
    [anon_sym_SEMI] = ACTIONS(6320),
    [anon_sym___extension__] = ACTIONS(6318),
    [anon_sym_typedef] = ACTIONS(6318),
    [anon_sym_in] = ACTIONS(6318),
    [anon_sym_out] = ACTIONS(6318),
    [anon_sym_inout] = ACTIONS(6318),
    [anon_sym_virtual] = ACTIONS(6318),
    [anon_sym_extern] = ACTIONS(6318),
    [anon_sym___attribute__] = ACTIONS(6318),
    [anon_sym___attribute] = ACTIONS(6318),
    [anon_sym_using] = ACTIONS(6318),
    [anon_sym_COLON_COLON] = ACTIONS(6320),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6320),
    [anon_sym___declspec] = ACTIONS(6318),
    [anon_sym___based] = ACTIONS(6318),
    [anon_sym_RBRACE] = ACTIONS(6320),
    [anon_sym_signed] = ACTIONS(6318),
    [anon_sym_unsigned] = ACTIONS(6318),
    [anon_sym_long] = ACTIONS(6318),
    [anon_sym_short] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6318),
    [anon_sym_static] = ACTIONS(6318),
    [anon_sym_register] = ACTIONS(6318),
    [anon_sym_inline] = ACTIONS(6318),
    [anon_sym___inline] = ACTIONS(6318),
    [anon_sym___inline__] = ACTIONS(6318),
    [anon_sym___forceinline] = ACTIONS(6318),
    [anon_sym_thread_local] = ACTIONS(6318),
    [anon_sym___thread] = ACTIONS(6318),
    [anon_sym_const] = ACTIONS(6318),
    [anon_sym_constexpr] = ACTIONS(6318),
    [anon_sym_volatile] = ACTIONS(6318),
    [anon_sym_restrict] = ACTIONS(6318),
    [anon_sym___restrict__] = ACTIONS(6318),
    [anon_sym__Atomic] = ACTIONS(6318),
    [anon_sym__Noreturn] = ACTIONS(6318),
    [anon_sym_noreturn] = ACTIONS(6318),
    [anon_sym__Nonnull] = ACTIONS(6318),
    [anon_sym_mutable] = ACTIONS(6318),
    [anon_sym_constinit] = ACTIONS(6318),
    [anon_sym_consteval] = ACTIONS(6318),
    [anon_sym_alignas] = ACTIONS(6318),
    [anon_sym__Alignas] = ACTIONS(6318),
    [sym_primitive_type] = ACTIONS(6318),
    [anon_sym_enum] = ACTIONS(6318),
    [anon_sym_class] = ACTIONS(6318),
    [anon_sym_struct] = ACTIONS(6318),
    [anon_sym_union] = ACTIONS(6318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6318),
    [anon_sym_let] = ACTIONS(6318),
    [anon_sym_This] = ACTIONS(6318),
    [anon_sym_decltype] = ACTIONS(6318),
    [anon_sym_explicit] = ACTIONS(6318),
    [anon_sym_typename] = ACTIONS(6318),
    [anon_sym_private] = ACTIONS(6318),
    [anon_sym_template] = ACTIONS(6318),
    [anon_sym_operator] = ACTIONS(6318),
    [anon_sym_friend] = ACTIONS(6318),
    [anon_sym_public] = ACTIONS(6318),
    [anon_sym_protected] = ACTIONS(6318),
    [anon_sym_static_assert] = ACTIONS(6318),
    [anon_sym_precise] = ACTIONS(6318),
    [anon_sym_shared] = ACTIONS(6318),
    [anon_sym_groupshared] = ACTIONS(6318),
    [anon_sym_uniform] = ACTIONS(6318),
    [anon_sym_row_major] = ACTIONS(6318),
    [anon_sym_column_major] = ACTIONS(6318),
    [anon_sym_globallycoherent] = ACTIONS(6318),
    [anon_sym_centroid] = ACTIONS(6318),
    [anon_sym_noperspective] = ACTIONS(6318),
    [anon_sym_nointerpolation] = ACTIONS(6318),
    [anon_sym_sample] = ACTIONS(6318),
    [anon_sym_linear] = ACTIONS(6318),
    [anon_sym_snorm] = ACTIONS(6318),
    [anon_sym_unorm] = ACTIONS(6318),
    [anon_sym_point] = ACTIONS(6318),
    [anon_sym_line] = ACTIONS(6318),
    [anon_sym_triangleadj] = ACTIONS(6318),
    [anon_sym_lineadj] = ACTIONS(6318),
    [anon_sym_triangle] = ACTIONS(6318),
    [anon_sym_interface] = ACTIONS(6318),
    [anon_sym_extension] = ACTIONS(6318),
    [anon_sym___init] = ACTIONS(6318),
    [anon_sym___subscript] = ACTIONS(6318),
    [anon_sym_property] = ACTIONS(6318),
    [anon_sym_associatedtype] = ACTIONS(6318),
  },
  [2081] = {
    [sym_identifier] = ACTIONS(3739),
    [aux_sym_preproc_def_token1] = ACTIONS(3739),
    [aux_sym_preproc_if_token1] = ACTIONS(3739),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3739),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3739),
    [sym_preproc_directive] = ACTIONS(3739),
    [anon_sym_LPAREN2] = ACTIONS(3741),
    [anon_sym_TILDE] = ACTIONS(3741),
    [anon_sym_STAR] = ACTIONS(3741),
    [anon_sym_AMP_AMP] = ACTIONS(3741),
    [anon_sym_AMP] = ACTIONS(3739),
    [anon_sym_SEMI] = ACTIONS(3741),
    [anon_sym___extension__] = ACTIONS(3739),
    [anon_sym_typedef] = ACTIONS(3739),
    [anon_sym_in] = ACTIONS(3739),
    [anon_sym_out] = ACTIONS(3739),
    [anon_sym_inout] = ACTIONS(3739),
    [anon_sym_virtual] = ACTIONS(3739),
    [anon_sym_extern] = ACTIONS(3739),
    [anon_sym___attribute__] = ACTIONS(3739),
    [anon_sym___attribute] = ACTIONS(3739),
    [anon_sym_using] = ACTIONS(3739),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3741),
    [anon_sym___declspec] = ACTIONS(3739),
    [anon_sym___based] = ACTIONS(3739),
    [anon_sym_RBRACE] = ACTIONS(3741),
    [anon_sym_signed] = ACTIONS(3739),
    [anon_sym_unsigned] = ACTIONS(3739),
    [anon_sym_long] = ACTIONS(3739),
    [anon_sym_short] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3739),
    [anon_sym_static] = ACTIONS(3739),
    [anon_sym_register] = ACTIONS(3739),
    [anon_sym_inline] = ACTIONS(3739),
    [anon_sym___inline] = ACTIONS(3739),
    [anon_sym___inline__] = ACTIONS(3739),
    [anon_sym___forceinline] = ACTIONS(3739),
    [anon_sym_thread_local] = ACTIONS(3739),
    [anon_sym___thread] = ACTIONS(3739),
    [anon_sym_const] = ACTIONS(3739),
    [anon_sym_constexpr] = ACTIONS(3739),
    [anon_sym_volatile] = ACTIONS(3739),
    [anon_sym_restrict] = ACTIONS(3739),
    [anon_sym___restrict__] = ACTIONS(3739),
    [anon_sym__Atomic] = ACTIONS(3739),
    [anon_sym__Noreturn] = ACTIONS(3739),
    [anon_sym_noreturn] = ACTIONS(3739),
    [anon_sym__Nonnull] = ACTIONS(3739),
    [anon_sym_mutable] = ACTIONS(3739),
    [anon_sym_constinit] = ACTIONS(3739),
    [anon_sym_consteval] = ACTIONS(3739),
    [anon_sym_alignas] = ACTIONS(3739),
    [anon_sym__Alignas] = ACTIONS(3739),
    [sym_primitive_type] = ACTIONS(3739),
    [anon_sym_enum] = ACTIONS(3739),
    [anon_sym_class] = ACTIONS(3739),
    [anon_sym_struct] = ACTIONS(3739),
    [anon_sym_union] = ACTIONS(3739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3739),
    [anon_sym_let] = ACTIONS(3739),
    [anon_sym_This] = ACTIONS(3739),
    [anon_sym_decltype] = ACTIONS(3739),
    [anon_sym_explicit] = ACTIONS(3739),
    [anon_sym_typename] = ACTIONS(3739),
    [anon_sym_private] = ACTIONS(3739),
    [anon_sym_template] = ACTIONS(3739),
    [anon_sym_operator] = ACTIONS(3739),
    [anon_sym_friend] = ACTIONS(3739),
    [anon_sym_public] = ACTIONS(3739),
    [anon_sym_protected] = ACTIONS(3739),
    [anon_sym_static_assert] = ACTIONS(3739),
    [anon_sym_precise] = ACTIONS(3739),
    [anon_sym_shared] = ACTIONS(3739),
    [anon_sym_groupshared] = ACTIONS(3739),
    [anon_sym_uniform] = ACTIONS(3739),
    [anon_sym_row_major] = ACTIONS(3739),
    [anon_sym_column_major] = ACTIONS(3739),
    [anon_sym_globallycoherent] = ACTIONS(3739),
    [anon_sym_centroid] = ACTIONS(3739),
    [anon_sym_noperspective] = ACTIONS(3739),
    [anon_sym_nointerpolation] = ACTIONS(3739),
    [anon_sym_sample] = ACTIONS(3739),
    [anon_sym_linear] = ACTIONS(3739),
    [anon_sym_snorm] = ACTIONS(3739),
    [anon_sym_unorm] = ACTIONS(3739),
    [anon_sym_point] = ACTIONS(3739),
    [anon_sym_line] = ACTIONS(3739),
    [anon_sym_triangleadj] = ACTIONS(3739),
    [anon_sym_lineadj] = ACTIONS(3739),
    [anon_sym_triangle] = ACTIONS(3739),
    [anon_sym_interface] = ACTIONS(3739),
    [anon_sym_extension] = ACTIONS(3739),
    [anon_sym___init] = ACTIONS(3739),
    [anon_sym___subscript] = ACTIONS(3739),
    [anon_sym_property] = ACTIONS(3739),
    [anon_sym_associatedtype] = ACTIONS(3739),
  },
  [2082] = {
    [sym_identifier] = ACTIONS(3808),
    [aux_sym_preproc_def_token1] = ACTIONS(3808),
    [aux_sym_preproc_if_token1] = ACTIONS(3808),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3808),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3808),
    [sym_preproc_directive] = ACTIONS(3808),
    [anon_sym_LPAREN2] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [anon_sym_STAR] = ACTIONS(3810),
    [anon_sym_AMP_AMP] = ACTIONS(3810),
    [anon_sym_AMP] = ACTIONS(3808),
    [anon_sym_SEMI] = ACTIONS(3810),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_typedef] = ACTIONS(3808),
    [anon_sym_in] = ACTIONS(3808),
    [anon_sym_out] = ACTIONS(3808),
    [anon_sym_inout] = ACTIONS(3808),
    [anon_sym_virtual] = ACTIONS(3808),
    [anon_sym_extern] = ACTIONS(3808),
    [anon_sym___attribute__] = ACTIONS(3808),
    [anon_sym___attribute] = ACTIONS(3808),
    [anon_sym_using] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3810),
    [anon_sym___declspec] = ACTIONS(3808),
    [anon_sym___based] = ACTIONS(3808),
    [anon_sym_RBRACE] = ACTIONS(3810),
    [anon_sym_signed] = ACTIONS(3808),
    [anon_sym_unsigned] = ACTIONS(3808),
    [anon_sym_long] = ACTIONS(3808),
    [anon_sym_short] = ACTIONS(3808),
    [anon_sym_LBRACK] = ACTIONS(3808),
    [anon_sym_static] = ACTIONS(3808),
    [anon_sym_register] = ACTIONS(3808),
    [anon_sym_inline] = ACTIONS(3808),
    [anon_sym___inline] = ACTIONS(3808),
    [anon_sym___inline__] = ACTIONS(3808),
    [anon_sym___forceinline] = ACTIONS(3808),
    [anon_sym_thread_local] = ACTIONS(3808),
    [anon_sym___thread] = ACTIONS(3808),
    [anon_sym_const] = ACTIONS(3808),
    [anon_sym_constexpr] = ACTIONS(3808),
    [anon_sym_volatile] = ACTIONS(3808),
    [anon_sym_restrict] = ACTIONS(3808),
    [anon_sym___restrict__] = ACTIONS(3808),
    [anon_sym__Atomic] = ACTIONS(3808),
    [anon_sym__Noreturn] = ACTIONS(3808),
    [anon_sym_noreturn] = ACTIONS(3808),
    [anon_sym__Nonnull] = ACTIONS(3808),
    [anon_sym_mutable] = ACTIONS(3808),
    [anon_sym_constinit] = ACTIONS(3808),
    [anon_sym_consteval] = ACTIONS(3808),
    [anon_sym_alignas] = ACTIONS(3808),
    [anon_sym__Alignas] = ACTIONS(3808),
    [sym_primitive_type] = ACTIONS(3808),
    [anon_sym_enum] = ACTIONS(3808),
    [anon_sym_class] = ACTIONS(3808),
    [anon_sym_struct] = ACTIONS(3808),
    [anon_sym_union] = ACTIONS(3808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3808),
    [anon_sym_let] = ACTIONS(3808),
    [anon_sym_This] = ACTIONS(3808),
    [anon_sym_decltype] = ACTIONS(3808),
    [anon_sym_explicit] = ACTIONS(3808),
    [anon_sym_typename] = ACTIONS(3808),
    [anon_sym_private] = ACTIONS(3808),
    [anon_sym_template] = ACTIONS(3808),
    [anon_sym_operator] = ACTIONS(3808),
    [anon_sym_friend] = ACTIONS(3808),
    [anon_sym_public] = ACTIONS(3808),
    [anon_sym_protected] = ACTIONS(3808),
    [anon_sym_static_assert] = ACTIONS(3808),
    [anon_sym_precise] = ACTIONS(3808),
    [anon_sym_shared] = ACTIONS(3808),
    [anon_sym_groupshared] = ACTIONS(3808),
    [anon_sym_uniform] = ACTIONS(3808),
    [anon_sym_row_major] = ACTIONS(3808),
    [anon_sym_column_major] = ACTIONS(3808),
    [anon_sym_globallycoherent] = ACTIONS(3808),
    [anon_sym_centroid] = ACTIONS(3808),
    [anon_sym_noperspective] = ACTIONS(3808),
    [anon_sym_nointerpolation] = ACTIONS(3808),
    [anon_sym_sample] = ACTIONS(3808),
    [anon_sym_linear] = ACTIONS(3808),
    [anon_sym_snorm] = ACTIONS(3808),
    [anon_sym_unorm] = ACTIONS(3808),
    [anon_sym_point] = ACTIONS(3808),
    [anon_sym_line] = ACTIONS(3808),
    [anon_sym_triangleadj] = ACTIONS(3808),
    [anon_sym_lineadj] = ACTIONS(3808),
    [anon_sym_triangle] = ACTIONS(3808),
    [anon_sym_interface] = ACTIONS(3808),
    [anon_sym_extension] = ACTIONS(3808),
    [anon_sym___init] = ACTIONS(3808),
    [anon_sym___subscript] = ACTIONS(3808),
    [anon_sym_property] = ACTIONS(3808),
    [anon_sym_associatedtype] = ACTIONS(3808),
  },
  [2083] = {
    [sym_identifier] = ACTIONS(6344),
    [aux_sym_preproc_def_token1] = ACTIONS(6344),
    [aux_sym_preproc_if_token1] = ACTIONS(6344),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6344),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6344),
    [sym_preproc_directive] = ACTIONS(6344),
    [anon_sym_LPAREN2] = ACTIONS(6346),
    [anon_sym_TILDE] = ACTIONS(6346),
    [anon_sym_STAR] = ACTIONS(6346),
    [anon_sym_AMP_AMP] = ACTIONS(6346),
    [anon_sym_AMP] = ACTIONS(6344),
    [anon_sym_SEMI] = ACTIONS(6346),
    [anon_sym___extension__] = ACTIONS(6344),
    [anon_sym_typedef] = ACTIONS(6344),
    [anon_sym_in] = ACTIONS(6344),
    [anon_sym_out] = ACTIONS(6344),
    [anon_sym_inout] = ACTIONS(6344),
    [anon_sym_virtual] = ACTIONS(6344),
    [anon_sym_extern] = ACTIONS(6344),
    [anon_sym___attribute__] = ACTIONS(6344),
    [anon_sym___attribute] = ACTIONS(6344),
    [anon_sym_using] = ACTIONS(6344),
    [anon_sym_COLON_COLON] = ACTIONS(6346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6346),
    [anon_sym___declspec] = ACTIONS(6344),
    [anon_sym___based] = ACTIONS(6344),
    [anon_sym_RBRACE] = ACTIONS(6346),
    [anon_sym_signed] = ACTIONS(6344),
    [anon_sym_unsigned] = ACTIONS(6344),
    [anon_sym_long] = ACTIONS(6344),
    [anon_sym_short] = ACTIONS(6344),
    [anon_sym_LBRACK] = ACTIONS(6344),
    [anon_sym_static] = ACTIONS(6344),
    [anon_sym_register] = ACTIONS(6344),
    [anon_sym_inline] = ACTIONS(6344),
    [anon_sym___inline] = ACTIONS(6344),
    [anon_sym___inline__] = ACTIONS(6344),
    [anon_sym___forceinline] = ACTIONS(6344),
    [anon_sym_thread_local] = ACTIONS(6344),
    [anon_sym___thread] = ACTIONS(6344),
    [anon_sym_const] = ACTIONS(6344),
    [anon_sym_constexpr] = ACTIONS(6344),
    [anon_sym_volatile] = ACTIONS(6344),
    [anon_sym_restrict] = ACTIONS(6344),
    [anon_sym___restrict__] = ACTIONS(6344),
    [anon_sym__Atomic] = ACTIONS(6344),
    [anon_sym__Noreturn] = ACTIONS(6344),
    [anon_sym_noreturn] = ACTIONS(6344),
    [anon_sym__Nonnull] = ACTIONS(6344),
    [anon_sym_mutable] = ACTIONS(6344),
    [anon_sym_constinit] = ACTIONS(6344),
    [anon_sym_consteval] = ACTIONS(6344),
    [anon_sym_alignas] = ACTIONS(6344),
    [anon_sym__Alignas] = ACTIONS(6344),
    [sym_primitive_type] = ACTIONS(6344),
    [anon_sym_enum] = ACTIONS(6344),
    [anon_sym_class] = ACTIONS(6344),
    [anon_sym_struct] = ACTIONS(6344),
    [anon_sym_union] = ACTIONS(6344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6344),
    [anon_sym_let] = ACTIONS(6344),
    [anon_sym_This] = ACTIONS(6344),
    [anon_sym_decltype] = ACTIONS(6344),
    [anon_sym_explicit] = ACTIONS(6344),
    [anon_sym_typename] = ACTIONS(6344),
    [anon_sym_private] = ACTIONS(6344),
    [anon_sym_template] = ACTIONS(6344),
    [anon_sym_operator] = ACTIONS(6344),
    [anon_sym_friend] = ACTIONS(6344),
    [anon_sym_public] = ACTIONS(6344),
    [anon_sym_protected] = ACTIONS(6344),
    [anon_sym_static_assert] = ACTIONS(6344),
    [anon_sym_precise] = ACTIONS(6344),
    [anon_sym_shared] = ACTIONS(6344),
    [anon_sym_groupshared] = ACTIONS(6344),
    [anon_sym_uniform] = ACTIONS(6344),
    [anon_sym_row_major] = ACTIONS(6344),
    [anon_sym_column_major] = ACTIONS(6344),
    [anon_sym_globallycoherent] = ACTIONS(6344),
    [anon_sym_centroid] = ACTIONS(6344),
    [anon_sym_noperspective] = ACTIONS(6344),
    [anon_sym_nointerpolation] = ACTIONS(6344),
    [anon_sym_sample] = ACTIONS(6344),
    [anon_sym_linear] = ACTIONS(6344),
    [anon_sym_snorm] = ACTIONS(6344),
    [anon_sym_unorm] = ACTIONS(6344),
    [anon_sym_point] = ACTIONS(6344),
    [anon_sym_line] = ACTIONS(6344),
    [anon_sym_triangleadj] = ACTIONS(6344),
    [anon_sym_lineadj] = ACTIONS(6344),
    [anon_sym_triangle] = ACTIONS(6344),
    [anon_sym_interface] = ACTIONS(6344),
    [anon_sym_extension] = ACTIONS(6344),
    [anon_sym___init] = ACTIONS(6344),
    [anon_sym___subscript] = ACTIONS(6344),
    [anon_sym_property] = ACTIONS(6344),
    [anon_sym_associatedtype] = ACTIONS(6344),
  },
  [2084] = {
    [sym_identifier] = ACTIONS(6364),
    [aux_sym_preproc_def_token1] = ACTIONS(6364),
    [aux_sym_preproc_if_token1] = ACTIONS(6364),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6364),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6364),
    [sym_preproc_directive] = ACTIONS(6364),
    [anon_sym_LPAREN2] = ACTIONS(6366),
    [anon_sym_TILDE] = ACTIONS(6366),
    [anon_sym_STAR] = ACTIONS(6366),
    [anon_sym_AMP_AMP] = ACTIONS(6366),
    [anon_sym_AMP] = ACTIONS(6364),
    [anon_sym_SEMI] = ACTIONS(6366),
    [anon_sym___extension__] = ACTIONS(6364),
    [anon_sym_typedef] = ACTIONS(6364),
    [anon_sym_in] = ACTIONS(6364),
    [anon_sym_out] = ACTIONS(6364),
    [anon_sym_inout] = ACTIONS(6364),
    [anon_sym_virtual] = ACTIONS(6364),
    [anon_sym_extern] = ACTIONS(6364),
    [anon_sym___attribute__] = ACTIONS(6364),
    [anon_sym___attribute] = ACTIONS(6364),
    [anon_sym_using] = ACTIONS(6364),
    [anon_sym_COLON_COLON] = ACTIONS(6366),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6366),
    [anon_sym___declspec] = ACTIONS(6364),
    [anon_sym___based] = ACTIONS(6364),
    [anon_sym_RBRACE] = ACTIONS(6366),
    [anon_sym_signed] = ACTIONS(6364),
    [anon_sym_unsigned] = ACTIONS(6364),
    [anon_sym_long] = ACTIONS(6364),
    [anon_sym_short] = ACTIONS(6364),
    [anon_sym_LBRACK] = ACTIONS(6364),
    [anon_sym_static] = ACTIONS(6364),
    [anon_sym_register] = ACTIONS(6364),
    [anon_sym_inline] = ACTIONS(6364),
    [anon_sym___inline] = ACTIONS(6364),
    [anon_sym___inline__] = ACTIONS(6364),
    [anon_sym___forceinline] = ACTIONS(6364),
    [anon_sym_thread_local] = ACTIONS(6364),
    [anon_sym___thread] = ACTIONS(6364),
    [anon_sym_const] = ACTIONS(6364),
    [anon_sym_constexpr] = ACTIONS(6364),
    [anon_sym_volatile] = ACTIONS(6364),
    [anon_sym_restrict] = ACTIONS(6364),
    [anon_sym___restrict__] = ACTIONS(6364),
    [anon_sym__Atomic] = ACTIONS(6364),
    [anon_sym__Noreturn] = ACTIONS(6364),
    [anon_sym_noreturn] = ACTIONS(6364),
    [anon_sym__Nonnull] = ACTIONS(6364),
    [anon_sym_mutable] = ACTIONS(6364),
    [anon_sym_constinit] = ACTIONS(6364),
    [anon_sym_consteval] = ACTIONS(6364),
    [anon_sym_alignas] = ACTIONS(6364),
    [anon_sym__Alignas] = ACTIONS(6364),
    [sym_primitive_type] = ACTIONS(6364),
    [anon_sym_enum] = ACTIONS(6364),
    [anon_sym_class] = ACTIONS(6364),
    [anon_sym_struct] = ACTIONS(6364),
    [anon_sym_union] = ACTIONS(6364),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6364),
    [anon_sym_let] = ACTIONS(6364),
    [anon_sym_This] = ACTIONS(6364),
    [anon_sym_decltype] = ACTIONS(6364),
    [anon_sym_explicit] = ACTIONS(6364),
    [anon_sym_typename] = ACTIONS(6364),
    [anon_sym_private] = ACTIONS(6364),
    [anon_sym_template] = ACTIONS(6364),
    [anon_sym_operator] = ACTIONS(6364),
    [anon_sym_friend] = ACTIONS(6364),
    [anon_sym_public] = ACTIONS(6364),
    [anon_sym_protected] = ACTIONS(6364),
    [anon_sym_static_assert] = ACTIONS(6364),
    [anon_sym_precise] = ACTIONS(6364),
    [anon_sym_shared] = ACTIONS(6364),
    [anon_sym_groupshared] = ACTIONS(6364),
    [anon_sym_uniform] = ACTIONS(6364),
    [anon_sym_row_major] = ACTIONS(6364),
    [anon_sym_column_major] = ACTIONS(6364),
    [anon_sym_globallycoherent] = ACTIONS(6364),
    [anon_sym_centroid] = ACTIONS(6364),
    [anon_sym_noperspective] = ACTIONS(6364),
    [anon_sym_nointerpolation] = ACTIONS(6364),
    [anon_sym_sample] = ACTIONS(6364),
    [anon_sym_linear] = ACTIONS(6364),
    [anon_sym_snorm] = ACTIONS(6364),
    [anon_sym_unorm] = ACTIONS(6364),
    [anon_sym_point] = ACTIONS(6364),
    [anon_sym_line] = ACTIONS(6364),
    [anon_sym_triangleadj] = ACTIONS(6364),
    [anon_sym_lineadj] = ACTIONS(6364),
    [anon_sym_triangle] = ACTIONS(6364),
    [anon_sym_interface] = ACTIONS(6364),
    [anon_sym_extension] = ACTIONS(6364),
    [anon_sym___init] = ACTIONS(6364),
    [anon_sym___subscript] = ACTIONS(6364),
    [anon_sym_property] = ACTIONS(6364),
    [anon_sym_associatedtype] = ACTIONS(6364),
  },
  [2085] = {
    [sym_expression] = STATE(5523),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2086] = {
    [sym_identifier] = ACTIONS(6140),
    [aux_sym_preproc_def_token1] = ACTIONS(6140),
    [aux_sym_preproc_if_token1] = ACTIONS(6140),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6140),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6140),
    [sym_preproc_directive] = ACTIONS(6140),
    [anon_sym_LPAREN2] = ACTIONS(6142),
    [anon_sym_TILDE] = ACTIONS(6142),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_AMP_AMP] = ACTIONS(6142),
    [anon_sym_AMP] = ACTIONS(6140),
    [anon_sym_SEMI] = ACTIONS(6142),
    [anon_sym___extension__] = ACTIONS(6140),
    [anon_sym_typedef] = ACTIONS(6140),
    [anon_sym_in] = ACTIONS(6140),
    [anon_sym_out] = ACTIONS(6140),
    [anon_sym_inout] = ACTIONS(6140),
    [anon_sym_virtual] = ACTIONS(6140),
    [anon_sym_extern] = ACTIONS(6140),
    [anon_sym___attribute__] = ACTIONS(6140),
    [anon_sym___attribute] = ACTIONS(6140),
    [anon_sym_using] = ACTIONS(6140),
    [anon_sym_COLON_COLON] = ACTIONS(6142),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6142),
    [anon_sym___declspec] = ACTIONS(6140),
    [anon_sym___based] = ACTIONS(6140),
    [anon_sym_RBRACE] = ACTIONS(6142),
    [anon_sym_signed] = ACTIONS(6140),
    [anon_sym_unsigned] = ACTIONS(6140),
    [anon_sym_long] = ACTIONS(6140),
    [anon_sym_short] = ACTIONS(6140),
    [anon_sym_LBRACK] = ACTIONS(6140),
    [anon_sym_static] = ACTIONS(6140),
    [anon_sym_register] = ACTIONS(6140),
    [anon_sym_inline] = ACTIONS(6140),
    [anon_sym___inline] = ACTIONS(6140),
    [anon_sym___inline__] = ACTIONS(6140),
    [anon_sym___forceinline] = ACTIONS(6140),
    [anon_sym_thread_local] = ACTIONS(6140),
    [anon_sym___thread] = ACTIONS(6140),
    [anon_sym_const] = ACTIONS(6140),
    [anon_sym_constexpr] = ACTIONS(6140),
    [anon_sym_volatile] = ACTIONS(6140),
    [anon_sym_restrict] = ACTIONS(6140),
    [anon_sym___restrict__] = ACTIONS(6140),
    [anon_sym__Atomic] = ACTIONS(6140),
    [anon_sym__Noreturn] = ACTIONS(6140),
    [anon_sym_noreturn] = ACTIONS(6140),
    [anon_sym__Nonnull] = ACTIONS(6140),
    [anon_sym_mutable] = ACTIONS(6140),
    [anon_sym_constinit] = ACTIONS(6140),
    [anon_sym_consteval] = ACTIONS(6140),
    [anon_sym_alignas] = ACTIONS(6140),
    [anon_sym__Alignas] = ACTIONS(6140),
    [sym_primitive_type] = ACTIONS(6140),
    [anon_sym_enum] = ACTIONS(6140),
    [anon_sym_class] = ACTIONS(6140),
    [anon_sym_struct] = ACTIONS(6140),
    [anon_sym_union] = ACTIONS(6140),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6140),
    [anon_sym_let] = ACTIONS(6140),
    [anon_sym_This] = ACTIONS(6140),
    [anon_sym_decltype] = ACTIONS(6140),
    [anon_sym_explicit] = ACTIONS(6140),
    [anon_sym_typename] = ACTIONS(6140),
    [anon_sym_private] = ACTIONS(6140),
    [anon_sym_template] = ACTIONS(6140),
    [anon_sym_operator] = ACTIONS(6140),
    [anon_sym_friend] = ACTIONS(6140),
    [anon_sym_public] = ACTIONS(6140),
    [anon_sym_protected] = ACTIONS(6140),
    [anon_sym_static_assert] = ACTIONS(6140),
    [anon_sym_precise] = ACTIONS(6140),
    [anon_sym_shared] = ACTIONS(6140),
    [anon_sym_groupshared] = ACTIONS(6140),
    [anon_sym_uniform] = ACTIONS(6140),
    [anon_sym_row_major] = ACTIONS(6140),
    [anon_sym_column_major] = ACTIONS(6140),
    [anon_sym_globallycoherent] = ACTIONS(6140),
    [anon_sym_centroid] = ACTIONS(6140),
    [anon_sym_noperspective] = ACTIONS(6140),
    [anon_sym_nointerpolation] = ACTIONS(6140),
    [anon_sym_sample] = ACTIONS(6140),
    [anon_sym_linear] = ACTIONS(6140),
    [anon_sym_snorm] = ACTIONS(6140),
    [anon_sym_unorm] = ACTIONS(6140),
    [anon_sym_point] = ACTIONS(6140),
    [anon_sym_line] = ACTIONS(6140),
    [anon_sym_triangleadj] = ACTIONS(6140),
    [anon_sym_lineadj] = ACTIONS(6140),
    [anon_sym_triangle] = ACTIONS(6140),
    [anon_sym_interface] = ACTIONS(6140),
    [anon_sym_extension] = ACTIONS(6140),
    [anon_sym___init] = ACTIONS(6140),
    [anon_sym___subscript] = ACTIONS(6140),
    [anon_sym_property] = ACTIONS(6140),
    [anon_sym_associatedtype] = ACTIONS(6140),
  },
  [2087] = {
    [sym_identifier] = ACTIONS(6140),
    [aux_sym_preproc_def_token1] = ACTIONS(6140),
    [aux_sym_preproc_if_token1] = ACTIONS(6140),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6140),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6140),
    [sym_preproc_directive] = ACTIONS(6140),
    [anon_sym_LPAREN2] = ACTIONS(6142),
    [anon_sym_TILDE] = ACTIONS(6142),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_AMP_AMP] = ACTIONS(6142),
    [anon_sym_AMP] = ACTIONS(6140),
    [anon_sym_SEMI] = ACTIONS(6142),
    [anon_sym___extension__] = ACTIONS(6140),
    [anon_sym_typedef] = ACTIONS(6140),
    [anon_sym_in] = ACTIONS(6140),
    [anon_sym_out] = ACTIONS(6140),
    [anon_sym_inout] = ACTIONS(6140),
    [anon_sym_virtual] = ACTIONS(6140),
    [anon_sym_extern] = ACTIONS(6140),
    [anon_sym___attribute__] = ACTIONS(6140),
    [anon_sym___attribute] = ACTIONS(6140),
    [anon_sym_using] = ACTIONS(6140),
    [anon_sym_COLON_COLON] = ACTIONS(6142),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6142),
    [anon_sym___declspec] = ACTIONS(6140),
    [anon_sym___based] = ACTIONS(6140),
    [anon_sym_RBRACE] = ACTIONS(6142),
    [anon_sym_signed] = ACTIONS(6140),
    [anon_sym_unsigned] = ACTIONS(6140),
    [anon_sym_long] = ACTIONS(6140),
    [anon_sym_short] = ACTIONS(6140),
    [anon_sym_LBRACK] = ACTIONS(6140),
    [anon_sym_static] = ACTIONS(6140),
    [anon_sym_register] = ACTIONS(6140),
    [anon_sym_inline] = ACTIONS(6140),
    [anon_sym___inline] = ACTIONS(6140),
    [anon_sym___inline__] = ACTIONS(6140),
    [anon_sym___forceinline] = ACTIONS(6140),
    [anon_sym_thread_local] = ACTIONS(6140),
    [anon_sym___thread] = ACTIONS(6140),
    [anon_sym_const] = ACTIONS(6140),
    [anon_sym_constexpr] = ACTIONS(6140),
    [anon_sym_volatile] = ACTIONS(6140),
    [anon_sym_restrict] = ACTIONS(6140),
    [anon_sym___restrict__] = ACTIONS(6140),
    [anon_sym__Atomic] = ACTIONS(6140),
    [anon_sym__Noreturn] = ACTIONS(6140),
    [anon_sym_noreturn] = ACTIONS(6140),
    [anon_sym__Nonnull] = ACTIONS(6140),
    [anon_sym_mutable] = ACTIONS(6140),
    [anon_sym_constinit] = ACTIONS(6140),
    [anon_sym_consteval] = ACTIONS(6140),
    [anon_sym_alignas] = ACTIONS(6140),
    [anon_sym__Alignas] = ACTIONS(6140),
    [sym_primitive_type] = ACTIONS(6140),
    [anon_sym_enum] = ACTIONS(6140),
    [anon_sym_class] = ACTIONS(6140),
    [anon_sym_struct] = ACTIONS(6140),
    [anon_sym_union] = ACTIONS(6140),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6140),
    [anon_sym_let] = ACTIONS(6140),
    [anon_sym_This] = ACTIONS(6140),
    [anon_sym_decltype] = ACTIONS(6140),
    [anon_sym_explicit] = ACTIONS(6140),
    [anon_sym_typename] = ACTIONS(6140),
    [anon_sym_private] = ACTIONS(6140),
    [anon_sym_template] = ACTIONS(6140),
    [anon_sym_operator] = ACTIONS(6140),
    [anon_sym_friend] = ACTIONS(6140),
    [anon_sym_public] = ACTIONS(6140),
    [anon_sym_protected] = ACTIONS(6140),
    [anon_sym_static_assert] = ACTIONS(6140),
    [anon_sym_precise] = ACTIONS(6140),
    [anon_sym_shared] = ACTIONS(6140),
    [anon_sym_groupshared] = ACTIONS(6140),
    [anon_sym_uniform] = ACTIONS(6140),
    [anon_sym_row_major] = ACTIONS(6140),
    [anon_sym_column_major] = ACTIONS(6140),
    [anon_sym_globallycoherent] = ACTIONS(6140),
    [anon_sym_centroid] = ACTIONS(6140),
    [anon_sym_noperspective] = ACTIONS(6140),
    [anon_sym_nointerpolation] = ACTIONS(6140),
    [anon_sym_sample] = ACTIONS(6140),
    [anon_sym_linear] = ACTIONS(6140),
    [anon_sym_snorm] = ACTIONS(6140),
    [anon_sym_unorm] = ACTIONS(6140),
    [anon_sym_point] = ACTIONS(6140),
    [anon_sym_line] = ACTIONS(6140),
    [anon_sym_triangleadj] = ACTIONS(6140),
    [anon_sym_lineadj] = ACTIONS(6140),
    [anon_sym_triangle] = ACTIONS(6140),
    [anon_sym_interface] = ACTIONS(6140),
    [anon_sym_extension] = ACTIONS(6140),
    [anon_sym___init] = ACTIONS(6140),
    [anon_sym___subscript] = ACTIONS(6140),
    [anon_sym_property] = ACTIONS(6140),
    [anon_sym_associatedtype] = ACTIONS(6140),
  },
  [2088] = {
    [sym_identifier] = ACTIONS(6148),
    [aux_sym_preproc_def_token1] = ACTIONS(6148),
    [aux_sym_preproc_if_token1] = ACTIONS(6148),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6148),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6148),
    [sym_preproc_directive] = ACTIONS(6148),
    [anon_sym_LPAREN2] = ACTIONS(6150),
    [anon_sym_TILDE] = ACTIONS(6150),
    [anon_sym_STAR] = ACTIONS(6150),
    [anon_sym_AMP_AMP] = ACTIONS(6150),
    [anon_sym_AMP] = ACTIONS(6148),
    [anon_sym_SEMI] = ACTIONS(6150),
    [anon_sym___extension__] = ACTIONS(6148),
    [anon_sym_typedef] = ACTIONS(6148),
    [anon_sym_in] = ACTIONS(6148),
    [anon_sym_out] = ACTIONS(6148),
    [anon_sym_inout] = ACTIONS(6148),
    [anon_sym_virtual] = ACTIONS(6148),
    [anon_sym_extern] = ACTIONS(6148),
    [anon_sym___attribute__] = ACTIONS(6148),
    [anon_sym___attribute] = ACTIONS(6148),
    [anon_sym_using] = ACTIONS(6148),
    [anon_sym_COLON_COLON] = ACTIONS(6150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6150),
    [anon_sym___declspec] = ACTIONS(6148),
    [anon_sym___based] = ACTIONS(6148),
    [anon_sym_RBRACE] = ACTIONS(6150),
    [anon_sym_signed] = ACTIONS(6148),
    [anon_sym_unsigned] = ACTIONS(6148),
    [anon_sym_long] = ACTIONS(6148),
    [anon_sym_short] = ACTIONS(6148),
    [anon_sym_LBRACK] = ACTIONS(6148),
    [anon_sym_static] = ACTIONS(6148),
    [anon_sym_register] = ACTIONS(6148),
    [anon_sym_inline] = ACTIONS(6148),
    [anon_sym___inline] = ACTIONS(6148),
    [anon_sym___inline__] = ACTIONS(6148),
    [anon_sym___forceinline] = ACTIONS(6148),
    [anon_sym_thread_local] = ACTIONS(6148),
    [anon_sym___thread] = ACTIONS(6148),
    [anon_sym_const] = ACTIONS(6148),
    [anon_sym_constexpr] = ACTIONS(6148),
    [anon_sym_volatile] = ACTIONS(6148),
    [anon_sym_restrict] = ACTIONS(6148),
    [anon_sym___restrict__] = ACTIONS(6148),
    [anon_sym__Atomic] = ACTIONS(6148),
    [anon_sym__Noreturn] = ACTIONS(6148),
    [anon_sym_noreturn] = ACTIONS(6148),
    [anon_sym__Nonnull] = ACTIONS(6148),
    [anon_sym_mutable] = ACTIONS(6148),
    [anon_sym_constinit] = ACTIONS(6148),
    [anon_sym_consteval] = ACTIONS(6148),
    [anon_sym_alignas] = ACTIONS(6148),
    [anon_sym__Alignas] = ACTIONS(6148),
    [sym_primitive_type] = ACTIONS(6148),
    [anon_sym_enum] = ACTIONS(6148),
    [anon_sym_class] = ACTIONS(6148),
    [anon_sym_struct] = ACTIONS(6148),
    [anon_sym_union] = ACTIONS(6148),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6148),
    [anon_sym_let] = ACTIONS(6148),
    [anon_sym_This] = ACTIONS(6148),
    [anon_sym_decltype] = ACTIONS(6148),
    [anon_sym_explicit] = ACTIONS(6148),
    [anon_sym_typename] = ACTIONS(6148),
    [anon_sym_private] = ACTIONS(6148),
    [anon_sym_template] = ACTIONS(6148),
    [anon_sym_operator] = ACTIONS(6148),
    [anon_sym_friend] = ACTIONS(6148),
    [anon_sym_public] = ACTIONS(6148),
    [anon_sym_protected] = ACTIONS(6148),
    [anon_sym_static_assert] = ACTIONS(6148),
    [anon_sym_precise] = ACTIONS(6148),
    [anon_sym_shared] = ACTIONS(6148),
    [anon_sym_groupshared] = ACTIONS(6148),
    [anon_sym_uniform] = ACTIONS(6148),
    [anon_sym_row_major] = ACTIONS(6148),
    [anon_sym_column_major] = ACTIONS(6148),
    [anon_sym_globallycoherent] = ACTIONS(6148),
    [anon_sym_centroid] = ACTIONS(6148),
    [anon_sym_noperspective] = ACTIONS(6148),
    [anon_sym_nointerpolation] = ACTIONS(6148),
    [anon_sym_sample] = ACTIONS(6148),
    [anon_sym_linear] = ACTIONS(6148),
    [anon_sym_snorm] = ACTIONS(6148),
    [anon_sym_unorm] = ACTIONS(6148),
    [anon_sym_point] = ACTIONS(6148),
    [anon_sym_line] = ACTIONS(6148),
    [anon_sym_triangleadj] = ACTIONS(6148),
    [anon_sym_lineadj] = ACTIONS(6148),
    [anon_sym_triangle] = ACTIONS(6148),
    [anon_sym_interface] = ACTIONS(6148),
    [anon_sym_extension] = ACTIONS(6148),
    [anon_sym___init] = ACTIONS(6148),
    [anon_sym___subscript] = ACTIONS(6148),
    [anon_sym_property] = ACTIONS(6148),
    [anon_sym_associatedtype] = ACTIONS(6148),
  },
  [2089] = {
    [sym_identifier] = ACTIONS(6152),
    [aux_sym_preproc_def_token1] = ACTIONS(6152),
    [aux_sym_preproc_if_token1] = ACTIONS(6152),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6152),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6152),
    [sym_preproc_directive] = ACTIONS(6152),
    [anon_sym_LPAREN2] = ACTIONS(6154),
    [anon_sym_TILDE] = ACTIONS(6154),
    [anon_sym_STAR] = ACTIONS(6154),
    [anon_sym_AMP_AMP] = ACTIONS(6154),
    [anon_sym_AMP] = ACTIONS(6152),
    [anon_sym_SEMI] = ACTIONS(6154),
    [anon_sym___extension__] = ACTIONS(6152),
    [anon_sym_typedef] = ACTIONS(6152),
    [anon_sym_in] = ACTIONS(6152),
    [anon_sym_out] = ACTIONS(6152),
    [anon_sym_inout] = ACTIONS(6152),
    [anon_sym_virtual] = ACTIONS(6152),
    [anon_sym_extern] = ACTIONS(6152),
    [anon_sym___attribute__] = ACTIONS(6152),
    [anon_sym___attribute] = ACTIONS(6152),
    [anon_sym_using] = ACTIONS(6152),
    [anon_sym_COLON_COLON] = ACTIONS(6154),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6154),
    [anon_sym___declspec] = ACTIONS(6152),
    [anon_sym___based] = ACTIONS(6152),
    [anon_sym_RBRACE] = ACTIONS(6154),
    [anon_sym_signed] = ACTIONS(6152),
    [anon_sym_unsigned] = ACTIONS(6152),
    [anon_sym_long] = ACTIONS(6152),
    [anon_sym_short] = ACTIONS(6152),
    [anon_sym_LBRACK] = ACTIONS(6152),
    [anon_sym_static] = ACTIONS(6152),
    [anon_sym_register] = ACTIONS(6152),
    [anon_sym_inline] = ACTIONS(6152),
    [anon_sym___inline] = ACTIONS(6152),
    [anon_sym___inline__] = ACTIONS(6152),
    [anon_sym___forceinline] = ACTIONS(6152),
    [anon_sym_thread_local] = ACTIONS(6152),
    [anon_sym___thread] = ACTIONS(6152),
    [anon_sym_const] = ACTIONS(6152),
    [anon_sym_constexpr] = ACTIONS(6152),
    [anon_sym_volatile] = ACTIONS(6152),
    [anon_sym_restrict] = ACTIONS(6152),
    [anon_sym___restrict__] = ACTIONS(6152),
    [anon_sym__Atomic] = ACTIONS(6152),
    [anon_sym__Noreturn] = ACTIONS(6152),
    [anon_sym_noreturn] = ACTIONS(6152),
    [anon_sym__Nonnull] = ACTIONS(6152),
    [anon_sym_mutable] = ACTIONS(6152),
    [anon_sym_constinit] = ACTIONS(6152),
    [anon_sym_consteval] = ACTIONS(6152),
    [anon_sym_alignas] = ACTIONS(6152),
    [anon_sym__Alignas] = ACTIONS(6152),
    [sym_primitive_type] = ACTIONS(6152),
    [anon_sym_enum] = ACTIONS(6152),
    [anon_sym_class] = ACTIONS(6152),
    [anon_sym_struct] = ACTIONS(6152),
    [anon_sym_union] = ACTIONS(6152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6152),
    [anon_sym_let] = ACTIONS(6152),
    [anon_sym_This] = ACTIONS(6152),
    [anon_sym_decltype] = ACTIONS(6152),
    [anon_sym_explicit] = ACTIONS(6152),
    [anon_sym_typename] = ACTIONS(6152),
    [anon_sym_private] = ACTIONS(6152),
    [anon_sym_template] = ACTIONS(6152),
    [anon_sym_operator] = ACTIONS(6152),
    [anon_sym_friend] = ACTIONS(6152),
    [anon_sym_public] = ACTIONS(6152),
    [anon_sym_protected] = ACTIONS(6152),
    [anon_sym_static_assert] = ACTIONS(6152),
    [anon_sym_precise] = ACTIONS(6152),
    [anon_sym_shared] = ACTIONS(6152),
    [anon_sym_groupshared] = ACTIONS(6152),
    [anon_sym_uniform] = ACTIONS(6152),
    [anon_sym_row_major] = ACTIONS(6152),
    [anon_sym_column_major] = ACTIONS(6152),
    [anon_sym_globallycoherent] = ACTIONS(6152),
    [anon_sym_centroid] = ACTIONS(6152),
    [anon_sym_noperspective] = ACTIONS(6152),
    [anon_sym_nointerpolation] = ACTIONS(6152),
    [anon_sym_sample] = ACTIONS(6152),
    [anon_sym_linear] = ACTIONS(6152),
    [anon_sym_snorm] = ACTIONS(6152),
    [anon_sym_unorm] = ACTIONS(6152),
    [anon_sym_point] = ACTIONS(6152),
    [anon_sym_line] = ACTIONS(6152),
    [anon_sym_triangleadj] = ACTIONS(6152),
    [anon_sym_lineadj] = ACTIONS(6152),
    [anon_sym_triangle] = ACTIONS(6152),
    [anon_sym_interface] = ACTIONS(6152),
    [anon_sym_extension] = ACTIONS(6152),
    [anon_sym___init] = ACTIONS(6152),
    [anon_sym___subscript] = ACTIONS(6152),
    [anon_sym_property] = ACTIONS(6152),
    [anon_sym_associatedtype] = ACTIONS(6152),
  },
  [2090] = {
    [sym_expression] = STATE(5929),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2091] = {
    [sym_identifier] = ACTIONS(3885),
    [aux_sym_preproc_def_token1] = ACTIONS(3885),
    [aux_sym_preproc_if_token1] = ACTIONS(3885),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3885),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3885),
    [sym_preproc_directive] = ACTIONS(3885),
    [anon_sym_LPAREN2] = ACTIONS(3887),
    [anon_sym_TILDE] = ACTIONS(3887),
    [anon_sym_STAR] = ACTIONS(3887),
    [anon_sym_AMP_AMP] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3885),
    [anon_sym_SEMI] = ACTIONS(3887),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_typedef] = ACTIONS(3885),
    [anon_sym_in] = ACTIONS(3885),
    [anon_sym_out] = ACTIONS(3885),
    [anon_sym_inout] = ACTIONS(3885),
    [anon_sym_virtual] = ACTIONS(3885),
    [anon_sym_extern] = ACTIONS(3885),
    [anon_sym___attribute__] = ACTIONS(3885),
    [anon_sym___attribute] = ACTIONS(3885),
    [anon_sym_using] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3887),
    [anon_sym___declspec] = ACTIONS(3885),
    [anon_sym___based] = ACTIONS(3885),
    [anon_sym_RBRACE] = ACTIONS(3887),
    [anon_sym_signed] = ACTIONS(3885),
    [anon_sym_unsigned] = ACTIONS(3885),
    [anon_sym_long] = ACTIONS(3885),
    [anon_sym_short] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_static] = ACTIONS(3885),
    [anon_sym_register] = ACTIONS(3885),
    [anon_sym_inline] = ACTIONS(3885),
    [anon_sym___inline] = ACTIONS(3885),
    [anon_sym___inline__] = ACTIONS(3885),
    [anon_sym___forceinline] = ACTIONS(3885),
    [anon_sym_thread_local] = ACTIONS(3885),
    [anon_sym___thread] = ACTIONS(3885),
    [anon_sym_const] = ACTIONS(3885),
    [anon_sym_constexpr] = ACTIONS(3885),
    [anon_sym_volatile] = ACTIONS(3885),
    [anon_sym_restrict] = ACTIONS(3885),
    [anon_sym___restrict__] = ACTIONS(3885),
    [anon_sym__Atomic] = ACTIONS(3885),
    [anon_sym__Noreturn] = ACTIONS(3885),
    [anon_sym_noreturn] = ACTIONS(3885),
    [anon_sym__Nonnull] = ACTIONS(3885),
    [anon_sym_mutable] = ACTIONS(3885),
    [anon_sym_constinit] = ACTIONS(3885),
    [anon_sym_consteval] = ACTIONS(3885),
    [anon_sym_alignas] = ACTIONS(3885),
    [anon_sym__Alignas] = ACTIONS(3885),
    [sym_primitive_type] = ACTIONS(3885),
    [anon_sym_enum] = ACTIONS(3885),
    [anon_sym_class] = ACTIONS(3885),
    [anon_sym_struct] = ACTIONS(3885),
    [anon_sym_union] = ACTIONS(3885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3885),
    [anon_sym_let] = ACTIONS(3885),
    [anon_sym_This] = ACTIONS(3885),
    [anon_sym_decltype] = ACTIONS(3885),
    [anon_sym_explicit] = ACTIONS(3885),
    [anon_sym_typename] = ACTIONS(3885),
    [anon_sym_private] = ACTIONS(3885),
    [anon_sym_template] = ACTIONS(3885),
    [anon_sym_operator] = ACTIONS(3885),
    [anon_sym_friend] = ACTIONS(3885),
    [anon_sym_public] = ACTIONS(3885),
    [anon_sym_protected] = ACTIONS(3885),
    [anon_sym_static_assert] = ACTIONS(3885),
    [anon_sym_precise] = ACTIONS(3885),
    [anon_sym_shared] = ACTIONS(3885),
    [anon_sym_groupshared] = ACTIONS(3885),
    [anon_sym_uniform] = ACTIONS(3885),
    [anon_sym_row_major] = ACTIONS(3885),
    [anon_sym_column_major] = ACTIONS(3885),
    [anon_sym_globallycoherent] = ACTIONS(3885),
    [anon_sym_centroid] = ACTIONS(3885),
    [anon_sym_noperspective] = ACTIONS(3885),
    [anon_sym_nointerpolation] = ACTIONS(3885),
    [anon_sym_sample] = ACTIONS(3885),
    [anon_sym_linear] = ACTIONS(3885),
    [anon_sym_snorm] = ACTIONS(3885),
    [anon_sym_unorm] = ACTIONS(3885),
    [anon_sym_point] = ACTIONS(3885),
    [anon_sym_line] = ACTIONS(3885),
    [anon_sym_triangleadj] = ACTIONS(3885),
    [anon_sym_lineadj] = ACTIONS(3885),
    [anon_sym_triangle] = ACTIONS(3885),
    [anon_sym_interface] = ACTIONS(3885),
    [anon_sym_extension] = ACTIONS(3885),
    [anon_sym___init] = ACTIONS(3885),
    [anon_sym___subscript] = ACTIONS(3885),
    [anon_sym_property] = ACTIONS(3885),
    [anon_sym_associatedtype] = ACTIONS(3885),
  },
  [2092] = {
    [sym_expression] = STATE(5517),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2093] = {
    [sym_expression] = STATE(5908),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2094] = {
    [sym_expression] = STATE(5522),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2095] = {
    [sym_identifier] = ACTIONS(3691),
    [aux_sym_preproc_def_token1] = ACTIONS(3691),
    [aux_sym_preproc_if_token1] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3691),
    [sym_preproc_directive] = ACTIONS(3691),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3693),
    [anon_sym_STAR] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_AMP] = ACTIONS(3691),
    [anon_sym_SEMI] = ACTIONS(3693),
    [anon_sym___extension__] = ACTIONS(3691),
    [anon_sym_typedef] = ACTIONS(3691),
    [anon_sym_in] = ACTIONS(3691),
    [anon_sym_out] = ACTIONS(3691),
    [anon_sym_inout] = ACTIONS(3691),
    [anon_sym_virtual] = ACTIONS(3691),
    [anon_sym_extern] = ACTIONS(3691),
    [anon_sym___attribute__] = ACTIONS(3691),
    [anon_sym___attribute] = ACTIONS(3691),
    [anon_sym_using] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3693),
    [anon_sym___declspec] = ACTIONS(3691),
    [anon_sym___based] = ACTIONS(3691),
    [anon_sym_RBRACE] = ACTIONS(3693),
    [anon_sym_signed] = ACTIONS(3691),
    [anon_sym_unsigned] = ACTIONS(3691),
    [anon_sym_long] = ACTIONS(3691),
    [anon_sym_short] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(3691),
    [anon_sym_static] = ACTIONS(3691),
    [anon_sym_register] = ACTIONS(3691),
    [anon_sym_inline] = ACTIONS(3691),
    [anon_sym___inline] = ACTIONS(3691),
    [anon_sym___inline__] = ACTIONS(3691),
    [anon_sym___forceinline] = ACTIONS(3691),
    [anon_sym_thread_local] = ACTIONS(3691),
    [anon_sym___thread] = ACTIONS(3691),
    [anon_sym_const] = ACTIONS(3691),
    [anon_sym_constexpr] = ACTIONS(3691),
    [anon_sym_volatile] = ACTIONS(3691),
    [anon_sym_restrict] = ACTIONS(3691),
    [anon_sym___restrict__] = ACTIONS(3691),
    [anon_sym__Atomic] = ACTIONS(3691),
    [anon_sym__Noreturn] = ACTIONS(3691),
    [anon_sym_noreturn] = ACTIONS(3691),
    [anon_sym__Nonnull] = ACTIONS(3691),
    [anon_sym_mutable] = ACTIONS(3691),
    [anon_sym_constinit] = ACTIONS(3691),
    [anon_sym_consteval] = ACTIONS(3691),
    [anon_sym_alignas] = ACTIONS(3691),
    [anon_sym__Alignas] = ACTIONS(3691),
    [sym_primitive_type] = ACTIONS(3691),
    [anon_sym_enum] = ACTIONS(3691),
    [anon_sym_class] = ACTIONS(3691),
    [anon_sym_struct] = ACTIONS(3691),
    [anon_sym_union] = ACTIONS(3691),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3691),
    [anon_sym_let] = ACTIONS(3691),
    [anon_sym_This] = ACTIONS(3691),
    [anon_sym_decltype] = ACTIONS(3691),
    [anon_sym_explicit] = ACTIONS(3691),
    [anon_sym_typename] = ACTIONS(3691),
    [anon_sym_private] = ACTIONS(3691),
    [anon_sym_template] = ACTIONS(3691),
    [anon_sym_operator] = ACTIONS(3691),
    [anon_sym_friend] = ACTIONS(3691),
    [anon_sym_public] = ACTIONS(3691),
    [anon_sym_protected] = ACTIONS(3691),
    [anon_sym_static_assert] = ACTIONS(3691),
    [anon_sym_precise] = ACTIONS(3691),
    [anon_sym_shared] = ACTIONS(3691),
    [anon_sym_groupshared] = ACTIONS(3691),
    [anon_sym_uniform] = ACTIONS(3691),
    [anon_sym_row_major] = ACTIONS(3691),
    [anon_sym_column_major] = ACTIONS(3691),
    [anon_sym_globallycoherent] = ACTIONS(3691),
    [anon_sym_centroid] = ACTIONS(3691),
    [anon_sym_noperspective] = ACTIONS(3691),
    [anon_sym_nointerpolation] = ACTIONS(3691),
    [anon_sym_sample] = ACTIONS(3691),
    [anon_sym_linear] = ACTIONS(3691),
    [anon_sym_snorm] = ACTIONS(3691),
    [anon_sym_unorm] = ACTIONS(3691),
    [anon_sym_point] = ACTIONS(3691),
    [anon_sym_line] = ACTIONS(3691),
    [anon_sym_triangleadj] = ACTIONS(3691),
    [anon_sym_lineadj] = ACTIONS(3691),
    [anon_sym_triangle] = ACTIONS(3691),
    [anon_sym_interface] = ACTIONS(3691),
    [anon_sym_extension] = ACTIONS(3691),
    [anon_sym___init] = ACTIONS(3691),
    [anon_sym___subscript] = ACTIONS(3691),
    [anon_sym_property] = ACTIONS(3691),
    [anon_sym_associatedtype] = ACTIONS(3691),
  },
  [2096] = {
    [sym_expression] = STATE(5662),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2097] = {
    [sym_identifier] = ACTIONS(3695),
    [aux_sym_preproc_def_token1] = ACTIONS(3695),
    [aux_sym_preproc_if_token1] = ACTIONS(3695),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3695),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3695),
    [sym_preproc_directive] = ACTIONS(3695),
    [anon_sym_LPAREN2] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3697),
    [anon_sym_STAR] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3695),
    [anon_sym_SEMI] = ACTIONS(3697),
    [anon_sym___extension__] = ACTIONS(3695),
    [anon_sym_typedef] = ACTIONS(3695),
    [anon_sym_in] = ACTIONS(3695),
    [anon_sym_out] = ACTIONS(3695),
    [anon_sym_inout] = ACTIONS(3695),
    [anon_sym_virtual] = ACTIONS(3695),
    [anon_sym_extern] = ACTIONS(3695),
    [anon_sym___attribute__] = ACTIONS(3695),
    [anon_sym___attribute] = ACTIONS(3695),
    [anon_sym_using] = ACTIONS(3695),
    [anon_sym_COLON_COLON] = ACTIONS(3697),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3697),
    [anon_sym___declspec] = ACTIONS(3695),
    [anon_sym___based] = ACTIONS(3695),
    [anon_sym_RBRACE] = ACTIONS(3697),
    [anon_sym_signed] = ACTIONS(3695),
    [anon_sym_unsigned] = ACTIONS(3695),
    [anon_sym_long] = ACTIONS(3695),
    [anon_sym_short] = ACTIONS(3695),
    [anon_sym_LBRACK] = ACTIONS(3695),
    [anon_sym_static] = ACTIONS(3695),
    [anon_sym_register] = ACTIONS(3695),
    [anon_sym_inline] = ACTIONS(3695),
    [anon_sym___inline] = ACTIONS(3695),
    [anon_sym___inline__] = ACTIONS(3695),
    [anon_sym___forceinline] = ACTIONS(3695),
    [anon_sym_thread_local] = ACTIONS(3695),
    [anon_sym___thread] = ACTIONS(3695),
    [anon_sym_const] = ACTIONS(3695),
    [anon_sym_constexpr] = ACTIONS(3695),
    [anon_sym_volatile] = ACTIONS(3695),
    [anon_sym_restrict] = ACTIONS(3695),
    [anon_sym___restrict__] = ACTIONS(3695),
    [anon_sym__Atomic] = ACTIONS(3695),
    [anon_sym__Noreturn] = ACTIONS(3695),
    [anon_sym_noreturn] = ACTIONS(3695),
    [anon_sym__Nonnull] = ACTIONS(3695),
    [anon_sym_mutable] = ACTIONS(3695),
    [anon_sym_constinit] = ACTIONS(3695),
    [anon_sym_consteval] = ACTIONS(3695),
    [anon_sym_alignas] = ACTIONS(3695),
    [anon_sym__Alignas] = ACTIONS(3695),
    [sym_primitive_type] = ACTIONS(3695),
    [anon_sym_enum] = ACTIONS(3695),
    [anon_sym_class] = ACTIONS(3695),
    [anon_sym_struct] = ACTIONS(3695),
    [anon_sym_union] = ACTIONS(3695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3695),
    [anon_sym_let] = ACTIONS(3695),
    [anon_sym_This] = ACTIONS(3695),
    [anon_sym_decltype] = ACTIONS(3695),
    [anon_sym_explicit] = ACTIONS(3695),
    [anon_sym_typename] = ACTIONS(3695),
    [anon_sym_private] = ACTIONS(3695),
    [anon_sym_template] = ACTIONS(3695),
    [anon_sym_operator] = ACTIONS(3695),
    [anon_sym_friend] = ACTIONS(3695),
    [anon_sym_public] = ACTIONS(3695),
    [anon_sym_protected] = ACTIONS(3695),
    [anon_sym_static_assert] = ACTIONS(3695),
    [anon_sym_precise] = ACTIONS(3695),
    [anon_sym_shared] = ACTIONS(3695),
    [anon_sym_groupshared] = ACTIONS(3695),
    [anon_sym_uniform] = ACTIONS(3695),
    [anon_sym_row_major] = ACTIONS(3695),
    [anon_sym_column_major] = ACTIONS(3695),
    [anon_sym_globallycoherent] = ACTIONS(3695),
    [anon_sym_centroid] = ACTIONS(3695),
    [anon_sym_noperspective] = ACTIONS(3695),
    [anon_sym_nointerpolation] = ACTIONS(3695),
    [anon_sym_sample] = ACTIONS(3695),
    [anon_sym_linear] = ACTIONS(3695),
    [anon_sym_snorm] = ACTIONS(3695),
    [anon_sym_unorm] = ACTIONS(3695),
    [anon_sym_point] = ACTIONS(3695),
    [anon_sym_line] = ACTIONS(3695),
    [anon_sym_triangleadj] = ACTIONS(3695),
    [anon_sym_lineadj] = ACTIONS(3695),
    [anon_sym_triangle] = ACTIONS(3695),
    [anon_sym_interface] = ACTIONS(3695),
    [anon_sym_extension] = ACTIONS(3695),
    [anon_sym___init] = ACTIONS(3695),
    [anon_sym___subscript] = ACTIONS(3695),
    [anon_sym_property] = ACTIONS(3695),
    [anon_sym_associatedtype] = ACTIONS(3695),
  },
  [2098] = {
    [sym_identifier] = ACTIONS(3699),
    [aux_sym_preproc_def_token1] = ACTIONS(3699),
    [aux_sym_preproc_if_token1] = ACTIONS(3699),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3699),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3699),
    [sym_preproc_directive] = ACTIONS(3699),
    [anon_sym_LPAREN2] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3701),
    [anon_sym_AMP_AMP] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(3701),
    [anon_sym___extension__] = ACTIONS(3699),
    [anon_sym_typedef] = ACTIONS(3699),
    [anon_sym_in] = ACTIONS(3699),
    [anon_sym_out] = ACTIONS(3699),
    [anon_sym_inout] = ACTIONS(3699),
    [anon_sym_virtual] = ACTIONS(3699),
    [anon_sym_extern] = ACTIONS(3699),
    [anon_sym___attribute__] = ACTIONS(3699),
    [anon_sym___attribute] = ACTIONS(3699),
    [anon_sym_using] = ACTIONS(3699),
    [anon_sym_COLON_COLON] = ACTIONS(3701),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3701),
    [anon_sym___declspec] = ACTIONS(3699),
    [anon_sym___based] = ACTIONS(3699),
    [anon_sym_RBRACE] = ACTIONS(3701),
    [anon_sym_signed] = ACTIONS(3699),
    [anon_sym_unsigned] = ACTIONS(3699),
    [anon_sym_long] = ACTIONS(3699),
    [anon_sym_short] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(3699),
    [anon_sym_static] = ACTIONS(3699),
    [anon_sym_register] = ACTIONS(3699),
    [anon_sym_inline] = ACTIONS(3699),
    [anon_sym___inline] = ACTIONS(3699),
    [anon_sym___inline__] = ACTIONS(3699),
    [anon_sym___forceinline] = ACTIONS(3699),
    [anon_sym_thread_local] = ACTIONS(3699),
    [anon_sym___thread] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3699),
    [anon_sym_constexpr] = ACTIONS(3699),
    [anon_sym_volatile] = ACTIONS(3699),
    [anon_sym_restrict] = ACTIONS(3699),
    [anon_sym___restrict__] = ACTIONS(3699),
    [anon_sym__Atomic] = ACTIONS(3699),
    [anon_sym__Noreturn] = ACTIONS(3699),
    [anon_sym_noreturn] = ACTIONS(3699),
    [anon_sym__Nonnull] = ACTIONS(3699),
    [anon_sym_mutable] = ACTIONS(3699),
    [anon_sym_constinit] = ACTIONS(3699),
    [anon_sym_consteval] = ACTIONS(3699),
    [anon_sym_alignas] = ACTIONS(3699),
    [anon_sym__Alignas] = ACTIONS(3699),
    [sym_primitive_type] = ACTIONS(3699),
    [anon_sym_enum] = ACTIONS(3699),
    [anon_sym_class] = ACTIONS(3699),
    [anon_sym_struct] = ACTIONS(3699),
    [anon_sym_union] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3699),
    [anon_sym_let] = ACTIONS(3699),
    [anon_sym_This] = ACTIONS(3699),
    [anon_sym_decltype] = ACTIONS(3699),
    [anon_sym_explicit] = ACTIONS(3699),
    [anon_sym_typename] = ACTIONS(3699),
    [anon_sym_private] = ACTIONS(3699),
    [anon_sym_template] = ACTIONS(3699),
    [anon_sym_operator] = ACTIONS(3699),
    [anon_sym_friend] = ACTIONS(3699),
    [anon_sym_public] = ACTIONS(3699),
    [anon_sym_protected] = ACTIONS(3699),
    [anon_sym_static_assert] = ACTIONS(3699),
    [anon_sym_precise] = ACTIONS(3699),
    [anon_sym_shared] = ACTIONS(3699),
    [anon_sym_groupshared] = ACTIONS(3699),
    [anon_sym_uniform] = ACTIONS(3699),
    [anon_sym_row_major] = ACTIONS(3699),
    [anon_sym_column_major] = ACTIONS(3699),
    [anon_sym_globallycoherent] = ACTIONS(3699),
    [anon_sym_centroid] = ACTIONS(3699),
    [anon_sym_noperspective] = ACTIONS(3699),
    [anon_sym_nointerpolation] = ACTIONS(3699),
    [anon_sym_sample] = ACTIONS(3699),
    [anon_sym_linear] = ACTIONS(3699),
    [anon_sym_snorm] = ACTIONS(3699),
    [anon_sym_unorm] = ACTIONS(3699),
    [anon_sym_point] = ACTIONS(3699),
    [anon_sym_line] = ACTIONS(3699),
    [anon_sym_triangleadj] = ACTIONS(3699),
    [anon_sym_lineadj] = ACTIONS(3699),
    [anon_sym_triangle] = ACTIONS(3699),
    [anon_sym_interface] = ACTIONS(3699),
    [anon_sym_extension] = ACTIONS(3699),
    [anon_sym___init] = ACTIONS(3699),
    [anon_sym___subscript] = ACTIONS(3699),
    [anon_sym_property] = ACTIONS(3699),
    [anon_sym_associatedtype] = ACTIONS(3699),
  },
  [2099] = {
    [sym_identifier] = ACTIONS(3703),
    [aux_sym_preproc_def_token1] = ACTIONS(3703),
    [aux_sym_preproc_if_token1] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3703),
    [sym_preproc_directive] = ACTIONS(3703),
    [anon_sym_LPAREN2] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3705),
    [anon_sym_STAR] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_AMP] = ACTIONS(3703),
    [anon_sym_SEMI] = ACTIONS(3705),
    [anon_sym___extension__] = ACTIONS(3703),
    [anon_sym_typedef] = ACTIONS(3703),
    [anon_sym_in] = ACTIONS(3703),
    [anon_sym_out] = ACTIONS(3703),
    [anon_sym_inout] = ACTIONS(3703),
    [anon_sym_virtual] = ACTIONS(3703),
    [anon_sym_extern] = ACTIONS(3703),
    [anon_sym___attribute__] = ACTIONS(3703),
    [anon_sym___attribute] = ACTIONS(3703),
    [anon_sym_using] = ACTIONS(3703),
    [anon_sym_COLON_COLON] = ACTIONS(3705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3705),
    [anon_sym___declspec] = ACTIONS(3703),
    [anon_sym___based] = ACTIONS(3703),
    [anon_sym_RBRACE] = ACTIONS(3705),
    [anon_sym_signed] = ACTIONS(3703),
    [anon_sym_unsigned] = ACTIONS(3703),
    [anon_sym_long] = ACTIONS(3703),
    [anon_sym_short] = ACTIONS(3703),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_static] = ACTIONS(3703),
    [anon_sym_register] = ACTIONS(3703),
    [anon_sym_inline] = ACTIONS(3703),
    [anon_sym___inline] = ACTIONS(3703),
    [anon_sym___inline__] = ACTIONS(3703),
    [anon_sym___forceinline] = ACTIONS(3703),
    [anon_sym_thread_local] = ACTIONS(3703),
    [anon_sym___thread] = ACTIONS(3703),
    [anon_sym_const] = ACTIONS(3703),
    [anon_sym_constexpr] = ACTIONS(3703),
    [anon_sym_volatile] = ACTIONS(3703),
    [anon_sym_restrict] = ACTIONS(3703),
    [anon_sym___restrict__] = ACTIONS(3703),
    [anon_sym__Atomic] = ACTIONS(3703),
    [anon_sym__Noreturn] = ACTIONS(3703),
    [anon_sym_noreturn] = ACTIONS(3703),
    [anon_sym__Nonnull] = ACTIONS(3703),
    [anon_sym_mutable] = ACTIONS(3703),
    [anon_sym_constinit] = ACTIONS(3703),
    [anon_sym_consteval] = ACTIONS(3703),
    [anon_sym_alignas] = ACTIONS(3703),
    [anon_sym__Alignas] = ACTIONS(3703),
    [sym_primitive_type] = ACTIONS(3703),
    [anon_sym_enum] = ACTIONS(3703),
    [anon_sym_class] = ACTIONS(3703),
    [anon_sym_struct] = ACTIONS(3703),
    [anon_sym_union] = ACTIONS(3703),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3703),
    [anon_sym_let] = ACTIONS(3703),
    [anon_sym_This] = ACTIONS(3703),
    [anon_sym_decltype] = ACTIONS(3703),
    [anon_sym_explicit] = ACTIONS(3703),
    [anon_sym_typename] = ACTIONS(3703),
    [anon_sym_private] = ACTIONS(3703),
    [anon_sym_template] = ACTIONS(3703),
    [anon_sym_operator] = ACTIONS(3703),
    [anon_sym_friend] = ACTIONS(3703),
    [anon_sym_public] = ACTIONS(3703),
    [anon_sym_protected] = ACTIONS(3703),
    [anon_sym_static_assert] = ACTIONS(3703),
    [anon_sym_precise] = ACTIONS(3703),
    [anon_sym_shared] = ACTIONS(3703),
    [anon_sym_groupshared] = ACTIONS(3703),
    [anon_sym_uniform] = ACTIONS(3703),
    [anon_sym_row_major] = ACTIONS(3703),
    [anon_sym_column_major] = ACTIONS(3703),
    [anon_sym_globallycoherent] = ACTIONS(3703),
    [anon_sym_centroid] = ACTIONS(3703),
    [anon_sym_noperspective] = ACTIONS(3703),
    [anon_sym_nointerpolation] = ACTIONS(3703),
    [anon_sym_sample] = ACTIONS(3703),
    [anon_sym_linear] = ACTIONS(3703),
    [anon_sym_snorm] = ACTIONS(3703),
    [anon_sym_unorm] = ACTIONS(3703),
    [anon_sym_point] = ACTIONS(3703),
    [anon_sym_line] = ACTIONS(3703),
    [anon_sym_triangleadj] = ACTIONS(3703),
    [anon_sym_lineadj] = ACTIONS(3703),
    [anon_sym_triangle] = ACTIONS(3703),
    [anon_sym_interface] = ACTIONS(3703),
    [anon_sym_extension] = ACTIONS(3703),
    [anon_sym___init] = ACTIONS(3703),
    [anon_sym___subscript] = ACTIONS(3703),
    [anon_sym_property] = ACTIONS(3703),
    [anon_sym_associatedtype] = ACTIONS(3703),
  },
  [2100] = {
    [sym_identifier] = ACTIONS(3707),
    [aux_sym_preproc_def_token1] = ACTIONS(3707),
    [aux_sym_preproc_if_token1] = ACTIONS(3707),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3707),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3707),
    [sym_preproc_directive] = ACTIONS(3707),
    [anon_sym_LPAREN2] = ACTIONS(3709),
    [anon_sym_TILDE] = ACTIONS(3709),
    [anon_sym_STAR] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(3707),
    [anon_sym_SEMI] = ACTIONS(3709),
    [anon_sym___extension__] = ACTIONS(3707),
    [anon_sym_typedef] = ACTIONS(3707),
    [anon_sym_in] = ACTIONS(3707),
    [anon_sym_out] = ACTIONS(3707),
    [anon_sym_inout] = ACTIONS(3707),
    [anon_sym_virtual] = ACTIONS(3707),
    [anon_sym_extern] = ACTIONS(3707),
    [anon_sym___attribute__] = ACTIONS(3707),
    [anon_sym___attribute] = ACTIONS(3707),
    [anon_sym_using] = ACTIONS(3707),
    [anon_sym_COLON_COLON] = ACTIONS(3709),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3709),
    [anon_sym___declspec] = ACTIONS(3707),
    [anon_sym___based] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3709),
    [anon_sym_signed] = ACTIONS(3707),
    [anon_sym_unsigned] = ACTIONS(3707),
    [anon_sym_long] = ACTIONS(3707),
    [anon_sym_short] = ACTIONS(3707),
    [anon_sym_LBRACK] = ACTIONS(3707),
    [anon_sym_static] = ACTIONS(3707),
    [anon_sym_register] = ACTIONS(3707),
    [anon_sym_inline] = ACTIONS(3707),
    [anon_sym___inline] = ACTIONS(3707),
    [anon_sym___inline__] = ACTIONS(3707),
    [anon_sym___forceinline] = ACTIONS(3707),
    [anon_sym_thread_local] = ACTIONS(3707),
    [anon_sym___thread] = ACTIONS(3707),
    [anon_sym_const] = ACTIONS(3707),
    [anon_sym_constexpr] = ACTIONS(3707),
    [anon_sym_volatile] = ACTIONS(3707),
    [anon_sym_restrict] = ACTIONS(3707),
    [anon_sym___restrict__] = ACTIONS(3707),
    [anon_sym__Atomic] = ACTIONS(3707),
    [anon_sym__Noreturn] = ACTIONS(3707),
    [anon_sym_noreturn] = ACTIONS(3707),
    [anon_sym__Nonnull] = ACTIONS(3707),
    [anon_sym_mutable] = ACTIONS(3707),
    [anon_sym_constinit] = ACTIONS(3707),
    [anon_sym_consteval] = ACTIONS(3707),
    [anon_sym_alignas] = ACTIONS(3707),
    [anon_sym__Alignas] = ACTIONS(3707),
    [sym_primitive_type] = ACTIONS(3707),
    [anon_sym_enum] = ACTIONS(3707),
    [anon_sym_class] = ACTIONS(3707),
    [anon_sym_struct] = ACTIONS(3707),
    [anon_sym_union] = ACTIONS(3707),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3707),
    [anon_sym_let] = ACTIONS(3707),
    [anon_sym_This] = ACTIONS(3707),
    [anon_sym_decltype] = ACTIONS(3707),
    [anon_sym_explicit] = ACTIONS(3707),
    [anon_sym_typename] = ACTIONS(3707),
    [anon_sym_private] = ACTIONS(3707),
    [anon_sym_template] = ACTIONS(3707),
    [anon_sym_operator] = ACTIONS(3707),
    [anon_sym_friend] = ACTIONS(3707),
    [anon_sym_public] = ACTIONS(3707),
    [anon_sym_protected] = ACTIONS(3707),
    [anon_sym_static_assert] = ACTIONS(3707),
    [anon_sym_precise] = ACTIONS(3707),
    [anon_sym_shared] = ACTIONS(3707),
    [anon_sym_groupshared] = ACTIONS(3707),
    [anon_sym_uniform] = ACTIONS(3707),
    [anon_sym_row_major] = ACTIONS(3707),
    [anon_sym_column_major] = ACTIONS(3707),
    [anon_sym_globallycoherent] = ACTIONS(3707),
    [anon_sym_centroid] = ACTIONS(3707),
    [anon_sym_noperspective] = ACTIONS(3707),
    [anon_sym_nointerpolation] = ACTIONS(3707),
    [anon_sym_sample] = ACTIONS(3707),
    [anon_sym_linear] = ACTIONS(3707),
    [anon_sym_snorm] = ACTIONS(3707),
    [anon_sym_unorm] = ACTIONS(3707),
    [anon_sym_point] = ACTIONS(3707),
    [anon_sym_line] = ACTIONS(3707),
    [anon_sym_triangleadj] = ACTIONS(3707),
    [anon_sym_lineadj] = ACTIONS(3707),
    [anon_sym_triangle] = ACTIONS(3707),
    [anon_sym_interface] = ACTIONS(3707),
    [anon_sym_extension] = ACTIONS(3707),
    [anon_sym___init] = ACTIONS(3707),
    [anon_sym___subscript] = ACTIONS(3707),
    [anon_sym_property] = ACTIONS(3707),
    [anon_sym_associatedtype] = ACTIONS(3707),
  },
  [2101] = {
    [sym_identifier] = ACTIONS(3711),
    [aux_sym_preproc_def_token1] = ACTIONS(3711),
    [aux_sym_preproc_if_token1] = ACTIONS(3711),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3711),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3711),
    [sym_preproc_directive] = ACTIONS(3711),
    [anon_sym_LPAREN2] = ACTIONS(3713),
    [anon_sym_TILDE] = ACTIONS(3713),
    [anon_sym_STAR] = ACTIONS(3713),
    [anon_sym_AMP_AMP] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(3711),
    [anon_sym_SEMI] = ACTIONS(3713),
    [anon_sym___extension__] = ACTIONS(3711),
    [anon_sym_typedef] = ACTIONS(3711),
    [anon_sym_in] = ACTIONS(3711),
    [anon_sym_out] = ACTIONS(3711),
    [anon_sym_inout] = ACTIONS(3711),
    [anon_sym_virtual] = ACTIONS(3711),
    [anon_sym_extern] = ACTIONS(3711),
    [anon_sym___attribute__] = ACTIONS(3711),
    [anon_sym___attribute] = ACTIONS(3711),
    [anon_sym_using] = ACTIONS(3711),
    [anon_sym_COLON_COLON] = ACTIONS(3713),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3713),
    [anon_sym___declspec] = ACTIONS(3711),
    [anon_sym___based] = ACTIONS(3711),
    [anon_sym_RBRACE] = ACTIONS(3713),
    [anon_sym_signed] = ACTIONS(3711),
    [anon_sym_unsigned] = ACTIONS(3711),
    [anon_sym_long] = ACTIONS(3711),
    [anon_sym_short] = ACTIONS(3711),
    [anon_sym_LBRACK] = ACTIONS(3711),
    [anon_sym_static] = ACTIONS(3711),
    [anon_sym_register] = ACTIONS(3711),
    [anon_sym_inline] = ACTIONS(3711),
    [anon_sym___inline] = ACTIONS(3711),
    [anon_sym___inline__] = ACTIONS(3711),
    [anon_sym___forceinline] = ACTIONS(3711),
    [anon_sym_thread_local] = ACTIONS(3711),
    [anon_sym___thread] = ACTIONS(3711),
    [anon_sym_const] = ACTIONS(3711),
    [anon_sym_constexpr] = ACTIONS(3711),
    [anon_sym_volatile] = ACTIONS(3711),
    [anon_sym_restrict] = ACTIONS(3711),
    [anon_sym___restrict__] = ACTIONS(3711),
    [anon_sym__Atomic] = ACTIONS(3711),
    [anon_sym__Noreturn] = ACTIONS(3711),
    [anon_sym_noreturn] = ACTIONS(3711),
    [anon_sym__Nonnull] = ACTIONS(3711),
    [anon_sym_mutable] = ACTIONS(3711),
    [anon_sym_constinit] = ACTIONS(3711),
    [anon_sym_consteval] = ACTIONS(3711),
    [anon_sym_alignas] = ACTIONS(3711),
    [anon_sym__Alignas] = ACTIONS(3711),
    [sym_primitive_type] = ACTIONS(3711),
    [anon_sym_enum] = ACTIONS(3711),
    [anon_sym_class] = ACTIONS(3711),
    [anon_sym_struct] = ACTIONS(3711),
    [anon_sym_union] = ACTIONS(3711),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_This] = ACTIONS(3711),
    [anon_sym_decltype] = ACTIONS(3711),
    [anon_sym_explicit] = ACTIONS(3711),
    [anon_sym_typename] = ACTIONS(3711),
    [anon_sym_private] = ACTIONS(3711),
    [anon_sym_template] = ACTIONS(3711),
    [anon_sym_operator] = ACTIONS(3711),
    [anon_sym_friend] = ACTIONS(3711),
    [anon_sym_public] = ACTIONS(3711),
    [anon_sym_protected] = ACTIONS(3711),
    [anon_sym_static_assert] = ACTIONS(3711),
    [anon_sym_precise] = ACTIONS(3711),
    [anon_sym_shared] = ACTIONS(3711),
    [anon_sym_groupshared] = ACTIONS(3711),
    [anon_sym_uniform] = ACTIONS(3711),
    [anon_sym_row_major] = ACTIONS(3711),
    [anon_sym_column_major] = ACTIONS(3711),
    [anon_sym_globallycoherent] = ACTIONS(3711),
    [anon_sym_centroid] = ACTIONS(3711),
    [anon_sym_noperspective] = ACTIONS(3711),
    [anon_sym_nointerpolation] = ACTIONS(3711),
    [anon_sym_sample] = ACTIONS(3711),
    [anon_sym_linear] = ACTIONS(3711),
    [anon_sym_snorm] = ACTIONS(3711),
    [anon_sym_unorm] = ACTIONS(3711),
    [anon_sym_point] = ACTIONS(3711),
    [anon_sym_line] = ACTIONS(3711),
    [anon_sym_triangleadj] = ACTIONS(3711),
    [anon_sym_lineadj] = ACTIONS(3711),
    [anon_sym_triangle] = ACTIONS(3711),
    [anon_sym_interface] = ACTIONS(3711),
    [anon_sym_extension] = ACTIONS(3711),
    [anon_sym___init] = ACTIONS(3711),
    [anon_sym___subscript] = ACTIONS(3711),
    [anon_sym_property] = ACTIONS(3711),
    [anon_sym_associatedtype] = ACTIONS(3711),
  },
  [2102] = {
    [sym_identifier] = ACTIONS(3715),
    [aux_sym_preproc_def_token1] = ACTIONS(3715),
    [aux_sym_preproc_if_token1] = ACTIONS(3715),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3715),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3715),
    [sym_preproc_directive] = ACTIONS(3715),
    [anon_sym_LPAREN2] = ACTIONS(3717),
    [anon_sym_TILDE] = ACTIONS(3717),
    [anon_sym_STAR] = ACTIONS(3717),
    [anon_sym_AMP_AMP] = ACTIONS(3717),
    [anon_sym_AMP] = ACTIONS(3715),
    [anon_sym_SEMI] = ACTIONS(3717),
    [anon_sym___extension__] = ACTIONS(3715),
    [anon_sym_typedef] = ACTIONS(3715),
    [anon_sym_in] = ACTIONS(3715),
    [anon_sym_out] = ACTIONS(3715),
    [anon_sym_inout] = ACTIONS(3715),
    [anon_sym_virtual] = ACTIONS(3715),
    [anon_sym_extern] = ACTIONS(3715),
    [anon_sym___attribute__] = ACTIONS(3715),
    [anon_sym___attribute] = ACTIONS(3715),
    [anon_sym_using] = ACTIONS(3715),
    [anon_sym_COLON_COLON] = ACTIONS(3717),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3717),
    [anon_sym___declspec] = ACTIONS(3715),
    [anon_sym___based] = ACTIONS(3715),
    [anon_sym_RBRACE] = ACTIONS(3717),
    [anon_sym_signed] = ACTIONS(3715),
    [anon_sym_unsigned] = ACTIONS(3715),
    [anon_sym_long] = ACTIONS(3715),
    [anon_sym_short] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_static] = ACTIONS(3715),
    [anon_sym_register] = ACTIONS(3715),
    [anon_sym_inline] = ACTIONS(3715),
    [anon_sym___inline] = ACTIONS(3715),
    [anon_sym___inline__] = ACTIONS(3715),
    [anon_sym___forceinline] = ACTIONS(3715),
    [anon_sym_thread_local] = ACTIONS(3715),
    [anon_sym___thread] = ACTIONS(3715),
    [anon_sym_const] = ACTIONS(3715),
    [anon_sym_constexpr] = ACTIONS(3715),
    [anon_sym_volatile] = ACTIONS(3715),
    [anon_sym_restrict] = ACTIONS(3715),
    [anon_sym___restrict__] = ACTIONS(3715),
    [anon_sym__Atomic] = ACTIONS(3715),
    [anon_sym__Noreturn] = ACTIONS(3715),
    [anon_sym_noreturn] = ACTIONS(3715),
    [anon_sym__Nonnull] = ACTIONS(3715),
    [anon_sym_mutable] = ACTIONS(3715),
    [anon_sym_constinit] = ACTIONS(3715),
    [anon_sym_consteval] = ACTIONS(3715),
    [anon_sym_alignas] = ACTIONS(3715),
    [anon_sym__Alignas] = ACTIONS(3715),
    [sym_primitive_type] = ACTIONS(3715),
    [anon_sym_enum] = ACTIONS(3715),
    [anon_sym_class] = ACTIONS(3715),
    [anon_sym_struct] = ACTIONS(3715),
    [anon_sym_union] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3715),
    [anon_sym_let] = ACTIONS(3715),
    [anon_sym_This] = ACTIONS(3715),
    [anon_sym_decltype] = ACTIONS(3715),
    [anon_sym_explicit] = ACTIONS(3715),
    [anon_sym_typename] = ACTIONS(3715),
    [anon_sym_private] = ACTIONS(3715),
    [anon_sym_template] = ACTIONS(3715),
    [anon_sym_operator] = ACTIONS(3715),
    [anon_sym_friend] = ACTIONS(3715),
    [anon_sym_public] = ACTIONS(3715),
    [anon_sym_protected] = ACTIONS(3715),
    [anon_sym_static_assert] = ACTIONS(3715),
    [anon_sym_precise] = ACTIONS(3715),
    [anon_sym_shared] = ACTIONS(3715),
    [anon_sym_groupshared] = ACTIONS(3715),
    [anon_sym_uniform] = ACTIONS(3715),
    [anon_sym_row_major] = ACTIONS(3715),
    [anon_sym_column_major] = ACTIONS(3715),
    [anon_sym_globallycoherent] = ACTIONS(3715),
    [anon_sym_centroid] = ACTIONS(3715),
    [anon_sym_noperspective] = ACTIONS(3715),
    [anon_sym_nointerpolation] = ACTIONS(3715),
    [anon_sym_sample] = ACTIONS(3715),
    [anon_sym_linear] = ACTIONS(3715),
    [anon_sym_snorm] = ACTIONS(3715),
    [anon_sym_unorm] = ACTIONS(3715),
    [anon_sym_point] = ACTIONS(3715),
    [anon_sym_line] = ACTIONS(3715),
    [anon_sym_triangleadj] = ACTIONS(3715),
    [anon_sym_lineadj] = ACTIONS(3715),
    [anon_sym_triangle] = ACTIONS(3715),
    [anon_sym_interface] = ACTIONS(3715),
    [anon_sym_extension] = ACTIONS(3715),
    [anon_sym___init] = ACTIONS(3715),
    [anon_sym___subscript] = ACTIONS(3715),
    [anon_sym_property] = ACTIONS(3715),
    [anon_sym_associatedtype] = ACTIONS(3715),
  },
  [2103] = {
    [sym_identifier] = ACTIONS(3460),
    [aux_sym_preproc_def_token1] = ACTIONS(3460),
    [aux_sym_preproc_if_token1] = ACTIONS(3460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3460),
    [sym_preproc_directive] = ACTIONS(3460),
    [anon_sym_LPAREN2] = ACTIONS(3458),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3458),
    [anon_sym_AMP_AMP] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3460),
    [anon_sym_SEMI] = ACTIONS(3458),
    [anon_sym___extension__] = ACTIONS(3460),
    [anon_sym_typedef] = ACTIONS(3460),
    [anon_sym_in] = ACTIONS(3460),
    [anon_sym_out] = ACTIONS(3460),
    [anon_sym_inout] = ACTIONS(3460),
    [anon_sym_virtual] = ACTIONS(3460),
    [anon_sym_extern] = ACTIONS(3460),
    [anon_sym___attribute__] = ACTIONS(3460),
    [anon_sym___attribute] = ACTIONS(3460),
    [anon_sym_using] = ACTIONS(3460),
    [anon_sym_COLON_COLON] = ACTIONS(3458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3458),
    [anon_sym___declspec] = ACTIONS(3460),
    [anon_sym___based] = ACTIONS(3460),
    [anon_sym_RBRACE] = ACTIONS(3458),
    [anon_sym_signed] = ACTIONS(3460),
    [anon_sym_unsigned] = ACTIONS(3460),
    [anon_sym_long] = ACTIONS(3460),
    [anon_sym_short] = ACTIONS(3460),
    [anon_sym_LBRACK] = ACTIONS(3460),
    [anon_sym_static] = ACTIONS(3460),
    [anon_sym_register] = ACTIONS(3460),
    [anon_sym_inline] = ACTIONS(3460),
    [anon_sym___inline] = ACTIONS(3460),
    [anon_sym___inline__] = ACTIONS(3460),
    [anon_sym___forceinline] = ACTIONS(3460),
    [anon_sym_thread_local] = ACTIONS(3460),
    [anon_sym___thread] = ACTIONS(3460),
    [anon_sym_const] = ACTIONS(3460),
    [anon_sym_constexpr] = ACTIONS(3460),
    [anon_sym_volatile] = ACTIONS(3460),
    [anon_sym_restrict] = ACTIONS(3460),
    [anon_sym___restrict__] = ACTIONS(3460),
    [anon_sym__Atomic] = ACTIONS(3460),
    [anon_sym__Noreturn] = ACTIONS(3460),
    [anon_sym_noreturn] = ACTIONS(3460),
    [anon_sym__Nonnull] = ACTIONS(3460),
    [anon_sym_mutable] = ACTIONS(3460),
    [anon_sym_constinit] = ACTIONS(3460),
    [anon_sym_consteval] = ACTIONS(3460),
    [anon_sym_alignas] = ACTIONS(3460),
    [anon_sym__Alignas] = ACTIONS(3460),
    [sym_primitive_type] = ACTIONS(3460),
    [anon_sym_enum] = ACTIONS(3460),
    [anon_sym_class] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(3460),
    [anon_sym_union] = ACTIONS(3460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3460),
    [anon_sym_let] = ACTIONS(3460),
    [anon_sym_This] = ACTIONS(3460),
    [anon_sym_decltype] = ACTIONS(3460),
    [anon_sym_explicit] = ACTIONS(3460),
    [anon_sym_typename] = ACTIONS(3460),
    [anon_sym_private] = ACTIONS(3460),
    [anon_sym_template] = ACTIONS(3460),
    [anon_sym_operator] = ACTIONS(3460),
    [anon_sym_friend] = ACTIONS(3460),
    [anon_sym_public] = ACTIONS(3460),
    [anon_sym_protected] = ACTIONS(3460),
    [anon_sym_static_assert] = ACTIONS(3460),
    [anon_sym_precise] = ACTIONS(3460),
    [anon_sym_shared] = ACTIONS(3460),
    [anon_sym_groupshared] = ACTIONS(3460),
    [anon_sym_uniform] = ACTIONS(3460),
    [anon_sym_row_major] = ACTIONS(3460),
    [anon_sym_column_major] = ACTIONS(3460),
    [anon_sym_globallycoherent] = ACTIONS(3460),
    [anon_sym_centroid] = ACTIONS(3460),
    [anon_sym_noperspective] = ACTIONS(3460),
    [anon_sym_nointerpolation] = ACTIONS(3460),
    [anon_sym_sample] = ACTIONS(3460),
    [anon_sym_linear] = ACTIONS(3460),
    [anon_sym_snorm] = ACTIONS(3460),
    [anon_sym_unorm] = ACTIONS(3460),
    [anon_sym_point] = ACTIONS(3460),
    [anon_sym_line] = ACTIONS(3460),
    [anon_sym_triangleadj] = ACTIONS(3460),
    [anon_sym_lineadj] = ACTIONS(3460),
    [anon_sym_triangle] = ACTIONS(3460),
    [anon_sym_interface] = ACTIONS(3460),
    [anon_sym_extension] = ACTIONS(3460),
    [anon_sym___init] = ACTIONS(3460),
    [anon_sym___subscript] = ACTIONS(3460),
    [anon_sym_property] = ACTIONS(3460),
    [anon_sym_associatedtype] = ACTIONS(3460),
  },
  [2104] = {
    [sym_identifier] = ACTIONS(3735),
    [aux_sym_preproc_def_token1] = ACTIONS(3735),
    [aux_sym_preproc_if_token1] = ACTIONS(3735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3735),
    [sym_preproc_directive] = ACTIONS(3735),
    [anon_sym_LPAREN2] = ACTIONS(3737),
    [anon_sym_TILDE] = ACTIONS(3737),
    [anon_sym_STAR] = ACTIONS(3737),
    [anon_sym_AMP_AMP] = ACTIONS(3737),
    [anon_sym_AMP] = ACTIONS(3735),
    [anon_sym_SEMI] = ACTIONS(3737),
    [anon_sym___extension__] = ACTIONS(3735),
    [anon_sym_typedef] = ACTIONS(3735),
    [anon_sym_in] = ACTIONS(3735),
    [anon_sym_out] = ACTIONS(3735),
    [anon_sym_inout] = ACTIONS(3735),
    [anon_sym_virtual] = ACTIONS(3735),
    [anon_sym_extern] = ACTIONS(3735),
    [anon_sym___attribute__] = ACTIONS(3735),
    [anon_sym___attribute] = ACTIONS(3735),
    [anon_sym_using] = ACTIONS(3735),
    [anon_sym_COLON_COLON] = ACTIONS(3737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3737),
    [anon_sym___declspec] = ACTIONS(3735),
    [anon_sym___based] = ACTIONS(3735),
    [anon_sym_RBRACE] = ACTIONS(3737),
    [anon_sym_signed] = ACTIONS(3735),
    [anon_sym_unsigned] = ACTIONS(3735),
    [anon_sym_long] = ACTIONS(3735),
    [anon_sym_short] = ACTIONS(3735),
    [anon_sym_LBRACK] = ACTIONS(3735),
    [anon_sym_static] = ACTIONS(3735),
    [anon_sym_register] = ACTIONS(3735),
    [anon_sym_inline] = ACTIONS(3735),
    [anon_sym___inline] = ACTIONS(3735),
    [anon_sym___inline__] = ACTIONS(3735),
    [anon_sym___forceinline] = ACTIONS(3735),
    [anon_sym_thread_local] = ACTIONS(3735),
    [anon_sym___thread] = ACTIONS(3735),
    [anon_sym_const] = ACTIONS(3735),
    [anon_sym_constexpr] = ACTIONS(3735),
    [anon_sym_volatile] = ACTIONS(3735),
    [anon_sym_restrict] = ACTIONS(3735),
    [anon_sym___restrict__] = ACTIONS(3735),
    [anon_sym__Atomic] = ACTIONS(3735),
    [anon_sym__Noreturn] = ACTIONS(3735),
    [anon_sym_noreturn] = ACTIONS(3735),
    [anon_sym__Nonnull] = ACTIONS(3735),
    [anon_sym_mutable] = ACTIONS(3735),
    [anon_sym_constinit] = ACTIONS(3735),
    [anon_sym_consteval] = ACTIONS(3735),
    [anon_sym_alignas] = ACTIONS(3735),
    [anon_sym__Alignas] = ACTIONS(3735),
    [sym_primitive_type] = ACTIONS(3735),
    [anon_sym_enum] = ACTIONS(3735),
    [anon_sym_class] = ACTIONS(3735),
    [anon_sym_struct] = ACTIONS(3735),
    [anon_sym_union] = ACTIONS(3735),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3735),
    [anon_sym_let] = ACTIONS(3735),
    [anon_sym_This] = ACTIONS(3735),
    [anon_sym_decltype] = ACTIONS(3735),
    [anon_sym_explicit] = ACTIONS(3735),
    [anon_sym_typename] = ACTIONS(3735),
    [anon_sym_private] = ACTIONS(3735),
    [anon_sym_template] = ACTIONS(3735),
    [anon_sym_operator] = ACTIONS(3735),
    [anon_sym_friend] = ACTIONS(3735),
    [anon_sym_public] = ACTIONS(3735),
    [anon_sym_protected] = ACTIONS(3735),
    [anon_sym_static_assert] = ACTIONS(3735),
    [anon_sym_precise] = ACTIONS(3735),
    [anon_sym_shared] = ACTIONS(3735),
    [anon_sym_groupshared] = ACTIONS(3735),
    [anon_sym_uniform] = ACTIONS(3735),
    [anon_sym_row_major] = ACTIONS(3735),
    [anon_sym_column_major] = ACTIONS(3735),
    [anon_sym_globallycoherent] = ACTIONS(3735),
    [anon_sym_centroid] = ACTIONS(3735),
    [anon_sym_noperspective] = ACTIONS(3735),
    [anon_sym_nointerpolation] = ACTIONS(3735),
    [anon_sym_sample] = ACTIONS(3735),
    [anon_sym_linear] = ACTIONS(3735),
    [anon_sym_snorm] = ACTIONS(3735),
    [anon_sym_unorm] = ACTIONS(3735),
    [anon_sym_point] = ACTIONS(3735),
    [anon_sym_line] = ACTIONS(3735),
    [anon_sym_triangleadj] = ACTIONS(3735),
    [anon_sym_lineadj] = ACTIONS(3735),
    [anon_sym_triangle] = ACTIONS(3735),
    [anon_sym_interface] = ACTIONS(3735),
    [anon_sym_extension] = ACTIONS(3735),
    [anon_sym___init] = ACTIONS(3735),
    [anon_sym___subscript] = ACTIONS(3735),
    [anon_sym_property] = ACTIONS(3735),
    [anon_sym_associatedtype] = ACTIONS(3735),
  },
  [2105] = {
    [sym_identifier] = ACTIONS(6176),
    [aux_sym_preproc_def_token1] = ACTIONS(6176),
    [aux_sym_preproc_if_token1] = ACTIONS(6176),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6176),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6176),
    [sym_preproc_directive] = ACTIONS(6176),
    [anon_sym_LPAREN2] = ACTIONS(6178),
    [anon_sym_TILDE] = ACTIONS(6178),
    [anon_sym_STAR] = ACTIONS(6178),
    [anon_sym_AMP_AMP] = ACTIONS(6178),
    [anon_sym_AMP] = ACTIONS(6176),
    [anon_sym_SEMI] = ACTIONS(6178),
    [anon_sym___extension__] = ACTIONS(6176),
    [anon_sym_typedef] = ACTIONS(6176),
    [anon_sym_in] = ACTIONS(6176),
    [anon_sym_out] = ACTIONS(6176),
    [anon_sym_inout] = ACTIONS(6176),
    [anon_sym_virtual] = ACTIONS(6176),
    [anon_sym_extern] = ACTIONS(6176),
    [anon_sym___attribute__] = ACTIONS(6176),
    [anon_sym___attribute] = ACTIONS(6176),
    [anon_sym_using] = ACTIONS(6176),
    [anon_sym_COLON_COLON] = ACTIONS(6178),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6178),
    [anon_sym___declspec] = ACTIONS(6176),
    [anon_sym___based] = ACTIONS(6176),
    [anon_sym_RBRACE] = ACTIONS(6178),
    [anon_sym_signed] = ACTIONS(6176),
    [anon_sym_unsigned] = ACTIONS(6176),
    [anon_sym_long] = ACTIONS(6176),
    [anon_sym_short] = ACTIONS(6176),
    [anon_sym_LBRACK] = ACTIONS(6176),
    [anon_sym_static] = ACTIONS(6176),
    [anon_sym_register] = ACTIONS(6176),
    [anon_sym_inline] = ACTIONS(6176),
    [anon_sym___inline] = ACTIONS(6176),
    [anon_sym___inline__] = ACTIONS(6176),
    [anon_sym___forceinline] = ACTIONS(6176),
    [anon_sym_thread_local] = ACTIONS(6176),
    [anon_sym___thread] = ACTIONS(6176),
    [anon_sym_const] = ACTIONS(6176),
    [anon_sym_constexpr] = ACTIONS(6176),
    [anon_sym_volatile] = ACTIONS(6176),
    [anon_sym_restrict] = ACTIONS(6176),
    [anon_sym___restrict__] = ACTIONS(6176),
    [anon_sym__Atomic] = ACTIONS(6176),
    [anon_sym__Noreturn] = ACTIONS(6176),
    [anon_sym_noreturn] = ACTIONS(6176),
    [anon_sym__Nonnull] = ACTIONS(6176),
    [anon_sym_mutable] = ACTIONS(6176),
    [anon_sym_constinit] = ACTIONS(6176),
    [anon_sym_consteval] = ACTIONS(6176),
    [anon_sym_alignas] = ACTIONS(6176),
    [anon_sym__Alignas] = ACTIONS(6176),
    [sym_primitive_type] = ACTIONS(6176),
    [anon_sym_enum] = ACTIONS(6176),
    [anon_sym_class] = ACTIONS(6176),
    [anon_sym_struct] = ACTIONS(6176),
    [anon_sym_union] = ACTIONS(6176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6176),
    [anon_sym_let] = ACTIONS(6176),
    [anon_sym_This] = ACTIONS(6176),
    [anon_sym_decltype] = ACTIONS(6176),
    [anon_sym_explicit] = ACTIONS(6176),
    [anon_sym_typename] = ACTIONS(6176),
    [anon_sym_private] = ACTIONS(6176),
    [anon_sym_template] = ACTIONS(6176),
    [anon_sym_operator] = ACTIONS(6176),
    [anon_sym_friend] = ACTIONS(6176),
    [anon_sym_public] = ACTIONS(6176),
    [anon_sym_protected] = ACTIONS(6176),
    [anon_sym_static_assert] = ACTIONS(6176),
    [anon_sym_precise] = ACTIONS(6176),
    [anon_sym_shared] = ACTIONS(6176),
    [anon_sym_groupshared] = ACTIONS(6176),
    [anon_sym_uniform] = ACTIONS(6176),
    [anon_sym_row_major] = ACTIONS(6176),
    [anon_sym_column_major] = ACTIONS(6176),
    [anon_sym_globallycoherent] = ACTIONS(6176),
    [anon_sym_centroid] = ACTIONS(6176),
    [anon_sym_noperspective] = ACTIONS(6176),
    [anon_sym_nointerpolation] = ACTIONS(6176),
    [anon_sym_sample] = ACTIONS(6176),
    [anon_sym_linear] = ACTIONS(6176),
    [anon_sym_snorm] = ACTIONS(6176),
    [anon_sym_unorm] = ACTIONS(6176),
    [anon_sym_point] = ACTIONS(6176),
    [anon_sym_line] = ACTIONS(6176),
    [anon_sym_triangleadj] = ACTIONS(6176),
    [anon_sym_lineadj] = ACTIONS(6176),
    [anon_sym_triangle] = ACTIONS(6176),
    [anon_sym_interface] = ACTIONS(6176),
    [anon_sym_extension] = ACTIONS(6176),
    [anon_sym___init] = ACTIONS(6176),
    [anon_sym___subscript] = ACTIONS(6176),
    [anon_sym_property] = ACTIONS(6176),
    [anon_sym_associatedtype] = ACTIONS(6176),
  },
  [2106] = {
    [sym_identifier] = ACTIONS(6182),
    [aux_sym_preproc_def_token1] = ACTIONS(6182),
    [aux_sym_preproc_if_token1] = ACTIONS(6182),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6182),
    [sym_preproc_directive] = ACTIONS(6182),
    [anon_sym_LPAREN2] = ACTIONS(6184),
    [anon_sym_TILDE] = ACTIONS(6184),
    [anon_sym_STAR] = ACTIONS(6184),
    [anon_sym_AMP_AMP] = ACTIONS(6184),
    [anon_sym_AMP] = ACTIONS(6182),
    [anon_sym_SEMI] = ACTIONS(6184),
    [anon_sym___extension__] = ACTIONS(6182),
    [anon_sym_typedef] = ACTIONS(6182),
    [anon_sym_in] = ACTIONS(6182),
    [anon_sym_out] = ACTIONS(6182),
    [anon_sym_inout] = ACTIONS(6182),
    [anon_sym_virtual] = ACTIONS(6182),
    [anon_sym_extern] = ACTIONS(6182),
    [anon_sym___attribute__] = ACTIONS(6182),
    [anon_sym___attribute] = ACTIONS(6182),
    [anon_sym_using] = ACTIONS(6182),
    [anon_sym_COLON_COLON] = ACTIONS(6184),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6184),
    [anon_sym___declspec] = ACTIONS(6182),
    [anon_sym___based] = ACTIONS(6182),
    [anon_sym_RBRACE] = ACTIONS(6184),
    [anon_sym_signed] = ACTIONS(6182),
    [anon_sym_unsigned] = ACTIONS(6182),
    [anon_sym_long] = ACTIONS(6182),
    [anon_sym_short] = ACTIONS(6182),
    [anon_sym_LBRACK] = ACTIONS(6182),
    [anon_sym_static] = ACTIONS(6182),
    [anon_sym_register] = ACTIONS(6182),
    [anon_sym_inline] = ACTIONS(6182),
    [anon_sym___inline] = ACTIONS(6182),
    [anon_sym___inline__] = ACTIONS(6182),
    [anon_sym___forceinline] = ACTIONS(6182),
    [anon_sym_thread_local] = ACTIONS(6182),
    [anon_sym___thread] = ACTIONS(6182),
    [anon_sym_const] = ACTIONS(6182),
    [anon_sym_constexpr] = ACTIONS(6182),
    [anon_sym_volatile] = ACTIONS(6182),
    [anon_sym_restrict] = ACTIONS(6182),
    [anon_sym___restrict__] = ACTIONS(6182),
    [anon_sym__Atomic] = ACTIONS(6182),
    [anon_sym__Noreturn] = ACTIONS(6182),
    [anon_sym_noreturn] = ACTIONS(6182),
    [anon_sym__Nonnull] = ACTIONS(6182),
    [anon_sym_mutable] = ACTIONS(6182),
    [anon_sym_constinit] = ACTIONS(6182),
    [anon_sym_consteval] = ACTIONS(6182),
    [anon_sym_alignas] = ACTIONS(6182),
    [anon_sym__Alignas] = ACTIONS(6182),
    [sym_primitive_type] = ACTIONS(6182),
    [anon_sym_enum] = ACTIONS(6182),
    [anon_sym_class] = ACTIONS(6182),
    [anon_sym_struct] = ACTIONS(6182),
    [anon_sym_union] = ACTIONS(6182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6182),
    [anon_sym_let] = ACTIONS(6182),
    [anon_sym_This] = ACTIONS(6182),
    [anon_sym_decltype] = ACTIONS(6182),
    [anon_sym_explicit] = ACTIONS(6182),
    [anon_sym_typename] = ACTIONS(6182),
    [anon_sym_private] = ACTIONS(6182),
    [anon_sym_template] = ACTIONS(6182),
    [anon_sym_operator] = ACTIONS(6182),
    [anon_sym_friend] = ACTIONS(6182),
    [anon_sym_public] = ACTIONS(6182),
    [anon_sym_protected] = ACTIONS(6182),
    [anon_sym_static_assert] = ACTIONS(6182),
    [anon_sym_precise] = ACTIONS(6182),
    [anon_sym_shared] = ACTIONS(6182),
    [anon_sym_groupshared] = ACTIONS(6182),
    [anon_sym_uniform] = ACTIONS(6182),
    [anon_sym_row_major] = ACTIONS(6182),
    [anon_sym_column_major] = ACTIONS(6182),
    [anon_sym_globallycoherent] = ACTIONS(6182),
    [anon_sym_centroid] = ACTIONS(6182),
    [anon_sym_noperspective] = ACTIONS(6182),
    [anon_sym_nointerpolation] = ACTIONS(6182),
    [anon_sym_sample] = ACTIONS(6182),
    [anon_sym_linear] = ACTIONS(6182),
    [anon_sym_snorm] = ACTIONS(6182),
    [anon_sym_unorm] = ACTIONS(6182),
    [anon_sym_point] = ACTIONS(6182),
    [anon_sym_line] = ACTIONS(6182),
    [anon_sym_triangleadj] = ACTIONS(6182),
    [anon_sym_lineadj] = ACTIONS(6182),
    [anon_sym_triangle] = ACTIONS(6182),
    [anon_sym_interface] = ACTIONS(6182),
    [anon_sym_extension] = ACTIONS(6182),
    [anon_sym___init] = ACTIONS(6182),
    [anon_sym___subscript] = ACTIONS(6182),
    [anon_sym_property] = ACTIONS(6182),
    [anon_sym_associatedtype] = ACTIONS(6182),
  },
  [2107] = {
    [sym_identifier] = ACTIONS(3771),
    [aux_sym_preproc_def_token1] = ACTIONS(3771),
    [aux_sym_preproc_if_token1] = ACTIONS(3771),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3771),
    [sym_preproc_directive] = ACTIONS(3771),
    [anon_sym_LPAREN2] = ACTIONS(3773),
    [anon_sym_TILDE] = ACTIONS(3773),
    [anon_sym_STAR] = ACTIONS(3773),
    [anon_sym_AMP_AMP] = ACTIONS(3773),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_SEMI] = ACTIONS(3773),
    [anon_sym___extension__] = ACTIONS(3771),
    [anon_sym_typedef] = ACTIONS(3771),
    [anon_sym_in] = ACTIONS(3771),
    [anon_sym_out] = ACTIONS(3771),
    [anon_sym_inout] = ACTIONS(3771),
    [anon_sym_virtual] = ACTIONS(3771),
    [anon_sym_extern] = ACTIONS(3771),
    [anon_sym___attribute__] = ACTIONS(3771),
    [anon_sym___attribute] = ACTIONS(3771),
    [anon_sym_using] = ACTIONS(3771),
    [anon_sym_COLON_COLON] = ACTIONS(3773),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3773),
    [anon_sym___declspec] = ACTIONS(3771),
    [anon_sym___based] = ACTIONS(3771),
    [anon_sym_RBRACE] = ACTIONS(3773),
    [anon_sym_signed] = ACTIONS(3771),
    [anon_sym_unsigned] = ACTIONS(3771),
    [anon_sym_long] = ACTIONS(3771),
    [anon_sym_short] = ACTIONS(3771),
    [anon_sym_LBRACK] = ACTIONS(3771),
    [anon_sym_static] = ACTIONS(3771),
    [anon_sym_register] = ACTIONS(3771),
    [anon_sym_inline] = ACTIONS(3771),
    [anon_sym___inline] = ACTIONS(3771),
    [anon_sym___inline__] = ACTIONS(3771),
    [anon_sym___forceinline] = ACTIONS(3771),
    [anon_sym_thread_local] = ACTIONS(3771),
    [anon_sym___thread] = ACTIONS(3771),
    [anon_sym_const] = ACTIONS(3771),
    [anon_sym_constexpr] = ACTIONS(3771),
    [anon_sym_volatile] = ACTIONS(3771),
    [anon_sym_restrict] = ACTIONS(3771),
    [anon_sym___restrict__] = ACTIONS(3771),
    [anon_sym__Atomic] = ACTIONS(3771),
    [anon_sym__Noreturn] = ACTIONS(3771),
    [anon_sym_noreturn] = ACTIONS(3771),
    [anon_sym__Nonnull] = ACTIONS(3771),
    [anon_sym_mutable] = ACTIONS(3771),
    [anon_sym_constinit] = ACTIONS(3771),
    [anon_sym_consteval] = ACTIONS(3771),
    [anon_sym_alignas] = ACTIONS(3771),
    [anon_sym__Alignas] = ACTIONS(3771),
    [sym_primitive_type] = ACTIONS(3771),
    [anon_sym_enum] = ACTIONS(3771),
    [anon_sym_class] = ACTIONS(3771),
    [anon_sym_struct] = ACTIONS(3771),
    [anon_sym_union] = ACTIONS(3771),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3771),
    [anon_sym_let] = ACTIONS(3771),
    [anon_sym_This] = ACTIONS(3771),
    [anon_sym_decltype] = ACTIONS(3771),
    [anon_sym_explicit] = ACTIONS(3771),
    [anon_sym_typename] = ACTIONS(3771),
    [anon_sym_private] = ACTIONS(3771),
    [anon_sym_template] = ACTIONS(3771),
    [anon_sym_operator] = ACTIONS(3771),
    [anon_sym_friend] = ACTIONS(3771),
    [anon_sym_public] = ACTIONS(3771),
    [anon_sym_protected] = ACTIONS(3771),
    [anon_sym_static_assert] = ACTIONS(3771),
    [anon_sym_precise] = ACTIONS(3771),
    [anon_sym_shared] = ACTIONS(3771),
    [anon_sym_groupshared] = ACTIONS(3771),
    [anon_sym_uniform] = ACTIONS(3771),
    [anon_sym_row_major] = ACTIONS(3771),
    [anon_sym_column_major] = ACTIONS(3771),
    [anon_sym_globallycoherent] = ACTIONS(3771),
    [anon_sym_centroid] = ACTIONS(3771),
    [anon_sym_noperspective] = ACTIONS(3771),
    [anon_sym_nointerpolation] = ACTIONS(3771),
    [anon_sym_sample] = ACTIONS(3771),
    [anon_sym_linear] = ACTIONS(3771),
    [anon_sym_snorm] = ACTIONS(3771),
    [anon_sym_unorm] = ACTIONS(3771),
    [anon_sym_point] = ACTIONS(3771),
    [anon_sym_line] = ACTIONS(3771),
    [anon_sym_triangleadj] = ACTIONS(3771),
    [anon_sym_lineadj] = ACTIONS(3771),
    [anon_sym_triangle] = ACTIONS(3771),
    [anon_sym_interface] = ACTIONS(3771),
    [anon_sym_extension] = ACTIONS(3771),
    [anon_sym___init] = ACTIONS(3771),
    [anon_sym___subscript] = ACTIONS(3771),
    [anon_sym_property] = ACTIONS(3771),
    [anon_sym_associatedtype] = ACTIONS(3771),
  },
  [2108] = {
    [sym_identifier] = ACTIONS(6186),
    [aux_sym_preproc_def_token1] = ACTIONS(6186),
    [aux_sym_preproc_if_token1] = ACTIONS(6186),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6186),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6186),
    [sym_preproc_directive] = ACTIONS(6186),
    [anon_sym_LPAREN2] = ACTIONS(6188),
    [anon_sym_TILDE] = ACTIONS(6188),
    [anon_sym_STAR] = ACTIONS(6188),
    [anon_sym_AMP_AMP] = ACTIONS(6188),
    [anon_sym_AMP] = ACTIONS(6186),
    [anon_sym_SEMI] = ACTIONS(6188),
    [anon_sym___extension__] = ACTIONS(6186),
    [anon_sym_typedef] = ACTIONS(6186),
    [anon_sym_in] = ACTIONS(6186),
    [anon_sym_out] = ACTIONS(6186),
    [anon_sym_inout] = ACTIONS(6186),
    [anon_sym_virtual] = ACTIONS(6186),
    [anon_sym_extern] = ACTIONS(6186),
    [anon_sym___attribute__] = ACTIONS(6186),
    [anon_sym___attribute] = ACTIONS(6186),
    [anon_sym_using] = ACTIONS(6186),
    [anon_sym_COLON_COLON] = ACTIONS(6188),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6188),
    [anon_sym___declspec] = ACTIONS(6186),
    [anon_sym___based] = ACTIONS(6186),
    [anon_sym_RBRACE] = ACTIONS(6188),
    [anon_sym_signed] = ACTIONS(6186),
    [anon_sym_unsigned] = ACTIONS(6186),
    [anon_sym_long] = ACTIONS(6186),
    [anon_sym_short] = ACTIONS(6186),
    [anon_sym_LBRACK] = ACTIONS(6186),
    [anon_sym_static] = ACTIONS(6186),
    [anon_sym_register] = ACTIONS(6186),
    [anon_sym_inline] = ACTIONS(6186),
    [anon_sym___inline] = ACTIONS(6186),
    [anon_sym___inline__] = ACTIONS(6186),
    [anon_sym___forceinline] = ACTIONS(6186),
    [anon_sym_thread_local] = ACTIONS(6186),
    [anon_sym___thread] = ACTIONS(6186),
    [anon_sym_const] = ACTIONS(6186),
    [anon_sym_constexpr] = ACTIONS(6186),
    [anon_sym_volatile] = ACTIONS(6186),
    [anon_sym_restrict] = ACTIONS(6186),
    [anon_sym___restrict__] = ACTIONS(6186),
    [anon_sym__Atomic] = ACTIONS(6186),
    [anon_sym__Noreturn] = ACTIONS(6186),
    [anon_sym_noreturn] = ACTIONS(6186),
    [anon_sym__Nonnull] = ACTIONS(6186),
    [anon_sym_mutable] = ACTIONS(6186),
    [anon_sym_constinit] = ACTIONS(6186),
    [anon_sym_consteval] = ACTIONS(6186),
    [anon_sym_alignas] = ACTIONS(6186),
    [anon_sym__Alignas] = ACTIONS(6186),
    [sym_primitive_type] = ACTIONS(6186),
    [anon_sym_enum] = ACTIONS(6186),
    [anon_sym_class] = ACTIONS(6186),
    [anon_sym_struct] = ACTIONS(6186),
    [anon_sym_union] = ACTIONS(6186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6186),
    [anon_sym_let] = ACTIONS(6186),
    [anon_sym_This] = ACTIONS(6186),
    [anon_sym_decltype] = ACTIONS(6186),
    [anon_sym_explicit] = ACTIONS(6186),
    [anon_sym_typename] = ACTIONS(6186),
    [anon_sym_private] = ACTIONS(6186),
    [anon_sym_template] = ACTIONS(6186),
    [anon_sym_operator] = ACTIONS(6186),
    [anon_sym_friend] = ACTIONS(6186),
    [anon_sym_public] = ACTIONS(6186),
    [anon_sym_protected] = ACTIONS(6186),
    [anon_sym_static_assert] = ACTIONS(6186),
    [anon_sym_precise] = ACTIONS(6186),
    [anon_sym_shared] = ACTIONS(6186),
    [anon_sym_groupshared] = ACTIONS(6186),
    [anon_sym_uniform] = ACTIONS(6186),
    [anon_sym_row_major] = ACTIONS(6186),
    [anon_sym_column_major] = ACTIONS(6186),
    [anon_sym_globallycoherent] = ACTIONS(6186),
    [anon_sym_centroid] = ACTIONS(6186),
    [anon_sym_noperspective] = ACTIONS(6186),
    [anon_sym_nointerpolation] = ACTIONS(6186),
    [anon_sym_sample] = ACTIONS(6186),
    [anon_sym_linear] = ACTIONS(6186),
    [anon_sym_snorm] = ACTIONS(6186),
    [anon_sym_unorm] = ACTIONS(6186),
    [anon_sym_point] = ACTIONS(6186),
    [anon_sym_line] = ACTIONS(6186),
    [anon_sym_triangleadj] = ACTIONS(6186),
    [anon_sym_lineadj] = ACTIONS(6186),
    [anon_sym_triangle] = ACTIONS(6186),
    [anon_sym_interface] = ACTIONS(6186),
    [anon_sym_extension] = ACTIONS(6186),
    [anon_sym___init] = ACTIONS(6186),
    [anon_sym___subscript] = ACTIONS(6186),
    [anon_sym_property] = ACTIONS(6186),
    [anon_sym_associatedtype] = ACTIONS(6186),
  },
  [2109] = {
    [sym_identifier] = ACTIONS(3832),
    [aux_sym_preproc_def_token1] = ACTIONS(3832),
    [aux_sym_preproc_if_token1] = ACTIONS(3832),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3832),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3832),
    [sym_preproc_directive] = ACTIONS(3832),
    [anon_sym_LPAREN2] = ACTIONS(3834),
    [anon_sym_TILDE] = ACTIONS(3834),
    [anon_sym_STAR] = ACTIONS(3834),
    [anon_sym_AMP_AMP] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3834),
    [anon_sym___extension__] = ACTIONS(3832),
    [anon_sym_typedef] = ACTIONS(3832),
    [anon_sym_in] = ACTIONS(3832),
    [anon_sym_out] = ACTIONS(3832),
    [anon_sym_inout] = ACTIONS(3832),
    [anon_sym_virtual] = ACTIONS(3832),
    [anon_sym_extern] = ACTIONS(3832),
    [anon_sym___attribute__] = ACTIONS(3832),
    [anon_sym___attribute] = ACTIONS(3832),
    [anon_sym_using] = ACTIONS(3832),
    [anon_sym_COLON_COLON] = ACTIONS(3834),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3834),
    [anon_sym___declspec] = ACTIONS(3832),
    [anon_sym___based] = ACTIONS(3832),
    [anon_sym_RBRACE] = ACTIONS(3834),
    [anon_sym_signed] = ACTIONS(3832),
    [anon_sym_unsigned] = ACTIONS(3832),
    [anon_sym_long] = ACTIONS(3832),
    [anon_sym_short] = ACTIONS(3832),
    [anon_sym_LBRACK] = ACTIONS(3832),
    [anon_sym_static] = ACTIONS(3832),
    [anon_sym_register] = ACTIONS(3832),
    [anon_sym_inline] = ACTIONS(3832),
    [anon_sym___inline] = ACTIONS(3832),
    [anon_sym___inline__] = ACTIONS(3832),
    [anon_sym___forceinline] = ACTIONS(3832),
    [anon_sym_thread_local] = ACTIONS(3832),
    [anon_sym___thread] = ACTIONS(3832),
    [anon_sym_const] = ACTIONS(3832),
    [anon_sym_constexpr] = ACTIONS(3832),
    [anon_sym_volatile] = ACTIONS(3832),
    [anon_sym_restrict] = ACTIONS(3832),
    [anon_sym___restrict__] = ACTIONS(3832),
    [anon_sym__Atomic] = ACTIONS(3832),
    [anon_sym__Noreturn] = ACTIONS(3832),
    [anon_sym_noreturn] = ACTIONS(3832),
    [anon_sym__Nonnull] = ACTIONS(3832),
    [anon_sym_mutable] = ACTIONS(3832),
    [anon_sym_constinit] = ACTIONS(3832),
    [anon_sym_consteval] = ACTIONS(3832),
    [anon_sym_alignas] = ACTIONS(3832),
    [anon_sym__Alignas] = ACTIONS(3832),
    [sym_primitive_type] = ACTIONS(3832),
    [anon_sym_enum] = ACTIONS(3832),
    [anon_sym_class] = ACTIONS(3832),
    [anon_sym_struct] = ACTIONS(3832),
    [anon_sym_union] = ACTIONS(3832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3832),
    [anon_sym_let] = ACTIONS(3832),
    [anon_sym_This] = ACTIONS(3832),
    [anon_sym_decltype] = ACTIONS(3832),
    [anon_sym_explicit] = ACTIONS(3832),
    [anon_sym_typename] = ACTIONS(3832),
    [anon_sym_private] = ACTIONS(3832),
    [anon_sym_template] = ACTIONS(3832),
    [anon_sym_operator] = ACTIONS(3832),
    [anon_sym_friend] = ACTIONS(3832),
    [anon_sym_public] = ACTIONS(3832),
    [anon_sym_protected] = ACTIONS(3832),
    [anon_sym_static_assert] = ACTIONS(3832),
    [anon_sym_precise] = ACTIONS(3832),
    [anon_sym_shared] = ACTIONS(3832),
    [anon_sym_groupshared] = ACTIONS(3832),
    [anon_sym_uniform] = ACTIONS(3832),
    [anon_sym_row_major] = ACTIONS(3832),
    [anon_sym_column_major] = ACTIONS(3832),
    [anon_sym_globallycoherent] = ACTIONS(3832),
    [anon_sym_centroid] = ACTIONS(3832),
    [anon_sym_noperspective] = ACTIONS(3832),
    [anon_sym_nointerpolation] = ACTIONS(3832),
    [anon_sym_sample] = ACTIONS(3832),
    [anon_sym_linear] = ACTIONS(3832),
    [anon_sym_snorm] = ACTIONS(3832),
    [anon_sym_unorm] = ACTIONS(3832),
    [anon_sym_point] = ACTIONS(3832),
    [anon_sym_line] = ACTIONS(3832),
    [anon_sym_triangleadj] = ACTIONS(3832),
    [anon_sym_lineadj] = ACTIONS(3832),
    [anon_sym_triangle] = ACTIONS(3832),
    [anon_sym_interface] = ACTIONS(3832),
    [anon_sym_extension] = ACTIONS(3832),
    [anon_sym___init] = ACTIONS(3832),
    [anon_sym___subscript] = ACTIONS(3832),
    [anon_sym_property] = ACTIONS(3832),
    [anon_sym_associatedtype] = ACTIONS(3832),
  },
  [2110] = {
    [sym_identifier] = ACTIONS(6190),
    [aux_sym_preproc_def_token1] = ACTIONS(6190),
    [aux_sym_preproc_if_token1] = ACTIONS(6190),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6190),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6190),
    [sym_preproc_directive] = ACTIONS(6190),
    [anon_sym_LPAREN2] = ACTIONS(6192),
    [anon_sym_TILDE] = ACTIONS(6192),
    [anon_sym_STAR] = ACTIONS(6192),
    [anon_sym_AMP_AMP] = ACTIONS(6192),
    [anon_sym_AMP] = ACTIONS(6190),
    [anon_sym_SEMI] = ACTIONS(6192),
    [anon_sym___extension__] = ACTIONS(6190),
    [anon_sym_typedef] = ACTIONS(6190),
    [anon_sym_in] = ACTIONS(6190),
    [anon_sym_out] = ACTIONS(6190),
    [anon_sym_inout] = ACTIONS(6190),
    [anon_sym_virtual] = ACTIONS(6190),
    [anon_sym_extern] = ACTIONS(6190),
    [anon_sym___attribute__] = ACTIONS(6190),
    [anon_sym___attribute] = ACTIONS(6190),
    [anon_sym_using] = ACTIONS(6190),
    [anon_sym_COLON_COLON] = ACTIONS(6192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6192),
    [anon_sym___declspec] = ACTIONS(6190),
    [anon_sym___based] = ACTIONS(6190),
    [anon_sym_RBRACE] = ACTIONS(6192),
    [anon_sym_signed] = ACTIONS(6190),
    [anon_sym_unsigned] = ACTIONS(6190),
    [anon_sym_long] = ACTIONS(6190),
    [anon_sym_short] = ACTIONS(6190),
    [anon_sym_LBRACK] = ACTIONS(6190),
    [anon_sym_static] = ACTIONS(6190),
    [anon_sym_register] = ACTIONS(6190),
    [anon_sym_inline] = ACTIONS(6190),
    [anon_sym___inline] = ACTIONS(6190),
    [anon_sym___inline__] = ACTIONS(6190),
    [anon_sym___forceinline] = ACTIONS(6190),
    [anon_sym_thread_local] = ACTIONS(6190),
    [anon_sym___thread] = ACTIONS(6190),
    [anon_sym_const] = ACTIONS(6190),
    [anon_sym_constexpr] = ACTIONS(6190),
    [anon_sym_volatile] = ACTIONS(6190),
    [anon_sym_restrict] = ACTIONS(6190),
    [anon_sym___restrict__] = ACTIONS(6190),
    [anon_sym__Atomic] = ACTIONS(6190),
    [anon_sym__Noreturn] = ACTIONS(6190),
    [anon_sym_noreturn] = ACTIONS(6190),
    [anon_sym__Nonnull] = ACTIONS(6190),
    [anon_sym_mutable] = ACTIONS(6190),
    [anon_sym_constinit] = ACTIONS(6190),
    [anon_sym_consteval] = ACTIONS(6190),
    [anon_sym_alignas] = ACTIONS(6190),
    [anon_sym__Alignas] = ACTIONS(6190),
    [sym_primitive_type] = ACTIONS(6190),
    [anon_sym_enum] = ACTIONS(6190),
    [anon_sym_class] = ACTIONS(6190),
    [anon_sym_struct] = ACTIONS(6190),
    [anon_sym_union] = ACTIONS(6190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6190),
    [anon_sym_let] = ACTIONS(6190),
    [anon_sym_This] = ACTIONS(6190),
    [anon_sym_decltype] = ACTIONS(6190),
    [anon_sym_explicit] = ACTIONS(6190),
    [anon_sym_typename] = ACTIONS(6190),
    [anon_sym_private] = ACTIONS(6190),
    [anon_sym_template] = ACTIONS(6190),
    [anon_sym_operator] = ACTIONS(6190),
    [anon_sym_friend] = ACTIONS(6190),
    [anon_sym_public] = ACTIONS(6190),
    [anon_sym_protected] = ACTIONS(6190),
    [anon_sym_static_assert] = ACTIONS(6190),
    [anon_sym_precise] = ACTIONS(6190),
    [anon_sym_shared] = ACTIONS(6190),
    [anon_sym_groupshared] = ACTIONS(6190),
    [anon_sym_uniform] = ACTIONS(6190),
    [anon_sym_row_major] = ACTIONS(6190),
    [anon_sym_column_major] = ACTIONS(6190),
    [anon_sym_globallycoherent] = ACTIONS(6190),
    [anon_sym_centroid] = ACTIONS(6190),
    [anon_sym_noperspective] = ACTIONS(6190),
    [anon_sym_nointerpolation] = ACTIONS(6190),
    [anon_sym_sample] = ACTIONS(6190),
    [anon_sym_linear] = ACTIONS(6190),
    [anon_sym_snorm] = ACTIONS(6190),
    [anon_sym_unorm] = ACTIONS(6190),
    [anon_sym_point] = ACTIONS(6190),
    [anon_sym_line] = ACTIONS(6190),
    [anon_sym_triangleadj] = ACTIONS(6190),
    [anon_sym_lineadj] = ACTIONS(6190),
    [anon_sym_triangle] = ACTIONS(6190),
    [anon_sym_interface] = ACTIONS(6190),
    [anon_sym_extension] = ACTIONS(6190),
    [anon_sym___init] = ACTIONS(6190),
    [anon_sym___subscript] = ACTIONS(6190),
    [anon_sym_property] = ACTIONS(6190),
    [anon_sym_associatedtype] = ACTIONS(6190),
  },
  [2111] = {
    [sym_identifier] = ACTIONS(6194),
    [aux_sym_preproc_def_token1] = ACTIONS(6194),
    [aux_sym_preproc_if_token1] = ACTIONS(6194),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6194),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6194),
    [sym_preproc_directive] = ACTIONS(6194),
    [anon_sym_LPAREN2] = ACTIONS(6196),
    [anon_sym_TILDE] = ACTIONS(6196),
    [anon_sym_STAR] = ACTIONS(6196),
    [anon_sym_AMP_AMP] = ACTIONS(6196),
    [anon_sym_AMP] = ACTIONS(6194),
    [anon_sym_SEMI] = ACTIONS(6196),
    [anon_sym___extension__] = ACTIONS(6194),
    [anon_sym_typedef] = ACTIONS(6194),
    [anon_sym_in] = ACTIONS(6194),
    [anon_sym_out] = ACTIONS(6194),
    [anon_sym_inout] = ACTIONS(6194),
    [anon_sym_virtual] = ACTIONS(6194),
    [anon_sym_extern] = ACTIONS(6194),
    [anon_sym___attribute__] = ACTIONS(6194),
    [anon_sym___attribute] = ACTIONS(6194),
    [anon_sym_using] = ACTIONS(6194),
    [anon_sym_COLON_COLON] = ACTIONS(6196),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6196),
    [anon_sym___declspec] = ACTIONS(6194),
    [anon_sym___based] = ACTIONS(6194),
    [anon_sym_RBRACE] = ACTIONS(6196),
    [anon_sym_signed] = ACTIONS(6194),
    [anon_sym_unsigned] = ACTIONS(6194),
    [anon_sym_long] = ACTIONS(6194),
    [anon_sym_short] = ACTIONS(6194),
    [anon_sym_LBRACK] = ACTIONS(6194),
    [anon_sym_static] = ACTIONS(6194),
    [anon_sym_register] = ACTIONS(6194),
    [anon_sym_inline] = ACTIONS(6194),
    [anon_sym___inline] = ACTIONS(6194),
    [anon_sym___inline__] = ACTIONS(6194),
    [anon_sym___forceinline] = ACTIONS(6194),
    [anon_sym_thread_local] = ACTIONS(6194),
    [anon_sym___thread] = ACTIONS(6194),
    [anon_sym_const] = ACTIONS(6194),
    [anon_sym_constexpr] = ACTIONS(6194),
    [anon_sym_volatile] = ACTIONS(6194),
    [anon_sym_restrict] = ACTIONS(6194),
    [anon_sym___restrict__] = ACTIONS(6194),
    [anon_sym__Atomic] = ACTIONS(6194),
    [anon_sym__Noreturn] = ACTIONS(6194),
    [anon_sym_noreturn] = ACTIONS(6194),
    [anon_sym__Nonnull] = ACTIONS(6194),
    [anon_sym_mutable] = ACTIONS(6194),
    [anon_sym_constinit] = ACTIONS(6194),
    [anon_sym_consteval] = ACTIONS(6194),
    [anon_sym_alignas] = ACTIONS(6194),
    [anon_sym__Alignas] = ACTIONS(6194),
    [sym_primitive_type] = ACTIONS(6194),
    [anon_sym_enum] = ACTIONS(6194),
    [anon_sym_class] = ACTIONS(6194),
    [anon_sym_struct] = ACTIONS(6194),
    [anon_sym_union] = ACTIONS(6194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6194),
    [anon_sym_let] = ACTIONS(6194),
    [anon_sym_This] = ACTIONS(6194),
    [anon_sym_decltype] = ACTIONS(6194),
    [anon_sym_explicit] = ACTIONS(6194),
    [anon_sym_typename] = ACTIONS(6194),
    [anon_sym_private] = ACTIONS(6194),
    [anon_sym_template] = ACTIONS(6194),
    [anon_sym_operator] = ACTIONS(6194),
    [anon_sym_friend] = ACTIONS(6194),
    [anon_sym_public] = ACTIONS(6194),
    [anon_sym_protected] = ACTIONS(6194),
    [anon_sym_static_assert] = ACTIONS(6194),
    [anon_sym_precise] = ACTIONS(6194),
    [anon_sym_shared] = ACTIONS(6194),
    [anon_sym_groupshared] = ACTIONS(6194),
    [anon_sym_uniform] = ACTIONS(6194),
    [anon_sym_row_major] = ACTIONS(6194),
    [anon_sym_column_major] = ACTIONS(6194),
    [anon_sym_globallycoherent] = ACTIONS(6194),
    [anon_sym_centroid] = ACTIONS(6194),
    [anon_sym_noperspective] = ACTIONS(6194),
    [anon_sym_nointerpolation] = ACTIONS(6194),
    [anon_sym_sample] = ACTIONS(6194),
    [anon_sym_linear] = ACTIONS(6194),
    [anon_sym_snorm] = ACTIONS(6194),
    [anon_sym_unorm] = ACTIONS(6194),
    [anon_sym_point] = ACTIONS(6194),
    [anon_sym_line] = ACTIONS(6194),
    [anon_sym_triangleadj] = ACTIONS(6194),
    [anon_sym_lineadj] = ACTIONS(6194),
    [anon_sym_triangle] = ACTIONS(6194),
    [anon_sym_interface] = ACTIONS(6194),
    [anon_sym_extension] = ACTIONS(6194),
    [anon_sym___init] = ACTIONS(6194),
    [anon_sym___subscript] = ACTIONS(6194),
    [anon_sym_property] = ACTIONS(6194),
    [anon_sym_associatedtype] = ACTIONS(6194),
  },
  [2112] = {
    [sym_identifier] = ACTIONS(6210),
    [aux_sym_preproc_def_token1] = ACTIONS(6210),
    [aux_sym_preproc_if_token1] = ACTIONS(6210),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6210),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6210),
    [sym_preproc_directive] = ACTIONS(6210),
    [anon_sym_LPAREN2] = ACTIONS(6212),
    [anon_sym_TILDE] = ACTIONS(6212),
    [anon_sym_STAR] = ACTIONS(6212),
    [anon_sym_AMP_AMP] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6210),
    [anon_sym_SEMI] = ACTIONS(6212),
    [anon_sym___extension__] = ACTIONS(6210),
    [anon_sym_typedef] = ACTIONS(6210),
    [anon_sym_in] = ACTIONS(6210),
    [anon_sym_out] = ACTIONS(6210),
    [anon_sym_inout] = ACTIONS(6210),
    [anon_sym_virtual] = ACTIONS(6210),
    [anon_sym_extern] = ACTIONS(6210),
    [anon_sym___attribute__] = ACTIONS(6210),
    [anon_sym___attribute] = ACTIONS(6210),
    [anon_sym_using] = ACTIONS(6210),
    [anon_sym_COLON_COLON] = ACTIONS(6212),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6212),
    [anon_sym___declspec] = ACTIONS(6210),
    [anon_sym___based] = ACTIONS(6210),
    [anon_sym_RBRACE] = ACTIONS(6212),
    [anon_sym_signed] = ACTIONS(6210),
    [anon_sym_unsigned] = ACTIONS(6210),
    [anon_sym_long] = ACTIONS(6210),
    [anon_sym_short] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6210),
    [anon_sym_static] = ACTIONS(6210),
    [anon_sym_register] = ACTIONS(6210),
    [anon_sym_inline] = ACTIONS(6210),
    [anon_sym___inline] = ACTIONS(6210),
    [anon_sym___inline__] = ACTIONS(6210),
    [anon_sym___forceinline] = ACTIONS(6210),
    [anon_sym_thread_local] = ACTIONS(6210),
    [anon_sym___thread] = ACTIONS(6210),
    [anon_sym_const] = ACTIONS(6210),
    [anon_sym_constexpr] = ACTIONS(6210),
    [anon_sym_volatile] = ACTIONS(6210),
    [anon_sym_restrict] = ACTIONS(6210),
    [anon_sym___restrict__] = ACTIONS(6210),
    [anon_sym__Atomic] = ACTIONS(6210),
    [anon_sym__Noreturn] = ACTIONS(6210),
    [anon_sym_noreturn] = ACTIONS(6210),
    [anon_sym__Nonnull] = ACTIONS(6210),
    [anon_sym_mutable] = ACTIONS(6210),
    [anon_sym_constinit] = ACTIONS(6210),
    [anon_sym_consteval] = ACTIONS(6210),
    [anon_sym_alignas] = ACTIONS(6210),
    [anon_sym__Alignas] = ACTIONS(6210),
    [sym_primitive_type] = ACTIONS(6210),
    [anon_sym_enum] = ACTIONS(6210),
    [anon_sym_class] = ACTIONS(6210),
    [anon_sym_struct] = ACTIONS(6210),
    [anon_sym_union] = ACTIONS(6210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6210),
    [anon_sym_let] = ACTIONS(6210),
    [anon_sym_This] = ACTIONS(6210),
    [anon_sym_decltype] = ACTIONS(6210),
    [anon_sym_explicit] = ACTIONS(6210),
    [anon_sym_typename] = ACTIONS(6210),
    [anon_sym_private] = ACTIONS(6210),
    [anon_sym_template] = ACTIONS(6210),
    [anon_sym_operator] = ACTIONS(6210),
    [anon_sym_friend] = ACTIONS(6210),
    [anon_sym_public] = ACTIONS(6210),
    [anon_sym_protected] = ACTIONS(6210),
    [anon_sym_static_assert] = ACTIONS(6210),
    [anon_sym_precise] = ACTIONS(6210),
    [anon_sym_shared] = ACTIONS(6210),
    [anon_sym_groupshared] = ACTIONS(6210),
    [anon_sym_uniform] = ACTIONS(6210),
    [anon_sym_row_major] = ACTIONS(6210),
    [anon_sym_column_major] = ACTIONS(6210),
    [anon_sym_globallycoherent] = ACTIONS(6210),
    [anon_sym_centroid] = ACTIONS(6210),
    [anon_sym_noperspective] = ACTIONS(6210),
    [anon_sym_nointerpolation] = ACTIONS(6210),
    [anon_sym_sample] = ACTIONS(6210),
    [anon_sym_linear] = ACTIONS(6210),
    [anon_sym_snorm] = ACTIONS(6210),
    [anon_sym_unorm] = ACTIONS(6210),
    [anon_sym_point] = ACTIONS(6210),
    [anon_sym_line] = ACTIONS(6210),
    [anon_sym_triangleadj] = ACTIONS(6210),
    [anon_sym_lineadj] = ACTIONS(6210),
    [anon_sym_triangle] = ACTIONS(6210),
    [anon_sym_interface] = ACTIONS(6210),
    [anon_sym_extension] = ACTIONS(6210),
    [anon_sym___init] = ACTIONS(6210),
    [anon_sym___subscript] = ACTIONS(6210),
    [anon_sym_property] = ACTIONS(6210),
    [anon_sym_associatedtype] = ACTIONS(6210),
  },
  [2113] = {
    [sym_identifier] = ACTIONS(3816),
    [aux_sym_preproc_def_token1] = ACTIONS(3816),
    [aux_sym_preproc_if_token1] = ACTIONS(3816),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3816),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3816),
    [sym_preproc_directive] = ACTIONS(3816),
    [anon_sym_LPAREN2] = ACTIONS(3818),
    [anon_sym_TILDE] = ACTIONS(3818),
    [anon_sym_STAR] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_SEMI] = ACTIONS(3818),
    [anon_sym___extension__] = ACTIONS(3816),
    [anon_sym_typedef] = ACTIONS(3816),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_out] = ACTIONS(3816),
    [anon_sym_inout] = ACTIONS(3816),
    [anon_sym_virtual] = ACTIONS(3816),
    [anon_sym_extern] = ACTIONS(3816),
    [anon_sym___attribute__] = ACTIONS(3816),
    [anon_sym___attribute] = ACTIONS(3816),
    [anon_sym_using] = ACTIONS(3816),
    [anon_sym_COLON_COLON] = ACTIONS(3818),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3818),
    [anon_sym___declspec] = ACTIONS(3816),
    [anon_sym___based] = ACTIONS(3816),
    [anon_sym_RBRACE] = ACTIONS(3818),
    [anon_sym_signed] = ACTIONS(3816),
    [anon_sym_unsigned] = ACTIONS(3816),
    [anon_sym_long] = ACTIONS(3816),
    [anon_sym_short] = ACTIONS(3816),
    [anon_sym_LBRACK] = ACTIONS(3816),
    [anon_sym_static] = ACTIONS(3816),
    [anon_sym_register] = ACTIONS(3816),
    [anon_sym_inline] = ACTIONS(3816),
    [anon_sym___inline] = ACTIONS(3816),
    [anon_sym___inline__] = ACTIONS(3816),
    [anon_sym___forceinline] = ACTIONS(3816),
    [anon_sym_thread_local] = ACTIONS(3816),
    [anon_sym___thread] = ACTIONS(3816),
    [anon_sym_const] = ACTIONS(3816),
    [anon_sym_constexpr] = ACTIONS(3816),
    [anon_sym_volatile] = ACTIONS(3816),
    [anon_sym_restrict] = ACTIONS(3816),
    [anon_sym___restrict__] = ACTIONS(3816),
    [anon_sym__Atomic] = ACTIONS(3816),
    [anon_sym__Noreturn] = ACTIONS(3816),
    [anon_sym_noreturn] = ACTIONS(3816),
    [anon_sym__Nonnull] = ACTIONS(3816),
    [anon_sym_mutable] = ACTIONS(3816),
    [anon_sym_constinit] = ACTIONS(3816),
    [anon_sym_consteval] = ACTIONS(3816),
    [anon_sym_alignas] = ACTIONS(3816),
    [anon_sym__Alignas] = ACTIONS(3816),
    [sym_primitive_type] = ACTIONS(3816),
    [anon_sym_enum] = ACTIONS(3816),
    [anon_sym_class] = ACTIONS(3816),
    [anon_sym_struct] = ACTIONS(3816),
    [anon_sym_union] = ACTIONS(3816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3816),
    [anon_sym_let] = ACTIONS(3816),
    [anon_sym_This] = ACTIONS(3816),
    [anon_sym_decltype] = ACTIONS(3816),
    [anon_sym_explicit] = ACTIONS(3816),
    [anon_sym_typename] = ACTIONS(3816),
    [anon_sym_private] = ACTIONS(3816),
    [anon_sym_template] = ACTIONS(3816),
    [anon_sym_operator] = ACTIONS(3816),
    [anon_sym_friend] = ACTIONS(3816),
    [anon_sym_public] = ACTIONS(3816),
    [anon_sym_protected] = ACTIONS(3816),
    [anon_sym_static_assert] = ACTIONS(3816),
    [anon_sym_precise] = ACTIONS(3816),
    [anon_sym_shared] = ACTIONS(3816),
    [anon_sym_groupshared] = ACTIONS(3816),
    [anon_sym_uniform] = ACTIONS(3816),
    [anon_sym_row_major] = ACTIONS(3816),
    [anon_sym_column_major] = ACTIONS(3816),
    [anon_sym_globallycoherent] = ACTIONS(3816),
    [anon_sym_centroid] = ACTIONS(3816),
    [anon_sym_noperspective] = ACTIONS(3816),
    [anon_sym_nointerpolation] = ACTIONS(3816),
    [anon_sym_sample] = ACTIONS(3816),
    [anon_sym_linear] = ACTIONS(3816),
    [anon_sym_snorm] = ACTIONS(3816),
    [anon_sym_unorm] = ACTIONS(3816),
    [anon_sym_point] = ACTIONS(3816),
    [anon_sym_line] = ACTIONS(3816),
    [anon_sym_triangleadj] = ACTIONS(3816),
    [anon_sym_lineadj] = ACTIONS(3816),
    [anon_sym_triangle] = ACTIONS(3816),
    [anon_sym_interface] = ACTIONS(3816),
    [anon_sym_extension] = ACTIONS(3816),
    [anon_sym___init] = ACTIONS(3816),
    [anon_sym___subscript] = ACTIONS(3816),
    [anon_sym_property] = ACTIONS(3816),
    [anon_sym_associatedtype] = ACTIONS(3816),
  },
  [2114] = {
    [sym_identifier] = ACTIONS(3820),
    [aux_sym_preproc_def_token1] = ACTIONS(3820),
    [aux_sym_preproc_if_token1] = ACTIONS(3820),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3820),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3820),
    [sym_preproc_directive] = ACTIONS(3820),
    [anon_sym_LPAREN2] = ACTIONS(3822),
    [anon_sym_TILDE] = ACTIONS(3822),
    [anon_sym_STAR] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3822),
    [anon_sym_AMP] = ACTIONS(3820),
    [anon_sym_SEMI] = ACTIONS(3822),
    [anon_sym___extension__] = ACTIONS(3820),
    [anon_sym_typedef] = ACTIONS(3820),
    [anon_sym_in] = ACTIONS(3820),
    [anon_sym_out] = ACTIONS(3820),
    [anon_sym_inout] = ACTIONS(3820),
    [anon_sym_virtual] = ACTIONS(3820),
    [anon_sym_extern] = ACTIONS(3820),
    [anon_sym___attribute__] = ACTIONS(3820),
    [anon_sym___attribute] = ACTIONS(3820),
    [anon_sym_using] = ACTIONS(3820),
    [anon_sym_COLON_COLON] = ACTIONS(3822),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3822),
    [anon_sym___declspec] = ACTIONS(3820),
    [anon_sym___based] = ACTIONS(3820),
    [anon_sym_RBRACE] = ACTIONS(3822),
    [anon_sym_signed] = ACTIONS(3820),
    [anon_sym_unsigned] = ACTIONS(3820),
    [anon_sym_long] = ACTIONS(3820),
    [anon_sym_short] = ACTIONS(3820),
    [anon_sym_LBRACK] = ACTIONS(3820),
    [anon_sym_static] = ACTIONS(3820),
    [anon_sym_register] = ACTIONS(3820),
    [anon_sym_inline] = ACTIONS(3820),
    [anon_sym___inline] = ACTIONS(3820),
    [anon_sym___inline__] = ACTIONS(3820),
    [anon_sym___forceinline] = ACTIONS(3820),
    [anon_sym_thread_local] = ACTIONS(3820),
    [anon_sym___thread] = ACTIONS(3820),
    [anon_sym_const] = ACTIONS(3820),
    [anon_sym_constexpr] = ACTIONS(3820),
    [anon_sym_volatile] = ACTIONS(3820),
    [anon_sym_restrict] = ACTIONS(3820),
    [anon_sym___restrict__] = ACTIONS(3820),
    [anon_sym__Atomic] = ACTIONS(3820),
    [anon_sym__Noreturn] = ACTIONS(3820),
    [anon_sym_noreturn] = ACTIONS(3820),
    [anon_sym__Nonnull] = ACTIONS(3820),
    [anon_sym_mutable] = ACTIONS(3820),
    [anon_sym_constinit] = ACTIONS(3820),
    [anon_sym_consteval] = ACTIONS(3820),
    [anon_sym_alignas] = ACTIONS(3820),
    [anon_sym__Alignas] = ACTIONS(3820),
    [sym_primitive_type] = ACTIONS(3820),
    [anon_sym_enum] = ACTIONS(3820),
    [anon_sym_class] = ACTIONS(3820),
    [anon_sym_struct] = ACTIONS(3820),
    [anon_sym_union] = ACTIONS(3820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3820),
    [anon_sym_let] = ACTIONS(3820),
    [anon_sym_This] = ACTIONS(3820),
    [anon_sym_decltype] = ACTIONS(3820),
    [anon_sym_explicit] = ACTIONS(3820),
    [anon_sym_typename] = ACTIONS(3820),
    [anon_sym_private] = ACTIONS(3820),
    [anon_sym_template] = ACTIONS(3820),
    [anon_sym_operator] = ACTIONS(3820),
    [anon_sym_friend] = ACTIONS(3820),
    [anon_sym_public] = ACTIONS(3820),
    [anon_sym_protected] = ACTIONS(3820),
    [anon_sym_static_assert] = ACTIONS(3820),
    [anon_sym_precise] = ACTIONS(3820),
    [anon_sym_shared] = ACTIONS(3820),
    [anon_sym_groupshared] = ACTIONS(3820),
    [anon_sym_uniform] = ACTIONS(3820),
    [anon_sym_row_major] = ACTIONS(3820),
    [anon_sym_column_major] = ACTIONS(3820),
    [anon_sym_globallycoherent] = ACTIONS(3820),
    [anon_sym_centroid] = ACTIONS(3820),
    [anon_sym_noperspective] = ACTIONS(3820),
    [anon_sym_nointerpolation] = ACTIONS(3820),
    [anon_sym_sample] = ACTIONS(3820),
    [anon_sym_linear] = ACTIONS(3820),
    [anon_sym_snorm] = ACTIONS(3820),
    [anon_sym_unorm] = ACTIONS(3820),
    [anon_sym_point] = ACTIONS(3820),
    [anon_sym_line] = ACTIONS(3820),
    [anon_sym_triangleadj] = ACTIONS(3820),
    [anon_sym_lineadj] = ACTIONS(3820),
    [anon_sym_triangle] = ACTIONS(3820),
    [anon_sym_interface] = ACTIONS(3820),
    [anon_sym_extension] = ACTIONS(3820),
    [anon_sym___init] = ACTIONS(3820),
    [anon_sym___subscript] = ACTIONS(3820),
    [anon_sym_property] = ACTIONS(3820),
    [anon_sym_associatedtype] = ACTIONS(3820),
  },
  [2115] = {
    [sym_identifier] = ACTIONS(3824),
    [aux_sym_preproc_def_token1] = ACTIONS(3824),
    [aux_sym_preproc_if_token1] = ACTIONS(3824),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3824),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3824),
    [sym_preproc_directive] = ACTIONS(3824),
    [anon_sym_LPAREN2] = ACTIONS(3826),
    [anon_sym_TILDE] = ACTIONS(3826),
    [anon_sym_STAR] = ACTIONS(3826),
    [anon_sym_AMP_AMP] = ACTIONS(3826),
    [anon_sym_AMP] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(3826),
    [anon_sym___extension__] = ACTIONS(3824),
    [anon_sym_typedef] = ACTIONS(3824),
    [anon_sym_in] = ACTIONS(3824),
    [anon_sym_out] = ACTIONS(3824),
    [anon_sym_inout] = ACTIONS(3824),
    [anon_sym_virtual] = ACTIONS(3824),
    [anon_sym_extern] = ACTIONS(3824),
    [anon_sym___attribute__] = ACTIONS(3824),
    [anon_sym___attribute] = ACTIONS(3824),
    [anon_sym_using] = ACTIONS(3824),
    [anon_sym_COLON_COLON] = ACTIONS(3826),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3826),
    [anon_sym___declspec] = ACTIONS(3824),
    [anon_sym___based] = ACTIONS(3824),
    [anon_sym_RBRACE] = ACTIONS(3826),
    [anon_sym_signed] = ACTIONS(3824),
    [anon_sym_unsigned] = ACTIONS(3824),
    [anon_sym_long] = ACTIONS(3824),
    [anon_sym_short] = ACTIONS(3824),
    [anon_sym_LBRACK] = ACTIONS(3824),
    [anon_sym_static] = ACTIONS(3824),
    [anon_sym_register] = ACTIONS(3824),
    [anon_sym_inline] = ACTIONS(3824),
    [anon_sym___inline] = ACTIONS(3824),
    [anon_sym___inline__] = ACTIONS(3824),
    [anon_sym___forceinline] = ACTIONS(3824),
    [anon_sym_thread_local] = ACTIONS(3824),
    [anon_sym___thread] = ACTIONS(3824),
    [anon_sym_const] = ACTIONS(3824),
    [anon_sym_constexpr] = ACTIONS(3824),
    [anon_sym_volatile] = ACTIONS(3824),
    [anon_sym_restrict] = ACTIONS(3824),
    [anon_sym___restrict__] = ACTIONS(3824),
    [anon_sym__Atomic] = ACTIONS(3824),
    [anon_sym__Noreturn] = ACTIONS(3824),
    [anon_sym_noreturn] = ACTIONS(3824),
    [anon_sym__Nonnull] = ACTIONS(3824),
    [anon_sym_mutable] = ACTIONS(3824),
    [anon_sym_constinit] = ACTIONS(3824),
    [anon_sym_consteval] = ACTIONS(3824),
    [anon_sym_alignas] = ACTIONS(3824),
    [anon_sym__Alignas] = ACTIONS(3824),
    [sym_primitive_type] = ACTIONS(3824),
    [anon_sym_enum] = ACTIONS(3824),
    [anon_sym_class] = ACTIONS(3824),
    [anon_sym_struct] = ACTIONS(3824),
    [anon_sym_union] = ACTIONS(3824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3824),
    [anon_sym_let] = ACTIONS(3824),
    [anon_sym_This] = ACTIONS(3824),
    [anon_sym_decltype] = ACTIONS(3824),
    [anon_sym_explicit] = ACTIONS(3824),
    [anon_sym_typename] = ACTIONS(3824),
    [anon_sym_private] = ACTIONS(3824),
    [anon_sym_template] = ACTIONS(3824),
    [anon_sym_operator] = ACTIONS(3824),
    [anon_sym_friend] = ACTIONS(3824),
    [anon_sym_public] = ACTIONS(3824),
    [anon_sym_protected] = ACTIONS(3824),
    [anon_sym_static_assert] = ACTIONS(3824),
    [anon_sym_precise] = ACTIONS(3824),
    [anon_sym_shared] = ACTIONS(3824),
    [anon_sym_groupshared] = ACTIONS(3824),
    [anon_sym_uniform] = ACTIONS(3824),
    [anon_sym_row_major] = ACTIONS(3824),
    [anon_sym_column_major] = ACTIONS(3824),
    [anon_sym_globallycoherent] = ACTIONS(3824),
    [anon_sym_centroid] = ACTIONS(3824),
    [anon_sym_noperspective] = ACTIONS(3824),
    [anon_sym_nointerpolation] = ACTIONS(3824),
    [anon_sym_sample] = ACTIONS(3824),
    [anon_sym_linear] = ACTIONS(3824),
    [anon_sym_snorm] = ACTIONS(3824),
    [anon_sym_unorm] = ACTIONS(3824),
    [anon_sym_point] = ACTIONS(3824),
    [anon_sym_line] = ACTIONS(3824),
    [anon_sym_triangleadj] = ACTIONS(3824),
    [anon_sym_lineadj] = ACTIONS(3824),
    [anon_sym_triangle] = ACTIONS(3824),
    [anon_sym_interface] = ACTIONS(3824),
    [anon_sym_extension] = ACTIONS(3824),
    [anon_sym___init] = ACTIONS(3824),
    [anon_sym___subscript] = ACTIONS(3824),
    [anon_sym_property] = ACTIONS(3824),
    [anon_sym_associatedtype] = ACTIONS(3824),
  },
  [2116] = {
    [sym_identifier] = ACTIONS(6218),
    [aux_sym_preproc_def_token1] = ACTIONS(6218),
    [aux_sym_preproc_if_token1] = ACTIONS(6218),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6218),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6218),
    [sym_preproc_directive] = ACTIONS(6218),
    [anon_sym_LPAREN2] = ACTIONS(6220),
    [anon_sym_TILDE] = ACTIONS(6220),
    [anon_sym_STAR] = ACTIONS(6220),
    [anon_sym_AMP_AMP] = ACTIONS(6220),
    [anon_sym_AMP] = ACTIONS(6218),
    [anon_sym_SEMI] = ACTIONS(6220),
    [anon_sym___extension__] = ACTIONS(6218),
    [anon_sym_typedef] = ACTIONS(6218),
    [anon_sym_in] = ACTIONS(6218),
    [anon_sym_out] = ACTIONS(6218),
    [anon_sym_inout] = ACTIONS(6218),
    [anon_sym_virtual] = ACTIONS(6218),
    [anon_sym_extern] = ACTIONS(6218),
    [anon_sym___attribute__] = ACTIONS(6218),
    [anon_sym___attribute] = ACTIONS(6218),
    [anon_sym_using] = ACTIONS(6218),
    [anon_sym_COLON_COLON] = ACTIONS(6220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6220),
    [anon_sym___declspec] = ACTIONS(6218),
    [anon_sym___based] = ACTIONS(6218),
    [anon_sym_RBRACE] = ACTIONS(6220),
    [anon_sym_signed] = ACTIONS(6218),
    [anon_sym_unsigned] = ACTIONS(6218),
    [anon_sym_long] = ACTIONS(6218),
    [anon_sym_short] = ACTIONS(6218),
    [anon_sym_LBRACK] = ACTIONS(6218),
    [anon_sym_static] = ACTIONS(6218),
    [anon_sym_register] = ACTIONS(6218),
    [anon_sym_inline] = ACTIONS(6218),
    [anon_sym___inline] = ACTIONS(6218),
    [anon_sym___inline__] = ACTIONS(6218),
    [anon_sym___forceinline] = ACTIONS(6218),
    [anon_sym_thread_local] = ACTIONS(6218),
    [anon_sym___thread] = ACTIONS(6218),
    [anon_sym_const] = ACTIONS(6218),
    [anon_sym_constexpr] = ACTIONS(6218),
    [anon_sym_volatile] = ACTIONS(6218),
    [anon_sym_restrict] = ACTIONS(6218),
    [anon_sym___restrict__] = ACTIONS(6218),
    [anon_sym__Atomic] = ACTIONS(6218),
    [anon_sym__Noreturn] = ACTIONS(6218),
    [anon_sym_noreturn] = ACTIONS(6218),
    [anon_sym__Nonnull] = ACTIONS(6218),
    [anon_sym_mutable] = ACTIONS(6218),
    [anon_sym_constinit] = ACTIONS(6218),
    [anon_sym_consteval] = ACTIONS(6218),
    [anon_sym_alignas] = ACTIONS(6218),
    [anon_sym__Alignas] = ACTIONS(6218),
    [sym_primitive_type] = ACTIONS(6218),
    [anon_sym_enum] = ACTIONS(6218),
    [anon_sym_class] = ACTIONS(6218),
    [anon_sym_struct] = ACTIONS(6218),
    [anon_sym_union] = ACTIONS(6218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6218),
    [anon_sym_let] = ACTIONS(6218),
    [anon_sym_This] = ACTIONS(6218),
    [anon_sym_decltype] = ACTIONS(6218),
    [anon_sym_explicit] = ACTIONS(6218),
    [anon_sym_typename] = ACTIONS(6218),
    [anon_sym_private] = ACTIONS(6218),
    [anon_sym_template] = ACTIONS(6218),
    [anon_sym_operator] = ACTIONS(6218),
    [anon_sym_friend] = ACTIONS(6218),
    [anon_sym_public] = ACTIONS(6218),
    [anon_sym_protected] = ACTIONS(6218),
    [anon_sym_static_assert] = ACTIONS(6218),
    [anon_sym_precise] = ACTIONS(6218),
    [anon_sym_shared] = ACTIONS(6218),
    [anon_sym_groupshared] = ACTIONS(6218),
    [anon_sym_uniform] = ACTIONS(6218),
    [anon_sym_row_major] = ACTIONS(6218),
    [anon_sym_column_major] = ACTIONS(6218),
    [anon_sym_globallycoherent] = ACTIONS(6218),
    [anon_sym_centroid] = ACTIONS(6218),
    [anon_sym_noperspective] = ACTIONS(6218),
    [anon_sym_nointerpolation] = ACTIONS(6218),
    [anon_sym_sample] = ACTIONS(6218),
    [anon_sym_linear] = ACTIONS(6218),
    [anon_sym_snorm] = ACTIONS(6218),
    [anon_sym_unorm] = ACTIONS(6218),
    [anon_sym_point] = ACTIONS(6218),
    [anon_sym_line] = ACTIONS(6218),
    [anon_sym_triangleadj] = ACTIONS(6218),
    [anon_sym_lineadj] = ACTIONS(6218),
    [anon_sym_triangle] = ACTIONS(6218),
    [anon_sym_interface] = ACTIONS(6218),
    [anon_sym_extension] = ACTIONS(6218),
    [anon_sym___init] = ACTIONS(6218),
    [anon_sym___subscript] = ACTIONS(6218),
    [anon_sym_property] = ACTIONS(6218),
    [anon_sym_associatedtype] = ACTIONS(6218),
  },
  [2117] = {
    [sym_expression] = STATE(5748),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2118] = {
    [sym_identifier] = ACTIONS(3853),
    [aux_sym_preproc_def_token1] = ACTIONS(3853),
    [aux_sym_preproc_if_token1] = ACTIONS(3853),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3853),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3853),
    [sym_preproc_directive] = ACTIONS(3853),
    [anon_sym_LPAREN2] = ACTIONS(3855),
    [anon_sym_TILDE] = ACTIONS(3855),
    [anon_sym_STAR] = ACTIONS(3855),
    [anon_sym_AMP_AMP] = ACTIONS(3855),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_SEMI] = ACTIONS(3855),
    [anon_sym___extension__] = ACTIONS(3853),
    [anon_sym_typedef] = ACTIONS(3853),
    [anon_sym_in] = ACTIONS(3853),
    [anon_sym_out] = ACTIONS(3853),
    [anon_sym_inout] = ACTIONS(3853),
    [anon_sym_virtual] = ACTIONS(3853),
    [anon_sym_extern] = ACTIONS(3853),
    [anon_sym___attribute__] = ACTIONS(3853),
    [anon_sym___attribute] = ACTIONS(3853),
    [anon_sym_using] = ACTIONS(3853),
    [anon_sym_COLON_COLON] = ACTIONS(3855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3855),
    [anon_sym___declspec] = ACTIONS(3853),
    [anon_sym___based] = ACTIONS(3853),
    [anon_sym_RBRACE] = ACTIONS(3855),
    [anon_sym_signed] = ACTIONS(3853),
    [anon_sym_unsigned] = ACTIONS(3853),
    [anon_sym_long] = ACTIONS(3853),
    [anon_sym_short] = ACTIONS(3853),
    [anon_sym_LBRACK] = ACTIONS(3853),
    [anon_sym_static] = ACTIONS(3853),
    [anon_sym_register] = ACTIONS(3853),
    [anon_sym_inline] = ACTIONS(3853),
    [anon_sym___inline] = ACTIONS(3853),
    [anon_sym___inline__] = ACTIONS(3853),
    [anon_sym___forceinline] = ACTIONS(3853),
    [anon_sym_thread_local] = ACTIONS(3853),
    [anon_sym___thread] = ACTIONS(3853),
    [anon_sym_const] = ACTIONS(3853),
    [anon_sym_constexpr] = ACTIONS(3853),
    [anon_sym_volatile] = ACTIONS(3853),
    [anon_sym_restrict] = ACTIONS(3853),
    [anon_sym___restrict__] = ACTIONS(3853),
    [anon_sym__Atomic] = ACTIONS(3853),
    [anon_sym__Noreturn] = ACTIONS(3853),
    [anon_sym_noreturn] = ACTIONS(3853),
    [anon_sym__Nonnull] = ACTIONS(3853),
    [anon_sym_mutable] = ACTIONS(3853),
    [anon_sym_constinit] = ACTIONS(3853),
    [anon_sym_consteval] = ACTIONS(3853),
    [anon_sym_alignas] = ACTIONS(3853),
    [anon_sym__Alignas] = ACTIONS(3853),
    [sym_primitive_type] = ACTIONS(3853),
    [anon_sym_enum] = ACTIONS(3853),
    [anon_sym_class] = ACTIONS(3853),
    [anon_sym_struct] = ACTIONS(3853),
    [anon_sym_union] = ACTIONS(3853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3853),
    [anon_sym_let] = ACTIONS(3853),
    [anon_sym_This] = ACTIONS(3853),
    [anon_sym_decltype] = ACTIONS(3853),
    [anon_sym_explicit] = ACTIONS(3853),
    [anon_sym_typename] = ACTIONS(3853),
    [anon_sym_private] = ACTIONS(3853),
    [anon_sym_template] = ACTIONS(3853),
    [anon_sym_operator] = ACTIONS(3853),
    [anon_sym_friend] = ACTIONS(3853),
    [anon_sym_public] = ACTIONS(3853),
    [anon_sym_protected] = ACTIONS(3853),
    [anon_sym_static_assert] = ACTIONS(3853),
    [anon_sym_precise] = ACTIONS(3853),
    [anon_sym_shared] = ACTIONS(3853),
    [anon_sym_groupshared] = ACTIONS(3853),
    [anon_sym_uniform] = ACTIONS(3853),
    [anon_sym_row_major] = ACTIONS(3853),
    [anon_sym_column_major] = ACTIONS(3853),
    [anon_sym_globallycoherent] = ACTIONS(3853),
    [anon_sym_centroid] = ACTIONS(3853),
    [anon_sym_noperspective] = ACTIONS(3853),
    [anon_sym_nointerpolation] = ACTIONS(3853),
    [anon_sym_sample] = ACTIONS(3853),
    [anon_sym_linear] = ACTIONS(3853),
    [anon_sym_snorm] = ACTIONS(3853),
    [anon_sym_unorm] = ACTIONS(3853),
    [anon_sym_point] = ACTIONS(3853),
    [anon_sym_line] = ACTIONS(3853),
    [anon_sym_triangleadj] = ACTIONS(3853),
    [anon_sym_lineadj] = ACTIONS(3853),
    [anon_sym_triangle] = ACTIONS(3853),
    [anon_sym_interface] = ACTIONS(3853),
    [anon_sym_extension] = ACTIONS(3853),
    [anon_sym___init] = ACTIONS(3853),
    [anon_sym___subscript] = ACTIONS(3853),
    [anon_sym_property] = ACTIONS(3853),
    [anon_sym_associatedtype] = ACTIONS(3853),
  },
  [2119] = {
    [sym_identifier] = ACTIONS(6218),
    [aux_sym_preproc_def_token1] = ACTIONS(6218),
    [aux_sym_preproc_if_token1] = ACTIONS(6218),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6218),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6218),
    [sym_preproc_directive] = ACTIONS(6218),
    [anon_sym_LPAREN2] = ACTIONS(6220),
    [anon_sym_TILDE] = ACTIONS(6220),
    [anon_sym_STAR] = ACTIONS(6220),
    [anon_sym_AMP_AMP] = ACTIONS(6220),
    [anon_sym_AMP] = ACTIONS(6218),
    [anon_sym_SEMI] = ACTIONS(6220),
    [anon_sym___extension__] = ACTIONS(6218),
    [anon_sym_typedef] = ACTIONS(6218),
    [anon_sym_in] = ACTIONS(6218),
    [anon_sym_out] = ACTIONS(6218),
    [anon_sym_inout] = ACTIONS(6218),
    [anon_sym_virtual] = ACTIONS(6218),
    [anon_sym_extern] = ACTIONS(6218),
    [anon_sym___attribute__] = ACTIONS(6218),
    [anon_sym___attribute] = ACTIONS(6218),
    [anon_sym_using] = ACTIONS(6218),
    [anon_sym_COLON_COLON] = ACTIONS(6220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6220),
    [anon_sym___declspec] = ACTIONS(6218),
    [anon_sym___based] = ACTIONS(6218),
    [anon_sym_RBRACE] = ACTIONS(6220),
    [anon_sym_signed] = ACTIONS(6218),
    [anon_sym_unsigned] = ACTIONS(6218),
    [anon_sym_long] = ACTIONS(6218),
    [anon_sym_short] = ACTIONS(6218),
    [anon_sym_LBRACK] = ACTIONS(6218),
    [anon_sym_static] = ACTIONS(6218),
    [anon_sym_register] = ACTIONS(6218),
    [anon_sym_inline] = ACTIONS(6218),
    [anon_sym___inline] = ACTIONS(6218),
    [anon_sym___inline__] = ACTIONS(6218),
    [anon_sym___forceinline] = ACTIONS(6218),
    [anon_sym_thread_local] = ACTIONS(6218),
    [anon_sym___thread] = ACTIONS(6218),
    [anon_sym_const] = ACTIONS(6218),
    [anon_sym_constexpr] = ACTIONS(6218),
    [anon_sym_volatile] = ACTIONS(6218),
    [anon_sym_restrict] = ACTIONS(6218),
    [anon_sym___restrict__] = ACTIONS(6218),
    [anon_sym__Atomic] = ACTIONS(6218),
    [anon_sym__Noreturn] = ACTIONS(6218),
    [anon_sym_noreturn] = ACTIONS(6218),
    [anon_sym__Nonnull] = ACTIONS(6218),
    [anon_sym_mutable] = ACTIONS(6218),
    [anon_sym_constinit] = ACTIONS(6218),
    [anon_sym_consteval] = ACTIONS(6218),
    [anon_sym_alignas] = ACTIONS(6218),
    [anon_sym__Alignas] = ACTIONS(6218),
    [sym_primitive_type] = ACTIONS(6218),
    [anon_sym_enum] = ACTIONS(6218),
    [anon_sym_class] = ACTIONS(6218),
    [anon_sym_struct] = ACTIONS(6218),
    [anon_sym_union] = ACTIONS(6218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6218),
    [anon_sym_let] = ACTIONS(6218),
    [anon_sym_This] = ACTIONS(6218),
    [anon_sym_decltype] = ACTIONS(6218),
    [anon_sym_explicit] = ACTIONS(6218),
    [anon_sym_typename] = ACTIONS(6218),
    [anon_sym_private] = ACTIONS(6218),
    [anon_sym_template] = ACTIONS(6218),
    [anon_sym_operator] = ACTIONS(6218),
    [anon_sym_friend] = ACTIONS(6218),
    [anon_sym_public] = ACTIONS(6218),
    [anon_sym_protected] = ACTIONS(6218),
    [anon_sym_static_assert] = ACTIONS(6218),
    [anon_sym_precise] = ACTIONS(6218),
    [anon_sym_shared] = ACTIONS(6218),
    [anon_sym_groupshared] = ACTIONS(6218),
    [anon_sym_uniform] = ACTIONS(6218),
    [anon_sym_row_major] = ACTIONS(6218),
    [anon_sym_column_major] = ACTIONS(6218),
    [anon_sym_globallycoherent] = ACTIONS(6218),
    [anon_sym_centroid] = ACTIONS(6218),
    [anon_sym_noperspective] = ACTIONS(6218),
    [anon_sym_nointerpolation] = ACTIONS(6218),
    [anon_sym_sample] = ACTIONS(6218),
    [anon_sym_linear] = ACTIONS(6218),
    [anon_sym_snorm] = ACTIONS(6218),
    [anon_sym_unorm] = ACTIONS(6218),
    [anon_sym_point] = ACTIONS(6218),
    [anon_sym_line] = ACTIONS(6218),
    [anon_sym_triangleadj] = ACTIONS(6218),
    [anon_sym_lineadj] = ACTIONS(6218),
    [anon_sym_triangle] = ACTIONS(6218),
    [anon_sym_interface] = ACTIONS(6218),
    [anon_sym_extension] = ACTIONS(6218),
    [anon_sym___init] = ACTIONS(6218),
    [anon_sym___subscript] = ACTIONS(6218),
    [anon_sym_property] = ACTIONS(6218),
    [anon_sym_associatedtype] = ACTIONS(6218),
  },
  [2120] = {
    [sym_identifier] = ACTIONS(6222),
    [aux_sym_preproc_def_token1] = ACTIONS(6222),
    [aux_sym_preproc_if_token1] = ACTIONS(6222),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6222),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6222),
    [sym_preproc_directive] = ACTIONS(6222),
    [anon_sym_LPAREN2] = ACTIONS(6224),
    [anon_sym_TILDE] = ACTIONS(6224),
    [anon_sym_STAR] = ACTIONS(6224),
    [anon_sym_AMP_AMP] = ACTIONS(6224),
    [anon_sym_AMP] = ACTIONS(6222),
    [anon_sym_SEMI] = ACTIONS(6224),
    [anon_sym___extension__] = ACTIONS(6222),
    [anon_sym_typedef] = ACTIONS(6222),
    [anon_sym_in] = ACTIONS(6222),
    [anon_sym_out] = ACTIONS(6222),
    [anon_sym_inout] = ACTIONS(6222),
    [anon_sym_virtual] = ACTIONS(6222),
    [anon_sym_extern] = ACTIONS(6222),
    [anon_sym___attribute__] = ACTIONS(6222),
    [anon_sym___attribute] = ACTIONS(6222),
    [anon_sym_using] = ACTIONS(6222),
    [anon_sym_COLON_COLON] = ACTIONS(6224),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6224),
    [anon_sym___declspec] = ACTIONS(6222),
    [anon_sym___based] = ACTIONS(6222),
    [anon_sym_RBRACE] = ACTIONS(6224),
    [anon_sym_signed] = ACTIONS(6222),
    [anon_sym_unsigned] = ACTIONS(6222),
    [anon_sym_long] = ACTIONS(6222),
    [anon_sym_short] = ACTIONS(6222),
    [anon_sym_LBRACK] = ACTIONS(6222),
    [anon_sym_static] = ACTIONS(6222),
    [anon_sym_register] = ACTIONS(6222),
    [anon_sym_inline] = ACTIONS(6222),
    [anon_sym___inline] = ACTIONS(6222),
    [anon_sym___inline__] = ACTIONS(6222),
    [anon_sym___forceinline] = ACTIONS(6222),
    [anon_sym_thread_local] = ACTIONS(6222),
    [anon_sym___thread] = ACTIONS(6222),
    [anon_sym_const] = ACTIONS(6222),
    [anon_sym_constexpr] = ACTIONS(6222),
    [anon_sym_volatile] = ACTIONS(6222),
    [anon_sym_restrict] = ACTIONS(6222),
    [anon_sym___restrict__] = ACTIONS(6222),
    [anon_sym__Atomic] = ACTIONS(6222),
    [anon_sym__Noreturn] = ACTIONS(6222),
    [anon_sym_noreturn] = ACTIONS(6222),
    [anon_sym__Nonnull] = ACTIONS(6222),
    [anon_sym_mutable] = ACTIONS(6222),
    [anon_sym_constinit] = ACTIONS(6222),
    [anon_sym_consteval] = ACTIONS(6222),
    [anon_sym_alignas] = ACTIONS(6222),
    [anon_sym__Alignas] = ACTIONS(6222),
    [sym_primitive_type] = ACTIONS(6222),
    [anon_sym_enum] = ACTIONS(6222),
    [anon_sym_class] = ACTIONS(6222),
    [anon_sym_struct] = ACTIONS(6222),
    [anon_sym_union] = ACTIONS(6222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6222),
    [anon_sym_let] = ACTIONS(6222),
    [anon_sym_This] = ACTIONS(6222),
    [anon_sym_decltype] = ACTIONS(6222),
    [anon_sym_explicit] = ACTIONS(6222),
    [anon_sym_typename] = ACTIONS(6222),
    [anon_sym_private] = ACTIONS(6222),
    [anon_sym_template] = ACTIONS(6222),
    [anon_sym_operator] = ACTIONS(6222),
    [anon_sym_friend] = ACTIONS(6222),
    [anon_sym_public] = ACTIONS(6222),
    [anon_sym_protected] = ACTIONS(6222),
    [anon_sym_static_assert] = ACTIONS(6222),
    [anon_sym_precise] = ACTIONS(6222),
    [anon_sym_shared] = ACTIONS(6222),
    [anon_sym_groupshared] = ACTIONS(6222),
    [anon_sym_uniform] = ACTIONS(6222),
    [anon_sym_row_major] = ACTIONS(6222),
    [anon_sym_column_major] = ACTIONS(6222),
    [anon_sym_globallycoherent] = ACTIONS(6222),
    [anon_sym_centroid] = ACTIONS(6222),
    [anon_sym_noperspective] = ACTIONS(6222),
    [anon_sym_nointerpolation] = ACTIONS(6222),
    [anon_sym_sample] = ACTIONS(6222),
    [anon_sym_linear] = ACTIONS(6222),
    [anon_sym_snorm] = ACTIONS(6222),
    [anon_sym_unorm] = ACTIONS(6222),
    [anon_sym_point] = ACTIONS(6222),
    [anon_sym_line] = ACTIONS(6222),
    [anon_sym_triangleadj] = ACTIONS(6222),
    [anon_sym_lineadj] = ACTIONS(6222),
    [anon_sym_triangle] = ACTIONS(6222),
    [anon_sym_interface] = ACTIONS(6222),
    [anon_sym_extension] = ACTIONS(6222),
    [anon_sym___init] = ACTIONS(6222),
    [anon_sym___subscript] = ACTIONS(6222),
    [anon_sym_property] = ACTIONS(6222),
    [anon_sym_associatedtype] = ACTIONS(6222),
  },
  [2121] = {
    [sym_identifier] = ACTIONS(3857),
    [aux_sym_preproc_def_token1] = ACTIONS(3857),
    [aux_sym_preproc_if_token1] = ACTIONS(3857),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3857),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3857),
    [sym_preproc_directive] = ACTIONS(3857),
    [anon_sym_LPAREN2] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3859),
    [anon_sym_STAR] = ACTIONS(3859),
    [anon_sym_AMP_AMP] = ACTIONS(3859),
    [anon_sym_AMP] = ACTIONS(3857),
    [anon_sym_SEMI] = ACTIONS(3859),
    [anon_sym___extension__] = ACTIONS(3857),
    [anon_sym_typedef] = ACTIONS(3857),
    [anon_sym_in] = ACTIONS(3857),
    [anon_sym_out] = ACTIONS(3857),
    [anon_sym_inout] = ACTIONS(3857),
    [anon_sym_virtual] = ACTIONS(3857),
    [anon_sym_extern] = ACTIONS(3857),
    [anon_sym___attribute__] = ACTIONS(3857),
    [anon_sym___attribute] = ACTIONS(3857),
    [anon_sym_using] = ACTIONS(3857),
    [anon_sym_COLON_COLON] = ACTIONS(3859),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3859),
    [anon_sym___declspec] = ACTIONS(3857),
    [anon_sym___based] = ACTIONS(3857),
    [anon_sym_RBRACE] = ACTIONS(3859),
    [anon_sym_signed] = ACTIONS(3857),
    [anon_sym_unsigned] = ACTIONS(3857),
    [anon_sym_long] = ACTIONS(3857),
    [anon_sym_short] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(3857),
    [anon_sym_static] = ACTIONS(3857),
    [anon_sym_register] = ACTIONS(3857),
    [anon_sym_inline] = ACTIONS(3857),
    [anon_sym___inline] = ACTIONS(3857),
    [anon_sym___inline__] = ACTIONS(3857),
    [anon_sym___forceinline] = ACTIONS(3857),
    [anon_sym_thread_local] = ACTIONS(3857),
    [anon_sym___thread] = ACTIONS(3857),
    [anon_sym_const] = ACTIONS(3857),
    [anon_sym_constexpr] = ACTIONS(3857),
    [anon_sym_volatile] = ACTIONS(3857),
    [anon_sym_restrict] = ACTIONS(3857),
    [anon_sym___restrict__] = ACTIONS(3857),
    [anon_sym__Atomic] = ACTIONS(3857),
    [anon_sym__Noreturn] = ACTIONS(3857),
    [anon_sym_noreturn] = ACTIONS(3857),
    [anon_sym__Nonnull] = ACTIONS(3857),
    [anon_sym_mutable] = ACTIONS(3857),
    [anon_sym_constinit] = ACTIONS(3857),
    [anon_sym_consteval] = ACTIONS(3857),
    [anon_sym_alignas] = ACTIONS(3857),
    [anon_sym__Alignas] = ACTIONS(3857),
    [sym_primitive_type] = ACTIONS(3857),
    [anon_sym_enum] = ACTIONS(3857),
    [anon_sym_class] = ACTIONS(3857),
    [anon_sym_struct] = ACTIONS(3857),
    [anon_sym_union] = ACTIONS(3857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3857),
    [anon_sym_let] = ACTIONS(3857),
    [anon_sym_This] = ACTIONS(3857),
    [anon_sym_decltype] = ACTIONS(3857),
    [anon_sym_explicit] = ACTIONS(3857),
    [anon_sym_typename] = ACTIONS(3857),
    [anon_sym_private] = ACTIONS(3857),
    [anon_sym_template] = ACTIONS(3857),
    [anon_sym_operator] = ACTIONS(3857),
    [anon_sym_friend] = ACTIONS(3857),
    [anon_sym_public] = ACTIONS(3857),
    [anon_sym_protected] = ACTIONS(3857),
    [anon_sym_static_assert] = ACTIONS(3857),
    [anon_sym_precise] = ACTIONS(3857),
    [anon_sym_shared] = ACTIONS(3857),
    [anon_sym_groupshared] = ACTIONS(3857),
    [anon_sym_uniform] = ACTIONS(3857),
    [anon_sym_row_major] = ACTIONS(3857),
    [anon_sym_column_major] = ACTIONS(3857),
    [anon_sym_globallycoherent] = ACTIONS(3857),
    [anon_sym_centroid] = ACTIONS(3857),
    [anon_sym_noperspective] = ACTIONS(3857),
    [anon_sym_nointerpolation] = ACTIONS(3857),
    [anon_sym_sample] = ACTIONS(3857),
    [anon_sym_linear] = ACTIONS(3857),
    [anon_sym_snorm] = ACTIONS(3857),
    [anon_sym_unorm] = ACTIONS(3857),
    [anon_sym_point] = ACTIONS(3857),
    [anon_sym_line] = ACTIONS(3857),
    [anon_sym_triangleadj] = ACTIONS(3857),
    [anon_sym_lineadj] = ACTIONS(3857),
    [anon_sym_triangle] = ACTIONS(3857),
    [anon_sym_interface] = ACTIONS(3857),
    [anon_sym_extension] = ACTIONS(3857),
    [anon_sym___init] = ACTIONS(3857),
    [anon_sym___subscript] = ACTIONS(3857),
    [anon_sym_property] = ACTIONS(3857),
    [anon_sym_associatedtype] = ACTIONS(3857),
  },
  [2122] = {
    [sym_identifier] = ACTIONS(3861),
    [aux_sym_preproc_def_token1] = ACTIONS(3861),
    [aux_sym_preproc_if_token1] = ACTIONS(3861),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3861),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3861),
    [sym_preproc_directive] = ACTIONS(3861),
    [anon_sym_LPAREN2] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3863),
    [anon_sym_STAR] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_AMP] = ACTIONS(3861),
    [anon_sym_SEMI] = ACTIONS(3863),
    [anon_sym___extension__] = ACTIONS(3861),
    [anon_sym_typedef] = ACTIONS(3861),
    [anon_sym_in] = ACTIONS(3861),
    [anon_sym_out] = ACTIONS(3861),
    [anon_sym_inout] = ACTIONS(3861),
    [anon_sym_virtual] = ACTIONS(3861),
    [anon_sym_extern] = ACTIONS(3861),
    [anon_sym___attribute__] = ACTIONS(3861),
    [anon_sym___attribute] = ACTIONS(3861),
    [anon_sym_using] = ACTIONS(3861),
    [anon_sym_COLON_COLON] = ACTIONS(3863),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3863),
    [anon_sym___declspec] = ACTIONS(3861),
    [anon_sym___based] = ACTIONS(3861),
    [anon_sym_RBRACE] = ACTIONS(3863),
    [anon_sym_signed] = ACTIONS(3861),
    [anon_sym_unsigned] = ACTIONS(3861),
    [anon_sym_long] = ACTIONS(3861),
    [anon_sym_short] = ACTIONS(3861),
    [anon_sym_LBRACK] = ACTIONS(3861),
    [anon_sym_static] = ACTIONS(3861),
    [anon_sym_register] = ACTIONS(3861),
    [anon_sym_inline] = ACTIONS(3861),
    [anon_sym___inline] = ACTIONS(3861),
    [anon_sym___inline__] = ACTIONS(3861),
    [anon_sym___forceinline] = ACTIONS(3861),
    [anon_sym_thread_local] = ACTIONS(3861),
    [anon_sym___thread] = ACTIONS(3861),
    [anon_sym_const] = ACTIONS(3861),
    [anon_sym_constexpr] = ACTIONS(3861),
    [anon_sym_volatile] = ACTIONS(3861),
    [anon_sym_restrict] = ACTIONS(3861),
    [anon_sym___restrict__] = ACTIONS(3861),
    [anon_sym__Atomic] = ACTIONS(3861),
    [anon_sym__Noreturn] = ACTIONS(3861),
    [anon_sym_noreturn] = ACTIONS(3861),
    [anon_sym__Nonnull] = ACTIONS(3861),
    [anon_sym_mutable] = ACTIONS(3861),
    [anon_sym_constinit] = ACTIONS(3861),
    [anon_sym_consteval] = ACTIONS(3861),
    [anon_sym_alignas] = ACTIONS(3861),
    [anon_sym__Alignas] = ACTIONS(3861),
    [sym_primitive_type] = ACTIONS(3861),
    [anon_sym_enum] = ACTIONS(3861),
    [anon_sym_class] = ACTIONS(3861),
    [anon_sym_struct] = ACTIONS(3861),
    [anon_sym_union] = ACTIONS(3861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3861),
    [anon_sym_let] = ACTIONS(3861),
    [anon_sym_This] = ACTIONS(3861),
    [anon_sym_decltype] = ACTIONS(3861),
    [anon_sym_explicit] = ACTIONS(3861),
    [anon_sym_typename] = ACTIONS(3861),
    [anon_sym_private] = ACTIONS(3861),
    [anon_sym_template] = ACTIONS(3861),
    [anon_sym_operator] = ACTIONS(3861),
    [anon_sym_friend] = ACTIONS(3861),
    [anon_sym_public] = ACTIONS(3861),
    [anon_sym_protected] = ACTIONS(3861),
    [anon_sym_static_assert] = ACTIONS(3861),
    [anon_sym_precise] = ACTIONS(3861),
    [anon_sym_shared] = ACTIONS(3861),
    [anon_sym_groupshared] = ACTIONS(3861),
    [anon_sym_uniform] = ACTIONS(3861),
    [anon_sym_row_major] = ACTIONS(3861),
    [anon_sym_column_major] = ACTIONS(3861),
    [anon_sym_globallycoherent] = ACTIONS(3861),
    [anon_sym_centroid] = ACTIONS(3861),
    [anon_sym_noperspective] = ACTIONS(3861),
    [anon_sym_nointerpolation] = ACTIONS(3861),
    [anon_sym_sample] = ACTIONS(3861),
    [anon_sym_linear] = ACTIONS(3861),
    [anon_sym_snorm] = ACTIONS(3861),
    [anon_sym_unorm] = ACTIONS(3861),
    [anon_sym_point] = ACTIONS(3861),
    [anon_sym_line] = ACTIONS(3861),
    [anon_sym_triangleadj] = ACTIONS(3861),
    [anon_sym_lineadj] = ACTIONS(3861),
    [anon_sym_triangle] = ACTIONS(3861),
    [anon_sym_interface] = ACTIONS(3861),
    [anon_sym_extension] = ACTIONS(3861),
    [anon_sym___init] = ACTIONS(3861),
    [anon_sym___subscript] = ACTIONS(3861),
    [anon_sym_property] = ACTIONS(3861),
    [anon_sym_associatedtype] = ACTIONS(3861),
  },
  [2123] = {
    [sym_identifier] = ACTIONS(6226),
    [aux_sym_preproc_def_token1] = ACTIONS(6226),
    [aux_sym_preproc_if_token1] = ACTIONS(6226),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6226),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6226),
    [sym_preproc_directive] = ACTIONS(6226),
    [anon_sym_LPAREN2] = ACTIONS(6228),
    [anon_sym_TILDE] = ACTIONS(6228),
    [anon_sym_STAR] = ACTIONS(6228),
    [anon_sym_AMP_AMP] = ACTIONS(6228),
    [anon_sym_AMP] = ACTIONS(6226),
    [anon_sym_SEMI] = ACTIONS(6228),
    [anon_sym___extension__] = ACTIONS(6226),
    [anon_sym_typedef] = ACTIONS(6226),
    [anon_sym_in] = ACTIONS(6226),
    [anon_sym_out] = ACTIONS(6226),
    [anon_sym_inout] = ACTIONS(6226),
    [anon_sym_virtual] = ACTIONS(6226),
    [anon_sym_extern] = ACTIONS(6226),
    [anon_sym___attribute__] = ACTIONS(6226),
    [anon_sym___attribute] = ACTIONS(6226),
    [anon_sym_using] = ACTIONS(6226),
    [anon_sym_COLON_COLON] = ACTIONS(6228),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6228),
    [anon_sym___declspec] = ACTIONS(6226),
    [anon_sym___based] = ACTIONS(6226),
    [anon_sym_RBRACE] = ACTIONS(6228),
    [anon_sym_signed] = ACTIONS(6226),
    [anon_sym_unsigned] = ACTIONS(6226),
    [anon_sym_long] = ACTIONS(6226),
    [anon_sym_short] = ACTIONS(6226),
    [anon_sym_LBRACK] = ACTIONS(6226),
    [anon_sym_static] = ACTIONS(6226),
    [anon_sym_register] = ACTIONS(6226),
    [anon_sym_inline] = ACTIONS(6226),
    [anon_sym___inline] = ACTIONS(6226),
    [anon_sym___inline__] = ACTIONS(6226),
    [anon_sym___forceinline] = ACTIONS(6226),
    [anon_sym_thread_local] = ACTIONS(6226),
    [anon_sym___thread] = ACTIONS(6226),
    [anon_sym_const] = ACTIONS(6226),
    [anon_sym_constexpr] = ACTIONS(6226),
    [anon_sym_volatile] = ACTIONS(6226),
    [anon_sym_restrict] = ACTIONS(6226),
    [anon_sym___restrict__] = ACTIONS(6226),
    [anon_sym__Atomic] = ACTIONS(6226),
    [anon_sym__Noreturn] = ACTIONS(6226),
    [anon_sym_noreturn] = ACTIONS(6226),
    [anon_sym__Nonnull] = ACTIONS(6226),
    [anon_sym_mutable] = ACTIONS(6226),
    [anon_sym_constinit] = ACTIONS(6226),
    [anon_sym_consteval] = ACTIONS(6226),
    [anon_sym_alignas] = ACTIONS(6226),
    [anon_sym__Alignas] = ACTIONS(6226),
    [sym_primitive_type] = ACTIONS(6226),
    [anon_sym_enum] = ACTIONS(6226),
    [anon_sym_class] = ACTIONS(6226),
    [anon_sym_struct] = ACTIONS(6226),
    [anon_sym_union] = ACTIONS(6226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6226),
    [anon_sym_let] = ACTIONS(6226),
    [anon_sym_This] = ACTIONS(6226),
    [anon_sym_decltype] = ACTIONS(6226),
    [anon_sym_explicit] = ACTIONS(6226),
    [anon_sym_typename] = ACTIONS(6226),
    [anon_sym_private] = ACTIONS(6226),
    [anon_sym_template] = ACTIONS(6226),
    [anon_sym_operator] = ACTIONS(6226),
    [anon_sym_friend] = ACTIONS(6226),
    [anon_sym_public] = ACTIONS(6226),
    [anon_sym_protected] = ACTIONS(6226),
    [anon_sym_static_assert] = ACTIONS(6226),
    [anon_sym_precise] = ACTIONS(6226),
    [anon_sym_shared] = ACTIONS(6226),
    [anon_sym_groupshared] = ACTIONS(6226),
    [anon_sym_uniform] = ACTIONS(6226),
    [anon_sym_row_major] = ACTIONS(6226),
    [anon_sym_column_major] = ACTIONS(6226),
    [anon_sym_globallycoherent] = ACTIONS(6226),
    [anon_sym_centroid] = ACTIONS(6226),
    [anon_sym_noperspective] = ACTIONS(6226),
    [anon_sym_nointerpolation] = ACTIONS(6226),
    [anon_sym_sample] = ACTIONS(6226),
    [anon_sym_linear] = ACTIONS(6226),
    [anon_sym_snorm] = ACTIONS(6226),
    [anon_sym_unorm] = ACTIONS(6226),
    [anon_sym_point] = ACTIONS(6226),
    [anon_sym_line] = ACTIONS(6226),
    [anon_sym_triangleadj] = ACTIONS(6226),
    [anon_sym_lineadj] = ACTIONS(6226),
    [anon_sym_triangle] = ACTIONS(6226),
    [anon_sym_interface] = ACTIONS(6226),
    [anon_sym_extension] = ACTIONS(6226),
    [anon_sym___init] = ACTIONS(6226),
    [anon_sym___subscript] = ACTIONS(6226),
    [anon_sym_property] = ACTIONS(6226),
    [anon_sym_associatedtype] = ACTIONS(6226),
  },
  [2124] = {
    [sym_identifier] = ACTIONS(6230),
    [aux_sym_preproc_def_token1] = ACTIONS(6230),
    [aux_sym_preproc_if_token1] = ACTIONS(6230),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6230),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6230),
    [sym_preproc_directive] = ACTIONS(6230),
    [anon_sym_LPAREN2] = ACTIONS(6232),
    [anon_sym_TILDE] = ACTIONS(6232),
    [anon_sym_STAR] = ACTIONS(6232),
    [anon_sym_AMP_AMP] = ACTIONS(6232),
    [anon_sym_AMP] = ACTIONS(6230),
    [anon_sym_SEMI] = ACTIONS(6232),
    [anon_sym___extension__] = ACTIONS(6230),
    [anon_sym_typedef] = ACTIONS(6230),
    [anon_sym_in] = ACTIONS(6230),
    [anon_sym_out] = ACTIONS(6230),
    [anon_sym_inout] = ACTIONS(6230),
    [anon_sym_virtual] = ACTIONS(6230),
    [anon_sym_extern] = ACTIONS(6230),
    [anon_sym___attribute__] = ACTIONS(6230),
    [anon_sym___attribute] = ACTIONS(6230),
    [anon_sym_using] = ACTIONS(6230),
    [anon_sym_COLON_COLON] = ACTIONS(6232),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6232),
    [anon_sym___declspec] = ACTIONS(6230),
    [anon_sym___based] = ACTIONS(6230),
    [anon_sym_RBRACE] = ACTIONS(6232),
    [anon_sym_signed] = ACTIONS(6230),
    [anon_sym_unsigned] = ACTIONS(6230),
    [anon_sym_long] = ACTIONS(6230),
    [anon_sym_short] = ACTIONS(6230),
    [anon_sym_LBRACK] = ACTIONS(6230),
    [anon_sym_static] = ACTIONS(6230),
    [anon_sym_register] = ACTIONS(6230),
    [anon_sym_inline] = ACTIONS(6230),
    [anon_sym___inline] = ACTIONS(6230),
    [anon_sym___inline__] = ACTIONS(6230),
    [anon_sym___forceinline] = ACTIONS(6230),
    [anon_sym_thread_local] = ACTIONS(6230),
    [anon_sym___thread] = ACTIONS(6230),
    [anon_sym_const] = ACTIONS(6230),
    [anon_sym_constexpr] = ACTIONS(6230),
    [anon_sym_volatile] = ACTIONS(6230),
    [anon_sym_restrict] = ACTIONS(6230),
    [anon_sym___restrict__] = ACTIONS(6230),
    [anon_sym__Atomic] = ACTIONS(6230),
    [anon_sym__Noreturn] = ACTIONS(6230),
    [anon_sym_noreturn] = ACTIONS(6230),
    [anon_sym__Nonnull] = ACTIONS(6230),
    [anon_sym_mutable] = ACTIONS(6230),
    [anon_sym_constinit] = ACTIONS(6230),
    [anon_sym_consteval] = ACTIONS(6230),
    [anon_sym_alignas] = ACTIONS(6230),
    [anon_sym__Alignas] = ACTIONS(6230),
    [sym_primitive_type] = ACTIONS(6230),
    [anon_sym_enum] = ACTIONS(6230),
    [anon_sym_class] = ACTIONS(6230),
    [anon_sym_struct] = ACTIONS(6230),
    [anon_sym_union] = ACTIONS(6230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6230),
    [anon_sym_let] = ACTIONS(6230),
    [anon_sym_This] = ACTIONS(6230),
    [anon_sym_decltype] = ACTIONS(6230),
    [anon_sym_explicit] = ACTIONS(6230),
    [anon_sym_typename] = ACTIONS(6230),
    [anon_sym_private] = ACTIONS(6230),
    [anon_sym_template] = ACTIONS(6230),
    [anon_sym_operator] = ACTIONS(6230),
    [anon_sym_friend] = ACTIONS(6230),
    [anon_sym_public] = ACTIONS(6230),
    [anon_sym_protected] = ACTIONS(6230),
    [anon_sym_static_assert] = ACTIONS(6230),
    [anon_sym_precise] = ACTIONS(6230),
    [anon_sym_shared] = ACTIONS(6230),
    [anon_sym_groupshared] = ACTIONS(6230),
    [anon_sym_uniform] = ACTIONS(6230),
    [anon_sym_row_major] = ACTIONS(6230),
    [anon_sym_column_major] = ACTIONS(6230),
    [anon_sym_globallycoherent] = ACTIONS(6230),
    [anon_sym_centroid] = ACTIONS(6230),
    [anon_sym_noperspective] = ACTIONS(6230),
    [anon_sym_nointerpolation] = ACTIONS(6230),
    [anon_sym_sample] = ACTIONS(6230),
    [anon_sym_linear] = ACTIONS(6230),
    [anon_sym_snorm] = ACTIONS(6230),
    [anon_sym_unorm] = ACTIONS(6230),
    [anon_sym_point] = ACTIONS(6230),
    [anon_sym_line] = ACTIONS(6230),
    [anon_sym_triangleadj] = ACTIONS(6230),
    [anon_sym_lineadj] = ACTIONS(6230),
    [anon_sym_triangle] = ACTIONS(6230),
    [anon_sym_interface] = ACTIONS(6230),
    [anon_sym_extension] = ACTIONS(6230),
    [anon_sym___init] = ACTIONS(6230),
    [anon_sym___subscript] = ACTIONS(6230),
    [anon_sym_property] = ACTIONS(6230),
    [anon_sym_associatedtype] = ACTIONS(6230),
  },
  [2125] = {
    [sym_identifier] = ACTIONS(6236),
    [aux_sym_preproc_def_token1] = ACTIONS(6236),
    [aux_sym_preproc_if_token1] = ACTIONS(6236),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6236),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6236),
    [sym_preproc_directive] = ACTIONS(6236),
    [anon_sym_LPAREN2] = ACTIONS(6238),
    [anon_sym_TILDE] = ACTIONS(6238),
    [anon_sym_STAR] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6236),
    [anon_sym_SEMI] = ACTIONS(6238),
    [anon_sym___extension__] = ACTIONS(6236),
    [anon_sym_typedef] = ACTIONS(6236),
    [anon_sym_in] = ACTIONS(6236),
    [anon_sym_out] = ACTIONS(6236),
    [anon_sym_inout] = ACTIONS(6236),
    [anon_sym_virtual] = ACTIONS(6236),
    [anon_sym_extern] = ACTIONS(6236),
    [anon_sym___attribute__] = ACTIONS(6236),
    [anon_sym___attribute] = ACTIONS(6236),
    [anon_sym_using] = ACTIONS(6236),
    [anon_sym_COLON_COLON] = ACTIONS(6238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6238),
    [anon_sym___declspec] = ACTIONS(6236),
    [anon_sym___based] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6238),
    [anon_sym_signed] = ACTIONS(6236),
    [anon_sym_unsigned] = ACTIONS(6236),
    [anon_sym_long] = ACTIONS(6236),
    [anon_sym_short] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_static] = ACTIONS(6236),
    [anon_sym_register] = ACTIONS(6236),
    [anon_sym_inline] = ACTIONS(6236),
    [anon_sym___inline] = ACTIONS(6236),
    [anon_sym___inline__] = ACTIONS(6236),
    [anon_sym___forceinline] = ACTIONS(6236),
    [anon_sym_thread_local] = ACTIONS(6236),
    [anon_sym___thread] = ACTIONS(6236),
    [anon_sym_const] = ACTIONS(6236),
    [anon_sym_constexpr] = ACTIONS(6236),
    [anon_sym_volatile] = ACTIONS(6236),
    [anon_sym_restrict] = ACTIONS(6236),
    [anon_sym___restrict__] = ACTIONS(6236),
    [anon_sym__Atomic] = ACTIONS(6236),
    [anon_sym__Noreturn] = ACTIONS(6236),
    [anon_sym_noreturn] = ACTIONS(6236),
    [anon_sym__Nonnull] = ACTIONS(6236),
    [anon_sym_mutable] = ACTIONS(6236),
    [anon_sym_constinit] = ACTIONS(6236),
    [anon_sym_consteval] = ACTIONS(6236),
    [anon_sym_alignas] = ACTIONS(6236),
    [anon_sym__Alignas] = ACTIONS(6236),
    [sym_primitive_type] = ACTIONS(6236),
    [anon_sym_enum] = ACTIONS(6236),
    [anon_sym_class] = ACTIONS(6236),
    [anon_sym_struct] = ACTIONS(6236),
    [anon_sym_union] = ACTIONS(6236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6236),
    [anon_sym_let] = ACTIONS(6236),
    [anon_sym_This] = ACTIONS(6236),
    [anon_sym_decltype] = ACTIONS(6236),
    [anon_sym_explicit] = ACTIONS(6236),
    [anon_sym_typename] = ACTIONS(6236),
    [anon_sym_private] = ACTIONS(6236),
    [anon_sym_template] = ACTIONS(6236),
    [anon_sym_operator] = ACTIONS(6236),
    [anon_sym_friend] = ACTIONS(6236),
    [anon_sym_public] = ACTIONS(6236),
    [anon_sym_protected] = ACTIONS(6236),
    [anon_sym_static_assert] = ACTIONS(6236),
    [anon_sym_precise] = ACTIONS(6236),
    [anon_sym_shared] = ACTIONS(6236),
    [anon_sym_groupshared] = ACTIONS(6236),
    [anon_sym_uniform] = ACTIONS(6236),
    [anon_sym_row_major] = ACTIONS(6236),
    [anon_sym_column_major] = ACTIONS(6236),
    [anon_sym_globallycoherent] = ACTIONS(6236),
    [anon_sym_centroid] = ACTIONS(6236),
    [anon_sym_noperspective] = ACTIONS(6236),
    [anon_sym_nointerpolation] = ACTIONS(6236),
    [anon_sym_sample] = ACTIONS(6236),
    [anon_sym_linear] = ACTIONS(6236),
    [anon_sym_snorm] = ACTIONS(6236),
    [anon_sym_unorm] = ACTIONS(6236),
    [anon_sym_point] = ACTIONS(6236),
    [anon_sym_line] = ACTIONS(6236),
    [anon_sym_triangleadj] = ACTIONS(6236),
    [anon_sym_lineadj] = ACTIONS(6236),
    [anon_sym_triangle] = ACTIONS(6236),
    [anon_sym_interface] = ACTIONS(6236),
    [anon_sym_extension] = ACTIONS(6236),
    [anon_sym___init] = ACTIONS(6236),
    [anon_sym___subscript] = ACTIONS(6236),
    [anon_sym_property] = ACTIONS(6236),
    [anon_sym_associatedtype] = ACTIONS(6236),
  },
  [2126] = {
    [sym_identifier] = ACTIONS(3581),
    [aux_sym_preproc_def_token1] = ACTIONS(3581),
    [aux_sym_preproc_if_token1] = ACTIONS(3581),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3581),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3581),
    [sym_preproc_directive] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(3579),
    [anon_sym_TILDE] = ACTIONS(3579),
    [anon_sym_STAR] = ACTIONS(3579),
    [anon_sym_AMP_AMP] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3581),
    [anon_sym_SEMI] = ACTIONS(3579),
    [anon_sym___extension__] = ACTIONS(3581),
    [anon_sym_typedef] = ACTIONS(3581),
    [anon_sym_in] = ACTIONS(3581),
    [anon_sym_out] = ACTIONS(3581),
    [anon_sym_inout] = ACTIONS(3581),
    [anon_sym_virtual] = ACTIONS(3581),
    [anon_sym_extern] = ACTIONS(3581),
    [anon_sym___attribute__] = ACTIONS(3581),
    [anon_sym___attribute] = ACTIONS(3581),
    [anon_sym_using] = ACTIONS(3581),
    [anon_sym_COLON_COLON] = ACTIONS(3579),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3579),
    [anon_sym___declspec] = ACTIONS(3581),
    [anon_sym___based] = ACTIONS(3581),
    [anon_sym_RBRACE] = ACTIONS(3579),
    [anon_sym_signed] = ACTIONS(3581),
    [anon_sym_unsigned] = ACTIONS(3581),
    [anon_sym_long] = ACTIONS(3581),
    [anon_sym_short] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_static] = ACTIONS(3581),
    [anon_sym_register] = ACTIONS(3581),
    [anon_sym_inline] = ACTIONS(3581),
    [anon_sym___inline] = ACTIONS(3581),
    [anon_sym___inline__] = ACTIONS(3581),
    [anon_sym___forceinline] = ACTIONS(3581),
    [anon_sym_thread_local] = ACTIONS(3581),
    [anon_sym___thread] = ACTIONS(3581),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_constexpr] = ACTIONS(3581),
    [anon_sym_volatile] = ACTIONS(3581),
    [anon_sym_restrict] = ACTIONS(3581),
    [anon_sym___restrict__] = ACTIONS(3581),
    [anon_sym__Atomic] = ACTIONS(3581),
    [anon_sym__Noreturn] = ACTIONS(3581),
    [anon_sym_noreturn] = ACTIONS(3581),
    [anon_sym__Nonnull] = ACTIONS(3581),
    [anon_sym_mutable] = ACTIONS(3581),
    [anon_sym_constinit] = ACTIONS(3581),
    [anon_sym_consteval] = ACTIONS(3581),
    [anon_sym_alignas] = ACTIONS(3581),
    [anon_sym__Alignas] = ACTIONS(3581),
    [sym_primitive_type] = ACTIONS(3581),
    [anon_sym_enum] = ACTIONS(3581),
    [anon_sym_class] = ACTIONS(3581),
    [anon_sym_struct] = ACTIONS(3581),
    [anon_sym_union] = ACTIONS(3581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_This] = ACTIONS(3581),
    [anon_sym_decltype] = ACTIONS(3581),
    [anon_sym_explicit] = ACTIONS(3581),
    [anon_sym_typename] = ACTIONS(3581),
    [anon_sym_private] = ACTIONS(3581),
    [anon_sym_template] = ACTIONS(3581),
    [anon_sym_operator] = ACTIONS(3581),
    [anon_sym_friend] = ACTIONS(3581),
    [anon_sym_public] = ACTIONS(3581),
    [anon_sym_protected] = ACTIONS(3581),
    [anon_sym_static_assert] = ACTIONS(3581),
    [anon_sym_precise] = ACTIONS(3581),
    [anon_sym_shared] = ACTIONS(3581),
    [anon_sym_groupshared] = ACTIONS(3581),
    [anon_sym_uniform] = ACTIONS(3581),
    [anon_sym_row_major] = ACTIONS(3581),
    [anon_sym_column_major] = ACTIONS(3581),
    [anon_sym_globallycoherent] = ACTIONS(3581),
    [anon_sym_centroid] = ACTIONS(3581),
    [anon_sym_noperspective] = ACTIONS(3581),
    [anon_sym_nointerpolation] = ACTIONS(3581),
    [anon_sym_sample] = ACTIONS(3581),
    [anon_sym_linear] = ACTIONS(3581),
    [anon_sym_snorm] = ACTIONS(3581),
    [anon_sym_unorm] = ACTIONS(3581),
    [anon_sym_point] = ACTIONS(3581),
    [anon_sym_line] = ACTIONS(3581),
    [anon_sym_triangleadj] = ACTIONS(3581),
    [anon_sym_lineadj] = ACTIONS(3581),
    [anon_sym_triangle] = ACTIONS(3581),
    [anon_sym_interface] = ACTIONS(3581),
    [anon_sym_extension] = ACTIONS(3581),
    [anon_sym___init] = ACTIONS(3581),
    [anon_sym___subscript] = ACTIONS(3581),
    [anon_sym_property] = ACTIONS(3581),
    [anon_sym_associatedtype] = ACTIONS(3581),
  },
  [2127] = {
    [sym_identifier] = ACTIONS(3591),
    [aux_sym_preproc_def_token1] = ACTIONS(3591),
    [aux_sym_preproc_if_token1] = ACTIONS(3591),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3591),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3591),
    [sym_preproc_directive] = ACTIONS(3591),
    [anon_sym_LPAREN2] = ACTIONS(3589),
    [anon_sym_TILDE] = ACTIONS(3589),
    [anon_sym_STAR] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(3589),
    [anon_sym___extension__] = ACTIONS(3591),
    [anon_sym_typedef] = ACTIONS(3591),
    [anon_sym_in] = ACTIONS(3591),
    [anon_sym_out] = ACTIONS(3591),
    [anon_sym_inout] = ACTIONS(3591),
    [anon_sym_virtual] = ACTIONS(3591),
    [anon_sym_extern] = ACTIONS(3591),
    [anon_sym___attribute__] = ACTIONS(3591),
    [anon_sym___attribute] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3591),
    [anon_sym_COLON_COLON] = ACTIONS(3589),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3589),
    [anon_sym___declspec] = ACTIONS(3591),
    [anon_sym___based] = ACTIONS(3591),
    [anon_sym_RBRACE] = ACTIONS(3589),
    [anon_sym_signed] = ACTIONS(3591),
    [anon_sym_unsigned] = ACTIONS(3591),
    [anon_sym_long] = ACTIONS(3591),
    [anon_sym_short] = ACTIONS(3591),
    [anon_sym_LBRACK] = ACTIONS(3591),
    [anon_sym_static] = ACTIONS(3591),
    [anon_sym_register] = ACTIONS(3591),
    [anon_sym_inline] = ACTIONS(3591),
    [anon_sym___inline] = ACTIONS(3591),
    [anon_sym___inline__] = ACTIONS(3591),
    [anon_sym___forceinline] = ACTIONS(3591),
    [anon_sym_thread_local] = ACTIONS(3591),
    [anon_sym___thread] = ACTIONS(3591),
    [anon_sym_const] = ACTIONS(3591),
    [anon_sym_constexpr] = ACTIONS(3591),
    [anon_sym_volatile] = ACTIONS(3591),
    [anon_sym_restrict] = ACTIONS(3591),
    [anon_sym___restrict__] = ACTIONS(3591),
    [anon_sym__Atomic] = ACTIONS(3591),
    [anon_sym__Noreturn] = ACTIONS(3591),
    [anon_sym_noreturn] = ACTIONS(3591),
    [anon_sym__Nonnull] = ACTIONS(3591),
    [anon_sym_mutable] = ACTIONS(3591),
    [anon_sym_constinit] = ACTIONS(3591),
    [anon_sym_consteval] = ACTIONS(3591),
    [anon_sym_alignas] = ACTIONS(3591),
    [anon_sym__Alignas] = ACTIONS(3591),
    [sym_primitive_type] = ACTIONS(3591),
    [anon_sym_enum] = ACTIONS(3591),
    [anon_sym_class] = ACTIONS(3591),
    [anon_sym_struct] = ACTIONS(3591),
    [anon_sym_union] = ACTIONS(3591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3591),
    [anon_sym_let] = ACTIONS(3591),
    [anon_sym_This] = ACTIONS(3591),
    [anon_sym_decltype] = ACTIONS(3591),
    [anon_sym_explicit] = ACTIONS(3591),
    [anon_sym_typename] = ACTIONS(3591),
    [anon_sym_private] = ACTIONS(3591),
    [anon_sym_template] = ACTIONS(3591),
    [anon_sym_operator] = ACTIONS(3591),
    [anon_sym_friend] = ACTIONS(3591),
    [anon_sym_public] = ACTIONS(3591),
    [anon_sym_protected] = ACTIONS(3591),
    [anon_sym_static_assert] = ACTIONS(3591),
    [anon_sym_precise] = ACTIONS(3591),
    [anon_sym_shared] = ACTIONS(3591),
    [anon_sym_groupshared] = ACTIONS(3591),
    [anon_sym_uniform] = ACTIONS(3591),
    [anon_sym_row_major] = ACTIONS(3591),
    [anon_sym_column_major] = ACTIONS(3591),
    [anon_sym_globallycoherent] = ACTIONS(3591),
    [anon_sym_centroid] = ACTIONS(3591),
    [anon_sym_noperspective] = ACTIONS(3591),
    [anon_sym_nointerpolation] = ACTIONS(3591),
    [anon_sym_sample] = ACTIONS(3591),
    [anon_sym_linear] = ACTIONS(3591),
    [anon_sym_snorm] = ACTIONS(3591),
    [anon_sym_unorm] = ACTIONS(3591),
    [anon_sym_point] = ACTIONS(3591),
    [anon_sym_line] = ACTIONS(3591),
    [anon_sym_triangleadj] = ACTIONS(3591),
    [anon_sym_lineadj] = ACTIONS(3591),
    [anon_sym_triangle] = ACTIONS(3591),
    [anon_sym_interface] = ACTIONS(3591),
    [anon_sym_extension] = ACTIONS(3591),
    [anon_sym___init] = ACTIONS(3591),
    [anon_sym___subscript] = ACTIONS(3591),
    [anon_sym_property] = ACTIONS(3591),
    [anon_sym_associatedtype] = ACTIONS(3591),
  },
  [2128] = {
    [sym_identifier] = ACTIONS(3889),
    [aux_sym_preproc_def_token1] = ACTIONS(3889),
    [aux_sym_preproc_if_token1] = ACTIONS(3889),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3889),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3889),
    [sym_preproc_directive] = ACTIONS(3889),
    [anon_sym_LPAREN2] = ACTIONS(3891),
    [anon_sym_TILDE] = ACTIONS(3891),
    [anon_sym_STAR] = ACTIONS(3891),
    [anon_sym_AMP_AMP] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3889),
    [anon_sym_SEMI] = ACTIONS(3891),
    [anon_sym___extension__] = ACTIONS(3889),
    [anon_sym_typedef] = ACTIONS(3889),
    [anon_sym_in] = ACTIONS(3889),
    [anon_sym_out] = ACTIONS(3889),
    [anon_sym_inout] = ACTIONS(3889),
    [anon_sym_virtual] = ACTIONS(3889),
    [anon_sym_extern] = ACTIONS(3889),
    [anon_sym___attribute__] = ACTIONS(3889),
    [anon_sym___attribute] = ACTIONS(3889),
    [anon_sym_using] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3891),
    [anon_sym___declspec] = ACTIONS(3889),
    [anon_sym___based] = ACTIONS(3889),
    [anon_sym_RBRACE] = ACTIONS(3891),
    [anon_sym_signed] = ACTIONS(3889),
    [anon_sym_unsigned] = ACTIONS(3889),
    [anon_sym_long] = ACTIONS(3889),
    [anon_sym_short] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_static] = ACTIONS(3889),
    [anon_sym_register] = ACTIONS(3889),
    [anon_sym_inline] = ACTIONS(3889),
    [anon_sym___inline] = ACTIONS(3889),
    [anon_sym___inline__] = ACTIONS(3889),
    [anon_sym___forceinline] = ACTIONS(3889),
    [anon_sym_thread_local] = ACTIONS(3889),
    [anon_sym___thread] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3889),
    [anon_sym_constexpr] = ACTIONS(3889),
    [anon_sym_volatile] = ACTIONS(3889),
    [anon_sym_restrict] = ACTIONS(3889),
    [anon_sym___restrict__] = ACTIONS(3889),
    [anon_sym__Atomic] = ACTIONS(3889),
    [anon_sym__Noreturn] = ACTIONS(3889),
    [anon_sym_noreturn] = ACTIONS(3889),
    [anon_sym__Nonnull] = ACTIONS(3889),
    [anon_sym_mutable] = ACTIONS(3889),
    [anon_sym_constinit] = ACTIONS(3889),
    [anon_sym_consteval] = ACTIONS(3889),
    [anon_sym_alignas] = ACTIONS(3889),
    [anon_sym__Alignas] = ACTIONS(3889),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_enum] = ACTIONS(3889),
    [anon_sym_class] = ACTIONS(3889),
    [anon_sym_struct] = ACTIONS(3889),
    [anon_sym_union] = ACTIONS(3889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_This] = ACTIONS(3889),
    [anon_sym_decltype] = ACTIONS(3889),
    [anon_sym_explicit] = ACTIONS(3889),
    [anon_sym_typename] = ACTIONS(3889),
    [anon_sym_private] = ACTIONS(3889),
    [anon_sym_template] = ACTIONS(3889),
    [anon_sym_operator] = ACTIONS(3889),
    [anon_sym_friend] = ACTIONS(3889),
    [anon_sym_public] = ACTIONS(3889),
    [anon_sym_protected] = ACTIONS(3889),
    [anon_sym_static_assert] = ACTIONS(3889),
    [anon_sym_precise] = ACTIONS(3889),
    [anon_sym_shared] = ACTIONS(3889),
    [anon_sym_groupshared] = ACTIONS(3889),
    [anon_sym_uniform] = ACTIONS(3889),
    [anon_sym_row_major] = ACTIONS(3889),
    [anon_sym_column_major] = ACTIONS(3889),
    [anon_sym_globallycoherent] = ACTIONS(3889),
    [anon_sym_centroid] = ACTIONS(3889),
    [anon_sym_noperspective] = ACTIONS(3889),
    [anon_sym_nointerpolation] = ACTIONS(3889),
    [anon_sym_sample] = ACTIONS(3889),
    [anon_sym_linear] = ACTIONS(3889),
    [anon_sym_snorm] = ACTIONS(3889),
    [anon_sym_unorm] = ACTIONS(3889),
    [anon_sym_point] = ACTIONS(3889),
    [anon_sym_line] = ACTIONS(3889),
    [anon_sym_triangleadj] = ACTIONS(3889),
    [anon_sym_lineadj] = ACTIONS(3889),
    [anon_sym_triangle] = ACTIONS(3889),
    [anon_sym_interface] = ACTIONS(3889),
    [anon_sym_extension] = ACTIONS(3889),
    [anon_sym___init] = ACTIONS(3889),
    [anon_sym___subscript] = ACTIONS(3889),
    [anon_sym_property] = ACTIONS(3889),
    [anon_sym_associatedtype] = ACTIONS(3889),
  },
  [2129] = {
    [sym_identifier] = ACTIONS(6242),
    [aux_sym_preproc_def_token1] = ACTIONS(6242),
    [aux_sym_preproc_if_token1] = ACTIONS(6242),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6242),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6242),
    [sym_preproc_directive] = ACTIONS(6242),
    [anon_sym_LPAREN2] = ACTIONS(6244),
    [anon_sym_TILDE] = ACTIONS(6244),
    [anon_sym_STAR] = ACTIONS(6244),
    [anon_sym_AMP_AMP] = ACTIONS(6244),
    [anon_sym_AMP] = ACTIONS(6242),
    [anon_sym_SEMI] = ACTIONS(6244),
    [anon_sym___extension__] = ACTIONS(6242),
    [anon_sym_typedef] = ACTIONS(6242),
    [anon_sym_in] = ACTIONS(6242),
    [anon_sym_out] = ACTIONS(6242),
    [anon_sym_inout] = ACTIONS(6242),
    [anon_sym_virtual] = ACTIONS(6242),
    [anon_sym_extern] = ACTIONS(6242),
    [anon_sym___attribute__] = ACTIONS(6242),
    [anon_sym___attribute] = ACTIONS(6242),
    [anon_sym_using] = ACTIONS(6242),
    [anon_sym_COLON_COLON] = ACTIONS(6244),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6244),
    [anon_sym___declspec] = ACTIONS(6242),
    [anon_sym___based] = ACTIONS(6242),
    [anon_sym_RBRACE] = ACTIONS(6244),
    [anon_sym_signed] = ACTIONS(6242),
    [anon_sym_unsigned] = ACTIONS(6242),
    [anon_sym_long] = ACTIONS(6242),
    [anon_sym_short] = ACTIONS(6242),
    [anon_sym_LBRACK] = ACTIONS(6242),
    [anon_sym_static] = ACTIONS(6242),
    [anon_sym_register] = ACTIONS(6242),
    [anon_sym_inline] = ACTIONS(6242),
    [anon_sym___inline] = ACTIONS(6242),
    [anon_sym___inline__] = ACTIONS(6242),
    [anon_sym___forceinline] = ACTIONS(6242),
    [anon_sym_thread_local] = ACTIONS(6242),
    [anon_sym___thread] = ACTIONS(6242),
    [anon_sym_const] = ACTIONS(6242),
    [anon_sym_constexpr] = ACTIONS(6242),
    [anon_sym_volatile] = ACTIONS(6242),
    [anon_sym_restrict] = ACTIONS(6242),
    [anon_sym___restrict__] = ACTIONS(6242),
    [anon_sym__Atomic] = ACTIONS(6242),
    [anon_sym__Noreturn] = ACTIONS(6242),
    [anon_sym_noreturn] = ACTIONS(6242),
    [anon_sym__Nonnull] = ACTIONS(6242),
    [anon_sym_mutable] = ACTIONS(6242),
    [anon_sym_constinit] = ACTIONS(6242),
    [anon_sym_consteval] = ACTIONS(6242),
    [anon_sym_alignas] = ACTIONS(6242),
    [anon_sym__Alignas] = ACTIONS(6242),
    [sym_primitive_type] = ACTIONS(6242),
    [anon_sym_enum] = ACTIONS(6242),
    [anon_sym_class] = ACTIONS(6242),
    [anon_sym_struct] = ACTIONS(6242),
    [anon_sym_union] = ACTIONS(6242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6242),
    [anon_sym_let] = ACTIONS(6242),
    [anon_sym_This] = ACTIONS(6242),
    [anon_sym_decltype] = ACTIONS(6242),
    [anon_sym_explicit] = ACTIONS(6242),
    [anon_sym_typename] = ACTIONS(6242),
    [anon_sym_private] = ACTIONS(6242),
    [anon_sym_template] = ACTIONS(6242),
    [anon_sym_operator] = ACTIONS(6242),
    [anon_sym_friend] = ACTIONS(6242),
    [anon_sym_public] = ACTIONS(6242),
    [anon_sym_protected] = ACTIONS(6242),
    [anon_sym_static_assert] = ACTIONS(6242),
    [anon_sym_precise] = ACTIONS(6242),
    [anon_sym_shared] = ACTIONS(6242),
    [anon_sym_groupshared] = ACTIONS(6242),
    [anon_sym_uniform] = ACTIONS(6242),
    [anon_sym_row_major] = ACTIONS(6242),
    [anon_sym_column_major] = ACTIONS(6242),
    [anon_sym_globallycoherent] = ACTIONS(6242),
    [anon_sym_centroid] = ACTIONS(6242),
    [anon_sym_noperspective] = ACTIONS(6242),
    [anon_sym_nointerpolation] = ACTIONS(6242),
    [anon_sym_sample] = ACTIONS(6242),
    [anon_sym_linear] = ACTIONS(6242),
    [anon_sym_snorm] = ACTIONS(6242),
    [anon_sym_unorm] = ACTIONS(6242),
    [anon_sym_point] = ACTIONS(6242),
    [anon_sym_line] = ACTIONS(6242),
    [anon_sym_triangleadj] = ACTIONS(6242),
    [anon_sym_lineadj] = ACTIONS(6242),
    [anon_sym_triangle] = ACTIONS(6242),
    [anon_sym_interface] = ACTIONS(6242),
    [anon_sym_extension] = ACTIONS(6242),
    [anon_sym___init] = ACTIONS(6242),
    [anon_sym___subscript] = ACTIONS(6242),
    [anon_sym_property] = ACTIONS(6242),
    [anon_sym_associatedtype] = ACTIONS(6242),
  },
  [2130] = {
    [sym_expression] = STATE(5982),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2131] = {
    [sym_expression] = STATE(5725),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2132] = {
    [sym_identifier] = ACTIONS(6246),
    [aux_sym_preproc_def_token1] = ACTIONS(6246),
    [aux_sym_preproc_if_token1] = ACTIONS(6246),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6246),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6246),
    [sym_preproc_directive] = ACTIONS(6246),
    [anon_sym_LPAREN2] = ACTIONS(6248),
    [anon_sym_TILDE] = ACTIONS(6248),
    [anon_sym_STAR] = ACTIONS(6248),
    [anon_sym_AMP_AMP] = ACTIONS(6248),
    [anon_sym_AMP] = ACTIONS(6246),
    [anon_sym_SEMI] = ACTIONS(6248),
    [anon_sym___extension__] = ACTIONS(6246),
    [anon_sym_typedef] = ACTIONS(6246),
    [anon_sym_in] = ACTIONS(6246),
    [anon_sym_out] = ACTIONS(6246),
    [anon_sym_inout] = ACTIONS(6246),
    [anon_sym_virtual] = ACTIONS(6246),
    [anon_sym_extern] = ACTIONS(6246),
    [anon_sym___attribute__] = ACTIONS(6246),
    [anon_sym___attribute] = ACTIONS(6246),
    [anon_sym_using] = ACTIONS(6246),
    [anon_sym_COLON_COLON] = ACTIONS(6248),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6248),
    [anon_sym___declspec] = ACTIONS(6246),
    [anon_sym___based] = ACTIONS(6246),
    [anon_sym_RBRACE] = ACTIONS(6248),
    [anon_sym_signed] = ACTIONS(6246),
    [anon_sym_unsigned] = ACTIONS(6246),
    [anon_sym_long] = ACTIONS(6246),
    [anon_sym_short] = ACTIONS(6246),
    [anon_sym_LBRACK] = ACTIONS(6246),
    [anon_sym_static] = ACTIONS(6246),
    [anon_sym_register] = ACTIONS(6246),
    [anon_sym_inline] = ACTIONS(6246),
    [anon_sym___inline] = ACTIONS(6246),
    [anon_sym___inline__] = ACTIONS(6246),
    [anon_sym___forceinline] = ACTIONS(6246),
    [anon_sym_thread_local] = ACTIONS(6246),
    [anon_sym___thread] = ACTIONS(6246),
    [anon_sym_const] = ACTIONS(6246),
    [anon_sym_constexpr] = ACTIONS(6246),
    [anon_sym_volatile] = ACTIONS(6246),
    [anon_sym_restrict] = ACTIONS(6246),
    [anon_sym___restrict__] = ACTIONS(6246),
    [anon_sym__Atomic] = ACTIONS(6246),
    [anon_sym__Noreturn] = ACTIONS(6246),
    [anon_sym_noreturn] = ACTIONS(6246),
    [anon_sym__Nonnull] = ACTIONS(6246),
    [anon_sym_mutable] = ACTIONS(6246),
    [anon_sym_constinit] = ACTIONS(6246),
    [anon_sym_consteval] = ACTIONS(6246),
    [anon_sym_alignas] = ACTIONS(6246),
    [anon_sym__Alignas] = ACTIONS(6246),
    [sym_primitive_type] = ACTIONS(6246),
    [anon_sym_enum] = ACTIONS(6246),
    [anon_sym_class] = ACTIONS(6246),
    [anon_sym_struct] = ACTIONS(6246),
    [anon_sym_union] = ACTIONS(6246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6246),
    [anon_sym_let] = ACTIONS(6246),
    [anon_sym_This] = ACTIONS(6246),
    [anon_sym_decltype] = ACTIONS(6246),
    [anon_sym_explicit] = ACTIONS(6246),
    [anon_sym_typename] = ACTIONS(6246),
    [anon_sym_private] = ACTIONS(6246),
    [anon_sym_template] = ACTIONS(6246),
    [anon_sym_operator] = ACTIONS(6246),
    [anon_sym_friend] = ACTIONS(6246),
    [anon_sym_public] = ACTIONS(6246),
    [anon_sym_protected] = ACTIONS(6246),
    [anon_sym_static_assert] = ACTIONS(6246),
    [anon_sym_precise] = ACTIONS(6246),
    [anon_sym_shared] = ACTIONS(6246),
    [anon_sym_groupshared] = ACTIONS(6246),
    [anon_sym_uniform] = ACTIONS(6246),
    [anon_sym_row_major] = ACTIONS(6246),
    [anon_sym_column_major] = ACTIONS(6246),
    [anon_sym_globallycoherent] = ACTIONS(6246),
    [anon_sym_centroid] = ACTIONS(6246),
    [anon_sym_noperspective] = ACTIONS(6246),
    [anon_sym_nointerpolation] = ACTIONS(6246),
    [anon_sym_sample] = ACTIONS(6246),
    [anon_sym_linear] = ACTIONS(6246),
    [anon_sym_snorm] = ACTIONS(6246),
    [anon_sym_unorm] = ACTIONS(6246),
    [anon_sym_point] = ACTIONS(6246),
    [anon_sym_line] = ACTIONS(6246),
    [anon_sym_triangleadj] = ACTIONS(6246),
    [anon_sym_lineadj] = ACTIONS(6246),
    [anon_sym_triangle] = ACTIONS(6246),
    [anon_sym_interface] = ACTIONS(6246),
    [anon_sym_extension] = ACTIONS(6246),
    [anon_sym___init] = ACTIONS(6246),
    [anon_sym___subscript] = ACTIONS(6246),
    [anon_sym_property] = ACTIONS(6246),
    [anon_sym_associatedtype] = ACTIONS(6246),
  },
  [2133] = {
    [sym_identifier] = ACTIONS(3931),
    [aux_sym_preproc_def_token1] = ACTIONS(3931),
    [aux_sym_preproc_if_token1] = ACTIONS(3931),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3931),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3931),
    [sym_preproc_directive] = ACTIONS(3931),
    [anon_sym_LPAREN2] = ACTIONS(3933),
    [anon_sym_TILDE] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_SEMI] = ACTIONS(3933),
    [anon_sym___extension__] = ACTIONS(3931),
    [anon_sym_typedef] = ACTIONS(3931),
    [anon_sym_in] = ACTIONS(3931),
    [anon_sym_out] = ACTIONS(3931),
    [anon_sym_inout] = ACTIONS(3931),
    [anon_sym_virtual] = ACTIONS(3931),
    [anon_sym_extern] = ACTIONS(3931),
    [anon_sym___attribute__] = ACTIONS(3931),
    [anon_sym___attribute] = ACTIONS(3931),
    [anon_sym_using] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3933),
    [anon_sym___declspec] = ACTIONS(3931),
    [anon_sym___based] = ACTIONS(3931),
    [anon_sym_RBRACE] = ACTIONS(3933),
    [anon_sym_signed] = ACTIONS(3931),
    [anon_sym_unsigned] = ACTIONS(3931),
    [anon_sym_long] = ACTIONS(3931),
    [anon_sym_short] = ACTIONS(3931),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_static] = ACTIONS(3931),
    [anon_sym_register] = ACTIONS(3931),
    [anon_sym_inline] = ACTIONS(3931),
    [anon_sym___inline] = ACTIONS(3931),
    [anon_sym___inline__] = ACTIONS(3931),
    [anon_sym___forceinline] = ACTIONS(3931),
    [anon_sym_thread_local] = ACTIONS(3931),
    [anon_sym___thread] = ACTIONS(3931),
    [anon_sym_const] = ACTIONS(3931),
    [anon_sym_constexpr] = ACTIONS(3931),
    [anon_sym_volatile] = ACTIONS(3931),
    [anon_sym_restrict] = ACTIONS(3931),
    [anon_sym___restrict__] = ACTIONS(3931),
    [anon_sym__Atomic] = ACTIONS(3931),
    [anon_sym__Noreturn] = ACTIONS(3931),
    [anon_sym_noreturn] = ACTIONS(3931),
    [anon_sym__Nonnull] = ACTIONS(3931),
    [anon_sym_mutable] = ACTIONS(3931),
    [anon_sym_constinit] = ACTIONS(3931),
    [anon_sym_consteval] = ACTIONS(3931),
    [anon_sym_alignas] = ACTIONS(3931),
    [anon_sym__Alignas] = ACTIONS(3931),
    [sym_primitive_type] = ACTIONS(3931),
    [anon_sym_enum] = ACTIONS(3931),
    [anon_sym_class] = ACTIONS(3931),
    [anon_sym_struct] = ACTIONS(3931),
    [anon_sym_union] = ACTIONS(3931),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3931),
    [anon_sym_let] = ACTIONS(3931),
    [anon_sym_This] = ACTIONS(3931),
    [anon_sym_decltype] = ACTIONS(3931),
    [anon_sym_explicit] = ACTIONS(3931),
    [anon_sym_typename] = ACTIONS(3931),
    [anon_sym_private] = ACTIONS(3931),
    [anon_sym_template] = ACTIONS(3931),
    [anon_sym_operator] = ACTIONS(3931),
    [anon_sym_friend] = ACTIONS(3931),
    [anon_sym_public] = ACTIONS(3931),
    [anon_sym_protected] = ACTIONS(3931),
    [anon_sym_static_assert] = ACTIONS(3931),
    [anon_sym_precise] = ACTIONS(3931),
    [anon_sym_shared] = ACTIONS(3931),
    [anon_sym_groupshared] = ACTIONS(3931),
    [anon_sym_uniform] = ACTIONS(3931),
    [anon_sym_row_major] = ACTIONS(3931),
    [anon_sym_column_major] = ACTIONS(3931),
    [anon_sym_globallycoherent] = ACTIONS(3931),
    [anon_sym_centroid] = ACTIONS(3931),
    [anon_sym_noperspective] = ACTIONS(3931),
    [anon_sym_nointerpolation] = ACTIONS(3931),
    [anon_sym_sample] = ACTIONS(3931),
    [anon_sym_linear] = ACTIONS(3931),
    [anon_sym_snorm] = ACTIONS(3931),
    [anon_sym_unorm] = ACTIONS(3931),
    [anon_sym_point] = ACTIONS(3931),
    [anon_sym_line] = ACTIONS(3931),
    [anon_sym_triangleadj] = ACTIONS(3931),
    [anon_sym_lineadj] = ACTIONS(3931),
    [anon_sym_triangle] = ACTIONS(3931),
    [anon_sym_interface] = ACTIONS(3931),
    [anon_sym_extension] = ACTIONS(3931),
    [anon_sym___init] = ACTIONS(3931),
    [anon_sym___subscript] = ACTIONS(3931),
    [anon_sym_property] = ACTIONS(3931),
    [anon_sym_associatedtype] = ACTIONS(3931),
  },
  [2134] = {
    [sym_identifier] = ACTIONS(6252),
    [aux_sym_preproc_def_token1] = ACTIONS(6252),
    [aux_sym_preproc_if_token1] = ACTIONS(6252),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6252),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6252),
    [sym_preproc_directive] = ACTIONS(6252),
    [anon_sym_LPAREN2] = ACTIONS(6254),
    [anon_sym_TILDE] = ACTIONS(6254),
    [anon_sym_STAR] = ACTIONS(6254),
    [anon_sym_AMP_AMP] = ACTIONS(6254),
    [anon_sym_AMP] = ACTIONS(6252),
    [anon_sym_SEMI] = ACTIONS(6254),
    [anon_sym___extension__] = ACTIONS(6252),
    [anon_sym_typedef] = ACTIONS(6252),
    [anon_sym_in] = ACTIONS(6252),
    [anon_sym_out] = ACTIONS(6252),
    [anon_sym_inout] = ACTIONS(6252),
    [anon_sym_virtual] = ACTIONS(6252),
    [anon_sym_extern] = ACTIONS(6252),
    [anon_sym___attribute__] = ACTIONS(6252),
    [anon_sym___attribute] = ACTIONS(6252),
    [anon_sym_using] = ACTIONS(6252),
    [anon_sym_COLON_COLON] = ACTIONS(6254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6254),
    [anon_sym___declspec] = ACTIONS(6252),
    [anon_sym___based] = ACTIONS(6252),
    [anon_sym_RBRACE] = ACTIONS(6254),
    [anon_sym_signed] = ACTIONS(6252),
    [anon_sym_unsigned] = ACTIONS(6252),
    [anon_sym_long] = ACTIONS(6252),
    [anon_sym_short] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_static] = ACTIONS(6252),
    [anon_sym_register] = ACTIONS(6252),
    [anon_sym_inline] = ACTIONS(6252),
    [anon_sym___inline] = ACTIONS(6252),
    [anon_sym___inline__] = ACTIONS(6252),
    [anon_sym___forceinline] = ACTIONS(6252),
    [anon_sym_thread_local] = ACTIONS(6252),
    [anon_sym___thread] = ACTIONS(6252),
    [anon_sym_const] = ACTIONS(6252),
    [anon_sym_constexpr] = ACTIONS(6252),
    [anon_sym_volatile] = ACTIONS(6252),
    [anon_sym_restrict] = ACTIONS(6252),
    [anon_sym___restrict__] = ACTIONS(6252),
    [anon_sym__Atomic] = ACTIONS(6252),
    [anon_sym__Noreturn] = ACTIONS(6252),
    [anon_sym_noreturn] = ACTIONS(6252),
    [anon_sym__Nonnull] = ACTIONS(6252),
    [anon_sym_mutable] = ACTIONS(6252),
    [anon_sym_constinit] = ACTIONS(6252),
    [anon_sym_consteval] = ACTIONS(6252),
    [anon_sym_alignas] = ACTIONS(6252),
    [anon_sym__Alignas] = ACTIONS(6252),
    [sym_primitive_type] = ACTIONS(6252),
    [anon_sym_enum] = ACTIONS(6252),
    [anon_sym_class] = ACTIONS(6252),
    [anon_sym_struct] = ACTIONS(6252),
    [anon_sym_union] = ACTIONS(6252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6252),
    [anon_sym_let] = ACTIONS(6252),
    [anon_sym_This] = ACTIONS(6252),
    [anon_sym_decltype] = ACTIONS(6252),
    [anon_sym_explicit] = ACTIONS(6252),
    [anon_sym_typename] = ACTIONS(6252),
    [anon_sym_private] = ACTIONS(6252),
    [anon_sym_template] = ACTIONS(6252),
    [anon_sym_operator] = ACTIONS(6252),
    [anon_sym_friend] = ACTIONS(6252),
    [anon_sym_public] = ACTIONS(6252),
    [anon_sym_protected] = ACTIONS(6252),
    [anon_sym_static_assert] = ACTIONS(6252),
    [anon_sym_precise] = ACTIONS(6252),
    [anon_sym_shared] = ACTIONS(6252),
    [anon_sym_groupshared] = ACTIONS(6252),
    [anon_sym_uniform] = ACTIONS(6252),
    [anon_sym_row_major] = ACTIONS(6252),
    [anon_sym_column_major] = ACTIONS(6252),
    [anon_sym_globallycoherent] = ACTIONS(6252),
    [anon_sym_centroid] = ACTIONS(6252),
    [anon_sym_noperspective] = ACTIONS(6252),
    [anon_sym_nointerpolation] = ACTIONS(6252),
    [anon_sym_sample] = ACTIONS(6252),
    [anon_sym_linear] = ACTIONS(6252),
    [anon_sym_snorm] = ACTIONS(6252),
    [anon_sym_unorm] = ACTIONS(6252),
    [anon_sym_point] = ACTIONS(6252),
    [anon_sym_line] = ACTIONS(6252),
    [anon_sym_triangleadj] = ACTIONS(6252),
    [anon_sym_lineadj] = ACTIONS(6252),
    [anon_sym_triangle] = ACTIONS(6252),
    [anon_sym_interface] = ACTIONS(6252),
    [anon_sym_extension] = ACTIONS(6252),
    [anon_sym___init] = ACTIONS(6252),
    [anon_sym___subscript] = ACTIONS(6252),
    [anon_sym_property] = ACTIONS(6252),
    [anon_sym_associatedtype] = ACTIONS(6252),
  },
  [2135] = {
    [sym_identifier] = ACTIONS(6256),
    [aux_sym_preproc_def_token1] = ACTIONS(6256),
    [aux_sym_preproc_if_token1] = ACTIONS(6256),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6256),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6256),
    [sym_preproc_directive] = ACTIONS(6256),
    [anon_sym_LPAREN2] = ACTIONS(6258),
    [anon_sym_TILDE] = ACTIONS(6258),
    [anon_sym_STAR] = ACTIONS(6258),
    [anon_sym_AMP_AMP] = ACTIONS(6258),
    [anon_sym_AMP] = ACTIONS(6256),
    [anon_sym_SEMI] = ACTIONS(6258),
    [anon_sym___extension__] = ACTIONS(6256),
    [anon_sym_typedef] = ACTIONS(6256),
    [anon_sym_in] = ACTIONS(6256),
    [anon_sym_out] = ACTIONS(6256),
    [anon_sym_inout] = ACTIONS(6256),
    [anon_sym_virtual] = ACTIONS(6256),
    [anon_sym_extern] = ACTIONS(6256),
    [anon_sym___attribute__] = ACTIONS(6256),
    [anon_sym___attribute] = ACTIONS(6256),
    [anon_sym_using] = ACTIONS(6256),
    [anon_sym_COLON_COLON] = ACTIONS(6258),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6258),
    [anon_sym___declspec] = ACTIONS(6256),
    [anon_sym___based] = ACTIONS(6256),
    [anon_sym_RBRACE] = ACTIONS(6258),
    [anon_sym_signed] = ACTIONS(6256),
    [anon_sym_unsigned] = ACTIONS(6256),
    [anon_sym_long] = ACTIONS(6256),
    [anon_sym_short] = ACTIONS(6256),
    [anon_sym_LBRACK] = ACTIONS(6256),
    [anon_sym_static] = ACTIONS(6256),
    [anon_sym_register] = ACTIONS(6256),
    [anon_sym_inline] = ACTIONS(6256),
    [anon_sym___inline] = ACTIONS(6256),
    [anon_sym___inline__] = ACTIONS(6256),
    [anon_sym___forceinline] = ACTIONS(6256),
    [anon_sym_thread_local] = ACTIONS(6256),
    [anon_sym___thread] = ACTIONS(6256),
    [anon_sym_const] = ACTIONS(6256),
    [anon_sym_constexpr] = ACTIONS(6256),
    [anon_sym_volatile] = ACTIONS(6256),
    [anon_sym_restrict] = ACTIONS(6256),
    [anon_sym___restrict__] = ACTIONS(6256),
    [anon_sym__Atomic] = ACTIONS(6256),
    [anon_sym__Noreturn] = ACTIONS(6256),
    [anon_sym_noreturn] = ACTIONS(6256),
    [anon_sym__Nonnull] = ACTIONS(6256),
    [anon_sym_mutable] = ACTIONS(6256),
    [anon_sym_constinit] = ACTIONS(6256),
    [anon_sym_consteval] = ACTIONS(6256),
    [anon_sym_alignas] = ACTIONS(6256),
    [anon_sym__Alignas] = ACTIONS(6256),
    [sym_primitive_type] = ACTIONS(6256),
    [anon_sym_enum] = ACTIONS(6256),
    [anon_sym_class] = ACTIONS(6256),
    [anon_sym_struct] = ACTIONS(6256),
    [anon_sym_union] = ACTIONS(6256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6256),
    [anon_sym_let] = ACTIONS(6256),
    [anon_sym_This] = ACTIONS(6256),
    [anon_sym_decltype] = ACTIONS(6256),
    [anon_sym_explicit] = ACTIONS(6256),
    [anon_sym_typename] = ACTIONS(6256),
    [anon_sym_private] = ACTIONS(6256),
    [anon_sym_template] = ACTIONS(6256),
    [anon_sym_operator] = ACTIONS(6256),
    [anon_sym_friend] = ACTIONS(6256),
    [anon_sym_public] = ACTIONS(6256),
    [anon_sym_protected] = ACTIONS(6256),
    [anon_sym_static_assert] = ACTIONS(6256),
    [anon_sym_precise] = ACTIONS(6256),
    [anon_sym_shared] = ACTIONS(6256),
    [anon_sym_groupshared] = ACTIONS(6256),
    [anon_sym_uniform] = ACTIONS(6256),
    [anon_sym_row_major] = ACTIONS(6256),
    [anon_sym_column_major] = ACTIONS(6256),
    [anon_sym_globallycoherent] = ACTIONS(6256),
    [anon_sym_centroid] = ACTIONS(6256),
    [anon_sym_noperspective] = ACTIONS(6256),
    [anon_sym_nointerpolation] = ACTIONS(6256),
    [anon_sym_sample] = ACTIONS(6256),
    [anon_sym_linear] = ACTIONS(6256),
    [anon_sym_snorm] = ACTIONS(6256),
    [anon_sym_unorm] = ACTIONS(6256),
    [anon_sym_point] = ACTIONS(6256),
    [anon_sym_line] = ACTIONS(6256),
    [anon_sym_triangleadj] = ACTIONS(6256),
    [anon_sym_lineadj] = ACTIONS(6256),
    [anon_sym_triangle] = ACTIONS(6256),
    [anon_sym_interface] = ACTIONS(6256),
    [anon_sym_extension] = ACTIONS(6256),
    [anon_sym___init] = ACTIONS(6256),
    [anon_sym___subscript] = ACTIONS(6256),
    [anon_sym_property] = ACTIONS(6256),
    [anon_sym_associatedtype] = ACTIONS(6256),
  },
  [2136] = {
    [sym_identifier] = ACTIONS(6260),
    [aux_sym_preproc_def_token1] = ACTIONS(6260),
    [aux_sym_preproc_if_token1] = ACTIONS(6260),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6260),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6260),
    [sym_preproc_directive] = ACTIONS(6260),
    [anon_sym_LPAREN2] = ACTIONS(6262),
    [anon_sym_TILDE] = ACTIONS(6262),
    [anon_sym_STAR] = ACTIONS(6262),
    [anon_sym_AMP_AMP] = ACTIONS(6262),
    [anon_sym_AMP] = ACTIONS(6260),
    [anon_sym_SEMI] = ACTIONS(6262),
    [anon_sym___extension__] = ACTIONS(6260),
    [anon_sym_typedef] = ACTIONS(6260),
    [anon_sym_in] = ACTIONS(6260),
    [anon_sym_out] = ACTIONS(6260),
    [anon_sym_inout] = ACTIONS(6260),
    [anon_sym_virtual] = ACTIONS(6260),
    [anon_sym_extern] = ACTIONS(6260),
    [anon_sym___attribute__] = ACTIONS(6260),
    [anon_sym___attribute] = ACTIONS(6260),
    [anon_sym_using] = ACTIONS(6260),
    [anon_sym_COLON_COLON] = ACTIONS(6262),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6262),
    [anon_sym___declspec] = ACTIONS(6260),
    [anon_sym___based] = ACTIONS(6260),
    [anon_sym_RBRACE] = ACTIONS(6262),
    [anon_sym_signed] = ACTIONS(6260),
    [anon_sym_unsigned] = ACTIONS(6260),
    [anon_sym_long] = ACTIONS(6260),
    [anon_sym_short] = ACTIONS(6260),
    [anon_sym_LBRACK] = ACTIONS(6260),
    [anon_sym_static] = ACTIONS(6260),
    [anon_sym_register] = ACTIONS(6260),
    [anon_sym_inline] = ACTIONS(6260),
    [anon_sym___inline] = ACTIONS(6260),
    [anon_sym___inline__] = ACTIONS(6260),
    [anon_sym___forceinline] = ACTIONS(6260),
    [anon_sym_thread_local] = ACTIONS(6260),
    [anon_sym___thread] = ACTIONS(6260),
    [anon_sym_const] = ACTIONS(6260),
    [anon_sym_constexpr] = ACTIONS(6260),
    [anon_sym_volatile] = ACTIONS(6260),
    [anon_sym_restrict] = ACTIONS(6260),
    [anon_sym___restrict__] = ACTIONS(6260),
    [anon_sym__Atomic] = ACTIONS(6260),
    [anon_sym__Noreturn] = ACTIONS(6260),
    [anon_sym_noreturn] = ACTIONS(6260),
    [anon_sym__Nonnull] = ACTIONS(6260),
    [anon_sym_mutable] = ACTIONS(6260),
    [anon_sym_constinit] = ACTIONS(6260),
    [anon_sym_consteval] = ACTIONS(6260),
    [anon_sym_alignas] = ACTIONS(6260),
    [anon_sym__Alignas] = ACTIONS(6260),
    [sym_primitive_type] = ACTIONS(6260),
    [anon_sym_enum] = ACTIONS(6260),
    [anon_sym_class] = ACTIONS(6260),
    [anon_sym_struct] = ACTIONS(6260),
    [anon_sym_union] = ACTIONS(6260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6260),
    [anon_sym_let] = ACTIONS(6260),
    [anon_sym_This] = ACTIONS(6260),
    [anon_sym_decltype] = ACTIONS(6260),
    [anon_sym_explicit] = ACTIONS(6260),
    [anon_sym_typename] = ACTIONS(6260),
    [anon_sym_private] = ACTIONS(6260),
    [anon_sym_template] = ACTIONS(6260),
    [anon_sym_operator] = ACTIONS(6260),
    [anon_sym_friend] = ACTIONS(6260),
    [anon_sym_public] = ACTIONS(6260),
    [anon_sym_protected] = ACTIONS(6260),
    [anon_sym_static_assert] = ACTIONS(6260),
    [anon_sym_precise] = ACTIONS(6260),
    [anon_sym_shared] = ACTIONS(6260),
    [anon_sym_groupshared] = ACTIONS(6260),
    [anon_sym_uniform] = ACTIONS(6260),
    [anon_sym_row_major] = ACTIONS(6260),
    [anon_sym_column_major] = ACTIONS(6260),
    [anon_sym_globallycoherent] = ACTIONS(6260),
    [anon_sym_centroid] = ACTIONS(6260),
    [anon_sym_noperspective] = ACTIONS(6260),
    [anon_sym_nointerpolation] = ACTIONS(6260),
    [anon_sym_sample] = ACTIONS(6260),
    [anon_sym_linear] = ACTIONS(6260),
    [anon_sym_snorm] = ACTIONS(6260),
    [anon_sym_unorm] = ACTIONS(6260),
    [anon_sym_point] = ACTIONS(6260),
    [anon_sym_line] = ACTIONS(6260),
    [anon_sym_triangleadj] = ACTIONS(6260),
    [anon_sym_lineadj] = ACTIONS(6260),
    [anon_sym_triangle] = ACTIONS(6260),
    [anon_sym_interface] = ACTIONS(6260),
    [anon_sym_extension] = ACTIONS(6260),
    [anon_sym___init] = ACTIONS(6260),
    [anon_sym___subscript] = ACTIONS(6260),
    [anon_sym_property] = ACTIONS(6260),
    [anon_sym_associatedtype] = ACTIONS(6260),
  },
  [2137] = {
    [sym_identifier] = ACTIONS(6264),
    [aux_sym_preproc_def_token1] = ACTIONS(6264),
    [aux_sym_preproc_if_token1] = ACTIONS(6264),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6264),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6264),
    [sym_preproc_directive] = ACTIONS(6264),
    [anon_sym_LPAREN2] = ACTIONS(6266),
    [anon_sym_TILDE] = ACTIONS(6266),
    [anon_sym_STAR] = ACTIONS(6266),
    [anon_sym_AMP_AMP] = ACTIONS(6266),
    [anon_sym_AMP] = ACTIONS(6264),
    [anon_sym_SEMI] = ACTIONS(6266),
    [anon_sym___extension__] = ACTIONS(6264),
    [anon_sym_typedef] = ACTIONS(6264),
    [anon_sym_in] = ACTIONS(6264),
    [anon_sym_out] = ACTIONS(6264),
    [anon_sym_inout] = ACTIONS(6264),
    [anon_sym_virtual] = ACTIONS(6264),
    [anon_sym_extern] = ACTIONS(6264),
    [anon_sym___attribute__] = ACTIONS(6264),
    [anon_sym___attribute] = ACTIONS(6264),
    [anon_sym_using] = ACTIONS(6264),
    [anon_sym_COLON_COLON] = ACTIONS(6266),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6266),
    [anon_sym___declspec] = ACTIONS(6264),
    [anon_sym___based] = ACTIONS(6264),
    [anon_sym_RBRACE] = ACTIONS(6266),
    [anon_sym_signed] = ACTIONS(6264),
    [anon_sym_unsigned] = ACTIONS(6264),
    [anon_sym_long] = ACTIONS(6264),
    [anon_sym_short] = ACTIONS(6264),
    [anon_sym_LBRACK] = ACTIONS(6264),
    [anon_sym_static] = ACTIONS(6264),
    [anon_sym_register] = ACTIONS(6264),
    [anon_sym_inline] = ACTIONS(6264),
    [anon_sym___inline] = ACTIONS(6264),
    [anon_sym___inline__] = ACTIONS(6264),
    [anon_sym___forceinline] = ACTIONS(6264),
    [anon_sym_thread_local] = ACTIONS(6264),
    [anon_sym___thread] = ACTIONS(6264),
    [anon_sym_const] = ACTIONS(6264),
    [anon_sym_constexpr] = ACTIONS(6264),
    [anon_sym_volatile] = ACTIONS(6264),
    [anon_sym_restrict] = ACTIONS(6264),
    [anon_sym___restrict__] = ACTIONS(6264),
    [anon_sym__Atomic] = ACTIONS(6264),
    [anon_sym__Noreturn] = ACTIONS(6264),
    [anon_sym_noreturn] = ACTIONS(6264),
    [anon_sym__Nonnull] = ACTIONS(6264),
    [anon_sym_mutable] = ACTIONS(6264),
    [anon_sym_constinit] = ACTIONS(6264),
    [anon_sym_consteval] = ACTIONS(6264),
    [anon_sym_alignas] = ACTIONS(6264),
    [anon_sym__Alignas] = ACTIONS(6264),
    [sym_primitive_type] = ACTIONS(6264),
    [anon_sym_enum] = ACTIONS(6264),
    [anon_sym_class] = ACTIONS(6264),
    [anon_sym_struct] = ACTIONS(6264),
    [anon_sym_union] = ACTIONS(6264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6264),
    [anon_sym_let] = ACTIONS(6264),
    [anon_sym_This] = ACTIONS(6264),
    [anon_sym_decltype] = ACTIONS(6264),
    [anon_sym_explicit] = ACTIONS(6264),
    [anon_sym_typename] = ACTIONS(6264),
    [anon_sym_private] = ACTIONS(6264),
    [anon_sym_template] = ACTIONS(6264),
    [anon_sym_operator] = ACTIONS(6264),
    [anon_sym_friend] = ACTIONS(6264),
    [anon_sym_public] = ACTIONS(6264),
    [anon_sym_protected] = ACTIONS(6264),
    [anon_sym_static_assert] = ACTIONS(6264),
    [anon_sym_precise] = ACTIONS(6264),
    [anon_sym_shared] = ACTIONS(6264),
    [anon_sym_groupshared] = ACTIONS(6264),
    [anon_sym_uniform] = ACTIONS(6264),
    [anon_sym_row_major] = ACTIONS(6264),
    [anon_sym_column_major] = ACTIONS(6264),
    [anon_sym_globallycoherent] = ACTIONS(6264),
    [anon_sym_centroid] = ACTIONS(6264),
    [anon_sym_noperspective] = ACTIONS(6264),
    [anon_sym_nointerpolation] = ACTIONS(6264),
    [anon_sym_sample] = ACTIONS(6264),
    [anon_sym_linear] = ACTIONS(6264),
    [anon_sym_snorm] = ACTIONS(6264),
    [anon_sym_unorm] = ACTIONS(6264),
    [anon_sym_point] = ACTIONS(6264),
    [anon_sym_line] = ACTIONS(6264),
    [anon_sym_triangleadj] = ACTIONS(6264),
    [anon_sym_lineadj] = ACTIONS(6264),
    [anon_sym_triangle] = ACTIONS(6264),
    [anon_sym_interface] = ACTIONS(6264),
    [anon_sym_extension] = ACTIONS(6264),
    [anon_sym___init] = ACTIONS(6264),
    [anon_sym___subscript] = ACTIONS(6264),
    [anon_sym_property] = ACTIONS(6264),
    [anon_sym_associatedtype] = ACTIONS(6264),
  },
  [2138] = {
    [sym_identifier] = ACTIONS(6268),
    [aux_sym_preproc_def_token1] = ACTIONS(6268),
    [aux_sym_preproc_if_token1] = ACTIONS(6268),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6268),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6268),
    [sym_preproc_directive] = ACTIONS(6268),
    [anon_sym_LPAREN2] = ACTIONS(6270),
    [anon_sym_TILDE] = ACTIONS(6270),
    [anon_sym_STAR] = ACTIONS(6270),
    [anon_sym_AMP_AMP] = ACTIONS(6270),
    [anon_sym_AMP] = ACTIONS(6268),
    [anon_sym_SEMI] = ACTIONS(6270),
    [anon_sym___extension__] = ACTIONS(6268),
    [anon_sym_typedef] = ACTIONS(6268),
    [anon_sym_in] = ACTIONS(6268),
    [anon_sym_out] = ACTIONS(6268),
    [anon_sym_inout] = ACTIONS(6268),
    [anon_sym_virtual] = ACTIONS(6268),
    [anon_sym_extern] = ACTIONS(6268),
    [anon_sym___attribute__] = ACTIONS(6268),
    [anon_sym___attribute] = ACTIONS(6268),
    [anon_sym_using] = ACTIONS(6268),
    [anon_sym_COLON_COLON] = ACTIONS(6270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6270),
    [anon_sym___declspec] = ACTIONS(6268),
    [anon_sym___based] = ACTIONS(6268),
    [anon_sym_RBRACE] = ACTIONS(6270),
    [anon_sym_signed] = ACTIONS(6268),
    [anon_sym_unsigned] = ACTIONS(6268),
    [anon_sym_long] = ACTIONS(6268),
    [anon_sym_short] = ACTIONS(6268),
    [anon_sym_LBRACK] = ACTIONS(6268),
    [anon_sym_static] = ACTIONS(6268),
    [anon_sym_register] = ACTIONS(6268),
    [anon_sym_inline] = ACTIONS(6268),
    [anon_sym___inline] = ACTIONS(6268),
    [anon_sym___inline__] = ACTIONS(6268),
    [anon_sym___forceinline] = ACTIONS(6268),
    [anon_sym_thread_local] = ACTIONS(6268),
    [anon_sym___thread] = ACTIONS(6268),
    [anon_sym_const] = ACTIONS(6268),
    [anon_sym_constexpr] = ACTIONS(6268),
    [anon_sym_volatile] = ACTIONS(6268),
    [anon_sym_restrict] = ACTIONS(6268),
    [anon_sym___restrict__] = ACTIONS(6268),
    [anon_sym__Atomic] = ACTIONS(6268),
    [anon_sym__Noreturn] = ACTIONS(6268),
    [anon_sym_noreturn] = ACTIONS(6268),
    [anon_sym__Nonnull] = ACTIONS(6268),
    [anon_sym_mutable] = ACTIONS(6268),
    [anon_sym_constinit] = ACTIONS(6268),
    [anon_sym_consteval] = ACTIONS(6268),
    [anon_sym_alignas] = ACTIONS(6268),
    [anon_sym__Alignas] = ACTIONS(6268),
    [sym_primitive_type] = ACTIONS(6268),
    [anon_sym_enum] = ACTIONS(6268),
    [anon_sym_class] = ACTIONS(6268),
    [anon_sym_struct] = ACTIONS(6268),
    [anon_sym_union] = ACTIONS(6268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6268),
    [anon_sym_let] = ACTIONS(6268),
    [anon_sym_This] = ACTIONS(6268),
    [anon_sym_decltype] = ACTIONS(6268),
    [anon_sym_explicit] = ACTIONS(6268),
    [anon_sym_typename] = ACTIONS(6268),
    [anon_sym_private] = ACTIONS(6268),
    [anon_sym_template] = ACTIONS(6268),
    [anon_sym_operator] = ACTIONS(6268),
    [anon_sym_friend] = ACTIONS(6268),
    [anon_sym_public] = ACTIONS(6268),
    [anon_sym_protected] = ACTIONS(6268),
    [anon_sym_static_assert] = ACTIONS(6268),
    [anon_sym_precise] = ACTIONS(6268),
    [anon_sym_shared] = ACTIONS(6268),
    [anon_sym_groupshared] = ACTIONS(6268),
    [anon_sym_uniform] = ACTIONS(6268),
    [anon_sym_row_major] = ACTIONS(6268),
    [anon_sym_column_major] = ACTIONS(6268),
    [anon_sym_globallycoherent] = ACTIONS(6268),
    [anon_sym_centroid] = ACTIONS(6268),
    [anon_sym_noperspective] = ACTIONS(6268),
    [anon_sym_nointerpolation] = ACTIONS(6268),
    [anon_sym_sample] = ACTIONS(6268),
    [anon_sym_linear] = ACTIONS(6268),
    [anon_sym_snorm] = ACTIONS(6268),
    [anon_sym_unorm] = ACTIONS(6268),
    [anon_sym_point] = ACTIONS(6268),
    [anon_sym_line] = ACTIONS(6268),
    [anon_sym_triangleadj] = ACTIONS(6268),
    [anon_sym_lineadj] = ACTIONS(6268),
    [anon_sym_triangle] = ACTIONS(6268),
    [anon_sym_interface] = ACTIONS(6268),
    [anon_sym_extension] = ACTIONS(6268),
    [anon_sym___init] = ACTIONS(6268),
    [anon_sym___subscript] = ACTIONS(6268),
    [anon_sym_property] = ACTIONS(6268),
    [anon_sym_associatedtype] = ACTIONS(6268),
  },
  [2139] = {
    [sym_identifier] = ACTIONS(6264),
    [aux_sym_preproc_def_token1] = ACTIONS(6264),
    [aux_sym_preproc_if_token1] = ACTIONS(6264),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6264),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6264),
    [sym_preproc_directive] = ACTIONS(6264),
    [anon_sym_LPAREN2] = ACTIONS(6266),
    [anon_sym_TILDE] = ACTIONS(6266),
    [anon_sym_STAR] = ACTIONS(6266),
    [anon_sym_AMP_AMP] = ACTIONS(6266),
    [anon_sym_AMP] = ACTIONS(6264),
    [anon_sym_SEMI] = ACTIONS(6266),
    [anon_sym___extension__] = ACTIONS(6264),
    [anon_sym_typedef] = ACTIONS(6264),
    [anon_sym_in] = ACTIONS(6264),
    [anon_sym_out] = ACTIONS(6264),
    [anon_sym_inout] = ACTIONS(6264),
    [anon_sym_virtual] = ACTIONS(6264),
    [anon_sym_extern] = ACTIONS(6264),
    [anon_sym___attribute__] = ACTIONS(6264),
    [anon_sym___attribute] = ACTIONS(6264),
    [anon_sym_using] = ACTIONS(6264),
    [anon_sym_COLON_COLON] = ACTIONS(6266),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6266),
    [anon_sym___declspec] = ACTIONS(6264),
    [anon_sym___based] = ACTIONS(6264),
    [anon_sym_RBRACE] = ACTIONS(6266),
    [anon_sym_signed] = ACTIONS(6264),
    [anon_sym_unsigned] = ACTIONS(6264),
    [anon_sym_long] = ACTIONS(6264),
    [anon_sym_short] = ACTIONS(6264),
    [anon_sym_LBRACK] = ACTIONS(6264),
    [anon_sym_static] = ACTIONS(6264),
    [anon_sym_register] = ACTIONS(6264),
    [anon_sym_inline] = ACTIONS(6264),
    [anon_sym___inline] = ACTIONS(6264),
    [anon_sym___inline__] = ACTIONS(6264),
    [anon_sym___forceinline] = ACTIONS(6264),
    [anon_sym_thread_local] = ACTIONS(6264),
    [anon_sym___thread] = ACTIONS(6264),
    [anon_sym_const] = ACTIONS(6264),
    [anon_sym_constexpr] = ACTIONS(6264),
    [anon_sym_volatile] = ACTIONS(6264),
    [anon_sym_restrict] = ACTIONS(6264),
    [anon_sym___restrict__] = ACTIONS(6264),
    [anon_sym__Atomic] = ACTIONS(6264),
    [anon_sym__Noreturn] = ACTIONS(6264),
    [anon_sym_noreturn] = ACTIONS(6264),
    [anon_sym__Nonnull] = ACTIONS(6264),
    [anon_sym_mutable] = ACTIONS(6264),
    [anon_sym_constinit] = ACTIONS(6264),
    [anon_sym_consteval] = ACTIONS(6264),
    [anon_sym_alignas] = ACTIONS(6264),
    [anon_sym__Alignas] = ACTIONS(6264),
    [sym_primitive_type] = ACTIONS(6264),
    [anon_sym_enum] = ACTIONS(6264),
    [anon_sym_class] = ACTIONS(6264),
    [anon_sym_struct] = ACTIONS(6264),
    [anon_sym_union] = ACTIONS(6264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6264),
    [anon_sym_let] = ACTIONS(6264),
    [anon_sym_This] = ACTIONS(6264),
    [anon_sym_decltype] = ACTIONS(6264),
    [anon_sym_explicit] = ACTIONS(6264),
    [anon_sym_typename] = ACTIONS(6264),
    [anon_sym_private] = ACTIONS(6264),
    [anon_sym_template] = ACTIONS(6264),
    [anon_sym_operator] = ACTIONS(6264),
    [anon_sym_friend] = ACTIONS(6264),
    [anon_sym_public] = ACTIONS(6264),
    [anon_sym_protected] = ACTIONS(6264),
    [anon_sym_static_assert] = ACTIONS(6264),
    [anon_sym_precise] = ACTIONS(6264),
    [anon_sym_shared] = ACTIONS(6264),
    [anon_sym_groupshared] = ACTIONS(6264),
    [anon_sym_uniform] = ACTIONS(6264),
    [anon_sym_row_major] = ACTIONS(6264),
    [anon_sym_column_major] = ACTIONS(6264),
    [anon_sym_globallycoherent] = ACTIONS(6264),
    [anon_sym_centroid] = ACTIONS(6264),
    [anon_sym_noperspective] = ACTIONS(6264),
    [anon_sym_nointerpolation] = ACTIONS(6264),
    [anon_sym_sample] = ACTIONS(6264),
    [anon_sym_linear] = ACTIONS(6264),
    [anon_sym_snorm] = ACTIONS(6264),
    [anon_sym_unorm] = ACTIONS(6264),
    [anon_sym_point] = ACTIONS(6264),
    [anon_sym_line] = ACTIONS(6264),
    [anon_sym_triangleadj] = ACTIONS(6264),
    [anon_sym_lineadj] = ACTIONS(6264),
    [anon_sym_triangle] = ACTIONS(6264),
    [anon_sym_interface] = ACTIONS(6264),
    [anon_sym_extension] = ACTIONS(6264),
    [anon_sym___init] = ACTIONS(6264),
    [anon_sym___subscript] = ACTIONS(6264),
    [anon_sym_property] = ACTIONS(6264),
    [anon_sym_associatedtype] = ACTIONS(6264),
  },
  [2140] = {
    [sym_identifier] = ACTIONS(6268),
    [aux_sym_preproc_def_token1] = ACTIONS(6268),
    [aux_sym_preproc_if_token1] = ACTIONS(6268),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6268),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6268),
    [sym_preproc_directive] = ACTIONS(6268),
    [anon_sym_LPAREN2] = ACTIONS(6270),
    [anon_sym_TILDE] = ACTIONS(6270),
    [anon_sym_STAR] = ACTIONS(6270),
    [anon_sym_AMP_AMP] = ACTIONS(6270),
    [anon_sym_AMP] = ACTIONS(6268),
    [anon_sym_SEMI] = ACTIONS(6270),
    [anon_sym___extension__] = ACTIONS(6268),
    [anon_sym_typedef] = ACTIONS(6268),
    [anon_sym_in] = ACTIONS(6268),
    [anon_sym_out] = ACTIONS(6268),
    [anon_sym_inout] = ACTIONS(6268),
    [anon_sym_virtual] = ACTIONS(6268),
    [anon_sym_extern] = ACTIONS(6268),
    [anon_sym___attribute__] = ACTIONS(6268),
    [anon_sym___attribute] = ACTIONS(6268),
    [anon_sym_using] = ACTIONS(6268),
    [anon_sym_COLON_COLON] = ACTIONS(6270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6270),
    [anon_sym___declspec] = ACTIONS(6268),
    [anon_sym___based] = ACTIONS(6268),
    [anon_sym_RBRACE] = ACTIONS(6270),
    [anon_sym_signed] = ACTIONS(6268),
    [anon_sym_unsigned] = ACTIONS(6268),
    [anon_sym_long] = ACTIONS(6268),
    [anon_sym_short] = ACTIONS(6268),
    [anon_sym_LBRACK] = ACTIONS(6268),
    [anon_sym_static] = ACTIONS(6268),
    [anon_sym_register] = ACTIONS(6268),
    [anon_sym_inline] = ACTIONS(6268),
    [anon_sym___inline] = ACTIONS(6268),
    [anon_sym___inline__] = ACTIONS(6268),
    [anon_sym___forceinline] = ACTIONS(6268),
    [anon_sym_thread_local] = ACTIONS(6268),
    [anon_sym___thread] = ACTIONS(6268),
    [anon_sym_const] = ACTIONS(6268),
    [anon_sym_constexpr] = ACTIONS(6268),
    [anon_sym_volatile] = ACTIONS(6268),
    [anon_sym_restrict] = ACTIONS(6268),
    [anon_sym___restrict__] = ACTIONS(6268),
    [anon_sym__Atomic] = ACTIONS(6268),
    [anon_sym__Noreturn] = ACTIONS(6268),
    [anon_sym_noreturn] = ACTIONS(6268),
    [anon_sym__Nonnull] = ACTIONS(6268),
    [anon_sym_mutable] = ACTIONS(6268),
    [anon_sym_constinit] = ACTIONS(6268),
    [anon_sym_consteval] = ACTIONS(6268),
    [anon_sym_alignas] = ACTIONS(6268),
    [anon_sym__Alignas] = ACTIONS(6268),
    [sym_primitive_type] = ACTIONS(6268),
    [anon_sym_enum] = ACTIONS(6268),
    [anon_sym_class] = ACTIONS(6268),
    [anon_sym_struct] = ACTIONS(6268),
    [anon_sym_union] = ACTIONS(6268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6268),
    [anon_sym_let] = ACTIONS(6268),
    [anon_sym_This] = ACTIONS(6268),
    [anon_sym_decltype] = ACTIONS(6268),
    [anon_sym_explicit] = ACTIONS(6268),
    [anon_sym_typename] = ACTIONS(6268),
    [anon_sym_private] = ACTIONS(6268),
    [anon_sym_template] = ACTIONS(6268),
    [anon_sym_operator] = ACTIONS(6268),
    [anon_sym_friend] = ACTIONS(6268),
    [anon_sym_public] = ACTIONS(6268),
    [anon_sym_protected] = ACTIONS(6268),
    [anon_sym_static_assert] = ACTIONS(6268),
    [anon_sym_precise] = ACTIONS(6268),
    [anon_sym_shared] = ACTIONS(6268),
    [anon_sym_groupshared] = ACTIONS(6268),
    [anon_sym_uniform] = ACTIONS(6268),
    [anon_sym_row_major] = ACTIONS(6268),
    [anon_sym_column_major] = ACTIONS(6268),
    [anon_sym_globallycoherent] = ACTIONS(6268),
    [anon_sym_centroid] = ACTIONS(6268),
    [anon_sym_noperspective] = ACTIONS(6268),
    [anon_sym_nointerpolation] = ACTIONS(6268),
    [anon_sym_sample] = ACTIONS(6268),
    [anon_sym_linear] = ACTIONS(6268),
    [anon_sym_snorm] = ACTIONS(6268),
    [anon_sym_unorm] = ACTIONS(6268),
    [anon_sym_point] = ACTIONS(6268),
    [anon_sym_line] = ACTIONS(6268),
    [anon_sym_triangleadj] = ACTIONS(6268),
    [anon_sym_lineadj] = ACTIONS(6268),
    [anon_sym_triangle] = ACTIONS(6268),
    [anon_sym_interface] = ACTIONS(6268),
    [anon_sym_extension] = ACTIONS(6268),
    [anon_sym___init] = ACTIONS(6268),
    [anon_sym___subscript] = ACTIONS(6268),
    [anon_sym_property] = ACTIONS(6268),
    [anon_sym_associatedtype] = ACTIONS(6268),
  },
  [2141] = {
    [sym_identifier] = ACTIONS(6278),
    [aux_sym_preproc_def_token1] = ACTIONS(6278),
    [aux_sym_preproc_if_token1] = ACTIONS(6278),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6278),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6278),
    [sym_preproc_directive] = ACTIONS(6278),
    [anon_sym_LPAREN2] = ACTIONS(6280),
    [anon_sym_TILDE] = ACTIONS(6280),
    [anon_sym_STAR] = ACTIONS(6280),
    [anon_sym_AMP_AMP] = ACTIONS(6280),
    [anon_sym_AMP] = ACTIONS(6278),
    [anon_sym_SEMI] = ACTIONS(6280),
    [anon_sym___extension__] = ACTIONS(6278),
    [anon_sym_typedef] = ACTIONS(6278),
    [anon_sym_in] = ACTIONS(6278),
    [anon_sym_out] = ACTIONS(6278),
    [anon_sym_inout] = ACTIONS(6278),
    [anon_sym_virtual] = ACTIONS(6278),
    [anon_sym_extern] = ACTIONS(6278),
    [anon_sym___attribute__] = ACTIONS(6278),
    [anon_sym___attribute] = ACTIONS(6278),
    [anon_sym_using] = ACTIONS(6278),
    [anon_sym_COLON_COLON] = ACTIONS(6280),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6280),
    [anon_sym___declspec] = ACTIONS(6278),
    [anon_sym___based] = ACTIONS(6278),
    [anon_sym_RBRACE] = ACTIONS(6280),
    [anon_sym_signed] = ACTIONS(6278),
    [anon_sym_unsigned] = ACTIONS(6278),
    [anon_sym_long] = ACTIONS(6278),
    [anon_sym_short] = ACTIONS(6278),
    [anon_sym_LBRACK] = ACTIONS(6278),
    [anon_sym_static] = ACTIONS(6278),
    [anon_sym_register] = ACTIONS(6278),
    [anon_sym_inline] = ACTIONS(6278),
    [anon_sym___inline] = ACTIONS(6278),
    [anon_sym___inline__] = ACTIONS(6278),
    [anon_sym___forceinline] = ACTIONS(6278),
    [anon_sym_thread_local] = ACTIONS(6278),
    [anon_sym___thread] = ACTIONS(6278),
    [anon_sym_const] = ACTIONS(6278),
    [anon_sym_constexpr] = ACTIONS(6278),
    [anon_sym_volatile] = ACTIONS(6278),
    [anon_sym_restrict] = ACTIONS(6278),
    [anon_sym___restrict__] = ACTIONS(6278),
    [anon_sym__Atomic] = ACTIONS(6278),
    [anon_sym__Noreturn] = ACTIONS(6278),
    [anon_sym_noreturn] = ACTIONS(6278),
    [anon_sym__Nonnull] = ACTIONS(6278),
    [anon_sym_mutable] = ACTIONS(6278),
    [anon_sym_constinit] = ACTIONS(6278),
    [anon_sym_consteval] = ACTIONS(6278),
    [anon_sym_alignas] = ACTIONS(6278),
    [anon_sym__Alignas] = ACTIONS(6278),
    [sym_primitive_type] = ACTIONS(6278),
    [anon_sym_enum] = ACTIONS(6278),
    [anon_sym_class] = ACTIONS(6278),
    [anon_sym_struct] = ACTIONS(6278),
    [anon_sym_union] = ACTIONS(6278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6278),
    [anon_sym_let] = ACTIONS(6278),
    [anon_sym_This] = ACTIONS(6278),
    [anon_sym_decltype] = ACTIONS(6278),
    [anon_sym_explicit] = ACTIONS(6278),
    [anon_sym_typename] = ACTIONS(6278),
    [anon_sym_private] = ACTIONS(6278),
    [anon_sym_template] = ACTIONS(6278),
    [anon_sym_operator] = ACTIONS(6278),
    [anon_sym_friend] = ACTIONS(6278),
    [anon_sym_public] = ACTIONS(6278),
    [anon_sym_protected] = ACTIONS(6278),
    [anon_sym_static_assert] = ACTIONS(6278),
    [anon_sym_precise] = ACTIONS(6278),
    [anon_sym_shared] = ACTIONS(6278),
    [anon_sym_groupshared] = ACTIONS(6278),
    [anon_sym_uniform] = ACTIONS(6278),
    [anon_sym_row_major] = ACTIONS(6278),
    [anon_sym_column_major] = ACTIONS(6278),
    [anon_sym_globallycoherent] = ACTIONS(6278),
    [anon_sym_centroid] = ACTIONS(6278),
    [anon_sym_noperspective] = ACTIONS(6278),
    [anon_sym_nointerpolation] = ACTIONS(6278),
    [anon_sym_sample] = ACTIONS(6278),
    [anon_sym_linear] = ACTIONS(6278),
    [anon_sym_snorm] = ACTIONS(6278),
    [anon_sym_unorm] = ACTIONS(6278),
    [anon_sym_point] = ACTIONS(6278),
    [anon_sym_line] = ACTIONS(6278),
    [anon_sym_triangleadj] = ACTIONS(6278),
    [anon_sym_lineadj] = ACTIONS(6278),
    [anon_sym_triangle] = ACTIONS(6278),
    [anon_sym_interface] = ACTIONS(6278),
    [anon_sym_extension] = ACTIONS(6278),
    [anon_sym___init] = ACTIONS(6278),
    [anon_sym___subscript] = ACTIONS(6278),
    [anon_sym_property] = ACTIONS(6278),
    [anon_sym_associatedtype] = ACTIONS(6278),
  },
  [2142] = {
    [sym_identifier] = ACTIONS(6294),
    [aux_sym_preproc_def_token1] = ACTIONS(6294),
    [aux_sym_preproc_if_token1] = ACTIONS(6294),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6294),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6294),
    [sym_preproc_directive] = ACTIONS(6294),
    [anon_sym_LPAREN2] = ACTIONS(6296),
    [anon_sym_TILDE] = ACTIONS(6296),
    [anon_sym_STAR] = ACTIONS(6296),
    [anon_sym_AMP_AMP] = ACTIONS(6296),
    [anon_sym_AMP] = ACTIONS(6294),
    [anon_sym_SEMI] = ACTIONS(6296),
    [anon_sym___extension__] = ACTIONS(6294),
    [anon_sym_typedef] = ACTIONS(6294),
    [anon_sym_in] = ACTIONS(6294),
    [anon_sym_out] = ACTIONS(6294),
    [anon_sym_inout] = ACTIONS(6294),
    [anon_sym_virtual] = ACTIONS(6294),
    [anon_sym_extern] = ACTIONS(6294),
    [anon_sym___attribute__] = ACTIONS(6294),
    [anon_sym___attribute] = ACTIONS(6294),
    [anon_sym_using] = ACTIONS(6294),
    [anon_sym_COLON_COLON] = ACTIONS(6296),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6296),
    [anon_sym___declspec] = ACTIONS(6294),
    [anon_sym___based] = ACTIONS(6294),
    [anon_sym_RBRACE] = ACTIONS(6296),
    [anon_sym_signed] = ACTIONS(6294),
    [anon_sym_unsigned] = ACTIONS(6294),
    [anon_sym_long] = ACTIONS(6294),
    [anon_sym_short] = ACTIONS(6294),
    [anon_sym_LBRACK] = ACTIONS(6294),
    [anon_sym_static] = ACTIONS(6294),
    [anon_sym_register] = ACTIONS(6294),
    [anon_sym_inline] = ACTIONS(6294),
    [anon_sym___inline] = ACTIONS(6294),
    [anon_sym___inline__] = ACTIONS(6294),
    [anon_sym___forceinline] = ACTIONS(6294),
    [anon_sym_thread_local] = ACTIONS(6294),
    [anon_sym___thread] = ACTIONS(6294),
    [anon_sym_const] = ACTIONS(6294),
    [anon_sym_constexpr] = ACTIONS(6294),
    [anon_sym_volatile] = ACTIONS(6294),
    [anon_sym_restrict] = ACTIONS(6294),
    [anon_sym___restrict__] = ACTIONS(6294),
    [anon_sym__Atomic] = ACTIONS(6294),
    [anon_sym__Noreturn] = ACTIONS(6294),
    [anon_sym_noreturn] = ACTIONS(6294),
    [anon_sym__Nonnull] = ACTIONS(6294),
    [anon_sym_mutable] = ACTIONS(6294),
    [anon_sym_constinit] = ACTIONS(6294),
    [anon_sym_consteval] = ACTIONS(6294),
    [anon_sym_alignas] = ACTIONS(6294),
    [anon_sym__Alignas] = ACTIONS(6294),
    [sym_primitive_type] = ACTIONS(6294),
    [anon_sym_enum] = ACTIONS(6294),
    [anon_sym_class] = ACTIONS(6294),
    [anon_sym_struct] = ACTIONS(6294),
    [anon_sym_union] = ACTIONS(6294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6294),
    [anon_sym_let] = ACTIONS(6294),
    [anon_sym_This] = ACTIONS(6294),
    [anon_sym_decltype] = ACTIONS(6294),
    [anon_sym_explicit] = ACTIONS(6294),
    [anon_sym_typename] = ACTIONS(6294),
    [anon_sym_private] = ACTIONS(6294),
    [anon_sym_template] = ACTIONS(6294),
    [anon_sym_operator] = ACTIONS(6294),
    [anon_sym_friend] = ACTIONS(6294),
    [anon_sym_public] = ACTIONS(6294),
    [anon_sym_protected] = ACTIONS(6294),
    [anon_sym_static_assert] = ACTIONS(6294),
    [anon_sym_precise] = ACTIONS(6294),
    [anon_sym_shared] = ACTIONS(6294),
    [anon_sym_groupshared] = ACTIONS(6294),
    [anon_sym_uniform] = ACTIONS(6294),
    [anon_sym_row_major] = ACTIONS(6294),
    [anon_sym_column_major] = ACTIONS(6294),
    [anon_sym_globallycoherent] = ACTIONS(6294),
    [anon_sym_centroid] = ACTIONS(6294),
    [anon_sym_noperspective] = ACTIONS(6294),
    [anon_sym_nointerpolation] = ACTIONS(6294),
    [anon_sym_sample] = ACTIONS(6294),
    [anon_sym_linear] = ACTIONS(6294),
    [anon_sym_snorm] = ACTIONS(6294),
    [anon_sym_unorm] = ACTIONS(6294),
    [anon_sym_point] = ACTIONS(6294),
    [anon_sym_line] = ACTIONS(6294),
    [anon_sym_triangleadj] = ACTIONS(6294),
    [anon_sym_lineadj] = ACTIONS(6294),
    [anon_sym_triangle] = ACTIONS(6294),
    [anon_sym_interface] = ACTIONS(6294),
    [anon_sym_extension] = ACTIONS(6294),
    [anon_sym___init] = ACTIONS(6294),
    [anon_sym___subscript] = ACTIONS(6294),
    [anon_sym_property] = ACTIONS(6294),
    [anon_sym_associatedtype] = ACTIONS(6294),
  },
  [2143] = {
    [sym_identifier] = ACTIONS(3963),
    [aux_sym_preproc_def_token1] = ACTIONS(3963),
    [aux_sym_preproc_if_token1] = ACTIONS(3963),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3963),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3963),
    [sym_preproc_directive] = ACTIONS(3963),
    [anon_sym_LPAREN2] = ACTIONS(3965),
    [anon_sym_TILDE] = ACTIONS(3965),
    [anon_sym_STAR] = ACTIONS(3965),
    [anon_sym_AMP_AMP] = ACTIONS(3965),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_SEMI] = ACTIONS(3965),
    [anon_sym___extension__] = ACTIONS(3963),
    [anon_sym_typedef] = ACTIONS(3963),
    [anon_sym_in] = ACTIONS(3963),
    [anon_sym_out] = ACTIONS(3963),
    [anon_sym_inout] = ACTIONS(3963),
    [anon_sym_virtual] = ACTIONS(3963),
    [anon_sym_extern] = ACTIONS(3963),
    [anon_sym___attribute__] = ACTIONS(3963),
    [anon_sym___attribute] = ACTIONS(3963),
    [anon_sym_using] = ACTIONS(3963),
    [anon_sym_COLON_COLON] = ACTIONS(3965),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3965),
    [anon_sym___declspec] = ACTIONS(3963),
    [anon_sym___based] = ACTIONS(3963),
    [anon_sym_RBRACE] = ACTIONS(3965),
    [anon_sym_signed] = ACTIONS(3963),
    [anon_sym_unsigned] = ACTIONS(3963),
    [anon_sym_long] = ACTIONS(3963),
    [anon_sym_short] = ACTIONS(3963),
    [anon_sym_LBRACK] = ACTIONS(3963),
    [anon_sym_static] = ACTIONS(3963),
    [anon_sym_register] = ACTIONS(3963),
    [anon_sym_inline] = ACTIONS(3963),
    [anon_sym___inline] = ACTIONS(3963),
    [anon_sym___inline__] = ACTIONS(3963),
    [anon_sym___forceinline] = ACTIONS(3963),
    [anon_sym_thread_local] = ACTIONS(3963),
    [anon_sym___thread] = ACTIONS(3963),
    [anon_sym_const] = ACTIONS(3963),
    [anon_sym_constexpr] = ACTIONS(3963),
    [anon_sym_volatile] = ACTIONS(3963),
    [anon_sym_restrict] = ACTIONS(3963),
    [anon_sym___restrict__] = ACTIONS(3963),
    [anon_sym__Atomic] = ACTIONS(3963),
    [anon_sym__Noreturn] = ACTIONS(3963),
    [anon_sym_noreturn] = ACTIONS(3963),
    [anon_sym__Nonnull] = ACTIONS(3963),
    [anon_sym_mutable] = ACTIONS(3963),
    [anon_sym_constinit] = ACTIONS(3963),
    [anon_sym_consteval] = ACTIONS(3963),
    [anon_sym_alignas] = ACTIONS(3963),
    [anon_sym__Alignas] = ACTIONS(3963),
    [sym_primitive_type] = ACTIONS(3963),
    [anon_sym_enum] = ACTIONS(3963),
    [anon_sym_class] = ACTIONS(3963),
    [anon_sym_struct] = ACTIONS(3963),
    [anon_sym_union] = ACTIONS(3963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3963),
    [anon_sym_let] = ACTIONS(3963),
    [anon_sym_This] = ACTIONS(3963),
    [anon_sym_decltype] = ACTIONS(3963),
    [anon_sym_explicit] = ACTIONS(3963),
    [anon_sym_typename] = ACTIONS(3963),
    [anon_sym_private] = ACTIONS(3963),
    [anon_sym_template] = ACTIONS(3963),
    [anon_sym_operator] = ACTIONS(3963),
    [anon_sym_friend] = ACTIONS(3963),
    [anon_sym_public] = ACTIONS(3963),
    [anon_sym_protected] = ACTIONS(3963),
    [anon_sym_static_assert] = ACTIONS(3963),
    [anon_sym_precise] = ACTIONS(3963),
    [anon_sym_shared] = ACTIONS(3963),
    [anon_sym_groupshared] = ACTIONS(3963),
    [anon_sym_uniform] = ACTIONS(3963),
    [anon_sym_row_major] = ACTIONS(3963),
    [anon_sym_column_major] = ACTIONS(3963),
    [anon_sym_globallycoherent] = ACTIONS(3963),
    [anon_sym_centroid] = ACTIONS(3963),
    [anon_sym_noperspective] = ACTIONS(3963),
    [anon_sym_nointerpolation] = ACTIONS(3963),
    [anon_sym_sample] = ACTIONS(3963),
    [anon_sym_linear] = ACTIONS(3963),
    [anon_sym_snorm] = ACTIONS(3963),
    [anon_sym_unorm] = ACTIONS(3963),
    [anon_sym_point] = ACTIONS(3963),
    [anon_sym_line] = ACTIONS(3963),
    [anon_sym_triangleadj] = ACTIONS(3963),
    [anon_sym_lineadj] = ACTIONS(3963),
    [anon_sym_triangle] = ACTIONS(3963),
    [anon_sym_interface] = ACTIONS(3963),
    [anon_sym_extension] = ACTIONS(3963),
    [anon_sym___init] = ACTIONS(3963),
    [anon_sym___subscript] = ACTIONS(3963),
    [anon_sym_property] = ACTIONS(3963),
    [anon_sym_associatedtype] = ACTIONS(3963),
  },
  [2144] = {
    [sym_identifier] = ACTIONS(3983),
    [aux_sym_preproc_def_token1] = ACTIONS(3983),
    [aux_sym_preproc_if_token1] = ACTIONS(3983),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3983),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3983),
    [sym_preproc_directive] = ACTIONS(3983),
    [anon_sym_LPAREN2] = ACTIONS(3985),
    [anon_sym_TILDE] = ACTIONS(3985),
    [anon_sym_STAR] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3983),
    [anon_sym_SEMI] = ACTIONS(3985),
    [anon_sym___extension__] = ACTIONS(3983),
    [anon_sym_typedef] = ACTIONS(3983),
    [anon_sym_in] = ACTIONS(3983),
    [anon_sym_out] = ACTIONS(3983),
    [anon_sym_inout] = ACTIONS(3983),
    [anon_sym_virtual] = ACTIONS(3983),
    [anon_sym_extern] = ACTIONS(3983),
    [anon_sym___attribute__] = ACTIONS(3983),
    [anon_sym___attribute] = ACTIONS(3983),
    [anon_sym_using] = ACTIONS(3983),
    [anon_sym_COLON_COLON] = ACTIONS(3985),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3985),
    [anon_sym___declspec] = ACTIONS(3983),
    [anon_sym___based] = ACTIONS(3983),
    [anon_sym_RBRACE] = ACTIONS(3985),
    [anon_sym_signed] = ACTIONS(3983),
    [anon_sym_unsigned] = ACTIONS(3983),
    [anon_sym_long] = ACTIONS(3983),
    [anon_sym_short] = ACTIONS(3983),
    [anon_sym_LBRACK] = ACTIONS(3983),
    [anon_sym_static] = ACTIONS(3983),
    [anon_sym_register] = ACTIONS(3983),
    [anon_sym_inline] = ACTIONS(3983),
    [anon_sym___inline] = ACTIONS(3983),
    [anon_sym___inline__] = ACTIONS(3983),
    [anon_sym___forceinline] = ACTIONS(3983),
    [anon_sym_thread_local] = ACTIONS(3983),
    [anon_sym___thread] = ACTIONS(3983),
    [anon_sym_const] = ACTIONS(3983),
    [anon_sym_constexpr] = ACTIONS(3983),
    [anon_sym_volatile] = ACTIONS(3983),
    [anon_sym_restrict] = ACTIONS(3983),
    [anon_sym___restrict__] = ACTIONS(3983),
    [anon_sym__Atomic] = ACTIONS(3983),
    [anon_sym__Noreturn] = ACTIONS(3983),
    [anon_sym_noreturn] = ACTIONS(3983),
    [anon_sym__Nonnull] = ACTIONS(3983),
    [anon_sym_mutable] = ACTIONS(3983),
    [anon_sym_constinit] = ACTIONS(3983),
    [anon_sym_consteval] = ACTIONS(3983),
    [anon_sym_alignas] = ACTIONS(3983),
    [anon_sym__Alignas] = ACTIONS(3983),
    [sym_primitive_type] = ACTIONS(3983),
    [anon_sym_enum] = ACTIONS(3983),
    [anon_sym_class] = ACTIONS(3983),
    [anon_sym_struct] = ACTIONS(3983),
    [anon_sym_union] = ACTIONS(3983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3983),
    [anon_sym_let] = ACTIONS(3983),
    [anon_sym_This] = ACTIONS(3983),
    [anon_sym_decltype] = ACTIONS(3983),
    [anon_sym_explicit] = ACTIONS(3983),
    [anon_sym_typename] = ACTIONS(3983),
    [anon_sym_private] = ACTIONS(3983),
    [anon_sym_template] = ACTIONS(3983),
    [anon_sym_operator] = ACTIONS(3983),
    [anon_sym_friend] = ACTIONS(3983),
    [anon_sym_public] = ACTIONS(3983),
    [anon_sym_protected] = ACTIONS(3983),
    [anon_sym_static_assert] = ACTIONS(3983),
    [anon_sym_precise] = ACTIONS(3983),
    [anon_sym_shared] = ACTIONS(3983),
    [anon_sym_groupshared] = ACTIONS(3983),
    [anon_sym_uniform] = ACTIONS(3983),
    [anon_sym_row_major] = ACTIONS(3983),
    [anon_sym_column_major] = ACTIONS(3983),
    [anon_sym_globallycoherent] = ACTIONS(3983),
    [anon_sym_centroid] = ACTIONS(3983),
    [anon_sym_noperspective] = ACTIONS(3983),
    [anon_sym_nointerpolation] = ACTIONS(3983),
    [anon_sym_sample] = ACTIONS(3983),
    [anon_sym_linear] = ACTIONS(3983),
    [anon_sym_snorm] = ACTIONS(3983),
    [anon_sym_unorm] = ACTIONS(3983),
    [anon_sym_point] = ACTIONS(3983),
    [anon_sym_line] = ACTIONS(3983),
    [anon_sym_triangleadj] = ACTIONS(3983),
    [anon_sym_lineadj] = ACTIONS(3983),
    [anon_sym_triangle] = ACTIONS(3983),
    [anon_sym_interface] = ACTIONS(3983),
    [anon_sym_extension] = ACTIONS(3983),
    [anon_sym___init] = ACTIONS(3983),
    [anon_sym___subscript] = ACTIONS(3983),
    [anon_sym_property] = ACTIONS(3983),
    [anon_sym_associatedtype] = ACTIONS(3983),
  },
  [2145] = {
    [sym_identifier] = ACTIONS(3379),
    [aux_sym_preproc_def_token1] = ACTIONS(3379),
    [aux_sym_preproc_if_token1] = ACTIONS(3379),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3379),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3379),
    [sym_preproc_directive] = ACTIONS(3379),
    [anon_sym_LPAREN2] = ACTIONS(3381),
    [anon_sym_TILDE] = ACTIONS(3381),
    [anon_sym_STAR] = ACTIONS(3381),
    [anon_sym_AMP_AMP] = ACTIONS(3381),
    [anon_sym_AMP] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3381),
    [anon_sym___extension__] = ACTIONS(3379),
    [anon_sym_typedef] = ACTIONS(3379),
    [anon_sym_in] = ACTIONS(3379),
    [anon_sym_out] = ACTIONS(3379),
    [anon_sym_inout] = ACTIONS(3379),
    [anon_sym_virtual] = ACTIONS(3379),
    [anon_sym_extern] = ACTIONS(3379),
    [anon_sym___attribute__] = ACTIONS(3379),
    [anon_sym___attribute] = ACTIONS(3379),
    [anon_sym_using] = ACTIONS(3379),
    [anon_sym_COLON_COLON] = ACTIONS(3381),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3381),
    [anon_sym___declspec] = ACTIONS(3379),
    [anon_sym___based] = ACTIONS(3379),
    [anon_sym_RBRACE] = ACTIONS(3381),
    [anon_sym_signed] = ACTIONS(3379),
    [anon_sym_unsigned] = ACTIONS(3379),
    [anon_sym_long] = ACTIONS(3379),
    [anon_sym_short] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_register] = ACTIONS(3379),
    [anon_sym_inline] = ACTIONS(3379),
    [anon_sym___inline] = ACTIONS(3379),
    [anon_sym___inline__] = ACTIONS(3379),
    [anon_sym___forceinline] = ACTIONS(3379),
    [anon_sym_thread_local] = ACTIONS(3379),
    [anon_sym___thread] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_constexpr] = ACTIONS(3379),
    [anon_sym_volatile] = ACTIONS(3379),
    [anon_sym_restrict] = ACTIONS(3379),
    [anon_sym___restrict__] = ACTIONS(3379),
    [anon_sym__Atomic] = ACTIONS(3379),
    [anon_sym__Noreturn] = ACTIONS(3379),
    [anon_sym_noreturn] = ACTIONS(3379),
    [anon_sym__Nonnull] = ACTIONS(3379),
    [anon_sym_mutable] = ACTIONS(3379),
    [anon_sym_constinit] = ACTIONS(3379),
    [anon_sym_consteval] = ACTIONS(3379),
    [anon_sym_alignas] = ACTIONS(3379),
    [anon_sym__Alignas] = ACTIONS(3379),
    [sym_primitive_type] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_struct] = ACTIONS(3379),
    [anon_sym_union] = ACTIONS(3379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3379),
    [anon_sym_let] = ACTIONS(3379),
    [anon_sym_This] = ACTIONS(3379),
    [anon_sym_decltype] = ACTIONS(3379),
    [anon_sym_explicit] = ACTIONS(3379),
    [anon_sym_typename] = ACTIONS(3379),
    [anon_sym_private] = ACTIONS(3379),
    [anon_sym_template] = ACTIONS(3379),
    [anon_sym_operator] = ACTIONS(3379),
    [anon_sym_friend] = ACTIONS(3379),
    [anon_sym_public] = ACTIONS(3379),
    [anon_sym_protected] = ACTIONS(3379),
    [anon_sym_static_assert] = ACTIONS(3379),
    [anon_sym_precise] = ACTIONS(3379),
    [anon_sym_shared] = ACTIONS(3379),
    [anon_sym_groupshared] = ACTIONS(3379),
    [anon_sym_uniform] = ACTIONS(3379),
    [anon_sym_row_major] = ACTIONS(3379),
    [anon_sym_column_major] = ACTIONS(3379),
    [anon_sym_globallycoherent] = ACTIONS(3379),
    [anon_sym_centroid] = ACTIONS(3379),
    [anon_sym_noperspective] = ACTIONS(3379),
    [anon_sym_nointerpolation] = ACTIONS(3379),
    [anon_sym_sample] = ACTIONS(3379),
    [anon_sym_linear] = ACTIONS(3379),
    [anon_sym_snorm] = ACTIONS(3379),
    [anon_sym_unorm] = ACTIONS(3379),
    [anon_sym_point] = ACTIONS(3379),
    [anon_sym_line] = ACTIONS(3379),
    [anon_sym_triangleadj] = ACTIONS(3379),
    [anon_sym_lineadj] = ACTIONS(3379),
    [anon_sym_triangle] = ACTIONS(3379),
    [anon_sym_interface] = ACTIONS(3379),
    [anon_sym_extension] = ACTIONS(3379),
    [anon_sym___init] = ACTIONS(3379),
    [anon_sym___subscript] = ACTIONS(3379),
    [anon_sym_property] = ACTIONS(3379),
    [anon_sym_associatedtype] = ACTIONS(3379),
  },
  [2146] = {
    [sym_identifier] = ACTIONS(3763),
    [aux_sym_preproc_def_token1] = ACTIONS(3763),
    [aux_sym_preproc_if_token1] = ACTIONS(3763),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3763),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3763),
    [sym_preproc_directive] = ACTIONS(3763),
    [anon_sym_LPAREN2] = ACTIONS(3765),
    [anon_sym_TILDE] = ACTIONS(3765),
    [anon_sym_STAR] = ACTIONS(3765),
    [anon_sym_AMP_AMP] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3763),
    [anon_sym_SEMI] = ACTIONS(3765),
    [anon_sym___extension__] = ACTIONS(3763),
    [anon_sym_typedef] = ACTIONS(3763),
    [anon_sym_in] = ACTIONS(3763),
    [anon_sym_out] = ACTIONS(3763),
    [anon_sym_inout] = ACTIONS(3763),
    [anon_sym_virtual] = ACTIONS(3763),
    [anon_sym_extern] = ACTIONS(3763),
    [anon_sym___attribute__] = ACTIONS(3763),
    [anon_sym___attribute] = ACTIONS(3763),
    [anon_sym_using] = ACTIONS(3763),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3765),
    [anon_sym___declspec] = ACTIONS(3763),
    [anon_sym___based] = ACTIONS(3763),
    [anon_sym_RBRACE] = ACTIONS(3765),
    [anon_sym_signed] = ACTIONS(3763),
    [anon_sym_unsigned] = ACTIONS(3763),
    [anon_sym_long] = ACTIONS(3763),
    [anon_sym_short] = ACTIONS(3763),
    [anon_sym_LBRACK] = ACTIONS(3763),
    [anon_sym_static] = ACTIONS(3763),
    [anon_sym_register] = ACTIONS(3763),
    [anon_sym_inline] = ACTIONS(3763),
    [anon_sym___inline] = ACTIONS(3763),
    [anon_sym___inline__] = ACTIONS(3763),
    [anon_sym___forceinline] = ACTIONS(3763),
    [anon_sym_thread_local] = ACTIONS(3763),
    [anon_sym___thread] = ACTIONS(3763),
    [anon_sym_const] = ACTIONS(3763),
    [anon_sym_constexpr] = ACTIONS(3763),
    [anon_sym_volatile] = ACTIONS(3763),
    [anon_sym_restrict] = ACTIONS(3763),
    [anon_sym___restrict__] = ACTIONS(3763),
    [anon_sym__Atomic] = ACTIONS(3763),
    [anon_sym__Noreturn] = ACTIONS(3763),
    [anon_sym_noreturn] = ACTIONS(3763),
    [anon_sym__Nonnull] = ACTIONS(3763),
    [anon_sym_mutable] = ACTIONS(3763),
    [anon_sym_constinit] = ACTIONS(3763),
    [anon_sym_consteval] = ACTIONS(3763),
    [anon_sym_alignas] = ACTIONS(3763),
    [anon_sym__Alignas] = ACTIONS(3763),
    [sym_primitive_type] = ACTIONS(3763),
    [anon_sym_enum] = ACTIONS(3763),
    [anon_sym_class] = ACTIONS(3763),
    [anon_sym_struct] = ACTIONS(3763),
    [anon_sym_union] = ACTIONS(3763),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3763),
    [anon_sym_let] = ACTIONS(3763),
    [anon_sym_This] = ACTIONS(3763),
    [anon_sym_decltype] = ACTIONS(3763),
    [anon_sym_explicit] = ACTIONS(3763),
    [anon_sym_typename] = ACTIONS(3763),
    [anon_sym_private] = ACTIONS(3763),
    [anon_sym_template] = ACTIONS(3763),
    [anon_sym_operator] = ACTIONS(3763),
    [anon_sym_friend] = ACTIONS(3763),
    [anon_sym_public] = ACTIONS(3763),
    [anon_sym_protected] = ACTIONS(3763),
    [anon_sym_static_assert] = ACTIONS(3763),
    [anon_sym_precise] = ACTIONS(3763),
    [anon_sym_shared] = ACTIONS(3763),
    [anon_sym_groupshared] = ACTIONS(3763),
    [anon_sym_uniform] = ACTIONS(3763),
    [anon_sym_row_major] = ACTIONS(3763),
    [anon_sym_column_major] = ACTIONS(3763),
    [anon_sym_globallycoherent] = ACTIONS(3763),
    [anon_sym_centroid] = ACTIONS(3763),
    [anon_sym_noperspective] = ACTIONS(3763),
    [anon_sym_nointerpolation] = ACTIONS(3763),
    [anon_sym_sample] = ACTIONS(3763),
    [anon_sym_linear] = ACTIONS(3763),
    [anon_sym_snorm] = ACTIONS(3763),
    [anon_sym_unorm] = ACTIONS(3763),
    [anon_sym_point] = ACTIONS(3763),
    [anon_sym_line] = ACTIONS(3763),
    [anon_sym_triangleadj] = ACTIONS(3763),
    [anon_sym_lineadj] = ACTIONS(3763),
    [anon_sym_triangle] = ACTIONS(3763),
    [anon_sym_interface] = ACTIONS(3763),
    [anon_sym_extension] = ACTIONS(3763),
    [anon_sym___init] = ACTIONS(3763),
    [anon_sym___subscript] = ACTIONS(3763),
    [anon_sym_property] = ACTIONS(3763),
    [anon_sym_associatedtype] = ACTIONS(3763),
  },
  [2147] = {
    [sym_expression] = STATE(5709),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2148] = {
    [sym_identifier] = ACTIONS(6306),
    [aux_sym_preproc_def_token1] = ACTIONS(6306),
    [aux_sym_preproc_if_token1] = ACTIONS(6306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6306),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6306),
    [sym_preproc_directive] = ACTIONS(6306),
    [anon_sym_LPAREN2] = ACTIONS(6308),
    [anon_sym_TILDE] = ACTIONS(6308),
    [anon_sym_STAR] = ACTIONS(6308),
    [anon_sym_AMP_AMP] = ACTIONS(6308),
    [anon_sym_AMP] = ACTIONS(6306),
    [anon_sym_SEMI] = ACTIONS(6308),
    [anon_sym___extension__] = ACTIONS(6306),
    [anon_sym_typedef] = ACTIONS(6306),
    [anon_sym_in] = ACTIONS(6306),
    [anon_sym_out] = ACTIONS(6306),
    [anon_sym_inout] = ACTIONS(6306),
    [anon_sym_virtual] = ACTIONS(6306),
    [anon_sym_extern] = ACTIONS(6306),
    [anon_sym___attribute__] = ACTIONS(6306),
    [anon_sym___attribute] = ACTIONS(6306),
    [anon_sym_using] = ACTIONS(6306),
    [anon_sym_COLON_COLON] = ACTIONS(6308),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6308),
    [anon_sym___declspec] = ACTIONS(6306),
    [anon_sym___based] = ACTIONS(6306),
    [anon_sym_RBRACE] = ACTIONS(6308),
    [anon_sym_signed] = ACTIONS(6306),
    [anon_sym_unsigned] = ACTIONS(6306),
    [anon_sym_long] = ACTIONS(6306),
    [anon_sym_short] = ACTIONS(6306),
    [anon_sym_LBRACK] = ACTIONS(6306),
    [anon_sym_static] = ACTIONS(6306),
    [anon_sym_register] = ACTIONS(6306),
    [anon_sym_inline] = ACTIONS(6306),
    [anon_sym___inline] = ACTIONS(6306),
    [anon_sym___inline__] = ACTIONS(6306),
    [anon_sym___forceinline] = ACTIONS(6306),
    [anon_sym_thread_local] = ACTIONS(6306),
    [anon_sym___thread] = ACTIONS(6306),
    [anon_sym_const] = ACTIONS(6306),
    [anon_sym_constexpr] = ACTIONS(6306),
    [anon_sym_volatile] = ACTIONS(6306),
    [anon_sym_restrict] = ACTIONS(6306),
    [anon_sym___restrict__] = ACTIONS(6306),
    [anon_sym__Atomic] = ACTIONS(6306),
    [anon_sym__Noreturn] = ACTIONS(6306),
    [anon_sym_noreturn] = ACTIONS(6306),
    [anon_sym__Nonnull] = ACTIONS(6306),
    [anon_sym_mutable] = ACTIONS(6306),
    [anon_sym_constinit] = ACTIONS(6306),
    [anon_sym_consteval] = ACTIONS(6306),
    [anon_sym_alignas] = ACTIONS(6306),
    [anon_sym__Alignas] = ACTIONS(6306),
    [sym_primitive_type] = ACTIONS(6306),
    [anon_sym_enum] = ACTIONS(6306),
    [anon_sym_class] = ACTIONS(6306),
    [anon_sym_struct] = ACTIONS(6306),
    [anon_sym_union] = ACTIONS(6306),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6306),
    [anon_sym_let] = ACTIONS(6306),
    [anon_sym_This] = ACTIONS(6306),
    [anon_sym_decltype] = ACTIONS(6306),
    [anon_sym_explicit] = ACTIONS(6306),
    [anon_sym_typename] = ACTIONS(6306),
    [anon_sym_private] = ACTIONS(6306),
    [anon_sym_template] = ACTIONS(6306),
    [anon_sym_operator] = ACTIONS(6306),
    [anon_sym_friend] = ACTIONS(6306),
    [anon_sym_public] = ACTIONS(6306),
    [anon_sym_protected] = ACTIONS(6306),
    [anon_sym_static_assert] = ACTIONS(6306),
    [anon_sym_precise] = ACTIONS(6306),
    [anon_sym_shared] = ACTIONS(6306),
    [anon_sym_groupshared] = ACTIONS(6306),
    [anon_sym_uniform] = ACTIONS(6306),
    [anon_sym_row_major] = ACTIONS(6306),
    [anon_sym_column_major] = ACTIONS(6306),
    [anon_sym_globallycoherent] = ACTIONS(6306),
    [anon_sym_centroid] = ACTIONS(6306),
    [anon_sym_noperspective] = ACTIONS(6306),
    [anon_sym_nointerpolation] = ACTIONS(6306),
    [anon_sym_sample] = ACTIONS(6306),
    [anon_sym_linear] = ACTIONS(6306),
    [anon_sym_snorm] = ACTIONS(6306),
    [anon_sym_unorm] = ACTIONS(6306),
    [anon_sym_point] = ACTIONS(6306),
    [anon_sym_line] = ACTIONS(6306),
    [anon_sym_triangleadj] = ACTIONS(6306),
    [anon_sym_lineadj] = ACTIONS(6306),
    [anon_sym_triangle] = ACTIONS(6306),
    [anon_sym_interface] = ACTIONS(6306),
    [anon_sym_extension] = ACTIONS(6306),
    [anon_sym___init] = ACTIONS(6306),
    [anon_sym___subscript] = ACTIONS(6306),
    [anon_sym_property] = ACTIONS(6306),
    [anon_sym_associatedtype] = ACTIONS(6306),
  },
  [2149] = {
    [sym_identifier] = ACTIONS(6310),
    [aux_sym_preproc_def_token1] = ACTIONS(6310),
    [aux_sym_preproc_if_token1] = ACTIONS(6310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6310),
    [sym_preproc_directive] = ACTIONS(6310),
    [anon_sym_LPAREN2] = ACTIONS(6312),
    [anon_sym_TILDE] = ACTIONS(6312),
    [anon_sym_STAR] = ACTIONS(6312),
    [anon_sym_AMP_AMP] = ACTIONS(6312),
    [anon_sym_AMP] = ACTIONS(6310),
    [anon_sym_SEMI] = ACTIONS(6312),
    [anon_sym___extension__] = ACTIONS(6310),
    [anon_sym_typedef] = ACTIONS(6310),
    [anon_sym_in] = ACTIONS(6310),
    [anon_sym_out] = ACTIONS(6310),
    [anon_sym_inout] = ACTIONS(6310),
    [anon_sym_virtual] = ACTIONS(6310),
    [anon_sym_extern] = ACTIONS(6310),
    [anon_sym___attribute__] = ACTIONS(6310),
    [anon_sym___attribute] = ACTIONS(6310),
    [anon_sym_using] = ACTIONS(6310),
    [anon_sym_COLON_COLON] = ACTIONS(6312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6312),
    [anon_sym___declspec] = ACTIONS(6310),
    [anon_sym___based] = ACTIONS(6310),
    [anon_sym_RBRACE] = ACTIONS(6312),
    [anon_sym_signed] = ACTIONS(6310),
    [anon_sym_unsigned] = ACTIONS(6310),
    [anon_sym_long] = ACTIONS(6310),
    [anon_sym_short] = ACTIONS(6310),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_static] = ACTIONS(6310),
    [anon_sym_register] = ACTIONS(6310),
    [anon_sym_inline] = ACTIONS(6310),
    [anon_sym___inline] = ACTIONS(6310),
    [anon_sym___inline__] = ACTIONS(6310),
    [anon_sym___forceinline] = ACTIONS(6310),
    [anon_sym_thread_local] = ACTIONS(6310),
    [anon_sym___thread] = ACTIONS(6310),
    [anon_sym_const] = ACTIONS(6310),
    [anon_sym_constexpr] = ACTIONS(6310),
    [anon_sym_volatile] = ACTIONS(6310),
    [anon_sym_restrict] = ACTIONS(6310),
    [anon_sym___restrict__] = ACTIONS(6310),
    [anon_sym__Atomic] = ACTIONS(6310),
    [anon_sym__Noreturn] = ACTIONS(6310),
    [anon_sym_noreturn] = ACTIONS(6310),
    [anon_sym__Nonnull] = ACTIONS(6310),
    [anon_sym_mutable] = ACTIONS(6310),
    [anon_sym_constinit] = ACTIONS(6310),
    [anon_sym_consteval] = ACTIONS(6310),
    [anon_sym_alignas] = ACTIONS(6310),
    [anon_sym__Alignas] = ACTIONS(6310),
    [sym_primitive_type] = ACTIONS(6310),
    [anon_sym_enum] = ACTIONS(6310),
    [anon_sym_class] = ACTIONS(6310),
    [anon_sym_struct] = ACTIONS(6310),
    [anon_sym_union] = ACTIONS(6310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6310),
    [anon_sym_let] = ACTIONS(6310),
    [anon_sym_This] = ACTIONS(6310),
    [anon_sym_decltype] = ACTIONS(6310),
    [anon_sym_explicit] = ACTIONS(6310),
    [anon_sym_typename] = ACTIONS(6310),
    [anon_sym_private] = ACTIONS(6310),
    [anon_sym_template] = ACTIONS(6310),
    [anon_sym_operator] = ACTIONS(6310),
    [anon_sym_friend] = ACTIONS(6310),
    [anon_sym_public] = ACTIONS(6310),
    [anon_sym_protected] = ACTIONS(6310),
    [anon_sym_static_assert] = ACTIONS(6310),
    [anon_sym_precise] = ACTIONS(6310),
    [anon_sym_shared] = ACTIONS(6310),
    [anon_sym_groupshared] = ACTIONS(6310),
    [anon_sym_uniform] = ACTIONS(6310),
    [anon_sym_row_major] = ACTIONS(6310),
    [anon_sym_column_major] = ACTIONS(6310),
    [anon_sym_globallycoherent] = ACTIONS(6310),
    [anon_sym_centroid] = ACTIONS(6310),
    [anon_sym_noperspective] = ACTIONS(6310),
    [anon_sym_nointerpolation] = ACTIONS(6310),
    [anon_sym_sample] = ACTIONS(6310),
    [anon_sym_linear] = ACTIONS(6310),
    [anon_sym_snorm] = ACTIONS(6310),
    [anon_sym_unorm] = ACTIONS(6310),
    [anon_sym_point] = ACTIONS(6310),
    [anon_sym_line] = ACTIONS(6310),
    [anon_sym_triangleadj] = ACTIONS(6310),
    [anon_sym_lineadj] = ACTIONS(6310),
    [anon_sym_triangle] = ACTIONS(6310),
    [anon_sym_interface] = ACTIONS(6310),
    [anon_sym_extension] = ACTIONS(6310),
    [anon_sym___init] = ACTIONS(6310),
    [anon_sym___subscript] = ACTIONS(6310),
    [anon_sym_property] = ACTIONS(6310),
    [anon_sym_associatedtype] = ACTIONS(6310),
  },
  [2150] = {
    [sym_identifier] = ACTIONS(6310),
    [aux_sym_preproc_def_token1] = ACTIONS(6310),
    [aux_sym_preproc_if_token1] = ACTIONS(6310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6310),
    [sym_preproc_directive] = ACTIONS(6310),
    [anon_sym_LPAREN2] = ACTIONS(6312),
    [anon_sym_TILDE] = ACTIONS(6312),
    [anon_sym_STAR] = ACTIONS(6312),
    [anon_sym_AMP_AMP] = ACTIONS(6312),
    [anon_sym_AMP] = ACTIONS(6310),
    [anon_sym_SEMI] = ACTIONS(6312),
    [anon_sym___extension__] = ACTIONS(6310),
    [anon_sym_typedef] = ACTIONS(6310),
    [anon_sym_in] = ACTIONS(6310),
    [anon_sym_out] = ACTIONS(6310),
    [anon_sym_inout] = ACTIONS(6310),
    [anon_sym_virtual] = ACTIONS(6310),
    [anon_sym_extern] = ACTIONS(6310),
    [anon_sym___attribute__] = ACTIONS(6310),
    [anon_sym___attribute] = ACTIONS(6310),
    [anon_sym_using] = ACTIONS(6310),
    [anon_sym_COLON_COLON] = ACTIONS(6312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6312),
    [anon_sym___declspec] = ACTIONS(6310),
    [anon_sym___based] = ACTIONS(6310),
    [anon_sym_RBRACE] = ACTIONS(6312),
    [anon_sym_signed] = ACTIONS(6310),
    [anon_sym_unsigned] = ACTIONS(6310),
    [anon_sym_long] = ACTIONS(6310),
    [anon_sym_short] = ACTIONS(6310),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_static] = ACTIONS(6310),
    [anon_sym_register] = ACTIONS(6310),
    [anon_sym_inline] = ACTIONS(6310),
    [anon_sym___inline] = ACTIONS(6310),
    [anon_sym___inline__] = ACTIONS(6310),
    [anon_sym___forceinline] = ACTIONS(6310),
    [anon_sym_thread_local] = ACTIONS(6310),
    [anon_sym___thread] = ACTIONS(6310),
    [anon_sym_const] = ACTIONS(6310),
    [anon_sym_constexpr] = ACTIONS(6310),
    [anon_sym_volatile] = ACTIONS(6310),
    [anon_sym_restrict] = ACTIONS(6310),
    [anon_sym___restrict__] = ACTIONS(6310),
    [anon_sym__Atomic] = ACTIONS(6310),
    [anon_sym__Noreturn] = ACTIONS(6310),
    [anon_sym_noreturn] = ACTIONS(6310),
    [anon_sym__Nonnull] = ACTIONS(6310),
    [anon_sym_mutable] = ACTIONS(6310),
    [anon_sym_constinit] = ACTIONS(6310),
    [anon_sym_consteval] = ACTIONS(6310),
    [anon_sym_alignas] = ACTIONS(6310),
    [anon_sym__Alignas] = ACTIONS(6310),
    [sym_primitive_type] = ACTIONS(6310),
    [anon_sym_enum] = ACTIONS(6310),
    [anon_sym_class] = ACTIONS(6310),
    [anon_sym_struct] = ACTIONS(6310),
    [anon_sym_union] = ACTIONS(6310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6310),
    [anon_sym_let] = ACTIONS(6310),
    [anon_sym_This] = ACTIONS(6310),
    [anon_sym_decltype] = ACTIONS(6310),
    [anon_sym_explicit] = ACTIONS(6310),
    [anon_sym_typename] = ACTIONS(6310),
    [anon_sym_private] = ACTIONS(6310),
    [anon_sym_template] = ACTIONS(6310),
    [anon_sym_operator] = ACTIONS(6310),
    [anon_sym_friend] = ACTIONS(6310),
    [anon_sym_public] = ACTIONS(6310),
    [anon_sym_protected] = ACTIONS(6310),
    [anon_sym_static_assert] = ACTIONS(6310),
    [anon_sym_precise] = ACTIONS(6310),
    [anon_sym_shared] = ACTIONS(6310),
    [anon_sym_groupshared] = ACTIONS(6310),
    [anon_sym_uniform] = ACTIONS(6310),
    [anon_sym_row_major] = ACTIONS(6310),
    [anon_sym_column_major] = ACTIONS(6310),
    [anon_sym_globallycoherent] = ACTIONS(6310),
    [anon_sym_centroid] = ACTIONS(6310),
    [anon_sym_noperspective] = ACTIONS(6310),
    [anon_sym_nointerpolation] = ACTIONS(6310),
    [anon_sym_sample] = ACTIONS(6310),
    [anon_sym_linear] = ACTIONS(6310),
    [anon_sym_snorm] = ACTIONS(6310),
    [anon_sym_unorm] = ACTIONS(6310),
    [anon_sym_point] = ACTIONS(6310),
    [anon_sym_line] = ACTIONS(6310),
    [anon_sym_triangleadj] = ACTIONS(6310),
    [anon_sym_lineadj] = ACTIONS(6310),
    [anon_sym_triangle] = ACTIONS(6310),
    [anon_sym_interface] = ACTIONS(6310),
    [anon_sym_extension] = ACTIONS(6310),
    [anon_sym___init] = ACTIONS(6310),
    [anon_sym___subscript] = ACTIONS(6310),
    [anon_sym_property] = ACTIONS(6310),
    [anon_sym_associatedtype] = ACTIONS(6310),
  },
  [2151] = {
    [sym_expression] = STATE(5901),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2152] = {
    [sym_identifier] = ACTIONS(3665),
    [aux_sym_preproc_def_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3665),
    [sym_preproc_directive] = ACTIONS(3665),
    [anon_sym_LPAREN2] = ACTIONS(3667),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_STAR] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_SEMI] = ACTIONS(3667),
    [anon_sym___extension__] = ACTIONS(3665),
    [anon_sym_typedef] = ACTIONS(3665),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_out] = ACTIONS(3665),
    [anon_sym_inout] = ACTIONS(3665),
    [anon_sym_virtual] = ACTIONS(3665),
    [anon_sym_extern] = ACTIONS(3665),
    [anon_sym___attribute__] = ACTIONS(3665),
    [anon_sym___attribute] = ACTIONS(3665),
    [anon_sym_using] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(3667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3667),
    [anon_sym___declspec] = ACTIONS(3665),
    [anon_sym___based] = ACTIONS(3665),
    [anon_sym_RBRACE] = ACTIONS(3667),
    [anon_sym_signed] = ACTIONS(3665),
    [anon_sym_unsigned] = ACTIONS(3665),
    [anon_sym_long] = ACTIONS(3665),
    [anon_sym_short] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3665),
    [anon_sym_static] = ACTIONS(3665),
    [anon_sym_register] = ACTIONS(3665),
    [anon_sym_inline] = ACTIONS(3665),
    [anon_sym___inline] = ACTIONS(3665),
    [anon_sym___inline__] = ACTIONS(3665),
    [anon_sym___forceinline] = ACTIONS(3665),
    [anon_sym_thread_local] = ACTIONS(3665),
    [anon_sym___thread] = ACTIONS(3665),
    [anon_sym_const] = ACTIONS(3665),
    [anon_sym_constexpr] = ACTIONS(3665),
    [anon_sym_volatile] = ACTIONS(3665),
    [anon_sym_restrict] = ACTIONS(3665),
    [anon_sym___restrict__] = ACTIONS(3665),
    [anon_sym__Atomic] = ACTIONS(3665),
    [anon_sym__Noreturn] = ACTIONS(3665),
    [anon_sym_noreturn] = ACTIONS(3665),
    [anon_sym__Nonnull] = ACTIONS(3665),
    [anon_sym_mutable] = ACTIONS(3665),
    [anon_sym_constinit] = ACTIONS(3665),
    [anon_sym_consteval] = ACTIONS(3665),
    [anon_sym_alignas] = ACTIONS(3665),
    [anon_sym__Alignas] = ACTIONS(3665),
    [sym_primitive_type] = ACTIONS(3665),
    [anon_sym_enum] = ACTIONS(3665),
    [anon_sym_class] = ACTIONS(3665),
    [anon_sym_struct] = ACTIONS(3665),
    [anon_sym_union] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3665),
    [anon_sym_let] = ACTIONS(3665),
    [anon_sym_This] = ACTIONS(3665),
    [anon_sym_decltype] = ACTIONS(3665),
    [anon_sym_explicit] = ACTIONS(3665),
    [anon_sym_typename] = ACTIONS(3665),
    [anon_sym_private] = ACTIONS(3665),
    [anon_sym_template] = ACTIONS(3665),
    [anon_sym_operator] = ACTIONS(3665),
    [anon_sym_friend] = ACTIONS(3665),
    [anon_sym_public] = ACTIONS(3665),
    [anon_sym_protected] = ACTIONS(3665),
    [anon_sym_static_assert] = ACTIONS(3665),
    [anon_sym_precise] = ACTIONS(3665),
    [anon_sym_shared] = ACTIONS(3665),
    [anon_sym_groupshared] = ACTIONS(3665),
    [anon_sym_uniform] = ACTIONS(3665),
    [anon_sym_row_major] = ACTIONS(3665),
    [anon_sym_column_major] = ACTIONS(3665),
    [anon_sym_globallycoherent] = ACTIONS(3665),
    [anon_sym_centroid] = ACTIONS(3665),
    [anon_sym_noperspective] = ACTIONS(3665),
    [anon_sym_nointerpolation] = ACTIONS(3665),
    [anon_sym_sample] = ACTIONS(3665),
    [anon_sym_linear] = ACTIONS(3665),
    [anon_sym_snorm] = ACTIONS(3665),
    [anon_sym_unorm] = ACTIONS(3665),
    [anon_sym_point] = ACTIONS(3665),
    [anon_sym_line] = ACTIONS(3665),
    [anon_sym_triangleadj] = ACTIONS(3665),
    [anon_sym_lineadj] = ACTIONS(3665),
    [anon_sym_triangle] = ACTIONS(3665),
    [anon_sym_interface] = ACTIONS(3665),
    [anon_sym_extension] = ACTIONS(3665),
    [anon_sym___init] = ACTIONS(3665),
    [anon_sym___subscript] = ACTIONS(3665),
    [anon_sym_property] = ACTIONS(3665),
    [anon_sym_associatedtype] = ACTIONS(3665),
  },
  [2153] = {
    [sym_expression] = STATE(5676),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2154] = {
    [sym_expression] = STATE(5961),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2155] = {
    [sym_expression] = STATE(4787),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(6662),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [2156] = {
    [sym_expression] = STATE(4789),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [2157] = {
    [sym_expression] = STATE(4662),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(6664),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [2158] = {
    [sym_expression] = STATE(4229),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(6666),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [2159] = {
    [sym_expression] = STATE(4249),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [2160] = {
    [sym_identifier] = ACTIONS(3828),
    [aux_sym_preproc_def_token1] = ACTIONS(3828),
    [aux_sym_preproc_if_token1] = ACTIONS(3828),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3828),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3828),
    [sym_preproc_directive] = ACTIONS(3828),
    [anon_sym_LPAREN2] = ACTIONS(3830),
    [anon_sym_TILDE] = ACTIONS(3830),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_SEMI] = ACTIONS(3830),
    [anon_sym___extension__] = ACTIONS(3828),
    [anon_sym_typedef] = ACTIONS(3828),
    [anon_sym_in] = ACTIONS(3828),
    [anon_sym_out] = ACTIONS(3828),
    [anon_sym_inout] = ACTIONS(3828),
    [anon_sym_virtual] = ACTIONS(3828),
    [anon_sym_extern] = ACTIONS(3828),
    [anon_sym___attribute__] = ACTIONS(3828),
    [anon_sym___attribute] = ACTIONS(3828),
    [anon_sym_using] = ACTIONS(3828),
    [anon_sym_COLON_COLON] = ACTIONS(3830),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3830),
    [anon_sym___declspec] = ACTIONS(3828),
    [anon_sym___based] = ACTIONS(3828),
    [anon_sym_RBRACE] = ACTIONS(3830),
    [anon_sym_signed] = ACTIONS(3828),
    [anon_sym_unsigned] = ACTIONS(3828),
    [anon_sym_long] = ACTIONS(3828),
    [anon_sym_short] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_static] = ACTIONS(3828),
    [anon_sym_register] = ACTIONS(3828),
    [anon_sym_inline] = ACTIONS(3828),
    [anon_sym___inline] = ACTIONS(3828),
    [anon_sym___inline__] = ACTIONS(3828),
    [anon_sym___forceinline] = ACTIONS(3828),
    [anon_sym_thread_local] = ACTIONS(3828),
    [anon_sym___thread] = ACTIONS(3828),
    [anon_sym_const] = ACTIONS(3828),
    [anon_sym_constexpr] = ACTIONS(3828),
    [anon_sym_volatile] = ACTIONS(3828),
    [anon_sym_restrict] = ACTIONS(3828),
    [anon_sym___restrict__] = ACTIONS(3828),
    [anon_sym__Atomic] = ACTIONS(3828),
    [anon_sym__Noreturn] = ACTIONS(3828),
    [anon_sym_noreturn] = ACTIONS(3828),
    [anon_sym__Nonnull] = ACTIONS(3828),
    [anon_sym_mutable] = ACTIONS(3828),
    [anon_sym_constinit] = ACTIONS(3828),
    [anon_sym_consteval] = ACTIONS(3828),
    [anon_sym_alignas] = ACTIONS(3828),
    [anon_sym__Alignas] = ACTIONS(3828),
    [sym_primitive_type] = ACTIONS(3828),
    [anon_sym_enum] = ACTIONS(3828),
    [anon_sym_class] = ACTIONS(3828),
    [anon_sym_struct] = ACTIONS(3828),
    [anon_sym_union] = ACTIONS(3828),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_This] = ACTIONS(3828),
    [anon_sym_decltype] = ACTIONS(3828),
    [anon_sym_explicit] = ACTIONS(3828),
    [anon_sym_typename] = ACTIONS(3828),
    [anon_sym_private] = ACTIONS(3828),
    [anon_sym_template] = ACTIONS(3828),
    [anon_sym_operator] = ACTIONS(3828),
    [anon_sym_friend] = ACTIONS(3828),
    [anon_sym_public] = ACTIONS(3828),
    [anon_sym_protected] = ACTIONS(3828),
    [anon_sym_static_assert] = ACTIONS(3828),
    [anon_sym_precise] = ACTIONS(3828),
    [anon_sym_shared] = ACTIONS(3828),
    [anon_sym_groupshared] = ACTIONS(3828),
    [anon_sym_uniform] = ACTIONS(3828),
    [anon_sym_row_major] = ACTIONS(3828),
    [anon_sym_column_major] = ACTIONS(3828),
    [anon_sym_globallycoherent] = ACTIONS(3828),
    [anon_sym_centroid] = ACTIONS(3828),
    [anon_sym_noperspective] = ACTIONS(3828),
    [anon_sym_nointerpolation] = ACTIONS(3828),
    [anon_sym_sample] = ACTIONS(3828),
    [anon_sym_linear] = ACTIONS(3828),
    [anon_sym_snorm] = ACTIONS(3828),
    [anon_sym_unorm] = ACTIONS(3828),
    [anon_sym_point] = ACTIONS(3828),
    [anon_sym_line] = ACTIONS(3828),
    [anon_sym_triangleadj] = ACTIONS(3828),
    [anon_sym_lineadj] = ACTIONS(3828),
    [anon_sym_triangle] = ACTIONS(3828),
    [anon_sym_interface] = ACTIONS(3828),
    [anon_sym_extension] = ACTIONS(3828),
    [anon_sym___init] = ACTIONS(3828),
    [anon_sym___subscript] = ACTIONS(3828),
    [anon_sym_property] = ACTIONS(3828),
    [anon_sym_associatedtype] = ACTIONS(3828),
  },
  [2161] = {
    [sym_expression] = STATE(4784),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [2162] = {
    [sym_expression] = STATE(4246),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [2163] = {
    [sym_expression] = STATE(3773),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2164] = {
    [sym_expression] = STATE(5379),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2165] = {
    [sym_expression] = STATE(4176),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(6668),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [2166] = {
    [sym_identifier] = ACTIONS(3677),
    [aux_sym_preproc_def_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3677),
    [sym_preproc_directive] = ACTIONS(3677),
    [anon_sym_LPAREN2] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3679),
    [anon_sym_STAR] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_AMP] = ACTIONS(3677),
    [anon_sym_SEMI] = ACTIONS(3679),
    [anon_sym___extension__] = ACTIONS(3677),
    [anon_sym_typedef] = ACTIONS(3677),
    [anon_sym_in] = ACTIONS(3677),
    [anon_sym_out] = ACTIONS(3677),
    [anon_sym_inout] = ACTIONS(3677),
    [anon_sym_virtual] = ACTIONS(3677),
    [anon_sym_extern] = ACTIONS(3677),
    [anon_sym___attribute__] = ACTIONS(3677),
    [anon_sym___attribute] = ACTIONS(3677),
    [anon_sym_using] = ACTIONS(3677),
    [anon_sym_COLON_COLON] = ACTIONS(3679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3679),
    [anon_sym___declspec] = ACTIONS(3677),
    [anon_sym___based] = ACTIONS(3677),
    [anon_sym_RBRACE] = ACTIONS(3679),
    [anon_sym_signed] = ACTIONS(3677),
    [anon_sym_unsigned] = ACTIONS(3677),
    [anon_sym_long] = ACTIONS(3677),
    [anon_sym_short] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3677),
    [anon_sym_static] = ACTIONS(3677),
    [anon_sym_register] = ACTIONS(3677),
    [anon_sym_inline] = ACTIONS(3677),
    [anon_sym___inline] = ACTIONS(3677),
    [anon_sym___inline__] = ACTIONS(3677),
    [anon_sym___forceinline] = ACTIONS(3677),
    [anon_sym_thread_local] = ACTIONS(3677),
    [anon_sym___thread] = ACTIONS(3677),
    [anon_sym_const] = ACTIONS(3677),
    [anon_sym_constexpr] = ACTIONS(3677),
    [anon_sym_volatile] = ACTIONS(3677),
    [anon_sym_restrict] = ACTIONS(3677),
    [anon_sym___restrict__] = ACTIONS(3677),
    [anon_sym__Atomic] = ACTIONS(3677),
    [anon_sym__Noreturn] = ACTIONS(3677),
    [anon_sym_noreturn] = ACTIONS(3677),
    [anon_sym__Nonnull] = ACTIONS(3677),
    [anon_sym_mutable] = ACTIONS(3677),
    [anon_sym_constinit] = ACTIONS(3677),
    [anon_sym_consteval] = ACTIONS(3677),
    [anon_sym_alignas] = ACTIONS(3677),
    [anon_sym__Alignas] = ACTIONS(3677),
    [sym_primitive_type] = ACTIONS(3677),
    [anon_sym_enum] = ACTIONS(3677),
    [anon_sym_class] = ACTIONS(3677),
    [anon_sym_struct] = ACTIONS(3677),
    [anon_sym_union] = ACTIONS(3677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3677),
    [anon_sym_let] = ACTIONS(3677),
    [anon_sym_This] = ACTIONS(3677),
    [anon_sym_decltype] = ACTIONS(3677),
    [anon_sym_explicit] = ACTIONS(3677),
    [anon_sym_typename] = ACTIONS(3677),
    [anon_sym_private] = ACTIONS(3677),
    [anon_sym_template] = ACTIONS(3677),
    [anon_sym_operator] = ACTIONS(3677),
    [anon_sym_friend] = ACTIONS(3677),
    [anon_sym_public] = ACTIONS(3677),
    [anon_sym_protected] = ACTIONS(3677),
    [anon_sym_static_assert] = ACTIONS(3677),
    [anon_sym_precise] = ACTIONS(3677),
    [anon_sym_shared] = ACTIONS(3677),
    [anon_sym_groupshared] = ACTIONS(3677),
    [anon_sym_uniform] = ACTIONS(3677),
    [anon_sym_row_major] = ACTIONS(3677),
    [anon_sym_column_major] = ACTIONS(3677),
    [anon_sym_globallycoherent] = ACTIONS(3677),
    [anon_sym_centroid] = ACTIONS(3677),
    [anon_sym_noperspective] = ACTIONS(3677),
    [anon_sym_nointerpolation] = ACTIONS(3677),
    [anon_sym_sample] = ACTIONS(3677),
    [anon_sym_linear] = ACTIONS(3677),
    [anon_sym_snorm] = ACTIONS(3677),
    [anon_sym_unorm] = ACTIONS(3677),
    [anon_sym_point] = ACTIONS(3677),
    [anon_sym_line] = ACTIONS(3677),
    [anon_sym_triangleadj] = ACTIONS(3677),
    [anon_sym_lineadj] = ACTIONS(3677),
    [anon_sym_triangle] = ACTIONS(3677),
    [anon_sym_interface] = ACTIONS(3677),
    [anon_sym_extension] = ACTIONS(3677),
    [anon_sym___init] = ACTIONS(3677),
    [anon_sym___subscript] = ACTIONS(3677),
    [anon_sym_property] = ACTIONS(3677),
    [anon_sym_associatedtype] = ACTIONS(3677),
  },
  [2167] = {
    [sym_identifier] = ACTIONS(3677),
    [aux_sym_preproc_def_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3677),
    [sym_preproc_directive] = ACTIONS(3677),
    [anon_sym_LPAREN2] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3679),
    [anon_sym_STAR] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_AMP] = ACTIONS(3677),
    [anon_sym_SEMI] = ACTIONS(3679),
    [anon_sym___extension__] = ACTIONS(3677),
    [anon_sym_typedef] = ACTIONS(3677),
    [anon_sym_in] = ACTIONS(3677),
    [anon_sym_out] = ACTIONS(3677),
    [anon_sym_inout] = ACTIONS(3677),
    [anon_sym_virtual] = ACTIONS(3677),
    [anon_sym_extern] = ACTIONS(3677),
    [anon_sym___attribute__] = ACTIONS(3677),
    [anon_sym___attribute] = ACTIONS(3677),
    [anon_sym_using] = ACTIONS(3677),
    [anon_sym_COLON_COLON] = ACTIONS(3679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3679),
    [anon_sym___declspec] = ACTIONS(3677),
    [anon_sym___based] = ACTIONS(3677),
    [anon_sym_RBRACE] = ACTIONS(3679),
    [anon_sym_signed] = ACTIONS(3677),
    [anon_sym_unsigned] = ACTIONS(3677),
    [anon_sym_long] = ACTIONS(3677),
    [anon_sym_short] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3677),
    [anon_sym_static] = ACTIONS(3677),
    [anon_sym_register] = ACTIONS(3677),
    [anon_sym_inline] = ACTIONS(3677),
    [anon_sym___inline] = ACTIONS(3677),
    [anon_sym___inline__] = ACTIONS(3677),
    [anon_sym___forceinline] = ACTIONS(3677),
    [anon_sym_thread_local] = ACTIONS(3677),
    [anon_sym___thread] = ACTIONS(3677),
    [anon_sym_const] = ACTIONS(3677),
    [anon_sym_constexpr] = ACTIONS(3677),
    [anon_sym_volatile] = ACTIONS(3677),
    [anon_sym_restrict] = ACTIONS(3677),
    [anon_sym___restrict__] = ACTIONS(3677),
    [anon_sym__Atomic] = ACTIONS(3677),
    [anon_sym__Noreturn] = ACTIONS(3677),
    [anon_sym_noreturn] = ACTIONS(3677),
    [anon_sym__Nonnull] = ACTIONS(3677),
    [anon_sym_mutable] = ACTIONS(3677),
    [anon_sym_constinit] = ACTIONS(3677),
    [anon_sym_consteval] = ACTIONS(3677),
    [anon_sym_alignas] = ACTIONS(3677),
    [anon_sym__Alignas] = ACTIONS(3677),
    [sym_primitive_type] = ACTIONS(3677),
    [anon_sym_enum] = ACTIONS(3677),
    [anon_sym_class] = ACTIONS(3677),
    [anon_sym_struct] = ACTIONS(3677),
    [anon_sym_union] = ACTIONS(3677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3677),
    [anon_sym_let] = ACTIONS(3677),
    [anon_sym_This] = ACTIONS(3677),
    [anon_sym_decltype] = ACTIONS(3677),
    [anon_sym_explicit] = ACTIONS(3677),
    [anon_sym_typename] = ACTIONS(3677),
    [anon_sym_private] = ACTIONS(3677),
    [anon_sym_template] = ACTIONS(3677),
    [anon_sym_operator] = ACTIONS(3677),
    [anon_sym_friend] = ACTIONS(3677),
    [anon_sym_public] = ACTIONS(3677),
    [anon_sym_protected] = ACTIONS(3677),
    [anon_sym_static_assert] = ACTIONS(3677),
    [anon_sym_precise] = ACTIONS(3677),
    [anon_sym_shared] = ACTIONS(3677),
    [anon_sym_groupshared] = ACTIONS(3677),
    [anon_sym_uniform] = ACTIONS(3677),
    [anon_sym_row_major] = ACTIONS(3677),
    [anon_sym_column_major] = ACTIONS(3677),
    [anon_sym_globallycoherent] = ACTIONS(3677),
    [anon_sym_centroid] = ACTIONS(3677),
    [anon_sym_noperspective] = ACTIONS(3677),
    [anon_sym_nointerpolation] = ACTIONS(3677),
    [anon_sym_sample] = ACTIONS(3677),
    [anon_sym_linear] = ACTIONS(3677),
    [anon_sym_snorm] = ACTIONS(3677),
    [anon_sym_unorm] = ACTIONS(3677),
    [anon_sym_point] = ACTIONS(3677),
    [anon_sym_line] = ACTIONS(3677),
    [anon_sym_triangleadj] = ACTIONS(3677),
    [anon_sym_lineadj] = ACTIONS(3677),
    [anon_sym_triangle] = ACTIONS(3677),
    [anon_sym_interface] = ACTIONS(3677),
    [anon_sym_extension] = ACTIONS(3677),
    [anon_sym___init] = ACTIONS(3677),
    [anon_sym___subscript] = ACTIONS(3677),
    [anon_sym_property] = ACTIONS(3677),
    [anon_sym_associatedtype] = ACTIONS(3677),
  },
  [2168] = {
    [sym_expression] = STATE(4691),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [2169] = {
    [sym_identifier] = ACTIONS(3792),
    [aux_sym_preproc_def_token1] = ACTIONS(3792),
    [aux_sym_preproc_if_token1] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3792),
    [sym_preproc_directive] = ACTIONS(3792),
    [anon_sym_LPAREN2] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3794),
    [anon_sym_STAR] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_AMP] = ACTIONS(3792),
    [anon_sym_SEMI] = ACTIONS(3794),
    [anon_sym___extension__] = ACTIONS(3792),
    [anon_sym_typedef] = ACTIONS(3792),
    [anon_sym_in] = ACTIONS(3792),
    [anon_sym_out] = ACTIONS(3792),
    [anon_sym_inout] = ACTIONS(3792),
    [anon_sym_virtual] = ACTIONS(3792),
    [anon_sym_extern] = ACTIONS(3792),
    [anon_sym___attribute__] = ACTIONS(3792),
    [anon_sym___attribute] = ACTIONS(3792),
    [anon_sym_using] = ACTIONS(3792),
    [anon_sym_COLON_COLON] = ACTIONS(3794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3794),
    [anon_sym___declspec] = ACTIONS(3792),
    [anon_sym___based] = ACTIONS(3792),
    [anon_sym_RBRACE] = ACTIONS(3794),
    [anon_sym_signed] = ACTIONS(3792),
    [anon_sym_unsigned] = ACTIONS(3792),
    [anon_sym_long] = ACTIONS(3792),
    [anon_sym_short] = ACTIONS(3792),
    [anon_sym_LBRACK] = ACTIONS(3792),
    [anon_sym_static] = ACTIONS(3792),
    [anon_sym_register] = ACTIONS(3792),
    [anon_sym_inline] = ACTIONS(3792),
    [anon_sym___inline] = ACTIONS(3792),
    [anon_sym___inline__] = ACTIONS(3792),
    [anon_sym___forceinline] = ACTIONS(3792),
    [anon_sym_thread_local] = ACTIONS(3792),
    [anon_sym___thread] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3792),
    [anon_sym_constexpr] = ACTIONS(3792),
    [anon_sym_volatile] = ACTIONS(3792),
    [anon_sym_restrict] = ACTIONS(3792),
    [anon_sym___restrict__] = ACTIONS(3792),
    [anon_sym__Atomic] = ACTIONS(3792),
    [anon_sym__Noreturn] = ACTIONS(3792),
    [anon_sym_noreturn] = ACTIONS(3792),
    [anon_sym__Nonnull] = ACTIONS(3792),
    [anon_sym_mutable] = ACTIONS(3792),
    [anon_sym_constinit] = ACTIONS(3792),
    [anon_sym_consteval] = ACTIONS(3792),
    [anon_sym_alignas] = ACTIONS(3792),
    [anon_sym__Alignas] = ACTIONS(3792),
    [sym_primitive_type] = ACTIONS(3792),
    [anon_sym_enum] = ACTIONS(3792),
    [anon_sym_class] = ACTIONS(3792),
    [anon_sym_struct] = ACTIONS(3792),
    [anon_sym_union] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3792),
    [anon_sym_let] = ACTIONS(3792),
    [anon_sym_This] = ACTIONS(3792),
    [anon_sym_decltype] = ACTIONS(3792),
    [anon_sym_explicit] = ACTIONS(3792),
    [anon_sym_typename] = ACTIONS(3792),
    [anon_sym_private] = ACTIONS(3792),
    [anon_sym_template] = ACTIONS(3792),
    [anon_sym_operator] = ACTIONS(3792),
    [anon_sym_friend] = ACTIONS(3792),
    [anon_sym_public] = ACTIONS(3792),
    [anon_sym_protected] = ACTIONS(3792),
    [anon_sym_static_assert] = ACTIONS(3792),
    [anon_sym_precise] = ACTIONS(3792),
    [anon_sym_shared] = ACTIONS(3792),
    [anon_sym_groupshared] = ACTIONS(3792),
    [anon_sym_uniform] = ACTIONS(3792),
    [anon_sym_row_major] = ACTIONS(3792),
    [anon_sym_column_major] = ACTIONS(3792),
    [anon_sym_globallycoherent] = ACTIONS(3792),
    [anon_sym_centroid] = ACTIONS(3792),
    [anon_sym_noperspective] = ACTIONS(3792),
    [anon_sym_nointerpolation] = ACTIONS(3792),
    [anon_sym_sample] = ACTIONS(3792),
    [anon_sym_linear] = ACTIONS(3792),
    [anon_sym_snorm] = ACTIONS(3792),
    [anon_sym_unorm] = ACTIONS(3792),
    [anon_sym_point] = ACTIONS(3792),
    [anon_sym_line] = ACTIONS(3792),
    [anon_sym_triangleadj] = ACTIONS(3792),
    [anon_sym_lineadj] = ACTIONS(3792),
    [anon_sym_triangle] = ACTIONS(3792),
    [anon_sym_interface] = ACTIONS(3792),
    [anon_sym_extension] = ACTIONS(3792),
    [anon_sym___init] = ACTIONS(3792),
    [anon_sym___subscript] = ACTIONS(3792),
    [anon_sym_property] = ACTIONS(3792),
    [anon_sym_associatedtype] = ACTIONS(3792),
  },
  [2170] = {
    [sym_identifier] = ACTIONS(3792),
    [aux_sym_preproc_def_token1] = ACTIONS(3792),
    [aux_sym_preproc_if_token1] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3792),
    [sym_preproc_directive] = ACTIONS(3792),
    [anon_sym_LPAREN2] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3794),
    [anon_sym_STAR] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_AMP] = ACTIONS(3792),
    [anon_sym_SEMI] = ACTIONS(3794),
    [anon_sym___extension__] = ACTIONS(3792),
    [anon_sym_typedef] = ACTIONS(3792),
    [anon_sym_in] = ACTIONS(3792),
    [anon_sym_out] = ACTIONS(3792),
    [anon_sym_inout] = ACTIONS(3792),
    [anon_sym_virtual] = ACTIONS(3792),
    [anon_sym_extern] = ACTIONS(3792),
    [anon_sym___attribute__] = ACTIONS(3792),
    [anon_sym___attribute] = ACTIONS(3792),
    [anon_sym_using] = ACTIONS(3792),
    [anon_sym_COLON_COLON] = ACTIONS(3794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3794),
    [anon_sym___declspec] = ACTIONS(3792),
    [anon_sym___based] = ACTIONS(3792),
    [anon_sym_RBRACE] = ACTIONS(3794),
    [anon_sym_signed] = ACTIONS(3792),
    [anon_sym_unsigned] = ACTIONS(3792),
    [anon_sym_long] = ACTIONS(3792),
    [anon_sym_short] = ACTIONS(3792),
    [anon_sym_LBRACK] = ACTIONS(3792),
    [anon_sym_static] = ACTIONS(3792),
    [anon_sym_register] = ACTIONS(3792),
    [anon_sym_inline] = ACTIONS(3792),
    [anon_sym___inline] = ACTIONS(3792),
    [anon_sym___inline__] = ACTIONS(3792),
    [anon_sym___forceinline] = ACTIONS(3792),
    [anon_sym_thread_local] = ACTIONS(3792),
    [anon_sym___thread] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3792),
    [anon_sym_constexpr] = ACTIONS(3792),
    [anon_sym_volatile] = ACTIONS(3792),
    [anon_sym_restrict] = ACTIONS(3792),
    [anon_sym___restrict__] = ACTIONS(3792),
    [anon_sym__Atomic] = ACTIONS(3792),
    [anon_sym__Noreturn] = ACTIONS(3792),
    [anon_sym_noreturn] = ACTIONS(3792),
    [anon_sym__Nonnull] = ACTIONS(3792),
    [anon_sym_mutable] = ACTIONS(3792),
    [anon_sym_constinit] = ACTIONS(3792),
    [anon_sym_consteval] = ACTIONS(3792),
    [anon_sym_alignas] = ACTIONS(3792),
    [anon_sym__Alignas] = ACTIONS(3792),
    [sym_primitive_type] = ACTIONS(3792),
    [anon_sym_enum] = ACTIONS(3792),
    [anon_sym_class] = ACTIONS(3792),
    [anon_sym_struct] = ACTIONS(3792),
    [anon_sym_union] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3792),
    [anon_sym_let] = ACTIONS(3792),
    [anon_sym_This] = ACTIONS(3792),
    [anon_sym_decltype] = ACTIONS(3792),
    [anon_sym_explicit] = ACTIONS(3792),
    [anon_sym_typename] = ACTIONS(3792),
    [anon_sym_private] = ACTIONS(3792),
    [anon_sym_template] = ACTIONS(3792),
    [anon_sym_operator] = ACTIONS(3792),
    [anon_sym_friend] = ACTIONS(3792),
    [anon_sym_public] = ACTIONS(3792),
    [anon_sym_protected] = ACTIONS(3792),
    [anon_sym_static_assert] = ACTIONS(3792),
    [anon_sym_precise] = ACTIONS(3792),
    [anon_sym_shared] = ACTIONS(3792),
    [anon_sym_groupshared] = ACTIONS(3792),
    [anon_sym_uniform] = ACTIONS(3792),
    [anon_sym_row_major] = ACTIONS(3792),
    [anon_sym_column_major] = ACTIONS(3792),
    [anon_sym_globallycoherent] = ACTIONS(3792),
    [anon_sym_centroid] = ACTIONS(3792),
    [anon_sym_noperspective] = ACTIONS(3792),
    [anon_sym_nointerpolation] = ACTIONS(3792),
    [anon_sym_sample] = ACTIONS(3792),
    [anon_sym_linear] = ACTIONS(3792),
    [anon_sym_snorm] = ACTIONS(3792),
    [anon_sym_unorm] = ACTIONS(3792),
    [anon_sym_point] = ACTIONS(3792),
    [anon_sym_line] = ACTIONS(3792),
    [anon_sym_triangleadj] = ACTIONS(3792),
    [anon_sym_lineadj] = ACTIONS(3792),
    [anon_sym_triangle] = ACTIONS(3792),
    [anon_sym_interface] = ACTIONS(3792),
    [anon_sym_extension] = ACTIONS(3792),
    [anon_sym___init] = ACTIONS(3792),
    [anon_sym___subscript] = ACTIONS(3792),
    [anon_sym_property] = ACTIONS(3792),
    [anon_sym_associatedtype] = ACTIONS(3792),
  },
  [2171] = {
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym_RBRACE] = ACTIONS(3814),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_private] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_friend] = ACTIONS(3812),
    [anon_sym_public] = ACTIONS(3812),
    [anon_sym_protected] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
    [anon_sym___init] = ACTIONS(3812),
    [anon_sym___subscript] = ACTIONS(3812),
    [anon_sym_property] = ACTIONS(3812),
    [anon_sym_associatedtype] = ACTIONS(3812),
  },
  [2172] = {
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym_RBRACE] = ACTIONS(3814),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_private] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_friend] = ACTIONS(3812),
    [anon_sym_public] = ACTIONS(3812),
    [anon_sym_protected] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
    [anon_sym___init] = ACTIONS(3812),
    [anon_sym___subscript] = ACTIONS(3812),
    [anon_sym_property] = ACTIONS(3812),
    [anon_sym_associatedtype] = ACTIONS(3812),
  },
  [2173] = {
    [sym_expression] = STATE(4714),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [2174] = {
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym_RBRACE] = ACTIONS(3814),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_private] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_friend] = ACTIONS(3812),
    [anon_sym_public] = ACTIONS(3812),
    [anon_sym_protected] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
    [anon_sym___init] = ACTIONS(3812),
    [anon_sym___subscript] = ACTIONS(3812),
    [anon_sym_property] = ACTIONS(3812),
    [anon_sym_associatedtype] = ACTIONS(3812),
  },
  [2175] = {
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym_RBRACE] = ACTIONS(3814),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_private] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_friend] = ACTIONS(3812),
    [anon_sym_public] = ACTIONS(3812),
    [anon_sym_protected] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
    [anon_sym___init] = ACTIONS(3812),
    [anon_sym___subscript] = ACTIONS(3812),
    [anon_sym_property] = ACTIONS(3812),
    [anon_sym_associatedtype] = ACTIONS(3812),
  },
  [2176] = {
    [sym_expression] = STATE(3761),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2177] = {
    [sym_expression] = STATE(3350),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2178] = {
    [sym_expression] = STATE(3762),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2179] = {
    [sym_expression] = STATE(3763),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2180] = {
    [sym_expression] = STATE(3764),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2181] = {
    [sym_expression] = STATE(3769),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2182] = {
    [sym_expression] = STATE(3771),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2183] = {
    [sym_expression] = STATE(3772),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2184] = {
    [sym_expression] = STATE(3775),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2185] = {
    [sym_expression] = STATE(3781),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2186] = {
    [sym_expression] = STATE(4303),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [2187] = {
    [sym_identifier] = ACTIONS(3935),
    [aux_sym_preproc_def_token1] = ACTIONS(3935),
    [aux_sym_preproc_if_token1] = ACTIONS(3935),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3935),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3935),
    [sym_preproc_directive] = ACTIONS(3935),
    [anon_sym_LPAREN2] = ACTIONS(3937),
    [anon_sym_TILDE] = ACTIONS(3937),
    [anon_sym_STAR] = ACTIONS(3937),
    [anon_sym_AMP_AMP] = ACTIONS(3937),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_SEMI] = ACTIONS(3937),
    [anon_sym___extension__] = ACTIONS(3935),
    [anon_sym_typedef] = ACTIONS(3935),
    [anon_sym_in] = ACTIONS(3935),
    [anon_sym_out] = ACTIONS(3935),
    [anon_sym_inout] = ACTIONS(3935),
    [anon_sym_virtual] = ACTIONS(3935),
    [anon_sym_extern] = ACTIONS(3935),
    [anon_sym___attribute__] = ACTIONS(3935),
    [anon_sym___attribute] = ACTIONS(3935),
    [anon_sym_using] = ACTIONS(3935),
    [anon_sym_COLON_COLON] = ACTIONS(3937),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3937),
    [anon_sym___declspec] = ACTIONS(3935),
    [anon_sym___based] = ACTIONS(3935),
    [anon_sym_RBRACE] = ACTIONS(3937),
    [anon_sym_signed] = ACTIONS(3935),
    [anon_sym_unsigned] = ACTIONS(3935),
    [anon_sym_long] = ACTIONS(3935),
    [anon_sym_short] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3935),
    [anon_sym_static] = ACTIONS(3935),
    [anon_sym_register] = ACTIONS(3935),
    [anon_sym_inline] = ACTIONS(3935),
    [anon_sym___inline] = ACTIONS(3935),
    [anon_sym___inline__] = ACTIONS(3935),
    [anon_sym___forceinline] = ACTIONS(3935),
    [anon_sym_thread_local] = ACTIONS(3935),
    [anon_sym___thread] = ACTIONS(3935),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_constexpr] = ACTIONS(3935),
    [anon_sym_volatile] = ACTIONS(3935),
    [anon_sym_restrict] = ACTIONS(3935),
    [anon_sym___restrict__] = ACTIONS(3935),
    [anon_sym__Atomic] = ACTIONS(3935),
    [anon_sym__Noreturn] = ACTIONS(3935),
    [anon_sym_noreturn] = ACTIONS(3935),
    [anon_sym__Nonnull] = ACTIONS(3935),
    [anon_sym_mutable] = ACTIONS(3935),
    [anon_sym_constinit] = ACTIONS(3935),
    [anon_sym_consteval] = ACTIONS(3935),
    [anon_sym_alignas] = ACTIONS(3935),
    [anon_sym__Alignas] = ACTIONS(3935),
    [sym_primitive_type] = ACTIONS(3935),
    [anon_sym_enum] = ACTIONS(3935),
    [anon_sym_class] = ACTIONS(3935),
    [anon_sym_struct] = ACTIONS(3935),
    [anon_sym_union] = ACTIONS(3935),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3935),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_This] = ACTIONS(3935),
    [anon_sym_decltype] = ACTIONS(3935),
    [anon_sym_explicit] = ACTIONS(3935),
    [anon_sym_typename] = ACTIONS(3935),
    [anon_sym_private] = ACTIONS(3935),
    [anon_sym_template] = ACTIONS(3935),
    [anon_sym_operator] = ACTIONS(3935),
    [anon_sym_friend] = ACTIONS(3935),
    [anon_sym_public] = ACTIONS(3935),
    [anon_sym_protected] = ACTIONS(3935),
    [anon_sym_static_assert] = ACTIONS(3935),
    [anon_sym_precise] = ACTIONS(3935),
    [anon_sym_shared] = ACTIONS(3935),
    [anon_sym_groupshared] = ACTIONS(3935),
    [anon_sym_uniform] = ACTIONS(3935),
    [anon_sym_row_major] = ACTIONS(3935),
    [anon_sym_column_major] = ACTIONS(3935),
    [anon_sym_globallycoherent] = ACTIONS(3935),
    [anon_sym_centroid] = ACTIONS(3935),
    [anon_sym_noperspective] = ACTIONS(3935),
    [anon_sym_nointerpolation] = ACTIONS(3935),
    [anon_sym_sample] = ACTIONS(3935),
    [anon_sym_linear] = ACTIONS(3935),
    [anon_sym_snorm] = ACTIONS(3935),
    [anon_sym_unorm] = ACTIONS(3935),
    [anon_sym_point] = ACTIONS(3935),
    [anon_sym_line] = ACTIONS(3935),
    [anon_sym_triangleadj] = ACTIONS(3935),
    [anon_sym_lineadj] = ACTIONS(3935),
    [anon_sym_triangle] = ACTIONS(3935),
    [anon_sym_interface] = ACTIONS(3935),
    [anon_sym_extension] = ACTIONS(3935),
    [anon_sym___init] = ACTIONS(3935),
    [anon_sym___subscript] = ACTIONS(3935),
    [anon_sym_property] = ACTIONS(3935),
    [anon_sym_associatedtype] = ACTIONS(3935),
  },
  [2188] = {
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym_RBRACE] = ACTIONS(3944),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_private] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_friend] = ACTIONS(3942),
    [anon_sym_public] = ACTIONS(3942),
    [anon_sym_protected] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
    [anon_sym___init] = ACTIONS(3942),
    [anon_sym___subscript] = ACTIONS(3942),
    [anon_sym_property] = ACTIONS(3942),
    [anon_sym_associatedtype] = ACTIONS(3942),
  },
  [2189] = {
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym_RBRACE] = ACTIONS(3944),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_private] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_friend] = ACTIONS(3942),
    [anon_sym_public] = ACTIONS(3942),
    [anon_sym_protected] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
    [anon_sym___init] = ACTIONS(3942),
    [anon_sym___subscript] = ACTIONS(3942),
    [anon_sym_property] = ACTIONS(3942),
    [anon_sym_associatedtype] = ACTIONS(3942),
  },
  [2190] = {
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym_RBRACE] = ACTIONS(3944),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_private] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_friend] = ACTIONS(3942),
    [anon_sym_public] = ACTIONS(3942),
    [anon_sym_protected] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
    [anon_sym___init] = ACTIONS(3942),
    [anon_sym___subscript] = ACTIONS(3942),
    [anon_sym_property] = ACTIONS(3942),
    [anon_sym_associatedtype] = ACTIONS(3942),
  },
  [2191] = {
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym_RBRACE] = ACTIONS(3944),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_private] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_friend] = ACTIONS(3942),
    [anon_sym_public] = ACTIONS(3942),
    [anon_sym_protected] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
    [anon_sym___init] = ACTIONS(3942),
    [anon_sym___subscript] = ACTIONS(3942),
    [anon_sym_property] = ACTIONS(3942),
    [anon_sym_associatedtype] = ACTIONS(3942),
  },
  [2192] = {
    [sym_identifier] = ACTIONS(3953),
    [aux_sym_preproc_def_token1] = ACTIONS(3953),
    [aux_sym_preproc_if_token1] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3953),
    [sym_preproc_directive] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_TILDE] = ACTIONS(3955),
    [anon_sym_STAR] = ACTIONS(3955),
    [anon_sym_AMP_AMP] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_SEMI] = ACTIONS(3955),
    [anon_sym___extension__] = ACTIONS(3953),
    [anon_sym_typedef] = ACTIONS(3953),
    [anon_sym_in] = ACTIONS(3953),
    [anon_sym_out] = ACTIONS(3953),
    [anon_sym_inout] = ACTIONS(3953),
    [anon_sym_virtual] = ACTIONS(3953),
    [anon_sym_extern] = ACTIONS(3953),
    [anon_sym___attribute__] = ACTIONS(3953),
    [anon_sym___attribute] = ACTIONS(3953),
    [anon_sym_using] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3955),
    [anon_sym___declspec] = ACTIONS(3953),
    [anon_sym___based] = ACTIONS(3953),
    [anon_sym_RBRACE] = ACTIONS(3955),
    [anon_sym_signed] = ACTIONS(3953),
    [anon_sym_unsigned] = ACTIONS(3953),
    [anon_sym_long] = ACTIONS(3953),
    [anon_sym_short] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_static] = ACTIONS(3953),
    [anon_sym_register] = ACTIONS(3953),
    [anon_sym_inline] = ACTIONS(3953),
    [anon_sym___inline] = ACTIONS(3953),
    [anon_sym___inline__] = ACTIONS(3953),
    [anon_sym___forceinline] = ACTIONS(3953),
    [anon_sym_thread_local] = ACTIONS(3953),
    [anon_sym___thread] = ACTIONS(3953),
    [anon_sym_const] = ACTIONS(3953),
    [anon_sym_constexpr] = ACTIONS(3953),
    [anon_sym_volatile] = ACTIONS(3953),
    [anon_sym_restrict] = ACTIONS(3953),
    [anon_sym___restrict__] = ACTIONS(3953),
    [anon_sym__Atomic] = ACTIONS(3953),
    [anon_sym__Noreturn] = ACTIONS(3953),
    [anon_sym_noreturn] = ACTIONS(3953),
    [anon_sym__Nonnull] = ACTIONS(3953),
    [anon_sym_mutable] = ACTIONS(3953),
    [anon_sym_constinit] = ACTIONS(3953),
    [anon_sym_consteval] = ACTIONS(3953),
    [anon_sym_alignas] = ACTIONS(3953),
    [anon_sym__Alignas] = ACTIONS(3953),
    [sym_primitive_type] = ACTIONS(3953),
    [anon_sym_enum] = ACTIONS(3953),
    [anon_sym_class] = ACTIONS(3953),
    [anon_sym_struct] = ACTIONS(3953),
    [anon_sym_union] = ACTIONS(3953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_This] = ACTIONS(3953),
    [anon_sym_decltype] = ACTIONS(3953),
    [anon_sym_explicit] = ACTIONS(3953),
    [anon_sym_typename] = ACTIONS(3953),
    [anon_sym_private] = ACTIONS(3953),
    [anon_sym_template] = ACTIONS(3953),
    [anon_sym_operator] = ACTIONS(3953),
    [anon_sym_friend] = ACTIONS(3953),
    [anon_sym_public] = ACTIONS(3953),
    [anon_sym_protected] = ACTIONS(3953),
    [anon_sym_static_assert] = ACTIONS(3953),
    [anon_sym_precise] = ACTIONS(3953),
    [anon_sym_shared] = ACTIONS(3953),
    [anon_sym_groupshared] = ACTIONS(3953),
    [anon_sym_uniform] = ACTIONS(3953),
    [anon_sym_row_major] = ACTIONS(3953),
    [anon_sym_column_major] = ACTIONS(3953),
    [anon_sym_globallycoherent] = ACTIONS(3953),
    [anon_sym_centroid] = ACTIONS(3953),
    [anon_sym_noperspective] = ACTIONS(3953),
    [anon_sym_nointerpolation] = ACTIONS(3953),
    [anon_sym_sample] = ACTIONS(3953),
    [anon_sym_linear] = ACTIONS(3953),
    [anon_sym_snorm] = ACTIONS(3953),
    [anon_sym_unorm] = ACTIONS(3953),
    [anon_sym_point] = ACTIONS(3953),
    [anon_sym_line] = ACTIONS(3953),
    [anon_sym_triangleadj] = ACTIONS(3953),
    [anon_sym_lineadj] = ACTIONS(3953),
    [anon_sym_triangle] = ACTIONS(3953),
    [anon_sym_interface] = ACTIONS(3953),
    [anon_sym_extension] = ACTIONS(3953),
    [anon_sym___init] = ACTIONS(3953),
    [anon_sym___subscript] = ACTIONS(3953),
    [anon_sym_property] = ACTIONS(3953),
    [anon_sym_associatedtype] = ACTIONS(3953),
  },
  [2193] = {
    [sym_identifier] = ACTIONS(3953),
    [aux_sym_preproc_def_token1] = ACTIONS(3953),
    [aux_sym_preproc_if_token1] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3953),
    [sym_preproc_directive] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_TILDE] = ACTIONS(3955),
    [anon_sym_STAR] = ACTIONS(3955),
    [anon_sym_AMP_AMP] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_SEMI] = ACTIONS(3955),
    [anon_sym___extension__] = ACTIONS(3953),
    [anon_sym_typedef] = ACTIONS(3953),
    [anon_sym_in] = ACTIONS(3953),
    [anon_sym_out] = ACTIONS(3953),
    [anon_sym_inout] = ACTIONS(3953),
    [anon_sym_virtual] = ACTIONS(3953),
    [anon_sym_extern] = ACTIONS(3953),
    [anon_sym___attribute__] = ACTIONS(3953),
    [anon_sym___attribute] = ACTIONS(3953),
    [anon_sym_using] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3955),
    [anon_sym___declspec] = ACTIONS(3953),
    [anon_sym___based] = ACTIONS(3953),
    [anon_sym_RBRACE] = ACTIONS(3955),
    [anon_sym_signed] = ACTIONS(3953),
    [anon_sym_unsigned] = ACTIONS(3953),
    [anon_sym_long] = ACTIONS(3953),
    [anon_sym_short] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_static] = ACTIONS(3953),
    [anon_sym_register] = ACTIONS(3953),
    [anon_sym_inline] = ACTIONS(3953),
    [anon_sym___inline] = ACTIONS(3953),
    [anon_sym___inline__] = ACTIONS(3953),
    [anon_sym___forceinline] = ACTIONS(3953),
    [anon_sym_thread_local] = ACTIONS(3953),
    [anon_sym___thread] = ACTIONS(3953),
    [anon_sym_const] = ACTIONS(3953),
    [anon_sym_constexpr] = ACTIONS(3953),
    [anon_sym_volatile] = ACTIONS(3953),
    [anon_sym_restrict] = ACTIONS(3953),
    [anon_sym___restrict__] = ACTIONS(3953),
    [anon_sym__Atomic] = ACTIONS(3953),
    [anon_sym__Noreturn] = ACTIONS(3953),
    [anon_sym_noreturn] = ACTIONS(3953),
    [anon_sym__Nonnull] = ACTIONS(3953),
    [anon_sym_mutable] = ACTIONS(3953),
    [anon_sym_constinit] = ACTIONS(3953),
    [anon_sym_consteval] = ACTIONS(3953),
    [anon_sym_alignas] = ACTIONS(3953),
    [anon_sym__Alignas] = ACTIONS(3953),
    [sym_primitive_type] = ACTIONS(3953),
    [anon_sym_enum] = ACTIONS(3953),
    [anon_sym_class] = ACTIONS(3953),
    [anon_sym_struct] = ACTIONS(3953),
    [anon_sym_union] = ACTIONS(3953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_This] = ACTIONS(3953),
    [anon_sym_decltype] = ACTIONS(3953),
    [anon_sym_explicit] = ACTIONS(3953),
    [anon_sym_typename] = ACTIONS(3953),
    [anon_sym_private] = ACTIONS(3953),
    [anon_sym_template] = ACTIONS(3953),
    [anon_sym_operator] = ACTIONS(3953),
    [anon_sym_friend] = ACTIONS(3953),
    [anon_sym_public] = ACTIONS(3953),
    [anon_sym_protected] = ACTIONS(3953),
    [anon_sym_static_assert] = ACTIONS(3953),
    [anon_sym_precise] = ACTIONS(3953),
    [anon_sym_shared] = ACTIONS(3953),
    [anon_sym_groupshared] = ACTIONS(3953),
    [anon_sym_uniform] = ACTIONS(3953),
    [anon_sym_row_major] = ACTIONS(3953),
    [anon_sym_column_major] = ACTIONS(3953),
    [anon_sym_globallycoherent] = ACTIONS(3953),
    [anon_sym_centroid] = ACTIONS(3953),
    [anon_sym_noperspective] = ACTIONS(3953),
    [anon_sym_nointerpolation] = ACTIONS(3953),
    [anon_sym_sample] = ACTIONS(3953),
    [anon_sym_linear] = ACTIONS(3953),
    [anon_sym_snorm] = ACTIONS(3953),
    [anon_sym_unorm] = ACTIONS(3953),
    [anon_sym_point] = ACTIONS(3953),
    [anon_sym_line] = ACTIONS(3953),
    [anon_sym_triangleadj] = ACTIONS(3953),
    [anon_sym_lineadj] = ACTIONS(3953),
    [anon_sym_triangle] = ACTIONS(3953),
    [anon_sym_interface] = ACTIONS(3953),
    [anon_sym_extension] = ACTIONS(3953),
    [anon_sym___init] = ACTIONS(3953),
    [anon_sym___subscript] = ACTIONS(3953),
    [anon_sym_property] = ACTIONS(3953),
    [anon_sym_associatedtype] = ACTIONS(3953),
  },
  [2194] = {
    [sym_identifier] = ACTIONS(3845),
    [aux_sym_preproc_def_token1] = ACTIONS(3845),
    [aux_sym_preproc_if_token1] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3845),
    [sym_preproc_directive] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3847),
    [anon_sym_STAR] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_SEMI] = ACTIONS(3847),
    [anon_sym___extension__] = ACTIONS(3845),
    [anon_sym_typedef] = ACTIONS(3845),
    [anon_sym_in] = ACTIONS(3845),
    [anon_sym_out] = ACTIONS(3845),
    [anon_sym_inout] = ACTIONS(3845),
    [anon_sym_virtual] = ACTIONS(3845),
    [anon_sym_extern] = ACTIONS(3845),
    [anon_sym___attribute__] = ACTIONS(3845),
    [anon_sym___attribute] = ACTIONS(3845),
    [anon_sym_using] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3847),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3847),
    [anon_sym___declspec] = ACTIONS(3845),
    [anon_sym___based] = ACTIONS(3845),
    [anon_sym_RBRACE] = ACTIONS(3847),
    [anon_sym_signed] = ACTIONS(3845),
    [anon_sym_unsigned] = ACTIONS(3845),
    [anon_sym_long] = ACTIONS(3845),
    [anon_sym_short] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_static] = ACTIONS(3845),
    [anon_sym_register] = ACTIONS(3845),
    [anon_sym_inline] = ACTIONS(3845),
    [anon_sym___inline] = ACTIONS(3845),
    [anon_sym___inline__] = ACTIONS(3845),
    [anon_sym___forceinline] = ACTIONS(3845),
    [anon_sym_thread_local] = ACTIONS(3845),
    [anon_sym___thread] = ACTIONS(3845),
    [anon_sym_const] = ACTIONS(3845),
    [anon_sym_constexpr] = ACTIONS(3845),
    [anon_sym_volatile] = ACTIONS(3845),
    [anon_sym_restrict] = ACTIONS(3845),
    [anon_sym___restrict__] = ACTIONS(3845),
    [anon_sym__Atomic] = ACTIONS(3845),
    [anon_sym__Noreturn] = ACTIONS(3845),
    [anon_sym_noreturn] = ACTIONS(3845),
    [anon_sym__Nonnull] = ACTIONS(3845),
    [anon_sym_mutable] = ACTIONS(3845),
    [anon_sym_constinit] = ACTIONS(3845),
    [anon_sym_consteval] = ACTIONS(3845),
    [anon_sym_alignas] = ACTIONS(3845),
    [anon_sym__Alignas] = ACTIONS(3845),
    [sym_primitive_type] = ACTIONS(3845),
    [anon_sym_enum] = ACTIONS(3845),
    [anon_sym_class] = ACTIONS(3845),
    [anon_sym_struct] = ACTIONS(3845),
    [anon_sym_union] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_This] = ACTIONS(3845),
    [anon_sym_decltype] = ACTIONS(3845),
    [anon_sym_explicit] = ACTIONS(3845),
    [anon_sym_typename] = ACTIONS(3845),
    [anon_sym_private] = ACTIONS(3845),
    [anon_sym_template] = ACTIONS(3845),
    [anon_sym_operator] = ACTIONS(3845),
    [anon_sym_friend] = ACTIONS(3845),
    [anon_sym_public] = ACTIONS(3845),
    [anon_sym_protected] = ACTIONS(3845),
    [anon_sym_static_assert] = ACTIONS(3845),
    [anon_sym_precise] = ACTIONS(3845),
    [anon_sym_shared] = ACTIONS(3845),
    [anon_sym_groupshared] = ACTIONS(3845),
    [anon_sym_uniform] = ACTIONS(3845),
    [anon_sym_row_major] = ACTIONS(3845),
    [anon_sym_column_major] = ACTIONS(3845),
    [anon_sym_globallycoherent] = ACTIONS(3845),
    [anon_sym_centroid] = ACTIONS(3845),
    [anon_sym_noperspective] = ACTIONS(3845),
    [anon_sym_nointerpolation] = ACTIONS(3845),
    [anon_sym_sample] = ACTIONS(3845),
    [anon_sym_linear] = ACTIONS(3845),
    [anon_sym_snorm] = ACTIONS(3845),
    [anon_sym_unorm] = ACTIONS(3845),
    [anon_sym_point] = ACTIONS(3845),
    [anon_sym_line] = ACTIONS(3845),
    [anon_sym_triangleadj] = ACTIONS(3845),
    [anon_sym_lineadj] = ACTIONS(3845),
    [anon_sym_triangle] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3845),
    [anon_sym_extension] = ACTIONS(3845),
    [anon_sym___init] = ACTIONS(3845),
    [anon_sym___subscript] = ACTIONS(3845),
    [anon_sym_property] = ACTIONS(3845),
    [anon_sym_associatedtype] = ACTIONS(3845),
  },
  [2195] = {
    [sym_identifier] = ACTIONS(3845),
    [aux_sym_preproc_def_token1] = ACTIONS(3845),
    [aux_sym_preproc_if_token1] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3845),
    [sym_preproc_directive] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3847),
    [anon_sym_STAR] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_SEMI] = ACTIONS(3847),
    [anon_sym___extension__] = ACTIONS(3845),
    [anon_sym_typedef] = ACTIONS(3845),
    [anon_sym_in] = ACTIONS(3845),
    [anon_sym_out] = ACTIONS(3845),
    [anon_sym_inout] = ACTIONS(3845),
    [anon_sym_virtual] = ACTIONS(3845),
    [anon_sym_extern] = ACTIONS(3845),
    [anon_sym___attribute__] = ACTIONS(3845),
    [anon_sym___attribute] = ACTIONS(3845),
    [anon_sym_using] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3847),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3847),
    [anon_sym___declspec] = ACTIONS(3845),
    [anon_sym___based] = ACTIONS(3845),
    [anon_sym_RBRACE] = ACTIONS(3847),
    [anon_sym_signed] = ACTIONS(3845),
    [anon_sym_unsigned] = ACTIONS(3845),
    [anon_sym_long] = ACTIONS(3845),
    [anon_sym_short] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_static] = ACTIONS(3845),
    [anon_sym_register] = ACTIONS(3845),
    [anon_sym_inline] = ACTIONS(3845),
    [anon_sym___inline] = ACTIONS(3845),
    [anon_sym___inline__] = ACTIONS(3845),
    [anon_sym___forceinline] = ACTIONS(3845),
    [anon_sym_thread_local] = ACTIONS(3845),
    [anon_sym___thread] = ACTIONS(3845),
    [anon_sym_const] = ACTIONS(3845),
    [anon_sym_constexpr] = ACTIONS(3845),
    [anon_sym_volatile] = ACTIONS(3845),
    [anon_sym_restrict] = ACTIONS(3845),
    [anon_sym___restrict__] = ACTIONS(3845),
    [anon_sym__Atomic] = ACTIONS(3845),
    [anon_sym__Noreturn] = ACTIONS(3845),
    [anon_sym_noreturn] = ACTIONS(3845),
    [anon_sym__Nonnull] = ACTIONS(3845),
    [anon_sym_mutable] = ACTIONS(3845),
    [anon_sym_constinit] = ACTIONS(3845),
    [anon_sym_consteval] = ACTIONS(3845),
    [anon_sym_alignas] = ACTIONS(3845),
    [anon_sym__Alignas] = ACTIONS(3845),
    [sym_primitive_type] = ACTIONS(3845),
    [anon_sym_enum] = ACTIONS(3845),
    [anon_sym_class] = ACTIONS(3845),
    [anon_sym_struct] = ACTIONS(3845),
    [anon_sym_union] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_This] = ACTIONS(3845),
    [anon_sym_decltype] = ACTIONS(3845),
    [anon_sym_explicit] = ACTIONS(3845),
    [anon_sym_typename] = ACTIONS(3845),
    [anon_sym_private] = ACTIONS(3845),
    [anon_sym_template] = ACTIONS(3845),
    [anon_sym_operator] = ACTIONS(3845),
    [anon_sym_friend] = ACTIONS(3845),
    [anon_sym_public] = ACTIONS(3845),
    [anon_sym_protected] = ACTIONS(3845),
    [anon_sym_static_assert] = ACTIONS(3845),
    [anon_sym_precise] = ACTIONS(3845),
    [anon_sym_shared] = ACTIONS(3845),
    [anon_sym_groupshared] = ACTIONS(3845),
    [anon_sym_uniform] = ACTIONS(3845),
    [anon_sym_row_major] = ACTIONS(3845),
    [anon_sym_column_major] = ACTIONS(3845),
    [anon_sym_globallycoherent] = ACTIONS(3845),
    [anon_sym_centroid] = ACTIONS(3845),
    [anon_sym_noperspective] = ACTIONS(3845),
    [anon_sym_nointerpolation] = ACTIONS(3845),
    [anon_sym_sample] = ACTIONS(3845),
    [anon_sym_linear] = ACTIONS(3845),
    [anon_sym_snorm] = ACTIONS(3845),
    [anon_sym_unorm] = ACTIONS(3845),
    [anon_sym_point] = ACTIONS(3845),
    [anon_sym_line] = ACTIONS(3845),
    [anon_sym_triangleadj] = ACTIONS(3845),
    [anon_sym_lineadj] = ACTIONS(3845),
    [anon_sym_triangle] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3845),
    [anon_sym_extension] = ACTIONS(3845),
    [anon_sym___init] = ACTIONS(3845),
    [anon_sym___subscript] = ACTIONS(3845),
    [anon_sym_property] = ACTIONS(3845),
    [anon_sym_associatedtype] = ACTIONS(3845),
  },
  [2196] = {
    [sym_expression] = STATE(4441),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(6425),
    [anon_sym_BANG] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5262),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(6670),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_DASH_DASH] = ACTIONS(5557),
    [anon_sym_PLUS_PLUS] = ACTIONS(5557),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [2197] = {
    [sym_expression] = STATE(4442),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(6425),
    [anon_sym_BANG] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5262),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_DASH_DASH] = ACTIONS(5557),
    [anon_sym_PLUS_PLUS] = ACTIONS(5557),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [2198] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6255),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [2199] = {
    [sym_expression] = STATE(4454),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(6425),
    [anon_sym_BANG] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5262),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(6672),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_DASH_DASH] = ACTIONS(5557),
    [anon_sym_PLUS_PLUS] = ACTIONS(5557),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [2200] = {
    [sym_expression] = STATE(5921),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2201] = {
    [sym_expression] = STATE(5442),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(6674),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2202] = {
    [sym_expression] = STATE(5381),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2203] = {
    [sym_expression] = STATE(5715),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2204] = {
    [sym_expression] = STATE(4473),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(6425),
    [anon_sym_BANG] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5262),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_DASH_DASH] = ACTIONS(5557),
    [anon_sym_PLUS_PLUS] = ACTIONS(5557),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [2205] = {
    [sym_expression] = STATE(5895),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2206] = {
    [sym_expression] = STATE(4826),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2207] = {
    [sym_identifier] = ACTIONS(3452),
    [aux_sym_preproc_def_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3452),
    [sym_preproc_directive] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(3450),
    [anon_sym_TILDE] = ACTIONS(3450),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_AMP_AMP] = ACTIONS(3450),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym___extension__] = ACTIONS(3452),
    [anon_sym_typedef] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_out] = ACTIONS(3452),
    [anon_sym_inout] = ACTIONS(3452),
    [anon_sym_virtual] = ACTIONS(3452),
    [anon_sym_extern] = ACTIONS(3452),
    [anon_sym___attribute__] = ACTIONS(3452),
    [anon_sym___attribute] = ACTIONS(3452),
    [anon_sym_using] = ACTIONS(3452),
    [anon_sym_COLON_COLON] = ACTIONS(3450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3450),
    [anon_sym___declspec] = ACTIONS(3452),
    [anon_sym___based] = ACTIONS(3452),
    [anon_sym_RBRACE] = ACTIONS(3450),
    [anon_sym_signed] = ACTIONS(3452),
    [anon_sym_unsigned] = ACTIONS(3452),
    [anon_sym_long] = ACTIONS(3452),
    [anon_sym_short] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3452),
    [anon_sym_static] = ACTIONS(3452),
    [anon_sym_register] = ACTIONS(3452),
    [anon_sym_inline] = ACTIONS(3452),
    [anon_sym___inline] = ACTIONS(3452),
    [anon_sym___inline__] = ACTIONS(3452),
    [anon_sym___forceinline] = ACTIONS(3452),
    [anon_sym_thread_local] = ACTIONS(3452),
    [anon_sym___thread] = ACTIONS(3452),
    [anon_sym_const] = ACTIONS(3452),
    [anon_sym_constexpr] = ACTIONS(3452),
    [anon_sym_volatile] = ACTIONS(3452),
    [anon_sym_restrict] = ACTIONS(3452),
    [anon_sym___restrict__] = ACTIONS(3452),
    [anon_sym__Atomic] = ACTIONS(3452),
    [anon_sym__Noreturn] = ACTIONS(3452),
    [anon_sym_noreturn] = ACTIONS(3452),
    [anon_sym__Nonnull] = ACTIONS(3452),
    [anon_sym_mutable] = ACTIONS(3452),
    [anon_sym_constinit] = ACTIONS(3452),
    [anon_sym_consteval] = ACTIONS(3452),
    [anon_sym_alignas] = ACTIONS(3452),
    [anon_sym__Alignas] = ACTIONS(3452),
    [sym_primitive_type] = ACTIONS(3452),
    [anon_sym_enum] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(3452),
    [anon_sym_union] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3452),
    [anon_sym_let] = ACTIONS(3452),
    [anon_sym_This] = ACTIONS(3452),
    [anon_sym_decltype] = ACTIONS(3452),
    [anon_sym_explicit] = ACTIONS(3452),
    [anon_sym_typename] = ACTIONS(3452),
    [anon_sym_private] = ACTIONS(3452),
    [anon_sym_template] = ACTIONS(3452),
    [anon_sym_operator] = ACTIONS(3452),
    [anon_sym_friend] = ACTIONS(3452),
    [anon_sym_public] = ACTIONS(3452),
    [anon_sym_protected] = ACTIONS(3452),
    [anon_sym_static_assert] = ACTIONS(3452),
    [anon_sym_precise] = ACTIONS(3452),
    [anon_sym_shared] = ACTIONS(3452),
    [anon_sym_groupshared] = ACTIONS(3452),
    [anon_sym_uniform] = ACTIONS(3452),
    [anon_sym_row_major] = ACTIONS(3452),
    [anon_sym_column_major] = ACTIONS(3452),
    [anon_sym_globallycoherent] = ACTIONS(3452),
    [anon_sym_centroid] = ACTIONS(3452),
    [anon_sym_noperspective] = ACTIONS(3452),
    [anon_sym_nointerpolation] = ACTIONS(3452),
    [anon_sym_sample] = ACTIONS(3452),
    [anon_sym_linear] = ACTIONS(3452),
    [anon_sym_snorm] = ACTIONS(3452),
    [anon_sym_unorm] = ACTIONS(3452),
    [anon_sym_point] = ACTIONS(3452),
    [anon_sym_line] = ACTIONS(3452),
    [anon_sym_triangleadj] = ACTIONS(3452),
    [anon_sym_lineadj] = ACTIONS(3452),
    [anon_sym_triangle] = ACTIONS(3452),
    [anon_sym_interface] = ACTIONS(3452),
    [anon_sym_extension] = ACTIONS(3452),
    [anon_sym___init] = ACTIONS(3452),
    [anon_sym___subscript] = ACTIONS(3452),
    [anon_sym_property] = ACTIONS(3452),
    [anon_sym_associatedtype] = ACTIONS(3452),
  },
  [2208] = {
    [sym_identifier] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4250),
    [anon_sym_RPAREN] = ACTIONS(4250),
    [anon_sym_LPAREN2] = ACTIONS(4250),
    [anon_sym_TILDE] = ACTIONS(4250),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_AMP_AMP] = ACTIONS(4250),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4250),
    [anon_sym___extension__] = ACTIONS(4248),
    [anon_sym_in] = ACTIONS(4248),
    [anon_sym_out] = ACTIONS(4248),
    [anon_sym_inout] = ACTIONS(4248),
    [anon_sym_virtual] = ACTIONS(4248),
    [anon_sym_extern] = ACTIONS(4248),
    [anon_sym___attribute__] = ACTIONS(4248),
    [anon_sym___attribute] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4250),
    [anon_sym___declspec] = ACTIONS(4248),
    [anon_sym___based] = ACTIONS(4248),
    [anon_sym_LBRACE] = ACTIONS(4250),
    [anon_sym_signed] = ACTIONS(4248),
    [anon_sym_unsigned] = ACTIONS(4248),
    [anon_sym_long] = ACTIONS(4248),
    [anon_sym_short] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_static] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4250),
    [anon_sym_register] = ACTIONS(4248),
    [anon_sym_inline] = ACTIONS(4248),
    [anon_sym___inline] = ACTIONS(4248),
    [anon_sym___inline__] = ACTIONS(4248),
    [anon_sym___forceinline] = ACTIONS(4248),
    [anon_sym_thread_local] = ACTIONS(4248),
    [anon_sym___thread] = ACTIONS(4248),
    [anon_sym_const] = ACTIONS(4248),
    [anon_sym_constexpr] = ACTIONS(4248),
    [anon_sym_volatile] = ACTIONS(4248),
    [anon_sym_restrict] = ACTIONS(4248),
    [anon_sym___restrict__] = ACTIONS(4248),
    [anon_sym__Atomic] = ACTIONS(4248),
    [anon_sym__Noreturn] = ACTIONS(4248),
    [anon_sym_noreturn] = ACTIONS(4248),
    [anon_sym__Nonnull] = ACTIONS(4248),
    [anon_sym_mutable] = ACTIONS(4248),
    [anon_sym_constinit] = ACTIONS(4248),
    [anon_sym_consteval] = ACTIONS(4248),
    [anon_sym_alignas] = ACTIONS(4248),
    [anon_sym__Alignas] = ACTIONS(4248),
    [sym_primitive_type] = ACTIONS(4248),
    [anon_sym_enum] = ACTIONS(4248),
    [anon_sym_class] = ACTIONS(4248),
    [anon_sym_struct] = ACTIONS(4248),
    [anon_sym_union] = ACTIONS(4248),
    [anon_sym_asm] = ACTIONS(4248),
    [anon_sym___asm__] = ACTIONS(4248),
    [anon_sym___asm] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4250),
    [anon_sym_DASH_GT] = ACTIONS(4250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4248),
    [anon_sym_let] = ACTIONS(4248),
    [anon_sym_This] = ACTIONS(4248),
    [anon_sym_decltype] = ACTIONS(4248),
    [anon_sym_final] = ACTIONS(4248),
    [anon_sym_override] = ACTIONS(4248),
    [anon_sym_explicit] = ACTIONS(4248),
    [anon_sym_typename] = ACTIONS(4248),
    [anon_sym_template] = ACTIONS(4248),
    [anon_sym_GT2] = ACTIONS(4250),
    [anon_sym_operator] = ACTIONS(4248),
    [anon_sym_try] = ACTIONS(4248),
    [anon_sym_noexcept] = ACTIONS(4248),
    [anon_sym_throw] = ACTIONS(4248),
    [anon_sym_requires] = ACTIONS(4248),
    [anon_sym_precise] = ACTIONS(4248),
    [anon_sym_shared] = ACTIONS(4248),
    [anon_sym_groupshared] = ACTIONS(4248),
    [anon_sym_uniform] = ACTIONS(4248),
    [anon_sym_row_major] = ACTIONS(4248),
    [anon_sym_column_major] = ACTIONS(4248),
    [anon_sym_globallycoherent] = ACTIONS(4248),
    [anon_sym_centroid] = ACTIONS(4248),
    [anon_sym_noperspective] = ACTIONS(4248),
    [anon_sym_nointerpolation] = ACTIONS(4248),
    [anon_sym_sample] = ACTIONS(4248),
    [anon_sym_linear] = ACTIONS(4248),
    [anon_sym_snorm] = ACTIONS(4248),
    [anon_sym_unorm] = ACTIONS(4248),
    [anon_sym_point] = ACTIONS(4248),
    [anon_sym_line] = ACTIONS(4248),
    [anon_sym_triangleadj] = ACTIONS(4248),
    [anon_sym_lineadj] = ACTIONS(4248),
    [anon_sym_triangle] = ACTIONS(4248),
    [anon_sym_interface] = ACTIONS(4248),
    [anon_sym_extension] = ACTIONS(4248),
    [anon_sym_where] = ACTIONS(4248),
  },
  [2209] = {
    [sym_identifier] = ACTIONS(3452),
    [aux_sym_preproc_def_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3452),
    [sym_preproc_directive] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(3450),
    [anon_sym_TILDE] = ACTIONS(3450),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_AMP_AMP] = ACTIONS(3450),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym___extension__] = ACTIONS(3452),
    [anon_sym_typedef] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_out] = ACTIONS(3452),
    [anon_sym_inout] = ACTIONS(3452),
    [anon_sym_virtual] = ACTIONS(3452),
    [anon_sym_extern] = ACTIONS(3452),
    [anon_sym___attribute__] = ACTIONS(3452),
    [anon_sym___attribute] = ACTIONS(3452),
    [anon_sym_using] = ACTIONS(3452),
    [anon_sym_COLON_COLON] = ACTIONS(3450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3450),
    [anon_sym___declspec] = ACTIONS(3452),
    [anon_sym___based] = ACTIONS(3452),
    [anon_sym_RBRACE] = ACTIONS(3450),
    [anon_sym_signed] = ACTIONS(3452),
    [anon_sym_unsigned] = ACTIONS(3452),
    [anon_sym_long] = ACTIONS(3452),
    [anon_sym_short] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3452),
    [anon_sym_static] = ACTIONS(3452),
    [anon_sym_register] = ACTIONS(3452),
    [anon_sym_inline] = ACTIONS(3452),
    [anon_sym___inline] = ACTIONS(3452),
    [anon_sym___inline__] = ACTIONS(3452),
    [anon_sym___forceinline] = ACTIONS(3452),
    [anon_sym_thread_local] = ACTIONS(3452),
    [anon_sym___thread] = ACTIONS(3452),
    [anon_sym_const] = ACTIONS(3452),
    [anon_sym_constexpr] = ACTIONS(3452),
    [anon_sym_volatile] = ACTIONS(3452),
    [anon_sym_restrict] = ACTIONS(3452),
    [anon_sym___restrict__] = ACTIONS(3452),
    [anon_sym__Atomic] = ACTIONS(3452),
    [anon_sym__Noreturn] = ACTIONS(3452),
    [anon_sym_noreturn] = ACTIONS(3452),
    [anon_sym__Nonnull] = ACTIONS(3452),
    [anon_sym_mutable] = ACTIONS(3452),
    [anon_sym_constinit] = ACTIONS(3452),
    [anon_sym_consteval] = ACTIONS(3452),
    [anon_sym_alignas] = ACTIONS(3452),
    [anon_sym__Alignas] = ACTIONS(3452),
    [sym_primitive_type] = ACTIONS(3452),
    [anon_sym_enum] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(3452),
    [anon_sym_union] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3452),
    [anon_sym_let] = ACTIONS(3452),
    [anon_sym_This] = ACTIONS(3452),
    [anon_sym_decltype] = ACTIONS(3452),
    [anon_sym_explicit] = ACTIONS(3452),
    [anon_sym_typename] = ACTIONS(3452),
    [anon_sym_private] = ACTIONS(3452),
    [anon_sym_template] = ACTIONS(3452),
    [anon_sym_operator] = ACTIONS(3452),
    [anon_sym_friend] = ACTIONS(3452),
    [anon_sym_public] = ACTIONS(3452),
    [anon_sym_protected] = ACTIONS(3452),
    [anon_sym_static_assert] = ACTIONS(3452),
    [anon_sym_precise] = ACTIONS(3452),
    [anon_sym_shared] = ACTIONS(3452),
    [anon_sym_groupshared] = ACTIONS(3452),
    [anon_sym_uniform] = ACTIONS(3452),
    [anon_sym_row_major] = ACTIONS(3452),
    [anon_sym_column_major] = ACTIONS(3452),
    [anon_sym_globallycoherent] = ACTIONS(3452),
    [anon_sym_centroid] = ACTIONS(3452),
    [anon_sym_noperspective] = ACTIONS(3452),
    [anon_sym_nointerpolation] = ACTIONS(3452),
    [anon_sym_sample] = ACTIONS(3452),
    [anon_sym_linear] = ACTIONS(3452),
    [anon_sym_snorm] = ACTIONS(3452),
    [anon_sym_unorm] = ACTIONS(3452),
    [anon_sym_point] = ACTIONS(3452),
    [anon_sym_line] = ACTIONS(3452),
    [anon_sym_triangleadj] = ACTIONS(3452),
    [anon_sym_lineadj] = ACTIONS(3452),
    [anon_sym_triangle] = ACTIONS(3452),
    [anon_sym_interface] = ACTIONS(3452),
    [anon_sym_extension] = ACTIONS(3452),
    [anon_sym___init] = ACTIONS(3452),
    [anon_sym___subscript] = ACTIONS(3452),
    [anon_sym_property] = ACTIONS(3452),
    [anon_sym_associatedtype] = ACTIONS(3452),
  },
  [2210] = {
    [sym_identifier] = ACTIONS(3452),
    [aux_sym_preproc_def_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3452),
    [sym_preproc_directive] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(3450),
    [anon_sym_TILDE] = ACTIONS(3450),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_AMP_AMP] = ACTIONS(3450),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym___extension__] = ACTIONS(3452),
    [anon_sym_typedef] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_out] = ACTIONS(3452),
    [anon_sym_inout] = ACTIONS(3452),
    [anon_sym_virtual] = ACTIONS(3452),
    [anon_sym_extern] = ACTIONS(3452),
    [anon_sym___attribute__] = ACTIONS(3452),
    [anon_sym___attribute] = ACTIONS(3452),
    [anon_sym_using] = ACTIONS(3452),
    [anon_sym_COLON_COLON] = ACTIONS(3450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3450),
    [anon_sym___declspec] = ACTIONS(3452),
    [anon_sym___based] = ACTIONS(3452),
    [anon_sym_RBRACE] = ACTIONS(3450),
    [anon_sym_signed] = ACTIONS(3452),
    [anon_sym_unsigned] = ACTIONS(3452),
    [anon_sym_long] = ACTIONS(3452),
    [anon_sym_short] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3452),
    [anon_sym_static] = ACTIONS(3452),
    [anon_sym_register] = ACTIONS(3452),
    [anon_sym_inline] = ACTIONS(3452),
    [anon_sym___inline] = ACTIONS(3452),
    [anon_sym___inline__] = ACTIONS(3452),
    [anon_sym___forceinline] = ACTIONS(3452),
    [anon_sym_thread_local] = ACTIONS(3452),
    [anon_sym___thread] = ACTIONS(3452),
    [anon_sym_const] = ACTIONS(3452),
    [anon_sym_constexpr] = ACTIONS(3452),
    [anon_sym_volatile] = ACTIONS(3452),
    [anon_sym_restrict] = ACTIONS(3452),
    [anon_sym___restrict__] = ACTIONS(3452),
    [anon_sym__Atomic] = ACTIONS(3452),
    [anon_sym__Noreturn] = ACTIONS(3452),
    [anon_sym_noreturn] = ACTIONS(3452),
    [anon_sym__Nonnull] = ACTIONS(3452),
    [anon_sym_mutable] = ACTIONS(3452),
    [anon_sym_constinit] = ACTIONS(3452),
    [anon_sym_consteval] = ACTIONS(3452),
    [anon_sym_alignas] = ACTIONS(3452),
    [anon_sym__Alignas] = ACTIONS(3452),
    [sym_primitive_type] = ACTIONS(3452),
    [anon_sym_enum] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(3452),
    [anon_sym_union] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3452),
    [anon_sym_let] = ACTIONS(3452),
    [anon_sym_This] = ACTIONS(3452),
    [anon_sym_decltype] = ACTIONS(3452),
    [anon_sym_explicit] = ACTIONS(3452),
    [anon_sym_typename] = ACTIONS(3452),
    [anon_sym_private] = ACTIONS(3452),
    [anon_sym_template] = ACTIONS(3452),
    [anon_sym_operator] = ACTIONS(3452),
    [anon_sym_friend] = ACTIONS(3452),
    [anon_sym_public] = ACTIONS(3452),
    [anon_sym_protected] = ACTIONS(3452),
    [anon_sym_static_assert] = ACTIONS(3452),
    [anon_sym_precise] = ACTIONS(3452),
    [anon_sym_shared] = ACTIONS(3452),
    [anon_sym_groupshared] = ACTIONS(3452),
    [anon_sym_uniform] = ACTIONS(3452),
    [anon_sym_row_major] = ACTIONS(3452),
    [anon_sym_column_major] = ACTIONS(3452),
    [anon_sym_globallycoherent] = ACTIONS(3452),
    [anon_sym_centroid] = ACTIONS(3452),
    [anon_sym_noperspective] = ACTIONS(3452),
    [anon_sym_nointerpolation] = ACTIONS(3452),
    [anon_sym_sample] = ACTIONS(3452),
    [anon_sym_linear] = ACTIONS(3452),
    [anon_sym_snorm] = ACTIONS(3452),
    [anon_sym_unorm] = ACTIONS(3452),
    [anon_sym_point] = ACTIONS(3452),
    [anon_sym_line] = ACTIONS(3452),
    [anon_sym_triangleadj] = ACTIONS(3452),
    [anon_sym_lineadj] = ACTIONS(3452),
    [anon_sym_triangle] = ACTIONS(3452),
    [anon_sym_interface] = ACTIONS(3452),
    [anon_sym_extension] = ACTIONS(3452),
    [anon_sym___init] = ACTIONS(3452),
    [anon_sym___subscript] = ACTIONS(3452),
    [anon_sym_property] = ACTIONS(3452),
    [anon_sym_associatedtype] = ACTIONS(3452),
  },
  [2211] = {
    [sym_expression] = STATE(4309),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(6425),
    [anon_sym_BANG] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5262),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_DASH_DASH] = ACTIONS(5557),
    [anon_sym_PLUS_PLUS] = ACTIONS(5557),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [2212] = {
    [sym_expression] = STATE(5940),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2213] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(6678),
  },
  [2214] = {
    [sym_identifier] = ACTIONS(3562),
    [aux_sym_preproc_def_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3562),
    [sym_preproc_directive] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym___extension__] = ACTIONS(3562),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_in] = ACTIONS(3562),
    [anon_sym_out] = ACTIONS(3562),
    [anon_sym_inout] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym___attribute__] = ACTIONS(3562),
    [anon_sym___attribute] = ACTIONS(3562),
    [anon_sym_using] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3560),
    [anon_sym___declspec] = ACTIONS(3562),
    [anon_sym___based] = ACTIONS(3562),
    [anon_sym_RBRACE] = ACTIONS(3560),
    [anon_sym_signed] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym___inline] = ACTIONS(3562),
    [anon_sym___inline__] = ACTIONS(3562),
    [anon_sym___forceinline] = ACTIONS(3562),
    [anon_sym_thread_local] = ACTIONS(3562),
    [anon_sym___thread] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_constexpr] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym___restrict__] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym__Noreturn] = ACTIONS(3562),
    [anon_sym_noreturn] = ACTIONS(3562),
    [anon_sym__Nonnull] = ACTIONS(3562),
    [anon_sym_mutable] = ACTIONS(3562),
    [anon_sym_constinit] = ACTIONS(3562),
    [anon_sym_consteval] = ACTIONS(3562),
    [anon_sym_alignas] = ACTIONS(3562),
    [anon_sym__Alignas] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_This] = ACTIONS(3562),
    [anon_sym_decltype] = ACTIONS(3562),
    [anon_sym_explicit] = ACTIONS(3562),
    [anon_sym_typename] = ACTIONS(3562),
    [anon_sym_private] = ACTIONS(3562),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(3562),
    [anon_sym_friend] = ACTIONS(3562),
    [anon_sym_public] = ACTIONS(3562),
    [anon_sym_protected] = ACTIONS(3562),
    [anon_sym_static_assert] = ACTIONS(3562),
    [anon_sym_precise] = ACTIONS(3562),
    [anon_sym_shared] = ACTIONS(3562),
    [anon_sym_groupshared] = ACTIONS(3562),
    [anon_sym_uniform] = ACTIONS(3562),
    [anon_sym_row_major] = ACTIONS(3562),
    [anon_sym_column_major] = ACTIONS(3562),
    [anon_sym_globallycoherent] = ACTIONS(3562),
    [anon_sym_centroid] = ACTIONS(3562),
    [anon_sym_noperspective] = ACTIONS(3562),
    [anon_sym_nointerpolation] = ACTIONS(3562),
    [anon_sym_sample] = ACTIONS(3562),
    [anon_sym_linear] = ACTIONS(3562),
    [anon_sym_snorm] = ACTIONS(3562),
    [anon_sym_unorm] = ACTIONS(3562),
    [anon_sym_point] = ACTIONS(3562),
    [anon_sym_line] = ACTIONS(3562),
    [anon_sym_triangleadj] = ACTIONS(3562),
    [anon_sym_lineadj] = ACTIONS(3562),
    [anon_sym_triangle] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_extension] = ACTIONS(3562),
    [anon_sym___init] = ACTIONS(3562),
    [anon_sym___subscript] = ACTIONS(3562),
    [anon_sym_property] = ACTIONS(3562),
    [anon_sym_associatedtype] = ACTIONS(3562),
  },
  [2215] = {
    [sym_identifier] = ACTIONS(3562),
    [aux_sym_preproc_def_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3562),
    [sym_preproc_directive] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym___extension__] = ACTIONS(3562),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_in] = ACTIONS(3562),
    [anon_sym_out] = ACTIONS(3562),
    [anon_sym_inout] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym___attribute__] = ACTIONS(3562),
    [anon_sym___attribute] = ACTIONS(3562),
    [anon_sym_using] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3560),
    [anon_sym___declspec] = ACTIONS(3562),
    [anon_sym___based] = ACTIONS(3562),
    [anon_sym_RBRACE] = ACTIONS(3560),
    [anon_sym_signed] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym___inline] = ACTIONS(3562),
    [anon_sym___inline__] = ACTIONS(3562),
    [anon_sym___forceinline] = ACTIONS(3562),
    [anon_sym_thread_local] = ACTIONS(3562),
    [anon_sym___thread] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_constexpr] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym___restrict__] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym__Noreturn] = ACTIONS(3562),
    [anon_sym_noreturn] = ACTIONS(3562),
    [anon_sym__Nonnull] = ACTIONS(3562),
    [anon_sym_mutable] = ACTIONS(3562),
    [anon_sym_constinit] = ACTIONS(3562),
    [anon_sym_consteval] = ACTIONS(3562),
    [anon_sym_alignas] = ACTIONS(3562),
    [anon_sym__Alignas] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_This] = ACTIONS(3562),
    [anon_sym_decltype] = ACTIONS(3562),
    [anon_sym_explicit] = ACTIONS(3562),
    [anon_sym_typename] = ACTIONS(3562),
    [anon_sym_private] = ACTIONS(3562),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(3562),
    [anon_sym_friend] = ACTIONS(3562),
    [anon_sym_public] = ACTIONS(3562),
    [anon_sym_protected] = ACTIONS(3562),
    [anon_sym_static_assert] = ACTIONS(3562),
    [anon_sym_precise] = ACTIONS(3562),
    [anon_sym_shared] = ACTIONS(3562),
    [anon_sym_groupshared] = ACTIONS(3562),
    [anon_sym_uniform] = ACTIONS(3562),
    [anon_sym_row_major] = ACTIONS(3562),
    [anon_sym_column_major] = ACTIONS(3562),
    [anon_sym_globallycoherent] = ACTIONS(3562),
    [anon_sym_centroid] = ACTIONS(3562),
    [anon_sym_noperspective] = ACTIONS(3562),
    [anon_sym_nointerpolation] = ACTIONS(3562),
    [anon_sym_sample] = ACTIONS(3562),
    [anon_sym_linear] = ACTIONS(3562),
    [anon_sym_snorm] = ACTIONS(3562),
    [anon_sym_unorm] = ACTIONS(3562),
    [anon_sym_point] = ACTIONS(3562),
    [anon_sym_line] = ACTIONS(3562),
    [anon_sym_triangleadj] = ACTIONS(3562),
    [anon_sym_lineadj] = ACTIONS(3562),
    [anon_sym_triangle] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_extension] = ACTIONS(3562),
    [anon_sym___init] = ACTIONS(3562),
    [anon_sym___subscript] = ACTIONS(3562),
    [anon_sym_property] = ACTIONS(3562),
    [anon_sym_associatedtype] = ACTIONS(3562),
  },
  [2216] = {
    [sym_identifier] = ACTIONS(3562),
    [aux_sym_preproc_def_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3562),
    [sym_preproc_directive] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym___extension__] = ACTIONS(3562),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_in] = ACTIONS(3562),
    [anon_sym_out] = ACTIONS(3562),
    [anon_sym_inout] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym___attribute__] = ACTIONS(3562),
    [anon_sym___attribute] = ACTIONS(3562),
    [anon_sym_using] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3560),
    [anon_sym___declspec] = ACTIONS(3562),
    [anon_sym___based] = ACTIONS(3562),
    [anon_sym_RBRACE] = ACTIONS(3560),
    [anon_sym_signed] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym___inline] = ACTIONS(3562),
    [anon_sym___inline__] = ACTIONS(3562),
    [anon_sym___forceinline] = ACTIONS(3562),
    [anon_sym_thread_local] = ACTIONS(3562),
    [anon_sym___thread] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_constexpr] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym___restrict__] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym__Noreturn] = ACTIONS(3562),
    [anon_sym_noreturn] = ACTIONS(3562),
    [anon_sym__Nonnull] = ACTIONS(3562),
    [anon_sym_mutable] = ACTIONS(3562),
    [anon_sym_constinit] = ACTIONS(3562),
    [anon_sym_consteval] = ACTIONS(3562),
    [anon_sym_alignas] = ACTIONS(3562),
    [anon_sym__Alignas] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_This] = ACTIONS(3562),
    [anon_sym_decltype] = ACTIONS(3562),
    [anon_sym_explicit] = ACTIONS(3562),
    [anon_sym_typename] = ACTIONS(3562),
    [anon_sym_private] = ACTIONS(3562),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(3562),
    [anon_sym_friend] = ACTIONS(3562),
    [anon_sym_public] = ACTIONS(3562),
    [anon_sym_protected] = ACTIONS(3562),
    [anon_sym_static_assert] = ACTIONS(3562),
    [anon_sym_precise] = ACTIONS(3562),
    [anon_sym_shared] = ACTIONS(3562),
    [anon_sym_groupshared] = ACTIONS(3562),
    [anon_sym_uniform] = ACTIONS(3562),
    [anon_sym_row_major] = ACTIONS(3562),
    [anon_sym_column_major] = ACTIONS(3562),
    [anon_sym_globallycoherent] = ACTIONS(3562),
    [anon_sym_centroid] = ACTIONS(3562),
    [anon_sym_noperspective] = ACTIONS(3562),
    [anon_sym_nointerpolation] = ACTIONS(3562),
    [anon_sym_sample] = ACTIONS(3562),
    [anon_sym_linear] = ACTIONS(3562),
    [anon_sym_snorm] = ACTIONS(3562),
    [anon_sym_unorm] = ACTIONS(3562),
    [anon_sym_point] = ACTIONS(3562),
    [anon_sym_line] = ACTIONS(3562),
    [anon_sym_triangleadj] = ACTIONS(3562),
    [anon_sym_lineadj] = ACTIONS(3562),
    [anon_sym_triangle] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_extension] = ACTIONS(3562),
    [anon_sym___init] = ACTIONS(3562),
    [anon_sym___subscript] = ACTIONS(3562),
    [anon_sym_property] = ACTIONS(3562),
    [anon_sym_associatedtype] = ACTIONS(3562),
  },
  [2217] = {
    [sym_expression] = STATE(5769),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2218] = {
    [sym_expression] = STATE(4313),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(6425),
    [anon_sym_BANG] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5262),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_DASH_DASH] = ACTIONS(5557),
    [anon_sym_PLUS_PLUS] = ACTIONS(5557),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [2219] = {
    [sym_expression] = STATE(5907),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2220] = {
    [sym_expression] = STATE(5670),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2221] = {
    [sym_identifier] = ACTIONS(3623),
    [aux_sym_preproc_def_token1] = ACTIONS(3623),
    [aux_sym_preproc_if_token1] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3623),
    [sym_preproc_directive] = ACTIONS(3623),
    [anon_sym_LPAREN2] = ACTIONS(3621),
    [anon_sym_TILDE] = ACTIONS(3621),
    [anon_sym_STAR] = ACTIONS(3621),
    [anon_sym_AMP_AMP] = ACTIONS(3621),
    [anon_sym_AMP] = ACTIONS(3623),
    [anon_sym_SEMI] = ACTIONS(3621),
    [anon_sym___extension__] = ACTIONS(3623),
    [anon_sym_typedef] = ACTIONS(3623),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_out] = ACTIONS(3623),
    [anon_sym_inout] = ACTIONS(3623),
    [anon_sym_virtual] = ACTIONS(3623),
    [anon_sym_extern] = ACTIONS(3623),
    [anon_sym___attribute__] = ACTIONS(3623),
    [anon_sym___attribute] = ACTIONS(3623),
    [anon_sym_using] = ACTIONS(3623),
    [anon_sym_COLON_COLON] = ACTIONS(3621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3621),
    [anon_sym___declspec] = ACTIONS(3623),
    [anon_sym___based] = ACTIONS(3623),
    [anon_sym_RBRACE] = ACTIONS(3621),
    [anon_sym_signed] = ACTIONS(3623),
    [anon_sym_unsigned] = ACTIONS(3623),
    [anon_sym_long] = ACTIONS(3623),
    [anon_sym_short] = ACTIONS(3623),
    [anon_sym_LBRACK] = ACTIONS(3623),
    [anon_sym_static] = ACTIONS(3623),
    [anon_sym_register] = ACTIONS(3623),
    [anon_sym_inline] = ACTIONS(3623),
    [anon_sym___inline] = ACTIONS(3623),
    [anon_sym___inline__] = ACTIONS(3623),
    [anon_sym___forceinline] = ACTIONS(3623),
    [anon_sym_thread_local] = ACTIONS(3623),
    [anon_sym___thread] = ACTIONS(3623),
    [anon_sym_const] = ACTIONS(3623),
    [anon_sym_constexpr] = ACTIONS(3623),
    [anon_sym_volatile] = ACTIONS(3623),
    [anon_sym_restrict] = ACTIONS(3623),
    [anon_sym___restrict__] = ACTIONS(3623),
    [anon_sym__Atomic] = ACTIONS(3623),
    [anon_sym__Noreturn] = ACTIONS(3623),
    [anon_sym_noreturn] = ACTIONS(3623),
    [anon_sym__Nonnull] = ACTIONS(3623),
    [anon_sym_mutable] = ACTIONS(3623),
    [anon_sym_constinit] = ACTIONS(3623),
    [anon_sym_consteval] = ACTIONS(3623),
    [anon_sym_alignas] = ACTIONS(3623),
    [anon_sym__Alignas] = ACTIONS(3623),
    [sym_primitive_type] = ACTIONS(3623),
    [anon_sym_enum] = ACTIONS(3623),
    [anon_sym_class] = ACTIONS(3623),
    [anon_sym_struct] = ACTIONS(3623),
    [anon_sym_union] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3623),
    [anon_sym_let] = ACTIONS(3623),
    [anon_sym_This] = ACTIONS(3623),
    [anon_sym_decltype] = ACTIONS(3623),
    [anon_sym_explicit] = ACTIONS(3623),
    [anon_sym_typename] = ACTIONS(3623),
    [anon_sym_private] = ACTIONS(3623),
    [anon_sym_template] = ACTIONS(3623),
    [anon_sym_operator] = ACTIONS(3623),
    [anon_sym_friend] = ACTIONS(3623),
    [anon_sym_public] = ACTIONS(3623),
    [anon_sym_protected] = ACTIONS(3623),
    [anon_sym_static_assert] = ACTIONS(3623),
    [anon_sym_precise] = ACTIONS(3623),
    [anon_sym_shared] = ACTIONS(3623),
    [anon_sym_groupshared] = ACTIONS(3623),
    [anon_sym_uniform] = ACTIONS(3623),
    [anon_sym_row_major] = ACTIONS(3623),
    [anon_sym_column_major] = ACTIONS(3623),
    [anon_sym_globallycoherent] = ACTIONS(3623),
    [anon_sym_centroid] = ACTIONS(3623),
    [anon_sym_noperspective] = ACTIONS(3623),
    [anon_sym_nointerpolation] = ACTIONS(3623),
    [anon_sym_sample] = ACTIONS(3623),
    [anon_sym_linear] = ACTIONS(3623),
    [anon_sym_snorm] = ACTIONS(3623),
    [anon_sym_unorm] = ACTIONS(3623),
    [anon_sym_point] = ACTIONS(3623),
    [anon_sym_line] = ACTIONS(3623),
    [anon_sym_triangleadj] = ACTIONS(3623),
    [anon_sym_lineadj] = ACTIONS(3623),
    [anon_sym_triangle] = ACTIONS(3623),
    [anon_sym_interface] = ACTIONS(3623),
    [anon_sym_extension] = ACTIONS(3623),
    [anon_sym___init] = ACTIONS(3623),
    [anon_sym___subscript] = ACTIONS(3623),
    [anon_sym_property] = ACTIONS(3623),
    [anon_sym_associatedtype] = ACTIONS(3623),
  },
  [2222] = {
    [sym_identifier] = ACTIONS(3623),
    [aux_sym_preproc_def_token1] = ACTIONS(3623),
    [aux_sym_preproc_if_token1] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3623),
    [sym_preproc_directive] = ACTIONS(3623),
    [anon_sym_LPAREN2] = ACTIONS(3621),
    [anon_sym_TILDE] = ACTIONS(3621),
    [anon_sym_STAR] = ACTIONS(3621),
    [anon_sym_AMP_AMP] = ACTIONS(3621),
    [anon_sym_AMP] = ACTIONS(3623),
    [anon_sym_SEMI] = ACTIONS(3621),
    [anon_sym___extension__] = ACTIONS(3623),
    [anon_sym_typedef] = ACTIONS(3623),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_out] = ACTIONS(3623),
    [anon_sym_inout] = ACTIONS(3623),
    [anon_sym_virtual] = ACTIONS(3623),
    [anon_sym_extern] = ACTIONS(3623),
    [anon_sym___attribute__] = ACTIONS(3623),
    [anon_sym___attribute] = ACTIONS(3623),
    [anon_sym_using] = ACTIONS(3623),
    [anon_sym_COLON_COLON] = ACTIONS(3621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3621),
    [anon_sym___declspec] = ACTIONS(3623),
    [anon_sym___based] = ACTIONS(3623),
    [anon_sym_RBRACE] = ACTIONS(3621),
    [anon_sym_signed] = ACTIONS(3623),
    [anon_sym_unsigned] = ACTIONS(3623),
    [anon_sym_long] = ACTIONS(3623),
    [anon_sym_short] = ACTIONS(3623),
    [anon_sym_LBRACK] = ACTIONS(3623),
    [anon_sym_static] = ACTIONS(3623),
    [anon_sym_register] = ACTIONS(3623),
    [anon_sym_inline] = ACTIONS(3623),
    [anon_sym___inline] = ACTIONS(3623),
    [anon_sym___inline__] = ACTIONS(3623),
    [anon_sym___forceinline] = ACTIONS(3623),
    [anon_sym_thread_local] = ACTIONS(3623),
    [anon_sym___thread] = ACTIONS(3623),
    [anon_sym_const] = ACTIONS(3623),
    [anon_sym_constexpr] = ACTIONS(3623),
    [anon_sym_volatile] = ACTIONS(3623),
    [anon_sym_restrict] = ACTIONS(3623),
    [anon_sym___restrict__] = ACTIONS(3623),
    [anon_sym__Atomic] = ACTIONS(3623),
    [anon_sym__Noreturn] = ACTIONS(3623),
    [anon_sym_noreturn] = ACTIONS(3623),
    [anon_sym__Nonnull] = ACTIONS(3623),
    [anon_sym_mutable] = ACTIONS(3623),
    [anon_sym_constinit] = ACTIONS(3623),
    [anon_sym_consteval] = ACTIONS(3623),
    [anon_sym_alignas] = ACTIONS(3623),
    [anon_sym__Alignas] = ACTIONS(3623),
    [sym_primitive_type] = ACTIONS(3623),
    [anon_sym_enum] = ACTIONS(3623),
    [anon_sym_class] = ACTIONS(3623),
    [anon_sym_struct] = ACTIONS(3623),
    [anon_sym_union] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3623),
    [anon_sym_let] = ACTIONS(3623),
    [anon_sym_This] = ACTIONS(3623),
    [anon_sym_decltype] = ACTIONS(3623),
    [anon_sym_explicit] = ACTIONS(3623),
    [anon_sym_typename] = ACTIONS(3623),
    [anon_sym_private] = ACTIONS(3623),
    [anon_sym_template] = ACTIONS(3623),
    [anon_sym_operator] = ACTIONS(3623),
    [anon_sym_friend] = ACTIONS(3623),
    [anon_sym_public] = ACTIONS(3623),
    [anon_sym_protected] = ACTIONS(3623),
    [anon_sym_static_assert] = ACTIONS(3623),
    [anon_sym_precise] = ACTIONS(3623),
    [anon_sym_shared] = ACTIONS(3623),
    [anon_sym_groupshared] = ACTIONS(3623),
    [anon_sym_uniform] = ACTIONS(3623),
    [anon_sym_row_major] = ACTIONS(3623),
    [anon_sym_column_major] = ACTIONS(3623),
    [anon_sym_globallycoherent] = ACTIONS(3623),
    [anon_sym_centroid] = ACTIONS(3623),
    [anon_sym_noperspective] = ACTIONS(3623),
    [anon_sym_nointerpolation] = ACTIONS(3623),
    [anon_sym_sample] = ACTIONS(3623),
    [anon_sym_linear] = ACTIONS(3623),
    [anon_sym_snorm] = ACTIONS(3623),
    [anon_sym_unorm] = ACTIONS(3623),
    [anon_sym_point] = ACTIONS(3623),
    [anon_sym_line] = ACTIONS(3623),
    [anon_sym_triangleadj] = ACTIONS(3623),
    [anon_sym_lineadj] = ACTIONS(3623),
    [anon_sym_triangle] = ACTIONS(3623),
    [anon_sym_interface] = ACTIONS(3623),
    [anon_sym_extension] = ACTIONS(3623),
    [anon_sym___init] = ACTIONS(3623),
    [anon_sym___subscript] = ACTIONS(3623),
    [anon_sym_property] = ACTIONS(3623),
    [anon_sym_associatedtype] = ACTIONS(3623),
  },
  [2223] = {
    [sym_identifier] = ACTIONS(3399),
    [aux_sym_preproc_def_token1] = ACTIONS(3399),
    [aux_sym_preproc_if_token1] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3399),
    [sym_preproc_directive] = ACTIONS(3399),
    [anon_sym_LPAREN2] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_STAR] = ACTIONS(3401),
    [anon_sym_AMP_AMP] = ACTIONS(3401),
    [anon_sym_AMP] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym___extension__] = ACTIONS(3399),
    [anon_sym_typedef] = ACTIONS(3399),
    [anon_sym_in] = ACTIONS(3399),
    [anon_sym_out] = ACTIONS(3399),
    [anon_sym_inout] = ACTIONS(3399),
    [anon_sym_virtual] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym___attribute__] = ACTIONS(3399),
    [anon_sym___attribute] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_COLON_COLON] = ACTIONS(3401),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3401),
    [anon_sym___declspec] = ACTIONS(3399),
    [anon_sym___based] = ACTIONS(3399),
    [anon_sym_RBRACE] = ACTIONS(3401),
    [anon_sym_signed] = ACTIONS(3399),
    [anon_sym_unsigned] = ACTIONS(3399),
    [anon_sym_long] = ACTIONS(3399),
    [anon_sym_short] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_register] = ACTIONS(3399),
    [anon_sym_inline] = ACTIONS(3399),
    [anon_sym___inline] = ACTIONS(3399),
    [anon_sym___inline__] = ACTIONS(3399),
    [anon_sym___forceinline] = ACTIONS(3399),
    [anon_sym_thread_local] = ACTIONS(3399),
    [anon_sym___thread] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_constexpr] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym_restrict] = ACTIONS(3399),
    [anon_sym___restrict__] = ACTIONS(3399),
    [anon_sym__Atomic] = ACTIONS(3399),
    [anon_sym__Noreturn] = ACTIONS(3399),
    [anon_sym_noreturn] = ACTIONS(3399),
    [anon_sym__Nonnull] = ACTIONS(3399),
    [anon_sym_mutable] = ACTIONS(3399),
    [anon_sym_constinit] = ACTIONS(3399),
    [anon_sym_consteval] = ACTIONS(3399),
    [anon_sym_alignas] = ACTIONS(3399),
    [anon_sym__Alignas] = ACTIONS(3399),
    [sym_primitive_type] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_union] = ACTIONS(3399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_This] = ACTIONS(3399),
    [anon_sym_decltype] = ACTIONS(3399),
    [anon_sym_explicit] = ACTIONS(3399),
    [anon_sym_typename] = ACTIONS(3399),
    [anon_sym_private] = ACTIONS(3399),
    [anon_sym_template] = ACTIONS(3399),
    [anon_sym_operator] = ACTIONS(3399),
    [anon_sym_friend] = ACTIONS(3399),
    [anon_sym_public] = ACTIONS(3399),
    [anon_sym_protected] = ACTIONS(3399),
    [anon_sym_static_assert] = ACTIONS(3399),
    [anon_sym_precise] = ACTIONS(3399),
    [anon_sym_shared] = ACTIONS(3399),
    [anon_sym_groupshared] = ACTIONS(3399),
    [anon_sym_uniform] = ACTIONS(3399),
    [anon_sym_row_major] = ACTIONS(3399),
    [anon_sym_column_major] = ACTIONS(3399),
    [anon_sym_globallycoherent] = ACTIONS(3399),
    [anon_sym_centroid] = ACTIONS(3399),
    [anon_sym_noperspective] = ACTIONS(3399),
    [anon_sym_nointerpolation] = ACTIONS(3399),
    [anon_sym_sample] = ACTIONS(3399),
    [anon_sym_linear] = ACTIONS(3399),
    [anon_sym_snorm] = ACTIONS(3399),
    [anon_sym_unorm] = ACTIONS(3399),
    [anon_sym_point] = ACTIONS(3399),
    [anon_sym_line] = ACTIONS(3399),
    [anon_sym_triangleadj] = ACTIONS(3399),
    [anon_sym_lineadj] = ACTIONS(3399),
    [anon_sym_triangle] = ACTIONS(3399),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_extension] = ACTIONS(3399),
    [anon_sym___init] = ACTIONS(3399),
    [anon_sym___subscript] = ACTIONS(3399),
    [anon_sym_property] = ACTIONS(3399),
    [anon_sym_associatedtype] = ACTIONS(3399),
  },
  [2224] = {
    [sym_identifier] = ACTIONS(3399),
    [aux_sym_preproc_def_token1] = ACTIONS(3399),
    [aux_sym_preproc_if_token1] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3399),
    [sym_preproc_directive] = ACTIONS(3399),
    [anon_sym_LPAREN2] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_STAR] = ACTIONS(3401),
    [anon_sym_AMP_AMP] = ACTIONS(3401),
    [anon_sym_AMP] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym___extension__] = ACTIONS(3399),
    [anon_sym_typedef] = ACTIONS(3399),
    [anon_sym_in] = ACTIONS(3399),
    [anon_sym_out] = ACTIONS(3399),
    [anon_sym_inout] = ACTIONS(3399),
    [anon_sym_virtual] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym___attribute__] = ACTIONS(3399),
    [anon_sym___attribute] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_COLON_COLON] = ACTIONS(3401),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3401),
    [anon_sym___declspec] = ACTIONS(3399),
    [anon_sym___based] = ACTIONS(3399),
    [anon_sym_RBRACE] = ACTIONS(3401),
    [anon_sym_signed] = ACTIONS(3399),
    [anon_sym_unsigned] = ACTIONS(3399),
    [anon_sym_long] = ACTIONS(3399),
    [anon_sym_short] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_register] = ACTIONS(3399),
    [anon_sym_inline] = ACTIONS(3399),
    [anon_sym___inline] = ACTIONS(3399),
    [anon_sym___inline__] = ACTIONS(3399),
    [anon_sym___forceinline] = ACTIONS(3399),
    [anon_sym_thread_local] = ACTIONS(3399),
    [anon_sym___thread] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_constexpr] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym_restrict] = ACTIONS(3399),
    [anon_sym___restrict__] = ACTIONS(3399),
    [anon_sym__Atomic] = ACTIONS(3399),
    [anon_sym__Noreturn] = ACTIONS(3399),
    [anon_sym_noreturn] = ACTIONS(3399),
    [anon_sym__Nonnull] = ACTIONS(3399),
    [anon_sym_mutable] = ACTIONS(3399),
    [anon_sym_constinit] = ACTIONS(3399),
    [anon_sym_consteval] = ACTIONS(3399),
    [anon_sym_alignas] = ACTIONS(3399),
    [anon_sym__Alignas] = ACTIONS(3399),
    [sym_primitive_type] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_union] = ACTIONS(3399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_This] = ACTIONS(3399),
    [anon_sym_decltype] = ACTIONS(3399),
    [anon_sym_explicit] = ACTIONS(3399),
    [anon_sym_typename] = ACTIONS(3399),
    [anon_sym_private] = ACTIONS(3399),
    [anon_sym_template] = ACTIONS(3399),
    [anon_sym_operator] = ACTIONS(3399),
    [anon_sym_friend] = ACTIONS(3399),
    [anon_sym_public] = ACTIONS(3399),
    [anon_sym_protected] = ACTIONS(3399),
    [anon_sym_static_assert] = ACTIONS(3399),
    [anon_sym_precise] = ACTIONS(3399),
    [anon_sym_shared] = ACTIONS(3399),
    [anon_sym_groupshared] = ACTIONS(3399),
    [anon_sym_uniform] = ACTIONS(3399),
    [anon_sym_row_major] = ACTIONS(3399),
    [anon_sym_column_major] = ACTIONS(3399),
    [anon_sym_globallycoherent] = ACTIONS(3399),
    [anon_sym_centroid] = ACTIONS(3399),
    [anon_sym_noperspective] = ACTIONS(3399),
    [anon_sym_nointerpolation] = ACTIONS(3399),
    [anon_sym_sample] = ACTIONS(3399),
    [anon_sym_linear] = ACTIONS(3399),
    [anon_sym_snorm] = ACTIONS(3399),
    [anon_sym_unorm] = ACTIONS(3399),
    [anon_sym_point] = ACTIONS(3399),
    [anon_sym_line] = ACTIONS(3399),
    [anon_sym_triangleadj] = ACTIONS(3399),
    [anon_sym_lineadj] = ACTIONS(3399),
    [anon_sym_triangle] = ACTIONS(3399),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_extension] = ACTIONS(3399),
    [anon_sym___init] = ACTIONS(3399),
    [anon_sym___subscript] = ACTIONS(3399),
    [anon_sym_property] = ACTIONS(3399),
    [anon_sym_associatedtype] = ACTIONS(3399),
  },
  [2225] = {
    [sym_expression] = STATE(4116),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [2226] = {
    [sym_identifier] = ACTIONS(3967),
    [aux_sym_preproc_def_token1] = ACTIONS(3967),
    [aux_sym_preproc_if_token1] = ACTIONS(3967),
    [aux_sym_preproc_if_token2] = ACTIONS(3967),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3967),
    [sym_preproc_directive] = ACTIONS(3967),
    [anon_sym_LPAREN2] = ACTIONS(3969),
    [anon_sym_TILDE] = ACTIONS(3969),
    [anon_sym_STAR] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_AMP] = ACTIONS(3967),
    [anon_sym_SEMI] = ACTIONS(3969),
    [anon_sym___extension__] = ACTIONS(3967),
    [anon_sym_typedef] = ACTIONS(3967),
    [anon_sym_in] = ACTIONS(3967),
    [anon_sym_out] = ACTIONS(3967),
    [anon_sym_inout] = ACTIONS(3967),
    [anon_sym_virtual] = ACTIONS(3967),
    [anon_sym_extern] = ACTIONS(3967),
    [anon_sym___attribute__] = ACTIONS(3967),
    [anon_sym___attribute] = ACTIONS(3967),
    [anon_sym_using] = ACTIONS(3967),
    [anon_sym_COLON_COLON] = ACTIONS(3969),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3969),
    [anon_sym___declspec] = ACTIONS(3967),
    [anon_sym___based] = ACTIONS(3967),
    [anon_sym_signed] = ACTIONS(3967),
    [anon_sym_unsigned] = ACTIONS(3967),
    [anon_sym_long] = ACTIONS(3967),
    [anon_sym_short] = ACTIONS(3967),
    [anon_sym_LBRACK] = ACTIONS(3967),
    [anon_sym_static] = ACTIONS(3967),
    [anon_sym_register] = ACTIONS(3967),
    [anon_sym_inline] = ACTIONS(3967),
    [anon_sym___inline] = ACTIONS(3967),
    [anon_sym___inline__] = ACTIONS(3967),
    [anon_sym___forceinline] = ACTIONS(3967),
    [anon_sym_thread_local] = ACTIONS(3967),
    [anon_sym___thread] = ACTIONS(3967),
    [anon_sym_const] = ACTIONS(3967),
    [anon_sym_constexpr] = ACTIONS(3967),
    [anon_sym_volatile] = ACTIONS(3967),
    [anon_sym_restrict] = ACTIONS(3967),
    [anon_sym___restrict__] = ACTIONS(3967),
    [anon_sym__Atomic] = ACTIONS(3967),
    [anon_sym__Noreturn] = ACTIONS(3967),
    [anon_sym_noreturn] = ACTIONS(3967),
    [anon_sym__Nonnull] = ACTIONS(3967),
    [anon_sym_mutable] = ACTIONS(3967),
    [anon_sym_constinit] = ACTIONS(3967),
    [anon_sym_consteval] = ACTIONS(3967),
    [anon_sym_alignas] = ACTIONS(3967),
    [anon_sym__Alignas] = ACTIONS(3967),
    [sym_primitive_type] = ACTIONS(3967),
    [anon_sym_enum] = ACTIONS(3967),
    [anon_sym_class] = ACTIONS(3967),
    [anon_sym_struct] = ACTIONS(3967),
    [anon_sym_union] = ACTIONS(3967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3967),
    [anon_sym_let] = ACTIONS(3967),
    [anon_sym_This] = ACTIONS(3967),
    [anon_sym_decltype] = ACTIONS(3967),
    [anon_sym_explicit] = ACTIONS(3967),
    [anon_sym_typename] = ACTIONS(3967),
    [anon_sym_private] = ACTIONS(3967),
    [anon_sym_template] = ACTIONS(3967),
    [anon_sym_operator] = ACTIONS(3967),
    [anon_sym_friend] = ACTIONS(3967),
    [anon_sym_public] = ACTIONS(3967),
    [anon_sym_protected] = ACTIONS(3967),
    [anon_sym_static_assert] = ACTIONS(3967),
    [anon_sym_precise] = ACTIONS(3967),
    [anon_sym_shared] = ACTIONS(3967),
    [anon_sym_groupshared] = ACTIONS(3967),
    [anon_sym_uniform] = ACTIONS(3967),
    [anon_sym_row_major] = ACTIONS(3967),
    [anon_sym_column_major] = ACTIONS(3967),
    [anon_sym_globallycoherent] = ACTIONS(3967),
    [anon_sym_centroid] = ACTIONS(3967),
    [anon_sym_noperspective] = ACTIONS(3967),
    [anon_sym_nointerpolation] = ACTIONS(3967),
    [anon_sym_sample] = ACTIONS(3967),
    [anon_sym_linear] = ACTIONS(3967),
    [anon_sym_snorm] = ACTIONS(3967),
    [anon_sym_unorm] = ACTIONS(3967),
    [anon_sym_point] = ACTIONS(3967),
    [anon_sym_line] = ACTIONS(3967),
    [anon_sym_triangleadj] = ACTIONS(3967),
    [anon_sym_lineadj] = ACTIONS(3967),
    [anon_sym_triangle] = ACTIONS(3967),
    [anon_sym_interface] = ACTIONS(3967),
    [anon_sym_extension] = ACTIONS(3967),
    [anon_sym___init] = ACTIONS(3967),
    [anon_sym___subscript] = ACTIONS(3967),
    [anon_sym_property] = ACTIONS(3967),
    [anon_sym_associatedtype] = ACTIONS(3967),
  },
  [2227] = {
    [sym_expression] = STATE(3877),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5032),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACK] = ACTIONS(6680),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2228] = {
    [sym_identifier] = ACTIONS(3661),
    [aux_sym_preproc_def_token1] = ACTIONS(3661),
    [aux_sym_preproc_if_token1] = ACTIONS(3661),
    [aux_sym_preproc_if_token2] = ACTIONS(3661),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3661),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3661),
    [sym_preproc_directive] = ACTIONS(3661),
    [anon_sym_LPAREN2] = ACTIONS(3663),
    [anon_sym_TILDE] = ACTIONS(3663),
    [anon_sym_STAR] = ACTIONS(3663),
    [anon_sym_AMP_AMP] = ACTIONS(3663),
    [anon_sym_AMP] = ACTIONS(3661),
    [anon_sym_SEMI] = ACTIONS(3663),
    [anon_sym___extension__] = ACTIONS(3661),
    [anon_sym_typedef] = ACTIONS(3661),
    [anon_sym_in] = ACTIONS(3661),
    [anon_sym_out] = ACTIONS(3661),
    [anon_sym_inout] = ACTIONS(3661),
    [anon_sym_virtual] = ACTIONS(3661),
    [anon_sym_extern] = ACTIONS(3661),
    [anon_sym___attribute__] = ACTIONS(3661),
    [anon_sym___attribute] = ACTIONS(3661),
    [anon_sym_using] = ACTIONS(3661),
    [anon_sym_COLON_COLON] = ACTIONS(3663),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3663),
    [anon_sym___declspec] = ACTIONS(3661),
    [anon_sym___based] = ACTIONS(3661),
    [anon_sym_signed] = ACTIONS(3661),
    [anon_sym_unsigned] = ACTIONS(3661),
    [anon_sym_long] = ACTIONS(3661),
    [anon_sym_short] = ACTIONS(3661),
    [anon_sym_LBRACK] = ACTIONS(3661),
    [anon_sym_static] = ACTIONS(3661),
    [anon_sym_register] = ACTIONS(3661),
    [anon_sym_inline] = ACTIONS(3661),
    [anon_sym___inline] = ACTIONS(3661),
    [anon_sym___inline__] = ACTIONS(3661),
    [anon_sym___forceinline] = ACTIONS(3661),
    [anon_sym_thread_local] = ACTIONS(3661),
    [anon_sym___thread] = ACTIONS(3661),
    [anon_sym_const] = ACTIONS(3661),
    [anon_sym_constexpr] = ACTIONS(3661),
    [anon_sym_volatile] = ACTIONS(3661),
    [anon_sym_restrict] = ACTIONS(3661),
    [anon_sym___restrict__] = ACTIONS(3661),
    [anon_sym__Atomic] = ACTIONS(3661),
    [anon_sym__Noreturn] = ACTIONS(3661),
    [anon_sym_noreturn] = ACTIONS(3661),
    [anon_sym__Nonnull] = ACTIONS(3661),
    [anon_sym_mutable] = ACTIONS(3661),
    [anon_sym_constinit] = ACTIONS(3661),
    [anon_sym_consteval] = ACTIONS(3661),
    [anon_sym_alignas] = ACTIONS(3661),
    [anon_sym__Alignas] = ACTIONS(3661),
    [sym_primitive_type] = ACTIONS(3661),
    [anon_sym_enum] = ACTIONS(3661),
    [anon_sym_class] = ACTIONS(3661),
    [anon_sym_struct] = ACTIONS(3661),
    [anon_sym_union] = ACTIONS(3661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3661),
    [anon_sym_let] = ACTIONS(3661),
    [anon_sym_This] = ACTIONS(3661),
    [anon_sym_decltype] = ACTIONS(3661),
    [anon_sym_explicit] = ACTIONS(3661),
    [anon_sym_typename] = ACTIONS(3661),
    [anon_sym_private] = ACTIONS(3661),
    [anon_sym_template] = ACTIONS(3661),
    [anon_sym_operator] = ACTIONS(3661),
    [anon_sym_friend] = ACTIONS(3661),
    [anon_sym_public] = ACTIONS(3661),
    [anon_sym_protected] = ACTIONS(3661),
    [anon_sym_static_assert] = ACTIONS(3661),
    [anon_sym_precise] = ACTIONS(3661),
    [anon_sym_shared] = ACTIONS(3661),
    [anon_sym_groupshared] = ACTIONS(3661),
    [anon_sym_uniform] = ACTIONS(3661),
    [anon_sym_row_major] = ACTIONS(3661),
    [anon_sym_column_major] = ACTIONS(3661),
    [anon_sym_globallycoherent] = ACTIONS(3661),
    [anon_sym_centroid] = ACTIONS(3661),
    [anon_sym_noperspective] = ACTIONS(3661),
    [anon_sym_nointerpolation] = ACTIONS(3661),
    [anon_sym_sample] = ACTIONS(3661),
    [anon_sym_linear] = ACTIONS(3661),
    [anon_sym_snorm] = ACTIONS(3661),
    [anon_sym_unorm] = ACTIONS(3661),
    [anon_sym_point] = ACTIONS(3661),
    [anon_sym_line] = ACTIONS(3661),
    [anon_sym_triangleadj] = ACTIONS(3661),
    [anon_sym_lineadj] = ACTIONS(3661),
    [anon_sym_triangle] = ACTIONS(3661),
    [anon_sym_interface] = ACTIONS(3661),
    [anon_sym_extension] = ACTIONS(3661),
    [anon_sym___init] = ACTIONS(3661),
    [anon_sym___subscript] = ACTIONS(3661),
    [anon_sym_property] = ACTIONS(3661),
    [anon_sym_associatedtype] = ACTIONS(3661),
  },
  [2229] = {
    [sym_identifier] = ACTIONS(3784),
    [aux_sym_preproc_def_token1] = ACTIONS(3784),
    [aux_sym_preproc_if_token1] = ACTIONS(3784),
    [aux_sym_preproc_if_token2] = ACTIONS(3784),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3784),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3784),
    [sym_preproc_directive] = ACTIONS(3784),
    [anon_sym_LPAREN2] = ACTIONS(3786),
    [anon_sym_TILDE] = ACTIONS(3786),
    [anon_sym_STAR] = ACTIONS(3786),
    [anon_sym_AMP_AMP] = ACTIONS(3786),
    [anon_sym_AMP] = ACTIONS(3784),
    [anon_sym_SEMI] = ACTIONS(3786),
    [anon_sym___extension__] = ACTIONS(3784),
    [anon_sym_typedef] = ACTIONS(3784),
    [anon_sym_in] = ACTIONS(3784),
    [anon_sym_out] = ACTIONS(3784),
    [anon_sym_inout] = ACTIONS(3784),
    [anon_sym_virtual] = ACTIONS(3784),
    [anon_sym_extern] = ACTIONS(3784),
    [anon_sym___attribute__] = ACTIONS(3784),
    [anon_sym___attribute] = ACTIONS(3784),
    [anon_sym_using] = ACTIONS(3784),
    [anon_sym_COLON_COLON] = ACTIONS(3786),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3786),
    [anon_sym___declspec] = ACTIONS(3784),
    [anon_sym___based] = ACTIONS(3784),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3784),
    [anon_sym_static] = ACTIONS(3784),
    [anon_sym_register] = ACTIONS(3784),
    [anon_sym_inline] = ACTIONS(3784),
    [anon_sym___inline] = ACTIONS(3784),
    [anon_sym___inline__] = ACTIONS(3784),
    [anon_sym___forceinline] = ACTIONS(3784),
    [anon_sym_thread_local] = ACTIONS(3784),
    [anon_sym___thread] = ACTIONS(3784),
    [anon_sym_const] = ACTIONS(3784),
    [anon_sym_constexpr] = ACTIONS(3784),
    [anon_sym_volatile] = ACTIONS(3784),
    [anon_sym_restrict] = ACTIONS(3784),
    [anon_sym___restrict__] = ACTIONS(3784),
    [anon_sym__Atomic] = ACTIONS(3784),
    [anon_sym__Noreturn] = ACTIONS(3784),
    [anon_sym_noreturn] = ACTIONS(3784),
    [anon_sym__Nonnull] = ACTIONS(3784),
    [anon_sym_mutable] = ACTIONS(3784),
    [anon_sym_constinit] = ACTIONS(3784),
    [anon_sym_consteval] = ACTIONS(3784),
    [anon_sym_alignas] = ACTIONS(3784),
    [anon_sym__Alignas] = ACTIONS(3784),
    [sym_primitive_type] = ACTIONS(3784),
    [anon_sym_enum] = ACTIONS(3784),
    [anon_sym_class] = ACTIONS(3784),
    [anon_sym_struct] = ACTIONS(3784),
    [anon_sym_union] = ACTIONS(3784),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3784),
    [anon_sym_let] = ACTIONS(3784),
    [anon_sym_This] = ACTIONS(3784),
    [anon_sym_decltype] = ACTIONS(3784),
    [anon_sym_explicit] = ACTIONS(3784),
    [anon_sym_typename] = ACTIONS(3784),
    [anon_sym_private] = ACTIONS(3784),
    [anon_sym_template] = ACTIONS(3784),
    [anon_sym_operator] = ACTIONS(3784),
    [anon_sym_friend] = ACTIONS(3784),
    [anon_sym_public] = ACTIONS(3784),
    [anon_sym_protected] = ACTIONS(3784),
    [anon_sym_static_assert] = ACTIONS(3784),
    [anon_sym_precise] = ACTIONS(3784),
    [anon_sym_shared] = ACTIONS(3784),
    [anon_sym_groupshared] = ACTIONS(3784),
    [anon_sym_uniform] = ACTIONS(3784),
    [anon_sym_row_major] = ACTIONS(3784),
    [anon_sym_column_major] = ACTIONS(3784),
    [anon_sym_globallycoherent] = ACTIONS(3784),
    [anon_sym_centroid] = ACTIONS(3784),
    [anon_sym_noperspective] = ACTIONS(3784),
    [anon_sym_nointerpolation] = ACTIONS(3784),
    [anon_sym_sample] = ACTIONS(3784),
    [anon_sym_linear] = ACTIONS(3784),
    [anon_sym_snorm] = ACTIONS(3784),
    [anon_sym_unorm] = ACTIONS(3784),
    [anon_sym_point] = ACTIONS(3784),
    [anon_sym_line] = ACTIONS(3784),
    [anon_sym_triangleadj] = ACTIONS(3784),
    [anon_sym_lineadj] = ACTIONS(3784),
    [anon_sym_triangle] = ACTIONS(3784),
    [anon_sym_interface] = ACTIONS(3784),
    [anon_sym_extension] = ACTIONS(3784),
    [anon_sym___init] = ACTIONS(3784),
    [anon_sym___subscript] = ACTIONS(3784),
    [anon_sym_property] = ACTIONS(3784),
    [anon_sym_associatedtype] = ACTIONS(3784),
  },
  [2230] = {
    [sym_identifier] = ACTIONS(3828),
    [aux_sym_preproc_def_token1] = ACTIONS(3828),
    [aux_sym_preproc_if_token1] = ACTIONS(3828),
    [aux_sym_preproc_if_token2] = ACTIONS(3828),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3828),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3828),
    [sym_preproc_directive] = ACTIONS(3828),
    [anon_sym_LPAREN2] = ACTIONS(3830),
    [anon_sym_TILDE] = ACTIONS(3830),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_SEMI] = ACTIONS(3830),
    [anon_sym___extension__] = ACTIONS(3828),
    [anon_sym_typedef] = ACTIONS(3828),
    [anon_sym_in] = ACTIONS(3828),
    [anon_sym_out] = ACTIONS(3828),
    [anon_sym_inout] = ACTIONS(3828),
    [anon_sym_virtual] = ACTIONS(3828),
    [anon_sym_extern] = ACTIONS(3828),
    [anon_sym___attribute__] = ACTIONS(3828),
    [anon_sym___attribute] = ACTIONS(3828),
    [anon_sym_using] = ACTIONS(3828),
    [anon_sym_COLON_COLON] = ACTIONS(3830),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3830),
    [anon_sym___declspec] = ACTIONS(3828),
    [anon_sym___based] = ACTIONS(3828),
    [anon_sym_signed] = ACTIONS(3828),
    [anon_sym_unsigned] = ACTIONS(3828),
    [anon_sym_long] = ACTIONS(3828),
    [anon_sym_short] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_static] = ACTIONS(3828),
    [anon_sym_register] = ACTIONS(3828),
    [anon_sym_inline] = ACTIONS(3828),
    [anon_sym___inline] = ACTIONS(3828),
    [anon_sym___inline__] = ACTIONS(3828),
    [anon_sym___forceinline] = ACTIONS(3828),
    [anon_sym_thread_local] = ACTIONS(3828),
    [anon_sym___thread] = ACTIONS(3828),
    [anon_sym_const] = ACTIONS(3828),
    [anon_sym_constexpr] = ACTIONS(3828),
    [anon_sym_volatile] = ACTIONS(3828),
    [anon_sym_restrict] = ACTIONS(3828),
    [anon_sym___restrict__] = ACTIONS(3828),
    [anon_sym__Atomic] = ACTIONS(3828),
    [anon_sym__Noreturn] = ACTIONS(3828),
    [anon_sym_noreturn] = ACTIONS(3828),
    [anon_sym__Nonnull] = ACTIONS(3828),
    [anon_sym_mutable] = ACTIONS(3828),
    [anon_sym_constinit] = ACTIONS(3828),
    [anon_sym_consteval] = ACTIONS(3828),
    [anon_sym_alignas] = ACTIONS(3828),
    [anon_sym__Alignas] = ACTIONS(3828),
    [sym_primitive_type] = ACTIONS(3828),
    [anon_sym_enum] = ACTIONS(3828),
    [anon_sym_class] = ACTIONS(3828),
    [anon_sym_struct] = ACTIONS(3828),
    [anon_sym_union] = ACTIONS(3828),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3828),
    [anon_sym_This] = ACTIONS(3828),
    [anon_sym_decltype] = ACTIONS(3828),
    [anon_sym_explicit] = ACTIONS(3828),
    [anon_sym_typename] = ACTIONS(3828),
    [anon_sym_private] = ACTIONS(3828),
    [anon_sym_template] = ACTIONS(3828),
    [anon_sym_operator] = ACTIONS(3828),
    [anon_sym_friend] = ACTIONS(3828),
    [anon_sym_public] = ACTIONS(3828),
    [anon_sym_protected] = ACTIONS(3828),
    [anon_sym_static_assert] = ACTIONS(3828),
    [anon_sym_precise] = ACTIONS(3828),
    [anon_sym_shared] = ACTIONS(3828),
    [anon_sym_groupshared] = ACTIONS(3828),
    [anon_sym_uniform] = ACTIONS(3828),
    [anon_sym_row_major] = ACTIONS(3828),
    [anon_sym_column_major] = ACTIONS(3828),
    [anon_sym_globallycoherent] = ACTIONS(3828),
    [anon_sym_centroid] = ACTIONS(3828),
    [anon_sym_noperspective] = ACTIONS(3828),
    [anon_sym_nointerpolation] = ACTIONS(3828),
    [anon_sym_sample] = ACTIONS(3828),
    [anon_sym_linear] = ACTIONS(3828),
    [anon_sym_snorm] = ACTIONS(3828),
    [anon_sym_unorm] = ACTIONS(3828),
    [anon_sym_point] = ACTIONS(3828),
    [anon_sym_line] = ACTIONS(3828),
    [anon_sym_triangleadj] = ACTIONS(3828),
    [anon_sym_lineadj] = ACTIONS(3828),
    [anon_sym_triangle] = ACTIONS(3828),
    [anon_sym_interface] = ACTIONS(3828),
    [anon_sym_extension] = ACTIONS(3828),
    [anon_sym___init] = ACTIONS(3828),
    [anon_sym___subscript] = ACTIONS(3828),
    [anon_sym_property] = ACTIONS(3828),
    [anon_sym_associatedtype] = ACTIONS(3828),
  },
  [2231] = {
    [sym_expression] = STATE(3865),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5032),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2232] = {
    [sym_identifier] = ACTIONS(3919),
    [aux_sym_preproc_def_token1] = ACTIONS(3919),
    [aux_sym_preproc_if_token1] = ACTIONS(3919),
    [aux_sym_preproc_if_token2] = ACTIONS(3919),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3919),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3919),
    [sym_preproc_directive] = ACTIONS(3919),
    [anon_sym_LPAREN2] = ACTIONS(3921),
    [anon_sym_TILDE] = ACTIONS(3921),
    [anon_sym_STAR] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_AMP] = ACTIONS(3919),
    [anon_sym_SEMI] = ACTIONS(3921),
    [anon_sym___extension__] = ACTIONS(3919),
    [anon_sym_typedef] = ACTIONS(3919),
    [anon_sym_in] = ACTIONS(3919),
    [anon_sym_out] = ACTIONS(3919),
    [anon_sym_inout] = ACTIONS(3919),
    [anon_sym_virtual] = ACTIONS(3919),
    [anon_sym_extern] = ACTIONS(3919),
    [anon_sym___attribute__] = ACTIONS(3919),
    [anon_sym___attribute] = ACTIONS(3919),
    [anon_sym_using] = ACTIONS(3919),
    [anon_sym_COLON_COLON] = ACTIONS(3921),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3921),
    [anon_sym___declspec] = ACTIONS(3919),
    [anon_sym___based] = ACTIONS(3919),
    [anon_sym_signed] = ACTIONS(3919),
    [anon_sym_unsigned] = ACTIONS(3919),
    [anon_sym_long] = ACTIONS(3919),
    [anon_sym_short] = ACTIONS(3919),
    [anon_sym_LBRACK] = ACTIONS(3919),
    [anon_sym_static] = ACTIONS(3919),
    [anon_sym_register] = ACTIONS(3919),
    [anon_sym_inline] = ACTIONS(3919),
    [anon_sym___inline] = ACTIONS(3919),
    [anon_sym___inline__] = ACTIONS(3919),
    [anon_sym___forceinline] = ACTIONS(3919),
    [anon_sym_thread_local] = ACTIONS(3919),
    [anon_sym___thread] = ACTIONS(3919),
    [anon_sym_const] = ACTIONS(3919),
    [anon_sym_constexpr] = ACTIONS(3919),
    [anon_sym_volatile] = ACTIONS(3919),
    [anon_sym_restrict] = ACTIONS(3919),
    [anon_sym___restrict__] = ACTIONS(3919),
    [anon_sym__Atomic] = ACTIONS(3919),
    [anon_sym__Noreturn] = ACTIONS(3919),
    [anon_sym_noreturn] = ACTIONS(3919),
    [anon_sym__Nonnull] = ACTIONS(3919),
    [anon_sym_mutable] = ACTIONS(3919),
    [anon_sym_constinit] = ACTIONS(3919),
    [anon_sym_consteval] = ACTIONS(3919),
    [anon_sym_alignas] = ACTIONS(3919),
    [anon_sym__Alignas] = ACTIONS(3919),
    [sym_primitive_type] = ACTIONS(3919),
    [anon_sym_enum] = ACTIONS(3919),
    [anon_sym_class] = ACTIONS(3919),
    [anon_sym_struct] = ACTIONS(3919),
    [anon_sym_union] = ACTIONS(3919),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3919),
    [anon_sym_let] = ACTIONS(3919),
    [anon_sym_This] = ACTIONS(3919),
    [anon_sym_decltype] = ACTIONS(3919),
    [anon_sym_explicit] = ACTIONS(3919),
    [anon_sym_typename] = ACTIONS(3919),
    [anon_sym_private] = ACTIONS(3919),
    [anon_sym_template] = ACTIONS(3919),
    [anon_sym_operator] = ACTIONS(3919),
    [anon_sym_friend] = ACTIONS(3919),
    [anon_sym_public] = ACTIONS(3919),
    [anon_sym_protected] = ACTIONS(3919),
    [anon_sym_static_assert] = ACTIONS(3919),
    [anon_sym_precise] = ACTIONS(3919),
    [anon_sym_shared] = ACTIONS(3919),
    [anon_sym_groupshared] = ACTIONS(3919),
    [anon_sym_uniform] = ACTIONS(3919),
    [anon_sym_row_major] = ACTIONS(3919),
    [anon_sym_column_major] = ACTIONS(3919),
    [anon_sym_globallycoherent] = ACTIONS(3919),
    [anon_sym_centroid] = ACTIONS(3919),
    [anon_sym_noperspective] = ACTIONS(3919),
    [anon_sym_nointerpolation] = ACTIONS(3919),
    [anon_sym_sample] = ACTIONS(3919),
    [anon_sym_linear] = ACTIONS(3919),
    [anon_sym_snorm] = ACTIONS(3919),
    [anon_sym_unorm] = ACTIONS(3919),
    [anon_sym_point] = ACTIONS(3919),
    [anon_sym_line] = ACTIONS(3919),
    [anon_sym_triangleadj] = ACTIONS(3919),
    [anon_sym_lineadj] = ACTIONS(3919),
    [anon_sym_triangle] = ACTIONS(3919),
    [anon_sym_interface] = ACTIONS(3919),
    [anon_sym_extension] = ACTIONS(3919),
    [anon_sym___init] = ACTIONS(3919),
    [anon_sym___subscript] = ACTIONS(3919),
    [anon_sym_property] = ACTIONS(3919),
    [anon_sym_associatedtype] = ACTIONS(3919),
  },
  [2233] = {
    [sym_identifier] = ACTIONS(3949),
    [aux_sym_preproc_def_token1] = ACTIONS(3949),
    [aux_sym_preproc_if_token1] = ACTIONS(3949),
    [aux_sym_preproc_if_token2] = ACTIONS(3949),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3949),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3949),
    [sym_preproc_directive] = ACTIONS(3949),
    [anon_sym_LPAREN2] = ACTIONS(3951),
    [anon_sym_TILDE] = ACTIONS(3951),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3949),
    [anon_sym_SEMI] = ACTIONS(3951),
    [anon_sym___extension__] = ACTIONS(3949),
    [anon_sym_typedef] = ACTIONS(3949),
    [anon_sym_in] = ACTIONS(3949),
    [anon_sym_out] = ACTIONS(3949),
    [anon_sym_inout] = ACTIONS(3949),
    [anon_sym_virtual] = ACTIONS(3949),
    [anon_sym_extern] = ACTIONS(3949),
    [anon_sym___attribute__] = ACTIONS(3949),
    [anon_sym___attribute] = ACTIONS(3949),
    [anon_sym_using] = ACTIONS(3949),
    [anon_sym_COLON_COLON] = ACTIONS(3951),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3951),
    [anon_sym___declspec] = ACTIONS(3949),
    [anon_sym___based] = ACTIONS(3949),
    [anon_sym_signed] = ACTIONS(3949),
    [anon_sym_unsigned] = ACTIONS(3949),
    [anon_sym_long] = ACTIONS(3949),
    [anon_sym_short] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [anon_sym_static] = ACTIONS(3949),
    [anon_sym_register] = ACTIONS(3949),
    [anon_sym_inline] = ACTIONS(3949),
    [anon_sym___inline] = ACTIONS(3949),
    [anon_sym___inline__] = ACTIONS(3949),
    [anon_sym___forceinline] = ACTIONS(3949),
    [anon_sym_thread_local] = ACTIONS(3949),
    [anon_sym___thread] = ACTIONS(3949),
    [anon_sym_const] = ACTIONS(3949),
    [anon_sym_constexpr] = ACTIONS(3949),
    [anon_sym_volatile] = ACTIONS(3949),
    [anon_sym_restrict] = ACTIONS(3949),
    [anon_sym___restrict__] = ACTIONS(3949),
    [anon_sym__Atomic] = ACTIONS(3949),
    [anon_sym__Noreturn] = ACTIONS(3949),
    [anon_sym_noreturn] = ACTIONS(3949),
    [anon_sym__Nonnull] = ACTIONS(3949),
    [anon_sym_mutable] = ACTIONS(3949),
    [anon_sym_constinit] = ACTIONS(3949),
    [anon_sym_consteval] = ACTIONS(3949),
    [anon_sym_alignas] = ACTIONS(3949),
    [anon_sym__Alignas] = ACTIONS(3949),
    [sym_primitive_type] = ACTIONS(3949),
    [anon_sym_enum] = ACTIONS(3949),
    [anon_sym_class] = ACTIONS(3949),
    [anon_sym_struct] = ACTIONS(3949),
    [anon_sym_union] = ACTIONS(3949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_This] = ACTIONS(3949),
    [anon_sym_decltype] = ACTIONS(3949),
    [anon_sym_explicit] = ACTIONS(3949),
    [anon_sym_typename] = ACTIONS(3949),
    [anon_sym_private] = ACTIONS(3949),
    [anon_sym_template] = ACTIONS(3949),
    [anon_sym_operator] = ACTIONS(3949),
    [anon_sym_friend] = ACTIONS(3949),
    [anon_sym_public] = ACTIONS(3949),
    [anon_sym_protected] = ACTIONS(3949),
    [anon_sym_static_assert] = ACTIONS(3949),
    [anon_sym_precise] = ACTIONS(3949),
    [anon_sym_shared] = ACTIONS(3949),
    [anon_sym_groupshared] = ACTIONS(3949),
    [anon_sym_uniform] = ACTIONS(3949),
    [anon_sym_row_major] = ACTIONS(3949),
    [anon_sym_column_major] = ACTIONS(3949),
    [anon_sym_globallycoherent] = ACTIONS(3949),
    [anon_sym_centroid] = ACTIONS(3949),
    [anon_sym_noperspective] = ACTIONS(3949),
    [anon_sym_nointerpolation] = ACTIONS(3949),
    [anon_sym_sample] = ACTIONS(3949),
    [anon_sym_linear] = ACTIONS(3949),
    [anon_sym_snorm] = ACTIONS(3949),
    [anon_sym_unorm] = ACTIONS(3949),
    [anon_sym_point] = ACTIONS(3949),
    [anon_sym_line] = ACTIONS(3949),
    [anon_sym_triangleadj] = ACTIONS(3949),
    [anon_sym_lineadj] = ACTIONS(3949),
    [anon_sym_triangle] = ACTIONS(3949),
    [anon_sym_interface] = ACTIONS(3949),
    [anon_sym_extension] = ACTIONS(3949),
    [anon_sym___init] = ACTIONS(3949),
    [anon_sym___subscript] = ACTIONS(3949),
    [anon_sym_property] = ACTIONS(3949),
    [anon_sym_associatedtype] = ACTIONS(3949),
  },
  [2234] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6241),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [2235] = {
    [sym_identifier] = ACTIONS(3877),
    [aux_sym_preproc_def_token1] = ACTIONS(3877),
    [aux_sym_preproc_if_token1] = ACTIONS(3877),
    [aux_sym_preproc_if_token2] = ACTIONS(3877),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3877),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3877),
    [sym_preproc_directive] = ACTIONS(3877),
    [anon_sym_LPAREN2] = ACTIONS(3879),
    [anon_sym_TILDE] = ACTIONS(3879),
    [anon_sym_STAR] = ACTIONS(3879),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3877),
    [anon_sym_SEMI] = ACTIONS(3879),
    [anon_sym___extension__] = ACTIONS(3877),
    [anon_sym_typedef] = ACTIONS(3877),
    [anon_sym_in] = ACTIONS(3877),
    [anon_sym_out] = ACTIONS(3877),
    [anon_sym_inout] = ACTIONS(3877),
    [anon_sym_virtual] = ACTIONS(3877),
    [anon_sym_extern] = ACTIONS(3877),
    [anon_sym___attribute__] = ACTIONS(3877),
    [anon_sym___attribute] = ACTIONS(3877),
    [anon_sym_using] = ACTIONS(3877),
    [anon_sym_COLON_COLON] = ACTIONS(3879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3879),
    [anon_sym___declspec] = ACTIONS(3877),
    [anon_sym___based] = ACTIONS(3877),
    [anon_sym_signed] = ACTIONS(3877),
    [anon_sym_unsigned] = ACTIONS(3877),
    [anon_sym_long] = ACTIONS(3877),
    [anon_sym_short] = ACTIONS(3877),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [anon_sym_static] = ACTIONS(3877),
    [anon_sym_register] = ACTIONS(3877),
    [anon_sym_inline] = ACTIONS(3877),
    [anon_sym___inline] = ACTIONS(3877),
    [anon_sym___inline__] = ACTIONS(3877),
    [anon_sym___forceinline] = ACTIONS(3877),
    [anon_sym_thread_local] = ACTIONS(3877),
    [anon_sym___thread] = ACTIONS(3877),
    [anon_sym_const] = ACTIONS(3877),
    [anon_sym_constexpr] = ACTIONS(3877),
    [anon_sym_volatile] = ACTIONS(3877),
    [anon_sym_restrict] = ACTIONS(3877),
    [anon_sym___restrict__] = ACTIONS(3877),
    [anon_sym__Atomic] = ACTIONS(3877),
    [anon_sym__Noreturn] = ACTIONS(3877),
    [anon_sym_noreturn] = ACTIONS(3877),
    [anon_sym__Nonnull] = ACTIONS(3877),
    [anon_sym_mutable] = ACTIONS(3877),
    [anon_sym_constinit] = ACTIONS(3877),
    [anon_sym_consteval] = ACTIONS(3877),
    [anon_sym_alignas] = ACTIONS(3877),
    [anon_sym__Alignas] = ACTIONS(3877),
    [sym_primitive_type] = ACTIONS(3877),
    [anon_sym_enum] = ACTIONS(3877),
    [anon_sym_class] = ACTIONS(3877),
    [anon_sym_struct] = ACTIONS(3877),
    [anon_sym_union] = ACTIONS(3877),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3877),
    [anon_sym_let] = ACTIONS(3877),
    [anon_sym_This] = ACTIONS(3877),
    [anon_sym_decltype] = ACTIONS(3877),
    [anon_sym_explicit] = ACTIONS(3877),
    [anon_sym_typename] = ACTIONS(3877),
    [anon_sym_private] = ACTIONS(3877),
    [anon_sym_template] = ACTIONS(3877),
    [anon_sym_operator] = ACTIONS(3877),
    [anon_sym_friend] = ACTIONS(3877),
    [anon_sym_public] = ACTIONS(3877),
    [anon_sym_protected] = ACTIONS(3877),
    [anon_sym_static_assert] = ACTIONS(3877),
    [anon_sym_precise] = ACTIONS(3877),
    [anon_sym_shared] = ACTIONS(3877),
    [anon_sym_groupshared] = ACTIONS(3877),
    [anon_sym_uniform] = ACTIONS(3877),
    [anon_sym_row_major] = ACTIONS(3877),
    [anon_sym_column_major] = ACTIONS(3877),
    [anon_sym_globallycoherent] = ACTIONS(3877),
    [anon_sym_centroid] = ACTIONS(3877),
    [anon_sym_noperspective] = ACTIONS(3877),
    [anon_sym_nointerpolation] = ACTIONS(3877),
    [anon_sym_sample] = ACTIONS(3877),
    [anon_sym_linear] = ACTIONS(3877),
    [anon_sym_snorm] = ACTIONS(3877),
    [anon_sym_unorm] = ACTIONS(3877),
    [anon_sym_point] = ACTIONS(3877),
    [anon_sym_line] = ACTIONS(3877),
    [anon_sym_triangleadj] = ACTIONS(3877),
    [anon_sym_lineadj] = ACTIONS(3877),
    [anon_sym_triangle] = ACTIONS(3877),
    [anon_sym_interface] = ACTIONS(3877),
    [anon_sym_extension] = ACTIONS(3877),
    [anon_sym___init] = ACTIONS(3877),
    [anon_sym___subscript] = ACTIONS(3877),
    [anon_sym_property] = ACTIONS(3877),
    [anon_sym_associatedtype] = ACTIONS(3877),
  },
  [2236] = {
    [sym_identifier] = ACTIONS(3893),
    [aux_sym_preproc_def_token1] = ACTIONS(3893),
    [aux_sym_preproc_if_token1] = ACTIONS(3893),
    [aux_sym_preproc_if_token2] = ACTIONS(3893),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3893),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3893),
    [sym_preproc_directive] = ACTIONS(3893),
    [anon_sym_LPAREN2] = ACTIONS(3895),
    [anon_sym_TILDE] = ACTIONS(3895),
    [anon_sym_STAR] = ACTIONS(3895),
    [anon_sym_AMP_AMP] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3893),
    [anon_sym_SEMI] = ACTIONS(3895),
    [anon_sym___extension__] = ACTIONS(3893),
    [anon_sym_typedef] = ACTIONS(3893),
    [anon_sym_in] = ACTIONS(3893),
    [anon_sym_out] = ACTIONS(3893),
    [anon_sym_inout] = ACTIONS(3893),
    [anon_sym_virtual] = ACTIONS(3893),
    [anon_sym_extern] = ACTIONS(3893),
    [anon_sym___attribute__] = ACTIONS(3893),
    [anon_sym___attribute] = ACTIONS(3893),
    [anon_sym_using] = ACTIONS(3893),
    [anon_sym_COLON_COLON] = ACTIONS(3895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3895),
    [anon_sym___declspec] = ACTIONS(3893),
    [anon_sym___based] = ACTIONS(3893),
    [anon_sym_signed] = ACTIONS(3893),
    [anon_sym_unsigned] = ACTIONS(3893),
    [anon_sym_long] = ACTIONS(3893),
    [anon_sym_short] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_static] = ACTIONS(3893),
    [anon_sym_register] = ACTIONS(3893),
    [anon_sym_inline] = ACTIONS(3893),
    [anon_sym___inline] = ACTIONS(3893),
    [anon_sym___inline__] = ACTIONS(3893),
    [anon_sym___forceinline] = ACTIONS(3893),
    [anon_sym_thread_local] = ACTIONS(3893),
    [anon_sym___thread] = ACTIONS(3893),
    [anon_sym_const] = ACTIONS(3893),
    [anon_sym_constexpr] = ACTIONS(3893),
    [anon_sym_volatile] = ACTIONS(3893),
    [anon_sym_restrict] = ACTIONS(3893),
    [anon_sym___restrict__] = ACTIONS(3893),
    [anon_sym__Atomic] = ACTIONS(3893),
    [anon_sym__Noreturn] = ACTIONS(3893),
    [anon_sym_noreturn] = ACTIONS(3893),
    [anon_sym__Nonnull] = ACTIONS(3893),
    [anon_sym_mutable] = ACTIONS(3893),
    [anon_sym_constinit] = ACTIONS(3893),
    [anon_sym_consteval] = ACTIONS(3893),
    [anon_sym_alignas] = ACTIONS(3893),
    [anon_sym__Alignas] = ACTIONS(3893),
    [sym_primitive_type] = ACTIONS(3893),
    [anon_sym_enum] = ACTIONS(3893),
    [anon_sym_class] = ACTIONS(3893),
    [anon_sym_struct] = ACTIONS(3893),
    [anon_sym_union] = ACTIONS(3893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3893),
    [anon_sym_This] = ACTIONS(3893),
    [anon_sym_decltype] = ACTIONS(3893),
    [anon_sym_explicit] = ACTIONS(3893),
    [anon_sym_typename] = ACTIONS(3893),
    [anon_sym_private] = ACTIONS(3893),
    [anon_sym_template] = ACTIONS(3893),
    [anon_sym_operator] = ACTIONS(3893),
    [anon_sym_friend] = ACTIONS(3893),
    [anon_sym_public] = ACTIONS(3893),
    [anon_sym_protected] = ACTIONS(3893),
    [anon_sym_static_assert] = ACTIONS(3893),
    [anon_sym_precise] = ACTIONS(3893),
    [anon_sym_shared] = ACTIONS(3893),
    [anon_sym_groupshared] = ACTIONS(3893),
    [anon_sym_uniform] = ACTIONS(3893),
    [anon_sym_row_major] = ACTIONS(3893),
    [anon_sym_column_major] = ACTIONS(3893),
    [anon_sym_globallycoherent] = ACTIONS(3893),
    [anon_sym_centroid] = ACTIONS(3893),
    [anon_sym_noperspective] = ACTIONS(3893),
    [anon_sym_nointerpolation] = ACTIONS(3893),
    [anon_sym_sample] = ACTIONS(3893),
    [anon_sym_linear] = ACTIONS(3893),
    [anon_sym_snorm] = ACTIONS(3893),
    [anon_sym_unorm] = ACTIONS(3893),
    [anon_sym_point] = ACTIONS(3893),
    [anon_sym_line] = ACTIONS(3893),
    [anon_sym_triangleadj] = ACTIONS(3893),
    [anon_sym_lineadj] = ACTIONS(3893),
    [anon_sym_triangle] = ACTIONS(3893),
    [anon_sym_interface] = ACTIONS(3893),
    [anon_sym_extension] = ACTIONS(3893),
    [anon_sym___init] = ACTIONS(3893),
    [anon_sym___subscript] = ACTIONS(3893),
    [anon_sym_property] = ACTIONS(3893),
    [anon_sym_associatedtype] = ACTIONS(3893),
  },
  [2237] = {
    [sym_expression] = STATE(5892),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2238] = {
    [sym_identifier] = ACTIONS(3739),
    [aux_sym_preproc_def_token1] = ACTIONS(3739),
    [aux_sym_preproc_if_token1] = ACTIONS(3739),
    [aux_sym_preproc_if_token2] = ACTIONS(3739),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3739),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3739),
    [sym_preproc_directive] = ACTIONS(3739),
    [anon_sym_LPAREN2] = ACTIONS(3741),
    [anon_sym_TILDE] = ACTIONS(3741),
    [anon_sym_STAR] = ACTIONS(3741),
    [anon_sym_AMP_AMP] = ACTIONS(3741),
    [anon_sym_AMP] = ACTIONS(3739),
    [anon_sym_SEMI] = ACTIONS(3741),
    [anon_sym___extension__] = ACTIONS(3739),
    [anon_sym_typedef] = ACTIONS(3739),
    [anon_sym_in] = ACTIONS(3739),
    [anon_sym_out] = ACTIONS(3739),
    [anon_sym_inout] = ACTIONS(3739),
    [anon_sym_virtual] = ACTIONS(3739),
    [anon_sym_extern] = ACTIONS(3739),
    [anon_sym___attribute__] = ACTIONS(3739),
    [anon_sym___attribute] = ACTIONS(3739),
    [anon_sym_using] = ACTIONS(3739),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3741),
    [anon_sym___declspec] = ACTIONS(3739),
    [anon_sym___based] = ACTIONS(3739),
    [anon_sym_signed] = ACTIONS(3739),
    [anon_sym_unsigned] = ACTIONS(3739),
    [anon_sym_long] = ACTIONS(3739),
    [anon_sym_short] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3739),
    [anon_sym_static] = ACTIONS(3739),
    [anon_sym_register] = ACTIONS(3739),
    [anon_sym_inline] = ACTIONS(3739),
    [anon_sym___inline] = ACTIONS(3739),
    [anon_sym___inline__] = ACTIONS(3739),
    [anon_sym___forceinline] = ACTIONS(3739),
    [anon_sym_thread_local] = ACTIONS(3739),
    [anon_sym___thread] = ACTIONS(3739),
    [anon_sym_const] = ACTIONS(3739),
    [anon_sym_constexpr] = ACTIONS(3739),
    [anon_sym_volatile] = ACTIONS(3739),
    [anon_sym_restrict] = ACTIONS(3739),
    [anon_sym___restrict__] = ACTIONS(3739),
    [anon_sym__Atomic] = ACTIONS(3739),
    [anon_sym__Noreturn] = ACTIONS(3739),
    [anon_sym_noreturn] = ACTIONS(3739),
    [anon_sym__Nonnull] = ACTIONS(3739),
    [anon_sym_mutable] = ACTIONS(3739),
    [anon_sym_constinit] = ACTIONS(3739),
    [anon_sym_consteval] = ACTIONS(3739),
    [anon_sym_alignas] = ACTIONS(3739),
    [anon_sym__Alignas] = ACTIONS(3739),
    [sym_primitive_type] = ACTIONS(3739),
    [anon_sym_enum] = ACTIONS(3739),
    [anon_sym_class] = ACTIONS(3739),
    [anon_sym_struct] = ACTIONS(3739),
    [anon_sym_union] = ACTIONS(3739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3739),
    [anon_sym_let] = ACTIONS(3739),
    [anon_sym_This] = ACTIONS(3739),
    [anon_sym_decltype] = ACTIONS(3739),
    [anon_sym_explicit] = ACTIONS(3739),
    [anon_sym_typename] = ACTIONS(3739),
    [anon_sym_private] = ACTIONS(3739),
    [anon_sym_template] = ACTIONS(3739),
    [anon_sym_operator] = ACTIONS(3739),
    [anon_sym_friend] = ACTIONS(3739),
    [anon_sym_public] = ACTIONS(3739),
    [anon_sym_protected] = ACTIONS(3739),
    [anon_sym_static_assert] = ACTIONS(3739),
    [anon_sym_precise] = ACTIONS(3739),
    [anon_sym_shared] = ACTIONS(3739),
    [anon_sym_groupshared] = ACTIONS(3739),
    [anon_sym_uniform] = ACTIONS(3739),
    [anon_sym_row_major] = ACTIONS(3739),
    [anon_sym_column_major] = ACTIONS(3739),
    [anon_sym_globallycoherent] = ACTIONS(3739),
    [anon_sym_centroid] = ACTIONS(3739),
    [anon_sym_noperspective] = ACTIONS(3739),
    [anon_sym_nointerpolation] = ACTIONS(3739),
    [anon_sym_sample] = ACTIONS(3739),
    [anon_sym_linear] = ACTIONS(3739),
    [anon_sym_snorm] = ACTIONS(3739),
    [anon_sym_unorm] = ACTIONS(3739),
    [anon_sym_point] = ACTIONS(3739),
    [anon_sym_line] = ACTIONS(3739),
    [anon_sym_triangleadj] = ACTIONS(3739),
    [anon_sym_lineadj] = ACTIONS(3739),
    [anon_sym_triangle] = ACTIONS(3739),
    [anon_sym_interface] = ACTIONS(3739),
    [anon_sym_extension] = ACTIONS(3739),
    [anon_sym___init] = ACTIONS(3739),
    [anon_sym___subscript] = ACTIONS(3739),
    [anon_sym_property] = ACTIONS(3739),
    [anon_sym_associatedtype] = ACTIONS(3739),
  },
  [2239] = {
    [sym_identifier] = ACTIONS(3885),
    [aux_sym_preproc_def_token1] = ACTIONS(3885),
    [aux_sym_preproc_if_token1] = ACTIONS(3885),
    [aux_sym_preproc_if_token2] = ACTIONS(3885),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3885),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3885),
    [sym_preproc_directive] = ACTIONS(3885),
    [anon_sym_LPAREN2] = ACTIONS(3887),
    [anon_sym_TILDE] = ACTIONS(3887),
    [anon_sym_STAR] = ACTIONS(3887),
    [anon_sym_AMP_AMP] = ACTIONS(3887),
    [anon_sym_AMP] = ACTIONS(3885),
    [anon_sym_SEMI] = ACTIONS(3887),
    [anon_sym___extension__] = ACTIONS(3885),
    [anon_sym_typedef] = ACTIONS(3885),
    [anon_sym_in] = ACTIONS(3885),
    [anon_sym_out] = ACTIONS(3885),
    [anon_sym_inout] = ACTIONS(3885),
    [anon_sym_virtual] = ACTIONS(3885),
    [anon_sym_extern] = ACTIONS(3885),
    [anon_sym___attribute__] = ACTIONS(3885),
    [anon_sym___attribute] = ACTIONS(3885),
    [anon_sym_using] = ACTIONS(3885),
    [anon_sym_COLON_COLON] = ACTIONS(3887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3887),
    [anon_sym___declspec] = ACTIONS(3885),
    [anon_sym___based] = ACTIONS(3885),
    [anon_sym_signed] = ACTIONS(3885),
    [anon_sym_unsigned] = ACTIONS(3885),
    [anon_sym_long] = ACTIONS(3885),
    [anon_sym_short] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [anon_sym_static] = ACTIONS(3885),
    [anon_sym_register] = ACTIONS(3885),
    [anon_sym_inline] = ACTIONS(3885),
    [anon_sym___inline] = ACTIONS(3885),
    [anon_sym___inline__] = ACTIONS(3885),
    [anon_sym___forceinline] = ACTIONS(3885),
    [anon_sym_thread_local] = ACTIONS(3885),
    [anon_sym___thread] = ACTIONS(3885),
    [anon_sym_const] = ACTIONS(3885),
    [anon_sym_constexpr] = ACTIONS(3885),
    [anon_sym_volatile] = ACTIONS(3885),
    [anon_sym_restrict] = ACTIONS(3885),
    [anon_sym___restrict__] = ACTIONS(3885),
    [anon_sym__Atomic] = ACTIONS(3885),
    [anon_sym__Noreturn] = ACTIONS(3885),
    [anon_sym_noreturn] = ACTIONS(3885),
    [anon_sym__Nonnull] = ACTIONS(3885),
    [anon_sym_mutable] = ACTIONS(3885),
    [anon_sym_constinit] = ACTIONS(3885),
    [anon_sym_consteval] = ACTIONS(3885),
    [anon_sym_alignas] = ACTIONS(3885),
    [anon_sym__Alignas] = ACTIONS(3885),
    [sym_primitive_type] = ACTIONS(3885),
    [anon_sym_enum] = ACTIONS(3885),
    [anon_sym_class] = ACTIONS(3885),
    [anon_sym_struct] = ACTIONS(3885),
    [anon_sym_union] = ACTIONS(3885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3885),
    [anon_sym_let] = ACTIONS(3885),
    [anon_sym_This] = ACTIONS(3885),
    [anon_sym_decltype] = ACTIONS(3885),
    [anon_sym_explicit] = ACTIONS(3885),
    [anon_sym_typename] = ACTIONS(3885),
    [anon_sym_private] = ACTIONS(3885),
    [anon_sym_template] = ACTIONS(3885),
    [anon_sym_operator] = ACTIONS(3885),
    [anon_sym_friend] = ACTIONS(3885),
    [anon_sym_public] = ACTIONS(3885),
    [anon_sym_protected] = ACTIONS(3885),
    [anon_sym_static_assert] = ACTIONS(3885),
    [anon_sym_precise] = ACTIONS(3885),
    [anon_sym_shared] = ACTIONS(3885),
    [anon_sym_groupshared] = ACTIONS(3885),
    [anon_sym_uniform] = ACTIONS(3885),
    [anon_sym_row_major] = ACTIONS(3885),
    [anon_sym_column_major] = ACTIONS(3885),
    [anon_sym_globallycoherent] = ACTIONS(3885),
    [anon_sym_centroid] = ACTIONS(3885),
    [anon_sym_noperspective] = ACTIONS(3885),
    [anon_sym_nointerpolation] = ACTIONS(3885),
    [anon_sym_sample] = ACTIONS(3885),
    [anon_sym_linear] = ACTIONS(3885),
    [anon_sym_snorm] = ACTIONS(3885),
    [anon_sym_unorm] = ACTIONS(3885),
    [anon_sym_point] = ACTIONS(3885),
    [anon_sym_line] = ACTIONS(3885),
    [anon_sym_triangleadj] = ACTIONS(3885),
    [anon_sym_lineadj] = ACTIONS(3885),
    [anon_sym_triangle] = ACTIONS(3885),
    [anon_sym_interface] = ACTIONS(3885),
    [anon_sym_extension] = ACTIONS(3885),
    [anon_sym___init] = ACTIONS(3885),
    [anon_sym___subscript] = ACTIONS(3885),
    [anon_sym_property] = ACTIONS(3885),
    [anon_sym_associatedtype] = ACTIONS(3885),
  },
  [2240] = {
    [sym_identifier] = ACTIONS(3677),
    [aux_sym_preproc_def_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token2] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3677),
    [sym_preproc_directive] = ACTIONS(3677),
    [anon_sym_LPAREN2] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3679),
    [anon_sym_STAR] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_AMP] = ACTIONS(3677),
    [anon_sym_SEMI] = ACTIONS(3679),
    [anon_sym___extension__] = ACTIONS(3677),
    [anon_sym_typedef] = ACTIONS(3677),
    [anon_sym_in] = ACTIONS(3677),
    [anon_sym_out] = ACTIONS(3677),
    [anon_sym_inout] = ACTIONS(3677),
    [anon_sym_virtual] = ACTIONS(3677),
    [anon_sym_extern] = ACTIONS(3677),
    [anon_sym___attribute__] = ACTIONS(3677),
    [anon_sym___attribute] = ACTIONS(3677),
    [anon_sym_using] = ACTIONS(3677),
    [anon_sym_COLON_COLON] = ACTIONS(3679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3679),
    [anon_sym___declspec] = ACTIONS(3677),
    [anon_sym___based] = ACTIONS(3677),
    [anon_sym_signed] = ACTIONS(3677),
    [anon_sym_unsigned] = ACTIONS(3677),
    [anon_sym_long] = ACTIONS(3677),
    [anon_sym_short] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3677),
    [anon_sym_static] = ACTIONS(3677),
    [anon_sym_register] = ACTIONS(3677),
    [anon_sym_inline] = ACTIONS(3677),
    [anon_sym___inline] = ACTIONS(3677),
    [anon_sym___inline__] = ACTIONS(3677),
    [anon_sym___forceinline] = ACTIONS(3677),
    [anon_sym_thread_local] = ACTIONS(3677),
    [anon_sym___thread] = ACTIONS(3677),
    [anon_sym_const] = ACTIONS(3677),
    [anon_sym_constexpr] = ACTIONS(3677),
    [anon_sym_volatile] = ACTIONS(3677),
    [anon_sym_restrict] = ACTIONS(3677),
    [anon_sym___restrict__] = ACTIONS(3677),
    [anon_sym__Atomic] = ACTIONS(3677),
    [anon_sym__Noreturn] = ACTIONS(3677),
    [anon_sym_noreturn] = ACTIONS(3677),
    [anon_sym__Nonnull] = ACTIONS(3677),
    [anon_sym_mutable] = ACTIONS(3677),
    [anon_sym_constinit] = ACTIONS(3677),
    [anon_sym_consteval] = ACTIONS(3677),
    [anon_sym_alignas] = ACTIONS(3677),
    [anon_sym__Alignas] = ACTIONS(3677),
    [sym_primitive_type] = ACTIONS(3677),
    [anon_sym_enum] = ACTIONS(3677),
    [anon_sym_class] = ACTIONS(3677),
    [anon_sym_struct] = ACTIONS(3677),
    [anon_sym_union] = ACTIONS(3677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3677),
    [anon_sym_let] = ACTIONS(3677),
    [anon_sym_This] = ACTIONS(3677),
    [anon_sym_decltype] = ACTIONS(3677),
    [anon_sym_explicit] = ACTIONS(3677),
    [anon_sym_typename] = ACTIONS(3677),
    [anon_sym_private] = ACTIONS(3677),
    [anon_sym_template] = ACTIONS(3677),
    [anon_sym_operator] = ACTIONS(3677),
    [anon_sym_friend] = ACTIONS(3677),
    [anon_sym_public] = ACTIONS(3677),
    [anon_sym_protected] = ACTIONS(3677),
    [anon_sym_static_assert] = ACTIONS(3677),
    [anon_sym_precise] = ACTIONS(3677),
    [anon_sym_shared] = ACTIONS(3677),
    [anon_sym_groupshared] = ACTIONS(3677),
    [anon_sym_uniform] = ACTIONS(3677),
    [anon_sym_row_major] = ACTIONS(3677),
    [anon_sym_column_major] = ACTIONS(3677),
    [anon_sym_globallycoherent] = ACTIONS(3677),
    [anon_sym_centroid] = ACTIONS(3677),
    [anon_sym_noperspective] = ACTIONS(3677),
    [anon_sym_nointerpolation] = ACTIONS(3677),
    [anon_sym_sample] = ACTIONS(3677),
    [anon_sym_linear] = ACTIONS(3677),
    [anon_sym_snorm] = ACTIONS(3677),
    [anon_sym_unorm] = ACTIONS(3677),
    [anon_sym_point] = ACTIONS(3677),
    [anon_sym_line] = ACTIONS(3677),
    [anon_sym_triangleadj] = ACTIONS(3677),
    [anon_sym_lineadj] = ACTIONS(3677),
    [anon_sym_triangle] = ACTIONS(3677),
    [anon_sym_interface] = ACTIONS(3677),
    [anon_sym_extension] = ACTIONS(3677),
    [anon_sym___init] = ACTIONS(3677),
    [anon_sym___subscript] = ACTIONS(3677),
    [anon_sym_property] = ACTIONS(3677),
    [anon_sym_associatedtype] = ACTIONS(3677),
  },
  [2241] = {
    [sym_identifier] = ACTIONS(3677),
    [aux_sym_preproc_def_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token2] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3677),
    [sym_preproc_directive] = ACTIONS(3677),
    [anon_sym_LPAREN2] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3679),
    [anon_sym_STAR] = ACTIONS(3679),
    [anon_sym_AMP_AMP] = ACTIONS(3679),
    [anon_sym_AMP] = ACTIONS(3677),
    [anon_sym_SEMI] = ACTIONS(3679),
    [anon_sym___extension__] = ACTIONS(3677),
    [anon_sym_typedef] = ACTIONS(3677),
    [anon_sym_in] = ACTIONS(3677),
    [anon_sym_out] = ACTIONS(3677),
    [anon_sym_inout] = ACTIONS(3677),
    [anon_sym_virtual] = ACTIONS(3677),
    [anon_sym_extern] = ACTIONS(3677),
    [anon_sym___attribute__] = ACTIONS(3677),
    [anon_sym___attribute] = ACTIONS(3677),
    [anon_sym_using] = ACTIONS(3677),
    [anon_sym_COLON_COLON] = ACTIONS(3679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3679),
    [anon_sym___declspec] = ACTIONS(3677),
    [anon_sym___based] = ACTIONS(3677),
    [anon_sym_signed] = ACTIONS(3677),
    [anon_sym_unsigned] = ACTIONS(3677),
    [anon_sym_long] = ACTIONS(3677),
    [anon_sym_short] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3677),
    [anon_sym_static] = ACTIONS(3677),
    [anon_sym_register] = ACTIONS(3677),
    [anon_sym_inline] = ACTIONS(3677),
    [anon_sym___inline] = ACTIONS(3677),
    [anon_sym___inline__] = ACTIONS(3677),
    [anon_sym___forceinline] = ACTIONS(3677),
    [anon_sym_thread_local] = ACTIONS(3677),
    [anon_sym___thread] = ACTIONS(3677),
    [anon_sym_const] = ACTIONS(3677),
    [anon_sym_constexpr] = ACTIONS(3677),
    [anon_sym_volatile] = ACTIONS(3677),
    [anon_sym_restrict] = ACTIONS(3677),
    [anon_sym___restrict__] = ACTIONS(3677),
    [anon_sym__Atomic] = ACTIONS(3677),
    [anon_sym__Noreturn] = ACTIONS(3677),
    [anon_sym_noreturn] = ACTIONS(3677),
    [anon_sym__Nonnull] = ACTIONS(3677),
    [anon_sym_mutable] = ACTIONS(3677),
    [anon_sym_constinit] = ACTIONS(3677),
    [anon_sym_consteval] = ACTIONS(3677),
    [anon_sym_alignas] = ACTIONS(3677),
    [anon_sym__Alignas] = ACTIONS(3677),
    [sym_primitive_type] = ACTIONS(3677),
    [anon_sym_enum] = ACTIONS(3677),
    [anon_sym_class] = ACTIONS(3677),
    [anon_sym_struct] = ACTIONS(3677),
    [anon_sym_union] = ACTIONS(3677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3677),
    [anon_sym_let] = ACTIONS(3677),
    [anon_sym_This] = ACTIONS(3677),
    [anon_sym_decltype] = ACTIONS(3677),
    [anon_sym_explicit] = ACTIONS(3677),
    [anon_sym_typename] = ACTIONS(3677),
    [anon_sym_private] = ACTIONS(3677),
    [anon_sym_template] = ACTIONS(3677),
    [anon_sym_operator] = ACTIONS(3677),
    [anon_sym_friend] = ACTIONS(3677),
    [anon_sym_public] = ACTIONS(3677),
    [anon_sym_protected] = ACTIONS(3677),
    [anon_sym_static_assert] = ACTIONS(3677),
    [anon_sym_precise] = ACTIONS(3677),
    [anon_sym_shared] = ACTIONS(3677),
    [anon_sym_groupshared] = ACTIONS(3677),
    [anon_sym_uniform] = ACTIONS(3677),
    [anon_sym_row_major] = ACTIONS(3677),
    [anon_sym_column_major] = ACTIONS(3677),
    [anon_sym_globallycoherent] = ACTIONS(3677),
    [anon_sym_centroid] = ACTIONS(3677),
    [anon_sym_noperspective] = ACTIONS(3677),
    [anon_sym_nointerpolation] = ACTIONS(3677),
    [anon_sym_sample] = ACTIONS(3677),
    [anon_sym_linear] = ACTIONS(3677),
    [anon_sym_snorm] = ACTIONS(3677),
    [anon_sym_unorm] = ACTIONS(3677),
    [anon_sym_point] = ACTIONS(3677),
    [anon_sym_line] = ACTIONS(3677),
    [anon_sym_triangleadj] = ACTIONS(3677),
    [anon_sym_lineadj] = ACTIONS(3677),
    [anon_sym_triangle] = ACTIONS(3677),
    [anon_sym_interface] = ACTIONS(3677),
    [anon_sym_extension] = ACTIONS(3677),
    [anon_sym___init] = ACTIONS(3677),
    [anon_sym___subscript] = ACTIONS(3677),
    [anon_sym_property] = ACTIONS(3677),
    [anon_sym_associatedtype] = ACTIONS(3677),
  },
  [2242] = {
    [sym_identifier] = ACTIONS(3691),
    [aux_sym_preproc_def_token1] = ACTIONS(3691),
    [aux_sym_preproc_if_token1] = ACTIONS(3691),
    [aux_sym_preproc_if_token2] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3691),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3691),
    [sym_preproc_directive] = ACTIONS(3691),
    [anon_sym_LPAREN2] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3693),
    [anon_sym_STAR] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_AMP] = ACTIONS(3691),
    [anon_sym_SEMI] = ACTIONS(3693),
    [anon_sym___extension__] = ACTIONS(3691),
    [anon_sym_typedef] = ACTIONS(3691),
    [anon_sym_in] = ACTIONS(3691),
    [anon_sym_out] = ACTIONS(3691),
    [anon_sym_inout] = ACTIONS(3691),
    [anon_sym_virtual] = ACTIONS(3691),
    [anon_sym_extern] = ACTIONS(3691),
    [anon_sym___attribute__] = ACTIONS(3691),
    [anon_sym___attribute] = ACTIONS(3691),
    [anon_sym_using] = ACTIONS(3691),
    [anon_sym_COLON_COLON] = ACTIONS(3693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3693),
    [anon_sym___declspec] = ACTIONS(3691),
    [anon_sym___based] = ACTIONS(3691),
    [anon_sym_signed] = ACTIONS(3691),
    [anon_sym_unsigned] = ACTIONS(3691),
    [anon_sym_long] = ACTIONS(3691),
    [anon_sym_short] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(3691),
    [anon_sym_static] = ACTIONS(3691),
    [anon_sym_register] = ACTIONS(3691),
    [anon_sym_inline] = ACTIONS(3691),
    [anon_sym___inline] = ACTIONS(3691),
    [anon_sym___inline__] = ACTIONS(3691),
    [anon_sym___forceinline] = ACTIONS(3691),
    [anon_sym_thread_local] = ACTIONS(3691),
    [anon_sym___thread] = ACTIONS(3691),
    [anon_sym_const] = ACTIONS(3691),
    [anon_sym_constexpr] = ACTIONS(3691),
    [anon_sym_volatile] = ACTIONS(3691),
    [anon_sym_restrict] = ACTIONS(3691),
    [anon_sym___restrict__] = ACTIONS(3691),
    [anon_sym__Atomic] = ACTIONS(3691),
    [anon_sym__Noreturn] = ACTIONS(3691),
    [anon_sym_noreturn] = ACTIONS(3691),
    [anon_sym__Nonnull] = ACTIONS(3691),
    [anon_sym_mutable] = ACTIONS(3691),
    [anon_sym_constinit] = ACTIONS(3691),
    [anon_sym_consteval] = ACTIONS(3691),
    [anon_sym_alignas] = ACTIONS(3691),
    [anon_sym__Alignas] = ACTIONS(3691),
    [sym_primitive_type] = ACTIONS(3691),
    [anon_sym_enum] = ACTIONS(3691),
    [anon_sym_class] = ACTIONS(3691),
    [anon_sym_struct] = ACTIONS(3691),
    [anon_sym_union] = ACTIONS(3691),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3691),
    [anon_sym_let] = ACTIONS(3691),
    [anon_sym_This] = ACTIONS(3691),
    [anon_sym_decltype] = ACTIONS(3691),
    [anon_sym_explicit] = ACTIONS(3691),
    [anon_sym_typename] = ACTIONS(3691),
    [anon_sym_private] = ACTIONS(3691),
    [anon_sym_template] = ACTIONS(3691),
    [anon_sym_operator] = ACTIONS(3691),
    [anon_sym_friend] = ACTIONS(3691),
    [anon_sym_public] = ACTIONS(3691),
    [anon_sym_protected] = ACTIONS(3691),
    [anon_sym_static_assert] = ACTIONS(3691),
    [anon_sym_precise] = ACTIONS(3691),
    [anon_sym_shared] = ACTIONS(3691),
    [anon_sym_groupshared] = ACTIONS(3691),
    [anon_sym_uniform] = ACTIONS(3691),
    [anon_sym_row_major] = ACTIONS(3691),
    [anon_sym_column_major] = ACTIONS(3691),
    [anon_sym_globallycoherent] = ACTIONS(3691),
    [anon_sym_centroid] = ACTIONS(3691),
    [anon_sym_noperspective] = ACTIONS(3691),
    [anon_sym_nointerpolation] = ACTIONS(3691),
    [anon_sym_sample] = ACTIONS(3691),
    [anon_sym_linear] = ACTIONS(3691),
    [anon_sym_snorm] = ACTIONS(3691),
    [anon_sym_unorm] = ACTIONS(3691),
    [anon_sym_point] = ACTIONS(3691),
    [anon_sym_line] = ACTIONS(3691),
    [anon_sym_triangleadj] = ACTIONS(3691),
    [anon_sym_lineadj] = ACTIONS(3691),
    [anon_sym_triangle] = ACTIONS(3691),
    [anon_sym_interface] = ACTIONS(3691),
    [anon_sym_extension] = ACTIONS(3691),
    [anon_sym___init] = ACTIONS(3691),
    [anon_sym___subscript] = ACTIONS(3691),
    [anon_sym_property] = ACTIONS(3691),
    [anon_sym_associatedtype] = ACTIONS(3691),
  },
  [2243] = {
    [sym_expression] = STATE(3870),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5032),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2244] = {
    [sym_identifier] = ACTIONS(3695),
    [aux_sym_preproc_def_token1] = ACTIONS(3695),
    [aux_sym_preproc_if_token1] = ACTIONS(3695),
    [aux_sym_preproc_if_token2] = ACTIONS(3695),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3695),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3695),
    [sym_preproc_directive] = ACTIONS(3695),
    [anon_sym_LPAREN2] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3697),
    [anon_sym_STAR] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3695),
    [anon_sym_SEMI] = ACTIONS(3697),
    [anon_sym___extension__] = ACTIONS(3695),
    [anon_sym_typedef] = ACTIONS(3695),
    [anon_sym_in] = ACTIONS(3695),
    [anon_sym_out] = ACTIONS(3695),
    [anon_sym_inout] = ACTIONS(3695),
    [anon_sym_virtual] = ACTIONS(3695),
    [anon_sym_extern] = ACTIONS(3695),
    [anon_sym___attribute__] = ACTIONS(3695),
    [anon_sym___attribute] = ACTIONS(3695),
    [anon_sym_using] = ACTIONS(3695),
    [anon_sym_COLON_COLON] = ACTIONS(3697),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3697),
    [anon_sym___declspec] = ACTIONS(3695),
    [anon_sym___based] = ACTIONS(3695),
    [anon_sym_signed] = ACTIONS(3695),
    [anon_sym_unsigned] = ACTIONS(3695),
    [anon_sym_long] = ACTIONS(3695),
    [anon_sym_short] = ACTIONS(3695),
    [anon_sym_LBRACK] = ACTIONS(3695),
    [anon_sym_static] = ACTIONS(3695),
    [anon_sym_register] = ACTIONS(3695),
    [anon_sym_inline] = ACTIONS(3695),
    [anon_sym___inline] = ACTIONS(3695),
    [anon_sym___inline__] = ACTIONS(3695),
    [anon_sym___forceinline] = ACTIONS(3695),
    [anon_sym_thread_local] = ACTIONS(3695),
    [anon_sym___thread] = ACTIONS(3695),
    [anon_sym_const] = ACTIONS(3695),
    [anon_sym_constexpr] = ACTIONS(3695),
    [anon_sym_volatile] = ACTIONS(3695),
    [anon_sym_restrict] = ACTIONS(3695),
    [anon_sym___restrict__] = ACTIONS(3695),
    [anon_sym__Atomic] = ACTIONS(3695),
    [anon_sym__Noreturn] = ACTIONS(3695),
    [anon_sym_noreturn] = ACTIONS(3695),
    [anon_sym__Nonnull] = ACTIONS(3695),
    [anon_sym_mutable] = ACTIONS(3695),
    [anon_sym_constinit] = ACTIONS(3695),
    [anon_sym_consteval] = ACTIONS(3695),
    [anon_sym_alignas] = ACTIONS(3695),
    [anon_sym__Alignas] = ACTIONS(3695),
    [sym_primitive_type] = ACTIONS(3695),
    [anon_sym_enum] = ACTIONS(3695),
    [anon_sym_class] = ACTIONS(3695),
    [anon_sym_struct] = ACTIONS(3695),
    [anon_sym_union] = ACTIONS(3695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3695),
    [anon_sym_let] = ACTIONS(3695),
    [anon_sym_This] = ACTIONS(3695),
    [anon_sym_decltype] = ACTIONS(3695),
    [anon_sym_explicit] = ACTIONS(3695),
    [anon_sym_typename] = ACTIONS(3695),
    [anon_sym_private] = ACTIONS(3695),
    [anon_sym_template] = ACTIONS(3695),
    [anon_sym_operator] = ACTIONS(3695),
    [anon_sym_friend] = ACTIONS(3695),
    [anon_sym_public] = ACTIONS(3695),
    [anon_sym_protected] = ACTIONS(3695),
    [anon_sym_static_assert] = ACTIONS(3695),
    [anon_sym_precise] = ACTIONS(3695),
    [anon_sym_shared] = ACTIONS(3695),
    [anon_sym_groupshared] = ACTIONS(3695),
    [anon_sym_uniform] = ACTIONS(3695),
    [anon_sym_row_major] = ACTIONS(3695),
    [anon_sym_column_major] = ACTIONS(3695),
    [anon_sym_globallycoherent] = ACTIONS(3695),
    [anon_sym_centroid] = ACTIONS(3695),
    [anon_sym_noperspective] = ACTIONS(3695),
    [anon_sym_nointerpolation] = ACTIONS(3695),
    [anon_sym_sample] = ACTIONS(3695),
    [anon_sym_linear] = ACTIONS(3695),
    [anon_sym_snorm] = ACTIONS(3695),
    [anon_sym_unorm] = ACTIONS(3695),
    [anon_sym_point] = ACTIONS(3695),
    [anon_sym_line] = ACTIONS(3695),
    [anon_sym_triangleadj] = ACTIONS(3695),
    [anon_sym_lineadj] = ACTIONS(3695),
    [anon_sym_triangle] = ACTIONS(3695),
    [anon_sym_interface] = ACTIONS(3695),
    [anon_sym_extension] = ACTIONS(3695),
    [anon_sym___init] = ACTIONS(3695),
    [anon_sym___subscript] = ACTIONS(3695),
    [anon_sym_property] = ACTIONS(3695),
    [anon_sym_associatedtype] = ACTIONS(3695),
  },
  [2245] = {
    [sym_identifier] = ACTIONS(3699),
    [aux_sym_preproc_def_token1] = ACTIONS(3699),
    [aux_sym_preproc_if_token1] = ACTIONS(3699),
    [aux_sym_preproc_if_token2] = ACTIONS(3699),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3699),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3699),
    [sym_preproc_directive] = ACTIONS(3699),
    [anon_sym_LPAREN2] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3701),
    [anon_sym_STAR] = ACTIONS(3701),
    [anon_sym_AMP_AMP] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(3701),
    [anon_sym___extension__] = ACTIONS(3699),
    [anon_sym_typedef] = ACTIONS(3699),
    [anon_sym_in] = ACTIONS(3699),
    [anon_sym_out] = ACTIONS(3699),
    [anon_sym_inout] = ACTIONS(3699),
    [anon_sym_virtual] = ACTIONS(3699),
    [anon_sym_extern] = ACTIONS(3699),
    [anon_sym___attribute__] = ACTIONS(3699),
    [anon_sym___attribute] = ACTIONS(3699),
    [anon_sym_using] = ACTIONS(3699),
    [anon_sym_COLON_COLON] = ACTIONS(3701),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3701),
    [anon_sym___declspec] = ACTIONS(3699),
    [anon_sym___based] = ACTIONS(3699),
    [anon_sym_signed] = ACTIONS(3699),
    [anon_sym_unsigned] = ACTIONS(3699),
    [anon_sym_long] = ACTIONS(3699),
    [anon_sym_short] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(3699),
    [anon_sym_static] = ACTIONS(3699),
    [anon_sym_register] = ACTIONS(3699),
    [anon_sym_inline] = ACTIONS(3699),
    [anon_sym___inline] = ACTIONS(3699),
    [anon_sym___inline__] = ACTIONS(3699),
    [anon_sym___forceinline] = ACTIONS(3699),
    [anon_sym_thread_local] = ACTIONS(3699),
    [anon_sym___thread] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3699),
    [anon_sym_constexpr] = ACTIONS(3699),
    [anon_sym_volatile] = ACTIONS(3699),
    [anon_sym_restrict] = ACTIONS(3699),
    [anon_sym___restrict__] = ACTIONS(3699),
    [anon_sym__Atomic] = ACTIONS(3699),
    [anon_sym__Noreturn] = ACTIONS(3699),
    [anon_sym_noreturn] = ACTIONS(3699),
    [anon_sym__Nonnull] = ACTIONS(3699),
    [anon_sym_mutable] = ACTIONS(3699),
    [anon_sym_constinit] = ACTIONS(3699),
    [anon_sym_consteval] = ACTIONS(3699),
    [anon_sym_alignas] = ACTIONS(3699),
    [anon_sym__Alignas] = ACTIONS(3699),
    [sym_primitive_type] = ACTIONS(3699),
    [anon_sym_enum] = ACTIONS(3699),
    [anon_sym_class] = ACTIONS(3699),
    [anon_sym_struct] = ACTIONS(3699),
    [anon_sym_union] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3699),
    [anon_sym_let] = ACTIONS(3699),
    [anon_sym_This] = ACTIONS(3699),
    [anon_sym_decltype] = ACTIONS(3699),
    [anon_sym_explicit] = ACTIONS(3699),
    [anon_sym_typename] = ACTIONS(3699),
    [anon_sym_private] = ACTIONS(3699),
    [anon_sym_template] = ACTIONS(3699),
    [anon_sym_operator] = ACTIONS(3699),
    [anon_sym_friend] = ACTIONS(3699),
    [anon_sym_public] = ACTIONS(3699),
    [anon_sym_protected] = ACTIONS(3699),
    [anon_sym_static_assert] = ACTIONS(3699),
    [anon_sym_precise] = ACTIONS(3699),
    [anon_sym_shared] = ACTIONS(3699),
    [anon_sym_groupshared] = ACTIONS(3699),
    [anon_sym_uniform] = ACTIONS(3699),
    [anon_sym_row_major] = ACTIONS(3699),
    [anon_sym_column_major] = ACTIONS(3699),
    [anon_sym_globallycoherent] = ACTIONS(3699),
    [anon_sym_centroid] = ACTIONS(3699),
    [anon_sym_noperspective] = ACTIONS(3699),
    [anon_sym_nointerpolation] = ACTIONS(3699),
    [anon_sym_sample] = ACTIONS(3699),
    [anon_sym_linear] = ACTIONS(3699),
    [anon_sym_snorm] = ACTIONS(3699),
    [anon_sym_unorm] = ACTIONS(3699),
    [anon_sym_point] = ACTIONS(3699),
    [anon_sym_line] = ACTIONS(3699),
    [anon_sym_triangleadj] = ACTIONS(3699),
    [anon_sym_lineadj] = ACTIONS(3699),
    [anon_sym_triangle] = ACTIONS(3699),
    [anon_sym_interface] = ACTIONS(3699),
    [anon_sym_extension] = ACTIONS(3699),
    [anon_sym___init] = ACTIONS(3699),
    [anon_sym___subscript] = ACTIONS(3699),
    [anon_sym_property] = ACTIONS(3699),
    [anon_sym_associatedtype] = ACTIONS(3699),
  },
  [2246] = {
    [sym_identifier] = ACTIONS(3703),
    [aux_sym_preproc_def_token1] = ACTIONS(3703),
    [aux_sym_preproc_if_token1] = ACTIONS(3703),
    [aux_sym_preproc_if_token2] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3703),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3703),
    [sym_preproc_directive] = ACTIONS(3703),
    [anon_sym_LPAREN2] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3705),
    [anon_sym_STAR] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_AMP] = ACTIONS(3703),
    [anon_sym_SEMI] = ACTIONS(3705),
    [anon_sym___extension__] = ACTIONS(3703),
    [anon_sym_typedef] = ACTIONS(3703),
    [anon_sym_in] = ACTIONS(3703),
    [anon_sym_out] = ACTIONS(3703),
    [anon_sym_inout] = ACTIONS(3703),
    [anon_sym_virtual] = ACTIONS(3703),
    [anon_sym_extern] = ACTIONS(3703),
    [anon_sym___attribute__] = ACTIONS(3703),
    [anon_sym___attribute] = ACTIONS(3703),
    [anon_sym_using] = ACTIONS(3703),
    [anon_sym_COLON_COLON] = ACTIONS(3705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3705),
    [anon_sym___declspec] = ACTIONS(3703),
    [anon_sym___based] = ACTIONS(3703),
    [anon_sym_signed] = ACTIONS(3703),
    [anon_sym_unsigned] = ACTIONS(3703),
    [anon_sym_long] = ACTIONS(3703),
    [anon_sym_short] = ACTIONS(3703),
    [anon_sym_LBRACK] = ACTIONS(3703),
    [anon_sym_static] = ACTIONS(3703),
    [anon_sym_register] = ACTIONS(3703),
    [anon_sym_inline] = ACTIONS(3703),
    [anon_sym___inline] = ACTIONS(3703),
    [anon_sym___inline__] = ACTIONS(3703),
    [anon_sym___forceinline] = ACTIONS(3703),
    [anon_sym_thread_local] = ACTIONS(3703),
    [anon_sym___thread] = ACTIONS(3703),
    [anon_sym_const] = ACTIONS(3703),
    [anon_sym_constexpr] = ACTIONS(3703),
    [anon_sym_volatile] = ACTIONS(3703),
    [anon_sym_restrict] = ACTIONS(3703),
    [anon_sym___restrict__] = ACTIONS(3703),
    [anon_sym__Atomic] = ACTIONS(3703),
    [anon_sym__Noreturn] = ACTIONS(3703),
    [anon_sym_noreturn] = ACTIONS(3703),
    [anon_sym__Nonnull] = ACTIONS(3703),
    [anon_sym_mutable] = ACTIONS(3703),
    [anon_sym_constinit] = ACTIONS(3703),
    [anon_sym_consteval] = ACTIONS(3703),
    [anon_sym_alignas] = ACTIONS(3703),
    [anon_sym__Alignas] = ACTIONS(3703),
    [sym_primitive_type] = ACTIONS(3703),
    [anon_sym_enum] = ACTIONS(3703),
    [anon_sym_class] = ACTIONS(3703),
    [anon_sym_struct] = ACTIONS(3703),
    [anon_sym_union] = ACTIONS(3703),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3703),
    [anon_sym_let] = ACTIONS(3703),
    [anon_sym_This] = ACTIONS(3703),
    [anon_sym_decltype] = ACTIONS(3703),
    [anon_sym_explicit] = ACTIONS(3703),
    [anon_sym_typename] = ACTIONS(3703),
    [anon_sym_private] = ACTIONS(3703),
    [anon_sym_template] = ACTIONS(3703),
    [anon_sym_operator] = ACTIONS(3703),
    [anon_sym_friend] = ACTIONS(3703),
    [anon_sym_public] = ACTIONS(3703),
    [anon_sym_protected] = ACTIONS(3703),
    [anon_sym_static_assert] = ACTIONS(3703),
    [anon_sym_precise] = ACTIONS(3703),
    [anon_sym_shared] = ACTIONS(3703),
    [anon_sym_groupshared] = ACTIONS(3703),
    [anon_sym_uniform] = ACTIONS(3703),
    [anon_sym_row_major] = ACTIONS(3703),
    [anon_sym_column_major] = ACTIONS(3703),
    [anon_sym_globallycoherent] = ACTIONS(3703),
    [anon_sym_centroid] = ACTIONS(3703),
    [anon_sym_noperspective] = ACTIONS(3703),
    [anon_sym_nointerpolation] = ACTIONS(3703),
    [anon_sym_sample] = ACTIONS(3703),
    [anon_sym_linear] = ACTIONS(3703),
    [anon_sym_snorm] = ACTIONS(3703),
    [anon_sym_unorm] = ACTIONS(3703),
    [anon_sym_point] = ACTIONS(3703),
    [anon_sym_line] = ACTIONS(3703),
    [anon_sym_triangleadj] = ACTIONS(3703),
    [anon_sym_lineadj] = ACTIONS(3703),
    [anon_sym_triangle] = ACTIONS(3703),
    [anon_sym_interface] = ACTIONS(3703),
    [anon_sym_extension] = ACTIONS(3703),
    [anon_sym___init] = ACTIONS(3703),
    [anon_sym___subscript] = ACTIONS(3703),
    [anon_sym_property] = ACTIONS(3703),
    [anon_sym_associatedtype] = ACTIONS(3703),
  },
  [2247] = {
    [sym_identifier] = ACTIONS(3707),
    [aux_sym_preproc_def_token1] = ACTIONS(3707),
    [aux_sym_preproc_if_token1] = ACTIONS(3707),
    [aux_sym_preproc_if_token2] = ACTIONS(3707),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3707),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3707),
    [sym_preproc_directive] = ACTIONS(3707),
    [anon_sym_LPAREN2] = ACTIONS(3709),
    [anon_sym_TILDE] = ACTIONS(3709),
    [anon_sym_STAR] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(3707),
    [anon_sym_SEMI] = ACTIONS(3709),
    [anon_sym___extension__] = ACTIONS(3707),
    [anon_sym_typedef] = ACTIONS(3707),
    [anon_sym_in] = ACTIONS(3707),
    [anon_sym_out] = ACTIONS(3707),
    [anon_sym_inout] = ACTIONS(3707),
    [anon_sym_virtual] = ACTIONS(3707),
    [anon_sym_extern] = ACTIONS(3707),
    [anon_sym___attribute__] = ACTIONS(3707),
    [anon_sym___attribute] = ACTIONS(3707),
    [anon_sym_using] = ACTIONS(3707),
    [anon_sym_COLON_COLON] = ACTIONS(3709),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3709),
    [anon_sym___declspec] = ACTIONS(3707),
    [anon_sym___based] = ACTIONS(3707),
    [anon_sym_signed] = ACTIONS(3707),
    [anon_sym_unsigned] = ACTIONS(3707),
    [anon_sym_long] = ACTIONS(3707),
    [anon_sym_short] = ACTIONS(3707),
    [anon_sym_LBRACK] = ACTIONS(3707),
    [anon_sym_static] = ACTIONS(3707),
    [anon_sym_register] = ACTIONS(3707),
    [anon_sym_inline] = ACTIONS(3707),
    [anon_sym___inline] = ACTIONS(3707),
    [anon_sym___inline__] = ACTIONS(3707),
    [anon_sym___forceinline] = ACTIONS(3707),
    [anon_sym_thread_local] = ACTIONS(3707),
    [anon_sym___thread] = ACTIONS(3707),
    [anon_sym_const] = ACTIONS(3707),
    [anon_sym_constexpr] = ACTIONS(3707),
    [anon_sym_volatile] = ACTIONS(3707),
    [anon_sym_restrict] = ACTIONS(3707),
    [anon_sym___restrict__] = ACTIONS(3707),
    [anon_sym__Atomic] = ACTIONS(3707),
    [anon_sym__Noreturn] = ACTIONS(3707),
    [anon_sym_noreturn] = ACTIONS(3707),
    [anon_sym__Nonnull] = ACTIONS(3707),
    [anon_sym_mutable] = ACTIONS(3707),
    [anon_sym_constinit] = ACTIONS(3707),
    [anon_sym_consteval] = ACTIONS(3707),
    [anon_sym_alignas] = ACTIONS(3707),
    [anon_sym__Alignas] = ACTIONS(3707),
    [sym_primitive_type] = ACTIONS(3707),
    [anon_sym_enum] = ACTIONS(3707),
    [anon_sym_class] = ACTIONS(3707),
    [anon_sym_struct] = ACTIONS(3707),
    [anon_sym_union] = ACTIONS(3707),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3707),
    [anon_sym_let] = ACTIONS(3707),
    [anon_sym_This] = ACTIONS(3707),
    [anon_sym_decltype] = ACTIONS(3707),
    [anon_sym_explicit] = ACTIONS(3707),
    [anon_sym_typename] = ACTIONS(3707),
    [anon_sym_private] = ACTIONS(3707),
    [anon_sym_template] = ACTIONS(3707),
    [anon_sym_operator] = ACTIONS(3707),
    [anon_sym_friend] = ACTIONS(3707),
    [anon_sym_public] = ACTIONS(3707),
    [anon_sym_protected] = ACTIONS(3707),
    [anon_sym_static_assert] = ACTIONS(3707),
    [anon_sym_precise] = ACTIONS(3707),
    [anon_sym_shared] = ACTIONS(3707),
    [anon_sym_groupshared] = ACTIONS(3707),
    [anon_sym_uniform] = ACTIONS(3707),
    [anon_sym_row_major] = ACTIONS(3707),
    [anon_sym_column_major] = ACTIONS(3707),
    [anon_sym_globallycoherent] = ACTIONS(3707),
    [anon_sym_centroid] = ACTIONS(3707),
    [anon_sym_noperspective] = ACTIONS(3707),
    [anon_sym_nointerpolation] = ACTIONS(3707),
    [anon_sym_sample] = ACTIONS(3707),
    [anon_sym_linear] = ACTIONS(3707),
    [anon_sym_snorm] = ACTIONS(3707),
    [anon_sym_unorm] = ACTIONS(3707),
    [anon_sym_point] = ACTIONS(3707),
    [anon_sym_line] = ACTIONS(3707),
    [anon_sym_triangleadj] = ACTIONS(3707),
    [anon_sym_lineadj] = ACTIONS(3707),
    [anon_sym_triangle] = ACTIONS(3707),
    [anon_sym_interface] = ACTIONS(3707),
    [anon_sym_extension] = ACTIONS(3707),
    [anon_sym___init] = ACTIONS(3707),
    [anon_sym___subscript] = ACTIONS(3707),
    [anon_sym_property] = ACTIONS(3707),
    [anon_sym_associatedtype] = ACTIONS(3707),
  },
  [2248] = {
    [sym_identifier] = ACTIONS(3711),
    [aux_sym_preproc_def_token1] = ACTIONS(3711),
    [aux_sym_preproc_if_token1] = ACTIONS(3711),
    [aux_sym_preproc_if_token2] = ACTIONS(3711),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3711),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3711),
    [sym_preproc_directive] = ACTIONS(3711),
    [anon_sym_LPAREN2] = ACTIONS(3713),
    [anon_sym_TILDE] = ACTIONS(3713),
    [anon_sym_STAR] = ACTIONS(3713),
    [anon_sym_AMP_AMP] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(3711),
    [anon_sym_SEMI] = ACTIONS(3713),
    [anon_sym___extension__] = ACTIONS(3711),
    [anon_sym_typedef] = ACTIONS(3711),
    [anon_sym_in] = ACTIONS(3711),
    [anon_sym_out] = ACTIONS(3711),
    [anon_sym_inout] = ACTIONS(3711),
    [anon_sym_virtual] = ACTIONS(3711),
    [anon_sym_extern] = ACTIONS(3711),
    [anon_sym___attribute__] = ACTIONS(3711),
    [anon_sym___attribute] = ACTIONS(3711),
    [anon_sym_using] = ACTIONS(3711),
    [anon_sym_COLON_COLON] = ACTIONS(3713),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3713),
    [anon_sym___declspec] = ACTIONS(3711),
    [anon_sym___based] = ACTIONS(3711),
    [anon_sym_signed] = ACTIONS(3711),
    [anon_sym_unsigned] = ACTIONS(3711),
    [anon_sym_long] = ACTIONS(3711),
    [anon_sym_short] = ACTIONS(3711),
    [anon_sym_LBRACK] = ACTIONS(3711),
    [anon_sym_static] = ACTIONS(3711),
    [anon_sym_register] = ACTIONS(3711),
    [anon_sym_inline] = ACTIONS(3711),
    [anon_sym___inline] = ACTIONS(3711),
    [anon_sym___inline__] = ACTIONS(3711),
    [anon_sym___forceinline] = ACTIONS(3711),
    [anon_sym_thread_local] = ACTIONS(3711),
    [anon_sym___thread] = ACTIONS(3711),
    [anon_sym_const] = ACTIONS(3711),
    [anon_sym_constexpr] = ACTIONS(3711),
    [anon_sym_volatile] = ACTIONS(3711),
    [anon_sym_restrict] = ACTIONS(3711),
    [anon_sym___restrict__] = ACTIONS(3711),
    [anon_sym__Atomic] = ACTIONS(3711),
    [anon_sym__Noreturn] = ACTIONS(3711),
    [anon_sym_noreturn] = ACTIONS(3711),
    [anon_sym__Nonnull] = ACTIONS(3711),
    [anon_sym_mutable] = ACTIONS(3711),
    [anon_sym_constinit] = ACTIONS(3711),
    [anon_sym_consteval] = ACTIONS(3711),
    [anon_sym_alignas] = ACTIONS(3711),
    [anon_sym__Alignas] = ACTIONS(3711),
    [sym_primitive_type] = ACTIONS(3711),
    [anon_sym_enum] = ACTIONS(3711),
    [anon_sym_class] = ACTIONS(3711),
    [anon_sym_struct] = ACTIONS(3711),
    [anon_sym_union] = ACTIONS(3711),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_This] = ACTIONS(3711),
    [anon_sym_decltype] = ACTIONS(3711),
    [anon_sym_explicit] = ACTIONS(3711),
    [anon_sym_typename] = ACTIONS(3711),
    [anon_sym_private] = ACTIONS(3711),
    [anon_sym_template] = ACTIONS(3711),
    [anon_sym_operator] = ACTIONS(3711),
    [anon_sym_friend] = ACTIONS(3711),
    [anon_sym_public] = ACTIONS(3711),
    [anon_sym_protected] = ACTIONS(3711),
    [anon_sym_static_assert] = ACTIONS(3711),
    [anon_sym_precise] = ACTIONS(3711),
    [anon_sym_shared] = ACTIONS(3711),
    [anon_sym_groupshared] = ACTIONS(3711),
    [anon_sym_uniform] = ACTIONS(3711),
    [anon_sym_row_major] = ACTIONS(3711),
    [anon_sym_column_major] = ACTIONS(3711),
    [anon_sym_globallycoherent] = ACTIONS(3711),
    [anon_sym_centroid] = ACTIONS(3711),
    [anon_sym_noperspective] = ACTIONS(3711),
    [anon_sym_nointerpolation] = ACTIONS(3711),
    [anon_sym_sample] = ACTIONS(3711),
    [anon_sym_linear] = ACTIONS(3711),
    [anon_sym_snorm] = ACTIONS(3711),
    [anon_sym_unorm] = ACTIONS(3711),
    [anon_sym_point] = ACTIONS(3711),
    [anon_sym_line] = ACTIONS(3711),
    [anon_sym_triangleadj] = ACTIONS(3711),
    [anon_sym_lineadj] = ACTIONS(3711),
    [anon_sym_triangle] = ACTIONS(3711),
    [anon_sym_interface] = ACTIONS(3711),
    [anon_sym_extension] = ACTIONS(3711),
    [anon_sym___init] = ACTIONS(3711),
    [anon_sym___subscript] = ACTIONS(3711),
    [anon_sym_property] = ACTIONS(3711),
    [anon_sym_associatedtype] = ACTIONS(3711),
  },
  [2249] = {
    [sym_identifier] = ACTIONS(3715),
    [aux_sym_preproc_def_token1] = ACTIONS(3715),
    [aux_sym_preproc_if_token1] = ACTIONS(3715),
    [aux_sym_preproc_if_token2] = ACTIONS(3715),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3715),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3715),
    [sym_preproc_directive] = ACTIONS(3715),
    [anon_sym_LPAREN2] = ACTIONS(3717),
    [anon_sym_TILDE] = ACTIONS(3717),
    [anon_sym_STAR] = ACTIONS(3717),
    [anon_sym_AMP_AMP] = ACTIONS(3717),
    [anon_sym_AMP] = ACTIONS(3715),
    [anon_sym_SEMI] = ACTIONS(3717),
    [anon_sym___extension__] = ACTIONS(3715),
    [anon_sym_typedef] = ACTIONS(3715),
    [anon_sym_in] = ACTIONS(3715),
    [anon_sym_out] = ACTIONS(3715),
    [anon_sym_inout] = ACTIONS(3715),
    [anon_sym_virtual] = ACTIONS(3715),
    [anon_sym_extern] = ACTIONS(3715),
    [anon_sym___attribute__] = ACTIONS(3715),
    [anon_sym___attribute] = ACTIONS(3715),
    [anon_sym_using] = ACTIONS(3715),
    [anon_sym_COLON_COLON] = ACTIONS(3717),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3717),
    [anon_sym___declspec] = ACTIONS(3715),
    [anon_sym___based] = ACTIONS(3715),
    [anon_sym_signed] = ACTIONS(3715),
    [anon_sym_unsigned] = ACTIONS(3715),
    [anon_sym_long] = ACTIONS(3715),
    [anon_sym_short] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_static] = ACTIONS(3715),
    [anon_sym_register] = ACTIONS(3715),
    [anon_sym_inline] = ACTIONS(3715),
    [anon_sym___inline] = ACTIONS(3715),
    [anon_sym___inline__] = ACTIONS(3715),
    [anon_sym___forceinline] = ACTIONS(3715),
    [anon_sym_thread_local] = ACTIONS(3715),
    [anon_sym___thread] = ACTIONS(3715),
    [anon_sym_const] = ACTIONS(3715),
    [anon_sym_constexpr] = ACTIONS(3715),
    [anon_sym_volatile] = ACTIONS(3715),
    [anon_sym_restrict] = ACTIONS(3715),
    [anon_sym___restrict__] = ACTIONS(3715),
    [anon_sym__Atomic] = ACTIONS(3715),
    [anon_sym__Noreturn] = ACTIONS(3715),
    [anon_sym_noreturn] = ACTIONS(3715),
    [anon_sym__Nonnull] = ACTIONS(3715),
    [anon_sym_mutable] = ACTIONS(3715),
    [anon_sym_constinit] = ACTIONS(3715),
    [anon_sym_consteval] = ACTIONS(3715),
    [anon_sym_alignas] = ACTIONS(3715),
    [anon_sym__Alignas] = ACTIONS(3715),
    [sym_primitive_type] = ACTIONS(3715),
    [anon_sym_enum] = ACTIONS(3715),
    [anon_sym_class] = ACTIONS(3715),
    [anon_sym_struct] = ACTIONS(3715),
    [anon_sym_union] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3715),
    [anon_sym_let] = ACTIONS(3715),
    [anon_sym_This] = ACTIONS(3715),
    [anon_sym_decltype] = ACTIONS(3715),
    [anon_sym_explicit] = ACTIONS(3715),
    [anon_sym_typename] = ACTIONS(3715),
    [anon_sym_private] = ACTIONS(3715),
    [anon_sym_template] = ACTIONS(3715),
    [anon_sym_operator] = ACTIONS(3715),
    [anon_sym_friend] = ACTIONS(3715),
    [anon_sym_public] = ACTIONS(3715),
    [anon_sym_protected] = ACTIONS(3715),
    [anon_sym_static_assert] = ACTIONS(3715),
    [anon_sym_precise] = ACTIONS(3715),
    [anon_sym_shared] = ACTIONS(3715),
    [anon_sym_groupshared] = ACTIONS(3715),
    [anon_sym_uniform] = ACTIONS(3715),
    [anon_sym_row_major] = ACTIONS(3715),
    [anon_sym_column_major] = ACTIONS(3715),
    [anon_sym_globallycoherent] = ACTIONS(3715),
    [anon_sym_centroid] = ACTIONS(3715),
    [anon_sym_noperspective] = ACTIONS(3715),
    [anon_sym_nointerpolation] = ACTIONS(3715),
    [anon_sym_sample] = ACTIONS(3715),
    [anon_sym_linear] = ACTIONS(3715),
    [anon_sym_snorm] = ACTIONS(3715),
    [anon_sym_unorm] = ACTIONS(3715),
    [anon_sym_point] = ACTIONS(3715),
    [anon_sym_line] = ACTIONS(3715),
    [anon_sym_triangleadj] = ACTIONS(3715),
    [anon_sym_lineadj] = ACTIONS(3715),
    [anon_sym_triangle] = ACTIONS(3715),
    [anon_sym_interface] = ACTIONS(3715),
    [anon_sym_extension] = ACTIONS(3715),
    [anon_sym___init] = ACTIONS(3715),
    [anon_sym___subscript] = ACTIONS(3715),
    [anon_sym_property] = ACTIONS(3715),
    [anon_sym_associatedtype] = ACTIONS(3715),
  },
  [2250] = {
    [sym_identifier] = ACTIONS(3735),
    [aux_sym_preproc_def_token1] = ACTIONS(3735),
    [aux_sym_preproc_if_token1] = ACTIONS(3735),
    [aux_sym_preproc_if_token2] = ACTIONS(3735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3735),
    [sym_preproc_directive] = ACTIONS(3735),
    [anon_sym_LPAREN2] = ACTIONS(3737),
    [anon_sym_TILDE] = ACTIONS(3737),
    [anon_sym_STAR] = ACTIONS(3737),
    [anon_sym_AMP_AMP] = ACTIONS(3737),
    [anon_sym_AMP] = ACTIONS(3735),
    [anon_sym_SEMI] = ACTIONS(3737),
    [anon_sym___extension__] = ACTIONS(3735),
    [anon_sym_typedef] = ACTIONS(3735),
    [anon_sym_in] = ACTIONS(3735),
    [anon_sym_out] = ACTIONS(3735),
    [anon_sym_inout] = ACTIONS(3735),
    [anon_sym_virtual] = ACTIONS(3735),
    [anon_sym_extern] = ACTIONS(3735),
    [anon_sym___attribute__] = ACTIONS(3735),
    [anon_sym___attribute] = ACTIONS(3735),
    [anon_sym_using] = ACTIONS(3735),
    [anon_sym_COLON_COLON] = ACTIONS(3737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3737),
    [anon_sym___declspec] = ACTIONS(3735),
    [anon_sym___based] = ACTIONS(3735),
    [anon_sym_signed] = ACTIONS(3735),
    [anon_sym_unsigned] = ACTIONS(3735),
    [anon_sym_long] = ACTIONS(3735),
    [anon_sym_short] = ACTIONS(3735),
    [anon_sym_LBRACK] = ACTIONS(3735),
    [anon_sym_static] = ACTIONS(3735),
    [anon_sym_register] = ACTIONS(3735),
    [anon_sym_inline] = ACTIONS(3735),
    [anon_sym___inline] = ACTIONS(3735),
    [anon_sym___inline__] = ACTIONS(3735),
    [anon_sym___forceinline] = ACTIONS(3735),
    [anon_sym_thread_local] = ACTIONS(3735),
    [anon_sym___thread] = ACTIONS(3735),
    [anon_sym_const] = ACTIONS(3735),
    [anon_sym_constexpr] = ACTIONS(3735),
    [anon_sym_volatile] = ACTIONS(3735),
    [anon_sym_restrict] = ACTIONS(3735),
    [anon_sym___restrict__] = ACTIONS(3735),
    [anon_sym__Atomic] = ACTIONS(3735),
    [anon_sym__Noreturn] = ACTIONS(3735),
    [anon_sym_noreturn] = ACTIONS(3735),
    [anon_sym__Nonnull] = ACTIONS(3735),
    [anon_sym_mutable] = ACTIONS(3735),
    [anon_sym_constinit] = ACTIONS(3735),
    [anon_sym_consteval] = ACTIONS(3735),
    [anon_sym_alignas] = ACTIONS(3735),
    [anon_sym__Alignas] = ACTIONS(3735),
    [sym_primitive_type] = ACTIONS(3735),
    [anon_sym_enum] = ACTIONS(3735),
    [anon_sym_class] = ACTIONS(3735),
    [anon_sym_struct] = ACTIONS(3735),
    [anon_sym_union] = ACTIONS(3735),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3735),
    [anon_sym_let] = ACTIONS(3735),
    [anon_sym_This] = ACTIONS(3735),
    [anon_sym_decltype] = ACTIONS(3735),
    [anon_sym_explicit] = ACTIONS(3735),
    [anon_sym_typename] = ACTIONS(3735),
    [anon_sym_private] = ACTIONS(3735),
    [anon_sym_template] = ACTIONS(3735),
    [anon_sym_operator] = ACTIONS(3735),
    [anon_sym_friend] = ACTIONS(3735),
    [anon_sym_public] = ACTIONS(3735),
    [anon_sym_protected] = ACTIONS(3735),
    [anon_sym_static_assert] = ACTIONS(3735),
    [anon_sym_precise] = ACTIONS(3735),
    [anon_sym_shared] = ACTIONS(3735),
    [anon_sym_groupshared] = ACTIONS(3735),
    [anon_sym_uniform] = ACTIONS(3735),
    [anon_sym_row_major] = ACTIONS(3735),
    [anon_sym_column_major] = ACTIONS(3735),
    [anon_sym_globallycoherent] = ACTIONS(3735),
    [anon_sym_centroid] = ACTIONS(3735),
    [anon_sym_noperspective] = ACTIONS(3735),
    [anon_sym_nointerpolation] = ACTIONS(3735),
    [anon_sym_sample] = ACTIONS(3735),
    [anon_sym_linear] = ACTIONS(3735),
    [anon_sym_snorm] = ACTIONS(3735),
    [anon_sym_unorm] = ACTIONS(3735),
    [anon_sym_point] = ACTIONS(3735),
    [anon_sym_line] = ACTIONS(3735),
    [anon_sym_triangleadj] = ACTIONS(3735),
    [anon_sym_lineadj] = ACTIONS(3735),
    [anon_sym_triangle] = ACTIONS(3735),
    [anon_sym_interface] = ACTIONS(3735),
    [anon_sym_extension] = ACTIONS(3735),
    [anon_sym___init] = ACTIONS(3735),
    [anon_sym___subscript] = ACTIONS(3735),
    [anon_sym_property] = ACTIONS(3735),
    [anon_sym_associatedtype] = ACTIONS(3735),
  },
  [2251] = {
    [sym_identifier] = ACTIONS(3669),
    [aux_sym_preproc_def_token1] = ACTIONS(3669),
    [aux_sym_preproc_if_token1] = ACTIONS(3669),
    [aux_sym_preproc_if_token2] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3669),
    [sym_preproc_directive] = ACTIONS(3669),
    [anon_sym_LPAREN2] = ACTIONS(3671),
    [anon_sym_TILDE] = ACTIONS(3671),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3671),
    [anon_sym_AMP] = ACTIONS(3669),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym___extension__] = ACTIONS(3669),
    [anon_sym_typedef] = ACTIONS(3669),
    [anon_sym_in] = ACTIONS(3669),
    [anon_sym_out] = ACTIONS(3669),
    [anon_sym_inout] = ACTIONS(3669),
    [anon_sym_virtual] = ACTIONS(3669),
    [anon_sym_extern] = ACTIONS(3669),
    [anon_sym___attribute__] = ACTIONS(3669),
    [anon_sym___attribute] = ACTIONS(3669),
    [anon_sym_using] = ACTIONS(3669),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3671),
    [anon_sym___declspec] = ACTIONS(3669),
    [anon_sym___based] = ACTIONS(3669),
    [anon_sym_signed] = ACTIONS(3669),
    [anon_sym_unsigned] = ACTIONS(3669),
    [anon_sym_long] = ACTIONS(3669),
    [anon_sym_short] = ACTIONS(3669),
    [anon_sym_LBRACK] = ACTIONS(3669),
    [anon_sym_static] = ACTIONS(3669),
    [anon_sym_register] = ACTIONS(3669),
    [anon_sym_inline] = ACTIONS(3669),
    [anon_sym___inline] = ACTIONS(3669),
    [anon_sym___inline__] = ACTIONS(3669),
    [anon_sym___forceinline] = ACTIONS(3669),
    [anon_sym_thread_local] = ACTIONS(3669),
    [anon_sym___thread] = ACTIONS(3669),
    [anon_sym_const] = ACTIONS(3669),
    [anon_sym_constexpr] = ACTIONS(3669),
    [anon_sym_volatile] = ACTIONS(3669),
    [anon_sym_restrict] = ACTIONS(3669),
    [anon_sym___restrict__] = ACTIONS(3669),
    [anon_sym__Atomic] = ACTIONS(3669),
    [anon_sym__Noreturn] = ACTIONS(3669),
    [anon_sym_noreturn] = ACTIONS(3669),
    [anon_sym__Nonnull] = ACTIONS(3669),
    [anon_sym_mutable] = ACTIONS(3669),
    [anon_sym_constinit] = ACTIONS(3669),
    [anon_sym_consteval] = ACTIONS(3669),
    [anon_sym_alignas] = ACTIONS(3669),
    [anon_sym__Alignas] = ACTIONS(3669),
    [sym_primitive_type] = ACTIONS(3669),
    [anon_sym_enum] = ACTIONS(3669),
    [anon_sym_class] = ACTIONS(3669),
    [anon_sym_struct] = ACTIONS(3669),
    [anon_sym_union] = ACTIONS(3669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3669),
    [anon_sym_let] = ACTIONS(3669),
    [anon_sym_This] = ACTIONS(3669),
    [anon_sym_decltype] = ACTIONS(3669),
    [anon_sym_explicit] = ACTIONS(3669),
    [anon_sym_typename] = ACTIONS(3669),
    [anon_sym_private] = ACTIONS(3669),
    [anon_sym_template] = ACTIONS(3669),
    [anon_sym_operator] = ACTIONS(3669),
    [anon_sym_friend] = ACTIONS(3669),
    [anon_sym_public] = ACTIONS(3669),
    [anon_sym_protected] = ACTIONS(3669),
    [anon_sym_static_assert] = ACTIONS(3669),
    [anon_sym_precise] = ACTIONS(3669),
    [anon_sym_shared] = ACTIONS(3669),
    [anon_sym_groupshared] = ACTIONS(3669),
    [anon_sym_uniform] = ACTIONS(3669),
    [anon_sym_row_major] = ACTIONS(3669),
    [anon_sym_column_major] = ACTIONS(3669),
    [anon_sym_globallycoherent] = ACTIONS(3669),
    [anon_sym_centroid] = ACTIONS(3669),
    [anon_sym_noperspective] = ACTIONS(3669),
    [anon_sym_nointerpolation] = ACTIONS(3669),
    [anon_sym_sample] = ACTIONS(3669),
    [anon_sym_linear] = ACTIONS(3669),
    [anon_sym_snorm] = ACTIONS(3669),
    [anon_sym_unorm] = ACTIONS(3669),
    [anon_sym_point] = ACTIONS(3669),
    [anon_sym_line] = ACTIONS(3669),
    [anon_sym_triangleadj] = ACTIONS(3669),
    [anon_sym_lineadj] = ACTIONS(3669),
    [anon_sym_triangle] = ACTIONS(3669),
    [anon_sym_interface] = ACTIONS(3669),
    [anon_sym_extension] = ACTIONS(3669),
    [anon_sym___init] = ACTIONS(3669),
    [anon_sym___subscript] = ACTIONS(3669),
    [anon_sym_property] = ACTIONS(3669),
    [anon_sym_associatedtype] = ACTIONS(3669),
  },
  [2252] = {
    [sym_identifier] = ACTIONS(3673),
    [aux_sym_preproc_def_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token2] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3673),
    [sym_preproc_directive] = ACTIONS(3673),
    [anon_sym_LPAREN2] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3673),
    [anon_sym_SEMI] = ACTIONS(3675),
    [anon_sym___extension__] = ACTIONS(3673),
    [anon_sym_typedef] = ACTIONS(3673),
    [anon_sym_in] = ACTIONS(3673),
    [anon_sym_out] = ACTIONS(3673),
    [anon_sym_inout] = ACTIONS(3673),
    [anon_sym_virtual] = ACTIONS(3673),
    [anon_sym_extern] = ACTIONS(3673),
    [anon_sym___attribute__] = ACTIONS(3673),
    [anon_sym___attribute] = ACTIONS(3673),
    [anon_sym_using] = ACTIONS(3673),
    [anon_sym_COLON_COLON] = ACTIONS(3675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3675),
    [anon_sym___declspec] = ACTIONS(3673),
    [anon_sym___based] = ACTIONS(3673),
    [anon_sym_signed] = ACTIONS(3673),
    [anon_sym_unsigned] = ACTIONS(3673),
    [anon_sym_long] = ACTIONS(3673),
    [anon_sym_short] = ACTIONS(3673),
    [anon_sym_LBRACK] = ACTIONS(3673),
    [anon_sym_static] = ACTIONS(3673),
    [anon_sym_register] = ACTIONS(3673),
    [anon_sym_inline] = ACTIONS(3673),
    [anon_sym___inline] = ACTIONS(3673),
    [anon_sym___inline__] = ACTIONS(3673),
    [anon_sym___forceinline] = ACTIONS(3673),
    [anon_sym_thread_local] = ACTIONS(3673),
    [anon_sym___thread] = ACTIONS(3673),
    [anon_sym_const] = ACTIONS(3673),
    [anon_sym_constexpr] = ACTIONS(3673),
    [anon_sym_volatile] = ACTIONS(3673),
    [anon_sym_restrict] = ACTIONS(3673),
    [anon_sym___restrict__] = ACTIONS(3673),
    [anon_sym__Atomic] = ACTIONS(3673),
    [anon_sym__Noreturn] = ACTIONS(3673),
    [anon_sym_noreturn] = ACTIONS(3673),
    [anon_sym__Nonnull] = ACTIONS(3673),
    [anon_sym_mutable] = ACTIONS(3673),
    [anon_sym_constinit] = ACTIONS(3673),
    [anon_sym_consteval] = ACTIONS(3673),
    [anon_sym_alignas] = ACTIONS(3673),
    [anon_sym__Alignas] = ACTIONS(3673),
    [sym_primitive_type] = ACTIONS(3673),
    [anon_sym_enum] = ACTIONS(3673),
    [anon_sym_class] = ACTIONS(3673),
    [anon_sym_struct] = ACTIONS(3673),
    [anon_sym_union] = ACTIONS(3673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3673),
    [anon_sym_let] = ACTIONS(3673),
    [anon_sym_This] = ACTIONS(3673),
    [anon_sym_decltype] = ACTIONS(3673),
    [anon_sym_explicit] = ACTIONS(3673),
    [anon_sym_typename] = ACTIONS(3673),
    [anon_sym_private] = ACTIONS(3673),
    [anon_sym_template] = ACTIONS(3673),
    [anon_sym_operator] = ACTIONS(3673),
    [anon_sym_friend] = ACTIONS(3673),
    [anon_sym_public] = ACTIONS(3673),
    [anon_sym_protected] = ACTIONS(3673),
    [anon_sym_static_assert] = ACTIONS(3673),
    [anon_sym_precise] = ACTIONS(3673),
    [anon_sym_shared] = ACTIONS(3673),
    [anon_sym_groupshared] = ACTIONS(3673),
    [anon_sym_uniform] = ACTIONS(3673),
    [anon_sym_row_major] = ACTIONS(3673),
    [anon_sym_column_major] = ACTIONS(3673),
    [anon_sym_globallycoherent] = ACTIONS(3673),
    [anon_sym_centroid] = ACTIONS(3673),
    [anon_sym_noperspective] = ACTIONS(3673),
    [anon_sym_nointerpolation] = ACTIONS(3673),
    [anon_sym_sample] = ACTIONS(3673),
    [anon_sym_linear] = ACTIONS(3673),
    [anon_sym_snorm] = ACTIONS(3673),
    [anon_sym_unorm] = ACTIONS(3673),
    [anon_sym_point] = ACTIONS(3673),
    [anon_sym_line] = ACTIONS(3673),
    [anon_sym_triangleadj] = ACTIONS(3673),
    [anon_sym_lineadj] = ACTIONS(3673),
    [anon_sym_triangle] = ACTIONS(3673),
    [anon_sym_interface] = ACTIONS(3673),
    [anon_sym_extension] = ACTIONS(3673),
    [anon_sym___init] = ACTIONS(3673),
    [anon_sym___subscript] = ACTIONS(3673),
    [anon_sym_property] = ACTIONS(3673),
    [anon_sym_associatedtype] = ACTIONS(3673),
  },
  [2253] = {
    [sym_identifier] = ACTIONS(3771),
    [aux_sym_preproc_def_token1] = ACTIONS(3771),
    [aux_sym_preproc_if_token1] = ACTIONS(3771),
    [aux_sym_preproc_if_token2] = ACTIONS(3771),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3771),
    [sym_preproc_directive] = ACTIONS(3771),
    [anon_sym_LPAREN2] = ACTIONS(3773),
    [anon_sym_TILDE] = ACTIONS(3773),
    [anon_sym_STAR] = ACTIONS(3773),
    [anon_sym_AMP_AMP] = ACTIONS(3773),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_SEMI] = ACTIONS(3773),
    [anon_sym___extension__] = ACTIONS(3771),
    [anon_sym_typedef] = ACTIONS(3771),
    [anon_sym_in] = ACTIONS(3771),
    [anon_sym_out] = ACTIONS(3771),
    [anon_sym_inout] = ACTIONS(3771),
    [anon_sym_virtual] = ACTIONS(3771),
    [anon_sym_extern] = ACTIONS(3771),
    [anon_sym___attribute__] = ACTIONS(3771),
    [anon_sym___attribute] = ACTIONS(3771),
    [anon_sym_using] = ACTIONS(3771),
    [anon_sym_COLON_COLON] = ACTIONS(3773),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3773),
    [anon_sym___declspec] = ACTIONS(3771),
    [anon_sym___based] = ACTIONS(3771),
    [anon_sym_signed] = ACTIONS(3771),
    [anon_sym_unsigned] = ACTIONS(3771),
    [anon_sym_long] = ACTIONS(3771),
    [anon_sym_short] = ACTIONS(3771),
    [anon_sym_LBRACK] = ACTIONS(3771),
    [anon_sym_static] = ACTIONS(3771),
    [anon_sym_register] = ACTIONS(3771),
    [anon_sym_inline] = ACTIONS(3771),
    [anon_sym___inline] = ACTIONS(3771),
    [anon_sym___inline__] = ACTIONS(3771),
    [anon_sym___forceinline] = ACTIONS(3771),
    [anon_sym_thread_local] = ACTIONS(3771),
    [anon_sym___thread] = ACTIONS(3771),
    [anon_sym_const] = ACTIONS(3771),
    [anon_sym_constexpr] = ACTIONS(3771),
    [anon_sym_volatile] = ACTIONS(3771),
    [anon_sym_restrict] = ACTIONS(3771),
    [anon_sym___restrict__] = ACTIONS(3771),
    [anon_sym__Atomic] = ACTIONS(3771),
    [anon_sym__Noreturn] = ACTIONS(3771),
    [anon_sym_noreturn] = ACTIONS(3771),
    [anon_sym__Nonnull] = ACTIONS(3771),
    [anon_sym_mutable] = ACTIONS(3771),
    [anon_sym_constinit] = ACTIONS(3771),
    [anon_sym_consteval] = ACTIONS(3771),
    [anon_sym_alignas] = ACTIONS(3771),
    [anon_sym__Alignas] = ACTIONS(3771),
    [sym_primitive_type] = ACTIONS(3771),
    [anon_sym_enum] = ACTIONS(3771),
    [anon_sym_class] = ACTIONS(3771),
    [anon_sym_struct] = ACTIONS(3771),
    [anon_sym_union] = ACTIONS(3771),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3771),
    [anon_sym_let] = ACTIONS(3771),
    [anon_sym_This] = ACTIONS(3771),
    [anon_sym_decltype] = ACTIONS(3771),
    [anon_sym_explicit] = ACTIONS(3771),
    [anon_sym_typename] = ACTIONS(3771),
    [anon_sym_private] = ACTIONS(3771),
    [anon_sym_template] = ACTIONS(3771),
    [anon_sym_operator] = ACTIONS(3771),
    [anon_sym_friend] = ACTIONS(3771),
    [anon_sym_public] = ACTIONS(3771),
    [anon_sym_protected] = ACTIONS(3771),
    [anon_sym_static_assert] = ACTIONS(3771),
    [anon_sym_precise] = ACTIONS(3771),
    [anon_sym_shared] = ACTIONS(3771),
    [anon_sym_groupshared] = ACTIONS(3771),
    [anon_sym_uniform] = ACTIONS(3771),
    [anon_sym_row_major] = ACTIONS(3771),
    [anon_sym_column_major] = ACTIONS(3771),
    [anon_sym_globallycoherent] = ACTIONS(3771),
    [anon_sym_centroid] = ACTIONS(3771),
    [anon_sym_noperspective] = ACTIONS(3771),
    [anon_sym_nointerpolation] = ACTIONS(3771),
    [anon_sym_sample] = ACTIONS(3771),
    [anon_sym_linear] = ACTIONS(3771),
    [anon_sym_snorm] = ACTIONS(3771),
    [anon_sym_unorm] = ACTIONS(3771),
    [anon_sym_point] = ACTIONS(3771),
    [anon_sym_line] = ACTIONS(3771),
    [anon_sym_triangleadj] = ACTIONS(3771),
    [anon_sym_lineadj] = ACTIONS(3771),
    [anon_sym_triangle] = ACTIONS(3771),
    [anon_sym_interface] = ACTIONS(3771),
    [anon_sym_extension] = ACTIONS(3771),
    [anon_sym___init] = ACTIONS(3771),
    [anon_sym___subscript] = ACTIONS(3771),
    [anon_sym_property] = ACTIONS(3771),
    [anon_sym_associatedtype] = ACTIONS(3771),
  },
  [2254] = {
    [sym_identifier] = ACTIONS(3792),
    [aux_sym_preproc_def_token1] = ACTIONS(3792),
    [aux_sym_preproc_if_token1] = ACTIONS(3792),
    [aux_sym_preproc_if_token2] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3792),
    [sym_preproc_directive] = ACTIONS(3792),
    [anon_sym_LPAREN2] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3794),
    [anon_sym_STAR] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_AMP] = ACTIONS(3792),
    [anon_sym_SEMI] = ACTIONS(3794),
    [anon_sym___extension__] = ACTIONS(3792),
    [anon_sym_typedef] = ACTIONS(3792),
    [anon_sym_in] = ACTIONS(3792),
    [anon_sym_out] = ACTIONS(3792),
    [anon_sym_inout] = ACTIONS(3792),
    [anon_sym_virtual] = ACTIONS(3792),
    [anon_sym_extern] = ACTIONS(3792),
    [anon_sym___attribute__] = ACTIONS(3792),
    [anon_sym___attribute] = ACTIONS(3792),
    [anon_sym_using] = ACTIONS(3792),
    [anon_sym_COLON_COLON] = ACTIONS(3794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3794),
    [anon_sym___declspec] = ACTIONS(3792),
    [anon_sym___based] = ACTIONS(3792),
    [anon_sym_signed] = ACTIONS(3792),
    [anon_sym_unsigned] = ACTIONS(3792),
    [anon_sym_long] = ACTIONS(3792),
    [anon_sym_short] = ACTIONS(3792),
    [anon_sym_LBRACK] = ACTIONS(3792),
    [anon_sym_static] = ACTIONS(3792),
    [anon_sym_register] = ACTIONS(3792),
    [anon_sym_inline] = ACTIONS(3792),
    [anon_sym___inline] = ACTIONS(3792),
    [anon_sym___inline__] = ACTIONS(3792),
    [anon_sym___forceinline] = ACTIONS(3792),
    [anon_sym_thread_local] = ACTIONS(3792),
    [anon_sym___thread] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3792),
    [anon_sym_constexpr] = ACTIONS(3792),
    [anon_sym_volatile] = ACTIONS(3792),
    [anon_sym_restrict] = ACTIONS(3792),
    [anon_sym___restrict__] = ACTIONS(3792),
    [anon_sym__Atomic] = ACTIONS(3792),
    [anon_sym__Noreturn] = ACTIONS(3792),
    [anon_sym_noreturn] = ACTIONS(3792),
    [anon_sym__Nonnull] = ACTIONS(3792),
    [anon_sym_mutable] = ACTIONS(3792),
    [anon_sym_constinit] = ACTIONS(3792),
    [anon_sym_consteval] = ACTIONS(3792),
    [anon_sym_alignas] = ACTIONS(3792),
    [anon_sym__Alignas] = ACTIONS(3792),
    [sym_primitive_type] = ACTIONS(3792),
    [anon_sym_enum] = ACTIONS(3792),
    [anon_sym_class] = ACTIONS(3792),
    [anon_sym_struct] = ACTIONS(3792),
    [anon_sym_union] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3792),
    [anon_sym_let] = ACTIONS(3792),
    [anon_sym_This] = ACTIONS(3792),
    [anon_sym_decltype] = ACTIONS(3792),
    [anon_sym_explicit] = ACTIONS(3792),
    [anon_sym_typename] = ACTIONS(3792),
    [anon_sym_private] = ACTIONS(3792),
    [anon_sym_template] = ACTIONS(3792),
    [anon_sym_operator] = ACTIONS(3792),
    [anon_sym_friend] = ACTIONS(3792),
    [anon_sym_public] = ACTIONS(3792),
    [anon_sym_protected] = ACTIONS(3792),
    [anon_sym_static_assert] = ACTIONS(3792),
    [anon_sym_precise] = ACTIONS(3792),
    [anon_sym_shared] = ACTIONS(3792),
    [anon_sym_groupshared] = ACTIONS(3792),
    [anon_sym_uniform] = ACTIONS(3792),
    [anon_sym_row_major] = ACTIONS(3792),
    [anon_sym_column_major] = ACTIONS(3792),
    [anon_sym_globallycoherent] = ACTIONS(3792),
    [anon_sym_centroid] = ACTIONS(3792),
    [anon_sym_noperspective] = ACTIONS(3792),
    [anon_sym_nointerpolation] = ACTIONS(3792),
    [anon_sym_sample] = ACTIONS(3792),
    [anon_sym_linear] = ACTIONS(3792),
    [anon_sym_snorm] = ACTIONS(3792),
    [anon_sym_unorm] = ACTIONS(3792),
    [anon_sym_point] = ACTIONS(3792),
    [anon_sym_line] = ACTIONS(3792),
    [anon_sym_triangleadj] = ACTIONS(3792),
    [anon_sym_lineadj] = ACTIONS(3792),
    [anon_sym_triangle] = ACTIONS(3792),
    [anon_sym_interface] = ACTIONS(3792),
    [anon_sym_extension] = ACTIONS(3792),
    [anon_sym___init] = ACTIONS(3792),
    [anon_sym___subscript] = ACTIONS(3792),
    [anon_sym_property] = ACTIONS(3792),
    [anon_sym_associatedtype] = ACTIONS(3792),
  },
  [2255] = {
    [sym_identifier] = ACTIONS(3792),
    [aux_sym_preproc_def_token1] = ACTIONS(3792),
    [aux_sym_preproc_if_token1] = ACTIONS(3792),
    [aux_sym_preproc_if_token2] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3792),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3792),
    [sym_preproc_directive] = ACTIONS(3792),
    [anon_sym_LPAREN2] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3794),
    [anon_sym_STAR] = ACTIONS(3794),
    [anon_sym_AMP_AMP] = ACTIONS(3794),
    [anon_sym_AMP] = ACTIONS(3792),
    [anon_sym_SEMI] = ACTIONS(3794),
    [anon_sym___extension__] = ACTIONS(3792),
    [anon_sym_typedef] = ACTIONS(3792),
    [anon_sym_in] = ACTIONS(3792),
    [anon_sym_out] = ACTIONS(3792),
    [anon_sym_inout] = ACTIONS(3792),
    [anon_sym_virtual] = ACTIONS(3792),
    [anon_sym_extern] = ACTIONS(3792),
    [anon_sym___attribute__] = ACTIONS(3792),
    [anon_sym___attribute] = ACTIONS(3792),
    [anon_sym_using] = ACTIONS(3792),
    [anon_sym_COLON_COLON] = ACTIONS(3794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3794),
    [anon_sym___declspec] = ACTIONS(3792),
    [anon_sym___based] = ACTIONS(3792),
    [anon_sym_signed] = ACTIONS(3792),
    [anon_sym_unsigned] = ACTIONS(3792),
    [anon_sym_long] = ACTIONS(3792),
    [anon_sym_short] = ACTIONS(3792),
    [anon_sym_LBRACK] = ACTIONS(3792),
    [anon_sym_static] = ACTIONS(3792),
    [anon_sym_register] = ACTIONS(3792),
    [anon_sym_inline] = ACTIONS(3792),
    [anon_sym___inline] = ACTIONS(3792),
    [anon_sym___inline__] = ACTIONS(3792),
    [anon_sym___forceinline] = ACTIONS(3792),
    [anon_sym_thread_local] = ACTIONS(3792),
    [anon_sym___thread] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3792),
    [anon_sym_constexpr] = ACTIONS(3792),
    [anon_sym_volatile] = ACTIONS(3792),
    [anon_sym_restrict] = ACTIONS(3792),
    [anon_sym___restrict__] = ACTIONS(3792),
    [anon_sym__Atomic] = ACTIONS(3792),
    [anon_sym__Noreturn] = ACTIONS(3792),
    [anon_sym_noreturn] = ACTIONS(3792),
    [anon_sym__Nonnull] = ACTIONS(3792),
    [anon_sym_mutable] = ACTIONS(3792),
    [anon_sym_constinit] = ACTIONS(3792),
    [anon_sym_consteval] = ACTIONS(3792),
    [anon_sym_alignas] = ACTIONS(3792),
    [anon_sym__Alignas] = ACTIONS(3792),
    [sym_primitive_type] = ACTIONS(3792),
    [anon_sym_enum] = ACTIONS(3792),
    [anon_sym_class] = ACTIONS(3792),
    [anon_sym_struct] = ACTIONS(3792),
    [anon_sym_union] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3792),
    [anon_sym_let] = ACTIONS(3792),
    [anon_sym_This] = ACTIONS(3792),
    [anon_sym_decltype] = ACTIONS(3792),
    [anon_sym_explicit] = ACTIONS(3792),
    [anon_sym_typename] = ACTIONS(3792),
    [anon_sym_private] = ACTIONS(3792),
    [anon_sym_template] = ACTIONS(3792),
    [anon_sym_operator] = ACTIONS(3792),
    [anon_sym_friend] = ACTIONS(3792),
    [anon_sym_public] = ACTIONS(3792),
    [anon_sym_protected] = ACTIONS(3792),
    [anon_sym_static_assert] = ACTIONS(3792),
    [anon_sym_precise] = ACTIONS(3792),
    [anon_sym_shared] = ACTIONS(3792),
    [anon_sym_groupshared] = ACTIONS(3792),
    [anon_sym_uniform] = ACTIONS(3792),
    [anon_sym_row_major] = ACTIONS(3792),
    [anon_sym_column_major] = ACTIONS(3792),
    [anon_sym_globallycoherent] = ACTIONS(3792),
    [anon_sym_centroid] = ACTIONS(3792),
    [anon_sym_noperspective] = ACTIONS(3792),
    [anon_sym_nointerpolation] = ACTIONS(3792),
    [anon_sym_sample] = ACTIONS(3792),
    [anon_sym_linear] = ACTIONS(3792),
    [anon_sym_snorm] = ACTIONS(3792),
    [anon_sym_unorm] = ACTIONS(3792),
    [anon_sym_point] = ACTIONS(3792),
    [anon_sym_line] = ACTIONS(3792),
    [anon_sym_triangleadj] = ACTIONS(3792),
    [anon_sym_lineadj] = ACTIONS(3792),
    [anon_sym_triangle] = ACTIONS(3792),
    [anon_sym_interface] = ACTIONS(3792),
    [anon_sym_extension] = ACTIONS(3792),
    [anon_sym___init] = ACTIONS(3792),
    [anon_sym___subscript] = ACTIONS(3792),
    [anon_sym_property] = ACTIONS(3792),
    [anon_sym_associatedtype] = ACTIONS(3792),
  },
  [2256] = {
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token2] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_private] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_friend] = ACTIONS(3812),
    [anon_sym_public] = ACTIONS(3812),
    [anon_sym_protected] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
    [anon_sym___init] = ACTIONS(3812),
    [anon_sym___subscript] = ACTIONS(3812),
    [anon_sym_property] = ACTIONS(3812),
    [anon_sym_associatedtype] = ACTIONS(3812),
  },
  [2257] = {
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token2] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_private] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_friend] = ACTIONS(3812),
    [anon_sym_public] = ACTIONS(3812),
    [anon_sym_protected] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
    [anon_sym___init] = ACTIONS(3812),
    [anon_sym___subscript] = ACTIONS(3812),
    [anon_sym_property] = ACTIONS(3812),
    [anon_sym_associatedtype] = ACTIONS(3812),
  },
  [2258] = {
    [sym_identifier] = ACTIONS(3816),
    [aux_sym_preproc_def_token1] = ACTIONS(3816),
    [aux_sym_preproc_if_token1] = ACTIONS(3816),
    [aux_sym_preproc_if_token2] = ACTIONS(3816),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3816),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3816),
    [sym_preproc_directive] = ACTIONS(3816),
    [anon_sym_LPAREN2] = ACTIONS(3818),
    [anon_sym_TILDE] = ACTIONS(3818),
    [anon_sym_STAR] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_SEMI] = ACTIONS(3818),
    [anon_sym___extension__] = ACTIONS(3816),
    [anon_sym_typedef] = ACTIONS(3816),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_out] = ACTIONS(3816),
    [anon_sym_inout] = ACTIONS(3816),
    [anon_sym_virtual] = ACTIONS(3816),
    [anon_sym_extern] = ACTIONS(3816),
    [anon_sym___attribute__] = ACTIONS(3816),
    [anon_sym___attribute] = ACTIONS(3816),
    [anon_sym_using] = ACTIONS(3816),
    [anon_sym_COLON_COLON] = ACTIONS(3818),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3818),
    [anon_sym___declspec] = ACTIONS(3816),
    [anon_sym___based] = ACTIONS(3816),
    [anon_sym_signed] = ACTIONS(3816),
    [anon_sym_unsigned] = ACTIONS(3816),
    [anon_sym_long] = ACTIONS(3816),
    [anon_sym_short] = ACTIONS(3816),
    [anon_sym_LBRACK] = ACTIONS(3816),
    [anon_sym_static] = ACTIONS(3816),
    [anon_sym_register] = ACTIONS(3816),
    [anon_sym_inline] = ACTIONS(3816),
    [anon_sym___inline] = ACTIONS(3816),
    [anon_sym___inline__] = ACTIONS(3816),
    [anon_sym___forceinline] = ACTIONS(3816),
    [anon_sym_thread_local] = ACTIONS(3816),
    [anon_sym___thread] = ACTIONS(3816),
    [anon_sym_const] = ACTIONS(3816),
    [anon_sym_constexpr] = ACTIONS(3816),
    [anon_sym_volatile] = ACTIONS(3816),
    [anon_sym_restrict] = ACTIONS(3816),
    [anon_sym___restrict__] = ACTIONS(3816),
    [anon_sym__Atomic] = ACTIONS(3816),
    [anon_sym__Noreturn] = ACTIONS(3816),
    [anon_sym_noreturn] = ACTIONS(3816),
    [anon_sym__Nonnull] = ACTIONS(3816),
    [anon_sym_mutable] = ACTIONS(3816),
    [anon_sym_constinit] = ACTIONS(3816),
    [anon_sym_consteval] = ACTIONS(3816),
    [anon_sym_alignas] = ACTIONS(3816),
    [anon_sym__Alignas] = ACTIONS(3816),
    [sym_primitive_type] = ACTIONS(3816),
    [anon_sym_enum] = ACTIONS(3816),
    [anon_sym_class] = ACTIONS(3816),
    [anon_sym_struct] = ACTIONS(3816),
    [anon_sym_union] = ACTIONS(3816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3816),
    [anon_sym_let] = ACTIONS(3816),
    [anon_sym_This] = ACTIONS(3816),
    [anon_sym_decltype] = ACTIONS(3816),
    [anon_sym_explicit] = ACTIONS(3816),
    [anon_sym_typename] = ACTIONS(3816),
    [anon_sym_private] = ACTIONS(3816),
    [anon_sym_template] = ACTIONS(3816),
    [anon_sym_operator] = ACTIONS(3816),
    [anon_sym_friend] = ACTIONS(3816),
    [anon_sym_public] = ACTIONS(3816),
    [anon_sym_protected] = ACTIONS(3816),
    [anon_sym_static_assert] = ACTIONS(3816),
    [anon_sym_precise] = ACTIONS(3816),
    [anon_sym_shared] = ACTIONS(3816),
    [anon_sym_groupshared] = ACTIONS(3816),
    [anon_sym_uniform] = ACTIONS(3816),
    [anon_sym_row_major] = ACTIONS(3816),
    [anon_sym_column_major] = ACTIONS(3816),
    [anon_sym_globallycoherent] = ACTIONS(3816),
    [anon_sym_centroid] = ACTIONS(3816),
    [anon_sym_noperspective] = ACTIONS(3816),
    [anon_sym_nointerpolation] = ACTIONS(3816),
    [anon_sym_sample] = ACTIONS(3816),
    [anon_sym_linear] = ACTIONS(3816),
    [anon_sym_snorm] = ACTIONS(3816),
    [anon_sym_unorm] = ACTIONS(3816),
    [anon_sym_point] = ACTIONS(3816),
    [anon_sym_line] = ACTIONS(3816),
    [anon_sym_triangleadj] = ACTIONS(3816),
    [anon_sym_lineadj] = ACTIONS(3816),
    [anon_sym_triangle] = ACTIONS(3816),
    [anon_sym_interface] = ACTIONS(3816),
    [anon_sym_extension] = ACTIONS(3816),
    [anon_sym___init] = ACTIONS(3816),
    [anon_sym___subscript] = ACTIONS(3816),
    [anon_sym_property] = ACTIONS(3816),
    [anon_sym_associatedtype] = ACTIONS(3816),
  },
  [2259] = {
    [sym_identifier] = ACTIONS(3820),
    [aux_sym_preproc_def_token1] = ACTIONS(3820),
    [aux_sym_preproc_if_token1] = ACTIONS(3820),
    [aux_sym_preproc_if_token2] = ACTIONS(3820),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3820),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3820),
    [sym_preproc_directive] = ACTIONS(3820),
    [anon_sym_LPAREN2] = ACTIONS(3822),
    [anon_sym_TILDE] = ACTIONS(3822),
    [anon_sym_STAR] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3822),
    [anon_sym_AMP] = ACTIONS(3820),
    [anon_sym_SEMI] = ACTIONS(3822),
    [anon_sym___extension__] = ACTIONS(3820),
    [anon_sym_typedef] = ACTIONS(3820),
    [anon_sym_in] = ACTIONS(3820),
    [anon_sym_out] = ACTIONS(3820),
    [anon_sym_inout] = ACTIONS(3820),
    [anon_sym_virtual] = ACTIONS(3820),
    [anon_sym_extern] = ACTIONS(3820),
    [anon_sym___attribute__] = ACTIONS(3820),
    [anon_sym___attribute] = ACTIONS(3820),
    [anon_sym_using] = ACTIONS(3820),
    [anon_sym_COLON_COLON] = ACTIONS(3822),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3822),
    [anon_sym___declspec] = ACTIONS(3820),
    [anon_sym___based] = ACTIONS(3820),
    [anon_sym_signed] = ACTIONS(3820),
    [anon_sym_unsigned] = ACTIONS(3820),
    [anon_sym_long] = ACTIONS(3820),
    [anon_sym_short] = ACTIONS(3820),
    [anon_sym_LBRACK] = ACTIONS(3820),
    [anon_sym_static] = ACTIONS(3820),
    [anon_sym_register] = ACTIONS(3820),
    [anon_sym_inline] = ACTIONS(3820),
    [anon_sym___inline] = ACTIONS(3820),
    [anon_sym___inline__] = ACTIONS(3820),
    [anon_sym___forceinline] = ACTIONS(3820),
    [anon_sym_thread_local] = ACTIONS(3820),
    [anon_sym___thread] = ACTIONS(3820),
    [anon_sym_const] = ACTIONS(3820),
    [anon_sym_constexpr] = ACTIONS(3820),
    [anon_sym_volatile] = ACTIONS(3820),
    [anon_sym_restrict] = ACTIONS(3820),
    [anon_sym___restrict__] = ACTIONS(3820),
    [anon_sym__Atomic] = ACTIONS(3820),
    [anon_sym__Noreturn] = ACTIONS(3820),
    [anon_sym_noreturn] = ACTIONS(3820),
    [anon_sym__Nonnull] = ACTIONS(3820),
    [anon_sym_mutable] = ACTIONS(3820),
    [anon_sym_constinit] = ACTIONS(3820),
    [anon_sym_consteval] = ACTIONS(3820),
    [anon_sym_alignas] = ACTIONS(3820),
    [anon_sym__Alignas] = ACTIONS(3820),
    [sym_primitive_type] = ACTIONS(3820),
    [anon_sym_enum] = ACTIONS(3820),
    [anon_sym_class] = ACTIONS(3820),
    [anon_sym_struct] = ACTIONS(3820),
    [anon_sym_union] = ACTIONS(3820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3820),
    [anon_sym_let] = ACTIONS(3820),
    [anon_sym_This] = ACTIONS(3820),
    [anon_sym_decltype] = ACTIONS(3820),
    [anon_sym_explicit] = ACTIONS(3820),
    [anon_sym_typename] = ACTIONS(3820),
    [anon_sym_private] = ACTIONS(3820),
    [anon_sym_template] = ACTIONS(3820),
    [anon_sym_operator] = ACTIONS(3820),
    [anon_sym_friend] = ACTIONS(3820),
    [anon_sym_public] = ACTIONS(3820),
    [anon_sym_protected] = ACTIONS(3820),
    [anon_sym_static_assert] = ACTIONS(3820),
    [anon_sym_precise] = ACTIONS(3820),
    [anon_sym_shared] = ACTIONS(3820),
    [anon_sym_groupshared] = ACTIONS(3820),
    [anon_sym_uniform] = ACTIONS(3820),
    [anon_sym_row_major] = ACTIONS(3820),
    [anon_sym_column_major] = ACTIONS(3820),
    [anon_sym_globallycoherent] = ACTIONS(3820),
    [anon_sym_centroid] = ACTIONS(3820),
    [anon_sym_noperspective] = ACTIONS(3820),
    [anon_sym_nointerpolation] = ACTIONS(3820),
    [anon_sym_sample] = ACTIONS(3820),
    [anon_sym_linear] = ACTIONS(3820),
    [anon_sym_snorm] = ACTIONS(3820),
    [anon_sym_unorm] = ACTIONS(3820),
    [anon_sym_point] = ACTIONS(3820),
    [anon_sym_line] = ACTIONS(3820),
    [anon_sym_triangleadj] = ACTIONS(3820),
    [anon_sym_lineadj] = ACTIONS(3820),
    [anon_sym_triangle] = ACTIONS(3820),
    [anon_sym_interface] = ACTIONS(3820),
    [anon_sym_extension] = ACTIONS(3820),
    [anon_sym___init] = ACTIONS(3820),
    [anon_sym___subscript] = ACTIONS(3820),
    [anon_sym_property] = ACTIONS(3820),
    [anon_sym_associatedtype] = ACTIONS(3820),
  },
  [2260] = {
    [sym_identifier] = ACTIONS(3824),
    [aux_sym_preproc_def_token1] = ACTIONS(3824),
    [aux_sym_preproc_if_token1] = ACTIONS(3824),
    [aux_sym_preproc_if_token2] = ACTIONS(3824),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3824),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3824),
    [sym_preproc_directive] = ACTIONS(3824),
    [anon_sym_LPAREN2] = ACTIONS(3826),
    [anon_sym_TILDE] = ACTIONS(3826),
    [anon_sym_STAR] = ACTIONS(3826),
    [anon_sym_AMP_AMP] = ACTIONS(3826),
    [anon_sym_AMP] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(3826),
    [anon_sym___extension__] = ACTIONS(3824),
    [anon_sym_typedef] = ACTIONS(3824),
    [anon_sym_in] = ACTIONS(3824),
    [anon_sym_out] = ACTIONS(3824),
    [anon_sym_inout] = ACTIONS(3824),
    [anon_sym_virtual] = ACTIONS(3824),
    [anon_sym_extern] = ACTIONS(3824),
    [anon_sym___attribute__] = ACTIONS(3824),
    [anon_sym___attribute] = ACTIONS(3824),
    [anon_sym_using] = ACTIONS(3824),
    [anon_sym_COLON_COLON] = ACTIONS(3826),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3826),
    [anon_sym___declspec] = ACTIONS(3824),
    [anon_sym___based] = ACTIONS(3824),
    [anon_sym_signed] = ACTIONS(3824),
    [anon_sym_unsigned] = ACTIONS(3824),
    [anon_sym_long] = ACTIONS(3824),
    [anon_sym_short] = ACTIONS(3824),
    [anon_sym_LBRACK] = ACTIONS(3824),
    [anon_sym_static] = ACTIONS(3824),
    [anon_sym_register] = ACTIONS(3824),
    [anon_sym_inline] = ACTIONS(3824),
    [anon_sym___inline] = ACTIONS(3824),
    [anon_sym___inline__] = ACTIONS(3824),
    [anon_sym___forceinline] = ACTIONS(3824),
    [anon_sym_thread_local] = ACTIONS(3824),
    [anon_sym___thread] = ACTIONS(3824),
    [anon_sym_const] = ACTIONS(3824),
    [anon_sym_constexpr] = ACTIONS(3824),
    [anon_sym_volatile] = ACTIONS(3824),
    [anon_sym_restrict] = ACTIONS(3824),
    [anon_sym___restrict__] = ACTIONS(3824),
    [anon_sym__Atomic] = ACTIONS(3824),
    [anon_sym__Noreturn] = ACTIONS(3824),
    [anon_sym_noreturn] = ACTIONS(3824),
    [anon_sym__Nonnull] = ACTIONS(3824),
    [anon_sym_mutable] = ACTIONS(3824),
    [anon_sym_constinit] = ACTIONS(3824),
    [anon_sym_consteval] = ACTIONS(3824),
    [anon_sym_alignas] = ACTIONS(3824),
    [anon_sym__Alignas] = ACTIONS(3824),
    [sym_primitive_type] = ACTIONS(3824),
    [anon_sym_enum] = ACTIONS(3824),
    [anon_sym_class] = ACTIONS(3824),
    [anon_sym_struct] = ACTIONS(3824),
    [anon_sym_union] = ACTIONS(3824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3824),
    [anon_sym_let] = ACTIONS(3824),
    [anon_sym_This] = ACTIONS(3824),
    [anon_sym_decltype] = ACTIONS(3824),
    [anon_sym_explicit] = ACTIONS(3824),
    [anon_sym_typename] = ACTIONS(3824),
    [anon_sym_private] = ACTIONS(3824),
    [anon_sym_template] = ACTIONS(3824),
    [anon_sym_operator] = ACTIONS(3824),
    [anon_sym_friend] = ACTIONS(3824),
    [anon_sym_public] = ACTIONS(3824),
    [anon_sym_protected] = ACTIONS(3824),
    [anon_sym_static_assert] = ACTIONS(3824),
    [anon_sym_precise] = ACTIONS(3824),
    [anon_sym_shared] = ACTIONS(3824),
    [anon_sym_groupshared] = ACTIONS(3824),
    [anon_sym_uniform] = ACTIONS(3824),
    [anon_sym_row_major] = ACTIONS(3824),
    [anon_sym_column_major] = ACTIONS(3824),
    [anon_sym_globallycoherent] = ACTIONS(3824),
    [anon_sym_centroid] = ACTIONS(3824),
    [anon_sym_noperspective] = ACTIONS(3824),
    [anon_sym_nointerpolation] = ACTIONS(3824),
    [anon_sym_sample] = ACTIONS(3824),
    [anon_sym_linear] = ACTIONS(3824),
    [anon_sym_snorm] = ACTIONS(3824),
    [anon_sym_unorm] = ACTIONS(3824),
    [anon_sym_point] = ACTIONS(3824),
    [anon_sym_line] = ACTIONS(3824),
    [anon_sym_triangleadj] = ACTIONS(3824),
    [anon_sym_lineadj] = ACTIONS(3824),
    [anon_sym_triangle] = ACTIONS(3824),
    [anon_sym_interface] = ACTIONS(3824),
    [anon_sym_extension] = ACTIONS(3824),
    [anon_sym___init] = ACTIONS(3824),
    [anon_sym___subscript] = ACTIONS(3824),
    [anon_sym_property] = ACTIONS(3824),
    [anon_sym_associatedtype] = ACTIONS(3824),
  },
  [2261] = {
    [sym_expression] = STATE(3822),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5032),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2262] = {
    [sym_identifier] = ACTIONS(3853),
    [aux_sym_preproc_def_token1] = ACTIONS(3853),
    [aux_sym_preproc_if_token1] = ACTIONS(3853),
    [aux_sym_preproc_if_token2] = ACTIONS(3853),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3853),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3853),
    [sym_preproc_directive] = ACTIONS(3853),
    [anon_sym_LPAREN2] = ACTIONS(3855),
    [anon_sym_TILDE] = ACTIONS(3855),
    [anon_sym_STAR] = ACTIONS(3855),
    [anon_sym_AMP_AMP] = ACTIONS(3855),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_SEMI] = ACTIONS(3855),
    [anon_sym___extension__] = ACTIONS(3853),
    [anon_sym_typedef] = ACTIONS(3853),
    [anon_sym_in] = ACTIONS(3853),
    [anon_sym_out] = ACTIONS(3853),
    [anon_sym_inout] = ACTIONS(3853),
    [anon_sym_virtual] = ACTIONS(3853),
    [anon_sym_extern] = ACTIONS(3853),
    [anon_sym___attribute__] = ACTIONS(3853),
    [anon_sym___attribute] = ACTIONS(3853),
    [anon_sym_using] = ACTIONS(3853),
    [anon_sym_COLON_COLON] = ACTIONS(3855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3855),
    [anon_sym___declspec] = ACTIONS(3853),
    [anon_sym___based] = ACTIONS(3853),
    [anon_sym_signed] = ACTIONS(3853),
    [anon_sym_unsigned] = ACTIONS(3853),
    [anon_sym_long] = ACTIONS(3853),
    [anon_sym_short] = ACTIONS(3853),
    [anon_sym_LBRACK] = ACTIONS(3853),
    [anon_sym_static] = ACTIONS(3853),
    [anon_sym_register] = ACTIONS(3853),
    [anon_sym_inline] = ACTIONS(3853),
    [anon_sym___inline] = ACTIONS(3853),
    [anon_sym___inline__] = ACTIONS(3853),
    [anon_sym___forceinline] = ACTIONS(3853),
    [anon_sym_thread_local] = ACTIONS(3853),
    [anon_sym___thread] = ACTIONS(3853),
    [anon_sym_const] = ACTIONS(3853),
    [anon_sym_constexpr] = ACTIONS(3853),
    [anon_sym_volatile] = ACTIONS(3853),
    [anon_sym_restrict] = ACTIONS(3853),
    [anon_sym___restrict__] = ACTIONS(3853),
    [anon_sym__Atomic] = ACTIONS(3853),
    [anon_sym__Noreturn] = ACTIONS(3853),
    [anon_sym_noreturn] = ACTIONS(3853),
    [anon_sym__Nonnull] = ACTIONS(3853),
    [anon_sym_mutable] = ACTIONS(3853),
    [anon_sym_constinit] = ACTIONS(3853),
    [anon_sym_consteval] = ACTIONS(3853),
    [anon_sym_alignas] = ACTIONS(3853),
    [anon_sym__Alignas] = ACTIONS(3853),
    [sym_primitive_type] = ACTIONS(3853),
    [anon_sym_enum] = ACTIONS(3853),
    [anon_sym_class] = ACTIONS(3853),
    [anon_sym_struct] = ACTIONS(3853),
    [anon_sym_union] = ACTIONS(3853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3853),
    [anon_sym_let] = ACTIONS(3853),
    [anon_sym_This] = ACTIONS(3853),
    [anon_sym_decltype] = ACTIONS(3853),
    [anon_sym_explicit] = ACTIONS(3853),
    [anon_sym_typename] = ACTIONS(3853),
    [anon_sym_private] = ACTIONS(3853),
    [anon_sym_template] = ACTIONS(3853),
    [anon_sym_operator] = ACTIONS(3853),
    [anon_sym_friend] = ACTIONS(3853),
    [anon_sym_public] = ACTIONS(3853),
    [anon_sym_protected] = ACTIONS(3853),
    [anon_sym_static_assert] = ACTIONS(3853),
    [anon_sym_precise] = ACTIONS(3853),
    [anon_sym_shared] = ACTIONS(3853),
    [anon_sym_groupshared] = ACTIONS(3853),
    [anon_sym_uniform] = ACTIONS(3853),
    [anon_sym_row_major] = ACTIONS(3853),
    [anon_sym_column_major] = ACTIONS(3853),
    [anon_sym_globallycoherent] = ACTIONS(3853),
    [anon_sym_centroid] = ACTIONS(3853),
    [anon_sym_noperspective] = ACTIONS(3853),
    [anon_sym_nointerpolation] = ACTIONS(3853),
    [anon_sym_sample] = ACTIONS(3853),
    [anon_sym_linear] = ACTIONS(3853),
    [anon_sym_snorm] = ACTIONS(3853),
    [anon_sym_unorm] = ACTIONS(3853),
    [anon_sym_point] = ACTIONS(3853),
    [anon_sym_line] = ACTIONS(3853),
    [anon_sym_triangleadj] = ACTIONS(3853),
    [anon_sym_lineadj] = ACTIONS(3853),
    [anon_sym_triangle] = ACTIONS(3853),
    [anon_sym_interface] = ACTIONS(3853),
    [anon_sym_extension] = ACTIONS(3853),
    [anon_sym___init] = ACTIONS(3853),
    [anon_sym___subscript] = ACTIONS(3853),
    [anon_sym_property] = ACTIONS(3853),
    [anon_sym_associatedtype] = ACTIONS(3853),
  },
  [2263] = {
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token2] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_private] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_friend] = ACTIONS(3812),
    [anon_sym_public] = ACTIONS(3812),
    [anon_sym_protected] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
    [anon_sym___init] = ACTIONS(3812),
    [anon_sym___subscript] = ACTIONS(3812),
    [anon_sym_property] = ACTIONS(3812),
    [anon_sym_associatedtype] = ACTIONS(3812),
  },
  [2264] = {
    [sym_identifier] = ACTIONS(3812),
    [aux_sym_preproc_def_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token1] = ACTIONS(3812),
    [aux_sym_preproc_if_token2] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3812),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3812),
    [sym_preproc_directive] = ACTIONS(3812),
    [anon_sym_LPAREN2] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3814),
    [anon_sym_STAR] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym___extension__] = ACTIONS(3812),
    [anon_sym_typedef] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3812),
    [anon_sym_out] = ACTIONS(3812),
    [anon_sym_inout] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym___attribute__] = ACTIONS(3812),
    [anon_sym___attribute] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_COLON_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3814),
    [anon_sym___declspec] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(3812),
    [anon_sym_signed] = ACTIONS(3812),
    [anon_sym_unsigned] = ACTIONS(3812),
    [anon_sym_long] = ACTIONS(3812),
    [anon_sym_short] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_register] = ACTIONS(3812),
    [anon_sym_inline] = ACTIONS(3812),
    [anon_sym___inline] = ACTIONS(3812),
    [anon_sym___inline__] = ACTIONS(3812),
    [anon_sym___forceinline] = ACTIONS(3812),
    [anon_sym_thread_local] = ACTIONS(3812),
    [anon_sym___thread] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_constexpr] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_restrict] = ACTIONS(3812),
    [anon_sym___restrict__] = ACTIONS(3812),
    [anon_sym__Atomic] = ACTIONS(3812),
    [anon_sym__Noreturn] = ACTIONS(3812),
    [anon_sym_noreturn] = ACTIONS(3812),
    [anon_sym__Nonnull] = ACTIONS(3812),
    [anon_sym_mutable] = ACTIONS(3812),
    [anon_sym_constinit] = ACTIONS(3812),
    [anon_sym_consteval] = ACTIONS(3812),
    [anon_sym_alignas] = ACTIONS(3812),
    [anon_sym__Alignas] = ACTIONS(3812),
    [sym_primitive_type] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_union] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_This] = ACTIONS(3812),
    [anon_sym_decltype] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_typename] = ACTIONS(3812),
    [anon_sym_private] = ACTIONS(3812),
    [anon_sym_template] = ACTIONS(3812),
    [anon_sym_operator] = ACTIONS(3812),
    [anon_sym_friend] = ACTIONS(3812),
    [anon_sym_public] = ACTIONS(3812),
    [anon_sym_protected] = ACTIONS(3812),
    [anon_sym_static_assert] = ACTIONS(3812),
    [anon_sym_precise] = ACTIONS(3812),
    [anon_sym_shared] = ACTIONS(3812),
    [anon_sym_groupshared] = ACTIONS(3812),
    [anon_sym_uniform] = ACTIONS(3812),
    [anon_sym_row_major] = ACTIONS(3812),
    [anon_sym_column_major] = ACTIONS(3812),
    [anon_sym_globallycoherent] = ACTIONS(3812),
    [anon_sym_centroid] = ACTIONS(3812),
    [anon_sym_noperspective] = ACTIONS(3812),
    [anon_sym_nointerpolation] = ACTIONS(3812),
    [anon_sym_sample] = ACTIONS(3812),
    [anon_sym_linear] = ACTIONS(3812),
    [anon_sym_snorm] = ACTIONS(3812),
    [anon_sym_unorm] = ACTIONS(3812),
    [anon_sym_point] = ACTIONS(3812),
    [anon_sym_line] = ACTIONS(3812),
    [anon_sym_triangleadj] = ACTIONS(3812),
    [anon_sym_lineadj] = ACTIONS(3812),
    [anon_sym_triangle] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_extension] = ACTIONS(3812),
    [anon_sym___init] = ACTIONS(3812),
    [anon_sym___subscript] = ACTIONS(3812),
    [anon_sym_property] = ACTIONS(3812),
    [anon_sym_associatedtype] = ACTIONS(3812),
  },
  [2265] = {
    [sym_identifier] = ACTIONS(3857),
    [aux_sym_preproc_def_token1] = ACTIONS(3857),
    [aux_sym_preproc_if_token1] = ACTIONS(3857),
    [aux_sym_preproc_if_token2] = ACTIONS(3857),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3857),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3857),
    [sym_preproc_directive] = ACTIONS(3857),
    [anon_sym_LPAREN2] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3859),
    [anon_sym_STAR] = ACTIONS(3859),
    [anon_sym_AMP_AMP] = ACTIONS(3859),
    [anon_sym_AMP] = ACTIONS(3857),
    [anon_sym_SEMI] = ACTIONS(3859),
    [anon_sym___extension__] = ACTIONS(3857),
    [anon_sym_typedef] = ACTIONS(3857),
    [anon_sym_in] = ACTIONS(3857),
    [anon_sym_out] = ACTIONS(3857),
    [anon_sym_inout] = ACTIONS(3857),
    [anon_sym_virtual] = ACTIONS(3857),
    [anon_sym_extern] = ACTIONS(3857),
    [anon_sym___attribute__] = ACTIONS(3857),
    [anon_sym___attribute] = ACTIONS(3857),
    [anon_sym_using] = ACTIONS(3857),
    [anon_sym_COLON_COLON] = ACTIONS(3859),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3859),
    [anon_sym___declspec] = ACTIONS(3857),
    [anon_sym___based] = ACTIONS(3857),
    [anon_sym_signed] = ACTIONS(3857),
    [anon_sym_unsigned] = ACTIONS(3857),
    [anon_sym_long] = ACTIONS(3857),
    [anon_sym_short] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(3857),
    [anon_sym_static] = ACTIONS(3857),
    [anon_sym_register] = ACTIONS(3857),
    [anon_sym_inline] = ACTIONS(3857),
    [anon_sym___inline] = ACTIONS(3857),
    [anon_sym___inline__] = ACTIONS(3857),
    [anon_sym___forceinline] = ACTIONS(3857),
    [anon_sym_thread_local] = ACTIONS(3857),
    [anon_sym___thread] = ACTIONS(3857),
    [anon_sym_const] = ACTIONS(3857),
    [anon_sym_constexpr] = ACTIONS(3857),
    [anon_sym_volatile] = ACTIONS(3857),
    [anon_sym_restrict] = ACTIONS(3857),
    [anon_sym___restrict__] = ACTIONS(3857),
    [anon_sym__Atomic] = ACTIONS(3857),
    [anon_sym__Noreturn] = ACTIONS(3857),
    [anon_sym_noreturn] = ACTIONS(3857),
    [anon_sym__Nonnull] = ACTIONS(3857),
    [anon_sym_mutable] = ACTIONS(3857),
    [anon_sym_constinit] = ACTIONS(3857),
    [anon_sym_consteval] = ACTIONS(3857),
    [anon_sym_alignas] = ACTIONS(3857),
    [anon_sym__Alignas] = ACTIONS(3857),
    [sym_primitive_type] = ACTIONS(3857),
    [anon_sym_enum] = ACTIONS(3857),
    [anon_sym_class] = ACTIONS(3857),
    [anon_sym_struct] = ACTIONS(3857),
    [anon_sym_union] = ACTIONS(3857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3857),
    [anon_sym_let] = ACTIONS(3857),
    [anon_sym_This] = ACTIONS(3857),
    [anon_sym_decltype] = ACTIONS(3857),
    [anon_sym_explicit] = ACTIONS(3857),
    [anon_sym_typename] = ACTIONS(3857),
    [anon_sym_private] = ACTIONS(3857),
    [anon_sym_template] = ACTIONS(3857),
    [anon_sym_operator] = ACTIONS(3857),
    [anon_sym_friend] = ACTIONS(3857),
    [anon_sym_public] = ACTIONS(3857),
    [anon_sym_protected] = ACTIONS(3857),
    [anon_sym_static_assert] = ACTIONS(3857),
    [anon_sym_precise] = ACTIONS(3857),
    [anon_sym_shared] = ACTIONS(3857),
    [anon_sym_groupshared] = ACTIONS(3857),
    [anon_sym_uniform] = ACTIONS(3857),
    [anon_sym_row_major] = ACTIONS(3857),
    [anon_sym_column_major] = ACTIONS(3857),
    [anon_sym_globallycoherent] = ACTIONS(3857),
    [anon_sym_centroid] = ACTIONS(3857),
    [anon_sym_noperspective] = ACTIONS(3857),
    [anon_sym_nointerpolation] = ACTIONS(3857),
    [anon_sym_sample] = ACTIONS(3857),
    [anon_sym_linear] = ACTIONS(3857),
    [anon_sym_snorm] = ACTIONS(3857),
    [anon_sym_unorm] = ACTIONS(3857),
    [anon_sym_point] = ACTIONS(3857),
    [anon_sym_line] = ACTIONS(3857),
    [anon_sym_triangleadj] = ACTIONS(3857),
    [anon_sym_lineadj] = ACTIONS(3857),
    [anon_sym_triangle] = ACTIONS(3857),
    [anon_sym_interface] = ACTIONS(3857),
    [anon_sym_extension] = ACTIONS(3857),
    [anon_sym___init] = ACTIONS(3857),
    [anon_sym___subscript] = ACTIONS(3857),
    [anon_sym_property] = ACTIONS(3857),
    [anon_sym_associatedtype] = ACTIONS(3857),
  },
  [2266] = {
    [sym_identifier] = ACTIONS(3861),
    [aux_sym_preproc_def_token1] = ACTIONS(3861),
    [aux_sym_preproc_if_token1] = ACTIONS(3861),
    [aux_sym_preproc_if_token2] = ACTIONS(3861),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3861),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3861),
    [sym_preproc_directive] = ACTIONS(3861),
    [anon_sym_LPAREN2] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3863),
    [anon_sym_STAR] = ACTIONS(3863),
    [anon_sym_AMP_AMP] = ACTIONS(3863),
    [anon_sym_AMP] = ACTIONS(3861),
    [anon_sym_SEMI] = ACTIONS(3863),
    [anon_sym___extension__] = ACTIONS(3861),
    [anon_sym_typedef] = ACTIONS(3861),
    [anon_sym_in] = ACTIONS(3861),
    [anon_sym_out] = ACTIONS(3861),
    [anon_sym_inout] = ACTIONS(3861),
    [anon_sym_virtual] = ACTIONS(3861),
    [anon_sym_extern] = ACTIONS(3861),
    [anon_sym___attribute__] = ACTIONS(3861),
    [anon_sym___attribute] = ACTIONS(3861),
    [anon_sym_using] = ACTIONS(3861),
    [anon_sym_COLON_COLON] = ACTIONS(3863),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3863),
    [anon_sym___declspec] = ACTIONS(3861),
    [anon_sym___based] = ACTIONS(3861),
    [anon_sym_signed] = ACTIONS(3861),
    [anon_sym_unsigned] = ACTIONS(3861),
    [anon_sym_long] = ACTIONS(3861),
    [anon_sym_short] = ACTIONS(3861),
    [anon_sym_LBRACK] = ACTIONS(3861),
    [anon_sym_static] = ACTIONS(3861),
    [anon_sym_register] = ACTIONS(3861),
    [anon_sym_inline] = ACTIONS(3861),
    [anon_sym___inline] = ACTIONS(3861),
    [anon_sym___inline__] = ACTIONS(3861),
    [anon_sym___forceinline] = ACTIONS(3861),
    [anon_sym_thread_local] = ACTIONS(3861),
    [anon_sym___thread] = ACTIONS(3861),
    [anon_sym_const] = ACTIONS(3861),
    [anon_sym_constexpr] = ACTIONS(3861),
    [anon_sym_volatile] = ACTIONS(3861),
    [anon_sym_restrict] = ACTIONS(3861),
    [anon_sym___restrict__] = ACTIONS(3861),
    [anon_sym__Atomic] = ACTIONS(3861),
    [anon_sym__Noreturn] = ACTIONS(3861),
    [anon_sym_noreturn] = ACTIONS(3861),
    [anon_sym__Nonnull] = ACTIONS(3861),
    [anon_sym_mutable] = ACTIONS(3861),
    [anon_sym_constinit] = ACTIONS(3861),
    [anon_sym_consteval] = ACTIONS(3861),
    [anon_sym_alignas] = ACTIONS(3861),
    [anon_sym__Alignas] = ACTIONS(3861),
    [sym_primitive_type] = ACTIONS(3861),
    [anon_sym_enum] = ACTIONS(3861),
    [anon_sym_class] = ACTIONS(3861),
    [anon_sym_struct] = ACTIONS(3861),
    [anon_sym_union] = ACTIONS(3861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3861),
    [anon_sym_let] = ACTIONS(3861),
    [anon_sym_This] = ACTIONS(3861),
    [anon_sym_decltype] = ACTIONS(3861),
    [anon_sym_explicit] = ACTIONS(3861),
    [anon_sym_typename] = ACTIONS(3861),
    [anon_sym_private] = ACTIONS(3861),
    [anon_sym_template] = ACTIONS(3861),
    [anon_sym_operator] = ACTIONS(3861),
    [anon_sym_friend] = ACTIONS(3861),
    [anon_sym_public] = ACTIONS(3861),
    [anon_sym_protected] = ACTIONS(3861),
    [anon_sym_static_assert] = ACTIONS(3861),
    [anon_sym_precise] = ACTIONS(3861),
    [anon_sym_shared] = ACTIONS(3861),
    [anon_sym_groupshared] = ACTIONS(3861),
    [anon_sym_uniform] = ACTIONS(3861),
    [anon_sym_row_major] = ACTIONS(3861),
    [anon_sym_column_major] = ACTIONS(3861),
    [anon_sym_globallycoherent] = ACTIONS(3861),
    [anon_sym_centroid] = ACTIONS(3861),
    [anon_sym_noperspective] = ACTIONS(3861),
    [anon_sym_nointerpolation] = ACTIONS(3861),
    [anon_sym_sample] = ACTIONS(3861),
    [anon_sym_linear] = ACTIONS(3861),
    [anon_sym_snorm] = ACTIONS(3861),
    [anon_sym_unorm] = ACTIONS(3861),
    [anon_sym_point] = ACTIONS(3861),
    [anon_sym_line] = ACTIONS(3861),
    [anon_sym_triangleadj] = ACTIONS(3861),
    [anon_sym_lineadj] = ACTIONS(3861),
    [anon_sym_triangle] = ACTIONS(3861),
    [anon_sym_interface] = ACTIONS(3861),
    [anon_sym_extension] = ACTIONS(3861),
    [anon_sym___init] = ACTIONS(3861),
    [anon_sym___subscript] = ACTIONS(3861),
    [anon_sym_property] = ACTIONS(3861),
    [anon_sym_associatedtype] = ACTIONS(3861),
  },
  [2267] = {
    [sym_identifier] = ACTIONS(3669),
    [aux_sym_preproc_def_token1] = ACTIONS(3669),
    [aux_sym_preproc_if_token1] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3669),
    [sym_preproc_directive] = ACTIONS(3669),
    [anon_sym_LPAREN2] = ACTIONS(3671),
    [anon_sym_TILDE] = ACTIONS(3671),
    [anon_sym_STAR] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3671),
    [anon_sym_AMP] = ACTIONS(3669),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym___extension__] = ACTIONS(3669),
    [anon_sym_typedef] = ACTIONS(3669),
    [anon_sym_in] = ACTIONS(3669),
    [anon_sym_out] = ACTIONS(3669),
    [anon_sym_inout] = ACTIONS(3669),
    [anon_sym_virtual] = ACTIONS(3669),
    [anon_sym_extern] = ACTIONS(3669),
    [anon_sym___attribute__] = ACTIONS(3669),
    [anon_sym___attribute] = ACTIONS(3669),
    [anon_sym_using] = ACTIONS(3669),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3671),
    [anon_sym___declspec] = ACTIONS(3669),
    [anon_sym___based] = ACTIONS(3669),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [anon_sym_signed] = ACTIONS(3669),
    [anon_sym_unsigned] = ACTIONS(3669),
    [anon_sym_long] = ACTIONS(3669),
    [anon_sym_short] = ACTIONS(3669),
    [anon_sym_LBRACK] = ACTIONS(3669),
    [anon_sym_static] = ACTIONS(3669),
    [anon_sym_register] = ACTIONS(3669),
    [anon_sym_inline] = ACTIONS(3669),
    [anon_sym___inline] = ACTIONS(3669),
    [anon_sym___inline__] = ACTIONS(3669),
    [anon_sym___forceinline] = ACTIONS(3669),
    [anon_sym_thread_local] = ACTIONS(3669),
    [anon_sym___thread] = ACTIONS(3669),
    [anon_sym_const] = ACTIONS(3669),
    [anon_sym_constexpr] = ACTIONS(3669),
    [anon_sym_volatile] = ACTIONS(3669),
    [anon_sym_restrict] = ACTIONS(3669),
    [anon_sym___restrict__] = ACTIONS(3669),
    [anon_sym__Atomic] = ACTIONS(3669),
    [anon_sym__Noreturn] = ACTIONS(3669),
    [anon_sym_noreturn] = ACTIONS(3669),
    [anon_sym__Nonnull] = ACTIONS(3669),
    [anon_sym_mutable] = ACTIONS(3669),
    [anon_sym_constinit] = ACTIONS(3669),
    [anon_sym_consteval] = ACTIONS(3669),
    [anon_sym_alignas] = ACTIONS(3669),
    [anon_sym__Alignas] = ACTIONS(3669),
    [sym_primitive_type] = ACTIONS(3669),
    [anon_sym_enum] = ACTIONS(3669),
    [anon_sym_class] = ACTIONS(3669),
    [anon_sym_struct] = ACTIONS(3669),
    [anon_sym_union] = ACTIONS(3669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3669),
    [anon_sym_let] = ACTIONS(3669),
    [anon_sym_This] = ACTIONS(3669),
    [anon_sym_decltype] = ACTIONS(3669),
    [anon_sym_explicit] = ACTIONS(3669),
    [anon_sym_typename] = ACTIONS(3669),
    [anon_sym_private] = ACTIONS(3669),
    [anon_sym_template] = ACTIONS(3669),
    [anon_sym_operator] = ACTIONS(3669),
    [anon_sym_friend] = ACTIONS(3669),
    [anon_sym_public] = ACTIONS(3669),
    [anon_sym_protected] = ACTIONS(3669),
    [anon_sym_static_assert] = ACTIONS(3669),
    [anon_sym_precise] = ACTIONS(3669),
    [anon_sym_shared] = ACTIONS(3669),
    [anon_sym_groupshared] = ACTIONS(3669),
    [anon_sym_uniform] = ACTIONS(3669),
    [anon_sym_row_major] = ACTIONS(3669),
    [anon_sym_column_major] = ACTIONS(3669),
    [anon_sym_globallycoherent] = ACTIONS(3669),
    [anon_sym_centroid] = ACTIONS(3669),
    [anon_sym_noperspective] = ACTIONS(3669),
    [anon_sym_nointerpolation] = ACTIONS(3669),
    [anon_sym_sample] = ACTIONS(3669),
    [anon_sym_linear] = ACTIONS(3669),
    [anon_sym_snorm] = ACTIONS(3669),
    [anon_sym_unorm] = ACTIONS(3669),
    [anon_sym_point] = ACTIONS(3669),
    [anon_sym_line] = ACTIONS(3669),
    [anon_sym_triangleadj] = ACTIONS(3669),
    [anon_sym_lineadj] = ACTIONS(3669),
    [anon_sym_triangle] = ACTIONS(3669),
    [anon_sym_interface] = ACTIONS(3669),
    [anon_sym_extension] = ACTIONS(3669),
    [anon_sym___init] = ACTIONS(3669),
    [anon_sym___subscript] = ACTIONS(3669),
    [anon_sym_property] = ACTIONS(3669),
    [anon_sym_associatedtype] = ACTIONS(3669),
  },
  [2268] = {
    [sym_identifier] = ACTIONS(3796),
    [aux_sym_preproc_def_token1] = ACTIONS(3796),
    [aux_sym_preproc_if_token1] = ACTIONS(3796),
    [aux_sym_preproc_if_token2] = ACTIONS(3796),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3796),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3796),
    [sym_preproc_directive] = ACTIONS(3796),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_TILDE] = ACTIONS(3798),
    [anon_sym_STAR] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_AMP] = ACTIONS(3796),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym___extension__] = ACTIONS(3796),
    [anon_sym_typedef] = ACTIONS(3796),
    [anon_sym_in] = ACTIONS(3796),
    [anon_sym_out] = ACTIONS(3796),
    [anon_sym_inout] = ACTIONS(3796),
    [anon_sym_virtual] = ACTIONS(3796),
    [anon_sym_extern] = ACTIONS(3796),
    [anon_sym___attribute__] = ACTIONS(3796),
    [anon_sym___attribute] = ACTIONS(3796),
    [anon_sym_using] = ACTIONS(3796),
    [anon_sym_COLON_COLON] = ACTIONS(3798),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3798),
    [anon_sym___declspec] = ACTIONS(3796),
    [anon_sym___based] = ACTIONS(3796),
    [anon_sym_signed] = ACTIONS(3796),
    [anon_sym_unsigned] = ACTIONS(3796),
    [anon_sym_long] = ACTIONS(3796),
    [anon_sym_short] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3796),
    [anon_sym_static] = ACTIONS(3796),
    [anon_sym_register] = ACTIONS(3796),
    [anon_sym_inline] = ACTIONS(3796),
    [anon_sym___inline] = ACTIONS(3796),
    [anon_sym___inline__] = ACTIONS(3796),
    [anon_sym___forceinline] = ACTIONS(3796),
    [anon_sym_thread_local] = ACTIONS(3796),
    [anon_sym___thread] = ACTIONS(3796),
    [anon_sym_const] = ACTIONS(3796),
    [anon_sym_constexpr] = ACTIONS(3796),
    [anon_sym_volatile] = ACTIONS(3796),
    [anon_sym_restrict] = ACTIONS(3796),
    [anon_sym___restrict__] = ACTIONS(3796),
    [anon_sym__Atomic] = ACTIONS(3796),
    [anon_sym__Noreturn] = ACTIONS(3796),
    [anon_sym_noreturn] = ACTIONS(3796),
    [anon_sym__Nonnull] = ACTIONS(3796),
    [anon_sym_mutable] = ACTIONS(3796),
    [anon_sym_constinit] = ACTIONS(3796),
    [anon_sym_consteval] = ACTIONS(3796),
    [anon_sym_alignas] = ACTIONS(3796),
    [anon_sym__Alignas] = ACTIONS(3796),
    [sym_primitive_type] = ACTIONS(3796),
    [anon_sym_enum] = ACTIONS(3796),
    [anon_sym_class] = ACTIONS(3796),
    [anon_sym_struct] = ACTIONS(3796),
    [anon_sym_union] = ACTIONS(3796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3796),
    [anon_sym_let] = ACTIONS(3796),
    [anon_sym_This] = ACTIONS(3796),
    [anon_sym_decltype] = ACTIONS(3796),
    [anon_sym_explicit] = ACTIONS(3796),
    [anon_sym_typename] = ACTIONS(3796),
    [anon_sym_private] = ACTIONS(3796),
    [anon_sym_template] = ACTIONS(3796),
    [anon_sym_operator] = ACTIONS(3796),
    [anon_sym_friend] = ACTIONS(3796),
    [anon_sym_public] = ACTIONS(3796),
    [anon_sym_protected] = ACTIONS(3796),
    [anon_sym_static_assert] = ACTIONS(3796),
    [anon_sym_precise] = ACTIONS(3796),
    [anon_sym_shared] = ACTIONS(3796),
    [anon_sym_groupshared] = ACTIONS(3796),
    [anon_sym_uniform] = ACTIONS(3796),
    [anon_sym_row_major] = ACTIONS(3796),
    [anon_sym_column_major] = ACTIONS(3796),
    [anon_sym_globallycoherent] = ACTIONS(3796),
    [anon_sym_centroid] = ACTIONS(3796),
    [anon_sym_noperspective] = ACTIONS(3796),
    [anon_sym_nointerpolation] = ACTIONS(3796),
    [anon_sym_sample] = ACTIONS(3796),
    [anon_sym_linear] = ACTIONS(3796),
    [anon_sym_snorm] = ACTIONS(3796),
    [anon_sym_unorm] = ACTIONS(3796),
    [anon_sym_point] = ACTIONS(3796),
    [anon_sym_line] = ACTIONS(3796),
    [anon_sym_triangleadj] = ACTIONS(3796),
    [anon_sym_lineadj] = ACTIONS(3796),
    [anon_sym_triangle] = ACTIONS(3796),
    [anon_sym_interface] = ACTIONS(3796),
    [anon_sym_extension] = ACTIONS(3796),
    [anon_sym___init] = ACTIONS(3796),
    [anon_sym___subscript] = ACTIONS(3796),
    [anon_sym_property] = ACTIONS(3796),
    [anon_sym_associatedtype] = ACTIONS(3796),
  },
  [2269] = {
    [sym_identifier] = ACTIONS(3800),
    [aux_sym_preproc_def_token1] = ACTIONS(3800),
    [aux_sym_preproc_if_token1] = ACTIONS(3800),
    [aux_sym_preproc_if_token2] = ACTIONS(3800),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3800),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3800),
    [sym_preproc_directive] = ACTIONS(3800),
    [anon_sym_LPAREN2] = ACTIONS(3802),
    [anon_sym_TILDE] = ACTIONS(3802),
    [anon_sym_STAR] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_SEMI] = ACTIONS(3802),
    [anon_sym___extension__] = ACTIONS(3800),
    [anon_sym_typedef] = ACTIONS(3800),
    [anon_sym_in] = ACTIONS(3800),
    [anon_sym_out] = ACTIONS(3800),
    [anon_sym_inout] = ACTIONS(3800),
    [anon_sym_virtual] = ACTIONS(3800),
    [anon_sym_extern] = ACTIONS(3800),
    [anon_sym___attribute__] = ACTIONS(3800),
    [anon_sym___attribute] = ACTIONS(3800),
    [anon_sym_using] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3802),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3802),
    [anon_sym___declspec] = ACTIONS(3800),
    [anon_sym___based] = ACTIONS(3800),
    [anon_sym_signed] = ACTIONS(3800),
    [anon_sym_unsigned] = ACTIONS(3800),
    [anon_sym_long] = ACTIONS(3800),
    [anon_sym_short] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3800),
    [anon_sym_static] = ACTIONS(3800),
    [anon_sym_register] = ACTIONS(3800),
    [anon_sym_inline] = ACTIONS(3800),
    [anon_sym___inline] = ACTIONS(3800),
    [anon_sym___inline__] = ACTIONS(3800),
    [anon_sym___forceinline] = ACTIONS(3800),
    [anon_sym_thread_local] = ACTIONS(3800),
    [anon_sym___thread] = ACTIONS(3800),
    [anon_sym_const] = ACTIONS(3800),
    [anon_sym_constexpr] = ACTIONS(3800),
    [anon_sym_volatile] = ACTIONS(3800),
    [anon_sym_restrict] = ACTIONS(3800),
    [anon_sym___restrict__] = ACTIONS(3800),
    [anon_sym__Atomic] = ACTIONS(3800),
    [anon_sym__Noreturn] = ACTIONS(3800),
    [anon_sym_noreturn] = ACTIONS(3800),
    [anon_sym__Nonnull] = ACTIONS(3800),
    [anon_sym_mutable] = ACTIONS(3800),
    [anon_sym_constinit] = ACTIONS(3800),
    [anon_sym_consteval] = ACTIONS(3800),
    [anon_sym_alignas] = ACTIONS(3800),
    [anon_sym__Alignas] = ACTIONS(3800),
    [sym_primitive_type] = ACTIONS(3800),
    [anon_sym_enum] = ACTIONS(3800),
    [anon_sym_class] = ACTIONS(3800),
    [anon_sym_struct] = ACTIONS(3800),
    [anon_sym_union] = ACTIONS(3800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_This] = ACTIONS(3800),
    [anon_sym_decltype] = ACTIONS(3800),
    [anon_sym_explicit] = ACTIONS(3800),
    [anon_sym_typename] = ACTIONS(3800),
    [anon_sym_private] = ACTIONS(3800),
    [anon_sym_template] = ACTIONS(3800),
    [anon_sym_operator] = ACTIONS(3800),
    [anon_sym_friend] = ACTIONS(3800),
    [anon_sym_public] = ACTIONS(3800),
    [anon_sym_protected] = ACTIONS(3800),
    [anon_sym_static_assert] = ACTIONS(3800),
    [anon_sym_precise] = ACTIONS(3800),
    [anon_sym_shared] = ACTIONS(3800),
    [anon_sym_groupshared] = ACTIONS(3800),
    [anon_sym_uniform] = ACTIONS(3800),
    [anon_sym_row_major] = ACTIONS(3800),
    [anon_sym_column_major] = ACTIONS(3800),
    [anon_sym_globallycoherent] = ACTIONS(3800),
    [anon_sym_centroid] = ACTIONS(3800),
    [anon_sym_noperspective] = ACTIONS(3800),
    [anon_sym_nointerpolation] = ACTIONS(3800),
    [anon_sym_sample] = ACTIONS(3800),
    [anon_sym_linear] = ACTIONS(3800),
    [anon_sym_snorm] = ACTIONS(3800),
    [anon_sym_unorm] = ACTIONS(3800),
    [anon_sym_point] = ACTIONS(3800),
    [anon_sym_line] = ACTIONS(3800),
    [anon_sym_triangleadj] = ACTIONS(3800),
    [anon_sym_lineadj] = ACTIONS(3800),
    [anon_sym_triangle] = ACTIONS(3800),
    [anon_sym_interface] = ACTIONS(3800),
    [anon_sym_extension] = ACTIONS(3800),
    [anon_sym___init] = ACTIONS(3800),
    [anon_sym___subscript] = ACTIONS(3800),
    [anon_sym_property] = ACTIONS(3800),
    [anon_sym_associatedtype] = ACTIONS(3800),
  },
  [2270] = {
    [sym_identifier] = ACTIONS(3931),
    [aux_sym_preproc_def_token1] = ACTIONS(3931),
    [aux_sym_preproc_if_token1] = ACTIONS(3931),
    [aux_sym_preproc_if_token2] = ACTIONS(3931),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3931),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3931),
    [sym_preproc_directive] = ACTIONS(3931),
    [anon_sym_LPAREN2] = ACTIONS(3933),
    [anon_sym_TILDE] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3931),
    [anon_sym_SEMI] = ACTIONS(3933),
    [anon_sym___extension__] = ACTIONS(3931),
    [anon_sym_typedef] = ACTIONS(3931),
    [anon_sym_in] = ACTIONS(3931),
    [anon_sym_out] = ACTIONS(3931),
    [anon_sym_inout] = ACTIONS(3931),
    [anon_sym_virtual] = ACTIONS(3931),
    [anon_sym_extern] = ACTIONS(3931),
    [anon_sym___attribute__] = ACTIONS(3931),
    [anon_sym___attribute] = ACTIONS(3931),
    [anon_sym_using] = ACTIONS(3931),
    [anon_sym_COLON_COLON] = ACTIONS(3933),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3933),
    [anon_sym___declspec] = ACTIONS(3931),
    [anon_sym___based] = ACTIONS(3931),
    [anon_sym_signed] = ACTIONS(3931),
    [anon_sym_unsigned] = ACTIONS(3931),
    [anon_sym_long] = ACTIONS(3931),
    [anon_sym_short] = ACTIONS(3931),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_static] = ACTIONS(3931),
    [anon_sym_register] = ACTIONS(3931),
    [anon_sym_inline] = ACTIONS(3931),
    [anon_sym___inline] = ACTIONS(3931),
    [anon_sym___inline__] = ACTIONS(3931),
    [anon_sym___forceinline] = ACTIONS(3931),
    [anon_sym_thread_local] = ACTIONS(3931),
    [anon_sym___thread] = ACTIONS(3931),
    [anon_sym_const] = ACTIONS(3931),
    [anon_sym_constexpr] = ACTIONS(3931),
    [anon_sym_volatile] = ACTIONS(3931),
    [anon_sym_restrict] = ACTIONS(3931),
    [anon_sym___restrict__] = ACTIONS(3931),
    [anon_sym__Atomic] = ACTIONS(3931),
    [anon_sym__Noreturn] = ACTIONS(3931),
    [anon_sym_noreturn] = ACTIONS(3931),
    [anon_sym__Nonnull] = ACTIONS(3931),
    [anon_sym_mutable] = ACTIONS(3931),
    [anon_sym_constinit] = ACTIONS(3931),
    [anon_sym_consteval] = ACTIONS(3931),
    [anon_sym_alignas] = ACTIONS(3931),
    [anon_sym__Alignas] = ACTIONS(3931),
    [sym_primitive_type] = ACTIONS(3931),
    [anon_sym_enum] = ACTIONS(3931),
    [anon_sym_class] = ACTIONS(3931),
    [anon_sym_struct] = ACTIONS(3931),
    [anon_sym_union] = ACTIONS(3931),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3931),
    [anon_sym_let] = ACTIONS(3931),
    [anon_sym_This] = ACTIONS(3931),
    [anon_sym_decltype] = ACTIONS(3931),
    [anon_sym_explicit] = ACTIONS(3931),
    [anon_sym_typename] = ACTIONS(3931),
    [anon_sym_private] = ACTIONS(3931),
    [anon_sym_template] = ACTIONS(3931),
    [anon_sym_operator] = ACTIONS(3931),
    [anon_sym_friend] = ACTIONS(3931),
    [anon_sym_public] = ACTIONS(3931),
    [anon_sym_protected] = ACTIONS(3931),
    [anon_sym_static_assert] = ACTIONS(3931),
    [anon_sym_precise] = ACTIONS(3931),
    [anon_sym_shared] = ACTIONS(3931),
    [anon_sym_groupshared] = ACTIONS(3931),
    [anon_sym_uniform] = ACTIONS(3931),
    [anon_sym_row_major] = ACTIONS(3931),
    [anon_sym_column_major] = ACTIONS(3931),
    [anon_sym_globallycoherent] = ACTIONS(3931),
    [anon_sym_centroid] = ACTIONS(3931),
    [anon_sym_noperspective] = ACTIONS(3931),
    [anon_sym_nointerpolation] = ACTIONS(3931),
    [anon_sym_sample] = ACTIONS(3931),
    [anon_sym_linear] = ACTIONS(3931),
    [anon_sym_snorm] = ACTIONS(3931),
    [anon_sym_unorm] = ACTIONS(3931),
    [anon_sym_point] = ACTIONS(3931),
    [anon_sym_line] = ACTIONS(3931),
    [anon_sym_triangleadj] = ACTIONS(3931),
    [anon_sym_lineadj] = ACTIONS(3931),
    [anon_sym_triangle] = ACTIONS(3931),
    [anon_sym_interface] = ACTIONS(3931),
    [anon_sym_extension] = ACTIONS(3931),
    [anon_sym___init] = ACTIONS(3931),
    [anon_sym___subscript] = ACTIONS(3931),
    [anon_sym_property] = ACTIONS(3931),
    [anon_sym_associatedtype] = ACTIONS(3931),
  },
  [2271] = {
    [sym_identifier] = ACTIONS(3935),
    [aux_sym_preproc_def_token1] = ACTIONS(3935),
    [aux_sym_preproc_if_token1] = ACTIONS(3935),
    [aux_sym_preproc_if_token2] = ACTIONS(3935),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3935),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3935),
    [sym_preproc_directive] = ACTIONS(3935),
    [anon_sym_LPAREN2] = ACTIONS(3937),
    [anon_sym_TILDE] = ACTIONS(3937),
    [anon_sym_STAR] = ACTIONS(3937),
    [anon_sym_AMP_AMP] = ACTIONS(3937),
    [anon_sym_AMP] = ACTIONS(3935),
    [anon_sym_SEMI] = ACTIONS(3937),
    [anon_sym___extension__] = ACTIONS(3935),
    [anon_sym_typedef] = ACTIONS(3935),
    [anon_sym_in] = ACTIONS(3935),
    [anon_sym_out] = ACTIONS(3935),
    [anon_sym_inout] = ACTIONS(3935),
    [anon_sym_virtual] = ACTIONS(3935),
    [anon_sym_extern] = ACTIONS(3935),
    [anon_sym___attribute__] = ACTIONS(3935),
    [anon_sym___attribute] = ACTIONS(3935),
    [anon_sym_using] = ACTIONS(3935),
    [anon_sym_COLON_COLON] = ACTIONS(3937),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3937),
    [anon_sym___declspec] = ACTIONS(3935),
    [anon_sym___based] = ACTIONS(3935),
    [anon_sym_signed] = ACTIONS(3935),
    [anon_sym_unsigned] = ACTIONS(3935),
    [anon_sym_long] = ACTIONS(3935),
    [anon_sym_short] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3935),
    [anon_sym_static] = ACTIONS(3935),
    [anon_sym_register] = ACTIONS(3935),
    [anon_sym_inline] = ACTIONS(3935),
    [anon_sym___inline] = ACTIONS(3935),
    [anon_sym___inline__] = ACTIONS(3935),
    [anon_sym___forceinline] = ACTIONS(3935),
    [anon_sym_thread_local] = ACTIONS(3935),
    [anon_sym___thread] = ACTIONS(3935),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_constexpr] = ACTIONS(3935),
    [anon_sym_volatile] = ACTIONS(3935),
    [anon_sym_restrict] = ACTIONS(3935),
    [anon_sym___restrict__] = ACTIONS(3935),
    [anon_sym__Atomic] = ACTIONS(3935),
    [anon_sym__Noreturn] = ACTIONS(3935),
    [anon_sym_noreturn] = ACTIONS(3935),
    [anon_sym__Nonnull] = ACTIONS(3935),
    [anon_sym_mutable] = ACTIONS(3935),
    [anon_sym_constinit] = ACTIONS(3935),
    [anon_sym_consteval] = ACTIONS(3935),
    [anon_sym_alignas] = ACTIONS(3935),
    [anon_sym__Alignas] = ACTIONS(3935),
    [sym_primitive_type] = ACTIONS(3935),
    [anon_sym_enum] = ACTIONS(3935),
    [anon_sym_class] = ACTIONS(3935),
    [anon_sym_struct] = ACTIONS(3935),
    [anon_sym_union] = ACTIONS(3935),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3935),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_This] = ACTIONS(3935),
    [anon_sym_decltype] = ACTIONS(3935),
    [anon_sym_explicit] = ACTIONS(3935),
    [anon_sym_typename] = ACTIONS(3935),
    [anon_sym_private] = ACTIONS(3935),
    [anon_sym_template] = ACTIONS(3935),
    [anon_sym_operator] = ACTIONS(3935),
    [anon_sym_friend] = ACTIONS(3935),
    [anon_sym_public] = ACTIONS(3935),
    [anon_sym_protected] = ACTIONS(3935),
    [anon_sym_static_assert] = ACTIONS(3935),
    [anon_sym_precise] = ACTIONS(3935),
    [anon_sym_shared] = ACTIONS(3935),
    [anon_sym_groupshared] = ACTIONS(3935),
    [anon_sym_uniform] = ACTIONS(3935),
    [anon_sym_row_major] = ACTIONS(3935),
    [anon_sym_column_major] = ACTIONS(3935),
    [anon_sym_globallycoherent] = ACTIONS(3935),
    [anon_sym_centroid] = ACTIONS(3935),
    [anon_sym_noperspective] = ACTIONS(3935),
    [anon_sym_nointerpolation] = ACTIONS(3935),
    [anon_sym_sample] = ACTIONS(3935),
    [anon_sym_linear] = ACTIONS(3935),
    [anon_sym_snorm] = ACTIONS(3935),
    [anon_sym_unorm] = ACTIONS(3935),
    [anon_sym_point] = ACTIONS(3935),
    [anon_sym_line] = ACTIONS(3935),
    [anon_sym_triangleadj] = ACTIONS(3935),
    [anon_sym_lineadj] = ACTIONS(3935),
    [anon_sym_triangle] = ACTIONS(3935),
    [anon_sym_interface] = ACTIONS(3935),
    [anon_sym_extension] = ACTIONS(3935),
    [anon_sym___init] = ACTIONS(3935),
    [anon_sym___subscript] = ACTIONS(3935),
    [anon_sym_property] = ACTIONS(3935),
    [anon_sym_associatedtype] = ACTIONS(3935),
  },
  [2272] = {
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token2] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_private] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_friend] = ACTIONS(3942),
    [anon_sym_public] = ACTIONS(3942),
    [anon_sym_protected] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
    [anon_sym___init] = ACTIONS(3942),
    [anon_sym___subscript] = ACTIONS(3942),
    [anon_sym_property] = ACTIONS(3942),
    [anon_sym_associatedtype] = ACTIONS(3942),
  },
  [2273] = {
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token2] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_private] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_friend] = ACTIONS(3942),
    [anon_sym_public] = ACTIONS(3942),
    [anon_sym_protected] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
    [anon_sym___init] = ACTIONS(3942),
    [anon_sym___subscript] = ACTIONS(3942),
    [anon_sym_property] = ACTIONS(3942),
    [anon_sym_associatedtype] = ACTIONS(3942),
  },
  [2274] = {
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token2] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_private] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_friend] = ACTIONS(3942),
    [anon_sym_public] = ACTIONS(3942),
    [anon_sym_protected] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
    [anon_sym___init] = ACTIONS(3942),
    [anon_sym___subscript] = ACTIONS(3942),
    [anon_sym_property] = ACTIONS(3942),
    [anon_sym_associatedtype] = ACTIONS(3942),
  },
  [2275] = {
    [sym_identifier] = ACTIONS(3942),
    [aux_sym_preproc_def_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token1] = ACTIONS(3942),
    [aux_sym_preproc_if_token2] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3942),
    [sym_preproc_directive] = ACTIONS(3942),
    [anon_sym_LPAREN2] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(3944),
    [anon_sym_STAR] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(3944),
    [anon_sym_AMP] = ACTIONS(3942),
    [anon_sym_SEMI] = ACTIONS(3944),
    [anon_sym___extension__] = ACTIONS(3942),
    [anon_sym_typedef] = ACTIONS(3942),
    [anon_sym_in] = ACTIONS(3942),
    [anon_sym_out] = ACTIONS(3942),
    [anon_sym_inout] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym___attribute__] = ACTIONS(3942),
    [anon_sym___attribute] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_COLON_COLON] = ACTIONS(3944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3944),
    [anon_sym___declspec] = ACTIONS(3942),
    [anon_sym___based] = ACTIONS(3942),
    [anon_sym_signed] = ACTIONS(3942),
    [anon_sym_unsigned] = ACTIONS(3942),
    [anon_sym_long] = ACTIONS(3942),
    [anon_sym_short] = ACTIONS(3942),
    [anon_sym_LBRACK] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_register] = ACTIONS(3942),
    [anon_sym_inline] = ACTIONS(3942),
    [anon_sym___inline] = ACTIONS(3942),
    [anon_sym___inline__] = ACTIONS(3942),
    [anon_sym___forceinline] = ACTIONS(3942),
    [anon_sym_thread_local] = ACTIONS(3942),
    [anon_sym___thread] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_constexpr] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_restrict] = ACTIONS(3942),
    [anon_sym___restrict__] = ACTIONS(3942),
    [anon_sym__Atomic] = ACTIONS(3942),
    [anon_sym__Noreturn] = ACTIONS(3942),
    [anon_sym_noreturn] = ACTIONS(3942),
    [anon_sym__Nonnull] = ACTIONS(3942),
    [anon_sym_mutable] = ACTIONS(3942),
    [anon_sym_constinit] = ACTIONS(3942),
    [anon_sym_consteval] = ACTIONS(3942),
    [anon_sym_alignas] = ACTIONS(3942),
    [anon_sym__Alignas] = ACTIONS(3942),
    [sym_primitive_type] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_union] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_This] = ACTIONS(3942),
    [anon_sym_decltype] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_typename] = ACTIONS(3942),
    [anon_sym_private] = ACTIONS(3942),
    [anon_sym_template] = ACTIONS(3942),
    [anon_sym_operator] = ACTIONS(3942),
    [anon_sym_friend] = ACTIONS(3942),
    [anon_sym_public] = ACTIONS(3942),
    [anon_sym_protected] = ACTIONS(3942),
    [anon_sym_static_assert] = ACTIONS(3942),
    [anon_sym_precise] = ACTIONS(3942),
    [anon_sym_shared] = ACTIONS(3942),
    [anon_sym_groupshared] = ACTIONS(3942),
    [anon_sym_uniform] = ACTIONS(3942),
    [anon_sym_row_major] = ACTIONS(3942),
    [anon_sym_column_major] = ACTIONS(3942),
    [anon_sym_globallycoherent] = ACTIONS(3942),
    [anon_sym_centroid] = ACTIONS(3942),
    [anon_sym_noperspective] = ACTIONS(3942),
    [anon_sym_nointerpolation] = ACTIONS(3942),
    [anon_sym_sample] = ACTIONS(3942),
    [anon_sym_linear] = ACTIONS(3942),
    [anon_sym_snorm] = ACTIONS(3942),
    [anon_sym_unorm] = ACTIONS(3942),
    [anon_sym_point] = ACTIONS(3942),
    [anon_sym_line] = ACTIONS(3942),
    [anon_sym_triangleadj] = ACTIONS(3942),
    [anon_sym_lineadj] = ACTIONS(3942),
    [anon_sym_triangle] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_extension] = ACTIONS(3942),
    [anon_sym___init] = ACTIONS(3942),
    [anon_sym___subscript] = ACTIONS(3942),
    [anon_sym_property] = ACTIONS(3942),
    [anon_sym_associatedtype] = ACTIONS(3942),
  },
  [2276] = {
    [sym_identifier] = ACTIONS(3953),
    [aux_sym_preproc_def_token1] = ACTIONS(3953),
    [aux_sym_preproc_if_token1] = ACTIONS(3953),
    [aux_sym_preproc_if_token2] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3953),
    [sym_preproc_directive] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_TILDE] = ACTIONS(3955),
    [anon_sym_STAR] = ACTIONS(3955),
    [anon_sym_AMP_AMP] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_SEMI] = ACTIONS(3955),
    [anon_sym___extension__] = ACTIONS(3953),
    [anon_sym_typedef] = ACTIONS(3953),
    [anon_sym_in] = ACTIONS(3953),
    [anon_sym_out] = ACTIONS(3953),
    [anon_sym_inout] = ACTIONS(3953),
    [anon_sym_virtual] = ACTIONS(3953),
    [anon_sym_extern] = ACTIONS(3953),
    [anon_sym___attribute__] = ACTIONS(3953),
    [anon_sym___attribute] = ACTIONS(3953),
    [anon_sym_using] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3955),
    [anon_sym___declspec] = ACTIONS(3953),
    [anon_sym___based] = ACTIONS(3953),
    [anon_sym_signed] = ACTIONS(3953),
    [anon_sym_unsigned] = ACTIONS(3953),
    [anon_sym_long] = ACTIONS(3953),
    [anon_sym_short] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_static] = ACTIONS(3953),
    [anon_sym_register] = ACTIONS(3953),
    [anon_sym_inline] = ACTIONS(3953),
    [anon_sym___inline] = ACTIONS(3953),
    [anon_sym___inline__] = ACTIONS(3953),
    [anon_sym___forceinline] = ACTIONS(3953),
    [anon_sym_thread_local] = ACTIONS(3953),
    [anon_sym___thread] = ACTIONS(3953),
    [anon_sym_const] = ACTIONS(3953),
    [anon_sym_constexpr] = ACTIONS(3953),
    [anon_sym_volatile] = ACTIONS(3953),
    [anon_sym_restrict] = ACTIONS(3953),
    [anon_sym___restrict__] = ACTIONS(3953),
    [anon_sym__Atomic] = ACTIONS(3953),
    [anon_sym__Noreturn] = ACTIONS(3953),
    [anon_sym_noreturn] = ACTIONS(3953),
    [anon_sym__Nonnull] = ACTIONS(3953),
    [anon_sym_mutable] = ACTIONS(3953),
    [anon_sym_constinit] = ACTIONS(3953),
    [anon_sym_consteval] = ACTIONS(3953),
    [anon_sym_alignas] = ACTIONS(3953),
    [anon_sym__Alignas] = ACTIONS(3953),
    [sym_primitive_type] = ACTIONS(3953),
    [anon_sym_enum] = ACTIONS(3953),
    [anon_sym_class] = ACTIONS(3953),
    [anon_sym_struct] = ACTIONS(3953),
    [anon_sym_union] = ACTIONS(3953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_This] = ACTIONS(3953),
    [anon_sym_decltype] = ACTIONS(3953),
    [anon_sym_explicit] = ACTIONS(3953),
    [anon_sym_typename] = ACTIONS(3953),
    [anon_sym_private] = ACTIONS(3953),
    [anon_sym_template] = ACTIONS(3953),
    [anon_sym_operator] = ACTIONS(3953),
    [anon_sym_friend] = ACTIONS(3953),
    [anon_sym_public] = ACTIONS(3953),
    [anon_sym_protected] = ACTIONS(3953),
    [anon_sym_static_assert] = ACTIONS(3953),
    [anon_sym_precise] = ACTIONS(3953),
    [anon_sym_shared] = ACTIONS(3953),
    [anon_sym_groupshared] = ACTIONS(3953),
    [anon_sym_uniform] = ACTIONS(3953),
    [anon_sym_row_major] = ACTIONS(3953),
    [anon_sym_column_major] = ACTIONS(3953),
    [anon_sym_globallycoherent] = ACTIONS(3953),
    [anon_sym_centroid] = ACTIONS(3953),
    [anon_sym_noperspective] = ACTIONS(3953),
    [anon_sym_nointerpolation] = ACTIONS(3953),
    [anon_sym_sample] = ACTIONS(3953),
    [anon_sym_linear] = ACTIONS(3953),
    [anon_sym_snorm] = ACTIONS(3953),
    [anon_sym_unorm] = ACTIONS(3953),
    [anon_sym_point] = ACTIONS(3953),
    [anon_sym_line] = ACTIONS(3953),
    [anon_sym_triangleadj] = ACTIONS(3953),
    [anon_sym_lineadj] = ACTIONS(3953),
    [anon_sym_triangle] = ACTIONS(3953),
    [anon_sym_interface] = ACTIONS(3953),
    [anon_sym_extension] = ACTIONS(3953),
    [anon_sym___init] = ACTIONS(3953),
    [anon_sym___subscript] = ACTIONS(3953),
    [anon_sym_property] = ACTIONS(3953),
    [anon_sym_associatedtype] = ACTIONS(3953),
  },
  [2277] = {
    [sym_identifier] = ACTIONS(3953),
    [aux_sym_preproc_def_token1] = ACTIONS(3953),
    [aux_sym_preproc_if_token1] = ACTIONS(3953),
    [aux_sym_preproc_if_token2] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3953),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3953),
    [sym_preproc_directive] = ACTIONS(3953),
    [anon_sym_LPAREN2] = ACTIONS(3955),
    [anon_sym_TILDE] = ACTIONS(3955),
    [anon_sym_STAR] = ACTIONS(3955),
    [anon_sym_AMP_AMP] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3953),
    [anon_sym_SEMI] = ACTIONS(3955),
    [anon_sym___extension__] = ACTIONS(3953),
    [anon_sym_typedef] = ACTIONS(3953),
    [anon_sym_in] = ACTIONS(3953),
    [anon_sym_out] = ACTIONS(3953),
    [anon_sym_inout] = ACTIONS(3953),
    [anon_sym_virtual] = ACTIONS(3953),
    [anon_sym_extern] = ACTIONS(3953),
    [anon_sym___attribute__] = ACTIONS(3953),
    [anon_sym___attribute] = ACTIONS(3953),
    [anon_sym_using] = ACTIONS(3953),
    [anon_sym_COLON_COLON] = ACTIONS(3955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3955),
    [anon_sym___declspec] = ACTIONS(3953),
    [anon_sym___based] = ACTIONS(3953),
    [anon_sym_signed] = ACTIONS(3953),
    [anon_sym_unsigned] = ACTIONS(3953),
    [anon_sym_long] = ACTIONS(3953),
    [anon_sym_short] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_static] = ACTIONS(3953),
    [anon_sym_register] = ACTIONS(3953),
    [anon_sym_inline] = ACTIONS(3953),
    [anon_sym___inline] = ACTIONS(3953),
    [anon_sym___inline__] = ACTIONS(3953),
    [anon_sym___forceinline] = ACTIONS(3953),
    [anon_sym_thread_local] = ACTIONS(3953),
    [anon_sym___thread] = ACTIONS(3953),
    [anon_sym_const] = ACTIONS(3953),
    [anon_sym_constexpr] = ACTIONS(3953),
    [anon_sym_volatile] = ACTIONS(3953),
    [anon_sym_restrict] = ACTIONS(3953),
    [anon_sym___restrict__] = ACTIONS(3953),
    [anon_sym__Atomic] = ACTIONS(3953),
    [anon_sym__Noreturn] = ACTIONS(3953),
    [anon_sym_noreturn] = ACTIONS(3953),
    [anon_sym__Nonnull] = ACTIONS(3953),
    [anon_sym_mutable] = ACTIONS(3953),
    [anon_sym_constinit] = ACTIONS(3953),
    [anon_sym_consteval] = ACTIONS(3953),
    [anon_sym_alignas] = ACTIONS(3953),
    [anon_sym__Alignas] = ACTIONS(3953),
    [sym_primitive_type] = ACTIONS(3953),
    [anon_sym_enum] = ACTIONS(3953),
    [anon_sym_class] = ACTIONS(3953),
    [anon_sym_struct] = ACTIONS(3953),
    [anon_sym_union] = ACTIONS(3953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_This] = ACTIONS(3953),
    [anon_sym_decltype] = ACTIONS(3953),
    [anon_sym_explicit] = ACTIONS(3953),
    [anon_sym_typename] = ACTIONS(3953),
    [anon_sym_private] = ACTIONS(3953),
    [anon_sym_template] = ACTIONS(3953),
    [anon_sym_operator] = ACTIONS(3953),
    [anon_sym_friend] = ACTIONS(3953),
    [anon_sym_public] = ACTIONS(3953),
    [anon_sym_protected] = ACTIONS(3953),
    [anon_sym_static_assert] = ACTIONS(3953),
    [anon_sym_precise] = ACTIONS(3953),
    [anon_sym_shared] = ACTIONS(3953),
    [anon_sym_groupshared] = ACTIONS(3953),
    [anon_sym_uniform] = ACTIONS(3953),
    [anon_sym_row_major] = ACTIONS(3953),
    [anon_sym_column_major] = ACTIONS(3953),
    [anon_sym_globallycoherent] = ACTIONS(3953),
    [anon_sym_centroid] = ACTIONS(3953),
    [anon_sym_noperspective] = ACTIONS(3953),
    [anon_sym_nointerpolation] = ACTIONS(3953),
    [anon_sym_sample] = ACTIONS(3953),
    [anon_sym_linear] = ACTIONS(3953),
    [anon_sym_snorm] = ACTIONS(3953),
    [anon_sym_unorm] = ACTIONS(3953),
    [anon_sym_point] = ACTIONS(3953),
    [anon_sym_line] = ACTIONS(3953),
    [anon_sym_triangleadj] = ACTIONS(3953),
    [anon_sym_lineadj] = ACTIONS(3953),
    [anon_sym_triangle] = ACTIONS(3953),
    [anon_sym_interface] = ACTIONS(3953),
    [anon_sym_extension] = ACTIONS(3953),
    [anon_sym___init] = ACTIONS(3953),
    [anon_sym___subscript] = ACTIONS(3953),
    [anon_sym_property] = ACTIONS(3953),
    [anon_sym_associatedtype] = ACTIONS(3953),
  },
  [2278] = {
    [sym_identifier] = ACTIONS(3963),
    [aux_sym_preproc_def_token1] = ACTIONS(3963),
    [aux_sym_preproc_if_token1] = ACTIONS(3963),
    [aux_sym_preproc_if_token2] = ACTIONS(3963),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3963),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3963),
    [sym_preproc_directive] = ACTIONS(3963),
    [anon_sym_LPAREN2] = ACTIONS(3965),
    [anon_sym_TILDE] = ACTIONS(3965),
    [anon_sym_STAR] = ACTIONS(3965),
    [anon_sym_AMP_AMP] = ACTIONS(3965),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_SEMI] = ACTIONS(3965),
    [anon_sym___extension__] = ACTIONS(3963),
    [anon_sym_typedef] = ACTIONS(3963),
    [anon_sym_in] = ACTIONS(3963),
    [anon_sym_out] = ACTIONS(3963),
    [anon_sym_inout] = ACTIONS(3963),
    [anon_sym_virtual] = ACTIONS(3963),
    [anon_sym_extern] = ACTIONS(3963),
    [anon_sym___attribute__] = ACTIONS(3963),
    [anon_sym___attribute] = ACTIONS(3963),
    [anon_sym_using] = ACTIONS(3963),
    [anon_sym_COLON_COLON] = ACTIONS(3965),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3965),
    [anon_sym___declspec] = ACTIONS(3963),
    [anon_sym___based] = ACTIONS(3963),
    [anon_sym_signed] = ACTIONS(3963),
    [anon_sym_unsigned] = ACTIONS(3963),
    [anon_sym_long] = ACTIONS(3963),
    [anon_sym_short] = ACTIONS(3963),
    [anon_sym_LBRACK] = ACTIONS(3963),
    [anon_sym_static] = ACTIONS(3963),
    [anon_sym_register] = ACTIONS(3963),
    [anon_sym_inline] = ACTIONS(3963),
    [anon_sym___inline] = ACTIONS(3963),
    [anon_sym___inline__] = ACTIONS(3963),
    [anon_sym___forceinline] = ACTIONS(3963),
    [anon_sym_thread_local] = ACTIONS(3963),
    [anon_sym___thread] = ACTIONS(3963),
    [anon_sym_const] = ACTIONS(3963),
    [anon_sym_constexpr] = ACTIONS(3963),
    [anon_sym_volatile] = ACTIONS(3963),
    [anon_sym_restrict] = ACTIONS(3963),
    [anon_sym___restrict__] = ACTIONS(3963),
    [anon_sym__Atomic] = ACTIONS(3963),
    [anon_sym__Noreturn] = ACTIONS(3963),
    [anon_sym_noreturn] = ACTIONS(3963),
    [anon_sym__Nonnull] = ACTIONS(3963),
    [anon_sym_mutable] = ACTIONS(3963),
    [anon_sym_constinit] = ACTIONS(3963),
    [anon_sym_consteval] = ACTIONS(3963),
    [anon_sym_alignas] = ACTIONS(3963),
    [anon_sym__Alignas] = ACTIONS(3963),
    [sym_primitive_type] = ACTIONS(3963),
    [anon_sym_enum] = ACTIONS(3963),
    [anon_sym_class] = ACTIONS(3963),
    [anon_sym_struct] = ACTIONS(3963),
    [anon_sym_union] = ACTIONS(3963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3963),
    [anon_sym_let] = ACTIONS(3963),
    [anon_sym_This] = ACTIONS(3963),
    [anon_sym_decltype] = ACTIONS(3963),
    [anon_sym_explicit] = ACTIONS(3963),
    [anon_sym_typename] = ACTIONS(3963),
    [anon_sym_private] = ACTIONS(3963),
    [anon_sym_template] = ACTIONS(3963),
    [anon_sym_operator] = ACTIONS(3963),
    [anon_sym_friend] = ACTIONS(3963),
    [anon_sym_public] = ACTIONS(3963),
    [anon_sym_protected] = ACTIONS(3963),
    [anon_sym_static_assert] = ACTIONS(3963),
    [anon_sym_precise] = ACTIONS(3963),
    [anon_sym_shared] = ACTIONS(3963),
    [anon_sym_groupshared] = ACTIONS(3963),
    [anon_sym_uniform] = ACTIONS(3963),
    [anon_sym_row_major] = ACTIONS(3963),
    [anon_sym_column_major] = ACTIONS(3963),
    [anon_sym_globallycoherent] = ACTIONS(3963),
    [anon_sym_centroid] = ACTIONS(3963),
    [anon_sym_noperspective] = ACTIONS(3963),
    [anon_sym_nointerpolation] = ACTIONS(3963),
    [anon_sym_sample] = ACTIONS(3963),
    [anon_sym_linear] = ACTIONS(3963),
    [anon_sym_snorm] = ACTIONS(3963),
    [anon_sym_unorm] = ACTIONS(3963),
    [anon_sym_point] = ACTIONS(3963),
    [anon_sym_line] = ACTIONS(3963),
    [anon_sym_triangleadj] = ACTIONS(3963),
    [anon_sym_lineadj] = ACTIONS(3963),
    [anon_sym_triangle] = ACTIONS(3963),
    [anon_sym_interface] = ACTIONS(3963),
    [anon_sym_extension] = ACTIONS(3963),
    [anon_sym___init] = ACTIONS(3963),
    [anon_sym___subscript] = ACTIONS(3963),
    [anon_sym_property] = ACTIONS(3963),
    [anon_sym_associatedtype] = ACTIONS(3963),
  },
  [2279] = {
    [sym_identifier] = ACTIONS(3983),
    [aux_sym_preproc_def_token1] = ACTIONS(3983),
    [aux_sym_preproc_if_token1] = ACTIONS(3983),
    [aux_sym_preproc_if_token2] = ACTIONS(3983),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3983),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3983),
    [sym_preproc_directive] = ACTIONS(3983),
    [anon_sym_LPAREN2] = ACTIONS(3985),
    [anon_sym_TILDE] = ACTIONS(3985),
    [anon_sym_STAR] = ACTIONS(3985),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_AMP] = ACTIONS(3983),
    [anon_sym_SEMI] = ACTIONS(3985),
    [anon_sym___extension__] = ACTIONS(3983),
    [anon_sym_typedef] = ACTIONS(3983),
    [anon_sym_in] = ACTIONS(3983),
    [anon_sym_out] = ACTIONS(3983),
    [anon_sym_inout] = ACTIONS(3983),
    [anon_sym_virtual] = ACTIONS(3983),
    [anon_sym_extern] = ACTIONS(3983),
    [anon_sym___attribute__] = ACTIONS(3983),
    [anon_sym___attribute] = ACTIONS(3983),
    [anon_sym_using] = ACTIONS(3983),
    [anon_sym_COLON_COLON] = ACTIONS(3985),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3985),
    [anon_sym___declspec] = ACTIONS(3983),
    [anon_sym___based] = ACTIONS(3983),
    [anon_sym_signed] = ACTIONS(3983),
    [anon_sym_unsigned] = ACTIONS(3983),
    [anon_sym_long] = ACTIONS(3983),
    [anon_sym_short] = ACTIONS(3983),
    [anon_sym_LBRACK] = ACTIONS(3983),
    [anon_sym_static] = ACTIONS(3983),
    [anon_sym_register] = ACTIONS(3983),
    [anon_sym_inline] = ACTIONS(3983),
    [anon_sym___inline] = ACTIONS(3983),
    [anon_sym___inline__] = ACTIONS(3983),
    [anon_sym___forceinline] = ACTIONS(3983),
    [anon_sym_thread_local] = ACTIONS(3983),
    [anon_sym___thread] = ACTIONS(3983),
    [anon_sym_const] = ACTIONS(3983),
    [anon_sym_constexpr] = ACTIONS(3983),
    [anon_sym_volatile] = ACTIONS(3983),
    [anon_sym_restrict] = ACTIONS(3983),
    [anon_sym___restrict__] = ACTIONS(3983),
    [anon_sym__Atomic] = ACTIONS(3983),
    [anon_sym__Noreturn] = ACTIONS(3983),
    [anon_sym_noreturn] = ACTIONS(3983),
    [anon_sym__Nonnull] = ACTIONS(3983),
    [anon_sym_mutable] = ACTIONS(3983),
    [anon_sym_constinit] = ACTIONS(3983),
    [anon_sym_consteval] = ACTIONS(3983),
    [anon_sym_alignas] = ACTIONS(3983),
    [anon_sym__Alignas] = ACTIONS(3983),
    [sym_primitive_type] = ACTIONS(3983),
    [anon_sym_enum] = ACTIONS(3983),
    [anon_sym_class] = ACTIONS(3983),
    [anon_sym_struct] = ACTIONS(3983),
    [anon_sym_union] = ACTIONS(3983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3983),
    [anon_sym_let] = ACTIONS(3983),
    [anon_sym_This] = ACTIONS(3983),
    [anon_sym_decltype] = ACTIONS(3983),
    [anon_sym_explicit] = ACTIONS(3983),
    [anon_sym_typename] = ACTIONS(3983),
    [anon_sym_private] = ACTIONS(3983),
    [anon_sym_template] = ACTIONS(3983),
    [anon_sym_operator] = ACTIONS(3983),
    [anon_sym_friend] = ACTIONS(3983),
    [anon_sym_public] = ACTIONS(3983),
    [anon_sym_protected] = ACTIONS(3983),
    [anon_sym_static_assert] = ACTIONS(3983),
    [anon_sym_precise] = ACTIONS(3983),
    [anon_sym_shared] = ACTIONS(3983),
    [anon_sym_groupshared] = ACTIONS(3983),
    [anon_sym_uniform] = ACTIONS(3983),
    [anon_sym_row_major] = ACTIONS(3983),
    [anon_sym_column_major] = ACTIONS(3983),
    [anon_sym_globallycoherent] = ACTIONS(3983),
    [anon_sym_centroid] = ACTIONS(3983),
    [anon_sym_noperspective] = ACTIONS(3983),
    [anon_sym_nointerpolation] = ACTIONS(3983),
    [anon_sym_sample] = ACTIONS(3983),
    [anon_sym_linear] = ACTIONS(3983),
    [anon_sym_snorm] = ACTIONS(3983),
    [anon_sym_unorm] = ACTIONS(3983),
    [anon_sym_point] = ACTIONS(3983),
    [anon_sym_line] = ACTIONS(3983),
    [anon_sym_triangleadj] = ACTIONS(3983),
    [anon_sym_lineadj] = ACTIONS(3983),
    [anon_sym_triangle] = ACTIONS(3983),
    [anon_sym_interface] = ACTIONS(3983),
    [anon_sym_extension] = ACTIONS(3983),
    [anon_sym___init] = ACTIONS(3983),
    [anon_sym___subscript] = ACTIONS(3983),
    [anon_sym_property] = ACTIONS(3983),
    [anon_sym_associatedtype] = ACTIONS(3983),
  },
  [2280] = {
    [sym_identifier] = ACTIONS(3808),
    [aux_sym_preproc_def_token1] = ACTIONS(3808),
    [aux_sym_preproc_if_token1] = ACTIONS(3808),
    [aux_sym_preproc_if_token2] = ACTIONS(3808),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3808),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3808),
    [sym_preproc_directive] = ACTIONS(3808),
    [anon_sym_LPAREN2] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [anon_sym_STAR] = ACTIONS(3810),
    [anon_sym_AMP_AMP] = ACTIONS(3810),
    [anon_sym_AMP] = ACTIONS(3808),
    [anon_sym_SEMI] = ACTIONS(3810),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_typedef] = ACTIONS(3808),
    [anon_sym_in] = ACTIONS(3808),
    [anon_sym_out] = ACTIONS(3808),
    [anon_sym_inout] = ACTIONS(3808),
    [anon_sym_virtual] = ACTIONS(3808),
    [anon_sym_extern] = ACTIONS(3808),
    [anon_sym___attribute__] = ACTIONS(3808),
    [anon_sym___attribute] = ACTIONS(3808),
    [anon_sym_using] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3810),
    [anon_sym___declspec] = ACTIONS(3808),
    [anon_sym___based] = ACTIONS(3808),
    [anon_sym_signed] = ACTIONS(3808),
    [anon_sym_unsigned] = ACTIONS(3808),
    [anon_sym_long] = ACTIONS(3808),
    [anon_sym_short] = ACTIONS(3808),
    [anon_sym_LBRACK] = ACTIONS(3808),
    [anon_sym_static] = ACTIONS(3808),
    [anon_sym_register] = ACTIONS(3808),
    [anon_sym_inline] = ACTIONS(3808),
    [anon_sym___inline] = ACTIONS(3808),
    [anon_sym___inline__] = ACTIONS(3808),
    [anon_sym___forceinline] = ACTIONS(3808),
    [anon_sym_thread_local] = ACTIONS(3808),
    [anon_sym___thread] = ACTIONS(3808),
    [anon_sym_const] = ACTIONS(3808),
    [anon_sym_constexpr] = ACTIONS(3808),
    [anon_sym_volatile] = ACTIONS(3808),
    [anon_sym_restrict] = ACTIONS(3808),
    [anon_sym___restrict__] = ACTIONS(3808),
    [anon_sym__Atomic] = ACTIONS(3808),
    [anon_sym__Noreturn] = ACTIONS(3808),
    [anon_sym_noreturn] = ACTIONS(3808),
    [anon_sym__Nonnull] = ACTIONS(3808),
    [anon_sym_mutable] = ACTIONS(3808),
    [anon_sym_constinit] = ACTIONS(3808),
    [anon_sym_consteval] = ACTIONS(3808),
    [anon_sym_alignas] = ACTIONS(3808),
    [anon_sym__Alignas] = ACTIONS(3808),
    [sym_primitive_type] = ACTIONS(3808),
    [anon_sym_enum] = ACTIONS(3808),
    [anon_sym_class] = ACTIONS(3808),
    [anon_sym_struct] = ACTIONS(3808),
    [anon_sym_union] = ACTIONS(3808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3808),
    [anon_sym_let] = ACTIONS(3808),
    [anon_sym_This] = ACTIONS(3808),
    [anon_sym_decltype] = ACTIONS(3808),
    [anon_sym_explicit] = ACTIONS(3808),
    [anon_sym_typename] = ACTIONS(3808),
    [anon_sym_private] = ACTIONS(3808),
    [anon_sym_template] = ACTIONS(3808),
    [anon_sym_operator] = ACTIONS(3808),
    [anon_sym_friend] = ACTIONS(3808),
    [anon_sym_public] = ACTIONS(3808),
    [anon_sym_protected] = ACTIONS(3808),
    [anon_sym_static_assert] = ACTIONS(3808),
    [anon_sym_precise] = ACTIONS(3808),
    [anon_sym_shared] = ACTIONS(3808),
    [anon_sym_groupshared] = ACTIONS(3808),
    [anon_sym_uniform] = ACTIONS(3808),
    [anon_sym_row_major] = ACTIONS(3808),
    [anon_sym_column_major] = ACTIONS(3808),
    [anon_sym_globallycoherent] = ACTIONS(3808),
    [anon_sym_centroid] = ACTIONS(3808),
    [anon_sym_noperspective] = ACTIONS(3808),
    [anon_sym_nointerpolation] = ACTIONS(3808),
    [anon_sym_sample] = ACTIONS(3808),
    [anon_sym_linear] = ACTIONS(3808),
    [anon_sym_snorm] = ACTIONS(3808),
    [anon_sym_unorm] = ACTIONS(3808),
    [anon_sym_point] = ACTIONS(3808),
    [anon_sym_line] = ACTIONS(3808),
    [anon_sym_triangleadj] = ACTIONS(3808),
    [anon_sym_lineadj] = ACTIONS(3808),
    [anon_sym_triangle] = ACTIONS(3808),
    [anon_sym_interface] = ACTIONS(3808),
    [anon_sym_extension] = ACTIONS(3808),
    [anon_sym___init] = ACTIONS(3808),
    [anon_sym___subscript] = ACTIONS(3808),
    [anon_sym_property] = ACTIONS(3808),
    [anon_sym_associatedtype] = ACTIONS(3808),
  },
  [2281] = {
    [sym_identifier] = ACTIONS(3845),
    [aux_sym_preproc_def_token1] = ACTIONS(3845),
    [aux_sym_preproc_if_token1] = ACTIONS(3845),
    [aux_sym_preproc_if_token2] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3845),
    [sym_preproc_directive] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3847),
    [anon_sym_STAR] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_SEMI] = ACTIONS(3847),
    [anon_sym___extension__] = ACTIONS(3845),
    [anon_sym_typedef] = ACTIONS(3845),
    [anon_sym_in] = ACTIONS(3845),
    [anon_sym_out] = ACTIONS(3845),
    [anon_sym_inout] = ACTIONS(3845),
    [anon_sym_virtual] = ACTIONS(3845),
    [anon_sym_extern] = ACTIONS(3845),
    [anon_sym___attribute__] = ACTIONS(3845),
    [anon_sym___attribute] = ACTIONS(3845),
    [anon_sym_using] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3847),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3847),
    [anon_sym___declspec] = ACTIONS(3845),
    [anon_sym___based] = ACTIONS(3845),
    [anon_sym_signed] = ACTIONS(3845),
    [anon_sym_unsigned] = ACTIONS(3845),
    [anon_sym_long] = ACTIONS(3845),
    [anon_sym_short] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_static] = ACTIONS(3845),
    [anon_sym_register] = ACTIONS(3845),
    [anon_sym_inline] = ACTIONS(3845),
    [anon_sym___inline] = ACTIONS(3845),
    [anon_sym___inline__] = ACTIONS(3845),
    [anon_sym___forceinline] = ACTIONS(3845),
    [anon_sym_thread_local] = ACTIONS(3845),
    [anon_sym___thread] = ACTIONS(3845),
    [anon_sym_const] = ACTIONS(3845),
    [anon_sym_constexpr] = ACTIONS(3845),
    [anon_sym_volatile] = ACTIONS(3845),
    [anon_sym_restrict] = ACTIONS(3845),
    [anon_sym___restrict__] = ACTIONS(3845),
    [anon_sym__Atomic] = ACTIONS(3845),
    [anon_sym__Noreturn] = ACTIONS(3845),
    [anon_sym_noreturn] = ACTIONS(3845),
    [anon_sym__Nonnull] = ACTIONS(3845),
    [anon_sym_mutable] = ACTIONS(3845),
    [anon_sym_constinit] = ACTIONS(3845),
    [anon_sym_consteval] = ACTIONS(3845),
    [anon_sym_alignas] = ACTIONS(3845),
    [anon_sym__Alignas] = ACTIONS(3845),
    [sym_primitive_type] = ACTIONS(3845),
    [anon_sym_enum] = ACTIONS(3845),
    [anon_sym_class] = ACTIONS(3845),
    [anon_sym_struct] = ACTIONS(3845),
    [anon_sym_union] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_This] = ACTIONS(3845),
    [anon_sym_decltype] = ACTIONS(3845),
    [anon_sym_explicit] = ACTIONS(3845),
    [anon_sym_typename] = ACTIONS(3845),
    [anon_sym_private] = ACTIONS(3845),
    [anon_sym_template] = ACTIONS(3845),
    [anon_sym_operator] = ACTIONS(3845),
    [anon_sym_friend] = ACTIONS(3845),
    [anon_sym_public] = ACTIONS(3845),
    [anon_sym_protected] = ACTIONS(3845),
    [anon_sym_static_assert] = ACTIONS(3845),
    [anon_sym_precise] = ACTIONS(3845),
    [anon_sym_shared] = ACTIONS(3845),
    [anon_sym_groupshared] = ACTIONS(3845),
    [anon_sym_uniform] = ACTIONS(3845),
    [anon_sym_row_major] = ACTIONS(3845),
    [anon_sym_column_major] = ACTIONS(3845),
    [anon_sym_globallycoherent] = ACTIONS(3845),
    [anon_sym_centroid] = ACTIONS(3845),
    [anon_sym_noperspective] = ACTIONS(3845),
    [anon_sym_nointerpolation] = ACTIONS(3845),
    [anon_sym_sample] = ACTIONS(3845),
    [anon_sym_linear] = ACTIONS(3845),
    [anon_sym_snorm] = ACTIONS(3845),
    [anon_sym_unorm] = ACTIONS(3845),
    [anon_sym_point] = ACTIONS(3845),
    [anon_sym_line] = ACTIONS(3845),
    [anon_sym_triangleadj] = ACTIONS(3845),
    [anon_sym_lineadj] = ACTIONS(3845),
    [anon_sym_triangle] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3845),
    [anon_sym_extension] = ACTIONS(3845),
    [anon_sym___init] = ACTIONS(3845),
    [anon_sym___subscript] = ACTIONS(3845),
    [anon_sym_property] = ACTIONS(3845),
    [anon_sym_associatedtype] = ACTIONS(3845),
  },
  [2282] = {
    [sym_identifier] = ACTIONS(3845),
    [aux_sym_preproc_def_token1] = ACTIONS(3845),
    [aux_sym_preproc_if_token1] = ACTIONS(3845),
    [aux_sym_preproc_if_token2] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3845),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3845),
    [sym_preproc_directive] = ACTIONS(3845),
    [anon_sym_LPAREN2] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3847),
    [anon_sym_STAR] = ACTIONS(3847),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_SEMI] = ACTIONS(3847),
    [anon_sym___extension__] = ACTIONS(3845),
    [anon_sym_typedef] = ACTIONS(3845),
    [anon_sym_in] = ACTIONS(3845),
    [anon_sym_out] = ACTIONS(3845),
    [anon_sym_inout] = ACTIONS(3845),
    [anon_sym_virtual] = ACTIONS(3845),
    [anon_sym_extern] = ACTIONS(3845),
    [anon_sym___attribute__] = ACTIONS(3845),
    [anon_sym___attribute] = ACTIONS(3845),
    [anon_sym_using] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3847),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3847),
    [anon_sym___declspec] = ACTIONS(3845),
    [anon_sym___based] = ACTIONS(3845),
    [anon_sym_signed] = ACTIONS(3845),
    [anon_sym_unsigned] = ACTIONS(3845),
    [anon_sym_long] = ACTIONS(3845),
    [anon_sym_short] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_static] = ACTIONS(3845),
    [anon_sym_register] = ACTIONS(3845),
    [anon_sym_inline] = ACTIONS(3845),
    [anon_sym___inline] = ACTIONS(3845),
    [anon_sym___inline__] = ACTIONS(3845),
    [anon_sym___forceinline] = ACTIONS(3845),
    [anon_sym_thread_local] = ACTIONS(3845),
    [anon_sym___thread] = ACTIONS(3845),
    [anon_sym_const] = ACTIONS(3845),
    [anon_sym_constexpr] = ACTIONS(3845),
    [anon_sym_volatile] = ACTIONS(3845),
    [anon_sym_restrict] = ACTIONS(3845),
    [anon_sym___restrict__] = ACTIONS(3845),
    [anon_sym__Atomic] = ACTIONS(3845),
    [anon_sym__Noreturn] = ACTIONS(3845),
    [anon_sym_noreturn] = ACTIONS(3845),
    [anon_sym__Nonnull] = ACTIONS(3845),
    [anon_sym_mutable] = ACTIONS(3845),
    [anon_sym_constinit] = ACTIONS(3845),
    [anon_sym_consteval] = ACTIONS(3845),
    [anon_sym_alignas] = ACTIONS(3845),
    [anon_sym__Alignas] = ACTIONS(3845),
    [sym_primitive_type] = ACTIONS(3845),
    [anon_sym_enum] = ACTIONS(3845),
    [anon_sym_class] = ACTIONS(3845),
    [anon_sym_struct] = ACTIONS(3845),
    [anon_sym_union] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3845),
    [anon_sym_let] = ACTIONS(3845),
    [anon_sym_This] = ACTIONS(3845),
    [anon_sym_decltype] = ACTIONS(3845),
    [anon_sym_explicit] = ACTIONS(3845),
    [anon_sym_typename] = ACTIONS(3845),
    [anon_sym_private] = ACTIONS(3845),
    [anon_sym_template] = ACTIONS(3845),
    [anon_sym_operator] = ACTIONS(3845),
    [anon_sym_friend] = ACTIONS(3845),
    [anon_sym_public] = ACTIONS(3845),
    [anon_sym_protected] = ACTIONS(3845),
    [anon_sym_static_assert] = ACTIONS(3845),
    [anon_sym_precise] = ACTIONS(3845),
    [anon_sym_shared] = ACTIONS(3845),
    [anon_sym_groupshared] = ACTIONS(3845),
    [anon_sym_uniform] = ACTIONS(3845),
    [anon_sym_row_major] = ACTIONS(3845),
    [anon_sym_column_major] = ACTIONS(3845),
    [anon_sym_globallycoherent] = ACTIONS(3845),
    [anon_sym_centroid] = ACTIONS(3845),
    [anon_sym_noperspective] = ACTIONS(3845),
    [anon_sym_nointerpolation] = ACTIONS(3845),
    [anon_sym_sample] = ACTIONS(3845),
    [anon_sym_linear] = ACTIONS(3845),
    [anon_sym_snorm] = ACTIONS(3845),
    [anon_sym_unorm] = ACTIONS(3845),
    [anon_sym_point] = ACTIONS(3845),
    [anon_sym_line] = ACTIONS(3845),
    [anon_sym_triangleadj] = ACTIONS(3845),
    [anon_sym_lineadj] = ACTIONS(3845),
    [anon_sym_triangle] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3845),
    [anon_sym_extension] = ACTIONS(3845),
    [anon_sym___init] = ACTIONS(3845),
    [anon_sym___subscript] = ACTIONS(3845),
    [anon_sym_property] = ACTIONS(3845),
    [anon_sym_associatedtype] = ACTIONS(3845),
  },
  [2283] = {
    [sym_identifier] = ACTIONS(3832),
    [aux_sym_preproc_def_token1] = ACTIONS(3832),
    [aux_sym_preproc_if_token1] = ACTIONS(3832),
    [aux_sym_preproc_if_token2] = ACTIONS(3832),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3832),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3832),
    [sym_preproc_directive] = ACTIONS(3832),
    [anon_sym_LPAREN2] = ACTIONS(3834),
    [anon_sym_TILDE] = ACTIONS(3834),
    [anon_sym_STAR] = ACTIONS(3834),
    [anon_sym_AMP_AMP] = ACTIONS(3834),
    [anon_sym_AMP] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3834),
    [anon_sym___extension__] = ACTIONS(3832),
    [anon_sym_typedef] = ACTIONS(3832),
    [anon_sym_in] = ACTIONS(3832),
    [anon_sym_out] = ACTIONS(3832),
    [anon_sym_inout] = ACTIONS(3832),
    [anon_sym_virtual] = ACTIONS(3832),
    [anon_sym_extern] = ACTIONS(3832),
    [anon_sym___attribute__] = ACTIONS(3832),
    [anon_sym___attribute] = ACTIONS(3832),
    [anon_sym_using] = ACTIONS(3832),
    [anon_sym_COLON_COLON] = ACTIONS(3834),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3834),
    [anon_sym___declspec] = ACTIONS(3832),
    [anon_sym___based] = ACTIONS(3832),
    [anon_sym_signed] = ACTIONS(3832),
    [anon_sym_unsigned] = ACTIONS(3832),
    [anon_sym_long] = ACTIONS(3832),
    [anon_sym_short] = ACTIONS(3832),
    [anon_sym_LBRACK] = ACTIONS(3832),
    [anon_sym_static] = ACTIONS(3832),
    [anon_sym_register] = ACTIONS(3832),
    [anon_sym_inline] = ACTIONS(3832),
    [anon_sym___inline] = ACTIONS(3832),
    [anon_sym___inline__] = ACTIONS(3832),
    [anon_sym___forceinline] = ACTIONS(3832),
    [anon_sym_thread_local] = ACTIONS(3832),
    [anon_sym___thread] = ACTIONS(3832),
    [anon_sym_const] = ACTIONS(3832),
    [anon_sym_constexpr] = ACTIONS(3832),
    [anon_sym_volatile] = ACTIONS(3832),
    [anon_sym_restrict] = ACTIONS(3832),
    [anon_sym___restrict__] = ACTIONS(3832),
    [anon_sym__Atomic] = ACTIONS(3832),
    [anon_sym__Noreturn] = ACTIONS(3832),
    [anon_sym_noreturn] = ACTIONS(3832),
    [anon_sym__Nonnull] = ACTIONS(3832),
    [anon_sym_mutable] = ACTIONS(3832),
    [anon_sym_constinit] = ACTIONS(3832),
    [anon_sym_consteval] = ACTIONS(3832),
    [anon_sym_alignas] = ACTIONS(3832),
    [anon_sym__Alignas] = ACTIONS(3832),
    [sym_primitive_type] = ACTIONS(3832),
    [anon_sym_enum] = ACTIONS(3832),
    [anon_sym_class] = ACTIONS(3832),
    [anon_sym_struct] = ACTIONS(3832),
    [anon_sym_union] = ACTIONS(3832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3832),
    [anon_sym_let] = ACTIONS(3832),
    [anon_sym_This] = ACTIONS(3832),
    [anon_sym_decltype] = ACTIONS(3832),
    [anon_sym_explicit] = ACTIONS(3832),
    [anon_sym_typename] = ACTIONS(3832),
    [anon_sym_private] = ACTIONS(3832),
    [anon_sym_template] = ACTIONS(3832),
    [anon_sym_operator] = ACTIONS(3832),
    [anon_sym_friend] = ACTIONS(3832),
    [anon_sym_public] = ACTIONS(3832),
    [anon_sym_protected] = ACTIONS(3832),
    [anon_sym_static_assert] = ACTIONS(3832),
    [anon_sym_precise] = ACTIONS(3832),
    [anon_sym_shared] = ACTIONS(3832),
    [anon_sym_groupshared] = ACTIONS(3832),
    [anon_sym_uniform] = ACTIONS(3832),
    [anon_sym_row_major] = ACTIONS(3832),
    [anon_sym_column_major] = ACTIONS(3832),
    [anon_sym_globallycoherent] = ACTIONS(3832),
    [anon_sym_centroid] = ACTIONS(3832),
    [anon_sym_noperspective] = ACTIONS(3832),
    [anon_sym_nointerpolation] = ACTIONS(3832),
    [anon_sym_sample] = ACTIONS(3832),
    [anon_sym_linear] = ACTIONS(3832),
    [anon_sym_snorm] = ACTIONS(3832),
    [anon_sym_unorm] = ACTIONS(3832),
    [anon_sym_point] = ACTIONS(3832),
    [anon_sym_line] = ACTIONS(3832),
    [anon_sym_triangleadj] = ACTIONS(3832),
    [anon_sym_lineadj] = ACTIONS(3832),
    [anon_sym_triangle] = ACTIONS(3832),
    [anon_sym_interface] = ACTIONS(3832),
    [anon_sym_extension] = ACTIONS(3832),
    [anon_sym___init] = ACTIONS(3832),
    [anon_sym___subscript] = ACTIONS(3832),
    [anon_sym_property] = ACTIONS(3832),
    [anon_sym_associatedtype] = ACTIONS(3832),
  },
  [2284] = {
    [sym_identifier] = ACTIONS(3665),
    [aux_sym_preproc_def_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token2] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3665),
    [sym_preproc_directive] = ACTIONS(3665),
    [anon_sym_LPAREN2] = ACTIONS(3667),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_STAR] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_SEMI] = ACTIONS(3667),
    [anon_sym___extension__] = ACTIONS(3665),
    [anon_sym_typedef] = ACTIONS(3665),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_out] = ACTIONS(3665),
    [anon_sym_inout] = ACTIONS(3665),
    [anon_sym_virtual] = ACTIONS(3665),
    [anon_sym_extern] = ACTIONS(3665),
    [anon_sym___attribute__] = ACTIONS(3665),
    [anon_sym___attribute] = ACTIONS(3665),
    [anon_sym_using] = ACTIONS(3665),
    [anon_sym_COLON_COLON] = ACTIONS(3667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3667),
    [anon_sym___declspec] = ACTIONS(3665),
    [anon_sym___based] = ACTIONS(3665),
    [anon_sym_signed] = ACTIONS(3665),
    [anon_sym_unsigned] = ACTIONS(3665),
    [anon_sym_long] = ACTIONS(3665),
    [anon_sym_short] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3665),
    [anon_sym_static] = ACTIONS(3665),
    [anon_sym_register] = ACTIONS(3665),
    [anon_sym_inline] = ACTIONS(3665),
    [anon_sym___inline] = ACTIONS(3665),
    [anon_sym___inline__] = ACTIONS(3665),
    [anon_sym___forceinline] = ACTIONS(3665),
    [anon_sym_thread_local] = ACTIONS(3665),
    [anon_sym___thread] = ACTIONS(3665),
    [anon_sym_const] = ACTIONS(3665),
    [anon_sym_constexpr] = ACTIONS(3665),
    [anon_sym_volatile] = ACTIONS(3665),
    [anon_sym_restrict] = ACTIONS(3665),
    [anon_sym___restrict__] = ACTIONS(3665),
    [anon_sym__Atomic] = ACTIONS(3665),
    [anon_sym__Noreturn] = ACTIONS(3665),
    [anon_sym_noreturn] = ACTIONS(3665),
    [anon_sym__Nonnull] = ACTIONS(3665),
    [anon_sym_mutable] = ACTIONS(3665),
    [anon_sym_constinit] = ACTIONS(3665),
    [anon_sym_consteval] = ACTIONS(3665),
    [anon_sym_alignas] = ACTIONS(3665),
    [anon_sym__Alignas] = ACTIONS(3665),
    [sym_primitive_type] = ACTIONS(3665),
    [anon_sym_enum] = ACTIONS(3665),
    [anon_sym_class] = ACTIONS(3665),
    [anon_sym_struct] = ACTIONS(3665),
    [anon_sym_union] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3665),
    [anon_sym_let] = ACTIONS(3665),
    [anon_sym_This] = ACTIONS(3665),
    [anon_sym_decltype] = ACTIONS(3665),
    [anon_sym_explicit] = ACTIONS(3665),
    [anon_sym_typename] = ACTIONS(3665),
    [anon_sym_private] = ACTIONS(3665),
    [anon_sym_template] = ACTIONS(3665),
    [anon_sym_operator] = ACTIONS(3665),
    [anon_sym_friend] = ACTIONS(3665),
    [anon_sym_public] = ACTIONS(3665),
    [anon_sym_protected] = ACTIONS(3665),
    [anon_sym_static_assert] = ACTIONS(3665),
    [anon_sym_precise] = ACTIONS(3665),
    [anon_sym_shared] = ACTIONS(3665),
    [anon_sym_groupshared] = ACTIONS(3665),
    [anon_sym_uniform] = ACTIONS(3665),
    [anon_sym_row_major] = ACTIONS(3665),
    [anon_sym_column_major] = ACTIONS(3665),
    [anon_sym_globallycoherent] = ACTIONS(3665),
    [anon_sym_centroid] = ACTIONS(3665),
    [anon_sym_noperspective] = ACTIONS(3665),
    [anon_sym_nointerpolation] = ACTIONS(3665),
    [anon_sym_sample] = ACTIONS(3665),
    [anon_sym_linear] = ACTIONS(3665),
    [anon_sym_snorm] = ACTIONS(3665),
    [anon_sym_unorm] = ACTIONS(3665),
    [anon_sym_point] = ACTIONS(3665),
    [anon_sym_line] = ACTIONS(3665),
    [anon_sym_triangleadj] = ACTIONS(3665),
    [anon_sym_lineadj] = ACTIONS(3665),
    [anon_sym_triangle] = ACTIONS(3665),
    [anon_sym_interface] = ACTIONS(3665),
    [anon_sym_extension] = ACTIONS(3665),
    [anon_sym___init] = ACTIONS(3665),
    [anon_sym___subscript] = ACTIONS(3665),
    [anon_sym_property] = ACTIONS(3665),
    [anon_sym_associatedtype] = ACTIONS(3665),
  },
  [2285] = {
    [sym_identifier] = ACTIONS(6206),
    [aux_sym_preproc_def_token1] = ACTIONS(6206),
    [aux_sym_preproc_if_token1] = ACTIONS(6206),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6206),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6206),
    [sym_preproc_directive] = ACTIONS(6206),
    [anon_sym_LPAREN2] = ACTIONS(6208),
    [anon_sym_TILDE] = ACTIONS(6208),
    [anon_sym_STAR] = ACTIONS(6208),
    [anon_sym_AMP_AMP] = ACTIONS(6208),
    [anon_sym_AMP] = ACTIONS(6206),
    [anon_sym_SEMI] = ACTIONS(6208),
    [anon_sym___extension__] = ACTIONS(6206),
    [anon_sym_typedef] = ACTIONS(6206),
    [anon_sym_in] = ACTIONS(6206),
    [anon_sym_out] = ACTIONS(6206),
    [anon_sym_inout] = ACTIONS(6206),
    [anon_sym_virtual] = ACTIONS(6206),
    [anon_sym_extern] = ACTIONS(6206),
    [anon_sym___attribute__] = ACTIONS(6206),
    [anon_sym___attribute] = ACTIONS(6206),
    [anon_sym_using] = ACTIONS(6206),
    [anon_sym_COLON_COLON] = ACTIONS(6208),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6208),
    [anon_sym___declspec] = ACTIONS(6206),
    [anon_sym___based] = ACTIONS(6206),
    [anon_sym_RBRACE] = ACTIONS(6208),
    [anon_sym_signed] = ACTIONS(6206),
    [anon_sym_unsigned] = ACTIONS(6206),
    [anon_sym_long] = ACTIONS(6206),
    [anon_sym_short] = ACTIONS(6206),
    [anon_sym_LBRACK] = ACTIONS(6206),
    [anon_sym_static] = ACTIONS(6206),
    [anon_sym_register] = ACTIONS(6206),
    [anon_sym_inline] = ACTIONS(6206),
    [anon_sym___inline] = ACTIONS(6206),
    [anon_sym___inline__] = ACTIONS(6206),
    [anon_sym___forceinline] = ACTIONS(6206),
    [anon_sym_thread_local] = ACTIONS(6206),
    [anon_sym___thread] = ACTIONS(6206),
    [anon_sym_const] = ACTIONS(6206),
    [anon_sym_constexpr] = ACTIONS(6206),
    [anon_sym_volatile] = ACTIONS(6206),
    [anon_sym_restrict] = ACTIONS(6206),
    [anon_sym___restrict__] = ACTIONS(6206),
    [anon_sym__Atomic] = ACTIONS(6206),
    [anon_sym__Noreturn] = ACTIONS(6206),
    [anon_sym_noreturn] = ACTIONS(6206),
    [anon_sym__Nonnull] = ACTIONS(6206),
    [anon_sym_mutable] = ACTIONS(6206),
    [anon_sym_constinit] = ACTIONS(6206),
    [anon_sym_consteval] = ACTIONS(6206),
    [anon_sym_alignas] = ACTIONS(6206),
    [anon_sym__Alignas] = ACTIONS(6206),
    [sym_primitive_type] = ACTIONS(6206),
    [anon_sym_enum] = ACTIONS(6206),
    [anon_sym_class] = ACTIONS(6206),
    [anon_sym_struct] = ACTIONS(6206),
    [anon_sym_union] = ACTIONS(6206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6206),
    [anon_sym_let] = ACTIONS(6206),
    [anon_sym_This] = ACTIONS(6206),
    [anon_sym_decltype] = ACTIONS(6206),
    [anon_sym_explicit] = ACTIONS(6206),
    [anon_sym_typename] = ACTIONS(6206),
    [anon_sym_private] = ACTIONS(6206),
    [anon_sym_template] = ACTIONS(6206),
    [anon_sym_operator] = ACTIONS(6206),
    [anon_sym_friend] = ACTIONS(6206),
    [anon_sym_public] = ACTIONS(6206),
    [anon_sym_protected] = ACTIONS(6206),
    [anon_sym_static_assert] = ACTIONS(6206),
    [anon_sym_precise] = ACTIONS(6206),
    [anon_sym_shared] = ACTIONS(6206),
    [anon_sym_groupshared] = ACTIONS(6206),
    [anon_sym_uniform] = ACTIONS(6206),
    [anon_sym_row_major] = ACTIONS(6206),
    [anon_sym_column_major] = ACTIONS(6206),
    [anon_sym_globallycoherent] = ACTIONS(6206),
    [anon_sym_centroid] = ACTIONS(6206),
    [anon_sym_noperspective] = ACTIONS(6206),
    [anon_sym_nointerpolation] = ACTIONS(6206),
    [anon_sym_sample] = ACTIONS(6206),
    [anon_sym_linear] = ACTIONS(6206),
    [anon_sym_snorm] = ACTIONS(6206),
    [anon_sym_unorm] = ACTIONS(6206),
    [anon_sym_point] = ACTIONS(6206),
    [anon_sym_line] = ACTIONS(6206),
    [anon_sym_triangleadj] = ACTIONS(6206),
    [anon_sym_lineadj] = ACTIONS(6206),
    [anon_sym_triangle] = ACTIONS(6206),
    [anon_sym_interface] = ACTIONS(6206),
    [anon_sym_extension] = ACTIONS(6206),
    [anon_sym___init] = ACTIONS(6206),
    [anon_sym___subscript] = ACTIONS(6206),
    [anon_sym_property] = ACTIONS(6206),
    [anon_sym_associatedtype] = ACTIONS(6206),
  },
  [2286] = {
    [sym_identifier] = ACTIONS(3673),
    [aux_sym_preproc_def_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token1] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3673),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3673),
    [sym_preproc_directive] = ACTIONS(3673),
    [anon_sym_LPAREN2] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3673),
    [anon_sym_SEMI] = ACTIONS(3675),
    [anon_sym___extension__] = ACTIONS(3673),
    [anon_sym_typedef] = ACTIONS(3673),
    [anon_sym_in] = ACTIONS(3673),
    [anon_sym_out] = ACTIONS(3673),
    [anon_sym_inout] = ACTIONS(3673),
    [anon_sym_virtual] = ACTIONS(3673),
    [anon_sym_extern] = ACTIONS(3673),
    [anon_sym___attribute__] = ACTIONS(3673),
    [anon_sym___attribute] = ACTIONS(3673),
    [anon_sym_using] = ACTIONS(3673),
    [anon_sym_COLON_COLON] = ACTIONS(3675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3675),
    [anon_sym___declspec] = ACTIONS(3673),
    [anon_sym___based] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(3675),
    [anon_sym_signed] = ACTIONS(3673),
    [anon_sym_unsigned] = ACTIONS(3673),
    [anon_sym_long] = ACTIONS(3673),
    [anon_sym_short] = ACTIONS(3673),
    [anon_sym_LBRACK] = ACTIONS(3673),
    [anon_sym_static] = ACTIONS(3673),
    [anon_sym_register] = ACTIONS(3673),
    [anon_sym_inline] = ACTIONS(3673),
    [anon_sym___inline] = ACTIONS(3673),
    [anon_sym___inline__] = ACTIONS(3673),
    [anon_sym___forceinline] = ACTIONS(3673),
    [anon_sym_thread_local] = ACTIONS(3673),
    [anon_sym___thread] = ACTIONS(3673),
    [anon_sym_const] = ACTIONS(3673),
    [anon_sym_constexpr] = ACTIONS(3673),
    [anon_sym_volatile] = ACTIONS(3673),
    [anon_sym_restrict] = ACTIONS(3673),
    [anon_sym___restrict__] = ACTIONS(3673),
    [anon_sym__Atomic] = ACTIONS(3673),
    [anon_sym__Noreturn] = ACTIONS(3673),
    [anon_sym_noreturn] = ACTIONS(3673),
    [anon_sym__Nonnull] = ACTIONS(3673),
    [anon_sym_mutable] = ACTIONS(3673),
    [anon_sym_constinit] = ACTIONS(3673),
    [anon_sym_consteval] = ACTIONS(3673),
    [anon_sym_alignas] = ACTIONS(3673),
    [anon_sym__Alignas] = ACTIONS(3673),
    [sym_primitive_type] = ACTIONS(3673),
    [anon_sym_enum] = ACTIONS(3673),
    [anon_sym_class] = ACTIONS(3673),
    [anon_sym_struct] = ACTIONS(3673),
    [anon_sym_union] = ACTIONS(3673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3673),
    [anon_sym_let] = ACTIONS(3673),
    [anon_sym_This] = ACTIONS(3673),
    [anon_sym_decltype] = ACTIONS(3673),
    [anon_sym_explicit] = ACTIONS(3673),
    [anon_sym_typename] = ACTIONS(3673),
    [anon_sym_private] = ACTIONS(3673),
    [anon_sym_template] = ACTIONS(3673),
    [anon_sym_operator] = ACTIONS(3673),
    [anon_sym_friend] = ACTIONS(3673),
    [anon_sym_public] = ACTIONS(3673),
    [anon_sym_protected] = ACTIONS(3673),
    [anon_sym_static_assert] = ACTIONS(3673),
    [anon_sym_precise] = ACTIONS(3673),
    [anon_sym_shared] = ACTIONS(3673),
    [anon_sym_groupshared] = ACTIONS(3673),
    [anon_sym_uniform] = ACTIONS(3673),
    [anon_sym_row_major] = ACTIONS(3673),
    [anon_sym_column_major] = ACTIONS(3673),
    [anon_sym_globallycoherent] = ACTIONS(3673),
    [anon_sym_centroid] = ACTIONS(3673),
    [anon_sym_noperspective] = ACTIONS(3673),
    [anon_sym_nointerpolation] = ACTIONS(3673),
    [anon_sym_sample] = ACTIONS(3673),
    [anon_sym_linear] = ACTIONS(3673),
    [anon_sym_snorm] = ACTIONS(3673),
    [anon_sym_unorm] = ACTIONS(3673),
    [anon_sym_point] = ACTIONS(3673),
    [anon_sym_line] = ACTIONS(3673),
    [anon_sym_triangleadj] = ACTIONS(3673),
    [anon_sym_lineadj] = ACTIONS(3673),
    [anon_sym_triangle] = ACTIONS(3673),
    [anon_sym_interface] = ACTIONS(3673),
    [anon_sym_extension] = ACTIONS(3673),
    [anon_sym___init] = ACTIONS(3673),
    [anon_sym___subscript] = ACTIONS(3673),
    [anon_sym_property] = ACTIONS(3673),
    [anon_sym_associatedtype] = ACTIONS(3673),
  },
  [2287] = {
    [sym_identifier] = ACTIONS(6214),
    [aux_sym_preproc_def_token1] = ACTIONS(6214),
    [aux_sym_preproc_if_token1] = ACTIONS(6214),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6214),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6214),
    [sym_preproc_directive] = ACTIONS(6214),
    [anon_sym_LPAREN2] = ACTIONS(6216),
    [anon_sym_TILDE] = ACTIONS(6216),
    [anon_sym_STAR] = ACTIONS(6216),
    [anon_sym_AMP_AMP] = ACTIONS(6216),
    [anon_sym_AMP] = ACTIONS(6214),
    [anon_sym_SEMI] = ACTIONS(6216),
    [anon_sym___extension__] = ACTIONS(6214),
    [anon_sym_typedef] = ACTIONS(6214),
    [anon_sym_in] = ACTIONS(6214),
    [anon_sym_out] = ACTIONS(6214),
    [anon_sym_inout] = ACTIONS(6214),
    [anon_sym_virtual] = ACTIONS(6214),
    [anon_sym_extern] = ACTIONS(6214),
    [anon_sym___attribute__] = ACTIONS(6214),
    [anon_sym___attribute] = ACTIONS(6214),
    [anon_sym_using] = ACTIONS(6214),
    [anon_sym_COLON_COLON] = ACTIONS(6216),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6216),
    [anon_sym___declspec] = ACTIONS(6214),
    [anon_sym___based] = ACTIONS(6214),
    [anon_sym_RBRACE] = ACTIONS(6216),
    [anon_sym_signed] = ACTIONS(6214),
    [anon_sym_unsigned] = ACTIONS(6214),
    [anon_sym_long] = ACTIONS(6214),
    [anon_sym_short] = ACTIONS(6214),
    [anon_sym_LBRACK] = ACTIONS(6214),
    [anon_sym_static] = ACTIONS(6214),
    [anon_sym_register] = ACTIONS(6214),
    [anon_sym_inline] = ACTIONS(6214),
    [anon_sym___inline] = ACTIONS(6214),
    [anon_sym___inline__] = ACTIONS(6214),
    [anon_sym___forceinline] = ACTIONS(6214),
    [anon_sym_thread_local] = ACTIONS(6214),
    [anon_sym___thread] = ACTIONS(6214),
    [anon_sym_const] = ACTIONS(6214),
    [anon_sym_constexpr] = ACTIONS(6214),
    [anon_sym_volatile] = ACTIONS(6214),
    [anon_sym_restrict] = ACTIONS(6214),
    [anon_sym___restrict__] = ACTIONS(6214),
    [anon_sym__Atomic] = ACTIONS(6214),
    [anon_sym__Noreturn] = ACTIONS(6214),
    [anon_sym_noreturn] = ACTIONS(6214),
    [anon_sym__Nonnull] = ACTIONS(6214),
    [anon_sym_mutable] = ACTIONS(6214),
    [anon_sym_constinit] = ACTIONS(6214),
    [anon_sym_consteval] = ACTIONS(6214),
    [anon_sym_alignas] = ACTIONS(6214),
    [anon_sym__Alignas] = ACTIONS(6214),
    [sym_primitive_type] = ACTIONS(6214),
    [anon_sym_enum] = ACTIONS(6214),
    [anon_sym_class] = ACTIONS(6214),
    [anon_sym_struct] = ACTIONS(6214),
    [anon_sym_union] = ACTIONS(6214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6214),
    [anon_sym_let] = ACTIONS(6214),
    [anon_sym_This] = ACTIONS(6214),
    [anon_sym_decltype] = ACTIONS(6214),
    [anon_sym_explicit] = ACTIONS(6214),
    [anon_sym_typename] = ACTIONS(6214),
    [anon_sym_private] = ACTIONS(6214),
    [anon_sym_template] = ACTIONS(6214),
    [anon_sym_operator] = ACTIONS(6214),
    [anon_sym_friend] = ACTIONS(6214),
    [anon_sym_public] = ACTIONS(6214),
    [anon_sym_protected] = ACTIONS(6214),
    [anon_sym_static_assert] = ACTIONS(6214),
    [anon_sym_precise] = ACTIONS(6214),
    [anon_sym_shared] = ACTIONS(6214),
    [anon_sym_groupshared] = ACTIONS(6214),
    [anon_sym_uniform] = ACTIONS(6214),
    [anon_sym_row_major] = ACTIONS(6214),
    [anon_sym_column_major] = ACTIONS(6214),
    [anon_sym_globallycoherent] = ACTIONS(6214),
    [anon_sym_centroid] = ACTIONS(6214),
    [anon_sym_noperspective] = ACTIONS(6214),
    [anon_sym_nointerpolation] = ACTIONS(6214),
    [anon_sym_sample] = ACTIONS(6214),
    [anon_sym_linear] = ACTIONS(6214),
    [anon_sym_snorm] = ACTIONS(6214),
    [anon_sym_unorm] = ACTIONS(6214),
    [anon_sym_point] = ACTIONS(6214),
    [anon_sym_line] = ACTIONS(6214),
    [anon_sym_triangleadj] = ACTIONS(6214),
    [anon_sym_lineadj] = ACTIONS(6214),
    [anon_sym_triangle] = ACTIONS(6214),
    [anon_sym_interface] = ACTIONS(6214),
    [anon_sym_extension] = ACTIONS(6214),
    [anon_sym___init] = ACTIONS(6214),
    [anon_sym___subscript] = ACTIONS(6214),
    [anon_sym_property] = ACTIONS(6214),
    [anon_sym_associatedtype] = ACTIONS(6214),
  },
  [2288] = {
    [sym_expression] = STATE(4809),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2289] = {
    [sym_expression] = STATE(5780),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2290] = {
    [sym_expression] = STATE(4812),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(6682),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2291] = {
    [sym_expression] = STATE(6002),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2292] = {
    [sym_identifier] = ACTIONS(3452),
    [aux_sym_preproc_def_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token2] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3452),
    [sym_preproc_directive] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(3450),
    [anon_sym_TILDE] = ACTIONS(3450),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_AMP_AMP] = ACTIONS(3450),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym___extension__] = ACTIONS(3452),
    [anon_sym_typedef] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_out] = ACTIONS(3452),
    [anon_sym_inout] = ACTIONS(3452),
    [anon_sym_virtual] = ACTIONS(3452),
    [anon_sym_extern] = ACTIONS(3452),
    [anon_sym___attribute__] = ACTIONS(3452),
    [anon_sym___attribute] = ACTIONS(3452),
    [anon_sym_using] = ACTIONS(3452),
    [anon_sym_COLON_COLON] = ACTIONS(3450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3450),
    [anon_sym___declspec] = ACTIONS(3452),
    [anon_sym___based] = ACTIONS(3452),
    [anon_sym_signed] = ACTIONS(3452),
    [anon_sym_unsigned] = ACTIONS(3452),
    [anon_sym_long] = ACTIONS(3452),
    [anon_sym_short] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3452),
    [anon_sym_static] = ACTIONS(3452),
    [anon_sym_register] = ACTIONS(3452),
    [anon_sym_inline] = ACTIONS(3452),
    [anon_sym___inline] = ACTIONS(3452),
    [anon_sym___inline__] = ACTIONS(3452),
    [anon_sym___forceinline] = ACTIONS(3452),
    [anon_sym_thread_local] = ACTIONS(3452),
    [anon_sym___thread] = ACTIONS(3452),
    [anon_sym_const] = ACTIONS(3452),
    [anon_sym_constexpr] = ACTIONS(3452),
    [anon_sym_volatile] = ACTIONS(3452),
    [anon_sym_restrict] = ACTIONS(3452),
    [anon_sym___restrict__] = ACTIONS(3452),
    [anon_sym__Atomic] = ACTIONS(3452),
    [anon_sym__Noreturn] = ACTIONS(3452),
    [anon_sym_noreturn] = ACTIONS(3452),
    [anon_sym__Nonnull] = ACTIONS(3452),
    [anon_sym_mutable] = ACTIONS(3452),
    [anon_sym_constinit] = ACTIONS(3452),
    [anon_sym_consteval] = ACTIONS(3452),
    [anon_sym_alignas] = ACTIONS(3452),
    [anon_sym__Alignas] = ACTIONS(3452),
    [sym_primitive_type] = ACTIONS(3452),
    [anon_sym_enum] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(3452),
    [anon_sym_union] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3452),
    [anon_sym_let] = ACTIONS(3452),
    [anon_sym_This] = ACTIONS(3452),
    [anon_sym_decltype] = ACTIONS(3452),
    [anon_sym_explicit] = ACTIONS(3452),
    [anon_sym_typename] = ACTIONS(3452),
    [anon_sym_private] = ACTIONS(3452),
    [anon_sym_template] = ACTIONS(3452),
    [anon_sym_operator] = ACTIONS(3452),
    [anon_sym_friend] = ACTIONS(3452),
    [anon_sym_public] = ACTIONS(3452),
    [anon_sym_protected] = ACTIONS(3452),
    [anon_sym_static_assert] = ACTIONS(3452),
    [anon_sym_precise] = ACTIONS(3452),
    [anon_sym_shared] = ACTIONS(3452),
    [anon_sym_groupshared] = ACTIONS(3452),
    [anon_sym_uniform] = ACTIONS(3452),
    [anon_sym_row_major] = ACTIONS(3452),
    [anon_sym_column_major] = ACTIONS(3452),
    [anon_sym_globallycoherent] = ACTIONS(3452),
    [anon_sym_centroid] = ACTIONS(3452),
    [anon_sym_noperspective] = ACTIONS(3452),
    [anon_sym_nointerpolation] = ACTIONS(3452),
    [anon_sym_sample] = ACTIONS(3452),
    [anon_sym_linear] = ACTIONS(3452),
    [anon_sym_snorm] = ACTIONS(3452),
    [anon_sym_unorm] = ACTIONS(3452),
    [anon_sym_point] = ACTIONS(3452),
    [anon_sym_line] = ACTIONS(3452),
    [anon_sym_triangleadj] = ACTIONS(3452),
    [anon_sym_lineadj] = ACTIONS(3452),
    [anon_sym_triangle] = ACTIONS(3452),
    [anon_sym_interface] = ACTIONS(3452),
    [anon_sym_extension] = ACTIONS(3452),
    [anon_sym___init] = ACTIONS(3452),
    [anon_sym___subscript] = ACTIONS(3452),
    [anon_sym_property] = ACTIONS(3452),
    [anon_sym_associatedtype] = ACTIONS(3452),
  },
  [2293] = {
    [sym_identifier] = ACTIONS(3452),
    [aux_sym_preproc_def_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token2] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3452),
    [sym_preproc_directive] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(3450),
    [anon_sym_TILDE] = ACTIONS(3450),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_AMP_AMP] = ACTIONS(3450),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym___extension__] = ACTIONS(3452),
    [anon_sym_typedef] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_out] = ACTIONS(3452),
    [anon_sym_inout] = ACTIONS(3452),
    [anon_sym_virtual] = ACTIONS(3452),
    [anon_sym_extern] = ACTIONS(3452),
    [anon_sym___attribute__] = ACTIONS(3452),
    [anon_sym___attribute] = ACTIONS(3452),
    [anon_sym_using] = ACTIONS(3452),
    [anon_sym_COLON_COLON] = ACTIONS(3450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3450),
    [anon_sym___declspec] = ACTIONS(3452),
    [anon_sym___based] = ACTIONS(3452),
    [anon_sym_signed] = ACTIONS(3452),
    [anon_sym_unsigned] = ACTIONS(3452),
    [anon_sym_long] = ACTIONS(3452),
    [anon_sym_short] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3452),
    [anon_sym_static] = ACTIONS(3452),
    [anon_sym_register] = ACTIONS(3452),
    [anon_sym_inline] = ACTIONS(3452),
    [anon_sym___inline] = ACTIONS(3452),
    [anon_sym___inline__] = ACTIONS(3452),
    [anon_sym___forceinline] = ACTIONS(3452),
    [anon_sym_thread_local] = ACTIONS(3452),
    [anon_sym___thread] = ACTIONS(3452),
    [anon_sym_const] = ACTIONS(3452),
    [anon_sym_constexpr] = ACTIONS(3452),
    [anon_sym_volatile] = ACTIONS(3452),
    [anon_sym_restrict] = ACTIONS(3452),
    [anon_sym___restrict__] = ACTIONS(3452),
    [anon_sym__Atomic] = ACTIONS(3452),
    [anon_sym__Noreturn] = ACTIONS(3452),
    [anon_sym_noreturn] = ACTIONS(3452),
    [anon_sym__Nonnull] = ACTIONS(3452),
    [anon_sym_mutable] = ACTIONS(3452),
    [anon_sym_constinit] = ACTIONS(3452),
    [anon_sym_consteval] = ACTIONS(3452),
    [anon_sym_alignas] = ACTIONS(3452),
    [anon_sym__Alignas] = ACTIONS(3452),
    [sym_primitive_type] = ACTIONS(3452),
    [anon_sym_enum] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(3452),
    [anon_sym_union] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3452),
    [anon_sym_let] = ACTIONS(3452),
    [anon_sym_This] = ACTIONS(3452),
    [anon_sym_decltype] = ACTIONS(3452),
    [anon_sym_explicit] = ACTIONS(3452),
    [anon_sym_typename] = ACTIONS(3452),
    [anon_sym_private] = ACTIONS(3452),
    [anon_sym_template] = ACTIONS(3452),
    [anon_sym_operator] = ACTIONS(3452),
    [anon_sym_friend] = ACTIONS(3452),
    [anon_sym_public] = ACTIONS(3452),
    [anon_sym_protected] = ACTIONS(3452),
    [anon_sym_static_assert] = ACTIONS(3452),
    [anon_sym_precise] = ACTIONS(3452),
    [anon_sym_shared] = ACTIONS(3452),
    [anon_sym_groupshared] = ACTIONS(3452),
    [anon_sym_uniform] = ACTIONS(3452),
    [anon_sym_row_major] = ACTIONS(3452),
    [anon_sym_column_major] = ACTIONS(3452),
    [anon_sym_globallycoherent] = ACTIONS(3452),
    [anon_sym_centroid] = ACTIONS(3452),
    [anon_sym_noperspective] = ACTIONS(3452),
    [anon_sym_nointerpolation] = ACTIONS(3452),
    [anon_sym_sample] = ACTIONS(3452),
    [anon_sym_linear] = ACTIONS(3452),
    [anon_sym_snorm] = ACTIONS(3452),
    [anon_sym_unorm] = ACTIONS(3452),
    [anon_sym_point] = ACTIONS(3452),
    [anon_sym_line] = ACTIONS(3452),
    [anon_sym_triangleadj] = ACTIONS(3452),
    [anon_sym_lineadj] = ACTIONS(3452),
    [anon_sym_triangle] = ACTIONS(3452),
    [anon_sym_interface] = ACTIONS(3452),
    [anon_sym_extension] = ACTIONS(3452),
    [anon_sym___init] = ACTIONS(3452),
    [anon_sym___subscript] = ACTIONS(3452),
    [anon_sym_property] = ACTIONS(3452),
    [anon_sym_associatedtype] = ACTIONS(3452),
  },
  [2294] = {
    [sym_identifier] = ACTIONS(3452),
    [aux_sym_preproc_def_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token1] = ACTIONS(3452),
    [aux_sym_preproc_if_token2] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3452),
    [sym_preproc_directive] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(3450),
    [anon_sym_TILDE] = ACTIONS(3450),
    [anon_sym_STAR] = ACTIONS(3450),
    [anon_sym_AMP_AMP] = ACTIONS(3450),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym___extension__] = ACTIONS(3452),
    [anon_sym_typedef] = ACTIONS(3452),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_out] = ACTIONS(3452),
    [anon_sym_inout] = ACTIONS(3452),
    [anon_sym_virtual] = ACTIONS(3452),
    [anon_sym_extern] = ACTIONS(3452),
    [anon_sym___attribute__] = ACTIONS(3452),
    [anon_sym___attribute] = ACTIONS(3452),
    [anon_sym_using] = ACTIONS(3452),
    [anon_sym_COLON_COLON] = ACTIONS(3450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3450),
    [anon_sym___declspec] = ACTIONS(3452),
    [anon_sym___based] = ACTIONS(3452),
    [anon_sym_signed] = ACTIONS(3452),
    [anon_sym_unsigned] = ACTIONS(3452),
    [anon_sym_long] = ACTIONS(3452),
    [anon_sym_short] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3452),
    [anon_sym_static] = ACTIONS(3452),
    [anon_sym_register] = ACTIONS(3452),
    [anon_sym_inline] = ACTIONS(3452),
    [anon_sym___inline] = ACTIONS(3452),
    [anon_sym___inline__] = ACTIONS(3452),
    [anon_sym___forceinline] = ACTIONS(3452),
    [anon_sym_thread_local] = ACTIONS(3452),
    [anon_sym___thread] = ACTIONS(3452),
    [anon_sym_const] = ACTIONS(3452),
    [anon_sym_constexpr] = ACTIONS(3452),
    [anon_sym_volatile] = ACTIONS(3452),
    [anon_sym_restrict] = ACTIONS(3452),
    [anon_sym___restrict__] = ACTIONS(3452),
    [anon_sym__Atomic] = ACTIONS(3452),
    [anon_sym__Noreturn] = ACTIONS(3452),
    [anon_sym_noreturn] = ACTIONS(3452),
    [anon_sym__Nonnull] = ACTIONS(3452),
    [anon_sym_mutable] = ACTIONS(3452),
    [anon_sym_constinit] = ACTIONS(3452),
    [anon_sym_consteval] = ACTIONS(3452),
    [anon_sym_alignas] = ACTIONS(3452),
    [anon_sym__Alignas] = ACTIONS(3452),
    [sym_primitive_type] = ACTIONS(3452),
    [anon_sym_enum] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(3452),
    [anon_sym_struct] = ACTIONS(3452),
    [anon_sym_union] = ACTIONS(3452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3452),
    [anon_sym_let] = ACTIONS(3452),
    [anon_sym_This] = ACTIONS(3452),
    [anon_sym_decltype] = ACTIONS(3452),
    [anon_sym_explicit] = ACTIONS(3452),
    [anon_sym_typename] = ACTIONS(3452),
    [anon_sym_private] = ACTIONS(3452),
    [anon_sym_template] = ACTIONS(3452),
    [anon_sym_operator] = ACTIONS(3452),
    [anon_sym_friend] = ACTIONS(3452),
    [anon_sym_public] = ACTIONS(3452),
    [anon_sym_protected] = ACTIONS(3452),
    [anon_sym_static_assert] = ACTIONS(3452),
    [anon_sym_precise] = ACTIONS(3452),
    [anon_sym_shared] = ACTIONS(3452),
    [anon_sym_groupshared] = ACTIONS(3452),
    [anon_sym_uniform] = ACTIONS(3452),
    [anon_sym_row_major] = ACTIONS(3452),
    [anon_sym_column_major] = ACTIONS(3452),
    [anon_sym_globallycoherent] = ACTIONS(3452),
    [anon_sym_centroid] = ACTIONS(3452),
    [anon_sym_noperspective] = ACTIONS(3452),
    [anon_sym_nointerpolation] = ACTIONS(3452),
    [anon_sym_sample] = ACTIONS(3452),
    [anon_sym_linear] = ACTIONS(3452),
    [anon_sym_snorm] = ACTIONS(3452),
    [anon_sym_unorm] = ACTIONS(3452),
    [anon_sym_point] = ACTIONS(3452),
    [anon_sym_line] = ACTIONS(3452),
    [anon_sym_triangleadj] = ACTIONS(3452),
    [anon_sym_lineadj] = ACTIONS(3452),
    [anon_sym_triangle] = ACTIONS(3452),
    [anon_sym_interface] = ACTIONS(3452),
    [anon_sym_extension] = ACTIONS(3452),
    [anon_sym___init] = ACTIONS(3452),
    [anon_sym___subscript] = ACTIONS(3452),
    [anon_sym_property] = ACTIONS(3452),
    [anon_sym_associatedtype] = ACTIONS(3452),
  },
  [2295] = {
    [sym_identifier] = ACTIONS(3460),
    [aux_sym_preproc_def_token1] = ACTIONS(3460),
    [aux_sym_preproc_if_token1] = ACTIONS(3460),
    [aux_sym_preproc_if_token2] = ACTIONS(3460),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3460),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3460),
    [sym_preproc_directive] = ACTIONS(3460),
    [anon_sym_LPAREN2] = ACTIONS(3458),
    [anon_sym_TILDE] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3458),
    [anon_sym_AMP_AMP] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3460),
    [anon_sym_SEMI] = ACTIONS(3458),
    [anon_sym___extension__] = ACTIONS(3460),
    [anon_sym_typedef] = ACTIONS(3460),
    [anon_sym_in] = ACTIONS(3460),
    [anon_sym_out] = ACTIONS(3460),
    [anon_sym_inout] = ACTIONS(3460),
    [anon_sym_virtual] = ACTIONS(3460),
    [anon_sym_extern] = ACTIONS(3460),
    [anon_sym___attribute__] = ACTIONS(3460),
    [anon_sym___attribute] = ACTIONS(3460),
    [anon_sym_using] = ACTIONS(3460),
    [anon_sym_COLON_COLON] = ACTIONS(3458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3458),
    [anon_sym___declspec] = ACTIONS(3460),
    [anon_sym___based] = ACTIONS(3460),
    [anon_sym_signed] = ACTIONS(3460),
    [anon_sym_unsigned] = ACTIONS(3460),
    [anon_sym_long] = ACTIONS(3460),
    [anon_sym_short] = ACTIONS(3460),
    [anon_sym_LBRACK] = ACTIONS(3460),
    [anon_sym_static] = ACTIONS(3460),
    [anon_sym_register] = ACTIONS(3460),
    [anon_sym_inline] = ACTIONS(3460),
    [anon_sym___inline] = ACTIONS(3460),
    [anon_sym___inline__] = ACTIONS(3460),
    [anon_sym___forceinline] = ACTIONS(3460),
    [anon_sym_thread_local] = ACTIONS(3460),
    [anon_sym___thread] = ACTIONS(3460),
    [anon_sym_const] = ACTIONS(3460),
    [anon_sym_constexpr] = ACTIONS(3460),
    [anon_sym_volatile] = ACTIONS(3460),
    [anon_sym_restrict] = ACTIONS(3460),
    [anon_sym___restrict__] = ACTIONS(3460),
    [anon_sym__Atomic] = ACTIONS(3460),
    [anon_sym__Noreturn] = ACTIONS(3460),
    [anon_sym_noreturn] = ACTIONS(3460),
    [anon_sym__Nonnull] = ACTIONS(3460),
    [anon_sym_mutable] = ACTIONS(3460),
    [anon_sym_constinit] = ACTIONS(3460),
    [anon_sym_consteval] = ACTIONS(3460),
    [anon_sym_alignas] = ACTIONS(3460),
    [anon_sym__Alignas] = ACTIONS(3460),
    [sym_primitive_type] = ACTIONS(3460),
    [anon_sym_enum] = ACTIONS(3460),
    [anon_sym_class] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(3460),
    [anon_sym_union] = ACTIONS(3460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3460),
    [anon_sym_let] = ACTIONS(3460),
    [anon_sym_This] = ACTIONS(3460),
    [anon_sym_decltype] = ACTIONS(3460),
    [anon_sym_explicit] = ACTIONS(3460),
    [anon_sym_typename] = ACTIONS(3460),
    [anon_sym_private] = ACTIONS(3460),
    [anon_sym_template] = ACTIONS(3460),
    [anon_sym_operator] = ACTIONS(3460),
    [anon_sym_friend] = ACTIONS(3460),
    [anon_sym_public] = ACTIONS(3460),
    [anon_sym_protected] = ACTIONS(3460),
    [anon_sym_static_assert] = ACTIONS(3460),
    [anon_sym_precise] = ACTIONS(3460),
    [anon_sym_shared] = ACTIONS(3460),
    [anon_sym_groupshared] = ACTIONS(3460),
    [anon_sym_uniform] = ACTIONS(3460),
    [anon_sym_row_major] = ACTIONS(3460),
    [anon_sym_column_major] = ACTIONS(3460),
    [anon_sym_globallycoherent] = ACTIONS(3460),
    [anon_sym_centroid] = ACTIONS(3460),
    [anon_sym_noperspective] = ACTIONS(3460),
    [anon_sym_nointerpolation] = ACTIONS(3460),
    [anon_sym_sample] = ACTIONS(3460),
    [anon_sym_linear] = ACTIONS(3460),
    [anon_sym_snorm] = ACTIONS(3460),
    [anon_sym_unorm] = ACTIONS(3460),
    [anon_sym_point] = ACTIONS(3460),
    [anon_sym_line] = ACTIONS(3460),
    [anon_sym_triangleadj] = ACTIONS(3460),
    [anon_sym_lineadj] = ACTIONS(3460),
    [anon_sym_triangle] = ACTIONS(3460),
    [anon_sym_interface] = ACTIONS(3460),
    [anon_sym_extension] = ACTIONS(3460),
    [anon_sym___init] = ACTIONS(3460),
    [anon_sym___subscript] = ACTIONS(3460),
    [anon_sym_property] = ACTIONS(3460),
    [anon_sym_associatedtype] = ACTIONS(3460),
  },
  [2296] = {
    [sym_identifier] = ACTIONS(3562),
    [aux_sym_preproc_def_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token2] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3562),
    [sym_preproc_directive] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym___extension__] = ACTIONS(3562),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_in] = ACTIONS(3562),
    [anon_sym_out] = ACTIONS(3562),
    [anon_sym_inout] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym___attribute__] = ACTIONS(3562),
    [anon_sym___attribute] = ACTIONS(3562),
    [anon_sym_using] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3560),
    [anon_sym___declspec] = ACTIONS(3562),
    [anon_sym___based] = ACTIONS(3562),
    [anon_sym_signed] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym___inline] = ACTIONS(3562),
    [anon_sym___inline__] = ACTIONS(3562),
    [anon_sym___forceinline] = ACTIONS(3562),
    [anon_sym_thread_local] = ACTIONS(3562),
    [anon_sym___thread] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_constexpr] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym___restrict__] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym__Noreturn] = ACTIONS(3562),
    [anon_sym_noreturn] = ACTIONS(3562),
    [anon_sym__Nonnull] = ACTIONS(3562),
    [anon_sym_mutable] = ACTIONS(3562),
    [anon_sym_constinit] = ACTIONS(3562),
    [anon_sym_consteval] = ACTIONS(3562),
    [anon_sym_alignas] = ACTIONS(3562),
    [anon_sym__Alignas] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_This] = ACTIONS(3562),
    [anon_sym_decltype] = ACTIONS(3562),
    [anon_sym_explicit] = ACTIONS(3562),
    [anon_sym_typename] = ACTIONS(3562),
    [anon_sym_private] = ACTIONS(3562),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(3562),
    [anon_sym_friend] = ACTIONS(3562),
    [anon_sym_public] = ACTIONS(3562),
    [anon_sym_protected] = ACTIONS(3562),
    [anon_sym_static_assert] = ACTIONS(3562),
    [anon_sym_precise] = ACTIONS(3562),
    [anon_sym_shared] = ACTIONS(3562),
    [anon_sym_groupshared] = ACTIONS(3562),
    [anon_sym_uniform] = ACTIONS(3562),
    [anon_sym_row_major] = ACTIONS(3562),
    [anon_sym_column_major] = ACTIONS(3562),
    [anon_sym_globallycoherent] = ACTIONS(3562),
    [anon_sym_centroid] = ACTIONS(3562),
    [anon_sym_noperspective] = ACTIONS(3562),
    [anon_sym_nointerpolation] = ACTIONS(3562),
    [anon_sym_sample] = ACTIONS(3562),
    [anon_sym_linear] = ACTIONS(3562),
    [anon_sym_snorm] = ACTIONS(3562),
    [anon_sym_unorm] = ACTIONS(3562),
    [anon_sym_point] = ACTIONS(3562),
    [anon_sym_line] = ACTIONS(3562),
    [anon_sym_triangleadj] = ACTIONS(3562),
    [anon_sym_lineadj] = ACTIONS(3562),
    [anon_sym_triangle] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_extension] = ACTIONS(3562),
    [anon_sym___init] = ACTIONS(3562),
    [anon_sym___subscript] = ACTIONS(3562),
    [anon_sym_property] = ACTIONS(3562),
    [anon_sym_associatedtype] = ACTIONS(3562),
  },
  [2297] = {
    [sym_identifier] = ACTIONS(3562),
    [aux_sym_preproc_def_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token2] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3562),
    [sym_preproc_directive] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym___extension__] = ACTIONS(3562),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_in] = ACTIONS(3562),
    [anon_sym_out] = ACTIONS(3562),
    [anon_sym_inout] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym___attribute__] = ACTIONS(3562),
    [anon_sym___attribute] = ACTIONS(3562),
    [anon_sym_using] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3560),
    [anon_sym___declspec] = ACTIONS(3562),
    [anon_sym___based] = ACTIONS(3562),
    [anon_sym_signed] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym___inline] = ACTIONS(3562),
    [anon_sym___inline__] = ACTIONS(3562),
    [anon_sym___forceinline] = ACTIONS(3562),
    [anon_sym_thread_local] = ACTIONS(3562),
    [anon_sym___thread] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_constexpr] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym___restrict__] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym__Noreturn] = ACTIONS(3562),
    [anon_sym_noreturn] = ACTIONS(3562),
    [anon_sym__Nonnull] = ACTIONS(3562),
    [anon_sym_mutable] = ACTIONS(3562),
    [anon_sym_constinit] = ACTIONS(3562),
    [anon_sym_consteval] = ACTIONS(3562),
    [anon_sym_alignas] = ACTIONS(3562),
    [anon_sym__Alignas] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_This] = ACTIONS(3562),
    [anon_sym_decltype] = ACTIONS(3562),
    [anon_sym_explicit] = ACTIONS(3562),
    [anon_sym_typename] = ACTIONS(3562),
    [anon_sym_private] = ACTIONS(3562),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(3562),
    [anon_sym_friend] = ACTIONS(3562),
    [anon_sym_public] = ACTIONS(3562),
    [anon_sym_protected] = ACTIONS(3562),
    [anon_sym_static_assert] = ACTIONS(3562),
    [anon_sym_precise] = ACTIONS(3562),
    [anon_sym_shared] = ACTIONS(3562),
    [anon_sym_groupshared] = ACTIONS(3562),
    [anon_sym_uniform] = ACTIONS(3562),
    [anon_sym_row_major] = ACTIONS(3562),
    [anon_sym_column_major] = ACTIONS(3562),
    [anon_sym_globallycoherent] = ACTIONS(3562),
    [anon_sym_centroid] = ACTIONS(3562),
    [anon_sym_noperspective] = ACTIONS(3562),
    [anon_sym_nointerpolation] = ACTIONS(3562),
    [anon_sym_sample] = ACTIONS(3562),
    [anon_sym_linear] = ACTIONS(3562),
    [anon_sym_snorm] = ACTIONS(3562),
    [anon_sym_unorm] = ACTIONS(3562),
    [anon_sym_point] = ACTIONS(3562),
    [anon_sym_line] = ACTIONS(3562),
    [anon_sym_triangleadj] = ACTIONS(3562),
    [anon_sym_lineadj] = ACTIONS(3562),
    [anon_sym_triangle] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_extension] = ACTIONS(3562),
    [anon_sym___init] = ACTIONS(3562),
    [anon_sym___subscript] = ACTIONS(3562),
    [anon_sym_property] = ACTIONS(3562),
    [anon_sym_associatedtype] = ACTIONS(3562),
  },
  [2298] = {
    [sym_identifier] = ACTIONS(3562),
    [aux_sym_preproc_def_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token1] = ACTIONS(3562),
    [aux_sym_preproc_if_token2] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3562),
    [sym_preproc_directive] = ACTIONS(3562),
    [anon_sym_LPAREN2] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_STAR] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym___extension__] = ACTIONS(3562),
    [anon_sym_typedef] = ACTIONS(3562),
    [anon_sym_in] = ACTIONS(3562),
    [anon_sym_out] = ACTIONS(3562),
    [anon_sym_inout] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym___attribute__] = ACTIONS(3562),
    [anon_sym___attribute] = ACTIONS(3562),
    [anon_sym_using] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3560),
    [anon_sym___declspec] = ACTIONS(3562),
    [anon_sym___based] = ACTIONS(3562),
    [anon_sym_signed] = ACTIONS(3562),
    [anon_sym_unsigned] = ACTIONS(3562),
    [anon_sym_long] = ACTIONS(3562),
    [anon_sym_short] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_register] = ACTIONS(3562),
    [anon_sym_inline] = ACTIONS(3562),
    [anon_sym___inline] = ACTIONS(3562),
    [anon_sym___inline__] = ACTIONS(3562),
    [anon_sym___forceinline] = ACTIONS(3562),
    [anon_sym_thread_local] = ACTIONS(3562),
    [anon_sym___thread] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_constexpr] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_restrict] = ACTIONS(3562),
    [anon_sym___restrict__] = ACTIONS(3562),
    [anon_sym__Atomic] = ACTIONS(3562),
    [anon_sym__Noreturn] = ACTIONS(3562),
    [anon_sym_noreturn] = ACTIONS(3562),
    [anon_sym__Nonnull] = ACTIONS(3562),
    [anon_sym_mutable] = ACTIONS(3562),
    [anon_sym_constinit] = ACTIONS(3562),
    [anon_sym_consteval] = ACTIONS(3562),
    [anon_sym_alignas] = ACTIONS(3562),
    [anon_sym__Alignas] = ACTIONS(3562),
    [sym_primitive_type] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_This] = ACTIONS(3562),
    [anon_sym_decltype] = ACTIONS(3562),
    [anon_sym_explicit] = ACTIONS(3562),
    [anon_sym_typename] = ACTIONS(3562),
    [anon_sym_private] = ACTIONS(3562),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(3562),
    [anon_sym_friend] = ACTIONS(3562),
    [anon_sym_public] = ACTIONS(3562),
    [anon_sym_protected] = ACTIONS(3562),
    [anon_sym_static_assert] = ACTIONS(3562),
    [anon_sym_precise] = ACTIONS(3562),
    [anon_sym_shared] = ACTIONS(3562),
    [anon_sym_groupshared] = ACTIONS(3562),
    [anon_sym_uniform] = ACTIONS(3562),
    [anon_sym_row_major] = ACTIONS(3562),
    [anon_sym_column_major] = ACTIONS(3562),
    [anon_sym_globallycoherent] = ACTIONS(3562),
    [anon_sym_centroid] = ACTIONS(3562),
    [anon_sym_noperspective] = ACTIONS(3562),
    [anon_sym_nointerpolation] = ACTIONS(3562),
    [anon_sym_sample] = ACTIONS(3562),
    [anon_sym_linear] = ACTIONS(3562),
    [anon_sym_snorm] = ACTIONS(3562),
    [anon_sym_unorm] = ACTIONS(3562),
    [anon_sym_point] = ACTIONS(3562),
    [anon_sym_line] = ACTIONS(3562),
    [anon_sym_triangleadj] = ACTIONS(3562),
    [anon_sym_lineadj] = ACTIONS(3562),
    [anon_sym_triangle] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_extension] = ACTIONS(3562),
    [anon_sym___init] = ACTIONS(3562),
    [anon_sym___subscript] = ACTIONS(3562),
    [anon_sym_property] = ACTIONS(3562),
    [anon_sym_associatedtype] = ACTIONS(3562),
  },
  [2299] = {
    [sym_identifier] = ACTIONS(3581),
    [aux_sym_preproc_def_token1] = ACTIONS(3581),
    [aux_sym_preproc_if_token1] = ACTIONS(3581),
    [aux_sym_preproc_if_token2] = ACTIONS(3581),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3581),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3581),
    [sym_preproc_directive] = ACTIONS(3581),
    [anon_sym_LPAREN2] = ACTIONS(3579),
    [anon_sym_TILDE] = ACTIONS(3579),
    [anon_sym_STAR] = ACTIONS(3579),
    [anon_sym_AMP_AMP] = ACTIONS(3579),
    [anon_sym_AMP] = ACTIONS(3581),
    [anon_sym_SEMI] = ACTIONS(3579),
    [anon_sym___extension__] = ACTIONS(3581),
    [anon_sym_typedef] = ACTIONS(3581),
    [anon_sym_in] = ACTIONS(3581),
    [anon_sym_out] = ACTIONS(3581),
    [anon_sym_inout] = ACTIONS(3581),
    [anon_sym_virtual] = ACTIONS(3581),
    [anon_sym_extern] = ACTIONS(3581),
    [anon_sym___attribute__] = ACTIONS(3581),
    [anon_sym___attribute] = ACTIONS(3581),
    [anon_sym_using] = ACTIONS(3581),
    [anon_sym_COLON_COLON] = ACTIONS(3579),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3579),
    [anon_sym___declspec] = ACTIONS(3581),
    [anon_sym___based] = ACTIONS(3581),
    [anon_sym_signed] = ACTIONS(3581),
    [anon_sym_unsigned] = ACTIONS(3581),
    [anon_sym_long] = ACTIONS(3581),
    [anon_sym_short] = ACTIONS(3581),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_static] = ACTIONS(3581),
    [anon_sym_register] = ACTIONS(3581),
    [anon_sym_inline] = ACTIONS(3581),
    [anon_sym___inline] = ACTIONS(3581),
    [anon_sym___inline__] = ACTIONS(3581),
    [anon_sym___forceinline] = ACTIONS(3581),
    [anon_sym_thread_local] = ACTIONS(3581),
    [anon_sym___thread] = ACTIONS(3581),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_constexpr] = ACTIONS(3581),
    [anon_sym_volatile] = ACTIONS(3581),
    [anon_sym_restrict] = ACTIONS(3581),
    [anon_sym___restrict__] = ACTIONS(3581),
    [anon_sym__Atomic] = ACTIONS(3581),
    [anon_sym__Noreturn] = ACTIONS(3581),
    [anon_sym_noreturn] = ACTIONS(3581),
    [anon_sym__Nonnull] = ACTIONS(3581),
    [anon_sym_mutable] = ACTIONS(3581),
    [anon_sym_constinit] = ACTIONS(3581),
    [anon_sym_consteval] = ACTIONS(3581),
    [anon_sym_alignas] = ACTIONS(3581),
    [anon_sym__Alignas] = ACTIONS(3581),
    [sym_primitive_type] = ACTIONS(3581),
    [anon_sym_enum] = ACTIONS(3581),
    [anon_sym_class] = ACTIONS(3581),
    [anon_sym_struct] = ACTIONS(3581),
    [anon_sym_union] = ACTIONS(3581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_This] = ACTIONS(3581),
    [anon_sym_decltype] = ACTIONS(3581),
    [anon_sym_explicit] = ACTIONS(3581),
    [anon_sym_typename] = ACTIONS(3581),
    [anon_sym_private] = ACTIONS(3581),
    [anon_sym_template] = ACTIONS(3581),
    [anon_sym_operator] = ACTIONS(3581),
    [anon_sym_friend] = ACTIONS(3581),
    [anon_sym_public] = ACTIONS(3581),
    [anon_sym_protected] = ACTIONS(3581),
    [anon_sym_static_assert] = ACTIONS(3581),
    [anon_sym_precise] = ACTIONS(3581),
    [anon_sym_shared] = ACTIONS(3581),
    [anon_sym_groupshared] = ACTIONS(3581),
    [anon_sym_uniform] = ACTIONS(3581),
    [anon_sym_row_major] = ACTIONS(3581),
    [anon_sym_column_major] = ACTIONS(3581),
    [anon_sym_globallycoherent] = ACTIONS(3581),
    [anon_sym_centroid] = ACTIONS(3581),
    [anon_sym_noperspective] = ACTIONS(3581),
    [anon_sym_nointerpolation] = ACTIONS(3581),
    [anon_sym_sample] = ACTIONS(3581),
    [anon_sym_linear] = ACTIONS(3581),
    [anon_sym_snorm] = ACTIONS(3581),
    [anon_sym_unorm] = ACTIONS(3581),
    [anon_sym_point] = ACTIONS(3581),
    [anon_sym_line] = ACTIONS(3581),
    [anon_sym_triangleadj] = ACTIONS(3581),
    [anon_sym_lineadj] = ACTIONS(3581),
    [anon_sym_triangle] = ACTIONS(3581),
    [anon_sym_interface] = ACTIONS(3581),
    [anon_sym_extension] = ACTIONS(3581),
    [anon_sym___init] = ACTIONS(3581),
    [anon_sym___subscript] = ACTIONS(3581),
    [anon_sym_property] = ACTIONS(3581),
    [anon_sym_associatedtype] = ACTIONS(3581),
  },
  [2300] = {
    [sym_identifier] = ACTIONS(3591),
    [aux_sym_preproc_def_token1] = ACTIONS(3591),
    [aux_sym_preproc_if_token1] = ACTIONS(3591),
    [aux_sym_preproc_if_token2] = ACTIONS(3591),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3591),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3591),
    [sym_preproc_directive] = ACTIONS(3591),
    [anon_sym_LPAREN2] = ACTIONS(3589),
    [anon_sym_TILDE] = ACTIONS(3589),
    [anon_sym_STAR] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(3589),
    [anon_sym___extension__] = ACTIONS(3591),
    [anon_sym_typedef] = ACTIONS(3591),
    [anon_sym_in] = ACTIONS(3591),
    [anon_sym_out] = ACTIONS(3591),
    [anon_sym_inout] = ACTIONS(3591),
    [anon_sym_virtual] = ACTIONS(3591),
    [anon_sym_extern] = ACTIONS(3591),
    [anon_sym___attribute__] = ACTIONS(3591),
    [anon_sym___attribute] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3591),
    [anon_sym_COLON_COLON] = ACTIONS(3589),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3589),
    [anon_sym___declspec] = ACTIONS(3591),
    [anon_sym___based] = ACTIONS(3591),
    [anon_sym_signed] = ACTIONS(3591),
    [anon_sym_unsigned] = ACTIONS(3591),
    [anon_sym_long] = ACTIONS(3591),
    [anon_sym_short] = ACTIONS(3591),
    [anon_sym_LBRACK] = ACTIONS(3591),
    [anon_sym_static] = ACTIONS(3591),
    [anon_sym_register] = ACTIONS(3591),
    [anon_sym_inline] = ACTIONS(3591),
    [anon_sym___inline] = ACTIONS(3591),
    [anon_sym___inline__] = ACTIONS(3591),
    [anon_sym___forceinline] = ACTIONS(3591),
    [anon_sym_thread_local] = ACTIONS(3591),
    [anon_sym___thread] = ACTIONS(3591),
    [anon_sym_const] = ACTIONS(3591),
    [anon_sym_constexpr] = ACTIONS(3591),
    [anon_sym_volatile] = ACTIONS(3591),
    [anon_sym_restrict] = ACTIONS(3591),
    [anon_sym___restrict__] = ACTIONS(3591),
    [anon_sym__Atomic] = ACTIONS(3591),
    [anon_sym__Noreturn] = ACTIONS(3591),
    [anon_sym_noreturn] = ACTIONS(3591),
    [anon_sym__Nonnull] = ACTIONS(3591),
    [anon_sym_mutable] = ACTIONS(3591),
    [anon_sym_constinit] = ACTIONS(3591),
    [anon_sym_consteval] = ACTIONS(3591),
    [anon_sym_alignas] = ACTIONS(3591),
    [anon_sym__Alignas] = ACTIONS(3591),
    [sym_primitive_type] = ACTIONS(3591),
    [anon_sym_enum] = ACTIONS(3591),
    [anon_sym_class] = ACTIONS(3591),
    [anon_sym_struct] = ACTIONS(3591),
    [anon_sym_union] = ACTIONS(3591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3591),
    [anon_sym_let] = ACTIONS(3591),
    [anon_sym_This] = ACTIONS(3591),
    [anon_sym_decltype] = ACTIONS(3591),
    [anon_sym_explicit] = ACTIONS(3591),
    [anon_sym_typename] = ACTIONS(3591),
    [anon_sym_private] = ACTIONS(3591),
    [anon_sym_template] = ACTIONS(3591),
    [anon_sym_operator] = ACTIONS(3591),
    [anon_sym_friend] = ACTIONS(3591),
    [anon_sym_public] = ACTIONS(3591),
    [anon_sym_protected] = ACTIONS(3591),
    [anon_sym_static_assert] = ACTIONS(3591),
    [anon_sym_precise] = ACTIONS(3591),
    [anon_sym_shared] = ACTIONS(3591),
    [anon_sym_groupshared] = ACTIONS(3591),
    [anon_sym_uniform] = ACTIONS(3591),
    [anon_sym_row_major] = ACTIONS(3591),
    [anon_sym_column_major] = ACTIONS(3591),
    [anon_sym_globallycoherent] = ACTIONS(3591),
    [anon_sym_centroid] = ACTIONS(3591),
    [anon_sym_noperspective] = ACTIONS(3591),
    [anon_sym_nointerpolation] = ACTIONS(3591),
    [anon_sym_sample] = ACTIONS(3591),
    [anon_sym_linear] = ACTIONS(3591),
    [anon_sym_snorm] = ACTIONS(3591),
    [anon_sym_unorm] = ACTIONS(3591),
    [anon_sym_point] = ACTIONS(3591),
    [anon_sym_line] = ACTIONS(3591),
    [anon_sym_triangleadj] = ACTIONS(3591),
    [anon_sym_lineadj] = ACTIONS(3591),
    [anon_sym_triangle] = ACTIONS(3591),
    [anon_sym_interface] = ACTIONS(3591),
    [anon_sym_extension] = ACTIONS(3591),
    [anon_sym___init] = ACTIONS(3591),
    [anon_sym___subscript] = ACTIONS(3591),
    [anon_sym_property] = ACTIONS(3591),
    [anon_sym_associatedtype] = ACTIONS(3591),
  },
  [2301] = {
    [sym_identifier] = ACTIONS(3889),
    [aux_sym_preproc_def_token1] = ACTIONS(3889),
    [aux_sym_preproc_if_token1] = ACTIONS(3889),
    [aux_sym_preproc_if_token2] = ACTIONS(3889),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3889),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3889),
    [sym_preproc_directive] = ACTIONS(3889),
    [anon_sym_LPAREN2] = ACTIONS(3891),
    [anon_sym_TILDE] = ACTIONS(3891),
    [anon_sym_STAR] = ACTIONS(3891),
    [anon_sym_AMP_AMP] = ACTIONS(3891),
    [anon_sym_AMP] = ACTIONS(3889),
    [anon_sym_SEMI] = ACTIONS(3891),
    [anon_sym___extension__] = ACTIONS(3889),
    [anon_sym_typedef] = ACTIONS(3889),
    [anon_sym_in] = ACTIONS(3889),
    [anon_sym_out] = ACTIONS(3889),
    [anon_sym_inout] = ACTIONS(3889),
    [anon_sym_virtual] = ACTIONS(3889),
    [anon_sym_extern] = ACTIONS(3889),
    [anon_sym___attribute__] = ACTIONS(3889),
    [anon_sym___attribute] = ACTIONS(3889),
    [anon_sym_using] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3891),
    [anon_sym___declspec] = ACTIONS(3889),
    [anon_sym___based] = ACTIONS(3889),
    [anon_sym_signed] = ACTIONS(3889),
    [anon_sym_unsigned] = ACTIONS(3889),
    [anon_sym_long] = ACTIONS(3889),
    [anon_sym_short] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [anon_sym_static] = ACTIONS(3889),
    [anon_sym_register] = ACTIONS(3889),
    [anon_sym_inline] = ACTIONS(3889),
    [anon_sym___inline] = ACTIONS(3889),
    [anon_sym___inline__] = ACTIONS(3889),
    [anon_sym___forceinline] = ACTIONS(3889),
    [anon_sym_thread_local] = ACTIONS(3889),
    [anon_sym___thread] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3889),
    [anon_sym_constexpr] = ACTIONS(3889),
    [anon_sym_volatile] = ACTIONS(3889),
    [anon_sym_restrict] = ACTIONS(3889),
    [anon_sym___restrict__] = ACTIONS(3889),
    [anon_sym__Atomic] = ACTIONS(3889),
    [anon_sym__Noreturn] = ACTIONS(3889),
    [anon_sym_noreturn] = ACTIONS(3889),
    [anon_sym__Nonnull] = ACTIONS(3889),
    [anon_sym_mutable] = ACTIONS(3889),
    [anon_sym_constinit] = ACTIONS(3889),
    [anon_sym_consteval] = ACTIONS(3889),
    [anon_sym_alignas] = ACTIONS(3889),
    [anon_sym__Alignas] = ACTIONS(3889),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_enum] = ACTIONS(3889),
    [anon_sym_class] = ACTIONS(3889),
    [anon_sym_struct] = ACTIONS(3889),
    [anon_sym_union] = ACTIONS(3889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_This] = ACTIONS(3889),
    [anon_sym_decltype] = ACTIONS(3889),
    [anon_sym_explicit] = ACTIONS(3889),
    [anon_sym_typename] = ACTIONS(3889),
    [anon_sym_private] = ACTIONS(3889),
    [anon_sym_template] = ACTIONS(3889),
    [anon_sym_operator] = ACTIONS(3889),
    [anon_sym_friend] = ACTIONS(3889),
    [anon_sym_public] = ACTIONS(3889),
    [anon_sym_protected] = ACTIONS(3889),
    [anon_sym_static_assert] = ACTIONS(3889),
    [anon_sym_precise] = ACTIONS(3889),
    [anon_sym_shared] = ACTIONS(3889),
    [anon_sym_groupshared] = ACTIONS(3889),
    [anon_sym_uniform] = ACTIONS(3889),
    [anon_sym_row_major] = ACTIONS(3889),
    [anon_sym_column_major] = ACTIONS(3889),
    [anon_sym_globallycoherent] = ACTIONS(3889),
    [anon_sym_centroid] = ACTIONS(3889),
    [anon_sym_noperspective] = ACTIONS(3889),
    [anon_sym_nointerpolation] = ACTIONS(3889),
    [anon_sym_sample] = ACTIONS(3889),
    [anon_sym_linear] = ACTIONS(3889),
    [anon_sym_snorm] = ACTIONS(3889),
    [anon_sym_unorm] = ACTIONS(3889),
    [anon_sym_point] = ACTIONS(3889),
    [anon_sym_line] = ACTIONS(3889),
    [anon_sym_triangleadj] = ACTIONS(3889),
    [anon_sym_lineadj] = ACTIONS(3889),
    [anon_sym_triangle] = ACTIONS(3889),
    [anon_sym_interface] = ACTIONS(3889),
    [anon_sym_extension] = ACTIONS(3889),
    [anon_sym___init] = ACTIONS(3889),
    [anon_sym___subscript] = ACTIONS(3889),
    [anon_sym_property] = ACTIONS(3889),
    [anon_sym_associatedtype] = ACTIONS(3889),
  },
  [2302] = {
    [sym_identifier] = ACTIONS(3623),
    [aux_sym_preproc_def_token1] = ACTIONS(3623),
    [aux_sym_preproc_if_token1] = ACTIONS(3623),
    [aux_sym_preproc_if_token2] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3623),
    [sym_preproc_directive] = ACTIONS(3623),
    [anon_sym_LPAREN2] = ACTIONS(3621),
    [anon_sym_TILDE] = ACTIONS(3621),
    [anon_sym_STAR] = ACTIONS(3621),
    [anon_sym_AMP_AMP] = ACTIONS(3621),
    [anon_sym_AMP] = ACTIONS(3623),
    [anon_sym_SEMI] = ACTIONS(3621),
    [anon_sym___extension__] = ACTIONS(3623),
    [anon_sym_typedef] = ACTIONS(3623),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_out] = ACTIONS(3623),
    [anon_sym_inout] = ACTIONS(3623),
    [anon_sym_virtual] = ACTIONS(3623),
    [anon_sym_extern] = ACTIONS(3623),
    [anon_sym___attribute__] = ACTIONS(3623),
    [anon_sym___attribute] = ACTIONS(3623),
    [anon_sym_using] = ACTIONS(3623),
    [anon_sym_COLON_COLON] = ACTIONS(3621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3621),
    [anon_sym___declspec] = ACTIONS(3623),
    [anon_sym___based] = ACTIONS(3623),
    [anon_sym_signed] = ACTIONS(3623),
    [anon_sym_unsigned] = ACTIONS(3623),
    [anon_sym_long] = ACTIONS(3623),
    [anon_sym_short] = ACTIONS(3623),
    [anon_sym_LBRACK] = ACTIONS(3623),
    [anon_sym_static] = ACTIONS(3623),
    [anon_sym_register] = ACTIONS(3623),
    [anon_sym_inline] = ACTIONS(3623),
    [anon_sym___inline] = ACTIONS(3623),
    [anon_sym___inline__] = ACTIONS(3623),
    [anon_sym___forceinline] = ACTIONS(3623),
    [anon_sym_thread_local] = ACTIONS(3623),
    [anon_sym___thread] = ACTIONS(3623),
    [anon_sym_const] = ACTIONS(3623),
    [anon_sym_constexpr] = ACTIONS(3623),
    [anon_sym_volatile] = ACTIONS(3623),
    [anon_sym_restrict] = ACTIONS(3623),
    [anon_sym___restrict__] = ACTIONS(3623),
    [anon_sym__Atomic] = ACTIONS(3623),
    [anon_sym__Noreturn] = ACTIONS(3623),
    [anon_sym_noreturn] = ACTIONS(3623),
    [anon_sym__Nonnull] = ACTIONS(3623),
    [anon_sym_mutable] = ACTIONS(3623),
    [anon_sym_constinit] = ACTIONS(3623),
    [anon_sym_consteval] = ACTIONS(3623),
    [anon_sym_alignas] = ACTIONS(3623),
    [anon_sym__Alignas] = ACTIONS(3623),
    [sym_primitive_type] = ACTIONS(3623),
    [anon_sym_enum] = ACTIONS(3623),
    [anon_sym_class] = ACTIONS(3623),
    [anon_sym_struct] = ACTIONS(3623),
    [anon_sym_union] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3623),
    [anon_sym_let] = ACTIONS(3623),
    [anon_sym_This] = ACTIONS(3623),
    [anon_sym_decltype] = ACTIONS(3623),
    [anon_sym_explicit] = ACTIONS(3623),
    [anon_sym_typename] = ACTIONS(3623),
    [anon_sym_private] = ACTIONS(3623),
    [anon_sym_template] = ACTIONS(3623),
    [anon_sym_operator] = ACTIONS(3623),
    [anon_sym_friend] = ACTIONS(3623),
    [anon_sym_public] = ACTIONS(3623),
    [anon_sym_protected] = ACTIONS(3623),
    [anon_sym_static_assert] = ACTIONS(3623),
    [anon_sym_precise] = ACTIONS(3623),
    [anon_sym_shared] = ACTIONS(3623),
    [anon_sym_groupshared] = ACTIONS(3623),
    [anon_sym_uniform] = ACTIONS(3623),
    [anon_sym_row_major] = ACTIONS(3623),
    [anon_sym_column_major] = ACTIONS(3623),
    [anon_sym_globallycoherent] = ACTIONS(3623),
    [anon_sym_centroid] = ACTIONS(3623),
    [anon_sym_noperspective] = ACTIONS(3623),
    [anon_sym_nointerpolation] = ACTIONS(3623),
    [anon_sym_sample] = ACTIONS(3623),
    [anon_sym_linear] = ACTIONS(3623),
    [anon_sym_snorm] = ACTIONS(3623),
    [anon_sym_unorm] = ACTIONS(3623),
    [anon_sym_point] = ACTIONS(3623),
    [anon_sym_line] = ACTIONS(3623),
    [anon_sym_triangleadj] = ACTIONS(3623),
    [anon_sym_lineadj] = ACTIONS(3623),
    [anon_sym_triangle] = ACTIONS(3623),
    [anon_sym_interface] = ACTIONS(3623),
    [anon_sym_extension] = ACTIONS(3623),
    [anon_sym___init] = ACTIONS(3623),
    [anon_sym___subscript] = ACTIONS(3623),
    [anon_sym_property] = ACTIONS(3623),
    [anon_sym_associatedtype] = ACTIONS(3623),
  },
  [2303] = {
    [sym_identifier] = ACTIONS(3623),
    [aux_sym_preproc_def_token1] = ACTIONS(3623),
    [aux_sym_preproc_if_token1] = ACTIONS(3623),
    [aux_sym_preproc_if_token2] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3623),
    [sym_preproc_directive] = ACTIONS(3623),
    [anon_sym_LPAREN2] = ACTIONS(3621),
    [anon_sym_TILDE] = ACTIONS(3621),
    [anon_sym_STAR] = ACTIONS(3621),
    [anon_sym_AMP_AMP] = ACTIONS(3621),
    [anon_sym_AMP] = ACTIONS(3623),
    [anon_sym_SEMI] = ACTIONS(3621),
    [anon_sym___extension__] = ACTIONS(3623),
    [anon_sym_typedef] = ACTIONS(3623),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_out] = ACTIONS(3623),
    [anon_sym_inout] = ACTIONS(3623),
    [anon_sym_virtual] = ACTIONS(3623),
    [anon_sym_extern] = ACTIONS(3623),
    [anon_sym___attribute__] = ACTIONS(3623),
    [anon_sym___attribute] = ACTIONS(3623),
    [anon_sym_using] = ACTIONS(3623),
    [anon_sym_COLON_COLON] = ACTIONS(3621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3621),
    [anon_sym___declspec] = ACTIONS(3623),
    [anon_sym___based] = ACTIONS(3623),
    [anon_sym_signed] = ACTIONS(3623),
    [anon_sym_unsigned] = ACTIONS(3623),
    [anon_sym_long] = ACTIONS(3623),
    [anon_sym_short] = ACTIONS(3623),
    [anon_sym_LBRACK] = ACTIONS(3623),
    [anon_sym_static] = ACTIONS(3623),
    [anon_sym_register] = ACTIONS(3623),
    [anon_sym_inline] = ACTIONS(3623),
    [anon_sym___inline] = ACTIONS(3623),
    [anon_sym___inline__] = ACTIONS(3623),
    [anon_sym___forceinline] = ACTIONS(3623),
    [anon_sym_thread_local] = ACTIONS(3623),
    [anon_sym___thread] = ACTIONS(3623),
    [anon_sym_const] = ACTIONS(3623),
    [anon_sym_constexpr] = ACTIONS(3623),
    [anon_sym_volatile] = ACTIONS(3623),
    [anon_sym_restrict] = ACTIONS(3623),
    [anon_sym___restrict__] = ACTIONS(3623),
    [anon_sym__Atomic] = ACTIONS(3623),
    [anon_sym__Noreturn] = ACTIONS(3623),
    [anon_sym_noreturn] = ACTIONS(3623),
    [anon_sym__Nonnull] = ACTIONS(3623),
    [anon_sym_mutable] = ACTIONS(3623),
    [anon_sym_constinit] = ACTIONS(3623),
    [anon_sym_consteval] = ACTIONS(3623),
    [anon_sym_alignas] = ACTIONS(3623),
    [anon_sym__Alignas] = ACTIONS(3623),
    [sym_primitive_type] = ACTIONS(3623),
    [anon_sym_enum] = ACTIONS(3623),
    [anon_sym_class] = ACTIONS(3623),
    [anon_sym_struct] = ACTIONS(3623),
    [anon_sym_union] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3623),
    [anon_sym_let] = ACTIONS(3623),
    [anon_sym_This] = ACTIONS(3623),
    [anon_sym_decltype] = ACTIONS(3623),
    [anon_sym_explicit] = ACTIONS(3623),
    [anon_sym_typename] = ACTIONS(3623),
    [anon_sym_private] = ACTIONS(3623),
    [anon_sym_template] = ACTIONS(3623),
    [anon_sym_operator] = ACTIONS(3623),
    [anon_sym_friend] = ACTIONS(3623),
    [anon_sym_public] = ACTIONS(3623),
    [anon_sym_protected] = ACTIONS(3623),
    [anon_sym_static_assert] = ACTIONS(3623),
    [anon_sym_precise] = ACTIONS(3623),
    [anon_sym_shared] = ACTIONS(3623),
    [anon_sym_groupshared] = ACTIONS(3623),
    [anon_sym_uniform] = ACTIONS(3623),
    [anon_sym_row_major] = ACTIONS(3623),
    [anon_sym_column_major] = ACTIONS(3623),
    [anon_sym_globallycoherent] = ACTIONS(3623),
    [anon_sym_centroid] = ACTIONS(3623),
    [anon_sym_noperspective] = ACTIONS(3623),
    [anon_sym_nointerpolation] = ACTIONS(3623),
    [anon_sym_sample] = ACTIONS(3623),
    [anon_sym_linear] = ACTIONS(3623),
    [anon_sym_snorm] = ACTIONS(3623),
    [anon_sym_unorm] = ACTIONS(3623),
    [anon_sym_point] = ACTIONS(3623),
    [anon_sym_line] = ACTIONS(3623),
    [anon_sym_triangleadj] = ACTIONS(3623),
    [anon_sym_lineadj] = ACTIONS(3623),
    [anon_sym_triangle] = ACTIONS(3623),
    [anon_sym_interface] = ACTIONS(3623),
    [anon_sym_extension] = ACTIONS(3623),
    [anon_sym___init] = ACTIONS(3623),
    [anon_sym___subscript] = ACTIONS(3623),
    [anon_sym_property] = ACTIONS(3623),
    [anon_sym_associatedtype] = ACTIONS(3623),
  },
  [2304] = {
    [sym_identifier] = ACTIONS(3379),
    [aux_sym_preproc_def_token1] = ACTIONS(3379),
    [aux_sym_preproc_if_token1] = ACTIONS(3379),
    [aux_sym_preproc_if_token2] = ACTIONS(3379),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3379),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3379),
    [sym_preproc_directive] = ACTIONS(3379),
    [anon_sym_LPAREN2] = ACTIONS(3381),
    [anon_sym_TILDE] = ACTIONS(3381),
    [anon_sym_STAR] = ACTIONS(3381),
    [anon_sym_AMP_AMP] = ACTIONS(3381),
    [anon_sym_AMP] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3381),
    [anon_sym___extension__] = ACTIONS(3379),
    [anon_sym_typedef] = ACTIONS(3379),
    [anon_sym_in] = ACTIONS(3379),
    [anon_sym_out] = ACTIONS(3379),
    [anon_sym_inout] = ACTIONS(3379),
    [anon_sym_virtual] = ACTIONS(3379),
    [anon_sym_extern] = ACTIONS(3379),
    [anon_sym___attribute__] = ACTIONS(3379),
    [anon_sym___attribute] = ACTIONS(3379),
    [anon_sym_using] = ACTIONS(3379),
    [anon_sym_COLON_COLON] = ACTIONS(3381),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3381),
    [anon_sym___declspec] = ACTIONS(3379),
    [anon_sym___based] = ACTIONS(3379),
    [anon_sym_signed] = ACTIONS(3379),
    [anon_sym_unsigned] = ACTIONS(3379),
    [anon_sym_long] = ACTIONS(3379),
    [anon_sym_short] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_register] = ACTIONS(3379),
    [anon_sym_inline] = ACTIONS(3379),
    [anon_sym___inline] = ACTIONS(3379),
    [anon_sym___inline__] = ACTIONS(3379),
    [anon_sym___forceinline] = ACTIONS(3379),
    [anon_sym_thread_local] = ACTIONS(3379),
    [anon_sym___thread] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_constexpr] = ACTIONS(3379),
    [anon_sym_volatile] = ACTIONS(3379),
    [anon_sym_restrict] = ACTIONS(3379),
    [anon_sym___restrict__] = ACTIONS(3379),
    [anon_sym__Atomic] = ACTIONS(3379),
    [anon_sym__Noreturn] = ACTIONS(3379),
    [anon_sym_noreturn] = ACTIONS(3379),
    [anon_sym__Nonnull] = ACTIONS(3379),
    [anon_sym_mutable] = ACTIONS(3379),
    [anon_sym_constinit] = ACTIONS(3379),
    [anon_sym_consteval] = ACTIONS(3379),
    [anon_sym_alignas] = ACTIONS(3379),
    [anon_sym__Alignas] = ACTIONS(3379),
    [sym_primitive_type] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_struct] = ACTIONS(3379),
    [anon_sym_union] = ACTIONS(3379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3379),
    [anon_sym_let] = ACTIONS(3379),
    [anon_sym_This] = ACTIONS(3379),
    [anon_sym_decltype] = ACTIONS(3379),
    [anon_sym_explicit] = ACTIONS(3379),
    [anon_sym_typename] = ACTIONS(3379),
    [anon_sym_private] = ACTIONS(3379),
    [anon_sym_template] = ACTIONS(3379),
    [anon_sym_operator] = ACTIONS(3379),
    [anon_sym_friend] = ACTIONS(3379),
    [anon_sym_public] = ACTIONS(3379),
    [anon_sym_protected] = ACTIONS(3379),
    [anon_sym_static_assert] = ACTIONS(3379),
    [anon_sym_precise] = ACTIONS(3379),
    [anon_sym_shared] = ACTIONS(3379),
    [anon_sym_groupshared] = ACTIONS(3379),
    [anon_sym_uniform] = ACTIONS(3379),
    [anon_sym_row_major] = ACTIONS(3379),
    [anon_sym_column_major] = ACTIONS(3379),
    [anon_sym_globallycoherent] = ACTIONS(3379),
    [anon_sym_centroid] = ACTIONS(3379),
    [anon_sym_noperspective] = ACTIONS(3379),
    [anon_sym_nointerpolation] = ACTIONS(3379),
    [anon_sym_sample] = ACTIONS(3379),
    [anon_sym_linear] = ACTIONS(3379),
    [anon_sym_snorm] = ACTIONS(3379),
    [anon_sym_unorm] = ACTIONS(3379),
    [anon_sym_point] = ACTIONS(3379),
    [anon_sym_line] = ACTIONS(3379),
    [anon_sym_triangleadj] = ACTIONS(3379),
    [anon_sym_lineadj] = ACTIONS(3379),
    [anon_sym_triangle] = ACTIONS(3379),
    [anon_sym_interface] = ACTIONS(3379),
    [anon_sym_extension] = ACTIONS(3379),
    [anon_sym___init] = ACTIONS(3379),
    [anon_sym___subscript] = ACTIONS(3379),
    [anon_sym_property] = ACTIONS(3379),
    [anon_sym_associatedtype] = ACTIONS(3379),
  },
  [2305] = {
    [sym_identifier] = ACTIONS(3763),
    [aux_sym_preproc_def_token1] = ACTIONS(3763),
    [aux_sym_preproc_if_token1] = ACTIONS(3763),
    [aux_sym_preproc_if_token2] = ACTIONS(3763),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3763),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3763),
    [sym_preproc_directive] = ACTIONS(3763),
    [anon_sym_LPAREN2] = ACTIONS(3765),
    [anon_sym_TILDE] = ACTIONS(3765),
    [anon_sym_STAR] = ACTIONS(3765),
    [anon_sym_AMP_AMP] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3763),
    [anon_sym_SEMI] = ACTIONS(3765),
    [anon_sym___extension__] = ACTIONS(3763),
    [anon_sym_typedef] = ACTIONS(3763),
    [anon_sym_in] = ACTIONS(3763),
    [anon_sym_out] = ACTIONS(3763),
    [anon_sym_inout] = ACTIONS(3763),
    [anon_sym_virtual] = ACTIONS(3763),
    [anon_sym_extern] = ACTIONS(3763),
    [anon_sym___attribute__] = ACTIONS(3763),
    [anon_sym___attribute] = ACTIONS(3763),
    [anon_sym_using] = ACTIONS(3763),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3765),
    [anon_sym___declspec] = ACTIONS(3763),
    [anon_sym___based] = ACTIONS(3763),
    [anon_sym_signed] = ACTIONS(3763),
    [anon_sym_unsigned] = ACTIONS(3763),
    [anon_sym_long] = ACTIONS(3763),
    [anon_sym_short] = ACTIONS(3763),
    [anon_sym_LBRACK] = ACTIONS(3763),
    [anon_sym_static] = ACTIONS(3763),
    [anon_sym_register] = ACTIONS(3763),
    [anon_sym_inline] = ACTIONS(3763),
    [anon_sym___inline] = ACTIONS(3763),
    [anon_sym___inline__] = ACTIONS(3763),
    [anon_sym___forceinline] = ACTIONS(3763),
    [anon_sym_thread_local] = ACTIONS(3763),
    [anon_sym___thread] = ACTIONS(3763),
    [anon_sym_const] = ACTIONS(3763),
    [anon_sym_constexpr] = ACTIONS(3763),
    [anon_sym_volatile] = ACTIONS(3763),
    [anon_sym_restrict] = ACTIONS(3763),
    [anon_sym___restrict__] = ACTIONS(3763),
    [anon_sym__Atomic] = ACTIONS(3763),
    [anon_sym__Noreturn] = ACTIONS(3763),
    [anon_sym_noreturn] = ACTIONS(3763),
    [anon_sym__Nonnull] = ACTIONS(3763),
    [anon_sym_mutable] = ACTIONS(3763),
    [anon_sym_constinit] = ACTIONS(3763),
    [anon_sym_consteval] = ACTIONS(3763),
    [anon_sym_alignas] = ACTIONS(3763),
    [anon_sym__Alignas] = ACTIONS(3763),
    [sym_primitive_type] = ACTIONS(3763),
    [anon_sym_enum] = ACTIONS(3763),
    [anon_sym_class] = ACTIONS(3763),
    [anon_sym_struct] = ACTIONS(3763),
    [anon_sym_union] = ACTIONS(3763),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3763),
    [anon_sym_let] = ACTIONS(3763),
    [anon_sym_This] = ACTIONS(3763),
    [anon_sym_decltype] = ACTIONS(3763),
    [anon_sym_explicit] = ACTIONS(3763),
    [anon_sym_typename] = ACTIONS(3763),
    [anon_sym_private] = ACTIONS(3763),
    [anon_sym_template] = ACTIONS(3763),
    [anon_sym_operator] = ACTIONS(3763),
    [anon_sym_friend] = ACTIONS(3763),
    [anon_sym_public] = ACTIONS(3763),
    [anon_sym_protected] = ACTIONS(3763),
    [anon_sym_static_assert] = ACTIONS(3763),
    [anon_sym_precise] = ACTIONS(3763),
    [anon_sym_shared] = ACTIONS(3763),
    [anon_sym_groupshared] = ACTIONS(3763),
    [anon_sym_uniform] = ACTIONS(3763),
    [anon_sym_row_major] = ACTIONS(3763),
    [anon_sym_column_major] = ACTIONS(3763),
    [anon_sym_globallycoherent] = ACTIONS(3763),
    [anon_sym_centroid] = ACTIONS(3763),
    [anon_sym_noperspective] = ACTIONS(3763),
    [anon_sym_nointerpolation] = ACTIONS(3763),
    [anon_sym_sample] = ACTIONS(3763),
    [anon_sym_linear] = ACTIONS(3763),
    [anon_sym_snorm] = ACTIONS(3763),
    [anon_sym_unorm] = ACTIONS(3763),
    [anon_sym_point] = ACTIONS(3763),
    [anon_sym_line] = ACTIONS(3763),
    [anon_sym_triangleadj] = ACTIONS(3763),
    [anon_sym_lineadj] = ACTIONS(3763),
    [anon_sym_triangle] = ACTIONS(3763),
    [anon_sym_interface] = ACTIONS(3763),
    [anon_sym_extension] = ACTIONS(3763),
    [anon_sym___init] = ACTIONS(3763),
    [anon_sym___subscript] = ACTIONS(3763),
    [anon_sym_property] = ACTIONS(3763),
    [anon_sym_associatedtype] = ACTIONS(3763),
  },
  [2306] = {
    [sym_identifier] = ACTIONS(3399),
    [aux_sym_preproc_def_token1] = ACTIONS(3399),
    [aux_sym_preproc_if_token1] = ACTIONS(3399),
    [aux_sym_preproc_if_token2] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3399),
    [sym_preproc_directive] = ACTIONS(3399),
    [anon_sym_LPAREN2] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_STAR] = ACTIONS(3401),
    [anon_sym_AMP_AMP] = ACTIONS(3401),
    [anon_sym_AMP] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym___extension__] = ACTIONS(3399),
    [anon_sym_typedef] = ACTIONS(3399),
    [anon_sym_in] = ACTIONS(3399),
    [anon_sym_out] = ACTIONS(3399),
    [anon_sym_inout] = ACTIONS(3399),
    [anon_sym_virtual] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym___attribute__] = ACTIONS(3399),
    [anon_sym___attribute] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_COLON_COLON] = ACTIONS(3401),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3401),
    [anon_sym___declspec] = ACTIONS(3399),
    [anon_sym___based] = ACTIONS(3399),
    [anon_sym_signed] = ACTIONS(3399),
    [anon_sym_unsigned] = ACTIONS(3399),
    [anon_sym_long] = ACTIONS(3399),
    [anon_sym_short] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_register] = ACTIONS(3399),
    [anon_sym_inline] = ACTIONS(3399),
    [anon_sym___inline] = ACTIONS(3399),
    [anon_sym___inline__] = ACTIONS(3399),
    [anon_sym___forceinline] = ACTIONS(3399),
    [anon_sym_thread_local] = ACTIONS(3399),
    [anon_sym___thread] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_constexpr] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym_restrict] = ACTIONS(3399),
    [anon_sym___restrict__] = ACTIONS(3399),
    [anon_sym__Atomic] = ACTIONS(3399),
    [anon_sym__Noreturn] = ACTIONS(3399),
    [anon_sym_noreturn] = ACTIONS(3399),
    [anon_sym__Nonnull] = ACTIONS(3399),
    [anon_sym_mutable] = ACTIONS(3399),
    [anon_sym_constinit] = ACTIONS(3399),
    [anon_sym_consteval] = ACTIONS(3399),
    [anon_sym_alignas] = ACTIONS(3399),
    [anon_sym__Alignas] = ACTIONS(3399),
    [sym_primitive_type] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_union] = ACTIONS(3399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_This] = ACTIONS(3399),
    [anon_sym_decltype] = ACTIONS(3399),
    [anon_sym_explicit] = ACTIONS(3399),
    [anon_sym_typename] = ACTIONS(3399),
    [anon_sym_private] = ACTIONS(3399),
    [anon_sym_template] = ACTIONS(3399),
    [anon_sym_operator] = ACTIONS(3399),
    [anon_sym_friend] = ACTIONS(3399),
    [anon_sym_public] = ACTIONS(3399),
    [anon_sym_protected] = ACTIONS(3399),
    [anon_sym_static_assert] = ACTIONS(3399),
    [anon_sym_precise] = ACTIONS(3399),
    [anon_sym_shared] = ACTIONS(3399),
    [anon_sym_groupshared] = ACTIONS(3399),
    [anon_sym_uniform] = ACTIONS(3399),
    [anon_sym_row_major] = ACTIONS(3399),
    [anon_sym_column_major] = ACTIONS(3399),
    [anon_sym_globallycoherent] = ACTIONS(3399),
    [anon_sym_centroid] = ACTIONS(3399),
    [anon_sym_noperspective] = ACTIONS(3399),
    [anon_sym_nointerpolation] = ACTIONS(3399),
    [anon_sym_sample] = ACTIONS(3399),
    [anon_sym_linear] = ACTIONS(3399),
    [anon_sym_snorm] = ACTIONS(3399),
    [anon_sym_unorm] = ACTIONS(3399),
    [anon_sym_point] = ACTIONS(3399),
    [anon_sym_line] = ACTIONS(3399),
    [anon_sym_triangleadj] = ACTIONS(3399),
    [anon_sym_lineadj] = ACTIONS(3399),
    [anon_sym_triangle] = ACTIONS(3399),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_extension] = ACTIONS(3399),
    [anon_sym___init] = ACTIONS(3399),
    [anon_sym___subscript] = ACTIONS(3399),
    [anon_sym_property] = ACTIONS(3399),
    [anon_sym_associatedtype] = ACTIONS(3399),
  },
  [2307] = {
    [sym_identifier] = ACTIONS(3399),
    [aux_sym_preproc_def_token1] = ACTIONS(3399),
    [aux_sym_preproc_if_token1] = ACTIONS(3399),
    [aux_sym_preproc_if_token2] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3399),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3399),
    [sym_preproc_directive] = ACTIONS(3399),
    [anon_sym_LPAREN2] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_STAR] = ACTIONS(3401),
    [anon_sym_AMP_AMP] = ACTIONS(3401),
    [anon_sym_AMP] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym___extension__] = ACTIONS(3399),
    [anon_sym_typedef] = ACTIONS(3399),
    [anon_sym_in] = ACTIONS(3399),
    [anon_sym_out] = ACTIONS(3399),
    [anon_sym_inout] = ACTIONS(3399),
    [anon_sym_virtual] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym___attribute__] = ACTIONS(3399),
    [anon_sym___attribute] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_COLON_COLON] = ACTIONS(3401),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3401),
    [anon_sym___declspec] = ACTIONS(3399),
    [anon_sym___based] = ACTIONS(3399),
    [anon_sym_signed] = ACTIONS(3399),
    [anon_sym_unsigned] = ACTIONS(3399),
    [anon_sym_long] = ACTIONS(3399),
    [anon_sym_short] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_register] = ACTIONS(3399),
    [anon_sym_inline] = ACTIONS(3399),
    [anon_sym___inline] = ACTIONS(3399),
    [anon_sym___inline__] = ACTIONS(3399),
    [anon_sym___forceinline] = ACTIONS(3399),
    [anon_sym_thread_local] = ACTIONS(3399),
    [anon_sym___thread] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_constexpr] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym_restrict] = ACTIONS(3399),
    [anon_sym___restrict__] = ACTIONS(3399),
    [anon_sym__Atomic] = ACTIONS(3399),
    [anon_sym__Noreturn] = ACTIONS(3399),
    [anon_sym_noreturn] = ACTIONS(3399),
    [anon_sym__Nonnull] = ACTIONS(3399),
    [anon_sym_mutable] = ACTIONS(3399),
    [anon_sym_constinit] = ACTIONS(3399),
    [anon_sym_consteval] = ACTIONS(3399),
    [anon_sym_alignas] = ACTIONS(3399),
    [anon_sym__Alignas] = ACTIONS(3399),
    [sym_primitive_type] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_union] = ACTIONS(3399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_This] = ACTIONS(3399),
    [anon_sym_decltype] = ACTIONS(3399),
    [anon_sym_explicit] = ACTIONS(3399),
    [anon_sym_typename] = ACTIONS(3399),
    [anon_sym_private] = ACTIONS(3399),
    [anon_sym_template] = ACTIONS(3399),
    [anon_sym_operator] = ACTIONS(3399),
    [anon_sym_friend] = ACTIONS(3399),
    [anon_sym_public] = ACTIONS(3399),
    [anon_sym_protected] = ACTIONS(3399),
    [anon_sym_static_assert] = ACTIONS(3399),
    [anon_sym_precise] = ACTIONS(3399),
    [anon_sym_shared] = ACTIONS(3399),
    [anon_sym_groupshared] = ACTIONS(3399),
    [anon_sym_uniform] = ACTIONS(3399),
    [anon_sym_row_major] = ACTIONS(3399),
    [anon_sym_column_major] = ACTIONS(3399),
    [anon_sym_globallycoherent] = ACTIONS(3399),
    [anon_sym_centroid] = ACTIONS(3399),
    [anon_sym_noperspective] = ACTIONS(3399),
    [anon_sym_nointerpolation] = ACTIONS(3399),
    [anon_sym_sample] = ACTIONS(3399),
    [anon_sym_linear] = ACTIONS(3399),
    [anon_sym_snorm] = ACTIONS(3399),
    [anon_sym_unorm] = ACTIONS(3399),
    [anon_sym_point] = ACTIONS(3399),
    [anon_sym_line] = ACTIONS(3399),
    [anon_sym_triangleadj] = ACTIONS(3399),
    [anon_sym_lineadj] = ACTIONS(3399),
    [anon_sym_triangle] = ACTIONS(3399),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_extension] = ACTIONS(3399),
    [anon_sym___init] = ACTIONS(3399),
    [anon_sym___subscript] = ACTIONS(3399),
    [anon_sym_property] = ACTIONS(3399),
    [anon_sym_associatedtype] = ACTIONS(3399),
  },
  [2308] = {
    [sym_expression] = STATE(3927),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [2309] = {
    [sym_expression] = STATE(5885),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2310] = {
    [sym_expression] = STATE(6031),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2311] = {
    [sym_expression] = STATE(5870),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2312] = {
    [sym_expression] = STATE(5772),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2313] = {
    [sym_expression] = STATE(5649),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2314] = {
    [sym_expression] = STATE(4812),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2315] = {
    [sym_expression] = STATE(6057),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2316] = {
    [sym_expression] = STATE(5915),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2317] = {
    [sym_expression] = STATE(4097),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [2318] = {
    [sym_expression] = STATE(4097),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(6684),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [2319] = {
    [sym_expression] = STATE(4130),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [2320] = {
    [sym_expression] = STATE(5421),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(6483),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2321] = {
    [sym_expression] = STATE(4826),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2322] = {
    [sym_expression] = STATE(4368),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(6425),
    [anon_sym_BANG] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5262),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_DASH_DASH] = ACTIONS(5557),
    [anon_sym_PLUS_PLUS] = ACTIONS(5557),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [2323] = {
    [sym_expression] = STATE(5360),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2324] = {
    [sym_expression] = STATE(5369),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(6686),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2325] = {
    [sym_expression] = STATE(5413),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2326] = {
    [sym_expression] = STATE(5406),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2327] = {
    [sym_expression] = STATE(4831),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2328] = {
    [sym_expression] = STATE(5409),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2329] = {
    [sym_expression] = STATE(5412),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2330] = {
    [sym_expression] = STATE(5418),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2331] = {
    [sym_expression] = STATE(5420),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2332] = {
    [sym_expression] = STATE(5423),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2333] = {
    [sym_expression] = STATE(5432),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2334] = {
    [sym_expression] = STATE(5435),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2335] = {
    [sym_expression] = STATE(5441),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2336] = {
    [sym_expression] = STATE(5451),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2337] = {
    [sym_expression] = STATE(5392),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2338] = {
    [sym_expression] = STATE(5127),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(6452),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [2339] = {
    [sym_expression] = STATE(5380),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2340] = {
    [sym_expression] = STATE(3794),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(6688),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2341] = {
    [sym_expression] = STATE(3364),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2342] = {
    [sym_expression] = STATE(5666),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2343] = {
    [sym_expression] = STATE(5718),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2344] = {
    [sym_expression] = STATE(5726),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2345] = {
    [sym_expression] = STATE(5744),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2346] = {
    [sym_expression] = STATE(5770),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2347] = {
    [sym_expression] = STATE(5858),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2348] = {
    [sym_expression] = STATE(5859),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2349] = {
    [sym_expression] = STATE(5861),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2350] = {
    [sym_expression] = STATE(5862),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2351] = {
    [sym_expression] = STATE(5864),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2352] = {
    [sym_expression] = STATE(5867),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2353] = {
    [sym_expression] = STATE(4254),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [2354] = {
    [sym_expression] = STATE(3861),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5032),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACK] = ACTIONS(6690),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2355] = {
    [sym_expression] = STATE(3364),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5032),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2356] = {
    [sym_expression] = STATE(3654),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6460),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4956),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK] = ACTIONS(6692),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_DASH_DASH] = ACTIONS(5544),
    [anon_sym_PLUS_PLUS] = ACTIONS(5544),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2357] = {
    [sym_expression] = STATE(3629),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6460),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4956),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_DASH_DASH] = ACTIONS(5544),
    [anon_sym_PLUS_PLUS] = ACTIONS(5544),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2358] = {
    [sym_expression] = STATE(3639),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6460),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4956),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_DASH_DASH] = ACTIONS(5544),
    [anon_sym_PLUS_PLUS] = ACTIONS(5544),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2359] = {
    [sym_expression] = STATE(3645),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6460),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4956),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_DASH_DASH] = ACTIONS(5544),
    [anon_sym_PLUS_PLUS] = ACTIONS(5544),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2360] = {
    [sym_expression] = STATE(3370),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2361] = {
    [sym_expression] = STATE(3370),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(6694),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2362] = {
    [sym_expression] = STATE(3777),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(6696),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2363] = {
    [sym_expression] = STATE(3355),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2364] = {
    [sym_expression] = STATE(5120),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(6452),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(6698),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [2365] = {
    [sym_expression] = STATE(4826),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(6452),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [2366] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5032),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2367] = {
    [sym_expression] = STATE(5119),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(6452),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [2368] = {
    [sym_expression] = STATE(5171),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(6452),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(6700),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [2369] = {
    [sym_expression] = STATE(5188),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(6452),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [2370] = {
    [sym_expression] = STATE(4831),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(6452),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [2371] = {
    [sym_expression] = STATE(5189),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(6452),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [2372] = {
    [sym_expression] = STATE(5190),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(6452),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [2373] = {
    [sym_expression] = STATE(5191),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(6452),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [2374] = {
    [sym_expression] = STATE(5192),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(6452),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [2375] = {
    [sym_expression] = STATE(5193),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(6452),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [2376] = {
    [sym_expression] = STATE(5194),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(6452),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [2377] = {
    [sym_expression] = STATE(5195),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(6452),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [2378] = {
    [sym_expression] = STATE(5112),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(6452),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [2379] = {
    [sym_expression] = STATE(5204),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(6452),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [2380] = {
    [sym_expression] = STATE(5637),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2381] = {
    [sym_expression] = STATE(5209),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(6452),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [2382] = {
    [sym_expression] = STATE(5176),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(6452),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [2383] = {
    [sym_expression] = STATE(4217),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [2384] = {
    [sym_expression] = STATE(4219),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [2385] = {
    [sym_expression] = STATE(4221),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [2386] = {
    [sym_expression] = STATE(4238),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [2387] = {
    [sym_expression] = STATE(4262),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [2388] = {
    [sym_expression] = STATE(4266),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [2389] = {
    [sym_expression] = STATE(4288),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [2390] = {
    [sym_expression] = STATE(4436),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(6425),
    [anon_sym_BANG] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5262),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_DASH_DASH] = ACTIONS(5557),
    [anon_sym_PLUS_PLUS] = ACTIONS(5557),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [2391] = {
    [sym_expression] = STATE(4462),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(6425),
    [anon_sym_BANG] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5262),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_DASH_DASH] = ACTIONS(5557),
    [anon_sym_PLUS_PLUS] = ACTIONS(5557),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [2392] = {
    [sym_expression] = STATE(4463),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(6425),
    [anon_sym_BANG] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5262),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_DASH_DASH] = ACTIONS(5557),
    [anon_sym_PLUS_PLUS] = ACTIONS(5557),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [2393] = {
    [sym_expression] = STATE(4465),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(6425),
    [anon_sym_BANG] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5262),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_DASH_DASH] = ACTIONS(5557),
    [anon_sym_PLUS_PLUS] = ACTIONS(5557),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [2394] = {
    [sym_expression] = STATE(4466),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(6425),
    [anon_sym_BANG] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5262),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_DASH_DASH] = ACTIONS(5557),
    [anon_sym_PLUS_PLUS] = ACTIONS(5557),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [2395] = {
    [sym_expression] = STATE(4467),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(6425),
    [anon_sym_BANG] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5262),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_DASH_DASH] = ACTIONS(5557),
    [anon_sym_PLUS_PLUS] = ACTIONS(5557),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [2396] = {
    [sym_expression] = STATE(4468),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(6425),
    [anon_sym_BANG] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5262),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_DASH_DASH] = ACTIONS(5557),
    [anon_sym_PLUS_PLUS] = ACTIONS(5557),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [2397] = {
    [sym_expression] = STATE(4469),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(6425),
    [anon_sym_BANG] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5262),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_DASH_DASH] = ACTIONS(5557),
    [anon_sym_PLUS_PLUS] = ACTIONS(5557),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [2398] = {
    [sym_expression] = STATE(4470),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(6425),
    [anon_sym_BANG] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5262),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_DASH_DASH] = ACTIONS(5557),
    [anon_sym_PLUS_PLUS] = ACTIONS(5557),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [2399] = {
    [sym_expression] = STATE(4471),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(6425),
    [anon_sym_BANG] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5262),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_DASH_DASH] = ACTIONS(5557),
    [anon_sym_PLUS_PLUS] = ACTIONS(5557),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [2400] = {
    [sym_expression] = STATE(4472),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(6425),
    [anon_sym_BANG] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5262),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_DASH_DASH] = ACTIONS(5557),
    [anon_sym_PLUS_PLUS] = ACTIONS(5557),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [2401] = {
    [sym_expression] = STATE(3625),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6460),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4956),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK] = ACTIONS(6702),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_DASH_DASH] = ACTIONS(5544),
    [anon_sym_PLUS_PLUS] = ACTIONS(5544),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2402] = {
    [sym_expression] = STATE(3364),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6460),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4956),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_DASH_DASH] = ACTIONS(5544),
    [anon_sym_PLUS_PLUS] = ACTIONS(5544),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2403] = {
    [sym_expression] = STATE(5627),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2404] = {
    [sym_expression] = STATE(4304),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [2405] = {
    [sym_expression] = STATE(4093),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [2406] = {
    [sym_expression] = STATE(5869),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2407] = {
    [sym_expression] = STATE(3892),
    [sym__string] = STATE(4338),
    [sym_conditional_expression] = STATE(4643),
    [sym_assignment_expression] = STATE(4643),
    [sym_pointer_expression] = STATE(4519),
    [sym_unary_expression] = STATE(4643),
    [sym_binary_expression] = STATE(4643),
    [sym_update_expression] = STATE(4643),
    [sym_cast_expression] = STATE(4643),
    [sym_sizeof_expression] = STATE(4643),
    [sym_alignof_expression] = STATE(4643),
    [sym_offsetof_expression] = STATE(4643),
    [sym_generic_expression] = STATE(4643),
    [sym_subscript_expression] = STATE(4519),
    [sym_call_expression] = STATE(4519),
    [sym_gnu_asm_expression] = STATE(4643),
    [sym_extension_expression] = STATE(4643),
    [sym_field_expression] = STATE(4519),
    [sym_compound_literal_expression] = STATE(4643),
    [sym_parenthesized_expression] = STATE(4519),
    [sym_char_literal] = STATE(4338),
    [sym_concatenated_string] = STATE(4338),
    [sym_string_literal] = STATE(3336),
    [sym_null] = STATE(4643),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10441),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4643),
    [sym_raw_string_literal] = STATE(3336),
    [sym_co_await_expression] = STATE(4643),
    [sym_new_expression] = STATE(4643),
    [sym_delete_expression] = STATE(4643),
    [sym_requires_clause] = STATE(4643),
    [sym_requires_expression] = STATE(4643),
    [sym_lambda_expression] = STATE(4643),
    [sym_lambda_capture_specifier] = STATE(6439),
    [sym_fold_expression] = STATE(4643),
    [sym_parameter_pack_expansion] = STATE(4643),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4519),
    [sym_qualified_type_identifier] = STATE(10441),
    [sym_user_defined_literal] = STATE(4519),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(4431),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(2807),
    [anon_sym_compl] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2833),
    [anon_sym_sizeof] = ACTIONS(2835),
    [anon_sym___alignof__] = ACTIONS(2837),
    [anon_sym___alignof] = ACTIONS(2837),
    [anon_sym__alignof] = ACTIONS(2837),
    [anon_sym_alignof] = ACTIONS(2837),
    [anon_sym__Alignof] = ACTIONS(2837),
    [anon_sym_offsetof] = ACTIONS(2839),
    [anon_sym__Generic] = ACTIONS(2841),
    [anon_sym_asm] = ACTIONS(2843),
    [anon_sym___asm__] = ACTIONS(2843),
    [anon_sym___asm] = ACTIONS(2843),
    [sym_number_literal] = ACTIONS(2845),
    [anon_sym_L_SQUOTE] = ACTIONS(2847),
    [anon_sym_u_SQUOTE] = ACTIONS(2847),
    [anon_sym_U_SQUOTE] = ACTIONS(2847),
    [anon_sym_u8_SQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_L_DQUOTE] = ACTIONS(2849),
    [anon_sym_u_DQUOTE] = ACTIONS(2849),
    [anon_sym_U_DQUOTE] = ACTIONS(2849),
    [anon_sym_u8_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE] = ACTIONS(2849),
    [sym_true] = ACTIONS(2851),
    [sym_false] = ACTIONS(2851),
    [anon_sym_NULL] = ACTIONS(2853),
    [anon_sym_nullptr] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_R_DQUOTE] = ACTIONS(2865),
    [anon_sym_LR_DQUOTE] = ACTIONS(2865),
    [anon_sym_uR_DQUOTE] = ACTIONS(2865),
    [anon_sym_UR_DQUOTE] = ACTIONS(2865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2865),
    [anon_sym_co_await] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_requires] = ACTIONS(2871),
    [sym_this] = ACTIONS(2851),
  },
  [2408] = {
    [sym_expression] = STATE(3786),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2409] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6460),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4956),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_DASH_DASH] = ACTIONS(5544),
    [anon_sym_PLUS_PLUS] = ACTIONS(5544),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2410] = {
    [sym_expression] = STATE(3860),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5032),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2411] = {
    [sym_expression] = STATE(3862),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5032),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2412] = {
    [sym_expression] = STATE(3350),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5032),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2413] = {
    [sym_expression] = STATE(3876),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5032),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2414] = {
    [sym_expression] = STATE(3812),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5032),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2415] = {
    [sym_expression] = STATE(3823),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5032),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2416] = {
    [sym_expression] = STATE(3826),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5032),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2417] = {
    [sym_expression] = STATE(3827),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5032),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2418] = {
    [sym_expression] = STATE(3832),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5032),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2419] = {
    [sym_expression] = STATE(3885),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5032),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2420] = {
    [sym_expression] = STATE(3863),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5032),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2421] = {
    [sym_expression] = STATE(4753),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [2422] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2423] = {
    [sym_expression] = STATE(4776),
    [sym__string] = STATE(4830),
    [sym_conditional_expression] = STATE(4888),
    [sym_assignment_expression] = STATE(4888),
    [sym_pointer_expression] = STATE(4579),
    [sym_unary_expression] = STATE(4888),
    [sym_binary_expression] = STATE(4888),
    [sym_update_expression] = STATE(4888),
    [sym_cast_expression] = STATE(4888),
    [sym_sizeof_expression] = STATE(4888),
    [sym_alignof_expression] = STATE(4888),
    [sym_offsetof_expression] = STATE(4888),
    [sym_generic_expression] = STATE(4888),
    [sym_subscript_expression] = STATE(4579),
    [sym_call_expression] = STATE(4579),
    [sym_gnu_asm_expression] = STATE(4888),
    [sym_extension_expression] = STATE(4888),
    [sym_field_expression] = STATE(4579),
    [sym_compound_literal_expression] = STATE(4888),
    [sym_parenthesized_expression] = STATE(4579),
    [sym_char_literal] = STATE(4830),
    [sym_concatenated_string] = STATE(4830),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4888),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10654),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4888),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4888),
    [sym_new_expression] = STATE(4888),
    [sym_delete_expression] = STATE(4888),
    [sym_requires_clause] = STATE(4888),
    [sym_requires_expression] = STATE(4888),
    [sym_lambda_expression] = STATE(4888),
    [sym_lambda_capture_specifier] = STATE(6465),
    [sym_fold_expression] = STATE(4888),
    [sym_parameter_pack_expansion] = STATE(4888),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7225),
    [sym_qualified_identifier] = STATE(4579),
    [sym_qualified_type_identifier] = STATE(10654),
    [sym_user_defined_literal] = STATE(4579),
    [sym_identifier] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2368),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2372),
    [anon_sym___asm__] = ACTIONS(2372),
    [anon_sym___asm] = ACTIONS(2372),
    [sym_number_literal] = ACTIONS(2374),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2380),
  },
  [2424] = {
    [sym_expression] = STATE(5847),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2425] = {
    [sym_expression] = STATE(5382),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2426] = {
    [sym_expression] = STATE(3624),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6460),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4956),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_DASH_DASH] = ACTIONS(5544),
    [anon_sym_PLUS_PLUS] = ACTIONS(5544),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2427] = {
    [sym_expression] = STATE(3627),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6460),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4956),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_DASH_DASH] = ACTIONS(5544),
    [anon_sym_PLUS_PLUS] = ACTIONS(5544),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2428] = {
    [sym_expression] = STATE(3350),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6460),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4956),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_DASH_DASH] = ACTIONS(5544),
    [anon_sym_PLUS_PLUS] = ACTIONS(5544),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2429] = {
    [sym_expression] = STATE(3656),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6460),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4956),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_DASH_DASH] = ACTIONS(5544),
    [anon_sym_PLUS_PLUS] = ACTIONS(5544),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2430] = {
    [sym_expression] = STATE(3615),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6460),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4956),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_DASH_DASH] = ACTIONS(5544),
    [anon_sym_PLUS_PLUS] = ACTIONS(5544),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2431] = {
    [sym_expression] = STATE(3659),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6460),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4956),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_DASH_DASH] = ACTIONS(5544),
    [anon_sym_PLUS_PLUS] = ACTIONS(5544),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2432] = {
    [sym_expression] = STATE(3660),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6460),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4956),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_DASH_DASH] = ACTIONS(5544),
    [anon_sym_PLUS_PLUS] = ACTIONS(5544),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2433] = {
    [sym_expression] = STATE(3661),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6460),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4956),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_DASH_DASH] = ACTIONS(5544),
    [anon_sym_PLUS_PLUS] = ACTIONS(5544),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2434] = {
    [sym_expression] = STATE(3663),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6460),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4956),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_DASH_DASH] = ACTIONS(5544),
    [anon_sym_PLUS_PLUS] = ACTIONS(5544),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2435] = {
    [sym_expression] = STATE(3664),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6460),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4956),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_DASH_DASH] = ACTIONS(5544),
    [anon_sym_PLUS_PLUS] = ACTIONS(5544),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2436] = {
    [sym_expression] = STATE(3628),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6460),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4956),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_DASH_DASH] = ACTIONS(5544),
    [anon_sym_PLUS_PLUS] = ACTIONS(5544),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2437] = {
    [sym_expression] = STATE(4435),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(6425),
    [anon_sym_BANG] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5262),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_DASH_DASH] = ACTIONS(5557),
    [anon_sym_PLUS_PLUS] = ACTIONS(5557),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [2438] = {
    [sym_expression] = STATE(4438),
    [sym__string] = STATE(4543),
    [sym_conditional_expression] = STATE(4722),
    [sym_assignment_expression] = STATE(4722),
    [sym_pointer_expression] = STATE(4725),
    [sym_unary_expression] = STATE(4722),
    [sym_binary_expression] = STATE(4722),
    [sym_update_expression] = STATE(4722),
    [sym_cast_expression] = STATE(4722),
    [sym_sizeof_expression] = STATE(4722),
    [sym_alignof_expression] = STATE(4722),
    [sym_offsetof_expression] = STATE(4722),
    [sym_generic_expression] = STATE(4722),
    [sym_subscript_expression] = STATE(4725),
    [sym_call_expression] = STATE(4725),
    [sym_gnu_asm_expression] = STATE(4722),
    [sym_extension_expression] = STATE(4722),
    [sym_field_expression] = STATE(4725),
    [sym_compound_literal_expression] = STATE(4722),
    [sym_parenthesized_expression] = STATE(4725),
    [sym_char_literal] = STATE(4543),
    [sym_concatenated_string] = STATE(4543),
    [sym_string_literal] = STATE(3368),
    [sym_null] = STATE(4722),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10446),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4722),
    [sym_raw_string_literal] = STATE(3368),
    [sym_co_await_expression] = STATE(4722),
    [sym_new_expression] = STATE(4722),
    [sym_delete_expression] = STATE(4722),
    [sym_requires_clause] = STATE(4722),
    [sym_requires_expression] = STATE(4722),
    [sym_lambda_expression] = STATE(4722),
    [sym_lambda_capture_specifier] = STATE(6410),
    [sym_fold_expression] = STATE(4722),
    [sym_parameter_pack_expansion] = STATE(4722),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4725),
    [sym_qualified_type_identifier] = STATE(10446),
    [sym_user_defined_literal] = STATE(4725),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(6425),
    [anon_sym_BANG] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5262),
    [anon_sym_COLON_COLON] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5258),
    [anon_sym_compl] = ACTIONS(5258),
    [anon_sym_DASH_DASH] = ACTIONS(5557),
    [anon_sym_PLUS_PLUS] = ACTIONS(5557),
    [anon_sym_sizeof] = ACTIONS(5270),
    [anon_sym___alignof__] = ACTIONS(5272),
    [anon_sym___alignof] = ACTIONS(5272),
    [anon_sym__alignof] = ACTIONS(5272),
    [anon_sym_alignof] = ACTIONS(5272),
    [anon_sym__Alignof] = ACTIONS(5272),
    [anon_sym_offsetof] = ACTIONS(5274),
    [anon_sym__Generic] = ACTIONS(5276),
    [anon_sym_asm] = ACTIONS(5278),
    [anon_sym___asm__] = ACTIONS(5278),
    [anon_sym___asm] = ACTIONS(5278),
    [sym_number_literal] = ACTIONS(5280),
    [anon_sym_L_SQUOTE] = ACTIONS(5282),
    [anon_sym_u_SQUOTE] = ACTIONS(5282),
    [anon_sym_U_SQUOTE] = ACTIONS(5282),
    [anon_sym_u8_SQUOTE] = ACTIONS(5282),
    [anon_sym_SQUOTE] = ACTIONS(5282),
    [anon_sym_L_DQUOTE] = ACTIONS(5284),
    [anon_sym_u_DQUOTE] = ACTIONS(5284),
    [anon_sym_U_DQUOTE] = ACTIONS(5284),
    [anon_sym_u8_DQUOTE] = ACTIONS(5284),
    [anon_sym_DQUOTE] = ACTIONS(5284),
    [sym_true] = ACTIONS(5286),
    [sym_false] = ACTIONS(5286),
    [anon_sym_NULL] = ACTIONS(5288),
    [anon_sym_nullptr] = ACTIONS(5288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5294),
    [anon_sym_new] = ACTIONS(5296),
    [anon_sym_requires] = ACTIONS(5298),
    [sym_this] = ACTIONS(5286),
  },
  [2439] = {
    [sym_expression] = STATE(4812),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2440] = {
    [sym_expression] = STATE(4809),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2441] = {
    [sym_identifier] = ACTIONS(6340),
    [aux_sym_preproc_def_token1] = ACTIONS(6340),
    [aux_sym_preproc_if_token1] = ACTIONS(6340),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6340),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6340),
    [sym_preproc_directive] = ACTIONS(6340),
    [anon_sym_LPAREN2] = ACTIONS(6342),
    [anon_sym_TILDE] = ACTIONS(6342),
    [anon_sym_STAR] = ACTIONS(6342),
    [anon_sym_AMP_AMP] = ACTIONS(6342),
    [anon_sym_AMP] = ACTIONS(6340),
    [anon_sym_SEMI] = ACTIONS(6342),
    [anon_sym___extension__] = ACTIONS(6340),
    [anon_sym_typedef] = ACTIONS(6340),
    [anon_sym_in] = ACTIONS(6340),
    [anon_sym_out] = ACTIONS(6340),
    [anon_sym_inout] = ACTIONS(6340),
    [anon_sym_virtual] = ACTIONS(6340),
    [anon_sym_extern] = ACTIONS(6340),
    [anon_sym___attribute__] = ACTIONS(6340),
    [anon_sym___attribute] = ACTIONS(6340),
    [anon_sym_using] = ACTIONS(6340),
    [anon_sym_COLON_COLON] = ACTIONS(6342),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6342),
    [anon_sym___declspec] = ACTIONS(6340),
    [anon_sym___based] = ACTIONS(6340),
    [anon_sym_RBRACE] = ACTIONS(6342),
    [anon_sym_signed] = ACTIONS(6340),
    [anon_sym_unsigned] = ACTIONS(6340),
    [anon_sym_long] = ACTIONS(6340),
    [anon_sym_short] = ACTIONS(6340),
    [anon_sym_LBRACK] = ACTIONS(6340),
    [anon_sym_static] = ACTIONS(6340),
    [anon_sym_register] = ACTIONS(6340),
    [anon_sym_inline] = ACTIONS(6340),
    [anon_sym___inline] = ACTIONS(6340),
    [anon_sym___inline__] = ACTIONS(6340),
    [anon_sym___forceinline] = ACTIONS(6340),
    [anon_sym_thread_local] = ACTIONS(6340),
    [anon_sym___thread] = ACTIONS(6340),
    [anon_sym_const] = ACTIONS(6340),
    [anon_sym_constexpr] = ACTIONS(6340),
    [anon_sym_volatile] = ACTIONS(6340),
    [anon_sym_restrict] = ACTIONS(6340),
    [anon_sym___restrict__] = ACTIONS(6340),
    [anon_sym__Atomic] = ACTIONS(6340),
    [anon_sym__Noreturn] = ACTIONS(6340),
    [anon_sym_noreturn] = ACTIONS(6340),
    [anon_sym__Nonnull] = ACTIONS(6340),
    [anon_sym_mutable] = ACTIONS(6340),
    [anon_sym_constinit] = ACTIONS(6340),
    [anon_sym_consteval] = ACTIONS(6340),
    [anon_sym_alignas] = ACTIONS(6340),
    [anon_sym__Alignas] = ACTIONS(6340),
    [sym_primitive_type] = ACTIONS(6340),
    [anon_sym_enum] = ACTIONS(6340),
    [anon_sym_class] = ACTIONS(6340),
    [anon_sym_struct] = ACTIONS(6340),
    [anon_sym_union] = ACTIONS(6340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6340),
    [anon_sym_let] = ACTIONS(6340),
    [anon_sym_This] = ACTIONS(6340),
    [anon_sym_decltype] = ACTIONS(6340),
    [anon_sym_explicit] = ACTIONS(6340),
    [anon_sym_typename] = ACTIONS(6340),
    [anon_sym_private] = ACTIONS(6340),
    [anon_sym_template] = ACTIONS(6340),
    [anon_sym_operator] = ACTIONS(6340),
    [anon_sym_friend] = ACTIONS(6340),
    [anon_sym_public] = ACTIONS(6340),
    [anon_sym_protected] = ACTIONS(6340),
    [anon_sym_static_assert] = ACTIONS(6340),
    [anon_sym_precise] = ACTIONS(6340),
    [anon_sym_shared] = ACTIONS(6340),
    [anon_sym_groupshared] = ACTIONS(6340),
    [anon_sym_uniform] = ACTIONS(6340),
    [anon_sym_row_major] = ACTIONS(6340),
    [anon_sym_column_major] = ACTIONS(6340),
    [anon_sym_globallycoherent] = ACTIONS(6340),
    [anon_sym_centroid] = ACTIONS(6340),
    [anon_sym_noperspective] = ACTIONS(6340),
    [anon_sym_nointerpolation] = ACTIONS(6340),
    [anon_sym_sample] = ACTIONS(6340),
    [anon_sym_linear] = ACTIONS(6340),
    [anon_sym_snorm] = ACTIONS(6340),
    [anon_sym_unorm] = ACTIONS(6340),
    [anon_sym_point] = ACTIONS(6340),
    [anon_sym_line] = ACTIONS(6340),
    [anon_sym_triangleadj] = ACTIONS(6340),
    [anon_sym_lineadj] = ACTIONS(6340),
    [anon_sym_triangle] = ACTIONS(6340),
    [anon_sym_interface] = ACTIONS(6340),
    [anon_sym_extension] = ACTIONS(6340),
    [anon_sym___init] = ACTIONS(6340),
    [anon_sym___subscript] = ACTIONS(6340),
    [anon_sym_property] = ACTIONS(6340),
    [anon_sym_associatedtype] = ACTIONS(6340),
  },
  [2442] = {
    [sym_identifier] = ACTIONS(3796),
    [aux_sym_preproc_def_token1] = ACTIONS(3796),
    [aux_sym_preproc_if_token1] = ACTIONS(3796),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3796),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3796),
    [sym_preproc_directive] = ACTIONS(3796),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_TILDE] = ACTIONS(3798),
    [anon_sym_STAR] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_AMP] = ACTIONS(3796),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym___extension__] = ACTIONS(3796),
    [anon_sym_typedef] = ACTIONS(3796),
    [anon_sym_in] = ACTIONS(3796),
    [anon_sym_out] = ACTIONS(3796),
    [anon_sym_inout] = ACTIONS(3796),
    [anon_sym_virtual] = ACTIONS(3796),
    [anon_sym_extern] = ACTIONS(3796),
    [anon_sym___attribute__] = ACTIONS(3796),
    [anon_sym___attribute] = ACTIONS(3796),
    [anon_sym_using] = ACTIONS(3796),
    [anon_sym_COLON_COLON] = ACTIONS(3798),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3798),
    [anon_sym___declspec] = ACTIONS(3796),
    [anon_sym___based] = ACTIONS(3796),
    [anon_sym_RBRACE] = ACTIONS(3798),
    [anon_sym_signed] = ACTIONS(3796),
    [anon_sym_unsigned] = ACTIONS(3796),
    [anon_sym_long] = ACTIONS(3796),
    [anon_sym_short] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3796),
    [anon_sym_static] = ACTIONS(3796),
    [anon_sym_register] = ACTIONS(3796),
    [anon_sym_inline] = ACTIONS(3796),
    [anon_sym___inline] = ACTIONS(3796),
    [anon_sym___inline__] = ACTIONS(3796),
    [anon_sym___forceinline] = ACTIONS(3796),
    [anon_sym_thread_local] = ACTIONS(3796),
    [anon_sym___thread] = ACTIONS(3796),
    [anon_sym_const] = ACTIONS(3796),
    [anon_sym_constexpr] = ACTIONS(3796),
    [anon_sym_volatile] = ACTIONS(3796),
    [anon_sym_restrict] = ACTIONS(3796),
    [anon_sym___restrict__] = ACTIONS(3796),
    [anon_sym__Atomic] = ACTIONS(3796),
    [anon_sym__Noreturn] = ACTIONS(3796),
    [anon_sym_noreturn] = ACTIONS(3796),
    [anon_sym__Nonnull] = ACTIONS(3796),
    [anon_sym_mutable] = ACTIONS(3796),
    [anon_sym_constinit] = ACTIONS(3796),
    [anon_sym_consteval] = ACTIONS(3796),
    [anon_sym_alignas] = ACTIONS(3796),
    [anon_sym__Alignas] = ACTIONS(3796),
    [sym_primitive_type] = ACTIONS(3796),
    [anon_sym_enum] = ACTIONS(3796),
    [anon_sym_class] = ACTIONS(3796),
    [anon_sym_struct] = ACTIONS(3796),
    [anon_sym_union] = ACTIONS(3796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3796),
    [anon_sym_let] = ACTIONS(3796),
    [anon_sym_This] = ACTIONS(3796),
    [anon_sym_decltype] = ACTIONS(3796),
    [anon_sym_explicit] = ACTIONS(3796),
    [anon_sym_typename] = ACTIONS(3796),
    [anon_sym_private] = ACTIONS(3796),
    [anon_sym_template] = ACTIONS(3796),
    [anon_sym_operator] = ACTIONS(3796),
    [anon_sym_friend] = ACTIONS(3796),
    [anon_sym_public] = ACTIONS(3796),
    [anon_sym_protected] = ACTIONS(3796),
    [anon_sym_static_assert] = ACTIONS(3796),
    [anon_sym_precise] = ACTIONS(3796),
    [anon_sym_shared] = ACTIONS(3796),
    [anon_sym_groupshared] = ACTIONS(3796),
    [anon_sym_uniform] = ACTIONS(3796),
    [anon_sym_row_major] = ACTIONS(3796),
    [anon_sym_column_major] = ACTIONS(3796),
    [anon_sym_globallycoherent] = ACTIONS(3796),
    [anon_sym_centroid] = ACTIONS(3796),
    [anon_sym_noperspective] = ACTIONS(3796),
    [anon_sym_nointerpolation] = ACTIONS(3796),
    [anon_sym_sample] = ACTIONS(3796),
    [anon_sym_linear] = ACTIONS(3796),
    [anon_sym_snorm] = ACTIONS(3796),
    [anon_sym_unorm] = ACTIONS(3796),
    [anon_sym_point] = ACTIONS(3796),
    [anon_sym_line] = ACTIONS(3796),
    [anon_sym_triangleadj] = ACTIONS(3796),
    [anon_sym_lineadj] = ACTIONS(3796),
    [anon_sym_triangle] = ACTIONS(3796),
    [anon_sym_interface] = ACTIONS(3796),
    [anon_sym_extension] = ACTIONS(3796),
    [anon_sym___init] = ACTIONS(3796),
    [anon_sym___subscript] = ACTIONS(3796),
    [anon_sym_property] = ACTIONS(3796),
    [anon_sym_associatedtype] = ACTIONS(3796),
  },
  [2443] = {
    [sym_expression] = STATE(4812),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(6452),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [2444] = {
    [sym_expression] = STATE(4809),
    [sym__string] = STATE(5253),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(3751),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(3751),
    [sym_call_expression] = STATE(3751),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(3751),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(3751),
    [sym_char_literal] = STATE(5253),
    [sym_concatenated_string] = STATE(5253),
    [sym_string_literal] = STATE(3844),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(3844),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3751),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(3751),
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(6452),
    [anon_sym_BANG] = ACTIONS(5389),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym_COLON_COLON] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5387),
    [anon_sym_compl] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_sizeof] = ACTIONS(5397),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5399),
    [anon_sym_L_SQUOTE] = ACTIONS(5401),
    [anon_sym_u_SQUOTE] = ACTIONS(5401),
    [anon_sym_U_SQUOTE] = ACTIONS(5401),
    [anon_sym_u8_SQUOTE] = ACTIONS(5401),
    [anon_sym_SQUOTE] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5403),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
    [anon_sym_co_await] = ACTIONS(5405),
    [anon_sym_new] = ACTIONS(5407),
    [anon_sym_requires] = ACTIONS(5409),
    [sym_this] = ACTIONS(249),
  },
  [2445] = {
    [sym_identifier] = ACTIONS(6348),
    [aux_sym_preproc_def_token1] = ACTIONS(6348),
    [aux_sym_preproc_if_token1] = ACTIONS(6348),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6348),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6348),
    [sym_preproc_directive] = ACTIONS(6348),
    [anon_sym_LPAREN2] = ACTIONS(6350),
    [anon_sym_TILDE] = ACTIONS(6350),
    [anon_sym_STAR] = ACTIONS(6350),
    [anon_sym_AMP_AMP] = ACTIONS(6350),
    [anon_sym_AMP] = ACTIONS(6348),
    [anon_sym_SEMI] = ACTIONS(6350),
    [anon_sym___extension__] = ACTIONS(6348),
    [anon_sym_typedef] = ACTIONS(6348),
    [anon_sym_in] = ACTIONS(6348),
    [anon_sym_out] = ACTIONS(6348),
    [anon_sym_inout] = ACTIONS(6348),
    [anon_sym_virtual] = ACTIONS(6348),
    [anon_sym_extern] = ACTIONS(6348),
    [anon_sym___attribute__] = ACTIONS(6348),
    [anon_sym___attribute] = ACTIONS(6348),
    [anon_sym_using] = ACTIONS(6348),
    [anon_sym_COLON_COLON] = ACTIONS(6350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6350),
    [anon_sym___declspec] = ACTIONS(6348),
    [anon_sym___based] = ACTIONS(6348),
    [anon_sym_RBRACE] = ACTIONS(6350),
    [anon_sym_signed] = ACTIONS(6348),
    [anon_sym_unsigned] = ACTIONS(6348),
    [anon_sym_long] = ACTIONS(6348),
    [anon_sym_short] = ACTIONS(6348),
    [anon_sym_LBRACK] = ACTIONS(6348),
    [anon_sym_static] = ACTIONS(6348),
    [anon_sym_register] = ACTIONS(6348),
    [anon_sym_inline] = ACTIONS(6348),
    [anon_sym___inline] = ACTIONS(6348),
    [anon_sym___inline__] = ACTIONS(6348),
    [anon_sym___forceinline] = ACTIONS(6348),
    [anon_sym_thread_local] = ACTIONS(6348),
    [anon_sym___thread] = ACTIONS(6348),
    [anon_sym_const] = ACTIONS(6348),
    [anon_sym_constexpr] = ACTIONS(6348),
    [anon_sym_volatile] = ACTIONS(6348),
    [anon_sym_restrict] = ACTIONS(6348),
    [anon_sym___restrict__] = ACTIONS(6348),
    [anon_sym__Atomic] = ACTIONS(6348),
    [anon_sym__Noreturn] = ACTIONS(6348),
    [anon_sym_noreturn] = ACTIONS(6348),
    [anon_sym__Nonnull] = ACTIONS(6348),
    [anon_sym_mutable] = ACTIONS(6348),
    [anon_sym_constinit] = ACTIONS(6348),
    [anon_sym_consteval] = ACTIONS(6348),
    [anon_sym_alignas] = ACTIONS(6348),
    [anon_sym__Alignas] = ACTIONS(6348),
    [sym_primitive_type] = ACTIONS(6348),
    [anon_sym_enum] = ACTIONS(6348),
    [anon_sym_class] = ACTIONS(6348),
    [anon_sym_struct] = ACTIONS(6348),
    [anon_sym_union] = ACTIONS(6348),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6348),
    [anon_sym_let] = ACTIONS(6348),
    [anon_sym_This] = ACTIONS(6348),
    [anon_sym_decltype] = ACTIONS(6348),
    [anon_sym_explicit] = ACTIONS(6348),
    [anon_sym_typename] = ACTIONS(6348),
    [anon_sym_private] = ACTIONS(6348),
    [anon_sym_template] = ACTIONS(6348),
    [anon_sym_operator] = ACTIONS(6348),
    [anon_sym_friend] = ACTIONS(6348),
    [anon_sym_public] = ACTIONS(6348),
    [anon_sym_protected] = ACTIONS(6348),
    [anon_sym_static_assert] = ACTIONS(6348),
    [anon_sym_precise] = ACTIONS(6348),
    [anon_sym_shared] = ACTIONS(6348),
    [anon_sym_groupshared] = ACTIONS(6348),
    [anon_sym_uniform] = ACTIONS(6348),
    [anon_sym_row_major] = ACTIONS(6348),
    [anon_sym_column_major] = ACTIONS(6348),
    [anon_sym_globallycoherent] = ACTIONS(6348),
    [anon_sym_centroid] = ACTIONS(6348),
    [anon_sym_noperspective] = ACTIONS(6348),
    [anon_sym_nointerpolation] = ACTIONS(6348),
    [anon_sym_sample] = ACTIONS(6348),
    [anon_sym_linear] = ACTIONS(6348),
    [anon_sym_snorm] = ACTIONS(6348),
    [anon_sym_unorm] = ACTIONS(6348),
    [anon_sym_point] = ACTIONS(6348),
    [anon_sym_line] = ACTIONS(6348),
    [anon_sym_triangleadj] = ACTIONS(6348),
    [anon_sym_lineadj] = ACTIONS(6348),
    [anon_sym_triangle] = ACTIONS(6348),
    [anon_sym_interface] = ACTIONS(6348),
    [anon_sym_extension] = ACTIONS(6348),
    [anon_sym___init] = ACTIONS(6348),
    [anon_sym___subscript] = ACTIONS(6348),
    [anon_sym_property] = ACTIONS(6348),
    [anon_sym_associatedtype] = ACTIONS(6348),
  },
  [2446] = {
    [sym_identifier] = ACTIONS(6352),
    [aux_sym_preproc_def_token1] = ACTIONS(6352),
    [aux_sym_preproc_if_token1] = ACTIONS(6352),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6352),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6352),
    [sym_preproc_directive] = ACTIONS(6352),
    [anon_sym_LPAREN2] = ACTIONS(6354),
    [anon_sym_TILDE] = ACTIONS(6354),
    [anon_sym_STAR] = ACTIONS(6354),
    [anon_sym_AMP_AMP] = ACTIONS(6354),
    [anon_sym_AMP] = ACTIONS(6352),
    [anon_sym_SEMI] = ACTIONS(6354),
    [anon_sym___extension__] = ACTIONS(6352),
    [anon_sym_typedef] = ACTIONS(6352),
    [anon_sym_in] = ACTIONS(6352),
    [anon_sym_out] = ACTIONS(6352),
    [anon_sym_inout] = ACTIONS(6352),
    [anon_sym_virtual] = ACTIONS(6352),
    [anon_sym_extern] = ACTIONS(6352),
    [anon_sym___attribute__] = ACTIONS(6352),
    [anon_sym___attribute] = ACTIONS(6352),
    [anon_sym_using] = ACTIONS(6352),
    [anon_sym_COLON_COLON] = ACTIONS(6354),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6354),
    [anon_sym___declspec] = ACTIONS(6352),
    [anon_sym___based] = ACTIONS(6352),
    [anon_sym_RBRACE] = ACTIONS(6354),
    [anon_sym_signed] = ACTIONS(6352),
    [anon_sym_unsigned] = ACTIONS(6352),
    [anon_sym_long] = ACTIONS(6352),
    [anon_sym_short] = ACTIONS(6352),
    [anon_sym_LBRACK] = ACTIONS(6352),
    [anon_sym_static] = ACTIONS(6352),
    [anon_sym_register] = ACTIONS(6352),
    [anon_sym_inline] = ACTIONS(6352),
    [anon_sym___inline] = ACTIONS(6352),
    [anon_sym___inline__] = ACTIONS(6352),
    [anon_sym___forceinline] = ACTIONS(6352),
    [anon_sym_thread_local] = ACTIONS(6352),
    [anon_sym___thread] = ACTIONS(6352),
    [anon_sym_const] = ACTIONS(6352),
    [anon_sym_constexpr] = ACTIONS(6352),
    [anon_sym_volatile] = ACTIONS(6352),
    [anon_sym_restrict] = ACTIONS(6352),
    [anon_sym___restrict__] = ACTIONS(6352),
    [anon_sym__Atomic] = ACTIONS(6352),
    [anon_sym__Noreturn] = ACTIONS(6352),
    [anon_sym_noreturn] = ACTIONS(6352),
    [anon_sym__Nonnull] = ACTIONS(6352),
    [anon_sym_mutable] = ACTIONS(6352),
    [anon_sym_constinit] = ACTIONS(6352),
    [anon_sym_consteval] = ACTIONS(6352),
    [anon_sym_alignas] = ACTIONS(6352),
    [anon_sym__Alignas] = ACTIONS(6352),
    [sym_primitive_type] = ACTIONS(6352),
    [anon_sym_enum] = ACTIONS(6352),
    [anon_sym_class] = ACTIONS(6352),
    [anon_sym_struct] = ACTIONS(6352),
    [anon_sym_union] = ACTIONS(6352),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6352),
    [anon_sym_let] = ACTIONS(6352),
    [anon_sym_This] = ACTIONS(6352),
    [anon_sym_decltype] = ACTIONS(6352),
    [anon_sym_explicit] = ACTIONS(6352),
    [anon_sym_typename] = ACTIONS(6352),
    [anon_sym_private] = ACTIONS(6352),
    [anon_sym_template] = ACTIONS(6352),
    [anon_sym_operator] = ACTIONS(6352),
    [anon_sym_friend] = ACTIONS(6352),
    [anon_sym_public] = ACTIONS(6352),
    [anon_sym_protected] = ACTIONS(6352),
    [anon_sym_static_assert] = ACTIONS(6352),
    [anon_sym_precise] = ACTIONS(6352),
    [anon_sym_shared] = ACTIONS(6352),
    [anon_sym_groupshared] = ACTIONS(6352),
    [anon_sym_uniform] = ACTIONS(6352),
    [anon_sym_row_major] = ACTIONS(6352),
    [anon_sym_column_major] = ACTIONS(6352),
    [anon_sym_globallycoherent] = ACTIONS(6352),
    [anon_sym_centroid] = ACTIONS(6352),
    [anon_sym_noperspective] = ACTIONS(6352),
    [anon_sym_nointerpolation] = ACTIONS(6352),
    [anon_sym_sample] = ACTIONS(6352),
    [anon_sym_linear] = ACTIONS(6352),
    [anon_sym_snorm] = ACTIONS(6352),
    [anon_sym_unorm] = ACTIONS(6352),
    [anon_sym_point] = ACTIONS(6352),
    [anon_sym_line] = ACTIONS(6352),
    [anon_sym_triangleadj] = ACTIONS(6352),
    [anon_sym_lineadj] = ACTIONS(6352),
    [anon_sym_triangle] = ACTIONS(6352),
    [anon_sym_interface] = ACTIONS(6352),
    [anon_sym_extension] = ACTIONS(6352),
    [anon_sym___init] = ACTIONS(6352),
    [anon_sym___subscript] = ACTIONS(6352),
    [anon_sym_property] = ACTIONS(6352),
    [anon_sym_associatedtype] = ACTIONS(6352),
  },
  [2447] = {
    [sym_expression] = STATE(3370),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5032),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2448] = {
    [sym_expression] = STATE(3355),
    [sym__string] = STATE(4281),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(4281),
    [sym_concatenated_string] = STATE(4281),
    [sym_string_literal] = STATE(3290),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3290),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5030),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5032),
    [anon_sym_COLON_COLON] = ACTIONS(5034),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5028),
    [anon_sym_compl] = ACTIONS(5028),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_sizeof] = ACTIONS(5036),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5038),
    [anon_sym_L_SQUOTE] = ACTIONS(5040),
    [anon_sym_u_SQUOTE] = ACTIONS(5040),
    [anon_sym_U_SQUOTE] = ACTIONS(5040),
    [anon_sym_u8_SQUOTE] = ACTIONS(5040),
    [anon_sym_SQUOTE] = ACTIONS(5040),
    [anon_sym_L_DQUOTE] = ACTIONS(5042),
    [anon_sym_u_DQUOTE] = ACTIONS(5042),
    [anon_sym_U_DQUOTE] = ACTIONS(5042),
    [anon_sym_u8_DQUOTE] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(5042),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5044),
    [anon_sym_R_DQUOTE] = ACTIONS(5046),
    [anon_sym_LR_DQUOTE] = ACTIONS(5046),
    [anon_sym_uR_DQUOTE] = ACTIONS(5046),
    [anon_sym_UR_DQUOTE] = ACTIONS(5046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5046),
    [anon_sym_co_await] = ACTIONS(5048),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2449] = {
    [sym_expression] = STATE(3370),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6460),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4956),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_DASH_DASH] = ACTIONS(5544),
    [anon_sym_PLUS_PLUS] = ACTIONS(5544),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2450] = {
    [sym_expression] = STATE(3355),
    [sym__string] = STATE(3674),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3674),
    [sym_concatenated_string] = STATE(3674),
    [sym_string_literal] = STATE(3120),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3120),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6460),
    [anon_sym_BANG] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_DASH] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4956),
    [anon_sym_STAR] = ACTIONS(5542),
    [anon_sym_AMP] = ACTIONS(5542),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(4956),
    [anon_sym_compl] = ACTIONS(4956),
    [anon_sym_DASH_DASH] = ACTIONS(5544),
    [anon_sym_PLUS_PLUS] = ACTIONS(5544),
    [anon_sym_sizeof] = ACTIONS(4968),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(4978),
    [anon_sym_L_SQUOTE] = ACTIONS(4980),
    [anon_sym_u_SQUOTE] = ACTIONS(4980),
    [anon_sym_U_SQUOTE] = ACTIONS(4980),
    [anon_sym_u8_SQUOTE] = ACTIONS(4980),
    [anon_sym_SQUOTE] = ACTIONS(4980),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(4988),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [anon_sym_co_await] = ACTIONS(4992),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2451] = {
    [sym_expression] = STATE(3757),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2452] = {
    [sym_identifier] = ACTIONS(6356),
    [aux_sym_preproc_def_token1] = ACTIONS(6356),
    [aux_sym_preproc_if_token1] = ACTIONS(6356),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6356),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6356),
    [sym_preproc_directive] = ACTIONS(6356),
    [anon_sym_LPAREN2] = ACTIONS(6358),
    [anon_sym_TILDE] = ACTIONS(6358),
    [anon_sym_STAR] = ACTIONS(6358),
    [anon_sym_AMP_AMP] = ACTIONS(6358),
    [anon_sym_AMP] = ACTIONS(6356),
    [anon_sym_SEMI] = ACTIONS(6358),
    [anon_sym___extension__] = ACTIONS(6356),
    [anon_sym_typedef] = ACTIONS(6356),
    [anon_sym_in] = ACTIONS(6356),
    [anon_sym_out] = ACTIONS(6356),
    [anon_sym_inout] = ACTIONS(6356),
    [anon_sym_virtual] = ACTIONS(6356),
    [anon_sym_extern] = ACTIONS(6356),
    [anon_sym___attribute__] = ACTIONS(6356),
    [anon_sym___attribute] = ACTIONS(6356),
    [anon_sym_using] = ACTIONS(6356),
    [anon_sym_COLON_COLON] = ACTIONS(6358),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6358),
    [anon_sym___declspec] = ACTIONS(6356),
    [anon_sym___based] = ACTIONS(6356),
    [anon_sym_RBRACE] = ACTIONS(6358),
    [anon_sym_signed] = ACTIONS(6356),
    [anon_sym_unsigned] = ACTIONS(6356),
    [anon_sym_long] = ACTIONS(6356),
    [anon_sym_short] = ACTIONS(6356),
    [anon_sym_LBRACK] = ACTIONS(6356),
    [anon_sym_static] = ACTIONS(6356),
    [anon_sym_register] = ACTIONS(6356),
    [anon_sym_inline] = ACTIONS(6356),
    [anon_sym___inline] = ACTIONS(6356),
    [anon_sym___inline__] = ACTIONS(6356),
    [anon_sym___forceinline] = ACTIONS(6356),
    [anon_sym_thread_local] = ACTIONS(6356),
    [anon_sym___thread] = ACTIONS(6356),
    [anon_sym_const] = ACTIONS(6356),
    [anon_sym_constexpr] = ACTIONS(6356),
    [anon_sym_volatile] = ACTIONS(6356),
    [anon_sym_restrict] = ACTIONS(6356),
    [anon_sym___restrict__] = ACTIONS(6356),
    [anon_sym__Atomic] = ACTIONS(6356),
    [anon_sym__Noreturn] = ACTIONS(6356),
    [anon_sym_noreturn] = ACTIONS(6356),
    [anon_sym__Nonnull] = ACTIONS(6356),
    [anon_sym_mutable] = ACTIONS(6356),
    [anon_sym_constinit] = ACTIONS(6356),
    [anon_sym_consteval] = ACTIONS(6356),
    [anon_sym_alignas] = ACTIONS(6356),
    [anon_sym__Alignas] = ACTIONS(6356),
    [sym_primitive_type] = ACTIONS(6356),
    [anon_sym_enum] = ACTIONS(6356),
    [anon_sym_class] = ACTIONS(6356),
    [anon_sym_struct] = ACTIONS(6356),
    [anon_sym_union] = ACTIONS(6356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6356),
    [anon_sym_let] = ACTIONS(6356),
    [anon_sym_This] = ACTIONS(6356),
    [anon_sym_decltype] = ACTIONS(6356),
    [anon_sym_explicit] = ACTIONS(6356),
    [anon_sym_typename] = ACTIONS(6356),
    [anon_sym_private] = ACTIONS(6356),
    [anon_sym_template] = ACTIONS(6356),
    [anon_sym_operator] = ACTIONS(6356),
    [anon_sym_friend] = ACTIONS(6356),
    [anon_sym_public] = ACTIONS(6356),
    [anon_sym_protected] = ACTIONS(6356),
    [anon_sym_static_assert] = ACTIONS(6356),
    [anon_sym_precise] = ACTIONS(6356),
    [anon_sym_shared] = ACTIONS(6356),
    [anon_sym_groupshared] = ACTIONS(6356),
    [anon_sym_uniform] = ACTIONS(6356),
    [anon_sym_row_major] = ACTIONS(6356),
    [anon_sym_column_major] = ACTIONS(6356),
    [anon_sym_globallycoherent] = ACTIONS(6356),
    [anon_sym_centroid] = ACTIONS(6356),
    [anon_sym_noperspective] = ACTIONS(6356),
    [anon_sym_nointerpolation] = ACTIONS(6356),
    [anon_sym_sample] = ACTIONS(6356),
    [anon_sym_linear] = ACTIONS(6356),
    [anon_sym_snorm] = ACTIONS(6356),
    [anon_sym_unorm] = ACTIONS(6356),
    [anon_sym_point] = ACTIONS(6356),
    [anon_sym_line] = ACTIONS(6356),
    [anon_sym_triangleadj] = ACTIONS(6356),
    [anon_sym_lineadj] = ACTIONS(6356),
    [anon_sym_triangle] = ACTIONS(6356),
    [anon_sym_interface] = ACTIONS(6356),
    [anon_sym_extension] = ACTIONS(6356),
    [anon_sym___init] = ACTIONS(6356),
    [anon_sym___subscript] = ACTIONS(6356),
    [anon_sym_property] = ACTIONS(6356),
    [anon_sym_associatedtype] = ACTIONS(6356),
  },
  [2453] = {
    [sym_expression] = STATE(5375),
    [sym__string] = STATE(5489),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4363),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4363),
    [sym_call_expression] = STATE(4363),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4363),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4363),
    [sym_char_literal] = STATE(5489),
    [sym_concatenated_string] = STATE(5489),
    [sym_string_literal] = STATE(4621),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4621),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4363),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4363),
    [sym_identifier] = ACTIONS(5417),
    [anon_sym_LPAREN2] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5419),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5419),
    [anon_sym_compl] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_sizeof] = ACTIONS(5427),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(5429),
    [anon_sym_L_SQUOTE] = ACTIONS(5431),
    [anon_sym_u_SQUOTE] = ACTIONS(5431),
    [anon_sym_U_SQUOTE] = ACTIONS(5431),
    [anon_sym_u8_SQUOTE] = ACTIONS(5431),
    [anon_sym_SQUOTE] = ACTIONS(5431),
    [anon_sym_L_DQUOTE] = ACTIONS(5433),
    [anon_sym_u_DQUOTE] = ACTIONS(5433),
    [anon_sym_U_DQUOTE] = ACTIONS(5433),
    [anon_sym_u8_DQUOTE] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(5433),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5435),
    [anon_sym_R_DQUOTE] = ACTIONS(5437),
    [anon_sym_LR_DQUOTE] = ACTIONS(5437),
    [anon_sym_uR_DQUOTE] = ACTIONS(5437),
    [anon_sym_UR_DQUOTE] = ACTIONS(5437),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5437),
    [anon_sym_co_await] = ACTIONS(5439),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2454] = {
    [sym_identifier] = ACTIONS(6360),
    [aux_sym_preproc_def_token1] = ACTIONS(6360),
    [aux_sym_preproc_if_token1] = ACTIONS(6360),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6360),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6360),
    [sym_preproc_directive] = ACTIONS(6360),
    [anon_sym_LPAREN2] = ACTIONS(6362),
    [anon_sym_TILDE] = ACTIONS(6362),
    [anon_sym_STAR] = ACTIONS(6362),
    [anon_sym_AMP_AMP] = ACTIONS(6362),
    [anon_sym_AMP] = ACTIONS(6360),
    [anon_sym_SEMI] = ACTIONS(6362),
    [anon_sym___extension__] = ACTIONS(6360),
    [anon_sym_typedef] = ACTIONS(6360),
    [anon_sym_in] = ACTIONS(6360),
    [anon_sym_out] = ACTIONS(6360),
    [anon_sym_inout] = ACTIONS(6360),
    [anon_sym_virtual] = ACTIONS(6360),
    [anon_sym_extern] = ACTIONS(6360),
    [anon_sym___attribute__] = ACTIONS(6360),
    [anon_sym___attribute] = ACTIONS(6360),
    [anon_sym_using] = ACTIONS(6360),
    [anon_sym_COLON_COLON] = ACTIONS(6362),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6362),
    [anon_sym___declspec] = ACTIONS(6360),
    [anon_sym___based] = ACTIONS(6360),
    [anon_sym_RBRACE] = ACTIONS(6362),
    [anon_sym_signed] = ACTIONS(6360),
    [anon_sym_unsigned] = ACTIONS(6360),
    [anon_sym_long] = ACTIONS(6360),
    [anon_sym_short] = ACTIONS(6360),
    [anon_sym_LBRACK] = ACTIONS(6360),
    [anon_sym_static] = ACTIONS(6360),
    [anon_sym_register] = ACTIONS(6360),
    [anon_sym_inline] = ACTIONS(6360),
    [anon_sym___inline] = ACTIONS(6360),
    [anon_sym___inline__] = ACTIONS(6360),
    [anon_sym___forceinline] = ACTIONS(6360),
    [anon_sym_thread_local] = ACTIONS(6360),
    [anon_sym___thread] = ACTIONS(6360),
    [anon_sym_const] = ACTIONS(6360),
    [anon_sym_constexpr] = ACTIONS(6360),
    [anon_sym_volatile] = ACTIONS(6360),
    [anon_sym_restrict] = ACTIONS(6360),
    [anon_sym___restrict__] = ACTIONS(6360),
    [anon_sym__Atomic] = ACTIONS(6360),
    [anon_sym__Noreturn] = ACTIONS(6360),
    [anon_sym_noreturn] = ACTIONS(6360),
    [anon_sym__Nonnull] = ACTIONS(6360),
    [anon_sym_mutable] = ACTIONS(6360),
    [anon_sym_constinit] = ACTIONS(6360),
    [anon_sym_consteval] = ACTIONS(6360),
    [anon_sym_alignas] = ACTIONS(6360),
    [anon_sym__Alignas] = ACTIONS(6360),
    [sym_primitive_type] = ACTIONS(6360),
    [anon_sym_enum] = ACTIONS(6360),
    [anon_sym_class] = ACTIONS(6360),
    [anon_sym_struct] = ACTIONS(6360),
    [anon_sym_union] = ACTIONS(6360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6360),
    [anon_sym_let] = ACTIONS(6360),
    [anon_sym_This] = ACTIONS(6360),
    [anon_sym_decltype] = ACTIONS(6360),
    [anon_sym_explicit] = ACTIONS(6360),
    [anon_sym_typename] = ACTIONS(6360),
    [anon_sym_private] = ACTIONS(6360),
    [anon_sym_template] = ACTIONS(6360),
    [anon_sym_operator] = ACTIONS(6360),
    [anon_sym_friend] = ACTIONS(6360),
    [anon_sym_public] = ACTIONS(6360),
    [anon_sym_protected] = ACTIONS(6360),
    [anon_sym_static_assert] = ACTIONS(6360),
    [anon_sym_precise] = ACTIONS(6360),
    [anon_sym_shared] = ACTIONS(6360),
    [anon_sym_groupshared] = ACTIONS(6360),
    [anon_sym_uniform] = ACTIONS(6360),
    [anon_sym_row_major] = ACTIONS(6360),
    [anon_sym_column_major] = ACTIONS(6360),
    [anon_sym_globallycoherent] = ACTIONS(6360),
    [anon_sym_centroid] = ACTIONS(6360),
    [anon_sym_noperspective] = ACTIONS(6360),
    [anon_sym_nointerpolation] = ACTIONS(6360),
    [anon_sym_sample] = ACTIONS(6360),
    [anon_sym_linear] = ACTIONS(6360),
    [anon_sym_snorm] = ACTIONS(6360),
    [anon_sym_unorm] = ACTIONS(6360),
    [anon_sym_point] = ACTIONS(6360),
    [anon_sym_line] = ACTIONS(6360),
    [anon_sym_triangleadj] = ACTIONS(6360),
    [anon_sym_lineadj] = ACTIONS(6360),
    [anon_sym_triangle] = ACTIONS(6360),
    [anon_sym_interface] = ACTIONS(6360),
    [anon_sym_extension] = ACTIONS(6360),
    [anon_sym___init] = ACTIONS(6360),
    [anon_sym___subscript] = ACTIONS(6360),
    [anon_sym_property] = ACTIONS(6360),
    [anon_sym_associatedtype] = ACTIONS(6360),
  },
  [2455] = {
    [sym_identifier] = ACTIONS(6368),
    [aux_sym_preproc_def_token1] = ACTIONS(6368),
    [aux_sym_preproc_if_token1] = ACTIONS(6368),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6368),
    [sym_preproc_directive] = ACTIONS(6368),
    [anon_sym_LPAREN2] = ACTIONS(6370),
    [anon_sym_TILDE] = ACTIONS(6370),
    [anon_sym_STAR] = ACTIONS(6370),
    [anon_sym_AMP_AMP] = ACTIONS(6370),
    [anon_sym_AMP] = ACTIONS(6368),
    [anon_sym_SEMI] = ACTIONS(6370),
    [anon_sym___extension__] = ACTIONS(6368),
    [anon_sym_typedef] = ACTIONS(6368),
    [anon_sym_in] = ACTIONS(6368),
    [anon_sym_out] = ACTIONS(6368),
    [anon_sym_inout] = ACTIONS(6368),
    [anon_sym_virtual] = ACTIONS(6368),
    [anon_sym_extern] = ACTIONS(6368),
    [anon_sym___attribute__] = ACTIONS(6368),
    [anon_sym___attribute] = ACTIONS(6368),
    [anon_sym_using] = ACTIONS(6368),
    [anon_sym_COLON_COLON] = ACTIONS(6370),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6370),
    [anon_sym___declspec] = ACTIONS(6368),
    [anon_sym___based] = ACTIONS(6368),
    [anon_sym_RBRACE] = ACTIONS(6370),
    [anon_sym_signed] = ACTIONS(6368),
    [anon_sym_unsigned] = ACTIONS(6368),
    [anon_sym_long] = ACTIONS(6368),
    [anon_sym_short] = ACTIONS(6368),
    [anon_sym_LBRACK] = ACTIONS(6368),
    [anon_sym_static] = ACTIONS(6368),
    [anon_sym_register] = ACTIONS(6368),
    [anon_sym_inline] = ACTIONS(6368),
    [anon_sym___inline] = ACTIONS(6368),
    [anon_sym___inline__] = ACTIONS(6368),
    [anon_sym___forceinline] = ACTIONS(6368),
    [anon_sym_thread_local] = ACTIONS(6368),
    [anon_sym___thread] = ACTIONS(6368),
    [anon_sym_const] = ACTIONS(6368),
    [anon_sym_constexpr] = ACTIONS(6368),
    [anon_sym_volatile] = ACTIONS(6368),
    [anon_sym_restrict] = ACTIONS(6368),
    [anon_sym___restrict__] = ACTIONS(6368),
    [anon_sym__Atomic] = ACTIONS(6368),
    [anon_sym__Noreturn] = ACTIONS(6368),
    [anon_sym_noreturn] = ACTIONS(6368),
    [anon_sym__Nonnull] = ACTIONS(6368),
    [anon_sym_mutable] = ACTIONS(6368),
    [anon_sym_constinit] = ACTIONS(6368),
    [anon_sym_consteval] = ACTIONS(6368),
    [anon_sym_alignas] = ACTIONS(6368),
    [anon_sym__Alignas] = ACTIONS(6368),
    [sym_primitive_type] = ACTIONS(6368),
    [anon_sym_enum] = ACTIONS(6368),
    [anon_sym_class] = ACTIONS(6368),
    [anon_sym_struct] = ACTIONS(6368),
    [anon_sym_union] = ACTIONS(6368),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6368),
    [anon_sym_let] = ACTIONS(6368),
    [anon_sym_This] = ACTIONS(6368),
    [anon_sym_decltype] = ACTIONS(6368),
    [anon_sym_explicit] = ACTIONS(6368),
    [anon_sym_typename] = ACTIONS(6368),
    [anon_sym_private] = ACTIONS(6368),
    [anon_sym_template] = ACTIONS(6368),
    [anon_sym_operator] = ACTIONS(6368),
    [anon_sym_friend] = ACTIONS(6368),
    [anon_sym_public] = ACTIONS(6368),
    [anon_sym_protected] = ACTIONS(6368),
    [anon_sym_static_assert] = ACTIONS(6368),
    [anon_sym_precise] = ACTIONS(6368),
    [anon_sym_shared] = ACTIONS(6368),
    [anon_sym_groupshared] = ACTIONS(6368),
    [anon_sym_uniform] = ACTIONS(6368),
    [anon_sym_row_major] = ACTIONS(6368),
    [anon_sym_column_major] = ACTIONS(6368),
    [anon_sym_globallycoherent] = ACTIONS(6368),
    [anon_sym_centroid] = ACTIONS(6368),
    [anon_sym_noperspective] = ACTIONS(6368),
    [anon_sym_nointerpolation] = ACTIONS(6368),
    [anon_sym_sample] = ACTIONS(6368),
    [anon_sym_linear] = ACTIONS(6368),
    [anon_sym_snorm] = ACTIONS(6368),
    [anon_sym_unorm] = ACTIONS(6368),
    [anon_sym_point] = ACTIONS(6368),
    [anon_sym_line] = ACTIONS(6368),
    [anon_sym_triangleadj] = ACTIONS(6368),
    [anon_sym_lineadj] = ACTIONS(6368),
    [anon_sym_triangle] = ACTIONS(6368),
    [anon_sym_interface] = ACTIONS(6368),
    [anon_sym_extension] = ACTIONS(6368),
    [anon_sym___init] = ACTIONS(6368),
    [anon_sym___subscript] = ACTIONS(6368),
    [anon_sym_property] = ACTIONS(6368),
    [anon_sym_associatedtype] = ACTIONS(6368),
  },
  [2456] = {
    [sym_identifier] = ACTIONS(6372),
    [aux_sym_preproc_def_token1] = ACTIONS(6372),
    [aux_sym_preproc_if_token1] = ACTIONS(6372),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6372),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6372),
    [sym_preproc_directive] = ACTIONS(6372),
    [anon_sym_LPAREN2] = ACTIONS(6374),
    [anon_sym_TILDE] = ACTIONS(6374),
    [anon_sym_STAR] = ACTIONS(6374),
    [anon_sym_AMP_AMP] = ACTIONS(6374),
    [anon_sym_AMP] = ACTIONS(6372),
    [anon_sym_SEMI] = ACTIONS(6374),
    [anon_sym___extension__] = ACTIONS(6372),
    [anon_sym_typedef] = ACTIONS(6372),
    [anon_sym_in] = ACTIONS(6372),
    [anon_sym_out] = ACTIONS(6372),
    [anon_sym_inout] = ACTIONS(6372),
    [anon_sym_virtual] = ACTIONS(6372),
    [anon_sym_extern] = ACTIONS(6372),
    [anon_sym___attribute__] = ACTIONS(6372),
    [anon_sym___attribute] = ACTIONS(6372),
    [anon_sym_using] = ACTIONS(6372),
    [anon_sym_COLON_COLON] = ACTIONS(6374),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6374),
    [anon_sym___declspec] = ACTIONS(6372),
    [anon_sym___based] = ACTIONS(6372),
    [anon_sym_RBRACE] = ACTIONS(6374),
    [anon_sym_signed] = ACTIONS(6372),
    [anon_sym_unsigned] = ACTIONS(6372),
    [anon_sym_long] = ACTIONS(6372),
    [anon_sym_short] = ACTIONS(6372),
    [anon_sym_LBRACK] = ACTIONS(6372),
    [anon_sym_static] = ACTIONS(6372),
    [anon_sym_register] = ACTIONS(6372),
    [anon_sym_inline] = ACTIONS(6372),
    [anon_sym___inline] = ACTIONS(6372),
    [anon_sym___inline__] = ACTIONS(6372),
    [anon_sym___forceinline] = ACTIONS(6372),
    [anon_sym_thread_local] = ACTIONS(6372),
    [anon_sym___thread] = ACTIONS(6372),
    [anon_sym_const] = ACTIONS(6372),
    [anon_sym_constexpr] = ACTIONS(6372),
    [anon_sym_volatile] = ACTIONS(6372),
    [anon_sym_restrict] = ACTIONS(6372),
    [anon_sym___restrict__] = ACTIONS(6372),
    [anon_sym__Atomic] = ACTIONS(6372),
    [anon_sym__Noreturn] = ACTIONS(6372),
    [anon_sym_noreturn] = ACTIONS(6372),
    [anon_sym__Nonnull] = ACTIONS(6372),
    [anon_sym_mutable] = ACTIONS(6372),
    [anon_sym_constinit] = ACTIONS(6372),
    [anon_sym_consteval] = ACTIONS(6372),
    [anon_sym_alignas] = ACTIONS(6372),
    [anon_sym__Alignas] = ACTIONS(6372),
    [sym_primitive_type] = ACTIONS(6372),
    [anon_sym_enum] = ACTIONS(6372),
    [anon_sym_class] = ACTIONS(6372),
    [anon_sym_struct] = ACTIONS(6372),
    [anon_sym_union] = ACTIONS(6372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6372),
    [anon_sym_let] = ACTIONS(6372),
    [anon_sym_This] = ACTIONS(6372),
    [anon_sym_decltype] = ACTIONS(6372),
    [anon_sym_explicit] = ACTIONS(6372),
    [anon_sym_typename] = ACTIONS(6372),
    [anon_sym_private] = ACTIONS(6372),
    [anon_sym_template] = ACTIONS(6372),
    [anon_sym_operator] = ACTIONS(6372),
    [anon_sym_friend] = ACTIONS(6372),
    [anon_sym_public] = ACTIONS(6372),
    [anon_sym_protected] = ACTIONS(6372),
    [anon_sym_static_assert] = ACTIONS(6372),
    [anon_sym_precise] = ACTIONS(6372),
    [anon_sym_shared] = ACTIONS(6372),
    [anon_sym_groupshared] = ACTIONS(6372),
    [anon_sym_uniform] = ACTIONS(6372),
    [anon_sym_row_major] = ACTIONS(6372),
    [anon_sym_column_major] = ACTIONS(6372),
    [anon_sym_globallycoherent] = ACTIONS(6372),
    [anon_sym_centroid] = ACTIONS(6372),
    [anon_sym_noperspective] = ACTIONS(6372),
    [anon_sym_nointerpolation] = ACTIONS(6372),
    [anon_sym_sample] = ACTIONS(6372),
    [anon_sym_linear] = ACTIONS(6372),
    [anon_sym_snorm] = ACTIONS(6372),
    [anon_sym_unorm] = ACTIONS(6372),
    [anon_sym_point] = ACTIONS(6372),
    [anon_sym_line] = ACTIONS(6372),
    [anon_sym_triangleadj] = ACTIONS(6372),
    [anon_sym_lineadj] = ACTIONS(6372),
    [anon_sym_triangle] = ACTIONS(6372),
    [anon_sym_interface] = ACTIONS(6372),
    [anon_sym_extension] = ACTIONS(6372),
    [anon_sym___init] = ACTIONS(6372),
    [anon_sym___subscript] = ACTIONS(6372),
    [anon_sym_property] = ACTIONS(6372),
    [anon_sym_associatedtype] = ACTIONS(6372),
  },
  [2457] = {
    [sym_identifier] = ACTIONS(6372),
    [aux_sym_preproc_def_token1] = ACTIONS(6372),
    [aux_sym_preproc_if_token1] = ACTIONS(6372),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6372),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6372),
    [sym_preproc_directive] = ACTIONS(6372),
    [anon_sym_LPAREN2] = ACTIONS(6374),
    [anon_sym_TILDE] = ACTIONS(6374),
    [anon_sym_STAR] = ACTIONS(6374),
    [anon_sym_AMP_AMP] = ACTIONS(6374),
    [anon_sym_AMP] = ACTIONS(6372),
    [anon_sym_SEMI] = ACTIONS(6374),
    [anon_sym___extension__] = ACTIONS(6372),
    [anon_sym_typedef] = ACTIONS(6372),
    [anon_sym_in] = ACTIONS(6372),
    [anon_sym_out] = ACTIONS(6372),
    [anon_sym_inout] = ACTIONS(6372),
    [anon_sym_virtual] = ACTIONS(6372),
    [anon_sym_extern] = ACTIONS(6372),
    [anon_sym___attribute__] = ACTIONS(6372),
    [anon_sym___attribute] = ACTIONS(6372),
    [anon_sym_using] = ACTIONS(6372),
    [anon_sym_COLON_COLON] = ACTIONS(6374),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6374),
    [anon_sym___declspec] = ACTIONS(6372),
    [anon_sym___based] = ACTIONS(6372),
    [anon_sym_RBRACE] = ACTIONS(6374),
    [anon_sym_signed] = ACTIONS(6372),
    [anon_sym_unsigned] = ACTIONS(6372),
    [anon_sym_long] = ACTIONS(6372),
    [anon_sym_short] = ACTIONS(6372),
    [anon_sym_LBRACK] = ACTIONS(6372),
    [anon_sym_static] = ACTIONS(6372),
    [anon_sym_register] = ACTIONS(6372),
    [anon_sym_inline] = ACTIONS(6372),
    [anon_sym___inline] = ACTIONS(6372),
    [anon_sym___inline__] = ACTIONS(6372),
    [anon_sym___forceinline] = ACTIONS(6372),
    [anon_sym_thread_local] = ACTIONS(6372),
    [anon_sym___thread] = ACTIONS(6372),
    [anon_sym_const] = ACTIONS(6372),
    [anon_sym_constexpr] = ACTIONS(6372),
    [anon_sym_volatile] = ACTIONS(6372),
    [anon_sym_restrict] = ACTIONS(6372),
    [anon_sym___restrict__] = ACTIONS(6372),
    [anon_sym__Atomic] = ACTIONS(6372),
    [anon_sym__Noreturn] = ACTIONS(6372),
    [anon_sym_noreturn] = ACTIONS(6372),
    [anon_sym__Nonnull] = ACTIONS(6372),
    [anon_sym_mutable] = ACTIONS(6372),
    [anon_sym_constinit] = ACTIONS(6372),
    [anon_sym_consteval] = ACTIONS(6372),
    [anon_sym_alignas] = ACTIONS(6372),
    [anon_sym__Alignas] = ACTIONS(6372),
    [sym_primitive_type] = ACTIONS(6372),
    [anon_sym_enum] = ACTIONS(6372),
    [anon_sym_class] = ACTIONS(6372),
    [anon_sym_struct] = ACTIONS(6372),
    [anon_sym_union] = ACTIONS(6372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6372),
    [anon_sym_let] = ACTIONS(6372),
    [anon_sym_This] = ACTIONS(6372),
    [anon_sym_decltype] = ACTIONS(6372),
    [anon_sym_explicit] = ACTIONS(6372),
    [anon_sym_typename] = ACTIONS(6372),
    [anon_sym_private] = ACTIONS(6372),
    [anon_sym_template] = ACTIONS(6372),
    [anon_sym_operator] = ACTIONS(6372),
    [anon_sym_friend] = ACTIONS(6372),
    [anon_sym_public] = ACTIONS(6372),
    [anon_sym_protected] = ACTIONS(6372),
    [anon_sym_static_assert] = ACTIONS(6372),
    [anon_sym_precise] = ACTIONS(6372),
    [anon_sym_shared] = ACTIONS(6372),
    [anon_sym_groupshared] = ACTIONS(6372),
    [anon_sym_uniform] = ACTIONS(6372),
    [anon_sym_row_major] = ACTIONS(6372),
    [anon_sym_column_major] = ACTIONS(6372),
    [anon_sym_globallycoherent] = ACTIONS(6372),
    [anon_sym_centroid] = ACTIONS(6372),
    [anon_sym_noperspective] = ACTIONS(6372),
    [anon_sym_nointerpolation] = ACTIONS(6372),
    [anon_sym_sample] = ACTIONS(6372),
    [anon_sym_linear] = ACTIONS(6372),
    [anon_sym_snorm] = ACTIONS(6372),
    [anon_sym_unorm] = ACTIONS(6372),
    [anon_sym_point] = ACTIONS(6372),
    [anon_sym_line] = ACTIONS(6372),
    [anon_sym_triangleadj] = ACTIONS(6372),
    [anon_sym_lineadj] = ACTIONS(6372),
    [anon_sym_triangle] = ACTIONS(6372),
    [anon_sym_interface] = ACTIONS(6372),
    [anon_sym_extension] = ACTIONS(6372),
    [anon_sym___init] = ACTIONS(6372),
    [anon_sym___subscript] = ACTIONS(6372),
    [anon_sym_property] = ACTIONS(6372),
    [anon_sym_associatedtype] = ACTIONS(6372),
  },
  [2458] = {
    [sym_identifier] = ACTIONS(6368),
    [aux_sym_preproc_def_token1] = ACTIONS(6368),
    [aux_sym_preproc_if_token1] = ACTIONS(6368),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6368),
    [sym_preproc_directive] = ACTIONS(6368),
    [anon_sym_LPAREN2] = ACTIONS(6370),
    [anon_sym_TILDE] = ACTIONS(6370),
    [anon_sym_STAR] = ACTIONS(6370),
    [anon_sym_AMP_AMP] = ACTIONS(6370),
    [anon_sym_AMP] = ACTIONS(6368),
    [anon_sym_SEMI] = ACTIONS(6370),
    [anon_sym___extension__] = ACTIONS(6368),
    [anon_sym_typedef] = ACTIONS(6368),
    [anon_sym_in] = ACTIONS(6368),
    [anon_sym_out] = ACTIONS(6368),
    [anon_sym_inout] = ACTIONS(6368),
    [anon_sym_virtual] = ACTIONS(6368),
    [anon_sym_extern] = ACTIONS(6368),
    [anon_sym___attribute__] = ACTIONS(6368),
    [anon_sym___attribute] = ACTIONS(6368),
    [anon_sym_using] = ACTIONS(6368),
    [anon_sym_COLON_COLON] = ACTIONS(6370),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6370),
    [anon_sym___declspec] = ACTIONS(6368),
    [anon_sym___based] = ACTIONS(6368),
    [anon_sym_RBRACE] = ACTIONS(6370),
    [anon_sym_signed] = ACTIONS(6368),
    [anon_sym_unsigned] = ACTIONS(6368),
    [anon_sym_long] = ACTIONS(6368),
    [anon_sym_short] = ACTIONS(6368),
    [anon_sym_LBRACK] = ACTIONS(6368),
    [anon_sym_static] = ACTIONS(6368),
    [anon_sym_register] = ACTIONS(6368),
    [anon_sym_inline] = ACTIONS(6368),
    [anon_sym___inline] = ACTIONS(6368),
    [anon_sym___inline__] = ACTIONS(6368),
    [anon_sym___forceinline] = ACTIONS(6368),
    [anon_sym_thread_local] = ACTIONS(6368),
    [anon_sym___thread] = ACTIONS(6368),
    [anon_sym_const] = ACTIONS(6368),
    [anon_sym_constexpr] = ACTIONS(6368),
    [anon_sym_volatile] = ACTIONS(6368),
    [anon_sym_restrict] = ACTIONS(6368),
    [anon_sym___restrict__] = ACTIONS(6368),
    [anon_sym__Atomic] = ACTIONS(6368),
    [anon_sym__Noreturn] = ACTIONS(6368),
    [anon_sym_noreturn] = ACTIONS(6368),
    [anon_sym__Nonnull] = ACTIONS(6368),
    [anon_sym_mutable] = ACTIONS(6368),
    [anon_sym_constinit] = ACTIONS(6368),
    [anon_sym_consteval] = ACTIONS(6368),
    [anon_sym_alignas] = ACTIONS(6368),
    [anon_sym__Alignas] = ACTIONS(6368),
    [sym_primitive_type] = ACTIONS(6368),
    [anon_sym_enum] = ACTIONS(6368),
    [anon_sym_class] = ACTIONS(6368),
    [anon_sym_struct] = ACTIONS(6368),
    [anon_sym_union] = ACTIONS(6368),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6368),
    [anon_sym_let] = ACTIONS(6368),
    [anon_sym_This] = ACTIONS(6368),
    [anon_sym_decltype] = ACTIONS(6368),
    [anon_sym_explicit] = ACTIONS(6368),
    [anon_sym_typename] = ACTIONS(6368),
    [anon_sym_private] = ACTIONS(6368),
    [anon_sym_template] = ACTIONS(6368),
    [anon_sym_operator] = ACTIONS(6368),
    [anon_sym_friend] = ACTIONS(6368),
    [anon_sym_public] = ACTIONS(6368),
    [anon_sym_protected] = ACTIONS(6368),
    [anon_sym_static_assert] = ACTIONS(6368),
    [anon_sym_precise] = ACTIONS(6368),
    [anon_sym_shared] = ACTIONS(6368),
    [anon_sym_groupshared] = ACTIONS(6368),
    [anon_sym_uniform] = ACTIONS(6368),
    [anon_sym_row_major] = ACTIONS(6368),
    [anon_sym_column_major] = ACTIONS(6368),
    [anon_sym_globallycoherent] = ACTIONS(6368),
    [anon_sym_centroid] = ACTIONS(6368),
    [anon_sym_noperspective] = ACTIONS(6368),
    [anon_sym_nointerpolation] = ACTIONS(6368),
    [anon_sym_sample] = ACTIONS(6368),
    [anon_sym_linear] = ACTIONS(6368),
    [anon_sym_snorm] = ACTIONS(6368),
    [anon_sym_unorm] = ACTIONS(6368),
    [anon_sym_point] = ACTIONS(6368),
    [anon_sym_line] = ACTIONS(6368),
    [anon_sym_triangleadj] = ACTIONS(6368),
    [anon_sym_lineadj] = ACTIONS(6368),
    [anon_sym_triangle] = ACTIONS(6368),
    [anon_sym_interface] = ACTIONS(6368),
    [anon_sym_extension] = ACTIONS(6368),
    [anon_sym___init] = ACTIONS(6368),
    [anon_sym___subscript] = ACTIONS(6368),
    [anon_sym_property] = ACTIONS(6368),
    [anon_sym_associatedtype] = ACTIONS(6368),
  },
  [2459] = {
    [sym_identifier] = ACTIONS(3800),
    [aux_sym_preproc_def_token1] = ACTIONS(3800),
    [aux_sym_preproc_if_token1] = ACTIONS(3800),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3800),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3800),
    [sym_preproc_directive] = ACTIONS(3800),
    [anon_sym_LPAREN2] = ACTIONS(3802),
    [anon_sym_TILDE] = ACTIONS(3802),
    [anon_sym_STAR] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_SEMI] = ACTIONS(3802),
    [anon_sym___extension__] = ACTIONS(3800),
    [anon_sym_typedef] = ACTIONS(3800),
    [anon_sym_in] = ACTIONS(3800),
    [anon_sym_out] = ACTIONS(3800),
    [anon_sym_inout] = ACTIONS(3800),
    [anon_sym_virtual] = ACTIONS(3800),
    [anon_sym_extern] = ACTIONS(3800),
    [anon_sym___attribute__] = ACTIONS(3800),
    [anon_sym___attribute] = ACTIONS(3800),
    [anon_sym_using] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3802),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3802),
    [anon_sym___declspec] = ACTIONS(3800),
    [anon_sym___based] = ACTIONS(3800),
    [anon_sym_RBRACE] = ACTIONS(3802),
    [anon_sym_signed] = ACTIONS(3800),
    [anon_sym_unsigned] = ACTIONS(3800),
    [anon_sym_long] = ACTIONS(3800),
    [anon_sym_short] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3800),
    [anon_sym_static] = ACTIONS(3800),
    [anon_sym_register] = ACTIONS(3800),
    [anon_sym_inline] = ACTIONS(3800),
    [anon_sym___inline] = ACTIONS(3800),
    [anon_sym___inline__] = ACTIONS(3800),
    [anon_sym___forceinline] = ACTIONS(3800),
    [anon_sym_thread_local] = ACTIONS(3800),
    [anon_sym___thread] = ACTIONS(3800),
    [anon_sym_const] = ACTIONS(3800),
    [anon_sym_constexpr] = ACTIONS(3800),
    [anon_sym_volatile] = ACTIONS(3800),
    [anon_sym_restrict] = ACTIONS(3800),
    [anon_sym___restrict__] = ACTIONS(3800),
    [anon_sym__Atomic] = ACTIONS(3800),
    [anon_sym__Noreturn] = ACTIONS(3800),
    [anon_sym_noreturn] = ACTIONS(3800),
    [anon_sym__Nonnull] = ACTIONS(3800),
    [anon_sym_mutable] = ACTIONS(3800),
    [anon_sym_constinit] = ACTIONS(3800),
    [anon_sym_consteval] = ACTIONS(3800),
    [anon_sym_alignas] = ACTIONS(3800),
    [anon_sym__Alignas] = ACTIONS(3800),
    [sym_primitive_type] = ACTIONS(3800),
    [anon_sym_enum] = ACTIONS(3800),
    [anon_sym_class] = ACTIONS(3800),
    [anon_sym_struct] = ACTIONS(3800),
    [anon_sym_union] = ACTIONS(3800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_This] = ACTIONS(3800),
    [anon_sym_decltype] = ACTIONS(3800),
    [anon_sym_explicit] = ACTIONS(3800),
    [anon_sym_typename] = ACTIONS(3800),
    [anon_sym_private] = ACTIONS(3800),
    [anon_sym_template] = ACTIONS(3800),
    [anon_sym_operator] = ACTIONS(3800),
    [anon_sym_friend] = ACTIONS(3800),
    [anon_sym_public] = ACTIONS(3800),
    [anon_sym_protected] = ACTIONS(3800),
    [anon_sym_static_assert] = ACTIONS(3800),
    [anon_sym_precise] = ACTIONS(3800),
    [anon_sym_shared] = ACTIONS(3800),
    [anon_sym_groupshared] = ACTIONS(3800),
    [anon_sym_uniform] = ACTIONS(3800),
    [anon_sym_row_major] = ACTIONS(3800),
    [anon_sym_column_major] = ACTIONS(3800),
    [anon_sym_globallycoherent] = ACTIONS(3800),
    [anon_sym_centroid] = ACTIONS(3800),
    [anon_sym_noperspective] = ACTIONS(3800),
    [anon_sym_nointerpolation] = ACTIONS(3800),
    [anon_sym_sample] = ACTIONS(3800),
    [anon_sym_linear] = ACTIONS(3800),
    [anon_sym_snorm] = ACTIONS(3800),
    [anon_sym_unorm] = ACTIONS(3800),
    [anon_sym_point] = ACTIONS(3800),
    [anon_sym_line] = ACTIONS(3800),
    [anon_sym_triangleadj] = ACTIONS(3800),
    [anon_sym_lineadj] = ACTIONS(3800),
    [anon_sym_triangle] = ACTIONS(3800),
    [anon_sym_interface] = ACTIONS(3800),
    [anon_sym_extension] = ACTIONS(3800),
    [anon_sym___init] = ACTIONS(3800),
    [anon_sym___subscript] = ACTIONS(3800),
    [anon_sym_property] = ACTIONS(3800),
    [anon_sym_associatedtype] = ACTIONS(3800),
  },
  [2460] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6843),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [2461] = {
    [sym_expression] = STATE(5994),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2462] = {
    [sym_expression] = STATE(5935),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2463] = {
    [sym_expression] = STATE(5759),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2464] = {
    [sym_expression] = STATE(5739),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(6704),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2465] = {
    [sym_expression] = STATE(5917),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2466] = {
    [sym_expression] = STATE(5775),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2467] = {
    [sym_expression] = STATE(4831),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2468] = {
    [sym_expression] = STATE(5777),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2469] = {
    [sym_expression] = STATE(5781),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2470] = {
    [sym_expression] = STATE(5788),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2471] = {
    [sym_expression] = STATE(5811),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2472] = {
    [sym_expression] = STATE(5819),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2473] = {
    [sym_expression] = STATE(5836),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2474] = {
    [sym_expression] = STATE(5843),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2475] = {
    [sym_expression] = STATE(5853),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2476] = {
    [sym_expression] = STATE(5626),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2477] = {
    [sym_expression] = STATE(6055),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2478] = {
    [sym_expression] = STATE(6064),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2479] = {
    [sym_expression] = STATE(6012),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2480] = {
    [sym_expression] = STATE(5466),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2481] = {
    [sym_expression] = STATE(5478),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2482] = {
    [sym_expression] = STATE(5661),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2483] = {
    [sym_expression] = STATE(5974),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2484] = {
    [sym_expression] = STATE(5675),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2485] = {
    [sym_expression] = STATE(5471),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2486] = {
    [sym_expression] = STATE(5497),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2487] = {
    [sym_expression] = STATE(5501),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2488] = {
    [sym_identifier] = ACTIONS(6206),
    [aux_sym_preproc_def_token1] = ACTIONS(6206),
    [aux_sym_preproc_if_token1] = ACTIONS(6206),
    [aux_sym_preproc_if_token2] = ACTIONS(6206),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6206),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6206),
    [sym_preproc_directive] = ACTIONS(6206),
    [anon_sym_LPAREN2] = ACTIONS(6208),
    [anon_sym_TILDE] = ACTIONS(6208),
    [anon_sym_STAR] = ACTIONS(6208),
    [anon_sym_AMP_AMP] = ACTIONS(6208),
    [anon_sym_AMP] = ACTIONS(6206),
    [anon_sym_SEMI] = ACTIONS(6208),
    [anon_sym___extension__] = ACTIONS(6206),
    [anon_sym_typedef] = ACTIONS(6206),
    [anon_sym_in] = ACTIONS(6206),
    [anon_sym_out] = ACTIONS(6206),
    [anon_sym_inout] = ACTIONS(6206),
    [anon_sym_virtual] = ACTIONS(6206),
    [anon_sym_extern] = ACTIONS(6206),
    [anon_sym___attribute__] = ACTIONS(6206),
    [anon_sym___attribute] = ACTIONS(6206),
    [anon_sym_using] = ACTIONS(6206),
    [anon_sym_COLON_COLON] = ACTIONS(6208),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6208),
    [anon_sym___declspec] = ACTIONS(6206),
    [anon_sym___based] = ACTIONS(6206),
    [anon_sym_signed] = ACTIONS(6206),
    [anon_sym_unsigned] = ACTIONS(6206),
    [anon_sym_long] = ACTIONS(6206),
    [anon_sym_short] = ACTIONS(6206),
    [anon_sym_LBRACK] = ACTIONS(6206),
    [anon_sym_static] = ACTIONS(6206),
    [anon_sym_register] = ACTIONS(6206),
    [anon_sym_inline] = ACTIONS(6206),
    [anon_sym___inline] = ACTIONS(6206),
    [anon_sym___inline__] = ACTIONS(6206),
    [anon_sym___forceinline] = ACTIONS(6206),
    [anon_sym_thread_local] = ACTIONS(6206),
    [anon_sym___thread] = ACTIONS(6206),
    [anon_sym_const] = ACTIONS(6206),
    [anon_sym_constexpr] = ACTIONS(6206),
    [anon_sym_volatile] = ACTIONS(6206),
    [anon_sym_restrict] = ACTIONS(6206),
    [anon_sym___restrict__] = ACTIONS(6206),
    [anon_sym__Atomic] = ACTIONS(6206),
    [anon_sym__Noreturn] = ACTIONS(6206),
    [anon_sym_noreturn] = ACTIONS(6206),
    [anon_sym__Nonnull] = ACTIONS(6206),
    [anon_sym_mutable] = ACTIONS(6206),
    [anon_sym_constinit] = ACTIONS(6206),
    [anon_sym_consteval] = ACTIONS(6206),
    [anon_sym_alignas] = ACTIONS(6206),
    [anon_sym__Alignas] = ACTIONS(6206),
    [sym_primitive_type] = ACTIONS(6206),
    [anon_sym_enum] = ACTIONS(6206),
    [anon_sym_class] = ACTIONS(6206),
    [anon_sym_struct] = ACTIONS(6206),
    [anon_sym_union] = ACTIONS(6206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6206),
    [anon_sym_let] = ACTIONS(6206),
    [anon_sym_This] = ACTIONS(6206),
    [anon_sym_decltype] = ACTIONS(6206),
    [anon_sym_explicit] = ACTIONS(6206),
    [anon_sym_typename] = ACTIONS(6206),
    [anon_sym_private] = ACTIONS(6206),
    [anon_sym_template] = ACTIONS(6206),
    [anon_sym_operator] = ACTIONS(6206),
    [anon_sym_friend] = ACTIONS(6206),
    [anon_sym_public] = ACTIONS(6206),
    [anon_sym_protected] = ACTIONS(6206),
    [anon_sym_static_assert] = ACTIONS(6206),
    [anon_sym_precise] = ACTIONS(6206),
    [anon_sym_shared] = ACTIONS(6206),
    [anon_sym_groupshared] = ACTIONS(6206),
    [anon_sym_uniform] = ACTIONS(6206),
    [anon_sym_row_major] = ACTIONS(6206),
    [anon_sym_column_major] = ACTIONS(6206),
    [anon_sym_globallycoherent] = ACTIONS(6206),
    [anon_sym_centroid] = ACTIONS(6206),
    [anon_sym_noperspective] = ACTIONS(6206),
    [anon_sym_nointerpolation] = ACTIONS(6206),
    [anon_sym_sample] = ACTIONS(6206),
    [anon_sym_linear] = ACTIONS(6206),
    [anon_sym_snorm] = ACTIONS(6206),
    [anon_sym_unorm] = ACTIONS(6206),
    [anon_sym_point] = ACTIONS(6206),
    [anon_sym_line] = ACTIONS(6206),
    [anon_sym_triangleadj] = ACTIONS(6206),
    [anon_sym_lineadj] = ACTIONS(6206),
    [anon_sym_triangle] = ACTIONS(6206),
    [anon_sym_interface] = ACTIONS(6206),
    [anon_sym_extension] = ACTIONS(6206),
    [anon_sym___init] = ACTIONS(6206),
    [anon_sym___subscript] = ACTIONS(6206),
    [anon_sym_property] = ACTIONS(6206),
    [anon_sym_associatedtype] = ACTIONS(6206),
  },
  [2489] = {
    [sym_expression] = STATE(6045),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2490] = {
    [sym_expression] = STATE(5952),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2491] = {
    [sym_identifier] = ACTIONS(6214),
    [aux_sym_preproc_def_token1] = ACTIONS(6214),
    [aux_sym_preproc_if_token1] = ACTIONS(6214),
    [aux_sym_preproc_if_token2] = ACTIONS(6214),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6214),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6214),
    [sym_preproc_directive] = ACTIONS(6214),
    [anon_sym_LPAREN2] = ACTIONS(6216),
    [anon_sym_TILDE] = ACTIONS(6216),
    [anon_sym_STAR] = ACTIONS(6216),
    [anon_sym_AMP_AMP] = ACTIONS(6216),
    [anon_sym_AMP] = ACTIONS(6214),
    [anon_sym_SEMI] = ACTIONS(6216),
    [anon_sym___extension__] = ACTIONS(6214),
    [anon_sym_typedef] = ACTIONS(6214),
    [anon_sym_in] = ACTIONS(6214),
    [anon_sym_out] = ACTIONS(6214),
    [anon_sym_inout] = ACTIONS(6214),
    [anon_sym_virtual] = ACTIONS(6214),
    [anon_sym_extern] = ACTIONS(6214),
    [anon_sym___attribute__] = ACTIONS(6214),
    [anon_sym___attribute] = ACTIONS(6214),
    [anon_sym_using] = ACTIONS(6214),
    [anon_sym_COLON_COLON] = ACTIONS(6216),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6216),
    [anon_sym___declspec] = ACTIONS(6214),
    [anon_sym___based] = ACTIONS(6214),
    [anon_sym_signed] = ACTIONS(6214),
    [anon_sym_unsigned] = ACTIONS(6214),
    [anon_sym_long] = ACTIONS(6214),
    [anon_sym_short] = ACTIONS(6214),
    [anon_sym_LBRACK] = ACTIONS(6214),
    [anon_sym_static] = ACTIONS(6214),
    [anon_sym_register] = ACTIONS(6214),
    [anon_sym_inline] = ACTIONS(6214),
    [anon_sym___inline] = ACTIONS(6214),
    [anon_sym___inline__] = ACTIONS(6214),
    [anon_sym___forceinline] = ACTIONS(6214),
    [anon_sym_thread_local] = ACTIONS(6214),
    [anon_sym___thread] = ACTIONS(6214),
    [anon_sym_const] = ACTIONS(6214),
    [anon_sym_constexpr] = ACTIONS(6214),
    [anon_sym_volatile] = ACTIONS(6214),
    [anon_sym_restrict] = ACTIONS(6214),
    [anon_sym___restrict__] = ACTIONS(6214),
    [anon_sym__Atomic] = ACTIONS(6214),
    [anon_sym__Noreturn] = ACTIONS(6214),
    [anon_sym_noreturn] = ACTIONS(6214),
    [anon_sym__Nonnull] = ACTIONS(6214),
    [anon_sym_mutable] = ACTIONS(6214),
    [anon_sym_constinit] = ACTIONS(6214),
    [anon_sym_consteval] = ACTIONS(6214),
    [anon_sym_alignas] = ACTIONS(6214),
    [anon_sym__Alignas] = ACTIONS(6214),
    [sym_primitive_type] = ACTIONS(6214),
    [anon_sym_enum] = ACTIONS(6214),
    [anon_sym_class] = ACTIONS(6214),
    [anon_sym_struct] = ACTIONS(6214),
    [anon_sym_union] = ACTIONS(6214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6214),
    [anon_sym_let] = ACTIONS(6214),
    [anon_sym_This] = ACTIONS(6214),
    [anon_sym_decltype] = ACTIONS(6214),
    [anon_sym_explicit] = ACTIONS(6214),
    [anon_sym_typename] = ACTIONS(6214),
    [anon_sym_private] = ACTIONS(6214),
    [anon_sym_template] = ACTIONS(6214),
    [anon_sym_operator] = ACTIONS(6214),
    [anon_sym_friend] = ACTIONS(6214),
    [anon_sym_public] = ACTIONS(6214),
    [anon_sym_protected] = ACTIONS(6214),
    [anon_sym_static_assert] = ACTIONS(6214),
    [anon_sym_precise] = ACTIONS(6214),
    [anon_sym_shared] = ACTIONS(6214),
    [anon_sym_groupshared] = ACTIONS(6214),
    [anon_sym_uniform] = ACTIONS(6214),
    [anon_sym_row_major] = ACTIONS(6214),
    [anon_sym_column_major] = ACTIONS(6214),
    [anon_sym_globallycoherent] = ACTIONS(6214),
    [anon_sym_centroid] = ACTIONS(6214),
    [anon_sym_noperspective] = ACTIONS(6214),
    [anon_sym_nointerpolation] = ACTIONS(6214),
    [anon_sym_sample] = ACTIONS(6214),
    [anon_sym_linear] = ACTIONS(6214),
    [anon_sym_snorm] = ACTIONS(6214),
    [anon_sym_unorm] = ACTIONS(6214),
    [anon_sym_point] = ACTIONS(6214),
    [anon_sym_line] = ACTIONS(6214),
    [anon_sym_triangleadj] = ACTIONS(6214),
    [anon_sym_lineadj] = ACTIONS(6214),
    [anon_sym_triangle] = ACTIONS(6214),
    [anon_sym_interface] = ACTIONS(6214),
    [anon_sym_extension] = ACTIONS(6214),
    [anon_sym___init] = ACTIONS(6214),
    [anon_sym___subscript] = ACTIONS(6214),
    [anon_sym_property] = ACTIONS(6214),
    [anon_sym_associatedtype] = ACTIONS(6214),
  },
  [2492] = {
    [sym_expression] = STATE(5947),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2493] = {
    [sym_expression] = STATE(6009),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2494] = {
    [sym_expression] = STATE(5975),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2495] = {
    [sym_expression] = STATE(5891),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2496] = {
    [sym_expression] = STATE(5474),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2497] = {
    [sym_expression] = STATE(5476),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2498] = {
    [sym_expression] = STATE(5972),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2499] = {
    [sym_expression] = STATE(5496),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2500] = {
    [sym_expression] = STATE(5499),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2501] = {
    [sym_expression] = STATE(5500),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2502] = {
    [sym_expression] = STATE(6003),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2503] = {
    [sym_expression] = STATE(5875),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2504] = {
    [sym_expression] = STATE(5955),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2505] = {
    [sym_expression] = STATE(6029),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2506] = {
    [sym_expression] = STATE(6046),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2507] = {
    [sym_expression] = STATE(6047),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2508] = {
    [sym_expression] = STATE(5623),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2509] = {
    [sym_expression] = STATE(5545),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2510] = {
    [sym_expression] = STATE(6051),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2511] = {
    [sym_expression] = STATE(5459),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2512] = {
    [sym_expression] = STATE(5460),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2513] = {
    [sym_expression] = STATE(5462),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2514] = {
    [sym_expression] = STATE(5905),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2515] = {
    [sym_expression] = STATE(5948),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2516] = {
    [sym_expression] = STATE(6014),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2517] = {
    [sym_expression] = STATE(6020),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2518] = {
    [sym_expression] = STATE(6041),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2519] = {
    [sym_expression] = STATE(6019),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2520] = {
    [sym_expression] = STATE(5487),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2521] = {
    [sym_expression] = STATE(5488),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2522] = {
    [sym_expression] = STATE(5989),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2523] = {
    [sym_expression] = STATE(5492),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2524] = {
    [sym_expression] = STATE(5493),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2525] = {
    [sym_expression] = STATE(5494),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2526] = {
    [sym_expression] = STATE(5880),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2527] = {
    [sym_expression] = STATE(5899),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2528] = {
    [sym_expression] = STATE(5933),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2529] = {
    [sym_expression] = STATE(5939),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2530] = {
    [sym_expression] = STATE(5506),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2531] = {
    [sym_expression] = STATE(5507),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2532] = {
    [sym_expression] = STATE(5946),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2533] = {
    [sym_expression] = STATE(5508),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2534] = {
    [sym_expression] = STATE(5509),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2535] = {
    [sym_expression] = STATE(5510),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2536] = {
    [sym_expression] = STATE(6050),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2537] = {
    [sym_expression] = STATE(5879),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2538] = {
    [sym_expression] = STATE(5886),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2539] = {
    [sym_expression] = STATE(5518),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2540] = {
    [sym_expression] = STATE(5519),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2541] = {
    [sym_expression] = STATE(5898),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2542] = {
    [sym_expression] = STATE(5520),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2543] = {
    [sym_expression] = STATE(5521),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2544] = {
    [sym_expression] = STATE(5936),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2545] = {
    [sym_expression] = STATE(5526),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2546] = {
    [sym_expression] = STATE(5527),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2547] = {
    [sym_expression] = STATE(5528),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2548] = {
    [sym_expression] = STATE(5529),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2549] = {
    [sym_expression] = STATE(5965),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2550] = {
    [sym_expression] = STATE(5532),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2551] = {
    [sym_expression] = STATE(5533),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2552] = {
    [sym_expression] = STATE(5534),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2553] = {
    [sym_expression] = STATE(5535),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2554] = {
    [sym_expression] = STATE(5996),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2555] = {
    [sym_expression] = STATE(5542),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2556] = {
    [sym_expression] = STATE(5543),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2557] = {
    [sym_expression] = STATE(6013),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2558] = {
    [sym_expression] = STATE(5546),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2559] = {
    [sym_expression] = STATE(5547),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2560] = {
    [sym_expression] = STATE(5551),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2561] = {
    [sym_expression] = STATE(5552),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2562] = {
    [sym_expression] = STATE(5555),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2563] = {
    [sym_expression] = STATE(5556),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2564] = {
    [sym_expression] = STATE(5457),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2565] = {
    [sym_expression] = STATE(5559),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2566] = {
    [sym_expression] = STATE(5562),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2567] = {
    [sym_expression] = STATE(5563),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2568] = {
    [sym_expression] = STATE(5570),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2569] = {
    [sym_expression] = STATE(5572),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2570] = {
    [sym_expression] = STATE(5576),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2571] = {
    [sym_expression] = STATE(5577),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2572] = {
    [sym_expression] = STATE(5579),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2573] = {
    [sym_expression] = STATE(5580),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2574] = {
    [sym_expression] = STATE(5583),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2575] = {
    [sym_expression] = STATE(5584),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2576] = {
    [sym_expression] = STATE(5586),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2577] = {
    [sym_expression] = STATE(5587),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2578] = {
    [sym_expression] = STATE(5591),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2579] = {
    [sym_expression] = STATE(5592),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2580] = {
    [sym_expression] = STATE(5595),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2581] = {
    [sym_expression] = STATE(5596),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2582] = {
    [sym_expression] = STATE(5598),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2583] = {
    [sym_expression] = STATE(5599),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2584] = {
    [sym_expression] = STATE(5601),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2585] = {
    [sym_expression] = STATE(5602),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2586] = {
    [sym_expression] = STATE(5604),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2587] = {
    [sym_expression] = STATE(5605),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2588] = {
    [sym_expression] = STATE(5612),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2589] = {
    [sym_expression] = STATE(5616),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2590] = {
    [sym_expression] = STATE(4812),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2591] = {
    [sym_expression] = STATE(4809),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2592] = {
    [sym_expression] = STATE(5874),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(6706),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2593] = {
    [sym_expression] = STATE(4826),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4730),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4730),
    [sym_call_expression] = STATE(4730),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4730),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4730),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4730),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4730),
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_BANG] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_PLUS] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5465),
    [anon_sym_COLON_COLON] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5461),
    [anon_sym_compl] = ACTIONS(5461),
    [anon_sym_DASH_DASH] = ACTIONS(5489),
    [anon_sym_PLUS_PLUS] = ACTIONS(5489),
    [anon_sym_sizeof] = ACTIONS(5469),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5471),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2594] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6308),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [2595] = {
    [sym_expression] = STATE(5486),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2596] = {
    [sym_expression] = STATE(5755),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2597] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6325),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [2598] = {
    [sym_expression] = STATE(4476),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6464),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5158),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2599] = {
    [sym_expression] = STATE(4477),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6464),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5158),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2600] = {
    [sym_expression] = STATE(5763),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2601] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6335),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [2602] = {
    [sym_expression] = STATE(5851),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2603] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6252),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [2604] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6286),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [2605] = {
    [sym_expression] = STATE(5647),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2606] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6300),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [2607] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6320),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [2608] = {
    [sym_expression] = STATE(5672),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2609] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6326),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [2610] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6338),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [2611] = {
    [sym_expression] = STATE(5685),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2612] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6351),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [2613] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6243),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [2614] = {
    [sym_expression] = STATE(5696),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2615] = {
    [sym__declaration_modifiers] = STATE(2666),
    [sym__declaration_specifiers] = STATE(6248),
    [sym_attribute_specifier] = STATE(2666),
    [sym_attribute_declaration] = STATE(2666),
    [sym_ms_declspec_modifier] = STATE(2666),
    [sym_storage_class_specifier] = STATE(2666),
    [sym_type_qualifier] = STATE(2666),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2796),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2666),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1810),
    [anon_sym_out] = ACTIONS(1810),
    [anon_sym_inout] = ACTIONS(1810),
    [anon_sym_virtual] = ACTIONS(1810),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [2616] = {
    [sym_expression] = STATE(4505),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6464),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5158),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2617] = {
    [sym_expression] = STATE(3795),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6116),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_DASH] = ACTIONS(5000),
    [anon_sym_PLUS] = ACTIONS(5000),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_compl] = ACTIONS(5000),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_sizeof] = ACTIONS(5008),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5016),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5020),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2618] = {
    [sym_expression] = STATE(4307),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6464),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5158),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2619] = {
    [sym_expression] = STATE(4483),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6464),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5158),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2620] = {
    [sym_expression] = STATE(4484),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6464),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5158),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2621] = {
    [sym_expression] = STATE(4485),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6464),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5158),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2622] = {
    [sym_expression] = STATE(4486),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6464),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5158),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2623] = {
    [sym_expression] = STATE(4487),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6464),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5158),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2624] = {
    [sym_expression] = STATE(4488),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6464),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5158),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2625] = {
    [sym_expression] = STATE(4489),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6464),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5158),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2626] = {
    [sym_expression] = STATE(4490),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6464),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5158),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2627] = {
    [sym_expression] = STATE(4491),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6464),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5158),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2628] = {
    [sym_expression] = STATE(4492),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6464),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5158),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2629] = {
    [sym_expression] = STATE(4479),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6464),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5158),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACK] = ACTIONS(6708),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2630] = {
    [sym_expression] = STATE(4480),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6464),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5158),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2631] = {
    [sym_expression] = STATE(4481),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6464),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5158),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACK] = ACTIONS(6710),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2632] = {
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6464),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5158),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2633] = {
    [sym_expression] = STATE(5404),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2634] = {
    [sym_expression] = STATE(4496),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6464),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5158),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2635] = {
    [sym_expression] = STATE(4498),
    [sym__string] = STATE(3741),
    [sym_conditional_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_pointer_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_update_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_sizeof_expression] = STATE(3445),
    [sym_alignof_expression] = STATE(3445),
    [sym_offsetof_expression] = STATE(3445),
    [sym_generic_expression] = STATE(3445),
    [sym_subscript_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_gnu_asm_expression] = STATE(3445),
    [sym_extension_expression] = STATE(3445),
    [sym_field_expression] = STATE(3402),
    [sym_compound_literal_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3402),
    [sym_char_literal] = STATE(3741),
    [sym_concatenated_string] = STATE(3741),
    [sym_string_literal] = STATE(3155),
    [sym_null] = STATE(3445),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10700),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(3445),
    [sym_raw_string_literal] = STATE(3155),
    [sym_co_await_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_requires_clause] = STATE(3445),
    [sym_requires_expression] = STATE(3445),
    [sym_lambda_expression] = STATE(3445),
    [sym_lambda_capture_specifier] = STATE(6429),
    [sym_fold_expression] = STATE(3445),
    [sym_parameter_pack_expansion] = STATE(3445),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(3402),
    [sym_qualified_type_identifier] = STATE(10700),
    [sym_user_defined_literal] = STATE(3402),
    [sym_identifier] = ACTIONS(4998),
    [anon_sym_LPAREN2] = ACTIONS(6464),
    [anon_sym_BANG] = ACTIONS(5156),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5158),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4966),
    [anon_sym_not] = ACTIONS(5154),
    [anon_sym_compl] = ACTIONS(5154),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_sizeof] = ACTIONS(5162),
    [anon_sym___alignof__] = ACTIONS(4970),
    [anon_sym___alignof] = ACTIONS(4970),
    [anon_sym__alignof] = ACTIONS(4970),
    [anon_sym_alignof] = ACTIONS(4970),
    [anon_sym__Alignof] = ACTIONS(4970),
    [anon_sym_offsetof] = ACTIONS(4972),
    [anon_sym__Generic] = ACTIONS(4974),
    [anon_sym_asm] = ACTIONS(4976),
    [anon_sym___asm__] = ACTIONS(4976),
    [anon_sym___asm] = ACTIONS(4976),
    [sym_number_literal] = ACTIONS(5010),
    [anon_sym_L_SQUOTE] = ACTIONS(5012),
    [anon_sym_u_SQUOTE] = ACTIONS(5012),
    [anon_sym_U_SQUOTE] = ACTIONS(5012),
    [anon_sym_u8_SQUOTE] = ACTIONS(5012),
    [anon_sym_SQUOTE] = ACTIONS(5012),
    [anon_sym_L_DQUOTE] = ACTIONS(5014),
    [anon_sym_u_DQUOTE] = ACTIONS(5014),
    [anon_sym_U_DQUOTE] = ACTIONS(5014),
    [anon_sym_u8_DQUOTE] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(5014),
    [sym_true] = ACTIONS(4984),
    [sym_false] = ACTIONS(4984),
    [anon_sym_NULL] = ACTIONS(4986),
    [anon_sym_nullptr] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5164),
    [anon_sym_R_DQUOTE] = ACTIONS(5018),
    [anon_sym_LR_DQUOTE] = ACTIONS(5018),
    [anon_sym_uR_DQUOTE] = ACTIONS(5018),
    [anon_sym_UR_DQUOTE] = ACTIONS(5018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5018),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_requires] = ACTIONS(4996),
    [sym_this] = ACTIONS(4984),
  },
  [2636] = {
    [sym_expression] = STATE(5808),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2637] = {
    [sym_expression] = STATE(5789),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(6712),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2638] = {
    [sym_expression] = STATE(4831),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2639] = {
    [sym_expression] = STATE(5791),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2640] = {
    [sym_expression] = STATE(5792),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2641] = {
    [sym_expression] = STATE(5793),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2642] = {
    [sym_expression] = STATE(5794),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2643] = {
    [sym_expression] = STATE(5795),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2644] = {
    [sym_expression] = STATE(5796),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2645] = {
    [sym_expression] = STATE(5797),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2646] = {
    [sym_expression] = STATE(5798),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2647] = {
    [sym_expression] = STATE(5799),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2648] = {
    [sym_expression] = STATE(5800),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2649] = {
    [sym_expression] = STATE(5427),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2650] = {
    [sym_expression] = STATE(5802),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2651] = {
    [sym_expression] = STATE(5804),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2652] = {
    [sym_expression] = STATE(5829),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2653] = {
    [sym_expression] = STATE(5830),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2654] = {
    [sym_expression] = STATE(5810),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(6714),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2655] = {
    [sym_expression] = STATE(5834),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4800),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4800),
    [sym_call_expression] = STATE(4800),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4800),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4800),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4800),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4800),
    [sym_identifier] = ACTIONS(5441),
    [anon_sym_LPAREN2] = ACTIONS(6429),
    [anon_sym_BANG] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5447),
    [anon_sym_COLON_COLON] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(5443),
    [anon_sym_compl] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5565),
    [anon_sym_PLUS_PLUS] = ACTIONS(5565),
    [anon_sym_sizeof] = ACTIONS(5451),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5453),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(5455),
    [anon_sym_new] = ACTIONS(5457),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2656] = {
    [sym_expression] = STATE(5786),
    [sym__string] = STATE(5976),
    [sym_conditional_expression] = STATE(6070),
    [sym_assignment_expression] = STATE(6070),
    [sym_pointer_expression] = STATE(4674),
    [sym_unary_expression] = STATE(6070),
    [sym_binary_expression] = STATE(6070),
    [sym_update_expression] = STATE(6070),
    [sym_cast_expression] = STATE(6070),
    [sym_sizeof_expression] = STATE(6070),
    [sym_alignof_expression] = STATE(6070),
    [sym_offsetof_expression] = STATE(6070),
    [sym_generic_expression] = STATE(6070),
    [sym_subscript_expression] = STATE(4674),
    [sym_call_expression] = STATE(4674),
    [sym_gnu_asm_expression] = STATE(6070),
    [sym_extension_expression] = STATE(6070),
    [sym_field_expression] = STATE(4674),
    [sym_compound_literal_expression] = STATE(6070),
    [sym_parenthesized_expression] = STATE(4674),
    [sym_char_literal] = STATE(5976),
    [sym_concatenated_string] = STATE(5976),
    [sym_string_literal] = STATE(4816),
    [sym_null] = STATE(6070),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10404),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(6070),
    [sym_raw_string_literal] = STATE(4816),
    [sym_co_await_expression] = STATE(6070),
    [sym_new_expression] = STATE(6070),
    [sym_delete_expression] = STATE(6070),
    [sym_requires_clause] = STATE(6070),
    [sym_requires_expression] = STATE(6070),
    [sym_lambda_expression] = STATE(6070),
    [sym_lambda_capture_specifier] = STATE(6433),
    [sym_fold_expression] = STATE(6070),
    [sym_parameter_pack_expansion] = STATE(6070),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7213),
    [sym_qualified_identifier] = STATE(4674),
    [sym_qualified_type_identifier] = STATE(10404),
    [sym_user_defined_literal] = STATE(4674),
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5082),
    [anon_sym_AMP] = ACTIONS(5082),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(5481),
    [anon_sym_not] = ACTIONS(5080),
    [anon_sym_compl] = ACTIONS(5080),
    [anon_sym_DASH_DASH] = ACTIONS(5100),
    [anon_sym_PLUS_PLUS] = ACTIONS(5100),
    [anon_sym_sizeof] = ACTIONS(5102),
    [anon_sym___alignof__] = ACTIONS(5104),
    [anon_sym___alignof] = ACTIONS(5104),
    [anon_sym__alignof] = ACTIONS(5104),
    [anon_sym_alignof] = ACTIONS(5104),
    [anon_sym__Alignof] = ACTIONS(5104),
    [anon_sym_offsetof] = ACTIONS(5106),
    [anon_sym__Generic] = ACTIONS(5108),
    [anon_sym_asm] = ACTIONS(5110),
    [anon_sym___asm__] = ACTIONS(5110),
    [anon_sym___asm] = ACTIONS(5110),
    [sym_number_literal] = ACTIONS(5112),
    [anon_sym_L_SQUOTE] = ACTIONS(5114),
    [anon_sym_u_SQUOTE] = ACTIONS(5114),
    [anon_sym_U_SQUOTE] = ACTIONS(5114),
    [anon_sym_u8_SQUOTE] = ACTIONS(5114),
    [anon_sym_SQUOTE] = ACTIONS(5114),
    [anon_sym_L_DQUOTE] = ACTIONS(5116),
    [anon_sym_u_DQUOTE] = ACTIONS(5116),
    [anon_sym_U_DQUOTE] = ACTIONS(5116),
    [anon_sym_u8_DQUOTE] = ACTIONS(5116),
    [anon_sym_DQUOTE] = ACTIONS(5116),
    [sym_true] = ACTIONS(5118),
    [sym_false] = ACTIONS(5118),
    [anon_sym_NULL] = ACTIONS(5120),
    [anon_sym_nullptr] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_R_DQUOTE] = ACTIONS(5134),
    [anon_sym_LR_DQUOTE] = ACTIONS(5134),
    [anon_sym_uR_DQUOTE] = ACTIONS(5134),
    [anon_sym_UR_DQUOTE] = ACTIONS(5134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5134),
    [anon_sym_co_await] = ACTIONS(5136),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5140),
    [sym_this] = ACTIONS(5118),
  },
  [2657] = {
    [sym_expression] = STATE(6058),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2658] = {
    [sym_expression] = STATE(6059),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2659] = {
    [sym_expression] = STATE(6060),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2660] = {
    [sym_expression] = STATE(6061),
    [sym__string] = STATE(5341),
    [sym_conditional_expression] = STATE(4922),
    [sym_assignment_expression] = STATE(4922),
    [sym_pointer_expression] = STATE(4315),
    [sym_unary_expression] = STATE(4922),
    [sym_binary_expression] = STATE(4922),
    [sym_update_expression] = STATE(4922),
    [sym_cast_expression] = STATE(4922),
    [sym_sizeof_expression] = STATE(4922),
    [sym_alignof_expression] = STATE(4922),
    [sym_offsetof_expression] = STATE(4922),
    [sym_generic_expression] = STATE(4922),
    [sym_subscript_expression] = STATE(4315),
    [sym_call_expression] = STATE(4315),
    [sym_gnu_asm_expression] = STATE(4922),
    [sym_extension_expression] = STATE(4922),
    [sym_field_expression] = STATE(4315),
    [sym_compound_literal_expression] = STATE(4922),
    [sym_parenthesized_expression] = STATE(4315),
    [sym_char_literal] = STATE(5341),
    [sym_concatenated_string] = STATE(5341),
    [sym_string_literal] = STATE(4259),
    [sym_null] = STATE(4922),
    [sym_decltype] = STATE(11339),
    [sym__class_name] = STATE(10558),
    [sym_template_type] = STATE(207),
    [sym_template_function] = STATE(4922),
    [sym_raw_string_literal] = STATE(4259),
    [sym_co_await_expression] = STATE(4922),
    [sym_new_expression] = STATE(4922),
    [sym_delete_expression] = STATE(4922),
    [sym_requires_clause] = STATE(4922),
    [sym_requires_expression] = STATE(4922),
    [sym_lambda_expression] = STATE(4922),
    [sym_lambda_capture_specifier] = STATE(6437),
    [sym_fold_expression] = STATE(4922),
    [sym_parameter_pack_expansion] = STATE(4922),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7239),
    [sym_qualified_identifier] = STATE(4315),
    [sym_qualified_type_identifier] = STATE(10558),
    [sym_user_defined_literal] = STATE(4315),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym___extension__] = ACTIONS(4437),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(4443),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(247),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(249),
    [sym_false] = ACTIONS(249),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(249),
  },
  [2661] = {
    [sym_identifier] = ACTIONS(6264),
    [aux_sym_preproc_def_token1] = ACTIONS(6264),
    [aux_sym_preproc_if_token1] = ACTIONS(6264),
    [aux_sym_preproc_if_token2] = ACTIONS(6264),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(6264),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(6264),
    [sym_preproc_directive] = ACTIONS(6264),
    [anon_sym_LPAREN2] = ACTIONS(6266),
    [anon_sym_TILDE] = ACTIONS(6266),
    [anon_sym_STAR] = ACTIONS(6266),
    [anon_sym_AMP_AMP] = ACTIONS(6266),
    [anon_sym_AMP] = ACTIONS(6264),
    [anon_sym_SEMI] = ACTIONS(6266),
    [anon_sym___extension__] = ACTIONS(6264),
    [anon_sym_typedef] = ACTIONS(6264),
    [anon_sym_in] = ACTIONS(6264),
    [anon_sym_out] = ACTIONS(6264),
    [anon_sym_inout] = ACTIONS(6264),
    [anon_sym_virtual] = ACTIONS(6264),
    [anon_sym_extern] = ACTIONS(6264),
    [anon_sym___attribute__] = ACTIONS(6264),
    [anon_sym___attribute] = ACTIONS(6264),
    [anon_sym_using] = ACTIONS(6264),
    [anon_sym_COLON_COLON] = ACTIONS(6266),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6266),
    [anon_sym___declspec] = ACTIONS(6264),
    [anon_sym___based] = ACTIONS(6264),
    [anon_sym_signed] = ACTIONS(6264),
    [anon_sym_unsigned] = ACTIONS(6264),
    [anon_sym_long] = ACTIONS(6264),
    [anon_sym_short] = ACTIONS(6264),
    [anon_sym_LBRACK] = ACTIONS(6264),
    [anon_sym_static] = ACTIONS(6264),
    [anon_sym_register] = ACTIONS(6264),
    [anon_sym_inline] = ACTIONS(6264),
    [anon_sym___inline] = ACTIONS(6264),
    [anon_sym___inline__] = ACTIONS(6264),
    [anon_sym___forceinline] = ACTIONS(6264),
    [anon_sym_thread_local] = ACTIONS(6264),
    [anon_sym___thread] = ACTIONS(6264),
    [anon_sym_const] = ACTIONS(6264),
    [anon_sym_constexpr] = ACTIONS(6264),
    [anon_sym_volatile] = ACTIONS(6264),
    [anon_sym_restrict] = ACTIONS(6264),
    [anon_sym___restrict__] = ACTIONS(6264),
    [anon_sym__Atomic] = ACTIONS(6264),
    [anon_sym__Noreturn] = ACTIONS(6264),
    [anon_sym_noreturn] = ACTIONS(6264),
    [anon_sym__Nonnull] = ACTIONS(6264),
    [anon_sym_mutable] = ACTIONS(6264),
    [anon_sym_constinit] = ACTIONS(6264),
    [anon_sym_consteval] = ACTIONS(6264),
    [anon_sym_alignas] = ACTIONS(6264),
    [anon_sym__Alignas] = ACTIONS(6264),
    [sym_primitive_type] = ACTIONS(6264),
    [anon_sym_enum] = ACTIONS(6264),
    [anon_sym_class] = ACTIONS(6264),
    [anon_sym_struct] = ACTIONS(6264),
    [anon_sym_union] = ACTIONS(6264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6264),
    [anon_sym_let] = ACTIONS(6264),
    [anon_sym_This] = ACTIONS(6264),
    [anon_sym_decltype] = ACTIONS(6264),
    [anon_sym_explicit] = ACTIONS(6264),
    [anon_sym_typename] = ACTIONS(6264),
    [anon_sym_private] = ACTIONS(6264),
    [anon_sym_template] = ACTIONS(6264),
    [anon_sym_operator] = ACTIONS(6264),
    [anon_sym_friend] = ACTIONS(6264),
    [anon_sym_public] = ACTIONS(6264),
    [anon_sym_protected] = ACTIONS(6264),
    [anon_sym_static_assert] = ACTIONS(6264),
    [anon_sym_precise] = ACTIONS(6264),
    [anon_sym_shared] = ACTIONS(6264),
    [anon_sym_groupshared] = ACTIONS(6264),
    [anon_sym_uniform] = ACTIONS(6264),
    [anon_sym_row_major] = ACTIONS(6264),
    [anon_sym_column_major] = ACTIONS(6264),
    [anon_sym_globallycoherent] = ACTIONS(6264),
    [anon_sym_centroid] = ACTIONS(6264),
    [anon_sym_noperspective] = ACTIONS(6264),
    [anon_sym_nointerpolation] = ACTIONS(6264),
    [anon_sym_sample] = ACTIONS(6264),
    [anon_sym_linear] = ACTIONS(6264),
    [anon_sym_snorm] = ACTIONS(6264),
    [anon_sym_unorm] = ACTIONS(6264),
    [anon_sym_point] = ACTIONS(6264),
    [anon_sym_line] = ACTIONS(6264),
    [anon_sym_triangleadj] = ACTIONS(6264),
    [anon_sym_lineadj] = ACTIONS(6264),
    [anon_sym_triangle] = ACTIONS(6264),
    [anon_sym_interface] = ACTIONS(6264),
    [anon_sym_extension] = ACTIONS(6264),
    [anon_sym___init] = ACTIONS(6264),
    [anon_sym___subscript] = ACTIONS(6264),
    [anon_sym_property] = ACTIONS(6264),
    [anon_sym_associatedtype] = ACTIONS(6264),
  },
  [2662] = {
    [sym__declaration_modifiers] = STATE(2906),
    [sym_attribute_specifier] = STATE(2906),
    [sym_attribute_declaration] = STATE(2906),
    [sym_ms_declspec_modifier] = STATE(2906),
    [sym_storage_class_specifier] = STATE(2906),
    [sym_type_qualifier] = STATE(2906),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3146),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2906),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2906),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3101),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(6716),
    [anon_sym_out] = ACTIONS(6716),
    [anon_sym_inout] = ACTIONS(6716),
    [anon_sym_virtual] = ACTIONS(6716),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(4411),
    [anon_sym_unsigned] = ACTIONS(4411),
    [anon_sym_long] = ACTIONS(4411),
    [anon_sym_short] = ACTIONS(4411),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(4413),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(4415),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
  },
  [2663] = {
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_COMMA] = ACTIONS(3352),
    [anon_sym_RPAREN] = ACTIONS(3352),
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3352),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym_LBRACE] = ACTIONS(3352),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3362),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_EQ] = ACTIONS(3352),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3362),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [anon_sym_asm] = ACTIONS(3362),
    [anon_sym___asm__] = ACTIONS(3362),
    [anon_sym___asm] = ACTIONS(3362),
    [anon_sym_DASH_GT] = ACTIONS(3352),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3362),
    [anon_sym_final] = ACTIONS(3362),
    [anon_sym_override] = ACTIONS(3362),
    [anon_sym_explicit] = ACTIONS(3362),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3362),
    [anon_sym_GT2] = ACTIONS(3352),
    [anon_sym_operator] = ACTIONS(3362),
    [anon_sym_try] = ACTIONS(3362),
    [anon_sym_noexcept] = ACTIONS(3362),
    [anon_sym_throw] = ACTIONS(3362),
    [anon_sym_requires] = ACTIONS(3362),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
    [anon_sym_where] = ACTIONS(3362),
  },
  [2664] = {
    [sym_identifier] = ACTIONS(4242),
    [anon_sym_COMMA] = ACTIONS(4240),
    [anon_sym_RPAREN] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_TILDE] = ACTIONS(4240),
    [anon_sym_STAR] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_AMP] = ACTIONS(4242),
    [anon_sym_SEMI] = ACTIONS(4240),
    [anon_sym___extension__] = ACTIONS(4242),
    [anon_sym_in] = ACTIONS(4242),
    [anon_sym_out] = ACTIONS(4242),
    [anon_sym_inout] = ACTIONS(4242),
    [anon_sym_virtual] = ACTIONS(4242),
    [anon_sym_extern] = ACTIONS(4242),
    [anon_sym___attribute__] = ACTIONS(4242),
    [anon_sym___attribute] = ACTIONS(4242),
    [anon_sym_COLON_COLON] = ACTIONS(4240),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4240),
    [anon_sym___declspec] = ACTIONS(4242),
    [anon_sym___based] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_signed] = ACTIONS(4242),
    [anon_sym_unsigned] = ACTIONS(4242),
    [anon_sym_long] = ACTIONS(4242),
    [anon_sym_short] = ACTIONS(4242),
    [anon_sym_LBRACK] = ACTIONS(4242),
    [anon_sym_static] = ACTIONS(4242),
    [anon_sym_EQ] = ACTIONS(4240),
    [anon_sym_register] = ACTIONS(4242),
    [anon_sym_inline] = ACTIONS(4242),
    [anon_sym___inline] = ACTIONS(4242),
    [anon_sym___inline__] = ACTIONS(4242),
    [anon_sym___forceinline] = ACTIONS(4242),
    [anon_sym_thread_local] = ACTIONS(4242),
    [anon_sym___thread] = ACTIONS(4242),
    [anon_sym_const] = ACTIONS(4242),
    [anon_sym_constexpr] = ACTIONS(4242),
    [anon_sym_volatile] = ACTIONS(4242),
    [anon_sym_restrict] = ACTIONS(4242),
    [anon_sym___restrict__] = ACTIONS(4242),
    [anon_sym__Atomic] = ACTIONS(4242),
    [anon_sym__Noreturn] = ACTIONS(4242),
    [anon_sym_noreturn] = ACTIONS(4242),
    [anon_sym__Nonnull] = ACTIONS(4242),
    [anon_sym_mutable] = ACTIONS(4242),
    [anon_sym_constinit] = ACTIONS(4242),
    [anon_sym_consteval] = ACTIONS(4242),
    [anon_sym_alignas] = ACTIONS(4242),
    [anon_sym__Alignas] = ACTIONS(4242),
    [sym_primitive_type] = ACTIONS(4242),
    [anon_sym_enum] = ACTIONS(4242),
    [anon_sym_class] = ACTIONS(4242),
    [anon_sym_struct] = ACTIONS(4242),
    [anon_sym_union] = ACTIONS(4242),
    [anon_sym_asm] = ACTIONS(4242),
    [anon_sym___asm__] = ACTIONS(4242),
    [anon_sym___asm] = ACTIONS(4242),
    [anon_sym_DASH_GT] = ACTIONS(4240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4242),
    [anon_sym_let] = ACTIONS(4242),
    [anon_sym_This] = ACTIONS(4242),
    [anon_sym_decltype] = ACTIONS(4242),
    [anon_sym_final] = ACTIONS(4242),
    [anon_sym_override] = ACTIONS(4242),
    [anon_sym_explicit] = ACTIONS(4242),
    [anon_sym_typename] = ACTIONS(4242),
    [anon_sym_template] = ACTIONS(4242),
    [anon_sym_GT2] = ACTIONS(4240),
    [anon_sym_operator] = ACTIONS(4242),
    [anon_sym_try] = ACTIONS(4242),
    [anon_sym_noexcept] = ACTIONS(4242),
    [anon_sym_throw] = ACTIONS(4242),
    [anon_sym_requires] = ACTIONS(4242),
    [anon_sym_precise] = ACTIONS(4242),
    [anon_sym_shared] = ACTIONS(4242),
    [anon_sym_groupshared] = ACTIONS(4242),
    [anon_sym_uniform] = ACTIONS(4242),
    [anon_sym_row_major] = ACTIONS(4242),
    [anon_sym_column_major] = ACTIONS(4242),
    [anon_sym_globallycoherent] = ACTIONS(4242),
    [anon_sym_centroid] = ACTIONS(4242),
    [anon_sym_noperspective] = ACTIONS(4242),
    [anon_sym_nointerpolation] = ACTIONS(4242),
    [anon_sym_sample] = ACTIONS(4242),
    [anon_sym_linear] = ACTIONS(4242),
    [anon_sym_snorm] = ACTIONS(4242),
    [anon_sym_unorm] = ACTIONS(4242),
    [anon_sym_point] = ACTIONS(4242),
    [anon_sym_line] = ACTIONS(4242),
    [anon_sym_triangleadj] = ACTIONS(4242),
    [anon_sym_lineadj] = ACTIONS(4242),
    [anon_sym_triangle] = ACTIONS(4242),
    [anon_sym_interface] = ACTIONS(4242),
    [anon_sym_extension] = ACTIONS(4242),
    [anon_sym_where] = ACTIONS(4242),
  },
  [2665] = {
    [sym__declaration_modifiers] = STATE(2906),
    [sym_attribute_specifier] = STATE(2906),
    [sym_attribute_declaration] = STATE(2906),
    [sym_ms_declspec_modifier] = STATE(2906),
    [sym_storage_class_specifier] = STATE(2906),
    [sym_type_qualifier] = STATE(2906),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(3091),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2906),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2906),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(6716),
    [anon_sym_out] = ACTIONS(6716),
    [anon_sym_inout] = ACTIONS(6716),
    [anon_sym_virtual] = ACTIONS(6716),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2476),
    [anon_sym_union] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_extension] = ACTIONS(2492),
  },
  [2666] = {
    [sym__declaration_modifiers] = STATE(2906),
    [sym_attribute_specifier] = STATE(2906),
    [sym_attribute_declaration] = STATE(2906),
    [sym_ms_declspec_modifier] = STATE(2906),
    [sym_storage_class_specifier] = STATE(2906),
    [sym_type_qualifier] = STATE(2906),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2805),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8754),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2906),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2906),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(4401),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(6716),
    [anon_sym_out] = ACTIONS(6716),
    [anon_sym_inout] = ACTIONS(6716),
    [anon_sym_virtual] = ACTIONS(6716),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(213),
    [anon_sym_struct] = ACTIONS(215),
    [anon_sym_union] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(255),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(277),
    [anon_sym_extension] = ACTIONS(279),
  },
  [2667] = {
    [sym__declaration_modifiers] = STATE(2906),
    [sym_attribute_specifier] = STATE(2906),
    [sym_attribute_declaration] = STATE(2906),
    [sym_ms_declspec_modifier] = STATE(2906),
    [sym_storage_class_specifier] = STATE(2906),
    [sym_type_qualifier] = STATE(2906),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_type_specifier] = STATE(2806),
    [sym_sized_type_specifier] = STATE(2839),
    [sym_enum_specifier] = STATE(2839),
    [sym_struct_specifier] = STATE(2839),
    [sym_union_specifier] = STATE(2839),
    [sym_placeholder_type_specifier] = STATE(2839),
    [sym_decltype] = STATE(2842),
    [sym_class_specifier] = STATE(2839),
    [sym_dependent_type] = STATE(2839),
    [sym_template_type] = STATE(2842),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(8769),
    [sym_qualified_type_identifier] = STATE(2888),
    [sym_qualifiers] = STATE(2906),
    [sym_interface_specifier] = STATE(2839),
    [sym_extension_specifier] = STATE(2839),
    [sym_associatedtype_specifier] = STATE(2839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2906),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2717),
    [sym_identifier] = ACTIONS(5515),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(6716),
    [anon_sym_out] = ACTIONS(6716),
    [anon_sym_inout] = ACTIONS(6716),
    [anon_sym_virtual] = ACTIONS(6716),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5525),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2326),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(203),
    [anon_sym_unsigned] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(251),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_This] = ACTIONS(251),
    [anon_sym_decltype] = ACTIONS(253),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_extension] = ACTIONS(2398),
  },
  [2668] = {
    [sym__declaration_modifiers] = STATE(3010),
    [sym_attribute_specifier] = STATE(3010),
    [sym_attribute_declaration] = STATE(3010),
    [sym_ms_declspec_modifier] = STATE(3010),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7963),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(3010),
    [sym_type_qualifier] = STATE(3010),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_decltype] = STATE(11339),
    [sym_explicit_function_specifier] = STATE(3010),
    [sym_operator_cast] = STATE(9074),
    [sym__constructor_specifiers] = STATE(3010),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(11339),
    [sym_template_function] = STATE(8054),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7190),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_operator_cast_identifier] = STATE(9074),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(3010),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3010),
    [sym_identifier] = ACTIONS(6718),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(6722),
    [anon_sym_out] = ACTIONS(6722),
    [anon_sym_inout] = ACTIONS(6722),
    [anon_sym_virtual] = ACTIONS(6722),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(6728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [2669] = {
    [sym__declaration_modifiers] = STATE(3010),
    [sym_attribute_specifier] = STATE(3010),
    [sym_attribute_declaration] = STATE(3010),
    [sym_ms_declspec_modifier] = STATE(3010),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7936),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(3010),
    [sym_type_qualifier] = STATE(3010),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_decltype] = STATE(11339),
    [sym_explicit_function_specifier] = STATE(3010),
    [sym_operator_cast] = STATE(9110),
    [sym__constructor_specifiers] = STATE(3010),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(11339),
    [sym_template_function] = STATE(8054),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7190),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_operator_cast_identifier] = STATE(9110),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(3010),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3010),
    [sym_identifier] = ACTIONS(6718),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(6722),
    [anon_sym_out] = ACTIONS(6722),
    [anon_sym_inout] = ACTIONS(6722),
    [anon_sym_virtual] = ACTIONS(6722),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(6728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [2670] = {
    [sym__declaration_modifiers] = STATE(3010),
    [sym_attribute_specifier] = STATE(3010),
    [sym_attribute_declaration] = STATE(3010),
    [sym_ms_declspec_modifier] = STATE(3010),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8129),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(3010),
    [sym_type_qualifier] = STATE(3010),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_decltype] = STATE(11339),
    [sym_explicit_function_specifier] = STATE(3010),
    [sym_operator_cast] = STATE(9087),
    [sym__constructor_specifiers] = STATE(3010),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(11339),
    [sym_template_function] = STATE(8054),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7190),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_operator_cast_identifier] = STATE(9087),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(3010),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3010),
    [sym_identifier] = ACTIONS(6718),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(6722),
    [anon_sym_out] = ACTIONS(6722),
    [anon_sym_inout] = ACTIONS(6722),
    [anon_sym_virtual] = ACTIONS(6722),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(6728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [2671] = {
    [sym__declaration_modifiers] = STATE(3010),
    [sym_attribute_specifier] = STATE(3010),
    [sym_attribute_declaration] = STATE(3010),
    [sym_ms_declspec_modifier] = STATE(3010),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7992),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(3010),
    [sym_type_qualifier] = STATE(3010),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_decltype] = STATE(11339),
    [sym_explicit_function_specifier] = STATE(3010),
    [sym_operator_cast] = STATE(9087),
    [sym__constructor_specifiers] = STATE(3010),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(11339),
    [sym_template_function] = STATE(8054),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7190),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_operator_cast_identifier] = STATE(9087),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(3010),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3010),
    [sym_identifier] = ACTIONS(6718),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(6722),
    [anon_sym_out] = ACTIONS(6722),
    [anon_sym_inout] = ACTIONS(6722),
    [anon_sym_virtual] = ACTIONS(6722),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(6728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [2672] = {
    [sym__declaration_modifiers] = STATE(3010),
    [sym_attribute_specifier] = STATE(3010),
    [sym_attribute_declaration] = STATE(3010),
    [sym_ms_declspec_modifier] = STATE(3010),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8071),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(3010),
    [sym_type_qualifier] = STATE(3010),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_decltype] = STATE(11339),
    [sym_explicit_function_specifier] = STATE(3010),
    [sym_operator_cast] = STATE(9197),
    [sym__constructor_specifiers] = STATE(3010),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(11339),
    [sym_template_function] = STATE(8054),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7190),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_operator_cast_identifier] = STATE(9197),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(3010),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3010),
    [sym_identifier] = ACTIONS(6718),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(6722),
    [anon_sym_out] = ACTIONS(6722),
    [anon_sym_inout] = ACTIONS(6722),
    [anon_sym_virtual] = ACTIONS(6722),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(6728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [2673] = {
    [sym__declaration_modifiers] = STATE(3010),
    [sym_attribute_specifier] = STATE(3010),
    [sym_attribute_declaration] = STATE(3010),
    [sym_ms_declspec_modifier] = STATE(3010),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8113),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(3010),
    [sym_type_qualifier] = STATE(3010),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_decltype] = STATE(11339),
    [sym_explicit_function_specifier] = STATE(3010),
    [sym_operator_cast] = STATE(9046),
    [sym__constructor_specifiers] = STATE(3010),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(11339),
    [sym_template_function] = STATE(8054),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7190),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_operator_cast_identifier] = STATE(9046),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(3010),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3010),
    [sym_identifier] = ACTIONS(6718),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(6722),
    [anon_sym_out] = ACTIONS(6722),
    [anon_sym_inout] = ACTIONS(6722),
    [anon_sym_virtual] = ACTIONS(6722),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(6728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [2674] = {
    [sym__declaration_modifiers] = STATE(3010),
    [sym_attribute_specifier] = STATE(3010),
    [sym_attribute_declaration] = STATE(3010),
    [sym_ms_declspec_modifier] = STATE(3010),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7971),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(3010),
    [sym_type_qualifier] = STATE(3010),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_decltype] = STATE(11339),
    [sym_explicit_function_specifier] = STATE(3010),
    [sym_operator_cast] = STATE(9197),
    [sym__constructor_specifiers] = STATE(3010),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(11339),
    [sym_template_function] = STATE(8054),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7190),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_operator_cast_identifier] = STATE(9197),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(3010),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3010),
    [sym_identifier] = ACTIONS(6718),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(6722),
    [anon_sym_out] = ACTIONS(6722),
    [anon_sym_inout] = ACTIONS(6722),
    [anon_sym_virtual] = ACTIONS(6722),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(6728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [2675] = {
    [sym__declaration_modifiers] = STATE(3010),
    [sym_attribute_specifier] = STATE(3010),
    [sym_attribute_declaration] = STATE(3010),
    [sym_ms_declspec_modifier] = STATE(3010),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7969),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(3010),
    [sym_type_qualifier] = STATE(3010),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_decltype] = STATE(11339),
    [sym_explicit_function_specifier] = STATE(3010),
    [sym_operator_cast] = STATE(9046),
    [sym__constructor_specifiers] = STATE(3010),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(11339),
    [sym_template_function] = STATE(8054),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7190),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_operator_cast_identifier] = STATE(9046),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(3010),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3010),
    [sym_identifier] = ACTIONS(6718),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(6722),
    [anon_sym_out] = ACTIONS(6722),
    [anon_sym_inout] = ACTIONS(6722),
    [anon_sym_virtual] = ACTIONS(6722),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(6728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [2676] = {
    [sym__declaration_modifiers] = STATE(3010),
    [sym_attribute_specifier] = STATE(3010),
    [sym_attribute_declaration] = STATE(3010),
    [sym_ms_declspec_modifier] = STATE(3010),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7995),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(3010),
    [sym_type_qualifier] = STATE(3010),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_decltype] = STATE(11339),
    [sym_explicit_function_specifier] = STATE(3010),
    [sym_operator_cast] = STATE(9183),
    [sym__constructor_specifiers] = STATE(3010),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(11339),
    [sym_template_function] = STATE(8054),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7190),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_operator_cast_identifier] = STATE(9183),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(3010),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3010),
    [sym_identifier] = ACTIONS(6718),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(6722),
    [anon_sym_out] = ACTIONS(6722),
    [anon_sym_inout] = ACTIONS(6722),
    [anon_sym_virtual] = ACTIONS(6722),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(6728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [2677] = {
    [sym__declaration_modifiers] = STATE(3010),
    [sym_attribute_specifier] = STATE(3010),
    [sym_attribute_declaration] = STATE(3010),
    [sym_ms_declspec_modifier] = STATE(3010),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(7964),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(3010),
    [sym_type_qualifier] = STATE(3010),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_decltype] = STATE(11339),
    [sym_explicit_function_specifier] = STATE(3010),
    [sym_operator_cast] = STATE(9202),
    [sym__constructor_specifiers] = STATE(3010),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(11339),
    [sym_template_function] = STATE(8054),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7190),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_operator_cast_identifier] = STATE(9202),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(3010),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3010),
    [sym_identifier] = ACTIONS(6718),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(6722),
    [anon_sym_out] = ACTIONS(6722),
    [anon_sym_inout] = ACTIONS(6722),
    [anon_sym_virtual] = ACTIONS(6722),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(6728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [2678] = {
    [sym__declaration_modifiers] = STATE(3010),
    [sym_attribute_specifier] = STATE(3010),
    [sym_attribute_declaration] = STATE(3010),
    [sym_ms_declspec_modifier] = STATE(3010),
    [sym_ms_based_modifier] = STATE(11547),
    [sym__declarator] = STATE(8915),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_function_declarator] = STATE(8127),
    [sym_array_declarator] = STATE(8054),
    [sym_storage_class_specifier] = STATE(3010),
    [sym_type_qualifier] = STATE(3010),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_decltype] = STATE(11339),
    [sym_explicit_function_specifier] = STATE(3010),
    [sym_operator_cast] = STATE(9110),
    [sym__constructor_specifiers] = STATE(3010),
    [sym_reference_declarator] = STATE(8054),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym_template_type] = STATE(11339),
    [sym_template_function] = STATE(8054),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7190),
    [sym_qualified_identifier] = STATE(8054),
    [sym_qualified_operator_cast_identifier] = STATE(9110),
    [sym_operator_name] = STATE(8054),
    [sym_qualifiers] = STATE(3010),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3010),
    [sym_identifier] = ACTIONS(6718),
    [anon_sym_LPAREN2] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(6722),
    [anon_sym_out] = ACTIONS(6722),
    [anon_sym_inout] = ACTIONS(6722),
    [anon_sym_virtual] = ACTIONS(6722),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(6728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [2679] = {
    [sym_type_qualifier] = STATE(2679),
    [sym_alignas_qualifier] = STATE(2719),
    [aux_sym__type_definition_type_repeat1] = STATE(2679),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3681),
    [anon_sym_COMMA] = ACTIONS(3681),
    [anon_sym_RPAREN] = ACTIONS(3681),
    [anon_sym_LPAREN2] = ACTIONS(3681),
    [anon_sym_TILDE] = ACTIONS(3681),
    [anon_sym_STAR] = ACTIONS(3681),
    [anon_sym_AMP_AMP] = ACTIONS(3681),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3683),
    [anon_sym_SEMI] = ACTIONS(3681),
    [anon_sym___extension__] = ACTIONS(6738),
    [anon_sym_in] = ACTIONS(3683),
    [anon_sym_out] = ACTIONS(3683),
    [anon_sym_inout] = ACTIONS(3683),
    [anon_sym_virtual] = ACTIONS(3683),
    [anon_sym_extern] = ACTIONS(3683),
    [anon_sym___attribute__] = ACTIONS(3683),
    [anon_sym___attribute] = ACTIONS(3683),
    [anon_sym_COLON_COLON] = ACTIONS(3681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3681),
    [anon_sym___declspec] = ACTIONS(3683),
    [anon_sym___based] = ACTIONS(3683),
    [anon_sym___cdecl] = ACTIONS(3683),
    [anon_sym___clrcall] = ACTIONS(3683),
    [anon_sym___stdcall] = ACTIONS(3683),
    [anon_sym___fastcall] = ACTIONS(3683),
    [anon_sym___thiscall] = ACTIONS(3683),
    [anon_sym___vectorcall] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3681),
    [anon_sym_signed] = ACTIONS(3683),
    [anon_sym_unsigned] = ACTIONS(3683),
    [anon_sym_long] = ACTIONS(3683),
    [anon_sym_short] = ACTIONS(3683),
    [anon_sym_LBRACK] = ACTIONS(3683),
    [anon_sym_static] = ACTIONS(3683),
    [anon_sym_EQ] = ACTIONS(3681),
    [anon_sym_register] = ACTIONS(3683),
    [anon_sym_inline] = ACTIONS(3683),
    [anon_sym___inline] = ACTIONS(3683),
    [anon_sym___inline__] = ACTIONS(3683),
    [anon_sym___forceinline] = ACTIONS(3683),
    [anon_sym_thread_local] = ACTIONS(3683),
    [anon_sym___thread] = ACTIONS(3683),
    [anon_sym_const] = ACTIONS(6738),
    [anon_sym_constexpr] = ACTIONS(6738),
    [anon_sym_volatile] = ACTIONS(6738),
    [anon_sym_restrict] = ACTIONS(6738),
    [anon_sym___restrict__] = ACTIONS(6738),
    [anon_sym__Atomic] = ACTIONS(6738),
    [anon_sym__Noreturn] = ACTIONS(6738),
    [anon_sym_noreturn] = ACTIONS(6738),
    [anon_sym__Nonnull] = ACTIONS(6738),
    [anon_sym_mutable] = ACTIONS(6738),
    [anon_sym_constinit] = ACTIONS(6738),
    [anon_sym_consteval] = ACTIONS(6738),
    [anon_sym_alignas] = ACTIONS(6741),
    [anon_sym__Alignas] = ACTIONS(6741),
    [sym_primitive_type] = ACTIONS(3683),
    [anon_sym_DOT] = ACTIONS(3683),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3683),
    [anon_sym_let] = ACTIONS(3683),
    [anon_sym_This] = ACTIONS(3683),
    [anon_sym_decltype] = ACTIONS(3683),
    [anon_sym_final] = ACTIONS(3683),
    [anon_sym_override] = ACTIONS(3683),
    [anon_sym_template] = ACTIONS(3683),
    [anon_sym_GT2] = ACTIONS(3681),
    [anon_sym_operator] = ACTIONS(3683),
    [anon_sym_requires] = ACTIONS(3683),
    [anon_sym_precise] = ACTIONS(3683),
    [anon_sym_shared] = ACTIONS(3683),
    [anon_sym_groupshared] = ACTIONS(3683),
    [anon_sym_uniform] = ACTIONS(3683),
    [anon_sym_row_major] = ACTIONS(3683),
    [anon_sym_column_major] = ACTIONS(3683),
    [anon_sym_globallycoherent] = ACTIONS(3683),
    [anon_sym_centroid] = ACTIONS(3683),
    [anon_sym_noperspective] = ACTIONS(3683),
    [anon_sym_nointerpolation] = ACTIONS(3683),
    [anon_sym_sample] = ACTIONS(3683),
    [anon_sym_linear] = ACTIONS(3683),
    [anon_sym_snorm] = ACTIONS(3683),
    [anon_sym_unorm] = ACTIONS(3683),
    [anon_sym_point] = ACTIONS(3683),
    [anon_sym_line] = ACTIONS(3683),
    [anon_sym_triangleadj] = ACTIONS(3683),
    [anon_sym_lineadj] = ACTIONS(3683),
    [anon_sym_triangle] = ACTIONS(3683),
    [anon_sym_where] = ACTIONS(3683),
  },
  [2680] = {
    [sym_template_argument_list] = STATE(2688),
    [sym_identifier] = ACTIONS(2222),
    [anon_sym_LPAREN2] = ACTIONS(2229),
    [anon_sym_TILDE] = ACTIONS(2229),
    [anon_sym_STAR] = ACTIONS(2229),
    [anon_sym_PIPE_PIPE] = ACTIONS(2229),
    [anon_sym_AMP_AMP] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(6744),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_virtual] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym___attribute] = ACTIONS(2222),
    [anon_sym_using] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2229),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym___based] = ACTIONS(2222),
    [anon_sym___cdecl] = ACTIONS(2222),
    [anon_sym___clrcall] = ACTIONS(2222),
    [anon_sym___stdcall] = ACTIONS(2222),
    [anon_sym___fastcall] = ACTIONS(2222),
    [anon_sym___thiscall] = ACTIONS(2222),
    [anon_sym___vectorcall] = ACTIONS(2222),
    [anon_sym_signed] = ACTIONS(2222),
    [anon_sym_unsigned] = ACTIONS(2222),
    [anon_sym_long] = ACTIONS(2222),
    [anon_sym_short] = ACTIONS(2222),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym__Nonnull] = ACTIONS(2222),
    [anon_sym_mutable] = ACTIONS(2222),
    [anon_sym_constinit] = ACTIONS(2222),
    [anon_sym_consteval] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [sym_primitive_type] = ACTIONS(2222),
    [anon_sym_enum] = ACTIONS(2222),
    [anon_sym_class] = ACTIONS(2222),
    [anon_sym_struct] = ACTIONS(2222),
    [anon_sym_union] = ACTIONS(2222),
    [anon_sym_or] = ACTIONS(2222),
    [anon_sym_and] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2222),
    [anon_sym_let] = ACTIONS(2222),
    [anon_sym_This] = ACTIONS(2222),
    [anon_sym_decltype] = ACTIONS(2222),
    [anon_sym_explicit] = ACTIONS(2222),
    [anon_sym_typename] = ACTIONS(2222),
    [anon_sym_template] = ACTIONS(2222),
    [anon_sym_operator] = ACTIONS(2222),
    [anon_sym_friend] = ACTIONS(2222),
    [anon_sym_concept] = ACTIONS(2222),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_groupshared] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_row_major] = ACTIONS(2222),
    [anon_sym_column_major] = ACTIONS(2222),
    [anon_sym_globallycoherent] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym_nointerpolation] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_linear] = ACTIONS(2222),
    [anon_sym_snorm] = ACTIONS(2222),
    [anon_sym_unorm] = ACTIONS(2222),
    [anon_sym_point] = ACTIONS(2222),
    [anon_sym_line] = ACTIONS(2222),
    [anon_sym_triangleadj] = ACTIONS(2222),
    [anon_sym_lineadj] = ACTIONS(2222),
    [anon_sym_triangle] = ACTIONS(2222),
    [anon_sym_interface] = ACTIONS(2222),
    [anon_sym_extension] = ACTIONS(2222),
  },
  [2681] = {
    [sym_identifier] = ACTIONS(6746),
    [anon_sym_LPAREN2] = ACTIONS(6748),
    [anon_sym_TILDE] = ACTIONS(6748),
    [anon_sym_STAR] = ACTIONS(6748),
    [anon_sym_AMP_AMP] = ACTIONS(6748),
    [anon_sym_AMP] = ACTIONS(6746),
    [anon_sym___extension__] = ACTIONS(6746),
    [anon_sym_in] = ACTIONS(6746),
    [anon_sym_out] = ACTIONS(6746),
    [anon_sym_inout] = ACTIONS(6746),
    [anon_sym_virtual] = ACTIONS(6746),
    [anon_sym_extern] = ACTIONS(6746),
    [anon_sym___attribute__] = ACTIONS(6746),
    [anon_sym___attribute] = ACTIONS(6746),
    [anon_sym_using] = ACTIONS(6746),
    [anon_sym_COLON_COLON] = ACTIONS(6748),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6748),
    [anon_sym___declspec] = ACTIONS(6746),
    [anon_sym___based] = ACTIONS(6746),
    [anon_sym___cdecl] = ACTIONS(6746),
    [anon_sym___clrcall] = ACTIONS(6746),
    [anon_sym___stdcall] = ACTIONS(6746),
    [anon_sym___fastcall] = ACTIONS(6746),
    [anon_sym___thiscall] = ACTIONS(6746),
    [anon_sym___vectorcall] = ACTIONS(6746),
    [anon_sym_LBRACE] = ACTIONS(6748),
    [anon_sym_signed] = ACTIONS(6746),
    [anon_sym_unsigned] = ACTIONS(6746),
    [anon_sym_long] = ACTIONS(6746),
    [anon_sym_short] = ACTIONS(6746),
    [anon_sym_LBRACK] = ACTIONS(6746),
    [anon_sym_static] = ACTIONS(6746),
    [anon_sym_register] = ACTIONS(6746),
    [anon_sym_inline] = ACTIONS(6746),
    [anon_sym___inline] = ACTIONS(6746),
    [anon_sym___inline__] = ACTIONS(6746),
    [anon_sym___forceinline] = ACTIONS(6746),
    [anon_sym_thread_local] = ACTIONS(6746),
    [anon_sym___thread] = ACTIONS(6746),
    [anon_sym_const] = ACTIONS(6746),
    [anon_sym_constexpr] = ACTIONS(6746),
    [anon_sym_volatile] = ACTIONS(6746),
    [anon_sym_restrict] = ACTIONS(6746),
    [anon_sym___restrict__] = ACTIONS(6746),
    [anon_sym__Atomic] = ACTIONS(6746),
    [anon_sym__Noreturn] = ACTIONS(6746),
    [anon_sym_noreturn] = ACTIONS(6746),
    [anon_sym__Nonnull] = ACTIONS(6746),
    [anon_sym_mutable] = ACTIONS(6746),
    [anon_sym_constinit] = ACTIONS(6746),
    [anon_sym_consteval] = ACTIONS(6746),
    [anon_sym_alignas] = ACTIONS(6746),
    [anon_sym__Alignas] = ACTIONS(6746),
    [sym_primitive_type] = ACTIONS(6746),
    [anon_sym_enum] = ACTIONS(6746),
    [anon_sym_class] = ACTIONS(6746),
    [anon_sym_struct] = ACTIONS(6746),
    [anon_sym_union] = ACTIONS(6746),
    [anon_sym_DASH_GT] = ACTIONS(6748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6746),
    [anon_sym_let] = ACTIONS(6746),
    [anon_sym_This] = ACTIONS(6746),
    [anon_sym_decltype] = ACTIONS(6746),
    [anon_sym_explicit] = ACTIONS(6746),
    [anon_sym_typename] = ACTIONS(6746),
    [anon_sym_template] = ACTIONS(6746),
    [anon_sym_operator] = ACTIONS(6746),
    [anon_sym_friend] = ACTIONS(6746),
    [anon_sym_noexcept] = ACTIONS(6746),
    [anon_sym_throw] = ACTIONS(6746),
    [anon_sym_concept] = ACTIONS(6746),
    [anon_sym_requires] = ACTIONS(6746),
    [anon_sym_precise] = ACTIONS(6746),
    [anon_sym_shared] = ACTIONS(6746),
    [anon_sym_groupshared] = ACTIONS(6746),
    [anon_sym_uniform] = ACTIONS(6746),
    [anon_sym_row_major] = ACTIONS(6746),
    [anon_sym_column_major] = ACTIONS(6746),
    [anon_sym_globallycoherent] = ACTIONS(6746),
    [anon_sym_centroid] = ACTIONS(6746),
    [anon_sym_noperspective] = ACTIONS(6746),
    [anon_sym_nointerpolation] = ACTIONS(6746),
    [anon_sym_sample] = ACTIONS(6746),
    [anon_sym_linear] = ACTIONS(6746),
    [anon_sym_snorm] = ACTIONS(6746),
    [anon_sym_unorm] = ACTIONS(6746),
    [anon_sym_point] = ACTIONS(6746),
    [anon_sym_line] = ACTIONS(6746),
    [anon_sym_triangleadj] = ACTIONS(6746),
    [anon_sym_lineadj] = ACTIONS(6746),
    [anon_sym_triangle] = ACTIONS(6746),
    [anon_sym_interface] = ACTIONS(6746),
    [anon_sym_extension] = ACTIONS(6746),
  },
  [2682] = {
    [sym_identifier] = ACTIONS(6750),
    [anon_sym_LPAREN2] = ACTIONS(6752),
    [anon_sym_TILDE] = ACTIONS(6752),
    [anon_sym_STAR] = ACTIONS(6752),
    [anon_sym_AMP_AMP] = ACTIONS(6752),
    [anon_sym_AMP] = ACTIONS(6750),
    [anon_sym___extension__] = ACTIONS(6750),
    [anon_sym_in] = ACTIONS(6750),
    [anon_sym_out] = ACTIONS(6750),
    [anon_sym_inout] = ACTIONS(6750),
    [anon_sym_virtual] = ACTIONS(6750),
    [anon_sym_extern] = ACTIONS(6750),
    [anon_sym___attribute__] = ACTIONS(6750),
    [anon_sym___attribute] = ACTIONS(6750),
    [anon_sym_using] = ACTIONS(6750),
    [anon_sym_COLON_COLON] = ACTIONS(6752),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6752),
    [anon_sym___declspec] = ACTIONS(6750),
    [anon_sym___based] = ACTIONS(6750),
    [anon_sym___cdecl] = ACTIONS(6750),
    [anon_sym___clrcall] = ACTIONS(6750),
    [anon_sym___stdcall] = ACTIONS(6750),
    [anon_sym___fastcall] = ACTIONS(6750),
    [anon_sym___thiscall] = ACTIONS(6750),
    [anon_sym___vectorcall] = ACTIONS(6750),
    [anon_sym_LBRACE] = ACTIONS(6752),
    [anon_sym_signed] = ACTIONS(6750),
    [anon_sym_unsigned] = ACTIONS(6750),
    [anon_sym_long] = ACTIONS(6750),
    [anon_sym_short] = ACTIONS(6750),
    [anon_sym_LBRACK] = ACTIONS(6750),
    [anon_sym_static] = ACTIONS(6750),
    [anon_sym_register] = ACTIONS(6750),
    [anon_sym_inline] = ACTIONS(6750),
    [anon_sym___inline] = ACTIONS(6750),
    [anon_sym___inline__] = ACTIONS(6750),
    [anon_sym___forceinline] = ACTIONS(6750),
    [anon_sym_thread_local] = ACTIONS(6750),
    [anon_sym___thread] = ACTIONS(6750),
    [anon_sym_const] = ACTIONS(6750),
    [anon_sym_constexpr] = ACTIONS(6750),
    [anon_sym_volatile] = ACTIONS(6750),
    [anon_sym_restrict] = ACTIONS(6750),
    [anon_sym___restrict__] = ACTIONS(6750),
    [anon_sym__Atomic] = ACTIONS(6750),
    [anon_sym__Noreturn] = ACTIONS(6750),
    [anon_sym_noreturn] = ACTIONS(6750),
    [anon_sym__Nonnull] = ACTIONS(6750),
    [anon_sym_mutable] = ACTIONS(6750),
    [anon_sym_constinit] = ACTIONS(6750),
    [anon_sym_consteval] = ACTIONS(6750),
    [anon_sym_alignas] = ACTIONS(6750),
    [anon_sym__Alignas] = ACTIONS(6750),
    [sym_primitive_type] = ACTIONS(6750),
    [anon_sym_enum] = ACTIONS(6750),
    [anon_sym_class] = ACTIONS(6750),
    [anon_sym_struct] = ACTIONS(6750),
    [anon_sym_union] = ACTIONS(6750),
    [anon_sym_DASH_GT] = ACTIONS(6752),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6750),
    [anon_sym_let] = ACTIONS(6750),
    [anon_sym_This] = ACTIONS(6750),
    [anon_sym_decltype] = ACTIONS(6750),
    [anon_sym_explicit] = ACTIONS(6750),
    [anon_sym_typename] = ACTIONS(6750),
    [anon_sym_template] = ACTIONS(6750),
    [anon_sym_operator] = ACTIONS(6750),
    [anon_sym_friend] = ACTIONS(6750),
    [anon_sym_noexcept] = ACTIONS(6750),
    [anon_sym_throw] = ACTIONS(6750),
    [anon_sym_concept] = ACTIONS(6750),
    [anon_sym_requires] = ACTIONS(6750),
    [anon_sym_precise] = ACTIONS(6750),
    [anon_sym_shared] = ACTIONS(6750),
    [anon_sym_groupshared] = ACTIONS(6750),
    [anon_sym_uniform] = ACTIONS(6750),
    [anon_sym_row_major] = ACTIONS(6750),
    [anon_sym_column_major] = ACTIONS(6750),
    [anon_sym_globallycoherent] = ACTIONS(6750),
    [anon_sym_centroid] = ACTIONS(6750),
    [anon_sym_noperspective] = ACTIONS(6750),
    [anon_sym_nointerpolation] = ACTIONS(6750),
    [anon_sym_sample] = ACTIONS(6750),
    [anon_sym_linear] = ACTIONS(6750),
    [anon_sym_snorm] = ACTIONS(6750),
    [anon_sym_unorm] = ACTIONS(6750),
    [anon_sym_point] = ACTIONS(6750),
    [anon_sym_line] = ACTIONS(6750),
    [anon_sym_triangleadj] = ACTIONS(6750),
    [anon_sym_lineadj] = ACTIONS(6750),
    [anon_sym_triangle] = ACTIONS(6750),
    [anon_sym_interface] = ACTIONS(6750),
    [anon_sym_extension] = ACTIONS(6750),
  },
  [2683] = {
    [sym_template_argument_list] = STATE(2688),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_LPAREN2] = ACTIONS(2408),
    [anon_sym_TILDE] = ACTIONS(2408),
    [anon_sym_STAR] = ACTIONS(2408),
    [anon_sym_PIPE_PIPE] = ACTIONS(2408),
    [anon_sym_AMP_AMP] = ACTIONS(2408),
    [anon_sym_AMP] = ACTIONS(2410),
    [anon_sym_LT] = ACTIONS(6744),
    [anon_sym___extension__] = ACTIONS(2410),
    [anon_sym_in] = ACTIONS(2410),
    [anon_sym_out] = ACTIONS(2410),
    [anon_sym_inout] = ACTIONS(2410),
    [anon_sym_virtual] = ACTIONS(2410),
    [anon_sym_extern] = ACTIONS(2410),
    [anon_sym___attribute__] = ACTIONS(2410),
    [anon_sym___attribute] = ACTIONS(2410),
    [anon_sym_using] = ACTIONS(2410),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2408),
    [anon_sym___declspec] = ACTIONS(2410),
    [anon_sym___based] = ACTIONS(2410),
    [anon_sym___cdecl] = ACTIONS(2410),
    [anon_sym___clrcall] = ACTIONS(2410),
    [anon_sym___stdcall] = ACTIONS(2410),
    [anon_sym___fastcall] = ACTIONS(2410),
    [anon_sym___thiscall] = ACTIONS(2410),
    [anon_sym___vectorcall] = ACTIONS(2410),
    [anon_sym_signed] = ACTIONS(2410),
    [anon_sym_unsigned] = ACTIONS(2410),
    [anon_sym_long] = ACTIONS(2410),
    [anon_sym_short] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_static] = ACTIONS(2410),
    [anon_sym_register] = ACTIONS(2410),
    [anon_sym_inline] = ACTIONS(2410),
    [anon_sym___inline] = ACTIONS(2410),
    [anon_sym___inline__] = ACTIONS(2410),
    [anon_sym___forceinline] = ACTIONS(2410),
    [anon_sym_thread_local] = ACTIONS(2410),
    [anon_sym___thread] = ACTIONS(2410),
    [anon_sym_const] = ACTIONS(2410),
    [anon_sym_constexpr] = ACTIONS(2410),
    [anon_sym_volatile] = ACTIONS(2410),
    [anon_sym_restrict] = ACTIONS(2410),
    [anon_sym___restrict__] = ACTIONS(2410),
    [anon_sym__Atomic] = ACTIONS(2410),
    [anon_sym__Noreturn] = ACTIONS(2410),
    [anon_sym_noreturn] = ACTIONS(2410),
    [anon_sym__Nonnull] = ACTIONS(2410),
    [anon_sym_mutable] = ACTIONS(2410),
    [anon_sym_constinit] = ACTIONS(2410),
    [anon_sym_consteval] = ACTIONS(2410),
    [anon_sym_alignas] = ACTIONS(2410),
    [anon_sym__Alignas] = ACTIONS(2410),
    [sym_primitive_type] = ACTIONS(2410),
    [anon_sym_enum] = ACTIONS(2410),
    [anon_sym_class] = ACTIONS(2410),
    [anon_sym_struct] = ACTIONS(2410),
    [anon_sym_union] = ACTIONS(2410),
    [anon_sym_or] = ACTIONS(2410),
    [anon_sym_and] = ACTIONS(2410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2410),
    [anon_sym_let] = ACTIONS(2410),
    [anon_sym_This] = ACTIONS(2410),
    [anon_sym_decltype] = ACTIONS(2410),
    [anon_sym_explicit] = ACTIONS(2410),
    [anon_sym_typename] = ACTIONS(2410),
    [anon_sym_template] = ACTIONS(2410),
    [anon_sym_operator] = ACTIONS(2410),
    [anon_sym_friend] = ACTIONS(2410),
    [anon_sym_concept] = ACTIONS(2410),
    [anon_sym_precise] = ACTIONS(2410),
    [anon_sym_shared] = ACTIONS(2410),
    [anon_sym_groupshared] = ACTIONS(2410),
    [anon_sym_uniform] = ACTIONS(2410),
    [anon_sym_row_major] = ACTIONS(2410),
    [anon_sym_column_major] = ACTIONS(2410),
    [anon_sym_globallycoherent] = ACTIONS(2410),
    [anon_sym_centroid] = ACTIONS(2410),
    [anon_sym_noperspective] = ACTIONS(2410),
    [anon_sym_nointerpolation] = ACTIONS(2410),
    [anon_sym_sample] = ACTIONS(2410),
    [anon_sym_linear] = ACTIONS(2410),
    [anon_sym_snorm] = ACTIONS(2410),
    [anon_sym_unorm] = ACTIONS(2410),
    [anon_sym_point] = ACTIONS(2410),
    [anon_sym_line] = ACTIONS(2410),
    [anon_sym_triangleadj] = ACTIONS(2410),
    [anon_sym_lineadj] = ACTIONS(2410),
    [anon_sym_triangle] = ACTIONS(2410),
    [anon_sym_interface] = ACTIONS(2410),
    [anon_sym_extension] = ACTIONS(2410),
  },
  [2684] = {
    [sym_identifier] = ACTIONS(6754),
    [anon_sym_LPAREN2] = ACTIONS(6756),
    [anon_sym_TILDE] = ACTIONS(6756),
    [anon_sym_STAR] = ACTIONS(6756),
    [anon_sym_AMP_AMP] = ACTIONS(6756),
    [anon_sym_AMP] = ACTIONS(6754),
    [anon_sym___extension__] = ACTIONS(6754),
    [anon_sym_in] = ACTIONS(6754),
    [anon_sym_out] = ACTIONS(6754),
    [anon_sym_inout] = ACTIONS(6754),
    [anon_sym_virtual] = ACTIONS(6754),
    [anon_sym_extern] = ACTIONS(6754),
    [anon_sym___attribute__] = ACTIONS(6754),
    [anon_sym___attribute] = ACTIONS(6754),
    [anon_sym_using] = ACTIONS(6754),
    [anon_sym_COLON_COLON] = ACTIONS(6756),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6756),
    [anon_sym___declspec] = ACTIONS(6754),
    [anon_sym___based] = ACTIONS(6754),
    [anon_sym___cdecl] = ACTIONS(6754),
    [anon_sym___clrcall] = ACTIONS(6754),
    [anon_sym___stdcall] = ACTIONS(6754),
    [anon_sym___fastcall] = ACTIONS(6754),
    [anon_sym___thiscall] = ACTIONS(6754),
    [anon_sym___vectorcall] = ACTIONS(6754),
    [anon_sym_LBRACE] = ACTIONS(6756),
    [anon_sym_signed] = ACTIONS(6754),
    [anon_sym_unsigned] = ACTIONS(6754),
    [anon_sym_long] = ACTIONS(6754),
    [anon_sym_short] = ACTIONS(6754),
    [anon_sym_LBRACK] = ACTIONS(6754),
    [anon_sym_static] = ACTIONS(6754),
    [anon_sym_register] = ACTIONS(6754),
    [anon_sym_inline] = ACTIONS(6754),
    [anon_sym___inline] = ACTIONS(6754),
    [anon_sym___inline__] = ACTIONS(6754),
    [anon_sym___forceinline] = ACTIONS(6754),
    [anon_sym_thread_local] = ACTIONS(6754),
    [anon_sym___thread] = ACTIONS(6754),
    [anon_sym_const] = ACTIONS(6754),
    [anon_sym_constexpr] = ACTIONS(6754),
    [anon_sym_volatile] = ACTIONS(6754),
    [anon_sym_restrict] = ACTIONS(6754),
    [anon_sym___restrict__] = ACTIONS(6754),
    [anon_sym__Atomic] = ACTIONS(6754),
    [anon_sym__Noreturn] = ACTIONS(6754),
    [anon_sym_noreturn] = ACTIONS(6754),
    [anon_sym__Nonnull] = ACTIONS(6754),
    [anon_sym_mutable] = ACTIONS(6754),
    [anon_sym_constinit] = ACTIONS(6754),
    [anon_sym_consteval] = ACTIONS(6754),
    [anon_sym_alignas] = ACTIONS(6754),
    [anon_sym__Alignas] = ACTIONS(6754),
    [sym_primitive_type] = ACTIONS(6754),
    [anon_sym_enum] = ACTIONS(6754),
    [anon_sym_class] = ACTIONS(6754),
    [anon_sym_struct] = ACTIONS(6754),
    [anon_sym_union] = ACTIONS(6754),
    [anon_sym_DASH_GT] = ACTIONS(6756),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6754),
    [anon_sym_let] = ACTIONS(6754),
    [anon_sym_This] = ACTIONS(6754),
    [anon_sym_decltype] = ACTIONS(6754),
    [anon_sym_explicit] = ACTIONS(6754),
    [anon_sym_typename] = ACTIONS(6754),
    [anon_sym_template] = ACTIONS(6754),
    [anon_sym_operator] = ACTIONS(6754),
    [anon_sym_friend] = ACTIONS(6754),
    [anon_sym_noexcept] = ACTIONS(6754),
    [anon_sym_throw] = ACTIONS(6754),
    [anon_sym_concept] = ACTIONS(6754),
    [anon_sym_requires] = ACTIONS(6754),
    [anon_sym_precise] = ACTIONS(6754),
    [anon_sym_shared] = ACTIONS(6754),
    [anon_sym_groupshared] = ACTIONS(6754),
    [anon_sym_uniform] = ACTIONS(6754),
    [anon_sym_row_major] = ACTIONS(6754),
    [anon_sym_column_major] = ACTIONS(6754),
    [anon_sym_globallycoherent] = ACTIONS(6754),
    [anon_sym_centroid] = ACTIONS(6754),
    [anon_sym_noperspective] = ACTIONS(6754),
    [anon_sym_nointerpolation] = ACTIONS(6754),
    [anon_sym_sample] = ACTIONS(6754),
    [anon_sym_linear] = ACTIONS(6754),
    [anon_sym_snorm] = ACTIONS(6754),
    [anon_sym_unorm] = ACTIONS(6754),
    [anon_sym_point] = ACTIONS(6754),
    [anon_sym_line] = ACTIONS(6754),
    [anon_sym_triangleadj] = ACTIONS(6754),
    [anon_sym_lineadj] = ACTIONS(6754),
    [anon_sym_triangle] = ACTIONS(6754),
    [anon_sym_interface] = ACTIONS(6754),
    [anon_sym_extension] = ACTIONS(6754),
  },
  [2685] = {
    [sym_identifier] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4250),
    [anon_sym_COMMA] = ACTIONS(4250),
    [anon_sym_RPAREN] = ACTIONS(4250),
    [anon_sym_LPAREN2] = ACTIONS(4250),
    [anon_sym_TILDE] = ACTIONS(4250),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_AMP_AMP] = ACTIONS(4250),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_COLON] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4250),
    [anon_sym___extension__] = ACTIONS(4248),
    [anon_sym_in] = ACTIONS(4248),
    [anon_sym_out] = ACTIONS(4248),
    [anon_sym_inout] = ACTIONS(4248),
    [anon_sym_virtual] = ACTIONS(4248),
    [anon_sym_extern] = ACTIONS(4248),
    [anon_sym___attribute__] = ACTIONS(4248),
    [anon_sym___attribute] = ACTIONS(4248),
    [anon_sym_COLON_COLON] = ACTIONS(4250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4250),
    [anon_sym___declspec] = ACTIONS(4248),
    [anon_sym___based] = ACTIONS(4248),
    [anon_sym___cdecl] = ACTIONS(4248),
    [anon_sym___clrcall] = ACTIONS(4248),
    [anon_sym___stdcall] = ACTIONS(4248),
    [anon_sym___fastcall] = ACTIONS(4248),
    [anon_sym___thiscall] = ACTIONS(4248),
    [anon_sym___vectorcall] = ACTIONS(4248),
    [anon_sym_LBRACE] = ACTIONS(4250),
    [anon_sym_LBRACK] = ACTIONS(4248),
    [anon_sym_static] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4250),
    [anon_sym_register] = ACTIONS(4248),
    [anon_sym_inline] = ACTIONS(4248),
    [anon_sym___inline] = ACTIONS(4248),
    [anon_sym___inline__] = ACTIONS(4248),
    [anon_sym___forceinline] = ACTIONS(4248),
    [anon_sym_thread_local] = ACTIONS(4248),
    [anon_sym___thread] = ACTIONS(4248),
    [anon_sym_const] = ACTIONS(4248),
    [anon_sym_constexpr] = ACTIONS(4248),
    [anon_sym_volatile] = ACTIONS(4248),
    [anon_sym_restrict] = ACTIONS(4248),
    [anon_sym___restrict__] = ACTIONS(4248),
    [anon_sym__Atomic] = ACTIONS(4248),
    [anon_sym__Noreturn] = ACTIONS(4248),
    [anon_sym_noreturn] = ACTIONS(4248),
    [anon_sym__Nonnull] = ACTIONS(4248),
    [anon_sym_mutable] = ACTIONS(4248),
    [anon_sym_constinit] = ACTIONS(4248),
    [anon_sym_consteval] = ACTIONS(4248),
    [anon_sym_alignas] = ACTIONS(4248),
    [anon_sym__Alignas] = ACTIONS(4248),
    [anon_sym_asm] = ACTIONS(4248),
    [anon_sym___asm__] = ACTIONS(4248),
    [anon_sym___asm] = ACTIONS(4248),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_DASH_GT] = ACTIONS(4250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4248),
    [anon_sym_let] = ACTIONS(4248),
    [anon_sym_This] = ACTIONS(4248),
    [anon_sym_decltype] = ACTIONS(4248),
    [anon_sym_final] = ACTIONS(4248),
    [anon_sym_override] = ACTIONS(4248),
    [anon_sym_explicit] = ACTIONS(4248),
    [anon_sym_template] = ACTIONS(4248),
    [anon_sym_GT2] = ACTIONS(4250),
    [anon_sym_operator] = ACTIONS(4248),
    [anon_sym_noexcept] = ACTIONS(4248),
    [anon_sym_throw] = ACTIONS(4248),
    [anon_sym_requires] = ACTIONS(4248),
    [anon_sym_precise] = ACTIONS(4248),
    [anon_sym_shared] = ACTIONS(4248),
    [anon_sym_groupshared] = ACTIONS(4248),
    [anon_sym_uniform] = ACTIONS(4248),
    [anon_sym_row_major] = ACTIONS(4248),
    [anon_sym_column_major] = ACTIONS(4248),
    [anon_sym_globallycoherent] = ACTIONS(4248),
    [anon_sym_centroid] = ACTIONS(4248),
    [anon_sym_noperspective] = ACTIONS(4248),
    [anon_sym_nointerpolation] = ACTIONS(4248),
    [anon_sym_sample] = ACTIONS(4248),
    [anon_sym_linear] = ACTIONS(4248),
    [anon_sym_snorm] = ACTIONS(4248),
    [anon_sym_unorm] = ACTIONS(4248),
    [anon_sym_point] = ACTIONS(4248),
    [anon_sym_line] = ACTIONS(4248),
    [anon_sym_triangleadj] = ACTIONS(4248),
    [anon_sym_lineadj] = ACTIONS(4248),
    [anon_sym_triangle] = ACTIONS(4248),
    [anon_sym_where] = ACTIONS(4248),
  },
  [2686] = {
    [sym_string_literal] = STATE(3241),
    [sym_template_argument_list] = STATE(2999),
    [sym_raw_string_literal] = STATE(3241),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_RPAREN] = ACTIONS(2172),
    [anon_sym_LPAREN2] = ACTIONS(2172),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6758),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym___extension__] = ACTIONS(2176),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6761),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_signed] = ACTIONS(6763),
    [anon_sym_unsigned] = ACTIONS(6763),
    [anon_sym_long] = ACTIONS(6763),
    [anon_sym_short] = ACTIONS(6763),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [anon_sym_EQ] = ACTIONS(2181),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2176),
    [anon_sym_volatile] = ACTIONS(2176),
    [anon_sym_restrict] = ACTIONS(2176),
    [anon_sym___restrict__] = ACTIONS(2176),
    [anon_sym__Atomic] = ACTIONS(2176),
    [anon_sym__Noreturn] = ACTIONS(2176),
    [anon_sym_noreturn] = ACTIONS(2176),
    [anon_sym__Nonnull] = ACTIONS(2176),
    [anon_sym_mutable] = ACTIONS(2176),
    [anon_sym_constinit] = ACTIONS(2176),
    [anon_sym_consteval] = ACTIONS(2176),
    [anon_sym_alignas] = ACTIONS(2176),
    [anon_sym__Alignas] = ACTIONS(2176),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2170),
    [anon_sym_SLASH_EQ] = ACTIONS(2170),
    [anon_sym_PERCENT_EQ] = ACTIONS(2170),
    [anon_sym_PLUS_EQ] = ACTIONS(2170),
    [anon_sym_DASH_EQ] = ACTIONS(2170),
    [anon_sym_LT_LT_EQ] = ACTIONS(2170),
    [anon_sym_GT_GT_EQ] = ACTIONS(2170),
    [anon_sym_AMP_EQ] = ACTIONS(2170),
    [anon_sym_CARET_EQ] = ACTIONS(2170),
    [anon_sym_PIPE_EQ] = ACTIONS(2170),
    [anon_sym_and_eq] = ACTIONS(2170),
    [anon_sym_or_eq] = ACTIONS(2170),
    [anon_sym_xor_eq] = ACTIONS(2170),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2181),
    [anon_sym_L_DQUOTE] = ACTIONS(6765),
    [anon_sym_u_DQUOTE] = ACTIONS(6765),
    [anon_sym_U_DQUOTE] = ACTIONS(6765),
    [anon_sym_u8_DQUOTE] = ACTIONS(6765),
    [anon_sym_DQUOTE] = ACTIONS(6765),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2176),
    [anon_sym_let] = ACTIONS(2176),
    [anon_sym_This] = ACTIONS(2176),
    [anon_sym_R_DQUOTE] = ACTIONS(6767),
    [anon_sym_LR_DQUOTE] = ACTIONS(6767),
    [anon_sym_uR_DQUOTE] = ACTIONS(6767),
    [anon_sym_UR_DQUOTE] = ACTIONS(6767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6767),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2170),
  },
  [2687] = {
    [sym_identifier] = ACTIONS(2276),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(2278),
    [anon_sym_PIPE_PIPE] = ACTIONS(2278),
    [anon_sym_AMP_AMP] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym___extension__] = ACTIONS(2276),
    [anon_sym_in] = ACTIONS(2276),
    [anon_sym_out] = ACTIONS(2276),
    [anon_sym_inout] = ACTIONS(2276),
    [anon_sym_virtual] = ACTIONS(2276),
    [anon_sym_extern] = ACTIONS(2276),
    [anon_sym___attribute__] = ACTIONS(2276),
    [anon_sym___attribute] = ACTIONS(2276),
    [anon_sym_using] = ACTIONS(2276),
    [anon_sym_COLON_COLON] = ACTIONS(2278),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2278),
    [anon_sym___declspec] = ACTIONS(2276),
    [anon_sym___based] = ACTIONS(2276),
    [anon_sym___cdecl] = ACTIONS(2276),
    [anon_sym___clrcall] = ACTIONS(2276),
    [anon_sym___stdcall] = ACTIONS(2276),
    [anon_sym___fastcall] = ACTIONS(2276),
    [anon_sym___thiscall] = ACTIONS(2276),
    [anon_sym___vectorcall] = ACTIONS(2276),
    [anon_sym_signed] = ACTIONS(2276),
    [anon_sym_unsigned] = ACTIONS(2276),
    [anon_sym_long] = ACTIONS(2276),
    [anon_sym_short] = ACTIONS(2276),
    [anon_sym_LBRACK] = ACTIONS(2276),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_register] = ACTIONS(2276),
    [anon_sym_inline] = ACTIONS(2276),
    [anon_sym___inline] = ACTIONS(2276),
    [anon_sym___inline__] = ACTIONS(2276),
    [anon_sym___forceinline] = ACTIONS(2276),
    [anon_sym_thread_local] = ACTIONS(2276),
    [anon_sym___thread] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_constexpr] = ACTIONS(2276),
    [anon_sym_volatile] = ACTIONS(2276),
    [anon_sym_restrict] = ACTIONS(2276),
    [anon_sym___restrict__] = ACTIONS(2276),
    [anon_sym__Atomic] = ACTIONS(2276),
    [anon_sym__Noreturn] = ACTIONS(2276),
    [anon_sym_noreturn] = ACTIONS(2276),
    [anon_sym__Nonnull] = ACTIONS(2276),
    [anon_sym_mutable] = ACTIONS(2276),
    [anon_sym_constinit] = ACTIONS(2276),
    [anon_sym_consteval] = ACTIONS(2276),
    [anon_sym_alignas] = ACTIONS(2276),
    [anon_sym__Alignas] = ACTIONS(2276),
    [sym_primitive_type] = ACTIONS(2276),
    [anon_sym_enum] = ACTIONS(2276),
    [anon_sym_class] = ACTIONS(2276),
    [anon_sym_struct] = ACTIONS(2276),
    [anon_sym_union] = ACTIONS(2276),
    [anon_sym_or] = ACTIONS(2276),
    [anon_sym_and] = ACTIONS(2276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_This] = ACTIONS(2276),
    [anon_sym_decltype] = ACTIONS(2276),
    [anon_sym_explicit] = ACTIONS(2276),
    [anon_sym_typename] = ACTIONS(2276),
    [anon_sym_template] = ACTIONS(2276),
    [anon_sym_operator] = ACTIONS(2276),
    [anon_sym_friend] = ACTIONS(2276),
    [anon_sym_concept] = ACTIONS(2276),
    [anon_sym_precise] = ACTIONS(2276),
    [anon_sym_shared] = ACTIONS(2276),
    [anon_sym_groupshared] = ACTIONS(2276),
    [anon_sym_uniform] = ACTIONS(2276),
    [anon_sym_row_major] = ACTIONS(2276),
    [anon_sym_column_major] = ACTIONS(2276),
    [anon_sym_globallycoherent] = ACTIONS(2276),
    [anon_sym_centroid] = ACTIONS(2276),
    [anon_sym_noperspective] = ACTIONS(2276),
    [anon_sym_nointerpolation] = ACTIONS(2276),
    [anon_sym_sample] = ACTIONS(2276),
    [anon_sym_linear] = ACTIONS(2276),
    [anon_sym_snorm] = ACTIONS(2276),
    [anon_sym_unorm] = ACTIONS(2276),
    [anon_sym_point] = ACTIONS(2276),
    [anon_sym_line] = ACTIONS(2276),
    [anon_sym_triangleadj] = ACTIONS(2276),
    [anon_sym_lineadj] = ACTIONS(2276),
    [anon_sym_triangle] = ACTIONS(2276),
    [anon_sym_interface] = ACTIONS(2276),
    [anon_sym_extension] = ACTIONS(2276),
  },
  [2688] = {
    [sym_identifier] = ACTIONS(2243),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_out] = ACTIONS(2243),
    [anon_sym_inout] = ACTIONS(2243),
    [anon_sym_virtual] = ACTIONS(2243),
    [anon_sym_extern] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym___attribute] = ACTIONS(2243),
    [anon_sym_using] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2243),
    [anon_sym___based] = ACTIONS(2243),
    [anon_sym___cdecl] = ACTIONS(2243),
    [anon_sym___clrcall] = ACTIONS(2243),
    [anon_sym___stdcall] = ACTIONS(2243),
    [anon_sym___fastcall] = ACTIONS(2243),
    [anon_sym___thiscall] = ACTIONS(2243),
    [anon_sym___vectorcall] = ACTIONS(2243),
    [anon_sym_signed] = ACTIONS(2243),
    [anon_sym_unsigned] = ACTIONS(2243),
    [anon_sym_long] = ACTIONS(2243),
    [anon_sym_short] = ACTIONS(2243),
    [anon_sym_LBRACK] = ACTIONS(2243),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_register] = ACTIONS(2243),
    [anon_sym_inline] = ACTIONS(2243),
    [anon_sym___inline] = ACTIONS(2243),
    [anon_sym___inline__] = ACTIONS(2243),
    [anon_sym___forceinline] = ACTIONS(2243),
    [anon_sym_thread_local] = ACTIONS(2243),
    [anon_sym___thread] = ACTIONS(2243),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym__Nonnull] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [sym_primitive_type] = ACTIONS(2243),
    [anon_sym_enum] = ACTIONS(2243),
    [anon_sym_class] = ACTIONS(2243),
    [anon_sym_struct] = ACTIONS(2243),
    [anon_sym_union] = ACTIONS(2243),
    [anon_sym_or] = ACTIONS(2243),
    [anon_sym_and] = ACTIONS(2243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2243),
    [anon_sym_let] = ACTIONS(2243),
    [anon_sym_This] = ACTIONS(2243),
    [anon_sym_decltype] = ACTIONS(2243),
    [anon_sym_explicit] = ACTIONS(2243),
    [anon_sym_typename] = ACTIONS(2243),
    [anon_sym_template] = ACTIONS(2243),
    [anon_sym_operator] = ACTIONS(2243),
    [anon_sym_friend] = ACTIONS(2243),
    [anon_sym_concept] = ACTIONS(2243),
    [anon_sym_precise] = ACTIONS(2243),
    [anon_sym_shared] = ACTIONS(2243),
    [anon_sym_groupshared] = ACTIONS(2243),
    [anon_sym_uniform] = ACTIONS(2243),
    [anon_sym_row_major] = ACTIONS(2243),
    [anon_sym_column_major] = ACTIONS(2243),
    [anon_sym_globallycoherent] = ACTIONS(2243),
    [anon_sym_centroid] = ACTIONS(2243),
    [anon_sym_noperspective] = ACTIONS(2243),
    [anon_sym_nointerpolation] = ACTIONS(2243),
    [anon_sym_sample] = ACTIONS(2243),
    [anon_sym_linear] = ACTIONS(2243),
    [anon_sym_snorm] = ACTIONS(2243),
    [anon_sym_unorm] = ACTIONS(2243),
    [anon_sym_point] = ACTIONS(2243),
    [anon_sym_line] = ACTIONS(2243),
    [anon_sym_triangleadj] = ACTIONS(2243),
    [anon_sym_lineadj] = ACTIONS(2243),
    [anon_sym_triangle] = ACTIONS(2243),
    [anon_sym_interface] = ACTIONS(2243),
    [anon_sym_extension] = ACTIONS(2243),
  },
  [2689] = {
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_PIPE_PIPE] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_out] = ACTIONS(2422),
    [anon_sym_inout] = ACTIONS(2422),
    [anon_sym_virtual] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_using] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2422),
    [anon_sym___based] = ACTIONS(2422),
    [anon_sym___cdecl] = ACTIONS(2422),
    [anon_sym___clrcall] = ACTIONS(2422),
    [anon_sym___stdcall] = ACTIONS(2422),
    [anon_sym___fastcall] = ACTIONS(2422),
    [anon_sym___thiscall] = ACTIONS(2422),
    [anon_sym___vectorcall] = ACTIONS(2422),
    [anon_sym_signed] = ACTIONS(2422),
    [anon_sym_unsigned] = ACTIONS(2422),
    [anon_sym_long] = ACTIONS(2422),
    [anon_sym_short] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_register] = ACTIONS(2422),
    [anon_sym_inline] = ACTIONS(2422),
    [anon_sym___inline] = ACTIONS(2422),
    [anon_sym___inline__] = ACTIONS(2422),
    [anon_sym___forceinline] = ACTIONS(2422),
    [anon_sym_thread_local] = ACTIONS(2422),
    [anon_sym___thread] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [sym_primitive_type] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
    [anon_sym_class] = ACTIONS(2422),
    [anon_sym_struct] = ACTIONS(2422),
    [anon_sym_union] = ACTIONS(2422),
    [anon_sym_or] = ACTIONS(2422),
    [anon_sym_and] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_decltype] = ACTIONS(2422),
    [anon_sym_explicit] = ACTIONS(2422),
    [anon_sym_typename] = ACTIONS(2422),
    [anon_sym_template] = ACTIONS(2422),
    [anon_sym_operator] = ACTIONS(2422),
    [anon_sym_friend] = ACTIONS(2422),
    [anon_sym_concept] = ACTIONS(2422),
    [anon_sym_precise] = ACTIONS(2422),
    [anon_sym_shared] = ACTIONS(2422),
    [anon_sym_groupshared] = ACTIONS(2422),
    [anon_sym_uniform] = ACTIONS(2422),
    [anon_sym_row_major] = ACTIONS(2422),
    [anon_sym_column_major] = ACTIONS(2422),
    [anon_sym_globallycoherent] = ACTIONS(2422),
    [anon_sym_centroid] = ACTIONS(2422),
    [anon_sym_noperspective] = ACTIONS(2422),
    [anon_sym_nointerpolation] = ACTIONS(2422),
    [anon_sym_sample] = ACTIONS(2422),
    [anon_sym_linear] = ACTIONS(2422),
    [anon_sym_snorm] = ACTIONS(2422),
    [anon_sym_unorm] = ACTIONS(2422),
    [anon_sym_point] = ACTIONS(2422),
    [anon_sym_line] = ACTIONS(2422),
    [anon_sym_triangleadj] = ACTIONS(2422),
    [anon_sym_lineadj] = ACTIONS(2422),
    [anon_sym_triangle] = ACTIONS(2422),
    [anon_sym_interface] = ACTIONS(2422),
    [anon_sym_extension] = ACTIONS(2422),
  },
  [2690] = {
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2416),
    [anon_sym_TILDE] = ACTIONS(2416),
    [anon_sym_STAR] = ACTIONS(2416),
    [anon_sym_PIPE_PIPE] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym___extension__] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(2418),
    [anon_sym_out] = ACTIONS(2418),
    [anon_sym_inout] = ACTIONS(2418),
    [anon_sym_virtual] = ACTIONS(2418),
    [anon_sym_extern] = ACTIONS(2418),
    [anon_sym___attribute__] = ACTIONS(2418),
    [anon_sym___attribute] = ACTIONS(2418),
    [anon_sym_using] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2416),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2416),
    [anon_sym___declspec] = ACTIONS(2418),
    [anon_sym___based] = ACTIONS(2418),
    [anon_sym___cdecl] = ACTIONS(2418),
    [anon_sym___clrcall] = ACTIONS(2418),
    [anon_sym___stdcall] = ACTIONS(2418),
    [anon_sym___fastcall] = ACTIONS(2418),
    [anon_sym___thiscall] = ACTIONS(2418),
    [anon_sym___vectorcall] = ACTIONS(2418),
    [anon_sym_signed] = ACTIONS(2418),
    [anon_sym_unsigned] = ACTIONS(2418),
    [anon_sym_long] = ACTIONS(2418),
    [anon_sym_short] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2418),
    [anon_sym_register] = ACTIONS(2418),
    [anon_sym_inline] = ACTIONS(2418),
    [anon_sym___inline] = ACTIONS(2418),
    [anon_sym___inline__] = ACTIONS(2418),
    [anon_sym___forceinline] = ACTIONS(2418),
    [anon_sym_thread_local] = ACTIONS(2418),
    [anon_sym___thread] = ACTIONS(2418),
    [anon_sym_const] = ACTIONS(2418),
    [anon_sym_constexpr] = ACTIONS(2418),
    [anon_sym_volatile] = ACTIONS(2418),
    [anon_sym_restrict] = ACTIONS(2418),
    [anon_sym___restrict__] = ACTIONS(2418),
    [anon_sym__Atomic] = ACTIONS(2418),
    [anon_sym__Noreturn] = ACTIONS(2418),
    [anon_sym_noreturn] = ACTIONS(2418),
    [anon_sym__Nonnull] = ACTIONS(2418),
    [anon_sym_mutable] = ACTIONS(2418),
    [anon_sym_constinit] = ACTIONS(2418),
    [anon_sym_consteval] = ACTIONS(2418),
    [anon_sym_alignas] = ACTIONS(2418),
    [anon_sym__Alignas] = ACTIONS(2418),
    [sym_primitive_type] = ACTIONS(2418),
    [anon_sym_enum] = ACTIONS(2418),
    [anon_sym_class] = ACTIONS(2418),
    [anon_sym_struct] = ACTIONS(2418),
    [anon_sym_union] = ACTIONS(2418),
    [anon_sym_or] = ACTIONS(2418),
    [anon_sym_and] = ACTIONS(2418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_This] = ACTIONS(2418),
    [anon_sym_decltype] = ACTIONS(2418),
    [anon_sym_explicit] = ACTIONS(2418),
    [anon_sym_typename] = ACTIONS(2418),
    [anon_sym_template] = ACTIONS(2418),
    [anon_sym_operator] = ACTIONS(2418),
    [anon_sym_friend] = ACTIONS(2418),
    [anon_sym_concept] = ACTIONS(2418),
    [anon_sym_precise] = ACTIONS(2418),
    [anon_sym_shared] = ACTIONS(2418),
    [anon_sym_groupshared] = ACTIONS(2418),
    [anon_sym_uniform] = ACTIONS(2418),
    [anon_sym_row_major] = ACTIONS(2418),
    [anon_sym_column_major] = ACTIONS(2418),
    [anon_sym_globallycoherent] = ACTIONS(2418),
    [anon_sym_centroid] = ACTIONS(2418),
    [anon_sym_noperspective] = ACTIONS(2418),
    [anon_sym_nointerpolation] = ACTIONS(2418),
    [anon_sym_sample] = ACTIONS(2418),
    [anon_sym_linear] = ACTIONS(2418),
    [anon_sym_snorm] = ACTIONS(2418),
    [anon_sym_unorm] = ACTIONS(2418),
    [anon_sym_point] = ACTIONS(2418),
    [anon_sym_line] = ACTIONS(2418),
    [anon_sym_triangleadj] = ACTIONS(2418),
    [anon_sym_lineadj] = ACTIONS(2418),
    [anon_sym_triangle] = ACTIONS(2418),
    [anon_sym_interface] = ACTIONS(2418),
    [anon_sym_extension] = ACTIONS(2418),
  },
  [2691] = {
    [sym_identifier] = ACTIONS(2428),
    [anon_sym_LPAREN2] = ACTIONS(2426),
    [anon_sym_TILDE] = ACTIONS(2426),
    [anon_sym_STAR] = ACTIONS(2426),
    [anon_sym_PIPE_PIPE] = ACTIONS(2426),
    [anon_sym_AMP_AMP] = ACTIONS(2426),
    [anon_sym_AMP] = ACTIONS(2428),
    [anon_sym___extension__] = ACTIONS(2428),
    [anon_sym_in] = ACTIONS(2428),
    [anon_sym_out] = ACTIONS(2428),
    [anon_sym_inout] = ACTIONS(2428),
    [anon_sym_virtual] = ACTIONS(2428),
    [anon_sym_extern] = ACTIONS(2428),
    [anon_sym___attribute__] = ACTIONS(2428),
    [anon_sym___attribute] = ACTIONS(2428),
    [anon_sym_using] = ACTIONS(2428),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2426),
    [anon_sym___declspec] = ACTIONS(2428),
    [anon_sym___based] = ACTIONS(2428),
    [anon_sym___cdecl] = ACTIONS(2428),
    [anon_sym___clrcall] = ACTIONS(2428),
    [anon_sym___stdcall] = ACTIONS(2428),
    [anon_sym___fastcall] = ACTIONS(2428),
    [anon_sym___thiscall] = ACTIONS(2428),
    [anon_sym___vectorcall] = ACTIONS(2428),
    [anon_sym_signed] = ACTIONS(2428),
    [anon_sym_unsigned] = ACTIONS(2428),
    [anon_sym_long] = ACTIONS(2428),
    [anon_sym_short] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_static] = ACTIONS(2428),
    [anon_sym_register] = ACTIONS(2428),
    [anon_sym_inline] = ACTIONS(2428),
    [anon_sym___inline] = ACTIONS(2428),
    [anon_sym___inline__] = ACTIONS(2428),
    [anon_sym___forceinline] = ACTIONS(2428),
    [anon_sym_thread_local] = ACTIONS(2428),
    [anon_sym___thread] = ACTIONS(2428),
    [anon_sym_const] = ACTIONS(2428),
    [anon_sym_constexpr] = ACTIONS(2428),
    [anon_sym_volatile] = ACTIONS(2428),
    [anon_sym_restrict] = ACTIONS(2428),
    [anon_sym___restrict__] = ACTIONS(2428),
    [anon_sym__Atomic] = ACTIONS(2428),
    [anon_sym__Noreturn] = ACTIONS(2428),
    [anon_sym_noreturn] = ACTIONS(2428),
    [anon_sym__Nonnull] = ACTIONS(2428),
    [anon_sym_mutable] = ACTIONS(2428),
    [anon_sym_constinit] = ACTIONS(2428),
    [anon_sym_consteval] = ACTIONS(2428),
    [anon_sym_alignas] = ACTIONS(2428),
    [anon_sym__Alignas] = ACTIONS(2428),
    [sym_primitive_type] = ACTIONS(2428),
    [anon_sym_enum] = ACTIONS(2428),
    [anon_sym_class] = ACTIONS(2428),
    [anon_sym_struct] = ACTIONS(2428),
    [anon_sym_union] = ACTIONS(2428),
    [anon_sym_or] = ACTIONS(2428),
    [anon_sym_and] = ACTIONS(2428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2428),
    [anon_sym_let] = ACTIONS(2428),
    [anon_sym_This] = ACTIONS(2428),
    [anon_sym_decltype] = ACTIONS(2428),
    [anon_sym_explicit] = ACTIONS(2428),
    [anon_sym_typename] = ACTIONS(2428),
    [anon_sym_template] = ACTIONS(2428),
    [anon_sym_operator] = ACTIONS(2428),
    [anon_sym_friend] = ACTIONS(2428),
    [anon_sym_concept] = ACTIONS(2428),
    [anon_sym_precise] = ACTIONS(2428),
    [anon_sym_shared] = ACTIONS(2428),
    [anon_sym_groupshared] = ACTIONS(2428),
    [anon_sym_uniform] = ACTIONS(2428),
    [anon_sym_row_major] = ACTIONS(2428),
    [anon_sym_column_major] = ACTIONS(2428),
    [anon_sym_globallycoherent] = ACTIONS(2428),
    [anon_sym_centroid] = ACTIONS(2428),
    [anon_sym_noperspective] = ACTIONS(2428),
    [anon_sym_nointerpolation] = ACTIONS(2428),
    [anon_sym_sample] = ACTIONS(2428),
    [anon_sym_linear] = ACTIONS(2428),
    [anon_sym_snorm] = ACTIONS(2428),
    [anon_sym_unorm] = ACTIONS(2428),
    [anon_sym_point] = ACTIONS(2428),
    [anon_sym_line] = ACTIONS(2428),
    [anon_sym_triangleadj] = ACTIONS(2428),
    [anon_sym_lineadj] = ACTIONS(2428),
    [anon_sym_triangle] = ACTIONS(2428),
    [anon_sym_interface] = ACTIONS(2428),
    [anon_sym_extension] = ACTIONS(2428),
  },
  [2692] = {
    [sym_type_qualifier] = STATE(2692),
    [sym_alignas_qualifier] = STATE(2732),
    [aux_sym__type_definition_type_repeat1] = STATE(2692),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3681),
    [anon_sym_COMMA] = ACTIONS(3681),
    [anon_sym_RPAREN] = ACTIONS(3681),
    [aux_sym_preproc_if_token2] = ACTIONS(3681),
    [aux_sym_preproc_else_token1] = ACTIONS(3681),
    [aux_sym_preproc_elif_token1] = ACTIONS(3683),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3681),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3681),
    [anon_sym_LPAREN2] = ACTIONS(3681),
    [anon_sym_DASH] = ACTIONS(3683),
    [anon_sym_PLUS] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(3683),
    [anon_sym_SLASH] = ACTIONS(3683),
    [anon_sym_PERCENT] = ACTIONS(3683),
    [anon_sym_PIPE_PIPE] = ACTIONS(3681),
    [anon_sym_AMP_AMP] = ACTIONS(3681),
    [anon_sym_PIPE] = ACTIONS(3683),
    [anon_sym_CARET] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_EQ_EQ] = ACTIONS(3681),
    [anon_sym_BANG_EQ] = ACTIONS(3681),
    [anon_sym_GT] = ACTIONS(3683),
    [anon_sym_GT_EQ] = ACTIONS(3681),
    [anon_sym_LT_EQ] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_LT_LT] = ACTIONS(3683),
    [anon_sym_GT_GT] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3681),
    [anon_sym_SEMI] = ACTIONS(3681),
    [anon_sym___extension__] = ACTIONS(6769),
    [anon_sym___attribute__] = ACTIONS(3683),
    [anon_sym___attribute] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3681),
    [anon_sym_RBRACE] = ACTIONS(3681),
    [anon_sym_signed] = ACTIONS(3683),
    [anon_sym_unsigned] = ACTIONS(3683),
    [anon_sym_long] = ACTIONS(3683),
    [anon_sym_short] = ACTIONS(3683),
    [anon_sym_LBRACK] = ACTIONS(3681),
    [anon_sym_RBRACK] = ACTIONS(3681),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_const] = ACTIONS(6769),
    [anon_sym_constexpr] = ACTIONS(6769),
    [anon_sym_volatile] = ACTIONS(6769),
    [anon_sym_restrict] = ACTIONS(6769),
    [anon_sym___restrict__] = ACTIONS(6769),
    [anon_sym__Atomic] = ACTIONS(6769),
    [anon_sym__Noreturn] = ACTIONS(6769),
    [anon_sym_noreturn] = ACTIONS(6769),
    [anon_sym__Nonnull] = ACTIONS(6769),
    [anon_sym_mutable] = ACTIONS(6769),
    [anon_sym_constinit] = ACTIONS(6769),
    [anon_sym_consteval] = ACTIONS(6769),
    [anon_sym_alignas] = ACTIONS(6772),
    [anon_sym__Alignas] = ACTIONS(6772),
    [sym_primitive_type] = ACTIONS(3683),
    [anon_sym_QMARK] = ACTIONS(3681),
    [anon_sym_STAR_EQ] = ACTIONS(3681),
    [anon_sym_SLASH_EQ] = ACTIONS(3681),
    [anon_sym_PERCENT_EQ] = ACTIONS(3681),
    [anon_sym_PLUS_EQ] = ACTIONS(3681),
    [anon_sym_DASH_EQ] = ACTIONS(3681),
    [anon_sym_LT_LT_EQ] = ACTIONS(3681),
    [anon_sym_GT_GT_EQ] = ACTIONS(3681),
    [anon_sym_AMP_EQ] = ACTIONS(3681),
    [anon_sym_CARET_EQ] = ACTIONS(3681),
    [anon_sym_PIPE_EQ] = ACTIONS(3681),
    [anon_sym_and_eq] = ACTIONS(3683),
    [anon_sym_or_eq] = ACTIONS(3683),
    [anon_sym_xor_eq] = ACTIONS(3683),
    [anon_sym_LT_EQ_GT] = ACTIONS(3681),
    [anon_sym_or] = ACTIONS(3683),
    [anon_sym_and] = ACTIONS(3683),
    [anon_sym_bitor] = ACTIONS(3683),
    [anon_sym_xor] = ACTIONS(3683),
    [anon_sym_bitand] = ACTIONS(3683),
    [anon_sym_not_eq] = ACTIONS(3683),
    [anon_sym_is] = ACTIONS(3683),
    [anon_sym_as] = ACTIONS(3683),
    [anon_sym_DASH_DASH] = ACTIONS(3681),
    [anon_sym_PLUS_PLUS] = ACTIONS(3681),
    [anon_sym_DOT] = ACTIONS(3683),
    [anon_sym_DOT_STAR] = ACTIONS(3681),
    [anon_sym_DASH_GT] = ACTIONS(3681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3683),
    [anon_sym_let] = ACTIONS(3683),
    [anon_sym_This] = ACTIONS(3683),
  },
  [2693] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2693),
    [sym_identifier] = ACTIONS(2915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2913),
    [anon_sym_COMMA] = ACTIONS(2913),
    [anon_sym_RPAREN] = ACTIONS(2913),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_COLON] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym_in] = ACTIONS(2915),
    [anon_sym_out] = ACTIONS(2915),
    [anon_sym_inout] = ACTIONS(2915),
    [anon_sym_virtual] = ACTIONS(2915),
    [anon_sym_extern] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym_COLON_COLON] = ACTIONS(2913),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2913),
    [anon_sym___declspec] = ACTIONS(2915),
    [anon_sym___based] = ACTIONS(2915),
    [anon_sym___cdecl] = ACTIONS(2915),
    [anon_sym___clrcall] = ACTIONS(2915),
    [anon_sym___stdcall] = ACTIONS(2915),
    [anon_sym___fastcall] = ACTIONS(2915),
    [anon_sym___thiscall] = ACTIONS(2915),
    [anon_sym___vectorcall] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_signed] = ACTIONS(6775),
    [anon_sym_unsigned] = ACTIONS(6775),
    [anon_sym_long] = ACTIONS(6775),
    [anon_sym_short] = ACTIONS(6775),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_static] = ACTIONS(2915),
    [anon_sym_EQ] = ACTIONS(2913),
    [anon_sym_register] = ACTIONS(2915),
    [anon_sym_inline] = ACTIONS(2915),
    [anon_sym___inline] = ACTIONS(2915),
    [anon_sym___inline__] = ACTIONS(2915),
    [anon_sym___forceinline] = ACTIONS(2915),
    [anon_sym_thread_local] = ACTIONS(2915),
    [anon_sym___thread] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_DOT] = ACTIONS(2915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2915),
    [anon_sym_let] = ACTIONS(2915),
    [anon_sym_This] = ACTIONS(2915),
    [anon_sym_decltype] = ACTIONS(2915),
    [anon_sym_final] = ACTIONS(2915),
    [anon_sym_override] = ACTIONS(2915),
    [anon_sym_template] = ACTIONS(2915),
    [anon_sym_GT2] = ACTIONS(2913),
    [anon_sym_operator] = ACTIONS(2915),
    [anon_sym_requires] = ACTIONS(2915),
    [anon_sym_precise] = ACTIONS(2915),
    [anon_sym_shared] = ACTIONS(2915),
    [anon_sym_groupshared] = ACTIONS(2915),
    [anon_sym_uniform] = ACTIONS(2915),
    [anon_sym_row_major] = ACTIONS(2915),
    [anon_sym_column_major] = ACTIONS(2915),
    [anon_sym_globallycoherent] = ACTIONS(2915),
    [anon_sym_centroid] = ACTIONS(2915),
    [anon_sym_noperspective] = ACTIONS(2915),
    [anon_sym_nointerpolation] = ACTIONS(2915),
    [anon_sym_sample] = ACTIONS(2915),
    [anon_sym_linear] = ACTIONS(2915),
    [anon_sym_snorm] = ACTIONS(2915),
    [anon_sym_unorm] = ACTIONS(2915),
    [anon_sym_point] = ACTIONS(2915),
    [anon_sym_line] = ACTIONS(2915),
    [anon_sym_triangleadj] = ACTIONS(2915),
    [anon_sym_lineadj] = ACTIONS(2915),
    [anon_sym_triangle] = ACTIONS(2915),
    [anon_sym_where] = ACTIONS(2915),
  },
  [2694] = {
    [sym_identifier] = ACTIONS(2414),
    [anon_sym_LPAREN2] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_PIPE_PIPE] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym___extension__] = ACTIONS(2414),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_out] = ACTIONS(2414),
    [anon_sym_inout] = ACTIONS(2414),
    [anon_sym_virtual] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym___attribute__] = ACTIONS(2414),
    [anon_sym___attribute] = ACTIONS(2414),
    [anon_sym_using] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2412),
    [anon_sym___declspec] = ACTIONS(2414),
    [anon_sym___based] = ACTIONS(2414),
    [anon_sym___cdecl] = ACTIONS(2414),
    [anon_sym___clrcall] = ACTIONS(2414),
    [anon_sym___stdcall] = ACTIONS(2414),
    [anon_sym___fastcall] = ACTIONS(2414),
    [anon_sym___thiscall] = ACTIONS(2414),
    [anon_sym___vectorcall] = ACTIONS(2414),
    [anon_sym_signed] = ACTIONS(2414),
    [anon_sym_unsigned] = ACTIONS(2414),
    [anon_sym_long] = ACTIONS(2414),
    [anon_sym_short] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_register] = ACTIONS(2414),
    [anon_sym_inline] = ACTIONS(2414),
    [anon_sym___inline] = ACTIONS(2414),
    [anon_sym___inline__] = ACTIONS(2414),
    [anon_sym___forceinline] = ACTIONS(2414),
    [anon_sym_thread_local] = ACTIONS(2414),
    [anon_sym___thread] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_constexpr] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym_restrict] = ACTIONS(2414),
    [anon_sym___restrict__] = ACTIONS(2414),
    [anon_sym__Atomic] = ACTIONS(2414),
    [anon_sym__Noreturn] = ACTIONS(2414),
    [anon_sym_noreturn] = ACTIONS(2414),
    [anon_sym__Nonnull] = ACTIONS(2414),
    [anon_sym_mutable] = ACTIONS(2414),
    [anon_sym_constinit] = ACTIONS(2414),
    [anon_sym_consteval] = ACTIONS(2414),
    [anon_sym_alignas] = ACTIONS(2414),
    [anon_sym__Alignas] = ACTIONS(2414),
    [sym_primitive_type] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [anon_sym_or] = ACTIONS(2414),
    [anon_sym_and] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2414),
    [anon_sym_let] = ACTIONS(2414),
    [anon_sym_This] = ACTIONS(2414),
    [anon_sym_decltype] = ACTIONS(2414),
    [anon_sym_explicit] = ACTIONS(2414),
    [anon_sym_typename] = ACTIONS(2414),
    [anon_sym_template] = ACTIONS(2414),
    [anon_sym_operator] = ACTIONS(2414),
    [anon_sym_friend] = ACTIONS(2414),
    [anon_sym_concept] = ACTIONS(2414),
    [anon_sym_precise] = ACTIONS(2414),
    [anon_sym_shared] = ACTIONS(2414),
    [anon_sym_groupshared] = ACTIONS(2414),
    [anon_sym_uniform] = ACTIONS(2414),
    [anon_sym_row_major] = ACTIONS(2414),
    [anon_sym_column_major] = ACTIONS(2414),
    [anon_sym_globallycoherent] = ACTIONS(2414),
    [anon_sym_centroid] = ACTIONS(2414),
    [anon_sym_noperspective] = ACTIONS(2414),
    [anon_sym_nointerpolation] = ACTIONS(2414),
    [anon_sym_sample] = ACTIONS(2414),
    [anon_sym_linear] = ACTIONS(2414),
    [anon_sym_snorm] = ACTIONS(2414),
    [anon_sym_unorm] = ACTIONS(2414),
    [anon_sym_point] = ACTIONS(2414),
    [anon_sym_line] = ACTIONS(2414),
    [anon_sym_triangleadj] = ACTIONS(2414),
    [anon_sym_lineadj] = ACTIONS(2414),
    [anon_sym_triangle] = ACTIONS(2414),
    [anon_sym_interface] = ACTIONS(2414),
    [anon_sym_extension] = ACTIONS(2414),
  },
  [2695] = {
    [sym_string_literal] = STATE(3241),
    [sym_template_argument_list] = STATE(3073),
    [sym_raw_string_literal] = STATE(3241),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_RPAREN] = ACTIONS(2183),
    [anon_sym_LPAREN2] = ACTIONS(2183),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6778),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym___extension__] = ACTIONS(2176),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_signed] = ACTIONS(6763),
    [anon_sym_unsigned] = ACTIONS(6763),
    [anon_sym_long] = ACTIONS(6763),
    [anon_sym_short] = ACTIONS(6763),
    [anon_sym_LBRACK] = ACTIONS(2183),
    [anon_sym_EQ] = ACTIONS(2181),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2176),
    [anon_sym_volatile] = ACTIONS(2176),
    [anon_sym_restrict] = ACTIONS(2176),
    [anon_sym___restrict__] = ACTIONS(2176),
    [anon_sym__Atomic] = ACTIONS(2176),
    [anon_sym__Noreturn] = ACTIONS(2176),
    [anon_sym_noreturn] = ACTIONS(2176),
    [anon_sym__Nonnull] = ACTIONS(2176),
    [anon_sym_mutable] = ACTIONS(2176),
    [anon_sym_constinit] = ACTIONS(2176),
    [anon_sym_consteval] = ACTIONS(2176),
    [anon_sym_alignas] = ACTIONS(2176),
    [anon_sym__Alignas] = ACTIONS(2176),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2170),
    [anon_sym_SLASH_EQ] = ACTIONS(2170),
    [anon_sym_PERCENT_EQ] = ACTIONS(2170),
    [anon_sym_PLUS_EQ] = ACTIONS(2170),
    [anon_sym_DASH_EQ] = ACTIONS(2170),
    [anon_sym_LT_LT_EQ] = ACTIONS(2170),
    [anon_sym_GT_GT_EQ] = ACTIONS(2170),
    [anon_sym_AMP_EQ] = ACTIONS(2170),
    [anon_sym_CARET_EQ] = ACTIONS(2170),
    [anon_sym_PIPE_EQ] = ACTIONS(2170),
    [anon_sym_and_eq] = ACTIONS(2170),
    [anon_sym_or_eq] = ACTIONS(2170),
    [anon_sym_xor_eq] = ACTIONS(2170),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2181),
    [anon_sym_L_DQUOTE] = ACTIONS(6765),
    [anon_sym_u_DQUOTE] = ACTIONS(6765),
    [anon_sym_U_DQUOTE] = ACTIONS(6765),
    [anon_sym_u8_DQUOTE] = ACTIONS(6765),
    [anon_sym_DQUOTE] = ACTIONS(6765),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2176),
    [anon_sym_let] = ACTIONS(2176),
    [anon_sym_This] = ACTIONS(2176),
    [anon_sym_R_DQUOTE] = ACTIONS(6767),
    [anon_sym_LR_DQUOTE] = ACTIONS(6767),
    [anon_sym_uR_DQUOTE] = ACTIONS(6767),
    [anon_sym_UR_DQUOTE] = ACTIONS(6767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6767),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2170),
  },
  [2696] = {
    [sym_identifier] = ACTIONS(2404),
    [anon_sym_LPAREN2] = ACTIONS(2402),
    [anon_sym_TILDE] = ACTIONS(2402),
    [anon_sym_STAR] = ACTIONS(2402),
    [anon_sym_PIPE_PIPE] = ACTIONS(2402),
    [anon_sym_AMP_AMP] = ACTIONS(2402),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym___extension__] = ACTIONS(2404),
    [anon_sym_in] = ACTIONS(2404),
    [anon_sym_out] = ACTIONS(2404),
    [anon_sym_inout] = ACTIONS(2404),
    [anon_sym_virtual] = ACTIONS(2404),
    [anon_sym_extern] = ACTIONS(2404),
    [anon_sym___attribute__] = ACTIONS(2404),
    [anon_sym___attribute] = ACTIONS(2404),
    [anon_sym_using] = ACTIONS(2404),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2402),
    [anon_sym___declspec] = ACTIONS(2404),
    [anon_sym___based] = ACTIONS(2404),
    [anon_sym___cdecl] = ACTIONS(2404),
    [anon_sym___clrcall] = ACTIONS(2404),
    [anon_sym___stdcall] = ACTIONS(2404),
    [anon_sym___fastcall] = ACTIONS(2404),
    [anon_sym___thiscall] = ACTIONS(2404),
    [anon_sym___vectorcall] = ACTIONS(2404),
    [anon_sym_signed] = ACTIONS(2404),
    [anon_sym_unsigned] = ACTIONS(2404),
    [anon_sym_long] = ACTIONS(2404),
    [anon_sym_short] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_register] = ACTIONS(2404),
    [anon_sym_inline] = ACTIONS(2404),
    [anon_sym___inline] = ACTIONS(2404),
    [anon_sym___inline__] = ACTIONS(2404),
    [anon_sym___forceinline] = ACTIONS(2404),
    [anon_sym_thread_local] = ACTIONS(2404),
    [anon_sym___thread] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [anon_sym_constexpr] = ACTIONS(2404),
    [anon_sym_volatile] = ACTIONS(2404),
    [anon_sym_restrict] = ACTIONS(2404),
    [anon_sym___restrict__] = ACTIONS(2404),
    [anon_sym__Atomic] = ACTIONS(2404),
    [anon_sym__Noreturn] = ACTIONS(2404),
    [anon_sym_noreturn] = ACTIONS(2404),
    [anon_sym__Nonnull] = ACTIONS(2404),
    [anon_sym_mutable] = ACTIONS(2404),
    [anon_sym_constinit] = ACTIONS(2404),
    [anon_sym_consteval] = ACTIONS(2404),
    [anon_sym_alignas] = ACTIONS(2404),
    [anon_sym__Alignas] = ACTIONS(2404),
    [sym_primitive_type] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
    [anon_sym_class] = ACTIONS(2404),
    [anon_sym_struct] = ACTIONS(2404),
    [anon_sym_union] = ACTIONS(2404),
    [anon_sym_or] = ACTIONS(2404),
    [anon_sym_and] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2404),
    [anon_sym_let] = ACTIONS(2404),
    [anon_sym_This] = ACTIONS(2404),
    [anon_sym_decltype] = ACTIONS(2404),
    [anon_sym_explicit] = ACTIONS(2404),
    [anon_sym_typename] = ACTIONS(2404),
    [anon_sym_template] = ACTIONS(2404),
    [anon_sym_operator] = ACTIONS(2404),
    [anon_sym_friend] = ACTIONS(2404),
    [anon_sym_concept] = ACTIONS(2404),
    [anon_sym_precise] = ACTIONS(2404),
    [anon_sym_shared] = ACTIONS(2404),
    [anon_sym_groupshared] = ACTIONS(2404),
    [anon_sym_uniform] = ACTIONS(2404),
    [anon_sym_row_major] = ACTIONS(2404),
    [anon_sym_column_major] = ACTIONS(2404),
    [anon_sym_globallycoherent] = ACTIONS(2404),
    [anon_sym_centroid] = ACTIONS(2404),
    [anon_sym_noperspective] = ACTIONS(2404),
    [anon_sym_nointerpolation] = ACTIONS(2404),
    [anon_sym_sample] = ACTIONS(2404),
    [anon_sym_linear] = ACTIONS(2404),
    [anon_sym_snorm] = ACTIONS(2404),
    [anon_sym_unorm] = ACTIONS(2404),
    [anon_sym_point] = ACTIONS(2404),
    [anon_sym_line] = ACTIONS(2404),
    [anon_sym_triangleadj] = ACTIONS(2404),
    [anon_sym_lineadj] = ACTIONS(2404),
    [anon_sym_triangle] = ACTIONS(2404),
    [anon_sym_interface] = ACTIONS(2404),
    [anon_sym_extension] = ACTIONS(2404),
  },
  [2697] = {
    [sym_identifier] = ACTIONS(6781),
    [anon_sym_LPAREN2] = ACTIONS(6783),
    [anon_sym_TILDE] = ACTIONS(6783),
    [anon_sym_STAR] = ACTIONS(6783),
    [anon_sym_PIPE_PIPE] = ACTIONS(6785),
    [anon_sym_AMP_AMP] = ACTIONS(6787),
    [anon_sym_AMP] = ACTIONS(6781),
    [anon_sym___extension__] = ACTIONS(6781),
    [anon_sym_in] = ACTIONS(6781),
    [anon_sym_out] = ACTIONS(6781),
    [anon_sym_inout] = ACTIONS(6781),
    [anon_sym_virtual] = ACTIONS(6781),
    [anon_sym_extern] = ACTIONS(6781),
    [anon_sym___attribute__] = ACTIONS(6781),
    [anon_sym___attribute] = ACTIONS(6781),
    [anon_sym_using] = ACTIONS(6781),
    [anon_sym_COLON_COLON] = ACTIONS(6783),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6783),
    [anon_sym___declspec] = ACTIONS(6781),
    [anon_sym___based] = ACTIONS(6781),
    [anon_sym___cdecl] = ACTIONS(6781),
    [anon_sym___clrcall] = ACTIONS(6781),
    [anon_sym___stdcall] = ACTIONS(6781),
    [anon_sym___fastcall] = ACTIONS(6781),
    [anon_sym___thiscall] = ACTIONS(6781),
    [anon_sym___vectorcall] = ACTIONS(6781),
    [anon_sym_signed] = ACTIONS(6781),
    [anon_sym_unsigned] = ACTIONS(6781),
    [anon_sym_long] = ACTIONS(6781),
    [anon_sym_short] = ACTIONS(6781),
    [anon_sym_LBRACK] = ACTIONS(6781),
    [anon_sym_static] = ACTIONS(6781),
    [anon_sym_register] = ACTIONS(6781),
    [anon_sym_inline] = ACTIONS(6781),
    [anon_sym___inline] = ACTIONS(6781),
    [anon_sym___inline__] = ACTIONS(6781),
    [anon_sym___forceinline] = ACTIONS(6781),
    [anon_sym_thread_local] = ACTIONS(6781),
    [anon_sym___thread] = ACTIONS(6781),
    [anon_sym_const] = ACTIONS(6781),
    [anon_sym_constexpr] = ACTIONS(6781),
    [anon_sym_volatile] = ACTIONS(6781),
    [anon_sym_restrict] = ACTIONS(6781),
    [anon_sym___restrict__] = ACTIONS(6781),
    [anon_sym__Atomic] = ACTIONS(6781),
    [anon_sym__Noreturn] = ACTIONS(6781),
    [anon_sym_noreturn] = ACTIONS(6781),
    [anon_sym__Nonnull] = ACTIONS(6781),
    [anon_sym_mutable] = ACTIONS(6781),
    [anon_sym_constinit] = ACTIONS(6781),
    [anon_sym_consteval] = ACTIONS(6781),
    [anon_sym_alignas] = ACTIONS(6781),
    [anon_sym__Alignas] = ACTIONS(6781),
    [sym_primitive_type] = ACTIONS(6781),
    [anon_sym_enum] = ACTIONS(6781),
    [anon_sym_class] = ACTIONS(6781),
    [anon_sym_struct] = ACTIONS(6781),
    [anon_sym_union] = ACTIONS(6781),
    [anon_sym_or] = ACTIONS(6789),
    [anon_sym_and] = ACTIONS(6791),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6781),
    [anon_sym_let] = ACTIONS(6781),
    [anon_sym_This] = ACTIONS(6781),
    [anon_sym_decltype] = ACTIONS(6781),
    [anon_sym_explicit] = ACTIONS(6781),
    [anon_sym_typename] = ACTIONS(6781),
    [anon_sym_template] = ACTIONS(6781),
    [anon_sym_operator] = ACTIONS(6781),
    [anon_sym_friend] = ACTIONS(6781),
    [anon_sym_concept] = ACTIONS(6781),
    [anon_sym_precise] = ACTIONS(6781),
    [anon_sym_shared] = ACTIONS(6781),
    [anon_sym_groupshared] = ACTIONS(6781),
    [anon_sym_uniform] = ACTIONS(6781),
    [anon_sym_row_major] = ACTIONS(6781),
    [anon_sym_column_major] = ACTIONS(6781),
    [anon_sym_globallycoherent] = ACTIONS(6781),
    [anon_sym_centroid] = ACTIONS(6781),
    [anon_sym_noperspective] = ACTIONS(6781),
    [anon_sym_nointerpolation] = ACTIONS(6781),
    [anon_sym_sample] = ACTIONS(6781),
    [anon_sym_linear] = ACTIONS(6781),
    [anon_sym_snorm] = ACTIONS(6781),
    [anon_sym_unorm] = ACTIONS(6781),
    [anon_sym_point] = ACTIONS(6781),
    [anon_sym_line] = ACTIONS(6781),
    [anon_sym_triangleadj] = ACTIONS(6781),
    [anon_sym_lineadj] = ACTIONS(6781),
    [anon_sym_triangle] = ACTIONS(6781),
    [anon_sym_interface] = ACTIONS(6781),
    [anon_sym_extension] = ACTIONS(6781),
  },
  [2698] = {
    [sym_string_literal] = STATE(4607),
    [sym_template_argument_list] = STATE(3597),
    [sym_raw_string_literal] = STATE(4607),
    [aux_sym_sized_type_specifier_repeat1] = STATE(5231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2183),
    [anon_sym_COMMA] = ACTIONS(2183),
    [anon_sym_LPAREN2] = ACTIONS(2183),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2181),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6793),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(2168),
    [anon_sym___extension__] = ACTIONS(2176),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_signed] = ACTIONS(6796),
    [anon_sym_unsigned] = ACTIONS(6796),
    [anon_sym_long] = ACTIONS(6796),
    [anon_sym_short] = ACTIONS(6796),
    [anon_sym_LBRACK] = ACTIONS(2183),
    [anon_sym_EQ] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2176),
    [anon_sym_volatile] = ACTIONS(2176),
    [anon_sym_restrict] = ACTIONS(2176),
    [anon_sym___restrict__] = ACTIONS(2176),
    [anon_sym__Atomic] = ACTIONS(2176),
    [anon_sym__Noreturn] = ACTIONS(2176),
    [anon_sym_noreturn] = ACTIONS(2176),
    [anon_sym__Nonnull] = ACTIONS(2176),
    [anon_sym_mutable] = ACTIONS(2176),
    [anon_sym_constinit] = ACTIONS(2176),
    [anon_sym_consteval] = ACTIONS(2176),
    [anon_sym_alignas] = ACTIONS(2176),
    [anon_sym__Alignas] = ACTIONS(2176),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(6798),
    [anon_sym_SLASH_EQ] = ACTIONS(6798),
    [anon_sym_PERCENT_EQ] = ACTIONS(6798),
    [anon_sym_PLUS_EQ] = ACTIONS(6798),
    [anon_sym_DASH_EQ] = ACTIONS(6798),
    [anon_sym_LT_LT_EQ] = ACTIONS(6798),
    [anon_sym_GT_GT_EQ] = ACTIONS(6800),
    [anon_sym_AMP_EQ] = ACTIONS(6798),
    [anon_sym_CARET_EQ] = ACTIONS(6798),
    [anon_sym_PIPE_EQ] = ACTIONS(6798),
    [anon_sym_and_eq] = ACTIONS(6798),
    [anon_sym_or_eq] = ACTIONS(6798),
    [anon_sym_xor_eq] = ACTIONS(6798),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(6802),
    [anon_sym_u_DQUOTE] = ACTIONS(6802),
    [anon_sym_U_DQUOTE] = ACTIONS(6802),
    [anon_sym_u8_DQUOTE] = ACTIONS(6802),
    [anon_sym_DQUOTE] = ACTIONS(6802),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2176),
    [anon_sym_let] = ACTIONS(2176),
    [anon_sym_This] = ACTIONS(2176),
    [anon_sym_GT2] = ACTIONS(2183),
    [anon_sym_R_DQUOTE] = ACTIONS(6804),
    [anon_sym_LR_DQUOTE] = ACTIONS(6804),
    [anon_sym_uR_DQUOTE] = ACTIONS(6804),
    [anon_sym_UR_DQUOTE] = ACTIONS(6804),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6804),
  },
  [2699] = {
    [sym_identifier] = ACTIONS(6806),
    [anon_sym_LPAREN2] = ACTIONS(6808),
    [anon_sym_TILDE] = ACTIONS(6808),
    [anon_sym_STAR] = ACTIONS(6808),
    [anon_sym_PIPE_PIPE] = ACTIONS(6808),
    [anon_sym_AMP_AMP] = ACTIONS(6787),
    [anon_sym_AMP] = ACTIONS(6806),
    [anon_sym___extension__] = ACTIONS(6806),
    [anon_sym_in] = ACTIONS(6806),
    [anon_sym_out] = ACTIONS(6806),
    [anon_sym_inout] = ACTIONS(6806),
    [anon_sym_virtual] = ACTIONS(6806),
    [anon_sym_extern] = ACTIONS(6806),
    [anon_sym___attribute__] = ACTIONS(6806),
    [anon_sym___attribute] = ACTIONS(6806),
    [anon_sym_using] = ACTIONS(6806),
    [anon_sym_COLON_COLON] = ACTIONS(6808),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6808),
    [anon_sym___declspec] = ACTIONS(6806),
    [anon_sym___based] = ACTIONS(6806),
    [anon_sym___cdecl] = ACTIONS(6806),
    [anon_sym___clrcall] = ACTIONS(6806),
    [anon_sym___stdcall] = ACTIONS(6806),
    [anon_sym___fastcall] = ACTIONS(6806),
    [anon_sym___thiscall] = ACTIONS(6806),
    [anon_sym___vectorcall] = ACTIONS(6806),
    [anon_sym_signed] = ACTIONS(6806),
    [anon_sym_unsigned] = ACTIONS(6806),
    [anon_sym_long] = ACTIONS(6806),
    [anon_sym_short] = ACTIONS(6806),
    [anon_sym_LBRACK] = ACTIONS(6806),
    [anon_sym_static] = ACTIONS(6806),
    [anon_sym_register] = ACTIONS(6806),
    [anon_sym_inline] = ACTIONS(6806),
    [anon_sym___inline] = ACTIONS(6806),
    [anon_sym___inline__] = ACTIONS(6806),
    [anon_sym___forceinline] = ACTIONS(6806),
    [anon_sym_thread_local] = ACTIONS(6806),
    [anon_sym___thread] = ACTIONS(6806),
    [anon_sym_const] = ACTIONS(6806),
    [anon_sym_constexpr] = ACTIONS(6806),
    [anon_sym_volatile] = ACTIONS(6806),
    [anon_sym_restrict] = ACTIONS(6806),
    [anon_sym___restrict__] = ACTIONS(6806),
    [anon_sym__Atomic] = ACTIONS(6806),
    [anon_sym__Noreturn] = ACTIONS(6806),
    [anon_sym_noreturn] = ACTIONS(6806),
    [anon_sym__Nonnull] = ACTIONS(6806),
    [anon_sym_mutable] = ACTIONS(6806),
    [anon_sym_constinit] = ACTIONS(6806),
    [anon_sym_consteval] = ACTIONS(6806),
    [anon_sym_alignas] = ACTIONS(6806),
    [anon_sym__Alignas] = ACTIONS(6806),
    [sym_primitive_type] = ACTIONS(6806),
    [anon_sym_enum] = ACTIONS(6806),
    [anon_sym_class] = ACTIONS(6806),
    [anon_sym_struct] = ACTIONS(6806),
    [anon_sym_union] = ACTIONS(6806),
    [anon_sym_or] = ACTIONS(6806),
    [anon_sym_and] = ACTIONS(6791),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6806),
    [anon_sym_let] = ACTIONS(6806),
    [anon_sym_This] = ACTIONS(6806),
    [anon_sym_decltype] = ACTIONS(6806),
    [anon_sym_explicit] = ACTIONS(6806),
    [anon_sym_typename] = ACTIONS(6806),
    [anon_sym_template] = ACTIONS(6806),
    [anon_sym_operator] = ACTIONS(6806),
    [anon_sym_friend] = ACTIONS(6806),
    [anon_sym_concept] = ACTIONS(6806),
    [anon_sym_precise] = ACTIONS(6806),
    [anon_sym_shared] = ACTIONS(6806),
    [anon_sym_groupshared] = ACTIONS(6806),
    [anon_sym_uniform] = ACTIONS(6806),
    [anon_sym_row_major] = ACTIONS(6806),
    [anon_sym_column_major] = ACTIONS(6806),
    [anon_sym_globallycoherent] = ACTIONS(6806),
    [anon_sym_centroid] = ACTIONS(6806),
    [anon_sym_noperspective] = ACTIONS(6806),
    [anon_sym_nointerpolation] = ACTIONS(6806),
    [anon_sym_sample] = ACTIONS(6806),
    [anon_sym_linear] = ACTIONS(6806),
    [anon_sym_snorm] = ACTIONS(6806),
    [anon_sym_unorm] = ACTIONS(6806),
    [anon_sym_point] = ACTIONS(6806),
    [anon_sym_line] = ACTIONS(6806),
    [anon_sym_triangleadj] = ACTIONS(6806),
    [anon_sym_lineadj] = ACTIONS(6806),
    [anon_sym_triangle] = ACTIONS(6806),
    [anon_sym_interface] = ACTIONS(6806),
    [anon_sym_extension] = ACTIONS(6806),
  },
  [2700] = {
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_PIPE_PIPE] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_out] = ACTIONS(2422),
    [anon_sym_inout] = ACTIONS(2422),
    [anon_sym_virtual] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_using] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2422),
    [anon_sym___based] = ACTIONS(2422),
    [anon_sym___cdecl] = ACTIONS(2422),
    [anon_sym___clrcall] = ACTIONS(2422),
    [anon_sym___stdcall] = ACTIONS(2422),
    [anon_sym___fastcall] = ACTIONS(2422),
    [anon_sym___thiscall] = ACTIONS(2422),
    [anon_sym___vectorcall] = ACTIONS(2422),
    [anon_sym_signed] = ACTIONS(2422),
    [anon_sym_unsigned] = ACTIONS(2422),
    [anon_sym_long] = ACTIONS(2422),
    [anon_sym_short] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_register] = ACTIONS(2422),
    [anon_sym_inline] = ACTIONS(2422),
    [anon_sym___inline] = ACTIONS(2422),
    [anon_sym___inline__] = ACTIONS(2422),
    [anon_sym___forceinline] = ACTIONS(2422),
    [anon_sym_thread_local] = ACTIONS(2422),
    [anon_sym___thread] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [sym_primitive_type] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
    [anon_sym_class] = ACTIONS(2422),
    [anon_sym_struct] = ACTIONS(2422),
    [anon_sym_union] = ACTIONS(2422),
    [anon_sym_or] = ACTIONS(2422),
    [anon_sym_and] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_decltype] = ACTIONS(2422),
    [anon_sym_explicit] = ACTIONS(2422),
    [anon_sym_typename] = ACTIONS(2422),
    [anon_sym_template] = ACTIONS(2422),
    [anon_sym_operator] = ACTIONS(2422),
    [anon_sym_friend] = ACTIONS(2422),
    [anon_sym_concept] = ACTIONS(2422),
    [anon_sym_precise] = ACTIONS(2422),
    [anon_sym_shared] = ACTIONS(2422),
    [anon_sym_groupshared] = ACTIONS(2422),
    [anon_sym_uniform] = ACTIONS(2422),
    [anon_sym_row_major] = ACTIONS(2422),
    [anon_sym_column_major] = ACTIONS(2422),
    [anon_sym_globallycoherent] = ACTIONS(2422),
    [anon_sym_centroid] = ACTIONS(2422),
    [anon_sym_noperspective] = ACTIONS(2422),
    [anon_sym_nointerpolation] = ACTIONS(2422),
    [anon_sym_sample] = ACTIONS(2422),
    [anon_sym_linear] = ACTIONS(2422),
    [anon_sym_snorm] = ACTIONS(2422),
    [anon_sym_unorm] = ACTIONS(2422),
    [anon_sym_point] = ACTIONS(2422),
    [anon_sym_line] = ACTIONS(2422),
    [anon_sym_triangleadj] = ACTIONS(2422),
    [anon_sym_lineadj] = ACTIONS(2422),
    [anon_sym_triangle] = ACTIONS(2422),
    [anon_sym_interface] = ACTIONS(2422),
    [anon_sym_extension] = ACTIONS(2422),
  },
  [2701] = {
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_PIPE_PIPE] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_out] = ACTIONS(2422),
    [anon_sym_inout] = ACTIONS(2422),
    [anon_sym_virtual] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_using] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2422),
    [anon_sym___based] = ACTIONS(2422),
    [anon_sym___cdecl] = ACTIONS(2422),
    [anon_sym___clrcall] = ACTIONS(2422),
    [anon_sym___stdcall] = ACTIONS(2422),
    [anon_sym___fastcall] = ACTIONS(2422),
    [anon_sym___thiscall] = ACTIONS(2422),
    [anon_sym___vectorcall] = ACTIONS(2422),
    [anon_sym_signed] = ACTIONS(2422),
    [anon_sym_unsigned] = ACTIONS(2422),
    [anon_sym_long] = ACTIONS(2422),
    [anon_sym_short] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_register] = ACTIONS(2422),
    [anon_sym_inline] = ACTIONS(2422),
    [anon_sym___inline] = ACTIONS(2422),
    [anon_sym___inline__] = ACTIONS(2422),
    [anon_sym___forceinline] = ACTIONS(2422),
    [anon_sym_thread_local] = ACTIONS(2422),
    [anon_sym___thread] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [sym_primitive_type] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
    [anon_sym_class] = ACTIONS(2422),
    [anon_sym_struct] = ACTIONS(2422),
    [anon_sym_union] = ACTIONS(2422),
    [anon_sym_or] = ACTIONS(2422),
    [anon_sym_and] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_decltype] = ACTIONS(2422),
    [anon_sym_explicit] = ACTIONS(2422),
    [anon_sym_typename] = ACTIONS(2422),
    [anon_sym_template] = ACTIONS(2422),
    [anon_sym_operator] = ACTIONS(2422),
    [anon_sym_friend] = ACTIONS(2422),
    [anon_sym_concept] = ACTIONS(2422),
    [anon_sym_precise] = ACTIONS(2422),
    [anon_sym_shared] = ACTIONS(2422),
    [anon_sym_groupshared] = ACTIONS(2422),
    [anon_sym_uniform] = ACTIONS(2422),
    [anon_sym_row_major] = ACTIONS(2422),
    [anon_sym_column_major] = ACTIONS(2422),
    [anon_sym_globallycoherent] = ACTIONS(2422),
    [anon_sym_centroid] = ACTIONS(2422),
    [anon_sym_noperspective] = ACTIONS(2422),
    [anon_sym_nointerpolation] = ACTIONS(2422),
    [anon_sym_sample] = ACTIONS(2422),
    [anon_sym_linear] = ACTIONS(2422),
    [anon_sym_snorm] = ACTIONS(2422),
    [anon_sym_unorm] = ACTIONS(2422),
    [anon_sym_point] = ACTIONS(2422),
    [anon_sym_line] = ACTIONS(2422),
    [anon_sym_triangleadj] = ACTIONS(2422),
    [anon_sym_lineadj] = ACTIONS(2422),
    [anon_sym_triangle] = ACTIONS(2422),
    [anon_sym_interface] = ACTIONS(2422),
    [anon_sym_extension] = ACTIONS(2422),
  },
  [2702] = {
    [sym_identifier] = ACTIONS(2268),
    [anon_sym_LPAREN2] = ACTIONS(2270),
    [anon_sym_TILDE] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(2270),
    [anon_sym_PIPE_PIPE] = ACTIONS(2270),
    [anon_sym_AMP_AMP] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(2268),
    [anon_sym___extension__] = ACTIONS(2268),
    [anon_sym_in] = ACTIONS(2268),
    [anon_sym_out] = ACTIONS(2268),
    [anon_sym_inout] = ACTIONS(2268),
    [anon_sym_virtual] = ACTIONS(2268),
    [anon_sym_extern] = ACTIONS(2268),
    [anon_sym___attribute__] = ACTIONS(2268),
    [anon_sym___attribute] = ACTIONS(2268),
    [anon_sym_using] = ACTIONS(2268),
    [anon_sym_COLON_COLON] = ACTIONS(2270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2270),
    [anon_sym___declspec] = ACTIONS(2268),
    [anon_sym___based] = ACTIONS(2268),
    [anon_sym___cdecl] = ACTIONS(2268),
    [anon_sym___clrcall] = ACTIONS(2268),
    [anon_sym___stdcall] = ACTIONS(2268),
    [anon_sym___fastcall] = ACTIONS(2268),
    [anon_sym___thiscall] = ACTIONS(2268),
    [anon_sym___vectorcall] = ACTIONS(2268),
    [anon_sym_signed] = ACTIONS(2268),
    [anon_sym_unsigned] = ACTIONS(2268),
    [anon_sym_long] = ACTIONS(2268),
    [anon_sym_short] = ACTIONS(2268),
    [anon_sym_LBRACK] = ACTIONS(2268),
    [anon_sym_static] = ACTIONS(2268),
    [anon_sym_register] = ACTIONS(2268),
    [anon_sym_inline] = ACTIONS(2268),
    [anon_sym___inline] = ACTIONS(2268),
    [anon_sym___inline__] = ACTIONS(2268),
    [anon_sym___forceinline] = ACTIONS(2268),
    [anon_sym_thread_local] = ACTIONS(2268),
    [anon_sym___thread] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_constexpr] = ACTIONS(2268),
    [anon_sym_volatile] = ACTIONS(2268),
    [anon_sym_restrict] = ACTIONS(2268),
    [anon_sym___restrict__] = ACTIONS(2268),
    [anon_sym__Atomic] = ACTIONS(2268),
    [anon_sym__Noreturn] = ACTIONS(2268),
    [anon_sym_noreturn] = ACTIONS(2268),
    [anon_sym__Nonnull] = ACTIONS(2268),
    [anon_sym_mutable] = ACTIONS(2268),
    [anon_sym_constinit] = ACTIONS(2268),
    [anon_sym_consteval] = ACTIONS(2268),
    [anon_sym_alignas] = ACTIONS(2268),
    [anon_sym__Alignas] = ACTIONS(2268),
    [sym_primitive_type] = ACTIONS(2268),
    [anon_sym_enum] = ACTIONS(2268),
    [anon_sym_class] = ACTIONS(2268),
    [anon_sym_struct] = ACTIONS(2268),
    [anon_sym_union] = ACTIONS(2268),
    [anon_sym_or] = ACTIONS(2268),
    [anon_sym_and] = ACTIONS(2268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_This] = ACTIONS(2268),
    [anon_sym_decltype] = ACTIONS(2268),
    [anon_sym_explicit] = ACTIONS(2268),
    [anon_sym_typename] = ACTIONS(2268),
    [anon_sym_template] = ACTIONS(2268),
    [anon_sym_operator] = ACTIONS(2268),
    [anon_sym_friend] = ACTIONS(2268),
    [anon_sym_concept] = ACTIONS(2268),
    [anon_sym_precise] = ACTIONS(2268),
    [anon_sym_shared] = ACTIONS(2268),
    [anon_sym_groupshared] = ACTIONS(2268),
    [anon_sym_uniform] = ACTIONS(2268),
    [anon_sym_row_major] = ACTIONS(2268),
    [anon_sym_column_major] = ACTIONS(2268),
    [anon_sym_globallycoherent] = ACTIONS(2268),
    [anon_sym_centroid] = ACTIONS(2268),
    [anon_sym_noperspective] = ACTIONS(2268),
    [anon_sym_nointerpolation] = ACTIONS(2268),
    [anon_sym_sample] = ACTIONS(2268),
    [anon_sym_linear] = ACTIONS(2268),
    [anon_sym_snorm] = ACTIONS(2268),
    [anon_sym_unorm] = ACTIONS(2268),
    [anon_sym_point] = ACTIONS(2268),
    [anon_sym_line] = ACTIONS(2268),
    [anon_sym_triangleadj] = ACTIONS(2268),
    [anon_sym_lineadj] = ACTIONS(2268),
    [anon_sym_triangle] = ACTIONS(2268),
    [anon_sym_interface] = ACTIONS(2268),
    [anon_sym_extension] = ACTIONS(2268),
  },
  [2703] = {
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_LPAREN2] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [anon_sym_STAR] = ACTIONS(2274),
    [anon_sym_PIPE_PIPE] = ACTIONS(2274),
    [anon_sym_AMP_AMP] = ACTIONS(2274),
    [anon_sym_AMP] = ACTIONS(2272),
    [anon_sym___extension__] = ACTIONS(2272),
    [anon_sym_in] = ACTIONS(2272),
    [anon_sym_out] = ACTIONS(2272),
    [anon_sym_inout] = ACTIONS(2272),
    [anon_sym_virtual] = ACTIONS(2272),
    [anon_sym_extern] = ACTIONS(2272),
    [anon_sym___attribute__] = ACTIONS(2272),
    [anon_sym___attribute] = ACTIONS(2272),
    [anon_sym_using] = ACTIONS(2272),
    [anon_sym_COLON_COLON] = ACTIONS(2274),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2274),
    [anon_sym___declspec] = ACTIONS(2272),
    [anon_sym___based] = ACTIONS(2272),
    [anon_sym___cdecl] = ACTIONS(2272),
    [anon_sym___clrcall] = ACTIONS(2272),
    [anon_sym___stdcall] = ACTIONS(2272),
    [anon_sym___fastcall] = ACTIONS(2272),
    [anon_sym___thiscall] = ACTIONS(2272),
    [anon_sym___vectorcall] = ACTIONS(2272),
    [anon_sym_signed] = ACTIONS(2272),
    [anon_sym_unsigned] = ACTIONS(2272),
    [anon_sym_long] = ACTIONS(2272),
    [anon_sym_short] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_register] = ACTIONS(2272),
    [anon_sym_inline] = ACTIONS(2272),
    [anon_sym___inline] = ACTIONS(2272),
    [anon_sym___inline__] = ACTIONS(2272),
    [anon_sym___forceinline] = ACTIONS(2272),
    [anon_sym_thread_local] = ACTIONS(2272),
    [anon_sym___thread] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_constexpr] = ACTIONS(2272),
    [anon_sym_volatile] = ACTIONS(2272),
    [anon_sym_restrict] = ACTIONS(2272),
    [anon_sym___restrict__] = ACTIONS(2272),
    [anon_sym__Atomic] = ACTIONS(2272),
    [anon_sym__Noreturn] = ACTIONS(2272),
    [anon_sym_noreturn] = ACTIONS(2272),
    [anon_sym__Nonnull] = ACTIONS(2272),
    [anon_sym_mutable] = ACTIONS(2272),
    [anon_sym_constinit] = ACTIONS(2272),
    [anon_sym_consteval] = ACTIONS(2272),
    [anon_sym_alignas] = ACTIONS(2272),
    [anon_sym__Alignas] = ACTIONS(2272),
    [sym_primitive_type] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_struct] = ACTIONS(2272),
    [anon_sym_union] = ACTIONS(2272),
    [anon_sym_or] = ACTIONS(2272),
    [anon_sym_and] = ACTIONS(2272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_This] = ACTIONS(2272),
    [anon_sym_decltype] = ACTIONS(2272),
    [anon_sym_explicit] = ACTIONS(2272),
    [anon_sym_typename] = ACTIONS(2272),
    [anon_sym_template] = ACTIONS(2272),
    [anon_sym_operator] = ACTIONS(2272),
    [anon_sym_friend] = ACTIONS(2272),
    [anon_sym_concept] = ACTIONS(2272),
    [anon_sym_precise] = ACTIONS(2272),
    [anon_sym_shared] = ACTIONS(2272),
    [anon_sym_groupshared] = ACTIONS(2272),
    [anon_sym_uniform] = ACTIONS(2272),
    [anon_sym_row_major] = ACTIONS(2272),
    [anon_sym_column_major] = ACTIONS(2272),
    [anon_sym_globallycoherent] = ACTIONS(2272),
    [anon_sym_centroid] = ACTIONS(2272),
    [anon_sym_noperspective] = ACTIONS(2272),
    [anon_sym_nointerpolation] = ACTIONS(2272),
    [anon_sym_sample] = ACTIONS(2272),
    [anon_sym_linear] = ACTIONS(2272),
    [anon_sym_snorm] = ACTIONS(2272),
    [anon_sym_unorm] = ACTIONS(2272),
    [anon_sym_point] = ACTIONS(2272),
    [anon_sym_line] = ACTIONS(2272),
    [anon_sym_triangleadj] = ACTIONS(2272),
    [anon_sym_lineadj] = ACTIONS(2272),
    [anon_sym_triangle] = ACTIONS(2272),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_extension] = ACTIONS(2272),
  },
  [2704] = {
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2314),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_PIPE_PIPE] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym___extension__] = ACTIONS(2312),
    [anon_sym_in] = ACTIONS(2312),
    [anon_sym_out] = ACTIONS(2312),
    [anon_sym_inout] = ACTIONS(2312),
    [anon_sym_virtual] = ACTIONS(2312),
    [anon_sym_extern] = ACTIONS(2312),
    [anon_sym___attribute__] = ACTIONS(2312),
    [anon_sym___attribute] = ACTIONS(2312),
    [anon_sym_using] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2314),
    [anon_sym___declspec] = ACTIONS(2312),
    [anon_sym___based] = ACTIONS(2312),
    [anon_sym___cdecl] = ACTIONS(2312),
    [anon_sym___clrcall] = ACTIONS(2312),
    [anon_sym___stdcall] = ACTIONS(2312),
    [anon_sym___fastcall] = ACTIONS(2312),
    [anon_sym___thiscall] = ACTIONS(2312),
    [anon_sym___vectorcall] = ACTIONS(2312),
    [anon_sym_signed] = ACTIONS(2312),
    [anon_sym_unsigned] = ACTIONS(2312),
    [anon_sym_long] = ACTIONS(2312),
    [anon_sym_short] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_register] = ACTIONS(2312),
    [anon_sym_inline] = ACTIONS(2312),
    [anon_sym___inline] = ACTIONS(2312),
    [anon_sym___inline__] = ACTIONS(2312),
    [anon_sym___forceinline] = ACTIONS(2312),
    [anon_sym_thread_local] = ACTIONS(2312),
    [anon_sym___thread] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_constexpr] = ACTIONS(2312),
    [anon_sym_volatile] = ACTIONS(2312),
    [anon_sym_restrict] = ACTIONS(2312),
    [anon_sym___restrict__] = ACTIONS(2312),
    [anon_sym__Atomic] = ACTIONS(2312),
    [anon_sym__Noreturn] = ACTIONS(2312),
    [anon_sym_noreturn] = ACTIONS(2312),
    [anon_sym__Nonnull] = ACTIONS(2312),
    [anon_sym_mutable] = ACTIONS(2312),
    [anon_sym_constinit] = ACTIONS(2312),
    [anon_sym_consteval] = ACTIONS(2312),
    [anon_sym_alignas] = ACTIONS(2312),
    [anon_sym__Alignas] = ACTIONS(2312),
    [sym_primitive_type] = ACTIONS(2312),
    [anon_sym_enum] = ACTIONS(2312),
    [anon_sym_class] = ACTIONS(2312),
    [anon_sym_struct] = ACTIONS(2312),
    [anon_sym_union] = ACTIONS(2312),
    [anon_sym_or] = ACTIONS(2312),
    [anon_sym_and] = ACTIONS(2312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_This] = ACTIONS(2312),
    [anon_sym_decltype] = ACTIONS(2312),
    [anon_sym_explicit] = ACTIONS(2312),
    [anon_sym_typename] = ACTIONS(2312),
    [anon_sym_template] = ACTIONS(2312),
    [anon_sym_operator] = ACTIONS(2312),
    [anon_sym_friend] = ACTIONS(2312),
    [anon_sym_concept] = ACTIONS(2312),
    [anon_sym_precise] = ACTIONS(2312),
    [anon_sym_shared] = ACTIONS(2312),
    [anon_sym_groupshared] = ACTIONS(2312),
    [anon_sym_uniform] = ACTIONS(2312),
    [anon_sym_row_major] = ACTIONS(2312),
    [anon_sym_column_major] = ACTIONS(2312),
    [anon_sym_globallycoherent] = ACTIONS(2312),
    [anon_sym_centroid] = ACTIONS(2312),
    [anon_sym_noperspective] = ACTIONS(2312),
    [anon_sym_nointerpolation] = ACTIONS(2312),
    [anon_sym_sample] = ACTIONS(2312),
    [anon_sym_linear] = ACTIONS(2312),
    [anon_sym_snorm] = ACTIONS(2312),
    [anon_sym_unorm] = ACTIONS(2312),
    [anon_sym_point] = ACTIONS(2312),
    [anon_sym_line] = ACTIONS(2312),
    [anon_sym_triangleadj] = ACTIONS(2312),
    [anon_sym_lineadj] = ACTIONS(2312),
    [anon_sym_triangle] = ACTIONS(2312),
    [anon_sym_interface] = ACTIONS(2312),
    [anon_sym_extension] = ACTIONS(2312),
  },
  [2705] = {
    [sym_identifier] = ACTIONS(2239),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym_in] = ACTIONS(2239),
    [anon_sym_out] = ACTIONS(2239),
    [anon_sym_inout] = ACTIONS(2239),
    [anon_sym_virtual] = ACTIONS(2239),
    [anon_sym_extern] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym___attribute] = ACTIONS(2239),
    [anon_sym_using] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2241),
    [anon_sym___declspec] = ACTIONS(2239),
    [anon_sym___based] = ACTIONS(2239),
    [anon_sym___cdecl] = ACTIONS(2239),
    [anon_sym___clrcall] = ACTIONS(2239),
    [anon_sym___stdcall] = ACTIONS(2239),
    [anon_sym___fastcall] = ACTIONS(2239),
    [anon_sym___thiscall] = ACTIONS(2239),
    [anon_sym___vectorcall] = ACTIONS(2239),
    [anon_sym_signed] = ACTIONS(2239),
    [anon_sym_unsigned] = ACTIONS(2239),
    [anon_sym_long] = ACTIONS(2239),
    [anon_sym_short] = ACTIONS(2239),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2239),
    [anon_sym_register] = ACTIONS(2239),
    [anon_sym_inline] = ACTIONS(2239),
    [anon_sym___inline] = ACTIONS(2239),
    [anon_sym___inline__] = ACTIONS(2239),
    [anon_sym___forceinline] = ACTIONS(2239),
    [anon_sym_thread_local] = ACTIONS(2239),
    [anon_sym___thread] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym__Nonnull] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [sym_primitive_type] = ACTIONS(2239),
    [anon_sym_enum] = ACTIONS(2239),
    [anon_sym_class] = ACTIONS(2239),
    [anon_sym_struct] = ACTIONS(2239),
    [anon_sym_union] = ACTIONS(2239),
    [anon_sym_or] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2239),
    [anon_sym_let] = ACTIONS(2239),
    [anon_sym_This] = ACTIONS(2239),
    [anon_sym_decltype] = ACTIONS(2239),
    [anon_sym_explicit] = ACTIONS(2239),
    [anon_sym_typename] = ACTIONS(2239),
    [anon_sym_template] = ACTIONS(2239),
    [anon_sym_operator] = ACTIONS(2239),
    [anon_sym_friend] = ACTIONS(2239),
    [anon_sym_concept] = ACTIONS(2239),
    [anon_sym_precise] = ACTIONS(2239),
    [anon_sym_shared] = ACTIONS(2239),
    [anon_sym_groupshared] = ACTIONS(2239),
    [anon_sym_uniform] = ACTIONS(2239),
    [anon_sym_row_major] = ACTIONS(2239),
    [anon_sym_column_major] = ACTIONS(2239),
    [anon_sym_globallycoherent] = ACTIONS(2239),
    [anon_sym_centroid] = ACTIONS(2239),
    [anon_sym_noperspective] = ACTIONS(2239),
    [anon_sym_nointerpolation] = ACTIONS(2239),
    [anon_sym_sample] = ACTIONS(2239),
    [anon_sym_linear] = ACTIONS(2239),
    [anon_sym_snorm] = ACTIONS(2239),
    [anon_sym_unorm] = ACTIONS(2239),
    [anon_sym_point] = ACTIONS(2239),
    [anon_sym_line] = ACTIONS(2239),
    [anon_sym_triangleadj] = ACTIONS(2239),
    [anon_sym_lineadj] = ACTIONS(2239),
    [anon_sym_triangle] = ACTIONS(2239),
    [anon_sym_interface] = ACTIONS(2239),
    [anon_sym_extension] = ACTIONS(2239),
  },
  [2706] = {
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_LPAREN2] = ACTIONS(2282),
    [anon_sym_TILDE] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(2282),
    [anon_sym_PIPE_PIPE] = ACTIONS(2282),
    [anon_sym_AMP_AMP] = ACTIONS(2282),
    [anon_sym_AMP] = ACTIONS(2280),
    [anon_sym___extension__] = ACTIONS(2280),
    [anon_sym_in] = ACTIONS(2280),
    [anon_sym_out] = ACTIONS(2280),
    [anon_sym_inout] = ACTIONS(2280),
    [anon_sym_virtual] = ACTIONS(2280),
    [anon_sym_extern] = ACTIONS(2280),
    [anon_sym___attribute__] = ACTIONS(2280),
    [anon_sym___attribute] = ACTIONS(2280),
    [anon_sym_using] = ACTIONS(2280),
    [anon_sym_COLON_COLON] = ACTIONS(2282),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2282),
    [anon_sym___declspec] = ACTIONS(2280),
    [anon_sym___based] = ACTIONS(2280),
    [anon_sym___cdecl] = ACTIONS(2280),
    [anon_sym___clrcall] = ACTIONS(2280),
    [anon_sym___stdcall] = ACTIONS(2280),
    [anon_sym___fastcall] = ACTIONS(2280),
    [anon_sym___thiscall] = ACTIONS(2280),
    [anon_sym___vectorcall] = ACTIONS(2280),
    [anon_sym_signed] = ACTIONS(2280),
    [anon_sym_unsigned] = ACTIONS(2280),
    [anon_sym_long] = ACTIONS(2280),
    [anon_sym_short] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_register] = ACTIONS(2280),
    [anon_sym_inline] = ACTIONS(2280),
    [anon_sym___inline] = ACTIONS(2280),
    [anon_sym___inline__] = ACTIONS(2280),
    [anon_sym___forceinline] = ACTIONS(2280),
    [anon_sym_thread_local] = ACTIONS(2280),
    [anon_sym___thread] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_constexpr] = ACTIONS(2280),
    [anon_sym_volatile] = ACTIONS(2280),
    [anon_sym_restrict] = ACTIONS(2280),
    [anon_sym___restrict__] = ACTIONS(2280),
    [anon_sym__Atomic] = ACTIONS(2280),
    [anon_sym__Noreturn] = ACTIONS(2280),
    [anon_sym_noreturn] = ACTIONS(2280),
    [anon_sym__Nonnull] = ACTIONS(2280),
    [anon_sym_mutable] = ACTIONS(2280),
    [anon_sym_constinit] = ACTIONS(2280),
    [anon_sym_consteval] = ACTIONS(2280),
    [anon_sym_alignas] = ACTIONS(2280),
    [anon_sym__Alignas] = ACTIONS(2280),
    [sym_primitive_type] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_struct] = ACTIONS(2280),
    [anon_sym_union] = ACTIONS(2280),
    [anon_sym_or] = ACTIONS(2280),
    [anon_sym_and] = ACTIONS(2280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_This] = ACTIONS(2280),
    [anon_sym_decltype] = ACTIONS(2280),
    [anon_sym_explicit] = ACTIONS(2280),
    [anon_sym_typename] = ACTIONS(2280),
    [anon_sym_template] = ACTIONS(2280),
    [anon_sym_operator] = ACTIONS(2280),
    [anon_sym_friend] = ACTIONS(2280),
    [anon_sym_concept] = ACTIONS(2280),
    [anon_sym_precise] = ACTIONS(2280),
    [anon_sym_shared] = ACTIONS(2280),
    [anon_sym_groupshared] = ACTIONS(2280),
    [anon_sym_uniform] = ACTIONS(2280),
    [anon_sym_row_major] = ACTIONS(2280),
    [anon_sym_column_major] = ACTIONS(2280),
    [anon_sym_globallycoherent] = ACTIONS(2280),
    [anon_sym_centroid] = ACTIONS(2280),
    [anon_sym_noperspective] = ACTIONS(2280),
    [anon_sym_nointerpolation] = ACTIONS(2280),
    [anon_sym_sample] = ACTIONS(2280),
    [anon_sym_linear] = ACTIONS(2280),
    [anon_sym_snorm] = ACTIONS(2280),
    [anon_sym_unorm] = ACTIONS(2280),
    [anon_sym_point] = ACTIONS(2280),
    [anon_sym_line] = ACTIONS(2280),
    [anon_sym_triangleadj] = ACTIONS(2280),
    [anon_sym_lineadj] = ACTIONS(2280),
    [anon_sym_triangle] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_extension] = ACTIONS(2280),
  },
  [2707] = {
    [sym_identifier] = ACTIONS(2284),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_PIPE_PIPE] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_in] = ACTIONS(2284),
    [anon_sym_out] = ACTIONS(2284),
    [anon_sym_inout] = ACTIONS(2284),
    [anon_sym_virtual] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_using] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym___cdecl] = ACTIONS(2284),
    [anon_sym___clrcall] = ACTIONS(2284),
    [anon_sym___stdcall] = ACTIONS(2284),
    [anon_sym___fastcall] = ACTIONS(2284),
    [anon_sym___thiscall] = ACTIONS(2284),
    [anon_sym___vectorcall] = ACTIONS(2284),
    [anon_sym_signed] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [anon_sym_or] = ACTIONS(2284),
    [anon_sym_and] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_This] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_typename] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_friend] = ACTIONS(2284),
    [anon_sym_concept] = ACTIONS(2284),
    [anon_sym_precise] = ACTIONS(2284),
    [anon_sym_shared] = ACTIONS(2284),
    [anon_sym_groupshared] = ACTIONS(2284),
    [anon_sym_uniform] = ACTIONS(2284),
    [anon_sym_row_major] = ACTIONS(2284),
    [anon_sym_column_major] = ACTIONS(2284),
    [anon_sym_globallycoherent] = ACTIONS(2284),
    [anon_sym_centroid] = ACTIONS(2284),
    [anon_sym_noperspective] = ACTIONS(2284),
    [anon_sym_nointerpolation] = ACTIONS(2284),
    [anon_sym_sample] = ACTIONS(2284),
    [anon_sym_linear] = ACTIONS(2284),
    [anon_sym_snorm] = ACTIONS(2284),
    [anon_sym_unorm] = ACTIONS(2284),
    [anon_sym_point] = ACTIONS(2284),
    [anon_sym_line] = ACTIONS(2284),
    [anon_sym_triangleadj] = ACTIONS(2284),
    [anon_sym_lineadj] = ACTIONS(2284),
    [anon_sym_triangle] = ACTIONS(2284),
    [anon_sym_interface] = ACTIONS(2284),
    [anon_sym_extension] = ACTIONS(2284),
  },
  [2708] = {
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_out] = ACTIONS(2288),
    [anon_sym_inout] = ACTIONS(2288),
    [anon_sym_virtual] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym___cdecl] = ACTIONS(2288),
    [anon_sym___clrcall] = ACTIONS(2288),
    [anon_sym___stdcall] = ACTIONS(2288),
    [anon_sym___fastcall] = ACTIONS(2288),
    [anon_sym___thiscall] = ACTIONS(2288),
    [anon_sym___vectorcall] = ACTIONS(2288),
    [anon_sym_signed] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_or] = ACTIONS(2288),
    [anon_sym_and] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_This] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_friend] = ACTIONS(2288),
    [anon_sym_concept] = ACTIONS(2288),
    [anon_sym_precise] = ACTIONS(2288),
    [anon_sym_shared] = ACTIONS(2288),
    [anon_sym_groupshared] = ACTIONS(2288),
    [anon_sym_uniform] = ACTIONS(2288),
    [anon_sym_row_major] = ACTIONS(2288),
    [anon_sym_column_major] = ACTIONS(2288),
    [anon_sym_globallycoherent] = ACTIONS(2288),
    [anon_sym_centroid] = ACTIONS(2288),
    [anon_sym_noperspective] = ACTIONS(2288),
    [anon_sym_nointerpolation] = ACTIONS(2288),
    [anon_sym_sample] = ACTIONS(2288),
    [anon_sym_linear] = ACTIONS(2288),
    [anon_sym_snorm] = ACTIONS(2288),
    [anon_sym_unorm] = ACTIONS(2288),
    [anon_sym_point] = ACTIONS(2288),
    [anon_sym_line] = ACTIONS(2288),
    [anon_sym_triangleadj] = ACTIONS(2288),
    [anon_sym_lineadj] = ACTIONS(2288),
    [anon_sym_triangle] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_extension] = ACTIONS(2288),
  },
  [2709] = {
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_PIPE_PIPE] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym_in] = ACTIONS(2292),
    [anon_sym_out] = ACTIONS(2292),
    [anon_sym_inout] = ACTIONS(2292),
    [anon_sym_virtual] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym___attribute] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2294),
    [anon_sym___declspec] = ACTIONS(2292),
    [anon_sym___based] = ACTIONS(2292),
    [anon_sym___cdecl] = ACTIONS(2292),
    [anon_sym___clrcall] = ACTIONS(2292),
    [anon_sym___stdcall] = ACTIONS(2292),
    [anon_sym___fastcall] = ACTIONS(2292),
    [anon_sym___thiscall] = ACTIONS(2292),
    [anon_sym___vectorcall] = ACTIONS(2292),
    [anon_sym_signed] = ACTIONS(2292),
    [anon_sym_unsigned] = ACTIONS(2292),
    [anon_sym_long] = ACTIONS(2292),
    [anon_sym_short] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym___inline] = ACTIONS(2292),
    [anon_sym___inline__] = ACTIONS(2292),
    [anon_sym___forceinline] = ACTIONS(2292),
    [anon_sym_thread_local] = ACTIONS(2292),
    [anon_sym___thread] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym__Nonnull] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [sym_primitive_type] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_struct] = ACTIONS(2292),
    [anon_sym_union] = ACTIONS(2292),
    [anon_sym_or] = ACTIONS(2292),
    [anon_sym_and] = ACTIONS(2292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_This] = ACTIONS(2292),
    [anon_sym_decltype] = ACTIONS(2292),
    [anon_sym_explicit] = ACTIONS(2292),
    [anon_sym_typename] = ACTIONS(2292),
    [anon_sym_template] = ACTIONS(2292),
    [anon_sym_operator] = ACTIONS(2292),
    [anon_sym_friend] = ACTIONS(2292),
    [anon_sym_concept] = ACTIONS(2292),
    [anon_sym_precise] = ACTIONS(2292),
    [anon_sym_shared] = ACTIONS(2292),
    [anon_sym_groupshared] = ACTIONS(2292),
    [anon_sym_uniform] = ACTIONS(2292),
    [anon_sym_row_major] = ACTIONS(2292),
    [anon_sym_column_major] = ACTIONS(2292),
    [anon_sym_globallycoherent] = ACTIONS(2292),
    [anon_sym_centroid] = ACTIONS(2292),
    [anon_sym_noperspective] = ACTIONS(2292),
    [anon_sym_nointerpolation] = ACTIONS(2292),
    [anon_sym_sample] = ACTIONS(2292),
    [anon_sym_linear] = ACTIONS(2292),
    [anon_sym_snorm] = ACTIONS(2292),
    [anon_sym_unorm] = ACTIONS(2292),
    [anon_sym_point] = ACTIONS(2292),
    [anon_sym_line] = ACTIONS(2292),
    [anon_sym_triangleadj] = ACTIONS(2292),
    [anon_sym_lineadj] = ACTIONS(2292),
    [anon_sym_triangle] = ACTIONS(2292),
    [anon_sym_interface] = ACTIONS(2292),
    [anon_sym_extension] = ACTIONS(2292),
  },
  [2710] = {
    [sym_identifier] = ACTIONS(2296),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_STAR] = ACTIONS(2298),
    [anon_sym_PIPE_PIPE] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym_in] = ACTIONS(2296),
    [anon_sym_out] = ACTIONS(2296),
    [anon_sym_inout] = ACTIONS(2296),
    [anon_sym_virtual] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym___attribute] = ACTIONS(2296),
    [anon_sym_using] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2298),
    [anon_sym___declspec] = ACTIONS(2296),
    [anon_sym___based] = ACTIONS(2296),
    [anon_sym___cdecl] = ACTIONS(2296),
    [anon_sym___clrcall] = ACTIONS(2296),
    [anon_sym___stdcall] = ACTIONS(2296),
    [anon_sym___fastcall] = ACTIONS(2296),
    [anon_sym___thiscall] = ACTIONS(2296),
    [anon_sym___vectorcall] = ACTIONS(2296),
    [anon_sym_signed] = ACTIONS(2296),
    [anon_sym_unsigned] = ACTIONS(2296),
    [anon_sym_long] = ACTIONS(2296),
    [anon_sym_short] = ACTIONS(2296),
    [anon_sym_LBRACK] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_register] = ACTIONS(2296),
    [anon_sym_inline] = ACTIONS(2296),
    [anon_sym___inline] = ACTIONS(2296),
    [anon_sym___inline__] = ACTIONS(2296),
    [anon_sym___forceinline] = ACTIONS(2296),
    [anon_sym_thread_local] = ACTIONS(2296),
    [anon_sym___thread] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym__Nonnull] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [sym_primitive_type] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2296),
    [anon_sym_class] = ACTIONS(2296),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_union] = ACTIONS(2296),
    [anon_sym_or] = ACTIONS(2296),
    [anon_sym_and] = ACTIONS(2296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_This] = ACTIONS(2296),
    [anon_sym_decltype] = ACTIONS(2296),
    [anon_sym_explicit] = ACTIONS(2296),
    [anon_sym_typename] = ACTIONS(2296),
    [anon_sym_template] = ACTIONS(2296),
    [anon_sym_operator] = ACTIONS(2296),
    [anon_sym_friend] = ACTIONS(2296),
    [anon_sym_concept] = ACTIONS(2296),
    [anon_sym_precise] = ACTIONS(2296),
    [anon_sym_shared] = ACTIONS(2296),
    [anon_sym_groupshared] = ACTIONS(2296),
    [anon_sym_uniform] = ACTIONS(2296),
    [anon_sym_row_major] = ACTIONS(2296),
    [anon_sym_column_major] = ACTIONS(2296),
    [anon_sym_globallycoherent] = ACTIONS(2296),
    [anon_sym_centroid] = ACTIONS(2296),
    [anon_sym_noperspective] = ACTIONS(2296),
    [anon_sym_nointerpolation] = ACTIONS(2296),
    [anon_sym_sample] = ACTIONS(2296),
    [anon_sym_linear] = ACTIONS(2296),
    [anon_sym_snorm] = ACTIONS(2296),
    [anon_sym_unorm] = ACTIONS(2296),
    [anon_sym_point] = ACTIONS(2296),
    [anon_sym_line] = ACTIONS(2296),
    [anon_sym_triangleadj] = ACTIONS(2296),
    [anon_sym_lineadj] = ACTIONS(2296),
    [anon_sym_triangle] = ACTIONS(2296),
    [anon_sym_interface] = ACTIONS(2296),
    [anon_sym_extension] = ACTIONS(2296),
  },
  [2711] = {
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_LPAREN2] = ACTIONS(2266),
    [anon_sym_TILDE] = ACTIONS(2266),
    [anon_sym_STAR] = ACTIONS(2266),
    [anon_sym_PIPE_PIPE] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2266),
    [anon_sym_AMP] = ACTIONS(2264),
    [anon_sym___extension__] = ACTIONS(2264),
    [anon_sym_in] = ACTIONS(2264),
    [anon_sym_out] = ACTIONS(2264),
    [anon_sym_inout] = ACTIONS(2264),
    [anon_sym_virtual] = ACTIONS(2264),
    [anon_sym_extern] = ACTIONS(2264),
    [anon_sym___attribute__] = ACTIONS(2264),
    [anon_sym___attribute] = ACTIONS(2264),
    [anon_sym_using] = ACTIONS(2264),
    [anon_sym_COLON_COLON] = ACTIONS(2266),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2266),
    [anon_sym___declspec] = ACTIONS(2264),
    [anon_sym___based] = ACTIONS(2264),
    [anon_sym___cdecl] = ACTIONS(2264),
    [anon_sym___clrcall] = ACTIONS(2264),
    [anon_sym___stdcall] = ACTIONS(2264),
    [anon_sym___fastcall] = ACTIONS(2264),
    [anon_sym___thiscall] = ACTIONS(2264),
    [anon_sym___vectorcall] = ACTIONS(2264),
    [anon_sym_signed] = ACTIONS(2264),
    [anon_sym_unsigned] = ACTIONS(2264),
    [anon_sym_long] = ACTIONS(2264),
    [anon_sym_short] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_register] = ACTIONS(2264),
    [anon_sym_inline] = ACTIONS(2264),
    [anon_sym___inline] = ACTIONS(2264),
    [anon_sym___inline__] = ACTIONS(2264),
    [anon_sym___forceinline] = ACTIONS(2264),
    [anon_sym_thread_local] = ACTIONS(2264),
    [anon_sym___thread] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_constexpr] = ACTIONS(2264),
    [anon_sym_volatile] = ACTIONS(2264),
    [anon_sym_restrict] = ACTIONS(2264),
    [anon_sym___restrict__] = ACTIONS(2264),
    [anon_sym__Atomic] = ACTIONS(2264),
    [anon_sym__Noreturn] = ACTIONS(2264),
    [anon_sym_noreturn] = ACTIONS(2264),
    [anon_sym__Nonnull] = ACTIONS(2264),
    [anon_sym_mutable] = ACTIONS(2264),
    [anon_sym_constinit] = ACTIONS(2264),
    [anon_sym_consteval] = ACTIONS(2264),
    [anon_sym_alignas] = ACTIONS(2264),
    [anon_sym__Alignas] = ACTIONS(2264),
    [sym_primitive_type] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
    [anon_sym_class] = ACTIONS(2264),
    [anon_sym_struct] = ACTIONS(2264),
    [anon_sym_union] = ACTIONS(2264),
    [anon_sym_or] = ACTIONS(2264),
    [anon_sym_and] = ACTIONS(2264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_This] = ACTIONS(2264),
    [anon_sym_decltype] = ACTIONS(2264),
    [anon_sym_explicit] = ACTIONS(2264),
    [anon_sym_typename] = ACTIONS(2264),
    [anon_sym_template] = ACTIONS(2264),
    [anon_sym_operator] = ACTIONS(2264),
    [anon_sym_friend] = ACTIONS(2264),
    [anon_sym_concept] = ACTIONS(2264),
    [anon_sym_precise] = ACTIONS(2264),
    [anon_sym_shared] = ACTIONS(2264),
    [anon_sym_groupshared] = ACTIONS(2264),
    [anon_sym_uniform] = ACTIONS(2264),
    [anon_sym_row_major] = ACTIONS(2264),
    [anon_sym_column_major] = ACTIONS(2264),
    [anon_sym_globallycoherent] = ACTIONS(2264),
    [anon_sym_centroid] = ACTIONS(2264),
    [anon_sym_noperspective] = ACTIONS(2264),
    [anon_sym_nointerpolation] = ACTIONS(2264),
    [anon_sym_sample] = ACTIONS(2264),
    [anon_sym_linear] = ACTIONS(2264),
    [anon_sym_snorm] = ACTIONS(2264),
    [anon_sym_unorm] = ACTIONS(2264),
    [anon_sym_point] = ACTIONS(2264),
    [anon_sym_line] = ACTIONS(2264),
    [anon_sym_triangleadj] = ACTIONS(2264),
    [anon_sym_lineadj] = ACTIONS(2264),
    [anon_sym_triangle] = ACTIONS(2264),
    [anon_sym_interface] = ACTIONS(2264),
    [anon_sym_extension] = ACTIONS(2264),
  },
  [2712] = {
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_STAR] = ACTIONS(2302),
    [anon_sym_PIPE_PIPE] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym_in] = ACTIONS(2300),
    [anon_sym_out] = ACTIONS(2300),
    [anon_sym_inout] = ACTIONS(2300),
    [anon_sym_virtual] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym___attribute] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2302),
    [anon_sym___declspec] = ACTIONS(2300),
    [anon_sym___based] = ACTIONS(2300),
    [anon_sym___cdecl] = ACTIONS(2300),
    [anon_sym___clrcall] = ACTIONS(2300),
    [anon_sym___stdcall] = ACTIONS(2300),
    [anon_sym___fastcall] = ACTIONS(2300),
    [anon_sym___thiscall] = ACTIONS(2300),
    [anon_sym___vectorcall] = ACTIONS(2300),
    [anon_sym_signed] = ACTIONS(2300),
    [anon_sym_unsigned] = ACTIONS(2300),
    [anon_sym_long] = ACTIONS(2300),
    [anon_sym_short] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_register] = ACTIONS(2300),
    [anon_sym_inline] = ACTIONS(2300),
    [anon_sym___inline] = ACTIONS(2300),
    [anon_sym___inline__] = ACTIONS(2300),
    [anon_sym___forceinline] = ACTIONS(2300),
    [anon_sym_thread_local] = ACTIONS(2300),
    [anon_sym___thread] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym__Nonnull] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [sym_primitive_type] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_struct] = ACTIONS(2300),
    [anon_sym_union] = ACTIONS(2300),
    [anon_sym_or] = ACTIONS(2300),
    [anon_sym_and] = ACTIONS(2300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_This] = ACTIONS(2300),
    [anon_sym_decltype] = ACTIONS(2300),
    [anon_sym_explicit] = ACTIONS(2300),
    [anon_sym_typename] = ACTIONS(2300),
    [anon_sym_template] = ACTIONS(2300),
    [anon_sym_operator] = ACTIONS(2300),
    [anon_sym_friend] = ACTIONS(2300),
    [anon_sym_concept] = ACTIONS(2300),
    [anon_sym_precise] = ACTIONS(2300),
    [anon_sym_shared] = ACTIONS(2300),
    [anon_sym_groupshared] = ACTIONS(2300),
    [anon_sym_uniform] = ACTIONS(2300),
    [anon_sym_row_major] = ACTIONS(2300),
    [anon_sym_column_major] = ACTIONS(2300),
    [anon_sym_globallycoherent] = ACTIONS(2300),
    [anon_sym_centroid] = ACTIONS(2300),
    [anon_sym_noperspective] = ACTIONS(2300),
    [anon_sym_nointerpolation] = ACTIONS(2300),
    [anon_sym_sample] = ACTIONS(2300),
    [anon_sym_linear] = ACTIONS(2300),
    [anon_sym_snorm] = ACTIONS(2300),
    [anon_sym_unorm] = ACTIONS(2300),
    [anon_sym_point] = ACTIONS(2300),
    [anon_sym_line] = ACTIONS(2300),
    [anon_sym_triangleadj] = ACTIONS(2300),
    [anon_sym_lineadj] = ACTIONS(2300),
    [anon_sym_triangle] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_extension] = ACTIONS(2300),
  },
  [2713] = {
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_LPAREN2] = ACTIONS(2262),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(2262),
    [anon_sym_PIPE_PIPE] = ACTIONS(2262),
    [anon_sym_AMP_AMP] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym___extension__] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(2260),
    [anon_sym_out] = ACTIONS(2260),
    [anon_sym_inout] = ACTIONS(2260),
    [anon_sym_virtual] = ACTIONS(2260),
    [anon_sym_extern] = ACTIONS(2260),
    [anon_sym___attribute__] = ACTIONS(2260),
    [anon_sym___attribute] = ACTIONS(2260),
    [anon_sym_using] = ACTIONS(2260),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2262),
    [anon_sym___declspec] = ACTIONS(2260),
    [anon_sym___based] = ACTIONS(2260),
    [anon_sym___cdecl] = ACTIONS(2260),
    [anon_sym___clrcall] = ACTIONS(2260),
    [anon_sym___stdcall] = ACTIONS(2260),
    [anon_sym___fastcall] = ACTIONS(2260),
    [anon_sym___thiscall] = ACTIONS(2260),
    [anon_sym___vectorcall] = ACTIONS(2260),
    [anon_sym_signed] = ACTIONS(2260),
    [anon_sym_unsigned] = ACTIONS(2260),
    [anon_sym_long] = ACTIONS(2260),
    [anon_sym_short] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_register] = ACTIONS(2260),
    [anon_sym_inline] = ACTIONS(2260),
    [anon_sym___inline] = ACTIONS(2260),
    [anon_sym___inline__] = ACTIONS(2260),
    [anon_sym___forceinline] = ACTIONS(2260),
    [anon_sym_thread_local] = ACTIONS(2260),
    [anon_sym___thread] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_constexpr] = ACTIONS(2260),
    [anon_sym_volatile] = ACTIONS(2260),
    [anon_sym_restrict] = ACTIONS(2260),
    [anon_sym___restrict__] = ACTIONS(2260),
    [anon_sym__Atomic] = ACTIONS(2260),
    [anon_sym__Noreturn] = ACTIONS(2260),
    [anon_sym_noreturn] = ACTIONS(2260),
    [anon_sym__Nonnull] = ACTIONS(2260),
    [anon_sym_mutable] = ACTIONS(2260),
    [anon_sym_constinit] = ACTIONS(2260),
    [anon_sym_consteval] = ACTIONS(2260),
    [anon_sym_alignas] = ACTIONS(2260),
    [anon_sym__Alignas] = ACTIONS(2260),
    [sym_primitive_type] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
    [anon_sym_class] = ACTIONS(2260),
    [anon_sym_struct] = ACTIONS(2260),
    [anon_sym_union] = ACTIONS(2260),
    [anon_sym_or] = ACTIONS(2260),
    [anon_sym_and] = ACTIONS(2260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_This] = ACTIONS(2260),
    [anon_sym_decltype] = ACTIONS(2260),
    [anon_sym_explicit] = ACTIONS(2260),
    [anon_sym_typename] = ACTIONS(2260),
    [anon_sym_template] = ACTIONS(2260),
    [anon_sym_operator] = ACTIONS(2260),
    [anon_sym_friend] = ACTIONS(2260),
    [anon_sym_concept] = ACTIONS(2260),
    [anon_sym_precise] = ACTIONS(2260),
    [anon_sym_shared] = ACTIONS(2260),
    [anon_sym_groupshared] = ACTIONS(2260),
    [anon_sym_uniform] = ACTIONS(2260),
    [anon_sym_row_major] = ACTIONS(2260),
    [anon_sym_column_major] = ACTIONS(2260),
    [anon_sym_globallycoherent] = ACTIONS(2260),
    [anon_sym_centroid] = ACTIONS(2260),
    [anon_sym_noperspective] = ACTIONS(2260),
    [anon_sym_nointerpolation] = ACTIONS(2260),
    [anon_sym_sample] = ACTIONS(2260),
    [anon_sym_linear] = ACTIONS(2260),
    [anon_sym_snorm] = ACTIONS(2260),
    [anon_sym_unorm] = ACTIONS(2260),
    [anon_sym_point] = ACTIONS(2260),
    [anon_sym_line] = ACTIONS(2260),
    [anon_sym_triangleadj] = ACTIONS(2260),
    [anon_sym_lineadj] = ACTIONS(2260),
    [anon_sym_triangle] = ACTIONS(2260),
    [anon_sym_interface] = ACTIONS(2260),
    [anon_sym_extension] = ACTIONS(2260),
  },
  [2714] = {
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym_in] = ACTIONS(2304),
    [anon_sym_out] = ACTIONS(2304),
    [anon_sym_inout] = ACTIONS(2304),
    [anon_sym_virtual] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym___attribute] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2306),
    [anon_sym___declspec] = ACTIONS(2304),
    [anon_sym___based] = ACTIONS(2304),
    [anon_sym___cdecl] = ACTIONS(2304),
    [anon_sym___clrcall] = ACTIONS(2304),
    [anon_sym___stdcall] = ACTIONS(2304),
    [anon_sym___fastcall] = ACTIONS(2304),
    [anon_sym___thiscall] = ACTIONS(2304),
    [anon_sym___vectorcall] = ACTIONS(2304),
    [anon_sym_signed] = ACTIONS(2304),
    [anon_sym_unsigned] = ACTIONS(2304),
    [anon_sym_long] = ACTIONS(2304),
    [anon_sym_short] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_register] = ACTIONS(2304),
    [anon_sym_inline] = ACTIONS(2304),
    [anon_sym___inline] = ACTIONS(2304),
    [anon_sym___inline__] = ACTIONS(2304),
    [anon_sym___forceinline] = ACTIONS(2304),
    [anon_sym_thread_local] = ACTIONS(2304),
    [anon_sym___thread] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym__Nonnull] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [sym_primitive_type] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_struct] = ACTIONS(2304),
    [anon_sym_union] = ACTIONS(2304),
    [anon_sym_or] = ACTIONS(2304),
    [anon_sym_and] = ACTIONS(2304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_This] = ACTIONS(2304),
    [anon_sym_decltype] = ACTIONS(2304),
    [anon_sym_explicit] = ACTIONS(2304),
    [anon_sym_typename] = ACTIONS(2304),
    [anon_sym_template] = ACTIONS(2304),
    [anon_sym_operator] = ACTIONS(2304),
    [anon_sym_friend] = ACTIONS(2304),
    [anon_sym_concept] = ACTIONS(2304),
    [anon_sym_precise] = ACTIONS(2304),
    [anon_sym_shared] = ACTIONS(2304),
    [anon_sym_groupshared] = ACTIONS(2304),
    [anon_sym_uniform] = ACTIONS(2304),
    [anon_sym_row_major] = ACTIONS(2304),
    [anon_sym_column_major] = ACTIONS(2304),
    [anon_sym_globallycoherent] = ACTIONS(2304),
    [anon_sym_centroid] = ACTIONS(2304),
    [anon_sym_noperspective] = ACTIONS(2304),
    [anon_sym_nointerpolation] = ACTIONS(2304),
    [anon_sym_sample] = ACTIONS(2304),
    [anon_sym_linear] = ACTIONS(2304),
    [anon_sym_snorm] = ACTIONS(2304),
    [anon_sym_unorm] = ACTIONS(2304),
    [anon_sym_point] = ACTIONS(2304),
    [anon_sym_line] = ACTIONS(2304),
    [anon_sym_triangleadj] = ACTIONS(2304),
    [anon_sym_lineadj] = ACTIONS(2304),
    [anon_sym_triangle] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_extension] = ACTIONS(2304),
  },
  [2715] = {
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_LPAREN2] = ACTIONS(2310),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym___extension__] = ACTIONS(2308),
    [anon_sym_in] = ACTIONS(2308),
    [anon_sym_out] = ACTIONS(2308),
    [anon_sym_inout] = ACTIONS(2308),
    [anon_sym_virtual] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2308),
    [anon_sym___attribute__] = ACTIONS(2308),
    [anon_sym___attribute] = ACTIONS(2308),
    [anon_sym_using] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2310),
    [anon_sym___declspec] = ACTIONS(2308),
    [anon_sym___based] = ACTIONS(2308),
    [anon_sym___cdecl] = ACTIONS(2308),
    [anon_sym___clrcall] = ACTIONS(2308),
    [anon_sym___stdcall] = ACTIONS(2308),
    [anon_sym___fastcall] = ACTIONS(2308),
    [anon_sym___thiscall] = ACTIONS(2308),
    [anon_sym___vectorcall] = ACTIONS(2308),
    [anon_sym_signed] = ACTIONS(2308),
    [anon_sym_unsigned] = ACTIONS(2308),
    [anon_sym_long] = ACTIONS(2308),
    [anon_sym_short] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_register] = ACTIONS(2308),
    [anon_sym_inline] = ACTIONS(2308),
    [anon_sym___inline] = ACTIONS(2308),
    [anon_sym___inline__] = ACTIONS(2308),
    [anon_sym___forceinline] = ACTIONS(2308),
    [anon_sym_thread_local] = ACTIONS(2308),
    [anon_sym___thread] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_constexpr] = ACTIONS(2308),
    [anon_sym_volatile] = ACTIONS(2308),
    [anon_sym_restrict] = ACTIONS(2308),
    [anon_sym___restrict__] = ACTIONS(2308),
    [anon_sym__Atomic] = ACTIONS(2308),
    [anon_sym__Noreturn] = ACTIONS(2308),
    [anon_sym_noreturn] = ACTIONS(2308),
    [anon_sym__Nonnull] = ACTIONS(2308),
    [anon_sym_mutable] = ACTIONS(2308),
    [anon_sym_constinit] = ACTIONS(2308),
    [anon_sym_consteval] = ACTIONS(2308),
    [anon_sym_alignas] = ACTIONS(2308),
    [anon_sym__Alignas] = ACTIONS(2308),
    [sym_primitive_type] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_struct] = ACTIONS(2308),
    [anon_sym_union] = ACTIONS(2308),
    [anon_sym_or] = ACTIONS(2308),
    [anon_sym_and] = ACTIONS(2308),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_This] = ACTIONS(2308),
    [anon_sym_decltype] = ACTIONS(2308),
    [anon_sym_explicit] = ACTIONS(2308),
    [anon_sym_typename] = ACTIONS(2308),
    [anon_sym_template] = ACTIONS(2308),
    [anon_sym_operator] = ACTIONS(2308),
    [anon_sym_friend] = ACTIONS(2308),
    [anon_sym_concept] = ACTIONS(2308),
    [anon_sym_precise] = ACTIONS(2308),
    [anon_sym_shared] = ACTIONS(2308),
    [anon_sym_groupshared] = ACTIONS(2308),
    [anon_sym_uniform] = ACTIONS(2308),
    [anon_sym_row_major] = ACTIONS(2308),
    [anon_sym_column_major] = ACTIONS(2308),
    [anon_sym_globallycoherent] = ACTIONS(2308),
    [anon_sym_centroid] = ACTIONS(2308),
    [anon_sym_noperspective] = ACTIONS(2308),
    [anon_sym_nointerpolation] = ACTIONS(2308),
    [anon_sym_sample] = ACTIONS(2308),
    [anon_sym_linear] = ACTIONS(2308),
    [anon_sym_snorm] = ACTIONS(2308),
    [anon_sym_unorm] = ACTIONS(2308),
    [anon_sym_point] = ACTIONS(2308),
    [anon_sym_line] = ACTIONS(2308),
    [anon_sym_triangleadj] = ACTIONS(2308),
    [anon_sym_lineadj] = ACTIONS(2308),
    [anon_sym_triangle] = ACTIONS(2308),
    [anon_sym_interface] = ACTIONS(2308),
    [anon_sym_extension] = ACTIONS(2308),
  },
  [2716] = {
    [sym_identifier] = ACTIONS(4242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4240),
    [anon_sym_COMMA] = ACTIONS(4240),
    [anon_sym_RPAREN] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_TILDE] = ACTIONS(4240),
    [anon_sym_STAR] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_AMP] = ACTIONS(4242),
    [anon_sym_COLON] = ACTIONS(4242),
    [anon_sym_SEMI] = ACTIONS(4240),
    [anon_sym___extension__] = ACTIONS(4242),
    [anon_sym_in] = ACTIONS(4242),
    [anon_sym_out] = ACTIONS(4242),
    [anon_sym_inout] = ACTIONS(4242),
    [anon_sym_virtual] = ACTIONS(4242),
    [anon_sym_extern] = ACTIONS(4242),
    [anon_sym___attribute__] = ACTIONS(4242),
    [anon_sym___attribute] = ACTIONS(4242),
    [anon_sym_COLON_COLON] = ACTIONS(4240),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4240),
    [anon_sym___declspec] = ACTIONS(4242),
    [anon_sym___based] = ACTIONS(4242),
    [anon_sym___cdecl] = ACTIONS(4242),
    [anon_sym___clrcall] = ACTIONS(4242),
    [anon_sym___stdcall] = ACTIONS(4242),
    [anon_sym___fastcall] = ACTIONS(4242),
    [anon_sym___thiscall] = ACTIONS(4242),
    [anon_sym___vectorcall] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_signed] = ACTIONS(4242),
    [anon_sym_unsigned] = ACTIONS(4242),
    [anon_sym_long] = ACTIONS(4242),
    [anon_sym_short] = ACTIONS(4242),
    [anon_sym_LBRACK] = ACTIONS(4242),
    [anon_sym_static] = ACTIONS(4242),
    [anon_sym_EQ] = ACTIONS(4240),
    [anon_sym_register] = ACTIONS(4242),
    [anon_sym_inline] = ACTIONS(4242),
    [anon_sym___inline] = ACTIONS(4242),
    [anon_sym___inline__] = ACTIONS(4242),
    [anon_sym___forceinline] = ACTIONS(4242),
    [anon_sym_thread_local] = ACTIONS(4242),
    [anon_sym___thread] = ACTIONS(4242),
    [anon_sym_const] = ACTIONS(4242),
    [anon_sym_constexpr] = ACTIONS(4242),
    [anon_sym_volatile] = ACTIONS(4242),
    [anon_sym_restrict] = ACTIONS(4242),
    [anon_sym___restrict__] = ACTIONS(4242),
    [anon_sym__Atomic] = ACTIONS(4242),
    [anon_sym__Noreturn] = ACTIONS(4242),
    [anon_sym_noreturn] = ACTIONS(4242),
    [anon_sym__Nonnull] = ACTIONS(4242),
    [anon_sym_mutable] = ACTIONS(4242),
    [anon_sym_constinit] = ACTIONS(4242),
    [anon_sym_consteval] = ACTIONS(4242),
    [anon_sym_alignas] = ACTIONS(4242),
    [anon_sym__Alignas] = ACTIONS(4242),
    [sym_primitive_type] = ACTIONS(4242),
    [anon_sym_DOT] = ACTIONS(4242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4242),
    [anon_sym_let] = ACTIONS(4242),
    [anon_sym_This] = ACTIONS(4242),
    [anon_sym_decltype] = ACTIONS(4242),
    [anon_sym_final] = ACTIONS(4242),
    [anon_sym_override] = ACTIONS(4242),
    [anon_sym_template] = ACTIONS(4242),
    [anon_sym_GT2] = ACTIONS(4240),
    [anon_sym_operator] = ACTIONS(4242),
    [anon_sym_requires] = ACTIONS(4242),
    [anon_sym_precise] = ACTIONS(4242),
    [anon_sym_shared] = ACTIONS(4242),
    [anon_sym_groupshared] = ACTIONS(4242),
    [anon_sym_uniform] = ACTIONS(4242),
    [anon_sym_row_major] = ACTIONS(4242),
    [anon_sym_column_major] = ACTIONS(4242),
    [anon_sym_globallycoherent] = ACTIONS(4242),
    [anon_sym_centroid] = ACTIONS(4242),
    [anon_sym_noperspective] = ACTIONS(4242),
    [anon_sym_nointerpolation] = ACTIONS(4242),
    [anon_sym_sample] = ACTIONS(4242),
    [anon_sym_linear] = ACTIONS(4242),
    [anon_sym_snorm] = ACTIONS(4242),
    [anon_sym_unorm] = ACTIONS(4242),
    [anon_sym_point] = ACTIONS(4242),
    [anon_sym_line] = ACTIONS(4242),
    [anon_sym_triangleadj] = ACTIONS(4242),
    [anon_sym_lineadj] = ACTIONS(4242),
    [anon_sym_triangle] = ACTIONS(4242),
    [anon_sym_where] = ACTIONS(4242),
  },
  [2717] = {
    [sym_type_qualifier] = STATE(2718),
    [sym_alignas_qualifier] = STATE(2719),
    [aux_sym__type_definition_type_repeat1] = STATE(2718),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2734),
    [sym_identifier] = ACTIONS(6810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3423),
    [anon_sym_COMMA] = ACTIONS(3423),
    [anon_sym_RPAREN] = ACTIONS(3423),
    [anon_sym_LPAREN2] = ACTIONS(3423),
    [anon_sym_TILDE] = ACTIONS(3423),
    [anon_sym_STAR] = ACTIONS(3423),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3428),
    [anon_sym_COLON] = ACTIONS(3428),
    [anon_sym_SEMI] = ACTIONS(3423),
    [anon_sym___extension__] = ACTIONS(6813),
    [anon_sym_in] = ACTIONS(3428),
    [anon_sym_out] = ACTIONS(3428),
    [anon_sym_inout] = ACTIONS(3428),
    [anon_sym_virtual] = ACTIONS(3428),
    [anon_sym_extern] = ACTIONS(3428),
    [anon_sym___attribute__] = ACTIONS(3428),
    [anon_sym___attribute] = ACTIONS(3428),
    [anon_sym_COLON_COLON] = ACTIONS(3423),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3423),
    [anon_sym___declspec] = ACTIONS(3428),
    [anon_sym___based] = ACTIONS(3428),
    [anon_sym___cdecl] = ACTIONS(3428),
    [anon_sym___clrcall] = ACTIONS(3428),
    [anon_sym___stdcall] = ACTIONS(3428),
    [anon_sym___fastcall] = ACTIONS(3428),
    [anon_sym___thiscall] = ACTIONS(3428),
    [anon_sym___vectorcall] = ACTIONS(3428),
    [anon_sym_LBRACE] = ACTIONS(3423),
    [anon_sym_signed] = ACTIONS(6816),
    [anon_sym_unsigned] = ACTIONS(6816),
    [anon_sym_long] = ACTIONS(6816),
    [anon_sym_short] = ACTIONS(6816),
    [anon_sym_LBRACK] = ACTIONS(3428),
    [anon_sym_static] = ACTIONS(3428),
    [anon_sym_EQ] = ACTIONS(3423),
    [anon_sym_register] = ACTIONS(3428),
    [anon_sym_inline] = ACTIONS(3428),
    [anon_sym___inline] = ACTIONS(3428),
    [anon_sym___inline__] = ACTIONS(3428),
    [anon_sym___forceinline] = ACTIONS(3428),
    [anon_sym_thread_local] = ACTIONS(3428),
    [anon_sym___thread] = ACTIONS(3428),
    [anon_sym_const] = ACTIONS(6813),
    [anon_sym_constexpr] = ACTIONS(6813),
    [anon_sym_volatile] = ACTIONS(6813),
    [anon_sym_restrict] = ACTIONS(6813),
    [anon_sym___restrict__] = ACTIONS(6813),
    [anon_sym__Atomic] = ACTIONS(6813),
    [anon_sym__Noreturn] = ACTIONS(6813),
    [anon_sym_noreturn] = ACTIONS(6813),
    [anon_sym__Nonnull] = ACTIONS(6813),
    [anon_sym_mutable] = ACTIONS(6813),
    [anon_sym_constinit] = ACTIONS(6813),
    [anon_sym_consteval] = ACTIONS(6813),
    [anon_sym_alignas] = ACTIONS(6818),
    [anon_sym__Alignas] = ACTIONS(6818),
    [sym_primitive_type] = ACTIONS(6821),
    [anon_sym_DOT] = ACTIONS(3428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3428),
    [anon_sym_let] = ACTIONS(3428),
    [anon_sym_This] = ACTIONS(3428),
    [anon_sym_decltype] = ACTIONS(3428),
    [anon_sym_template] = ACTIONS(3428),
    [anon_sym_GT2] = ACTIONS(3423),
    [anon_sym_operator] = ACTIONS(3428),
    [anon_sym_precise] = ACTIONS(3428),
    [anon_sym_shared] = ACTIONS(3428),
    [anon_sym_groupshared] = ACTIONS(3428),
    [anon_sym_uniform] = ACTIONS(3428),
    [anon_sym_row_major] = ACTIONS(3428),
    [anon_sym_column_major] = ACTIONS(3428),
    [anon_sym_globallycoherent] = ACTIONS(3428),
    [anon_sym_centroid] = ACTIONS(3428),
    [anon_sym_noperspective] = ACTIONS(3428),
    [anon_sym_nointerpolation] = ACTIONS(3428),
    [anon_sym_sample] = ACTIONS(3428),
    [anon_sym_linear] = ACTIONS(3428),
    [anon_sym_snorm] = ACTIONS(3428),
    [anon_sym_unorm] = ACTIONS(3428),
    [anon_sym_point] = ACTIONS(3428),
    [anon_sym_line] = ACTIONS(3428),
    [anon_sym_triangleadj] = ACTIONS(3428),
    [anon_sym_lineadj] = ACTIONS(3428),
    [anon_sym_triangle] = ACTIONS(3428),
  },
  [2718] = {
    [sym_type_qualifier] = STATE(2679),
    [sym_alignas_qualifier] = STATE(2719),
    [aux_sym__type_definition_type_repeat1] = STATE(2679),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2752),
    [sym_identifier] = ACTIONS(6823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3542),
    [anon_sym_COMMA] = ACTIONS(3542),
    [anon_sym_RPAREN] = ACTIONS(3542),
    [anon_sym_LPAREN2] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_STAR] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_AMP] = ACTIONS(3540),
    [anon_sym_COLON] = ACTIONS(3540),
    [anon_sym_SEMI] = ACTIONS(3542),
    [anon_sym___extension__] = ACTIONS(6826),
    [anon_sym_in] = ACTIONS(3540),
    [anon_sym_out] = ACTIONS(3540),
    [anon_sym_inout] = ACTIONS(3540),
    [anon_sym_virtual] = ACTIONS(3540),
    [anon_sym_extern] = ACTIONS(3540),
    [anon_sym___attribute__] = ACTIONS(3540),
    [anon_sym___attribute] = ACTIONS(3540),
    [anon_sym_COLON_COLON] = ACTIONS(3542),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3542),
    [anon_sym___declspec] = ACTIONS(3540),
    [anon_sym___based] = ACTIONS(3540),
    [anon_sym___cdecl] = ACTIONS(3540),
    [anon_sym___clrcall] = ACTIONS(3540),
    [anon_sym___stdcall] = ACTIONS(3540),
    [anon_sym___fastcall] = ACTIONS(3540),
    [anon_sym___thiscall] = ACTIONS(3540),
    [anon_sym___vectorcall] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_signed] = ACTIONS(6829),
    [anon_sym_unsigned] = ACTIONS(6829),
    [anon_sym_long] = ACTIONS(6829),
    [anon_sym_short] = ACTIONS(6829),
    [anon_sym_LBRACK] = ACTIONS(3540),
    [anon_sym_static] = ACTIONS(3540),
    [anon_sym_EQ] = ACTIONS(3542),
    [anon_sym_register] = ACTIONS(3540),
    [anon_sym_inline] = ACTIONS(3540),
    [anon_sym___inline] = ACTIONS(3540),
    [anon_sym___inline__] = ACTIONS(3540),
    [anon_sym___forceinline] = ACTIONS(3540),
    [anon_sym_thread_local] = ACTIONS(3540),
    [anon_sym___thread] = ACTIONS(3540),
    [anon_sym_const] = ACTIONS(6826),
    [anon_sym_constexpr] = ACTIONS(6826),
    [anon_sym_volatile] = ACTIONS(6826),
    [anon_sym_restrict] = ACTIONS(6826),
    [anon_sym___restrict__] = ACTIONS(6826),
    [anon_sym__Atomic] = ACTIONS(6826),
    [anon_sym__Noreturn] = ACTIONS(6826),
    [anon_sym_noreturn] = ACTIONS(6826),
    [anon_sym__Nonnull] = ACTIONS(6826),
    [anon_sym_mutable] = ACTIONS(6826),
    [anon_sym_constinit] = ACTIONS(6826),
    [anon_sym_consteval] = ACTIONS(6826),
    [anon_sym_alignas] = ACTIONS(6831),
    [anon_sym__Alignas] = ACTIONS(6831),
    [sym_primitive_type] = ACTIONS(6834),
    [anon_sym_DOT] = ACTIONS(3540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3540),
    [anon_sym_let] = ACTIONS(3540),
    [anon_sym_This] = ACTIONS(3540),
    [anon_sym_decltype] = ACTIONS(3540),
    [anon_sym_template] = ACTIONS(3540),
    [anon_sym_GT2] = ACTIONS(3542),
    [anon_sym_operator] = ACTIONS(3540),
    [anon_sym_precise] = ACTIONS(3540),
    [anon_sym_shared] = ACTIONS(3540),
    [anon_sym_groupshared] = ACTIONS(3540),
    [anon_sym_uniform] = ACTIONS(3540),
    [anon_sym_row_major] = ACTIONS(3540),
    [anon_sym_column_major] = ACTIONS(3540),
    [anon_sym_globallycoherent] = ACTIONS(3540),
    [anon_sym_centroid] = ACTIONS(3540),
    [anon_sym_noperspective] = ACTIONS(3540),
    [anon_sym_nointerpolation] = ACTIONS(3540),
    [anon_sym_sample] = ACTIONS(3540),
    [anon_sym_linear] = ACTIONS(3540),
    [anon_sym_snorm] = ACTIONS(3540),
    [anon_sym_unorm] = ACTIONS(3540),
    [anon_sym_point] = ACTIONS(3540),
    [anon_sym_line] = ACTIONS(3540),
    [anon_sym_triangleadj] = ACTIONS(3540),
    [anon_sym_lineadj] = ACTIONS(3540),
    [anon_sym_triangle] = ACTIONS(3540),
  },
  [2719] = {
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3352),
    [anon_sym_COMMA] = ACTIONS(3352),
    [anon_sym_RPAREN] = ACTIONS(3352),
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_COLON] = ACTIONS(3362),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3352),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym___cdecl] = ACTIONS(3362),
    [anon_sym___clrcall] = ACTIONS(3362),
    [anon_sym___stdcall] = ACTIONS(3362),
    [anon_sym___fastcall] = ACTIONS(3362),
    [anon_sym___thiscall] = ACTIONS(3362),
    [anon_sym___vectorcall] = ACTIONS(3362),
    [anon_sym_LBRACE] = ACTIONS(3352),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3362),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_EQ] = ACTIONS(3352),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3362),
    [anon_sym_DOT] = ACTIONS(3362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3362),
    [anon_sym_final] = ACTIONS(3362),
    [anon_sym_override] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3362),
    [anon_sym_GT2] = ACTIONS(3352),
    [anon_sym_operator] = ACTIONS(3362),
    [anon_sym_requires] = ACTIONS(3362),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_where] = ACTIONS(3362),
  },
  [2720] = {
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_RPAREN] = ACTIONS(2420),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_PIPE_PIPE] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_out] = ACTIONS(2422),
    [anon_sym_inout] = ACTIONS(2422),
    [anon_sym_virtual] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2422),
    [anon_sym___based] = ACTIONS(2422),
    [anon_sym___cdecl] = ACTIONS(2422),
    [anon_sym___clrcall] = ACTIONS(2422),
    [anon_sym___stdcall] = ACTIONS(2422),
    [anon_sym___fastcall] = ACTIONS(2422),
    [anon_sym___thiscall] = ACTIONS(2422),
    [anon_sym___vectorcall] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_register] = ACTIONS(2422),
    [anon_sym_inline] = ACTIONS(2422),
    [anon_sym___inline] = ACTIONS(2422),
    [anon_sym___inline__] = ACTIONS(2422),
    [anon_sym___forceinline] = ACTIONS(2422),
    [anon_sym_thread_local] = ACTIONS(2422),
    [anon_sym___thread] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [anon_sym_or] = ACTIONS(2422),
    [anon_sym_and] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2422),
    [anon_sym_DASH_GT] = ACTIONS(2420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_decltype] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_template] = ACTIONS(2422),
    [anon_sym_GT2] = ACTIONS(2420),
    [anon_sym_operator] = ACTIONS(2422),
    [anon_sym_noexcept] = ACTIONS(2422),
    [anon_sym_throw] = ACTIONS(2422),
    [anon_sym_precise] = ACTIONS(2422),
    [anon_sym_shared] = ACTIONS(2422),
    [anon_sym_groupshared] = ACTIONS(2422),
    [anon_sym_uniform] = ACTIONS(2422),
    [anon_sym_row_major] = ACTIONS(2422),
    [anon_sym_column_major] = ACTIONS(2422),
    [anon_sym_globallycoherent] = ACTIONS(2422),
    [anon_sym_centroid] = ACTIONS(2422),
    [anon_sym_noperspective] = ACTIONS(2422),
    [anon_sym_nointerpolation] = ACTIONS(2422),
    [anon_sym_sample] = ACTIONS(2422),
    [anon_sym_linear] = ACTIONS(2422),
    [anon_sym_snorm] = ACTIONS(2422),
    [anon_sym_unorm] = ACTIONS(2422),
    [anon_sym_point] = ACTIONS(2422),
    [anon_sym_line] = ACTIONS(2422),
    [anon_sym_triangleadj] = ACTIONS(2422),
    [anon_sym_lineadj] = ACTIONS(2422),
    [anon_sym_triangle] = ACTIONS(2422),
  },
  [2721] = {
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_RPAREN] = ACTIONS(2420),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_PIPE_PIPE] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_out] = ACTIONS(2422),
    [anon_sym_inout] = ACTIONS(2422),
    [anon_sym_virtual] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2422),
    [anon_sym___based] = ACTIONS(2422),
    [anon_sym___cdecl] = ACTIONS(2422),
    [anon_sym___clrcall] = ACTIONS(2422),
    [anon_sym___stdcall] = ACTIONS(2422),
    [anon_sym___fastcall] = ACTIONS(2422),
    [anon_sym___thiscall] = ACTIONS(2422),
    [anon_sym___vectorcall] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_register] = ACTIONS(2422),
    [anon_sym_inline] = ACTIONS(2422),
    [anon_sym___inline] = ACTIONS(2422),
    [anon_sym___inline__] = ACTIONS(2422),
    [anon_sym___forceinline] = ACTIONS(2422),
    [anon_sym_thread_local] = ACTIONS(2422),
    [anon_sym___thread] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [anon_sym_or] = ACTIONS(2422),
    [anon_sym_and] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2422),
    [anon_sym_DASH_GT] = ACTIONS(2420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_decltype] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_template] = ACTIONS(2422),
    [anon_sym_GT2] = ACTIONS(2420),
    [anon_sym_operator] = ACTIONS(2422),
    [anon_sym_noexcept] = ACTIONS(2422),
    [anon_sym_throw] = ACTIONS(2422),
    [anon_sym_precise] = ACTIONS(2422),
    [anon_sym_shared] = ACTIONS(2422),
    [anon_sym_groupshared] = ACTIONS(2422),
    [anon_sym_uniform] = ACTIONS(2422),
    [anon_sym_row_major] = ACTIONS(2422),
    [anon_sym_column_major] = ACTIONS(2422),
    [anon_sym_globallycoherent] = ACTIONS(2422),
    [anon_sym_centroid] = ACTIONS(2422),
    [anon_sym_noperspective] = ACTIONS(2422),
    [anon_sym_nointerpolation] = ACTIONS(2422),
    [anon_sym_sample] = ACTIONS(2422),
    [anon_sym_linear] = ACTIONS(2422),
    [anon_sym_snorm] = ACTIONS(2422),
    [anon_sym_unorm] = ACTIONS(2422),
    [anon_sym_point] = ACTIONS(2422),
    [anon_sym_line] = ACTIONS(2422),
    [anon_sym_triangleadj] = ACTIONS(2422),
    [anon_sym_lineadj] = ACTIONS(2422),
    [anon_sym_triangle] = ACTIONS(2422),
  },
  [2722] = {
    [sym_identifier] = ACTIONS(2243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_RPAREN] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_COLON] = ACTIONS(2243),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_out] = ACTIONS(2243),
    [anon_sym_inout] = ACTIONS(2243),
    [anon_sym_virtual] = ACTIONS(2243),
    [anon_sym_extern] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym___attribute] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2250),
    [anon_sym___declspec] = ACTIONS(2243),
    [anon_sym___based] = ACTIONS(2243),
    [anon_sym___cdecl] = ACTIONS(2243),
    [anon_sym___clrcall] = ACTIONS(2243),
    [anon_sym___stdcall] = ACTIONS(2243),
    [anon_sym___fastcall] = ACTIONS(2243),
    [anon_sym___thiscall] = ACTIONS(2243),
    [anon_sym___vectorcall] = ACTIONS(2243),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2243),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_EQ] = ACTIONS(2250),
    [anon_sym_register] = ACTIONS(2243),
    [anon_sym_inline] = ACTIONS(2243),
    [anon_sym___inline] = ACTIONS(2243),
    [anon_sym___inline__] = ACTIONS(2243),
    [anon_sym___forceinline] = ACTIONS(2243),
    [anon_sym_thread_local] = ACTIONS(2243),
    [anon_sym___thread] = ACTIONS(2243),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym__Nonnull] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [anon_sym_or] = ACTIONS(2243),
    [anon_sym_and] = ACTIONS(2243),
    [anon_sym_DOT] = ACTIONS(2243),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2243),
    [anon_sym_let] = ACTIONS(2243),
    [anon_sym_This] = ACTIONS(2243),
    [anon_sym_decltype] = ACTIONS(2243),
    [anon_sym_final] = ACTIONS(2243),
    [anon_sym_override] = ACTIONS(2243),
    [anon_sym_template] = ACTIONS(2243),
    [anon_sym_GT2] = ACTIONS(2250),
    [anon_sym_operator] = ACTIONS(2243),
    [anon_sym_noexcept] = ACTIONS(2243),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_precise] = ACTIONS(2243),
    [anon_sym_shared] = ACTIONS(2243),
    [anon_sym_groupshared] = ACTIONS(2243),
    [anon_sym_uniform] = ACTIONS(2243),
    [anon_sym_row_major] = ACTIONS(2243),
    [anon_sym_column_major] = ACTIONS(2243),
    [anon_sym_globallycoherent] = ACTIONS(2243),
    [anon_sym_centroid] = ACTIONS(2243),
    [anon_sym_noperspective] = ACTIONS(2243),
    [anon_sym_nointerpolation] = ACTIONS(2243),
    [anon_sym_sample] = ACTIONS(2243),
    [anon_sym_linear] = ACTIONS(2243),
    [anon_sym_snorm] = ACTIONS(2243),
    [anon_sym_unorm] = ACTIONS(2243),
    [anon_sym_point] = ACTIONS(2243),
    [anon_sym_line] = ACTIONS(2243),
    [anon_sym_triangleadj] = ACTIONS(2243),
    [anon_sym_lineadj] = ACTIONS(2243),
    [anon_sym_triangle] = ACTIONS(2243),
  },
  [2723] = {
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_RPAREN] = ACTIONS(2420),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_PIPE_PIPE] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_out] = ACTIONS(2422),
    [anon_sym_inout] = ACTIONS(2422),
    [anon_sym_virtual] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2422),
    [anon_sym___based] = ACTIONS(2422),
    [anon_sym___cdecl] = ACTIONS(2422),
    [anon_sym___clrcall] = ACTIONS(2422),
    [anon_sym___stdcall] = ACTIONS(2422),
    [anon_sym___fastcall] = ACTIONS(2422),
    [anon_sym___thiscall] = ACTIONS(2422),
    [anon_sym___vectorcall] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_register] = ACTIONS(2422),
    [anon_sym_inline] = ACTIONS(2422),
    [anon_sym___inline] = ACTIONS(2422),
    [anon_sym___inline__] = ACTIONS(2422),
    [anon_sym___forceinline] = ACTIONS(2422),
    [anon_sym_thread_local] = ACTIONS(2422),
    [anon_sym___thread] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [anon_sym_or] = ACTIONS(2422),
    [anon_sym_and] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2422),
    [anon_sym_DASH_GT] = ACTIONS(2420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_decltype] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_template] = ACTIONS(2422),
    [anon_sym_GT2] = ACTIONS(2420),
    [anon_sym_operator] = ACTIONS(2422),
    [anon_sym_noexcept] = ACTIONS(2422),
    [anon_sym_throw] = ACTIONS(2422),
    [anon_sym_precise] = ACTIONS(2422),
    [anon_sym_shared] = ACTIONS(2422),
    [anon_sym_groupshared] = ACTIONS(2422),
    [anon_sym_uniform] = ACTIONS(2422),
    [anon_sym_row_major] = ACTIONS(2422),
    [anon_sym_column_major] = ACTIONS(2422),
    [anon_sym_globallycoherent] = ACTIONS(2422),
    [anon_sym_centroid] = ACTIONS(2422),
    [anon_sym_noperspective] = ACTIONS(2422),
    [anon_sym_nointerpolation] = ACTIONS(2422),
    [anon_sym_sample] = ACTIONS(2422),
    [anon_sym_linear] = ACTIONS(2422),
    [anon_sym_snorm] = ACTIONS(2422),
    [anon_sym_unorm] = ACTIONS(2422),
    [anon_sym_point] = ACTIONS(2422),
    [anon_sym_line] = ACTIONS(2422),
    [anon_sym_triangleadj] = ACTIONS(2422),
    [anon_sym_lineadj] = ACTIONS(2422),
    [anon_sym_triangle] = ACTIONS(2422),
  },
  [2724] = {
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2416),
    [anon_sym_COMMA] = ACTIONS(2416),
    [anon_sym_RPAREN] = ACTIONS(2416),
    [anon_sym_LPAREN2] = ACTIONS(2416),
    [anon_sym_TILDE] = ACTIONS(2416),
    [anon_sym_STAR] = ACTIONS(2416),
    [anon_sym_PIPE_PIPE] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym___extension__] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(2418),
    [anon_sym_out] = ACTIONS(2418),
    [anon_sym_inout] = ACTIONS(2418),
    [anon_sym_virtual] = ACTIONS(2418),
    [anon_sym_extern] = ACTIONS(2418),
    [anon_sym___attribute__] = ACTIONS(2418),
    [anon_sym___attribute] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2416),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2416),
    [anon_sym___declspec] = ACTIONS(2418),
    [anon_sym___based] = ACTIONS(2418),
    [anon_sym___cdecl] = ACTIONS(2418),
    [anon_sym___clrcall] = ACTIONS(2418),
    [anon_sym___stdcall] = ACTIONS(2418),
    [anon_sym___fastcall] = ACTIONS(2418),
    [anon_sym___thiscall] = ACTIONS(2418),
    [anon_sym___vectorcall] = ACTIONS(2418),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2416),
    [anon_sym_register] = ACTIONS(2418),
    [anon_sym_inline] = ACTIONS(2418),
    [anon_sym___inline] = ACTIONS(2418),
    [anon_sym___inline__] = ACTIONS(2418),
    [anon_sym___forceinline] = ACTIONS(2418),
    [anon_sym_thread_local] = ACTIONS(2418),
    [anon_sym___thread] = ACTIONS(2418),
    [anon_sym_const] = ACTIONS(2418),
    [anon_sym_constexpr] = ACTIONS(2418),
    [anon_sym_volatile] = ACTIONS(2418),
    [anon_sym_restrict] = ACTIONS(2418),
    [anon_sym___restrict__] = ACTIONS(2418),
    [anon_sym__Atomic] = ACTIONS(2418),
    [anon_sym__Noreturn] = ACTIONS(2418),
    [anon_sym_noreturn] = ACTIONS(2418),
    [anon_sym__Nonnull] = ACTIONS(2418),
    [anon_sym_mutable] = ACTIONS(2418),
    [anon_sym_constinit] = ACTIONS(2418),
    [anon_sym_consteval] = ACTIONS(2418),
    [anon_sym_alignas] = ACTIONS(2418),
    [anon_sym__Alignas] = ACTIONS(2418),
    [anon_sym_or] = ACTIONS(2418),
    [anon_sym_and] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(2418),
    [anon_sym_DASH_GT] = ACTIONS(2416),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_This] = ACTIONS(2418),
    [anon_sym_decltype] = ACTIONS(2418),
    [anon_sym_final] = ACTIONS(2418),
    [anon_sym_override] = ACTIONS(2418),
    [anon_sym_template] = ACTIONS(2418),
    [anon_sym_GT2] = ACTIONS(2416),
    [anon_sym_operator] = ACTIONS(2418),
    [anon_sym_noexcept] = ACTIONS(2418),
    [anon_sym_throw] = ACTIONS(2418),
    [anon_sym_precise] = ACTIONS(2418),
    [anon_sym_shared] = ACTIONS(2418),
    [anon_sym_groupshared] = ACTIONS(2418),
    [anon_sym_uniform] = ACTIONS(2418),
    [anon_sym_row_major] = ACTIONS(2418),
    [anon_sym_column_major] = ACTIONS(2418),
    [anon_sym_globallycoherent] = ACTIONS(2418),
    [anon_sym_centroid] = ACTIONS(2418),
    [anon_sym_noperspective] = ACTIONS(2418),
    [anon_sym_nointerpolation] = ACTIONS(2418),
    [anon_sym_sample] = ACTIONS(2418),
    [anon_sym_linear] = ACTIONS(2418),
    [anon_sym_snorm] = ACTIONS(2418),
    [anon_sym_unorm] = ACTIONS(2418),
    [anon_sym_point] = ACTIONS(2418),
    [anon_sym_line] = ACTIONS(2418),
    [anon_sym_triangleadj] = ACTIONS(2418),
    [anon_sym_lineadj] = ACTIONS(2418),
    [anon_sym_triangle] = ACTIONS(2418),
  },
  [2725] = {
    [sym_identifier] = ACTIONS(4860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4862),
    [anon_sym_COMMA] = ACTIONS(4862),
    [anon_sym_RPAREN] = ACTIONS(4862),
    [anon_sym_LPAREN2] = ACTIONS(4862),
    [anon_sym_TILDE] = ACTIONS(4862),
    [anon_sym_STAR] = ACTIONS(4862),
    [anon_sym_AMP_AMP] = ACTIONS(4862),
    [anon_sym_AMP] = ACTIONS(4860),
    [anon_sym_COLON] = ACTIONS(4860),
    [anon_sym_SEMI] = ACTIONS(4862),
    [anon_sym___extension__] = ACTIONS(4860),
    [anon_sym_in] = ACTIONS(4860),
    [anon_sym_out] = ACTIONS(4860),
    [anon_sym_inout] = ACTIONS(4860),
    [anon_sym_virtual] = ACTIONS(4860),
    [anon_sym_extern] = ACTIONS(4860),
    [anon_sym___attribute__] = ACTIONS(4860),
    [anon_sym___attribute] = ACTIONS(4860),
    [anon_sym_COLON_COLON] = ACTIONS(4862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4862),
    [anon_sym___declspec] = ACTIONS(4860),
    [anon_sym___based] = ACTIONS(4860),
    [anon_sym___cdecl] = ACTIONS(4860),
    [anon_sym___clrcall] = ACTIONS(4860),
    [anon_sym___stdcall] = ACTIONS(4860),
    [anon_sym___fastcall] = ACTIONS(4860),
    [anon_sym___thiscall] = ACTIONS(4860),
    [anon_sym___vectorcall] = ACTIONS(4860),
    [anon_sym_LBRACE] = ACTIONS(4862),
    [anon_sym_LBRACK] = ACTIONS(4860),
    [anon_sym_static] = ACTIONS(4860),
    [anon_sym_EQ] = ACTIONS(4862),
    [anon_sym_register] = ACTIONS(4860),
    [anon_sym_inline] = ACTIONS(4860),
    [anon_sym___inline] = ACTIONS(4860),
    [anon_sym___inline__] = ACTIONS(4860),
    [anon_sym___forceinline] = ACTIONS(4860),
    [anon_sym_thread_local] = ACTIONS(4860),
    [anon_sym___thread] = ACTIONS(4860),
    [anon_sym_const] = ACTIONS(4860),
    [anon_sym_constexpr] = ACTIONS(4860),
    [anon_sym_volatile] = ACTIONS(4860),
    [anon_sym_restrict] = ACTIONS(4860),
    [anon_sym___restrict__] = ACTIONS(4860),
    [anon_sym__Atomic] = ACTIONS(4860),
    [anon_sym__Noreturn] = ACTIONS(4860),
    [anon_sym_noreturn] = ACTIONS(4860),
    [anon_sym__Nonnull] = ACTIONS(4860),
    [anon_sym_mutable] = ACTIONS(4860),
    [anon_sym_constinit] = ACTIONS(4860),
    [anon_sym_consteval] = ACTIONS(4860),
    [anon_sym_alignas] = ACTIONS(4860),
    [anon_sym__Alignas] = ACTIONS(4860),
    [anon_sym_DASH_GT] = ACTIONS(4862),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4860),
    [anon_sym_final] = ACTIONS(4860),
    [anon_sym_override] = ACTIONS(4860),
    [anon_sym_explicit] = ACTIONS(4860),
    [anon_sym_private] = ACTIONS(4860),
    [anon_sym_template] = ACTIONS(4860),
    [anon_sym_GT2] = ACTIONS(4862),
    [anon_sym_operator] = ACTIONS(4860),
    [anon_sym_try] = ACTIONS(4860),
    [anon_sym_public] = ACTIONS(4860),
    [anon_sym_protected] = ACTIONS(4860),
    [anon_sym_noexcept] = ACTIONS(4860),
    [anon_sym_throw] = ACTIONS(4860),
    [anon_sym_requires] = ACTIONS(4860),
    [anon_sym_precise] = ACTIONS(4860),
    [anon_sym_shared] = ACTIONS(4860),
    [anon_sym_groupshared] = ACTIONS(4860),
    [anon_sym_uniform] = ACTIONS(4860),
    [anon_sym_row_major] = ACTIONS(4860),
    [anon_sym_column_major] = ACTIONS(4860),
    [anon_sym_globallycoherent] = ACTIONS(4860),
    [anon_sym_centroid] = ACTIONS(4860),
    [anon_sym_noperspective] = ACTIONS(4860),
    [anon_sym_nointerpolation] = ACTIONS(4860),
    [anon_sym_sample] = ACTIONS(4860),
    [anon_sym_linear] = ACTIONS(4860),
    [anon_sym_snorm] = ACTIONS(4860),
    [anon_sym_unorm] = ACTIONS(4860),
    [anon_sym_point] = ACTIONS(4860),
    [anon_sym_line] = ACTIONS(4860),
    [anon_sym_triangleadj] = ACTIONS(4860),
    [anon_sym_lineadj] = ACTIONS(4860),
    [anon_sym_triangle] = ACTIONS(4860),
    [anon_sym_where] = ACTIONS(4860),
  },
  [2726] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(2915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2913),
    [anon_sym_COMMA] = ACTIONS(2913),
    [anon_sym_RPAREN] = ACTIONS(2913),
    [aux_sym_preproc_if_token2] = ACTIONS(2913),
    [aux_sym_preproc_else_token1] = ACTIONS(2913),
    [aux_sym_preproc_elif_token1] = ACTIONS(2915),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2913),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2913),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2915),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(2915),
    [anon_sym_SLASH] = ACTIONS(2915),
    [anon_sym_PERCENT] = ACTIONS(2915),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_CARET] = ACTIONS(2915),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2915),
    [anon_sym_GT_EQ] = ACTIONS(2913),
    [anon_sym_LT_EQ] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2915),
    [anon_sym_LT_LT] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2915),
    [anon_sym_COLON] = ACTIONS(2913),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_RBRACE] = ACTIONS(2913),
    [anon_sym_signed] = ACTIONS(6836),
    [anon_sym_unsigned] = ACTIONS(6836),
    [anon_sym_long] = ACTIONS(6836),
    [anon_sym_short] = ACTIONS(6836),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_RBRACK] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(2913),
    [anon_sym_STAR_EQ] = ACTIONS(2913),
    [anon_sym_SLASH_EQ] = ACTIONS(2913),
    [anon_sym_PERCENT_EQ] = ACTIONS(2913),
    [anon_sym_PLUS_EQ] = ACTIONS(2913),
    [anon_sym_DASH_EQ] = ACTIONS(2913),
    [anon_sym_LT_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_GT_EQ] = ACTIONS(2913),
    [anon_sym_AMP_EQ] = ACTIONS(2913),
    [anon_sym_CARET_EQ] = ACTIONS(2913),
    [anon_sym_PIPE_EQ] = ACTIONS(2913),
    [anon_sym_and_eq] = ACTIONS(2915),
    [anon_sym_or_eq] = ACTIONS(2915),
    [anon_sym_xor_eq] = ACTIONS(2915),
    [anon_sym_LT_EQ_GT] = ACTIONS(2913),
    [anon_sym_or] = ACTIONS(2915),
    [anon_sym_and] = ACTIONS(2915),
    [anon_sym_bitor] = ACTIONS(2915),
    [anon_sym_xor] = ACTIONS(2915),
    [anon_sym_bitand] = ACTIONS(2915),
    [anon_sym_not_eq] = ACTIONS(2915),
    [anon_sym_is] = ACTIONS(2915),
    [anon_sym_as] = ACTIONS(2915),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_DOT] = ACTIONS(2915),
    [anon_sym_DOT_STAR] = ACTIONS(2913),
    [anon_sym_DASH_GT] = ACTIONS(2913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2915),
    [anon_sym_let] = ACTIONS(2915),
    [anon_sym_This] = ACTIONS(2915),
  },
  [2727] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(3713),
    [sym_raw_string_literal] = STATE(3527),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_RPAREN] = ACTIONS(2183),
    [anon_sym_LPAREN2] = ACTIONS(2183),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6839),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym___extension__] = ACTIONS(2176),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_signed] = ACTIONS(6763),
    [anon_sym_unsigned] = ACTIONS(6763),
    [anon_sym_long] = ACTIONS(6763),
    [anon_sym_short] = ACTIONS(6763),
    [anon_sym_LBRACK] = ACTIONS(2183),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2176),
    [anon_sym_volatile] = ACTIONS(2176),
    [anon_sym_restrict] = ACTIONS(2176),
    [anon_sym___restrict__] = ACTIONS(2176),
    [anon_sym__Atomic] = ACTIONS(2176),
    [anon_sym__Noreturn] = ACTIONS(2176),
    [anon_sym_noreturn] = ACTIONS(2176),
    [anon_sym__Nonnull] = ACTIONS(2176),
    [anon_sym_mutable] = ACTIONS(2176),
    [anon_sym_constinit] = ACTIONS(2176),
    [anon_sym_consteval] = ACTIONS(2176),
    [anon_sym_alignas] = ACTIONS(2176),
    [anon_sym__Alignas] = ACTIONS(2176),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2207),
    [anon_sym_SLASH_EQ] = ACTIONS(2207),
    [anon_sym_PERCENT_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_GT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_EQ] = ACTIONS(2207),
    [anon_sym_CARET_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_EQ] = ACTIONS(2207),
    [anon_sym_and_eq] = ACTIONS(2207),
    [anon_sym_or_eq] = ACTIONS(2207),
    [anon_sym_xor_eq] = ACTIONS(2207),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2176),
    [anon_sym_let] = ACTIONS(2176),
    [anon_sym_This] = ACTIONS(2176),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
  },
  [2728] = {
    [sym_identifier] = ACTIONS(4716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4718),
    [anon_sym_COMMA] = ACTIONS(4718),
    [anon_sym_RPAREN] = ACTIONS(4718),
    [anon_sym_LPAREN2] = ACTIONS(4718),
    [anon_sym_TILDE] = ACTIONS(4718),
    [anon_sym_STAR] = ACTIONS(4718),
    [anon_sym_AMP_AMP] = ACTIONS(4718),
    [anon_sym_AMP] = ACTIONS(4716),
    [anon_sym_COLON] = ACTIONS(4716),
    [anon_sym_SEMI] = ACTIONS(4718),
    [anon_sym___extension__] = ACTIONS(4716),
    [anon_sym_in] = ACTIONS(4716),
    [anon_sym_out] = ACTIONS(4716),
    [anon_sym_inout] = ACTIONS(4716),
    [anon_sym_virtual] = ACTIONS(4716),
    [anon_sym_extern] = ACTIONS(4716),
    [anon_sym___attribute__] = ACTIONS(4716),
    [anon_sym___attribute] = ACTIONS(4716),
    [anon_sym_COLON_COLON] = ACTIONS(4718),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4718),
    [anon_sym___declspec] = ACTIONS(4716),
    [anon_sym___based] = ACTIONS(4716),
    [anon_sym___cdecl] = ACTIONS(4716),
    [anon_sym___clrcall] = ACTIONS(4716),
    [anon_sym___stdcall] = ACTIONS(4716),
    [anon_sym___fastcall] = ACTIONS(4716),
    [anon_sym___thiscall] = ACTIONS(4716),
    [anon_sym___vectorcall] = ACTIONS(4716),
    [anon_sym_LBRACE] = ACTIONS(4718),
    [anon_sym_LBRACK] = ACTIONS(4716),
    [anon_sym_static] = ACTIONS(4716),
    [anon_sym_EQ] = ACTIONS(4718),
    [anon_sym_register] = ACTIONS(4716),
    [anon_sym_inline] = ACTIONS(4716),
    [anon_sym___inline] = ACTIONS(4716),
    [anon_sym___inline__] = ACTIONS(4716),
    [anon_sym___forceinline] = ACTIONS(4716),
    [anon_sym_thread_local] = ACTIONS(4716),
    [anon_sym___thread] = ACTIONS(4716),
    [anon_sym_const] = ACTIONS(4716),
    [anon_sym_constexpr] = ACTIONS(4716),
    [anon_sym_volatile] = ACTIONS(4716),
    [anon_sym_restrict] = ACTIONS(4716),
    [anon_sym___restrict__] = ACTIONS(4716),
    [anon_sym__Atomic] = ACTIONS(4716),
    [anon_sym__Noreturn] = ACTIONS(4716),
    [anon_sym_noreturn] = ACTIONS(4716),
    [anon_sym__Nonnull] = ACTIONS(4716),
    [anon_sym_mutable] = ACTIONS(4716),
    [anon_sym_constinit] = ACTIONS(4716),
    [anon_sym_consteval] = ACTIONS(4716),
    [anon_sym_alignas] = ACTIONS(4716),
    [anon_sym__Alignas] = ACTIONS(4716),
    [anon_sym_DASH_GT] = ACTIONS(4718),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4716),
    [anon_sym_final] = ACTIONS(4716),
    [anon_sym_override] = ACTIONS(4716),
    [anon_sym_explicit] = ACTIONS(4716),
    [anon_sym_private] = ACTIONS(4716),
    [anon_sym_template] = ACTIONS(4716),
    [anon_sym_GT2] = ACTIONS(4718),
    [anon_sym_operator] = ACTIONS(4716),
    [anon_sym_try] = ACTIONS(4716),
    [anon_sym_public] = ACTIONS(4716),
    [anon_sym_protected] = ACTIONS(4716),
    [anon_sym_noexcept] = ACTIONS(4716),
    [anon_sym_throw] = ACTIONS(4716),
    [anon_sym_requires] = ACTIONS(4716),
    [anon_sym_precise] = ACTIONS(4716),
    [anon_sym_shared] = ACTIONS(4716),
    [anon_sym_groupshared] = ACTIONS(4716),
    [anon_sym_uniform] = ACTIONS(4716),
    [anon_sym_row_major] = ACTIONS(4716),
    [anon_sym_column_major] = ACTIONS(4716),
    [anon_sym_globallycoherent] = ACTIONS(4716),
    [anon_sym_centroid] = ACTIONS(4716),
    [anon_sym_noperspective] = ACTIONS(4716),
    [anon_sym_nointerpolation] = ACTIONS(4716),
    [anon_sym_sample] = ACTIONS(4716),
    [anon_sym_linear] = ACTIONS(4716),
    [anon_sym_snorm] = ACTIONS(4716),
    [anon_sym_unorm] = ACTIONS(4716),
    [anon_sym_point] = ACTIONS(4716),
    [anon_sym_line] = ACTIONS(4716),
    [anon_sym_triangleadj] = ACTIONS(4716),
    [anon_sym_lineadj] = ACTIONS(4716),
    [anon_sym_triangle] = ACTIONS(4716),
    [anon_sym_where] = ACTIONS(4716),
  },
  [2729] = {
    [sym_identifier] = ACTIONS(2428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2426),
    [anon_sym_COMMA] = ACTIONS(2426),
    [anon_sym_RPAREN] = ACTIONS(2426),
    [anon_sym_LPAREN2] = ACTIONS(2426),
    [anon_sym_TILDE] = ACTIONS(2426),
    [anon_sym_STAR] = ACTIONS(2426),
    [anon_sym_PIPE_PIPE] = ACTIONS(2426),
    [anon_sym_AMP_AMP] = ACTIONS(2426),
    [anon_sym_AMP] = ACTIONS(2428),
    [anon_sym_COLON] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2426),
    [anon_sym___extension__] = ACTIONS(2428),
    [anon_sym_in] = ACTIONS(2428),
    [anon_sym_out] = ACTIONS(2428),
    [anon_sym_inout] = ACTIONS(2428),
    [anon_sym_virtual] = ACTIONS(2428),
    [anon_sym_extern] = ACTIONS(2428),
    [anon_sym___attribute__] = ACTIONS(2428),
    [anon_sym___attribute] = ACTIONS(2428),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2426),
    [anon_sym___declspec] = ACTIONS(2428),
    [anon_sym___based] = ACTIONS(2428),
    [anon_sym___cdecl] = ACTIONS(2428),
    [anon_sym___clrcall] = ACTIONS(2428),
    [anon_sym___stdcall] = ACTIONS(2428),
    [anon_sym___fastcall] = ACTIONS(2428),
    [anon_sym___thiscall] = ACTIONS(2428),
    [anon_sym___vectorcall] = ACTIONS(2428),
    [anon_sym_LBRACE] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_static] = ACTIONS(2428),
    [anon_sym_EQ] = ACTIONS(2426),
    [anon_sym_register] = ACTIONS(2428),
    [anon_sym_inline] = ACTIONS(2428),
    [anon_sym___inline] = ACTIONS(2428),
    [anon_sym___inline__] = ACTIONS(2428),
    [anon_sym___forceinline] = ACTIONS(2428),
    [anon_sym_thread_local] = ACTIONS(2428),
    [anon_sym___thread] = ACTIONS(2428),
    [anon_sym_const] = ACTIONS(2428),
    [anon_sym_constexpr] = ACTIONS(2428),
    [anon_sym_volatile] = ACTIONS(2428),
    [anon_sym_restrict] = ACTIONS(2428),
    [anon_sym___restrict__] = ACTIONS(2428),
    [anon_sym__Atomic] = ACTIONS(2428),
    [anon_sym__Noreturn] = ACTIONS(2428),
    [anon_sym_noreturn] = ACTIONS(2428),
    [anon_sym__Nonnull] = ACTIONS(2428),
    [anon_sym_mutable] = ACTIONS(2428),
    [anon_sym_constinit] = ACTIONS(2428),
    [anon_sym_consteval] = ACTIONS(2428),
    [anon_sym_alignas] = ACTIONS(2428),
    [anon_sym__Alignas] = ACTIONS(2428),
    [anon_sym_or] = ACTIONS(2428),
    [anon_sym_and] = ACTIONS(2428),
    [anon_sym_DOT] = ACTIONS(2428),
    [anon_sym_DASH_GT] = ACTIONS(2426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2428),
    [anon_sym_let] = ACTIONS(2428),
    [anon_sym_This] = ACTIONS(2428),
    [anon_sym_decltype] = ACTIONS(2428),
    [anon_sym_final] = ACTIONS(2428),
    [anon_sym_override] = ACTIONS(2428),
    [anon_sym_template] = ACTIONS(2428),
    [anon_sym_GT2] = ACTIONS(2426),
    [anon_sym_operator] = ACTIONS(2428),
    [anon_sym_noexcept] = ACTIONS(2428),
    [anon_sym_throw] = ACTIONS(2428),
    [anon_sym_precise] = ACTIONS(2428),
    [anon_sym_shared] = ACTIONS(2428),
    [anon_sym_groupshared] = ACTIONS(2428),
    [anon_sym_uniform] = ACTIONS(2428),
    [anon_sym_row_major] = ACTIONS(2428),
    [anon_sym_column_major] = ACTIONS(2428),
    [anon_sym_globallycoherent] = ACTIONS(2428),
    [anon_sym_centroid] = ACTIONS(2428),
    [anon_sym_noperspective] = ACTIONS(2428),
    [anon_sym_nointerpolation] = ACTIONS(2428),
    [anon_sym_sample] = ACTIONS(2428),
    [anon_sym_linear] = ACTIONS(2428),
    [anon_sym_snorm] = ACTIONS(2428),
    [anon_sym_unorm] = ACTIONS(2428),
    [anon_sym_point] = ACTIONS(2428),
    [anon_sym_line] = ACTIONS(2428),
    [anon_sym_triangleadj] = ACTIONS(2428),
    [anon_sym_lineadj] = ACTIONS(2428),
    [anon_sym_triangle] = ACTIONS(2428),
  },
  [2730] = {
    [sym_template_argument_list] = STATE(2953),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2764),
    [sym_identifier] = ACTIONS(3777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3775),
    [anon_sym_COMMA] = ACTIONS(3775),
    [anon_sym_RPAREN] = ACTIONS(3775),
    [anon_sym_LPAREN2] = ACTIONS(3775),
    [anon_sym_TILDE] = ACTIONS(3775),
    [anon_sym_STAR] = ACTIONS(3775),
    [anon_sym_AMP_AMP] = ACTIONS(3775),
    [anon_sym_AMP] = ACTIONS(3777),
    [anon_sym_LT] = ACTIONS(3779),
    [anon_sym_COLON] = ACTIONS(3777),
    [anon_sym_SEMI] = ACTIONS(3775),
    [anon_sym___extension__] = ACTIONS(3777),
    [anon_sym_in] = ACTIONS(3777),
    [anon_sym_out] = ACTIONS(3777),
    [anon_sym_inout] = ACTIONS(3777),
    [anon_sym_virtual] = ACTIONS(3777),
    [anon_sym_extern] = ACTIONS(3777),
    [anon_sym___attribute__] = ACTIONS(3777),
    [anon_sym___attribute] = ACTIONS(3777),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3775),
    [anon_sym___declspec] = ACTIONS(3777),
    [anon_sym___based] = ACTIONS(3777),
    [anon_sym___cdecl] = ACTIONS(3777),
    [anon_sym___clrcall] = ACTIONS(3777),
    [anon_sym___stdcall] = ACTIONS(3777),
    [anon_sym___fastcall] = ACTIONS(3777),
    [anon_sym___thiscall] = ACTIONS(3777),
    [anon_sym___vectorcall] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3775),
    [anon_sym_signed] = ACTIONS(5332),
    [anon_sym_unsigned] = ACTIONS(5332),
    [anon_sym_long] = ACTIONS(5332),
    [anon_sym_short] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(3777),
    [anon_sym_static] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(3775),
    [anon_sym_register] = ACTIONS(3777),
    [anon_sym_inline] = ACTIONS(3777),
    [anon_sym___inline] = ACTIONS(3777),
    [anon_sym___inline__] = ACTIONS(3777),
    [anon_sym___forceinline] = ACTIONS(3777),
    [anon_sym_thread_local] = ACTIONS(3777),
    [anon_sym___thread] = ACTIONS(3777),
    [anon_sym_const] = ACTIONS(3777),
    [anon_sym_constexpr] = ACTIONS(3777),
    [anon_sym_volatile] = ACTIONS(3777),
    [anon_sym_restrict] = ACTIONS(3777),
    [anon_sym___restrict__] = ACTIONS(3777),
    [anon_sym__Atomic] = ACTIONS(3777),
    [anon_sym__Noreturn] = ACTIONS(3777),
    [anon_sym_noreturn] = ACTIONS(3777),
    [anon_sym__Nonnull] = ACTIONS(3777),
    [anon_sym_mutable] = ACTIONS(3777),
    [anon_sym_constinit] = ACTIONS(3777),
    [anon_sym_consteval] = ACTIONS(3777),
    [anon_sym_alignas] = ACTIONS(3777),
    [anon_sym__Alignas] = ACTIONS(3777),
    [anon_sym_DOT] = ACTIONS(3777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3777),
    [anon_sym_let] = ACTIONS(3777),
    [anon_sym_This] = ACTIONS(3777),
    [anon_sym_decltype] = ACTIONS(3777),
    [anon_sym_template] = ACTIONS(3777),
    [anon_sym_GT2] = ACTIONS(3775),
    [anon_sym_operator] = ACTIONS(3777),
    [anon_sym_precise] = ACTIONS(3777),
    [anon_sym_shared] = ACTIONS(3777),
    [anon_sym_groupshared] = ACTIONS(3777),
    [anon_sym_uniform] = ACTIONS(3777),
    [anon_sym_row_major] = ACTIONS(3777),
    [anon_sym_column_major] = ACTIONS(3777),
    [anon_sym_globallycoherent] = ACTIONS(3777),
    [anon_sym_centroid] = ACTIONS(3777),
    [anon_sym_noperspective] = ACTIONS(3777),
    [anon_sym_nointerpolation] = ACTIONS(3777),
    [anon_sym_sample] = ACTIONS(3777),
    [anon_sym_linear] = ACTIONS(3777),
    [anon_sym_snorm] = ACTIONS(3777),
    [anon_sym_unorm] = ACTIONS(3777),
    [anon_sym_point] = ACTIONS(3777),
    [anon_sym_line] = ACTIONS(3777),
    [anon_sym_triangleadj] = ACTIONS(3777),
    [anon_sym_lineadj] = ACTIONS(3777),
    [anon_sym_triangle] = ACTIONS(3777),
  },
  [2731] = {
    [sym_identifier] = ACTIONS(4242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4240),
    [anon_sym_COMMA] = ACTIONS(4240),
    [anon_sym_RPAREN] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_TILDE] = ACTIONS(4240),
    [anon_sym_STAR] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_AMP] = ACTIONS(4242),
    [anon_sym_COLON] = ACTIONS(4242),
    [anon_sym_SEMI] = ACTIONS(4240),
    [anon_sym___extension__] = ACTIONS(4242),
    [anon_sym_in] = ACTIONS(4242),
    [anon_sym_out] = ACTIONS(4242),
    [anon_sym_inout] = ACTIONS(4242),
    [anon_sym_virtual] = ACTIONS(4242),
    [anon_sym_extern] = ACTIONS(4242),
    [anon_sym___attribute__] = ACTIONS(4242),
    [anon_sym___attribute] = ACTIONS(4242),
    [anon_sym_COLON_COLON] = ACTIONS(4240),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4240),
    [anon_sym___declspec] = ACTIONS(4242),
    [anon_sym___based] = ACTIONS(4242),
    [anon_sym___cdecl] = ACTIONS(4242),
    [anon_sym___clrcall] = ACTIONS(4242),
    [anon_sym___stdcall] = ACTIONS(4242),
    [anon_sym___fastcall] = ACTIONS(4242),
    [anon_sym___thiscall] = ACTIONS(4242),
    [anon_sym___vectorcall] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_LBRACK] = ACTIONS(4242),
    [anon_sym_static] = ACTIONS(4242),
    [anon_sym_EQ] = ACTIONS(4240),
    [anon_sym_register] = ACTIONS(4242),
    [anon_sym_inline] = ACTIONS(4242),
    [anon_sym___inline] = ACTIONS(4242),
    [anon_sym___inline__] = ACTIONS(4242),
    [anon_sym___forceinline] = ACTIONS(4242),
    [anon_sym_thread_local] = ACTIONS(4242),
    [anon_sym___thread] = ACTIONS(4242),
    [anon_sym_const] = ACTIONS(4242),
    [anon_sym_constexpr] = ACTIONS(4242),
    [anon_sym_volatile] = ACTIONS(4242),
    [anon_sym_restrict] = ACTIONS(4242),
    [anon_sym___restrict__] = ACTIONS(4242),
    [anon_sym__Atomic] = ACTIONS(4242),
    [anon_sym__Noreturn] = ACTIONS(4242),
    [anon_sym_noreturn] = ACTIONS(4242),
    [anon_sym__Nonnull] = ACTIONS(4242),
    [anon_sym_mutable] = ACTIONS(4242),
    [anon_sym_constinit] = ACTIONS(4242),
    [anon_sym_consteval] = ACTIONS(4242),
    [anon_sym_alignas] = ACTIONS(4242),
    [anon_sym__Alignas] = ACTIONS(4242),
    [anon_sym_asm] = ACTIONS(4242),
    [anon_sym___asm__] = ACTIONS(4242),
    [anon_sym___asm] = ACTIONS(4242),
    [anon_sym_DASH_GT] = ACTIONS(4240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4242),
    [anon_sym_final] = ACTIONS(4242),
    [anon_sym_override] = ACTIONS(4242),
    [anon_sym_explicit] = ACTIONS(4242),
    [anon_sym_template] = ACTIONS(4242),
    [anon_sym_GT2] = ACTIONS(4240),
    [anon_sym_operator] = ACTIONS(4242),
    [anon_sym_noexcept] = ACTIONS(4242),
    [anon_sym_throw] = ACTIONS(4242),
    [anon_sym_requires] = ACTIONS(4242),
    [anon_sym_precise] = ACTIONS(4242),
    [anon_sym_shared] = ACTIONS(4242),
    [anon_sym_groupshared] = ACTIONS(4242),
    [anon_sym_uniform] = ACTIONS(4242),
    [anon_sym_row_major] = ACTIONS(4242),
    [anon_sym_column_major] = ACTIONS(4242),
    [anon_sym_globallycoherent] = ACTIONS(4242),
    [anon_sym_centroid] = ACTIONS(4242),
    [anon_sym_noperspective] = ACTIONS(4242),
    [anon_sym_nointerpolation] = ACTIONS(4242),
    [anon_sym_sample] = ACTIONS(4242),
    [anon_sym_linear] = ACTIONS(4242),
    [anon_sym_snorm] = ACTIONS(4242),
    [anon_sym_unorm] = ACTIONS(4242),
    [anon_sym_point] = ACTIONS(4242),
    [anon_sym_line] = ACTIONS(4242),
    [anon_sym_triangleadj] = ACTIONS(4242),
    [anon_sym_lineadj] = ACTIONS(4242),
    [anon_sym_triangle] = ACTIONS(4242),
    [anon_sym_where] = ACTIONS(4242),
  },
  [2732] = {
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3352),
    [anon_sym_COMMA] = ACTIONS(3352),
    [anon_sym_RPAREN] = ACTIONS(3352),
    [aux_sym_preproc_if_token2] = ACTIONS(3352),
    [aux_sym_preproc_else_token1] = ACTIONS(3352),
    [aux_sym_preproc_elif_token1] = ACTIONS(3362),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3352),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3352),
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_DASH] = ACTIONS(3362),
    [anon_sym_PLUS] = ACTIONS(3362),
    [anon_sym_STAR] = ACTIONS(3362),
    [anon_sym_SLASH] = ACTIONS(3362),
    [anon_sym_PERCENT] = ACTIONS(3362),
    [anon_sym_PIPE_PIPE] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_PIPE] = ACTIONS(3362),
    [anon_sym_CARET] = ACTIONS(3362),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_EQ_EQ] = ACTIONS(3352),
    [anon_sym_BANG_EQ] = ACTIONS(3352),
    [anon_sym_GT] = ACTIONS(3362),
    [anon_sym_GT_EQ] = ACTIONS(3352),
    [anon_sym_LT_EQ] = ACTIONS(3362),
    [anon_sym_LT] = ACTIONS(3362),
    [anon_sym_LT_LT] = ACTIONS(3362),
    [anon_sym_GT_GT] = ACTIONS(3362),
    [anon_sym_COLON] = ACTIONS(3352),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_LBRACE] = ACTIONS(3352),
    [anon_sym_RBRACE] = ACTIONS(3352),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3352),
    [anon_sym_RBRACK] = ACTIONS(3352),
    [anon_sym_EQ] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3362),
    [anon_sym_QMARK] = ACTIONS(3352),
    [anon_sym_STAR_EQ] = ACTIONS(3352),
    [anon_sym_SLASH_EQ] = ACTIONS(3352),
    [anon_sym_PERCENT_EQ] = ACTIONS(3352),
    [anon_sym_PLUS_EQ] = ACTIONS(3352),
    [anon_sym_DASH_EQ] = ACTIONS(3352),
    [anon_sym_LT_LT_EQ] = ACTIONS(3352),
    [anon_sym_GT_GT_EQ] = ACTIONS(3352),
    [anon_sym_AMP_EQ] = ACTIONS(3352),
    [anon_sym_CARET_EQ] = ACTIONS(3352),
    [anon_sym_PIPE_EQ] = ACTIONS(3352),
    [anon_sym_and_eq] = ACTIONS(3362),
    [anon_sym_or_eq] = ACTIONS(3362),
    [anon_sym_xor_eq] = ACTIONS(3362),
    [anon_sym_LT_EQ_GT] = ACTIONS(3352),
    [anon_sym_or] = ACTIONS(3362),
    [anon_sym_and] = ACTIONS(3362),
    [anon_sym_bitor] = ACTIONS(3362),
    [anon_sym_xor] = ACTIONS(3362),
    [anon_sym_bitand] = ACTIONS(3362),
    [anon_sym_not_eq] = ACTIONS(3362),
    [anon_sym_is] = ACTIONS(3362),
    [anon_sym_as] = ACTIONS(3362),
    [anon_sym_DASH_DASH] = ACTIONS(3352),
    [anon_sym_PLUS_PLUS] = ACTIONS(3352),
    [anon_sym_DOT] = ACTIONS(3362),
    [anon_sym_DOT_STAR] = ACTIONS(3352),
    [anon_sym_DASH_GT] = ACTIONS(3352),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
  },
  [2733] = {
    [sym_identifier] = ACTIONS(4242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4240),
    [anon_sym_COMMA] = ACTIONS(4240),
    [anon_sym_RPAREN] = ACTIONS(4240),
    [aux_sym_preproc_if_token2] = ACTIONS(4240),
    [aux_sym_preproc_else_token1] = ACTIONS(4240),
    [aux_sym_preproc_elif_token1] = ACTIONS(4242),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4240),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4242),
    [anon_sym_PLUS] = ACTIONS(4242),
    [anon_sym_STAR] = ACTIONS(4242),
    [anon_sym_SLASH] = ACTIONS(4242),
    [anon_sym_PERCENT] = ACTIONS(4242),
    [anon_sym_PIPE_PIPE] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_PIPE] = ACTIONS(4242),
    [anon_sym_CARET] = ACTIONS(4242),
    [anon_sym_AMP] = ACTIONS(4242),
    [anon_sym_EQ_EQ] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(4240),
    [anon_sym_GT] = ACTIONS(4242),
    [anon_sym_GT_EQ] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(4242),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_LT_LT] = ACTIONS(4242),
    [anon_sym_GT_GT] = ACTIONS(4242),
    [anon_sym_COLON] = ACTIONS(4240),
    [anon_sym_SEMI] = ACTIONS(4240),
    [anon_sym___extension__] = ACTIONS(4242),
    [anon_sym___attribute__] = ACTIONS(4242),
    [anon_sym___attribute] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_RBRACE] = ACTIONS(4240),
    [anon_sym_signed] = ACTIONS(4242),
    [anon_sym_unsigned] = ACTIONS(4242),
    [anon_sym_long] = ACTIONS(4242),
    [anon_sym_short] = ACTIONS(4242),
    [anon_sym_LBRACK] = ACTIONS(4240),
    [anon_sym_RBRACK] = ACTIONS(4240),
    [anon_sym_EQ] = ACTIONS(4242),
    [anon_sym_const] = ACTIONS(4242),
    [anon_sym_constexpr] = ACTIONS(4242),
    [anon_sym_volatile] = ACTIONS(4242),
    [anon_sym_restrict] = ACTIONS(4242),
    [anon_sym___restrict__] = ACTIONS(4242),
    [anon_sym__Atomic] = ACTIONS(4242),
    [anon_sym__Noreturn] = ACTIONS(4242),
    [anon_sym_noreturn] = ACTIONS(4242),
    [anon_sym__Nonnull] = ACTIONS(4242),
    [anon_sym_mutable] = ACTIONS(4242),
    [anon_sym_constinit] = ACTIONS(4242),
    [anon_sym_consteval] = ACTIONS(4242),
    [anon_sym_alignas] = ACTIONS(4242),
    [anon_sym__Alignas] = ACTIONS(4242),
    [sym_primitive_type] = ACTIONS(4242),
    [anon_sym_QMARK] = ACTIONS(4240),
    [anon_sym_STAR_EQ] = ACTIONS(4240),
    [anon_sym_SLASH_EQ] = ACTIONS(4240),
    [anon_sym_PERCENT_EQ] = ACTIONS(4240),
    [anon_sym_PLUS_EQ] = ACTIONS(4240),
    [anon_sym_DASH_EQ] = ACTIONS(4240),
    [anon_sym_LT_LT_EQ] = ACTIONS(4240),
    [anon_sym_GT_GT_EQ] = ACTIONS(4240),
    [anon_sym_AMP_EQ] = ACTIONS(4240),
    [anon_sym_CARET_EQ] = ACTIONS(4240),
    [anon_sym_PIPE_EQ] = ACTIONS(4240),
    [anon_sym_and_eq] = ACTIONS(4242),
    [anon_sym_or_eq] = ACTIONS(4242),
    [anon_sym_xor_eq] = ACTIONS(4242),
    [anon_sym_LT_EQ_GT] = ACTIONS(4240),
    [anon_sym_or] = ACTIONS(4242),
    [anon_sym_and] = ACTIONS(4242),
    [anon_sym_bitor] = ACTIONS(4242),
    [anon_sym_xor] = ACTIONS(4242),
    [anon_sym_bitand] = ACTIONS(4242),
    [anon_sym_not_eq] = ACTIONS(4242),
    [anon_sym_is] = ACTIONS(4242),
    [anon_sym_as] = ACTIONS(4242),
    [anon_sym_DASH_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_PLUS] = ACTIONS(4240),
    [anon_sym_DOT] = ACTIONS(4242),
    [anon_sym_DOT_STAR] = ACTIONS(4240),
    [anon_sym_DASH_GT] = ACTIONS(4240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4242),
    [anon_sym_let] = ACTIONS(4242),
    [anon_sym_This] = ACTIONS(4242),
  },
  [2734] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2693),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4121),
    [anon_sym_COMMA] = ACTIONS(4121),
    [anon_sym_RPAREN] = ACTIONS(4121),
    [anon_sym_LPAREN2] = ACTIONS(4121),
    [anon_sym_TILDE] = ACTIONS(4121),
    [anon_sym_STAR] = ACTIONS(4121),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_AMP] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4124),
    [anon_sym_SEMI] = ACTIONS(4121),
    [anon_sym___extension__] = ACTIONS(4124),
    [anon_sym_in] = ACTIONS(4124),
    [anon_sym_out] = ACTIONS(4124),
    [anon_sym_inout] = ACTIONS(4124),
    [anon_sym_virtual] = ACTIONS(4124),
    [anon_sym_extern] = ACTIONS(4124),
    [anon_sym___attribute__] = ACTIONS(4124),
    [anon_sym___attribute] = ACTIONS(4124),
    [anon_sym_COLON_COLON] = ACTIONS(4121),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4121),
    [anon_sym___declspec] = ACTIONS(4124),
    [anon_sym___based] = ACTIONS(4124),
    [anon_sym___cdecl] = ACTIONS(4124),
    [anon_sym___clrcall] = ACTIONS(4124),
    [anon_sym___stdcall] = ACTIONS(4124),
    [anon_sym___fastcall] = ACTIONS(4124),
    [anon_sym___thiscall] = ACTIONS(4124),
    [anon_sym___vectorcall] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_signed] = ACTIONS(6775),
    [anon_sym_unsigned] = ACTIONS(6775),
    [anon_sym_long] = ACTIONS(6775),
    [anon_sym_short] = ACTIONS(6775),
    [anon_sym_LBRACK] = ACTIONS(4124),
    [anon_sym_static] = ACTIONS(4124),
    [anon_sym_EQ] = ACTIONS(4121),
    [anon_sym_register] = ACTIONS(4124),
    [anon_sym_inline] = ACTIONS(4124),
    [anon_sym___inline] = ACTIONS(4124),
    [anon_sym___inline__] = ACTIONS(4124),
    [anon_sym___forceinline] = ACTIONS(4124),
    [anon_sym_thread_local] = ACTIONS(4124),
    [anon_sym___thread] = ACTIONS(4124),
    [anon_sym_const] = ACTIONS(4124),
    [anon_sym_constexpr] = ACTIONS(4124),
    [anon_sym_volatile] = ACTIONS(4124),
    [anon_sym_restrict] = ACTIONS(4124),
    [anon_sym___restrict__] = ACTIONS(4124),
    [anon_sym__Atomic] = ACTIONS(4124),
    [anon_sym__Noreturn] = ACTIONS(4124),
    [anon_sym_noreturn] = ACTIONS(4124),
    [anon_sym__Nonnull] = ACTIONS(4124),
    [anon_sym_mutable] = ACTIONS(4124),
    [anon_sym_constinit] = ACTIONS(4124),
    [anon_sym_consteval] = ACTIONS(4124),
    [anon_sym_alignas] = ACTIONS(4124),
    [anon_sym__Alignas] = ACTIONS(4124),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_DOT] = ACTIONS(4124),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4124),
    [anon_sym_let] = ACTIONS(4124),
    [anon_sym_This] = ACTIONS(4124),
    [anon_sym_decltype] = ACTIONS(4124),
    [anon_sym_template] = ACTIONS(4124),
    [anon_sym_GT2] = ACTIONS(4121),
    [anon_sym_operator] = ACTIONS(4124),
    [anon_sym_precise] = ACTIONS(4124),
    [anon_sym_shared] = ACTIONS(4124),
    [anon_sym_groupshared] = ACTIONS(4124),
    [anon_sym_uniform] = ACTIONS(4124),
    [anon_sym_row_major] = ACTIONS(4124),
    [anon_sym_column_major] = ACTIONS(4124),
    [anon_sym_globallycoherent] = ACTIONS(4124),
    [anon_sym_centroid] = ACTIONS(4124),
    [anon_sym_noperspective] = ACTIONS(4124),
    [anon_sym_nointerpolation] = ACTIONS(4124),
    [anon_sym_sample] = ACTIONS(4124),
    [anon_sym_linear] = ACTIONS(4124),
    [anon_sym_snorm] = ACTIONS(4124),
    [anon_sym_unorm] = ACTIONS(4124),
    [anon_sym_point] = ACTIONS(4124),
    [anon_sym_line] = ACTIONS(4124),
    [anon_sym_triangleadj] = ACTIONS(4124),
    [anon_sym_lineadj] = ACTIONS(4124),
    [anon_sym_triangle] = ACTIONS(4124),
  },
  [2735] = {
    [sym_type_qualifier] = STATE(2736),
    [sym_alignas_qualifier] = STATE(2732),
    [aux_sym__type_definition_type_repeat1] = STATE(2736),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2780),
    [sym_identifier] = ACTIONS(6842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3423),
    [anon_sym_COMMA] = ACTIONS(3423),
    [anon_sym_RPAREN] = ACTIONS(3423),
    [anon_sym_LPAREN2] = ACTIONS(3423),
    [anon_sym_DASH] = ACTIONS(3428),
    [anon_sym_PLUS] = ACTIONS(3428),
    [anon_sym_STAR] = ACTIONS(3428),
    [anon_sym_SLASH] = ACTIONS(3428),
    [anon_sym_PERCENT] = ACTIONS(3428),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_PIPE] = ACTIONS(3428),
    [anon_sym_CARET] = ACTIONS(3428),
    [anon_sym_AMP] = ACTIONS(3428),
    [anon_sym_EQ_EQ] = ACTIONS(3423),
    [anon_sym_BANG_EQ] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3428),
    [anon_sym_GT_EQ] = ACTIONS(3423),
    [anon_sym_LT_EQ] = ACTIONS(3428),
    [anon_sym_LT] = ACTIONS(3428),
    [anon_sym_LT_LT] = ACTIONS(3428),
    [anon_sym_GT_GT] = ACTIONS(3428),
    [anon_sym_COLON] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3423),
    [anon_sym___extension__] = ACTIONS(6844),
    [anon_sym___attribute__] = ACTIONS(3428),
    [anon_sym___attribute] = ACTIONS(3428),
    [anon_sym_LBRACE] = ACTIONS(3423),
    [anon_sym_RBRACE] = ACTIONS(3423),
    [anon_sym_signed] = ACTIONS(6846),
    [anon_sym_unsigned] = ACTIONS(6846),
    [anon_sym_long] = ACTIONS(6846),
    [anon_sym_short] = ACTIONS(6846),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_RBRACK] = ACTIONS(3423),
    [anon_sym_EQ] = ACTIONS(3428),
    [anon_sym_const] = ACTIONS(6844),
    [anon_sym_constexpr] = ACTIONS(6844),
    [anon_sym_volatile] = ACTIONS(6844),
    [anon_sym_restrict] = ACTIONS(6844),
    [anon_sym___restrict__] = ACTIONS(6844),
    [anon_sym__Atomic] = ACTIONS(6844),
    [anon_sym__Noreturn] = ACTIONS(6844),
    [anon_sym_noreturn] = ACTIONS(6844),
    [anon_sym__Nonnull] = ACTIONS(6844),
    [anon_sym_mutable] = ACTIONS(6844),
    [anon_sym_constinit] = ACTIONS(6844),
    [anon_sym_consteval] = ACTIONS(6844),
    [anon_sym_alignas] = ACTIONS(6848),
    [anon_sym__Alignas] = ACTIONS(6848),
    [sym_primitive_type] = ACTIONS(6850),
    [anon_sym_QMARK] = ACTIONS(3423),
    [anon_sym_STAR_EQ] = ACTIONS(3423),
    [anon_sym_SLASH_EQ] = ACTIONS(3423),
    [anon_sym_PERCENT_EQ] = ACTIONS(3423),
    [anon_sym_PLUS_EQ] = ACTIONS(3423),
    [anon_sym_DASH_EQ] = ACTIONS(3423),
    [anon_sym_LT_LT_EQ] = ACTIONS(3423),
    [anon_sym_GT_GT_EQ] = ACTIONS(3423),
    [anon_sym_AMP_EQ] = ACTIONS(3423),
    [anon_sym_CARET_EQ] = ACTIONS(3423),
    [anon_sym_PIPE_EQ] = ACTIONS(3423),
    [anon_sym_and_eq] = ACTIONS(3428),
    [anon_sym_or_eq] = ACTIONS(3428),
    [anon_sym_xor_eq] = ACTIONS(3428),
    [anon_sym_LT_EQ_GT] = ACTIONS(3423),
    [anon_sym_or] = ACTIONS(3428),
    [anon_sym_and] = ACTIONS(3428),
    [anon_sym_bitor] = ACTIONS(3428),
    [anon_sym_xor] = ACTIONS(3428),
    [anon_sym_bitand] = ACTIONS(3428),
    [anon_sym_not_eq] = ACTIONS(3428),
    [anon_sym_is] = ACTIONS(3428),
    [anon_sym_as] = ACTIONS(3428),
    [anon_sym_DASH_DASH] = ACTIONS(3423),
    [anon_sym_PLUS_PLUS] = ACTIONS(3423),
    [anon_sym_DOT] = ACTIONS(3428),
    [anon_sym_DOT_STAR] = ACTIONS(3423),
    [anon_sym_DASH_GT] = ACTIONS(3423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3428),
    [anon_sym_let] = ACTIONS(3428),
    [anon_sym_This] = ACTIONS(3428),
  },
  [2736] = {
    [sym_type_qualifier] = STATE(2692),
    [sym_alignas_qualifier] = STATE(2732),
    [aux_sym__type_definition_type_repeat1] = STATE(2692),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3272),
    [sym_identifier] = ACTIONS(6852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3542),
    [anon_sym_COMMA] = ACTIONS(3542),
    [anon_sym_RPAREN] = ACTIONS(3542),
    [anon_sym_LPAREN2] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(3540),
    [anon_sym_SLASH] = ACTIONS(3540),
    [anon_sym_PERCENT] = ACTIONS(3540),
    [anon_sym_PIPE_PIPE] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_PIPE] = ACTIONS(3540),
    [anon_sym_CARET] = ACTIONS(3540),
    [anon_sym_AMP] = ACTIONS(3540),
    [anon_sym_EQ_EQ] = ACTIONS(3542),
    [anon_sym_BANG_EQ] = ACTIONS(3542),
    [anon_sym_GT] = ACTIONS(3540),
    [anon_sym_GT_EQ] = ACTIONS(3542),
    [anon_sym_LT_EQ] = ACTIONS(3540),
    [anon_sym_LT] = ACTIONS(3540),
    [anon_sym_LT_LT] = ACTIONS(3540),
    [anon_sym_GT_GT] = ACTIONS(3540),
    [anon_sym_COLON] = ACTIONS(3542),
    [anon_sym_SEMI] = ACTIONS(3542),
    [anon_sym___extension__] = ACTIONS(6844),
    [anon_sym___attribute__] = ACTIONS(3540),
    [anon_sym___attribute] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_RBRACE] = ACTIONS(3542),
    [anon_sym_signed] = ACTIONS(6854),
    [anon_sym_unsigned] = ACTIONS(6854),
    [anon_sym_long] = ACTIONS(6854),
    [anon_sym_short] = ACTIONS(6854),
    [anon_sym_LBRACK] = ACTIONS(3542),
    [anon_sym_RBRACK] = ACTIONS(3542),
    [anon_sym_EQ] = ACTIONS(3540),
    [anon_sym_const] = ACTIONS(6844),
    [anon_sym_constexpr] = ACTIONS(6844),
    [anon_sym_volatile] = ACTIONS(6844),
    [anon_sym_restrict] = ACTIONS(6844),
    [anon_sym___restrict__] = ACTIONS(6844),
    [anon_sym__Atomic] = ACTIONS(6844),
    [anon_sym__Noreturn] = ACTIONS(6844),
    [anon_sym_noreturn] = ACTIONS(6844),
    [anon_sym__Nonnull] = ACTIONS(6844),
    [anon_sym_mutable] = ACTIONS(6844),
    [anon_sym_constinit] = ACTIONS(6844),
    [anon_sym_consteval] = ACTIONS(6844),
    [anon_sym_alignas] = ACTIONS(6848),
    [anon_sym__Alignas] = ACTIONS(6848),
    [sym_primitive_type] = ACTIONS(6856),
    [anon_sym_QMARK] = ACTIONS(3542),
    [anon_sym_STAR_EQ] = ACTIONS(3542),
    [anon_sym_SLASH_EQ] = ACTIONS(3542),
    [anon_sym_PERCENT_EQ] = ACTIONS(3542),
    [anon_sym_PLUS_EQ] = ACTIONS(3542),
    [anon_sym_DASH_EQ] = ACTIONS(3542),
    [anon_sym_LT_LT_EQ] = ACTIONS(3542),
    [anon_sym_GT_GT_EQ] = ACTIONS(3542),
    [anon_sym_AMP_EQ] = ACTIONS(3542),
    [anon_sym_CARET_EQ] = ACTIONS(3542),
    [anon_sym_PIPE_EQ] = ACTIONS(3542),
    [anon_sym_and_eq] = ACTIONS(3540),
    [anon_sym_or_eq] = ACTIONS(3540),
    [anon_sym_xor_eq] = ACTIONS(3540),
    [anon_sym_LT_EQ_GT] = ACTIONS(3542),
    [anon_sym_or] = ACTIONS(3540),
    [anon_sym_and] = ACTIONS(3540),
    [anon_sym_bitor] = ACTIONS(3540),
    [anon_sym_xor] = ACTIONS(3540),
    [anon_sym_bitand] = ACTIONS(3540),
    [anon_sym_not_eq] = ACTIONS(3540),
    [anon_sym_is] = ACTIONS(3540),
    [anon_sym_as] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(3542),
    [anon_sym_PLUS_PLUS] = ACTIONS(3542),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_DOT_STAR] = ACTIONS(3542),
    [anon_sym_DASH_GT] = ACTIONS(3542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3540),
    [anon_sym_let] = ACTIONS(3540),
    [anon_sym_This] = ACTIONS(3540),
  },
  [2737] = {
    [sym_attribute_specifier] = STATE(2882),
    [sym_field_declaration_list] = STATE(2816),
    [sym_virtual_specifier] = STATE(9396),
    [sym_base_class_clause] = STATE(10585),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2895),
    [anon_sym_RPAREN] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_out] = ACTIONS(2893),
    [anon_sym_inout] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(6858),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_EQ] = ACTIONS(2895),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym__Nonnull] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym__Alignas] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_This] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_GT2] = ACTIONS(2895),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_precise] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_groupshared] = ACTIONS(2893),
    [anon_sym_uniform] = ACTIONS(2893),
    [anon_sym_row_major] = ACTIONS(2893),
    [anon_sym_column_major] = ACTIONS(2893),
    [anon_sym_globallycoherent] = ACTIONS(2893),
    [anon_sym_centroid] = ACTIONS(2893),
    [anon_sym_noperspective] = ACTIONS(2893),
    [anon_sym_nointerpolation] = ACTIONS(2893),
    [anon_sym_sample] = ACTIONS(2893),
    [anon_sym_linear] = ACTIONS(2893),
    [anon_sym_snorm] = ACTIONS(2893),
    [anon_sym_unorm] = ACTIONS(2893),
    [anon_sym_point] = ACTIONS(2893),
    [anon_sym_line] = ACTIONS(2893),
    [anon_sym_triangleadj] = ACTIONS(2893),
    [anon_sym_lineadj] = ACTIONS(2893),
    [anon_sym_triangle] = ACTIONS(2893),
  },
  [2738] = {
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3352),
    [anon_sym_COMMA] = ACTIONS(3352),
    [anon_sym_RPAREN] = ACTIONS(3352),
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_COLON] = ACTIONS(3362),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3352),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym___cdecl] = ACTIONS(3362),
    [anon_sym___clrcall] = ACTIONS(3362),
    [anon_sym___stdcall] = ACTIONS(3362),
    [anon_sym___fastcall] = ACTIONS(3362),
    [anon_sym___thiscall] = ACTIONS(3362),
    [anon_sym___vectorcall] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3362),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_EQ] = ACTIONS(3352),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [anon_sym_asm] = ACTIONS(3362),
    [anon_sym___asm__] = ACTIONS(3362),
    [anon_sym___asm] = ACTIONS(3362),
    [anon_sym_DASH_GT] = ACTIONS(3352),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3362),
    [anon_sym_final] = ACTIONS(3362),
    [anon_sym_override] = ACTIONS(3362),
    [anon_sym_explicit] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3362),
    [anon_sym_GT2] = ACTIONS(3352),
    [anon_sym_operator] = ACTIONS(3362),
    [anon_sym_noexcept] = ACTIONS(3362),
    [anon_sym_throw] = ACTIONS(3362),
    [anon_sym_requires] = ACTIONS(3362),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_where] = ACTIONS(3362),
  },
  [2739] = {
    [sym_type_qualifier] = STATE(2740),
    [sym_alignas_qualifier] = STATE(2732),
    [aux_sym__type_definition_type_repeat1] = STATE(2740),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2779),
    [sym_identifier] = ACTIONS(6860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3423),
    [anon_sym_COMMA] = ACTIONS(3423),
    [aux_sym_preproc_if_token2] = ACTIONS(3423),
    [aux_sym_preproc_else_token1] = ACTIONS(3423),
    [aux_sym_preproc_elif_token1] = ACTIONS(3428),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3423),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3423),
    [anon_sym_LPAREN2] = ACTIONS(3423),
    [anon_sym_DASH] = ACTIONS(3428),
    [anon_sym_PLUS] = ACTIONS(3428),
    [anon_sym_STAR] = ACTIONS(3428),
    [anon_sym_SLASH] = ACTIONS(3428),
    [anon_sym_PERCENT] = ACTIONS(3428),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_PIPE] = ACTIONS(3428),
    [anon_sym_CARET] = ACTIONS(3428),
    [anon_sym_AMP] = ACTIONS(3428),
    [anon_sym_EQ_EQ] = ACTIONS(3423),
    [anon_sym_BANG_EQ] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3428),
    [anon_sym_GT_EQ] = ACTIONS(3423),
    [anon_sym_LT_EQ] = ACTIONS(3428),
    [anon_sym_LT] = ACTIONS(3428),
    [anon_sym_LT_LT] = ACTIONS(3428),
    [anon_sym_GT_GT] = ACTIONS(3428),
    [anon_sym___extension__] = ACTIONS(6844),
    [anon_sym___attribute__] = ACTIONS(3428),
    [anon_sym___attribute] = ACTIONS(3428),
    [anon_sym_LBRACE] = ACTIONS(3423),
    [anon_sym_signed] = ACTIONS(6863),
    [anon_sym_unsigned] = ACTIONS(6863),
    [anon_sym_long] = ACTIONS(6863),
    [anon_sym_short] = ACTIONS(6863),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_EQ] = ACTIONS(3428),
    [anon_sym_const] = ACTIONS(6844),
    [anon_sym_constexpr] = ACTIONS(6844),
    [anon_sym_volatile] = ACTIONS(6844),
    [anon_sym_restrict] = ACTIONS(6844),
    [anon_sym___restrict__] = ACTIONS(6844),
    [anon_sym__Atomic] = ACTIONS(6844),
    [anon_sym__Noreturn] = ACTIONS(6844),
    [anon_sym_noreturn] = ACTIONS(6844),
    [anon_sym__Nonnull] = ACTIONS(6844),
    [anon_sym_mutable] = ACTIONS(6844),
    [anon_sym_constinit] = ACTIONS(6844),
    [anon_sym_consteval] = ACTIONS(6844),
    [anon_sym_alignas] = ACTIONS(6848),
    [anon_sym__Alignas] = ACTIONS(6848),
    [sym_primitive_type] = ACTIONS(6865),
    [anon_sym_QMARK] = ACTIONS(3423),
    [anon_sym_STAR_EQ] = ACTIONS(3423),
    [anon_sym_SLASH_EQ] = ACTIONS(3423),
    [anon_sym_PERCENT_EQ] = ACTIONS(3423),
    [anon_sym_PLUS_EQ] = ACTIONS(3423),
    [anon_sym_DASH_EQ] = ACTIONS(3423),
    [anon_sym_LT_LT_EQ] = ACTIONS(3423),
    [anon_sym_GT_GT_EQ] = ACTIONS(3423),
    [anon_sym_AMP_EQ] = ACTIONS(3423),
    [anon_sym_CARET_EQ] = ACTIONS(3423),
    [anon_sym_PIPE_EQ] = ACTIONS(3423),
    [anon_sym_and_eq] = ACTIONS(3428),
    [anon_sym_or_eq] = ACTIONS(3428),
    [anon_sym_xor_eq] = ACTIONS(3428),
    [anon_sym_LT_EQ_GT] = ACTIONS(3423),
    [anon_sym_or] = ACTIONS(3428),
    [anon_sym_and] = ACTIONS(3428),
    [anon_sym_bitor] = ACTIONS(3428),
    [anon_sym_xor] = ACTIONS(3428),
    [anon_sym_bitand] = ACTIONS(3428),
    [anon_sym_not_eq] = ACTIONS(3428),
    [anon_sym_is] = ACTIONS(3428),
    [anon_sym_as] = ACTIONS(3428),
    [anon_sym_DASH_DASH] = ACTIONS(3423),
    [anon_sym_PLUS_PLUS] = ACTIONS(3423),
    [anon_sym_DOT] = ACTIONS(3428),
    [anon_sym_DOT_STAR] = ACTIONS(3423),
    [anon_sym_DASH_GT] = ACTIONS(3423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3428),
    [anon_sym_let] = ACTIONS(3428),
    [anon_sym_This] = ACTIONS(3428),
  },
  [2740] = {
    [sym_type_qualifier] = STATE(2692),
    [sym_alignas_qualifier] = STATE(2732),
    [aux_sym__type_definition_type_repeat1] = STATE(2692),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3182),
    [sym_identifier] = ACTIONS(6867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3542),
    [anon_sym_COMMA] = ACTIONS(3542),
    [aux_sym_preproc_if_token2] = ACTIONS(3542),
    [aux_sym_preproc_else_token1] = ACTIONS(3542),
    [aux_sym_preproc_elif_token1] = ACTIONS(3540),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3542),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3542),
    [anon_sym_LPAREN2] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(3540),
    [anon_sym_SLASH] = ACTIONS(3540),
    [anon_sym_PERCENT] = ACTIONS(3540),
    [anon_sym_PIPE_PIPE] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_PIPE] = ACTIONS(3540),
    [anon_sym_CARET] = ACTIONS(3540),
    [anon_sym_AMP] = ACTIONS(3540),
    [anon_sym_EQ_EQ] = ACTIONS(3542),
    [anon_sym_BANG_EQ] = ACTIONS(3542),
    [anon_sym_GT] = ACTIONS(3540),
    [anon_sym_GT_EQ] = ACTIONS(3542),
    [anon_sym_LT_EQ] = ACTIONS(3540),
    [anon_sym_LT] = ACTIONS(3540),
    [anon_sym_LT_LT] = ACTIONS(3540),
    [anon_sym_GT_GT] = ACTIONS(3540),
    [anon_sym___extension__] = ACTIONS(6844),
    [anon_sym___attribute__] = ACTIONS(3540),
    [anon_sym___attribute] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_signed] = ACTIONS(6870),
    [anon_sym_unsigned] = ACTIONS(6870),
    [anon_sym_long] = ACTIONS(6870),
    [anon_sym_short] = ACTIONS(6870),
    [anon_sym_LBRACK] = ACTIONS(3542),
    [anon_sym_EQ] = ACTIONS(3540),
    [anon_sym_const] = ACTIONS(6844),
    [anon_sym_constexpr] = ACTIONS(6844),
    [anon_sym_volatile] = ACTIONS(6844),
    [anon_sym_restrict] = ACTIONS(6844),
    [anon_sym___restrict__] = ACTIONS(6844),
    [anon_sym__Atomic] = ACTIONS(6844),
    [anon_sym__Noreturn] = ACTIONS(6844),
    [anon_sym_noreturn] = ACTIONS(6844),
    [anon_sym__Nonnull] = ACTIONS(6844),
    [anon_sym_mutable] = ACTIONS(6844),
    [anon_sym_constinit] = ACTIONS(6844),
    [anon_sym_consteval] = ACTIONS(6844),
    [anon_sym_alignas] = ACTIONS(6848),
    [anon_sym__Alignas] = ACTIONS(6848),
    [sym_primitive_type] = ACTIONS(6872),
    [anon_sym_QMARK] = ACTIONS(3542),
    [anon_sym_STAR_EQ] = ACTIONS(3542),
    [anon_sym_SLASH_EQ] = ACTIONS(3542),
    [anon_sym_PERCENT_EQ] = ACTIONS(3542),
    [anon_sym_PLUS_EQ] = ACTIONS(3542),
    [anon_sym_DASH_EQ] = ACTIONS(3542),
    [anon_sym_LT_LT_EQ] = ACTIONS(3542),
    [anon_sym_GT_GT_EQ] = ACTIONS(3542),
    [anon_sym_AMP_EQ] = ACTIONS(3542),
    [anon_sym_CARET_EQ] = ACTIONS(3542),
    [anon_sym_PIPE_EQ] = ACTIONS(3542),
    [anon_sym_and_eq] = ACTIONS(3540),
    [anon_sym_or_eq] = ACTIONS(3540),
    [anon_sym_xor_eq] = ACTIONS(3540),
    [anon_sym_LT_EQ_GT] = ACTIONS(3542),
    [anon_sym_or] = ACTIONS(3540),
    [anon_sym_and] = ACTIONS(3540),
    [anon_sym_bitor] = ACTIONS(3540),
    [anon_sym_xor] = ACTIONS(3540),
    [anon_sym_bitand] = ACTIONS(3540),
    [anon_sym_not_eq] = ACTIONS(3540),
    [anon_sym_is] = ACTIONS(3540),
    [anon_sym_as] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(3542),
    [anon_sym_PLUS_PLUS] = ACTIONS(3542),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_DOT_STAR] = ACTIONS(3542),
    [anon_sym_DASH_GT] = ACTIONS(3542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3540),
    [anon_sym_let] = ACTIONS(3540),
    [anon_sym_This] = ACTIONS(3540),
  },
  [2741] = {
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2314),
    [anon_sym_COMMA] = ACTIONS(2314),
    [anon_sym_RPAREN] = ACTIONS(2314),
    [aux_sym_preproc_if_token2] = ACTIONS(2314),
    [aux_sym_preproc_else_token1] = ACTIONS(2314),
    [aux_sym_preproc_elif_token1] = ACTIONS(2312),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2314),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2314),
    [anon_sym_LPAREN2] = ACTIONS(2314),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_SLASH] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2312),
    [anon_sym_PIPE_PIPE] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2314),
    [anon_sym_PIPE] = ACTIONS(2312),
    [anon_sym_CARET] = ACTIONS(2312),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_EQ_EQ] = ACTIONS(2314),
    [anon_sym_BANG_EQ] = ACTIONS(2314),
    [anon_sym_GT] = ACTIONS(2312),
    [anon_sym_GT_EQ] = ACTIONS(2314),
    [anon_sym_LT_EQ] = ACTIONS(2312),
    [anon_sym_LT] = ACTIONS(2312),
    [anon_sym_LT_LT] = ACTIONS(2312),
    [anon_sym_GT_GT] = ACTIONS(2312),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym___extension__] = ACTIONS(2312),
    [anon_sym___attribute__] = ACTIONS(2312),
    [anon_sym___attribute] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_RBRACE] = ACTIONS(2314),
    [anon_sym_LBRACK] = ACTIONS(2314),
    [anon_sym_RBRACK] = ACTIONS(2314),
    [anon_sym_EQ] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_constexpr] = ACTIONS(2312),
    [anon_sym_volatile] = ACTIONS(2312),
    [anon_sym_restrict] = ACTIONS(2312),
    [anon_sym___restrict__] = ACTIONS(2312),
    [anon_sym__Atomic] = ACTIONS(2312),
    [anon_sym__Noreturn] = ACTIONS(2312),
    [anon_sym_noreturn] = ACTIONS(2312),
    [anon_sym__Nonnull] = ACTIONS(2312),
    [anon_sym_mutable] = ACTIONS(2312),
    [anon_sym_constinit] = ACTIONS(2312),
    [anon_sym_consteval] = ACTIONS(2312),
    [anon_sym_alignas] = ACTIONS(2312),
    [anon_sym__Alignas] = ACTIONS(2312),
    [anon_sym_QMARK] = ACTIONS(2314),
    [anon_sym_STAR_EQ] = ACTIONS(2314),
    [anon_sym_SLASH_EQ] = ACTIONS(2314),
    [anon_sym_PERCENT_EQ] = ACTIONS(2314),
    [anon_sym_PLUS_EQ] = ACTIONS(2314),
    [anon_sym_DASH_EQ] = ACTIONS(2314),
    [anon_sym_LT_LT_EQ] = ACTIONS(2314),
    [anon_sym_GT_GT_EQ] = ACTIONS(2314),
    [anon_sym_AMP_EQ] = ACTIONS(2314),
    [anon_sym_CARET_EQ] = ACTIONS(2314),
    [anon_sym_PIPE_EQ] = ACTIONS(2314),
    [anon_sym_and_eq] = ACTIONS(2312),
    [anon_sym_or_eq] = ACTIONS(2312),
    [anon_sym_xor_eq] = ACTIONS(2312),
    [anon_sym_LT_EQ_GT] = ACTIONS(2314),
    [anon_sym_or] = ACTIONS(2312),
    [anon_sym_and] = ACTIONS(2312),
    [anon_sym_bitor] = ACTIONS(2312),
    [anon_sym_xor] = ACTIONS(2312),
    [anon_sym_bitand] = ACTIONS(2312),
    [anon_sym_not_eq] = ACTIONS(2312),
    [anon_sym_is] = ACTIONS(2312),
    [anon_sym_as] = ACTIONS(2312),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_DOT] = ACTIONS(2312),
    [anon_sym_DOT_STAR] = ACTIONS(2314),
    [anon_sym_DASH_GT] = ACTIONS(2314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_This] = ACTIONS(2312),
    [anon_sym_final] = ACTIONS(2312),
    [anon_sym_override] = ACTIONS(2312),
  },
  [2742] = {
    [sym_identifier] = ACTIONS(2239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2241),
    [anon_sym_COMMA] = ACTIONS(2241),
    [anon_sym_RPAREN] = ACTIONS(2241),
    [aux_sym_preproc_if_token2] = ACTIONS(2241),
    [aux_sym_preproc_else_token1] = ACTIONS(2241),
    [aux_sym_preproc_elif_token1] = ACTIONS(2239),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2241),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2241),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2239),
    [anon_sym_PLUS] = ACTIONS(2239),
    [anon_sym_STAR] = ACTIONS(2239),
    [anon_sym_SLASH] = ACTIONS(2239),
    [anon_sym_PERCENT] = ACTIONS(2239),
    [anon_sym_PIPE_PIPE] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_PIPE] = ACTIONS(2239),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_LT_EQ] = ACTIONS(2239),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_LT_LT] = ACTIONS(2239),
    [anon_sym_GT_GT] = ACTIONS(2239),
    [anon_sym_COLON] = ACTIONS(2239),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym___attribute] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_RBRACE] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2241),
    [anon_sym_RBRACK] = ACTIONS(2241),
    [anon_sym_EQ] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym__Nonnull] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [anon_sym_QMARK] = ACTIONS(2241),
    [anon_sym_STAR_EQ] = ACTIONS(2241),
    [anon_sym_SLASH_EQ] = ACTIONS(2241),
    [anon_sym_PERCENT_EQ] = ACTIONS(2241),
    [anon_sym_PLUS_EQ] = ACTIONS(2241),
    [anon_sym_DASH_EQ] = ACTIONS(2241),
    [anon_sym_LT_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_GT_EQ] = ACTIONS(2241),
    [anon_sym_AMP_EQ] = ACTIONS(2241),
    [anon_sym_CARET_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_EQ] = ACTIONS(2241),
    [anon_sym_and_eq] = ACTIONS(2239),
    [anon_sym_or_eq] = ACTIONS(2239),
    [anon_sym_xor_eq] = ACTIONS(2239),
    [anon_sym_LT_EQ_GT] = ACTIONS(2241),
    [anon_sym_or] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(2239),
    [anon_sym_bitor] = ACTIONS(2239),
    [anon_sym_xor] = ACTIONS(2239),
    [anon_sym_bitand] = ACTIONS(2239),
    [anon_sym_not_eq] = ACTIONS(2239),
    [anon_sym_is] = ACTIONS(2239),
    [anon_sym_as] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2239),
    [anon_sym_DOT_STAR] = ACTIONS(2241),
    [anon_sym_DASH_GT] = ACTIONS(2241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2239),
    [anon_sym_let] = ACTIONS(2239),
    [anon_sym_This] = ACTIONS(2239),
    [anon_sym_final] = ACTIONS(2239),
    [anon_sym_override] = ACTIONS(2239),
  },
  [2743] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2762),
    [sym_identifier] = ACTIONS(3995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3997),
    [anon_sym_COMMA] = ACTIONS(3997),
    [anon_sym_RPAREN] = ACTIONS(3997),
    [anon_sym_LPAREN2] = ACTIONS(3997),
    [anon_sym_TILDE] = ACTIONS(3997),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_AMP] = ACTIONS(3995),
    [anon_sym_COLON] = ACTIONS(3995),
    [anon_sym_SEMI] = ACTIONS(3997),
    [anon_sym___extension__] = ACTIONS(3995),
    [anon_sym_in] = ACTIONS(3995),
    [anon_sym_out] = ACTIONS(3995),
    [anon_sym_inout] = ACTIONS(3995),
    [anon_sym_virtual] = ACTIONS(3995),
    [anon_sym_extern] = ACTIONS(3995),
    [anon_sym___attribute__] = ACTIONS(3995),
    [anon_sym___attribute] = ACTIONS(3995),
    [anon_sym_COLON_COLON] = ACTIONS(3997),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3997),
    [anon_sym___declspec] = ACTIONS(3995),
    [anon_sym___based] = ACTIONS(3995),
    [anon_sym___cdecl] = ACTIONS(3995),
    [anon_sym___clrcall] = ACTIONS(3995),
    [anon_sym___stdcall] = ACTIONS(3995),
    [anon_sym___fastcall] = ACTIONS(3995),
    [anon_sym___thiscall] = ACTIONS(3995),
    [anon_sym___vectorcall] = ACTIONS(3995),
    [anon_sym_LBRACE] = ACTIONS(3997),
    [anon_sym_signed] = ACTIONS(6874),
    [anon_sym_unsigned] = ACTIONS(6874),
    [anon_sym_long] = ACTIONS(6874),
    [anon_sym_short] = ACTIONS(6874),
    [anon_sym_LBRACK] = ACTIONS(3995),
    [anon_sym_static] = ACTIONS(3995),
    [anon_sym_EQ] = ACTIONS(3997),
    [anon_sym_register] = ACTIONS(3995),
    [anon_sym_inline] = ACTIONS(3995),
    [anon_sym___inline] = ACTIONS(3995),
    [anon_sym___inline__] = ACTIONS(3995),
    [anon_sym___forceinline] = ACTIONS(3995),
    [anon_sym_thread_local] = ACTIONS(3995),
    [anon_sym___thread] = ACTIONS(3995),
    [anon_sym_const] = ACTIONS(3995),
    [anon_sym_constexpr] = ACTIONS(3995),
    [anon_sym_volatile] = ACTIONS(3995),
    [anon_sym_restrict] = ACTIONS(3995),
    [anon_sym___restrict__] = ACTIONS(3995),
    [anon_sym__Atomic] = ACTIONS(3995),
    [anon_sym__Noreturn] = ACTIONS(3995),
    [anon_sym_noreturn] = ACTIONS(3995),
    [anon_sym__Nonnull] = ACTIONS(3995),
    [anon_sym_mutable] = ACTIONS(3995),
    [anon_sym_constinit] = ACTIONS(3995),
    [anon_sym_consteval] = ACTIONS(3995),
    [anon_sym_alignas] = ACTIONS(3995),
    [anon_sym__Alignas] = ACTIONS(3995),
    [anon_sym_DOT] = ACTIONS(3995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3995),
    [anon_sym_let] = ACTIONS(3995),
    [anon_sym_This] = ACTIONS(3995),
    [anon_sym_decltype] = ACTIONS(3995),
    [anon_sym_template] = ACTIONS(3995),
    [anon_sym_GT2] = ACTIONS(3997),
    [anon_sym_operator] = ACTIONS(3995),
    [anon_sym_precise] = ACTIONS(3995),
    [anon_sym_shared] = ACTIONS(3995),
    [anon_sym_groupshared] = ACTIONS(3995),
    [anon_sym_uniform] = ACTIONS(3995),
    [anon_sym_row_major] = ACTIONS(3995),
    [anon_sym_column_major] = ACTIONS(3995),
    [anon_sym_globallycoherent] = ACTIONS(3995),
    [anon_sym_centroid] = ACTIONS(3995),
    [anon_sym_noperspective] = ACTIONS(3995),
    [anon_sym_nointerpolation] = ACTIONS(3995),
    [anon_sym_sample] = ACTIONS(3995),
    [anon_sym_linear] = ACTIONS(3995),
    [anon_sym_snorm] = ACTIONS(3995),
    [anon_sym_unorm] = ACTIONS(3995),
    [anon_sym_point] = ACTIONS(3995),
    [anon_sym_line] = ACTIONS(3995),
    [anon_sym_triangleadj] = ACTIONS(3995),
    [anon_sym_lineadj] = ACTIONS(3995),
    [anon_sym_triangle] = ACTIONS(3995),
  },
  [2744] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2745),
    [sym_identifier] = ACTIONS(4053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4051),
    [anon_sym_COMMA] = ACTIONS(4051),
    [anon_sym_RPAREN] = ACTIONS(4051),
    [anon_sym_LPAREN2] = ACTIONS(4051),
    [anon_sym_TILDE] = ACTIONS(4051),
    [anon_sym_STAR] = ACTIONS(4051),
    [anon_sym_AMP_AMP] = ACTIONS(4051),
    [anon_sym_AMP] = ACTIONS(4053),
    [anon_sym_COLON] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4051),
    [anon_sym___extension__] = ACTIONS(4053),
    [anon_sym_in] = ACTIONS(4053),
    [anon_sym_out] = ACTIONS(4053),
    [anon_sym_inout] = ACTIONS(4053),
    [anon_sym_virtual] = ACTIONS(4053),
    [anon_sym_extern] = ACTIONS(4053),
    [anon_sym___attribute__] = ACTIONS(4053),
    [anon_sym___attribute] = ACTIONS(4053),
    [anon_sym_COLON_COLON] = ACTIONS(4051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4051),
    [anon_sym___declspec] = ACTIONS(4053),
    [anon_sym___based] = ACTIONS(4053),
    [anon_sym___cdecl] = ACTIONS(4053),
    [anon_sym___clrcall] = ACTIONS(4053),
    [anon_sym___stdcall] = ACTIONS(4053),
    [anon_sym___fastcall] = ACTIONS(4053),
    [anon_sym___thiscall] = ACTIONS(4053),
    [anon_sym___vectorcall] = ACTIONS(4053),
    [anon_sym_LBRACE] = ACTIONS(4051),
    [anon_sym_signed] = ACTIONS(6876),
    [anon_sym_unsigned] = ACTIONS(6876),
    [anon_sym_long] = ACTIONS(6876),
    [anon_sym_short] = ACTIONS(6876),
    [anon_sym_LBRACK] = ACTIONS(4053),
    [anon_sym_static] = ACTIONS(4053),
    [anon_sym_EQ] = ACTIONS(4051),
    [anon_sym_register] = ACTIONS(4053),
    [anon_sym_inline] = ACTIONS(4053),
    [anon_sym___inline] = ACTIONS(4053),
    [anon_sym___inline__] = ACTIONS(4053),
    [anon_sym___forceinline] = ACTIONS(4053),
    [anon_sym_thread_local] = ACTIONS(4053),
    [anon_sym___thread] = ACTIONS(4053),
    [anon_sym_const] = ACTIONS(4053),
    [anon_sym_constexpr] = ACTIONS(4053),
    [anon_sym_volatile] = ACTIONS(4053),
    [anon_sym_restrict] = ACTIONS(4053),
    [anon_sym___restrict__] = ACTIONS(4053),
    [anon_sym__Atomic] = ACTIONS(4053),
    [anon_sym__Noreturn] = ACTIONS(4053),
    [anon_sym_noreturn] = ACTIONS(4053),
    [anon_sym__Nonnull] = ACTIONS(4053),
    [anon_sym_mutable] = ACTIONS(4053),
    [anon_sym_constinit] = ACTIONS(4053),
    [anon_sym_consteval] = ACTIONS(4053),
    [anon_sym_alignas] = ACTIONS(4053),
    [anon_sym__Alignas] = ACTIONS(4053),
    [anon_sym_DOT] = ACTIONS(4053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4053),
    [anon_sym_let] = ACTIONS(4053),
    [anon_sym_This] = ACTIONS(4053),
    [anon_sym_decltype] = ACTIONS(4053),
    [anon_sym_template] = ACTIONS(4053),
    [anon_sym_GT2] = ACTIONS(4051),
    [anon_sym_operator] = ACTIONS(4053),
    [anon_sym_precise] = ACTIONS(4053),
    [anon_sym_shared] = ACTIONS(4053),
    [anon_sym_groupshared] = ACTIONS(4053),
    [anon_sym_uniform] = ACTIONS(4053),
    [anon_sym_row_major] = ACTIONS(4053),
    [anon_sym_column_major] = ACTIONS(4053),
    [anon_sym_globallycoherent] = ACTIONS(4053),
    [anon_sym_centroid] = ACTIONS(4053),
    [anon_sym_noperspective] = ACTIONS(4053),
    [anon_sym_nointerpolation] = ACTIONS(4053),
    [anon_sym_sample] = ACTIONS(4053),
    [anon_sym_linear] = ACTIONS(4053),
    [anon_sym_snorm] = ACTIONS(4053),
    [anon_sym_unorm] = ACTIONS(4053),
    [anon_sym_point] = ACTIONS(4053),
    [anon_sym_line] = ACTIONS(4053),
    [anon_sym_triangleadj] = ACTIONS(4053),
    [anon_sym_lineadj] = ACTIONS(4053),
    [anon_sym_triangle] = ACTIONS(4053),
  },
  [2745] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2762),
    [sym_identifier] = ACTIONS(4102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4100),
    [anon_sym_COMMA] = ACTIONS(4100),
    [anon_sym_RPAREN] = ACTIONS(4100),
    [anon_sym_LPAREN2] = ACTIONS(4100),
    [anon_sym_TILDE] = ACTIONS(4100),
    [anon_sym_STAR] = ACTIONS(4100),
    [anon_sym_AMP_AMP] = ACTIONS(4100),
    [anon_sym_AMP] = ACTIONS(4102),
    [anon_sym_COLON] = ACTIONS(4102),
    [anon_sym_SEMI] = ACTIONS(4100),
    [anon_sym___extension__] = ACTIONS(4102),
    [anon_sym_in] = ACTIONS(4102),
    [anon_sym_out] = ACTIONS(4102),
    [anon_sym_inout] = ACTIONS(4102),
    [anon_sym_virtual] = ACTIONS(4102),
    [anon_sym_extern] = ACTIONS(4102),
    [anon_sym___attribute__] = ACTIONS(4102),
    [anon_sym___attribute] = ACTIONS(4102),
    [anon_sym_COLON_COLON] = ACTIONS(4100),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4100),
    [anon_sym___declspec] = ACTIONS(4102),
    [anon_sym___based] = ACTIONS(4102),
    [anon_sym___cdecl] = ACTIONS(4102),
    [anon_sym___clrcall] = ACTIONS(4102),
    [anon_sym___stdcall] = ACTIONS(4102),
    [anon_sym___fastcall] = ACTIONS(4102),
    [anon_sym___thiscall] = ACTIONS(4102),
    [anon_sym___vectorcall] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(4100),
    [anon_sym_signed] = ACTIONS(6874),
    [anon_sym_unsigned] = ACTIONS(6874),
    [anon_sym_long] = ACTIONS(6874),
    [anon_sym_short] = ACTIONS(6874),
    [anon_sym_LBRACK] = ACTIONS(4102),
    [anon_sym_static] = ACTIONS(4102),
    [anon_sym_EQ] = ACTIONS(4100),
    [anon_sym_register] = ACTIONS(4102),
    [anon_sym_inline] = ACTIONS(4102),
    [anon_sym___inline] = ACTIONS(4102),
    [anon_sym___inline__] = ACTIONS(4102),
    [anon_sym___forceinline] = ACTIONS(4102),
    [anon_sym_thread_local] = ACTIONS(4102),
    [anon_sym___thread] = ACTIONS(4102),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_constexpr] = ACTIONS(4102),
    [anon_sym_volatile] = ACTIONS(4102),
    [anon_sym_restrict] = ACTIONS(4102),
    [anon_sym___restrict__] = ACTIONS(4102),
    [anon_sym__Atomic] = ACTIONS(4102),
    [anon_sym__Noreturn] = ACTIONS(4102),
    [anon_sym_noreturn] = ACTIONS(4102),
    [anon_sym__Nonnull] = ACTIONS(4102),
    [anon_sym_mutable] = ACTIONS(4102),
    [anon_sym_constinit] = ACTIONS(4102),
    [anon_sym_consteval] = ACTIONS(4102),
    [anon_sym_alignas] = ACTIONS(4102),
    [anon_sym__Alignas] = ACTIONS(4102),
    [anon_sym_DOT] = ACTIONS(4102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4102),
    [anon_sym_let] = ACTIONS(4102),
    [anon_sym_This] = ACTIONS(4102),
    [anon_sym_decltype] = ACTIONS(4102),
    [anon_sym_template] = ACTIONS(4102),
    [anon_sym_GT2] = ACTIONS(4100),
    [anon_sym_operator] = ACTIONS(4102),
    [anon_sym_precise] = ACTIONS(4102),
    [anon_sym_shared] = ACTIONS(4102),
    [anon_sym_groupshared] = ACTIONS(4102),
    [anon_sym_uniform] = ACTIONS(4102),
    [anon_sym_row_major] = ACTIONS(4102),
    [anon_sym_column_major] = ACTIONS(4102),
    [anon_sym_globallycoherent] = ACTIONS(4102),
    [anon_sym_centroid] = ACTIONS(4102),
    [anon_sym_noperspective] = ACTIONS(4102),
    [anon_sym_nointerpolation] = ACTIONS(4102),
    [anon_sym_sample] = ACTIONS(4102),
    [anon_sym_linear] = ACTIONS(4102),
    [anon_sym_snorm] = ACTIONS(4102),
    [anon_sym_unorm] = ACTIONS(4102),
    [anon_sym_point] = ACTIONS(4102),
    [anon_sym_line] = ACTIONS(4102),
    [anon_sym_triangleadj] = ACTIONS(4102),
    [anon_sym_lineadj] = ACTIONS(4102),
    [anon_sym_triangle] = ACTIONS(4102),
  },
  [2746] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2760),
    [sym_identifier] = ACTIONS(4164),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4166),
    [anon_sym_COMMA] = ACTIONS(4166),
    [anon_sym_RPAREN] = ACTIONS(4166),
    [anon_sym_LPAREN2] = ACTIONS(4166),
    [anon_sym_TILDE] = ACTIONS(4166),
    [anon_sym_STAR] = ACTIONS(4166),
    [anon_sym_AMP_AMP] = ACTIONS(4166),
    [anon_sym_AMP] = ACTIONS(4164),
    [anon_sym_COLON] = ACTIONS(4164),
    [anon_sym_SEMI] = ACTIONS(4166),
    [anon_sym___extension__] = ACTIONS(4164),
    [anon_sym_in] = ACTIONS(4164),
    [anon_sym_out] = ACTIONS(4164),
    [anon_sym_inout] = ACTIONS(4164),
    [anon_sym_virtual] = ACTIONS(4164),
    [anon_sym_extern] = ACTIONS(4164),
    [anon_sym___attribute__] = ACTIONS(4164),
    [anon_sym___attribute] = ACTIONS(4164),
    [anon_sym_COLON_COLON] = ACTIONS(4166),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4166),
    [anon_sym___declspec] = ACTIONS(4164),
    [anon_sym___based] = ACTIONS(4164),
    [anon_sym___cdecl] = ACTIONS(4164),
    [anon_sym___clrcall] = ACTIONS(4164),
    [anon_sym___stdcall] = ACTIONS(4164),
    [anon_sym___fastcall] = ACTIONS(4164),
    [anon_sym___thiscall] = ACTIONS(4164),
    [anon_sym___vectorcall] = ACTIONS(4164),
    [anon_sym_LBRACE] = ACTIONS(4166),
    [anon_sym_signed] = ACTIONS(6878),
    [anon_sym_unsigned] = ACTIONS(6878),
    [anon_sym_long] = ACTIONS(6878),
    [anon_sym_short] = ACTIONS(6878),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_static] = ACTIONS(4164),
    [anon_sym_EQ] = ACTIONS(4166),
    [anon_sym_register] = ACTIONS(4164),
    [anon_sym_inline] = ACTIONS(4164),
    [anon_sym___inline] = ACTIONS(4164),
    [anon_sym___inline__] = ACTIONS(4164),
    [anon_sym___forceinline] = ACTIONS(4164),
    [anon_sym_thread_local] = ACTIONS(4164),
    [anon_sym___thread] = ACTIONS(4164),
    [anon_sym_const] = ACTIONS(4164),
    [anon_sym_constexpr] = ACTIONS(4164),
    [anon_sym_volatile] = ACTIONS(4164),
    [anon_sym_restrict] = ACTIONS(4164),
    [anon_sym___restrict__] = ACTIONS(4164),
    [anon_sym__Atomic] = ACTIONS(4164),
    [anon_sym__Noreturn] = ACTIONS(4164),
    [anon_sym_noreturn] = ACTIONS(4164),
    [anon_sym__Nonnull] = ACTIONS(4164),
    [anon_sym_mutable] = ACTIONS(4164),
    [anon_sym_constinit] = ACTIONS(4164),
    [anon_sym_consteval] = ACTIONS(4164),
    [anon_sym_alignas] = ACTIONS(4164),
    [anon_sym__Alignas] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4164),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4164),
    [anon_sym_let] = ACTIONS(4164),
    [anon_sym_This] = ACTIONS(4164),
    [anon_sym_decltype] = ACTIONS(4164),
    [anon_sym_template] = ACTIONS(4164),
    [anon_sym_GT2] = ACTIONS(4166),
    [anon_sym_operator] = ACTIONS(4164),
    [anon_sym_precise] = ACTIONS(4164),
    [anon_sym_shared] = ACTIONS(4164),
    [anon_sym_groupshared] = ACTIONS(4164),
    [anon_sym_uniform] = ACTIONS(4164),
    [anon_sym_row_major] = ACTIONS(4164),
    [anon_sym_column_major] = ACTIONS(4164),
    [anon_sym_globallycoherent] = ACTIONS(4164),
    [anon_sym_centroid] = ACTIONS(4164),
    [anon_sym_noperspective] = ACTIONS(4164),
    [anon_sym_nointerpolation] = ACTIONS(4164),
    [anon_sym_sample] = ACTIONS(4164),
    [anon_sym_linear] = ACTIONS(4164),
    [anon_sym_snorm] = ACTIONS(4164),
    [anon_sym_unorm] = ACTIONS(4164),
    [anon_sym_point] = ACTIONS(4164),
    [anon_sym_line] = ACTIONS(4164),
    [anon_sym_triangleadj] = ACTIONS(4164),
    [anon_sym_lineadj] = ACTIONS(4164),
    [anon_sym_triangle] = ACTIONS(4164),
  },
  [2747] = {
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_COMMA] = ACTIONS(2282),
    [anon_sym_RPAREN] = ACTIONS(2282),
    [aux_sym_preproc_if_token2] = ACTIONS(2282),
    [aux_sym_preproc_else_token1] = ACTIONS(2282),
    [aux_sym_preproc_elif_token1] = ACTIONS(2280),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2282),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2282),
    [anon_sym_LPAREN2] = ACTIONS(2282),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2280),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_PERCENT] = ACTIONS(2280),
    [anon_sym_PIPE_PIPE] = ACTIONS(2282),
    [anon_sym_AMP_AMP] = ACTIONS(2282),
    [anon_sym_PIPE] = ACTIONS(2280),
    [anon_sym_CARET] = ACTIONS(2280),
    [anon_sym_AMP] = ACTIONS(2280),
    [anon_sym_EQ_EQ] = ACTIONS(2282),
    [anon_sym_BANG_EQ] = ACTIONS(2282),
    [anon_sym_GT] = ACTIONS(2280),
    [anon_sym_GT_EQ] = ACTIONS(2282),
    [anon_sym_LT_EQ] = ACTIONS(2280),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_LT_LT] = ACTIONS(2280),
    [anon_sym_GT_GT] = ACTIONS(2280),
    [anon_sym_COLON] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(2280),
    [anon_sym___attribute__] = ACTIONS(2280),
    [anon_sym___attribute] = ACTIONS(2280),
    [anon_sym_COLON_COLON] = ACTIONS(2282),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_RBRACE] = ACTIONS(2282),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_RBRACK] = ACTIONS(2282),
    [anon_sym_EQ] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_constexpr] = ACTIONS(2280),
    [anon_sym_volatile] = ACTIONS(2280),
    [anon_sym_restrict] = ACTIONS(2280),
    [anon_sym___restrict__] = ACTIONS(2280),
    [anon_sym__Atomic] = ACTIONS(2280),
    [anon_sym__Noreturn] = ACTIONS(2280),
    [anon_sym_noreturn] = ACTIONS(2280),
    [anon_sym__Nonnull] = ACTIONS(2280),
    [anon_sym_mutable] = ACTIONS(2280),
    [anon_sym_constinit] = ACTIONS(2280),
    [anon_sym_consteval] = ACTIONS(2280),
    [anon_sym_alignas] = ACTIONS(2280),
    [anon_sym__Alignas] = ACTIONS(2280),
    [anon_sym_QMARK] = ACTIONS(2282),
    [anon_sym_STAR_EQ] = ACTIONS(2282),
    [anon_sym_SLASH_EQ] = ACTIONS(2282),
    [anon_sym_PERCENT_EQ] = ACTIONS(2282),
    [anon_sym_PLUS_EQ] = ACTIONS(2282),
    [anon_sym_DASH_EQ] = ACTIONS(2282),
    [anon_sym_LT_LT_EQ] = ACTIONS(2282),
    [anon_sym_GT_GT_EQ] = ACTIONS(2282),
    [anon_sym_AMP_EQ] = ACTIONS(2282),
    [anon_sym_CARET_EQ] = ACTIONS(2282),
    [anon_sym_PIPE_EQ] = ACTIONS(2282),
    [anon_sym_and_eq] = ACTIONS(2280),
    [anon_sym_or_eq] = ACTIONS(2280),
    [anon_sym_xor_eq] = ACTIONS(2280),
    [anon_sym_LT_EQ_GT] = ACTIONS(2282),
    [anon_sym_or] = ACTIONS(2280),
    [anon_sym_and] = ACTIONS(2280),
    [anon_sym_bitor] = ACTIONS(2280),
    [anon_sym_xor] = ACTIONS(2280),
    [anon_sym_bitand] = ACTIONS(2280),
    [anon_sym_not_eq] = ACTIONS(2280),
    [anon_sym_is] = ACTIONS(2280),
    [anon_sym_as] = ACTIONS(2280),
    [anon_sym_DASH_DASH] = ACTIONS(2282),
    [anon_sym_PLUS_PLUS] = ACTIONS(2282),
    [anon_sym_DOT] = ACTIONS(2280),
    [anon_sym_DOT_STAR] = ACTIONS(2282),
    [anon_sym_DASH_GT] = ACTIONS(2282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_This] = ACTIONS(2280),
    [anon_sym_final] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
  },
  [2748] = {
    [sym_identifier] = ACTIONS(2284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2286),
    [anon_sym_COMMA] = ACTIONS(2286),
    [anon_sym_RPAREN] = ACTIONS(2286),
    [aux_sym_preproc_if_token2] = ACTIONS(2286),
    [aux_sym_preproc_else_token1] = ACTIONS(2286),
    [aux_sym_preproc_elif_token1] = ACTIONS(2284),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2286),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2286),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2284),
    [anon_sym_SLASH] = ACTIONS(2284),
    [anon_sym_PERCENT] = ACTIONS(2284),
    [anon_sym_PIPE_PIPE] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2284),
    [anon_sym_CARET] = ACTIONS(2284),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_EQ_EQ] = ACTIONS(2286),
    [anon_sym_BANG_EQ] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2284),
    [anon_sym_GT_EQ] = ACTIONS(2286),
    [anon_sym_LT_EQ] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2284),
    [anon_sym_LT_LT] = ACTIONS(2284),
    [anon_sym_GT_GT] = ACTIONS(2284),
    [anon_sym_COLON] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_RBRACK] = ACTIONS(2286),
    [anon_sym_EQ] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [anon_sym_QMARK] = ACTIONS(2286),
    [anon_sym_STAR_EQ] = ACTIONS(2286),
    [anon_sym_SLASH_EQ] = ACTIONS(2286),
    [anon_sym_PERCENT_EQ] = ACTIONS(2286),
    [anon_sym_PLUS_EQ] = ACTIONS(2286),
    [anon_sym_DASH_EQ] = ACTIONS(2286),
    [anon_sym_LT_LT_EQ] = ACTIONS(2286),
    [anon_sym_GT_GT_EQ] = ACTIONS(2286),
    [anon_sym_AMP_EQ] = ACTIONS(2286),
    [anon_sym_CARET_EQ] = ACTIONS(2286),
    [anon_sym_PIPE_EQ] = ACTIONS(2286),
    [anon_sym_and_eq] = ACTIONS(2284),
    [anon_sym_or_eq] = ACTIONS(2284),
    [anon_sym_xor_eq] = ACTIONS(2284),
    [anon_sym_LT_EQ_GT] = ACTIONS(2286),
    [anon_sym_or] = ACTIONS(2284),
    [anon_sym_and] = ACTIONS(2284),
    [anon_sym_bitor] = ACTIONS(2284),
    [anon_sym_xor] = ACTIONS(2284),
    [anon_sym_bitand] = ACTIONS(2284),
    [anon_sym_not_eq] = ACTIONS(2284),
    [anon_sym_is] = ACTIONS(2284),
    [anon_sym_as] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_DOT] = ACTIONS(2284),
    [anon_sym_DOT_STAR] = ACTIONS(2286),
    [anon_sym_DASH_GT] = ACTIONS(2286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_This] = ACTIONS(2284),
    [anon_sym_final] = ACTIONS(2284),
    [anon_sym_override] = ACTIONS(2284),
  },
  [2749] = {
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2290),
    [anon_sym_COMMA] = ACTIONS(2290),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [aux_sym_preproc_if_token2] = ACTIONS(2290),
    [aux_sym_preproc_else_token1] = ACTIONS(2290),
    [aux_sym_preproc_elif_token1] = ACTIONS(2288),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2290),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2290),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_PERCENT] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_CARET] = ACTIONS(2288),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_EQ_EQ] = ACTIONS(2290),
    [anon_sym_BANG_EQ] = ACTIONS(2290),
    [anon_sym_GT] = ACTIONS(2288),
    [anon_sym_GT_EQ] = ACTIONS(2290),
    [anon_sym_LT_EQ] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(2288),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_COLON] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_RBRACE] = ACTIONS(2290),
    [anon_sym_LBRACK] = ACTIONS(2290),
    [anon_sym_RBRACK] = ACTIONS(2290),
    [anon_sym_EQ] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [anon_sym_QMARK] = ACTIONS(2290),
    [anon_sym_STAR_EQ] = ACTIONS(2290),
    [anon_sym_SLASH_EQ] = ACTIONS(2290),
    [anon_sym_PERCENT_EQ] = ACTIONS(2290),
    [anon_sym_PLUS_EQ] = ACTIONS(2290),
    [anon_sym_DASH_EQ] = ACTIONS(2290),
    [anon_sym_LT_LT_EQ] = ACTIONS(2290),
    [anon_sym_GT_GT_EQ] = ACTIONS(2290),
    [anon_sym_AMP_EQ] = ACTIONS(2290),
    [anon_sym_CARET_EQ] = ACTIONS(2290),
    [anon_sym_PIPE_EQ] = ACTIONS(2290),
    [anon_sym_and_eq] = ACTIONS(2288),
    [anon_sym_or_eq] = ACTIONS(2288),
    [anon_sym_xor_eq] = ACTIONS(2288),
    [anon_sym_LT_EQ_GT] = ACTIONS(2290),
    [anon_sym_or] = ACTIONS(2288),
    [anon_sym_and] = ACTIONS(2288),
    [anon_sym_bitor] = ACTIONS(2288),
    [anon_sym_xor] = ACTIONS(2288),
    [anon_sym_bitand] = ACTIONS(2288),
    [anon_sym_not_eq] = ACTIONS(2288),
    [anon_sym_is] = ACTIONS(2288),
    [anon_sym_as] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_DOT] = ACTIONS(2288),
    [anon_sym_DOT_STAR] = ACTIONS(2290),
    [anon_sym_DASH_GT] = ACTIONS(2290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_This] = ACTIONS(2288),
    [anon_sym_final] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
  },
  [2750] = {
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2294),
    [anon_sym_COMMA] = ACTIONS(2294),
    [anon_sym_RPAREN] = ACTIONS(2294),
    [aux_sym_preproc_if_token2] = ACTIONS(2294),
    [aux_sym_preproc_else_token1] = ACTIONS(2294),
    [aux_sym_preproc_elif_token1] = ACTIONS(2292),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2294),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2294),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2292),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_PERCENT] = ACTIONS(2292),
    [anon_sym_PIPE_PIPE] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_PIPE] = ACTIONS(2292),
    [anon_sym_CARET] = ACTIONS(2292),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_EQ_EQ] = ACTIONS(2294),
    [anon_sym_BANG_EQ] = ACTIONS(2294),
    [anon_sym_GT] = ACTIONS(2292),
    [anon_sym_GT_EQ] = ACTIONS(2294),
    [anon_sym_LT_EQ] = ACTIONS(2292),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_LT_LT] = ACTIONS(2292),
    [anon_sym_GT_GT] = ACTIONS(2292),
    [anon_sym_COLON] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym___attribute] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_LBRACK] = ACTIONS(2294),
    [anon_sym_RBRACK] = ACTIONS(2294),
    [anon_sym_EQ] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym__Nonnull] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [anon_sym_QMARK] = ACTIONS(2294),
    [anon_sym_STAR_EQ] = ACTIONS(2294),
    [anon_sym_SLASH_EQ] = ACTIONS(2294),
    [anon_sym_PERCENT_EQ] = ACTIONS(2294),
    [anon_sym_PLUS_EQ] = ACTIONS(2294),
    [anon_sym_DASH_EQ] = ACTIONS(2294),
    [anon_sym_LT_LT_EQ] = ACTIONS(2294),
    [anon_sym_GT_GT_EQ] = ACTIONS(2294),
    [anon_sym_AMP_EQ] = ACTIONS(2294),
    [anon_sym_CARET_EQ] = ACTIONS(2294),
    [anon_sym_PIPE_EQ] = ACTIONS(2294),
    [anon_sym_and_eq] = ACTIONS(2292),
    [anon_sym_or_eq] = ACTIONS(2292),
    [anon_sym_xor_eq] = ACTIONS(2292),
    [anon_sym_LT_EQ_GT] = ACTIONS(2294),
    [anon_sym_or] = ACTIONS(2292),
    [anon_sym_and] = ACTIONS(2292),
    [anon_sym_bitor] = ACTIONS(2292),
    [anon_sym_xor] = ACTIONS(2292),
    [anon_sym_bitand] = ACTIONS(2292),
    [anon_sym_not_eq] = ACTIONS(2292),
    [anon_sym_is] = ACTIONS(2292),
    [anon_sym_as] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_DOT] = ACTIONS(2292),
    [anon_sym_DOT_STAR] = ACTIONS(2294),
    [anon_sym_DASH_GT] = ACTIONS(2294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_This] = ACTIONS(2292),
    [anon_sym_final] = ACTIONS(2292),
    [anon_sym_override] = ACTIONS(2292),
  },
  [2751] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2761),
    [sym_identifier] = ACTIONS(4178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4180),
    [anon_sym_COMMA] = ACTIONS(4180),
    [anon_sym_RPAREN] = ACTIONS(4180),
    [anon_sym_LPAREN2] = ACTIONS(4180),
    [anon_sym_TILDE] = ACTIONS(4180),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_AMP] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4178),
    [anon_sym_SEMI] = ACTIONS(4180),
    [anon_sym___extension__] = ACTIONS(4178),
    [anon_sym_in] = ACTIONS(4178),
    [anon_sym_out] = ACTIONS(4178),
    [anon_sym_inout] = ACTIONS(4178),
    [anon_sym_virtual] = ACTIONS(4178),
    [anon_sym_extern] = ACTIONS(4178),
    [anon_sym___attribute__] = ACTIONS(4178),
    [anon_sym___attribute] = ACTIONS(4178),
    [anon_sym_COLON_COLON] = ACTIONS(4180),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4180),
    [anon_sym___declspec] = ACTIONS(4178),
    [anon_sym___based] = ACTIONS(4178),
    [anon_sym___cdecl] = ACTIONS(4178),
    [anon_sym___clrcall] = ACTIONS(4178),
    [anon_sym___stdcall] = ACTIONS(4178),
    [anon_sym___fastcall] = ACTIONS(4178),
    [anon_sym___thiscall] = ACTIONS(4178),
    [anon_sym___vectorcall] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_signed] = ACTIONS(6880),
    [anon_sym_unsigned] = ACTIONS(6880),
    [anon_sym_long] = ACTIONS(6880),
    [anon_sym_short] = ACTIONS(6880),
    [anon_sym_LBRACK] = ACTIONS(4178),
    [anon_sym_static] = ACTIONS(4178),
    [anon_sym_EQ] = ACTIONS(4180),
    [anon_sym_register] = ACTIONS(4178),
    [anon_sym_inline] = ACTIONS(4178),
    [anon_sym___inline] = ACTIONS(4178),
    [anon_sym___inline__] = ACTIONS(4178),
    [anon_sym___forceinline] = ACTIONS(4178),
    [anon_sym_thread_local] = ACTIONS(4178),
    [anon_sym___thread] = ACTIONS(4178),
    [anon_sym_const] = ACTIONS(4178),
    [anon_sym_constexpr] = ACTIONS(4178),
    [anon_sym_volatile] = ACTIONS(4178),
    [anon_sym_restrict] = ACTIONS(4178),
    [anon_sym___restrict__] = ACTIONS(4178),
    [anon_sym__Atomic] = ACTIONS(4178),
    [anon_sym__Noreturn] = ACTIONS(4178),
    [anon_sym_noreturn] = ACTIONS(4178),
    [anon_sym__Nonnull] = ACTIONS(4178),
    [anon_sym_mutable] = ACTIONS(4178),
    [anon_sym_constinit] = ACTIONS(4178),
    [anon_sym_consteval] = ACTIONS(4178),
    [anon_sym_alignas] = ACTIONS(4178),
    [anon_sym__Alignas] = ACTIONS(4178),
    [anon_sym_DOT] = ACTIONS(4178),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4178),
    [anon_sym_let] = ACTIONS(4178),
    [anon_sym_This] = ACTIONS(4178),
    [anon_sym_decltype] = ACTIONS(4178),
    [anon_sym_template] = ACTIONS(4178),
    [anon_sym_GT2] = ACTIONS(4180),
    [anon_sym_operator] = ACTIONS(4178),
    [anon_sym_precise] = ACTIONS(4178),
    [anon_sym_shared] = ACTIONS(4178),
    [anon_sym_groupshared] = ACTIONS(4178),
    [anon_sym_uniform] = ACTIONS(4178),
    [anon_sym_row_major] = ACTIONS(4178),
    [anon_sym_column_major] = ACTIONS(4178),
    [anon_sym_globallycoherent] = ACTIONS(4178),
    [anon_sym_centroid] = ACTIONS(4178),
    [anon_sym_noperspective] = ACTIONS(4178),
    [anon_sym_nointerpolation] = ACTIONS(4178),
    [anon_sym_sample] = ACTIONS(4178),
    [anon_sym_linear] = ACTIONS(4178),
    [anon_sym_snorm] = ACTIONS(4178),
    [anon_sym_unorm] = ACTIONS(4178),
    [anon_sym_point] = ACTIONS(4178),
    [anon_sym_line] = ACTIONS(4178),
    [anon_sym_triangleadj] = ACTIONS(4178),
    [anon_sym_lineadj] = ACTIONS(4178),
    [anon_sym_triangle] = ACTIONS(4178),
  },
  [2752] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2762),
    [sym_identifier] = ACTIONS(4185),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4187),
    [anon_sym_COMMA] = ACTIONS(4187),
    [anon_sym_RPAREN] = ACTIONS(4187),
    [anon_sym_LPAREN2] = ACTIONS(4187),
    [anon_sym_TILDE] = ACTIONS(4187),
    [anon_sym_STAR] = ACTIONS(4187),
    [anon_sym_AMP_AMP] = ACTIONS(4187),
    [anon_sym_AMP] = ACTIONS(4185),
    [anon_sym_COLON] = ACTIONS(4185),
    [anon_sym_SEMI] = ACTIONS(4187),
    [anon_sym___extension__] = ACTIONS(4185),
    [anon_sym_in] = ACTIONS(4185),
    [anon_sym_out] = ACTIONS(4185),
    [anon_sym_inout] = ACTIONS(4185),
    [anon_sym_virtual] = ACTIONS(4185),
    [anon_sym_extern] = ACTIONS(4185),
    [anon_sym___attribute__] = ACTIONS(4185),
    [anon_sym___attribute] = ACTIONS(4185),
    [anon_sym_COLON_COLON] = ACTIONS(4187),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4187),
    [anon_sym___declspec] = ACTIONS(4185),
    [anon_sym___based] = ACTIONS(4185),
    [anon_sym___cdecl] = ACTIONS(4185),
    [anon_sym___clrcall] = ACTIONS(4185),
    [anon_sym___stdcall] = ACTIONS(4185),
    [anon_sym___fastcall] = ACTIONS(4185),
    [anon_sym___thiscall] = ACTIONS(4185),
    [anon_sym___vectorcall] = ACTIONS(4185),
    [anon_sym_LBRACE] = ACTIONS(4187),
    [anon_sym_signed] = ACTIONS(6874),
    [anon_sym_unsigned] = ACTIONS(6874),
    [anon_sym_long] = ACTIONS(6874),
    [anon_sym_short] = ACTIONS(6874),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [anon_sym_static] = ACTIONS(4185),
    [anon_sym_EQ] = ACTIONS(4187),
    [anon_sym_register] = ACTIONS(4185),
    [anon_sym_inline] = ACTIONS(4185),
    [anon_sym___inline] = ACTIONS(4185),
    [anon_sym___inline__] = ACTIONS(4185),
    [anon_sym___forceinline] = ACTIONS(4185),
    [anon_sym_thread_local] = ACTIONS(4185),
    [anon_sym___thread] = ACTIONS(4185),
    [anon_sym_const] = ACTIONS(4185),
    [anon_sym_constexpr] = ACTIONS(4185),
    [anon_sym_volatile] = ACTIONS(4185),
    [anon_sym_restrict] = ACTIONS(4185),
    [anon_sym___restrict__] = ACTIONS(4185),
    [anon_sym__Atomic] = ACTIONS(4185),
    [anon_sym__Noreturn] = ACTIONS(4185),
    [anon_sym_noreturn] = ACTIONS(4185),
    [anon_sym__Nonnull] = ACTIONS(4185),
    [anon_sym_mutable] = ACTIONS(4185),
    [anon_sym_constinit] = ACTIONS(4185),
    [anon_sym_consteval] = ACTIONS(4185),
    [anon_sym_alignas] = ACTIONS(4185),
    [anon_sym__Alignas] = ACTIONS(4185),
    [anon_sym_DOT] = ACTIONS(4185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4185),
    [anon_sym_let] = ACTIONS(4185),
    [anon_sym_This] = ACTIONS(4185),
    [anon_sym_decltype] = ACTIONS(4185),
    [anon_sym_template] = ACTIONS(4185),
    [anon_sym_GT2] = ACTIONS(4187),
    [anon_sym_operator] = ACTIONS(4185),
    [anon_sym_precise] = ACTIONS(4185),
    [anon_sym_shared] = ACTIONS(4185),
    [anon_sym_groupshared] = ACTIONS(4185),
    [anon_sym_uniform] = ACTIONS(4185),
    [anon_sym_row_major] = ACTIONS(4185),
    [anon_sym_column_major] = ACTIONS(4185),
    [anon_sym_globallycoherent] = ACTIONS(4185),
    [anon_sym_centroid] = ACTIONS(4185),
    [anon_sym_noperspective] = ACTIONS(4185),
    [anon_sym_nointerpolation] = ACTIONS(4185),
    [anon_sym_sample] = ACTIONS(4185),
    [anon_sym_linear] = ACTIONS(4185),
    [anon_sym_snorm] = ACTIONS(4185),
    [anon_sym_unorm] = ACTIONS(4185),
    [anon_sym_point] = ACTIONS(4185),
    [anon_sym_line] = ACTIONS(4185),
    [anon_sym_triangleadj] = ACTIONS(4185),
    [anon_sym_lineadj] = ACTIONS(4185),
    [anon_sym_triangle] = ACTIONS(4185),
  },
  [2753] = {
    [sym_identifier] = ACTIONS(2296),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2298),
    [anon_sym_COMMA] = ACTIONS(2298),
    [anon_sym_RPAREN] = ACTIONS(2298),
    [aux_sym_preproc_if_token2] = ACTIONS(2298),
    [aux_sym_preproc_else_token1] = ACTIONS(2298),
    [aux_sym_preproc_elif_token1] = ACTIONS(2296),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2298),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2298),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2296),
    [anon_sym_SLASH] = ACTIONS(2296),
    [anon_sym_PERCENT] = ACTIONS(2296),
    [anon_sym_PIPE_PIPE] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_PIPE] = ACTIONS(2296),
    [anon_sym_CARET] = ACTIONS(2296),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_EQ_EQ] = ACTIONS(2298),
    [anon_sym_BANG_EQ] = ACTIONS(2298),
    [anon_sym_GT] = ACTIONS(2296),
    [anon_sym_GT_EQ] = ACTIONS(2298),
    [anon_sym_LT_EQ] = ACTIONS(2296),
    [anon_sym_LT] = ACTIONS(2296),
    [anon_sym_LT_LT] = ACTIONS(2296),
    [anon_sym_GT_GT] = ACTIONS(2296),
    [anon_sym_COLON] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2298),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym___attribute] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_RBRACE] = ACTIONS(2298),
    [anon_sym_LBRACK] = ACTIONS(2298),
    [anon_sym_RBRACK] = ACTIONS(2298),
    [anon_sym_EQ] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym__Nonnull] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [anon_sym_QMARK] = ACTIONS(2298),
    [anon_sym_STAR_EQ] = ACTIONS(2298),
    [anon_sym_SLASH_EQ] = ACTIONS(2298),
    [anon_sym_PERCENT_EQ] = ACTIONS(2298),
    [anon_sym_PLUS_EQ] = ACTIONS(2298),
    [anon_sym_DASH_EQ] = ACTIONS(2298),
    [anon_sym_LT_LT_EQ] = ACTIONS(2298),
    [anon_sym_GT_GT_EQ] = ACTIONS(2298),
    [anon_sym_AMP_EQ] = ACTIONS(2298),
    [anon_sym_CARET_EQ] = ACTIONS(2298),
    [anon_sym_PIPE_EQ] = ACTIONS(2298),
    [anon_sym_and_eq] = ACTIONS(2296),
    [anon_sym_or_eq] = ACTIONS(2296),
    [anon_sym_xor_eq] = ACTIONS(2296),
    [anon_sym_LT_EQ_GT] = ACTIONS(2298),
    [anon_sym_or] = ACTIONS(2296),
    [anon_sym_and] = ACTIONS(2296),
    [anon_sym_bitor] = ACTIONS(2296),
    [anon_sym_xor] = ACTIONS(2296),
    [anon_sym_bitand] = ACTIONS(2296),
    [anon_sym_not_eq] = ACTIONS(2296),
    [anon_sym_is] = ACTIONS(2296),
    [anon_sym_as] = ACTIONS(2296),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_DOT] = ACTIONS(2296),
    [anon_sym_DOT_STAR] = ACTIONS(2298),
    [anon_sym_DASH_GT] = ACTIONS(2298),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_This] = ACTIONS(2296),
    [anon_sym_final] = ACTIONS(2296),
    [anon_sym_override] = ACTIONS(2296),
  },
  [2754] = {
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2266),
    [anon_sym_COMMA] = ACTIONS(2266),
    [anon_sym_RPAREN] = ACTIONS(2266),
    [aux_sym_preproc_if_token2] = ACTIONS(2266),
    [aux_sym_preproc_else_token1] = ACTIONS(2266),
    [aux_sym_preproc_elif_token1] = ACTIONS(2264),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2266),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2266),
    [anon_sym_LPAREN2] = ACTIONS(2266),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2264),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_PERCENT] = ACTIONS(2264),
    [anon_sym_PIPE_PIPE] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2266),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_CARET] = ACTIONS(2264),
    [anon_sym_AMP] = ACTIONS(2264),
    [anon_sym_EQ_EQ] = ACTIONS(2266),
    [anon_sym_BANG_EQ] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(2264),
    [anon_sym_GT_EQ] = ACTIONS(2266),
    [anon_sym_LT_EQ] = ACTIONS(2264),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_LT_LT] = ACTIONS(2264),
    [anon_sym_GT_GT] = ACTIONS(2264),
    [anon_sym_COLON] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2266),
    [anon_sym___extension__] = ACTIONS(2264),
    [anon_sym___attribute__] = ACTIONS(2264),
    [anon_sym___attribute] = ACTIONS(2264),
    [anon_sym_COLON_COLON] = ACTIONS(2266),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_RBRACE] = ACTIONS(2266),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_RBRACK] = ACTIONS(2266),
    [anon_sym_EQ] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_constexpr] = ACTIONS(2264),
    [anon_sym_volatile] = ACTIONS(2264),
    [anon_sym_restrict] = ACTIONS(2264),
    [anon_sym___restrict__] = ACTIONS(2264),
    [anon_sym__Atomic] = ACTIONS(2264),
    [anon_sym__Noreturn] = ACTIONS(2264),
    [anon_sym_noreturn] = ACTIONS(2264),
    [anon_sym__Nonnull] = ACTIONS(2264),
    [anon_sym_mutable] = ACTIONS(2264),
    [anon_sym_constinit] = ACTIONS(2264),
    [anon_sym_consteval] = ACTIONS(2264),
    [anon_sym_alignas] = ACTIONS(2264),
    [anon_sym__Alignas] = ACTIONS(2264),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_STAR_EQ] = ACTIONS(2266),
    [anon_sym_SLASH_EQ] = ACTIONS(2266),
    [anon_sym_PERCENT_EQ] = ACTIONS(2266),
    [anon_sym_PLUS_EQ] = ACTIONS(2266),
    [anon_sym_DASH_EQ] = ACTIONS(2266),
    [anon_sym_LT_LT_EQ] = ACTIONS(2266),
    [anon_sym_GT_GT_EQ] = ACTIONS(2266),
    [anon_sym_AMP_EQ] = ACTIONS(2266),
    [anon_sym_CARET_EQ] = ACTIONS(2266),
    [anon_sym_PIPE_EQ] = ACTIONS(2266),
    [anon_sym_and_eq] = ACTIONS(2264),
    [anon_sym_or_eq] = ACTIONS(2264),
    [anon_sym_xor_eq] = ACTIONS(2264),
    [anon_sym_LT_EQ_GT] = ACTIONS(2266),
    [anon_sym_or] = ACTIONS(2264),
    [anon_sym_and] = ACTIONS(2264),
    [anon_sym_bitor] = ACTIONS(2264),
    [anon_sym_xor] = ACTIONS(2264),
    [anon_sym_bitand] = ACTIONS(2264),
    [anon_sym_not_eq] = ACTIONS(2264),
    [anon_sym_is] = ACTIONS(2264),
    [anon_sym_as] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2266),
    [anon_sym_PLUS_PLUS] = ACTIONS(2266),
    [anon_sym_DOT] = ACTIONS(2264),
    [anon_sym_DOT_STAR] = ACTIONS(2266),
    [anon_sym_DASH_GT] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_This] = ACTIONS(2264),
    [anon_sym_final] = ACTIONS(2264),
    [anon_sym_override] = ACTIONS(2264),
  },
  [2755] = {
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2302),
    [anon_sym_COMMA] = ACTIONS(2302),
    [anon_sym_RPAREN] = ACTIONS(2302),
    [aux_sym_preproc_if_token2] = ACTIONS(2302),
    [aux_sym_preproc_else_token1] = ACTIONS(2302),
    [aux_sym_preproc_elif_token1] = ACTIONS(2300),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2302),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2302),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_PIPE_PIPE] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_PIPE] = ACTIONS(2300),
    [anon_sym_CARET] = ACTIONS(2300),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_EQ_EQ] = ACTIONS(2302),
    [anon_sym_BANG_EQ] = ACTIONS(2302),
    [anon_sym_GT] = ACTIONS(2300),
    [anon_sym_GT_EQ] = ACTIONS(2302),
    [anon_sym_LT_EQ] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_LT_LT] = ACTIONS(2300),
    [anon_sym_GT_GT] = ACTIONS(2300),
    [anon_sym_COLON] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym___attribute] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_RBRACE] = ACTIONS(2302),
    [anon_sym_LBRACK] = ACTIONS(2302),
    [anon_sym_RBRACK] = ACTIONS(2302),
    [anon_sym_EQ] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym__Nonnull] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [anon_sym_QMARK] = ACTIONS(2302),
    [anon_sym_STAR_EQ] = ACTIONS(2302),
    [anon_sym_SLASH_EQ] = ACTIONS(2302),
    [anon_sym_PERCENT_EQ] = ACTIONS(2302),
    [anon_sym_PLUS_EQ] = ACTIONS(2302),
    [anon_sym_DASH_EQ] = ACTIONS(2302),
    [anon_sym_LT_LT_EQ] = ACTIONS(2302),
    [anon_sym_GT_GT_EQ] = ACTIONS(2302),
    [anon_sym_AMP_EQ] = ACTIONS(2302),
    [anon_sym_CARET_EQ] = ACTIONS(2302),
    [anon_sym_PIPE_EQ] = ACTIONS(2302),
    [anon_sym_and_eq] = ACTIONS(2300),
    [anon_sym_or_eq] = ACTIONS(2300),
    [anon_sym_xor_eq] = ACTIONS(2300),
    [anon_sym_LT_EQ_GT] = ACTIONS(2302),
    [anon_sym_or] = ACTIONS(2300),
    [anon_sym_and] = ACTIONS(2300),
    [anon_sym_bitor] = ACTIONS(2300),
    [anon_sym_xor] = ACTIONS(2300),
    [anon_sym_bitand] = ACTIONS(2300),
    [anon_sym_not_eq] = ACTIONS(2300),
    [anon_sym_is] = ACTIONS(2300),
    [anon_sym_as] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_DOT] = ACTIONS(2300),
    [anon_sym_DOT_STAR] = ACTIONS(2302),
    [anon_sym_DASH_GT] = ACTIONS(2302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_This] = ACTIONS(2300),
    [anon_sym_final] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
  },
  [2756] = {
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_COMMA] = ACTIONS(2262),
    [anon_sym_RPAREN] = ACTIONS(2262),
    [aux_sym_preproc_if_token2] = ACTIONS(2262),
    [aux_sym_preproc_else_token1] = ACTIONS(2262),
    [aux_sym_preproc_elif_token1] = ACTIONS(2260),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2262),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2262),
    [anon_sym_LPAREN2] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2260),
    [anon_sym_PERCENT] = ACTIONS(2260),
    [anon_sym_PIPE_PIPE] = ACTIONS(2262),
    [anon_sym_AMP_AMP] = ACTIONS(2262),
    [anon_sym_PIPE] = ACTIONS(2260),
    [anon_sym_CARET] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_EQ_EQ] = ACTIONS(2262),
    [anon_sym_BANG_EQ] = ACTIONS(2262),
    [anon_sym_GT] = ACTIONS(2260),
    [anon_sym_GT_EQ] = ACTIONS(2262),
    [anon_sym_LT_EQ] = ACTIONS(2260),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_LT_LT] = ACTIONS(2260),
    [anon_sym_GT_GT] = ACTIONS(2260),
    [anon_sym_COLON] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym___extension__] = ACTIONS(2260),
    [anon_sym___attribute__] = ACTIONS(2260),
    [anon_sym___attribute] = ACTIONS(2260),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_RBRACE] = ACTIONS(2262),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [anon_sym_RBRACK] = ACTIONS(2262),
    [anon_sym_EQ] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_constexpr] = ACTIONS(2260),
    [anon_sym_volatile] = ACTIONS(2260),
    [anon_sym_restrict] = ACTIONS(2260),
    [anon_sym___restrict__] = ACTIONS(2260),
    [anon_sym__Atomic] = ACTIONS(2260),
    [anon_sym__Noreturn] = ACTIONS(2260),
    [anon_sym_noreturn] = ACTIONS(2260),
    [anon_sym__Nonnull] = ACTIONS(2260),
    [anon_sym_mutable] = ACTIONS(2260),
    [anon_sym_constinit] = ACTIONS(2260),
    [anon_sym_consteval] = ACTIONS(2260),
    [anon_sym_alignas] = ACTIONS(2260),
    [anon_sym__Alignas] = ACTIONS(2260),
    [anon_sym_QMARK] = ACTIONS(2262),
    [anon_sym_STAR_EQ] = ACTIONS(2262),
    [anon_sym_SLASH_EQ] = ACTIONS(2262),
    [anon_sym_PERCENT_EQ] = ACTIONS(2262),
    [anon_sym_PLUS_EQ] = ACTIONS(2262),
    [anon_sym_DASH_EQ] = ACTIONS(2262),
    [anon_sym_LT_LT_EQ] = ACTIONS(2262),
    [anon_sym_GT_GT_EQ] = ACTIONS(2262),
    [anon_sym_AMP_EQ] = ACTIONS(2262),
    [anon_sym_CARET_EQ] = ACTIONS(2262),
    [anon_sym_PIPE_EQ] = ACTIONS(2262),
    [anon_sym_and_eq] = ACTIONS(2260),
    [anon_sym_or_eq] = ACTIONS(2260),
    [anon_sym_xor_eq] = ACTIONS(2260),
    [anon_sym_LT_EQ_GT] = ACTIONS(2262),
    [anon_sym_or] = ACTIONS(2260),
    [anon_sym_and] = ACTIONS(2260),
    [anon_sym_bitor] = ACTIONS(2260),
    [anon_sym_xor] = ACTIONS(2260),
    [anon_sym_bitand] = ACTIONS(2260),
    [anon_sym_not_eq] = ACTIONS(2260),
    [anon_sym_is] = ACTIONS(2260),
    [anon_sym_as] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_DOT] = ACTIONS(2260),
    [anon_sym_DOT_STAR] = ACTIONS(2262),
    [anon_sym_DASH_GT] = ACTIONS(2262),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_This] = ACTIONS(2260),
    [anon_sym_final] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
  },
  [2757] = {
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_COMMA] = ACTIONS(2306),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [aux_sym_preproc_if_token2] = ACTIONS(2306),
    [aux_sym_preproc_else_token1] = ACTIONS(2306),
    [aux_sym_preproc_elif_token1] = ACTIONS(2304),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2306),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2306),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2304),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_PERCENT] = ACTIONS(2304),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE] = ACTIONS(2304),
    [anon_sym_CARET] = ACTIONS(2304),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_GT] = ACTIONS(2304),
    [anon_sym_GT_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_LT_LT] = ACTIONS(2304),
    [anon_sym_GT_GT] = ACTIONS(2304),
    [anon_sym_COLON] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2306),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym___attribute] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_LBRACK] = ACTIONS(2306),
    [anon_sym_RBRACK] = ACTIONS(2306),
    [anon_sym_EQ] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym__Nonnull] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [anon_sym_QMARK] = ACTIONS(2306),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_and_eq] = ACTIONS(2304),
    [anon_sym_or_eq] = ACTIONS(2304),
    [anon_sym_xor_eq] = ACTIONS(2304),
    [anon_sym_LT_EQ_GT] = ACTIONS(2306),
    [anon_sym_or] = ACTIONS(2304),
    [anon_sym_and] = ACTIONS(2304),
    [anon_sym_bitor] = ACTIONS(2304),
    [anon_sym_xor] = ACTIONS(2304),
    [anon_sym_bitand] = ACTIONS(2304),
    [anon_sym_not_eq] = ACTIONS(2304),
    [anon_sym_is] = ACTIONS(2304),
    [anon_sym_as] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DOT] = ACTIONS(2304),
    [anon_sym_DOT_STAR] = ACTIONS(2306),
    [anon_sym_DASH_GT] = ACTIONS(2306),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_This] = ACTIONS(2304),
    [anon_sym_final] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
  },
  [2758] = {
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2310),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_RPAREN] = ACTIONS(2310),
    [aux_sym_preproc_if_token2] = ACTIONS(2310),
    [aux_sym_preproc_else_token1] = ACTIONS(2310),
    [aux_sym_preproc_elif_token1] = ACTIONS(2308),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2310),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2310),
    [anon_sym_LPAREN2] = ACTIONS(2310),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2308),
    [anon_sym_SLASH] = ACTIONS(2308),
    [anon_sym_PERCENT] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_CARET] = ACTIONS(2308),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2310),
    [anon_sym_BANG_EQ] = ACTIONS(2310),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_EQ] = ACTIONS(2310),
    [anon_sym_LT_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2308),
    [anon_sym_COLON] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(2308),
    [anon_sym___attribute__] = ACTIONS(2308),
    [anon_sym___attribute] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_RBRACE] = ACTIONS(2310),
    [anon_sym_LBRACK] = ACTIONS(2310),
    [anon_sym_RBRACK] = ACTIONS(2310),
    [anon_sym_EQ] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_constexpr] = ACTIONS(2308),
    [anon_sym_volatile] = ACTIONS(2308),
    [anon_sym_restrict] = ACTIONS(2308),
    [anon_sym___restrict__] = ACTIONS(2308),
    [anon_sym__Atomic] = ACTIONS(2308),
    [anon_sym__Noreturn] = ACTIONS(2308),
    [anon_sym_noreturn] = ACTIONS(2308),
    [anon_sym__Nonnull] = ACTIONS(2308),
    [anon_sym_mutable] = ACTIONS(2308),
    [anon_sym_constinit] = ACTIONS(2308),
    [anon_sym_consteval] = ACTIONS(2308),
    [anon_sym_alignas] = ACTIONS(2308),
    [anon_sym__Alignas] = ACTIONS(2308),
    [anon_sym_QMARK] = ACTIONS(2310),
    [anon_sym_STAR_EQ] = ACTIONS(2310),
    [anon_sym_SLASH_EQ] = ACTIONS(2310),
    [anon_sym_PERCENT_EQ] = ACTIONS(2310),
    [anon_sym_PLUS_EQ] = ACTIONS(2310),
    [anon_sym_DASH_EQ] = ACTIONS(2310),
    [anon_sym_LT_LT_EQ] = ACTIONS(2310),
    [anon_sym_GT_GT_EQ] = ACTIONS(2310),
    [anon_sym_AMP_EQ] = ACTIONS(2310),
    [anon_sym_CARET_EQ] = ACTIONS(2310),
    [anon_sym_PIPE_EQ] = ACTIONS(2310),
    [anon_sym_and_eq] = ACTIONS(2308),
    [anon_sym_or_eq] = ACTIONS(2308),
    [anon_sym_xor_eq] = ACTIONS(2308),
    [anon_sym_LT_EQ_GT] = ACTIONS(2310),
    [anon_sym_or] = ACTIONS(2308),
    [anon_sym_and] = ACTIONS(2308),
    [anon_sym_bitor] = ACTIONS(2308),
    [anon_sym_xor] = ACTIONS(2308),
    [anon_sym_bitand] = ACTIONS(2308),
    [anon_sym_not_eq] = ACTIONS(2308),
    [anon_sym_is] = ACTIONS(2308),
    [anon_sym_as] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_DOT] = ACTIONS(2308),
    [anon_sym_DOT_STAR] = ACTIONS(2310),
    [anon_sym_DASH_GT] = ACTIONS(2310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_This] = ACTIONS(2308),
    [anon_sym_final] = ACTIONS(2308),
    [anon_sym_override] = ACTIONS(2308),
  },
  [2759] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2762),
    [sym_identifier] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4080),
    [anon_sym_RPAREN] = ACTIONS(4080),
    [anon_sym_LPAREN2] = ACTIONS(4080),
    [anon_sym_TILDE] = ACTIONS(4080),
    [anon_sym_STAR] = ACTIONS(4080),
    [anon_sym_AMP_AMP] = ACTIONS(4080),
    [anon_sym_AMP] = ACTIONS(4078),
    [anon_sym_COLON] = ACTIONS(4078),
    [anon_sym_SEMI] = ACTIONS(4080),
    [anon_sym___extension__] = ACTIONS(4078),
    [anon_sym_in] = ACTIONS(4078),
    [anon_sym_out] = ACTIONS(4078),
    [anon_sym_inout] = ACTIONS(4078),
    [anon_sym_virtual] = ACTIONS(4078),
    [anon_sym_extern] = ACTIONS(4078),
    [anon_sym___attribute__] = ACTIONS(4078),
    [anon_sym___attribute] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(4080),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4080),
    [anon_sym___declspec] = ACTIONS(4078),
    [anon_sym___based] = ACTIONS(4078),
    [anon_sym___cdecl] = ACTIONS(4078),
    [anon_sym___clrcall] = ACTIONS(4078),
    [anon_sym___stdcall] = ACTIONS(4078),
    [anon_sym___fastcall] = ACTIONS(4078),
    [anon_sym___thiscall] = ACTIONS(4078),
    [anon_sym___vectorcall] = ACTIONS(4078),
    [anon_sym_LBRACE] = ACTIONS(4080),
    [anon_sym_signed] = ACTIONS(6874),
    [anon_sym_unsigned] = ACTIONS(6874),
    [anon_sym_long] = ACTIONS(6874),
    [anon_sym_short] = ACTIONS(6874),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_static] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_register] = ACTIONS(4078),
    [anon_sym_inline] = ACTIONS(4078),
    [anon_sym___inline] = ACTIONS(4078),
    [anon_sym___inline__] = ACTIONS(4078),
    [anon_sym___forceinline] = ACTIONS(4078),
    [anon_sym_thread_local] = ACTIONS(4078),
    [anon_sym___thread] = ACTIONS(4078),
    [anon_sym_const] = ACTIONS(4078),
    [anon_sym_constexpr] = ACTIONS(4078),
    [anon_sym_volatile] = ACTIONS(4078),
    [anon_sym_restrict] = ACTIONS(4078),
    [anon_sym___restrict__] = ACTIONS(4078),
    [anon_sym__Atomic] = ACTIONS(4078),
    [anon_sym__Noreturn] = ACTIONS(4078),
    [anon_sym_noreturn] = ACTIONS(4078),
    [anon_sym__Nonnull] = ACTIONS(4078),
    [anon_sym_mutable] = ACTIONS(4078),
    [anon_sym_constinit] = ACTIONS(4078),
    [anon_sym_consteval] = ACTIONS(4078),
    [anon_sym_alignas] = ACTIONS(4078),
    [anon_sym__Alignas] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(4078),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4078),
    [anon_sym_let] = ACTIONS(4078),
    [anon_sym_This] = ACTIONS(4078),
    [anon_sym_decltype] = ACTIONS(4078),
    [anon_sym_template] = ACTIONS(4078),
    [anon_sym_GT2] = ACTIONS(4080),
    [anon_sym_operator] = ACTIONS(4078),
    [anon_sym_precise] = ACTIONS(4078),
    [anon_sym_shared] = ACTIONS(4078),
    [anon_sym_groupshared] = ACTIONS(4078),
    [anon_sym_uniform] = ACTIONS(4078),
    [anon_sym_row_major] = ACTIONS(4078),
    [anon_sym_column_major] = ACTIONS(4078),
    [anon_sym_globallycoherent] = ACTIONS(4078),
    [anon_sym_centroid] = ACTIONS(4078),
    [anon_sym_noperspective] = ACTIONS(4078),
    [anon_sym_nointerpolation] = ACTIONS(4078),
    [anon_sym_sample] = ACTIONS(4078),
    [anon_sym_linear] = ACTIONS(4078),
    [anon_sym_snorm] = ACTIONS(4078),
    [anon_sym_unorm] = ACTIONS(4078),
    [anon_sym_point] = ACTIONS(4078),
    [anon_sym_line] = ACTIONS(4078),
    [anon_sym_triangleadj] = ACTIONS(4078),
    [anon_sym_lineadj] = ACTIONS(4078),
    [anon_sym_triangle] = ACTIONS(4078),
  },
  [2760] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2762),
    [sym_identifier] = ACTIONS(4064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4062),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_RPAREN] = ACTIONS(4062),
    [anon_sym_LPAREN2] = ACTIONS(4062),
    [anon_sym_TILDE] = ACTIONS(4062),
    [anon_sym_STAR] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_COLON] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4062),
    [anon_sym___extension__] = ACTIONS(4064),
    [anon_sym_in] = ACTIONS(4064),
    [anon_sym_out] = ACTIONS(4064),
    [anon_sym_inout] = ACTIONS(4064),
    [anon_sym_virtual] = ACTIONS(4064),
    [anon_sym_extern] = ACTIONS(4064),
    [anon_sym___attribute__] = ACTIONS(4064),
    [anon_sym___attribute] = ACTIONS(4064),
    [anon_sym_COLON_COLON] = ACTIONS(4062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4062),
    [anon_sym___declspec] = ACTIONS(4064),
    [anon_sym___based] = ACTIONS(4064),
    [anon_sym___cdecl] = ACTIONS(4064),
    [anon_sym___clrcall] = ACTIONS(4064),
    [anon_sym___stdcall] = ACTIONS(4064),
    [anon_sym___fastcall] = ACTIONS(4064),
    [anon_sym___thiscall] = ACTIONS(4064),
    [anon_sym___vectorcall] = ACTIONS(4064),
    [anon_sym_LBRACE] = ACTIONS(4062),
    [anon_sym_signed] = ACTIONS(6874),
    [anon_sym_unsigned] = ACTIONS(6874),
    [anon_sym_long] = ACTIONS(6874),
    [anon_sym_short] = ACTIONS(6874),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [anon_sym_static] = ACTIONS(4064),
    [anon_sym_EQ] = ACTIONS(4062),
    [anon_sym_register] = ACTIONS(4064),
    [anon_sym_inline] = ACTIONS(4064),
    [anon_sym___inline] = ACTIONS(4064),
    [anon_sym___inline__] = ACTIONS(4064),
    [anon_sym___forceinline] = ACTIONS(4064),
    [anon_sym_thread_local] = ACTIONS(4064),
    [anon_sym___thread] = ACTIONS(4064),
    [anon_sym_const] = ACTIONS(4064),
    [anon_sym_constexpr] = ACTIONS(4064),
    [anon_sym_volatile] = ACTIONS(4064),
    [anon_sym_restrict] = ACTIONS(4064),
    [anon_sym___restrict__] = ACTIONS(4064),
    [anon_sym__Atomic] = ACTIONS(4064),
    [anon_sym__Noreturn] = ACTIONS(4064),
    [anon_sym_noreturn] = ACTIONS(4064),
    [anon_sym__Nonnull] = ACTIONS(4064),
    [anon_sym_mutable] = ACTIONS(4064),
    [anon_sym_constinit] = ACTIONS(4064),
    [anon_sym_consteval] = ACTIONS(4064),
    [anon_sym_alignas] = ACTIONS(4064),
    [anon_sym__Alignas] = ACTIONS(4064),
    [anon_sym_DOT] = ACTIONS(4064),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4064),
    [anon_sym_let] = ACTIONS(4064),
    [anon_sym_This] = ACTIONS(4064),
    [anon_sym_decltype] = ACTIONS(4064),
    [anon_sym_template] = ACTIONS(4064),
    [anon_sym_GT2] = ACTIONS(4062),
    [anon_sym_operator] = ACTIONS(4064),
    [anon_sym_precise] = ACTIONS(4064),
    [anon_sym_shared] = ACTIONS(4064),
    [anon_sym_groupshared] = ACTIONS(4064),
    [anon_sym_uniform] = ACTIONS(4064),
    [anon_sym_row_major] = ACTIONS(4064),
    [anon_sym_column_major] = ACTIONS(4064),
    [anon_sym_globallycoherent] = ACTIONS(4064),
    [anon_sym_centroid] = ACTIONS(4064),
    [anon_sym_noperspective] = ACTIONS(4064),
    [anon_sym_nointerpolation] = ACTIONS(4064),
    [anon_sym_sample] = ACTIONS(4064),
    [anon_sym_linear] = ACTIONS(4064),
    [anon_sym_snorm] = ACTIONS(4064),
    [anon_sym_unorm] = ACTIONS(4064),
    [anon_sym_point] = ACTIONS(4064),
    [anon_sym_line] = ACTIONS(4064),
    [anon_sym_triangleadj] = ACTIONS(4064),
    [anon_sym_lineadj] = ACTIONS(4064),
    [anon_sym_triangle] = ACTIONS(4064),
  },
  [2761] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2762),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4071),
    [anon_sym_COMMA] = ACTIONS(4071),
    [anon_sym_RPAREN] = ACTIONS(4071),
    [anon_sym_LPAREN2] = ACTIONS(4071),
    [anon_sym_TILDE] = ACTIONS(4071),
    [anon_sym_STAR] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
    [anon_sym_COLON] = ACTIONS(4073),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym___extension__] = ACTIONS(4073),
    [anon_sym_in] = ACTIONS(4073),
    [anon_sym_out] = ACTIONS(4073),
    [anon_sym_inout] = ACTIONS(4073),
    [anon_sym_virtual] = ACTIONS(4073),
    [anon_sym_extern] = ACTIONS(4073),
    [anon_sym___attribute__] = ACTIONS(4073),
    [anon_sym___attribute] = ACTIONS(4073),
    [anon_sym_COLON_COLON] = ACTIONS(4071),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4071),
    [anon_sym___declspec] = ACTIONS(4073),
    [anon_sym___based] = ACTIONS(4073),
    [anon_sym___cdecl] = ACTIONS(4073),
    [anon_sym___clrcall] = ACTIONS(4073),
    [anon_sym___stdcall] = ACTIONS(4073),
    [anon_sym___fastcall] = ACTIONS(4073),
    [anon_sym___thiscall] = ACTIONS(4073),
    [anon_sym___vectorcall] = ACTIONS(4073),
    [anon_sym_LBRACE] = ACTIONS(4071),
    [anon_sym_signed] = ACTIONS(6874),
    [anon_sym_unsigned] = ACTIONS(6874),
    [anon_sym_long] = ACTIONS(6874),
    [anon_sym_short] = ACTIONS(6874),
    [anon_sym_LBRACK] = ACTIONS(4073),
    [anon_sym_static] = ACTIONS(4073),
    [anon_sym_EQ] = ACTIONS(4071),
    [anon_sym_register] = ACTIONS(4073),
    [anon_sym_inline] = ACTIONS(4073),
    [anon_sym___inline] = ACTIONS(4073),
    [anon_sym___inline__] = ACTIONS(4073),
    [anon_sym___forceinline] = ACTIONS(4073),
    [anon_sym_thread_local] = ACTIONS(4073),
    [anon_sym___thread] = ACTIONS(4073),
    [anon_sym_const] = ACTIONS(4073),
    [anon_sym_constexpr] = ACTIONS(4073),
    [anon_sym_volatile] = ACTIONS(4073),
    [anon_sym_restrict] = ACTIONS(4073),
    [anon_sym___restrict__] = ACTIONS(4073),
    [anon_sym__Atomic] = ACTIONS(4073),
    [anon_sym__Noreturn] = ACTIONS(4073),
    [anon_sym_noreturn] = ACTIONS(4073),
    [anon_sym__Nonnull] = ACTIONS(4073),
    [anon_sym_mutable] = ACTIONS(4073),
    [anon_sym_constinit] = ACTIONS(4073),
    [anon_sym_consteval] = ACTIONS(4073),
    [anon_sym_alignas] = ACTIONS(4073),
    [anon_sym__Alignas] = ACTIONS(4073),
    [anon_sym_DOT] = ACTIONS(4073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4073),
    [anon_sym_let] = ACTIONS(4073),
    [anon_sym_This] = ACTIONS(4073),
    [anon_sym_decltype] = ACTIONS(4073),
    [anon_sym_template] = ACTIONS(4073),
    [anon_sym_GT2] = ACTIONS(4071),
    [anon_sym_operator] = ACTIONS(4073),
    [anon_sym_precise] = ACTIONS(4073),
    [anon_sym_shared] = ACTIONS(4073),
    [anon_sym_groupshared] = ACTIONS(4073),
    [anon_sym_uniform] = ACTIONS(4073),
    [anon_sym_row_major] = ACTIONS(4073),
    [anon_sym_column_major] = ACTIONS(4073),
    [anon_sym_globallycoherent] = ACTIONS(4073),
    [anon_sym_centroid] = ACTIONS(4073),
    [anon_sym_noperspective] = ACTIONS(4073),
    [anon_sym_nointerpolation] = ACTIONS(4073),
    [anon_sym_sample] = ACTIONS(4073),
    [anon_sym_linear] = ACTIONS(4073),
    [anon_sym_snorm] = ACTIONS(4073),
    [anon_sym_unorm] = ACTIONS(4073),
    [anon_sym_point] = ACTIONS(4073),
    [anon_sym_line] = ACTIONS(4073),
    [anon_sym_triangleadj] = ACTIONS(4073),
    [anon_sym_lineadj] = ACTIONS(4073),
    [anon_sym_triangle] = ACTIONS(4073),
  },
  [2762] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2762),
    [sym_identifier] = ACTIONS(2915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2913),
    [anon_sym_COMMA] = ACTIONS(2913),
    [anon_sym_RPAREN] = ACTIONS(2913),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_COLON] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym_in] = ACTIONS(2915),
    [anon_sym_out] = ACTIONS(2915),
    [anon_sym_inout] = ACTIONS(2915),
    [anon_sym_virtual] = ACTIONS(2915),
    [anon_sym_extern] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym_COLON_COLON] = ACTIONS(2913),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2913),
    [anon_sym___declspec] = ACTIONS(2915),
    [anon_sym___based] = ACTIONS(2915),
    [anon_sym___cdecl] = ACTIONS(2915),
    [anon_sym___clrcall] = ACTIONS(2915),
    [anon_sym___stdcall] = ACTIONS(2915),
    [anon_sym___fastcall] = ACTIONS(2915),
    [anon_sym___thiscall] = ACTIONS(2915),
    [anon_sym___vectorcall] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_signed] = ACTIONS(6882),
    [anon_sym_unsigned] = ACTIONS(6882),
    [anon_sym_long] = ACTIONS(6882),
    [anon_sym_short] = ACTIONS(6882),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_static] = ACTIONS(2915),
    [anon_sym_EQ] = ACTIONS(2913),
    [anon_sym_register] = ACTIONS(2915),
    [anon_sym_inline] = ACTIONS(2915),
    [anon_sym___inline] = ACTIONS(2915),
    [anon_sym___inline__] = ACTIONS(2915),
    [anon_sym___forceinline] = ACTIONS(2915),
    [anon_sym_thread_local] = ACTIONS(2915),
    [anon_sym___thread] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [anon_sym_DOT] = ACTIONS(2915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2915),
    [anon_sym_let] = ACTIONS(2915),
    [anon_sym_This] = ACTIONS(2915),
    [anon_sym_decltype] = ACTIONS(2915),
    [anon_sym_template] = ACTIONS(2915),
    [anon_sym_GT2] = ACTIONS(2913),
    [anon_sym_operator] = ACTIONS(2915),
    [anon_sym_precise] = ACTIONS(2915),
    [anon_sym_shared] = ACTIONS(2915),
    [anon_sym_groupshared] = ACTIONS(2915),
    [anon_sym_uniform] = ACTIONS(2915),
    [anon_sym_row_major] = ACTIONS(2915),
    [anon_sym_column_major] = ACTIONS(2915),
    [anon_sym_globallycoherent] = ACTIONS(2915),
    [anon_sym_centroid] = ACTIONS(2915),
    [anon_sym_noperspective] = ACTIONS(2915),
    [anon_sym_nointerpolation] = ACTIONS(2915),
    [anon_sym_sample] = ACTIONS(2915),
    [anon_sym_linear] = ACTIONS(2915),
    [anon_sym_snorm] = ACTIONS(2915),
    [anon_sym_unorm] = ACTIONS(2915),
    [anon_sym_point] = ACTIONS(2915),
    [anon_sym_line] = ACTIONS(2915),
    [anon_sym_triangleadj] = ACTIONS(2915),
    [anon_sym_lineadj] = ACTIONS(2915),
    [anon_sym_triangle] = ACTIONS(2915),
  },
  [2763] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2759),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2972),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_RPAREN] = ACTIONS(2972),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_COLON] = ACTIONS(2974),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym___extension__] = ACTIONS(2974),
    [anon_sym_in] = ACTIONS(2974),
    [anon_sym_out] = ACTIONS(2974),
    [anon_sym_inout] = ACTIONS(2974),
    [anon_sym_virtual] = ACTIONS(2974),
    [anon_sym_extern] = ACTIONS(2974),
    [anon_sym___attribute__] = ACTIONS(2974),
    [anon_sym___attribute] = ACTIONS(2974),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2974),
    [anon_sym___based] = ACTIONS(2974),
    [anon_sym___cdecl] = ACTIONS(2974),
    [anon_sym___clrcall] = ACTIONS(2974),
    [anon_sym___stdcall] = ACTIONS(2974),
    [anon_sym___fastcall] = ACTIONS(2974),
    [anon_sym___thiscall] = ACTIONS(2974),
    [anon_sym___vectorcall] = ACTIONS(2974),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_signed] = ACTIONS(6885),
    [anon_sym_unsigned] = ACTIONS(6885),
    [anon_sym_long] = ACTIONS(6885),
    [anon_sym_short] = ACTIONS(6885),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [anon_sym_static] = ACTIONS(2974),
    [anon_sym_EQ] = ACTIONS(2972),
    [anon_sym_register] = ACTIONS(2974),
    [anon_sym_inline] = ACTIONS(2974),
    [anon_sym___inline] = ACTIONS(2974),
    [anon_sym___inline__] = ACTIONS(2974),
    [anon_sym___forceinline] = ACTIONS(2974),
    [anon_sym_thread_local] = ACTIONS(2974),
    [anon_sym___thread] = ACTIONS(2974),
    [anon_sym_const] = ACTIONS(2974),
    [anon_sym_constexpr] = ACTIONS(2974),
    [anon_sym_volatile] = ACTIONS(2974),
    [anon_sym_restrict] = ACTIONS(2974),
    [anon_sym___restrict__] = ACTIONS(2974),
    [anon_sym__Atomic] = ACTIONS(2974),
    [anon_sym__Noreturn] = ACTIONS(2974),
    [anon_sym_noreturn] = ACTIONS(2974),
    [anon_sym__Nonnull] = ACTIONS(2974),
    [anon_sym_mutable] = ACTIONS(2974),
    [anon_sym_constinit] = ACTIONS(2974),
    [anon_sym_consteval] = ACTIONS(2974),
    [anon_sym_alignas] = ACTIONS(2974),
    [anon_sym__Alignas] = ACTIONS(2974),
    [anon_sym_DOT] = ACTIONS(2974),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_This] = ACTIONS(2974),
    [anon_sym_decltype] = ACTIONS(2974),
    [anon_sym_template] = ACTIONS(2974),
    [anon_sym_GT2] = ACTIONS(2972),
    [anon_sym_operator] = ACTIONS(2974),
    [anon_sym_precise] = ACTIONS(2974),
    [anon_sym_shared] = ACTIONS(2974),
    [anon_sym_groupshared] = ACTIONS(2974),
    [anon_sym_uniform] = ACTIONS(2974),
    [anon_sym_row_major] = ACTIONS(2974),
    [anon_sym_column_major] = ACTIONS(2974),
    [anon_sym_globallycoherent] = ACTIONS(2974),
    [anon_sym_centroid] = ACTIONS(2974),
    [anon_sym_noperspective] = ACTIONS(2974),
    [anon_sym_nointerpolation] = ACTIONS(2974),
    [anon_sym_sample] = ACTIONS(2974),
    [anon_sym_linear] = ACTIONS(2974),
    [anon_sym_snorm] = ACTIONS(2974),
    [anon_sym_unorm] = ACTIONS(2974),
    [anon_sym_point] = ACTIONS(2974),
    [anon_sym_line] = ACTIONS(2974),
    [anon_sym_triangleadj] = ACTIONS(2974),
    [anon_sym_lineadj] = ACTIONS(2974),
    [anon_sym_triangle] = ACTIONS(2974),
  },
  [2764] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2762),
    [sym_identifier] = ACTIONS(4093),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4095),
    [anon_sym_COMMA] = ACTIONS(4095),
    [anon_sym_RPAREN] = ACTIONS(4095),
    [anon_sym_LPAREN2] = ACTIONS(4095),
    [anon_sym_TILDE] = ACTIONS(4095),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP_AMP] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_COLON] = ACTIONS(4093),
    [anon_sym_SEMI] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4093),
    [anon_sym_in] = ACTIONS(4093),
    [anon_sym_out] = ACTIONS(4093),
    [anon_sym_inout] = ACTIONS(4093),
    [anon_sym_virtual] = ACTIONS(4093),
    [anon_sym_extern] = ACTIONS(4093),
    [anon_sym___attribute__] = ACTIONS(4093),
    [anon_sym___attribute] = ACTIONS(4093),
    [anon_sym_COLON_COLON] = ACTIONS(4095),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4095),
    [anon_sym___declspec] = ACTIONS(4093),
    [anon_sym___based] = ACTIONS(4093),
    [anon_sym___cdecl] = ACTIONS(4093),
    [anon_sym___clrcall] = ACTIONS(4093),
    [anon_sym___stdcall] = ACTIONS(4093),
    [anon_sym___fastcall] = ACTIONS(4093),
    [anon_sym___thiscall] = ACTIONS(4093),
    [anon_sym___vectorcall] = ACTIONS(4093),
    [anon_sym_LBRACE] = ACTIONS(4095),
    [anon_sym_signed] = ACTIONS(6874),
    [anon_sym_unsigned] = ACTIONS(6874),
    [anon_sym_long] = ACTIONS(6874),
    [anon_sym_short] = ACTIONS(6874),
    [anon_sym_LBRACK] = ACTIONS(4093),
    [anon_sym_static] = ACTIONS(4093),
    [anon_sym_EQ] = ACTIONS(4095),
    [anon_sym_register] = ACTIONS(4093),
    [anon_sym_inline] = ACTIONS(4093),
    [anon_sym___inline] = ACTIONS(4093),
    [anon_sym___inline__] = ACTIONS(4093),
    [anon_sym___forceinline] = ACTIONS(4093),
    [anon_sym_thread_local] = ACTIONS(4093),
    [anon_sym___thread] = ACTIONS(4093),
    [anon_sym_const] = ACTIONS(4093),
    [anon_sym_constexpr] = ACTIONS(4093),
    [anon_sym_volatile] = ACTIONS(4093),
    [anon_sym_restrict] = ACTIONS(4093),
    [anon_sym___restrict__] = ACTIONS(4093),
    [anon_sym__Atomic] = ACTIONS(4093),
    [anon_sym__Noreturn] = ACTIONS(4093),
    [anon_sym_noreturn] = ACTIONS(4093),
    [anon_sym__Nonnull] = ACTIONS(4093),
    [anon_sym_mutable] = ACTIONS(4093),
    [anon_sym_constinit] = ACTIONS(4093),
    [anon_sym_consteval] = ACTIONS(4093),
    [anon_sym_alignas] = ACTIONS(4093),
    [anon_sym__Alignas] = ACTIONS(4093),
    [anon_sym_DOT] = ACTIONS(4093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4093),
    [anon_sym_let] = ACTIONS(4093),
    [anon_sym_This] = ACTIONS(4093),
    [anon_sym_decltype] = ACTIONS(4093),
    [anon_sym_template] = ACTIONS(4093),
    [anon_sym_GT2] = ACTIONS(4095),
    [anon_sym_operator] = ACTIONS(4093),
    [anon_sym_precise] = ACTIONS(4093),
    [anon_sym_shared] = ACTIONS(4093),
    [anon_sym_groupshared] = ACTIONS(4093),
    [anon_sym_uniform] = ACTIONS(4093),
    [anon_sym_row_major] = ACTIONS(4093),
    [anon_sym_column_major] = ACTIONS(4093),
    [anon_sym_globallycoherent] = ACTIONS(4093),
    [anon_sym_centroid] = ACTIONS(4093),
    [anon_sym_noperspective] = ACTIONS(4093),
    [anon_sym_nointerpolation] = ACTIONS(4093),
    [anon_sym_sample] = ACTIONS(4093),
    [anon_sym_linear] = ACTIONS(4093),
    [anon_sym_snorm] = ACTIONS(4093),
    [anon_sym_unorm] = ACTIONS(4093),
    [anon_sym_point] = ACTIONS(4093),
    [anon_sym_line] = ACTIONS(4093),
    [anon_sym_triangleadj] = ACTIONS(4093),
    [anon_sym_lineadj] = ACTIONS(4093),
    [anon_sym_triangle] = ACTIONS(4093),
  },
  [2765] = {
    [sym_identifier] = ACTIONS(2268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2270),
    [anon_sym_COMMA] = ACTIONS(2270),
    [anon_sym_RPAREN] = ACTIONS(2270),
    [aux_sym_preproc_if_token2] = ACTIONS(2270),
    [aux_sym_preproc_else_token1] = ACTIONS(2270),
    [aux_sym_preproc_elif_token1] = ACTIONS(2268),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2270),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2270),
    [anon_sym_LPAREN2] = ACTIONS(2270),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2268),
    [anon_sym_SLASH] = ACTIONS(2268),
    [anon_sym_PERCENT] = ACTIONS(2268),
    [anon_sym_PIPE_PIPE] = ACTIONS(2270),
    [anon_sym_AMP_AMP] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2268),
    [anon_sym_CARET] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2268),
    [anon_sym_EQ_EQ] = ACTIONS(2270),
    [anon_sym_BANG_EQ] = ACTIONS(2270),
    [anon_sym_GT] = ACTIONS(2268),
    [anon_sym_GT_EQ] = ACTIONS(2270),
    [anon_sym_LT_EQ] = ACTIONS(2268),
    [anon_sym_LT] = ACTIONS(2268),
    [anon_sym_LT_LT] = ACTIONS(2268),
    [anon_sym_GT_GT] = ACTIONS(2268),
    [anon_sym_COLON] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym___extension__] = ACTIONS(2268),
    [anon_sym___attribute__] = ACTIONS(2268),
    [anon_sym___attribute] = ACTIONS(2268),
    [anon_sym_COLON_COLON] = ACTIONS(2270),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_RBRACE] = ACTIONS(2270),
    [anon_sym_LBRACK] = ACTIONS(2270),
    [anon_sym_RBRACK] = ACTIONS(2270),
    [anon_sym_EQ] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_constexpr] = ACTIONS(2268),
    [anon_sym_volatile] = ACTIONS(2268),
    [anon_sym_restrict] = ACTIONS(2268),
    [anon_sym___restrict__] = ACTIONS(2268),
    [anon_sym__Atomic] = ACTIONS(2268),
    [anon_sym__Noreturn] = ACTIONS(2268),
    [anon_sym_noreturn] = ACTIONS(2268),
    [anon_sym__Nonnull] = ACTIONS(2268),
    [anon_sym_mutable] = ACTIONS(2268),
    [anon_sym_constinit] = ACTIONS(2268),
    [anon_sym_consteval] = ACTIONS(2268),
    [anon_sym_alignas] = ACTIONS(2268),
    [anon_sym__Alignas] = ACTIONS(2268),
    [anon_sym_QMARK] = ACTIONS(2270),
    [anon_sym_STAR_EQ] = ACTIONS(2270),
    [anon_sym_SLASH_EQ] = ACTIONS(2270),
    [anon_sym_PERCENT_EQ] = ACTIONS(2270),
    [anon_sym_PLUS_EQ] = ACTIONS(2270),
    [anon_sym_DASH_EQ] = ACTIONS(2270),
    [anon_sym_LT_LT_EQ] = ACTIONS(2270),
    [anon_sym_GT_GT_EQ] = ACTIONS(2270),
    [anon_sym_AMP_EQ] = ACTIONS(2270),
    [anon_sym_CARET_EQ] = ACTIONS(2270),
    [anon_sym_PIPE_EQ] = ACTIONS(2270),
    [anon_sym_and_eq] = ACTIONS(2268),
    [anon_sym_or_eq] = ACTIONS(2268),
    [anon_sym_xor_eq] = ACTIONS(2268),
    [anon_sym_LT_EQ_GT] = ACTIONS(2270),
    [anon_sym_or] = ACTIONS(2268),
    [anon_sym_and] = ACTIONS(2268),
    [anon_sym_bitor] = ACTIONS(2268),
    [anon_sym_xor] = ACTIONS(2268),
    [anon_sym_bitand] = ACTIONS(2268),
    [anon_sym_not_eq] = ACTIONS(2268),
    [anon_sym_is] = ACTIONS(2268),
    [anon_sym_as] = ACTIONS(2268),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_DOT] = ACTIONS(2268),
    [anon_sym_DOT_STAR] = ACTIONS(2270),
    [anon_sym_DASH_GT] = ACTIONS(2270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_This] = ACTIONS(2268),
    [anon_sym_final] = ACTIONS(2268),
    [anon_sym_override] = ACTIONS(2268),
  },
  [2766] = {
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2274),
    [anon_sym_COMMA] = ACTIONS(2274),
    [anon_sym_RPAREN] = ACTIONS(2274),
    [aux_sym_preproc_if_token2] = ACTIONS(2274),
    [aux_sym_preproc_else_token1] = ACTIONS(2274),
    [aux_sym_preproc_elif_token1] = ACTIONS(2272),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2274),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2274),
    [anon_sym_LPAREN2] = ACTIONS(2274),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2272),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_PERCENT] = ACTIONS(2272),
    [anon_sym_PIPE_PIPE] = ACTIONS(2274),
    [anon_sym_AMP_AMP] = ACTIONS(2274),
    [anon_sym_PIPE] = ACTIONS(2272),
    [anon_sym_CARET] = ACTIONS(2272),
    [anon_sym_AMP] = ACTIONS(2272),
    [anon_sym_EQ_EQ] = ACTIONS(2274),
    [anon_sym_BANG_EQ] = ACTIONS(2274),
    [anon_sym_GT] = ACTIONS(2272),
    [anon_sym_GT_EQ] = ACTIONS(2274),
    [anon_sym_LT_EQ] = ACTIONS(2272),
    [anon_sym_LT] = ACTIONS(2272),
    [anon_sym_LT_LT] = ACTIONS(2272),
    [anon_sym_GT_GT] = ACTIONS(2272),
    [anon_sym_COLON] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym___extension__] = ACTIONS(2272),
    [anon_sym___attribute__] = ACTIONS(2272),
    [anon_sym___attribute] = ACTIONS(2272),
    [anon_sym_COLON_COLON] = ACTIONS(2274),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_RBRACE] = ACTIONS(2274),
    [anon_sym_LBRACK] = ACTIONS(2274),
    [anon_sym_RBRACK] = ACTIONS(2274),
    [anon_sym_EQ] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_constexpr] = ACTIONS(2272),
    [anon_sym_volatile] = ACTIONS(2272),
    [anon_sym_restrict] = ACTIONS(2272),
    [anon_sym___restrict__] = ACTIONS(2272),
    [anon_sym__Atomic] = ACTIONS(2272),
    [anon_sym__Noreturn] = ACTIONS(2272),
    [anon_sym_noreturn] = ACTIONS(2272),
    [anon_sym__Nonnull] = ACTIONS(2272),
    [anon_sym_mutable] = ACTIONS(2272),
    [anon_sym_constinit] = ACTIONS(2272),
    [anon_sym_consteval] = ACTIONS(2272),
    [anon_sym_alignas] = ACTIONS(2272),
    [anon_sym__Alignas] = ACTIONS(2272),
    [anon_sym_QMARK] = ACTIONS(2274),
    [anon_sym_STAR_EQ] = ACTIONS(2274),
    [anon_sym_SLASH_EQ] = ACTIONS(2274),
    [anon_sym_PERCENT_EQ] = ACTIONS(2274),
    [anon_sym_PLUS_EQ] = ACTIONS(2274),
    [anon_sym_DASH_EQ] = ACTIONS(2274),
    [anon_sym_LT_LT_EQ] = ACTIONS(2274),
    [anon_sym_GT_GT_EQ] = ACTIONS(2274),
    [anon_sym_AMP_EQ] = ACTIONS(2274),
    [anon_sym_CARET_EQ] = ACTIONS(2274),
    [anon_sym_PIPE_EQ] = ACTIONS(2274),
    [anon_sym_and_eq] = ACTIONS(2272),
    [anon_sym_or_eq] = ACTIONS(2272),
    [anon_sym_xor_eq] = ACTIONS(2272),
    [anon_sym_LT_EQ_GT] = ACTIONS(2274),
    [anon_sym_or] = ACTIONS(2272),
    [anon_sym_and] = ACTIONS(2272),
    [anon_sym_bitor] = ACTIONS(2272),
    [anon_sym_xor] = ACTIONS(2272),
    [anon_sym_bitand] = ACTIONS(2272),
    [anon_sym_not_eq] = ACTIONS(2272),
    [anon_sym_is] = ACTIONS(2272),
    [anon_sym_as] = ACTIONS(2272),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_DOT] = ACTIONS(2272),
    [anon_sym_DOT_STAR] = ACTIONS(2274),
    [anon_sym_DASH_GT] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_This] = ACTIONS(2272),
    [anon_sym_final] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
  },
  [2767] = {
    [sym_identifier] = ACTIONS(2276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2278),
    [anon_sym_COMMA] = ACTIONS(2278),
    [anon_sym_RPAREN] = ACTIONS(2278),
    [aux_sym_preproc_if_token2] = ACTIONS(2278),
    [aux_sym_preproc_else_token1] = ACTIONS(2278),
    [aux_sym_preproc_elif_token1] = ACTIONS(2276),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2278),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2278),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_PLUS] = ACTIONS(2276),
    [anon_sym_STAR] = ACTIONS(2276),
    [anon_sym_SLASH] = ACTIONS(2276),
    [anon_sym_PERCENT] = ACTIONS(2276),
    [anon_sym_PIPE_PIPE] = ACTIONS(2278),
    [anon_sym_AMP_AMP] = ACTIONS(2278),
    [anon_sym_PIPE] = ACTIONS(2276),
    [anon_sym_CARET] = ACTIONS(2276),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_EQ_EQ] = ACTIONS(2278),
    [anon_sym_BANG_EQ] = ACTIONS(2278),
    [anon_sym_GT] = ACTIONS(2276),
    [anon_sym_GT_EQ] = ACTIONS(2278),
    [anon_sym_LT_EQ] = ACTIONS(2276),
    [anon_sym_LT] = ACTIONS(2276),
    [anon_sym_LT_LT] = ACTIONS(2276),
    [anon_sym_GT_GT] = ACTIONS(2276),
    [anon_sym_COLON] = ACTIONS(2276),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym___extension__] = ACTIONS(2276),
    [anon_sym___attribute__] = ACTIONS(2276),
    [anon_sym___attribute] = ACTIONS(2276),
    [anon_sym_COLON_COLON] = ACTIONS(2278),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_RBRACK] = ACTIONS(2278),
    [anon_sym_EQ] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_constexpr] = ACTIONS(2276),
    [anon_sym_volatile] = ACTIONS(2276),
    [anon_sym_restrict] = ACTIONS(2276),
    [anon_sym___restrict__] = ACTIONS(2276),
    [anon_sym__Atomic] = ACTIONS(2276),
    [anon_sym__Noreturn] = ACTIONS(2276),
    [anon_sym_noreturn] = ACTIONS(2276),
    [anon_sym__Nonnull] = ACTIONS(2276),
    [anon_sym_mutable] = ACTIONS(2276),
    [anon_sym_constinit] = ACTIONS(2276),
    [anon_sym_consteval] = ACTIONS(2276),
    [anon_sym_alignas] = ACTIONS(2276),
    [anon_sym__Alignas] = ACTIONS(2276),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_STAR_EQ] = ACTIONS(2278),
    [anon_sym_SLASH_EQ] = ACTIONS(2278),
    [anon_sym_PERCENT_EQ] = ACTIONS(2278),
    [anon_sym_PLUS_EQ] = ACTIONS(2278),
    [anon_sym_DASH_EQ] = ACTIONS(2278),
    [anon_sym_LT_LT_EQ] = ACTIONS(2278),
    [anon_sym_GT_GT_EQ] = ACTIONS(2278),
    [anon_sym_AMP_EQ] = ACTIONS(2278),
    [anon_sym_CARET_EQ] = ACTIONS(2278),
    [anon_sym_PIPE_EQ] = ACTIONS(2278),
    [anon_sym_and_eq] = ACTIONS(2276),
    [anon_sym_or_eq] = ACTIONS(2276),
    [anon_sym_xor_eq] = ACTIONS(2276),
    [anon_sym_LT_EQ_GT] = ACTIONS(2278),
    [anon_sym_or] = ACTIONS(2276),
    [anon_sym_and] = ACTIONS(2276),
    [anon_sym_bitor] = ACTIONS(2276),
    [anon_sym_xor] = ACTIONS(2276),
    [anon_sym_bitand] = ACTIONS(2276),
    [anon_sym_not_eq] = ACTIONS(2276),
    [anon_sym_is] = ACTIONS(2276),
    [anon_sym_as] = ACTIONS(2276),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DOT] = ACTIONS(2276),
    [anon_sym_DOT_STAR] = ACTIONS(2278),
    [anon_sym_DASH_GT] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_This] = ACTIONS(2276),
    [anon_sym_final] = ACTIONS(2276),
    [anon_sym_override] = ACTIONS(2276),
  },
  [2768] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2743),
    [sym_identifier] = ACTIONS(4111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4113),
    [anon_sym_COMMA] = ACTIONS(4113),
    [anon_sym_RPAREN] = ACTIONS(4113),
    [anon_sym_LPAREN2] = ACTIONS(4113),
    [anon_sym_TILDE] = ACTIONS(4113),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4113),
    [anon_sym_AMP] = ACTIONS(4111),
    [anon_sym_COLON] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym___extension__] = ACTIONS(4111),
    [anon_sym_in] = ACTIONS(4111),
    [anon_sym_out] = ACTIONS(4111),
    [anon_sym_inout] = ACTIONS(4111),
    [anon_sym_virtual] = ACTIONS(4111),
    [anon_sym_extern] = ACTIONS(4111),
    [anon_sym___attribute__] = ACTIONS(4111),
    [anon_sym___attribute] = ACTIONS(4111),
    [anon_sym_COLON_COLON] = ACTIONS(4113),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4113),
    [anon_sym___declspec] = ACTIONS(4111),
    [anon_sym___based] = ACTIONS(4111),
    [anon_sym___cdecl] = ACTIONS(4111),
    [anon_sym___clrcall] = ACTIONS(4111),
    [anon_sym___stdcall] = ACTIONS(4111),
    [anon_sym___fastcall] = ACTIONS(4111),
    [anon_sym___thiscall] = ACTIONS(4111),
    [anon_sym___vectorcall] = ACTIONS(4111),
    [anon_sym_LBRACE] = ACTIONS(4113),
    [anon_sym_signed] = ACTIONS(6887),
    [anon_sym_unsigned] = ACTIONS(6887),
    [anon_sym_long] = ACTIONS(6887),
    [anon_sym_short] = ACTIONS(6887),
    [anon_sym_LBRACK] = ACTIONS(4111),
    [anon_sym_static] = ACTIONS(4111),
    [anon_sym_EQ] = ACTIONS(4113),
    [anon_sym_register] = ACTIONS(4111),
    [anon_sym_inline] = ACTIONS(4111),
    [anon_sym___inline] = ACTIONS(4111),
    [anon_sym___inline__] = ACTIONS(4111),
    [anon_sym___forceinline] = ACTIONS(4111),
    [anon_sym_thread_local] = ACTIONS(4111),
    [anon_sym___thread] = ACTIONS(4111),
    [anon_sym_const] = ACTIONS(4111),
    [anon_sym_constexpr] = ACTIONS(4111),
    [anon_sym_volatile] = ACTIONS(4111),
    [anon_sym_restrict] = ACTIONS(4111),
    [anon_sym___restrict__] = ACTIONS(4111),
    [anon_sym__Atomic] = ACTIONS(4111),
    [anon_sym__Noreturn] = ACTIONS(4111),
    [anon_sym_noreturn] = ACTIONS(4111),
    [anon_sym__Nonnull] = ACTIONS(4111),
    [anon_sym_mutable] = ACTIONS(4111),
    [anon_sym_constinit] = ACTIONS(4111),
    [anon_sym_consteval] = ACTIONS(4111),
    [anon_sym_alignas] = ACTIONS(4111),
    [anon_sym__Alignas] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(4111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4111),
    [anon_sym_let] = ACTIONS(4111),
    [anon_sym_This] = ACTIONS(4111),
    [anon_sym_decltype] = ACTIONS(4111),
    [anon_sym_template] = ACTIONS(4111),
    [anon_sym_GT2] = ACTIONS(4113),
    [anon_sym_operator] = ACTIONS(4111),
    [anon_sym_precise] = ACTIONS(4111),
    [anon_sym_shared] = ACTIONS(4111),
    [anon_sym_groupshared] = ACTIONS(4111),
    [anon_sym_uniform] = ACTIONS(4111),
    [anon_sym_row_major] = ACTIONS(4111),
    [anon_sym_column_major] = ACTIONS(4111),
    [anon_sym_globallycoherent] = ACTIONS(4111),
    [anon_sym_centroid] = ACTIONS(4111),
    [anon_sym_noperspective] = ACTIONS(4111),
    [anon_sym_nointerpolation] = ACTIONS(4111),
    [anon_sym_sample] = ACTIONS(4111),
    [anon_sym_linear] = ACTIONS(4111),
    [anon_sym_snorm] = ACTIONS(4111),
    [anon_sym_unorm] = ACTIONS(4111),
    [anon_sym_point] = ACTIONS(4111),
    [anon_sym_line] = ACTIONS(4111),
    [anon_sym_triangleadj] = ACTIONS(4111),
    [anon_sym_lineadj] = ACTIONS(4111),
    [anon_sym_triangle] = ACTIONS(4111),
  },
  [2769] = {
    [sym__declaration_modifiers] = STATE(2772),
    [sym_attribute_specifier] = STATE(2772),
    [sym_attribute_declaration] = STATE(2772),
    [sym_ms_declspec_modifier] = STATE(2772),
    [sym_storage_class_specifier] = STATE(2772),
    [sym_type_qualifier] = STATE(2772),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_qualifiers] = STATE(2772),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2772),
    [sym_identifier] = ACTIONS(6889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6891),
    [anon_sym_COMMA] = ACTIONS(6891),
    [anon_sym_RPAREN] = ACTIONS(6891),
    [anon_sym_LPAREN2] = ACTIONS(6891),
    [anon_sym_TILDE] = ACTIONS(6891),
    [anon_sym_STAR] = ACTIONS(6891),
    [anon_sym_AMP_AMP] = ACTIONS(6891),
    [anon_sym_AMP] = ACTIONS(6889),
    [anon_sym_COLON] = ACTIONS(6889),
    [anon_sym_SEMI] = ACTIONS(6891),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(6893),
    [anon_sym_out] = ACTIONS(6893),
    [anon_sym_inout] = ACTIONS(6893),
    [anon_sym_virtual] = ACTIONS(6893),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(6891),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(6889),
    [anon_sym___cdecl] = ACTIONS(6889),
    [anon_sym___clrcall] = ACTIONS(6889),
    [anon_sym___stdcall] = ACTIONS(6889),
    [anon_sym___fastcall] = ACTIONS(6889),
    [anon_sym___thiscall] = ACTIONS(6889),
    [anon_sym___vectorcall] = ACTIONS(6889),
    [anon_sym_LBRACK] = ACTIONS(6889),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_EQ] = ACTIONS(6891),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6889),
    [anon_sym_template] = ACTIONS(6889),
    [anon_sym_GT2] = ACTIONS(6891),
    [anon_sym_operator] = ACTIONS(6889),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [2770] = {
    [sym_string_literal] = STATE(1569),
    [sym_identifier] = ACTIONS(6895),
    [anon_sym_LPAREN2] = ACTIONS(6897),
    [anon_sym_TILDE] = ACTIONS(6897),
    [anon_sym_STAR] = ACTIONS(6897),
    [anon_sym_AMP_AMP] = ACTIONS(6897),
    [anon_sym_AMP] = ACTIONS(6895),
    [anon_sym___extension__] = ACTIONS(6895),
    [anon_sym_in] = ACTIONS(6895),
    [anon_sym_out] = ACTIONS(6895),
    [anon_sym_inout] = ACTIONS(6895),
    [anon_sym_virtual] = ACTIONS(6895),
    [anon_sym_extern] = ACTIONS(6895),
    [anon_sym___attribute__] = ACTIONS(6895),
    [anon_sym___attribute] = ACTIONS(6895),
    [anon_sym_COLON_COLON] = ACTIONS(6897),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6897),
    [anon_sym___declspec] = ACTIONS(6895),
    [anon_sym___based] = ACTIONS(6895),
    [anon_sym_signed] = ACTIONS(6895),
    [anon_sym_unsigned] = ACTIONS(6895),
    [anon_sym_long] = ACTIONS(6895),
    [anon_sym_short] = ACTIONS(6895),
    [anon_sym_LBRACK] = ACTIONS(6895),
    [anon_sym_static] = ACTIONS(6895),
    [anon_sym_register] = ACTIONS(6895),
    [anon_sym_inline] = ACTIONS(6895),
    [anon_sym___inline] = ACTIONS(6895),
    [anon_sym___inline__] = ACTIONS(6895),
    [anon_sym___forceinline] = ACTIONS(6895),
    [anon_sym_thread_local] = ACTIONS(6895),
    [anon_sym___thread] = ACTIONS(6895),
    [anon_sym_const] = ACTIONS(6895),
    [anon_sym_constexpr] = ACTIONS(6895),
    [anon_sym_volatile] = ACTIONS(6895),
    [anon_sym_restrict] = ACTIONS(6895),
    [anon_sym___restrict__] = ACTIONS(6895),
    [anon_sym__Atomic] = ACTIONS(6895),
    [anon_sym__Noreturn] = ACTIONS(6895),
    [anon_sym_noreturn] = ACTIONS(6895),
    [anon_sym__Nonnull] = ACTIONS(6895),
    [anon_sym_mutable] = ACTIONS(6895),
    [anon_sym_constinit] = ACTIONS(6895),
    [anon_sym_consteval] = ACTIONS(6895),
    [anon_sym_alignas] = ACTIONS(6895),
    [anon_sym__Alignas] = ACTIONS(6895),
    [sym_primitive_type] = ACTIONS(6895),
    [anon_sym_enum] = ACTIONS(6895),
    [anon_sym_class] = ACTIONS(6895),
    [anon_sym_struct] = ACTIONS(6895),
    [anon_sym_union] = ACTIONS(6895),
    [anon_sym_L_DQUOTE] = ACTIONS(6899),
    [anon_sym_u_DQUOTE] = ACTIONS(6899),
    [anon_sym_U_DQUOTE] = ACTIONS(6899),
    [anon_sym_u8_DQUOTE] = ACTIONS(6899),
    [anon_sym_DQUOTE] = ACTIONS(6899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6895),
    [anon_sym_let] = ACTIONS(6895),
    [anon_sym_This] = ACTIONS(6895),
    [anon_sym_decltype] = ACTIONS(6895),
    [anon_sym_explicit] = ACTIONS(6895),
    [anon_sym_typename] = ACTIONS(6895),
    [anon_sym_template] = ACTIONS(6895),
    [anon_sym_operator] = ACTIONS(6895),
    [anon_sym_precise] = ACTIONS(6895),
    [anon_sym_shared] = ACTIONS(6895),
    [anon_sym_groupshared] = ACTIONS(6895),
    [anon_sym_uniform] = ACTIONS(6895),
    [anon_sym_row_major] = ACTIONS(6895),
    [anon_sym_column_major] = ACTIONS(6895),
    [anon_sym_globallycoherent] = ACTIONS(6895),
    [anon_sym_centroid] = ACTIONS(6895),
    [anon_sym_noperspective] = ACTIONS(6895),
    [anon_sym_nointerpolation] = ACTIONS(6895),
    [anon_sym_sample] = ACTIONS(6895),
    [anon_sym_linear] = ACTIONS(6895),
    [anon_sym_snorm] = ACTIONS(6895),
    [anon_sym_unorm] = ACTIONS(6895),
    [anon_sym_point] = ACTIONS(6895),
    [anon_sym_line] = ACTIONS(6895),
    [anon_sym_triangleadj] = ACTIONS(6895),
    [anon_sym_lineadj] = ACTIONS(6895),
    [anon_sym_triangle] = ACTIONS(6895),
    [anon_sym_interface] = ACTIONS(6895),
    [anon_sym_extension] = ACTIONS(6895),
  },
  [2771] = {
    [sym_string_literal] = STATE(1568),
    [sym_identifier] = ACTIONS(6895),
    [anon_sym_LPAREN2] = ACTIONS(6897),
    [anon_sym_TILDE] = ACTIONS(6897),
    [anon_sym_STAR] = ACTIONS(6897),
    [anon_sym_AMP_AMP] = ACTIONS(6897),
    [anon_sym_AMP] = ACTIONS(6895),
    [anon_sym___extension__] = ACTIONS(6895),
    [anon_sym_in] = ACTIONS(6895),
    [anon_sym_out] = ACTIONS(6895),
    [anon_sym_inout] = ACTIONS(6895),
    [anon_sym_virtual] = ACTIONS(6895),
    [anon_sym_extern] = ACTIONS(6895),
    [anon_sym___attribute__] = ACTIONS(6895),
    [anon_sym___attribute] = ACTIONS(6895),
    [anon_sym_COLON_COLON] = ACTIONS(6897),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6897),
    [anon_sym___declspec] = ACTIONS(6895),
    [anon_sym___based] = ACTIONS(6895),
    [anon_sym_signed] = ACTIONS(6895),
    [anon_sym_unsigned] = ACTIONS(6895),
    [anon_sym_long] = ACTIONS(6895),
    [anon_sym_short] = ACTIONS(6895),
    [anon_sym_LBRACK] = ACTIONS(6895),
    [anon_sym_static] = ACTIONS(6895),
    [anon_sym_register] = ACTIONS(6895),
    [anon_sym_inline] = ACTIONS(6895),
    [anon_sym___inline] = ACTIONS(6895),
    [anon_sym___inline__] = ACTIONS(6895),
    [anon_sym___forceinline] = ACTIONS(6895),
    [anon_sym_thread_local] = ACTIONS(6895),
    [anon_sym___thread] = ACTIONS(6895),
    [anon_sym_const] = ACTIONS(6895),
    [anon_sym_constexpr] = ACTIONS(6895),
    [anon_sym_volatile] = ACTIONS(6895),
    [anon_sym_restrict] = ACTIONS(6895),
    [anon_sym___restrict__] = ACTIONS(6895),
    [anon_sym__Atomic] = ACTIONS(6895),
    [anon_sym__Noreturn] = ACTIONS(6895),
    [anon_sym_noreturn] = ACTIONS(6895),
    [anon_sym__Nonnull] = ACTIONS(6895),
    [anon_sym_mutable] = ACTIONS(6895),
    [anon_sym_constinit] = ACTIONS(6895),
    [anon_sym_consteval] = ACTIONS(6895),
    [anon_sym_alignas] = ACTIONS(6895),
    [anon_sym__Alignas] = ACTIONS(6895),
    [sym_primitive_type] = ACTIONS(6895),
    [anon_sym_enum] = ACTIONS(6895),
    [anon_sym_class] = ACTIONS(6895),
    [anon_sym_struct] = ACTIONS(6895),
    [anon_sym_union] = ACTIONS(6895),
    [anon_sym_L_DQUOTE] = ACTIONS(6899),
    [anon_sym_u_DQUOTE] = ACTIONS(6899),
    [anon_sym_U_DQUOTE] = ACTIONS(6899),
    [anon_sym_u8_DQUOTE] = ACTIONS(6899),
    [anon_sym_DQUOTE] = ACTIONS(6899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6895),
    [anon_sym_let] = ACTIONS(6895),
    [anon_sym_This] = ACTIONS(6895),
    [anon_sym_decltype] = ACTIONS(6895),
    [anon_sym_explicit] = ACTIONS(6895),
    [anon_sym_typename] = ACTIONS(6895),
    [anon_sym_template] = ACTIONS(6895),
    [anon_sym_operator] = ACTIONS(6895),
    [anon_sym_precise] = ACTIONS(6895),
    [anon_sym_shared] = ACTIONS(6895),
    [anon_sym_groupshared] = ACTIONS(6895),
    [anon_sym_uniform] = ACTIONS(6895),
    [anon_sym_row_major] = ACTIONS(6895),
    [anon_sym_column_major] = ACTIONS(6895),
    [anon_sym_globallycoherent] = ACTIONS(6895),
    [anon_sym_centroid] = ACTIONS(6895),
    [anon_sym_noperspective] = ACTIONS(6895),
    [anon_sym_nointerpolation] = ACTIONS(6895),
    [anon_sym_sample] = ACTIONS(6895),
    [anon_sym_linear] = ACTIONS(6895),
    [anon_sym_snorm] = ACTIONS(6895),
    [anon_sym_unorm] = ACTIONS(6895),
    [anon_sym_point] = ACTIONS(6895),
    [anon_sym_line] = ACTIONS(6895),
    [anon_sym_triangleadj] = ACTIONS(6895),
    [anon_sym_lineadj] = ACTIONS(6895),
    [anon_sym_triangle] = ACTIONS(6895),
    [anon_sym_interface] = ACTIONS(6895),
    [anon_sym_extension] = ACTIONS(6895),
  },
  [2772] = {
    [sym__declaration_modifiers] = STATE(2772),
    [sym_attribute_specifier] = STATE(2772),
    [sym_attribute_declaration] = STATE(2772),
    [sym_ms_declspec_modifier] = STATE(2772),
    [sym_storage_class_specifier] = STATE(2772),
    [sym_type_qualifier] = STATE(2772),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_qualifiers] = STATE(2772),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2772),
    [sym_identifier] = ACTIONS(6901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6903),
    [anon_sym_COMMA] = ACTIONS(6903),
    [anon_sym_RPAREN] = ACTIONS(6903),
    [anon_sym_LPAREN2] = ACTIONS(6903),
    [anon_sym_TILDE] = ACTIONS(6903),
    [anon_sym_STAR] = ACTIONS(6903),
    [anon_sym_AMP_AMP] = ACTIONS(6903),
    [anon_sym_AMP] = ACTIONS(6901),
    [anon_sym_COLON] = ACTIONS(6901),
    [anon_sym_SEMI] = ACTIONS(6903),
    [anon_sym___extension__] = ACTIONS(6905),
    [anon_sym_in] = ACTIONS(6908),
    [anon_sym_out] = ACTIONS(6908),
    [anon_sym_inout] = ACTIONS(6908),
    [anon_sym_virtual] = ACTIONS(6908),
    [anon_sym_extern] = ACTIONS(6911),
    [anon_sym___attribute__] = ACTIONS(6914),
    [anon_sym___attribute] = ACTIONS(6914),
    [anon_sym_COLON_COLON] = ACTIONS(6903),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6917),
    [anon_sym___declspec] = ACTIONS(6920),
    [anon_sym___based] = ACTIONS(6901),
    [anon_sym___cdecl] = ACTIONS(6901),
    [anon_sym___clrcall] = ACTIONS(6901),
    [anon_sym___stdcall] = ACTIONS(6901),
    [anon_sym___fastcall] = ACTIONS(6901),
    [anon_sym___thiscall] = ACTIONS(6901),
    [anon_sym___vectorcall] = ACTIONS(6901),
    [anon_sym_LBRACK] = ACTIONS(6901),
    [anon_sym_static] = ACTIONS(6911),
    [anon_sym_EQ] = ACTIONS(6903),
    [anon_sym_register] = ACTIONS(6911),
    [anon_sym_inline] = ACTIONS(6911),
    [anon_sym___inline] = ACTIONS(6911),
    [anon_sym___inline__] = ACTIONS(6911),
    [anon_sym___forceinline] = ACTIONS(6911),
    [anon_sym_thread_local] = ACTIONS(6911),
    [anon_sym___thread] = ACTIONS(6911),
    [anon_sym_const] = ACTIONS(6905),
    [anon_sym_constexpr] = ACTIONS(6905),
    [anon_sym_volatile] = ACTIONS(6905),
    [anon_sym_restrict] = ACTIONS(6905),
    [anon_sym___restrict__] = ACTIONS(6905),
    [anon_sym__Atomic] = ACTIONS(6905),
    [anon_sym__Noreturn] = ACTIONS(6905),
    [anon_sym_noreturn] = ACTIONS(6905),
    [anon_sym__Nonnull] = ACTIONS(6905),
    [anon_sym_mutable] = ACTIONS(6905),
    [anon_sym_constinit] = ACTIONS(6905),
    [anon_sym_consteval] = ACTIONS(6905),
    [anon_sym_alignas] = ACTIONS(6923),
    [anon_sym__Alignas] = ACTIONS(6923),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6901),
    [anon_sym_template] = ACTIONS(6901),
    [anon_sym_GT2] = ACTIONS(6903),
    [anon_sym_operator] = ACTIONS(6901),
    [anon_sym_precise] = ACTIONS(6926),
    [anon_sym_shared] = ACTIONS(6926),
    [anon_sym_groupshared] = ACTIONS(6926),
    [anon_sym_uniform] = ACTIONS(6926),
    [anon_sym_row_major] = ACTIONS(6926),
    [anon_sym_column_major] = ACTIONS(6926),
    [anon_sym_globallycoherent] = ACTIONS(6926),
    [anon_sym_centroid] = ACTIONS(6926),
    [anon_sym_noperspective] = ACTIONS(6926),
    [anon_sym_nointerpolation] = ACTIONS(6926),
    [anon_sym_sample] = ACTIONS(6926),
    [anon_sym_linear] = ACTIONS(6926),
    [anon_sym_snorm] = ACTIONS(6926),
    [anon_sym_unorm] = ACTIONS(6926),
    [anon_sym_point] = ACTIONS(6926),
    [anon_sym_line] = ACTIONS(6926),
    [anon_sym_triangleadj] = ACTIONS(6926),
    [anon_sym_lineadj] = ACTIONS(6926),
    [anon_sym_triangle] = ACTIONS(6926),
  },
  [2773] = {
    [sym__declaration_modifiers] = STATE(2772),
    [sym_attribute_specifier] = STATE(2772),
    [sym_attribute_declaration] = STATE(2772),
    [sym_ms_declspec_modifier] = STATE(2772),
    [sym_storage_class_specifier] = STATE(2772),
    [sym_type_qualifier] = STATE(2772),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_qualifiers] = STATE(2772),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2772),
    [sym_identifier] = ACTIONS(6929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6931),
    [anon_sym_COMMA] = ACTIONS(6931),
    [anon_sym_RPAREN] = ACTIONS(6931),
    [anon_sym_LPAREN2] = ACTIONS(6931),
    [anon_sym_TILDE] = ACTIONS(6931),
    [anon_sym_STAR] = ACTIONS(6931),
    [anon_sym_AMP_AMP] = ACTIONS(6931),
    [anon_sym_AMP] = ACTIONS(6929),
    [anon_sym_COLON] = ACTIONS(6929),
    [anon_sym_SEMI] = ACTIONS(6931),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(6893),
    [anon_sym_out] = ACTIONS(6893),
    [anon_sym_inout] = ACTIONS(6893),
    [anon_sym_virtual] = ACTIONS(6893),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(6931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(6929),
    [anon_sym___cdecl] = ACTIONS(6929),
    [anon_sym___clrcall] = ACTIONS(6929),
    [anon_sym___stdcall] = ACTIONS(6929),
    [anon_sym___fastcall] = ACTIONS(6929),
    [anon_sym___thiscall] = ACTIONS(6929),
    [anon_sym___vectorcall] = ACTIONS(6929),
    [anon_sym_LBRACK] = ACTIONS(6929),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_EQ] = ACTIONS(6931),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6929),
    [anon_sym_template] = ACTIONS(6929),
    [anon_sym_GT2] = ACTIONS(6931),
    [anon_sym_operator] = ACTIONS(6929),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [2774] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2759),
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2881),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2881),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_signed] = ACTIONS(6885),
    [anon_sym_unsigned] = ACTIONS(6885),
    [anon_sym_long] = ACTIONS(6885),
    [anon_sym_short] = ACTIONS(6885),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2881),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_GT2] = ACTIONS(2881),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
  },
  [2775] = {
    [sym_string_literal] = STATE(1566),
    [sym_identifier] = ACTIONS(6895),
    [anon_sym_LPAREN2] = ACTIONS(6897),
    [anon_sym_TILDE] = ACTIONS(6897),
    [anon_sym_STAR] = ACTIONS(6897),
    [anon_sym_AMP_AMP] = ACTIONS(6897),
    [anon_sym_AMP] = ACTIONS(6895),
    [anon_sym___extension__] = ACTIONS(6895),
    [anon_sym_in] = ACTIONS(6895),
    [anon_sym_out] = ACTIONS(6895),
    [anon_sym_inout] = ACTIONS(6895),
    [anon_sym_virtual] = ACTIONS(6895),
    [anon_sym_extern] = ACTIONS(6895),
    [anon_sym___attribute__] = ACTIONS(6895),
    [anon_sym___attribute] = ACTIONS(6895),
    [anon_sym_COLON_COLON] = ACTIONS(6897),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6897),
    [anon_sym___declspec] = ACTIONS(6895),
    [anon_sym___based] = ACTIONS(6895),
    [anon_sym_signed] = ACTIONS(6895),
    [anon_sym_unsigned] = ACTIONS(6895),
    [anon_sym_long] = ACTIONS(6895),
    [anon_sym_short] = ACTIONS(6895),
    [anon_sym_LBRACK] = ACTIONS(6895),
    [anon_sym_static] = ACTIONS(6895),
    [anon_sym_register] = ACTIONS(6895),
    [anon_sym_inline] = ACTIONS(6895),
    [anon_sym___inline] = ACTIONS(6895),
    [anon_sym___inline__] = ACTIONS(6895),
    [anon_sym___forceinline] = ACTIONS(6895),
    [anon_sym_thread_local] = ACTIONS(6895),
    [anon_sym___thread] = ACTIONS(6895),
    [anon_sym_const] = ACTIONS(6895),
    [anon_sym_constexpr] = ACTIONS(6895),
    [anon_sym_volatile] = ACTIONS(6895),
    [anon_sym_restrict] = ACTIONS(6895),
    [anon_sym___restrict__] = ACTIONS(6895),
    [anon_sym__Atomic] = ACTIONS(6895),
    [anon_sym__Noreturn] = ACTIONS(6895),
    [anon_sym_noreturn] = ACTIONS(6895),
    [anon_sym__Nonnull] = ACTIONS(6895),
    [anon_sym_mutable] = ACTIONS(6895),
    [anon_sym_constinit] = ACTIONS(6895),
    [anon_sym_consteval] = ACTIONS(6895),
    [anon_sym_alignas] = ACTIONS(6895),
    [anon_sym__Alignas] = ACTIONS(6895),
    [sym_primitive_type] = ACTIONS(6895),
    [anon_sym_enum] = ACTIONS(6895),
    [anon_sym_class] = ACTIONS(6895),
    [anon_sym_struct] = ACTIONS(6895),
    [anon_sym_union] = ACTIONS(6895),
    [anon_sym_L_DQUOTE] = ACTIONS(6899),
    [anon_sym_u_DQUOTE] = ACTIONS(6899),
    [anon_sym_U_DQUOTE] = ACTIONS(6899),
    [anon_sym_u8_DQUOTE] = ACTIONS(6899),
    [anon_sym_DQUOTE] = ACTIONS(6899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6895),
    [anon_sym_let] = ACTIONS(6895),
    [anon_sym_This] = ACTIONS(6895),
    [anon_sym_decltype] = ACTIONS(6895),
    [anon_sym_explicit] = ACTIONS(6895),
    [anon_sym_typename] = ACTIONS(6895),
    [anon_sym_template] = ACTIONS(6895),
    [anon_sym_operator] = ACTIONS(6895),
    [anon_sym_precise] = ACTIONS(6895),
    [anon_sym_shared] = ACTIONS(6895),
    [anon_sym_groupshared] = ACTIONS(6895),
    [anon_sym_uniform] = ACTIONS(6895),
    [anon_sym_row_major] = ACTIONS(6895),
    [anon_sym_column_major] = ACTIONS(6895),
    [anon_sym_globallycoherent] = ACTIONS(6895),
    [anon_sym_centroid] = ACTIONS(6895),
    [anon_sym_noperspective] = ACTIONS(6895),
    [anon_sym_nointerpolation] = ACTIONS(6895),
    [anon_sym_sample] = ACTIONS(6895),
    [anon_sym_linear] = ACTIONS(6895),
    [anon_sym_snorm] = ACTIONS(6895),
    [anon_sym_unorm] = ACTIONS(6895),
    [anon_sym_point] = ACTIONS(6895),
    [anon_sym_line] = ACTIONS(6895),
    [anon_sym_triangleadj] = ACTIONS(6895),
    [anon_sym_lineadj] = ACTIONS(6895),
    [anon_sym_triangle] = ACTIONS(6895),
    [anon_sym_interface] = ACTIONS(6895),
    [anon_sym_extension] = ACTIONS(6895),
  },
  [2776] = {
    [sym_string_literal] = STATE(1567),
    [sym_identifier] = ACTIONS(6895),
    [anon_sym_LPAREN2] = ACTIONS(6897),
    [anon_sym_TILDE] = ACTIONS(6897),
    [anon_sym_STAR] = ACTIONS(6897),
    [anon_sym_AMP_AMP] = ACTIONS(6897),
    [anon_sym_AMP] = ACTIONS(6895),
    [anon_sym___extension__] = ACTIONS(6895),
    [anon_sym_in] = ACTIONS(6895),
    [anon_sym_out] = ACTIONS(6895),
    [anon_sym_inout] = ACTIONS(6895),
    [anon_sym_virtual] = ACTIONS(6895),
    [anon_sym_extern] = ACTIONS(6895),
    [anon_sym___attribute__] = ACTIONS(6895),
    [anon_sym___attribute] = ACTIONS(6895),
    [anon_sym_COLON_COLON] = ACTIONS(6897),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6897),
    [anon_sym___declspec] = ACTIONS(6895),
    [anon_sym___based] = ACTIONS(6895),
    [anon_sym_signed] = ACTIONS(6895),
    [anon_sym_unsigned] = ACTIONS(6895),
    [anon_sym_long] = ACTIONS(6895),
    [anon_sym_short] = ACTIONS(6895),
    [anon_sym_LBRACK] = ACTIONS(6895),
    [anon_sym_static] = ACTIONS(6895),
    [anon_sym_register] = ACTIONS(6895),
    [anon_sym_inline] = ACTIONS(6895),
    [anon_sym___inline] = ACTIONS(6895),
    [anon_sym___inline__] = ACTIONS(6895),
    [anon_sym___forceinline] = ACTIONS(6895),
    [anon_sym_thread_local] = ACTIONS(6895),
    [anon_sym___thread] = ACTIONS(6895),
    [anon_sym_const] = ACTIONS(6895),
    [anon_sym_constexpr] = ACTIONS(6895),
    [anon_sym_volatile] = ACTIONS(6895),
    [anon_sym_restrict] = ACTIONS(6895),
    [anon_sym___restrict__] = ACTIONS(6895),
    [anon_sym__Atomic] = ACTIONS(6895),
    [anon_sym__Noreturn] = ACTIONS(6895),
    [anon_sym_noreturn] = ACTIONS(6895),
    [anon_sym__Nonnull] = ACTIONS(6895),
    [anon_sym_mutable] = ACTIONS(6895),
    [anon_sym_constinit] = ACTIONS(6895),
    [anon_sym_consteval] = ACTIONS(6895),
    [anon_sym_alignas] = ACTIONS(6895),
    [anon_sym__Alignas] = ACTIONS(6895),
    [sym_primitive_type] = ACTIONS(6895),
    [anon_sym_enum] = ACTIONS(6895),
    [anon_sym_class] = ACTIONS(6895),
    [anon_sym_struct] = ACTIONS(6895),
    [anon_sym_union] = ACTIONS(6895),
    [anon_sym_L_DQUOTE] = ACTIONS(6899),
    [anon_sym_u_DQUOTE] = ACTIONS(6899),
    [anon_sym_U_DQUOTE] = ACTIONS(6899),
    [anon_sym_u8_DQUOTE] = ACTIONS(6899),
    [anon_sym_DQUOTE] = ACTIONS(6899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6895),
    [anon_sym_let] = ACTIONS(6895),
    [anon_sym_This] = ACTIONS(6895),
    [anon_sym_decltype] = ACTIONS(6895),
    [anon_sym_explicit] = ACTIONS(6895),
    [anon_sym_typename] = ACTIONS(6895),
    [anon_sym_template] = ACTIONS(6895),
    [anon_sym_operator] = ACTIONS(6895),
    [anon_sym_precise] = ACTIONS(6895),
    [anon_sym_shared] = ACTIONS(6895),
    [anon_sym_groupshared] = ACTIONS(6895),
    [anon_sym_uniform] = ACTIONS(6895),
    [anon_sym_row_major] = ACTIONS(6895),
    [anon_sym_column_major] = ACTIONS(6895),
    [anon_sym_globallycoherent] = ACTIONS(6895),
    [anon_sym_centroid] = ACTIONS(6895),
    [anon_sym_noperspective] = ACTIONS(6895),
    [anon_sym_nointerpolation] = ACTIONS(6895),
    [anon_sym_sample] = ACTIONS(6895),
    [anon_sym_linear] = ACTIONS(6895),
    [anon_sym_snorm] = ACTIONS(6895),
    [anon_sym_unorm] = ACTIONS(6895),
    [anon_sym_point] = ACTIONS(6895),
    [anon_sym_line] = ACTIONS(6895),
    [anon_sym_triangleadj] = ACTIONS(6895),
    [anon_sym_lineadj] = ACTIONS(6895),
    [anon_sym_triangle] = ACTIONS(6895),
    [anon_sym_interface] = ACTIONS(6895),
    [anon_sym_extension] = ACTIONS(6895),
  },
  [2777] = {
    [sym_type_qualifier] = STATE(2789),
    [sym_alignas_qualifier] = STATE(2845),
    [aux_sym__type_definition_type_repeat1] = STATE(2789),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3405),
    [sym_identifier] = ACTIONS(6933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3542),
    [anon_sym_COMMA] = ACTIONS(3542),
    [anon_sym_RPAREN] = ACTIONS(3542),
    [anon_sym_LPAREN2] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(3540),
    [anon_sym_SLASH] = ACTIONS(3540),
    [anon_sym_PERCENT] = ACTIONS(3540),
    [anon_sym_PIPE_PIPE] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_PIPE] = ACTIONS(3540),
    [anon_sym_CARET] = ACTIONS(3540),
    [anon_sym_AMP] = ACTIONS(3540),
    [anon_sym_EQ_EQ] = ACTIONS(3542),
    [anon_sym_BANG_EQ] = ACTIONS(3542),
    [anon_sym_GT] = ACTIONS(3540),
    [anon_sym_GT_EQ] = ACTIONS(3542),
    [anon_sym_LT_EQ] = ACTIONS(3540),
    [anon_sym_LT] = ACTIONS(3540),
    [anon_sym_LT_LT] = ACTIONS(3540),
    [anon_sym_GT_GT] = ACTIONS(3540),
    [anon_sym___extension__] = ACTIONS(6935),
    [anon_sym___attribute__] = ACTIONS(3540),
    [anon_sym___attribute] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_signed] = ACTIONS(6937),
    [anon_sym_unsigned] = ACTIONS(6937),
    [anon_sym_long] = ACTIONS(6937),
    [anon_sym_short] = ACTIONS(6937),
    [anon_sym_LBRACK] = ACTIONS(3542),
    [anon_sym_EQ] = ACTIONS(3540),
    [anon_sym_const] = ACTIONS(6935),
    [anon_sym_constexpr] = ACTIONS(6935),
    [anon_sym_volatile] = ACTIONS(6935),
    [anon_sym_restrict] = ACTIONS(6935),
    [anon_sym___restrict__] = ACTIONS(6935),
    [anon_sym__Atomic] = ACTIONS(6935),
    [anon_sym__Noreturn] = ACTIONS(6935),
    [anon_sym_noreturn] = ACTIONS(6935),
    [anon_sym__Nonnull] = ACTIONS(6935),
    [anon_sym_mutable] = ACTIONS(6935),
    [anon_sym_constinit] = ACTIONS(6935),
    [anon_sym_consteval] = ACTIONS(6935),
    [anon_sym_alignas] = ACTIONS(6939),
    [anon_sym__Alignas] = ACTIONS(6939),
    [sym_primitive_type] = ACTIONS(6941),
    [anon_sym_QMARK] = ACTIONS(3542),
    [anon_sym_STAR_EQ] = ACTIONS(3542),
    [anon_sym_SLASH_EQ] = ACTIONS(3542),
    [anon_sym_PERCENT_EQ] = ACTIONS(3542),
    [anon_sym_PLUS_EQ] = ACTIONS(3542),
    [anon_sym_DASH_EQ] = ACTIONS(3542),
    [anon_sym_LT_LT_EQ] = ACTIONS(3542),
    [anon_sym_GT_GT_EQ] = ACTIONS(3542),
    [anon_sym_AMP_EQ] = ACTIONS(3542),
    [anon_sym_CARET_EQ] = ACTIONS(3542),
    [anon_sym_PIPE_EQ] = ACTIONS(3542),
    [anon_sym_and_eq] = ACTIONS(3540),
    [anon_sym_or_eq] = ACTIONS(3540),
    [anon_sym_xor_eq] = ACTIONS(3540),
    [anon_sym_LT_EQ_GT] = ACTIONS(3542),
    [anon_sym_or] = ACTIONS(3540),
    [anon_sym_and] = ACTIONS(3540),
    [anon_sym_bitor] = ACTIONS(3540),
    [anon_sym_xor] = ACTIONS(3540),
    [anon_sym_bitand] = ACTIONS(3540),
    [anon_sym_not_eq] = ACTIONS(3540),
    [anon_sym_is] = ACTIONS(3540),
    [anon_sym_as] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(3542),
    [anon_sym_PLUS_PLUS] = ACTIONS(3542),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_DOT_STAR] = ACTIONS(3542),
    [anon_sym_DASH_GT] = ACTIONS(3540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3540),
    [anon_sym_let] = ACTIONS(3540),
    [anon_sym_This] = ACTIONS(3540),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3542),
  },
  [2778] = {
    [sym_type_qualifier] = STATE(2777),
    [sym_alignas_qualifier] = STATE(2845),
    [aux_sym__type_definition_type_repeat1] = STATE(2777),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2818),
    [sym_identifier] = ACTIONS(6943),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3423),
    [anon_sym_COMMA] = ACTIONS(3423),
    [anon_sym_RPAREN] = ACTIONS(3423),
    [anon_sym_LPAREN2] = ACTIONS(3423),
    [anon_sym_DASH] = ACTIONS(3428),
    [anon_sym_PLUS] = ACTIONS(3428),
    [anon_sym_STAR] = ACTIONS(3428),
    [anon_sym_SLASH] = ACTIONS(3428),
    [anon_sym_PERCENT] = ACTIONS(3428),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_PIPE] = ACTIONS(3428),
    [anon_sym_CARET] = ACTIONS(3428),
    [anon_sym_AMP] = ACTIONS(3428),
    [anon_sym_EQ_EQ] = ACTIONS(3423),
    [anon_sym_BANG_EQ] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3428),
    [anon_sym_GT_EQ] = ACTIONS(3423),
    [anon_sym_LT_EQ] = ACTIONS(3428),
    [anon_sym_LT] = ACTIONS(3428),
    [anon_sym_LT_LT] = ACTIONS(3428),
    [anon_sym_GT_GT] = ACTIONS(3428),
    [anon_sym___extension__] = ACTIONS(6935),
    [anon_sym___attribute__] = ACTIONS(3428),
    [anon_sym___attribute] = ACTIONS(3428),
    [anon_sym_LBRACE] = ACTIONS(3423),
    [anon_sym_signed] = ACTIONS(6945),
    [anon_sym_unsigned] = ACTIONS(6945),
    [anon_sym_long] = ACTIONS(6945),
    [anon_sym_short] = ACTIONS(6945),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_EQ] = ACTIONS(3428),
    [anon_sym_const] = ACTIONS(6935),
    [anon_sym_constexpr] = ACTIONS(6935),
    [anon_sym_volatile] = ACTIONS(6935),
    [anon_sym_restrict] = ACTIONS(6935),
    [anon_sym___restrict__] = ACTIONS(6935),
    [anon_sym__Atomic] = ACTIONS(6935),
    [anon_sym__Noreturn] = ACTIONS(6935),
    [anon_sym_noreturn] = ACTIONS(6935),
    [anon_sym__Nonnull] = ACTIONS(6935),
    [anon_sym_mutable] = ACTIONS(6935),
    [anon_sym_constinit] = ACTIONS(6935),
    [anon_sym_consteval] = ACTIONS(6935),
    [anon_sym_alignas] = ACTIONS(6939),
    [anon_sym__Alignas] = ACTIONS(6939),
    [sym_primitive_type] = ACTIONS(6947),
    [anon_sym_QMARK] = ACTIONS(3423),
    [anon_sym_STAR_EQ] = ACTIONS(3423),
    [anon_sym_SLASH_EQ] = ACTIONS(3423),
    [anon_sym_PERCENT_EQ] = ACTIONS(3423),
    [anon_sym_PLUS_EQ] = ACTIONS(3423),
    [anon_sym_DASH_EQ] = ACTIONS(3423),
    [anon_sym_LT_LT_EQ] = ACTIONS(3423),
    [anon_sym_GT_GT_EQ] = ACTIONS(3423),
    [anon_sym_AMP_EQ] = ACTIONS(3423),
    [anon_sym_CARET_EQ] = ACTIONS(3423),
    [anon_sym_PIPE_EQ] = ACTIONS(3423),
    [anon_sym_and_eq] = ACTIONS(3428),
    [anon_sym_or_eq] = ACTIONS(3428),
    [anon_sym_xor_eq] = ACTIONS(3428),
    [anon_sym_LT_EQ_GT] = ACTIONS(3423),
    [anon_sym_or] = ACTIONS(3428),
    [anon_sym_and] = ACTIONS(3428),
    [anon_sym_bitor] = ACTIONS(3428),
    [anon_sym_xor] = ACTIONS(3428),
    [anon_sym_bitand] = ACTIONS(3428),
    [anon_sym_not_eq] = ACTIONS(3428),
    [anon_sym_is] = ACTIONS(3428),
    [anon_sym_as] = ACTIONS(3428),
    [anon_sym_DASH_DASH] = ACTIONS(3423),
    [anon_sym_PLUS_PLUS] = ACTIONS(3423),
    [anon_sym_DOT] = ACTIONS(3428),
    [anon_sym_DOT_STAR] = ACTIONS(3423),
    [anon_sym_DASH_GT] = ACTIONS(3428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3428),
    [anon_sym_let] = ACTIONS(3428),
    [anon_sym_This] = ACTIONS(3428),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3423),
  },
  [2779] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4121),
    [anon_sym_COMMA] = ACTIONS(4121),
    [aux_sym_preproc_if_token2] = ACTIONS(4121),
    [aux_sym_preproc_else_token1] = ACTIONS(4121),
    [aux_sym_preproc_elif_token1] = ACTIONS(4124),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4121),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4121),
    [anon_sym_LPAREN2] = ACTIONS(4121),
    [anon_sym_DASH] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4124),
    [anon_sym_STAR] = ACTIONS(4124),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_PIPE_PIPE] = ACTIONS(4121),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE] = ACTIONS(4124),
    [anon_sym_CARET] = ACTIONS(4124),
    [anon_sym_AMP] = ACTIONS(4124),
    [anon_sym_EQ_EQ] = ACTIONS(4121),
    [anon_sym_BANG_EQ] = ACTIONS(4121),
    [anon_sym_GT] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4121),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_LT_LT] = ACTIONS(4124),
    [anon_sym_GT_GT] = ACTIONS(4124),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(4124),
    [anon_sym___attribute] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_signed] = ACTIONS(6836),
    [anon_sym_unsigned] = ACTIONS(6836),
    [anon_sym_long] = ACTIONS(6836),
    [anon_sym_short] = ACTIONS(6836),
    [anon_sym_LBRACK] = ACTIONS(4121),
    [anon_sym_EQ] = ACTIONS(4124),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(4121),
    [anon_sym_STAR_EQ] = ACTIONS(4121),
    [anon_sym_SLASH_EQ] = ACTIONS(4121),
    [anon_sym_PERCENT_EQ] = ACTIONS(4121),
    [anon_sym_PLUS_EQ] = ACTIONS(4121),
    [anon_sym_DASH_EQ] = ACTIONS(4121),
    [anon_sym_LT_LT_EQ] = ACTIONS(4121),
    [anon_sym_GT_GT_EQ] = ACTIONS(4121),
    [anon_sym_AMP_EQ] = ACTIONS(4121),
    [anon_sym_CARET_EQ] = ACTIONS(4121),
    [anon_sym_PIPE_EQ] = ACTIONS(4121),
    [anon_sym_and_eq] = ACTIONS(4124),
    [anon_sym_or_eq] = ACTIONS(4124),
    [anon_sym_xor_eq] = ACTIONS(4124),
    [anon_sym_LT_EQ_GT] = ACTIONS(4121),
    [anon_sym_or] = ACTIONS(4124),
    [anon_sym_and] = ACTIONS(4124),
    [anon_sym_bitor] = ACTIONS(4124),
    [anon_sym_xor] = ACTIONS(4124),
    [anon_sym_bitand] = ACTIONS(4124),
    [anon_sym_not_eq] = ACTIONS(4124),
    [anon_sym_is] = ACTIONS(4124),
    [anon_sym_as] = ACTIONS(4124),
    [anon_sym_DASH_DASH] = ACTIONS(4121),
    [anon_sym_PLUS_PLUS] = ACTIONS(4121),
    [anon_sym_DOT] = ACTIONS(4124),
    [anon_sym_DOT_STAR] = ACTIONS(4121),
    [anon_sym_DASH_GT] = ACTIONS(4121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4124),
    [anon_sym_let] = ACTIONS(4124),
    [anon_sym_This] = ACTIONS(4124),
  },
  [2780] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(2915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4121),
    [anon_sym_COMMA] = ACTIONS(4121),
    [anon_sym_RPAREN] = ACTIONS(4121),
    [anon_sym_LPAREN2] = ACTIONS(4121),
    [anon_sym_DASH] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4124),
    [anon_sym_STAR] = ACTIONS(4124),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_PIPE_PIPE] = ACTIONS(4121),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE] = ACTIONS(4124),
    [anon_sym_CARET] = ACTIONS(4124),
    [anon_sym_AMP] = ACTIONS(4124),
    [anon_sym_EQ_EQ] = ACTIONS(4121),
    [anon_sym_BANG_EQ] = ACTIONS(4121),
    [anon_sym_GT] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4121),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_LT_LT] = ACTIONS(4124),
    [anon_sym_GT_GT] = ACTIONS(4124),
    [anon_sym_COLON] = ACTIONS(4121),
    [anon_sym_SEMI] = ACTIONS(4121),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(4124),
    [anon_sym___attribute] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_RBRACE] = ACTIONS(4121),
    [anon_sym_signed] = ACTIONS(6836),
    [anon_sym_unsigned] = ACTIONS(6836),
    [anon_sym_long] = ACTIONS(6836),
    [anon_sym_short] = ACTIONS(6836),
    [anon_sym_LBRACK] = ACTIONS(4121),
    [anon_sym_RBRACK] = ACTIONS(4121),
    [anon_sym_EQ] = ACTIONS(4124),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(4121),
    [anon_sym_STAR_EQ] = ACTIONS(4121),
    [anon_sym_SLASH_EQ] = ACTIONS(4121),
    [anon_sym_PERCENT_EQ] = ACTIONS(4121),
    [anon_sym_PLUS_EQ] = ACTIONS(4121),
    [anon_sym_DASH_EQ] = ACTIONS(4121),
    [anon_sym_LT_LT_EQ] = ACTIONS(4121),
    [anon_sym_GT_GT_EQ] = ACTIONS(4121),
    [anon_sym_AMP_EQ] = ACTIONS(4121),
    [anon_sym_CARET_EQ] = ACTIONS(4121),
    [anon_sym_PIPE_EQ] = ACTIONS(4121),
    [anon_sym_and_eq] = ACTIONS(4124),
    [anon_sym_or_eq] = ACTIONS(4124),
    [anon_sym_xor_eq] = ACTIONS(4124),
    [anon_sym_LT_EQ_GT] = ACTIONS(4121),
    [anon_sym_or] = ACTIONS(4124),
    [anon_sym_and] = ACTIONS(4124),
    [anon_sym_bitor] = ACTIONS(4124),
    [anon_sym_xor] = ACTIONS(4124),
    [anon_sym_bitand] = ACTIONS(4124),
    [anon_sym_not_eq] = ACTIONS(4124),
    [anon_sym_is] = ACTIONS(4124),
    [anon_sym_as] = ACTIONS(4124),
    [anon_sym_DASH_DASH] = ACTIONS(4121),
    [anon_sym_PLUS_PLUS] = ACTIONS(4121),
    [anon_sym_DOT] = ACTIONS(4124),
    [anon_sym_DOT_STAR] = ACTIONS(4121),
    [anon_sym_DASH_GT] = ACTIONS(4121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4124),
    [anon_sym_let] = ACTIONS(4124),
    [anon_sym_This] = ACTIONS(4124),
  },
  [2781] = {
    [sym__declaration_modifiers] = STATE(2773),
    [sym_attribute_specifier] = STATE(2773),
    [sym_attribute_declaration] = STATE(2773),
    [sym_ms_declspec_modifier] = STATE(2773),
    [sym_storage_class_specifier] = STATE(2773),
    [sym_type_qualifier] = STATE(2773),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_qualifiers] = STATE(2773),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2773),
    [sym_identifier] = ACTIONS(6949),
    [anon_sym_LPAREN2] = ACTIONS(6951),
    [anon_sym_TILDE] = ACTIONS(6951),
    [anon_sym_STAR] = ACTIONS(6951),
    [anon_sym_AMP_AMP] = ACTIONS(6951),
    [anon_sym_AMP] = ACTIONS(6949),
    [anon_sym_SEMI] = ACTIONS(6953),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(6955),
    [anon_sym_out] = ACTIONS(6955),
    [anon_sym_inout] = ACTIONS(6955),
    [anon_sym_virtual] = ACTIONS(6955),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(6951),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(6949),
    [anon_sym___cdecl] = ACTIONS(6949),
    [anon_sym___clrcall] = ACTIONS(6949),
    [anon_sym___stdcall] = ACTIONS(6949),
    [anon_sym___fastcall] = ACTIONS(6949),
    [anon_sym___thiscall] = ACTIONS(6949),
    [anon_sym___vectorcall] = ACTIONS(6949),
    [anon_sym_LBRACK] = ACTIONS(6949),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [anon_sym_DOT] = ACTIONS(6957),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6959),
    [anon_sym_let] = ACTIONS(6959),
    [anon_sym_This] = ACTIONS(6959),
    [anon_sym_decltype] = ACTIONS(6949),
    [anon_sym_template] = ACTIONS(6949),
    [anon_sym_operator] = ACTIONS(6949),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [2782] = {
    [sym__declaration_modifiers] = STATE(2773),
    [sym_attribute_specifier] = STATE(2773),
    [sym_attribute_declaration] = STATE(2773),
    [sym_ms_declspec_modifier] = STATE(2773),
    [sym_storage_class_specifier] = STATE(2773),
    [sym_type_qualifier] = STATE(2773),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_qualifiers] = STATE(2773),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2773),
    [sym_identifier] = ACTIONS(6949),
    [anon_sym_LPAREN2] = ACTIONS(6951),
    [anon_sym_TILDE] = ACTIONS(6951),
    [anon_sym_STAR] = ACTIONS(6951),
    [anon_sym_AMP_AMP] = ACTIONS(6951),
    [anon_sym_AMP] = ACTIONS(6949),
    [anon_sym_SEMI] = ACTIONS(6961),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(6955),
    [anon_sym_out] = ACTIONS(6955),
    [anon_sym_inout] = ACTIONS(6955),
    [anon_sym_virtual] = ACTIONS(6955),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(6951),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(6949),
    [anon_sym___cdecl] = ACTIONS(6949),
    [anon_sym___clrcall] = ACTIONS(6949),
    [anon_sym___stdcall] = ACTIONS(6949),
    [anon_sym___fastcall] = ACTIONS(6949),
    [anon_sym___thiscall] = ACTIONS(6949),
    [anon_sym___vectorcall] = ACTIONS(6949),
    [anon_sym_LBRACK] = ACTIONS(6949),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [anon_sym_DOT] = ACTIONS(6957),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6959),
    [anon_sym_let] = ACTIONS(6959),
    [anon_sym_This] = ACTIONS(6959),
    [anon_sym_decltype] = ACTIONS(6949),
    [anon_sym_template] = ACTIONS(6949),
    [anon_sym_operator] = ACTIONS(6949),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [2783] = {
    [sym_attribute_specifier] = STATE(2885),
    [sym_enumerator_list] = STATE(2831),
    [sym_identifier] = ACTIONS(3989),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3987),
    [anon_sym_COMMA] = ACTIONS(3987),
    [anon_sym_RPAREN] = ACTIONS(3987),
    [anon_sym_LPAREN2] = ACTIONS(3987),
    [anon_sym_TILDE] = ACTIONS(3987),
    [anon_sym_STAR] = ACTIONS(3987),
    [anon_sym_AMP_AMP] = ACTIONS(3987),
    [anon_sym_AMP] = ACTIONS(3989),
    [anon_sym_COLON] = ACTIONS(3989),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym___extension__] = ACTIONS(3989),
    [anon_sym_in] = ACTIONS(3989),
    [anon_sym_out] = ACTIONS(3989),
    [anon_sym_inout] = ACTIONS(3989),
    [anon_sym_virtual] = ACTIONS(3989),
    [anon_sym_extern] = ACTIONS(3989),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(3987),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3987),
    [anon_sym___declspec] = ACTIONS(3989),
    [anon_sym___based] = ACTIONS(3989),
    [anon_sym___cdecl] = ACTIONS(3989),
    [anon_sym___clrcall] = ACTIONS(3989),
    [anon_sym___stdcall] = ACTIONS(3989),
    [anon_sym___fastcall] = ACTIONS(3989),
    [anon_sym___thiscall] = ACTIONS(3989),
    [anon_sym___vectorcall] = ACTIONS(3989),
    [anon_sym_LBRACE] = ACTIONS(6963),
    [anon_sym_LBRACK] = ACTIONS(3989),
    [anon_sym_static] = ACTIONS(3989),
    [anon_sym_EQ] = ACTIONS(3987),
    [anon_sym_register] = ACTIONS(3989),
    [anon_sym_inline] = ACTIONS(3989),
    [anon_sym___inline] = ACTIONS(3989),
    [anon_sym___inline__] = ACTIONS(3989),
    [anon_sym___forceinline] = ACTIONS(3989),
    [anon_sym_thread_local] = ACTIONS(3989),
    [anon_sym___thread] = ACTIONS(3989),
    [anon_sym_const] = ACTIONS(3989),
    [anon_sym_constexpr] = ACTIONS(3989),
    [anon_sym_volatile] = ACTIONS(3989),
    [anon_sym_restrict] = ACTIONS(3989),
    [anon_sym___restrict__] = ACTIONS(3989),
    [anon_sym__Atomic] = ACTIONS(3989),
    [anon_sym__Noreturn] = ACTIONS(3989),
    [anon_sym_noreturn] = ACTIONS(3989),
    [anon_sym__Nonnull] = ACTIONS(3989),
    [anon_sym_mutable] = ACTIONS(3989),
    [anon_sym_constinit] = ACTIONS(3989),
    [anon_sym_consteval] = ACTIONS(3989),
    [anon_sym_alignas] = ACTIONS(3989),
    [anon_sym__Alignas] = ACTIONS(3989),
    [anon_sym_DOT] = ACTIONS(3989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3989),
    [anon_sym_let] = ACTIONS(3989),
    [anon_sym_This] = ACTIONS(3989),
    [anon_sym_decltype] = ACTIONS(3989),
    [anon_sym_template] = ACTIONS(3989),
    [anon_sym_GT2] = ACTIONS(3987),
    [anon_sym_operator] = ACTIONS(3989),
    [anon_sym_precise] = ACTIONS(3989),
    [anon_sym_shared] = ACTIONS(3989),
    [anon_sym_groupshared] = ACTIONS(3989),
    [anon_sym_uniform] = ACTIONS(3989),
    [anon_sym_row_major] = ACTIONS(3989),
    [anon_sym_column_major] = ACTIONS(3989),
    [anon_sym_globallycoherent] = ACTIONS(3989),
    [anon_sym_centroid] = ACTIONS(3989),
    [anon_sym_noperspective] = ACTIONS(3989),
    [anon_sym_nointerpolation] = ACTIONS(3989),
    [anon_sym_sample] = ACTIONS(3989),
    [anon_sym_linear] = ACTIONS(3989),
    [anon_sym_snorm] = ACTIONS(3989),
    [anon_sym_unorm] = ACTIONS(3989),
    [anon_sym_point] = ACTIONS(3989),
    [anon_sym_line] = ACTIONS(3989),
    [anon_sym_triangleadj] = ACTIONS(3989),
    [anon_sym_lineadj] = ACTIONS(3989),
    [anon_sym_triangle] = ACTIONS(3989),
  },
  [2784] = {
    [sym_attribute_specifier] = STATE(2868),
    [sym_enumerator_list] = STATE(2814),
    [sym_identifier] = ACTIONS(3993),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3991),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_LPAREN2] = ACTIONS(3991),
    [anon_sym_TILDE] = ACTIONS(3991),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym___extension__] = ACTIONS(3993),
    [anon_sym_in] = ACTIONS(3993),
    [anon_sym_out] = ACTIONS(3993),
    [anon_sym_inout] = ACTIONS(3993),
    [anon_sym_virtual] = ACTIONS(3993),
    [anon_sym_extern] = ACTIONS(3993),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3991),
    [anon_sym___declspec] = ACTIONS(3993),
    [anon_sym___based] = ACTIONS(3993),
    [anon_sym___cdecl] = ACTIONS(3993),
    [anon_sym___clrcall] = ACTIONS(3993),
    [anon_sym___stdcall] = ACTIONS(3993),
    [anon_sym___fastcall] = ACTIONS(3993),
    [anon_sym___thiscall] = ACTIONS(3993),
    [anon_sym___vectorcall] = ACTIONS(3993),
    [anon_sym_LBRACE] = ACTIONS(6963),
    [anon_sym_LBRACK] = ACTIONS(3993),
    [anon_sym_static] = ACTIONS(3993),
    [anon_sym_EQ] = ACTIONS(3991),
    [anon_sym_register] = ACTIONS(3993),
    [anon_sym_inline] = ACTIONS(3993),
    [anon_sym___inline] = ACTIONS(3993),
    [anon_sym___inline__] = ACTIONS(3993),
    [anon_sym___forceinline] = ACTIONS(3993),
    [anon_sym_thread_local] = ACTIONS(3993),
    [anon_sym___thread] = ACTIONS(3993),
    [anon_sym_const] = ACTIONS(3993),
    [anon_sym_constexpr] = ACTIONS(3993),
    [anon_sym_volatile] = ACTIONS(3993),
    [anon_sym_restrict] = ACTIONS(3993),
    [anon_sym___restrict__] = ACTIONS(3993),
    [anon_sym__Atomic] = ACTIONS(3993),
    [anon_sym__Noreturn] = ACTIONS(3993),
    [anon_sym_noreturn] = ACTIONS(3993),
    [anon_sym__Nonnull] = ACTIONS(3993),
    [anon_sym_mutable] = ACTIONS(3993),
    [anon_sym_constinit] = ACTIONS(3993),
    [anon_sym_consteval] = ACTIONS(3993),
    [anon_sym_alignas] = ACTIONS(3993),
    [anon_sym__Alignas] = ACTIONS(3993),
    [anon_sym_DOT] = ACTIONS(3993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3993),
    [anon_sym_let] = ACTIONS(3993),
    [anon_sym_This] = ACTIONS(3993),
    [anon_sym_decltype] = ACTIONS(3993),
    [anon_sym_template] = ACTIONS(3993),
    [anon_sym_GT2] = ACTIONS(3991),
    [anon_sym_operator] = ACTIONS(3993),
    [anon_sym_precise] = ACTIONS(3993),
    [anon_sym_shared] = ACTIONS(3993),
    [anon_sym_groupshared] = ACTIONS(3993),
    [anon_sym_uniform] = ACTIONS(3993),
    [anon_sym_row_major] = ACTIONS(3993),
    [anon_sym_column_major] = ACTIONS(3993),
    [anon_sym_globallycoherent] = ACTIONS(3993),
    [anon_sym_centroid] = ACTIONS(3993),
    [anon_sym_noperspective] = ACTIONS(3993),
    [anon_sym_nointerpolation] = ACTIONS(3993),
    [anon_sym_sample] = ACTIONS(3993),
    [anon_sym_linear] = ACTIONS(3993),
    [anon_sym_snorm] = ACTIONS(3993),
    [anon_sym_unorm] = ACTIONS(3993),
    [anon_sym_point] = ACTIONS(3993),
    [anon_sym_line] = ACTIONS(3993),
    [anon_sym_triangleadj] = ACTIONS(3993),
    [anon_sym_lineadj] = ACTIONS(3993),
    [anon_sym_triangle] = ACTIONS(3993),
  },
  [2785] = {
    [sym__declaration_modifiers] = STATE(2773),
    [sym_attribute_specifier] = STATE(2773),
    [sym_attribute_declaration] = STATE(2773),
    [sym_ms_declspec_modifier] = STATE(2773),
    [sym_storage_class_specifier] = STATE(2773),
    [sym_type_qualifier] = STATE(2773),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_qualifiers] = STATE(2773),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2773),
    [sym_identifier] = ACTIONS(6949),
    [anon_sym_LPAREN2] = ACTIONS(6951),
    [anon_sym_TILDE] = ACTIONS(6951),
    [anon_sym_STAR] = ACTIONS(6951),
    [anon_sym_AMP_AMP] = ACTIONS(6951),
    [anon_sym_AMP] = ACTIONS(6949),
    [anon_sym_SEMI] = ACTIONS(6965),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(6955),
    [anon_sym_out] = ACTIONS(6955),
    [anon_sym_inout] = ACTIONS(6955),
    [anon_sym_virtual] = ACTIONS(6955),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(6951),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(6949),
    [anon_sym___cdecl] = ACTIONS(6949),
    [anon_sym___clrcall] = ACTIONS(6949),
    [anon_sym___stdcall] = ACTIONS(6949),
    [anon_sym___fastcall] = ACTIONS(6949),
    [anon_sym___thiscall] = ACTIONS(6949),
    [anon_sym___vectorcall] = ACTIONS(6949),
    [anon_sym_LBRACK] = ACTIONS(6949),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [anon_sym_DOT] = ACTIONS(6957),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6959),
    [anon_sym_let] = ACTIONS(6959),
    [anon_sym_This] = ACTIONS(6959),
    [anon_sym_decltype] = ACTIONS(6949),
    [anon_sym_template] = ACTIONS(6949),
    [anon_sym_operator] = ACTIONS(6949),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [2786] = {
    [sym__declaration_modifiers] = STATE(2773),
    [sym_attribute_specifier] = STATE(2773),
    [sym_attribute_declaration] = STATE(2773),
    [sym_ms_declspec_modifier] = STATE(2773),
    [sym_storage_class_specifier] = STATE(2773),
    [sym_type_qualifier] = STATE(2773),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_qualifiers] = STATE(2773),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2773),
    [sym_identifier] = ACTIONS(6949),
    [anon_sym_LPAREN2] = ACTIONS(6951),
    [anon_sym_TILDE] = ACTIONS(6951),
    [anon_sym_STAR] = ACTIONS(6951),
    [anon_sym_AMP_AMP] = ACTIONS(6951),
    [anon_sym_AMP] = ACTIONS(6949),
    [anon_sym_SEMI] = ACTIONS(6967),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(6955),
    [anon_sym_out] = ACTIONS(6955),
    [anon_sym_inout] = ACTIONS(6955),
    [anon_sym_virtual] = ACTIONS(6955),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(6951),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(6949),
    [anon_sym___cdecl] = ACTIONS(6949),
    [anon_sym___clrcall] = ACTIONS(6949),
    [anon_sym___stdcall] = ACTIONS(6949),
    [anon_sym___fastcall] = ACTIONS(6949),
    [anon_sym___thiscall] = ACTIONS(6949),
    [anon_sym___vectorcall] = ACTIONS(6949),
    [anon_sym_LBRACK] = ACTIONS(6949),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [anon_sym_DOT] = ACTIONS(6957),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6959),
    [anon_sym_let] = ACTIONS(6959),
    [anon_sym_This] = ACTIONS(6959),
    [anon_sym_decltype] = ACTIONS(6949),
    [anon_sym_template] = ACTIONS(6949),
    [anon_sym_operator] = ACTIONS(6949),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [2787] = {
    [sym__declaration_modifiers] = STATE(2773),
    [sym_attribute_specifier] = STATE(2773),
    [sym_attribute_declaration] = STATE(2773),
    [sym_ms_declspec_modifier] = STATE(2773),
    [sym_storage_class_specifier] = STATE(2773),
    [sym_type_qualifier] = STATE(2773),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_qualifiers] = STATE(2773),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2773),
    [sym_identifier] = ACTIONS(6949),
    [anon_sym_LPAREN2] = ACTIONS(6951),
    [anon_sym_TILDE] = ACTIONS(6951),
    [anon_sym_STAR] = ACTIONS(6951),
    [anon_sym_AMP_AMP] = ACTIONS(6951),
    [anon_sym_AMP] = ACTIONS(6949),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(6955),
    [anon_sym_out] = ACTIONS(6955),
    [anon_sym_inout] = ACTIONS(6955),
    [anon_sym_virtual] = ACTIONS(6955),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(6951),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(6949),
    [anon_sym___cdecl] = ACTIONS(6949),
    [anon_sym___clrcall] = ACTIONS(6949),
    [anon_sym___stdcall] = ACTIONS(6949),
    [anon_sym___fastcall] = ACTIONS(6949),
    [anon_sym___thiscall] = ACTIONS(6949),
    [anon_sym___vectorcall] = ACTIONS(6949),
    [anon_sym_LBRACK] = ACTIONS(6949),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [anon_sym_DOT] = ACTIONS(6957),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6959),
    [anon_sym_let] = ACTIONS(6959),
    [anon_sym_This] = ACTIONS(6959),
    [anon_sym_decltype] = ACTIONS(6949),
    [anon_sym_template] = ACTIONS(6949),
    [anon_sym_operator] = ACTIONS(6949),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [2788] = {
    [sym_type_qualifier] = STATE(2790),
    [sym_alignas_qualifier] = STATE(2907),
    [aux_sym__type_definition_type_repeat1] = STATE(2790),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2889),
    [sym_identifier] = ACTIONS(6971),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3423),
    [anon_sym_COMMA] = ACTIONS(3423),
    [anon_sym_LPAREN2] = ACTIONS(3423),
    [anon_sym_DASH] = ACTIONS(3428),
    [anon_sym_PLUS] = ACTIONS(3428),
    [anon_sym_STAR] = ACTIONS(3428),
    [anon_sym_SLASH] = ACTIONS(3428),
    [anon_sym_PERCENT] = ACTIONS(3428),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_PIPE] = ACTIONS(3428),
    [anon_sym_CARET] = ACTIONS(3428),
    [anon_sym_AMP] = ACTIONS(3428),
    [anon_sym_EQ_EQ] = ACTIONS(3423),
    [anon_sym_BANG_EQ] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3428),
    [anon_sym_GT_EQ] = ACTIONS(3428),
    [anon_sym_LT_EQ] = ACTIONS(3428),
    [anon_sym_LT] = ACTIONS(3428),
    [anon_sym_LT_LT] = ACTIONS(3428),
    [anon_sym_GT_GT] = ACTIONS(3428),
    [anon_sym___extension__] = ACTIONS(6973),
    [anon_sym___attribute__] = ACTIONS(3428),
    [anon_sym___attribute] = ACTIONS(3428),
    [anon_sym_LBRACE] = ACTIONS(3423),
    [anon_sym_signed] = ACTIONS(6975),
    [anon_sym_unsigned] = ACTIONS(6975),
    [anon_sym_long] = ACTIONS(6975),
    [anon_sym_short] = ACTIONS(6975),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_EQ] = ACTIONS(3428),
    [anon_sym_const] = ACTIONS(6973),
    [anon_sym_constexpr] = ACTIONS(6973),
    [anon_sym_volatile] = ACTIONS(6973),
    [anon_sym_restrict] = ACTIONS(6973),
    [anon_sym___restrict__] = ACTIONS(6973),
    [anon_sym__Atomic] = ACTIONS(6973),
    [anon_sym__Noreturn] = ACTIONS(6973),
    [anon_sym_noreturn] = ACTIONS(6973),
    [anon_sym__Nonnull] = ACTIONS(6973),
    [anon_sym_mutable] = ACTIONS(6973),
    [anon_sym_constinit] = ACTIONS(6973),
    [anon_sym_consteval] = ACTIONS(6973),
    [anon_sym_alignas] = ACTIONS(6977),
    [anon_sym__Alignas] = ACTIONS(6977),
    [sym_primitive_type] = ACTIONS(6979),
    [anon_sym_QMARK] = ACTIONS(3423),
    [anon_sym_STAR_EQ] = ACTIONS(3423),
    [anon_sym_SLASH_EQ] = ACTIONS(3423),
    [anon_sym_PERCENT_EQ] = ACTIONS(3423),
    [anon_sym_PLUS_EQ] = ACTIONS(3423),
    [anon_sym_DASH_EQ] = ACTIONS(3423),
    [anon_sym_LT_LT_EQ] = ACTIONS(3423),
    [anon_sym_GT_GT_EQ] = ACTIONS(3428),
    [anon_sym_AMP_EQ] = ACTIONS(3423),
    [anon_sym_CARET_EQ] = ACTIONS(3423),
    [anon_sym_PIPE_EQ] = ACTIONS(3423),
    [anon_sym_and_eq] = ACTIONS(3428),
    [anon_sym_or_eq] = ACTIONS(3428),
    [anon_sym_xor_eq] = ACTIONS(3428),
    [anon_sym_LT_EQ_GT] = ACTIONS(3423),
    [anon_sym_or] = ACTIONS(3428),
    [anon_sym_and] = ACTIONS(3428),
    [anon_sym_bitor] = ACTIONS(3428),
    [anon_sym_xor] = ACTIONS(3428),
    [anon_sym_bitand] = ACTIONS(3428),
    [anon_sym_not_eq] = ACTIONS(3428),
    [anon_sym_is] = ACTIONS(3428),
    [anon_sym_as] = ACTIONS(3428),
    [anon_sym_DASH_DASH] = ACTIONS(3423),
    [anon_sym_PLUS_PLUS] = ACTIONS(3423),
    [anon_sym_DOT] = ACTIONS(3428),
    [anon_sym_DOT_STAR] = ACTIONS(3423),
    [anon_sym_DASH_GT] = ACTIONS(3423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3428),
    [anon_sym_let] = ACTIONS(3428),
    [anon_sym_This] = ACTIONS(3428),
    [anon_sym_GT2] = ACTIONS(3423),
  },
  [2789] = {
    [sym_type_qualifier] = STATE(2789),
    [sym_alignas_qualifier] = STATE(2845),
    [aux_sym__type_definition_type_repeat1] = STATE(2789),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3681),
    [anon_sym_COMMA] = ACTIONS(3681),
    [anon_sym_RPAREN] = ACTIONS(3681),
    [anon_sym_LPAREN2] = ACTIONS(3681),
    [anon_sym_DASH] = ACTIONS(3683),
    [anon_sym_PLUS] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(3683),
    [anon_sym_SLASH] = ACTIONS(3683),
    [anon_sym_PERCENT] = ACTIONS(3683),
    [anon_sym_PIPE_PIPE] = ACTIONS(3681),
    [anon_sym_AMP_AMP] = ACTIONS(3681),
    [anon_sym_PIPE] = ACTIONS(3683),
    [anon_sym_CARET] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_EQ_EQ] = ACTIONS(3681),
    [anon_sym_BANG_EQ] = ACTIONS(3681),
    [anon_sym_GT] = ACTIONS(3683),
    [anon_sym_GT_EQ] = ACTIONS(3681),
    [anon_sym_LT_EQ] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_LT_LT] = ACTIONS(3683),
    [anon_sym_GT_GT] = ACTIONS(3683),
    [anon_sym___extension__] = ACTIONS(6981),
    [anon_sym___attribute__] = ACTIONS(3683),
    [anon_sym___attribute] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3681),
    [anon_sym_signed] = ACTIONS(3683),
    [anon_sym_unsigned] = ACTIONS(3683),
    [anon_sym_long] = ACTIONS(3683),
    [anon_sym_short] = ACTIONS(3683),
    [anon_sym_LBRACK] = ACTIONS(3681),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_const] = ACTIONS(6981),
    [anon_sym_constexpr] = ACTIONS(6981),
    [anon_sym_volatile] = ACTIONS(6981),
    [anon_sym_restrict] = ACTIONS(6981),
    [anon_sym___restrict__] = ACTIONS(6981),
    [anon_sym__Atomic] = ACTIONS(6981),
    [anon_sym__Noreturn] = ACTIONS(6981),
    [anon_sym_noreturn] = ACTIONS(6981),
    [anon_sym__Nonnull] = ACTIONS(6981),
    [anon_sym_mutable] = ACTIONS(6981),
    [anon_sym_constinit] = ACTIONS(6981),
    [anon_sym_consteval] = ACTIONS(6981),
    [anon_sym_alignas] = ACTIONS(6984),
    [anon_sym__Alignas] = ACTIONS(6984),
    [sym_primitive_type] = ACTIONS(3683),
    [anon_sym_QMARK] = ACTIONS(3681),
    [anon_sym_STAR_EQ] = ACTIONS(3681),
    [anon_sym_SLASH_EQ] = ACTIONS(3681),
    [anon_sym_PERCENT_EQ] = ACTIONS(3681),
    [anon_sym_PLUS_EQ] = ACTIONS(3681),
    [anon_sym_DASH_EQ] = ACTIONS(3681),
    [anon_sym_LT_LT_EQ] = ACTIONS(3681),
    [anon_sym_GT_GT_EQ] = ACTIONS(3681),
    [anon_sym_AMP_EQ] = ACTIONS(3681),
    [anon_sym_CARET_EQ] = ACTIONS(3681),
    [anon_sym_PIPE_EQ] = ACTIONS(3681),
    [anon_sym_and_eq] = ACTIONS(3683),
    [anon_sym_or_eq] = ACTIONS(3683),
    [anon_sym_xor_eq] = ACTIONS(3683),
    [anon_sym_LT_EQ_GT] = ACTIONS(3681),
    [anon_sym_or] = ACTIONS(3683),
    [anon_sym_and] = ACTIONS(3683),
    [anon_sym_bitor] = ACTIONS(3683),
    [anon_sym_xor] = ACTIONS(3683),
    [anon_sym_bitand] = ACTIONS(3683),
    [anon_sym_not_eq] = ACTIONS(3683),
    [anon_sym_is] = ACTIONS(3683),
    [anon_sym_as] = ACTIONS(3683),
    [anon_sym_DASH_DASH] = ACTIONS(3681),
    [anon_sym_PLUS_PLUS] = ACTIONS(3681),
    [anon_sym_DOT] = ACTIONS(3683),
    [anon_sym_DOT_STAR] = ACTIONS(3681),
    [anon_sym_DASH_GT] = ACTIONS(3683),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3683),
    [anon_sym_let] = ACTIONS(3683),
    [anon_sym_This] = ACTIONS(3683),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3681),
  },
  [2790] = {
    [sym_type_qualifier] = STATE(2804),
    [sym_alignas_qualifier] = STATE(2907),
    [aux_sym__type_definition_type_repeat1] = STATE(2804),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3513),
    [sym_identifier] = ACTIONS(6987),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3542),
    [anon_sym_COMMA] = ACTIONS(3542),
    [anon_sym_LPAREN2] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(3540),
    [anon_sym_SLASH] = ACTIONS(3540),
    [anon_sym_PERCENT] = ACTIONS(3540),
    [anon_sym_PIPE_PIPE] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_PIPE] = ACTIONS(3540),
    [anon_sym_CARET] = ACTIONS(3540),
    [anon_sym_AMP] = ACTIONS(3540),
    [anon_sym_EQ_EQ] = ACTIONS(3542),
    [anon_sym_BANG_EQ] = ACTIONS(3542),
    [anon_sym_GT] = ACTIONS(3540),
    [anon_sym_GT_EQ] = ACTIONS(3540),
    [anon_sym_LT_EQ] = ACTIONS(3540),
    [anon_sym_LT] = ACTIONS(3540),
    [anon_sym_LT_LT] = ACTIONS(3540),
    [anon_sym_GT_GT] = ACTIONS(3540),
    [anon_sym___extension__] = ACTIONS(6973),
    [anon_sym___attribute__] = ACTIONS(3540),
    [anon_sym___attribute] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_signed] = ACTIONS(6989),
    [anon_sym_unsigned] = ACTIONS(6989),
    [anon_sym_long] = ACTIONS(6989),
    [anon_sym_short] = ACTIONS(6989),
    [anon_sym_LBRACK] = ACTIONS(3542),
    [anon_sym_EQ] = ACTIONS(3540),
    [anon_sym_const] = ACTIONS(6973),
    [anon_sym_constexpr] = ACTIONS(6973),
    [anon_sym_volatile] = ACTIONS(6973),
    [anon_sym_restrict] = ACTIONS(6973),
    [anon_sym___restrict__] = ACTIONS(6973),
    [anon_sym__Atomic] = ACTIONS(6973),
    [anon_sym__Noreturn] = ACTIONS(6973),
    [anon_sym_noreturn] = ACTIONS(6973),
    [anon_sym__Nonnull] = ACTIONS(6973),
    [anon_sym_mutable] = ACTIONS(6973),
    [anon_sym_constinit] = ACTIONS(6973),
    [anon_sym_consteval] = ACTIONS(6973),
    [anon_sym_alignas] = ACTIONS(6977),
    [anon_sym__Alignas] = ACTIONS(6977),
    [sym_primitive_type] = ACTIONS(6991),
    [anon_sym_QMARK] = ACTIONS(3542),
    [anon_sym_STAR_EQ] = ACTIONS(3542),
    [anon_sym_SLASH_EQ] = ACTIONS(3542),
    [anon_sym_PERCENT_EQ] = ACTIONS(3542),
    [anon_sym_PLUS_EQ] = ACTIONS(3542),
    [anon_sym_DASH_EQ] = ACTIONS(3542),
    [anon_sym_LT_LT_EQ] = ACTIONS(3542),
    [anon_sym_GT_GT_EQ] = ACTIONS(3540),
    [anon_sym_AMP_EQ] = ACTIONS(3542),
    [anon_sym_CARET_EQ] = ACTIONS(3542),
    [anon_sym_PIPE_EQ] = ACTIONS(3542),
    [anon_sym_and_eq] = ACTIONS(3540),
    [anon_sym_or_eq] = ACTIONS(3540),
    [anon_sym_xor_eq] = ACTIONS(3540),
    [anon_sym_LT_EQ_GT] = ACTIONS(3542),
    [anon_sym_or] = ACTIONS(3540),
    [anon_sym_and] = ACTIONS(3540),
    [anon_sym_bitor] = ACTIONS(3540),
    [anon_sym_xor] = ACTIONS(3540),
    [anon_sym_bitand] = ACTIONS(3540),
    [anon_sym_not_eq] = ACTIONS(3540),
    [anon_sym_is] = ACTIONS(3540),
    [anon_sym_as] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(3542),
    [anon_sym_PLUS_PLUS] = ACTIONS(3542),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_DOT_STAR] = ACTIONS(3542),
    [anon_sym_DASH_GT] = ACTIONS(3542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3540),
    [anon_sym_let] = ACTIONS(3540),
    [anon_sym_This] = ACTIONS(3540),
    [anon_sym_GT2] = ACTIONS(3542),
  },
  [2791] = {
    [sym__declaration_modifiers] = STATE(2773),
    [sym_attribute_specifier] = STATE(2773),
    [sym_attribute_declaration] = STATE(2773),
    [sym_ms_declspec_modifier] = STATE(2773),
    [sym_storage_class_specifier] = STATE(2773),
    [sym_type_qualifier] = STATE(2773),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_qualifiers] = STATE(2773),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2773),
    [sym_identifier] = ACTIONS(6949),
    [anon_sym_LPAREN2] = ACTIONS(6951),
    [anon_sym_TILDE] = ACTIONS(6951),
    [anon_sym_STAR] = ACTIONS(6951),
    [anon_sym_AMP_AMP] = ACTIONS(6951),
    [anon_sym_AMP] = ACTIONS(6949),
    [anon_sym_SEMI] = ACTIONS(6993),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(6955),
    [anon_sym_out] = ACTIONS(6955),
    [anon_sym_inout] = ACTIONS(6955),
    [anon_sym_virtual] = ACTIONS(6955),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(6951),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(6949),
    [anon_sym___cdecl] = ACTIONS(6949),
    [anon_sym___clrcall] = ACTIONS(6949),
    [anon_sym___stdcall] = ACTIONS(6949),
    [anon_sym___fastcall] = ACTIONS(6949),
    [anon_sym___thiscall] = ACTIONS(6949),
    [anon_sym___vectorcall] = ACTIONS(6949),
    [anon_sym_LBRACK] = ACTIONS(6949),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [anon_sym_DOT] = ACTIONS(6957),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6959),
    [anon_sym_let] = ACTIONS(6959),
    [anon_sym_This] = ACTIONS(6959),
    [anon_sym_decltype] = ACTIONS(6949),
    [anon_sym_template] = ACTIONS(6949),
    [anon_sym_operator] = ACTIONS(6949),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [2792] = {
    [sym__declaration_modifiers] = STATE(2773),
    [sym_attribute_specifier] = STATE(2773),
    [sym_attribute_declaration] = STATE(2773),
    [sym_ms_declspec_modifier] = STATE(2773),
    [sym_storage_class_specifier] = STATE(2773),
    [sym_type_qualifier] = STATE(2773),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_qualifiers] = STATE(2773),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2773),
    [sym_identifier] = ACTIONS(6949),
    [anon_sym_LPAREN2] = ACTIONS(6951),
    [anon_sym_TILDE] = ACTIONS(6951),
    [anon_sym_STAR] = ACTIONS(6951),
    [anon_sym_AMP_AMP] = ACTIONS(6951),
    [anon_sym_AMP] = ACTIONS(6949),
    [anon_sym_SEMI] = ACTIONS(6995),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(6955),
    [anon_sym_out] = ACTIONS(6955),
    [anon_sym_inout] = ACTIONS(6955),
    [anon_sym_virtual] = ACTIONS(6955),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(6951),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(6949),
    [anon_sym___cdecl] = ACTIONS(6949),
    [anon_sym___clrcall] = ACTIONS(6949),
    [anon_sym___stdcall] = ACTIONS(6949),
    [anon_sym___fastcall] = ACTIONS(6949),
    [anon_sym___thiscall] = ACTIONS(6949),
    [anon_sym___vectorcall] = ACTIONS(6949),
    [anon_sym_LBRACK] = ACTIONS(6949),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [anon_sym_DOT] = ACTIONS(6957),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6959),
    [anon_sym_let] = ACTIONS(6959),
    [anon_sym_This] = ACTIONS(6959),
    [anon_sym_decltype] = ACTIONS(6949),
    [anon_sym_template] = ACTIONS(6949),
    [anon_sym_operator] = ACTIONS(6949),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [2793] = {
    [sym__declaration_modifiers] = STATE(2773),
    [sym_attribute_specifier] = STATE(2773),
    [sym_attribute_declaration] = STATE(2773),
    [sym_ms_declspec_modifier] = STATE(2773),
    [sym_storage_class_specifier] = STATE(2773),
    [sym_type_qualifier] = STATE(2773),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_qualifiers] = STATE(2773),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2773),
    [sym_identifier] = ACTIONS(6949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6951),
    [anon_sym_COMMA] = ACTIONS(6951),
    [anon_sym_RPAREN] = ACTIONS(6951),
    [anon_sym_LPAREN2] = ACTIONS(6951),
    [anon_sym_TILDE] = ACTIONS(6951),
    [anon_sym_STAR] = ACTIONS(6951),
    [anon_sym_AMP_AMP] = ACTIONS(6951),
    [anon_sym_AMP] = ACTIONS(6949),
    [anon_sym_COLON] = ACTIONS(6949),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(6955),
    [anon_sym_out] = ACTIONS(6955),
    [anon_sym_inout] = ACTIONS(6955),
    [anon_sym_virtual] = ACTIONS(6955),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(6951),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(6949),
    [anon_sym_LBRACK] = ACTIONS(6949),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_EQ] = ACTIONS(6951),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [anon_sym_DOT] = ACTIONS(6997),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6959),
    [anon_sym_let] = ACTIONS(6959),
    [anon_sym_This] = ACTIONS(6959),
    [anon_sym_decltype] = ACTIONS(6949),
    [anon_sym_template] = ACTIONS(6949),
    [anon_sym_GT2] = ACTIONS(6951),
    [anon_sym_operator] = ACTIONS(6949),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [2794] = {
    [sym_attribute_specifier] = STATE(2882),
    [sym_field_declaration_list] = STATE(2816),
    [sym_virtual_specifier] = STATE(9396),
    [sym_base_class_clause] = STATE(10585),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(6999),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_out] = ACTIONS(2893),
    [anon_sym_inout] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(6858),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym__Nonnull] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym__Alignas] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_This] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_precise] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_groupshared] = ACTIONS(2893),
    [anon_sym_uniform] = ACTIONS(2893),
    [anon_sym_row_major] = ACTIONS(2893),
    [anon_sym_column_major] = ACTIONS(2893),
    [anon_sym_globallycoherent] = ACTIONS(2893),
    [anon_sym_centroid] = ACTIONS(2893),
    [anon_sym_noperspective] = ACTIONS(2893),
    [anon_sym_nointerpolation] = ACTIONS(2893),
    [anon_sym_sample] = ACTIONS(2893),
    [anon_sym_linear] = ACTIONS(2893),
    [anon_sym_snorm] = ACTIONS(2893),
    [anon_sym_unorm] = ACTIONS(2893),
    [anon_sym_point] = ACTIONS(2893),
    [anon_sym_line] = ACTIONS(2893),
    [anon_sym_triangleadj] = ACTIONS(2893),
    [anon_sym_lineadj] = ACTIONS(2893),
    [anon_sym_triangle] = ACTIONS(2893),
  },
  [2795] = {
    [sym_attribute_specifier] = STATE(2882),
    [sym_field_declaration_list] = STATE(2816),
    [sym_virtual_specifier] = STATE(9396),
    [sym_base_class_clause] = STATE(10585),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(7001),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_out] = ACTIONS(2893),
    [anon_sym_inout] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(6858),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym__Nonnull] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym__Alignas] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_This] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_precise] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_groupshared] = ACTIONS(2893),
    [anon_sym_uniform] = ACTIONS(2893),
    [anon_sym_row_major] = ACTIONS(2893),
    [anon_sym_column_major] = ACTIONS(2893),
    [anon_sym_globallycoherent] = ACTIONS(2893),
    [anon_sym_centroid] = ACTIONS(2893),
    [anon_sym_noperspective] = ACTIONS(2893),
    [anon_sym_nointerpolation] = ACTIONS(2893),
    [anon_sym_sample] = ACTIONS(2893),
    [anon_sym_linear] = ACTIONS(2893),
    [anon_sym_snorm] = ACTIONS(2893),
    [anon_sym_unorm] = ACTIONS(2893),
    [anon_sym_point] = ACTIONS(2893),
    [anon_sym_line] = ACTIONS(2893),
    [anon_sym_triangleadj] = ACTIONS(2893),
    [anon_sym_lineadj] = ACTIONS(2893),
    [anon_sym_triangle] = ACTIONS(2893),
  },
  [2796] = {
    [sym__declaration_modifiers] = STATE(2773),
    [sym_attribute_specifier] = STATE(2773),
    [sym_attribute_declaration] = STATE(2773),
    [sym_ms_declspec_modifier] = STATE(2773),
    [sym_storage_class_specifier] = STATE(2773),
    [sym_type_qualifier] = STATE(2773),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_qualifiers] = STATE(2773),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2773),
    [sym_identifier] = ACTIONS(6949),
    [anon_sym_LPAREN2] = ACTIONS(6951),
    [anon_sym_TILDE] = ACTIONS(6951),
    [anon_sym_STAR] = ACTIONS(6951),
    [anon_sym_AMP_AMP] = ACTIONS(6951),
    [anon_sym_AMP] = ACTIONS(6949),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(6955),
    [anon_sym_out] = ACTIONS(6955),
    [anon_sym_inout] = ACTIONS(6955),
    [anon_sym_virtual] = ACTIONS(6955),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(6951),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(6949),
    [anon_sym___cdecl] = ACTIONS(6949),
    [anon_sym___clrcall] = ACTIONS(6949),
    [anon_sym___stdcall] = ACTIONS(6949),
    [anon_sym___fastcall] = ACTIONS(6949),
    [anon_sym___thiscall] = ACTIONS(6949),
    [anon_sym___vectorcall] = ACTIONS(6949),
    [anon_sym_LBRACK] = ACTIONS(6949),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [anon_sym_DOT] = ACTIONS(6957),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6959),
    [anon_sym_let] = ACTIONS(6959),
    [anon_sym_This] = ACTIONS(6959),
    [anon_sym_decltype] = ACTIONS(6949),
    [anon_sym_template] = ACTIONS(6949),
    [anon_sym_operator] = ACTIONS(6949),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [2797] = {
    [sym_attribute_specifier] = STATE(2882),
    [sym_field_declaration_list] = STATE(2816),
    [sym_virtual_specifier] = STATE(9396),
    [sym_base_class_clause] = STATE(10585),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(7003),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_out] = ACTIONS(2893),
    [anon_sym_inout] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(6858),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym__Nonnull] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym__Alignas] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_This] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_precise] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_groupshared] = ACTIONS(2893),
    [anon_sym_uniform] = ACTIONS(2893),
    [anon_sym_row_major] = ACTIONS(2893),
    [anon_sym_column_major] = ACTIONS(2893),
    [anon_sym_globallycoherent] = ACTIONS(2893),
    [anon_sym_centroid] = ACTIONS(2893),
    [anon_sym_noperspective] = ACTIONS(2893),
    [anon_sym_nointerpolation] = ACTIONS(2893),
    [anon_sym_sample] = ACTIONS(2893),
    [anon_sym_linear] = ACTIONS(2893),
    [anon_sym_snorm] = ACTIONS(2893),
    [anon_sym_unorm] = ACTIONS(2893),
    [anon_sym_point] = ACTIONS(2893),
    [anon_sym_line] = ACTIONS(2893),
    [anon_sym_triangleadj] = ACTIONS(2893),
    [anon_sym_lineadj] = ACTIONS(2893),
    [anon_sym_triangle] = ACTIONS(2893),
  },
  [2798] = {
    [sym_attribute_specifier] = STATE(2882),
    [sym_field_declaration_list] = STATE(2816),
    [sym_virtual_specifier] = STATE(9396),
    [sym_base_class_clause] = STATE(10585),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(7005),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_out] = ACTIONS(2893),
    [anon_sym_inout] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(6858),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym__Nonnull] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym__Alignas] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_This] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_precise] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_groupshared] = ACTIONS(2893),
    [anon_sym_uniform] = ACTIONS(2893),
    [anon_sym_row_major] = ACTIONS(2893),
    [anon_sym_column_major] = ACTIONS(2893),
    [anon_sym_globallycoherent] = ACTIONS(2893),
    [anon_sym_centroid] = ACTIONS(2893),
    [anon_sym_noperspective] = ACTIONS(2893),
    [anon_sym_nointerpolation] = ACTIONS(2893),
    [anon_sym_sample] = ACTIONS(2893),
    [anon_sym_linear] = ACTIONS(2893),
    [anon_sym_snorm] = ACTIONS(2893),
    [anon_sym_unorm] = ACTIONS(2893),
    [anon_sym_point] = ACTIONS(2893),
    [anon_sym_line] = ACTIONS(2893),
    [anon_sym_triangleadj] = ACTIONS(2893),
    [anon_sym_lineadj] = ACTIONS(2893),
    [anon_sym_triangle] = ACTIONS(2893),
  },
  [2799] = {
    [sym_type_qualifier] = STATE(2799),
    [sym_alignas_qualifier] = STATE(2912),
    [aux_sym__type_definition_type_repeat1] = STATE(2799),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3681),
    [anon_sym_COMMA] = ACTIONS(3681),
    [anon_sym_RPAREN] = ACTIONS(3681),
    [aux_sym_preproc_if_token2] = ACTIONS(3681),
    [aux_sym_preproc_else_token1] = ACTIONS(3681),
    [aux_sym_preproc_elif_token1] = ACTIONS(3683),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3681),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3681),
    [anon_sym_LPAREN2] = ACTIONS(3681),
    [anon_sym_DASH] = ACTIONS(3683),
    [anon_sym_PLUS] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(3681),
    [anon_sym_SLASH] = ACTIONS(3683),
    [anon_sym_PERCENT] = ACTIONS(3681),
    [anon_sym_PIPE_PIPE] = ACTIONS(3681),
    [anon_sym_AMP_AMP] = ACTIONS(3681),
    [anon_sym_PIPE] = ACTIONS(3683),
    [anon_sym_CARET] = ACTIONS(3681),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_EQ_EQ] = ACTIONS(3681),
    [anon_sym_BANG_EQ] = ACTIONS(3681),
    [anon_sym_GT] = ACTIONS(3683),
    [anon_sym_GT_EQ] = ACTIONS(3681),
    [anon_sym_LT_EQ] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_LT_LT] = ACTIONS(3681),
    [anon_sym_GT_GT] = ACTIONS(3681),
    [anon_sym_COLON] = ACTIONS(3681),
    [anon_sym_SEMI] = ACTIONS(3681),
    [anon_sym___extension__] = ACTIONS(7007),
    [anon_sym___attribute__] = ACTIONS(3683),
    [anon_sym___attribute] = ACTIONS(3683),
    [anon_sym___based] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3681),
    [anon_sym_RBRACE] = ACTIONS(3681),
    [anon_sym_signed] = ACTIONS(3683),
    [anon_sym_unsigned] = ACTIONS(3683),
    [anon_sym_long] = ACTIONS(3683),
    [anon_sym_short] = ACTIONS(3683),
    [anon_sym_LBRACK] = ACTIONS(3681),
    [anon_sym_RBRACK] = ACTIONS(3681),
    [anon_sym_const] = ACTIONS(7007),
    [anon_sym_constexpr] = ACTIONS(7007),
    [anon_sym_volatile] = ACTIONS(7007),
    [anon_sym_restrict] = ACTIONS(7007),
    [anon_sym___restrict__] = ACTIONS(7007),
    [anon_sym__Atomic] = ACTIONS(7007),
    [anon_sym__Noreturn] = ACTIONS(7007),
    [anon_sym_noreturn] = ACTIONS(7007),
    [anon_sym__Nonnull] = ACTIONS(7007),
    [anon_sym_mutable] = ACTIONS(7007),
    [anon_sym_constinit] = ACTIONS(7007),
    [anon_sym_consteval] = ACTIONS(7007),
    [anon_sym_alignas] = ACTIONS(7010),
    [anon_sym__Alignas] = ACTIONS(7010),
    [sym_primitive_type] = ACTIONS(3683),
    [anon_sym_QMARK] = ACTIONS(3681),
    [anon_sym_LT_EQ_GT] = ACTIONS(3681),
    [anon_sym_or] = ACTIONS(3683),
    [anon_sym_and] = ACTIONS(3683),
    [anon_sym_bitor] = ACTIONS(3683),
    [anon_sym_xor] = ACTIONS(3683),
    [anon_sym_bitand] = ACTIONS(3683),
    [anon_sym_not_eq] = ACTIONS(3683),
    [anon_sym_is] = ACTIONS(3683),
    [anon_sym_as] = ACTIONS(3683),
    [anon_sym_DASH_DASH] = ACTIONS(3681),
    [anon_sym_PLUS_PLUS] = ACTIONS(3681),
    [anon_sym_DOT] = ACTIONS(3683),
    [anon_sym_DOT_STAR] = ACTIONS(3681),
    [anon_sym_DASH_GT] = ACTIONS(3681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3683),
    [anon_sym_let] = ACTIONS(3683),
    [anon_sym_This] = ACTIONS(3683),
    [anon_sym_final] = ACTIONS(3683),
    [anon_sym_override] = ACTIONS(3683),
    [anon_sym_requires] = ACTIONS(3683),
    [anon_sym_where] = ACTIONS(3683),
  },
  [2800] = {
    [sym_attribute_specifier] = STATE(2882),
    [sym_field_declaration_list] = STATE(2816),
    [sym_virtual_specifier] = STATE(9396),
    [sym_base_class_clause] = STATE(10585),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(7013),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_out] = ACTIONS(2893),
    [anon_sym_inout] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(6858),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym__Nonnull] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym__Alignas] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_This] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_precise] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_groupshared] = ACTIONS(2893),
    [anon_sym_uniform] = ACTIONS(2893),
    [anon_sym_row_major] = ACTIONS(2893),
    [anon_sym_column_major] = ACTIONS(2893),
    [anon_sym_globallycoherent] = ACTIONS(2893),
    [anon_sym_centroid] = ACTIONS(2893),
    [anon_sym_noperspective] = ACTIONS(2893),
    [anon_sym_nointerpolation] = ACTIONS(2893),
    [anon_sym_sample] = ACTIONS(2893),
    [anon_sym_linear] = ACTIONS(2893),
    [anon_sym_snorm] = ACTIONS(2893),
    [anon_sym_unorm] = ACTIONS(2893),
    [anon_sym_point] = ACTIONS(2893),
    [anon_sym_line] = ACTIONS(2893),
    [anon_sym_triangleadj] = ACTIONS(2893),
    [anon_sym_lineadj] = ACTIONS(2893),
    [anon_sym_triangle] = ACTIONS(2893),
  },
  [2801] = {
    [sym_argument_list] = STATE(3418),
    [sym_initializer_list] = STATE(4856),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2759),
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(3836),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2881),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_signed] = ACTIONS(6885),
    [anon_sym_unsigned] = ACTIONS(6885),
    [anon_sym_long] = ACTIONS(6885),
    [anon_sym_short] = ACTIONS(6885),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
  },
  [2802] = {
    [sym_attribute_specifier] = STATE(2882),
    [sym_field_declaration_list] = STATE(2816),
    [sym_virtual_specifier] = STATE(9396),
    [sym_base_class_clause] = STATE(10585),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(7015),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_out] = ACTIONS(2893),
    [anon_sym_inout] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(6858),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym__Nonnull] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym__Alignas] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_This] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_precise] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_groupshared] = ACTIONS(2893),
    [anon_sym_uniform] = ACTIONS(2893),
    [anon_sym_row_major] = ACTIONS(2893),
    [anon_sym_column_major] = ACTIONS(2893),
    [anon_sym_globallycoherent] = ACTIONS(2893),
    [anon_sym_centroid] = ACTIONS(2893),
    [anon_sym_noperspective] = ACTIONS(2893),
    [anon_sym_nointerpolation] = ACTIONS(2893),
    [anon_sym_sample] = ACTIONS(2893),
    [anon_sym_linear] = ACTIONS(2893),
    [anon_sym_snorm] = ACTIONS(2893),
    [anon_sym_unorm] = ACTIONS(2893),
    [anon_sym_point] = ACTIONS(2893),
    [anon_sym_line] = ACTIONS(2893),
    [anon_sym_triangleadj] = ACTIONS(2893),
    [anon_sym_lineadj] = ACTIONS(2893),
    [anon_sym_triangle] = ACTIONS(2893),
  },
  [2803] = {
    [sym_attribute_specifier] = STATE(2882),
    [sym_field_declaration_list] = STATE(2816),
    [sym_virtual_specifier] = STATE(9396),
    [sym_base_class_clause] = STATE(10585),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(7017),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_out] = ACTIONS(2893),
    [anon_sym_inout] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(6858),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym__Nonnull] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym__Alignas] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_This] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_precise] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_groupshared] = ACTIONS(2893),
    [anon_sym_uniform] = ACTIONS(2893),
    [anon_sym_row_major] = ACTIONS(2893),
    [anon_sym_column_major] = ACTIONS(2893),
    [anon_sym_globallycoherent] = ACTIONS(2893),
    [anon_sym_centroid] = ACTIONS(2893),
    [anon_sym_noperspective] = ACTIONS(2893),
    [anon_sym_nointerpolation] = ACTIONS(2893),
    [anon_sym_sample] = ACTIONS(2893),
    [anon_sym_linear] = ACTIONS(2893),
    [anon_sym_snorm] = ACTIONS(2893),
    [anon_sym_unorm] = ACTIONS(2893),
    [anon_sym_point] = ACTIONS(2893),
    [anon_sym_line] = ACTIONS(2893),
    [anon_sym_triangleadj] = ACTIONS(2893),
    [anon_sym_lineadj] = ACTIONS(2893),
    [anon_sym_triangle] = ACTIONS(2893),
  },
  [2804] = {
    [sym_type_qualifier] = STATE(2804),
    [sym_alignas_qualifier] = STATE(2907),
    [aux_sym__type_definition_type_repeat1] = STATE(2804),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3681),
    [anon_sym_COMMA] = ACTIONS(3681),
    [anon_sym_LPAREN2] = ACTIONS(3681),
    [anon_sym_DASH] = ACTIONS(3683),
    [anon_sym_PLUS] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(3683),
    [anon_sym_SLASH] = ACTIONS(3683),
    [anon_sym_PERCENT] = ACTIONS(3683),
    [anon_sym_PIPE_PIPE] = ACTIONS(3681),
    [anon_sym_AMP_AMP] = ACTIONS(3681),
    [anon_sym_PIPE] = ACTIONS(3683),
    [anon_sym_CARET] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_EQ_EQ] = ACTIONS(3681),
    [anon_sym_BANG_EQ] = ACTIONS(3681),
    [anon_sym_GT] = ACTIONS(3683),
    [anon_sym_GT_EQ] = ACTIONS(3683),
    [anon_sym_LT_EQ] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_LT_LT] = ACTIONS(3683),
    [anon_sym_GT_GT] = ACTIONS(3683),
    [anon_sym___extension__] = ACTIONS(7019),
    [anon_sym___attribute__] = ACTIONS(3683),
    [anon_sym___attribute] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3681),
    [anon_sym_signed] = ACTIONS(3683),
    [anon_sym_unsigned] = ACTIONS(3683),
    [anon_sym_long] = ACTIONS(3683),
    [anon_sym_short] = ACTIONS(3683),
    [anon_sym_LBRACK] = ACTIONS(3681),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_const] = ACTIONS(7019),
    [anon_sym_constexpr] = ACTIONS(7019),
    [anon_sym_volatile] = ACTIONS(7019),
    [anon_sym_restrict] = ACTIONS(7019),
    [anon_sym___restrict__] = ACTIONS(7019),
    [anon_sym__Atomic] = ACTIONS(7019),
    [anon_sym__Noreturn] = ACTIONS(7019),
    [anon_sym_noreturn] = ACTIONS(7019),
    [anon_sym__Nonnull] = ACTIONS(7019),
    [anon_sym_mutable] = ACTIONS(7019),
    [anon_sym_constinit] = ACTIONS(7019),
    [anon_sym_consteval] = ACTIONS(7019),
    [anon_sym_alignas] = ACTIONS(7022),
    [anon_sym__Alignas] = ACTIONS(7022),
    [sym_primitive_type] = ACTIONS(3683),
    [anon_sym_QMARK] = ACTIONS(3681),
    [anon_sym_STAR_EQ] = ACTIONS(3681),
    [anon_sym_SLASH_EQ] = ACTIONS(3681),
    [anon_sym_PERCENT_EQ] = ACTIONS(3681),
    [anon_sym_PLUS_EQ] = ACTIONS(3681),
    [anon_sym_DASH_EQ] = ACTIONS(3681),
    [anon_sym_LT_LT_EQ] = ACTIONS(3681),
    [anon_sym_GT_GT_EQ] = ACTIONS(3683),
    [anon_sym_AMP_EQ] = ACTIONS(3681),
    [anon_sym_CARET_EQ] = ACTIONS(3681),
    [anon_sym_PIPE_EQ] = ACTIONS(3681),
    [anon_sym_and_eq] = ACTIONS(3683),
    [anon_sym_or_eq] = ACTIONS(3683),
    [anon_sym_xor_eq] = ACTIONS(3683),
    [anon_sym_LT_EQ_GT] = ACTIONS(3681),
    [anon_sym_or] = ACTIONS(3683),
    [anon_sym_and] = ACTIONS(3683),
    [anon_sym_bitor] = ACTIONS(3683),
    [anon_sym_xor] = ACTIONS(3683),
    [anon_sym_bitand] = ACTIONS(3683),
    [anon_sym_not_eq] = ACTIONS(3683),
    [anon_sym_is] = ACTIONS(3683),
    [anon_sym_as] = ACTIONS(3683),
    [anon_sym_DASH_DASH] = ACTIONS(3681),
    [anon_sym_PLUS_PLUS] = ACTIONS(3681),
    [anon_sym_DOT] = ACTIONS(3683),
    [anon_sym_DOT_STAR] = ACTIONS(3681),
    [anon_sym_DASH_GT] = ACTIONS(3681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3683),
    [anon_sym_let] = ACTIONS(3683),
    [anon_sym_This] = ACTIONS(3683),
    [anon_sym_GT2] = ACTIONS(3681),
  },
  [2805] = {
    [sym__declaration_modifiers] = STATE(2769),
    [sym_attribute_specifier] = STATE(2769),
    [sym_attribute_declaration] = STATE(2769),
    [sym_ms_declspec_modifier] = STATE(2769),
    [sym_storage_class_specifier] = STATE(2769),
    [sym_type_qualifier] = STATE(2769),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_qualifiers] = STATE(2769),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2769),
    [sym_identifier] = ACTIONS(7025),
    [anon_sym_LPAREN2] = ACTIONS(7027),
    [anon_sym_TILDE] = ACTIONS(7027),
    [anon_sym_STAR] = ACTIONS(7027),
    [anon_sym_AMP_AMP] = ACTIONS(7027),
    [anon_sym_AMP] = ACTIONS(7025),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(7029),
    [anon_sym_out] = ACTIONS(7029),
    [anon_sym_inout] = ACTIONS(7029),
    [anon_sym_virtual] = ACTIONS(7029),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(7027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(7025),
    [anon_sym___cdecl] = ACTIONS(7025),
    [anon_sym___clrcall] = ACTIONS(7025),
    [anon_sym___stdcall] = ACTIONS(7025),
    [anon_sym___fastcall] = ACTIONS(7025),
    [anon_sym___thiscall] = ACTIONS(7025),
    [anon_sym___vectorcall] = ACTIONS(7025),
    [anon_sym_LBRACK] = ACTIONS(7025),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [anon_sym_DOT] = ACTIONS(6957),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6959),
    [anon_sym_let] = ACTIONS(6959),
    [anon_sym_This] = ACTIONS(6959),
    [anon_sym_decltype] = ACTIONS(7025),
    [anon_sym_template] = ACTIONS(7025),
    [anon_sym_operator] = ACTIONS(7025),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [2806] = {
    [sym__declaration_modifiers] = STATE(2769),
    [sym_attribute_specifier] = STATE(2769),
    [sym_attribute_declaration] = STATE(2769),
    [sym_ms_declspec_modifier] = STATE(2769),
    [sym_storage_class_specifier] = STATE(2769),
    [sym_type_qualifier] = STATE(2769),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_qualifiers] = STATE(2769),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2769),
    [sym_identifier] = ACTIONS(7025),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7027),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_RPAREN] = ACTIONS(7027),
    [anon_sym_LPAREN2] = ACTIONS(7027),
    [anon_sym_TILDE] = ACTIONS(7027),
    [anon_sym_STAR] = ACTIONS(7027),
    [anon_sym_AMP_AMP] = ACTIONS(7027),
    [anon_sym_AMP] = ACTIONS(7025),
    [anon_sym_COLON] = ACTIONS(7025),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(7029),
    [anon_sym_out] = ACTIONS(7029),
    [anon_sym_inout] = ACTIONS(7029),
    [anon_sym_virtual] = ACTIONS(7029),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(7027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(7025),
    [anon_sym_LBRACK] = ACTIONS(7025),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_EQ] = ACTIONS(7027),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [anon_sym_DOT] = ACTIONS(6997),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6959),
    [anon_sym_let] = ACTIONS(6959),
    [anon_sym_This] = ACTIONS(6959),
    [anon_sym_decltype] = ACTIONS(7025),
    [anon_sym_template] = ACTIONS(7025),
    [anon_sym_GT2] = ACTIONS(7027),
    [anon_sym_operator] = ACTIONS(7025),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [2807] = {
    [sym_attribute_specifier] = STATE(2882),
    [sym_field_declaration_list] = STATE(2816),
    [sym_virtual_specifier] = STATE(9396),
    [sym_base_class_clause] = STATE(10585),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(7031),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_out] = ACTIONS(2893),
    [anon_sym_inout] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(6858),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym__Nonnull] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym__Alignas] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_This] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_precise] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_groupshared] = ACTIONS(2893),
    [anon_sym_uniform] = ACTIONS(2893),
    [anon_sym_row_major] = ACTIONS(2893),
    [anon_sym_column_major] = ACTIONS(2893),
    [anon_sym_globallycoherent] = ACTIONS(2893),
    [anon_sym_centroid] = ACTIONS(2893),
    [anon_sym_noperspective] = ACTIONS(2893),
    [anon_sym_nointerpolation] = ACTIONS(2893),
    [anon_sym_sample] = ACTIONS(2893),
    [anon_sym_linear] = ACTIONS(2893),
    [anon_sym_snorm] = ACTIONS(2893),
    [anon_sym_unorm] = ACTIONS(2893),
    [anon_sym_point] = ACTIONS(2893),
    [anon_sym_line] = ACTIONS(2893),
    [anon_sym_triangleadj] = ACTIONS(2893),
    [anon_sym_lineadj] = ACTIONS(2893),
    [anon_sym_triangle] = ACTIONS(2893),
  },
  [2808] = {
    [sym_attribute_specifier] = STATE(2882),
    [sym_field_declaration_list] = STATE(2816),
    [sym_virtual_specifier] = STATE(9396),
    [sym_base_class_clause] = STATE(10585),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(7033),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_out] = ACTIONS(2893),
    [anon_sym_inout] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(6858),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym__Nonnull] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym__Alignas] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_This] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_precise] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_groupshared] = ACTIONS(2893),
    [anon_sym_uniform] = ACTIONS(2893),
    [anon_sym_row_major] = ACTIONS(2893),
    [anon_sym_column_major] = ACTIONS(2893),
    [anon_sym_globallycoherent] = ACTIONS(2893),
    [anon_sym_centroid] = ACTIONS(2893),
    [anon_sym_noperspective] = ACTIONS(2893),
    [anon_sym_nointerpolation] = ACTIONS(2893),
    [anon_sym_sample] = ACTIONS(2893),
    [anon_sym_linear] = ACTIONS(2893),
    [anon_sym_snorm] = ACTIONS(2893),
    [anon_sym_unorm] = ACTIONS(2893),
    [anon_sym_point] = ACTIONS(2893),
    [anon_sym_line] = ACTIONS(2893),
    [anon_sym_triangleadj] = ACTIONS(2893),
    [anon_sym_lineadj] = ACTIONS(2893),
    [anon_sym_triangle] = ACTIONS(2893),
  },
  [2809] = {
    [sym_attribute_specifier] = STATE(2882),
    [sym_field_declaration_list] = STATE(2816),
    [sym_virtual_specifier] = STATE(9396),
    [sym_base_class_clause] = STATE(10585),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(7035),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_out] = ACTIONS(2893),
    [anon_sym_inout] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(6858),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym__Nonnull] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym__Alignas] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_This] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_precise] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_groupshared] = ACTIONS(2893),
    [anon_sym_uniform] = ACTIONS(2893),
    [anon_sym_row_major] = ACTIONS(2893),
    [anon_sym_column_major] = ACTIONS(2893),
    [anon_sym_globallycoherent] = ACTIONS(2893),
    [anon_sym_centroid] = ACTIONS(2893),
    [anon_sym_noperspective] = ACTIONS(2893),
    [anon_sym_nointerpolation] = ACTIONS(2893),
    [anon_sym_sample] = ACTIONS(2893),
    [anon_sym_linear] = ACTIONS(2893),
    [anon_sym_snorm] = ACTIONS(2893),
    [anon_sym_unorm] = ACTIONS(2893),
    [anon_sym_point] = ACTIONS(2893),
    [anon_sym_line] = ACTIONS(2893),
    [anon_sym_triangleadj] = ACTIONS(2893),
    [anon_sym_lineadj] = ACTIONS(2893),
    [anon_sym_triangle] = ACTIONS(2893),
  },
  [2810] = {
    [sym_attribute_specifier] = STATE(2882),
    [sym_field_declaration_list] = STATE(2816),
    [sym_virtual_specifier] = STATE(9396),
    [sym_base_class_clause] = STATE(10585),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(7037),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_out] = ACTIONS(2893),
    [anon_sym_inout] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(6858),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym__Nonnull] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym__Alignas] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_This] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_precise] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_groupshared] = ACTIONS(2893),
    [anon_sym_uniform] = ACTIONS(2893),
    [anon_sym_row_major] = ACTIONS(2893),
    [anon_sym_column_major] = ACTIONS(2893),
    [anon_sym_globallycoherent] = ACTIONS(2893),
    [anon_sym_centroid] = ACTIONS(2893),
    [anon_sym_noperspective] = ACTIONS(2893),
    [anon_sym_nointerpolation] = ACTIONS(2893),
    [anon_sym_sample] = ACTIONS(2893),
    [anon_sym_linear] = ACTIONS(2893),
    [anon_sym_snorm] = ACTIONS(2893),
    [anon_sym_unorm] = ACTIONS(2893),
    [anon_sym_point] = ACTIONS(2893),
    [anon_sym_line] = ACTIONS(2893),
    [anon_sym_triangleadj] = ACTIONS(2893),
    [anon_sym_lineadj] = ACTIONS(2893),
    [anon_sym_triangle] = ACTIONS(2893),
  },
  [2811] = {
    [sym_attribute_specifier] = STATE(2882),
    [sym_field_declaration_list] = STATE(2816),
    [sym_virtual_specifier] = STATE(9396),
    [sym_base_class_clause] = STATE(10585),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(7039),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_out] = ACTIONS(2893),
    [anon_sym_inout] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(6858),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym__Nonnull] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym__Alignas] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_This] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_precise] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_groupshared] = ACTIONS(2893),
    [anon_sym_uniform] = ACTIONS(2893),
    [anon_sym_row_major] = ACTIONS(2893),
    [anon_sym_column_major] = ACTIONS(2893),
    [anon_sym_globallycoherent] = ACTIONS(2893),
    [anon_sym_centroid] = ACTIONS(2893),
    [anon_sym_noperspective] = ACTIONS(2893),
    [anon_sym_nointerpolation] = ACTIONS(2893),
    [anon_sym_sample] = ACTIONS(2893),
    [anon_sym_linear] = ACTIONS(2893),
    [anon_sym_snorm] = ACTIONS(2893),
    [anon_sym_unorm] = ACTIONS(2893),
    [anon_sym_point] = ACTIONS(2893),
    [anon_sym_line] = ACTIONS(2893),
    [anon_sym_triangleadj] = ACTIONS(2893),
    [anon_sym_lineadj] = ACTIONS(2893),
    [anon_sym_triangle] = ACTIONS(2893),
  },
  [2812] = {
    [sym_attribute_specifier] = STATE(2882),
    [sym_field_declaration_list] = STATE(2816),
    [sym_virtual_specifier] = STATE(9396),
    [sym_base_class_clause] = STATE(10585),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(7041),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_out] = ACTIONS(2893),
    [anon_sym_inout] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(6858),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym__Nonnull] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym__Alignas] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_This] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_precise] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_groupshared] = ACTIONS(2893),
    [anon_sym_uniform] = ACTIONS(2893),
    [anon_sym_row_major] = ACTIONS(2893),
    [anon_sym_column_major] = ACTIONS(2893),
    [anon_sym_globallycoherent] = ACTIONS(2893),
    [anon_sym_centroid] = ACTIONS(2893),
    [anon_sym_noperspective] = ACTIONS(2893),
    [anon_sym_nointerpolation] = ACTIONS(2893),
    [anon_sym_sample] = ACTIONS(2893),
    [anon_sym_linear] = ACTIONS(2893),
    [anon_sym_snorm] = ACTIONS(2893),
    [anon_sym_unorm] = ACTIONS(2893),
    [anon_sym_point] = ACTIONS(2893),
    [anon_sym_line] = ACTIONS(2893),
    [anon_sym_triangleadj] = ACTIONS(2893),
    [anon_sym_lineadj] = ACTIONS(2893),
    [anon_sym_triangle] = ACTIONS(2893),
  },
  [2813] = {
    [sym_attribute_specifier] = STATE(2882),
    [sym_field_declaration_list] = STATE(2816),
    [sym_virtual_specifier] = STATE(9396),
    [sym_base_class_clause] = STATE(10585),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(7043),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_out] = ACTIONS(2893),
    [anon_sym_inout] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(6858),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym__Nonnull] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym__Alignas] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_This] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_precise] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_groupshared] = ACTIONS(2893),
    [anon_sym_uniform] = ACTIONS(2893),
    [anon_sym_row_major] = ACTIONS(2893),
    [anon_sym_column_major] = ACTIONS(2893),
    [anon_sym_globallycoherent] = ACTIONS(2893),
    [anon_sym_centroid] = ACTIONS(2893),
    [anon_sym_noperspective] = ACTIONS(2893),
    [anon_sym_nointerpolation] = ACTIONS(2893),
    [anon_sym_sample] = ACTIONS(2893),
    [anon_sym_linear] = ACTIONS(2893),
    [anon_sym_snorm] = ACTIONS(2893),
    [anon_sym_unorm] = ACTIONS(2893),
    [anon_sym_point] = ACTIONS(2893),
    [anon_sym_line] = ACTIONS(2893),
    [anon_sym_triangleadj] = ACTIONS(2893),
    [anon_sym_lineadj] = ACTIONS(2893),
    [anon_sym_triangle] = ACTIONS(2893),
  },
  [2814] = {
    [sym_attribute_specifier] = STATE(2894),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4085),
    [anon_sym_COMMA] = ACTIONS(4085),
    [anon_sym_RPAREN] = ACTIONS(4085),
    [anon_sym_LPAREN2] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4087),
    [anon_sym_COLON] = ACTIONS(4087),
    [anon_sym_SEMI] = ACTIONS(4085),
    [anon_sym___extension__] = ACTIONS(4087),
    [anon_sym_in] = ACTIONS(4087),
    [anon_sym_out] = ACTIONS(4087),
    [anon_sym_inout] = ACTIONS(4087),
    [anon_sym_virtual] = ACTIONS(4087),
    [anon_sym_extern] = ACTIONS(4087),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(4085),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4085),
    [anon_sym___declspec] = ACTIONS(4087),
    [anon_sym___based] = ACTIONS(4087),
    [anon_sym___cdecl] = ACTIONS(4087),
    [anon_sym___clrcall] = ACTIONS(4087),
    [anon_sym___stdcall] = ACTIONS(4087),
    [anon_sym___fastcall] = ACTIONS(4087),
    [anon_sym___thiscall] = ACTIONS(4087),
    [anon_sym___vectorcall] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(4087),
    [anon_sym_static] = ACTIONS(4087),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_register] = ACTIONS(4087),
    [anon_sym_inline] = ACTIONS(4087),
    [anon_sym___inline] = ACTIONS(4087),
    [anon_sym___inline__] = ACTIONS(4087),
    [anon_sym___forceinline] = ACTIONS(4087),
    [anon_sym_thread_local] = ACTIONS(4087),
    [anon_sym___thread] = ACTIONS(4087),
    [anon_sym_const] = ACTIONS(4087),
    [anon_sym_constexpr] = ACTIONS(4087),
    [anon_sym_volatile] = ACTIONS(4087),
    [anon_sym_restrict] = ACTIONS(4087),
    [anon_sym___restrict__] = ACTIONS(4087),
    [anon_sym__Atomic] = ACTIONS(4087),
    [anon_sym__Noreturn] = ACTIONS(4087),
    [anon_sym_noreturn] = ACTIONS(4087),
    [anon_sym__Nonnull] = ACTIONS(4087),
    [anon_sym_mutable] = ACTIONS(4087),
    [anon_sym_constinit] = ACTIONS(4087),
    [anon_sym_consteval] = ACTIONS(4087),
    [anon_sym_alignas] = ACTIONS(4087),
    [anon_sym__Alignas] = ACTIONS(4087),
    [anon_sym_DOT] = ACTIONS(4087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4087),
    [anon_sym_let] = ACTIONS(4087),
    [anon_sym_This] = ACTIONS(4087),
    [anon_sym_decltype] = ACTIONS(4087),
    [anon_sym_template] = ACTIONS(4087),
    [anon_sym_GT2] = ACTIONS(4085),
    [anon_sym_operator] = ACTIONS(4087),
    [anon_sym_precise] = ACTIONS(4087),
    [anon_sym_shared] = ACTIONS(4087),
    [anon_sym_groupshared] = ACTIONS(4087),
    [anon_sym_uniform] = ACTIONS(4087),
    [anon_sym_row_major] = ACTIONS(4087),
    [anon_sym_column_major] = ACTIONS(4087),
    [anon_sym_globallycoherent] = ACTIONS(4087),
    [anon_sym_centroid] = ACTIONS(4087),
    [anon_sym_noperspective] = ACTIONS(4087),
    [anon_sym_nointerpolation] = ACTIONS(4087),
    [anon_sym_sample] = ACTIONS(4087),
    [anon_sym_linear] = ACTIONS(4087),
    [anon_sym_snorm] = ACTIONS(4087),
    [anon_sym_unorm] = ACTIONS(4087),
    [anon_sym_point] = ACTIONS(4087),
    [anon_sym_line] = ACTIONS(4087),
    [anon_sym_triangleadj] = ACTIONS(4087),
    [anon_sym_lineadj] = ACTIONS(4087),
    [anon_sym_triangle] = ACTIONS(4087),
  },
  [2815] = {
    [sym_type_qualifier] = STATE(2817),
    [sym_alignas_qualifier] = STATE(2959),
    [aux_sym__type_definition_type_repeat1] = STATE(2817),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2935),
    [sym_identifier] = ACTIONS(7045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3423),
    [anon_sym_COMMA] = ACTIONS(3423),
    [anon_sym_RPAREN] = ACTIONS(3423),
    [anon_sym_LPAREN2] = ACTIONS(3423),
    [anon_sym_DASH] = ACTIONS(3428),
    [anon_sym_PLUS] = ACTIONS(3428),
    [anon_sym_STAR] = ACTIONS(3428),
    [anon_sym_SLASH] = ACTIONS(3428),
    [anon_sym_PERCENT] = ACTIONS(3428),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_PIPE] = ACTIONS(3428),
    [anon_sym_CARET] = ACTIONS(3428),
    [anon_sym_AMP] = ACTIONS(3428),
    [anon_sym_EQ_EQ] = ACTIONS(3423),
    [anon_sym_BANG_EQ] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3428),
    [anon_sym_GT_EQ] = ACTIONS(3423),
    [anon_sym_LT_EQ] = ACTIONS(3428),
    [anon_sym_LT] = ACTIONS(3428),
    [anon_sym_LT_LT] = ACTIONS(3428),
    [anon_sym_GT_GT] = ACTIONS(3428),
    [anon_sym___extension__] = ACTIONS(7047),
    [anon_sym___attribute__] = ACTIONS(3428),
    [anon_sym___attribute] = ACTIONS(3428),
    [anon_sym_LBRACE] = ACTIONS(3423),
    [anon_sym_signed] = ACTIONS(7049),
    [anon_sym_unsigned] = ACTIONS(7049),
    [anon_sym_long] = ACTIONS(7049),
    [anon_sym_short] = ACTIONS(7049),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_EQ] = ACTIONS(3428),
    [anon_sym_const] = ACTIONS(7047),
    [anon_sym_constexpr] = ACTIONS(7047),
    [anon_sym_volatile] = ACTIONS(7047),
    [anon_sym_restrict] = ACTIONS(7047),
    [anon_sym___restrict__] = ACTIONS(7047),
    [anon_sym__Atomic] = ACTIONS(7047),
    [anon_sym__Noreturn] = ACTIONS(7047),
    [anon_sym_noreturn] = ACTIONS(7047),
    [anon_sym__Nonnull] = ACTIONS(7047),
    [anon_sym_mutable] = ACTIONS(7047),
    [anon_sym_constinit] = ACTIONS(7047),
    [anon_sym_consteval] = ACTIONS(7047),
    [anon_sym_alignas] = ACTIONS(7051),
    [anon_sym__Alignas] = ACTIONS(7051),
    [sym_primitive_type] = ACTIONS(7053),
    [anon_sym_QMARK] = ACTIONS(3423),
    [anon_sym_STAR_EQ] = ACTIONS(3423),
    [anon_sym_SLASH_EQ] = ACTIONS(3423),
    [anon_sym_PERCENT_EQ] = ACTIONS(3423),
    [anon_sym_PLUS_EQ] = ACTIONS(3423),
    [anon_sym_DASH_EQ] = ACTIONS(3423),
    [anon_sym_LT_LT_EQ] = ACTIONS(3423),
    [anon_sym_GT_GT_EQ] = ACTIONS(3423),
    [anon_sym_AMP_EQ] = ACTIONS(3423),
    [anon_sym_CARET_EQ] = ACTIONS(3423),
    [anon_sym_PIPE_EQ] = ACTIONS(3423),
    [anon_sym_LT_EQ_GT] = ACTIONS(3423),
    [anon_sym_or] = ACTIONS(3428),
    [anon_sym_and] = ACTIONS(3428),
    [anon_sym_bitor] = ACTIONS(3428),
    [anon_sym_xor] = ACTIONS(3428),
    [anon_sym_bitand] = ACTIONS(3428),
    [anon_sym_not_eq] = ACTIONS(3428),
    [anon_sym_is] = ACTIONS(3428),
    [anon_sym_as] = ACTIONS(3428),
    [anon_sym_DASH_DASH] = ACTIONS(3423),
    [anon_sym_PLUS_PLUS] = ACTIONS(3423),
    [anon_sym_DOT] = ACTIONS(3428),
    [anon_sym_DOT_STAR] = ACTIONS(3423),
    [anon_sym_DASH_GT] = ACTIONS(3428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3428),
    [anon_sym_let] = ACTIONS(3428),
    [anon_sym_This] = ACTIONS(3428),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3423),
  },
  [2816] = {
    [sym_attribute_specifier] = STATE(2871),
    [sym_identifier] = ACTIONS(4010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(4008),
    [anon_sym_RPAREN] = ACTIONS(4008),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_TILDE] = ACTIONS(4008),
    [anon_sym_STAR] = ACTIONS(4008),
    [anon_sym_AMP_AMP] = ACTIONS(4008),
    [anon_sym_AMP] = ACTIONS(4010),
    [anon_sym_COLON] = ACTIONS(4010),
    [anon_sym_SEMI] = ACTIONS(4008),
    [anon_sym___extension__] = ACTIONS(4010),
    [anon_sym_in] = ACTIONS(4010),
    [anon_sym_out] = ACTIONS(4010),
    [anon_sym_inout] = ACTIONS(4010),
    [anon_sym_virtual] = ACTIONS(4010),
    [anon_sym_extern] = ACTIONS(4010),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(4008),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4008),
    [anon_sym___declspec] = ACTIONS(4010),
    [anon_sym___based] = ACTIONS(4010),
    [anon_sym___cdecl] = ACTIONS(4010),
    [anon_sym___clrcall] = ACTIONS(4010),
    [anon_sym___stdcall] = ACTIONS(4010),
    [anon_sym___fastcall] = ACTIONS(4010),
    [anon_sym___thiscall] = ACTIONS(4010),
    [anon_sym___vectorcall] = ACTIONS(4010),
    [anon_sym_LBRACK] = ACTIONS(4010),
    [anon_sym_static] = ACTIONS(4010),
    [anon_sym_EQ] = ACTIONS(4008),
    [anon_sym_register] = ACTIONS(4010),
    [anon_sym_inline] = ACTIONS(4010),
    [anon_sym___inline] = ACTIONS(4010),
    [anon_sym___inline__] = ACTIONS(4010),
    [anon_sym___forceinline] = ACTIONS(4010),
    [anon_sym_thread_local] = ACTIONS(4010),
    [anon_sym___thread] = ACTIONS(4010),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_constexpr] = ACTIONS(4010),
    [anon_sym_volatile] = ACTIONS(4010),
    [anon_sym_restrict] = ACTIONS(4010),
    [anon_sym___restrict__] = ACTIONS(4010),
    [anon_sym__Atomic] = ACTIONS(4010),
    [anon_sym__Noreturn] = ACTIONS(4010),
    [anon_sym_noreturn] = ACTIONS(4010),
    [anon_sym__Nonnull] = ACTIONS(4010),
    [anon_sym_mutable] = ACTIONS(4010),
    [anon_sym_constinit] = ACTIONS(4010),
    [anon_sym_consteval] = ACTIONS(4010),
    [anon_sym_alignas] = ACTIONS(4010),
    [anon_sym__Alignas] = ACTIONS(4010),
    [anon_sym_DOT] = ACTIONS(4010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4010),
    [anon_sym_let] = ACTIONS(4010),
    [anon_sym_This] = ACTIONS(4010),
    [anon_sym_decltype] = ACTIONS(4010),
    [anon_sym_template] = ACTIONS(4010),
    [anon_sym_GT2] = ACTIONS(4008),
    [anon_sym_operator] = ACTIONS(4010),
    [anon_sym_precise] = ACTIONS(4010),
    [anon_sym_shared] = ACTIONS(4010),
    [anon_sym_groupshared] = ACTIONS(4010),
    [anon_sym_uniform] = ACTIONS(4010),
    [anon_sym_row_major] = ACTIONS(4010),
    [anon_sym_column_major] = ACTIONS(4010),
    [anon_sym_globallycoherent] = ACTIONS(4010),
    [anon_sym_centroid] = ACTIONS(4010),
    [anon_sym_noperspective] = ACTIONS(4010),
    [anon_sym_nointerpolation] = ACTIONS(4010),
    [anon_sym_sample] = ACTIONS(4010),
    [anon_sym_linear] = ACTIONS(4010),
    [anon_sym_snorm] = ACTIONS(4010),
    [anon_sym_unorm] = ACTIONS(4010),
    [anon_sym_point] = ACTIONS(4010),
    [anon_sym_line] = ACTIONS(4010),
    [anon_sym_triangleadj] = ACTIONS(4010),
    [anon_sym_lineadj] = ACTIONS(4010),
    [anon_sym_triangle] = ACTIONS(4010),
  },
  [2817] = {
    [sym_type_qualifier] = STATE(2873),
    [sym_alignas_qualifier] = STATE(2959),
    [aux_sym__type_definition_type_repeat1] = STATE(2873),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3543),
    [sym_identifier] = ACTIONS(7055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3542),
    [anon_sym_COMMA] = ACTIONS(3542),
    [anon_sym_RPAREN] = ACTIONS(3542),
    [anon_sym_LPAREN2] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(3540),
    [anon_sym_SLASH] = ACTIONS(3540),
    [anon_sym_PERCENT] = ACTIONS(3540),
    [anon_sym_PIPE_PIPE] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_PIPE] = ACTIONS(3540),
    [anon_sym_CARET] = ACTIONS(3540),
    [anon_sym_AMP] = ACTIONS(3540),
    [anon_sym_EQ_EQ] = ACTIONS(3542),
    [anon_sym_BANG_EQ] = ACTIONS(3542),
    [anon_sym_GT] = ACTIONS(3540),
    [anon_sym_GT_EQ] = ACTIONS(3542),
    [anon_sym_LT_EQ] = ACTIONS(3540),
    [anon_sym_LT] = ACTIONS(3540),
    [anon_sym_LT_LT] = ACTIONS(3540),
    [anon_sym_GT_GT] = ACTIONS(3540),
    [anon_sym___extension__] = ACTIONS(7047),
    [anon_sym___attribute__] = ACTIONS(3540),
    [anon_sym___attribute] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_signed] = ACTIONS(7057),
    [anon_sym_unsigned] = ACTIONS(7057),
    [anon_sym_long] = ACTIONS(7057),
    [anon_sym_short] = ACTIONS(7057),
    [anon_sym_LBRACK] = ACTIONS(3542),
    [anon_sym_EQ] = ACTIONS(3540),
    [anon_sym_const] = ACTIONS(7047),
    [anon_sym_constexpr] = ACTIONS(7047),
    [anon_sym_volatile] = ACTIONS(7047),
    [anon_sym_restrict] = ACTIONS(7047),
    [anon_sym___restrict__] = ACTIONS(7047),
    [anon_sym__Atomic] = ACTIONS(7047),
    [anon_sym__Noreturn] = ACTIONS(7047),
    [anon_sym_noreturn] = ACTIONS(7047),
    [anon_sym__Nonnull] = ACTIONS(7047),
    [anon_sym_mutable] = ACTIONS(7047),
    [anon_sym_constinit] = ACTIONS(7047),
    [anon_sym_consteval] = ACTIONS(7047),
    [anon_sym_alignas] = ACTIONS(7051),
    [anon_sym__Alignas] = ACTIONS(7051),
    [sym_primitive_type] = ACTIONS(7059),
    [anon_sym_QMARK] = ACTIONS(3542),
    [anon_sym_STAR_EQ] = ACTIONS(3542),
    [anon_sym_SLASH_EQ] = ACTIONS(3542),
    [anon_sym_PERCENT_EQ] = ACTIONS(3542),
    [anon_sym_PLUS_EQ] = ACTIONS(3542),
    [anon_sym_DASH_EQ] = ACTIONS(3542),
    [anon_sym_LT_LT_EQ] = ACTIONS(3542),
    [anon_sym_GT_GT_EQ] = ACTIONS(3542),
    [anon_sym_AMP_EQ] = ACTIONS(3542),
    [anon_sym_CARET_EQ] = ACTIONS(3542),
    [anon_sym_PIPE_EQ] = ACTIONS(3542),
    [anon_sym_LT_EQ_GT] = ACTIONS(3542),
    [anon_sym_or] = ACTIONS(3540),
    [anon_sym_and] = ACTIONS(3540),
    [anon_sym_bitor] = ACTIONS(3540),
    [anon_sym_xor] = ACTIONS(3540),
    [anon_sym_bitand] = ACTIONS(3540),
    [anon_sym_not_eq] = ACTIONS(3540),
    [anon_sym_is] = ACTIONS(3540),
    [anon_sym_as] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(3542),
    [anon_sym_PLUS_PLUS] = ACTIONS(3542),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_DOT_STAR] = ACTIONS(3542),
    [anon_sym_DASH_GT] = ACTIONS(3540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3540),
    [anon_sym_let] = ACTIONS(3540),
    [anon_sym_This] = ACTIONS(3540),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3542),
  },
  [2818] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2828),
    [sym_identifier] = ACTIONS(2915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4121),
    [anon_sym_COMMA] = ACTIONS(4121),
    [anon_sym_RPAREN] = ACTIONS(4121),
    [anon_sym_LPAREN2] = ACTIONS(4121),
    [anon_sym_DASH] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4124),
    [anon_sym_STAR] = ACTIONS(4124),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_PIPE_PIPE] = ACTIONS(4121),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE] = ACTIONS(4124),
    [anon_sym_CARET] = ACTIONS(4124),
    [anon_sym_AMP] = ACTIONS(4124),
    [anon_sym_EQ_EQ] = ACTIONS(4121),
    [anon_sym_BANG_EQ] = ACTIONS(4121),
    [anon_sym_GT] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4121),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_LT_LT] = ACTIONS(4124),
    [anon_sym_GT_GT] = ACTIONS(4124),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(4124),
    [anon_sym___attribute] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_signed] = ACTIONS(7061),
    [anon_sym_unsigned] = ACTIONS(7061),
    [anon_sym_long] = ACTIONS(7061),
    [anon_sym_short] = ACTIONS(7061),
    [anon_sym_LBRACK] = ACTIONS(4121),
    [anon_sym_EQ] = ACTIONS(4124),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(4121),
    [anon_sym_STAR_EQ] = ACTIONS(4121),
    [anon_sym_SLASH_EQ] = ACTIONS(4121),
    [anon_sym_PERCENT_EQ] = ACTIONS(4121),
    [anon_sym_PLUS_EQ] = ACTIONS(4121),
    [anon_sym_DASH_EQ] = ACTIONS(4121),
    [anon_sym_LT_LT_EQ] = ACTIONS(4121),
    [anon_sym_GT_GT_EQ] = ACTIONS(4121),
    [anon_sym_AMP_EQ] = ACTIONS(4121),
    [anon_sym_CARET_EQ] = ACTIONS(4121),
    [anon_sym_PIPE_EQ] = ACTIONS(4121),
    [anon_sym_and_eq] = ACTIONS(4124),
    [anon_sym_or_eq] = ACTIONS(4124),
    [anon_sym_xor_eq] = ACTIONS(4124),
    [anon_sym_LT_EQ_GT] = ACTIONS(4121),
    [anon_sym_or] = ACTIONS(4124),
    [anon_sym_and] = ACTIONS(4124),
    [anon_sym_bitor] = ACTIONS(4124),
    [anon_sym_xor] = ACTIONS(4124),
    [anon_sym_bitand] = ACTIONS(4124),
    [anon_sym_not_eq] = ACTIONS(4124),
    [anon_sym_is] = ACTIONS(4124),
    [anon_sym_as] = ACTIONS(4124),
    [anon_sym_DASH_DASH] = ACTIONS(4121),
    [anon_sym_PLUS_PLUS] = ACTIONS(4121),
    [anon_sym_DOT] = ACTIONS(4124),
    [anon_sym_DOT_STAR] = ACTIONS(4121),
    [anon_sym_DASH_GT] = ACTIONS(4124),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4124),
    [anon_sym_let] = ACTIONS(4124),
    [anon_sym_This] = ACTIONS(4124),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4121),
  },
  [2819] = {
    [sym_attribute_specifier] = STATE(2838),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4012),
    [anon_sym_COMMA] = ACTIONS(4012),
    [anon_sym_RPAREN] = ACTIONS(4012),
    [anon_sym_LPAREN2] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [anon_sym_STAR] = ACTIONS(4012),
    [anon_sym_AMP_AMP] = ACTIONS(4012),
    [anon_sym_AMP] = ACTIONS(4014),
    [anon_sym_COLON] = ACTIONS(4014),
    [anon_sym_SEMI] = ACTIONS(4012),
    [anon_sym___extension__] = ACTIONS(4014),
    [anon_sym_in] = ACTIONS(4014),
    [anon_sym_out] = ACTIONS(4014),
    [anon_sym_inout] = ACTIONS(4014),
    [anon_sym_virtual] = ACTIONS(4014),
    [anon_sym_extern] = ACTIONS(4014),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(4012),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4012),
    [anon_sym___declspec] = ACTIONS(4014),
    [anon_sym___based] = ACTIONS(4014),
    [anon_sym___cdecl] = ACTIONS(4014),
    [anon_sym___clrcall] = ACTIONS(4014),
    [anon_sym___stdcall] = ACTIONS(4014),
    [anon_sym___fastcall] = ACTIONS(4014),
    [anon_sym___thiscall] = ACTIONS(4014),
    [anon_sym___vectorcall] = ACTIONS(4014),
    [anon_sym_LBRACK] = ACTIONS(4014),
    [anon_sym_static] = ACTIONS(4014),
    [anon_sym_EQ] = ACTIONS(4012),
    [anon_sym_register] = ACTIONS(4014),
    [anon_sym_inline] = ACTIONS(4014),
    [anon_sym___inline] = ACTIONS(4014),
    [anon_sym___inline__] = ACTIONS(4014),
    [anon_sym___forceinline] = ACTIONS(4014),
    [anon_sym_thread_local] = ACTIONS(4014),
    [anon_sym___thread] = ACTIONS(4014),
    [anon_sym_const] = ACTIONS(4014),
    [anon_sym_constexpr] = ACTIONS(4014),
    [anon_sym_volatile] = ACTIONS(4014),
    [anon_sym_restrict] = ACTIONS(4014),
    [anon_sym___restrict__] = ACTIONS(4014),
    [anon_sym__Atomic] = ACTIONS(4014),
    [anon_sym__Noreturn] = ACTIONS(4014),
    [anon_sym_noreturn] = ACTIONS(4014),
    [anon_sym__Nonnull] = ACTIONS(4014),
    [anon_sym_mutable] = ACTIONS(4014),
    [anon_sym_constinit] = ACTIONS(4014),
    [anon_sym_consteval] = ACTIONS(4014),
    [anon_sym_alignas] = ACTIONS(4014),
    [anon_sym__Alignas] = ACTIONS(4014),
    [anon_sym_DOT] = ACTIONS(4014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4014),
    [anon_sym_let] = ACTIONS(4014),
    [anon_sym_This] = ACTIONS(4014),
    [anon_sym_decltype] = ACTIONS(4014),
    [anon_sym_template] = ACTIONS(4014),
    [anon_sym_GT2] = ACTIONS(4012),
    [anon_sym_operator] = ACTIONS(4014),
    [anon_sym_precise] = ACTIONS(4014),
    [anon_sym_shared] = ACTIONS(4014),
    [anon_sym_groupshared] = ACTIONS(4014),
    [anon_sym_uniform] = ACTIONS(4014),
    [anon_sym_row_major] = ACTIONS(4014),
    [anon_sym_column_major] = ACTIONS(4014),
    [anon_sym_globallycoherent] = ACTIONS(4014),
    [anon_sym_centroid] = ACTIONS(4014),
    [anon_sym_noperspective] = ACTIONS(4014),
    [anon_sym_nointerpolation] = ACTIONS(4014),
    [anon_sym_sample] = ACTIONS(4014),
    [anon_sym_linear] = ACTIONS(4014),
    [anon_sym_snorm] = ACTIONS(4014),
    [anon_sym_unorm] = ACTIONS(4014),
    [anon_sym_point] = ACTIONS(4014),
    [anon_sym_line] = ACTIONS(4014),
    [anon_sym_triangleadj] = ACTIONS(4014),
    [anon_sym_lineadj] = ACTIONS(4014),
    [anon_sym_triangle] = ACTIONS(4014),
  },
  [2820] = {
    [sym_attribute_specifier] = STATE(2870),
    [sym_identifier] = ACTIONS(4200),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4198),
    [anon_sym_COMMA] = ACTIONS(4198),
    [anon_sym_RPAREN] = ACTIONS(4198),
    [anon_sym_LPAREN2] = ACTIONS(4198),
    [anon_sym_TILDE] = ACTIONS(4198),
    [anon_sym_STAR] = ACTIONS(4198),
    [anon_sym_AMP_AMP] = ACTIONS(4198),
    [anon_sym_AMP] = ACTIONS(4200),
    [anon_sym_COLON] = ACTIONS(4200),
    [anon_sym_SEMI] = ACTIONS(4198),
    [anon_sym___extension__] = ACTIONS(4200),
    [anon_sym_in] = ACTIONS(4200),
    [anon_sym_out] = ACTIONS(4200),
    [anon_sym_inout] = ACTIONS(4200),
    [anon_sym_virtual] = ACTIONS(4200),
    [anon_sym_extern] = ACTIONS(4200),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(4198),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4198),
    [anon_sym___declspec] = ACTIONS(4200),
    [anon_sym___based] = ACTIONS(4200),
    [anon_sym___cdecl] = ACTIONS(4200),
    [anon_sym___clrcall] = ACTIONS(4200),
    [anon_sym___stdcall] = ACTIONS(4200),
    [anon_sym___fastcall] = ACTIONS(4200),
    [anon_sym___thiscall] = ACTIONS(4200),
    [anon_sym___vectorcall] = ACTIONS(4200),
    [anon_sym_LBRACK] = ACTIONS(4200),
    [anon_sym_static] = ACTIONS(4200),
    [anon_sym_EQ] = ACTIONS(4198),
    [anon_sym_register] = ACTIONS(4200),
    [anon_sym_inline] = ACTIONS(4200),
    [anon_sym___inline] = ACTIONS(4200),
    [anon_sym___inline__] = ACTIONS(4200),
    [anon_sym___forceinline] = ACTIONS(4200),
    [anon_sym_thread_local] = ACTIONS(4200),
    [anon_sym___thread] = ACTIONS(4200),
    [anon_sym_const] = ACTIONS(4200),
    [anon_sym_constexpr] = ACTIONS(4200),
    [anon_sym_volatile] = ACTIONS(4200),
    [anon_sym_restrict] = ACTIONS(4200),
    [anon_sym___restrict__] = ACTIONS(4200),
    [anon_sym__Atomic] = ACTIONS(4200),
    [anon_sym__Noreturn] = ACTIONS(4200),
    [anon_sym_noreturn] = ACTIONS(4200),
    [anon_sym__Nonnull] = ACTIONS(4200),
    [anon_sym_mutable] = ACTIONS(4200),
    [anon_sym_constinit] = ACTIONS(4200),
    [anon_sym_consteval] = ACTIONS(4200),
    [anon_sym_alignas] = ACTIONS(4200),
    [anon_sym__Alignas] = ACTIONS(4200),
    [anon_sym_DOT] = ACTIONS(4200),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4200),
    [anon_sym_let] = ACTIONS(4200),
    [anon_sym_This] = ACTIONS(4200),
    [anon_sym_decltype] = ACTIONS(4200),
    [anon_sym_template] = ACTIONS(4200),
    [anon_sym_GT2] = ACTIONS(4198),
    [anon_sym_operator] = ACTIONS(4200),
    [anon_sym_precise] = ACTIONS(4200),
    [anon_sym_shared] = ACTIONS(4200),
    [anon_sym_groupshared] = ACTIONS(4200),
    [anon_sym_uniform] = ACTIONS(4200),
    [anon_sym_row_major] = ACTIONS(4200),
    [anon_sym_column_major] = ACTIONS(4200),
    [anon_sym_globallycoherent] = ACTIONS(4200),
    [anon_sym_centroid] = ACTIONS(4200),
    [anon_sym_noperspective] = ACTIONS(4200),
    [anon_sym_nointerpolation] = ACTIONS(4200),
    [anon_sym_sample] = ACTIONS(4200),
    [anon_sym_linear] = ACTIONS(4200),
    [anon_sym_snorm] = ACTIONS(4200),
    [anon_sym_unorm] = ACTIONS(4200),
    [anon_sym_point] = ACTIONS(4200),
    [anon_sym_line] = ACTIONS(4200),
    [anon_sym_triangleadj] = ACTIONS(4200),
    [anon_sym_lineadj] = ACTIONS(4200),
    [anon_sym_triangle] = ACTIONS(4200),
  },
  [2821] = {
    [sym_attribute_specifier] = STATE(2849),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4043),
    [anon_sym_COMMA] = ACTIONS(4043),
    [anon_sym_RPAREN] = ACTIONS(4043),
    [anon_sym_LPAREN2] = ACTIONS(4043),
    [anon_sym_TILDE] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_AMP_AMP] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_COLON] = ACTIONS(4045),
    [anon_sym_SEMI] = ACTIONS(4043),
    [anon_sym___extension__] = ACTIONS(4045),
    [anon_sym_in] = ACTIONS(4045),
    [anon_sym_out] = ACTIONS(4045),
    [anon_sym_inout] = ACTIONS(4045),
    [anon_sym_virtual] = ACTIONS(4045),
    [anon_sym_extern] = ACTIONS(4045),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(4043),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4043),
    [anon_sym___declspec] = ACTIONS(4045),
    [anon_sym___based] = ACTIONS(4045),
    [anon_sym___cdecl] = ACTIONS(4045),
    [anon_sym___clrcall] = ACTIONS(4045),
    [anon_sym___stdcall] = ACTIONS(4045),
    [anon_sym___fastcall] = ACTIONS(4045),
    [anon_sym___thiscall] = ACTIONS(4045),
    [anon_sym___vectorcall] = ACTIONS(4045),
    [anon_sym_LBRACK] = ACTIONS(4045),
    [anon_sym_static] = ACTIONS(4045),
    [anon_sym_EQ] = ACTIONS(4043),
    [anon_sym_register] = ACTIONS(4045),
    [anon_sym_inline] = ACTIONS(4045),
    [anon_sym___inline] = ACTIONS(4045),
    [anon_sym___inline__] = ACTIONS(4045),
    [anon_sym___forceinline] = ACTIONS(4045),
    [anon_sym_thread_local] = ACTIONS(4045),
    [anon_sym___thread] = ACTIONS(4045),
    [anon_sym_const] = ACTIONS(4045),
    [anon_sym_constexpr] = ACTIONS(4045),
    [anon_sym_volatile] = ACTIONS(4045),
    [anon_sym_restrict] = ACTIONS(4045),
    [anon_sym___restrict__] = ACTIONS(4045),
    [anon_sym__Atomic] = ACTIONS(4045),
    [anon_sym__Noreturn] = ACTIONS(4045),
    [anon_sym_noreturn] = ACTIONS(4045),
    [anon_sym__Nonnull] = ACTIONS(4045),
    [anon_sym_mutable] = ACTIONS(4045),
    [anon_sym_constinit] = ACTIONS(4045),
    [anon_sym_consteval] = ACTIONS(4045),
    [anon_sym_alignas] = ACTIONS(4045),
    [anon_sym__Alignas] = ACTIONS(4045),
    [anon_sym_DOT] = ACTIONS(4045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4045),
    [anon_sym_let] = ACTIONS(4045),
    [anon_sym_This] = ACTIONS(4045),
    [anon_sym_decltype] = ACTIONS(4045),
    [anon_sym_template] = ACTIONS(4045),
    [anon_sym_GT2] = ACTIONS(4043),
    [anon_sym_operator] = ACTIONS(4045),
    [anon_sym_precise] = ACTIONS(4045),
    [anon_sym_shared] = ACTIONS(4045),
    [anon_sym_groupshared] = ACTIONS(4045),
    [anon_sym_uniform] = ACTIONS(4045),
    [anon_sym_row_major] = ACTIONS(4045),
    [anon_sym_column_major] = ACTIONS(4045),
    [anon_sym_globallycoherent] = ACTIONS(4045),
    [anon_sym_centroid] = ACTIONS(4045),
    [anon_sym_noperspective] = ACTIONS(4045),
    [anon_sym_nointerpolation] = ACTIONS(4045),
    [anon_sym_sample] = ACTIONS(4045),
    [anon_sym_linear] = ACTIONS(4045),
    [anon_sym_snorm] = ACTIONS(4045),
    [anon_sym_unorm] = ACTIONS(4045),
    [anon_sym_point] = ACTIONS(4045),
    [anon_sym_line] = ACTIONS(4045),
    [anon_sym_triangleadj] = ACTIONS(4045),
    [anon_sym_lineadj] = ACTIONS(4045),
    [anon_sym_triangle] = ACTIONS(4045),
  },
  [2822] = {
    [sym_attribute_specifier] = STATE(2872),
    [sym_identifier] = ACTIONS(4049),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4047),
    [anon_sym_COMMA] = ACTIONS(4047),
    [anon_sym_RPAREN] = ACTIONS(4047),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_TILDE] = ACTIONS(4047),
    [anon_sym_STAR] = ACTIONS(4047),
    [anon_sym_AMP_AMP] = ACTIONS(4047),
    [anon_sym_AMP] = ACTIONS(4049),
    [anon_sym_COLON] = ACTIONS(4049),
    [anon_sym_SEMI] = ACTIONS(4047),
    [anon_sym___extension__] = ACTIONS(4049),
    [anon_sym_in] = ACTIONS(4049),
    [anon_sym_out] = ACTIONS(4049),
    [anon_sym_inout] = ACTIONS(4049),
    [anon_sym_virtual] = ACTIONS(4049),
    [anon_sym_extern] = ACTIONS(4049),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(4047),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4047),
    [anon_sym___declspec] = ACTIONS(4049),
    [anon_sym___based] = ACTIONS(4049),
    [anon_sym___cdecl] = ACTIONS(4049),
    [anon_sym___clrcall] = ACTIONS(4049),
    [anon_sym___stdcall] = ACTIONS(4049),
    [anon_sym___fastcall] = ACTIONS(4049),
    [anon_sym___thiscall] = ACTIONS(4049),
    [anon_sym___vectorcall] = ACTIONS(4049),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_static] = ACTIONS(4049),
    [anon_sym_EQ] = ACTIONS(4047),
    [anon_sym_register] = ACTIONS(4049),
    [anon_sym_inline] = ACTIONS(4049),
    [anon_sym___inline] = ACTIONS(4049),
    [anon_sym___inline__] = ACTIONS(4049),
    [anon_sym___forceinline] = ACTIONS(4049),
    [anon_sym_thread_local] = ACTIONS(4049),
    [anon_sym___thread] = ACTIONS(4049),
    [anon_sym_const] = ACTIONS(4049),
    [anon_sym_constexpr] = ACTIONS(4049),
    [anon_sym_volatile] = ACTIONS(4049),
    [anon_sym_restrict] = ACTIONS(4049),
    [anon_sym___restrict__] = ACTIONS(4049),
    [anon_sym__Atomic] = ACTIONS(4049),
    [anon_sym__Noreturn] = ACTIONS(4049),
    [anon_sym_noreturn] = ACTIONS(4049),
    [anon_sym__Nonnull] = ACTIONS(4049),
    [anon_sym_mutable] = ACTIONS(4049),
    [anon_sym_constinit] = ACTIONS(4049),
    [anon_sym_consteval] = ACTIONS(4049),
    [anon_sym_alignas] = ACTIONS(4049),
    [anon_sym__Alignas] = ACTIONS(4049),
    [anon_sym_DOT] = ACTIONS(4049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4049),
    [anon_sym_let] = ACTIONS(4049),
    [anon_sym_This] = ACTIONS(4049),
    [anon_sym_decltype] = ACTIONS(4049),
    [anon_sym_template] = ACTIONS(4049),
    [anon_sym_GT2] = ACTIONS(4047),
    [anon_sym_operator] = ACTIONS(4049),
    [anon_sym_precise] = ACTIONS(4049),
    [anon_sym_shared] = ACTIONS(4049),
    [anon_sym_groupshared] = ACTIONS(4049),
    [anon_sym_uniform] = ACTIONS(4049),
    [anon_sym_row_major] = ACTIONS(4049),
    [anon_sym_column_major] = ACTIONS(4049),
    [anon_sym_globallycoherent] = ACTIONS(4049),
    [anon_sym_centroid] = ACTIONS(4049),
    [anon_sym_noperspective] = ACTIONS(4049),
    [anon_sym_nointerpolation] = ACTIONS(4049),
    [anon_sym_sample] = ACTIONS(4049),
    [anon_sym_linear] = ACTIONS(4049),
    [anon_sym_snorm] = ACTIONS(4049),
    [anon_sym_unorm] = ACTIONS(4049),
    [anon_sym_point] = ACTIONS(4049),
    [anon_sym_line] = ACTIONS(4049),
    [anon_sym_triangleadj] = ACTIONS(4049),
    [anon_sym_lineadj] = ACTIONS(4049),
    [anon_sym_triangle] = ACTIONS(4049),
  },
  [2823] = {
    [sym_template_argument_list] = STATE(2722),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2764),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_LPAREN2] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2168),
    [anon_sym_LT] = ACTIONS(7064),
    [anon_sym_SEMI] = ACTIONS(2176),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2176),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym___cdecl] = ACTIONS(2168),
    [anon_sym___clrcall] = ACTIONS(2168),
    [anon_sym___stdcall] = ACTIONS(2168),
    [anon_sym___fastcall] = ACTIONS(2168),
    [anon_sym___thiscall] = ACTIONS(2168),
    [anon_sym___vectorcall] = ACTIONS(2168),
    [anon_sym_signed] = ACTIONS(5332),
    [anon_sym_unsigned] = ACTIONS(5332),
    [anon_sym_long] = ACTIONS(5332),
    [anon_sym_short] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(2168),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [anon_sym_DOT] = ACTIONS(2176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_decltype] = ACTIONS(2168),
    [anon_sym_template] = ACTIONS(2168),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
  },
  [2824] = {
    [sym_attribute_specifier] = STATE(2883),
    [sym_identifier] = ACTIONS(4107),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4109),
    [anon_sym_COMMA] = ACTIONS(4109),
    [anon_sym_RPAREN] = ACTIONS(4109),
    [anon_sym_LPAREN2] = ACTIONS(4109),
    [anon_sym_TILDE] = ACTIONS(4109),
    [anon_sym_STAR] = ACTIONS(4109),
    [anon_sym_AMP_AMP] = ACTIONS(4109),
    [anon_sym_AMP] = ACTIONS(4107),
    [anon_sym_COLON] = ACTIONS(4107),
    [anon_sym_SEMI] = ACTIONS(4109),
    [anon_sym___extension__] = ACTIONS(4107),
    [anon_sym_in] = ACTIONS(4107),
    [anon_sym_out] = ACTIONS(4107),
    [anon_sym_inout] = ACTIONS(4107),
    [anon_sym_virtual] = ACTIONS(4107),
    [anon_sym_extern] = ACTIONS(4107),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(4109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4109),
    [anon_sym___declspec] = ACTIONS(4107),
    [anon_sym___based] = ACTIONS(4107),
    [anon_sym___cdecl] = ACTIONS(4107),
    [anon_sym___clrcall] = ACTIONS(4107),
    [anon_sym___stdcall] = ACTIONS(4107),
    [anon_sym___fastcall] = ACTIONS(4107),
    [anon_sym___thiscall] = ACTIONS(4107),
    [anon_sym___vectorcall] = ACTIONS(4107),
    [anon_sym_LBRACK] = ACTIONS(4107),
    [anon_sym_static] = ACTIONS(4107),
    [anon_sym_EQ] = ACTIONS(4109),
    [anon_sym_register] = ACTIONS(4107),
    [anon_sym_inline] = ACTIONS(4107),
    [anon_sym___inline] = ACTIONS(4107),
    [anon_sym___inline__] = ACTIONS(4107),
    [anon_sym___forceinline] = ACTIONS(4107),
    [anon_sym_thread_local] = ACTIONS(4107),
    [anon_sym___thread] = ACTIONS(4107),
    [anon_sym_const] = ACTIONS(4107),
    [anon_sym_constexpr] = ACTIONS(4107),
    [anon_sym_volatile] = ACTIONS(4107),
    [anon_sym_restrict] = ACTIONS(4107),
    [anon_sym___restrict__] = ACTIONS(4107),
    [anon_sym__Atomic] = ACTIONS(4107),
    [anon_sym__Noreturn] = ACTIONS(4107),
    [anon_sym_noreturn] = ACTIONS(4107),
    [anon_sym__Nonnull] = ACTIONS(4107),
    [anon_sym_mutable] = ACTIONS(4107),
    [anon_sym_constinit] = ACTIONS(4107),
    [anon_sym_consteval] = ACTIONS(4107),
    [anon_sym_alignas] = ACTIONS(4107),
    [anon_sym__Alignas] = ACTIONS(4107),
    [anon_sym_DOT] = ACTIONS(4107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4107),
    [anon_sym_let] = ACTIONS(4107),
    [anon_sym_This] = ACTIONS(4107),
    [anon_sym_decltype] = ACTIONS(4107),
    [anon_sym_template] = ACTIONS(4107),
    [anon_sym_GT2] = ACTIONS(4109),
    [anon_sym_operator] = ACTIONS(4107),
    [anon_sym_precise] = ACTIONS(4107),
    [anon_sym_shared] = ACTIONS(4107),
    [anon_sym_groupshared] = ACTIONS(4107),
    [anon_sym_uniform] = ACTIONS(4107),
    [anon_sym_row_major] = ACTIONS(4107),
    [anon_sym_column_major] = ACTIONS(4107),
    [anon_sym_globallycoherent] = ACTIONS(4107),
    [anon_sym_centroid] = ACTIONS(4107),
    [anon_sym_noperspective] = ACTIONS(4107),
    [anon_sym_nointerpolation] = ACTIONS(4107),
    [anon_sym_sample] = ACTIONS(4107),
    [anon_sym_linear] = ACTIONS(4107),
    [anon_sym_snorm] = ACTIONS(4107),
    [anon_sym_unorm] = ACTIONS(4107),
    [anon_sym_point] = ACTIONS(4107),
    [anon_sym_line] = ACTIONS(4107),
    [anon_sym_triangleadj] = ACTIONS(4107),
    [anon_sym_lineadj] = ACTIONS(4107),
    [anon_sym_triangle] = ACTIONS(4107),
  },
  [2825] = {
    [sym_identifier] = ACTIONS(7066),
    [anon_sym___extension__] = ACTIONS(7066),
    [anon_sym_in] = ACTIONS(7066),
    [anon_sym_out] = ACTIONS(7066),
    [anon_sym_inout] = ACTIONS(7066),
    [anon_sym_virtual] = ACTIONS(7066),
    [anon_sym_extern] = ACTIONS(7066),
    [anon_sym___attribute__] = ACTIONS(7066),
    [anon_sym___attribute] = ACTIONS(7066),
    [anon_sym_COLON_COLON] = ACTIONS(7068),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7068),
    [anon_sym___declspec] = ACTIONS(7066),
    [anon_sym___cdecl] = ACTIONS(7066),
    [anon_sym___clrcall] = ACTIONS(7066),
    [anon_sym___stdcall] = ACTIONS(7066),
    [anon_sym___fastcall] = ACTIONS(7066),
    [anon_sym___thiscall] = ACTIONS(7066),
    [anon_sym___vectorcall] = ACTIONS(7066),
    [anon_sym_signed] = ACTIONS(7066),
    [anon_sym_unsigned] = ACTIONS(7066),
    [anon_sym_long] = ACTIONS(7066),
    [anon_sym_short] = ACTIONS(7066),
    [anon_sym_LBRACK] = ACTIONS(7070),
    [anon_sym_static] = ACTIONS(7066),
    [anon_sym_EQ] = ACTIONS(7072),
    [anon_sym_register] = ACTIONS(7066),
    [anon_sym_inline] = ACTIONS(7066),
    [anon_sym___inline] = ACTIONS(7066),
    [anon_sym___inline__] = ACTIONS(7066),
    [anon_sym___forceinline] = ACTIONS(7066),
    [anon_sym_thread_local] = ACTIONS(7066),
    [anon_sym___thread] = ACTIONS(7066),
    [anon_sym_const] = ACTIONS(7066),
    [anon_sym_constexpr] = ACTIONS(7066),
    [anon_sym_volatile] = ACTIONS(7066),
    [anon_sym_restrict] = ACTIONS(7066),
    [anon_sym___restrict__] = ACTIONS(7066),
    [anon_sym__Atomic] = ACTIONS(7066),
    [anon_sym__Noreturn] = ACTIONS(7066),
    [anon_sym_noreturn] = ACTIONS(7066),
    [anon_sym__Nonnull] = ACTIONS(7066),
    [anon_sym_mutable] = ACTIONS(7066),
    [anon_sym_constinit] = ACTIONS(7066),
    [anon_sym_consteval] = ACTIONS(7066),
    [anon_sym_alignas] = ACTIONS(7066),
    [anon_sym__Alignas] = ACTIONS(7066),
    [sym_primitive_type] = ACTIONS(7066),
    [anon_sym_enum] = ACTIONS(7066),
    [anon_sym_class] = ACTIONS(7066),
    [anon_sym_struct] = ACTIONS(7066),
    [anon_sym_union] = ACTIONS(7066),
    [anon_sym_if] = ACTIONS(7066),
    [anon_sym_for] = ACTIONS(7066),
    [anon_sym_DOT] = ACTIONS(7072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(7066),
    [anon_sym_let] = ACTIONS(7066),
    [anon_sym_This] = ACTIONS(7066),
    [anon_sym_decltype] = ACTIONS(7066),
    [anon_sym_typename] = ACTIONS(7066),
    [anon_sym_template] = ACTIONS(7066),
    [anon_sym_precise] = ACTIONS(7066),
    [anon_sym_shared] = ACTIONS(7066),
    [anon_sym_groupshared] = ACTIONS(7066),
    [anon_sym_uniform] = ACTIONS(7066),
    [anon_sym_row_major] = ACTIONS(7066),
    [anon_sym_column_major] = ACTIONS(7066),
    [anon_sym_globallycoherent] = ACTIONS(7066),
    [anon_sym_centroid] = ACTIONS(7066),
    [anon_sym_noperspective] = ACTIONS(7066),
    [anon_sym_nointerpolation] = ACTIONS(7066),
    [anon_sym_sample] = ACTIONS(7066),
    [anon_sym_linear] = ACTIONS(7066),
    [anon_sym_snorm] = ACTIONS(7066),
    [anon_sym_unorm] = ACTIONS(7066),
    [anon_sym_point] = ACTIONS(7066),
    [anon_sym_line] = ACTIONS(7066),
    [anon_sym_triangleadj] = ACTIONS(7066),
    [anon_sym_lineadj] = ACTIONS(7066),
    [anon_sym_triangle] = ACTIONS(7066),
    [anon_sym_interface] = ACTIONS(7066),
    [anon_sym_extension] = ACTIONS(7066),
  },
  [2826] = {
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2972),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_RPAREN] = ACTIONS(2972),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_COLON] = ACTIONS(2974),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym___extension__] = ACTIONS(2974),
    [anon_sym_in] = ACTIONS(2974),
    [anon_sym_out] = ACTIONS(2974),
    [anon_sym_inout] = ACTIONS(2974),
    [anon_sym_virtual] = ACTIONS(2974),
    [anon_sym_extern] = ACTIONS(2974),
    [anon_sym___attribute__] = ACTIONS(2974),
    [anon_sym___attribute] = ACTIONS(2974),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2972),
    [anon_sym___declspec] = ACTIONS(2974),
    [anon_sym___based] = ACTIONS(2974),
    [anon_sym___cdecl] = ACTIONS(2974),
    [anon_sym___clrcall] = ACTIONS(2974),
    [anon_sym___stdcall] = ACTIONS(2974),
    [anon_sym___fastcall] = ACTIONS(2974),
    [anon_sym___thiscall] = ACTIONS(2974),
    [anon_sym___vectorcall] = ACTIONS(2974),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [anon_sym_static] = ACTIONS(2974),
    [anon_sym_EQ] = ACTIONS(2972),
    [anon_sym_register] = ACTIONS(2974),
    [anon_sym_inline] = ACTIONS(2974),
    [anon_sym___inline] = ACTIONS(2974),
    [anon_sym___inline__] = ACTIONS(2974),
    [anon_sym___forceinline] = ACTIONS(2974),
    [anon_sym_thread_local] = ACTIONS(2974),
    [anon_sym___thread] = ACTIONS(2974),
    [anon_sym_const] = ACTIONS(2974),
    [anon_sym_constexpr] = ACTIONS(2974),
    [anon_sym_volatile] = ACTIONS(2974),
    [anon_sym_restrict] = ACTIONS(2974),
    [anon_sym___restrict__] = ACTIONS(2974),
    [anon_sym__Atomic] = ACTIONS(2974),
    [anon_sym__Noreturn] = ACTIONS(2974),
    [anon_sym_noreturn] = ACTIONS(2974),
    [anon_sym__Nonnull] = ACTIONS(2974),
    [anon_sym_mutable] = ACTIONS(2974),
    [anon_sym_constinit] = ACTIONS(2974),
    [anon_sym_consteval] = ACTIONS(2974),
    [anon_sym_alignas] = ACTIONS(2974),
    [anon_sym__Alignas] = ACTIONS(2974),
    [anon_sym_DOT] = ACTIONS(2974),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_This] = ACTIONS(2974),
    [anon_sym_decltype] = ACTIONS(2974),
    [anon_sym_template] = ACTIONS(2974),
    [anon_sym_GT2] = ACTIONS(2972),
    [anon_sym_operator] = ACTIONS(2974),
    [anon_sym_precise] = ACTIONS(2974),
    [anon_sym_shared] = ACTIONS(2974),
    [anon_sym_groupshared] = ACTIONS(2974),
    [anon_sym_uniform] = ACTIONS(2974),
    [anon_sym_row_major] = ACTIONS(2974),
    [anon_sym_column_major] = ACTIONS(2974),
    [anon_sym_globallycoherent] = ACTIONS(2974),
    [anon_sym_centroid] = ACTIONS(2974),
    [anon_sym_noperspective] = ACTIONS(2974),
    [anon_sym_nointerpolation] = ACTIONS(2974),
    [anon_sym_sample] = ACTIONS(2974),
    [anon_sym_linear] = ACTIONS(2974),
    [anon_sym_snorm] = ACTIONS(2974),
    [anon_sym_unorm] = ACTIONS(2974),
    [anon_sym_point] = ACTIONS(2974),
    [anon_sym_line] = ACTIONS(2974),
    [anon_sym_triangleadj] = ACTIONS(2974),
    [anon_sym_lineadj] = ACTIONS(2974),
    [anon_sym_triangle] = ACTIONS(2974),
  },
  [2827] = {
    [sym_template_argument_list] = STATE(3043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2764),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_LPAREN2] = ACTIONS(2193),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2168),
    [anon_sym_LT] = ACTIONS(7064),
    [anon_sym_SEMI] = ACTIONS(2176),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2193),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym___cdecl] = ACTIONS(2168),
    [anon_sym___clrcall] = ACTIONS(2168),
    [anon_sym___stdcall] = ACTIONS(2168),
    [anon_sym___fastcall] = ACTIONS(2168),
    [anon_sym___thiscall] = ACTIONS(2168),
    [anon_sym___vectorcall] = ACTIONS(2168),
    [anon_sym_signed] = ACTIONS(5332),
    [anon_sym_unsigned] = ACTIONS(5332),
    [anon_sym_long] = ACTIONS(5332),
    [anon_sym_short] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(7074),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [anon_sym_DOT] = ACTIONS(2176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_decltype] = ACTIONS(2168),
    [anon_sym_template] = ACTIONS(2168),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
  },
  [2828] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2828),
    [sym_identifier] = ACTIONS(2915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2913),
    [anon_sym_COMMA] = ACTIONS(2913),
    [anon_sym_RPAREN] = ACTIONS(2913),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2915),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(2915),
    [anon_sym_SLASH] = ACTIONS(2915),
    [anon_sym_PERCENT] = ACTIONS(2915),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_CARET] = ACTIONS(2915),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2915),
    [anon_sym_GT_EQ] = ACTIONS(2913),
    [anon_sym_LT_EQ] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2915),
    [anon_sym_LT_LT] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2915),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_signed] = ACTIONS(7061),
    [anon_sym_unsigned] = ACTIONS(7061),
    [anon_sym_long] = ACTIONS(7061),
    [anon_sym_short] = ACTIONS(7061),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(2913),
    [anon_sym_STAR_EQ] = ACTIONS(2913),
    [anon_sym_SLASH_EQ] = ACTIONS(2913),
    [anon_sym_PERCENT_EQ] = ACTIONS(2913),
    [anon_sym_PLUS_EQ] = ACTIONS(2913),
    [anon_sym_DASH_EQ] = ACTIONS(2913),
    [anon_sym_LT_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_GT_EQ] = ACTIONS(2913),
    [anon_sym_AMP_EQ] = ACTIONS(2913),
    [anon_sym_CARET_EQ] = ACTIONS(2913),
    [anon_sym_PIPE_EQ] = ACTIONS(2913),
    [anon_sym_and_eq] = ACTIONS(2915),
    [anon_sym_or_eq] = ACTIONS(2915),
    [anon_sym_xor_eq] = ACTIONS(2915),
    [anon_sym_LT_EQ_GT] = ACTIONS(2913),
    [anon_sym_or] = ACTIONS(2915),
    [anon_sym_and] = ACTIONS(2915),
    [anon_sym_bitor] = ACTIONS(2915),
    [anon_sym_xor] = ACTIONS(2915),
    [anon_sym_bitand] = ACTIONS(2915),
    [anon_sym_not_eq] = ACTIONS(2915),
    [anon_sym_is] = ACTIONS(2915),
    [anon_sym_as] = ACTIONS(2915),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_DOT] = ACTIONS(2915),
    [anon_sym_DOT_STAR] = ACTIONS(2913),
    [anon_sym_DASH_GT] = ACTIONS(2915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2915),
    [anon_sym_let] = ACTIONS(2915),
    [anon_sym_This] = ACTIONS(2915),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2913),
  },
  [2829] = {
    [sym_template_argument_list] = STATE(2722),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2764),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_LPAREN2] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2168),
    [anon_sym_LT] = ACTIONS(7064),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2176),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym___cdecl] = ACTIONS(2168),
    [anon_sym___clrcall] = ACTIONS(2168),
    [anon_sym___stdcall] = ACTIONS(2168),
    [anon_sym___fastcall] = ACTIONS(2168),
    [anon_sym___thiscall] = ACTIONS(2168),
    [anon_sym___vectorcall] = ACTIONS(2168),
    [anon_sym_signed] = ACTIONS(5332),
    [anon_sym_unsigned] = ACTIONS(5332),
    [anon_sym_long] = ACTIONS(5332),
    [anon_sym_short] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(2168),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [anon_sym_DOT] = ACTIONS(2176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_decltype] = ACTIONS(2168),
    [anon_sym_template] = ACTIONS(2168),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
  },
  [2830] = {
    [sym_attribute_specifier] = STATE(2851),
    [sym_identifier] = ACTIONS(4176),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(4174),
    [anon_sym_RPAREN] = ACTIONS(4174),
    [anon_sym_LPAREN2] = ACTIONS(4174),
    [anon_sym_TILDE] = ACTIONS(4174),
    [anon_sym_STAR] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4176),
    [anon_sym_COLON] = ACTIONS(4176),
    [anon_sym_SEMI] = ACTIONS(4174),
    [anon_sym___extension__] = ACTIONS(4176),
    [anon_sym_in] = ACTIONS(4176),
    [anon_sym_out] = ACTIONS(4176),
    [anon_sym_inout] = ACTIONS(4176),
    [anon_sym_virtual] = ACTIONS(4176),
    [anon_sym_extern] = ACTIONS(4176),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(4174),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4174),
    [anon_sym___declspec] = ACTIONS(4176),
    [anon_sym___based] = ACTIONS(4176),
    [anon_sym___cdecl] = ACTIONS(4176),
    [anon_sym___clrcall] = ACTIONS(4176),
    [anon_sym___stdcall] = ACTIONS(4176),
    [anon_sym___fastcall] = ACTIONS(4176),
    [anon_sym___thiscall] = ACTIONS(4176),
    [anon_sym___vectorcall] = ACTIONS(4176),
    [anon_sym_LBRACK] = ACTIONS(4176),
    [anon_sym_static] = ACTIONS(4176),
    [anon_sym_EQ] = ACTIONS(4174),
    [anon_sym_register] = ACTIONS(4176),
    [anon_sym_inline] = ACTIONS(4176),
    [anon_sym___inline] = ACTIONS(4176),
    [anon_sym___inline__] = ACTIONS(4176),
    [anon_sym___forceinline] = ACTIONS(4176),
    [anon_sym_thread_local] = ACTIONS(4176),
    [anon_sym___thread] = ACTIONS(4176),
    [anon_sym_const] = ACTIONS(4176),
    [anon_sym_constexpr] = ACTIONS(4176),
    [anon_sym_volatile] = ACTIONS(4176),
    [anon_sym_restrict] = ACTIONS(4176),
    [anon_sym___restrict__] = ACTIONS(4176),
    [anon_sym__Atomic] = ACTIONS(4176),
    [anon_sym__Noreturn] = ACTIONS(4176),
    [anon_sym_noreturn] = ACTIONS(4176),
    [anon_sym__Nonnull] = ACTIONS(4176),
    [anon_sym_mutable] = ACTIONS(4176),
    [anon_sym_constinit] = ACTIONS(4176),
    [anon_sym_consteval] = ACTIONS(4176),
    [anon_sym_alignas] = ACTIONS(4176),
    [anon_sym__Alignas] = ACTIONS(4176),
    [anon_sym_DOT] = ACTIONS(4176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4176),
    [anon_sym_let] = ACTIONS(4176),
    [anon_sym_This] = ACTIONS(4176),
    [anon_sym_decltype] = ACTIONS(4176),
    [anon_sym_template] = ACTIONS(4176),
    [anon_sym_GT2] = ACTIONS(4174),
    [anon_sym_operator] = ACTIONS(4176),
    [anon_sym_precise] = ACTIONS(4176),
    [anon_sym_shared] = ACTIONS(4176),
    [anon_sym_groupshared] = ACTIONS(4176),
    [anon_sym_uniform] = ACTIONS(4176),
    [anon_sym_row_major] = ACTIONS(4176),
    [anon_sym_column_major] = ACTIONS(4176),
    [anon_sym_globallycoherent] = ACTIONS(4176),
    [anon_sym_centroid] = ACTIONS(4176),
    [anon_sym_noperspective] = ACTIONS(4176),
    [anon_sym_nointerpolation] = ACTIONS(4176),
    [anon_sym_sample] = ACTIONS(4176),
    [anon_sym_linear] = ACTIONS(4176),
    [anon_sym_snorm] = ACTIONS(4176),
    [anon_sym_unorm] = ACTIONS(4176),
    [anon_sym_point] = ACTIONS(4176),
    [anon_sym_line] = ACTIONS(4176),
    [anon_sym_triangleadj] = ACTIONS(4176),
    [anon_sym_lineadj] = ACTIONS(4176),
    [anon_sym_triangle] = ACTIONS(4176),
  },
  [2831] = {
    [sym_attribute_specifier] = STATE(2879),
    [sym_identifier] = ACTIONS(4060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4058),
    [anon_sym_COMMA] = ACTIONS(4058),
    [anon_sym_RPAREN] = ACTIONS(4058),
    [anon_sym_LPAREN2] = ACTIONS(4058),
    [anon_sym_TILDE] = ACTIONS(4058),
    [anon_sym_STAR] = ACTIONS(4058),
    [anon_sym_AMP_AMP] = ACTIONS(4058),
    [anon_sym_AMP] = ACTIONS(4060),
    [anon_sym_COLON] = ACTIONS(4060),
    [anon_sym_SEMI] = ACTIONS(4058),
    [anon_sym___extension__] = ACTIONS(4060),
    [anon_sym_in] = ACTIONS(4060),
    [anon_sym_out] = ACTIONS(4060),
    [anon_sym_inout] = ACTIONS(4060),
    [anon_sym_virtual] = ACTIONS(4060),
    [anon_sym_extern] = ACTIONS(4060),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(4058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4058),
    [anon_sym___declspec] = ACTIONS(4060),
    [anon_sym___based] = ACTIONS(4060),
    [anon_sym___cdecl] = ACTIONS(4060),
    [anon_sym___clrcall] = ACTIONS(4060),
    [anon_sym___stdcall] = ACTIONS(4060),
    [anon_sym___fastcall] = ACTIONS(4060),
    [anon_sym___thiscall] = ACTIONS(4060),
    [anon_sym___vectorcall] = ACTIONS(4060),
    [anon_sym_LBRACK] = ACTIONS(4060),
    [anon_sym_static] = ACTIONS(4060),
    [anon_sym_EQ] = ACTIONS(4058),
    [anon_sym_register] = ACTIONS(4060),
    [anon_sym_inline] = ACTIONS(4060),
    [anon_sym___inline] = ACTIONS(4060),
    [anon_sym___inline__] = ACTIONS(4060),
    [anon_sym___forceinline] = ACTIONS(4060),
    [anon_sym_thread_local] = ACTIONS(4060),
    [anon_sym___thread] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4060),
    [anon_sym_constexpr] = ACTIONS(4060),
    [anon_sym_volatile] = ACTIONS(4060),
    [anon_sym_restrict] = ACTIONS(4060),
    [anon_sym___restrict__] = ACTIONS(4060),
    [anon_sym__Atomic] = ACTIONS(4060),
    [anon_sym__Noreturn] = ACTIONS(4060),
    [anon_sym_noreturn] = ACTIONS(4060),
    [anon_sym__Nonnull] = ACTIONS(4060),
    [anon_sym_mutable] = ACTIONS(4060),
    [anon_sym_constinit] = ACTIONS(4060),
    [anon_sym_consteval] = ACTIONS(4060),
    [anon_sym_alignas] = ACTIONS(4060),
    [anon_sym__Alignas] = ACTIONS(4060),
    [anon_sym_DOT] = ACTIONS(4060),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4060),
    [anon_sym_let] = ACTIONS(4060),
    [anon_sym_This] = ACTIONS(4060),
    [anon_sym_decltype] = ACTIONS(4060),
    [anon_sym_template] = ACTIONS(4060),
    [anon_sym_GT2] = ACTIONS(4058),
    [anon_sym_operator] = ACTIONS(4060),
    [anon_sym_precise] = ACTIONS(4060),
    [anon_sym_shared] = ACTIONS(4060),
    [anon_sym_groupshared] = ACTIONS(4060),
    [anon_sym_uniform] = ACTIONS(4060),
    [anon_sym_row_major] = ACTIONS(4060),
    [anon_sym_column_major] = ACTIONS(4060),
    [anon_sym_globallycoherent] = ACTIONS(4060),
    [anon_sym_centroid] = ACTIONS(4060),
    [anon_sym_noperspective] = ACTIONS(4060),
    [anon_sym_nointerpolation] = ACTIONS(4060),
    [anon_sym_sample] = ACTIONS(4060),
    [anon_sym_linear] = ACTIONS(4060),
    [anon_sym_snorm] = ACTIONS(4060),
    [anon_sym_unorm] = ACTIONS(4060),
    [anon_sym_point] = ACTIONS(4060),
    [anon_sym_line] = ACTIONS(4060),
    [anon_sym_triangleadj] = ACTIONS(4060),
    [anon_sym_lineadj] = ACTIONS(4060),
    [anon_sym_triangle] = ACTIONS(4060),
  },
  [2832] = {
    [sym_attribute_specifier] = STATE(2853),
    [sym_identifier] = ACTIONS(4004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4002),
    [anon_sym_COMMA] = ACTIONS(4002),
    [anon_sym_RPAREN] = ACTIONS(4002),
    [anon_sym_LPAREN2] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_STAR] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4002),
    [anon_sym_AMP] = ACTIONS(4004),
    [anon_sym_COLON] = ACTIONS(4004),
    [anon_sym_SEMI] = ACTIONS(4002),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_in] = ACTIONS(4004),
    [anon_sym_out] = ACTIONS(4004),
    [anon_sym_inout] = ACTIONS(4004),
    [anon_sym_virtual] = ACTIONS(4004),
    [anon_sym_extern] = ACTIONS(4004),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(4002),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4002),
    [anon_sym___declspec] = ACTIONS(4004),
    [anon_sym___based] = ACTIONS(4004),
    [anon_sym___cdecl] = ACTIONS(4004),
    [anon_sym___clrcall] = ACTIONS(4004),
    [anon_sym___stdcall] = ACTIONS(4004),
    [anon_sym___fastcall] = ACTIONS(4004),
    [anon_sym___thiscall] = ACTIONS(4004),
    [anon_sym___vectorcall] = ACTIONS(4004),
    [anon_sym_LBRACK] = ACTIONS(4004),
    [anon_sym_static] = ACTIONS(4004),
    [anon_sym_EQ] = ACTIONS(4002),
    [anon_sym_register] = ACTIONS(4004),
    [anon_sym_inline] = ACTIONS(4004),
    [anon_sym___inline] = ACTIONS(4004),
    [anon_sym___inline__] = ACTIONS(4004),
    [anon_sym___forceinline] = ACTIONS(4004),
    [anon_sym_thread_local] = ACTIONS(4004),
    [anon_sym___thread] = ACTIONS(4004),
    [anon_sym_const] = ACTIONS(4004),
    [anon_sym_constexpr] = ACTIONS(4004),
    [anon_sym_volatile] = ACTIONS(4004),
    [anon_sym_restrict] = ACTIONS(4004),
    [anon_sym___restrict__] = ACTIONS(4004),
    [anon_sym__Atomic] = ACTIONS(4004),
    [anon_sym__Noreturn] = ACTIONS(4004),
    [anon_sym_noreturn] = ACTIONS(4004),
    [anon_sym__Nonnull] = ACTIONS(4004),
    [anon_sym_mutable] = ACTIONS(4004),
    [anon_sym_constinit] = ACTIONS(4004),
    [anon_sym_consteval] = ACTIONS(4004),
    [anon_sym_alignas] = ACTIONS(4004),
    [anon_sym__Alignas] = ACTIONS(4004),
    [anon_sym_DOT] = ACTIONS(4004),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4004),
    [anon_sym_let] = ACTIONS(4004),
    [anon_sym_This] = ACTIONS(4004),
    [anon_sym_decltype] = ACTIONS(4004),
    [anon_sym_template] = ACTIONS(4004),
    [anon_sym_GT2] = ACTIONS(4002),
    [anon_sym_operator] = ACTIONS(4004),
    [anon_sym_precise] = ACTIONS(4004),
    [anon_sym_shared] = ACTIONS(4004),
    [anon_sym_groupshared] = ACTIONS(4004),
    [anon_sym_uniform] = ACTIONS(4004),
    [anon_sym_row_major] = ACTIONS(4004),
    [anon_sym_column_major] = ACTIONS(4004),
    [anon_sym_globallycoherent] = ACTIONS(4004),
    [anon_sym_centroid] = ACTIONS(4004),
    [anon_sym_noperspective] = ACTIONS(4004),
    [anon_sym_nointerpolation] = ACTIONS(4004),
    [anon_sym_sample] = ACTIONS(4004),
    [anon_sym_linear] = ACTIONS(4004),
    [anon_sym_snorm] = ACTIONS(4004),
    [anon_sym_unorm] = ACTIONS(4004),
    [anon_sym_point] = ACTIONS(4004),
    [anon_sym_line] = ACTIONS(4004),
    [anon_sym_triangleadj] = ACTIONS(4004),
    [anon_sym_lineadj] = ACTIONS(4004),
    [anon_sym_triangle] = ACTIONS(4004),
  },
  [2833] = {
    [sym_attribute_specifier] = STATE(2903),
    [sym_identifier] = ACTIONS(4156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4154),
    [anon_sym_COMMA] = ACTIONS(4154),
    [anon_sym_RPAREN] = ACTIONS(4154),
    [anon_sym_LPAREN2] = ACTIONS(4154),
    [anon_sym_TILDE] = ACTIONS(4154),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_AMP_AMP] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4156),
    [anon_sym_COLON] = ACTIONS(4156),
    [anon_sym_SEMI] = ACTIONS(4154),
    [anon_sym___extension__] = ACTIONS(4156),
    [anon_sym_in] = ACTIONS(4156),
    [anon_sym_out] = ACTIONS(4156),
    [anon_sym_inout] = ACTIONS(4156),
    [anon_sym_virtual] = ACTIONS(4156),
    [anon_sym_extern] = ACTIONS(4156),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(4154),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4154),
    [anon_sym___declspec] = ACTIONS(4156),
    [anon_sym___based] = ACTIONS(4156),
    [anon_sym___cdecl] = ACTIONS(4156),
    [anon_sym___clrcall] = ACTIONS(4156),
    [anon_sym___stdcall] = ACTIONS(4156),
    [anon_sym___fastcall] = ACTIONS(4156),
    [anon_sym___thiscall] = ACTIONS(4156),
    [anon_sym___vectorcall] = ACTIONS(4156),
    [anon_sym_LBRACK] = ACTIONS(4156),
    [anon_sym_static] = ACTIONS(4156),
    [anon_sym_EQ] = ACTIONS(4154),
    [anon_sym_register] = ACTIONS(4156),
    [anon_sym_inline] = ACTIONS(4156),
    [anon_sym___inline] = ACTIONS(4156),
    [anon_sym___inline__] = ACTIONS(4156),
    [anon_sym___forceinline] = ACTIONS(4156),
    [anon_sym_thread_local] = ACTIONS(4156),
    [anon_sym___thread] = ACTIONS(4156),
    [anon_sym_const] = ACTIONS(4156),
    [anon_sym_constexpr] = ACTIONS(4156),
    [anon_sym_volatile] = ACTIONS(4156),
    [anon_sym_restrict] = ACTIONS(4156),
    [anon_sym___restrict__] = ACTIONS(4156),
    [anon_sym__Atomic] = ACTIONS(4156),
    [anon_sym__Noreturn] = ACTIONS(4156),
    [anon_sym_noreturn] = ACTIONS(4156),
    [anon_sym__Nonnull] = ACTIONS(4156),
    [anon_sym_mutable] = ACTIONS(4156),
    [anon_sym_constinit] = ACTIONS(4156),
    [anon_sym_consteval] = ACTIONS(4156),
    [anon_sym_alignas] = ACTIONS(4156),
    [anon_sym__Alignas] = ACTIONS(4156),
    [anon_sym_DOT] = ACTIONS(4156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4156),
    [anon_sym_let] = ACTIONS(4156),
    [anon_sym_This] = ACTIONS(4156),
    [anon_sym_decltype] = ACTIONS(4156),
    [anon_sym_template] = ACTIONS(4156),
    [anon_sym_GT2] = ACTIONS(4154),
    [anon_sym_operator] = ACTIONS(4156),
    [anon_sym_precise] = ACTIONS(4156),
    [anon_sym_shared] = ACTIONS(4156),
    [anon_sym_groupshared] = ACTIONS(4156),
    [anon_sym_uniform] = ACTIONS(4156),
    [anon_sym_row_major] = ACTIONS(4156),
    [anon_sym_column_major] = ACTIONS(4156),
    [anon_sym_globallycoherent] = ACTIONS(4156),
    [anon_sym_centroid] = ACTIONS(4156),
    [anon_sym_noperspective] = ACTIONS(4156),
    [anon_sym_nointerpolation] = ACTIONS(4156),
    [anon_sym_sample] = ACTIONS(4156),
    [anon_sym_linear] = ACTIONS(4156),
    [anon_sym_snorm] = ACTIONS(4156),
    [anon_sym_unorm] = ACTIONS(4156),
    [anon_sym_point] = ACTIONS(4156),
    [anon_sym_line] = ACTIONS(4156),
    [anon_sym_triangleadj] = ACTIONS(4156),
    [anon_sym_lineadj] = ACTIONS(4156),
    [anon_sym_triangle] = ACTIONS(4156),
  },
  [2834] = {
    [sym_attribute_specifier] = STATE(2880),
    [sym_identifier] = ACTIONS(4091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4089),
    [anon_sym_COMMA] = ACTIONS(4089),
    [anon_sym_RPAREN] = ACTIONS(4089),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_TILDE] = ACTIONS(4089),
    [anon_sym_STAR] = ACTIONS(4089),
    [anon_sym_AMP_AMP] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4091),
    [anon_sym_COLON] = ACTIONS(4091),
    [anon_sym_SEMI] = ACTIONS(4089),
    [anon_sym___extension__] = ACTIONS(4091),
    [anon_sym_in] = ACTIONS(4091),
    [anon_sym_out] = ACTIONS(4091),
    [anon_sym_inout] = ACTIONS(4091),
    [anon_sym_virtual] = ACTIONS(4091),
    [anon_sym_extern] = ACTIONS(4091),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(4089),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4089),
    [anon_sym___declspec] = ACTIONS(4091),
    [anon_sym___based] = ACTIONS(4091),
    [anon_sym___cdecl] = ACTIONS(4091),
    [anon_sym___clrcall] = ACTIONS(4091),
    [anon_sym___stdcall] = ACTIONS(4091),
    [anon_sym___fastcall] = ACTIONS(4091),
    [anon_sym___thiscall] = ACTIONS(4091),
    [anon_sym___vectorcall] = ACTIONS(4091),
    [anon_sym_LBRACK] = ACTIONS(4091),
    [anon_sym_static] = ACTIONS(4091),
    [anon_sym_EQ] = ACTIONS(4089),
    [anon_sym_register] = ACTIONS(4091),
    [anon_sym_inline] = ACTIONS(4091),
    [anon_sym___inline] = ACTIONS(4091),
    [anon_sym___inline__] = ACTIONS(4091),
    [anon_sym___forceinline] = ACTIONS(4091),
    [anon_sym_thread_local] = ACTIONS(4091),
    [anon_sym___thread] = ACTIONS(4091),
    [anon_sym_const] = ACTIONS(4091),
    [anon_sym_constexpr] = ACTIONS(4091),
    [anon_sym_volatile] = ACTIONS(4091),
    [anon_sym_restrict] = ACTIONS(4091),
    [anon_sym___restrict__] = ACTIONS(4091),
    [anon_sym__Atomic] = ACTIONS(4091),
    [anon_sym__Noreturn] = ACTIONS(4091),
    [anon_sym_noreturn] = ACTIONS(4091),
    [anon_sym__Nonnull] = ACTIONS(4091),
    [anon_sym_mutable] = ACTIONS(4091),
    [anon_sym_constinit] = ACTIONS(4091),
    [anon_sym_consteval] = ACTIONS(4091),
    [anon_sym_alignas] = ACTIONS(4091),
    [anon_sym__Alignas] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(4091),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4091),
    [anon_sym_let] = ACTIONS(4091),
    [anon_sym_This] = ACTIONS(4091),
    [anon_sym_decltype] = ACTIONS(4091),
    [anon_sym_template] = ACTIONS(4091),
    [anon_sym_GT2] = ACTIONS(4089),
    [anon_sym_operator] = ACTIONS(4091),
    [anon_sym_precise] = ACTIONS(4091),
    [anon_sym_shared] = ACTIONS(4091),
    [anon_sym_groupshared] = ACTIONS(4091),
    [anon_sym_uniform] = ACTIONS(4091),
    [anon_sym_row_major] = ACTIONS(4091),
    [anon_sym_column_major] = ACTIONS(4091),
    [anon_sym_globallycoherent] = ACTIONS(4091),
    [anon_sym_centroid] = ACTIONS(4091),
    [anon_sym_noperspective] = ACTIONS(4091),
    [anon_sym_nointerpolation] = ACTIONS(4091),
    [anon_sym_sample] = ACTIONS(4091),
    [anon_sym_linear] = ACTIONS(4091),
    [anon_sym_snorm] = ACTIONS(4091),
    [anon_sym_unorm] = ACTIONS(4091),
    [anon_sym_point] = ACTIONS(4091),
    [anon_sym_line] = ACTIONS(4091),
    [anon_sym_triangleadj] = ACTIONS(4091),
    [anon_sym_lineadj] = ACTIONS(4091),
    [anon_sym_triangle] = ACTIONS(4091),
  },
  [2835] = {
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3352),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3362),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3362),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3362),
    [anon_sym_explicit] = ACTIONS(3362),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3362),
    [anon_sym_operator] = ACTIONS(3362),
    [anon_sym_friend] = ACTIONS(7077),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [2836] = {
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3352),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3362),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3362),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3362),
    [anon_sym_explicit] = ACTIONS(3362),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3362),
    [anon_sym_operator] = ACTIONS(3362),
    [anon_sym_friend] = ACTIONS(7079),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [2837] = {
    [sym_identifier] = ACTIONS(5072),
    [anon_sym_LPAREN2] = ACTIONS(5070),
    [anon_sym_TILDE] = ACTIONS(5070),
    [anon_sym_STAR] = ACTIONS(5070),
    [anon_sym_AMP_AMP] = ACTIONS(5070),
    [anon_sym_AMP] = ACTIONS(5072),
    [anon_sym___extension__] = ACTIONS(5072),
    [anon_sym_in] = ACTIONS(5072),
    [anon_sym_out] = ACTIONS(5072),
    [anon_sym_inout] = ACTIONS(5072),
    [anon_sym_virtual] = ACTIONS(5072),
    [anon_sym_extern] = ACTIONS(5072),
    [anon_sym___attribute__] = ACTIONS(5072),
    [anon_sym___attribute] = ACTIONS(5072),
    [anon_sym_using] = ACTIONS(5068),
    [anon_sym_COLON_COLON] = ACTIONS(5070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5063),
    [anon_sym___declspec] = ACTIONS(5072),
    [anon_sym___based] = ACTIONS(5072),
    [anon_sym_signed] = ACTIONS(5072),
    [anon_sym_unsigned] = ACTIONS(5072),
    [anon_sym_long] = ACTIONS(5072),
    [anon_sym_short] = ACTIONS(5072),
    [anon_sym_LBRACK] = ACTIONS(5072),
    [anon_sym_static] = ACTIONS(5072),
    [anon_sym_register] = ACTIONS(5072),
    [anon_sym_inline] = ACTIONS(5072),
    [anon_sym___inline] = ACTIONS(5072),
    [anon_sym___inline__] = ACTIONS(5072),
    [anon_sym___forceinline] = ACTIONS(5072),
    [anon_sym_thread_local] = ACTIONS(5072),
    [anon_sym___thread] = ACTIONS(5072),
    [anon_sym_const] = ACTIONS(5072),
    [anon_sym_constexpr] = ACTIONS(5072),
    [anon_sym_volatile] = ACTIONS(5072),
    [anon_sym_restrict] = ACTIONS(5072),
    [anon_sym___restrict__] = ACTIONS(5072),
    [anon_sym__Atomic] = ACTIONS(5072),
    [anon_sym__Noreturn] = ACTIONS(5072),
    [anon_sym_noreturn] = ACTIONS(5072),
    [anon_sym__Nonnull] = ACTIONS(5072),
    [anon_sym_mutable] = ACTIONS(5072),
    [anon_sym_constinit] = ACTIONS(5072),
    [anon_sym_consteval] = ACTIONS(5072),
    [anon_sym_alignas] = ACTIONS(5072),
    [anon_sym__Alignas] = ACTIONS(5072),
    [sym_primitive_type] = ACTIONS(5072),
    [anon_sym_enum] = ACTIONS(5072),
    [anon_sym_class] = ACTIONS(5072),
    [anon_sym_struct] = ACTIONS(5072),
    [anon_sym_union] = ACTIONS(5072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(5072),
    [anon_sym_let] = ACTIONS(5072),
    [anon_sym_This] = ACTIONS(5072),
    [anon_sym_decltype] = ACTIONS(5072),
    [anon_sym_explicit] = ACTIONS(5072),
    [anon_sym_typename] = ACTIONS(5072),
    [anon_sym_template] = ACTIONS(5072),
    [anon_sym_operator] = ACTIONS(5072),
    [anon_sym_precise] = ACTIONS(5072),
    [anon_sym_shared] = ACTIONS(5072),
    [anon_sym_groupshared] = ACTIONS(5072),
    [anon_sym_uniform] = ACTIONS(5072),
    [anon_sym_row_major] = ACTIONS(5072),
    [anon_sym_column_major] = ACTIONS(5072),
    [anon_sym_globallycoherent] = ACTIONS(5072),
    [anon_sym_centroid] = ACTIONS(5072),
    [anon_sym_noperspective] = ACTIONS(5072),
    [anon_sym_nointerpolation] = ACTIONS(5072),
    [anon_sym_sample] = ACTIONS(5072),
    [anon_sym_linear] = ACTIONS(5072),
    [anon_sym_snorm] = ACTIONS(5072),
    [anon_sym_unorm] = ACTIONS(5072),
    [anon_sym_point] = ACTIONS(5072),
    [anon_sym_line] = ACTIONS(5072),
    [anon_sym_triangleadj] = ACTIONS(5072),
    [anon_sym_lineadj] = ACTIONS(5072),
    [anon_sym_triangle] = ACTIONS(5072),
    [anon_sym_interface] = ACTIONS(5072),
    [anon_sym_extension] = ACTIONS(5072),
  },
  [2838] = {
    [sym_identifier] = ACTIONS(2930),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2928),
    [anon_sym_COMMA] = ACTIONS(2928),
    [anon_sym_RPAREN] = ACTIONS(2928),
    [anon_sym_LPAREN2] = ACTIONS(2928),
    [anon_sym_TILDE] = ACTIONS(2928),
    [anon_sym_STAR] = ACTIONS(2928),
    [anon_sym_AMP_AMP] = ACTIONS(2928),
    [anon_sym_AMP] = ACTIONS(2930),
    [anon_sym_COLON] = ACTIONS(2930),
    [anon_sym_SEMI] = ACTIONS(2928),
    [anon_sym___extension__] = ACTIONS(2930),
    [anon_sym_in] = ACTIONS(2930),
    [anon_sym_out] = ACTIONS(2930),
    [anon_sym_inout] = ACTIONS(2930),
    [anon_sym_virtual] = ACTIONS(2930),
    [anon_sym_extern] = ACTIONS(2930),
    [anon_sym___attribute__] = ACTIONS(2930),
    [anon_sym___attribute] = ACTIONS(2930),
    [anon_sym_COLON_COLON] = ACTIONS(2928),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2928),
    [anon_sym___declspec] = ACTIONS(2930),
    [anon_sym___based] = ACTIONS(2930),
    [anon_sym___cdecl] = ACTIONS(2930),
    [anon_sym___clrcall] = ACTIONS(2930),
    [anon_sym___stdcall] = ACTIONS(2930),
    [anon_sym___fastcall] = ACTIONS(2930),
    [anon_sym___thiscall] = ACTIONS(2930),
    [anon_sym___vectorcall] = ACTIONS(2930),
    [anon_sym_LBRACK] = ACTIONS(2930),
    [anon_sym_static] = ACTIONS(2930),
    [anon_sym_EQ] = ACTIONS(2928),
    [anon_sym_register] = ACTIONS(2930),
    [anon_sym_inline] = ACTIONS(2930),
    [anon_sym___inline] = ACTIONS(2930),
    [anon_sym___inline__] = ACTIONS(2930),
    [anon_sym___forceinline] = ACTIONS(2930),
    [anon_sym_thread_local] = ACTIONS(2930),
    [anon_sym___thread] = ACTIONS(2930),
    [anon_sym_const] = ACTIONS(2930),
    [anon_sym_constexpr] = ACTIONS(2930),
    [anon_sym_volatile] = ACTIONS(2930),
    [anon_sym_restrict] = ACTIONS(2930),
    [anon_sym___restrict__] = ACTIONS(2930),
    [anon_sym__Atomic] = ACTIONS(2930),
    [anon_sym__Noreturn] = ACTIONS(2930),
    [anon_sym_noreturn] = ACTIONS(2930),
    [anon_sym__Nonnull] = ACTIONS(2930),
    [anon_sym_mutable] = ACTIONS(2930),
    [anon_sym_constinit] = ACTIONS(2930),
    [anon_sym_consteval] = ACTIONS(2930),
    [anon_sym_alignas] = ACTIONS(2930),
    [anon_sym__Alignas] = ACTIONS(2930),
    [anon_sym_DOT] = ACTIONS(2930),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2930),
    [anon_sym_This] = ACTIONS(2930),
    [anon_sym_decltype] = ACTIONS(2930),
    [anon_sym_template] = ACTIONS(2930),
    [anon_sym_GT2] = ACTIONS(2928),
    [anon_sym_operator] = ACTIONS(2930),
    [anon_sym_precise] = ACTIONS(2930),
    [anon_sym_shared] = ACTIONS(2930),
    [anon_sym_groupshared] = ACTIONS(2930),
    [anon_sym_uniform] = ACTIONS(2930),
    [anon_sym_row_major] = ACTIONS(2930),
    [anon_sym_column_major] = ACTIONS(2930),
    [anon_sym_globallycoherent] = ACTIONS(2930),
    [anon_sym_centroid] = ACTIONS(2930),
    [anon_sym_noperspective] = ACTIONS(2930),
    [anon_sym_nointerpolation] = ACTIONS(2930),
    [anon_sym_sample] = ACTIONS(2930),
    [anon_sym_linear] = ACTIONS(2930),
    [anon_sym_snorm] = ACTIONS(2930),
    [anon_sym_unorm] = ACTIONS(2930),
    [anon_sym_point] = ACTIONS(2930),
    [anon_sym_line] = ACTIONS(2930),
    [anon_sym_triangleadj] = ACTIONS(2930),
    [anon_sym_lineadj] = ACTIONS(2930),
    [anon_sym_triangle] = ACTIONS(2930),
  },
  [2839] = {
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2881),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2881),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2881),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_GT2] = ACTIONS(2881),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
  },
  [2840] = {
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2932),
    [anon_sym_COMMA] = ACTIONS(2932),
    [anon_sym_RPAREN] = ACTIONS(2932),
    [anon_sym_LPAREN2] = ACTIONS(2932),
    [anon_sym_TILDE] = ACTIONS(2932),
    [anon_sym_STAR] = ACTIONS(2932),
    [anon_sym_AMP_AMP] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_COLON] = ACTIONS(2934),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym___extension__] = ACTIONS(2934),
    [anon_sym_in] = ACTIONS(2934),
    [anon_sym_out] = ACTIONS(2934),
    [anon_sym_inout] = ACTIONS(2934),
    [anon_sym_virtual] = ACTIONS(2934),
    [anon_sym_extern] = ACTIONS(2934),
    [anon_sym___attribute__] = ACTIONS(2934),
    [anon_sym___attribute] = ACTIONS(2934),
    [anon_sym_COLON_COLON] = ACTIONS(2932),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2932),
    [anon_sym___declspec] = ACTIONS(2934),
    [anon_sym___based] = ACTIONS(2934),
    [anon_sym___cdecl] = ACTIONS(2934),
    [anon_sym___clrcall] = ACTIONS(2934),
    [anon_sym___stdcall] = ACTIONS(2934),
    [anon_sym___fastcall] = ACTIONS(2934),
    [anon_sym___thiscall] = ACTIONS(2934),
    [anon_sym___vectorcall] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [anon_sym_static] = ACTIONS(2934),
    [anon_sym_EQ] = ACTIONS(2932),
    [anon_sym_register] = ACTIONS(2934),
    [anon_sym_inline] = ACTIONS(2934),
    [anon_sym___inline] = ACTIONS(2934),
    [anon_sym___inline__] = ACTIONS(2934),
    [anon_sym___forceinline] = ACTIONS(2934),
    [anon_sym_thread_local] = ACTIONS(2934),
    [anon_sym___thread] = ACTIONS(2934),
    [anon_sym_const] = ACTIONS(2934),
    [anon_sym_constexpr] = ACTIONS(2934),
    [anon_sym_volatile] = ACTIONS(2934),
    [anon_sym_restrict] = ACTIONS(2934),
    [anon_sym___restrict__] = ACTIONS(2934),
    [anon_sym__Atomic] = ACTIONS(2934),
    [anon_sym__Noreturn] = ACTIONS(2934),
    [anon_sym_noreturn] = ACTIONS(2934),
    [anon_sym__Nonnull] = ACTIONS(2934),
    [anon_sym_mutable] = ACTIONS(2934),
    [anon_sym_constinit] = ACTIONS(2934),
    [anon_sym_consteval] = ACTIONS(2934),
    [anon_sym_alignas] = ACTIONS(2934),
    [anon_sym__Alignas] = ACTIONS(2934),
    [anon_sym_DOT] = ACTIONS(2934),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_This] = ACTIONS(2934),
    [anon_sym_decltype] = ACTIONS(2934),
    [anon_sym_template] = ACTIONS(2934),
    [anon_sym_GT2] = ACTIONS(2932),
    [anon_sym_operator] = ACTIONS(2934),
    [anon_sym_precise] = ACTIONS(2934),
    [anon_sym_shared] = ACTIONS(2934),
    [anon_sym_groupshared] = ACTIONS(2934),
    [anon_sym_uniform] = ACTIONS(2934),
    [anon_sym_row_major] = ACTIONS(2934),
    [anon_sym_column_major] = ACTIONS(2934),
    [anon_sym_globallycoherent] = ACTIONS(2934),
    [anon_sym_centroid] = ACTIONS(2934),
    [anon_sym_noperspective] = ACTIONS(2934),
    [anon_sym_nointerpolation] = ACTIONS(2934),
    [anon_sym_sample] = ACTIONS(2934),
    [anon_sym_linear] = ACTIONS(2934),
    [anon_sym_snorm] = ACTIONS(2934),
    [anon_sym_unorm] = ACTIONS(2934),
    [anon_sym_point] = ACTIONS(2934),
    [anon_sym_line] = ACTIONS(2934),
    [anon_sym_triangleadj] = ACTIONS(2934),
    [anon_sym_lineadj] = ACTIONS(2934),
    [anon_sym_triangle] = ACTIONS(2934),
  },
  [2841] = {
    [sym_identifier] = ACTIONS(6895),
    [anon_sym_LPAREN2] = ACTIONS(6897),
    [anon_sym_TILDE] = ACTIONS(6897),
    [anon_sym_STAR] = ACTIONS(6897),
    [anon_sym_AMP_AMP] = ACTIONS(6897),
    [anon_sym_AMP] = ACTIONS(6895),
    [anon_sym___extension__] = ACTIONS(6895),
    [anon_sym_in] = ACTIONS(6895),
    [anon_sym_out] = ACTIONS(6895),
    [anon_sym_inout] = ACTIONS(6895),
    [anon_sym_virtual] = ACTIONS(6895),
    [anon_sym_extern] = ACTIONS(6895),
    [anon_sym___attribute__] = ACTIONS(6895),
    [anon_sym___attribute] = ACTIONS(6895),
    [anon_sym_COLON_COLON] = ACTIONS(6897),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6897),
    [anon_sym___declspec] = ACTIONS(6895),
    [anon_sym___based] = ACTIONS(6895),
    [anon_sym_signed] = ACTIONS(6895),
    [anon_sym_unsigned] = ACTIONS(6895),
    [anon_sym_long] = ACTIONS(6895),
    [anon_sym_short] = ACTIONS(6895),
    [anon_sym_LBRACK] = ACTIONS(6895),
    [anon_sym_static] = ACTIONS(6895),
    [anon_sym_register] = ACTIONS(6895),
    [anon_sym_inline] = ACTIONS(6895),
    [anon_sym___inline] = ACTIONS(6895),
    [anon_sym___inline__] = ACTIONS(6895),
    [anon_sym___forceinline] = ACTIONS(6895),
    [anon_sym_thread_local] = ACTIONS(6895),
    [anon_sym___thread] = ACTIONS(6895),
    [anon_sym_const] = ACTIONS(6895),
    [anon_sym_constexpr] = ACTIONS(6895),
    [anon_sym_volatile] = ACTIONS(6895),
    [anon_sym_restrict] = ACTIONS(6895),
    [anon_sym___restrict__] = ACTIONS(6895),
    [anon_sym__Atomic] = ACTIONS(6895),
    [anon_sym__Noreturn] = ACTIONS(6895),
    [anon_sym_noreturn] = ACTIONS(6895),
    [anon_sym__Nonnull] = ACTIONS(6895),
    [anon_sym_mutable] = ACTIONS(6895),
    [anon_sym_constinit] = ACTIONS(6895),
    [anon_sym_consteval] = ACTIONS(6895),
    [anon_sym_alignas] = ACTIONS(6895),
    [anon_sym__Alignas] = ACTIONS(6895),
    [sym_primitive_type] = ACTIONS(6895),
    [anon_sym_enum] = ACTIONS(6895),
    [anon_sym_class] = ACTIONS(6895),
    [anon_sym_struct] = ACTIONS(6895),
    [anon_sym_union] = ACTIONS(6895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6895),
    [anon_sym_let] = ACTIONS(6895),
    [anon_sym_This] = ACTIONS(6895),
    [anon_sym_decltype] = ACTIONS(6895),
    [anon_sym_explicit] = ACTIONS(6895),
    [anon_sym_typename] = ACTIONS(6895),
    [anon_sym_template] = ACTIONS(6895),
    [anon_sym_operator] = ACTIONS(6895),
    [anon_sym_namespace] = ACTIONS(7081),
    [anon_sym_precise] = ACTIONS(6895),
    [anon_sym_shared] = ACTIONS(6895),
    [anon_sym_groupshared] = ACTIONS(6895),
    [anon_sym_uniform] = ACTIONS(6895),
    [anon_sym_row_major] = ACTIONS(6895),
    [anon_sym_column_major] = ACTIONS(6895),
    [anon_sym_globallycoherent] = ACTIONS(6895),
    [anon_sym_centroid] = ACTIONS(6895),
    [anon_sym_noperspective] = ACTIONS(6895),
    [anon_sym_nointerpolation] = ACTIONS(6895),
    [anon_sym_sample] = ACTIONS(6895),
    [anon_sym_linear] = ACTIONS(6895),
    [anon_sym_snorm] = ACTIONS(6895),
    [anon_sym_unorm] = ACTIONS(6895),
    [anon_sym_point] = ACTIONS(6895),
    [anon_sym_line] = ACTIONS(6895),
    [anon_sym_triangleadj] = ACTIONS(6895),
    [anon_sym_lineadj] = ACTIONS(6895),
    [anon_sym_triangle] = ACTIONS(6895),
    [anon_sym_interface] = ACTIONS(6895),
    [anon_sym_extension] = ACTIONS(6895),
  },
  [2842] = {
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2881),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2881),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_GT2] = ACTIONS(2881),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
  },
  [2843] = {
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3352),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3362),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3362),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3362),
    [anon_sym_explicit] = ACTIONS(3362),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3362),
    [anon_sym_operator] = ACTIONS(3362),
    [anon_sym_friend] = ACTIONS(7083),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [2844] = {
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2881),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2881),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
  },
  [2845] = {
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3352),
    [anon_sym_COMMA] = ACTIONS(3352),
    [anon_sym_RPAREN] = ACTIONS(3352),
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_DASH] = ACTIONS(3362),
    [anon_sym_PLUS] = ACTIONS(3362),
    [anon_sym_STAR] = ACTIONS(3362),
    [anon_sym_SLASH] = ACTIONS(3362),
    [anon_sym_PERCENT] = ACTIONS(3362),
    [anon_sym_PIPE_PIPE] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_PIPE] = ACTIONS(3362),
    [anon_sym_CARET] = ACTIONS(3362),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_EQ_EQ] = ACTIONS(3352),
    [anon_sym_BANG_EQ] = ACTIONS(3352),
    [anon_sym_GT] = ACTIONS(3362),
    [anon_sym_GT_EQ] = ACTIONS(3352),
    [anon_sym_LT_EQ] = ACTIONS(3362),
    [anon_sym_LT] = ACTIONS(3362),
    [anon_sym_LT_LT] = ACTIONS(3362),
    [anon_sym_GT_GT] = ACTIONS(3362),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_LBRACE] = ACTIONS(3352),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3352),
    [anon_sym_EQ] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3362),
    [anon_sym_QMARK] = ACTIONS(3352),
    [anon_sym_STAR_EQ] = ACTIONS(3352),
    [anon_sym_SLASH_EQ] = ACTIONS(3352),
    [anon_sym_PERCENT_EQ] = ACTIONS(3352),
    [anon_sym_PLUS_EQ] = ACTIONS(3352),
    [anon_sym_DASH_EQ] = ACTIONS(3352),
    [anon_sym_LT_LT_EQ] = ACTIONS(3352),
    [anon_sym_GT_GT_EQ] = ACTIONS(3352),
    [anon_sym_AMP_EQ] = ACTIONS(3352),
    [anon_sym_CARET_EQ] = ACTIONS(3352),
    [anon_sym_PIPE_EQ] = ACTIONS(3352),
    [anon_sym_and_eq] = ACTIONS(3362),
    [anon_sym_or_eq] = ACTIONS(3362),
    [anon_sym_xor_eq] = ACTIONS(3362),
    [anon_sym_LT_EQ_GT] = ACTIONS(3352),
    [anon_sym_or] = ACTIONS(3362),
    [anon_sym_and] = ACTIONS(3362),
    [anon_sym_bitor] = ACTIONS(3362),
    [anon_sym_xor] = ACTIONS(3362),
    [anon_sym_bitand] = ACTIONS(3362),
    [anon_sym_not_eq] = ACTIONS(3362),
    [anon_sym_is] = ACTIONS(3362),
    [anon_sym_as] = ACTIONS(3362),
    [anon_sym_DASH_DASH] = ACTIONS(3352),
    [anon_sym_PLUS_PLUS] = ACTIONS(3352),
    [anon_sym_DOT] = ACTIONS(3362),
    [anon_sym_DOT_STAR] = ACTIONS(3352),
    [anon_sym_DASH_GT] = ACTIONS(3362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3352),
  },
  [2846] = {
    [sym_identifier] = ACTIONS(3026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3024),
    [anon_sym_COMMA] = ACTIONS(3024),
    [anon_sym_RPAREN] = ACTIONS(3024),
    [anon_sym_LPAREN2] = ACTIONS(3024),
    [anon_sym_TILDE] = ACTIONS(3024),
    [anon_sym_STAR] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_AMP] = ACTIONS(3026),
    [anon_sym_COLON] = ACTIONS(3026),
    [anon_sym_SEMI] = ACTIONS(3024),
    [anon_sym___extension__] = ACTIONS(3026),
    [anon_sym_in] = ACTIONS(3026),
    [anon_sym_out] = ACTIONS(3026),
    [anon_sym_inout] = ACTIONS(3026),
    [anon_sym_virtual] = ACTIONS(3026),
    [anon_sym_extern] = ACTIONS(3026),
    [anon_sym___attribute__] = ACTIONS(3026),
    [anon_sym___attribute] = ACTIONS(3026),
    [anon_sym_COLON_COLON] = ACTIONS(3024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3024),
    [anon_sym___declspec] = ACTIONS(3026),
    [anon_sym___based] = ACTIONS(3026),
    [anon_sym___cdecl] = ACTIONS(3026),
    [anon_sym___clrcall] = ACTIONS(3026),
    [anon_sym___stdcall] = ACTIONS(3026),
    [anon_sym___fastcall] = ACTIONS(3026),
    [anon_sym___thiscall] = ACTIONS(3026),
    [anon_sym___vectorcall] = ACTIONS(3026),
    [anon_sym_LBRACK] = ACTIONS(3026),
    [anon_sym_static] = ACTIONS(3026),
    [anon_sym_EQ] = ACTIONS(3024),
    [anon_sym_register] = ACTIONS(3026),
    [anon_sym_inline] = ACTIONS(3026),
    [anon_sym___inline] = ACTIONS(3026),
    [anon_sym___inline__] = ACTIONS(3026),
    [anon_sym___forceinline] = ACTIONS(3026),
    [anon_sym_thread_local] = ACTIONS(3026),
    [anon_sym___thread] = ACTIONS(3026),
    [anon_sym_const] = ACTIONS(3026),
    [anon_sym_constexpr] = ACTIONS(3026),
    [anon_sym_volatile] = ACTIONS(3026),
    [anon_sym_restrict] = ACTIONS(3026),
    [anon_sym___restrict__] = ACTIONS(3026),
    [anon_sym__Atomic] = ACTIONS(3026),
    [anon_sym__Noreturn] = ACTIONS(3026),
    [anon_sym_noreturn] = ACTIONS(3026),
    [anon_sym__Nonnull] = ACTIONS(3026),
    [anon_sym_mutable] = ACTIONS(3026),
    [anon_sym_constinit] = ACTIONS(3026),
    [anon_sym_consteval] = ACTIONS(3026),
    [anon_sym_alignas] = ACTIONS(3026),
    [anon_sym__Alignas] = ACTIONS(3026),
    [anon_sym_DOT] = ACTIONS(3026),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3026),
    [anon_sym_let] = ACTIONS(3026),
    [anon_sym_This] = ACTIONS(3026),
    [anon_sym_decltype] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(3026),
    [anon_sym_GT2] = ACTIONS(3024),
    [anon_sym_operator] = ACTIONS(3026),
    [anon_sym_precise] = ACTIONS(3026),
    [anon_sym_shared] = ACTIONS(3026),
    [anon_sym_groupshared] = ACTIONS(3026),
    [anon_sym_uniform] = ACTIONS(3026),
    [anon_sym_row_major] = ACTIONS(3026),
    [anon_sym_column_major] = ACTIONS(3026),
    [anon_sym_globallycoherent] = ACTIONS(3026),
    [anon_sym_centroid] = ACTIONS(3026),
    [anon_sym_noperspective] = ACTIONS(3026),
    [anon_sym_nointerpolation] = ACTIONS(3026),
    [anon_sym_sample] = ACTIONS(3026),
    [anon_sym_linear] = ACTIONS(3026),
    [anon_sym_snorm] = ACTIONS(3026),
    [anon_sym_unorm] = ACTIONS(3026),
    [anon_sym_point] = ACTIONS(3026),
    [anon_sym_line] = ACTIONS(3026),
    [anon_sym_triangleadj] = ACTIONS(3026),
    [anon_sym_lineadj] = ACTIONS(3026),
    [anon_sym_triangle] = ACTIONS(3026),
  },
  [2847] = {
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2881),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2881),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2881),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
  },
  [2848] = {
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3352),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3362),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3362),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3362),
    [anon_sym_explicit] = ACTIONS(3362),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3362),
    [anon_sym_operator] = ACTIONS(3362),
    [anon_sym_friend] = ACTIONS(7085),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [2849] = {
    [sym_identifier] = ACTIONS(3002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3000),
    [anon_sym_COMMA] = ACTIONS(3000),
    [anon_sym_RPAREN] = ACTIONS(3000),
    [anon_sym_LPAREN2] = ACTIONS(3000),
    [anon_sym_TILDE] = ACTIONS(3000),
    [anon_sym_STAR] = ACTIONS(3000),
    [anon_sym_AMP_AMP] = ACTIONS(3000),
    [anon_sym_AMP] = ACTIONS(3002),
    [anon_sym_COLON] = ACTIONS(3002),
    [anon_sym_SEMI] = ACTIONS(3000),
    [anon_sym___extension__] = ACTIONS(3002),
    [anon_sym_in] = ACTIONS(3002),
    [anon_sym_out] = ACTIONS(3002),
    [anon_sym_inout] = ACTIONS(3002),
    [anon_sym_virtual] = ACTIONS(3002),
    [anon_sym_extern] = ACTIONS(3002),
    [anon_sym___attribute__] = ACTIONS(3002),
    [anon_sym___attribute] = ACTIONS(3002),
    [anon_sym_COLON_COLON] = ACTIONS(3000),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3000),
    [anon_sym___declspec] = ACTIONS(3002),
    [anon_sym___based] = ACTIONS(3002),
    [anon_sym___cdecl] = ACTIONS(3002),
    [anon_sym___clrcall] = ACTIONS(3002),
    [anon_sym___stdcall] = ACTIONS(3002),
    [anon_sym___fastcall] = ACTIONS(3002),
    [anon_sym___thiscall] = ACTIONS(3002),
    [anon_sym___vectorcall] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_static] = ACTIONS(3002),
    [anon_sym_EQ] = ACTIONS(3000),
    [anon_sym_register] = ACTIONS(3002),
    [anon_sym_inline] = ACTIONS(3002),
    [anon_sym___inline] = ACTIONS(3002),
    [anon_sym___inline__] = ACTIONS(3002),
    [anon_sym___forceinline] = ACTIONS(3002),
    [anon_sym_thread_local] = ACTIONS(3002),
    [anon_sym___thread] = ACTIONS(3002),
    [anon_sym_const] = ACTIONS(3002),
    [anon_sym_constexpr] = ACTIONS(3002),
    [anon_sym_volatile] = ACTIONS(3002),
    [anon_sym_restrict] = ACTIONS(3002),
    [anon_sym___restrict__] = ACTIONS(3002),
    [anon_sym__Atomic] = ACTIONS(3002),
    [anon_sym__Noreturn] = ACTIONS(3002),
    [anon_sym_noreturn] = ACTIONS(3002),
    [anon_sym__Nonnull] = ACTIONS(3002),
    [anon_sym_mutable] = ACTIONS(3002),
    [anon_sym_constinit] = ACTIONS(3002),
    [anon_sym_consteval] = ACTIONS(3002),
    [anon_sym_alignas] = ACTIONS(3002),
    [anon_sym__Alignas] = ACTIONS(3002),
    [anon_sym_DOT] = ACTIONS(3002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3002),
    [anon_sym_let] = ACTIONS(3002),
    [anon_sym_This] = ACTIONS(3002),
    [anon_sym_decltype] = ACTIONS(3002),
    [anon_sym_template] = ACTIONS(3002),
    [anon_sym_GT2] = ACTIONS(3000),
    [anon_sym_operator] = ACTIONS(3002),
    [anon_sym_precise] = ACTIONS(3002),
    [anon_sym_shared] = ACTIONS(3002),
    [anon_sym_groupshared] = ACTIONS(3002),
    [anon_sym_uniform] = ACTIONS(3002),
    [anon_sym_row_major] = ACTIONS(3002),
    [anon_sym_column_major] = ACTIONS(3002),
    [anon_sym_globallycoherent] = ACTIONS(3002),
    [anon_sym_centroid] = ACTIONS(3002),
    [anon_sym_noperspective] = ACTIONS(3002),
    [anon_sym_nointerpolation] = ACTIONS(3002),
    [anon_sym_sample] = ACTIONS(3002),
    [anon_sym_linear] = ACTIONS(3002),
    [anon_sym_snorm] = ACTIONS(3002),
    [anon_sym_unorm] = ACTIONS(3002),
    [anon_sym_point] = ACTIONS(3002),
    [anon_sym_line] = ACTIONS(3002),
    [anon_sym_triangleadj] = ACTIONS(3002),
    [anon_sym_lineadj] = ACTIONS(3002),
    [anon_sym_triangle] = ACTIONS(3002),
  },
  [2850] = {
    [sym_identifier] = ACTIONS(2948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2946),
    [anon_sym_COMMA] = ACTIONS(2946),
    [anon_sym_RPAREN] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2946),
    [anon_sym_TILDE] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_COLON] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym___extension__] = ACTIONS(2948),
    [anon_sym_in] = ACTIONS(2948),
    [anon_sym_out] = ACTIONS(2948),
    [anon_sym_inout] = ACTIONS(2948),
    [anon_sym_virtual] = ACTIONS(2948),
    [anon_sym_extern] = ACTIONS(2948),
    [anon_sym___attribute__] = ACTIONS(2948),
    [anon_sym___attribute] = ACTIONS(2948),
    [anon_sym_COLON_COLON] = ACTIONS(2946),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2946),
    [anon_sym___declspec] = ACTIONS(2948),
    [anon_sym___based] = ACTIONS(2948),
    [anon_sym___cdecl] = ACTIONS(2948),
    [anon_sym___clrcall] = ACTIONS(2948),
    [anon_sym___stdcall] = ACTIONS(2948),
    [anon_sym___fastcall] = ACTIONS(2948),
    [anon_sym___thiscall] = ACTIONS(2948),
    [anon_sym___vectorcall] = ACTIONS(2948),
    [anon_sym_LBRACK] = ACTIONS(2948),
    [anon_sym_static] = ACTIONS(2948),
    [anon_sym_EQ] = ACTIONS(2946),
    [anon_sym_register] = ACTIONS(2948),
    [anon_sym_inline] = ACTIONS(2948),
    [anon_sym___inline] = ACTIONS(2948),
    [anon_sym___inline__] = ACTIONS(2948),
    [anon_sym___forceinline] = ACTIONS(2948),
    [anon_sym_thread_local] = ACTIONS(2948),
    [anon_sym___thread] = ACTIONS(2948),
    [anon_sym_const] = ACTIONS(2948),
    [anon_sym_constexpr] = ACTIONS(2948),
    [anon_sym_volatile] = ACTIONS(2948),
    [anon_sym_restrict] = ACTIONS(2948),
    [anon_sym___restrict__] = ACTIONS(2948),
    [anon_sym__Atomic] = ACTIONS(2948),
    [anon_sym__Noreturn] = ACTIONS(2948),
    [anon_sym_noreturn] = ACTIONS(2948),
    [anon_sym__Nonnull] = ACTIONS(2948),
    [anon_sym_mutable] = ACTIONS(2948),
    [anon_sym_constinit] = ACTIONS(2948),
    [anon_sym_consteval] = ACTIONS(2948),
    [anon_sym_alignas] = ACTIONS(2948),
    [anon_sym__Alignas] = ACTIONS(2948),
    [anon_sym_DOT] = ACTIONS(2948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2948),
    [anon_sym_let] = ACTIONS(2948),
    [anon_sym_This] = ACTIONS(2948),
    [anon_sym_decltype] = ACTIONS(2948),
    [anon_sym_template] = ACTIONS(2948),
    [anon_sym_GT2] = ACTIONS(2946),
    [anon_sym_operator] = ACTIONS(2948),
    [anon_sym_precise] = ACTIONS(2948),
    [anon_sym_shared] = ACTIONS(2948),
    [anon_sym_groupshared] = ACTIONS(2948),
    [anon_sym_uniform] = ACTIONS(2948),
    [anon_sym_row_major] = ACTIONS(2948),
    [anon_sym_column_major] = ACTIONS(2948),
    [anon_sym_globallycoherent] = ACTIONS(2948),
    [anon_sym_centroid] = ACTIONS(2948),
    [anon_sym_noperspective] = ACTIONS(2948),
    [anon_sym_nointerpolation] = ACTIONS(2948),
    [anon_sym_sample] = ACTIONS(2948),
    [anon_sym_linear] = ACTIONS(2948),
    [anon_sym_snorm] = ACTIONS(2948),
    [anon_sym_unorm] = ACTIONS(2948),
    [anon_sym_point] = ACTIONS(2948),
    [anon_sym_line] = ACTIONS(2948),
    [anon_sym_triangleadj] = ACTIONS(2948),
    [anon_sym_lineadj] = ACTIONS(2948),
    [anon_sym_triangle] = ACTIONS(2948),
  },
  [2851] = {
    [sym_identifier] = ACTIONS(3030),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3028),
    [anon_sym_COMMA] = ACTIONS(3028),
    [anon_sym_RPAREN] = ACTIONS(3028),
    [anon_sym_LPAREN2] = ACTIONS(3028),
    [anon_sym_TILDE] = ACTIONS(3028),
    [anon_sym_STAR] = ACTIONS(3028),
    [anon_sym_AMP_AMP] = ACTIONS(3028),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym___extension__] = ACTIONS(3030),
    [anon_sym_in] = ACTIONS(3030),
    [anon_sym_out] = ACTIONS(3030),
    [anon_sym_inout] = ACTIONS(3030),
    [anon_sym_virtual] = ACTIONS(3030),
    [anon_sym_extern] = ACTIONS(3030),
    [anon_sym___attribute__] = ACTIONS(3030),
    [anon_sym___attribute] = ACTIONS(3030),
    [anon_sym_COLON_COLON] = ACTIONS(3028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3028),
    [anon_sym___declspec] = ACTIONS(3030),
    [anon_sym___based] = ACTIONS(3030),
    [anon_sym___cdecl] = ACTIONS(3030),
    [anon_sym___clrcall] = ACTIONS(3030),
    [anon_sym___stdcall] = ACTIONS(3030),
    [anon_sym___fastcall] = ACTIONS(3030),
    [anon_sym___thiscall] = ACTIONS(3030),
    [anon_sym___vectorcall] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_EQ] = ACTIONS(3028),
    [anon_sym_register] = ACTIONS(3030),
    [anon_sym_inline] = ACTIONS(3030),
    [anon_sym___inline] = ACTIONS(3030),
    [anon_sym___inline__] = ACTIONS(3030),
    [anon_sym___forceinline] = ACTIONS(3030),
    [anon_sym_thread_local] = ACTIONS(3030),
    [anon_sym___thread] = ACTIONS(3030),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_constexpr] = ACTIONS(3030),
    [anon_sym_volatile] = ACTIONS(3030),
    [anon_sym_restrict] = ACTIONS(3030),
    [anon_sym___restrict__] = ACTIONS(3030),
    [anon_sym__Atomic] = ACTIONS(3030),
    [anon_sym__Noreturn] = ACTIONS(3030),
    [anon_sym_noreturn] = ACTIONS(3030),
    [anon_sym__Nonnull] = ACTIONS(3030),
    [anon_sym_mutable] = ACTIONS(3030),
    [anon_sym_constinit] = ACTIONS(3030),
    [anon_sym_consteval] = ACTIONS(3030),
    [anon_sym_alignas] = ACTIONS(3030),
    [anon_sym__Alignas] = ACTIONS(3030),
    [anon_sym_DOT] = ACTIONS(3030),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3030),
    [anon_sym_let] = ACTIONS(3030),
    [anon_sym_This] = ACTIONS(3030),
    [anon_sym_decltype] = ACTIONS(3030),
    [anon_sym_template] = ACTIONS(3030),
    [anon_sym_GT2] = ACTIONS(3028),
    [anon_sym_operator] = ACTIONS(3030),
    [anon_sym_precise] = ACTIONS(3030),
    [anon_sym_shared] = ACTIONS(3030),
    [anon_sym_groupshared] = ACTIONS(3030),
    [anon_sym_uniform] = ACTIONS(3030),
    [anon_sym_row_major] = ACTIONS(3030),
    [anon_sym_column_major] = ACTIONS(3030),
    [anon_sym_globallycoherent] = ACTIONS(3030),
    [anon_sym_centroid] = ACTIONS(3030),
    [anon_sym_noperspective] = ACTIONS(3030),
    [anon_sym_nointerpolation] = ACTIONS(3030),
    [anon_sym_sample] = ACTIONS(3030),
    [anon_sym_linear] = ACTIONS(3030),
    [anon_sym_snorm] = ACTIONS(3030),
    [anon_sym_unorm] = ACTIONS(3030),
    [anon_sym_point] = ACTIONS(3030),
    [anon_sym_line] = ACTIONS(3030),
    [anon_sym_triangleadj] = ACTIONS(3030),
    [anon_sym_lineadj] = ACTIONS(3030),
    [anon_sym_triangle] = ACTIONS(3030),
  },
  [2852] = {
    [sym_identifier] = ACTIONS(4242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4240),
    [anon_sym_COMMA] = ACTIONS(4240),
    [anon_sym_RPAREN] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4242),
    [anon_sym_PLUS] = ACTIONS(4242),
    [anon_sym_STAR] = ACTIONS(4242),
    [anon_sym_SLASH] = ACTIONS(4242),
    [anon_sym_PERCENT] = ACTIONS(4242),
    [anon_sym_PIPE_PIPE] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_PIPE] = ACTIONS(4242),
    [anon_sym_CARET] = ACTIONS(4242),
    [anon_sym_AMP] = ACTIONS(4242),
    [anon_sym_EQ_EQ] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(4240),
    [anon_sym_GT] = ACTIONS(4242),
    [anon_sym_GT_EQ] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(4242),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_LT_LT] = ACTIONS(4242),
    [anon_sym_GT_GT] = ACTIONS(4242),
    [anon_sym___extension__] = ACTIONS(4242),
    [anon_sym___attribute__] = ACTIONS(4242),
    [anon_sym___attribute] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_signed] = ACTIONS(4242),
    [anon_sym_unsigned] = ACTIONS(4242),
    [anon_sym_long] = ACTIONS(4242),
    [anon_sym_short] = ACTIONS(4242),
    [anon_sym_LBRACK] = ACTIONS(4240),
    [anon_sym_EQ] = ACTIONS(4242),
    [anon_sym_const] = ACTIONS(4242),
    [anon_sym_constexpr] = ACTIONS(4242),
    [anon_sym_volatile] = ACTIONS(4242),
    [anon_sym_restrict] = ACTIONS(4242),
    [anon_sym___restrict__] = ACTIONS(4242),
    [anon_sym__Atomic] = ACTIONS(4242),
    [anon_sym__Noreturn] = ACTIONS(4242),
    [anon_sym_noreturn] = ACTIONS(4242),
    [anon_sym__Nonnull] = ACTIONS(4242),
    [anon_sym_mutable] = ACTIONS(4242),
    [anon_sym_constinit] = ACTIONS(4242),
    [anon_sym_consteval] = ACTIONS(4242),
    [anon_sym_alignas] = ACTIONS(4242),
    [anon_sym__Alignas] = ACTIONS(4242),
    [sym_primitive_type] = ACTIONS(4242),
    [anon_sym_QMARK] = ACTIONS(4240),
    [anon_sym_STAR_EQ] = ACTIONS(4240),
    [anon_sym_SLASH_EQ] = ACTIONS(4240),
    [anon_sym_PERCENT_EQ] = ACTIONS(4240),
    [anon_sym_PLUS_EQ] = ACTIONS(4240),
    [anon_sym_DASH_EQ] = ACTIONS(4240),
    [anon_sym_LT_LT_EQ] = ACTIONS(4240),
    [anon_sym_GT_GT_EQ] = ACTIONS(4240),
    [anon_sym_AMP_EQ] = ACTIONS(4240),
    [anon_sym_CARET_EQ] = ACTIONS(4240),
    [anon_sym_PIPE_EQ] = ACTIONS(4240),
    [anon_sym_and_eq] = ACTIONS(4242),
    [anon_sym_or_eq] = ACTIONS(4242),
    [anon_sym_xor_eq] = ACTIONS(4242),
    [anon_sym_LT_EQ_GT] = ACTIONS(4240),
    [anon_sym_or] = ACTIONS(4242),
    [anon_sym_and] = ACTIONS(4242),
    [anon_sym_bitor] = ACTIONS(4242),
    [anon_sym_xor] = ACTIONS(4242),
    [anon_sym_bitand] = ACTIONS(4242),
    [anon_sym_not_eq] = ACTIONS(4242),
    [anon_sym_is] = ACTIONS(4242),
    [anon_sym_as] = ACTIONS(4242),
    [anon_sym_DASH_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_PLUS] = ACTIONS(4240),
    [anon_sym_DOT] = ACTIONS(4242),
    [anon_sym_DOT_STAR] = ACTIONS(4240),
    [anon_sym_DASH_GT] = ACTIONS(4242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4242),
    [anon_sym_let] = ACTIONS(4242),
    [anon_sym_This] = ACTIONS(4242),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4240),
  },
  [2853] = {
    [sym_identifier] = ACTIONS(3034),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3032),
    [anon_sym_RPAREN] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_COLON] = ACTIONS(3034),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_in] = ACTIONS(3034),
    [anon_sym_out] = ACTIONS(3034),
    [anon_sym_inout] = ACTIONS(3034),
    [anon_sym_virtual] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym___attribute] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3032),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym___cdecl] = ACTIONS(3034),
    [anon_sym___clrcall] = ACTIONS(3034),
    [anon_sym___stdcall] = ACTIONS(3034),
    [anon_sym___fastcall] = ACTIONS(3034),
    [anon_sym___thiscall] = ACTIONS(3034),
    [anon_sym___vectorcall] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_EQ] = ACTIONS(3032),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym__Nonnull] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [anon_sym_DOT] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_GT2] = ACTIONS(3032),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_precise] = ACTIONS(3034),
    [anon_sym_shared] = ACTIONS(3034),
    [anon_sym_groupshared] = ACTIONS(3034),
    [anon_sym_uniform] = ACTIONS(3034),
    [anon_sym_row_major] = ACTIONS(3034),
    [anon_sym_column_major] = ACTIONS(3034),
    [anon_sym_globallycoherent] = ACTIONS(3034),
    [anon_sym_centroid] = ACTIONS(3034),
    [anon_sym_noperspective] = ACTIONS(3034),
    [anon_sym_nointerpolation] = ACTIONS(3034),
    [anon_sym_sample] = ACTIONS(3034),
    [anon_sym_linear] = ACTIONS(3034),
    [anon_sym_snorm] = ACTIONS(3034),
    [anon_sym_unorm] = ACTIONS(3034),
    [anon_sym_point] = ACTIONS(3034),
    [anon_sym_line] = ACTIONS(3034),
    [anon_sym_triangleadj] = ACTIONS(3034),
    [anon_sym_lineadj] = ACTIONS(3034),
    [anon_sym_triangle] = ACTIONS(3034),
  },
  [2854] = {
    [sym_identifier] = ACTIONS(3038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3036),
    [anon_sym_COMMA] = ACTIONS(3036),
    [anon_sym_RPAREN] = ACTIONS(3036),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym_COLON] = ACTIONS(3038),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3038),
    [anon_sym_in] = ACTIONS(3038),
    [anon_sym_out] = ACTIONS(3038),
    [anon_sym_inout] = ACTIONS(3038),
    [anon_sym_virtual] = ACTIONS(3038),
    [anon_sym_extern] = ACTIONS(3038),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym___attribute] = ACTIONS(3038),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3038),
    [anon_sym___based] = ACTIONS(3038),
    [anon_sym___cdecl] = ACTIONS(3038),
    [anon_sym___clrcall] = ACTIONS(3038),
    [anon_sym___stdcall] = ACTIONS(3038),
    [anon_sym___fastcall] = ACTIONS(3038),
    [anon_sym___thiscall] = ACTIONS(3038),
    [anon_sym___vectorcall] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_EQ] = ACTIONS(3036),
    [anon_sym_register] = ACTIONS(3038),
    [anon_sym_inline] = ACTIONS(3038),
    [anon_sym___inline] = ACTIONS(3038),
    [anon_sym___inline__] = ACTIONS(3038),
    [anon_sym___forceinline] = ACTIONS(3038),
    [anon_sym_thread_local] = ACTIONS(3038),
    [anon_sym___thread] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_constexpr] = ACTIONS(3038),
    [anon_sym_volatile] = ACTIONS(3038),
    [anon_sym_restrict] = ACTIONS(3038),
    [anon_sym___restrict__] = ACTIONS(3038),
    [anon_sym__Atomic] = ACTIONS(3038),
    [anon_sym__Noreturn] = ACTIONS(3038),
    [anon_sym_noreturn] = ACTIONS(3038),
    [anon_sym__Nonnull] = ACTIONS(3038),
    [anon_sym_mutable] = ACTIONS(3038),
    [anon_sym_constinit] = ACTIONS(3038),
    [anon_sym_consteval] = ACTIONS(3038),
    [anon_sym_alignas] = ACTIONS(3038),
    [anon_sym__Alignas] = ACTIONS(3038),
    [anon_sym_DOT] = ACTIONS(3038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3038),
    [anon_sym_let] = ACTIONS(3038),
    [anon_sym_This] = ACTIONS(3038),
    [anon_sym_decltype] = ACTIONS(3038),
    [anon_sym_template] = ACTIONS(3038),
    [anon_sym_GT2] = ACTIONS(3036),
    [anon_sym_operator] = ACTIONS(3038),
    [anon_sym_precise] = ACTIONS(3038),
    [anon_sym_shared] = ACTIONS(3038),
    [anon_sym_groupshared] = ACTIONS(3038),
    [anon_sym_uniform] = ACTIONS(3038),
    [anon_sym_row_major] = ACTIONS(3038),
    [anon_sym_column_major] = ACTIONS(3038),
    [anon_sym_globallycoherent] = ACTIONS(3038),
    [anon_sym_centroid] = ACTIONS(3038),
    [anon_sym_noperspective] = ACTIONS(3038),
    [anon_sym_nointerpolation] = ACTIONS(3038),
    [anon_sym_sample] = ACTIONS(3038),
    [anon_sym_linear] = ACTIONS(3038),
    [anon_sym_snorm] = ACTIONS(3038),
    [anon_sym_unorm] = ACTIONS(3038),
    [anon_sym_point] = ACTIONS(3038),
    [anon_sym_line] = ACTIONS(3038),
    [anon_sym_triangleadj] = ACTIONS(3038),
    [anon_sym_lineadj] = ACTIONS(3038),
    [anon_sym_triangle] = ACTIONS(3038),
  },
  [2855] = {
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3352),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3362),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3362),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3362),
    [anon_sym_explicit] = ACTIONS(3362),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3362),
    [anon_sym_operator] = ACTIONS(3362),
    [anon_sym_friend] = ACTIONS(7087),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [2856] = {
    [sym_identifier] = ACTIONS(4716),
    [anon_sym_LPAREN2] = ACTIONS(4718),
    [anon_sym_TILDE] = ACTIONS(4718),
    [anon_sym_STAR] = ACTIONS(4718),
    [anon_sym_AMP_AMP] = ACTIONS(4718),
    [anon_sym_AMP] = ACTIONS(4716),
    [anon_sym___extension__] = ACTIONS(4716),
    [anon_sym_in] = ACTIONS(4716),
    [anon_sym_out] = ACTIONS(4716),
    [anon_sym_inout] = ACTIONS(4716),
    [anon_sym_virtual] = ACTIONS(4716),
    [anon_sym_extern] = ACTIONS(4716),
    [anon_sym___attribute__] = ACTIONS(4716),
    [anon_sym___attribute] = ACTIONS(4716),
    [anon_sym_using] = ACTIONS(4716),
    [anon_sym_COLON_COLON] = ACTIONS(4718),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4718),
    [anon_sym___declspec] = ACTIONS(4716),
    [anon_sym___based] = ACTIONS(4716),
    [anon_sym_signed] = ACTIONS(4716),
    [anon_sym_unsigned] = ACTIONS(4716),
    [anon_sym_long] = ACTIONS(4716),
    [anon_sym_short] = ACTIONS(4716),
    [anon_sym_LBRACK] = ACTIONS(4716),
    [anon_sym_static] = ACTIONS(4716),
    [anon_sym_register] = ACTIONS(4716),
    [anon_sym_inline] = ACTIONS(4716),
    [anon_sym___inline] = ACTIONS(4716),
    [anon_sym___inline__] = ACTIONS(4716),
    [anon_sym___forceinline] = ACTIONS(4716),
    [anon_sym_thread_local] = ACTIONS(4716),
    [anon_sym___thread] = ACTIONS(4716),
    [anon_sym_const] = ACTIONS(4716),
    [anon_sym_constexpr] = ACTIONS(4716),
    [anon_sym_volatile] = ACTIONS(4716),
    [anon_sym_restrict] = ACTIONS(4716),
    [anon_sym___restrict__] = ACTIONS(4716),
    [anon_sym__Atomic] = ACTIONS(4716),
    [anon_sym__Noreturn] = ACTIONS(4716),
    [anon_sym_noreturn] = ACTIONS(4716),
    [anon_sym__Nonnull] = ACTIONS(4716),
    [anon_sym_mutable] = ACTIONS(4716),
    [anon_sym_constinit] = ACTIONS(4716),
    [anon_sym_consteval] = ACTIONS(4716),
    [anon_sym_alignas] = ACTIONS(4716),
    [anon_sym__Alignas] = ACTIONS(4716),
    [sym_primitive_type] = ACTIONS(4716),
    [anon_sym_enum] = ACTIONS(4716),
    [anon_sym_class] = ACTIONS(4716),
    [anon_sym_struct] = ACTIONS(4716),
    [anon_sym_union] = ACTIONS(4716),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4716),
    [anon_sym_let] = ACTIONS(4716),
    [anon_sym_This] = ACTIONS(4716),
    [anon_sym_decltype] = ACTIONS(4716),
    [anon_sym_explicit] = ACTIONS(4716),
    [anon_sym_typename] = ACTIONS(4716),
    [anon_sym_template] = ACTIONS(4716),
    [anon_sym_operator] = ACTIONS(4716),
    [anon_sym_precise] = ACTIONS(4716),
    [anon_sym_shared] = ACTIONS(4716),
    [anon_sym_groupshared] = ACTIONS(4716),
    [anon_sym_uniform] = ACTIONS(4716),
    [anon_sym_row_major] = ACTIONS(4716),
    [anon_sym_column_major] = ACTIONS(4716),
    [anon_sym_globallycoherent] = ACTIONS(4716),
    [anon_sym_centroid] = ACTIONS(4716),
    [anon_sym_noperspective] = ACTIONS(4716),
    [anon_sym_nointerpolation] = ACTIONS(4716),
    [anon_sym_sample] = ACTIONS(4716),
    [anon_sym_linear] = ACTIONS(4716),
    [anon_sym_snorm] = ACTIONS(4716),
    [anon_sym_unorm] = ACTIONS(4716),
    [anon_sym_point] = ACTIONS(4716),
    [anon_sym_line] = ACTIONS(4716),
    [anon_sym_triangleadj] = ACTIONS(4716),
    [anon_sym_lineadj] = ACTIONS(4716),
    [anon_sym_triangle] = ACTIONS(4716),
    [anon_sym_interface] = ACTIONS(4716),
    [anon_sym_extension] = ACTIONS(4716),
  },
  [2857] = {
    [sym_identifier] = ACTIONS(6895),
    [anon_sym_LPAREN2] = ACTIONS(6897),
    [anon_sym_TILDE] = ACTIONS(6897),
    [anon_sym_STAR] = ACTIONS(6897),
    [anon_sym_AMP_AMP] = ACTIONS(6897),
    [anon_sym_AMP] = ACTIONS(6895),
    [anon_sym___extension__] = ACTIONS(6895),
    [anon_sym_in] = ACTIONS(6895),
    [anon_sym_out] = ACTIONS(6895),
    [anon_sym_inout] = ACTIONS(6895),
    [anon_sym_virtual] = ACTIONS(6895),
    [anon_sym_extern] = ACTIONS(6895),
    [anon_sym___attribute__] = ACTIONS(6895),
    [anon_sym___attribute] = ACTIONS(6895),
    [anon_sym_COLON_COLON] = ACTIONS(6897),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6897),
    [anon_sym___declspec] = ACTIONS(6895),
    [anon_sym___based] = ACTIONS(6895),
    [anon_sym_signed] = ACTIONS(6895),
    [anon_sym_unsigned] = ACTIONS(6895),
    [anon_sym_long] = ACTIONS(6895),
    [anon_sym_short] = ACTIONS(6895),
    [anon_sym_LBRACK] = ACTIONS(6895),
    [anon_sym_static] = ACTIONS(6895),
    [anon_sym_register] = ACTIONS(6895),
    [anon_sym_inline] = ACTIONS(6895),
    [anon_sym___inline] = ACTIONS(6895),
    [anon_sym___inline__] = ACTIONS(6895),
    [anon_sym___forceinline] = ACTIONS(6895),
    [anon_sym_thread_local] = ACTIONS(6895),
    [anon_sym___thread] = ACTIONS(6895),
    [anon_sym_const] = ACTIONS(6895),
    [anon_sym_constexpr] = ACTIONS(6895),
    [anon_sym_volatile] = ACTIONS(6895),
    [anon_sym_restrict] = ACTIONS(6895),
    [anon_sym___restrict__] = ACTIONS(6895),
    [anon_sym__Atomic] = ACTIONS(6895),
    [anon_sym__Noreturn] = ACTIONS(6895),
    [anon_sym_noreturn] = ACTIONS(6895),
    [anon_sym__Nonnull] = ACTIONS(6895),
    [anon_sym_mutable] = ACTIONS(6895),
    [anon_sym_constinit] = ACTIONS(6895),
    [anon_sym_consteval] = ACTIONS(6895),
    [anon_sym_alignas] = ACTIONS(6895),
    [anon_sym__Alignas] = ACTIONS(6895),
    [sym_primitive_type] = ACTIONS(6895),
    [anon_sym_enum] = ACTIONS(6895),
    [anon_sym_class] = ACTIONS(6895),
    [anon_sym_struct] = ACTIONS(6895),
    [anon_sym_union] = ACTIONS(6895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6895),
    [anon_sym_let] = ACTIONS(6895),
    [anon_sym_This] = ACTIONS(6895),
    [anon_sym_decltype] = ACTIONS(6895),
    [anon_sym_explicit] = ACTIONS(6895),
    [anon_sym_typename] = ACTIONS(6895),
    [anon_sym_template] = ACTIONS(6895),
    [anon_sym_operator] = ACTIONS(6895),
    [anon_sym_namespace] = ACTIONS(7089),
    [anon_sym_precise] = ACTIONS(6895),
    [anon_sym_shared] = ACTIONS(6895),
    [anon_sym_groupshared] = ACTIONS(6895),
    [anon_sym_uniform] = ACTIONS(6895),
    [anon_sym_row_major] = ACTIONS(6895),
    [anon_sym_column_major] = ACTIONS(6895),
    [anon_sym_globallycoherent] = ACTIONS(6895),
    [anon_sym_centroid] = ACTIONS(6895),
    [anon_sym_noperspective] = ACTIONS(6895),
    [anon_sym_nointerpolation] = ACTIONS(6895),
    [anon_sym_sample] = ACTIONS(6895),
    [anon_sym_linear] = ACTIONS(6895),
    [anon_sym_snorm] = ACTIONS(6895),
    [anon_sym_unorm] = ACTIONS(6895),
    [anon_sym_point] = ACTIONS(6895),
    [anon_sym_line] = ACTIONS(6895),
    [anon_sym_triangleadj] = ACTIONS(6895),
    [anon_sym_lineadj] = ACTIONS(6895),
    [anon_sym_triangle] = ACTIONS(6895),
    [anon_sym_interface] = ACTIONS(6895),
    [anon_sym_extension] = ACTIONS(6895),
  },
  [2858] = {
    [sym_identifier] = ACTIONS(2952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2950),
    [anon_sym_COMMA] = ACTIONS(2950),
    [anon_sym_RPAREN] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2950),
    [anon_sym_STAR] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_AMP] = ACTIONS(2952),
    [anon_sym_COLON] = ACTIONS(2952),
    [anon_sym_SEMI] = ACTIONS(2950),
    [anon_sym___extension__] = ACTIONS(2952),
    [anon_sym_in] = ACTIONS(2952),
    [anon_sym_out] = ACTIONS(2952),
    [anon_sym_inout] = ACTIONS(2952),
    [anon_sym_virtual] = ACTIONS(2952),
    [anon_sym_extern] = ACTIONS(2952),
    [anon_sym___attribute__] = ACTIONS(2952),
    [anon_sym___attribute] = ACTIONS(2952),
    [anon_sym_COLON_COLON] = ACTIONS(2950),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2950),
    [anon_sym___declspec] = ACTIONS(2952),
    [anon_sym___based] = ACTIONS(2952),
    [anon_sym___cdecl] = ACTIONS(2952),
    [anon_sym___clrcall] = ACTIONS(2952),
    [anon_sym___stdcall] = ACTIONS(2952),
    [anon_sym___fastcall] = ACTIONS(2952),
    [anon_sym___thiscall] = ACTIONS(2952),
    [anon_sym___vectorcall] = ACTIONS(2952),
    [anon_sym_LBRACK] = ACTIONS(2952),
    [anon_sym_static] = ACTIONS(2952),
    [anon_sym_EQ] = ACTIONS(2950),
    [anon_sym_register] = ACTIONS(2952),
    [anon_sym_inline] = ACTIONS(2952),
    [anon_sym___inline] = ACTIONS(2952),
    [anon_sym___inline__] = ACTIONS(2952),
    [anon_sym___forceinline] = ACTIONS(2952),
    [anon_sym_thread_local] = ACTIONS(2952),
    [anon_sym___thread] = ACTIONS(2952),
    [anon_sym_const] = ACTIONS(2952),
    [anon_sym_constexpr] = ACTIONS(2952),
    [anon_sym_volatile] = ACTIONS(2952),
    [anon_sym_restrict] = ACTIONS(2952),
    [anon_sym___restrict__] = ACTIONS(2952),
    [anon_sym__Atomic] = ACTIONS(2952),
    [anon_sym__Noreturn] = ACTIONS(2952),
    [anon_sym_noreturn] = ACTIONS(2952),
    [anon_sym__Nonnull] = ACTIONS(2952),
    [anon_sym_mutable] = ACTIONS(2952),
    [anon_sym_constinit] = ACTIONS(2952),
    [anon_sym_consteval] = ACTIONS(2952),
    [anon_sym_alignas] = ACTIONS(2952),
    [anon_sym__Alignas] = ACTIONS(2952),
    [anon_sym_DOT] = ACTIONS(2952),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2952),
    [anon_sym_let] = ACTIONS(2952),
    [anon_sym_This] = ACTIONS(2952),
    [anon_sym_decltype] = ACTIONS(2952),
    [anon_sym_template] = ACTIONS(2952),
    [anon_sym_GT2] = ACTIONS(2950),
    [anon_sym_operator] = ACTIONS(2952),
    [anon_sym_precise] = ACTIONS(2952),
    [anon_sym_shared] = ACTIONS(2952),
    [anon_sym_groupshared] = ACTIONS(2952),
    [anon_sym_uniform] = ACTIONS(2952),
    [anon_sym_row_major] = ACTIONS(2952),
    [anon_sym_column_major] = ACTIONS(2952),
    [anon_sym_globallycoherent] = ACTIONS(2952),
    [anon_sym_centroid] = ACTIONS(2952),
    [anon_sym_noperspective] = ACTIONS(2952),
    [anon_sym_nointerpolation] = ACTIONS(2952),
    [anon_sym_sample] = ACTIONS(2952),
    [anon_sym_linear] = ACTIONS(2952),
    [anon_sym_snorm] = ACTIONS(2952),
    [anon_sym_unorm] = ACTIONS(2952),
    [anon_sym_point] = ACTIONS(2952),
    [anon_sym_line] = ACTIONS(2952),
    [anon_sym_triangleadj] = ACTIONS(2952),
    [anon_sym_lineadj] = ACTIONS(2952),
    [anon_sym_triangle] = ACTIONS(2952),
  },
  [2859] = {
    [sym_identifier] = ACTIONS(2550),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2548),
    [anon_sym_COMMA] = ACTIONS(2548),
    [anon_sym_RPAREN] = ACTIONS(2548),
    [anon_sym_LPAREN2] = ACTIONS(2548),
    [anon_sym_TILDE] = ACTIONS(2548),
    [anon_sym_STAR] = ACTIONS(2548),
    [anon_sym_AMP_AMP] = ACTIONS(2548),
    [anon_sym_AMP] = ACTIONS(2550),
    [anon_sym_COLON] = ACTIONS(2550),
    [anon_sym_SEMI] = ACTIONS(2548),
    [anon_sym___extension__] = ACTIONS(2550),
    [anon_sym_in] = ACTIONS(2550),
    [anon_sym_out] = ACTIONS(2550),
    [anon_sym_inout] = ACTIONS(2550),
    [anon_sym_virtual] = ACTIONS(2550),
    [anon_sym_extern] = ACTIONS(2550),
    [anon_sym___attribute__] = ACTIONS(2550),
    [anon_sym___attribute] = ACTIONS(2550),
    [anon_sym_COLON_COLON] = ACTIONS(2548),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2548),
    [anon_sym___declspec] = ACTIONS(2550),
    [anon_sym___based] = ACTIONS(2550),
    [anon_sym___cdecl] = ACTIONS(2550),
    [anon_sym___clrcall] = ACTIONS(2550),
    [anon_sym___stdcall] = ACTIONS(2550),
    [anon_sym___fastcall] = ACTIONS(2550),
    [anon_sym___thiscall] = ACTIONS(2550),
    [anon_sym___vectorcall] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_static] = ACTIONS(2550),
    [anon_sym_EQ] = ACTIONS(2548),
    [anon_sym_register] = ACTIONS(2550),
    [anon_sym_inline] = ACTIONS(2550),
    [anon_sym___inline] = ACTIONS(2550),
    [anon_sym___inline__] = ACTIONS(2550),
    [anon_sym___forceinline] = ACTIONS(2550),
    [anon_sym_thread_local] = ACTIONS(2550),
    [anon_sym___thread] = ACTIONS(2550),
    [anon_sym_const] = ACTIONS(2550),
    [anon_sym_constexpr] = ACTIONS(2550),
    [anon_sym_volatile] = ACTIONS(2550),
    [anon_sym_restrict] = ACTIONS(2550),
    [anon_sym___restrict__] = ACTIONS(2550),
    [anon_sym__Atomic] = ACTIONS(2550),
    [anon_sym__Noreturn] = ACTIONS(2550),
    [anon_sym_noreturn] = ACTIONS(2550),
    [anon_sym__Nonnull] = ACTIONS(2550),
    [anon_sym_mutable] = ACTIONS(2550),
    [anon_sym_constinit] = ACTIONS(2550),
    [anon_sym_consteval] = ACTIONS(2550),
    [anon_sym_alignas] = ACTIONS(2550),
    [anon_sym__Alignas] = ACTIONS(2550),
    [anon_sym_DOT] = ACTIONS(2550),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(2550),
    [anon_sym_This] = ACTIONS(2550),
    [anon_sym_decltype] = ACTIONS(2550),
    [anon_sym_template] = ACTIONS(2550),
    [anon_sym_GT2] = ACTIONS(2548),
    [anon_sym_operator] = ACTIONS(2550),
    [anon_sym_precise] = ACTIONS(2550),
    [anon_sym_shared] = ACTIONS(2550),
    [anon_sym_groupshared] = ACTIONS(2550),
    [anon_sym_uniform] = ACTIONS(2550),
    [anon_sym_row_major] = ACTIONS(2550),
    [anon_sym_column_major] = ACTIONS(2550),
    [anon_sym_globallycoherent] = ACTIONS(2550),
    [anon_sym_centroid] = ACTIONS(2550),
    [anon_sym_noperspective] = ACTIONS(2550),
    [anon_sym_nointerpolation] = ACTIONS(2550),
    [anon_sym_sample] = ACTIONS(2550),
    [anon_sym_linear] = ACTIONS(2550),
    [anon_sym_snorm] = ACTIONS(2550),
    [anon_sym_unorm] = ACTIONS(2550),
    [anon_sym_point] = ACTIONS(2550),
    [anon_sym_line] = ACTIONS(2550),
    [anon_sym_triangleadj] = ACTIONS(2550),
    [anon_sym_lineadj] = ACTIONS(2550),
    [anon_sym_triangle] = ACTIONS(2550),
  },
  [2860] = {
    [sym_identifier] = ACTIONS(6895),
    [anon_sym_LPAREN2] = ACTIONS(6897),
    [anon_sym_TILDE] = ACTIONS(6897),
    [anon_sym_STAR] = ACTIONS(6897),
    [anon_sym_AMP_AMP] = ACTIONS(6897),
    [anon_sym_AMP] = ACTIONS(6895),
    [anon_sym___extension__] = ACTIONS(6895),
    [anon_sym_in] = ACTIONS(6895),
    [anon_sym_out] = ACTIONS(6895),
    [anon_sym_inout] = ACTIONS(6895),
    [anon_sym_virtual] = ACTIONS(6895),
    [anon_sym_extern] = ACTIONS(6895),
    [anon_sym___attribute__] = ACTIONS(6895),
    [anon_sym___attribute] = ACTIONS(6895),
    [anon_sym_COLON_COLON] = ACTIONS(6897),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6897),
    [anon_sym___declspec] = ACTIONS(6895),
    [anon_sym___based] = ACTIONS(6895),
    [anon_sym_signed] = ACTIONS(6895),
    [anon_sym_unsigned] = ACTIONS(6895),
    [anon_sym_long] = ACTIONS(6895),
    [anon_sym_short] = ACTIONS(6895),
    [anon_sym_LBRACK] = ACTIONS(6895),
    [anon_sym_static] = ACTIONS(6895),
    [anon_sym_register] = ACTIONS(6895),
    [anon_sym_inline] = ACTIONS(6895),
    [anon_sym___inline] = ACTIONS(6895),
    [anon_sym___inline__] = ACTIONS(6895),
    [anon_sym___forceinline] = ACTIONS(6895),
    [anon_sym_thread_local] = ACTIONS(6895),
    [anon_sym___thread] = ACTIONS(6895),
    [anon_sym_const] = ACTIONS(6895),
    [anon_sym_constexpr] = ACTIONS(6895),
    [anon_sym_volatile] = ACTIONS(6895),
    [anon_sym_restrict] = ACTIONS(6895),
    [anon_sym___restrict__] = ACTIONS(6895),
    [anon_sym__Atomic] = ACTIONS(6895),
    [anon_sym__Noreturn] = ACTIONS(6895),
    [anon_sym_noreturn] = ACTIONS(6895),
    [anon_sym__Nonnull] = ACTIONS(6895),
    [anon_sym_mutable] = ACTIONS(6895),
    [anon_sym_constinit] = ACTIONS(6895),
    [anon_sym_consteval] = ACTIONS(6895),
    [anon_sym_alignas] = ACTIONS(6895),
    [anon_sym__Alignas] = ACTIONS(6895),
    [sym_primitive_type] = ACTIONS(6895),
    [anon_sym_enum] = ACTIONS(6895),
    [anon_sym_class] = ACTIONS(6895),
    [anon_sym_struct] = ACTIONS(6895),
    [anon_sym_union] = ACTIONS(6895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6895),
    [anon_sym_let] = ACTIONS(6895),
    [anon_sym_This] = ACTIONS(6895),
    [anon_sym_decltype] = ACTIONS(6895),
    [anon_sym_explicit] = ACTIONS(6895),
    [anon_sym_typename] = ACTIONS(6895),
    [anon_sym_template] = ACTIONS(6895),
    [anon_sym_operator] = ACTIONS(6895),
    [anon_sym_namespace] = ACTIONS(7091),
    [anon_sym_precise] = ACTIONS(6895),
    [anon_sym_shared] = ACTIONS(6895),
    [anon_sym_groupshared] = ACTIONS(6895),
    [anon_sym_uniform] = ACTIONS(6895),
    [anon_sym_row_major] = ACTIONS(6895),
    [anon_sym_column_major] = ACTIONS(6895),
    [anon_sym_globallycoherent] = ACTIONS(6895),
    [anon_sym_centroid] = ACTIONS(6895),
    [anon_sym_noperspective] = ACTIONS(6895),
    [anon_sym_nointerpolation] = ACTIONS(6895),
    [anon_sym_sample] = ACTIONS(6895),
    [anon_sym_linear] = ACTIONS(6895),
    [anon_sym_snorm] = ACTIONS(6895),
    [anon_sym_unorm] = ACTIONS(6895),
    [anon_sym_point] = ACTIONS(6895),
    [anon_sym_line] = ACTIONS(6895),
    [anon_sym_triangleadj] = ACTIONS(6895),
    [anon_sym_lineadj] = ACTIONS(6895),
    [anon_sym_triangle] = ACTIONS(6895),
    [anon_sym_interface] = ACTIONS(6895),
    [anon_sym_extension] = ACTIONS(6895),
  },
  [2861] = {
    [sym_template_argument_list] = STATE(2722),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_LPAREN2] = ACTIONS(2408),
    [anon_sym_TILDE] = ACTIONS(2408),
    [anon_sym_STAR] = ACTIONS(2408),
    [anon_sym_AMP_AMP] = ACTIONS(2408),
    [anon_sym_AMP] = ACTIONS(2410),
    [anon_sym_LT] = ACTIONS(7064),
    [anon_sym_COLON] = ACTIONS(2410),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym___extension__] = ACTIONS(2410),
    [anon_sym_in] = ACTIONS(2410),
    [anon_sym_out] = ACTIONS(2410),
    [anon_sym_inout] = ACTIONS(2410),
    [anon_sym_virtual] = ACTIONS(2410),
    [anon_sym_extern] = ACTIONS(2410),
    [anon_sym___attribute__] = ACTIONS(2410),
    [anon_sym___attribute] = ACTIONS(2410),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2408),
    [anon_sym___declspec] = ACTIONS(2410),
    [anon_sym___based] = ACTIONS(2410),
    [anon_sym___cdecl] = ACTIONS(2410),
    [anon_sym___clrcall] = ACTIONS(2410),
    [anon_sym___stdcall] = ACTIONS(2410),
    [anon_sym___fastcall] = ACTIONS(2410),
    [anon_sym___thiscall] = ACTIONS(2410),
    [anon_sym___vectorcall] = ACTIONS(2410),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_static] = ACTIONS(2410),
    [anon_sym_register] = ACTIONS(2410),
    [anon_sym_inline] = ACTIONS(2410),
    [anon_sym___inline] = ACTIONS(2410),
    [anon_sym___inline__] = ACTIONS(2410),
    [anon_sym___forceinline] = ACTIONS(2410),
    [anon_sym_thread_local] = ACTIONS(2410),
    [anon_sym___thread] = ACTIONS(2410),
    [anon_sym_const] = ACTIONS(2410),
    [anon_sym_constexpr] = ACTIONS(2410),
    [anon_sym_volatile] = ACTIONS(2410),
    [anon_sym_restrict] = ACTIONS(2410),
    [anon_sym___restrict__] = ACTIONS(2410),
    [anon_sym__Atomic] = ACTIONS(2410),
    [anon_sym__Noreturn] = ACTIONS(2410),
    [anon_sym_noreturn] = ACTIONS(2410),
    [anon_sym__Nonnull] = ACTIONS(2410),
    [anon_sym_mutable] = ACTIONS(2410),
    [anon_sym_constinit] = ACTIONS(2410),
    [anon_sym_consteval] = ACTIONS(2410),
    [anon_sym_alignas] = ACTIONS(2410),
    [anon_sym__Alignas] = ACTIONS(2410),
    [anon_sym_DOT] = ACTIONS(2408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2410),
    [anon_sym_let] = ACTIONS(2410),
    [anon_sym_This] = ACTIONS(2410),
    [anon_sym_decltype] = ACTIONS(2410),
    [anon_sym_final] = ACTIONS(2410),
    [anon_sym_override] = ACTIONS(2410),
    [anon_sym_template] = ACTIONS(2410),
    [anon_sym_operator] = ACTIONS(2410),
    [anon_sym_precise] = ACTIONS(2410),
    [anon_sym_shared] = ACTIONS(2410),
    [anon_sym_groupshared] = ACTIONS(2410),
    [anon_sym_uniform] = ACTIONS(2410),
    [anon_sym_row_major] = ACTIONS(2410),
    [anon_sym_column_major] = ACTIONS(2410),
    [anon_sym_globallycoherent] = ACTIONS(2410),
    [anon_sym_centroid] = ACTIONS(2410),
    [anon_sym_noperspective] = ACTIONS(2410),
    [anon_sym_nointerpolation] = ACTIONS(2410),
    [anon_sym_sample] = ACTIONS(2410),
    [anon_sym_linear] = ACTIONS(2410),
    [anon_sym_snorm] = ACTIONS(2410),
    [anon_sym_unorm] = ACTIONS(2410),
    [anon_sym_point] = ACTIONS(2410),
    [anon_sym_line] = ACTIONS(2410),
    [anon_sym_triangleadj] = ACTIONS(2410),
    [anon_sym_lineadj] = ACTIONS(2410),
    [anon_sym_triangle] = ACTIONS(2410),
  },
  [2862] = {
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3352),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3362),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3362),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3362),
    [anon_sym_explicit] = ACTIONS(3362),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3362),
    [anon_sym_operator] = ACTIONS(3362),
    [anon_sym_friend] = ACTIONS(7093),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [2863] = {
    [sym_identifier] = ACTIONS(3042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3040),
    [anon_sym_COMMA] = ACTIONS(3040),
    [anon_sym_RPAREN] = ACTIONS(3040),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_COLON] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym_in] = ACTIONS(3042),
    [anon_sym_out] = ACTIONS(3042),
    [anon_sym_inout] = ACTIONS(3042),
    [anon_sym_virtual] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym___cdecl] = ACTIONS(3042),
    [anon_sym___clrcall] = ACTIONS(3042),
    [anon_sym___stdcall] = ACTIONS(3042),
    [anon_sym___fastcall] = ACTIONS(3042),
    [anon_sym___thiscall] = ACTIONS(3042),
    [anon_sym___vectorcall] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_EQ] = ACTIONS(3040),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym___inline] = ACTIONS(3042),
    [anon_sym___inline__] = ACTIONS(3042),
    [anon_sym___forceinline] = ACTIONS(3042),
    [anon_sym_thread_local] = ACTIONS(3042),
    [anon_sym___thread] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [anon_sym_DOT] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3042),
    [anon_sym_let] = ACTIONS(3042),
    [anon_sym_This] = ACTIONS(3042),
    [anon_sym_decltype] = ACTIONS(3042),
    [anon_sym_template] = ACTIONS(3042),
    [anon_sym_GT2] = ACTIONS(3040),
    [anon_sym_operator] = ACTIONS(3042),
    [anon_sym_precise] = ACTIONS(3042),
    [anon_sym_shared] = ACTIONS(3042),
    [anon_sym_groupshared] = ACTIONS(3042),
    [anon_sym_uniform] = ACTIONS(3042),
    [anon_sym_row_major] = ACTIONS(3042),
    [anon_sym_column_major] = ACTIONS(3042),
    [anon_sym_globallycoherent] = ACTIONS(3042),
    [anon_sym_centroid] = ACTIONS(3042),
    [anon_sym_noperspective] = ACTIONS(3042),
    [anon_sym_nointerpolation] = ACTIONS(3042),
    [anon_sym_sample] = ACTIONS(3042),
    [anon_sym_linear] = ACTIONS(3042),
    [anon_sym_snorm] = ACTIONS(3042),
    [anon_sym_unorm] = ACTIONS(3042),
    [anon_sym_point] = ACTIONS(3042),
    [anon_sym_line] = ACTIONS(3042),
    [anon_sym_triangleadj] = ACTIONS(3042),
    [anon_sym_lineadj] = ACTIONS(3042),
    [anon_sym_triangle] = ACTIONS(3042),
  },
  [2864] = {
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym_typedef] = ACTIONS(7095),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3352),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3362),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3362),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3362),
    [anon_sym_explicit] = ACTIONS(3362),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3362),
    [anon_sym_operator] = ACTIONS(3362),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [2865] = {
    [sym_template_argument_list] = STATE(2722),
    [sym_identifier] = ACTIONS(2222),
    [anon_sym_LPAREN2] = ACTIONS(2229),
    [anon_sym_TILDE] = ACTIONS(2229),
    [anon_sym_STAR] = ACTIONS(2229),
    [anon_sym_AMP_AMP] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(7064),
    [anon_sym_COLON] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(2229),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_virtual] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym___attribute] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2229),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym___based] = ACTIONS(2222),
    [anon_sym___cdecl] = ACTIONS(2222),
    [anon_sym___clrcall] = ACTIONS(2222),
    [anon_sym___stdcall] = ACTIONS(2222),
    [anon_sym___fastcall] = ACTIONS(2222),
    [anon_sym___thiscall] = ACTIONS(2222),
    [anon_sym___vectorcall] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym__Nonnull] = ACTIONS(2222),
    [anon_sym_mutable] = ACTIONS(2222),
    [anon_sym_constinit] = ACTIONS(2222),
    [anon_sym_consteval] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [anon_sym_DOT] = ACTIONS(2229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2222),
    [anon_sym_let] = ACTIONS(2222),
    [anon_sym_This] = ACTIONS(2222),
    [anon_sym_decltype] = ACTIONS(2222),
    [anon_sym_final] = ACTIONS(2222),
    [anon_sym_override] = ACTIONS(2222),
    [anon_sym_template] = ACTIONS(2222),
    [anon_sym_operator] = ACTIONS(2222),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_groupshared] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_row_major] = ACTIONS(2222),
    [anon_sym_column_major] = ACTIONS(2222),
    [anon_sym_globallycoherent] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym_nointerpolation] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_linear] = ACTIONS(2222),
    [anon_sym_snorm] = ACTIONS(2222),
    [anon_sym_unorm] = ACTIONS(2222),
    [anon_sym_point] = ACTIONS(2222),
    [anon_sym_line] = ACTIONS(2222),
    [anon_sym_triangleadj] = ACTIONS(2222),
    [anon_sym_lineadj] = ACTIONS(2222),
    [anon_sym_triangle] = ACTIONS(2222),
  },
  [2866] = {
    [sym_identifier] = ACTIONS(2879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2877),
    [anon_sym_COMMA] = ACTIONS(2877),
    [anon_sym_RPAREN] = ACTIONS(2877),
    [anon_sym_LPAREN2] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2877),
    [anon_sym_STAR] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_AMP] = ACTIONS(2879),
    [anon_sym_COLON] = ACTIONS(2879),
    [anon_sym_SEMI] = ACTIONS(2877),
    [anon_sym___extension__] = ACTIONS(2879),
    [anon_sym_in] = ACTIONS(2879),
    [anon_sym_out] = ACTIONS(2879),
    [anon_sym_inout] = ACTIONS(2879),
    [anon_sym_virtual] = ACTIONS(2879),
    [anon_sym_extern] = ACTIONS(2879),
    [anon_sym___attribute__] = ACTIONS(2879),
    [anon_sym___attribute] = ACTIONS(2879),
    [anon_sym_COLON_COLON] = ACTIONS(2877),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2877),
    [anon_sym___declspec] = ACTIONS(2879),
    [anon_sym___based] = ACTIONS(2879),
    [anon_sym___cdecl] = ACTIONS(2879),
    [anon_sym___clrcall] = ACTIONS(2879),
    [anon_sym___stdcall] = ACTIONS(2879),
    [anon_sym___fastcall] = ACTIONS(2879),
    [anon_sym___thiscall] = ACTIONS(2879),
    [anon_sym___vectorcall] = ACTIONS(2879),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_static] = ACTIONS(2879),
    [anon_sym_EQ] = ACTIONS(2877),
    [anon_sym_register] = ACTIONS(2879),
    [anon_sym_inline] = ACTIONS(2879),
    [anon_sym___inline] = ACTIONS(2879),
    [anon_sym___inline__] = ACTIONS(2879),
    [anon_sym___forceinline] = ACTIONS(2879),
    [anon_sym_thread_local] = ACTIONS(2879),
    [anon_sym___thread] = ACTIONS(2879),
    [anon_sym_const] = ACTIONS(2879),
    [anon_sym_constexpr] = ACTIONS(2879),
    [anon_sym_volatile] = ACTIONS(2879),
    [anon_sym_restrict] = ACTIONS(2879),
    [anon_sym___restrict__] = ACTIONS(2879),
    [anon_sym__Atomic] = ACTIONS(2879),
    [anon_sym__Noreturn] = ACTIONS(2879),
    [anon_sym_noreturn] = ACTIONS(2879),
    [anon_sym__Nonnull] = ACTIONS(2879),
    [anon_sym_mutable] = ACTIONS(2879),
    [anon_sym_constinit] = ACTIONS(2879),
    [anon_sym_consteval] = ACTIONS(2879),
    [anon_sym_alignas] = ACTIONS(2879),
    [anon_sym__Alignas] = ACTIONS(2879),
    [anon_sym_DOT] = ACTIONS(2879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2879),
    [anon_sym_let] = ACTIONS(2879),
    [anon_sym_This] = ACTIONS(2879),
    [anon_sym_decltype] = ACTIONS(2879),
    [anon_sym_template] = ACTIONS(2879),
    [anon_sym_GT2] = ACTIONS(2877),
    [anon_sym_operator] = ACTIONS(2879),
    [anon_sym_precise] = ACTIONS(2879),
    [anon_sym_shared] = ACTIONS(2879),
    [anon_sym_groupshared] = ACTIONS(2879),
    [anon_sym_uniform] = ACTIONS(2879),
    [anon_sym_row_major] = ACTIONS(2879),
    [anon_sym_column_major] = ACTIONS(2879),
    [anon_sym_globallycoherent] = ACTIONS(2879),
    [anon_sym_centroid] = ACTIONS(2879),
    [anon_sym_noperspective] = ACTIONS(2879),
    [anon_sym_nointerpolation] = ACTIONS(2879),
    [anon_sym_sample] = ACTIONS(2879),
    [anon_sym_linear] = ACTIONS(2879),
    [anon_sym_snorm] = ACTIONS(2879),
    [anon_sym_unorm] = ACTIONS(2879),
    [anon_sym_point] = ACTIONS(2879),
    [anon_sym_line] = ACTIONS(2879),
    [anon_sym_triangleadj] = ACTIONS(2879),
    [anon_sym_lineadj] = ACTIONS(2879),
    [anon_sym_triangle] = ACTIONS(2879),
  },
  [2867] = {
    [sym_identifier] = ACTIONS(3054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3052),
    [anon_sym_COMMA] = ACTIONS(3052),
    [anon_sym_RPAREN] = ACTIONS(3052),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_COLON] = ACTIONS(3054),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3054),
    [anon_sym_in] = ACTIONS(3054),
    [anon_sym_out] = ACTIONS(3054),
    [anon_sym_inout] = ACTIONS(3054),
    [anon_sym_virtual] = ACTIONS(3054),
    [anon_sym_extern] = ACTIONS(3054),
    [anon_sym___attribute__] = ACTIONS(3054),
    [anon_sym___attribute] = ACTIONS(3054),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3052),
    [anon_sym___declspec] = ACTIONS(3054),
    [anon_sym___based] = ACTIONS(3054),
    [anon_sym___cdecl] = ACTIONS(3054),
    [anon_sym___clrcall] = ACTIONS(3054),
    [anon_sym___stdcall] = ACTIONS(3054),
    [anon_sym___fastcall] = ACTIONS(3054),
    [anon_sym___thiscall] = ACTIONS(3054),
    [anon_sym___vectorcall] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3054),
    [anon_sym_static] = ACTIONS(3054),
    [anon_sym_EQ] = ACTIONS(3052),
    [anon_sym_register] = ACTIONS(3054),
    [anon_sym_inline] = ACTIONS(3054),
    [anon_sym___inline] = ACTIONS(3054),
    [anon_sym___inline__] = ACTIONS(3054),
    [anon_sym___forceinline] = ACTIONS(3054),
    [anon_sym_thread_local] = ACTIONS(3054),
    [anon_sym___thread] = ACTIONS(3054),
    [anon_sym_const] = ACTIONS(3054),
    [anon_sym_constexpr] = ACTIONS(3054),
    [anon_sym_volatile] = ACTIONS(3054),
    [anon_sym_restrict] = ACTIONS(3054),
    [anon_sym___restrict__] = ACTIONS(3054),
    [anon_sym__Atomic] = ACTIONS(3054),
    [anon_sym__Noreturn] = ACTIONS(3054),
    [anon_sym_noreturn] = ACTIONS(3054),
    [anon_sym__Nonnull] = ACTIONS(3054),
    [anon_sym_mutable] = ACTIONS(3054),
    [anon_sym_constinit] = ACTIONS(3054),
    [anon_sym_consteval] = ACTIONS(3054),
    [anon_sym_alignas] = ACTIONS(3054),
    [anon_sym__Alignas] = ACTIONS(3054),
    [anon_sym_DOT] = ACTIONS(3054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3054),
    [anon_sym_let] = ACTIONS(3054),
    [anon_sym_This] = ACTIONS(3054),
    [anon_sym_decltype] = ACTIONS(3054),
    [anon_sym_template] = ACTIONS(3054),
    [anon_sym_GT2] = ACTIONS(3052),
    [anon_sym_operator] = ACTIONS(3054),
    [anon_sym_precise] = ACTIONS(3054),
    [anon_sym_shared] = ACTIONS(3054),
    [anon_sym_groupshared] = ACTIONS(3054),
    [anon_sym_uniform] = ACTIONS(3054),
    [anon_sym_row_major] = ACTIONS(3054),
    [anon_sym_column_major] = ACTIONS(3054),
    [anon_sym_globallycoherent] = ACTIONS(3054),
    [anon_sym_centroid] = ACTIONS(3054),
    [anon_sym_noperspective] = ACTIONS(3054),
    [anon_sym_nointerpolation] = ACTIONS(3054),
    [anon_sym_sample] = ACTIONS(3054),
    [anon_sym_linear] = ACTIONS(3054),
    [anon_sym_snorm] = ACTIONS(3054),
    [anon_sym_unorm] = ACTIONS(3054),
    [anon_sym_point] = ACTIONS(3054),
    [anon_sym_line] = ACTIONS(3054),
    [anon_sym_triangleadj] = ACTIONS(3054),
    [anon_sym_lineadj] = ACTIONS(3054),
    [anon_sym_triangle] = ACTIONS(3054),
  },
  [2868] = {
    [sym_identifier] = ACTIONS(2986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(2984),
    [anon_sym_RPAREN] = ACTIONS(2984),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2984),
    [anon_sym_STAR] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_AMP] = ACTIONS(2986),
    [anon_sym_COLON] = ACTIONS(2986),
    [anon_sym_SEMI] = ACTIONS(2984),
    [anon_sym___extension__] = ACTIONS(2986),
    [anon_sym_in] = ACTIONS(2986),
    [anon_sym_out] = ACTIONS(2986),
    [anon_sym_inout] = ACTIONS(2986),
    [anon_sym_virtual] = ACTIONS(2986),
    [anon_sym_extern] = ACTIONS(2986),
    [anon_sym___attribute__] = ACTIONS(2986),
    [anon_sym___attribute] = ACTIONS(2986),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2984),
    [anon_sym___declspec] = ACTIONS(2986),
    [anon_sym___based] = ACTIONS(2986),
    [anon_sym___cdecl] = ACTIONS(2986),
    [anon_sym___clrcall] = ACTIONS(2986),
    [anon_sym___stdcall] = ACTIONS(2986),
    [anon_sym___fastcall] = ACTIONS(2986),
    [anon_sym___thiscall] = ACTIONS(2986),
    [anon_sym___vectorcall] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2986),
    [anon_sym_static] = ACTIONS(2986),
    [anon_sym_EQ] = ACTIONS(2984),
    [anon_sym_register] = ACTIONS(2986),
    [anon_sym_inline] = ACTIONS(2986),
    [anon_sym___inline] = ACTIONS(2986),
    [anon_sym___inline__] = ACTIONS(2986),
    [anon_sym___forceinline] = ACTIONS(2986),
    [anon_sym_thread_local] = ACTIONS(2986),
    [anon_sym___thread] = ACTIONS(2986),
    [anon_sym_const] = ACTIONS(2986),
    [anon_sym_constexpr] = ACTIONS(2986),
    [anon_sym_volatile] = ACTIONS(2986),
    [anon_sym_restrict] = ACTIONS(2986),
    [anon_sym___restrict__] = ACTIONS(2986),
    [anon_sym__Atomic] = ACTIONS(2986),
    [anon_sym__Noreturn] = ACTIONS(2986),
    [anon_sym_noreturn] = ACTIONS(2986),
    [anon_sym__Nonnull] = ACTIONS(2986),
    [anon_sym_mutable] = ACTIONS(2986),
    [anon_sym_constinit] = ACTIONS(2986),
    [anon_sym_consteval] = ACTIONS(2986),
    [anon_sym_alignas] = ACTIONS(2986),
    [anon_sym__Alignas] = ACTIONS(2986),
    [anon_sym_DOT] = ACTIONS(2986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2986),
    [anon_sym_let] = ACTIONS(2986),
    [anon_sym_This] = ACTIONS(2986),
    [anon_sym_decltype] = ACTIONS(2986),
    [anon_sym_template] = ACTIONS(2986),
    [anon_sym_GT2] = ACTIONS(2984),
    [anon_sym_operator] = ACTIONS(2986),
    [anon_sym_precise] = ACTIONS(2986),
    [anon_sym_shared] = ACTIONS(2986),
    [anon_sym_groupshared] = ACTIONS(2986),
    [anon_sym_uniform] = ACTIONS(2986),
    [anon_sym_row_major] = ACTIONS(2986),
    [anon_sym_column_major] = ACTIONS(2986),
    [anon_sym_globallycoherent] = ACTIONS(2986),
    [anon_sym_centroid] = ACTIONS(2986),
    [anon_sym_noperspective] = ACTIONS(2986),
    [anon_sym_nointerpolation] = ACTIONS(2986),
    [anon_sym_sample] = ACTIONS(2986),
    [anon_sym_linear] = ACTIONS(2986),
    [anon_sym_snorm] = ACTIONS(2986),
    [anon_sym_unorm] = ACTIONS(2986),
    [anon_sym_point] = ACTIONS(2986),
    [anon_sym_line] = ACTIONS(2986),
    [anon_sym_triangleadj] = ACTIONS(2986),
    [anon_sym_lineadj] = ACTIONS(2986),
    [anon_sym_triangle] = ACTIONS(2986),
  },
  [2869] = {
    [sym_identifier] = ACTIONS(2956),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2954),
    [anon_sym_COMMA] = ACTIONS(2954),
    [anon_sym_RPAREN] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2954),
    [anon_sym_TILDE] = ACTIONS(2954),
    [anon_sym_STAR] = ACTIONS(2954),
    [anon_sym_AMP_AMP] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(2956),
    [anon_sym_COLON] = ACTIONS(2956),
    [anon_sym_SEMI] = ACTIONS(2954),
    [anon_sym___extension__] = ACTIONS(2956),
    [anon_sym_in] = ACTIONS(2956),
    [anon_sym_out] = ACTIONS(2956),
    [anon_sym_inout] = ACTIONS(2956),
    [anon_sym_virtual] = ACTIONS(2956),
    [anon_sym_extern] = ACTIONS(2956),
    [anon_sym___attribute__] = ACTIONS(2956),
    [anon_sym___attribute] = ACTIONS(2956),
    [anon_sym_COLON_COLON] = ACTIONS(2954),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2954),
    [anon_sym___declspec] = ACTIONS(2956),
    [anon_sym___based] = ACTIONS(2956),
    [anon_sym___cdecl] = ACTIONS(2956),
    [anon_sym___clrcall] = ACTIONS(2956),
    [anon_sym___stdcall] = ACTIONS(2956),
    [anon_sym___fastcall] = ACTIONS(2956),
    [anon_sym___thiscall] = ACTIONS(2956),
    [anon_sym___vectorcall] = ACTIONS(2956),
    [anon_sym_LBRACK] = ACTIONS(2956),
    [anon_sym_static] = ACTIONS(2956),
    [anon_sym_EQ] = ACTIONS(2954),
    [anon_sym_register] = ACTIONS(2956),
    [anon_sym_inline] = ACTIONS(2956),
    [anon_sym___inline] = ACTIONS(2956),
    [anon_sym___inline__] = ACTIONS(2956),
    [anon_sym___forceinline] = ACTIONS(2956),
    [anon_sym_thread_local] = ACTIONS(2956),
    [anon_sym___thread] = ACTIONS(2956),
    [anon_sym_const] = ACTIONS(2956),
    [anon_sym_constexpr] = ACTIONS(2956),
    [anon_sym_volatile] = ACTIONS(2956),
    [anon_sym_restrict] = ACTIONS(2956),
    [anon_sym___restrict__] = ACTIONS(2956),
    [anon_sym__Atomic] = ACTIONS(2956),
    [anon_sym__Noreturn] = ACTIONS(2956),
    [anon_sym_noreturn] = ACTIONS(2956),
    [anon_sym__Nonnull] = ACTIONS(2956),
    [anon_sym_mutable] = ACTIONS(2956),
    [anon_sym_constinit] = ACTIONS(2956),
    [anon_sym_consteval] = ACTIONS(2956),
    [anon_sym_alignas] = ACTIONS(2956),
    [anon_sym__Alignas] = ACTIONS(2956),
    [anon_sym_DOT] = ACTIONS(2956),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2956),
    [anon_sym_let] = ACTIONS(2956),
    [anon_sym_This] = ACTIONS(2956),
    [anon_sym_decltype] = ACTIONS(2956),
    [anon_sym_template] = ACTIONS(2956),
    [anon_sym_GT2] = ACTIONS(2954),
    [anon_sym_operator] = ACTIONS(2956),
    [anon_sym_precise] = ACTIONS(2956),
    [anon_sym_shared] = ACTIONS(2956),
    [anon_sym_groupshared] = ACTIONS(2956),
    [anon_sym_uniform] = ACTIONS(2956),
    [anon_sym_row_major] = ACTIONS(2956),
    [anon_sym_column_major] = ACTIONS(2956),
    [anon_sym_globallycoherent] = ACTIONS(2956),
    [anon_sym_centroid] = ACTIONS(2956),
    [anon_sym_noperspective] = ACTIONS(2956),
    [anon_sym_nointerpolation] = ACTIONS(2956),
    [anon_sym_sample] = ACTIONS(2956),
    [anon_sym_linear] = ACTIONS(2956),
    [anon_sym_snorm] = ACTIONS(2956),
    [anon_sym_unorm] = ACTIONS(2956),
    [anon_sym_point] = ACTIONS(2956),
    [anon_sym_line] = ACTIONS(2956),
    [anon_sym_triangleadj] = ACTIONS(2956),
    [anon_sym_lineadj] = ACTIONS(2956),
    [anon_sym_triangle] = ACTIONS(2956),
  },
  [2870] = {
    [sym_identifier] = ACTIONS(2960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2958),
    [anon_sym_COMMA] = ACTIONS(2958),
    [anon_sym_RPAREN] = ACTIONS(2958),
    [anon_sym_LPAREN2] = ACTIONS(2958),
    [anon_sym_TILDE] = ACTIONS(2958),
    [anon_sym_STAR] = ACTIONS(2958),
    [anon_sym_AMP_AMP] = ACTIONS(2958),
    [anon_sym_AMP] = ACTIONS(2960),
    [anon_sym_COLON] = ACTIONS(2960),
    [anon_sym_SEMI] = ACTIONS(2958),
    [anon_sym___extension__] = ACTIONS(2960),
    [anon_sym_in] = ACTIONS(2960),
    [anon_sym_out] = ACTIONS(2960),
    [anon_sym_inout] = ACTIONS(2960),
    [anon_sym_virtual] = ACTIONS(2960),
    [anon_sym_extern] = ACTIONS(2960),
    [anon_sym___attribute__] = ACTIONS(2960),
    [anon_sym___attribute] = ACTIONS(2960),
    [anon_sym_COLON_COLON] = ACTIONS(2958),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2958),
    [anon_sym___declspec] = ACTIONS(2960),
    [anon_sym___based] = ACTIONS(2960),
    [anon_sym___cdecl] = ACTIONS(2960),
    [anon_sym___clrcall] = ACTIONS(2960),
    [anon_sym___stdcall] = ACTIONS(2960),
    [anon_sym___fastcall] = ACTIONS(2960),
    [anon_sym___thiscall] = ACTIONS(2960),
    [anon_sym___vectorcall] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_static] = ACTIONS(2960),
    [anon_sym_EQ] = ACTIONS(2958),
    [anon_sym_register] = ACTIONS(2960),
    [anon_sym_inline] = ACTIONS(2960),
    [anon_sym___inline] = ACTIONS(2960),
    [anon_sym___inline__] = ACTIONS(2960),
    [anon_sym___forceinline] = ACTIONS(2960),
    [anon_sym_thread_local] = ACTIONS(2960),
    [anon_sym___thread] = ACTIONS(2960),
    [anon_sym_const] = ACTIONS(2960),
    [anon_sym_constexpr] = ACTIONS(2960),
    [anon_sym_volatile] = ACTIONS(2960),
    [anon_sym_restrict] = ACTIONS(2960),
    [anon_sym___restrict__] = ACTIONS(2960),
    [anon_sym__Atomic] = ACTIONS(2960),
    [anon_sym__Noreturn] = ACTIONS(2960),
    [anon_sym_noreturn] = ACTIONS(2960),
    [anon_sym__Nonnull] = ACTIONS(2960),
    [anon_sym_mutable] = ACTIONS(2960),
    [anon_sym_constinit] = ACTIONS(2960),
    [anon_sym_consteval] = ACTIONS(2960),
    [anon_sym_alignas] = ACTIONS(2960),
    [anon_sym__Alignas] = ACTIONS(2960),
    [anon_sym_DOT] = ACTIONS(2960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2960),
    [anon_sym_let] = ACTIONS(2960),
    [anon_sym_This] = ACTIONS(2960),
    [anon_sym_decltype] = ACTIONS(2960),
    [anon_sym_template] = ACTIONS(2960),
    [anon_sym_GT2] = ACTIONS(2958),
    [anon_sym_operator] = ACTIONS(2960),
    [anon_sym_precise] = ACTIONS(2960),
    [anon_sym_shared] = ACTIONS(2960),
    [anon_sym_groupshared] = ACTIONS(2960),
    [anon_sym_uniform] = ACTIONS(2960),
    [anon_sym_row_major] = ACTIONS(2960),
    [anon_sym_column_major] = ACTIONS(2960),
    [anon_sym_globallycoherent] = ACTIONS(2960),
    [anon_sym_centroid] = ACTIONS(2960),
    [anon_sym_noperspective] = ACTIONS(2960),
    [anon_sym_nointerpolation] = ACTIONS(2960),
    [anon_sym_sample] = ACTIONS(2960),
    [anon_sym_linear] = ACTIONS(2960),
    [anon_sym_snorm] = ACTIONS(2960),
    [anon_sym_unorm] = ACTIONS(2960),
    [anon_sym_point] = ACTIONS(2960),
    [anon_sym_line] = ACTIONS(2960),
    [anon_sym_triangleadj] = ACTIONS(2960),
    [anon_sym_lineadj] = ACTIONS(2960),
    [anon_sym_triangle] = ACTIONS(2960),
  },
  [2871] = {
    [sym_identifier] = ACTIONS(2926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2924),
    [anon_sym_COMMA] = ACTIONS(2924),
    [anon_sym_RPAREN] = ACTIONS(2924),
    [anon_sym_LPAREN2] = ACTIONS(2924),
    [anon_sym_TILDE] = ACTIONS(2924),
    [anon_sym_STAR] = ACTIONS(2924),
    [anon_sym_AMP_AMP] = ACTIONS(2924),
    [anon_sym_AMP] = ACTIONS(2926),
    [anon_sym_COLON] = ACTIONS(2926),
    [anon_sym_SEMI] = ACTIONS(2924),
    [anon_sym___extension__] = ACTIONS(2926),
    [anon_sym_in] = ACTIONS(2926),
    [anon_sym_out] = ACTIONS(2926),
    [anon_sym_inout] = ACTIONS(2926),
    [anon_sym_virtual] = ACTIONS(2926),
    [anon_sym_extern] = ACTIONS(2926),
    [anon_sym___attribute__] = ACTIONS(2926),
    [anon_sym___attribute] = ACTIONS(2926),
    [anon_sym_COLON_COLON] = ACTIONS(2924),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2924),
    [anon_sym___declspec] = ACTIONS(2926),
    [anon_sym___based] = ACTIONS(2926),
    [anon_sym___cdecl] = ACTIONS(2926),
    [anon_sym___clrcall] = ACTIONS(2926),
    [anon_sym___stdcall] = ACTIONS(2926),
    [anon_sym___fastcall] = ACTIONS(2926),
    [anon_sym___thiscall] = ACTIONS(2926),
    [anon_sym___vectorcall] = ACTIONS(2926),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_static] = ACTIONS(2926),
    [anon_sym_EQ] = ACTIONS(2924),
    [anon_sym_register] = ACTIONS(2926),
    [anon_sym_inline] = ACTIONS(2926),
    [anon_sym___inline] = ACTIONS(2926),
    [anon_sym___inline__] = ACTIONS(2926),
    [anon_sym___forceinline] = ACTIONS(2926),
    [anon_sym_thread_local] = ACTIONS(2926),
    [anon_sym___thread] = ACTIONS(2926),
    [anon_sym_const] = ACTIONS(2926),
    [anon_sym_constexpr] = ACTIONS(2926),
    [anon_sym_volatile] = ACTIONS(2926),
    [anon_sym_restrict] = ACTIONS(2926),
    [anon_sym___restrict__] = ACTIONS(2926),
    [anon_sym__Atomic] = ACTIONS(2926),
    [anon_sym__Noreturn] = ACTIONS(2926),
    [anon_sym_noreturn] = ACTIONS(2926),
    [anon_sym__Nonnull] = ACTIONS(2926),
    [anon_sym_mutable] = ACTIONS(2926),
    [anon_sym_constinit] = ACTIONS(2926),
    [anon_sym_consteval] = ACTIONS(2926),
    [anon_sym_alignas] = ACTIONS(2926),
    [anon_sym__Alignas] = ACTIONS(2926),
    [anon_sym_DOT] = ACTIONS(2926),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2926),
    [anon_sym_let] = ACTIONS(2926),
    [anon_sym_This] = ACTIONS(2926),
    [anon_sym_decltype] = ACTIONS(2926),
    [anon_sym_template] = ACTIONS(2926),
    [anon_sym_GT2] = ACTIONS(2924),
    [anon_sym_operator] = ACTIONS(2926),
    [anon_sym_precise] = ACTIONS(2926),
    [anon_sym_shared] = ACTIONS(2926),
    [anon_sym_groupshared] = ACTIONS(2926),
    [anon_sym_uniform] = ACTIONS(2926),
    [anon_sym_row_major] = ACTIONS(2926),
    [anon_sym_column_major] = ACTIONS(2926),
    [anon_sym_globallycoherent] = ACTIONS(2926),
    [anon_sym_centroid] = ACTIONS(2926),
    [anon_sym_noperspective] = ACTIONS(2926),
    [anon_sym_nointerpolation] = ACTIONS(2926),
    [anon_sym_sample] = ACTIONS(2926),
    [anon_sym_linear] = ACTIONS(2926),
    [anon_sym_snorm] = ACTIONS(2926),
    [anon_sym_unorm] = ACTIONS(2926),
    [anon_sym_point] = ACTIONS(2926),
    [anon_sym_line] = ACTIONS(2926),
    [anon_sym_triangleadj] = ACTIONS(2926),
    [anon_sym_lineadj] = ACTIONS(2926),
    [anon_sym_triangle] = ACTIONS(2926),
  },
  [2872] = {
    [sym_identifier] = ACTIONS(3006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3004),
    [anon_sym_COMMA] = ACTIONS(3004),
    [anon_sym_RPAREN] = ACTIONS(3004),
    [anon_sym_LPAREN2] = ACTIONS(3004),
    [anon_sym_TILDE] = ACTIONS(3004),
    [anon_sym_STAR] = ACTIONS(3004),
    [anon_sym_AMP_AMP] = ACTIONS(3004),
    [anon_sym_AMP] = ACTIONS(3006),
    [anon_sym_COLON] = ACTIONS(3006),
    [anon_sym_SEMI] = ACTIONS(3004),
    [anon_sym___extension__] = ACTIONS(3006),
    [anon_sym_in] = ACTIONS(3006),
    [anon_sym_out] = ACTIONS(3006),
    [anon_sym_inout] = ACTIONS(3006),
    [anon_sym_virtual] = ACTIONS(3006),
    [anon_sym_extern] = ACTIONS(3006),
    [anon_sym___attribute__] = ACTIONS(3006),
    [anon_sym___attribute] = ACTIONS(3006),
    [anon_sym_COLON_COLON] = ACTIONS(3004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3004),
    [anon_sym___declspec] = ACTIONS(3006),
    [anon_sym___based] = ACTIONS(3006),
    [anon_sym___cdecl] = ACTIONS(3006),
    [anon_sym___clrcall] = ACTIONS(3006),
    [anon_sym___stdcall] = ACTIONS(3006),
    [anon_sym___fastcall] = ACTIONS(3006),
    [anon_sym___thiscall] = ACTIONS(3006),
    [anon_sym___vectorcall] = ACTIONS(3006),
    [anon_sym_LBRACK] = ACTIONS(3006),
    [anon_sym_static] = ACTIONS(3006),
    [anon_sym_EQ] = ACTIONS(3004),
    [anon_sym_register] = ACTIONS(3006),
    [anon_sym_inline] = ACTIONS(3006),
    [anon_sym___inline] = ACTIONS(3006),
    [anon_sym___inline__] = ACTIONS(3006),
    [anon_sym___forceinline] = ACTIONS(3006),
    [anon_sym_thread_local] = ACTIONS(3006),
    [anon_sym___thread] = ACTIONS(3006),
    [anon_sym_const] = ACTIONS(3006),
    [anon_sym_constexpr] = ACTIONS(3006),
    [anon_sym_volatile] = ACTIONS(3006),
    [anon_sym_restrict] = ACTIONS(3006),
    [anon_sym___restrict__] = ACTIONS(3006),
    [anon_sym__Atomic] = ACTIONS(3006),
    [anon_sym__Noreturn] = ACTIONS(3006),
    [anon_sym_noreturn] = ACTIONS(3006),
    [anon_sym__Nonnull] = ACTIONS(3006),
    [anon_sym_mutable] = ACTIONS(3006),
    [anon_sym_constinit] = ACTIONS(3006),
    [anon_sym_consteval] = ACTIONS(3006),
    [anon_sym_alignas] = ACTIONS(3006),
    [anon_sym__Alignas] = ACTIONS(3006),
    [anon_sym_DOT] = ACTIONS(3006),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3006),
    [anon_sym_let] = ACTIONS(3006),
    [anon_sym_This] = ACTIONS(3006),
    [anon_sym_decltype] = ACTIONS(3006),
    [anon_sym_template] = ACTIONS(3006),
    [anon_sym_GT2] = ACTIONS(3004),
    [anon_sym_operator] = ACTIONS(3006),
    [anon_sym_precise] = ACTIONS(3006),
    [anon_sym_shared] = ACTIONS(3006),
    [anon_sym_groupshared] = ACTIONS(3006),
    [anon_sym_uniform] = ACTIONS(3006),
    [anon_sym_row_major] = ACTIONS(3006),
    [anon_sym_column_major] = ACTIONS(3006),
    [anon_sym_globallycoherent] = ACTIONS(3006),
    [anon_sym_centroid] = ACTIONS(3006),
    [anon_sym_noperspective] = ACTIONS(3006),
    [anon_sym_nointerpolation] = ACTIONS(3006),
    [anon_sym_sample] = ACTIONS(3006),
    [anon_sym_linear] = ACTIONS(3006),
    [anon_sym_snorm] = ACTIONS(3006),
    [anon_sym_unorm] = ACTIONS(3006),
    [anon_sym_point] = ACTIONS(3006),
    [anon_sym_line] = ACTIONS(3006),
    [anon_sym_triangleadj] = ACTIONS(3006),
    [anon_sym_lineadj] = ACTIONS(3006),
    [anon_sym_triangle] = ACTIONS(3006),
  },
  [2873] = {
    [sym_type_qualifier] = STATE(2873),
    [sym_alignas_qualifier] = STATE(2959),
    [aux_sym__type_definition_type_repeat1] = STATE(2873),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3681),
    [anon_sym_COMMA] = ACTIONS(3681),
    [anon_sym_RPAREN] = ACTIONS(3681),
    [anon_sym_LPAREN2] = ACTIONS(3681),
    [anon_sym_DASH] = ACTIONS(3683),
    [anon_sym_PLUS] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(3683),
    [anon_sym_SLASH] = ACTIONS(3683),
    [anon_sym_PERCENT] = ACTIONS(3683),
    [anon_sym_PIPE_PIPE] = ACTIONS(3681),
    [anon_sym_AMP_AMP] = ACTIONS(3681),
    [anon_sym_PIPE] = ACTIONS(3683),
    [anon_sym_CARET] = ACTIONS(3683),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_EQ_EQ] = ACTIONS(3681),
    [anon_sym_BANG_EQ] = ACTIONS(3681),
    [anon_sym_GT] = ACTIONS(3683),
    [anon_sym_GT_EQ] = ACTIONS(3681),
    [anon_sym_LT_EQ] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_LT_LT] = ACTIONS(3683),
    [anon_sym_GT_GT] = ACTIONS(3683),
    [anon_sym___extension__] = ACTIONS(7097),
    [anon_sym___attribute__] = ACTIONS(3683),
    [anon_sym___attribute] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3681),
    [anon_sym_signed] = ACTIONS(3683),
    [anon_sym_unsigned] = ACTIONS(3683),
    [anon_sym_long] = ACTIONS(3683),
    [anon_sym_short] = ACTIONS(3683),
    [anon_sym_LBRACK] = ACTIONS(3681),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_const] = ACTIONS(7097),
    [anon_sym_constexpr] = ACTIONS(7097),
    [anon_sym_volatile] = ACTIONS(7097),
    [anon_sym_restrict] = ACTIONS(7097),
    [anon_sym___restrict__] = ACTIONS(7097),
    [anon_sym__Atomic] = ACTIONS(7097),
    [anon_sym__Noreturn] = ACTIONS(7097),
    [anon_sym_noreturn] = ACTIONS(7097),
    [anon_sym__Nonnull] = ACTIONS(7097),
    [anon_sym_mutable] = ACTIONS(7097),
    [anon_sym_constinit] = ACTIONS(7097),
    [anon_sym_consteval] = ACTIONS(7097),
    [anon_sym_alignas] = ACTIONS(7100),
    [anon_sym__Alignas] = ACTIONS(7100),
    [sym_primitive_type] = ACTIONS(3683),
    [anon_sym_QMARK] = ACTIONS(3681),
    [anon_sym_STAR_EQ] = ACTIONS(3681),
    [anon_sym_SLASH_EQ] = ACTIONS(3681),
    [anon_sym_PERCENT_EQ] = ACTIONS(3681),
    [anon_sym_PLUS_EQ] = ACTIONS(3681),
    [anon_sym_DASH_EQ] = ACTIONS(3681),
    [anon_sym_LT_LT_EQ] = ACTIONS(3681),
    [anon_sym_GT_GT_EQ] = ACTIONS(3681),
    [anon_sym_AMP_EQ] = ACTIONS(3681),
    [anon_sym_CARET_EQ] = ACTIONS(3681),
    [anon_sym_PIPE_EQ] = ACTIONS(3681),
    [anon_sym_LT_EQ_GT] = ACTIONS(3681),
    [anon_sym_or] = ACTIONS(3683),
    [anon_sym_and] = ACTIONS(3683),
    [anon_sym_bitor] = ACTIONS(3683),
    [anon_sym_xor] = ACTIONS(3683),
    [anon_sym_bitand] = ACTIONS(3683),
    [anon_sym_not_eq] = ACTIONS(3683),
    [anon_sym_is] = ACTIONS(3683),
    [anon_sym_as] = ACTIONS(3683),
    [anon_sym_DASH_DASH] = ACTIONS(3681),
    [anon_sym_PLUS_PLUS] = ACTIONS(3681),
    [anon_sym_DOT] = ACTIONS(3683),
    [anon_sym_DOT_STAR] = ACTIONS(3681),
    [anon_sym_DASH_GT] = ACTIONS(3683),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3683),
    [anon_sym_let] = ACTIONS(3683),
    [anon_sym_This] = ACTIONS(3683),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3681),
  },
  [2874] = {
    [sym_identifier] = ACTIONS(4860),
    [anon_sym_LPAREN2] = ACTIONS(4862),
    [anon_sym_TILDE] = ACTIONS(4862),
    [anon_sym_STAR] = ACTIONS(4862),
    [anon_sym_AMP_AMP] = ACTIONS(4862),
    [anon_sym_AMP] = ACTIONS(4860),
    [anon_sym___extension__] = ACTIONS(4860),
    [anon_sym_in] = ACTIONS(4860),
    [anon_sym_out] = ACTIONS(4860),
    [anon_sym_inout] = ACTIONS(4860),
    [anon_sym_virtual] = ACTIONS(4860),
    [anon_sym_extern] = ACTIONS(4860),
    [anon_sym___attribute__] = ACTIONS(4860),
    [anon_sym___attribute] = ACTIONS(4860),
    [anon_sym_using] = ACTIONS(4860),
    [anon_sym_COLON_COLON] = ACTIONS(4862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4862),
    [anon_sym___declspec] = ACTIONS(4860),
    [anon_sym___based] = ACTIONS(4860),
    [anon_sym_signed] = ACTIONS(4860),
    [anon_sym_unsigned] = ACTIONS(4860),
    [anon_sym_long] = ACTIONS(4860),
    [anon_sym_short] = ACTIONS(4860),
    [anon_sym_LBRACK] = ACTIONS(4860),
    [anon_sym_static] = ACTIONS(4860),
    [anon_sym_register] = ACTIONS(4860),
    [anon_sym_inline] = ACTIONS(4860),
    [anon_sym___inline] = ACTIONS(4860),
    [anon_sym___inline__] = ACTIONS(4860),
    [anon_sym___forceinline] = ACTIONS(4860),
    [anon_sym_thread_local] = ACTIONS(4860),
    [anon_sym___thread] = ACTIONS(4860),
    [anon_sym_const] = ACTIONS(4860),
    [anon_sym_constexpr] = ACTIONS(4860),
    [anon_sym_volatile] = ACTIONS(4860),
    [anon_sym_restrict] = ACTIONS(4860),
    [anon_sym___restrict__] = ACTIONS(4860),
    [anon_sym__Atomic] = ACTIONS(4860),
    [anon_sym__Noreturn] = ACTIONS(4860),
    [anon_sym_noreturn] = ACTIONS(4860),
    [anon_sym__Nonnull] = ACTIONS(4860),
    [anon_sym_mutable] = ACTIONS(4860),
    [anon_sym_constinit] = ACTIONS(4860),
    [anon_sym_consteval] = ACTIONS(4860),
    [anon_sym_alignas] = ACTIONS(4860),
    [anon_sym__Alignas] = ACTIONS(4860),
    [sym_primitive_type] = ACTIONS(4860),
    [anon_sym_enum] = ACTIONS(4860),
    [anon_sym_class] = ACTIONS(4860),
    [anon_sym_struct] = ACTIONS(4860),
    [anon_sym_union] = ACTIONS(4860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4860),
    [anon_sym_let] = ACTIONS(4860),
    [anon_sym_This] = ACTIONS(4860),
    [anon_sym_decltype] = ACTIONS(4860),
    [anon_sym_explicit] = ACTIONS(4860),
    [anon_sym_typename] = ACTIONS(4860),
    [anon_sym_template] = ACTIONS(4860),
    [anon_sym_operator] = ACTIONS(4860),
    [anon_sym_precise] = ACTIONS(4860),
    [anon_sym_shared] = ACTIONS(4860),
    [anon_sym_groupshared] = ACTIONS(4860),
    [anon_sym_uniform] = ACTIONS(4860),
    [anon_sym_row_major] = ACTIONS(4860),
    [anon_sym_column_major] = ACTIONS(4860),
    [anon_sym_globallycoherent] = ACTIONS(4860),
    [anon_sym_centroid] = ACTIONS(4860),
    [anon_sym_noperspective] = ACTIONS(4860),
    [anon_sym_nointerpolation] = ACTIONS(4860),
    [anon_sym_sample] = ACTIONS(4860),
    [anon_sym_linear] = ACTIONS(4860),
    [anon_sym_snorm] = ACTIONS(4860),
    [anon_sym_unorm] = ACTIONS(4860),
    [anon_sym_point] = ACTIONS(4860),
    [anon_sym_line] = ACTIONS(4860),
    [anon_sym_triangleadj] = ACTIONS(4860),
    [anon_sym_lineadj] = ACTIONS(4860),
    [anon_sym_triangle] = ACTIONS(4860),
    [anon_sym_interface] = ACTIONS(4860),
    [anon_sym_extension] = ACTIONS(4860),
  },
  [2875] = {
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3352),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3362),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3362),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3362),
    [anon_sym_explicit] = ACTIONS(3362),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3362),
    [anon_sym_operator] = ACTIONS(3362),
    [anon_sym_friend] = ACTIONS(7103),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [2876] = {
    [sym_identifier] = ACTIONS(3010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3008),
    [anon_sym_COMMA] = ACTIONS(3008),
    [anon_sym_RPAREN] = ACTIONS(3008),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_TILDE] = ACTIONS(3008),
    [anon_sym_STAR] = ACTIONS(3008),
    [anon_sym_AMP_AMP] = ACTIONS(3008),
    [anon_sym_AMP] = ACTIONS(3010),
    [anon_sym_COLON] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(3008),
    [anon_sym___extension__] = ACTIONS(3010),
    [anon_sym_in] = ACTIONS(3010),
    [anon_sym_out] = ACTIONS(3010),
    [anon_sym_inout] = ACTIONS(3010),
    [anon_sym_virtual] = ACTIONS(3010),
    [anon_sym_extern] = ACTIONS(3010),
    [anon_sym___attribute__] = ACTIONS(3010),
    [anon_sym___attribute] = ACTIONS(3010),
    [anon_sym_COLON_COLON] = ACTIONS(3008),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3008),
    [anon_sym___declspec] = ACTIONS(3010),
    [anon_sym___based] = ACTIONS(3010),
    [anon_sym___cdecl] = ACTIONS(3010),
    [anon_sym___clrcall] = ACTIONS(3010),
    [anon_sym___stdcall] = ACTIONS(3010),
    [anon_sym___fastcall] = ACTIONS(3010),
    [anon_sym___thiscall] = ACTIONS(3010),
    [anon_sym___vectorcall] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3010),
    [anon_sym_static] = ACTIONS(3010),
    [anon_sym_EQ] = ACTIONS(3008),
    [anon_sym_register] = ACTIONS(3010),
    [anon_sym_inline] = ACTIONS(3010),
    [anon_sym___inline] = ACTIONS(3010),
    [anon_sym___inline__] = ACTIONS(3010),
    [anon_sym___forceinline] = ACTIONS(3010),
    [anon_sym_thread_local] = ACTIONS(3010),
    [anon_sym___thread] = ACTIONS(3010),
    [anon_sym_const] = ACTIONS(3010),
    [anon_sym_constexpr] = ACTIONS(3010),
    [anon_sym_volatile] = ACTIONS(3010),
    [anon_sym_restrict] = ACTIONS(3010),
    [anon_sym___restrict__] = ACTIONS(3010),
    [anon_sym__Atomic] = ACTIONS(3010),
    [anon_sym__Noreturn] = ACTIONS(3010),
    [anon_sym_noreturn] = ACTIONS(3010),
    [anon_sym__Nonnull] = ACTIONS(3010),
    [anon_sym_mutable] = ACTIONS(3010),
    [anon_sym_constinit] = ACTIONS(3010),
    [anon_sym_consteval] = ACTIONS(3010),
    [anon_sym_alignas] = ACTIONS(3010),
    [anon_sym__Alignas] = ACTIONS(3010),
    [anon_sym_DOT] = ACTIONS(3010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3010),
    [anon_sym_let] = ACTIONS(3010),
    [anon_sym_This] = ACTIONS(3010),
    [anon_sym_decltype] = ACTIONS(3010),
    [anon_sym_template] = ACTIONS(3010),
    [anon_sym_GT2] = ACTIONS(3008),
    [anon_sym_operator] = ACTIONS(3010),
    [anon_sym_precise] = ACTIONS(3010),
    [anon_sym_shared] = ACTIONS(3010),
    [anon_sym_groupshared] = ACTIONS(3010),
    [anon_sym_uniform] = ACTIONS(3010),
    [anon_sym_row_major] = ACTIONS(3010),
    [anon_sym_column_major] = ACTIONS(3010),
    [anon_sym_globallycoherent] = ACTIONS(3010),
    [anon_sym_centroid] = ACTIONS(3010),
    [anon_sym_noperspective] = ACTIONS(3010),
    [anon_sym_nointerpolation] = ACTIONS(3010),
    [anon_sym_sample] = ACTIONS(3010),
    [anon_sym_linear] = ACTIONS(3010),
    [anon_sym_snorm] = ACTIONS(3010),
    [anon_sym_unorm] = ACTIONS(3010),
    [anon_sym_point] = ACTIONS(3010),
    [anon_sym_line] = ACTIONS(3010),
    [anon_sym_triangleadj] = ACTIONS(3010),
    [anon_sym_lineadj] = ACTIONS(3010),
    [anon_sym_triangle] = ACTIONS(3010),
  },
  [2877] = {
    [sym_identifier] = ACTIONS(7105),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7107),
    [anon_sym_COMMA] = ACTIONS(7107),
    [anon_sym_RPAREN] = ACTIONS(7107),
    [anon_sym_LPAREN2] = ACTIONS(7107),
    [anon_sym_TILDE] = ACTIONS(7107),
    [anon_sym_STAR] = ACTIONS(7107),
    [anon_sym_AMP_AMP] = ACTIONS(7107),
    [anon_sym_AMP] = ACTIONS(7105),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_SEMI] = ACTIONS(7107),
    [anon_sym___extension__] = ACTIONS(7105),
    [anon_sym_in] = ACTIONS(7105),
    [anon_sym_out] = ACTIONS(7105),
    [anon_sym_inout] = ACTIONS(7105),
    [anon_sym_virtual] = ACTIONS(7105),
    [anon_sym_extern] = ACTIONS(7105),
    [anon_sym___attribute__] = ACTIONS(7105),
    [anon_sym___attribute] = ACTIONS(7105),
    [anon_sym_COLON_COLON] = ACTIONS(7107),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7107),
    [anon_sym___declspec] = ACTIONS(7105),
    [anon_sym___based] = ACTIONS(7105),
    [anon_sym___cdecl] = ACTIONS(7105),
    [anon_sym___clrcall] = ACTIONS(7105),
    [anon_sym___stdcall] = ACTIONS(7105),
    [anon_sym___fastcall] = ACTIONS(7105),
    [anon_sym___thiscall] = ACTIONS(7105),
    [anon_sym___vectorcall] = ACTIONS(7105),
    [anon_sym_LBRACE] = ACTIONS(7107),
    [anon_sym_LBRACK] = ACTIONS(7105),
    [anon_sym_static] = ACTIONS(7105),
    [anon_sym_EQ] = ACTIONS(7107),
    [anon_sym_register] = ACTIONS(7105),
    [anon_sym_inline] = ACTIONS(7105),
    [anon_sym___inline] = ACTIONS(7105),
    [anon_sym___inline__] = ACTIONS(7105),
    [anon_sym___forceinline] = ACTIONS(7105),
    [anon_sym_thread_local] = ACTIONS(7105),
    [anon_sym___thread] = ACTIONS(7105),
    [anon_sym_const] = ACTIONS(7105),
    [anon_sym_constexpr] = ACTIONS(7105),
    [anon_sym_volatile] = ACTIONS(7105),
    [anon_sym_restrict] = ACTIONS(7105),
    [anon_sym___restrict__] = ACTIONS(7105),
    [anon_sym__Atomic] = ACTIONS(7105),
    [anon_sym__Noreturn] = ACTIONS(7105),
    [anon_sym_noreturn] = ACTIONS(7105),
    [anon_sym__Nonnull] = ACTIONS(7105),
    [anon_sym_mutable] = ACTIONS(7105),
    [anon_sym_constinit] = ACTIONS(7105),
    [anon_sym_consteval] = ACTIONS(7105),
    [anon_sym_alignas] = ACTIONS(7105),
    [anon_sym__Alignas] = ACTIONS(7105),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(7105),
    [anon_sym_final] = ACTIONS(7105),
    [anon_sym_override] = ACTIONS(7105),
    [anon_sym_explicit] = ACTIONS(7105),
    [anon_sym_template] = ACTIONS(7105),
    [anon_sym_GT2] = ACTIONS(7107),
    [anon_sym_operator] = ACTIONS(7105),
    [anon_sym_precise] = ACTIONS(7105),
    [anon_sym_shared] = ACTIONS(7105),
    [anon_sym_groupshared] = ACTIONS(7105),
    [anon_sym_uniform] = ACTIONS(7105),
    [anon_sym_row_major] = ACTIONS(7105),
    [anon_sym_column_major] = ACTIONS(7105),
    [anon_sym_globallycoherent] = ACTIONS(7105),
    [anon_sym_centroid] = ACTIONS(7105),
    [anon_sym_noperspective] = ACTIONS(7105),
    [anon_sym_nointerpolation] = ACTIONS(7105),
    [anon_sym_sample] = ACTIONS(7105),
    [anon_sym_linear] = ACTIONS(7105),
    [anon_sym_snorm] = ACTIONS(7105),
    [anon_sym_unorm] = ACTIONS(7105),
    [anon_sym_point] = ACTIONS(7105),
    [anon_sym_line] = ACTIONS(7105),
    [anon_sym_triangleadj] = ACTIONS(7105),
    [anon_sym_lineadj] = ACTIONS(7105),
    [anon_sym_triangle] = ACTIONS(7105),
  },
  [2878] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2878),
    [sym_identifier] = ACTIONS(2915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2913),
    [anon_sym_COMMA] = ACTIONS(2913),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2915),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(2915),
    [anon_sym_SLASH] = ACTIONS(2915),
    [anon_sym_PERCENT] = ACTIONS(2915),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_CARET] = ACTIONS(2915),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2915),
    [anon_sym_GT_EQ] = ACTIONS(2915),
    [anon_sym_LT_EQ] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2915),
    [anon_sym_LT_LT] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2915),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_signed] = ACTIONS(7109),
    [anon_sym_unsigned] = ACTIONS(7109),
    [anon_sym_long] = ACTIONS(7109),
    [anon_sym_short] = ACTIONS(7109),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(2913),
    [anon_sym_STAR_EQ] = ACTIONS(2913),
    [anon_sym_SLASH_EQ] = ACTIONS(2913),
    [anon_sym_PERCENT_EQ] = ACTIONS(2913),
    [anon_sym_PLUS_EQ] = ACTIONS(2913),
    [anon_sym_DASH_EQ] = ACTIONS(2913),
    [anon_sym_LT_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_GT_EQ] = ACTIONS(2915),
    [anon_sym_AMP_EQ] = ACTIONS(2913),
    [anon_sym_CARET_EQ] = ACTIONS(2913),
    [anon_sym_PIPE_EQ] = ACTIONS(2913),
    [anon_sym_and_eq] = ACTIONS(2915),
    [anon_sym_or_eq] = ACTIONS(2915),
    [anon_sym_xor_eq] = ACTIONS(2915),
    [anon_sym_LT_EQ_GT] = ACTIONS(2913),
    [anon_sym_or] = ACTIONS(2915),
    [anon_sym_and] = ACTIONS(2915),
    [anon_sym_bitor] = ACTIONS(2915),
    [anon_sym_xor] = ACTIONS(2915),
    [anon_sym_bitand] = ACTIONS(2915),
    [anon_sym_not_eq] = ACTIONS(2915),
    [anon_sym_is] = ACTIONS(2915),
    [anon_sym_as] = ACTIONS(2915),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_DOT] = ACTIONS(2915),
    [anon_sym_DOT_STAR] = ACTIONS(2913),
    [anon_sym_DASH_GT] = ACTIONS(2913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2915),
    [anon_sym_let] = ACTIONS(2915),
    [anon_sym_This] = ACTIONS(2915),
    [anon_sym_GT2] = ACTIONS(2913),
  },
  [2879] = {
    [sym_identifier] = ACTIONS(2990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2988),
    [anon_sym_RPAREN] = ACTIONS(2988),
    [anon_sym_LPAREN2] = ACTIONS(2988),
    [anon_sym_TILDE] = ACTIONS(2988),
    [anon_sym_STAR] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_AMP] = ACTIONS(2990),
    [anon_sym_COLON] = ACTIONS(2990),
    [anon_sym_SEMI] = ACTIONS(2988),
    [anon_sym___extension__] = ACTIONS(2990),
    [anon_sym_in] = ACTIONS(2990),
    [anon_sym_out] = ACTIONS(2990),
    [anon_sym_inout] = ACTIONS(2990),
    [anon_sym_virtual] = ACTIONS(2990),
    [anon_sym_extern] = ACTIONS(2990),
    [anon_sym___attribute__] = ACTIONS(2990),
    [anon_sym___attribute] = ACTIONS(2990),
    [anon_sym_COLON_COLON] = ACTIONS(2988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2988),
    [anon_sym___declspec] = ACTIONS(2990),
    [anon_sym___based] = ACTIONS(2990),
    [anon_sym___cdecl] = ACTIONS(2990),
    [anon_sym___clrcall] = ACTIONS(2990),
    [anon_sym___stdcall] = ACTIONS(2990),
    [anon_sym___fastcall] = ACTIONS(2990),
    [anon_sym___thiscall] = ACTIONS(2990),
    [anon_sym___vectorcall] = ACTIONS(2990),
    [anon_sym_LBRACK] = ACTIONS(2990),
    [anon_sym_static] = ACTIONS(2990),
    [anon_sym_EQ] = ACTIONS(2988),
    [anon_sym_register] = ACTIONS(2990),
    [anon_sym_inline] = ACTIONS(2990),
    [anon_sym___inline] = ACTIONS(2990),
    [anon_sym___inline__] = ACTIONS(2990),
    [anon_sym___forceinline] = ACTIONS(2990),
    [anon_sym_thread_local] = ACTIONS(2990),
    [anon_sym___thread] = ACTIONS(2990),
    [anon_sym_const] = ACTIONS(2990),
    [anon_sym_constexpr] = ACTIONS(2990),
    [anon_sym_volatile] = ACTIONS(2990),
    [anon_sym_restrict] = ACTIONS(2990),
    [anon_sym___restrict__] = ACTIONS(2990),
    [anon_sym__Atomic] = ACTIONS(2990),
    [anon_sym__Noreturn] = ACTIONS(2990),
    [anon_sym_noreturn] = ACTIONS(2990),
    [anon_sym__Nonnull] = ACTIONS(2990),
    [anon_sym_mutable] = ACTIONS(2990),
    [anon_sym_constinit] = ACTIONS(2990),
    [anon_sym_consteval] = ACTIONS(2990),
    [anon_sym_alignas] = ACTIONS(2990),
    [anon_sym__Alignas] = ACTIONS(2990),
    [anon_sym_DOT] = ACTIONS(2990),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2990),
    [anon_sym_let] = ACTIONS(2990),
    [anon_sym_This] = ACTIONS(2990),
    [anon_sym_decltype] = ACTIONS(2990),
    [anon_sym_template] = ACTIONS(2990),
    [anon_sym_GT2] = ACTIONS(2988),
    [anon_sym_operator] = ACTIONS(2990),
    [anon_sym_precise] = ACTIONS(2990),
    [anon_sym_shared] = ACTIONS(2990),
    [anon_sym_groupshared] = ACTIONS(2990),
    [anon_sym_uniform] = ACTIONS(2990),
    [anon_sym_row_major] = ACTIONS(2990),
    [anon_sym_column_major] = ACTIONS(2990),
    [anon_sym_globallycoherent] = ACTIONS(2990),
    [anon_sym_centroid] = ACTIONS(2990),
    [anon_sym_noperspective] = ACTIONS(2990),
    [anon_sym_nointerpolation] = ACTIONS(2990),
    [anon_sym_sample] = ACTIONS(2990),
    [anon_sym_linear] = ACTIONS(2990),
    [anon_sym_snorm] = ACTIONS(2990),
    [anon_sym_unorm] = ACTIONS(2990),
    [anon_sym_point] = ACTIONS(2990),
    [anon_sym_line] = ACTIONS(2990),
    [anon_sym_triangleadj] = ACTIONS(2990),
    [anon_sym_lineadj] = ACTIONS(2990),
    [anon_sym_triangle] = ACTIONS(2990),
  },
  [2880] = {
    [sym_identifier] = ACTIONS(3046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3044),
    [anon_sym_COMMA] = ACTIONS(3044),
    [anon_sym_RPAREN] = ACTIONS(3044),
    [anon_sym_LPAREN2] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3046),
    [anon_sym_COLON] = ACTIONS(3046),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym___extension__] = ACTIONS(3046),
    [anon_sym_in] = ACTIONS(3046),
    [anon_sym_out] = ACTIONS(3046),
    [anon_sym_inout] = ACTIONS(3046),
    [anon_sym_virtual] = ACTIONS(3046),
    [anon_sym_extern] = ACTIONS(3046),
    [anon_sym___attribute__] = ACTIONS(3046),
    [anon_sym___attribute] = ACTIONS(3046),
    [anon_sym_COLON_COLON] = ACTIONS(3044),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3044),
    [anon_sym___declspec] = ACTIONS(3046),
    [anon_sym___based] = ACTIONS(3046),
    [anon_sym___cdecl] = ACTIONS(3046),
    [anon_sym___clrcall] = ACTIONS(3046),
    [anon_sym___stdcall] = ACTIONS(3046),
    [anon_sym___fastcall] = ACTIONS(3046),
    [anon_sym___thiscall] = ACTIONS(3046),
    [anon_sym___vectorcall] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_static] = ACTIONS(3046),
    [anon_sym_EQ] = ACTIONS(3044),
    [anon_sym_register] = ACTIONS(3046),
    [anon_sym_inline] = ACTIONS(3046),
    [anon_sym___inline] = ACTIONS(3046),
    [anon_sym___inline__] = ACTIONS(3046),
    [anon_sym___forceinline] = ACTIONS(3046),
    [anon_sym_thread_local] = ACTIONS(3046),
    [anon_sym___thread] = ACTIONS(3046),
    [anon_sym_const] = ACTIONS(3046),
    [anon_sym_constexpr] = ACTIONS(3046),
    [anon_sym_volatile] = ACTIONS(3046),
    [anon_sym_restrict] = ACTIONS(3046),
    [anon_sym___restrict__] = ACTIONS(3046),
    [anon_sym__Atomic] = ACTIONS(3046),
    [anon_sym__Noreturn] = ACTIONS(3046),
    [anon_sym_noreturn] = ACTIONS(3046),
    [anon_sym__Nonnull] = ACTIONS(3046),
    [anon_sym_mutable] = ACTIONS(3046),
    [anon_sym_constinit] = ACTIONS(3046),
    [anon_sym_consteval] = ACTIONS(3046),
    [anon_sym_alignas] = ACTIONS(3046),
    [anon_sym__Alignas] = ACTIONS(3046),
    [anon_sym_DOT] = ACTIONS(3046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3046),
    [anon_sym_let] = ACTIONS(3046),
    [anon_sym_This] = ACTIONS(3046),
    [anon_sym_decltype] = ACTIONS(3046),
    [anon_sym_template] = ACTIONS(3046),
    [anon_sym_GT2] = ACTIONS(3044),
    [anon_sym_operator] = ACTIONS(3046),
    [anon_sym_precise] = ACTIONS(3046),
    [anon_sym_shared] = ACTIONS(3046),
    [anon_sym_groupshared] = ACTIONS(3046),
    [anon_sym_uniform] = ACTIONS(3046),
    [anon_sym_row_major] = ACTIONS(3046),
    [anon_sym_column_major] = ACTIONS(3046),
    [anon_sym_globallycoherent] = ACTIONS(3046),
    [anon_sym_centroid] = ACTIONS(3046),
    [anon_sym_noperspective] = ACTIONS(3046),
    [anon_sym_nointerpolation] = ACTIONS(3046),
    [anon_sym_sample] = ACTIONS(3046),
    [anon_sym_linear] = ACTIONS(3046),
    [anon_sym_snorm] = ACTIONS(3046),
    [anon_sym_unorm] = ACTIONS(3046),
    [anon_sym_point] = ACTIONS(3046),
    [anon_sym_line] = ACTIONS(3046),
    [anon_sym_triangleadj] = ACTIONS(3046),
    [anon_sym_lineadj] = ACTIONS(3046),
    [anon_sym_triangle] = ACTIONS(3046),
  },
  [2881] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2881),
    [sym_identifier] = ACTIONS(2915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2913),
    [anon_sym_COMMA] = ACTIONS(2913),
    [anon_sym_RPAREN] = ACTIONS(2913),
    [aux_sym_preproc_if_token2] = ACTIONS(2913),
    [aux_sym_preproc_else_token1] = ACTIONS(2913),
    [aux_sym_preproc_elif_token1] = ACTIONS(2915),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2913),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2913),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2915),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_SLASH] = ACTIONS(2915),
    [anon_sym_PERCENT] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_CARET] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2915),
    [anon_sym_GT_EQ] = ACTIONS(2913),
    [anon_sym_LT_EQ] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2915),
    [anon_sym_LT_LT] = ACTIONS(2913),
    [anon_sym_GT_GT] = ACTIONS(2913),
    [anon_sym_COLON] = ACTIONS(2913),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym___based] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_RBRACE] = ACTIONS(2913),
    [anon_sym_signed] = ACTIONS(7112),
    [anon_sym_unsigned] = ACTIONS(7112),
    [anon_sym_long] = ACTIONS(7112),
    [anon_sym_short] = ACTIONS(7112),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_RBRACK] = ACTIONS(2913),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(2913),
    [anon_sym_LT_EQ_GT] = ACTIONS(2913),
    [anon_sym_or] = ACTIONS(2915),
    [anon_sym_and] = ACTIONS(2915),
    [anon_sym_bitor] = ACTIONS(2915),
    [anon_sym_xor] = ACTIONS(2915),
    [anon_sym_bitand] = ACTIONS(2915),
    [anon_sym_not_eq] = ACTIONS(2915),
    [anon_sym_is] = ACTIONS(2915),
    [anon_sym_as] = ACTIONS(2915),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_DOT] = ACTIONS(2915),
    [anon_sym_DOT_STAR] = ACTIONS(2913),
    [anon_sym_DASH_GT] = ACTIONS(2913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2915),
    [anon_sym_let] = ACTIONS(2915),
    [anon_sym_This] = ACTIONS(2915),
    [anon_sym_final] = ACTIONS(2915),
    [anon_sym_override] = ACTIONS(2915),
    [anon_sym_requires] = ACTIONS(2915),
    [anon_sym_where] = ACTIONS(2915),
  },
  [2882] = {
    [sym_identifier] = ACTIONS(3050),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3048),
    [anon_sym_COMMA] = ACTIONS(3048),
    [anon_sym_RPAREN] = ACTIONS(3048),
    [anon_sym_LPAREN2] = ACTIONS(3048),
    [anon_sym_TILDE] = ACTIONS(3048),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_AMP_AMP] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3050),
    [anon_sym_COLON] = ACTIONS(3050),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym___extension__] = ACTIONS(3050),
    [anon_sym_in] = ACTIONS(3050),
    [anon_sym_out] = ACTIONS(3050),
    [anon_sym_inout] = ACTIONS(3050),
    [anon_sym_virtual] = ACTIONS(3050),
    [anon_sym_extern] = ACTIONS(3050),
    [anon_sym___attribute__] = ACTIONS(3050),
    [anon_sym___attribute] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3048),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3048),
    [anon_sym___declspec] = ACTIONS(3050),
    [anon_sym___based] = ACTIONS(3050),
    [anon_sym___cdecl] = ACTIONS(3050),
    [anon_sym___clrcall] = ACTIONS(3050),
    [anon_sym___stdcall] = ACTIONS(3050),
    [anon_sym___fastcall] = ACTIONS(3050),
    [anon_sym___thiscall] = ACTIONS(3050),
    [anon_sym___vectorcall] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_static] = ACTIONS(3050),
    [anon_sym_EQ] = ACTIONS(3048),
    [anon_sym_register] = ACTIONS(3050),
    [anon_sym_inline] = ACTIONS(3050),
    [anon_sym___inline] = ACTIONS(3050),
    [anon_sym___inline__] = ACTIONS(3050),
    [anon_sym___forceinline] = ACTIONS(3050),
    [anon_sym_thread_local] = ACTIONS(3050),
    [anon_sym___thread] = ACTIONS(3050),
    [anon_sym_const] = ACTIONS(3050),
    [anon_sym_constexpr] = ACTIONS(3050),
    [anon_sym_volatile] = ACTIONS(3050),
    [anon_sym_restrict] = ACTIONS(3050),
    [anon_sym___restrict__] = ACTIONS(3050),
    [anon_sym__Atomic] = ACTIONS(3050),
    [anon_sym__Noreturn] = ACTIONS(3050),
    [anon_sym_noreturn] = ACTIONS(3050),
    [anon_sym__Nonnull] = ACTIONS(3050),
    [anon_sym_mutable] = ACTIONS(3050),
    [anon_sym_constinit] = ACTIONS(3050),
    [anon_sym_consteval] = ACTIONS(3050),
    [anon_sym_alignas] = ACTIONS(3050),
    [anon_sym__Alignas] = ACTIONS(3050),
    [anon_sym_DOT] = ACTIONS(3050),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3050),
    [anon_sym_let] = ACTIONS(3050),
    [anon_sym_This] = ACTIONS(3050),
    [anon_sym_decltype] = ACTIONS(3050),
    [anon_sym_template] = ACTIONS(3050),
    [anon_sym_GT2] = ACTIONS(3048),
    [anon_sym_operator] = ACTIONS(3050),
    [anon_sym_precise] = ACTIONS(3050),
    [anon_sym_shared] = ACTIONS(3050),
    [anon_sym_groupshared] = ACTIONS(3050),
    [anon_sym_uniform] = ACTIONS(3050),
    [anon_sym_row_major] = ACTIONS(3050),
    [anon_sym_column_major] = ACTIONS(3050),
    [anon_sym_globallycoherent] = ACTIONS(3050),
    [anon_sym_centroid] = ACTIONS(3050),
    [anon_sym_noperspective] = ACTIONS(3050),
    [anon_sym_nointerpolation] = ACTIONS(3050),
    [anon_sym_sample] = ACTIONS(3050),
    [anon_sym_linear] = ACTIONS(3050),
    [anon_sym_snorm] = ACTIONS(3050),
    [anon_sym_unorm] = ACTIONS(3050),
    [anon_sym_point] = ACTIONS(3050),
    [anon_sym_line] = ACTIONS(3050),
    [anon_sym_triangleadj] = ACTIONS(3050),
    [anon_sym_lineadj] = ACTIONS(3050),
    [anon_sym_triangle] = ACTIONS(3050),
  },
  [2883] = {
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2976),
    [anon_sym_COMMA] = ACTIONS(2976),
    [anon_sym_RPAREN] = ACTIONS(2976),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_TILDE] = ACTIONS(2976),
    [anon_sym_STAR] = ACTIONS(2976),
    [anon_sym_AMP_AMP] = ACTIONS(2976),
    [anon_sym_AMP] = ACTIONS(2978),
    [anon_sym_COLON] = ACTIONS(2978),
    [anon_sym_SEMI] = ACTIONS(2976),
    [anon_sym___extension__] = ACTIONS(2978),
    [anon_sym_in] = ACTIONS(2978),
    [anon_sym_out] = ACTIONS(2978),
    [anon_sym_inout] = ACTIONS(2978),
    [anon_sym_virtual] = ACTIONS(2978),
    [anon_sym_extern] = ACTIONS(2978),
    [anon_sym___attribute__] = ACTIONS(2978),
    [anon_sym___attribute] = ACTIONS(2978),
    [anon_sym_COLON_COLON] = ACTIONS(2976),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2976),
    [anon_sym___declspec] = ACTIONS(2978),
    [anon_sym___based] = ACTIONS(2978),
    [anon_sym___cdecl] = ACTIONS(2978),
    [anon_sym___clrcall] = ACTIONS(2978),
    [anon_sym___stdcall] = ACTIONS(2978),
    [anon_sym___fastcall] = ACTIONS(2978),
    [anon_sym___thiscall] = ACTIONS(2978),
    [anon_sym___vectorcall] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_static] = ACTIONS(2978),
    [anon_sym_EQ] = ACTIONS(2976),
    [anon_sym_register] = ACTIONS(2978),
    [anon_sym_inline] = ACTIONS(2978),
    [anon_sym___inline] = ACTIONS(2978),
    [anon_sym___inline__] = ACTIONS(2978),
    [anon_sym___forceinline] = ACTIONS(2978),
    [anon_sym_thread_local] = ACTIONS(2978),
    [anon_sym___thread] = ACTIONS(2978),
    [anon_sym_const] = ACTIONS(2978),
    [anon_sym_constexpr] = ACTIONS(2978),
    [anon_sym_volatile] = ACTIONS(2978),
    [anon_sym_restrict] = ACTIONS(2978),
    [anon_sym___restrict__] = ACTIONS(2978),
    [anon_sym__Atomic] = ACTIONS(2978),
    [anon_sym__Noreturn] = ACTIONS(2978),
    [anon_sym_noreturn] = ACTIONS(2978),
    [anon_sym__Nonnull] = ACTIONS(2978),
    [anon_sym_mutable] = ACTIONS(2978),
    [anon_sym_constinit] = ACTIONS(2978),
    [anon_sym_consteval] = ACTIONS(2978),
    [anon_sym_alignas] = ACTIONS(2978),
    [anon_sym__Alignas] = ACTIONS(2978),
    [anon_sym_DOT] = ACTIONS(2978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_This] = ACTIONS(2978),
    [anon_sym_decltype] = ACTIONS(2978),
    [anon_sym_template] = ACTIONS(2978),
    [anon_sym_GT2] = ACTIONS(2976),
    [anon_sym_operator] = ACTIONS(2978),
    [anon_sym_precise] = ACTIONS(2978),
    [anon_sym_shared] = ACTIONS(2978),
    [anon_sym_groupshared] = ACTIONS(2978),
    [anon_sym_uniform] = ACTIONS(2978),
    [anon_sym_row_major] = ACTIONS(2978),
    [anon_sym_column_major] = ACTIONS(2978),
    [anon_sym_globallycoherent] = ACTIONS(2978),
    [anon_sym_centroid] = ACTIONS(2978),
    [anon_sym_noperspective] = ACTIONS(2978),
    [anon_sym_nointerpolation] = ACTIONS(2978),
    [anon_sym_sample] = ACTIONS(2978),
    [anon_sym_linear] = ACTIONS(2978),
    [anon_sym_snorm] = ACTIONS(2978),
    [anon_sym_unorm] = ACTIONS(2978),
    [anon_sym_point] = ACTIONS(2978),
    [anon_sym_line] = ACTIONS(2978),
    [anon_sym_triangleadj] = ACTIONS(2978),
    [anon_sym_lineadj] = ACTIONS(2978),
    [anon_sym_triangle] = ACTIONS(2978),
  },
  [2884] = {
    [sym_argument_list] = STATE(4525),
    [sym_initializer_list] = STATE(4916),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2759),
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2881),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(7115),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2881),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(5321),
    [anon_sym_signed] = ACTIONS(6885),
    [anon_sym_unsigned] = ACTIONS(6885),
    [anon_sym_long] = ACTIONS(6885),
    [anon_sym_short] = ACTIONS(6885),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2881),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
  },
  [2885] = {
    [sym_identifier] = ACTIONS(3022),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3020),
    [anon_sym_COMMA] = ACTIONS(3020),
    [anon_sym_RPAREN] = ACTIONS(3020),
    [anon_sym_LPAREN2] = ACTIONS(3020),
    [anon_sym_TILDE] = ACTIONS(3020),
    [anon_sym_STAR] = ACTIONS(3020),
    [anon_sym_AMP_AMP] = ACTIONS(3020),
    [anon_sym_AMP] = ACTIONS(3022),
    [anon_sym_COLON] = ACTIONS(3022),
    [anon_sym_SEMI] = ACTIONS(3020),
    [anon_sym___extension__] = ACTIONS(3022),
    [anon_sym_in] = ACTIONS(3022),
    [anon_sym_out] = ACTIONS(3022),
    [anon_sym_inout] = ACTIONS(3022),
    [anon_sym_virtual] = ACTIONS(3022),
    [anon_sym_extern] = ACTIONS(3022),
    [anon_sym___attribute__] = ACTIONS(3022),
    [anon_sym___attribute] = ACTIONS(3022),
    [anon_sym_COLON_COLON] = ACTIONS(3020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3020),
    [anon_sym___declspec] = ACTIONS(3022),
    [anon_sym___based] = ACTIONS(3022),
    [anon_sym___cdecl] = ACTIONS(3022),
    [anon_sym___clrcall] = ACTIONS(3022),
    [anon_sym___stdcall] = ACTIONS(3022),
    [anon_sym___fastcall] = ACTIONS(3022),
    [anon_sym___thiscall] = ACTIONS(3022),
    [anon_sym___vectorcall] = ACTIONS(3022),
    [anon_sym_LBRACK] = ACTIONS(3022),
    [anon_sym_static] = ACTIONS(3022),
    [anon_sym_EQ] = ACTIONS(3020),
    [anon_sym_register] = ACTIONS(3022),
    [anon_sym_inline] = ACTIONS(3022),
    [anon_sym___inline] = ACTIONS(3022),
    [anon_sym___inline__] = ACTIONS(3022),
    [anon_sym___forceinline] = ACTIONS(3022),
    [anon_sym_thread_local] = ACTIONS(3022),
    [anon_sym___thread] = ACTIONS(3022),
    [anon_sym_const] = ACTIONS(3022),
    [anon_sym_constexpr] = ACTIONS(3022),
    [anon_sym_volatile] = ACTIONS(3022),
    [anon_sym_restrict] = ACTIONS(3022),
    [anon_sym___restrict__] = ACTIONS(3022),
    [anon_sym__Atomic] = ACTIONS(3022),
    [anon_sym__Noreturn] = ACTIONS(3022),
    [anon_sym_noreturn] = ACTIONS(3022),
    [anon_sym__Nonnull] = ACTIONS(3022),
    [anon_sym_mutable] = ACTIONS(3022),
    [anon_sym_constinit] = ACTIONS(3022),
    [anon_sym_consteval] = ACTIONS(3022),
    [anon_sym_alignas] = ACTIONS(3022),
    [anon_sym__Alignas] = ACTIONS(3022),
    [anon_sym_DOT] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3022),
    [anon_sym_let] = ACTIONS(3022),
    [anon_sym_This] = ACTIONS(3022),
    [anon_sym_decltype] = ACTIONS(3022),
    [anon_sym_template] = ACTIONS(3022),
    [anon_sym_GT2] = ACTIONS(3020),
    [anon_sym_operator] = ACTIONS(3022),
    [anon_sym_precise] = ACTIONS(3022),
    [anon_sym_shared] = ACTIONS(3022),
    [anon_sym_groupshared] = ACTIONS(3022),
    [anon_sym_uniform] = ACTIONS(3022),
    [anon_sym_row_major] = ACTIONS(3022),
    [anon_sym_column_major] = ACTIONS(3022),
    [anon_sym_globallycoherent] = ACTIONS(3022),
    [anon_sym_centroid] = ACTIONS(3022),
    [anon_sym_noperspective] = ACTIONS(3022),
    [anon_sym_nointerpolation] = ACTIONS(3022),
    [anon_sym_sample] = ACTIONS(3022),
    [anon_sym_linear] = ACTIONS(3022),
    [anon_sym_snorm] = ACTIONS(3022),
    [anon_sym_unorm] = ACTIONS(3022),
    [anon_sym_point] = ACTIONS(3022),
    [anon_sym_line] = ACTIONS(3022),
    [anon_sym_triangleadj] = ACTIONS(3022),
    [anon_sym_lineadj] = ACTIONS(3022),
    [anon_sym_triangle] = ACTIONS(3022),
  },
  [2886] = {
    [sym_identifier] = ACTIONS(3014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3012),
    [anon_sym_COMMA] = ACTIONS(3012),
    [anon_sym_RPAREN] = ACTIONS(3012),
    [anon_sym_LPAREN2] = ACTIONS(3012),
    [anon_sym_TILDE] = ACTIONS(3012),
    [anon_sym_STAR] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_COLON] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym___extension__] = ACTIONS(3014),
    [anon_sym_in] = ACTIONS(3014),
    [anon_sym_out] = ACTIONS(3014),
    [anon_sym_inout] = ACTIONS(3014),
    [anon_sym_virtual] = ACTIONS(3014),
    [anon_sym_extern] = ACTIONS(3014),
    [anon_sym___attribute__] = ACTIONS(3014),
    [anon_sym___attribute] = ACTIONS(3014),
    [anon_sym_COLON_COLON] = ACTIONS(3012),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3012),
    [anon_sym___declspec] = ACTIONS(3014),
    [anon_sym___based] = ACTIONS(3014),
    [anon_sym___cdecl] = ACTIONS(3014),
    [anon_sym___clrcall] = ACTIONS(3014),
    [anon_sym___stdcall] = ACTIONS(3014),
    [anon_sym___fastcall] = ACTIONS(3014),
    [anon_sym___thiscall] = ACTIONS(3014),
    [anon_sym___vectorcall] = ACTIONS(3014),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_static] = ACTIONS(3014),
    [anon_sym_EQ] = ACTIONS(3012),
    [anon_sym_register] = ACTIONS(3014),
    [anon_sym_inline] = ACTIONS(3014),
    [anon_sym___inline] = ACTIONS(3014),
    [anon_sym___inline__] = ACTIONS(3014),
    [anon_sym___forceinline] = ACTIONS(3014),
    [anon_sym_thread_local] = ACTIONS(3014),
    [anon_sym___thread] = ACTIONS(3014),
    [anon_sym_const] = ACTIONS(3014),
    [anon_sym_constexpr] = ACTIONS(3014),
    [anon_sym_volatile] = ACTIONS(3014),
    [anon_sym_restrict] = ACTIONS(3014),
    [anon_sym___restrict__] = ACTIONS(3014),
    [anon_sym__Atomic] = ACTIONS(3014),
    [anon_sym__Noreturn] = ACTIONS(3014),
    [anon_sym_noreturn] = ACTIONS(3014),
    [anon_sym__Nonnull] = ACTIONS(3014),
    [anon_sym_mutable] = ACTIONS(3014),
    [anon_sym_constinit] = ACTIONS(3014),
    [anon_sym_consteval] = ACTIONS(3014),
    [anon_sym_alignas] = ACTIONS(3014),
    [anon_sym__Alignas] = ACTIONS(3014),
    [anon_sym_DOT] = ACTIONS(3014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3014),
    [anon_sym_let] = ACTIONS(3014),
    [anon_sym_This] = ACTIONS(3014),
    [anon_sym_decltype] = ACTIONS(3014),
    [anon_sym_template] = ACTIONS(3014),
    [anon_sym_GT2] = ACTIONS(3012),
    [anon_sym_operator] = ACTIONS(3014),
    [anon_sym_precise] = ACTIONS(3014),
    [anon_sym_shared] = ACTIONS(3014),
    [anon_sym_groupshared] = ACTIONS(3014),
    [anon_sym_uniform] = ACTIONS(3014),
    [anon_sym_row_major] = ACTIONS(3014),
    [anon_sym_column_major] = ACTIONS(3014),
    [anon_sym_globallycoherent] = ACTIONS(3014),
    [anon_sym_centroid] = ACTIONS(3014),
    [anon_sym_noperspective] = ACTIONS(3014),
    [anon_sym_nointerpolation] = ACTIONS(3014),
    [anon_sym_sample] = ACTIONS(3014),
    [anon_sym_linear] = ACTIONS(3014),
    [anon_sym_snorm] = ACTIONS(3014),
    [anon_sym_unorm] = ACTIONS(3014),
    [anon_sym_point] = ACTIONS(3014),
    [anon_sym_line] = ACTIONS(3014),
    [anon_sym_triangleadj] = ACTIONS(3014),
    [anon_sym_lineadj] = ACTIONS(3014),
    [anon_sym_triangle] = ACTIONS(3014),
  },
  [2887] = {
    [sym_template_argument_list] = STATE(2722),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2764),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2176),
    [anon_sym_COMMA] = ACTIONS(2176),
    [anon_sym_RPAREN] = ACTIONS(2176),
    [anon_sym_LPAREN2] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2168),
    [anon_sym_LT] = ACTIONS(7118),
    [anon_sym_COLON] = ACTIONS(2168),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2176),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym_signed] = ACTIONS(5332),
    [anon_sym_unsigned] = ACTIONS(5332),
    [anon_sym_long] = ACTIONS(5332),
    [anon_sym_short] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(2168),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_EQ] = ACTIONS(2176),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [anon_sym_DOT] = ACTIONS(2168),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_decltype] = ACTIONS(2168),
    [anon_sym_template] = ACTIONS(2168),
    [anon_sym_GT2] = ACTIONS(2176),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
  },
  [2888] = {
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2881),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2881),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2881),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_GT2] = ACTIONS(2881),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
  },
  [2889] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2878),
    [sym_identifier] = ACTIONS(2915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4121),
    [anon_sym_COMMA] = ACTIONS(4121),
    [anon_sym_LPAREN2] = ACTIONS(4121),
    [anon_sym_DASH] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4124),
    [anon_sym_STAR] = ACTIONS(4124),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_PIPE_PIPE] = ACTIONS(4121),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE] = ACTIONS(4124),
    [anon_sym_CARET] = ACTIONS(4124),
    [anon_sym_AMP] = ACTIONS(4124),
    [anon_sym_EQ_EQ] = ACTIONS(4121),
    [anon_sym_BANG_EQ] = ACTIONS(4121),
    [anon_sym_GT] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4124),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_LT_LT] = ACTIONS(4124),
    [anon_sym_GT_GT] = ACTIONS(4124),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(4124),
    [anon_sym___attribute] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_signed] = ACTIONS(7109),
    [anon_sym_unsigned] = ACTIONS(7109),
    [anon_sym_long] = ACTIONS(7109),
    [anon_sym_short] = ACTIONS(7109),
    [anon_sym_LBRACK] = ACTIONS(4121),
    [anon_sym_EQ] = ACTIONS(4124),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(4121),
    [anon_sym_STAR_EQ] = ACTIONS(4121),
    [anon_sym_SLASH_EQ] = ACTIONS(4121),
    [anon_sym_PERCENT_EQ] = ACTIONS(4121),
    [anon_sym_PLUS_EQ] = ACTIONS(4121),
    [anon_sym_DASH_EQ] = ACTIONS(4121),
    [anon_sym_LT_LT_EQ] = ACTIONS(4121),
    [anon_sym_GT_GT_EQ] = ACTIONS(4124),
    [anon_sym_AMP_EQ] = ACTIONS(4121),
    [anon_sym_CARET_EQ] = ACTIONS(4121),
    [anon_sym_PIPE_EQ] = ACTIONS(4121),
    [anon_sym_and_eq] = ACTIONS(4124),
    [anon_sym_or_eq] = ACTIONS(4124),
    [anon_sym_xor_eq] = ACTIONS(4124),
    [anon_sym_LT_EQ_GT] = ACTIONS(4121),
    [anon_sym_or] = ACTIONS(4124),
    [anon_sym_and] = ACTIONS(4124),
    [anon_sym_bitor] = ACTIONS(4124),
    [anon_sym_xor] = ACTIONS(4124),
    [anon_sym_bitand] = ACTIONS(4124),
    [anon_sym_not_eq] = ACTIONS(4124),
    [anon_sym_is] = ACTIONS(4124),
    [anon_sym_as] = ACTIONS(4124),
    [anon_sym_DASH_DASH] = ACTIONS(4121),
    [anon_sym_PLUS_PLUS] = ACTIONS(4121),
    [anon_sym_DOT] = ACTIONS(4124),
    [anon_sym_DOT_STAR] = ACTIONS(4121),
    [anon_sym_DASH_GT] = ACTIONS(4121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4124),
    [anon_sym_let] = ACTIONS(4124),
    [anon_sym_This] = ACTIONS(4124),
    [anon_sym_GT2] = ACTIONS(4121),
  },
  [2890] = {
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym_typedef] = ACTIONS(7120),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3352),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3362),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3362),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3362),
    [anon_sym_explicit] = ACTIONS(3362),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3362),
    [anon_sym_operator] = ACTIONS(3362),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [2891] = {
    [sym_identifier] = ACTIONS(3042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3040),
    [anon_sym_COMMA] = ACTIONS(3040),
    [anon_sym_RPAREN] = ACTIONS(3040),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_COLON] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym_in] = ACTIONS(3042),
    [anon_sym_out] = ACTIONS(3042),
    [anon_sym_inout] = ACTIONS(3042),
    [anon_sym_virtual] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym___cdecl] = ACTIONS(3042),
    [anon_sym___clrcall] = ACTIONS(3042),
    [anon_sym___stdcall] = ACTIONS(3042),
    [anon_sym___fastcall] = ACTIONS(3042),
    [anon_sym___thiscall] = ACTIONS(3042),
    [anon_sym___vectorcall] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_EQ] = ACTIONS(3040),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym___inline] = ACTIONS(3042),
    [anon_sym___inline__] = ACTIONS(3042),
    [anon_sym___forceinline] = ACTIONS(3042),
    [anon_sym_thread_local] = ACTIONS(3042),
    [anon_sym___thread] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [anon_sym_DOT] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3042),
    [anon_sym_let] = ACTIONS(3042),
    [anon_sym_This] = ACTIONS(3042),
    [anon_sym_decltype] = ACTIONS(3042),
    [anon_sym_template] = ACTIONS(3042),
    [anon_sym_GT2] = ACTIONS(3040),
    [anon_sym_operator] = ACTIONS(3042),
    [anon_sym_precise] = ACTIONS(3042),
    [anon_sym_shared] = ACTIONS(3042),
    [anon_sym_groupshared] = ACTIONS(3042),
    [anon_sym_uniform] = ACTIONS(3042),
    [anon_sym_row_major] = ACTIONS(3042),
    [anon_sym_column_major] = ACTIONS(3042),
    [anon_sym_globallycoherent] = ACTIONS(3042),
    [anon_sym_centroid] = ACTIONS(3042),
    [anon_sym_noperspective] = ACTIONS(3042),
    [anon_sym_nointerpolation] = ACTIONS(3042),
    [anon_sym_sample] = ACTIONS(3042),
    [anon_sym_linear] = ACTIONS(3042),
    [anon_sym_snorm] = ACTIONS(3042),
    [anon_sym_unorm] = ACTIONS(3042),
    [anon_sym_point] = ACTIONS(3042),
    [anon_sym_line] = ACTIONS(3042),
    [anon_sym_triangleadj] = ACTIONS(3042),
    [anon_sym_lineadj] = ACTIONS(3042),
    [anon_sym_triangle] = ACTIONS(3042),
  },
  [2892] = {
    [sym_identifier] = ACTIONS(3042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3040),
    [anon_sym_COMMA] = ACTIONS(3040),
    [anon_sym_RPAREN] = ACTIONS(3040),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_COLON] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym_in] = ACTIONS(3042),
    [anon_sym_out] = ACTIONS(3042),
    [anon_sym_inout] = ACTIONS(3042),
    [anon_sym_virtual] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym___cdecl] = ACTIONS(3042),
    [anon_sym___clrcall] = ACTIONS(3042),
    [anon_sym___stdcall] = ACTIONS(3042),
    [anon_sym___fastcall] = ACTIONS(3042),
    [anon_sym___thiscall] = ACTIONS(3042),
    [anon_sym___vectorcall] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_EQ] = ACTIONS(3040),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym___inline] = ACTIONS(3042),
    [anon_sym___inline__] = ACTIONS(3042),
    [anon_sym___forceinline] = ACTIONS(3042),
    [anon_sym_thread_local] = ACTIONS(3042),
    [anon_sym___thread] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [anon_sym_DOT] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3042),
    [anon_sym_let] = ACTIONS(3042),
    [anon_sym_This] = ACTIONS(3042),
    [anon_sym_decltype] = ACTIONS(3042),
    [anon_sym_template] = ACTIONS(3042),
    [anon_sym_GT2] = ACTIONS(3040),
    [anon_sym_operator] = ACTIONS(3042),
    [anon_sym_precise] = ACTIONS(3042),
    [anon_sym_shared] = ACTIONS(3042),
    [anon_sym_groupshared] = ACTIONS(3042),
    [anon_sym_uniform] = ACTIONS(3042),
    [anon_sym_row_major] = ACTIONS(3042),
    [anon_sym_column_major] = ACTIONS(3042),
    [anon_sym_globallycoherent] = ACTIONS(3042),
    [anon_sym_centroid] = ACTIONS(3042),
    [anon_sym_noperspective] = ACTIONS(3042),
    [anon_sym_nointerpolation] = ACTIONS(3042),
    [anon_sym_sample] = ACTIONS(3042),
    [anon_sym_linear] = ACTIONS(3042),
    [anon_sym_snorm] = ACTIONS(3042),
    [anon_sym_unorm] = ACTIONS(3042),
    [anon_sym_point] = ACTIONS(3042),
    [anon_sym_line] = ACTIONS(3042),
    [anon_sym_triangleadj] = ACTIONS(3042),
    [anon_sym_lineadj] = ACTIONS(3042),
    [anon_sym_triangle] = ACTIONS(3042),
  },
  [2893] = {
    [sym_identifier] = ACTIONS(6895),
    [anon_sym_LPAREN2] = ACTIONS(6897),
    [anon_sym_TILDE] = ACTIONS(6897),
    [anon_sym_STAR] = ACTIONS(6897),
    [anon_sym_AMP_AMP] = ACTIONS(6897),
    [anon_sym_AMP] = ACTIONS(6895),
    [anon_sym___extension__] = ACTIONS(6895),
    [anon_sym_in] = ACTIONS(6895),
    [anon_sym_out] = ACTIONS(6895),
    [anon_sym_inout] = ACTIONS(6895),
    [anon_sym_virtual] = ACTIONS(6895),
    [anon_sym_extern] = ACTIONS(6895),
    [anon_sym___attribute__] = ACTIONS(6895),
    [anon_sym___attribute] = ACTIONS(6895),
    [anon_sym_COLON_COLON] = ACTIONS(6897),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6897),
    [anon_sym___declspec] = ACTIONS(6895),
    [anon_sym___based] = ACTIONS(6895),
    [anon_sym_signed] = ACTIONS(6895),
    [anon_sym_unsigned] = ACTIONS(6895),
    [anon_sym_long] = ACTIONS(6895),
    [anon_sym_short] = ACTIONS(6895),
    [anon_sym_LBRACK] = ACTIONS(6895),
    [anon_sym_static] = ACTIONS(6895),
    [anon_sym_register] = ACTIONS(6895),
    [anon_sym_inline] = ACTIONS(6895),
    [anon_sym___inline] = ACTIONS(6895),
    [anon_sym___inline__] = ACTIONS(6895),
    [anon_sym___forceinline] = ACTIONS(6895),
    [anon_sym_thread_local] = ACTIONS(6895),
    [anon_sym___thread] = ACTIONS(6895),
    [anon_sym_const] = ACTIONS(6895),
    [anon_sym_constexpr] = ACTIONS(6895),
    [anon_sym_volatile] = ACTIONS(6895),
    [anon_sym_restrict] = ACTIONS(6895),
    [anon_sym___restrict__] = ACTIONS(6895),
    [anon_sym__Atomic] = ACTIONS(6895),
    [anon_sym__Noreturn] = ACTIONS(6895),
    [anon_sym_noreturn] = ACTIONS(6895),
    [anon_sym__Nonnull] = ACTIONS(6895),
    [anon_sym_mutable] = ACTIONS(6895),
    [anon_sym_constinit] = ACTIONS(6895),
    [anon_sym_consteval] = ACTIONS(6895),
    [anon_sym_alignas] = ACTIONS(6895),
    [anon_sym__Alignas] = ACTIONS(6895),
    [sym_primitive_type] = ACTIONS(6895),
    [anon_sym_enum] = ACTIONS(6895),
    [anon_sym_class] = ACTIONS(6895),
    [anon_sym_struct] = ACTIONS(6895),
    [anon_sym_union] = ACTIONS(6895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6895),
    [anon_sym_let] = ACTIONS(6895),
    [anon_sym_This] = ACTIONS(6895),
    [anon_sym_decltype] = ACTIONS(6895),
    [anon_sym_explicit] = ACTIONS(6895),
    [anon_sym_typename] = ACTIONS(6895),
    [anon_sym_template] = ACTIONS(6895),
    [anon_sym_operator] = ACTIONS(6895),
    [anon_sym_namespace] = ACTIONS(7122),
    [anon_sym_precise] = ACTIONS(6895),
    [anon_sym_shared] = ACTIONS(6895),
    [anon_sym_groupshared] = ACTIONS(6895),
    [anon_sym_uniform] = ACTIONS(6895),
    [anon_sym_row_major] = ACTIONS(6895),
    [anon_sym_column_major] = ACTIONS(6895),
    [anon_sym_globallycoherent] = ACTIONS(6895),
    [anon_sym_centroid] = ACTIONS(6895),
    [anon_sym_noperspective] = ACTIONS(6895),
    [anon_sym_nointerpolation] = ACTIONS(6895),
    [anon_sym_sample] = ACTIONS(6895),
    [anon_sym_linear] = ACTIONS(6895),
    [anon_sym_snorm] = ACTIONS(6895),
    [anon_sym_unorm] = ACTIONS(6895),
    [anon_sym_point] = ACTIONS(6895),
    [anon_sym_line] = ACTIONS(6895),
    [anon_sym_triangleadj] = ACTIONS(6895),
    [anon_sym_lineadj] = ACTIONS(6895),
    [anon_sym_triangle] = ACTIONS(6895),
    [anon_sym_interface] = ACTIONS(6895),
    [anon_sym_extension] = ACTIONS(6895),
  },
  [2894] = {
    [sym_identifier] = ACTIONS(3018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3016),
    [anon_sym_COMMA] = ACTIONS(3016),
    [anon_sym_RPAREN] = ACTIONS(3016),
    [anon_sym_LPAREN2] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [anon_sym_STAR] = ACTIONS(3016),
    [anon_sym_AMP_AMP] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_COLON] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(3016),
    [anon_sym___extension__] = ACTIONS(3018),
    [anon_sym_in] = ACTIONS(3018),
    [anon_sym_out] = ACTIONS(3018),
    [anon_sym_inout] = ACTIONS(3018),
    [anon_sym_virtual] = ACTIONS(3018),
    [anon_sym_extern] = ACTIONS(3018),
    [anon_sym___attribute__] = ACTIONS(3018),
    [anon_sym___attribute] = ACTIONS(3018),
    [anon_sym_COLON_COLON] = ACTIONS(3016),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3016),
    [anon_sym___declspec] = ACTIONS(3018),
    [anon_sym___based] = ACTIONS(3018),
    [anon_sym___cdecl] = ACTIONS(3018),
    [anon_sym___clrcall] = ACTIONS(3018),
    [anon_sym___stdcall] = ACTIONS(3018),
    [anon_sym___fastcall] = ACTIONS(3018),
    [anon_sym___thiscall] = ACTIONS(3018),
    [anon_sym___vectorcall] = ACTIONS(3018),
    [anon_sym_LBRACK] = ACTIONS(3018),
    [anon_sym_static] = ACTIONS(3018),
    [anon_sym_EQ] = ACTIONS(3016),
    [anon_sym_register] = ACTIONS(3018),
    [anon_sym_inline] = ACTIONS(3018),
    [anon_sym___inline] = ACTIONS(3018),
    [anon_sym___inline__] = ACTIONS(3018),
    [anon_sym___forceinline] = ACTIONS(3018),
    [anon_sym_thread_local] = ACTIONS(3018),
    [anon_sym___thread] = ACTIONS(3018),
    [anon_sym_const] = ACTIONS(3018),
    [anon_sym_constexpr] = ACTIONS(3018),
    [anon_sym_volatile] = ACTIONS(3018),
    [anon_sym_restrict] = ACTIONS(3018),
    [anon_sym___restrict__] = ACTIONS(3018),
    [anon_sym__Atomic] = ACTIONS(3018),
    [anon_sym__Noreturn] = ACTIONS(3018),
    [anon_sym_noreturn] = ACTIONS(3018),
    [anon_sym__Nonnull] = ACTIONS(3018),
    [anon_sym_mutable] = ACTIONS(3018),
    [anon_sym_constinit] = ACTIONS(3018),
    [anon_sym_consteval] = ACTIONS(3018),
    [anon_sym_alignas] = ACTIONS(3018),
    [anon_sym__Alignas] = ACTIONS(3018),
    [anon_sym_DOT] = ACTIONS(3018),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3018),
    [anon_sym_let] = ACTIONS(3018),
    [anon_sym_This] = ACTIONS(3018),
    [anon_sym_decltype] = ACTIONS(3018),
    [anon_sym_template] = ACTIONS(3018),
    [anon_sym_GT2] = ACTIONS(3016),
    [anon_sym_operator] = ACTIONS(3018),
    [anon_sym_precise] = ACTIONS(3018),
    [anon_sym_shared] = ACTIONS(3018),
    [anon_sym_groupshared] = ACTIONS(3018),
    [anon_sym_uniform] = ACTIONS(3018),
    [anon_sym_row_major] = ACTIONS(3018),
    [anon_sym_column_major] = ACTIONS(3018),
    [anon_sym_globallycoherent] = ACTIONS(3018),
    [anon_sym_centroid] = ACTIONS(3018),
    [anon_sym_noperspective] = ACTIONS(3018),
    [anon_sym_nointerpolation] = ACTIONS(3018),
    [anon_sym_sample] = ACTIONS(3018),
    [anon_sym_linear] = ACTIONS(3018),
    [anon_sym_snorm] = ACTIONS(3018),
    [anon_sym_unorm] = ACTIONS(3018),
    [anon_sym_point] = ACTIONS(3018),
    [anon_sym_line] = ACTIONS(3018),
    [anon_sym_triangleadj] = ACTIONS(3018),
    [anon_sym_lineadj] = ACTIONS(3018),
    [anon_sym_triangle] = ACTIONS(3018),
  },
  [2895] = {
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2552),
    [anon_sym_COMMA] = ACTIONS(2552),
    [anon_sym_RPAREN] = ACTIONS(2552),
    [anon_sym_LPAREN2] = ACTIONS(2552),
    [anon_sym_TILDE] = ACTIONS(2552),
    [anon_sym_STAR] = ACTIONS(2552),
    [anon_sym_AMP_AMP] = ACTIONS(2552),
    [anon_sym_AMP] = ACTIONS(2554),
    [anon_sym_COLON] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym___extension__] = ACTIONS(2554),
    [anon_sym_in] = ACTIONS(2554),
    [anon_sym_out] = ACTIONS(2554),
    [anon_sym_inout] = ACTIONS(2554),
    [anon_sym_virtual] = ACTIONS(2554),
    [anon_sym_extern] = ACTIONS(2554),
    [anon_sym___attribute__] = ACTIONS(2554),
    [anon_sym___attribute] = ACTIONS(2554),
    [anon_sym_COLON_COLON] = ACTIONS(2552),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2552),
    [anon_sym___declspec] = ACTIONS(2554),
    [anon_sym___based] = ACTIONS(2554),
    [anon_sym___cdecl] = ACTIONS(2554),
    [anon_sym___clrcall] = ACTIONS(2554),
    [anon_sym___stdcall] = ACTIONS(2554),
    [anon_sym___fastcall] = ACTIONS(2554),
    [anon_sym___thiscall] = ACTIONS(2554),
    [anon_sym___vectorcall] = ACTIONS(2554),
    [anon_sym_LBRACK] = ACTIONS(2554),
    [anon_sym_static] = ACTIONS(2554),
    [anon_sym_EQ] = ACTIONS(2552),
    [anon_sym_register] = ACTIONS(2554),
    [anon_sym_inline] = ACTIONS(2554),
    [anon_sym___inline] = ACTIONS(2554),
    [anon_sym___inline__] = ACTIONS(2554),
    [anon_sym___forceinline] = ACTIONS(2554),
    [anon_sym_thread_local] = ACTIONS(2554),
    [anon_sym___thread] = ACTIONS(2554),
    [anon_sym_const] = ACTIONS(2554),
    [anon_sym_constexpr] = ACTIONS(2554),
    [anon_sym_volatile] = ACTIONS(2554),
    [anon_sym_restrict] = ACTIONS(2554),
    [anon_sym___restrict__] = ACTIONS(2554),
    [anon_sym__Atomic] = ACTIONS(2554),
    [anon_sym__Noreturn] = ACTIONS(2554),
    [anon_sym_noreturn] = ACTIONS(2554),
    [anon_sym__Nonnull] = ACTIONS(2554),
    [anon_sym_mutable] = ACTIONS(2554),
    [anon_sym_constinit] = ACTIONS(2554),
    [anon_sym_consteval] = ACTIONS(2554),
    [anon_sym_alignas] = ACTIONS(2554),
    [anon_sym__Alignas] = ACTIONS(2554),
    [anon_sym_DOT] = ACTIONS(2554),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2554),
    [anon_sym_let] = ACTIONS(2554),
    [anon_sym_This] = ACTIONS(2554),
    [anon_sym_decltype] = ACTIONS(2554),
    [anon_sym_template] = ACTIONS(2554),
    [anon_sym_GT2] = ACTIONS(2552),
    [anon_sym_operator] = ACTIONS(2554),
    [anon_sym_precise] = ACTIONS(2554),
    [anon_sym_shared] = ACTIONS(2554),
    [anon_sym_groupshared] = ACTIONS(2554),
    [anon_sym_uniform] = ACTIONS(2554),
    [anon_sym_row_major] = ACTIONS(2554),
    [anon_sym_column_major] = ACTIONS(2554),
    [anon_sym_globallycoherent] = ACTIONS(2554),
    [anon_sym_centroid] = ACTIONS(2554),
    [anon_sym_noperspective] = ACTIONS(2554),
    [anon_sym_nointerpolation] = ACTIONS(2554),
    [anon_sym_sample] = ACTIONS(2554),
    [anon_sym_linear] = ACTIONS(2554),
    [anon_sym_snorm] = ACTIONS(2554),
    [anon_sym_unorm] = ACTIONS(2554),
    [anon_sym_point] = ACTIONS(2554),
    [anon_sym_line] = ACTIONS(2554),
    [anon_sym_triangleadj] = ACTIONS(2554),
    [anon_sym_lineadj] = ACTIONS(2554),
    [anon_sym_triangle] = ACTIONS(2554),
  },
  [2896] = {
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2932),
    [anon_sym_COMMA] = ACTIONS(2932),
    [anon_sym_RPAREN] = ACTIONS(2932),
    [anon_sym_LPAREN2] = ACTIONS(2932),
    [anon_sym_TILDE] = ACTIONS(2932),
    [anon_sym_STAR] = ACTIONS(2932),
    [anon_sym_AMP_AMP] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_COLON] = ACTIONS(2934),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym___extension__] = ACTIONS(2934),
    [anon_sym_in] = ACTIONS(2934),
    [anon_sym_out] = ACTIONS(2934),
    [anon_sym_inout] = ACTIONS(2934),
    [anon_sym_virtual] = ACTIONS(2934),
    [anon_sym_extern] = ACTIONS(2934),
    [anon_sym___attribute__] = ACTIONS(2934),
    [anon_sym___attribute] = ACTIONS(2934),
    [anon_sym_COLON_COLON] = ACTIONS(2932),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2932),
    [anon_sym___declspec] = ACTIONS(2934),
    [anon_sym___based] = ACTIONS(2934),
    [anon_sym___cdecl] = ACTIONS(2934),
    [anon_sym___clrcall] = ACTIONS(2934),
    [anon_sym___stdcall] = ACTIONS(2934),
    [anon_sym___fastcall] = ACTIONS(2934),
    [anon_sym___thiscall] = ACTIONS(2934),
    [anon_sym___vectorcall] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [anon_sym_static] = ACTIONS(2934),
    [anon_sym_EQ] = ACTIONS(2932),
    [anon_sym_register] = ACTIONS(2934),
    [anon_sym_inline] = ACTIONS(2934),
    [anon_sym___inline] = ACTIONS(2934),
    [anon_sym___inline__] = ACTIONS(2934),
    [anon_sym___forceinline] = ACTIONS(2934),
    [anon_sym_thread_local] = ACTIONS(2934),
    [anon_sym___thread] = ACTIONS(2934),
    [anon_sym_const] = ACTIONS(2934),
    [anon_sym_constexpr] = ACTIONS(2934),
    [anon_sym_volatile] = ACTIONS(2934),
    [anon_sym_restrict] = ACTIONS(2934),
    [anon_sym___restrict__] = ACTIONS(2934),
    [anon_sym__Atomic] = ACTIONS(2934),
    [anon_sym__Noreturn] = ACTIONS(2934),
    [anon_sym_noreturn] = ACTIONS(2934),
    [anon_sym__Nonnull] = ACTIONS(2934),
    [anon_sym_mutable] = ACTIONS(2934),
    [anon_sym_constinit] = ACTIONS(2934),
    [anon_sym_consteval] = ACTIONS(2934),
    [anon_sym_alignas] = ACTIONS(2934),
    [anon_sym__Alignas] = ACTIONS(2934),
    [anon_sym_DOT] = ACTIONS(2934),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_This] = ACTIONS(2934),
    [anon_sym_decltype] = ACTIONS(2934),
    [anon_sym_template] = ACTIONS(2934),
    [anon_sym_GT2] = ACTIONS(2932),
    [anon_sym_operator] = ACTIONS(2934),
    [anon_sym_precise] = ACTIONS(2934),
    [anon_sym_shared] = ACTIONS(2934),
    [anon_sym_groupshared] = ACTIONS(2934),
    [anon_sym_uniform] = ACTIONS(2934),
    [anon_sym_row_major] = ACTIONS(2934),
    [anon_sym_column_major] = ACTIONS(2934),
    [anon_sym_globallycoherent] = ACTIONS(2934),
    [anon_sym_centroid] = ACTIONS(2934),
    [anon_sym_noperspective] = ACTIONS(2934),
    [anon_sym_nointerpolation] = ACTIONS(2934),
    [anon_sym_sample] = ACTIONS(2934),
    [anon_sym_linear] = ACTIONS(2934),
    [anon_sym_snorm] = ACTIONS(2934),
    [anon_sym_unorm] = ACTIONS(2934),
    [anon_sym_point] = ACTIONS(2934),
    [anon_sym_line] = ACTIONS(2934),
    [anon_sym_triangleadj] = ACTIONS(2934),
    [anon_sym_lineadj] = ACTIONS(2934),
    [anon_sym_triangle] = ACTIONS(2934),
  },
  [2897] = {
    [sym_identifier] = ACTIONS(2938),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_RPAREN] = ACTIONS(2936),
    [anon_sym_LPAREN2] = ACTIONS(2936),
    [anon_sym_TILDE] = ACTIONS(2936),
    [anon_sym_STAR] = ACTIONS(2936),
    [anon_sym_AMP_AMP] = ACTIONS(2936),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_COLON] = ACTIONS(2938),
    [anon_sym_SEMI] = ACTIONS(2936),
    [anon_sym___extension__] = ACTIONS(2938),
    [anon_sym_in] = ACTIONS(2938),
    [anon_sym_out] = ACTIONS(2938),
    [anon_sym_inout] = ACTIONS(2938),
    [anon_sym_virtual] = ACTIONS(2938),
    [anon_sym_extern] = ACTIONS(2938),
    [anon_sym___attribute__] = ACTIONS(2938),
    [anon_sym___attribute] = ACTIONS(2938),
    [anon_sym_COLON_COLON] = ACTIONS(2936),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2936),
    [anon_sym___declspec] = ACTIONS(2938),
    [anon_sym___based] = ACTIONS(2938),
    [anon_sym___cdecl] = ACTIONS(2938),
    [anon_sym___clrcall] = ACTIONS(2938),
    [anon_sym___stdcall] = ACTIONS(2938),
    [anon_sym___fastcall] = ACTIONS(2938),
    [anon_sym___thiscall] = ACTIONS(2938),
    [anon_sym___vectorcall] = ACTIONS(2938),
    [anon_sym_LBRACK] = ACTIONS(2938),
    [anon_sym_static] = ACTIONS(2938),
    [anon_sym_EQ] = ACTIONS(2936),
    [anon_sym_register] = ACTIONS(2938),
    [anon_sym_inline] = ACTIONS(2938),
    [anon_sym___inline] = ACTIONS(2938),
    [anon_sym___inline__] = ACTIONS(2938),
    [anon_sym___forceinline] = ACTIONS(2938),
    [anon_sym_thread_local] = ACTIONS(2938),
    [anon_sym___thread] = ACTIONS(2938),
    [anon_sym_const] = ACTIONS(2938),
    [anon_sym_constexpr] = ACTIONS(2938),
    [anon_sym_volatile] = ACTIONS(2938),
    [anon_sym_restrict] = ACTIONS(2938),
    [anon_sym___restrict__] = ACTIONS(2938),
    [anon_sym__Atomic] = ACTIONS(2938),
    [anon_sym__Noreturn] = ACTIONS(2938),
    [anon_sym_noreturn] = ACTIONS(2938),
    [anon_sym__Nonnull] = ACTIONS(2938),
    [anon_sym_mutable] = ACTIONS(2938),
    [anon_sym_constinit] = ACTIONS(2938),
    [anon_sym_consteval] = ACTIONS(2938),
    [anon_sym_alignas] = ACTIONS(2938),
    [anon_sym__Alignas] = ACTIONS(2938),
    [anon_sym_DOT] = ACTIONS(2938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2938),
    [anon_sym_let] = ACTIONS(2938),
    [anon_sym_This] = ACTIONS(2938),
    [anon_sym_decltype] = ACTIONS(2938),
    [anon_sym_template] = ACTIONS(2938),
    [anon_sym_GT2] = ACTIONS(2936),
    [anon_sym_operator] = ACTIONS(2938),
    [anon_sym_precise] = ACTIONS(2938),
    [anon_sym_shared] = ACTIONS(2938),
    [anon_sym_groupshared] = ACTIONS(2938),
    [anon_sym_uniform] = ACTIONS(2938),
    [anon_sym_row_major] = ACTIONS(2938),
    [anon_sym_column_major] = ACTIONS(2938),
    [anon_sym_globallycoherent] = ACTIONS(2938),
    [anon_sym_centroid] = ACTIONS(2938),
    [anon_sym_noperspective] = ACTIONS(2938),
    [anon_sym_nointerpolation] = ACTIONS(2938),
    [anon_sym_sample] = ACTIONS(2938),
    [anon_sym_linear] = ACTIONS(2938),
    [anon_sym_snorm] = ACTIONS(2938),
    [anon_sym_unorm] = ACTIONS(2938),
    [anon_sym_point] = ACTIONS(2938),
    [anon_sym_line] = ACTIONS(2938),
    [anon_sym_triangleadj] = ACTIONS(2938),
    [anon_sym_lineadj] = ACTIONS(2938),
    [anon_sym_triangle] = ACTIONS(2938),
  },
  [2898] = {
    [sym_identifier] = ACTIONS(2942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2940),
    [anon_sym_COMMA] = ACTIONS(2940),
    [anon_sym_RPAREN] = ACTIONS(2940),
    [anon_sym_LPAREN2] = ACTIONS(2940),
    [anon_sym_TILDE] = ACTIONS(2940),
    [anon_sym_STAR] = ACTIONS(2940),
    [anon_sym_AMP_AMP] = ACTIONS(2940),
    [anon_sym_AMP] = ACTIONS(2942),
    [anon_sym_COLON] = ACTIONS(2942),
    [anon_sym_SEMI] = ACTIONS(2940),
    [anon_sym___extension__] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_out] = ACTIONS(2942),
    [anon_sym_inout] = ACTIONS(2942),
    [anon_sym_virtual] = ACTIONS(2942),
    [anon_sym_extern] = ACTIONS(2942),
    [anon_sym___attribute__] = ACTIONS(2942),
    [anon_sym___attribute] = ACTIONS(2942),
    [anon_sym_COLON_COLON] = ACTIONS(2940),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2940),
    [anon_sym___declspec] = ACTIONS(2942),
    [anon_sym___based] = ACTIONS(2942),
    [anon_sym___cdecl] = ACTIONS(2942),
    [anon_sym___clrcall] = ACTIONS(2942),
    [anon_sym___stdcall] = ACTIONS(2942),
    [anon_sym___fastcall] = ACTIONS(2942),
    [anon_sym___thiscall] = ACTIONS(2942),
    [anon_sym___vectorcall] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(2942),
    [anon_sym_static] = ACTIONS(2942),
    [anon_sym_EQ] = ACTIONS(2940),
    [anon_sym_register] = ACTIONS(2942),
    [anon_sym_inline] = ACTIONS(2942),
    [anon_sym___inline] = ACTIONS(2942),
    [anon_sym___inline__] = ACTIONS(2942),
    [anon_sym___forceinline] = ACTIONS(2942),
    [anon_sym_thread_local] = ACTIONS(2942),
    [anon_sym___thread] = ACTIONS(2942),
    [anon_sym_const] = ACTIONS(2942),
    [anon_sym_constexpr] = ACTIONS(2942),
    [anon_sym_volatile] = ACTIONS(2942),
    [anon_sym_restrict] = ACTIONS(2942),
    [anon_sym___restrict__] = ACTIONS(2942),
    [anon_sym__Atomic] = ACTIONS(2942),
    [anon_sym__Noreturn] = ACTIONS(2942),
    [anon_sym_noreturn] = ACTIONS(2942),
    [anon_sym__Nonnull] = ACTIONS(2942),
    [anon_sym_mutable] = ACTIONS(2942),
    [anon_sym_constinit] = ACTIONS(2942),
    [anon_sym_consteval] = ACTIONS(2942),
    [anon_sym_alignas] = ACTIONS(2942),
    [anon_sym__Alignas] = ACTIONS(2942),
    [anon_sym_DOT] = ACTIONS(2942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2942),
    [anon_sym_let] = ACTIONS(2942),
    [anon_sym_This] = ACTIONS(2942),
    [anon_sym_decltype] = ACTIONS(2942),
    [anon_sym_template] = ACTIONS(2942),
    [anon_sym_GT2] = ACTIONS(2940),
    [anon_sym_operator] = ACTIONS(2942),
    [anon_sym_precise] = ACTIONS(2942),
    [anon_sym_shared] = ACTIONS(2942),
    [anon_sym_groupshared] = ACTIONS(2942),
    [anon_sym_uniform] = ACTIONS(2942),
    [anon_sym_row_major] = ACTIONS(2942),
    [anon_sym_column_major] = ACTIONS(2942),
    [anon_sym_globallycoherent] = ACTIONS(2942),
    [anon_sym_centroid] = ACTIONS(2942),
    [anon_sym_noperspective] = ACTIONS(2942),
    [anon_sym_nointerpolation] = ACTIONS(2942),
    [anon_sym_sample] = ACTIONS(2942),
    [anon_sym_linear] = ACTIONS(2942),
    [anon_sym_snorm] = ACTIONS(2942),
    [anon_sym_unorm] = ACTIONS(2942),
    [anon_sym_point] = ACTIONS(2942),
    [anon_sym_line] = ACTIONS(2942),
    [anon_sym_triangleadj] = ACTIONS(2942),
    [anon_sym_lineadj] = ACTIONS(2942),
    [anon_sym_triangle] = ACTIONS(2942),
  },
  [2899] = {
    [sym_identifier] = ACTIONS(2994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(2992),
    [anon_sym_RPAREN] = ACTIONS(2992),
    [anon_sym_LPAREN2] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2992),
    [anon_sym_STAR] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_AMP] = ACTIONS(2994),
    [anon_sym_COLON] = ACTIONS(2994),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym___extension__] = ACTIONS(2994),
    [anon_sym_in] = ACTIONS(2994),
    [anon_sym_out] = ACTIONS(2994),
    [anon_sym_inout] = ACTIONS(2994),
    [anon_sym_virtual] = ACTIONS(2994),
    [anon_sym_extern] = ACTIONS(2994),
    [anon_sym___attribute__] = ACTIONS(2994),
    [anon_sym___attribute] = ACTIONS(2994),
    [anon_sym_COLON_COLON] = ACTIONS(2992),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2992),
    [anon_sym___declspec] = ACTIONS(2994),
    [anon_sym___based] = ACTIONS(2994),
    [anon_sym___cdecl] = ACTIONS(2994),
    [anon_sym___clrcall] = ACTIONS(2994),
    [anon_sym___stdcall] = ACTIONS(2994),
    [anon_sym___fastcall] = ACTIONS(2994),
    [anon_sym___thiscall] = ACTIONS(2994),
    [anon_sym___vectorcall] = ACTIONS(2994),
    [anon_sym_LBRACK] = ACTIONS(2994),
    [anon_sym_static] = ACTIONS(2994),
    [anon_sym_EQ] = ACTIONS(2992),
    [anon_sym_register] = ACTIONS(2994),
    [anon_sym_inline] = ACTIONS(2994),
    [anon_sym___inline] = ACTIONS(2994),
    [anon_sym___inline__] = ACTIONS(2994),
    [anon_sym___forceinline] = ACTIONS(2994),
    [anon_sym_thread_local] = ACTIONS(2994),
    [anon_sym___thread] = ACTIONS(2994),
    [anon_sym_const] = ACTIONS(2994),
    [anon_sym_constexpr] = ACTIONS(2994),
    [anon_sym_volatile] = ACTIONS(2994),
    [anon_sym_restrict] = ACTIONS(2994),
    [anon_sym___restrict__] = ACTIONS(2994),
    [anon_sym__Atomic] = ACTIONS(2994),
    [anon_sym__Noreturn] = ACTIONS(2994),
    [anon_sym_noreturn] = ACTIONS(2994),
    [anon_sym__Nonnull] = ACTIONS(2994),
    [anon_sym_mutable] = ACTIONS(2994),
    [anon_sym_constinit] = ACTIONS(2994),
    [anon_sym_consteval] = ACTIONS(2994),
    [anon_sym_alignas] = ACTIONS(2994),
    [anon_sym__Alignas] = ACTIONS(2994),
    [anon_sym_DOT] = ACTIONS(2994),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2994),
    [anon_sym_let] = ACTIONS(2994),
    [anon_sym_This] = ACTIONS(2994),
    [anon_sym_decltype] = ACTIONS(2994),
    [anon_sym_template] = ACTIONS(2994),
    [anon_sym_GT2] = ACTIONS(2992),
    [anon_sym_operator] = ACTIONS(2994),
    [anon_sym_precise] = ACTIONS(2994),
    [anon_sym_shared] = ACTIONS(2994),
    [anon_sym_groupshared] = ACTIONS(2994),
    [anon_sym_uniform] = ACTIONS(2994),
    [anon_sym_row_major] = ACTIONS(2994),
    [anon_sym_column_major] = ACTIONS(2994),
    [anon_sym_globallycoherent] = ACTIONS(2994),
    [anon_sym_centroid] = ACTIONS(2994),
    [anon_sym_noperspective] = ACTIONS(2994),
    [anon_sym_nointerpolation] = ACTIONS(2994),
    [anon_sym_sample] = ACTIONS(2994),
    [anon_sym_linear] = ACTIONS(2994),
    [anon_sym_snorm] = ACTIONS(2994),
    [anon_sym_unorm] = ACTIONS(2994),
    [anon_sym_point] = ACTIONS(2994),
    [anon_sym_line] = ACTIONS(2994),
    [anon_sym_triangleadj] = ACTIONS(2994),
    [anon_sym_lineadj] = ACTIONS(2994),
    [anon_sym_triangle] = ACTIONS(2994),
  },
  [2900] = {
    [sym_identifier] = ACTIONS(2998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2996),
    [anon_sym_COMMA] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(2996),
    [anon_sym_LPAREN2] = ACTIONS(2996),
    [anon_sym_TILDE] = ACTIONS(2996),
    [anon_sym_STAR] = ACTIONS(2996),
    [anon_sym_AMP_AMP] = ACTIONS(2996),
    [anon_sym_AMP] = ACTIONS(2998),
    [anon_sym_COLON] = ACTIONS(2998),
    [anon_sym_SEMI] = ACTIONS(2996),
    [anon_sym___extension__] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(2998),
    [anon_sym_out] = ACTIONS(2998),
    [anon_sym_inout] = ACTIONS(2998),
    [anon_sym_virtual] = ACTIONS(2998),
    [anon_sym_extern] = ACTIONS(2998),
    [anon_sym___attribute__] = ACTIONS(2998),
    [anon_sym___attribute] = ACTIONS(2998),
    [anon_sym_COLON_COLON] = ACTIONS(2996),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2996),
    [anon_sym___declspec] = ACTIONS(2998),
    [anon_sym___based] = ACTIONS(2998),
    [anon_sym___cdecl] = ACTIONS(2998),
    [anon_sym___clrcall] = ACTIONS(2998),
    [anon_sym___stdcall] = ACTIONS(2998),
    [anon_sym___fastcall] = ACTIONS(2998),
    [anon_sym___thiscall] = ACTIONS(2998),
    [anon_sym___vectorcall] = ACTIONS(2998),
    [anon_sym_LBRACK] = ACTIONS(2998),
    [anon_sym_static] = ACTIONS(2998),
    [anon_sym_EQ] = ACTIONS(2996),
    [anon_sym_register] = ACTIONS(2998),
    [anon_sym_inline] = ACTIONS(2998),
    [anon_sym___inline] = ACTIONS(2998),
    [anon_sym___inline__] = ACTIONS(2998),
    [anon_sym___forceinline] = ACTIONS(2998),
    [anon_sym_thread_local] = ACTIONS(2998),
    [anon_sym___thread] = ACTIONS(2998),
    [anon_sym_const] = ACTIONS(2998),
    [anon_sym_constexpr] = ACTIONS(2998),
    [anon_sym_volatile] = ACTIONS(2998),
    [anon_sym_restrict] = ACTIONS(2998),
    [anon_sym___restrict__] = ACTIONS(2998),
    [anon_sym__Atomic] = ACTIONS(2998),
    [anon_sym__Noreturn] = ACTIONS(2998),
    [anon_sym_noreturn] = ACTIONS(2998),
    [anon_sym__Nonnull] = ACTIONS(2998),
    [anon_sym_mutable] = ACTIONS(2998),
    [anon_sym_constinit] = ACTIONS(2998),
    [anon_sym_consteval] = ACTIONS(2998),
    [anon_sym_alignas] = ACTIONS(2998),
    [anon_sym__Alignas] = ACTIONS(2998),
    [anon_sym_DOT] = ACTIONS(2998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2998),
    [anon_sym_let] = ACTIONS(2998),
    [anon_sym_This] = ACTIONS(2998),
    [anon_sym_decltype] = ACTIONS(2998),
    [anon_sym_template] = ACTIONS(2998),
    [anon_sym_GT2] = ACTIONS(2996),
    [anon_sym_operator] = ACTIONS(2998),
    [anon_sym_precise] = ACTIONS(2998),
    [anon_sym_shared] = ACTIONS(2998),
    [anon_sym_groupshared] = ACTIONS(2998),
    [anon_sym_uniform] = ACTIONS(2998),
    [anon_sym_row_major] = ACTIONS(2998),
    [anon_sym_column_major] = ACTIONS(2998),
    [anon_sym_globallycoherent] = ACTIONS(2998),
    [anon_sym_centroid] = ACTIONS(2998),
    [anon_sym_noperspective] = ACTIONS(2998),
    [anon_sym_nointerpolation] = ACTIONS(2998),
    [anon_sym_sample] = ACTIONS(2998),
    [anon_sym_linear] = ACTIONS(2998),
    [anon_sym_snorm] = ACTIONS(2998),
    [anon_sym_unorm] = ACTIONS(2998),
    [anon_sym_point] = ACTIONS(2998),
    [anon_sym_line] = ACTIONS(2998),
    [anon_sym_triangleadj] = ACTIONS(2998),
    [anon_sym_lineadj] = ACTIONS(2998),
    [anon_sym_triangle] = ACTIONS(2998),
  },
  [2901] = {
    [sym_identifier] = ACTIONS(2982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2980),
    [anon_sym_COMMA] = ACTIONS(2980),
    [anon_sym_RPAREN] = ACTIONS(2980),
    [anon_sym_LPAREN2] = ACTIONS(2980),
    [anon_sym_TILDE] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2980),
    [anon_sym_AMP_AMP] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_COLON] = ACTIONS(2982),
    [anon_sym_SEMI] = ACTIONS(2980),
    [anon_sym___extension__] = ACTIONS(2982),
    [anon_sym_in] = ACTIONS(2982),
    [anon_sym_out] = ACTIONS(2982),
    [anon_sym_inout] = ACTIONS(2982),
    [anon_sym_virtual] = ACTIONS(2982),
    [anon_sym_extern] = ACTIONS(2982),
    [anon_sym___attribute__] = ACTIONS(2982),
    [anon_sym___attribute] = ACTIONS(2982),
    [anon_sym_COLON_COLON] = ACTIONS(2980),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2980),
    [anon_sym___declspec] = ACTIONS(2982),
    [anon_sym___based] = ACTIONS(2982),
    [anon_sym___cdecl] = ACTIONS(2982),
    [anon_sym___clrcall] = ACTIONS(2982),
    [anon_sym___stdcall] = ACTIONS(2982),
    [anon_sym___fastcall] = ACTIONS(2982),
    [anon_sym___thiscall] = ACTIONS(2982),
    [anon_sym___vectorcall] = ACTIONS(2982),
    [anon_sym_LBRACK] = ACTIONS(2982),
    [anon_sym_static] = ACTIONS(2982),
    [anon_sym_EQ] = ACTIONS(2980),
    [anon_sym_register] = ACTIONS(2982),
    [anon_sym_inline] = ACTIONS(2982),
    [anon_sym___inline] = ACTIONS(2982),
    [anon_sym___inline__] = ACTIONS(2982),
    [anon_sym___forceinline] = ACTIONS(2982),
    [anon_sym_thread_local] = ACTIONS(2982),
    [anon_sym___thread] = ACTIONS(2982),
    [anon_sym_const] = ACTIONS(2982),
    [anon_sym_constexpr] = ACTIONS(2982),
    [anon_sym_volatile] = ACTIONS(2982),
    [anon_sym_restrict] = ACTIONS(2982),
    [anon_sym___restrict__] = ACTIONS(2982),
    [anon_sym__Atomic] = ACTIONS(2982),
    [anon_sym__Noreturn] = ACTIONS(2982),
    [anon_sym_noreturn] = ACTIONS(2982),
    [anon_sym__Nonnull] = ACTIONS(2982),
    [anon_sym_mutable] = ACTIONS(2982),
    [anon_sym_constinit] = ACTIONS(2982),
    [anon_sym_consteval] = ACTIONS(2982),
    [anon_sym_alignas] = ACTIONS(2982),
    [anon_sym__Alignas] = ACTIONS(2982),
    [anon_sym_DOT] = ACTIONS(2982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2982),
    [anon_sym_let] = ACTIONS(2982),
    [anon_sym_This] = ACTIONS(2982),
    [anon_sym_decltype] = ACTIONS(2982),
    [anon_sym_template] = ACTIONS(2982),
    [anon_sym_GT2] = ACTIONS(2980),
    [anon_sym_operator] = ACTIONS(2982),
    [anon_sym_precise] = ACTIONS(2982),
    [anon_sym_shared] = ACTIONS(2982),
    [anon_sym_groupshared] = ACTIONS(2982),
    [anon_sym_uniform] = ACTIONS(2982),
    [anon_sym_row_major] = ACTIONS(2982),
    [anon_sym_column_major] = ACTIONS(2982),
    [anon_sym_globallycoherent] = ACTIONS(2982),
    [anon_sym_centroid] = ACTIONS(2982),
    [anon_sym_noperspective] = ACTIONS(2982),
    [anon_sym_nointerpolation] = ACTIONS(2982),
    [anon_sym_sample] = ACTIONS(2982),
    [anon_sym_linear] = ACTIONS(2982),
    [anon_sym_snorm] = ACTIONS(2982),
    [anon_sym_unorm] = ACTIONS(2982),
    [anon_sym_point] = ACTIONS(2982),
    [anon_sym_line] = ACTIONS(2982),
    [anon_sym_triangleadj] = ACTIONS(2982),
    [anon_sym_lineadj] = ACTIONS(2982),
    [anon_sym_triangle] = ACTIONS(2982),
  },
  [2902] = {
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym_typedef] = ACTIONS(7124),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_out] = ACTIONS(3362),
    [anon_sym_inout] = ACTIONS(3362),
    [anon_sym_virtual] = ACTIONS(3362),
    [anon_sym_extern] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3352),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3352),
    [anon_sym___declspec] = ACTIONS(3362),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3362),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_register] = ACTIONS(3362),
    [anon_sym_inline] = ACTIONS(3362),
    [anon_sym___inline] = ACTIONS(3362),
    [anon_sym___inline__] = ACTIONS(3362),
    [anon_sym___forceinline] = ACTIONS(3362),
    [anon_sym_thread_local] = ACTIONS(3362),
    [anon_sym___thread] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3362),
    [anon_sym_enum] = ACTIONS(3362),
    [anon_sym_class] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3362),
    [anon_sym_union] = ACTIONS(3362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_decltype] = ACTIONS(3362),
    [anon_sym_explicit] = ACTIONS(3362),
    [anon_sym_typename] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3362),
    [anon_sym_operator] = ACTIONS(3362),
    [anon_sym_precise] = ACTIONS(3362),
    [anon_sym_shared] = ACTIONS(3362),
    [anon_sym_groupshared] = ACTIONS(3362),
    [anon_sym_uniform] = ACTIONS(3362),
    [anon_sym_row_major] = ACTIONS(3362),
    [anon_sym_column_major] = ACTIONS(3362),
    [anon_sym_globallycoherent] = ACTIONS(3362),
    [anon_sym_centroid] = ACTIONS(3362),
    [anon_sym_noperspective] = ACTIONS(3362),
    [anon_sym_nointerpolation] = ACTIONS(3362),
    [anon_sym_sample] = ACTIONS(3362),
    [anon_sym_linear] = ACTIONS(3362),
    [anon_sym_snorm] = ACTIONS(3362),
    [anon_sym_unorm] = ACTIONS(3362),
    [anon_sym_point] = ACTIONS(3362),
    [anon_sym_line] = ACTIONS(3362),
    [anon_sym_triangleadj] = ACTIONS(3362),
    [anon_sym_lineadj] = ACTIONS(3362),
    [anon_sym_triangle] = ACTIONS(3362),
    [anon_sym_interface] = ACTIONS(3362),
    [anon_sym_extension] = ACTIONS(3362),
  },
  [2903] = {
    [sym_identifier] = ACTIONS(3058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3056),
    [anon_sym_COMMA] = ACTIONS(3056),
    [anon_sym_RPAREN] = ACTIONS(3056),
    [anon_sym_LPAREN2] = ACTIONS(3056),
    [anon_sym_TILDE] = ACTIONS(3056),
    [anon_sym_STAR] = ACTIONS(3056),
    [anon_sym_AMP_AMP] = ACTIONS(3056),
    [anon_sym_AMP] = ACTIONS(3058),
    [anon_sym_COLON] = ACTIONS(3058),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym___extension__] = ACTIONS(3058),
    [anon_sym_in] = ACTIONS(3058),
    [anon_sym_out] = ACTIONS(3058),
    [anon_sym_inout] = ACTIONS(3058),
    [anon_sym_virtual] = ACTIONS(3058),
    [anon_sym_extern] = ACTIONS(3058),
    [anon_sym___attribute__] = ACTIONS(3058),
    [anon_sym___attribute] = ACTIONS(3058),
    [anon_sym_COLON_COLON] = ACTIONS(3056),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3056),
    [anon_sym___declspec] = ACTIONS(3058),
    [anon_sym___based] = ACTIONS(3058),
    [anon_sym___cdecl] = ACTIONS(3058),
    [anon_sym___clrcall] = ACTIONS(3058),
    [anon_sym___stdcall] = ACTIONS(3058),
    [anon_sym___fastcall] = ACTIONS(3058),
    [anon_sym___thiscall] = ACTIONS(3058),
    [anon_sym___vectorcall] = ACTIONS(3058),
    [anon_sym_LBRACK] = ACTIONS(3058),
    [anon_sym_static] = ACTIONS(3058),
    [anon_sym_EQ] = ACTIONS(3056),
    [anon_sym_register] = ACTIONS(3058),
    [anon_sym_inline] = ACTIONS(3058),
    [anon_sym___inline] = ACTIONS(3058),
    [anon_sym___inline__] = ACTIONS(3058),
    [anon_sym___forceinline] = ACTIONS(3058),
    [anon_sym_thread_local] = ACTIONS(3058),
    [anon_sym___thread] = ACTIONS(3058),
    [anon_sym_const] = ACTIONS(3058),
    [anon_sym_constexpr] = ACTIONS(3058),
    [anon_sym_volatile] = ACTIONS(3058),
    [anon_sym_restrict] = ACTIONS(3058),
    [anon_sym___restrict__] = ACTIONS(3058),
    [anon_sym__Atomic] = ACTIONS(3058),
    [anon_sym__Noreturn] = ACTIONS(3058),
    [anon_sym_noreturn] = ACTIONS(3058),
    [anon_sym__Nonnull] = ACTIONS(3058),
    [anon_sym_mutable] = ACTIONS(3058),
    [anon_sym_constinit] = ACTIONS(3058),
    [anon_sym_consteval] = ACTIONS(3058),
    [anon_sym_alignas] = ACTIONS(3058),
    [anon_sym__Alignas] = ACTIONS(3058),
    [anon_sym_DOT] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3058),
    [anon_sym_let] = ACTIONS(3058),
    [anon_sym_This] = ACTIONS(3058),
    [anon_sym_decltype] = ACTIONS(3058),
    [anon_sym_template] = ACTIONS(3058),
    [anon_sym_GT2] = ACTIONS(3056),
    [anon_sym_operator] = ACTIONS(3058),
    [anon_sym_precise] = ACTIONS(3058),
    [anon_sym_shared] = ACTIONS(3058),
    [anon_sym_groupshared] = ACTIONS(3058),
    [anon_sym_uniform] = ACTIONS(3058),
    [anon_sym_row_major] = ACTIONS(3058),
    [anon_sym_column_major] = ACTIONS(3058),
    [anon_sym_globallycoherent] = ACTIONS(3058),
    [anon_sym_centroid] = ACTIONS(3058),
    [anon_sym_noperspective] = ACTIONS(3058),
    [anon_sym_nointerpolation] = ACTIONS(3058),
    [anon_sym_sample] = ACTIONS(3058),
    [anon_sym_linear] = ACTIONS(3058),
    [anon_sym_snorm] = ACTIONS(3058),
    [anon_sym_unorm] = ACTIONS(3058),
    [anon_sym_point] = ACTIONS(3058),
    [anon_sym_line] = ACTIONS(3058),
    [anon_sym_triangleadj] = ACTIONS(3058),
    [anon_sym_lineadj] = ACTIONS(3058),
    [anon_sym_triangle] = ACTIONS(3058),
  },
  [2904] = {
    [sym_identifier] = ACTIONS(2964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2962),
    [anon_sym_RPAREN] = ACTIONS(2962),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2962),
    [anon_sym_STAR] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_COLON] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym___extension__] = ACTIONS(2964),
    [anon_sym_in] = ACTIONS(2964),
    [anon_sym_out] = ACTIONS(2964),
    [anon_sym_inout] = ACTIONS(2964),
    [anon_sym_virtual] = ACTIONS(2964),
    [anon_sym_extern] = ACTIONS(2964),
    [anon_sym___attribute__] = ACTIONS(2964),
    [anon_sym___attribute] = ACTIONS(2964),
    [anon_sym_COLON_COLON] = ACTIONS(2962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2962),
    [anon_sym___declspec] = ACTIONS(2964),
    [anon_sym___based] = ACTIONS(2964),
    [anon_sym___cdecl] = ACTIONS(2964),
    [anon_sym___clrcall] = ACTIONS(2964),
    [anon_sym___stdcall] = ACTIONS(2964),
    [anon_sym___fastcall] = ACTIONS(2964),
    [anon_sym___thiscall] = ACTIONS(2964),
    [anon_sym___vectorcall] = ACTIONS(2964),
    [anon_sym_LBRACK] = ACTIONS(2964),
    [anon_sym_static] = ACTIONS(2964),
    [anon_sym_EQ] = ACTIONS(2962),
    [anon_sym_register] = ACTIONS(2964),
    [anon_sym_inline] = ACTIONS(2964),
    [anon_sym___inline] = ACTIONS(2964),
    [anon_sym___inline__] = ACTIONS(2964),
    [anon_sym___forceinline] = ACTIONS(2964),
    [anon_sym_thread_local] = ACTIONS(2964),
    [anon_sym___thread] = ACTIONS(2964),
    [anon_sym_const] = ACTIONS(2964),
    [anon_sym_constexpr] = ACTIONS(2964),
    [anon_sym_volatile] = ACTIONS(2964),
    [anon_sym_restrict] = ACTIONS(2964),
    [anon_sym___restrict__] = ACTIONS(2964),
    [anon_sym__Atomic] = ACTIONS(2964),
    [anon_sym__Noreturn] = ACTIONS(2964),
    [anon_sym_noreturn] = ACTIONS(2964),
    [anon_sym__Nonnull] = ACTIONS(2964),
    [anon_sym_mutable] = ACTIONS(2964),
    [anon_sym_constinit] = ACTIONS(2964),
    [anon_sym_consteval] = ACTIONS(2964),
    [anon_sym_alignas] = ACTIONS(2964),
    [anon_sym__Alignas] = ACTIONS(2964),
    [anon_sym_DOT] = ACTIONS(2964),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2964),
    [anon_sym_let] = ACTIONS(2964),
    [anon_sym_This] = ACTIONS(2964),
    [anon_sym_decltype] = ACTIONS(2964),
    [anon_sym_template] = ACTIONS(2964),
    [anon_sym_GT2] = ACTIONS(2962),
    [anon_sym_operator] = ACTIONS(2964),
    [anon_sym_precise] = ACTIONS(2964),
    [anon_sym_shared] = ACTIONS(2964),
    [anon_sym_groupshared] = ACTIONS(2964),
    [anon_sym_uniform] = ACTIONS(2964),
    [anon_sym_row_major] = ACTIONS(2964),
    [anon_sym_column_major] = ACTIONS(2964),
    [anon_sym_globallycoherent] = ACTIONS(2964),
    [anon_sym_centroid] = ACTIONS(2964),
    [anon_sym_noperspective] = ACTIONS(2964),
    [anon_sym_nointerpolation] = ACTIONS(2964),
    [anon_sym_sample] = ACTIONS(2964),
    [anon_sym_linear] = ACTIONS(2964),
    [anon_sym_snorm] = ACTIONS(2964),
    [anon_sym_unorm] = ACTIONS(2964),
    [anon_sym_point] = ACTIONS(2964),
    [anon_sym_line] = ACTIONS(2964),
    [anon_sym_triangleadj] = ACTIONS(2964),
    [anon_sym_lineadj] = ACTIONS(2964),
    [anon_sym_triangle] = ACTIONS(2964),
  },
  [2905] = {
    [sym_identifier] = ACTIONS(4242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4240),
    [anon_sym_COMMA] = ACTIONS(4240),
    [anon_sym_RPAREN] = ACTIONS(4240),
    [aux_sym_preproc_if_token2] = ACTIONS(4240),
    [aux_sym_preproc_else_token1] = ACTIONS(4240),
    [aux_sym_preproc_elif_token1] = ACTIONS(4242),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4240),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4242),
    [anon_sym_PLUS] = ACTIONS(4242),
    [anon_sym_STAR] = ACTIONS(4240),
    [anon_sym_SLASH] = ACTIONS(4242),
    [anon_sym_PERCENT] = ACTIONS(4240),
    [anon_sym_PIPE_PIPE] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_PIPE] = ACTIONS(4242),
    [anon_sym_CARET] = ACTIONS(4240),
    [anon_sym_AMP] = ACTIONS(4242),
    [anon_sym_EQ_EQ] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(4240),
    [anon_sym_GT] = ACTIONS(4242),
    [anon_sym_GT_EQ] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(4242),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_LT_LT] = ACTIONS(4240),
    [anon_sym_GT_GT] = ACTIONS(4240),
    [anon_sym_COLON] = ACTIONS(4240),
    [anon_sym_SEMI] = ACTIONS(4240),
    [anon_sym___extension__] = ACTIONS(4242),
    [anon_sym___attribute__] = ACTIONS(4242),
    [anon_sym___attribute] = ACTIONS(4242),
    [anon_sym___based] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_RBRACE] = ACTIONS(4240),
    [anon_sym_signed] = ACTIONS(4242),
    [anon_sym_unsigned] = ACTIONS(4242),
    [anon_sym_long] = ACTIONS(4242),
    [anon_sym_short] = ACTIONS(4242),
    [anon_sym_LBRACK] = ACTIONS(4240),
    [anon_sym_RBRACK] = ACTIONS(4240),
    [anon_sym_const] = ACTIONS(4242),
    [anon_sym_constexpr] = ACTIONS(4242),
    [anon_sym_volatile] = ACTIONS(4242),
    [anon_sym_restrict] = ACTIONS(4242),
    [anon_sym___restrict__] = ACTIONS(4242),
    [anon_sym__Atomic] = ACTIONS(4242),
    [anon_sym__Noreturn] = ACTIONS(4242),
    [anon_sym_noreturn] = ACTIONS(4242),
    [anon_sym__Nonnull] = ACTIONS(4242),
    [anon_sym_mutable] = ACTIONS(4242),
    [anon_sym_constinit] = ACTIONS(4242),
    [anon_sym_consteval] = ACTIONS(4242),
    [anon_sym_alignas] = ACTIONS(4242),
    [anon_sym__Alignas] = ACTIONS(4242),
    [sym_primitive_type] = ACTIONS(4242),
    [anon_sym_QMARK] = ACTIONS(4240),
    [anon_sym_LT_EQ_GT] = ACTIONS(4240),
    [anon_sym_or] = ACTIONS(4242),
    [anon_sym_and] = ACTIONS(4242),
    [anon_sym_bitor] = ACTIONS(4242),
    [anon_sym_xor] = ACTIONS(4242),
    [anon_sym_bitand] = ACTIONS(4242),
    [anon_sym_not_eq] = ACTIONS(4242),
    [anon_sym_is] = ACTIONS(4242),
    [anon_sym_as] = ACTIONS(4242),
    [anon_sym_DASH_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_PLUS] = ACTIONS(4240),
    [anon_sym_DOT] = ACTIONS(4242),
    [anon_sym_DOT_STAR] = ACTIONS(4240),
    [anon_sym_DASH_GT] = ACTIONS(4240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4242),
    [anon_sym_let] = ACTIONS(4242),
    [anon_sym_This] = ACTIONS(4242),
    [anon_sym_final] = ACTIONS(4242),
    [anon_sym_override] = ACTIONS(4242),
    [anon_sym_requires] = ACTIONS(4242),
    [anon_sym_where] = ACTIONS(4242),
  },
  [2906] = {
    [sym__declaration_modifiers] = STATE(2906),
    [sym_attribute_specifier] = STATE(2906),
    [sym_attribute_declaration] = STATE(2906),
    [sym_ms_declspec_modifier] = STATE(2906),
    [sym_storage_class_specifier] = STATE(2906),
    [sym_type_qualifier] = STATE(2906),
    [sym_alignas_qualifier] = STATE(2663),
    [sym_qualifiers] = STATE(2906),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2906),
    [sym_identifier] = ACTIONS(6901),
    [anon_sym___extension__] = ACTIONS(7126),
    [anon_sym_in] = ACTIONS(7129),
    [anon_sym_out] = ACTIONS(7129),
    [anon_sym_inout] = ACTIONS(7129),
    [anon_sym_virtual] = ACTIONS(7129),
    [anon_sym_extern] = ACTIONS(7132),
    [anon_sym___attribute__] = ACTIONS(7135),
    [anon_sym___attribute] = ACTIONS(7135),
    [anon_sym_COLON_COLON] = ACTIONS(6903),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7138),
    [anon_sym___declspec] = ACTIONS(7141),
    [anon_sym_signed] = ACTIONS(6901),
    [anon_sym_unsigned] = ACTIONS(6901),
    [anon_sym_long] = ACTIONS(6901),
    [anon_sym_short] = ACTIONS(6901),
    [anon_sym_static] = ACTIONS(7132),
    [anon_sym_register] = ACTIONS(7132),
    [anon_sym_inline] = ACTIONS(7132),
    [anon_sym___inline] = ACTIONS(7132),
    [anon_sym___inline__] = ACTIONS(7132),
    [anon_sym___forceinline] = ACTIONS(7132),
    [anon_sym_thread_local] = ACTIONS(7132),
    [anon_sym___thread] = ACTIONS(7132),
    [anon_sym_const] = ACTIONS(7126),
    [anon_sym_constexpr] = ACTIONS(7126),
    [anon_sym_volatile] = ACTIONS(7126),
    [anon_sym_restrict] = ACTIONS(7126),
    [anon_sym___restrict__] = ACTIONS(7126),
    [anon_sym__Atomic] = ACTIONS(7126),
    [anon_sym__Noreturn] = ACTIONS(7126),
    [anon_sym_noreturn] = ACTIONS(7126),
    [anon_sym__Nonnull] = ACTIONS(7126),
    [anon_sym_mutable] = ACTIONS(7126),
    [anon_sym_constinit] = ACTIONS(7126),
    [anon_sym_consteval] = ACTIONS(7126),
    [anon_sym_alignas] = ACTIONS(7144),
    [anon_sym__Alignas] = ACTIONS(7144),
    [sym_primitive_type] = ACTIONS(6901),
    [anon_sym_enum] = ACTIONS(6901),
    [anon_sym_class] = ACTIONS(6901),
    [anon_sym_struct] = ACTIONS(6901),
    [anon_sym_union] = ACTIONS(6901),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6901),
    [anon_sym_let] = ACTIONS(6901),
    [anon_sym_This] = ACTIONS(6901),
    [anon_sym_decltype] = ACTIONS(6901),
    [anon_sym_typename] = ACTIONS(6901),
    [anon_sym_template] = ACTIONS(6901),
    [anon_sym_precise] = ACTIONS(7147),
    [anon_sym_shared] = ACTIONS(7147),
    [anon_sym_groupshared] = ACTIONS(7147),
    [anon_sym_uniform] = ACTIONS(7147),
    [anon_sym_row_major] = ACTIONS(7147),
    [anon_sym_column_major] = ACTIONS(7147),
    [anon_sym_globallycoherent] = ACTIONS(7147),
    [anon_sym_centroid] = ACTIONS(7147),
    [anon_sym_noperspective] = ACTIONS(7147),
    [anon_sym_nointerpolation] = ACTIONS(7147),
    [anon_sym_sample] = ACTIONS(7147),
    [anon_sym_linear] = ACTIONS(7147),
    [anon_sym_snorm] = ACTIONS(7147),
    [anon_sym_unorm] = ACTIONS(7147),
    [anon_sym_point] = ACTIONS(7147),
    [anon_sym_line] = ACTIONS(7147),
    [anon_sym_triangleadj] = ACTIONS(7147),
    [anon_sym_lineadj] = ACTIONS(7147),
    [anon_sym_triangle] = ACTIONS(7147),
    [anon_sym_interface] = ACTIONS(6901),
    [anon_sym_extension] = ACTIONS(6901),
  },
  [2907] = {
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3352),
    [anon_sym_COMMA] = ACTIONS(3352),
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_DASH] = ACTIONS(3362),
    [anon_sym_PLUS] = ACTIONS(3362),
    [anon_sym_STAR] = ACTIONS(3362),
    [anon_sym_SLASH] = ACTIONS(3362),
    [anon_sym_PERCENT] = ACTIONS(3362),
    [anon_sym_PIPE_PIPE] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_PIPE] = ACTIONS(3362),
    [anon_sym_CARET] = ACTIONS(3362),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_EQ_EQ] = ACTIONS(3352),
    [anon_sym_BANG_EQ] = ACTIONS(3352),
    [anon_sym_GT] = ACTIONS(3362),
    [anon_sym_GT_EQ] = ACTIONS(3362),
    [anon_sym_LT_EQ] = ACTIONS(3362),
    [anon_sym_LT] = ACTIONS(3362),
    [anon_sym_LT_LT] = ACTIONS(3362),
    [anon_sym_GT_GT] = ACTIONS(3362),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_LBRACE] = ACTIONS(3352),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3352),
    [anon_sym_EQ] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3362),
    [anon_sym_QMARK] = ACTIONS(3352),
    [anon_sym_STAR_EQ] = ACTIONS(3352),
    [anon_sym_SLASH_EQ] = ACTIONS(3352),
    [anon_sym_PERCENT_EQ] = ACTIONS(3352),
    [anon_sym_PLUS_EQ] = ACTIONS(3352),
    [anon_sym_DASH_EQ] = ACTIONS(3352),
    [anon_sym_LT_LT_EQ] = ACTIONS(3352),
    [anon_sym_GT_GT_EQ] = ACTIONS(3362),
    [anon_sym_AMP_EQ] = ACTIONS(3352),
    [anon_sym_CARET_EQ] = ACTIONS(3352),
    [anon_sym_PIPE_EQ] = ACTIONS(3352),
    [anon_sym_and_eq] = ACTIONS(3362),
    [anon_sym_or_eq] = ACTIONS(3362),
    [anon_sym_xor_eq] = ACTIONS(3362),
    [anon_sym_LT_EQ_GT] = ACTIONS(3352),
    [anon_sym_or] = ACTIONS(3362),
    [anon_sym_and] = ACTIONS(3362),
    [anon_sym_bitor] = ACTIONS(3362),
    [anon_sym_xor] = ACTIONS(3362),
    [anon_sym_bitand] = ACTIONS(3362),
    [anon_sym_not_eq] = ACTIONS(3362),
    [anon_sym_is] = ACTIONS(3362),
    [anon_sym_as] = ACTIONS(3362),
    [anon_sym_DASH_DASH] = ACTIONS(3352),
    [anon_sym_PLUS_PLUS] = ACTIONS(3352),
    [anon_sym_DOT] = ACTIONS(3362),
    [anon_sym_DOT_STAR] = ACTIONS(3352),
    [anon_sym_DASH_GT] = ACTIONS(3352),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_GT2] = ACTIONS(3352),
  },
  [2908] = {
    [sym_identifier] = ACTIONS(7150),
    [anon_sym_SEMI] = ACTIONS(7152),
    [anon_sym___extension__] = ACTIONS(7150),
    [anon_sym_in] = ACTIONS(7150),
    [anon_sym_out] = ACTIONS(7150),
    [anon_sym_inout] = ACTIONS(7150),
    [anon_sym_virtual] = ACTIONS(7150),
    [anon_sym_extern] = ACTIONS(7150),
    [anon_sym___attribute__] = ACTIONS(7150),
    [anon_sym___attribute] = ACTIONS(7150),
    [anon_sym_COLON_COLON] = ACTIONS(7152),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7152),
    [anon_sym___declspec] = ACTIONS(7150),
    [anon_sym___cdecl] = ACTIONS(7150),
    [anon_sym___clrcall] = ACTIONS(7150),
    [anon_sym___stdcall] = ACTIONS(7150),
    [anon_sym___fastcall] = ACTIONS(7150),
    [anon_sym___thiscall] = ACTIONS(7150),
    [anon_sym___vectorcall] = ACTIONS(7150),
    [anon_sym_LBRACE] = ACTIONS(7152),
    [anon_sym_signed] = ACTIONS(7150),
    [anon_sym_unsigned] = ACTIONS(7150),
    [anon_sym_long] = ACTIONS(7150),
    [anon_sym_short] = ACTIONS(7150),
    [anon_sym_LBRACK] = ACTIONS(7150),
    [anon_sym_static] = ACTIONS(7150),
    [anon_sym_register] = ACTIONS(7150),
    [anon_sym_inline] = ACTIONS(7150),
    [anon_sym___inline] = ACTIONS(7150),
    [anon_sym___inline__] = ACTIONS(7150),
    [anon_sym___forceinline] = ACTIONS(7150),
    [anon_sym_thread_local] = ACTIONS(7150),
    [anon_sym___thread] = ACTIONS(7150),
    [anon_sym_const] = ACTIONS(7150),
    [anon_sym_constexpr] = ACTIONS(7150),
    [anon_sym_volatile] = ACTIONS(7150),
    [anon_sym_restrict] = ACTIONS(7150),
    [anon_sym___restrict__] = ACTIONS(7150),
    [anon_sym__Atomic] = ACTIONS(7150),
    [anon_sym__Noreturn] = ACTIONS(7150),
    [anon_sym_noreturn] = ACTIONS(7150),
    [anon_sym__Nonnull] = ACTIONS(7150),
    [anon_sym_mutable] = ACTIONS(7150),
    [anon_sym_constinit] = ACTIONS(7150),
    [anon_sym_consteval] = ACTIONS(7150),
    [anon_sym_alignas] = ACTIONS(7150),
    [anon_sym__Alignas] = ACTIONS(7150),
    [sym_primitive_type] = ACTIONS(7150),
    [anon_sym_enum] = ACTIONS(7150),
    [anon_sym_class] = ACTIONS(7150),
    [anon_sym_struct] = ACTIONS(7150),
    [anon_sym_union] = ACTIONS(7150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(7150),
    [anon_sym_let] = ACTIONS(7150),
    [anon_sym_This] = ACTIONS(7150),
    [anon_sym_decltype] = ACTIONS(7150),
    [anon_sym_typename] = ACTIONS(7150),
    [anon_sym_template] = ACTIONS(7150),
    [anon_sym_precise] = ACTIONS(7150),
    [anon_sym_shared] = ACTIONS(7150),
    [anon_sym_groupshared] = ACTIONS(7150),
    [anon_sym_uniform] = ACTIONS(7150),
    [anon_sym_row_major] = ACTIONS(7150),
    [anon_sym_column_major] = ACTIONS(7150),
    [anon_sym_globallycoherent] = ACTIONS(7150),
    [anon_sym_centroid] = ACTIONS(7150),
    [anon_sym_noperspective] = ACTIONS(7150),
    [anon_sym_nointerpolation] = ACTIONS(7150),
    [anon_sym_sample] = ACTIONS(7150),
    [anon_sym_linear] = ACTIONS(7150),
    [anon_sym_snorm] = ACTIONS(7150),
    [anon_sym_unorm] = ACTIONS(7150),
    [anon_sym_point] = ACTIONS(7150),
    [anon_sym_line] = ACTIONS(7150),
    [anon_sym_triangleadj] = ACTIONS(7150),
    [anon_sym_lineadj] = ACTIONS(7150),
    [anon_sym_triangle] = ACTIONS(7150),
    [anon_sym_interface] = ACTIONS(7150),
    [anon_sym_extension] = ACTIONS(7150),
  },
  [2909] = {
    [sym_identifier] = ACTIONS(4242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4240),
    [anon_sym_COMMA] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4242),
    [anon_sym_PLUS] = ACTIONS(4242),
    [anon_sym_STAR] = ACTIONS(4242),
    [anon_sym_SLASH] = ACTIONS(4242),
    [anon_sym_PERCENT] = ACTIONS(4242),
    [anon_sym_PIPE_PIPE] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_PIPE] = ACTIONS(4242),
    [anon_sym_CARET] = ACTIONS(4242),
    [anon_sym_AMP] = ACTIONS(4242),
    [anon_sym_EQ_EQ] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(4240),
    [anon_sym_GT] = ACTIONS(4242),
    [anon_sym_GT_EQ] = ACTIONS(4242),
    [anon_sym_LT_EQ] = ACTIONS(4242),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_LT_LT] = ACTIONS(4242),
    [anon_sym_GT_GT] = ACTIONS(4242),
    [anon_sym___extension__] = ACTIONS(4242),
    [anon_sym___attribute__] = ACTIONS(4242),
    [anon_sym___attribute] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_signed] = ACTIONS(4242),
    [anon_sym_unsigned] = ACTIONS(4242),
    [anon_sym_long] = ACTIONS(4242),
    [anon_sym_short] = ACTIONS(4242),
    [anon_sym_LBRACK] = ACTIONS(4240),
    [anon_sym_EQ] = ACTIONS(4242),
    [anon_sym_const] = ACTIONS(4242),
    [anon_sym_constexpr] = ACTIONS(4242),
    [anon_sym_volatile] = ACTIONS(4242),
    [anon_sym_restrict] = ACTIONS(4242),
    [anon_sym___restrict__] = ACTIONS(4242),
    [anon_sym__Atomic] = ACTIONS(4242),
    [anon_sym__Noreturn] = ACTIONS(4242),
    [anon_sym_noreturn] = ACTIONS(4242),
    [anon_sym__Nonnull] = ACTIONS(4242),
    [anon_sym_mutable] = ACTIONS(4242),
    [anon_sym_constinit] = ACTIONS(4242),
    [anon_sym_consteval] = ACTIONS(4242),
    [anon_sym_alignas] = ACTIONS(4242),
    [anon_sym__Alignas] = ACTIONS(4242),
    [sym_primitive_type] = ACTIONS(4242),
    [anon_sym_QMARK] = ACTIONS(4240),
    [anon_sym_STAR_EQ] = ACTIONS(4240),
    [anon_sym_SLASH_EQ] = ACTIONS(4240),
    [anon_sym_PERCENT_EQ] = ACTIONS(4240),
    [anon_sym_PLUS_EQ] = ACTIONS(4240),
    [anon_sym_DASH_EQ] = ACTIONS(4240),
    [anon_sym_LT_LT_EQ] = ACTIONS(4240),
    [anon_sym_GT_GT_EQ] = ACTIONS(4242),
    [anon_sym_AMP_EQ] = ACTIONS(4240),
    [anon_sym_CARET_EQ] = ACTIONS(4240),
    [anon_sym_PIPE_EQ] = ACTIONS(4240),
    [anon_sym_and_eq] = ACTIONS(4242),
    [anon_sym_or_eq] = ACTIONS(4242),
    [anon_sym_xor_eq] = ACTIONS(4242),
    [anon_sym_LT_EQ_GT] = ACTIONS(4240),
    [anon_sym_or] = ACTIONS(4242),
    [anon_sym_and] = ACTIONS(4242),
    [anon_sym_bitor] = ACTIONS(4242),
    [anon_sym_xor] = ACTIONS(4242),
    [anon_sym_bitand] = ACTIONS(4242),
    [anon_sym_not_eq] = ACTIONS(4242),
    [anon_sym_is] = ACTIONS(4242),
    [anon_sym_as] = ACTIONS(4242),
    [anon_sym_DASH_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_PLUS] = ACTIONS(4240),
    [anon_sym_DOT] = ACTIONS(4242),
    [anon_sym_DOT_STAR] = ACTIONS(4240),
    [anon_sym_DASH_GT] = ACTIONS(4240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4242),
    [anon_sym_let] = ACTIONS(4242),
    [anon_sym_This] = ACTIONS(4242),
    [anon_sym_GT2] = ACTIONS(4240),
  },
  [2910] = {
    [sym_template_argument_list] = STATE(2722),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2764),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2176),
    [anon_sym_COMMA] = ACTIONS(7154),
    [anon_sym_LPAREN2] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2168),
    [anon_sym_LT] = ACTIONS(7118),
    [anon_sym_COLON] = ACTIONS(2168),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2176),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym_signed] = ACTIONS(5332),
    [anon_sym_unsigned] = ACTIONS(5332),
    [anon_sym_long] = ACTIONS(5332),
    [anon_sym_short] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(2168),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_EQ] = ACTIONS(7156),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [anon_sym_DOT] = ACTIONS(2168),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_decltype] = ACTIONS(2168),
    [anon_sym_template] = ACTIONS(2168),
    [anon_sym_GT2] = ACTIONS(7154),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
  },
  [2911] = {
    [sym_identifier] = ACTIONS(7158),
    [anon_sym_SEMI] = ACTIONS(7160),
    [anon_sym___extension__] = ACTIONS(7158),
    [anon_sym_in] = ACTIONS(7158),
    [anon_sym_out] = ACTIONS(7158),
    [anon_sym_inout] = ACTIONS(7158),
    [anon_sym_virtual] = ACTIONS(7158),
    [anon_sym_extern] = ACTIONS(7158),
    [anon_sym___attribute__] = ACTIONS(7158),
    [anon_sym___attribute] = ACTIONS(7158),
    [anon_sym_COLON_COLON] = ACTIONS(7160),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7160),
    [anon_sym___declspec] = ACTIONS(7158),
    [anon_sym___cdecl] = ACTIONS(7158),
    [anon_sym___clrcall] = ACTIONS(7158),
    [anon_sym___stdcall] = ACTIONS(7158),
    [anon_sym___fastcall] = ACTIONS(7158),
    [anon_sym___thiscall] = ACTIONS(7158),
    [anon_sym___vectorcall] = ACTIONS(7158),
    [anon_sym_LBRACE] = ACTIONS(7160),
    [anon_sym_signed] = ACTIONS(7158),
    [anon_sym_unsigned] = ACTIONS(7158),
    [anon_sym_long] = ACTIONS(7158),
    [anon_sym_short] = ACTIONS(7158),
    [anon_sym_LBRACK] = ACTIONS(7158),
    [anon_sym_static] = ACTIONS(7158),
    [anon_sym_register] = ACTIONS(7158),
    [anon_sym_inline] = ACTIONS(7158),
    [anon_sym___inline] = ACTIONS(7158),
    [anon_sym___inline__] = ACTIONS(7158),
    [anon_sym___forceinline] = ACTIONS(7158),
    [anon_sym_thread_local] = ACTIONS(7158),
    [anon_sym___thread] = ACTIONS(7158),
    [anon_sym_const] = ACTIONS(7158),
    [anon_sym_constexpr] = ACTIONS(7158),
    [anon_sym_volatile] = ACTIONS(7158),
    [anon_sym_restrict] = ACTIONS(7158),
    [anon_sym___restrict__] = ACTIONS(7158),
    [anon_sym__Atomic] = ACTIONS(7158),
    [anon_sym__Noreturn] = ACTIONS(7158),
    [anon_sym_noreturn] = ACTIONS(7158),
    [anon_sym__Nonnull] = ACTIONS(7158),
    [anon_sym_mutable] = ACTIONS(7158),
    [anon_sym_constinit] = ACTIONS(7158),
    [anon_sym_consteval] = ACTIONS(7158),
    [anon_sym_alignas] = ACTIONS(7158),
    [anon_sym__Alignas] = ACTIONS(7158),
    [sym_primitive_type] = ACTIONS(7158),
    [anon_sym_enum] = ACTIONS(7158),
    [anon_sym_class] = ACTIONS(7158),
    [anon_sym_struct] = ACTIONS(7158),
    [anon_sym_union] = ACTIONS(7158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(7158),
    [anon_sym_let] = ACTIONS(7158),
    [anon_sym_This] = ACTIONS(7158),
    [anon_sym_decltype] = ACTIONS(7158),
    [anon_sym_typename] = ACTIONS(7158),
    [anon_sym_template] = ACTIONS(7158),
    [anon_sym_precise] = ACTIONS(7158),
    [anon_sym_shared] = ACTIONS(7158),
    [anon_sym_groupshared] = ACTIONS(7158),
    [anon_sym_uniform] = ACTIONS(7158),
    [anon_sym_row_major] = ACTIONS(7158),
    [anon_sym_column_major] = ACTIONS(7158),
    [anon_sym_globallycoherent] = ACTIONS(7158),
    [anon_sym_centroid] = ACTIONS(7158),
    [anon_sym_noperspective] = ACTIONS(7158),
    [anon_sym_nointerpolation] = ACTIONS(7158),
    [anon_sym_sample] = ACTIONS(7158),
    [anon_sym_linear] = ACTIONS(7158),
    [anon_sym_snorm] = ACTIONS(7158),
    [anon_sym_unorm] = ACTIONS(7158),
    [anon_sym_point] = ACTIONS(7158),
    [anon_sym_line] = ACTIONS(7158),
    [anon_sym_triangleadj] = ACTIONS(7158),
    [anon_sym_lineadj] = ACTIONS(7158),
    [anon_sym_triangle] = ACTIONS(7158),
    [anon_sym_interface] = ACTIONS(7158),
    [anon_sym_extension] = ACTIONS(7158),
  },
  [2912] = {
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3352),
    [anon_sym_COMMA] = ACTIONS(3352),
    [anon_sym_RPAREN] = ACTIONS(3352),
    [aux_sym_preproc_if_token2] = ACTIONS(3352),
    [aux_sym_preproc_else_token1] = ACTIONS(3352),
    [aux_sym_preproc_elif_token1] = ACTIONS(3362),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3352),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3352),
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_DASH] = ACTIONS(3362),
    [anon_sym_PLUS] = ACTIONS(3362),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_SLASH] = ACTIONS(3362),
    [anon_sym_PERCENT] = ACTIONS(3352),
    [anon_sym_PIPE_PIPE] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_PIPE] = ACTIONS(3362),
    [anon_sym_CARET] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_EQ_EQ] = ACTIONS(3352),
    [anon_sym_BANG_EQ] = ACTIONS(3352),
    [anon_sym_GT] = ACTIONS(3362),
    [anon_sym_GT_EQ] = ACTIONS(3352),
    [anon_sym_LT_EQ] = ACTIONS(3362),
    [anon_sym_LT] = ACTIONS(3362),
    [anon_sym_LT_LT] = ACTIONS(3352),
    [anon_sym_GT_GT] = ACTIONS(3352),
    [anon_sym_COLON] = ACTIONS(3352),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym___based] = ACTIONS(3362),
    [anon_sym_LBRACE] = ACTIONS(3352),
    [anon_sym_RBRACE] = ACTIONS(3352),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3352),
    [anon_sym_RBRACK] = ACTIONS(3352),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3362),
    [anon_sym_QMARK] = ACTIONS(3352),
    [anon_sym_LT_EQ_GT] = ACTIONS(3352),
    [anon_sym_or] = ACTIONS(3362),
    [anon_sym_and] = ACTIONS(3362),
    [anon_sym_bitor] = ACTIONS(3362),
    [anon_sym_xor] = ACTIONS(3362),
    [anon_sym_bitand] = ACTIONS(3362),
    [anon_sym_not_eq] = ACTIONS(3362),
    [anon_sym_is] = ACTIONS(3362),
    [anon_sym_as] = ACTIONS(3362),
    [anon_sym_DASH_DASH] = ACTIONS(3352),
    [anon_sym_PLUS_PLUS] = ACTIONS(3352),
    [anon_sym_DOT] = ACTIONS(3362),
    [anon_sym_DOT_STAR] = ACTIONS(3352),
    [anon_sym_DASH_GT] = ACTIONS(3352),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_final] = ACTIONS(3362),
    [anon_sym_override] = ACTIONS(3362),
    [anon_sym_requires] = ACTIONS(3362),
    [anon_sym_where] = ACTIONS(3362),
  },
  [2913] = {
    [sym_template_argument_list] = STATE(3064),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2764),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2176),
    [anon_sym_COMMA] = ACTIONS(2176),
    [anon_sym_RPAREN] = ACTIONS(2193),
    [anon_sym_LPAREN2] = ACTIONS(2193),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2168),
    [anon_sym_LT] = ACTIONS(7118),
    [anon_sym_COLON] = ACTIONS(2168),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2193),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym_signed] = ACTIONS(5332),
    [anon_sym_unsigned] = ACTIONS(5332),
    [anon_sym_long] = ACTIONS(5332),
    [anon_sym_short] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(7074),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_EQ] = ACTIONS(2176),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [anon_sym_DOT] = ACTIONS(2168),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_decltype] = ACTIONS(2168),
    [anon_sym_template] = ACTIONS(2168),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
  },
  [2914] = {
    [sym_identifier] = ACTIONS(6895),
    [anon_sym_LPAREN2] = ACTIONS(6897),
    [anon_sym_TILDE] = ACTIONS(6897),
    [anon_sym_STAR] = ACTIONS(6897),
    [anon_sym_AMP_AMP] = ACTIONS(6897),
    [anon_sym_AMP] = ACTIONS(6895),
    [anon_sym___extension__] = ACTIONS(6895),
    [anon_sym_in] = ACTIONS(6895),
    [anon_sym_out] = ACTIONS(6895),
    [anon_sym_inout] = ACTIONS(6895),
    [anon_sym_virtual] = ACTIONS(6895),
    [anon_sym_extern] = ACTIONS(6895),
    [anon_sym___attribute__] = ACTIONS(6895),
    [anon_sym___attribute] = ACTIONS(6895),
    [anon_sym_COLON_COLON] = ACTIONS(6897),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6897),
    [anon_sym___declspec] = ACTIONS(6895),
    [anon_sym___based] = ACTIONS(6895),
    [anon_sym_signed] = ACTIONS(6895),
    [anon_sym_unsigned] = ACTIONS(6895),
    [anon_sym_long] = ACTIONS(6895),
    [anon_sym_short] = ACTIONS(6895),
    [anon_sym_LBRACK] = ACTIONS(6895),
    [anon_sym_static] = ACTIONS(6895),
    [anon_sym_register] = ACTIONS(6895),
    [anon_sym_inline] = ACTIONS(6895),
    [anon_sym___inline] = ACTIONS(6895),
    [anon_sym___inline__] = ACTIONS(6895),
    [anon_sym___forceinline] = ACTIONS(6895),
    [anon_sym_thread_local] = ACTIONS(6895),
    [anon_sym___thread] = ACTIONS(6895),
    [anon_sym_const] = ACTIONS(6895),
    [anon_sym_constexpr] = ACTIONS(6895),
    [anon_sym_volatile] = ACTIONS(6895),
    [anon_sym_restrict] = ACTIONS(6895),
    [anon_sym___restrict__] = ACTIONS(6895),
    [anon_sym__Atomic] = ACTIONS(6895),
    [anon_sym__Noreturn] = ACTIONS(6895),
    [anon_sym_noreturn] = ACTIONS(6895),
    [anon_sym__Nonnull] = ACTIONS(6895),
    [anon_sym_mutable] = ACTIONS(6895),
    [anon_sym_constinit] = ACTIONS(6895),
    [anon_sym_consteval] = ACTIONS(6895),
    [anon_sym_alignas] = ACTIONS(6895),
    [anon_sym__Alignas] = ACTIONS(6895),
    [sym_primitive_type] = ACTIONS(6895),
    [anon_sym_enum] = ACTIONS(6895),
    [anon_sym_class] = ACTIONS(6895),
    [anon_sym_struct] = ACTIONS(6895),
    [anon_sym_union] = ACTIONS(6895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6895),
    [anon_sym_let] = ACTIONS(6895),
    [anon_sym_This] = ACTIONS(6895),
    [anon_sym_decltype] = ACTIONS(6895),
    [anon_sym_explicit] = ACTIONS(6895),
    [anon_sym_typename] = ACTIONS(6895),
    [anon_sym_template] = ACTIONS(6895),
    [anon_sym_operator] = ACTIONS(6895),
    [anon_sym_precise] = ACTIONS(6895),
    [anon_sym_shared] = ACTIONS(6895),
    [anon_sym_groupshared] = ACTIONS(6895),
    [anon_sym_uniform] = ACTIONS(6895),
    [anon_sym_row_major] = ACTIONS(6895),
    [anon_sym_column_major] = ACTIONS(6895),
    [anon_sym_globallycoherent] = ACTIONS(6895),
    [anon_sym_centroid] = ACTIONS(6895),
    [anon_sym_noperspective] = ACTIONS(6895),
    [anon_sym_nointerpolation] = ACTIONS(6895),
    [anon_sym_sample] = ACTIONS(6895),
    [anon_sym_linear] = ACTIONS(6895),
    [anon_sym_snorm] = ACTIONS(6895),
    [anon_sym_unorm] = ACTIONS(6895),
    [anon_sym_point] = ACTIONS(6895),
    [anon_sym_line] = ACTIONS(6895),
    [anon_sym_triangleadj] = ACTIONS(6895),
    [anon_sym_lineadj] = ACTIONS(6895),
    [anon_sym_triangle] = ACTIONS(6895),
    [anon_sym_interface] = ACTIONS(6895),
    [anon_sym_extension] = ACTIONS(6895),
  },
  [2915] = {
    [sym_identifier] = ACTIONS(7105),
    [anon_sym_LPAREN2] = ACTIONS(7107),
    [anon_sym_TILDE] = ACTIONS(7107),
    [anon_sym_STAR] = ACTIONS(7107),
    [anon_sym_AMP_AMP] = ACTIONS(7107),
    [anon_sym_AMP] = ACTIONS(7105),
    [anon_sym___extension__] = ACTIONS(7105),
    [anon_sym_in] = ACTIONS(7105),
    [anon_sym_out] = ACTIONS(7105),
    [anon_sym_inout] = ACTIONS(7105),
    [anon_sym_virtual] = ACTIONS(7105),
    [anon_sym_extern] = ACTIONS(7105),
    [anon_sym___attribute__] = ACTIONS(7105),
    [anon_sym___attribute] = ACTIONS(7105),
    [anon_sym_COLON_COLON] = ACTIONS(7107),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7107),
    [anon_sym___declspec] = ACTIONS(7105),
    [anon_sym___based] = ACTIONS(7105),
    [anon_sym_signed] = ACTIONS(7105),
    [anon_sym_unsigned] = ACTIONS(7105),
    [anon_sym_long] = ACTIONS(7105),
    [anon_sym_short] = ACTIONS(7105),
    [anon_sym_LBRACK] = ACTIONS(7105),
    [anon_sym_static] = ACTIONS(7105),
    [anon_sym_register] = ACTIONS(7105),
    [anon_sym_inline] = ACTIONS(7105),
    [anon_sym___inline] = ACTIONS(7105),
    [anon_sym___inline__] = ACTIONS(7105),
    [anon_sym___forceinline] = ACTIONS(7105),
    [anon_sym_thread_local] = ACTIONS(7105),
    [anon_sym___thread] = ACTIONS(7105),
    [anon_sym_const] = ACTIONS(7105),
    [anon_sym_constexpr] = ACTIONS(7105),
    [anon_sym_volatile] = ACTIONS(7105),
    [anon_sym_restrict] = ACTIONS(7105),
    [anon_sym___restrict__] = ACTIONS(7105),
    [anon_sym__Atomic] = ACTIONS(7105),
    [anon_sym__Noreturn] = ACTIONS(7105),
    [anon_sym_noreturn] = ACTIONS(7105),
    [anon_sym__Nonnull] = ACTIONS(7105),
    [anon_sym_mutable] = ACTIONS(7105),
    [anon_sym_constinit] = ACTIONS(7105),
    [anon_sym_consteval] = ACTIONS(7105),
    [anon_sym_alignas] = ACTIONS(7105),
    [anon_sym__Alignas] = ACTIONS(7105),
    [sym_primitive_type] = ACTIONS(7105),
    [anon_sym_enum] = ACTIONS(7105),
    [anon_sym_class] = ACTIONS(7105),
    [anon_sym_struct] = ACTIONS(7105),
    [anon_sym_union] = ACTIONS(7105),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(7105),
    [anon_sym_let] = ACTIONS(7105),
    [anon_sym_This] = ACTIONS(7105),
    [anon_sym_decltype] = ACTIONS(7105),
    [anon_sym_explicit] = ACTIONS(7105),
    [anon_sym_typename] = ACTIONS(7105),
    [anon_sym_template] = ACTIONS(7105),
    [anon_sym_operator] = ACTIONS(7105),
    [anon_sym_precise] = ACTIONS(7105),
    [anon_sym_shared] = ACTIONS(7105),
    [anon_sym_groupshared] = ACTIONS(7105),
    [anon_sym_uniform] = ACTIONS(7105),
    [anon_sym_row_major] = ACTIONS(7105),
    [anon_sym_column_major] = ACTIONS(7105),
    [anon_sym_globallycoherent] = ACTIONS(7105),
    [anon_sym_centroid] = ACTIONS(7105),
    [anon_sym_noperspective] = ACTIONS(7105),
    [anon_sym_nointerpolation] = ACTIONS(7105),
    [anon_sym_sample] = ACTIONS(7105),
    [anon_sym_linear] = ACTIONS(7105),
    [anon_sym_snorm] = ACTIONS(7105),
    [anon_sym_unorm] = ACTIONS(7105),
    [anon_sym_point] = ACTIONS(7105),
    [anon_sym_line] = ACTIONS(7105),
    [anon_sym_triangleadj] = ACTIONS(7105),
    [anon_sym_lineadj] = ACTIONS(7105),
    [anon_sym_triangle] = ACTIONS(7105),
    [anon_sym_interface] = ACTIONS(7105),
    [anon_sym_extension] = ACTIONS(7105),
  },
  [2916] = {
    [sym_identifier] = ACTIONS(7162),
    [anon_sym_LPAREN2] = ACTIONS(7164),
    [anon_sym_TILDE] = ACTIONS(7164),
    [anon_sym_STAR] = ACTIONS(7164),
    [anon_sym_AMP_AMP] = ACTIONS(7164),
    [anon_sym_AMP] = ACTIONS(7162),
    [anon_sym___extension__] = ACTIONS(7162),
    [anon_sym_in] = ACTIONS(7162),
    [anon_sym_out] = ACTIONS(7162),
    [anon_sym_inout] = ACTIONS(7162),
    [anon_sym_virtual] = ACTIONS(7162),
    [anon_sym_extern] = ACTIONS(7162),
    [anon_sym___attribute__] = ACTIONS(7162),
    [anon_sym___attribute] = ACTIONS(7162),
    [anon_sym_COLON_COLON] = ACTIONS(7164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7164),
    [anon_sym___declspec] = ACTIONS(7162),
    [anon_sym___based] = ACTIONS(7162),
    [anon_sym_signed] = ACTIONS(7162),
    [anon_sym_unsigned] = ACTIONS(7162),
    [anon_sym_long] = ACTIONS(7162),
    [anon_sym_short] = ACTIONS(7162),
    [anon_sym_LBRACK] = ACTIONS(7162),
    [anon_sym_static] = ACTIONS(7162),
    [anon_sym_register] = ACTIONS(7162),
    [anon_sym_inline] = ACTIONS(7162),
    [anon_sym___inline] = ACTIONS(7162),
    [anon_sym___inline__] = ACTIONS(7162),
    [anon_sym___forceinline] = ACTIONS(7162),
    [anon_sym_thread_local] = ACTIONS(7162),
    [anon_sym___thread] = ACTIONS(7162),
    [anon_sym_const] = ACTIONS(7162),
    [anon_sym_constexpr] = ACTIONS(7162),
    [anon_sym_volatile] = ACTIONS(7162),
    [anon_sym_restrict] = ACTIONS(7162),
    [anon_sym___restrict__] = ACTIONS(7162),
    [anon_sym__Atomic] = ACTIONS(7162),
    [anon_sym__Noreturn] = ACTIONS(7162),
    [anon_sym_noreturn] = ACTIONS(7162),
    [anon_sym__Nonnull] = ACTIONS(7162),
    [anon_sym_mutable] = ACTIONS(7162),
    [anon_sym_constinit] = ACTIONS(7162),
    [anon_sym_consteval] = ACTIONS(7162),
    [anon_sym_alignas] = ACTIONS(7162),
    [anon_sym__Alignas] = ACTIONS(7162),
    [sym_primitive_type] = ACTIONS(7162),
    [anon_sym_enum] = ACTIONS(7162),
    [anon_sym_class] = ACTIONS(7162),
    [anon_sym_struct] = ACTIONS(7162),
    [anon_sym_union] = ACTIONS(7162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(7162),
    [anon_sym_let] = ACTIONS(7162),
    [anon_sym_This] = ACTIONS(7162),
    [anon_sym_decltype] = ACTIONS(7162),
    [anon_sym_explicit] = ACTIONS(7162),
    [anon_sym_typename] = ACTIONS(7162),
    [anon_sym_template] = ACTIONS(7162),
    [anon_sym_operator] = ACTIONS(7162),
    [anon_sym_precise] = ACTIONS(7162),
    [anon_sym_shared] = ACTIONS(7162),
    [anon_sym_groupshared] = ACTIONS(7162),
    [anon_sym_uniform] = ACTIONS(7162),
    [anon_sym_row_major] = ACTIONS(7162),
    [anon_sym_column_major] = ACTIONS(7162),
    [anon_sym_globallycoherent] = ACTIONS(7162),
    [anon_sym_centroid] = ACTIONS(7162),
    [anon_sym_noperspective] = ACTIONS(7162),
    [anon_sym_nointerpolation] = ACTIONS(7162),
    [anon_sym_sample] = ACTIONS(7162),
    [anon_sym_linear] = ACTIONS(7162),
    [anon_sym_snorm] = ACTIONS(7162),
    [anon_sym_unorm] = ACTIONS(7162),
    [anon_sym_point] = ACTIONS(7162),
    [anon_sym_line] = ACTIONS(7162),
    [anon_sym_triangleadj] = ACTIONS(7162),
    [anon_sym_lineadj] = ACTIONS(7162),
    [anon_sym_triangle] = ACTIONS(7162),
    [anon_sym_interface] = ACTIONS(7162),
    [anon_sym_extension] = ACTIONS(7162),
  },
  [2917] = {
    [sym_attribute_specifier] = STATE(2854),
    [sym_enumerator_list] = STATE(2824),
    [sym__enum_base_clause] = STATE(2783),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(7166),
    [anon_sym_SEMI] = ACTIONS(3480),
    [anon_sym___extension__] = ACTIONS(3478),
    [anon_sym_in] = ACTIONS(3478),
    [anon_sym_out] = ACTIONS(3478),
    [anon_sym_inout] = ACTIONS(3478),
    [anon_sym_virtual] = ACTIONS(3478),
    [anon_sym_extern] = ACTIONS(3478),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(3480),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3480),
    [anon_sym___declspec] = ACTIONS(3478),
    [anon_sym___based] = ACTIONS(3478),
    [anon_sym___cdecl] = ACTIONS(3478),
    [anon_sym___clrcall] = ACTIONS(3478),
    [anon_sym___stdcall] = ACTIONS(3478),
    [anon_sym___fastcall] = ACTIONS(3478),
    [anon_sym___thiscall] = ACTIONS(3478),
    [anon_sym___vectorcall] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(6963),
    [anon_sym_LBRACK] = ACTIONS(3478),
    [anon_sym_static] = ACTIONS(3478),
    [anon_sym_register] = ACTIONS(3478),
    [anon_sym_inline] = ACTIONS(3478),
    [anon_sym___inline] = ACTIONS(3478),
    [anon_sym___inline__] = ACTIONS(3478),
    [anon_sym___forceinline] = ACTIONS(3478),
    [anon_sym_thread_local] = ACTIONS(3478),
    [anon_sym___thread] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(3478),
    [anon_sym_constexpr] = ACTIONS(3478),
    [anon_sym_volatile] = ACTIONS(3478),
    [anon_sym_restrict] = ACTIONS(3478),
    [anon_sym___restrict__] = ACTIONS(3478),
    [anon_sym__Atomic] = ACTIONS(3478),
    [anon_sym__Noreturn] = ACTIONS(3478),
    [anon_sym_noreturn] = ACTIONS(3478),
    [anon_sym__Nonnull] = ACTIONS(3478),
    [anon_sym_mutable] = ACTIONS(3478),
    [anon_sym_constinit] = ACTIONS(3478),
    [anon_sym_consteval] = ACTIONS(3478),
    [anon_sym_alignas] = ACTIONS(3478),
    [anon_sym__Alignas] = ACTIONS(3478),
    [anon_sym_DOT] = ACTIONS(3480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3478),
    [anon_sym_let] = ACTIONS(3478),
    [anon_sym_This] = ACTIONS(3478),
    [anon_sym_decltype] = ACTIONS(3478),
    [anon_sym_template] = ACTIONS(3478),
    [anon_sym_operator] = ACTIONS(3478),
    [anon_sym_precise] = ACTIONS(3478),
    [anon_sym_shared] = ACTIONS(3478),
    [anon_sym_groupshared] = ACTIONS(3478),
    [anon_sym_uniform] = ACTIONS(3478),
    [anon_sym_row_major] = ACTIONS(3478),
    [anon_sym_column_major] = ACTIONS(3478),
    [anon_sym_globallycoherent] = ACTIONS(3478),
    [anon_sym_centroid] = ACTIONS(3478),
    [anon_sym_noperspective] = ACTIONS(3478),
    [anon_sym_nointerpolation] = ACTIONS(3478),
    [anon_sym_sample] = ACTIONS(3478),
    [anon_sym_linear] = ACTIONS(3478),
    [anon_sym_snorm] = ACTIONS(3478),
    [anon_sym_unorm] = ACTIONS(3478),
    [anon_sym_point] = ACTIONS(3478),
    [anon_sym_line] = ACTIONS(3478),
    [anon_sym_triangleadj] = ACTIONS(3478),
    [anon_sym_lineadj] = ACTIONS(3478),
    [anon_sym_triangle] = ACTIONS(3478),
  },
  [2918] = {
    [sym_attribute_specifier] = STATE(2904),
    [sym_enumerator_list] = STATE(2833),
    [sym__enum_base_clause] = STATE(2784),
    [sym_identifier] = ACTIONS(3502),
    [anon_sym_LPAREN2] = ACTIONS(3504),
    [anon_sym_TILDE] = ACTIONS(3504),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_AMP_AMP] = ACTIONS(3504),
    [anon_sym_AMP] = ACTIONS(3502),
    [anon_sym_COLON] = ACTIONS(7166),
    [anon_sym_SEMI] = ACTIONS(3504),
    [anon_sym___extension__] = ACTIONS(3502),
    [anon_sym_in] = ACTIONS(3502),
    [anon_sym_out] = ACTIONS(3502),
    [anon_sym_inout] = ACTIONS(3502),
    [anon_sym_virtual] = ACTIONS(3502),
    [anon_sym_extern] = ACTIONS(3502),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(3504),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3504),
    [anon_sym___declspec] = ACTIONS(3502),
    [anon_sym___based] = ACTIONS(3502),
    [anon_sym___cdecl] = ACTIONS(3502),
    [anon_sym___clrcall] = ACTIONS(3502),
    [anon_sym___stdcall] = ACTIONS(3502),
    [anon_sym___fastcall] = ACTIONS(3502),
    [anon_sym___thiscall] = ACTIONS(3502),
    [anon_sym___vectorcall] = ACTIONS(3502),
    [anon_sym_LBRACE] = ACTIONS(6963),
    [anon_sym_LBRACK] = ACTIONS(3502),
    [anon_sym_static] = ACTIONS(3502),
    [anon_sym_register] = ACTIONS(3502),
    [anon_sym_inline] = ACTIONS(3502),
    [anon_sym___inline] = ACTIONS(3502),
    [anon_sym___inline__] = ACTIONS(3502),
    [anon_sym___forceinline] = ACTIONS(3502),
    [anon_sym_thread_local] = ACTIONS(3502),
    [anon_sym___thread] = ACTIONS(3502),
    [anon_sym_const] = ACTIONS(3502),
    [anon_sym_constexpr] = ACTIONS(3502),
    [anon_sym_volatile] = ACTIONS(3502),
    [anon_sym_restrict] = ACTIONS(3502),
    [anon_sym___restrict__] = ACTIONS(3502),
    [anon_sym__Atomic] = ACTIONS(3502),
    [anon_sym__Noreturn] = ACTIONS(3502),
    [anon_sym_noreturn] = ACTIONS(3502),
    [anon_sym__Nonnull] = ACTIONS(3502),
    [anon_sym_mutable] = ACTIONS(3502),
    [anon_sym_constinit] = ACTIONS(3502),
    [anon_sym_consteval] = ACTIONS(3502),
    [anon_sym_alignas] = ACTIONS(3502),
    [anon_sym__Alignas] = ACTIONS(3502),
    [anon_sym_DOT] = ACTIONS(3504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3502),
    [anon_sym_let] = ACTIONS(3502),
    [anon_sym_This] = ACTIONS(3502),
    [anon_sym_decltype] = ACTIONS(3502),
    [anon_sym_template] = ACTIONS(3502),
    [anon_sym_operator] = ACTIONS(3502),
    [anon_sym_precise] = ACTIONS(3502),
    [anon_sym_shared] = ACTIONS(3502),
    [anon_sym_groupshared] = ACTIONS(3502),
    [anon_sym_uniform] = ACTIONS(3502),
    [anon_sym_row_major] = ACTIONS(3502),
    [anon_sym_column_major] = ACTIONS(3502),
    [anon_sym_globallycoherent] = ACTIONS(3502),
    [anon_sym_centroid] = ACTIONS(3502),
    [anon_sym_noperspective] = ACTIONS(3502),
    [anon_sym_nointerpolation] = ACTIONS(3502),
    [anon_sym_sample] = ACTIONS(3502),
    [anon_sym_linear] = ACTIONS(3502),
    [anon_sym_snorm] = ACTIONS(3502),
    [anon_sym_unorm] = ACTIONS(3502),
    [anon_sym_point] = ACTIONS(3502),
    [anon_sym_line] = ACTIONS(3502),
    [anon_sym_triangleadj] = ACTIONS(3502),
    [anon_sym_lineadj] = ACTIONS(3502),
    [anon_sym_triangle] = ACTIONS(3502),
  },
  [2919] = {
    [sym_identifier] = ACTIONS(7168),
    [anon_sym_LPAREN2] = ACTIONS(7171),
    [anon_sym_TILDE] = ACTIONS(7171),
    [anon_sym_STAR] = ACTIONS(7171),
    [anon_sym_AMP_AMP] = ACTIONS(7171),
    [anon_sym_AMP] = ACTIONS(7173),
    [anon_sym___extension__] = ACTIONS(7168),
    [anon_sym_in] = ACTIONS(7168),
    [anon_sym_out] = ACTIONS(7168),
    [anon_sym_inout] = ACTIONS(7168),
    [anon_sym_virtual] = ACTIONS(7168),
    [anon_sym_extern] = ACTIONS(7168),
    [anon_sym___attribute__] = ACTIONS(7168),
    [anon_sym___attribute] = ACTIONS(7168),
    [anon_sym_COLON_COLON] = ACTIONS(7175),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7175),
    [anon_sym___declspec] = ACTIONS(7168),
    [anon_sym___based] = ACTIONS(7173),
    [anon_sym_signed] = ACTIONS(7178),
    [anon_sym_unsigned] = ACTIONS(7178),
    [anon_sym_long] = ACTIONS(7178),
    [anon_sym_short] = ACTIONS(7178),
    [anon_sym_LBRACK] = ACTIONS(7173),
    [anon_sym_static] = ACTIONS(7168),
    [anon_sym_register] = ACTIONS(7168),
    [anon_sym_inline] = ACTIONS(7168),
    [anon_sym___inline] = ACTIONS(7168),
    [anon_sym___inline__] = ACTIONS(7168),
    [anon_sym___forceinline] = ACTIONS(7168),
    [anon_sym_thread_local] = ACTIONS(7168),
    [anon_sym___thread] = ACTIONS(7168),
    [anon_sym_const] = ACTIONS(7168),
    [anon_sym_constexpr] = ACTIONS(7168),
    [anon_sym_volatile] = ACTIONS(7168),
    [anon_sym_restrict] = ACTIONS(7168),
    [anon_sym___restrict__] = ACTIONS(7168),
    [anon_sym__Atomic] = ACTIONS(7168),
    [anon_sym__Noreturn] = ACTIONS(7168),
    [anon_sym_noreturn] = ACTIONS(7168),
    [anon_sym__Nonnull] = ACTIONS(7168),
    [anon_sym_mutable] = ACTIONS(7168),
    [anon_sym_constinit] = ACTIONS(7168),
    [anon_sym_consteval] = ACTIONS(7168),
    [anon_sym_alignas] = ACTIONS(7168),
    [anon_sym__Alignas] = ACTIONS(7168),
    [sym_primitive_type] = ACTIONS(7178),
    [anon_sym_enum] = ACTIONS(7178),
    [anon_sym_class] = ACTIONS(7178),
    [anon_sym_struct] = ACTIONS(7178),
    [anon_sym_union] = ACTIONS(7178),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(7178),
    [anon_sym_let] = ACTIONS(7178),
    [anon_sym_This] = ACTIONS(7178),
    [anon_sym_decltype] = ACTIONS(7168),
    [anon_sym_explicit] = ACTIONS(7173),
    [anon_sym_typename] = ACTIONS(7178),
    [anon_sym_template] = ACTIONS(7168),
    [anon_sym_operator] = ACTIONS(7173),
    [anon_sym_precise] = ACTIONS(7168),
    [anon_sym_shared] = ACTIONS(7168),
    [anon_sym_groupshared] = ACTIONS(7168),
    [anon_sym_uniform] = ACTIONS(7168),
    [anon_sym_row_major] = ACTIONS(7168),
    [anon_sym_column_major] = ACTIONS(7168),
    [anon_sym_globallycoherent] = ACTIONS(7168),
    [anon_sym_centroid] = ACTIONS(7168),
    [anon_sym_noperspective] = ACTIONS(7168),
    [anon_sym_nointerpolation] = ACTIONS(7168),
    [anon_sym_sample] = ACTIONS(7168),
    [anon_sym_linear] = ACTIONS(7168),
    [anon_sym_snorm] = ACTIONS(7168),
    [anon_sym_unorm] = ACTIONS(7168),
    [anon_sym_point] = ACTIONS(7168),
    [anon_sym_line] = ACTIONS(7168),
    [anon_sym_triangleadj] = ACTIONS(7168),
    [anon_sym_lineadj] = ACTIONS(7168),
    [anon_sym_triangle] = ACTIONS(7168),
    [anon_sym_interface] = ACTIONS(7178),
    [anon_sym_extension] = ACTIONS(7178),
  },
  [2920] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2274),
    [anon_sym_COMMA] = ACTIONS(2274),
    [anon_sym_RPAREN] = ACTIONS(2274),
    [anon_sym_LPAREN2] = ACTIONS(2274),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2272),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_PERCENT] = ACTIONS(2272),
    [anon_sym_PIPE_PIPE] = ACTIONS(2274),
    [anon_sym_AMP_AMP] = ACTIONS(2274),
    [anon_sym_PIPE] = ACTIONS(2272),
    [anon_sym_CARET] = ACTIONS(2272),
    [anon_sym_AMP] = ACTIONS(2272),
    [anon_sym_EQ_EQ] = ACTIONS(2274),
    [anon_sym_BANG_EQ] = ACTIONS(2274),
    [anon_sym_GT] = ACTIONS(2272),
    [anon_sym_GT_EQ] = ACTIONS(2274),
    [anon_sym_LT_EQ] = ACTIONS(2272),
    [anon_sym_LT] = ACTIONS(2272),
    [anon_sym_LT_LT] = ACTIONS(2272),
    [anon_sym_GT_GT] = ACTIONS(2272),
    [anon_sym_COLON] = ACTIONS(2272),
    [anon_sym___extension__] = ACTIONS(2274),
    [anon_sym___attribute__] = ACTIONS(2274),
    [anon_sym___attribute] = ACTIONS(2272),
    [anon_sym_COLON_COLON] = ACTIONS(2274),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_LBRACK] = ACTIONS(2274),
    [anon_sym_EQ] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_constexpr] = ACTIONS(2274),
    [anon_sym_volatile] = ACTIONS(2274),
    [anon_sym_restrict] = ACTIONS(2274),
    [anon_sym___restrict__] = ACTIONS(2274),
    [anon_sym__Atomic] = ACTIONS(2274),
    [anon_sym__Noreturn] = ACTIONS(2274),
    [anon_sym_noreturn] = ACTIONS(2274),
    [anon_sym__Nonnull] = ACTIONS(2274),
    [anon_sym_mutable] = ACTIONS(2274),
    [anon_sym_constinit] = ACTIONS(2274),
    [anon_sym_consteval] = ACTIONS(2274),
    [anon_sym_alignas] = ACTIONS(2274),
    [anon_sym__Alignas] = ACTIONS(2274),
    [anon_sym_QMARK] = ACTIONS(2274),
    [anon_sym_STAR_EQ] = ACTIONS(2274),
    [anon_sym_SLASH_EQ] = ACTIONS(2274),
    [anon_sym_PERCENT_EQ] = ACTIONS(2274),
    [anon_sym_PLUS_EQ] = ACTIONS(2274),
    [anon_sym_DASH_EQ] = ACTIONS(2274),
    [anon_sym_LT_LT_EQ] = ACTIONS(2274),
    [anon_sym_GT_GT_EQ] = ACTIONS(2274),
    [anon_sym_AMP_EQ] = ACTIONS(2274),
    [anon_sym_CARET_EQ] = ACTIONS(2274),
    [anon_sym_PIPE_EQ] = ACTIONS(2274),
    [anon_sym_and_eq] = ACTIONS(2274),
    [anon_sym_or_eq] = ACTIONS(2274),
    [anon_sym_xor_eq] = ACTIONS(2274),
    [anon_sym_LT_EQ_GT] = ACTIONS(2274),
    [anon_sym_or] = ACTIONS(2272),
    [anon_sym_and] = ACTIONS(2272),
    [anon_sym_bitor] = ACTIONS(2274),
    [anon_sym_xor] = ACTIONS(2272),
    [anon_sym_bitand] = ACTIONS(2274),
    [anon_sym_not_eq] = ACTIONS(2274),
    [anon_sym_is] = ACTIONS(2274),
    [anon_sym_as] = ACTIONS(2274),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_DOT] = ACTIONS(2272),
    [anon_sym_DOT_STAR] = ACTIONS(2274),
    [anon_sym_DASH_GT] = ACTIONS(2272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2274),
    [anon_sym_let] = ACTIONS(2274),
    [anon_sym_This] = ACTIONS(2274),
    [anon_sym_final] = ACTIONS(2274),
    [anon_sym_override] = ACTIONS(2274),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2274),
  },
  [2921] = {
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_RPAREN] = ACTIONS(2420),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_PIPE_PIPE] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_COLON] = ACTIONS(2420),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_out] = ACTIONS(2422),
    [anon_sym_inout] = ACTIONS(2422),
    [anon_sym_virtual] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2422),
    [anon_sym___based] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_register] = ACTIONS(2422),
    [anon_sym_inline] = ACTIONS(2422),
    [anon_sym___inline] = ACTIONS(2422),
    [anon_sym___inline__] = ACTIONS(2422),
    [anon_sym___forceinline] = ACTIONS(2422),
    [anon_sym_thread_local] = ACTIONS(2422),
    [anon_sym___thread] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [anon_sym_or] = ACTIONS(2422),
    [anon_sym_and] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_GT2] = ACTIONS(2420),
    [anon_sym_operator] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_requires] = ACTIONS(2422),
    [anon_sym_precise] = ACTIONS(2422),
    [anon_sym_shared] = ACTIONS(2422),
    [anon_sym_groupshared] = ACTIONS(2422),
    [anon_sym_uniform] = ACTIONS(2422),
    [anon_sym_row_major] = ACTIONS(2422),
    [anon_sym_column_major] = ACTIONS(2422),
    [anon_sym_globallycoherent] = ACTIONS(2422),
    [anon_sym_centroid] = ACTIONS(2422),
    [anon_sym_noperspective] = ACTIONS(2422),
    [anon_sym_nointerpolation] = ACTIONS(2422),
    [anon_sym_sample] = ACTIONS(2422),
    [anon_sym_linear] = ACTIONS(2422),
    [anon_sym_snorm] = ACTIONS(2422),
    [anon_sym_unorm] = ACTIONS(2422),
    [anon_sym_point] = ACTIONS(2422),
    [anon_sym_line] = ACTIONS(2422),
    [anon_sym_triangleadj] = ACTIONS(2422),
    [anon_sym_lineadj] = ACTIONS(2422),
    [anon_sym_triangle] = ACTIONS(2422),
    [anon_sym_where] = ACTIONS(2422),
  },
  [2922] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_COMMA] = ACTIONS(2306),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2304),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_PERCENT] = ACTIONS(2304),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE] = ACTIONS(2304),
    [anon_sym_CARET] = ACTIONS(2304),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_GT] = ACTIONS(2304),
    [anon_sym_GT_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_LT_LT] = ACTIONS(2304),
    [anon_sym_GT_GT] = ACTIONS(2304),
    [anon_sym_COLON] = ACTIONS(2304),
    [anon_sym___extension__] = ACTIONS(2306),
    [anon_sym___attribute__] = ACTIONS(2306),
    [anon_sym___attribute] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_LBRACK] = ACTIONS(2306),
    [anon_sym_EQ] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2306),
    [anon_sym_volatile] = ACTIONS(2306),
    [anon_sym_restrict] = ACTIONS(2306),
    [anon_sym___restrict__] = ACTIONS(2306),
    [anon_sym__Atomic] = ACTIONS(2306),
    [anon_sym__Noreturn] = ACTIONS(2306),
    [anon_sym_noreturn] = ACTIONS(2306),
    [anon_sym__Nonnull] = ACTIONS(2306),
    [anon_sym_mutable] = ACTIONS(2306),
    [anon_sym_constinit] = ACTIONS(2306),
    [anon_sym_consteval] = ACTIONS(2306),
    [anon_sym_alignas] = ACTIONS(2306),
    [anon_sym__Alignas] = ACTIONS(2306),
    [anon_sym_QMARK] = ACTIONS(2306),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2306),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_and_eq] = ACTIONS(2306),
    [anon_sym_or_eq] = ACTIONS(2306),
    [anon_sym_xor_eq] = ACTIONS(2306),
    [anon_sym_LT_EQ_GT] = ACTIONS(2306),
    [anon_sym_or] = ACTIONS(2304),
    [anon_sym_and] = ACTIONS(2304),
    [anon_sym_bitor] = ACTIONS(2306),
    [anon_sym_xor] = ACTIONS(2304),
    [anon_sym_bitand] = ACTIONS(2306),
    [anon_sym_not_eq] = ACTIONS(2306),
    [anon_sym_is] = ACTIONS(2306),
    [anon_sym_as] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DOT] = ACTIONS(2304),
    [anon_sym_DOT_STAR] = ACTIONS(2306),
    [anon_sym_DASH_GT] = ACTIONS(2304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2306),
    [anon_sym_let] = ACTIONS(2306),
    [anon_sym_This] = ACTIONS(2306),
    [anon_sym_final] = ACTIONS(2306),
    [anon_sym_override] = ACTIONS(2306),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2306),
  },
  [2923] = {
    [sym_template_argument_list] = STATE(2722),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2408),
    [anon_sym_COMMA] = ACTIONS(2408),
    [anon_sym_RPAREN] = ACTIONS(2408),
    [anon_sym_LPAREN2] = ACTIONS(2408),
    [anon_sym_TILDE] = ACTIONS(2408),
    [anon_sym_STAR] = ACTIONS(2408),
    [anon_sym_AMP_AMP] = ACTIONS(2408),
    [anon_sym_AMP] = ACTIONS(2410),
    [anon_sym_LT] = ACTIONS(7118),
    [anon_sym_COLON] = ACTIONS(2410),
    [anon_sym___extension__] = ACTIONS(2410),
    [anon_sym_in] = ACTIONS(2410),
    [anon_sym_out] = ACTIONS(2410),
    [anon_sym_inout] = ACTIONS(2410),
    [anon_sym_virtual] = ACTIONS(2410),
    [anon_sym_extern] = ACTIONS(2410),
    [anon_sym___attribute__] = ACTIONS(2410),
    [anon_sym___attribute] = ACTIONS(2410),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2408),
    [anon_sym___declspec] = ACTIONS(2410),
    [anon_sym___based] = ACTIONS(2410),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_static] = ACTIONS(2410),
    [anon_sym_EQ] = ACTIONS(2408),
    [anon_sym_register] = ACTIONS(2410),
    [anon_sym_inline] = ACTIONS(2410),
    [anon_sym___inline] = ACTIONS(2410),
    [anon_sym___inline__] = ACTIONS(2410),
    [anon_sym___forceinline] = ACTIONS(2410),
    [anon_sym_thread_local] = ACTIONS(2410),
    [anon_sym___thread] = ACTIONS(2410),
    [anon_sym_const] = ACTIONS(2410),
    [anon_sym_constexpr] = ACTIONS(2410),
    [anon_sym_volatile] = ACTIONS(2410),
    [anon_sym_restrict] = ACTIONS(2410),
    [anon_sym___restrict__] = ACTIONS(2410),
    [anon_sym__Atomic] = ACTIONS(2410),
    [anon_sym__Noreturn] = ACTIONS(2410),
    [anon_sym_noreturn] = ACTIONS(2410),
    [anon_sym__Nonnull] = ACTIONS(2410),
    [anon_sym_mutable] = ACTIONS(2410),
    [anon_sym_constinit] = ACTIONS(2410),
    [anon_sym_consteval] = ACTIONS(2410),
    [anon_sym_alignas] = ACTIONS(2410),
    [anon_sym__Alignas] = ACTIONS(2410),
    [anon_sym_DOT] = ACTIONS(2410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2410),
    [anon_sym_let] = ACTIONS(2410),
    [anon_sym_This] = ACTIONS(2410),
    [anon_sym_decltype] = ACTIONS(2410),
    [anon_sym_final] = ACTIONS(2410),
    [anon_sym_override] = ACTIONS(2410),
    [anon_sym_template] = ACTIONS(2410),
    [anon_sym_GT2] = ACTIONS(2408),
    [anon_sym_operator] = ACTIONS(2410),
    [anon_sym_precise] = ACTIONS(2410),
    [anon_sym_shared] = ACTIONS(2410),
    [anon_sym_groupshared] = ACTIONS(2410),
    [anon_sym_uniform] = ACTIONS(2410),
    [anon_sym_row_major] = ACTIONS(2410),
    [anon_sym_column_major] = ACTIONS(2410),
    [anon_sym_globallycoherent] = ACTIONS(2410),
    [anon_sym_centroid] = ACTIONS(2410),
    [anon_sym_noperspective] = ACTIONS(2410),
    [anon_sym_nointerpolation] = ACTIONS(2410),
    [anon_sym_sample] = ACTIONS(2410),
    [anon_sym_linear] = ACTIONS(2410),
    [anon_sym_snorm] = ACTIONS(2410),
    [anon_sym_unorm] = ACTIONS(2410),
    [anon_sym_point] = ACTIONS(2410),
    [anon_sym_line] = ACTIONS(2410),
    [anon_sym_triangleadj] = ACTIONS(2410),
    [anon_sym_lineadj] = ACTIONS(2410),
    [anon_sym_triangle] = ACTIONS(2410),
  },
  [2924] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2266),
    [anon_sym_COMMA] = ACTIONS(2266),
    [anon_sym_RPAREN] = ACTIONS(2266),
    [anon_sym_LPAREN2] = ACTIONS(2266),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2264),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_PERCENT] = ACTIONS(2264),
    [anon_sym_PIPE_PIPE] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2266),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_CARET] = ACTIONS(2264),
    [anon_sym_AMP] = ACTIONS(2264),
    [anon_sym_EQ_EQ] = ACTIONS(2266),
    [anon_sym_BANG_EQ] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(2264),
    [anon_sym_GT_EQ] = ACTIONS(2266),
    [anon_sym_LT_EQ] = ACTIONS(2264),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_LT_LT] = ACTIONS(2264),
    [anon_sym_GT_GT] = ACTIONS(2264),
    [anon_sym_COLON] = ACTIONS(2264),
    [anon_sym___extension__] = ACTIONS(2266),
    [anon_sym___attribute__] = ACTIONS(2266),
    [anon_sym___attribute] = ACTIONS(2264),
    [anon_sym_COLON_COLON] = ACTIONS(2266),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_EQ] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_constexpr] = ACTIONS(2266),
    [anon_sym_volatile] = ACTIONS(2266),
    [anon_sym_restrict] = ACTIONS(2266),
    [anon_sym___restrict__] = ACTIONS(2266),
    [anon_sym__Atomic] = ACTIONS(2266),
    [anon_sym__Noreturn] = ACTIONS(2266),
    [anon_sym_noreturn] = ACTIONS(2266),
    [anon_sym__Nonnull] = ACTIONS(2266),
    [anon_sym_mutable] = ACTIONS(2266),
    [anon_sym_constinit] = ACTIONS(2266),
    [anon_sym_consteval] = ACTIONS(2266),
    [anon_sym_alignas] = ACTIONS(2266),
    [anon_sym__Alignas] = ACTIONS(2266),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_STAR_EQ] = ACTIONS(2266),
    [anon_sym_SLASH_EQ] = ACTIONS(2266),
    [anon_sym_PERCENT_EQ] = ACTIONS(2266),
    [anon_sym_PLUS_EQ] = ACTIONS(2266),
    [anon_sym_DASH_EQ] = ACTIONS(2266),
    [anon_sym_LT_LT_EQ] = ACTIONS(2266),
    [anon_sym_GT_GT_EQ] = ACTIONS(2266),
    [anon_sym_AMP_EQ] = ACTIONS(2266),
    [anon_sym_CARET_EQ] = ACTIONS(2266),
    [anon_sym_PIPE_EQ] = ACTIONS(2266),
    [anon_sym_and_eq] = ACTIONS(2266),
    [anon_sym_or_eq] = ACTIONS(2266),
    [anon_sym_xor_eq] = ACTIONS(2266),
    [anon_sym_LT_EQ_GT] = ACTIONS(2266),
    [anon_sym_or] = ACTIONS(2264),
    [anon_sym_and] = ACTIONS(2264),
    [anon_sym_bitor] = ACTIONS(2266),
    [anon_sym_xor] = ACTIONS(2264),
    [anon_sym_bitand] = ACTIONS(2266),
    [anon_sym_not_eq] = ACTIONS(2266),
    [anon_sym_is] = ACTIONS(2266),
    [anon_sym_as] = ACTIONS(2266),
    [anon_sym_DASH_DASH] = ACTIONS(2266),
    [anon_sym_PLUS_PLUS] = ACTIONS(2266),
    [anon_sym_DOT] = ACTIONS(2264),
    [anon_sym_DOT_STAR] = ACTIONS(2266),
    [anon_sym_DASH_GT] = ACTIONS(2264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2266),
    [anon_sym_let] = ACTIONS(2266),
    [anon_sym_This] = ACTIONS(2266),
    [anon_sym_final] = ACTIONS(2266),
    [anon_sym_override] = ACTIONS(2266),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2266),
  },
  [2925] = {
    [sym_identifier] = ACTIONS(7066),
    [anon_sym___extension__] = ACTIONS(7066),
    [anon_sym_in] = ACTIONS(7066),
    [anon_sym_out] = ACTIONS(7066),
    [anon_sym_inout] = ACTIONS(7066),
    [anon_sym_virtual] = ACTIONS(7066),
    [anon_sym_extern] = ACTIONS(7066),
    [anon_sym___attribute__] = ACTIONS(7066),
    [anon_sym___attribute] = ACTIONS(7066),
    [anon_sym_COLON_COLON] = ACTIONS(7068),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7068),
    [anon_sym___declspec] = ACTIONS(7066),
    [anon_sym___cdecl] = ACTIONS(7066),
    [anon_sym___clrcall] = ACTIONS(7066),
    [anon_sym___stdcall] = ACTIONS(7066),
    [anon_sym___fastcall] = ACTIONS(7066),
    [anon_sym___thiscall] = ACTIONS(7066),
    [anon_sym___vectorcall] = ACTIONS(7066),
    [anon_sym_signed] = ACTIONS(7066),
    [anon_sym_unsigned] = ACTIONS(7066),
    [anon_sym_long] = ACTIONS(7066),
    [anon_sym_short] = ACTIONS(7066),
    [anon_sym_static] = ACTIONS(7066),
    [anon_sym_register] = ACTIONS(7066),
    [anon_sym_inline] = ACTIONS(7066),
    [anon_sym___inline] = ACTIONS(7066),
    [anon_sym___inline__] = ACTIONS(7066),
    [anon_sym___forceinline] = ACTIONS(7066),
    [anon_sym_thread_local] = ACTIONS(7066),
    [anon_sym___thread] = ACTIONS(7066),
    [anon_sym_const] = ACTIONS(7066),
    [anon_sym_constexpr] = ACTIONS(7066),
    [anon_sym_volatile] = ACTIONS(7066),
    [anon_sym_restrict] = ACTIONS(7066),
    [anon_sym___restrict__] = ACTIONS(7066),
    [anon_sym__Atomic] = ACTIONS(7066),
    [anon_sym__Noreturn] = ACTIONS(7066),
    [anon_sym_noreturn] = ACTIONS(7066),
    [anon_sym__Nonnull] = ACTIONS(7066),
    [anon_sym_mutable] = ACTIONS(7066),
    [anon_sym_constinit] = ACTIONS(7066),
    [anon_sym_consteval] = ACTIONS(7066),
    [anon_sym_alignas] = ACTIONS(7066),
    [anon_sym__Alignas] = ACTIONS(7066),
    [sym_primitive_type] = ACTIONS(7066),
    [anon_sym_enum] = ACTIONS(7066),
    [anon_sym_class] = ACTIONS(7066),
    [anon_sym_struct] = ACTIONS(7066),
    [anon_sym_union] = ACTIONS(7066),
    [anon_sym_if] = ACTIONS(7066),
    [anon_sym_for] = ACTIONS(7066),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(7066),
    [anon_sym_let] = ACTIONS(7066),
    [anon_sym_This] = ACTIONS(7066),
    [anon_sym_decltype] = ACTIONS(7066),
    [anon_sym_typename] = ACTIONS(7066),
    [anon_sym_template] = ACTIONS(7066),
    [anon_sym_precise] = ACTIONS(7066),
    [anon_sym_shared] = ACTIONS(7066),
    [anon_sym_groupshared] = ACTIONS(7066),
    [anon_sym_uniform] = ACTIONS(7066),
    [anon_sym_row_major] = ACTIONS(7066),
    [anon_sym_column_major] = ACTIONS(7066),
    [anon_sym_globallycoherent] = ACTIONS(7066),
    [anon_sym_centroid] = ACTIONS(7066),
    [anon_sym_noperspective] = ACTIONS(7066),
    [anon_sym_nointerpolation] = ACTIONS(7066),
    [anon_sym_sample] = ACTIONS(7066),
    [anon_sym_linear] = ACTIONS(7066),
    [anon_sym_snorm] = ACTIONS(7066),
    [anon_sym_unorm] = ACTIONS(7066),
    [anon_sym_point] = ACTIONS(7066),
    [anon_sym_line] = ACTIONS(7066),
    [anon_sym_triangleadj] = ACTIONS(7066),
    [anon_sym_lineadj] = ACTIONS(7066),
    [anon_sym_triangle] = ACTIONS(7066),
    [anon_sym_interface] = ACTIONS(7066),
    [anon_sym_extension] = ACTIONS(7066),
  },
  [2926] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2314),
    [anon_sym_COMMA] = ACTIONS(2314),
    [anon_sym_RPAREN] = ACTIONS(2314),
    [anon_sym_LPAREN2] = ACTIONS(2314),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_SLASH] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2312),
    [anon_sym_PIPE_PIPE] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2314),
    [anon_sym_PIPE] = ACTIONS(2312),
    [anon_sym_CARET] = ACTIONS(2312),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_EQ_EQ] = ACTIONS(2314),
    [anon_sym_BANG_EQ] = ACTIONS(2314),
    [anon_sym_GT] = ACTIONS(2312),
    [anon_sym_GT_EQ] = ACTIONS(2314),
    [anon_sym_LT_EQ] = ACTIONS(2312),
    [anon_sym_LT] = ACTIONS(2312),
    [anon_sym_LT_LT] = ACTIONS(2312),
    [anon_sym_GT_GT] = ACTIONS(2312),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym___extension__] = ACTIONS(2314),
    [anon_sym___attribute__] = ACTIONS(2314),
    [anon_sym___attribute] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_LBRACK] = ACTIONS(2314),
    [anon_sym_EQ] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_constexpr] = ACTIONS(2314),
    [anon_sym_volatile] = ACTIONS(2314),
    [anon_sym_restrict] = ACTIONS(2314),
    [anon_sym___restrict__] = ACTIONS(2314),
    [anon_sym__Atomic] = ACTIONS(2314),
    [anon_sym__Noreturn] = ACTIONS(2314),
    [anon_sym_noreturn] = ACTIONS(2314),
    [anon_sym__Nonnull] = ACTIONS(2314),
    [anon_sym_mutable] = ACTIONS(2314),
    [anon_sym_constinit] = ACTIONS(2314),
    [anon_sym_consteval] = ACTIONS(2314),
    [anon_sym_alignas] = ACTIONS(2314),
    [anon_sym__Alignas] = ACTIONS(2314),
    [anon_sym_QMARK] = ACTIONS(2314),
    [anon_sym_STAR_EQ] = ACTIONS(2314),
    [anon_sym_SLASH_EQ] = ACTIONS(2314),
    [anon_sym_PERCENT_EQ] = ACTIONS(2314),
    [anon_sym_PLUS_EQ] = ACTIONS(2314),
    [anon_sym_DASH_EQ] = ACTIONS(2314),
    [anon_sym_LT_LT_EQ] = ACTIONS(2314),
    [anon_sym_GT_GT_EQ] = ACTIONS(2314),
    [anon_sym_AMP_EQ] = ACTIONS(2314),
    [anon_sym_CARET_EQ] = ACTIONS(2314),
    [anon_sym_PIPE_EQ] = ACTIONS(2314),
    [anon_sym_and_eq] = ACTIONS(2314),
    [anon_sym_or_eq] = ACTIONS(2314),
    [anon_sym_xor_eq] = ACTIONS(2314),
    [anon_sym_LT_EQ_GT] = ACTIONS(2314),
    [anon_sym_or] = ACTIONS(2312),
    [anon_sym_and] = ACTIONS(2312),
    [anon_sym_bitor] = ACTIONS(2314),
    [anon_sym_xor] = ACTIONS(2312),
    [anon_sym_bitand] = ACTIONS(2314),
    [anon_sym_not_eq] = ACTIONS(2314),
    [anon_sym_is] = ACTIONS(2314),
    [anon_sym_as] = ACTIONS(2314),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_DOT] = ACTIONS(2312),
    [anon_sym_DOT_STAR] = ACTIONS(2314),
    [anon_sym_DASH_GT] = ACTIONS(2312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2314),
    [anon_sym_let] = ACTIONS(2314),
    [anon_sym_This] = ACTIONS(2314),
    [anon_sym_final] = ACTIONS(2314),
    [anon_sym_override] = ACTIONS(2314),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2314),
  },
  [2927] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2310),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_RPAREN] = ACTIONS(2310),
    [anon_sym_LPAREN2] = ACTIONS(2310),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2308),
    [anon_sym_SLASH] = ACTIONS(2308),
    [anon_sym_PERCENT] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_CARET] = ACTIONS(2308),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2310),
    [anon_sym_BANG_EQ] = ACTIONS(2310),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_EQ] = ACTIONS(2310),
    [anon_sym_LT_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2308),
    [anon_sym_COLON] = ACTIONS(2308),
    [anon_sym___extension__] = ACTIONS(2310),
    [anon_sym___attribute__] = ACTIONS(2310),
    [anon_sym___attribute] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_LBRACK] = ACTIONS(2310),
    [anon_sym_EQ] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_constexpr] = ACTIONS(2310),
    [anon_sym_volatile] = ACTIONS(2310),
    [anon_sym_restrict] = ACTIONS(2310),
    [anon_sym___restrict__] = ACTIONS(2310),
    [anon_sym__Atomic] = ACTIONS(2310),
    [anon_sym__Noreturn] = ACTIONS(2310),
    [anon_sym_noreturn] = ACTIONS(2310),
    [anon_sym__Nonnull] = ACTIONS(2310),
    [anon_sym_mutable] = ACTIONS(2310),
    [anon_sym_constinit] = ACTIONS(2310),
    [anon_sym_consteval] = ACTIONS(2310),
    [anon_sym_alignas] = ACTIONS(2310),
    [anon_sym__Alignas] = ACTIONS(2310),
    [anon_sym_QMARK] = ACTIONS(2310),
    [anon_sym_STAR_EQ] = ACTIONS(2310),
    [anon_sym_SLASH_EQ] = ACTIONS(2310),
    [anon_sym_PERCENT_EQ] = ACTIONS(2310),
    [anon_sym_PLUS_EQ] = ACTIONS(2310),
    [anon_sym_DASH_EQ] = ACTIONS(2310),
    [anon_sym_LT_LT_EQ] = ACTIONS(2310),
    [anon_sym_GT_GT_EQ] = ACTIONS(2310),
    [anon_sym_AMP_EQ] = ACTIONS(2310),
    [anon_sym_CARET_EQ] = ACTIONS(2310),
    [anon_sym_PIPE_EQ] = ACTIONS(2310),
    [anon_sym_and_eq] = ACTIONS(2310),
    [anon_sym_or_eq] = ACTIONS(2310),
    [anon_sym_xor_eq] = ACTIONS(2310),
    [anon_sym_LT_EQ_GT] = ACTIONS(2310),
    [anon_sym_or] = ACTIONS(2308),
    [anon_sym_and] = ACTIONS(2308),
    [anon_sym_bitor] = ACTIONS(2310),
    [anon_sym_xor] = ACTIONS(2308),
    [anon_sym_bitand] = ACTIONS(2310),
    [anon_sym_not_eq] = ACTIONS(2310),
    [anon_sym_is] = ACTIONS(2310),
    [anon_sym_as] = ACTIONS(2310),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_DOT] = ACTIONS(2308),
    [anon_sym_DOT_STAR] = ACTIONS(2310),
    [anon_sym_DASH_GT] = ACTIONS(2308),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2310),
    [anon_sym_let] = ACTIONS(2310),
    [anon_sym_This] = ACTIONS(2310),
    [anon_sym_final] = ACTIONS(2310),
    [anon_sym_override] = ACTIONS(2310),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2310),
  },
  [2928] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2241),
    [anon_sym_COMMA] = ACTIONS(2241),
    [anon_sym_RPAREN] = ACTIONS(2241),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2239),
    [anon_sym_PLUS] = ACTIONS(2239),
    [anon_sym_STAR] = ACTIONS(2239),
    [anon_sym_SLASH] = ACTIONS(2239),
    [anon_sym_PERCENT] = ACTIONS(2239),
    [anon_sym_PIPE_PIPE] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_PIPE] = ACTIONS(2239),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_LT_EQ] = ACTIONS(2239),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_LT_LT] = ACTIONS(2239),
    [anon_sym_GT_GT] = ACTIONS(2239),
    [anon_sym_COLON] = ACTIONS(2239),
    [anon_sym___extension__] = ACTIONS(2241),
    [anon_sym___attribute__] = ACTIONS(2241),
    [anon_sym___attribute] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2241),
    [anon_sym_EQ] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2241),
    [anon_sym_volatile] = ACTIONS(2241),
    [anon_sym_restrict] = ACTIONS(2241),
    [anon_sym___restrict__] = ACTIONS(2241),
    [anon_sym__Atomic] = ACTIONS(2241),
    [anon_sym__Noreturn] = ACTIONS(2241),
    [anon_sym_noreturn] = ACTIONS(2241),
    [anon_sym__Nonnull] = ACTIONS(2241),
    [anon_sym_mutable] = ACTIONS(2241),
    [anon_sym_constinit] = ACTIONS(2241),
    [anon_sym_consteval] = ACTIONS(2241),
    [anon_sym_alignas] = ACTIONS(2241),
    [anon_sym__Alignas] = ACTIONS(2241),
    [anon_sym_QMARK] = ACTIONS(2241),
    [anon_sym_STAR_EQ] = ACTIONS(2241),
    [anon_sym_SLASH_EQ] = ACTIONS(2241),
    [anon_sym_PERCENT_EQ] = ACTIONS(2241),
    [anon_sym_PLUS_EQ] = ACTIONS(2241),
    [anon_sym_DASH_EQ] = ACTIONS(2241),
    [anon_sym_LT_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_GT_EQ] = ACTIONS(2241),
    [anon_sym_AMP_EQ] = ACTIONS(2241),
    [anon_sym_CARET_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_EQ] = ACTIONS(2241),
    [anon_sym_and_eq] = ACTIONS(2241),
    [anon_sym_or_eq] = ACTIONS(2241),
    [anon_sym_xor_eq] = ACTIONS(2241),
    [anon_sym_LT_EQ_GT] = ACTIONS(2241),
    [anon_sym_or] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(2239),
    [anon_sym_bitor] = ACTIONS(2241),
    [anon_sym_xor] = ACTIONS(2239),
    [anon_sym_bitand] = ACTIONS(2241),
    [anon_sym_not_eq] = ACTIONS(2241),
    [anon_sym_is] = ACTIONS(2241),
    [anon_sym_as] = ACTIONS(2241),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2239),
    [anon_sym_DOT_STAR] = ACTIONS(2241),
    [anon_sym_DASH_GT] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2241),
    [anon_sym_let] = ACTIONS(2241),
    [anon_sym_This] = ACTIONS(2241),
    [anon_sym_final] = ACTIONS(2241),
    [anon_sym_override] = ACTIONS(2241),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2241),
  },
  [2929] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_COMMA] = ACTIONS(2282),
    [anon_sym_RPAREN] = ACTIONS(2282),
    [anon_sym_LPAREN2] = ACTIONS(2282),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2280),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_PERCENT] = ACTIONS(2280),
    [anon_sym_PIPE_PIPE] = ACTIONS(2282),
    [anon_sym_AMP_AMP] = ACTIONS(2282),
    [anon_sym_PIPE] = ACTIONS(2280),
    [anon_sym_CARET] = ACTIONS(2280),
    [anon_sym_AMP] = ACTIONS(2280),
    [anon_sym_EQ_EQ] = ACTIONS(2282),
    [anon_sym_BANG_EQ] = ACTIONS(2282),
    [anon_sym_GT] = ACTIONS(2280),
    [anon_sym_GT_EQ] = ACTIONS(2282),
    [anon_sym_LT_EQ] = ACTIONS(2280),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_LT_LT] = ACTIONS(2280),
    [anon_sym_GT_GT] = ACTIONS(2280),
    [anon_sym_COLON] = ACTIONS(2280),
    [anon_sym___extension__] = ACTIONS(2282),
    [anon_sym___attribute__] = ACTIONS(2282),
    [anon_sym___attribute] = ACTIONS(2280),
    [anon_sym_COLON_COLON] = ACTIONS(2282),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_EQ] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_constexpr] = ACTIONS(2282),
    [anon_sym_volatile] = ACTIONS(2282),
    [anon_sym_restrict] = ACTIONS(2282),
    [anon_sym___restrict__] = ACTIONS(2282),
    [anon_sym__Atomic] = ACTIONS(2282),
    [anon_sym__Noreturn] = ACTIONS(2282),
    [anon_sym_noreturn] = ACTIONS(2282),
    [anon_sym__Nonnull] = ACTIONS(2282),
    [anon_sym_mutable] = ACTIONS(2282),
    [anon_sym_constinit] = ACTIONS(2282),
    [anon_sym_consteval] = ACTIONS(2282),
    [anon_sym_alignas] = ACTIONS(2282),
    [anon_sym__Alignas] = ACTIONS(2282),
    [anon_sym_QMARK] = ACTIONS(2282),
    [anon_sym_STAR_EQ] = ACTIONS(2282),
    [anon_sym_SLASH_EQ] = ACTIONS(2282),
    [anon_sym_PERCENT_EQ] = ACTIONS(2282),
    [anon_sym_PLUS_EQ] = ACTIONS(2282),
    [anon_sym_DASH_EQ] = ACTIONS(2282),
    [anon_sym_LT_LT_EQ] = ACTIONS(2282),
    [anon_sym_GT_GT_EQ] = ACTIONS(2282),
    [anon_sym_AMP_EQ] = ACTIONS(2282),
    [anon_sym_CARET_EQ] = ACTIONS(2282),
    [anon_sym_PIPE_EQ] = ACTIONS(2282),
    [anon_sym_and_eq] = ACTIONS(2282),
    [anon_sym_or_eq] = ACTIONS(2282),
    [anon_sym_xor_eq] = ACTIONS(2282),
    [anon_sym_LT_EQ_GT] = ACTIONS(2282),
    [anon_sym_or] = ACTIONS(2280),
    [anon_sym_and] = ACTIONS(2280),
    [anon_sym_bitor] = ACTIONS(2282),
    [anon_sym_xor] = ACTIONS(2280),
    [anon_sym_bitand] = ACTIONS(2282),
    [anon_sym_not_eq] = ACTIONS(2282),
    [anon_sym_is] = ACTIONS(2282),
    [anon_sym_as] = ACTIONS(2282),
    [anon_sym_DASH_DASH] = ACTIONS(2282),
    [anon_sym_PLUS_PLUS] = ACTIONS(2282),
    [anon_sym_DOT] = ACTIONS(2280),
    [anon_sym_DOT_STAR] = ACTIONS(2282),
    [anon_sym_DASH_GT] = ACTIONS(2280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2282),
    [anon_sym_let] = ACTIONS(2282),
    [anon_sym_This] = ACTIONS(2282),
    [anon_sym_final] = ACTIONS(2282),
    [anon_sym_override] = ACTIONS(2282),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2282),
  },
  [2930] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2270),
    [anon_sym_COMMA] = ACTIONS(2270),
    [anon_sym_RPAREN] = ACTIONS(2270),
    [anon_sym_LPAREN2] = ACTIONS(2270),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2268),
    [anon_sym_SLASH] = ACTIONS(2268),
    [anon_sym_PERCENT] = ACTIONS(2268),
    [anon_sym_PIPE_PIPE] = ACTIONS(2270),
    [anon_sym_AMP_AMP] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2268),
    [anon_sym_CARET] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2268),
    [anon_sym_EQ_EQ] = ACTIONS(2270),
    [anon_sym_BANG_EQ] = ACTIONS(2270),
    [anon_sym_GT] = ACTIONS(2268),
    [anon_sym_GT_EQ] = ACTIONS(2270),
    [anon_sym_LT_EQ] = ACTIONS(2268),
    [anon_sym_LT] = ACTIONS(2268),
    [anon_sym_LT_LT] = ACTIONS(2268),
    [anon_sym_GT_GT] = ACTIONS(2268),
    [anon_sym_COLON] = ACTIONS(2268),
    [anon_sym___extension__] = ACTIONS(2270),
    [anon_sym___attribute__] = ACTIONS(2270),
    [anon_sym___attribute] = ACTIONS(2268),
    [anon_sym_COLON_COLON] = ACTIONS(2270),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_LBRACK] = ACTIONS(2270),
    [anon_sym_EQ] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_constexpr] = ACTIONS(2270),
    [anon_sym_volatile] = ACTIONS(2270),
    [anon_sym_restrict] = ACTIONS(2270),
    [anon_sym___restrict__] = ACTIONS(2270),
    [anon_sym__Atomic] = ACTIONS(2270),
    [anon_sym__Noreturn] = ACTIONS(2270),
    [anon_sym_noreturn] = ACTIONS(2270),
    [anon_sym__Nonnull] = ACTIONS(2270),
    [anon_sym_mutable] = ACTIONS(2270),
    [anon_sym_constinit] = ACTIONS(2270),
    [anon_sym_consteval] = ACTIONS(2270),
    [anon_sym_alignas] = ACTIONS(2270),
    [anon_sym__Alignas] = ACTIONS(2270),
    [anon_sym_QMARK] = ACTIONS(2270),
    [anon_sym_STAR_EQ] = ACTIONS(2270),
    [anon_sym_SLASH_EQ] = ACTIONS(2270),
    [anon_sym_PERCENT_EQ] = ACTIONS(2270),
    [anon_sym_PLUS_EQ] = ACTIONS(2270),
    [anon_sym_DASH_EQ] = ACTIONS(2270),
    [anon_sym_LT_LT_EQ] = ACTIONS(2270),
    [anon_sym_GT_GT_EQ] = ACTIONS(2270),
    [anon_sym_AMP_EQ] = ACTIONS(2270),
    [anon_sym_CARET_EQ] = ACTIONS(2270),
    [anon_sym_PIPE_EQ] = ACTIONS(2270),
    [anon_sym_and_eq] = ACTIONS(2270),
    [anon_sym_or_eq] = ACTIONS(2270),
    [anon_sym_xor_eq] = ACTIONS(2270),
    [anon_sym_LT_EQ_GT] = ACTIONS(2270),
    [anon_sym_or] = ACTIONS(2268),
    [anon_sym_and] = ACTIONS(2268),
    [anon_sym_bitor] = ACTIONS(2270),
    [anon_sym_xor] = ACTIONS(2268),
    [anon_sym_bitand] = ACTIONS(2270),
    [anon_sym_not_eq] = ACTIONS(2270),
    [anon_sym_is] = ACTIONS(2270),
    [anon_sym_as] = ACTIONS(2270),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_DOT] = ACTIONS(2268),
    [anon_sym_DOT_STAR] = ACTIONS(2270),
    [anon_sym_DASH_GT] = ACTIONS(2268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2270),
    [anon_sym_let] = ACTIONS(2270),
    [anon_sym_This] = ACTIONS(2270),
    [anon_sym_final] = ACTIONS(2270),
    [anon_sym_override] = ACTIONS(2270),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2270),
  },
  [2931] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2290),
    [anon_sym_COMMA] = ACTIONS(2290),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_PERCENT] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_CARET] = ACTIONS(2288),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_EQ_EQ] = ACTIONS(2290),
    [anon_sym_BANG_EQ] = ACTIONS(2290),
    [anon_sym_GT] = ACTIONS(2288),
    [anon_sym_GT_EQ] = ACTIONS(2290),
    [anon_sym_LT_EQ] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(2288),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_COLON] = ACTIONS(2288),
    [anon_sym___extension__] = ACTIONS(2290),
    [anon_sym___attribute__] = ACTIONS(2290),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_LBRACK] = ACTIONS(2290),
    [anon_sym_EQ] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2290),
    [anon_sym_volatile] = ACTIONS(2290),
    [anon_sym_restrict] = ACTIONS(2290),
    [anon_sym___restrict__] = ACTIONS(2290),
    [anon_sym__Atomic] = ACTIONS(2290),
    [anon_sym__Noreturn] = ACTIONS(2290),
    [anon_sym_noreturn] = ACTIONS(2290),
    [anon_sym__Nonnull] = ACTIONS(2290),
    [anon_sym_mutable] = ACTIONS(2290),
    [anon_sym_constinit] = ACTIONS(2290),
    [anon_sym_consteval] = ACTIONS(2290),
    [anon_sym_alignas] = ACTIONS(2290),
    [anon_sym__Alignas] = ACTIONS(2290),
    [anon_sym_QMARK] = ACTIONS(2290),
    [anon_sym_STAR_EQ] = ACTIONS(2290),
    [anon_sym_SLASH_EQ] = ACTIONS(2290),
    [anon_sym_PERCENT_EQ] = ACTIONS(2290),
    [anon_sym_PLUS_EQ] = ACTIONS(2290),
    [anon_sym_DASH_EQ] = ACTIONS(2290),
    [anon_sym_LT_LT_EQ] = ACTIONS(2290),
    [anon_sym_GT_GT_EQ] = ACTIONS(2290),
    [anon_sym_AMP_EQ] = ACTIONS(2290),
    [anon_sym_CARET_EQ] = ACTIONS(2290),
    [anon_sym_PIPE_EQ] = ACTIONS(2290),
    [anon_sym_and_eq] = ACTIONS(2290),
    [anon_sym_or_eq] = ACTIONS(2290),
    [anon_sym_xor_eq] = ACTIONS(2290),
    [anon_sym_LT_EQ_GT] = ACTIONS(2290),
    [anon_sym_or] = ACTIONS(2288),
    [anon_sym_and] = ACTIONS(2288),
    [anon_sym_bitor] = ACTIONS(2290),
    [anon_sym_xor] = ACTIONS(2288),
    [anon_sym_bitand] = ACTIONS(2290),
    [anon_sym_not_eq] = ACTIONS(2290),
    [anon_sym_is] = ACTIONS(2290),
    [anon_sym_as] = ACTIONS(2290),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_DOT] = ACTIONS(2288),
    [anon_sym_DOT_STAR] = ACTIONS(2290),
    [anon_sym_DASH_GT] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2290),
    [anon_sym_let] = ACTIONS(2290),
    [anon_sym_This] = ACTIONS(2290),
    [anon_sym_final] = ACTIONS(2290),
    [anon_sym_override] = ACTIONS(2290),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2290),
  },
  [2932] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2286),
    [anon_sym_COMMA] = ACTIONS(2286),
    [anon_sym_RPAREN] = ACTIONS(2286),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2284),
    [anon_sym_SLASH] = ACTIONS(2284),
    [anon_sym_PERCENT] = ACTIONS(2284),
    [anon_sym_PIPE_PIPE] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2284),
    [anon_sym_CARET] = ACTIONS(2284),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_EQ_EQ] = ACTIONS(2286),
    [anon_sym_BANG_EQ] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2284),
    [anon_sym_GT_EQ] = ACTIONS(2286),
    [anon_sym_LT_EQ] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2284),
    [anon_sym_LT_LT] = ACTIONS(2284),
    [anon_sym_GT_GT] = ACTIONS(2284),
    [anon_sym_COLON] = ACTIONS(2284),
    [anon_sym___extension__] = ACTIONS(2286),
    [anon_sym___attribute__] = ACTIONS(2286),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_EQ] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2286),
    [anon_sym_volatile] = ACTIONS(2286),
    [anon_sym_restrict] = ACTIONS(2286),
    [anon_sym___restrict__] = ACTIONS(2286),
    [anon_sym__Atomic] = ACTIONS(2286),
    [anon_sym__Noreturn] = ACTIONS(2286),
    [anon_sym_noreturn] = ACTIONS(2286),
    [anon_sym__Nonnull] = ACTIONS(2286),
    [anon_sym_mutable] = ACTIONS(2286),
    [anon_sym_constinit] = ACTIONS(2286),
    [anon_sym_consteval] = ACTIONS(2286),
    [anon_sym_alignas] = ACTIONS(2286),
    [anon_sym__Alignas] = ACTIONS(2286),
    [anon_sym_QMARK] = ACTIONS(2286),
    [anon_sym_STAR_EQ] = ACTIONS(2286),
    [anon_sym_SLASH_EQ] = ACTIONS(2286),
    [anon_sym_PERCENT_EQ] = ACTIONS(2286),
    [anon_sym_PLUS_EQ] = ACTIONS(2286),
    [anon_sym_DASH_EQ] = ACTIONS(2286),
    [anon_sym_LT_LT_EQ] = ACTIONS(2286),
    [anon_sym_GT_GT_EQ] = ACTIONS(2286),
    [anon_sym_AMP_EQ] = ACTIONS(2286),
    [anon_sym_CARET_EQ] = ACTIONS(2286),
    [anon_sym_PIPE_EQ] = ACTIONS(2286),
    [anon_sym_and_eq] = ACTIONS(2286),
    [anon_sym_or_eq] = ACTIONS(2286),
    [anon_sym_xor_eq] = ACTIONS(2286),
    [anon_sym_LT_EQ_GT] = ACTIONS(2286),
    [anon_sym_or] = ACTIONS(2284),
    [anon_sym_and] = ACTIONS(2284),
    [anon_sym_bitor] = ACTIONS(2286),
    [anon_sym_xor] = ACTIONS(2284),
    [anon_sym_bitand] = ACTIONS(2286),
    [anon_sym_not_eq] = ACTIONS(2286),
    [anon_sym_is] = ACTIONS(2286),
    [anon_sym_as] = ACTIONS(2286),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_DOT] = ACTIONS(2284),
    [anon_sym_DOT_STAR] = ACTIONS(2286),
    [anon_sym_DASH_GT] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2286),
    [anon_sym_let] = ACTIONS(2286),
    [anon_sym_This] = ACTIONS(2286),
    [anon_sym_final] = ACTIONS(2286),
    [anon_sym_override] = ACTIONS(2286),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2286),
  },
  [2933] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2294),
    [anon_sym_COMMA] = ACTIONS(2294),
    [anon_sym_RPAREN] = ACTIONS(2294),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2292),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_PERCENT] = ACTIONS(2292),
    [anon_sym_PIPE_PIPE] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_PIPE] = ACTIONS(2292),
    [anon_sym_CARET] = ACTIONS(2292),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_EQ_EQ] = ACTIONS(2294),
    [anon_sym_BANG_EQ] = ACTIONS(2294),
    [anon_sym_GT] = ACTIONS(2292),
    [anon_sym_GT_EQ] = ACTIONS(2294),
    [anon_sym_LT_EQ] = ACTIONS(2292),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_LT_LT] = ACTIONS(2292),
    [anon_sym_GT_GT] = ACTIONS(2292),
    [anon_sym_COLON] = ACTIONS(2292),
    [anon_sym___extension__] = ACTIONS(2294),
    [anon_sym___attribute__] = ACTIONS(2294),
    [anon_sym___attribute] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_LBRACK] = ACTIONS(2294),
    [anon_sym_EQ] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2294),
    [anon_sym_volatile] = ACTIONS(2294),
    [anon_sym_restrict] = ACTIONS(2294),
    [anon_sym___restrict__] = ACTIONS(2294),
    [anon_sym__Atomic] = ACTIONS(2294),
    [anon_sym__Noreturn] = ACTIONS(2294),
    [anon_sym_noreturn] = ACTIONS(2294),
    [anon_sym__Nonnull] = ACTIONS(2294),
    [anon_sym_mutable] = ACTIONS(2294),
    [anon_sym_constinit] = ACTIONS(2294),
    [anon_sym_consteval] = ACTIONS(2294),
    [anon_sym_alignas] = ACTIONS(2294),
    [anon_sym__Alignas] = ACTIONS(2294),
    [anon_sym_QMARK] = ACTIONS(2294),
    [anon_sym_STAR_EQ] = ACTIONS(2294),
    [anon_sym_SLASH_EQ] = ACTIONS(2294),
    [anon_sym_PERCENT_EQ] = ACTIONS(2294),
    [anon_sym_PLUS_EQ] = ACTIONS(2294),
    [anon_sym_DASH_EQ] = ACTIONS(2294),
    [anon_sym_LT_LT_EQ] = ACTIONS(2294),
    [anon_sym_GT_GT_EQ] = ACTIONS(2294),
    [anon_sym_AMP_EQ] = ACTIONS(2294),
    [anon_sym_CARET_EQ] = ACTIONS(2294),
    [anon_sym_PIPE_EQ] = ACTIONS(2294),
    [anon_sym_and_eq] = ACTIONS(2294),
    [anon_sym_or_eq] = ACTIONS(2294),
    [anon_sym_xor_eq] = ACTIONS(2294),
    [anon_sym_LT_EQ_GT] = ACTIONS(2294),
    [anon_sym_or] = ACTIONS(2292),
    [anon_sym_and] = ACTIONS(2292),
    [anon_sym_bitor] = ACTIONS(2294),
    [anon_sym_xor] = ACTIONS(2292),
    [anon_sym_bitand] = ACTIONS(2294),
    [anon_sym_not_eq] = ACTIONS(2294),
    [anon_sym_is] = ACTIONS(2294),
    [anon_sym_as] = ACTIONS(2294),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_DOT] = ACTIONS(2292),
    [anon_sym_DOT_STAR] = ACTIONS(2294),
    [anon_sym_DASH_GT] = ACTIONS(2292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2294),
    [anon_sym_let] = ACTIONS(2294),
    [anon_sym_This] = ACTIONS(2294),
    [anon_sym_final] = ACTIONS(2294),
    [anon_sym_override] = ACTIONS(2294),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2294),
  },
  [2934] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2302),
    [anon_sym_COMMA] = ACTIONS(2302),
    [anon_sym_RPAREN] = ACTIONS(2302),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_PIPE_PIPE] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_PIPE] = ACTIONS(2300),
    [anon_sym_CARET] = ACTIONS(2300),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_EQ_EQ] = ACTIONS(2302),
    [anon_sym_BANG_EQ] = ACTIONS(2302),
    [anon_sym_GT] = ACTIONS(2300),
    [anon_sym_GT_EQ] = ACTIONS(2302),
    [anon_sym_LT_EQ] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_LT_LT] = ACTIONS(2300),
    [anon_sym_GT_GT] = ACTIONS(2300),
    [anon_sym_COLON] = ACTIONS(2300),
    [anon_sym___extension__] = ACTIONS(2302),
    [anon_sym___attribute__] = ACTIONS(2302),
    [anon_sym___attribute] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_LBRACK] = ACTIONS(2302),
    [anon_sym_EQ] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2302),
    [anon_sym_volatile] = ACTIONS(2302),
    [anon_sym_restrict] = ACTIONS(2302),
    [anon_sym___restrict__] = ACTIONS(2302),
    [anon_sym__Atomic] = ACTIONS(2302),
    [anon_sym__Noreturn] = ACTIONS(2302),
    [anon_sym_noreturn] = ACTIONS(2302),
    [anon_sym__Nonnull] = ACTIONS(2302),
    [anon_sym_mutable] = ACTIONS(2302),
    [anon_sym_constinit] = ACTIONS(2302),
    [anon_sym_consteval] = ACTIONS(2302),
    [anon_sym_alignas] = ACTIONS(2302),
    [anon_sym__Alignas] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2302),
    [anon_sym_STAR_EQ] = ACTIONS(2302),
    [anon_sym_SLASH_EQ] = ACTIONS(2302),
    [anon_sym_PERCENT_EQ] = ACTIONS(2302),
    [anon_sym_PLUS_EQ] = ACTIONS(2302),
    [anon_sym_DASH_EQ] = ACTIONS(2302),
    [anon_sym_LT_LT_EQ] = ACTIONS(2302),
    [anon_sym_GT_GT_EQ] = ACTIONS(2302),
    [anon_sym_AMP_EQ] = ACTIONS(2302),
    [anon_sym_CARET_EQ] = ACTIONS(2302),
    [anon_sym_PIPE_EQ] = ACTIONS(2302),
    [anon_sym_and_eq] = ACTIONS(2302),
    [anon_sym_or_eq] = ACTIONS(2302),
    [anon_sym_xor_eq] = ACTIONS(2302),
    [anon_sym_LT_EQ_GT] = ACTIONS(2302),
    [anon_sym_or] = ACTIONS(2300),
    [anon_sym_and] = ACTIONS(2300),
    [anon_sym_bitor] = ACTIONS(2302),
    [anon_sym_xor] = ACTIONS(2300),
    [anon_sym_bitand] = ACTIONS(2302),
    [anon_sym_not_eq] = ACTIONS(2302),
    [anon_sym_is] = ACTIONS(2302),
    [anon_sym_as] = ACTIONS(2302),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_DOT] = ACTIONS(2300),
    [anon_sym_DOT_STAR] = ACTIONS(2302),
    [anon_sym_DASH_GT] = ACTIONS(2300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2302),
    [anon_sym_let] = ACTIONS(2302),
    [anon_sym_This] = ACTIONS(2302),
    [anon_sym_final] = ACTIONS(2302),
    [anon_sym_override] = ACTIONS(2302),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2302),
  },
  [2935] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2939),
    [sym_identifier] = ACTIONS(2915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4121),
    [anon_sym_COMMA] = ACTIONS(4121),
    [anon_sym_RPAREN] = ACTIONS(4121),
    [anon_sym_LPAREN2] = ACTIONS(4121),
    [anon_sym_DASH] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4124),
    [anon_sym_STAR] = ACTIONS(4124),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_PERCENT] = ACTIONS(4124),
    [anon_sym_PIPE_PIPE] = ACTIONS(4121),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE] = ACTIONS(4124),
    [anon_sym_CARET] = ACTIONS(4124),
    [anon_sym_AMP] = ACTIONS(4124),
    [anon_sym_EQ_EQ] = ACTIONS(4121),
    [anon_sym_BANG_EQ] = ACTIONS(4121),
    [anon_sym_GT] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4121),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_LT_LT] = ACTIONS(4124),
    [anon_sym_GT_GT] = ACTIONS(4124),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(4124),
    [anon_sym___attribute] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_signed] = ACTIONS(7180),
    [anon_sym_unsigned] = ACTIONS(7180),
    [anon_sym_long] = ACTIONS(7180),
    [anon_sym_short] = ACTIONS(7180),
    [anon_sym_LBRACK] = ACTIONS(4121),
    [anon_sym_EQ] = ACTIONS(4124),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(4121),
    [anon_sym_STAR_EQ] = ACTIONS(4121),
    [anon_sym_SLASH_EQ] = ACTIONS(4121),
    [anon_sym_PERCENT_EQ] = ACTIONS(4121),
    [anon_sym_PLUS_EQ] = ACTIONS(4121),
    [anon_sym_DASH_EQ] = ACTIONS(4121),
    [anon_sym_LT_LT_EQ] = ACTIONS(4121),
    [anon_sym_GT_GT_EQ] = ACTIONS(4121),
    [anon_sym_AMP_EQ] = ACTIONS(4121),
    [anon_sym_CARET_EQ] = ACTIONS(4121),
    [anon_sym_PIPE_EQ] = ACTIONS(4121),
    [anon_sym_LT_EQ_GT] = ACTIONS(4121),
    [anon_sym_or] = ACTIONS(4124),
    [anon_sym_and] = ACTIONS(4124),
    [anon_sym_bitor] = ACTIONS(4124),
    [anon_sym_xor] = ACTIONS(4124),
    [anon_sym_bitand] = ACTIONS(4124),
    [anon_sym_not_eq] = ACTIONS(4124),
    [anon_sym_is] = ACTIONS(4124),
    [anon_sym_as] = ACTIONS(4124),
    [anon_sym_DASH_DASH] = ACTIONS(4121),
    [anon_sym_PLUS_PLUS] = ACTIONS(4121),
    [anon_sym_DOT] = ACTIONS(4124),
    [anon_sym_DOT_STAR] = ACTIONS(4121),
    [anon_sym_DASH_GT] = ACTIONS(4124),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4124),
    [anon_sym_let] = ACTIONS(4124),
    [anon_sym_This] = ACTIONS(4124),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4121),
  },
  [2936] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_COMMA] = ACTIONS(2262),
    [anon_sym_RPAREN] = ACTIONS(2262),
    [anon_sym_LPAREN2] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2260),
    [anon_sym_PERCENT] = ACTIONS(2260),
    [anon_sym_PIPE_PIPE] = ACTIONS(2262),
    [anon_sym_AMP_AMP] = ACTIONS(2262),
    [anon_sym_PIPE] = ACTIONS(2260),
    [anon_sym_CARET] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_EQ_EQ] = ACTIONS(2262),
    [anon_sym_BANG_EQ] = ACTIONS(2262),
    [anon_sym_GT] = ACTIONS(2260),
    [anon_sym_GT_EQ] = ACTIONS(2262),
    [anon_sym_LT_EQ] = ACTIONS(2260),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_LT_LT] = ACTIONS(2260),
    [anon_sym_GT_GT] = ACTIONS(2260),
    [anon_sym_COLON] = ACTIONS(2260),
    [anon_sym___extension__] = ACTIONS(2262),
    [anon_sym___attribute__] = ACTIONS(2262),
    [anon_sym___attribute] = ACTIONS(2260),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [anon_sym_EQ] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_constexpr] = ACTIONS(2262),
    [anon_sym_volatile] = ACTIONS(2262),
    [anon_sym_restrict] = ACTIONS(2262),
    [anon_sym___restrict__] = ACTIONS(2262),
    [anon_sym__Atomic] = ACTIONS(2262),
    [anon_sym__Noreturn] = ACTIONS(2262),
    [anon_sym_noreturn] = ACTIONS(2262),
    [anon_sym__Nonnull] = ACTIONS(2262),
    [anon_sym_mutable] = ACTIONS(2262),
    [anon_sym_constinit] = ACTIONS(2262),
    [anon_sym_consteval] = ACTIONS(2262),
    [anon_sym_alignas] = ACTIONS(2262),
    [anon_sym__Alignas] = ACTIONS(2262),
    [anon_sym_QMARK] = ACTIONS(2262),
    [anon_sym_STAR_EQ] = ACTIONS(2262),
    [anon_sym_SLASH_EQ] = ACTIONS(2262),
    [anon_sym_PERCENT_EQ] = ACTIONS(2262),
    [anon_sym_PLUS_EQ] = ACTIONS(2262),
    [anon_sym_DASH_EQ] = ACTIONS(2262),
    [anon_sym_LT_LT_EQ] = ACTIONS(2262),
    [anon_sym_GT_GT_EQ] = ACTIONS(2262),
    [anon_sym_AMP_EQ] = ACTIONS(2262),
    [anon_sym_CARET_EQ] = ACTIONS(2262),
    [anon_sym_PIPE_EQ] = ACTIONS(2262),
    [anon_sym_and_eq] = ACTIONS(2262),
    [anon_sym_or_eq] = ACTIONS(2262),
    [anon_sym_xor_eq] = ACTIONS(2262),
    [anon_sym_LT_EQ_GT] = ACTIONS(2262),
    [anon_sym_or] = ACTIONS(2260),
    [anon_sym_and] = ACTIONS(2260),
    [anon_sym_bitor] = ACTIONS(2262),
    [anon_sym_xor] = ACTIONS(2260),
    [anon_sym_bitand] = ACTIONS(2262),
    [anon_sym_not_eq] = ACTIONS(2262),
    [anon_sym_is] = ACTIONS(2262),
    [anon_sym_as] = ACTIONS(2262),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_DOT] = ACTIONS(2260),
    [anon_sym_DOT_STAR] = ACTIONS(2262),
    [anon_sym_DASH_GT] = ACTIONS(2260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2262),
    [anon_sym_let] = ACTIONS(2262),
    [anon_sym_This] = ACTIONS(2262),
    [anon_sym_final] = ACTIONS(2262),
    [anon_sym_override] = ACTIONS(2262),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2262),
  },
  [2937] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2298),
    [anon_sym_COMMA] = ACTIONS(2298),
    [anon_sym_RPAREN] = ACTIONS(2298),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2296),
    [anon_sym_SLASH] = ACTIONS(2296),
    [anon_sym_PERCENT] = ACTIONS(2296),
    [anon_sym_PIPE_PIPE] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_PIPE] = ACTIONS(2296),
    [anon_sym_CARET] = ACTIONS(2296),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_EQ_EQ] = ACTIONS(2298),
    [anon_sym_BANG_EQ] = ACTIONS(2298),
    [anon_sym_GT] = ACTIONS(2296),
    [anon_sym_GT_EQ] = ACTIONS(2298),
    [anon_sym_LT_EQ] = ACTIONS(2296),
    [anon_sym_LT] = ACTIONS(2296),
    [anon_sym_LT_LT] = ACTIONS(2296),
    [anon_sym_GT_GT] = ACTIONS(2296),
    [anon_sym_COLON] = ACTIONS(2296),
    [anon_sym___extension__] = ACTIONS(2298),
    [anon_sym___attribute__] = ACTIONS(2298),
    [anon_sym___attribute] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_LBRACK] = ACTIONS(2298),
    [anon_sym_EQ] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2298),
    [anon_sym_volatile] = ACTIONS(2298),
    [anon_sym_restrict] = ACTIONS(2298),
    [anon_sym___restrict__] = ACTIONS(2298),
    [anon_sym__Atomic] = ACTIONS(2298),
    [anon_sym__Noreturn] = ACTIONS(2298),
    [anon_sym_noreturn] = ACTIONS(2298),
    [anon_sym__Nonnull] = ACTIONS(2298),
    [anon_sym_mutable] = ACTIONS(2298),
    [anon_sym_constinit] = ACTIONS(2298),
    [anon_sym_consteval] = ACTIONS(2298),
    [anon_sym_alignas] = ACTIONS(2298),
    [anon_sym__Alignas] = ACTIONS(2298),
    [anon_sym_QMARK] = ACTIONS(2298),
    [anon_sym_STAR_EQ] = ACTIONS(2298),
    [anon_sym_SLASH_EQ] = ACTIONS(2298),
    [anon_sym_PERCENT_EQ] = ACTIONS(2298),
    [anon_sym_PLUS_EQ] = ACTIONS(2298),
    [anon_sym_DASH_EQ] = ACTIONS(2298),
    [anon_sym_LT_LT_EQ] = ACTIONS(2298),
    [anon_sym_GT_GT_EQ] = ACTIONS(2298),
    [anon_sym_AMP_EQ] = ACTIONS(2298),
    [anon_sym_CARET_EQ] = ACTIONS(2298),
    [anon_sym_PIPE_EQ] = ACTIONS(2298),
    [anon_sym_and_eq] = ACTIONS(2298),
    [anon_sym_or_eq] = ACTIONS(2298),
    [anon_sym_xor_eq] = ACTIONS(2298),
    [anon_sym_LT_EQ_GT] = ACTIONS(2298),
    [anon_sym_or] = ACTIONS(2296),
    [anon_sym_and] = ACTIONS(2296),
    [anon_sym_bitor] = ACTIONS(2298),
    [anon_sym_xor] = ACTIONS(2296),
    [anon_sym_bitand] = ACTIONS(2298),
    [anon_sym_not_eq] = ACTIONS(2298),
    [anon_sym_is] = ACTIONS(2298),
    [anon_sym_as] = ACTIONS(2298),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_DOT] = ACTIONS(2296),
    [anon_sym_DOT_STAR] = ACTIONS(2298),
    [anon_sym_DASH_GT] = ACTIONS(2296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2298),
    [anon_sym_let] = ACTIONS(2298),
    [anon_sym_This] = ACTIONS(2298),
    [anon_sym_final] = ACTIONS(2298),
    [anon_sym_override] = ACTIONS(2298),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2298),
  },
  [2938] = {
    [sym_template_argument_list] = STATE(2722),
    [sym_identifier] = ACTIONS(2222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2229),
    [anon_sym_COMMA] = ACTIONS(2229),
    [anon_sym_RPAREN] = ACTIONS(2229),
    [anon_sym_LPAREN2] = ACTIONS(2229),
    [anon_sym_TILDE] = ACTIONS(2229),
    [anon_sym_STAR] = ACTIONS(2229),
    [anon_sym_AMP_AMP] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(7118),
    [anon_sym_COLON] = ACTIONS(2222),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_virtual] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym___attribute] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2229),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym___based] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_EQ] = ACTIONS(2229),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym__Nonnull] = ACTIONS(2222),
    [anon_sym_mutable] = ACTIONS(2222),
    [anon_sym_constinit] = ACTIONS(2222),
    [anon_sym_consteval] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [anon_sym_DOT] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2222),
    [anon_sym_let] = ACTIONS(2222),
    [anon_sym_This] = ACTIONS(2222),
    [anon_sym_decltype] = ACTIONS(2222),
    [anon_sym_final] = ACTIONS(2222),
    [anon_sym_override] = ACTIONS(2222),
    [anon_sym_template] = ACTIONS(2222),
    [anon_sym_GT2] = ACTIONS(2229),
    [anon_sym_operator] = ACTIONS(2222),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_groupshared] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_row_major] = ACTIONS(2222),
    [anon_sym_column_major] = ACTIONS(2222),
    [anon_sym_globallycoherent] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym_nointerpolation] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_linear] = ACTIONS(2222),
    [anon_sym_snorm] = ACTIONS(2222),
    [anon_sym_unorm] = ACTIONS(2222),
    [anon_sym_point] = ACTIONS(2222),
    [anon_sym_line] = ACTIONS(2222),
    [anon_sym_triangleadj] = ACTIONS(2222),
    [anon_sym_lineadj] = ACTIONS(2222),
    [anon_sym_triangle] = ACTIONS(2222),
  },
  [2939] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2939),
    [sym_identifier] = ACTIONS(2915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2913),
    [anon_sym_COMMA] = ACTIONS(2913),
    [anon_sym_RPAREN] = ACTIONS(2913),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2915),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(2915),
    [anon_sym_SLASH] = ACTIONS(2915),
    [anon_sym_PERCENT] = ACTIONS(2915),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_CARET] = ACTIONS(2915),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2915),
    [anon_sym_GT_EQ] = ACTIONS(2913),
    [anon_sym_LT_EQ] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2915),
    [anon_sym_LT_LT] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2915),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_signed] = ACTIONS(7180),
    [anon_sym_unsigned] = ACTIONS(7180),
    [anon_sym_long] = ACTIONS(7180),
    [anon_sym_short] = ACTIONS(7180),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(2913),
    [anon_sym_STAR_EQ] = ACTIONS(2913),
    [anon_sym_SLASH_EQ] = ACTIONS(2913),
    [anon_sym_PERCENT_EQ] = ACTIONS(2913),
    [anon_sym_PLUS_EQ] = ACTIONS(2913),
    [anon_sym_DASH_EQ] = ACTIONS(2913),
    [anon_sym_LT_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_GT_EQ] = ACTIONS(2913),
    [anon_sym_AMP_EQ] = ACTIONS(2913),
    [anon_sym_CARET_EQ] = ACTIONS(2913),
    [anon_sym_PIPE_EQ] = ACTIONS(2913),
    [anon_sym_LT_EQ_GT] = ACTIONS(2913),
    [anon_sym_or] = ACTIONS(2915),
    [anon_sym_and] = ACTIONS(2915),
    [anon_sym_bitor] = ACTIONS(2915),
    [anon_sym_xor] = ACTIONS(2915),
    [anon_sym_bitand] = ACTIONS(2915),
    [anon_sym_not_eq] = ACTIONS(2915),
    [anon_sym_is] = ACTIONS(2915),
    [anon_sym_as] = ACTIONS(2915),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_DOT] = ACTIONS(2915),
    [anon_sym_DOT_STAR] = ACTIONS(2913),
    [anon_sym_DASH_GT] = ACTIONS(2915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2915),
    [anon_sym_let] = ACTIONS(2915),
    [anon_sym_This] = ACTIONS(2915),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2913),
  },
  [2940] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2278),
    [anon_sym_COMMA] = ACTIONS(2278),
    [anon_sym_RPAREN] = ACTIONS(2278),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_PLUS] = ACTIONS(2276),
    [anon_sym_STAR] = ACTIONS(2276),
    [anon_sym_SLASH] = ACTIONS(2276),
    [anon_sym_PERCENT] = ACTIONS(2276),
    [anon_sym_PIPE_PIPE] = ACTIONS(2278),
    [anon_sym_AMP_AMP] = ACTIONS(2278),
    [anon_sym_PIPE] = ACTIONS(2276),
    [anon_sym_CARET] = ACTIONS(2276),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_EQ_EQ] = ACTIONS(2278),
    [anon_sym_BANG_EQ] = ACTIONS(2278),
    [anon_sym_GT] = ACTIONS(2276),
    [anon_sym_GT_EQ] = ACTIONS(2278),
    [anon_sym_LT_EQ] = ACTIONS(2276),
    [anon_sym_LT] = ACTIONS(2276),
    [anon_sym_LT_LT] = ACTIONS(2276),
    [anon_sym_GT_GT] = ACTIONS(2276),
    [anon_sym_COLON] = ACTIONS(2276),
    [anon_sym___extension__] = ACTIONS(2278),
    [anon_sym___attribute__] = ACTIONS(2278),
    [anon_sym___attribute] = ACTIONS(2276),
    [anon_sym_COLON_COLON] = ACTIONS(2278),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_EQ] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_constexpr] = ACTIONS(2278),
    [anon_sym_volatile] = ACTIONS(2278),
    [anon_sym_restrict] = ACTIONS(2278),
    [anon_sym___restrict__] = ACTIONS(2278),
    [anon_sym__Atomic] = ACTIONS(2278),
    [anon_sym__Noreturn] = ACTIONS(2278),
    [anon_sym_noreturn] = ACTIONS(2278),
    [anon_sym__Nonnull] = ACTIONS(2278),
    [anon_sym_mutable] = ACTIONS(2278),
    [anon_sym_constinit] = ACTIONS(2278),
    [anon_sym_consteval] = ACTIONS(2278),
    [anon_sym_alignas] = ACTIONS(2278),
    [anon_sym__Alignas] = ACTIONS(2278),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_STAR_EQ] = ACTIONS(2278),
    [anon_sym_SLASH_EQ] = ACTIONS(2278),
    [anon_sym_PERCENT_EQ] = ACTIONS(2278),
    [anon_sym_PLUS_EQ] = ACTIONS(2278),
    [anon_sym_DASH_EQ] = ACTIONS(2278),
    [anon_sym_LT_LT_EQ] = ACTIONS(2278),
    [anon_sym_GT_GT_EQ] = ACTIONS(2278),
    [anon_sym_AMP_EQ] = ACTIONS(2278),
    [anon_sym_CARET_EQ] = ACTIONS(2278),
    [anon_sym_PIPE_EQ] = ACTIONS(2278),
    [anon_sym_and_eq] = ACTIONS(2278),
    [anon_sym_or_eq] = ACTIONS(2278),
    [anon_sym_xor_eq] = ACTIONS(2278),
    [anon_sym_LT_EQ_GT] = ACTIONS(2278),
    [anon_sym_or] = ACTIONS(2276),
    [anon_sym_and] = ACTIONS(2276),
    [anon_sym_bitor] = ACTIONS(2278),
    [anon_sym_xor] = ACTIONS(2276),
    [anon_sym_bitand] = ACTIONS(2278),
    [anon_sym_not_eq] = ACTIONS(2278),
    [anon_sym_is] = ACTIONS(2278),
    [anon_sym_as] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DOT] = ACTIONS(2276),
    [anon_sym_DOT_STAR] = ACTIONS(2278),
    [anon_sym_DASH_GT] = ACTIONS(2276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2278),
    [anon_sym_let] = ACTIONS(2278),
    [anon_sym_This] = ACTIONS(2278),
    [anon_sym_final] = ACTIONS(2278),
    [anon_sym_override] = ACTIONS(2278),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2278),
  },
  [2941] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2278),
    [anon_sym_COMMA] = ACTIONS(2278),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_PLUS] = ACTIONS(2276),
    [anon_sym_STAR] = ACTIONS(2276),
    [anon_sym_SLASH] = ACTIONS(2276),
    [anon_sym_PERCENT] = ACTIONS(2276),
    [anon_sym_PIPE_PIPE] = ACTIONS(2278),
    [anon_sym_AMP_AMP] = ACTIONS(2278),
    [anon_sym_PIPE] = ACTIONS(2276),
    [anon_sym_CARET] = ACTIONS(2276),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_EQ_EQ] = ACTIONS(2278),
    [anon_sym_BANG_EQ] = ACTIONS(2278),
    [anon_sym_GT] = ACTIONS(2276),
    [anon_sym_GT_EQ] = ACTIONS(2276),
    [anon_sym_LT_EQ] = ACTIONS(2276),
    [anon_sym_LT] = ACTIONS(2276),
    [anon_sym_LT_LT] = ACTIONS(2276),
    [anon_sym_GT_GT] = ACTIONS(2276),
    [anon_sym_COLON] = ACTIONS(2276),
    [anon_sym___extension__] = ACTIONS(2278),
    [anon_sym___attribute__] = ACTIONS(2278),
    [anon_sym___attribute] = ACTIONS(2276),
    [anon_sym_COLON_COLON] = ACTIONS(2278),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_EQ] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_constexpr] = ACTIONS(2278),
    [anon_sym_volatile] = ACTIONS(2278),
    [anon_sym_restrict] = ACTIONS(2278),
    [anon_sym___restrict__] = ACTIONS(2278),
    [anon_sym__Atomic] = ACTIONS(2278),
    [anon_sym__Noreturn] = ACTIONS(2278),
    [anon_sym_noreturn] = ACTIONS(2278),
    [anon_sym__Nonnull] = ACTIONS(2278),
    [anon_sym_mutable] = ACTIONS(2278),
    [anon_sym_constinit] = ACTIONS(2278),
    [anon_sym_consteval] = ACTIONS(2278),
    [anon_sym_alignas] = ACTIONS(2278),
    [anon_sym__Alignas] = ACTIONS(2278),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_STAR_EQ] = ACTIONS(2278),
    [anon_sym_SLASH_EQ] = ACTIONS(2278),
    [anon_sym_PERCENT_EQ] = ACTIONS(2278),
    [anon_sym_PLUS_EQ] = ACTIONS(2278),
    [anon_sym_DASH_EQ] = ACTIONS(2278),
    [anon_sym_LT_LT_EQ] = ACTIONS(2278),
    [anon_sym_GT_GT_EQ] = ACTIONS(2276),
    [anon_sym_AMP_EQ] = ACTIONS(2278),
    [anon_sym_CARET_EQ] = ACTIONS(2278),
    [anon_sym_PIPE_EQ] = ACTIONS(2278),
    [anon_sym_and_eq] = ACTIONS(2278),
    [anon_sym_or_eq] = ACTIONS(2278),
    [anon_sym_xor_eq] = ACTIONS(2278),
    [anon_sym_LT_EQ_GT] = ACTIONS(2278),
    [anon_sym_or] = ACTIONS(2276),
    [anon_sym_and] = ACTIONS(2276),
    [anon_sym_bitor] = ACTIONS(2278),
    [anon_sym_xor] = ACTIONS(2276),
    [anon_sym_bitand] = ACTIONS(2278),
    [anon_sym_not_eq] = ACTIONS(2278),
    [anon_sym_is] = ACTIONS(2278),
    [anon_sym_as] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DOT] = ACTIONS(2276),
    [anon_sym_DOT_STAR] = ACTIONS(2278),
    [anon_sym_DASH_GT] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2278),
    [anon_sym_let] = ACTIONS(2278),
    [anon_sym_This] = ACTIONS(2278),
    [anon_sym_final] = ACTIONS(2278),
    [anon_sym_override] = ACTIONS(2278),
    [anon_sym_GT2] = ACTIONS(2278),
  },
  [2942] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2302),
    [anon_sym_COMMA] = ACTIONS(2302),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_PIPE_PIPE] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_PIPE] = ACTIONS(2300),
    [anon_sym_CARET] = ACTIONS(2300),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_EQ_EQ] = ACTIONS(2302),
    [anon_sym_BANG_EQ] = ACTIONS(2302),
    [anon_sym_GT] = ACTIONS(2300),
    [anon_sym_GT_EQ] = ACTIONS(2300),
    [anon_sym_LT_EQ] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_LT_LT] = ACTIONS(2300),
    [anon_sym_GT_GT] = ACTIONS(2300),
    [anon_sym_COLON] = ACTIONS(2300),
    [anon_sym___extension__] = ACTIONS(2302),
    [anon_sym___attribute__] = ACTIONS(2302),
    [anon_sym___attribute] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_LBRACK] = ACTIONS(2302),
    [anon_sym_EQ] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2302),
    [anon_sym_volatile] = ACTIONS(2302),
    [anon_sym_restrict] = ACTIONS(2302),
    [anon_sym___restrict__] = ACTIONS(2302),
    [anon_sym__Atomic] = ACTIONS(2302),
    [anon_sym__Noreturn] = ACTIONS(2302),
    [anon_sym_noreturn] = ACTIONS(2302),
    [anon_sym__Nonnull] = ACTIONS(2302),
    [anon_sym_mutable] = ACTIONS(2302),
    [anon_sym_constinit] = ACTIONS(2302),
    [anon_sym_consteval] = ACTIONS(2302),
    [anon_sym_alignas] = ACTIONS(2302),
    [anon_sym__Alignas] = ACTIONS(2302),
    [anon_sym_QMARK] = ACTIONS(2302),
    [anon_sym_STAR_EQ] = ACTIONS(2302),
    [anon_sym_SLASH_EQ] = ACTIONS(2302),
    [anon_sym_PERCENT_EQ] = ACTIONS(2302),
    [anon_sym_PLUS_EQ] = ACTIONS(2302),
    [anon_sym_DASH_EQ] = ACTIONS(2302),
    [anon_sym_LT_LT_EQ] = ACTIONS(2302),
    [anon_sym_GT_GT_EQ] = ACTIONS(2300),
    [anon_sym_AMP_EQ] = ACTIONS(2302),
    [anon_sym_CARET_EQ] = ACTIONS(2302),
    [anon_sym_PIPE_EQ] = ACTIONS(2302),
    [anon_sym_and_eq] = ACTIONS(2302),
    [anon_sym_or_eq] = ACTIONS(2302),
    [anon_sym_xor_eq] = ACTIONS(2302),
    [anon_sym_LT_EQ_GT] = ACTIONS(2302),
    [anon_sym_or] = ACTIONS(2300),
    [anon_sym_and] = ACTIONS(2300),
    [anon_sym_bitor] = ACTIONS(2302),
    [anon_sym_xor] = ACTIONS(2300),
    [anon_sym_bitand] = ACTIONS(2302),
    [anon_sym_not_eq] = ACTIONS(2302),
    [anon_sym_is] = ACTIONS(2302),
    [anon_sym_as] = ACTIONS(2302),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_DOT] = ACTIONS(2300),
    [anon_sym_DOT_STAR] = ACTIONS(2302),
    [anon_sym_DASH_GT] = ACTIONS(2302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2302),
    [anon_sym_let] = ACTIONS(2302),
    [anon_sym_This] = ACTIONS(2302),
    [anon_sym_final] = ACTIONS(2302),
    [anon_sym_override] = ACTIONS(2302),
    [anon_sym_GT2] = ACTIONS(2302),
  },
  [2943] = {
    [sym_attribute_specifier] = STATE(2854),
    [sym_enumerator_list] = STATE(2824),
    [sym__enum_base_clause] = STATE(2783),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3480),
    [anon_sym_RPAREN] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(7183),
    [anon_sym___extension__] = ACTIONS(3478),
    [anon_sym_in] = ACTIONS(3478),
    [anon_sym_out] = ACTIONS(3478),
    [anon_sym_inout] = ACTIONS(3478),
    [anon_sym_virtual] = ACTIONS(3478),
    [anon_sym_extern] = ACTIONS(3478),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(3480),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3480),
    [anon_sym___declspec] = ACTIONS(3478),
    [anon_sym___based] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(6963),
    [anon_sym_LBRACK] = ACTIONS(3478),
    [anon_sym_static] = ACTIONS(3478),
    [anon_sym_EQ] = ACTIONS(3480),
    [anon_sym_register] = ACTIONS(3478),
    [anon_sym_inline] = ACTIONS(3478),
    [anon_sym___inline] = ACTIONS(3478),
    [anon_sym___inline__] = ACTIONS(3478),
    [anon_sym___forceinline] = ACTIONS(3478),
    [anon_sym_thread_local] = ACTIONS(3478),
    [anon_sym___thread] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(3478),
    [anon_sym_constexpr] = ACTIONS(3478),
    [anon_sym_volatile] = ACTIONS(3478),
    [anon_sym_restrict] = ACTIONS(3478),
    [anon_sym___restrict__] = ACTIONS(3478),
    [anon_sym__Atomic] = ACTIONS(3478),
    [anon_sym__Noreturn] = ACTIONS(3478),
    [anon_sym_noreturn] = ACTIONS(3478),
    [anon_sym__Nonnull] = ACTIONS(3478),
    [anon_sym_mutable] = ACTIONS(3478),
    [anon_sym_constinit] = ACTIONS(3478),
    [anon_sym_consteval] = ACTIONS(3478),
    [anon_sym_alignas] = ACTIONS(3478),
    [anon_sym__Alignas] = ACTIONS(3478),
    [anon_sym_DOT] = ACTIONS(3478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3478),
    [anon_sym_let] = ACTIONS(3478),
    [anon_sym_This] = ACTIONS(3478),
    [anon_sym_decltype] = ACTIONS(3478),
    [anon_sym_template] = ACTIONS(3478),
    [anon_sym_GT2] = ACTIONS(3480),
    [anon_sym_operator] = ACTIONS(3478),
    [anon_sym_precise] = ACTIONS(3478),
    [anon_sym_shared] = ACTIONS(3478),
    [anon_sym_groupshared] = ACTIONS(3478),
    [anon_sym_uniform] = ACTIONS(3478),
    [anon_sym_row_major] = ACTIONS(3478),
    [anon_sym_column_major] = ACTIONS(3478),
    [anon_sym_globallycoherent] = ACTIONS(3478),
    [anon_sym_centroid] = ACTIONS(3478),
    [anon_sym_noperspective] = ACTIONS(3478),
    [anon_sym_nointerpolation] = ACTIONS(3478),
    [anon_sym_sample] = ACTIONS(3478),
    [anon_sym_linear] = ACTIONS(3478),
    [anon_sym_snorm] = ACTIONS(3478),
    [anon_sym_unorm] = ACTIONS(3478),
    [anon_sym_point] = ACTIONS(3478),
    [anon_sym_line] = ACTIONS(3478),
    [anon_sym_triangleadj] = ACTIONS(3478),
    [anon_sym_lineadj] = ACTIONS(3478),
    [anon_sym_triangle] = ACTIONS(3478),
  },
  [2944] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_COMMA] = ACTIONS(2262),
    [anon_sym_LPAREN2] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2260),
    [anon_sym_PERCENT] = ACTIONS(2260),
    [anon_sym_PIPE_PIPE] = ACTIONS(2262),
    [anon_sym_AMP_AMP] = ACTIONS(2262),
    [anon_sym_PIPE] = ACTIONS(2260),
    [anon_sym_CARET] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_EQ_EQ] = ACTIONS(2262),
    [anon_sym_BANG_EQ] = ACTIONS(2262),
    [anon_sym_GT] = ACTIONS(2260),
    [anon_sym_GT_EQ] = ACTIONS(2260),
    [anon_sym_LT_EQ] = ACTIONS(2260),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_LT_LT] = ACTIONS(2260),
    [anon_sym_GT_GT] = ACTIONS(2260),
    [anon_sym_COLON] = ACTIONS(2260),
    [anon_sym___extension__] = ACTIONS(2262),
    [anon_sym___attribute__] = ACTIONS(2262),
    [anon_sym___attribute] = ACTIONS(2260),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [anon_sym_EQ] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_constexpr] = ACTIONS(2262),
    [anon_sym_volatile] = ACTIONS(2262),
    [anon_sym_restrict] = ACTIONS(2262),
    [anon_sym___restrict__] = ACTIONS(2262),
    [anon_sym__Atomic] = ACTIONS(2262),
    [anon_sym__Noreturn] = ACTIONS(2262),
    [anon_sym_noreturn] = ACTIONS(2262),
    [anon_sym__Nonnull] = ACTIONS(2262),
    [anon_sym_mutable] = ACTIONS(2262),
    [anon_sym_constinit] = ACTIONS(2262),
    [anon_sym_consteval] = ACTIONS(2262),
    [anon_sym_alignas] = ACTIONS(2262),
    [anon_sym__Alignas] = ACTIONS(2262),
    [anon_sym_QMARK] = ACTIONS(2262),
    [anon_sym_STAR_EQ] = ACTIONS(2262),
    [anon_sym_SLASH_EQ] = ACTIONS(2262),
    [anon_sym_PERCENT_EQ] = ACTIONS(2262),
    [anon_sym_PLUS_EQ] = ACTIONS(2262),
    [anon_sym_DASH_EQ] = ACTIONS(2262),
    [anon_sym_LT_LT_EQ] = ACTIONS(2262),
    [anon_sym_GT_GT_EQ] = ACTIONS(2260),
    [anon_sym_AMP_EQ] = ACTIONS(2262),
    [anon_sym_CARET_EQ] = ACTIONS(2262),
    [anon_sym_PIPE_EQ] = ACTIONS(2262),
    [anon_sym_and_eq] = ACTIONS(2262),
    [anon_sym_or_eq] = ACTIONS(2262),
    [anon_sym_xor_eq] = ACTIONS(2262),
    [anon_sym_LT_EQ_GT] = ACTIONS(2262),
    [anon_sym_or] = ACTIONS(2260),
    [anon_sym_and] = ACTIONS(2260),
    [anon_sym_bitor] = ACTIONS(2262),
    [anon_sym_xor] = ACTIONS(2260),
    [anon_sym_bitand] = ACTIONS(2262),
    [anon_sym_not_eq] = ACTIONS(2262),
    [anon_sym_is] = ACTIONS(2262),
    [anon_sym_as] = ACTIONS(2262),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_DOT] = ACTIONS(2260),
    [anon_sym_DOT_STAR] = ACTIONS(2262),
    [anon_sym_DASH_GT] = ACTIONS(2262),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2262),
    [anon_sym_let] = ACTIONS(2262),
    [anon_sym_This] = ACTIONS(2262),
    [anon_sym_final] = ACTIONS(2262),
    [anon_sym_override] = ACTIONS(2262),
    [anon_sym_GT2] = ACTIONS(2262),
  },
  [2945] = {
    [sym_attribute_specifier] = STATE(2904),
    [sym_enumerator_list] = STATE(2833),
    [sym__enum_base_clause] = STATE(2784),
    [sym_identifier] = ACTIONS(3502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3504),
    [anon_sym_COMMA] = ACTIONS(3504),
    [anon_sym_RPAREN] = ACTIONS(3504),
    [anon_sym_LPAREN2] = ACTIONS(3504),
    [anon_sym_TILDE] = ACTIONS(3504),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_AMP_AMP] = ACTIONS(3504),
    [anon_sym_AMP] = ACTIONS(3502),
    [anon_sym_COLON] = ACTIONS(7183),
    [anon_sym___extension__] = ACTIONS(3502),
    [anon_sym_in] = ACTIONS(3502),
    [anon_sym_out] = ACTIONS(3502),
    [anon_sym_inout] = ACTIONS(3502),
    [anon_sym_virtual] = ACTIONS(3502),
    [anon_sym_extern] = ACTIONS(3502),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_COLON_COLON] = ACTIONS(3504),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3504),
    [anon_sym___declspec] = ACTIONS(3502),
    [anon_sym___based] = ACTIONS(3502),
    [anon_sym_LBRACE] = ACTIONS(6963),
    [anon_sym_LBRACK] = ACTIONS(3502),
    [anon_sym_static] = ACTIONS(3502),
    [anon_sym_EQ] = ACTIONS(3504),
    [anon_sym_register] = ACTIONS(3502),
    [anon_sym_inline] = ACTIONS(3502),
    [anon_sym___inline] = ACTIONS(3502),
    [anon_sym___inline__] = ACTIONS(3502),
    [anon_sym___forceinline] = ACTIONS(3502),
    [anon_sym_thread_local] = ACTIONS(3502),
    [anon_sym___thread] = ACTIONS(3502),
    [anon_sym_const] = ACTIONS(3502),
    [anon_sym_constexpr] = ACTIONS(3502),
    [anon_sym_volatile] = ACTIONS(3502),
    [anon_sym_restrict] = ACTIONS(3502),
    [anon_sym___restrict__] = ACTIONS(3502),
    [anon_sym__Atomic] = ACTIONS(3502),
    [anon_sym__Noreturn] = ACTIONS(3502),
    [anon_sym_noreturn] = ACTIONS(3502),
    [anon_sym__Nonnull] = ACTIONS(3502),
    [anon_sym_mutable] = ACTIONS(3502),
    [anon_sym_constinit] = ACTIONS(3502),
    [anon_sym_consteval] = ACTIONS(3502),
    [anon_sym_alignas] = ACTIONS(3502),
    [anon_sym__Alignas] = ACTIONS(3502),
    [anon_sym_DOT] = ACTIONS(3502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3502),
    [anon_sym_let] = ACTIONS(3502),
    [anon_sym_This] = ACTIONS(3502),
    [anon_sym_decltype] = ACTIONS(3502),
    [anon_sym_template] = ACTIONS(3502),
    [anon_sym_GT2] = ACTIONS(3504),
    [anon_sym_operator] = ACTIONS(3502),
    [anon_sym_precise] = ACTIONS(3502),
    [anon_sym_shared] = ACTIONS(3502),
    [anon_sym_groupshared] = ACTIONS(3502),
    [anon_sym_uniform] = ACTIONS(3502),
    [anon_sym_row_major] = ACTIONS(3502),
    [anon_sym_column_major] = ACTIONS(3502),
    [anon_sym_globallycoherent] = ACTIONS(3502),
    [anon_sym_centroid] = ACTIONS(3502),
    [anon_sym_noperspective] = ACTIONS(3502),
    [anon_sym_nointerpolation] = ACTIONS(3502),
    [anon_sym_sample] = ACTIONS(3502),
    [anon_sym_linear] = ACTIONS(3502),
    [anon_sym_snorm] = ACTIONS(3502),
    [anon_sym_unorm] = ACTIONS(3502),
    [anon_sym_point] = ACTIONS(3502),
    [anon_sym_line] = ACTIONS(3502),
    [anon_sym_triangleadj] = ACTIONS(3502),
    [anon_sym_lineadj] = ACTIONS(3502),
    [anon_sym_triangle] = ACTIONS(3502),
  },
  [2946] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_COMMA] = ACTIONS(2306),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2304),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_PERCENT] = ACTIONS(2304),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE] = ACTIONS(2304),
    [anon_sym_CARET] = ACTIONS(2304),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_GT] = ACTIONS(2304),
    [anon_sym_GT_EQ] = ACTIONS(2304),
    [anon_sym_LT_EQ] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_LT_LT] = ACTIONS(2304),
    [anon_sym_GT_GT] = ACTIONS(2304),
    [anon_sym_COLON] = ACTIONS(2304),
    [anon_sym___extension__] = ACTIONS(2306),
    [anon_sym___attribute__] = ACTIONS(2306),
    [anon_sym___attribute] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_LBRACK] = ACTIONS(2306),
    [anon_sym_EQ] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2306),
    [anon_sym_volatile] = ACTIONS(2306),
    [anon_sym_restrict] = ACTIONS(2306),
    [anon_sym___restrict__] = ACTIONS(2306),
    [anon_sym__Atomic] = ACTIONS(2306),
    [anon_sym__Noreturn] = ACTIONS(2306),
    [anon_sym_noreturn] = ACTIONS(2306),
    [anon_sym__Nonnull] = ACTIONS(2306),
    [anon_sym_mutable] = ACTIONS(2306),
    [anon_sym_constinit] = ACTIONS(2306),
    [anon_sym_consteval] = ACTIONS(2306),
    [anon_sym_alignas] = ACTIONS(2306),
    [anon_sym__Alignas] = ACTIONS(2306),
    [anon_sym_QMARK] = ACTIONS(2306),
    [anon_sym_STAR_EQ] = ACTIONS(2306),
    [anon_sym_SLASH_EQ] = ACTIONS(2306),
    [anon_sym_PERCENT_EQ] = ACTIONS(2306),
    [anon_sym_PLUS_EQ] = ACTIONS(2306),
    [anon_sym_DASH_EQ] = ACTIONS(2306),
    [anon_sym_LT_LT_EQ] = ACTIONS(2306),
    [anon_sym_GT_GT_EQ] = ACTIONS(2304),
    [anon_sym_AMP_EQ] = ACTIONS(2306),
    [anon_sym_CARET_EQ] = ACTIONS(2306),
    [anon_sym_PIPE_EQ] = ACTIONS(2306),
    [anon_sym_and_eq] = ACTIONS(2306),
    [anon_sym_or_eq] = ACTIONS(2306),
    [anon_sym_xor_eq] = ACTIONS(2306),
    [anon_sym_LT_EQ_GT] = ACTIONS(2306),
    [anon_sym_or] = ACTIONS(2304),
    [anon_sym_and] = ACTIONS(2304),
    [anon_sym_bitor] = ACTIONS(2306),
    [anon_sym_xor] = ACTIONS(2304),
    [anon_sym_bitand] = ACTIONS(2306),
    [anon_sym_not_eq] = ACTIONS(2306),
    [anon_sym_is] = ACTIONS(2306),
    [anon_sym_as] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DOT] = ACTIONS(2304),
    [anon_sym_DOT_STAR] = ACTIONS(2306),
    [anon_sym_DASH_GT] = ACTIONS(2306),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2306),
    [anon_sym_let] = ACTIONS(2306),
    [anon_sym_This] = ACTIONS(2306),
    [anon_sym_final] = ACTIONS(2306),
    [anon_sym_override] = ACTIONS(2306),
    [anon_sym_GT2] = ACTIONS(2306),
  },
  [2947] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2310),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_LPAREN2] = ACTIONS(2310),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2308),
    [anon_sym_SLASH] = ACTIONS(2308),
    [anon_sym_PERCENT] = ACTIONS(2308),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_CARET] = ACTIONS(2308),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2310),
    [anon_sym_BANG_EQ] = ACTIONS(2310),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_EQ] = ACTIONS(2308),
    [anon_sym_LT_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_LT_LT] = ACTIONS(2308),
    [anon_sym_GT_GT] = ACTIONS(2308),
    [anon_sym_COLON] = ACTIONS(2308),
    [anon_sym___extension__] = ACTIONS(2310),
    [anon_sym___attribute__] = ACTIONS(2310),
    [anon_sym___attribute] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_LBRACK] = ACTIONS(2310),
    [anon_sym_EQ] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_constexpr] = ACTIONS(2310),
    [anon_sym_volatile] = ACTIONS(2310),
    [anon_sym_restrict] = ACTIONS(2310),
    [anon_sym___restrict__] = ACTIONS(2310),
    [anon_sym__Atomic] = ACTIONS(2310),
    [anon_sym__Noreturn] = ACTIONS(2310),
    [anon_sym_noreturn] = ACTIONS(2310),
    [anon_sym__Nonnull] = ACTIONS(2310),
    [anon_sym_mutable] = ACTIONS(2310),
    [anon_sym_constinit] = ACTIONS(2310),
    [anon_sym_consteval] = ACTIONS(2310),
    [anon_sym_alignas] = ACTIONS(2310),
    [anon_sym__Alignas] = ACTIONS(2310),
    [anon_sym_QMARK] = ACTIONS(2310),
    [anon_sym_STAR_EQ] = ACTIONS(2310),
    [anon_sym_SLASH_EQ] = ACTIONS(2310),
    [anon_sym_PERCENT_EQ] = ACTIONS(2310),
    [anon_sym_PLUS_EQ] = ACTIONS(2310),
    [anon_sym_DASH_EQ] = ACTIONS(2310),
    [anon_sym_LT_LT_EQ] = ACTIONS(2310),
    [anon_sym_GT_GT_EQ] = ACTIONS(2308),
    [anon_sym_AMP_EQ] = ACTIONS(2310),
    [anon_sym_CARET_EQ] = ACTIONS(2310),
    [anon_sym_PIPE_EQ] = ACTIONS(2310),
    [anon_sym_and_eq] = ACTIONS(2310),
    [anon_sym_or_eq] = ACTIONS(2310),
    [anon_sym_xor_eq] = ACTIONS(2310),
    [anon_sym_LT_EQ_GT] = ACTIONS(2310),
    [anon_sym_or] = ACTIONS(2308),
    [anon_sym_and] = ACTIONS(2308),
    [anon_sym_bitor] = ACTIONS(2310),
    [anon_sym_xor] = ACTIONS(2308),
    [anon_sym_bitand] = ACTIONS(2310),
    [anon_sym_not_eq] = ACTIONS(2310),
    [anon_sym_is] = ACTIONS(2310),
    [anon_sym_as] = ACTIONS(2310),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_DOT] = ACTIONS(2308),
    [anon_sym_DOT_STAR] = ACTIONS(2310),
    [anon_sym_DASH_GT] = ACTIONS(2310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2310),
    [anon_sym_let] = ACTIONS(2310),
    [anon_sym_This] = ACTIONS(2310),
    [anon_sym_final] = ACTIONS(2310),
    [anon_sym_override] = ACTIONS(2310),
    [anon_sym_GT2] = ACTIONS(2310),
  },
  [2948] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2314),
    [anon_sym_COMMA] = ACTIONS(2314),
    [anon_sym_LPAREN2] = ACTIONS(2314),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_SLASH] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2312),
    [anon_sym_PIPE_PIPE] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2314),
    [anon_sym_PIPE] = ACTIONS(2312),
    [anon_sym_CARET] = ACTIONS(2312),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_EQ_EQ] = ACTIONS(2314),
    [anon_sym_BANG_EQ] = ACTIONS(2314),
    [anon_sym_GT] = ACTIONS(2312),
    [anon_sym_GT_EQ] = ACTIONS(2312),
    [anon_sym_LT_EQ] = ACTIONS(2312),
    [anon_sym_LT] = ACTIONS(2312),
    [anon_sym_LT_LT] = ACTIONS(2312),
    [anon_sym_GT_GT] = ACTIONS(2312),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym___extension__] = ACTIONS(2314),
    [anon_sym___attribute__] = ACTIONS(2314),
    [anon_sym___attribute] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_LBRACK] = ACTIONS(2314),
    [anon_sym_EQ] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_constexpr] = ACTIONS(2314),
    [anon_sym_volatile] = ACTIONS(2314),
    [anon_sym_restrict] = ACTIONS(2314),
    [anon_sym___restrict__] = ACTIONS(2314),
    [anon_sym__Atomic] = ACTIONS(2314),
    [anon_sym__Noreturn] = ACTIONS(2314),
    [anon_sym_noreturn] = ACTIONS(2314),
    [anon_sym__Nonnull] = ACTIONS(2314),
    [anon_sym_mutable] = ACTIONS(2314),
    [anon_sym_constinit] = ACTIONS(2314),
    [anon_sym_consteval] = ACTIONS(2314),
    [anon_sym_alignas] = ACTIONS(2314),
    [anon_sym__Alignas] = ACTIONS(2314),
    [anon_sym_QMARK] = ACTIONS(2314),
    [anon_sym_STAR_EQ] = ACTIONS(2314),
    [anon_sym_SLASH_EQ] = ACTIONS(2314),
    [anon_sym_PERCENT_EQ] = ACTIONS(2314),
    [anon_sym_PLUS_EQ] = ACTIONS(2314),
    [anon_sym_DASH_EQ] = ACTIONS(2314),
    [anon_sym_LT_LT_EQ] = ACTIONS(2314),
    [anon_sym_GT_GT_EQ] = ACTIONS(2312),
    [anon_sym_AMP_EQ] = ACTIONS(2314),
    [anon_sym_CARET_EQ] = ACTIONS(2314),
    [anon_sym_PIPE_EQ] = ACTIONS(2314),
    [anon_sym_and_eq] = ACTIONS(2314),
    [anon_sym_or_eq] = ACTIONS(2314),
    [anon_sym_xor_eq] = ACTIONS(2314),
    [anon_sym_LT_EQ_GT] = ACTIONS(2314),
    [anon_sym_or] = ACTIONS(2312),
    [anon_sym_and] = ACTIONS(2312),
    [anon_sym_bitor] = ACTIONS(2314),
    [anon_sym_xor] = ACTIONS(2312),
    [anon_sym_bitand] = ACTIONS(2314),
    [anon_sym_not_eq] = ACTIONS(2314),
    [anon_sym_is] = ACTIONS(2314),
    [anon_sym_as] = ACTIONS(2314),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_DOT] = ACTIONS(2312),
    [anon_sym_DOT_STAR] = ACTIONS(2314),
    [anon_sym_DASH_GT] = ACTIONS(2314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2314),
    [anon_sym_let] = ACTIONS(2314),
    [anon_sym_This] = ACTIONS(2314),
    [anon_sym_final] = ACTIONS(2314),
    [anon_sym_override] = ACTIONS(2314),
    [anon_sym_GT2] = ACTIONS(2314),
  },
  [2949] = {
    [sym_identifier] = ACTIONS(4716),
    [anon_sym_LPAREN2] = ACTIONS(4718),
    [anon_sym_BANG] = ACTIONS(4718),
    [anon_sym_TILDE] = ACTIONS(4718),
    [anon_sym_DASH] = ACTIONS(4716),
    [anon_sym_PLUS] = ACTIONS(4716),
    [anon_sym_STAR] = ACTIONS(4718),
    [anon_sym_AMP] = ACTIONS(4718),
    [anon_sym_SEMI] = ACTIONS(4718),
    [anon_sym___extension__] = ACTIONS(4716),
    [anon_sym_using] = ACTIONS(4716),
    [anon_sym_COLON_COLON] = ACTIONS(4718),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4718),
    [anon_sym_LBRACE] = ACTIONS(4718),
    [anon_sym_LBRACK] = ACTIONS(4716),
    [sym_primitive_type] = ACTIONS(4716),
    [anon_sym_if] = ACTIONS(4716),
    [anon_sym_switch] = ACTIONS(4716),
    [anon_sym_case] = ACTIONS(4716),
    [anon_sym_default] = ACTIONS(4716),
    [anon_sym_while] = ACTIONS(4716),
    [anon_sym_do] = ACTIONS(4716),
    [anon_sym_for] = ACTIONS(4716),
    [anon_sym_return] = ACTIONS(4716),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_continue] = ACTIONS(4716),
    [anon_sym_goto] = ACTIONS(4716),
    [anon_sym___try] = ACTIONS(4716),
    [anon_sym___leave] = ACTIONS(4716),
    [anon_sym_not] = ACTIONS(4716),
    [anon_sym_compl] = ACTIONS(4716),
    [anon_sym_DASH_DASH] = ACTIONS(4718),
    [anon_sym_PLUS_PLUS] = ACTIONS(4718),
    [anon_sym_sizeof] = ACTIONS(4716),
    [anon_sym___alignof__] = ACTIONS(4716),
    [anon_sym___alignof] = ACTIONS(4716),
    [anon_sym__alignof] = ACTIONS(4716),
    [anon_sym_alignof] = ACTIONS(4716),
    [anon_sym__Alignof] = ACTIONS(4716),
    [anon_sym_offsetof] = ACTIONS(4716),
    [anon_sym__Generic] = ACTIONS(4716),
    [anon_sym_asm] = ACTIONS(4716),
    [anon_sym___asm__] = ACTIONS(4716),
    [anon_sym___asm] = ACTIONS(4716),
    [sym_number_literal] = ACTIONS(4718),
    [anon_sym_L_SQUOTE] = ACTIONS(4718),
    [anon_sym_u_SQUOTE] = ACTIONS(4718),
    [anon_sym_U_SQUOTE] = ACTIONS(4718),
    [anon_sym_u8_SQUOTE] = ACTIONS(4718),
    [anon_sym_SQUOTE] = ACTIONS(4718),
    [anon_sym_L_DQUOTE] = ACTIONS(4718),
    [anon_sym_u_DQUOTE] = ACTIONS(4718),
    [anon_sym_U_DQUOTE] = ACTIONS(4718),
    [anon_sym_u8_DQUOTE] = ACTIONS(4718),
    [anon_sym_DQUOTE] = ACTIONS(4718),
    [sym_true] = ACTIONS(4716),
    [sym_false] = ACTIONS(4716),
    [anon_sym_NULL] = ACTIONS(4716),
    [anon_sym_nullptr] = ACTIONS(4716),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4716),
    [anon_sym_template] = ACTIONS(4716),
    [anon_sym_try] = ACTIONS(4716),
    [anon_sym_delete] = ACTIONS(4716),
    [anon_sym_throw] = ACTIONS(4716),
    [anon_sym_co_return] = ACTIONS(4716),
    [anon_sym_co_yield] = ACTIONS(4716),
    [anon_sym_R_DQUOTE] = ACTIONS(4718),
    [anon_sym_LR_DQUOTE] = ACTIONS(4718),
    [anon_sym_uR_DQUOTE] = ACTIONS(4718),
    [anon_sym_UR_DQUOTE] = ACTIONS(4718),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4718),
    [anon_sym_co_await] = ACTIONS(4716),
    [anon_sym_new] = ACTIONS(4716),
    [anon_sym_requires] = ACTIONS(4716),
    [sym_this] = ACTIONS(4716),
    [anon_sym_discard] = ACTIONS(4716),
    [anon_sym_cbuffer] = ACTIONS(4716),
  },
  [2950] = {
    [sym_identifier] = ACTIONS(4242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4240),
    [anon_sym_COMMA] = ACTIONS(4240),
    [anon_sym_RPAREN] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4242),
    [anon_sym_PLUS] = ACTIONS(4242),
    [anon_sym_STAR] = ACTIONS(4242),
    [anon_sym_SLASH] = ACTIONS(4242),
    [anon_sym_PERCENT] = ACTIONS(4242),
    [anon_sym_PIPE_PIPE] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_PIPE] = ACTIONS(4242),
    [anon_sym_CARET] = ACTIONS(4242),
    [anon_sym_AMP] = ACTIONS(4242),
    [anon_sym_EQ_EQ] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(4240),
    [anon_sym_GT] = ACTIONS(4242),
    [anon_sym_GT_EQ] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(4242),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_LT_LT] = ACTIONS(4242),
    [anon_sym_GT_GT] = ACTIONS(4242),
    [anon_sym___extension__] = ACTIONS(4242),
    [anon_sym___attribute__] = ACTIONS(4242),
    [anon_sym___attribute] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_signed] = ACTIONS(4242),
    [anon_sym_unsigned] = ACTIONS(4242),
    [anon_sym_long] = ACTIONS(4242),
    [anon_sym_short] = ACTIONS(4242),
    [anon_sym_LBRACK] = ACTIONS(4240),
    [anon_sym_EQ] = ACTIONS(4242),
    [anon_sym_const] = ACTIONS(4242),
    [anon_sym_constexpr] = ACTIONS(4242),
    [anon_sym_volatile] = ACTIONS(4242),
    [anon_sym_restrict] = ACTIONS(4242),
    [anon_sym___restrict__] = ACTIONS(4242),
    [anon_sym__Atomic] = ACTIONS(4242),
    [anon_sym__Noreturn] = ACTIONS(4242),
    [anon_sym_noreturn] = ACTIONS(4242),
    [anon_sym__Nonnull] = ACTIONS(4242),
    [anon_sym_mutable] = ACTIONS(4242),
    [anon_sym_constinit] = ACTIONS(4242),
    [anon_sym_consteval] = ACTIONS(4242),
    [anon_sym_alignas] = ACTIONS(4242),
    [anon_sym__Alignas] = ACTIONS(4242),
    [sym_primitive_type] = ACTIONS(4242),
    [anon_sym_QMARK] = ACTIONS(4240),
    [anon_sym_STAR_EQ] = ACTIONS(4240),
    [anon_sym_SLASH_EQ] = ACTIONS(4240),
    [anon_sym_PERCENT_EQ] = ACTIONS(4240),
    [anon_sym_PLUS_EQ] = ACTIONS(4240),
    [anon_sym_DASH_EQ] = ACTIONS(4240),
    [anon_sym_LT_LT_EQ] = ACTIONS(4240),
    [anon_sym_GT_GT_EQ] = ACTIONS(4240),
    [anon_sym_AMP_EQ] = ACTIONS(4240),
    [anon_sym_CARET_EQ] = ACTIONS(4240),
    [anon_sym_PIPE_EQ] = ACTIONS(4240),
    [anon_sym_LT_EQ_GT] = ACTIONS(4240),
    [anon_sym_or] = ACTIONS(4242),
    [anon_sym_and] = ACTIONS(4242),
    [anon_sym_bitor] = ACTIONS(4242),
    [anon_sym_xor] = ACTIONS(4242),
    [anon_sym_bitand] = ACTIONS(4242),
    [anon_sym_not_eq] = ACTIONS(4242),
    [anon_sym_is] = ACTIONS(4242),
    [anon_sym_as] = ACTIONS(4242),
    [anon_sym_DASH_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_PLUS] = ACTIONS(4240),
    [anon_sym_DOT] = ACTIONS(4242),
    [anon_sym_DOT_STAR] = ACTIONS(4240),
    [anon_sym_DASH_GT] = ACTIONS(4242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4242),
    [anon_sym_let] = ACTIONS(4242),
    [anon_sym_This] = ACTIONS(4242),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4240),
  },
  [2951] = {
    [sym_identifier] = ACTIONS(4860),
    [anon_sym_LPAREN2] = ACTIONS(4862),
    [anon_sym_BANG] = ACTIONS(4862),
    [anon_sym_TILDE] = ACTIONS(4862),
    [anon_sym_DASH] = ACTIONS(4860),
    [anon_sym_PLUS] = ACTIONS(4860),
    [anon_sym_STAR] = ACTIONS(4862),
    [anon_sym_AMP] = ACTIONS(4862),
    [anon_sym_SEMI] = ACTIONS(4862),
    [anon_sym___extension__] = ACTIONS(4860),
    [anon_sym_using] = ACTIONS(4860),
    [anon_sym_COLON_COLON] = ACTIONS(4862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4862),
    [anon_sym_LBRACE] = ACTIONS(4862),
    [anon_sym_LBRACK] = ACTIONS(4860),
    [sym_primitive_type] = ACTIONS(4860),
    [anon_sym_if] = ACTIONS(4860),
    [anon_sym_switch] = ACTIONS(4860),
    [anon_sym_case] = ACTIONS(4860),
    [anon_sym_default] = ACTIONS(4860),
    [anon_sym_while] = ACTIONS(4860),
    [anon_sym_do] = ACTIONS(4860),
    [anon_sym_for] = ACTIONS(4860),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_break] = ACTIONS(4860),
    [anon_sym_continue] = ACTIONS(4860),
    [anon_sym_goto] = ACTIONS(4860),
    [anon_sym___try] = ACTIONS(4860),
    [anon_sym___leave] = ACTIONS(4860),
    [anon_sym_not] = ACTIONS(4860),
    [anon_sym_compl] = ACTIONS(4860),
    [anon_sym_DASH_DASH] = ACTIONS(4862),
    [anon_sym_PLUS_PLUS] = ACTIONS(4862),
    [anon_sym_sizeof] = ACTIONS(4860),
    [anon_sym___alignof__] = ACTIONS(4860),
    [anon_sym___alignof] = ACTIONS(4860),
    [anon_sym__alignof] = ACTIONS(4860),
    [anon_sym_alignof] = ACTIONS(4860),
    [anon_sym__Alignof] = ACTIONS(4860),
    [anon_sym_offsetof] = ACTIONS(4860),
    [anon_sym__Generic] = ACTIONS(4860),
    [anon_sym_asm] = ACTIONS(4860),
    [anon_sym___asm__] = ACTIONS(4860),
    [anon_sym___asm] = ACTIONS(4860),
    [sym_number_literal] = ACTIONS(4862),
    [anon_sym_L_SQUOTE] = ACTIONS(4862),
    [anon_sym_u_SQUOTE] = ACTIONS(4862),
    [anon_sym_U_SQUOTE] = ACTIONS(4862),
    [anon_sym_u8_SQUOTE] = ACTIONS(4862),
    [anon_sym_SQUOTE] = ACTIONS(4862),
    [anon_sym_L_DQUOTE] = ACTIONS(4862),
    [anon_sym_u_DQUOTE] = ACTIONS(4862),
    [anon_sym_U_DQUOTE] = ACTIONS(4862),
    [anon_sym_u8_DQUOTE] = ACTIONS(4862),
    [anon_sym_DQUOTE] = ACTIONS(4862),
    [sym_true] = ACTIONS(4860),
    [sym_false] = ACTIONS(4860),
    [anon_sym_NULL] = ACTIONS(4860),
    [anon_sym_nullptr] = ACTIONS(4860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4860),
    [anon_sym_template] = ACTIONS(4860),
    [anon_sym_try] = ACTIONS(4860),
    [anon_sym_delete] = ACTIONS(4860),
    [anon_sym_throw] = ACTIONS(4860),
    [anon_sym_co_return] = ACTIONS(4860),
    [anon_sym_co_yield] = ACTIONS(4860),
    [anon_sym_R_DQUOTE] = ACTIONS(4862),
    [anon_sym_LR_DQUOTE] = ACTIONS(4862),
    [anon_sym_uR_DQUOTE] = ACTIONS(4862),
    [anon_sym_UR_DQUOTE] = ACTIONS(4862),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4862),
    [anon_sym_co_await] = ACTIONS(4860),
    [anon_sym_new] = ACTIONS(4860),
    [anon_sym_requires] = ACTIONS(4860),
    [sym_this] = ACTIONS(4860),
    [anon_sym_discard] = ACTIONS(4860),
    [anon_sym_cbuffer] = ACTIONS(4860),
  },
  [2952] = {
    [sym_string_literal] = STATE(2970),
    [sym_template_argument_list] = STATE(3325),
    [sym_raw_string_literal] = STATE(2970),
    [sym_identifier] = ACTIONS(2181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_RPAREN] = ACTIONS(2170),
    [aux_sym_preproc_if_token2] = ACTIONS(2170),
    [aux_sym_preproc_else_token1] = ACTIONS(2170),
    [aux_sym_preproc_elif_token1] = ACTIONS(2181),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2170),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(7185),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(2181),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_RBRACE] = ACTIONS(2170),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_RBRACK] = ACTIONS(2170),
    [anon_sym_EQ] = ACTIONS(2181),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2170),
    [anon_sym_SLASH_EQ] = ACTIONS(2170),
    [anon_sym_PERCENT_EQ] = ACTIONS(2170),
    [anon_sym_PLUS_EQ] = ACTIONS(2170),
    [anon_sym_DASH_EQ] = ACTIONS(2170),
    [anon_sym_LT_LT_EQ] = ACTIONS(2170),
    [anon_sym_GT_GT_EQ] = ACTIONS(2170),
    [anon_sym_AMP_EQ] = ACTIONS(2170),
    [anon_sym_CARET_EQ] = ACTIONS(2170),
    [anon_sym_PIPE_EQ] = ACTIONS(2170),
    [anon_sym_and_eq] = ACTIONS(2181),
    [anon_sym_or_eq] = ACTIONS(2181),
    [anon_sym_xor_eq] = ACTIONS(2181),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
  },
  [2953] = {
    [sym_identifier] = ACTIONS(2243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_RPAREN] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2243),
    [anon_sym_PLUS] = ACTIONS(2243),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_SLASH] = ACTIONS(2243),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2243),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_EQ_EQ] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2243),
    [anon_sym_GT_EQ] = ACTIONS(2250),
    [anon_sym_LT_EQ] = ACTIONS(2243),
    [anon_sym_LT] = ACTIONS(2243),
    [anon_sym_LT_LT] = ACTIONS(2250),
    [anon_sym_GT_GT] = ACTIONS(2250),
    [anon_sym_COLON] = ACTIONS(2243),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym___attribute] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym___based] = ACTIONS(2243),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_signed] = ACTIONS(2243),
    [anon_sym_unsigned] = ACTIONS(2243),
    [anon_sym_long] = ACTIONS(2243),
    [anon_sym_short] = ACTIONS(2243),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_RBRACK] = ACTIONS(2250),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym__Nonnull] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [sym_primitive_type] = ACTIONS(2243),
    [anon_sym_else] = ACTIONS(2243),
    [anon_sym_while] = ACTIONS(2243),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_LT_EQ_GT] = ACTIONS(2250),
    [anon_sym_or] = ACTIONS(2243),
    [anon_sym_and] = ACTIONS(2243),
    [anon_sym_bitor] = ACTIONS(2243),
    [anon_sym_xor] = ACTIONS(2243),
    [anon_sym_bitand] = ACTIONS(2243),
    [anon_sym_not_eq] = ACTIONS(2243),
    [anon_sym_is] = ACTIONS(2243),
    [anon_sym_as] = ACTIONS(2243),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2243),
    [anon_sym_DOT_STAR] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2243),
    [anon_sym_let] = ACTIONS(2243),
    [anon_sym_This] = ACTIONS(2243),
    [anon_sym_final] = ACTIONS(2243),
    [anon_sym_override] = ACTIONS(2243),
    [anon_sym_requires] = ACTIONS(2243),
    [anon_sym_where] = ACTIONS(2243),
  },
  [2954] = {
    [sym_identifier] = ACTIONS(7162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7164),
    [anon_sym_COMMA] = ACTIONS(7164),
    [anon_sym_RPAREN] = ACTIONS(7164),
    [anon_sym_LPAREN2] = ACTIONS(7164),
    [anon_sym_TILDE] = ACTIONS(7164),
    [anon_sym_STAR] = ACTIONS(7164),
    [anon_sym_AMP_AMP] = ACTIONS(7164),
    [anon_sym_AMP] = ACTIONS(7162),
    [anon_sym_COLON] = ACTIONS(7162),
    [anon_sym_SEMI] = ACTIONS(7164),
    [anon_sym___extension__] = ACTIONS(7162),
    [anon_sym_in] = ACTIONS(7162),
    [anon_sym_out] = ACTIONS(7162),
    [anon_sym_inout] = ACTIONS(7162),
    [anon_sym_virtual] = ACTIONS(7162),
    [anon_sym_extern] = ACTIONS(7162),
    [anon_sym___attribute__] = ACTIONS(7162),
    [anon_sym___attribute] = ACTIONS(7162),
    [anon_sym_COLON_COLON] = ACTIONS(7164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7164),
    [anon_sym___declspec] = ACTIONS(7162),
    [anon_sym___based] = ACTIONS(7162),
    [anon_sym___cdecl] = ACTIONS(7162),
    [anon_sym___clrcall] = ACTIONS(7162),
    [anon_sym___stdcall] = ACTIONS(7162),
    [anon_sym___fastcall] = ACTIONS(7162),
    [anon_sym___thiscall] = ACTIONS(7162),
    [anon_sym___vectorcall] = ACTIONS(7162),
    [anon_sym_LBRACK] = ACTIONS(7162),
    [anon_sym_static] = ACTIONS(7162),
    [anon_sym_EQ] = ACTIONS(7164),
    [anon_sym_register] = ACTIONS(7162),
    [anon_sym_inline] = ACTIONS(7162),
    [anon_sym___inline] = ACTIONS(7162),
    [anon_sym___inline__] = ACTIONS(7162),
    [anon_sym___forceinline] = ACTIONS(7162),
    [anon_sym_thread_local] = ACTIONS(7162),
    [anon_sym___thread] = ACTIONS(7162),
    [anon_sym_const] = ACTIONS(7162),
    [anon_sym_constexpr] = ACTIONS(7162),
    [anon_sym_volatile] = ACTIONS(7162),
    [anon_sym_restrict] = ACTIONS(7162),
    [anon_sym___restrict__] = ACTIONS(7162),
    [anon_sym__Atomic] = ACTIONS(7162),
    [anon_sym__Noreturn] = ACTIONS(7162),
    [anon_sym_noreturn] = ACTIONS(7162),
    [anon_sym__Nonnull] = ACTIONS(7162),
    [anon_sym_mutable] = ACTIONS(7162),
    [anon_sym_constinit] = ACTIONS(7162),
    [anon_sym_consteval] = ACTIONS(7162),
    [anon_sym_alignas] = ACTIONS(7162),
    [anon_sym__Alignas] = ACTIONS(7162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(7162),
    [anon_sym_explicit] = ACTIONS(7162),
    [anon_sym_template] = ACTIONS(7162),
    [anon_sym_GT2] = ACTIONS(7164),
    [anon_sym_operator] = ACTIONS(7162),
    [anon_sym_precise] = ACTIONS(7162),
    [anon_sym_shared] = ACTIONS(7162),
    [anon_sym_groupshared] = ACTIONS(7162),
    [anon_sym_uniform] = ACTIONS(7162),
    [anon_sym_row_major] = ACTIONS(7162),
    [anon_sym_column_major] = ACTIONS(7162),
    [anon_sym_globallycoherent] = ACTIONS(7162),
    [anon_sym_centroid] = ACTIONS(7162),
    [anon_sym_noperspective] = ACTIONS(7162),
    [anon_sym_nointerpolation] = ACTIONS(7162),
    [anon_sym_sample] = ACTIONS(7162),
    [anon_sym_linear] = ACTIONS(7162),
    [anon_sym_snorm] = ACTIONS(7162),
    [anon_sym_unorm] = ACTIONS(7162),
    [anon_sym_point] = ACTIONS(7162),
    [anon_sym_line] = ACTIONS(7162),
    [anon_sym_triangleadj] = ACTIONS(7162),
    [anon_sym_lineadj] = ACTIONS(7162),
    [anon_sym_triangle] = ACTIONS(7162),
  },
  [2955] = {
    [sym_identifier] = ACTIONS(6895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6897),
    [anon_sym_COMMA] = ACTIONS(6897),
    [anon_sym_RPAREN] = ACTIONS(6897),
    [anon_sym_LPAREN2] = ACTIONS(6897),
    [anon_sym_TILDE] = ACTIONS(6897),
    [anon_sym_STAR] = ACTIONS(6897),
    [anon_sym_AMP_AMP] = ACTIONS(6897),
    [anon_sym_AMP] = ACTIONS(6895),
    [anon_sym_COLON] = ACTIONS(6895),
    [anon_sym_SEMI] = ACTIONS(6897),
    [anon_sym___extension__] = ACTIONS(6895),
    [anon_sym_in] = ACTIONS(6895),
    [anon_sym_out] = ACTIONS(6895),
    [anon_sym_inout] = ACTIONS(6895),
    [anon_sym_virtual] = ACTIONS(6895),
    [anon_sym_extern] = ACTIONS(6895),
    [anon_sym___attribute__] = ACTIONS(6895),
    [anon_sym___attribute] = ACTIONS(6895),
    [anon_sym_COLON_COLON] = ACTIONS(6897),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6897),
    [anon_sym___declspec] = ACTIONS(6895),
    [anon_sym___based] = ACTIONS(6895),
    [anon_sym___cdecl] = ACTIONS(6895),
    [anon_sym___clrcall] = ACTIONS(6895),
    [anon_sym___stdcall] = ACTIONS(6895),
    [anon_sym___fastcall] = ACTIONS(6895),
    [anon_sym___thiscall] = ACTIONS(6895),
    [anon_sym___vectorcall] = ACTIONS(6895),
    [anon_sym_LBRACK] = ACTIONS(6895),
    [anon_sym_static] = ACTIONS(6895),
    [anon_sym_EQ] = ACTIONS(6897),
    [anon_sym_register] = ACTIONS(6895),
    [anon_sym_inline] = ACTIONS(6895),
    [anon_sym___inline] = ACTIONS(6895),
    [anon_sym___inline__] = ACTIONS(6895),
    [anon_sym___forceinline] = ACTIONS(6895),
    [anon_sym_thread_local] = ACTIONS(6895),
    [anon_sym___thread] = ACTIONS(6895),
    [anon_sym_const] = ACTIONS(6895),
    [anon_sym_constexpr] = ACTIONS(6895),
    [anon_sym_volatile] = ACTIONS(6895),
    [anon_sym_restrict] = ACTIONS(6895),
    [anon_sym___restrict__] = ACTIONS(6895),
    [anon_sym__Atomic] = ACTIONS(6895),
    [anon_sym__Noreturn] = ACTIONS(6895),
    [anon_sym_noreturn] = ACTIONS(6895),
    [anon_sym__Nonnull] = ACTIONS(6895),
    [anon_sym_mutable] = ACTIONS(6895),
    [anon_sym_constinit] = ACTIONS(6895),
    [anon_sym_consteval] = ACTIONS(6895),
    [anon_sym_alignas] = ACTIONS(6895),
    [anon_sym__Alignas] = ACTIONS(6895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6895),
    [anon_sym_explicit] = ACTIONS(6895),
    [anon_sym_template] = ACTIONS(6895),
    [anon_sym_GT2] = ACTIONS(6897),
    [anon_sym_operator] = ACTIONS(6895),
    [anon_sym_precise] = ACTIONS(6895),
    [anon_sym_shared] = ACTIONS(6895),
    [anon_sym_groupshared] = ACTIONS(6895),
    [anon_sym_uniform] = ACTIONS(6895),
    [anon_sym_row_major] = ACTIONS(6895),
    [anon_sym_column_major] = ACTIONS(6895),
    [anon_sym_globallycoherent] = ACTIONS(6895),
    [anon_sym_centroid] = ACTIONS(6895),
    [anon_sym_noperspective] = ACTIONS(6895),
    [anon_sym_nointerpolation] = ACTIONS(6895),
    [anon_sym_sample] = ACTIONS(6895),
    [anon_sym_linear] = ACTIONS(6895),
    [anon_sym_snorm] = ACTIONS(6895),
    [anon_sym_unorm] = ACTIONS(6895),
    [anon_sym_point] = ACTIONS(6895),
    [anon_sym_line] = ACTIONS(6895),
    [anon_sym_triangleadj] = ACTIONS(6895),
    [anon_sym_lineadj] = ACTIONS(6895),
    [anon_sym_triangle] = ACTIONS(6895),
  },
  [2956] = {
    [sym_template_argument_list] = STATE(2722),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2408),
    [anon_sym_COMMA] = ACTIONS(7154),
    [anon_sym_LPAREN2] = ACTIONS(2408),
    [anon_sym_TILDE] = ACTIONS(2408),
    [anon_sym_STAR] = ACTIONS(2408),
    [anon_sym_AMP_AMP] = ACTIONS(2408),
    [anon_sym_AMP] = ACTIONS(2410),
    [anon_sym_LT] = ACTIONS(7118),
    [anon_sym_COLON] = ACTIONS(2410),
    [anon_sym___extension__] = ACTIONS(2410),
    [anon_sym_in] = ACTIONS(2410),
    [anon_sym_out] = ACTIONS(2410),
    [anon_sym_inout] = ACTIONS(2410),
    [anon_sym_virtual] = ACTIONS(2410),
    [anon_sym_extern] = ACTIONS(2410),
    [anon_sym___attribute__] = ACTIONS(2410),
    [anon_sym___attribute] = ACTIONS(2410),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2408),
    [anon_sym___declspec] = ACTIONS(2410),
    [anon_sym___based] = ACTIONS(2410),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_static] = ACTIONS(2410),
    [anon_sym_EQ] = ACTIONS(7156),
    [anon_sym_register] = ACTIONS(2410),
    [anon_sym_inline] = ACTIONS(2410),
    [anon_sym___inline] = ACTIONS(2410),
    [anon_sym___inline__] = ACTIONS(2410),
    [anon_sym___forceinline] = ACTIONS(2410),
    [anon_sym_thread_local] = ACTIONS(2410),
    [anon_sym___thread] = ACTIONS(2410),
    [anon_sym_const] = ACTIONS(2410),
    [anon_sym_constexpr] = ACTIONS(2410),
    [anon_sym_volatile] = ACTIONS(2410),
    [anon_sym_restrict] = ACTIONS(2410),
    [anon_sym___restrict__] = ACTIONS(2410),
    [anon_sym__Atomic] = ACTIONS(2410),
    [anon_sym__Noreturn] = ACTIONS(2410),
    [anon_sym_noreturn] = ACTIONS(2410),
    [anon_sym__Nonnull] = ACTIONS(2410),
    [anon_sym_mutable] = ACTIONS(2410),
    [anon_sym_constinit] = ACTIONS(2410),
    [anon_sym_consteval] = ACTIONS(2410),
    [anon_sym_alignas] = ACTIONS(2410),
    [anon_sym__Alignas] = ACTIONS(2410),
    [anon_sym_DOT] = ACTIONS(2410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2410),
    [anon_sym_let] = ACTIONS(2410),
    [anon_sym_This] = ACTIONS(2410),
    [anon_sym_decltype] = ACTIONS(2410),
    [anon_sym_final] = ACTIONS(2410),
    [anon_sym_override] = ACTIONS(2410),
    [anon_sym_template] = ACTIONS(2410),
    [anon_sym_GT2] = ACTIONS(7154),
    [anon_sym_operator] = ACTIONS(2410),
    [anon_sym_precise] = ACTIONS(2410),
    [anon_sym_shared] = ACTIONS(2410),
    [anon_sym_groupshared] = ACTIONS(2410),
    [anon_sym_uniform] = ACTIONS(2410),
    [anon_sym_row_major] = ACTIONS(2410),
    [anon_sym_column_major] = ACTIONS(2410),
    [anon_sym_globallycoherent] = ACTIONS(2410),
    [anon_sym_centroid] = ACTIONS(2410),
    [anon_sym_noperspective] = ACTIONS(2410),
    [anon_sym_nointerpolation] = ACTIONS(2410),
    [anon_sym_sample] = ACTIONS(2410),
    [anon_sym_linear] = ACTIONS(2410),
    [anon_sym_snorm] = ACTIONS(2410),
    [anon_sym_unorm] = ACTIONS(2410),
    [anon_sym_point] = ACTIONS(2410),
    [anon_sym_line] = ACTIONS(2410),
    [anon_sym_triangleadj] = ACTIONS(2410),
    [anon_sym_lineadj] = ACTIONS(2410),
    [anon_sym_triangle] = ACTIONS(2410),
  },
  [2957] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2270),
    [anon_sym_COMMA] = ACTIONS(2270),
    [anon_sym_LPAREN2] = ACTIONS(2270),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2268),
    [anon_sym_SLASH] = ACTIONS(2268),
    [anon_sym_PERCENT] = ACTIONS(2268),
    [anon_sym_PIPE_PIPE] = ACTIONS(2270),
    [anon_sym_AMP_AMP] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2268),
    [anon_sym_CARET] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2268),
    [anon_sym_EQ_EQ] = ACTIONS(2270),
    [anon_sym_BANG_EQ] = ACTIONS(2270),
    [anon_sym_GT] = ACTIONS(2268),
    [anon_sym_GT_EQ] = ACTIONS(2268),
    [anon_sym_LT_EQ] = ACTIONS(2268),
    [anon_sym_LT] = ACTIONS(2268),
    [anon_sym_LT_LT] = ACTIONS(2268),
    [anon_sym_GT_GT] = ACTIONS(2268),
    [anon_sym_COLON] = ACTIONS(2268),
    [anon_sym___extension__] = ACTIONS(2270),
    [anon_sym___attribute__] = ACTIONS(2270),
    [anon_sym___attribute] = ACTIONS(2268),
    [anon_sym_COLON_COLON] = ACTIONS(2270),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_LBRACK] = ACTIONS(2270),
    [anon_sym_EQ] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_constexpr] = ACTIONS(2270),
    [anon_sym_volatile] = ACTIONS(2270),
    [anon_sym_restrict] = ACTIONS(2270),
    [anon_sym___restrict__] = ACTIONS(2270),
    [anon_sym__Atomic] = ACTIONS(2270),
    [anon_sym__Noreturn] = ACTIONS(2270),
    [anon_sym_noreturn] = ACTIONS(2270),
    [anon_sym__Nonnull] = ACTIONS(2270),
    [anon_sym_mutable] = ACTIONS(2270),
    [anon_sym_constinit] = ACTIONS(2270),
    [anon_sym_consteval] = ACTIONS(2270),
    [anon_sym_alignas] = ACTIONS(2270),
    [anon_sym__Alignas] = ACTIONS(2270),
    [anon_sym_QMARK] = ACTIONS(2270),
    [anon_sym_STAR_EQ] = ACTIONS(2270),
    [anon_sym_SLASH_EQ] = ACTIONS(2270),
    [anon_sym_PERCENT_EQ] = ACTIONS(2270),
    [anon_sym_PLUS_EQ] = ACTIONS(2270),
    [anon_sym_DASH_EQ] = ACTIONS(2270),
    [anon_sym_LT_LT_EQ] = ACTIONS(2270),
    [anon_sym_GT_GT_EQ] = ACTIONS(2268),
    [anon_sym_AMP_EQ] = ACTIONS(2270),
    [anon_sym_CARET_EQ] = ACTIONS(2270),
    [anon_sym_PIPE_EQ] = ACTIONS(2270),
    [anon_sym_and_eq] = ACTIONS(2270),
    [anon_sym_or_eq] = ACTIONS(2270),
    [anon_sym_xor_eq] = ACTIONS(2270),
    [anon_sym_LT_EQ_GT] = ACTIONS(2270),
    [anon_sym_or] = ACTIONS(2268),
    [anon_sym_and] = ACTIONS(2268),
    [anon_sym_bitor] = ACTIONS(2270),
    [anon_sym_xor] = ACTIONS(2268),
    [anon_sym_bitand] = ACTIONS(2270),
    [anon_sym_not_eq] = ACTIONS(2270),
    [anon_sym_is] = ACTIONS(2270),
    [anon_sym_as] = ACTIONS(2270),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_DOT] = ACTIONS(2268),
    [anon_sym_DOT_STAR] = ACTIONS(2270),
    [anon_sym_DASH_GT] = ACTIONS(2270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2270),
    [anon_sym_let] = ACTIONS(2270),
    [anon_sym_This] = ACTIONS(2270),
    [anon_sym_final] = ACTIONS(2270),
    [anon_sym_override] = ACTIONS(2270),
    [anon_sym_GT2] = ACTIONS(2270),
  },
  [2958] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2274),
    [anon_sym_COMMA] = ACTIONS(2274),
    [anon_sym_LPAREN2] = ACTIONS(2274),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2272),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_PERCENT] = ACTIONS(2272),
    [anon_sym_PIPE_PIPE] = ACTIONS(2274),
    [anon_sym_AMP_AMP] = ACTIONS(2274),
    [anon_sym_PIPE] = ACTIONS(2272),
    [anon_sym_CARET] = ACTIONS(2272),
    [anon_sym_AMP] = ACTIONS(2272),
    [anon_sym_EQ_EQ] = ACTIONS(2274),
    [anon_sym_BANG_EQ] = ACTIONS(2274),
    [anon_sym_GT] = ACTIONS(2272),
    [anon_sym_GT_EQ] = ACTIONS(2272),
    [anon_sym_LT_EQ] = ACTIONS(2272),
    [anon_sym_LT] = ACTIONS(2272),
    [anon_sym_LT_LT] = ACTIONS(2272),
    [anon_sym_GT_GT] = ACTIONS(2272),
    [anon_sym_COLON] = ACTIONS(2272),
    [anon_sym___extension__] = ACTIONS(2274),
    [anon_sym___attribute__] = ACTIONS(2274),
    [anon_sym___attribute] = ACTIONS(2272),
    [anon_sym_COLON_COLON] = ACTIONS(2274),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_LBRACK] = ACTIONS(2274),
    [anon_sym_EQ] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_constexpr] = ACTIONS(2274),
    [anon_sym_volatile] = ACTIONS(2274),
    [anon_sym_restrict] = ACTIONS(2274),
    [anon_sym___restrict__] = ACTIONS(2274),
    [anon_sym__Atomic] = ACTIONS(2274),
    [anon_sym__Noreturn] = ACTIONS(2274),
    [anon_sym_noreturn] = ACTIONS(2274),
    [anon_sym__Nonnull] = ACTIONS(2274),
    [anon_sym_mutable] = ACTIONS(2274),
    [anon_sym_constinit] = ACTIONS(2274),
    [anon_sym_consteval] = ACTIONS(2274),
    [anon_sym_alignas] = ACTIONS(2274),
    [anon_sym__Alignas] = ACTIONS(2274),
    [anon_sym_QMARK] = ACTIONS(2274),
    [anon_sym_STAR_EQ] = ACTIONS(2274),
    [anon_sym_SLASH_EQ] = ACTIONS(2274),
    [anon_sym_PERCENT_EQ] = ACTIONS(2274),
    [anon_sym_PLUS_EQ] = ACTIONS(2274),
    [anon_sym_DASH_EQ] = ACTIONS(2274),
    [anon_sym_LT_LT_EQ] = ACTIONS(2274),
    [anon_sym_GT_GT_EQ] = ACTIONS(2272),
    [anon_sym_AMP_EQ] = ACTIONS(2274),
    [anon_sym_CARET_EQ] = ACTIONS(2274),
    [anon_sym_PIPE_EQ] = ACTIONS(2274),
    [anon_sym_and_eq] = ACTIONS(2274),
    [anon_sym_or_eq] = ACTIONS(2274),
    [anon_sym_xor_eq] = ACTIONS(2274),
    [anon_sym_LT_EQ_GT] = ACTIONS(2274),
    [anon_sym_or] = ACTIONS(2272),
    [anon_sym_and] = ACTIONS(2272),
    [anon_sym_bitor] = ACTIONS(2274),
    [anon_sym_xor] = ACTIONS(2272),
    [anon_sym_bitand] = ACTIONS(2274),
    [anon_sym_not_eq] = ACTIONS(2274),
    [anon_sym_is] = ACTIONS(2274),
    [anon_sym_as] = ACTIONS(2274),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_DOT] = ACTIONS(2272),
    [anon_sym_DOT_STAR] = ACTIONS(2274),
    [anon_sym_DASH_GT] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2274),
    [anon_sym_let] = ACTIONS(2274),
    [anon_sym_This] = ACTIONS(2274),
    [anon_sym_final] = ACTIONS(2274),
    [anon_sym_override] = ACTIONS(2274),
    [anon_sym_GT2] = ACTIONS(2274),
  },
  [2959] = {
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3352),
    [anon_sym_COMMA] = ACTIONS(3352),
    [anon_sym_RPAREN] = ACTIONS(3352),
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_DASH] = ACTIONS(3362),
    [anon_sym_PLUS] = ACTIONS(3362),
    [anon_sym_STAR] = ACTIONS(3362),
    [anon_sym_SLASH] = ACTIONS(3362),
    [anon_sym_PERCENT] = ACTIONS(3362),
    [anon_sym_PIPE_PIPE] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_PIPE] = ACTIONS(3362),
    [anon_sym_CARET] = ACTIONS(3362),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_EQ_EQ] = ACTIONS(3352),
    [anon_sym_BANG_EQ] = ACTIONS(3352),
    [anon_sym_GT] = ACTIONS(3362),
    [anon_sym_GT_EQ] = ACTIONS(3352),
    [anon_sym_LT_EQ] = ACTIONS(3362),
    [anon_sym_LT] = ACTIONS(3362),
    [anon_sym_LT_LT] = ACTIONS(3362),
    [anon_sym_GT_GT] = ACTIONS(3362),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_LBRACE] = ACTIONS(3352),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3352),
    [anon_sym_EQ] = ACTIONS(3362),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3362),
    [anon_sym_QMARK] = ACTIONS(3352),
    [anon_sym_STAR_EQ] = ACTIONS(3352),
    [anon_sym_SLASH_EQ] = ACTIONS(3352),
    [anon_sym_PERCENT_EQ] = ACTIONS(3352),
    [anon_sym_PLUS_EQ] = ACTIONS(3352),
    [anon_sym_DASH_EQ] = ACTIONS(3352),
    [anon_sym_LT_LT_EQ] = ACTIONS(3352),
    [anon_sym_GT_GT_EQ] = ACTIONS(3352),
    [anon_sym_AMP_EQ] = ACTIONS(3352),
    [anon_sym_CARET_EQ] = ACTIONS(3352),
    [anon_sym_PIPE_EQ] = ACTIONS(3352),
    [anon_sym_LT_EQ_GT] = ACTIONS(3352),
    [anon_sym_or] = ACTIONS(3362),
    [anon_sym_and] = ACTIONS(3362),
    [anon_sym_bitor] = ACTIONS(3362),
    [anon_sym_xor] = ACTIONS(3362),
    [anon_sym_bitand] = ACTIONS(3362),
    [anon_sym_not_eq] = ACTIONS(3362),
    [anon_sym_is] = ACTIONS(3362),
    [anon_sym_as] = ACTIONS(3362),
    [anon_sym_DASH_DASH] = ACTIONS(3352),
    [anon_sym_PLUS_PLUS] = ACTIONS(3352),
    [anon_sym_DOT] = ACTIONS(3362),
    [anon_sym_DOT_STAR] = ACTIONS(3352),
    [anon_sym_DASH_GT] = ACTIONS(3362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3352),
  },
  [2960] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2241),
    [anon_sym_COMMA] = ACTIONS(2241),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2239),
    [anon_sym_PLUS] = ACTIONS(2239),
    [anon_sym_STAR] = ACTIONS(2239),
    [anon_sym_SLASH] = ACTIONS(2239),
    [anon_sym_PERCENT] = ACTIONS(2239),
    [anon_sym_PIPE_PIPE] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_PIPE] = ACTIONS(2239),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2239),
    [anon_sym_LT_EQ] = ACTIONS(2239),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_LT_LT] = ACTIONS(2239),
    [anon_sym_GT_GT] = ACTIONS(2239),
    [anon_sym_COLON] = ACTIONS(2239),
    [anon_sym___extension__] = ACTIONS(2241),
    [anon_sym___attribute__] = ACTIONS(2241),
    [anon_sym___attribute] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2241),
    [anon_sym_EQ] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2241),
    [anon_sym_volatile] = ACTIONS(2241),
    [anon_sym_restrict] = ACTIONS(2241),
    [anon_sym___restrict__] = ACTIONS(2241),
    [anon_sym__Atomic] = ACTIONS(2241),
    [anon_sym__Noreturn] = ACTIONS(2241),
    [anon_sym_noreturn] = ACTIONS(2241),
    [anon_sym__Nonnull] = ACTIONS(2241),
    [anon_sym_mutable] = ACTIONS(2241),
    [anon_sym_constinit] = ACTIONS(2241),
    [anon_sym_consteval] = ACTIONS(2241),
    [anon_sym_alignas] = ACTIONS(2241),
    [anon_sym__Alignas] = ACTIONS(2241),
    [anon_sym_QMARK] = ACTIONS(2241),
    [anon_sym_STAR_EQ] = ACTIONS(2241),
    [anon_sym_SLASH_EQ] = ACTIONS(2241),
    [anon_sym_PERCENT_EQ] = ACTIONS(2241),
    [anon_sym_PLUS_EQ] = ACTIONS(2241),
    [anon_sym_DASH_EQ] = ACTIONS(2241),
    [anon_sym_LT_LT_EQ] = ACTIONS(2241),
    [anon_sym_GT_GT_EQ] = ACTIONS(2239),
    [anon_sym_AMP_EQ] = ACTIONS(2241),
    [anon_sym_CARET_EQ] = ACTIONS(2241),
    [anon_sym_PIPE_EQ] = ACTIONS(2241),
    [anon_sym_and_eq] = ACTIONS(2241),
    [anon_sym_or_eq] = ACTIONS(2241),
    [anon_sym_xor_eq] = ACTIONS(2241),
    [anon_sym_LT_EQ_GT] = ACTIONS(2241),
    [anon_sym_or] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(2239),
    [anon_sym_bitor] = ACTIONS(2241),
    [anon_sym_xor] = ACTIONS(2239),
    [anon_sym_bitand] = ACTIONS(2241),
    [anon_sym_not_eq] = ACTIONS(2241),
    [anon_sym_is] = ACTIONS(2241),
    [anon_sym_as] = ACTIONS(2241),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2239),
    [anon_sym_DOT_STAR] = ACTIONS(2241),
    [anon_sym_DASH_GT] = ACTIONS(2241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2241),
    [anon_sym_let] = ACTIONS(2241),
    [anon_sym_This] = ACTIONS(2241),
    [anon_sym_final] = ACTIONS(2241),
    [anon_sym_override] = ACTIONS(2241),
    [anon_sym_GT2] = ACTIONS(2241),
  },
  [2961] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_COMMA] = ACTIONS(2282),
    [anon_sym_LPAREN2] = ACTIONS(2282),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2280),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_PERCENT] = ACTIONS(2280),
    [anon_sym_PIPE_PIPE] = ACTIONS(2282),
    [anon_sym_AMP_AMP] = ACTIONS(2282),
    [anon_sym_PIPE] = ACTIONS(2280),
    [anon_sym_CARET] = ACTIONS(2280),
    [anon_sym_AMP] = ACTIONS(2280),
    [anon_sym_EQ_EQ] = ACTIONS(2282),
    [anon_sym_BANG_EQ] = ACTIONS(2282),
    [anon_sym_GT] = ACTIONS(2280),
    [anon_sym_GT_EQ] = ACTIONS(2280),
    [anon_sym_LT_EQ] = ACTIONS(2280),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_LT_LT] = ACTIONS(2280),
    [anon_sym_GT_GT] = ACTIONS(2280),
    [anon_sym_COLON] = ACTIONS(2280),
    [anon_sym___extension__] = ACTIONS(2282),
    [anon_sym___attribute__] = ACTIONS(2282),
    [anon_sym___attribute] = ACTIONS(2280),
    [anon_sym_COLON_COLON] = ACTIONS(2282),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_EQ] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_constexpr] = ACTIONS(2282),
    [anon_sym_volatile] = ACTIONS(2282),
    [anon_sym_restrict] = ACTIONS(2282),
    [anon_sym___restrict__] = ACTIONS(2282),
    [anon_sym__Atomic] = ACTIONS(2282),
    [anon_sym__Noreturn] = ACTIONS(2282),
    [anon_sym_noreturn] = ACTIONS(2282),
    [anon_sym__Nonnull] = ACTIONS(2282),
    [anon_sym_mutable] = ACTIONS(2282),
    [anon_sym_constinit] = ACTIONS(2282),
    [anon_sym_consteval] = ACTIONS(2282),
    [anon_sym_alignas] = ACTIONS(2282),
    [anon_sym__Alignas] = ACTIONS(2282),
    [anon_sym_QMARK] = ACTIONS(2282),
    [anon_sym_STAR_EQ] = ACTIONS(2282),
    [anon_sym_SLASH_EQ] = ACTIONS(2282),
    [anon_sym_PERCENT_EQ] = ACTIONS(2282),
    [anon_sym_PLUS_EQ] = ACTIONS(2282),
    [anon_sym_DASH_EQ] = ACTIONS(2282),
    [anon_sym_LT_LT_EQ] = ACTIONS(2282),
    [anon_sym_GT_GT_EQ] = ACTIONS(2280),
    [anon_sym_AMP_EQ] = ACTIONS(2282),
    [anon_sym_CARET_EQ] = ACTIONS(2282),
    [anon_sym_PIPE_EQ] = ACTIONS(2282),
    [anon_sym_and_eq] = ACTIONS(2282),
    [anon_sym_or_eq] = ACTIONS(2282),
    [anon_sym_xor_eq] = ACTIONS(2282),
    [anon_sym_LT_EQ_GT] = ACTIONS(2282),
    [anon_sym_or] = ACTIONS(2280),
    [anon_sym_and] = ACTIONS(2280),
    [anon_sym_bitor] = ACTIONS(2282),
    [anon_sym_xor] = ACTIONS(2280),
    [anon_sym_bitand] = ACTIONS(2282),
    [anon_sym_not_eq] = ACTIONS(2282),
    [anon_sym_is] = ACTIONS(2282),
    [anon_sym_as] = ACTIONS(2282),
    [anon_sym_DASH_DASH] = ACTIONS(2282),
    [anon_sym_PLUS_PLUS] = ACTIONS(2282),
    [anon_sym_DOT] = ACTIONS(2280),
    [anon_sym_DOT_STAR] = ACTIONS(2282),
    [anon_sym_DASH_GT] = ACTIONS(2282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2282),
    [anon_sym_let] = ACTIONS(2282),
    [anon_sym_This] = ACTIONS(2282),
    [anon_sym_final] = ACTIONS(2282),
    [anon_sym_override] = ACTIONS(2282),
    [anon_sym_GT2] = ACTIONS(2282),
  },
  [2962] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2286),
    [anon_sym_COMMA] = ACTIONS(2286),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2284),
    [anon_sym_SLASH] = ACTIONS(2284),
    [anon_sym_PERCENT] = ACTIONS(2284),
    [anon_sym_PIPE_PIPE] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2284),
    [anon_sym_CARET] = ACTIONS(2284),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_EQ_EQ] = ACTIONS(2286),
    [anon_sym_BANG_EQ] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2284),
    [anon_sym_GT_EQ] = ACTIONS(2284),
    [anon_sym_LT_EQ] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2284),
    [anon_sym_LT_LT] = ACTIONS(2284),
    [anon_sym_GT_GT] = ACTIONS(2284),
    [anon_sym_COLON] = ACTIONS(2284),
    [anon_sym___extension__] = ACTIONS(2286),
    [anon_sym___attribute__] = ACTIONS(2286),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_EQ] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2286),
    [anon_sym_volatile] = ACTIONS(2286),
    [anon_sym_restrict] = ACTIONS(2286),
    [anon_sym___restrict__] = ACTIONS(2286),
    [anon_sym__Atomic] = ACTIONS(2286),
    [anon_sym__Noreturn] = ACTIONS(2286),
    [anon_sym_noreturn] = ACTIONS(2286),
    [anon_sym__Nonnull] = ACTIONS(2286),
    [anon_sym_mutable] = ACTIONS(2286),
    [anon_sym_constinit] = ACTIONS(2286),
    [anon_sym_consteval] = ACTIONS(2286),
    [anon_sym_alignas] = ACTIONS(2286),
    [anon_sym__Alignas] = ACTIONS(2286),
    [anon_sym_QMARK] = ACTIONS(2286),
    [anon_sym_STAR_EQ] = ACTIONS(2286),
    [anon_sym_SLASH_EQ] = ACTIONS(2286),
    [anon_sym_PERCENT_EQ] = ACTIONS(2286),
    [anon_sym_PLUS_EQ] = ACTIONS(2286),
    [anon_sym_DASH_EQ] = ACTIONS(2286),
    [anon_sym_LT_LT_EQ] = ACTIONS(2286),
    [anon_sym_GT_GT_EQ] = ACTIONS(2284),
    [anon_sym_AMP_EQ] = ACTIONS(2286),
    [anon_sym_CARET_EQ] = ACTIONS(2286),
    [anon_sym_PIPE_EQ] = ACTIONS(2286),
    [anon_sym_and_eq] = ACTIONS(2286),
    [anon_sym_or_eq] = ACTIONS(2286),
    [anon_sym_xor_eq] = ACTIONS(2286),
    [anon_sym_LT_EQ_GT] = ACTIONS(2286),
    [anon_sym_or] = ACTIONS(2284),
    [anon_sym_and] = ACTIONS(2284),
    [anon_sym_bitor] = ACTIONS(2286),
    [anon_sym_xor] = ACTIONS(2284),
    [anon_sym_bitand] = ACTIONS(2286),
    [anon_sym_not_eq] = ACTIONS(2286),
    [anon_sym_is] = ACTIONS(2286),
    [anon_sym_as] = ACTIONS(2286),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_DOT] = ACTIONS(2284),
    [anon_sym_DOT_STAR] = ACTIONS(2286),
    [anon_sym_DASH_GT] = ACTIONS(2286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2286),
    [anon_sym_let] = ACTIONS(2286),
    [anon_sym_This] = ACTIONS(2286),
    [anon_sym_final] = ACTIONS(2286),
    [anon_sym_override] = ACTIONS(2286),
    [anon_sym_GT2] = ACTIONS(2286),
  },
  [2963] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2290),
    [anon_sym_COMMA] = ACTIONS(2290),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_PERCENT] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_CARET] = ACTIONS(2288),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_EQ_EQ] = ACTIONS(2290),
    [anon_sym_BANG_EQ] = ACTIONS(2290),
    [anon_sym_GT] = ACTIONS(2288),
    [anon_sym_GT_EQ] = ACTIONS(2288),
    [anon_sym_LT_EQ] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(2288),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_COLON] = ACTIONS(2288),
    [anon_sym___extension__] = ACTIONS(2290),
    [anon_sym___attribute__] = ACTIONS(2290),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_LBRACK] = ACTIONS(2290),
    [anon_sym_EQ] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2290),
    [anon_sym_volatile] = ACTIONS(2290),
    [anon_sym_restrict] = ACTIONS(2290),
    [anon_sym___restrict__] = ACTIONS(2290),
    [anon_sym__Atomic] = ACTIONS(2290),
    [anon_sym__Noreturn] = ACTIONS(2290),
    [anon_sym_noreturn] = ACTIONS(2290),
    [anon_sym__Nonnull] = ACTIONS(2290),
    [anon_sym_mutable] = ACTIONS(2290),
    [anon_sym_constinit] = ACTIONS(2290),
    [anon_sym_consteval] = ACTIONS(2290),
    [anon_sym_alignas] = ACTIONS(2290),
    [anon_sym__Alignas] = ACTIONS(2290),
    [anon_sym_QMARK] = ACTIONS(2290),
    [anon_sym_STAR_EQ] = ACTIONS(2290),
    [anon_sym_SLASH_EQ] = ACTIONS(2290),
    [anon_sym_PERCENT_EQ] = ACTIONS(2290),
    [anon_sym_PLUS_EQ] = ACTIONS(2290),
    [anon_sym_DASH_EQ] = ACTIONS(2290),
    [anon_sym_LT_LT_EQ] = ACTIONS(2290),
    [anon_sym_GT_GT_EQ] = ACTIONS(2288),
    [anon_sym_AMP_EQ] = ACTIONS(2290),
    [anon_sym_CARET_EQ] = ACTIONS(2290),
    [anon_sym_PIPE_EQ] = ACTIONS(2290),
    [anon_sym_and_eq] = ACTIONS(2290),
    [anon_sym_or_eq] = ACTIONS(2290),
    [anon_sym_xor_eq] = ACTIONS(2290),
    [anon_sym_LT_EQ_GT] = ACTIONS(2290),
    [anon_sym_or] = ACTIONS(2288),
    [anon_sym_and] = ACTIONS(2288),
    [anon_sym_bitor] = ACTIONS(2290),
    [anon_sym_xor] = ACTIONS(2288),
    [anon_sym_bitand] = ACTIONS(2290),
    [anon_sym_not_eq] = ACTIONS(2290),
    [anon_sym_is] = ACTIONS(2290),
    [anon_sym_as] = ACTIONS(2290),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_DOT] = ACTIONS(2288),
    [anon_sym_DOT_STAR] = ACTIONS(2290),
    [anon_sym_DASH_GT] = ACTIONS(2290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2290),
    [anon_sym_let] = ACTIONS(2290),
    [anon_sym_This] = ACTIONS(2290),
    [anon_sym_final] = ACTIONS(2290),
    [anon_sym_override] = ACTIONS(2290),
    [anon_sym_GT2] = ACTIONS(2290),
  },
  [2964] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2294),
    [anon_sym_COMMA] = ACTIONS(2294),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2292),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_PERCENT] = ACTIONS(2292),
    [anon_sym_PIPE_PIPE] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_PIPE] = ACTIONS(2292),
    [anon_sym_CARET] = ACTIONS(2292),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_EQ_EQ] = ACTIONS(2294),
    [anon_sym_BANG_EQ] = ACTIONS(2294),
    [anon_sym_GT] = ACTIONS(2292),
    [anon_sym_GT_EQ] = ACTIONS(2292),
    [anon_sym_LT_EQ] = ACTIONS(2292),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_LT_LT] = ACTIONS(2292),
    [anon_sym_GT_GT] = ACTIONS(2292),
    [anon_sym_COLON] = ACTIONS(2292),
    [anon_sym___extension__] = ACTIONS(2294),
    [anon_sym___attribute__] = ACTIONS(2294),
    [anon_sym___attribute] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_LBRACK] = ACTIONS(2294),
    [anon_sym_EQ] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2294),
    [anon_sym_volatile] = ACTIONS(2294),
    [anon_sym_restrict] = ACTIONS(2294),
    [anon_sym___restrict__] = ACTIONS(2294),
    [anon_sym__Atomic] = ACTIONS(2294),
    [anon_sym__Noreturn] = ACTIONS(2294),
    [anon_sym_noreturn] = ACTIONS(2294),
    [anon_sym__Nonnull] = ACTIONS(2294),
    [anon_sym_mutable] = ACTIONS(2294),
    [anon_sym_constinit] = ACTIONS(2294),
    [anon_sym_consteval] = ACTIONS(2294),
    [anon_sym_alignas] = ACTIONS(2294),
    [anon_sym__Alignas] = ACTIONS(2294),
    [anon_sym_QMARK] = ACTIONS(2294),
    [anon_sym_STAR_EQ] = ACTIONS(2294),
    [anon_sym_SLASH_EQ] = ACTIONS(2294),
    [anon_sym_PERCENT_EQ] = ACTIONS(2294),
    [anon_sym_PLUS_EQ] = ACTIONS(2294),
    [anon_sym_DASH_EQ] = ACTIONS(2294),
    [anon_sym_LT_LT_EQ] = ACTIONS(2294),
    [anon_sym_GT_GT_EQ] = ACTIONS(2292),
    [anon_sym_AMP_EQ] = ACTIONS(2294),
    [anon_sym_CARET_EQ] = ACTIONS(2294),
    [anon_sym_PIPE_EQ] = ACTIONS(2294),
    [anon_sym_and_eq] = ACTIONS(2294),
    [anon_sym_or_eq] = ACTIONS(2294),
    [anon_sym_xor_eq] = ACTIONS(2294),
    [anon_sym_LT_EQ_GT] = ACTIONS(2294),
    [anon_sym_or] = ACTIONS(2292),
    [anon_sym_and] = ACTIONS(2292),
    [anon_sym_bitor] = ACTIONS(2294),
    [anon_sym_xor] = ACTIONS(2292),
    [anon_sym_bitand] = ACTIONS(2294),
    [anon_sym_not_eq] = ACTIONS(2294),
    [anon_sym_is] = ACTIONS(2294),
    [anon_sym_as] = ACTIONS(2294),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_DOT] = ACTIONS(2292),
    [anon_sym_DOT_STAR] = ACTIONS(2294),
    [anon_sym_DASH_GT] = ACTIONS(2294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2294),
    [anon_sym_let] = ACTIONS(2294),
    [anon_sym_This] = ACTIONS(2294),
    [anon_sym_final] = ACTIONS(2294),
    [anon_sym_override] = ACTIONS(2294),
    [anon_sym_GT2] = ACTIONS(2294),
  },
  [2965] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2298),
    [anon_sym_COMMA] = ACTIONS(2298),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2296),
    [anon_sym_SLASH] = ACTIONS(2296),
    [anon_sym_PERCENT] = ACTIONS(2296),
    [anon_sym_PIPE_PIPE] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_PIPE] = ACTIONS(2296),
    [anon_sym_CARET] = ACTIONS(2296),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_EQ_EQ] = ACTIONS(2298),
    [anon_sym_BANG_EQ] = ACTIONS(2298),
    [anon_sym_GT] = ACTIONS(2296),
    [anon_sym_GT_EQ] = ACTIONS(2296),
    [anon_sym_LT_EQ] = ACTIONS(2296),
    [anon_sym_LT] = ACTIONS(2296),
    [anon_sym_LT_LT] = ACTIONS(2296),
    [anon_sym_GT_GT] = ACTIONS(2296),
    [anon_sym_COLON] = ACTIONS(2296),
    [anon_sym___extension__] = ACTIONS(2298),
    [anon_sym___attribute__] = ACTIONS(2298),
    [anon_sym___attribute] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_LBRACK] = ACTIONS(2298),
    [anon_sym_EQ] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2298),
    [anon_sym_volatile] = ACTIONS(2298),
    [anon_sym_restrict] = ACTIONS(2298),
    [anon_sym___restrict__] = ACTIONS(2298),
    [anon_sym__Atomic] = ACTIONS(2298),
    [anon_sym__Noreturn] = ACTIONS(2298),
    [anon_sym_noreturn] = ACTIONS(2298),
    [anon_sym__Nonnull] = ACTIONS(2298),
    [anon_sym_mutable] = ACTIONS(2298),
    [anon_sym_constinit] = ACTIONS(2298),
    [anon_sym_consteval] = ACTIONS(2298),
    [anon_sym_alignas] = ACTIONS(2298),
    [anon_sym__Alignas] = ACTIONS(2298),
    [anon_sym_QMARK] = ACTIONS(2298),
    [anon_sym_STAR_EQ] = ACTIONS(2298),
    [anon_sym_SLASH_EQ] = ACTIONS(2298),
    [anon_sym_PERCENT_EQ] = ACTIONS(2298),
    [anon_sym_PLUS_EQ] = ACTIONS(2298),
    [anon_sym_DASH_EQ] = ACTIONS(2298),
    [anon_sym_LT_LT_EQ] = ACTIONS(2298),
    [anon_sym_GT_GT_EQ] = ACTIONS(2296),
    [anon_sym_AMP_EQ] = ACTIONS(2298),
    [anon_sym_CARET_EQ] = ACTIONS(2298),
    [anon_sym_PIPE_EQ] = ACTIONS(2298),
    [anon_sym_and_eq] = ACTIONS(2298),
    [anon_sym_or_eq] = ACTIONS(2298),
    [anon_sym_xor_eq] = ACTIONS(2298),
    [anon_sym_LT_EQ_GT] = ACTIONS(2298),
    [anon_sym_or] = ACTIONS(2296),
    [anon_sym_and] = ACTIONS(2296),
    [anon_sym_bitor] = ACTIONS(2298),
    [anon_sym_xor] = ACTIONS(2296),
    [anon_sym_bitand] = ACTIONS(2298),
    [anon_sym_not_eq] = ACTIONS(2298),
    [anon_sym_is] = ACTIONS(2298),
    [anon_sym_as] = ACTIONS(2298),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_DOT] = ACTIONS(2296),
    [anon_sym_DOT_STAR] = ACTIONS(2298),
    [anon_sym_DASH_GT] = ACTIONS(2298),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2298),
    [anon_sym_let] = ACTIONS(2298),
    [anon_sym_This] = ACTIONS(2298),
    [anon_sym_final] = ACTIONS(2298),
    [anon_sym_override] = ACTIONS(2298),
    [anon_sym_GT2] = ACTIONS(2298),
  },
  [2966] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2266),
    [anon_sym_COMMA] = ACTIONS(2266),
    [anon_sym_LPAREN2] = ACTIONS(2266),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2264),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_PERCENT] = ACTIONS(2264),
    [anon_sym_PIPE_PIPE] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2266),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_CARET] = ACTIONS(2264),
    [anon_sym_AMP] = ACTIONS(2264),
    [anon_sym_EQ_EQ] = ACTIONS(2266),
    [anon_sym_BANG_EQ] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(2264),
    [anon_sym_GT_EQ] = ACTIONS(2264),
    [anon_sym_LT_EQ] = ACTIONS(2264),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_LT_LT] = ACTIONS(2264),
    [anon_sym_GT_GT] = ACTIONS(2264),
    [anon_sym_COLON] = ACTIONS(2264),
    [anon_sym___extension__] = ACTIONS(2266),
    [anon_sym___attribute__] = ACTIONS(2266),
    [anon_sym___attribute] = ACTIONS(2264),
    [anon_sym_COLON_COLON] = ACTIONS(2266),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_EQ] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_constexpr] = ACTIONS(2266),
    [anon_sym_volatile] = ACTIONS(2266),
    [anon_sym_restrict] = ACTIONS(2266),
    [anon_sym___restrict__] = ACTIONS(2266),
    [anon_sym__Atomic] = ACTIONS(2266),
    [anon_sym__Noreturn] = ACTIONS(2266),
    [anon_sym_noreturn] = ACTIONS(2266),
    [anon_sym__Nonnull] = ACTIONS(2266),
    [anon_sym_mutable] = ACTIONS(2266),
    [anon_sym_constinit] = ACTIONS(2266),
    [anon_sym_consteval] = ACTIONS(2266),
    [anon_sym_alignas] = ACTIONS(2266),
    [anon_sym__Alignas] = ACTIONS(2266),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_STAR_EQ] = ACTIONS(2266),
    [anon_sym_SLASH_EQ] = ACTIONS(2266),
    [anon_sym_PERCENT_EQ] = ACTIONS(2266),
    [anon_sym_PLUS_EQ] = ACTIONS(2266),
    [anon_sym_DASH_EQ] = ACTIONS(2266),
    [anon_sym_LT_LT_EQ] = ACTIONS(2266),
    [anon_sym_GT_GT_EQ] = ACTIONS(2264),
    [anon_sym_AMP_EQ] = ACTIONS(2266),
    [anon_sym_CARET_EQ] = ACTIONS(2266),
    [anon_sym_PIPE_EQ] = ACTIONS(2266),
    [anon_sym_and_eq] = ACTIONS(2266),
    [anon_sym_or_eq] = ACTIONS(2266),
    [anon_sym_xor_eq] = ACTIONS(2266),
    [anon_sym_LT_EQ_GT] = ACTIONS(2266),
    [anon_sym_or] = ACTIONS(2264),
    [anon_sym_and] = ACTIONS(2264),
    [anon_sym_bitor] = ACTIONS(2266),
    [anon_sym_xor] = ACTIONS(2264),
    [anon_sym_bitand] = ACTIONS(2266),
    [anon_sym_not_eq] = ACTIONS(2266),
    [anon_sym_is] = ACTIONS(2266),
    [anon_sym_as] = ACTIONS(2266),
    [anon_sym_DASH_DASH] = ACTIONS(2266),
    [anon_sym_PLUS_PLUS] = ACTIONS(2266),
    [anon_sym_DOT] = ACTIONS(2264),
    [anon_sym_DOT_STAR] = ACTIONS(2266),
    [anon_sym_DASH_GT] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2266),
    [anon_sym_let] = ACTIONS(2266),
    [anon_sym_This] = ACTIONS(2266),
    [anon_sym_final] = ACTIONS(2266),
    [anon_sym_override] = ACTIONS(2266),
    [anon_sym_GT2] = ACTIONS(2266),
  },
  [2967] = {
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_RPAREN] = ACTIONS(2420),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_SLASH] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2420),
    [anon_sym_PIPE_PIPE] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_PIPE] = ACTIONS(2422),
    [anon_sym_CARET] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_EQ_EQ] = ACTIONS(2420),
    [anon_sym_BANG_EQ] = ACTIONS(2420),
    [anon_sym_GT] = ACTIONS(2422),
    [anon_sym_GT_EQ] = ACTIONS(2420),
    [anon_sym_LT_EQ] = ACTIONS(2422),
    [anon_sym_LT] = ACTIONS(2422),
    [anon_sym_LT_LT] = ACTIONS(2420),
    [anon_sym_GT_GT] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2420),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym___based] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2422),
    [anon_sym_unsigned] = ACTIONS(2422),
    [anon_sym_long] = ACTIONS(2422),
    [anon_sym_short] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [anon_sym_RBRACK] = ACTIONS(2420),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [sym_primitive_type] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_QMARK] = ACTIONS(2420),
    [anon_sym_LT_EQ_GT] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2422),
    [anon_sym_and] = ACTIONS(2422),
    [anon_sym_bitor] = ACTIONS(2422),
    [anon_sym_xor] = ACTIONS(2422),
    [anon_sym_bitand] = ACTIONS(2422),
    [anon_sym_not_eq] = ACTIONS(2422),
    [anon_sym_is] = ACTIONS(2422),
    [anon_sym_as] = ACTIONS(2422),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_DOT] = ACTIONS(2422),
    [anon_sym_DOT_STAR] = ACTIONS(2420),
    [anon_sym_DASH_GT] = ACTIONS(2420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_requires] = ACTIONS(2422),
    [anon_sym_where] = ACTIONS(2422),
  },
  [2968] = {
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2290),
    [anon_sym_COMMA] = ACTIONS(2290),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_COLON] = ACTIONS(2288),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_out] = ACTIONS(2288),
    [anon_sym_inout] = ACTIONS(2288),
    [anon_sym_virtual] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_EQ] = ACTIONS(2290),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [anon_sym_DOT] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_This] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [anon_sym_final] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_GT2] = ACTIONS(2290),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_precise] = ACTIONS(2288),
    [anon_sym_shared] = ACTIONS(2288),
    [anon_sym_groupshared] = ACTIONS(2288),
    [anon_sym_uniform] = ACTIONS(2288),
    [anon_sym_row_major] = ACTIONS(2288),
    [anon_sym_column_major] = ACTIONS(2288),
    [anon_sym_globallycoherent] = ACTIONS(2288),
    [anon_sym_centroid] = ACTIONS(2288),
    [anon_sym_noperspective] = ACTIONS(2288),
    [anon_sym_nointerpolation] = ACTIONS(2288),
    [anon_sym_sample] = ACTIONS(2288),
    [anon_sym_linear] = ACTIONS(2288),
    [anon_sym_snorm] = ACTIONS(2288),
    [anon_sym_unorm] = ACTIONS(2288),
    [anon_sym_point] = ACTIONS(2288),
    [anon_sym_line] = ACTIONS(2288),
    [anon_sym_triangleadj] = ACTIONS(2288),
    [anon_sym_lineadj] = ACTIONS(2288),
    [anon_sym_triangle] = ACTIONS(2288),
  },
  [2969] = {
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2294),
    [anon_sym_COMMA] = ACTIONS(2294),
    [anon_sym_RPAREN] = ACTIONS(2294),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_COLON] = ACTIONS(2292),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym_in] = ACTIONS(2292),
    [anon_sym_out] = ACTIONS(2292),
    [anon_sym_inout] = ACTIONS(2292),
    [anon_sym_virtual] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym___attribute] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2294),
    [anon_sym___declspec] = ACTIONS(2292),
    [anon_sym___based] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_EQ] = ACTIONS(2294),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym___inline] = ACTIONS(2292),
    [anon_sym___inline__] = ACTIONS(2292),
    [anon_sym___forceinline] = ACTIONS(2292),
    [anon_sym_thread_local] = ACTIONS(2292),
    [anon_sym___thread] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym__Nonnull] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [anon_sym_DOT] = ACTIONS(2292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_This] = ACTIONS(2292),
    [anon_sym_decltype] = ACTIONS(2292),
    [anon_sym_final] = ACTIONS(2292),
    [anon_sym_override] = ACTIONS(2292),
    [anon_sym_template] = ACTIONS(2292),
    [anon_sym_GT2] = ACTIONS(2294),
    [anon_sym_operator] = ACTIONS(2292),
    [anon_sym_precise] = ACTIONS(2292),
    [anon_sym_shared] = ACTIONS(2292),
    [anon_sym_groupshared] = ACTIONS(2292),
    [anon_sym_uniform] = ACTIONS(2292),
    [anon_sym_row_major] = ACTIONS(2292),
    [anon_sym_column_major] = ACTIONS(2292),
    [anon_sym_globallycoherent] = ACTIONS(2292),
    [anon_sym_centroid] = ACTIONS(2292),
    [anon_sym_noperspective] = ACTIONS(2292),
    [anon_sym_nointerpolation] = ACTIONS(2292),
    [anon_sym_sample] = ACTIONS(2292),
    [anon_sym_linear] = ACTIONS(2292),
    [anon_sym_snorm] = ACTIONS(2292),
    [anon_sym_unorm] = ACTIONS(2292),
    [anon_sym_point] = ACTIONS(2292),
    [anon_sym_line] = ACTIONS(2292),
    [anon_sym_triangleadj] = ACTIONS(2292),
    [anon_sym_lineadj] = ACTIONS(2292),
    [anon_sym_triangle] = ACTIONS(2292),
  },
  [2970] = {
    [sym_string_literal] = STATE(2987),
    [sym_raw_string_literal] = STATE(2987),
    [aux_sym_concatenated_string_repeat1] = STATE(2987),
    [sym_identifier] = ACTIONS(7188),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7190),
    [anon_sym_COMMA] = ACTIONS(7190),
    [anon_sym_RPAREN] = ACTIONS(7190),
    [aux_sym_preproc_if_token2] = ACTIONS(7190),
    [aux_sym_preproc_else_token1] = ACTIONS(7190),
    [aux_sym_preproc_elif_token1] = ACTIONS(7192),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7190),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7190),
    [anon_sym_LPAREN2] = ACTIONS(7190),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_STAR] = ACTIONS(7192),
    [anon_sym_SLASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [anon_sym_PIPE_PIPE] = ACTIONS(7190),
    [anon_sym_AMP_AMP] = ACTIONS(7190),
    [anon_sym_PIPE] = ACTIONS(7192),
    [anon_sym_CARET] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(7192),
    [anon_sym_EQ_EQ] = ACTIONS(7190),
    [anon_sym_BANG_EQ] = ACTIONS(7190),
    [anon_sym_GT] = ACTIONS(7192),
    [anon_sym_GT_EQ] = ACTIONS(7190),
    [anon_sym_LT_EQ] = ACTIONS(7192),
    [anon_sym_LT] = ACTIONS(7192),
    [anon_sym_LT_LT] = ACTIONS(7192),
    [anon_sym_GT_GT] = ACTIONS(7192),
    [anon_sym_COLON] = ACTIONS(7190),
    [anon_sym_SEMI] = ACTIONS(7190),
    [anon_sym_RBRACE] = ACTIONS(7190),
    [anon_sym_LBRACK] = ACTIONS(7190),
    [anon_sym_RBRACK] = ACTIONS(7190),
    [anon_sym_EQ] = ACTIONS(7192),
    [anon_sym_QMARK] = ACTIONS(7190),
    [anon_sym_STAR_EQ] = ACTIONS(7190),
    [anon_sym_SLASH_EQ] = ACTIONS(7190),
    [anon_sym_PERCENT_EQ] = ACTIONS(7190),
    [anon_sym_PLUS_EQ] = ACTIONS(7190),
    [anon_sym_DASH_EQ] = ACTIONS(7190),
    [anon_sym_LT_LT_EQ] = ACTIONS(7190),
    [anon_sym_GT_GT_EQ] = ACTIONS(7190),
    [anon_sym_AMP_EQ] = ACTIONS(7190),
    [anon_sym_CARET_EQ] = ACTIONS(7190),
    [anon_sym_PIPE_EQ] = ACTIONS(7190),
    [anon_sym_and_eq] = ACTIONS(7192),
    [anon_sym_or_eq] = ACTIONS(7192),
    [anon_sym_xor_eq] = ACTIONS(7192),
    [anon_sym_LT_EQ_GT] = ACTIONS(7190),
    [anon_sym_or] = ACTIONS(7192),
    [anon_sym_and] = ACTIONS(7192),
    [anon_sym_bitor] = ACTIONS(7192),
    [anon_sym_xor] = ACTIONS(7192),
    [anon_sym_bitand] = ACTIONS(7192),
    [anon_sym_not_eq] = ACTIONS(7192),
    [anon_sym_is] = ACTIONS(7192),
    [anon_sym_as] = ACTIONS(7192),
    [anon_sym_DASH_DASH] = ACTIONS(7190),
    [anon_sym_PLUS_PLUS] = ACTIONS(7190),
    [anon_sym_DOT] = ACTIONS(7192),
    [anon_sym_DOT_STAR] = ACTIONS(7190),
    [anon_sym_DASH_GT] = ACTIONS(7190),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [sym_literal_suffix] = ACTIONS(7192),
  },
  [2971] = {
    [sym_identifier] = ACTIONS(2296),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2298),
    [anon_sym_COMMA] = ACTIONS(2298),
    [anon_sym_RPAREN] = ACTIONS(2298),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_STAR] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_COLON] = ACTIONS(2296),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym_in] = ACTIONS(2296),
    [anon_sym_out] = ACTIONS(2296),
    [anon_sym_inout] = ACTIONS(2296),
    [anon_sym_virtual] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym___attribute] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2298),
    [anon_sym___declspec] = ACTIONS(2296),
    [anon_sym___based] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_LBRACK] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_EQ] = ACTIONS(2298),
    [anon_sym_register] = ACTIONS(2296),
    [anon_sym_inline] = ACTIONS(2296),
    [anon_sym___inline] = ACTIONS(2296),
    [anon_sym___inline__] = ACTIONS(2296),
    [anon_sym___forceinline] = ACTIONS(2296),
    [anon_sym_thread_local] = ACTIONS(2296),
    [anon_sym___thread] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym__Nonnull] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [anon_sym_DOT] = ACTIONS(2296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_This] = ACTIONS(2296),
    [anon_sym_decltype] = ACTIONS(2296),
    [anon_sym_final] = ACTIONS(2296),
    [anon_sym_override] = ACTIONS(2296),
    [anon_sym_template] = ACTIONS(2296),
    [anon_sym_GT2] = ACTIONS(2298),
    [anon_sym_operator] = ACTIONS(2296),
    [anon_sym_precise] = ACTIONS(2296),
    [anon_sym_shared] = ACTIONS(2296),
    [anon_sym_groupshared] = ACTIONS(2296),
    [anon_sym_uniform] = ACTIONS(2296),
    [anon_sym_row_major] = ACTIONS(2296),
    [anon_sym_column_major] = ACTIONS(2296),
    [anon_sym_globallycoherent] = ACTIONS(2296),
    [anon_sym_centroid] = ACTIONS(2296),
    [anon_sym_noperspective] = ACTIONS(2296),
    [anon_sym_nointerpolation] = ACTIONS(2296),
    [anon_sym_sample] = ACTIONS(2296),
    [anon_sym_linear] = ACTIONS(2296),
    [anon_sym_snorm] = ACTIONS(2296),
    [anon_sym_unorm] = ACTIONS(2296),
    [anon_sym_point] = ACTIONS(2296),
    [anon_sym_line] = ACTIONS(2296),
    [anon_sym_triangleadj] = ACTIONS(2296),
    [anon_sym_lineadj] = ACTIONS(2296),
    [anon_sym_triangle] = ACTIONS(2296),
  },
  [2972] = {
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2266),
    [anon_sym_COMMA] = ACTIONS(2266),
    [anon_sym_RPAREN] = ACTIONS(2266),
    [anon_sym_LPAREN2] = ACTIONS(2266),
    [anon_sym_TILDE] = ACTIONS(2266),
    [anon_sym_STAR] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2266),
    [anon_sym_AMP] = ACTIONS(2264),
    [anon_sym_COLON] = ACTIONS(2264),
    [anon_sym___extension__] = ACTIONS(2264),
    [anon_sym_in] = ACTIONS(2264),
    [anon_sym_out] = ACTIONS(2264),
    [anon_sym_inout] = ACTIONS(2264),
    [anon_sym_virtual] = ACTIONS(2264),
    [anon_sym_extern] = ACTIONS(2264),
    [anon_sym___attribute__] = ACTIONS(2264),
    [anon_sym___attribute] = ACTIONS(2264),
    [anon_sym_COLON_COLON] = ACTIONS(2266),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2266),
    [anon_sym___declspec] = ACTIONS(2264),
    [anon_sym___based] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_LBRACK] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_EQ] = ACTIONS(2266),
    [anon_sym_register] = ACTIONS(2264),
    [anon_sym_inline] = ACTIONS(2264),
    [anon_sym___inline] = ACTIONS(2264),
    [anon_sym___inline__] = ACTIONS(2264),
    [anon_sym___forceinline] = ACTIONS(2264),
    [anon_sym_thread_local] = ACTIONS(2264),
    [anon_sym___thread] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_constexpr] = ACTIONS(2264),
    [anon_sym_volatile] = ACTIONS(2264),
    [anon_sym_restrict] = ACTIONS(2264),
    [anon_sym___restrict__] = ACTIONS(2264),
    [anon_sym__Atomic] = ACTIONS(2264),
    [anon_sym__Noreturn] = ACTIONS(2264),
    [anon_sym_noreturn] = ACTIONS(2264),
    [anon_sym__Nonnull] = ACTIONS(2264),
    [anon_sym_mutable] = ACTIONS(2264),
    [anon_sym_constinit] = ACTIONS(2264),
    [anon_sym_consteval] = ACTIONS(2264),
    [anon_sym_alignas] = ACTIONS(2264),
    [anon_sym__Alignas] = ACTIONS(2264),
    [anon_sym_DOT] = ACTIONS(2264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_This] = ACTIONS(2264),
    [anon_sym_decltype] = ACTIONS(2264),
    [anon_sym_final] = ACTIONS(2264),
    [anon_sym_override] = ACTIONS(2264),
    [anon_sym_template] = ACTIONS(2264),
    [anon_sym_GT2] = ACTIONS(2266),
    [anon_sym_operator] = ACTIONS(2264),
    [anon_sym_precise] = ACTIONS(2264),
    [anon_sym_shared] = ACTIONS(2264),
    [anon_sym_groupshared] = ACTIONS(2264),
    [anon_sym_uniform] = ACTIONS(2264),
    [anon_sym_row_major] = ACTIONS(2264),
    [anon_sym_column_major] = ACTIONS(2264),
    [anon_sym_globallycoherent] = ACTIONS(2264),
    [anon_sym_centroid] = ACTIONS(2264),
    [anon_sym_noperspective] = ACTIONS(2264),
    [anon_sym_nointerpolation] = ACTIONS(2264),
    [anon_sym_sample] = ACTIONS(2264),
    [anon_sym_linear] = ACTIONS(2264),
    [anon_sym_snorm] = ACTIONS(2264),
    [anon_sym_unorm] = ACTIONS(2264),
    [anon_sym_point] = ACTIONS(2264),
    [anon_sym_line] = ACTIONS(2264),
    [anon_sym_triangleadj] = ACTIONS(2264),
    [anon_sym_lineadj] = ACTIONS(2264),
    [anon_sym_triangle] = ACTIONS(2264),
  },
  [2973] = {
    [sym_template_argument_list] = STATE(3043),
    [sym_identifier] = ACTIONS(2222),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2229),
    [anon_sym_STAR] = ACTIONS(2229),
    [anon_sym_AMP_AMP] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(7064),
    [anon_sym_SEMI] = ACTIONS(2229),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_virtual] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym___attribute] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2226),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym___based] = ACTIONS(2222),
    [anon_sym___cdecl] = ACTIONS(2222),
    [anon_sym___clrcall] = ACTIONS(2222),
    [anon_sym___stdcall] = ACTIONS(2222),
    [anon_sym___fastcall] = ACTIONS(2222),
    [anon_sym___thiscall] = ACTIONS(2222),
    [anon_sym___vectorcall] = ACTIONS(2222),
    [anon_sym_LBRACK] = ACTIONS(2231),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym__Nonnull] = ACTIONS(2222),
    [anon_sym_mutable] = ACTIONS(2222),
    [anon_sym_constinit] = ACTIONS(2222),
    [anon_sym_consteval] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [anon_sym_DOT] = ACTIONS(2229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2222),
    [anon_sym_let] = ACTIONS(2222),
    [anon_sym_This] = ACTIONS(2222),
    [anon_sym_decltype] = ACTIONS(2222),
    [anon_sym_template] = ACTIONS(2222),
    [anon_sym_operator] = ACTIONS(2222),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_groupshared] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_row_major] = ACTIONS(2222),
    [anon_sym_column_major] = ACTIONS(2222),
    [anon_sym_globallycoherent] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym_nointerpolation] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_linear] = ACTIONS(2222),
    [anon_sym_snorm] = ACTIONS(2222),
    [anon_sym_unorm] = ACTIONS(2222),
    [anon_sym_point] = ACTIONS(2222),
    [anon_sym_line] = ACTIONS(2222),
    [anon_sym_triangleadj] = ACTIONS(2222),
    [anon_sym_lineadj] = ACTIONS(2222),
    [anon_sym_triangle] = ACTIONS(2222),
  },
  [2974] = {
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2302),
    [anon_sym_COMMA] = ACTIONS(2302),
    [anon_sym_RPAREN] = ACTIONS(2302),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_STAR] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_COLON] = ACTIONS(2300),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym_in] = ACTIONS(2300),
    [anon_sym_out] = ACTIONS(2300),
    [anon_sym_inout] = ACTIONS(2300),
    [anon_sym_virtual] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym___attribute] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2302),
    [anon_sym___declspec] = ACTIONS(2300),
    [anon_sym___based] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_EQ] = ACTIONS(2302),
    [anon_sym_register] = ACTIONS(2300),
    [anon_sym_inline] = ACTIONS(2300),
    [anon_sym___inline] = ACTIONS(2300),
    [anon_sym___inline__] = ACTIONS(2300),
    [anon_sym___forceinline] = ACTIONS(2300),
    [anon_sym_thread_local] = ACTIONS(2300),
    [anon_sym___thread] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym__Nonnull] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [anon_sym_DOT] = ACTIONS(2300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_This] = ACTIONS(2300),
    [anon_sym_decltype] = ACTIONS(2300),
    [anon_sym_final] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_template] = ACTIONS(2300),
    [anon_sym_GT2] = ACTIONS(2302),
    [anon_sym_operator] = ACTIONS(2300),
    [anon_sym_precise] = ACTIONS(2300),
    [anon_sym_shared] = ACTIONS(2300),
    [anon_sym_groupshared] = ACTIONS(2300),
    [anon_sym_uniform] = ACTIONS(2300),
    [anon_sym_row_major] = ACTIONS(2300),
    [anon_sym_column_major] = ACTIONS(2300),
    [anon_sym_globallycoherent] = ACTIONS(2300),
    [anon_sym_centroid] = ACTIONS(2300),
    [anon_sym_noperspective] = ACTIONS(2300),
    [anon_sym_nointerpolation] = ACTIONS(2300),
    [anon_sym_sample] = ACTIONS(2300),
    [anon_sym_linear] = ACTIONS(2300),
    [anon_sym_snorm] = ACTIONS(2300),
    [anon_sym_unorm] = ACTIONS(2300),
    [anon_sym_point] = ACTIONS(2300),
    [anon_sym_line] = ACTIONS(2300),
    [anon_sym_triangleadj] = ACTIONS(2300),
    [anon_sym_lineadj] = ACTIONS(2300),
    [anon_sym_triangle] = ACTIONS(2300),
  },
  [2975] = {
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_COMMA] = ACTIONS(2262),
    [anon_sym_RPAREN] = ACTIONS(2262),
    [anon_sym_LPAREN2] = ACTIONS(2262),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(2262),
    [anon_sym_AMP_AMP] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_COLON] = ACTIONS(2260),
    [anon_sym___extension__] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(2260),
    [anon_sym_out] = ACTIONS(2260),
    [anon_sym_inout] = ACTIONS(2260),
    [anon_sym_virtual] = ACTIONS(2260),
    [anon_sym_extern] = ACTIONS(2260),
    [anon_sym___attribute__] = ACTIONS(2260),
    [anon_sym___attribute] = ACTIONS(2260),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2262),
    [anon_sym___declspec] = ACTIONS(2260),
    [anon_sym___based] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_EQ] = ACTIONS(2262),
    [anon_sym_register] = ACTIONS(2260),
    [anon_sym_inline] = ACTIONS(2260),
    [anon_sym___inline] = ACTIONS(2260),
    [anon_sym___inline__] = ACTIONS(2260),
    [anon_sym___forceinline] = ACTIONS(2260),
    [anon_sym_thread_local] = ACTIONS(2260),
    [anon_sym___thread] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_constexpr] = ACTIONS(2260),
    [anon_sym_volatile] = ACTIONS(2260),
    [anon_sym_restrict] = ACTIONS(2260),
    [anon_sym___restrict__] = ACTIONS(2260),
    [anon_sym__Atomic] = ACTIONS(2260),
    [anon_sym__Noreturn] = ACTIONS(2260),
    [anon_sym_noreturn] = ACTIONS(2260),
    [anon_sym__Nonnull] = ACTIONS(2260),
    [anon_sym_mutable] = ACTIONS(2260),
    [anon_sym_constinit] = ACTIONS(2260),
    [anon_sym_consteval] = ACTIONS(2260),
    [anon_sym_alignas] = ACTIONS(2260),
    [anon_sym__Alignas] = ACTIONS(2260),
    [anon_sym_DOT] = ACTIONS(2260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_This] = ACTIONS(2260),
    [anon_sym_decltype] = ACTIONS(2260),
    [anon_sym_final] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
    [anon_sym_template] = ACTIONS(2260),
    [anon_sym_GT2] = ACTIONS(2262),
    [anon_sym_operator] = ACTIONS(2260),
    [anon_sym_precise] = ACTIONS(2260),
    [anon_sym_shared] = ACTIONS(2260),
    [anon_sym_groupshared] = ACTIONS(2260),
    [anon_sym_uniform] = ACTIONS(2260),
    [anon_sym_row_major] = ACTIONS(2260),
    [anon_sym_column_major] = ACTIONS(2260),
    [anon_sym_globallycoherent] = ACTIONS(2260),
    [anon_sym_centroid] = ACTIONS(2260),
    [anon_sym_noperspective] = ACTIONS(2260),
    [anon_sym_nointerpolation] = ACTIONS(2260),
    [anon_sym_sample] = ACTIONS(2260),
    [anon_sym_linear] = ACTIONS(2260),
    [anon_sym_snorm] = ACTIONS(2260),
    [anon_sym_unorm] = ACTIONS(2260),
    [anon_sym_point] = ACTIONS(2260),
    [anon_sym_line] = ACTIONS(2260),
    [anon_sym_triangleadj] = ACTIONS(2260),
    [anon_sym_lineadj] = ACTIONS(2260),
    [anon_sym_triangle] = ACTIONS(2260),
  },
  [2976] = {
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_COMMA] = ACTIONS(2306),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_COLON] = ACTIONS(2304),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym_in] = ACTIONS(2304),
    [anon_sym_out] = ACTIONS(2304),
    [anon_sym_inout] = ACTIONS(2304),
    [anon_sym_virtual] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym___attribute] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2306),
    [anon_sym___declspec] = ACTIONS(2304),
    [anon_sym___based] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_EQ] = ACTIONS(2306),
    [anon_sym_register] = ACTIONS(2304),
    [anon_sym_inline] = ACTIONS(2304),
    [anon_sym___inline] = ACTIONS(2304),
    [anon_sym___inline__] = ACTIONS(2304),
    [anon_sym___forceinline] = ACTIONS(2304),
    [anon_sym_thread_local] = ACTIONS(2304),
    [anon_sym___thread] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym__Nonnull] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [anon_sym_DOT] = ACTIONS(2304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_This] = ACTIONS(2304),
    [anon_sym_decltype] = ACTIONS(2304),
    [anon_sym_final] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_template] = ACTIONS(2304),
    [anon_sym_GT2] = ACTIONS(2306),
    [anon_sym_operator] = ACTIONS(2304),
    [anon_sym_precise] = ACTIONS(2304),
    [anon_sym_shared] = ACTIONS(2304),
    [anon_sym_groupshared] = ACTIONS(2304),
    [anon_sym_uniform] = ACTIONS(2304),
    [anon_sym_row_major] = ACTIONS(2304),
    [anon_sym_column_major] = ACTIONS(2304),
    [anon_sym_globallycoherent] = ACTIONS(2304),
    [anon_sym_centroid] = ACTIONS(2304),
    [anon_sym_noperspective] = ACTIONS(2304),
    [anon_sym_nointerpolation] = ACTIONS(2304),
    [anon_sym_sample] = ACTIONS(2304),
    [anon_sym_linear] = ACTIONS(2304),
    [anon_sym_snorm] = ACTIONS(2304),
    [anon_sym_unorm] = ACTIONS(2304),
    [anon_sym_point] = ACTIONS(2304),
    [anon_sym_line] = ACTIONS(2304),
    [anon_sym_triangleadj] = ACTIONS(2304),
    [anon_sym_lineadj] = ACTIONS(2304),
    [anon_sym_triangle] = ACTIONS(2304),
  },
  [2977] = {
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2310),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_RPAREN] = ACTIONS(2310),
    [anon_sym_LPAREN2] = ACTIONS(2310),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_COLON] = ACTIONS(2308),
    [anon_sym___extension__] = ACTIONS(2308),
    [anon_sym_in] = ACTIONS(2308),
    [anon_sym_out] = ACTIONS(2308),
    [anon_sym_inout] = ACTIONS(2308),
    [anon_sym_virtual] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2308),
    [anon_sym___attribute__] = ACTIONS(2308),
    [anon_sym___attribute] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2310),
    [anon_sym___declspec] = ACTIONS(2308),
    [anon_sym___based] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_EQ] = ACTIONS(2310),
    [anon_sym_register] = ACTIONS(2308),
    [anon_sym_inline] = ACTIONS(2308),
    [anon_sym___inline] = ACTIONS(2308),
    [anon_sym___inline__] = ACTIONS(2308),
    [anon_sym___forceinline] = ACTIONS(2308),
    [anon_sym_thread_local] = ACTIONS(2308),
    [anon_sym___thread] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_constexpr] = ACTIONS(2308),
    [anon_sym_volatile] = ACTIONS(2308),
    [anon_sym_restrict] = ACTIONS(2308),
    [anon_sym___restrict__] = ACTIONS(2308),
    [anon_sym__Atomic] = ACTIONS(2308),
    [anon_sym__Noreturn] = ACTIONS(2308),
    [anon_sym_noreturn] = ACTIONS(2308),
    [anon_sym__Nonnull] = ACTIONS(2308),
    [anon_sym_mutable] = ACTIONS(2308),
    [anon_sym_constinit] = ACTIONS(2308),
    [anon_sym_consteval] = ACTIONS(2308),
    [anon_sym_alignas] = ACTIONS(2308),
    [anon_sym__Alignas] = ACTIONS(2308),
    [anon_sym_DOT] = ACTIONS(2308),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_This] = ACTIONS(2308),
    [anon_sym_decltype] = ACTIONS(2308),
    [anon_sym_final] = ACTIONS(2308),
    [anon_sym_override] = ACTIONS(2308),
    [anon_sym_template] = ACTIONS(2308),
    [anon_sym_GT2] = ACTIONS(2310),
    [anon_sym_operator] = ACTIONS(2308),
    [anon_sym_precise] = ACTIONS(2308),
    [anon_sym_shared] = ACTIONS(2308),
    [anon_sym_groupshared] = ACTIONS(2308),
    [anon_sym_uniform] = ACTIONS(2308),
    [anon_sym_row_major] = ACTIONS(2308),
    [anon_sym_column_major] = ACTIONS(2308),
    [anon_sym_globallycoherent] = ACTIONS(2308),
    [anon_sym_centroid] = ACTIONS(2308),
    [anon_sym_noperspective] = ACTIONS(2308),
    [anon_sym_nointerpolation] = ACTIONS(2308),
    [anon_sym_sample] = ACTIONS(2308),
    [anon_sym_linear] = ACTIONS(2308),
    [anon_sym_snorm] = ACTIONS(2308),
    [anon_sym_unorm] = ACTIONS(2308),
    [anon_sym_point] = ACTIONS(2308),
    [anon_sym_line] = ACTIONS(2308),
    [anon_sym_triangleadj] = ACTIONS(2308),
    [anon_sym_lineadj] = ACTIONS(2308),
    [anon_sym_triangle] = ACTIONS(2308),
  },
  [2978] = {
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2314),
    [anon_sym_COMMA] = ACTIONS(2314),
    [anon_sym_RPAREN] = ACTIONS(2314),
    [anon_sym_LPAREN2] = ACTIONS(2314),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym___extension__] = ACTIONS(2312),
    [anon_sym_in] = ACTIONS(2312),
    [anon_sym_out] = ACTIONS(2312),
    [anon_sym_inout] = ACTIONS(2312),
    [anon_sym_virtual] = ACTIONS(2312),
    [anon_sym_extern] = ACTIONS(2312),
    [anon_sym___attribute__] = ACTIONS(2312),
    [anon_sym___attribute] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2314),
    [anon_sym___declspec] = ACTIONS(2312),
    [anon_sym___based] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_EQ] = ACTIONS(2314),
    [anon_sym_register] = ACTIONS(2312),
    [anon_sym_inline] = ACTIONS(2312),
    [anon_sym___inline] = ACTIONS(2312),
    [anon_sym___inline__] = ACTIONS(2312),
    [anon_sym___forceinline] = ACTIONS(2312),
    [anon_sym_thread_local] = ACTIONS(2312),
    [anon_sym___thread] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_constexpr] = ACTIONS(2312),
    [anon_sym_volatile] = ACTIONS(2312),
    [anon_sym_restrict] = ACTIONS(2312),
    [anon_sym___restrict__] = ACTIONS(2312),
    [anon_sym__Atomic] = ACTIONS(2312),
    [anon_sym__Noreturn] = ACTIONS(2312),
    [anon_sym_noreturn] = ACTIONS(2312),
    [anon_sym__Nonnull] = ACTIONS(2312),
    [anon_sym_mutable] = ACTIONS(2312),
    [anon_sym_constinit] = ACTIONS(2312),
    [anon_sym_consteval] = ACTIONS(2312),
    [anon_sym_alignas] = ACTIONS(2312),
    [anon_sym__Alignas] = ACTIONS(2312),
    [anon_sym_DOT] = ACTIONS(2312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_This] = ACTIONS(2312),
    [anon_sym_decltype] = ACTIONS(2312),
    [anon_sym_final] = ACTIONS(2312),
    [anon_sym_override] = ACTIONS(2312),
    [anon_sym_template] = ACTIONS(2312),
    [anon_sym_GT2] = ACTIONS(2314),
    [anon_sym_operator] = ACTIONS(2312),
    [anon_sym_precise] = ACTIONS(2312),
    [anon_sym_shared] = ACTIONS(2312),
    [anon_sym_groupshared] = ACTIONS(2312),
    [anon_sym_uniform] = ACTIONS(2312),
    [anon_sym_row_major] = ACTIONS(2312),
    [anon_sym_column_major] = ACTIONS(2312),
    [anon_sym_globallycoherent] = ACTIONS(2312),
    [anon_sym_centroid] = ACTIONS(2312),
    [anon_sym_noperspective] = ACTIONS(2312),
    [anon_sym_nointerpolation] = ACTIONS(2312),
    [anon_sym_sample] = ACTIONS(2312),
    [anon_sym_linear] = ACTIONS(2312),
    [anon_sym_snorm] = ACTIONS(2312),
    [anon_sym_unorm] = ACTIONS(2312),
    [anon_sym_point] = ACTIONS(2312),
    [anon_sym_line] = ACTIONS(2312),
    [anon_sym_triangleadj] = ACTIONS(2312),
    [anon_sym_lineadj] = ACTIONS(2312),
    [anon_sym_triangle] = ACTIONS(2312),
  },
  [2979] = {
    [sym_identifier] = ACTIONS(2268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2270),
    [anon_sym_COMMA] = ACTIONS(2270),
    [anon_sym_RPAREN] = ACTIONS(2270),
    [anon_sym_LPAREN2] = ACTIONS(2270),
    [anon_sym_TILDE] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(2270),
    [anon_sym_AMP_AMP] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(2268),
    [anon_sym_COLON] = ACTIONS(2268),
    [anon_sym___extension__] = ACTIONS(2268),
    [anon_sym_in] = ACTIONS(2268),
    [anon_sym_out] = ACTIONS(2268),
    [anon_sym_inout] = ACTIONS(2268),
    [anon_sym_virtual] = ACTIONS(2268),
    [anon_sym_extern] = ACTIONS(2268),
    [anon_sym___attribute__] = ACTIONS(2268),
    [anon_sym___attribute] = ACTIONS(2268),
    [anon_sym_COLON_COLON] = ACTIONS(2270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2270),
    [anon_sym___declspec] = ACTIONS(2268),
    [anon_sym___based] = ACTIONS(2268),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_LBRACK] = ACTIONS(2268),
    [anon_sym_static] = ACTIONS(2268),
    [anon_sym_EQ] = ACTIONS(2270),
    [anon_sym_register] = ACTIONS(2268),
    [anon_sym_inline] = ACTIONS(2268),
    [anon_sym___inline] = ACTIONS(2268),
    [anon_sym___inline__] = ACTIONS(2268),
    [anon_sym___forceinline] = ACTIONS(2268),
    [anon_sym_thread_local] = ACTIONS(2268),
    [anon_sym___thread] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_constexpr] = ACTIONS(2268),
    [anon_sym_volatile] = ACTIONS(2268),
    [anon_sym_restrict] = ACTIONS(2268),
    [anon_sym___restrict__] = ACTIONS(2268),
    [anon_sym__Atomic] = ACTIONS(2268),
    [anon_sym__Noreturn] = ACTIONS(2268),
    [anon_sym_noreturn] = ACTIONS(2268),
    [anon_sym__Nonnull] = ACTIONS(2268),
    [anon_sym_mutable] = ACTIONS(2268),
    [anon_sym_constinit] = ACTIONS(2268),
    [anon_sym_consteval] = ACTIONS(2268),
    [anon_sym_alignas] = ACTIONS(2268),
    [anon_sym__Alignas] = ACTIONS(2268),
    [anon_sym_DOT] = ACTIONS(2268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_This] = ACTIONS(2268),
    [anon_sym_decltype] = ACTIONS(2268),
    [anon_sym_final] = ACTIONS(2268),
    [anon_sym_override] = ACTIONS(2268),
    [anon_sym_template] = ACTIONS(2268),
    [anon_sym_GT2] = ACTIONS(2270),
    [anon_sym_operator] = ACTIONS(2268),
    [anon_sym_precise] = ACTIONS(2268),
    [anon_sym_shared] = ACTIONS(2268),
    [anon_sym_groupshared] = ACTIONS(2268),
    [anon_sym_uniform] = ACTIONS(2268),
    [anon_sym_row_major] = ACTIONS(2268),
    [anon_sym_column_major] = ACTIONS(2268),
    [anon_sym_globallycoherent] = ACTIONS(2268),
    [anon_sym_centroid] = ACTIONS(2268),
    [anon_sym_noperspective] = ACTIONS(2268),
    [anon_sym_nointerpolation] = ACTIONS(2268),
    [anon_sym_sample] = ACTIONS(2268),
    [anon_sym_linear] = ACTIONS(2268),
    [anon_sym_snorm] = ACTIONS(2268),
    [anon_sym_unorm] = ACTIONS(2268),
    [anon_sym_point] = ACTIONS(2268),
    [anon_sym_line] = ACTIONS(2268),
    [anon_sym_triangleadj] = ACTIONS(2268),
    [anon_sym_lineadj] = ACTIONS(2268),
    [anon_sym_triangle] = ACTIONS(2268),
  },
  [2980] = {
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2274),
    [anon_sym_COMMA] = ACTIONS(2274),
    [anon_sym_RPAREN] = ACTIONS(2274),
    [anon_sym_LPAREN2] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [anon_sym_STAR] = ACTIONS(2274),
    [anon_sym_AMP_AMP] = ACTIONS(2274),
    [anon_sym_AMP] = ACTIONS(2272),
    [anon_sym_COLON] = ACTIONS(2272),
    [anon_sym___extension__] = ACTIONS(2272),
    [anon_sym_in] = ACTIONS(2272),
    [anon_sym_out] = ACTIONS(2272),
    [anon_sym_inout] = ACTIONS(2272),
    [anon_sym_virtual] = ACTIONS(2272),
    [anon_sym_extern] = ACTIONS(2272),
    [anon_sym___attribute__] = ACTIONS(2272),
    [anon_sym___attribute] = ACTIONS(2272),
    [anon_sym_COLON_COLON] = ACTIONS(2274),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2274),
    [anon_sym___declspec] = ACTIONS(2272),
    [anon_sym___based] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_EQ] = ACTIONS(2274),
    [anon_sym_register] = ACTIONS(2272),
    [anon_sym_inline] = ACTIONS(2272),
    [anon_sym___inline] = ACTIONS(2272),
    [anon_sym___inline__] = ACTIONS(2272),
    [anon_sym___forceinline] = ACTIONS(2272),
    [anon_sym_thread_local] = ACTIONS(2272),
    [anon_sym___thread] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_constexpr] = ACTIONS(2272),
    [anon_sym_volatile] = ACTIONS(2272),
    [anon_sym_restrict] = ACTIONS(2272),
    [anon_sym___restrict__] = ACTIONS(2272),
    [anon_sym__Atomic] = ACTIONS(2272),
    [anon_sym__Noreturn] = ACTIONS(2272),
    [anon_sym_noreturn] = ACTIONS(2272),
    [anon_sym__Nonnull] = ACTIONS(2272),
    [anon_sym_mutable] = ACTIONS(2272),
    [anon_sym_constinit] = ACTIONS(2272),
    [anon_sym_consteval] = ACTIONS(2272),
    [anon_sym_alignas] = ACTIONS(2272),
    [anon_sym__Alignas] = ACTIONS(2272),
    [anon_sym_DOT] = ACTIONS(2272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_This] = ACTIONS(2272),
    [anon_sym_decltype] = ACTIONS(2272),
    [anon_sym_final] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_template] = ACTIONS(2272),
    [anon_sym_GT2] = ACTIONS(2274),
    [anon_sym_operator] = ACTIONS(2272),
    [anon_sym_precise] = ACTIONS(2272),
    [anon_sym_shared] = ACTIONS(2272),
    [anon_sym_groupshared] = ACTIONS(2272),
    [anon_sym_uniform] = ACTIONS(2272),
    [anon_sym_row_major] = ACTIONS(2272),
    [anon_sym_column_major] = ACTIONS(2272),
    [anon_sym_globallycoherent] = ACTIONS(2272),
    [anon_sym_centroid] = ACTIONS(2272),
    [anon_sym_noperspective] = ACTIONS(2272),
    [anon_sym_nointerpolation] = ACTIONS(2272),
    [anon_sym_sample] = ACTIONS(2272),
    [anon_sym_linear] = ACTIONS(2272),
    [anon_sym_snorm] = ACTIONS(2272),
    [anon_sym_unorm] = ACTIONS(2272),
    [anon_sym_point] = ACTIONS(2272),
    [anon_sym_line] = ACTIONS(2272),
    [anon_sym_triangleadj] = ACTIONS(2272),
    [anon_sym_lineadj] = ACTIONS(2272),
    [anon_sym_triangle] = ACTIONS(2272),
  },
  [2981] = {
    [sym_identifier] = ACTIONS(7194),
    [anon_sym_LPAREN2] = ACTIONS(7196),
    [anon_sym_BANG] = ACTIONS(7196),
    [anon_sym_TILDE] = ACTIONS(7196),
    [anon_sym_DASH] = ACTIONS(7194),
    [anon_sym_PLUS] = ACTIONS(7194),
    [anon_sym_STAR] = ACTIONS(7196),
    [anon_sym_AMP] = ACTIONS(7196),
    [anon_sym_SEMI] = ACTIONS(7196),
    [anon_sym___extension__] = ACTIONS(7194),
    [anon_sym_COLON_COLON] = ACTIONS(7196),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7196),
    [anon_sym_LBRACE] = ACTIONS(7196),
    [anon_sym_LBRACK] = ACTIONS(7194),
    [sym_primitive_type] = ACTIONS(7194),
    [anon_sym_if] = ACTIONS(7194),
    [anon_sym_switch] = ACTIONS(7194),
    [anon_sym_case] = ACTIONS(7194),
    [anon_sym_default] = ACTIONS(7194),
    [anon_sym_while] = ACTIONS(7194),
    [anon_sym_do] = ACTIONS(7194),
    [anon_sym_for] = ACTIONS(7194),
    [anon_sym_return] = ACTIONS(7194),
    [anon_sym_break] = ACTIONS(7194),
    [anon_sym_continue] = ACTIONS(7194),
    [anon_sym_goto] = ACTIONS(7194),
    [anon_sym___try] = ACTIONS(7194),
    [anon_sym___leave] = ACTIONS(7194),
    [anon_sym_not] = ACTIONS(7194),
    [anon_sym_compl] = ACTIONS(7194),
    [anon_sym_DASH_DASH] = ACTIONS(7196),
    [anon_sym_PLUS_PLUS] = ACTIONS(7196),
    [anon_sym_sizeof] = ACTIONS(7194),
    [anon_sym___alignof__] = ACTIONS(7194),
    [anon_sym___alignof] = ACTIONS(7194),
    [anon_sym__alignof] = ACTIONS(7194),
    [anon_sym_alignof] = ACTIONS(7194),
    [anon_sym__Alignof] = ACTIONS(7194),
    [anon_sym_offsetof] = ACTIONS(7194),
    [anon_sym__Generic] = ACTIONS(7194),
    [anon_sym_asm] = ACTIONS(7194),
    [anon_sym___asm__] = ACTIONS(7194),
    [anon_sym___asm] = ACTIONS(7194),
    [sym_number_literal] = ACTIONS(7196),
    [anon_sym_L_SQUOTE] = ACTIONS(7196),
    [anon_sym_u_SQUOTE] = ACTIONS(7196),
    [anon_sym_U_SQUOTE] = ACTIONS(7196),
    [anon_sym_u8_SQUOTE] = ACTIONS(7196),
    [anon_sym_SQUOTE] = ACTIONS(7196),
    [anon_sym_L_DQUOTE] = ACTIONS(7196),
    [anon_sym_u_DQUOTE] = ACTIONS(7196),
    [anon_sym_U_DQUOTE] = ACTIONS(7196),
    [anon_sym_u8_DQUOTE] = ACTIONS(7196),
    [anon_sym_DQUOTE] = ACTIONS(7196),
    [sym_true] = ACTIONS(7194),
    [sym_false] = ACTIONS(7194),
    [anon_sym_NULL] = ACTIONS(7194),
    [anon_sym_nullptr] = ACTIONS(7194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(7194),
    [anon_sym_template] = ACTIONS(7194),
    [anon_sym_try] = ACTIONS(7194),
    [anon_sym_delete] = ACTIONS(7194),
    [anon_sym_throw] = ACTIONS(7194),
    [anon_sym_co_return] = ACTIONS(7194),
    [anon_sym_co_yield] = ACTIONS(7194),
    [anon_sym_R_DQUOTE] = ACTIONS(7196),
    [anon_sym_LR_DQUOTE] = ACTIONS(7196),
    [anon_sym_uR_DQUOTE] = ACTIONS(7196),
    [anon_sym_UR_DQUOTE] = ACTIONS(7196),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7196),
    [anon_sym_co_await] = ACTIONS(7194),
    [anon_sym_new] = ACTIONS(7194),
    [anon_sym_requires] = ACTIONS(7194),
    [sym_this] = ACTIONS(7194),
    [anon_sym_discard] = ACTIONS(7194),
    [anon_sym_cbuffer] = ACTIONS(7194),
  },
  [2982] = {
    [sym_identifier] = ACTIONS(7198),
    [anon_sym_LPAREN2] = ACTIONS(7200),
    [anon_sym_BANG] = ACTIONS(7200),
    [anon_sym_TILDE] = ACTIONS(7200),
    [anon_sym_DASH] = ACTIONS(7198),
    [anon_sym_PLUS] = ACTIONS(7198),
    [anon_sym_STAR] = ACTIONS(7200),
    [anon_sym_AMP] = ACTIONS(7200),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym___extension__] = ACTIONS(7198),
    [anon_sym_COLON_COLON] = ACTIONS(7200),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7200),
    [anon_sym_LBRACE] = ACTIONS(7200),
    [anon_sym_LBRACK] = ACTIONS(7198),
    [sym_primitive_type] = ACTIONS(7198),
    [anon_sym_if] = ACTIONS(7198),
    [anon_sym_switch] = ACTIONS(7198),
    [anon_sym_case] = ACTIONS(7198),
    [anon_sym_default] = ACTIONS(7198),
    [anon_sym_while] = ACTIONS(7198),
    [anon_sym_do] = ACTIONS(7198),
    [anon_sym_for] = ACTIONS(7198),
    [anon_sym_return] = ACTIONS(7198),
    [anon_sym_break] = ACTIONS(7198),
    [anon_sym_continue] = ACTIONS(7198),
    [anon_sym_goto] = ACTIONS(7198),
    [anon_sym___try] = ACTIONS(7198),
    [anon_sym___leave] = ACTIONS(7198),
    [anon_sym_not] = ACTIONS(7198),
    [anon_sym_compl] = ACTIONS(7198),
    [anon_sym_DASH_DASH] = ACTIONS(7200),
    [anon_sym_PLUS_PLUS] = ACTIONS(7200),
    [anon_sym_sizeof] = ACTIONS(7198),
    [anon_sym___alignof__] = ACTIONS(7198),
    [anon_sym___alignof] = ACTIONS(7198),
    [anon_sym__alignof] = ACTIONS(7198),
    [anon_sym_alignof] = ACTIONS(7198),
    [anon_sym__Alignof] = ACTIONS(7198),
    [anon_sym_offsetof] = ACTIONS(7198),
    [anon_sym__Generic] = ACTIONS(7198),
    [anon_sym_asm] = ACTIONS(7198),
    [anon_sym___asm__] = ACTIONS(7198),
    [anon_sym___asm] = ACTIONS(7198),
    [sym_number_literal] = ACTIONS(7200),
    [anon_sym_L_SQUOTE] = ACTIONS(7200),
    [anon_sym_u_SQUOTE] = ACTIONS(7200),
    [anon_sym_U_SQUOTE] = ACTIONS(7200),
    [anon_sym_u8_SQUOTE] = ACTIONS(7200),
    [anon_sym_SQUOTE] = ACTIONS(7200),
    [anon_sym_L_DQUOTE] = ACTIONS(7200),
    [anon_sym_u_DQUOTE] = ACTIONS(7200),
    [anon_sym_U_DQUOTE] = ACTIONS(7200),
    [anon_sym_u8_DQUOTE] = ACTIONS(7200),
    [anon_sym_DQUOTE] = ACTIONS(7200),
    [sym_true] = ACTIONS(7198),
    [sym_false] = ACTIONS(7198),
    [anon_sym_NULL] = ACTIONS(7198),
    [anon_sym_nullptr] = ACTIONS(7198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(7198),
    [anon_sym_template] = ACTIONS(7198),
    [anon_sym_try] = ACTIONS(7198),
    [anon_sym_delete] = ACTIONS(7198),
    [anon_sym_throw] = ACTIONS(7198),
    [anon_sym_co_return] = ACTIONS(7198),
    [anon_sym_co_yield] = ACTIONS(7198),
    [anon_sym_R_DQUOTE] = ACTIONS(7200),
    [anon_sym_LR_DQUOTE] = ACTIONS(7200),
    [anon_sym_uR_DQUOTE] = ACTIONS(7200),
    [anon_sym_UR_DQUOTE] = ACTIONS(7200),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7200),
    [anon_sym_co_await] = ACTIONS(7198),
    [anon_sym_new] = ACTIONS(7198),
    [anon_sym_requires] = ACTIONS(7198),
    [sym_this] = ACTIONS(7198),
    [anon_sym_discard] = ACTIONS(7198),
    [anon_sym_cbuffer] = ACTIONS(7198),
  },
  [2983] = {
    [sym_identifier] = ACTIONS(2276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2278),
    [anon_sym_COMMA] = ACTIONS(2278),
    [anon_sym_RPAREN] = ACTIONS(2278),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(2278),
    [anon_sym_AMP_AMP] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_COLON] = ACTIONS(2276),
    [anon_sym___extension__] = ACTIONS(2276),
    [anon_sym_in] = ACTIONS(2276),
    [anon_sym_out] = ACTIONS(2276),
    [anon_sym_inout] = ACTIONS(2276),
    [anon_sym_virtual] = ACTIONS(2276),
    [anon_sym_extern] = ACTIONS(2276),
    [anon_sym___attribute__] = ACTIONS(2276),
    [anon_sym___attribute] = ACTIONS(2276),
    [anon_sym_COLON_COLON] = ACTIONS(2278),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2278),
    [anon_sym___declspec] = ACTIONS(2276),
    [anon_sym___based] = ACTIONS(2276),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_LBRACK] = ACTIONS(2276),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_EQ] = ACTIONS(2278),
    [anon_sym_register] = ACTIONS(2276),
    [anon_sym_inline] = ACTIONS(2276),
    [anon_sym___inline] = ACTIONS(2276),
    [anon_sym___inline__] = ACTIONS(2276),
    [anon_sym___forceinline] = ACTIONS(2276),
    [anon_sym_thread_local] = ACTIONS(2276),
    [anon_sym___thread] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_constexpr] = ACTIONS(2276),
    [anon_sym_volatile] = ACTIONS(2276),
    [anon_sym_restrict] = ACTIONS(2276),
    [anon_sym___restrict__] = ACTIONS(2276),
    [anon_sym__Atomic] = ACTIONS(2276),
    [anon_sym__Noreturn] = ACTIONS(2276),
    [anon_sym_noreturn] = ACTIONS(2276),
    [anon_sym__Nonnull] = ACTIONS(2276),
    [anon_sym_mutable] = ACTIONS(2276),
    [anon_sym_constinit] = ACTIONS(2276),
    [anon_sym_consteval] = ACTIONS(2276),
    [anon_sym_alignas] = ACTIONS(2276),
    [anon_sym__Alignas] = ACTIONS(2276),
    [anon_sym_DOT] = ACTIONS(2276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_This] = ACTIONS(2276),
    [anon_sym_decltype] = ACTIONS(2276),
    [anon_sym_final] = ACTIONS(2276),
    [anon_sym_override] = ACTIONS(2276),
    [anon_sym_template] = ACTIONS(2276),
    [anon_sym_GT2] = ACTIONS(2278),
    [anon_sym_operator] = ACTIONS(2276),
    [anon_sym_precise] = ACTIONS(2276),
    [anon_sym_shared] = ACTIONS(2276),
    [anon_sym_groupshared] = ACTIONS(2276),
    [anon_sym_uniform] = ACTIONS(2276),
    [anon_sym_row_major] = ACTIONS(2276),
    [anon_sym_column_major] = ACTIONS(2276),
    [anon_sym_globallycoherent] = ACTIONS(2276),
    [anon_sym_centroid] = ACTIONS(2276),
    [anon_sym_noperspective] = ACTIONS(2276),
    [anon_sym_nointerpolation] = ACTIONS(2276),
    [anon_sym_sample] = ACTIONS(2276),
    [anon_sym_linear] = ACTIONS(2276),
    [anon_sym_snorm] = ACTIONS(2276),
    [anon_sym_unorm] = ACTIONS(2276),
    [anon_sym_point] = ACTIONS(2276),
    [anon_sym_line] = ACTIONS(2276),
    [anon_sym_triangleadj] = ACTIONS(2276),
    [anon_sym_lineadj] = ACTIONS(2276),
    [anon_sym_triangle] = ACTIONS(2276),
  },
  [2984] = {
    [sym_string_literal] = STATE(2984),
    [sym_raw_string_literal] = STATE(2984),
    [aux_sym_concatenated_string_repeat1] = STATE(2984),
    [sym_identifier] = ACTIONS(7202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7205),
    [anon_sym_COMMA] = ACTIONS(7205),
    [anon_sym_RPAREN] = ACTIONS(7205),
    [aux_sym_preproc_if_token2] = ACTIONS(7205),
    [aux_sym_preproc_else_token1] = ACTIONS(7205),
    [aux_sym_preproc_elif_token1] = ACTIONS(7207),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7205),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7205),
    [anon_sym_LPAREN2] = ACTIONS(7205),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_SLASH] = ACTIONS(7207),
    [anon_sym_PERCENT] = ACTIONS(7207),
    [anon_sym_PIPE_PIPE] = ACTIONS(7205),
    [anon_sym_AMP_AMP] = ACTIONS(7205),
    [anon_sym_PIPE] = ACTIONS(7207),
    [anon_sym_CARET] = ACTIONS(7207),
    [anon_sym_AMP] = ACTIONS(7207),
    [anon_sym_EQ_EQ] = ACTIONS(7205),
    [anon_sym_BANG_EQ] = ACTIONS(7205),
    [anon_sym_GT] = ACTIONS(7207),
    [anon_sym_GT_EQ] = ACTIONS(7205),
    [anon_sym_LT_EQ] = ACTIONS(7207),
    [anon_sym_LT] = ACTIONS(7207),
    [anon_sym_LT_LT] = ACTIONS(7207),
    [anon_sym_GT_GT] = ACTIONS(7207),
    [anon_sym_COLON] = ACTIONS(7205),
    [anon_sym_SEMI] = ACTIONS(7205),
    [anon_sym_RBRACE] = ACTIONS(7205),
    [anon_sym_LBRACK] = ACTIONS(7205),
    [anon_sym_RBRACK] = ACTIONS(7205),
    [anon_sym_EQ] = ACTIONS(7207),
    [anon_sym_QMARK] = ACTIONS(7205),
    [anon_sym_STAR_EQ] = ACTIONS(7205),
    [anon_sym_SLASH_EQ] = ACTIONS(7205),
    [anon_sym_PERCENT_EQ] = ACTIONS(7205),
    [anon_sym_PLUS_EQ] = ACTIONS(7205),
    [anon_sym_DASH_EQ] = ACTIONS(7205),
    [anon_sym_LT_LT_EQ] = ACTIONS(7205),
    [anon_sym_GT_GT_EQ] = ACTIONS(7205),
    [anon_sym_AMP_EQ] = ACTIONS(7205),
    [anon_sym_CARET_EQ] = ACTIONS(7205),
    [anon_sym_PIPE_EQ] = ACTIONS(7205),
    [anon_sym_and_eq] = ACTIONS(7207),
    [anon_sym_or_eq] = ACTIONS(7207),
    [anon_sym_xor_eq] = ACTIONS(7207),
    [anon_sym_LT_EQ_GT] = ACTIONS(7205),
    [anon_sym_or] = ACTIONS(7207),
    [anon_sym_and] = ACTIONS(7207),
    [anon_sym_bitor] = ACTIONS(7207),
    [anon_sym_xor] = ACTIONS(7207),
    [anon_sym_bitand] = ACTIONS(7207),
    [anon_sym_not_eq] = ACTIONS(7207),
    [anon_sym_is] = ACTIONS(7207),
    [anon_sym_as] = ACTIONS(7207),
    [anon_sym_DASH_DASH] = ACTIONS(7205),
    [anon_sym_PLUS_PLUS] = ACTIONS(7205),
    [anon_sym_DOT] = ACTIONS(7207),
    [anon_sym_DOT_STAR] = ACTIONS(7205),
    [anon_sym_DASH_GT] = ACTIONS(7205),
    [anon_sym_L_DQUOTE] = ACTIONS(7209),
    [anon_sym_u_DQUOTE] = ACTIONS(7209),
    [anon_sym_U_DQUOTE] = ACTIONS(7209),
    [anon_sym_u8_DQUOTE] = ACTIONS(7209),
    [anon_sym_DQUOTE] = ACTIONS(7209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7212),
    [anon_sym_LR_DQUOTE] = ACTIONS(7212),
    [anon_sym_uR_DQUOTE] = ACTIONS(7212),
    [anon_sym_UR_DQUOTE] = ACTIONS(7212),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7212),
    [sym_literal_suffix] = ACTIONS(7207),
  },
  [2985] = {
    [sym_identifier] = ACTIONS(2239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2241),
    [anon_sym_COMMA] = ACTIONS(2241),
    [anon_sym_RPAREN] = ACTIONS(2241),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_COLON] = ACTIONS(2239),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym_in] = ACTIONS(2239),
    [anon_sym_out] = ACTIONS(2239),
    [anon_sym_inout] = ACTIONS(2239),
    [anon_sym_virtual] = ACTIONS(2239),
    [anon_sym_extern] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym___attribute] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2241),
    [anon_sym___declspec] = ACTIONS(2239),
    [anon_sym___based] = ACTIONS(2239),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2239),
    [anon_sym_EQ] = ACTIONS(2241),
    [anon_sym_register] = ACTIONS(2239),
    [anon_sym_inline] = ACTIONS(2239),
    [anon_sym___inline] = ACTIONS(2239),
    [anon_sym___inline__] = ACTIONS(2239),
    [anon_sym___forceinline] = ACTIONS(2239),
    [anon_sym_thread_local] = ACTIONS(2239),
    [anon_sym___thread] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym__Nonnull] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [anon_sym_DOT] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2239),
    [anon_sym_let] = ACTIONS(2239),
    [anon_sym_This] = ACTIONS(2239),
    [anon_sym_decltype] = ACTIONS(2239),
    [anon_sym_final] = ACTIONS(2239),
    [anon_sym_override] = ACTIONS(2239),
    [anon_sym_template] = ACTIONS(2239),
    [anon_sym_GT2] = ACTIONS(2241),
    [anon_sym_operator] = ACTIONS(2239),
    [anon_sym_precise] = ACTIONS(2239),
    [anon_sym_shared] = ACTIONS(2239),
    [anon_sym_groupshared] = ACTIONS(2239),
    [anon_sym_uniform] = ACTIONS(2239),
    [anon_sym_row_major] = ACTIONS(2239),
    [anon_sym_column_major] = ACTIONS(2239),
    [anon_sym_globallycoherent] = ACTIONS(2239),
    [anon_sym_centroid] = ACTIONS(2239),
    [anon_sym_noperspective] = ACTIONS(2239),
    [anon_sym_nointerpolation] = ACTIONS(2239),
    [anon_sym_sample] = ACTIONS(2239),
    [anon_sym_linear] = ACTIONS(2239),
    [anon_sym_snorm] = ACTIONS(2239),
    [anon_sym_unorm] = ACTIONS(2239),
    [anon_sym_point] = ACTIONS(2239),
    [anon_sym_line] = ACTIONS(2239),
    [anon_sym_triangleadj] = ACTIONS(2239),
    [anon_sym_lineadj] = ACTIONS(2239),
    [anon_sym_triangle] = ACTIONS(2239),
  },
  [2986] = {
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_COMMA] = ACTIONS(2282),
    [anon_sym_RPAREN] = ACTIONS(2282),
    [anon_sym_LPAREN2] = ACTIONS(2282),
    [anon_sym_TILDE] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(2282),
    [anon_sym_AMP_AMP] = ACTIONS(2282),
    [anon_sym_AMP] = ACTIONS(2280),
    [anon_sym_COLON] = ACTIONS(2280),
    [anon_sym___extension__] = ACTIONS(2280),
    [anon_sym_in] = ACTIONS(2280),
    [anon_sym_out] = ACTIONS(2280),
    [anon_sym_inout] = ACTIONS(2280),
    [anon_sym_virtual] = ACTIONS(2280),
    [anon_sym_extern] = ACTIONS(2280),
    [anon_sym___attribute__] = ACTIONS(2280),
    [anon_sym___attribute] = ACTIONS(2280),
    [anon_sym_COLON_COLON] = ACTIONS(2282),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2282),
    [anon_sym___declspec] = ACTIONS(2280),
    [anon_sym___based] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_LBRACK] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_EQ] = ACTIONS(2282),
    [anon_sym_register] = ACTIONS(2280),
    [anon_sym_inline] = ACTIONS(2280),
    [anon_sym___inline] = ACTIONS(2280),
    [anon_sym___inline__] = ACTIONS(2280),
    [anon_sym___forceinline] = ACTIONS(2280),
    [anon_sym_thread_local] = ACTIONS(2280),
    [anon_sym___thread] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_constexpr] = ACTIONS(2280),
    [anon_sym_volatile] = ACTIONS(2280),
    [anon_sym_restrict] = ACTIONS(2280),
    [anon_sym___restrict__] = ACTIONS(2280),
    [anon_sym__Atomic] = ACTIONS(2280),
    [anon_sym__Noreturn] = ACTIONS(2280),
    [anon_sym_noreturn] = ACTIONS(2280),
    [anon_sym__Nonnull] = ACTIONS(2280),
    [anon_sym_mutable] = ACTIONS(2280),
    [anon_sym_constinit] = ACTIONS(2280),
    [anon_sym_consteval] = ACTIONS(2280),
    [anon_sym_alignas] = ACTIONS(2280),
    [anon_sym__Alignas] = ACTIONS(2280),
    [anon_sym_DOT] = ACTIONS(2280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_This] = ACTIONS(2280),
    [anon_sym_decltype] = ACTIONS(2280),
    [anon_sym_final] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_template] = ACTIONS(2280),
    [anon_sym_GT2] = ACTIONS(2282),
    [anon_sym_operator] = ACTIONS(2280),
    [anon_sym_precise] = ACTIONS(2280),
    [anon_sym_shared] = ACTIONS(2280),
    [anon_sym_groupshared] = ACTIONS(2280),
    [anon_sym_uniform] = ACTIONS(2280),
    [anon_sym_row_major] = ACTIONS(2280),
    [anon_sym_column_major] = ACTIONS(2280),
    [anon_sym_globallycoherent] = ACTIONS(2280),
    [anon_sym_centroid] = ACTIONS(2280),
    [anon_sym_noperspective] = ACTIONS(2280),
    [anon_sym_nointerpolation] = ACTIONS(2280),
    [anon_sym_sample] = ACTIONS(2280),
    [anon_sym_linear] = ACTIONS(2280),
    [anon_sym_snorm] = ACTIONS(2280),
    [anon_sym_unorm] = ACTIONS(2280),
    [anon_sym_point] = ACTIONS(2280),
    [anon_sym_line] = ACTIONS(2280),
    [anon_sym_triangleadj] = ACTIONS(2280),
    [anon_sym_lineadj] = ACTIONS(2280),
    [anon_sym_triangle] = ACTIONS(2280),
  },
  [2987] = {
    [sym_string_literal] = STATE(2984),
    [sym_raw_string_literal] = STATE(2984),
    [aux_sym_concatenated_string_repeat1] = STATE(2984),
    [sym_identifier] = ACTIONS(7215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7217),
    [anon_sym_COMMA] = ACTIONS(7217),
    [anon_sym_RPAREN] = ACTIONS(7217),
    [aux_sym_preproc_if_token2] = ACTIONS(7217),
    [aux_sym_preproc_else_token1] = ACTIONS(7217),
    [aux_sym_preproc_elif_token1] = ACTIONS(7219),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7217),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7217),
    [anon_sym_LPAREN2] = ACTIONS(7217),
    [anon_sym_DASH] = ACTIONS(7219),
    [anon_sym_PLUS] = ACTIONS(7219),
    [anon_sym_STAR] = ACTIONS(7219),
    [anon_sym_SLASH] = ACTIONS(7219),
    [anon_sym_PERCENT] = ACTIONS(7219),
    [anon_sym_PIPE_PIPE] = ACTIONS(7217),
    [anon_sym_AMP_AMP] = ACTIONS(7217),
    [anon_sym_PIPE] = ACTIONS(7219),
    [anon_sym_CARET] = ACTIONS(7219),
    [anon_sym_AMP] = ACTIONS(7219),
    [anon_sym_EQ_EQ] = ACTIONS(7217),
    [anon_sym_BANG_EQ] = ACTIONS(7217),
    [anon_sym_GT] = ACTIONS(7219),
    [anon_sym_GT_EQ] = ACTIONS(7217),
    [anon_sym_LT_EQ] = ACTIONS(7219),
    [anon_sym_LT] = ACTIONS(7219),
    [anon_sym_LT_LT] = ACTIONS(7219),
    [anon_sym_GT_GT] = ACTIONS(7219),
    [anon_sym_COLON] = ACTIONS(7217),
    [anon_sym_SEMI] = ACTIONS(7217),
    [anon_sym_RBRACE] = ACTIONS(7217),
    [anon_sym_LBRACK] = ACTIONS(7217),
    [anon_sym_RBRACK] = ACTIONS(7217),
    [anon_sym_EQ] = ACTIONS(7219),
    [anon_sym_QMARK] = ACTIONS(7217),
    [anon_sym_STAR_EQ] = ACTIONS(7217),
    [anon_sym_SLASH_EQ] = ACTIONS(7217),
    [anon_sym_PERCENT_EQ] = ACTIONS(7217),
    [anon_sym_PLUS_EQ] = ACTIONS(7217),
    [anon_sym_DASH_EQ] = ACTIONS(7217),
    [anon_sym_LT_LT_EQ] = ACTIONS(7217),
    [anon_sym_GT_GT_EQ] = ACTIONS(7217),
    [anon_sym_AMP_EQ] = ACTIONS(7217),
    [anon_sym_CARET_EQ] = ACTIONS(7217),
    [anon_sym_PIPE_EQ] = ACTIONS(7217),
    [anon_sym_and_eq] = ACTIONS(7219),
    [anon_sym_or_eq] = ACTIONS(7219),
    [anon_sym_xor_eq] = ACTIONS(7219),
    [anon_sym_LT_EQ_GT] = ACTIONS(7217),
    [anon_sym_or] = ACTIONS(7219),
    [anon_sym_and] = ACTIONS(7219),
    [anon_sym_bitor] = ACTIONS(7219),
    [anon_sym_xor] = ACTIONS(7219),
    [anon_sym_bitand] = ACTIONS(7219),
    [anon_sym_not_eq] = ACTIONS(7219),
    [anon_sym_is] = ACTIONS(7219),
    [anon_sym_as] = ACTIONS(7219),
    [anon_sym_DASH_DASH] = ACTIONS(7217),
    [anon_sym_PLUS_PLUS] = ACTIONS(7217),
    [anon_sym_DOT] = ACTIONS(7219),
    [anon_sym_DOT_STAR] = ACTIONS(7217),
    [anon_sym_DASH_GT] = ACTIONS(7217),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [sym_literal_suffix] = ACTIONS(7219),
  },
  [2988] = {
    [sym_identifier] = ACTIONS(2284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2286),
    [anon_sym_COMMA] = ACTIONS(2286),
    [anon_sym_RPAREN] = ACTIONS(2286),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_COLON] = ACTIONS(2284),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_in] = ACTIONS(2284),
    [anon_sym_out] = ACTIONS(2284),
    [anon_sym_inout] = ACTIONS(2284),
    [anon_sym_virtual] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_EQ] = ACTIONS(2286),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [anon_sym_DOT] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_This] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [anon_sym_final] = ACTIONS(2284),
    [anon_sym_override] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_GT2] = ACTIONS(2286),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_precise] = ACTIONS(2284),
    [anon_sym_shared] = ACTIONS(2284),
    [anon_sym_groupshared] = ACTIONS(2284),
    [anon_sym_uniform] = ACTIONS(2284),
    [anon_sym_row_major] = ACTIONS(2284),
    [anon_sym_column_major] = ACTIONS(2284),
    [anon_sym_globallycoherent] = ACTIONS(2284),
    [anon_sym_centroid] = ACTIONS(2284),
    [anon_sym_noperspective] = ACTIONS(2284),
    [anon_sym_nointerpolation] = ACTIONS(2284),
    [anon_sym_sample] = ACTIONS(2284),
    [anon_sym_linear] = ACTIONS(2284),
    [anon_sym_snorm] = ACTIONS(2284),
    [anon_sym_unorm] = ACTIONS(2284),
    [anon_sym_point] = ACTIONS(2284),
    [anon_sym_line] = ACTIONS(2284),
    [anon_sym_triangleadj] = ACTIONS(2284),
    [anon_sym_lineadj] = ACTIONS(2284),
    [anon_sym_triangle] = ACTIONS(2284),
  },
  [2989] = {
    [sym_template_argument_list] = STATE(3064),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2764),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_LPAREN2] = ACTIONS(2193),
    [anon_sym_TILDE] = ACTIONS(2176),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2168),
    [anon_sym_LT] = ACTIONS(7064),
    [anon_sym_SEMI] = ACTIONS(6761),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2193),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym_signed] = ACTIONS(5332),
    [anon_sym_unsigned] = ACTIONS(5332),
    [anon_sym_long] = ACTIONS(5332),
    [anon_sym_short] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(7074),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [anon_sym_DOT] = ACTIONS(2176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_decltype] = ACTIONS(2168),
    [anon_sym_template] = ACTIONS(2168),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
  },
  [2990] = {
    [sym_identifier] = ACTIONS(2268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2270),
    [anon_sym_COMMA] = ACTIONS(2270),
    [anon_sym_RPAREN] = ACTIONS(2270),
    [anon_sym_LPAREN2] = ACTIONS(2270),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2270),
    [anon_sym_SLASH] = ACTIONS(2268),
    [anon_sym_PERCENT] = ACTIONS(2270),
    [anon_sym_PIPE_PIPE] = ACTIONS(2270),
    [anon_sym_AMP_AMP] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2268),
    [anon_sym_CARET] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(2268),
    [anon_sym_EQ_EQ] = ACTIONS(2270),
    [anon_sym_BANG_EQ] = ACTIONS(2270),
    [anon_sym_GT] = ACTIONS(2268),
    [anon_sym_GT_EQ] = ACTIONS(2270),
    [anon_sym_LT_EQ] = ACTIONS(2268),
    [anon_sym_LT] = ACTIONS(2268),
    [anon_sym_LT_LT] = ACTIONS(2270),
    [anon_sym_GT_GT] = ACTIONS(2270),
    [anon_sym_COLON] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym___extension__] = ACTIONS(2268),
    [anon_sym___attribute__] = ACTIONS(2268),
    [anon_sym___attribute] = ACTIONS(2268),
    [anon_sym_COLON_COLON] = ACTIONS(2270),
    [anon_sym___based] = ACTIONS(2268),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_RBRACE] = ACTIONS(2270),
    [anon_sym_signed] = ACTIONS(2268),
    [anon_sym_unsigned] = ACTIONS(2268),
    [anon_sym_long] = ACTIONS(2268),
    [anon_sym_short] = ACTIONS(2268),
    [anon_sym_LBRACK] = ACTIONS(2270),
    [anon_sym_RBRACK] = ACTIONS(2270),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_constexpr] = ACTIONS(2268),
    [anon_sym_volatile] = ACTIONS(2268),
    [anon_sym_restrict] = ACTIONS(2268),
    [anon_sym___restrict__] = ACTIONS(2268),
    [anon_sym__Atomic] = ACTIONS(2268),
    [anon_sym__Noreturn] = ACTIONS(2268),
    [anon_sym_noreturn] = ACTIONS(2268),
    [anon_sym__Nonnull] = ACTIONS(2268),
    [anon_sym_mutable] = ACTIONS(2268),
    [anon_sym_constinit] = ACTIONS(2268),
    [anon_sym_consteval] = ACTIONS(2268),
    [anon_sym_alignas] = ACTIONS(2268),
    [anon_sym__Alignas] = ACTIONS(2268),
    [sym_primitive_type] = ACTIONS(2268),
    [anon_sym_QMARK] = ACTIONS(2270),
    [anon_sym_LT_EQ_GT] = ACTIONS(2270),
    [anon_sym_or] = ACTIONS(2268),
    [anon_sym_and] = ACTIONS(2268),
    [anon_sym_bitor] = ACTIONS(2268),
    [anon_sym_xor] = ACTIONS(2268),
    [anon_sym_bitand] = ACTIONS(2268),
    [anon_sym_not_eq] = ACTIONS(2268),
    [anon_sym_is] = ACTIONS(2268),
    [anon_sym_as] = ACTIONS(2268),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_DOT] = ACTIONS(2268),
    [anon_sym_DOT_STAR] = ACTIONS(2270),
    [anon_sym_DASH_GT] = ACTIONS(2270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_This] = ACTIONS(2268),
    [anon_sym_final] = ACTIONS(2268),
    [anon_sym_override] = ACTIONS(2268),
    [anon_sym_requires] = ACTIONS(2268),
    [anon_sym_where] = ACTIONS(2268),
  },
  [2991] = {
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_COMMA] = ACTIONS(2262),
    [anon_sym_RPAREN] = ACTIONS(2262),
    [anon_sym_LPAREN2] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2262),
    [anon_sym_SLASH] = ACTIONS(2260),
    [anon_sym_PERCENT] = ACTIONS(2262),
    [anon_sym_PIPE_PIPE] = ACTIONS(2262),
    [anon_sym_AMP_AMP] = ACTIONS(2262),
    [anon_sym_PIPE] = ACTIONS(2260),
    [anon_sym_CARET] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_EQ_EQ] = ACTIONS(2262),
    [anon_sym_BANG_EQ] = ACTIONS(2262),
    [anon_sym_GT] = ACTIONS(2260),
    [anon_sym_GT_EQ] = ACTIONS(2262),
    [anon_sym_LT_EQ] = ACTIONS(2260),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_LT_LT] = ACTIONS(2262),
    [anon_sym_GT_GT] = ACTIONS(2262),
    [anon_sym_COLON] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym___extension__] = ACTIONS(2260),
    [anon_sym___attribute__] = ACTIONS(2260),
    [anon_sym___attribute] = ACTIONS(2260),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
    [anon_sym___based] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_RBRACE] = ACTIONS(2262),
    [anon_sym_signed] = ACTIONS(2260),
    [anon_sym_unsigned] = ACTIONS(2260),
    [anon_sym_long] = ACTIONS(2260),
    [anon_sym_short] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [anon_sym_RBRACK] = ACTIONS(2262),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_constexpr] = ACTIONS(2260),
    [anon_sym_volatile] = ACTIONS(2260),
    [anon_sym_restrict] = ACTIONS(2260),
    [anon_sym___restrict__] = ACTIONS(2260),
    [anon_sym__Atomic] = ACTIONS(2260),
    [anon_sym__Noreturn] = ACTIONS(2260),
    [anon_sym_noreturn] = ACTIONS(2260),
    [anon_sym__Nonnull] = ACTIONS(2260),
    [anon_sym_mutable] = ACTIONS(2260),
    [anon_sym_constinit] = ACTIONS(2260),
    [anon_sym_consteval] = ACTIONS(2260),
    [anon_sym_alignas] = ACTIONS(2260),
    [anon_sym__Alignas] = ACTIONS(2260),
    [sym_primitive_type] = ACTIONS(2260),
    [anon_sym_QMARK] = ACTIONS(2262),
    [anon_sym_LT_EQ_GT] = ACTIONS(2262),
    [anon_sym_or] = ACTIONS(2260),
    [anon_sym_and] = ACTIONS(2260),
    [anon_sym_bitor] = ACTIONS(2260),
    [anon_sym_xor] = ACTIONS(2260),
    [anon_sym_bitand] = ACTIONS(2260),
    [anon_sym_not_eq] = ACTIONS(2260),
    [anon_sym_is] = ACTIONS(2260),
    [anon_sym_as] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_DOT] = ACTIONS(2260),
    [anon_sym_DOT_STAR] = ACTIONS(2262),
    [anon_sym_DASH_GT] = ACTIONS(2262),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_This] = ACTIONS(2260),
    [anon_sym_final] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
    [anon_sym_requires] = ACTIONS(2260),
    [anon_sym_where] = ACTIONS(2260),
  },
  [2992] = {
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2290),
    [anon_sym_COMMA] = ACTIONS(2290),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_PERCENT] = ACTIONS(2290),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_CARET] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_EQ_EQ] = ACTIONS(2290),
    [anon_sym_BANG_EQ] = ACTIONS(2290),
    [anon_sym_GT] = ACTIONS(2288),
    [anon_sym_GT_EQ] = ACTIONS(2290),
    [anon_sym_LT_EQ] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(2290),
    [anon_sym_GT_GT] = ACTIONS(2290),
    [anon_sym_COLON] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_RBRACE] = ACTIONS(2290),
    [anon_sym_signed] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2290),
    [anon_sym_RBRACK] = ACTIONS(2290),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_QMARK] = ACTIONS(2290),
    [anon_sym_LT_EQ_GT] = ACTIONS(2290),
    [anon_sym_or] = ACTIONS(2288),
    [anon_sym_and] = ACTIONS(2288),
    [anon_sym_bitor] = ACTIONS(2288),
    [anon_sym_xor] = ACTIONS(2288),
    [anon_sym_bitand] = ACTIONS(2288),
    [anon_sym_not_eq] = ACTIONS(2288),
    [anon_sym_is] = ACTIONS(2288),
    [anon_sym_as] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_DOT] = ACTIONS(2288),
    [anon_sym_DOT_STAR] = ACTIONS(2290),
    [anon_sym_DASH_GT] = ACTIONS(2290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_This] = ACTIONS(2288),
    [anon_sym_final] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_requires] = ACTIONS(2288),
    [anon_sym_where] = ACTIONS(2288),
  },
  [2993] = {
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2294),
    [anon_sym_COMMA] = ACTIONS(2294),
    [anon_sym_RPAREN] = ACTIONS(2294),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_PERCENT] = ACTIONS(2294),
    [anon_sym_PIPE_PIPE] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_PIPE] = ACTIONS(2292),
    [anon_sym_CARET] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_EQ_EQ] = ACTIONS(2294),
    [anon_sym_BANG_EQ] = ACTIONS(2294),
    [anon_sym_GT] = ACTIONS(2292),
    [anon_sym_GT_EQ] = ACTIONS(2294),
    [anon_sym_LT_EQ] = ACTIONS(2292),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_LT_LT] = ACTIONS(2294),
    [anon_sym_GT_GT] = ACTIONS(2294),
    [anon_sym_COLON] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym___attribute] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym___based] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_signed] = ACTIONS(2292),
    [anon_sym_unsigned] = ACTIONS(2292),
    [anon_sym_long] = ACTIONS(2292),
    [anon_sym_short] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2294),
    [anon_sym_RBRACK] = ACTIONS(2294),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym__Nonnull] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [sym_primitive_type] = ACTIONS(2292),
    [anon_sym_QMARK] = ACTIONS(2294),
    [anon_sym_LT_EQ_GT] = ACTIONS(2294),
    [anon_sym_or] = ACTIONS(2292),
    [anon_sym_and] = ACTIONS(2292),
    [anon_sym_bitor] = ACTIONS(2292),
    [anon_sym_xor] = ACTIONS(2292),
    [anon_sym_bitand] = ACTIONS(2292),
    [anon_sym_not_eq] = ACTIONS(2292),
    [anon_sym_is] = ACTIONS(2292),
    [anon_sym_as] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_DOT] = ACTIONS(2292),
    [anon_sym_DOT_STAR] = ACTIONS(2294),
    [anon_sym_DASH_GT] = ACTIONS(2294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_This] = ACTIONS(2292),
    [anon_sym_final] = ACTIONS(2292),
    [anon_sym_override] = ACTIONS(2292),
    [anon_sym_requires] = ACTIONS(2292),
    [anon_sym_where] = ACTIONS(2292),
  },
  [2994] = {
    [sym_identifier] = ACTIONS(2296),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2298),
    [anon_sym_COMMA] = ACTIONS(2298),
    [anon_sym_RPAREN] = ACTIONS(2298),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2298),
    [anon_sym_SLASH] = ACTIONS(2296),
    [anon_sym_PERCENT] = ACTIONS(2298),
    [anon_sym_PIPE_PIPE] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_PIPE] = ACTIONS(2296),
    [anon_sym_CARET] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_EQ_EQ] = ACTIONS(2298),
    [anon_sym_BANG_EQ] = ACTIONS(2298),
    [anon_sym_GT] = ACTIONS(2296),
    [anon_sym_GT_EQ] = ACTIONS(2298),
    [anon_sym_LT_EQ] = ACTIONS(2296),
    [anon_sym_LT] = ACTIONS(2296),
    [anon_sym_LT_LT] = ACTIONS(2298),
    [anon_sym_GT_GT] = ACTIONS(2298),
    [anon_sym_COLON] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2298),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym___attribute] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym___based] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_RBRACE] = ACTIONS(2298),
    [anon_sym_signed] = ACTIONS(2296),
    [anon_sym_unsigned] = ACTIONS(2296),
    [anon_sym_long] = ACTIONS(2296),
    [anon_sym_short] = ACTIONS(2296),
    [anon_sym_LBRACK] = ACTIONS(2298),
    [anon_sym_RBRACK] = ACTIONS(2298),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym__Nonnull] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [sym_primitive_type] = ACTIONS(2296),
    [anon_sym_QMARK] = ACTIONS(2298),
    [anon_sym_LT_EQ_GT] = ACTIONS(2298),
    [anon_sym_or] = ACTIONS(2296),
    [anon_sym_and] = ACTIONS(2296),
    [anon_sym_bitor] = ACTIONS(2296),
    [anon_sym_xor] = ACTIONS(2296),
    [anon_sym_bitand] = ACTIONS(2296),
    [anon_sym_not_eq] = ACTIONS(2296),
    [anon_sym_is] = ACTIONS(2296),
    [anon_sym_as] = ACTIONS(2296),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_DOT] = ACTIONS(2296),
    [anon_sym_DOT_STAR] = ACTIONS(2298),
    [anon_sym_DASH_GT] = ACTIONS(2298),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_This] = ACTIONS(2296),
    [anon_sym_final] = ACTIONS(2296),
    [anon_sym_override] = ACTIONS(2296),
    [anon_sym_requires] = ACTIONS(2296),
    [anon_sym_where] = ACTIONS(2296),
  },
  [2995] = {
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2314),
    [anon_sym_COMMA] = ACTIONS(2314),
    [anon_sym_RPAREN] = ACTIONS(2314),
    [anon_sym_LPAREN2] = ACTIONS(2314),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_SLASH] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2314),
    [anon_sym_PIPE_PIPE] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2314),
    [anon_sym_PIPE] = ACTIONS(2312),
    [anon_sym_CARET] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_EQ_EQ] = ACTIONS(2314),
    [anon_sym_BANG_EQ] = ACTIONS(2314),
    [anon_sym_GT] = ACTIONS(2312),
    [anon_sym_GT_EQ] = ACTIONS(2314),
    [anon_sym_LT_EQ] = ACTIONS(2312),
    [anon_sym_LT] = ACTIONS(2312),
    [anon_sym_LT_LT] = ACTIONS(2314),
    [anon_sym_GT_GT] = ACTIONS(2314),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym___extension__] = ACTIONS(2312),
    [anon_sym___attribute__] = ACTIONS(2312),
    [anon_sym___attribute] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym___based] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_RBRACE] = ACTIONS(2314),
    [anon_sym_signed] = ACTIONS(2312),
    [anon_sym_unsigned] = ACTIONS(2312),
    [anon_sym_long] = ACTIONS(2312),
    [anon_sym_short] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2314),
    [anon_sym_RBRACK] = ACTIONS(2314),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_constexpr] = ACTIONS(2312),
    [anon_sym_volatile] = ACTIONS(2312),
    [anon_sym_restrict] = ACTIONS(2312),
    [anon_sym___restrict__] = ACTIONS(2312),
    [anon_sym__Atomic] = ACTIONS(2312),
    [anon_sym__Noreturn] = ACTIONS(2312),
    [anon_sym_noreturn] = ACTIONS(2312),
    [anon_sym__Nonnull] = ACTIONS(2312),
    [anon_sym_mutable] = ACTIONS(2312),
    [anon_sym_constinit] = ACTIONS(2312),
    [anon_sym_consteval] = ACTIONS(2312),
    [anon_sym_alignas] = ACTIONS(2312),
    [anon_sym__Alignas] = ACTIONS(2312),
    [sym_primitive_type] = ACTIONS(2312),
    [anon_sym_QMARK] = ACTIONS(2314),
    [anon_sym_LT_EQ_GT] = ACTIONS(2314),
    [anon_sym_or] = ACTIONS(2312),
    [anon_sym_and] = ACTIONS(2312),
    [anon_sym_bitor] = ACTIONS(2312),
    [anon_sym_xor] = ACTIONS(2312),
    [anon_sym_bitand] = ACTIONS(2312),
    [anon_sym_not_eq] = ACTIONS(2312),
    [anon_sym_is] = ACTIONS(2312),
    [anon_sym_as] = ACTIONS(2312),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_DOT] = ACTIONS(2312),
    [anon_sym_DOT_STAR] = ACTIONS(2314),
    [anon_sym_DASH_GT] = ACTIONS(2314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_This] = ACTIONS(2312),
    [anon_sym_final] = ACTIONS(2312),
    [anon_sym_override] = ACTIONS(2312),
    [anon_sym_requires] = ACTIONS(2312),
    [anon_sym_where] = ACTIONS(2312),
  },
  [2996] = {
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2266),
    [anon_sym_COMMA] = ACTIONS(2266),
    [anon_sym_RPAREN] = ACTIONS(2266),
    [anon_sym_LPAREN2] = ACTIONS(2266),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2266),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_PERCENT] = ACTIONS(2266),
    [anon_sym_PIPE_PIPE] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2266),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_CARET] = ACTIONS(2266),
    [anon_sym_AMP] = ACTIONS(2264),
    [anon_sym_EQ_EQ] = ACTIONS(2266),
    [anon_sym_BANG_EQ] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(2264),
    [anon_sym_GT_EQ] = ACTIONS(2266),
    [anon_sym_LT_EQ] = ACTIONS(2264),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_LT_LT] = ACTIONS(2266),
    [anon_sym_GT_GT] = ACTIONS(2266),
    [anon_sym_COLON] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2266),
    [anon_sym___extension__] = ACTIONS(2264),
    [anon_sym___attribute__] = ACTIONS(2264),
    [anon_sym___attribute] = ACTIONS(2264),
    [anon_sym_COLON_COLON] = ACTIONS(2266),
    [anon_sym___based] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_RBRACE] = ACTIONS(2266),
    [anon_sym_signed] = ACTIONS(2264),
    [anon_sym_unsigned] = ACTIONS(2264),
    [anon_sym_long] = ACTIONS(2264),
    [anon_sym_short] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_RBRACK] = ACTIONS(2266),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_constexpr] = ACTIONS(2264),
    [anon_sym_volatile] = ACTIONS(2264),
    [anon_sym_restrict] = ACTIONS(2264),
    [anon_sym___restrict__] = ACTIONS(2264),
    [anon_sym__Atomic] = ACTIONS(2264),
    [anon_sym__Noreturn] = ACTIONS(2264),
    [anon_sym_noreturn] = ACTIONS(2264),
    [anon_sym__Nonnull] = ACTIONS(2264),
    [anon_sym_mutable] = ACTIONS(2264),
    [anon_sym_constinit] = ACTIONS(2264),
    [anon_sym_consteval] = ACTIONS(2264),
    [anon_sym_alignas] = ACTIONS(2264),
    [anon_sym__Alignas] = ACTIONS(2264),
    [sym_primitive_type] = ACTIONS(2264),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_LT_EQ_GT] = ACTIONS(2266),
    [anon_sym_or] = ACTIONS(2264),
    [anon_sym_and] = ACTIONS(2264),
    [anon_sym_bitor] = ACTIONS(2264),
    [anon_sym_xor] = ACTIONS(2264),
    [anon_sym_bitand] = ACTIONS(2264),
    [anon_sym_not_eq] = ACTIONS(2264),
    [anon_sym_is] = ACTIONS(2264),
    [anon_sym_as] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2266),
    [anon_sym_PLUS_PLUS] = ACTIONS(2266),
    [anon_sym_DOT] = ACTIONS(2264),
    [anon_sym_DOT_STAR] = ACTIONS(2266),
    [anon_sym_DASH_GT] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_This] = ACTIONS(2264),
    [anon_sym_final] = ACTIONS(2264),
    [anon_sym_override] = ACTIONS(2264),
    [anon_sym_requires] = ACTIONS(2264),
    [anon_sym_where] = ACTIONS(2264),
  },
  [2997] = {
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2881),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_SLASH] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_CARET] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_EQ_EQ] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_GT_EQ] = ACTIONS(2881),
    [anon_sym_LT_EQ] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_LT_LT] = ACTIONS(2881),
    [anon_sym_GT_GT] = ACTIONS(2881),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_RBRACE] = ACTIONS(2881),
    [anon_sym_signed] = ACTIONS(2883),
    [anon_sym_unsigned] = ACTIONS(2883),
    [anon_sym_long] = ACTIONS(2883),
    [anon_sym_short] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2881),
    [anon_sym_RBRACK] = ACTIONS(2881),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [sym_primitive_type] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_LT_EQ_GT] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2883),
    [anon_sym_and] = ACTIONS(2883),
    [anon_sym_bitor] = ACTIONS(2883),
    [anon_sym_xor] = ACTIONS(2883),
    [anon_sym_bitand] = ACTIONS(2883),
    [anon_sym_not_eq] = ACTIONS(2883),
    [anon_sym_is] = ACTIONS(2883),
    [anon_sym_as] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_DOT_STAR] = ACTIONS(2881),
    [anon_sym_DASH_GT] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_final] = ACTIONS(2883),
    [anon_sym_override] = ACTIONS(2883),
    [anon_sym_requires] = ACTIONS(2883),
    [anon_sym_where] = ACTIONS(2883),
  },
  [2998] = {
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2274),
    [anon_sym_COMMA] = ACTIONS(2274),
    [anon_sym_RPAREN] = ACTIONS(2274),
    [anon_sym_LPAREN2] = ACTIONS(2274),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2274),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_PERCENT] = ACTIONS(2274),
    [anon_sym_PIPE_PIPE] = ACTIONS(2274),
    [anon_sym_AMP_AMP] = ACTIONS(2274),
    [anon_sym_PIPE] = ACTIONS(2272),
    [anon_sym_CARET] = ACTIONS(2274),
    [anon_sym_AMP] = ACTIONS(2272),
    [anon_sym_EQ_EQ] = ACTIONS(2274),
    [anon_sym_BANG_EQ] = ACTIONS(2274),
    [anon_sym_GT] = ACTIONS(2272),
    [anon_sym_GT_EQ] = ACTIONS(2274),
    [anon_sym_LT_EQ] = ACTIONS(2272),
    [anon_sym_LT] = ACTIONS(2272),
    [anon_sym_LT_LT] = ACTIONS(2274),
    [anon_sym_GT_GT] = ACTIONS(2274),
    [anon_sym_COLON] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym___extension__] = ACTIONS(2272),
    [anon_sym___attribute__] = ACTIONS(2272),
    [anon_sym___attribute] = ACTIONS(2272),
    [anon_sym_COLON_COLON] = ACTIONS(2274),
    [anon_sym___based] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_RBRACE] = ACTIONS(2274),
    [anon_sym_signed] = ACTIONS(2272),
    [anon_sym_unsigned] = ACTIONS(2272),
    [anon_sym_long] = ACTIONS(2272),
    [anon_sym_short] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2274),
    [anon_sym_RBRACK] = ACTIONS(2274),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_constexpr] = ACTIONS(2272),
    [anon_sym_volatile] = ACTIONS(2272),
    [anon_sym_restrict] = ACTIONS(2272),
    [anon_sym___restrict__] = ACTIONS(2272),
    [anon_sym__Atomic] = ACTIONS(2272),
    [anon_sym__Noreturn] = ACTIONS(2272),
    [anon_sym_noreturn] = ACTIONS(2272),
    [anon_sym__Nonnull] = ACTIONS(2272),
    [anon_sym_mutable] = ACTIONS(2272),
    [anon_sym_constinit] = ACTIONS(2272),
    [anon_sym_consteval] = ACTIONS(2272),
    [anon_sym_alignas] = ACTIONS(2272),
    [anon_sym__Alignas] = ACTIONS(2272),
    [sym_primitive_type] = ACTIONS(2272),
    [anon_sym_QMARK] = ACTIONS(2274),
    [anon_sym_LT_EQ_GT] = ACTIONS(2274),
    [anon_sym_or] = ACTIONS(2272),
    [anon_sym_and] = ACTIONS(2272),
    [anon_sym_bitor] = ACTIONS(2272),
    [anon_sym_xor] = ACTIONS(2272),
    [anon_sym_bitand] = ACTIONS(2272),
    [anon_sym_not_eq] = ACTIONS(2272),
    [anon_sym_is] = ACTIONS(2272),
    [anon_sym_as] = ACTIONS(2272),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_DOT] = ACTIONS(2272),
    [anon_sym_DOT_STAR] = ACTIONS(2274),
    [anon_sym_DASH_GT] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_This] = ACTIONS(2272),
    [anon_sym_final] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_requires] = ACTIONS(2272),
    [anon_sym_where] = ACTIONS(2272),
  },
  [2999] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2245),
    [anon_sym_COMMA] = ACTIONS(2245),
    [anon_sym_RPAREN] = ACTIONS(2247),
    [anon_sym_LPAREN2] = ACTIONS(2247),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_SLASH] = ACTIONS(2255),
    [anon_sym_PERCENT] = ACTIONS(2255),
    [anon_sym_PIPE_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2255),
    [anon_sym_CARET] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2245),
    [anon_sym_BANG_EQ] = ACTIONS(2245),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_GT_EQ] = ACTIONS(2245),
    [anon_sym_LT_EQ] = ACTIONS(2255),
    [anon_sym_LT] = ACTIONS(2255),
    [anon_sym_LT_LT] = ACTIONS(2255),
    [anon_sym_GT_GT] = ACTIONS(2255),
    [anon_sym_SEMI] = ACTIONS(2245),
    [anon_sym___extension__] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2245),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2255),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2250),
    [anon_sym_volatile] = ACTIONS(2250),
    [anon_sym_restrict] = ACTIONS(2250),
    [anon_sym___restrict__] = ACTIONS(2250),
    [anon_sym__Atomic] = ACTIONS(2250),
    [anon_sym__Noreturn] = ACTIONS(2250),
    [anon_sym_noreturn] = ACTIONS(2250),
    [anon_sym__Nonnull] = ACTIONS(2250),
    [anon_sym_mutable] = ACTIONS(2250),
    [anon_sym_constinit] = ACTIONS(2250),
    [anon_sym_consteval] = ACTIONS(2250),
    [anon_sym_alignas] = ACTIONS(2250),
    [anon_sym__Alignas] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2245),
    [anon_sym_STAR_EQ] = ACTIONS(2245),
    [anon_sym_SLASH_EQ] = ACTIONS(2245),
    [anon_sym_PERCENT_EQ] = ACTIONS(2245),
    [anon_sym_PLUS_EQ] = ACTIONS(2245),
    [anon_sym_DASH_EQ] = ACTIONS(2245),
    [anon_sym_LT_LT_EQ] = ACTIONS(2245),
    [anon_sym_GT_GT_EQ] = ACTIONS(2245),
    [anon_sym_AMP_EQ] = ACTIONS(2245),
    [anon_sym_CARET_EQ] = ACTIONS(2245),
    [anon_sym_PIPE_EQ] = ACTIONS(2245),
    [anon_sym_and_eq] = ACTIONS(2245),
    [anon_sym_or_eq] = ACTIONS(2245),
    [anon_sym_xor_eq] = ACTIONS(2245),
    [anon_sym_LT_EQ_GT] = ACTIONS(2245),
    [anon_sym_or] = ACTIONS(2255),
    [anon_sym_and] = ACTIONS(2255),
    [anon_sym_bitor] = ACTIONS(2245),
    [anon_sym_xor] = ACTIONS(2255),
    [anon_sym_bitand] = ACTIONS(2245),
    [anon_sym_not_eq] = ACTIONS(2245),
    [anon_sym_is] = ACTIONS(2245),
    [anon_sym_as] = ACTIONS(2245),
    [anon_sym_DASH_DASH] = ACTIONS(2245),
    [anon_sym_PLUS_PLUS] = ACTIONS(2245),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2245),
    [anon_sym_DASH_GT] = ACTIONS(2255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_This] = ACTIONS(2250),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2245),
  },
  [3000] = {
    [sym_identifier] = ACTIONS(2276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2278),
    [anon_sym_COMMA] = ACTIONS(2278),
    [anon_sym_RPAREN] = ACTIONS(2278),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_PLUS] = ACTIONS(2276),
    [anon_sym_STAR] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2276),
    [anon_sym_PERCENT] = ACTIONS(2278),
    [anon_sym_PIPE_PIPE] = ACTIONS(2278),
    [anon_sym_AMP_AMP] = ACTIONS(2278),
    [anon_sym_PIPE] = ACTIONS(2276),
    [anon_sym_CARET] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_EQ_EQ] = ACTIONS(2278),
    [anon_sym_BANG_EQ] = ACTIONS(2278),
    [anon_sym_GT] = ACTIONS(2276),
    [anon_sym_GT_EQ] = ACTIONS(2278),
    [anon_sym_LT_EQ] = ACTIONS(2276),
    [anon_sym_LT] = ACTIONS(2276),
    [anon_sym_LT_LT] = ACTIONS(2278),
    [anon_sym_GT_GT] = ACTIONS(2278),
    [anon_sym_COLON] = ACTIONS(2276),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym___extension__] = ACTIONS(2276),
    [anon_sym___attribute__] = ACTIONS(2276),
    [anon_sym___attribute] = ACTIONS(2276),
    [anon_sym_COLON_COLON] = ACTIONS(2278),
    [anon_sym___based] = ACTIONS(2276),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_signed] = ACTIONS(2276),
    [anon_sym_unsigned] = ACTIONS(2276),
    [anon_sym_long] = ACTIONS(2276),
    [anon_sym_short] = ACTIONS(2276),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_RBRACK] = ACTIONS(2278),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_constexpr] = ACTIONS(2276),
    [anon_sym_volatile] = ACTIONS(2276),
    [anon_sym_restrict] = ACTIONS(2276),
    [anon_sym___restrict__] = ACTIONS(2276),
    [anon_sym__Atomic] = ACTIONS(2276),
    [anon_sym__Noreturn] = ACTIONS(2276),
    [anon_sym_noreturn] = ACTIONS(2276),
    [anon_sym__Nonnull] = ACTIONS(2276),
    [anon_sym_mutable] = ACTIONS(2276),
    [anon_sym_constinit] = ACTIONS(2276),
    [anon_sym_consteval] = ACTIONS(2276),
    [anon_sym_alignas] = ACTIONS(2276),
    [anon_sym__Alignas] = ACTIONS(2276),
    [sym_primitive_type] = ACTIONS(2276),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LT_EQ_GT] = ACTIONS(2278),
    [anon_sym_or] = ACTIONS(2276),
    [anon_sym_and] = ACTIONS(2276),
    [anon_sym_bitor] = ACTIONS(2276),
    [anon_sym_xor] = ACTIONS(2276),
    [anon_sym_bitand] = ACTIONS(2276),
    [anon_sym_not_eq] = ACTIONS(2276),
    [anon_sym_is] = ACTIONS(2276),
    [anon_sym_as] = ACTIONS(2276),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DOT] = ACTIONS(2276),
    [anon_sym_DOT_STAR] = ACTIONS(2278),
    [anon_sym_DASH_GT] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_This] = ACTIONS(2276),
    [anon_sym_final] = ACTIONS(2276),
    [anon_sym_override] = ACTIONS(2276),
    [anon_sym_requires] = ACTIONS(2276),
    [anon_sym_where] = ACTIONS(2276),
  },
  [3001] = {
    [sym_template_argument_list] = STATE(2999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2224),
    [anon_sym_COMMA] = ACTIONS(2224),
    [anon_sym_RPAREN] = ACTIONS(2226),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2231),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_PIPE_PIPE] = ACTIONS(2224),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_EQ_EQ] = ACTIONS(2224),
    [anon_sym_BANG_EQ] = ACTIONS(2224),
    [anon_sym_GT] = ACTIONS(2234),
    [anon_sym_GT_EQ] = ACTIONS(2224),
    [anon_sym_LT_EQ] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(5546),
    [anon_sym_LT_LT] = ACTIONS(2234),
    [anon_sym_GT_GT] = ACTIONS(2234),
    [anon_sym___extension__] = ACTIONS(2229),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2224),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2231),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2229),
    [anon_sym_volatile] = ACTIONS(2229),
    [anon_sym_restrict] = ACTIONS(2229),
    [anon_sym___restrict__] = ACTIONS(2229),
    [anon_sym__Atomic] = ACTIONS(2229),
    [anon_sym__Noreturn] = ACTIONS(2229),
    [anon_sym_noreturn] = ACTIONS(2229),
    [anon_sym__Nonnull] = ACTIONS(2229),
    [anon_sym_mutable] = ACTIONS(2229),
    [anon_sym_constinit] = ACTIONS(2229),
    [anon_sym_consteval] = ACTIONS(2229),
    [anon_sym_alignas] = ACTIONS(2229),
    [anon_sym__Alignas] = ACTIONS(2229),
    [anon_sym_QMARK] = ACTIONS(2224),
    [anon_sym_STAR_EQ] = ACTIONS(2224),
    [anon_sym_SLASH_EQ] = ACTIONS(2224),
    [anon_sym_PERCENT_EQ] = ACTIONS(2224),
    [anon_sym_PLUS_EQ] = ACTIONS(2224),
    [anon_sym_DASH_EQ] = ACTIONS(2224),
    [anon_sym_LT_LT_EQ] = ACTIONS(2224),
    [anon_sym_GT_GT_EQ] = ACTIONS(2224),
    [anon_sym_AMP_EQ] = ACTIONS(2224),
    [anon_sym_CARET_EQ] = ACTIONS(2224),
    [anon_sym_PIPE_EQ] = ACTIONS(2224),
    [anon_sym_and_eq] = ACTIONS(2224),
    [anon_sym_or_eq] = ACTIONS(2224),
    [anon_sym_xor_eq] = ACTIONS(2224),
    [anon_sym_LT_EQ_GT] = ACTIONS(2224),
    [anon_sym_or] = ACTIONS(2234),
    [anon_sym_and] = ACTIONS(2234),
    [anon_sym_bitor] = ACTIONS(2224),
    [anon_sym_xor] = ACTIONS(2234),
    [anon_sym_bitand] = ACTIONS(2224),
    [anon_sym_not_eq] = ACTIONS(2224),
    [anon_sym_is] = ACTIONS(2224),
    [anon_sym_as] = ACTIONS(2224),
    [anon_sym_DASH_DASH] = ACTIONS(2224),
    [anon_sym_PLUS_PLUS] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(2231),
    [anon_sym_DOT_STAR] = ACTIONS(2224),
    [anon_sym_DASH_GT] = ACTIONS(2234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2229),
    [anon_sym_let] = ACTIONS(2229),
    [anon_sym_This] = ACTIONS(2229),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2224),
  },
  [3002] = {
    [sym_identifier] = ACTIONS(2239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2241),
    [anon_sym_COMMA] = ACTIONS(2241),
    [anon_sym_RPAREN] = ACTIONS(2241),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2239),
    [anon_sym_PLUS] = ACTIONS(2239),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_SLASH] = ACTIONS(2239),
    [anon_sym_PERCENT] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_PIPE] = ACTIONS(2239),
    [anon_sym_CARET] = ACTIONS(2241),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_LT_EQ] = ACTIONS(2239),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_LT_LT] = ACTIONS(2241),
    [anon_sym_GT_GT] = ACTIONS(2241),
    [anon_sym_COLON] = ACTIONS(2239),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym___attribute] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym___based] = ACTIONS(2239),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_RBRACE] = ACTIONS(2241),
    [anon_sym_signed] = ACTIONS(2239),
    [anon_sym_unsigned] = ACTIONS(2239),
    [anon_sym_long] = ACTIONS(2239),
    [anon_sym_short] = ACTIONS(2239),
    [anon_sym_LBRACK] = ACTIONS(2241),
    [anon_sym_RBRACK] = ACTIONS(2241),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym__Nonnull] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [sym_primitive_type] = ACTIONS(2239),
    [anon_sym_QMARK] = ACTIONS(2241),
    [anon_sym_LT_EQ_GT] = ACTIONS(2241),
    [anon_sym_or] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(2239),
    [anon_sym_bitor] = ACTIONS(2239),
    [anon_sym_xor] = ACTIONS(2239),
    [anon_sym_bitand] = ACTIONS(2239),
    [anon_sym_not_eq] = ACTIONS(2239),
    [anon_sym_is] = ACTIONS(2239),
    [anon_sym_as] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2239),
    [anon_sym_DOT_STAR] = ACTIONS(2241),
    [anon_sym_DASH_GT] = ACTIONS(2241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2239),
    [anon_sym_let] = ACTIONS(2239),
    [anon_sym_This] = ACTIONS(2239),
    [anon_sym_final] = ACTIONS(2239),
    [anon_sym_override] = ACTIONS(2239),
    [anon_sym_requires] = ACTIONS(2239),
    [anon_sym_where] = ACTIONS(2239),
  },
  [3003] = {
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_RPAREN] = ACTIONS(2420),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_SLASH] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2420),
    [anon_sym_PIPE_PIPE] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_PIPE] = ACTIONS(2422),
    [anon_sym_CARET] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_EQ_EQ] = ACTIONS(2420),
    [anon_sym_BANG_EQ] = ACTIONS(2420),
    [anon_sym_GT] = ACTIONS(2422),
    [anon_sym_GT_EQ] = ACTIONS(2420),
    [anon_sym_LT_EQ] = ACTIONS(2422),
    [anon_sym_LT] = ACTIONS(2422),
    [anon_sym_LT_LT] = ACTIONS(2420),
    [anon_sym_GT_GT] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym___based] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2422),
    [anon_sym_unsigned] = ACTIONS(2422),
    [anon_sym_long] = ACTIONS(2422),
    [anon_sym_short] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [anon_sym_RBRACK] = ACTIONS(2420),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [sym_primitive_type] = ACTIONS(2422),
    [anon_sym_QMARK] = ACTIONS(2420),
    [anon_sym_LT_EQ_GT] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2422),
    [anon_sym_and] = ACTIONS(2422),
    [anon_sym_bitor] = ACTIONS(2422),
    [anon_sym_xor] = ACTIONS(2422),
    [anon_sym_bitand] = ACTIONS(2422),
    [anon_sym_not_eq] = ACTIONS(2422),
    [anon_sym_is] = ACTIONS(2422),
    [anon_sym_as] = ACTIONS(2422),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_DOT] = ACTIONS(2422),
    [anon_sym_DOT_STAR] = ACTIONS(2420),
    [anon_sym_DASH_GT] = ACTIONS(2420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_requires] = ACTIONS(2422),
    [anon_sym_where] = ACTIONS(2422),
  },
  [3004] = {
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_RPAREN] = ACTIONS(2420),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_SLASH] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2420),
    [anon_sym_PIPE_PIPE] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_PIPE] = ACTIONS(2422),
    [anon_sym_CARET] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_EQ_EQ] = ACTIONS(2420),
    [anon_sym_BANG_EQ] = ACTIONS(2420),
    [anon_sym_GT] = ACTIONS(2422),
    [anon_sym_GT_EQ] = ACTIONS(2420),
    [anon_sym_LT_EQ] = ACTIONS(2422),
    [anon_sym_LT] = ACTIONS(2422),
    [anon_sym_LT_LT] = ACTIONS(2420),
    [anon_sym_GT_GT] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2422),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym___based] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2422),
    [anon_sym_unsigned] = ACTIONS(2422),
    [anon_sym_long] = ACTIONS(2422),
    [anon_sym_short] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [anon_sym_RBRACK] = ACTIONS(2420),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_constexpr] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_restrict] = ACTIONS(2422),
    [anon_sym___restrict__] = ACTIONS(2422),
    [anon_sym__Atomic] = ACTIONS(2422),
    [anon_sym__Noreturn] = ACTIONS(2422),
    [anon_sym_noreturn] = ACTIONS(2422),
    [anon_sym__Nonnull] = ACTIONS(2422),
    [anon_sym_mutable] = ACTIONS(2422),
    [anon_sym_constinit] = ACTIONS(2422),
    [anon_sym_consteval] = ACTIONS(2422),
    [anon_sym_alignas] = ACTIONS(2422),
    [anon_sym__Alignas] = ACTIONS(2422),
    [sym_primitive_type] = ACTIONS(2422),
    [anon_sym_QMARK] = ACTIONS(2420),
    [anon_sym_LT_EQ_GT] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2422),
    [anon_sym_and] = ACTIONS(2422),
    [anon_sym_bitor] = ACTIONS(2422),
    [anon_sym_xor] = ACTIONS(2422),
    [anon_sym_bitand] = ACTIONS(2422),
    [anon_sym_not_eq] = ACTIONS(2422),
    [anon_sym_is] = ACTIONS(2422),
    [anon_sym_as] = ACTIONS(2422),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_DOT] = ACTIONS(2422),
    [anon_sym_DOT_STAR] = ACTIONS(2420),
    [anon_sym_DASH_GT] = ACTIONS(2420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_requires] = ACTIONS(2422),
    [anon_sym_where] = ACTIONS(2422),
  },
  [3005] = {
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_COMMA] = ACTIONS(2282),
    [anon_sym_RPAREN] = ACTIONS(2282),
    [anon_sym_LPAREN2] = ACTIONS(2282),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2282),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_PERCENT] = ACTIONS(2282),
    [anon_sym_PIPE_PIPE] = ACTIONS(2282),
    [anon_sym_AMP_AMP] = ACTIONS(2282),
    [anon_sym_PIPE] = ACTIONS(2280),
    [anon_sym_CARET] = ACTIONS(2282),
    [anon_sym_AMP] = ACTIONS(2280),
    [anon_sym_EQ_EQ] = ACTIONS(2282),
    [anon_sym_BANG_EQ] = ACTIONS(2282),
    [anon_sym_GT] = ACTIONS(2280),
    [anon_sym_GT_EQ] = ACTIONS(2282),
    [anon_sym_LT_EQ] = ACTIONS(2280),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_LT_LT] = ACTIONS(2282),
    [anon_sym_GT_GT] = ACTIONS(2282),
    [anon_sym_COLON] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(2280),
    [anon_sym___attribute__] = ACTIONS(2280),
    [anon_sym___attribute] = ACTIONS(2280),
    [anon_sym_COLON_COLON] = ACTIONS(2282),
    [anon_sym___based] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_RBRACE] = ACTIONS(2282),
    [anon_sym_signed] = ACTIONS(2280),
    [anon_sym_unsigned] = ACTIONS(2280),
    [anon_sym_long] = ACTIONS(2280),
    [anon_sym_short] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_RBRACK] = ACTIONS(2282),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_constexpr] = ACTIONS(2280),
    [anon_sym_volatile] = ACTIONS(2280),
    [anon_sym_restrict] = ACTIONS(2280),
    [anon_sym___restrict__] = ACTIONS(2280),
    [anon_sym__Atomic] = ACTIONS(2280),
    [anon_sym__Noreturn] = ACTIONS(2280),
    [anon_sym_noreturn] = ACTIONS(2280),
    [anon_sym__Nonnull] = ACTIONS(2280),
    [anon_sym_mutable] = ACTIONS(2280),
    [anon_sym_constinit] = ACTIONS(2280),
    [anon_sym_consteval] = ACTIONS(2280),
    [anon_sym_alignas] = ACTIONS(2280),
    [anon_sym__Alignas] = ACTIONS(2280),
    [sym_primitive_type] = ACTIONS(2280),
    [anon_sym_QMARK] = ACTIONS(2282),
    [anon_sym_LT_EQ_GT] = ACTIONS(2282),
    [anon_sym_or] = ACTIONS(2280),
    [anon_sym_and] = ACTIONS(2280),
    [anon_sym_bitor] = ACTIONS(2280),
    [anon_sym_xor] = ACTIONS(2280),
    [anon_sym_bitand] = ACTIONS(2280),
    [anon_sym_not_eq] = ACTIONS(2280),
    [anon_sym_is] = ACTIONS(2280),
    [anon_sym_as] = ACTIONS(2280),
    [anon_sym_DASH_DASH] = ACTIONS(2282),
    [anon_sym_PLUS_PLUS] = ACTIONS(2282),
    [anon_sym_DOT] = ACTIONS(2280),
    [anon_sym_DOT_STAR] = ACTIONS(2282),
    [anon_sym_DASH_GT] = ACTIONS(2282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_This] = ACTIONS(2280),
    [anon_sym_final] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_requires] = ACTIONS(2280),
    [anon_sym_where] = ACTIONS(2280),
  },
  [3006] = {
    [sym_identifier] = ACTIONS(2284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2286),
    [anon_sym_COMMA] = ACTIONS(2286),
    [anon_sym_RPAREN] = ACTIONS(2286),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_SLASH] = ACTIONS(2284),
    [anon_sym_PERCENT] = ACTIONS(2286),
    [anon_sym_PIPE_PIPE] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2284),
    [anon_sym_CARET] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_EQ_EQ] = ACTIONS(2286),
    [anon_sym_BANG_EQ] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2284),
    [anon_sym_GT_EQ] = ACTIONS(2286),
    [anon_sym_LT_EQ] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2284),
    [anon_sym_LT_LT] = ACTIONS(2286),
    [anon_sym_GT_GT] = ACTIONS(2286),
    [anon_sym_COLON] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_signed] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_RBRACK] = ACTIONS(2286),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_QMARK] = ACTIONS(2286),
    [anon_sym_LT_EQ_GT] = ACTIONS(2286),
    [anon_sym_or] = ACTIONS(2284),
    [anon_sym_and] = ACTIONS(2284),
    [anon_sym_bitor] = ACTIONS(2284),
    [anon_sym_xor] = ACTIONS(2284),
    [anon_sym_bitand] = ACTIONS(2284),
    [anon_sym_not_eq] = ACTIONS(2284),
    [anon_sym_is] = ACTIONS(2284),
    [anon_sym_as] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_DOT] = ACTIONS(2284),
    [anon_sym_DOT_STAR] = ACTIONS(2286),
    [anon_sym_DASH_GT] = ACTIONS(2286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_This] = ACTIONS(2284),
    [anon_sym_final] = ACTIONS(2284),
    [anon_sym_override] = ACTIONS(2284),
    [anon_sym_requires] = ACTIONS(2284),
    [anon_sym_where] = ACTIONS(2284),
  },
  [3007] = {
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2310),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_RPAREN] = ACTIONS(2310),
    [anon_sym_LPAREN2] = ACTIONS(2310),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_SLASH] = ACTIONS(2308),
    [anon_sym_PERCENT] = ACTIONS(2310),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_CARET] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2310),
    [anon_sym_BANG_EQ] = ACTIONS(2310),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_EQ] = ACTIONS(2310),
    [anon_sym_LT_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_LT_LT] = ACTIONS(2310),
    [anon_sym_GT_GT] = ACTIONS(2310),
    [anon_sym_COLON] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(2308),
    [anon_sym___attribute__] = ACTIONS(2308),
    [anon_sym___attribute] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym___based] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_RBRACE] = ACTIONS(2310),
    [anon_sym_signed] = ACTIONS(2308),
    [anon_sym_unsigned] = ACTIONS(2308),
    [anon_sym_long] = ACTIONS(2308),
    [anon_sym_short] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2310),
    [anon_sym_RBRACK] = ACTIONS(2310),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_constexpr] = ACTIONS(2308),
    [anon_sym_volatile] = ACTIONS(2308),
    [anon_sym_restrict] = ACTIONS(2308),
    [anon_sym___restrict__] = ACTIONS(2308),
    [anon_sym__Atomic] = ACTIONS(2308),
    [anon_sym__Noreturn] = ACTIONS(2308),
    [anon_sym_noreturn] = ACTIONS(2308),
    [anon_sym__Nonnull] = ACTIONS(2308),
    [anon_sym_mutable] = ACTIONS(2308),
    [anon_sym_constinit] = ACTIONS(2308),
    [anon_sym_consteval] = ACTIONS(2308),
    [anon_sym_alignas] = ACTIONS(2308),
    [anon_sym__Alignas] = ACTIONS(2308),
    [sym_primitive_type] = ACTIONS(2308),
    [anon_sym_QMARK] = ACTIONS(2310),
    [anon_sym_LT_EQ_GT] = ACTIONS(2310),
    [anon_sym_or] = ACTIONS(2308),
    [anon_sym_and] = ACTIONS(2308),
    [anon_sym_bitor] = ACTIONS(2308),
    [anon_sym_xor] = ACTIONS(2308),
    [anon_sym_bitand] = ACTIONS(2308),
    [anon_sym_not_eq] = ACTIONS(2308),
    [anon_sym_is] = ACTIONS(2308),
    [anon_sym_as] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_DOT] = ACTIONS(2308),
    [anon_sym_DOT_STAR] = ACTIONS(2310),
    [anon_sym_DASH_GT] = ACTIONS(2310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_This] = ACTIONS(2308),
    [anon_sym_final] = ACTIONS(2308),
    [anon_sym_override] = ACTIONS(2308),
    [anon_sym_requires] = ACTIONS(2308),
    [anon_sym_where] = ACTIONS(2308),
  },
  [3008] = {
    [sym_identifier] = ACTIONS(2428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2426),
    [anon_sym_COMMA] = ACTIONS(2426),
    [anon_sym_RPAREN] = ACTIONS(2426),
    [anon_sym_LPAREN2] = ACTIONS(2426),
    [anon_sym_DASH] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2428),
    [anon_sym_STAR] = ACTIONS(2426),
    [anon_sym_SLASH] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2426),
    [anon_sym_PIPE_PIPE] = ACTIONS(2426),
    [anon_sym_AMP_AMP] = ACTIONS(2426),
    [anon_sym_PIPE] = ACTIONS(2428),
    [anon_sym_CARET] = ACTIONS(2426),
    [anon_sym_AMP] = ACTIONS(2428),
    [anon_sym_EQ_EQ] = ACTIONS(2426),
    [anon_sym_BANG_EQ] = ACTIONS(2426),
    [anon_sym_GT] = ACTIONS(2428),
    [anon_sym_GT_EQ] = ACTIONS(2426),
    [anon_sym_LT_EQ] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(2428),
    [anon_sym_LT_LT] = ACTIONS(2426),
    [anon_sym_GT_GT] = ACTIONS(2426),
    [anon_sym_COLON] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2426),
    [anon_sym___extension__] = ACTIONS(2428),
    [anon_sym___attribute__] = ACTIONS(2428),
    [anon_sym___attribute] = ACTIONS(2428),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym___based] = ACTIONS(2428),
    [anon_sym_LBRACE] = ACTIONS(2426),
    [anon_sym_RBRACE] = ACTIONS(2426),
    [anon_sym_signed] = ACTIONS(2428),
    [anon_sym_unsigned] = ACTIONS(2428),
    [anon_sym_long] = ACTIONS(2428),
    [anon_sym_short] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(2426),
    [anon_sym_RBRACK] = ACTIONS(2426),
    [anon_sym_const] = ACTIONS(2428),
    [anon_sym_constexpr] = ACTIONS(2428),
    [anon_sym_volatile] = ACTIONS(2428),
    [anon_sym_restrict] = ACTIONS(2428),
    [anon_sym___restrict__] = ACTIONS(2428),
    [anon_sym__Atomic] = ACTIONS(2428),
    [anon_sym__Noreturn] = ACTIONS(2428),
    [anon_sym_noreturn] = ACTIONS(2428),
    [anon_sym__Nonnull] = ACTIONS(2428),
    [anon_sym_mutable] = ACTIONS(2428),
    [anon_sym_constinit] = ACTIONS(2428),
    [anon_sym_consteval] = ACTIONS(2428),
    [anon_sym_alignas] = ACTIONS(2428),
    [anon_sym__Alignas] = ACTIONS(2428),
    [sym_primitive_type] = ACTIONS(2428),
    [anon_sym_QMARK] = ACTIONS(2426),
    [anon_sym_LT_EQ_GT] = ACTIONS(2426),
    [anon_sym_or] = ACTIONS(2428),
    [anon_sym_and] = ACTIONS(2428),
    [anon_sym_bitor] = ACTIONS(2428),
    [anon_sym_xor] = ACTIONS(2428),
    [anon_sym_bitand] = ACTIONS(2428),
    [anon_sym_not_eq] = ACTIONS(2428),
    [anon_sym_is] = ACTIONS(2428),
    [anon_sym_as] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2426),
    [anon_sym_PLUS_PLUS] = ACTIONS(2426),
    [anon_sym_DOT] = ACTIONS(2428),
    [anon_sym_DOT_STAR] = ACTIONS(2426),
    [anon_sym_DASH_GT] = ACTIONS(2426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2428),
    [anon_sym_let] = ACTIONS(2428),
    [anon_sym_This] = ACTIONS(2428),
    [anon_sym_final] = ACTIONS(2428),
    [anon_sym_override] = ACTIONS(2428),
    [anon_sym_requires] = ACTIONS(2428),
    [anon_sym_where] = ACTIONS(2428),
  },
  [3009] = {
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_COMMA] = ACTIONS(2306),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_PERCENT] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE] = ACTIONS(2304),
    [anon_sym_CARET] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_GT] = ACTIONS(2304),
    [anon_sym_GT_EQ] = ACTIONS(2306),
    [anon_sym_LT_EQ] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_LT_LT] = ACTIONS(2306),
    [anon_sym_GT_GT] = ACTIONS(2306),
    [anon_sym_COLON] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2306),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym___attribute] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym___based] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_signed] = ACTIONS(2304),
    [anon_sym_unsigned] = ACTIONS(2304),
    [anon_sym_long] = ACTIONS(2304),
    [anon_sym_short] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2306),
    [anon_sym_RBRACK] = ACTIONS(2306),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym__Nonnull] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [sym_primitive_type] = ACTIONS(2304),
    [anon_sym_QMARK] = ACTIONS(2306),
    [anon_sym_LT_EQ_GT] = ACTIONS(2306),
    [anon_sym_or] = ACTIONS(2304),
    [anon_sym_and] = ACTIONS(2304),
    [anon_sym_bitor] = ACTIONS(2304),
    [anon_sym_xor] = ACTIONS(2304),
    [anon_sym_bitand] = ACTIONS(2304),
    [anon_sym_not_eq] = ACTIONS(2304),
    [anon_sym_is] = ACTIONS(2304),
    [anon_sym_as] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DOT] = ACTIONS(2304),
    [anon_sym_DOT_STAR] = ACTIONS(2306),
    [anon_sym_DASH_GT] = ACTIONS(2306),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_This] = ACTIONS(2304),
    [anon_sym_final] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_requires] = ACTIONS(2304),
    [anon_sym_where] = ACTIONS(2304),
  },
  [3010] = {
    [sym__declaration_modifiers] = STATE(3010),
    [sym_attribute_specifier] = STATE(3010),
    [sym_attribute_declaration] = STATE(3010),
    [sym_ms_declspec_modifier] = STATE(3010),
    [sym_storage_class_specifier] = STATE(3010),
    [sym_type_qualifier] = STATE(3010),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_explicit_function_specifier] = STATE(3010),
    [sym__constructor_specifiers] = STATE(3010),
    [sym_qualifiers] = STATE(3010),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3010),
    [sym_identifier] = ACTIONS(7221),
    [anon_sym_LPAREN2] = ACTIONS(7223),
    [anon_sym_TILDE] = ACTIONS(7223),
    [anon_sym_STAR] = ACTIONS(7223),
    [anon_sym_AMP_AMP] = ACTIONS(7223),
    [anon_sym_AMP] = ACTIONS(7221),
    [anon_sym___extension__] = ACTIONS(7225),
    [anon_sym_in] = ACTIONS(7228),
    [anon_sym_out] = ACTIONS(7228),
    [anon_sym_inout] = ACTIONS(7228),
    [anon_sym_virtual] = ACTIONS(7228),
    [anon_sym_extern] = ACTIONS(7231),
    [anon_sym___attribute__] = ACTIONS(7234),
    [anon_sym___attribute] = ACTIONS(7234),
    [anon_sym_COLON_COLON] = ACTIONS(7223),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7237),
    [anon_sym___declspec] = ACTIONS(7240),
    [anon_sym___based] = ACTIONS(7221),
    [anon_sym_LBRACK] = ACTIONS(7221),
    [anon_sym_static] = ACTIONS(7231),
    [anon_sym_register] = ACTIONS(7231),
    [anon_sym_inline] = ACTIONS(7231),
    [anon_sym___inline] = ACTIONS(7231),
    [anon_sym___inline__] = ACTIONS(7231),
    [anon_sym___forceinline] = ACTIONS(7231),
    [anon_sym_thread_local] = ACTIONS(7231),
    [anon_sym___thread] = ACTIONS(7231),
    [anon_sym_const] = ACTIONS(7225),
    [anon_sym_constexpr] = ACTIONS(7225),
    [anon_sym_volatile] = ACTIONS(7225),
    [anon_sym_restrict] = ACTIONS(7225),
    [anon_sym___restrict__] = ACTIONS(7225),
    [anon_sym__Atomic] = ACTIONS(7225),
    [anon_sym__Noreturn] = ACTIONS(7225),
    [anon_sym_noreturn] = ACTIONS(7225),
    [anon_sym__Nonnull] = ACTIONS(7225),
    [anon_sym_mutable] = ACTIONS(7225),
    [anon_sym_constinit] = ACTIONS(7225),
    [anon_sym_consteval] = ACTIONS(7225),
    [anon_sym_alignas] = ACTIONS(7243),
    [anon_sym__Alignas] = ACTIONS(7243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(7221),
    [anon_sym_explicit] = ACTIONS(7246),
    [anon_sym_template] = ACTIONS(7221),
    [anon_sym_operator] = ACTIONS(7221),
    [anon_sym_precise] = ACTIONS(7249),
    [anon_sym_shared] = ACTIONS(7249),
    [anon_sym_groupshared] = ACTIONS(7249),
    [anon_sym_uniform] = ACTIONS(7249),
    [anon_sym_row_major] = ACTIONS(7249),
    [anon_sym_column_major] = ACTIONS(7249),
    [anon_sym_globallycoherent] = ACTIONS(7249),
    [anon_sym_centroid] = ACTIONS(7249),
    [anon_sym_noperspective] = ACTIONS(7249),
    [anon_sym_nointerpolation] = ACTIONS(7249),
    [anon_sym_sample] = ACTIONS(7249),
    [anon_sym_linear] = ACTIONS(7249),
    [anon_sym_snorm] = ACTIONS(7249),
    [anon_sym_unorm] = ACTIONS(7249),
    [anon_sym_point] = ACTIONS(7249),
    [anon_sym_line] = ACTIONS(7249),
    [anon_sym_triangleadj] = ACTIONS(7249),
    [anon_sym_lineadj] = ACTIONS(7249),
    [anon_sym_triangle] = ACTIONS(7249),
  },
  [3011] = {
    [sym_identifier] = ACTIONS(2879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2877),
    [anon_sym_COMMA] = ACTIONS(2877),
    [anon_sym_RPAREN] = ACTIONS(2877),
    [anon_sym_LPAREN2] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2879),
    [anon_sym_PLUS] = ACTIONS(2879),
    [anon_sym_STAR] = ACTIONS(2877),
    [anon_sym_SLASH] = ACTIONS(2879),
    [anon_sym_PERCENT] = ACTIONS(2877),
    [anon_sym_PIPE_PIPE] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_PIPE] = ACTIONS(2879),
    [anon_sym_CARET] = ACTIONS(2877),
    [anon_sym_AMP] = ACTIONS(2879),
    [anon_sym_EQ_EQ] = ACTIONS(2877),
    [anon_sym_BANG_EQ] = ACTIONS(2877),
    [anon_sym_GT] = ACTIONS(2879),
    [anon_sym_GT_EQ] = ACTIONS(2877),
    [anon_sym_LT_EQ] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2879),
    [anon_sym_LT_LT] = ACTIONS(2877),
    [anon_sym_GT_GT] = ACTIONS(2877),
    [anon_sym_COLON] = ACTIONS(2879),
    [anon_sym_SEMI] = ACTIONS(2877),
    [anon_sym___extension__] = ACTIONS(2879),
    [anon_sym___attribute__] = ACTIONS(2879),
    [anon_sym___attribute] = ACTIONS(2879),
    [anon_sym_COLON_COLON] = ACTIONS(2877),
    [anon_sym___based] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_RBRACE] = ACTIONS(2877),
    [anon_sym_signed] = ACTIONS(2879),
    [anon_sym_unsigned] = ACTIONS(2879),
    [anon_sym_long] = ACTIONS(2879),
    [anon_sym_short] = ACTIONS(2879),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_RBRACK] = ACTIONS(2877),
    [anon_sym_const] = ACTIONS(2879),
    [anon_sym_constexpr] = ACTIONS(2879),
    [anon_sym_volatile] = ACTIONS(2879),
    [anon_sym_restrict] = ACTIONS(2879),
    [anon_sym___restrict__] = ACTIONS(2879),
    [anon_sym__Atomic] = ACTIONS(2879),
    [anon_sym__Noreturn] = ACTIONS(2879),
    [anon_sym_noreturn] = ACTIONS(2879),
    [anon_sym__Nonnull] = ACTIONS(2879),
    [anon_sym_mutable] = ACTIONS(2879),
    [anon_sym_constinit] = ACTIONS(2879),
    [anon_sym_consteval] = ACTIONS(2879),
    [anon_sym_alignas] = ACTIONS(2879),
    [anon_sym__Alignas] = ACTIONS(2879),
    [sym_primitive_type] = ACTIONS(2879),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_LT_EQ_GT] = ACTIONS(2877),
    [anon_sym_or] = ACTIONS(2879),
    [anon_sym_and] = ACTIONS(2879),
    [anon_sym_bitor] = ACTIONS(2879),
    [anon_sym_xor] = ACTIONS(2879),
    [anon_sym_bitand] = ACTIONS(2879),
    [anon_sym_not_eq] = ACTIONS(2879),
    [anon_sym_is] = ACTIONS(2879),
    [anon_sym_as] = ACTIONS(2879),
    [anon_sym_DASH_DASH] = ACTIONS(2877),
    [anon_sym_PLUS_PLUS] = ACTIONS(2877),
    [anon_sym_DOT] = ACTIONS(2879),
    [anon_sym_DOT_STAR] = ACTIONS(2877),
    [anon_sym_DASH_GT] = ACTIONS(2877),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2879),
    [anon_sym_let] = ACTIONS(2879),
    [anon_sym_This] = ACTIONS(2879),
    [anon_sym_final] = ACTIONS(2879),
    [anon_sym_override] = ACTIONS(2879),
    [anon_sym_requires] = ACTIONS(2879),
    [anon_sym_where] = ACTIONS(2879),
  },
  [3012] = {
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2302),
    [anon_sym_COMMA] = ACTIONS(2302),
    [anon_sym_RPAREN] = ACTIONS(2302),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2302),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2302),
    [anon_sym_PIPE_PIPE] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_PIPE] = ACTIONS(2300),
    [anon_sym_CARET] = ACTIONS(2302),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_EQ_EQ] = ACTIONS(2302),
    [anon_sym_BANG_EQ] = ACTIONS(2302),
    [anon_sym_GT] = ACTIONS(2300),
    [anon_sym_GT_EQ] = ACTIONS(2302),
    [anon_sym_LT_EQ] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_LT_LT] = ACTIONS(2302),
    [anon_sym_GT_GT] = ACTIONS(2302),
    [anon_sym_COLON] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym___attribute] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym___based] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_RBRACE] = ACTIONS(2302),
    [anon_sym_signed] = ACTIONS(2300),
    [anon_sym_unsigned] = ACTIONS(2300),
    [anon_sym_long] = ACTIONS(2300),
    [anon_sym_short] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2302),
    [anon_sym_RBRACK] = ACTIONS(2302),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym__Nonnull] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [sym_primitive_type] = ACTIONS(2300),
    [anon_sym_QMARK] = ACTIONS(2302),
    [anon_sym_LT_EQ_GT] = ACTIONS(2302),
    [anon_sym_or] = ACTIONS(2300),
    [anon_sym_and] = ACTIONS(2300),
    [anon_sym_bitor] = ACTIONS(2300),
    [anon_sym_xor] = ACTIONS(2300),
    [anon_sym_bitand] = ACTIONS(2300),
    [anon_sym_not_eq] = ACTIONS(2300),
    [anon_sym_is] = ACTIONS(2300),
    [anon_sym_as] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_DOT] = ACTIONS(2300),
    [anon_sym_DOT_STAR] = ACTIONS(2302),
    [anon_sym_DASH_GT] = ACTIONS(2302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_This] = ACTIONS(2300),
    [anon_sym_final] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_requires] = ACTIONS(2300),
    [anon_sym_where] = ACTIONS(2300),
  },
  [3013] = {
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2416),
    [anon_sym_COMMA] = ACTIONS(2416),
    [anon_sym_RPAREN] = ACTIONS(2416),
    [anon_sym_LPAREN2] = ACTIONS(2416),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2416),
    [anon_sym_SLASH] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2416),
    [anon_sym_PIPE_PIPE] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_PIPE] = ACTIONS(2418),
    [anon_sym_CARET] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_EQ_EQ] = ACTIONS(2416),
    [anon_sym_BANG_EQ] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(2418),
    [anon_sym_GT_EQ] = ACTIONS(2416),
    [anon_sym_LT_EQ] = ACTIONS(2418),
    [anon_sym_LT] = ACTIONS(2418),
    [anon_sym_LT_LT] = ACTIONS(2416),
    [anon_sym_GT_GT] = ACTIONS(2416),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym___extension__] = ACTIONS(2418),
    [anon_sym___attribute__] = ACTIONS(2418),
    [anon_sym___attribute] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2416),
    [anon_sym___based] = ACTIONS(2418),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_RBRACE] = ACTIONS(2416),
    [anon_sym_signed] = ACTIONS(2418),
    [anon_sym_unsigned] = ACTIONS(2418),
    [anon_sym_long] = ACTIONS(2418),
    [anon_sym_short] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2416),
    [anon_sym_RBRACK] = ACTIONS(2416),
    [anon_sym_const] = ACTIONS(2418),
    [anon_sym_constexpr] = ACTIONS(2418),
    [anon_sym_volatile] = ACTIONS(2418),
    [anon_sym_restrict] = ACTIONS(2418),
    [anon_sym___restrict__] = ACTIONS(2418),
    [anon_sym__Atomic] = ACTIONS(2418),
    [anon_sym__Noreturn] = ACTIONS(2418),
    [anon_sym_noreturn] = ACTIONS(2418),
    [anon_sym__Nonnull] = ACTIONS(2418),
    [anon_sym_mutable] = ACTIONS(2418),
    [anon_sym_constinit] = ACTIONS(2418),
    [anon_sym_consteval] = ACTIONS(2418),
    [anon_sym_alignas] = ACTIONS(2418),
    [anon_sym__Alignas] = ACTIONS(2418),
    [sym_primitive_type] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2416),
    [anon_sym_LT_EQ_GT] = ACTIONS(2416),
    [anon_sym_or] = ACTIONS(2418),
    [anon_sym_and] = ACTIONS(2418),
    [anon_sym_bitor] = ACTIONS(2418),
    [anon_sym_xor] = ACTIONS(2418),
    [anon_sym_bitand] = ACTIONS(2418),
    [anon_sym_not_eq] = ACTIONS(2418),
    [anon_sym_is] = ACTIONS(2418),
    [anon_sym_as] = ACTIONS(2418),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_DOT] = ACTIONS(2418),
    [anon_sym_DOT_STAR] = ACTIONS(2416),
    [anon_sym_DASH_GT] = ACTIONS(2416),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_This] = ACTIONS(2418),
    [anon_sym_final] = ACTIONS(2418),
    [anon_sym_override] = ACTIONS(2418),
    [anon_sym_requires] = ACTIONS(2418),
    [anon_sym_where] = ACTIONS(2418),
  },
  [3014] = {
    [sym_identifier] = ACTIONS(2926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2924),
    [anon_sym_COMMA] = ACTIONS(2924),
    [anon_sym_RPAREN] = ACTIONS(2924),
    [anon_sym_LPAREN2] = ACTIONS(2924),
    [anon_sym_DASH] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2926),
    [anon_sym_STAR] = ACTIONS(2924),
    [anon_sym_SLASH] = ACTIONS(2926),
    [anon_sym_PERCENT] = ACTIONS(2924),
    [anon_sym_PIPE_PIPE] = ACTIONS(2924),
    [anon_sym_AMP_AMP] = ACTIONS(2924),
    [anon_sym_PIPE] = ACTIONS(2926),
    [anon_sym_CARET] = ACTIONS(2924),
    [anon_sym_AMP] = ACTIONS(2926),
    [anon_sym_EQ_EQ] = ACTIONS(2924),
    [anon_sym_BANG_EQ] = ACTIONS(2924),
    [anon_sym_GT] = ACTIONS(2926),
    [anon_sym_GT_EQ] = ACTIONS(2924),
    [anon_sym_LT_EQ] = ACTIONS(2926),
    [anon_sym_LT] = ACTIONS(2926),
    [anon_sym_LT_LT] = ACTIONS(2924),
    [anon_sym_GT_GT] = ACTIONS(2924),
    [anon_sym_COLON] = ACTIONS(2924),
    [anon_sym_SEMI] = ACTIONS(2924),
    [anon_sym___extension__] = ACTIONS(2926),
    [anon_sym___attribute__] = ACTIONS(2926),
    [anon_sym___attribute] = ACTIONS(2926),
    [anon_sym___based] = ACTIONS(2926),
    [anon_sym_LBRACE] = ACTIONS(2924),
    [anon_sym_RBRACE] = ACTIONS(2924),
    [anon_sym_signed] = ACTIONS(2926),
    [anon_sym_unsigned] = ACTIONS(2926),
    [anon_sym_long] = ACTIONS(2926),
    [anon_sym_short] = ACTIONS(2926),
    [anon_sym_LBRACK] = ACTIONS(2924),
    [anon_sym_RBRACK] = ACTIONS(2924),
    [anon_sym_const] = ACTIONS(2926),
    [anon_sym_constexpr] = ACTIONS(2926),
    [anon_sym_volatile] = ACTIONS(2926),
    [anon_sym_restrict] = ACTIONS(2926),
    [anon_sym___restrict__] = ACTIONS(2926),
    [anon_sym__Atomic] = ACTIONS(2926),
    [anon_sym__Noreturn] = ACTIONS(2926),
    [anon_sym_noreturn] = ACTIONS(2926),
    [anon_sym__Nonnull] = ACTIONS(2926),
    [anon_sym_mutable] = ACTIONS(2926),
    [anon_sym_constinit] = ACTIONS(2926),
    [anon_sym_consteval] = ACTIONS(2926),
    [anon_sym_alignas] = ACTIONS(2926),
    [anon_sym__Alignas] = ACTIONS(2926),
    [sym_primitive_type] = ACTIONS(2926),
    [anon_sym_QMARK] = ACTIONS(2924),
    [anon_sym_LT_EQ_GT] = ACTIONS(2924),
    [anon_sym_or] = ACTIONS(2926),
    [anon_sym_and] = ACTIONS(2926),
    [anon_sym_bitor] = ACTIONS(2926),
    [anon_sym_xor] = ACTIONS(2926),
    [anon_sym_bitand] = ACTIONS(2926),
    [anon_sym_not_eq] = ACTIONS(2926),
    [anon_sym_is] = ACTIONS(2926),
    [anon_sym_as] = ACTIONS(2926),
    [anon_sym_DASH_DASH] = ACTIONS(2924),
    [anon_sym_PLUS_PLUS] = ACTIONS(2924),
    [anon_sym_DOT] = ACTIONS(2926),
    [anon_sym_DOT_STAR] = ACTIONS(2924),
    [anon_sym_DASH_GT] = ACTIONS(2924),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2926),
    [anon_sym_let] = ACTIONS(2926),
    [anon_sym_This] = ACTIONS(2926),
    [anon_sym_final] = ACTIONS(2926),
    [anon_sym_override] = ACTIONS(2926),
    [anon_sym_requires] = ACTIONS(2926),
    [anon_sym_where] = ACTIONS(2926),
  },
  [3015] = {
    [sym_attribute_specifier] = STATE(3217),
    [sym_field_declaration_list] = STATE(3143),
    [sym_virtual_specifier] = STATE(9530),
    [sym_base_class_clause] = STATE(10458),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2895),
    [anon_sym_RPAREN] = ACTIONS(2895),
    [aux_sym_preproc_if_token2] = ACTIONS(2895),
    [aux_sym_preproc_else_token1] = ACTIONS(2895),
    [aux_sym_preproc_elif_token1] = ACTIONS(2893),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2895),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_PERCENT] = ACTIONS(2893),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_PIPE] = ACTIONS(2893),
    [anon_sym_CARET] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_EQ_EQ] = ACTIONS(2895),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_GT] = ACTIONS(2893),
    [anon_sym_GT_EQ] = ACTIONS(2895),
    [anon_sym_LT_EQ] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_LT_LT] = ACTIONS(2893),
    [anon_sym_GT_GT] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(7252),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym___attribute__] = ACTIONS(7254),
    [anon_sym___attribute] = ACTIONS(7254),
    [anon_sym_LBRACE] = ACTIONS(7256),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_RBRACK] = ACTIONS(2895),
    [anon_sym_EQ] = ACTIONS(2893),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_STAR_EQ] = ACTIONS(2895),
    [anon_sym_SLASH_EQ] = ACTIONS(2895),
    [anon_sym_PERCENT_EQ] = ACTIONS(2895),
    [anon_sym_PLUS_EQ] = ACTIONS(2895),
    [anon_sym_DASH_EQ] = ACTIONS(2895),
    [anon_sym_LT_LT_EQ] = ACTIONS(2895),
    [anon_sym_GT_GT_EQ] = ACTIONS(2895),
    [anon_sym_AMP_EQ] = ACTIONS(2895),
    [anon_sym_CARET_EQ] = ACTIONS(2895),
    [anon_sym_PIPE_EQ] = ACTIONS(2895),
    [anon_sym_and_eq] = ACTIONS(2893),
    [anon_sym_or_eq] = ACTIONS(2893),
    [anon_sym_xor_eq] = ACTIONS(2893),
    [anon_sym_LT_EQ_GT] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2893),
    [anon_sym_and] = ACTIONS(2893),
    [anon_sym_bitor] = ACTIONS(2893),
    [anon_sym_xor] = ACTIONS(2893),
    [anon_sym_bitand] = ACTIONS(2893),
    [anon_sym_not_eq] = ACTIONS(2893),
    [anon_sym_is] = ACTIONS(2893),
    [anon_sym_as] = ACTIONS(2893),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2893),
    [anon_sym_DOT_STAR] = ACTIONS(2895),
    [anon_sym_DASH_GT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_This] = ACTIONS(2893),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
  },
  [3016] = {
    [sym_identifier] = ACTIONS(2948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2946),
    [anon_sym_COMMA] = ACTIONS(2946),
    [anon_sym_RPAREN] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2948),
    [anon_sym_PLUS] = ACTIONS(2948),
    [anon_sym_STAR] = ACTIONS(2946),
    [anon_sym_SLASH] = ACTIONS(2948),
    [anon_sym_PERCENT] = ACTIONS(2946),
    [anon_sym_PIPE_PIPE] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_PIPE] = ACTIONS(2948),
    [anon_sym_CARET] = ACTIONS(2946),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_EQ_EQ] = ACTIONS(2946),
    [anon_sym_BANG_EQ] = ACTIONS(2946),
    [anon_sym_GT] = ACTIONS(2948),
    [anon_sym_GT_EQ] = ACTIONS(2946),
    [anon_sym_LT_EQ] = ACTIONS(2948),
    [anon_sym_LT] = ACTIONS(2948),
    [anon_sym_LT_LT] = ACTIONS(2946),
    [anon_sym_GT_GT] = ACTIONS(2946),
    [anon_sym_COLON] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym___extension__] = ACTIONS(2948),
    [anon_sym___attribute__] = ACTIONS(2948),
    [anon_sym___attribute] = ACTIONS(2948),
    [anon_sym___based] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_RBRACE] = ACTIONS(2946),
    [anon_sym_signed] = ACTIONS(2948),
    [anon_sym_unsigned] = ACTIONS(2948),
    [anon_sym_long] = ACTIONS(2948),
    [anon_sym_short] = ACTIONS(2948),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_RBRACK] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2948),
    [anon_sym_constexpr] = ACTIONS(2948),
    [anon_sym_volatile] = ACTIONS(2948),
    [anon_sym_restrict] = ACTIONS(2948),
    [anon_sym___restrict__] = ACTIONS(2948),
    [anon_sym__Atomic] = ACTIONS(2948),
    [anon_sym__Noreturn] = ACTIONS(2948),
    [anon_sym_noreturn] = ACTIONS(2948),
    [anon_sym__Nonnull] = ACTIONS(2948),
    [anon_sym_mutable] = ACTIONS(2948),
    [anon_sym_constinit] = ACTIONS(2948),
    [anon_sym_consteval] = ACTIONS(2948),
    [anon_sym_alignas] = ACTIONS(2948),
    [anon_sym__Alignas] = ACTIONS(2948),
    [sym_primitive_type] = ACTIONS(2948),
    [anon_sym_QMARK] = ACTIONS(2946),
    [anon_sym_LT_EQ_GT] = ACTIONS(2946),
    [anon_sym_or] = ACTIONS(2948),
    [anon_sym_and] = ACTIONS(2948),
    [anon_sym_bitor] = ACTIONS(2948),
    [anon_sym_xor] = ACTIONS(2948),
    [anon_sym_bitand] = ACTIONS(2948),
    [anon_sym_not_eq] = ACTIONS(2948),
    [anon_sym_is] = ACTIONS(2948),
    [anon_sym_as] = ACTIONS(2948),
    [anon_sym_DASH_DASH] = ACTIONS(2946),
    [anon_sym_PLUS_PLUS] = ACTIONS(2946),
    [anon_sym_DOT] = ACTIONS(2948),
    [anon_sym_DOT_STAR] = ACTIONS(2946),
    [anon_sym_DASH_GT] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2948),
    [anon_sym_let] = ACTIONS(2948),
    [anon_sym_This] = ACTIONS(2948),
    [anon_sym_final] = ACTIONS(2948),
    [anon_sym_override] = ACTIONS(2948),
    [anon_sym_requires] = ACTIONS(2948),
    [anon_sym_where] = ACTIONS(2948),
  },
  [3017] = {
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2972),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_RPAREN] = ACTIONS(2972),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_SLASH] = ACTIONS(2974),
    [anon_sym_PERCENT] = ACTIONS(2972),
    [anon_sym_PIPE_PIPE] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_PIPE] = ACTIONS(2974),
    [anon_sym_CARET] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_EQ_EQ] = ACTIONS(2972),
    [anon_sym_BANG_EQ] = ACTIONS(2972),
    [anon_sym_GT] = ACTIONS(2974),
    [anon_sym_GT_EQ] = ACTIONS(2972),
    [anon_sym_LT_EQ] = ACTIONS(2974),
    [anon_sym_LT] = ACTIONS(2974),
    [anon_sym_LT_LT] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(2972),
    [anon_sym_COLON] = ACTIONS(2972),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym___extension__] = ACTIONS(2974),
    [anon_sym___attribute__] = ACTIONS(2974),
    [anon_sym___attribute] = ACTIONS(2974),
    [anon_sym___based] = ACTIONS(2974),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_signed] = ACTIONS(2974),
    [anon_sym_unsigned] = ACTIONS(2974),
    [anon_sym_long] = ACTIONS(2974),
    [anon_sym_short] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_RBRACK] = ACTIONS(2972),
    [anon_sym_const] = ACTIONS(2974),
    [anon_sym_constexpr] = ACTIONS(2974),
    [anon_sym_volatile] = ACTIONS(2974),
    [anon_sym_restrict] = ACTIONS(2974),
    [anon_sym___restrict__] = ACTIONS(2974),
    [anon_sym__Atomic] = ACTIONS(2974),
    [anon_sym__Noreturn] = ACTIONS(2974),
    [anon_sym_noreturn] = ACTIONS(2974),
    [anon_sym__Nonnull] = ACTIONS(2974),
    [anon_sym_mutable] = ACTIONS(2974),
    [anon_sym_constinit] = ACTIONS(2974),
    [anon_sym_consteval] = ACTIONS(2974),
    [anon_sym_alignas] = ACTIONS(2974),
    [anon_sym__Alignas] = ACTIONS(2974),
    [sym_primitive_type] = ACTIONS(2974),
    [anon_sym_QMARK] = ACTIONS(2972),
    [anon_sym_LT_EQ_GT] = ACTIONS(2972),
    [anon_sym_or] = ACTIONS(2974),
    [anon_sym_and] = ACTIONS(2974),
    [anon_sym_bitor] = ACTIONS(2974),
    [anon_sym_xor] = ACTIONS(2974),
    [anon_sym_bitand] = ACTIONS(2974),
    [anon_sym_not_eq] = ACTIONS(2974),
    [anon_sym_is] = ACTIONS(2974),
    [anon_sym_as] = ACTIONS(2974),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_DOT] = ACTIONS(2974),
    [anon_sym_DOT_STAR] = ACTIONS(2972),
    [anon_sym_DASH_GT] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_This] = ACTIONS(2974),
    [anon_sym_final] = ACTIONS(2974),
    [anon_sym_override] = ACTIONS(2974),
    [anon_sym_requires] = ACTIONS(2974),
    [anon_sym_where] = ACTIONS(2974),
  },
  [3018] = {
    [sym_identifier] = ACTIONS(2952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2950),
    [anon_sym_COMMA] = ACTIONS(2950),
    [anon_sym_RPAREN] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2952),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_STAR] = ACTIONS(2950),
    [anon_sym_SLASH] = ACTIONS(2952),
    [anon_sym_PERCENT] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_PIPE] = ACTIONS(2952),
    [anon_sym_CARET] = ACTIONS(2950),
    [anon_sym_AMP] = ACTIONS(2952),
    [anon_sym_EQ_EQ] = ACTIONS(2950),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_GT] = ACTIONS(2952),
    [anon_sym_GT_EQ] = ACTIONS(2950),
    [anon_sym_LT_EQ] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_LT_LT] = ACTIONS(2950),
    [anon_sym_GT_GT] = ACTIONS(2950),
    [anon_sym_COLON] = ACTIONS(2950),
    [anon_sym_SEMI] = ACTIONS(2950),
    [anon_sym___extension__] = ACTIONS(2952),
    [anon_sym___attribute__] = ACTIONS(2952),
    [anon_sym___attribute] = ACTIONS(2952),
    [anon_sym___based] = ACTIONS(2952),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_RBRACE] = ACTIONS(2950),
    [anon_sym_signed] = ACTIONS(2952),
    [anon_sym_unsigned] = ACTIONS(2952),
    [anon_sym_long] = ACTIONS(2952),
    [anon_sym_short] = ACTIONS(2952),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_RBRACK] = ACTIONS(2950),
    [anon_sym_const] = ACTIONS(2952),
    [anon_sym_constexpr] = ACTIONS(2952),
    [anon_sym_volatile] = ACTIONS(2952),
    [anon_sym_restrict] = ACTIONS(2952),
    [anon_sym___restrict__] = ACTIONS(2952),
    [anon_sym__Atomic] = ACTIONS(2952),
    [anon_sym__Noreturn] = ACTIONS(2952),
    [anon_sym_noreturn] = ACTIONS(2952),
    [anon_sym__Nonnull] = ACTIONS(2952),
    [anon_sym_mutable] = ACTIONS(2952),
    [anon_sym_constinit] = ACTIONS(2952),
    [anon_sym_consteval] = ACTIONS(2952),
    [anon_sym_alignas] = ACTIONS(2952),
    [anon_sym__Alignas] = ACTIONS(2952),
    [sym_primitive_type] = ACTIONS(2952),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_LT_EQ_GT] = ACTIONS(2950),
    [anon_sym_or] = ACTIONS(2952),
    [anon_sym_and] = ACTIONS(2952),
    [anon_sym_bitor] = ACTIONS(2952),
    [anon_sym_xor] = ACTIONS(2952),
    [anon_sym_bitand] = ACTIONS(2952),
    [anon_sym_not_eq] = ACTIONS(2952),
    [anon_sym_is] = ACTIONS(2952),
    [anon_sym_as] = ACTIONS(2952),
    [anon_sym_DASH_DASH] = ACTIONS(2950),
    [anon_sym_PLUS_PLUS] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2952),
    [anon_sym_DOT_STAR] = ACTIONS(2950),
    [anon_sym_DASH_GT] = ACTIONS(2950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2952),
    [anon_sym_let] = ACTIONS(2952),
    [anon_sym_This] = ACTIONS(2952),
    [anon_sym_final] = ACTIONS(2952),
    [anon_sym_override] = ACTIONS(2952),
    [anon_sym_requires] = ACTIONS(2952),
    [anon_sym_where] = ACTIONS(2952),
  },
  [3019] = {
    [sym_identifier] = ACTIONS(3054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3052),
    [anon_sym_COMMA] = ACTIONS(3052),
    [anon_sym_RPAREN] = ACTIONS(3052),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_SLASH] = ACTIONS(3054),
    [anon_sym_PERCENT] = ACTIONS(3052),
    [anon_sym_PIPE_PIPE] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_PIPE] = ACTIONS(3054),
    [anon_sym_CARET] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_EQ_EQ] = ACTIONS(3052),
    [anon_sym_BANG_EQ] = ACTIONS(3052),
    [anon_sym_GT] = ACTIONS(3054),
    [anon_sym_GT_EQ] = ACTIONS(3052),
    [anon_sym_LT_EQ] = ACTIONS(3054),
    [anon_sym_LT] = ACTIONS(3054),
    [anon_sym_LT_LT] = ACTIONS(3052),
    [anon_sym_GT_GT] = ACTIONS(3052),
    [anon_sym_COLON] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3054),
    [anon_sym___attribute__] = ACTIONS(3054),
    [anon_sym___attribute] = ACTIONS(3054),
    [anon_sym___based] = ACTIONS(3054),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_RBRACE] = ACTIONS(3052),
    [anon_sym_signed] = ACTIONS(3054),
    [anon_sym_unsigned] = ACTIONS(3054),
    [anon_sym_long] = ACTIONS(3054),
    [anon_sym_short] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [anon_sym_RBRACK] = ACTIONS(3052),
    [anon_sym_const] = ACTIONS(3054),
    [anon_sym_constexpr] = ACTIONS(3054),
    [anon_sym_volatile] = ACTIONS(3054),
    [anon_sym_restrict] = ACTIONS(3054),
    [anon_sym___restrict__] = ACTIONS(3054),
    [anon_sym__Atomic] = ACTIONS(3054),
    [anon_sym__Noreturn] = ACTIONS(3054),
    [anon_sym_noreturn] = ACTIONS(3054),
    [anon_sym__Nonnull] = ACTIONS(3054),
    [anon_sym_mutable] = ACTIONS(3054),
    [anon_sym_constinit] = ACTIONS(3054),
    [anon_sym_consteval] = ACTIONS(3054),
    [anon_sym_alignas] = ACTIONS(3054),
    [anon_sym__Alignas] = ACTIONS(3054),
    [sym_primitive_type] = ACTIONS(3054),
    [anon_sym_QMARK] = ACTIONS(3052),
    [anon_sym_LT_EQ_GT] = ACTIONS(3052),
    [anon_sym_or] = ACTIONS(3054),
    [anon_sym_and] = ACTIONS(3054),
    [anon_sym_bitor] = ACTIONS(3054),
    [anon_sym_xor] = ACTIONS(3054),
    [anon_sym_bitand] = ACTIONS(3054),
    [anon_sym_not_eq] = ACTIONS(3054),
    [anon_sym_is] = ACTIONS(3054),
    [anon_sym_as] = ACTIONS(3054),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_DOT] = ACTIONS(3054),
    [anon_sym_DOT_STAR] = ACTIONS(3052),
    [anon_sym_DASH_GT] = ACTIONS(3052),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3054),
    [anon_sym_let] = ACTIONS(3054),
    [anon_sym_This] = ACTIONS(3054),
    [anon_sym_final] = ACTIONS(3054),
    [anon_sym_override] = ACTIONS(3054),
    [anon_sym_requires] = ACTIONS(3054),
    [anon_sym_where] = ACTIONS(3054),
  },
  [3020] = {
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2976),
    [anon_sym_COMMA] = ACTIONS(2976),
    [anon_sym_RPAREN] = ACTIONS(2976),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_STAR] = ACTIONS(2976),
    [anon_sym_SLASH] = ACTIONS(2978),
    [anon_sym_PERCENT] = ACTIONS(2976),
    [anon_sym_PIPE_PIPE] = ACTIONS(2976),
    [anon_sym_AMP_AMP] = ACTIONS(2976),
    [anon_sym_PIPE] = ACTIONS(2978),
    [anon_sym_CARET] = ACTIONS(2976),
    [anon_sym_AMP] = ACTIONS(2978),
    [anon_sym_EQ_EQ] = ACTIONS(2976),
    [anon_sym_BANG_EQ] = ACTIONS(2976),
    [anon_sym_GT] = ACTIONS(2978),
    [anon_sym_GT_EQ] = ACTIONS(2976),
    [anon_sym_LT_EQ] = ACTIONS(2978),
    [anon_sym_LT] = ACTIONS(2978),
    [anon_sym_LT_LT] = ACTIONS(2976),
    [anon_sym_GT_GT] = ACTIONS(2976),
    [anon_sym_COLON] = ACTIONS(2976),
    [anon_sym_SEMI] = ACTIONS(2976),
    [anon_sym___extension__] = ACTIONS(2978),
    [anon_sym___attribute__] = ACTIONS(2978),
    [anon_sym___attribute] = ACTIONS(2978),
    [anon_sym___based] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(2976),
    [anon_sym_RBRACE] = ACTIONS(2976),
    [anon_sym_signed] = ACTIONS(2978),
    [anon_sym_unsigned] = ACTIONS(2978),
    [anon_sym_long] = ACTIONS(2978),
    [anon_sym_short] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2976),
    [anon_sym_RBRACK] = ACTIONS(2976),
    [anon_sym_const] = ACTIONS(2978),
    [anon_sym_constexpr] = ACTIONS(2978),
    [anon_sym_volatile] = ACTIONS(2978),
    [anon_sym_restrict] = ACTIONS(2978),
    [anon_sym___restrict__] = ACTIONS(2978),
    [anon_sym__Atomic] = ACTIONS(2978),
    [anon_sym__Noreturn] = ACTIONS(2978),
    [anon_sym_noreturn] = ACTIONS(2978),
    [anon_sym__Nonnull] = ACTIONS(2978),
    [anon_sym_mutable] = ACTIONS(2978),
    [anon_sym_constinit] = ACTIONS(2978),
    [anon_sym_consteval] = ACTIONS(2978),
    [anon_sym_alignas] = ACTIONS(2978),
    [anon_sym__Alignas] = ACTIONS(2978),
    [sym_primitive_type] = ACTIONS(2978),
    [anon_sym_QMARK] = ACTIONS(2976),
    [anon_sym_LT_EQ_GT] = ACTIONS(2976),
    [anon_sym_or] = ACTIONS(2978),
    [anon_sym_and] = ACTIONS(2978),
    [anon_sym_bitor] = ACTIONS(2978),
    [anon_sym_xor] = ACTIONS(2978),
    [anon_sym_bitand] = ACTIONS(2978),
    [anon_sym_not_eq] = ACTIONS(2978),
    [anon_sym_is] = ACTIONS(2978),
    [anon_sym_as] = ACTIONS(2978),
    [anon_sym_DASH_DASH] = ACTIONS(2976),
    [anon_sym_PLUS_PLUS] = ACTIONS(2976),
    [anon_sym_DOT] = ACTIONS(2978),
    [anon_sym_DOT_STAR] = ACTIONS(2976),
    [anon_sym_DASH_GT] = ACTIONS(2976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_This] = ACTIONS(2978),
    [anon_sym_final] = ACTIONS(2978),
    [anon_sym_override] = ACTIONS(2978),
    [anon_sym_requires] = ACTIONS(2978),
    [anon_sym_where] = ACTIONS(2978),
  },
  [3021] = {
    [sym_identifier] = ACTIONS(3022),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3020),
    [anon_sym_COMMA] = ACTIONS(3020),
    [anon_sym_RPAREN] = ACTIONS(3020),
    [anon_sym_LPAREN2] = ACTIONS(3020),
    [anon_sym_DASH] = ACTIONS(3022),
    [anon_sym_PLUS] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3020),
    [anon_sym_SLASH] = ACTIONS(3022),
    [anon_sym_PERCENT] = ACTIONS(3020),
    [anon_sym_PIPE_PIPE] = ACTIONS(3020),
    [anon_sym_AMP_AMP] = ACTIONS(3020),
    [anon_sym_PIPE] = ACTIONS(3022),
    [anon_sym_CARET] = ACTIONS(3020),
    [anon_sym_AMP] = ACTIONS(3022),
    [anon_sym_EQ_EQ] = ACTIONS(3020),
    [anon_sym_BANG_EQ] = ACTIONS(3020),
    [anon_sym_GT] = ACTIONS(3022),
    [anon_sym_GT_EQ] = ACTIONS(3020),
    [anon_sym_LT_EQ] = ACTIONS(3022),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_LT_LT] = ACTIONS(3020),
    [anon_sym_GT_GT] = ACTIONS(3020),
    [anon_sym_COLON] = ACTIONS(3020),
    [anon_sym_SEMI] = ACTIONS(3020),
    [anon_sym___extension__] = ACTIONS(3022),
    [anon_sym___attribute__] = ACTIONS(3022),
    [anon_sym___attribute] = ACTIONS(3022),
    [anon_sym___based] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3020),
    [anon_sym_RBRACE] = ACTIONS(3020),
    [anon_sym_signed] = ACTIONS(3022),
    [anon_sym_unsigned] = ACTIONS(3022),
    [anon_sym_long] = ACTIONS(3022),
    [anon_sym_short] = ACTIONS(3022),
    [anon_sym_LBRACK] = ACTIONS(3020),
    [anon_sym_RBRACK] = ACTIONS(3020),
    [anon_sym_const] = ACTIONS(3022),
    [anon_sym_constexpr] = ACTIONS(3022),
    [anon_sym_volatile] = ACTIONS(3022),
    [anon_sym_restrict] = ACTIONS(3022),
    [anon_sym___restrict__] = ACTIONS(3022),
    [anon_sym__Atomic] = ACTIONS(3022),
    [anon_sym__Noreturn] = ACTIONS(3022),
    [anon_sym_noreturn] = ACTIONS(3022),
    [anon_sym__Nonnull] = ACTIONS(3022),
    [anon_sym_mutable] = ACTIONS(3022),
    [anon_sym_constinit] = ACTIONS(3022),
    [anon_sym_consteval] = ACTIONS(3022),
    [anon_sym_alignas] = ACTIONS(3022),
    [anon_sym__Alignas] = ACTIONS(3022),
    [sym_primitive_type] = ACTIONS(3022),
    [anon_sym_QMARK] = ACTIONS(3020),
    [anon_sym_LT_EQ_GT] = ACTIONS(3020),
    [anon_sym_or] = ACTIONS(3022),
    [anon_sym_and] = ACTIONS(3022),
    [anon_sym_bitor] = ACTIONS(3022),
    [anon_sym_xor] = ACTIONS(3022),
    [anon_sym_bitand] = ACTIONS(3022),
    [anon_sym_not_eq] = ACTIONS(3022),
    [anon_sym_is] = ACTIONS(3022),
    [anon_sym_as] = ACTIONS(3022),
    [anon_sym_DASH_DASH] = ACTIONS(3020),
    [anon_sym_PLUS_PLUS] = ACTIONS(3020),
    [anon_sym_DOT] = ACTIONS(3022),
    [anon_sym_DOT_STAR] = ACTIONS(3020),
    [anon_sym_DASH_GT] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3022),
    [anon_sym_let] = ACTIONS(3022),
    [anon_sym_This] = ACTIONS(3022),
    [anon_sym_final] = ACTIONS(3022),
    [anon_sym_override] = ACTIONS(3022),
    [anon_sym_requires] = ACTIONS(3022),
    [anon_sym_where] = ACTIONS(3022),
  },
  [3022] = {
    [sym_identifier] = ACTIONS(2960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2958),
    [anon_sym_COMMA] = ACTIONS(2958),
    [anon_sym_RPAREN] = ACTIONS(2958),
    [anon_sym_LPAREN2] = ACTIONS(2958),
    [anon_sym_DASH] = ACTIONS(2960),
    [anon_sym_PLUS] = ACTIONS(2960),
    [anon_sym_STAR] = ACTIONS(2958),
    [anon_sym_SLASH] = ACTIONS(2960),
    [anon_sym_PERCENT] = ACTIONS(2958),
    [anon_sym_PIPE_PIPE] = ACTIONS(2958),
    [anon_sym_AMP_AMP] = ACTIONS(2958),
    [anon_sym_PIPE] = ACTIONS(2960),
    [anon_sym_CARET] = ACTIONS(2958),
    [anon_sym_AMP] = ACTIONS(2960),
    [anon_sym_EQ_EQ] = ACTIONS(2958),
    [anon_sym_BANG_EQ] = ACTIONS(2958),
    [anon_sym_GT] = ACTIONS(2960),
    [anon_sym_GT_EQ] = ACTIONS(2958),
    [anon_sym_LT_EQ] = ACTIONS(2960),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_LT_LT] = ACTIONS(2958),
    [anon_sym_GT_GT] = ACTIONS(2958),
    [anon_sym_COLON] = ACTIONS(2958),
    [anon_sym_SEMI] = ACTIONS(2958),
    [anon_sym___extension__] = ACTIONS(2960),
    [anon_sym___attribute__] = ACTIONS(2960),
    [anon_sym___attribute] = ACTIONS(2960),
    [anon_sym___based] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2958),
    [anon_sym_RBRACE] = ACTIONS(2958),
    [anon_sym_signed] = ACTIONS(2960),
    [anon_sym_unsigned] = ACTIONS(2960),
    [anon_sym_long] = ACTIONS(2960),
    [anon_sym_short] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2958),
    [anon_sym_RBRACK] = ACTIONS(2958),
    [anon_sym_const] = ACTIONS(2960),
    [anon_sym_constexpr] = ACTIONS(2960),
    [anon_sym_volatile] = ACTIONS(2960),
    [anon_sym_restrict] = ACTIONS(2960),
    [anon_sym___restrict__] = ACTIONS(2960),
    [anon_sym__Atomic] = ACTIONS(2960),
    [anon_sym__Noreturn] = ACTIONS(2960),
    [anon_sym_noreturn] = ACTIONS(2960),
    [anon_sym__Nonnull] = ACTIONS(2960),
    [anon_sym_mutable] = ACTIONS(2960),
    [anon_sym_constinit] = ACTIONS(2960),
    [anon_sym_consteval] = ACTIONS(2960),
    [anon_sym_alignas] = ACTIONS(2960),
    [anon_sym__Alignas] = ACTIONS(2960),
    [sym_primitive_type] = ACTIONS(2960),
    [anon_sym_QMARK] = ACTIONS(2958),
    [anon_sym_LT_EQ_GT] = ACTIONS(2958),
    [anon_sym_or] = ACTIONS(2960),
    [anon_sym_and] = ACTIONS(2960),
    [anon_sym_bitor] = ACTIONS(2960),
    [anon_sym_xor] = ACTIONS(2960),
    [anon_sym_bitand] = ACTIONS(2960),
    [anon_sym_not_eq] = ACTIONS(2960),
    [anon_sym_is] = ACTIONS(2960),
    [anon_sym_as] = ACTIONS(2960),
    [anon_sym_DASH_DASH] = ACTIONS(2958),
    [anon_sym_PLUS_PLUS] = ACTIONS(2958),
    [anon_sym_DOT] = ACTIONS(2960),
    [anon_sym_DOT_STAR] = ACTIONS(2958),
    [anon_sym_DASH_GT] = ACTIONS(2958),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2960),
    [anon_sym_let] = ACTIONS(2960),
    [anon_sym_This] = ACTIONS(2960),
    [anon_sym_final] = ACTIONS(2960),
    [anon_sym_override] = ACTIONS(2960),
    [anon_sym_requires] = ACTIONS(2960),
    [anon_sym_where] = ACTIONS(2960),
  },
  [3023] = {
    [sym_identifier] = ACTIONS(2998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2996),
    [anon_sym_COMMA] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(2996),
    [anon_sym_LPAREN2] = ACTIONS(2996),
    [anon_sym_DASH] = ACTIONS(2998),
    [anon_sym_PLUS] = ACTIONS(2998),
    [anon_sym_STAR] = ACTIONS(2996),
    [anon_sym_SLASH] = ACTIONS(2998),
    [anon_sym_PERCENT] = ACTIONS(2996),
    [anon_sym_PIPE_PIPE] = ACTIONS(2996),
    [anon_sym_AMP_AMP] = ACTIONS(2996),
    [anon_sym_PIPE] = ACTIONS(2998),
    [anon_sym_CARET] = ACTIONS(2996),
    [anon_sym_AMP] = ACTIONS(2998),
    [anon_sym_EQ_EQ] = ACTIONS(2996),
    [anon_sym_BANG_EQ] = ACTIONS(2996),
    [anon_sym_GT] = ACTIONS(2998),
    [anon_sym_GT_EQ] = ACTIONS(2996),
    [anon_sym_LT_EQ] = ACTIONS(2998),
    [anon_sym_LT] = ACTIONS(2998),
    [anon_sym_LT_LT] = ACTIONS(2996),
    [anon_sym_GT_GT] = ACTIONS(2996),
    [anon_sym_COLON] = ACTIONS(2996),
    [anon_sym_SEMI] = ACTIONS(2996),
    [anon_sym___extension__] = ACTIONS(2998),
    [anon_sym___attribute__] = ACTIONS(2998),
    [anon_sym___attribute] = ACTIONS(2998),
    [anon_sym___based] = ACTIONS(2998),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_RBRACE] = ACTIONS(2996),
    [anon_sym_signed] = ACTIONS(2998),
    [anon_sym_unsigned] = ACTIONS(2998),
    [anon_sym_long] = ACTIONS(2998),
    [anon_sym_short] = ACTIONS(2998),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_RBRACK] = ACTIONS(2996),
    [anon_sym_const] = ACTIONS(2998),
    [anon_sym_constexpr] = ACTIONS(2998),
    [anon_sym_volatile] = ACTIONS(2998),
    [anon_sym_restrict] = ACTIONS(2998),
    [anon_sym___restrict__] = ACTIONS(2998),
    [anon_sym__Atomic] = ACTIONS(2998),
    [anon_sym__Noreturn] = ACTIONS(2998),
    [anon_sym_noreturn] = ACTIONS(2998),
    [anon_sym__Nonnull] = ACTIONS(2998),
    [anon_sym_mutable] = ACTIONS(2998),
    [anon_sym_constinit] = ACTIONS(2998),
    [anon_sym_consteval] = ACTIONS(2998),
    [anon_sym_alignas] = ACTIONS(2998),
    [anon_sym__Alignas] = ACTIONS(2998),
    [sym_primitive_type] = ACTIONS(2998),
    [anon_sym_QMARK] = ACTIONS(2996),
    [anon_sym_LT_EQ_GT] = ACTIONS(2996),
    [anon_sym_or] = ACTIONS(2998),
    [anon_sym_and] = ACTIONS(2998),
    [anon_sym_bitor] = ACTIONS(2998),
    [anon_sym_xor] = ACTIONS(2998),
    [anon_sym_bitand] = ACTIONS(2998),
    [anon_sym_not_eq] = ACTIONS(2998),
    [anon_sym_is] = ACTIONS(2998),
    [anon_sym_as] = ACTIONS(2998),
    [anon_sym_DASH_DASH] = ACTIONS(2996),
    [anon_sym_PLUS_PLUS] = ACTIONS(2996),
    [anon_sym_DOT] = ACTIONS(2998),
    [anon_sym_DOT_STAR] = ACTIONS(2996),
    [anon_sym_DASH_GT] = ACTIONS(2996),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2998),
    [anon_sym_let] = ACTIONS(2998),
    [anon_sym_This] = ACTIONS(2998),
    [anon_sym_final] = ACTIONS(2998),
    [anon_sym_override] = ACTIONS(2998),
    [anon_sym_requires] = ACTIONS(2998),
    [anon_sym_where] = ACTIONS(2998),
  },
  [3024] = {
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2552),
    [anon_sym_COMMA] = ACTIONS(2552),
    [anon_sym_RPAREN] = ACTIONS(2552),
    [anon_sym_LPAREN2] = ACTIONS(2552),
    [anon_sym_DASH] = ACTIONS(2554),
    [anon_sym_PLUS] = ACTIONS(2554),
    [anon_sym_STAR] = ACTIONS(2552),
    [anon_sym_SLASH] = ACTIONS(2554),
    [anon_sym_PERCENT] = ACTIONS(2552),
    [anon_sym_PIPE_PIPE] = ACTIONS(2552),
    [anon_sym_AMP_AMP] = ACTIONS(2552),
    [anon_sym_PIPE] = ACTIONS(2554),
    [anon_sym_CARET] = ACTIONS(2552),
    [anon_sym_AMP] = ACTIONS(2554),
    [anon_sym_EQ_EQ] = ACTIONS(2552),
    [anon_sym_BANG_EQ] = ACTIONS(2552),
    [anon_sym_GT] = ACTIONS(2554),
    [anon_sym_GT_EQ] = ACTIONS(2552),
    [anon_sym_LT_EQ] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2552),
    [anon_sym_GT_GT] = ACTIONS(2552),
    [anon_sym_COLON] = ACTIONS(2552),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym___extension__] = ACTIONS(2554),
    [anon_sym___attribute__] = ACTIONS(2554),
    [anon_sym___attribute] = ACTIONS(2554),
    [anon_sym___based] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(2552),
    [anon_sym_RBRACE] = ACTIONS(2552),
    [anon_sym_signed] = ACTIONS(2554),
    [anon_sym_unsigned] = ACTIONS(2554),
    [anon_sym_long] = ACTIONS(2554),
    [anon_sym_short] = ACTIONS(2554),
    [anon_sym_LBRACK] = ACTIONS(2552),
    [anon_sym_RBRACK] = ACTIONS(2552),
    [anon_sym_const] = ACTIONS(2554),
    [anon_sym_constexpr] = ACTIONS(2554),
    [anon_sym_volatile] = ACTIONS(2554),
    [anon_sym_restrict] = ACTIONS(2554),
    [anon_sym___restrict__] = ACTIONS(2554),
    [anon_sym__Atomic] = ACTIONS(2554),
    [anon_sym__Noreturn] = ACTIONS(2554),
    [anon_sym_noreturn] = ACTIONS(2554),
    [anon_sym__Nonnull] = ACTIONS(2554),
    [anon_sym_mutable] = ACTIONS(2554),
    [anon_sym_constinit] = ACTIONS(2554),
    [anon_sym_consteval] = ACTIONS(2554),
    [anon_sym_alignas] = ACTIONS(2554),
    [anon_sym__Alignas] = ACTIONS(2554),
    [sym_primitive_type] = ACTIONS(2554),
    [anon_sym_QMARK] = ACTIONS(2552),
    [anon_sym_LT_EQ_GT] = ACTIONS(2552),
    [anon_sym_or] = ACTIONS(2554),
    [anon_sym_and] = ACTIONS(2554),
    [anon_sym_bitor] = ACTIONS(2554),
    [anon_sym_xor] = ACTIONS(2554),
    [anon_sym_bitand] = ACTIONS(2554),
    [anon_sym_not_eq] = ACTIONS(2554),
    [anon_sym_is] = ACTIONS(2554),
    [anon_sym_as] = ACTIONS(2554),
    [anon_sym_DASH_DASH] = ACTIONS(2552),
    [anon_sym_PLUS_PLUS] = ACTIONS(2552),
    [anon_sym_DOT] = ACTIONS(2554),
    [anon_sym_DOT_STAR] = ACTIONS(2552),
    [anon_sym_DASH_GT] = ACTIONS(2552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2554),
    [anon_sym_let] = ACTIONS(2554),
    [anon_sym_This] = ACTIONS(2554),
    [anon_sym_final] = ACTIONS(2554),
    [anon_sym_override] = ACTIONS(2554),
    [anon_sym_requires] = ACTIONS(2554),
    [anon_sym_where] = ACTIONS(2554),
  },
  [3025] = {
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2426),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
  },
  [3026] = {
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2426),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2881),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym___cdecl] = ACTIONS(2883),
    [anon_sym___clrcall] = ACTIONS(2883),
    [anon_sym___stdcall] = ACTIONS(2883),
    [anon_sym___fastcall] = ACTIONS(2883),
    [anon_sym___thiscall] = ACTIONS(2883),
    [anon_sym___vectorcall] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
  },
  [3027] = {
    [sym_template_argument_list] = STATE(3077),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2226),
    [anon_sym_COMMA] = ACTIONS(2226),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2231),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_PIPE_PIPE] = ACTIONS(2224),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_EQ_EQ] = ACTIONS(2224),
    [anon_sym_BANG_EQ] = ACTIONS(2224),
    [anon_sym_GT] = ACTIONS(2234),
    [anon_sym_GT_EQ] = ACTIONS(2234),
    [anon_sym_LT_EQ] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(7258),
    [anon_sym_LT_LT] = ACTIONS(2234),
    [anon_sym_GT_GT] = ACTIONS(2234),
    [anon_sym_COLON] = ACTIONS(2222),
    [anon_sym___extension__] = ACTIONS(2229),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_EQ] = ACTIONS(2231),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2229),
    [anon_sym_volatile] = ACTIONS(2229),
    [anon_sym_restrict] = ACTIONS(2229),
    [anon_sym___restrict__] = ACTIONS(2229),
    [anon_sym__Atomic] = ACTIONS(2229),
    [anon_sym__Noreturn] = ACTIONS(2229),
    [anon_sym_noreturn] = ACTIONS(2229),
    [anon_sym__Nonnull] = ACTIONS(2229),
    [anon_sym_mutable] = ACTIONS(2229),
    [anon_sym_constinit] = ACTIONS(2229),
    [anon_sym_consteval] = ACTIONS(2229),
    [anon_sym_alignas] = ACTIONS(2229),
    [anon_sym__Alignas] = ACTIONS(2229),
    [anon_sym_QMARK] = ACTIONS(2224),
    [anon_sym_STAR_EQ] = ACTIONS(2224),
    [anon_sym_SLASH_EQ] = ACTIONS(2224),
    [anon_sym_PERCENT_EQ] = ACTIONS(2224),
    [anon_sym_PLUS_EQ] = ACTIONS(2224),
    [anon_sym_DASH_EQ] = ACTIONS(2224),
    [anon_sym_LT_LT_EQ] = ACTIONS(2224),
    [anon_sym_GT_GT_EQ] = ACTIONS(2234),
    [anon_sym_AMP_EQ] = ACTIONS(2224),
    [anon_sym_CARET_EQ] = ACTIONS(2224),
    [anon_sym_PIPE_EQ] = ACTIONS(2224),
    [anon_sym_and_eq] = ACTIONS(2224),
    [anon_sym_or_eq] = ACTIONS(2224),
    [anon_sym_xor_eq] = ACTIONS(2224),
    [anon_sym_LT_EQ_GT] = ACTIONS(2224),
    [anon_sym_or] = ACTIONS(2234),
    [anon_sym_and] = ACTIONS(2234),
    [anon_sym_bitor] = ACTIONS(2224),
    [anon_sym_xor] = ACTIONS(2234),
    [anon_sym_bitand] = ACTIONS(2224),
    [anon_sym_not_eq] = ACTIONS(2224),
    [anon_sym_is] = ACTIONS(2224),
    [anon_sym_as] = ACTIONS(2224),
    [anon_sym_DASH_DASH] = ACTIONS(2224),
    [anon_sym_PLUS_PLUS] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(2231),
    [anon_sym_DOT_STAR] = ACTIONS(2224),
    [anon_sym_DASH_GT] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2229),
    [anon_sym_let] = ACTIONS(2229),
    [anon_sym_This] = ACTIONS(2229),
    [anon_sym_GT2] = ACTIONS(2226),
  },
  [3028] = {
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2932),
    [anon_sym_COMMA] = ACTIONS(2932),
    [anon_sym_RPAREN] = ACTIONS(2932),
    [anon_sym_LPAREN2] = ACTIONS(2932),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_STAR] = ACTIONS(2932),
    [anon_sym_SLASH] = ACTIONS(2934),
    [anon_sym_PERCENT] = ACTIONS(2932),
    [anon_sym_PIPE_PIPE] = ACTIONS(2932),
    [anon_sym_AMP_AMP] = ACTIONS(2932),
    [anon_sym_PIPE] = ACTIONS(2934),
    [anon_sym_CARET] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_EQ_EQ] = ACTIONS(2932),
    [anon_sym_BANG_EQ] = ACTIONS(2932),
    [anon_sym_GT] = ACTIONS(2934),
    [anon_sym_GT_EQ] = ACTIONS(2932),
    [anon_sym_LT_EQ] = ACTIONS(2934),
    [anon_sym_LT] = ACTIONS(2934),
    [anon_sym_LT_LT] = ACTIONS(2932),
    [anon_sym_GT_GT] = ACTIONS(2932),
    [anon_sym_COLON] = ACTIONS(2932),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym___extension__] = ACTIONS(2934),
    [anon_sym___attribute__] = ACTIONS(2934),
    [anon_sym___attribute] = ACTIONS(2934),
    [anon_sym___based] = ACTIONS(2934),
    [anon_sym_LBRACE] = ACTIONS(2932),
    [anon_sym_RBRACE] = ACTIONS(2932),
    [anon_sym_signed] = ACTIONS(2934),
    [anon_sym_unsigned] = ACTIONS(2934),
    [anon_sym_long] = ACTIONS(2934),
    [anon_sym_short] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2932),
    [anon_sym_RBRACK] = ACTIONS(2932),
    [anon_sym_const] = ACTIONS(2934),
    [anon_sym_constexpr] = ACTIONS(2934),
    [anon_sym_volatile] = ACTIONS(2934),
    [anon_sym_restrict] = ACTIONS(2934),
    [anon_sym___restrict__] = ACTIONS(2934),
    [anon_sym__Atomic] = ACTIONS(2934),
    [anon_sym__Noreturn] = ACTIONS(2934),
    [anon_sym_noreturn] = ACTIONS(2934),
    [anon_sym__Nonnull] = ACTIONS(2934),
    [anon_sym_mutable] = ACTIONS(2934),
    [anon_sym_constinit] = ACTIONS(2934),
    [anon_sym_consteval] = ACTIONS(2934),
    [anon_sym_alignas] = ACTIONS(2934),
    [anon_sym__Alignas] = ACTIONS(2934),
    [sym_primitive_type] = ACTIONS(2934),
    [anon_sym_QMARK] = ACTIONS(2932),
    [anon_sym_LT_EQ_GT] = ACTIONS(2932),
    [anon_sym_or] = ACTIONS(2934),
    [anon_sym_and] = ACTIONS(2934),
    [anon_sym_bitor] = ACTIONS(2934),
    [anon_sym_xor] = ACTIONS(2934),
    [anon_sym_bitand] = ACTIONS(2934),
    [anon_sym_not_eq] = ACTIONS(2934),
    [anon_sym_is] = ACTIONS(2934),
    [anon_sym_as] = ACTIONS(2934),
    [anon_sym_DASH_DASH] = ACTIONS(2932),
    [anon_sym_PLUS_PLUS] = ACTIONS(2932),
    [anon_sym_DOT] = ACTIONS(2934),
    [anon_sym_DOT_STAR] = ACTIONS(2932),
    [anon_sym_DASH_GT] = ACTIONS(2932),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_This] = ACTIONS(2934),
    [anon_sym_final] = ACTIONS(2934),
    [anon_sym_override] = ACTIONS(2934),
    [anon_sym_requires] = ACTIONS(2934),
    [anon_sym_where] = ACTIONS(2934),
  },
  [3029] = {
    [sym_identifier] = ACTIONS(3042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3040),
    [anon_sym_COMMA] = ACTIONS(3040),
    [anon_sym_RPAREN] = ACTIONS(3040),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_SLASH] = ACTIONS(3042),
    [anon_sym_PERCENT] = ACTIONS(3040),
    [anon_sym_PIPE_PIPE] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_PIPE] = ACTIONS(3042),
    [anon_sym_CARET] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_EQ_EQ] = ACTIONS(3040),
    [anon_sym_BANG_EQ] = ACTIONS(3040),
    [anon_sym_GT] = ACTIONS(3042),
    [anon_sym_GT_EQ] = ACTIONS(3040),
    [anon_sym_LT_EQ] = ACTIONS(3042),
    [anon_sym_LT] = ACTIONS(3042),
    [anon_sym_LT_LT] = ACTIONS(3040),
    [anon_sym_GT_GT] = ACTIONS(3040),
    [anon_sym_COLON] = ACTIONS(3040),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_RBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3040),
    [anon_sym_RBRACK] = ACTIONS(3040),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_QMARK] = ACTIONS(3040),
    [anon_sym_LT_EQ_GT] = ACTIONS(3040),
    [anon_sym_or] = ACTIONS(3042),
    [anon_sym_and] = ACTIONS(3042),
    [anon_sym_bitor] = ACTIONS(3042),
    [anon_sym_xor] = ACTIONS(3042),
    [anon_sym_bitand] = ACTIONS(3042),
    [anon_sym_not_eq] = ACTIONS(3042),
    [anon_sym_is] = ACTIONS(3042),
    [anon_sym_as] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_DOT] = ACTIONS(3042),
    [anon_sym_DOT_STAR] = ACTIONS(3040),
    [anon_sym_DASH_GT] = ACTIONS(3040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3042),
    [anon_sym_let] = ACTIONS(3042),
    [anon_sym_This] = ACTIONS(3042),
    [anon_sym_final] = ACTIONS(3042),
    [anon_sym_override] = ACTIONS(3042),
    [anon_sym_requires] = ACTIONS(3042),
    [anon_sym_where] = ACTIONS(3042),
  },
  [3030] = {
    [sym_identifier] = ACTIONS(2982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2980),
    [anon_sym_COMMA] = ACTIONS(2980),
    [anon_sym_RPAREN] = ACTIONS(2980),
    [anon_sym_LPAREN2] = ACTIONS(2980),
    [anon_sym_DASH] = ACTIONS(2982),
    [anon_sym_PLUS] = ACTIONS(2982),
    [anon_sym_STAR] = ACTIONS(2980),
    [anon_sym_SLASH] = ACTIONS(2982),
    [anon_sym_PERCENT] = ACTIONS(2980),
    [anon_sym_PIPE_PIPE] = ACTIONS(2980),
    [anon_sym_AMP_AMP] = ACTIONS(2980),
    [anon_sym_PIPE] = ACTIONS(2982),
    [anon_sym_CARET] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_EQ_EQ] = ACTIONS(2980),
    [anon_sym_BANG_EQ] = ACTIONS(2980),
    [anon_sym_GT] = ACTIONS(2982),
    [anon_sym_GT_EQ] = ACTIONS(2980),
    [anon_sym_LT_EQ] = ACTIONS(2982),
    [anon_sym_LT] = ACTIONS(2982),
    [anon_sym_LT_LT] = ACTIONS(2980),
    [anon_sym_GT_GT] = ACTIONS(2980),
    [anon_sym_COLON] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2980),
    [anon_sym___extension__] = ACTIONS(2982),
    [anon_sym___attribute__] = ACTIONS(2982),
    [anon_sym___attribute] = ACTIONS(2982),
    [anon_sym___based] = ACTIONS(2982),
    [anon_sym_LBRACE] = ACTIONS(2980),
    [anon_sym_RBRACE] = ACTIONS(2980),
    [anon_sym_signed] = ACTIONS(2982),
    [anon_sym_unsigned] = ACTIONS(2982),
    [anon_sym_long] = ACTIONS(2982),
    [anon_sym_short] = ACTIONS(2982),
    [anon_sym_LBRACK] = ACTIONS(2980),
    [anon_sym_RBRACK] = ACTIONS(2980),
    [anon_sym_const] = ACTIONS(2982),
    [anon_sym_constexpr] = ACTIONS(2982),
    [anon_sym_volatile] = ACTIONS(2982),
    [anon_sym_restrict] = ACTIONS(2982),
    [anon_sym___restrict__] = ACTIONS(2982),
    [anon_sym__Atomic] = ACTIONS(2982),
    [anon_sym__Noreturn] = ACTIONS(2982),
    [anon_sym_noreturn] = ACTIONS(2982),
    [anon_sym__Nonnull] = ACTIONS(2982),
    [anon_sym_mutable] = ACTIONS(2982),
    [anon_sym_constinit] = ACTIONS(2982),
    [anon_sym_consteval] = ACTIONS(2982),
    [anon_sym_alignas] = ACTIONS(2982),
    [anon_sym__Alignas] = ACTIONS(2982),
    [sym_primitive_type] = ACTIONS(2982),
    [anon_sym_QMARK] = ACTIONS(2980),
    [anon_sym_LT_EQ_GT] = ACTIONS(2980),
    [anon_sym_or] = ACTIONS(2982),
    [anon_sym_and] = ACTIONS(2982),
    [anon_sym_bitor] = ACTIONS(2982),
    [anon_sym_xor] = ACTIONS(2982),
    [anon_sym_bitand] = ACTIONS(2982),
    [anon_sym_not_eq] = ACTIONS(2982),
    [anon_sym_is] = ACTIONS(2982),
    [anon_sym_as] = ACTIONS(2982),
    [anon_sym_DASH_DASH] = ACTIONS(2980),
    [anon_sym_PLUS_PLUS] = ACTIONS(2980),
    [anon_sym_DOT] = ACTIONS(2982),
    [anon_sym_DOT_STAR] = ACTIONS(2980),
    [anon_sym_DASH_GT] = ACTIONS(2980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2982),
    [anon_sym_let] = ACTIONS(2982),
    [anon_sym_This] = ACTIONS(2982),
    [anon_sym_final] = ACTIONS(2982),
    [anon_sym_override] = ACTIONS(2982),
    [anon_sym_requires] = ACTIONS(2982),
    [anon_sym_where] = ACTIONS(2982),
  },
  [3031] = {
    [sym_identifier] = ACTIONS(3058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3056),
    [anon_sym_COMMA] = ACTIONS(3056),
    [anon_sym_RPAREN] = ACTIONS(3056),
    [anon_sym_LPAREN2] = ACTIONS(3056),
    [anon_sym_DASH] = ACTIONS(3058),
    [anon_sym_PLUS] = ACTIONS(3058),
    [anon_sym_STAR] = ACTIONS(3056),
    [anon_sym_SLASH] = ACTIONS(3058),
    [anon_sym_PERCENT] = ACTIONS(3056),
    [anon_sym_PIPE_PIPE] = ACTIONS(3056),
    [anon_sym_AMP_AMP] = ACTIONS(3056),
    [anon_sym_PIPE] = ACTIONS(3058),
    [anon_sym_CARET] = ACTIONS(3056),
    [anon_sym_AMP] = ACTIONS(3058),
    [anon_sym_EQ_EQ] = ACTIONS(3056),
    [anon_sym_BANG_EQ] = ACTIONS(3056),
    [anon_sym_GT] = ACTIONS(3058),
    [anon_sym_GT_EQ] = ACTIONS(3056),
    [anon_sym_LT_EQ] = ACTIONS(3058),
    [anon_sym_LT] = ACTIONS(3058),
    [anon_sym_LT_LT] = ACTIONS(3056),
    [anon_sym_GT_GT] = ACTIONS(3056),
    [anon_sym_COLON] = ACTIONS(3056),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym___extension__] = ACTIONS(3058),
    [anon_sym___attribute__] = ACTIONS(3058),
    [anon_sym___attribute] = ACTIONS(3058),
    [anon_sym___based] = ACTIONS(3058),
    [anon_sym_LBRACE] = ACTIONS(3056),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_signed] = ACTIONS(3058),
    [anon_sym_unsigned] = ACTIONS(3058),
    [anon_sym_long] = ACTIONS(3058),
    [anon_sym_short] = ACTIONS(3058),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_RBRACK] = ACTIONS(3056),
    [anon_sym_const] = ACTIONS(3058),
    [anon_sym_constexpr] = ACTIONS(3058),
    [anon_sym_volatile] = ACTIONS(3058),
    [anon_sym_restrict] = ACTIONS(3058),
    [anon_sym___restrict__] = ACTIONS(3058),
    [anon_sym__Atomic] = ACTIONS(3058),
    [anon_sym__Noreturn] = ACTIONS(3058),
    [anon_sym_noreturn] = ACTIONS(3058),
    [anon_sym__Nonnull] = ACTIONS(3058),
    [anon_sym_mutable] = ACTIONS(3058),
    [anon_sym_constinit] = ACTIONS(3058),
    [anon_sym_consteval] = ACTIONS(3058),
    [anon_sym_alignas] = ACTIONS(3058),
    [anon_sym__Alignas] = ACTIONS(3058),
    [sym_primitive_type] = ACTIONS(3058),
    [anon_sym_QMARK] = ACTIONS(3056),
    [anon_sym_LT_EQ_GT] = ACTIONS(3056),
    [anon_sym_or] = ACTIONS(3058),
    [anon_sym_and] = ACTIONS(3058),
    [anon_sym_bitor] = ACTIONS(3058),
    [anon_sym_xor] = ACTIONS(3058),
    [anon_sym_bitand] = ACTIONS(3058),
    [anon_sym_not_eq] = ACTIONS(3058),
    [anon_sym_is] = ACTIONS(3058),
    [anon_sym_as] = ACTIONS(3058),
    [anon_sym_DASH_DASH] = ACTIONS(3056),
    [anon_sym_PLUS_PLUS] = ACTIONS(3056),
    [anon_sym_DOT] = ACTIONS(3058),
    [anon_sym_DOT_STAR] = ACTIONS(3056),
    [anon_sym_DASH_GT] = ACTIONS(3056),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3058),
    [anon_sym_let] = ACTIONS(3058),
    [anon_sym_This] = ACTIONS(3058),
    [anon_sym_final] = ACTIONS(3058),
    [anon_sym_override] = ACTIONS(3058),
    [anon_sym_requires] = ACTIONS(3058),
    [anon_sym_where] = ACTIONS(3058),
  },
  [3032] = {
    [sym_identifier] = ACTIONS(2986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(2984),
    [anon_sym_RPAREN] = ACTIONS(2984),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_DASH] = ACTIONS(2986),
    [anon_sym_PLUS] = ACTIONS(2986),
    [anon_sym_STAR] = ACTIONS(2984),
    [anon_sym_SLASH] = ACTIONS(2986),
    [anon_sym_PERCENT] = ACTIONS(2984),
    [anon_sym_PIPE_PIPE] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_PIPE] = ACTIONS(2986),
    [anon_sym_CARET] = ACTIONS(2984),
    [anon_sym_AMP] = ACTIONS(2986),
    [anon_sym_EQ_EQ] = ACTIONS(2984),
    [anon_sym_BANG_EQ] = ACTIONS(2984),
    [anon_sym_GT] = ACTIONS(2986),
    [anon_sym_GT_EQ] = ACTIONS(2984),
    [anon_sym_LT_EQ] = ACTIONS(2986),
    [anon_sym_LT] = ACTIONS(2986),
    [anon_sym_LT_LT] = ACTIONS(2984),
    [anon_sym_GT_GT] = ACTIONS(2984),
    [anon_sym_COLON] = ACTIONS(2984),
    [anon_sym_SEMI] = ACTIONS(2984),
    [anon_sym___extension__] = ACTIONS(2986),
    [anon_sym___attribute__] = ACTIONS(2986),
    [anon_sym___attribute] = ACTIONS(2986),
    [anon_sym___based] = ACTIONS(2986),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_RBRACE] = ACTIONS(2984),
    [anon_sym_signed] = ACTIONS(2986),
    [anon_sym_unsigned] = ACTIONS(2986),
    [anon_sym_long] = ACTIONS(2986),
    [anon_sym_short] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2984),
    [anon_sym_RBRACK] = ACTIONS(2984),
    [anon_sym_const] = ACTIONS(2986),
    [anon_sym_constexpr] = ACTIONS(2986),
    [anon_sym_volatile] = ACTIONS(2986),
    [anon_sym_restrict] = ACTIONS(2986),
    [anon_sym___restrict__] = ACTIONS(2986),
    [anon_sym__Atomic] = ACTIONS(2986),
    [anon_sym__Noreturn] = ACTIONS(2986),
    [anon_sym_noreturn] = ACTIONS(2986),
    [anon_sym__Nonnull] = ACTIONS(2986),
    [anon_sym_mutable] = ACTIONS(2986),
    [anon_sym_constinit] = ACTIONS(2986),
    [anon_sym_consteval] = ACTIONS(2986),
    [anon_sym_alignas] = ACTIONS(2986),
    [anon_sym__Alignas] = ACTIONS(2986),
    [sym_primitive_type] = ACTIONS(2986),
    [anon_sym_QMARK] = ACTIONS(2984),
    [anon_sym_LT_EQ_GT] = ACTIONS(2984),
    [anon_sym_or] = ACTIONS(2986),
    [anon_sym_and] = ACTIONS(2986),
    [anon_sym_bitor] = ACTIONS(2986),
    [anon_sym_xor] = ACTIONS(2986),
    [anon_sym_bitand] = ACTIONS(2986),
    [anon_sym_not_eq] = ACTIONS(2986),
    [anon_sym_is] = ACTIONS(2986),
    [anon_sym_as] = ACTIONS(2986),
    [anon_sym_DASH_DASH] = ACTIONS(2984),
    [anon_sym_PLUS_PLUS] = ACTIONS(2984),
    [anon_sym_DOT] = ACTIONS(2986),
    [anon_sym_DOT_STAR] = ACTIONS(2984),
    [anon_sym_DASH_GT] = ACTIONS(2984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2986),
    [anon_sym_let] = ACTIONS(2986),
    [anon_sym_This] = ACTIONS(2986),
    [anon_sym_final] = ACTIONS(2986),
    [anon_sym_override] = ACTIONS(2986),
    [anon_sym_requires] = ACTIONS(2986),
    [anon_sym_where] = ACTIONS(2986),
  },
  [3033] = {
    [sym_identifier] = ACTIONS(2990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2988),
    [anon_sym_RPAREN] = ACTIONS(2988),
    [anon_sym_LPAREN2] = ACTIONS(2988),
    [anon_sym_DASH] = ACTIONS(2990),
    [anon_sym_PLUS] = ACTIONS(2990),
    [anon_sym_STAR] = ACTIONS(2988),
    [anon_sym_SLASH] = ACTIONS(2990),
    [anon_sym_PERCENT] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_PIPE] = ACTIONS(2990),
    [anon_sym_CARET] = ACTIONS(2988),
    [anon_sym_AMP] = ACTIONS(2990),
    [anon_sym_EQ_EQ] = ACTIONS(2988),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_GT] = ACTIONS(2990),
    [anon_sym_GT_EQ] = ACTIONS(2988),
    [anon_sym_LT_EQ] = ACTIONS(2990),
    [anon_sym_LT] = ACTIONS(2990),
    [anon_sym_LT_LT] = ACTIONS(2988),
    [anon_sym_GT_GT] = ACTIONS(2988),
    [anon_sym_COLON] = ACTIONS(2988),
    [anon_sym_SEMI] = ACTIONS(2988),
    [anon_sym___extension__] = ACTIONS(2990),
    [anon_sym___attribute__] = ACTIONS(2990),
    [anon_sym___attribute] = ACTIONS(2990),
    [anon_sym___based] = ACTIONS(2990),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_RBRACE] = ACTIONS(2988),
    [anon_sym_signed] = ACTIONS(2990),
    [anon_sym_unsigned] = ACTIONS(2990),
    [anon_sym_long] = ACTIONS(2990),
    [anon_sym_short] = ACTIONS(2990),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_RBRACK] = ACTIONS(2988),
    [anon_sym_const] = ACTIONS(2990),
    [anon_sym_constexpr] = ACTIONS(2990),
    [anon_sym_volatile] = ACTIONS(2990),
    [anon_sym_restrict] = ACTIONS(2990),
    [anon_sym___restrict__] = ACTIONS(2990),
    [anon_sym__Atomic] = ACTIONS(2990),
    [anon_sym__Noreturn] = ACTIONS(2990),
    [anon_sym_noreturn] = ACTIONS(2990),
    [anon_sym__Nonnull] = ACTIONS(2990),
    [anon_sym_mutable] = ACTIONS(2990),
    [anon_sym_constinit] = ACTIONS(2990),
    [anon_sym_consteval] = ACTIONS(2990),
    [anon_sym_alignas] = ACTIONS(2990),
    [anon_sym__Alignas] = ACTIONS(2990),
    [sym_primitive_type] = ACTIONS(2990),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_LT_EQ_GT] = ACTIONS(2988),
    [anon_sym_or] = ACTIONS(2990),
    [anon_sym_and] = ACTIONS(2990),
    [anon_sym_bitor] = ACTIONS(2990),
    [anon_sym_xor] = ACTIONS(2990),
    [anon_sym_bitand] = ACTIONS(2990),
    [anon_sym_not_eq] = ACTIONS(2990),
    [anon_sym_is] = ACTIONS(2990),
    [anon_sym_as] = ACTIONS(2990),
    [anon_sym_DASH_DASH] = ACTIONS(2988),
    [anon_sym_PLUS_PLUS] = ACTIONS(2988),
    [anon_sym_DOT] = ACTIONS(2990),
    [anon_sym_DOT_STAR] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(2988),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2990),
    [anon_sym_let] = ACTIONS(2990),
    [anon_sym_This] = ACTIONS(2990),
    [anon_sym_final] = ACTIONS(2990),
    [anon_sym_override] = ACTIONS(2990),
    [anon_sym_requires] = ACTIONS(2990),
    [anon_sym_where] = ACTIONS(2990),
  },
  [3034] = {
    [sym_identifier] = ACTIONS(3026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3024),
    [anon_sym_COMMA] = ACTIONS(3024),
    [anon_sym_RPAREN] = ACTIONS(3024),
    [anon_sym_LPAREN2] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3026),
    [anon_sym_PLUS] = ACTIONS(3026),
    [anon_sym_STAR] = ACTIONS(3024),
    [anon_sym_SLASH] = ACTIONS(3026),
    [anon_sym_PERCENT] = ACTIONS(3024),
    [anon_sym_PIPE_PIPE] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_PIPE] = ACTIONS(3026),
    [anon_sym_CARET] = ACTIONS(3024),
    [anon_sym_AMP] = ACTIONS(3026),
    [anon_sym_EQ_EQ] = ACTIONS(3024),
    [anon_sym_BANG_EQ] = ACTIONS(3024),
    [anon_sym_GT] = ACTIONS(3026),
    [anon_sym_GT_EQ] = ACTIONS(3024),
    [anon_sym_LT_EQ] = ACTIONS(3026),
    [anon_sym_LT] = ACTIONS(3026),
    [anon_sym_LT_LT] = ACTIONS(3024),
    [anon_sym_GT_GT] = ACTIONS(3024),
    [anon_sym_COLON] = ACTIONS(3024),
    [anon_sym_SEMI] = ACTIONS(3024),
    [anon_sym___extension__] = ACTIONS(3026),
    [anon_sym___attribute__] = ACTIONS(3026),
    [anon_sym___attribute] = ACTIONS(3026),
    [anon_sym___based] = ACTIONS(3026),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_RBRACE] = ACTIONS(3024),
    [anon_sym_signed] = ACTIONS(3026),
    [anon_sym_unsigned] = ACTIONS(3026),
    [anon_sym_long] = ACTIONS(3026),
    [anon_sym_short] = ACTIONS(3026),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_RBRACK] = ACTIONS(3024),
    [anon_sym_const] = ACTIONS(3026),
    [anon_sym_constexpr] = ACTIONS(3026),
    [anon_sym_volatile] = ACTIONS(3026),
    [anon_sym_restrict] = ACTIONS(3026),
    [anon_sym___restrict__] = ACTIONS(3026),
    [anon_sym__Atomic] = ACTIONS(3026),
    [anon_sym__Noreturn] = ACTIONS(3026),
    [anon_sym_noreturn] = ACTIONS(3026),
    [anon_sym__Nonnull] = ACTIONS(3026),
    [anon_sym_mutable] = ACTIONS(3026),
    [anon_sym_constinit] = ACTIONS(3026),
    [anon_sym_consteval] = ACTIONS(3026),
    [anon_sym_alignas] = ACTIONS(3026),
    [anon_sym__Alignas] = ACTIONS(3026),
    [sym_primitive_type] = ACTIONS(3026),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_LT_EQ_GT] = ACTIONS(3024),
    [anon_sym_or] = ACTIONS(3026),
    [anon_sym_and] = ACTIONS(3026),
    [anon_sym_bitor] = ACTIONS(3026),
    [anon_sym_xor] = ACTIONS(3026),
    [anon_sym_bitand] = ACTIONS(3026),
    [anon_sym_not_eq] = ACTIONS(3026),
    [anon_sym_is] = ACTIONS(3026),
    [anon_sym_as] = ACTIONS(3026),
    [anon_sym_DASH_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_PLUS] = ACTIONS(3024),
    [anon_sym_DOT] = ACTIONS(3026),
    [anon_sym_DOT_STAR] = ACTIONS(3024),
    [anon_sym_DASH_GT] = ACTIONS(3024),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3026),
    [anon_sym_let] = ACTIONS(3026),
    [anon_sym_This] = ACTIONS(3026),
    [anon_sym_final] = ACTIONS(3026),
    [anon_sym_override] = ACTIONS(3026),
    [anon_sym_requires] = ACTIONS(3026),
    [anon_sym_where] = ACTIONS(3026),
  },
  [3035] = {
    [sym_identifier] = ACTIONS(2930),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2928),
    [anon_sym_COMMA] = ACTIONS(2928),
    [anon_sym_RPAREN] = ACTIONS(2928),
    [anon_sym_LPAREN2] = ACTIONS(2928),
    [anon_sym_DASH] = ACTIONS(2930),
    [anon_sym_PLUS] = ACTIONS(2930),
    [anon_sym_STAR] = ACTIONS(2928),
    [anon_sym_SLASH] = ACTIONS(2930),
    [anon_sym_PERCENT] = ACTIONS(2928),
    [anon_sym_PIPE_PIPE] = ACTIONS(2928),
    [anon_sym_AMP_AMP] = ACTIONS(2928),
    [anon_sym_PIPE] = ACTIONS(2930),
    [anon_sym_CARET] = ACTIONS(2928),
    [anon_sym_AMP] = ACTIONS(2930),
    [anon_sym_EQ_EQ] = ACTIONS(2928),
    [anon_sym_BANG_EQ] = ACTIONS(2928),
    [anon_sym_GT] = ACTIONS(2930),
    [anon_sym_GT_EQ] = ACTIONS(2928),
    [anon_sym_LT_EQ] = ACTIONS(2930),
    [anon_sym_LT] = ACTIONS(2930),
    [anon_sym_LT_LT] = ACTIONS(2928),
    [anon_sym_GT_GT] = ACTIONS(2928),
    [anon_sym_COLON] = ACTIONS(2928),
    [anon_sym_SEMI] = ACTIONS(2928),
    [anon_sym___extension__] = ACTIONS(2930),
    [anon_sym___attribute__] = ACTIONS(2930),
    [anon_sym___attribute] = ACTIONS(2930),
    [anon_sym___based] = ACTIONS(2930),
    [anon_sym_LBRACE] = ACTIONS(2928),
    [anon_sym_RBRACE] = ACTIONS(2928),
    [anon_sym_signed] = ACTIONS(2930),
    [anon_sym_unsigned] = ACTIONS(2930),
    [anon_sym_long] = ACTIONS(2930),
    [anon_sym_short] = ACTIONS(2930),
    [anon_sym_LBRACK] = ACTIONS(2928),
    [anon_sym_RBRACK] = ACTIONS(2928),
    [anon_sym_const] = ACTIONS(2930),
    [anon_sym_constexpr] = ACTIONS(2930),
    [anon_sym_volatile] = ACTIONS(2930),
    [anon_sym_restrict] = ACTIONS(2930),
    [anon_sym___restrict__] = ACTIONS(2930),
    [anon_sym__Atomic] = ACTIONS(2930),
    [anon_sym__Noreturn] = ACTIONS(2930),
    [anon_sym_noreturn] = ACTIONS(2930),
    [anon_sym__Nonnull] = ACTIONS(2930),
    [anon_sym_mutable] = ACTIONS(2930),
    [anon_sym_constinit] = ACTIONS(2930),
    [anon_sym_consteval] = ACTIONS(2930),
    [anon_sym_alignas] = ACTIONS(2930),
    [anon_sym__Alignas] = ACTIONS(2930),
    [sym_primitive_type] = ACTIONS(2930),
    [anon_sym_QMARK] = ACTIONS(2928),
    [anon_sym_LT_EQ_GT] = ACTIONS(2928),
    [anon_sym_or] = ACTIONS(2930),
    [anon_sym_and] = ACTIONS(2930),
    [anon_sym_bitor] = ACTIONS(2930),
    [anon_sym_xor] = ACTIONS(2930),
    [anon_sym_bitand] = ACTIONS(2930),
    [anon_sym_not_eq] = ACTIONS(2930),
    [anon_sym_is] = ACTIONS(2930),
    [anon_sym_as] = ACTIONS(2930),
    [anon_sym_DASH_DASH] = ACTIONS(2928),
    [anon_sym_PLUS_PLUS] = ACTIONS(2928),
    [anon_sym_DOT] = ACTIONS(2930),
    [anon_sym_DOT_STAR] = ACTIONS(2928),
    [anon_sym_DASH_GT] = ACTIONS(2928),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2930),
    [anon_sym_This] = ACTIONS(2930),
    [anon_sym_final] = ACTIONS(2930),
    [anon_sym_override] = ACTIONS(2930),
    [anon_sym_requires] = ACTIONS(2930),
    [anon_sym_where] = ACTIONS(2930),
  },
  [3036] = {
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2932),
    [anon_sym_COMMA] = ACTIONS(2932),
    [anon_sym_RPAREN] = ACTIONS(2932),
    [anon_sym_LPAREN2] = ACTIONS(2932),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_STAR] = ACTIONS(2932),
    [anon_sym_SLASH] = ACTIONS(2934),
    [anon_sym_PERCENT] = ACTIONS(2932),
    [anon_sym_PIPE_PIPE] = ACTIONS(2932),
    [anon_sym_AMP_AMP] = ACTIONS(2932),
    [anon_sym_PIPE] = ACTIONS(2934),
    [anon_sym_CARET] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_EQ_EQ] = ACTIONS(2932),
    [anon_sym_BANG_EQ] = ACTIONS(2932),
    [anon_sym_GT] = ACTIONS(2934),
    [anon_sym_GT_EQ] = ACTIONS(2932),
    [anon_sym_LT_EQ] = ACTIONS(2934),
    [anon_sym_LT] = ACTIONS(2934),
    [anon_sym_LT_LT] = ACTIONS(2932),
    [anon_sym_GT_GT] = ACTIONS(2932),
    [anon_sym_COLON] = ACTIONS(2932),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym___extension__] = ACTIONS(2934),
    [anon_sym___attribute__] = ACTIONS(2934),
    [anon_sym___attribute] = ACTIONS(2934),
    [anon_sym___based] = ACTIONS(2934),
    [anon_sym_LBRACE] = ACTIONS(2932),
    [anon_sym_RBRACE] = ACTIONS(2932),
    [anon_sym_signed] = ACTIONS(2934),
    [anon_sym_unsigned] = ACTIONS(2934),
    [anon_sym_long] = ACTIONS(2934),
    [anon_sym_short] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2932),
    [anon_sym_RBRACK] = ACTIONS(2932),
    [anon_sym_const] = ACTIONS(2934),
    [anon_sym_constexpr] = ACTIONS(2934),
    [anon_sym_volatile] = ACTIONS(2934),
    [anon_sym_restrict] = ACTIONS(2934),
    [anon_sym___restrict__] = ACTIONS(2934),
    [anon_sym__Atomic] = ACTIONS(2934),
    [anon_sym__Noreturn] = ACTIONS(2934),
    [anon_sym_noreturn] = ACTIONS(2934),
    [anon_sym__Nonnull] = ACTIONS(2934),
    [anon_sym_mutable] = ACTIONS(2934),
    [anon_sym_constinit] = ACTIONS(2934),
    [anon_sym_consteval] = ACTIONS(2934),
    [anon_sym_alignas] = ACTIONS(2934),
    [anon_sym__Alignas] = ACTIONS(2934),
    [sym_primitive_type] = ACTIONS(2934),
    [anon_sym_QMARK] = ACTIONS(2932),
    [anon_sym_LT_EQ_GT] = ACTIONS(2932),
    [anon_sym_or] = ACTIONS(2934),
    [anon_sym_and] = ACTIONS(2934),
    [anon_sym_bitor] = ACTIONS(2934),
    [anon_sym_xor] = ACTIONS(2934),
    [anon_sym_bitand] = ACTIONS(2934),
    [anon_sym_not_eq] = ACTIONS(2934),
    [anon_sym_is] = ACTIONS(2934),
    [anon_sym_as] = ACTIONS(2934),
    [anon_sym_DASH_DASH] = ACTIONS(2932),
    [anon_sym_PLUS_PLUS] = ACTIONS(2932),
    [anon_sym_DOT] = ACTIONS(2934),
    [anon_sym_DOT_STAR] = ACTIONS(2932),
    [anon_sym_DASH_GT] = ACTIONS(2932),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_This] = ACTIONS(2934),
    [anon_sym_final] = ACTIONS(2934),
    [anon_sym_override] = ACTIONS(2934),
    [anon_sym_requires] = ACTIONS(2934),
    [anon_sym_where] = ACTIONS(2934),
  },
  [3037] = {
    [sym_identifier] = ACTIONS(3002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3000),
    [anon_sym_COMMA] = ACTIONS(3000),
    [anon_sym_RPAREN] = ACTIONS(3000),
    [anon_sym_LPAREN2] = ACTIONS(3000),
    [anon_sym_DASH] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(3000),
    [anon_sym_SLASH] = ACTIONS(3002),
    [anon_sym_PERCENT] = ACTIONS(3000),
    [anon_sym_PIPE_PIPE] = ACTIONS(3000),
    [anon_sym_AMP_AMP] = ACTIONS(3000),
    [anon_sym_PIPE] = ACTIONS(3002),
    [anon_sym_CARET] = ACTIONS(3000),
    [anon_sym_AMP] = ACTIONS(3002),
    [anon_sym_EQ_EQ] = ACTIONS(3000),
    [anon_sym_BANG_EQ] = ACTIONS(3000),
    [anon_sym_GT] = ACTIONS(3002),
    [anon_sym_GT_EQ] = ACTIONS(3000),
    [anon_sym_LT_EQ] = ACTIONS(3002),
    [anon_sym_LT] = ACTIONS(3002),
    [anon_sym_LT_LT] = ACTIONS(3000),
    [anon_sym_GT_GT] = ACTIONS(3000),
    [anon_sym_COLON] = ACTIONS(3000),
    [anon_sym_SEMI] = ACTIONS(3000),
    [anon_sym___extension__] = ACTIONS(3002),
    [anon_sym___attribute__] = ACTIONS(3002),
    [anon_sym___attribute] = ACTIONS(3002),
    [anon_sym___based] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3000),
    [anon_sym_RBRACE] = ACTIONS(3000),
    [anon_sym_signed] = ACTIONS(3002),
    [anon_sym_unsigned] = ACTIONS(3002),
    [anon_sym_long] = ACTIONS(3002),
    [anon_sym_short] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3000),
    [anon_sym_RBRACK] = ACTIONS(3000),
    [anon_sym_const] = ACTIONS(3002),
    [anon_sym_constexpr] = ACTIONS(3002),
    [anon_sym_volatile] = ACTIONS(3002),
    [anon_sym_restrict] = ACTIONS(3002),
    [anon_sym___restrict__] = ACTIONS(3002),
    [anon_sym__Atomic] = ACTIONS(3002),
    [anon_sym__Noreturn] = ACTIONS(3002),
    [anon_sym_noreturn] = ACTIONS(3002),
    [anon_sym__Nonnull] = ACTIONS(3002),
    [anon_sym_mutable] = ACTIONS(3002),
    [anon_sym_constinit] = ACTIONS(3002),
    [anon_sym_consteval] = ACTIONS(3002),
    [anon_sym_alignas] = ACTIONS(3002),
    [anon_sym__Alignas] = ACTIONS(3002),
    [sym_primitive_type] = ACTIONS(3002),
    [anon_sym_QMARK] = ACTIONS(3000),
    [anon_sym_LT_EQ_GT] = ACTIONS(3000),
    [anon_sym_or] = ACTIONS(3002),
    [anon_sym_and] = ACTIONS(3002),
    [anon_sym_bitor] = ACTIONS(3002),
    [anon_sym_xor] = ACTIONS(3002),
    [anon_sym_bitand] = ACTIONS(3002),
    [anon_sym_not_eq] = ACTIONS(3002),
    [anon_sym_is] = ACTIONS(3002),
    [anon_sym_as] = ACTIONS(3002),
    [anon_sym_DASH_DASH] = ACTIONS(3000),
    [anon_sym_PLUS_PLUS] = ACTIONS(3000),
    [anon_sym_DOT] = ACTIONS(3002),
    [anon_sym_DOT_STAR] = ACTIONS(3000),
    [anon_sym_DASH_GT] = ACTIONS(3000),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3002),
    [anon_sym_let] = ACTIONS(3002),
    [anon_sym_This] = ACTIONS(3002),
    [anon_sym_final] = ACTIONS(3002),
    [anon_sym_override] = ACTIONS(3002),
    [anon_sym_requires] = ACTIONS(3002),
    [anon_sym_where] = ACTIONS(3002),
  },
  [3038] = {
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2881),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_SLASH] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_CARET] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_EQ_EQ] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_GT_EQ] = ACTIONS(2881),
    [anon_sym_LT_EQ] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_LT_LT] = ACTIONS(2881),
    [anon_sym_GT_GT] = ACTIONS(2881),
    [anon_sym_COLON] = ACTIONS(2881),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_RBRACE] = ACTIONS(2881),
    [anon_sym_signed] = ACTIONS(2883),
    [anon_sym_unsigned] = ACTIONS(2883),
    [anon_sym_long] = ACTIONS(2883),
    [anon_sym_short] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2881),
    [anon_sym_RBRACK] = ACTIONS(2881),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [sym_primitive_type] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_LT_EQ_GT] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2883),
    [anon_sym_and] = ACTIONS(2883),
    [anon_sym_bitor] = ACTIONS(2883),
    [anon_sym_xor] = ACTIONS(2883),
    [anon_sym_bitand] = ACTIONS(2883),
    [anon_sym_not_eq] = ACTIONS(2883),
    [anon_sym_is] = ACTIONS(2883),
    [anon_sym_as] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_DOT_STAR] = ACTIONS(2881),
    [anon_sym_DASH_GT] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_final] = ACTIONS(2883),
    [anon_sym_override] = ACTIONS(2883),
    [anon_sym_requires] = ACTIONS(2883),
    [anon_sym_where] = ACTIONS(2883),
  },
  [3039] = {
    [sym_identifier] = ACTIONS(3006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3004),
    [anon_sym_COMMA] = ACTIONS(3004),
    [anon_sym_RPAREN] = ACTIONS(3004),
    [anon_sym_LPAREN2] = ACTIONS(3004),
    [anon_sym_DASH] = ACTIONS(3006),
    [anon_sym_PLUS] = ACTIONS(3006),
    [anon_sym_STAR] = ACTIONS(3004),
    [anon_sym_SLASH] = ACTIONS(3006),
    [anon_sym_PERCENT] = ACTIONS(3004),
    [anon_sym_PIPE_PIPE] = ACTIONS(3004),
    [anon_sym_AMP_AMP] = ACTIONS(3004),
    [anon_sym_PIPE] = ACTIONS(3006),
    [anon_sym_CARET] = ACTIONS(3004),
    [anon_sym_AMP] = ACTIONS(3006),
    [anon_sym_EQ_EQ] = ACTIONS(3004),
    [anon_sym_BANG_EQ] = ACTIONS(3004),
    [anon_sym_GT] = ACTIONS(3006),
    [anon_sym_GT_EQ] = ACTIONS(3004),
    [anon_sym_LT_EQ] = ACTIONS(3006),
    [anon_sym_LT] = ACTIONS(3006),
    [anon_sym_LT_LT] = ACTIONS(3004),
    [anon_sym_GT_GT] = ACTIONS(3004),
    [anon_sym_COLON] = ACTIONS(3004),
    [anon_sym_SEMI] = ACTIONS(3004),
    [anon_sym___extension__] = ACTIONS(3006),
    [anon_sym___attribute__] = ACTIONS(3006),
    [anon_sym___attribute] = ACTIONS(3006),
    [anon_sym___based] = ACTIONS(3006),
    [anon_sym_LBRACE] = ACTIONS(3004),
    [anon_sym_RBRACE] = ACTIONS(3004),
    [anon_sym_signed] = ACTIONS(3006),
    [anon_sym_unsigned] = ACTIONS(3006),
    [anon_sym_long] = ACTIONS(3006),
    [anon_sym_short] = ACTIONS(3006),
    [anon_sym_LBRACK] = ACTIONS(3004),
    [anon_sym_RBRACK] = ACTIONS(3004),
    [anon_sym_const] = ACTIONS(3006),
    [anon_sym_constexpr] = ACTIONS(3006),
    [anon_sym_volatile] = ACTIONS(3006),
    [anon_sym_restrict] = ACTIONS(3006),
    [anon_sym___restrict__] = ACTIONS(3006),
    [anon_sym__Atomic] = ACTIONS(3006),
    [anon_sym__Noreturn] = ACTIONS(3006),
    [anon_sym_noreturn] = ACTIONS(3006),
    [anon_sym__Nonnull] = ACTIONS(3006),
    [anon_sym_mutable] = ACTIONS(3006),
    [anon_sym_constinit] = ACTIONS(3006),
    [anon_sym_consteval] = ACTIONS(3006),
    [anon_sym_alignas] = ACTIONS(3006),
    [anon_sym__Alignas] = ACTIONS(3006),
    [sym_primitive_type] = ACTIONS(3006),
    [anon_sym_QMARK] = ACTIONS(3004),
    [anon_sym_LT_EQ_GT] = ACTIONS(3004),
    [anon_sym_or] = ACTIONS(3006),
    [anon_sym_and] = ACTIONS(3006),
    [anon_sym_bitor] = ACTIONS(3006),
    [anon_sym_xor] = ACTIONS(3006),
    [anon_sym_bitand] = ACTIONS(3006),
    [anon_sym_not_eq] = ACTIONS(3006),
    [anon_sym_is] = ACTIONS(3006),
    [anon_sym_as] = ACTIONS(3006),
    [anon_sym_DASH_DASH] = ACTIONS(3004),
    [anon_sym_PLUS_PLUS] = ACTIONS(3004),
    [anon_sym_DOT] = ACTIONS(3006),
    [anon_sym_DOT_STAR] = ACTIONS(3004),
    [anon_sym_DASH_GT] = ACTIONS(3004),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3006),
    [anon_sym_let] = ACTIONS(3006),
    [anon_sym_This] = ACTIONS(3006),
    [anon_sym_final] = ACTIONS(3006),
    [anon_sym_override] = ACTIONS(3006),
    [anon_sym_requires] = ACTIONS(3006),
    [anon_sym_where] = ACTIONS(3006),
  },
  [3040] = {
    [sym_identifier] = ACTIONS(3010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3008),
    [anon_sym_COMMA] = ACTIONS(3008),
    [anon_sym_RPAREN] = ACTIONS(3008),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_DASH] = ACTIONS(3010),
    [anon_sym_PLUS] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(3008),
    [anon_sym_SLASH] = ACTIONS(3010),
    [anon_sym_PERCENT] = ACTIONS(3008),
    [anon_sym_PIPE_PIPE] = ACTIONS(3008),
    [anon_sym_AMP_AMP] = ACTIONS(3008),
    [anon_sym_PIPE] = ACTIONS(3010),
    [anon_sym_CARET] = ACTIONS(3008),
    [anon_sym_AMP] = ACTIONS(3010),
    [anon_sym_EQ_EQ] = ACTIONS(3008),
    [anon_sym_BANG_EQ] = ACTIONS(3008),
    [anon_sym_GT] = ACTIONS(3010),
    [anon_sym_GT_EQ] = ACTIONS(3008),
    [anon_sym_LT_EQ] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(3010),
    [anon_sym_LT_LT] = ACTIONS(3008),
    [anon_sym_GT_GT] = ACTIONS(3008),
    [anon_sym_COLON] = ACTIONS(3008),
    [anon_sym_SEMI] = ACTIONS(3008),
    [anon_sym___extension__] = ACTIONS(3010),
    [anon_sym___attribute__] = ACTIONS(3010),
    [anon_sym___attribute] = ACTIONS(3010),
    [anon_sym___based] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3008),
    [anon_sym_RBRACE] = ACTIONS(3008),
    [anon_sym_signed] = ACTIONS(3010),
    [anon_sym_unsigned] = ACTIONS(3010),
    [anon_sym_long] = ACTIONS(3010),
    [anon_sym_short] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3008),
    [anon_sym_RBRACK] = ACTIONS(3008),
    [anon_sym_const] = ACTIONS(3010),
    [anon_sym_constexpr] = ACTIONS(3010),
    [anon_sym_volatile] = ACTIONS(3010),
    [anon_sym_restrict] = ACTIONS(3010),
    [anon_sym___restrict__] = ACTIONS(3010),
    [anon_sym__Atomic] = ACTIONS(3010),
    [anon_sym__Noreturn] = ACTIONS(3010),
    [anon_sym_noreturn] = ACTIONS(3010),
    [anon_sym__Nonnull] = ACTIONS(3010),
    [anon_sym_mutable] = ACTIONS(3010),
    [anon_sym_constinit] = ACTIONS(3010),
    [anon_sym_consteval] = ACTIONS(3010),
    [anon_sym_alignas] = ACTIONS(3010),
    [anon_sym__Alignas] = ACTIONS(3010),
    [sym_primitive_type] = ACTIONS(3010),
    [anon_sym_QMARK] = ACTIONS(3008),
    [anon_sym_LT_EQ_GT] = ACTIONS(3008),
    [anon_sym_or] = ACTIONS(3010),
    [anon_sym_and] = ACTIONS(3010),
    [anon_sym_bitor] = ACTIONS(3010),
    [anon_sym_xor] = ACTIONS(3010),
    [anon_sym_bitand] = ACTIONS(3010),
    [anon_sym_not_eq] = ACTIONS(3010),
    [anon_sym_is] = ACTIONS(3010),
    [anon_sym_as] = ACTIONS(3010),
    [anon_sym_DASH_DASH] = ACTIONS(3008),
    [anon_sym_PLUS_PLUS] = ACTIONS(3008),
    [anon_sym_DOT] = ACTIONS(3010),
    [anon_sym_DOT_STAR] = ACTIONS(3008),
    [anon_sym_DASH_GT] = ACTIONS(3008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3010),
    [anon_sym_let] = ACTIONS(3010),
    [anon_sym_This] = ACTIONS(3010),
    [anon_sym_final] = ACTIONS(3010),
    [anon_sym_override] = ACTIONS(3010),
    [anon_sym_requires] = ACTIONS(3010),
    [anon_sym_where] = ACTIONS(3010),
  },
  [3041] = {
    [sym_identifier] = ACTIONS(4252),
    [anon_sym_LPAREN2] = ACTIONS(4254),
    [anon_sym_TILDE] = ACTIONS(4254),
    [anon_sym_STAR] = ACTIONS(4254),
    [anon_sym_AMP_AMP] = ACTIONS(4254),
    [anon_sym_AMP] = ACTIONS(4252),
    [anon_sym_SEMI] = ACTIONS(4254),
    [anon_sym___extension__] = ACTIONS(4252),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_out] = ACTIONS(4252),
    [anon_sym_inout] = ACTIONS(4252),
    [anon_sym_virtual] = ACTIONS(4252),
    [anon_sym_extern] = ACTIONS(4252),
    [anon_sym___attribute__] = ACTIONS(4252),
    [anon_sym___attribute] = ACTIONS(4252),
    [anon_sym_COLON_COLON] = ACTIONS(4254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4254),
    [anon_sym___declspec] = ACTIONS(4252),
    [anon_sym___based] = ACTIONS(4252),
    [anon_sym___cdecl] = ACTIONS(4252),
    [anon_sym___clrcall] = ACTIONS(4252),
    [anon_sym___stdcall] = ACTIONS(4252),
    [anon_sym___fastcall] = ACTIONS(4252),
    [anon_sym___thiscall] = ACTIONS(4252),
    [anon_sym___vectorcall] = ACTIONS(4252),
    [anon_sym_LBRACK] = ACTIONS(4252),
    [anon_sym_static] = ACTIONS(4252),
    [anon_sym_register] = ACTIONS(4252),
    [anon_sym_inline] = ACTIONS(4252),
    [anon_sym___inline] = ACTIONS(4252),
    [anon_sym___inline__] = ACTIONS(4252),
    [anon_sym___forceinline] = ACTIONS(4252),
    [anon_sym_thread_local] = ACTIONS(4252),
    [anon_sym___thread] = ACTIONS(4252),
    [anon_sym_const] = ACTIONS(4252),
    [anon_sym_constexpr] = ACTIONS(4252),
    [anon_sym_volatile] = ACTIONS(4252),
    [anon_sym_restrict] = ACTIONS(4252),
    [anon_sym___restrict__] = ACTIONS(4252),
    [anon_sym__Atomic] = ACTIONS(4252),
    [anon_sym__Noreturn] = ACTIONS(4252),
    [anon_sym_noreturn] = ACTIONS(4252),
    [anon_sym__Nonnull] = ACTIONS(4252),
    [anon_sym_mutable] = ACTIONS(4252),
    [anon_sym_constinit] = ACTIONS(4252),
    [anon_sym_consteval] = ACTIONS(4252),
    [anon_sym_alignas] = ACTIONS(4252),
    [anon_sym__Alignas] = ACTIONS(4252),
    [anon_sym_DOT] = ACTIONS(6957),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6959),
    [anon_sym_let] = ACTIONS(6959),
    [anon_sym_This] = ACTIONS(6959),
    [anon_sym_decltype] = ACTIONS(4252),
    [anon_sym_template] = ACTIONS(4252),
    [anon_sym_operator] = ACTIONS(4252),
    [anon_sym_precise] = ACTIONS(4252),
    [anon_sym_shared] = ACTIONS(4252),
    [anon_sym_groupshared] = ACTIONS(4252),
    [anon_sym_uniform] = ACTIONS(4252),
    [anon_sym_row_major] = ACTIONS(4252),
    [anon_sym_column_major] = ACTIONS(4252),
    [anon_sym_globallycoherent] = ACTIONS(4252),
    [anon_sym_centroid] = ACTIONS(4252),
    [anon_sym_noperspective] = ACTIONS(4252),
    [anon_sym_nointerpolation] = ACTIONS(4252),
    [anon_sym_sample] = ACTIONS(4252),
    [anon_sym_linear] = ACTIONS(4252),
    [anon_sym_snorm] = ACTIONS(4252),
    [anon_sym_unorm] = ACTIONS(4252),
    [anon_sym_point] = ACTIONS(4252),
    [anon_sym_line] = ACTIONS(4252),
    [anon_sym_triangleadj] = ACTIONS(4252),
    [anon_sym_lineadj] = ACTIONS(4252),
    [anon_sym_triangle] = ACTIONS(4252),
  },
  [3042] = {
    [sym_template_argument_list] = STATE(3064),
    [sym_identifier] = ACTIONS(2222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2229),
    [anon_sym_COMMA] = ACTIONS(2229),
    [anon_sym_RPAREN] = ACTIONS(2226),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2229),
    [anon_sym_STAR] = ACTIONS(2229),
    [anon_sym_AMP_AMP] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(7118),
    [anon_sym_COLON] = ACTIONS(2222),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_virtual] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym___attribute] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2226),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym___based] = ACTIONS(2222),
    [anon_sym_LBRACK] = ACTIONS(2231),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_EQ] = ACTIONS(2229),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym__Nonnull] = ACTIONS(2222),
    [anon_sym_mutable] = ACTIONS(2222),
    [anon_sym_constinit] = ACTIONS(2222),
    [anon_sym_consteval] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [anon_sym_DOT] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2222),
    [anon_sym_let] = ACTIONS(2222),
    [anon_sym_This] = ACTIONS(2222),
    [anon_sym_decltype] = ACTIONS(2222),
    [anon_sym_template] = ACTIONS(2222),
    [anon_sym_operator] = ACTIONS(2222),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_groupshared] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_row_major] = ACTIONS(2222),
    [anon_sym_column_major] = ACTIONS(2222),
    [anon_sym_globallycoherent] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym_nointerpolation] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_linear] = ACTIONS(2222),
    [anon_sym_snorm] = ACTIONS(2222),
    [anon_sym_unorm] = ACTIONS(2222),
    [anon_sym_point] = ACTIONS(2222),
    [anon_sym_line] = ACTIONS(2222),
    [anon_sym_triangleadj] = ACTIONS(2222),
    [anon_sym_lineadj] = ACTIONS(2222),
    [anon_sym_triangle] = ACTIONS(2222),
  },
  [3043] = {
    [sym_identifier] = ACTIONS(2243),
    [anon_sym_LPAREN2] = ACTIONS(2247),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_out] = ACTIONS(2243),
    [anon_sym_inout] = ACTIONS(2243),
    [anon_sym_virtual] = ACTIONS(2243),
    [anon_sym_extern] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym___attribute] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2247),
    [anon_sym___declspec] = ACTIONS(2243),
    [anon_sym___based] = ACTIONS(2243),
    [anon_sym___cdecl] = ACTIONS(2243),
    [anon_sym___clrcall] = ACTIONS(2243),
    [anon_sym___stdcall] = ACTIONS(2243),
    [anon_sym___fastcall] = ACTIONS(2243),
    [anon_sym___thiscall] = ACTIONS(2243),
    [anon_sym___vectorcall] = ACTIONS(2243),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_register] = ACTIONS(2243),
    [anon_sym_inline] = ACTIONS(2243),
    [anon_sym___inline] = ACTIONS(2243),
    [anon_sym___inline__] = ACTIONS(2243),
    [anon_sym___forceinline] = ACTIONS(2243),
    [anon_sym_thread_local] = ACTIONS(2243),
    [anon_sym___thread] = ACTIONS(2243),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym__Nonnull] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [anon_sym_DOT] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2243),
    [anon_sym_let] = ACTIONS(2243),
    [anon_sym_This] = ACTIONS(2243),
    [anon_sym_decltype] = ACTIONS(2243),
    [anon_sym_template] = ACTIONS(2243),
    [anon_sym_operator] = ACTIONS(2243),
    [anon_sym_precise] = ACTIONS(2243),
    [anon_sym_shared] = ACTIONS(2243),
    [anon_sym_groupshared] = ACTIONS(2243),
    [anon_sym_uniform] = ACTIONS(2243),
    [anon_sym_row_major] = ACTIONS(2243),
    [anon_sym_column_major] = ACTIONS(2243),
    [anon_sym_globallycoherent] = ACTIONS(2243),
    [anon_sym_centroid] = ACTIONS(2243),
    [anon_sym_noperspective] = ACTIONS(2243),
    [anon_sym_nointerpolation] = ACTIONS(2243),
    [anon_sym_sample] = ACTIONS(2243),
    [anon_sym_linear] = ACTIONS(2243),
    [anon_sym_snorm] = ACTIONS(2243),
    [anon_sym_unorm] = ACTIONS(2243),
    [anon_sym_point] = ACTIONS(2243),
    [anon_sym_line] = ACTIONS(2243),
    [anon_sym_triangleadj] = ACTIONS(2243),
    [anon_sym_lineadj] = ACTIONS(2243),
    [anon_sym_triangle] = ACTIONS(2243),
  },
  [3044] = {
    [sym_identifier] = ACTIONS(3014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3012),
    [anon_sym_COMMA] = ACTIONS(3012),
    [anon_sym_RPAREN] = ACTIONS(3012),
    [anon_sym_LPAREN2] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_STAR] = ACTIONS(3012),
    [anon_sym_SLASH] = ACTIONS(3014),
    [anon_sym_PERCENT] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_PIPE] = ACTIONS(3014),
    [anon_sym_CARET] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_EQ_EQ] = ACTIONS(3012),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_GT] = ACTIONS(3014),
    [anon_sym_GT_EQ] = ACTIONS(3012),
    [anon_sym_LT_EQ] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(3014),
    [anon_sym_LT_LT] = ACTIONS(3012),
    [anon_sym_GT_GT] = ACTIONS(3012),
    [anon_sym_COLON] = ACTIONS(3012),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym___extension__] = ACTIONS(3014),
    [anon_sym___attribute__] = ACTIONS(3014),
    [anon_sym___attribute] = ACTIONS(3014),
    [anon_sym___based] = ACTIONS(3014),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_RBRACE] = ACTIONS(3012),
    [anon_sym_signed] = ACTIONS(3014),
    [anon_sym_unsigned] = ACTIONS(3014),
    [anon_sym_long] = ACTIONS(3014),
    [anon_sym_short] = ACTIONS(3014),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_RBRACK] = ACTIONS(3012),
    [anon_sym_const] = ACTIONS(3014),
    [anon_sym_constexpr] = ACTIONS(3014),
    [anon_sym_volatile] = ACTIONS(3014),
    [anon_sym_restrict] = ACTIONS(3014),
    [anon_sym___restrict__] = ACTIONS(3014),
    [anon_sym__Atomic] = ACTIONS(3014),
    [anon_sym__Noreturn] = ACTIONS(3014),
    [anon_sym_noreturn] = ACTIONS(3014),
    [anon_sym__Nonnull] = ACTIONS(3014),
    [anon_sym_mutable] = ACTIONS(3014),
    [anon_sym_constinit] = ACTIONS(3014),
    [anon_sym_consteval] = ACTIONS(3014),
    [anon_sym_alignas] = ACTIONS(3014),
    [anon_sym__Alignas] = ACTIONS(3014),
    [sym_primitive_type] = ACTIONS(3014),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_LT_EQ_GT] = ACTIONS(3012),
    [anon_sym_or] = ACTIONS(3014),
    [anon_sym_and] = ACTIONS(3014),
    [anon_sym_bitor] = ACTIONS(3014),
    [anon_sym_xor] = ACTIONS(3014),
    [anon_sym_bitand] = ACTIONS(3014),
    [anon_sym_not_eq] = ACTIONS(3014),
    [anon_sym_is] = ACTIONS(3014),
    [anon_sym_as] = ACTIONS(3014),
    [anon_sym_DASH_DASH] = ACTIONS(3012),
    [anon_sym_PLUS_PLUS] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3014),
    [anon_sym_DOT_STAR] = ACTIONS(3012),
    [anon_sym_DASH_GT] = ACTIONS(3012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3014),
    [anon_sym_let] = ACTIONS(3014),
    [anon_sym_This] = ACTIONS(3014),
    [anon_sym_final] = ACTIONS(3014),
    [anon_sym_override] = ACTIONS(3014),
    [anon_sym_requires] = ACTIONS(3014),
    [anon_sym_where] = ACTIONS(3014),
  },
  [3045] = {
    [sym_identifier] = ACTIONS(3034),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3032),
    [anon_sym_RPAREN] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_SLASH] = ACTIONS(3034),
    [anon_sym_PERCENT] = ACTIONS(3032),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_PIPE] = ACTIONS(3034),
    [anon_sym_CARET] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_EQ_EQ] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_GT] = ACTIONS(3034),
    [anon_sym_GT_EQ] = ACTIONS(3032),
    [anon_sym_LT_EQ] = ACTIONS(3034),
    [anon_sym_LT] = ACTIONS(3034),
    [anon_sym_LT_LT] = ACTIONS(3032),
    [anon_sym_GT_GT] = ACTIONS(3032),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym___attribute] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_RBRACE] = ACTIONS(3032),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_RBRACK] = ACTIONS(3032),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym__Nonnull] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_LT_EQ_GT] = ACTIONS(3032),
    [anon_sym_or] = ACTIONS(3034),
    [anon_sym_and] = ACTIONS(3034),
    [anon_sym_bitor] = ACTIONS(3034),
    [anon_sym_xor] = ACTIONS(3034),
    [anon_sym_bitand] = ACTIONS(3034),
    [anon_sym_not_eq] = ACTIONS(3034),
    [anon_sym_is] = ACTIONS(3034),
    [anon_sym_as] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_PLUS] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3034),
    [anon_sym_DOT_STAR] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3032),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
    [anon_sym_final] = ACTIONS(3034),
    [anon_sym_override] = ACTIONS(3034),
    [anon_sym_requires] = ACTIONS(3034),
    [anon_sym_where] = ACTIONS(3034),
  },
  [3046] = {
    [sym_identifier] = ACTIONS(2964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2962),
    [anon_sym_RPAREN] = ACTIONS(2962),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2964),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_STAR] = ACTIONS(2962),
    [anon_sym_SLASH] = ACTIONS(2964),
    [anon_sym_PERCENT] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_PIPE] = ACTIONS(2964),
    [anon_sym_CARET] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_EQ_EQ] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_GT] = ACTIONS(2964),
    [anon_sym_GT_EQ] = ACTIONS(2962),
    [anon_sym_LT_EQ] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_LT_LT] = ACTIONS(2962),
    [anon_sym_GT_GT] = ACTIONS(2962),
    [anon_sym_COLON] = ACTIONS(2962),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym___extension__] = ACTIONS(2964),
    [anon_sym___attribute__] = ACTIONS(2964),
    [anon_sym___attribute] = ACTIONS(2964),
    [anon_sym___based] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [anon_sym_signed] = ACTIONS(2964),
    [anon_sym_unsigned] = ACTIONS(2964),
    [anon_sym_long] = ACTIONS(2964),
    [anon_sym_short] = ACTIONS(2964),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_RBRACK] = ACTIONS(2962),
    [anon_sym_const] = ACTIONS(2964),
    [anon_sym_constexpr] = ACTIONS(2964),
    [anon_sym_volatile] = ACTIONS(2964),
    [anon_sym_restrict] = ACTIONS(2964),
    [anon_sym___restrict__] = ACTIONS(2964),
    [anon_sym__Atomic] = ACTIONS(2964),
    [anon_sym__Noreturn] = ACTIONS(2964),
    [anon_sym_noreturn] = ACTIONS(2964),
    [anon_sym__Nonnull] = ACTIONS(2964),
    [anon_sym_mutable] = ACTIONS(2964),
    [anon_sym_constinit] = ACTIONS(2964),
    [anon_sym_consteval] = ACTIONS(2964),
    [anon_sym_alignas] = ACTIONS(2964),
    [anon_sym__Alignas] = ACTIONS(2964),
    [sym_primitive_type] = ACTIONS(2964),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_LT_EQ_GT] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2964),
    [anon_sym_and] = ACTIONS(2964),
    [anon_sym_bitor] = ACTIONS(2964),
    [anon_sym_xor] = ACTIONS(2964),
    [anon_sym_bitand] = ACTIONS(2964),
    [anon_sym_not_eq] = ACTIONS(2964),
    [anon_sym_is] = ACTIONS(2964),
    [anon_sym_as] = ACTIONS(2964),
    [anon_sym_DASH_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_PLUS] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2964),
    [anon_sym_DOT_STAR] = ACTIONS(2962),
    [anon_sym_DASH_GT] = ACTIONS(2962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2964),
    [anon_sym_let] = ACTIONS(2964),
    [anon_sym_This] = ACTIONS(2964),
    [anon_sym_final] = ACTIONS(2964),
    [anon_sym_override] = ACTIONS(2964),
    [anon_sym_requires] = ACTIONS(2964),
    [anon_sym_where] = ACTIONS(2964),
  },
  [3047] = {
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_LPAREN2] = ACTIONS(4246),
    [anon_sym_TILDE] = ACTIONS(4246),
    [anon_sym_STAR] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym___extension__] = ACTIONS(4244),
    [anon_sym_in] = ACTIONS(4244),
    [anon_sym_out] = ACTIONS(4244),
    [anon_sym_inout] = ACTIONS(4244),
    [anon_sym_virtual] = ACTIONS(4244),
    [anon_sym_extern] = ACTIONS(4244),
    [anon_sym___attribute__] = ACTIONS(4244),
    [anon_sym___attribute] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4246),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4246),
    [anon_sym___declspec] = ACTIONS(4244),
    [anon_sym___based] = ACTIONS(4244),
    [anon_sym___cdecl] = ACTIONS(4244),
    [anon_sym___clrcall] = ACTIONS(4244),
    [anon_sym___stdcall] = ACTIONS(4244),
    [anon_sym___fastcall] = ACTIONS(4244),
    [anon_sym___thiscall] = ACTIONS(4244),
    [anon_sym___vectorcall] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [anon_sym_static] = ACTIONS(4244),
    [anon_sym_register] = ACTIONS(4244),
    [anon_sym_inline] = ACTIONS(4244),
    [anon_sym___inline] = ACTIONS(4244),
    [anon_sym___inline__] = ACTIONS(4244),
    [anon_sym___forceinline] = ACTIONS(4244),
    [anon_sym_thread_local] = ACTIONS(4244),
    [anon_sym___thread] = ACTIONS(4244),
    [anon_sym_const] = ACTIONS(4244),
    [anon_sym_constexpr] = ACTIONS(4244),
    [anon_sym_volatile] = ACTIONS(4244),
    [anon_sym_restrict] = ACTIONS(4244),
    [anon_sym___restrict__] = ACTIONS(4244),
    [anon_sym__Atomic] = ACTIONS(4244),
    [anon_sym__Noreturn] = ACTIONS(4244),
    [anon_sym_noreturn] = ACTIONS(4244),
    [anon_sym__Nonnull] = ACTIONS(4244),
    [anon_sym_mutable] = ACTIONS(4244),
    [anon_sym_constinit] = ACTIONS(4244),
    [anon_sym_consteval] = ACTIONS(4244),
    [anon_sym_alignas] = ACTIONS(4244),
    [anon_sym__Alignas] = ACTIONS(4244),
    [anon_sym_DOT] = ACTIONS(6957),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6959),
    [anon_sym_let] = ACTIONS(6959),
    [anon_sym_This] = ACTIONS(6959),
    [anon_sym_decltype] = ACTIONS(4244),
    [anon_sym_template] = ACTIONS(4244),
    [anon_sym_operator] = ACTIONS(4244),
    [anon_sym_precise] = ACTIONS(4244),
    [anon_sym_shared] = ACTIONS(4244),
    [anon_sym_groupshared] = ACTIONS(4244),
    [anon_sym_uniform] = ACTIONS(4244),
    [anon_sym_row_major] = ACTIONS(4244),
    [anon_sym_column_major] = ACTIONS(4244),
    [anon_sym_globallycoherent] = ACTIONS(4244),
    [anon_sym_centroid] = ACTIONS(4244),
    [anon_sym_noperspective] = ACTIONS(4244),
    [anon_sym_nointerpolation] = ACTIONS(4244),
    [anon_sym_sample] = ACTIONS(4244),
    [anon_sym_linear] = ACTIONS(4244),
    [anon_sym_snorm] = ACTIONS(4244),
    [anon_sym_unorm] = ACTIONS(4244),
    [anon_sym_point] = ACTIONS(4244),
    [anon_sym_line] = ACTIONS(4244),
    [anon_sym_triangleadj] = ACTIONS(4244),
    [anon_sym_lineadj] = ACTIONS(4244),
    [anon_sym_triangle] = ACTIONS(4244),
  },
  [3048] = {
    [sym_identifier] = ACTIONS(3038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3036),
    [anon_sym_COMMA] = ACTIONS(3036),
    [anon_sym_RPAREN] = ACTIONS(3036),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_SLASH] = ACTIONS(3038),
    [anon_sym_PERCENT] = ACTIONS(3036),
    [anon_sym_PIPE_PIPE] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_PIPE] = ACTIONS(3038),
    [anon_sym_CARET] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym_EQ_EQ] = ACTIONS(3036),
    [anon_sym_BANG_EQ] = ACTIONS(3036),
    [anon_sym_GT] = ACTIONS(3038),
    [anon_sym_GT_EQ] = ACTIONS(3036),
    [anon_sym_LT_EQ] = ACTIONS(3038),
    [anon_sym_LT] = ACTIONS(3038),
    [anon_sym_LT_LT] = ACTIONS(3036),
    [anon_sym_GT_GT] = ACTIONS(3036),
    [anon_sym_COLON] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3038),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym___attribute] = ACTIONS(3038),
    [anon_sym___based] = ACTIONS(3038),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_RBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3038),
    [anon_sym_unsigned] = ACTIONS(3038),
    [anon_sym_long] = ACTIONS(3038),
    [anon_sym_short] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3036),
    [anon_sym_RBRACK] = ACTIONS(3036),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_constexpr] = ACTIONS(3038),
    [anon_sym_volatile] = ACTIONS(3038),
    [anon_sym_restrict] = ACTIONS(3038),
    [anon_sym___restrict__] = ACTIONS(3038),
    [anon_sym__Atomic] = ACTIONS(3038),
    [anon_sym__Noreturn] = ACTIONS(3038),
    [anon_sym_noreturn] = ACTIONS(3038),
    [anon_sym__Nonnull] = ACTIONS(3038),
    [anon_sym_mutable] = ACTIONS(3038),
    [anon_sym_constinit] = ACTIONS(3038),
    [anon_sym_consteval] = ACTIONS(3038),
    [anon_sym_alignas] = ACTIONS(3038),
    [anon_sym__Alignas] = ACTIONS(3038),
    [sym_primitive_type] = ACTIONS(3038),
    [anon_sym_QMARK] = ACTIONS(3036),
    [anon_sym_LT_EQ_GT] = ACTIONS(3036),
    [anon_sym_or] = ACTIONS(3038),
    [anon_sym_and] = ACTIONS(3038),
    [anon_sym_bitor] = ACTIONS(3038),
    [anon_sym_xor] = ACTIONS(3038),
    [anon_sym_bitand] = ACTIONS(3038),
    [anon_sym_not_eq] = ACTIONS(3038),
    [anon_sym_is] = ACTIONS(3038),
    [anon_sym_as] = ACTIONS(3038),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_DOT] = ACTIONS(3038),
    [anon_sym_DOT_STAR] = ACTIONS(3036),
    [anon_sym_DASH_GT] = ACTIONS(3036),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3038),
    [anon_sym_let] = ACTIONS(3038),
    [anon_sym_This] = ACTIONS(3038),
    [anon_sym_final] = ACTIONS(3038),
    [anon_sym_override] = ACTIONS(3038),
    [anon_sym_requires] = ACTIONS(3038),
    [anon_sym_where] = ACTIONS(3038),
  },
  [3049] = {
    [sym_template_argument_list] = STATE(3073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2224),
    [anon_sym_COMMA] = ACTIONS(2224),
    [anon_sym_RPAREN] = ACTIONS(2226),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2231),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_PIPE_PIPE] = ACTIONS(2224),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_EQ_EQ] = ACTIONS(2224),
    [anon_sym_BANG_EQ] = ACTIONS(2224),
    [anon_sym_GT] = ACTIONS(2234),
    [anon_sym_GT_EQ] = ACTIONS(2224),
    [anon_sym_LT_EQ] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(7261),
    [anon_sym_LT_LT] = ACTIONS(2234),
    [anon_sym_GT_GT] = ACTIONS(2234),
    [anon_sym___extension__] = ACTIONS(2229),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2229),
    [anon_sym_volatile] = ACTIONS(2229),
    [anon_sym_restrict] = ACTIONS(2229),
    [anon_sym___restrict__] = ACTIONS(2229),
    [anon_sym__Atomic] = ACTIONS(2229),
    [anon_sym__Noreturn] = ACTIONS(2229),
    [anon_sym_noreturn] = ACTIONS(2229),
    [anon_sym__Nonnull] = ACTIONS(2229),
    [anon_sym_mutable] = ACTIONS(2229),
    [anon_sym_constinit] = ACTIONS(2229),
    [anon_sym_consteval] = ACTIONS(2229),
    [anon_sym_alignas] = ACTIONS(2229),
    [anon_sym__Alignas] = ACTIONS(2229),
    [anon_sym_QMARK] = ACTIONS(2224),
    [anon_sym_STAR_EQ] = ACTIONS(2224),
    [anon_sym_SLASH_EQ] = ACTIONS(2224),
    [anon_sym_PERCENT_EQ] = ACTIONS(2224),
    [anon_sym_PLUS_EQ] = ACTIONS(2224),
    [anon_sym_DASH_EQ] = ACTIONS(2224),
    [anon_sym_LT_LT_EQ] = ACTIONS(2224),
    [anon_sym_GT_GT_EQ] = ACTIONS(2224),
    [anon_sym_AMP_EQ] = ACTIONS(2224),
    [anon_sym_CARET_EQ] = ACTIONS(2224),
    [anon_sym_PIPE_EQ] = ACTIONS(2224),
    [anon_sym_and_eq] = ACTIONS(2224),
    [anon_sym_or_eq] = ACTIONS(2224),
    [anon_sym_xor_eq] = ACTIONS(2224),
    [anon_sym_LT_EQ_GT] = ACTIONS(2224),
    [anon_sym_or] = ACTIONS(2234),
    [anon_sym_and] = ACTIONS(2234),
    [anon_sym_bitor] = ACTIONS(2224),
    [anon_sym_xor] = ACTIONS(2234),
    [anon_sym_bitand] = ACTIONS(2224),
    [anon_sym_not_eq] = ACTIONS(2224),
    [anon_sym_is] = ACTIONS(2224),
    [anon_sym_as] = ACTIONS(2224),
    [anon_sym_DASH_DASH] = ACTIONS(2224),
    [anon_sym_PLUS_PLUS] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(2231),
    [anon_sym_DOT_STAR] = ACTIONS(2224),
    [anon_sym_DASH_GT] = ACTIONS(2234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2229),
    [anon_sym_let] = ACTIONS(2229),
    [anon_sym_This] = ACTIONS(2229),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2224),
  },
  [3050] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2693),
    [sym_identifier] = ACTIONS(2915),
    [anon_sym_COMMA] = ACTIONS(4121),
    [anon_sym_RPAREN] = ACTIONS(4121),
    [anon_sym_LPAREN2] = ACTIONS(4121),
    [anon_sym_STAR] = ACTIONS(4121),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_AMP] = ACTIONS(4124),
    [anon_sym___extension__] = ACTIONS(4124),
    [anon_sym_in] = ACTIONS(4124),
    [anon_sym_out] = ACTIONS(4124),
    [anon_sym_inout] = ACTIONS(4124),
    [anon_sym_virtual] = ACTIONS(4124),
    [anon_sym_extern] = ACTIONS(4124),
    [anon_sym___attribute__] = ACTIONS(4124),
    [anon_sym___attribute] = ACTIONS(4124),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4121),
    [anon_sym___declspec] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_signed] = ACTIONS(6775),
    [anon_sym_unsigned] = ACTIONS(6775),
    [anon_sym_long] = ACTIONS(6775),
    [anon_sym_short] = ACTIONS(6775),
    [anon_sym_LBRACK] = ACTIONS(4124),
    [anon_sym_static] = ACTIONS(4124),
    [anon_sym_register] = ACTIONS(4124),
    [anon_sym_inline] = ACTIONS(4124),
    [anon_sym___inline] = ACTIONS(4124),
    [anon_sym___inline__] = ACTIONS(4124),
    [anon_sym___forceinline] = ACTIONS(4124),
    [anon_sym_thread_local] = ACTIONS(4124),
    [anon_sym___thread] = ACTIONS(4124),
    [anon_sym_const] = ACTIONS(4124),
    [anon_sym_constexpr] = ACTIONS(4124),
    [anon_sym_volatile] = ACTIONS(4124),
    [anon_sym_restrict] = ACTIONS(4124),
    [anon_sym___restrict__] = ACTIONS(4124),
    [anon_sym__Atomic] = ACTIONS(4124),
    [anon_sym__Noreturn] = ACTIONS(4124),
    [anon_sym_noreturn] = ACTIONS(4124),
    [anon_sym__Nonnull] = ACTIONS(4124),
    [anon_sym_mutable] = ACTIONS(4124),
    [anon_sym_constinit] = ACTIONS(4124),
    [anon_sym_consteval] = ACTIONS(4124),
    [anon_sym_alignas] = ACTIONS(4124),
    [anon_sym__Alignas] = ACTIONS(4124),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_DOT] = ACTIONS(4121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4124),
    [anon_sym_let] = ACTIONS(4124),
    [anon_sym_This] = ACTIONS(4124),
    [anon_sym_final] = ACTIONS(4124),
    [anon_sym_override] = ACTIONS(4124),
    [anon_sym_requires] = ACTIONS(4124),
    [anon_sym_precise] = ACTIONS(4124),
    [anon_sym_shared] = ACTIONS(4124),
    [anon_sym_groupshared] = ACTIONS(4124),
    [anon_sym_uniform] = ACTIONS(4124),
    [anon_sym_row_major] = ACTIONS(4124),
    [anon_sym_column_major] = ACTIONS(4124),
    [anon_sym_globallycoherent] = ACTIONS(4124),
    [anon_sym_centroid] = ACTIONS(4124),
    [anon_sym_noperspective] = ACTIONS(4124),
    [anon_sym_nointerpolation] = ACTIONS(4124),
    [anon_sym_sample] = ACTIONS(4124),
    [anon_sym_linear] = ACTIONS(4124),
    [anon_sym_snorm] = ACTIONS(4124),
    [anon_sym_unorm] = ACTIONS(4124),
    [anon_sym_point] = ACTIONS(4124),
    [anon_sym_line] = ACTIONS(4124),
    [anon_sym_triangleadj] = ACTIONS(4124),
    [anon_sym_lineadj] = ACTIONS(4124),
    [anon_sym_triangle] = ACTIONS(4124),
    [anon_sym_where] = ACTIONS(4124),
  },
  [3051] = {
    [sym_identifier] = ACTIONS(2550),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2548),
    [anon_sym_COMMA] = ACTIONS(2548),
    [anon_sym_RPAREN] = ACTIONS(2548),
    [anon_sym_LPAREN2] = ACTIONS(2548),
    [anon_sym_DASH] = ACTIONS(2550),
    [anon_sym_PLUS] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(2548),
    [anon_sym_SLASH] = ACTIONS(2550),
    [anon_sym_PERCENT] = ACTIONS(2548),
    [anon_sym_PIPE_PIPE] = ACTIONS(2548),
    [anon_sym_AMP_AMP] = ACTIONS(2548),
    [anon_sym_PIPE] = ACTIONS(2550),
    [anon_sym_CARET] = ACTIONS(2548),
    [anon_sym_AMP] = ACTIONS(2550),
    [anon_sym_EQ_EQ] = ACTIONS(2548),
    [anon_sym_BANG_EQ] = ACTIONS(2548),
    [anon_sym_GT] = ACTIONS(2550),
    [anon_sym_GT_EQ] = ACTIONS(2548),
    [anon_sym_LT_EQ] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(2550),
    [anon_sym_LT_LT] = ACTIONS(2548),
    [anon_sym_GT_GT] = ACTIONS(2548),
    [anon_sym_COLON] = ACTIONS(2548),
    [anon_sym_SEMI] = ACTIONS(2548),
    [anon_sym___extension__] = ACTIONS(2550),
    [anon_sym___attribute__] = ACTIONS(2550),
    [anon_sym___attribute] = ACTIONS(2550),
    [anon_sym___based] = ACTIONS(2550),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_RBRACE] = ACTIONS(2548),
    [anon_sym_signed] = ACTIONS(2550),
    [anon_sym_unsigned] = ACTIONS(2550),
    [anon_sym_long] = ACTIONS(2550),
    [anon_sym_short] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2548),
    [anon_sym_RBRACK] = ACTIONS(2548),
    [anon_sym_const] = ACTIONS(2550),
    [anon_sym_constexpr] = ACTIONS(2550),
    [anon_sym_volatile] = ACTIONS(2550),
    [anon_sym_restrict] = ACTIONS(2550),
    [anon_sym___restrict__] = ACTIONS(2550),
    [anon_sym__Atomic] = ACTIONS(2550),
    [anon_sym__Noreturn] = ACTIONS(2550),
    [anon_sym_noreturn] = ACTIONS(2550),
    [anon_sym__Nonnull] = ACTIONS(2550),
    [anon_sym_mutable] = ACTIONS(2550),
    [anon_sym_constinit] = ACTIONS(2550),
    [anon_sym_consteval] = ACTIONS(2550),
    [anon_sym_alignas] = ACTIONS(2550),
    [anon_sym__Alignas] = ACTIONS(2550),
    [sym_primitive_type] = ACTIONS(2550),
    [anon_sym_QMARK] = ACTIONS(2548),
    [anon_sym_LT_EQ_GT] = ACTIONS(2548),
    [anon_sym_or] = ACTIONS(2550),
    [anon_sym_and] = ACTIONS(2550),
    [anon_sym_bitor] = ACTIONS(2550),
    [anon_sym_xor] = ACTIONS(2550),
    [anon_sym_bitand] = ACTIONS(2550),
    [anon_sym_not_eq] = ACTIONS(2550),
    [anon_sym_is] = ACTIONS(2550),
    [anon_sym_as] = ACTIONS(2550),
    [anon_sym_DASH_DASH] = ACTIONS(2548),
    [anon_sym_PLUS_PLUS] = ACTIONS(2548),
    [anon_sym_DOT] = ACTIONS(2550),
    [anon_sym_DOT_STAR] = ACTIONS(2548),
    [anon_sym_DASH_GT] = ACTIONS(2548),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(2550),
    [anon_sym_This] = ACTIONS(2550),
    [anon_sym_final] = ACTIONS(2550),
    [anon_sym_override] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2550),
    [anon_sym_where] = ACTIONS(2550),
  },
  [3052] = {
    [sym_identifier] = ACTIONS(3042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3040),
    [anon_sym_COMMA] = ACTIONS(3040),
    [anon_sym_RPAREN] = ACTIONS(3040),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_SLASH] = ACTIONS(3042),
    [anon_sym_PERCENT] = ACTIONS(3040),
    [anon_sym_PIPE_PIPE] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_PIPE] = ACTIONS(3042),
    [anon_sym_CARET] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_EQ_EQ] = ACTIONS(3040),
    [anon_sym_BANG_EQ] = ACTIONS(3040),
    [anon_sym_GT] = ACTIONS(3042),
    [anon_sym_GT_EQ] = ACTIONS(3040),
    [anon_sym_LT_EQ] = ACTIONS(3042),
    [anon_sym_LT] = ACTIONS(3042),
    [anon_sym_LT_LT] = ACTIONS(3040),
    [anon_sym_GT_GT] = ACTIONS(3040),
    [anon_sym_COLON] = ACTIONS(3040),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_RBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3040),
    [anon_sym_RBRACK] = ACTIONS(3040),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_QMARK] = ACTIONS(3040),
    [anon_sym_LT_EQ_GT] = ACTIONS(3040),
    [anon_sym_or] = ACTIONS(3042),
    [anon_sym_and] = ACTIONS(3042),
    [anon_sym_bitor] = ACTIONS(3042),
    [anon_sym_xor] = ACTIONS(3042),
    [anon_sym_bitand] = ACTIONS(3042),
    [anon_sym_not_eq] = ACTIONS(3042),
    [anon_sym_is] = ACTIONS(3042),
    [anon_sym_as] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_DOT] = ACTIONS(3042),
    [anon_sym_DOT_STAR] = ACTIONS(3040),
    [anon_sym_DASH_GT] = ACTIONS(3040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3042),
    [anon_sym_let] = ACTIONS(3042),
    [anon_sym_This] = ACTIONS(3042),
    [anon_sym_final] = ACTIONS(3042),
    [anon_sym_override] = ACTIONS(3042),
    [anon_sym_requires] = ACTIONS(3042),
    [anon_sym_where] = ACTIONS(3042),
  },
  [3053] = {
    [sym_identifier] = ACTIONS(3046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3044),
    [anon_sym_COMMA] = ACTIONS(3044),
    [anon_sym_RPAREN] = ACTIONS(3044),
    [anon_sym_LPAREN2] = ACTIONS(3044),
    [anon_sym_DASH] = ACTIONS(3046),
    [anon_sym_PLUS] = ACTIONS(3046),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_SLASH] = ACTIONS(3046),
    [anon_sym_PERCENT] = ACTIONS(3044),
    [anon_sym_PIPE_PIPE] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3044),
    [anon_sym_PIPE] = ACTIONS(3046),
    [anon_sym_CARET] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3046),
    [anon_sym_EQ_EQ] = ACTIONS(3044),
    [anon_sym_BANG_EQ] = ACTIONS(3044),
    [anon_sym_GT] = ACTIONS(3046),
    [anon_sym_GT_EQ] = ACTIONS(3044),
    [anon_sym_LT_EQ] = ACTIONS(3046),
    [anon_sym_LT] = ACTIONS(3046),
    [anon_sym_LT_LT] = ACTIONS(3044),
    [anon_sym_GT_GT] = ACTIONS(3044),
    [anon_sym_COLON] = ACTIONS(3044),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym___extension__] = ACTIONS(3046),
    [anon_sym___attribute__] = ACTIONS(3046),
    [anon_sym___attribute] = ACTIONS(3046),
    [anon_sym___based] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3044),
    [anon_sym_RBRACE] = ACTIONS(3044),
    [anon_sym_signed] = ACTIONS(3046),
    [anon_sym_unsigned] = ACTIONS(3046),
    [anon_sym_long] = ACTIONS(3046),
    [anon_sym_short] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3044),
    [anon_sym_RBRACK] = ACTIONS(3044),
    [anon_sym_const] = ACTIONS(3046),
    [anon_sym_constexpr] = ACTIONS(3046),
    [anon_sym_volatile] = ACTIONS(3046),
    [anon_sym_restrict] = ACTIONS(3046),
    [anon_sym___restrict__] = ACTIONS(3046),
    [anon_sym__Atomic] = ACTIONS(3046),
    [anon_sym__Noreturn] = ACTIONS(3046),
    [anon_sym_noreturn] = ACTIONS(3046),
    [anon_sym__Nonnull] = ACTIONS(3046),
    [anon_sym_mutable] = ACTIONS(3046),
    [anon_sym_constinit] = ACTIONS(3046),
    [anon_sym_consteval] = ACTIONS(3046),
    [anon_sym_alignas] = ACTIONS(3046),
    [anon_sym__Alignas] = ACTIONS(3046),
    [sym_primitive_type] = ACTIONS(3046),
    [anon_sym_QMARK] = ACTIONS(3044),
    [anon_sym_LT_EQ_GT] = ACTIONS(3044),
    [anon_sym_or] = ACTIONS(3046),
    [anon_sym_and] = ACTIONS(3046),
    [anon_sym_bitor] = ACTIONS(3046),
    [anon_sym_xor] = ACTIONS(3046),
    [anon_sym_bitand] = ACTIONS(3046),
    [anon_sym_not_eq] = ACTIONS(3046),
    [anon_sym_is] = ACTIONS(3046),
    [anon_sym_as] = ACTIONS(3046),
    [anon_sym_DASH_DASH] = ACTIONS(3044),
    [anon_sym_PLUS_PLUS] = ACTIONS(3044),
    [anon_sym_DOT] = ACTIONS(3046),
    [anon_sym_DOT_STAR] = ACTIONS(3044),
    [anon_sym_DASH_GT] = ACTIONS(3044),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3046),
    [anon_sym_let] = ACTIONS(3046),
    [anon_sym_This] = ACTIONS(3046),
    [anon_sym_final] = ACTIONS(3046),
    [anon_sym_override] = ACTIONS(3046),
    [anon_sym_requires] = ACTIONS(3046),
    [anon_sym_where] = ACTIONS(3046),
  },
  [3054] = {
    [sym_identifier] = ACTIONS(3030),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3028),
    [anon_sym_COMMA] = ACTIONS(3028),
    [anon_sym_RPAREN] = ACTIONS(3028),
    [anon_sym_LPAREN2] = ACTIONS(3028),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3028),
    [anon_sym_SLASH] = ACTIONS(3030),
    [anon_sym_PERCENT] = ACTIONS(3028),
    [anon_sym_PIPE_PIPE] = ACTIONS(3028),
    [anon_sym_AMP_AMP] = ACTIONS(3028),
    [anon_sym_PIPE] = ACTIONS(3030),
    [anon_sym_CARET] = ACTIONS(3028),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_EQ_EQ] = ACTIONS(3028),
    [anon_sym_BANG_EQ] = ACTIONS(3028),
    [anon_sym_GT] = ACTIONS(3030),
    [anon_sym_GT_EQ] = ACTIONS(3028),
    [anon_sym_LT_EQ] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_LT_LT] = ACTIONS(3028),
    [anon_sym_GT_GT] = ACTIONS(3028),
    [anon_sym_COLON] = ACTIONS(3028),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym___extension__] = ACTIONS(3030),
    [anon_sym___attribute__] = ACTIONS(3030),
    [anon_sym___attribute] = ACTIONS(3030),
    [anon_sym___based] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3028),
    [anon_sym_RBRACE] = ACTIONS(3028),
    [anon_sym_signed] = ACTIONS(3030),
    [anon_sym_unsigned] = ACTIONS(3030),
    [anon_sym_long] = ACTIONS(3030),
    [anon_sym_short] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3028),
    [anon_sym_RBRACK] = ACTIONS(3028),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_constexpr] = ACTIONS(3030),
    [anon_sym_volatile] = ACTIONS(3030),
    [anon_sym_restrict] = ACTIONS(3030),
    [anon_sym___restrict__] = ACTIONS(3030),
    [anon_sym__Atomic] = ACTIONS(3030),
    [anon_sym__Noreturn] = ACTIONS(3030),
    [anon_sym_noreturn] = ACTIONS(3030),
    [anon_sym__Nonnull] = ACTIONS(3030),
    [anon_sym_mutable] = ACTIONS(3030),
    [anon_sym_constinit] = ACTIONS(3030),
    [anon_sym_consteval] = ACTIONS(3030),
    [anon_sym_alignas] = ACTIONS(3030),
    [anon_sym__Alignas] = ACTIONS(3030),
    [sym_primitive_type] = ACTIONS(3030),
    [anon_sym_QMARK] = ACTIONS(3028),
    [anon_sym_LT_EQ_GT] = ACTIONS(3028),
    [anon_sym_or] = ACTIONS(3030),
    [anon_sym_and] = ACTIONS(3030),
    [anon_sym_bitor] = ACTIONS(3030),
    [anon_sym_xor] = ACTIONS(3030),
    [anon_sym_bitand] = ACTIONS(3030),
    [anon_sym_not_eq] = ACTIONS(3030),
    [anon_sym_is] = ACTIONS(3030),
    [anon_sym_as] = ACTIONS(3030),
    [anon_sym_DASH_DASH] = ACTIONS(3028),
    [anon_sym_PLUS_PLUS] = ACTIONS(3028),
    [anon_sym_DOT] = ACTIONS(3030),
    [anon_sym_DOT_STAR] = ACTIONS(3028),
    [anon_sym_DASH_GT] = ACTIONS(3028),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3030),
    [anon_sym_let] = ACTIONS(3030),
    [anon_sym_This] = ACTIONS(3030),
    [anon_sym_final] = ACTIONS(3030),
    [anon_sym_override] = ACTIONS(3030),
    [anon_sym_requires] = ACTIONS(3030),
    [anon_sym_where] = ACTIONS(3030),
  },
  [3055] = {
    [sym_identifier] = ACTIONS(2938),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_RPAREN] = ACTIONS(2936),
    [anon_sym_LPAREN2] = ACTIONS(2936),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_STAR] = ACTIONS(2936),
    [anon_sym_SLASH] = ACTIONS(2938),
    [anon_sym_PERCENT] = ACTIONS(2936),
    [anon_sym_PIPE_PIPE] = ACTIONS(2936),
    [anon_sym_AMP_AMP] = ACTIONS(2936),
    [anon_sym_PIPE] = ACTIONS(2938),
    [anon_sym_CARET] = ACTIONS(2936),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_EQ_EQ] = ACTIONS(2936),
    [anon_sym_BANG_EQ] = ACTIONS(2936),
    [anon_sym_GT] = ACTIONS(2938),
    [anon_sym_GT_EQ] = ACTIONS(2936),
    [anon_sym_LT_EQ] = ACTIONS(2938),
    [anon_sym_LT] = ACTIONS(2938),
    [anon_sym_LT_LT] = ACTIONS(2936),
    [anon_sym_GT_GT] = ACTIONS(2936),
    [anon_sym_COLON] = ACTIONS(2936),
    [anon_sym_SEMI] = ACTIONS(2936),
    [anon_sym___extension__] = ACTIONS(2938),
    [anon_sym___attribute__] = ACTIONS(2938),
    [anon_sym___attribute] = ACTIONS(2938),
    [anon_sym___based] = ACTIONS(2938),
    [anon_sym_LBRACE] = ACTIONS(2936),
    [anon_sym_RBRACE] = ACTIONS(2936),
    [anon_sym_signed] = ACTIONS(2938),
    [anon_sym_unsigned] = ACTIONS(2938),
    [anon_sym_long] = ACTIONS(2938),
    [anon_sym_short] = ACTIONS(2938),
    [anon_sym_LBRACK] = ACTIONS(2936),
    [anon_sym_RBRACK] = ACTIONS(2936),
    [anon_sym_const] = ACTIONS(2938),
    [anon_sym_constexpr] = ACTIONS(2938),
    [anon_sym_volatile] = ACTIONS(2938),
    [anon_sym_restrict] = ACTIONS(2938),
    [anon_sym___restrict__] = ACTIONS(2938),
    [anon_sym__Atomic] = ACTIONS(2938),
    [anon_sym__Noreturn] = ACTIONS(2938),
    [anon_sym_noreturn] = ACTIONS(2938),
    [anon_sym__Nonnull] = ACTIONS(2938),
    [anon_sym_mutable] = ACTIONS(2938),
    [anon_sym_constinit] = ACTIONS(2938),
    [anon_sym_consteval] = ACTIONS(2938),
    [anon_sym_alignas] = ACTIONS(2938),
    [anon_sym__Alignas] = ACTIONS(2938),
    [sym_primitive_type] = ACTIONS(2938),
    [anon_sym_QMARK] = ACTIONS(2936),
    [anon_sym_LT_EQ_GT] = ACTIONS(2936),
    [anon_sym_or] = ACTIONS(2938),
    [anon_sym_and] = ACTIONS(2938),
    [anon_sym_bitor] = ACTIONS(2938),
    [anon_sym_xor] = ACTIONS(2938),
    [anon_sym_bitand] = ACTIONS(2938),
    [anon_sym_not_eq] = ACTIONS(2938),
    [anon_sym_is] = ACTIONS(2938),
    [anon_sym_as] = ACTIONS(2938),
    [anon_sym_DASH_DASH] = ACTIONS(2936),
    [anon_sym_PLUS_PLUS] = ACTIONS(2936),
    [anon_sym_DOT] = ACTIONS(2938),
    [anon_sym_DOT_STAR] = ACTIONS(2936),
    [anon_sym_DASH_GT] = ACTIONS(2936),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2938),
    [anon_sym_let] = ACTIONS(2938),
    [anon_sym_This] = ACTIONS(2938),
    [anon_sym_final] = ACTIONS(2938),
    [anon_sym_override] = ACTIONS(2938),
    [anon_sym_requires] = ACTIONS(2938),
    [anon_sym_where] = ACTIONS(2938),
  },
  [3056] = {
    [sym_identifier] = ACTIONS(2942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2940),
    [anon_sym_COMMA] = ACTIONS(2940),
    [anon_sym_RPAREN] = ACTIONS(2940),
    [anon_sym_LPAREN2] = ACTIONS(2940),
    [anon_sym_DASH] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(2940),
    [anon_sym_SLASH] = ACTIONS(2942),
    [anon_sym_PERCENT] = ACTIONS(2940),
    [anon_sym_PIPE_PIPE] = ACTIONS(2940),
    [anon_sym_AMP_AMP] = ACTIONS(2940),
    [anon_sym_PIPE] = ACTIONS(2942),
    [anon_sym_CARET] = ACTIONS(2940),
    [anon_sym_AMP] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2940),
    [anon_sym_BANG_EQ] = ACTIONS(2940),
    [anon_sym_GT] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2940),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_LT] = ACTIONS(2942),
    [anon_sym_LT_LT] = ACTIONS(2940),
    [anon_sym_GT_GT] = ACTIONS(2940),
    [anon_sym_COLON] = ACTIONS(2940),
    [anon_sym_SEMI] = ACTIONS(2940),
    [anon_sym___extension__] = ACTIONS(2942),
    [anon_sym___attribute__] = ACTIONS(2942),
    [anon_sym___attribute] = ACTIONS(2942),
    [anon_sym___based] = ACTIONS(2942),
    [anon_sym_LBRACE] = ACTIONS(2940),
    [anon_sym_RBRACE] = ACTIONS(2940),
    [anon_sym_signed] = ACTIONS(2942),
    [anon_sym_unsigned] = ACTIONS(2942),
    [anon_sym_long] = ACTIONS(2942),
    [anon_sym_short] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(2940),
    [anon_sym_RBRACK] = ACTIONS(2940),
    [anon_sym_const] = ACTIONS(2942),
    [anon_sym_constexpr] = ACTIONS(2942),
    [anon_sym_volatile] = ACTIONS(2942),
    [anon_sym_restrict] = ACTIONS(2942),
    [anon_sym___restrict__] = ACTIONS(2942),
    [anon_sym__Atomic] = ACTIONS(2942),
    [anon_sym__Noreturn] = ACTIONS(2942),
    [anon_sym_noreturn] = ACTIONS(2942),
    [anon_sym__Nonnull] = ACTIONS(2942),
    [anon_sym_mutable] = ACTIONS(2942),
    [anon_sym_constinit] = ACTIONS(2942),
    [anon_sym_consteval] = ACTIONS(2942),
    [anon_sym_alignas] = ACTIONS(2942),
    [anon_sym__Alignas] = ACTIONS(2942),
    [sym_primitive_type] = ACTIONS(2942),
    [anon_sym_QMARK] = ACTIONS(2940),
    [anon_sym_LT_EQ_GT] = ACTIONS(2940),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_bitor] = ACTIONS(2942),
    [anon_sym_xor] = ACTIONS(2942),
    [anon_sym_bitand] = ACTIONS(2942),
    [anon_sym_not_eq] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_as] = ACTIONS(2942),
    [anon_sym_DASH_DASH] = ACTIONS(2940),
    [anon_sym_PLUS_PLUS] = ACTIONS(2940),
    [anon_sym_DOT] = ACTIONS(2942),
    [anon_sym_DOT_STAR] = ACTIONS(2940),
    [anon_sym_DASH_GT] = ACTIONS(2940),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2942),
    [anon_sym_let] = ACTIONS(2942),
    [anon_sym_This] = ACTIONS(2942),
    [anon_sym_final] = ACTIONS(2942),
    [anon_sym_override] = ACTIONS(2942),
    [anon_sym_requires] = ACTIONS(2942),
    [anon_sym_where] = ACTIONS(2942),
  },
  [3057] = {
    [sym_identifier] = ACTIONS(2994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(2992),
    [anon_sym_RPAREN] = ACTIONS(2992),
    [anon_sym_LPAREN2] = ACTIONS(2992),
    [anon_sym_DASH] = ACTIONS(2994),
    [anon_sym_PLUS] = ACTIONS(2994),
    [anon_sym_STAR] = ACTIONS(2992),
    [anon_sym_SLASH] = ACTIONS(2994),
    [anon_sym_PERCENT] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_PIPE] = ACTIONS(2994),
    [anon_sym_CARET] = ACTIONS(2992),
    [anon_sym_AMP] = ACTIONS(2994),
    [anon_sym_EQ_EQ] = ACTIONS(2992),
    [anon_sym_BANG_EQ] = ACTIONS(2992),
    [anon_sym_GT] = ACTIONS(2994),
    [anon_sym_GT_EQ] = ACTIONS(2992),
    [anon_sym_LT_EQ] = ACTIONS(2994),
    [anon_sym_LT] = ACTIONS(2994),
    [anon_sym_LT_LT] = ACTIONS(2992),
    [anon_sym_GT_GT] = ACTIONS(2992),
    [anon_sym_COLON] = ACTIONS(2992),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym___extension__] = ACTIONS(2994),
    [anon_sym___attribute__] = ACTIONS(2994),
    [anon_sym___attribute] = ACTIONS(2994),
    [anon_sym___based] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_RBRACE] = ACTIONS(2992),
    [anon_sym_signed] = ACTIONS(2994),
    [anon_sym_unsigned] = ACTIONS(2994),
    [anon_sym_long] = ACTIONS(2994),
    [anon_sym_short] = ACTIONS(2994),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_RBRACK] = ACTIONS(2992),
    [anon_sym_const] = ACTIONS(2994),
    [anon_sym_constexpr] = ACTIONS(2994),
    [anon_sym_volatile] = ACTIONS(2994),
    [anon_sym_restrict] = ACTIONS(2994),
    [anon_sym___restrict__] = ACTIONS(2994),
    [anon_sym__Atomic] = ACTIONS(2994),
    [anon_sym__Noreturn] = ACTIONS(2994),
    [anon_sym_noreturn] = ACTIONS(2994),
    [anon_sym__Nonnull] = ACTIONS(2994),
    [anon_sym_mutable] = ACTIONS(2994),
    [anon_sym_constinit] = ACTIONS(2994),
    [anon_sym_consteval] = ACTIONS(2994),
    [anon_sym_alignas] = ACTIONS(2994),
    [anon_sym__Alignas] = ACTIONS(2994),
    [sym_primitive_type] = ACTIONS(2994),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_LT_EQ_GT] = ACTIONS(2992),
    [anon_sym_or] = ACTIONS(2994),
    [anon_sym_and] = ACTIONS(2994),
    [anon_sym_bitor] = ACTIONS(2994),
    [anon_sym_xor] = ACTIONS(2994),
    [anon_sym_bitand] = ACTIONS(2994),
    [anon_sym_not_eq] = ACTIONS(2994),
    [anon_sym_is] = ACTIONS(2994),
    [anon_sym_as] = ACTIONS(2994),
    [anon_sym_DASH_DASH] = ACTIONS(2992),
    [anon_sym_PLUS_PLUS] = ACTIONS(2992),
    [anon_sym_DOT] = ACTIONS(2994),
    [anon_sym_DOT_STAR] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(2992),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2994),
    [anon_sym_let] = ACTIONS(2994),
    [anon_sym_This] = ACTIONS(2994),
    [anon_sym_final] = ACTIONS(2994),
    [anon_sym_override] = ACTIONS(2994),
    [anon_sym_requires] = ACTIONS(2994),
    [anon_sym_where] = ACTIONS(2994),
  },
  [3058] = {
    [sym_identifier] = ACTIONS(3050),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3048),
    [anon_sym_COMMA] = ACTIONS(3048),
    [anon_sym_RPAREN] = ACTIONS(3048),
    [anon_sym_LPAREN2] = ACTIONS(3048),
    [anon_sym_DASH] = ACTIONS(3050),
    [anon_sym_PLUS] = ACTIONS(3050),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_SLASH] = ACTIONS(3050),
    [anon_sym_PERCENT] = ACTIONS(3048),
    [anon_sym_PIPE_PIPE] = ACTIONS(3048),
    [anon_sym_AMP_AMP] = ACTIONS(3048),
    [anon_sym_PIPE] = ACTIONS(3050),
    [anon_sym_CARET] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3050),
    [anon_sym_EQ_EQ] = ACTIONS(3048),
    [anon_sym_BANG_EQ] = ACTIONS(3048),
    [anon_sym_GT] = ACTIONS(3050),
    [anon_sym_GT_EQ] = ACTIONS(3048),
    [anon_sym_LT_EQ] = ACTIONS(3050),
    [anon_sym_LT] = ACTIONS(3050),
    [anon_sym_LT_LT] = ACTIONS(3048),
    [anon_sym_GT_GT] = ACTIONS(3048),
    [anon_sym_COLON] = ACTIONS(3048),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym___extension__] = ACTIONS(3050),
    [anon_sym___attribute__] = ACTIONS(3050),
    [anon_sym___attribute] = ACTIONS(3050),
    [anon_sym___based] = ACTIONS(3050),
    [anon_sym_LBRACE] = ACTIONS(3048),
    [anon_sym_RBRACE] = ACTIONS(3048),
    [anon_sym_signed] = ACTIONS(3050),
    [anon_sym_unsigned] = ACTIONS(3050),
    [anon_sym_long] = ACTIONS(3050),
    [anon_sym_short] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3048),
    [anon_sym_RBRACK] = ACTIONS(3048),
    [anon_sym_const] = ACTIONS(3050),
    [anon_sym_constexpr] = ACTIONS(3050),
    [anon_sym_volatile] = ACTIONS(3050),
    [anon_sym_restrict] = ACTIONS(3050),
    [anon_sym___restrict__] = ACTIONS(3050),
    [anon_sym__Atomic] = ACTIONS(3050),
    [anon_sym__Noreturn] = ACTIONS(3050),
    [anon_sym_noreturn] = ACTIONS(3050),
    [anon_sym__Nonnull] = ACTIONS(3050),
    [anon_sym_mutable] = ACTIONS(3050),
    [anon_sym_constinit] = ACTIONS(3050),
    [anon_sym_consteval] = ACTIONS(3050),
    [anon_sym_alignas] = ACTIONS(3050),
    [anon_sym__Alignas] = ACTIONS(3050),
    [sym_primitive_type] = ACTIONS(3050),
    [anon_sym_QMARK] = ACTIONS(3048),
    [anon_sym_LT_EQ_GT] = ACTIONS(3048),
    [anon_sym_or] = ACTIONS(3050),
    [anon_sym_and] = ACTIONS(3050),
    [anon_sym_bitor] = ACTIONS(3050),
    [anon_sym_xor] = ACTIONS(3050),
    [anon_sym_bitand] = ACTIONS(3050),
    [anon_sym_not_eq] = ACTIONS(3050),
    [anon_sym_is] = ACTIONS(3050),
    [anon_sym_as] = ACTIONS(3050),
    [anon_sym_DASH_DASH] = ACTIONS(3048),
    [anon_sym_PLUS_PLUS] = ACTIONS(3048),
    [anon_sym_DOT] = ACTIONS(3050),
    [anon_sym_DOT_STAR] = ACTIONS(3048),
    [anon_sym_DASH_GT] = ACTIONS(3048),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3050),
    [anon_sym_let] = ACTIONS(3050),
    [anon_sym_This] = ACTIONS(3050),
    [anon_sym_final] = ACTIONS(3050),
    [anon_sym_override] = ACTIONS(3050),
    [anon_sym_requires] = ACTIONS(3050),
    [anon_sym_where] = ACTIONS(3050),
  },
  [3059] = {
    [sym_identifier] = ACTIONS(3042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3040),
    [anon_sym_COMMA] = ACTIONS(3040),
    [anon_sym_RPAREN] = ACTIONS(3040),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_SLASH] = ACTIONS(3042),
    [anon_sym_PERCENT] = ACTIONS(3040),
    [anon_sym_PIPE_PIPE] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_PIPE] = ACTIONS(3042),
    [anon_sym_CARET] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_EQ_EQ] = ACTIONS(3040),
    [anon_sym_BANG_EQ] = ACTIONS(3040),
    [anon_sym_GT] = ACTIONS(3042),
    [anon_sym_GT_EQ] = ACTIONS(3040),
    [anon_sym_LT_EQ] = ACTIONS(3042),
    [anon_sym_LT] = ACTIONS(3042),
    [anon_sym_LT_LT] = ACTIONS(3040),
    [anon_sym_GT_GT] = ACTIONS(3040),
    [anon_sym_COLON] = ACTIONS(3040),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_RBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3040),
    [anon_sym_RBRACK] = ACTIONS(3040),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_QMARK] = ACTIONS(3040),
    [anon_sym_LT_EQ_GT] = ACTIONS(3040),
    [anon_sym_or] = ACTIONS(3042),
    [anon_sym_and] = ACTIONS(3042),
    [anon_sym_bitor] = ACTIONS(3042),
    [anon_sym_xor] = ACTIONS(3042),
    [anon_sym_bitand] = ACTIONS(3042),
    [anon_sym_not_eq] = ACTIONS(3042),
    [anon_sym_is] = ACTIONS(3042),
    [anon_sym_as] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_DOT] = ACTIONS(3042),
    [anon_sym_DOT_STAR] = ACTIONS(3040),
    [anon_sym_DASH_GT] = ACTIONS(3040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3042),
    [anon_sym_let] = ACTIONS(3042),
    [anon_sym_This] = ACTIONS(3042),
    [anon_sym_final] = ACTIONS(3042),
    [anon_sym_override] = ACTIONS(3042),
    [anon_sym_requires] = ACTIONS(3042),
    [anon_sym_where] = ACTIONS(3042),
  },
  [3060] = {
    [sym_identifier] = ACTIONS(3018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3016),
    [anon_sym_COMMA] = ACTIONS(3016),
    [anon_sym_RPAREN] = ACTIONS(3016),
    [anon_sym_LPAREN2] = ACTIONS(3016),
    [anon_sym_DASH] = ACTIONS(3018),
    [anon_sym_PLUS] = ACTIONS(3018),
    [anon_sym_STAR] = ACTIONS(3016),
    [anon_sym_SLASH] = ACTIONS(3018),
    [anon_sym_PERCENT] = ACTIONS(3016),
    [anon_sym_PIPE_PIPE] = ACTIONS(3016),
    [anon_sym_AMP_AMP] = ACTIONS(3016),
    [anon_sym_PIPE] = ACTIONS(3018),
    [anon_sym_CARET] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_EQ_EQ] = ACTIONS(3016),
    [anon_sym_BANG_EQ] = ACTIONS(3016),
    [anon_sym_GT] = ACTIONS(3018),
    [anon_sym_GT_EQ] = ACTIONS(3016),
    [anon_sym_LT_EQ] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(3018),
    [anon_sym_LT_LT] = ACTIONS(3016),
    [anon_sym_GT_GT] = ACTIONS(3016),
    [anon_sym_COLON] = ACTIONS(3016),
    [anon_sym_SEMI] = ACTIONS(3016),
    [anon_sym___extension__] = ACTIONS(3018),
    [anon_sym___attribute__] = ACTIONS(3018),
    [anon_sym___attribute] = ACTIONS(3018),
    [anon_sym___based] = ACTIONS(3018),
    [anon_sym_LBRACE] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(3016),
    [anon_sym_signed] = ACTIONS(3018),
    [anon_sym_unsigned] = ACTIONS(3018),
    [anon_sym_long] = ACTIONS(3018),
    [anon_sym_short] = ACTIONS(3018),
    [anon_sym_LBRACK] = ACTIONS(3016),
    [anon_sym_RBRACK] = ACTIONS(3016),
    [anon_sym_const] = ACTIONS(3018),
    [anon_sym_constexpr] = ACTIONS(3018),
    [anon_sym_volatile] = ACTIONS(3018),
    [anon_sym_restrict] = ACTIONS(3018),
    [anon_sym___restrict__] = ACTIONS(3018),
    [anon_sym__Atomic] = ACTIONS(3018),
    [anon_sym__Noreturn] = ACTIONS(3018),
    [anon_sym_noreturn] = ACTIONS(3018),
    [anon_sym__Nonnull] = ACTIONS(3018),
    [anon_sym_mutable] = ACTIONS(3018),
    [anon_sym_constinit] = ACTIONS(3018),
    [anon_sym_consteval] = ACTIONS(3018),
    [anon_sym_alignas] = ACTIONS(3018),
    [anon_sym__Alignas] = ACTIONS(3018),
    [sym_primitive_type] = ACTIONS(3018),
    [anon_sym_QMARK] = ACTIONS(3016),
    [anon_sym_LT_EQ_GT] = ACTIONS(3016),
    [anon_sym_or] = ACTIONS(3018),
    [anon_sym_and] = ACTIONS(3018),
    [anon_sym_bitor] = ACTIONS(3018),
    [anon_sym_xor] = ACTIONS(3018),
    [anon_sym_bitand] = ACTIONS(3018),
    [anon_sym_not_eq] = ACTIONS(3018),
    [anon_sym_is] = ACTIONS(3018),
    [anon_sym_as] = ACTIONS(3018),
    [anon_sym_DASH_DASH] = ACTIONS(3016),
    [anon_sym_PLUS_PLUS] = ACTIONS(3016),
    [anon_sym_DOT] = ACTIONS(3018),
    [anon_sym_DOT_STAR] = ACTIONS(3016),
    [anon_sym_DASH_GT] = ACTIONS(3016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3018),
    [anon_sym_let] = ACTIONS(3018),
    [anon_sym_This] = ACTIONS(3018),
    [anon_sym_final] = ACTIONS(3018),
    [anon_sym_override] = ACTIONS(3018),
    [anon_sym_requires] = ACTIONS(3018),
    [anon_sym_where] = ACTIONS(3018),
  },
  [3061] = {
    [sym_identifier] = ACTIONS(2956),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2954),
    [anon_sym_COMMA] = ACTIONS(2954),
    [anon_sym_RPAREN] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2954),
    [anon_sym_DASH] = ACTIONS(2956),
    [anon_sym_PLUS] = ACTIONS(2956),
    [anon_sym_STAR] = ACTIONS(2954),
    [anon_sym_SLASH] = ACTIONS(2956),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [anon_sym_PIPE_PIPE] = ACTIONS(2954),
    [anon_sym_AMP_AMP] = ACTIONS(2954),
    [anon_sym_PIPE] = ACTIONS(2956),
    [anon_sym_CARET] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(2956),
    [anon_sym_EQ_EQ] = ACTIONS(2954),
    [anon_sym_BANG_EQ] = ACTIONS(2954),
    [anon_sym_GT] = ACTIONS(2956),
    [anon_sym_GT_EQ] = ACTIONS(2954),
    [anon_sym_LT_EQ] = ACTIONS(2956),
    [anon_sym_LT] = ACTIONS(2956),
    [anon_sym_LT_LT] = ACTIONS(2954),
    [anon_sym_GT_GT] = ACTIONS(2954),
    [anon_sym_COLON] = ACTIONS(2954),
    [anon_sym_SEMI] = ACTIONS(2954),
    [anon_sym___extension__] = ACTIONS(2956),
    [anon_sym___attribute__] = ACTIONS(2956),
    [anon_sym___attribute] = ACTIONS(2956),
    [anon_sym___based] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(2954),
    [anon_sym_signed] = ACTIONS(2956),
    [anon_sym_unsigned] = ACTIONS(2956),
    [anon_sym_long] = ACTIONS(2956),
    [anon_sym_short] = ACTIONS(2956),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_RBRACK] = ACTIONS(2954),
    [anon_sym_const] = ACTIONS(2956),
    [anon_sym_constexpr] = ACTIONS(2956),
    [anon_sym_volatile] = ACTIONS(2956),
    [anon_sym_restrict] = ACTIONS(2956),
    [anon_sym___restrict__] = ACTIONS(2956),
    [anon_sym__Atomic] = ACTIONS(2956),
    [anon_sym__Noreturn] = ACTIONS(2956),
    [anon_sym_noreturn] = ACTIONS(2956),
    [anon_sym__Nonnull] = ACTIONS(2956),
    [anon_sym_mutable] = ACTIONS(2956),
    [anon_sym_constinit] = ACTIONS(2956),
    [anon_sym_consteval] = ACTIONS(2956),
    [anon_sym_alignas] = ACTIONS(2956),
    [anon_sym__Alignas] = ACTIONS(2956),
    [sym_primitive_type] = ACTIONS(2956),
    [anon_sym_QMARK] = ACTIONS(2954),
    [anon_sym_LT_EQ_GT] = ACTIONS(2954),
    [anon_sym_or] = ACTIONS(2956),
    [anon_sym_and] = ACTIONS(2956),
    [anon_sym_bitor] = ACTIONS(2956),
    [anon_sym_xor] = ACTIONS(2956),
    [anon_sym_bitand] = ACTIONS(2956),
    [anon_sym_not_eq] = ACTIONS(2956),
    [anon_sym_is] = ACTIONS(2956),
    [anon_sym_as] = ACTIONS(2956),
    [anon_sym_DASH_DASH] = ACTIONS(2954),
    [anon_sym_PLUS_PLUS] = ACTIONS(2954),
    [anon_sym_DOT] = ACTIONS(2956),
    [anon_sym_DOT_STAR] = ACTIONS(2954),
    [anon_sym_DASH_GT] = ACTIONS(2954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2956),
    [anon_sym_let] = ACTIONS(2956),
    [anon_sym_This] = ACTIONS(2956),
    [anon_sym_final] = ACTIONS(2956),
    [anon_sym_override] = ACTIONS(2956),
    [anon_sym_requires] = ACTIONS(2956),
    [anon_sym_where] = ACTIONS(2956),
  },
  [3062] = {
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2881),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_SLASH] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_CARET] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_EQ_EQ] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_GT_EQ] = ACTIONS(2881),
    [anon_sym_LT_EQ] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_LT_LT] = ACTIONS(2881),
    [anon_sym_GT_GT] = ACTIONS(2881),
    [anon_sym_COLON] = ACTIONS(2881),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_RBRACE] = ACTIONS(2881),
    [anon_sym_signed] = ACTIONS(2883),
    [anon_sym_unsigned] = ACTIONS(2883),
    [anon_sym_long] = ACTIONS(2883),
    [anon_sym_short] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2881),
    [anon_sym_RBRACK] = ACTIONS(2881),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [sym_primitive_type] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_LT_EQ_GT] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2883),
    [anon_sym_and] = ACTIONS(2883),
    [anon_sym_bitor] = ACTIONS(2883),
    [anon_sym_xor] = ACTIONS(2883),
    [anon_sym_bitand] = ACTIONS(2883),
    [anon_sym_not_eq] = ACTIONS(2883),
    [anon_sym_is] = ACTIONS(2883),
    [anon_sym_as] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_DOT_STAR] = ACTIONS(2881),
    [anon_sym_DASH_GT] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_final] = ACTIONS(2883),
    [anon_sym_override] = ACTIONS(2883),
    [anon_sym_requires] = ACTIONS(2883),
    [anon_sym_where] = ACTIONS(2883),
  },
  [3063] = {
    [sym_identifier] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4250),
    [anon_sym_COMMA] = ACTIONS(4250),
    [anon_sym_RPAREN] = ACTIONS(4250),
    [aux_sym_preproc_if_token2] = ACTIONS(4250),
    [aux_sym_preproc_else_token1] = ACTIONS(4250),
    [aux_sym_preproc_elif_token1] = ACTIONS(4248),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4250),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4250),
    [anon_sym_LPAREN2] = ACTIONS(4250),
    [anon_sym_DASH] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(4250),
    [anon_sym_AMP_AMP] = ACTIONS(4250),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_CARET] = ACTIONS(4250),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4250),
    [anon_sym_BANG_EQ] = ACTIONS(4250),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4250),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4250),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_COLON] = ACTIONS(4250),
    [anon_sym_SEMI] = ACTIONS(4250),
    [anon_sym___extension__] = ACTIONS(4248),
    [anon_sym___attribute__] = ACTIONS(4248),
    [anon_sym___attribute] = ACTIONS(4248),
    [anon_sym_LBRACE] = ACTIONS(4250),
    [anon_sym_RBRACE] = ACTIONS(4250),
    [anon_sym_LBRACK] = ACTIONS(4250),
    [anon_sym_RBRACK] = ACTIONS(4250),
    [anon_sym_const] = ACTIONS(4248),
    [anon_sym_constexpr] = ACTIONS(4248),
    [anon_sym_volatile] = ACTIONS(4248),
    [anon_sym_restrict] = ACTIONS(4248),
    [anon_sym___restrict__] = ACTIONS(4248),
    [anon_sym__Atomic] = ACTIONS(4248),
    [anon_sym__Noreturn] = ACTIONS(4248),
    [anon_sym_noreturn] = ACTIONS(4248),
    [anon_sym__Nonnull] = ACTIONS(4248),
    [anon_sym_mutable] = ACTIONS(4248),
    [anon_sym_constinit] = ACTIONS(4248),
    [anon_sym_consteval] = ACTIONS(4248),
    [anon_sym_alignas] = ACTIONS(4248),
    [anon_sym__Alignas] = ACTIONS(4248),
    [anon_sym_QMARK] = ACTIONS(4250),
    [anon_sym_LT_EQ_GT] = ACTIONS(4250),
    [anon_sym_or] = ACTIONS(4248),
    [anon_sym_and] = ACTIONS(4248),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4248),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_is] = ACTIONS(4248),
    [anon_sym_as] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4250),
    [anon_sym_PLUS_PLUS] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_DOT_STAR] = ACTIONS(4250),
    [anon_sym_DASH_GT] = ACTIONS(4250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4248),
    [anon_sym_let] = ACTIONS(4248),
    [anon_sym_This] = ACTIONS(4248),
    [anon_sym_final] = ACTIONS(4248),
    [anon_sym_override] = ACTIONS(4248),
    [anon_sym_requires] = ACTIONS(4248),
    [anon_sym_where] = ACTIONS(4248),
  },
  [3064] = {
    [sym_identifier] = ACTIONS(2243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_RPAREN] = ACTIONS(2247),
    [anon_sym_LPAREN2] = ACTIONS(2247),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_COLON] = ACTIONS(2243),
    [anon_sym_SEMI] = ACTIONS(2245),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_out] = ACTIONS(2243),
    [anon_sym_inout] = ACTIONS(2243),
    [anon_sym_virtual] = ACTIONS(2243),
    [anon_sym_extern] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym___attribute] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2247),
    [anon_sym___declspec] = ACTIONS(2243),
    [anon_sym___based] = ACTIONS(2243),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_EQ] = ACTIONS(2250),
    [anon_sym_register] = ACTIONS(2243),
    [anon_sym_inline] = ACTIONS(2243),
    [anon_sym___inline] = ACTIONS(2243),
    [anon_sym___inline__] = ACTIONS(2243),
    [anon_sym___forceinline] = ACTIONS(2243),
    [anon_sym_thread_local] = ACTIONS(2243),
    [anon_sym___thread] = ACTIONS(2243),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym__Nonnull] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [anon_sym_DOT] = ACTIONS(2243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2243),
    [anon_sym_let] = ACTIONS(2243),
    [anon_sym_This] = ACTIONS(2243),
    [anon_sym_decltype] = ACTIONS(2243),
    [anon_sym_template] = ACTIONS(2243),
    [anon_sym_operator] = ACTIONS(2243),
    [anon_sym_precise] = ACTIONS(2243),
    [anon_sym_shared] = ACTIONS(2243),
    [anon_sym_groupshared] = ACTIONS(2243),
    [anon_sym_uniform] = ACTIONS(2243),
    [anon_sym_row_major] = ACTIONS(2243),
    [anon_sym_column_major] = ACTIONS(2243),
    [anon_sym_globallycoherent] = ACTIONS(2243),
    [anon_sym_centroid] = ACTIONS(2243),
    [anon_sym_noperspective] = ACTIONS(2243),
    [anon_sym_nointerpolation] = ACTIONS(2243),
    [anon_sym_sample] = ACTIONS(2243),
    [anon_sym_linear] = ACTIONS(2243),
    [anon_sym_snorm] = ACTIONS(2243),
    [anon_sym_unorm] = ACTIONS(2243),
    [anon_sym_point] = ACTIONS(2243),
    [anon_sym_line] = ACTIONS(2243),
    [anon_sym_triangleadj] = ACTIONS(2243),
    [anon_sym_lineadj] = ACTIONS(2243),
    [anon_sym_triangle] = ACTIONS(2243),
  },
  [3065] = {
    [sym_type_qualifier] = STATE(3074),
    [sym_alignas_qualifier] = STATE(2912),
    [aux_sym__type_definition_type_repeat1] = STATE(3074),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3127),
    [sym_identifier] = ACTIONS(7264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3423),
    [anon_sym_COMMA] = ACTIONS(3423),
    [anon_sym_RPAREN] = ACTIONS(3423),
    [anon_sym_LPAREN2] = ACTIONS(3423),
    [anon_sym_DASH] = ACTIONS(3428),
    [anon_sym_PLUS] = ACTIONS(3428),
    [anon_sym_STAR] = ACTIONS(3423),
    [anon_sym_SLASH] = ACTIONS(3428),
    [anon_sym_PERCENT] = ACTIONS(3423),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_PIPE] = ACTIONS(3428),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3428),
    [anon_sym_EQ_EQ] = ACTIONS(3423),
    [anon_sym_BANG_EQ] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3428),
    [anon_sym_GT_EQ] = ACTIONS(3423),
    [anon_sym_LT_EQ] = ACTIONS(3428),
    [anon_sym_LT] = ACTIONS(3428),
    [anon_sym_LT_LT] = ACTIONS(3423),
    [anon_sym_GT_GT] = ACTIONS(3423),
    [anon_sym_COLON] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3423),
    [anon_sym___extension__] = ACTIONS(7266),
    [anon_sym___attribute__] = ACTIONS(3428),
    [anon_sym___attribute] = ACTIONS(3428),
    [anon_sym_LBRACE] = ACTIONS(3423),
    [anon_sym_RBRACE] = ACTIONS(3423),
    [anon_sym_signed] = ACTIONS(7268),
    [anon_sym_unsigned] = ACTIONS(7268),
    [anon_sym_long] = ACTIONS(7268),
    [anon_sym_short] = ACTIONS(7268),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_RBRACK] = ACTIONS(3423),
    [anon_sym_const] = ACTIONS(7266),
    [anon_sym_constexpr] = ACTIONS(7266),
    [anon_sym_volatile] = ACTIONS(7266),
    [anon_sym_restrict] = ACTIONS(7266),
    [anon_sym___restrict__] = ACTIONS(7266),
    [anon_sym__Atomic] = ACTIONS(7266),
    [anon_sym__Noreturn] = ACTIONS(7266),
    [anon_sym_noreturn] = ACTIONS(7266),
    [anon_sym__Nonnull] = ACTIONS(7266),
    [anon_sym_mutable] = ACTIONS(7266),
    [anon_sym_constinit] = ACTIONS(7266),
    [anon_sym_consteval] = ACTIONS(7266),
    [anon_sym_alignas] = ACTIONS(7270),
    [anon_sym__Alignas] = ACTIONS(7270),
    [sym_primitive_type] = ACTIONS(7272),
    [anon_sym_QMARK] = ACTIONS(3423),
    [anon_sym_LT_EQ_GT] = ACTIONS(3423),
    [anon_sym_or] = ACTIONS(3428),
    [anon_sym_and] = ACTIONS(3428),
    [anon_sym_bitor] = ACTIONS(3428),
    [anon_sym_xor] = ACTIONS(3428),
    [anon_sym_bitand] = ACTIONS(3428),
    [anon_sym_not_eq] = ACTIONS(3428),
    [anon_sym_is] = ACTIONS(3428),
    [anon_sym_as] = ACTIONS(3428),
    [anon_sym_DASH_DASH] = ACTIONS(3423),
    [anon_sym_PLUS_PLUS] = ACTIONS(3423),
    [anon_sym_DOT] = ACTIONS(3428),
    [anon_sym_DOT_STAR] = ACTIONS(3423),
    [anon_sym_DASH_GT] = ACTIONS(3423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3428),
    [anon_sym_let] = ACTIONS(3428),
    [anon_sym_This] = ACTIONS(3428),
  },
  [3066] = {
    [sym_identifier] = ACTIONS(7150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7152),
    [anon_sym_COMMA] = ACTIONS(7152),
    [anon_sym_RPAREN] = ACTIONS(7152),
    [aux_sym_preproc_if_token2] = ACTIONS(7152),
    [aux_sym_preproc_else_token1] = ACTIONS(7152),
    [aux_sym_preproc_elif_token1] = ACTIONS(7150),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7152),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7152),
    [anon_sym_LPAREN2] = ACTIONS(7152),
    [anon_sym_DASH] = ACTIONS(7150),
    [anon_sym_PLUS] = ACTIONS(7150),
    [anon_sym_STAR] = ACTIONS(7150),
    [anon_sym_SLASH] = ACTIONS(7150),
    [anon_sym_PERCENT] = ACTIONS(7150),
    [anon_sym_PIPE_PIPE] = ACTIONS(7152),
    [anon_sym_AMP_AMP] = ACTIONS(7152),
    [anon_sym_PIPE] = ACTIONS(7150),
    [anon_sym_CARET] = ACTIONS(7150),
    [anon_sym_AMP] = ACTIONS(7150),
    [anon_sym_EQ_EQ] = ACTIONS(7152),
    [anon_sym_BANG_EQ] = ACTIONS(7152),
    [anon_sym_GT] = ACTIONS(7150),
    [anon_sym_GT_EQ] = ACTIONS(7152),
    [anon_sym_LT_EQ] = ACTIONS(7150),
    [anon_sym_LT] = ACTIONS(7150),
    [anon_sym_LT_LT] = ACTIONS(7150),
    [anon_sym_GT_GT] = ACTIONS(7150),
    [anon_sym_COLON] = ACTIONS(7152),
    [anon_sym_SEMI] = ACTIONS(7152),
    [anon_sym_RBRACE] = ACTIONS(7152),
    [anon_sym_LBRACK] = ACTIONS(7152),
    [anon_sym_RBRACK] = ACTIONS(7152),
    [anon_sym_EQ] = ACTIONS(7150),
    [anon_sym_QMARK] = ACTIONS(7152),
    [anon_sym_STAR_EQ] = ACTIONS(7152),
    [anon_sym_SLASH_EQ] = ACTIONS(7152),
    [anon_sym_PERCENT_EQ] = ACTIONS(7152),
    [anon_sym_PLUS_EQ] = ACTIONS(7152),
    [anon_sym_DASH_EQ] = ACTIONS(7152),
    [anon_sym_LT_LT_EQ] = ACTIONS(7152),
    [anon_sym_GT_GT_EQ] = ACTIONS(7152),
    [anon_sym_AMP_EQ] = ACTIONS(7152),
    [anon_sym_CARET_EQ] = ACTIONS(7152),
    [anon_sym_PIPE_EQ] = ACTIONS(7152),
    [anon_sym_and_eq] = ACTIONS(7150),
    [anon_sym_or_eq] = ACTIONS(7150),
    [anon_sym_xor_eq] = ACTIONS(7150),
    [anon_sym_LT_EQ_GT] = ACTIONS(7152),
    [anon_sym_or] = ACTIONS(7150),
    [anon_sym_and] = ACTIONS(7150),
    [anon_sym_bitor] = ACTIONS(7150),
    [anon_sym_xor] = ACTIONS(7150),
    [anon_sym_bitand] = ACTIONS(7150),
    [anon_sym_not_eq] = ACTIONS(7150),
    [anon_sym_is] = ACTIONS(7150),
    [anon_sym_as] = ACTIONS(7150),
    [anon_sym_DASH_DASH] = ACTIONS(7152),
    [anon_sym_PLUS_PLUS] = ACTIONS(7152),
    [anon_sym_DOT] = ACTIONS(7150),
    [anon_sym_DOT_STAR] = ACTIONS(7152),
    [anon_sym_DASH_GT] = ACTIONS(7152),
    [anon_sym_L_DQUOTE] = ACTIONS(7152),
    [anon_sym_u_DQUOTE] = ACTIONS(7152),
    [anon_sym_U_DQUOTE] = ACTIONS(7152),
    [anon_sym_u8_DQUOTE] = ACTIONS(7152),
    [anon_sym_DQUOTE] = ACTIONS(7152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7152),
    [anon_sym_LR_DQUOTE] = ACTIONS(7152),
    [anon_sym_uR_DQUOTE] = ACTIONS(7152),
    [anon_sym_UR_DQUOTE] = ACTIONS(7152),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7152),
    [sym_literal_suffix] = ACTIONS(7150),
  },
  [3067] = {
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_LPAREN2] = ACTIONS(4246),
    [anon_sym_TILDE] = ACTIONS(4246),
    [anon_sym_STAR] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_COLON] = ACTIONS(4244),
    [anon_sym___extension__] = ACTIONS(4244),
    [anon_sym_in] = ACTIONS(4244),
    [anon_sym_out] = ACTIONS(4244),
    [anon_sym_inout] = ACTIONS(4244),
    [anon_sym_virtual] = ACTIONS(4244),
    [anon_sym_extern] = ACTIONS(4244),
    [anon_sym___attribute__] = ACTIONS(4244),
    [anon_sym___attribute] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4246),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4246),
    [anon_sym___declspec] = ACTIONS(4244),
    [anon_sym___based] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [anon_sym_static] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4246),
    [anon_sym_register] = ACTIONS(4244),
    [anon_sym_inline] = ACTIONS(4244),
    [anon_sym___inline] = ACTIONS(4244),
    [anon_sym___inline__] = ACTIONS(4244),
    [anon_sym___forceinline] = ACTIONS(4244),
    [anon_sym_thread_local] = ACTIONS(4244),
    [anon_sym___thread] = ACTIONS(4244),
    [anon_sym_const] = ACTIONS(4244),
    [anon_sym_constexpr] = ACTIONS(4244),
    [anon_sym_volatile] = ACTIONS(4244),
    [anon_sym_restrict] = ACTIONS(4244),
    [anon_sym___restrict__] = ACTIONS(4244),
    [anon_sym__Atomic] = ACTIONS(4244),
    [anon_sym__Noreturn] = ACTIONS(4244),
    [anon_sym_noreturn] = ACTIONS(4244),
    [anon_sym__Nonnull] = ACTIONS(4244),
    [anon_sym_mutable] = ACTIONS(4244),
    [anon_sym_constinit] = ACTIONS(4244),
    [anon_sym_consteval] = ACTIONS(4244),
    [anon_sym_alignas] = ACTIONS(4244),
    [anon_sym__Alignas] = ACTIONS(4244),
    [anon_sym_DOT] = ACTIONS(6997),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6959),
    [anon_sym_let] = ACTIONS(6959),
    [anon_sym_This] = ACTIONS(6959),
    [anon_sym_decltype] = ACTIONS(4244),
    [anon_sym_template] = ACTIONS(4244),
    [anon_sym_GT2] = ACTIONS(4246),
    [anon_sym_operator] = ACTIONS(4244),
    [anon_sym_precise] = ACTIONS(4244),
    [anon_sym_shared] = ACTIONS(4244),
    [anon_sym_groupshared] = ACTIONS(4244),
    [anon_sym_uniform] = ACTIONS(4244),
    [anon_sym_row_major] = ACTIONS(4244),
    [anon_sym_column_major] = ACTIONS(4244),
    [anon_sym_globallycoherent] = ACTIONS(4244),
    [anon_sym_centroid] = ACTIONS(4244),
    [anon_sym_noperspective] = ACTIONS(4244),
    [anon_sym_nointerpolation] = ACTIONS(4244),
    [anon_sym_sample] = ACTIONS(4244),
    [anon_sym_linear] = ACTIONS(4244),
    [anon_sym_snorm] = ACTIONS(4244),
    [anon_sym_unorm] = ACTIONS(4244),
    [anon_sym_point] = ACTIONS(4244),
    [anon_sym_line] = ACTIONS(4244),
    [anon_sym_triangleadj] = ACTIONS(4244),
    [anon_sym_lineadj] = ACTIONS(4244),
    [anon_sym_triangle] = ACTIONS(4244),
  },
  [3068] = {
    [sym_type_qualifier] = STATE(3069),
    [sym_alignas_qualifier] = STATE(2912),
    [aux_sym__type_definition_type_repeat1] = STATE(3069),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3116),
    [sym_identifier] = ACTIONS(7274),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3423),
    [anon_sym_COMMA] = ACTIONS(3423),
    [aux_sym_preproc_if_token2] = ACTIONS(3423),
    [aux_sym_preproc_else_token1] = ACTIONS(3423),
    [aux_sym_preproc_elif_token1] = ACTIONS(3428),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3423),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3423),
    [anon_sym_LPAREN2] = ACTIONS(3423),
    [anon_sym_DASH] = ACTIONS(3428),
    [anon_sym_PLUS] = ACTIONS(3428),
    [anon_sym_STAR] = ACTIONS(3423),
    [anon_sym_SLASH] = ACTIONS(3428),
    [anon_sym_PERCENT] = ACTIONS(3423),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_PIPE] = ACTIONS(3428),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3428),
    [anon_sym_EQ_EQ] = ACTIONS(3423),
    [anon_sym_BANG_EQ] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3428),
    [anon_sym_GT_EQ] = ACTIONS(3423),
    [anon_sym_LT_EQ] = ACTIONS(3428),
    [anon_sym_LT] = ACTIONS(3428),
    [anon_sym_LT_LT] = ACTIONS(3423),
    [anon_sym_GT_GT] = ACTIONS(3423),
    [anon_sym___extension__] = ACTIONS(7266),
    [anon_sym___attribute__] = ACTIONS(3428),
    [anon_sym___attribute] = ACTIONS(3428),
    [anon_sym_LBRACE] = ACTIONS(3423),
    [anon_sym_signed] = ACTIONS(7277),
    [anon_sym_unsigned] = ACTIONS(7277),
    [anon_sym_long] = ACTIONS(7277),
    [anon_sym_short] = ACTIONS(7277),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_const] = ACTIONS(7266),
    [anon_sym_constexpr] = ACTIONS(7266),
    [anon_sym_volatile] = ACTIONS(7266),
    [anon_sym_restrict] = ACTIONS(7266),
    [anon_sym___restrict__] = ACTIONS(7266),
    [anon_sym__Atomic] = ACTIONS(7266),
    [anon_sym__Noreturn] = ACTIONS(7266),
    [anon_sym_noreturn] = ACTIONS(7266),
    [anon_sym__Nonnull] = ACTIONS(7266),
    [anon_sym_mutable] = ACTIONS(7266),
    [anon_sym_constinit] = ACTIONS(7266),
    [anon_sym_consteval] = ACTIONS(7266),
    [anon_sym_alignas] = ACTIONS(7270),
    [anon_sym__Alignas] = ACTIONS(7270),
    [sym_primitive_type] = ACTIONS(7279),
    [anon_sym_QMARK] = ACTIONS(3423),
    [anon_sym_LT_EQ_GT] = ACTIONS(3423),
    [anon_sym_or] = ACTIONS(3428),
    [anon_sym_and] = ACTIONS(3428),
    [anon_sym_bitor] = ACTIONS(3428),
    [anon_sym_xor] = ACTIONS(3428),
    [anon_sym_bitand] = ACTIONS(3428),
    [anon_sym_not_eq] = ACTIONS(3428),
    [anon_sym_is] = ACTIONS(3428),
    [anon_sym_as] = ACTIONS(3428),
    [anon_sym_DASH_DASH] = ACTIONS(3423),
    [anon_sym_PLUS_PLUS] = ACTIONS(3423),
    [anon_sym_DOT] = ACTIONS(3428),
    [anon_sym_DOT_STAR] = ACTIONS(3423),
    [anon_sym_DASH_GT] = ACTIONS(3423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3428),
    [anon_sym_let] = ACTIONS(3428),
    [anon_sym_This] = ACTIONS(3428),
  },
  [3069] = {
    [sym_type_qualifier] = STATE(2799),
    [sym_alignas_qualifier] = STATE(2912),
    [aux_sym__type_definition_type_repeat1] = STATE(2799),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4515),
    [sym_identifier] = ACTIONS(7281),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3542),
    [anon_sym_COMMA] = ACTIONS(3542),
    [aux_sym_preproc_if_token2] = ACTIONS(3542),
    [aux_sym_preproc_else_token1] = ACTIONS(3542),
    [aux_sym_preproc_elif_token1] = ACTIONS(3540),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3542),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3542),
    [anon_sym_LPAREN2] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(3542),
    [anon_sym_SLASH] = ACTIONS(3540),
    [anon_sym_PERCENT] = ACTIONS(3542),
    [anon_sym_PIPE_PIPE] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_PIPE] = ACTIONS(3540),
    [anon_sym_CARET] = ACTIONS(3542),
    [anon_sym_AMP] = ACTIONS(3540),
    [anon_sym_EQ_EQ] = ACTIONS(3542),
    [anon_sym_BANG_EQ] = ACTIONS(3542),
    [anon_sym_GT] = ACTIONS(3540),
    [anon_sym_GT_EQ] = ACTIONS(3542),
    [anon_sym_LT_EQ] = ACTIONS(3540),
    [anon_sym_LT] = ACTIONS(3540),
    [anon_sym_LT_LT] = ACTIONS(3542),
    [anon_sym_GT_GT] = ACTIONS(3542),
    [anon_sym___extension__] = ACTIONS(7266),
    [anon_sym___attribute__] = ACTIONS(3540),
    [anon_sym___attribute] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_signed] = ACTIONS(7284),
    [anon_sym_unsigned] = ACTIONS(7284),
    [anon_sym_long] = ACTIONS(7284),
    [anon_sym_short] = ACTIONS(7284),
    [anon_sym_LBRACK] = ACTIONS(3542),
    [anon_sym_const] = ACTIONS(7266),
    [anon_sym_constexpr] = ACTIONS(7266),
    [anon_sym_volatile] = ACTIONS(7266),
    [anon_sym_restrict] = ACTIONS(7266),
    [anon_sym___restrict__] = ACTIONS(7266),
    [anon_sym__Atomic] = ACTIONS(7266),
    [anon_sym__Noreturn] = ACTIONS(7266),
    [anon_sym_noreturn] = ACTIONS(7266),
    [anon_sym__Nonnull] = ACTIONS(7266),
    [anon_sym_mutable] = ACTIONS(7266),
    [anon_sym_constinit] = ACTIONS(7266),
    [anon_sym_consteval] = ACTIONS(7266),
    [anon_sym_alignas] = ACTIONS(7270),
    [anon_sym__Alignas] = ACTIONS(7270),
    [sym_primitive_type] = ACTIONS(7286),
    [anon_sym_QMARK] = ACTIONS(3542),
    [anon_sym_LT_EQ_GT] = ACTIONS(3542),
    [anon_sym_or] = ACTIONS(3540),
    [anon_sym_and] = ACTIONS(3540),
    [anon_sym_bitor] = ACTIONS(3540),
    [anon_sym_xor] = ACTIONS(3540),
    [anon_sym_bitand] = ACTIONS(3540),
    [anon_sym_not_eq] = ACTIONS(3540),
    [anon_sym_is] = ACTIONS(3540),
    [anon_sym_as] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(3542),
    [anon_sym_PLUS_PLUS] = ACTIONS(3542),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_DOT_STAR] = ACTIONS(3542),
    [anon_sym_DASH_GT] = ACTIONS(3542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3540),
    [anon_sym_let] = ACTIONS(3540),
    [anon_sym_This] = ACTIONS(3540),
  },
  [3070] = {
    [sym_identifier] = ACTIONS(7158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7160),
    [anon_sym_COMMA] = ACTIONS(7160),
    [anon_sym_RPAREN] = ACTIONS(7160),
    [aux_sym_preproc_if_token2] = ACTIONS(7160),
    [aux_sym_preproc_else_token1] = ACTIONS(7160),
    [aux_sym_preproc_elif_token1] = ACTIONS(7158),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7160),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7160),
    [anon_sym_LPAREN2] = ACTIONS(7160),
    [anon_sym_DASH] = ACTIONS(7158),
    [anon_sym_PLUS] = ACTIONS(7158),
    [anon_sym_STAR] = ACTIONS(7158),
    [anon_sym_SLASH] = ACTIONS(7158),
    [anon_sym_PERCENT] = ACTIONS(7158),
    [anon_sym_PIPE_PIPE] = ACTIONS(7160),
    [anon_sym_AMP_AMP] = ACTIONS(7160),
    [anon_sym_PIPE] = ACTIONS(7158),
    [anon_sym_CARET] = ACTIONS(7158),
    [anon_sym_AMP] = ACTIONS(7158),
    [anon_sym_EQ_EQ] = ACTIONS(7160),
    [anon_sym_BANG_EQ] = ACTIONS(7160),
    [anon_sym_GT] = ACTIONS(7158),
    [anon_sym_GT_EQ] = ACTIONS(7160),
    [anon_sym_LT_EQ] = ACTIONS(7158),
    [anon_sym_LT] = ACTIONS(7158),
    [anon_sym_LT_LT] = ACTIONS(7158),
    [anon_sym_GT_GT] = ACTIONS(7158),
    [anon_sym_COLON] = ACTIONS(7160),
    [anon_sym_SEMI] = ACTIONS(7160),
    [anon_sym_RBRACE] = ACTIONS(7160),
    [anon_sym_LBRACK] = ACTIONS(7160),
    [anon_sym_RBRACK] = ACTIONS(7160),
    [anon_sym_EQ] = ACTIONS(7158),
    [anon_sym_QMARK] = ACTIONS(7160),
    [anon_sym_STAR_EQ] = ACTIONS(7160),
    [anon_sym_SLASH_EQ] = ACTIONS(7160),
    [anon_sym_PERCENT_EQ] = ACTIONS(7160),
    [anon_sym_PLUS_EQ] = ACTIONS(7160),
    [anon_sym_DASH_EQ] = ACTIONS(7160),
    [anon_sym_LT_LT_EQ] = ACTIONS(7160),
    [anon_sym_GT_GT_EQ] = ACTIONS(7160),
    [anon_sym_AMP_EQ] = ACTIONS(7160),
    [anon_sym_CARET_EQ] = ACTIONS(7160),
    [anon_sym_PIPE_EQ] = ACTIONS(7160),
    [anon_sym_and_eq] = ACTIONS(7158),
    [anon_sym_or_eq] = ACTIONS(7158),
    [anon_sym_xor_eq] = ACTIONS(7158),
    [anon_sym_LT_EQ_GT] = ACTIONS(7160),
    [anon_sym_or] = ACTIONS(7158),
    [anon_sym_and] = ACTIONS(7158),
    [anon_sym_bitor] = ACTIONS(7158),
    [anon_sym_xor] = ACTIONS(7158),
    [anon_sym_bitand] = ACTIONS(7158),
    [anon_sym_not_eq] = ACTIONS(7158),
    [anon_sym_is] = ACTIONS(7158),
    [anon_sym_as] = ACTIONS(7158),
    [anon_sym_DASH_DASH] = ACTIONS(7160),
    [anon_sym_PLUS_PLUS] = ACTIONS(7160),
    [anon_sym_DOT] = ACTIONS(7158),
    [anon_sym_DOT_STAR] = ACTIONS(7160),
    [anon_sym_DASH_GT] = ACTIONS(7160),
    [anon_sym_L_DQUOTE] = ACTIONS(7160),
    [anon_sym_u_DQUOTE] = ACTIONS(7160),
    [anon_sym_U_DQUOTE] = ACTIONS(7160),
    [anon_sym_u8_DQUOTE] = ACTIONS(7160),
    [anon_sym_DQUOTE] = ACTIONS(7160),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7160),
    [anon_sym_LR_DQUOTE] = ACTIONS(7160),
    [anon_sym_uR_DQUOTE] = ACTIONS(7160),
    [anon_sym_UR_DQUOTE] = ACTIONS(7160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7160),
    [sym_literal_suffix] = ACTIONS(7158),
  },
  [3071] = {
    [sym_identifier] = ACTIONS(7288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7290),
    [anon_sym_COMMA] = ACTIONS(7290),
    [anon_sym_RPAREN] = ACTIONS(7290),
    [aux_sym_preproc_if_token2] = ACTIONS(7290),
    [aux_sym_preproc_else_token1] = ACTIONS(7290),
    [aux_sym_preproc_elif_token1] = ACTIONS(7288),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7290),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7290),
    [anon_sym_LPAREN2] = ACTIONS(7290),
    [anon_sym_DASH] = ACTIONS(7288),
    [anon_sym_PLUS] = ACTIONS(7288),
    [anon_sym_STAR] = ACTIONS(7288),
    [anon_sym_SLASH] = ACTIONS(7288),
    [anon_sym_PERCENT] = ACTIONS(7288),
    [anon_sym_PIPE_PIPE] = ACTIONS(7290),
    [anon_sym_AMP_AMP] = ACTIONS(7290),
    [anon_sym_PIPE] = ACTIONS(7288),
    [anon_sym_CARET] = ACTIONS(7288),
    [anon_sym_AMP] = ACTIONS(7288),
    [anon_sym_EQ_EQ] = ACTIONS(7290),
    [anon_sym_BANG_EQ] = ACTIONS(7290),
    [anon_sym_GT] = ACTIONS(7288),
    [anon_sym_GT_EQ] = ACTIONS(7290),
    [anon_sym_LT_EQ] = ACTIONS(7288),
    [anon_sym_LT] = ACTIONS(7288),
    [anon_sym_LT_LT] = ACTIONS(7288),
    [anon_sym_GT_GT] = ACTIONS(7288),
    [anon_sym_COLON] = ACTIONS(7290),
    [anon_sym_SEMI] = ACTIONS(7290),
    [anon_sym_RBRACE] = ACTIONS(7290),
    [anon_sym_LBRACK] = ACTIONS(7290),
    [anon_sym_RBRACK] = ACTIONS(7290),
    [anon_sym_EQ] = ACTIONS(7288),
    [anon_sym_QMARK] = ACTIONS(7290),
    [anon_sym_STAR_EQ] = ACTIONS(7290),
    [anon_sym_SLASH_EQ] = ACTIONS(7290),
    [anon_sym_PERCENT_EQ] = ACTIONS(7290),
    [anon_sym_PLUS_EQ] = ACTIONS(7290),
    [anon_sym_DASH_EQ] = ACTIONS(7290),
    [anon_sym_LT_LT_EQ] = ACTIONS(7290),
    [anon_sym_GT_GT_EQ] = ACTIONS(7290),
    [anon_sym_AMP_EQ] = ACTIONS(7290),
    [anon_sym_CARET_EQ] = ACTIONS(7290),
    [anon_sym_PIPE_EQ] = ACTIONS(7290),
    [anon_sym_and_eq] = ACTIONS(7288),
    [anon_sym_or_eq] = ACTIONS(7288),
    [anon_sym_xor_eq] = ACTIONS(7288),
    [anon_sym_LT_EQ_GT] = ACTIONS(7290),
    [anon_sym_or] = ACTIONS(7288),
    [anon_sym_and] = ACTIONS(7288),
    [anon_sym_bitor] = ACTIONS(7288),
    [anon_sym_xor] = ACTIONS(7288),
    [anon_sym_bitand] = ACTIONS(7288),
    [anon_sym_not_eq] = ACTIONS(7288),
    [anon_sym_is] = ACTIONS(7288),
    [anon_sym_as] = ACTIONS(7288),
    [anon_sym_DASH_DASH] = ACTIONS(7290),
    [anon_sym_PLUS_PLUS] = ACTIONS(7290),
    [anon_sym_DOT] = ACTIONS(7288),
    [anon_sym_DOT_STAR] = ACTIONS(7290),
    [anon_sym_DASH_GT] = ACTIONS(7290),
    [anon_sym_L_DQUOTE] = ACTIONS(7290),
    [anon_sym_u_DQUOTE] = ACTIONS(7290),
    [anon_sym_U_DQUOTE] = ACTIONS(7290),
    [anon_sym_u8_DQUOTE] = ACTIONS(7290),
    [anon_sym_DQUOTE] = ACTIONS(7290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7290),
    [anon_sym_LR_DQUOTE] = ACTIONS(7290),
    [anon_sym_uR_DQUOTE] = ACTIONS(7290),
    [anon_sym_UR_DQUOTE] = ACTIONS(7290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7290),
    [sym_literal_suffix] = ACTIONS(7288),
  },
  [3072] = {
    [sym_type_qualifier] = STATE(3072),
    [sym_alignas_qualifier] = STATE(3113),
    [aux_sym_array_declarator_repeat1] = STATE(3072),
    [sym_identifier] = ACTIONS(7292),
    [anon_sym_LPAREN2] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7294),
    [anon_sym_TILDE] = ACTIONS(7294),
    [anon_sym_DASH] = ACTIONS(7292),
    [anon_sym_PLUS] = ACTIONS(7292),
    [anon_sym_STAR] = ACTIONS(7294),
    [anon_sym_AMP] = ACTIONS(7294),
    [anon_sym___extension__] = ACTIONS(7296),
    [anon_sym_COLON_COLON] = ACTIONS(7294),
    [anon_sym_LBRACK] = ACTIONS(7294),
    [anon_sym_static] = ACTIONS(7299),
    [anon_sym_RBRACK] = ACTIONS(7294),
    [anon_sym_const] = ACTIONS(7296),
    [anon_sym_constexpr] = ACTIONS(7296),
    [anon_sym_volatile] = ACTIONS(7296),
    [anon_sym_restrict] = ACTIONS(7296),
    [anon_sym___restrict__] = ACTIONS(7296),
    [anon_sym__Atomic] = ACTIONS(7296),
    [anon_sym__Noreturn] = ACTIONS(7296),
    [anon_sym_noreturn] = ACTIONS(7296),
    [anon_sym__Nonnull] = ACTIONS(7296),
    [anon_sym_mutable] = ACTIONS(7296),
    [anon_sym_constinit] = ACTIONS(7296),
    [anon_sym_consteval] = ACTIONS(7296),
    [anon_sym_alignas] = ACTIONS(7302),
    [anon_sym__Alignas] = ACTIONS(7302),
    [sym_primitive_type] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7292),
    [anon_sym_compl] = ACTIONS(7292),
    [anon_sym_DASH_DASH] = ACTIONS(7294),
    [anon_sym_PLUS_PLUS] = ACTIONS(7294),
    [anon_sym_sizeof] = ACTIONS(7292),
    [anon_sym___alignof__] = ACTIONS(7292),
    [anon_sym___alignof] = ACTIONS(7292),
    [anon_sym__alignof] = ACTIONS(7292),
    [anon_sym_alignof] = ACTIONS(7292),
    [anon_sym__Alignof] = ACTIONS(7292),
    [anon_sym_offsetof] = ACTIONS(7292),
    [anon_sym__Generic] = ACTIONS(7292),
    [anon_sym_asm] = ACTIONS(7292),
    [anon_sym___asm__] = ACTIONS(7292),
    [anon_sym___asm] = ACTIONS(7292),
    [sym_number_literal] = ACTIONS(7294),
    [anon_sym_L_SQUOTE] = ACTIONS(7294),
    [anon_sym_u_SQUOTE] = ACTIONS(7294),
    [anon_sym_U_SQUOTE] = ACTIONS(7294),
    [anon_sym_u8_SQUOTE] = ACTIONS(7294),
    [anon_sym_SQUOTE] = ACTIONS(7294),
    [anon_sym_L_DQUOTE] = ACTIONS(7294),
    [anon_sym_u_DQUOTE] = ACTIONS(7294),
    [anon_sym_U_DQUOTE] = ACTIONS(7294),
    [anon_sym_u8_DQUOTE] = ACTIONS(7294),
    [anon_sym_DQUOTE] = ACTIONS(7294),
    [sym_true] = ACTIONS(7292),
    [sym_false] = ACTIONS(7292),
    [anon_sym_NULL] = ACTIONS(7292),
    [anon_sym_nullptr] = ACTIONS(7292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(7292),
    [anon_sym_template] = ACTIONS(7292),
    [anon_sym_delete] = ACTIONS(7292),
    [anon_sym_R_DQUOTE] = ACTIONS(7294),
    [anon_sym_LR_DQUOTE] = ACTIONS(7294),
    [anon_sym_uR_DQUOTE] = ACTIONS(7294),
    [anon_sym_UR_DQUOTE] = ACTIONS(7294),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7294),
    [anon_sym_co_await] = ACTIONS(7292),
    [anon_sym_new] = ACTIONS(7292),
    [anon_sym_requires] = ACTIONS(7292),
    [sym_this] = ACTIONS(7292),
  },
  [3073] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2245),
    [anon_sym_COMMA] = ACTIONS(2245),
    [anon_sym_RPAREN] = ACTIONS(2247),
    [anon_sym_LPAREN2] = ACTIONS(2247),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_SLASH] = ACTIONS(2255),
    [anon_sym_PERCENT] = ACTIONS(2255),
    [anon_sym_PIPE_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2255),
    [anon_sym_CARET] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2245),
    [anon_sym_BANG_EQ] = ACTIONS(2245),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_GT_EQ] = ACTIONS(2245),
    [anon_sym_LT_EQ] = ACTIONS(2255),
    [anon_sym_LT] = ACTIONS(2255),
    [anon_sym_LT_LT] = ACTIONS(2255),
    [anon_sym_GT_GT] = ACTIONS(2255),
    [anon_sym___extension__] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2247),
    [anon_sym_EQ] = ACTIONS(2255),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2250),
    [anon_sym_volatile] = ACTIONS(2250),
    [anon_sym_restrict] = ACTIONS(2250),
    [anon_sym___restrict__] = ACTIONS(2250),
    [anon_sym__Atomic] = ACTIONS(2250),
    [anon_sym__Noreturn] = ACTIONS(2250),
    [anon_sym_noreturn] = ACTIONS(2250),
    [anon_sym__Nonnull] = ACTIONS(2250),
    [anon_sym_mutable] = ACTIONS(2250),
    [anon_sym_constinit] = ACTIONS(2250),
    [anon_sym_consteval] = ACTIONS(2250),
    [anon_sym_alignas] = ACTIONS(2250),
    [anon_sym__Alignas] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2245),
    [anon_sym_STAR_EQ] = ACTIONS(2245),
    [anon_sym_SLASH_EQ] = ACTIONS(2245),
    [anon_sym_PERCENT_EQ] = ACTIONS(2245),
    [anon_sym_PLUS_EQ] = ACTIONS(2245),
    [anon_sym_DASH_EQ] = ACTIONS(2245),
    [anon_sym_LT_LT_EQ] = ACTIONS(2245),
    [anon_sym_GT_GT_EQ] = ACTIONS(2245),
    [anon_sym_AMP_EQ] = ACTIONS(2245),
    [anon_sym_CARET_EQ] = ACTIONS(2245),
    [anon_sym_PIPE_EQ] = ACTIONS(2245),
    [anon_sym_and_eq] = ACTIONS(2245),
    [anon_sym_or_eq] = ACTIONS(2245),
    [anon_sym_xor_eq] = ACTIONS(2245),
    [anon_sym_LT_EQ_GT] = ACTIONS(2245),
    [anon_sym_or] = ACTIONS(2255),
    [anon_sym_and] = ACTIONS(2255),
    [anon_sym_bitor] = ACTIONS(2245),
    [anon_sym_xor] = ACTIONS(2255),
    [anon_sym_bitand] = ACTIONS(2245),
    [anon_sym_not_eq] = ACTIONS(2245),
    [anon_sym_is] = ACTIONS(2245),
    [anon_sym_as] = ACTIONS(2245),
    [anon_sym_DASH_DASH] = ACTIONS(2245),
    [anon_sym_PLUS_PLUS] = ACTIONS(2245),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2245),
    [anon_sym_DASH_GT] = ACTIONS(2255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_This] = ACTIONS(2250),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2245),
  },
  [3074] = {
    [sym_type_qualifier] = STATE(2799),
    [sym_alignas_qualifier] = STATE(2912),
    [aux_sym__type_definition_type_repeat1] = STATE(2799),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3090),
    [sym_identifier] = ACTIONS(7305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3542),
    [anon_sym_COMMA] = ACTIONS(3542),
    [anon_sym_RPAREN] = ACTIONS(3542),
    [anon_sym_LPAREN2] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(3542),
    [anon_sym_SLASH] = ACTIONS(3540),
    [anon_sym_PERCENT] = ACTIONS(3542),
    [anon_sym_PIPE_PIPE] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_PIPE] = ACTIONS(3540),
    [anon_sym_CARET] = ACTIONS(3542),
    [anon_sym_AMP] = ACTIONS(3540),
    [anon_sym_EQ_EQ] = ACTIONS(3542),
    [anon_sym_BANG_EQ] = ACTIONS(3542),
    [anon_sym_GT] = ACTIONS(3540),
    [anon_sym_GT_EQ] = ACTIONS(3542),
    [anon_sym_LT_EQ] = ACTIONS(3540),
    [anon_sym_LT] = ACTIONS(3540),
    [anon_sym_LT_LT] = ACTIONS(3542),
    [anon_sym_GT_GT] = ACTIONS(3542),
    [anon_sym_COLON] = ACTIONS(3542),
    [anon_sym_SEMI] = ACTIONS(3542),
    [anon_sym___extension__] = ACTIONS(7266),
    [anon_sym___attribute__] = ACTIONS(3540),
    [anon_sym___attribute] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_RBRACE] = ACTIONS(3542),
    [anon_sym_signed] = ACTIONS(7307),
    [anon_sym_unsigned] = ACTIONS(7307),
    [anon_sym_long] = ACTIONS(7307),
    [anon_sym_short] = ACTIONS(7307),
    [anon_sym_LBRACK] = ACTIONS(3542),
    [anon_sym_RBRACK] = ACTIONS(3542),
    [anon_sym_const] = ACTIONS(7266),
    [anon_sym_constexpr] = ACTIONS(7266),
    [anon_sym_volatile] = ACTIONS(7266),
    [anon_sym_restrict] = ACTIONS(7266),
    [anon_sym___restrict__] = ACTIONS(7266),
    [anon_sym__Atomic] = ACTIONS(7266),
    [anon_sym__Noreturn] = ACTIONS(7266),
    [anon_sym_noreturn] = ACTIONS(7266),
    [anon_sym__Nonnull] = ACTIONS(7266),
    [anon_sym_mutable] = ACTIONS(7266),
    [anon_sym_constinit] = ACTIONS(7266),
    [anon_sym_consteval] = ACTIONS(7266),
    [anon_sym_alignas] = ACTIONS(7270),
    [anon_sym__Alignas] = ACTIONS(7270),
    [sym_primitive_type] = ACTIONS(7309),
    [anon_sym_QMARK] = ACTIONS(3542),
    [anon_sym_LT_EQ_GT] = ACTIONS(3542),
    [anon_sym_or] = ACTIONS(3540),
    [anon_sym_and] = ACTIONS(3540),
    [anon_sym_bitor] = ACTIONS(3540),
    [anon_sym_xor] = ACTIONS(3540),
    [anon_sym_bitand] = ACTIONS(3540),
    [anon_sym_not_eq] = ACTIONS(3540),
    [anon_sym_is] = ACTIONS(3540),
    [anon_sym_as] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(3542),
    [anon_sym_PLUS_PLUS] = ACTIONS(3542),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_DOT_STAR] = ACTIONS(3542),
    [anon_sym_DASH_GT] = ACTIONS(3542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3540),
    [anon_sym_let] = ACTIONS(3540),
    [anon_sym_This] = ACTIONS(3540),
  },
  [3075] = {
    [sym_identifier] = ACTIONS(4252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4254),
    [anon_sym_COMMA] = ACTIONS(4254),
    [anon_sym_RPAREN] = ACTIONS(4254),
    [anon_sym_LPAREN2] = ACTIONS(4254),
    [anon_sym_TILDE] = ACTIONS(4254),
    [anon_sym_STAR] = ACTIONS(4254),
    [anon_sym_AMP_AMP] = ACTIONS(4254),
    [anon_sym_AMP] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(4252),
    [anon_sym___extension__] = ACTIONS(4252),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_out] = ACTIONS(4252),
    [anon_sym_inout] = ACTIONS(4252),
    [anon_sym_virtual] = ACTIONS(4252),
    [anon_sym_extern] = ACTIONS(4252),
    [anon_sym___attribute__] = ACTIONS(4252),
    [anon_sym___attribute] = ACTIONS(4252),
    [anon_sym_COLON_COLON] = ACTIONS(4254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4254),
    [anon_sym___declspec] = ACTIONS(4252),
    [anon_sym___based] = ACTIONS(4252),
    [anon_sym_LBRACK] = ACTIONS(4252),
    [anon_sym_static] = ACTIONS(4252),
    [anon_sym_EQ] = ACTIONS(4254),
    [anon_sym_register] = ACTIONS(4252),
    [anon_sym_inline] = ACTIONS(4252),
    [anon_sym___inline] = ACTIONS(4252),
    [anon_sym___inline__] = ACTIONS(4252),
    [anon_sym___forceinline] = ACTIONS(4252),
    [anon_sym_thread_local] = ACTIONS(4252),
    [anon_sym___thread] = ACTIONS(4252),
    [anon_sym_const] = ACTIONS(4252),
    [anon_sym_constexpr] = ACTIONS(4252),
    [anon_sym_volatile] = ACTIONS(4252),
    [anon_sym_restrict] = ACTIONS(4252),
    [anon_sym___restrict__] = ACTIONS(4252),
    [anon_sym__Atomic] = ACTIONS(4252),
    [anon_sym__Noreturn] = ACTIONS(4252),
    [anon_sym_noreturn] = ACTIONS(4252),
    [anon_sym__Nonnull] = ACTIONS(4252),
    [anon_sym_mutable] = ACTIONS(4252),
    [anon_sym_constinit] = ACTIONS(4252),
    [anon_sym_consteval] = ACTIONS(4252),
    [anon_sym_alignas] = ACTIONS(4252),
    [anon_sym__Alignas] = ACTIONS(4252),
    [anon_sym_DOT] = ACTIONS(6997),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6959),
    [anon_sym_let] = ACTIONS(6959),
    [anon_sym_This] = ACTIONS(6959),
    [anon_sym_decltype] = ACTIONS(4252),
    [anon_sym_template] = ACTIONS(4252),
    [anon_sym_GT2] = ACTIONS(4254),
    [anon_sym_operator] = ACTIONS(4252),
    [anon_sym_precise] = ACTIONS(4252),
    [anon_sym_shared] = ACTIONS(4252),
    [anon_sym_groupshared] = ACTIONS(4252),
    [anon_sym_uniform] = ACTIONS(4252),
    [anon_sym_row_major] = ACTIONS(4252),
    [anon_sym_column_major] = ACTIONS(4252),
    [anon_sym_globallycoherent] = ACTIONS(4252),
    [anon_sym_centroid] = ACTIONS(4252),
    [anon_sym_noperspective] = ACTIONS(4252),
    [anon_sym_nointerpolation] = ACTIONS(4252),
    [anon_sym_sample] = ACTIONS(4252),
    [anon_sym_linear] = ACTIONS(4252),
    [anon_sym_snorm] = ACTIONS(4252),
    [anon_sym_unorm] = ACTIONS(4252),
    [anon_sym_point] = ACTIONS(4252),
    [anon_sym_line] = ACTIONS(4252),
    [anon_sym_triangleadj] = ACTIONS(4252),
    [anon_sym_lineadj] = ACTIONS(4252),
    [anon_sym_triangle] = ACTIONS(4252),
  },
  [3076] = {
    [sym_identifier] = ACTIONS(7311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7313),
    [anon_sym_COMMA] = ACTIONS(7313),
    [anon_sym_RPAREN] = ACTIONS(7313),
    [aux_sym_preproc_if_token2] = ACTIONS(7313),
    [aux_sym_preproc_else_token1] = ACTIONS(7313),
    [aux_sym_preproc_elif_token1] = ACTIONS(7311),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7313),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7313),
    [anon_sym_LPAREN2] = ACTIONS(7313),
    [anon_sym_DASH] = ACTIONS(7311),
    [anon_sym_PLUS] = ACTIONS(7311),
    [anon_sym_STAR] = ACTIONS(7311),
    [anon_sym_SLASH] = ACTIONS(7311),
    [anon_sym_PERCENT] = ACTIONS(7311),
    [anon_sym_PIPE_PIPE] = ACTIONS(7313),
    [anon_sym_AMP_AMP] = ACTIONS(7313),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_CARET] = ACTIONS(7311),
    [anon_sym_AMP] = ACTIONS(7311),
    [anon_sym_EQ_EQ] = ACTIONS(7313),
    [anon_sym_BANG_EQ] = ACTIONS(7313),
    [anon_sym_GT] = ACTIONS(7311),
    [anon_sym_GT_EQ] = ACTIONS(7313),
    [anon_sym_LT_EQ] = ACTIONS(7311),
    [anon_sym_LT] = ACTIONS(7311),
    [anon_sym_LT_LT] = ACTIONS(7311),
    [anon_sym_GT_GT] = ACTIONS(7311),
    [anon_sym_COLON] = ACTIONS(7313),
    [anon_sym_SEMI] = ACTIONS(7313),
    [anon_sym_RBRACE] = ACTIONS(7313),
    [anon_sym_LBRACK] = ACTIONS(7313),
    [anon_sym_RBRACK] = ACTIONS(7313),
    [anon_sym_EQ] = ACTIONS(7311),
    [anon_sym_QMARK] = ACTIONS(7313),
    [anon_sym_STAR_EQ] = ACTIONS(7313),
    [anon_sym_SLASH_EQ] = ACTIONS(7313),
    [anon_sym_PERCENT_EQ] = ACTIONS(7313),
    [anon_sym_PLUS_EQ] = ACTIONS(7313),
    [anon_sym_DASH_EQ] = ACTIONS(7313),
    [anon_sym_LT_LT_EQ] = ACTIONS(7313),
    [anon_sym_GT_GT_EQ] = ACTIONS(7313),
    [anon_sym_AMP_EQ] = ACTIONS(7313),
    [anon_sym_CARET_EQ] = ACTIONS(7313),
    [anon_sym_PIPE_EQ] = ACTIONS(7313),
    [anon_sym_and_eq] = ACTIONS(7311),
    [anon_sym_or_eq] = ACTIONS(7311),
    [anon_sym_xor_eq] = ACTIONS(7311),
    [anon_sym_LT_EQ_GT] = ACTIONS(7313),
    [anon_sym_or] = ACTIONS(7311),
    [anon_sym_and] = ACTIONS(7311),
    [anon_sym_bitor] = ACTIONS(7311),
    [anon_sym_xor] = ACTIONS(7311),
    [anon_sym_bitand] = ACTIONS(7311),
    [anon_sym_not_eq] = ACTIONS(7311),
    [anon_sym_is] = ACTIONS(7311),
    [anon_sym_as] = ACTIONS(7311),
    [anon_sym_DASH_DASH] = ACTIONS(7313),
    [anon_sym_PLUS_PLUS] = ACTIONS(7313),
    [anon_sym_DOT] = ACTIONS(7311),
    [anon_sym_DOT_STAR] = ACTIONS(7313),
    [anon_sym_DASH_GT] = ACTIONS(7313),
    [anon_sym_L_DQUOTE] = ACTIONS(7313),
    [anon_sym_u_DQUOTE] = ACTIONS(7313),
    [anon_sym_U_DQUOTE] = ACTIONS(7313),
    [anon_sym_u8_DQUOTE] = ACTIONS(7313),
    [anon_sym_DQUOTE] = ACTIONS(7313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7313),
    [anon_sym_LR_DQUOTE] = ACTIONS(7313),
    [anon_sym_uR_DQUOTE] = ACTIONS(7313),
    [anon_sym_UR_DQUOTE] = ACTIONS(7313),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7313),
    [sym_literal_suffix] = ACTIONS(7311),
  },
  [3077] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2247),
    [anon_sym_COMMA] = ACTIONS(2247),
    [anon_sym_LPAREN2] = ACTIONS(2247),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_SLASH] = ACTIONS(2255),
    [anon_sym_PERCENT] = ACTIONS(2255),
    [anon_sym_PIPE_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2255),
    [anon_sym_CARET] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2245),
    [anon_sym_BANG_EQ] = ACTIONS(2245),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_GT_EQ] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2255),
    [anon_sym_LT] = ACTIONS(2255),
    [anon_sym_LT_LT] = ACTIONS(2255),
    [anon_sym_GT_GT] = ACTIONS(2255),
    [anon_sym_COLON] = ACTIONS(2243),
    [anon_sym___extension__] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2247),
    [anon_sym_EQ] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2250),
    [anon_sym_volatile] = ACTIONS(2250),
    [anon_sym_restrict] = ACTIONS(2250),
    [anon_sym___restrict__] = ACTIONS(2250),
    [anon_sym__Atomic] = ACTIONS(2250),
    [anon_sym__Noreturn] = ACTIONS(2250),
    [anon_sym_noreturn] = ACTIONS(2250),
    [anon_sym__Nonnull] = ACTIONS(2250),
    [anon_sym_mutable] = ACTIONS(2250),
    [anon_sym_constinit] = ACTIONS(2250),
    [anon_sym_consteval] = ACTIONS(2250),
    [anon_sym_alignas] = ACTIONS(2250),
    [anon_sym__Alignas] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2245),
    [anon_sym_STAR_EQ] = ACTIONS(2245),
    [anon_sym_SLASH_EQ] = ACTIONS(2245),
    [anon_sym_PERCENT_EQ] = ACTIONS(2245),
    [anon_sym_PLUS_EQ] = ACTIONS(2245),
    [anon_sym_DASH_EQ] = ACTIONS(2245),
    [anon_sym_LT_LT_EQ] = ACTIONS(2245),
    [anon_sym_GT_GT_EQ] = ACTIONS(2255),
    [anon_sym_AMP_EQ] = ACTIONS(2245),
    [anon_sym_CARET_EQ] = ACTIONS(2245),
    [anon_sym_PIPE_EQ] = ACTIONS(2245),
    [anon_sym_and_eq] = ACTIONS(2245),
    [anon_sym_or_eq] = ACTIONS(2245),
    [anon_sym_xor_eq] = ACTIONS(2245),
    [anon_sym_LT_EQ_GT] = ACTIONS(2245),
    [anon_sym_or] = ACTIONS(2255),
    [anon_sym_and] = ACTIONS(2255),
    [anon_sym_bitor] = ACTIONS(2245),
    [anon_sym_xor] = ACTIONS(2255),
    [anon_sym_bitand] = ACTIONS(2245),
    [anon_sym_not_eq] = ACTIONS(2245),
    [anon_sym_is] = ACTIONS(2245),
    [anon_sym_as] = ACTIONS(2245),
    [anon_sym_DASH_DASH] = ACTIONS(2245),
    [anon_sym_PLUS_PLUS] = ACTIONS(2245),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2245),
    [anon_sym_DASH_GT] = ACTIONS(2245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_This] = ACTIONS(2250),
    [anon_sym_GT2] = ACTIONS(2247),
  },
  [3078] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(4695),
    [sym_raw_string_literal] = STATE(3527),
    [sym_identifier] = ACTIONS(2181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [aux_sym_preproc_if_token2] = ACTIONS(2170),
    [aux_sym_preproc_else_token1] = ACTIONS(2170),
    [aux_sym_preproc_elif_token1] = ACTIONS(2181),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2170),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(7315),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_EQ] = ACTIONS(7318),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(7320),
    [anon_sym_SLASH_EQ] = ACTIONS(7320),
    [anon_sym_PERCENT_EQ] = ACTIONS(7320),
    [anon_sym_PLUS_EQ] = ACTIONS(7320),
    [anon_sym_DASH_EQ] = ACTIONS(7320),
    [anon_sym_LT_LT_EQ] = ACTIONS(7320),
    [anon_sym_GT_GT_EQ] = ACTIONS(7320),
    [anon_sym_AMP_EQ] = ACTIONS(7320),
    [anon_sym_CARET_EQ] = ACTIONS(7320),
    [anon_sym_PIPE_EQ] = ACTIONS(7320),
    [anon_sym_and_eq] = ACTIONS(7318),
    [anon_sym_or_eq] = ACTIONS(7318),
    [anon_sym_xor_eq] = ACTIONS(7318),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
  },
  [3079] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3085),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4113),
    [anon_sym_COMMA] = ACTIONS(4113),
    [anon_sym_RPAREN] = ACTIONS(4113),
    [anon_sym_LPAREN2] = ACTIONS(4113),
    [anon_sym_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4111),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_SLASH] = ACTIONS(4111),
    [anon_sym_PERCENT] = ACTIONS(4113),
    [anon_sym_PIPE_PIPE] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4111),
    [anon_sym_CARET] = ACTIONS(4113),
    [anon_sym_AMP] = ACTIONS(4111),
    [anon_sym_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_COLON] = ACTIONS(4113),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym___extension__] = ACTIONS(4113),
    [anon_sym___attribute__] = ACTIONS(4113),
    [anon_sym___attribute] = ACTIONS(4111),
    [anon_sym_LBRACE] = ACTIONS(4113),
    [anon_sym_RBRACE] = ACTIONS(4113),
    [anon_sym_signed] = ACTIONS(7322),
    [anon_sym_unsigned] = ACTIONS(7322),
    [anon_sym_long] = ACTIONS(7322),
    [anon_sym_short] = ACTIONS(7322),
    [anon_sym_LBRACK] = ACTIONS(4113),
    [anon_sym_RBRACK] = ACTIONS(4113),
    [anon_sym_const] = ACTIONS(4111),
    [anon_sym_constexpr] = ACTIONS(4113),
    [anon_sym_volatile] = ACTIONS(4113),
    [anon_sym_restrict] = ACTIONS(4113),
    [anon_sym___restrict__] = ACTIONS(4113),
    [anon_sym__Atomic] = ACTIONS(4113),
    [anon_sym__Noreturn] = ACTIONS(4113),
    [anon_sym_noreturn] = ACTIONS(4113),
    [anon_sym__Nonnull] = ACTIONS(4113),
    [anon_sym_mutable] = ACTIONS(4113),
    [anon_sym_constinit] = ACTIONS(4113),
    [anon_sym_consteval] = ACTIONS(4113),
    [anon_sym_alignas] = ACTIONS(4113),
    [anon_sym__Alignas] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_LT_EQ_GT] = ACTIONS(4113),
    [anon_sym_or] = ACTIONS(4113),
    [anon_sym_and] = ACTIONS(4113),
    [anon_sym_bitor] = ACTIONS(4113),
    [anon_sym_xor] = ACTIONS(4113),
    [anon_sym_bitand] = ACTIONS(4113),
    [anon_sym_not_eq] = ACTIONS(4113),
    [anon_sym_is] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4113),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(4111),
    [anon_sym_DOT_STAR] = ACTIONS(4113),
    [anon_sym_DASH_GT] = ACTIONS(4113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_This] = ACTIONS(4113),
    [anon_sym_final] = ACTIONS(4113),
    [anon_sym_override] = ACTIONS(4113),
    [anon_sym_requires] = ACTIONS(4113),
    [anon_sym_where] = ACTIONS(4113),
  },
  [3080] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3089),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4051),
    [anon_sym_COMMA] = ACTIONS(4051),
    [anon_sym_RPAREN] = ACTIONS(4051),
    [anon_sym_LPAREN2] = ACTIONS(4051),
    [anon_sym_DASH] = ACTIONS(4053),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_STAR] = ACTIONS(4051),
    [anon_sym_SLASH] = ACTIONS(4053),
    [anon_sym_PERCENT] = ACTIONS(4051),
    [anon_sym_PIPE_PIPE] = ACTIONS(4051),
    [anon_sym_AMP_AMP] = ACTIONS(4051),
    [anon_sym_PIPE] = ACTIONS(4053),
    [anon_sym_CARET] = ACTIONS(4051),
    [anon_sym_AMP] = ACTIONS(4053),
    [anon_sym_EQ_EQ] = ACTIONS(4051),
    [anon_sym_BANG_EQ] = ACTIONS(4051),
    [anon_sym_GT] = ACTIONS(4053),
    [anon_sym_GT_EQ] = ACTIONS(4051),
    [anon_sym_LT_EQ] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4051),
    [anon_sym_GT_GT] = ACTIONS(4051),
    [anon_sym_COLON] = ACTIONS(4051),
    [anon_sym_SEMI] = ACTIONS(4051),
    [anon_sym___extension__] = ACTIONS(4051),
    [anon_sym___attribute__] = ACTIONS(4051),
    [anon_sym___attribute] = ACTIONS(4053),
    [anon_sym_LBRACE] = ACTIONS(4051),
    [anon_sym_RBRACE] = ACTIONS(4051),
    [anon_sym_signed] = ACTIONS(7324),
    [anon_sym_unsigned] = ACTIONS(7324),
    [anon_sym_long] = ACTIONS(7324),
    [anon_sym_short] = ACTIONS(7324),
    [anon_sym_LBRACK] = ACTIONS(4051),
    [anon_sym_RBRACK] = ACTIONS(4051),
    [anon_sym_const] = ACTIONS(4053),
    [anon_sym_constexpr] = ACTIONS(4051),
    [anon_sym_volatile] = ACTIONS(4051),
    [anon_sym_restrict] = ACTIONS(4051),
    [anon_sym___restrict__] = ACTIONS(4051),
    [anon_sym__Atomic] = ACTIONS(4051),
    [anon_sym__Noreturn] = ACTIONS(4051),
    [anon_sym_noreturn] = ACTIONS(4051),
    [anon_sym__Nonnull] = ACTIONS(4051),
    [anon_sym_mutable] = ACTIONS(4051),
    [anon_sym_constinit] = ACTIONS(4051),
    [anon_sym_consteval] = ACTIONS(4051),
    [anon_sym_alignas] = ACTIONS(4051),
    [anon_sym__Alignas] = ACTIONS(4051),
    [anon_sym_QMARK] = ACTIONS(4051),
    [anon_sym_LT_EQ_GT] = ACTIONS(4051),
    [anon_sym_or] = ACTIONS(4051),
    [anon_sym_and] = ACTIONS(4051),
    [anon_sym_bitor] = ACTIONS(4051),
    [anon_sym_xor] = ACTIONS(4051),
    [anon_sym_bitand] = ACTIONS(4051),
    [anon_sym_not_eq] = ACTIONS(4051),
    [anon_sym_is] = ACTIONS(4051),
    [anon_sym_as] = ACTIONS(4051),
    [anon_sym_DASH_DASH] = ACTIONS(4051),
    [anon_sym_PLUS_PLUS] = ACTIONS(4051),
    [anon_sym_DOT] = ACTIONS(4053),
    [anon_sym_DOT_STAR] = ACTIONS(4051),
    [anon_sym_DASH_GT] = ACTIONS(4051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4051),
    [anon_sym_let] = ACTIONS(4051),
    [anon_sym_This] = ACTIONS(4051),
    [anon_sym_final] = ACTIONS(4051),
    [anon_sym_override] = ACTIONS(4051),
    [anon_sym_requires] = ACTIONS(4051),
    [anon_sym_where] = ACTIONS(4051),
  },
  [3081] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3093),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2881),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_SLASH] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_CARET] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_EQ_EQ] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_GT_EQ] = ACTIONS(2881),
    [anon_sym_LT_EQ] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_LT_LT] = ACTIONS(2881),
    [anon_sym_GT_GT] = ACTIONS(2881),
    [anon_sym_COLON] = ACTIONS(2881),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___extension__] = ACTIONS(2881),
    [anon_sym___attribute__] = ACTIONS(2881),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_RBRACE] = ACTIONS(2881),
    [anon_sym_signed] = ACTIONS(7326),
    [anon_sym_unsigned] = ACTIONS(7326),
    [anon_sym_long] = ACTIONS(7326),
    [anon_sym_short] = ACTIONS(7326),
    [anon_sym_LBRACK] = ACTIONS(2881),
    [anon_sym_RBRACK] = ACTIONS(2881),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2881),
    [anon_sym_volatile] = ACTIONS(2881),
    [anon_sym_restrict] = ACTIONS(2881),
    [anon_sym___restrict__] = ACTIONS(2881),
    [anon_sym__Atomic] = ACTIONS(2881),
    [anon_sym__Noreturn] = ACTIONS(2881),
    [anon_sym_noreturn] = ACTIONS(2881),
    [anon_sym__Nonnull] = ACTIONS(2881),
    [anon_sym_mutable] = ACTIONS(2881),
    [anon_sym_constinit] = ACTIONS(2881),
    [anon_sym_consteval] = ACTIONS(2881),
    [anon_sym_alignas] = ACTIONS(2881),
    [anon_sym__Alignas] = ACTIONS(2881),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_LT_EQ_GT] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2881),
    [anon_sym_and] = ACTIONS(2881),
    [anon_sym_bitor] = ACTIONS(2881),
    [anon_sym_xor] = ACTIONS(2881),
    [anon_sym_bitand] = ACTIONS(2881),
    [anon_sym_not_eq] = ACTIONS(2881),
    [anon_sym_is] = ACTIONS(2881),
    [anon_sym_as] = ACTIONS(2881),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_DOT_STAR] = ACTIONS(2881),
    [anon_sym_DASH_GT] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2881),
    [anon_sym_let] = ACTIONS(2881),
    [anon_sym_This] = ACTIONS(2881),
    [anon_sym_final] = ACTIONS(2881),
    [anon_sym_override] = ACTIONS(2881),
    [anon_sym_requires] = ACTIONS(2881),
    [anon_sym_where] = ACTIONS(2881),
  },
  [3082] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4180),
    [anon_sym_COMMA] = ACTIONS(4180),
    [anon_sym_RPAREN] = ACTIONS(4180),
    [anon_sym_LPAREN2] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4178),
    [anon_sym_PLUS] = ACTIONS(4178),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4178),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_PIPE] = ACTIONS(4178),
    [anon_sym_CARET] = ACTIONS(4180),
    [anon_sym_AMP] = ACTIONS(4178),
    [anon_sym_EQ_EQ] = ACTIONS(4180),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4178),
    [anon_sym_GT_EQ] = ACTIONS(4180),
    [anon_sym_LT_EQ] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_LT_LT] = ACTIONS(4180),
    [anon_sym_GT_GT] = ACTIONS(4180),
    [anon_sym_COLON] = ACTIONS(4180),
    [anon_sym_SEMI] = ACTIONS(4180),
    [anon_sym___extension__] = ACTIONS(4180),
    [anon_sym___attribute__] = ACTIONS(4180),
    [anon_sym___attribute] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_RBRACE] = ACTIONS(4180),
    [anon_sym_signed] = ACTIONS(7328),
    [anon_sym_unsigned] = ACTIONS(7328),
    [anon_sym_long] = ACTIONS(7328),
    [anon_sym_short] = ACTIONS(7328),
    [anon_sym_LBRACK] = ACTIONS(4180),
    [anon_sym_RBRACK] = ACTIONS(4180),
    [anon_sym_const] = ACTIONS(4178),
    [anon_sym_constexpr] = ACTIONS(4180),
    [anon_sym_volatile] = ACTIONS(4180),
    [anon_sym_restrict] = ACTIONS(4180),
    [anon_sym___restrict__] = ACTIONS(4180),
    [anon_sym__Atomic] = ACTIONS(4180),
    [anon_sym__Noreturn] = ACTIONS(4180),
    [anon_sym_noreturn] = ACTIONS(4180),
    [anon_sym__Nonnull] = ACTIONS(4180),
    [anon_sym_mutable] = ACTIONS(4180),
    [anon_sym_constinit] = ACTIONS(4180),
    [anon_sym_consteval] = ACTIONS(4180),
    [anon_sym_alignas] = ACTIONS(4180),
    [anon_sym__Alignas] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_and] = ACTIONS(4180),
    [anon_sym_bitor] = ACTIONS(4180),
    [anon_sym_xor] = ACTIONS(4180),
    [anon_sym_bitand] = ACTIONS(4180),
    [anon_sym_not_eq] = ACTIONS(4180),
    [anon_sym_is] = ACTIONS(4180),
    [anon_sym_as] = ACTIONS(4180),
    [anon_sym_DASH_DASH] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4178),
    [anon_sym_DOT_STAR] = ACTIONS(4180),
    [anon_sym_DASH_GT] = ACTIONS(4180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4180),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_This] = ACTIONS(4180),
    [anon_sym_final] = ACTIONS(4180),
    [anon_sym_override] = ACTIONS(4180),
    [anon_sym_requires] = ACTIONS(4180),
    [anon_sym_where] = ACTIONS(4180),
  },
  [3083] = {
    [sym_template_argument_list] = STATE(3342),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2764),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_LPAREN2] = ACTIONS(2193),
    [anon_sym_STAR] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_AMP] = ACTIONS(2168),
    [anon_sym_LT] = ACTIONS(7064),
    [anon_sym_SEMI] = ACTIONS(2176),
    [anon_sym___extension__] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2168),
    [anon_sym_out] = ACTIONS(2168),
    [anon_sym_inout] = ACTIONS(2168),
    [anon_sym_virtual] = ACTIONS(2168),
    [anon_sym_extern] = ACTIONS(2168),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2193),
    [anon_sym___declspec] = ACTIONS(2168),
    [anon_sym___based] = ACTIONS(2168),
    [anon_sym_signed] = ACTIONS(5332),
    [anon_sym_unsigned] = ACTIONS(5332),
    [anon_sym_long] = ACTIONS(5332),
    [anon_sym_short] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(7330),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_register] = ACTIONS(2168),
    [anon_sym_inline] = ACTIONS(2168),
    [anon_sym___inline] = ACTIONS(2168),
    [anon_sym___inline__] = ACTIONS(2168),
    [anon_sym___forceinline] = ACTIONS(2168),
    [anon_sym_thread_local] = ACTIONS(2168),
    [anon_sym___thread] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_constexpr] = ACTIONS(2168),
    [anon_sym_volatile] = ACTIONS(2168),
    [anon_sym_restrict] = ACTIONS(2168),
    [anon_sym___restrict__] = ACTIONS(2168),
    [anon_sym__Atomic] = ACTIONS(2168),
    [anon_sym__Noreturn] = ACTIONS(2168),
    [anon_sym_noreturn] = ACTIONS(2168),
    [anon_sym__Nonnull] = ACTIONS(2168),
    [anon_sym_mutable] = ACTIONS(2168),
    [anon_sym_constinit] = ACTIONS(2168),
    [anon_sym_consteval] = ACTIONS(2168),
    [anon_sym_alignas] = ACTIONS(2168),
    [anon_sym__Alignas] = ACTIONS(2168),
    [anon_sym_DOT] = ACTIONS(2176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
    [anon_sym_operator] = ACTIONS(2168),
    [anon_sym_precise] = ACTIONS(2168),
    [anon_sym_shared] = ACTIONS(2168),
    [anon_sym_groupshared] = ACTIONS(2168),
    [anon_sym_uniform] = ACTIONS(2168),
    [anon_sym_row_major] = ACTIONS(2168),
    [anon_sym_column_major] = ACTIONS(2168),
    [anon_sym_globallycoherent] = ACTIONS(2168),
    [anon_sym_centroid] = ACTIONS(2168),
    [anon_sym_noperspective] = ACTIONS(2168),
    [anon_sym_nointerpolation] = ACTIONS(2168),
    [anon_sym_sample] = ACTIONS(2168),
    [anon_sym_linear] = ACTIONS(2168),
    [anon_sym_snorm] = ACTIONS(2168),
    [anon_sym_unorm] = ACTIONS(2168),
    [anon_sym_point] = ACTIONS(2168),
    [anon_sym_line] = ACTIONS(2168),
    [anon_sym_triangleadj] = ACTIONS(2168),
    [anon_sym_lineadj] = ACTIONS(2168),
    [anon_sym_triangle] = ACTIONS(2168),
  },
  [3084] = {
    [sym_attribute_specifier] = STATE(2882),
    [sym_field_declaration_list] = STATE(2816),
    [sym_virtual_specifier] = STATE(9396),
    [sym_base_class_clause] = STATE(10585),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(7252),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_out] = ACTIONS(2893),
    [anon_sym_inout] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(6858),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym__Nonnull] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym__Alignas] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_This] = ACTIONS(2893),
    [anon_sym_final] = ACTIONS(2564),
    [anon_sym_override] = ACTIONS(2564),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_precise] = ACTIONS(2893),
    [anon_sym_shared] = ACTIONS(2893),
    [anon_sym_groupshared] = ACTIONS(2893),
    [anon_sym_uniform] = ACTIONS(2893),
    [anon_sym_row_major] = ACTIONS(2893),
    [anon_sym_column_major] = ACTIONS(2893),
    [anon_sym_globallycoherent] = ACTIONS(2893),
    [anon_sym_centroid] = ACTIONS(2893),
    [anon_sym_noperspective] = ACTIONS(2893),
    [anon_sym_nointerpolation] = ACTIONS(2893),
    [anon_sym_sample] = ACTIONS(2893),
    [anon_sym_linear] = ACTIONS(2893),
    [anon_sym_snorm] = ACTIONS(2893),
    [anon_sym_unorm] = ACTIONS(2893),
    [anon_sym_point] = ACTIONS(2893),
    [anon_sym_line] = ACTIONS(2893),
    [anon_sym_triangleadj] = ACTIONS(2893),
    [anon_sym_lineadj] = ACTIONS(2893),
    [anon_sym_triangle] = ACTIONS(2893),
  },
  [3085] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3997),
    [anon_sym_COMMA] = ACTIONS(3997),
    [anon_sym_RPAREN] = ACTIONS(3997),
    [anon_sym_LPAREN2] = ACTIONS(3997),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_STAR] = ACTIONS(3997),
    [anon_sym_SLASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3997),
    [anon_sym_PIPE_PIPE] = ACTIONS(3997),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_PIPE] = ACTIONS(3995),
    [anon_sym_CARET] = ACTIONS(3997),
    [anon_sym_AMP] = ACTIONS(3995),
    [anon_sym_EQ_EQ] = ACTIONS(3997),
    [anon_sym_BANG_EQ] = ACTIONS(3997),
    [anon_sym_GT] = ACTIONS(3995),
    [anon_sym_GT_EQ] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3995),
    [anon_sym_LT] = ACTIONS(3995),
    [anon_sym_LT_LT] = ACTIONS(3997),
    [anon_sym_GT_GT] = ACTIONS(3997),
    [anon_sym_COLON] = ACTIONS(3997),
    [anon_sym_SEMI] = ACTIONS(3997),
    [anon_sym___extension__] = ACTIONS(3997),
    [anon_sym___attribute__] = ACTIONS(3997),
    [anon_sym___attribute] = ACTIONS(3995),
    [anon_sym_LBRACE] = ACTIONS(3997),
    [anon_sym_RBRACE] = ACTIONS(3997),
    [anon_sym_signed] = ACTIONS(7332),
    [anon_sym_unsigned] = ACTIONS(7332),
    [anon_sym_long] = ACTIONS(7332),
    [anon_sym_short] = ACTIONS(7332),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_RBRACK] = ACTIONS(3997),
    [anon_sym_const] = ACTIONS(3995),
    [anon_sym_constexpr] = ACTIONS(3997),
    [anon_sym_volatile] = ACTIONS(3997),
    [anon_sym_restrict] = ACTIONS(3997),
    [anon_sym___restrict__] = ACTIONS(3997),
    [anon_sym__Atomic] = ACTIONS(3997),
    [anon_sym__Noreturn] = ACTIONS(3997),
    [anon_sym_noreturn] = ACTIONS(3997),
    [anon_sym__Nonnull] = ACTIONS(3997),
    [anon_sym_mutable] = ACTIONS(3997),
    [anon_sym_constinit] = ACTIONS(3997),
    [anon_sym_consteval] = ACTIONS(3997),
    [anon_sym_alignas] = ACTIONS(3997),
    [anon_sym__Alignas] = ACTIONS(3997),
    [anon_sym_QMARK] = ACTIONS(3997),
    [anon_sym_LT_EQ_GT] = ACTIONS(3997),
    [anon_sym_or] = ACTIONS(3997),
    [anon_sym_and] = ACTIONS(3997),
    [anon_sym_bitor] = ACTIONS(3997),
    [anon_sym_xor] = ACTIONS(3997),
    [anon_sym_bitand] = ACTIONS(3997),
    [anon_sym_not_eq] = ACTIONS(3997),
    [anon_sym_is] = ACTIONS(3997),
    [anon_sym_as] = ACTIONS(3997),
    [anon_sym_DASH_DASH] = ACTIONS(3997),
    [anon_sym_PLUS_PLUS] = ACTIONS(3997),
    [anon_sym_DOT] = ACTIONS(3995),
    [anon_sym_DOT_STAR] = ACTIONS(3997),
    [anon_sym_DASH_GT] = ACTIONS(3997),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3997),
    [anon_sym_let] = ACTIONS(3997),
    [anon_sym_This] = ACTIONS(3997),
    [anon_sym_final] = ACTIONS(3997),
    [anon_sym_override] = ACTIONS(3997),
    [anon_sym_requires] = ACTIONS(3997),
    [anon_sym_where] = ACTIONS(3997),
  },
  [3086] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4095),
    [anon_sym_COMMA] = ACTIONS(4095),
    [anon_sym_RPAREN] = ACTIONS(4095),
    [anon_sym_LPAREN2] = ACTIONS(4095),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_SLASH] = ACTIONS(4093),
    [anon_sym_PERCENT] = ACTIONS(4095),
    [anon_sym_PIPE_PIPE] = ACTIONS(4095),
    [anon_sym_AMP_AMP] = ACTIONS(4095),
    [anon_sym_PIPE] = ACTIONS(4093),
    [anon_sym_CARET] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_EQ_EQ] = ACTIONS(4095),
    [anon_sym_BANG_EQ] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_GT_EQ] = ACTIONS(4095),
    [anon_sym_LT_EQ] = ACTIONS(4093),
    [anon_sym_LT] = ACTIONS(4093),
    [anon_sym_LT_LT] = ACTIONS(4095),
    [anon_sym_GT_GT] = ACTIONS(4095),
    [anon_sym_COLON] = ACTIONS(4095),
    [anon_sym_SEMI] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4095),
    [anon_sym___attribute__] = ACTIONS(4095),
    [anon_sym___attribute] = ACTIONS(4093),
    [anon_sym_LBRACE] = ACTIONS(4095),
    [anon_sym_RBRACE] = ACTIONS(4095),
    [anon_sym_signed] = ACTIONS(7332),
    [anon_sym_unsigned] = ACTIONS(7332),
    [anon_sym_long] = ACTIONS(7332),
    [anon_sym_short] = ACTIONS(7332),
    [anon_sym_LBRACK] = ACTIONS(4095),
    [anon_sym_RBRACK] = ACTIONS(4095),
    [anon_sym_const] = ACTIONS(4093),
    [anon_sym_constexpr] = ACTIONS(4095),
    [anon_sym_volatile] = ACTIONS(4095),
    [anon_sym_restrict] = ACTIONS(4095),
    [anon_sym___restrict__] = ACTIONS(4095),
    [anon_sym__Atomic] = ACTIONS(4095),
    [anon_sym__Noreturn] = ACTIONS(4095),
    [anon_sym_noreturn] = ACTIONS(4095),
    [anon_sym__Nonnull] = ACTIONS(4095),
    [anon_sym_mutable] = ACTIONS(4095),
    [anon_sym_constinit] = ACTIONS(4095),
    [anon_sym_consteval] = ACTIONS(4095),
    [anon_sym_alignas] = ACTIONS(4095),
    [anon_sym__Alignas] = ACTIONS(4095),
    [anon_sym_QMARK] = ACTIONS(4095),
    [anon_sym_LT_EQ_GT] = ACTIONS(4095),
    [anon_sym_or] = ACTIONS(4095),
    [anon_sym_and] = ACTIONS(4095),
    [anon_sym_bitor] = ACTIONS(4095),
    [anon_sym_xor] = ACTIONS(4095),
    [anon_sym_bitand] = ACTIONS(4095),
    [anon_sym_not_eq] = ACTIONS(4095),
    [anon_sym_is] = ACTIONS(4095),
    [anon_sym_as] = ACTIONS(4095),
    [anon_sym_DASH_DASH] = ACTIONS(4095),
    [anon_sym_PLUS_PLUS] = ACTIONS(4095),
    [anon_sym_DOT] = ACTIONS(4093),
    [anon_sym_DOT_STAR] = ACTIONS(4095),
    [anon_sym_DASH_GT] = ACTIONS(4095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4095),
    [anon_sym_let] = ACTIONS(4095),
    [anon_sym_This] = ACTIONS(4095),
    [anon_sym_final] = ACTIONS(4095),
    [anon_sym_override] = ACTIONS(4095),
    [anon_sym_requires] = ACTIONS(4095),
    [anon_sym_where] = ACTIONS(4095),
  },
  [3087] = {
    [sym_template_argument_list] = STATE(3108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2224),
    [anon_sym_RPAREN] = ACTIONS(2226),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2231),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_PIPE_PIPE] = ACTIONS(2224),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_EQ_EQ] = ACTIONS(2224),
    [anon_sym_BANG_EQ] = ACTIONS(2224),
    [anon_sym_GT] = ACTIONS(2234),
    [anon_sym_GT_EQ] = ACTIONS(2224),
    [anon_sym_LT_EQ] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(7334),
    [anon_sym_LT_LT] = ACTIONS(2234),
    [anon_sym_GT_GT] = ACTIONS(2234),
    [anon_sym___extension__] = ACTIONS(2229),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2229),
    [anon_sym_volatile] = ACTIONS(2229),
    [anon_sym_restrict] = ACTIONS(2229),
    [anon_sym___restrict__] = ACTIONS(2229),
    [anon_sym__Atomic] = ACTIONS(2229),
    [anon_sym__Noreturn] = ACTIONS(2229),
    [anon_sym_noreturn] = ACTIONS(2229),
    [anon_sym__Nonnull] = ACTIONS(2229),
    [anon_sym_mutable] = ACTIONS(2229),
    [anon_sym_constinit] = ACTIONS(2229),
    [anon_sym_consteval] = ACTIONS(2229),
    [anon_sym_alignas] = ACTIONS(2229),
    [anon_sym__Alignas] = ACTIONS(2229),
    [anon_sym_QMARK] = ACTIONS(2224),
    [anon_sym_STAR_EQ] = ACTIONS(2224),
    [anon_sym_SLASH_EQ] = ACTIONS(2224),
    [anon_sym_PERCENT_EQ] = ACTIONS(2224),
    [anon_sym_PLUS_EQ] = ACTIONS(2224),
    [anon_sym_DASH_EQ] = ACTIONS(2224),
    [anon_sym_LT_LT_EQ] = ACTIONS(2224),
    [anon_sym_GT_GT_EQ] = ACTIONS(2224),
    [anon_sym_AMP_EQ] = ACTIONS(2224),
    [anon_sym_CARET_EQ] = ACTIONS(2224),
    [anon_sym_PIPE_EQ] = ACTIONS(2224),
    [anon_sym_and_eq] = ACTIONS(2224),
    [anon_sym_or_eq] = ACTIONS(2224),
    [anon_sym_xor_eq] = ACTIONS(2224),
    [anon_sym_LT_EQ_GT] = ACTIONS(2224),
    [anon_sym_or] = ACTIONS(2234),
    [anon_sym_and] = ACTIONS(2234),
    [anon_sym_bitor] = ACTIONS(2224),
    [anon_sym_xor] = ACTIONS(2234),
    [anon_sym_bitand] = ACTIONS(2224),
    [anon_sym_not_eq] = ACTIONS(2224),
    [anon_sym_is] = ACTIONS(2224),
    [anon_sym_as] = ACTIONS(2224),
    [anon_sym_DASH_DASH] = ACTIONS(2224),
    [anon_sym_PLUS_PLUS] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(2231),
    [anon_sym_DOT_STAR] = ACTIONS(2224),
    [anon_sym_DASH_GT] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2229),
    [anon_sym_let] = ACTIONS(2229),
    [anon_sym_This] = ACTIONS(2229),
  },
  [3088] = {
    [sym__declaration_modifiers] = STATE(2773),
    [sym_attribute_specifier] = STATE(2773),
    [sym_attribute_declaration] = STATE(2773),
    [sym_ms_declspec_modifier] = STATE(2773),
    [sym_storage_class_specifier] = STATE(2773),
    [sym_type_qualifier] = STATE(2773),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_qualifiers] = STATE(2773),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2773),
    [sym_identifier] = ACTIONS(6949),
    [anon_sym_LPAREN2] = ACTIONS(6951),
    [anon_sym_STAR] = ACTIONS(6951),
    [anon_sym_AMP_AMP] = ACTIONS(6951),
    [anon_sym_AMP] = ACTIONS(6949),
    [anon_sym_SEMI] = ACTIONS(6951),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(6955),
    [anon_sym_out] = ACTIONS(6955),
    [anon_sym_inout] = ACTIONS(6955),
    [anon_sym_virtual] = ACTIONS(6955),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(6949),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [anon_sym_DOT] = ACTIONS(7337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6959),
    [anon_sym_let] = ACTIONS(6959),
    [anon_sym_This] = ACTIONS(6959),
    [anon_sym_operator] = ACTIONS(6949),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [3089] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4100),
    [anon_sym_COMMA] = ACTIONS(4100),
    [anon_sym_RPAREN] = ACTIONS(4100),
    [anon_sym_LPAREN2] = ACTIONS(4100),
    [anon_sym_DASH] = ACTIONS(4102),
    [anon_sym_PLUS] = ACTIONS(4102),
    [anon_sym_STAR] = ACTIONS(4100),
    [anon_sym_SLASH] = ACTIONS(4102),
    [anon_sym_PERCENT] = ACTIONS(4100),
    [anon_sym_PIPE_PIPE] = ACTIONS(4100),
    [anon_sym_AMP_AMP] = ACTIONS(4100),
    [anon_sym_PIPE] = ACTIONS(4102),
    [anon_sym_CARET] = ACTIONS(4100),
    [anon_sym_AMP] = ACTIONS(4102),
    [anon_sym_EQ_EQ] = ACTIONS(4100),
    [anon_sym_BANG_EQ] = ACTIONS(4100),
    [anon_sym_GT] = ACTIONS(4102),
    [anon_sym_GT_EQ] = ACTIONS(4100),
    [anon_sym_LT_EQ] = ACTIONS(4102),
    [anon_sym_LT] = ACTIONS(4102),
    [anon_sym_LT_LT] = ACTIONS(4100),
    [anon_sym_GT_GT] = ACTIONS(4100),
    [anon_sym_COLON] = ACTIONS(4100),
    [anon_sym_SEMI] = ACTIONS(4100),
    [anon_sym___extension__] = ACTIONS(4100),
    [anon_sym___attribute__] = ACTIONS(4100),
    [anon_sym___attribute] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(4100),
    [anon_sym_RBRACE] = ACTIONS(4100),
    [anon_sym_signed] = ACTIONS(7332),
    [anon_sym_unsigned] = ACTIONS(7332),
    [anon_sym_long] = ACTIONS(7332),
    [anon_sym_short] = ACTIONS(7332),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_RBRACK] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_constexpr] = ACTIONS(4100),
    [anon_sym_volatile] = ACTIONS(4100),
    [anon_sym_restrict] = ACTIONS(4100),
    [anon_sym___restrict__] = ACTIONS(4100),
    [anon_sym__Atomic] = ACTIONS(4100),
    [anon_sym__Noreturn] = ACTIONS(4100),
    [anon_sym_noreturn] = ACTIONS(4100),
    [anon_sym__Nonnull] = ACTIONS(4100),
    [anon_sym_mutable] = ACTIONS(4100),
    [anon_sym_constinit] = ACTIONS(4100),
    [anon_sym_consteval] = ACTIONS(4100),
    [anon_sym_alignas] = ACTIONS(4100),
    [anon_sym__Alignas] = ACTIONS(4100),
    [anon_sym_QMARK] = ACTIONS(4100),
    [anon_sym_LT_EQ_GT] = ACTIONS(4100),
    [anon_sym_or] = ACTIONS(4100),
    [anon_sym_and] = ACTIONS(4100),
    [anon_sym_bitor] = ACTIONS(4100),
    [anon_sym_xor] = ACTIONS(4100),
    [anon_sym_bitand] = ACTIONS(4100),
    [anon_sym_not_eq] = ACTIONS(4100),
    [anon_sym_is] = ACTIONS(4100),
    [anon_sym_as] = ACTIONS(4100),
    [anon_sym_DASH_DASH] = ACTIONS(4100),
    [anon_sym_PLUS_PLUS] = ACTIONS(4100),
    [anon_sym_DOT] = ACTIONS(4102),
    [anon_sym_DOT_STAR] = ACTIONS(4100),
    [anon_sym_DASH_GT] = ACTIONS(4100),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4100),
    [anon_sym_let] = ACTIONS(4100),
    [anon_sym_This] = ACTIONS(4100),
    [anon_sym_final] = ACTIONS(4100),
    [anon_sym_override] = ACTIONS(4100),
    [anon_sym_requires] = ACTIONS(4100),
    [anon_sym_where] = ACTIONS(4100),
  },
  [3090] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4187),
    [anon_sym_COMMA] = ACTIONS(4187),
    [anon_sym_RPAREN] = ACTIONS(4187),
    [anon_sym_LPAREN2] = ACTIONS(4187),
    [anon_sym_DASH] = ACTIONS(4185),
    [anon_sym_PLUS] = ACTIONS(4185),
    [anon_sym_STAR] = ACTIONS(4187),
    [anon_sym_SLASH] = ACTIONS(4185),
    [anon_sym_PERCENT] = ACTIONS(4187),
    [anon_sym_PIPE_PIPE] = ACTIONS(4187),
    [anon_sym_AMP_AMP] = ACTIONS(4187),
    [anon_sym_PIPE] = ACTIONS(4185),
    [anon_sym_CARET] = ACTIONS(4187),
    [anon_sym_AMP] = ACTIONS(4185),
    [anon_sym_EQ_EQ] = ACTIONS(4187),
    [anon_sym_BANG_EQ] = ACTIONS(4187),
    [anon_sym_GT] = ACTIONS(4185),
    [anon_sym_GT_EQ] = ACTIONS(4187),
    [anon_sym_LT_EQ] = ACTIONS(4185),
    [anon_sym_LT] = ACTIONS(4185),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_COLON] = ACTIONS(4187),
    [anon_sym_SEMI] = ACTIONS(4187),
    [anon_sym___extension__] = ACTIONS(4187),
    [anon_sym___attribute__] = ACTIONS(4187),
    [anon_sym___attribute] = ACTIONS(4185),
    [anon_sym_LBRACE] = ACTIONS(4187),
    [anon_sym_RBRACE] = ACTIONS(4187),
    [anon_sym_signed] = ACTIONS(7332),
    [anon_sym_unsigned] = ACTIONS(7332),
    [anon_sym_long] = ACTIONS(7332),
    [anon_sym_short] = ACTIONS(7332),
    [anon_sym_LBRACK] = ACTIONS(4187),
    [anon_sym_RBRACK] = ACTIONS(4187),
    [anon_sym_const] = ACTIONS(4185),
    [anon_sym_constexpr] = ACTIONS(4187),
    [anon_sym_volatile] = ACTIONS(4187),
    [anon_sym_restrict] = ACTIONS(4187),
    [anon_sym___restrict__] = ACTIONS(4187),
    [anon_sym__Atomic] = ACTIONS(4187),
    [anon_sym__Noreturn] = ACTIONS(4187),
    [anon_sym_noreturn] = ACTIONS(4187),
    [anon_sym__Nonnull] = ACTIONS(4187),
    [anon_sym_mutable] = ACTIONS(4187),
    [anon_sym_constinit] = ACTIONS(4187),
    [anon_sym_consteval] = ACTIONS(4187),
    [anon_sym_alignas] = ACTIONS(4187),
    [anon_sym__Alignas] = ACTIONS(4187),
    [anon_sym_QMARK] = ACTIONS(4187),
    [anon_sym_LT_EQ_GT] = ACTIONS(4187),
    [anon_sym_or] = ACTIONS(4187),
    [anon_sym_and] = ACTIONS(4187),
    [anon_sym_bitor] = ACTIONS(4187),
    [anon_sym_xor] = ACTIONS(4187),
    [anon_sym_bitand] = ACTIONS(4187),
    [anon_sym_not_eq] = ACTIONS(4187),
    [anon_sym_is] = ACTIONS(4187),
    [anon_sym_as] = ACTIONS(4187),
    [anon_sym_DASH_DASH] = ACTIONS(4187),
    [anon_sym_PLUS_PLUS] = ACTIONS(4187),
    [anon_sym_DOT] = ACTIONS(4185),
    [anon_sym_DOT_STAR] = ACTIONS(4187),
    [anon_sym_DASH_GT] = ACTIONS(4187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4187),
    [anon_sym_let] = ACTIONS(4187),
    [anon_sym_This] = ACTIONS(4187),
    [anon_sym_final] = ACTIONS(4187),
    [anon_sym_override] = ACTIONS(4187),
    [anon_sym_requires] = ACTIONS(4187),
    [anon_sym_where] = ACTIONS(4187),
  },
  [3091] = {
    [sym__declaration_modifiers] = STATE(2769),
    [sym_attribute_specifier] = STATE(2769),
    [sym_attribute_declaration] = STATE(2769),
    [sym_ms_declspec_modifier] = STATE(2769),
    [sym_storage_class_specifier] = STATE(2769),
    [sym_type_qualifier] = STATE(2769),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_qualifiers] = STATE(2769),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2769),
    [sym_identifier] = ACTIONS(7025),
    [anon_sym_LPAREN2] = ACTIONS(7027),
    [anon_sym_STAR] = ACTIONS(7027),
    [anon_sym_AMP_AMP] = ACTIONS(7027),
    [anon_sym_AMP] = ACTIONS(7025),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym___extension__] = ACTIONS(6720),
    [anon_sym_in] = ACTIONS(7029),
    [anon_sym_out] = ACTIONS(7029),
    [anon_sym_inout] = ACTIONS(7029),
    [anon_sym_virtual] = ACTIONS(7029),
    [anon_sym_extern] = ACTIONS(6724),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(6732),
    [anon_sym___based] = ACTIONS(7025),
    [anon_sym_static] = ACTIONS(6724),
    [anon_sym_register] = ACTIONS(6724),
    [anon_sym_inline] = ACTIONS(6724),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(6724),
    [anon_sym___forceinline] = ACTIONS(6724),
    [anon_sym_thread_local] = ACTIONS(6724),
    [anon_sym___thread] = ACTIONS(6724),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(6720),
    [anon_sym_volatile] = ACTIONS(6720),
    [anon_sym_restrict] = ACTIONS(6720),
    [anon_sym___restrict__] = ACTIONS(6720),
    [anon_sym__Atomic] = ACTIONS(6720),
    [anon_sym__Noreturn] = ACTIONS(6720),
    [anon_sym_noreturn] = ACTIONS(6720),
    [anon_sym__Nonnull] = ACTIONS(6720),
    [anon_sym_mutable] = ACTIONS(6720),
    [anon_sym_constinit] = ACTIONS(6720),
    [anon_sym_consteval] = ACTIONS(6720),
    [anon_sym_alignas] = ACTIONS(6734),
    [anon_sym__Alignas] = ACTIONS(6734),
    [anon_sym_DOT] = ACTIONS(7337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6959),
    [anon_sym_let] = ACTIONS(6959),
    [anon_sym_This] = ACTIONS(6959),
    [anon_sym_operator] = ACTIONS(7025),
    [anon_sym_precise] = ACTIONS(6736),
    [anon_sym_shared] = ACTIONS(6736),
    [anon_sym_groupshared] = ACTIONS(6736),
    [anon_sym_uniform] = ACTIONS(6736),
    [anon_sym_row_major] = ACTIONS(6736),
    [anon_sym_column_major] = ACTIONS(6736),
    [anon_sym_globallycoherent] = ACTIONS(6736),
    [anon_sym_centroid] = ACTIONS(6736),
    [anon_sym_noperspective] = ACTIONS(6736),
    [anon_sym_nointerpolation] = ACTIONS(6736),
    [anon_sym_sample] = ACTIONS(6736),
    [anon_sym_linear] = ACTIONS(6736),
    [anon_sym_snorm] = ACTIONS(6736),
    [anon_sym_unorm] = ACTIONS(6736),
    [anon_sym_point] = ACTIONS(6736),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(6736),
    [anon_sym_lineadj] = ACTIONS(6736),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [3092] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4062),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_RPAREN] = ACTIONS(4062),
    [anon_sym_LPAREN2] = ACTIONS(4062),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_STAR] = ACTIONS(4062),
    [anon_sym_SLASH] = ACTIONS(4064),
    [anon_sym_PERCENT] = ACTIONS(4062),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE] = ACTIONS(4064),
    [anon_sym_CARET] = ACTIONS(4062),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [anon_sym_GT] = ACTIONS(4064),
    [anon_sym_GT_EQ] = ACTIONS(4062),
    [anon_sym_LT_EQ] = ACTIONS(4064),
    [anon_sym_LT] = ACTIONS(4064),
    [anon_sym_LT_LT] = ACTIONS(4062),
    [anon_sym_GT_GT] = ACTIONS(4062),
    [anon_sym_COLON] = ACTIONS(4062),
    [anon_sym_SEMI] = ACTIONS(4062),
    [anon_sym___extension__] = ACTIONS(4062),
    [anon_sym___attribute__] = ACTIONS(4062),
    [anon_sym___attribute] = ACTIONS(4064),
    [anon_sym_LBRACE] = ACTIONS(4062),
    [anon_sym_RBRACE] = ACTIONS(4062),
    [anon_sym_signed] = ACTIONS(7332),
    [anon_sym_unsigned] = ACTIONS(7332),
    [anon_sym_long] = ACTIONS(7332),
    [anon_sym_short] = ACTIONS(7332),
    [anon_sym_LBRACK] = ACTIONS(4062),
    [anon_sym_RBRACK] = ACTIONS(4062),
    [anon_sym_const] = ACTIONS(4064),
    [anon_sym_constexpr] = ACTIONS(4062),
    [anon_sym_volatile] = ACTIONS(4062),
    [anon_sym_restrict] = ACTIONS(4062),
    [anon_sym___restrict__] = ACTIONS(4062),
    [anon_sym__Atomic] = ACTIONS(4062),
    [anon_sym__Noreturn] = ACTIONS(4062),
    [anon_sym_noreturn] = ACTIONS(4062),
    [anon_sym__Nonnull] = ACTIONS(4062),
    [anon_sym_mutable] = ACTIONS(4062),
    [anon_sym_constinit] = ACTIONS(4062),
    [anon_sym_consteval] = ACTIONS(4062),
    [anon_sym_alignas] = ACTIONS(4062),
    [anon_sym__Alignas] = ACTIONS(4062),
    [anon_sym_QMARK] = ACTIONS(4062),
    [anon_sym_LT_EQ_GT] = ACTIONS(4062),
    [anon_sym_or] = ACTIONS(4062),
    [anon_sym_and] = ACTIONS(4062),
    [anon_sym_bitor] = ACTIONS(4062),
    [anon_sym_xor] = ACTIONS(4062),
    [anon_sym_bitand] = ACTIONS(4062),
    [anon_sym_not_eq] = ACTIONS(4062),
    [anon_sym_is] = ACTIONS(4062),
    [anon_sym_as] = ACTIONS(4062),
    [anon_sym_DASH_DASH] = ACTIONS(4062),
    [anon_sym_PLUS_PLUS] = ACTIONS(4062),
    [anon_sym_DOT] = ACTIONS(4064),
    [anon_sym_DOT_STAR] = ACTIONS(4062),
    [anon_sym_DASH_GT] = ACTIONS(4062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4062),
    [anon_sym_let] = ACTIONS(4062),
    [anon_sym_This] = ACTIONS(4062),
    [anon_sym_final] = ACTIONS(4062),
    [anon_sym_override] = ACTIONS(4062),
    [anon_sym_requires] = ACTIONS(4062),
    [anon_sym_where] = ACTIONS(4062),
  },
  [3093] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4080),
    [anon_sym_RPAREN] = ACTIONS(4080),
    [anon_sym_LPAREN2] = ACTIONS(4080),
    [anon_sym_DASH] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(4078),
    [anon_sym_STAR] = ACTIONS(4080),
    [anon_sym_SLASH] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4080),
    [anon_sym_PIPE_PIPE] = ACTIONS(4080),
    [anon_sym_AMP_AMP] = ACTIONS(4080),
    [anon_sym_PIPE] = ACTIONS(4078),
    [anon_sym_CARET] = ACTIONS(4080),
    [anon_sym_AMP] = ACTIONS(4078),
    [anon_sym_EQ_EQ] = ACTIONS(4080),
    [anon_sym_BANG_EQ] = ACTIONS(4080),
    [anon_sym_GT] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4080),
    [anon_sym_LT_EQ] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_LT_LT] = ACTIONS(4080),
    [anon_sym_GT_GT] = ACTIONS(4080),
    [anon_sym_COLON] = ACTIONS(4080),
    [anon_sym_SEMI] = ACTIONS(4080),
    [anon_sym___extension__] = ACTIONS(4080),
    [anon_sym___attribute__] = ACTIONS(4080),
    [anon_sym___attribute] = ACTIONS(4078),
    [anon_sym_LBRACE] = ACTIONS(4080),
    [anon_sym_RBRACE] = ACTIONS(4080),
    [anon_sym_signed] = ACTIONS(7332),
    [anon_sym_unsigned] = ACTIONS(7332),
    [anon_sym_long] = ACTIONS(7332),
    [anon_sym_short] = ACTIONS(7332),
    [anon_sym_LBRACK] = ACTIONS(4080),
    [anon_sym_RBRACK] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4078),
    [anon_sym_constexpr] = ACTIONS(4080),
    [anon_sym_volatile] = ACTIONS(4080),
    [anon_sym_restrict] = ACTIONS(4080),
    [anon_sym___restrict__] = ACTIONS(4080),
    [anon_sym__Atomic] = ACTIONS(4080),
    [anon_sym__Noreturn] = ACTIONS(4080),
    [anon_sym_noreturn] = ACTIONS(4080),
    [anon_sym__Nonnull] = ACTIONS(4080),
    [anon_sym_mutable] = ACTIONS(4080),
    [anon_sym_constinit] = ACTIONS(4080),
    [anon_sym_consteval] = ACTIONS(4080),
    [anon_sym_alignas] = ACTIONS(4080),
    [anon_sym__Alignas] = ACTIONS(4080),
    [anon_sym_QMARK] = ACTIONS(4080),
    [anon_sym_LT_EQ_GT] = ACTIONS(4080),
    [anon_sym_or] = ACTIONS(4080),
    [anon_sym_and] = ACTIONS(4080),
    [anon_sym_bitor] = ACTIONS(4080),
    [anon_sym_xor] = ACTIONS(4080),
    [anon_sym_bitand] = ACTIONS(4080),
    [anon_sym_not_eq] = ACTIONS(4080),
    [anon_sym_is] = ACTIONS(4080),
    [anon_sym_as] = ACTIONS(4080),
    [anon_sym_DASH_DASH] = ACTIONS(4080),
    [anon_sym_PLUS_PLUS] = ACTIONS(4080),
    [anon_sym_DOT] = ACTIONS(4078),
    [anon_sym_DOT_STAR] = ACTIONS(4080),
    [anon_sym_DASH_GT] = ACTIONS(4080),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4080),
    [anon_sym_let] = ACTIONS(4080),
    [anon_sym_This] = ACTIONS(4080),
    [anon_sym_final] = ACTIONS(4080),
    [anon_sym_override] = ACTIONS(4080),
    [anon_sym_requires] = ACTIONS(4080),
    [anon_sym_where] = ACTIONS(4080),
  },
  [3094] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4071),
    [anon_sym_COMMA] = ACTIONS(4071),
    [anon_sym_RPAREN] = ACTIONS(4071),
    [anon_sym_LPAREN2] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(4073),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(4071),
    [anon_sym_SLASH] = ACTIONS(4073),
    [anon_sym_PERCENT] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_CARET] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
    [anon_sym_EQ_EQ] = ACTIONS(4071),
    [anon_sym_BANG_EQ] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_EQ] = ACTIONS(4071),
    [anon_sym_LT_EQ] = ACTIONS(4073),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_COLON] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym___extension__] = ACTIONS(4071),
    [anon_sym___attribute__] = ACTIONS(4071),
    [anon_sym___attribute] = ACTIONS(4073),
    [anon_sym_LBRACE] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(4071),
    [anon_sym_signed] = ACTIONS(7332),
    [anon_sym_unsigned] = ACTIONS(7332),
    [anon_sym_long] = ACTIONS(7332),
    [anon_sym_short] = ACTIONS(7332),
    [anon_sym_LBRACK] = ACTIONS(4071),
    [anon_sym_RBRACK] = ACTIONS(4071),
    [anon_sym_const] = ACTIONS(4073),
    [anon_sym_constexpr] = ACTIONS(4071),
    [anon_sym_volatile] = ACTIONS(4071),
    [anon_sym_restrict] = ACTIONS(4071),
    [anon_sym___restrict__] = ACTIONS(4071),
    [anon_sym__Atomic] = ACTIONS(4071),
    [anon_sym__Noreturn] = ACTIONS(4071),
    [anon_sym_noreturn] = ACTIONS(4071),
    [anon_sym__Nonnull] = ACTIONS(4071),
    [anon_sym_mutable] = ACTIONS(4071),
    [anon_sym_constinit] = ACTIONS(4071),
    [anon_sym_consteval] = ACTIONS(4071),
    [anon_sym_alignas] = ACTIONS(4071),
    [anon_sym__Alignas] = ACTIONS(4071),
    [anon_sym_QMARK] = ACTIONS(4071),
    [anon_sym_LT_EQ_GT] = ACTIONS(4071),
    [anon_sym_or] = ACTIONS(4071),
    [anon_sym_and] = ACTIONS(4071),
    [anon_sym_bitor] = ACTIONS(4071),
    [anon_sym_xor] = ACTIONS(4071),
    [anon_sym_bitand] = ACTIONS(4071),
    [anon_sym_not_eq] = ACTIONS(4071),
    [anon_sym_is] = ACTIONS(4071),
    [anon_sym_as] = ACTIONS(4071),
    [anon_sym_DASH_DASH] = ACTIONS(4071),
    [anon_sym_PLUS_PLUS] = ACTIONS(4071),
    [anon_sym_DOT] = ACTIONS(4073),
    [anon_sym_DOT_STAR] = ACTIONS(4071),
    [anon_sym_DASH_GT] = ACTIONS(4071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4071),
    [anon_sym_let] = ACTIONS(4071),
    [anon_sym_This] = ACTIONS(4071),
    [anon_sym_final] = ACTIONS(4071),
    [anon_sym_override] = ACTIONS(4071),
    [anon_sym_requires] = ACTIONS(4071),
    [anon_sym_where] = ACTIONS(4071),
  },
  [3095] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3093),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2972),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_RPAREN] = ACTIONS(2972),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_SLASH] = ACTIONS(2974),
    [anon_sym_PERCENT] = ACTIONS(2972),
    [anon_sym_PIPE_PIPE] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_PIPE] = ACTIONS(2974),
    [anon_sym_CARET] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_EQ_EQ] = ACTIONS(2972),
    [anon_sym_BANG_EQ] = ACTIONS(2972),
    [anon_sym_GT] = ACTIONS(2974),
    [anon_sym_GT_EQ] = ACTIONS(2972),
    [anon_sym_LT_EQ] = ACTIONS(2974),
    [anon_sym_LT] = ACTIONS(2974),
    [anon_sym_LT_LT] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(2972),
    [anon_sym_COLON] = ACTIONS(2972),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym___extension__] = ACTIONS(2972),
    [anon_sym___attribute__] = ACTIONS(2972),
    [anon_sym___attribute] = ACTIONS(2974),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_signed] = ACTIONS(7326),
    [anon_sym_unsigned] = ACTIONS(7326),
    [anon_sym_long] = ACTIONS(7326),
    [anon_sym_short] = ACTIONS(7326),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_RBRACK] = ACTIONS(2972),
    [anon_sym_const] = ACTIONS(2974),
    [anon_sym_constexpr] = ACTIONS(2972),
    [anon_sym_volatile] = ACTIONS(2972),
    [anon_sym_restrict] = ACTIONS(2972),
    [anon_sym___restrict__] = ACTIONS(2972),
    [anon_sym__Atomic] = ACTIONS(2972),
    [anon_sym__Noreturn] = ACTIONS(2972),
    [anon_sym_noreturn] = ACTIONS(2972),
    [anon_sym__Nonnull] = ACTIONS(2972),
    [anon_sym_mutable] = ACTIONS(2972),
    [anon_sym_constinit] = ACTIONS(2972),
    [anon_sym_consteval] = ACTIONS(2972),
    [anon_sym_alignas] = ACTIONS(2972),
    [anon_sym__Alignas] = ACTIONS(2972),
    [anon_sym_QMARK] = ACTIONS(2972),
    [anon_sym_LT_EQ_GT] = ACTIONS(2972),
    [anon_sym_or] = ACTIONS(2972),
    [anon_sym_and] = ACTIONS(2972),
    [anon_sym_bitor] = ACTIONS(2972),
    [anon_sym_xor] = ACTIONS(2972),
    [anon_sym_bitand] = ACTIONS(2972),
    [anon_sym_not_eq] = ACTIONS(2972),
    [anon_sym_is] = ACTIONS(2972),
    [anon_sym_as] = ACTIONS(2972),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_DOT] = ACTIONS(2974),
    [anon_sym_DOT_STAR] = ACTIONS(2972),
    [anon_sym_DASH_GT] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2972),
    [anon_sym_let] = ACTIONS(2972),
    [anon_sym_This] = ACTIONS(2972),
    [anon_sym_final] = ACTIONS(2972),
    [anon_sym_override] = ACTIONS(2972),
    [anon_sym_requires] = ACTIONS(2972),
    [anon_sym_where] = ACTIONS(2972),
  },
  [3096] = {
    [sym_template_argument_list] = STATE(3105),
    [sym_identifier] = ACTIONS(2222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2229),
    [anon_sym_COMMA] = ACTIONS(2229),
    [anon_sym_RPAREN] = ACTIONS(2229),
    [aux_sym_preproc_if_token2] = ACTIONS(2229),
    [aux_sym_preproc_else_token1] = ACTIONS(2229),
    [aux_sym_preproc_elif_token1] = ACTIONS(2222),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2229),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2229),
    [anon_sym_LPAREN2] = ACTIONS(2229),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2222),
    [anon_sym_SLASH] = ACTIONS(2222),
    [anon_sym_PERCENT] = ACTIONS(2222),
    [anon_sym_PIPE_PIPE] = ACTIONS(2229),
    [anon_sym_AMP_AMP] = ACTIONS(2229),
    [anon_sym_PIPE] = ACTIONS(2222),
    [anon_sym_CARET] = ACTIONS(2222),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_EQ_EQ] = ACTIONS(2229),
    [anon_sym_BANG_EQ] = ACTIONS(2229),
    [anon_sym_GT] = ACTIONS(2222),
    [anon_sym_GT_EQ] = ACTIONS(2229),
    [anon_sym_LT_EQ] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(7339),
    [anon_sym_LT_LT] = ACTIONS(2222),
    [anon_sym_GT_GT] = ACTIONS(2222),
    [anon_sym_COLON] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(2229),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym___attribute] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_RBRACE] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2229),
    [anon_sym_RBRACK] = ACTIONS(2229),
    [anon_sym_EQ] = ACTIONS(2222),
    [anon_sym_QMARK] = ACTIONS(2229),
    [anon_sym_STAR_EQ] = ACTIONS(2229),
    [anon_sym_SLASH_EQ] = ACTIONS(2229),
    [anon_sym_PERCENT_EQ] = ACTIONS(2229),
    [anon_sym_PLUS_EQ] = ACTIONS(2229),
    [anon_sym_DASH_EQ] = ACTIONS(2229),
    [anon_sym_LT_LT_EQ] = ACTIONS(2229),
    [anon_sym_GT_GT_EQ] = ACTIONS(2229),
    [anon_sym_AMP_EQ] = ACTIONS(2229),
    [anon_sym_CARET_EQ] = ACTIONS(2229),
    [anon_sym_PIPE_EQ] = ACTIONS(2229),
    [anon_sym_and_eq] = ACTIONS(2222),
    [anon_sym_or_eq] = ACTIONS(2222),
    [anon_sym_xor_eq] = ACTIONS(2222),
    [anon_sym_LT_EQ_GT] = ACTIONS(2229),
    [anon_sym_or] = ACTIONS(2222),
    [anon_sym_and] = ACTIONS(2222),
    [anon_sym_bitor] = ACTIONS(2222),
    [anon_sym_xor] = ACTIONS(2222),
    [anon_sym_bitand] = ACTIONS(2222),
    [anon_sym_not_eq] = ACTIONS(2222),
    [anon_sym_is] = ACTIONS(2222),
    [anon_sym_as] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2229),
    [anon_sym_DOT] = ACTIONS(2222),
    [anon_sym_DOT_STAR] = ACTIONS(2229),
    [anon_sym_DASH_GT] = ACTIONS(2229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2222),
    [anon_sym_let] = ACTIONS(2222),
    [anon_sym_This] = ACTIONS(2222),
    [anon_sym_final] = ACTIONS(2222),
    [anon_sym_override] = ACTIONS(2222),
  },
  [3097] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4166),
    [anon_sym_COMMA] = ACTIONS(4166),
    [anon_sym_RPAREN] = ACTIONS(4166),
    [anon_sym_LPAREN2] = ACTIONS(4166),
    [anon_sym_DASH] = ACTIONS(4164),
    [anon_sym_PLUS] = ACTIONS(4164),
    [anon_sym_STAR] = ACTIONS(4166),
    [anon_sym_SLASH] = ACTIONS(4164),
    [anon_sym_PERCENT] = ACTIONS(4166),
    [anon_sym_PIPE_PIPE] = ACTIONS(4166),
    [anon_sym_AMP_AMP] = ACTIONS(4166),
    [anon_sym_PIPE] = ACTIONS(4164),
    [anon_sym_CARET] = ACTIONS(4166),
    [anon_sym_AMP] = ACTIONS(4164),
    [anon_sym_EQ_EQ] = ACTIONS(4166),
    [anon_sym_BANG_EQ] = ACTIONS(4166),
    [anon_sym_GT] = ACTIONS(4164),
    [anon_sym_GT_EQ] = ACTIONS(4166),
    [anon_sym_LT_EQ] = ACTIONS(4164),
    [anon_sym_LT] = ACTIONS(4164),
    [anon_sym_LT_LT] = ACTIONS(4166),
    [anon_sym_GT_GT] = ACTIONS(4166),
    [anon_sym_COLON] = ACTIONS(4166),
    [anon_sym_SEMI] = ACTIONS(4166),
    [anon_sym___extension__] = ACTIONS(4166),
    [anon_sym___attribute__] = ACTIONS(4166),
    [anon_sym___attribute] = ACTIONS(4164),
    [anon_sym_LBRACE] = ACTIONS(4166),
    [anon_sym_RBRACE] = ACTIONS(4166),
    [anon_sym_signed] = ACTIONS(7342),
    [anon_sym_unsigned] = ACTIONS(7342),
    [anon_sym_long] = ACTIONS(7342),
    [anon_sym_short] = ACTIONS(7342),
    [anon_sym_LBRACK] = ACTIONS(4166),
    [anon_sym_RBRACK] = ACTIONS(4166),
    [anon_sym_const] = ACTIONS(4164),
    [anon_sym_constexpr] = ACTIONS(4166),
    [anon_sym_volatile] = ACTIONS(4166),
    [anon_sym_restrict] = ACTIONS(4166),
    [anon_sym___restrict__] = ACTIONS(4166),
    [anon_sym__Atomic] = ACTIONS(4166),
    [anon_sym__Noreturn] = ACTIONS(4166),
    [anon_sym_noreturn] = ACTIONS(4166),
    [anon_sym__Nonnull] = ACTIONS(4166),
    [anon_sym_mutable] = ACTIONS(4166),
    [anon_sym_constinit] = ACTIONS(4166),
    [anon_sym_consteval] = ACTIONS(4166),
    [anon_sym_alignas] = ACTIONS(4166),
    [anon_sym__Alignas] = ACTIONS(4166),
    [anon_sym_QMARK] = ACTIONS(4166),
    [anon_sym_LT_EQ_GT] = ACTIONS(4166),
    [anon_sym_or] = ACTIONS(4166),
    [anon_sym_and] = ACTIONS(4166),
    [anon_sym_bitor] = ACTIONS(4166),
    [anon_sym_xor] = ACTIONS(4166),
    [anon_sym_bitand] = ACTIONS(4166),
    [anon_sym_not_eq] = ACTIONS(4166),
    [anon_sym_is] = ACTIONS(4166),
    [anon_sym_as] = ACTIONS(4166),
    [anon_sym_DASH_DASH] = ACTIONS(4166),
    [anon_sym_PLUS_PLUS] = ACTIONS(4166),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_DOT_STAR] = ACTIONS(4166),
    [anon_sym_DASH_GT] = ACTIONS(4166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4166),
    [anon_sym_let] = ACTIONS(4166),
    [anon_sym_This] = ACTIONS(4166),
    [anon_sym_final] = ACTIONS(4166),
    [anon_sym_override] = ACTIONS(4166),
    [anon_sym_requires] = ACTIONS(4166),
    [anon_sym_where] = ACTIONS(4166),
  },
  [3098] = {
    [sym_template_argument_list] = STATE(3105),
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2408),
    [anon_sym_COMMA] = ACTIONS(2408),
    [anon_sym_RPAREN] = ACTIONS(2408),
    [aux_sym_preproc_if_token2] = ACTIONS(2408),
    [aux_sym_preproc_else_token1] = ACTIONS(2408),
    [aux_sym_preproc_elif_token1] = ACTIONS(2410),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2408),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2408),
    [anon_sym_LPAREN2] = ACTIONS(2408),
    [anon_sym_DASH] = ACTIONS(2410),
    [anon_sym_PLUS] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(2410),
    [anon_sym_SLASH] = ACTIONS(2410),
    [anon_sym_PERCENT] = ACTIONS(2410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2408),
    [anon_sym_AMP_AMP] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2410),
    [anon_sym_CARET] = ACTIONS(2410),
    [anon_sym_AMP] = ACTIONS(2410),
    [anon_sym_EQ_EQ] = ACTIONS(2408),
    [anon_sym_BANG_EQ] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2410),
    [anon_sym_GT_EQ] = ACTIONS(2408),
    [anon_sym_LT_EQ] = ACTIONS(2410),
    [anon_sym_LT] = ACTIONS(7344),
    [anon_sym_LT_LT] = ACTIONS(2410),
    [anon_sym_GT_GT] = ACTIONS(2410),
    [anon_sym_COLON] = ACTIONS(2410),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym___attribute__] = ACTIONS(2410),
    [anon_sym___attribute] = ACTIONS(2410),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_RBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2408),
    [anon_sym_RBRACK] = ACTIONS(2408),
    [anon_sym_EQ] = ACTIONS(2410),
    [anon_sym_QMARK] = ACTIONS(2408),
    [anon_sym_STAR_EQ] = ACTIONS(2408),
    [anon_sym_SLASH_EQ] = ACTIONS(2408),
    [anon_sym_PERCENT_EQ] = ACTIONS(2408),
    [anon_sym_PLUS_EQ] = ACTIONS(2408),
    [anon_sym_DASH_EQ] = ACTIONS(2408),
    [anon_sym_LT_LT_EQ] = ACTIONS(2408),
    [anon_sym_GT_GT_EQ] = ACTIONS(2408),
    [anon_sym_AMP_EQ] = ACTIONS(2408),
    [anon_sym_CARET_EQ] = ACTIONS(2408),
    [anon_sym_PIPE_EQ] = ACTIONS(2408),
    [anon_sym_and_eq] = ACTIONS(2410),
    [anon_sym_or_eq] = ACTIONS(2410),
    [anon_sym_xor_eq] = ACTIONS(2410),
    [anon_sym_LT_EQ_GT] = ACTIONS(2408),
    [anon_sym_or] = ACTIONS(2410),
    [anon_sym_and] = ACTIONS(2410),
    [anon_sym_bitor] = ACTIONS(2410),
    [anon_sym_xor] = ACTIONS(2410),
    [anon_sym_bitand] = ACTIONS(2410),
    [anon_sym_not_eq] = ACTIONS(2410),
    [anon_sym_is] = ACTIONS(2410),
    [anon_sym_as] = ACTIONS(2410),
    [anon_sym_DASH_DASH] = ACTIONS(2408),
    [anon_sym_PLUS_PLUS] = ACTIONS(2408),
    [anon_sym_DOT] = ACTIONS(2410),
    [anon_sym_DOT_STAR] = ACTIONS(2408),
    [anon_sym_DASH_GT] = ACTIONS(2408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2410),
    [anon_sym_let] = ACTIONS(2410),
    [anon_sym_This] = ACTIONS(2410),
    [anon_sym_final] = ACTIONS(2410),
    [anon_sym_override] = ACTIONS(2410),
  },
  [3099] = {
    [sym_attribute_specifier] = STATE(3058),
    [sym_field_declaration_list] = STATE(3190),
    [sym_virtual_specifier] = STATE(9439),
    [sym_base_class_clause] = STATE(10563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2895),
    [anon_sym_RPAREN] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_PIPE] = ACTIONS(2893),
    [anon_sym_CARET] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_EQ_EQ] = ACTIONS(2895),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_GT] = ACTIONS(2893),
    [anon_sym_GT_EQ] = ACTIONS(2895),
    [anon_sym_LT_EQ] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_LT_LT] = ACTIONS(2895),
    [anon_sym_GT_GT] = ACTIONS(2895),
    [anon_sym_COLON] = ACTIONS(7252),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym___extension__] = ACTIONS(2895),
    [anon_sym___attribute__] = ACTIONS(7346),
    [anon_sym___attribute] = ACTIONS(7348),
    [anon_sym_LBRACE] = ACTIONS(7350),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_RBRACK] = ACTIONS(2895),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2895),
    [anon_sym_volatile] = ACTIONS(2895),
    [anon_sym_restrict] = ACTIONS(2895),
    [anon_sym___restrict__] = ACTIONS(2895),
    [anon_sym__Atomic] = ACTIONS(2895),
    [anon_sym__Noreturn] = ACTIONS(2895),
    [anon_sym_noreturn] = ACTIONS(2895),
    [anon_sym__Nonnull] = ACTIONS(2895),
    [anon_sym_mutable] = ACTIONS(2895),
    [anon_sym_constinit] = ACTIONS(2895),
    [anon_sym_consteval] = ACTIONS(2895),
    [anon_sym_alignas] = ACTIONS(2895),
    [anon_sym__Alignas] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_LT_EQ_GT] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [anon_sym_and] = ACTIONS(2895),
    [anon_sym_bitor] = ACTIONS(2895),
    [anon_sym_xor] = ACTIONS(2895),
    [anon_sym_bitand] = ACTIONS(2895),
    [anon_sym_not_eq] = ACTIONS(2895),
    [anon_sym_is] = ACTIONS(2895),
    [anon_sym_as] = ACTIONS(2895),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2893),
    [anon_sym_DOT_STAR] = ACTIONS(2895),
    [anon_sym_DASH_GT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2895),
    [anon_sym_let] = ACTIONS(2895),
    [anon_sym_This] = ACTIONS(2895),
    [anon_sym_final] = ACTIONS(7352),
    [anon_sym_override] = ACTIONS(7352),
    [anon_sym_requires] = ACTIONS(2895),
    [anon_sym_where] = ACTIONS(2895),
  },
  [3100] = {
    [sym_argument_list] = STATE(3386),
    [sym_initializer_list] = STATE(3386),
    [sym_new_declarator] = STATE(3287),
    [sym_identifier] = ACTIONS(7354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7356),
    [anon_sym_COMMA] = ACTIONS(7356),
    [anon_sym_RPAREN] = ACTIONS(7356),
    [aux_sym_preproc_if_token2] = ACTIONS(7356),
    [aux_sym_preproc_else_token1] = ACTIONS(7356),
    [aux_sym_preproc_elif_token1] = ACTIONS(7354),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7356),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7356),
    [anon_sym_LPAREN2] = ACTIONS(7358),
    [anon_sym_DASH] = ACTIONS(7354),
    [anon_sym_PLUS] = ACTIONS(7354),
    [anon_sym_STAR] = ACTIONS(7354),
    [anon_sym_SLASH] = ACTIONS(7354),
    [anon_sym_PERCENT] = ACTIONS(7354),
    [anon_sym_PIPE_PIPE] = ACTIONS(7356),
    [anon_sym_AMP_AMP] = ACTIONS(7356),
    [anon_sym_PIPE] = ACTIONS(7354),
    [anon_sym_CARET] = ACTIONS(7354),
    [anon_sym_AMP] = ACTIONS(7354),
    [anon_sym_EQ_EQ] = ACTIONS(7356),
    [anon_sym_BANG_EQ] = ACTIONS(7356),
    [anon_sym_GT] = ACTIONS(7354),
    [anon_sym_GT_EQ] = ACTIONS(7356),
    [anon_sym_LT_EQ] = ACTIONS(7354),
    [anon_sym_LT] = ACTIONS(7354),
    [anon_sym_LT_LT] = ACTIONS(7354),
    [anon_sym_GT_GT] = ACTIONS(7354),
    [anon_sym_COLON] = ACTIONS(7356),
    [anon_sym_SEMI] = ACTIONS(7356),
    [anon_sym___attribute__] = ACTIONS(7354),
    [anon_sym___attribute] = ACTIONS(7354),
    [anon_sym_LBRACE] = ACTIONS(4964),
    [anon_sym_RBRACE] = ACTIONS(7356),
    [anon_sym_LBRACK] = ACTIONS(7360),
    [anon_sym_RBRACK] = ACTIONS(7356),
    [anon_sym_EQ] = ACTIONS(7354),
    [anon_sym_QMARK] = ACTIONS(7356),
    [anon_sym_STAR_EQ] = ACTIONS(7356),
    [anon_sym_SLASH_EQ] = ACTIONS(7356),
    [anon_sym_PERCENT_EQ] = ACTIONS(7356),
    [anon_sym_PLUS_EQ] = ACTIONS(7356),
    [anon_sym_DASH_EQ] = ACTIONS(7356),
    [anon_sym_LT_LT_EQ] = ACTIONS(7356),
    [anon_sym_GT_GT_EQ] = ACTIONS(7356),
    [anon_sym_AMP_EQ] = ACTIONS(7356),
    [anon_sym_CARET_EQ] = ACTIONS(7356),
    [anon_sym_PIPE_EQ] = ACTIONS(7356),
    [anon_sym_and_eq] = ACTIONS(7354),
    [anon_sym_or_eq] = ACTIONS(7354),
    [anon_sym_xor_eq] = ACTIONS(7354),
    [anon_sym_LT_EQ_GT] = ACTIONS(7356),
    [anon_sym_or] = ACTIONS(7354),
    [anon_sym_and] = ACTIONS(7354),
    [anon_sym_bitor] = ACTIONS(7354),
    [anon_sym_xor] = ACTIONS(7354),
    [anon_sym_bitand] = ACTIONS(7354),
    [anon_sym_not_eq] = ACTIONS(7354),
    [anon_sym_is] = ACTIONS(7354),
    [anon_sym_as] = ACTIONS(7354),
    [anon_sym_DASH_DASH] = ACTIONS(7356),
    [anon_sym_PLUS_PLUS] = ACTIONS(7356),
    [anon_sym_DOT] = ACTIONS(7354),
    [anon_sym_DOT_STAR] = ACTIONS(7356),
    [anon_sym_DASH_GT] = ACTIONS(7356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(7362),
    [anon_sym_let] = ACTIONS(7362),
    [anon_sym_This] = ACTIONS(7362),
  },
  [3101] = {
    [sym_type_qualifier] = STATE(3111),
    [sym_alignas_qualifier] = STATE(2719),
    [aux_sym__type_definition_type_repeat1] = STATE(3111),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3050),
    [sym_identifier] = ACTIONS(7364),
    [anon_sym_LPAREN2] = ACTIONS(3423),
    [anon_sym_STAR] = ACTIONS(3423),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3428),
    [anon_sym___extension__] = ACTIONS(6813),
    [anon_sym_in] = ACTIONS(3428),
    [anon_sym_out] = ACTIONS(3428),
    [anon_sym_inout] = ACTIONS(3428),
    [anon_sym_virtual] = ACTIONS(3428),
    [anon_sym_extern] = ACTIONS(3428),
    [anon_sym___attribute__] = ACTIONS(3428),
    [anon_sym___attribute] = ACTIONS(3428),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3423),
    [anon_sym___declspec] = ACTIONS(3428),
    [anon_sym_LBRACE] = ACTIONS(3423),
    [anon_sym_signed] = ACTIONS(7366),
    [anon_sym_unsigned] = ACTIONS(7366),
    [anon_sym_long] = ACTIONS(7366),
    [anon_sym_short] = ACTIONS(7366),
    [anon_sym_LBRACK] = ACTIONS(3428),
    [anon_sym_static] = ACTIONS(3428),
    [anon_sym_register] = ACTIONS(3428),
    [anon_sym_inline] = ACTIONS(3428),
    [anon_sym___inline] = ACTIONS(3428),
    [anon_sym___inline__] = ACTIONS(3428),
    [anon_sym___forceinline] = ACTIONS(3428),
    [anon_sym_thread_local] = ACTIONS(3428),
    [anon_sym___thread] = ACTIONS(3428),
    [anon_sym_const] = ACTIONS(6813),
    [anon_sym_constexpr] = ACTIONS(6813),
    [anon_sym_volatile] = ACTIONS(6813),
    [anon_sym_restrict] = ACTIONS(6813),
    [anon_sym___restrict__] = ACTIONS(6813),
    [anon_sym__Atomic] = ACTIONS(6813),
    [anon_sym__Noreturn] = ACTIONS(6813),
    [anon_sym_noreturn] = ACTIONS(6813),
    [anon_sym__Nonnull] = ACTIONS(6813),
    [anon_sym_mutable] = ACTIONS(6813),
    [anon_sym_constinit] = ACTIONS(6813),
    [anon_sym_consteval] = ACTIONS(6813),
    [anon_sym_alignas] = ACTIONS(6818),
    [anon_sym__Alignas] = ACTIONS(6818),
    [sym_primitive_type] = ACTIONS(6821),
    [anon_sym_DOT] = ACTIONS(3423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3428),
    [anon_sym_let] = ACTIONS(3428),
    [anon_sym_This] = ACTIONS(3428),
    [anon_sym_precise] = ACTIONS(3428),
    [anon_sym_shared] = ACTIONS(3428),
    [anon_sym_groupshared] = ACTIONS(3428),
    [anon_sym_uniform] = ACTIONS(3428),
    [anon_sym_row_major] = ACTIONS(3428),
    [anon_sym_column_major] = ACTIONS(3428),
    [anon_sym_globallycoherent] = ACTIONS(3428),
    [anon_sym_centroid] = ACTIONS(3428),
    [anon_sym_noperspective] = ACTIONS(3428),
    [anon_sym_nointerpolation] = ACTIONS(3428),
    [anon_sym_sample] = ACTIONS(3428),
    [anon_sym_linear] = ACTIONS(3428),
    [anon_sym_snorm] = ACTIONS(3428),
    [anon_sym_unorm] = ACTIONS(3428),
    [anon_sym_point] = ACTIONS(3428),
    [anon_sym_line] = ACTIONS(3428),
    [anon_sym_triangleadj] = ACTIONS(3428),
    [anon_sym_lineadj] = ACTIONS(3428),
    [anon_sym_triangle] = ACTIONS(3428),
  },
  [3102] = {
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2416),
    [anon_sym_COMMA] = ACTIONS(2416),
    [anon_sym_RPAREN] = ACTIONS(2416),
    [aux_sym_preproc_if_token2] = ACTIONS(2416),
    [aux_sym_preproc_else_token1] = ACTIONS(2416),
    [aux_sym_preproc_elif_token1] = ACTIONS(2418),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2416),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2416),
    [anon_sym_LPAREN2] = ACTIONS(2416),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_SLASH] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_PIPE] = ACTIONS(2418),
    [anon_sym_CARET] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_EQ_EQ] = ACTIONS(2416),
    [anon_sym_BANG_EQ] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(2418),
    [anon_sym_GT_EQ] = ACTIONS(2416),
    [anon_sym_LT_EQ] = ACTIONS(2418),
    [anon_sym_LT] = ACTIONS(2418),
    [anon_sym_LT_LT] = ACTIONS(2418),
    [anon_sym_GT_GT] = ACTIONS(2418),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym___attribute__] = ACTIONS(2418),
    [anon_sym___attribute] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2416),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_RBRACE] = ACTIONS(2416),
    [anon_sym_LBRACK] = ACTIONS(2416),
    [anon_sym_RBRACK] = ACTIONS(2416),
    [anon_sym_EQ] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2416),
    [anon_sym_STAR_EQ] = ACTIONS(2416),
    [anon_sym_SLASH_EQ] = ACTIONS(2416),
    [anon_sym_PERCENT_EQ] = ACTIONS(2416),
    [anon_sym_PLUS_EQ] = ACTIONS(2416),
    [anon_sym_DASH_EQ] = ACTIONS(2416),
    [anon_sym_LT_LT_EQ] = ACTIONS(2416),
    [anon_sym_GT_GT_EQ] = ACTIONS(2416),
    [anon_sym_AMP_EQ] = ACTIONS(2416),
    [anon_sym_CARET_EQ] = ACTIONS(2416),
    [anon_sym_PIPE_EQ] = ACTIONS(2416),
    [anon_sym_and_eq] = ACTIONS(2418),
    [anon_sym_or_eq] = ACTIONS(2418),
    [anon_sym_xor_eq] = ACTIONS(2418),
    [anon_sym_LT_EQ_GT] = ACTIONS(2416),
    [anon_sym_or] = ACTIONS(2418),
    [anon_sym_and] = ACTIONS(2418),
    [anon_sym_bitor] = ACTIONS(2418),
    [anon_sym_xor] = ACTIONS(2418),
    [anon_sym_bitand] = ACTIONS(2418),
    [anon_sym_not_eq] = ACTIONS(2418),
    [anon_sym_is] = ACTIONS(2418),
    [anon_sym_as] = ACTIONS(2418),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_DOT] = ACTIONS(2418),
    [anon_sym_DOT_STAR] = ACTIONS(2416),
    [anon_sym_DASH_GT] = ACTIONS(2416),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_This] = ACTIONS(2418),
    [anon_sym_final] = ACTIONS(2418),
    [anon_sym_override] = ACTIONS(2418),
  },
  [3103] = {
    [sym_identifier] = ACTIONS(2428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2426),
    [anon_sym_COMMA] = ACTIONS(2426),
    [anon_sym_RPAREN] = ACTIONS(2426),
    [aux_sym_preproc_if_token2] = ACTIONS(2426),
    [aux_sym_preproc_else_token1] = ACTIONS(2426),
    [aux_sym_preproc_elif_token1] = ACTIONS(2428),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2426),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2426),
    [anon_sym_LPAREN2] = ACTIONS(2426),
    [anon_sym_DASH] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2428),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_SLASH] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_PIPE_PIPE] = ACTIONS(2426),
    [anon_sym_AMP_AMP] = ACTIONS(2426),
    [anon_sym_PIPE] = ACTIONS(2428),
    [anon_sym_CARET] = ACTIONS(2428),
    [anon_sym_AMP] = ACTIONS(2428),
    [anon_sym_EQ_EQ] = ACTIONS(2426),
    [anon_sym_BANG_EQ] = ACTIONS(2426),
    [anon_sym_GT] = ACTIONS(2428),
    [anon_sym_GT_EQ] = ACTIONS(2426),
    [anon_sym_LT_EQ] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(2428),
    [anon_sym_LT_LT] = ACTIONS(2428),
    [anon_sym_GT_GT] = ACTIONS(2428),
    [anon_sym_COLON] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2426),
    [anon_sym___attribute__] = ACTIONS(2428),
    [anon_sym___attribute] = ACTIONS(2428),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2426),
    [anon_sym_RBRACE] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(2426),
    [anon_sym_RBRACK] = ACTIONS(2426),
    [anon_sym_EQ] = ACTIONS(2428),
    [anon_sym_QMARK] = ACTIONS(2426),
    [anon_sym_STAR_EQ] = ACTIONS(2426),
    [anon_sym_SLASH_EQ] = ACTIONS(2426),
    [anon_sym_PERCENT_EQ] = ACTIONS(2426),
    [anon_sym_PLUS_EQ] = ACTIONS(2426),
    [anon_sym_DASH_EQ] = ACTIONS(2426),
    [anon_sym_LT_LT_EQ] = ACTIONS(2426),
    [anon_sym_GT_GT_EQ] = ACTIONS(2426),
    [anon_sym_AMP_EQ] = ACTIONS(2426),
    [anon_sym_CARET_EQ] = ACTIONS(2426),
    [anon_sym_PIPE_EQ] = ACTIONS(2426),
    [anon_sym_and_eq] = ACTIONS(2428),
    [anon_sym_or_eq] = ACTIONS(2428),
    [anon_sym_xor_eq] = ACTIONS(2428),
    [anon_sym_LT_EQ_GT] = ACTIONS(2426),
    [anon_sym_or] = ACTIONS(2428),
    [anon_sym_and] = ACTIONS(2428),
    [anon_sym_bitor] = ACTIONS(2428),
    [anon_sym_xor] = ACTIONS(2428),
    [anon_sym_bitand] = ACTIONS(2428),
    [anon_sym_not_eq] = ACTIONS(2428),
    [anon_sym_is] = ACTIONS(2428),
    [anon_sym_as] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2426),
    [anon_sym_PLUS_PLUS] = ACTIONS(2426),
    [anon_sym_DOT] = ACTIONS(2428),
    [anon_sym_DOT_STAR] = ACTIONS(2426),
    [anon_sym_DASH_GT] = ACTIONS(2426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2428),
    [anon_sym_let] = ACTIONS(2428),
    [anon_sym_This] = ACTIONS(2428),
    [anon_sym_final] = ACTIONS(2428),
    [anon_sym_override] = ACTIONS(2428),
  },
  [3104] = {
    [sym_argument_list] = STATE(3442),
    [sym_initializer_list] = STATE(3442),
    [sym_new_declarator] = STATE(3313),
    [sym_identifier] = ACTIONS(7368),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7370),
    [anon_sym_COMMA] = ACTIONS(7370),
    [anon_sym_RPAREN] = ACTIONS(7370),
    [aux_sym_preproc_if_token2] = ACTIONS(7370),
    [aux_sym_preproc_else_token1] = ACTIONS(7370),
    [aux_sym_preproc_elif_token1] = ACTIONS(7368),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7370),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7370),
    [anon_sym_LPAREN2] = ACTIONS(7358),
    [anon_sym_DASH] = ACTIONS(7368),
    [anon_sym_PLUS] = ACTIONS(7368),
    [anon_sym_STAR] = ACTIONS(7368),
    [anon_sym_SLASH] = ACTIONS(7368),
    [anon_sym_PERCENT] = ACTIONS(7368),
    [anon_sym_PIPE_PIPE] = ACTIONS(7370),
    [anon_sym_AMP_AMP] = ACTIONS(7370),
    [anon_sym_PIPE] = ACTIONS(7368),
    [anon_sym_CARET] = ACTIONS(7368),
    [anon_sym_AMP] = ACTIONS(7368),
    [anon_sym_EQ_EQ] = ACTIONS(7370),
    [anon_sym_BANG_EQ] = ACTIONS(7370),
    [anon_sym_GT] = ACTIONS(7368),
    [anon_sym_GT_EQ] = ACTIONS(7370),
    [anon_sym_LT_EQ] = ACTIONS(7368),
    [anon_sym_LT] = ACTIONS(7368),
    [anon_sym_LT_LT] = ACTIONS(7368),
    [anon_sym_GT_GT] = ACTIONS(7368),
    [anon_sym_COLON] = ACTIONS(7370),
    [anon_sym_SEMI] = ACTIONS(7370),
    [anon_sym___attribute__] = ACTIONS(7368),
    [anon_sym___attribute] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(4964),
    [anon_sym_RBRACE] = ACTIONS(7370),
    [anon_sym_LBRACK] = ACTIONS(7360),
    [anon_sym_RBRACK] = ACTIONS(7370),
    [anon_sym_EQ] = ACTIONS(7368),
    [anon_sym_QMARK] = ACTIONS(7370),
    [anon_sym_STAR_EQ] = ACTIONS(7370),
    [anon_sym_SLASH_EQ] = ACTIONS(7370),
    [anon_sym_PERCENT_EQ] = ACTIONS(7370),
    [anon_sym_PLUS_EQ] = ACTIONS(7370),
    [anon_sym_DASH_EQ] = ACTIONS(7370),
    [anon_sym_LT_LT_EQ] = ACTIONS(7370),
    [anon_sym_GT_GT_EQ] = ACTIONS(7370),
    [anon_sym_AMP_EQ] = ACTIONS(7370),
    [anon_sym_CARET_EQ] = ACTIONS(7370),
    [anon_sym_PIPE_EQ] = ACTIONS(7370),
    [anon_sym_and_eq] = ACTIONS(7368),
    [anon_sym_or_eq] = ACTIONS(7368),
    [anon_sym_xor_eq] = ACTIONS(7368),
    [anon_sym_LT_EQ_GT] = ACTIONS(7370),
    [anon_sym_or] = ACTIONS(7368),
    [anon_sym_and] = ACTIONS(7368),
    [anon_sym_bitor] = ACTIONS(7368),
    [anon_sym_xor] = ACTIONS(7368),
    [anon_sym_bitand] = ACTIONS(7368),
    [anon_sym_not_eq] = ACTIONS(7368),
    [anon_sym_is] = ACTIONS(7368),
    [anon_sym_as] = ACTIONS(7368),
    [anon_sym_DASH_DASH] = ACTIONS(7370),
    [anon_sym_PLUS_PLUS] = ACTIONS(7370),
    [anon_sym_DOT] = ACTIONS(7368),
    [anon_sym_DOT_STAR] = ACTIONS(7370),
    [anon_sym_DASH_GT] = ACTIONS(7370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(7362),
    [anon_sym_let] = ACTIONS(7362),
    [anon_sym_This] = ACTIONS(7362),
  },
  [3105] = {
    [sym_identifier] = ACTIONS(2243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_RPAREN] = ACTIONS(2250),
    [aux_sym_preproc_if_token2] = ACTIONS(2250),
    [aux_sym_preproc_else_token1] = ACTIONS(2250),
    [aux_sym_preproc_elif_token1] = ACTIONS(2243),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2250),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2243),
    [anon_sym_PLUS] = ACTIONS(2243),
    [anon_sym_STAR] = ACTIONS(2243),
    [anon_sym_SLASH] = ACTIONS(2243),
    [anon_sym_PERCENT] = ACTIONS(2243),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2243),
    [anon_sym_CARET] = ACTIONS(2243),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_EQ_EQ] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2243),
    [anon_sym_GT_EQ] = ACTIONS(2250),
    [anon_sym_LT_EQ] = ACTIONS(2243),
    [anon_sym_LT] = ACTIONS(2243),
    [anon_sym_LT_LT] = ACTIONS(2243),
    [anon_sym_GT_GT] = ACTIONS(2243),
    [anon_sym_COLON] = ACTIONS(2243),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym___attribute] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_RBRACK] = ACTIONS(2250),
    [anon_sym_EQ] = ACTIONS(2243),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_STAR_EQ] = ACTIONS(2250),
    [anon_sym_SLASH_EQ] = ACTIONS(2250),
    [anon_sym_PERCENT_EQ] = ACTIONS(2250),
    [anon_sym_PLUS_EQ] = ACTIONS(2250),
    [anon_sym_DASH_EQ] = ACTIONS(2250),
    [anon_sym_LT_LT_EQ] = ACTIONS(2250),
    [anon_sym_GT_GT_EQ] = ACTIONS(2250),
    [anon_sym_AMP_EQ] = ACTIONS(2250),
    [anon_sym_CARET_EQ] = ACTIONS(2250),
    [anon_sym_PIPE_EQ] = ACTIONS(2250),
    [anon_sym_and_eq] = ACTIONS(2243),
    [anon_sym_or_eq] = ACTIONS(2243),
    [anon_sym_xor_eq] = ACTIONS(2243),
    [anon_sym_LT_EQ_GT] = ACTIONS(2250),
    [anon_sym_or] = ACTIONS(2243),
    [anon_sym_and] = ACTIONS(2243),
    [anon_sym_bitor] = ACTIONS(2243),
    [anon_sym_xor] = ACTIONS(2243),
    [anon_sym_bitand] = ACTIONS(2243),
    [anon_sym_not_eq] = ACTIONS(2243),
    [anon_sym_is] = ACTIONS(2243),
    [anon_sym_as] = ACTIONS(2243),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2243),
    [anon_sym_DOT_STAR] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2243),
    [anon_sym_let] = ACTIONS(2243),
    [anon_sym_This] = ACTIONS(2243),
    [anon_sym_final] = ACTIONS(2243),
    [anon_sym_override] = ACTIONS(2243),
  },
  [3106] = {
    [sym_argument_list] = STATE(3414),
    [sym_initializer_list] = STATE(3414),
    [sym_new_declarator] = STATE(3284),
    [sym_identifier] = ACTIONS(7372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7374),
    [anon_sym_COMMA] = ACTIONS(7374),
    [anon_sym_RPAREN] = ACTIONS(7374),
    [aux_sym_preproc_if_token2] = ACTIONS(7374),
    [aux_sym_preproc_else_token1] = ACTIONS(7374),
    [aux_sym_preproc_elif_token1] = ACTIONS(7372),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7374),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7374),
    [anon_sym_LPAREN2] = ACTIONS(7358),
    [anon_sym_DASH] = ACTIONS(7372),
    [anon_sym_PLUS] = ACTIONS(7372),
    [anon_sym_STAR] = ACTIONS(7372),
    [anon_sym_SLASH] = ACTIONS(7372),
    [anon_sym_PERCENT] = ACTIONS(7372),
    [anon_sym_PIPE_PIPE] = ACTIONS(7374),
    [anon_sym_AMP_AMP] = ACTIONS(7374),
    [anon_sym_PIPE] = ACTIONS(7372),
    [anon_sym_CARET] = ACTIONS(7372),
    [anon_sym_AMP] = ACTIONS(7372),
    [anon_sym_EQ_EQ] = ACTIONS(7374),
    [anon_sym_BANG_EQ] = ACTIONS(7374),
    [anon_sym_GT] = ACTIONS(7372),
    [anon_sym_GT_EQ] = ACTIONS(7374),
    [anon_sym_LT_EQ] = ACTIONS(7372),
    [anon_sym_LT] = ACTIONS(7372),
    [anon_sym_LT_LT] = ACTIONS(7372),
    [anon_sym_GT_GT] = ACTIONS(7372),
    [anon_sym_COLON] = ACTIONS(7374),
    [anon_sym_SEMI] = ACTIONS(7374),
    [anon_sym___attribute__] = ACTIONS(7372),
    [anon_sym___attribute] = ACTIONS(7372),
    [anon_sym_LBRACE] = ACTIONS(4964),
    [anon_sym_RBRACE] = ACTIONS(7374),
    [anon_sym_LBRACK] = ACTIONS(7360),
    [anon_sym_RBRACK] = ACTIONS(7374),
    [anon_sym_EQ] = ACTIONS(7372),
    [anon_sym_QMARK] = ACTIONS(7374),
    [anon_sym_STAR_EQ] = ACTIONS(7374),
    [anon_sym_SLASH_EQ] = ACTIONS(7374),
    [anon_sym_PERCENT_EQ] = ACTIONS(7374),
    [anon_sym_PLUS_EQ] = ACTIONS(7374),
    [anon_sym_DASH_EQ] = ACTIONS(7374),
    [anon_sym_LT_LT_EQ] = ACTIONS(7374),
    [anon_sym_GT_GT_EQ] = ACTIONS(7374),
    [anon_sym_AMP_EQ] = ACTIONS(7374),
    [anon_sym_CARET_EQ] = ACTIONS(7374),
    [anon_sym_PIPE_EQ] = ACTIONS(7374),
    [anon_sym_and_eq] = ACTIONS(7372),
    [anon_sym_or_eq] = ACTIONS(7372),
    [anon_sym_xor_eq] = ACTIONS(7372),
    [anon_sym_LT_EQ_GT] = ACTIONS(7374),
    [anon_sym_or] = ACTIONS(7372),
    [anon_sym_and] = ACTIONS(7372),
    [anon_sym_bitor] = ACTIONS(7372),
    [anon_sym_xor] = ACTIONS(7372),
    [anon_sym_bitand] = ACTIONS(7372),
    [anon_sym_not_eq] = ACTIONS(7372),
    [anon_sym_is] = ACTIONS(7372),
    [anon_sym_as] = ACTIONS(7372),
    [anon_sym_DASH_DASH] = ACTIONS(7374),
    [anon_sym_PLUS_PLUS] = ACTIONS(7374),
    [anon_sym_DOT] = ACTIONS(7372),
    [anon_sym_DOT_STAR] = ACTIONS(7374),
    [anon_sym_DASH_GT] = ACTIONS(7374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(7362),
    [anon_sym_let] = ACTIONS(7362),
    [anon_sym_This] = ACTIONS(7362),
  },
  [3107] = {
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_RPAREN] = ACTIONS(2420),
    [aux_sym_preproc_if_token2] = ACTIONS(2420),
    [aux_sym_preproc_else_token1] = ACTIONS(2420),
    [aux_sym_preproc_elif_token1] = ACTIONS(2422),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2420),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2420),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2422),
    [anon_sym_SLASH] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2422),
    [anon_sym_PIPE_PIPE] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_PIPE] = ACTIONS(2422),
    [anon_sym_CARET] = ACTIONS(2422),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_EQ_EQ] = ACTIONS(2420),
    [anon_sym_BANG_EQ] = ACTIONS(2420),
    [anon_sym_GT] = ACTIONS(2422),
    [anon_sym_GT_EQ] = ACTIONS(2420),
    [anon_sym_LT_EQ] = ACTIONS(2422),
    [anon_sym_LT] = ACTIONS(2422),
    [anon_sym_LT_LT] = ACTIONS(2422),
    [anon_sym_GT_GT] = ACTIONS(2422),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [anon_sym_RBRACK] = ACTIONS(2420),
    [anon_sym_EQ] = ACTIONS(2422),
    [anon_sym_QMARK] = ACTIONS(2420),
    [anon_sym_STAR_EQ] = ACTIONS(2420),
    [anon_sym_SLASH_EQ] = ACTIONS(2420),
    [anon_sym_PERCENT_EQ] = ACTIONS(2420),
    [anon_sym_PLUS_EQ] = ACTIONS(2420),
    [anon_sym_DASH_EQ] = ACTIONS(2420),
    [anon_sym_LT_LT_EQ] = ACTIONS(2420),
    [anon_sym_GT_GT_EQ] = ACTIONS(2420),
    [anon_sym_AMP_EQ] = ACTIONS(2420),
    [anon_sym_CARET_EQ] = ACTIONS(2420),
    [anon_sym_PIPE_EQ] = ACTIONS(2420),
    [anon_sym_and_eq] = ACTIONS(2422),
    [anon_sym_or_eq] = ACTIONS(2422),
    [anon_sym_xor_eq] = ACTIONS(2422),
    [anon_sym_LT_EQ_GT] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2422),
    [anon_sym_and] = ACTIONS(2422),
    [anon_sym_bitor] = ACTIONS(2422),
    [anon_sym_xor] = ACTIONS(2422),
    [anon_sym_bitand] = ACTIONS(2422),
    [anon_sym_not_eq] = ACTIONS(2422),
    [anon_sym_is] = ACTIONS(2422),
    [anon_sym_as] = ACTIONS(2422),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_DOT] = ACTIONS(2422),
    [anon_sym_DOT_STAR] = ACTIONS(2420),
    [anon_sym_DASH_GT] = ACTIONS(2420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
  },
  [3108] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2245),
    [anon_sym_RPAREN] = ACTIONS(2247),
    [anon_sym_LPAREN2] = ACTIONS(2247),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_SLASH] = ACTIONS(2255),
    [anon_sym_PERCENT] = ACTIONS(2255),
    [anon_sym_PIPE_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2255),
    [anon_sym_CARET] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_EQ_EQ] = ACTIONS(2245),
    [anon_sym_BANG_EQ] = ACTIONS(2245),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_GT_EQ] = ACTIONS(2245),
    [anon_sym_LT_EQ] = ACTIONS(2255),
    [anon_sym_LT] = ACTIONS(2255),
    [anon_sym_LT_LT] = ACTIONS(2255),
    [anon_sym_GT_GT] = ACTIONS(2255),
    [anon_sym___extension__] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2247),
    [anon_sym_EQ] = ACTIONS(2255),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2250),
    [anon_sym_volatile] = ACTIONS(2250),
    [anon_sym_restrict] = ACTIONS(2250),
    [anon_sym___restrict__] = ACTIONS(2250),
    [anon_sym__Atomic] = ACTIONS(2250),
    [anon_sym__Noreturn] = ACTIONS(2250),
    [anon_sym_noreturn] = ACTIONS(2250),
    [anon_sym__Nonnull] = ACTIONS(2250),
    [anon_sym_mutable] = ACTIONS(2250),
    [anon_sym_constinit] = ACTIONS(2250),
    [anon_sym_consteval] = ACTIONS(2250),
    [anon_sym_alignas] = ACTIONS(2250),
    [anon_sym__Alignas] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2245),
    [anon_sym_STAR_EQ] = ACTIONS(2245),
    [anon_sym_SLASH_EQ] = ACTIONS(2245),
    [anon_sym_PERCENT_EQ] = ACTIONS(2245),
    [anon_sym_PLUS_EQ] = ACTIONS(2245),
    [anon_sym_DASH_EQ] = ACTIONS(2245),
    [anon_sym_LT_LT_EQ] = ACTIONS(2245),
    [anon_sym_GT_GT_EQ] = ACTIONS(2245),
    [anon_sym_AMP_EQ] = ACTIONS(2245),
    [anon_sym_CARET_EQ] = ACTIONS(2245),
    [anon_sym_PIPE_EQ] = ACTIONS(2245),
    [anon_sym_and_eq] = ACTIONS(2245),
    [anon_sym_or_eq] = ACTIONS(2245),
    [anon_sym_xor_eq] = ACTIONS(2245),
    [anon_sym_LT_EQ_GT] = ACTIONS(2245),
    [anon_sym_or] = ACTIONS(2255),
    [anon_sym_and] = ACTIONS(2255),
    [anon_sym_bitor] = ACTIONS(2245),
    [anon_sym_xor] = ACTIONS(2255),
    [anon_sym_bitand] = ACTIONS(2245),
    [anon_sym_not_eq] = ACTIONS(2245),
    [anon_sym_is] = ACTIONS(2245),
    [anon_sym_as] = ACTIONS(2245),
    [anon_sym_DASH_DASH] = ACTIONS(2245),
    [anon_sym_PLUS_PLUS] = ACTIONS(2245),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_DOT_STAR] = ACTIONS(2245),
    [anon_sym_DASH_GT] = ACTIONS(2245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_This] = ACTIONS(2250),
  },
  [3109] = {
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_RPAREN] = ACTIONS(2420),
    [aux_sym_preproc_if_token2] = ACTIONS(2420),
    [aux_sym_preproc_else_token1] = ACTIONS(2420),
    [aux_sym_preproc_elif_token1] = ACTIONS(2422),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2420),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2420),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2422),
    [anon_sym_SLASH] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2422),
    [anon_sym_PIPE_PIPE] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_PIPE] = ACTIONS(2422),
    [anon_sym_CARET] = ACTIONS(2422),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_EQ_EQ] = ACTIONS(2420),
    [anon_sym_BANG_EQ] = ACTIONS(2420),
    [anon_sym_GT] = ACTIONS(2422),
    [anon_sym_GT_EQ] = ACTIONS(2420),
    [anon_sym_LT_EQ] = ACTIONS(2422),
    [anon_sym_LT] = ACTIONS(2422),
    [anon_sym_LT_LT] = ACTIONS(2422),
    [anon_sym_GT_GT] = ACTIONS(2422),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [anon_sym_RBRACK] = ACTIONS(2420),
    [anon_sym_EQ] = ACTIONS(2422),
    [anon_sym_QMARK] = ACTIONS(2420),
    [anon_sym_STAR_EQ] = ACTIONS(2420),
    [anon_sym_SLASH_EQ] = ACTIONS(2420),
    [anon_sym_PERCENT_EQ] = ACTIONS(2420),
    [anon_sym_PLUS_EQ] = ACTIONS(2420),
    [anon_sym_DASH_EQ] = ACTIONS(2420),
    [anon_sym_LT_LT_EQ] = ACTIONS(2420),
    [anon_sym_GT_GT_EQ] = ACTIONS(2420),
    [anon_sym_AMP_EQ] = ACTIONS(2420),
    [anon_sym_CARET_EQ] = ACTIONS(2420),
    [anon_sym_PIPE_EQ] = ACTIONS(2420),
    [anon_sym_and_eq] = ACTIONS(2422),
    [anon_sym_or_eq] = ACTIONS(2422),
    [anon_sym_xor_eq] = ACTIONS(2422),
    [anon_sym_LT_EQ_GT] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2422),
    [anon_sym_and] = ACTIONS(2422),
    [anon_sym_bitor] = ACTIONS(2422),
    [anon_sym_xor] = ACTIONS(2422),
    [anon_sym_bitand] = ACTIONS(2422),
    [anon_sym_not_eq] = ACTIONS(2422),
    [anon_sym_is] = ACTIONS(2422),
    [anon_sym_as] = ACTIONS(2422),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_DOT] = ACTIONS(2422),
    [anon_sym_DOT_STAR] = ACTIONS(2420),
    [anon_sym_DASH_GT] = ACTIONS(2420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
  },
  [3110] = {
    [sym_argument_list] = STATE(3424),
    [sym_initializer_list] = STATE(3424),
    [sym_new_declarator] = STATE(3293),
    [sym_identifier] = ACTIONS(7376),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7378),
    [anon_sym_COMMA] = ACTIONS(7378),
    [anon_sym_RPAREN] = ACTIONS(7378),
    [aux_sym_preproc_if_token2] = ACTIONS(7378),
    [aux_sym_preproc_else_token1] = ACTIONS(7378),
    [aux_sym_preproc_elif_token1] = ACTIONS(7376),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7378),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7378),
    [anon_sym_LPAREN2] = ACTIONS(7358),
    [anon_sym_DASH] = ACTIONS(7376),
    [anon_sym_PLUS] = ACTIONS(7376),
    [anon_sym_STAR] = ACTIONS(7376),
    [anon_sym_SLASH] = ACTIONS(7376),
    [anon_sym_PERCENT] = ACTIONS(7376),
    [anon_sym_PIPE_PIPE] = ACTIONS(7378),
    [anon_sym_AMP_AMP] = ACTIONS(7378),
    [anon_sym_PIPE] = ACTIONS(7376),
    [anon_sym_CARET] = ACTIONS(7376),
    [anon_sym_AMP] = ACTIONS(7376),
    [anon_sym_EQ_EQ] = ACTIONS(7378),
    [anon_sym_BANG_EQ] = ACTIONS(7378),
    [anon_sym_GT] = ACTIONS(7376),
    [anon_sym_GT_EQ] = ACTIONS(7378),
    [anon_sym_LT_EQ] = ACTIONS(7376),
    [anon_sym_LT] = ACTIONS(7376),
    [anon_sym_LT_LT] = ACTIONS(7376),
    [anon_sym_GT_GT] = ACTIONS(7376),
    [anon_sym_COLON] = ACTIONS(7378),
    [anon_sym_SEMI] = ACTIONS(7378),
    [anon_sym___attribute__] = ACTIONS(7376),
    [anon_sym___attribute] = ACTIONS(7376),
    [anon_sym_LBRACE] = ACTIONS(4964),
    [anon_sym_RBRACE] = ACTIONS(7378),
    [anon_sym_LBRACK] = ACTIONS(7360),
    [anon_sym_RBRACK] = ACTIONS(7378),
    [anon_sym_EQ] = ACTIONS(7376),
    [anon_sym_QMARK] = ACTIONS(7378),
    [anon_sym_STAR_EQ] = ACTIONS(7378),
    [anon_sym_SLASH_EQ] = ACTIONS(7378),
    [anon_sym_PERCENT_EQ] = ACTIONS(7378),
    [anon_sym_PLUS_EQ] = ACTIONS(7378),
    [anon_sym_DASH_EQ] = ACTIONS(7378),
    [anon_sym_LT_LT_EQ] = ACTIONS(7378),
    [anon_sym_GT_GT_EQ] = ACTIONS(7378),
    [anon_sym_AMP_EQ] = ACTIONS(7378),
    [anon_sym_CARET_EQ] = ACTIONS(7378),
    [anon_sym_PIPE_EQ] = ACTIONS(7378),
    [anon_sym_and_eq] = ACTIONS(7376),
    [anon_sym_or_eq] = ACTIONS(7376),
    [anon_sym_xor_eq] = ACTIONS(7376),
    [anon_sym_LT_EQ_GT] = ACTIONS(7378),
    [anon_sym_or] = ACTIONS(7376),
    [anon_sym_and] = ACTIONS(7376),
    [anon_sym_bitor] = ACTIONS(7376),
    [anon_sym_xor] = ACTIONS(7376),
    [anon_sym_bitand] = ACTIONS(7376),
    [anon_sym_not_eq] = ACTIONS(7376),
    [anon_sym_is] = ACTIONS(7376),
    [anon_sym_as] = ACTIONS(7376),
    [anon_sym_DASH_DASH] = ACTIONS(7378),
    [anon_sym_PLUS_PLUS] = ACTIONS(7378),
    [anon_sym_DOT] = ACTIONS(7376),
    [anon_sym_DOT_STAR] = ACTIONS(7378),
    [anon_sym_DASH_GT] = ACTIONS(7378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(7362),
    [anon_sym_let] = ACTIONS(7362),
    [anon_sym_This] = ACTIONS(7362),
  },
  [3111] = {
    [sym_type_qualifier] = STATE(2679),
    [sym_alignas_qualifier] = STATE(2719),
    [aux_sym__type_definition_type_repeat1] = STATE(2679),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2752),
    [sym_identifier] = ACTIONS(7380),
    [anon_sym_LPAREN2] = ACTIONS(3542),
    [anon_sym_STAR] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_AMP] = ACTIONS(3540),
    [anon_sym___extension__] = ACTIONS(6826),
    [anon_sym_in] = ACTIONS(3540),
    [anon_sym_out] = ACTIONS(3540),
    [anon_sym_inout] = ACTIONS(3540),
    [anon_sym_virtual] = ACTIONS(3540),
    [anon_sym_extern] = ACTIONS(3540),
    [anon_sym___attribute__] = ACTIONS(3540),
    [anon_sym___attribute] = ACTIONS(3540),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3542),
    [anon_sym___declspec] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_signed] = ACTIONS(6829),
    [anon_sym_unsigned] = ACTIONS(6829),
    [anon_sym_long] = ACTIONS(6829),
    [anon_sym_short] = ACTIONS(6829),
    [anon_sym_LBRACK] = ACTIONS(3540),
    [anon_sym_static] = ACTIONS(3540),
    [anon_sym_register] = ACTIONS(3540),
    [anon_sym_inline] = ACTIONS(3540),
    [anon_sym___inline] = ACTIONS(3540),
    [anon_sym___inline__] = ACTIONS(3540),
    [anon_sym___forceinline] = ACTIONS(3540),
    [anon_sym_thread_local] = ACTIONS(3540),
    [anon_sym___thread] = ACTIONS(3540),
    [anon_sym_const] = ACTIONS(6826),
    [anon_sym_constexpr] = ACTIONS(6826),
    [anon_sym_volatile] = ACTIONS(6826),
    [anon_sym_restrict] = ACTIONS(6826),
    [anon_sym___restrict__] = ACTIONS(6826),
    [anon_sym__Atomic] = ACTIONS(6826),
    [anon_sym__Noreturn] = ACTIONS(6826),
    [anon_sym_noreturn] = ACTIONS(6826),
    [anon_sym__Nonnull] = ACTIONS(6826),
    [anon_sym_mutable] = ACTIONS(6826),
    [anon_sym_constinit] = ACTIONS(6826),
    [anon_sym_consteval] = ACTIONS(6826),
    [anon_sym_alignas] = ACTIONS(6831),
    [anon_sym__Alignas] = ACTIONS(6831),
    [sym_primitive_type] = ACTIONS(6834),
    [anon_sym_DOT] = ACTIONS(3542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3540),
    [anon_sym_let] = ACTIONS(3540),
    [anon_sym_This] = ACTIONS(3540),
    [anon_sym_precise] = ACTIONS(3540),
    [anon_sym_shared] = ACTIONS(3540),
    [anon_sym_groupshared] = ACTIONS(3540),
    [anon_sym_uniform] = ACTIONS(3540),
    [anon_sym_row_major] = ACTIONS(3540),
    [anon_sym_column_major] = ACTIONS(3540),
    [anon_sym_globallycoherent] = ACTIONS(3540),
    [anon_sym_centroid] = ACTIONS(3540),
    [anon_sym_noperspective] = ACTIONS(3540),
    [anon_sym_nointerpolation] = ACTIONS(3540),
    [anon_sym_sample] = ACTIONS(3540),
    [anon_sym_linear] = ACTIONS(3540),
    [anon_sym_snorm] = ACTIONS(3540),
    [anon_sym_unorm] = ACTIONS(3540),
    [anon_sym_point] = ACTIONS(3540),
    [anon_sym_line] = ACTIONS(3540),
    [anon_sym_triangleadj] = ACTIONS(3540),
    [anon_sym_lineadj] = ACTIONS(3540),
    [anon_sym_triangle] = ACTIONS(3540),
  },
  [3112] = {
    [sym_template_argument_list] = STATE(2953),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3173),
    [sym_identifier] = ACTIONS(3777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3775),
    [anon_sym_COMMA] = ACTIONS(3775),
    [aux_sym_preproc_if_token2] = ACTIONS(3775),
    [aux_sym_preproc_else_token1] = ACTIONS(3775),
    [aux_sym_preproc_elif_token1] = ACTIONS(3777),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3775),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3775),
    [anon_sym_LPAREN2] = ACTIONS(3775),
    [anon_sym_DASH] = ACTIONS(3777),
    [anon_sym_PLUS] = ACTIONS(3777),
    [anon_sym_STAR] = ACTIONS(3777),
    [anon_sym_SLASH] = ACTIONS(3777),
    [anon_sym_PERCENT] = ACTIONS(3777),
    [anon_sym_PIPE_PIPE] = ACTIONS(3775),
    [anon_sym_AMP_AMP] = ACTIONS(3775),
    [anon_sym_PIPE] = ACTIONS(3777),
    [anon_sym_CARET] = ACTIONS(3777),
    [anon_sym_AMP] = ACTIONS(3777),
    [anon_sym_EQ_EQ] = ACTIONS(3775),
    [anon_sym_BANG_EQ] = ACTIONS(3775),
    [anon_sym_GT] = ACTIONS(3777),
    [anon_sym_GT_EQ] = ACTIONS(3775),
    [anon_sym_LT_EQ] = ACTIONS(3777),
    [anon_sym_LT] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3777),
    [anon_sym_GT_GT] = ACTIONS(3777),
    [anon_sym___attribute__] = ACTIONS(3777),
    [anon_sym___attribute] = ACTIONS(3777),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(3775),
    [anon_sym_signed] = ACTIONS(7382),
    [anon_sym_unsigned] = ACTIONS(7382),
    [anon_sym_long] = ACTIONS(7382),
    [anon_sym_short] = ACTIONS(7382),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_EQ] = ACTIONS(3777),
    [anon_sym_QMARK] = ACTIONS(3775),
    [anon_sym_STAR_EQ] = ACTIONS(3775),
    [anon_sym_SLASH_EQ] = ACTIONS(3775),
    [anon_sym_PERCENT_EQ] = ACTIONS(3775),
    [anon_sym_PLUS_EQ] = ACTIONS(3775),
    [anon_sym_DASH_EQ] = ACTIONS(3775),
    [anon_sym_LT_LT_EQ] = ACTIONS(3775),
    [anon_sym_GT_GT_EQ] = ACTIONS(3775),
    [anon_sym_AMP_EQ] = ACTIONS(3775),
    [anon_sym_CARET_EQ] = ACTIONS(3775),
    [anon_sym_PIPE_EQ] = ACTIONS(3775),
    [anon_sym_and_eq] = ACTIONS(3777),
    [anon_sym_or_eq] = ACTIONS(3777),
    [anon_sym_xor_eq] = ACTIONS(3777),
    [anon_sym_LT_EQ_GT] = ACTIONS(3775),
    [anon_sym_or] = ACTIONS(3777),
    [anon_sym_and] = ACTIONS(3777),
    [anon_sym_bitor] = ACTIONS(3777),
    [anon_sym_xor] = ACTIONS(3777),
    [anon_sym_bitand] = ACTIONS(3777),
    [anon_sym_not_eq] = ACTIONS(3777),
    [anon_sym_is] = ACTIONS(3777),
    [anon_sym_as] = ACTIONS(3777),
    [anon_sym_DASH_DASH] = ACTIONS(3775),
    [anon_sym_PLUS_PLUS] = ACTIONS(3775),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_DOT_STAR] = ACTIONS(3775),
    [anon_sym_DASH_GT] = ACTIONS(3775),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3777),
    [anon_sym_let] = ACTIONS(3777),
    [anon_sym_This] = ACTIONS(3777),
  },
  [3113] = {
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_BANG] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [anon_sym_DASH] = ACTIONS(3362),
    [anon_sym_PLUS] = ACTIONS(3362),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3352),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym_COLON_COLON] = ACTIONS(3352),
    [anon_sym_LBRACK] = ACTIONS(3352),
    [anon_sym_static] = ACTIONS(3362),
    [anon_sym_RBRACK] = ACTIONS(3352),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3362),
    [anon_sym_not] = ACTIONS(3362),
    [anon_sym_compl] = ACTIONS(3362),
    [anon_sym_DASH_DASH] = ACTIONS(3352),
    [anon_sym_PLUS_PLUS] = ACTIONS(3352),
    [anon_sym_sizeof] = ACTIONS(3362),
    [anon_sym___alignof__] = ACTIONS(3362),
    [anon_sym___alignof] = ACTIONS(3362),
    [anon_sym__alignof] = ACTIONS(3362),
    [anon_sym_alignof] = ACTIONS(3362),
    [anon_sym__Alignof] = ACTIONS(3362),
    [anon_sym_offsetof] = ACTIONS(3362),
    [anon_sym__Generic] = ACTIONS(3362),
    [anon_sym_asm] = ACTIONS(3362),
    [anon_sym___asm__] = ACTIONS(3362),
    [anon_sym___asm] = ACTIONS(3362),
    [sym_number_literal] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3352),
    [anon_sym_u_SQUOTE] = ACTIONS(3352),
    [anon_sym_U_SQUOTE] = ACTIONS(3352),
    [anon_sym_u8_SQUOTE] = ACTIONS(3352),
    [anon_sym_SQUOTE] = ACTIONS(3352),
    [anon_sym_L_DQUOTE] = ACTIONS(3352),
    [anon_sym_u_DQUOTE] = ACTIONS(3352),
    [anon_sym_U_DQUOTE] = ACTIONS(3352),
    [anon_sym_u8_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3352),
    [sym_true] = ACTIONS(3362),
    [sym_false] = ACTIONS(3362),
    [anon_sym_NULL] = ACTIONS(3362),
    [anon_sym_nullptr] = ACTIONS(3362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3362),
    [anon_sym_template] = ACTIONS(3362),
    [anon_sym_delete] = ACTIONS(3362),
    [anon_sym_R_DQUOTE] = ACTIONS(3352),
    [anon_sym_LR_DQUOTE] = ACTIONS(3352),
    [anon_sym_uR_DQUOTE] = ACTIONS(3352),
    [anon_sym_UR_DQUOTE] = ACTIONS(3352),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3352),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(3362),
    [anon_sym_requires] = ACTIONS(3362),
    [sym_this] = ACTIONS(3362),
  },
  [3114] = {
    [sym_attribute_specifier] = STATE(3233),
    [sym_enumerator_list] = STATE(3153),
    [sym_identifier] = ACTIONS(3989),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3987),
    [anon_sym_COMMA] = ACTIONS(3987),
    [anon_sym_RPAREN] = ACTIONS(3987),
    [aux_sym_preproc_if_token2] = ACTIONS(3987),
    [aux_sym_preproc_else_token1] = ACTIONS(3987),
    [aux_sym_preproc_elif_token1] = ACTIONS(3989),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3987),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3987),
    [anon_sym_LPAREN2] = ACTIONS(3987),
    [anon_sym_DASH] = ACTIONS(3989),
    [anon_sym_PLUS] = ACTIONS(3989),
    [anon_sym_STAR] = ACTIONS(3989),
    [anon_sym_SLASH] = ACTIONS(3989),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_AMP_AMP] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3989),
    [anon_sym_CARET] = ACTIONS(3989),
    [anon_sym_AMP] = ACTIONS(3989),
    [anon_sym_EQ_EQ] = ACTIONS(3987),
    [anon_sym_BANG_EQ] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3989),
    [anon_sym_GT_EQ] = ACTIONS(3987),
    [anon_sym_LT_EQ] = ACTIONS(3989),
    [anon_sym_LT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_GT_GT] = ACTIONS(3989),
    [anon_sym_COLON] = ACTIONS(3987),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym___attribute__] = ACTIONS(7254),
    [anon_sym___attribute] = ACTIONS(7254),
    [anon_sym_LBRACE] = ACTIONS(7384),
    [anon_sym_RBRACE] = ACTIONS(3987),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_RBRACK] = ACTIONS(3987),
    [anon_sym_EQ] = ACTIONS(3989),
    [anon_sym_QMARK] = ACTIONS(3987),
    [anon_sym_STAR_EQ] = ACTIONS(3987),
    [anon_sym_SLASH_EQ] = ACTIONS(3987),
    [anon_sym_PERCENT_EQ] = ACTIONS(3987),
    [anon_sym_PLUS_EQ] = ACTIONS(3987),
    [anon_sym_DASH_EQ] = ACTIONS(3987),
    [anon_sym_LT_LT_EQ] = ACTIONS(3987),
    [anon_sym_GT_GT_EQ] = ACTIONS(3987),
    [anon_sym_AMP_EQ] = ACTIONS(3987),
    [anon_sym_CARET_EQ] = ACTIONS(3987),
    [anon_sym_PIPE_EQ] = ACTIONS(3987),
    [anon_sym_and_eq] = ACTIONS(3989),
    [anon_sym_or_eq] = ACTIONS(3989),
    [anon_sym_xor_eq] = ACTIONS(3989),
    [anon_sym_LT_EQ_GT] = ACTIONS(3987),
    [anon_sym_or] = ACTIONS(3989),
    [anon_sym_and] = ACTIONS(3989),
    [anon_sym_bitor] = ACTIONS(3989),
    [anon_sym_xor] = ACTIONS(3989),
    [anon_sym_bitand] = ACTIONS(3989),
    [anon_sym_not_eq] = ACTIONS(3989),
    [anon_sym_is] = ACTIONS(3989),
    [anon_sym_as] = ACTIONS(3989),
    [anon_sym_DASH_DASH] = ACTIONS(3987),
    [anon_sym_PLUS_PLUS] = ACTIONS(3987),
    [anon_sym_DOT] = ACTIONS(3989),
    [anon_sym_DOT_STAR] = ACTIONS(3987),
    [anon_sym_DASH_GT] = ACTIONS(3987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3989),
    [anon_sym_let] = ACTIONS(3989),
    [anon_sym_This] = ACTIONS(3989),
  },
  [3115] = {
    [sym_identifier] = ACTIONS(3581),
    [anon_sym___extension__] = ACTIONS(3581),
    [anon_sym_in] = ACTIONS(3581),
    [anon_sym_out] = ACTIONS(3581),
    [anon_sym_inout] = ACTIONS(3581),
    [anon_sym_virtual] = ACTIONS(3581),
    [anon_sym_extern] = ACTIONS(3581),
    [anon_sym___attribute__] = ACTIONS(3581),
    [anon_sym___attribute] = ACTIONS(3581),
    [anon_sym_COLON_COLON] = ACTIONS(3579),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3579),
    [anon_sym___declspec] = ACTIONS(3581),
    [anon_sym_signed] = ACTIONS(3581),
    [anon_sym_unsigned] = ACTIONS(3581),
    [anon_sym_long] = ACTIONS(3581),
    [anon_sym_short] = ACTIONS(3581),
    [anon_sym_static] = ACTIONS(3581),
    [anon_sym_register] = ACTIONS(3581),
    [anon_sym_inline] = ACTIONS(3581),
    [anon_sym___inline] = ACTIONS(3581),
    [anon_sym___inline__] = ACTIONS(3581),
    [anon_sym___forceinline] = ACTIONS(3581),
    [anon_sym_thread_local] = ACTIONS(3581),
    [anon_sym___thread] = ACTIONS(3581),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_constexpr] = ACTIONS(3581),
    [anon_sym_volatile] = ACTIONS(3581),
    [anon_sym_restrict] = ACTIONS(3581),
    [anon_sym___restrict__] = ACTIONS(3581),
    [anon_sym__Atomic] = ACTIONS(3581),
    [anon_sym__Noreturn] = ACTIONS(3581),
    [anon_sym_noreturn] = ACTIONS(3581),
    [anon_sym__Nonnull] = ACTIONS(3581),
    [anon_sym_mutable] = ACTIONS(3581),
    [anon_sym_constinit] = ACTIONS(3581),
    [anon_sym_consteval] = ACTIONS(3581),
    [anon_sym_alignas] = ACTIONS(3581),
    [anon_sym__Alignas] = ACTIONS(3581),
    [sym_primitive_type] = ACTIONS(3581),
    [anon_sym_enum] = ACTIONS(3581),
    [anon_sym_class] = ACTIONS(3581),
    [anon_sym_struct] = ACTIONS(3581),
    [anon_sym_union] = ACTIONS(3581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3581),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_This] = ACTIONS(3581),
    [anon_sym_decltype] = ACTIONS(3581),
    [anon_sym_typename] = ACTIONS(3581),
    [anon_sym_template] = ACTIONS(3581),
    [anon_sym_precise] = ACTIONS(3581),
    [anon_sym_shared] = ACTIONS(3581),
    [anon_sym_groupshared] = ACTIONS(3581),
    [anon_sym_uniform] = ACTIONS(3581),
    [anon_sym_row_major] = ACTIONS(3581),
    [anon_sym_column_major] = ACTIONS(3581),
    [anon_sym_globallycoherent] = ACTIONS(3581),
    [anon_sym_centroid] = ACTIONS(3581),
    [anon_sym_noperspective] = ACTIONS(3581),
    [anon_sym_nointerpolation] = ACTIONS(3581),
    [anon_sym_sample] = ACTIONS(3581),
    [anon_sym_linear] = ACTIONS(3581),
    [anon_sym_snorm] = ACTIONS(3581),
    [anon_sym_unorm] = ACTIONS(3581),
    [anon_sym_point] = ACTIONS(3581),
    [anon_sym_line] = ACTIONS(3581),
    [anon_sym_triangleadj] = ACTIONS(3581),
    [anon_sym_lineadj] = ACTIONS(3581),
    [anon_sym_triangle] = ACTIONS(3581),
    [anon_sym_interface] = ACTIONS(3581),
    [anon_sym_extension] = ACTIONS(3581),
  },
  [3116] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2881),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4121),
    [anon_sym_COMMA] = ACTIONS(4121),
    [aux_sym_preproc_if_token2] = ACTIONS(4121),
    [aux_sym_preproc_else_token1] = ACTIONS(4121),
    [aux_sym_preproc_elif_token1] = ACTIONS(4124),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4121),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4121),
    [anon_sym_LPAREN2] = ACTIONS(4121),
    [anon_sym_DASH] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4124),
    [anon_sym_STAR] = ACTIONS(4121),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_PERCENT] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4121),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE] = ACTIONS(4124),
    [anon_sym_CARET] = ACTIONS(4121),
    [anon_sym_AMP] = ACTIONS(4124),
    [anon_sym_EQ_EQ] = ACTIONS(4121),
    [anon_sym_BANG_EQ] = ACTIONS(4121),
    [anon_sym_GT] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4121),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_LT_LT] = ACTIONS(4121),
    [anon_sym_GT_GT] = ACTIONS(4121),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(4124),
    [anon_sym___attribute] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_signed] = ACTIONS(7112),
    [anon_sym_unsigned] = ACTIONS(7112),
    [anon_sym_long] = ACTIONS(7112),
    [anon_sym_short] = ACTIONS(7112),
    [anon_sym_LBRACK] = ACTIONS(4121),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(4121),
    [anon_sym_LT_EQ_GT] = ACTIONS(4121),
    [anon_sym_or] = ACTIONS(4124),
    [anon_sym_and] = ACTIONS(4124),
    [anon_sym_bitor] = ACTIONS(4124),
    [anon_sym_xor] = ACTIONS(4124),
    [anon_sym_bitand] = ACTIONS(4124),
    [anon_sym_not_eq] = ACTIONS(4124),
    [anon_sym_is] = ACTIONS(4124),
    [anon_sym_as] = ACTIONS(4124),
    [anon_sym_DASH_DASH] = ACTIONS(4121),
    [anon_sym_PLUS_PLUS] = ACTIONS(4121),
    [anon_sym_DOT] = ACTIONS(4124),
    [anon_sym_DOT_STAR] = ACTIONS(4121),
    [anon_sym_DASH_GT] = ACTIONS(4121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4124),
    [anon_sym_let] = ACTIONS(4124),
    [anon_sym_This] = ACTIONS(4124),
  },
  [3117] = {
    [sym_identifier] = ACTIONS(3591),
    [anon_sym___extension__] = ACTIONS(3591),
    [anon_sym_in] = ACTIONS(3591),
    [anon_sym_out] = ACTIONS(3591),
    [anon_sym_inout] = ACTIONS(3591),
    [anon_sym_virtual] = ACTIONS(3591),
    [anon_sym_extern] = ACTIONS(3591),
    [anon_sym___attribute__] = ACTIONS(3591),
    [anon_sym___attribute] = ACTIONS(3591),
    [anon_sym_COLON_COLON] = ACTIONS(3589),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3589),
    [anon_sym___declspec] = ACTIONS(3591),
    [anon_sym_signed] = ACTIONS(3591),
    [anon_sym_unsigned] = ACTIONS(3591),
    [anon_sym_long] = ACTIONS(3591),
    [anon_sym_short] = ACTIONS(3591),
    [anon_sym_static] = ACTIONS(3591),
    [anon_sym_register] = ACTIONS(3591),
    [anon_sym_inline] = ACTIONS(3591),
    [anon_sym___inline] = ACTIONS(3591),
    [anon_sym___inline__] = ACTIONS(3591),
    [anon_sym___forceinline] = ACTIONS(3591),
    [anon_sym_thread_local] = ACTIONS(3591),
    [anon_sym___thread] = ACTIONS(3591),
    [anon_sym_const] = ACTIONS(3591),
    [anon_sym_constexpr] = ACTIONS(3591),
    [anon_sym_volatile] = ACTIONS(3591),
    [anon_sym_restrict] = ACTIONS(3591),
    [anon_sym___restrict__] = ACTIONS(3591),
    [anon_sym__Atomic] = ACTIONS(3591),
    [anon_sym__Noreturn] = ACTIONS(3591),
    [anon_sym_noreturn] = ACTIONS(3591),
    [anon_sym__Nonnull] = ACTIONS(3591),
    [anon_sym_mutable] = ACTIONS(3591),
    [anon_sym_constinit] = ACTIONS(3591),
    [anon_sym_consteval] = ACTIONS(3591),
    [anon_sym_alignas] = ACTIONS(3591),
    [anon_sym__Alignas] = ACTIONS(3591),
    [sym_primitive_type] = ACTIONS(3591),
    [anon_sym_enum] = ACTIONS(3591),
    [anon_sym_class] = ACTIONS(3591),
    [anon_sym_struct] = ACTIONS(3591),
    [anon_sym_union] = ACTIONS(3591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3591),
    [anon_sym_let] = ACTIONS(3591),
    [anon_sym_This] = ACTIONS(3591),
    [anon_sym_decltype] = ACTIONS(3591),
    [anon_sym_typename] = ACTIONS(3591),
    [anon_sym_template] = ACTIONS(3591),
    [anon_sym_precise] = ACTIONS(3591),
    [anon_sym_shared] = ACTIONS(3591),
    [anon_sym_groupshared] = ACTIONS(3591),
    [anon_sym_uniform] = ACTIONS(3591),
    [anon_sym_row_major] = ACTIONS(3591),
    [anon_sym_column_major] = ACTIONS(3591),
    [anon_sym_globallycoherent] = ACTIONS(3591),
    [anon_sym_centroid] = ACTIONS(3591),
    [anon_sym_noperspective] = ACTIONS(3591),
    [anon_sym_nointerpolation] = ACTIONS(3591),
    [anon_sym_sample] = ACTIONS(3591),
    [anon_sym_linear] = ACTIONS(3591),
    [anon_sym_snorm] = ACTIONS(3591),
    [anon_sym_unorm] = ACTIONS(3591),
    [anon_sym_point] = ACTIONS(3591),
    [anon_sym_line] = ACTIONS(3591),
    [anon_sym_triangleadj] = ACTIONS(3591),
    [anon_sym_lineadj] = ACTIONS(3591),
    [anon_sym_triangle] = ACTIONS(3591),
    [anon_sym_interface] = ACTIONS(3591),
    [anon_sym_extension] = ACTIONS(3591),
  },
  [3118] = {
    [sym_identifier] = ACTIONS(4242),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_BANG] = ACTIONS(4240),
    [anon_sym_TILDE] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4242),
    [anon_sym_PLUS] = ACTIONS(4242),
    [anon_sym_STAR] = ACTIONS(4240),
    [anon_sym_AMP] = ACTIONS(4240),
    [anon_sym___extension__] = ACTIONS(4242),
    [anon_sym_COLON_COLON] = ACTIONS(4240),
    [anon_sym_LBRACK] = ACTIONS(4240),
    [anon_sym_static] = ACTIONS(4242),
    [anon_sym_RBRACK] = ACTIONS(4240),
    [anon_sym_const] = ACTIONS(4242),
    [anon_sym_constexpr] = ACTIONS(4242),
    [anon_sym_volatile] = ACTIONS(4242),
    [anon_sym_restrict] = ACTIONS(4242),
    [anon_sym___restrict__] = ACTIONS(4242),
    [anon_sym__Atomic] = ACTIONS(4242),
    [anon_sym__Noreturn] = ACTIONS(4242),
    [anon_sym_noreturn] = ACTIONS(4242),
    [anon_sym__Nonnull] = ACTIONS(4242),
    [anon_sym_mutable] = ACTIONS(4242),
    [anon_sym_constinit] = ACTIONS(4242),
    [anon_sym_consteval] = ACTIONS(4242),
    [anon_sym_alignas] = ACTIONS(4242),
    [anon_sym__Alignas] = ACTIONS(4242),
    [sym_primitive_type] = ACTIONS(4242),
    [anon_sym_not] = ACTIONS(4242),
    [anon_sym_compl] = ACTIONS(4242),
    [anon_sym_DASH_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_PLUS] = ACTIONS(4240),
    [anon_sym_sizeof] = ACTIONS(4242),
    [anon_sym___alignof__] = ACTIONS(4242),
    [anon_sym___alignof] = ACTIONS(4242),
    [anon_sym__alignof] = ACTIONS(4242),
    [anon_sym_alignof] = ACTIONS(4242),
    [anon_sym__Alignof] = ACTIONS(4242),
    [anon_sym_offsetof] = ACTIONS(4242),
    [anon_sym__Generic] = ACTIONS(4242),
    [anon_sym_asm] = ACTIONS(4242),
    [anon_sym___asm__] = ACTIONS(4242),
    [anon_sym___asm] = ACTIONS(4242),
    [sym_number_literal] = ACTIONS(4240),
    [anon_sym_L_SQUOTE] = ACTIONS(4240),
    [anon_sym_u_SQUOTE] = ACTIONS(4240),
    [anon_sym_U_SQUOTE] = ACTIONS(4240),
    [anon_sym_u8_SQUOTE] = ACTIONS(4240),
    [anon_sym_SQUOTE] = ACTIONS(4240),
    [anon_sym_L_DQUOTE] = ACTIONS(4240),
    [anon_sym_u_DQUOTE] = ACTIONS(4240),
    [anon_sym_U_DQUOTE] = ACTIONS(4240),
    [anon_sym_u8_DQUOTE] = ACTIONS(4240),
    [anon_sym_DQUOTE] = ACTIONS(4240),
    [sym_true] = ACTIONS(4242),
    [sym_false] = ACTIONS(4242),
    [anon_sym_NULL] = ACTIONS(4242),
    [anon_sym_nullptr] = ACTIONS(4242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4242),
    [anon_sym_template] = ACTIONS(4242),
    [anon_sym_delete] = ACTIONS(4242),
    [anon_sym_R_DQUOTE] = ACTIONS(4240),
    [anon_sym_LR_DQUOTE] = ACTIONS(4240),
    [anon_sym_uR_DQUOTE] = ACTIONS(4240),
    [anon_sym_UR_DQUOTE] = ACTIONS(4240),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4240),
    [anon_sym_co_await] = ACTIONS(4242),
    [anon_sym_new] = ACTIONS(4242),
    [anon_sym_requires] = ACTIONS(4242),
    [sym_this] = ACTIONS(4242),
  },
  [3119] = {
    [sym_identifier] = ACTIONS(3889),
    [anon_sym___extension__] = ACTIONS(3889),
    [anon_sym_in] = ACTIONS(3889),
    [anon_sym_out] = ACTIONS(3889),
    [anon_sym_inout] = ACTIONS(3889),
    [anon_sym_virtual] = ACTIONS(3889),
    [anon_sym_extern] = ACTIONS(3889),
    [anon_sym___attribute__] = ACTIONS(3889),
    [anon_sym___attribute] = ACTIONS(3889),
    [anon_sym_COLON_COLON] = ACTIONS(3891),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3891),
    [anon_sym___declspec] = ACTIONS(3889),
    [anon_sym_signed] = ACTIONS(3889),
    [anon_sym_unsigned] = ACTIONS(3889),
    [anon_sym_long] = ACTIONS(3889),
    [anon_sym_short] = ACTIONS(3889),
    [anon_sym_static] = ACTIONS(3889),
    [anon_sym_register] = ACTIONS(3889),
    [anon_sym_inline] = ACTIONS(3889),
    [anon_sym___inline] = ACTIONS(3889),
    [anon_sym___inline__] = ACTIONS(3889),
    [anon_sym___forceinline] = ACTIONS(3889),
    [anon_sym_thread_local] = ACTIONS(3889),
    [anon_sym___thread] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3889),
    [anon_sym_constexpr] = ACTIONS(3889),
    [anon_sym_volatile] = ACTIONS(3889),
    [anon_sym_restrict] = ACTIONS(3889),
    [anon_sym___restrict__] = ACTIONS(3889),
    [anon_sym__Atomic] = ACTIONS(3889),
    [anon_sym__Noreturn] = ACTIONS(3889),
    [anon_sym_noreturn] = ACTIONS(3889),
    [anon_sym__Nonnull] = ACTIONS(3889),
    [anon_sym_mutable] = ACTIONS(3889),
    [anon_sym_constinit] = ACTIONS(3889),
    [anon_sym_consteval] = ACTIONS(3889),
    [anon_sym_alignas] = ACTIONS(3889),
    [anon_sym__Alignas] = ACTIONS(3889),
    [sym_primitive_type] = ACTIONS(3889),
    [anon_sym_enum] = ACTIONS(3889),
    [anon_sym_class] = ACTIONS(3889),
    [anon_sym_struct] = ACTIONS(3889),
    [anon_sym_union] = ACTIONS(3889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3889),
    [anon_sym_let] = ACTIONS(3889),
    [anon_sym_This] = ACTIONS(3889),
    [anon_sym_decltype] = ACTIONS(3889),
    [anon_sym_typename] = ACTIONS(3889),
    [anon_sym_template] = ACTIONS(3889),
    [anon_sym_precise] = ACTIONS(3889),
    [anon_sym_shared] = ACTIONS(3889),
    [anon_sym_groupshared] = ACTIONS(3889),
    [anon_sym_uniform] = ACTIONS(3889),
    [anon_sym_row_major] = ACTIONS(3889),
    [anon_sym_column_major] = ACTIONS(3889),
    [anon_sym_globallycoherent] = ACTIONS(3889),
    [anon_sym_centroid] = ACTIONS(3889),
    [anon_sym_noperspective] = ACTIONS(3889),
    [anon_sym_nointerpolation] = ACTIONS(3889),
    [anon_sym_sample] = ACTIONS(3889),
    [anon_sym_linear] = ACTIONS(3889),
    [anon_sym_snorm] = ACTIONS(3889),
    [anon_sym_unorm] = ACTIONS(3889),
    [anon_sym_point] = ACTIONS(3889),
    [anon_sym_line] = ACTIONS(3889),
    [anon_sym_triangleadj] = ACTIONS(3889),
    [anon_sym_lineadj] = ACTIONS(3889),
    [anon_sym_triangle] = ACTIONS(3889),
    [anon_sym_interface] = ACTIONS(3889),
    [anon_sym_extension] = ACTIONS(3889),
  },
  [3120] = {
    [sym_string_literal] = STATE(2970),
    [sym_raw_string_literal] = STATE(2970),
    [sym_identifier] = ACTIONS(7386),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7388),
    [anon_sym_COMMA] = ACTIONS(7388),
    [aux_sym_preproc_if_token2] = ACTIONS(7388),
    [aux_sym_preproc_else_token1] = ACTIONS(7388),
    [aux_sym_preproc_elif_token1] = ACTIONS(7386),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7388),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7388),
    [anon_sym_LPAREN2] = ACTIONS(7388),
    [anon_sym_DASH] = ACTIONS(7386),
    [anon_sym_PLUS] = ACTIONS(7386),
    [anon_sym_STAR] = ACTIONS(7386),
    [anon_sym_SLASH] = ACTIONS(7386),
    [anon_sym_PERCENT] = ACTIONS(7386),
    [anon_sym_PIPE_PIPE] = ACTIONS(7388),
    [anon_sym_AMP_AMP] = ACTIONS(7388),
    [anon_sym_PIPE] = ACTIONS(7386),
    [anon_sym_CARET] = ACTIONS(7386),
    [anon_sym_AMP] = ACTIONS(7386),
    [anon_sym_EQ_EQ] = ACTIONS(7388),
    [anon_sym_BANG_EQ] = ACTIONS(7388),
    [anon_sym_GT] = ACTIONS(7386),
    [anon_sym_GT_EQ] = ACTIONS(7388),
    [anon_sym_LT_EQ] = ACTIONS(7386),
    [anon_sym_LT] = ACTIONS(7386),
    [anon_sym_LT_LT] = ACTIONS(7386),
    [anon_sym_GT_GT] = ACTIONS(7386),
    [anon_sym_LBRACK] = ACTIONS(7388),
    [anon_sym_EQ] = ACTIONS(7386),
    [anon_sym_QMARK] = ACTIONS(7388),
    [anon_sym_STAR_EQ] = ACTIONS(7388),
    [anon_sym_SLASH_EQ] = ACTIONS(7388),
    [anon_sym_PERCENT_EQ] = ACTIONS(7388),
    [anon_sym_PLUS_EQ] = ACTIONS(7388),
    [anon_sym_DASH_EQ] = ACTIONS(7388),
    [anon_sym_LT_LT_EQ] = ACTIONS(7388),
    [anon_sym_GT_GT_EQ] = ACTIONS(7388),
    [anon_sym_AMP_EQ] = ACTIONS(7388),
    [anon_sym_CARET_EQ] = ACTIONS(7388),
    [anon_sym_PIPE_EQ] = ACTIONS(7388),
    [anon_sym_and_eq] = ACTIONS(7386),
    [anon_sym_or_eq] = ACTIONS(7386),
    [anon_sym_xor_eq] = ACTIONS(7386),
    [anon_sym_LT_EQ_GT] = ACTIONS(7388),
    [anon_sym_or] = ACTIONS(7386),
    [anon_sym_and] = ACTIONS(7386),
    [anon_sym_bitor] = ACTIONS(7386),
    [anon_sym_xor] = ACTIONS(7386),
    [anon_sym_bitand] = ACTIONS(7386),
    [anon_sym_not_eq] = ACTIONS(7386),
    [anon_sym_is] = ACTIONS(7386),
    [anon_sym_as] = ACTIONS(7386),
    [anon_sym_DASH_DASH] = ACTIONS(7388),
    [anon_sym_PLUS_PLUS] = ACTIONS(7388),
    [anon_sym_DOT] = ACTIONS(7386),
    [anon_sym_DOT_STAR] = ACTIONS(7388),
    [anon_sym_DASH_GT] = ACTIONS(7388),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [sym_literal_suffix] = ACTIONS(7386),
  },
  [3121] = {
    [sym_identifier] = ACTIONS(4024),
    [anon_sym___extension__] = ACTIONS(4024),
    [anon_sym_in] = ACTIONS(4024),
    [anon_sym_out] = ACTIONS(4024),
    [anon_sym_inout] = ACTIONS(4024),
    [anon_sym_virtual] = ACTIONS(4024),
    [anon_sym_extern] = ACTIONS(4024),
    [anon_sym___attribute__] = ACTIONS(4024),
    [anon_sym___attribute] = ACTIONS(4024),
    [anon_sym_COLON_COLON] = ACTIONS(4029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4029),
    [anon_sym___declspec] = ACTIONS(4024),
    [anon_sym_signed] = ACTIONS(4024),
    [anon_sym_unsigned] = ACTIONS(4024),
    [anon_sym_long] = ACTIONS(4024),
    [anon_sym_short] = ACTIONS(4024),
    [anon_sym_static] = ACTIONS(4024),
    [anon_sym_register] = ACTIONS(4024),
    [anon_sym_inline] = ACTIONS(4024),
    [anon_sym___inline] = ACTIONS(4024),
    [anon_sym___inline__] = ACTIONS(4024),
    [anon_sym___forceinline] = ACTIONS(4024),
    [anon_sym_thread_local] = ACTIONS(4024),
    [anon_sym___thread] = ACTIONS(4024),
    [anon_sym_const] = ACTIONS(4024),
    [anon_sym_constexpr] = ACTIONS(4024),
    [anon_sym_volatile] = ACTIONS(4024),
    [anon_sym_restrict] = ACTIONS(4024),
    [anon_sym___restrict__] = ACTIONS(4024),
    [anon_sym__Atomic] = ACTIONS(4024),
    [anon_sym__Noreturn] = ACTIONS(4024),
    [anon_sym_noreturn] = ACTIONS(4024),
    [anon_sym__Nonnull] = ACTIONS(4024),
    [anon_sym_mutable] = ACTIONS(4024),
    [anon_sym_constinit] = ACTIONS(4024),
    [anon_sym_consteval] = ACTIONS(4024),
    [anon_sym_alignas] = ACTIONS(4024),
    [anon_sym__Alignas] = ACTIONS(4024),
    [sym_primitive_type] = ACTIONS(4024),
    [anon_sym_enum] = ACTIONS(4024),
    [anon_sym_class] = ACTIONS(4024),
    [anon_sym_struct] = ACTIONS(4024),
    [anon_sym_union] = ACTIONS(4024),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4024),
    [anon_sym_let] = ACTIONS(4024),
    [anon_sym_This] = ACTIONS(4024),
    [anon_sym_decltype] = ACTIONS(4024),
    [anon_sym_typename] = ACTIONS(4024),
    [anon_sym_template] = ACTIONS(4024),
    [anon_sym_precise] = ACTIONS(4024),
    [anon_sym_shared] = ACTIONS(4024),
    [anon_sym_groupshared] = ACTIONS(4024),
    [anon_sym_uniform] = ACTIONS(4024),
    [anon_sym_row_major] = ACTIONS(4024),
    [anon_sym_column_major] = ACTIONS(4024),
    [anon_sym_globallycoherent] = ACTIONS(4024),
    [anon_sym_centroid] = ACTIONS(4024),
    [anon_sym_noperspective] = ACTIONS(4024),
    [anon_sym_nointerpolation] = ACTIONS(4024),
    [anon_sym_sample] = ACTIONS(4024),
    [anon_sym_linear] = ACTIONS(4024),
    [anon_sym_snorm] = ACTIONS(4024),
    [anon_sym_unorm] = ACTIONS(4024),
    [anon_sym_point] = ACTIONS(4024),
    [anon_sym_line] = ACTIONS(4024),
    [anon_sym_triangleadj] = ACTIONS(4024),
    [anon_sym_lineadj] = ACTIONS(4024),
    [anon_sym_triangle] = ACTIONS(4024),
    [anon_sym_interface] = ACTIONS(4024),
    [anon_sym_extension] = ACTIONS(4024),
  },
  [3122] = {
    [sym_identifier] = ACTIONS(7390),
    [anon_sym___extension__] = ACTIONS(7390),
    [anon_sym_in] = ACTIONS(7390),
    [anon_sym_out] = ACTIONS(7390),
    [anon_sym_inout] = ACTIONS(7390),
    [anon_sym_virtual] = ACTIONS(7390),
    [anon_sym_extern] = ACTIONS(7390),
    [anon_sym___attribute__] = ACTIONS(7390),
    [anon_sym___attribute] = ACTIONS(7390),
    [anon_sym_COLON_COLON] = ACTIONS(7392),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7392),
    [anon_sym___declspec] = ACTIONS(7390),
    [anon_sym_signed] = ACTIONS(7390),
    [anon_sym_unsigned] = ACTIONS(7390),
    [anon_sym_long] = ACTIONS(7390),
    [anon_sym_short] = ACTIONS(7390),
    [anon_sym_static] = ACTIONS(7390),
    [anon_sym_register] = ACTIONS(7390),
    [anon_sym_inline] = ACTIONS(7390),
    [anon_sym___inline] = ACTIONS(7390),
    [anon_sym___inline__] = ACTIONS(7390),
    [anon_sym___forceinline] = ACTIONS(7390),
    [anon_sym_thread_local] = ACTIONS(7390),
    [anon_sym___thread] = ACTIONS(7390),
    [anon_sym_const] = ACTIONS(7390),
    [anon_sym_constexpr] = ACTIONS(7390),
    [anon_sym_volatile] = ACTIONS(7390),
    [anon_sym_restrict] = ACTIONS(7390),
    [anon_sym___restrict__] = ACTIONS(7390),
    [anon_sym__Atomic] = ACTIONS(7390),
    [anon_sym__Noreturn] = ACTIONS(7390),
    [anon_sym_noreturn] = ACTIONS(7390),
    [anon_sym__Nonnull] = ACTIONS(7390),
    [anon_sym_mutable] = ACTIONS(7390),
    [anon_sym_constinit] = ACTIONS(7390),
    [anon_sym_consteval] = ACTIONS(7390),
    [anon_sym_alignas] = ACTIONS(7390),
    [anon_sym__Alignas] = ACTIONS(7390),
    [sym_primitive_type] = ACTIONS(7390),
    [anon_sym_enum] = ACTIONS(7390),
    [anon_sym_class] = ACTIONS(7390),
    [anon_sym_struct] = ACTIONS(7390),
    [anon_sym_union] = ACTIONS(7390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(7390),
    [anon_sym_let] = ACTIONS(7390),
    [anon_sym_This] = ACTIONS(7390),
    [anon_sym_decltype] = ACTIONS(7390),
    [anon_sym_typename] = ACTIONS(7390),
    [anon_sym_template] = ACTIONS(7390),
    [anon_sym_precise] = ACTIONS(7390),
    [anon_sym_shared] = ACTIONS(7390),
    [anon_sym_groupshared] = ACTIONS(7390),
    [anon_sym_uniform] = ACTIONS(7390),
    [anon_sym_row_major] = ACTIONS(7390),
    [anon_sym_column_major] = ACTIONS(7390),
    [anon_sym_globallycoherent] = ACTIONS(7390),
    [anon_sym_centroid] = ACTIONS(7390),
    [anon_sym_noperspective] = ACTIONS(7390),
    [anon_sym_nointerpolation] = ACTIONS(7390),
    [anon_sym_sample] = ACTIONS(7390),
    [anon_sym_linear] = ACTIONS(7390),
    [anon_sym_snorm] = ACTIONS(7390),
    [anon_sym_unorm] = ACTIONS(7390),
    [anon_sym_point] = ACTIONS(7390),
    [anon_sym_line] = ACTIONS(7390),
    [anon_sym_triangleadj] = ACTIONS(7390),
    [anon_sym_lineadj] = ACTIONS(7390),
    [anon_sym_triangle] = ACTIONS(7390),
    [anon_sym_interface] = ACTIONS(7390),
    [anon_sym_extension] = ACTIONS(7390),
  },
  [3123] = {
    [sym_ms_based_modifier] = STATE(10947),
    [sym_ms_unaligned_ptr_modifier] = STATE(5091),
    [sym_ms_pointer_modifier] = STATE(3124),
    [sym__declarator] = STATE(7998),
    [sym__abstract_declarator] = STATE(8358),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_abstract_parenthesized_declarator] = STATE(7454),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_abstract_pointer_declarator] = STATE(7454),
    [sym_function_declarator] = STATE(8054),
    [sym_abstract_function_declarator] = STATE(7454),
    [sym_array_declarator] = STATE(8054),
    [sym_abstract_array_declarator] = STATE(7454),
    [sym_type_qualifier] = STATE(3529),
    [sym_alignas_qualifier] = STATE(5539),
    [sym_parameter_list] = STATE(3727),
    [sym_decltype] = STATE(11339),
    [sym_reference_declarator] = STATE(8054),
    [sym_abstract_reference_declarator] = STATE(7454),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym__function_declarator_seq] = STATE(7543),
    [sym_template_type] = STATE(11339),
    [sym_template_function] = STATE(8054),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7400),
    [sym_qualified_identifier] = STATE(8054),
    [sym_operator_name] = STATE(8054),
    [aux_sym__type_definition_type_repeat1] = STATE(3529),
    [aux_sym_pointer_declarator_repeat1] = STATE(3124),
    [sym_identifier] = ACTIONS(7394),
    [anon_sym_COMMA] = ACTIONS(7396),
    [anon_sym_RPAREN] = ACTIONS(7396),
    [anon_sym_LPAREN2] = ACTIONS(5344),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(7398),
    [anon_sym_AMP_AMP] = ACTIONS(7400),
    [anon_sym_AMP] = ACTIONS(7402),
    [anon_sym_COLON] = ACTIONS(7404),
    [anon_sym___extension__] = ACTIONS(5368),
    [anon_sym___attribute__] = ACTIONS(7404),
    [anon_sym___attribute] = ACTIONS(7404),
    [anon_sym_COLON_COLON] = ACTIONS(7406),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(5364),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(5364),
    [sym_ms_signed_ptr_modifier] = ACTIONS(5364),
    [anon_sym__unaligned] = ACTIONS(5366),
    [anon_sym___unaligned] = ACTIONS(5366),
    [anon_sym_LBRACK] = ACTIONS(7408),
    [anon_sym_EQ] = ACTIONS(7396),
    [anon_sym_const] = ACTIONS(5368),
    [anon_sym_constexpr] = ACTIONS(5368),
    [anon_sym_volatile] = ACTIONS(5368),
    [anon_sym_restrict] = ACTIONS(5368),
    [anon_sym___restrict__] = ACTIONS(5368),
    [anon_sym__Atomic] = ACTIONS(5368),
    [anon_sym__Noreturn] = ACTIONS(5368),
    [anon_sym_noreturn] = ACTIONS(5368),
    [anon_sym__Nonnull] = ACTIONS(5368),
    [anon_sym_mutable] = ACTIONS(5368),
    [anon_sym_constinit] = ACTIONS(5368),
    [anon_sym_consteval] = ACTIONS(5368),
    [anon_sym_alignas] = ACTIONS(5370),
    [anon_sym__Alignas] = ACTIONS(5370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(7396),
    [anon_sym_operator] = ACTIONS(2861),
  },
  [3124] = {
    [sym_ms_based_modifier] = STATE(10947),
    [sym_ms_unaligned_ptr_modifier] = STATE(5091),
    [sym_ms_pointer_modifier] = STATE(4976),
    [sym__declarator] = STATE(7901),
    [sym__abstract_declarator] = STATE(8361),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_abstract_parenthesized_declarator] = STATE(7454),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_abstract_pointer_declarator] = STATE(7454),
    [sym_function_declarator] = STATE(8054),
    [sym_abstract_function_declarator] = STATE(7454),
    [sym_array_declarator] = STATE(8054),
    [sym_abstract_array_declarator] = STATE(7454),
    [sym_type_qualifier] = STATE(3530),
    [sym_alignas_qualifier] = STATE(5539),
    [sym_parameter_list] = STATE(3727),
    [sym_decltype] = STATE(11339),
    [sym_reference_declarator] = STATE(8054),
    [sym_abstract_reference_declarator] = STATE(7454),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym__function_declarator_seq] = STATE(7543),
    [sym_template_type] = STATE(11339),
    [sym_template_function] = STATE(8054),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7400),
    [sym_qualified_identifier] = STATE(8054),
    [sym_operator_name] = STATE(8054),
    [aux_sym__type_definition_type_repeat1] = STATE(3530),
    [aux_sym_pointer_declarator_repeat1] = STATE(4976),
    [sym_identifier] = ACTIONS(7394),
    [anon_sym_COMMA] = ACTIONS(7410),
    [anon_sym_RPAREN] = ACTIONS(7410),
    [anon_sym_LPAREN2] = ACTIONS(5344),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(7398),
    [anon_sym_AMP_AMP] = ACTIONS(7400),
    [anon_sym_AMP] = ACTIONS(7402),
    [anon_sym_COLON] = ACTIONS(7412),
    [anon_sym___extension__] = ACTIONS(5368),
    [anon_sym___attribute__] = ACTIONS(7412),
    [anon_sym___attribute] = ACTIONS(7412),
    [anon_sym_COLON_COLON] = ACTIONS(7406),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(5364),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(5364),
    [sym_ms_signed_ptr_modifier] = ACTIONS(5364),
    [anon_sym__unaligned] = ACTIONS(5366),
    [anon_sym___unaligned] = ACTIONS(5366),
    [anon_sym_LBRACK] = ACTIONS(7408),
    [anon_sym_EQ] = ACTIONS(7410),
    [anon_sym_const] = ACTIONS(5368),
    [anon_sym_constexpr] = ACTIONS(5368),
    [anon_sym_volatile] = ACTIONS(5368),
    [anon_sym_restrict] = ACTIONS(5368),
    [anon_sym___restrict__] = ACTIONS(5368),
    [anon_sym__Atomic] = ACTIONS(5368),
    [anon_sym__Noreturn] = ACTIONS(5368),
    [anon_sym_noreturn] = ACTIONS(5368),
    [anon_sym__Nonnull] = ACTIONS(5368),
    [anon_sym_mutable] = ACTIONS(5368),
    [anon_sym_constinit] = ACTIONS(5368),
    [anon_sym_consteval] = ACTIONS(5368),
    [anon_sym_alignas] = ACTIONS(5370),
    [anon_sym__Alignas] = ACTIONS(5370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(7410),
    [anon_sym_operator] = ACTIONS(2861),
  },
  [3125] = {
    [sym_template_argument_list] = STATE(3064),
    [sym_identifier] = ACTIONS(2222),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2229),
    [anon_sym_STAR] = ACTIONS(2229),
    [anon_sym_AMP_AMP] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(7064),
    [anon_sym_SEMI] = ACTIONS(2224),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_virtual] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym___attribute] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2226),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym___based] = ACTIONS(2222),
    [anon_sym_LBRACK] = ACTIONS(2231),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym__Nonnull] = ACTIONS(2222),
    [anon_sym_mutable] = ACTIONS(2222),
    [anon_sym_constinit] = ACTIONS(2222),
    [anon_sym_consteval] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [anon_sym_DOT] = ACTIONS(2229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2222),
    [anon_sym_let] = ACTIONS(2222),
    [anon_sym_This] = ACTIONS(2222),
    [anon_sym_decltype] = ACTIONS(2222),
    [anon_sym_template] = ACTIONS(2222),
    [anon_sym_operator] = ACTIONS(2222),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_groupshared] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_row_major] = ACTIONS(2222),
    [anon_sym_column_major] = ACTIONS(2222),
    [anon_sym_globallycoherent] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym_nointerpolation] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_linear] = ACTIONS(2222),
    [anon_sym_snorm] = ACTIONS(2222),
    [anon_sym_unorm] = ACTIONS(2222),
    [anon_sym_point] = ACTIONS(2222),
    [anon_sym_line] = ACTIONS(2222),
    [anon_sym_triangleadj] = ACTIONS(2222),
    [anon_sym_lineadj] = ACTIONS(2222),
    [anon_sym_triangle] = ACTIONS(2222),
  },
  [3126] = {
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_RPAREN] = ACTIONS(2420),
    [aux_sym_preproc_if_token2] = ACTIONS(2420),
    [aux_sym_preproc_else_token1] = ACTIONS(2420),
    [aux_sym_preproc_elif_token1] = ACTIONS(2422),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2420),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2420),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2422),
    [anon_sym_SLASH] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2422),
    [anon_sym_PIPE_PIPE] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_PIPE] = ACTIONS(2422),
    [anon_sym_CARET] = ACTIONS(2422),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_EQ_EQ] = ACTIONS(2420),
    [anon_sym_BANG_EQ] = ACTIONS(2420),
    [anon_sym_GT] = ACTIONS(2422),
    [anon_sym_GT_EQ] = ACTIONS(2420),
    [anon_sym_LT_EQ] = ACTIONS(2422),
    [anon_sym_LT] = ACTIONS(2422),
    [anon_sym_LT_LT] = ACTIONS(2422),
    [anon_sym_GT_GT] = ACTIONS(2422),
    [anon_sym_COLON] = ACTIONS(2420),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___attribute__] = ACTIONS(2422),
    [anon_sym___attribute] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [anon_sym_RBRACK] = ACTIONS(2420),
    [anon_sym_EQ] = ACTIONS(2422),
    [anon_sym_QMARK] = ACTIONS(2420),
    [anon_sym_STAR_EQ] = ACTIONS(2420),
    [anon_sym_SLASH_EQ] = ACTIONS(2420),
    [anon_sym_PERCENT_EQ] = ACTIONS(2420),
    [anon_sym_PLUS_EQ] = ACTIONS(2420),
    [anon_sym_DASH_EQ] = ACTIONS(2420),
    [anon_sym_LT_LT_EQ] = ACTIONS(2420),
    [anon_sym_GT_GT_EQ] = ACTIONS(2420),
    [anon_sym_AMP_EQ] = ACTIONS(2420),
    [anon_sym_CARET_EQ] = ACTIONS(2420),
    [anon_sym_PIPE_EQ] = ACTIONS(2420),
    [anon_sym_and_eq] = ACTIONS(2422),
    [anon_sym_or_eq] = ACTIONS(2422),
    [anon_sym_xor_eq] = ACTIONS(2422),
    [anon_sym_LT_EQ_GT] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2422),
    [anon_sym_and] = ACTIONS(2422),
    [anon_sym_bitor] = ACTIONS(2422),
    [anon_sym_xor] = ACTIONS(2422),
    [anon_sym_bitand] = ACTIONS(2422),
    [anon_sym_not_eq] = ACTIONS(2422),
    [anon_sym_is] = ACTIONS(2422),
    [anon_sym_as] = ACTIONS(2422),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_DOT] = ACTIONS(2422),
    [anon_sym_DOT_STAR] = ACTIONS(2420),
    [anon_sym_DASH_GT] = ACTIONS(2420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_This] = ACTIONS(2422),
    [anon_sym_final] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
  },
  [3127] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2881),
    [sym_identifier] = ACTIONS(2915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4121),
    [anon_sym_COMMA] = ACTIONS(4121),
    [anon_sym_RPAREN] = ACTIONS(4121),
    [anon_sym_LPAREN2] = ACTIONS(4121),
    [anon_sym_DASH] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4124),
    [anon_sym_STAR] = ACTIONS(4121),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_PERCENT] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4121),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE] = ACTIONS(4124),
    [anon_sym_CARET] = ACTIONS(4121),
    [anon_sym_AMP] = ACTIONS(4124),
    [anon_sym_EQ_EQ] = ACTIONS(4121),
    [anon_sym_BANG_EQ] = ACTIONS(4121),
    [anon_sym_GT] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4121),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_LT_LT] = ACTIONS(4121),
    [anon_sym_GT_GT] = ACTIONS(4121),
    [anon_sym_COLON] = ACTIONS(4121),
    [anon_sym_SEMI] = ACTIONS(4121),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(4124),
    [anon_sym___attribute] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_RBRACE] = ACTIONS(4121),
    [anon_sym_signed] = ACTIONS(7112),
    [anon_sym_unsigned] = ACTIONS(7112),
    [anon_sym_long] = ACTIONS(7112),
    [anon_sym_short] = ACTIONS(7112),
    [anon_sym_LBRACK] = ACTIONS(4121),
    [anon_sym_RBRACK] = ACTIONS(4121),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(4121),
    [anon_sym_LT_EQ_GT] = ACTIONS(4121),
    [anon_sym_or] = ACTIONS(4124),
    [anon_sym_and] = ACTIONS(4124),
    [anon_sym_bitor] = ACTIONS(4124),
    [anon_sym_xor] = ACTIONS(4124),
    [anon_sym_bitand] = ACTIONS(4124),
    [anon_sym_not_eq] = ACTIONS(4124),
    [anon_sym_is] = ACTIONS(4124),
    [anon_sym_as] = ACTIONS(4124),
    [anon_sym_DASH_DASH] = ACTIONS(4121),
    [anon_sym_PLUS_PLUS] = ACTIONS(4121),
    [anon_sym_DOT] = ACTIONS(4124),
    [anon_sym_DOT_STAR] = ACTIONS(4121),
    [anon_sym_DASH_GT] = ACTIONS(4121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4124),
    [anon_sym_let] = ACTIONS(4124),
    [anon_sym_This] = ACTIONS(4124),
  },
  [3128] = {
    [sym_attribute_specifier] = STATE(3247),
    [sym_enumerator_list] = STATE(3137),
    [sym_identifier] = ACTIONS(3993),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3991),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [aux_sym_preproc_if_token2] = ACTIONS(3991),
    [aux_sym_preproc_else_token1] = ACTIONS(3991),
    [aux_sym_preproc_elif_token1] = ACTIONS(3993),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3991),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3991),
    [anon_sym_LPAREN2] = ACTIONS(3991),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_COLON] = ACTIONS(3991),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym___attribute__] = ACTIONS(7254),
    [anon_sym___attribute] = ACTIONS(7254),
    [anon_sym_LBRACE] = ACTIONS(7384),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_QMARK] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_and_eq] = ACTIONS(3993),
    [anon_sym_or_eq] = ACTIONS(3993),
    [anon_sym_xor_eq] = ACTIONS(3993),
    [anon_sym_LT_EQ_GT] = ACTIONS(3991),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_bitor] = ACTIONS(3993),
    [anon_sym_xor] = ACTIONS(3993),
    [anon_sym_bitand] = ACTIONS(3993),
    [anon_sym_not_eq] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_DOT_STAR] = ACTIONS(3991),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3993),
    [anon_sym_let] = ACTIONS(3993),
    [anon_sym_This] = ACTIONS(3993),
  },
  [3129] = {
    [sym_identifier] = ACTIONS(3379),
    [anon_sym___extension__] = ACTIONS(3379),
    [anon_sym_in] = ACTIONS(3379),
    [anon_sym_out] = ACTIONS(3379),
    [anon_sym_inout] = ACTIONS(3379),
    [anon_sym_virtual] = ACTIONS(3379),
    [anon_sym_extern] = ACTIONS(3379),
    [anon_sym___attribute__] = ACTIONS(3379),
    [anon_sym___attribute] = ACTIONS(3379),
    [anon_sym_COLON_COLON] = ACTIONS(3381),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3381),
    [anon_sym___declspec] = ACTIONS(3379),
    [anon_sym_signed] = ACTIONS(3379),
    [anon_sym_unsigned] = ACTIONS(3379),
    [anon_sym_long] = ACTIONS(3379),
    [anon_sym_short] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_register] = ACTIONS(3379),
    [anon_sym_inline] = ACTIONS(3379),
    [anon_sym___inline] = ACTIONS(3379),
    [anon_sym___inline__] = ACTIONS(3379),
    [anon_sym___forceinline] = ACTIONS(3379),
    [anon_sym_thread_local] = ACTIONS(3379),
    [anon_sym___thread] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_constexpr] = ACTIONS(3379),
    [anon_sym_volatile] = ACTIONS(3379),
    [anon_sym_restrict] = ACTIONS(3379),
    [anon_sym___restrict__] = ACTIONS(3379),
    [anon_sym__Atomic] = ACTIONS(3379),
    [anon_sym__Noreturn] = ACTIONS(3379),
    [anon_sym_noreturn] = ACTIONS(3379),
    [anon_sym__Nonnull] = ACTIONS(3379),
    [anon_sym_mutable] = ACTIONS(3379),
    [anon_sym_constinit] = ACTIONS(3379),
    [anon_sym_consteval] = ACTIONS(3379),
    [anon_sym_alignas] = ACTIONS(3379),
    [anon_sym__Alignas] = ACTIONS(3379),
    [sym_primitive_type] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_struct] = ACTIONS(3379),
    [anon_sym_union] = ACTIONS(3379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3379),
    [anon_sym_let] = ACTIONS(3379),
    [anon_sym_This] = ACTIONS(3379),
    [anon_sym_decltype] = ACTIONS(3379),
    [anon_sym_typename] = ACTIONS(3379),
    [anon_sym_template] = ACTIONS(3379),
    [anon_sym_precise] = ACTIONS(3379),
    [anon_sym_shared] = ACTIONS(3379),
    [anon_sym_groupshared] = ACTIONS(3379),
    [anon_sym_uniform] = ACTIONS(3379),
    [anon_sym_row_major] = ACTIONS(3379),
    [anon_sym_column_major] = ACTIONS(3379),
    [anon_sym_globallycoherent] = ACTIONS(3379),
    [anon_sym_centroid] = ACTIONS(3379),
    [anon_sym_noperspective] = ACTIONS(3379),
    [anon_sym_nointerpolation] = ACTIONS(3379),
    [anon_sym_sample] = ACTIONS(3379),
    [anon_sym_linear] = ACTIONS(3379),
    [anon_sym_snorm] = ACTIONS(3379),
    [anon_sym_unorm] = ACTIONS(3379),
    [anon_sym_point] = ACTIONS(3379),
    [anon_sym_line] = ACTIONS(3379),
    [anon_sym_triangleadj] = ACTIONS(3379),
    [anon_sym_lineadj] = ACTIONS(3379),
    [anon_sym_triangle] = ACTIONS(3379),
    [anon_sym_interface] = ACTIONS(3379),
    [anon_sym_extension] = ACTIONS(3379),
  },
  [3130] = {
    [sym_identifier] = ACTIONS(3763),
    [anon_sym___extension__] = ACTIONS(3763),
    [anon_sym_in] = ACTIONS(3763),
    [anon_sym_out] = ACTIONS(3763),
    [anon_sym_inout] = ACTIONS(3763),
    [anon_sym_virtual] = ACTIONS(3763),
    [anon_sym_extern] = ACTIONS(3763),
    [anon_sym___attribute__] = ACTIONS(3763),
    [anon_sym___attribute] = ACTIONS(3763),
    [anon_sym_COLON_COLON] = ACTIONS(3765),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3765),
    [anon_sym___declspec] = ACTIONS(3763),
    [anon_sym_signed] = ACTIONS(3763),
    [anon_sym_unsigned] = ACTIONS(3763),
    [anon_sym_long] = ACTIONS(3763),
    [anon_sym_short] = ACTIONS(3763),
    [anon_sym_static] = ACTIONS(3763),
    [anon_sym_register] = ACTIONS(3763),
    [anon_sym_inline] = ACTIONS(3763),
    [anon_sym___inline] = ACTIONS(3763),
    [anon_sym___inline__] = ACTIONS(3763),
    [anon_sym___forceinline] = ACTIONS(3763),
    [anon_sym_thread_local] = ACTIONS(3763),
    [anon_sym___thread] = ACTIONS(3763),
    [anon_sym_const] = ACTIONS(3763),
    [anon_sym_constexpr] = ACTIONS(3763),
    [anon_sym_volatile] = ACTIONS(3763),
    [anon_sym_restrict] = ACTIONS(3763),
    [anon_sym___restrict__] = ACTIONS(3763),
    [anon_sym__Atomic] = ACTIONS(3763),
    [anon_sym__Noreturn] = ACTIONS(3763),
    [anon_sym_noreturn] = ACTIONS(3763),
    [anon_sym__Nonnull] = ACTIONS(3763),
    [anon_sym_mutable] = ACTIONS(3763),
    [anon_sym_constinit] = ACTIONS(3763),
    [anon_sym_consteval] = ACTIONS(3763),
    [anon_sym_alignas] = ACTIONS(3763),
    [anon_sym__Alignas] = ACTIONS(3763),
    [sym_primitive_type] = ACTIONS(3763),
    [anon_sym_enum] = ACTIONS(3763),
    [anon_sym_class] = ACTIONS(3763),
    [anon_sym_struct] = ACTIONS(3763),
    [anon_sym_union] = ACTIONS(3763),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3763),
    [anon_sym_let] = ACTIONS(3763),
    [anon_sym_This] = ACTIONS(3763),
    [anon_sym_decltype] = ACTIONS(3763),
    [anon_sym_typename] = ACTIONS(3763),
    [anon_sym_template] = ACTIONS(3763),
    [anon_sym_precise] = ACTIONS(3763),
    [anon_sym_shared] = ACTIONS(3763),
    [anon_sym_groupshared] = ACTIONS(3763),
    [anon_sym_uniform] = ACTIONS(3763),
    [anon_sym_row_major] = ACTIONS(3763),
    [anon_sym_column_major] = ACTIONS(3763),
    [anon_sym_globallycoherent] = ACTIONS(3763),
    [anon_sym_centroid] = ACTIONS(3763),
    [anon_sym_noperspective] = ACTIONS(3763),
    [anon_sym_nointerpolation] = ACTIONS(3763),
    [anon_sym_sample] = ACTIONS(3763),
    [anon_sym_linear] = ACTIONS(3763),
    [anon_sym_snorm] = ACTIONS(3763),
    [anon_sym_unorm] = ACTIONS(3763),
    [anon_sym_point] = ACTIONS(3763),
    [anon_sym_line] = ACTIONS(3763),
    [anon_sym_triangleadj] = ACTIONS(3763),
    [anon_sym_lineadj] = ACTIONS(3763),
    [anon_sym_triangle] = ACTIONS(3763),
    [anon_sym_interface] = ACTIONS(3763),
    [anon_sym_extension] = ACTIONS(3763),
  },
  [3131] = {
    [sym_identifier] = ACTIONS(3460),
    [anon_sym___extension__] = ACTIONS(3460),
    [anon_sym_in] = ACTIONS(3460),
    [anon_sym_out] = ACTIONS(3460),
    [anon_sym_inout] = ACTIONS(3460),
    [anon_sym_virtual] = ACTIONS(3460),
    [anon_sym_extern] = ACTIONS(3460),
    [anon_sym___attribute__] = ACTIONS(3460),
    [anon_sym___attribute] = ACTIONS(3460),
    [anon_sym_COLON_COLON] = ACTIONS(3458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3458),
    [anon_sym___declspec] = ACTIONS(3460),
    [anon_sym_signed] = ACTIONS(3460),
    [anon_sym_unsigned] = ACTIONS(3460),
    [anon_sym_long] = ACTIONS(3460),
    [anon_sym_short] = ACTIONS(3460),
    [anon_sym_static] = ACTIONS(3460),
    [anon_sym_register] = ACTIONS(3460),
    [anon_sym_inline] = ACTIONS(3460),
    [anon_sym___inline] = ACTIONS(3460),
    [anon_sym___inline__] = ACTIONS(3460),
    [anon_sym___forceinline] = ACTIONS(3460),
    [anon_sym_thread_local] = ACTIONS(3460),
    [anon_sym___thread] = ACTIONS(3460),
    [anon_sym_const] = ACTIONS(3460),
    [anon_sym_constexpr] = ACTIONS(3460),
    [anon_sym_volatile] = ACTIONS(3460),
    [anon_sym_restrict] = ACTIONS(3460),
    [anon_sym___restrict__] = ACTIONS(3460),
    [anon_sym__Atomic] = ACTIONS(3460),
    [anon_sym__Noreturn] = ACTIONS(3460),
    [anon_sym_noreturn] = ACTIONS(3460),
    [anon_sym__Nonnull] = ACTIONS(3460),
    [anon_sym_mutable] = ACTIONS(3460),
    [anon_sym_constinit] = ACTIONS(3460),
    [anon_sym_consteval] = ACTIONS(3460),
    [anon_sym_alignas] = ACTIONS(3460),
    [anon_sym__Alignas] = ACTIONS(3460),
    [sym_primitive_type] = ACTIONS(3460),
    [anon_sym_enum] = ACTIONS(3460),
    [anon_sym_class] = ACTIONS(3460),
    [anon_sym_struct] = ACTIONS(3460),
    [anon_sym_union] = ACTIONS(3460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3460),
    [anon_sym_let] = ACTIONS(3460),
    [anon_sym_This] = ACTIONS(3460),
    [anon_sym_decltype] = ACTIONS(3460),
    [anon_sym_typename] = ACTIONS(3460),
    [anon_sym_template] = ACTIONS(3460),
    [anon_sym_precise] = ACTIONS(3460),
    [anon_sym_shared] = ACTIONS(3460),
    [anon_sym_groupshared] = ACTIONS(3460),
    [anon_sym_uniform] = ACTIONS(3460),
    [anon_sym_row_major] = ACTIONS(3460),
    [anon_sym_column_major] = ACTIONS(3460),
    [anon_sym_globallycoherent] = ACTIONS(3460),
    [anon_sym_centroid] = ACTIONS(3460),
    [anon_sym_noperspective] = ACTIONS(3460),
    [anon_sym_nointerpolation] = ACTIONS(3460),
    [anon_sym_sample] = ACTIONS(3460),
    [anon_sym_linear] = ACTIONS(3460),
    [anon_sym_snorm] = ACTIONS(3460),
    [anon_sym_unorm] = ACTIONS(3460),
    [anon_sym_point] = ACTIONS(3460),
    [anon_sym_line] = ACTIONS(3460),
    [anon_sym_triangleadj] = ACTIONS(3460),
    [anon_sym_lineadj] = ACTIONS(3460),
    [anon_sym_triangle] = ACTIONS(3460),
    [anon_sym_interface] = ACTIONS(3460),
    [anon_sym_extension] = ACTIONS(3460),
  },
  [3132] = {
    [sym_attribute_specifier] = STATE(3032),
    [sym_enumerator_list] = STATE(3168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3991),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_LPAREN2] = ACTIONS(3991),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3991),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym___extension__] = ACTIONS(3991),
    [anon_sym___attribute__] = ACTIONS(7346),
    [anon_sym___attribute] = ACTIONS(7348),
    [anon_sym_LBRACE] = ACTIONS(7414),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_const] = ACTIONS(3993),
    [anon_sym_constexpr] = ACTIONS(3991),
    [anon_sym_volatile] = ACTIONS(3991),
    [anon_sym_restrict] = ACTIONS(3991),
    [anon_sym___restrict__] = ACTIONS(3991),
    [anon_sym__Atomic] = ACTIONS(3991),
    [anon_sym__Noreturn] = ACTIONS(3991),
    [anon_sym_noreturn] = ACTIONS(3991),
    [anon_sym__Nonnull] = ACTIONS(3991),
    [anon_sym_mutable] = ACTIONS(3991),
    [anon_sym_constinit] = ACTIONS(3991),
    [anon_sym_consteval] = ACTIONS(3991),
    [anon_sym_alignas] = ACTIONS(3991),
    [anon_sym__Alignas] = ACTIONS(3991),
    [anon_sym_QMARK] = ACTIONS(3991),
    [anon_sym_LT_EQ_GT] = ACTIONS(3991),
    [anon_sym_or] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3991),
    [anon_sym_bitor] = ACTIONS(3991),
    [anon_sym_xor] = ACTIONS(3991),
    [anon_sym_bitand] = ACTIONS(3991),
    [anon_sym_not_eq] = ACTIONS(3991),
    [anon_sym_is] = ACTIONS(3991),
    [anon_sym_as] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_DOT_STAR] = ACTIONS(3991),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3991),
    [anon_sym_let] = ACTIONS(3991),
    [anon_sym_This] = ACTIONS(3991),
    [anon_sym_final] = ACTIONS(3991),
    [anon_sym_override] = ACTIONS(3991),
    [anon_sym_requires] = ACTIONS(3991),
    [anon_sym_where] = ACTIONS(3991),
  },
  [3133] = {
    [sym_string_literal] = STATE(2970),
    [sym_template_argument_list] = STATE(3325),
    [sym_raw_string_literal] = STATE(2970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(7416),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(7185),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7416),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_RBRACE] = ACTIONS(2170),
    [anon_sym_LBRACK] = ACTIONS(7418),
    [anon_sym_EQ] = ACTIONS(2181),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2170),
    [anon_sym_SLASH_EQ] = ACTIONS(2170),
    [anon_sym_PERCENT_EQ] = ACTIONS(2170),
    [anon_sym_PLUS_EQ] = ACTIONS(2170),
    [anon_sym_DASH_EQ] = ACTIONS(2170),
    [anon_sym_LT_LT_EQ] = ACTIONS(2170),
    [anon_sym_GT_GT_EQ] = ACTIONS(2170),
    [anon_sym_AMP_EQ] = ACTIONS(2170),
    [anon_sym_CARET_EQ] = ACTIONS(2170),
    [anon_sym_PIPE_EQ] = ACTIONS(2170),
    [anon_sym_and_eq] = ACTIONS(2170),
    [anon_sym_or_eq] = ACTIONS(2170),
    [anon_sym_xor_eq] = ACTIONS(2170),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
  },
  [3134] = {
    [sym_string_literal] = STATE(4064),
    [sym_template_argument_list] = STATE(4695),
    [sym_raw_string_literal] = STATE(4064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6839),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym___attribute__] = ACTIONS(2170),
    [anon_sym___attribute] = ACTIONS(2181),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_EQ] = ACTIONS(7420),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(7422),
    [anon_sym_SLASH_EQ] = ACTIONS(7422),
    [anon_sym_PERCENT_EQ] = ACTIONS(7422),
    [anon_sym_PLUS_EQ] = ACTIONS(7422),
    [anon_sym_DASH_EQ] = ACTIONS(7422),
    [anon_sym_LT_LT_EQ] = ACTIONS(7422),
    [anon_sym_GT_GT_EQ] = ACTIONS(7422),
    [anon_sym_AMP_EQ] = ACTIONS(7422),
    [anon_sym_CARET_EQ] = ACTIONS(7422),
    [anon_sym_PIPE_EQ] = ACTIONS(7422),
    [anon_sym_and_eq] = ACTIONS(7422),
    [anon_sym_or_eq] = ACTIONS(7422),
    [anon_sym_xor_eq] = ACTIONS(7422),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(7424),
    [anon_sym_u_DQUOTE] = ACTIONS(7424),
    [anon_sym_U_DQUOTE] = ACTIONS(7424),
    [anon_sym_u8_DQUOTE] = ACTIONS(7424),
    [anon_sym_DQUOTE] = ACTIONS(7424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7426),
    [anon_sym_LR_DQUOTE] = ACTIONS(7426),
    [anon_sym_uR_DQUOTE] = ACTIONS(7426),
    [anon_sym_UR_DQUOTE] = ACTIONS(7426),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7426),
  },
  [3135] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(4695),
    [sym_raw_string_literal] = STATE(3527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_RPAREN] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6839),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_RBRACE] = ACTIONS(2170),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2207),
    [anon_sym_SLASH_EQ] = ACTIONS(2207),
    [anon_sym_PERCENT_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_GT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_EQ] = ACTIONS(2207),
    [anon_sym_CARET_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_EQ] = ACTIONS(2207),
    [anon_sym_and_eq] = ACTIONS(2207),
    [anon_sym_or_eq] = ACTIONS(2207),
    [anon_sym_xor_eq] = ACTIONS(2207),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
  },
  [3136] = {
    [sym__declaration_modifiers] = STATE(2773),
    [sym_attribute_specifier] = STATE(2773),
    [sym_attribute_declaration] = STATE(2773),
    [sym_ms_declspec_modifier] = STATE(2773),
    [sym_storage_class_specifier] = STATE(2773),
    [sym_type_qualifier] = STATE(2773),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_qualifiers] = STATE(2773),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2773),
    [anon_sym_LPAREN2] = ACTIONS(6951),
    [anon_sym_STAR] = ACTIONS(6951),
    [anon_sym_AMP_AMP] = ACTIONS(6951),
    [anon_sym_AMP] = ACTIONS(6949),
    [anon_sym___extension__] = ACTIONS(7428),
    [anon_sym_in] = ACTIONS(6955),
    [anon_sym_out] = ACTIONS(7430),
    [anon_sym_inout] = ACTIONS(7430),
    [anon_sym_virtual] = ACTIONS(7430),
    [anon_sym_extern] = ACTIONS(7432),
    [anon_sym___attribute__] = ACTIONS(7434),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(7436),
    [anon_sym_LBRACK] = ACTIONS(6949),
    [anon_sym_static] = ACTIONS(7432),
    [anon_sym_register] = ACTIONS(7432),
    [anon_sym_inline] = ACTIONS(7432),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(7432),
    [anon_sym___forceinline] = ACTIONS(7432),
    [anon_sym_thread_local] = ACTIONS(7432),
    [anon_sym___thread] = ACTIONS(7432),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(7428),
    [anon_sym_volatile] = ACTIONS(7428),
    [anon_sym_restrict] = ACTIONS(7428),
    [anon_sym___restrict__] = ACTIONS(7428),
    [anon_sym__Atomic] = ACTIONS(7428),
    [anon_sym__Noreturn] = ACTIONS(7428),
    [anon_sym_noreturn] = ACTIONS(7428),
    [anon_sym__Nonnull] = ACTIONS(7428),
    [anon_sym_mutable] = ACTIONS(7428),
    [anon_sym_constinit] = ACTIONS(7428),
    [anon_sym_consteval] = ACTIONS(7428),
    [anon_sym_alignas] = ACTIONS(7438),
    [anon_sym__Alignas] = ACTIONS(7438),
    [anon_sym_DOT] = ACTIONS(7440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(7442),
    [anon_sym_let] = ACTIONS(7442),
    [anon_sym_This] = ACTIONS(7442),
    [anon_sym_precise] = ACTIONS(7444),
    [anon_sym_shared] = ACTIONS(7444),
    [anon_sym_groupshared] = ACTIONS(7444),
    [anon_sym_uniform] = ACTIONS(7444),
    [anon_sym_row_major] = ACTIONS(7444),
    [anon_sym_column_major] = ACTIONS(7444),
    [anon_sym_globallycoherent] = ACTIONS(7444),
    [anon_sym_centroid] = ACTIONS(7444),
    [anon_sym_noperspective] = ACTIONS(7444),
    [anon_sym_nointerpolation] = ACTIONS(7444),
    [anon_sym_sample] = ACTIONS(7444),
    [anon_sym_linear] = ACTIONS(7444),
    [anon_sym_snorm] = ACTIONS(7444),
    [anon_sym_unorm] = ACTIONS(7444),
    [anon_sym_point] = ACTIONS(7444),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(7444),
    [anon_sym_lineadj] = ACTIONS(7444),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [3137] = {
    [sym_attribute_specifier] = STATE(3253),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4085),
    [anon_sym_COMMA] = ACTIONS(4085),
    [anon_sym_RPAREN] = ACTIONS(4085),
    [aux_sym_preproc_if_token2] = ACTIONS(4085),
    [aux_sym_preproc_else_token1] = ACTIONS(4085),
    [aux_sym_preproc_elif_token1] = ACTIONS(4087),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4085),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4085),
    [anon_sym_LPAREN2] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4087),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_STAR] = ACTIONS(4087),
    [anon_sym_SLASH] = ACTIONS(4087),
    [anon_sym_PERCENT] = ACTIONS(4087),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4087),
    [anon_sym_CARET] = ACTIONS(4087),
    [anon_sym_AMP] = ACTIONS(4087),
    [anon_sym_EQ_EQ] = ACTIONS(4085),
    [anon_sym_BANG_EQ] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4087),
    [anon_sym_GT_EQ] = ACTIONS(4085),
    [anon_sym_LT_EQ] = ACTIONS(4087),
    [anon_sym_LT] = ACTIONS(4087),
    [anon_sym_LT_LT] = ACTIONS(4087),
    [anon_sym_GT_GT] = ACTIONS(4087),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_SEMI] = ACTIONS(4085),
    [anon_sym___attribute__] = ACTIONS(7254),
    [anon_sym___attribute] = ACTIONS(7254),
    [anon_sym_LBRACE] = ACTIONS(4085),
    [anon_sym_RBRACE] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4085),
    [anon_sym_RBRACK] = ACTIONS(4085),
    [anon_sym_EQ] = ACTIONS(4087),
    [anon_sym_QMARK] = ACTIONS(4085),
    [anon_sym_STAR_EQ] = ACTIONS(4085),
    [anon_sym_SLASH_EQ] = ACTIONS(4085),
    [anon_sym_PERCENT_EQ] = ACTIONS(4085),
    [anon_sym_PLUS_EQ] = ACTIONS(4085),
    [anon_sym_DASH_EQ] = ACTIONS(4085),
    [anon_sym_LT_LT_EQ] = ACTIONS(4085),
    [anon_sym_GT_GT_EQ] = ACTIONS(4085),
    [anon_sym_AMP_EQ] = ACTIONS(4085),
    [anon_sym_CARET_EQ] = ACTIONS(4085),
    [anon_sym_PIPE_EQ] = ACTIONS(4085),
    [anon_sym_and_eq] = ACTIONS(4087),
    [anon_sym_or_eq] = ACTIONS(4087),
    [anon_sym_xor_eq] = ACTIONS(4087),
    [anon_sym_LT_EQ_GT] = ACTIONS(4085),
    [anon_sym_or] = ACTIONS(4087),
    [anon_sym_and] = ACTIONS(4087),
    [anon_sym_bitor] = ACTIONS(4087),
    [anon_sym_xor] = ACTIONS(4087),
    [anon_sym_bitand] = ACTIONS(4087),
    [anon_sym_not_eq] = ACTIONS(4087),
    [anon_sym_is] = ACTIONS(4087),
    [anon_sym_as] = ACTIONS(4087),
    [anon_sym_DASH_DASH] = ACTIONS(4085),
    [anon_sym_PLUS_PLUS] = ACTIONS(4085),
    [anon_sym_DOT] = ACTIONS(4087),
    [anon_sym_DOT_STAR] = ACTIONS(4085),
    [anon_sym_DASH_GT] = ACTIONS(4085),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4087),
    [anon_sym_let] = ACTIONS(4087),
    [anon_sym_This] = ACTIONS(4087),
  },
  [3138] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(4695),
    [sym_raw_string_literal] = STATE(3527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(7416),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6839),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7416),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_RBRACE] = ACTIONS(2170),
    [anon_sym_LBRACK] = ACTIONS(7418),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2207),
    [anon_sym_SLASH_EQ] = ACTIONS(2207),
    [anon_sym_PERCENT_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_GT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_EQ] = ACTIONS(2207),
    [anon_sym_CARET_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_EQ] = ACTIONS(2207),
    [anon_sym_and_eq] = ACTIONS(2207),
    [anon_sym_or_eq] = ACTIONS(2207),
    [anon_sym_xor_eq] = ACTIONS(2207),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
  },
  [3139] = {
    [sym_attribute_specifier] = STATE(3021),
    [sym_enumerator_list] = STATE(3231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3987),
    [anon_sym_COMMA] = ACTIONS(3987),
    [anon_sym_RPAREN] = ACTIONS(3987),
    [anon_sym_LPAREN2] = ACTIONS(3987),
    [anon_sym_DASH] = ACTIONS(3989),
    [anon_sym_PLUS] = ACTIONS(3989),
    [anon_sym_STAR] = ACTIONS(3987),
    [anon_sym_SLASH] = ACTIONS(3989),
    [anon_sym_PERCENT] = ACTIONS(3987),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_AMP_AMP] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3989),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_AMP] = ACTIONS(3989),
    [anon_sym_EQ_EQ] = ACTIONS(3987),
    [anon_sym_BANG_EQ] = ACTIONS(3987),
    [anon_sym_GT] = ACTIONS(3989),
    [anon_sym_GT_EQ] = ACTIONS(3987),
    [anon_sym_LT_EQ] = ACTIONS(3989),
    [anon_sym_LT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3987),
    [anon_sym_COLON] = ACTIONS(3987),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym___extension__] = ACTIONS(3987),
    [anon_sym___attribute__] = ACTIONS(7346),
    [anon_sym___attribute] = ACTIONS(7348),
    [anon_sym_LBRACE] = ACTIONS(7414),
    [anon_sym_RBRACE] = ACTIONS(3987),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_RBRACK] = ACTIONS(3987),
    [anon_sym_const] = ACTIONS(3989),
    [anon_sym_constexpr] = ACTIONS(3987),
    [anon_sym_volatile] = ACTIONS(3987),
    [anon_sym_restrict] = ACTIONS(3987),
    [anon_sym___restrict__] = ACTIONS(3987),
    [anon_sym__Atomic] = ACTIONS(3987),
    [anon_sym__Noreturn] = ACTIONS(3987),
    [anon_sym_noreturn] = ACTIONS(3987),
    [anon_sym__Nonnull] = ACTIONS(3987),
    [anon_sym_mutable] = ACTIONS(3987),
    [anon_sym_constinit] = ACTIONS(3987),
    [anon_sym_consteval] = ACTIONS(3987),
    [anon_sym_alignas] = ACTIONS(3987),
    [anon_sym__Alignas] = ACTIONS(3987),
    [anon_sym_QMARK] = ACTIONS(3987),
    [anon_sym_LT_EQ_GT] = ACTIONS(3987),
    [anon_sym_or] = ACTIONS(3987),
    [anon_sym_and] = ACTIONS(3987),
    [anon_sym_bitor] = ACTIONS(3987),
    [anon_sym_xor] = ACTIONS(3987),
    [anon_sym_bitand] = ACTIONS(3987),
    [anon_sym_not_eq] = ACTIONS(3987),
    [anon_sym_is] = ACTIONS(3987),
    [anon_sym_as] = ACTIONS(3987),
    [anon_sym_DASH_DASH] = ACTIONS(3987),
    [anon_sym_PLUS_PLUS] = ACTIONS(3987),
    [anon_sym_DOT] = ACTIONS(3989),
    [anon_sym_DOT_STAR] = ACTIONS(3987),
    [anon_sym_DASH_GT] = ACTIONS(3987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3987),
    [anon_sym_let] = ACTIONS(3987),
    [anon_sym_This] = ACTIONS(3987),
    [anon_sym_final] = ACTIONS(3987),
    [anon_sym_override] = ACTIONS(3987),
    [anon_sym_requires] = ACTIONS(3987),
    [anon_sym_where] = ACTIONS(3987),
  },
  [3140] = {
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2881),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [aux_sym_preproc_if_token2] = ACTIONS(2881),
    [aux_sym_preproc_else_token1] = ACTIONS(2881),
    [aux_sym_preproc_elif_token1] = ACTIONS(2883),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2881),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2883),
    [anon_sym_SLASH] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_CARET] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_EQ_EQ] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_GT_EQ] = ACTIONS(2881),
    [anon_sym_LT_EQ] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_LT_LT] = ACTIONS(2883),
    [anon_sym_GT_GT] = ACTIONS(2883),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_RBRACE] = ACTIONS(2881),
    [anon_sym_LBRACK] = ACTIONS(2881),
    [anon_sym_RBRACK] = ACTIONS(2881),
    [anon_sym_EQ] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_STAR_EQ] = ACTIONS(2881),
    [anon_sym_SLASH_EQ] = ACTIONS(2881),
    [anon_sym_PERCENT_EQ] = ACTIONS(2881),
    [anon_sym_PLUS_EQ] = ACTIONS(2881),
    [anon_sym_DASH_EQ] = ACTIONS(2881),
    [anon_sym_LT_LT_EQ] = ACTIONS(2881),
    [anon_sym_GT_GT_EQ] = ACTIONS(2881),
    [anon_sym_AMP_EQ] = ACTIONS(2881),
    [anon_sym_CARET_EQ] = ACTIONS(2881),
    [anon_sym_PIPE_EQ] = ACTIONS(2881),
    [anon_sym_and_eq] = ACTIONS(2883),
    [anon_sym_or_eq] = ACTIONS(2883),
    [anon_sym_xor_eq] = ACTIONS(2883),
    [anon_sym_LT_EQ_GT] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2883),
    [anon_sym_and] = ACTIONS(2883),
    [anon_sym_bitor] = ACTIONS(2883),
    [anon_sym_xor] = ACTIONS(2883),
    [anon_sym_bitand] = ACTIONS(2883),
    [anon_sym_not_eq] = ACTIONS(2883),
    [anon_sym_is] = ACTIONS(2883),
    [anon_sym_as] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_DOT_STAR] = ACTIONS(2881),
    [anon_sym_DASH_GT] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
  },
  [3141] = {
    [sym_string_literal] = STATE(3158),
    [sym_template_argument_list] = STATE(3325),
    [sym_raw_string_literal] = STATE(3158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(7185),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym___attribute__] = ACTIONS(2170),
    [anon_sym___attribute] = ACTIONS(2181),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_EQ] = ACTIONS(2181),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2170),
    [anon_sym_SLASH_EQ] = ACTIONS(2170),
    [anon_sym_PERCENT_EQ] = ACTIONS(2170),
    [anon_sym_PLUS_EQ] = ACTIONS(2170),
    [anon_sym_DASH_EQ] = ACTIONS(2170),
    [anon_sym_LT_LT_EQ] = ACTIONS(2170),
    [anon_sym_GT_GT_EQ] = ACTIONS(2170),
    [anon_sym_AMP_EQ] = ACTIONS(2170),
    [anon_sym_CARET_EQ] = ACTIONS(2170),
    [anon_sym_PIPE_EQ] = ACTIONS(2170),
    [anon_sym_and_eq] = ACTIONS(2170),
    [anon_sym_or_eq] = ACTIONS(2170),
    [anon_sym_xor_eq] = ACTIONS(2170),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(7446),
    [anon_sym_u_DQUOTE] = ACTIONS(7446),
    [anon_sym_U_DQUOTE] = ACTIONS(7446),
    [anon_sym_u8_DQUOTE] = ACTIONS(7446),
    [anon_sym_DQUOTE] = ACTIONS(7446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7448),
    [anon_sym_LR_DQUOTE] = ACTIONS(7448),
    [anon_sym_uR_DQUOTE] = ACTIONS(7448),
    [anon_sym_UR_DQUOTE] = ACTIONS(7448),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7448),
  },
  [3142] = {
    [sym_template_argument_list] = STATE(2953),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3316),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3775),
    [anon_sym_COMMA] = ACTIONS(3775),
    [anon_sym_RPAREN] = ACTIONS(3775),
    [anon_sym_LPAREN2] = ACTIONS(3775),
    [anon_sym_DASH] = ACTIONS(3777),
    [anon_sym_PLUS] = ACTIONS(3777),
    [anon_sym_STAR] = ACTIONS(3777),
    [anon_sym_SLASH] = ACTIONS(3777),
    [anon_sym_PERCENT] = ACTIONS(3777),
    [anon_sym_PIPE_PIPE] = ACTIONS(3775),
    [anon_sym_AMP_AMP] = ACTIONS(3775),
    [anon_sym_PIPE] = ACTIONS(3777),
    [anon_sym_CARET] = ACTIONS(3777),
    [anon_sym_AMP] = ACTIONS(3777),
    [anon_sym_EQ_EQ] = ACTIONS(3775),
    [anon_sym_BANG_EQ] = ACTIONS(3775),
    [anon_sym_GT] = ACTIONS(3777),
    [anon_sym_GT_EQ] = ACTIONS(3775),
    [anon_sym_LT_EQ] = ACTIONS(3777),
    [anon_sym_LT] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3777),
    [anon_sym_GT_GT] = ACTIONS(3777),
    [anon_sym_COLON] = ACTIONS(3777),
    [anon_sym_SEMI] = ACTIONS(3775),
    [anon_sym___attribute__] = ACTIONS(3775),
    [anon_sym___attribute] = ACTIONS(3777),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(3775),
    [anon_sym_RBRACE] = ACTIONS(3775),
    [anon_sym_signed] = ACTIONS(7450),
    [anon_sym_unsigned] = ACTIONS(7450),
    [anon_sym_long] = ACTIONS(7450),
    [anon_sym_short] = ACTIONS(7450),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_RBRACK] = ACTIONS(3775),
    [anon_sym_EQ] = ACTIONS(3777),
    [anon_sym_QMARK] = ACTIONS(3775),
    [anon_sym_STAR_EQ] = ACTIONS(3775),
    [anon_sym_SLASH_EQ] = ACTIONS(3775),
    [anon_sym_PERCENT_EQ] = ACTIONS(3775),
    [anon_sym_PLUS_EQ] = ACTIONS(3775),
    [anon_sym_DASH_EQ] = ACTIONS(3775),
    [anon_sym_LT_LT_EQ] = ACTIONS(3775),
    [anon_sym_GT_GT_EQ] = ACTIONS(3775),
    [anon_sym_AMP_EQ] = ACTIONS(3775),
    [anon_sym_CARET_EQ] = ACTIONS(3775),
    [anon_sym_PIPE_EQ] = ACTIONS(3775),
    [anon_sym_and_eq] = ACTIONS(3775),
    [anon_sym_or_eq] = ACTIONS(3775),
    [anon_sym_xor_eq] = ACTIONS(3775),
    [anon_sym_LT_EQ_GT] = ACTIONS(3775),
    [anon_sym_or] = ACTIONS(3777),
    [anon_sym_and] = ACTIONS(3777),
    [anon_sym_bitor] = ACTIONS(3775),
    [anon_sym_xor] = ACTIONS(3777),
    [anon_sym_bitand] = ACTIONS(3775),
    [anon_sym_not_eq] = ACTIONS(3775),
    [anon_sym_is] = ACTIONS(3775),
    [anon_sym_as] = ACTIONS(3775),
    [anon_sym_DASH_DASH] = ACTIONS(3775),
    [anon_sym_PLUS_PLUS] = ACTIONS(3775),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_DOT_STAR] = ACTIONS(3775),
    [anon_sym_DASH_GT] = ACTIONS(3775),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3775),
    [anon_sym_let] = ACTIONS(3775),
    [anon_sym_This] = ACTIONS(3775),
  },
  [3143] = {
    [sym_attribute_specifier] = STATE(3235),
    [sym_identifier] = ACTIONS(4010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(4008),
    [anon_sym_RPAREN] = ACTIONS(4008),
    [aux_sym_preproc_if_token2] = ACTIONS(4008),
    [aux_sym_preproc_else_token1] = ACTIONS(4008),
    [aux_sym_preproc_elif_token1] = ACTIONS(4010),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4008),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4008),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_DASH] = ACTIONS(4010),
    [anon_sym_PLUS] = ACTIONS(4010),
    [anon_sym_STAR] = ACTIONS(4010),
    [anon_sym_SLASH] = ACTIONS(4010),
    [anon_sym_PERCENT] = ACTIONS(4010),
    [anon_sym_PIPE_PIPE] = ACTIONS(4008),
    [anon_sym_AMP_AMP] = ACTIONS(4008),
    [anon_sym_PIPE] = ACTIONS(4010),
    [anon_sym_CARET] = ACTIONS(4010),
    [anon_sym_AMP] = ACTIONS(4010),
    [anon_sym_EQ_EQ] = ACTIONS(4008),
    [anon_sym_BANG_EQ] = ACTIONS(4008),
    [anon_sym_GT] = ACTIONS(4010),
    [anon_sym_GT_EQ] = ACTIONS(4008),
    [anon_sym_LT_EQ] = ACTIONS(4010),
    [anon_sym_LT] = ACTIONS(4010),
    [anon_sym_LT_LT] = ACTIONS(4010),
    [anon_sym_GT_GT] = ACTIONS(4010),
    [anon_sym_COLON] = ACTIONS(4008),
    [anon_sym_SEMI] = ACTIONS(4008),
    [anon_sym___attribute__] = ACTIONS(7254),
    [anon_sym___attribute] = ACTIONS(7254),
    [anon_sym_LBRACE] = ACTIONS(4008),
    [anon_sym_RBRACE] = ACTIONS(4008),
    [anon_sym_LBRACK] = ACTIONS(4008),
    [anon_sym_RBRACK] = ACTIONS(4008),
    [anon_sym_EQ] = ACTIONS(4010),
    [anon_sym_QMARK] = ACTIONS(4008),
    [anon_sym_STAR_EQ] = ACTIONS(4008),
    [anon_sym_SLASH_EQ] = ACTIONS(4008),
    [anon_sym_PERCENT_EQ] = ACTIONS(4008),
    [anon_sym_PLUS_EQ] = ACTIONS(4008),
    [anon_sym_DASH_EQ] = ACTIONS(4008),
    [anon_sym_LT_LT_EQ] = ACTIONS(4008),
    [anon_sym_GT_GT_EQ] = ACTIONS(4008),
    [anon_sym_AMP_EQ] = ACTIONS(4008),
    [anon_sym_CARET_EQ] = ACTIONS(4008),
    [anon_sym_PIPE_EQ] = ACTIONS(4008),
    [anon_sym_and_eq] = ACTIONS(4010),
    [anon_sym_or_eq] = ACTIONS(4010),
    [anon_sym_xor_eq] = ACTIONS(4010),
    [anon_sym_LT_EQ_GT] = ACTIONS(4008),
    [anon_sym_or] = ACTIONS(4010),
    [anon_sym_and] = ACTIONS(4010),
    [anon_sym_bitor] = ACTIONS(4010),
    [anon_sym_xor] = ACTIONS(4010),
    [anon_sym_bitand] = ACTIONS(4010),
    [anon_sym_not_eq] = ACTIONS(4010),
    [anon_sym_is] = ACTIONS(4010),
    [anon_sym_as] = ACTIONS(4010),
    [anon_sym_DASH_DASH] = ACTIONS(4008),
    [anon_sym_PLUS_PLUS] = ACTIONS(4008),
    [anon_sym_DOT] = ACTIONS(4010),
    [anon_sym_DOT_STAR] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4010),
    [anon_sym_let] = ACTIONS(4010),
    [anon_sym_This] = ACTIONS(4010),
  },
  [3144] = {
    [sym_string_literal] = STATE(3154),
    [sym_raw_string_literal] = STATE(3154),
    [aux_sym_concatenated_string_repeat1] = STATE(3154),
    [sym_identifier] = ACTIONS(7452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7217),
    [anon_sym_COMMA] = ACTIONS(7217),
    [anon_sym_LPAREN2] = ACTIONS(7217),
    [anon_sym_DASH] = ACTIONS(7219),
    [anon_sym_PLUS] = ACTIONS(7219),
    [anon_sym_STAR] = ACTIONS(7219),
    [anon_sym_SLASH] = ACTIONS(7219),
    [anon_sym_PERCENT] = ACTIONS(7219),
    [anon_sym_PIPE_PIPE] = ACTIONS(7217),
    [anon_sym_AMP_AMP] = ACTIONS(7217),
    [anon_sym_PIPE] = ACTIONS(7219),
    [anon_sym_CARET] = ACTIONS(7219),
    [anon_sym_AMP] = ACTIONS(7219),
    [anon_sym_EQ_EQ] = ACTIONS(7217),
    [anon_sym_BANG_EQ] = ACTIONS(7217),
    [anon_sym_GT] = ACTIONS(7219),
    [anon_sym_GT_EQ] = ACTIONS(7217),
    [anon_sym_LT_EQ] = ACTIONS(7219),
    [anon_sym_LT] = ACTIONS(7219),
    [anon_sym_LT_LT] = ACTIONS(7219),
    [anon_sym_GT_GT] = ACTIONS(7219),
    [anon_sym_SEMI] = ACTIONS(7217),
    [anon_sym___attribute__] = ACTIONS(7219),
    [anon_sym___attribute] = ACTIONS(7219),
    [anon_sym_LBRACK] = ACTIONS(7217),
    [anon_sym_EQ] = ACTIONS(7219),
    [anon_sym_QMARK] = ACTIONS(7217),
    [anon_sym_STAR_EQ] = ACTIONS(7217),
    [anon_sym_SLASH_EQ] = ACTIONS(7217),
    [anon_sym_PERCENT_EQ] = ACTIONS(7217),
    [anon_sym_PLUS_EQ] = ACTIONS(7217),
    [anon_sym_DASH_EQ] = ACTIONS(7217),
    [anon_sym_LT_LT_EQ] = ACTIONS(7217),
    [anon_sym_GT_GT_EQ] = ACTIONS(7217),
    [anon_sym_AMP_EQ] = ACTIONS(7217),
    [anon_sym_CARET_EQ] = ACTIONS(7217),
    [anon_sym_PIPE_EQ] = ACTIONS(7217),
    [anon_sym_and_eq] = ACTIONS(7219),
    [anon_sym_or_eq] = ACTIONS(7219),
    [anon_sym_xor_eq] = ACTIONS(7219),
    [anon_sym_LT_EQ_GT] = ACTIONS(7217),
    [anon_sym_or] = ACTIONS(7219),
    [anon_sym_and] = ACTIONS(7219),
    [anon_sym_bitor] = ACTIONS(7219),
    [anon_sym_xor] = ACTIONS(7219),
    [anon_sym_bitand] = ACTIONS(7219),
    [anon_sym_not_eq] = ACTIONS(7219),
    [anon_sym_is] = ACTIONS(7219),
    [anon_sym_as] = ACTIONS(7219),
    [anon_sym_DASH_DASH] = ACTIONS(7217),
    [anon_sym_PLUS_PLUS] = ACTIONS(7217),
    [anon_sym_DOT] = ACTIONS(7219),
    [anon_sym_DOT_STAR] = ACTIONS(7217),
    [anon_sym_DASH_GT] = ACTIONS(7217),
    [anon_sym_L_DQUOTE] = ACTIONS(7446),
    [anon_sym_u_DQUOTE] = ACTIONS(7446),
    [anon_sym_U_DQUOTE] = ACTIONS(7446),
    [anon_sym_u8_DQUOTE] = ACTIONS(7446),
    [anon_sym_DQUOTE] = ACTIONS(7446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7448),
    [anon_sym_LR_DQUOTE] = ACTIONS(7448),
    [anon_sym_uR_DQUOTE] = ACTIONS(7448),
    [anon_sym_UR_DQUOTE] = ACTIONS(7448),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7448),
    [sym_literal_suffix] = ACTIONS(7219),
  },
  [3145] = {
    [sym_attribute_specifier] = STATE(3246),
    [sym_identifier] = ACTIONS(4156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4154),
    [anon_sym_COMMA] = ACTIONS(4154),
    [anon_sym_RPAREN] = ACTIONS(4154),
    [aux_sym_preproc_if_token2] = ACTIONS(4154),
    [aux_sym_preproc_else_token1] = ACTIONS(4154),
    [aux_sym_preproc_elif_token1] = ACTIONS(4156),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4154),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4154),
    [anon_sym_LPAREN2] = ACTIONS(4154),
    [anon_sym_DASH] = ACTIONS(4156),
    [anon_sym_PLUS] = ACTIONS(4156),
    [anon_sym_STAR] = ACTIONS(4156),
    [anon_sym_SLASH] = ACTIONS(4156),
    [anon_sym_PERCENT] = ACTIONS(4156),
    [anon_sym_PIPE_PIPE] = ACTIONS(4154),
    [anon_sym_AMP_AMP] = ACTIONS(4154),
    [anon_sym_PIPE] = ACTIONS(4156),
    [anon_sym_CARET] = ACTIONS(4156),
    [anon_sym_AMP] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4154),
    [anon_sym_BANG_EQ] = ACTIONS(4154),
    [anon_sym_GT] = ACTIONS(4156),
    [anon_sym_GT_EQ] = ACTIONS(4154),
    [anon_sym_LT_EQ] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(4156),
    [anon_sym_LT_LT] = ACTIONS(4156),
    [anon_sym_GT_GT] = ACTIONS(4156),
    [anon_sym_COLON] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4154),
    [anon_sym___attribute__] = ACTIONS(7254),
    [anon_sym___attribute] = ACTIONS(7254),
    [anon_sym_LBRACE] = ACTIONS(4154),
    [anon_sym_RBRACE] = ACTIONS(4154),
    [anon_sym_LBRACK] = ACTIONS(4154),
    [anon_sym_RBRACK] = ACTIONS(4154),
    [anon_sym_EQ] = ACTIONS(4156),
    [anon_sym_QMARK] = ACTIONS(4154),
    [anon_sym_STAR_EQ] = ACTIONS(4154),
    [anon_sym_SLASH_EQ] = ACTIONS(4154),
    [anon_sym_PERCENT_EQ] = ACTIONS(4154),
    [anon_sym_PLUS_EQ] = ACTIONS(4154),
    [anon_sym_DASH_EQ] = ACTIONS(4154),
    [anon_sym_LT_LT_EQ] = ACTIONS(4154),
    [anon_sym_GT_GT_EQ] = ACTIONS(4154),
    [anon_sym_AMP_EQ] = ACTIONS(4154),
    [anon_sym_CARET_EQ] = ACTIONS(4154),
    [anon_sym_PIPE_EQ] = ACTIONS(4154),
    [anon_sym_and_eq] = ACTIONS(4156),
    [anon_sym_or_eq] = ACTIONS(4156),
    [anon_sym_xor_eq] = ACTIONS(4156),
    [anon_sym_LT_EQ_GT] = ACTIONS(4154),
    [anon_sym_or] = ACTIONS(4156),
    [anon_sym_and] = ACTIONS(4156),
    [anon_sym_bitor] = ACTIONS(4156),
    [anon_sym_xor] = ACTIONS(4156),
    [anon_sym_bitand] = ACTIONS(4156),
    [anon_sym_not_eq] = ACTIONS(4156),
    [anon_sym_is] = ACTIONS(4156),
    [anon_sym_as] = ACTIONS(4156),
    [anon_sym_DASH_DASH] = ACTIONS(4154),
    [anon_sym_PLUS_PLUS] = ACTIONS(4154),
    [anon_sym_DOT] = ACTIONS(4156),
    [anon_sym_DOT_STAR] = ACTIONS(4154),
    [anon_sym_DASH_GT] = ACTIONS(4154),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4156),
    [anon_sym_let] = ACTIONS(4156),
    [anon_sym_This] = ACTIONS(4156),
  },
  [3146] = {
    [sym__declaration_modifiers] = STATE(2769),
    [sym_attribute_specifier] = STATE(2769),
    [sym_attribute_declaration] = STATE(2769),
    [sym_ms_declspec_modifier] = STATE(2769),
    [sym_storage_class_specifier] = STATE(2769),
    [sym_type_qualifier] = STATE(2769),
    [sym_alignas_qualifier] = STATE(2738),
    [sym_qualifiers] = STATE(2769),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2769),
    [anon_sym_LPAREN2] = ACTIONS(7027),
    [anon_sym_STAR] = ACTIONS(7027),
    [anon_sym_AMP_AMP] = ACTIONS(7027),
    [anon_sym_AMP] = ACTIONS(7025),
    [anon_sym___extension__] = ACTIONS(7428),
    [anon_sym_in] = ACTIONS(7029),
    [anon_sym_out] = ACTIONS(7454),
    [anon_sym_inout] = ACTIONS(7454),
    [anon_sym_virtual] = ACTIONS(7454),
    [anon_sym_extern] = ACTIONS(7432),
    [anon_sym___attribute__] = ACTIONS(7434),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6730),
    [anon_sym___declspec] = ACTIONS(7436),
    [anon_sym_LBRACK] = ACTIONS(7025),
    [anon_sym_static] = ACTIONS(7432),
    [anon_sym_register] = ACTIONS(7432),
    [anon_sym_inline] = ACTIONS(7432),
    [anon_sym___inline] = ACTIONS(6724),
    [anon_sym___inline__] = ACTIONS(7432),
    [anon_sym___forceinline] = ACTIONS(7432),
    [anon_sym_thread_local] = ACTIONS(7432),
    [anon_sym___thread] = ACTIONS(7432),
    [anon_sym_const] = ACTIONS(6720),
    [anon_sym_constexpr] = ACTIONS(7428),
    [anon_sym_volatile] = ACTIONS(7428),
    [anon_sym_restrict] = ACTIONS(7428),
    [anon_sym___restrict__] = ACTIONS(7428),
    [anon_sym__Atomic] = ACTIONS(7428),
    [anon_sym__Noreturn] = ACTIONS(7428),
    [anon_sym_noreturn] = ACTIONS(7428),
    [anon_sym__Nonnull] = ACTIONS(7428),
    [anon_sym_mutable] = ACTIONS(7428),
    [anon_sym_constinit] = ACTIONS(7428),
    [anon_sym_consteval] = ACTIONS(7428),
    [anon_sym_alignas] = ACTIONS(7438),
    [anon_sym__Alignas] = ACTIONS(7438),
    [anon_sym_DOT] = ACTIONS(7440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(7442),
    [anon_sym_let] = ACTIONS(7442),
    [anon_sym_This] = ACTIONS(7442),
    [anon_sym_precise] = ACTIONS(7444),
    [anon_sym_shared] = ACTIONS(7444),
    [anon_sym_groupshared] = ACTIONS(7444),
    [anon_sym_uniform] = ACTIONS(7444),
    [anon_sym_row_major] = ACTIONS(7444),
    [anon_sym_column_major] = ACTIONS(7444),
    [anon_sym_globallycoherent] = ACTIONS(7444),
    [anon_sym_centroid] = ACTIONS(7444),
    [anon_sym_noperspective] = ACTIONS(7444),
    [anon_sym_nointerpolation] = ACTIONS(7444),
    [anon_sym_sample] = ACTIONS(7444),
    [anon_sym_linear] = ACTIONS(7444),
    [anon_sym_snorm] = ACTIONS(7444),
    [anon_sym_unorm] = ACTIONS(7444),
    [anon_sym_point] = ACTIONS(7444),
    [anon_sym_line] = ACTIONS(6736),
    [anon_sym_triangleadj] = ACTIONS(7444),
    [anon_sym_lineadj] = ACTIONS(7444),
    [anon_sym_triangle] = ACTIONS(6736),
  },
  [3147] = {
    [sym_attribute_specifier] = STATE(3250),
    [sym_identifier] = ACTIONS(4049),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4047),
    [anon_sym_COMMA] = ACTIONS(4047),
    [anon_sym_RPAREN] = ACTIONS(4047),
    [aux_sym_preproc_if_token2] = ACTIONS(4047),
    [aux_sym_preproc_else_token1] = ACTIONS(4047),
    [aux_sym_preproc_elif_token1] = ACTIONS(4049),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4047),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4047),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_DASH] = ACTIONS(4049),
    [anon_sym_PLUS] = ACTIONS(4049),
    [anon_sym_STAR] = ACTIONS(4049),
    [anon_sym_SLASH] = ACTIONS(4049),
    [anon_sym_PERCENT] = ACTIONS(4049),
    [anon_sym_PIPE_PIPE] = ACTIONS(4047),
    [anon_sym_AMP_AMP] = ACTIONS(4047),
    [anon_sym_PIPE] = ACTIONS(4049),
    [anon_sym_CARET] = ACTIONS(4049),
    [anon_sym_AMP] = ACTIONS(4049),
    [anon_sym_EQ_EQ] = ACTIONS(4047),
    [anon_sym_BANG_EQ] = ACTIONS(4047),
    [anon_sym_GT] = ACTIONS(4049),
    [anon_sym_GT_EQ] = ACTIONS(4047),
    [anon_sym_LT_EQ] = ACTIONS(4049),
    [anon_sym_LT] = ACTIONS(4049),
    [anon_sym_LT_LT] = ACTIONS(4049),
    [anon_sym_GT_GT] = ACTIONS(4049),
    [anon_sym_COLON] = ACTIONS(4047),
    [anon_sym_SEMI] = ACTIONS(4047),
    [anon_sym___attribute__] = ACTIONS(7254),
    [anon_sym___attribute] = ACTIONS(7254),
    [anon_sym_LBRACE] = ACTIONS(4047),
    [anon_sym_RBRACE] = ACTIONS(4047),
    [anon_sym_LBRACK] = ACTIONS(4047),
    [anon_sym_RBRACK] = ACTIONS(4047),
    [anon_sym_EQ] = ACTIONS(4049),
    [anon_sym_QMARK] = ACTIONS(4047),
    [anon_sym_STAR_EQ] = ACTIONS(4047),
    [anon_sym_SLASH_EQ] = ACTIONS(4047),
    [anon_sym_PERCENT_EQ] = ACTIONS(4047),
    [anon_sym_PLUS_EQ] = ACTIONS(4047),
    [anon_sym_DASH_EQ] = ACTIONS(4047),
    [anon_sym_LT_LT_EQ] = ACTIONS(4047),
    [anon_sym_GT_GT_EQ] = ACTIONS(4047),
    [anon_sym_AMP_EQ] = ACTIONS(4047),
    [anon_sym_CARET_EQ] = ACTIONS(4047),
    [anon_sym_PIPE_EQ] = ACTIONS(4047),
    [anon_sym_and_eq] = ACTIONS(4049),
    [anon_sym_or_eq] = ACTIONS(4049),
    [anon_sym_xor_eq] = ACTIONS(4049),
    [anon_sym_LT_EQ_GT] = ACTIONS(4047),
    [anon_sym_or] = ACTIONS(4049),
    [anon_sym_and] = ACTIONS(4049),
    [anon_sym_bitor] = ACTIONS(4049),
    [anon_sym_xor] = ACTIONS(4049),
    [anon_sym_bitand] = ACTIONS(4049),
    [anon_sym_not_eq] = ACTIONS(4049),
    [anon_sym_is] = ACTIONS(4049),
    [anon_sym_as] = ACTIONS(4049),
    [anon_sym_DASH_DASH] = ACTIONS(4047),
    [anon_sym_PLUS_PLUS] = ACTIONS(4047),
    [anon_sym_DOT] = ACTIONS(4049),
    [anon_sym_DOT_STAR] = ACTIONS(4047),
    [anon_sym_DASH_GT] = ACTIONS(4047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4049),
    [anon_sym_let] = ACTIONS(4049),
    [anon_sym_This] = ACTIONS(4049),
  },
  [3148] = {
    [sym_attribute_specifier] = STATE(3228),
    [sym_identifier] = ACTIONS(4200),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4198),
    [anon_sym_COMMA] = ACTIONS(4198),
    [anon_sym_RPAREN] = ACTIONS(4198),
    [aux_sym_preproc_if_token2] = ACTIONS(4198),
    [aux_sym_preproc_else_token1] = ACTIONS(4198),
    [aux_sym_preproc_elif_token1] = ACTIONS(4200),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4198),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4198),
    [anon_sym_LPAREN2] = ACTIONS(4198),
    [anon_sym_DASH] = ACTIONS(4200),
    [anon_sym_PLUS] = ACTIONS(4200),
    [anon_sym_STAR] = ACTIONS(4200),
    [anon_sym_SLASH] = ACTIONS(4200),
    [anon_sym_PERCENT] = ACTIONS(4200),
    [anon_sym_PIPE_PIPE] = ACTIONS(4198),
    [anon_sym_AMP_AMP] = ACTIONS(4198),
    [anon_sym_PIPE] = ACTIONS(4200),
    [anon_sym_CARET] = ACTIONS(4200),
    [anon_sym_AMP] = ACTIONS(4200),
    [anon_sym_EQ_EQ] = ACTIONS(4198),
    [anon_sym_BANG_EQ] = ACTIONS(4198),
    [anon_sym_GT] = ACTIONS(4200),
    [anon_sym_GT_EQ] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(4200),
    [anon_sym_LT] = ACTIONS(4200),
    [anon_sym_LT_LT] = ACTIONS(4200),
    [anon_sym_GT_GT] = ACTIONS(4200),
    [anon_sym_COLON] = ACTIONS(4198),
    [anon_sym_SEMI] = ACTIONS(4198),
    [anon_sym___attribute__] = ACTIONS(7254),
    [anon_sym___attribute] = ACTIONS(7254),
    [anon_sym_LBRACE] = ACTIONS(4198),
    [anon_sym_RBRACE] = ACTIONS(4198),
    [anon_sym_LBRACK] = ACTIONS(4198),
    [anon_sym_RBRACK] = ACTIONS(4198),
    [anon_sym_EQ] = ACTIONS(4200),
    [anon_sym_QMARK] = ACTIONS(4198),
    [anon_sym_STAR_EQ] = ACTIONS(4198),
    [anon_sym_SLASH_EQ] = ACTIONS(4198),
    [anon_sym_PERCENT_EQ] = ACTIONS(4198),
    [anon_sym_PLUS_EQ] = ACTIONS(4198),
    [anon_sym_DASH_EQ] = ACTIONS(4198),
    [anon_sym_LT_LT_EQ] = ACTIONS(4198),
    [anon_sym_GT_GT_EQ] = ACTIONS(4198),
    [anon_sym_AMP_EQ] = ACTIONS(4198),
    [anon_sym_CARET_EQ] = ACTIONS(4198),
    [anon_sym_PIPE_EQ] = ACTIONS(4198),
    [anon_sym_and_eq] = ACTIONS(4200),
    [anon_sym_or_eq] = ACTIONS(4200),
    [anon_sym_xor_eq] = ACTIONS(4200),
    [anon_sym_LT_EQ_GT] = ACTIONS(4198),
    [anon_sym_or] = ACTIONS(4200),
    [anon_sym_and] = ACTIONS(4200),
    [anon_sym_bitor] = ACTIONS(4200),
    [anon_sym_xor] = ACTIONS(4200),
    [anon_sym_bitand] = ACTIONS(4200),
    [anon_sym_not_eq] = ACTIONS(4200),
    [anon_sym_is] = ACTIONS(4200),
    [anon_sym_as] = ACTIONS(4200),
    [anon_sym_DASH_DASH] = ACTIONS(4198),
    [anon_sym_PLUS_PLUS] = ACTIONS(4198),
    [anon_sym_DOT] = ACTIONS(4200),
    [anon_sym_DOT_STAR] = ACTIONS(4198),
    [anon_sym_DASH_GT] = ACTIONS(4198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4200),
    [anon_sym_let] = ACTIONS(4200),
    [anon_sym_This] = ACTIONS(4200),
  },
  [3149] = {
    [sym_template_argument_list] = STATE(3105),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3316),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2176),
    [anon_sym_COMMA] = ACTIONS(2176),
    [anon_sym_RPAREN] = ACTIONS(2176),
    [anon_sym_LPAREN2] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2168),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_STAR] = ACTIONS(2168),
    [anon_sym_SLASH] = ACTIONS(2168),
    [anon_sym_PERCENT] = ACTIONS(2168),
    [anon_sym_PIPE_PIPE] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_PIPE] = ACTIONS(2168),
    [anon_sym_CARET] = ACTIONS(2168),
    [anon_sym_AMP] = ACTIONS(2168),
    [anon_sym_EQ_EQ] = ACTIONS(2176),
    [anon_sym_BANG_EQ] = ACTIONS(2176),
    [anon_sym_GT] = ACTIONS(2168),
    [anon_sym_GT_EQ] = ACTIONS(2176),
    [anon_sym_LT_EQ] = ACTIONS(2168),
    [anon_sym_LT] = ACTIONS(7344),
    [anon_sym_LT_LT] = ACTIONS(2168),
    [anon_sym_GT_GT] = ACTIONS(2168),
    [anon_sym_COLON] = ACTIONS(2168),
    [anon_sym_SEMI] = ACTIONS(2176),
    [anon_sym___attribute__] = ACTIONS(2176),
    [anon_sym___attribute] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_RBRACE] = ACTIONS(2176),
    [anon_sym_signed] = ACTIONS(7450),
    [anon_sym_unsigned] = ACTIONS(7450),
    [anon_sym_long] = ACTIONS(7450),
    [anon_sym_short] = ACTIONS(7450),
    [anon_sym_LBRACK] = ACTIONS(2176),
    [anon_sym_RBRACK] = ACTIONS(2176),
    [anon_sym_EQ] = ACTIONS(2168),
    [anon_sym_QMARK] = ACTIONS(2176),
    [anon_sym_STAR_EQ] = ACTIONS(2176),
    [anon_sym_SLASH_EQ] = ACTIONS(2176),
    [anon_sym_PERCENT_EQ] = ACTIONS(2176),
    [anon_sym_PLUS_EQ] = ACTIONS(2176),
    [anon_sym_DASH_EQ] = ACTIONS(2176),
    [anon_sym_LT_LT_EQ] = ACTIONS(2176),
    [anon_sym_GT_GT_EQ] = ACTIONS(2176),
    [anon_sym_AMP_EQ] = ACTIONS(2176),
    [anon_sym_CARET_EQ] = ACTIONS(2176),
    [anon_sym_PIPE_EQ] = ACTIONS(2176),
    [anon_sym_and_eq] = ACTIONS(2176),
    [anon_sym_or_eq] = ACTIONS(2176),
    [anon_sym_xor_eq] = ACTIONS(2176),
    [anon_sym_LT_EQ_GT] = ACTIONS(2176),
    [anon_sym_or] = ACTIONS(2168),
    [anon_sym_and] = ACTIONS(2168),
    [anon_sym_bitor] = ACTIONS(2176),
    [anon_sym_xor] = ACTIONS(2168),
    [anon_sym_bitand] = ACTIONS(2176),
    [anon_sym_not_eq] = ACTIONS(2176),
    [anon_sym_is] = ACTIONS(2176),
    [anon_sym_as] = ACTIONS(2176),
    [anon_sym_DASH_DASH] = ACTIONS(2176),
    [anon_sym_PLUS_PLUS] = ACTIONS(2176),
    [anon_sym_DOT] = ACTIONS(2168),
    [anon_sym_DOT_STAR] = ACTIONS(2176),
    [anon_sym_DASH_GT] = ACTIONS(2176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2176),
    [anon_sym_let] = ACTIONS(2176),
    [anon_sym_This] = ACTIONS(2176),
  },
  [3150] = {
    [sym_identifier] = ACTIONS(2879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2877),
    [anon_sym_COMMA] = ACTIONS(2877),
    [anon_sym_RPAREN] = ACTIONS(2877),
    [aux_sym_preproc_if_token2] = ACTIONS(2877),
    [aux_sym_preproc_else_token1] = ACTIONS(2877),
    [aux_sym_preproc_elif_token1] = ACTIONS(2879),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2877),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2877),
    [anon_sym_LPAREN2] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2879),
    [anon_sym_PLUS] = ACTIONS(2879),
    [anon_sym_STAR] = ACTIONS(2879),
    [anon_sym_SLASH] = ACTIONS(2879),
    [anon_sym_PERCENT] = ACTIONS(2879),
    [anon_sym_PIPE_PIPE] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_PIPE] = ACTIONS(2879),
    [anon_sym_CARET] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2879),
    [anon_sym_EQ_EQ] = ACTIONS(2877),
    [anon_sym_BANG_EQ] = ACTIONS(2877),
    [anon_sym_GT] = ACTIONS(2879),
    [anon_sym_GT_EQ] = ACTIONS(2877),
    [anon_sym_LT_EQ] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2879),
    [anon_sym_LT_LT] = ACTIONS(2879),
    [anon_sym_GT_GT] = ACTIONS(2879),
    [anon_sym_COLON] = ACTIONS(2879),
    [anon_sym_SEMI] = ACTIONS(2877),
    [anon_sym___attribute__] = ACTIONS(2879),
    [anon_sym___attribute] = ACTIONS(2879),
    [anon_sym_COLON_COLON] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_RBRACE] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_RBRACK] = ACTIONS(2877),
    [anon_sym_EQ] = ACTIONS(2879),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_STAR_EQ] = ACTIONS(2877),
    [anon_sym_SLASH_EQ] = ACTIONS(2877),
    [anon_sym_PERCENT_EQ] = ACTIONS(2877),
    [anon_sym_PLUS_EQ] = ACTIONS(2877),
    [anon_sym_DASH_EQ] = ACTIONS(2877),
    [anon_sym_LT_LT_EQ] = ACTIONS(2877),
    [anon_sym_GT_GT_EQ] = ACTIONS(2877),
    [anon_sym_AMP_EQ] = ACTIONS(2877),
    [anon_sym_CARET_EQ] = ACTIONS(2877),
    [anon_sym_PIPE_EQ] = ACTIONS(2877),
    [anon_sym_and_eq] = ACTIONS(2879),
    [anon_sym_or_eq] = ACTIONS(2879),
    [anon_sym_xor_eq] = ACTIONS(2879),
    [anon_sym_LT_EQ_GT] = ACTIONS(2877),
    [anon_sym_or] = ACTIONS(2879),
    [anon_sym_and] = ACTIONS(2879),
    [anon_sym_bitor] = ACTIONS(2879),
    [anon_sym_xor] = ACTIONS(2879),
    [anon_sym_bitand] = ACTIONS(2879),
    [anon_sym_not_eq] = ACTIONS(2879),
    [anon_sym_is] = ACTIONS(2879),
    [anon_sym_as] = ACTIONS(2879),
    [anon_sym_DASH_DASH] = ACTIONS(2877),
    [anon_sym_PLUS_PLUS] = ACTIONS(2877),
    [anon_sym_DOT] = ACTIONS(2879),
    [anon_sym_DOT_STAR] = ACTIONS(2877),
    [anon_sym_DASH_GT] = ACTIONS(2877),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2879),
    [anon_sym_let] = ACTIONS(2879),
    [anon_sym_This] = ACTIONS(2879),
  },
  [3151] = {
    [sym_attribute_specifier] = STATE(3212),
    [sym_identifier] = ACTIONS(4004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4002),
    [anon_sym_COMMA] = ACTIONS(4002),
    [anon_sym_RPAREN] = ACTIONS(4002),
    [aux_sym_preproc_if_token2] = ACTIONS(4002),
    [aux_sym_preproc_else_token1] = ACTIONS(4002),
    [aux_sym_preproc_elif_token1] = ACTIONS(4004),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4002),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4002),
    [anon_sym_LPAREN2] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4004),
    [anon_sym_PLUS] = ACTIONS(4004),
    [anon_sym_STAR] = ACTIONS(4004),
    [anon_sym_SLASH] = ACTIONS(4004),
    [anon_sym_PERCENT] = ACTIONS(4004),
    [anon_sym_PIPE_PIPE] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4002),
    [anon_sym_PIPE] = ACTIONS(4004),
    [anon_sym_CARET] = ACTIONS(4004),
    [anon_sym_AMP] = ACTIONS(4004),
    [anon_sym_EQ_EQ] = ACTIONS(4002),
    [anon_sym_BANG_EQ] = ACTIONS(4002),
    [anon_sym_GT] = ACTIONS(4004),
    [anon_sym_GT_EQ] = ACTIONS(4002),
    [anon_sym_LT_EQ] = ACTIONS(4004),
    [anon_sym_LT] = ACTIONS(4004),
    [anon_sym_LT_LT] = ACTIONS(4004),
    [anon_sym_GT_GT] = ACTIONS(4004),
    [anon_sym_COLON] = ACTIONS(4002),
    [anon_sym_SEMI] = ACTIONS(4002),
    [anon_sym___attribute__] = ACTIONS(7254),
    [anon_sym___attribute] = ACTIONS(7254),
    [anon_sym_LBRACE] = ACTIONS(4002),
    [anon_sym_RBRACE] = ACTIONS(4002),
    [anon_sym_LBRACK] = ACTIONS(4002),
    [anon_sym_RBRACK] = ACTIONS(4002),
    [anon_sym_EQ] = ACTIONS(4004),
    [anon_sym_QMARK] = ACTIONS(4002),
    [anon_sym_STAR_EQ] = ACTIONS(4002),
    [anon_sym_SLASH_EQ] = ACTIONS(4002),
    [anon_sym_PERCENT_EQ] = ACTIONS(4002),
    [anon_sym_PLUS_EQ] = ACTIONS(4002),
    [anon_sym_DASH_EQ] = ACTIONS(4002),
    [anon_sym_LT_LT_EQ] = ACTIONS(4002),
    [anon_sym_GT_GT_EQ] = ACTIONS(4002),
    [anon_sym_AMP_EQ] = ACTIONS(4002),
    [anon_sym_CARET_EQ] = ACTIONS(4002),
    [anon_sym_PIPE_EQ] = ACTIONS(4002),
    [anon_sym_and_eq] = ACTIONS(4004),
    [anon_sym_or_eq] = ACTIONS(4004),
    [anon_sym_xor_eq] = ACTIONS(4004),
    [anon_sym_LT_EQ_GT] = ACTIONS(4002),
    [anon_sym_or] = ACTIONS(4004),
    [anon_sym_and] = ACTIONS(4004),
    [anon_sym_bitor] = ACTIONS(4004),
    [anon_sym_xor] = ACTIONS(4004),
    [anon_sym_bitand] = ACTIONS(4004),
    [anon_sym_not_eq] = ACTIONS(4004),
    [anon_sym_is] = ACTIONS(4004),
    [anon_sym_as] = ACTIONS(4004),
    [anon_sym_DASH_DASH] = ACTIONS(4002),
    [anon_sym_PLUS_PLUS] = ACTIONS(4002),
    [anon_sym_DOT] = ACTIONS(4004),
    [anon_sym_DOT_STAR] = ACTIONS(4002),
    [anon_sym_DASH_GT] = ACTIONS(4002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4004),
    [anon_sym_let] = ACTIONS(4004),
    [anon_sym_This] = ACTIONS(4004),
  },
  [3152] = {
    [sym_attribute_specifier] = STATE(3232),
    [sym_identifier] = ACTIONS(4107),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4109),
    [anon_sym_COMMA] = ACTIONS(4109),
    [anon_sym_RPAREN] = ACTIONS(4109),
    [aux_sym_preproc_if_token2] = ACTIONS(4109),
    [aux_sym_preproc_else_token1] = ACTIONS(4109),
    [aux_sym_preproc_elif_token1] = ACTIONS(4107),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4109),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4109),
    [anon_sym_LPAREN2] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4107),
    [anon_sym_STAR] = ACTIONS(4107),
    [anon_sym_SLASH] = ACTIONS(4107),
    [anon_sym_PERCENT] = ACTIONS(4107),
    [anon_sym_PIPE_PIPE] = ACTIONS(4109),
    [anon_sym_AMP_AMP] = ACTIONS(4109),
    [anon_sym_PIPE] = ACTIONS(4107),
    [anon_sym_CARET] = ACTIONS(4107),
    [anon_sym_AMP] = ACTIONS(4107),
    [anon_sym_EQ_EQ] = ACTIONS(4109),
    [anon_sym_BANG_EQ] = ACTIONS(4109),
    [anon_sym_GT] = ACTIONS(4107),
    [anon_sym_GT_EQ] = ACTIONS(4109),
    [anon_sym_LT_EQ] = ACTIONS(4107),
    [anon_sym_LT] = ACTIONS(4107),
    [anon_sym_LT_LT] = ACTIONS(4107),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_COLON] = ACTIONS(4109),
    [anon_sym_SEMI] = ACTIONS(4109),
    [anon_sym___attribute__] = ACTIONS(7254),
    [anon_sym___attribute] = ACTIONS(7254),
    [anon_sym_LBRACE] = ACTIONS(4109),
    [anon_sym_RBRACE] = ACTIONS(4109),
    [anon_sym_LBRACK] = ACTIONS(4109),
    [anon_sym_RBRACK] = ACTIONS(4109),
    [anon_sym_EQ] = ACTIONS(4107),
    [anon_sym_QMARK] = ACTIONS(4109),
    [anon_sym_STAR_EQ] = ACTIONS(4109),
    [anon_sym_SLASH_EQ] = ACTIONS(4109),
    [anon_sym_PERCENT_EQ] = ACTIONS(4109),
    [anon_sym_PLUS_EQ] = ACTIONS(4109),
    [anon_sym_DASH_EQ] = ACTIONS(4109),
    [anon_sym_LT_LT_EQ] = ACTIONS(4109),
    [anon_sym_GT_GT_EQ] = ACTIONS(4109),
    [anon_sym_AMP_EQ] = ACTIONS(4109),
    [anon_sym_CARET_EQ] = ACTIONS(4109),
    [anon_sym_PIPE_EQ] = ACTIONS(4109),
    [anon_sym_and_eq] = ACTIONS(4107),
    [anon_sym_or_eq] = ACTIONS(4107),
    [anon_sym_xor_eq] = ACTIONS(4107),
    [anon_sym_LT_EQ_GT] = ACTIONS(4109),
    [anon_sym_or] = ACTIONS(4107),
    [anon_sym_and] = ACTIONS(4107),
    [anon_sym_bitor] = ACTIONS(4107),
    [anon_sym_xor] = ACTIONS(4107),
    [anon_sym_bitand] = ACTIONS(4107),
    [anon_sym_not_eq] = ACTIONS(4107),
    [anon_sym_is] = ACTIONS(4107),
    [anon_sym_as] = ACTIONS(4107),
    [anon_sym_DASH_DASH] = ACTIONS(4109),
    [anon_sym_PLUS_PLUS] = ACTIONS(4109),
    [anon_sym_DOT] = ACTIONS(4107),
    [anon_sym_DOT_STAR] = ACTIONS(4109),
    [anon_sym_DASH_GT] = ACTIONS(4109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4107),
    [anon_sym_let] = ACTIONS(4107),
    [anon_sym_This] = ACTIONS(4107),
  },
  [3153] = {
    [sym_attribute_specifier] = STATE(3248),
    [sym_identifier] = ACTIONS(4060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4058),
    [anon_sym_COMMA] = ACTIONS(4058),
    [anon_sym_RPAREN] = ACTIONS(4058),
    [aux_sym_preproc_if_token2] = ACTIONS(4058),
    [aux_sym_preproc_else_token1] = ACTIONS(4058),
    [aux_sym_preproc_elif_token1] = ACTIONS(4060),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4058),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4058),
    [anon_sym_LPAREN2] = ACTIONS(4058),
    [anon_sym_DASH] = ACTIONS(4060),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_STAR] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4060),
    [anon_sym_PERCENT] = ACTIONS(4060),
    [anon_sym_PIPE_PIPE] = ACTIONS(4058),
    [anon_sym_AMP_AMP] = ACTIONS(4058),
    [anon_sym_PIPE] = ACTIONS(4060),
    [anon_sym_CARET] = ACTIONS(4060),
    [anon_sym_AMP] = ACTIONS(4060),
    [anon_sym_EQ_EQ] = ACTIONS(4058),
    [anon_sym_BANG_EQ] = ACTIONS(4058),
    [anon_sym_GT] = ACTIONS(4060),
    [anon_sym_GT_EQ] = ACTIONS(4058),
    [anon_sym_LT_EQ] = ACTIONS(4060),
    [anon_sym_LT] = ACTIONS(4060),
    [anon_sym_LT_LT] = ACTIONS(4060),
    [anon_sym_GT_GT] = ACTIONS(4060),
    [anon_sym_COLON] = ACTIONS(4058),
    [anon_sym_SEMI] = ACTIONS(4058),
    [anon_sym___attribute__] = ACTIONS(7254),
    [anon_sym___attribute] = ACTIONS(7254),
    [anon_sym_LBRACE] = ACTIONS(4058),
    [anon_sym_RBRACE] = ACTIONS(4058),
    [anon_sym_LBRACK] = ACTIONS(4058),
    [anon_sym_RBRACK] = ACTIONS(4058),
    [anon_sym_EQ] = ACTIONS(4060),
    [anon_sym_QMARK] = ACTIONS(4058),
    [anon_sym_STAR_EQ] = ACTIONS(4058),
    [anon_sym_SLASH_EQ] = ACTIONS(4058),
    [anon_sym_PERCENT_EQ] = ACTIONS(4058),
    [anon_sym_PLUS_EQ] = ACTIONS(4058),
    [anon_sym_DASH_EQ] = ACTIONS(4058),
    [anon_sym_LT_LT_EQ] = ACTIONS(4058),
    [anon_sym_GT_GT_EQ] = ACTIONS(4058),
    [anon_sym_AMP_EQ] = ACTIONS(4058),
    [anon_sym_CARET_EQ] = ACTIONS(4058),
    [anon_sym_PIPE_EQ] = ACTIONS(4058),
    [anon_sym_and_eq] = ACTIONS(4060),
    [anon_sym_or_eq] = ACTIONS(4060),
    [anon_sym_xor_eq] = ACTIONS(4060),
    [anon_sym_LT_EQ_GT] = ACTIONS(4058),
    [anon_sym_or] = ACTIONS(4060),
    [anon_sym_and] = ACTIONS(4060),
    [anon_sym_bitor] = ACTIONS(4060),
    [anon_sym_xor] = ACTIONS(4060),
    [anon_sym_bitand] = ACTIONS(4060),
    [anon_sym_not_eq] = ACTIONS(4060),
    [anon_sym_is] = ACTIONS(4060),
    [anon_sym_as] = ACTIONS(4060),
    [anon_sym_DASH_DASH] = ACTIONS(4058),
    [anon_sym_PLUS_PLUS] = ACTIONS(4058),
    [anon_sym_DOT] = ACTIONS(4060),
    [anon_sym_DOT_STAR] = ACTIONS(4058),
    [anon_sym_DASH_GT] = ACTIONS(4058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4060),
    [anon_sym_let] = ACTIONS(4060),
    [anon_sym_This] = ACTIONS(4060),
  },
  [3154] = {
    [sym_string_literal] = STATE(3154),
    [sym_raw_string_literal] = STATE(3154),
    [aux_sym_concatenated_string_repeat1] = STATE(3154),
    [sym_identifier] = ACTIONS(7456),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7205),
    [anon_sym_COMMA] = ACTIONS(7205),
    [anon_sym_LPAREN2] = ACTIONS(7205),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_SLASH] = ACTIONS(7207),
    [anon_sym_PERCENT] = ACTIONS(7207),
    [anon_sym_PIPE_PIPE] = ACTIONS(7205),
    [anon_sym_AMP_AMP] = ACTIONS(7205),
    [anon_sym_PIPE] = ACTIONS(7207),
    [anon_sym_CARET] = ACTIONS(7207),
    [anon_sym_AMP] = ACTIONS(7207),
    [anon_sym_EQ_EQ] = ACTIONS(7205),
    [anon_sym_BANG_EQ] = ACTIONS(7205),
    [anon_sym_GT] = ACTIONS(7207),
    [anon_sym_GT_EQ] = ACTIONS(7205),
    [anon_sym_LT_EQ] = ACTIONS(7207),
    [anon_sym_LT] = ACTIONS(7207),
    [anon_sym_LT_LT] = ACTIONS(7207),
    [anon_sym_GT_GT] = ACTIONS(7207),
    [anon_sym_SEMI] = ACTIONS(7205),
    [anon_sym___attribute__] = ACTIONS(7207),
    [anon_sym___attribute] = ACTIONS(7207),
    [anon_sym_LBRACK] = ACTIONS(7205),
    [anon_sym_EQ] = ACTIONS(7207),
    [anon_sym_QMARK] = ACTIONS(7205),
    [anon_sym_STAR_EQ] = ACTIONS(7205),
    [anon_sym_SLASH_EQ] = ACTIONS(7205),
    [anon_sym_PERCENT_EQ] = ACTIONS(7205),
    [anon_sym_PLUS_EQ] = ACTIONS(7205),
    [anon_sym_DASH_EQ] = ACTIONS(7205),
    [anon_sym_LT_LT_EQ] = ACTIONS(7205),
    [anon_sym_GT_GT_EQ] = ACTIONS(7205),
    [anon_sym_AMP_EQ] = ACTIONS(7205),
    [anon_sym_CARET_EQ] = ACTIONS(7205),
    [anon_sym_PIPE_EQ] = ACTIONS(7205),
    [anon_sym_and_eq] = ACTIONS(7207),
    [anon_sym_or_eq] = ACTIONS(7207),
    [anon_sym_xor_eq] = ACTIONS(7207),
    [anon_sym_LT_EQ_GT] = ACTIONS(7205),
    [anon_sym_or] = ACTIONS(7207),
    [anon_sym_and] = ACTIONS(7207),
    [anon_sym_bitor] = ACTIONS(7207),
    [anon_sym_xor] = ACTIONS(7207),
    [anon_sym_bitand] = ACTIONS(7207),
    [anon_sym_not_eq] = ACTIONS(7207),
    [anon_sym_is] = ACTIONS(7207),
    [anon_sym_as] = ACTIONS(7207),
    [anon_sym_DASH_DASH] = ACTIONS(7205),
    [anon_sym_PLUS_PLUS] = ACTIONS(7205),
    [anon_sym_DOT] = ACTIONS(7207),
    [anon_sym_DOT_STAR] = ACTIONS(7205),
    [anon_sym_DASH_GT] = ACTIONS(7205),
    [anon_sym_L_DQUOTE] = ACTIONS(7459),
    [anon_sym_u_DQUOTE] = ACTIONS(7459),
    [anon_sym_U_DQUOTE] = ACTIONS(7459),
    [anon_sym_u8_DQUOTE] = ACTIONS(7459),
    [anon_sym_DQUOTE] = ACTIONS(7459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7462),
    [anon_sym_LR_DQUOTE] = ACTIONS(7462),
    [anon_sym_uR_DQUOTE] = ACTIONS(7462),
    [anon_sym_UR_DQUOTE] = ACTIONS(7462),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7462),
    [sym_literal_suffix] = ACTIONS(7207),
  },
  [3155] = {
    [sym_string_literal] = STATE(2970),
    [sym_raw_string_literal] = STATE(2970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7388),
    [anon_sym_COMMA] = ACTIONS(7388),
    [anon_sym_RPAREN] = ACTIONS(7388),
    [anon_sym_LPAREN2] = ACTIONS(7388),
    [anon_sym_DASH] = ACTIONS(7386),
    [anon_sym_PLUS] = ACTIONS(7386),
    [anon_sym_STAR] = ACTIONS(7386),
    [anon_sym_SLASH] = ACTIONS(7386),
    [anon_sym_PERCENT] = ACTIONS(7386),
    [anon_sym_PIPE_PIPE] = ACTIONS(7388),
    [anon_sym_AMP_AMP] = ACTIONS(7388),
    [anon_sym_PIPE] = ACTIONS(7386),
    [anon_sym_CARET] = ACTIONS(7386),
    [anon_sym_AMP] = ACTIONS(7386),
    [anon_sym_EQ_EQ] = ACTIONS(7388),
    [anon_sym_BANG_EQ] = ACTIONS(7388),
    [anon_sym_GT] = ACTIONS(7386),
    [anon_sym_GT_EQ] = ACTIONS(7388),
    [anon_sym_LT_EQ] = ACTIONS(7386),
    [anon_sym_LT] = ACTIONS(7386),
    [anon_sym_LT_LT] = ACTIONS(7386),
    [anon_sym_GT_GT] = ACTIONS(7386),
    [anon_sym_COLON] = ACTIONS(7388),
    [anon_sym_SEMI] = ACTIONS(7388),
    [anon_sym_RBRACE] = ACTIONS(7388),
    [anon_sym_LBRACK] = ACTIONS(7388),
    [anon_sym_RBRACK] = ACTIONS(7388),
    [anon_sym_EQ] = ACTIONS(7386),
    [anon_sym_QMARK] = ACTIONS(7388),
    [anon_sym_STAR_EQ] = ACTIONS(7388),
    [anon_sym_SLASH_EQ] = ACTIONS(7388),
    [anon_sym_PERCENT_EQ] = ACTIONS(7388),
    [anon_sym_PLUS_EQ] = ACTIONS(7388),
    [anon_sym_DASH_EQ] = ACTIONS(7388),
    [anon_sym_LT_LT_EQ] = ACTIONS(7388),
    [anon_sym_GT_GT_EQ] = ACTIONS(7388),
    [anon_sym_AMP_EQ] = ACTIONS(7388),
    [anon_sym_CARET_EQ] = ACTIONS(7388),
    [anon_sym_PIPE_EQ] = ACTIONS(7388),
    [anon_sym_and_eq] = ACTIONS(7386),
    [anon_sym_or_eq] = ACTIONS(7386),
    [anon_sym_xor_eq] = ACTIONS(7386),
    [anon_sym_LT_EQ_GT] = ACTIONS(7388),
    [anon_sym_or] = ACTIONS(7386),
    [anon_sym_and] = ACTIONS(7386),
    [anon_sym_bitor] = ACTIONS(7386),
    [anon_sym_xor] = ACTIONS(7386),
    [anon_sym_bitand] = ACTIONS(7386),
    [anon_sym_not_eq] = ACTIONS(7386),
    [anon_sym_is] = ACTIONS(7386),
    [anon_sym_as] = ACTIONS(7386),
    [anon_sym_DASH_DASH] = ACTIONS(7388),
    [anon_sym_PLUS_PLUS] = ACTIONS(7388),
    [anon_sym_DOT] = ACTIONS(7386),
    [anon_sym_DOT_STAR] = ACTIONS(7388),
    [anon_sym_DASH_GT] = ACTIONS(7388),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
    [sym_literal_suffix] = ACTIONS(7386),
  },
  [3156] = {
    [sym_type_qualifier] = STATE(3159),
    [sym_alignas_qualifier] = STATE(3356),
    [aux_sym__type_definition_type_repeat1] = STATE(3159),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3326),
    [sym_identifier] = ACTIONS(7465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3423),
    [anon_sym_COMMA] = ACTIONS(3423),
    [anon_sym_LPAREN2] = ACTIONS(3423),
    [anon_sym_DASH] = ACTIONS(3428),
    [anon_sym_PLUS] = ACTIONS(3428),
    [anon_sym_STAR] = ACTIONS(3423),
    [anon_sym_SLASH] = ACTIONS(3428),
    [anon_sym_PERCENT] = ACTIONS(3423),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_PIPE] = ACTIONS(3428),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3428),
    [anon_sym_EQ_EQ] = ACTIONS(3423),
    [anon_sym_BANG_EQ] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3428),
    [anon_sym_GT_EQ] = ACTIONS(3428),
    [anon_sym_LT_EQ] = ACTIONS(3428),
    [anon_sym_LT] = ACTIONS(3428),
    [anon_sym_LT_LT] = ACTIONS(3423),
    [anon_sym_GT_GT] = ACTIONS(3428),
    [anon_sym___extension__] = ACTIONS(7467),
    [anon_sym___attribute__] = ACTIONS(3428),
    [anon_sym___attribute] = ACTIONS(3428),
    [anon_sym_LBRACE] = ACTIONS(3423),
    [anon_sym_signed] = ACTIONS(7469),
    [anon_sym_unsigned] = ACTIONS(7469),
    [anon_sym_long] = ACTIONS(7469),
    [anon_sym_short] = ACTIONS(7469),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_const] = ACTIONS(7467),
    [anon_sym_constexpr] = ACTIONS(7467),
    [anon_sym_volatile] = ACTIONS(7467),
    [anon_sym_restrict] = ACTIONS(7467),
    [anon_sym___restrict__] = ACTIONS(7467),
    [anon_sym__Atomic] = ACTIONS(7467),
    [anon_sym__Noreturn] = ACTIONS(7467),
    [anon_sym_noreturn] = ACTIONS(7467),
    [anon_sym__Nonnull] = ACTIONS(7467),
    [anon_sym_mutable] = ACTIONS(7467),
    [anon_sym_constinit] = ACTIONS(7467),
    [anon_sym_consteval] = ACTIONS(7467),
    [anon_sym_alignas] = ACTIONS(7471),
    [anon_sym__Alignas] = ACTIONS(7471),
    [sym_primitive_type] = ACTIONS(7473),
    [anon_sym_QMARK] = ACTIONS(3423),
    [anon_sym_LT_EQ_GT] = ACTIONS(3423),
    [anon_sym_or] = ACTIONS(3428),
    [anon_sym_and] = ACTIONS(3428),
    [anon_sym_bitor] = ACTIONS(3428),
    [anon_sym_xor] = ACTIONS(3428),
    [anon_sym_bitand] = ACTIONS(3428),
    [anon_sym_not_eq] = ACTIONS(3428),
    [anon_sym_is] = ACTIONS(3428),
    [anon_sym_as] = ACTIONS(3428),
    [anon_sym_DASH_DASH] = ACTIONS(3423),
    [anon_sym_PLUS_PLUS] = ACTIONS(3423),
    [anon_sym_DOT] = ACTIONS(3428),
    [anon_sym_DOT_STAR] = ACTIONS(3423),
    [anon_sym_DASH_GT] = ACTIONS(3423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3428),
    [anon_sym_let] = ACTIONS(3428),
    [anon_sym_This] = ACTIONS(3428),
    [anon_sym_GT2] = ACTIONS(3423),
  },
  [3157] = {
    [sym_string_literal] = STATE(2970),
    [sym_template_argument_list] = STATE(3686),
    [sym_raw_string_literal] = STATE(2970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(7475),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(7478),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6761),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_RBRACE] = ACTIONS(2170),
    [anon_sym_LBRACK] = ACTIONS(7481),
    [anon_sym_EQ] = ACTIONS(2181),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2170),
    [anon_sym_SLASH_EQ] = ACTIONS(2170),
    [anon_sym_PERCENT_EQ] = ACTIONS(2170),
    [anon_sym_PLUS_EQ] = ACTIONS(2170),
    [anon_sym_DASH_EQ] = ACTIONS(2170),
    [anon_sym_LT_LT_EQ] = ACTIONS(2170),
    [anon_sym_GT_GT_EQ] = ACTIONS(2170),
    [anon_sym_AMP_EQ] = ACTIONS(2170),
    [anon_sym_CARET_EQ] = ACTIONS(2170),
    [anon_sym_PIPE_EQ] = ACTIONS(2170),
    [anon_sym_and_eq] = ACTIONS(2170),
    [anon_sym_or_eq] = ACTIONS(2170),
    [anon_sym_xor_eq] = ACTIONS(2170),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
  },
  [3158] = {
    [sym_string_literal] = STATE(3144),
    [sym_raw_string_literal] = STATE(3144),
    [aux_sym_concatenated_string_repeat1] = STATE(3144),
    [sym_identifier] = ACTIONS(7484),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7190),
    [anon_sym_COMMA] = ACTIONS(7190),
    [anon_sym_LPAREN2] = ACTIONS(7190),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_STAR] = ACTIONS(7192),
    [anon_sym_SLASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [anon_sym_PIPE_PIPE] = ACTIONS(7190),
    [anon_sym_AMP_AMP] = ACTIONS(7190),
    [anon_sym_PIPE] = ACTIONS(7192),
    [anon_sym_CARET] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(7192),
    [anon_sym_EQ_EQ] = ACTIONS(7190),
    [anon_sym_BANG_EQ] = ACTIONS(7190),
    [anon_sym_GT] = ACTIONS(7192),
    [anon_sym_GT_EQ] = ACTIONS(7190),
    [anon_sym_LT_EQ] = ACTIONS(7192),
    [anon_sym_LT] = ACTIONS(7192),
    [anon_sym_LT_LT] = ACTIONS(7192),
    [anon_sym_GT_GT] = ACTIONS(7192),
    [anon_sym_SEMI] = ACTIONS(7190),
    [anon_sym___attribute__] = ACTIONS(7192),
    [anon_sym___attribute] = ACTIONS(7192),
    [anon_sym_LBRACK] = ACTIONS(7190),
    [anon_sym_EQ] = ACTIONS(7192),
    [anon_sym_QMARK] = ACTIONS(7190),
    [anon_sym_STAR_EQ] = ACTIONS(7190),
    [anon_sym_SLASH_EQ] = ACTIONS(7190),
    [anon_sym_PERCENT_EQ] = ACTIONS(7190),
    [anon_sym_PLUS_EQ] = ACTIONS(7190),
    [anon_sym_DASH_EQ] = ACTIONS(7190),
    [anon_sym_LT_LT_EQ] = ACTIONS(7190),
    [anon_sym_GT_GT_EQ] = ACTIONS(7190),
    [anon_sym_AMP_EQ] = ACTIONS(7190),
    [anon_sym_CARET_EQ] = ACTIONS(7190),
    [anon_sym_PIPE_EQ] = ACTIONS(7190),
    [anon_sym_and_eq] = ACTIONS(7192),
    [anon_sym_or_eq] = ACTIONS(7192),
    [anon_sym_xor_eq] = ACTIONS(7192),
    [anon_sym_LT_EQ_GT] = ACTIONS(7190),
    [anon_sym_or] = ACTIONS(7192),
    [anon_sym_and] = ACTIONS(7192),
    [anon_sym_bitor] = ACTIONS(7192),
    [anon_sym_xor] = ACTIONS(7192),
    [anon_sym_bitand] = ACTIONS(7192),
    [anon_sym_not_eq] = ACTIONS(7192),
    [anon_sym_is] = ACTIONS(7192),
    [anon_sym_as] = ACTIONS(7192),
    [anon_sym_DASH_DASH] = ACTIONS(7190),
    [anon_sym_PLUS_PLUS] = ACTIONS(7190),
    [anon_sym_DOT] = ACTIONS(7192),
    [anon_sym_DOT_STAR] = ACTIONS(7190),
    [anon_sym_DASH_GT] = ACTIONS(7190),
    [anon_sym_L_DQUOTE] = ACTIONS(7446),
    [anon_sym_u_DQUOTE] = ACTIONS(7446),
    [anon_sym_U_DQUOTE] = ACTIONS(7446),
    [anon_sym_u8_DQUOTE] = ACTIONS(7446),
    [anon_sym_DQUOTE] = ACTIONS(7446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7448),
    [anon_sym_LR_DQUOTE] = ACTIONS(7448),
    [anon_sym_uR_DQUOTE] = ACTIONS(7448),
    [anon_sym_UR_DQUOTE] = ACTIONS(7448),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7448),
    [sym_literal_suffix] = ACTIONS(7192),
  },
  [3159] = {
    [sym_type_qualifier] = STATE(3176),
    [sym_alignas_qualifier] = STATE(3356),
    [aux_sym__type_definition_type_repeat1] = STATE(3176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4956),
    [sym_identifier] = ACTIONS(7486),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3542),
    [anon_sym_COMMA] = ACTIONS(3542),
    [anon_sym_LPAREN2] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(3542),
    [anon_sym_SLASH] = ACTIONS(3540),
    [anon_sym_PERCENT] = ACTIONS(3542),
    [anon_sym_PIPE_PIPE] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_PIPE] = ACTIONS(3540),
    [anon_sym_CARET] = ACTIONS(3542),
    [anon_sym_AMP] = ACTIONS(3540),
    [anon_sym_EQ_EQ] = ACTIONS(3542),
    [anon_sym_BANG_EQ] = ACTIONS(3542),
    [anon_sym_GT] = ACTIONS(3540),
    [anon_sym_GT_EQ] = ACTIONS(3540),
    [anon_sym_LT_EQ] = ACTIONS(3540),
    [anon_sym_LT] = ACTIONS(3540),
    [anon_sym_LT_LT] = ACTIONS(3542),
    [anon_sym_GT_GT] = ACTIONS(3540),
    [anon_sym___extension__] = ACTIONS(7467),
    [anon_sym___attribute__] = ACTIONS(3540),
    [anon_sym___attribute] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_signed] = ACTIONS(7488),
    [anon_sym_unsigned] = ACTIONS(7488),
    [anon_sym_long] = ACTIONS(7488),
    [anon_sym_short] = ACTIONS(7488),
    [anon_sym_LBRACK] = ACTIONS(3542),
    [anon_sym_const] = ACTIONS(7467),
    [anon_sym_constexpr] = ACTIONS(7467),
    [anon_sym_volatile] = ACTIONS(7467),
    [anon_sym_restrict] = ACTIONS(7467),
    [anon_sym___restrict__] = ACTIONS(7467),
    [anon_sym__Atomic] = ACTIONS(7467),
    [anon_sym__Noreturn] = ACTIONS(7467),
    [anon_sym_noreturn] = ACTIONS(7467),
    [anon_sym__Nonnull] = ACTIONS(7467),
    [anon_sym_mutable] = ACTIONS(7467),
    [anon_sym_constinit] = ACTIONS(7467),
    [anon_sym_consteval] = ACTIONS(7467),
    [anon_sym_alignas] = ACTIONS(7471),
    [anon_sym__Alignas] = ACTIONS(7471),
    [sym_primitive_type] = ACTIONS(7490),
    [anon_sym_QMARK] = ACTIONS(3542),
    [anon_sym_LT_EQ_GT] = ACTIONS(3542),
    [anon_sym_or] = ACTIONS(3540),
    [anon_sym_and] = ACTIONS(3540),
    [anon_sym_bitor] = ACTIONS(3540),
    [anon_sym_xor] = ACTIONS(3540),
    [anon_sym_bitand] = ACTIONS(3540),
    [anon_sym_not_eq] = ACTIONS(3540),
    [anon_sym_is] = ACTIONS(3540),
    [anon_sym_as] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(3542),
    [anon_sym_PLUS_PLUS] = ACTIONS(3542),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_DOT_STAR] = ACTIONS(3542),
    [anon_sym_DASH_GT] = ACTIONS(3542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3540),
    [anon_sym_let] = ACTIONS(3540),
    [anon_sym_This] = ACTIONS(3540),
    [anon_sym_GT2] = ACTIONS(3542),
  },
  [3160] = {
    [sym_attribute_specifier] = STATE(3254),
    [sym_identifier] = ACTIONS(4176),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(4174),
    [anon_sym_RPAREN] = ACTIONS(4174),
    [aux_sym_preproc_if_token2] = ACTIONS(4174),
    [aux_sym_preproc_else_token1] = ACTIONS(4174),
    [aux_sym_preproc_elif_token1] = ACTIONS(4176),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4174),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4174),
    [anon_sym_LPAREN2] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4176),
    [anon_sym_PLUS] = ACTIONS(4176),
    [anon_sym_STAR] = ACTIONS(4176),
    [anon_sym_SLASH] = ACTIONS(4176),
    [anon_sym_PERCENT] = ACTIONS(4176),
    [anon_sym_PIPE_PIPE] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4174),
    [anon_sym_PIPE] = ACTIONS(4176),
    [anon_sym_CARET] = ACTIONS(4176),
    [anon_sym_AMP] = ACTIONS(4176),
    [anon_sym_EQ_EQ] = ACTIONS(4174),
    [anon_sym_BANG_EQ] = ACTIONS(4174),
    [anon_sym_GT] = ACTIONS(4176),
    [anon_sym_GT_EQ] = ACTIONS(4174),
    [anon_sym_LT_EQ] = ACTIONS(4176),
    [anon_sym_LT] = ACTIONS(4176),
    [anon_sym_LT_LT] = ACTIONS(4176),
    [anon_sym_GT_GT] = ACTIONS(4176),
    [anon_sym_COLON] = ACTIONS(4174),
    [anon_sym_SEMI] = ACTIONS(4174),
    [anon_sym___attribute__] = ACTIONS(7254),
    [anon_sym___attribute] = ACTIONS(7254),
    [anon_sym_LBRACE] = ACTIONS(4174),
    [anon_sym_RBRACE] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4174),
    [anon_sym_RBRACK] = ACTIONS(4174),
    [anon_sym_EQ] = ACTIONS(4176),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_STAR_EQ] = ACTIONS(4174),
    [anon_sym_SLASH_EQ] = ACTIONS(4174),
    [anon_sym_PERCENT_EQ] = ACTIONS(4174),
    [anon_sym_PLUS_EQ] = ACTIONS(4174),
    [anon_sym_DASH_EQ] = ACTIONS(4174),
    [anon_sym_LT_LT_EQ] = ACTIONS(4174),
    [anon_sym_GT_GT_EQ] = ACTIONS(4174),
    [anon_sym_AMP_EQ] = ACTIONS(4174),
    [anon_sym_CARET_EQ] = ACTIONS(4174),
    [anon_sym_PIPE_EQ] = ACTIONS(4174),
    [anon_sym_and_eq] = ACTIONS(4176),
    [anon_sym_or_eq] = ACTIONS(4176),
    [anon_sym_xor_eq] = ACTIONS(4176),
    [anon_sym_LT_EQ_GT] = ACTIONS(4174),
    [anon_sym_or] = ACTIONS(4176),
    [anon_sym_and] = ACTIONS(4176),
    [anon_sym_bitor] = ACTIONS(4176),
    [anon_sym_xor] = ACTIONS(4176),
    [anon_sym_bitand] = ACTIONS(4176),
    [anon_sym_not_eq] = ACTIONS(4176),
    [anon_sym_is] = ACTIONS(4176),
    [anon_sym_as] = ACTIONS(4176),
    [anon_sym_DASH_DASH] = ACTIONS(4174),
    [anon_sym_PLUS_PLUS] = ACTIONS(4174),
    [anon_sym_DOT] = ACTIONS(4176),
    [anon_sym_DOT_STAR] = ACTIONS(4174),
    [anon_sym_DASH_GT] = ACTIONS(4174),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4176),
    [anon_sym_let] = ACTIONS(4176),
    [anon_sym_This] = ACTIONS(4176),
  },
  [3161] = {
    [sym_string_literal] = STATE(3241),
    [sym_template_argument_list] = STATE(4257),
    [sym_raw_string_literal] = STATE(3241),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_RPAREN] = ACTIONS(7416),
    [anon_sym_LPAREN2] = ACTIONS(7416),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6778),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7416),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(7418),
    [anon_sym_EQ] = ACTIONS(2181),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2170),
    [anon_sym_SLASH_EQ] = ACTIONS(2170),
    [anon_sym_PERCENT_EQ] = ACTIONS(2170),
    [anon_sym_PLUS_EQ] = ACTIONS(2170),
    [anon_sym_DASH_EQ] = ACTIONS(2170),
    [anon_sym_LT_LT_EQ] = ACTIONS(2170),
    [anon_sym_GT_GT_EQ] = ACTIONS(2170),
    [anon_sym_AMP_EQ] = ACTIONS(2170),
    [anon_sym_CARET_EQ] = ACTIONS(2170),
    [anon_sym_PIPE_EQ] = ACTIONS(2170),
    [anon_sym_and_eq] = ACTIONS(2170),
    [anon_sym_or_eq] = ACTIONS(2170),
    [anon_sym_xor_eq] = ACTIONS(2170),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2181),
    [anon_sym_L_DQUOTE] = ACTIONS(6765),
    [anon_sym_u_DQUOTE] = ACTIONS(6765),
    [anon_sym_U_DQUOTE] = ACTIONS(6765),
    [anon_sym_u8_DQUOTE] = ACTIONS(6765),
    [anon_sym_DQUOTE] = ACTIONS(6765),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6767),
    [anon_sym_LR_DQUOTE] = ACTIONS(6767),
    [anon_sym_uR_DQUOTE] = ACTIONS(6767),
    [anon_sym_UR_DQUOTE] = ACTIONS(6767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6767),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2170),
  },
  [3162] = {
    [sym_attribute_specifier] = STATE(3257),
    [sym_identifier] = ACTIONS(4091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4089),
    [anon_sym_COMMA] = ACTIONS(4089),
    [anon_sym_RPAREN] = ACTIONS(4089),
    [aux_sym_preproc_if_token2] = ACTIONS(4089),
    [aux_sym_preproc_else_token1] = ACTIONS(4089),
    [aux_sym_preproc_elif_token1] = ACTIONS(4091),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4089),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4089),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4091),
    [anon_sym_PLUS] = ACTIONS(4091),
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_PERCENT] = ACTIONS(4091),
    [anon_sym_PIPE_PIPE] = ACTIONS(4089),
    [anon_sym_AMP_AMP] = ACTIONS(4089),
    [anon_sym_PIPE] = ACTIONS(4091),
    [anon_sym_CARET] = ACTIONS(4091),
    [anon_sym_AMP] = ACTIONS(4091),
    [anon_sym_EQ_EQ] = ACTIONS(4089),
    [anon_sym_BANG_EQ] = ACTIONS(4089),
    [anon_sym_GT] = ACTIONS(4091),
    [anon_sym_GT_EQ] = ACTIONS(4089),
    [anon_sym_LT_EQ] = ACTIONS(4091),
    [anon_sym_LT] = ACTIONS(4091),
    [anon_sym_LT_LT] = ACTIONS(4091),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_COLON] = ACTIONS(4089),
    [anon_sym_SEMI] = ACTIONS(4089),
    [anon_sym___attribute__] = ACTIONS(7254),
    [anon_sym___attribute] = ACTIONS(7254),
    [anon_sym_LBRACE] = ACTIONS(4089),
    [anon_sym_RBRACE] = ACTIONS(4089),
    [anon_sym_LBRACK] = ACTIONS(4089),
    [anon_sym_RBRACK] = ACTIONS(4089),
    [anon_sym_EQ] = ACTIONS(4091),
    [anon_sym_QMARK] = ACTIONS(4089),
    [anon_sym_STAR_EQ] = ACTIONS(4089),
    [anon_sym_SLASH_EQ] = ACTIONS(4089),
    [anon_sym_PERCENT_EQ] = ACTIONS(4089),
    [anon_sym_PLUS_EQ] = ACTIONS(4089),
    [anon_sym_DASH_EQ] = ACTIONS(4089),
    [anon_sym_LT_LT_EQ] = ACTIONS(4089),
    [anon_sym_GT_GT_EQ] = ACTIONS(4089),
    [anon_sym_AMP_EQ] = ACTIONS(4089),
    [anon_sym_CARET_EQ] = ACTIONS(4089),
    [anon_sym_PIPE_EQ] = ACTIONS(4089),
    [anon_sym_and_eq] = ACTIONS(4091),
    [anon_sym_or_eq] = ACTIONS(4091),
    [anon_sym_xor_eq] = ACTIONS(4091),
    [anon_sym_LT_EQ_GT] = ACTIONS(4089),
    [anon_sym_or] = ACTIONS(4091),
    [anon_sym_and] = ACTIONS(4091),
    [anon_sym_bitor] = ACTIONS(4091),
    [anon_sym_xor] = ACTIONS(4091),
    [anon_sym_bitand] = ACTIONS(4091),
    [anon_sym_not_eq] = ACTIONS(4091),
    [anon_sym_is] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(4091),
    [anon_sym_DASH_DASH] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(4089),
    [anon_sym_DOT] = ACTIONS(4091),
    [anon_sym_DOT_STAR] = ACTIONS(4089),
    [anon_sym_DASH_GT] = ACTIONS(4089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4091),
    [anon_sym_let] = ACTIONS(4091),
    [anon_sym_This] = ACTIONS(4091),
  },
  [3163] = {
    [sym_string_literal] = STATE(3241),
    [sym_template_argument_list] = STATE(3845),
    [sym_raw_string_literal] = STATE(3241),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_RPAREN] = ACTIONS(7475),
    [anon_sym_LPAREN2] = ACTIONS(7475),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6758),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6761),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(7481),
    [anon_sym_EQ] = ACTIONS(2181),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2170),
    [anon_sym_SLASH_EQ] = ACTIONS(2170),
    [anon_sym_PERCENT_EQ] = ACTIONS(2170),
    [anon_sym_PLUS_EQ] = ACTIONS(2170),
    [anon_sym_DASH_EQ] = ACTIONS(2170),
    [anon_sym_LT_LT_EQ] = ACTIONS(2170),
    [anon_sym_GT_GT_EQ] = ACTIONS(2170),
    [anon_sym_AMP_EQ] = ACTIONS(2170),
    [anon_sym_CARET_EQ] = ACTIONS(2170),
    [anon_sym_PIPE_EQ] = ACTIONS(2170),
    [anon_sym_and_eq] = ACTIONS(2170),
    [anon_sym_or_eq] = ACTIONS(2170),
    [anon_sym_xor_eq] = ACTIONS(2170),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2181),
    [anon_sym_L_DQUOTE] = ACTIONS(6765),
    [anon_sym_u_DQUOTE] = ACTIONS(6765),
    [anon_sym_U_DQUOTE] = ACTIONS(6765),
    [anon_sym_u8_DQUOTE] = ACTIONS(6765),
    [anon_sym_DQUOTE] = ACTIONS(6765),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6767),
    [anon_sym_LR_DQUOTE] = ACTIONS(6767),
    [anon_sym_uR_DQUOTE] = ACTIONS(6767),
    [anon_sym_UR_DQUOTE] = ACTIONS(6767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6767),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2170),
  },
  [3164] = {
    [sym_attribute_specifier] = STATE(3249),
    [sym_identifier] = ACTIONS(4045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4043),
    [anon_sym_COMMA] = ACTIONS(4043),
    [anon_sym_RPAREN] = ACTIONS(4043),
    [aux_sym_preproc_if_token2] = ACTIONS(4043),
    [aux_sym_preproc_else_token1] = ACTIONS(4043),
    [aux_sym_preproc_elif_token1] = ACTIONS(4045),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4043),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4043),
    [anon_sym_LPAREN2] = ACTIONS(4043),
    [anon_sym_DASH] = ACTIONS(4045),
    [anon_sym_PLUS] = ACTIONS(4045),
    [anon_sym_STAR] = ACTIONS(4045),
    [anon_sym_SLASH] = ACTIONS(4045),
    [anon_sym_PERCENT] = ACTIONS(4045),
    [anon_sym_PIPE_PIPE] = ACTIONS(4043),
    [anon_sym_AMP_AMP] = ACTIONS(4043),
    [anon_sym_PIPE] = ACTIONS(4045),
    [anon_sym_CARET] = ACTIONS(4045),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4043),
    [anon_sym_BANG_EQ] = ACTIONS(4043),
    [anon_sym_GT] = ACTIONS(4045),
    [anon_sym_GT_EQ] = ACTIONS(4043),
    [anon_sym_LT_EQ] = ACTIONS(4045),
    [anon_sym_LT] = ACTIONS(4045),
    [anon_sym_LT_LT] = ACTIONS(4045),
    [anon_sym_GT_GT] = ACTIONS(4045),
    [anon_sym_COLON] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4043),
    [anon_sym___attribute__] = ACTIONS(7254),
    [anon_sym___attribute] = ACTIONS(7254),
    [anon_sym_LBRACE] = ACTIONS(4043),
    [anon_sym_RBRACE] = ACTIONS(4043),
    [anon_sym_LBRACK] = ACTIONS(4043),
    [anon_sym_RBRACK] = ACTIONS(4043),
    [anon_sym_EQ] = ACTIONS(4045),
    [anon_sym_QMARK] = ACTIONS(4043),
    [anon_sym_STAR_EQ] = ACTIONS(4043),
    [anon_sym_SLASH_EQ] = ACTIONS(4043),
    [anon_sym_PERCENT_EQ] = ACTIONS(4043),
    [anon_sym_PLUS_EQ] = ACTIONS(4043),
    [anon_sym_DASH_EQ] = ACTIONS(4043),
    [anon_sym_LT_LT_EQ] = ACTIONS(4043),
    [anon_sym_GT_GT_EQ] = ACTIONS(4043),
    [anon_sym_AMP_EQ] = ACTIONS(4043),
    [anon_sym_CARET_EQ] = ACTIONS(4043),
    [anon_sym_PIPE_EQ] = ACTIONS(4043),
    [anon_sym_and_eq] = ACTIONS(4045),
    [anon_sym_or_eq] = ACTIONS(4045),
    [anon_sym_xor_eq] = ACTIONS(4045),
    [anon_sym_LT_EQ_GT] = ACTIONS(4043),
    [anon_sym_or] = ACTIONS(4045),
    [anon_sym_and] = ACTIONS(4045),
    [anon_sym_bitor] = ACTIONS(4045),
    [anon_sym_xor] = ACTIONS(4045),
    [anon_sym_bitand] = ACTIONS(4045),
    [anon_sym_not_eq] = ACTIONS(4045),
    [anon_sym_is] = ACTIONS(4045),
    [anon_sym_as] = ACTIONS(4045),
    [anon_sym_DASH_DASH] = ACTIONS(4043),
    [anon_sym_PLUS_PLUS] = ACTIONS(4043),
    [anon_sym_DOT] = ACTIONS(4045),
    [anon_sym_DOT_STAR] = ACTIONS(4043),
    [anon_sym_DASH_GT] = ACTIONS(4043),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4045),
    [anon_sym_let] = ACTIONS(4045),
    [anon_sym_This] = ACTIONS(4045),
  },
  [3165] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(4695),
    [sym_raw_string_literal] = STATE(3527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6839),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(7492),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_RBRACE] = ACTIONS(2170),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2207),
    [anon_sym_SLASH_EQ] = ACTIONS(2207),
    [anon_sym_PERCENT_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_GT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_EQ] = ACTIONS(2207),
    [anon_sym_CARET_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_EQ] = ACTIONS(2207),
    [anon_sym_and_eq] = ACTIONS(2207),
    [anon_sym_or_eq] = ACTIONS(2207),
    [anon_sym_xor_eq] = ACTIONS(2207),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
  },
  [3166] = {
    [sym_attribute_specifier] = STATE(3236),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4012),
    [anon_sym_COMMA] = ACTIONS(4012),
    [anon_sym_RPAREN] = ACTIONS(4012),
    [aux_sym_preproc_if_token2] = ACTIONS(4012),
    [aux_sym_preproc_else_token1] = ACTIONS(4012),
    [aux_sym_preproc_elif_token1] = ACTIONS(4014),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4012),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4012),
    [anon_sym_LPAREN2] = ACTIONS(4012),
    [anon_sym_DASH] = ACTIONS(4014),
    [anon_sym_PLUS] = ACTIONS(4014),
    [anon_sym_STAR] = ACTIONS(4014),
    [anon_sym_SLASH] = ACTIONS(4014),
    [anon_sym_PERCENT] = ACTIONS(4014),
    [anon_sym_PIPE_PIPE] = ACTIONS(4012),
    [anon_sym_AMP_AMP] = ACTIONS(4012),
    [anon_sym_PIPE] = ACTIONS(4014),
    [anon_sym_CARET] = ACTIONS(4014),
    [anon_sym_AMP] = ACTIONS(4014),
    [anon_sym_EQ_EQ] = ACTIONS(4012),
    [anon_sym_BANG_EQ] = ACTIONS(4012),
    [anon_sym_GT] = ACTIONS(4014),
    [anon_sym_GT_EQ] = ACTIONS(4012),
    [anon_sym_LT_EQ] = ACTIONS(4014),
    [anon_sym_LT] = ACTIONS(4014),
    [anon_sym_LT_LT] = ACTIONS(4014),
    [anon_sym_GT_GT] = ACTIONS(4014),
    [anon_sym_COLON] = ACTIONS(4012),
    [anon_sym_SEMI] = ACTIONS(4012),
    [anon_sym___attribute__] = ACTIONS(7254),
    [anon_sym___attribute] = ACTIONS(7254),
    [anon_sym_LBRACE] = ACTIONS(4012),
    [anon_sym_RBRACE] = ACTIONS(4012),
    [anon_sym_LBRACK] = ACTIONS(4012),
    [anon_sym_RBRACK] = ACTIONS(4012),
    [anon_sym_EQ] = ACTIONS(4014),
    [anon_sym_QMARK] = ACTIONS(4012),
    [anon_sym_STAR_EQ] = ACTIONS(4012),
    [anon_sym_SLASH_EQ] = ACTIONS(4012),
    [anon_sym_PERCENT_EQ] = ACTIONS(4012),
    [anon_sym_PLUS_EQ] = ACTIONS(4012),
    [anon_sym_DASH_EQ] = ACTIONS(4012),
    [anon_sym_LT_LT_EQ] = ACTIONS(4012),
    [anon_sym_GT_GT_EQ] = ACTIONS(4012),
    [anon_sym_AMP_EQ] = ACTIONS(4012),
    [anon_sym_CARET_EQ] = ACTIONS(4012),
    [anon_sym_PIPE_EQ] = ACTIONS(4012),
    [anon_sym_and_eq] = ACTIONS(4014),
    [anon_sym_or_eq] = ACTIONS(4014),
    [anon_sym_xor_eq] = ACTIONS(4014),
    [anon_sym_LT_EQ_GT] = ACTIONS(4012),
    [anon_sym_or] = ACTIONS(4014),
    [anon_sym_and] = ACTIONS(4014),
    [anon_sym_bitor] = ACTIONS(4014),
    [anon_sym_xor] = ACTIONS(4014),
    [anon_sym_bitand] = ACTIONS(4014),
    [anon_sym_not_eq] = ACTIONS(4014),
    [anon_sym_is] = ACTIONS(4014),
    [anon_sym_as] = ACTIONS(4014),
    [anon_sym_DASH_DASH] = ACTIONS(4012),
    [anon_sym_PLUS_PLUS] = ACTIONS(4012),
    [anon_sym_DOT] = ACTIONS(4014),
    [anon_sym_DOT_STAR] = ACTIONS(4012),
    [anon_sym_DASH_GT] = ACTIONS(4012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4014),
    [anon_sym_let] = ACTIONS(4014),
    [anon_sym_This] = ACTIONS(4014),
  },
  [3167] = {
    [sym_attribute_declaration] = STATE(3260),
    [sym_parameter_list] = STATE(3274),
    [aux_sym_attributed_declarator_repeat1] = STATE(3260),
    [sym_identifier] = ACTIONS(7494),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7496),
    [anon_sym_COMMA] = ACTIONS(7496),
    [anon_sym_RPAREN] = ACTIONS(7496),
    [aux_sym_preproc_if_token2] = ACTIONS(7496),
    [aux_sym_preproc_else_token1] = ACTIONS(7496),
    [aux_sym_preproc_elif_token1] = ACTIONS(7494),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7496),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7496),
    [anon_sym_LPAREN2] = ACTIONS(7498),
    [anon_sym_DASH] = ACTIONS(7494),
    [anon_sym_PLUS] = ACTIONS(7494),
    [anon_sym_STAR] = ACTIONS(7494),
    [anon_sym_SLASH] = ACTIONS(7494),
    [anon_sym_PERCENT] = ACTIONS(7494),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7494),
    [anon_sym_CARET] = ACTIONS(7494),
    [anon_sym_AMP] = ACTIONS(7494),
    [anon_sym_EQ_EQ] = ACTIONS(7496),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_GT] = ACTIONS(7494),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_LT_EQ] = ACTIONS(7494),
    [anon_sym_LT] = ACTIONS(7494),
    [anon_sym_LT_LT] = ACTIONS(7494),
    [anon_sym_GT_GT] = ACTIONS(7494),
    [anon_sym_COLON] = ACTIONS(7496),
    [anon_sym_SEMI] = ACTIONS(7496),
    [anon_sym___attribute__] = ACTIONS(7494),
    [anon_sym___attribute] = ACTIONS(7494),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7500),
    [anon_sym_RBRACE] = ACTIONS(7496),
    [anon_sym_LBRACK] = ACTIONS(7502),
    [anon_sym_RBRACK] = ACTIONS(7496),
    [anon_sym_EQ] = ACTIONS(7494),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_STAR_EQ] = ACTIONS(7496),
    [anon_sym_SLASH_EQ] = ACTIONS(7496),
    [anon_sym_PERCENT_EQ] = ACTIONS(7496),
    [anon_sym_PLUS_EQ] = ACTIONS(7496),
    [anon_sym_DASH_EQ] = ACTIONS(7496),
    [anon_sym_LT_LT_EQ] = ACTIONS(7496),
    [anon_sym_GT_GT_EQ] = ACTIONS(7496),
    [anon_sym_AMP_EQ] = ACTIONS(7496),
    [anon_sym_CARET_EQ] = ACTIONS(7496),
    [anon_sym_PIPE_EQ] = ACTIONS(7496),
    [anon_sym_and_eq] = ACTIONS(7494),
    [anon_sym_or_eq] = ACTIONS(7494),
    [anon_sym_xor_eq] = ACTIONS(7494),
    [anon_sym_LT_EQ_GT] = ACTIONS(7496),
    [anon_sym_or] = ACTIONS(7494),
    [anon_sym_and] = ACTIONS(7494),
    [anon_sym_bitor] = ACTIONS(7494),
    [anon_sym_xor] = ACTIONS(7494),
    [anon_sym_bitand] = ACTIONS(7494),
    [anon_sym_not_eq] = ACTIONS(7494),
    [anon_sym_is] = ACTIONS(7494),
    [anon_sym_as] = ACTIONS(7494),
    [anon_sym_DASH_DASH] = ACTIONS(7496),
    [anon_sym_PLUS_PLUS] = ACTIONS(7496),
    [anon_sym_DOT] = ACTIONS(7494),
    [anon_sym_DOT_STAR] = ACTIONS(7496),
    [anon_sym_DASH_GT] = ACTIONS(7496),
    [sym_comment] = ACTIONS(3),
  },
  [3168] = {
    [sym_attribute_specifier] = STATE(3060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4085),
    [anon_sym_COMMA] = ACTIONS(4085),
    [anon_sym_RPAREN] = ACTIONS(4085),
    [anon_sym_LPAREN2] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4087),
    [anon_sym_PLUS] = ACTIONS(4087),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4087),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4087),
    [anon_sym_CARET] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4087),
    [anon_sym_EQ_EQ] = ACTIONS(4085),
    [anon_sym_BANG_EQ] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4087),
    [anon_sym_GT_EQ] = ACTIONS(4085),
    [anon_sym_LT_EQ] = ACTIONS(4087),
    [anon_sym_LT] = ACTIONS(4087),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_SEMI] = ACTIONS(4085),
    [anon_sym___extension__] = ACTIONS(4085),
    [anon_sym___attribute__] = ACTIONS(7346),
    [anon_sym___attribute] = ACTIONS(7348),
    [anon_sym_LBRACE] = ACTIONS(4085),
    [anon_sym_RBRACE] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4085),
    [anon_sym_RBRACK] = ACTIONS(4085),
    [anon_sym_const] = ACTIONS(4087),
    [anon_sym_constexpr] = ACTIONS(4085),
    [anon_sym_volatile] = ACTIONS(4085),
    [anon_sym_restrict] = ACTIONS(4085),
    [anon_sym___restrict__] = ACTIONS(4085),
    [anon_sym__Atomic] = ACTIONS(4085),
    [anon_sym__Noreturn] = ACTIONS(4085),
    [anon_sym_noreturn] = ACTIONS(4085),
    [anon_sym__Nonnull] = ACTIONS(4085),
    [anon_sym_mutable] = ACTIONS(4085),
    [anon_sym_constinit] = ACTIONS(4085),
    [anon_sym_consteval] = ACTIONS(4085),
    [anon_sym_alignas] = ACTIONS(4085),
    [anon_sym__Alignas] = ACTIONS(4085),
    [anon_sym_QMARK] = ACTIONS(4085),
    [anon_sym_LT_EQ_GT] = ACTIONS(4085),
    [anon_sym_or] = ACTIONS(4085),
    [anon_sym_and] = ACTIONS(4085),
    [anon_sym_bitor] = ACTIONS(4085),
    [anon_sym_xor] = ACTIONS(4085),
    [anon_sym_bitand] = ACTIONS(4085),
    [anon_sym_not_eq] = ACTIONS(4085),
    [anon_sym_is] = ACTIONS(4085),
    [anon_sym_as] = ACTIONS(4085),
    [anon_sym_DASH_DASH] = ACTIONS(4085),
    [anon_sym_PLUS_PLUS] = ACTIONS(4085),
    [anon_sym_DOT] = ACTIONS(4087),
    [anon_sym_DOT_STAR] = ACTIONS(4085),
    [anon_sym_DASH_GT] = ACTIONS(4085),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4085),
    [anon_sym_let] = ACTIONS(4085),
    [anon_sym_This] = ACTIONS(4085),
    [anon_sym_final] = ACTIONS(4085),
    [anon_sym_override] = ACTIONS(4085),
    [anon_sym_requires] = ACTIONS(4085),
    [anon_sym_where] = ACTIONS(4085),
  },
  [3169] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3169),
    [sym_identifier] = ACTIONS(2915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2913),
    [anon_sym_COMMA] = ACTIONS(2913),
    [aux_sym_preproc_if_token2] = ACTIONS(2913),
    [aux_sym_preproc_else_token1] = ACTIONS(2913),
    [aux_sym_preproc_elif_token1] = ACTIONS(2915),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2913),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2913),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2915),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(2915),
    [anon_sym_SLASH] = ACTIONS(2915),
    [anon_sym_PERCENT] = ACTIONS(2915),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_CARET] = ACTIONS(2915),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2915),
    [anon_sym_GT_EQ] = ACTIONS(2913),
    [anon_sym_LT_EQ] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2915),
    [anon_sym_LT_LT] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_signed] = ACTIONS(7504),
    [anon_sym_unsigned] = ACTIONS(7504),
    [anon_sym_long] = ACTIONS(7504),
    [anon_sym_short] = ACTIONS(7504),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(2913),
    [anon_sym_STAR_EQ] = ACTIONS(2913),
    [anon_sym_SLASH_EQ] = ACTIONS(2913),
    [anon_sym_PERCENT_EQ] = ACTIONS(2913),
    [anon_sym_PLUS_EQ] = ACTIONS(2913),
    [anon_sym_DASH_EQ] = ACTIONS(2913),
    [anon_sym_LT_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_GT_EQ] = ACTIONS(2913),
    [anon_sym_AMP_EQ] = ACTIONS(2913),
    [anon_sym_CARET_EQ] = ACTIONS(2913),
    [anon_sym_PIPE_EQ] = ACTIONS(2913),
    [anon_sym_and_eq] = ACTIONS(2915),
    [anon_sym_or_eq] = ACTIONS(2915),
    [anon_sym_xor_eq] = ACTIONS(2915),
    [anon_sym_LT_EQ_GT] = ACTIONS(2913),
    [anon_sym_or] = ACTIONS(2915),
    [anon_sym_and] = ACTIONS(2915),
    [anon_sym_bitor] = ACTIONS(2915),
    [anon_sym_xor] = ACTIONS(2915),
    [anon_sym_bitand] = ACTIONS(2915),
    [anon_sym_not_eq] = ACTIONS(2915),
    [anon_sym_is] = ACTIONS(2915),
    [anon_sym_as] = ACTIONS(2915),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_DOT] = ACTIONS(2915),
    [anon_sym_DOT_STAR] = ACTIONS(2913),
    [anon_sym_DASH_GT] = ACTIONS(2913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2915),
    [anon_sym_let] = ACTIONS(2915),
    [anon_sym_This] = ACTIONS(2915),
  },
  [3170] = {
    [sym_ms_based_modifier] = STATE(10947),
    [sym_ms_unaligned_ptr_modifier] = STATE(5091),
    [sym_ms_pointer_modifier] = STATE(3215),
    [sym__declarator] = STATE(7998),
    [sym__abstract_declarator] = STATE(8627),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_abstract_parenthesized_declarator] = STATE(7454),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_abstract_pointer_declarator] = STATE(7454),
    [sym_function_declarator] = STATE(8054),
    [sym_abstract_function_declarator] = STATE(7454),
    [sym_array_declarator] = STATE(8054),
    [sym_abstract_array_declarator] = STATE(7454),
    [sym_type_qualifier] = STATE(3613),
    [sym_alignas_qualifier] = STATE(5539),
    [sym_parameter_list] = STATE(4120),
    [sym_decltype] = STATE(11339),
    [sym_reference_declarator] = STATE(8054),
    [sym_abstract_reference_declarator] = STATE(7454),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym__function_declarator_seq] = STATE(7543),
    [sym_template_type] = STATE(11339),
    [sym_template_function] = STATE(8054),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7400),
    [sym_qualified_identifier] = STATE(8054),
    [sym_operator_name] = STATE(8054),
    [aux_sym__type_definition_type_repeat1] = STATE(3613),
    [aux_sym_pointer_declarator_repeat1] = STATE(3215),
    [sym_identifier] = ACTIONS(7394),
    [anon_sym_COMMA] = ACTIONS(7396),
    [anon_sym_LPAREN2] = ACTIONS(5344),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(7507),
    [anon_sym_AMP_AMP] = ACTIONS(7509),
    [anon_sym_AMP] = ACTIONS(7511),
    [anon_sym_COLON] = ACTIONS(7404),
    [anon_sym___extension__] = ACTIONS(5368),
    [anon_sym___attribute__] = ACTIONS(7404),
    [anon_sym___attribute] = ACTIONS(7404),
    [anon_sym_COLON_COLON] = ACTIONS(7406),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(5364),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(5364),
    [sym_ms_signed_ptr_modifier] = ACTIONS(5364),
    [anon_sym__unaligned] = ACTIONS(5366),
    [anon_sym___unaligned] = ACTIONS(5366),
    [anon_sym_LBRACK] = ACTIONS(7408),
    [anon_sym_const] = ACTIONS(5368),
    [anon_sym_constexpr] = ACTIONS(5368),
    [anon_sym_volatile] = ACTIONS(5368),
    [anon_sym_restrict] = ACTIONS(5368),
    [anon_sym___restrict__] = ACTIONS(5368),
    [anon_sym__Atomic] = ACTIONS(5368),
    [anon_sym__Noreturn] = ACTIONS(5368),
    [anon_sym_noreturn] = ACTIONS(5368),
    [anon_sym__Nonnull] = ACTIONS(5368),
    [anon_sym_mutable] = ACTIONS(5368),
    [anon_sym_constinit] = ACTIONS(5368),
    [anon_sym_consteval] = ACTIONS(5368),
    [anon_sym_alignas] = ACTIONS(5370),
    [anon_sym__Alignas] = ACTIONS(5370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(7396),
    [anon_sym_operator] = ACTIONS(2861),
  },
  [3171] = {
    [sym_attribute_specifier] = STATE(3054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(4174),
    [anon_sym_RPAREN] = ACTIONS(4174),
    [anon_sym_LPAREN2] = ACTIONS(4174),
    [anon_sym_DASH] = ACTIONS(4176),
    [anon_sym_PLUS] = ACTIONS(4176),
    [anon_sym_STAR] = ACTIONS(4174),
    [anon_sym_SLASH] = ACTIONS(4176),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [anon_sym_PIPE_PIPE] = ACTIONS(4174),
    [anon_sym_AMP_AMP] = ACTIONS(4174),
    [anon_sym_PIPE] = ACTIONS(4176),
    [anon_sym_CARET] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4176),
    [anon_sym_EQ_EQ] = ACTIONS(4174),
    [anon_sym_BANG_EQ] = ACTIONS(4174),
    [anon_sym_GT] = ACTIONS(4176),
    [anon_sym_GT_EQ] = ACTIONS(4174),
    [anon_sym_LT_EQ] = ACTIONS(4176),
    [anon_sym_LT] = ACTIONS(4176),
    [anon_sym_LT_LT] = ACTIONS(4174),
    [anon_sym_GT_GT] = ACTIONS(4174),
    [anon_sym_COLON] = ACTIONS(4174),
    [anon_sym_SEMI] = ACTIONS(4174),
    [anon_sym___extension__] = ACTIONS(4174),
    [anon_sym___attribute__] = ACTIONS(7346),
    [anon_sym___attribute] = ACTIONS(7348),
    [anon_sym_LBRACE] = ACTIONS(4174),
    [anon_sym_RBRACE] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4174),
    [anon_sym_RBRACK] = ACTIONS(4174),
    [anon_sym_const] = ACTIONS(4176),
    [anon_sym_constexpr] = ACTIONS(4174),
    [anon_sym_volatile] = ACTIONS(4174),
    [anon_sym_restrict] = ACTIONS(4174),
    [anon_sym___restrict__] = ACTIONS(4174),
    [anon_sym__Atomic] = ACTIONS(4174),
    [anon_sym__Noreturn] = ACTIONS(4174),
    [anon_sym_noreturn] = ACTIONS(4174),
    [anon_sym__Nonnull] = ACTIONS(4174),
    [anon_sym_mutable] = ACTIONS(4174),
    [anon_sym_constinit] = ACTIONS(4174),
    [anon_sym_consteval] = ACTIONS(4174),
    [anon_sym_alignas] = ACTIONS(4174),
    [anon_sym__Alignas] = ACTIONS(4174),
    [anon_sym_QMARK] = ACTIONS(4174),
    [anon_sym_LT_EQ_GT] = ACTIONS(4174),
    [anon_sym_or] = ACTIONS(4174),
    [anon_sym_and] = ACTIONS(4174),
    [anon_sym_bitor] = ACTIONS(4174),
    [anon_sym_xor] = ACTIONS(4174),
    [anon_sym_bitand] = ACTIONS(4174),
    [anon_sym_not_eq] = ACTIONS(4174),
    [anon_sym_is] = ACTIONS(4174),
    [anon_sym_as] = ACTIONS(4174),
    [anon_sym_DASH_DASH] = ACTIONS(4174),
    [anon_sym_PLUS_PLUS] = ACTIONS(4174),
    [anon_sym_DOT] = ACTIONS(4176),
    [anon_sym_DOT_STAR] = ACTIONS(4174),
    [anon_sym_DASH_GT] = ACTIONS(4174),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4174),
    [anon_sym_let] = ACTIONS(4174),
    [anon_sym_This] = ACTIONS(4174),
    [anon_sym_final] = ACTIONS(4174),
    [anon_sym_override] = ACTIONS(4174),
    [anon_sym_requires] = ACTIONS(4174),
    [anon_sym_where] = ACTIONS(4174),
  },
  [3172] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3169),
    [sym_identifier] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4080),
    [aux_sym_preproc_if_token2] = ACTIONS(4080),
    [aux_sym_preproc_else_token1] = ACTIONS(4080),
    [aux_sym_preproc_elif_token1] = ACTIONS(4078),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4080),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4080),
    [anon_sym_LPAREN2] = ACTIONS(4080),
    [anon_sym_DASH] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(4078),
    [anon_sym_STAR] = ACTIONS(4078),
    [anon_sym_SLASH] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [anon_sym_PIPE_PIPE] = ACTIONS(4080),
    [anon_sym_AMP_AMP] = ACTIONS(4080),
    [anon_sym_PIPE] = ACTIONS(4078),
    [anon_sym_CARET] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(4078),
    [anon_sym_EQ_EQ] = ACTIONS(4080),
    [anon_sym_BANG_EQ] = ACTIONS(4080),
    [anon_sym_GT] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4080),
    [anon_sym_LT_EQ] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_LT_LT] = ACTIONS(4078),
    [anon_sym_GT_GT] = ACTIONS(4078),
    [anon_sym___attribute__] = ACTIONS(4078),
    [anon_sym___attribute] = ACTIONS(4078),
    [anon_sym_LBRACE] = ACTIONS(4080),
    [anon_sym_signed] = ACTIONS(7513),
    [anon_sym_unsigned] = ACTIONS(7513),
    [anon_sym_long] = ACTIONS(7513),
    [anon_sym_short] = ACTIONS(7513),
    [anon_sym_LBRACK] = ACTIONS(4080),
    [anon_sym_EQ] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(4080),
    [anon_sym_STAR_EQ] = ACTIONS(4080),
    [anon_sym_SLASH_EQ] = ACTIONS(4080),
    [anon_sym_PERCENT_EQ] = ACTIONS(4080),
    [anon_sym_PLUS_EQ] = ACTIONS(4080),
    [anon_sym_DASH_EQ] = ACTIONS(4080),
    [anon_sym_LT_LT_EQ] = ACTIONS(4080),
    [anon_sym_GT_GT_EQ] = ACTIONS(4080),
    [anon_sym_AMP_EQ] = ACTIONS(4080),
    [anon_sym_CARET_EQ] = ACTIONS(4080),
    [anon_sym_PIPE_EQ] = ACTIONS(4080),
    [anon_sym_and_eq] = ACTIONS(4078),
    [anon_sym_or_eq] = ACTIONS(4078),
    [anon_sym_xor_eq] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4080),
    [anon_sym_or] = ACTIONS(4078),
    [anon_sym_and] = ACTIONS(4078),
    [anon_sym_bitor] = ACTIONS(4078),
    [anon_sym_xor] = ACTIONS(4078),
    [anon_sym_bitand] = ACTIONS(4078),
    [anon_sym_not_eq] = ACTIONS(4078),
    [anon_sym_is] = ACTIONS(4078),
    [anon_sym_as] = ACTIONS(4078),
    [anon_sym_DASH_DASH] = ACTIONS(4080),
    [anon_sym_PLUS_PLUS] = ACTIONS(4080),
    [anon_sym_DOT] = ACTIONS(4078),
    [anon_sym_DOT_STAR] = ACTIONS(4080),
    [anon_sym_DASH_GT] = ACTIONS(4080),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4078),
    [anon_sym_let] = ACTIONS(4078),
    [anon_sym_This] = ACTIONS(4078),
  },
  [3173] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3169),
    [sym_identifier] = ACTIONS(4093),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4095),
    [anon_sym_COMMA] = ACTIONS(4095),
    [aux_sym_preproc_if_token2] = ACTIONS(4095),
    [aux_sym_preproc_else_token1] = ACTIONS(4095),
    [aux_sym_preproc_elif_token1] = ACTIONS(4093),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4095),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4095),
    [anon_sym_LPAREN2] = ACTIONS(4095),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4093),
    [anon_sym_SLASH] = ACTIONS(4093),
    [anon_sym_PERCENT] = ACTIONS(4093),
    [anon_sym_PIPE_PIPE] = ACTIONS(4095),
    [anon_sym_AMP_AMP] = ACTIONS(4095),
    [anon_sym_PIPE] = ACTIONS(4093),
    [anon_sym_CARET] = ACTIONS(4093),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_EQ_EQ] = ACTIONS(4095),
    [anon_sym_BANG_EQ] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_GT_EQ] = ACTIONS(4095),
    [anon_sym_LT_EQ] = ACTIONS(4093),
    [anon_sym_LT] = ACTIONS(4093),
    [anon_sym_LT_LT] = ACTIONS(4093),
    [anon_sym_GT_GT] = ACTIONS(4093),
    [anon_sym___attribute__] = ACTIONS(4093),
    [anon_sym___attribute] = ACTIONS(4093),
    [anon_sym_LBRACE] = ACTIONS(4095),
    [anon_sym_signed] = ACTIONS(7513),
    [anon_sym_unsigned] = ACTIONS(7513),
    [anon_sym_long] = ACTIONS(7513),
    [anon_sym_short] = ACTIONS(7513),
    [anon_sym_LBRACK] = ACTIONS(4095),
    [anon_sym_EQ] = ACTIONS(4093),
    [anon_sym_QMARK] = ACTIONS(4095),
    [anon_sym_STAR_EQ] = ACTIONS(4095),
    [anon_sym_SLASH_EQ] = ACTIONS(4095),
    [anon_sym_PERCENT_EQ] = ACTIONS(4095),
    [anon_sym_PLUS_EQ] = ACTIONS(4095),
    [anon_sym_DASH_EQ] = ACTIONS(4095),
    [anon_sym_LT_LT_EQ] = ACTIONS(4095),
    [anon_sym_GT_GT_EQ] = ACTIONS(4095),
    [anon_sym_AMP_EQ] = ACTIONS(4095),
    [anon_sym_CARET_EQ] = ACTIONS(4095),
    [anon_sym_PIPE_EQ] = ACTIONS(4095),
    [anon_sym_and_eq] = ACTIONS(4093),
    [anon_sym_or_eq] = ACTIONS(4093),
    [anon_sym_xor_eq] = ACTIONS(4093),
    [anon_sym_LT_EQ_GT] = ACTIONS(4095),
    [anon_sym_or] = ACTIONS(4093),
    [anon_sym_and] = ACTIONS(4093),
    [anon_sym_bitor] = ACTIONS(4093),
    [anon_sym_xor] = ACTIONS(4093),
    [anon_sym_bitand] = ACTIONS(4093),
    [anon_sym_not_eq] = ACTIONS(4093),
    [anon_sym_is] = ACTIONS(4093),
    [anon_sym_as] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4095),
    [anon_sym_PLUS_PLUS] = ACTIONS(4095),
    [anon_sym_DOT] = ACTIONS(4093),
    [anon_sym_DOT_STAR] = ACTIONS(4095),
    [anon_sym_DASH_GT] = ACTIONS(4095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4093),
    [anon_sym_let] = ACTIONS(4093),
    [anon_sym_This] = ACTIONS(4093),
  },
  [3174] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3178),
    [sym_identifier] = ACTIONS(4111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4113),
    [anon_sym_COMMA] = ACTIONS(4113),
    [aux_sym_preproc_if_token2] = ACTIONS(4113),
    [aux_sym_preproc_else_token1] = ACTIONS(4113),
    [aux_sym_preproc_elif_token1] = ACTIONS(4111),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4113),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4113),
    [anon_sym_LPAREN2] = ACTIONS(4113),
    [anon_sym_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4111),
    [anon_sym_STAR] = ACTIONS(4111),
    [anon_sym_SLASH] = ACTIONS(4111),
    [anon_sym_PERCENT] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4111),
    [anon_sym_CARET] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4111),
    [anon_sym_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4111),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym___attribute__] = ACTIONS(4111),
    [anon_sym___attribute] = ACTIONS(4111),
    [anon_sym_LBRACE] = ACTIONS(4113),
    [anon_sym_signed] = ACTIONS(7515),
    [anon_sym_unsigned] = ACTIONS(7515),
    [anon_sym_long] = ACTIONS(7515),
    [anon_sym_short] = ACTIONS(7515),
    [anon_sym_LBRACK] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4111),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_STAR_EQ] = ACTIONS(4113),
    [anon_sym_SLASH_EQ] = ACTIONS(4113),
    [anon_sym_PERCENT_EQ] = ACTIONS(4113),
    [anon_sym_PLUS_EQ] = ACTIONS(4113),
    [anon_sym_DASH_EQ] = ACTIONS(4113),
    [anon_sym_LT_LT_EQ] = ACTIONS(4113),
    [anon_sym_GT_GT_EQ] = ACTIONS(4113),
    [anon_sym_AMP_EQ] = ACTIONS(4113),
    [anon_sym_CARET_EQ] = ACTIONS(4113),
    [anon_sym_PIPE_EQ] = ACTIONS(4113),
    [anon_sym_and_eq] = ACTIONS(4111),
    [anon_sym_or_eq] = ACTIONS(4111),
    [anon_sym_xor_eq] = ACTIONS(4111),
    [anon_sym_LT_EQ_GT] = ACTIONS(4113),
    [anon_sym_or] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4111),
    [anon_sym_bitor] = ACTIONS(4111),
    [anon_sym_xor] = ACTIONS(4111),
    [anon_sym_bitand] = ACTIONS(4111),
    [anon_sym_not_eq] = ACTIONS(4111),
    [anon_sym_is] = ACTIONS(4111),
    [anon_sym_as] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(4111),
    [anon_sym_DOT_STAR] = ACTIONS(4113),
    [anon_sym_DASH_GT] = ACTIONS(4113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4111),
    [anon_sym_let] = ACTIONS(4111),
    [anon_sym_This] = ACTIONS(4111),
  },
  [3175] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3179),
    [sym_identifier] = ACTIONS(4053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4051),
    [anon_sym_COMMA] = ACTIONS(4051),
    [aux_sym_preproc_if_token2] = ACTIONS(4051),
    [aux_sym_preproc_else_token1] = ACTIONS(4051),
    [aux_sym_preproc_elif_token1] = ACTIONS(4053),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4051),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4051),
    [anon_sym_LPAREN2] = ACTIONS(4051),
    [anon_sym_DASH] = ACTIONS(4053),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_STAR] = ACTIONS(4053),
    [anon_sym_SLASH] = ACTIONS(4053),
    [anon_sym_PERCENT] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4051),
    [anon_sym_AMP_AMP] = ACTIONS(4051),
    [anon_sym_PIPE] = ACTIONS(4053),
    [anon_sym_CARET] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4053),
    [anon_sym_EQ_EQ] = ACTIONS(4051),
    [anon_sym_BANG_EQ] = ACTIONS(4051),
    [anon_sym_GT] = ACTIONS(4053),
    [anon_sym_GT_EQ] = ACTIONS(4051),
    [anon_sym_LT_EQ] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4053),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym___attribute__] = ACTIONS(4053),
    [anon_sym___attribute] = ACTIONS(4053),
    [anon_sym_LBRACE] = ACTIONS(4051),
    [anon_sym_signed] = ACTIONS(7517),
    [anon_sym_unsigned] = ACTIONS(7517),
    [anon_sym_long] = ACTIONS(7517),
    [anon_sym_short] = ACTIONS(7517),
    [anon_sym_LBRACK] = ACTIONS(4051),
    [anon_sym_EQ] = ACTIONS(4053),
    [anon_sym_QMARK] = ACTIONS(4051),
    [anon_sym_STAR_EQ] = ACTIONS(4051),
    [anon_sym_SLASH_EQ] = ACTIONS(4051),
    [anon_sym_PERCENT_EQ] = ACTIONS(4051),
    [anon_sym_PLUS_EQ] = ACTIONS(4051),
    [anon_sym_DASH_EQ] = ACTIONS(4051),
    [anon_sym_LT_LT_EQ] = ACTIONS(4051),
    [anon_sym_GT_GT_EQ] = ACTIONS(4051),
    [anon_sym_AMP_EQ] = ACTIONS(4051),
    [anon_sym_CARET_EQ] = ACTIONS(4051),
    [anon_sym_PIPE_EQ] = ACTIONS(4051),
    [anon_sym_and_eq] = ACTIONS(4053),
    [anon_sym_or_eq] = ACTIONS(4053),
    [anon_sym_xor_eq] = ACTIONS(4053),
    [anon_sym_LT_EQ_GT] = ACTIONS(4051),
    [anon_sym_or] = ACTIONS(4053),
    [anon_sym_and] = ACTIONS(4053),
    [anon_sym_bitor] = ACTIONS(4053),
    [anon_sym_xor] = ACTIONS(4053),
    [anon_sym_bitand] = ACTIONS(4053),
    [anon_sym_not_eq] = ACTIONS(4053),
    [anon_sym_is] = ACTIONS(4053),
    [anon_sym_as] = ACTIONS(4053),
    [anon_sym_DASH_DASH] = ACTIONS(4051),
    [anon_sym_PLUS_PLUS] = ACTIONS(4051),
    [anon_sym_DOT] = ACTIONS(4053),
    [anon_sym_DOT_STAR] = ACTIONS(4051),
    [anon_sym_DASH_GT] = ACTIONS(4051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4053),
    [anon_sym_let] = ACTIONS(4053),
    [anon_sym_This] = ACTIONS(4053),
  },
  [3176] = {
    [sym_type_qualifier] = STATE(3176),
    [sym_alignas_qualifier] = STATE(3356),
    [aux_sym__type_definition_type_repeat1] = STATE(3176),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3681),
    [anon_sym_COMMA] = ACTIONS(3681),
    [anon_sym_LPAREN2] = ACTIONS(3681),
    [anon_sym_DASH] = ACTIONS(3683),
    [anon_sym_PLUS] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(3681),
    [anon_sym_SLASH] = ACTIONS(3683),
    [anon_sym_PERCENT] = ACTIONS(3681),
    [anon_sym_PIPE_PIPE] = ACTIONS(3681),
    [anon_sym_AMP_AMP] = ACTIONS(3681),
    [anon_sym_PIPE] = ACTIONS(3683),
    [anon_sym_CARET] = ACTIONS(3681),
    [anon_sym_AMP] = ACTIONS(3683),
    [anon_sym_EQ_EQ] = ACTIONS(3681),
    [anon_sym_BANG_EQ] = ACTIONS(3681),
    [anon_sym_GT] = ACTIONS(3683),
    [anon_sym_GT_EQ] = ACTIONS(3683),
    [anon_sym_LT_EQ] = ACTIONS(3683),
    [anon_sym_LT] = ACTIONS(3683),
    [anon_sym_LT_LT] = ACTIONS(3681),
    [anon_sym_GT_GT] = ACTIONS(3683),
    [anon_sym___extension__] = ACTIONS(7519),
    [anon_sym___attribute__] = ACTIONS(3683),
    [anon_sym___attribute] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3681),
    [anon_sym_signed] = ACTIONS(3683),
    [anon_sym_unsigned] = ACTIONS(3683),
    [anon_sym_long] = ACTIONS(3683),
    [anon_sym_short] = ACTIONS(3683),
    [anon_sym_LBRACK] = ACTIONS(3681),
    [anon_sym_const] = ACTIONS(7519),
    [anon_sym_constexpr] = ACTIONS(7519),
    [anon_sym_volatile] = ACTIONS(7519),
    [anon_sym_restrict] = ACTIONS(7519),
    [anon_sym___restrict__] = ACTIONS(7519),
    [anon_sym__Atomic] = ACTIONS(7519),
    [anon_sym__Noreturn] = ACTIONS(7519),
    [anon_sym_noreturn] = ACTIONS(7519),
    [anon_sym__Nonnull] = ACTIONS(7519),
    [anon_sym_mutable] = ACTIONS(7519),
    [anon_sym_constinit] = ACTIONS(7519),
    [anon_sym_consteval] = ACTIONS(7519),
    [anon_sym_alignas] = ACTIONS(7522),
    [anon_sym__Alignas] = ACTIONS(7522),
    [sym_primitive_type] = ACTIONS(3683),
    [anon_sym_QMARK] = ACTIONS(3681),
    [anon_sym_LT_EQ_GT] = ACTIONS(3681),
    [anon_sym_or] = ACTIONS(3683),
    [anon_sym_and] = ACTIONS(3683),
    [anon_sym_bitor] = ACTIONS(3683),
    [anon_sym_xor] = ACTIONS(3683),
    [anon_sym_bitand] = ACTIONS(3683),
    [anon_sym_not_eq] = ACTIONS(3683),
    [anon_sym_is] = ACTIONS(3683),
    [anon_sym_as] = ACTIONS(3683),
    [anon_sym_DASH_DASH] = ACTIONS(3681),
    [anon_sym_PLUS_PLUS] = ACTIONS(3681),
    [anon_sym_DOT] = ACTIONS(3683),
    [anon_sym_DOT_STAR] = ACTIONS(3681),
    [anon_sym_DASH_GT] = ACTIONS(3681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3683),
    [anon_sym_let] = ACTIONS(3683),
    [anon_sym_This] = ACTIONS(3683),
    [anon_sym_GT2] = ACTIONS(3681),
  },
  [3177] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(4695),
    [sym_raw_string_literal] = STATE(3527),
    [aux_sym_structured_binding_declarator_repeat1] = STATE(9611),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(7525),
    [anon_sym_LPAREN2] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6839),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_RBRACK] = ACTIONS(7527),
    [anon_sym_EQ] = ACTIONS(7530),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(7532),
    [anon_sym_SLASH_EQ] = ACTIONS(7532),
    [anon_sym_PERCENT_EQ] = ACTIONS(7532),
    [anon_sym_PLUS_EQ] = ACTIONS(7532),
    [anon_sym_DASH_EQ] = ACTIONS(7532),
    [anon_sym_LT_LT_EQ] = ACTIONS(7532),
    [anon_sym_GT_GT_EQ] = ACTIONS(7532),
    [anon_sym_AMP_EQ] = ACTIONS(7532),
    [anon_sym_CARET_EQ] = ACTIONS(7532),
    [anon_sym_PIPE_EQ] = ACTIONS(7532),
    [anon_sym_and_eq] = ACTIONS(7532),
    [anon_sym_or_eq] = ACTIONS(7532),
    [anon_sym_xor_eq] = ACTIONS(7532),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
  },
  [3178] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3169),
    [sym_identifier] = ACTIONS(3995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3997),
    [anon_sym_COMMA] = ACTIONS(3997),
    [aux_sym_preproc_if_token2] = ACTIONS(3997),
    [aux_sym_preproc_else_token1] = ACTIONS(3997),
    [aux_sym_preproc_elif_token1] = ACTIONS(3995),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3997),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3997),
    [anon_sym_LPAREN2] = ACTIONS(3997),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_STAR] = ACTIONS(3995),
    [anon_sym_SLASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3995),
    [anon_sym_PIPE_PIPE] = ACTIONS(3997),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_PIPE] = ACTIONS(3995),
    [anon_sym_CARET] = ACTIONS(3995),
    [anon_sym_AMP] = ACTIONS(3995),
    [anon_sym_EQ_EQ] = ACTIONS(3997),
    [anon_sym_BANG_EQ] = ACTIONS(3997),
    [anon_sym_GT] = ACTIONS(3995),
    [anon_sym_GT_EQ] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3995),
    [anon_sym_LT] = ACTIONS(3995),
    [anon_sym_LT_LT] = ACTIONS(3995),
    [anon_sym_GT_GT] = ACTIONS(3995),
    [anon_sym___attribute__] = ACTIONS(3995),
    [anon_sym___attribute] = ACTIONS(3995),
    [anon_sym_LBRACE] = ACTIONS(3997),
    [anon_sym_signed] = ACTIONS(7513),
    [anon_sym_unsigned] = ACTIONS(7513),
    [anon_sym_long] = ACTIONS(7513),
    [anon_sym_short] = ACTIONS(7513),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_EQ] = ACTIONS(3995),
    [anon_sym_QMARK] = ACTIONS(3997),
    [anon_sym_STAR_EQ] = ACTIONS(3997),
    [anon_sym_SLASH_EQ] = ACTIONS(3997),
    [anon_sym_PERCENT_EQ] = ACTIONS(3997),
    [anon_sym_PLUS_EQ] = ACTIONS(3997),
    [anon_sym_DASH_EQ] = ACTIONS(3997),
    [anon_sym_LT_LT_EQ] = ACTIONS(3997),
    [anon_sym_GT_GT_EQ] = ACTIONS(3997),
    [anon_sym_AMP_EQ] = ACTIONS(3997),
    [anon_sym_CARET_EQ] = ACTIONS(3997),
    [anon_sym_PIPE_EQ] = ACTIONS(3997),
    [anon_sym_and_eq] = ACTIONS(3995),
    [anon_sym_or_eq] = ACTIONS(3995),
    [anon_sym_xor_eq] = ACTIONS(3995),
    [anon_sym_LT_EQ_GT] = ACTIONS(3997),
    [anon_sym_or] = ACTIONS(3995),
    [anon_sym_and] = ACTIONS(3995),
    [anon_sym_bitor] = ACTIONS(3995),
    [anon_sym_xor] = ACTIONS(3995),
    [anon_sym_bitand] = ACTIONS(3995),
    [anon_sym_not_eq] = ACTIONS(3995),
    [anon_sym_is] = ACTIONS(3995),
    [anon_sym_as] = ACTIONS(3995),
    [anon_sym_DASH_DASH] = ACTIONS(3997),
    [anon_sym_PLUS_PLUS] = ACTIONS(3997),
    [anon_sym_DOT] = ACTIONS(3995),
    [anon_sym_DOT_STAR] = ACTIONS(3997),
    [anon_sym_DASH_GT] = ACTIONS(3997),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3995),
    [anon_sym_let] = ACTIONS(3995),
    [anon_sym_This] = ACTIONS(3995),
  },
  [3179] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3169),
    [sym_identifier] = ACTIONS(4102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4100),
    [anon_sym_COMMA] = ACTIONS(4100),
    [aux_sym_preproc_if_token2] = ACTIONS(4100),
    [aux_sym_preproc_else_token1] = ACTIONS(4100),
    [aux_sym_preproc_elif_token1] = ACTIONS(4102),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4100),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4100),
    [anon_sym_LPAREN2] = ACTIONS(4100),
    [anon_sym_DASH] = ACTIONS(4102),
    [anon_sym_PLUS] = ACTIONS(4102),
    [anon_sym_STAR] = ACTIONS(4102),
    [anon_sym_SLASH] = ACTIONS(4102),
    [anon_sym_PERCENT] = ACTIONS(4102),
    [anon_sym_PIPE_PIPE] = ACTIONS(4100),
    [anon_sym_AMP_AMP] = ACTIONS(4100),
    [anon_sym_PIPE] = ACTIONS(4102),
    [anon_sym_CARET] = ACTIONS(4102),
    [anon_sym_AMP] = ACTIONS(4102),
    [anon_sym_EQ_EQ] = ACTIONS(4100),
    [anon_sym_BANG_EQ] = ACTIONS(4100),
    [anon_sym_GT] = ACTIONS(4102),
    [anon_sym_GT_EQ] = ACTIONS(4100),
    [anon_sym_LT_EQ] = ACTIONS(4102),
    [anon_sym_LT] = ACTIONS(4102),
    [anon_sym_LT_LT] = ACTIONS(4102),
    [anon_sym_GT_GT] = ACTIONS(4102),
    [anon_sym___attribute__] = ACTIONS(4102),
    [anon_sym___attribute] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(4100),
    [anon_sym_signed] = ACTIONS(7513),
    [anon_sym_unsigned] = ACTIONS(7513),
    [anon_sym_long] = ACTIONS(7513),
    [anon_sym_short] = ACTIONS(7513),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_EQ] = ACTIONS(4102),
    [anon_sym_QMARK] = ACTIONS(4100),
    [anon_sym_STAR_EQ] = ACTIONS(4100),
    [anon_sym_SLASH_EQ] = ACTIONS(4100),
    [anon_sym_PERCENT_EQ] = ACTIONS(4100),
    [anon_sym_PLUS_EQ] = ACTIONS(4100),
    [anon_sym_DASH_EQ] = ACTIONS(4100),
    [anon_sym_LT_LT_EQ] = ACTIONS(4100),
    [anon_sym_GT_GT_EQ] = ACTIONS(4100),
    [anon_sym_AMP_EQ] = ACTIONS(4100),
    [anon_sym_CARET_EQ] = ACTIONS(4100),
    [anon_sym_PIPE_EQ] = ACTIONS(4100),
    [anon_sym_and_eq] = ACTIONS(4102),
    [anon_sym_or_eq] = ACTIONS(4102),
    [anon_sym_xor_eq] = ACTIONS(4102),
    [anon_sym_LT_EQ_GT] = ACTIONS(4100),
    [anon_sym_or] = ACTIONS(4102),
    [anon_sym_and] = ACTIONS(4102),
    [anon_sym_bitor] = ACTIONS(4102),
    [anon_sym_xor] = ACTIONS(4102),
    [anon_sym_bitand] = ACTIONS(4102),
    [anon_sym_not_eq] = ACTIONS(4102),
    [anon_sym_is] = ACTIONS(4102),
    [anon_sym_as] = ACTIONS(4102),
    [anon_sym_DASH_DASH] = ACTIONS(4100),
    [anon_sym_PLUS_PLUS] = ACTIONS(4100),
    [anon_sym_DOT] = ACTIONS(4102),
    [anon_sym_DOT_STAR] = ACTIONS(4100),
    [anon_sym_DASH_GT] = ACTIONS(4100),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4102),
    [anon_sym_let] = ACTIONS(4102),
    [anon_sym_This] = ACTIONS(4102),
  },
  [3180] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3184),
    [sym_identifier] = ACTIONS(4164),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4166),
    [anon_sym_COMMA] = ACTIONS(4166),
    [aux_sym_preproc_if_token2] = ACTIONS(4166),
    [aux_sym_preproc_else_token1] = ACTIONS(4166),
    [aux_sym_preproc_elif_token1] = ACTIONS(4164),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4166),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4166),
    [anon_sym_LPAREN2] = ACTIONS(4166),
    [anon_sym_DASH] = ACTIONS(4164),
    [anon_sym_PLUS] = ACTIONS(4164),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4164),
    [anon_sym_PERCENT] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(4166),
    [anon_sym_AMP_AMP] = ACTIONS(4166),
    [anon_sym_PIPE] = ACTIONS(4164),
    [anon_sym_CARET] = ACTIONS(4164),
    [anon_sym_AMP] = ACTIONS(4164),
    [anon_sym_EQ_EQ] = ACTIONS(4166),
    [anon_sym_BANG_EQ] = ACTIONS(4166),
    [anon_sym_GT] = ACTIONS(4164),
    [anon_sym_GT_EQ] = ACTIONS(4166),
    [anon_sym_LT_EQ] = ACTIONS(4164),
    [anon_sym_LT] = ACTIONS(4164),
    [anon_sym_LT_LT] = ACTIONS(4164),
    [anon_sym_GT_GT] = ACTIONS(4164),
    [anon_sym___attribute__] = ACTIONS(4164),
    [anon_sym___attribute] = ACTIONS(4164),
    [anon_sym_LBRACE] = ACTIONS(4166),
    [anon_sym_signed] = ACTIONS(7534),
    [anon_sym_unsigned] = ACTIONS(7534),
    [anon_sym_long] = ACTIONS(7534),
    [anon_sym_short] = ACTIONS(7534),
    [anon_sym_LBRACK] = ACTIONS(4166),
    [anon_sym_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(4166),
    [anon_sym_STAR_EQ] = ACTIONS(4166),
    [anon_sym_SLASH_EQ] = ACTIONS(4166),
    [anon_sym_PERCENT_EQ] = ACTIONS(4166),
    [anon_sym_PLUS_EQ] = ACTIONS(4166),
    [anon_sym_DASH_EQ] = ACTIONS(4166),
    [anon_sym_LT_LT_EQ] = ACTIONS(4166),
    [anon_sym_GT_GT_EQ] = ACTIONS(4166),
    [anon_sym_AMP_EQ] = ACTIONS(4166),
    [anon_sym_CARET_EQ] = ACTIONS(4166),
    [anon_sym_PIPE_EQ] = ACTIONS(4166),
    [anon_sym_and_eq] = ACTIONS(4164),
    [anon_sym_or_eq] = ACTIONS(4164),
    [anon_sym_xor_eq] = ACTIONS(4164),
    [anon_sym_LT_EQ_GT] = ACTIONS(4166),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_bitor] = ACTIONS(4164),
    [anon_sym_xor] = ACTIONS(4164),
    [anon_sym_bitand] = ACTIONS(4164),
    [anon_sym_not_eq] = ACTIONS(4164),
    [anon_sym_is] = ACTIONS(4164),
    [anon_sym_as] = ACTIONS(4164),
    [anon_sym_DASH_DASH] = ACTIONS(4166),
    [anon_sym_PLUS_PLUS] = ACTIONS(4166),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_DOT_STAR] = ACTIONS(4166),
    [anon_sym_DASH_GT] = ACTIONS(4166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4164),
    [anon_sym_let] = ACTIONS(4164),
    [anon_sym_This] = ACTIONS(4164),
  },
  [3181] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3185),
    [sym_identifier] = ACTIONS(4178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4180),
    [anon_sym_COMMA] = ACTIONS(4180),
    [aux_sym_preproc_if_token2] = ACTIONS(4180),
    [aux_sym_preproc_else_token1] = ACTIONS(4180),
    [aux_sym_preproc_elif_token1] = ACTIONS(4178),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4180),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4180),
    [anon_sym_LPAREN2] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4178),
    [anon_sym_PLUS] = ACTIONS(4178),
    [anon_sym_STAR] = ACTIONS(4178),
    [anon_sym_SLASH] = ACTIONS(4178),
    [anon_sym_PERCENT] = ACTIONS(4178),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_PIPE] = ACTIONS(4178),
    [anon_sym_CARET] = ACTIONS(4178),
    [anon_sym_AMP] = ACTIONS(4178),
    [anon_sym_EQ_EQ] = ACTIONS(4180),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4178),
    [anon_sym_GT_EQ] = ACTIONS(4180),
    [anon_sym_LT_EQ] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_LT_LT] = ACTIONS(4178),
    [anon_sym_GT_GT] = ACTIONS(4178),
    [anon_sym___attribute__] = ACTIONS(4178),
    [anon_sym___attribute] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_signed] = ACTIONS(7536),
    [anon_sym_unsigned] = ACTIONS(7536),
    [anon_sym_long] = ACTIONS(7536),
    [anon_sym_short] = ACTIONS(7536),
    [anon_sym_LBRACK] = ACTIONS(4180),
    [anon_sym_EQ] = ACTIONS(4178),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_STAR_EQ] = ACTIONS(4180),
    [anon_sym_SLASH_EQ] = ACTIONS(4180),
    [anon_sym_PERCENT_EQ] = ACTIONS(4180),
    [anon_sym_PLUS_EQ] = ACTIONS(4180),
    [anon_sym_DASH_EQ] = ACTIONS(4180),
    [anon_sym_LT_LT_EQ] = ACTIONS(4180),
    [anon_sym_GT_GT_EQ] = ACTIONS(4180),
    [anon_sym_AMP_EQ] = ACTIONS(4180),
    [anon_sym_CARET_EQ] = ACTIONS(4180),
    [anon_sym_PIPE_EQ] = ACTIONS(4180),
    [anon_sym_and_eq] = ACTIONS(4178),
    [anon_sym_or_eq] = ACTIONS(4178),
    [anon_sym_xor_eq] = ACTIONS(4178),
    [anon_sym_LT_EQ_GT] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4178),
    [anon_sym_and] = ACTIONS(4178),
    [anon_sym_bitor] = ACTIONS(4178),
    [anon_sym_xor] = ACTIONS(4178),
    [anon_sym_bitand] = ACTIONS(4178),
    [anon_sym_not_eq] = ACTIONS(4178),
    [anon_sym_is] = ACTIONS(4178),
    [anon_sym_as] = ACTIONS(4178),
    [anon_sym_DASH_DASH] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4178),
    [anon_sym_DOT_STAR] = ACTIONS(4180),
    [anon_sym_DASH_GT] = ACTIONS(4180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4178),
    [anon_sym_let] = ACTIONS(4178),
    [anon_sym_This] = ACTIONS(4178),
  },
  [3182] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3169),
    [sym_identifier] = ACTIONS(4185),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4187),
    [anon_sym_COMMA] = ACTIONS(4187),
    [aux_sym_preproc_if_token2] = ACTIONS(4187),
    [aux_sym_preproc_else_token1] = ACTIONS(4187),
    [aux_sym_preproc_elif_token1] = ACTIONS(4185),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4187),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4187),
    [anon_sym_LPAREN2] = ACTIONS(4187),
    [anon_sym_DASH] = ACTIONS(4185),
    [anon_sym_PLUS] = ACTIONS(4185),
    [anon_sym_STAR] = ACTIONS(4185),
    [anon_sym_SLASH] = ACTIONS(4185),
    [anon_sym_PERCENT] = ACTIONS(4185),
    [anon_sym_PIPE_PIPE] = ACTIONS(4187),
    [anon_sym_AMP_AMP] = ACTIONS(4187),
    [anon_sym_PIPE] = ACTIONS(4185),
    [anon_sym_CARET] = ACTIONS(4185),
    [anon_sym_AMP] = ACTIONS(4185),
    [anon_sym_EQ_EQ] = ACTIONS(4187),
    [anon_sym_BANG_EQ] = ACTIONS(4187),
    [anon_sym_GT] = ACTIONS(4185),
    [anon_sym_GT_EQ] = ACTIONS(4187),
    [anon_sym_LT_EQ] = ACTIONS(4185),
    [anon_sym_LT] = ACTIONS(4185),
    [anon_sym_LT_LT] = ACTIONS(4185),
    [anon_sym_GT_GT] = ACTIONS(4185),
    [anon_sym___attribute__] = ACTIONS(4185),
    [anon_sym___attribute] = ACTIONS(4185),
    [anon_sym_LBRACE] = ACTIONS(4187),
    [anon_sym_signed] = ACTIONS(7513),
    [anon_sym_unsigned] = ACTIONS(7513),
    [anon_sym_long] = ACTIONS(7513),
    [anon_sym_short] = ACTIONS(7513),
    [anon_sym_LBRACK] = ACTIONS(4187),
    [anon_sym_EQ] = ACTIONS(4185),
    [anon_sym_QMARK] = ACTIONS(4187),
    [anon_sym_STAR_EQ] = ACTIONS(4187),
    [anon_sym_SLASH_EQ] = ACTIONS(4187),
    [anon_sym_PERCENT_EQ] = ACTIONS(4187),
    [anon_sym_PLUS_EQ] = ACTIONS(4187),
    [anon_sym_DASH_EQ] = ACTIONS(4187),
    [anon_sym_LT_LT_EQ] = ACTIONS(4187),
    [anon_sym_GT_GT_EQ] = ACTIONS(4187),
    [anon_sym_AMP_EQ] = ACTIONS(4187),
    [anon_sym_CARET_EQ] = ACTIONS(4187),
    [anon_sym_PIPE_EQ] = ACTIONS(4187),
    [anon_sym_and_eq] = ACTIONS(4185),
    [anon_sym_or_eq] = ACTIONS(4185),
    [anon_sym_xor_eq] = ACTIONS(4185),
    [anon_sym_LT_EQ_GT] = ACTIONS(4187),
    [anon_sym_or] = ACTIONS(4185),
    [anon_sym_and] = ACTIONS(4185),
    [anon_sym_bitor] = ACTIONS(4185),
    [anon_sym_xor] = ACTIONS(4185),
    [anon_sym_bitand] = ACTIONS(4185),
    [anon_sym_not_eq] = ACTIONS(4185),
    [anon_sym_is] = ACTIONS(4185),
    [anon_sym_as] = ACTIONS(4185),
    [anon_sym_DASH_DASH] = ACTIONS(4187),
    [anon_sym_PLUS_PLUS] = ACTIONS(4187),
    [anon_sym_DOT] = ACTIONS(4185),
    [anon_sym_DOT_STAR] = ACTIONS(4187),
    [anon_sym_DASH_GT] = ACTIONS(4187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4185),
    [anon_sym_let] = ACTIONS(4185),
    [anon_sym_This] = ACTIONS(4185),
  },
  [3183] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3172),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2972),
    [anon_sym_COMMA] = ACTIONS(2972),
    [aux_sym_preproc_if_token2] = ACTIONS(2972),
    [aux_sym_preproc_else_token1] = ACTIONS(2972),
    [aux_sym_preproc_elif_token1] = ACTIONS(2974),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2972),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2972),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_STAR] = ACTIONS(2974),
    [anon_sym_SLASH] = ACTIONS(2974),
    [anon_sym_PERCENT] = ACTIONS(2974),
    [anon_sym_PIPE_PIPE] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_PIPE] = ACTIONS(2974),
    [anon_sym_CARET] = ACTIONS(2974),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_EQ_EQ] = ACTIONS(2972),
    [anon_sym_BANG_EQ] = ACTIONS(2972),
    [anon_sym_GT] = ACTIONS(2974),
    [anon_sym_GT_EQ] = ACTIONS(2972),
    [anon_sym_LT_EQ] = ACTIONS(2974),
    [anon_sym_LT] = ACTIONS(2974),
    [anon_sym_LT_LT] = ACTIONS(2974),
    [anon_sym_GT_GT] = ACTIONS(2974),
    [anon_sym___attribute__] = ACTIONS(2974),
    [anon_sym___attribute] = ACTIONS(2974),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_signed] = ACTIONS(7538),
    [anon_sym_unsigned] = ACTIONS(7538),
    [anon_sym_long] = ACTIONS(7538),
    [anon_sym_short] = ACTIONS(7538),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_EQ] = ACTIONS(2974),
    [anon_sym_QMARK] = ACTIONS(2972),
    [anon_sym_STAR_EQ] = ACTIONS(2972),
    [anon_sym_SLASH_EQ] = ACTIONS(2972),
    [anon_sym_PERCENT_EQ] = ACTIONS(2972),
    [anon_sym_PLUS_EQ] = ACTIONS(2972),
    [anon_sym_DASH_EQ] = ACTIONS(2972),
    [anon_sym_LT_LT_EQ] = ACTIONS(2972),
    [anon_sym_GT_GT_EQ] = ACTIONS(2972),
    [anon_sym_AMP_EQ] = ACTIONS(2972),
    [anon_sym_CARET_EQ] = ACTIONS(2972),
    [anon_sym_PIPE_EQ] = ACTIONS(2972),
    [anon_sym_and_eq] = ACTIONS(2974),
    [anon_sym_or_eq] = ACTIONS(2974),
    [anon_sym_xor_eq] = ACTIONS(2974),
    [anon_sym_LT_EQ_GT] = ACTIONS(2972),
    [anon_sym_or] = ACTIONS(2974),
    [anon_sym_and] = ACTIONS(2974),
    [anon_sym_bitor] = ACTIONS(2974),
    [anon_sym_xor] = ACTIONS(2974),
    [anon_sym_bitand] = ACTIONS(2974),
    [anon_sym_not_eq] = ACTIONS(2974),
    [anon_sym_is] = ACTIONS(2974),
    [anon_sym_as] = ACTIONS(2974),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_DOT] = ACTIONS(2974),
    [anon_sym_DOT_STAR] = ACTIONS(2972),
    [anon_sym_DASH_GT] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_This] = ACTIONS(2974),
  },
  [3184] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3169),
    [sym_identifier] = ACTIONS(4064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4062),
    [anon_sym_COMMA] = ACTIONS(4062),
    [aux_sym_preproc_if_token2] = ACTIONS(4062),
    [aux_sym_preproc_else_token1] = ACTIONS(4062),
    [aux_sym_preproc_elif_token1] = ACTIONS(4064),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4062),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4062),
    [anon_sym_LPAREN2] = ACTIONS(4062),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_STAR] = ACTIONS(4064),
    [anon_sym_SLASH] = ACTIONS(4064),
    [anon_sym_PERCENT] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE] = ACTIONS(4064),
    [anon_sym_CARET] = ACTIONS(4064),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [anon_sym_GT] = ACTIONS(4064),
    [anon_sym_GT_EQ] = ACTIONS(4062),
    [anon_sym_LT_EQ] = ACTIONS(4064),
    [anon_sym_LT] = ACTIONS(4064),
    [anon_sym_LT_LT] = ACTIONS(4064),
    [anon_sym_GT_GT] = ACTIONS(4064),
    [anon_sym___attribute__] = ACTIONS(4064),
    [anon_sym___attribute] = ACTIONS(4064),
    [anon_sym_LBRACE] = ACTIONS(4062),
    [anon_sym_signed] = ACTIONS(7513),
    [anon_sym_unsigned] = ACTIONS(7513),
    [anon_sym_long] = ACTIONS(7513),
    [anon_sym_short] = ACTIONS(7513),
    [anon_sym_LBRACK] = ACTIONS(4062),
    [anon_sym_EQ] = ACTIONS(4064),
    [anon_sym_QMARK] = ACTIONS(4062),
    [anon_sym_STAR_EQ] = ACTIONS(4062),
    [anon_sym_SLASH_EQ] = ACTIONS(4062),
    [anon_sym_PERCENT_EQ] = ACTIONS(4062),
    [anon_sym_PLUS_EQ] = ACTIONS(4062),
    [anon_sym_DASH_EQ] = ACTIONS(4062),
    [anon_sym_LT_LT_EQ] = ACTIONS(4062),
    [anon_sym_GT_GT_EQ] = ACTIONS(4062),
    [anon_sym_AMP_EQ] = ACTIONS(4062),
    [anon_sym_CARET_EQ] = ACTIONS(4062),
    [anon_sym_PIPE_EQ] = ACTIONS(4062),
    [anon_sym_and_eq] = ACTIONS(4064),
    [anon_sym_or_eq] = ACTIONS(4064),
    [anon_sym_xor_eq] = ACTIONS(4064),
    [anon_sym_LT_EQ_GT] = ACTIONS(4062),
    [anon_sym_or] = ACTIONS(4064),
    [anon_sym_and] = ACTIONS(4064),
    [anon_sym_bitor] = ACTIONS(4064),
    [anon_sym_xor] = ACTIONS(4064),
    [anon_sym_bitand] = ACTIONS(4064),
    [anon_sym_not_eq] = ACTIONS(4064),
    [anon_sym_is] = ACTIONS(4064),
    [anon_sym_as] = ACTIONS(4064),
    [anon_sym_DASH_DASH] = ACTIONS(4062),
    [anon_sym_PLUS_PLUS] = ACTIONS(4062),
    [anon_sym_DOT] = ACTIONS(4064),
    [anon_sym_DOT_STAR] = ACTIONS(4062),
    [anon_sym_DASH_GT] = ACTIONS(4062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4064),
    [anon_sym_let] = ACTIONS(4064),
    [anon_sym_This] = ACTIONS(4064),
  },
  [3185] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3169),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4071),
    [anon_sym_COMMA] = ACTIONS(4071),
    [aux_sym_preproc_if_token2] = ACTIONS(4071),
    [aux_sym_preproc_else_token1] = ACTIONS(4071),
    [aux_sym_preproc_elif_token1] = ACTIONS(4073),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4071),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4071),
    [anon_sym_LPAREN2] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(4073),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(4073),
    [anon_sym_SLASH] = ACTIONS(4073),
    [anon_sym_PERCENT] = ACTIONS(4073),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_CARET] = ACTIONS(4073),
    [anon_sym_AMP] = ACTIONS(4073),
    [anon_sym_EQ_EQ] = ACTIONS(4071),
    [anon_sym_BANG_EQ] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_EQ] = ACTIONS(4071),
    [anon_sym_LT_EQ] = ACTIONS(4073),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4073),
    [anon_sym___attribute__] = ACTIONS(4073),
    [anon_sym___attribute] = ACTIONS(4073),
    [anon_sym_LBRACE] = ACTIONS(4071),
    [anon_sym_signed] = ACTIONS(7513),
    [anon_sym_unsigned] = ACTIONS(7513),
    [anon_sym_long] = ACTIONS(7513),
    [anon_sym_short] = ACTIONS(7513),
    [anon_sym_LBRACK] = ACTIONS(4071),
    [anon_sym_EQ] = ACTIONS(4073),
    [anon_sym_QMARK] = ACTIONS(4071),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4073),
    [anon_sym_or_eq] = ACTIONS(4073),
    [anon_sym_xor_eq] = ACTIONS(4073),
    [anon_sym_LT_EQ_GT] = ACTIONS(4071),
    [anon_sym_or] = ACTIONS(4073),
    [anon_sym_and] = ACTIONS(4073),
    [anon_sym_bitor] = ACTIONS(4073),
    [anon_sym_xor] = ACTIONS(4073),
    [anon_sym_bitand] = ACTIONS(4073),
    [anon_sym_not_eq] = ACTIONS(4073),
    [anon_sym_is] = ACTIONS(4073),
    [anon_sym_as] = ACTIONS(4073),
    [anon_sym_DASH_DASH] = ACTIONS(4071),
    [anon_sym_PLUS_PLUS] = ACTIONS(4071),
    [anon_sym_DOT] = ACTIONS(4073),
    [anon_sym_DOT_STAR] = ACTIONS(4071),
    [anon_sym_DASH_GT] = ACTIONS(4071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4073),
    [anon_sym_let] = ACTIONS(4073),
    [anon_sym_This] = ACTIONS(4073),
  },
  [3186] = {
    [sym_attribute_specifier] = STATE(3022),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4198),
    [anon_sym_COMMA] = ACTIONS(4198),
    [anon_sym_RPAREN] = ACTIONS(4198),
    [anon_sym_LPAREN2] = ACTIONS(4198),
    [anon_sym_DASH] = ACTIONS(4200),
    [anon_sym_PLUS] = ACTIONS(4200),
    [anon_sym_STAR] = ACTIONS(4198),
    [anon_sym_SLASH] = ACTIONS(4200),
    [anon_sym_PERCENT] = ACTIONS(4198),
    [anon_sym_PIPE_PIPE] = ACTIONS(4198),
    [anon_sym_AMP_AMP] = ACTIONS(4198),
    [anon_sym_PIPE] = ACTIONS(4200),
    [anon_sym_CARET] = ACTIONS(4198),
    [anon_sym_AMP] = ACTIONS(4200),
    [anon_sym_EQ_EQ] = ACTIONS(4198),
    [anon_sym_BANG_EQ] = ACTIONS(4198),
    [anon_sym_GT] = ACTIONS(4200),
    [anon_sym_GT_EQ] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(4200),
    [anon_sym_LT] = ACTIONS(4200),
    [anon_sym_LT_LT] = ACTIONS(4198),
    [anon_sym_GT_GT] = ACTIONS(4198),
    [anon_sym_COLON] = ACTIONS(4198),
    [anon_sym_SEMI] = ACTIONS(4198),
    [anon_sym___extension__] = ACTIONS(4198),
    [anon_sym___attribute__] = ACTIONS(7346),
    [anon_sym___attribute] = ACTIONS(7348),
    [anon_sym_LBRACE] = ACTIONS(4198),
    [anon_sym_RBRACE] = ACTIONS(4198),
    [anon_sym_LBRACK] = ACTIONS(4198),
    [anon_sym_RBRACK] = ACTIONS(4198),
    [anon_sym_const] = ACTIONS(4200),
    [anon_sym_constexpr] = ACTIONS(4198),
    [anon_sym_volatile] = ACTIONS(4198),
    [anon_sym_restrict] = ACTIONS(4198),
    [anon_sym___restrict__] = ACTIONS(4198),
    [anon_sym__Atomic] = ACTIONS(4198),
    [anon_sym__Noreturn] = ACTIONS(4198),
    [anon_sym_noreturn] = ACTIONS(4198),
    [anon_sym__Nonnull] = ACTIONS(4198),
    [anon_sym_mutable] = ACTIONS(4198),
    [anon_sym_constinit] = ACTIONS(4198),
    [anon_sym_consteval] = ACTIONS(4198),
    [anon_sym_alignas] = ACTIONS(4198),
    [anon_sym__Alignas] = ACTIONS(4198),
    [anon_sym_QMARK] = ACTIONS(4198),
    [anon_sym_LT_EQ_GT] = ACTIONS(4198),
    [anon_sym_or] = ACTIONS(4198),
    [anon_sym_and] = ACTIONS(4198),
    [anon_sym_bitor] = ACTIONS(4198),
    [anon_sym_xor] = ACTIONS(4198),
    [anon_sym_bitand] = ACTIONS(4198),
    [anon_sym_not_eq] = ACTIONS(4198),
    [anon_sym_is] = ACTIONS(4198),
    [anon_sym_as] = ACTIONS(4198),
    [anon_sym_DASH_DASH] = ACTIONS(4198),
    [anon_sym_PLUS_PLUS] = ACTIONS(4198),
    [anon_sym_DOT] = ACTIONS(4200),
    [anon_sym_DOT_STAR] = ACTIONS(4198),
    [anon_sym_DASH_GT] = ACTIONS(4198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4198),
    [anon_sym_let] = ACTIONS(4198),
    [anon_sym_This] = ACTIONS(4198),
    [anon_sym_final] = ACTIONS(4198),
    [anon_sym_override] = ACTIONS(4198),
    [anon_sym_requires] = ACTIONS(4198),
    [anon_sym_where] = ACTIONS(4198),
  },
  [3187] = {
    [sym_identifier] = ACTIONS(3014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3012),
    [anon_sym_COMMA] = ACTIONS(3012),
    [anon_sym_RPAREN] = ACTIONS(3012),
    [aux_sym_preproc_if_token2] = ACTIONS(3012),
    [aux_sym_preproc_else_token1] = ACTIONS(3012),
    [aux_sym_preproc_elif_token1] = ACTIONS(3014),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3012),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3012),
    [anon_sym_LPAREN2] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_STAR] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3014),
    [anon_sym_PERCENT] = ACTIONS(3014),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_PIPE] = ACTIONS(3014),
    [anon_sym_CARET] = ACTIONS(3014),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_EQ_EQ] = ACTIONS(3012),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_GT] = ACTIONS(3014),
    [anon_sym_GT_EQ] = ACTIONS(3012),
    [anon_sym_LT_EQ] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(3014),
    [anon_sym_LT_LT] = ACTIONS(3014),
    [anon_sym_GT_GT] = ACTIONS(3014),
    [anon_sym_COLON] = ACTIONS(3012),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym___attribute__] = ACTIONS(3014),
    [anon_sym___attribute] = ACTIONS(3014),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_RBRACE] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_RBRACK] = ACTIONS(3012),
    [anon_sym_EQ] = ACTIONS(3014),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_STAR_EQ] = ACTIONS(3012),
    [anon_sym_SLASH_EQ] = ACTIONS(3012),
    [anon_sym_PERCENT_EQ] = ACTIONS(3012),
    [anon_sym_PLUS_EQ] = ACTIONS(3012),
    [anon_sym_DASH_EQ] = ACTIONS(3012),
    [anon_sym_LT_LT_EQ] = ACTIONS(3012),
    [anon_sym_GT_GT_EQ] = ACTIONS(3012),
    [anon_sym_AMP_EQ] = ACTIONS(3012),
    [anon_sym_CARET_EQ] = ACTIONS(3012),
    [anon_sym_PIPE_EQ] = ACTIONS(3012),
    [anon_sym_and_eq] = ACTIONS(3014),
    [anon_sym_or_eq] = ACTIONS(3014),
    [anon_sym_xor_eq] = ACTIONS(3014),
    [anon_sym_LT_EQ_GT] = ACTIONS(3012),
    [anon_sym_or] = ACTIONS(3014),
    [anon_sym_and] = ACTIONS(3014),
    [anon_sym_bitor] = ACTIONS(3014),
    [anon_sym_xor] = ACTIONS(3014),
    [anon_sym_bitand] = ACTIONS(3014),
    [anon_sym_not_eq] = ACTIONS(3014),
    [anon_sym_is] = ACTIONS(3014),
    [anon_sym_as] = ACTIONS(3014),
    [anon_sym_DASH_DASH] = ACTIONS(3012),
    [anon_sym_PLUS_PLUS] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3014),
    [anon_sym_DOT_STAR] = ACTIONS(3012),
    [anon_sym_DASH_GT] = ACTIONS(3012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3014),
    [anon_sym_let] = ACTIONS(3014),
    [anon_sym_This] = ACTIONS(3014),
  },
  [3188] = {
    [sym_attribute_specifier] = STATE(3020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4109),
    [anon_sym_COMMA] = ACTIONS(4109),
    [anon_sym_RPAREN] = ACTIONS(4109),
    [anon_sym_LPAREN2] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4107),
    [anon_sym_STAR] = ACTIONS(4109),
    [anon_sym_SLASH] = ACTIONS(4107),
    [anon_sym_PERCENT] = ACTIONS(4109),
    [anon_sym_PIPE_PIPE] = ACTIONS(4109),
    [anon_sym_AMP_AMP] = ACTIONS(4109),
    [anon_sym_PIPE] = ACTIONS(4107),
    [anon_sym_CARET] = ACTIONS(4109),
    [anon_sym_AMP] = ACTIONS(4107),
    [anon_sym_EQ_EQ] = ACTIONS(4109),
    [anon_sym_BANG_EQ] = ACTIONS(4109),
    [anon_sym_GT] = ACTIONS(4107),
    [anon_sym_GT_EQ] = ACTIONS(4109),
    [anon_sym_LT_EQ] = ACTIONS(4107),
    [anon_sym_LT] = ACTIONS(4107),
    [anon_sym_LT_LT] = ACTIONS(4109),
    [anon_sym_GT_GT] = ACTIONS(4109),
    [anon_sym_COLON] = ACTIONS(4109),
    [anon_sym_SEMI] = ACTIONS(4109),
    [anon_sym___extension__] = ACTIONS(4109),
    [anon_sym___attribute__] = ACTIONS(7346),
    [anon_sym___attribute] = ACTIONS(7348),
    [anon_sym_LBRACE] = ACTIONS(4109),
    [anon_sym_RBRACE] = ACTIONS(4109),
    [anon_sym_LBRACK] = ACTIONS(4109),
    [anon_sym_RBRACK] = ACTIONS(4109),
    [anon_sym_const] = ACTIONS(4107),
    [anon_sym_constexpr] = ACTIONS(4109),
    [anon_sym_volatile] = ACTIONS(4109),
    [anon_sym_restrict] = ACTIONS(4109),
    [anon_sym___restrict__] = ACTIONS(4109),
    [anon_sym__Atomic] = ACTIONS(4109),
    [anon_sym__Noreturn] = ACTIONS(4109),
    [anon_sym_noreturn] = ACTIONS(4109),
    [anon_sym__Nonnull] = ACTIONS(4109),
    [anon_sym_mutable] = ACTIONS(4109),
    [anon_sym_constinit] = ACTIONS(4109),
    [anon_sym_consteval] = ACTIONS(4109),
    [anon_sym_alignas] = ACTIONS(4109),
    [anon_sym__Alignas] = ACTIONS(4109),
    [anon_sym_QMARK] = ACTIONS(4109),
    [anon_sym_LT_EQ_GT] = ACTIONS(4109),
    [anon_sym_or] = ACTIONS(4109),
    [anon_sym_and] = ACTIONS(4109),
    [anon_sym_bitor] = ACTIONS(4109),
    [anon_sym_xor] = ACTIONS(4109),
    [anon_sym_bitand] = ACTIONS(4109),
    [anon_sym_not_eq] = ACTIONS(4109),
    [anon_sym_is] = ACTIONS(4109),
    [anon_sym_as] = ACTIONS(4109),
    [anon_sym_DASH_DASH] = ACTIONS(4109),
    [anon_sym_PLUS_PLUS] = ACTIONS(4109),
    [anon_sym_DOT] = ACTIONS(4107),
    [anon_sym_DOT_STAR] = ACTIONS(4109),
    [anon_sym_DASH_GT] = ACTIONS(4109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4109),
    [anon_sym_let] = ACTIONS(4109),
    [anon_sym_This] = ACTIONS(4109),
    [anon_sym_final] = ACTIONS(4109),
    [anon_sym_override] = ACTIONS(4109),
    [anon_sym_requires] = ACTIONS(4109),
    [anon_sym_where] = ACTIONS(4109),
  },
  [3189] = {
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2881),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [aux_sym_preproc_if_token2] = ACTIONS(2881),
    [aux_sym_preproc_else_token1] = ACTIONS(2881),
    [aux_sym_preproc_elif_token1] = ACTIONS(2883),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2881),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2883),
    [anon_sym_SLASH] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_CARET] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_EQ_EQ] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_GT_EQ] = ACTIONS(2881),
    [anon_sym_LT_EQ] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_LT_LT] = ACTIONS(2883),
    [anon_sym_GT_GT] = ACTIONS(2883),
    [anon_sym_COLON] = ACTIONS(2881),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_RBRACE] = ACTIONS(2881),
    [anon_sym_LBRACK] = ACTIONS(2881),
    [anon_sym_RBRACK] = ACTIONS(2881),
    [anon_sym_EQ] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_STAR_EQ] = ACTIONS(2881),
    [anon_sym_SLASH_EQ] = ACTIONS(2881),
    [anon_sym_PERCENT_EQ] = ACTIONS(2881),
    [anon_sym_PLUS_EQ] = ACTIONS(2881),
    [anon_sym_DASH_EQ] = ACTIONS(2881),
    [anon_sym_LT_LT_EQ] = ACTIONS(2881),
    [anon_sym_GT_GT_EQ] = ACTIONS(2881),
    [anon_sym_AMP_EQ] = ACTIONS(2881),
    [anon_sym_CARET_EQ] = ACTIONS(2881),
    [anon_sym_PIPE_EQ] = ACTIONS(2881),
    [anon_sym_and_eq] = ACTIONS(2883),
    [anon_sym_or_eq] = ACTIONS(2883),
    [anon_sym_xor_eq] = ACTIONS(2883),
    [anon_sym_LT_EQ_GT] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2883),
    [anon_sym_and] = ACTIONS(2883),
    [anon_sym_bitor] = ACTIONS(2883),
    [anon_sym_xor] = ACTIONS(2883),
    [anon_sym_bitand] = ACTIONS(2883),
    [anon_sym_not_eq] = ACTIONS(2883),
    [anon_sym_is] = ACTIONS(2883),
    [anon_sym_as] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_DOT_STAR] = ACTIONS(2881),
    [anon_sym_DASH_GT] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
  },
  [3190] = {
    [sym_attribute_specifier] = STATE(3014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(4008),
    [anon_sym_RPAREN] = ACTIONS(4008),
    [anon_sym_LPAREN2] = ACTIONS(4008),
    [anon_sym_DASH] = ACTIONS(4010),
    [anon_sym_PLUS] = ACTIONS(4010),
    [anon_sym_STAR] = ACTIONS(4008),
    [anon_sym_SLASH] = ACTIONS(4010),
    [anon_sym_PERCENT] = ACTIONS(4008),
    [anon_sym_PIPE_PIPE] = ACTIONS(4008),
    [anon_sym_AMP_AMP] = ACTIONS(4008),
    [anon_sym_PIPE] = ACTIONS(4010),
    [anon_sym_CARET] = ACTIONS(4008),
    [anon_sym_AMP] = ACTIONS(4010),
    [anon_sym_EQ_EQ] = ACTIONS(4008),
    [anon_sym_BANG_EQ] = ACTIONS(4008),
    [anon_sym_GT] = ACTIONS(4010),
    [anon_sym_GT_EQ] = ACTIONS(4008),
    [anon_sym_LT_EQ] = ACTIONS(4010),
    [anon_sym_LT] = ACTIONS(4010),
    [anon_sym_LT_LT] = ACTIONS(4008),
    [anon_sym_GT_GT] = ACTIONS(4008),
    [anon_sym_COLON] = ACTIONS(4008),
    [anon_sym_SEMI] = ACTIONS(4008),
    [anon_sym___extension__] = ACTIONS(4008),
    [anon_sym___attribute__] = ACTIONS(7346),
    [anon_sym___attribute] = ACTIONS(7348),
    [anon_sym_LBRACE] = ACTIONS(4008),
    [anon_sym_RBRACE] = ACTIONS(4008),
    [anon_sym_LBRACK] = ACTIONS(4008),
    [anon_sym_RBRACK] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_constexpr] = ACTIONS(4008),
    [anon_sym_volatile] = ACTIONS(4008),
    [anon_sym_restrict] = ACTIONS(4008),
    [anon_sym___restrict__] = ACTIONS(4008),
    [anon_sym__Atomic] = ACTIONS(4008),
    [anon_sym__Noreturn] = ACTIONS(4008),
    [anon_sym_noreturn] = ACTIONS(4008),
    [anon_sym__Nonnull] = ACTIONS(4008),
    [anon_sym_mutable] = ACTIONS(4008),
    [anon_sym_constinit] = ACTIONS(4008),
    [anon_sym_consteval] = ACTIONS(4008),
    [anon_sym_alignas] = ACTIONS(4008),
    [anon_sym__Alignas] = ACTIONS(4008),
    [anon_sym_QMARK] = ACTIONS(4008),
    [anon_sym_LT_EQ_GT] = ACTIONS(4008),
    [anon_sym_or] = ACTIONS(4008),
    [anon_sym_and] = ACTIONS(4008),
    [anon_sym_bitor] = ACTIONS(4008),
    [anon_sym_xor] = ACTIONS(4008),
    [anon_sym_bitand] = ACTIONS(4008),
    [anon_sym_not_eq] = ACTIONS(4008),
    [anon_sym_is] = ACTIONS(4008),
    [anon_sym_as] = ACTIONS(4008),
    [anon_sym_DASH_DASH] = ACTIONS(4008),
    [anon_sym_PLUS_PLUS] = ACTIONS(4008),
    [anon_sym_DOT] = ACTIONS(4010),
    [anon_sym_DOT_STAR] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4008),
    [anon_sym_let] = ACTIONS(4008),
    [anon_sym_This] = ACTIONS(4008),
    [anon_sym_final] = ACTIONS(4008),
    [anon_sym_override] = ACTIONS(4008),
    [anon_sym_requires] = ACTIONS(4008),
    [anon_sym_where] = ACTIONS(4008),
  },
  [3191] = {
    [sym_attribute_specifier] = STATE(3035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4012),
    [anon_sym_COMMA] = ACTIONS(4012),
    [anon_sym_RPAREN] = ACTIONS(4012),
    [anon_sym_LPAREN2] = ACTIONS(4012),
    [anon_sym_DASH] = ACTIONS(4014),
    [anon_sym_PLUS] = ACTIONS(4014),
    [anon_sym_STAR] = ACTIONS(4012),
    [anon_sym_SLASH] = ACTIONS(4014),
    [anon_sym_PERCENT] = ACTIONS(4012),
    [anon_sym_PIPE_PIPE] = ACTIONS(4012),
    [anon_sym_AMP_AMP] = ACTIONS(4012),
    [anon_sym_PIPE] = ACTIONS(4014),
    [anon_sym_CARET] = ACTIONS(4012),
    [anon_sym_AMP] = ACTIONS(4014),
    [anon_sym_EQ_EQ] = ACTIONS(4012),
    [anon_sym_BANG_EQ] = ACTIONS(4012),
    [anon_sym_GT] = ACTIONS(4014),
    [anon_sym_GT_EQ] = ACTIONS(4012),
    [anon_sym_LT_EQ] = ACTIONS(4014),
    [anon_sym_LT] = ACTIONS(4014),
    [anon_sym_LT_LT] = ACTIONS(4012),
    [anon_sym_GT_GT] = ACTIONS(4012),
    [anon_sym_COLON] = ACTIONS(4012),
    [anon_sym_SEMI] = ACTIONS(4012),
    [anon_sym___extension__] = ACTIONS(4012),
    [anon_sym___attribute__] = ACTIONS(7346),
    [anon_sym___attribute] = ACTIONS(7348),
    [anon_sym_LBRACE] = ACTIONS(4012),
    [anon_sym_RBRACE] = ACTIONS(4012),
    [anon_sym_LBRACK] = ACTIONS(4012),
    [anon_sym_RBRACK] = ACTIONS(4012),
    [anon_sym_const] = ACTIONS(4014),
    [anon_sym_constexpr] = ACTIONS(4012),
    [anon_sym_volatile] = ACTIONS(4012),
    [anon_sym_restrict] = ACTIONS(4012),
    [anon_sym___restrict__] = ACTIONS(4012),
    [anon_sym__Atomic] = ACTIONS(4012),
    [anon_sym__Noreturn] = ACTIONS(4012),
    [anon_sym_noreturn] = ACTIONS(4012),
    [anon_sym__Nonnull] = ACTIONS(4012),
    [anon_sym_mutable] = ACTIONS(4012),
    [anon_sym_constinit] = ACTIONS(4012),
    [anon_sym_consteval] = ACTIONS(4012),
    [anon_sym_alignas] = ACTIONS(4012),
    [anon_sym__Alignas] = ACTIONS(4012),
    [anon_sym_QMARK] = ACTIONS(4012),
    [anon_sym_LT_EQ_GT] = ACTIONS(4012),
    [anon_sym_or] = ACTIONS(4012),
    [anon_sym_and] = ACTIONS(4012),
    [anon_sym_bitor] = ACTIONS(4012),
    [anon_sym_xor] = ACTIONS(4012),
    [anon_sym_bitand] = ACTIONS(4012),
    [anon_sym_not_eq] = ACTIONS(4012),
    [anon_sym_is] = ACTIONS(4012),
    [anon_sym_as] = ACTIONS(4012),
    [anon_sym_DASH_DASH] = ACTIONS(4012),
    [anon_sym_PLUS_PLUS] = ACTIONS(4012),
    [anon_sym_DOT] = ACTIONS(4014),
    [anon_sym_DOT_STAR] = ACTIONS(4012),
    [anon_sym_DASH_GT] = ACTIONS(4012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4012),
    [anon_sym_let] = ACTIONS(4012),
    [anon_sym_This] = ACTIONS(4012),
    [anon_sym_final] = ACTIONS(4012),
    [anon_sym_override] = ACTIONS(4012),
    [anon_sym_requires] = ACTIONS(4012),
    [anon_sym_where] = ACTIONS(4012),
  },
  [3192] = {
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2881),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [aux_sym_preproc_if_token2] = ACTIONS(2881),
    [aux_sym_preproc_else_token1] = ACTIONS(2881),
    [aux_sym_preproc_elif_token1] = ACTIONS(2883),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2881),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2883),
    [anon_sym_SLASH] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_CARET] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_EQ_EQ] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_GT_EQ] = ACTIONS(2881),
    [anon_sym_LT_EQ] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_LT_LT] = ACTIONS(2883),
    [anon_sym_GT_GT] = ACTIONS(2883),
    [anon_sym_COLON] = ACTIONS(2881),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_RBRACE] = ACTIONS(2881),
    [anon_sym_LBRACK] = ACTIONS(2881),
    [anon_sym_RBRACK] = ACTIONS(2881),
    [anon_sym_EQ] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_STAR_EQ] = ACTIONS(2881),
    [anon_sym_SLASH_EQ] = ACTIONS(2881),
    [anon_sym_PERCENT_EQ] = ACTIONS(2881),
    [anon_sym_PLUS_EQ] = ACTIONS(2881),
    [anon_sym_DASH_EQ] = ACTIONS(2881),
    [anon_sym_LT_LT_EQ] = ACTIONS(2881),
    [anon_sym_GT_GT_EQ] = ACTIONS(2881),
    [anon_sym_AMP_EQ] = ACTIONS(2881),
    [anon_sym_CARET_EQ] = ACTIONS(2881),
    [anon_sym_PIPE_EQ] = ACTIONS(2881),
    [anon_sym_and_eq] = ACTIONS(2883),
    [anon_sym_or_eq] = ACTIONS(2883),
    [anon_sym_xor_eq] = ACTIONS(2883),
    [anon_sym_LT_EQ_GT] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2883),
    [anon_sym_and] = ACTIONS(2883),
    [anon_sym_bitor] = ACTIONS(2883),
    [anon_sym_xor] = ACTIONS(2883),
    [anon_sym_bitand] = ACTIONS(2883),
    [anon_sym_not_eq] = ACTIONS(2883),
    [anon_sym_is] = ACTIONS(2883),
    [anon_sym_as] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_DOT_STAR] = ACTIONS(2881),
    [anon_sym_DASH_GT] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
  },
  [3193] = {
    [sym_string_literal] = STATE(3243),
    [sym_raw_string_literal] = STATE(3243),
    [aux_sym_concatenated_string_repeat1] = STATE(3243),
    [sym_identifier] = ACTIONS(7540),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7217),
    [anon_sym_COMMA] = ACTIONS(7217),
    [anon_sym_RPAREN] = ACTIONS(7217),
    [anon_sym_LPAREN2] = ACTIONS(7217),
    [anon_sym_DASH] = ACTIONS(7219),
    [anon_sym_PLUS] = ACTIONS(7219),
    [anon_sym_STAR] = ACTIONS(7219),
    [anon_sym_SLASH] = ACTIONS(7219),
    [anon_sym_PERCENT] = ACTIONS(7219),
    [anon_sym_PIPE_PIPE] = ACTIONS(7217),
    [anon_sym_AMP_AMP] = ACTIONS(7217),
    [anon_sym_PIPE] = ACTIONS(7219),
    [anon_sym_CARET] = ACTIONS(7219),
    [anon_sym_AMP] = ACTIONS(7219),
    [anon_sym_EQ_EQ] = ACTIONS(7217),
    [anon_sym_BANG_EQ] = ACTIONS(7217),
    [anon_sym_GT] = ACTIONS(7219),
    [anon_sym_GT_EQ] = ACTIONS(7217),
    [anon_sym_LT_EQ] = ACTIONS(7219),
    [anon_sym_LT] = ACTIONS(7219),
    [anon_sym_LT_LT] = ACTIONS(7219),
    [anon_sym_GT_GT] = ACTIONS(7219),
    [anon_sym_LBRACK] = ACTIONS(7217),
    [anon_sym_EQ] = ACTIONS(7219),
    [anon_sym_QMARK] = ACTIONS(7217),
    [anon_sym_STAR_EQ] = ACTIONS(7217),
    [anon_sym_SLASH_EQ] = ACTIONS(7217),
    [anon_sym_PERCENT_EQ] = ACTIONS(7217),
    [anon_sym_PLUS_EQ] = ACTIONS(7217),
    [anon_sym_DASH_EQ] = ACTIONS(7217),
    [anon_sym_LT_LT_EQ] = ACTIONS(7217),
    [anon_sym_GT_GT_EQ] = ACTIONS(7217),
    [anon_sym_AMP_EQ] = ACTIONS(7217),
    [anon_sym_CARET_EQ] = ACTIONS(7217),
    [anon_sym_PIPE_EQ] = ACTIONS(7217),
    [anon_sym_and_eq] = ACTIONS(7219),
    [anon_sym_or_eq] = ACTIONS(7219),
    [anon_sym_xor_eq] = ACTIONS(7219),
    [anon_sym_LT_EQ_GT] = ACTIONS(7217),
    [anon_sym_or] = ACTIONS(7219),
    [anon_sym_and] = ACTIONS(7219),
    [anon_sym_bitor] = ACTIONS(7219),
    [anon_sym_xor] = ACTIONS(7219),
    [anon_sym_bitand] = ACTIONS(7219),
    [anon_sym_not_eq] = ACTIONS(7219),
    [anon_sym_is] = ACTIONS(7219),
    [anon_sym_as] = ACTIONS(7219),
    [anon_sym_DASH_DASH] = ACTIONS(7217),
    [anon_sym_PLUS_PLUS] = ACTIONS(7217),
    [anon_sym_DOT] = ACTIONS(7219),
    [anon_sym_DOT_STAR] = ACTIONS(7217),
    [anon_sym_DASH_GT] = ACTIONS(7219),
    [anon_sym_L_DQUOTE] = ACTIONS(6765),
    [anon_sym_u_DQUOTE] = ACTIONS(6765),
    [anon_sym_U_DQUOTE] = ACTIONS(6765),
    [anon_sym_u8_DQUOTE] = ACTIONS(6765),
    [anon_sym_DQUOTE] = ACTIONS(6765),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6767),
    [anon_sym_LR_DQUOTE] = ACTIONS(6767),
    [anon_sym_uR_DQUOTE] = ACTIONS(6767),
    [anon_sym_UR_DQUOTE] = ACTIONS(6767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6767),
    [anon_sym_DASH_GT_STAR] = ACTIONS(7217),
    [sym_literal_suffix] = ACTIONS(7219),
  },
  [3194] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(4695),
    [sym_raw_string_literal] = STATE(3527),
    [aux_sym_structured_binding_declarator_repeat1] = STATE(9611),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7542),
    [anon_sym_COMMA] = ACTIONS(7545),
    [anon_sym_LPAREN2] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6839),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_RBRACK] = ACTIONS(7548),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(7532),
    [anon_sym_SLASH_EQ] = ACTIONS(7532),
    [anon_sym_PERCENT_EQ] = ACTIONS(7532),
    [anon_sym_PLUS_EQ] = ACTIONS(7532),
    [anon_sym_DASH_EQ] = ACTIONS(7532),
    [anon_sym_LT_LT_EQ] = ACTIONS(7532),
    [anon_sym_GT_GT_EQ] = ACTIONS(7532),
    [anon_sym_AMP_EQ] = ACTIONS(7532),
    [anon_sym_CARET_EQ] = ACTIONS(7532),
    [anon_sym_PIPE_EQ] = ACTIONS(7532),
    [anon_sym_and_eq] = ACTIONS(7532),
    [anon_sym_or_eq] = ACTIONS(7532),
    [anon_sym_xor_eq] = ACTIONS(7532),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
  },
  [3195] = {
    [sym_identifier] = ACTIONS(2938),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2936),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_RPAREN] = ACTIONS(2936),
    [aux_sym_preproc_if_token2] = ACTIONS(2936),
    [aux_sym_preproc_else_token1] = ACTIONS(2936),
    [aux_sym_preproc_elif_token1] = ACTIONS(2938),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2936),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2936),
    [anon_sym_LPAREN2] = ACTIONS(2936),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_STAR] = ACTIONS(2938),
    [anon_sym_SLASH] = ACTIONS(2938),
    [anon_sym_PERCENT] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE] = ACTIONS(2936),
    [anon_sym_AMP_AMP] = ACTIONS(2936),
    [anon_sym_PIPE] = ACTIONS(2938),
    [anon_sym_CARET] = ACTIONS(2938),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_EQ_EQ] = ACTIONS(2936),
    [anon_sym_BANG_EQ] = ACTIONS(2936),
    [anon_sym_GT] = ACTIONS(2938),
    [anon_sym_GT_EQ] = ACTIONS(2936),
    [anon_sym_LT_EQ] = ACTIONS(2938),
    [anon_sym_LT] = ACTIONS(2938),
    [anon_sym_LT_LT] = ACTIONS(2938),
    [anon_sym_GT_GT] = ACTIONS(2938),
    [anon_sym_COLON] = ACTIONS(2936),
    [anon_sym_SEMI] = ACTIONS(2936),
    [anon_sym___attribute__] = ACTIONS(2938),
    [anon_sym___attribute] = ACTIONS(2938),
    [anon_sym_LBRACE] = ACTIONS(2936),
    [anon_sym_RBRACE] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(2936),
    [anon_sym_RBRACK] = ACTIONS(2936),
    [anon_sym_EQ] = ACTIONS(2938),
    [anon_sym_QMARK] = ACTIONS(2936),
    [anon_sym_STAR_EQ] = ACTIONS(2936),
    [anon_sym_SLASH_EQ] = ACTIONS(2936),
    [anon_sym_PERCENT_EQ] = ACTIONS(2936),
    [anon_sym_PLUS_EQ] = ACTIONS(2936),
    [anon_sym_DASH_EQ] = ACTIONS(2936),
    [anon_sym_LT_LT_EQ] = ACTIONS(2936),
    [anon_sym_GT_GT_EQ] = ACTIONS(2936),
    [anon_sym_AMP_EQ] = ACTIONS(2936),
    [anon_sym_CARET_EQ] = ACTIONS(2936),
    [anon_sym_PIPE_EQ] = ACTIONS(2936),
    [anon_sym_and_eq] = ACTIONS(2938),
    [anon_sym_or_eq] = ACTIONS(2938),
    [anon_sym_xor_eq] = ACTIONS(2938),
    [anon_sym_LT_EQ_GT] = ACTIONS(2936),
    [anon_sym_or] = ACTIONS(2938),
    [anon_sym_and] = ACTIONS(2938),
    [anon_sym_bitor] = ACTIONS(2938),
    [anon_sym_xor] = ACTIONS(2938),
    [anon_sym_bitand] = ACTIONS(2938),
    [anon_sym_not_eq] = ACTIONS(2938),
    [anon_sym_is] = ACTIONS(2938),
    [anon_sym_as] = ACTIONS(2938),
    [anon_sym_DASH_DASH] = ACTIONS(2936),
    [anon_sym_PLUS_PLUS] = ACTIONS(2936),
    [anon_sym_DOT] = ACTIONS(2938),
    [anon_sym_DOT_STAR] = ACTIONS(2936),
    [anon_sym_DASH_GT] = ACTIONS(2936),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2938),
    [anon_sym_let] = ACTIONS(2938),
    [anon_sym_This] = ACTIONS(2938),
  },
  [3196] = {
    [sym_identifier] = ACTIONS(2942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2940),
    [anon_sym_COMMA] = ACTIONS(2940),
    [anon_sym_RPAREN] = ACTIONS(2940),
    [aux_sym_preproc_if_token2] = ACTIONS(2940),
    [aux_sym_preproc_else_token1] = ACTIONS(2940),
    [aux_sym_preproc_elif_token1] = ACTIONS(2942),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2940),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2940),
    [anon_sym_LPAREN2] = ACTIONS(2940),
    [anon_sym_DASH] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(2942),
    [anon_sym_SLASH] = ACTIONS(2942),
    [anon_sym_PERCENT] = ACTIONS(2942),
    [anon_sym_PIPE_PIPE] = ACTIONS(2940),
    [anon_sym_AMP_AMP] = ACTIONS(2940),
    [anon_sym_PIPE] = ACTIONS(2942),
    [anon_sym_CARET] = ACTIONS(2942),
    [anon_sym_AMP] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2940),
    [anon_sym_BANG_EQ] = ACTIONS(2940),
    [anon_sym_GT] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2940),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_LT] = ACTIONS(2942),
    [anon_sym_LT_LT] = ACTIONS(2942),
    [anon_sym_GT_GT] = ACTIONS(2942),
    [anon_sym_COLON] = ACTIONS(2940),
    [anon_sym_SEMI] = ACTIONS(2940),
    [anon_sym___attribute__] = ACTIONS(2942),
    [anon_sym___attribute] = ACTIONS(2942),
    [anon_sym_LBRACE] = ACTIONS(2940),
    [anon_sym_RBRACE] = ACTIONS(2940),
    [anon_sym_LBRACK] = ACTIONS(2940),
    [anon_sym_RBRACK] = ACTIONS(2940),
    [anon_sym_EQ] = ACTIONS(2942),
    [anon_sym_QMARK] = ACTIONS(2940),
    [anon_sym_STAR_EQ] = ACTIONS(2940),
    [anon_sym_SLASH_EQ] = ACTIONS(2940),
    [anon_sym_PERCENT_EQ] = ACTIONS(2940),
    [anon_sym_PLUS_EQ] = ACTIONS(2940),
    [anon_sym_DASH_EQ] = ACTIONS(2940),
    [anon_sym_LT_LT_EQ] = ACTIONS(2940),
    [anon_sym_GT_GT_EQ] = ACTIONS(2940),
    [anon_sym_AMP_EQ] = ACTIONS(2940),
    [anon_sym_CARET_EQ] = ACTIONS(2940),
    [anon_sym_PIPE_EQ] = ACTIONS(2940),
    [anon_sym_and_eq] = ACTIONS(2942),
    [anon_sym_or_eq] = ACTIONS(2942),
    [anon_sym_xor_eq] = ACTIONS(2942),
    [anon_sym_LT_EQ_GT] = ACTIONS(2940),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_bitor] = ACTIONS(2942),
    [anon_sym_xor] = ACTIONS(2942),
    [anon_sym_bitand] = ACTIONS(2942),
    [anon_sym_not_eq] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_as] = ACTIONS(2942),
    [anon_sym_DASH_DASH] = ACTIONS(2940),
    [anon_sym_PLUS_PLUS] = ACTIONS(2940),
    [anon_sym_DOT] = ACTIONS(2942),
    [anon_sym_DOT_STAR] = ACTIONS(2940),
    [anon_sym_DASH_GT] = ACTIONS(2940),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2942),
    [anon_sym_let] = ACTIONS(2942),
    [anon_sym_This] = ACTIONS(2942),
  },
  [3197] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(4695),
    [sym_raw_string_literal] = STATE(3527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6839),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(2216),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2207),
    [anon_sym_SLASH_EQ] = ACTIONS(2207),
    [anon_sym_PERCENT_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_GT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_EQ] = ACTIONS(2207),
    [anon_sym_CARET_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_EQ] = ACTIONS(2207),
    [anon_sym_and_eq] = ACTIONS(2207),
    [anon_sym_or_eq] = ACTIONS(2207),
    [anon_sym_xor_eq] = ACTIONS(2207),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
  },
  [3198] = {
    [sym_attribute_declaration] = STATE(3260),
    [sym_parameter_list] = STATE(3274),
    [aux_sym_attributed_declarator_repeat1] = STATE(3260),
    [sym_identifier] = ACTIONS(7554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7556),
    [anon_sym_COMMA] = ACTIONS(7556),
    [anon_sym_RPAREN] = ACTIONS(7556),
    [aux_sym_preproc_if_token2] = ACTIONS(7556),
    [aux_sym_preproc_else_token1] = ACTIONS(7556),
    [aux_sym_preproc_elif_token1] = ACTIONS(7554),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7556),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7556),
    [anon_sym_LPAREN2] = ACTIONS(7498),
    [anon_sym_DASH] = ACTIONS(7554),
    [anon_sym_PLUS] = ACTIONS(7554),
    [anon_sym_STAR] = ACTIONS(7554),
    [anon_sym_SLASH] = ACTIONS(7554),
    [anon_sym_PERCENT] = ACTIONS(7554),
    [anon_sym_PIPE_PIPE] = ACTIONS(7556),
    [anon_sym_AMP_AMP] = ACTIONS(7556),
    [anon_sym_PIPE] = ACTIONS(7554),
    [anon_sym_CARET] = ACTIONS(7554),
    [anon_sym_AMP] = ACTIONS(7554),
    [anon_sym_EQ_EQ] = ACTIONS(7556),
    [anon_sym_BANG_EQ] = ACTIONS(7556),
    [anon_sym_GT] = ACTIONS(7554),
    [anon_sym_GT_EQ] = ACTIONS(7556),
    [anon_sym_LT_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7554),
    [anon_sym_LT_LT] = ACTIONS(7554),
    [anon_sym_GT_GT] = ACTIONS(7554),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_SEMI] = ACTIONS(7556),
    [anon_sym___attribute__] = ACTIONS(7554),
    [anon_sym___attribute] = ACTIONS(7554),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7500),
    [anon_sym_RBRACE] = ACTIONS(7556),
    [anon_sym_LBRACK] = ACTIONS(7502),
    [anon_sym_RBRACK] = ACTIONS(7556),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_QMARK] = ACTIONS(7556),
    [anon_sym_STAR_EQ] = ACTIONS(7556),
    [anon_sym_SLASH_EQ] = ACTIONS(7556),
    [anon_sym_PERCENT_EQ] = ACTIONS(7556),
    [anon_sym_PLUS_EQ] = ACTIONS(7556),
    [anon_sym_DASH_EQ] = ACTIONS(7556),
    [anon_sym_LT_LT_EQ] = ACTIONS(7556),
    [anon_sym_GT_GT_EQ] = ACTIONS(7556),
    [anon_sym_AMP_EQ] = ACTIONS(7556),
    [anon_sym_CARET_EQ] = ACTIONS(7556),
    [anon_sym_PIPE_EQ] = ACTIONS(7556),
    [anon_sym_and_eq] = ACTIONS(7554),
    [anon_sym_or_eq] = ACTIONS(7554),
    [anon_sym_xor_eq] = ACTIONS(7554),
    [anon_sym_LT_EQ_GT] = ACTIONS(7556),
    [anon_sym_or] = ACTIONS(7554),
    [anon_sym_and] = ACTIONS(7554),
    [anon_sym_bitor] = ACTIONS(7554),
    [anon_sym_xor] = ACTIONS(7554),
    [anon_sym_bitand] = ACTIONS(7554),
    [anon_sym_not_eq] = ACTIONS(7554),
    [anon_sym_is] = ACTIONS(7554),
    [anon_sym_as] = ACTIONS(7554),
    [anon_sym_DASH_DASH] = ACTIONS(7556),
    [anon_sym_PLUS_PLUS] = ACTIONS(7556),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_DOT_STAR] = ACTIONS(7556),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [sym_comment] = ACTIONS(3),
  },
  [3199] = {
    [sym_identifier] = ACTIONS(2994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(2992),
    [anon_sym_RPAREN] = ACTIONS(2992),
    [aux_sym_preproc_if_token2] = ACTIONS(2992),
    [aux_sym_preproc_else_token1] = ACTIONS(2992),
    [aux_sym_preproc_elif_token1] = ACTIONS(2994),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2992),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2992),
    [anon_sym_LPAREN2] = ACTIONS(2992),
    [anon_sym_DASH] = ACTIONS(2994),
    [anon_sym_PLUS] = ACTIONS(2994),
    [anon_sym_STAR] = ACTIONS(2994),
    [anon_sym_SLASH] = ACTIONS(2994),
    [anon_sym_PERCENT] = ACTIONS(2994),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_PIPE] = ACTIONS(2994),
    [anon_sym_CARET] = ACTIONS(2994),
    [anon_sym_AMP] = ACTIONS(2994),
    [anon_sym_EQ_EQ] = ACTIONS(2992),
    [anon_sym_BANG_EQ] = ACTIONS(2992),
    [anon_sym_GT] = ACTIONS(2994),
    [anon_sym_GT_EQ] = ACTIONS(2992),
    [anon_sym_LT_EQ] = ACTIONS(2994),
    [anon_sym_LT] = ACTIONS(2994),
    [anon_sym_LT_LT] = ACTIONS(2994),
    [anon_sym_GT_GT] = ACTIONS(2994),
    [anon_sym_COLON] = ACTIONS(2992),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym___attribute__] = ACTIONS(2994),
    [anon_sym___attribute] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_RBRACE] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_RBRACK] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(2994),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_STAR_EQ] = ACTIONS(2992),
    [anon_sym_SLASH_EQ] = ACTIONS(2992),
    [anon_sym_PERCENT_EQ] = ACTIONS(2992),
    [anon_sym_PLUS_EQ] = ACTIONS(2992),
    [anon_sym_DASH_EQ] = ACTIONS(2992),
    [anon_sym_LT_LT_EQ] = ACTIONS(2992),
    [anon_sym_GT_GT_EQ] = ACTIONS(2992),
    [anon_sym_AMP_EQ] = ACTIONS(2992),
    [anon_sym_CARET_EQ] = ACTIONS(2992),
    [anon_sym_PIPE_EQ] = ACTIONS(2992),
    [anon_sym_and_eq] = ACTIONS(2994),
    [anon_sym_or_eq] = ACTIONS(2994),
    [anon_sym_xor_eq] = ACTIONS(2994),
    [anon_sym_LT_EQ_GT] = ACTIONS(2992),
    [anon_sym_or] = ACTIONS(2994),
    [anon_sym_and] = ACTIONS(2994),
    [anon_sym_bitor] = ACTIONS(2994),
    [anon_sym_xor] = ACTIONS(2994),
    [anon_sym_bitand] = ACTIONS(2994),
    [anon_sym_not_eq] = ACTIONS(2994),
    [anon_sym_is] = ACTIONS(2994),
    [anon_sym_as] = ACTIONS(2994),
    [anon_sym_DASH_DASH] = ACTIONS(2992),
    [anon_sym_PLUS_PLUS] = ACTIONS(2992),
    [anon_sym_DOT] = ACTIONS(2994),
    [anon_sym_DOT_STAR] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(2992),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2994),
    [anon_sym_let] = ACTIONS(2994),
    [anon_sym_This] = ACTIONS(2994),
  },
  [3200] = {
    [sym_identifier] = ACTIONS(2998),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2996),
    [anon_sym_COMMA] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(2996),
    [aux_sym_preproc_if_token2] = ACTIONS(2996),
    [aux_sym_preproc_else_token1] = ACTIONS(2996),
    [aux_sym_preproc_elif_token1] = ACTIONS(2998),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2996),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2996),
    [anon_sym_LPAREN2] = ACTIONS(2996),
    [anon_sym_DASH] = ACTIONS(2998),
    [anon_sym_PLUS] = ACTIONS(2998),
    [anon_sym_STAR] = ACTIONS(2998),
    [anon_sym_SLASH] = ACTIONS(2998),
    [anon_sym_PERCENT] = ACTIONS(2998),
    [anon_sym_PIPE_PIPE] = ACTIONS(2996),
    [anon_sym_AMP_AMP] = ACTIONS(2996),
    [anon_sym_PIPE] = ACTIONS(2998),
    [anon_sym_CARET] = ACTIONS(2998),
    [anon_sym_AMP] = ACTIONS(2998),
    [anon_sym_EQ_EQ] = ACTIONS(2996),
    [anon_sym_BANG_EQ] = ACTIONS(2996),
    [anon_sym_GT] = ACTIONS(2998),
    [anon_sym_GT_EQ] = ACTIONS(2996),
    [anon_sym_LT_EQ] = ACTIONS(2998),
    [anon_sym_LT] = ACTIONS(2998),
    [anon_sym_LT_LT] = ACTIONS(2998),
    [anon_sym_GT_GT] = ACTIONS(2998),
    [anon_sym_COLON] = ACTIONS(2996),
    [anon_sym_SEMI] = ACTIONS(2996),
    [anon_sym___attribute__] = ACTIONS(2998),
    [anon_sym___attribute] = ACTIONS(2998),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_RBRACE] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_RBRACK] = ACTIONS(2996),
    [anon_sym_EQ] = ACTIONS(2998),
    [anon_sym_QMARK] = ACTIONS(2996),
    [anon_sym_STAR_EQ] = ACTIONS(2996),
    [anon_sym_SLASH_EQ] = ACTIONS(2996),
    [anon_sym_PERCENT_EQ] = ACTIONS(2996),
    [anon_sym_PLUS_EQ] = ACTIONS(2996),
    [anon_sym_DASH_EQ] = ACTIONS(2996),
    [anon_sym_LT_LT_EQ] = ACTIONS(2996),
    [anon_sym_GT_GT_EQ] = ACTIONS(2996),
    [anon_sym_AMP_EQ] = ACTIONS(2996),
    [anon_sym_CARET_EQ] = ACTIONS(2996),
    [anon_sym_PIPE_EQ] = ACTIONS(2996),
    [anon_sym_and_eq] = ACTIONS(2998),
    [anon_sym_or_eq] = ACTIONS(2998),
    [anon_sym_xor_eq] = ACTIONS(2998),
    [anon_sym_LT_EQ_GT] = ACTIONS(2996),
    [anon_sym_or] = ACTIONS(2998),
    [anon_sym_and] = ACTIONS(2998),
    [anon_sym_bitor] = ACTIONS(2998),
    [anon_sym_xor] = ACTIONS(2998),
    [anon_sym_bitand] = ACTIONS(2998),
    [anon_sym_not_eq] = ACTIONS(2998),
    [anon_sym_is] = ACTIONS(2998),
    [anon_sym_as] = ACTIONS(2998),
    [anon_sym_DASH_DASH] = ACTIONS(2996),
    [anon_sym_PLUS_PLUS] = ACTIONS(2996),
    [anon_sym_DOT] = ACTIONS(2998),
    [anon_sym_DOT_STAR] = ACTIONS(2996),
    [anon_sym_DASH_GT] = ACTIONS(2996),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2998),
    [anon_sym_let] = ACTIONS(2998),
    [anon_sym_This] = ACTIONS(2998),
  },
  [3201] = {
    [sym_attribute_declaration] = STATE(3260),
    [sym_parameter_list] = STATE(3274),
    [aux_sym_attributed_declarator_repeat1] = STATE(3260),
    [sym_identifier] = ACTIONS(7558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7560),
    [anon_sym_COMMA] = ACTIONS(7560),
    [anon_sym_RPAREN] = ACTIONS(7560),
    [aux_sym_preproc_if_token2] = ACTIONS(7560),
    [aux_sym_preproc_else_token1] = ACTIONS(7560),
    [aux_sym_preproc_elif_token1] = ACTIONS(7558),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7560),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7560),
    [anon_sym_LPAREN2] = ACTIONS(7498),
    [anon_sym_DASH] = ACTIONS(7558),
    [anon_sym_PLUS] = ACTIONS(7558),
    [anon_sym_STAR] = ACTIONS(7558),
    [anon_sym_SLASH] = ACTIONS(7558),
    [anon_sym_PERCENT] = ACTIONS(7558),
    [anon_sym_PIPE_PIPE] = ACTIONS(7560),
    [anon_sym_AMP_AMP] = ACTIONS(7560),
    [anon_sym_PIPE] = ACTIONS(7558),
    [anon_sym_CARET] = ACTIONS(7558),
    [anon_sym_AMP] = ACTIONS(7558),
    [anon_sym_EQ_EQ] = ACTIONS(7560),
    [anon_sym_BANG_EQ] = ACTIONS(7560),
    [anon_sym_GT] = ACTIONS(7558),
    [anon_sym_GT_EQ] = ACTIONS(7560),
    [anon_sym_LT_EQ] = ACTIONS(7558),
    [anon_sym_LT] = ACTIONS(7558),
    [anon_sym_LT_LT] = ACTIONS(7558),
    [anon_sym_GT_GT] = ACTIONS(7558),
    [anon_sym_COLON] = ACTIONS(7560),
    [anon_sym_SEMI] = ACTIONS(7560),
    [anon_sym___attribute__] = ACTIONS(7558),
    [anon_sym___attribute] = ACTIONS(7558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7500),
    [anon_sym_RBRACE] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7502),
    [anon_sym_RBRACK] = ACTIONS(7560),
    [anon_sym_EQ] = ACTIONS(7558),
    [anon_sym_QMARK] = ACTIONS(7560),
    [anon_sym_STAR_EQ] = ACTIONS(7560),
    [anon_sym_SLASH_EQ] = ACTIONS(7560),
    [anon_sym_PERCENT_EQ] = ACTIONS(7560),
    [anon_sym_PLUS_EQ] = ACTIONS(7560),
    [anon_sym_DASH_EQ] = ACTIONS(7560),
    [anon_sym_LT_LT_EQ] = ACTIONS(7560),
    [anon_sym_GT_GT_EQ] = ACTIONS(7560),
    [anon_sym_AMP_EQ] = ACTIONS(7560),
    [anon_sym_CARET_EQ] = ACTIONS(7560),
    [anon_sym_PIPE_EQ] = ACTIONS(7560),
    [anon_sym_and_eq] = ACTIONS(7558),
    [anon_sym_or_eq] = ACTIONS(7558),
    [anon_sym_xor_eq] = ACTIONS(7558),
    [anon_sym_LT_EQ_GT] = ACTIONS(7560),
    [anon_sym_or] = ACTIONS(7558),
    [anon_sym_and] = ACTIONS(7558),
    [anon_sym_bitor] = ACTIONS(7558),
    [anon_sym_xor] = ACTIONS(7558),
    [anon_sym_bitand] = ACTIONS(7558),
    [anon_sym_not_eq] = ACTIONS(7558),
    [anon_sym_is] = ACTIONS(7558),
    [anon_sym_as] = ACTIONS(7558),
    [anon_sym_DASH_DASH] = ACTIONS(7560),
    [anon_sym_PLUS_PLUS] = ACTIONS(7560),
    [anon_sym_DOT] = ACTIONS(7558),
    [anon_sym_DOT_STAR] = ACTIONS(7560),
    [anon_sym_DASH_GT] = ACTIONS(7560),
    [sym_comment] = ACTIONS(3),
  },
  [3202] = {
    [sym_ms_based_modifier] = STATE(10947),
    [sym_ms_unaligned_ptr_modifier] = STATE(5091),
    [sym_ms_pointer_modifier] = STATE(3203),
    [sym__declarator] = STATE(7998),
    [sym__abstract_declarator] = STATE(8610),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_abstract_parenthesized_declarator] = STATE(7454),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_abstract_pointer_declarator] = STATE(7454),
    [sym_function_declarator] = STATE(8054),
    [sym_abstract_function_declarator] = STATE(7454),
    [sym_array_declarator] = STATE(8054),
    [sym_abstract_array_declarator] = STATE(7454),
    [sym_type_qualifier] = STATE(3606),
    [sym_alignas_qualifier] = STATE(5539),
    [sym_parameter_list] = STATE(4273),
    [sym_decltype] = STATE(11339),
    [sym_reference_declarator] = STATE(8054),
    [sym_abstract_reference_declarator] = STATE(7454),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym__function_declarator_seq] = STATE(7543),
    [sym_template_type] = STATE(11339),
    [sym_template_function] = STATE(8054),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7400),
    [sym_qualified_identifier] = STATE(8054),
    [sym_operator_name] = STATE(8054),
    [aux_sym__type_definition_type_repeat1] = STATE(3606),
    [aux_sym_pointer_declarator_repeat1] = STATE(3203),
    [sym_identifier] = ACTIONS(7394),
    [anon_sym_COMMA] = ACTIONS(7396),
    [anon_sym_RPAREN] = ACTIONS(7396),
    [anon_sym_LPAREN2] = ACTIONS(5344),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(7562),
    [anon_sym_AMP_AMP] = ACTIONS(7564),
    [anon_sym_AMP] = ACTIONS(7566),
    [anon_sym_COLON] = ACTIONS(7404),
    [anon_sym___extension__] = ACTIONS(5368),
    [anon_sym___attribute__] = ACTIONS(7404),
    [anon_sym___attribute] = ACTIONS(7404),
    [anon_sym_COLON_COLON] = ACTIONS(7406),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(5364),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(5364),
    [sym_ms_signed_ptr_modifier] = ACTIONS(5364),
    [anon_sym__unaligned] = ACTIONS(5366),
    [anon_sym___unaligned] = ACTIONS(5366),
    [anon_sym_LBRACK] = ACTIONS(7408),
    [anon_sym_const] = ACTIONS(5368),
    [anon_sym_constexpr] = ACTIONS(5368),
    [anon_sym_volatile] = ACTIONS(5368),
    [anon_sym_restrict] = ACTIONS(5368),
    [anon_sym___restrict__] = ACTIONS(5368),
    [anon_sym__Atomic] = ACTIONS(5368),
    [anon_sym__Noreturn] = ACTIONS(5368),
    [anon_sym_noreturn] = ACTIONS(5368),
    [anon_sym__Nonnull] = ACTIONS(5368),
    [anon_sym_mutable] = ACTIONS(5368),
    [anon_sym_constinit] = ACTIONS(5368),
    [anon_sym_consteval] = ACTIONS(5368),
    [anon_sym_alignas] = ACTIONS(5370),
    [anon_sym__Alignas] = ACTIONS(5370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(2861),
  },
  [3203] = {
    [sym_ms_based_modifier] = STATE(10947),
    [sym_ms_unaligned_ptr_modifier] = STATE(5091),
    [sym_ms_pointer_modifier] = STATE(4976),
    [sym__declarator] = STATE(7901),
    [sym__abstract_declarator] = STATE(8675),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_abstract_parenthesized_declarator] = STATE(7454),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_abstract_pointer_declarator] = STATE(7454),
    [sym_function_declarator] = STATE(8054),
    [sym_abstract_function_declarator] = STATE(7454),
    [sym_array_declarator] = STATE(8054),
    [sym_abstract_array_declarator] = STATE(7454),
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(5539),
    [sym_parameter_list] = STATE(4273),
    [sym_decltype] = STATE(11339),
    [sym_reference_declarator] = STATE(8054),
    [sym_abstract_reference_declarator] = STATE(7454),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym__function_declarator_seq] = STATE(7543),
    [sym_template_type] = STATE(11339),
    [sym_template_function] = STATE(8054),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7400),
    [sym_qualified_identifier] = STATE(8054),
    [sym_operator_name] = STATE(8054),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_pointer_declarator_repeat1] = STATE(4976),
    [sym_identifier] = ACTIONS(7394),
    [anon_sym_COMMA] = ACTIONS(7410),
    [anon_sym_RPAREN] = ACTIONS(7410),
    [anon_sym_LPAREN2] = ACTIONS(5344),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(7562),
    [anon_sym_AMP_AMP] = ACTIONS(7564),
    [anon_sym_AMP] = ACTIONS(7566),
    [anon_sym_COLON] = ACTIONS(7412),
    [anon_sym___extension__] = ACTIONS(5368),
    [anon_sym___attribute__] = ACTIONS(7412),
    [anon_sym___attribute] = ACTIONS(7412),
    [anon_sym_COLON_COLON] = ACTIONS(7406),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(5364),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(5364),
    [sym_ms_signed_ptr_modifier] = ACTIONS(5364),
    [anon_sym__unaligned] = ACTIONS(5366),
    [anon_sym___unaligned] = ACTIONS(5366),
    [anon_sym_LBRACK] = ACTIONS(7408),
    [anon_sym_const] = ACTIONS(5368),
    [anon_sym_constexpr] = ACTIONS(5368),
    [anon_sym_volatile] = ACTIONS(5368),
    [anon_sym_restrict] = ACTIONS(5368),
    [anon_sym___restrict__] = ACTIONS(5368),
    [anon_sym__Atomic] = ACTIONS(5368),
    [anon_sym__Noreturn] = ACTIONS(5368),
    [anon_sym_noreturn] = ACTIONS(5368),
    [anon_sym__Nonnull] = ACTIONS(5368),
    [anon_sym_mutable] = ACTIONS(5368),
    [anon_sym_constinit] = ACTIONS(5368),
    [anon_sym_consteval] = ACTIONS(5368),
    [anon_sym_alignas] = ACTIONS(5370),
    [anon_sym__Alignas] = ACTIONS(5370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(2861),
  },
  [3204] = {
    [sym_identifier] = ACTIONS(2948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2946),
    [anon_sym_COMMA] = ACTIONS(2946),
    [anon_sym_RPAREN] = ACTIONS(2946),
    [aux_sym_preproc_if_token2] = ACTIONS(2946),
    [aux_sym_preproc_else_token1] = ACTIONS(2946),
    [aux_sym_preproc_elif_token1] = ACTIONS(2948),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2948),
    [anon_sym_PLUS] = ACTIONS(2948),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_SLASH] = ACTIONS(2948),
    [anon_sym_PERCENT] = ACTIONS(2948),
    [anon_sym_PIPE_PIPE] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_PIPE] = ACTIONS(2948),
    [anon_sym_CARET] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_EQ_EQ] = ACTIONS(2946),
    [anon_sym_BANG_EQ] = ACTIONS(2946),
    [anon_sym_GT] = ACTIONS(2948),
    [anon_sym_GT_EQ] = ACTIONS(2946),
    [anon_sym_LT_EQ] = ACTIONS(2948),
    [anon_sym_LT] = ACTIONS(2948),
    [anon_sym_LT_LT] = ACTIONS(2948),
    [anon_sym_GT_GT] = ACTIONS(2948),
    [anon_sym_COLON] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym___attribute__] = ACTIONS(2948),
    [anon_sym___attribute] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_RBRACE] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_RBRACK] = ACTIONS(2946),
    [anon_sym_EQ] = ACTIONS(2948),
    [anon_sym_QMARK] = ACTIONS(2946),
    [anon_sym_STAR_EQ] = ACTIONS(2946),
    [anon_sym_SLASH_EQ] = ACTIONS(2946),
    [anon_sym_PERCENT_EQ] = ACTIONS(2946),
    [anon_sym_PLUS_EQ] = ACTIONS(2946),
    [anon_sym_DASH_EQ] = ACTIONS(2946),
    [anon_sym_LT_LT_EQ] = ACTIONS(2946),
    [anon_sym_GT_GT_EQ] = ACTIONS(2946),
    [anon_sym_AMP_EQ] = ACTIONS(2946),
    [anon_sym_CARET_EQ] = ACTIONS(2946),
    [anon_sym_PIPE_EQ] = ACTIONS(2946),
    [anon_sym_and_eq] = ACTIONS(2948),
    [anon_sym_or_eq] = ACTIONS(2948),
    [anon_sym_xor_eq] = ACTIONS(2948),
    [anon_sym_LT_EQ_GT] = ACTIONS(2946),
    [anon_sym_or] = ACTIONS(2948),
    [anon_sym_and] = ACTIONS(2948),
    [anon_sym_bitor] = ACTIONS(2948),
    [anon_sym_xor] = ACTIONS(2948),
    [anon_sym_bitand] = ACTIONS(2948),
    [anon_sym_not_eq] = ACTIONS(2948),
    [anon_sym_is] = ACTIONS(2948),
    [anon_sym_as] = ACTIONS(2948),
    [anon_sym_DASH_DASH] = ACTIONS(2946),
    [anon_sym_PLUS_PLUS] = ACTIONS(2946),
    [anon_sym_DOT] = ACTIONS(2948),
    [anon_sym_DOT_STAR] = ACTIONS(2946),
    [anon_sym_DASH_GT] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2948),
    [anon_sym_let] = ACTIONS(2948),
    [anon_sym_This] = ACTIONS(2948),
  },
  [3205] = {
    [sym_identifier] = ACTIONS(2952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2950),
    [anon_sym_COMMA] = ACTIONS(2950),
    [anon_sym_RPAREN] = ACTIONS(2950),
    [aux_sym_preproc_if_token2] = ACTIONS(2950),
    [aux_sym_preproc_else_token1] = ACTIONS(2950),
    [aux_sym_preproc_elif_token1] = ACTIONS(2952),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2950),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2952),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_STAR] = ACTIONS(2952),
    [anon_sym_SLASH] = ACTIONS(2952),
    [anon_sym_PERCENT] = ACTIONS(2952),
    [anon_sym_PIPE_PIPE] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_PIPE] = ACTIONS(2952),
    [anon_sym_CARET] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2952),
    [anon_sym_EQ_EQ] = ACTIONS(2950),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_GT] = ACTIONS(2952),
    [anon_sym_GT_EQ] = ACTIONS(2950),
    [anon_sym_LT_EQ] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_LT_LT] = ACTIONS(2952),
    [anon_sym_GT_GT] = ACTIONS(2952),
    [anon_sym_COLON] = ACTIONS(2950),
    [anon_sym_SEMI] = ACTIONS(2950),
    [anon_sym___attribute__] = ACTIONS(2952),
    [anon_sym___attribute] = ACTIONS(2952),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_RBRACE] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_RBRACK] = ACTIONS(2950),
    [anon_sym_EQ] = ACTIONS(2952),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_STAR_EQ] = ACTIONS(2950),
    [anon_sym_SLASH_EQ] = ACTIONS(2950),
    [anon_sym_PERCENT_EQ] = ACTIONS(2950),
    [anon_sym_PLUS_EQ] = ACTIONS(2950),
    [anon_sym_DASH_EQ] = ACTIONS(2950),
    [anon_sym_LT_LT_EQ] = ACTIONS(2950),
    [anon_sym_GT_GT_EQ] = ACTIONS(2950),
    [anon_sym_AMP_EQ] = ACTIONS(2950),
    [anon_sym_CARET_EQ] = ACTIONS(2950),
    [anon_sym_PIPE_EQ] = ACTIONS(2950),
    [anon_sym_and_eq] = ACTIONS(2952),
    [anon_sym_or_eq] = ACTIONS(2952),
    [anon_sym_xor_eq] = ACTIONS(2952),
    [anon_sym_LT_EQ_GT] = ACTIONS(2950),
    [anon_sym_or] = ACTIONS(2952),
    [anon_sym_and] = ACTIONS(2952),
    [anon_sym_bitor] = ACTIONS(2952),
    [anon_sym_xor] = ACTIONS(2952),
    [anon_sym_bitand] = ACTIONS(2952),
    [anon_sym_not_eq] = ACTIONS(2952),
    [anon_sym_is] = ACTIONS(2952),
    [anon_sym_as] = ACTIONS(2952),
    [anon_sym_DASH_DASH] = ACTIONS(2950),
    [anon_sym_PLUS_PLUS] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2952),
    [anon_sym_DOT_STAR] = ACTIONS(2950),
    [anon_sym_DASH_GT] = ACTIONS(2950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2952),
    [anon_sym_let] = ACTIONS(2952),
    [anon_sym_This] = ACTIONS(2952),
  },
  [3206] = {
    [sym_identifier] = ACTIONS(3054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3052),
    [anon_sym_COMMA] = ACTIONS(3052),
    [anon_sym_RPAREN] = ACTIONS(3052),
    [aux_sym_preproc_if_token2] = ACTIONS(3052),
    [aux_sym_preproc_else_token1] = ACTIONS(3052),
    [aux_sym_preproc_elif_token1] = ACTIONS(3054),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3052),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3052),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3054),
    [anon_sym_SLASH] = ACTIONS(3054),
    [anon_sym_PERCENT] = ACTIONS(3054),
    [anon_sym_PIPE_PIPE] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_PIPE] = ACTIONS(3054),
    [anon_sym_CARET] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_EQ_EQ] = ACTIONS(3052),
    [anon_sym_BANG_EQ] = ACTIONS(3052),
    [anon_sym_GT] = ACTIONS(3054),
    [anon_sym_GT_EQ] = ACTIONS(3052),
    [anon_sym_LT_EQ] = ACTIONS(3054),
    [anon_sym_LT] = ACTIONS(3054),
    [anon_sym_LT_LT] = ACTIONS(3054),
    [anon_sym_GT_GT] = ACTIONS(3054),
    [anon_sym_COLON] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___attribute__] = ACTIONS(3054),
    [anon_sym___attribute] = ACTIONS(3054),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_RBRACE] = ACTIONS(3052),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [anon_sym_RBRACK] = ACTIONS(3052),
    [anon_sym_EQ] = ACTIONS(3054),
    [anon_sym_QMARK] = ACTIONS(3052),
    [anon_sym_STAR_EQ] = ACTIONS(3052),
    [anon_sym_SLASH_EQ] = ACTIONS(3052),
    [anon_sym_PERCENT_EQ] = ACTIONS(3052),
    [anon_sym_PLUS_EQ] = ACTIONS(3052),
    [anon_sym_DASH_EQ] = ACTIONS(3052),
    [anon_sym_LT_LT_EQ] = ACTIONS(3052),
    [anon_sym_GT_GT_EQ] = ACTIONS(3052),
    [anon_sym_AMP_EQ] = ACTIONS(3052),
    [anon_sym_CARET_EQ] = ACTIONS(3052),
    [anon_sym_PIPE_EQ] = ACTIONS(3052),
    [anon_sym_and_eq] = ACTIONS(3054),
    [anon_sym_or_eq] = ACTIONS(3054),
    [anon_sym_xor_eq] = ACTIONS(3054),
    [anon_sym_LT_EQ_GT] = ACTIONS(3052),
    [anon_sym_or] = ACTIONS(3054),
    [anon_sym_and] = ACTIONS(3054),
    [anon_sym_bitor] = ACTIONS(3054),
    [anon_sym_xor] = ACTIONS(3054),
    [anon_sym_bitand] = ACTIONS(3054),
    [anon_sym_not_eq] = ACTIONS(3054),
    [anon_sym_is] = ACTIONS(3054),
    [anon_sym_as] = ACTIONS(3054),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_DOT] = ACTIONS(3054),
    [anon_sym_DOT_STAR] = ACTIONS(3052),
    [anon_sym_DASH_GT] = ACTIONS(3052),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3054),
    [anon_sym_let] = ACTIONS(3054),
    [anon_sym_This] = ACTIONS(3054),
  },
  [3207] = {
    [sym_attribute_specifier] = STATE(2854),
    [sym_enumerator_list] = STATE(2824),
    [sym__enum_base_clause] = STATE(2783),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(7568),
    [anon_sym_SEMI] = ACTIONS(3480),
    [anon_sym___extension__] = ACTIONS(3478),
    [anon_sym_in] = ACTIONS(3478),
    [anon_sym_out] = ACTIONS(3478),
    [anon_sym_inout] = ACTIONS(3478),
    [anon_sym_virtual] = ACTIONS(3478),
    [anon_sym_extern] = ACTIONS(3478),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3480),
    [anon_sym___declspec] = ACTIONS(3478),
    [anon_sym___based] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(6963),
    [anon_sym_static] = ACTIONS(3478),
    [anon_sym_register] = ACTIONS(3478),
    [anon_sym_inline] = ACTIONS(3478),
    [anon_sym___inline] = ACTIONS(3478),
    [anon_sym___inline__] = ACTIONS(3478),
    [anon_sym___forceinline] = ACTIONS(3478),
    [anon_sym_thread_local] = ACTIONS(3478),
    [anon_sym___thread] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(3478),
    [anon_sym_constexpr] = ACTIONS(3478),
    [anon_sym_volatile] = ACTIONS(3478),
    [anon_sym_restrict] = ACTIONS(3478),
    [anon_sym___restrict__] = ACTIONS(3478),
    [anon_sym__Atomic] = ACTIONS(3478),
    [anon_sym__Noreturn] = ACTIONS(3478),
    [anon_sym_noreturn] = ACTIONS(3478),
    [anon_sym__Nonnull] = ACTIONS(3478),
    [anon_sym_mutable] = ACTIONS(3478),
    [anon_sym_constinit] = ACTIONS(3478),
    [anon_sym_consteval] = ACTIONS(3478),
    [anon_sym_alignas] = ACTIONS(3478),
    [anon_sym__Alignas] = ACTIONS(3478),
    [anon_sym_DOT] = ACTIONS(3480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3478),
    [anon_sym_let] = ACTIONS(3478),
    [anon_sym_This] = ACTIONS(3478),
    [anon_sym_operator] = ACTIONS(3478),
    [anon_sym_precise] = ACTIONS(3478),
    [anon_sym_shared] = ACTIONS(3478),
    [anon_sym_groupshared] = ACTIONS(3478),
    [anon_sym_uniform] = ACTIONS(3478),
    [anon_sym_row_major] = ACTIONS(3478),
    [anon_sym_column_major] = ACTIONS(3478),
    [anon_sym_globallycoherent] = ACTIONS(3478),
    [anon_sym_centroid] = ACTIONS(3478),
    [anon_sym_noperspective] = ACTIONS(3478),
    [anon_sym_nointerpolation] = ACTIONS(3478),
    [anon_sym_sample] = ACTIONS(3478),
    [anon_sym_linear] = ACTIONS(3478),
    [anon_sym_snorm] = ACTIONS(3478),
    [anon_sym_unorm] = ACTIONS(3478),
    [anon_sym_point] = ACTIONS(3478),
    [anon_sym_line] = ACTIONS(3478),
    [anon_sym_triangleadj] = ACTIONS(3478),
    [anon_sym_lineadj] = ACTIONS(3478),
    [anon_sym_triangle] = ACTIONS(3478),
  },
  [3208] = {
    [sym_attribute_specifier] = STATE(2904),
    [sym_enumerator_list] = STATE(2833),
    [sym__enum_base_clause] = STATE(2784),
    [sym_identifier] = ACTIONS(3502),
    [anon_sym_LPAREN2] = ACTIONS(3504),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_AMP_AMP] = ACTIONS(3504),
    [anon_sym_AMP] = ACTIONS(3502),
    [anon_sym_COLON] = ACTIONS(7568),
    [anon_sym_SEMI] = ACTIONS(3504),
    [anon_sym___extension__] = ACTIONS(3502),
    [anon_sym_in] = ACTIONS(3502),
    [anon_sym_out] = ACTIONS(3502),
    [anon_sym_inout] = ACTIONS(3502),
    [anon_sym_virtual] = ACTIONS(3502),
    [anon_sym_extern] = ACTIONS(3502),
    [anon_sym___attribute__] = ACTIONS(6726),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3504),
    [anon_sym___declspec] = ACTIONS(3502),
    [anon_sym___based] = ACTIONS(3502),
    [anon_sym_LBRACE] = ACTIONS(6963),
    [anon_sym_static] = ACTIONS(3502),
    [anon_sym_register] = ACTIONS(3502),
    [anon_sym_inline] = ACTIONS(3502),
    [anon_sym___inline] = ACTIONS(3502),
    [anon_sym___inline__] = ACTIONS(3502),
    [anon_sym___forceinline] = ACTIONS(3502),
    [anon_sym_thread_local] = ACTIONS(3502),
    [anon_sym___thread] = ACTIONS(3502),
    [anon_sym_const] = ACTIONS(3502),
    [anon_sym_constexpr] = ACTIONS(3502),
    [anon_sym_volatile] = ACTIONS(3502),
    [anon_sym_restrict] = ACTIONS(3502),
    [anon_sym___restrict__] = ACTIONS(3502),
    [anon_sym__Atomic] = ACTIONS(3502),
    [anon_sym__Noreturn] = ACTIONS(3502),
    [anon_sym_noreturn] = ACTIONS(3502),
    [anon_sym__Nonnull] = ACTIONS(3502),
    [anon_sym_mutable] = ACTIONS(3502),
    [anon_sym_constinit] = ACTIONS(3502),
    [anon_sym_consteval] = ACTIONS(3502),
    [anon_sym_alignas] = ACTIONS(3502),
    [anon_sym__Alignas] = ACTIONS(3502),
    [anon_sym_DOT] = ACTIONS(3504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3502),
    [anon_sym_let] = ACTIONS(3502),
    [anon_sym_This] = ACTIONS(3502),
    [anon_sym_operator] = ACTIONS(3502),
    [anon_sym_precise] = ACTIONS(3502),
    [anon_sym_shared] = ACTIONS(3502),
    [anon_sym_groupshared] = ACTIONS(3502),
    [anon_sym_uniform] = ACTIONS(3502),
    [anon_sym_row_major] = ACTIONS(3502),
    [anon_sym_column_major] = ACTIONS(3502),
    [anon_sym_globallycoherent] = ACTIONS(3502),
    [anon_sym_centroid] = ACTIONS(3502),
    [anon_sym_noperspective] = ACTIONS(3502),
    [anon_sym_nointerpolation] = ACTIONS(3502),
    [anon_sym_sample] = ACTIONS(3502),
    [anon_sym_linear] = ACTIONS(3502),
    [anon_sym_snorm] = ACTIONS(3502),
    [anon_sym_unorm] = ACTIONS(3502),
    [anon_sym_point] = ACTIONS(3502),
    [anon_sym_line] = ACTIONS(3502),
    [anon_sym_triangleadj] = ACTIONS(3502),
    [anon_sym_lineadj] = ACTIONS(3502),
    [anon_sym_triangle] = ACTIONS(3502),
  },
  [3209] = {
    [sym_identifier] = ACTIONS(2550),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2548),
    [anon_sym_COMMA] = ACTIONS(2548),
    [anon_sym_RPAREN] = ACTIONS(2548),
    [aux_sym_preproc_if_token2] = ACTIONS(2548),
    [aux_sym_preproc_else_token1] = ACTIONS(2548),
    [aux_sym_preproc_elif_token1] = ACTIONS(2550),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2548),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2548),
    [anon_sym_LPAREN2] = ACTIONS(2548),
    [anon_sym_DASH] = ACTIONS(2550),
    [anon_sym_PLUS] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(2550),
    [anon_sym_SLASH] = ACTIONS(2550),
    [anon_sym_PERCENT] = ACTIONS(2550),
    [anon_sym_PIPE_PIPE] = ACTIONS(2548),
    [anon_sym_AMP_AMP] = ACTIONS(2548),
    [anon_sym_PIPE] = ACTIONS(2550),
    [anon_sym_CARET] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2550),
    [anon_sym_EQ_EQ] = ACTIONS(2548),
    [anon_sym_BANG_EQ] = ACTIONS(2548),
    [anon_sym_GT] = ACTIONS(2550),
    [anon_sym_GT_EQ] = ACTIONS(2548),
    [anon_sym_LT_EQ] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(2550),
    [anon_sym_LT_LT] = ACTIONS(2550),
    [anon_sym_GT_GT] = ACTIONS(2550),
    [anon_sym_COLON] = ACTIONS(2548),
    [anon_sym_SEMI] = ACTIONS(2548),
    [anon_sym___attribute__] = ACTIONS(2550),
    [anon_sym___attribute] = ACTIONS(2550),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_RBRACE] = ACTIONS(2548),
    [anon_sym_LBRACK] = ACTIONS(2548),
    [anon_sym_RBRACK] = ACTIONS(2548),
    [anon_sym_EQ] = ACTIONS(2550),
    [anon_sym_QMARK] = ACTIONS(2548),
    [anon_sym_STAR_EQ] = ACTIONS(2548),
    [anon_sym_SLASH_EQ] = ACTIONS(2548),
    [anon_sym_PERCENT_EQ] = ACTIONS(2548),
    [anon_sym_PLUS_EQ] = ACTIONS(2548),
    [anon_sym_DASH_EQ] = ACTIONS(2548),
    [anon_sym_LT_LT_EQ] = ACTIONS(2548),
    [anon_sym_GT_GT_EQ] = ACTIONS(2548),
    [anon_sym_AMP_EQ] = ACTIONS(2548),
    [anon_sym_CARET_EQ] = ACTIONS(2548),
    [anon_sym_PIPE_EQ] = ACTIONS(2548),
    [anon_sym_and_eq] = ACTIONS(2550),
    [anon_sym_or_eq] = ACTIONS(2550),
    [anon_sym_xor_eq] = ACTIONS(2550),
    [anon_sym_LT_EQ_GT] = ACTIONS(2548),
    [anon_sym_or] = ACTIONS(2550),
    [anon_sym_and] = ACTIONS(2550),
    [anon_sym_bitor] = ACTIONS(2550),
    [anon_sym_xor] = ACTIONS(2550),
    [anon_sym_bitand] = ACTIONS(2550),
    [anon_sym_not_eq] = ACTIONS(2550),
    [anon_sym_is] = ACTIONS(2550),
    [anon_sym_as] = ACTIONS(2550),
    [anon_sym_DASH_DASH] = ACTIONS(2548),
    [anon_sym_PLUS_PLUS] = ACTIONS(2548),
    [anon_sym_DOT] = ACTIONS(2550),
    [anon_sym_DOT_STAR] = ACTIONS(2548),
    [anon_sym_DASH_GT] = ACTIONS(2548),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(2550),
    [anon_sym_This] = ACTIONS(2550),
  },
  [3210] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(4695),
    [sym_raw_string_literal] = STATE(3527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6839),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(5334),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2207),
    [anon_sym_SLASH_EQ] = ACTIONS(2207),
    [anon_sym_PERCENT_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_GT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_EQ] = ACTIONS(2207),
    [anon_sym_CARET_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_EQ] = ACTIONS(2207),
    [anon_sym_and_eq] = ACTIONS(2207),
    [anon_sym_or_eq] = ACTIONS(2207),
    [anon_sym_xor_eq] = ACTIONS(2207),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
  },
  [3211] = {
    [sym_identifier] = ACTIONS(3026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3024),
    [anon_sym_COMMA] = ACTIONS(3024),
    [anon_sym_RPAREN] = ACTIONS(3024),
    [aux_sym_preproc_if_token2] = ACTIONS(3024),
    [aux_sym_preproc_else_token1] = ACTIONS(3024),
    [aux_sym_preproc_elif_token1] = ACTIONS(3026),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3024),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3024),
    [anon_sym_LPAREN2] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3026),
    [anon_sym_PLUS] = ACTIONS(3026),
    [anon_sym_STAR] = ACTIONS(3026),
    [anon_sym_SLASH] = ACTIONS(3026),
    [anon_sym_PERCENT] = ACTIONS(3026),
    [anon_sym_PIPE_PIPE] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_PIPE] = ACTIONS(3026),
    [anon_sym_CARET] = ACTIONS(3026),
    [anon_sym_AMP] = ACTIONS(3026),
    [anon_sym_EQ_EQ] = ACTIONS(3024),
    [anon_sym_BANG_EQ] = ACTIONS(3024),
    [anon_sym_GT] = ACTIONS(3026),
    [anon_sym_GT_EQ] = ACTIONS(3024),
    [anon_sym_LT_EQ] = ACTIONS(3026),
    [anon_sym_LT] = ACTIONS(3026),
    [anon_sym_LT_LT] = ACTIONS(3026),
    [anon_sym_GT_GT] = ACTIONS(3026),
    [anon_sym_COLON] = ACTIONS(3024),
    [anon_sym_SEMI] = ACTIONS(3024),
    [anon_sym___attribute__] = ACTIONS(3026),
    [anon_sym___attribute] = ACTIONS(3026),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_RBRACE] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_RBRACK] = ACTIONS(3024),
    [anon_sym_EQ] = ACTIONS(3026),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_STAR_EQ] = ACTIONS(3024),
    [anon_sym_SLASH_EQ] = ACTIONS(3024),
    [anon_sym_PERCENT_EQ] = ACTIONS(3024),
    [anon_sym_PLUS_EQ] = ACTIONS(3024),
    [anon_sym_DASH_EQ] = ACTIONS(3024),
    [anon_sym_LT_LT_EQ] = ACTIONS(3024),
    [anon_sym_GT_GT_EQ] = ACTIONS(3024),
    [anon_sym_AMP_EQ] = ACTIONS(3024),
    [anon_sym_CARET_EQ] = ACTIONS(3024),
    [anon_sym_PIPE_EQ] = ACTIONS(3024),
    [anon_sym_and_eq] = ACTIONS(3026),
    [anon_sym_or_eq] = ACTIONS(3026),
    [anon_sym_xor_eq] = ACTIONS(3026),
    [anon_sym_LT_EQ_GT] = ACTIONS(3024),
    [anon_sym_or] = ACTIONS(3026),
    [anon_sym_and] = ACTIONS(3026),
    [anon_sym_bitor] = ACTIONS(3026),
    [anon_sym_xor] = ACTIONS(3026),
    [anon_sym_bitand] = ACTIONS(3026),
    [anon_sym_not_eq] = ACTIONS(3026),
    [anon_sym_is] = ACTIONS(3026),
    [anon_sym_as] = ACTIONS(3026),
    [anon_sym_DASH_DASH] = ACTIONS(3024),
    [anon_sym_PLUS_PLUS] = ACTIONS(3024),
    [anon_sym_DOT] = ACTIONS(3026),
    [anon_sym_DOT_STAR] = ACTIONS(3024),
    [anon_sym_DASH_GT] = ACTIONS(3024),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3026),
    [anon_sym_let] = ACTIONS(3026),
    [anon_sym_This] = ACTIONS(3026),
  },
  [3212] = {
    [sym_identifier] = ACTIONS(3034),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3032),
    [anon_sym_COMMA] = ACTIONS(3032),
    [anon_sym_RPAREN] = ACTIONS(3032),
    [aux_sym_preproc_if_token2] = ACTIONS(3032),
    [aux_sym_preproc_else_token1] = ACTIONS(3032),
    [aux_sym_preproc_elif_token1] = ACTIONS(3034),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3032),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3034),
    [anon_sym_SLASH] = ACTIONS(3034),
    [anon_sym_PERCENT] = ACTIONS(3034),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_PIPE] = ACTIONS(3034),
    [anon_sym_CARET] = ACTIONS(3034),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_EQ_EQ] = ACTIONS(3032),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_GT] = ACTIONS(3034),
    [anon_sym_GT_EQ] = ACTIONS(3032),
    [anon_sym_LT_EQ] = ACTIONS(3034),
    [anon_sym_LT] = ACTIONS(3034),
    [anon_sym_LT_LT] = ACTIONS(3034),
    [anon_sym_GT_GT] = ACTIONS(3034),
    [anon_sym_COLON] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym___attribute] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_RBRACE] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_RBRACK] = ACTIONS(3032),
    [anon_sym_EQ] = ACTIONS(3034),
    [anon_sym_QMARK] = ACTIONS(3032),
    [anon_sym_STAR_EQ] = ACTIONS(3032),
    [anon_sym_SLASH_EQ] = ACTIONS(3032),
    [anon_sym_PERCENT_EQ] = ACTIONS(3032),
    [anon_sym_PLUS_EQ] = ACTIONS(3032),
    [anon_sym_DASH_EQ] = ACTIONS(3032),
    [anon_sym_LT_LT_EQ] = ACTIONS(3032),
    [anon_sym_GT_GT_EQ] = ACTIONS(3032),
    [anon_sym_AMP_EQ] = ACTIONS(3032),
    [anon_sym_CARET_EQ] = ACTIONS(3032),
    [anon_sym_PIPE_EQ] = ACTIONS(3032),
    [anon_sym_and_eq] = ACTIONS(3034),
    [anon_sym_or_eq] = ACTIONS(3034),
    [anon_sym_xor_eq] = ACTIONS(3034),
    [anon_sym_LT_EQ_GT] = ACTIONS(3032),
    [anon_sym_or] = ACTIONS(3034),
    [anon_sym_and] = ACTIONS(3034),
    [anon_sym_bitor] = ACTIONS(3034),
    [anon_sym_xor] = ACTIONS(3034),
    [anon_sym_bitand] = ACTIONS(3034),
    [anon_sym_not_eq] = ACTIONS(3034),
    [anon_sym_is] = ACTIONS(3034),
    [anon_sym_as] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_PLUS] = ACTIONS(3032),
    [anon_sym_DOT] = ACTIONS(3034),
    [anon_sym_DOT_STAR] = ACTIONS(3032),
    [anon_sym_DASH_GT] = ACTIONS(3032),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_This] = ACTIONS(3034),
  },
  [3213] = {
    [sym_identifier] = ACTIONS(3038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3036),
    [anon_sym_COMMA] = ACTIONS(3036),
    [anon_sym_RPAREN] = ACTIONS(3036),
    [aux_sym_preproc_if_token2] = ACTIONS(3036),
    [aux_sym_preproc_else_token1] = ACTIONS(3036),
    [aux_sym_preproc_elif_token1] = ACTIONS(3038),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3036),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3036),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(3038),
    [anon_sym_SLASH] = ACTIONS(3038),
    [anon_sym_PERCENT] = ACTIONS(3038),
    [anon_sym_PIPE_PIPE] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_PIPE] = ACTIONS(3038),
    [anon_sym_CARET] = ACTIONS(3038),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym_EQ_EQ] = ACTIONS(3036),
    [anon_sym_BANG_EQ] = ACTIONS(3036),
    [anon_sym_GT] = ACTIONS(3038),
    [anon_sym_GT_EQ] = ACTIONS(3036),
    [anon_sym_LT_EQ] = ACTIONS(3038),
    [anon_sym_LT] = ACTIONS(3038),
    [anon_sym_LT_LT] = ACTIONS(3038),
    [anon_sym_GT_GT] = ACTIONS(3038),
    [anon_sym_COLON] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym___attribute] = ACTIONS(3038),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_RBRACE] = ACTIONS(3036),
    [anon_sym_LBRACK] = ACTIONS(3036),
    [anon_sym_RBRACK] = ACTIONS(3036),
    [anon_sym_EQ] = ACTIONS(3038),
    [anon_sym_QMARK] = ACTIONS(3036),
    [anon_sym_STAR_EQ] = ACTIONS(3036),
    [anon_sym_SLASH_EQ] = ACTIONS(3036),
    [anon_sym_PERCENT_EQ] = ACTIONS(3036),
    [anon_sym_PLUS_EQ] = ACTIONS(3036),
    [anon_sym_DASH_EQ] = ACTIONS(3036),
    [anon_sym_LT_LT_EQ] = ACTIONS(3036),
    [anon_sym_GT_GT_EQ] = ACTIONS(3036),
    [anon_sym_AMP_EQ] = ACTIONS(3036),
    [anon_sym_CARET_EQ] = ACTIONS(3036),
    [anon_sym_PIPE_EQ] = ACTIONS(3036),
    [anon_sym_and_eq] = ACTIONS(3038),
    [anon_sym_or_eq] = ACTIONS(3038),
    [anon_sym_xor_eq] = ACTIONS(3038),
    [anon_sym_LT_EQ_GT] = ACTIONS(3036),
    [anon_sym_or] = ACTIONS(3038),
    [anon_sym_and] = ACTIONS(3038),
    [anon_sym_bitor] = ACTIONS(3038),
    [anon_sym_xor] = ACTIONS(3038),
    [anon_sym_bitand] = ACTIONS(3038),
    [anon_sym_not_eq] = ACTIONS(3038),
    [anon_sym_is] = ACTIONS(3038),
    [anon_sym_as] = ACTIONS(3038),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_DOT] = ACTIONS(3038),
    [anon_sym_DOT_STAR] = ACTIONS(3036),
    [anon_sym_DASH_GT] = ACTIONS(3036),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3038),
    [anon_sym_let] = ACTIONS(3038),
    [anon_sym_This] = ACTIONS(3038),
  },
  [3214] = {
    [sym_identifier] = ACTIONS(3042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3040),
    [anon_sym_COMMA] = ACTIONS(3040),
    [anon_sym_RPAREN] = ACTIONS(3040),
    [aux_sym_preproc_if_token2] = ACTIONS(3040),
    [aux_sym_preproc_else_token1] = ACTIONS(3040),
    [aux_sym_preproc_elif_token1] = ACTIONS(3042),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3040),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3040),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3042),
    [anon_sym_SLASH] = ACTIONS(3042),
    [anon_sym_PERCENT] = ACTIONS(3042),
    [anon_sym_PIPE_PIPE] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_PIPE] = ACTIONS(3042),
    [anon_sym_CARET] = ACTIONS(3042),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_EQ_EQ] = ACTIONS(3040),
    [anon_sym_BANG_EQ] = ACTIONS(3040),
    [anon_sym_GT] = ACTIONS(3042),
    [anon_sym_GT_EQ] = ACTIONS(3040),
    [anon_sym_LT_EQ] = ACTIONS(3042),
    [anon_sym_LT] = ACTIONS(3042),
    [anon_sym_LT_LT] = ACTIONS(3042),
    [anon_sym_GT_GT] = ACTIONS(3042),
    [anon_sym_COLON] = ACTIONS(3040),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_RBRACE] = ACTIONS(3040),
    [anon_sym_LBRACK] = ACTIONS(3040),
    [anon_sym_RBRACK] = ACTIONS(3040),
    [anon_sym_EQ] = ACTIONS(3042),
    [anon_sym_QMARK] = ACTIONS(3040),
    [anon_sym_STAR_EQ] = ACTIONS(3040),
    [anon_sym_SLASH_EQ] = ACTIONS(3040),
    [anon_sym_PERCENT_EQ] = ACTIONS(3040),
    [anon_sym_PLUS_EQ] = ACTIONS(3040),
    [anon_sym_DASH_EQ] = ACTIONS(3040),
    [anon_sym_LT_LT_EQ] = ACTIONS(3040),
    [anon_sym_GT_GT_EQ] = ACTIONS(3040),
    [anon_sym_AMP_EQ] = ACTIONS(3040),
    [anon_sym_CARET_EQ] = ACTIONS(3040),
    [anon_sym_PIPE_EQ] = ACTIONS(3040),
    [anon_sym_and_eq] = ACTIONS(3042),
    [anon_sym_or_eq] = ACTIONS(3042),
    [anon_sym_xor_eq] = ACTIONS(3042),
    [anon_sym_LT_EQ_GT] = ACTIONS(3040),
    [anon_sym_or] = ACTIONS(3042),
    [anon_sym_and] = ACTIONS(3042),
    [anon_sym_bitor] = ACTIONS(3042),
    [anon_sym_xor] = ACTIONS(3042),
    [anon_sym_bitand] = ACTIONS(3042),
    [anon_sym_not_eq] = ACTIONS(3042),
    [anon_sym_is] = ACTIONS(3042),
    [anon_sym_as] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_DOT] = ACTIONS(3042),
    [anon_sym_DOT_STAR] = ACTIONS(3040),
    [anon_sym_DASH_GT] = ACTIONS(3040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3042),
    [anon_sym_let] = ACTIONS(3042),
    [anon_sym_This] = ACTIONS(3042),
  },
  [3215] = {
    [sym_ms_based_modifier] = STATE(10947),
    [sym_ms_unaligned_ptr_modifier] = STATE(5091),
    [sym_ms_pointer_modifier] = STATE(4976),
    [sym__declarator] = STATE(7901),
    [sym__abstract_declarator] = STATE(8726),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_abstract_parenthesized_declarator] = STATE(7454),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_abstract_pointer_declarator] = STATE(7454),
    [sym_function_declarator] = STATE(8054),
    [sym_abstract_function_declarator] = STATE(7454),
    [sym_array_declarator] = STATE(8054),
    [sym_abstract_array_declarator] = STATE(7454),
    [sym_type_qualifier] = STATE(3586),
    [sym_alignas_qualifier] = STATE(5539),
    [sym_parameter_list] = STATE(4120),
    [sym_decltype] = STATE(11339),
    [sym_reference_declarator] = STATE(8054),
    [sym_abstract_reference_declarator] = STATE(7454),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym__function_declarator_seq] = STATE(7543),
    [sym_template_type] = STATE(11339),
    [sym_template_function] = STATE(8054),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7400),
    [sym_qualified_identifier] = STATE(8054),
    [sym_operator_name] = STATE(8054),
    [aux_sym__type_definition_type_repeat1] = STATE(3586),
    [aux_sym_pointer_declarator_repeat1] = STATE(4976),
    [sym_identifier] = ACTIONS(7394),
    [anon_sym_COMMA] = ACTIONS(7410),
    [anon_sym_LPAREN2] = ACTIONS(5344),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(7507),
    [anon_sym_AMP_AMP] = ACTIONS(7509),
    [anon_sym_AMP] = ACTIONS(7511),
    [anon_sym_COLON] = ACTIONS(7412),
    [anon_sym___extension__] = ACTIONS(5368),
    [anon_sym___attribute__] = ACTIONS(7412),
    [anon_sym___attribute] = ACTIONS(7412),
    [anon_sym_COLON_COLON] = ACTIONS(7406),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(5364),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(5364),
    [sym_ms_signed_ptr_modifier] = ACTIONS(5364),
    [anon_sym__unaligned] = ACTIONS(5366),
    [anon_sym___unaligned] = ACTIONS(5366),
    [anon_sym_LBRACK] = ACTIONS(7408),
    [anon_sym_const] = ACTIONS(5368),
    [anon_sym_constexpr] = ACTIONS(5368),
    [anon_sym_volatile] = ACTIONS(5368),
    [anon_sym_restrict] = ACTIONS(5368),
    [anon_sym___restrict__] = ACTIONS(5368),
    [anon_sym__Atomic] = ACTIONS(5368),
    [anon_sym__Noreturn] = ACTIONS(5368),
    [anon_sym_noreturn] = ACTIONS(5368),
    [anon_sym__Nonnull] = ACTIONS(5368),
    [anon_sym_mutable] = ACTIONS(5368),
    [anon_sym_constinit] = ACTIONS(5368),
    [anon_sym_consteval] = ACTIONS(5368),
    [anon_sym_alignas] = ACTIONS(5370),
    [anon_sym__Alignas] = ACTIONS(5370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_GT2] = ACTIONS(7410),
    [anon_sym_operator] = ACTIONS(2861),
  },
  [3216] = {
    [sym_identifier] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4250),
    [anon_sym_COMMA] = ACTIONS(4250),
    [anon_sym_RPAREN] = ACTIONS(4250),
    [aux_sym_preproc_if_token2] = ACTIONS(4250),
    [aux_sym_preproc_else_token1] = ACTIONS(4250),
    [aux_sym_preproc_elif_token1] = ACTIONS(4248),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4250),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4250),
    [anon_sym_LPAREN2] = ACTIONS(4250),
    [anon_sym_DASH] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_STAR] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [anon_sym_PIPE_PIPE] = ACTIONS(4250),
    [anon_sym_AMP_AMP] = ACTIONS(4250),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4250),
    [anon_sym_BANG_EQ] = ACTIONS(4250),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4250),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_COLON] = ACTIONS(4250),
    [anon_sym_SEMI] = ACTIONS(4250),
    [anon_sym___attribute__] = ACTIONS(4248),
    [anon_sym___attribute] = ACTIONS(4248),
    [anon_sym_LBRACE] = ACTIONS(4250),
    [anon_sym_RBRACE] = ACTIONS(4250),
    [anon_sym_LBRACK] = ACTIONS(4250),
    [anon_sym_RBRACK] = ACTIONS(4250),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_QMARK] = ACTIONS(4250),
    [anon_sym_STAR_EQ] = ACTIONS(4250),
    [anon_sym_SLASH_EQ] = ACTIONS(4250),
    [anon_sym_PERCENT_EQ] = ACTIONS(4250),
    [anon_sym_PLUS_EQ] = ACTIONS(4250),
    [anon_sym_DASH_EQ] = ACTIONS(4250),
    [anon_sym_LT_LT_EQ] = ACTIONS(4250),
    [anon_sym_GT_GT_EQ] = ACTIONS(4250),
    [anon_sym_AMP_EQ] = ACTIONS(4250),
    [anon_sym_CARET_EQ] = ACTIONS(4250),
    [anon_sym_PIPE_EQ] = ACTIONS(4250),
    [anon_sym_and_eq] = ACTIONS(4248),
    [anon_sym_or_eq] = ACTIONS(4248),
    [anon_sym_xor_eq] = ACTIONS(4248),
    [anon_sym_LT_EQ_GT] = ACTIONS(4250),
    [anon_sym_or] = ACTIONS(4248),
    [anon_sym_and] = ACTIONS(4248),
    [anon_sym_bitor] = ACTIONS(4248),
    [anon_sym_xor] = ACTIONS(4248),
    [anon_sym_bitand] = ACTIONS(4248),
    [anon_sym_not_eq] = ACTIONS(4248),
    [anon_sym_is] = ACTIONS(4248),
    [anon_sym_as] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4250),
    [anon_sym_PLUS_PLUS] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_DOT_STAR] = ACTIONS(4250),
    [anon_sym_DASH_GT] = ACTIONS(4250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4248),
    [anon_sym_let] = ACTIONS(4248),
    [anon_sym_This] = ACTIONS(4248),
  },
  [3217] = {
    [sym_identifier] = ACTIONS(3050),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3048),
    [anon_sym_COMMA] = ACTIONS(3048),
    [anon_sym_RPAREN] = ACTIONS(3048),
    [aux_sym_preproc_if_token2] = ACTIONS(3048),
    [aux_sym_preproc_else_token1] = ACTIONS(3048),
    [aux_sym_preproc_elif_token1] = ACTIONS(3050),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3048),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3048),
    [anon_sym_LPAREN2] = ACTIONS(3048),
    [anon_sym_DASH] = ACTIONS(3050),
    [anon_sym_PLUS] = ACTIONS(3050),
    [anon_sym_STAR] = ACTIONS(3050),
    [anon_sym_SLASH] = ACTIONS(3050),
    [anon_sym_PERCENT] = ACTIONS(3050),
    [anon_sym_PIPE_PIPE] = ACTIONS(3048),
    [anon_sym_AMP_AMP] = ACTIONS(3048),
    [anon_sym_PIPE] = ACTIONS(3050),
    [anon_sym_CARET] = ACTIONS(3050),
    [anon_sym_AMP] = ACTIONS(3050),
    [anon_sym_EQ_EQ] = ACTIONS(3048),
    [anon_sym_BANG_EQ] = ACTIONS(3048),
    [anon_sym_GT] = ACTIONS(3050),
    [anon_sym_GT_EQ] = ACTIONS(3048),
    [anon_sym_LT_EQ] = ACTIONS(3050),
    [anon_sym_LT] = ACTIONS(3050),
    [anon_sym_LT_LT] = ACTIONS(3050),
    [anon_sym_GT_GT] = ACTIONS(3050),
    [anon_sym_COLON] = ACTIONS(3048),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym___attribute__] = ACTIONS(3050),
    [anon_sym___attribute] = ACTIONS(3050),
    [anon_sym_LBRACE] = ACTIONS(3048),
    [anon_sym_RBRACE] = ACTIONS(3048),
    [anon_sym_LBRACK] = ACTIONS(3048),
    [anon_sym_RBRACK] = ACTIONS(3048),
    [anon_sym_EQ] = ACTIONS(3050),
    [anon_sym_QMARK] = ACTIONS(3048),
    [anon_sym_STAR_EQ] = ACTIONS(3048),
    [anon_sym_SLASH_EQ] = ACTIONS(3048),
    [anon_sym_PERCENT_EQ] = ACTIONS(3048),
    [anon_sym_PLUS_EQ] = ACTIONS(3048),
    [anon_sym_DASH_EQ] = ACTIONS(3048),
    [anon_sym_LT_LT_EQ] = ACTIONS(3048),
    [anon_sym_GT_GT_EQ] = ACTIONS(3048),
    [anon_sym_AMP_EQ] = ACTIONS(3048),
    [anon_sym_CARET_EQ] = ACTIONS(3048),
    [anon_sym_PIPE_EQ] = ACTIONS(3048),
    [anon_sym_and_eq] = ACTIONS(3050),
    [anon_sym_or_eq] = ACTIONS(3050),
    [anon_sym_xor_eq] = ACTIONS(3050),
    [anon_sym_LT_EQ_GT] = ACTIONS(3048),
    [anon_sym_or] = ACTIONS(3050),
    [anon_sym_and] = ACTIONS(3050),
    [anon_sym_bitor] = ACTIONS(3050),
    [anon_sym_xor] = ACTIONS(3050),
    [anon_sym_bitand] = ACTIONS(3050),
    [anon_sym_not_eq] = ACTIONS(3050),
    [anon_sym_is] = ACTIONS(3050),
    [anon_sym_as] = ACTIONS(3050),
    [anon_sym_DASH_DASH] = ACTIONS(3048),
    [anon_sym_PLUS_PLUS] = ACTIONS(3048),
    [anon_sym_DOT] = ACTIONS(3050),
    [anon_sym_DOT_STAR] = ACTIONS(3048),
    [anon_sym_DASH_GT] = ACTIONS(3048),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3050),
    [anon_sym_let] = ACTIONS(3050),
    [anon_sym_This] = ACTIONS(3050),
  },
  [3218] = {
    [sym_identifier] = ACTIONS(3042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3040),
    [anon_sym_COMMA] = ACTIONS(3040),
    [anon_sym_RPAREN] = ACTIONS(3040),
    [aux_sym_preproc_if_token2] = ACTIONS(3040),
    [aux_sym_preproc_else_token1] = ACTIONS(3040),
    [aux_sym_preproc_elif_token1] = ACTIONS(3042),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3040),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3040),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3042),
    [anon_sym_SLASH] = ACTIONS(3042),
    [anon_sym_PERCENT] = ACTIONS(3042),
    [anon_sym_PIPE_PIPE] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_PIPE] = ACTIONS(3042),
    [anon_sym_CARET] = ACTIONS(3042),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_EQ_EQ] = ACTIONS(3040),
    [anon_sym_BANG_EQ] = ACTIONS(3040),
    [anon_sym_GT] = ACTIONS(3042),
    [anon_sym_GT_EQ] = ACTIONS(3040),
    [anon_sym_LT_EQ] = ACTIONS(3042),
    [anon_sym_LT] = ACTIONS(3042),
    [anon_sym_LT_LT] = ACTIONS(3042),
    [anon_sym_GT_GT] = ACTIONS(3042),
    [anon_sym_COLON] = ACTIONS(3040),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_RBRACE] = ACTIONS(3040),
    [anon_sym_LBRACK] = ACTIONS(3040),
    [anon_sym_RBRACK] = ACTIONS(3040),
    [anon_sym_EQ] = ACTIONS(3042),
    [anon_sym_QMARK] = ACTIONS(3040),
    [anon_sym_STAR_EQ] = ACTIONS(3040),
    [anon_sym_SLASH_EQ] = ACTIONS(3040),
    [anon_sym_PERCENT_EQ] = ACTIONS(3040),
    [anon_sym_PLUS_EQ] = ACTIONS(3040),
    [anon_sym_DASH_EQ] = ACTIONS(3040),
    [anon_sym_LT_LT_EQ] = ACTIONS(3040),
    [anon_sym_GT_GT_EQ] = ACTIONS(3040),
    [anon_sym_AMP_EQ] = ACTIONS(3040),
    [anon_sym_CARET_EQ] = ACTIONS(3040),
    [anon_sym_PIPE_EQ] = ACTIONS(3040),
    [anon_sym_and_eq] = ACTIONS(3042),
    [anon_sym_or_eq] = ACTIONS(3042),
    [anon_sym_xor_eq] = ACTIONS(3042),
    [anon_sym_LT_EQ_GT] = ACTIONS(3040),
    [anon_sym_or] = ACTIONS(3042),
    [anon_sym_and] = ACTIONS(3042),
    [anon_sym_bitor] = ACTIONS(3042),
    [anon_sym_xor] = ACTIONS(3042),
    [anon_sym_bitand] = ACTIONS(3042),
    [anon_sym_not_eq] = ACTIONS(3042),
    [anon_sym_is] = ACTIONS(3042),
    [anon_sym_as] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_DOT] = ACTIONS(3042),
    [anon_sym_DOT_STAR] = ACTIONS(3040),
    [anon_sym_DASH_GT] = ACTIONS(3040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3042),
    [anon_sym_let] = ACTIONS(3042),
    [anon_sym_This] = ACTIONS(3042),
  },
  [3219] = {
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2552),
    [anon_sym_COMMA] = ACTIONS(2552),
    [anon_sym_RPAREN] = ACTIONS(2552),
    [aux_sym_preproc_if_token2] = ACTIONS(2552),
    [aux_sym_preproc_else_token1] = ACTIONS(2552),
    [aux_sym_preproc_elif_token1] = ACTIONS(2554),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2552),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2552),
    [anon_sym_LPAREN2] = ACTIONS(2552),
    [anon_sym_DASH] = ACTIONS(2554),
    [anon_sym_PLUS] = ACTIONS(2554),
    [anon_sym_STAR] = ACTIONS(2554),
    [anon_sym_SLASH] = ACTIONS(2554),
    [anon_sym_PERCENT] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2552),
    [anon_sym_AMP_AMP] = ACTIONS(2552),
    [anon_sym_PIPE] = ACTIONS(2554),
    [anon_sym_CARET] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2554),
    [anon_sym_EQ_EQ] = ACTIONS(2552),
    [anon_sym_BANG_EQ] = ACTIONS(2552),
    [anon_sym_GT] = ACTIONS(2554),
    [anon_sym_GT_EQ] = ACTIONS(2552),
    [anon_sym_LT_EQ] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2554),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_COLON] = ACTIONS(2552),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym___attribute__] = ACTIONS(2554),
    [anon_sym___attribute] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(2552),
    [anon_sym_RBRACE] = ACTIONS(2552),
    [anon_sym_LBRACK] = ACTIONS(2552),
    [anon_sym_RBRACK] = ACTIONS(2552),
    [anon_sym_EQ] = ACTIONS(2554),
    [anon_sym_QMARK] = ACTIONS(2552),
    [anon_sym_STAR_EQ] = ACTIONS(2552),
    [anon_sym_SLASH_EQ] = ACTIONS(2552),
    [anon_sym_PERCENT_EQ] = ACTIONS(2552),
    [anon_sym_PLUS_EQ] = ACTIONS(2552),
    [anon_sym_DASH_EQ] = ACTIONS(2552),
    [anon_sym_LT_LT_EQ] = ACTIONS(2552),
    [anon_sym_GT_GT_EQ] = ACTIONS(2552),
    [anon_sym_AMP_EQ] = ACTIONS(2552),
    [anon_sym_CARET_EQ] = ACTIONS(2552),
    [anon_sym_PIPE_EQ] = ACTIONS(2552),
    [anon_sym_and_eq] = ACTIONS(2554),
    [anon_sym_or_eq] = ACTIONS(2554),
    [anon_sym_xor_eq] = ACTIONS(2554),
    [anon_sym_LT_EQ_GT] = ACTIONS(2552),
    [anon_sym_or] = ACTIONS(2554),
    [anon_sym_and] = ACTIONS(2554),
    [anon_sym_bitor] = ACTIONS(2554),
    [anon_sym_xor] = ACTIONS(2554),
    [anon_sym_bitand] = ACTIONS(2554),
    [anon_sym_not_eq] = ACTIONS(2554),
    [anon_sym_is] = ACTIONS(2554),
    [anon_sym_as] = ACTIONS(2554),
    [anon_sym_DASH_DASH] = ACTIONS(2552),
    [anon_sym_PLUS_PLUS] = ACTIONS(2552),
    [anon_sym_DOT] = ACTIONS(2554),
    [anon_sym_DOT_STAR] = ACTIONS(2552),
    [anon_sym_DASH_GT] = ACTIONS(2552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2554),
    [anon_sym_let] = ACTIONS(2554),
    [anon_sym_This] = ACTIONS(2554),
  },
  [3220] = {
    [sym_identifier] = ACTIONS(3042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3040),
    [anon_sym_COMMA] = ACTIONS(3040),
    [anon_sym_RPAREN] = ACTIONS(3040),
    [aux_sym_preproc_if_token2] = ACTIONS(3040),
    [aux_sym_preproc_else_token1] = ACTIONS(3040),
    [aux_sym_preproc_elif_token1] = ACTIONS(3042),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3040),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3040),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3042),
    [anon_sym_SLASH] = ACTIONS(3042),
    [anon_sym_PERCENT] = ACTIONS(3042),
    [anon_sym_PIPE_PIPE] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_PIPE] = ACTIONS(3042),
    [anon_sym_CARET] = ACTIONS(3042),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_EQ_EQ] = ACTIONS(3040),
    [anon_sym_BANG_EQ] = ACTIONS(3040),
    [anon_sym_GT] = ACTIONS(3042),
    [anon_sym_GT_EQ] = ACTIONS(3040),
    [anon_sym_LT_EQ] = ACTIONS(3042),
    [anon_sym_LT] = ACTIONS(3042),
    [anon_sym_LT_LT] = ACTIONS(3042),
    [anon_sym_GT_GT] = ACTIONS(3042),
    [anon_sym_COLON] = ACTIONS(3040),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_RBRACE] = ACTIONS(3040),
    [anon_sym_LBRACK] = ACTIONS(3040),
    [anon_sym_RBRACK] = ACTIONS(3040),
    [anon_sym_EQ] = ACTIONS(3042),
    [anon_sym_QMARK] = ACTIONS(3040),
    [anon_sym_STAR_EQ] = ACTIONS(3040),
    [anon_sym_SLASH_EQ] = ACTIONS(3040),
    [anon_sym_PERCENT_EQ] = ACTIONS(3040),
    [anon_sym_PLUS_EQ] = ACTIONS(3040),
    [anon_sym_DASH_EQ] = ACTIONS(3040),
    [anon_sym_LT_LT_EQ] = ACTIONS(3040),
    [anon_sym_GT_GT_EQ] = ACTIONS(3040),
    [anon_sym_AMP_EQ] = ACTIONS(3040),
    [anon_sym_CARET_EQ] = ACTIONS(3040),
    [anon_sym_PIPE_EQ] = ACTIONS(3040),
    [anon_sym_and_eq] = ACTIONS(3042),
    [anon_sym_or_eq] = ACTIONS(3042),
    [anon_sym_xor_eq] = ACTIONS(3042),
    [anon_sym_LT_EQ_GT] = ACTIONS(3040),
    [anon_sym_or] = ACTIONS(3042),
    [anon_sym_and] = ACTIONS(3042),
    [anon_sym_bitor] = ACTIONS(3042),
    [anon_sym_xor] = ACTIONS(3042),
    [anon_sym_bitand] = ACTIONS(3042),
    [anon_sym_not_eq] = ACTIONS(3042),
    [anon_sym_is] = ACTIONS(3042),
    [anon_sym_as] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_DOT] = ACTIONS(3042),
    [anon_sym_DOT_STAR] = ACTIONS(3040),
    [anon_sym_DASH_GT] = ACTIONS(3040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3042),
    [anon_sym_let] = ACTIONS(3042),
    [anon_sym_This] = ACTIONS(3042),
  },
  [3221] = {
    [sym_string_literal] = STATE(3241),
    [sym_template_argument_list] = STATE(4257),
    [sym_raw_string_literal] = STATE(3241),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_RPAREN] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6778),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_EQ] = ACTIONS(2181),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2170),
    [anon_sym_SLASH_EQ] = ACTIONS(2170),
    [anon_sym_PERCENT_EQ] = ACTIONS(2170),
    [anon_sym_PLUS_EQ] = ACTIONS(2170),
    [anon_sym_DASH_EQ] = ACTIONS(2170),
    [anon_sym_LT_LT_EQ] = ACTIONS(2170),
    [anon_sym_GT_GT_EQ] = ACTIONS(2170),
    [anon_sym_AMP_EQ] = ACTIONS(2170),
    [anon_sym_CARET_EQ] = ACTIONS(2170),
    [anon_sym_PIPE_EQ] = ACTIONS(2170),
    [anon_sym_and_eq] = ACTIONS(2170),
    [anon_sym_or_eq] = ACTIONS(2170),
    [anon_sym_xor_eq] = ACTIONS(2170),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2181),
    [anon_sym_L_DQUOTE] = ACTIONS(6765),
    [anon_sym_u_DQUOTE] = ACTIONS(6765),
    [anon_sym_U_DQUOTE] = ACTIONS(6765),
    [anon_sym_u8_DQUOTE] = ACTIONS(6765),
    [anon_sym_DQUOTE] = ACTIONS(6765),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6767),
    [anon_sym_LR_DQUOTE] = ACTIONS(6767),
    [anon_sym_uR_DQUOTE] = ACTIONS(6767),
    [anon_sym_UR_DQUOTE] = ACTIONS(6767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6767),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2170),
  },
  [3222] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(4695),
    [sym_raw_string_literal] = STATE(3527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6839),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(5336),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2207),
    [anon_sym_SLASH_EQ] = ACTIONS(2207),
    [anon_sym_PERCENT_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_GT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_EQ] = ACTIONS(2207),
    [anon_sym_CARET_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_EQ] = ACTIONS(2207),
    [anon_sym_and_eq] = ACTIONS(2207),
    [anon_sym_or_eq] = ACTIONS(2207),
    [anon_sym_xor_eq] = ACTIONS(2207),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
  },
  [3223] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(4695),
    [sym_raw_string_literal] = STATE(3527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6839),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(5413),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2207),
    [anon_sym_SLASH_EQ] = ACTIONS(2207),
    [anon_sym_PERCENT_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_GT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_EQ] = ACTIONS(2207),
    [anon_sym_CARET_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_EQ] = ACTIONS(2207),
    [anon_sym_and_eq] = ACTIONS(2207),
    [anon_sym_or_eq] = ACTIONS(2207),
    [anon_sym_xor_eq] = ACTIONS(2207),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
  },
  [3224] = {
    [sym_attribute_specifier] = STATE(3045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4002),
    [anon_sym_COMMA] = ACTIONS(4002),
    [anon_sym_RPAREN] = ACTIONS(4002),
    [anon_sym_LPAREN2] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4004),
    [anon_sym_PLUS] = ACTIONS(4004),
    [anon_sym_STAR] = ACTIONS(4002),
    [anon_sym_SLASH] = ACTIONS(4004),
    [anon_sym_PERCENT] = ACTIONS(4002),
    [anon_sym_PIPE_PIPE] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4002),
    [anon_sym_PIPE] = ACTIONS(4004),
    [anon_sym_CARET] = ACTIONS(4002),
    [anon_sym_AMP] = ACTIONS(4004),
    [anon_sym_EQ_EQ] = ACTIONS(4002),
    [anon_sym_BANG_EQ] = ACTIONS(4002),
    [anon_sym_GT] = ACTIONS(4004),
    [anon_sym_GT_EQ] = ACTIONS(4002),
    [anon_sym_LT_EQ] = ACTIONS(4004),
    [anon_sym_LT] = ACTIONS(4004),
    [anon_sym_LT_LT] = ACTIONS(4002),
    [anon_sym_GT_GT] = ACTIONS(4002),
    [anon_sym_COLON] = ACTIONS(4002),
    [anon_sym_SEMI] = ACTIONS(4002),
    [anon_sym___extension__] = ACTIONS(4002),
    [anon_sym___attribute__] = ACTIONS(7346),
    [anon_sym___attribute] = ACTIONS(7348),
    [anon_sym_LBRACE] = ACTIONS(4002),
    [anon_sym_RBRACE] = ACTIONS(4002),
    [anon_sym_LBRACK] = ACTIONS(4002),
    [anon_sym_RBRACK] = ACTIONS(4002),
    [anon_sym_const] = ACTIONS(4004),
    [anon_sym_constexpr] = ACTIONS(4002),
    [anon_sym_volatile] = ACTIONS(4002),
    [anon_sym_restrict] = ACTIONS(4002),
    [anon_sym___restrict__] = ACTIONS(4002),
    [anon_sym__Atomic] = ACTIONS(4002),
    [anon_sym__Noreturn] = ACTIONS(4002),
    [anon_sym_noreturn] = ACTIONS(4002),
    [anon_sym__Nonnull] = ACTIONS(4002),
    [anon_sym_mutable] = ACTIONS(4002),
    [anon_sym_constinit] = ACTIONS(4002),
    [anon_sym_consteval] = ACTIONS(4002),
    [anon_sym_alignas] = ACTIONS(4002),
    [anon_sym__Alignas] = ACTIONS(4002),
    [anon_sym_QMARK] = ACTIONS(4002),
    [anon_sym_LT_EQ_GT] = ACTIONS(4002),
    [anon_sym_or] = ACTIONS(4002),
    [anon_sym_and] = ACTIONS(4002),
    [anon_sym_bitor] = ACTIONS(4002),
    [anon_sym_xor] = ACTIONS(4002),
    [anon_sym_bitand] = ACTIONS(4002),
    [anon_sym_not_eq] = ACTIONS(4002),
    [anon_sym_is] = ACTIONS(4002),
    [anon_sym_as] = ACTIONS(4002),
    [anon_sym_DASH_DASH] = ACTIONS(4002),
    [anon_sym_PLUS_PLUS] = ACTIONS(4002),
    [anon_sym_DOT] = ACTIONS(4004),
    [anon_sym_DOT_STAR] = ACTIONS(4002),
    [anon_sym_DASH_GT] = ACTIONS(4002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4002),
    [anon_sym_let] = ACTIONS(4002),
    [anon_sym_This] = ACTIONS(4002),
    [anon_sym_final] = ACTIONS(4002),
    [anon_sym_override] = ACTIONS(4002),
    [anon_sym_requires] = ACTIONS(4002),
    [anon_sym_where] = ACTIONS(4002),
  },
  [3225] = {
    [sym_attribute_specifier] = STATE(3053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4089),
    [anon_sym_COMMA] = ACTIONS(4089),
    [anon_sym_RPAREN] = ACTIONS(4089),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4091),
    [anon_sym_PLUS] = ACTIONS(4091),
    [anon_sym_STAR] = ACTIONS(4089),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [anon_sym_PIPE_PIPE] = ACTIONS(4089),
    [anon_sym_AMP_AMP] = ACTIONS(4089),
    [anon_sym_PIPE] = ACTIONS(4091),
    [anon_sym_CARET] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4091),
    [anon_sym_EQ_EQ] = ACTIONS(4089),
    [anon_sym_BANG_EQ] = ACTIONS(4089),
    [anon_sym_GT] = ACTIONS(4091),
    [anon_sym_GT_EQ] = ACTIONS(4089),
    [anon_sym_LT_EQ] = ACTIONS(4091),
    [anon_sym_LT] = ACTIONS(4091),
    [anon_sym_LT_LT] = ACTIONS(4089),
    [anon_sym_GT_GT] = ACTIONS(4089),
    [anon_sym_COLON] = ACTIONS(4089),
    [anon_sym_SEMI] = ACTIONS(4089),
    [anon_sym___extension__] = ACTIONS(4089),
    [anon_sym___attribute__] = ACTIONS(7346),
    [anon_sym___attribute] = ACTIONS(7348),
    [anon_sym_LBRACE] = ACTIONS(4089),
    [anon_sym_RBRACE] = ACTIONS(4089),
    [anon_sym_LBRACK] = ACTIONS(4089),
    [anon_sym_RBRACK] = ACTIONS(4089),
    [anon_sym_const] = ACTIONS(4091),
    [anon_sym_constexpr] = ACTIONS(4089),
    [anon_sym_volatile] = ACTIONS(4089),
    [anon_sym_restrict] = ACTIONS(4089),
    [anon_sym___restrict__] = ACTIONS(4089),
    [anon_sym__Atomic] = ACTIONS(4089),
    [anon_sym__Noreturn] = ACTIONS(4089),
    [anon_sym_noreturn] = ACTIONS(4089),
    [anon_sym__Nonnull] = ACTIONS(4089),
    [anon_sym_mutable] = ACTIONS(4089),
    [anon_sym_constinit] = ACTIONS(4089),
    [anon_sym_consteval] = ACTIONS(4089),
    [anon_sym_alignas] = ACTIONS(4089),
    [anon_sym__Alignas] = ACTIONS(4089),
    [anon_sym_QMARK] = ACTIONS(4089),
    [anon_sym_LT_EQ_GT] = ACTIONS(4089),
    [anon_sym_or] = ACTIONS(4089),
    [anon_sym_and] = ACTIONS(4089),
    [anon_sym_bitor] = ACTIONS(4089),
    [anon_sym_xor] = ACTIONS(4089),
    [anon_sym_bitand] = ACTIONS(4089),
    [anon_sym_not_eq] = ACTIONS(4089),
    [anon_sym_is] = ACTIONS(4089),
    [anon_sym_as] = ACTIONS(4089),
    [anon_sym_DASH_DASH] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(4089),
    [anon_sym_DOT] = ACTIONS(4091),
    [anon_sym_DOT_STAR] = ACTIONS(4089),
    [anon_sym_DASH_GT] = ACTIONS(4089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4089),
    [anon_sym_let] = ACTIONS(4089),
    [anon_sym_This] = ACTIONS(4089),
    [anon_sym_final] = ACTIONS(4089),
    [anon_sym_override] = ACTIONS(4089),
    [anon_sym_requires] = ACTIONS(4089),
    [anon_sym_where] = ACTIONS(4089),
  },
  [3226] = {
    [sym_attribute_specifier] = STATE(3031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4154),
    [anon_sym_COMMA] = ACTIONS(4154),
    [anon_sym_RPAREN] = ACTIONS(4154),
    [anon_sym_LPAREN2] = ACTIONS(4154),
    [anon_sym_DASH] = ACTIONS(4156),
    [anon_sym_PLUS] = ACTIONS(4156),
    [anon_sym_STAR] = ACTIONS(4154),
    [anon_sym_SLASH] = ACTIONS(4156),
    [anon_sym_PERCENT] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE] = ACTIONS(4154),
    [anon_sym_AMP_AMP] = ACTIONS(4154),
    [anon_sym_PIPE] = ACTIONS(4156),
    [anon_sym_CARET] = ACTIONS(4154),
    [anon_sym_AMP] = ACTIONS(4156),
    [anon_sym_EQ_EQ] = ACTIONS(4154),
    [anon_sym_BANG_EQ] = ACTIONS(4154),
    [anon_sym_GT] = ACTIONS(4156),
    [anon_sym_GT_EQ] = ACTIONS(4154),
    [anon_sym_LT_EQ] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(4156),
    [anon_sym_LT_LT] = ACTIONS(4154),
    [anon_sym_GT_GT] = ACTIONS(4154),
    [anon_sym_COLON] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4154),
    [anon_sym___extension__] = ACTIONS(4154),
    [anon_sym___attribute__] = ACTIONS(7346),
    [anon_sym___attribute] = ACTIONS(7348),
    [anon_sym_LBRACE] = ACTIONS(4154),
    [anon_sym_RBRACE] = ACTIONS(4154),
    [anon_sym_LBRACK] = ACTIONS(4154),
    [anon_sym_RBRACK] = ACTIONS(4154),
    [anon_sym_const] = ACTIONS(4156),
    [anon_sym_constexpr] = ACTIONS(4154),
    [anon_sym_volatile] = ACTIONS(4154),
    [anon_sym_restrict] = ACTIONS(4154),
    [anon_sym___restrict__] = ACTIONS(4154),
    [anon_sym__Atomic] = ACTIONS(4154),
    [anon_sym__Noreturn] = ACTIONS(4154),
    [anon_sym_noreturn] = ACTIONS(4154),
    [anon_sym__Nonnull] = ACTIONS(4154),
    [anon_sym_mutable] = ACTIONS(4154),
    [anon_sym_constinit] = ACTIONS(4154),
    [anon_sym_consteval] = ACTIONS(4154),
    [anon_sym_alignas] = ACTIONS(4154),
    [anon_sym__Alignas] = ACTIONS(4154),
    [anon_sym_QMARK] = ACTIONS(4154),
    [anon_sym_LT_EQ_GT] = ACTIONS(4154),
    [anon_sym_or] = ACTIONS(4154),
    [anon_sym_and] = ACTIONS(4154),
    [anon_sym_bitor] = ACTIONS(4154),
    [anon_sym_xor] = ACTIONS(4154),
    [anon_sym_bitand] = ACTIONS(4154),
    [anon_sym_not_eq] = ACTIONS(4154),
    [anon_sym_is] = ACTIONS(4154),
    [anon_sym_as] = ACTIONS(4154),
    [anon_sym_DASH_DASH] = ACTIONS(4154),
    [anon_sym_PLUS_PLUS] = ACTIONS(4154),
    [anon_sym_DOT] = ACTIONS(4156),
    [anon_sym_DOT_STAR] = ACTIONS(4154),
    [anon_sym_DASH_GT] = ACTIONS(4154),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4154),
    [anon_sym_let] = ACTIONS(4154),
    [anon_sym_This] = ACTIONS(4154),
    [anon_sym_final] = ACTIONS(4154),
    [anon_sym_override] = ACTIONS(4154),
    [anon_sym_requires] = ACTIONS(4154),
    [anon_sym_where] = ACTIONS(4154),
  },
  [3227] = {
    [sym_identifier] = ACTIONS(2956),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2954),
    [anon_sym_COMMA] = ACTIONS(2954),
    [anon_sym_RPAREN] = ACTIONS(2954),
    [aux_sym_preproc_if_token2] = ACTIONS(2954),
    [aux_sym_preproc_else_token1] = ACTIONS(2954),
    [aux_sym_preproc_elif_token1] = ACTIONS(2956),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2954),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2954),
    [anon_sym_DASH] = ACTIONS(2956),
    [anon_sym_PLUS] = ACTIONS(2956),
    [anon_sym_STAR] = ACTIONS(2956),
    [anon_sym_SLASH] = ACTIONS(2956),
    [anon_sym_PERCENT] = ACTIONS(2956),
    [anon_sym_PIPE_PIPE] = ACTIONS(2954),
    [anon_sym_AMP_AMP] = ACTIONS(2954),
    [anon_sym_PIPE] = ACTIONS(2956),
    [anon_sym_CARET] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2956),
    [anon_sym_EQ_EQ] = ACTIONS(2954),
    [anon_sym_BANG_EQ] = ACTIONS(2954),
    [anon_sym_GT] = ACTIONS(2956),
    [anon_sym_GT_EQ] = ACTIONS(2954),
    [anon_sym_LT_EQ] = ACTIONS(2956),
    [anon_sym_LT] = ACTIONS(2956),
    [anon_sym_LT_LT] = ACTIONS(2956),
    [anon_sym_GT_GT] = ACTIONS(2956),
    [anon_sym_COLON] = ACTIONS(2954),
    [anon_sym_SEMI] = ACTIONS(2954),
    [anon_sym___attribute__] = ACTIONS(2956),
    [anon_sym___attribute] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_RBRACK] = ACTIONS(2954),
    [anon_sym_EQ] = ACTIONS(2956),
    [anon_sym_QMARK] = ACTIONS(2954),
    [anon_sym_STAR_EQ] = ACTIONS(2954),
    [anon_sym_SLASH_EQ] = ACTIONS(2954),
    [anon_sym_PERCENT_EQ] = ACTIONS(2954),
    [anon_sym_PLUS_EQ] = ACTIONS(2954),
    [anon_sym_DASH_EQ] = ACTIONS(2954),
    [anon_sym_LT_LT_EQ] = ACTIONS(2954),
    [anon_sym_GT_GT_EQ] = ACTIONS(2954),
    [anon_sym_AMP_EQ] = ACTIONS(2954),
    [anon_sym_CARET_EQ] = ACTIONS(2954),
    [anon_sym_PIPE_EQ] = ACTIONS(2954),
    [anon_sym_and_eq] = ACTIONS(2956),
    [anon_sym_or_eq] = ACTIONS(2956),
    [anon_sym_xor_eq] = ACTIONS(2956),
    [anon_sym_LT_EQ_GT] = ACTIONS(2954),
    [anon_sym_or] = ACTIONS(2956),
    [anon_sym_and] = ACTIONS(2956),
    [anon_sym_bitor] = ACTIONS(2956),
    [anon_sym_xor] = ACTIONS(2956),
    [anon_sym_bitand] = ACTIONS(2956),
    [anon_sym_not_eq] = ACTIONS(2956),
    [anon_sym_is] = ACTIONS(2956),
    [anon_sym_as] = ACTIONS(2956),
    [anon_sym_DASH_DASH] = ACTIONS(2954),
    [anon_sym_PLUS_PLUS] = ACTIONS(2954),
    [anon_sym_DOT] = ACTIONS(2956),
    [anon_sym_DOT_STAR] = ACTIONS(2954),
    [anon_sym_DASH_GT] = ACTIONS(2954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2956),
    [anon_sym_let] = ACTIONS(2956),
    [anon_sym_This] = ACTIONS(2956),
  },
  [3228] = {
    [sym_identifier] = ACTIONS(2960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2958),
    [anon_sym_COMMA] = ACTIONS(2958),
    [anon_sym_RPAREN] = ACTIONS(2958),
    [aux_sym_preproc_if_token2] = ACTIONS(2958),
    [aux_sym_preproc_else_token1] = ACTIONS(2958),
    [aux_sym_preproc_elif_token1] = ACTIONS(2960),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2958),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2958),
    [anon_sym_LPAREN2] = ACTIONS(2958),
    [anon_sym_DASH] = ACTIONS(2960),
    [anon_sym_PLUS] = ACTIONS(2960),
    [anon_sym_STAR] = ACTIONS(2960),
    [anon_sym_SLASH] = ACTIONS(2960),
    [anon_sym_PERCENT] = ACTIONS(2960),
    [anon_sym_PIPE_PIPE] = ACTIONS(2958),
    [anon_sym_AMP_AMP] = ACTIONS(2958),
    [anon_sym_PIPE] = ACTIONS(2960),
    [anon_sym_CARET] = ACTIONS(2960),
    [anon_sym_AMP] = ACTIONS(2960),
    [anon_sym_EQ_EQ] = ACTIONS(2958),
    [anon_sym_BANG_EQ] = ACTIONS(2958),
    [anon_sym_GT] = ACTIONS(2960),
    [anon_sym_GT_EQ] = ACTIONS(2958),
    [anon_sym_LT_EQ] = ACTIONS(2960),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_LT_LT] = ACTIONS(2960),
    [anon_sym_GT_GT] = ACTIONS(2960),
    [anon_sym_COLON] = ACTIONS(2958),
    [anon_sym_SEMI] = ACTIONS(2958),
    [anon_sym___attribute__] = ACTIONS(2960),
    [anon_sym___attribute] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2958),
    [anon_sym_RBRACE] = ACTIONS(2958),
    [anon_sym_LBRACK] = ACTIONS(2958),
    [anon_sym_RBRACK] = ACTIONS(2958),
    [anon_sym_EQ] = ACTIONS(2960),
    [anon_sym_QMARK] = ACTIONS(2958),
    [anon_sym_STAR_EQ] = ACTIONS(2958),
    [anon_sym_SLASH_EQ] = ACTIONS(2958),
    [anon_sym_PERCENT_EQ] = ACTIONS(2958),
    [anon_sym_PLUS_EQ] = ACTIONS(2958),
    [anon_sym_DASH_EQ] = ACTIONS(2958),
    [anon_sym_LT_LT_EQ] = ACTIONS(2958),
    [anon_sym_GT_GT_EQ] = ACTIONS(2958),
    [anon_sym_AMP_EQ] = ACTIONS(2958),
    [anon_sym_CARET_EQ] = ACTIONS(2958),
    [anon_sym_PIPE_EQ] = ACTIONS(2958),
    [anon_sym_and_eq] = ACTIONS(2960),
    [anon_sym_or_eq] = ACTIONS(2960),
    [anon_sym_xor_eq] = ACTIONS(2960),
    [anon_sym_LT_EQ_GT] = ACTIONS(2958),
    [anon_sym_or] = ACTIONS(2960),
    [anon_sym_and] = ACTIONS(2960),
    [anon_sym_bitor] = ACTIONS(2960),
    [anon_sym_xor] = ACTIONS(2960),
    [anon_sym_bitand] = ACTIONS(2960),
    [anon_sym_not_eq] = ACTIONS(2960),
    [anon_sym_is] = ACTIONS(2960),
    [anon_sym_as] = ACTIONS(2960),
    [anon_sym_DASH_DASH] = ACTIONS(2958),
    [anon_sym_PLUS_PLUS] = ACTIONS(2958),
    [anon_sym_DOT] = ACTIONS(2960),
    [anon_sym_DOT_STAR] = ACTIONS(2958),
    [anon_sym_DASH_GT] = ACTIONS(2958),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2960),
    [anon_sym_let] = ACTIONS(2960),
    [anon_sym_This] = ACTIONS(2960),
  },
  [3229] = {
    [sym_identifier] = ACTIONS(2964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2962),
    [anon_sym_RPAREN] = ACTIONS(2962),
    [aux_sym_preproc_if_token2] = ACTIONS(2962),
    [aux_sym_preproc_else_token1] = ACTIONS(2962),
    [aux_sym_preproc_elif_token1] = ACTIONS(2964),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2962),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2962),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2964),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_STAR] = ACTIONS(2964),
    [anon_sym_SLASH] = ACTIONS(2964),
    [anon_sym_PERCENT] = ACTIONS(2964),
    [anon_sym_PIPE_PIPE] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_PIPE] = ACTIONS(2964),
    [anon_sym_CARET] = ACTIONS(2964),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_EQ_EQ] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_GT] = ACTIONS(2964),
    [anon_sym_GT_EQ] = ACTIONS(2962),
    [anon_sym_LT_EQ] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_LT_LT] = ACTIONS(2964),
    [anon_sym_GT_GT] = ACTIONS(2964),
    [anon_sym_COLON] = ACTIONS(2962),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym___attribute__] = ACTIONS(2964),
    [anon_sym___attribute] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_RBRACK] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(2964),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_STAR_EQ] = ACTIONS(2962),
    [anon_sym_SLASH_EQ] = ACTIONS(2962),
    [anon_sym_PERCENT_EQ] = ACTIONS(2962),
    [anon_sym_PLUS_EQ] = ACTIONS(2962),
    [anon_sym_DASH_EQ] = ACTIONS(2962),
    [anon_sym_LT_LT_EQ] = ACTIONS(2962),
    [anon_sym_GT_GT_EQ] = ACTIONS(2962),
    [anon_sym_AMP_EQ] = ACTIONS(2962),
    [anon_sym_CARET_EQ] = ACTIONS(2962),
    [anon_sym_PIPE_EQ] = ACTIONS(2962),
    [anon_sym_and_eq] = ACTIONS(2964),
    [anon_sym_or_eq] = ACTIONS(2964),
    [anon_sym_xor_eq] = ACTIONS(2964),
    [anon_sym_LT_EQ_GT] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2964),
    [anon_sym_and] = ACTIONS(2964),
    [anon_sym_bitor] = ACTIONS(2964),
    [anon_sym_xor] = ACTIONS(2964),
    [anon_sym_bitand] = ACTIONS(2964),
    [anon_sym_not_eq] = ACTIONS(2964),
    [anon_sym_is] = ACTIONS(2964),
    [anon_sym_as] = ACTIONS(2964),
    [anon_sym_DASH_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_PLUS] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2964),
    [anon_sym_DOT_STAR] = ACTIONS(2962),
    [anon_sym_DASH_GT] = ACTIONS(2962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2964),
    [anon_sym_let] = ACTIONS(2964),
    [anon_sym_This] = ACTIONS(2964),
  },
  [3230] = {
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2972),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_RPAREN] = ACTIONS(2972),
    [aux_sym_preproc_if_token2] = ACTIONS(2972),
    [aux_sym_preproc_else_token1] = ACTIONS(2972),
    [aux_sym_preproc_elif_token1] = ACTIONS(2974),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2972),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2972),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_STAR] = ACTIONS(2974),
    [anon_sym_SLASH] = ACTIONS(2974),
    [anon_sym_PERCENT] = ACTIONS(2974),
    [anon_sym_PIPE_PIPE] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_PIPE] = ACTIONS(2974),
    [anon_sym_CARET] = ACTIONS(2974),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_EQ_EQ] = ACTIONS(2972),
    [anon_sym_BANG_EQ] = ACTIONS(2972),
    [anon_sym_GT] = ACTIONS(2974),
    [anon_sym_GT_EQ] = ACTIONS(2972),
    [anon_sym_LT_EQ] = ACTIONS(2974),
    [anon_sym_LT] = ACTIONS(2974),
    [anon_sym_LT_LT] = ACTIONS(2974),
    [anon_sym_GT_GT] = ACTIONS(2974),
    [anon_sym_COLON] = ACTIONS(2972),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym___attribute__] = ACTIONS(2974),
    [anon_sym___attribute] = ACTIONS(2974),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_RBRACK] = ACTIONS(2972),
    [anon_sym_EQ] = ACTIONS(2974),
    [anon_sym_QMARK] = ACTIONS(2972),
    [anon_sym_STAR_EQ] = ACTIONS(2972),
    [anon_sym_SLASH_EQ] = ACTIONS(2972),
    [anon_sym_PERCENT_EQ] = ACTIONS(2972),
    [anon_sym_PLUS_EQ] = ACTIONS(2972),
    [anon_sym_DASH_EQ] = ACTIONS(2972),
    [anon_sym_LT_LT_EQ] = ACTIONS(2972),
    [anon_sym_GT_GT_EQ] = ACTIONS(2972),
    [anon_sym_AMP_EQ] = ACTIONS(2972),
    [anon_sym_CARET_EQ] = ACTIONS(2972),
    [anon_sym_PIPE_EQ] = ACTIONS(2972),
    [anon_sym_and_eq] = ACTIONS(2974),
    [anon_sym_or_eq] = ACTIONS(2974),
    [anon_sym_xor_eq] = ACTIONS(2974),
    [anon_sym_LT_EQ_GT] = ACTIONS(2972),
    [anon_sym_or] = ACTIONS(2974),
    [anon_sym_and] = ACTIONS(2974),
    [anon_sym_bitor] = ACTIONS(2974),
    [anon_sym_xor] = ACTIONS(2974),
    [anon_sym_bitand] = ACTIONS(2974),
    [anon_sym_not_eq] = ACTIONS(2974),
    [anon_sym_is] = ACTIONS(2974),
    [anon_sym_as] = ACTIONS(2974),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_DOT] = ACTIONS(2974),
    [anon_sym_DOT_STAR] = ACTIONS(2972),
    [anon_sym_DASH_GT] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_This] = ACTIONS(2974),
  },
  [3231] = {
    [sym_attribute_specifier] = STATE(3033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4058),
    [anon_sym_COMMA] = ACTIONS(4058),
    [anon_sym_RPAREN] = ACTIONS(4058),
    [anon_sym_LPAREN2] = ACTIONS(4058),
    [anon_sym_DASH] = ACTIONS(4060),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_STAR] = ACTIONS(4058),
    [anon_sym_SLASH] = ACTIONS(4060),
    [anon_sym_PERCENT] = ACTIONS(4058),
    [anon_sym_PIPE_PIPE] = ACTIONS(4058),
    [anon_sym_AMP_AMP] = ACTIONS(4058),
    [anon_sym_PIPE] = ACTIONS(4060),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_AMP] = ACTIONS(4060),
    [anon_sym_EQ_EQ] = ACTIONS(4058),
    [anon_sym_BANG_EQ] = ACTIONS(4058),
    [anon_sym_GT] = ACTIONS(4060),
    [anon_sym_GT_EQ] = ACTIONS(4058),
    [anon_sym_LT_EQ] = ACTIONS(4060),
    [anon_sym_LT] = ACTIONS(4060),
    [anon_sym_LT_LT] = ACTIONS(4058),
    [anon_sym_GT_GT] = ACTIONS(4058),
    [anon_sym_COLON] = ACTIONS(4058),
    [anon_sym_SEMI] = ACTIONS(4058),
    [anon_sym___extension__] = ACTIONS(4058),
    [anon_sym___attribute__] = ACTIONS(7346),
    [anon_sym___attribute] = ACTIONS(7348),
    [anon_sym_LBRACE] = ACTIONS(4058),
    [anon_sym_RBRACE] = ACTIONS(4058),
    [anon_sym_LBRACK] = ACTIONS(4058),
    [anon_sym_RBRACK] = ACTIONS(4058),
    [anon_sym_const] = ACTIONS(4060),
    [anon_sym_constexpr] = ACTIONS(4058),
    [anon_sym_volatile] = ACTIONS(4058),
    [anon_sym_restrict] = ACTIONS(4058),
    [anon_sym___restrict__] = ACTIONS(4058),
    [anon_sym__Atomic] = ACTIONS(4058),
    [anon_sym__Noreturn] = ACTIONS(4058),
    [anon_sym_noreturn] = ACTIONS(4058),
    [anon_sym__Nonnull] = ACTIONS(4058),
    [anon_sym_mutable] = ACTIONS(4058),
    [anon_sym_constinit] = ACTIONS(4058),
    [anon_sym_consteval] = ACTIONS(4058),
    [anon_sym_alignas] = ACTIONS(4058),
    [anon_sym__Alignas] = ACTIONS(4058),
    [anon_sym_QMARK] = ACTIONS(4058),
    [anon_sym_LT_EQ_GT] = ACTIONS(4058),
    [anon_sym_or] = ACTIONS(4058),
    [anon_sym_and] = ACTIONS(4058),
    [anon_sym_bitor] = ACTIONS(4058),
    [anon_sym_xor] = ACTIONS(4058),
    [anon_sym_bitand] = ACTIONS(4058),
    [anon_sym_not_eq] = ACTIONS(4058),
    [anon_sym_is] = ACTIONS(4058),
    [anon_sym_as] = ACTIONS(4058),
    [anon_sym_DASH_DASH] = ACTIONS(4058),
    [anon_sym_PLUS_PLUS] = ACTIONS(4058),
    [anon_sym_DOT] = ACTIONS(4060),
    [anon_sym_DOT_STAR] = ACTIONS(4058),
    [anon_sym_DASH_GT] = ACTIONS(4058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4058),
    [anon_sym_let] = ACTIONS(4058),
    [anon_sym_This] = ACTIONS(4058),
    [anon_sym_final] = ACTIONS(4058),
    [anon_sym_override] = ACTIONS(4058),
    [anon_sym_requires] = ACTIONS(4058),
    [anon_sym_where] = ACTIONS(4058),
  },
  [3232] = {
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2976),
    [anon_sym_COMMA] = ACTIONS(2976),
    [anon_sym_RPAREN] = ACTIONS(2976),
    [aux_sym_preproc_if_token2] = ACTIONS(2976),
    [aux_sym_preproc_else_token1] = ACTIONS(2976),
    [aux_sym_preproc_elif_token1] = ACTIONS(2978),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2976),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2976),
    [anon_sym_LPAREN2] = ACTIONS(2976),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_STAR] = ACTIONS(2978),
    [anon_sym_SLASH] = ACTIONS(2978),
    [anon_sym_PERCENT] = ACTIONS(2978),
    [anon_sym_PIPE_PIPE] = ACTIONS(2976),
    [anon_sym_AMP_AMP] = ACTIONS(2976),
    [anon_sym_PIPE] = ACTIONS(2978),
    [anon_sym_CARET] = ACTIONS(2978),
    [anon_sym_AMP] = ACTIONS(2978),
    [anon_sym_EQ_EQ] = ACTIONS(2976),
    [anon_sym_BANG_EQ] = ACTIONS(2976),
    [anon_sym_GT] = ACTIONS(2978),
    [anon_sym_GT_EQ] = ACTIONS(2976),
    [anon_sym_LT_EQ] = ACTIONS(2978),
    [anon_sym_LT] = ACTIONS(2978),
    [anon_sym_LT_LT] = ACTIONS(2978),
    [anon_sym_GT_GT] = ACTIONS(2978),
    [anon_sym_COLON] = ACTIONS(2976),
    [anon_sym_SEMI] = ACTIONS(2976),
    [anon_sym___attribute__] = ACTIONS(2978),
    [anon_sym___attribute] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(2976),
    [anon_sym_RBRACE] = ACTIONS(2976),
    [anon_sym_LBRACK] = ACTIONS(2976),
    [anon_sym_RBRACK] = ACTIONS(2976),
    [anon_sym_EQ] = ACTIONS(2978),
    [anon_sym_QMARK] = ACTIONS(2976),
    [anon_sym_STAR_EQ] = ACTIONS(2976),
    [anon_sym_SLASH_EQ] = ACTIONS(2976),
    [anon_sym_PERCENT_EQ] = ACTIONS(2976),
    [anon_sym_PLUS_EQ] = ACTIONS(2976),
    [anon_sym_DASH_EQ] = ACTIONS(2976),
    [anon_sym_LT_LT_EQ] = ACTIONS(2976),
    [anon_sym_GT_GT_EQ] = ACTIONS(2976),
    [anon_sym_AMP_EQ] = ACTIONS(2976),
    [anon_sym_CARET_EQ] = ACTIONS(2976),
    [anon_sym_PIPE_EQ] = ACTIONS(2976),
    [anon_sym_and_eq] = ACTIONS(2978),
    [anon_sym_or_eq] = ACTIONS(2978),
    [anon_sym_xor_eq] = ACTIONS(2978),
    [anon_sym_LT_EQ_GT] = ACTIONS(2976),
    [anon_sym_or] = ACTIONS(2978),
    [anon_sym_and] = ACTIONS(2978),
    [anon_sym_bitor] = ACTIONS(2978),
    [anon_sym_xor] = ACTIONS(2978),
    [anon_sym_bitand] = ACTIONS(2978),
    [anon_sym_not_eq] = ACTIONS(2978),
    [anon_sym_is] = ACTIONS(2978),
    [anon_sym_as] = ACTIONS(2978),
    [anon_sym_DASH_DASH] = ACTIONS(2976),
    [anon_sym_PLUS_PLUS] = ACTIONS(2976),
    [anon_sym_DOT] = ACTIONS(2978),
    [anon_sym_DOT_STAR] = ACTIONS(2976),
    [anon_sym_DASH_GT] = ACTIONS(2976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_This] = ACTIONS(2978),
  },
  [3233] = {
    [sym_identifier] = ACTIONS(3022),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3020),
    [anon_sym_COMMA] = ACTIONS(3020),
    [anon_sym_RPAREN] = ACTIONS(3020),
    [aux_sym_preproc_if_token2] = ACTIONS(3020),
    [aux_sym_preproc_else_token1] = ACTIONS(3020),
    [aux_sym_preproc_elif_token1] = ACTIONS(3022),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3020),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3020),
    [anon_sym_LPAREN2] = ACTIONS(3020),
    [anon_sym_DASH] = ACTIONS(3022),
    [anon_sym_PLUS] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3022),
    [anon_sym_SLASH] = ACTIONS(3022),
    [anon_sym_PERCENT] = ACTIONS(3022),
    [anon_sym_PIPE_PIPE] = ACTIONS(3020),
    [anon_sym_AMP_AMP] = ACTIONS(3020),
    [anon_sym_PIPE] = ACTIONS(3022),
    [anon_sym_CARET] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3022),
    [anon_sym_EQ_EQ] = ACTIONS(3020),
    [anon_sym_BANG_EQ] = ACTIONS(3020),
    [anon_sym_GT] = ACTIONS(3022),
    [anon_sym_GT_EQ] = ACTIONS(3020),
    [anon_sym_LT_EQ] = ACTIONS(3022),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_LT_LT] = ACTIONS(3022),
    [anon_sym_GT_GT] = ACTIONS(3022),
    [anon_sym_COLON] = ACTIONS(3020),
    [anon_sym_SEMI] = ACTIONS(3020),
    [anon_sym___attribute__] = ACTIONS(3022),
    [anon_sym___attribute] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3020),
    [anon_sym_RBRACE] = ACTIONS(3020),
    [anon_sym_LBRACK] = ACTIONS(3020),
    [anon_sym_RBRACK] = ACTIONS(3020),
    [anon_sym_EQ] = ACTIONS(3022),
    [anon_sym_QMARK] = ACTIONS(3020),
    [anon_sym_STAR_EQ] = ACTIONS(3020),
    [anon_sym_SLASH_EQ] = ACTIONS(3020),
    [anon_sym_PERCENT_EQ] = ACTIONS(3020),
    [anon_sym_PLUS_EQ] = ACTIONS(3020),
    [anon_sym_DASH_EQ] = ACTIONS(3020),
    [anon_sym_LT_LT_EQ] = ACTIONS(3020),
    [anon_sym_GT_GT_EQ] = ACTIONS(3020),
    [anon_sym_AMP_EQ] = ACTIONS(3020),
    [anon_sym_CARET_EQ] = ACTIONS(3020),
    [anon_sym_PIPE_EQ] = ACTIONS(3020),
    [anon_sym_and_eq] = ACTIONS(3022),
    [anon_sym_or_eq] = ACTIONS(3022),
    [anon_sym_xor_eq] = ACTIONS(3022),
    [anon_sym_LT_EQ_GT] = ACTIONS(3020),
    [anon_sym_or] = ACTIONS(3022),
    [anon_sym_and] = ACTIONS(3022),
    [anon_sym_bitor] = ACTIONS(3022),
    [anon_sym_xor] = ACTIONS(3022),
    [anon_sym_bitand] = ACTIONS(3022),
    [anon_sym_not_eq] = ACTIONS(3022),
    [anon_sym_is] = ACTIONS(3022),
    [anon_sym_as] = ACTIONS(3022),
    [anon_sym_DASH_DASH] = ACTIONS(3020),
    [anon_sym_PLUS_PLUS] = ACTIONS(3020),
    [anon_sym_DOT] = ACTIONS(3022),
    [anon_sym_DOT_STAR] = ACTIONS(3020),
    [anon_sym_DASH_GT] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3022),
    [anon_sym_let] = ACTIONS(3022),
    [anon_sym_This] = ACTIONS(3022),
  },
  [3234] = {
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2932),
    [anon_sym_COMMA] = ACTIONS(2932),
    [anon_sym_RPAREN] = ACTIONS(2932),
    [aux_sym_preproc_if_token2] = ACTIONS(2932),
    [aux_sym_preproc_else_token1] = ACTIONS(2932),
    [aux_sym_preproc_elif_token1] = ACTIONS(2934),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2932),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2932),
    [anon_sym_LPAREN2] = ACTIONS(2932),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_STAR] = ACTIONS(2934),
    [anon_sym_SLASH] = ACTIONS(2934),
    [anon_sym_PERCENT] = ACTIONS(2934),
    [anon_sym_PIPE_PIPE] = ACTIONS(2932),
    [anon_sym_AMP_AMP] = ACTIONS(2932),
    [anon_sym_PIPE] = ACTIONS(2934),
    [anon_sym_CARET] = ACTIONS(2934),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_EQ_EQ] = ACTIONS(2932),
    [anon_sym_BANG_EQ] = ACTIONS(2932),
    [anon_sym_GT] = ACTIONS(2934),
    [anon_sym_GT_EQ] = ACTIONS(2932),
    [anon_sym_LT_EQ] = ACTIONS(2934),
    [anon_sym_LT] = ACTIONS(2934),
    [anon_sym_LT_LT] = ACTIONS(2934),
    [anon_sym_GT_GT] = ACTIONS(2934),
    [anon_sym_COLON] = ACTIONS(2932),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym___attribute__] = ACTIONS(2934),
    [anon_sym___attribute] = ACTIONS(2934),
    [anon_sym_LBRACE] = ACTIONS(2932),
    [anon_sym_RBRACE] = ACTIONS(2932),
    [anon_sym_LBRACK] = ACTIONS(2932),
    [anon_sym_RBRACK] = ACTIONS(2932),
    [anon_sym_EQ] = ACTIONS(2934),
    [anon_sym_QMARK] = ACTIONS(2932),
    [anon_sym_STAR_EQ] = ACTIONS(2932),
    [anon_sym_SLASH_EQ] = ACTIONS(2932),
    [anon_sym_PERCENT_EQ] = ACTIONS(2932),
    [anon_sym_PLUS_EQ] = ACTIONS(2932),
    [anon_sym_DASH_EQ] = ACTIONS(2932),
    [anon_sym_LT_LT_EQ] = ACTIONS(2932),
    [anon_sym_GT_GT_EQ] = ACTIONS(2932),
    [anon_sym_AMP_EQ] = ACTIONS(2932),
    [anon_sym_CARET_EQ] = ACTIONS(2932),
    [anon_sym_PIPE_EQ] = ACTIONS(2932),
    [anon_sym_and_eq] = ACTIONS(2934),
    [anon_sym_or_eq] = ACTIONS(2934),
    [anon_sym_xor_eq] = ACTIONS(2934),
    [anon_sym_LT_EQ_GT] = ACTIONS(2932),
    [anon_sym_or] = ACTIONS(2934),
    [anon_sym_and] = ACTIONS(2934),
    [anon_sym_bitor] = ACTIONS(2934),
    [anon_sym_xor] = ACTIONS(2934),
    [anon_sym_bitand] = ACTIONS(2934),
    [anon_sym_not_eq] = ACTIONS(2934),
    [anon_sym_is] = ACTIONS(2934),
    [anon_sym_as] = ACTIONS(2934),
    [anon_sym_DASH_DASH] = ACTIONS(2932),
    [anon_sym_PLUS_PLUS] = ACTIONS(2932),
    [anon_sym_DOT] = ACTIONS(2934),
    [anon_sym_DOT_STAR] = ACTIONS(2932),
    [anon_sym_DASH_GT] = ACTIONS(2932),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_This] = ACTIONS(2934),
  },
  [3235] = {
    [sym_identifier] = ACTIONS(2926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2924),
    [anon_sym_COMMA] = ACTIONS(2924),
    [anon_sym_RPAREN] = ACTIONS(2924),
    [aux_sym_preproc_if_token2] = ACTIONS(2924),
    [aux_sym_preproc_else_token1] = ACTIONS(2924),
    [aux_sym_preproc_elif_token1] = ACTIONS(2926),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2924),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2924),
    [anon_sym_LPAREN2] = ACTIONS(2924),
    [anon_sym_DASH] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2926),
    [anon_sym_STAR] = ACTIONS(2926),
    [anon_sym_SLASH] = ACTIONS(2926),
    [anon_sym_PERCENT] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2924),
    [anon_sym_AMP_AMP] = ACTIONS(2924),
    [anon_sym_PIPE] = ACTIONS(2926),
    [anon_sym_CARET] = ACTIONS(2926),
    [anon_sym_AMP] = ACTIONS(2926),
    [anon_sym_EQ_EQ] = ACTIONS(2924),
    [anon_sym_BANG_EQ] = ACTIONS(2924),
    [anon_sym_GT] = ACTIONS(2926),
    [anon_sym_GT_EQ] = ACTIONS(2924),
    [anon_sym_LT_EQ] = ACTIONS(2926),
    [anon_sym_LT] = ACTIONS(2926),
    [anon_sym_LT_LT] = ACTIONS(2926),
    [anon_sym_GT_GT] = ACTIONS(2926),
    [anon_sym_COLON] = ACTIONS(2924),
    [anon_sym_SEMI] = ACTIONS(2924),
    [anon_sym___attribute__] = ACTIONS(2926),
    [anon_sym___attribute] = ACTIONS(2926),
    [anon_sym_LBRACE] = ACTIONS(2924),
    [anon_sym_RBRACE] = ACTIONS(2924),
    [anon_sym_LBRACK] = ACTIONS(2924),
    [anon_sym_RBRACK] = ACTIONS(2924),
    [anon_sym_EQ] = ACTIONS(2926),
    [anon_sym_QMARK] = ACTIONS(2924),
    [anon_sym_STAR_EQ] = ACTIONS(2924),
    [anon_sym_SLASH_EQ] = ACTIONS(2924),
    [anon_sym_PERCENT_EQ] = ACTIONS(2924),
    [anon_sym_PLUS_EQ] = ACTIONS(2924),
    [anon_sym_DASH_EQ] = ACTIONS(2924),
    [anon_sym_LT_LT_EQ] = ACTIONS(2924),
    [anon_sym_GT_GT_EQ] = ACTIONS(2924),
    [anon_sym_AMP_EQ] = ACTIONS(2924),
    [anon_sym_CARET_EQ] = ACTIONS(2924),
    [anon_sym_PIPE_EQ] = ACTIONS(2924),
    [anon_sym_and_eq] = ACTIONS(2926),
    [anon_sym_or_eq] = ACTIONS(2926),
    [anon_sym_xor_eq] = ACTIONS(2926),
    [anon_sym_LT_EQ_GT] = ACTIONS(2924),
    [anon_sym_or] = ACTIONS(2926),
    [anon_sym_and] = ACTIONS(2926),
    [anon_sym_bitor] = ACTIONS(2926),
    [anon_sym_xor] = ACTIONS(2926),
    [anon_sym_bitand] = ACTIONS(2926),
    [anon_sym_not_eq] = ACTIONS(2926),
    [anon_sym_is] = ACTIONS(2926),
    [anon_sym_as] = ACTIONS(2926),
    [anon_sym_DASH_DASH] = ACTIONS(2924),
    [anon_sym_PLUS_PLUS] = ACTIONS(2924),
    [anon_sym_DOT] = ACTIONS(2926),
    [anon_sym_DOT_STAR] = ACTIONS(2924),
    [anon_sym_DASH_GT] = ACTIONS(2924),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2926),
    [anon_sym_let] = ACTIONS(2926),
    [anon_sym_This] = ACTIONS(2926),
  },
  [3236] = {
    [sym_identifier] = ACTIONS(2930),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2928),
    [anon_sym_COMMA] = ACTIONS(2928),
    [anon_sym_RPAREN] = ACTIONS(2928),
    [aux_sym_preproc_if_token2] = ACTIONS(2928),
    [aux_sym_preproc_else_token1] = ACTIONS(2928),
    [aux_sym_preproc_elif_token1] = ACTIONS(2930),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2928),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2928),
    [anon_sym_LPAREN2] = ACTIONS(2928),
    [anon_sym_DASH] = ACTIONS(2930),
    [anon_sym_PLUS] = ACTIONS(2930),
    [anon_sym_STAR] = ACTIONS(2930),
    [anon_sym_SLASH] = ACTIONS(2930),
    [anon_sym_PERCENT] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2928),
    [anon_sym_AMP_AMP] = ACTIONS(2928),
    [anon_sym_PIPE] = ACTIONS(2930),
    [anon_sym_CARET] = ACTIONS(2930),
    [anon_sym_AMP] = ACTIONS(2930),
    [anon_sym_EQ_EQ] = ACTIONS(2928),
    [anon_sym_BANG_EQ] = ACTIONS(2928),
    [anon_sym_GT] = ACTIONS(2930),
    [anon_sym_GT_EQ] = ACTIONS(2928),
    [anon_sym_LT_EQ] = ACTIONS(2930),
    [anon_sym_LT] = ACTIONS(2930),
    [anon_sym_LT_LT] = ACTIONS(2930),
    [anon_sym_GT_GT] = ACTIONS(2930),
    [anon_sym_COLON] = ACTIONS(2928),
    [anon_sym_SEMI] = ACTIONS(2928),
    [anon_sym___attribute__] = ACTIONS(2930),
    [anon_sym___attribute] = ACTIONS(2930),
    [anon_sym_LBRACE] = ACTIONS(2928),
    [anon_sym_RBRACE] = ACTIONS(2928),
    [anon_sym_LBRACK] = ACTIONS(2928),
    [anon_sym_RBRACK] = ACTIONS(2928),
    [anon_sym_EQ] = ACTIONS(2930),
    [anon_sym_QMARK] = ACTIONS(2928),
    [anon_sym_STAR_EQ] = ACTIONS(2928),
    [anon_sym_SLASH_EQ] = ACTIONS(2928),
    [anon_sym_PERCENT_EQ] = ACTIONS(2928),
    [anon_sym_PLUS_EQ] = ACTIONS(2928),
    [anon_sym_DASH_EQ] = ACTIONS(2928),
    [anon_sym_LT_LT_EQ] = ACTIONS(2928),
    [anon_sym_GT_GT_EQ] = ACTIONS(2928),
    [anon_sym_AMP_EQ] = ACTIONS(2928),
    [anon_sym_CARET_EQ] = ACTIONS(2928),
    [anon_sym_PIPE_EQ] = ACTIONS(2928),
    [anon_sym_and_eq] = ACTIONS(2930),
    [anon_sym_or_eq] = ACTIONS(2930),
    [anon_sym_xor_eq] = ACTIONS(2930),
    [anon_sym_LT_EQ_GT] = ACTIONS(2928),
    [anon_sym_or] = ACTIONS(2930),
    [anon_sym_and] = ACTIONS(2930),
    [anon_sym_bitor] = ACTIONS(2930),
    [anon_sym_xor] = ACTIONS(2930),
    [anon_sym_bitand] = ACTIONS(2930),
    [anon_sym_not_eq] = ACTIONS(2930),
    [anon_sym_is] = ACTIONS(2930),
    [anon_sym_as] = ACTIONS(2930),
    [anon_sym_DASH_DASH] = ACTIONS(2928),
    [anon_sym_PLUS_PLUS] = ACTIONS(2928),
    [anon_sym_DOT] = ACTIONS(2930),
    [anon_sym_DOT_STAR] = ACTIONS(2928),
    [anon_sym_DASH_GT] = ACTIONS(2928),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2930),
    [anon_sym_This] = ACTIONS(2930),
  },
  [3237] = {
    [sym_attribute_specifier] = STATE(3037),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4043),
    [anon_sym_COMMA] = ACTIONS(4043),
    [anon_sym_RPAREN] = ACTIONS(4043),
    [anon_sym_LPAREN2] = ACTIONS(4043),
    [anon_sym_DASH] = ACTIONS(4045),
    [anon_sym_PLUS] = ACTIONS(4045),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4045),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4043),
    [anon_sym_AMP_AMP] = ACTIONS(4043),
    [anon_sym_PIPE] = ACTIONS(4045),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4043),
    [anon_sym_BANG_EQ] = ACTIONS(4043),
    [anon_sym_GT] = ACTIONS(4045),
    [anon_sym_GT_EQ] = ACTIONS(4043),
    [anon_sym_LT_EQ] = ACTIONS(4045),
    [anon_sym_LT] = ACTIONS(4045),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_COLON] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4043),
    [anon_sym___extension__] = ACTIONS(4043),
    [anon_sym___attribute__] = ACTIONS(7346),
    [anon_sym___attribute] = ACTIONS(7348),
    [anon_sym_LBRACE] = ACTIONS(4043),
    [anon_sym_RBRACE] = ACTIONS(4043),
    [anon_sym_LBRACK] = ACTIONS(4043),
    [anon_sym_RBRACK] = ACTIONS(4043),
    [anon_sym_const] = ACTIONS(4045),
    [anon_sym_constexpr] = ACTIONS(4043),
    [anon_sym_volatile] = ACTIONS(4043),
    [anon_sym_restrict] = ACTIONS(4043),
    [anon_sym___restrict__] = ACTIONS(4043),
    [anon_sym__Atomic] = ACTIONS(4043),
    [anon_sym__Noreturn] = ACTIONS(4043),
    [anon_sym_noreturn] = ACTIONS(4043),
    [anon_sym__Nonnull] = ACTIONS(4043),
    [anon_sym_mutable] = ACTIONS(4043),
    [anon_sym_constinit] = ACTIONS(4043),
    [anon_sym_consteval] = ACTIONS(4043),
    [anon_sym_alignas] = ACTIONS(4043),
    [anon_sym__Alignas] = ACTIONS(4043),
    [anon_sym_QMARK] = ACTIONS(4043),
    [anon_sym_LT_EQ_GT] = ACTIONS(4043),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4043),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4043),
    [anon_sym_not_eq] = ACTIONS(4043),
    [anon_sym_is] = ACTIONS(4043),
    [anon_sym_as] = ACTIONS(4043),
    [anon_sym_DASH_DASH] = ACTIONS(4043),
    [anon_sym_PLUS_PLUS] = ACTIONS(4043),
    [anon_sym_DOT] = ACTIONS(4045),
    [anon_sym_DOT_STAR] = ACTIONS(4043),
    [anon_sym_DASH_GT] = ACTIONS(4043),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4043),
    [anon_sym_let] = ACTIONS(4043),
    [anon_sym_This] = ACTIONS(4043),
    [anon_sym_final] = ACTIONS(4043),
    [anon_sym_override] = ACTIONS(4043),
    [anon_sym_requires] = ACTIONS(4043),
    [anon_sym_where] = ACTIONS(4043),
  },
  [3238] = {
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2932),
    [anon_sym_COMMA] = ACTIONS(2932),
    [anon_sym_RPAREN] = ACTIONS(2932),
    [aux_sym_preproc_if_token2] = ACTIONS(2932),
    [aux_sym_preproc_else_token1] = ACTIONS(2932),
    [aux_sym_preproc_elif_token1] = ACTIONS(2934),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2932),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2932),
    [anon_sym_LPAREN2] = ACTIONS(2932),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_STAR] = ACTIONS(2934),
    [anon_sym_SLASH] = ACTIONS(2934),
    [anon_sym_PERCENT] = ACTIONS(2934),
    [anon_sym_PIPE_PIPE] = ACTIONS(2932),
    [anon_sym_AMP_AMP] = ACTIONS(2932),
    [anon_sym_PIPE] = ACTIONS(2934),
    [anon_sym_CARET] = ACTIONS(2934),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_EQ_EQ] = ACTIONS(2932),
    [anon_sym_BANG_EQ] = ACTIONS(2932),
    [anon_sym_GT] = ACTIONS(2934),
    [anon_sym_GT_EQ] = ACTIONS(2932),
    [anon_sym_LT_EQ] = ACTIONS(2934),
    [anon_sym_LT] = ACTIONS(2934),
    [anon_sym_LT_LT] = ACTIONS(2934),
    [anon_sym_GT_GT] = ACTIONS(2934),
    [anon_sym_COLON] = ACTIONS(2932),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym___attribute__] = ACTIONS(2934),
    [anon_sym___attribute] = ACTIONS(2934),
    [anon_sym_LBRACE] = ACTIONS(2932),
    [anon_sym_RBRACE] = ACTIONS(2932),
    [anon_sym_LBRACK] = ACTIONS(2932),
    [anon_sym_RBRACK] = ACTIONS(2932),
    [anon_sym_EQ] = ACTIONS(2934),
    [anon_sym_QMARK] = ACTIONS(2932),
    [anon_sym_STAR_EQ] = ACTIONS(2932),
    [anon_sym_SLASH_EQ] = ACTIONS(2932),
    [anon_sym_PERCENT_EQ] = ACTIONS(2932),
    [anon_sym_PLUS_EQ] = ACTIONS(2932),
    [anon_sym_DASH_EQ] = ACTIONS(2932),
    [anon_sym_LT_LT_EQ] = ACTIONS(2932),
    [anon_sym_GT_GT_EQ] = ACTIONS(2932),
    [anon_sym_AMP_EQ] = ACTIONS(2932),
    [anon_sym_CARET_EQ] = ACTIONS(2932),
    [anon_sym_PIPE_EQ] = ACTIONS(2932),
    [anon_sym_and_eq] = ACTIONS(2934),
    [anon_sym_or_eq] = ACTIONS(2934),
    [anon_sym_xor_eq] = ACTIONS(2934),
    [anon_sym_LT_EQ_GT] = ACTIONS(2932),
    [anon_sym_or] = ACTIONS(2934),
    [anon_sym_and] = ACTIONS(2934),
    [anon_sym_bitor] = ACTIONS(2934),
    [anon_sym_xor] = ACTIONS(2934),
    [anon_sym_bitand] = ACTIONS(2934),
    [anon_sym_not_eq] = ACTIONS(2934),
    [anon_sym_is] = ACTIONS(2934),
    [anon_sym_as] = ACTIONS(2934),
    [anon_sym_DASH_DASH] = ACTIONS(2932),
    [anon_sym_PLUS_PLUS] = ACTIONS(2932),
    [anon_sym_DOT] = ACTIONS(2934),
    [anon_sym_DOT_STAR] = ACTIONS(2932),
    [anon_sym_DASH_GT] = ACTIONS(2932),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_This] = ACTIONS(2934),
  },
  [3239] = {
    [sym_attribute_declaration] = STATE(3260),
    [sym_parameter_list] = STATE(3274),
    [aux_sym_attributed_declarator_repeat1] = STATE(3260),
    [sym_identifier] = ACTIONS(7570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7572),
    [anon_sym_COMMA] = ACTIONS(7572),
    [anon_sym_RPAREN] = ACTIONS(7572),
    [aux_sym_preproc_if_token2] = ACTIONS(7572),
    [aux_sym_preproc_else_token1] = ACTIONS(7572),
    [aux_sym_preproc_elif_token1] = ACTIONS(7570),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7572),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7572),
    [anon_sym_LPAREN2] = ACTIONS(7498),
    [anon_sym_DASH] = ACTIONS(7570),
    [anon_sym_PLUS] = ACTIONS(7570),
    [anon_sym_STAR] = ACTIONS(7570),
    [anon_sym_SLASH] = ACTIONS(7570),
    [anon_sym_PERCENT] = ACTIONS(7570),
    [anon_sym_PIPE_PIPE] = ACTIONS(7572),
    [anon_sym_AMP_AMP] = ACTIONS(7572),
    [anon_sym_PIPE] = ACTIONS(7570),
    [anon_sym_CARET] = ACTIONS(7570),
    [anon_sym_AMP] = ACTIONS(7570),
    [anon_sym_EQ_EQ] = ACTIONS(7572),
    [anon_sym_BANG_EQ] = ACTIONS(7572),
    [anon_sym_GT] = ACTIONS(7570),
    [anon_sym_GT_EQ] = ACTIONS(7572),
    [anon_sym_LT_EQ] = ACTIONS(7570),
    [anon_sym_LT] = ACTIONS(7570),
    [anon_sym_LT_LT] = ACTIONS(7570),
    [anon_sym_GT_GT] = ACTIONS(7570),
    [anon_sym_COLON] = ACTIONS(7572),
    [anon_sym_SEMI] = ACTIONS(7572),
    [anon_sym___attribute__] = ACTIONS(7570),
    [anon_sym___attribute] = ACTIONS(7570),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7500),
    [anon_sym_RBRACE] = ACTIONS(7572),
    [anon_sym_LBRACK] = ACTIONS(7502),
    [anon_sym_RBRACK] = ACTIONS(7572),
    [anon_sym_EQ] = ACTIONS(7570),
    [anon_sym_QMARK] = ACTIONS(7572),
    [anon_sym_STAR_EQ] = ACTIONS(7572),
    [anon_sym_SLASH_EQ] = ACTIONS(7572),
    [anon_sym_PERCENT_EQ] = ACTIONS(7572),
    [anon_sym_PLUS_EQ] = ACTIONS(7572),
    [anon_sym_DASH_EQ] = ACTIONS(7572),
    [anon_sym_LT_LT_EQ] = ACTIONS(7572),
    [anon_sym_GT_GT_EQ] = ACTIONS(7572),
    [anon_sym_AMP_EQ] = ACTIONS(7572),
    [anon_sym_CARET_EQ] = ACTIONS(7572),
    [anon_sym_PIPE_EQ] = ACTIONS(7572),
    [anon_sym_and_eq] = ACTIONS(7570),
    [anon_sym_or_eq] = ACTIONS(7570),
    [anon_sym_xor_eq] = ACTIONS(7570),
    [anon_sym_LT_EQ_GT] = ACTIONS(7572),
    [anon_sym_or] = ACTIONS(7570),
    [anon_sym_and] = ACTIONS(7570),
    [anon_sym_bitor] = ACTIONS(7570),
    [anon_sym_xor] = ACTIONS(7570),
    [anon_sym_bitand] = ACTIONS(7570),
    [anon_sym_not_eq] = ACTIONS(7570),
    [anon_sym_is] = ACTIONS(7570),
    [anon_sym_as] = ACTIONS(7570),
    [anon_sym_DASH_DASH] = ACTIONS(7572),
    [anon_sym_PLUS_PLUS] = ACTIONS(7572),
    [anon_sym_DOT] = ACTIONS(7570),
    [anon_sym_DOT_STAR] = ACTIONS(7572),
    [anon_sym_DASH_GT] = ACTIONS(7572),
    [sym_comment] = ACTIONS(3),
  },
  [3240] = {
    [sym_attribute_specifier] = STATE(3039),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4047),
    [anon_sym_COMMA] = ACTIONS(4047),
    [anon_sym_RPAREN] = ACTIONS(4047),
    [anon_sym_LPAREN2] = ACTIONS(4047),
    [anon_sym_DASH] = ACTIONS(4049),
    [anon_sym_PLUS] = ACTIONS(4049),
    [anon_sym_STAR] = ACTIONS(4047),
    [anon_sym_SLASH] = ACTIONS(4049),
    [anon_sym_PERCENT] = ACTIONS(4047),
    [anon_sym_PIPE_PIPE] = ACTIONS(4047),
    [anon_sym_AMP_AMP] = ACTIONS(4047),
    [anon_sym_PIPE] = ACTIONS(4049),
    [anon_sym_CARET] = ACTIONS(4047),
    [anon_sym_AMP] = ACTIONS(4049),
    [anon_sym_EQ_EQ] = ACTIONS(4047),
    [anon_sym_BANG_EQ] = ACTIONS(4047),
    [anon_sym_GT] = ACTIONS(4049),
    [anon_sym_GT_EQ] = ACTIONS(4047),
    [anon_sym_LT_EQ] = ACTIONS(4049),
    [anon_sym_LT] = ACTIONS(4049),
    [anon_sym_LT_LT] = ACTIONS(4047),
    [anon_sym_GT_GT] = ACTIONS(4047),
    [anon_sym_COLON] = ACTIONS(4047),
    [anon_sym_SEMI] = ACTIONS(4047),
    [anon_sym___extension__] = ACTIONS(4047),
    [anon_sym___attribute__] = ACTIONS(7346),
    [anon_sym___attribute] = ACTIONS(7348),
    [anon_sym_LBRACE] = ACTIONS(4047),
    [anon_sym_RBRACE] = ACTIONS(4047),
    [anon_sym_LBRACK] = ACTIONS(4047),
    [anon_sym_RBRACK] = ACTIONS(4047),
    [anon_sym_const] = ACTIONS(4049),
    [anon_sym_constexpr] = ACTIONS(4047),
    [anon_sym_volatile] = ACTIONS(4047),
    [anon_sym_restrict] = ACTIONS(4047),
    [anon_sym___restrict__] = ACTIONS(4047),
    [anon_sym__Atomic] = ACTIONS(4047),
    [anon_sym__Noreturn] = ACTIONS(4047),
    [anon_sym_noreturn] = ACTIONS(4047),
    [anon_sym__Nonnull] = ACTIONS(4047),
    [anon_sym_mutable] = ACTIONS(4047),
    [anon_sym_constinit] = ACTIONS(4047),
    [anon_sym_consteval] = ACTIONS(4047),
    [anon_sym_alignas] = ACTIONS(4047),
    [anon_sym__Alignas] = ACTIONS(4047),
    [anon_sym_QMARK] = ACTIONS(4047),
    [anon_sym_LT_EQ_GT] = ACTIONS(4047),
    [anon_sym_or] = ACTIONS(4047),
    [anon_sym_and] = ACTIONS(4047),
    [anon_sym_bitor] = ACTIONS(4047),
    [anon_sym_xor] = ACTIONS(4047),
    [anon_sym_bitand] = ACTIONS(4047),
    [anon_sym_not_eq] = ACTIONS(4047),
    [anon_sym_is] = ACTIONS(4047),
    [anon_sym_as] = ACTIONS(4047),
    [anon_sym_DASH_DASH] = ACTIONS(4047),
    [anon_sym_PLUS_PLUS] = ACTIONS(4047),
    [anon_sym_DOT] = ACTIONS(4049),
    [anon_sym_DOT_STAR] = ACTIONS(4047),
    [anon_sym_DASH_GT] = ACTIONS(4047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4047),
    [anon_sym_let] = ACTIONS(4047),
    [anon_sym_This] = ACTIONS(4047),
    [anon_sym_final] = ACTIONS(4047),
    [anon_sym_override] = ACTIONS(4047),
    [anon_sym_requires] = ACTIONS(4047),
    [anon_sym_where] = ACTIONS(4047),
  },
  [3241] = {
    [sym_string_literal] = STATE(3193),
    [sym_raw_string_literal] = STATE(3193),
    [aux_sym_concatenated_string_repeat1] = STATE(3193),
    [sym_identifier] = ACTIONS(7574),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7190),
    [anon_sym_COMMA] = ACTIONS(7190),
    [anon_sym_RPAREN] = ACTIONS(7190),
    [anon_sym_LPAREN2] = ACTIONS(7190),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_STAR] = ACTIONS(7192),
    [anon_sym_SLASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [anon_sym_PIPE_PIPE] = ACTIONS(7190),
    [anon_sym_AMP_AMP] = ACTIONS(7190),
    [anon_sym_PIPE] = ACTIONS(7192),
    [anon_sym_CARET] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(7192),
    [anon_sym_EQ_EQ] = ACTIONS(7190),
    [anon_sym_BANG_EQ] = ACTIONS(7190),
    [anon_sym_GT] = ACTIONS(7192),
    [anon_sym_GT_EQ] = ACTIONS(7190),
    [anon_sym_LT_EQ] = ACTIONS(7192),
    [anon_sym_LT] = ACTIONS(7192),
    [anon_sym_LT_LT] = ACTIONS(7192),
    [anon_sym_GT_GT] = ACTIONS(7192),
    [anon_sym_LBRACK] = ACTIONS(7190),
    [anon_sym_EQ] = ACTIONS(7192),
    [anon_sym_QMARK] = ACTIONS(7190),
    [anon_sym_STAR_EQ] = ACTIONS(7190),
    [anon_sym_SLASH_EQ] = ACTIONS(7190),
    [anon_sym_PERCENT_EQ] = ACTIONS(7190),
    [anon_sym_PLUS_EQ] = ACTIONS(7190),
    [anon_sym_DASH_EQ] = ACTIONS(7190),
    [anon_sym_LT_LT_EQ] = ACTIONS(7190),
    [anon_sym_GT_GT_EQ] = ACTIONS(7190),
    [anon_sym_AMP_EQ] = ACTIONS(7190),
    [anon_sym_CARET_EQ] = ACTIONS(7190),
    [anon_sym_PIPE_EQ] = ACTIONS(7190),
    [anon_sym_and_eq] = ACTIONS(7192),
    [anon_sym_or_eq] = ACTIONS(7192),
    [anon_sym_xor_eq] = ACTIONS(7192),
    [anon_sym_LT_EQ_GT] = ACTIONS(7190),
    [anon_sym_or] = ACTIONS(7192),
    [anon_sym_and] = ACTIONS(7192),
    [anon_sym_bitor] = ACTIONS(7192),
    [anon_sym_xor] = ACTIONS(7192),
    [anon_sym_bitand] = ACTIONS(7192),
    [anon_sym_not_eq] = ACTIONS(7192),
    [anon_sym_is] = ACTIONS(7192),
    [anon_sym_as] = ACTIONS(7192),
    [anon_sym_DASH_DASH] = ACTIONS(7190),
    [anon_sym_PLUS_PLUS] = ACTIONS(7190),
    [anon_sym_DOT] = ACTIONS(7192),
    [anon_sym_DOT_STAR] = ACTIONS(7190),
    [anon_sym_DASH_GT] = ACTIONS(7192),
    [anon_sym_L_DQUOTE] = ACTIONS(6765),
    [anon_sym_u_DQUOTE] = ACTIONS(6765),
    [anon_sym_U_DQUOTE] = ACTIONS(6765),
    [anon_sym_u8_DQUOTE] = ACTIONS(6765),
    [anon_sym_DQUOTE] = ACTIONS(6765),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6767),
    [anon_sym_LR_DQUOTE] = ACTIONS(6767),
    [anon_sym_uR_DQUOTE] = ACTIONS(6767),
    [anon_sym_UR_DQUOTE] = ACTIONS(6767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6767),
    [anon_sym_DASH_GT_STAR] = ACTIONS(7190),
    [sym_literal_suffix] = ACTIONS(7192),
  },
  [3242] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(4695),
    [sym_raw_string_literal] = STATE(3527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6839),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(5411),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2207),
    [anon_sym_SLASH_EQ] = ACTIONS(2207),
    [anon_sym_PERCENT_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_GT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_EQ] = ACTIONS(2207),
    [anon_sym_CARET_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_EQ] = ACTIONS(2207),
    [anon_sym_and_eq] = ACTIONS(2207),
    [anon_sym_or_eq] = ACTIONS(2207),
    [anon_sym_xor_eq] = ACTIONS(2207),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
  },
  [3243] = {
    [sym_string_literal] = STATE(3243),
    [sym_raw_string_literal] = STATE(3243),
    [aux_sym_concatenated_string_repeat1] = STATE(3243),
    [sym_identifier] = ACTIONS(7576),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7205),
    [anon_sym_COMMA] = ACTIONS(7205),
    [anon_sym_RPAREN] = ACTIONS(7205),
    [anon_sym_LPAREN2] = ACTIONS(7205),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_SLASH] = ACTIONS(7207),
    [anon_sym_PERCENT] = ACTIONS(7207),
    [anon_sym_PIPE_PIPE] = ACTIONS(7205),
    [anon_sym_AMP_AMP] = ACTIONS(7205),
    [anon_sym_PIPE] = ACTIONS(7207),
    [anon_sym_CARET] = ACTIONS(7207),
    [anon_sym_AMP] = ACTIONS(7207),
    [anon_sym_EQ_EQ] = ACTIONS(7205),
    [anon_sym_BANG_EQ] = ACTIONS(7205),
    [anon_sym_GT] = ACTIONS(7207),
    [anon_sym_GT_EQ] = ACTIONS(7205),
    [anon_sym_LT_EQ] = ACTIONS(7207),
    [anon_sym_LT] = ACTIONS(7207),
    [anon_sym_LT_LT] = ACTIONS(7207),
    [anon_sym_GT_GT] = ACTIONS(7207),
    [anon_sym_LBRACK] = ACTIONS(7205),
    [anon_sym_EQ] = ACTIONS(7207),
    [anon_sym_QMARK] = ACTIONS(7205),
    [anon_sym_STAR_EQ] = ACTIONS(7205),
    [anon_sym_SLASH_EQ] = ACTIONS(7205),
    [anon_sym_PERCENT_EQ] = ACTIONS(7205),
    [anon_sym_PLUS_EQ] = ACTIONS(7205),
    [anon_sym_DASH_EQ] = ACTIONS(7205),
    [anon_sym_LT_LT_EQ] = ACTIONS(7205),
    [anon_sym_GT_GT_EQ] = ACTIONS(7205),
    [anon_sym_AMP_EQ] = ACTIONS(7205),
    [anon_sym_CARET_EQ] = ACTIONS(7205),
    [anon_sym_PIPE_EQ] = ACTIONS(7205),
    [anon_sym_and_eq] = ACTIONS(7207),
    [anon_sym_or_eq] = ACTIONS(7207),
    [anon_sym_xor_eq] = ACTIONS(7207),
    [anon_sym_LT_EQ_GT] = ACTIONS(7205),
    [anon_sym_or] = ACTIONS(7207),
    [anon_sym_and] = ACTIONS(7207),
    [anon_sym_bitor] = ACTIONS(7207),
    [anon_sym_xor] = ACTIONS(7207),
    [anon_sym_bitand] = ACTIONS(7207),
    [anon_sym_not_eq] = ACTIONS(7207),
    [anon_sym_is] = ACTIONS(7207),
    [anon_sym_as] = ACTIONS(7207),
    [anon_sym_DASH_DASH] = ACTIONS(7205),
    [anon_sym_PLUS_PLUS] = ACTIONS(7205),
    [anon_sym_DOT] = ACTIONS(7207),
    [anon_sym_DOT_STAR] = ACTIONS(7205),
    [anon_sym_DASH_GT] = ACTIONS(7207),
    [anon_sym_L_DQUOTE] = ACTIONS(7579),
    [anon_sym_u_DQUOTE] = ACTIONS(7579),
    [anon_sym_U_DQUOTE] = ACTIONS(7579),
    [anon_sym_u8_DQUOTE] = ACTIONS(7579),
    [anon_sym_DQUOTE] = ACTIONS(7579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7582),
    [anon_sym_LR_DQUOTE] = ACTIONS(7582),
    [anon_sym_uR_DQUOTE] = ACTIONS(7582),
    [anon_sym_UR_DQUOTE] = ACTIONS(7582),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7582),
    [anon_sym_DASH_GT_STAR] = ACTIONS(7205),
    [sym_literal_suffix] = ACTIONS(7207),
  },
  [3244] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(4695),
    [sym_raw_string_literal] = STATE(3527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6839),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2207),
    [anon_sym_SLASH_EQ] = ACTIONS(2207),
    [anon_sym_PERCENT_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
    [anon_sym_LT_LT_EQ] = ACTIONS(2207),
    [anon_sym_GT_GT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_EQ] = ACTIONS(2207),
    [anon_sym_CARET_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_EQ] = ACTIONS(2207),
    [anon_sym_and_eq] = ACTIONS(2207),
    [anon_sym_or_eq] = ACTIONS(2207),
    [anon_sym_xor_eq] = ACTIONS(2207),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
  },
  [3245] = {
    [sym_identifier] = ACTIONS(2982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2980),
    [anon_sym_COMMA] = ACTIONS(2980),
    [anon_sym_RPAREN] = ACTIONS(2980),
    [aux_sym_preproc_if_token2] = ACTIONS(2980),
    [aux_sym_preproc_else_token1] = ACTIONS(2980),
    [aux_sym_preproc_elif_token1] = ACTIONS(2982),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2980),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2980),
    [anon_sym_LPAREN2] = ACTIONS(2980),
    [anon_sym_DASH] = ACTIONS(2982),
    [anon_sym_PLUS] = ACTIONS(2982),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_SLASH] = ACTIONS(2982),
    [anon_sym_PERCENT] = ACTIONS(2982),
    [anon_sym_PIPE_PIPE] = ACTIONS(2980),
    [anon_sym_AMP_AMP] = ACTIONS(2980),
    [anon_sym_PIPE] = ACTIONS(2982),
    [anon_sym_CARET] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_EQ_EQ] = ACTIONS(2980),
    [anon_sym_BANG_EQ] = ACTIONS(2980),
    [anon_sym_GT] = ACTIONS(2982),
    [anon_sym_GT_EQ] = ACTIONS(2980),
    [anon_sym_LT_EQ] = ACTIONS(2982),
    [anon_sym_LT] = ACTIONS(2982),
    [anon_sym_LT_LT] = ACTIONS(2982),
    [anon_sym_GT_GT] = ACTIONS(2982),
    [anon_sym_COLON] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2980),
    [anon_sym___attribute__] = ACTIONS(2982),
    [anon_sym___attribute] = ACTIONS(2982),
    [anon_sym_LBRACE] = ACTIONS(2980),
    [anon_sym_RBRACE] = ACTIONS(2980),
    [anon_sym_LBRACK] = ACTIONS(2980),
    [anon_sym_RBRACK] = ACTIONS(2980),
    [anon_sym_EQ] = ACTIONS(2982),
    [anon_sym_QMARK] = ACTIONS(2980),
    [anon_sym_STAR_EQ] = ACTIONS(2980),
    [anon_sym_SLASH_EQ] = ACTIONS(2980),
    [anon_sym_PERCENT_EQ] = ACTIONS(2980),
    [anon_sym_PLUS_EQ] = ACTIONS(2980),
    [anon_sym_DASH_EQ] = ACTIONS(2980),
    [anon_sym_LT_LT_EQ] = ACTIONS(2980),
    [anon_sym_GT_GT_EQ] = ACTIONS(2980),
    [anon_sym_AMP_EQ] = ACTIONS(2980),
    [anon_sym_CARET_EQ] = ACTIONS(2980),
    [anon_sym_PIPE_EQ] = ACTIONS(2980),
    [anon_sym_and_eq] = ACTIONS(2982),
    [anon_sym_or_eq] = ACTIONS(2982),
    [anon_sym_xor_eq] = ACTIONS(2982),
    [anon_sym_LT_EQ_GT] = ACTIONS(2980),
    [anon_sym_or] = ACTIONS(2982),
    [anon_sym_and] = ACTIONS(2982),
    [anon_sym_bitor] = ACTIONS(2982),
    [anon_sym_xor] = ACTIONS(2982),
    [anon_sym_bitand] = ACTIONS(2982),
    [anon_sym_not_eq] = ACTIONS(2982),
    [anon_sym_is] = ACTIONS(2982),
    [anon_sym_as] = ACTIONS(2982),
    [anon_sym_DASH_DASH] = ACTIONS(2980),
    [anon_sym_PLUS_PLUS] = ACTIONS(2980),
    [anon_sym_DOT] = ACTIONS(2982),
    [anon_sym_DOT_STAR] = ACTIONS(2980),
    [anon_sym_DASH_GT] = ACTIONS(2980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2982),
    [anon_sym_let] = ACTIONS(2982),
    [anon_sym_This] = ACTIONS(2982),
  },
  [3246] = {
    [sym_identifier] = ACTIONS(3058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3056),
    [anon_sym_COMMA] = ACTIONS(3056),
    [anon_sym_RPAREN] = ACTIONS(3056),
    [aux_sym_preproc_if_token2] = ACTIONS(3056),
    [aux_sym_preproc_else_token1] = ACTIONS(3056),
    [aux_sym_preproc_elif_token1] = ACTIONS(3058),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3056),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3056),
    [anon_sym_LPAREN2] = ACTIONS(3056),
    [anon_sym_DASH] = ACTIONS(3058),
    [anon_sym_PLUS] = ACTIONS(3058),
    [anon_sym_STAR] = ACTIONS(3058),
    [anon_sym_SLASH] = ACTIONS(3058),
    [anon_sym_PERCENT] = ACTIONS(3058),
    [anon_sym_PIPE_PIPE] = ACTIONS(3056),
    [anon_sym_AMP_AMP] = ACTIONS(3056),
    [anon_sym_PIPE] = ACTIONS(3058),
    [anon_sym_CARET] = ACTIONS(3058),
    [anon_sym_AMP] = ACTIONS(3058),
    [anon_sym_EQ_EQ] = ACTIONS(3056),
    [anon_sym_BANG_EQ] = ACTIONS(3056),
    [anon_sym_GT] = ACTIONS(3058),
    [anon_sym_GT_EQ] = ACTIONS(3056),
    [anon_sym_LT_EQ] = ACTIONS(3058),
    [anon_sym_LT] = ACTIONS(3058),
    [anon_sym_LT_LT] = ACTIONS(3058),
    [anon_sym_GT_GT] = ACTIONS(3058),
    [anon_sym_COLON] = ACTIONS(3056),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym___attribute__] = ACTIONS(3058),
    [anon_sym___attribute] = ACTIONS(3058),
    [anon_sym_LBRACE] = ACTIONS(3056),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_RBRACK] = ACTIONS(3056),
    [anon_sym_EQ] = ACTIONS(3058),
    [anon_sym_QMARK] = ACTIONS(3056),
    [anon_sym_STAR_EQ] = ACTIONS(3056),
    [anon_sym_SLASH_EQ] = ACTIONS(3056),
    [anon_sym_PERCENT_EQ] = ACTIONS(3056),
    [anon_sym_PLUS_EQ] = ACTIONS(3056),
    [anon_sym_DASH_EQ] = ACTIONS(3056),
    [anon_sym_LT_LT_EQ] = ACTIONS(3056),
    [anon_sym_GT_GT_EQ] = ACTIONS(3056),
    [anon_sym_AMP_EQ] = ACTIONS(3056),
    [anon_sym_CARET_EQ] = ACTIONS(3056),
    [anon_sym_PIPE_EQ] = ACTIONS(3056),
    [anon_sym_and_eq] = ACTIONS(3058),
    [anon_sym_or_eq] = ACTIONS(3058),
    [anon_sym_xor_eq] = ACTIONS(3058),
    [anon_sym_LT_EQ_GT] = ACTIONS(3056),
    [anon_sym_or] = ACTIONS(3058),
    [anon_sym_and] = ACTIONS(3058),
    [anon_sym_bitor] = ACTIONS(3058),
    [anon_sym_xor] = ACTIONS(3058),
    [anon_sym_bitand] = ACTIONS(3058),
    [anon_sym_not_eq] = ACTIONS(3058),
    [anon_sym_is] = ACTIONS(3058),
    [anon_sym_as] = ACTIONS(3058),
    [anon_sym_DASH_DASH] = ACTIONS(3056),
    [anon_sym_PLUS_PLUS] = ACTIONS(3056),
    [anon_sym_DOT] = ACTIONS(3058),
    [anon_sym_DOT_STAR] = ACTIONS(3056),
    [anon_sym_DASH_GT] = ACTIONS(3056),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3058),
    [anon_sym_let] = ACTIONS(3058),
    [anon_sym_This] = ACTIONS(3058),
  },
  [3247] = {
    [sym_identifier] = ACTIONS(2986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(2984),
    [anon_sym_RPAREN] = ACTIONS(2984),
    [aux_sym_preproc_if_token2] = ACTIONS(2984),
    [aux_sym_preproc_else_token1] = ACTIONS(2984),
    [aux_sym_preproc_elif_token1] = ACTIONS(2986),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2984),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2984),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_DASH] = ACTIONS(2986),
    [anon_sym_PLUS] = ACTIONS(2986),
    [anon_sym_STAR] = ACTIONS(2986),
    [anon_sym_SLASH] = ACTIONS(2986),
    [anon_sym_PERCENT] = ACTIONS(2986),
    [anon_sym_PIPE_PIPE] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_PIPE] = ACTIONS(2986),
    [anon_sym_CARET] = ACTIONS(2986),
    [anon_sym_AMP] = ACTIONS(2986),
    [anon_sym_EQ_EQ] = ACTIONS(2984),
    [anon_sym_BANG_EQ] = ACTIONS(2984),
    [anon_sym_GT] = ACTIONS(2986),
    [anon_sym_GT_EQ] = ACTIONS(2984),
    [anon_sym_LT_EQ] = ACTIONS(2986),
    [anon_sym_LT] = ACTIONS(2986),
    [anon_sym_LT_LT] = ACTIONS(2986),
    [anon_sym_GT_GT] = ACTIONS(2986),
    [anon_sym_COLON] = ACTIONS(2984),
    [anon_sym_SEMI] = ACTIONS(2984),
    [anon_sym___attribute__] = ACTIONS(2986),
    [anon_sym___attribute] = ACTIONS(2986),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_RBRACE] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2984),
    [anon_sym_RBRACK] = ACTIONS(2984),
    [anon_sym_EQ] = ACTIONS(2986),
    [anon_sym_QMARK] = ACTIONS(2984),
    [anon_sym_STAR_EQ] = ACTIONS(2984),
    [anon_sym_SLASH_EQ] = ACTIONS(2984),
    [anon_sym_PERCENT_EQ] = ACTIONS(2984),
    [anon_sym_PLUS_EQ] = ACTIONS(2984),
    [anon_sym_DASH_EQ] = ACTIONS(2984),
    [anon_sym_LT_LT_EQ] = ACTIONS(2984),
    [anon_sym_GT_GT_EQ] = ACTIONS(2984),
    [anon_sym_AMP_EQ] = ACTIONS(2984),
    [anon_sym_CARET_EQ] = ACTIONS(2984),
    [anon_sym_PIPE_EQ] = ACTIONS(2984),
    [anon_sym_and_eq] = ACTIONS(2986),
    [anon_sym_or_eq] = ACTIONS(2986),
    [anon_sym_xor_eq] = ACTIONS(2986),
    [anon_sym_LT_EQ_GT] = ACTIONS(2984),
    [anon_sym_or] = ACTIONS(2986),
    [anon_sym_and] = ACTIONS(2986),
    [anon_sym_bitor] = ACTIONS(2986),
    [anon_sym_xor] = ACTIONS(2986),
    [anon_sym_bitand] = ACTIONS(2986),
    [anon_sym_not_eq] = ACTIONS(2986),
    [anon_sym_is] = ACTIONS(2986),
    [anon_sym_as] = ACTIONS(2986),
    [anon_sym_DASH_DASH] = ACTIONS(2984),
    [anon_sym_PLUS_PLUS] = ACTIONS(2984),
    [anon_sym_DOT] = ACTIONS(2986),
    [anon_sym_DOT_STAR] = ACTIONS(2984),
    [anon_sym_DASH_GT] = ACTIONS(2984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2986),
    [anon_sym_let] = ACTIONS(2986),
    [anon_sym_This] = ACTIONS(2986),
  },
  [3248] = {
    [sym_identifier] = ACTIONS(2990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2988),
    [anon_sym_RPAREN] = ACTIONS(2988),
    [aux_sym_preproc_if_token2] = ACTIONS(2988),
    [aux_sym_preproc_else_token1] = ACTIONS(2988),
    [aux_sym_preproc_elif_token1] = ACTIONS(2990),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2988),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2988),
    [anon_sym_LPAREN2] = ACTIONS(2988),
    [anon_sym_DASH] = ACTIONS(2990),
    [anon_sym_PLUS] = ACTIONS(2990),
    [anon_sym_STAR] = ACTIONS(2990),
    [anon_sym_SLASH] = ACTIONS(2990),
    [anon_sym_PERCENT] = ACTIONS(2990),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_PIPE] = ACTIONS(2990),
    [anon_sym_CARET] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2990),
    [anon_sym_EQ_EQ] = ACTIONS(2988),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_GT] = ACTIONS(2990),
    [anon_sym_GT_EQ] = ACTIONS(2988),
    [anon_sym_LT_EQ] = ACTIONS(2990),
    [anon_sym_LT] = ACTIONS(2990),
    [anon_sym_LT_LT] = ACTIONS(2990),
    [anon_sym_GT_GT] = ACTIONS(2990),
    [anon_sym_COLON] = ACTIONS(2988),
    [anon_sym_SEMI] = ACTIONS(2988),
    [anon_sym___attribute__] = ACTIONS(2990),
    [anon_sym___attribute] = ACTIONS(2990),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_RBRACE] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_RBRACK] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(2990),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_STAR_EQ] = ACTIONS(2988),
    [anon_sym_SLASH_EQ] = ACTIONS(2988),
    [anon_sym_PERCENT_EQ] = ACTIONS(2988),
    [anon_sym_PLUS_EQ] = ACTIONS(2988),
    [anon_sym_DASH_EQ] = ACTIONS(2988),
    [anon_sym_LT_LT_EQ] = ACTIONS(2988),
    [anon_sym_GT_GT_EQ] = ACTIONS(2988),
    [anon_sym_AMP_EQ] = ACTIONS(2988),
    [anon_sym_CARET_EQ] = ACTIONS(2988),
    [anon_sym_PIPE_EQ] = ACTIONS(2988),
    [anon_sym_and_eq] = ACTIONS(2990),
    [anon_sym_or_eq] = ACTIONS(2990),
    [anon_sym_xor_eq] = ACTIONS(2990),
    [anon_sym_LT_EQ_GT] = ACTIONS(2988),
    [anon_sym_or] = ACTIONS(2990),
    [anon_sym_and] = ACTIONS(2990),
    [anon_sym_bitor] = ACTIONS(2990),
    [anon_sym_xor] = ACTIONS(2990),
    [anon_sym_bitand] = ACTIONS(2990),
    [anon_sym_not_eq] = ACTIONS(2990),
    [anon_sym_is] = ACTIONS(2990),
    [anon_sym_as] = ACTIONS(2990),
    [anon_sym_DASH_DASH] = ACTIONS(2988),
    [anon_sym_PLUS_PLUS] = ACTIONS(2988),
    [anon_sym_DOT] = ACTIONS(2990),
    [anon_sym_DOT_STAR] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(2988),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2990),
    [anon_sym_let] = ACTIONS(2990),
    [anon_sym_This] = ACTIONS(2990),
  },
  [3249] = {
    [sym_identifier] = ACTIONS(3002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3000),
    [anon_sym_COMMA] = ACTIONS(3000),
    [anon_sym_RPAREN] = ACTIONS(3000),
    [aux_sym_preproc_if_token2] = ACTIONS(3000),
    [aux_sym_preproc_else_token1] = ACTIONS(3000),
    [aux_sym_preproc_elif_token1] = ACTIONS(3002),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3000),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3000),
    [anon_sym_LPAREN2] = ACTIONS(3000),
    [anon_sym_DASH] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(3002),
    [anon_sym_SLASH] = ACTIONS(3002),
    [anon_sym_PERCENT] = ACTIONS(3002),
    [anon_sym_PIPE_PIPE] = ACTIONS(3000),
    [anon_sym_AMP_AMP] = ACTIONS(3000),
    [anon_sym_PIPE] = ACTIONS(3002),
    [anon_sym_CARET] = ACTIONS(3002),
    [anon_sym_AMP] = ACTIONS(3002),
    [anon_sym_EQ_EQ] = ACTIONS(3000),
    [anon_sym_BANG_EQ] = ACTIONS(3000),
    [anon_sym_GT] = ACTIONS(3002),
    [anon_sym_GT_EQ] = ACTIONS(3000),
    [anon_sym_LT_EQ] = ACTIONS(3002),
    [anon_sym_LT] = ACTIONS(3002),
    [anon_sym_LT_LT] = ACTIONS(3002),
    [anon_sym_GT_GT] = ACTIONS(3002),
    [anon_sym_COLON] = ACTIONS(3000),
    [anon_sym_SEMI] = ACTIONS(3000),
    [anon_sym___attribute__] = ACTIONS(3002),
    [anon_sym___attribute] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3000),
    [anon_sym_RBRACE] = ACTIONS(3000),
    [anon_sym_LBRACK] = ACTIONS(3000),
    [anon_sym_RBRACK] = ACTIONS(3000),
    [anon_sym_EQ] = ACTIONS(3002),
    [anon_sym_QMARK] = ACTIONS(3000),
    [anon_sym_STAR_EQ] = ACTIONS(3000),
    [anon_sym_SLASH_EQ] = ACTIONS(3000),
    [anon_sym_PERCENT_EQ] = ACTIONS(3000),
    [anon_sym_PLUS_EQ] = ACTIONS(3000),
    [anon_sym_DASH_EQ] = ACTIONS(3000),
    [anon_sym_LT_LT_EQ] = ACTIONS(3000),
    [anon_sym_GT_GT_EQ] = ACTIONS(3000),
    [anon_sym_AMP_EQ] = ACTIONS(3000),
    [anon_sym_CARET_EQ] = ACTIONS(3000),
    [anon_sym_PIPE_EQ] = ACTIONS(3000),
    [anon_sym_and_eq] = ACTIONS(3002),
    [anon_sym_or_eq] = ACTIONS(3002),
    [anon_sym_xor_eq] = ACTIONS(3002),
    [anon_sym_LT_EQ_GT] = ACTIONS(3000),
    [anon_sym_or] = ACTIONS(3002),
    [anon_sym_and] = ACTIONS(3002),
    [anon_sym_bitor] = ACTIONS(3002),
    [anon_sym_xor] = ACTIONS(3002),
    [anon_sym_bitand] = ACTIONS(3002),
    [anon_sym_not_eq] = ACTIONS(3002),
    [anon_sym_is] = ACTIONS(3002),
    [anon_sym_as] = ACTIONS(3002),
    [anon_sym_DASH_DASH] = ACTIONS(3000),
    [anon_sym_PLUS_PLUS] = ACTIONS(3000),
    [anon_sym_DOT] = ACTIONS(3002),
    [anon_sym_DOT_STAR] = ACTIONS(3000),
    [anon_sym_DASH_GT] = ACTIONS(3000),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3002),
    [anon_sym_let] = ACTIONS(3002),
    [anon_sym_This] = ACTIONS(3002),
  },
  [3250] = {
    [sym_identifier] = ACTIONS(3006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3004),
    [anon_sym_COMMA] = ACTIONS(3004),
    [anon_sym_RPAREN] = ACTIONS(3004),
    [aux_sym_preproc_if_token2] = ACTIONS(3004),
    [aux_sym_preproc_else_token1] = ACTIONS(3004),
    [aux_sym_preproc_elif_token1] = ACTIONS(3006),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3004),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3004),
    [anon_sym_LPAREN2] = ACTIONS(3004),
    [anon_sym_DASH] = ACTIONS(3006),
    [anon_sym_PLUS] = ACTIONS(3006),
    [anon_sym_STAR] = ACTIONS(3006),
    [anon_sym_SLASH] = ACTIONS(3006),
    [anon_sym_PERCENT] = ACTIONS(3006),
    [anon_sym_PIPE_PIPE] = ACTIONS(3004),
    [anon_sym_AMP_AMP] = ACTIONS(3004),
    [anon_sym_PIPE] = ACTIONS(3006),
    [anon_sym_CARET] = ACTIONS(3006),
    [anon_sym_AMP] = ACTIONS(3006),
    [anon_sym_EQ_EQ] = ACTIONS(3004),
    [anon_sym_BANG_EQ] = ACTIONS(3004),
    [anon_sym_GT] = ACTIONS(3006),
    [anon_sym_GT_EQ] = ACTIONS(3004),
    [anon_sym_LT_EQ] = ACTIONS(3006),
    [anon_sym_LT] = ACTIONS(3006),
    [anon_sym_LT_LT] = ACTIONS(3006),
    [anon_sym_GT_GT] = ACTIONS(3006),
    [anon_sym_COLON] = ACTIONS(3004),
    [anon_sym_SEMI] = ACTIONS(3004),
    [anon_sym___attribute__] = ACTIONS(3006),
    [anon_sym___attribute] = ACTIONS(3006),
    [anon_sym_LBRACE] = ACTIONS(3004),
    [anon_sym_RBRACE] = ACTIONS(3004),
    [anon_sym_LBRACK] = ACTIONS(3004),
    [anon_sym_RBRACK] = ACTIONS(3004),
    [anon_sym_EQ] = ACTIONS(3006),
    [anon_sym_QMARK] = ACTIONS(3004),
    [anon_sym_STAR_EQ] = ACTIONS(3004),
    [anon_sym_SLASH_EQ] = ACTIONS(3004),
    [anon_sym_PERCENT_EQ] = ACTIONS(3004),
    [anon_sym_PLUS_EQ] = ACTIONS(3004),
    [anon_sym_DASH_EQ] = ACTIONS(3004),
    [anon_sym_LT_LT_EQ] = ACTIONS(3004),
    [anon_sym_GT_GT_EQ] = ACTIONS(3004),
    [anon_sym_AMP_EQ] = ACTIONS(3004),
    [anon_sym_CARET_EQ] = ACTIONS(3004),
    [anon_sym_PIPE_EQ] = ACTIONS(3004),
    [anon_sym_and_eq] = ACTIONS(3006),
    [anon_sym_or_eq] = ACTIONS(3006),
    [anon_sym_xor_eq] = ACTIONS(3006),
    [anon_sym_LT_EQ_GT] = ACTIONS(3004),
    [anon_sym_or] = ACTIONS(3006),
    [anon_sym_and] = ACTIONS(3006),
    [anon_sym_bitor] = ACTIONS(3006),
    [anon_sym_xor] = ACTIONS(3006),
    [anon_sym_bitand] = ACTIONS(3006),
    [anon_sym_not_eq] = ACTIONS(3006),
    [anon_sym_is] = ACTIONS(3006),
    [anon_sym_as] = ACTIONS(3006),
    [anon_sym_DASH_DASH] = ACTIONS(3004),
    [anon_sym_PLUS_PLUS] = ACTIONS(3004),
    [anon_sym_DOT] = ACTIONS(3006),
    [anon_sym_DOT_STAR] = ACTIONS(3004),
    [anon_sym_DASH_GT] = ACTIONS(3004),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3006),
    [anon_sym_let] = ACTIONS(3006),
    [anon_sym_This] = ACTIONS(3006),
  },
  [3251] = {
    [sym_identifier] = ACTIONS(3010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3008),
    [anon_sym_COMMA] = ACTIONS(3008),
    [anon_sym_RPAREN] = ACTIONS(3008),
    [aux_sym_preproc_if_token2] = ACTIONS(3008),
    [aux_sym_preproc_else_token1] = ACTIONS(3008),
    [aux_sym_preproc_elif_token1] = ACTIONS(3010),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3008),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3008),
    [anon_sym_LPAREN2] = ACTIONS(3008),
    [anon_sym_DASH] = ACTIONS(3010),
    [anon_sym_PLUS] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_SLASH] = ACTIONS(3010),
    [anon_sym_PERCENT] = ACTIONS(3010),
    [anon_sym_PIPE_PIPE] = ACTIONS(3008),
    [anon_sym_AMP_AMP] = ACTIONS(3008),
    [anon_sym_PIPE] = ACTIONS(3010),
    [anon_sym_CARET] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3010),
    [anon_sym_EQ_EQ] = ACTIONS(3008),
    [anon_sym_BANG_EQ] = ACTIONS(3008),
    [anon_sym_GT] = ACTIONS(3010),
    [anon_sym_GT_EQ] = ACTIONS(3008),
    [anon_sym_LT_EQ] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(3010),
    [anon_sym_LT_LT] = ACTIONS(3010),
    [anon_sym_GT_GT] = ACTIONS(3010),
    [anon_sym_COLON] = ACTIONS(3008),
    [anon_sym_SEMI] = ACTIONS(3008),
    [anon_sym___attribute__] = ACTIONS(3010),
    [anon_sym___attribute] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3008),
    [anon_sym_RBRACE] = ACTIONS(3008),
    [anon_sym_LBRACK] = ACTIONS(3008),
    [anon_sym_RBRACK] = ACTIONS(3008),
    [anon_sym_EQ] = ACTIONS(3010),
    [anon_sym_QMARK] = ACTIONS(3008),
    [anon_sym_STAR_EQ] = ACTIONS(3008),
    [anon_sym_SLASH_EQ] = ACTIONS(3008),
    [anon_sym_PERCENT_EQ] = ACTIONS(3008),
    [anon_sym_PLUS_EQ] = ACTIONS(3008),
    [anon_sym_DASH_EQ] = ACTIONS(3008),
    [anon_sym_LT_LT_EQ] = ACTIONS(3008),
    [anon_sym_GT_GT_EQ] = ACTIONS(3008),
    [anon_sym_AMP_EQ] = ACTIONS(3008),
    [anon_sym_CARET_EQ] = ACTIONS(3008),
    [anon_sym_PIPE_EQ] = ACTIONS(3008),
    [anon_sym_and_eq] = ACTIONS(3010),
    [anon_sym_or_eq] = ACTIONS(3010),
    [anon_sym_xor_eq] = ACTIONS(3010),
    [anon_sym_LT_EQ_GT] = ACTIONS(3008),
    [anon_sym_or] = ACTIONS(3010),
    [anon_sym_and] = ACTIONS(3010),
    [anon_sym_bitor] = ACTIONS(3010),
    [anon_sym_xor] = ACTIONS(3010),
    [anon_sym_bitand] = ACTIONS(3010),
    [anon_sym_not_eq] = ACTIONS(3010),
    [anon_sym_is] = ACTIONS(3010),
    [anon_sym_as] = ACTIONS(3010),
    [anon_sym_DASH_DASH] = ACTIONS(3008),
    [anon_sym_PLUS_PLUS] = ACTIONS(3008),
    [anon_sym_DOT] = ACTIONS(3010),
    [anon_sym_DOT_STAR] = ACTIONS(3008),
    [anon_sym_DASH_GT] = ACTIONS(3008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3010),
    [anon_sym_let] = ACTIONS(3010),
    [anon_sym_This] = ACTIONS(3010),
  },
  [3252] = {
    [sym_attribute_declaration] = STATE(3260),
    [sym_parameter_list] = STATE(3274),
    [aux_sym_attributed_declarator_repeat1] = STATE(3260),
    [sym_identifier] = ACTIONS(7585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7587),
    [anon_sym_COMMA] = ACTIONS(7587),
    [anon_sym_RPAREN] = ACTIONS(7587),
    [aux_sym_preproc_if_token2] = ACTIONS(7587),
    [aux_sym_preproc_else_token1] = ACTIONS(7587),
    [aux_sym_preproc_elif_token1] = ACTIONS(7585),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7587),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7587),
    [anon_sym_LPAREN2] = ACTIONS(7498),
    [anon_sym_DASH] = ACTIONS(7585),
    [anon_sym_PLUS] = ACTIONS(7585),
    [anon_sym_STAR] = ACTIONS(7585),
    [anon_sym_SLASH] = ACTIONS(7585),
    [anon_sym_PERCENT] = ACTIONS(7585),
    [anon_sym_PIPE_PIPE] = ACTIONS(7587),
    [anon_sym_AMP_AMP] = ACTIONS(7587),
    [anon_sym_PIPE] = ACTIONS(7585),
    [anon_sym_CARET] = ACTIONS(7585),
    [anon_sym_AMP] = ACTIONS(7585),
    [anon_sym_EQ_EQ] = ACTIONS(7587),
    [anon_sym_BANG_EQ] = ACTIONS(7587),
    [anon_sym_GT] = ACTIONS(7585),
    [anon_sym_GT_EQ] = ACTIONS(7587),
    [anon_sym_LT_EQ] = ACTIONS(7585),
    [anon_sym_LT] = ACTIONS(7585),
    [anon_sym_LT_LT] = ACTIONS(7585),
    [anon_sym_GT_GT] = ACTIONS(7585),
    [anon_sym_COLON] = ACTIONS(7587),
    [anon_sym_SEMI] = ACTIONS(7587),
    [anon_sym___attribute__] = ACTIONS(7585),
    [anon_sym___attribute] = ACTIONS(7585),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7500),
    [anon_sym_RBRACE] = ACTIONS(7587),
    [anon_sym_LBRACK] = ACTIONS(7502),
    [anon_sym_RBRACK] = ACTIONS(7587),
    [anon_sym_EQ] = ACTIONS(7585),
    [anon_sym_QMARK] = ACTIONS(7587),
    [anon_sym_STAR_EQ] = ACTIONS(7587),
    [anon_sym_SLASH_EQ] = ACTIONS(7587),
    [anon_sym_PERCENT_EQ] = ACTIONS(7587),
    [anon_sym_PLUS_EQ] = ACTIONS(7587),
    [anon_sym_DASH_EQ] = ACTIONS(7587),
    [anon_sym_LT_LT_EQ] = ACTIONS(7587),
    [anon_sym_GT_GT_EQ] = ACTIONS(7587),
    [anon_sym_AMP_EQ] = ACTIONS(7587),
    [anon_sym_CARET_EQ] = ACTIONS(7587),
    [anon_sym_PIPE_EQ] = ACTIONS(7587),
    [anon_sym_and_eq] = ACTIONS(7585),
    [anon_sym_or_eq] = ACTIONS(7585),
    [anon_sym_xor_eq] = ACTIONS(7585),
    [anon_sym_LT_EQ_GT] = ACTIONS(7587),
    [anon_sym_or] = ACTIONS(7585),
    [anon_sym_and] = ACTIONS(7585),
    [anon_sym_bitor] = ACTIONS(7585),
    [anon_sym_xor] = ACTIONS(7585),
    [anon_sym_bitand] = ACTIONS(7585),
    [anon_sym_not_eq] = ACTIONS(7585),
    [anon_sym_is] = ACTIONS(7585),
    [anon_sym_as] = ACTIONS(7585),
    [anon_sym_DASH_DASH] = ACTIONS(7587),
    [anon_sym_PLUS_PLUS] = ACTIONS(7587),
    [anon_sym_DOT] = ACTIONS(7585),
    [anon_sym_DOT_STAR] = ACTIONS(7587),
    [anon_sym_DASH_GT] = ACTIONS(7587),
    [sym_comment] = ACTIONS(3),
  },
  [3253] = {
    [sym_identifier] = ACTIONS(3018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3016),
    [anon_sym_COMMA] = ACTIONS(3016),
    [anon_sym_RPAREN] = ACTIONS(3016),
    [aux_sym_preproc_if_token2] = ACTIONS(3016),
    [aux_sym_preproc_else_token1] = ACTIONS(3016),
    [aux_sym_preproc_elif_token1] = ACTIONS(3018),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3016),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3016),
    [anon_sym_LPAREN2] = ACTIONS(3016),
    [anon_sym_DASH] = ACTIONS(3018),
    [anon_sym_PLUS] = ACTIONS(3018),
    [anon_sym_STAR] = ACTIONS(3018),
    [anon_sym_SLASH] = ACTIONS(3018),
    [anon_sym_PERCENT] = ACTIONS(3018),
    [anon_sym_PIPE_PIPE] = ACTIONS(3016),
    [anon_sym_AMP_AMP] = ACTIONS(3016),
    [anon_sym_PIPE] = ACTIONS(3018),
    [anon_sym_CARET] = ACTIONS(3018),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_EQ_EQ] = ACTIONS(3016),
    [anon_sym_BANG_EQ] = ACTIONS(3016),
    [anon_sym_GT] = ACTIONS(3018),
    [anon_sym_GT_EQ] = ACTIONS(3016),
    [anon_sym_LT_EQ] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(3018),
    [anon_sym_LT_LT] = ACTIONS(3018),
    [anon_sym_GT_GT] = ACTIONS(3018),
    [anon_sym_COLON] = ACTIONS(3016),
    [anon_sym_SEMI] = ACTIONS(3016),
    [anon_sym___attribute__] = ACTIONS(3018),
    [anon_sym___attribute] = ACTIONS(3018),
    [anon_sym_LBRACE] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(3016),
    [anon_sym_LBRACK] = ACTIONS(3016),
    [anon_sym_RBRACK] = ACTIONS(3016),
    [anon_sym_EQ] = ACTIONS(3018),
    [anon_sym_QMARK] = ACTIONS(3016),
    [anon_sym_STAR_EQ] = ACTIONS(3016),
    [anon_sym_SLASH_EQ] = ACTIONS(3016),
    [anon_sym_PERCENT_EQ] = ACTIONS(3016),
    [anon_sym_PLUS_EQ] = ACTIONS(3016),
    [anon_sym_DASH_EQ] = ACTIONS(3016),
    [anon_sym_LT_LT_EQ] = ACTIONS(3016),
    [anon_sym_GT_GT_EQ] = ACTIONS(3016),
    [anon_sym_AMP_EQ] = ACTIONS(3016),
    [anon_sym_CARET_EQ] = ACTIONS(3016),
    [anon_sym_PIPE_EQ] = ACTIONS(3016),
    [anon_sym_and_eq] = ACTIONS(3018),
    [anon_sym_or_eq] = ACTIONS(3018),
    [anon_sym_xor_eq] = ACTIONS(3018),
    [anon_sym_LT_EQ_GT] = ACTIONS(3016),
    [anon_sym_or] = ACTIONS(3018),
    [anon_sym_and] = ACTIONS(3018),
    [anon_sym_bitor] = ACTIONS(3018),
    [anon_sym_xor] = ACTIONS(3018),
    [anon_sym_bitand] = ACTIONS(3018),
    [anon_sym_not_eq] = ACTIONS(3018),
    [anon_sym_is] = ACTIONS(3018),
    [anon_sym_as] = ACTIONS(3018),
    [anon_sym_DASH_DASH] = ACTIONS(3016),
    [anon_sym_PLUS_PLUS] = ACTIONS(3016),
    [anon_sym_DOT] = ACTIONS(3018),
    [anon_sym_DOT_STAR] = ACTIONS(3016),
    [anon_sym_DASH_GT] = ACTIONS(3016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3018),
    [anon_sym_let] = ACTIONS(3018),
    [anon_sym_This] = ACTIONS(3018),
  },
  [3254] = {
    [sym_identifier] = ACTIONS(3030),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3028),
    [anon_sym_COMMA] = ACTIONS(3028),
    [anon_sym_RPAREN] = ACTIONS(3028),
    [aux_sym_preproc_if_token2] = ACTIONS(3028),
    [aux_sym_preproc_else_token1] = ACTIONS(3028),
    [aux_sym_preproc_elif_token1] = ACTIONS(3030),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3028),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3028),
    [anon_sym_LPAREN2] = ACTIONS(3028),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3030),
    [anon_sym_SLASH] = ACTIONS(3030),
    [anon_sym_PERCENT] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3028),
    [anon_sym_AMP_AMP] = ACTIONS(3028),
    [anon_sym_PIPE] = ACTIONS(3030),
    [anon_sym_CARET] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_EQ_EQ] = ACTIONS(3028),
    [anon_sym_BANG_EQ] = ACTIONS(3028),
    [anon_sym_GT] = ACTIONS(3030),
    [anon_sym_GT_EQ] = ACTIONS(3028),
    [anon_sym_LT_EQ] = ACTIONS(3030),
    [anon_sym_LT] = ACTIONS(3030),
    [anon_sym_LT_LT] = ACTIONS(3030),
    [anon_sym_GT_GT] = ACTIONS(3030),
    [anon_sym_COLON] = ACTIONS(3028),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym___attribute__] = ACTIONS(3030),
    [anon_sym___attribute] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3028),
    [anon_sym_RBRACE] = ACTIONS(3028),
    [anon_sym_LBRACK] = ACTIONS(3028),
    [anon_sym_RBRACK] = ACTIONS(3028),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_QMARK] = ACTIONS(3028),
    [anon_sym_STAR_EQ] = ACTIONS(3028),
    [anon_sym_SLASH_EQ] = ACTIONS(3028),
    [anon_sym_PERCENT_EQ] = ACTIONS(3028),
    [anon_sym_PLUS_EQ] = ACTIONS(3028),
    [anon_sym_DASH_EQ] = ACTIONS(3028),
    [anon_sym_LT_LT_EQ] = ACTIONS(3028),
    [anon_sym_GT_GT_EQ] = ACTIONS(3028),
    [anon_sym_AMP_EQ] = ACTIONS(3028),
    [anon_sym_CARET_EQ] = ACTIONS(3028),
    [anon_sym_PIPE_EQ] = ACTIONS(3028),
    [anon_sym_and_eq] = ACTIONS(3030),
    [anon_sym_or_eq] = ACTIONS(3030),
    [anon_sym_xor_eq] = ACTIONS(3030),
    [anon_sym_LT_EQ_GT] = ACTIONS(3028),
    [anon_sym_or] = ACTIONS(3030),
    [anon_sym_and] = ACTIONS(3030),
    [anon_sym_bitor] = ACTIONS(3030),
    [anon_sym_xor] = ACTIONS(3030),
    [anon_sym_bitand] = ACTIONS(3030),
    [anon_sym_not_eq] = ACTIONS(3030),
    [anon_sym_is] = ACTIONS(3030),
    [anon_sym_as] = ACTIONS(3030),
    [anon_sym_DASH_DASH] = ACTIONS(3028),
    [anon_sym_PLUS_PLUS] = ACTIONS(3028),
    [anon_sym_DOT] = ACTIONS(3030),
    [anon_sym_DOT_STAR] = ACTIONS(3028),
    [anon_sym_DASH_GT] = ACTIONS(3028),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3030),
    [anon_sym_let] = ACTIONS(3030),
    [anon_sym_This] = ACTIONS(3030),
  },
  [3255] = {
    [sym_string_literal] = STATE(3337),
    [sym_template_argument_list] = STATE(4727),
    [sym_raw_string_literal] = STATE(3337),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_RPAREN] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(7589),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_EQ] = ACTIONS(2181),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2170),
    [anon_sym_SLASH_EQ] = ACTIONS(2170),
    [anon_sym_PERCENT_EQ] = ACTIONS(2170),
    [anon_sym_PLUS_EQ] = ACTIONS(2170),
    [anon_sym_DASH_EQ] = ACTIONS(2170),
    [anon_sym_LT_LT_EQ] = ACTIONS(2170),
    [anon_sym_GT_GT_EQ] = ACTIONS(2170),
    [anon_sym_AMP_EQ] = ACTIONS(2170),
    [anon_sym_CARET_EQ] = ACTIONS(2170),
    [anon_sym_PIPE_EQ] = ACTIONS(2170),
    [anon_sym_and_eq] = ACTIONS(7592),
    [anon_sym_or_eq] = ACTIONS(7592),
    [anon_sym_xor_eq] = ACTIONS(7592),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2181),
    [anon_sym_L_DQUOTE] = ACTIONS(5383),
    [anon_sym_u_DQUOTE] = ACTIONS(5383),
    [anon_sym_U_DQUOTE] = ACTIONS(5383),
    [anon_sym_u8_DQUOTE] = ACTIONS(5383),
    [anon_sym_DQUOTE] = ACTIONS(5383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5385),
    [anon_sym_LR_DQUOTE] = ACTIONS(5385),
    [anon_sym_uR_DQUOTE] = ACTIONS(5385),
    [anon_sym_UR_DQUOTE] = ACTIONS(5385),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5385),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2170),
  },
  [3256] = {
    [sym_template_argument_list] = STATE(3105),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3173),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2176),
    [anon_sym_COMMA] = ACTIONS(2176),
    [aux_sym_preproc_if_token2] = ACTIONS(2176),
    [aux_sym_preproc_else_token1] = ACTIONS(2176),
    [aux_sym_preproc_elif_token1] = ACTIONS(2168),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2176),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2176),
    [anon_sym_LPAREN2] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2168),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_STAR] = ACTIONS(2168),
    [anon_sym_SLASH] = ACTIONS(2168),
    [anon_sym_PERCENT] = ACTIONS(2168),
    [anon_sym_PIPE_PIPE] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_PIPE] = ACTIONS(2168),
    [anon_sym_CARET] = ACTIONS(2168),
    [anon_sym_AMP] = ACTIONS(2168),
    [anon_sym_EQ_EQ] = ACTIONS(2176),
    [anon_sym_BANG_EQ] = ACTIONS(2176),
    [anon_sym_GT] = ACTIONS(2168),
    [anon_sym_GT_EQ] = ACTIONS(2176),
    [anon_sym_LT_EQ] = ACTIONS(2168),
    [anon_sym_LT] = ACTIONS(7344),
    [anon_sym_LT_LT] = ACTIONS(2168),
    [anon_sym_GT_GT] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_signed] = ACTIONS(7382),
    [anon_sym_unsigned] = ACTIONS(7382),
    [anon_sym_long] = ACTIONS(7382),
    [anon_sym_short] = ACTIONS(7382),
    [anon_sym_LBRACK] = ACTIONS(2176),
    [anon_sym_EQ] = ACTIONS(2168),
    [anon_sym_QMARK] = ACTIONS(2176),
    [anon_sym_STAR_EQ] = ACTIONS(2176),
    [anon_sym_SLASH_EQ] = ACTIONS(2176),
    [anon_sym_PERCENT_EQ] = ACTIONS(2176),
    [anon_sym_PLUS_EQ] = ACTIONS(2176),
    [anon_sym_DASH_EQ] = ACTIONS(2176),
    [anon_sym_LT_LT_EQ] = ACTIONS(2176),
    [anon_sym_GT_GT_EQ] = ACTIONS(2176),
    [anon_sym_AMP_EQ] = ACTIONS(2176),
    [anon_sym_CARET_EQ] = ACTIONS(2176),
    [anon_sym_PIPE_EQ] = ACTIONS(2176),
    [anon_sym_and_eq] = ACTIONS(2168),
    [anon_sym_or_eq] = ACTIONS(2168),
    [anon_sym_xor_eq] = ACTIONS(2168),
    [anon_sym_LT_EQ_GT] = ACTIONS(2176),
    [anon_sym_or] = ACTIONS(2168),
    [anon_sym_and] = ACTIONS(2168),
    [anon_sym_bitor] = ACTIONS(2168),
    [anon_sym_xor] = ACTIONS(2168),
    [anon_sym_bitand] = ACTIONS(2168),
    [anon_sym_not_eq] = ACTIONS(2168),
    [anon_sym_is] = ACTIONS(2168),
    [anon_sym_as] = ACTIONS(2168),
    [anon_sym_DASH_DASH] = ACTIONS(2176),
    [anon_sym_PLUS_PLUS] = ACTIONS(2176),
    [anon_sym_DOT] = ACTIONS(2168),
    [anon_sym_DOT_STAR] = ACTIONS(2176),
    [anon_sym_DASH_GT] = ACTIONS(2176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_This] = ACTIONS(2168),
  },
  [3257] = {
    [sym_identifier] = ACTIONS(3046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3044),
    [anon_sym_COMMA] = ACTIONS(3044),
    [anon_sym_RPAREN] = ACTIONS(3044),
    [aux_sym_preproc_if_token2] = ACTIONS(3044),
    [aux_sym_preproc_else_token1] = ACTIONS(3044),
    [aux_sym_preproc_elif_token1] = ACTIONS(3046),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3044),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3044),
    [anon_sym_LPAREN2] = ACTIONS(3044),
    [anon_sym_DASH] = ACTIONS(3046),
    [anon_sym_PLUS] = ACTIONS(3046),
    [anon_sym_STAR] = ACTIONS(3046),
    [anon_sym_SLASH] = ACTIONS(3046),
    [anon_sym_PERCENT] = ACTIONS(3046),
    [anon_sym_PIPE_PIPE] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3044),
    [anon_sym_PIPE] = ACTIONS(3046),
    [anon_sym_CARET] = ACTIONS(3046),
    [anon_sym_AMP] = ACTIONS(3046),
    [anon_sym_EQ_EQ] = ACTIONS(3044),
    [anon_sym_BANG_EQ] = ACTIONS(3044),
    [anon_sym_GT] = ACTIONS(3046),
    [anon_sym_GT_EQ] = ACTIONS(3044),
    [anon_sym_LT_EQ] = ACTIONS(3046),
    [anon_sym_LT] = ACTIONS(3046),
    [anon_sym_LT_LT] = ACTIONS(3046),
    [anon_sym_GT_GT] = ACTIONS(3046),
    [anon_sym_COLON] = ACTIONS(3044),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym___attribute__] = ACTIONS(3046),
    [anon_sym___attribute] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3044),
    [anon_sym_RBRACE] = ACTIONS(3044),
    [anon_sym_LBRACK] = ACTIONS(3044),
    [anon_sym_RBRACK] = ACTIONS(3044),
    [anon_sym_EQ] = ACTIONS(3046),
    [anon_sym_QMARK] = ACTIONS(3044),
    [anon_sym_STAR_EQ] = ACTIONS(3044),
    [anon_sym_SLASH_EQ] = ACTIONS(3044),
    [anon_sym_PERCENT_EQ] = ACTIONS(3044),
    [anon_sym_PLUS_EQ] = ACTIONS(3044),
    [anon_sym_DASH_EQ] = ACTIONS(3044),
    [anon_sym_LT_LT_EQ] = ACTIONS(3044),
    [anon_sym_GT_GT_EQ] = ACTIONS(3044),
    [anon_sym_AMP_EQ] = ACTIONS(3044),
    [anon_sym_CARET_EQ] = ACTIONS(3044),
    [anon_sym_PIPE_EQ] = ACTIONS(3044),
    [anon_sym_and_eq] = ACTIONS(3046),
    [anon_sym_or_eq] = ACTIONS(3046),
    [anon_sym_xor_eq] = ACTIONS(3046),
    [anon_sym_LT_EQ_GT] = ACTIONS(3044),
    [anon_sym_or] = ACTIONS(3046),
    [anon_sym_and] = ACTIONS(3046),
    [anon_sym_bitor] = ACTIONS(3046),
    [anon_sym_xor] = ACTIONS(3046),
    [anon_sym_bitand] = ACTIONS(3046),
    [anon_sym_not_eq] = ACTIONS(3046),
    [anon_sym_is] = ACTIONS(3046),
    [anon_sym_as] = ACTIONS(3046),
    [anon_sym_DASH_DASH] = ACTIONS(3044),
    [anon_sym_PLUS_PLUS] = ACTIONS(3044),
    [anon_sym_DOT] = ACTIONS(3046),
    [anon_sym_DOT_STAR] = ACTIONS(3044),
    [anon_sym_DASH_GT] = ACTIONS(3044),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3046),
    [anon_sym_let] = ACTIONS(3046),
    [anon_sym_This] = ACTIONS(3046),
  },
  [3258] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7313),
    [anon_sym_COMMA] = ACTIONS(7313),
    [anon_sym_RPAREN] = ACTIONS(7313),
    [anon_sym_LPAREN2] = ACTIONS(7313),
    [anon_sym_DASH] = ACTIONS(7311),
    [anon_sym_PLUS] = ACTIONS(7311),
    [anon_sym_STAR] = ACTIONS(7311),
    [anon_sym_SLASH] = ACTIONS(7311),
    [anon_sym_PERCENT] = ACTIONS(7311),
    [anon_sym_PIPE_PIPE] = ACTIONS(7313),
    [anon_sym_AMP_AMP] = ACTIONS(7313),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_CARET] = ACTIONS(7311),
    [anon_sym_AMP] = ACTIONS(7311),
    [anon_sym_EQ_EQ] = ACTIONS(7313),
    [anon_sym_BANG_EQ] = ACTIONS(7313),
    [anon_sym_GT] = ACTIONS(7311),
    [anon_sym_GT_EQ] = ACTIONS(7313),
    [anon_sym_LT_EQ] = ACTIONS(7311),
    [anon_sym_LT] = ACTIONS(7311),
    [anon_sym_LT_LT] = ACTIONS(7311),
    [anon_sym_GT_GT] = ACTIONS(7311),
    [anon_sym_COLON] = ACTIONS(7313),
    [anon_sym_SEMI] = ACTIONS(7313),
    [anon_sym_RBRACE] = ACTIONS(7313),
    [anon_sym_LBRACK] = ACTIONS(7313),
    [anon_sym_RBRACK] = ACTIONS(7313),
    [anon_sym_EQ] = ACTIONS(7311),
    [anon_sym_QMARK] = ACTIONS(7313),
    [anon_sym_STAR_EQ] = ACTIONS(7313),
    [anon_sym_SLASH_EQ] = ACTIONS(7313),
    [anon_sym_PERCENT_EQ] = ACTIONS(7313),
    [anon_sym_PLUS_EQ] = ACTIONS(7313),
    [anon_sym_DASH_EQ] = ACTIONS(7313),
    [anon_sym_LT_LT_EQ] = ACTIONS(7313),
    [anon_sym_GT_GT_EQ] = ACTIONS(7313),
    [anon_sym_AMP_EQ] = ACTIONS(7313),
    [anon_sym_CARET_EQ] = ACTIONS(7313),
    [anon_sym_PIPE_EQ] = ACTIONS(7313),
    [anon_sym_and_eq] = ACTIONS(7311),
    [anon_sym_or_eq] = ACTIONS(7311),
    [anon_sym_xor_eq] = ACTIONS(7311),
    [anon_sym_LT_EQ_GT] = ACTIONS(7313),
    [anon_sym_or] = ACTIONS(7311),
    [anon_sym_and] = ACTIONS(7311),
    [anon_sym_bitor] = ACTIONS(7311),
    [anon_sym_xor] = ACTIONS(7311),
    [anon_sym_bitand] = ACTIONS(7311),
    [anon_sym_not_eq] = ACTIONS(7311),
    [anon_sym_is] = ACTIONS(7311),
    [anon_sym_as] = ACTIONS(7311),
    [anon_sym_DASH_DASH] = ACTIONS(7313),
    [anon_sym_PLUS_PLUS] = ACTIONS(7313),
    [anon_sym_DOT] = ACTIONS(7311),
    [anon_sym_DOT_STAR] = ACTIONS(7313),
    [anon_sym_DASH_GT] = ACTIONS(7313),
    [anon_sym_L_DQUOTE] = ACTIONS(7313),
    [anon_sym_u_DQUOTE] = ACTIONS(7313),
    [anon_sym_U_DQUOTE] = ACTIONS(7313),
    [anon_sym_u8_DQUOTE] = ACTIONS(7313),
    [anon_sym_DQUOTE] = ACTIONS(7313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7313),
    [anon_sym_LR_DQUOTE] = ACTIONS(7313),
    [anon_sym_uR_DQUOTE] = ACTIONS(7313),
    [anon_sym_UR_DQUOTE] = ACTIONS(7313),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7313),
    [sym_literal_suffix] = ACTIONS(7311),
  },
  [3259] = {
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_STAR] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym___extension__] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2883),
    [anon_sym_out] = ACTIONS(2883),
    [anon_sym_inout] = ACTIONS(2883),
    [anon_sym_virtual] = ACTIONS(2883),
    [anon_sym_extern] = ACTIONS(2883),
    [anon_sym___attribute__] = ACTIONS(2883),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2881),
    [anon_sym___declspec] = ACTIONS(2883),
    [anon_sym___based] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_register] = ACTIONS(2883),
    [anon_sym_inline] = ACTIONS(2883),
    [anon_sym___inline] = ACTIONS(2883),
    [anon_sym___inline__] = ACTIONS(2883),
    [anon_sym___forceinline] = ACTIONS(2883),
    [anon_sym_thread_local] = ACTIONS(2883),
    [anon_sym___thread] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_constexpr] = ACTIONS(2883),
    [anon_sym_volatile] = ACTIONS(2883),
    [anon_sym_restrict] = ACTIONS(2883),
    [anon_sym___restrict__] = ACTIONS(2883),
    [anon_sym__Atomic] = ACTIONS(2883),
    [anon_sym__Noreturn] = ACTIONS(2883),
    [anon_sym_noreturn] = ACTIONS(2883),
    [anon_sym__Nonnull] = ACTIONS(2883),
    [anon_sym_mutable] = ACTIONS(2883),
    [anon_sym_constinit] = ACTIONS(2883),
    [anon_sym_consteval] = ACTIONS(2883),
    [anon_sym_alignas] = ACTIONS(2883),
    [anon_sym__Alignas] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
    [anon_sym_decltype] = ACTIONS(2883),
    [anon_sym_template] = ACTIONS(2883),
    [anon_sym_operator] = ACTIONS(2883),
    [anon_sym_precise] = ACTIONS(2883),
    [anon_sym_shared] = ACTIONS(2883),
    [anon_sym_groupshared] = ACTIONS(2883),
    [anon_sym_uniform] = ACTIONS(2883),
    [anon_sym_row_major] = ACTIONS(2883),
    [anon_sym_column_major] = ACTIONS(2883),
    [anon_sym_globallycoherent] = ACTIONS(2883),
    [anon_sym_centroid] = ACTIONS(2883),
    [anon_sym_noperspective] = ACTIONS(2883),
    [anon_sym_nointerpolation] = ACTIONS(2883),
    [anon_sym_sample] = ACTIONS(2883),
    [anon_sym_linear] = ACTIONS(2883),
    [anon_sym_snorm] = ACTIONS(2883),
    [anon_sym_unorm] = ACTIONS(2883),
    [anon_sym_point] = ACTIONS(2883),
    [anon_sym_line] = ACTIONS(2883),
    [anon_sym_triangleadj] = ACTIONS(2883),
    [anon_sym_lineadj] = ACTIONS(2883),
    [anon_sym_triangle] = ACTIONS(2883),
  },
  [3260] = {
    [sym_attribute_declaration] = STATE(3282),
    [aux_sym_attributed_declarator_repeat1] = STATE(3282),
    [sym_identifier] = ACTIONS(7594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7596),
    [anon_sym_COMMA] = ACTIONS(7596),
    [anon_sym_RPAREN] = ACTIONS(7596),
    [aux_sym_preproc_if_token2] = ACTIONS(7596),
    [aux_sym_preproc_else_token1] = ACTIONS(7596),
    [aux_sym_preproc_elif_token1] = ACTIONS(7594),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7596),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7596),
    [anon_sym_LPAREN2] = ACTIONS(7596),
    [anon_sym_DASH] = ACTIONS(7594),
    [anon_sym_PLUS] = ACTIONS(7594),
    [anon_sym_STAR] = ACTIONS(7594),
    [anon_sym_SLASH] = ACTIONS(7594),
    [anon_sym_PERCENT] = ACTIONS(7594),
    [anon_sym_PIPE_PIPE] = ACTIONS(7596),
    [anon_sym_AMP_AMP] = ACTIONS(7596),
    [anon_sym_PIPE] = ACTIONS(7594),
    [anon_sym_CARET] = ACTIONS(7594),
    [anon_sym_AMP] = ACTIONS(7594),
    [anon_sym_EQ_EQ] = ACTIONS(7596),
    [anon_sym_BANG_EQ] = ACTIONS(7596),
    [anon_sym_GT] = ACTIONS(7594),
    [anon_sym_GT_EQ] = ACTIONS(7596),
    [anon_sym_LT_EQ] = ACTIONS(7594),
    [anon_sym_LT] = ACTIONS(7594),
    [anon_sym_LT_LT] = ACTIONS(7594),
    [anon_sym_GT_GT] = ACTIONS(7594),
    [anon_sym_COLON] = ACTIONS(7596),
    [anon_sym_SEMI] = ACTIONS(7596),
    [anon_sym___attribute__] = ACTIONS(7594),
    [anon_sym___attribute] = ACTIONS(7594),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7500),
    [anon_sym_RBRACE] = ACTIONS(7596),
    [anon_sym_LBRACK] = ACTIONS(7594),
    [anon_sym_RBRACK] = ACTIONS(7596),
    [anon_sym_EQ] = ACTIONS(7594),
    [anon_sym_QMARK] = ACTIONS(7596),
    [anon_sym_STAR_EQ] = ACTIONS(7596),
    [anon_sym_SLASH_EQ] = ACTIONS(7596),
    [anon_sym_PERCENT_EQ] = ACTIONS(7596),
    [anon_sym_PLUS_EQ] = ACTIONS(7596),
    [anon_sym_DASH_EQ] = ACTIONS(7596),
    [anon_sym_LT_LT_EQ] = ACTIONS(7596),
    [anon_sym_GT_GT_EQ] = ACTIONS(7596),
    [anon_sym_AMP_EQ] = ACTIONS(7596),
    [anon_sym_CARET_EQ] = ACTIONS(7596),
    [anon_sym_PIPE_EQ] = ACTIONS(7596),
    [anon_sym_and_eq] = ACTIONS(7594),
    [anon_sym_or_eq] = ACTIONS(7594),
    [anon_sym_xor_eq] = ACTIONS(7594),
    [anon_sym_LT_EQ_GT] = ACTIONS(7596),
    [anon_sym_or] = ACTIONS(7594),
    [anon_sym_and] = ACTIONS(7594),
    [anon_sym_bitor] = ACTIONS(7594),
    [anon_sym_xor] = ACTIONS(7594),
    [anon_sym_bitand] = ACTIONS(7594),
    [anon_sym_not_eq] = ACTIONS(7594),
    [anon_sym_is] = ACTIONS(7594),
    [anon_sym_as] = ACTIONS(7594),
    [anon_sym_DASH_DASH] = ACTIONS(7596),
    [anon_sym_PLUS_PLUS] = ACTIONS(7596),
    [anon_sym_DOT] = ACTIONS(7594),
    [anon_sym_DOT_STAR] = ACTIONS(7596),
    [anon_sym_DASH_GT] = ACTIONS(7596),
    [sym_comment] = ACTIONS(3),
  },
  [3261] = {
    [sym_string_literal] = STATE(3268),
    [sym_raw_string_literal] = STATE(3268),
    [aux_sym_concatenated_string_repeat1] = STATE(3268),
    [sym_identifier] = ACTIONS(7598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7190),
    [anon_sym_COMMA] = ACTIONS(7190),
    [anon_sym_LPAREN2] = ACTIONS(7190),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_STAR] = ACTIONS(7192),
    [anon_sym_SLASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [anon_sym_PIPE_PIPE] = ACTIONS(7190),
    [anon_sym_AMP_AMP] = ACTIONS(7190),
    [anon_sym_PIPE] = ACTIONS(7192),
    [anon_sym_CARET] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(7192),
    [anon_sym_EQ_EQ] = ACTIONS(7190),
    [anon_sym_BANG_EQ] = ACTIONS(7190),
    [anon_sym_GT] = ACTIONS(7192),
    [anon_sym_GT_EQ] = ACTIONS(7192),
    [anon_sym_LT_EQ] = ACTIONS(7192),
    [anon_sym_LT] = ACTIONS(7192),
    [anon_sym_LT_LT] = ACTIONS(7192),
    [anon_sym_GT_GT] = ACTIONS(7192),
    [anon_sym_LBRACK] = ACTIONS(7190),
    [anon_sym_EQ] = ACTIONS(7192),
    [anon_sym_QMARK] = ACTIONS(7190),
    [anon_sym_STAR_EQ] = ACTIONS(7190),
    [anon_sym_SLASH_EQ] = ACTIONS(7190),
    [anon_sym_PERCENT_EQ] = ACTIONS(7190),
    [anon_sym_PLUS_EQ] = ACTIONS(7190),
    [anon_sym_DASH_EQ] = ACTIONS(7190),
    [anon_sym_LT_LT_EQ] = ACTIONS(7190),
    [anon_sym_GT_GT_EQ] = ACTIONS(7192),
    [anon_sym_AMP_EQ] = ACTIONS(7190),
    [anon_sym_CARET_EQ] = ACTIONS(7190),
    [anon_sym_PIPE_EQ] = ACTIONS(7190),
    [anon_sym_and_eq] = ACTIONS(7192),
    [anon_sym_or_eq] = ACTIONS(7192),
    [anon_sym_xor_eq] = ACTIONS(7192),
    [anon_sym_LT_EQ_GT] = ACTIONS(7190),
    [anon_sym_or] = ACTIONS(7192),
    [anon_sym_and] = ACTIONS(7192),
    [anon_sym_bitor] = ACTIONS(7192),
    [anon_sym_xor] = ACTIONS(7192),
    [anon_sym_bitand] = ACTIONS(7192),
    [anon_sym_not_eq] = ACTIONS(7192),
    [anon_sym_is] = ACTIONS(7192),
    [anon_sym_as] = ACTIONS(7192),
    [anon_sym_DASH_DASH] = ACTIONS(7190),
    [anon_sym_PLUS_PLUS] = ACTIONS(7190),
    [anon_sym_DOT] = ACTIONS(7192),
    [anon_sym_DOT_STAR] = ACTIONS(7190),
    [anon_sym_DASH_GT] = ACTIONS(7190),
    [anon_sym_L_DQUOTE] = ACTIONS(7600),
    [anon_sym_u_DQUOTE] = ACTIONS(7600),
    [anon_sym_U_DQUOTE] = ACTIONS(7600),
    [anon_sym_u8_DQUOTE] = ACTIONS(7600),
    [anon_sym_DQUOTE] = ACTIONS(7600),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(7190),
    [anon_sym_R_DQUOTE] = ACTIONS(7602),
    [anon_sym_LR_DQUOTE] = ACTIONS(7602),
    [anon_sym_uR_DQUOTE] = ACTIONS(7602),
    [anon_sym_UR_DQUOTE] = ACTIONS(7602),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7602),
    [sym_literal_suffix] = ACTIONS(7192),
  },
  [3262] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3997),
    [anon_sym_COMMA] = ACTIONS(3997),
    [anon_sym_RPAREN] = ACTIONS(3997),
    [anon_sym_LPAREN2] = ACTIONS(3997),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_STAR] = ACTIONS(3995),
    [anon_sym_SLASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3995),
    [anon_sym_PIPE_PIPE] = ACTIONS(3997),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_PIPE] = ACTIONS(3995),
    [anon_sym_CARET] = ACTIONS(3995),
    [anon_sym_AMP] = ACTIONS(3995),
    [anon_sym_EQ_EQ] = ACTIONS(3997),
    [anon_sym_BANG_EQ] = ACTIONS(3997),
    [anon_sym_GT] = ACTIONS(3995),
    [anon_sym_GT_EQ] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3995),
    [anon_sym_LT] = ACTIONS(3995),
    [anon_sym_LT_LT] = ACTIONS(3995),
    [anon_sym_GT_GT] = ACTIONS(3995),
    [anon_sym_COLON] = ACTIONS(3997),
    [anon_sym_SEMI] = ACTIONS(3997),
    [anon_sym___attribute__] = ACTIONS(3997),
    [anon_sym___attribute] = ACTIONS(3995),
    [anon_sym_LBRACE] = ACTIONS(3997),
    [anon_sym_RBRACE] = ACTIONS(3997),
    [anon_sym_signed] = ACTIONS(7604),
    [anon_sym_unsigned] = ACTIONS(7604),
    [anon_sym_long] = ACTIONS(7604),
    [anon_sym_short] = ACTIONS(7604),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_RBRACK] = ACTIONS(3997),
    [anon_sym_EQ] = ACTIONS(3995),
    [anon_sym_QMARK] = ACTIONS(3997),
    [anon_sym_STAR_EQ] = ACTIONS(3997),
    [anon_sym_SLASH_EQ] = ACTIONS(3997),
    [anon_sym_PERCENT_EQ] = ACTIONS(3997),
    [anon_sym_PLUS_EQ] = ACTIONS(3997),
    [anon_sym_DASH_EQ] = ACTIONS(3997),
    [anon_sym_LT_LT_EQ] = ACTIONS(3997),
    [anon_sym_GT_GT_EQ] = ACTIONS(3997),
    [anon_sym_AMP_EQ] = ACTIONS(3997),
    [anon_sym_CARET_EQ] = ACTIONS(3997),
    [anon_sym_PIPE_EQ] = ACTIONS(3997),
    [anon_sym_and_eq] = ACTIONS(3997),
    [anon_sym_or_eq] = ACTIONS(3997),
    [anon_sym_xor_eq] = ACTIONS(3997),
    [anon_sym_LT_EQ_GT] = ACTIONS(3997),
    [anon_sym_or] = ACTIONS(3995),
    [anon_sym_and] = ACTIONS(3995),
    [anon_sym_bitor] = ACTIONS(3997),
    [anon_sym_xor] = ACTIONS(3995),
    [anon_sym_bitand] = ACTIONS(3997),
    [anon_sym_not_eq] = ACTIONS(3997),
    [anon_sym_is] = ACTIONS(3997),
    [anon_sym_as] = ACTIONS(3997),
    [anon_sym_DASH_DASH] = ACTIONS(3997),
    [anon_sym_PLUS_PLUS] = ACTIONS(3997),
    [anon_sym_DOT] = ACTIONS(3995),
    [anon_sym_DOT_STAR] = ACTIONS(3997),
    [anon_sym_DASH_GT] = ACTIONS(3997),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3997),
    [anon_sym_let] = ACTIONS(3997),
    [anon_sym_This] = ACTIONS(3997),
  },
  [3263] = {
    [sym_attribute_specifier] = STATE(3213),
    [sym_enumerator_list] = STATE(3152),
    [sym__enum_base_clause] = STATE(3114),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3480),
    [aux_sym_preproc_if_token2] = ACTIONS(3480),
    [aux_sym_preproc_else_token1] = ACTIONS(3480),
    [aux_sym_preproc_elif_token1] = ACTIONS(3478),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3480),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3478),
    [anon_sym_PLUS] = ACTIONS(3478),
    [anon_sym_STAR] = ACTIONS(3478),
    [anon_sym_SLASH] = ACTIONS(3478),
    [anon_sym_PERCENT] = ACTIONS(3478),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_PIPE] = ACTIONS(3478),
    [anon_sym_CARET] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_EQ_EQ] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_GT] = ACTIONS(3478),
    [anon_sym_GT_EQ] = ACTIONS(3480),
    [anon_sym_LT_EQ] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_LT_LT] = ACTIONS(3478),
    [anon_sym_GT_GT] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(7606),
    [anon_sym___attribute__] = ACTIONS(7254),
    [anon_sym___attribute] = ACTIONS(7254),
    [anon_sym_LBRACE] = ACTIONS(7384),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_STAR_EQ] = ACTIONS(3480),
    [anon_sym_SLASH_EQ] = ACTIONS(3480),
    [anon_sym_PERCENT_EQ] = ACTIONS(3480),
    [anon_sym_PLUS_EQ] = ACTIONS(3480),
    [anon_sym_DASH_EQ] = ACTIONS(3480),
    [anon_sym_LT_LT_EQ] = ACTIONS(3480),
    [anon_sym_GT_GT_EQ] = ACTIONS(3480),
    [anon_sym_AMP_EQ] = ACTIONS(3480),
    [anon_sym_CARET_EQ] = ACTIONS(3480),
    [anon_sym_PIPE_EQ] = ACTIONS(3480),
    [anon_sym_and_eq] = ACTIONS(3478),
    [anon_sym_or_eq] = ACTIONS(3478),
    [anon_sym_xor_eq] = ACTIONS(3478),
    [anon_sym_LT_EQ_GT] = ACTIONS(3480),
    [anon_sym_or] = ACTIONS(3478),
    [anon_sym_and] = ACTIONS(3478),
    [anon_sym_bitor] = ACTIONS(3478),
    [anon_sym_xor] = ACTIONS(3478),
    [anon_sym_bitand] = ACTIONS(3478),
    [anon_sym_not_eq] = ACTIONS(3478),
    [anon_sym_is] = ACTIONS(3478),
    [anon_sym_as] = ACTIONS(3478),
    [anon_sym_DASH_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_PLUS] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3478),
    [anon_sym_DOT_STAR] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3478),
    [anon_sym_let] = ACTIONS(3478),
    [anon_sym_This] = ACTIONS(3478),
  },
  [3264] = {
    [sym_attribute_specifier] = STATE(3229),
    [sym_enumerator_list] = STATE(3145),
    [sym__enum_base_clause] = STATE(3128),
    [sym_identifier] = ACTIONS(3502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3504),
    [anon_sym_COMMA] = ACTIONS(3504),
    [aux_sym_preproc_if_token2] = ACTIONS(3504),
    [aux_sym_preproc_else_token1] = ACTIONS(3504),
    [aux_sym_preproc_elif_token1] = ACTIONS(3502),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3504),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3504),
    [anon_sym_LPAREN2] = ACTIONS(3504),
    [anon_sym_DASH] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(3502),
    [anon_sym_STAR] = ACTIONS(3502),
    [anon_sym_SLASH] = ACTIONS(3502),
    [anon_sym_PERCENT] = ACTIONS(3502),
    [anon_sym_PIPE_PIPE] = ACTIONS(3504),
    [anon_sym_AMP_AMP] = ACTIONS(3504),
    [anon_sym_PIPE] = ACTIONS(3502),
    [anon_sym_CARET] = ACTIONS(3502),
    [anon_sym_AMP] = ACTIONS(3502),
    [anon_sym_EQ_EQ] = ACTIONS(3504),
    [anon_sym_BANG_EQ] = ACTIONS(3504),
    [anon_sym_GT] = ACTIONS(3502),
    [anon_sym_GT_EQ] = ACTIONS(3504),
    [anon_sym_LT_EQ] = ACTIONS(3502),
    [anon_sym_LT] = ACTIONS(3502),
    [anon_sym_LT_LT] = ACTIONS(3502),
    [anon_sym_GT_GT] = ACTIONS(3502),
    [anon_sym_COLON] = ACTIONS(7606),
    [anon_sym___attribute__] = ACTIONS(7254),
    [anon_sym___attribute] = ACTIONS(7254),
    [anon_sym_LBRACE] = ACTIONS(7384),
    [anon_sym_LBRACK] = ACTIONS(3504),
    [anon_sym_EQ] = ACTIONS(3502),
    [anon_sym_QMARK] = ACTIONS(3504),
    [anon_sym_STAR_EQ] = ACTIONS(3504),
    [anon_sym_SLASH_EQ] = ACTIONS(3504),
    [anon_sym_PERCENT_EQ] = ACTIONS(3504),
    [anon_sym_PLUS_EQ] = ACTIONS(3504),
    [anon_sym_DASH_EQ] = ACTIONS(3504),
    [anon_sym_LT_LT_EQ] = ACTIONS(3504),
    [anon_sym_GT_GT_EQ] = ACTIONS(3504),
    [anon_sym_AMP_EQ] = ACTIONS(3504),
    [anon_sym_CARET_EQ] = ACTIONS(3504),
    [anon_sym_PIPE_EQ] = ACTIONS(3504),
    [anon_sym_and_eq] = ACTIONS(3502),
    [anon_sym_or_eq] = ACTIONS(3502),
    [anon_sym_xor_eq] = ACTIONS(3502),
    [anon_sym_LT_EQ_GT] = ACTIONS(3504),
    [anon_sym_or] = ACTIONS(3502),
    [anon_sym_and] = ACTIONS(3502),
    [anon_sym_bitor] = ACTIONS(3502),
    [anon_sym_xor] = ACTIONS(3502),
    [anon_sym_bitand] = ACTIONS(3502),
    [anon_sym_not_eq] = ACTIONS(3502),
    [anon_sym_is] = ACTIONS(3502),
    [anon_sym_as] = ACTIONS(3502),
    [anon_sym_DASH_DASH] = ACTIONS(3504),
    [anon_sym_PLUS_PLUS] = ACTIONS(3504),
    [anon_sym_DOT] = ACTIONS(3502),
    [anon_sym_DOT_STAR] = ACTIONS(3504),
    [anon_sym_DASH_GT] = ACTIONS(3504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3502),
    [anon_sym_let] = ACTIONS(3502),
    [anon_sym_This] = ACTIONS(3502),
  },
  [3265] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4100),
    [anon_sym_COMMA] = ACTIONS(4100),
    [anon_sym_RPAREN] = ACTIONS(4100),
    [anon_sym_LPAREN2] = ACTIONS(4100),
    [anon_sym_DASH] = ACTIONS(4102),
    [anon_sym_PLUS] = ACTIONS(4102),
    [anon_sym_STAR] = ACTIONS(4102),
    [anon_sym_SLASH] = ACTIONS(4102),
    [anon_sym_PERCENT] = ACTIONS(4102),
    [anon_sym_PIPE_PIPE] = ACTIONS(4100),
    [anon_sym_AMP_AMP] = ACTIONS(4100),
    [anon_sym_PIPE] = ACTIONS(4102),
    [anon_sym_CARET] = ACTIONS(4102),
    [anon_sym_AMP] = ACTIONS(4102),
    [anon_sym_EQ_EQ] = ACTIONS(4100),
    [anon_sym_BANG_EQ] = ACTIONS(4100),
    [anon_sym_GT] = ACTIONS(4102),
    [anon_sym_GT_EQ] = ACTIONS(4100),
    [anon_sym_LT_EQ] = ACTIONS(4102),
    [anon_sym_LT] = ACTIONS(4102),
    [anon_sym_LT_LT] = ACTIONS(4102),
    [anon_sym_GT_GT] = ACTIONS(4102),
    [anon_sym_COLON] = ACTIONS(4100),
    [anon_sym_SEMI] = ACTIONS(4100),
    [anon_sym___attribute__] = ACTIONS(4100),
    [anon_sym___attribute] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(4100),
    [anon_sym_RBRACE] = ACTIONS(4100),
    [anon_sym_signed] = ACTIONS(7604),
    [anon_sym_unsigned] = ACTIONS(7604),
    [anon_sym_long] = ACTIONS(7604),
    [anon_sym_short] = ACTIONS(7604),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_RBRACK] = ACTIONS(4100),
    [anon_sym_EQ] = ACTIONS(4102),
    [anon_sym_QMARK] = ACTIONS(4100),
    [anon_sym_STAR_EQ] = ACTIONS(4100),
    [anon_sym_SLASH_EQ] = ACTIONS(4100),
    [anon_sym_PERCENT_EQ] = ACTIONS(4100),
    [anon_sym_PLUS_EQ] = ACTIONS(4100),
    [anon_sym_DASH_EQ] = ACTIONS(4100),
    [anon_sym_LT_LT_EQ] = ACTIONS(4100),
    [anon_sym_GT_GT_EQ] = ACTIONS(4100),
    [anon_sym_AMP_EQ] = ACTIONS(4100),
    [anon_sym_CARET_EQ] = ACTIONS(4100),
    [anon_sym_PIPE_EQ] = ACTIONS(4100),
    [anon_sym_and_eq] = ACTIONS(4100),
    [anon_sym_or_eq] = ACTIONS(4100),
    [anon_sym_xor_eq] = ACTIONS(4100),
    [anon_sym_LT_EQ_GT] = ACTIONS(4100),
    [anon_sym_or] = ACTIONS(4102),
    [anon_sym_and] = ACTIONS(4102),
    [anon_sym_bitor] = ACTIONS(4100),
    [anon_sym_xor] = ACTIONS(4102),
    [anon_sym_bitand] = ACTIONS(4100),
    [anon_sym_not_eq] = ACTIONS(4100),
    [anon_sym_is] = ACTIONS(4100),
    [anon_sym_as] = ACTIONS(4100),
    [anon_sym_DASH_DASH] = ACTIONS(4100),
    [anon_sym_PLUS_PLUS] = ACTIONS(4100),
    [anon_sym_DOT] = ACTIONS(4102),
    [anon_sym_DOT_STAR] = ACTIONS(4100),
    [anon_sym_DASH_GT] = ACTIONS(4100),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4100),
    [anon_sym_let] = ACTIONS(4100),
    [anon_sym_This] = ACTIONS(4100),
  },
  [3266] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4166),
    [anon_sym_COMMA] = ACTIONS(4166),
    [anon_sym_RPAREN] = ACTIONS(4166),
    [anon_sym_LPAREN2] = ACTIONS(4166),
    [anon_sym_DASH] = ACTIONS(4164),
    [anon_sym_PLUS] = ACTIONS(4164),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4164),
    [anon_sym_PERCENT] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(4166),
    [anon_sym_AMP_AMP] = ACTIONS(4166),
    [anon_sym_PIPE] = ACTIONS(4164),
    [anon_sym_CARET] = ACTIONS(4164),
    [anon_sym_AMP] = ACTIONS(4164),
    [anon_sym_EQ_EQ] = ACTIONS(4166),
    [anon_sym_BANG_EQ] = ACTIONS(4166),
    [anon_sym_GT] = ACTIONS(4164),
    [anon_sym_GT_EQ] = ACTIONS(4166),
    [anon_sym_LT_EQ] = ACTIONS(4164),
    [anon_sym_LT] = ACTIONS(4164),
    [anon_sym_LT_LT] = ACTIONS(4164),
    [anon_sym_GT_GT] = ACTIONS(4164),
    [anon_sym_COLON] = ACTIONS(4166),
    [anon_sym_SEMI] = ACTIONS(4166),
    [anon_sym___attribute__] = ACTIONS(4166),
    [anon_sym___attribute] = ACTIONS(4164),
    [anon_sym_LBRACE] = ACTIONS(4166),
    [anon_sym_RBRACE] = ACTIONS(4166),
    [anon_sym_signed] = ACTIONS(7608),
    [anon_sym_unsigned] = ACTIONS(7608),
    [anon_sym_long] = ACTIONS(7608),
    [anon_sym_short] = ACTIONS(7608),
    [anon_sym_LBRACK] = ACTIONS(4166),
    [anon_sym_RBRACK] = ACTIONS(4166),
    [anon_sym_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(4166),
    [anon_sym_STAR_EQ] = ACTIONS(4166),
    [anon_sym_SLASH_EQ] = ACTIONS(4166),
    [anon_sym_PERCENT_EQ] = ACTIONS(4166),
    [anon_sym_PLUS_EQ] = ACTIONS(4166),
    [anon_sym_DASH_EQ] = ACTIONS(4166),
    [anon_sym_LT_LT_EQ] = ACTIONS(4166),
    [anon_sym_GT_GT_EQ] = ACTIONS(4166),
    [anon_sym_AMP_EQ] = ACTIONS(4166),
    [anon_sym_CARET_EQ] = ACTIONS(4166),
    [anon_sym_PIPE_EQ] = ACTIONS(4166),
    [anon_sym_and_eq] = ACTIONS(4166),
    [anon_sym_or_eq] = ACTIONS(4166),
    [anon_sym_xor_eq] = ACTIONS(4166),
    [anon_sym_LT_EQ_GT] = ACTIONS(4166),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_bitor] = ACTIONS(4166),
    [anon_sym_xor] = ACTIONS(4164),
    [anon_sym_bitand] = ACTIONS(4166),
    [anon_sym_not_eq] = ACTIONS(4166),
    [anon_sym_is] = ACTIONS(4166),
    [anon_sym_as] = ACTIONS(4166),
    [anon_sym_DASH_DASH] = ACTIONS(4166),
    [anon_sym_PLUS_PLUS] = ACTIONS(4166),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_DOT_STAR] = ACTIONS(4166),
    [anon_sym_DASH_GT] = ACTIONS(4166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4166),
    [anon_sym_let] = ACTIONS(4166),
    [anon_sym_This] = ACTIONS(4166),
  },
  [3267] = {
    [sym_identifier] = ACTIONS(7610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7612),
    [anon_sym_COMMA] = ACTIONS(7612),
    [anon_sym_RPAREN] = ACTIONS(7612),
    [aux_sym_preproc_if_token2] = ACTIONS(7612),
    [aux_sym_preproc_else_token1] = ACTIONS(7612),
    [aux_sym_preproc_elif_token1] = ACTIONS(7610),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7612),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7612),
    [anon_sym_LPAREN2] = ACTIONS(7612),
    [anon_sym_DASH] = ACTIONS(7610),
    [anon_sym_PLUS] = ACTIONS(7610),
    [anon_sym_STAR] = ACTIONS(7610),
    [anon_sym_SLASH] = ACTIONS(7610),
    [anon_sym_PERCENT] = ACTIONS(7610),
    [anon_sym_PIPE_PIPE] = ACTIONS(7612),
    [anon_sym_AMP_AMP] = ACTIONS(7612),
    [anon_sym_PIPE] = ACTIONS(7610),
    [anon_sym_CARET] = ACTIONS(7610),
    [anon_sym_AMP] = ACTIONS(7610),
    [anon_sym_EQ_EQ] = ACTIONS(7612),
    [anon_sym_BANG_EQ] = ACTIONS(7612),
    [anon_sym_GT] = ACTIONS(7610),
    [anon_sym_GT_EQ] = ACTIONS(7612),
    [anon_sym_LT_EQ] = ACTIONS(7610),
    [anon_sym_LT] = ACTIONS(7610),
    [anon_sym_LT_LT] = ACTIONS(7610),
    [anon_sym_GT_GT] = ACTIONS(7610),
    [anon_sym_COLON] = ACTIONS(7612),
    [anon_sym_SEMI] = ACTIONS(7612),
    [anon_sym___attribute__] = ACTIONS(7610),
    [anon_sym___attribute] = ACTIONS(7610),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7612),
    [anon_sym_LBRACE] = ACTIONS(7612),
    [anon_sym_RBRACE] = ACTIONS(7612),
    [anon_sym_LBRACK] = ACTIONS(7610),
    [anon_sym_RBRACK] = ACTIONS(7612),
    [anon_sym_EQ] = ACTIONS(7610),
    [anon_sym_QMARK] = ACTIONS(7612),
    [anon_sym_STAR_EQ] = ACTIONS(7612),
    [anon_sym_SLASH_EQ] = ACTIONS(7612),
    [anon_sym_PERCENT_EQ] = ACTIONS(7612),
    [anon_sym_PLUS_EQ] = ACTIONS(7612),
    [anon_sym_DASH_EQ] = ACTIONS(7612),
    [anon_sym_LT_LT_EQ] = ACTIONS(7612),
    [anon_sym_GT_GT_EQ] = ACTIONS(7612),
    [anon_sym_AMP_EQ] = ACTIONS(7612),
    [anon_sym_CARET_EQ] = ACTIONS(7612),
    [anon_sym_PIPE_EQ] = ACTIONS(7612),
    [anon_sym_and_eq] = ACTIONS(7610),
    [anon_sym_or_eq] = ACTIONS(7610),
    [anon_sym_xor_eq] = ACTIONS(7610),
    [anon_sym_LT_EQ_GT] = ACTIONS(7612),
    [anon_sym_or] = ACTIONS(7610),
    [anon_sym_and] = ACTIONS(7610),
    [anon_sym_bitor] = ACTIONS(7610),
    [anon_sym_xor] = ACTIONS(7610),
    [anon_sym_bitand] = ACTIONS(7610),
    [anon_sym_not_eq] = ACTIONS(7610),
    [anon_sym_is] = ACTIONS(7610),
    [anon_sym_as] = ACTIONS(7610),
    [anon_sym_DASH_DASH] = ACTIONS(7612),
    [anon_sym_PLUS_PLUS] = ACTIONS(7612),
    [anon_sym_DOT] = ACTIONS(7610),
    [anon_sym_DOT_STAR] = ACTIONS(7612),
    [anon_sym_DASH_GT] = ACTIONS(7612),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(7610),
  },
  [3268] = {
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [aux_sym_concatenated_string_repeat1] = STATE(3276),
    [sym_identifier] = ACTIONS(7614),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7217),
    [anon_sym_COMMA] = ACTIONS(7217),
    [anon_sym_LPAREN2] = ACTIONS(7217),
    [anon_sym_DASH] = ACTIONS(7219),
    [anon_sym_PLUS] = ACTIONS(7219),
    [anon_sym_STAR] = ACTIONS(7219),
    [anon_sym_SLASH] = ACTIONS(7219),
    [anon_sym_PERCENT] = ACTIONS(7219),
    [anon_sym_PIPE_PIPE] = ACTIONS(7217),
    [anon_sym_AMP_AMP] = ACTIONS(7217),
    [anon_sym_PIPE] = ACTIONS(7219),
    [anon_sym_CARET] = ACTIONS(7219),
    [anon_sym_AMP] = ACTIONS(7219),
    [anon_sym_EQ_EQ] = ACTIONS(7217),
    [anon_sym_BANG_EQ] = ACTIONS(7217),
    [anon_sym_GT] = ACTIONS(7219),
    [anon_sym_GT_EQ] = ACTIONS(7219),
    [anon_sym_LT_EQ] = ACTIONS(7219),
    [anon_sym_LT] = ACTIONS(7219),
    [anon_sym_LT_LT] = ACTIONS(7219),
    [anon_sym_GT_GT] = ACTIONS(7219),
    [anon_sym_LBRACK] = ACTIONS(7217),
    [anon_sym_EQ] = ACTIONS(7219),
    [anon_sym_QMARK] = ACTIONS(7217),
    [anon_sym_STAR_EQ] = ACTIONS(7217),
    [anon_sym_SLASH_EQ] = ACTIONS(7217),
    [anon_sym_PERCENT_EQ] = ACTIONS(7217),
    [anon_sym_PLUS_EQ] = ACTIONS(7217),
    [anon_sym_DASH_EQ] = ACTIONS(7217),
    [anon_sym_LT_LT_EQ] = ACTIONS(7217),
    [anon_sym_GT_GT_EQ] = ACTIONS(7219),
    [anon_sym_AMP_EQ] = ACTIONS(7217),
    [anon_sym_CARET_EQ] = ACTIONS(7217),
    [anon_sym_PIPE_EQ] = ACTIONS(7217),
    [anon_sym_and_eq] = ACTIONS(7219),
    [anon_sym_or_eq] = ACTIONS(7219),
    [anon_sym_xor_eq] = ACTIONS(7219),
    [anon_sym_LT_EQ_GT] = ACTIONS(7217),
    [anon_sym_or] = ACTIONS(7219),
    [anon_sym_and] = ACTIONS(7219),
    [anon_sym_bitor] = ACTIONS(7219),
    [anon_sym_xor] = ACTIONS(7219),
    [anon_sym_bitand] = ACTIONS(7219),
    [anon_sym_not_eq] = ACTIONS(7219),
    [anon_sym_is] = ACTIONS(7219),
    [anon_sym_as] = ACTIONS(7219),
    [anon_sym_DASH_DASH] = ACTIONS(7217),
    [anon_sym_PLUS_PLUS] = ACTIONS(7217),
    [anon_sym_DOT] = ACTIONS(7219),
    [anon_sym_DOT_STAR] = ACTIONS(7217),
    [anon_sym_DASH_GT] = ACTIONS(7217),
    [anon_sym_L_DQUOTE] = ACTIONS(7600),
    [anon_sym_u_DQUOTE] = ACTIONS(7600),
    [anon_sym_U_DQUOTE] = ACTIONS(7600),
    [anon_sym_u8_DQUOTE] = ACTIONS(7600),
    [anon_sym_DQUOTE] = ACTIONS(7600),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(7217),
    [anon_sym_R_DQUOTE] = ACTIONS(7602),
    [anon_sym_LR_DQUOTE] = ACTIONS(7602),
    [anon_sym_uR_DQUOTE] = ACTIONS(7602),
    [anon_sym_UR_DQUOTE] = ACTIONS(7602),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7602),
    [sym_literal_suffix] = ACTIONS(7219),
  },
  [3269] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7152),
    [anon_sym_COMMA] = ACTIONS(7152),
    [anon_sym_RPAREN] = ACTIONS(7152),
    [anon_sym_LPAREN2] = ACTIONS(7152),
    [anon_sym_DASH] = ACTIONS(7150),
    [anon_sym_PLUS] = ACTIONS(7150),
    [anon_sym_STAR] = ACTIONS(7150),
    [anon_sym_SLASH] = ACTIONS(7150),
    [anon_sym_PERCENT] = ACTIONS(7150),
    [anon_sym_PIPE_PIPE] = ACTIONS(7152),
    [anon_sym_AMP_AMP] = ACTIONS(7152),
    [anon_sym_PIPE] = ACTIONS(7150),
    [anon_sym_CARET] = ACTIONS(7150),
    [anon_sym_AMP] = ACTIONS(7150),
    [anon_sym_EQ_EQ] = ACTIONS(7152),
    [anon_sym_BANG_EQ] = ACTIONS(7152),
    [anon_sym_GT] = ACTIONS(7150),
    [anon_sym_GT_EQ] = ACTIONS(7152),
    [anon_sym_LT_EQ] = ACTIONS(7150),
    [anon_sym_LT] = ACTIONS(7150),
    [anon_sym_LT_LT] = ACTIONS(7150),
    [anon_sym_GT_GT] = ACTIONS(7150),
    [anon_sym_COLON] = ACTIONS(7152),
    [anon_sym_SEMI] = ACTIONS(7152),
    [anon_sym_RBRACE] = ACTIONS(7152),
    [anon_sym_LBRACK] = ACTIONS(7152),
    [anon_sym_RBRACK] = ACTIONS(7152),
    [anon_sym_EQ] = ACTIONS(7150),
    [anon_sym_QMARK] = ACTIONS(7152),
    [anon_sym_STAR_EQ] = ACTIONS(7152),
    [anon_sym_SLASH_EQ] = ACTIONS(7152),
    [anon_sym_PERCENT_EQ] = ACTIONS(7152),
    [anon_sym_PLUS_EQ] = ACTIONS(7152),
    [anon_sym_DASH_EQ] = ACTIONS(7152),
    [anon_sym_LT_LT_EQ] = ACTIONS(7152),
    [anon_sym_GT_GT_EQ] = ACTIONS(7152),
    [anon_sym_AMP_EQ] = ACTIONS(7152),
    [anon_sym_CARET_EQ] = ACTIONS(7152),
    [anon_sym_PIPE_EQ] = ACTIONS(7152),
    [anon_sym_and_eq] = ACTIONS(7150),
    [anon_sym_or_eq] = ACTIONS(7150),
    [anon_sym_xor_eq] = ACTIONS(7150),
    [anon_sym_LT_EQ_GT] = ACTIONS(7152),
    [anon_sym_or] = ACTIONS(7150),
    [anon_sym_and] = ACTIONS(7150),
    [anon_sym_bitor] = ACTIONS(7150),
    [anon_sym_xor] = ACTIONS(7150),
    [anon_sym_bitand] = ACTIONS(7150),
    [anon_sym_not_eq] = ACTIONS(7150),
    [anon_sym_is] = ACTIONS(7150),
    [anon_sym_as] = ACTIONS(7150),
    [anon_sym_DASH_DASH] = ACTIONS(7152),
    [anon_sym_PLUS_PLUS] = ACTIONS(7152),
    [anon_sym_DOT] = ACTIONS(7150),
    [anon_sym_DOT_STAR] = ACTIONS(7152),
    [anon_sym_DASH_GT] = ACTIONS(7152),
    [anon_sym_L_DQUOTE] = ACTIONS(7152),
    [anon_sym_u_DQUOTE] = ACTIONS(7152),
    [anon_sym_U_DQUOTE] = ACTIONS(7152),
    [anon_sym_u8_DQUOTE] = ACTIONS(7152),
    [anon_sym_DQUOTE] = ACTIONS(7152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7152),
    [anon_sym_LR_DQUOTE] = ACTIONS(7152),
    [anon_sym_uR_DQUOTE] = ACTIONS(7152),
    [anon_sym_UR_DQUOTE] = ACTIONS(7152),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7152),
    [sym_literal_suffix] = ACTIONS(7150),
  },
  [3270] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3289),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4180),
    [anon_sym_COMMA] = ACTIONS(4180),
    [anon_sym_RPAREN] = ACTIONS(4180),
    [anon_sym_LPAREN2] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4178),
    [anon_sym_PLUS] = ACTIONS(4178),
    [anon_sym_STAR] = ACTIONS(4178),
    [anon_sym_SLASH] = ACTIONS(4178),
    [anon_sym_PERCENT] = ACTIONS(4178),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_PIPE] = ACTIONS(4178),
    [anon_sym_CARET] = ACTIONS(4178),
    [anon_sym_AMP] = ACTIONS(4178),
    [anon_sym_EQ_EQ] = ACTIONS(4180),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4178),
    [anon_sym_GT_EQ] = ACTIONS(4180),
    [anon_sym_LT_EQ] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_LT_LT] = ACTIONS(4178),
    [anon_sym_GT_GT] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4180),
    [anon_sym_SEMI] = ACTIONS(4180),
    [anon_sym___attribute__] = ACTIONS(4180),
    [anon_sym___attribute] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_RBRACE] = ACTIONS(4180),
    [anon_sym_signed] = ACTIONS(7616),
    [anon_sym_unsigned] = ACTIONS(7616),
    [anon_sym_long] = ACTIONS(7616),
    [anon_sym_short] = ACTIONS(7616),
    [anon_sym_LBRACK] = ACTIONS(4180),
    [anon_sym_RBRACK] = ACTIONS(4180),
    [anon_sym_EQ] = ACTIONS(4178),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_STAR_EQ] = ACTIONS(4180),
    [anon_sym_SLASH_EQ] = ACTIONS(4180),
    [anon_sym_PERCENT_EQ] = ACTIONS(4180),
    [anon_sym_PLUS_EQ] = ACTIONS(4180),
    [anon_sym_DASH_EQ] = ACTIONS(4180),
    [anon_sym_LT_LT_EQ] = ACTIONS(4180),
    [anon_sym_GT_GT_EQ] = ACTIONS(4180),
    [anon_sym_AMP_EQ] = ACTIONS(4180),
    [anon_sym_CARET_EQ] = ACTIONS(4180),
    [anon_sym_PIPE_EQ] = ACTIONS(4180),
    [anon_sym_and_eq] = ACTIONS(4180),
    [anon_sym_or_eq] = ACTIONS(4180),
    [anon_sym_xor_eq] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4178),
    [anon_sym_and] = ACTIONS(4178),
    [anon_sym_bitor] = ACTIONS(4180),
    [anon_sym_xor] = ACTIONS(4178),
    [anon_sym_bitand] = ACTIONS(4180),
    [anon_sym_not_eq] = ACTIONS(4180),
    [anon_sym_is] = ACTIONS(4180),
    [anon_sym_as] = ACTIONS(4180),
    [anon_sym_DASH_DASH] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4178),
    [anon_sym_DOT_STAR] = ACTIONS(4180),
    [anon_sym_DASH_GT] = ACTIONS(4180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4180),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_This] = ACTIONS(4180),
  },
  [3271] = {
    [sym_identifier] = ACTIONS(7618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(7620),
    [anon_sym_RPAREN] = ACTIONS(7620),
    [aux_sym_preproc_if_token2] = ACTIONS(7620),
    [aux_sym_preproc_else_token1] = ACTIONS(7620),
    [aux_sym_preproc_elif_token1] = ACTIONS(7618),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7620),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7620),
    [anon_sym_LPAREN2] = ACTIONS(7620),
    [anon_sym_DASH] = ACTIONS(7618),
    [anon_sym_PLUS] = ACTIONS(7618),
    [anon_sym_STAR] = ACTIONS(7618),
    [anon_sym_SLASH] = ACTIONS(7618),
    [anon_sym_PERCENT] = ACTIONS(7618),
    [anon_sym_PIPE_PIPE] = ACTIONS(7620),
    [anon_sym_AMP_AMP] = ACTIONS(7620),
    [anon_sym_PIPE] = ACTIONS(7618),
    [anon_sym_CARET] = ACTIONS(7618),
    [anon_sym_AMP] = ACTIONS(7618),
    [anon_sym_EQ_EQ] = ACTIONS(7620),
    [anon_sym_BANG_EQ] = ACTIONS(7620),
    [anon_sym_GT] = ACTIONS(7618),
    [anon_sym_GT_EQ] = ACTIONS(7620),
    [anon_sym_LT_EQ] = ACTIONS(7618),
    [anon_sym_LT] = ACTIONS(7618),
    [anon_sym_LT_LT] = ACTIONS(7618),
    [anon_sym_GT_GT] = ACTIONS(7618),
    [anon_sym_COLON] = ACTIONS(7620),
    [anon_sym_SEMI] = ACTIONS(7620),
    [anon_sym___attribute__] = ACTIONS(7618),
    [anon_sym___attribute] = ACTIONS(7618),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7620),
    [anon_sym_LBRACE] = ACTIONS(7620),
    [anon_sym_RBRACE] = ACTIONS(7620),
    [anon_sym_LBRACK] = ACTIONS(7618),
    [anon_sym_RBRACK] = ACTIONS(7620),
    [anon_sym_EQ] = ACTIONS(7618),
    [anon_sym_QMARK] = ACTIONS(7620),
    [anon_sym_STAR_EQ] = ACTIONS(7620),
    [anon_sym_SLASH_EQ] = ACTIONS(7620),
    [anon_sym_PERCENT_EQ] = ACTIONS(7620),
    [anon_sym_PLUS_EQ] = ACTIONS(7620),
    [anon_sym_DASH_EQ] = ACTIONS(7620),
    [anon_sym_LT_LT_EQ] = ACTIONS(7620),
    [anon_sym_GT_GT_EQ] = ACTIONS(7620),
    [anon_sym_AMP_EQ] = ACTIONS(7620),
    [anon_sym_CARET_EQ] = ACTIONS(7620),
    [anon_sym_PIPE_EQ] = ACTIONS(7620),
    [anon_sym_and_eq] = ACTIONS(7618),
    [anon_sym_or_eq] = ACTIONS(7618),
    [anon_sym_xor_eq] = ACTIONS(7618),
    [anon_sym_LT_EQ_GT] = ACTIONS(7620),
    [anon_sym_or] = ACTIONS(7618),
    [anon_sym_and] = ACTIONS(7618),
    [anon_sym_bitor] = ACTIONS(7618),
    [anon_sym_xor] = ACTIONS(7618),
    [anon_sym_bitand] = ACTIONS(7618),
    [anon_sym_not_eq] = ACTIONS(7618),
    [anon_sym_is] = ACTIONS(7618),
    [anon_sym_as] = ACTIONS(7618),
    [anon_sym_DASH_DASH] = ACTIONS(7620),
    [anon_sym_PLUS_PLUS] = ACTIONS(7620),
    [anon_sym_DOT] = ACTIONS(7618),
    [anon_sym_DOT_STAR] = ACTIONS(7620),
    [anon_sym_DASH_GT] = ACTIONS(7620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(7618),
  },
  [3272] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4187),
    [anon_sym_COMMA] = ACTIONS(4187),
    [anon_sym_RPAREN] = ACTIONS(4187),
    [anon_sym_LPAREN2] = ACTIONS(4187),
    [anon_sym_DASH] = ACTIONS(4185),
    [anon_sym_PLUS] = ACTIONS(4185),
    [anon_sym_STAR] = ACTIONS(4185),
    [anon_sym_SLASH] = ACTIONS(4185),
    [anon_sym_PERCENT] = ACTIONS(4185),
    [anon_sym_PIPE_PIPE] = ACTIONS(4187),
    [anon_sym_AMP_AMP] = ACTIONS(4187),
    [anon_sym_PIPE] = ACTIONS(4185),
    [anon_sym_CARET] = ACTIONS(4185),
    [anon_sym_AMP] = ACTIONS(4185),
    [anon_sym_EQ_EQ] = ACTIONS(4187),
    [anon_sym_BANG_EQ] = ACTIONS(4187),
    [anon_sym_GT] = ACTIONS(4185),
    [anon_sym_GT_EQ] = ACTIONS(4187),
    [anon_sym_LT_EQ] = ACTIONS(4185),
    [anon_sym_LT] = ACTIONS(4185),
    [anon_sym_LT_LT] = ACTIONS(4185),
    [anon_sym_GT_GT] = ACTIONS(4185),
    [anon_sym_COLON] = ACTIONS(4187),
    [anon_sym_SEMI] = ACTIONS(4187),
    [anon_sym___attribute__] = ACTIONS(4187),
    [anon_sym___attribute] = ACTIONS(4185),
    [anon_sym_LBRACE] = ACTIONS(4187),
    [anon_sym_RBRACE] = ACTIONS(4187),
    [anon_sym_signed] = ACTIONS(7604),
    [anon_sym_unsigned] = ACTIONS(7604),
    [anon_sym_long] = ACTIONS(7604),
    [anon_sym_short] = ACTIONS(7604),
    [anon_sym_LBRACK] = ACTIONS(4187),
    [anon_sym_RBRACK] = ACTIONS(4187),
    [anon_sym_EQ] = ACTIONS(4185),
    [anon_sym_QMARK] = ACTIONS(4187),
    [anon_sym_STAR_EQ] = ACTIONS(4187),
    [anon_sym_SLASH_EQ] = ACTIONS(4187),
    [anon_sym_PERCENT_EQ] = ACTIONS(4187),
    [anon_sym_PLUS_EQ] = ACTIONS(4187),
    [anon_sym_DASH_EQ] = ACTIONS(4187),
    [anon_sym_LT_LT_EQ] = ACTIONS(4187),
    [anon_sym_GT_GT_EQ] = ACTIONS(4187),
    [anon_sym_AMP_EQ] = ACTIONS(4187),
    [anon_sym_CARET_EQ] = ACTIONS(4187),
    [anon_sym_PIPE_EQ] = ACTIONS(4187),
    [anon_sym_and_eq] = ACTIONS(4187),
    [anon_sym_or_eq] = ACTIONS(4187),
    [anon_sym_xor_eq] = ACTIONS(4187),
    [anon_sym_LT_EQ_GT] = ACTIONS(4187),
    [anon_sym_or] = ACTIONS(4185),
    [anon_sym_and] = ACTIONS(4185),
    [anon_sym_bitor] = ACTIONS(4187),
    [anon_sym_xor] = ACTIONS(4185),
    [anon_sym_bitand] = ACTIONS(4187),
    [anon_sym_not_eq] = ACTIONS(4187),
    [anon_sym_is] = ACTIONS(4187),
    [anon_sym_as] = ACTIONS(4187),
    [anon_sym_DASH_DASH] = ACTIONS(4187),
    [anon_sym_PLUS_PLUS] = ACTIONS(4187),
    [anon_sym_DOT] = ACTIONS(4185),
    [anon_sym_DOT_STAR] = ACTIONS(4187),
    [anon_sym_DASH_GT] = ACTIONS(4187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4187),
    [anon_sym_let] = ACTIONS(4187),
    [anon_sym_This] = ACTIONS(4187),
  },
  [3273] = {
    [sym_identifier] = ACTIONS(7622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7624),
    [anon_sym_COMMA] = ACTIONS(7624),
    [anon_sym_RPAREN] = ACTIONS(7624),
    [aux_sym_preproc_if_token2] = ACTIONS(7624),
    [aux_sym_preproc_else_token1] = ACTIONS(7624),
    [aux_sym_preproc_elif_token1] = ACTIONS(7622),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7624),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7624),
    [anon_sym_LPAREN2] = ACTIONS(7624),
    [anon_sym_DASH] = ACTIONS(7622),
    [anon_sym_PLUS] = ACTIONS(7622),
    [anon_sym_STAR] = ACTIONS(7622),
    [anon_sym_SLASH] = ACTIONS(7622),
    [anon_sym_PERCENT] = ACTIONS(7622),
    [anon_sym_PIPE_PIPE] = ACTIONS(7624),
    [anon_sym_AMP_AMP] = ACTIONS(7624),
    [anon_sym_PIPE] = ACTIONS(7622),
    [anon_sym_CARET] = ACTIONS(7622),
    [anon_sym_AMP] = ACTIONS(7622),
    [anon_sym_EQ_EQ] = ACTIONS(7624),
    [anon_sym_BANG_EQ] = ACTIONS(7624),
    [anon_sym_GT] = ACTIONS(7622),
    [anon_sym_GT_EQ] = ACTIONS(7624),
    [anon_sym_LT_EQ] = ACTIONS(7622),
    [anon_sym_LT] = ACTIONS(7622),
    [anon_sym_LT_LT] = ACTIONS(7622),
    [anon_sym_GT_GT] = ACTIONS(7622),
    [anon_sym_COLON] = ACTIONS(7624),
    [anon_sym_SEMI] = ACTIONS(7624),
    [anon_sym___attribute__] = ACTIONS(7622),
    [anon_sym___attribute] = ACTIONS(7622),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7624),
    [anon_sym_LBRACE] = ACTIONS(7624),
    [anon_sym_RBRACE] = ACTIONS(7624),
    [anon_sym_LBRACK] = ACTIONS(7622),
    [anon_sym_RBRACK] = ACTIONS(7624),
    [anon_sym_EQ] = ACTIONS(7622),
    [anon_sym_QMARK] = ACTIONS(7624),
    [anon_sym_STAR_EQ] = ACTIONS(7624),
    [anon_sym_SLASH_EQ] = ACTIONS(7624),
    [anon_sym_PERCENT_EQ] = ACTIONS(7624),
    [anon_sym_PLUS_EQ] = ACTIONS(7624),
    [anon_sym_DASH_EQ] = ACTIONS(7624),
    [anon_sym_LT_LT_EQ] = ACTIONS(7624),
    [anon_sym_GT_GT_EQ] = ACTIONS(7624),
    [anon_sym_AMP_EQ] = ACTIONS(7624),
    [anon_sym_CARET_EQ] = ACTIONS(7624),
    [anon_sym_PIPE_EQ] = ACTIONS(7624),
    [anon_sym_and_eq] = ACTIONS(7622),
    [anon_sym_or_eq] = ACTIONS(7622),
    [anon_sym_xor_eq] = ACTIONS(7622),
    [anon_sym_LT_EQ_GT] = ACTIONS(7624),
    [anon_sym_or] = ACTIONS(7622),
    [anon_sym_and] = ACTIONS(7622),
    [anon_sym_bitor] = ACTIONS(7622),
    [anon_sym_xor] = ACTIONS(7622),
    [anon_sym_bitand] = ACTIONS(7622),
    [anon_sym_not_eq] = ACTIONS(7622),
    [anon_sym_is] = ACTIONS(7622),
    [anon_sym_as] = ACTIONS(7622),
    [anon_sym_DASH_DASH] = ACTIONS(7624),
    [anon_sym_PLUS_PLUS] = ACTIONS(7624),
    [anon_sym_DOT] = ACTIONS(7622),
    [anon_sym_DOT_STAR] = ACTIONS(7624),
    [anon_sym_DASH_GT] = ACTIONS(7624),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(7622),
  },
  [3274] = {
    [sym_identifier] = ACTIONS(7626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7628),
    [anon_sym_COMMA] = ACTIONS(7628),
    [anon_sym_RPAREN] = ACTIONS(7628),
    [aux_sym_preproc_if_token2] = ACTIONS(7628),
    [aux_sym_preproc_else_token1] = ACTIONS(7628),
    [aux_sym_preproc_elif_token1] = ACTIONS(7626),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7628),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7628),
    [anon_sym_LPAREN2] = ACTIONS(7628),
    [anon_sym_DASH] = ACTIONS(7626),
    [anon_sym_PLUS] = ACTIONS(7626),
    [anon_sym_STAR] = ACTIONS(7626),
    [anon_sym_SLASH] = ACTIONS(7626),
    [anon_sym_PERCENT] = ACTIONS(7626),
    [anon_sym_PIPE_PIPE] = ACTIONS(7628),
    [anon_sym_AMP_AMP] = ACTIONS(7628),
    [anon_sym_PIPE] = ACTIONS(7626),
    [anon_sym_CARET] = ACTIONS(7626),
    [anon_sym_AMP] = ACTIONS(7626),
    [anon_sym_EQ_EQ] = ACTIONS(7628),
    [anon_sym_BANG_EQ] = ACTIONS(7628),
    [anon_sym_GT] = ACTIONS(7626),
    [anon_sym_GT_EQ] = ACTIONS(7628),
    [anon_sym_LT_EQ] = ACTIONS(7626),
    [anon_sym_LT] = ACTIONS(7626),
    [anon_sym_LT_LT] = ACTIONS(7626),
    [anon_sym_GT_GT] = ACTIONS(7626),
    [anon_sym_COLON] = ACTIONS(7628),
    [anon_sym_SEMI] = ACTIONS(7628),
    [anon_sym___attribute__] = ACTIONS(7626),
    [anon_sym___attribute] = ACTIONS(7626),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7628),
    [anon_sym_LBRACE] = ACTIONS(7628),
    [anon_sym_RBRACE] = ACTIONS(7628),
    [anon_sym_LBRACK] = ACTIONS(7626),
    [anon_sym_RBRACK] = ACTIONS(7628),
    [anon_sym_EQ] = ACTIONS(7626),
    [anon_sym_QMARK] = ACTIONS(7628),
    [anon_sym_STAR_EQ] = ACTIONS(7628),
    [anon_sym_SLASH_EQ] = ACTIONS(7628),
    [anon_sym_PERCENT_EQ] = ACTIONS(7628),
    [anon_sym_PLUS_EQ] = ACTIONS(7628),
    [anon_sym_DASH_EQ] = ACTIONS(7628),
    [anon_sym_LT_LT_EQ] = ACTIONS(7628),
    [anon_sym_GT_GT_EQ] = ACTIONS(7628),
    [anon_sym_AMP_EQ] = ACTIONS(7628),
    [anon_sym_CARET_EQ] = ACTIONS(7628),
    [anon_sym_PIPE_EQ] = ACTIONS(7628),
    [anon_sym_and_eq] = ACTIONS(7626),
    [anon_sym_or_eq] = ACTIONS(7626),
    [anon_sym_xor_eq] = ACTIONS(7626),
    [anon_sym_LT_EQ_GT] = ACTIONS(7628),
    [anon_sym_or] = ACTIONS(7626),
    [anon_sym_and] = ACTIONS(7626),
    [anon_sym_bitor] = ACTIONS(7626),
    [anon_sym_xor] = ACTIONS(7626),
    [anon_sym_bitand] = ACTIONS(7626),
    [anon_sym_not_eq] = ACTIONS(7626),
    [anon_sym_is] = ACTIONS(7626),
    [anon_sym_as] = ACTIONS(7626),
    [anon_sym_DASH_DASH] = ACTIONS(7628),
    [anon_sym_PLUS_PLUS] = ACTIONS(7628),
    [anon_sym_DOT] = ACTIONS(7626),
    [anon_sym_DOT_STAR] = ACTIONS(7628),
    [anon_sym_DASH_GT] = ACTIONS(7628),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(7626),
  },
  [3275] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3314),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2972),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_RPAREN] = ACTIONS(2972),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_STAR] = ACTIONS(2974),
    [anon_sym_SLASH] = ACTIONS(2974),
    [anon_sym_PERCENT] = ACTIONS(2974),
    [anon_sym_PIPE_PIPE] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_PIPE] = ACTIONS(2974),
    [anon_sym_CARET] = ACTIONS(2974),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_EQ_EQ] = ACTIONS(2972),
    [anon_sym_BANG_EQ] = ACTIONS(2972),
    [anon_sym_GT] = ACTIONS(2974),
    [anon_sym_GT_EQ] = ACTIONS(2972),
    [anon_sym_LT_EQ] = ACTIONS(2974),
    [anon_sym_LT] = ACTIONS(2974),
    [anon_sym_LT_LT] = ACTIONS(2974),
    [anon_sym_GT_GT] = ACTIONS(2974),
    [anon_sym_COLON] = ACTIONS(2972),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym___attribute__] = ACTIONS(2972),
    [anon_sym___attribute] = ACTIONS(2974),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_signed] = ACTIONS(7630),
    [anon_sym_unsigned] = ACTIONS(7630),
    [anon_sym_long] = ACTIONS(7630),
    [anon_sym_short] = ACTIONS(7630),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_RBRACK] = ACTIONS(2972),
    [anon_sym_EQ] = ACTIONS(2974),
    [anon_sym_QMARK] = ACTIONS(2972),
    [anon_sym_STAR_EQ] = ACTIONS(2972),
    [anon_sym_SLASH_EQ] = ACTIONS(2972),
    [anon_sym_PERCENT_EQ] = ACTIONS(2972),
    [anon_sym_PLUS_EQ] = ACTIONS(2972),
    [anon_sym_DASH_EQ] = ACTIONS(2972),
    [anon_sym_LT_LT_EQ] = ACTIONS(2972),
    [anon_sym_GT_GT_EQ] = ACTIONS(2972),
    [anon_sym_AMP_EQ] = ACTIONS(2972),
    [anon_sym_CARET_EQ] = ACTIONS(2972),
    [anon_sym_PIPE_EQ] = ACTIONS(2972),
    [anon_sym_and_eq] = ACTIONS(2972),
    [anon_sym_or_eq] = ACTIONS(2972),
    [anon_sym_xor_eq] = ACTIONS(2972),
    [anon_sym_LT_EQ_GT] = ACTIONS(2972),
    [anon_sym_or] = ACTIONS(2974),
    [anon_sym_and] = ACTIONS(2974),
    [anon_sym_bitor] = ACTIONS(2972),
    [anon_sym_xor] = ACTIONS(2974),
    [anon_sym_bitand] = ACTIONS(2972),
    [anon_sym_not_eq] = ACTIONS(2972),
    [anon_sym_is] = ACTIONS(2972),
    [anon_sym_as] = ACTIONS(2972),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_DOT] = ACTIONS(2974),
    [anon_sym_DOT_STAR] = ACTIONS(2972),
    [anon_sym_DASH_GT] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2972),
    [anon_sym_let] = ACTIONS(2972),
    [anon_sym_This] = ACTIONS(2972),
  },
  [3276] = {
    [sym_string_literal] = STATE(3276),
    [sym_raw_string_literal] = STATE(3276),
    [aux_sym_concatenated_string_repeat1] = STATE(3276),
    [sym_identifier] = ACTIONS(7632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7205),
    [anon_sym_COMMA] = ACTIONS(7205),
    [anon_sym_LPAREN2] = ACTIONS(7205),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_SLASH] = ACTIONS(7207),
    [anon_sym_PERCENT] = ACTIONS(7207),
    [anon_sym_PIPE_PIPE] = ACTIONS(7205),
    [anon_sym_AMP_AMP] = ACTIONS(7205),
    [anon_sym_PIPE] = ACTIONS(7207),
    [anon_sym_CARET] = ACTIONS(7207),
    [anon_sym_AMP] = ACTIONS(7207),
    [anon_sym_EQ_EQ] = ACTIONS(7205),
    [anon_sym_BANG_EQ] = ACTIONS(7205),
    [anon_sym_GT] = ACTIONS(7207),
    [anon_sym_GT_EQ] = ACTIONS(7207),
    [anon_sym_LT_EQ] = ACTIONS(7207),
    [anon_sym_LT] = ACTIONS(7207),
    [anon_sym_LT_LT] = ACTIONS(7207),
    [anon_sym_GT_GT] = ACTIONS(7207),
    [anon_sym_LBRACK] = ACTIONS(7205),
    [anon_sym_EQ] = ACTIONS(7207),
    [anon_sym_QMARK] = ACTIONS(7205),
    [anon_sym_STAR_EQ] = ACTIONS(7205),
    [anon_sym_SLASH_EQ] = ACTIONS(7205),
    [anon_sym_PERCENT_EQ] = ACTIONS(7205),
    [anon_sym_PLUS_EQ] = ACTIONS(7205),
    [anon_sym_DASH_EQ] = ACTIONS(7205),
    [anon_sym_LT_LT_EQ] = ACTIONS(7205),
    [anon_sym_GT_GT_EQ] = ACTIONS(7207),
    [anon_sym_AMP_EQ] = ACTIONS(7205),
    [anon_sym_CARET_EQ] = ACTIONS(7205),
    [anon_sym_PIPE_EQ] = ACTIONS(7205),
    [anon_sym_and_eq] = ACTIONS(7207),
    [anon_sym_or_eq] = ACTIONS(7207),
    [anon_sym_xor_eq] = ACTIONS(7207),
    [anon_sym_LT_EQ_GT] = ACTIONS(7205),
    [anon_sym_or] = ACTIONS(7207),
    [anon_sym_and] = ACTIONS(7207),
    [anon_sym_bitor] = ACTIONS(7207),
    [anon_sym_xor] = ACTIONS(7207),
    [anon_sym_bitand] = ACTIONS(7207),
    [anon_sym_not_eq] = ACTIONS(7207),
    [anon_sym_is] = ACTIONS(7207),
    [anon_sym_as] = ACTIONS(7207),
    [anon_sym_DASH_DASH] = ACTIONS(7205),
    [anon_sym_PLUS_PLUS] = ACTIONS(7205),
    [anon_sym_DOT] = ACTIONS(7207),
    [anon_sym_DOT_STAR] = ACTIONS(7205),
    [anon_sym_DASH_GT] = ACTIONS(7205),
    [anon_sym_L_DQUOTE] = ACTIONS(7635),
    [anon_sym_u_DQUOTE] = ACTIONS(7635),
    [anon_sym_U_DQUOTE] = ACTIONS(7635),
    [anon_sym_u8_DQUOTE] = ACTIONS(7635),
    [anon_sym_DQUOTE] = ACTIONS(7635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(7205),
    [anon_sym_R_DQUOTE] = ACTIONS(7638),
    [anon_sym_LR_DQUOTE] = ACTIONS(7638),
    [anon_sym_uR_DQUOTE] = ACTIONS(7638),
    [anon_sym_UR_DQUOTE] = ACTIONS(7638),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7638),
    [sym_literal_suffix] = ACTIONS(7207),
  },
  [3277] = {
    [sym_identifier] = ACTIONS(7641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7643),
    [anon_sym_COMMA] = ACTIONS(7643),
    [anon_sym_RPAREN] = ACTIONS(7643),
    [aux_sym_preproc_if_token2] = ACTIONS(7643),
    [aux_sym_preproc_else_token1] = ACTIONS(7643),
    [aux_sym_preproc_elif_token1] = ACTIONS(7641),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7643),
    [anon_sym_LPAREN2] = ACTIONS(7643),
    [anon_sym_DASH] = ACTIONS(7641),
    [anon_sym_PLUS] = ACTIONS(7641),
    [anon_sym_STAR] = ACTIONS(7641),
    [anon_sym_SLASH] = ACTIONS(7641),
    [anon_sym_PERCENT] = ACTIONS(7641),
    [anon_sym_PIPE_PIPE] = ACTIONS(7643),
    [anon_sym_AMP_AMP] = ACTIONS(7643),
    [anon_sym_PIPE] = ACTIONS(7641),
    [anon_sym_CARET] = ACTIONS(7641),
    [anon_sym_AMP] = ACTIONS(7641),
    [anon_sym_EQ_EQ] = ACTIONS(7643),
    [anon_sym_BANG_EQ] = ACTIONS(7643),
    [anon_sym_GT] = ACTIONS(7641),
    [anon_sym_GT_EQ] = ACTIONS(7643),
    [anon_sym_LT_EQ] = ACTIONS(7641),
    [anon_sym_LT] = ACTIONS(7641),
    [anon_sym_LT_LT] = ACTIONS(7641),
    [anon_sym_GT_GT] = ACTIONS(7641),
    [anon_sym_COLON] = ACTIONS(7643),
    [anon_sym_SEMI] = ACTIONS(7643),
    [anon_sym___attribute__] = ACTIONS(7641),
    [anon_sym___attribute] = ACTIONS(7641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7643),
    [anon_sym_LBRACE] = ACTIONS(7643),
    [anon_sym_RBRACE] = ACTIONS(7643),
    [anon_sym_LBRACK] = ACTIONS(7641),
    [anon_sym_RBRACK] = ACTIONS(7643),
    [anon_sym_EQ] = ACTIONS(7641),
    [anon_sym_QMARK] = ACTIONS(7643),
    [anon_sym_STAR_EQ] = ACTIONS(7643),
    [anon_sym_SLASH_EQ] = ACTIONS(7643),
    [anon_sym_PERCENT_EQ] = ACTIONS(7643),
    [anon_sym_PLUS_EQ] = ACTIONS(7643),
    [anon_sym_DASH_EQ] = ACTIONS(7643),
    [anon_sym_LT_LT_EQ] = ACTIONS(7643),
    [anon_sym_GT_GT_EQ] = ACTIONS(7643),
    [anon_sym_AMP_EQ] = ACTIONS(7643),
    [anon_sym_CARET_EQ] = ACTIONS(7643),
    [anon_sym_PIPE_EQ] = ACTIONS(7643),
    [anon_sym_and_eq] = ACTIONS(7641),
    [anon_sym_or_eq] = ACTIONS(7641),
    [anon_sym_xor_eq] = ACTIONS(7641),
    [anon_sym_LT_EQ_GT] = ACTIONS(7643),
    [anon_sym_or] = ACTIONS(7641),
    [anon_sym_and] = ACTIONS(7641),
    [anon_sym_bitor] = ACTIONS(7641),
    [anon_sym_xor] = ACTIONS(7641),
    [anon_sym_bitand] = ACTIONS(7641),
    [anon_sym_not_eq] = ACTIONS(7641),
    [anon_sym_is] = ACTIONS(7641),
    [anon_sym_as] = ACTIONS(7641),
    [anon_sym_DASH_DASH] = ACTIONS(7643),
    [anon_sym_PLUS_PLUS] = ACTIONS(7643),
    [anon_sym_DOT] = ACTIONS(7641),
    [anon_sym_DOT_STAR] = ACTIONS(7643),
    [anon_sym_DASH_GT] = ACTIONS(7643),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(7641),
  },
  [3278] = {
    [sym_template_argument_list] = STATE(3325),
    [sym_identifier] = ACTIONS(2234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2224),
    [anon_sym_COMMA] = ACTIONS(2224),
    [anon_sym_RPAREN] = ACTIONS(2224),
    [aux_sym_preproc_if_token2] = ACTIONS(2224),
    [aux_sym_preproc_else_token1] = ACTIONS(2224),
    [aux_sym_preproc_elif_token1] = ACTIONS(2234),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2224),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2224),
    [anon_sym_LPAREN2] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_PIPE_PIPE] = ACTIONS(2224),
    [anon_sym_AMP_AMP] = ACTIONS(2224),
    [anon_sym_PIPE] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2234),
    [anon_sym_EQ_EQ] = ACTIONS(2224),
    [anon_sym_BANG_EQ] = ACTIONS(2224),
    [anon_sym_GT] = ACTIONS(2234),
    [anon_sym_GT_EQ] = ACTIONS(2224),
    [anon_sym_LT_EQ] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(7334),
    [anon_sym_LT_LT] = ACTIONS(2234),
    [anon_sym_GT_GT] = ACTIONS(2234),
    [anon_sym_COLON] = ACTIONS(2234),
    [anon_sym_SEMI] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2234),
    [anon_sym___attribute] = ACTIONS(2234),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_RBRACE] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_RBRACK] = ACTIONS(2224),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_QMARK] = ACTIONS(2224),
    [anon_sym_STAR_EQ] = ACTIONS(2224),
    [anon_sym_SLASH_EQ] = ACTIONS(2224),
    [anon_sym_PERCENT_EQ] = ACTIONS(2224),
    [anon_sym_PLUS_EQ] = ACTIONS(2224),
    [anon_sym_DASH_EQ] = ACTIONS(2224),
    [anon_sym_LT_LT_EQ] = ACTIONS(2224),
    [anon_sym_GT_GT_EQ] = ACTIONS(2224),
    [anon_sym_AMP_EQ] = ACTIONS(2224),
    [anon_sym_CARET_EQ] = ACTIONS(2224),
    [anon_sym_PIPE_EQ] = ACTIONS(2224),
    [anon_sym_and_eq] = ACTIONS(2234),
    [anon_sym_or_eq] = ACTIONS(2234),
    [anon_sym_xor_eq] = ACTIONS(2234),
    [anon_sym_LT_EQ_GT] = ACTIONS(2224),
    [anon_sym_or] = ACTIONS(2234),
    [anon_sym_and] = ACTIONS(2234),
    [anon_sym_bitor] = ACTIONS(2234),
    [anon_sym_xor] = ACTIONS(2234),
    [anon_sym_bitand] = ACTIONS(2234),
    [anon_sym_not_eq] = ACTIONS(2234),
    [anon_sym_is] = ACTIONS(2234),
    [anon_sym_as] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2224),
    [anon_sym_PLUS_PLUS] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(2234),
    [anon_sym_DOT_STAR] = ACTIONS(2224),
    [anon_sym_DASH_GT] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
  },
  [3279] = {
    [sym_string_literal] = STATE(3261),
    [sym_template_argument_list] = STATE(4334),
    [sym_raw_string_literal] = STATE(3261),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2181),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(7645),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_EQ] = ACTIONS(2181),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2170),
    [anon_sym_SLASH_EQ] = ACTIONS(2170),
    [anon_sym_PERCENT_EQ] = ACTIONS(2170),
    [anon_sym_PLUS_EQ] = ACTIONS(2170),
    [anon_sym_DASH_EQ] = ACTIONS(2170),
    [anon_sym_LT_LT_EQ] = ACTIONS(2170),
    [anon_sym_GT_GT_EQ] = ACTIONS(2181),
    [anon_sym_AMP_EQ] = ACTIONS(2170),
    [anon_sym_CARET_EQ] = ACTIONS(2170),
    [anon_sym_PIPE_EQ] = ACTIONS(2170),
    [anon_sym_and_eq] = ACTIONS(2170),
    [anon_sym_or_eq] = ACTIONS(2170),
    [anon_sym_xor_eq] = ACTIONS(2170),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(7600),
    [anon_sym_u_DQUOTE] = ACTIONS(7600),
    [anon_sym_U_DQUOTE] = ACTIONS(7600),
    [anon_sym_u8_DQUOTE] = ACTIONS(7600),
    [anon_sym_DQUOTE] = ACTIONS(7600),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(2170),
    [anon_sym_R_DQUOTE] = ACTIONS(7602),
    [anon_sym_LR_DQUOTE] = ACTIONS(7602),
    [anon_sym_uR_DQUOTE] = ACTIONS(7602),
    [anon_sym_UR_DQUOTE] = ACTIONS(7602),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7602),
  },
  [3280] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7290),
    [anon_sym_COMMA] = ACTIONS(7290),
    [anon_sym_RPAREN] = ACTIONS(7290),
    [anon_sym_LPAREN2] = ACTIONS(7290),
    [anon_sym_DASH] = ACTIONS(7288),
    [anon_sym_PLUS] = ACTIONS(7288),
    [anon_sym_STAR] = ACTIONS(7288),
    [anon_sym_SLASH] = ACTIONS(7288),
    [anon_sym_PERCENT] = ACTIONS(7288),
    [anon_sym_PIPE_PIPE] = ACTIONS(7290),
    [anon_sym_AMP_AMP] = ACTIONS(7290),
    [anon_sym_PIPE] = ACTIONS(7288),
    [anon_sym_CARET] = ACTIONS(7288),
    [anon_sym_AMP] = ACTIONS(7288),
    [anon_sym_EQ_EQ] = ACTIONS(7290),
    [anon_sym_BANG_EQ] = ACTIONS(7290),
    [anon_sym_GT] = ACTIONS(7288),
    [anon_sym_GT_EQ] = ACTIONS(7290),
    [anon_sym_LT_EQ] = ACTIONS(7288),
    [anon_sym_LT] = ACTIONS(7288),
    [anon_sym_LT_LT] = ACTIONS(7288),
    [anon_sym_GT_GT] = ACTIONS(7288),
    [anon_sym_COLON] = ACTIONS(7290),
    [anon_sym_SEMI] = ACTIONS(7290),
    [anon_sym_RBRACE] = ACTIONS(7290),
    [anon_sym_LBRACK] = ACTIONS(7290),
    [anon_sym_RBRACK] = ACTIONS(7290),
    [anon_sym_EQ] = ACTIONS(7288),
    [anon_sym_QMARK] = ACTIONS(7290),
    [anon_sym_STAR_EQ] = ACTIONS(7290),
    [anon_sym_SLASH_EQ] = ACTIONS(7290),
    [anon_sym_PERCENT_EQ] = ACTIONS(7290),
    [anon_sym_PLUS_EQ] = ACTIONS(7290),
    [anon_sym_DASH_EQ] = ACTIONS(7290),
    [anon_sym_LT_LT_EQ] = ACTIONS(7290),
    [anon_sym_GT_GT_EQ] = ACTIONS(7290),
    [anon_sym_AMP_EQ] = ACTIONS(7290),
    [anon_sym_CARET_EQ] = ACTIONS(7290),
    [anon_sym_PIPE_EQ] = ACTIONS(7290),
    [anon_sym_and_eq] = ACTIONS(7288),
    [anon_sym_or_eq] = ACTIONS(7288),
    [anon_sym_xor_eq] = ACTIONS(7288),
    [anon_sym_LT_EQ_GT] = ACTIONS(7290),
    [anon_sym_or] = ACTIONS(7288),
    [anon_sym_and] = ACTIONS(7288),
    [anon_sym_bitor] = ACTIONS(7288),
    [anon_sym_xor] = ACTIONS(7288),
    [anon_sym_bitand] = ACTIONS(7288),
    [anon_sym_not_eq] = ACTIONS(7288),
    [anon_sym_is] = ACTIONS(7288),
    [anon_sym_as] = ACTIONS(7288),
    [anon_sym_DASH_DASH] = ACTIONS(7290),
    [anon_sym_PLUS_PLUS] = ACTIONS(7290),
    [anon_sym_DOT] = ACTIONS(7288),
    [anon_sym_DOT_STAR] = ACTIONS(7290),
    [anon_sym_DASH_GT] = ACTIONS(7290),
    [anon_sym_L_DQUOTE] = ACTIONS(7290),
    [anon_sym_u_DQUOTE] = ACTIONS(7290),
    [anon_sym_U_DQUOTE] = ACTIONS(7290),
    [anon_sym_u8_DQUOTE] = ACTIONS(7290),
    [anon_sym_DQUOTE] = ACTIONS(7290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7290),
    [anon_sym_LR_DQUOTE] = ACTIONS(7290),
    [anon_sym_uR_DQUOTE] = ACTIONS(7290),
    [anon_sym_UR_DQUOTE] = ACTIONS(7290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7290),
    [sym_literal_suffix] = ACTIONS(7288),
  },
  [3281] = {
    [sym_string_literal] = STATE(4607),
    [sym_template_argument_list] = STATE(5635),
    [sym_raw_string_literal] = STATE(4607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2181),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6793),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_EQ] = ACTIONS(6800),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(6798),
    [anon_sym_SLASH_EQ] = ACTIONS(6798),
    [anon_sym_PERCENT_EQ] = ACTIONS(6798),
    [anon_sym_PLUS_EQ] = ACTIONS(6798),
    [anon_sym_DASH_EQ] = ACTIONS(6798),
    [anon_sym_LT_LT_EQ] = ACTIONS(6798),
    [anon_sym_GT_GT_EQ] = ACTIONS(6800),
    [anon_sym_AMP_EQ] = ACTIONS(6798),
    [anon_sym_CARET_EQ] = ACTIONS(6798),
    [anon_sym_PIPE_EQ] = ACTIONS(6798),
    [anon_sym_and_eq] = ACTIONS(6798),
    [anon_sym_or_eq] = ACTIONS(6798),
    [anon_sym_xor_eq] = ACTIONS(6798),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(6802),
    [anon_sym_u_DQUOTE] = ACTIONS(6802),
    [anon_sym_U_DQUOTE] = ACTIONS(6802),
    [anon_sym_u8_DQUOTE] = ACTIONS(6802),
    [anon_sym_DQUOTE] = ACTIONS(6802),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(2170),
    [anon_sym_R_DQUOTE] = ACTIONS(6804),
    [anon_sym_LR_DQUOTE] = ACTIONS(6804),
    [anon_sym_uR_DQUOTE] = ACTIONS(6804),
    [anon_sym_UR_DQUOTE] = ACTIONS(6804),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6804),
  },
  [3282] = {
    [sym_attribute_declaration] = STATE(3282),
    [aux_sym_attributed_declarator_repeat1] = STATE(3282),
    [sym_identifier] = ACTIONS(4482),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7648),
    [anon_sym_COMMA] = ACTIONS(7648),
    [anon_sym_RPAREN] = ACTIONS(7648),
    [aux_sym_preproc_if_token2] = ACTIONS(7648),
    [aux_sym_preproc_else_token1] = ACTIONS(7648),
    [aux_sym_preproc_elif_token1] = ACTIONS(4482),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7648),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7648),
    [anon_sym_LPAREN2] = ACTIONS(7648),
    [anon_sym_DASH] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4482),
    [anon_sym_STAR] = ACTIONS(4482),
    [anon_sym_SLASH] = ACTIONS(4482),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_PIPE_PIPE] = ACTIONS(7648),
    [anon_sym_AMP_AMP] = ACTIONS(7648),
    [anon_sym_PIPE] = ACTIONS(4482),
    [anon_sym_CARET] = ACTIONS(4482),
    [anon_sym_AMP] = ACTIONS(4482),
    [anon_sym_EQ_EQ] = ACTIONS(7648),
    [anon_sym_BANG_EQ] = ACTIONS(7648),
    [anon_sym_GT] = ACTIONS(4482),
    [anon_sym_GT_EQ] = ACTIONS(7648),
    [anon_sym_LT_EQ] = ACTIONS(4482),
    [anon_sym_LT] = ACTIONS(4482),
    [anon_sym_LT_LT] = ACTIONS(4482),
    [anon_sym_GT_GT] = ACTIONS(4482),
    [anon_sym_COLON] = ACTIONS(7648),
    [anon_sym_SEMI] = ACTIONS(7648),
    [anon_sym___attribute__] = ACTIONS(4482),
    [anon_sym___attribute] = ACTIONS(4482),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7650),
    [anon_sym_RBRACE] = ACTIONS(7648),
    [anon_sym_LBRACK] = ACTIONS(4482),
    [anon_sym_RBRACK] = ACTIONS(7648),
    [anon_sym_EQ] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(7648),
    [anon_sym_STAR_EQ] = ACTIONS(7648),
    [anon_sym_SLASH_EQ] = ACTIONS(7648),
    [anon_sym_PERCENT_EQ] = ACTIONS(7648),
    [anon_sym_PLUS_EQ] = ACTIONS(7648),
    [anon_sym_DASH_EQ] = ACTIONS(7648),
    [anon_sym_LT_LT_EQ] = ACTIONS(7648),
    [anon_sym_GT_GT_EQ] = ACTIONS(7648),
    [anon_sym_AMP_EQ] = ACTIONS(7648),
    [anon_sym_CARET_EQ] = ACTIONS(7648),
    [anon_sym_PIPE_EQ] = ACTIONS(7648),
    [anon_sym_and_eq] = ACTIONS(4482),
    [anon_sym_or_eq] = ACTIONS(4482),
    [anon_sym_xor_eq] = ACTIONS(4482),
    [anon_sym_LT_EQ_GT] = ACTIONS(7648),
    [anon_sym_or] = ACTIONS(4482),
    [anon_sym_and] = ACTIONS(4482),
    [anon_sym_bitor] = ACTIONS(4482),
    [anon_sym_xor] = ACTIONS(4482),
    [anon_sym_bitand] = ACTIONS(4482),
    [anon_sym_not_eq] = ACTIONS(4482),
    [anon_sym_is] = ACTIONS(4482),
    [anon_sym_as] = ACTIONS(4482),
    [anon_sym_DASH_DASH] = ACTIONS(7648),
    [anon_sym_PLUS_PLUS] = ACTIONS(7648),
    [anon_sym_DOT] = ACTIONS(4482),
    [anon_sym_DOT_STAR] = ACTIONS(7648),
    [anon_sym_DASH_GT] = ACTIONS(7648),
    [sym_comment] = ACTIONS(3),
  },
  [3283] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(4695),
    [sym_raw_string_literal] = STATE(3527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7542),
    [anon_sym_COMMA] = ACTIONS(7653),
    [anon_sym_LPAREN2] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6839),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_RBRACK] = ACTIONS(7655),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(7532),
    [anon_sym_SLASH_EQ] = ACTIONS(7532),
    [anon_sym_PERCENT_EQ] = ACTIONS(7532),
    [anon_sym_PLUS_EQ] = ACTIONS(7532),
    [anon_sym_DASH_EQ] = ACTIONS(7532),
    [anon_sym_LT_LT_EQ] = ACTIONS(7532),
    [anon_sym_GT_GT_EQ] = ACTIONS(7532),
    [anon_sym_AMP_EQ] = ACTIONS(7532),
    [anon_sym_CARET_EQ] = ACTIONS(7532),
    [anon_sym_PIPE_EQ] = ACTIONS(7532),
    [anon_sym_and_eq] = ACTIONS(7532),
    [anon_sym_or_eq] = ACTIONS(7532),
    [anon_sym_xor_eq] = ACTIONS(7532),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
  },
  [3284] = {
    [sym_argument_list] = STATE(3423),
    [sym_initializer_list] = STATE(3423),
    [sym_identifier] = ACTIONS(7658),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7660),
    [anon_sym_COMMA] = ACTIONS(7660),
    [anon_sym_RPAREN] = ACTIONS(7660),
    [aux_sym_preproc_if_token2] = ACTIONS(7660),
    [aux_sym_preproc_else_token1] = ACTIONS(7660),
    [aux_sym_preproc_elif_token1] = ACTIONS(7658),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7660),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7660),
    [anon_sym_LPAREN2] = ACTIONS(7358),
    [anon_sym_DASH] = ACTIONS(7658),
    [anon_sym_PLUS] = ACTIONS(7658),
    [anon_sym_STAR] = ACTIONS(7658),
    [anon_sym_SLASH] = ACTIONS(7658),
    [anon_sym_PERCENT] = ACTIONS(7658),
    [anon_sym_PIPE_PIPE] = ACTIONS(7660),
    [anon_sym_AMP_AMP] = ACTIONS(7660),
    [anon_sym_PIPE] = ACTIONS(7658),
    [anon_sym_CARET] = ACTIONS(7658),
    [anon_sym_AMP] = ACTIONS(7658),
    [anon_sym_EQ_EQ] = ACTIONS(7660),
    [anon_sym_BANG_EQ] = ACTIONS(7660),
    [anon_sym_GT] = ACTIONS(7658),
    [anon_sym_GT_EQ] = ACTIONS(7660),
    [anon_sym_LT_EQ] = ACTIONS(7658),
    [anon_sym_LT] = ACTIONS(7658),
    [anon_sym_LT_LT] = ACTIONS(7658),
    [anon_sym_GT_GT] = ACTIONS(7658),
    [anon_sym_COLON] = ACTIONS(7660),
    [anon_sym_SEMI] = ACTIONS(7660),
    [anon_sym___attribute__] = ACTIONS(7658),
    [anon_sym___attribute] = ACTIONS(7658),
    [anon_sym_LBRACE] = ACTIONS(4964),
    [anon_sym_RBRACE] = ACTIONS(7660),
    [anon_sym_LBRACK] = ACTIONS(7660),
    [anon_sym_RBRACK] = ACTIONS(7660),
    [anon_sym_EQ] = ACTIONS(7658),
    [anon_sym_QMARK] = ACTIONS(7660),
    [anon_sym_STAR_EQ] = ACTIONS(7660),
    [anon_sym_SLASH_EQ] = ACTIONS(7660),
    [anon_sym_PERCENT_EQ] = ACTIONS(7660),
    [anon_sym_PLUS_EQ] = ACTIONS(7660),
    [anon_sym_DASH_EQ] = ACTIONS(7660),
    [anon_sym_LT_LT_EQ] = ACTIONS(7660),
    [anon_sym_GT_GT_EQ] = ACTIONS(7660),
    [anon_sym_AMP_EQ] = ACTIONS(7660),
    [anon_sym_CARET_EQ] = ACTIONS(7660),
    [anon_sym_PIPE_EQ] = ACTIONS(7660),
    [anon_sym_and_eq] = ACTIONS(7658),
    [anon_sym_or_eq] = ACTIONS(7658),
    [anon_sym_xor_eq] = ACTIONS(7658),
    [anon_sym_LT_EQ_GT] = ACTIONS(7660),
    [anon_sym_or] = ACTIONS(7658),
    [anon_sym_and] = ACTIONS(7658),
    [anon_sym_bitor] = ACTIONS(7658),
    [anon_sym_xor] = ACTIONS(7658),
    [anon_sym_bitand] = ACTIONS(7658),
    [anon_sym_not_eq] = ACTIONS(7658),
    [anon_sym_is] = ACTIONS(7658),
    [anon_sym_as] = ACTIONS(7658),
    [anon_sym_DASH_DASH] = ACTIONS(7660),
    [anon_sym_PLUS_PLUS] = ACTIONS(7660),
    [anon_sym_DOT] = ACTIONS(7658),
    [anon_sym_DOT_STAR] = ACTIONS(7660),
    [anon_sym_DASH_GT] = ACTIONS(7660),
    [sym_comment] = ACTIONS(3),
  },
  [3285] = {
    [sym_identifier] = ACTIONS(7662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7664),
    [anon_sym_COMMA] = ACTIONS(7664),
    [anon_sym_RPAREN] = ACTIONS(7664),
    [aux_sym_preproc_if_token2] = ACTIONS(7664),
    [aux_sym_preproc_else_token1] = ACTIONS(7664),
    [aux_sym_preproc_elif_token1] = ACTIONS(7662),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7664),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7664),
    [anon_sym_LPAREN2] = ACTIONS(7664),
    [anon_sym_DASH] = ACTIONS(7662),
    [anon_sym_PLUS] = ACTIONS(7662),
    [anon_sym_STAR] = ACTIONS(7662),
    [anon_sym_SLASH] = ACTIONS(7662),
    [anon_sym_PERCENT] = ACTIONS(7662),
    [anon_sym_PIPE_PIPE] = ACTIONS(7664),
    [anon_sym_AMP_AMP] = ACTIONS(7664),
    [anon_sym_PIPE] = ACTIONS(7662),
    [anon_sym_CARET] = ACTIONS(7662),
    [anon_sym_AMP] = ACTIONS(7662),
    [anon_sym_EQ_EQ] = ACTIONS(7664),
    [anon_sym_BANG_EQ] = ACTIONS(7664),
    [anon_sym_GT] = ACTIONS(7662),
    [anon_sym_GT_EQ] = ACTIONS(7664),
    [anon_sym_LT_EQ] = ACTIONS(7662),
    [anon_sym_LT] = ACTIONS(7662),
    [anon_sym_LT_LT] = ACTIONS(7662),
    [anon_sym_GT_GT] = ACTIONS(7662),
    [anon_sym_COLON] = ACTIONS(7664),
    [anon_sym_SEMI] = ACTIONS(7664),
    [anon_sym___attribute__] = ACTIONS(7662),
    [anon_sym___attribute] = ACTIONS(7662),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7664),
    [anon_sym_LBRACE] = ACTIONS(7664),
    [anon_sym_RBRACE] = ACTIONS(7664),
    [anon_sym_LBRACK] = ACTIONS(7662),
    [anon_sym_RBRACK] = ACTIONS(7664),
    [anon_sym_EQ] = ACTIONS(7662),
    [anon_sym_QMARK] = ACTIONS(7664),
    [anon_sym_STAR_EQ] = ACTIONS(7664),
    [anon_sym_SLASH_EQ] = ACTIONS(7664),
    [anon_sym_PERCENT_EQ] = ACTIONS(7664),
    [anon_sym_PLUS_EQ] = ACTIONS(7664),
    [anon_sym_DASH_EQ] = ACTIONS(7664),
    [anon_sym_LT_LT_EQ] = ACTIONS(7664),
    [anon_sym_GT_GT_EQ] = ACTIONS(7664),
    [anon_sym_AMP_EQ] = ACTIONS(7664),
    [anon_sym_CARET_EQ] = ACTIONS(7664),
    [anon_sym_PIPE_EQ] = ACTIONS(7664),
    [anon_sym_and_eq] = ACTIONS(7662),
    [anon_sym_or_eq] = ACTIONS(7662),
    [anon_sym_xor_eq] = ACTIONS(7662),
    [anon_sym_LT_EQ_GT] = ACTIONS(7664),
    [anon_sym_or] = ACTIONS(7662),
    [anon_sym_and] = ACTIONS(7662),
    [anon_sym_bitor] = ACTIONS(7662),
    [anon_sym_xor] = ACTIONS(7662),
    [anon_sym_bitand] = ACTIONS(7662),
    [anon_sym_not_eq] = ACTIONS(7662),
    [anon_sym_is] = ACTIONS(7662),
    [anon_sym_as] = ACTIONS(7662),
    [anon_sym_DASH_DASH] = ACTIONS(7664),
    [anon_sym_PLUS_PLUS] = ACTIONS(7664),
    [anon_sym_DOT] = ACTIONS(7662),
    [anon_sym_DOT_STAR] = ACTIONS(7664),
    [anon_sym_DASH_GT] = ACTIONS(7664),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(7662),
  },
  [3286] = {
    [sym_string_literal] = STATE(2970),
    [sym_template_argument_list] = STATE(3325),
    [sym_raw_string_literal] = STATE(2970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7542),
    [anon_sym_COMMA] = ACTIONS(7666),
    [anon_sym_LPAREN2] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(7185),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_RBRACK] = ACTIONS(7668),
    [anon_sym_EQ] = ACTIONS(2181),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2170),
    [anon_sym_SLASH_EQ] = ACTIONS(2170),
    [anon_sym_PERCENT_EQ] = ACTIONS(2170),
    [anon_sym_PLUS_EQ] = ACTIONS(2170),
    [anon_sym_DASH_EQ] = ACTIONS(2170),
    [anon_sym_LT_LT_EQ] = ACTIONS(2170),
    [anon_sym_GT_GT_EQ] = ACTIONS(2170),
    [anon_sym_AMP_EQ] = ACTIONS(2170),
    [anon_sym_CARET_EQ] = ACTIONS(2170),
    [anon_sym_PIPE_EQ] = ACTIONS(2170),
    [anon_sym_and_eq] = ACTIONS(2170),
    [anon_sym_or_eq] = ACTIONS(2170),
    [anon_sym_xor_eq] = ACTIONS(2170),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(4982),
    [anon_sym_u_DQUOTE] = ACTIONS(4982),
    [anon_sym_U_DQUOTE] = ACTIONS(4982),
    [anon_sym_u8_DQUOTE] = ACTIONS(4982),
    [anon_sym_DQUOTE] = ACTIONS(4982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4990),
    [anon_sym_LR_DQUOTE] = ACTIONS(4990),
    [anon_sym_uR_DQUOTE] = ACTIONS(4990),
    [anon_sym_UR_DQUOTE] = ACTIONS(4990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4990),
  },
  [3287] = {
    [sym_argument_list] = STATE(3449),
    [sym_initializer_list] = STATE(3449),
    [sym_identifier] = ACTIONS(7671),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7673),
    [anon_sym_COMMA] = ACTIONS(7673),
    [anon_sym_RPAREN] = ACTIONS(7673),
    [aux_sym_preproc_if_token2] = ACTIONS(7673),
    [aux_sym_preproc_else_token1] = ACTIONS(7673),
    [aux_sym_preproc_elif_token1] = ACTIONS(7671),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7673),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7673),
    [anon_sym_LPAREN2] = ACTIONS(7358),
    [anon_sym_DASH] = ACTIONS(7671),
    [anon_sym_PLUS] = ACTIONS(7671),
    [anon_sym_STAR] = ACTIONS(7671),
    [anon_sym_SLASH] = ACTIONS(7671),
    [anon_sym_PERCENT] = ACTIONS(7671),
    [anon_sym_PIPE_PIPE] = ACTIONS(7673),
    [anon_sym_AMP_AMP] = ACTIONS(7673),
    [anon_sym_PIPE] = ACTIONS(7671),
    [anon_sym_CARET] = ACTIONS(7671),
    [anon_sym_AMP] = ACTIONS(7671),
    [anon_sym_EQ_EQ] = ACTIONS(7673),
    [anon_sym_BANG_EQ] = ACTIONS(7673),
    [anon_sym_GT] = ACTIONS(7671),
    [anon_sym_GT_EQ] = ACTIONS(7673),
    [anon_sym_LT_EQ] = ACTIONS(7671),
    [anon_sym_LT] = ACTIONS(7671),
    [anon_sym_LT_LT] = ACTIONS(7671),
    [anon_sym_GT_GT] = ACTIONS(7671),
    [anon_sym_COLON] = ACTIONS(7673),
    [anon_sym_SEMI] = ACTIONS(7673),
    [anon_sym___attribute__] = ACTIONS(7671),
    [anon_sym___attribute] = ACTIONS(7671),
    [anon_sym_LBRACE] = ACTIONS(4964),
    [anon_sym_RBRACE] = ACTIONS(7673),
    [anon_sym_LBRACK] = ACTIONS(7673),
    [anon_sym_RBRACK] = ACTIONS(7673),
    [anon_sym_EQ] = ACTIONS(7671),
    [anon_sym_QMARK] = ACTIONS(7673),
    [anon_sym_STAR_EQ] = ACTIONS(7673),
    [anon_sym_SLASH_EQ] = ACTIONS(7673),
    [anon_sym_PERCENT_EQ] = ACTIONS(7673),
    [anon_sym_PLUS_EQ] = ACTIONS(7673),
    [anon_sym_DASH_EQ] = ACTIONS(7673),
    [anon_sym_LT_LT_EQ] = ACTIONS(7673),
    [anon_sym_GT_GT_EQ] = ACTIONS(7673),
    [anon_sym_AMP_EQ] = ACTIONS(7673),
    [anon_sym_CARET_EQ] = ACTIONS(7673),
    [anon_sym_PIPE_EQ] = ACTIONS(7673),
    [anon_sym_and_eq] = ACTIONS(7671),
    [anon_sym_or_eq] = ACTIONS(7671),
    [anon_sym_xor_eq] = ACTIONS(7671),
    [anon_sym_LT_EQ_GT] = ACTIONS(7673),
    [anon_sym_or] = ACTIONS(7671),
    [anon_sym_and] = ACTIONS(7671),
    [anon_sym_bitor] = ACTIONS(7671),
    [anon_sym_xor] = ACTIONS(7671),
    [anon_sym_bitand] = ACTIONS(7671),
    [anon_sym_not_eq] = ACTIONS(7671),
    [anon_sym_is] = ACTIONS(7671),
    [anon_sym_as] = ACTIONS(7671),
    [anon_sym_DASH_DASH] = ACTIONS(7673),
    [anon_sym_PLUS_PLUS] = ACTIONS(7673),
    [anon_sym_DOT] = ACTIONS(7671),
    [anon_sym_DOT_STAR] = ACTIONS(7673),
    [anon_sym_DASH_GT] = ACTIONS(7673),
    [sym_comment] = ACTIONS(3),
  },
  [3288] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4062),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_RPAREN] = ACTIONS(4062),
    [anon_sym_LPAREN2] = ACTIONS(4062),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_STAR] = ACTIONS(4064),
    [anon_sym_SLASH] = ACTIONS(4064),
    [anon_sym_PERCENT] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE] = ACTIONS(4064),
    [anon_sym_CARET] = ACTIONS(4064),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [anon_sym_GT] = ACTIONS(4064),
    [anon_sym_GT_EQ] = ACTIONS(4062),
    [anon_sym_LT_EQ] = ACTIONS(4064),
    [anon_sym_LT] = ACTIONS(4064),
    [anon_sym_LT_LT] = ACTIONS(4064),
    [anon_sym_GT_GT] = ACTIONS(4064),
    [anon_sym_COLON] = ACTIONS(4062),
    [anon_sym_SEMI] = ACTIONS(4062),
    [anon_sym___attribute__] = ACTIONS(4062),
    [anon_sym___attribute] = ACTIONS(4064),
    [anon_sym_LBRACE] = ACTIONS(4062),
    [anon_sym_RBRACE] = ACTIONS(4062),
    [anon_sym_signed] = ACTIONS(7604),
    [anon_sym_unsigned] = ACTIONS(7604),
    [anon_sym_long] = ACTIONS(7604),
    [anon_sym_short] = ACTIONS(7604),
    [anon_sym_LBRACK] = ACTIONS(4062),
    [anon_sym_RBRACK] = ACTIONS(4062),
    [anon_sym_EQ] = ACTIONS(4064),
    [anon_sym_QMARK] = ACTIONS(4062),
    [anon_sym_STAR_EQ] = ACTIONS(4062),
    [anon_sym_SLASH_EQ] = ACTIONS(4062),
    [anon_sym_PERCENT_EQ] = ACTIONS(4062),
    [anon_sym_PLUS_EQ] = ACTIONS(4062),
    [anon_sym_DASH_EQ] = ACTIONS(4062),
    [anon_sym_LT_LT_EQ] = ACTIONS(4062),
    [anon_sym_GT_GT_EQ] = ACTIONS(4062),
    [anon_sym_AMP_EQ] = ACTIONS(4062),
    [anon_sym_CARET_EQ] = ACTIONS(4062),
    [anon_sym_PIPE_EQ] = ACTIONS(4062),
    [anon_sym_and_eq] = ACTIONS(4062),
    [anon_sym_or_eq] = ACTIONS(4062),
    [anon_sym_xor_eq] = ACTIONS(4062),
    [anon_sym_LT_EQ_GT] = ACTIONS(4062),
    [anon_sym_or] = ACTIONS(4064),
    [anon_sym_and] = ACTIONS(4064),
    [anon_sym_bitor] = ACTIONS(4062),
    [anon_sym_xor] = ACTIONS(4064),
    [anon_sym_bitand] = ACTIONS(4062),
    [anon_sym_not_eq] = ACTIONS(4062),
    [anon_sym_is] = ACTIONS(4062),
    [anon_sym_as] = ACTIONS(4062),
    [anon_sym_DASH_DASH] = ACTIONS(4062),
    [anon_sym_PLUS_PLUS] = ACTIONS(4062),
    [anon_sym_DOT] = ACTIONS(4064),
    [anon_sym_DOT_STAR] = ACTIONS(4062),
    [anon_sym_DASH_GT] = ACTIONS(4062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4062),
    [anon_sym_let] = ACTIONS(4062),
    [anon_sym_This] = ACTIONS(4062),
  },
  [3289] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4071),
    [anon_sym_COMMA] = ACTIONS(4071),
    [anon_sym_RPAREN] = ACTIONS(4071),
    [anon_sym_LPAREN2] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(4073),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(4073),
    [anon_sym_SLASH] = ACTIONS(4073),
    [anon_sym_PERCENT] = ACTIONS(4073),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_CARET] = ACTIONS(4073),
    [anon_sym_AMP] = ACTIONS(4073),
    [anon_sym_EQ_EQ] = ACTIONS(4071),
    [anon_sym_BANG_EQ] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_EQ] = ACTIONS(4071),
    [anon_sym_LT_EQ] = ACTIONS(4073),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4073),
    [anon_sym_COLON] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym___attribute__] = ACTIONS(4071),
    [anon_sym___attribute] = ACTIONS(4073),
    [anon_sym_LBRACE] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(4071),
    [anon_sym_signed] = ACTIONS(7604),
    [anon_sym_unsigned] = ACTIONS(7604),
    [anon_sym_long] = ACTIONS(7604),
    [anon_sym_short] = ACTIONS(7604),
    [anon_sym_LBRACK] = ACTIONS(4071),
    [anon_sym_RBRACK] = ACTIONS(4071),
    [anon_sym_EQ] = ACTIONS(4073),
    [anon_sym_QMARK] = ACTIONS(4071),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4071),
    [anon_sym_or_eq] = ACTIONS(4071),
    [anon_sym_xor_eq] = ACTIONS(4071),
    [anon_sym_LT_EQ_GT] = ACTIONS(4071),
    [anon_sym_or] = ACTIONS(4073),
    [anon_sym_and] = ACTIONS(4073),
    [anon_sym_bitor] = ACTIONS(4071),
    [anon_sym_xor] = ACTIONS(4073),
    [anon_sym_bitand] = ACTIONS(4071),
    [anon_sym_not_eq] = ACTIONS(4071),
    [anon_sym_is] = ACTIONS(4071),
    [anon_sym_as] = ACTIONS(4071),
    [anon_sym_DASH_DASH] = ACTIONS(4071),
    [anon_sym_PLUS_PLUS] = ACTIONS(4071),
    [anon_sym_DOT] = ACTIONS(4073),
    [anon_sym_DOT_STAR] = ACTIONS(4071),
    [anon_sym_DASH_GT] = ACTIONS(4071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4071),
    [anon_sym_let] = ACTIONS(4071),
    [anon_sym_This] = ACTIONS(4071),
  },
  [3290] = {
    [sym_string_literal] = STATE(3158),
    [sym_raw_string_literal] = STATE(3158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7388),
    [anon_sym_COMMA] = ACTIONS(7388),
    [anon_sym_LPAREN2] = ACTIONS(7388),
    [anon_sym_DASH] = ACTIONS(7386),
    [anon_sym_PLUS] = ACTIONS(7386),
    [anon_sym_STAR] = ACTIONS(7386),
    [anon_sym_SLASH] = ACTIONS(7386),
    [anon_sym_PERCENT] = ACTIONS(7386),
    [anon_sym_PIPE_PIPE] = ACTIONS(7388),
    [anon_sym_AMP_AMP] = ACTIONS(7388),
    [anon_sym_PIPE] = ACTIONS(7386),
    [anon_sym_CARET] = ACTIONS(7386),
    [anon_sym_AMP] = ACTIONS(7386),
    [anon_sym_EQ_EQ] = ACTIONS(7388),
    [anon_sym_BANG_EQ] = ACTIONS(7388),
    [anon_sym_GT] = ACTIONS(7386),
    [anon_sym_GT_EQ] = ACTIONS(7388),
    [anon_sym_LT_EQ] = ACTIONS(7386),
    [anon_sym_LT] = ACTIONS(7386),
    [anon_sym_LT_LT] = ACTIONS(7386),
    [anon_sym_GT_GT] = ACTIONS(7386),
    [anon_sym_SEMI] = ACTIONS(7388),
    [anon_sym___attribute__] = ACTIONS(7386),
    [anon_sym___attribute] = ACTIONS(7386),
    [anon_sym_LBRACK] = ACTIONS(7388),
    [anon_sym_EQ] = ACTIONS(7386),
    [anon_sym_QMARK] = ACTIONS(7388),
    [anon_sym_STAR_EQ] = ACTIONS(7388),
    [anon_sym_SLASH_EQ] = ACTIONS(7388),
    [anon_sym_PERCENT_EQ] = ACTIONS(7388),
    [anon_sym_PLUS_EQ] = ACTIONS(7388),
    [anon_sym_DASH_EQ] = ACTIONS(7388),
    [anon_sym_LT_LT_EQ] = ACTIONS(7388),
    [anon_sym_GT_GT_EQ] = ACTIONS(7388),
    [anon_sym_AMP_EQ] = ACTIONS(7388),
    [anon_sym_CARET_EQ] = ACTIONS(7388),
    [anon_sym_PIPE_EQ] = ACTIONS(7388),
    [anon_sym_and_eq] = ACTIONS(7386),
    [anon_sym_or_eq] = ACTIONS(7386),
    [anon_sym_xor_eq] = ACTIONS(7386),
    [anon_sym_LT_EQ_GT] = ACTIONS(7388),
    [anon_sym_or] = ACTIONS(7386),
    [anon_sym_and] = ACTIONS(7386),
    [anon_sym_bitor] = ACTIONS(7386),
    [anon_sym_xor] = ACTIONS(7386),
    [anon_sym_bitand] = ACTIONS(7386),
    [anon_sym_not_eq] = ACTIONS(7386),
    [anon_sym_is] = ACTIONS(7386),
    [anon_sym_as] = ACTIONS(7386),
    [anon_sym_DASH_DASH] = ACTIONS(7388),
    [anon_sym_PLUS_PLUS] = ACTIONS(7388),
    [anon_sym_DOT] = ACTIONS(7386),
    [anon_sym_DOT_STAR] = ACTIONS(7388),
    [anon_sym_DASH_GT] = ACTIONS(7388),
    [anon_sym_L_DQUOTE] = ACTIONS(7446),
    [anon_sym_u_DQUOTE] = ACTIONS(7446),
    [anon_sym_U_DQUOTE] = ACTIONS(7446),
    [anon_sym_u8_DQUOTE] = ACTIONS(7446),
    [anon_sym_DQUOTE] = ACTIONS(7446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7448),
    [anon_sym_LR_DQUOTE] = ACTIONS(7448),
    [anon_sym_uR_DQUOTE] = ACTIONS(7448),
    [anon_sym_UR_DQUOTE] = ACTIONS(7448),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7448),
    [sym_literal_suffix] = ACTIONS(7386),
  },
  [3291] = {
    [sym_identifier] = ACTIONS(7675),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7677),
    [anon_sym_COMMA] = ACTIONS(7677),
    [anon_sym_RPAREN] = ACTIONS(7677),
    [aux_sym_preproc_if_token2] = ACTIONS(7677),
    [aux_sym_preproc_else_token1] = ACTIONS(7677),
    [aux_sym_preproc_elif_token1] = ACTIONS(7675),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7677),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7677),
    [anon_sym_LPAREN2] = ACTIONS(7677),
    [anon_sym_DASH] = ACTIONS(7675),
    [anon_sym_PLUS] = ACTIONS(7675),
    [anon_sym_STAR] = ACTIONS(7675),
    [anon_sym_SLASH] = ACTIONS(7675),
    [anon_sym_PERCENT] = ACTIONS(7675),
    [anon_sym_PIPE_PIPE] = ACTIONS(7677),
    [anon_sym_AMP_AMP] = ACTIONS(7677),
    [anon_sym_PIPE] = ACTIONS(7675),
    [anon_sym_CARET] = ACTIONS(7675),
    [anon_sym_AMP] = ACTIONS(7675),
    [anon_sym_EQ_EQ] = ACTIONS(7677),
    [anon_sym_BANG_EQ] = ACTIONS(7677),
    [anon_sym_GT] = ACTIONS(7675),
    [anon_sym_GT_EQ] = ACTIONS(7677),
    [anon_sym_LT_EQ] = ACTIONS(7675),
    [anon_sym_LT] = ACTIONS(7675),
    [anon_sym_LT_LT] = ACTIONS(7675),
    [anon_sym_GT_GT] = ACTIONS(7675),
    [anon_sym_COLON] = ACTIONS(7677),
    [anon_sym_SEMI] = ACTIONS(7677),
    [anon_sym___attribute__] = ACTIONS(7675),
    [anon_sym___attribute] = ACTIONS(7675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7677),
    [anon_sym_LBRACE] = ACTIONS(7677),
    [anon_sym_RBRACE] = ACTIONS(7677),
    [anon_sym_LBRACK] = ACTIONS(7675),
    [anon_sym_RBRACK] = ACTIONS(7677),
    [anon_sym_EQ] = ACTIONS(7675),
    [anon_sym_QMARK] = ACTIONS(7677),
    [anon_sym_STAR_EQ] = ACTIONS(7677),
    [anon_sym_SLASH_EQ] = ACTIONS(7677),
    [anon_sym_PERCENT_EQ] = ACTIONS(7677),
    [anon_sym_PLUS_EQ] = ACTIONS(7677),
    [anon_sym_DASH_EQ] = ACTIONS(7677),
    [anon_sym_LT_LT_EQ] = ACTIONS(7677),
    [anon_sym_GT_GT_EQ] = ACTIONS(7677),
    [anon_sym_AMP_EQ] = ACTIONS(7677),
    [anon_sym_CARET_EQ] = ACTIONS(7677),
    [anon_sym_PIPE_EQ] = ACTIONS(7677),
    [anon_sym_and_eq] = ACTIONS(7675),
    [anon_sym_or_eq] = ACTIONS(7675),
    [anon_sym_xor_eq] = ACTIONS(7675),
    [anon_sym_LT_EQ_GT] = ACTIONS(7677),
    [anon_sym_or] = ACTIONS(7675),
    [anon_sym_and] = ACTIONS(7675),
    [anon_sym_bitor] = ACTIONS(7675),
    [anon_sym_xor] = ACTIONS(7675),
    [anon_sym_bitand] = ACTIONS(7675),
    [anon_sym_not_eq] = ACTIONS(7675),
    [anon_sym_is] = ACTIONS(7675),
    [anon_sym_as] = ACTIONS(7675),
    [anon_sym_DASH_DASH] = ACTIONS(7677),
    [anon_sym_PLUS_PLUS] = ACTIONS(7677),
    [anon_sym_DOT] = ACTIONS(7675),
    [anon_sym_DOT_STAR] = ACTIONS(7677),
    [anon_sym_DASH_GT] = ACTIONS(7677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(7675),
  },
  [3292] = {
    [sym_identifier] = ACTIONS(7679),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7681),
    [anon_sym_COMMA] = ACTIONS(7681),
    [anon_sym_RPAREN] = ACTIONS(7681),
    [aux_sym_preproc_if_token2] = ACTIONS(7681),
    [aux_sym_preproc_else_token1] = ACTIONS(7681),
    [aux_sym_preproc_elif_token1] = ACTIONS(7679),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7681),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7681),
    [anon_sym_LPAREN2] = ACTIONS(7681),
    [anon_sym_DASH] = ACTIONS(7679),
    [anon_sym_PLUS] = ACTIONS(7679),
    [anon_sym_STAR] = ACTIONS(7679),
    [anon_sym_SLASH] = ACTIONS(7679),
    [anon_sym_PERCENT] = ACTIONS(7679),
    [anon_sym_PIPE_PIPE] = ACTIONS(7681),
    [anon_sym_AMP_AMP] = ACTIONS(7681),
    [anon_sym_PIPE] = ACTIONS(7679),
    [anon_sym_CARET] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(7679),
    [anon_sym_EQ_EQ] = ACTIONS(7681),
    [anon_sym_BANG_EQ] = ACTIONS(7681),
    [anon_sym_GT] = ACTIONS(7679),
    [anon_sym_GT_EQ] = ACTIONS(7681),
    [anon_sym_LT_EQ] = ACTIONS(7679),
    [anon_sym_LT] = ACTIONS(7679),
    [anon_sym_LT_LT] = ACTIONS(7679),
    [anon_sym_GT_GT] = ACTIONS(7679),
    [anon_sym_COLON] = ACTIONS(7681),
    [anon_sym_SEMI] = ACTIONS(7681),
    [anon_sym___attribute__] = ACTIONS(7679),
    [anon_sym___attribute] = ACTIONS(7679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7681),
    [anon_sym_LBRACE] = ACTIONS(7681),
    [anon_sym_RBRACE] = ACTIONS(7681),
    [anon_sym_LBRACK] = ACTIONS(7679),
    [anon_sym_RBRACK] = ACTIONS(7681),
    [anon_sym_EQ] = ACTIONS(7679),
    [anon_sym_QMARK] = ACTIONS(7681),
    [anon_sym_STAR_EQ] = ACTIONS(7681),
    [anon_sym_SLASH_EQ] = ACTIONS(7681),
    [anon_sym_PERCENT_EQ] = ACTIONS(7681),
    [anon_sym_PLUS_EQ] = ACTIONS(7681),
    [anon_sym_DASH_EQ] = ACTIONS(7681),
    [anon_sym_LT_LT_EQ] = ACTIONS(7681),
    [anon_sym_GT_GT_EQ] = ACTIONS(7681),
    [anon_sym_AMP_EQ] = ACTIONS(7681),
    [anon_sym_CARET_EQ] = ACTIONS(7681),
    [anon_sym_PIPE_EQ] = ACTIONS(7681),
    [anon_sym_and_eq] = ACTIONS(7679),
    [anon_sym_or_eq] = ACTIONS(7679),
    [anon_sym_xor_eq] = ACTIONS(7679),
    [anon_sym_LT_EQ_GT] = ACTIONS(7681),
    [anon_sym_or] = ACTIONS(7679),
    [anon_sym_and] = ACTIONS(7679),
    [anon_sym_bitor] = ACTIONS(7679),
    [anon_sym_xor] = ACTIONS(7679),
    [anon_sym_bitand] = ACTIONS(7679),
    [anon_sym_not_eq] = ACTIONS(7679),
    [anon_sym_is] = ACTIONS(7679),
    [anon_sym_as] = ACTIONS(7679),
    [anon_sym_DASH_DASH] = ACTIONS(7681),
    [anon_sym_PLUS_PLUS] = ACTIONS(7681),
    [anon_sym_DOT] = ACTIONS(7679),
    [anon_sym_DOT_STAR] = ACTIONS(7681),
    [anon_sym_DASH_GT] = ACTIONS(7681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(7679),
  },
  [3293] = {
    [sym_argument_list] = STATE(3426),
    [sym_initializer_list] = STATE(3426),
    [sym_identifier] = ACTIONS(7683),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7685),
    [anon_sym_COMMA] = ACTIONS(7685),
    [anon_sym_RPAREN] = ACTIONS(7685),
    [aux_sym_preproc_if_token2] = ACTIONS(7685),
    [aux_sym_preproc_else_token1] = ACTIONS(7685),
    [aux_sym_preproc_elif_token1] = ACTIONS(7683),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7685),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7685),
    [anon_sym_LPAREN2] = ACTIONS(7358),
    [anon_sym_DASH] = ACTIONS(7683),
    [anon_sym_PLUS] = ACTIONS(7683),
    [anon_sym_STAR] = ACTIONS(7683),
    [anon_sym_SLASH] = ACTIONS(7683),
    [anon_sym_PERCENT] = ACTIONS(7683),
    [anon_sym_PIPE_PIPE] = ACTIONS(7685),
    [anon_sym_AMP_AMP] = ACTIONS(7685),
    [anon_sym_PIPE] = ACTIONS(7683),
    [anon_sym_CARET] = ACTIONS(7683),
    [anon_sym_AMP] = ACTIONS(7683),
    [anon_sym_EQ_EQ] = ACTIONS(7685),
    [anon_sym_BANG_EQ] = ACTIONS(7685),
    [anon_sym_GT] = ACTIONS(7683),
    [anon_sym_GT_EQ] = ACTIONS(7685),
    [anon_sym_LT_EQ] = ACTIONS(7683),
    [anon_sym_LT] = ACTIONS(7683),
    [anon_sym_LT_LT] = ACTIONS(7683),
    [anon_sym_GT_GT] = ACTIONS(7683),
    [anon_sym_COLON] = ACTIONS(7685),
    [anon_sym_SEMI] = ACTIONS(7685),
    [anon_sym___attribute__] = ACTIONS(7683),
    [anon_sym___attribute] = ACTIONS(7683),
    [anon_sym_LBRACE] = ACTIONS(4964),
    [anon_sym_RBRACE] = ACTIONS(7685),
    [anon_sym_LBRACK] = ACTIONS(7685),
    [anon_sym_RBRACK] = ACTIONS(7685),
    [anon_sym_EQ] = ACTIONS(7683),
    [anon_sym_QMARK] = ACTIONS(7685),
    [anon_sym_STAR_EQ] = ACTIONS(7685),
    [anon_sym_SLASH_EQ] = ACTIONS(7685),
    [anon_sym_PERCENT_EQ] = ACTIONS(7685),
    [anon_sym_PLUS_EQ] = ACTIONS(7685),
    [anon_sym_DASH_EQ] = ACTIONS(7685),
    [anon_sym_LT_LT_EQ] = ACTIONS(7685),
    [anon_sym_GT_GT_EQ] = ACTIONS(7685),
    [anon_sym_AMP_EQ] = ACTIONS(7685),
    [anon_sym_CARET_EQ] = ACTIONS(7685),
    [anon_sym_PIPE_EQ] = ACTIONS(7685),
    [anon_sym_and_eq] = ACTIONS(7683),
    [anon_sym_or_eq] = ACTIONS(7683),
    [anon_sym_xor_eq] = ACTIONS(7683),
    [anon_sym_LT_EQ_GT] = ACTIONS(7685),
    [anon_sym_or] = ACTIONS(7683),
    [anon_sym_and] = ACTIONS(7683),
    [anon_sym_bitor] = ACTIONS(7683),
    [anon_sym_xor] = ACTIONS(7683),
    [anon_sym_bitand] = ACTIONS(7683),
    [anon_sym_not_eq] = ACTIONS(7683),
    [anon_sym_is] = ACTIONS(7683),
    [anon_sym_as] = ACTIONS(7683),
    [anon_sym_DASH_DASH] = ACTIONS(7685),
    [anon_sym_PLUS_PLUS] = ACTIONS(7685),
    [anon_sym_DOT] = ACTIONS(7683),
    [anon_sym_DOT_STAR] = ACTIONS(7685),
    [anon_sym_DASH_GT] = ACTIONS(7685),
    [sym_comment] = ACTIONS(3),
  },
  [3294] = {
    [sym_template_argument_list] = STATE(3342),
    [sym_identifier] = ACTIONS(2222),
    [anon_sym_LPAREN2] = ACTIONS(2226),
    [anon_sym_STAR] = ACTIONS(2229),
    [anon_sym_AMP_AMP] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(7064),
    [anon_sym_SEMI] = ACTIONS(2229),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_virtual] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym___attribute] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2226),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym___based] = ACTIONS(2222),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym__Nonnull] = ACTIONS(2222),
    [anon_sym_mutable] = ACTIONS(2222),
    [anon_sym_constinit] = ACTIONS(2222),
    [anon_sym_consteval] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [anon_sym_DOT] = ACTIONS(2229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2222),
    [anon_sym_let] = ACTIONS(2222),
    [anon_sym_This] = ACTIONS(2222),
    [anon_sym_operator] = ACTIONS(2222),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_groupshared] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_row_major] = ACTIONS(2222),
    [anon_sym_column_major] = ACTIONS(2222),
    [anon_sym_globallycoherent] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym_nointerpolation] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_linear] = ACTIONS(2222),
    [anon_sym_snorm] = ACTIONS(2222),
    [anon_sym_unorm] = ACTIONS(2222),
    [anon_sym_point] = ACTIONS(2222),
    [anon_sym_line] = ACTIONS(2222),
    [anon_sym_triangleadj] = ACTIONS(2222),
    [anon_sym_lineadj] = ACTIONS(2222),
    [anon_sym_triangle] = ACTIONS(2222),
  },
  [3295] = {
    [sym_identifier] = ACTIONS(2268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2270),
    [anon_sym_COMMA] = ACTIONS(2270),
    [anon_sym_LPAREN2] = ACTIONS(2270),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2270),
    [anon_sym_SLASH] = ACTIONS(2268),
    [anon_sym_PERCENT] = ACTIONS(2270),
    [anon_sym_PIPE_PIPE] = ACTIONS(2270),
    [anon_sym_AMP_AMP] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2268),
    [anon_sym_CARET] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(2268),
    [anon_sym_EQ_EQ] = ACTIONS(2270),
    [anon_sym_BANG_EQ] = ACTIONS(2270),
    [anon_sym_GT] = ACTIONS(2268),
    [anon_sym_GT_EQ] = ACTIONS(2268),
    [anon_sym_LT_EQ] = ACTIONS(2268),
    [anon_sym_LT] = ACTIONS(2268),
    [anon_sym_LT_LT] = ACTIONS(2270),
    [anon_sym_GT_GT] = ACTIONS(2268),
    [anon_sym_COLON] = ACTIONS(2268),
    [anon_sym___extension__] = ACTIONS(2268),
    [anon_sym___attribute__] = ACTIONS(2268),
    [anon_sym___attribute] = ACTIONS(2268),
    [anon_sym_COLON_COLON] = ACTIONS(2270),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_LBRACK] = ACTIONS(2270),
    [anon_sym_EQ] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_constexpr] = ACTIONS(2268),
    [anon_sym_volatile] = ACTIONS(2268),
    [anon_sym_restrict] = ACTIONS(2268),
    [anon_sym___restrict__] = ACTIONS(2268),
    [anon_sym__Atomic] = ACTIONS(2268),
    [anon_sym__Noreturn] = ACTIONS(2268),
    [anon_sym_noreturn] = ACTIONS(2268),
    [anon_sym__Nonnull] = ACTIONS(2268),
    [anon_sym_mutable] = ACTIONS(2268),
    [anon_sym_constinit] = ACTIONS(2268),
    [anon_sym_consteval] = ACTIONS(2268),
    [anon_sym_alignas] = ACTIONS(2268),
    [anon_sym__Alignas] = ACTIONS(2268),
    [anon_sym_QMARK] = ACTIONS(2270),
    [anon_sym_LT_EQ_GT] = ACTIONS(2270),
    [anon_sym_or] = ACTIONS(2268),
    [anon_sym_and] = ACTIONS(2268),
    [anon_sym_bitor] = ACTIONS(2268),
    [anon_sym_xor] = ACTIONS(2268),
    [anon_sym_bitand] = ACTIONS(2268),
    [anon_sym_not_eq] = ACTIONS(2268),
    [anon_sym_is] = ACTIONS(2268),
    [anon_sym_as] = ACTIONS(2268),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_DOT] = ACTIONS(2268),
    [anon_sym_DOT_STAR] = ACTIONS(2270),
    [anon_sym_DASH_GT] = ACTIONS(2270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_This] = ACTIONS(2268),
    [anon_sym_final] = ACTIONS(2268),
    [anon_sym_override] = ACTIONS(2268),
    [anon_sym_GT2] = ACTIONS(2270),
    [anon_sym_requires] = ACTIONS(2268),
    [anon_sym_where] = ACTIONS(2268),
  },
  [3296] = {
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2274),
    [anon_sym_COMMA] = ACTIONS(2274),
    [anon_sym_LPAREN2] = ACTIONS(2274),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2274),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_PERCENT] = ACTIONS(2274),
    [anon_sym_PIPE_PIPE] = ACTIONS(2274),
    [anon_sym_AMP_AMP] = ACTIONS(2274),
    [anon_sym_PIPE] = ACTIONS(2272),
    [anon_sym_CARET] = ACTIONS(2274),
    [anon_sym_AMP] = ACTIONS(2272),
    [anon_sym_EQ_EQ] = ACTIONS(2274),
    [anon_sym_BANG_EQ] = ACTIONS(2274),
    [anon_sym_GT] = ACTIONS(2272),
    [anon_sym_GT_EQ] = ACTIONS(2272),
    [anon_sym_LT_EQ] = ACTIONS(2272),
    [anon_sym_LT] = ACTIONS(2272),
    [anon_sym_LT_LT] = ACTIONS(2274),
    [anon_sym_GT_GT] = ACTIONS(2272),
    [anon_sym_COLON] = ACTIONS(2272),
    [anon_sym___extension__] = ACTIONS(2272),
    [anon_sym___attribute__] = ACTIONS(2272),
    [anon_sym___attribute] = ACTIONS(2272),
    [anon_sym_COLON_COLON] = ACTIONS(2274),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_LBRACK] = ACTIONS(2274),
    [anon_sym_EQ] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_constexpr] = ACTIONS(2272),
    [anon_sym_volatile] = ACTIONS(2272),
    [anon_sym_restrict] = ACTIONS(2272),
    [anon_sym___restrict__] = ACTIONS(2272),
    [anon_sym__Atomic] = ACTIONS(2272),
    [anon_sym__Noreturn] = ACTIONS(2272),
    [anon_sym_noreturn] = ACTIONS(2272),
    [anon_sym__Nonnull] = ACTIONS(2272),
    [anon_sym_mutable] = ACTIONS(2272),
    [anon_sym_constinit] = ACTIONS(2272),
    [anon_sym_consteval] = ACTIONS(2272),
    [anon_sym_alignas] = ACTIONS(2272),
    [anon_sym__Alignas] = ACTIONS(2272),
    [anon_sym_QMARK] = ACTIONS(2274),
    [anon_sym_LT_EQ_GT] = ACTIONS(2274),
    [anon_sym_or] = ACTIONS(2272),
    [anon_sym_and] = ACTIONS(2272),
    [anon_sym_bitor] = ACTIONS(2272),
    [anon_sym_xor] = ACTIONS(2272),
    [anon_sym_bitand] = ACTIONS(2272),
    [anon_sym_not_eq] = ACTIONS(2272),
    [anon_sym_is] = ACTIONS(2272),
    [anon_sym_as] = ACTIONS(2272),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_DOT] = ACTIONS(2272),
    [anon_sym_DOT_STAR] = ACTIONS(2274),
    [anon_sym_DASH_GT] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_This] = ACTIONS(2272),
    [anon_sym_final] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_GT2] = ACTIONS(2274),
    [anon_sym_requires] = ACTIONS(2272),
    [anon_sym_where] = ACTIONS(2272),
  },
  [3297] = {
    [sym_identifier] = ACTIONS(2276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2278),
    [anon_sym_COMMA] = ACTIONS(2278),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_PLUS] = ACTIONS(2276),
    [anon_sym_STAR] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2276),
    [anon_sym_PERCENT] = ACTIONS(2278),
    [anon_sym_PIPE_PIPE] = ACTIONS(2278),
    [anon_sym_AMP_AMP] = ACTIONS(2278),
    [anon_sym_PIPE] = ACTIONS(2276),
    [anon_sym_CARET] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_EQ_EQ] = ACTIONS(2278),
    [anon_sym_BANG_EQ] = ACTIONS(2278),
    [anon_sym_GT] = ACTIONS(2276),
    [anon_sym_GT_EQ] = ACTIONS(2276),
    [anon_sym_LT_EQ] = ACTIONS(2276),
    [anon_sym_LT] = ACTIONS(2276),
    [anon_sym_LT_LT] = ACTIONS(2278),
    [anon_sym_GT_GT] = ACTIONS(2276),
    [anon_sym_COLON] = ACTIONS(2276),
    [anon_sym___extension__] = ACTIONS(2276),
    [anon_sym___attribute__] = ACTIONS(2276),
    [anon_sym___attribute] = ACTIONS(2276),
    [anon_sym_COLON_COLON] = ACTIONS(2278),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_EQ] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_constexpr] = ACTIONS(2276),
    [anon_sym_volatile] = ACTIONS(2276),
    [anon_sym_restrict] = ACTIONS(2276),
    [anon_sym___restrict__] = ACTIONS(2276),
    [anon_sym__Atomic] = ACTIONS(2276),
    [anon_sym__Noreturn] = ACTIONS(2276),
    [anon_sym_noreturn] = ACTIONS(2276),
    [anon_sym__Nonnull] = ACTIONS(2276),
    [anon_sym_mutable] = ACTIONS(2276),
    [anon_sym_constinit] = ACTIONS(2276),
    [anon_sym_consteval] = ACTIONS(2276),
    [anon_sym_alignas] = ACTIONS(2276),
    [anon_sym__Alignas] = ACTIONS(2276),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LT_EQ_GT] = ACTIONS(2278),
    [anon_sym_or] = ACTIONS(2276),
    [anon_sym_and] = ACTIONS(2276),
    [anon_sym_bitor] = ACTIONS(2276),
    [anon_sym_xor] = ACTIONS(2276),
    [anon_sym_bitand] = ACTIONS(2276),
    [anon_sym_not_eq] = ACTIONS(2276),
    [anon_sym_is] = ACTIONS(2276),
    [anon_sym_as] = ACTIONS(2276),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DOT] = ACTIONS(2276),
    [anon_sym_DOT_STAR] = ACTIONS(2278),
    [anon_sym_DASH_GT] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_This] = ACTIONS(2276),
    [anon_sym_final] = ACTIONS(2276),
    [anon_sym_override] = ACTIONS(2276),
    [anon_sym_GT2] = ACTIONS(2278),
    [anon_sym_requires] = ACTIONS(2276),
    [anon_sym_where] = ACTIONS(2276),
  },
  [3298] = {
    [sym_identifier] = ACTIONS(2239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2241),
    [anon_sym_COMMA] = ACTIONS(2241),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2239),
    [anon_sym_PLUS] = ACTIONS(2239),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_SLASH] = ACTIONS(2239),
    [anon_sym_PERCENT] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_PIPE] = ACTIONS(2239),
    [anon_sym_CARET] = ACTIONS(2241),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2241),
    [anon_sym_GT] = ACTIONS(2239),
    [anon_sym_GT_EQ] = ACTIONS(2239),
    [anon_sym_LT_EQ] = ACTIONS(2239),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_LT_LT] = ACTIONS(2241),
    [anon_sym_GT_GT] = ACTIONS(2239),
    [anon_sym_COLON] = ACTIONS(2239),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym___attribute] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2241),
    [anon_sym_EQ] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym__Nonnull] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [anon_sym_QMARK] = ACTIONS(2241),
    [anon_sym_LT_EQ_GT] = ACTIONS(2241),
    [anon_sym_or] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(2239),
    [anon_sym_bitor] = ACTIONS(2239),
    [anon_sym_xor] = ACTIONS(2239),
    [anon_sym_bitand] = ACTIONS(2239),
    [anon_sym_not_eq] = ACTIONS(2239),
    [anon_sym_is] = ACTIONS(2239),
    [anon_sym_as] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2239),
    [anon_sym_DOT_STAR] = ACTIONS(2241),
    [anon_sym_DASH_GT] = ACTIONS(2241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2239),
    [anon_sym_let] = ACTIONS(2239),
    [anon_sym_This] = ACTIONS(2239),
    [anon_sym_final] = ACTIONS(2239),
    [anon_sym_override] = ACTIONS(2239),
    [anon_sym_GT2] = ACTIONS(2241),
    [anon_sym_requires] = ACTIONS(2239),
    [anon_sym_where] = ACTIONS(2239),
  },
  [3299] = {
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2282),
    [anon_sym_COMMA] = ACTIONS(2282),
    [anon_sym_LPAREN2] = ACTIONS(2282),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2282),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_PERCENT] = ACTIONS(2282),
    [anon_sym_PIPE_PIPE] = ACTIONS(2282),
    [anon_sym_AMP_AMP] = ACTIONS(2282),
    [anon_sym_PIPE] = ACTIONS(2280),
    [anon_sym_CARET] = ACTIONS(2282),
    [anon_sym_AMP] = ACTIONS(2280),
    [anon_sym_EQ_EQ] = ACTIONS(2282),
    [anon_sym_BANG_EQ] = ACTIONS(2282),
    [anon_sym_GT] = ACTIONS(2280),
    [anon_sym_GT_EQ] = ACTIONS(2280),
    [anon_sym_LT_EQ] = ACTIONS(2280),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_LT_LT] = ACTIONS(2282),
    [anon_sym_GT_GT] = ACTIONS(2280),
    [anon_sym_COLON] = ACTIONS(2280),
    [anon_sym___extension__] = ACTIONS(2280),
    [anon_sym___attribute__] = ACTIONS(2280),
    [anon_sym___attribute] = ACTIONS(2280),
    [anon_sym_COLON_COLON] = ACTIONS(2282),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_EQ] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_constexpr] = ACTIONS(2280),
    [anon_sym_volatile] = ACTIONS(2280),
    [anon_sym_restrict] = ACTIONS(2280),
    [anon_sym___restrict__] = ACTIONS(2280),
    [anon_sym__Atomic] = ACTIONS(2280),
    [anon_sym__Noreturn] = ACTIONS(2280),
    [anon_sym_noreturn] = ACTIONS(2280),
    [anon_sym__Nonnull] = ACTIONS(2280),
    [anon_sym_mutable] = ACTIONS(2280),
    [anon_sym_constinit] = ACTIONS(2280),
    [anon_sym_consteval] = ACTIONS(2280),
    [anon_sym_alignas] = ACTIONS(2280),
    [anon_sym__Alignas] = ACTIONS(2280),
    [anon_sym_QMARK] = ACTIONS(2282),
    [anon_sym_LT_EQ_GT] = ACTIONS(2282),
    [anon_sym_or] = ACTIONS(2280),
    [anon_sym_and] = ACTIONS(2280),
    [anon_sym_bitor] = ACTIONS(2280),
    [anon_sym_xor] = ACTIONS(2280),
    [anon_sym_bitand] = ACTIONS(2280),
    [anon_sym_not_eq] = ACTIONS(2280),
    [anon_sym_is] = ACTIONS(2280),
    [anon_sym_as] = ACTIONS(2280),
    [anon_sym_DASH_DASH] = ACTIONS(2282),
    [anon_sym_PLUS_PLUS] = ACTIONS(2282),
    [anon_sym_DOT] = ACTIONS(2280),
    [anon_sym_DOT_STAR] = ACTIONS(2282),
    [anon_sym_DASH_GT] = ACTIONS(2282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_This] = ACTIONS(2280),
    [anon_sym_final] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_GT2] = ACTIONS(2282),
    [anon_sym_requires] = ACTIONS(2280),
    [anon_sym_where] = ACTIONS(2280),
  },
  [3300] = {
    [sym_identifier] = ACTIONS(2284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2286),
    [anon_sym_COMMA] = ACTIONS(2286),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_SLASH] = ACTIONS(2284),
    [anon_sym_PERCENT] = ACTIONS(2286),
    [anon_sym_PIPE_PIPE] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2284),
    [anon_sym_CARET] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_EQ_EQ] = ACTIONS(2286),
    [anon_sym_BANG_EQ] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2284),
    [anon_sym_GT_EQ] = ACTIONS(2284),
    [anon_sym_LT_EQ] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2284),
    [anon_sym_LT_LT] = ACTIONS(2286),
    [anon_sym_GT_GT] = ACTIONS(2284),
    [anon_sym_COLON] = ACTIONS(2284),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_EQ] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [anon_sym_QMARK] = ACTIONS(2286),
    [anon_sym_LT_EQ_GT] = ACTIONS(2286),
    [anon_sym_or] = ACTIONS(2284),
    [anon_sym_and] = ACTIONS(2284),
    [anon_sym_bitor] = ACTIONS(2284),
    [anon_sym_xor] = ACTIONS(2284),
    [anon_sym_bitand] = ACTIONS(2284),
    [anon_sym_not_eq] = ACTIONS(2284),
    [anon_sym_is] = ACTIONS(2284),
    [anon_sym_as] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_DOT] = ACTIONS(2284),
    [anon_sym_DOT_STAR] = ACTIONS(2286),
    [anon_sym_DASH_GT] = ACTIONS(2286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_This] = ACTIONS(2284),
    [anon_sym_final] = ACTIONS(2284),
    [anon_sym_override] = ACTIONS(2284),
    [anon_sym_GT2] = ACTIONS(2286),
    [anon_sym_requires] = ACTIONS(2284),
    [anon_sym_where] = ACTIONS(2284),
  },
  [3301] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(4695),
    [sym_raw_string_literal] = STATE(3527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6839),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(2181),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_EQ] = ACTIONS(7687),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(7689),
    [anon_sym_SLASH_EQ] = ACTIONS(7689),
    [anon_sym_PERCENT_EQ] = ACTIONS(7689),
    [anon_sym_PLUS_EQ] = ACTIONS(7689),
    [anon_sym_DASH_EQ] = ACTIONS(7689),
    [anon_sym_LT_LT_EQ] = ACTIONS(7689),
    [anon_sym_GT_GT_EQ] = ACTIONS(7689),
    [anon_sym_AMP_EQ] = ACTIONS(7689),
    [anon_sym_CARET_EQ] = ACTIONS(7689),
    [anon_sym_PIPE_EQ] = ACTIONS(7689),
    [anon_sym_and_eq] = ACTIONS(7689),
    [anon_sym_or_eq] = ACTIONS(7689),
    [anon_sym_xor_eq] = ACTIONS(7689),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
  },
  [3302] = {
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2290),
    [anon_sym_COMMA] = ACTIONS(2290),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_PERCENT] = ACTIONS(2290),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_CARET] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_EQ_EQ] = ACTIONS(2290),
    [anon_sym_BANG_EQ] = ACTIONS(2290),
    [anon_sym_GT] = ACTIONS(2288),
    [anon_sym_GT_EQ] = ACTIONS(2288),
    [anon_sym_LT_EQ] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(2290),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_COLON] = ACTIONS(2288),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_LBRACK] = ACTIONS(2290),
    [anon_sym_EQ] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [anon_sym_QMARK] = ACTIONS(2290),
    [anon_sym_LT_EQ_GT] = ACTIONS(2290),
    [anon_sym_or] = ACTIONS(2288),
    [anon_sym_and] = ACTIONS(2288),
    [anon_sym_bitor] = ACTIONS(2288),
    [anon_sym_xor] = ACTIONS(2288),
    [anon_sym_bitand] = ACTIONS(2288),
    [anon_sym_not_eq] = ACTIONS(2288),
    [anon_sym_is] = ACTIONS(2288),
    [anon_sym_as] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_DOT] = ACTIONS(2288),
    [anon_sym_DOT_STAR] = ACTIONS(2290),
    [anon_sym_DASH_GT] = ACTIONS(2290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_This] = ACTIONS(2288),
    [anon_sym_final] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_GT2] = ACTIONS(2290),
    [anon_sym_requires] = ACTIONS(2288),
    [anon_sym_where] = ACTIONS(2288),
  },
  [3303] = {
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2294),
    [anon_sym_COMMA] = ACTIONS(2294),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_PERCENT] = ACTIONS(2294),
    [anon_sym_PIPE_PIPE] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_PIPE] = ACTIONS(2292),
    [anon_sym_CARET] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_EQ_EQ] = ACTIONS(2294),
    [anon_sym_BANG_EQ] = ACTIONS(2294),
    [anon_sym_GT] = ACTIONS(2292),
    [anon_sym_GT_EQ] = ACTIONS(2292),
    [anon_sym_LT_EQ] = ACTIONS(2292),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_LT_LT] = ACTIONS(2294),
    [anon_sym_GT_GT] = ACTIONS(2292),
    [anon_sym_COLON] = ACTIONS(2292),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym___attribute] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_LBRACK] = ACTIONS(2294),
    [anon_sym_EQ] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym__Nonnull] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [anon_sym_QMARK] = ACTIONS(2294),
    [anon_sym_LT_EQ_GT] = ACTIONS(2294),
    [anon_sym_or] = ACTIONS(2292),
    [anon_sym_and] = ACTIONS(2292),
    [anon_sym_bitor] = ACTIONS(2292),
    [anon_sym_xor] = ACTIONS(2292),
    [anon_sym_bitand] = ACTIONS(2292),
    [anon_sym_not_eq] = ACTIONS(2292),
    [anon_sym_is] = ACTIONS(2292),
    [anon_sym_as] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_DOT] = ACTIONS(2292),
    [anon_sym_DOT_STAR] = ACTIONS(2294),
    [anon_sym_DASH_GT] = ACTIONS(2294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_This] = ACTIONS(2292),
    [anon_sym_final] = ACTIONS(2292),
    [anon_sym_override] = ACTIONS(2292),
    [anon_sym_GT2] = ACTIONS(2294),
    [anon_sym_requires] = ACTIONS(2292),
    [anon_sym_where] = ACTIONS(2292),
  },
  [3304] = {
    [sym_identifier] = ACTIONS(2296),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2298),
    [anon_sym_COMMA] = ACTIONS(2298),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2298),
    [anon_sym_SLASH] = ACTIONS(2296),
    [anon_sym_PERCENT] = ACTIONS(2298),
    [anon_sym_PIPE_PIPE] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_PIPE] = ACTIONS(2296),
    [anon_sym_CARET] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_EQ_EQ] = ACTIONS(2298),
    [anon_sym_BANG_EQ] = ACTIONS(2298),
    [anon_sym_GT] = ACTIONS(2296),
    [anon_sym_GT_EQ] = ACTIONS(2296),
    [anon_sym_LT_EQ] = ACTIONS(2296),
    [anon_sym_LT] = ACTIONS(2296),
    [anon_sym_LT_LT] = ACTIONS(2298),
    [anon_sym_GT_GT] = ACTIONS(2296),
    [anon_sym_COLON] = ACTIONS(2296),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym___attribute] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_LBRACK] = ACTIONS(2298),
    [anon_sym_EQ] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym__Nonnull] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [anon_sym_QMARK] = ACTIONS(2298),
    [anon_sym_LT_EQ_GT] = ACTIONS(2298),
    [anon_sym_or] = ACTIONS(2296),
    [anon_sym_and] = ACTIONS(2296),
    [anon_sym_bitor] = ACTIONS(2296),
    [anon_sym_xor] = ACTIONS(2296),
    [anon_sym_bitand] = ACTIONS(2296),
    [anon_sym_not_eq] = ACTIONS(2296),
    [anon_sym_is] = ACTIONS(2296),
    [anon_sym_as] = ACTIONS(2296),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_DOT] = ACTIONS(2296),
    [anon_sym_DOT_STAR] = ACTIONS(2298),
    [anon_sym_DASH_GT] = ACTIONS(2298),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_This] = ACTIONS(2296),
    [anon_sym_final] = ACTIONS(2296),
    [anon_sym_override] = ACTIONS(2296),
    [anon_sym_GT2] = ACTIONS(2298),
    [anon_sym_requires] = ACTIONS(2296),
    [anon_sym_where] = ACTIONS(2296),
  },
  [3305] = {
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2266),
    [anon_sym_COMMA] = ACTIONS(2266),
    [anon_sym_LPAREN2] = ACTIONS(2266),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2266),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_PERCENT] = ACTIONS(2266),
    [anon_sym_PIPE_PIPE] = ACTIONS(2266),
    [anon_sym_AMP_AMP] = ACTIONS(2266),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_CARET] = ACTIONS(2266),
    [anon_sym_AMP] = ACTIONS(2264),
    [anon_sym_EQ_EQ] = ACTIONS(2266),
    [anon_sym_BANG_EQ] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(2264),
    [anon_sym_GT_EQ] = ACTIONS(2264),
    [anon_sym_LT_EQ] = ACTIONS(2264),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_LT_LT] = ACTIONS(2266),
    [anon_sym_GT_GT] = ACTIONS(2264),
    [anon_sym_COLON] = ACTIONS(2264),
    [anon_sym___extension__] = ACTIONS(2264),
    [anon_sym___attribute__] = ACTIONS(2264),
    [anon_sym___attribute] = ACTIONS(2264),
    [anon_sym_COLON_COLON] = ACTIONS(2266),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_EQ] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_constexpr] = ACTIONS(2264),
    [anon_sym_volatile] = ACTIONS(2264),
    [anon_sym_restrict] = ACTIONS(2264),
    [anon_sym___restrict__] = ACTIONS(2264),
    [anon_sym__Atomic] = ACTIONS(2264),
    [anon_sym__Noreturn] = ACTIONS(2264),
    [anon_sym_noreturn] = ACTIONS(2264),
    [anon_sym__Nonnull] = ACTIONS(2264),
    [anon_sym_mutable] = ACTIONS(2264),
    [anon_sym_constinit] = ACTIONS(2264),
    [anon_sym_consteval] = ACTIONS(2264),
    [anon_sym_alignas] = ACTIONS(2264),
    [anon_sym__Alignas] = ACTIONS(2264),
    [anon_sym_QMARK] = ACTIONS(2266),
    [anon_sym_LT_EQ_GT] = ACTIONS(2266),
    [anon_sym_or] = ACTIONS(2264),
    [anon_sym_and] = ACTIONS(2264),
    [anon_sym_bitor] = ACTIONS(2264),
    [anon_sym_xor] = ACTIONS(2264),
    [anon_sym_bitand] = ACTIONS(2264),
    [anon_sym_not_eq] = ACTIONS(2264),
    [anon_sym_is] = ACTIONS(2264),
    [anon_sym_as] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2266),
    [anon_sym_PLUS_PLUS] = ACTIONS(2266),
    [anon_sym_DOT] = ACTIONS(2264),
    [anon_sym_DOT_STAR] = ACTIONS(2266),
    [anon_sym_DASH_GT] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_This] = ACTIONS(2264),
    [anon_sym_final] = ACTIONS(2264),
    [anon_sym_override] = ACTIONS(2264),
    [anon_sym_GT2] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2264),
    [anon_sym_where] = ACTIONS(2264),
  },
  [3306] = {
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2302),
    [anon_sym_COMMA] = ACTIONS(2302),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2302),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2302),
    [anon_sym_PIPE_PIPE] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_PIPE] = ACTIONS(2300),
    [anon_sym_CARET] = ACTIONS(2302),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_EQ_EQ] = ACTIONS(2302),
    [anon_sym_BANG_EQ] = ACTIONS(2302),
    [anon_sym_GT] = ACTIONS(2300),
    [anon_sym_GT_EQ] = ACTIONS(2300),
    [anon_sym_LT_EQ] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_LT_LT] = ACTIONS(2302),
    [anon_sym_GT_GT] = ACTIONS(2300),
    [anon_sym_COLON] = ACTIONS(2300),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym___attribute] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_LBRACK] = ACTIONS(2302),
    [anon_sym_EQ] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym__Nonnull] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [anon_sym_QMARK] = ACTIONS(2302),
    [anon_sym_LT_EQ_GT] = ACTIONS(2302),
    [anon_sym_or] = ACTIONS(2300),
    [anon_sym_and] = ACTIONS(2300),
    [anon_sym_bitor] = ACTIONS(2300),
    [anon_sym_xor] = ACTIONS(2300),
    [anon_sym_bitand] = ACTIONS(2300),
    [anon_sym_not_eq] = ACTIONS(2300),
    [anon_sym_is] = ACTIONS(2300),
    [anon_sym_as] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_DOT] = ACTIONS(2300),
    [anon_sym_DOT_STAR] = ACTIONS(2302),
    [anon_sym_DASH_GT] = ACTIONS(2302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_This] = ACTIONS(2300),
    [anon_sym_final] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_GT2] = ACTIONS(2302),
    [anon_sym_requires] = ACTIONS(2300),
    [anon_sym_where] = ACTIONS(2300),
  },
  [3307] = {
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_COMMA] = ACTIONS(2262),
    [anon_sym_LPAREN2] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2262),
    [anon_sym_SLASH] = ACTIONS(2260),
    [anon_sym_PERCENT] = ACTIONS(2262),
    [anon_sym_PIPE_PIPE] = ACTIONS(2262),
    [anon_sym_AMP_AMP] = ACTIONS(2262),
    [anon_sym_PIPE] = ACTIONS(2260),
    [anon_sym_CARET] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_EQ_EQ] = ACTIONS(2262),
    [anon_sym_BANG_EQ] = ACTIONS(2262),
    [anon_sym_GT] = ACTIONS(2260),
    [anon_sym_GT_EQ] = ACTIONS(2260),
    [anon_sym_LT_EQ] = ACTIONS(2260),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_LT_LT] = ACTIONS(2262),
    [anon_sym_GT_GT] = ACTIONS(2260),
    [anon_sym_COLON] = ACTIONS(2260),
    [anon_sym___extension__] = ACTIONS(2260),
    [anon_sym___attribute__] = ACTIONS(2260),
    [anon_sym___attribute] = ACTIONS(2260),
    [anon_sym_COLON_COLON] = ACTIONS(2262),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [anon_sym_EQ] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_constexpr] = ACTIONS(2260),
    [anon_sym_volatile] = ACTIONS(2260),
    [anon_sym_restrict] = ACTIONS(2260),
    [anon_sym___restrict__] = ACTIONS(2260),
    [anon_sym__Atomic] = ACTIONS(2260),
    [anon_sym__Noreturn] = ACTIONS(2260),
    [anon_sym_noreturn] = ACTIONS(2260),
    [anon_sym__Nonnull] = ACTIONS(2260),
    [anon_sym_mutable] = ACTIONS(2260),
    [anon_sym_constinit] = ACTIONS(2260),
    [anon_sym_consteval] = ACTIONS(2260),
    [anon_sym_alignas] = ACTIONS(2260),
    [anon_sym__Alignas] = ACTIONS(2260),
    [anon_sym_QMARK] = ACTIONS(2262),
    [anon_sym_LT_EQ_GT] = ACTIONS(2262),
    [anon_sym_or] = ACTIONS(2260),
    [anon_sym_and] = ACTIONS(2260),
    [anon_sym_bitor] = ACTIONS(2260),
    [anon_sym_xor] = ACTIONS(2260),
    [anon_sym_bitand] = ACTIONS(2260),
    [anon_sym_not_eq] = ACTIONS(2260),
    [anon_sym_is] = ACTIONS(2260),
    [anon_sym_as] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_DOT] = ACTIONS(2260),
    [anon_sym_DOT_STAR] = ACTIONS(2262),
    [anon_sym_DASH_GT] = ACTIONS(2262),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_This] = ACTIONS(2260),
    [anon_sym_final] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
    [anon_sym_GT2] = ACTIONS(2262),
    [anon_sym_requires] = ACTIONS(2260),
    [anon_sym_where] = ACTIONS(2260),
  },
  [3308] = {
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2306),
    [anon_sym_COMMA] = ACTIONS(2306),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_PERCENT] = ACTIONS(2306),
    [anon_sym_PIPE_PIPE] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_PIPE] = ACTIONS(2304),
    [anon_sym_CARET] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_EQ_EQ] = ACTIONS(2306),
    [anon_sym_BANG_EQ] = ACTIONS(2306),
    [anon_sym_GT] = ACTIONS(2304),
    [anon_sym_GT_EQ] = ACTIONS(2304),
    [anon_sym_LT_EQ] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_LT_LT] = ACTIONS(2306),
    [anon_sym_GT_GT] = ACTIONS(2304),
    [anon_sym_COLON] = ACTIONS(2304),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym___attribute] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_LBRACK] = ACTIONS(2306),
    [anon_sym_EQ] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym__Nonnull] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [anon_sym_QMARK] = ACTIONS(2306),
    [anon_sym_LT_EQ_GT] = ACTIONS(2306),
    [anon_sym_or] = ACTIONS(2304),
    [anon_sym_and] = ACTIONS(2304),
    [anon_sym_bitor] = ACTIONS(2304),
    [anon_sym_xor] = ACTIONS(2304),
    [anon_sym_bitand] = ACTIONS(2304),
    [anon_sym_not_eq] = ACTIONS(2304),
    [anon_sym_is] = ACTIONS(2304),
    [anon_sym_as] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DOT] = ACTIONS(2304),
    [anon_sym_DOT_STAR] = ACTIONS(2306),
    [anon_sym_DASH_GT] = ACTIONS(2306),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_This] = ACTIONS(2304),
    [anon_sym_final] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_GT2] = ACTIONS(2306),
    [anon_sym_requires] = ACTIONS(2304),
    [anon_sym_where] = ACTIONS(2304),
  },
  [3309] = {
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2310),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_LPAREN2] = ACTIONS(2310),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_SLASH] = ACTIONS(2308),
    [anon_sym_PERCENT] = ACTIONS(2310),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_PIPE] = ACTIONS(2308),
    [anon_sym_CARET] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_EQ_EQ] = ACTIONS(2310),
    [anon_sym_BANG_EQ] = ACTIONS(2310),
    [anon_sym_GT] = ACTIONS(2308),
    [anon_sym_GT_EQ] = ACTIONS(2308),
    [anon_sym_LT_EQ] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_LT_LT] = ACTIONS(2310),
    [anon_sym_GT_GT] = ACTIONS(2308),
    [anon_sym_COLON] = ACTIONS(2308),
    [anon_sym___extension__] = ACTIONS(2308),
    [anon_sym___attribute__] = ACTIONS(2308),
    [anon_sym___attribute] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_LBRACK] = ACTIONS(2310),
    [anon_sym_EQ] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_constexpr] = ACTIONS(2308),
    [anon_sym_volatile] = ACTIONS(2308),
    [anon_sym_restrict] = ACTIONS(2308),
    [anon_sym___restrict__] = ACTIONS(2308),
    [anon_sym__Atomic] = ACTIONS(2308),
    [anon_sym__Noreturn] = ACTIONS(2308),
    [anon_sym_noreturn] = ACTIONS(2308),
    [anon_sym__Nonnull] = ACTIONS(2308),
    [anon_sym_mutable] = ACTIONS(2308),
    [anon_sym_constinit] = ACTIONS(2308),
    [anon_sym_consteval] = ACTIONS(2308),
    [anon_sym_alignas] = ACTIONS(2308),
    [anon_sym__Alignas] = ACTIONS(2308),
    [anon_sym_QMARK] = ACTIONS(2310),
    [anon_sym_LT_EQ_GT] = ACTIONS(2310),
    [anon_sym_or] = ACTIONS(2308),
    [anon_sym_and] = ACTIONS(2308),
    [anon_sym_bitor] = ACTIONS(2308),
    [anon_sym_xor] = ACTIONS(2308),
    [anon_sym_bitand] = ACTIONS(2308),
    [anon_sym_not_eq] = ACTIONS(2308),
    [anon_sym_is] = ACTIONS(2308),
    [anon_sym_as] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_DOT] = ACTIONS(2308),
    [anon_sym_DOT_STAR] = ACTIONS(2310),
    [anon_sym_DASH_GT] = ACTIONS(2310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_This] = ACTIONS(2308),
    [anon_sym_final] = ACTIONS(2308),
    [anon_sym_override] = ACTIONS(2308),
    [anon_sym_GT2] = ACTIONS(2310),
    [anon_sym_requires] = ACTIONS(2308),
    [anon_sym_where] = ACTIONS(2308),
  },
  [3310] = {
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2314),
    [anon_sym_COMMA] = ACTIONS(2314),
    [anon_sym_LPAREN2] = ACTIONS(2314),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_SLASH] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2314),
    [anon_sym_PIPE_PIPE] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2314),
    [anon_sym_PIPE] = ACTIONS(2312),
    [anon_sym_CARET] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_EQ_EQ] = ACTIONS(2314),
    [anon_sym_BANG_EQ] = ACTIONS(2314),
    [anon_sym_GT] = ACTIONS(2312),
    [anon_sym_GT_EQ] = ACTIONS(2312),
    [anon_sym_LT_EQ] = ACTIONS(2312),
    [anon_sym_LT] = ACTIONS(2312),
    [anon_sym_LT_LT] = ACTIONS(2314),
    [anon_sym_GT_GT] = ACTIONS(2312),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym___extension__] = ACTIONS(2312),
    [anon_sym___attribute__] = ACTIONS(2312),
    [anon_sym___attribute] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_LBRACK] = ACTIONS(2314),
    [anon_sym_EQ] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_constexpr] = ACTIONS(2312),
    [anon_sym_volatile] = ACTIONS(2312),
    [anon_sym_restrict] = ACTIONS(2312),
    [anon_sym___restrict__] = ACTIONS(2312),
    [anon_sym__Atomic] = ACTIONS(2312),
    [anon_sym__Noreturn] = ACTIONS(2312),
    [anon_sym_noreturn] = ACTIONS(2312),
    [anon_sym__Nonnull] = ACTIONS(2312),
    [anon_sym_mutable] = ACTIONS(2312),
    [anon_sym_constinit] = ACTIONS(2312),
    [anon_sym_consteval] = ACTIONS(2312),
    [anon_sym_alignas] = ACTIONS(2312),
    [anon_sym__Alignas] = ACTIONS(2312),
    [anon_sym_QMARK] = ACTIONS(2314),
    [anon_sym_LT_EQ_GT] = ACTIONS(2314),
    [anon_sym_or] = ACTIONS(2312),
    [anon_sym_and] = ACTIONS(2312),
    [anon_sym_bitor] = ACTIONS(2312),
    [anon_sym_xor] = ACTIONS(2312),
    [anon_sym_bitand] = ACTIONS(2312),
    [anon_sym_not_eq] = ACTIONS(2312),
    [anon_sym_is] = ACTIONS(2312),
    [anon_sym_as] = ACTIONS(2312),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_DOT] = ACTIONS(2312),
    [anon_sym_DOT_STAR] = ACTIONS(2314),
    [anon_sym_DASH_GT] = ACTIONS(2314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_This] = ACTIONS(2312),
    [anon_sym_final] = ACTIONS(2312),
    [anon_sym_override] = ACTIONS(2312),
    [anon_sym_GT2] = ACTIONS(2314),
    [anon_sym_requires] = ACTIONS(2312),
    [anon_sym_where] = ACTIONS(2312),
  },
  [3311] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3314),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2881),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2883),
    [anon_sym_SLASH] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_CARET] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_EQ_EQ] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_GT_EQ] = ACTIONS(2881),
    [anon_sym_LT_EQ] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_LT_LT] = ACTIONS(2883),
    [anon_sym_GT_GT] = ACTIONS(2883),
    [anon_sym_COLON] = ACTIONS(2881),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym___attribute__] = ACTIONS(2881),
    [anon_sym___attribute] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_RBRACE] = ACTIONS(2881),
    [anon_sym_signed] = ACTIONS(7630),
    [anon_sym_unsigned] = ACTIONS(7630),
    [anon_sym_long] = ACTIONS(7630),
    [anon_sym_short] = ACTIONS(7630),
    [anon_sym_LBRACK] = ACTIONS(2881),
    [anon_sym_RBRACK] = ACTIONS(2881),
    [anon_sym_EQ] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_STAR_EQ] = ACTIONS(2881),
    [anon_sym_SLASH_EQ] = ACTIONS(2881),
    [anon_sym_PERCENT_EQ] = ACTIONS(2881),
    [anon_sym_PLUS_EQ] = ACTIONS(2881),
    [anon_sym_DASH_EQ] = ACTIONS(2881),
    [anon_sym_LT_LT_EQ] = ACTIONS(2881),
    [anon_sym_GT_GT_EQ] = ACTIONS(2881),
    [anon_sym_AMP_EQ] = ACTIONS(2881),
    [anon_sym_CARET_EQ] = ACTIONS(2881),
    [anon_sym_PIPE_EQ] = ACTIONS(2881),
    [anon_sym_and_eq] = ACTIONS(2881),
    [anon_sym_or_eq] = ACTIONS(2881),
    [anon_sym_xor_eq] = ACTIONS(2881),
    [anon_sym_LT_EQ_GT] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2883),
    [anon_sym_and] = ACTIONS(2883),
    [anon_sym_bitor] = ACTIONS(2881),
    [anon_sym_xor] = ACTIONS(2883),
    [anon_sym_bitand] = ACTIONS(2881),
    [anon_sym_not_eq] = ACTIONS(2881),
    [anon_sym_is] = ACTIONS(2881),
    [anon_sym_as] = ACTIONS(2881),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_DOT_STAR] = ACTIONS(2881),
    [anon_sym_DASH_GT] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2881),
    [anon_sym_let] = ACTIONS(2881),
    [anon_sym_This] = ACTIONS(2881),
  },
  [3312] = {
    [sym_identifier] = ACTIONS(7691),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7693),
    [anon_sym_COMMA] = ACTIONS(7693),
    [anon_sym_RPAREN] = ACTIONS(7693),
    [aux_sym_preproc_if_token2] = ACTIONS(7693),
    [aux_sym_preproc_else_token1] = ACTIONS(7693),
    [aux_sym_preproc_elif_token1] = ACTIONS(7691),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7693),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7693),
    [anon_sym_LPAREN2] = ACTIONS(7693),
    [anon_sym_DASH] = ACTIONS(7691),
    [anon_sym_PLUS] = ACTIONS(7691),
    [anon_sym_STAR] = ACTIONS(7691),
    [anon_sym_SLASH] = ACTIONS(7691),
    [anon_sym_PERCENT] = ACTIONS(7691),
    [anon_sym_PIPE_PIPE] = ACTIONS(7693),
    [anon_sym_AMP_AMP] = ACTIONS(7693),
    [anon_sym_PIPE] = ACTIONS(7691),
    [anon_sym_CARET] = ACTIONS(7691),
    [anon_sym_AMP] = ACTIONS(7691),
    [anon_sym_EQ_EQ] = ACTIONS(7693),
    [anon_sym_BANG_EQ] = ACTIONS(7693),
    [anon_sym_GT] = ACTIONS(7691),
    [anon_sym_GT_EQ] = ACTIONS(7693),
    [anon_sym_LT_EQ] = ACTIONS(7691),
    [anon_sym_LT] = ACTIONS(7691),
    [anon_sym_LT_LT] = ACTIONS(7691),
    [anon_sym_GT_GT] = ACTIONS(7691),
    [anon_sym_COLON] = ACTIONS(7693),
    [anon_sym_SEMI] = ACTIONS(7693),
    [anon_sym___attribute__] = ACTIONS(7691),
    [anon_sym___attribute] = ACTIONS(7691),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7693),
    [anon_sym_LBRACE] = ACTIONS(7693),
    [anon_sym_RBRACE] = ACTIONS(7693),
    [anon_sym_LBRACK] = ACTIONS(7691),
    [anon_sym_RBRACK] = ACTIONS(7693),
    [anon_sym_EQ] = ACTIONS(7691),
    [anon_sym_QMARK] = ACTIONS(7693),
    [anon_sym_STAR_EQ] = ACTIONS(7693),
    [anon_sym_SLASH_EQ] = ACTIONS(7693),
    [anon_sym_PERCENT_EQ] = ACTIONS(7693),
    [anon_sym_PLUS_EQ] = ACTIONS(7693),
    [anon_sym_DASH_EQ] = ACTIONS(7693),
    [anon_sym_LT_LT_EQ] = ACTIONS(7693),
    [anon_sym_GT_GT_EQ] = ACTIONS(7693),
    [anon_sym_AMP_EQ] = ACTIONS(7693),
    [anon_sym_CARET_EQ] = ACTIONS(7693),
    [anon_sym_PIPE_EQ] = ACTIONS(7693),
    [anon_sym_and_eq] = ACTIONS(7691),
    [anon_sym_or_eq] = ACTIONS(7691),
    [anon_sym_xor_eq] = ACTIONS(7691),
    [anon_sym_LT_EQ_GT] = ACTIONS(7693),
    [anon_sym_or] = ACTIONS(7691),
    [anon_sym_and] = ACTIONS(7691),
    [anon_sym_bitor] = ACTIONS(7691),
    [anon_sym_xor] = ACTIONS(7691),
    [anon_sym_bitand] = ACTIONS(7691),
    [anon_sym_not_eq] = ACTIONS(7691),
    [anon_sym_is] = ACTIONS(7691),
    [anon_sym_as] = ACTIONS(7691),
    [anon_sym_DASH_DASH] = ACTIONS(7693),
    [anon_sym_PLUS_PLUS] = ACTIONS(7693),
    [anon_sym_DOT] = ACTIONS(7691),
    [anon_sym_DOT_STAR] = ACTIONS(7693),
    [anon_sym_DASH_GT] = ACTIONS(7693),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(7691),
  },
  [3313] = {
    [sym_argument_list] = STATE(3420),
    [sym_initializer_list] = STATE(3420),
    [sym_identifier] = ACTIONS(7695),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7697),
    [anon_sym_COMMA] = ACTIONS(7697),
    [anon_sym_RPAREN] = ACTIONS(7697),
    [aux_sym_preproc_if_token2] = ACTIONS(7697),
    [aux_sym_preproc_else_token1] = ACTIONS(7697),
    [aux_sym_preproc_elif_token1] = ACTIONS(7695),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7697),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7697),
    [anon_sym_LPAREN2] = ACTIONS(7358),
    [anon_sym_DASH] = ACTIONS(7695),
    [anon_sym_PLUS] = ACTIONS(7695),
    [anon_sym_STAR] = ACTIONS(7695),
    [anon_sym_SLASH] = ACTIONS(7695),
    [anon_sym_PERCENT] = ACTIONS(7695),
    [anon_sym_PIPE_PIPE] = ACTIONS(7697),
    [anon_sym_AMP_AMP] = ACTIONS(7697),
    [anon_sym_PIPE] = ACTIONS(7695),
    [anon_sym_CARET] = ACTIONS(7695),
    [anon_sym_AMP] = ACTIONS(7695),
    [anon_sym_EQ_EQ] = ACTIONS(7697),
    [anon_sym_BANG_EQ] = ACTIONS(7697),
    [anon_sym_GT] = ACTIONS(7695),
    [anon_sym_GT_EQ] = ACTIONS(7697),
    [anon_sym_LT_EQ] = ACTIONS(7695),
    [anon_sym_LT] = ACTIONS(7695),
    [anon_sym_LT_LT] = ACTIONS(7695),
    [anon_sym_GT_GT] = ACTIONS(7695),
    [anon_sym_COLON] = ACTIONS(7697),
    [anon_sym_SEMI] = ACTIONS(7697),
    [anon_sym___attribute__] = ACTIONS(7695),
    [anon_sym___attribute] = ACTIONS(7695),
    [anon_sym_LBRACE] = ACTIONS(4964),
    [anon_sym_RBRACE] = ACTIONS(7697),
    [anon_sym_LBRACK] = ACTIONS(7697),
    [anon_sym_RBRACK] = ACTIONS(7697),
    [anon_sym_EQ] = ACTIONS(7695),
    [anon_sym_QMARK] = ACTIONS(7697),
    [anon_sym_STAR_EQ] = ACTIONS(7697),
    [anon_sym_SLASH_EQ] = ACTIONS(7697),
    [anon_sym_PERCENT_EQ] = ACTIONS(7697),
    [anon_sym_PLUS_EQ] = ACTIONS(7697),
    [anon_sym_DASH_EQ] = ACTIONS(7697),
    [anon_sym_LT_LT_EQ] = ACTIONS(7697),
    [anon_sym_GT_GT_EQ] = ACTIONS(7697),
    [anon_sym_AMP_EQ] = ACTIONS(7697),
    [anon_sym_CARET_EQ] = ACTIONS(7697),
    [anon_sym_PIPE_EQ] = ACTIONS(7697),
    [anon_sym_and_eq] = ACTIONS(7695),
    [anon_sym_or_eq] = ACTIONS(7695),
    [anon_sym_xor_eq] = ACTIONS(7695),
    [anon_sym_LT_EQ_GT] = ACTIONS(7697),
    [anon_sym_or] = ACTIONS(7695),
    [anon_sym_and] = ACTIONS(7695),
    [anon_sym_bitor] = ACTIONS(7695),
    [anon_sym_xor] = ACTIONS(7695),
    [anon_sym_bitand] = ACTIONS(7695),
    [anon_sym_not_eq] = ACTIONS(7695),
    [anon_sym_is] = ACTIONS(7695),
    [anon_sym_as] = ACTIONS(7695),
    [anon_sym_DASH_DASH] = ACTIONS(7697),
    [anon_sym_PLUS_PLUS] = ACTIONS(7697),
    [anon_sym_DOT] = ACTIONS(7695),
    [anon_sym_DOT_STAR] = ACTIONS(7697),
    [anon_sym_DASH_GT] = ACTIONS(7697),
    [sym_comment] = ACTIONS(3),
  },
  [3314] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4080),
    [anon_sym_RPAREN] = ACTIONS(4080),
    [anon_sym_LPAREN2] = ACTIONS(4080),
    [anon_sym_DASH] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(4078),
    [anon_sym_STAR] = ACTIONS(4078),
    [anon_sym_SLASH] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [anon_sym_PIPE_PIPE] = ACTIONS(4080),
    [anon_sym_AMP_AMP] = ACTIONS(4080),
    [anon_sym_PIPE] = ACTIONS(4078),
    [anon_sym_CARET] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(4078),
    [anon_sym_EQ_EQ] = ACTIONS(4080),
    [anon_sym_BANG_EQ] = ACTIONS(4080),
    [anon_sym_GT] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4080),
    [anon_sym_LT_EQ] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_LT_LT] = ACTIONS(4078),
    [anon_sym_GT_GT] = ACTIONS(4078),
    [anon_sym_COLON] = ACTIONS(4080),
    [anon_sym_SEMI] = ACTIONS(4080),
    [anon_sym___attribute__] = ACTIONS(4080),
    [anon_sym___attribute] = ACTIONS(4078),
    [anon_sym_LBRACE] = ACTIONS(4080),
    [anon_sym_RBRACE] = ACTIONS(4080),
    [anon_sym_signed] = ACTIONS(7604),
    [anon_sym_unsigned] = ACTIONS(7604),
    [anon_sym_long] = ACTIONS(7604),
    [anon_sym_short] = ACTIONS(7604),
    [anon_sym_LBRACK] = ACTIONS(4080),
    [anon_sym_RBRACK] = ACTIONS(4080),
    [anon_sym_EQ] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(4080),
    [anon_sym_STAR_EQ] = ACTIONS(4080),
    [anon_sym_SLASH_EQ] = ACTIONS(4080),
    [anon_sym_PERCENT_EQ] = ACTIONS(4080),
    [anon_sym_PLUS_EQ] = ACTIONS(4080),
    [anon_sym_DASH_EQ] = ACTIONS(4080),
    [anon_sym_LT_LT_EQ] = ACTIONS(4080),
    [anon_sym_GT_GT_EQ] = ACTIONS(4080),
    [anon_sym_AMP_EQ] = ACTIONS(4080),
    [anon_sym_CARET_EQ] = ACTIONS(4080),
    [anon_sym_PIPE_EQ] = ACTIONS(4080),
    [anon_sym_and_eq] = ACTIONS(4080),
    [anon_sym_or_eq] = ACTIONS(4080),
    [anon_sym_xor_eq] = ACTIONS(4080),
    [anon_sym_LT_EQ_GT] = ACTIONS(4080),
    [anon_sym_or] = ACTIONS(4078),
    [anon_sym_and] = ACTIONS(4078),
    [anon_sym_bitor] = ACTIONS(4080),
    [anon_sym_xor] = ACTIONS(4078),
    [anon_sym_bitand] = ACTIONS(4080),
    [anon_sym_not_eq] = ACTIONS(4080),
    [anon_sym_is] = ACTIONS(4080),
    [anon_sym_as] = ACTIONS(4080),
    [anon_sym_DASH_DASH] = ACTIONS(4080),
    [anon_sym_PLUS_PLUS] = ACTIONS(4080),
    [anon_sym_DOT] = ACTIONS(4078),
    [anon_sym_DOT_STAR] = ACTIONS(4080),
    [anon_sym_DASH_GT] = ACTIONS(4080),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4080),
    [anon_sym_let] = ACTIONS(4080),
    [anon_sym_This] = ACTIONS(4080),
  },
  [3315] = {
    [sym_identifier] = ACTIONS(7699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7701),
    [anon_sym_COMMA] = ACTIONS(7701),
    [anon_sym_RPAREN] = ACTIONS(7701),
    [aux_sym_preproc_if_token2] = ACTIONS(7701),
    [aux_sym_preproc_else_token1] = ACTIONS(7701),
    [aux_sym_preproc_elif_token1] = ACTIONS(7699),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7701),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7701),
    [anon_sym_LPAREN2] = ACTIONS(7701),
    [anon_sym_DASH] = ACTIONS(7699),
    [anon_sym_PLUS] = ACTIONS(7699),
    [anon_sym_STAR] = ACTIONS(7699),
    [anon_sym_SLASH] = ACTIONS(7699),
    [anon_sym_PERCENT] = ACTIONS(7699),
    [anon_sym_PIPE_PIPE] = ACTIONS(7701),
    [anon_sym_AMP_AMP] = ACTIONS(7701),
    [anon_sym_PIPE] = ACTIONS(7699),
    [anon_sym_CARET] = ACTIONS(7699),
    [anon_sym_AMP] = ACTIONS(7699),
    [anon_sym_EQ_EQ] = ACTIONS(7701),
    [anon_sym_BANG_EQ] = ACTIONS(7701),
    [anon_sym_GT] = ACTIONS(7699),
    [anon_sym_GT_EQ] = ACTIONS(7701),
    [anon_sym_LT_EQ] = ACTIONS(7699),
    [anon_sym_LT] = ACTIONS(7699),
    [anon_sym_LT_LT] = ACTIONS(7699),
    [anon_sym_GT_GT] = ACTIONS(7699),
    [anon_sym_COLON] = ACTIONS(7701),
    [anon_sym_SEMI] = ACTIONS(7701),
    [anon_sym___attribute__] = ACTIONS(7699),
    [anon_sym___attribute] = ACTIONS(7699),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7701),
    [anon_sym_LBRACE] = ACTIONS(7701),
    [anon_sym_RBRACE] = ACTIONS(7701),
    [anon_sym_LBRACK] = ACTIONS(7699),
    [anon_sym_RBRACK] = ACTIONS(7701),
    [anon_sym_EQ] = ACTIONS(7699),
    [anon_sym_QMARK] = ACTIONS(7701),
    [anon_sym_STAR_EQ] = ACTIONS(7701),
    [anon_sym_SLASH_EQ] = ACTIONS(7701),
    [anon_sym_PERCENT_EQ] = ACTIONS(7701),
    [anon_sym_PLUS_EQ] = ACTIONS(7701),
    [anon_sym_DASH_EQ] = ACTIONS(7701),
    [anon_sym_LT_LT_EQ] = ACTIONS(7701),
    [anon_sym_GT_GT_EQ] = ACTIONS(7701),
    [anon_sym_AMP_EQ] = ACTIONS(7701),
    [anon_sym_CARET_EQ] = ACTIONS(7701),
    [anon_sym_PIPE_EQ] = ACTIONS(7701),
    [anon_sym_and_eq] = ACTIONS(7699),
    [anon_sym_or_eq] = ACTIONS(7699),
    [anon_sym_xor_eq] = ACTIONS(7699),
    [anon_sym_LT_EQ_GT] = ACTIONS(7701),
    [anon_sym_or] = ACTIONS(7699),
    [anon_sym_and] = ACTIONS(7699),
    [anon_sym_bitor] = ACTIONS(7699),
    [anon_sym_xor] = ACTIONS(7699),
    [anon_sym_bitand] = ACTIONS(7699),
    [anon_sym_not_eq] = ACTIONS(7699),
    [anon_sym_is] = ACTIONS(7699),
    [anon_sym_as] = ACTIONS(7699),
    [anon_sym_DASH_DASH] = ACTIONS(7701),
    [anon_sym_PLUS_PLUS] = ACTIONS(7701),
    [anon_sym_DOT] = ACTIONS(7699),
    [anon_sym_DOT_STAR] = ACTIONS(7701),
    [anon_sym_DASH_GT] = ACTIONS(7701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(7699),
  },
  [3316] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4095),
    [anon_sym_COMMA] = ACTIONS(4095),
    [anon_sym_RPAREN] = ACTIONS(4095),
    [anon_sym_LPAREN2] = ACTIONS(4095),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4093),
    [anon_sym_SLASH] = ACTIONS(4093),
    [anon_sym_PERCENT] = ACTIONS(4093),
    [anon_sym_PIPE_PIPE] = ACTIONS(4095),
    [anon_sym_AMP_AMP] = ACTIONS(4095),
    [anon_sym_PIPE] = ACTIONS(4093),
    [anon_sym_CARET] = ACTIONS(4093),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_EQ_EQ] = ACTIONS(4095),
    [anon_sym_BANG_EQ] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_GT_EQ] = ACTIONS(4095),
    [anon_sym_LT_EQ] = ACTIONS(4093),
    [anon_sym_LT] = ACTIONS(4093),
    [anon_sym_LT_LT] = ACTIONS(4093),
    [anon_sym_GT_GT] = ACTIONS(4093),
    [anon_sym_COLON] = ACTIONS(4095),
    [anon_sym_SEMI] = ACTIONS(4095),
    [anon_sym___attribute__] = ACTIONS(4095),
    [anon_sym___attribute] = ACTIONS(4093),
    [anon_sym_LBRACE] = ACTIONS(4095),
    [anon_sym_RBRACE] = ACTIONS(4095),
    [anon_sym_signed] = ACTIONS(7604),
    [anon_sym_unsigned] = ACTIONS(7604),
    [anon_sym_long] = ACTIONS(7604),
    [anon_sym_short] = ACTIONS(7604),
    [anon_sym_LBRACK] = ACTIONS(4095),
    [anon_sym_RBRACK] = ACTIONS(4095),
    [anon_sym_EQ] = ACTIONS(4093),
    [anon_sym_QMARK] = ACTIONS(4095),
    [anon_sym_STAR_EQ] = ACTIONS(4095),
    [anon_sym_SLASH_EQ] = ACTIONS(4095),
    [anon_sym_PERCENT_EQ] = ACTIONS(4095),
    [anon_sym_PLUS_EQ] = ACTIONS(4095),
    [anon_sym_DASH_EQ] = ACTIONS(4095),
    [anon_sym_LT_LT_EQ] = ACTIONS(4095),
    [anon_sym_GT_GT_EQ] = ACTIONS(4095),
    [anon_sym_AMP_EQ] = ACTIONS(4095),
    [anon_sym_CARET_EQ] = ACTIONS(4095),
    [anon_sym_PIPE_EQ] = ACTIONS(4095),
    [anon_sym_and_eq] = ACTIONS(4095),
    [anon_sym_or_eq] = ACTIONS(4095),
    [anon_sym_xor_eq] = ACTIONS(4095),
    [anon_sym_LT_EQ_GT] = ACTIONS(4095),
    [anon_sym_or] = ACTIONS(4093),
    [anon_sym_and] = ACTIONS(4093),
    [anon_sym_bitor] = ACTIONS(4095),
    [anon_sym_xor] = ACTIONS(4093),
    [anon_sym_bitand] = ACTIONS(4095),
    [anon_sym_not_eq] = ACTIONS(4095),
    [anon_sym_is] = ACTIONS(4095),
    [anon_sym_as] = ACTIONS(4095),
    [anon_sym_DASH_DASH] = ACTIONS(4095),
    [anon_sym_PLUS_PLUS] = ACTIONS(4095),
    [anon_sym_DOT] = ACTIONS(4093),
    [anon_sym_DOT_STAR] = ACTIONS(4095),
    [anon_sym_DASH_GT] = ACTIONS(4095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4095),
    [anon_sym_let] = ACTIONS(4095),
    [anon_sym_This] = ACTIONS(4095),
  },
  [3317] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3262),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4113),
    [anon_sym_COMMA] = ACTIONS(4113),
    [anon_sym_RPAREN] = ACTIONS(4113),
    [anon_sym_LPAREN2] = ACTIONS(4113),
    [anon_sym_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4111),
    [anon_sym_STAR] = ACTIONS(4111),
    [anon_sym_SLASH] = ACTIONS(4111),
    [anon_sym_PERCENT] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4111),
    [anon_sym_CARET] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4111),
    [anon_sym_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4111),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_COLON] = ACTIONS(4113),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym___attribute__] = ACTIONS(4113),
    [anon_sym___attribute] = ACTIONS(4111),
    [anon_sym_LBRACE] = ACTIONS(4113),
    [anon_sym_RBRACE] = ACTIONS(4113),
    [anon_sym_signed] = ACTIONS(7703),
    [anon_sym_unsigned] = ACTIONS(7703),
    [anon_sym_long] = ACTIONS(7703),
    [anon_sym_short] = ACTIONS(7703),
    [anon_sym_LBRACK] = ACTIONS(4113),
    [anon_sym_RBRACK] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4111),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_STAR_EQ] = ACTIONS(4113),
    [anon_sym_SLASH_EQ] = ACTIONS(4113),
    [anon_sym_PERCENT_EQ] = ACTIONS(4113),
    [anon_sym_PLUS_EQ] = ACTIONS(4113),
    [anon_sym_DASH_EQ] = ACTIONS(4113),
    [anon_sym_LT_LT_EQ] = ACTIONS(4113),
    [anon_sym_GT_GT_EQ] = ACTIONS(4113),
    [anon_sym_AMP_EQ] = ACTIONS(4113),
    [anon_sym_CARET_EQ] = ACTIONS(4113),
    [anon_sym_PIPE_EQ] = ACTIONS(4113),
    [anon_sym_and_eq] = ACTIONS(4113),
    [anon_sym_or_eq] = ACTIONS(4113),
    [anon_sym_xor_eq] = ACTIONS(4113),
    [anon_sym_LT_EQ_GT] = ACTIONS(4113),
    [anon_sym_or] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4111),
    [anon_sym_bitor] = ACTIONS(4113),
    [anon_sym_xor] = ACTIONS(4111),
    [anon_sym_bitand] = ACTIONS(4113),
    [anon_sym_not_eq] = ACTIONS(4113),
    [anon_sym_is] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4113),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(4111),
    [anon_sym_DOT_STAR] = ACTIONS(4113),
    [anon_sym_DASH_GT] = ACTIONS(4113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_This] = ACTIONS(4113),
  },
  [3318] = {
    [sym_string_literal] = STATE(3527),
    [sym_template_argument_list] = STATE(4695),
    [sym_raw_string_literal] = STATE(3527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(6839),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_RBRACK] = ACTIONS(2170),
    [anon_sym_EQ] = ACTIONS(7530),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(7532),
    [anon_sym_SLASH_EQ] = ACTIONS(7532),
    [anon_sym_PERCENT_EQ] = ACTIONS(7532),
    [anon_sym_PLUS_EQ] = ACTIONS(7532),
    [anon_sym_DASH_EQ] = ACTIONS(7532),
    [anon_sym_LT_LT_EQ] = ACTIONS(7532),
    [anon_sym_GT_GT_EQ] = ACTIONS(7532),
    [anon_sym_AMP_EQ] = ACTIONS(7532),
    [anon_sym_CARET_EQ] = ACTIONS(7532),
    [anon_sym_PIPE_EQ] = ACTIONS(7532),
    [anon_sym_and_eq] = ACTIONS(7532),
    [anon_sym_or_eq] = ACTIONS(7532),
    [anon_sym_xor_eq] = ACTIONS(7532),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2170),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2170),
    [anon_sym_not_eq] = ACTIONS(2170),
    [anon_sym_is] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [anon_sym_L_DQUOTE] = ACTIONS(2209),
    [anon_sym_u_DQUOTE] = ACTIONS(2209),
    [anon_sym_U_DQUOTE] = ACTIONS(2209),
    [anon_sym_u8_DQUOTE] = ACTIONS(2209),
    [anon_sym_DQUOTE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2211),
    [anon_sym_LR_DQUOTE] = ACTIONS(2211),
    [anon_sym_uR_DQUOTE] = ACTIONS(2211),
    [anon_sym_UR_DQUOTE] = ACTIONS(2211),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2211),
  },
  [3319] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4051),
    [anon_sym_COMMA] = ACTIONS(4051),
    [anon_sym_RPAREN] = ACTIONS(4051),
    [anon_sym_LPAREN2] = ACTIONS(4051),
    [anon_sym_DASH] = ACTIONS(4053),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_STAR] = ACTIONS(4053),
    [anon_sym_SLASH] = ACTIONS(4053),
    [anon_sym_PERCENT] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4051),
    [anon_sym_AMP_AMP] = ACTIONS(4051),
    [anon_sym_PIPE] = ACTIONS(4053),
    [anon_sym_CARET] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4053),
    [anon_sym_EQ_EQ] = ACTIONS(4051),
    [anon_sym_BANG_EQ] = ACTIONS(4051),
    [anon_sym_GT] = ACTIONS(4053),
    [anon_sym_GT_EQ] = ACTIONS(4051),
    [anon_sym_LT_EQ] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4053),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_COLON] = ACTIONS(4051),
    [anon_sym_SEMI] = ACTIONS(4051),
    [anon_sym___attribute__] = ACTIONS(4051),
    [anon_sym___attribute] = ACTIONS(4053),
    [anon_sym_LBRACE] = ACTIONS(4051),
    [anon_sym_RBRACE] = ACTIONS(4051),
    [anon_sym_signed] = ACTIONS(7705),
    [anon_sym_unsigned] = ACTIONS(7705),
    [anon_sym_long] = ACTIONS(7705),
    [anon_sym_short] = ACTIONS(7705),
    [anon_sym_LBRACK] = ACTIONS(4051),
    [anon_sym_RBRACK] = ACTIONS(4051),
    [anon_sym_EQ] = ACTIONS(4053),
    [anon_sym_QMARK] = ACTIONS(4051),
    [anon_sym_STAR_EQ] = ACTIONS(4051),
    [anon_sym_SLASH_EQ] = ACTIONS(4051),
    [anon_sym_PERCENT_EQ] = ACTIONS(4051),
    [anon_sym_PLUS_EQ] = ACTIONS(4051),
    [anon_sym_DASH_EQ] = ACTIONS(4051),
    [anon_sym_LT_LT_EQ] = ACTIONS(4051),
    [anon_sym_GT_GT_EQ] = ACTIONS(4051),
    [anon_sym_AMP_EQ] = ACTIONS(4051),
    [anon_sym_CARET_EQ] = ACTIONS(4051),
    [anon_sym_PIPE_EQ] = ACTIONS(4051),
    [anon_sym_and_eq] = ACTIONS(4051),
    [anon_sym_or_eq] = ACTIONS(4051),
    [anon_sym_xor_eq] = ACTIONS(4051),
    [anon_sym_LT_EQ_GT] = ACTIONS(4051),
    [anon_sym_or] = ACTIONS(4053),
    [anon_sym_and] = ACTIONS(4053),
    [anon_sym_bitor] = ACTIONS(4051),
    [anon_sym_xor] = ACTIONS(4053),
    [anon_sym_bitand] = ACTIONS(4051),
    [anon_sym_not_eq] = ACTIONS(4051),
    [anon_sym_is] = ACTIONS(4051),
    [anon_sym_as] = ACTIONS(4051),
    [anon_sym_DASH_DASH] = ACTIONS(4051),
    [anon_sym_PLUS_PLUS] = ACTIONS(4051),
    [anon_sym_DOT] = ACTIONS(4053),
    [anon_sym_DOT_STAR] = ACTIONS(4051),
    [anon_sym_DASH_GT] = ACTIONS(4051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4051),
    [anon_sym_let] = ACTIONS(4051),
    [anon_sym_This] = ACTIONS(4051),
  },
  [3320] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7160),
    [anon_sym_COMMA] = ACTIONS(7160),
    [anon_sym_RPAREN] = ACTIONS(7160),
    [anon_sym_LPAREN2] = ACTIONS(7160),
    [anon_sym_DASH] = ACTIONS(7158),
    [anon_sym_PLUS] = ACTIONS(7158),
    [anon_sym_STAR] = ACTIONS(7158),
    [anon_sym_SLASH] = ACTIONS(7158),
    [anon_sym_PERCENT] = ACTIONS(7158),
    [anon_sym_PIPE_PIPE] = ACTIONS(7160),
    [anon_sym_AMP_AMP] = ACTIONS(7160),
    [anon_sym_PIPE] = ACTIONS(7158),
    [anon_sym_CARET] = ACTIONS(7158),
    [anon_sym_AMP] = ACTIONS(7158),
    [anon_sym_EQ_EQ] = ACTIONS(7160),
    [anon_sym_BANG_EQ] = ACTIONS(7160),
    [anon_sym_GT] = ACTIONS(7158),
    [anon_sym_GT_EQ] = ACTIONS(7160),
    [anon_sym_LT_EQ] = ACTIONS(7158),
    [anon_sym_LT] = ACTIONS(7158),
    [anon_sym_LT_LT] = ACTIONS(7158),
    [anon_sym_GT_GT] = ACTIONS(7158),
    [anon_sym_COLON] = ACTIONS(7160),
    [anon_sym_SEMI] = ACTIONS(7160),
    [anon_sym_RBRACE] = ACTIONS(7160),
    [anon_sym_LBRACK] = ACTIONS(7160),
    [anon_sym_RBRACK] = ACTIONS(7160),
    [anon_sym_EQ] = ACTIONS(7158),
    [anon_sym_QMARK] = ACTIONS(7160),
    [anon_sym_STAR_EQ] = ACTIONS(7160),
    [anon_sym_SLASH_EQ] = ACTIONS(7160),
    [anon_sym_PERCENT_EQ] = ACTIONS(7160),
    [anon_sym_PLUS_EQ] = ACTIONS(7160),
    [anon_sym_DASH_EQ] = ACTIONS(7160),
    [anon_sym_LT_LT_EQ] = ACTIONS(7160),
    [anon_sym_GT_GT_EQ] = ACTIONS(7160),
    [anon_sym_AMP_EQ] = ACTIONS(7160),
    [anon_sym_CARET_EQ] = ACTIONS(7160),
    [anon_sym_PIPE_EQ] = ACTIONS(7160),
    [anon_sym_and_eq] = ACTIONS(7158),
    [anon_sym_or_eq] = ACTIONS(7158),
    [anon_sym_xor_eq] = ACTIONS(7158),
    [anon_sym_LT_EQ_GT] = ACTIONS(7160),
    [anon_sym_or] = ACTIONS(7158),
    [anon_sym_and] = ACTIONS(7158),
    [anon_sym_bitor] = ACTIONS(7158),
    [anon_sym_xor] = ACTIONS(7158),
    [anon_sym_bitand] = ACTIONS(7158),
    [anon_sym_not_eq] = ACTIONS(7158),
    [anon_sym_is] = ACTIONS(7158),
    [anon_sym_as] = ACTIONS(7158),
    [anon_sym_DASH_DASH] = ACTIONS(7160),
    [anon_sym_PLUS_PLUS] = ACTIONS(7160),
    [anon_sym_DOT] = ACTIONS(7158),
    [anon_sym_DOT_STAR] = ACTIONS(7160),
    [anon_sym_DASH_GT] = ACTIONS(7160),
    [anon_sym_L_DQUOTE] = ACTIONS(7160),
    [anon_sym_u_DQUOTE] = ACTIONS(7160),
    [anon_sym_U_DQUOTE] = ACTIONS(7160),
    [anon_sym_u8_DQUOTE] = ACTIONS(7160),
    [anon_sym_DQUOTE] = ACTIONS(7160),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7160),
    [anon_sym_LR_DQUOTE] = ACTIONS(7160),
    [anon_sym_uR_DQUOTE] = ACTIONS(7160),
    [anon_sym_UR_DQUOTE] = ACTIONS(7160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7160),
    [sym_literal_suffix] = ACTIONS(7158),
  },
  [3321] = {
    [sym_identifier] = ACTIONS(7707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7709),
    [anon_sym_COMMA] = ACTIONS(7709),
    [anon_sym_RPAREN] = ACTIONS(7709),
    [aux_sym_preproc_if_token2] = ACTIONS(7709),
    [aux_sym_preproc_else_token1] = ACTIONS(7709),
    [aux_sym_preproc_elif_token1] = ACTIONS(7707),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7709),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7709),
    [anon_sym_LPAREN2] = ACTIONS(7709),
    [anon_sym_DASH] = ACTIONS(7707),
    [anon_sym_PLUS] = ACTIONS(7707),
    [anon_sym_STAR] = ACTIONS(7707),
    [anon_sym_SLASH] = ACTIONS(7707),
    [anon_sym_PERCENT] = ACTIONS(7707),
    [anon_sym_PIPE_PIPE] = ACTIONS(7709),
    [anon_sym_AMP_AMP] = ACTIONS(7709),
    [anon_sym_PIPE] = ACTIONS(7707),
    [anon_sym_CARET] = ACTIONS(7707),
    [anon_sym_AMP] = ACTIONS(7707),
    [anon_sym_EQ_EQ] = ACTIONS(7709),
    [anon_sym_BANG_EQ] = ACTIONS(7709),
    [anon_sym_GT] = ACTIONS(7707),
    [anon_sym_GT_EQ] = ACTIONS(7709),
    [anon_sym_LT_EQ] = ACTIONS(7707),
    [anon_sym_LT] = ACTIONS(7707),
    [anon_sym_LT_LT] = ACTIONS(7707),
    [anon_sym_GT_GT] = ACTIONS(7707),
    [anon_sym_COLON] = ACTIONS(7709),
    [anon_sym_SEMI] = ACTIONS(7709),
    [anon_sym___attribute__] = ACTIONS(7707),
    [anon_sym___attribute] = ACTIONS(7707),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7709),
    [anon_sym_LBRACE] = ACTIONS(7709),
    [anon_sym_RBRACE] = ACTIONS(7709),
    [anon_sym_LBRACK] = ACTIONS(7707),
    [anon_sym_RBRACK] = ACTIONS(7709),
    [anon_sym_EQ] = ACTIONS(7707),
    [anon_sym_QMARK] = ACTIONS(7709),
    [anon_sym_STAR_EQ] = ACTIONS(7709),
    [anon_sym_SLASH_EQ] = ACTIONS(7709),
    [anon_sym_PERCENT_EQ] = ACTIONS(7709),
    [anon_sym_PLUS_EQ] = ACTIONS(7709),
    [anon_sym_DASH_EQ] = ACTIONS(7709),
    [anon_sym_LT_LT_EQ] = ACTIONS(7709),
    [anon_sym_GT_GT_EQ] = ACTIONS(7709),
    [anon_sym_AMP_EQ] = ACTIONS(7709),
    [anon_sym_CARET_EQ] = ACTIONS(7709),
    [anon_sym_PIPE_EQ] = ACTIONS(7709),
    [anon_sym_and_eq] = ACTIONS(7707),
    [anon_sym_or_eq] = ACTIONS(7707),
    [anon_sym_xor_eq] = ACTIONS(7707),
    [anon_sym_LT_EQ_GT] = ACTIONS(7709),
    [anon_sym_or] = ACTIONS(7707),
    [anon_sym_and] = ACTIONS(7707),
    [anon_sym_bitor] = ACTIONS(7707),
    [anon_sym_xor] = ACTIONS(7707),
    [anon_sym_bitand] = ACTIONS(7707),
    [anon_sym_not_eq] = ACTIONS(7707),
    [anon_sym_is] = ACTIONS(7707),
    [anon_sym_as] = ACTIONS(7707),
    [anon_sym_DASH_DASH] = ACTIONS(7709),
    [anon_sym_PLUS_PLUS] = ACTIONS(7709),
    [anon_sym_DOT] = ACTIONS(7707),
    [anon_sym_DOT_STAR] = ACTIONS(7709),
    [anon_sym_DASH_GT] = ACTIONS(7709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(7707),
  },
  [3322] = {
    [sym_template_argument_list] = STATE(2953),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3439),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3775),
    [anon_sym_COMMA] = ACTIONS(3775),
    [anon_sym_RPAREN] = ACTIONS(3775),
    [anon_sym_LPAREN2] = ACTIONS(3775),
    [anon_sym_DASH] = ACTIONS(3777),
    [anon_sym_PLUS] = ACTIONS(3777),
    [anon_sym_STAR] = ACTIONS(3777),
    [anon_sym_SLASH] = ACTIONS(3777),
    [anon_sym_PERCENT] = ACTIONS(3777),
    [anon_sym_PIPE_PIPE] = ACTIONS(3775),
    [anon_sym_AMP_AMP] = ACTIONS(3775),
    [anon_sym_PIPE] = ACTIONS(3777),
    [anon_sym_CARET] = ACTIONS(3777),
    [anon_sym_AMP] = ACTIONS(3777),
    [anon_sym_EQ_EQ] = ACTIONS(3775),
    [anon_sym_BANG_EQ] = ACTIONS(3775),
    [anon_sym_GT] = ACTIONS(3777),
    [anon_sym_GT_EQ] = ACTIONS(3775),
    [anon_sym_LT_EQ] = ACTIONS(3777),
    [anon_sym_LT] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3777),
    [anon_sym_GT_GT] = ACTIONS(3777),
    [anon_sym___attribute__] = ACTIONS(3775),
    [anon_sym___attribute] = ACTIONS(3777),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(3775),
    [anon_sym_signed] = ACTIONS(7711),
    [anon_sym_unsigned] = ACTIONS(7711),
    [anon_sym_long] = ACTIONS(7711),
    [anon_sym_short] = ACTIONS(7711),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_EQ] = ACTIONS(3777),
    [anon_sym_QMARK] = ACTIONS(3775),
    [anon_sym_STAR_EQ] = ACTIONS(3775),
    [anon_sym_SLASH_EQ] = ACTIONS(3775),
    [anon_sym_PERCENT_EQ] = ACTIONS(3775),
    [anon_sym_PLUS_EQ] = ACTIONS(3775),
    [anon_sym_DASH_EQ] = ACTIONS(3775),
    [anon_sym_LT_LT_EQ] = ACTIONS(3775),
    [anon_sym_GT_GT_EQ] = ACTIONS(3775),
    [anon_sym_AMP_EQ] = ACTIONS(3775),
    [anon_sym_CARET_EQ] = ACTIONS(3775),
    [anon_sym_PIPE_EQ] = ACTIONS(3775),
    [anon_sym_and_eq] = ACTIONS(3775),
    [anon_sym_or_eq] = ACTIONS(3775),
    [anon_sym_xor_eq] = ACTIONS(3775),
    [anon_sym_LT_EQ_GT] = ACTIONS(3775),
    [anon_sym_or] = ACTIONS(3777),
    [anon_sym_and] = ACTIONS(3777),
    [anon_sym_bitor] = ACTIONS(3775),
    [anon_sym_xor] = ACTIONS(3777),
    [anon_sym_bitand] = ACTIONS(3775),
    [anon_sym_not_eq] = ACTIONS(3775),
    [anon_sym_is] = ACTIONS(3775),
    [anon_sym_as] = ACTIONS(3775),
    [anon_sym_DASH_DASH] = ACTIONS(3775),
    [anon_sym_PLUS_PLUS] = ACTIONS(3775),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_DOT_STAR] = ACTIONS(3775),
    [anon_sym_DASH_GT] = ACTIONS(3777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3775),
    [anon_sym_let] = ACTIONS(3775),
    [anon_sym_This] = ACTIONS(3775),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3775),
  },
  [3323] = {
    [sym_new_declarator] = STATE(3361),
    [sym_identifier] = ACTIONS(7713),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7715),
    [anon_sym_COMMA] = ACTIONS(7715),
    [anon_sym_RPAREN] = ACTIONS(7715),
    [aux_sym_preproc_if_token2] = ACTIONS(7715),
    [aux_sym_preproc_else_token1] = ACTIONS(7715),
    [aux_sym_preproc_elif_token1] = ACTIONS(7713),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7715),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7715),
    [anon_sym_LPAREN2] = ACTIONS(7715),
    [anon_sym_DASH] = ACTIONS(7713),
    [anon_sym_PLUS] = ACTIONS(7713),
    [anon_sym_STAR] = ACTIONS(7713),
    [anon_sym_SLASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [anon_sym_PIPE_PIPE] = ACTIONS(7715),
    [anon_sym_AMP_AMP] = ACTIONS(7715),
    [anon_sym_PIPE] = ACTIONS(7713),
    [anon_sym_CARET] = ACTIONS(7713),
    [anon_sym_AMP] = ACTIONS(7713),
    [anon_sym_EQ_EQ] = ACTIONS(7715),
    [anon_sym_BANG_EQ] = ACTIONS(7715),
    [anon_sym_GT] = ACTIONS(7713),
    [anon_sym_GT_EQ] = ACTIONS(7715),
    [anon_sym_LT_EQ] = ACTIONS(7713),
    [anon_sym_LT] = ACTIONS(7713),
    [anon_sym_LT_LT] = ACTIONS(7713),
    [anon_sym_GT_GT] = ACTIONS(7713),
    [anon_sym_COLON] = ACTIONS(7715),
    [anon_sym_SEMI] = ACTIONS(7715),
    [anon_sym___attribute__] = ACTIONS(7713),
    [anon_sym___attribute] = ACTIONS(7713),
    [anon_sym_LBRACE] = ACTIONS(7715),
    [anon_sym_RBRACE] = ACTIONS(7715),
    [anon_sym_LBRACK] = ACTIONS(7360),
    [anon_sym_RBRACK] = ACTIONS(7715),
    [anon_sym_EQ] = ACTIONS(7713),
    [anon_sym_QMARK] = ACTIONS(7715),
    [anon_sym_STAR_EQ] = ACTIONS(7715),
    [anon_sym_SLASH_EQ] = ACTIONS(7715),
    [anon_sym_PERCENT_EQ] = ACTIONS(7715),
    [anon_sym_PLUS_EQ] = ACTIONS(7715),
    [anon_sym_DASH_EQ] = ACTIONS(7715),
    [anon_sym_LT_LT_EQ] = ACTIONS(7715),
    [anon_sym_GT_GT_EQ] = ACTIONS(7715),
    [anon_sym_AMP_EQ] = ACTIONS(7715),
    [anon_sym_CARET_EQ] = ACTIONS(7715),
    [anon_sym_PIPE_EQ] = ACTIONS(7715),
    [anon_sym_and_eq] = ACTIONS(7713),
    [anon_sym_or_eq] = ACTIONS(7713),
    [anon_sym_xor_eq] = ACTIONS(7713),
    [anon_sym_LT_EQ_GT] = ACTIONS(7715),
    [anon_sym_or] = ACTIONS(7713),
    [anon_sym_and] = ACTIONS(7713),
    [anon_sym_bitor] = ACTIONS(7713),
    [anon_sym_xor] = ACTIONS(7713),
    [anon_sym_bitand] = ACTIONS(7713),
    [anon_sym_not_eq] = ACTIONS(7713),
    [anon_sym_is] = ACTIONS(7713),
    [anon_sym_as] = ACTIONS(7713),
    [anon_sym_DASH_DASH] = ACTIONS(7715),
    [anon_sym_PLUS_PLUS] = ACTIONS(7715),
    [anon_sym_DOT] = ACTIONS(7713),
    [anon_sym_DOT_STAR] = ACTIONS(7715),
    [anon_sym_DASH_GT] = ACTIONS(7715),
    [sym_comment] = ACTIONS(3),
  },
  [3324] = {
    [sym_identifier] = ACTIONS(7150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7152),
    [anon_sym_COMMA] = ACTIONS(7152),
    [anon_sym_LPAREN2] = ACTIONS(7152),
    [anon_sym_DASH] = ACTIONS(7150),
    [anon_sym_PLUS] = ACTIONS(7150),
    [anon_sym_STAR] = ACTIONS(7150),
    [anon_sym_SLASH] = ACTIONS(7150),
    [anon_sym_PERCENT] = ACTIONS(7150),
    [anon_sym_PIPE_PIPE] = ACTIONS(7152),
    [anon_sym_AMP_AMP] = ACTIONS(7152),
    [anon_sym_PIPE] = ACTIONS(7150),
    [anon_sym_CARET] = ACTIONS(7150),
    [anon_sym_AMP] = ACTIONS(7150),
    [anon_sym_EQ_EQ] = ACTIONS(7152),
    [anon_sym_BANG_EQ] = ACTIONS(7152),
    [anon_sym_GT] = ACTIONS(7150),
    [anon_sym_GT_EQ] = ACTIONS(7152),
    [anon_sym_LT_EQ] = ACTIONS(7150),
    [anon_sym_LT] = ACTIONS(7150),
    [anon_sym_LT_LT] = ACTIONS(7150),
    [anon_sym_GT_GT] = ACTIONS(7150),
    [anon_sym_SEMI] = ACTIONS(7152),
    [anon_sym___attribute__] = ACTIONS(7150),
    [anon_sym___attribute] = ACTIONS(7150),
    [anon_sym_LBRACK] = ACTIONS(7152),
    [anon_sym_EQ] = ACTIONS(7150),
    [anon_sym_QMARK] = ACTIONS(7152),
    [anon_sym_STAR_EQ] = ACTIONS(7152),
    [anon_sym_SLASH_EQ] = ACTIONS(7152),
    [anon_sym_PERCENT_EQ] = ACTIONS(7152),
    [anon_sym_PLUS_EQ] = ACTIONS(7152),
    [anon_sym_DASH_EQ] = ACTIONS(7152),
    [anon_sym_LT_LT_EQ] = ACTIONS(7152),
    [anon_sym_GT_GT_EQ] = ACTIONS(7152),
    [anon_sym_AMP_EQ] = ACTIONS(7152),
    [anon_sym_CARET_EQ] = ACTIONS(7152),
    [anon_sym_PIPE_EQ] = ACTIONS(7152),
    [anon_sym_and_eq] = ACTIONS(7150),
    [anon_sym_or_eq] = ACTIONS(7150),
    [anon_sym_xor_eq] = ACTIONS(7150),
    [anon_sym_LT_EQ_GT] = ACTIONS(7152),
    [anon_sym_or] = ACTIONS(7150),
    [anon_sym_and] = ACTIONS(7150),
    [anon_sym_bitor] = ACTIONS(7150),
    [anon_sym_xor] = ACTIONS(7150),
    [anon_sym_bitand] = ACTIONS(7150),
    [anon_sym_not_eq] = ACTIONS(7150),
    [anon_sym_is] = ACTIONS(7150),
    [anon_sym_as] = ACTIONS(7150),
    [anon_sym_DASH_DASH] = ACTIONS(7152),
    [anon_sym_PLUS_PLUS] = ACTIONS(7152),
    [anon_sym_DOT] = ACTIONS(7150),
    [anon_sym_DOT_STAR] = ACTIONS(7152),
    [anon_sym_DASH_GT] = ACTIONS(7152),
    [anon_sym_L_DQUOTE] = ACTIONS(7152),
    [anon_sym_u_DQUOTE] = ACTIONS(7152),
    [anon_sym_U_DQUOTE] = ACTIONS(7152),
    [anon_sym_u8_DQUOTE] = ACTIONS(7152),
    [anon_sym_DQUOTE] = ACTIONS(7152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7152),
    [anon_sym_LR_DQUOTE] = ACTIONS(7152),
    [anon_sym_uR_DQUOTE] = ACTIONS(7152),
    [anon_sym_UR_DQUOTE] = ACTIONS(7152),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7152),
    [sym_literal_suffix] = ACTIONS(7150),
  },
  [3325] = {
    [sym_identifier] = ACTIONS(2255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2245),
    [anon_sym_COMMA] = ACTIONS(2245),
    [anon_sym_RPAREN] = ACTIONS(2245),
    [aux_sym_preproc_if_token2] = ACTIONS(2245),
    [aux_sym_preproc_else_token1] = ACTIONS(2245),
    [aux_sym_preproc_elif_token1] = ACTIONS(2255),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2245),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2245),
    [anon_sym_LPAREN2] = ACTIONS(2245),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2255),
    [anon_sym_SLASH] = ACTIONS(2255),
    [anon_sym_PERCENT] = ACTIONS(2255),
    [anon_sym_PIPE_PIPE] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2245),
    [anon_sym_PIPE] = ACTIONS(2255),
    [anon_sym_CARET] = ACTIONS(2255),
    [anon_sym_AMP] = ACTIONS(2255),
    [anon_sym_EQ_EQ] = ACTIONS(2245),
    [anon_sym_BANG_EQ] = ACTIONS(2245),
    [anon_sym_GT] = ACTIONS(2255),
    [anon_sym_GT_EQ] = ACTIONS(2245),
    [anon_sym_LT_EQ] = ACTIONS(2255),
    [anon_sym_LT] = ACTIONS(2255),
    [anon_sym_LT_LT] = ACTIONS(2255),
    [anon_sym_GT_GT] = ACTIONS(2255),
    [anon_sym_COLON] = ACTIONS(2255),
    [anon_sym_SEMI] = ACTIONS(2245),
    [anon_sym___attribute__] = ACTIONS(2255),
    [anon_sym___attribute] = ACTIONS(2255),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2245),
    [anon_sym_LBRACK] = ACTIONS(2245),
    [anon_sym_RBRACK] = ACTIONS(2245),
    [anon_sym_EQ] = ACTIONS(2255),
    [anon_sym_QMARK] = ACTIONS(2245),
    [anon_sym_STAR_EQ] = ACTIONS(2245),
    [anon_sym_SLASH_EQ] = ACTIONS(2245),
    [anon_sym_PERCENT_EQ] = ACTIONS(2245),
    [anon_sym_PLUS_EQ] = ACTIONS(2245),
    [anon_sym_DASH_EQ] = ACTIONS(2245),
    [anon_sym_LT_LT_EQ] = ACTIONS(2245),
    [anon_sym_GT_GT_EQ] = ACTIONS(2245),
    [anon_sym_AMP_EQ] = ACTIONS(2245),
    [anon_sym_CARET_EQ] = ACTIONS(2245),
    [anon_sym_PIPE_EQ] = ACTIONS(2245),
    [anon_sym_and_eq] = ACTIONS(2255),
    [anon_sym_or_eq] = ACTIONS(2255),
    [anon_sym_xor_eq] = ACTIONS(2255),
    [anon_sym_LT_EQ_GT] = ACTIONS(2245),
    [anon_sym_or] = ACTIONS(2255),
    [anon_sym_and] = ACTIONS(2255),
    [anon_sym_bitor] = ACTIONS(2255),
    [anon_sym_xor] = ACTIONS(2255),
    [anon_sym_bitand] = ACTIONS(2255),
    [anon_sym_not_eq] = ACTIONS(2255),
    [anon_sym_is] = ACTIONS(2255),
    [anon_sym_as] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2245),
    [anon_sym_PLUS_PLUS] = ACTIONS(2245),
    [anon_sym_DOT] = ACTIONS(2255),
    [anon_sym_DOT_STAR] = ACTIONS(2245),
    [anon_sym_DASH_GT] = ACTIONS(2245),
    [sym_comment] = ACTIONS(3),
  },
  [3326] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3327),
    [sym_identifier] = ACTIONS(2915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4121),
    [anon_sym_COMMA] = ACTIONS(4121),
    [anon_sym_LPAREN2] = ACTIONS(4121),
    [anon_sym_DASH] = ACTIONS(4124),
    [anon_sym_PLUS] = ACTIONS(4124),
    [anon_sym_STAR] = ACTIONS(4121),
    [anon_sym_SLASH] = ACTIONS(4124),
    [anon_sym_PERCENT] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4121),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE] = ACTIONS(4124),
    [anon_sym_CARET] = ACTIONS(4121),
    [anon_sym_AMP] = ACTIONS(4124),
    [anon_sym_EQ_EQ] = ACTIONS(4121),
    [anon_sym_BANG_EQ] = ACTIONS(4121),
    [anon_sym_GT] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4124),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_LT_LT] = ACTIONS(4121),
    [anon_sym_GT_GT] = ACTIONS(4124),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(4124),
    [anon_sym___attribute] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_signed] = ACTIONS(7717),
    [anon_sym_unsigned] = ACTIONS(7717),
    [anon_sym_long] = ACTIONS(7717),
    [anon_sym_short] = ACTIONS(7717),
    [anon_sym_LBRACK] = ACTIONS(4121),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(4121),
    [anon_sym_LT_EQ_GT] = ACTIONS(4121),
    [anon_sym_or] = ACTIONS(4124),
    [anon_sym_and] = ACTIONS(4124),
    [anon_sym_bitor] = ACTIONS(4124),
    [anon_sym_xor] = ACTIONS(4124),
    [anon_sym_bitand] = ACTIONS(4124),
    [anon_sym_not_eq] = ACTIONS(4124),
    [anon_sym_is] = ACTIONS(4124),
    [anon_sym_as] = ACTIONS(4124),
    [anon_sym_DASH_DASH] = ACTIONS(4121),
    [anon_sym_PLUS_PLUS] = ACTIONS(4121),
    [anon_sym_DOT] = ACTIONS(4124),
    [anon_sym_DOT_STAR] = ACTIONS(4121),
    [anon_sym_DASH_GT] = ACTIONS(4121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4124),
    [anon_sym_let] = ACTIONS(4124),
    [anon_sym_This] = ACTIONS(4124),
    [anon_sym_GT2] = ACTIONS(4121),
  },
  [3327] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3327),
    [sym_identifier] = ACTIONS(2915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2913),
    [anon_sym_COMMA] = ACTIONS(2913),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2915),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_SLASH] = ACTIONS(2915),
    [anon_sym_PERCENT] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_CARET] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2915),
    [anon_sym_GT_EQ] = ACTIONS(2915),
    [anon_sym_LT_EQ] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2915),
    [anon_sym_LT_LT] = ACTIONS(2913),
    [anon_sym_GT_GT] = ACTIONS(2915),
    [anon_sym___extension__] = ACTIONS(2915),
    [anon_sym___attribute__] = ACTIONS(2915),
    [anon_sym___attribute] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_signed] = ACTIONS(7717),
    [anon_sym_unsigned] = ACTIONS(7717),
    [anon_sym_long] = ACTIONS(7717),
    [anon_sym_short] = ACTIONS(7717),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_constexpr] = ACTIONS(2915),
    [anon_sym_volatile] = ACTIONS(2915),
    [anon_sym_restrict] = ACTIONS(2915),
    [anon_sym___restrict__] = ACTIONS(2915),
    [anon_sym__Atomic] = ACTIONS(2915),
    [anon_sym__Noreturn] = ACTIONS(2915),
    [anon_sym_noreturn] = ACTIONS(2915),
    [anon_sym__Nonnull] = ACTIONS(2915),
    [anon_sym_mutable] = ACTIONS(2915),
    [anon_sym_constinit] = ACTIONS(2915),
    [anon_sym_consteval] = ACTIONS(2915),
    [anon_sym_alignas] = ACTIONS(2915),
    [anon_sym__Alignas] = ACTIONS(2915),
    [sym_primitive_type] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(2913),
    [anon_sym_LT_EQ_GT] = ACTIONS(2913),
    [anon_sym_or] = ACTIONS(2915),
    [anon_sym_and] = ACTIONS(2915),
    [anon_sym_bitor] = ACTIONS(2915),
    [anon_sym_xor] = ACTIONS(2915),
    [anon_sym_bitand] = ACTIONS(2915),
    [anon_sym_not_eq] = ACTIONS(2915),
    [anon_sym_is] = ACTIONS(2915),
    [anon_sym_as] = ACTIONS(2915),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_DOT] = ACTIONS(2915),
    [anon_sym_DOT_STAR] = ACTIONS(2913),
    [anon_sym_DASH_GT] = ACTIONS(2913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2915),
    [anon_sym_let] = ACTIONS(2915),
    [anon_sym_This] = ACTIONS(2915),
    [anon_sym_GT2] = ACTIONS(2913),
  },
  [3328] = {
    [sym_attribute_specifier] = STATE(3715),
    [sym_field_declaration_list] = STATE(3581),
    [sym_virtual_specifier] = STATE(9380),
    [sym_base_class_clause] = STATE(10385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2895),
    [anon_sym_RPAREN] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_PERCENT] = ACTIONS(2893),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_PIPE] = ACTIONS(2893),
    [anon_sym_CARET] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_EQ_EQ] = ACTIONS(2895),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_GT] = ACTIONS(2893),
    [anon_sym_GT_EQ] = ACTIONS(2895),
    [anon_sym_LT_EQ] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_LT_LT] = ACTIONS(2893),
    [anon_sym_GT_GT] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(7252),
    [anon_sym___attribute__] = ACTIONS(7720),
    [anon_sym___attribute] = ACTIONS(7722),
    [anon_sym_LBRACE] = ACTIONS(7724),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_EQ] = ACTIONS(2893),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_STAR_EQ] = ACTIONS(2895),
    [anon_sym_SLASH_EQ] = ACTIONS(2895),
    [anon_sym_PERCENT_EQ] = ACTIONS(2895),
    [anon_sym_PLUS_EQ] = ACTIONS(2895),
    [anon_sym_DASH_EQ] = ACTIONS(2895),
    [anon_sym_LT_LT_EQ] = ACTIONS(2895),
    [anon_sym_GT_GT_EQ] = ACTIONS(2895),
    [anon_sym_AMP_EQ] = ACTIONS(2895),
    [anon_sym_CARET_EQ] = ACTIONS(2895),
    [anon_sym_PIPE_EQ] = ACTIONS(2895),
    [anon_sym_and_eq] = ACTIONS(2895),
    [anon_sym_or_eq] = ACTIONS(2895),
    [anon_sym_xor_eq] = ACTIONS(2895),
    [anon_sym_LT_EQ_GT] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2893),
    [anon_sym_and] = ACTIONS(2893),
    [anon_sym_bitor] = ACTIONS(2895),
    [anon_sym_xor] = ACTIONS(2893),
    [anon_sym_bitand] = ACTIONS(2895),
    [anon_sym_not_eq] = ACTIONS(2895),
    [anon_sym_is] = ACTIONS(2895),
    [anon_sym_as] = ACTIONS(2895),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2893),
    [anon_sym_DOT_STAR] = ACTIONS(2895),
    [anon_sym_DASH_GT] = ACTIONS(2893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2895),
    [anon_sym_let] = ACTIONS(2895),
    [anon_sym_This] = ACTIONS(2895),
    [anon_sym_final] = ACTIONS(7352),
    [anon_sym_override] = ACTIONS(7352),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2895),
  },
  [3329] = {
    [sym_template_argument_list] = STATE(3330),
    [sym_identifier] = ACTIONS(7726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7728),
    [anon_sym_COMMA] = ACTIONS(7728),
    [anon_sym_RPAREN] = ACTIONS(7728),
    [aux_sym_preproc_if_token2] = ACTIONS(7728),
    [aux_sym_preproc_else_token1] = ACTIONS(7728),
    [aux_sym_preproc_elif_token1] = ACTIONS(7726),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7728),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7728),
    [anon_sym_LPAREN2] = ACTIONS(7728),
    [anon_sym_DASH] = ACTIONS(7726),
    [anon_sym_PLUS] = ACTIONS(7726),
    [anon_sym_STAR] = ACTIONS(7726),
    [anon_sym_SLASH] = ACTIONS(7726),
    [anon_sym_PERCENT] = ACTIONS(7726),
    [anon_sym_PIPE_PIPE] = ACTIONS(7728),
    [anon_sym_AMP_AMP] = ACTIONS(7728),
    [anon_sym_PIPE] = ACTIONS(7726),
    [anon_sym_CARET] = ACTIONS(7726),
    [anon_sym_AMP] = ACTIONS(7726),
    [anon_sym_EQ_EQ] = ACTIONS(7728),
    [anon_sym_BANG_EQ] = ACTIONS(7728),
    [anon_sym_GT] = ACTIONS(7726),
    [anon_sym_GT_EQ] = ACTIONS(7728),
    [anon_sym_LT_EQ] = ACTIONS(7726),
    [anon_sym_LT] = ACTIONS(7730),
    [anon_sym_LT_LT] = ACTIONS(7726),
    [anon_sym_GT_GT] = ACTIONS(7726),
    [anon_sym_COLON] = ACTIONS(7726),
    [anon_sym_SEMI] = ACTIONS(7728),
    [anon_sym___attribute__] = ACTIONS(7726),
    [anon_sym___attribute] = ACTIONS(7726),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_RBRACE] = ACTIONS(7728),
    [anon_sym_LBRACK] = ACTIONS(7728),
    [anon_sym_RBRACK] = ACTIONS(7728),
    [anon_sym_EQ] = ACTIONS(7726),
    [anon_sym_QMARK] = ACTIONS(7728),
    [anon_sym_STAR_EQ] = ACTIONS(7728),
    [anon_sym_SLASH_EQ] = ACTIONS(7728),
    [anon_sym_PERCENT_EQ] = ACTIONS(7728),
    [anon_sym_PLUS_EQ] = ACTIONS(7728),
    [anon_sym_DASH_EQ] = ACTIONS(7728),
    [anon_sym_LT_LT_EQ] = ACTIONS(7728),
    [anon_sym_GT_GT_EQ] = ACTIONS(7728),
    [anon_sym_AMP_EQ] = ACTIONS(7728),
    [anon_sym_CARET_EQ] = ACTIONS(7728),
    [anon_sym_PIPE_EQ] = ACTIONS(7728),
    [anon_sym_and_eq] = ACTIONS(7726),
    [anon_sym_or_eq] = ACTIONS(7726),
    [anon_sym_xor_eq] = ACTIONS(7726),
    [anon_sym_LT_EQ_GT] = ACTIONS(7728),
    [anon_sym_or] = ACTIONS(7726),
    [anon_sym_and] = ACTIONS(7726),
    [anon_sym_bitor] = ACTIONS(7726),
    [anon_sym_xor] = ACTIONS(7726),
    [anon_sym_bitand] = ACTIONS(7726),
    [anon_sym_not_eq] = ACTIONS(7726),
    [anon_sym_is] = ACTIONS(7726),
    [anon_sym_as] = ACTIONS(7726),
    [anon_sym_DASH_DASH] = ACTIONS(7728),
    [anon_sym_PLUS_PLUS] = ACTIONS(7728),
    [anon_sym_DOT] = ACTIONS(7726),
    [anon_sym_DOT_STAR] = ACTIONS(7728),
    [anon_sym_DASH_GT] = ACTIONS(7728),
    [sym_comment] = ACTIONS(3),
  },
  [3330] = {
    [sym_identifier] = ACTIONS(7733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7735),
    [anon_sym_COMMA] = ACTIONS(7735),
    [anon_sym_RPAREN] = ACTIONS(7735),
    [aux_sym_preproc_if_token2] = ACTIONS(7735),
    [aux_sym_preproc_else_token1] = ACTIONS(7735),
    [aux_sym_preproc_elif_token1] = ACTIONS(7733),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7735),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7735),
    [anon_sym_LPAREN2] = ACTIONS(7735),
    [anon_sym_DASH] = ACTIONS(7733),
    [anon_sym_PLUS] = ACTIONS(7733),
    [anon_sym_STAR] = ACTIONS(7733),
    [anon_sym_SLASH] = ACTIONS(7733),
    [anon_sym_PERCENT] = ACTIONS(7733),
    [anon_sym_PIPE_PIPE] = ACTIONS(7735),
    [anon_sym_AMP_AMP] = ACTIONS(7735),
    [anon_sym_PIPE] = ACTIONS(7733),
    [anon_sym_CARET] = ACTIONS(7733),
    [anon_sym_AMP] = ACTIONS(7733),
    [anon_sym_EQ_EQ] = ACTIONS(7735),
    [anon_sym_BANG_EQ] = ACTIONS(7735),
    [anon_sym_GT] = ACTIONS(7733),
    [anon_sym_GT_EQ] = ACTIONS(7735),
    [anon_sym_LT_EQ] = ACTIONS(7733),
    [anon_sym_LT] = ACTIONS(7733),
    [anon_sym_LT_LT] = ACTIONS(7733),
    [anon_sym_GT_GT] = ACTIONS(7733),
    [anon_sym_COLON] = ACTIONS(7733),
    [anon_sym_SEMI] = ACTIONS(7735),
    [anon_sym___attribute__] = ACTIONS(7733),
    [anon_sym___attribute] = ACTIONS(7733),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(7735),
    [anon_sym_RBRACE] = ACTIONS(7735),
    [anon_sym_LBRACK] = ACTIONS(7735),
    [anon_sym_RBRACK] = ACTIONS(7735),
    [anon_sym_EQ] = ACTIONS(7733),
    [anon_sym_QMARK] = ACTIONS(7735),
    [anon_sym_STAR_EQ] = ACTIONS(7735),
    [anon_sym_SLASH_EQ] = ACTIONS(7735),
    [anon_sym_PERCENT_EQ] = ACTIONS(7735),
    [anon_sym_PLUS_EQ] = ACTIONS(7735),
    [anon_sym_DASH_EQ] = ACTIONS(7735),
    [anon_sym_LT_LT_EQ] = ACTIONS(7735),
    [anon_sym_GT_GT_EQ] = ACTIONS(7735),
    [anon_sym_AMP_EQ] = ACTIONS(7735),
    [anon_sym_CARET_EQ] = ACTIONS(7735),
    [anon_sym_PIPE_EQ] = ACTIONS(7735),
    [anon_sym_and_eq] = ACTIONS(7733),
    [anon_sym_or_eq] = ACTIONS(7733),
    [anon_sym_xor_eq] = ACTIONS(7733),
    [anon_sym_LT_EQ_GT] = ACTIONS(7735),
    [anon_sym_or] = ACTIONS(7733),
    [anon_sym_and] = ACTIONS(7733),
    [anon_sym_bitor] = ACTIONS(7733),
    [anon_sym_xor] = ACTIONS(7733),
    [anon_sym_bitand] = ACTIONS(7733),
    [anon_sym_not_eq] = ACTIONS(7733),
    [anon_sym_is] = ACTIONS(7733),
    [anon_sym_as] = ACTIONS(7733),
    [anon_sym_DASH_DASH] = ACTIONS(7735),
    [anon_sym_PLUS_PLUS] = ACTIONS(7735),
    [anon_sym_DOT] = ACTIONS(7733),
    [anon_sym_DOT_STAR] = ACTIONS(7735),
    [anon_sym_DASH_GT] = ACTIONS(7735),
    [sym_comment] = ACTIONS(3),
  },
  [3331] = {
    [sym_identifier] = ACTIONS(7311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7313),
    [anon_sym_COMMA] = ACTIONS(7313),
    [anon_sym_LPAREN2] = ACTIONS(7313),
    [anon_sym_DASH] = ACTIONS(7311),
    [anon_sym_PLUS] = ACTIONS(7311),
    [anon_sym_STAR] = ACTIONS(7311),
    [anon_sym_SLASH] = ACTIONS(7311),
    [anon_sym_PERCENT] = ACTIONS(7311),
    [anon_sym_PIPE_PIPE] = ACTIONS(7313),
    [anon_sym_AMP_AMP] = ACTIONS(7313),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_CARET] = ACTIONS(7311),
    [anon_sym_AMP] = ACTIONS(7311),
    [anon_sym_EQ_EQ] = ACTIONS(7313),
    [anon_sym_BANG_EQ] = ACTIONS(7313),
    [anon_sym_GT] = ACTIONS(7311),
    [anon_sym_GT_EQ] = ACTIONS(7313),
    [anon_sym_LT_EQ] = ACTIONS(7311),
    [anon_sym_LT] = ACTIONS(7311),
    [anon_sym_LT_LT] = ACTIONS(7311),
    [anon_sym_GT_GT] = ACTIONS(7311),
    [anon_sym_SEMI] = ACTIONS(7313),
    [anon_sym___attribute__] = ACTIONS(7311),
    [anon_sym___attribute] = ACTIONS(7311),
    [anon_sym_LBRACK] = ACTIONS(7313),
    [anon_sym_EQ] = ACTIONS(7311),
    [anon_sym_QMARK] = ACTIONS(7313),
    [anon_sym_STAR_EQ] = ACTIONS(7313),
    [anon_sym_SLASH_EQ] = ACTIONS(7313),
    [anon_sym_PERCENT_EQ] = ACTIONS(7313),
    [anon_sym_PLUS_EQ] = ACTIONS(7313),
    [anon_sym_DASH_EQ] = ACTIONS(7313),
    [anon_sym_LT_LT_EQ] = ACTIONS(7313),
    [anon_sym_GT_GT_EQ] = ACTIONS(7313),
    [anon_sym_AMP_EQ] = ACTIONS(7313),
    [anon_sym_CARET_EQ] = ACTIONS(7313),
    [anon_sym_PIPE_EQ] = ACTIONS(7313),
    [anon_sym_and_eq] = ACTIONS(7311),
    [anon_sym_or_eq] = ACTIONS(7311),
    [anon_sym_xor_eq] = ACTIONS(7311),
    [anon_sym_LT_EQ_GT] = ACTIONS(7313),
    [anon_sym_or] = ACTIONS(7311),
    [anon_sym_and] = ACTIONS(7311),
    [anon_sym_bitor] = ACTIONS(7311),
    [anon_sym_xor] = ACTIONS(7311),
    [anon_sym_bitand] = ACTIONS(7311),
    [anon_sym_not_eq] = ACTIONS(7311),
    [anon_sym_is] = ACTIONS(7311),
    [anon_sym_as] = ACTIONS(7311),
    [anon_sym_DASH_DASH] = ACTIONS(7313),
    [anon_sym_PLUS_PLUS] = ACTIONS(7313),
    [anon_sym_DOT] = ACTIONS(7311),
    [anon_sym_DOT_STAR] = ACTIONS(7313),
    [anon_sym_DASH_GT] = ACTIONS(7313),
    [anon_sym_L_DQUOTE] = ACTIONS(7313),
    [anon_sym_u_DQUOTE] = ACTIONS(7313),
    [anon_sym_U_DQUOTE] = ACTIONS(7313),
    [anon_sym_u8_DQUOTE] = ACTIONS(7313),
    [anon_sym_DQUOTE] = ACTIONS(7313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7313),
    [anon_sym_LR_DQUOTE] = ACTIONS(7313),
    [anon_sym_uR_DQUOTE] = ACTIONS(7313),
    [anon_sym_UR_DQUOTE] = ACTIONS(7313),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7313),
    [sym_literal_suffix] = ACTIONS(7311),
  },
  [3332] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3172),
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2881),
    [aux_sym_preproc_if_token2] = ACTIONS(2881),
    [aux_sym_preproc_else_token1] = ACTIONS(2881),
    [aux_sym_preproc_elif_token1] = ACTIONS(2883),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2881),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_STAR] = ACTIONS(2883),
    [anon_sym_SLASH] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_PIPE] = ACTIONS(2883),
    [anon_sym_CARET] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_EQ_EQ] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_GT_EQ] = ACTIONS(2881),
    [anon_sym_LT_EQ] = ACTIONS(2883),
    [anon_sym_LT] = ACTIONS(2883),
    [anon_sym_LT_LT] = ACTIONS(2883),
    [anon_sym_GT_GT] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_signed] = ACTIONS(7538),
    [anon_sym_unsigned] = ACTIONS(7538),
    [anon_sym_long] = ACTIONS(7538),
    [anon_sym_short] = ACTIONS(7538),
    [anon_sym_LBRACK] = ACTIONS(2881),
    [anon_sym_EQ] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_STAR_EQ] = ACTIONS(2881),
    [anon_sym_SLASH_EQ] = ACTIONS(2881),
    [anon_sym_PERCENT_EQ] = ACTIONS(2881),
    [anon_sym_PLUS_EQ] = ACTIONS(2881),
    [anon_sym_DASH_EQ] = ACTIONS(2881),
    [anon_sym_LT_LT_EQ] = ACTIONS(2881),
    [anon_sym_GT_GT_EQ] = ACTIONS(2881),
    [anon_sym_AMP_EQ] = ACTIONS(2881),
    [anon_sym_CARET_EQ] = ACTIONS(2881),
    [anon_sym_PIPE_EQ] = ACTIONS(2881),
    [anon_sym_and_eq] = ACTIONS(2883),
    [anon_sym_or_eq] = ACTIONS(2883),
    [anon_sym_xor_eq] = ACTIONS(2883),
    [anon_sym_LT_EQ_GT] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2883),
    [anon_sym_and] = ACTIONS(2883),
    [anon_sym_bitor] = ACTIONS(2883),
    [anon_sym_xor] = ACTIONS(2883),
    [anon_sym_bitand] = ACTIONS(2883),
    [anon_sym_not_eq] = ACTIONS(2883),
    [anon_sym_is] = ACTIONS(2883),
    [anon_sym_as] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_DOT_STAR] = ACTIONS(2881),
    [anon_sym_DASH_GT] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_This] = ACTIONS(2883),
  },
  [3333] = {
    [sym_identifier] = ACTIONS(7158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7160),
    [anon_sym_COMMA] = ACTIONS(7160),
    [anon_sym_LPAREN2] = ACTIONS(7160),
    [anon_sym_DASH] = ACTIONS(7158),
    [anon_sym_PLUS] = ACTIONS(7158),
    [anon_sym_STAR] = ACTIONS(7158),
    [anon_sym_SLASH] = ACTIONS(7158),
    [anon_sym_PERCENT] = ACTIONS(7158),
    [anon_sym_PIPE_PIPE] = ACTIONS(7160),
    [anon_sym_AMP_AMP] = ACTIONS(7160),
    [anon_sym_PIPE] = ACTIONS(7158),
    [anon_sym_CARET] = ACTIONS(7158),
    [anon_sym_AMP] = ACTIONS(7158),
    [anon_sym_EQ_EQ] = ACTIONS(7160),
    [anon_sym_BANG_EQ] = ACTIONS(7160),
    [anon_sym_GT] = ACTIONS(7158),
    [anon_sym_GT_EQ] = ACTIONS(7160),
    [anon_sym_LT_EQ] = ACTIONS(7158),
    [anon_sym_LT] = ACTIONS(7158),
    [anon_sym_LT_LT] = ACTIONS(7158),
    [anon_sym_GT_GT] = ACTIONS(7158),
    [anon_sym_SEMI] = ACTIONS(7160),
    [anon_sym___attribute__] = ACTIONS(7158),
    [anon_sym___attribute] = ACTIONS(7158),
    [anon_sym_LBRACK] = ACTIONS(7160),
    [anon_sym_EQ] = ACTIONS(7158),
    [anon_sym_QMARK] = ACTIONS(7160),
    [anon_sym_STAR_EQ] = ACTIONS(7160),
    [anon_sym_SLASH_EQ] = ACTIONS(7160),
    [anon_sym_PERCENT_EQ] = ACTIONS(7160),
    [anon_sym_PLUS_EQ] = ACTIONS(7160),
    [anon_sym_DASH_EQ] = ACTIONS(7160),
    [anon_sym_LT_LT_EQ] = ACTIONS(7160),
    [anon_sym_GT_GT_EQ] = ACTIONS(7160),
    [anon_sym_AMP_EQ] = ACTIONS(7160),
    [anon_sym_CARET_EQ] = ACTIONS(7160),
    [anon_sym_PIPE_EQ] = ACTIONS(7160),
    [anon_sym_and_eq] = ACTIONS(7158),
    [anon_sym_or_eq] = ACTIONS(7158),
    [anon_sym_xor_eq] = ACTIONS(7158),
    [anon_sym_LT_EQ_GT] = ACTIONS(7160),
    [anon_sym_or] = ACTIONS(7158),
    [anon_sym_and] = ACTIONS(7158),
    [anon_sym_bitor] = ACTIONS(7158),
    [anon_sym_xor] = ACTIONS(7158),
    [anon_sym_bitand] = ACTIONS(7158),
    [anon_sym_not_eq] = ACTIONS(7158),
    [anon_sym_is] = ACTIONS(7158),
    [anon_sym_as] = ACTIONS(7158),
    [anon_sym_DASH_DASH] = ACTIONS(7160),
    [anon_sym_PLUS_PLUS] = ACTIONS(7160),
    [anon_sym_DOT] = ACTIONS(7158),
    [anon_sym_DOT_STAR] = ACTIONS(7160),
    [anon_sym_DASH_GT] = ACTIONS(7160),
    [anon_sym_L_DQUOTE] = ACTIONS(7160),
    [anon_sym_u_DQUOTE] = ACTIONS(7160),
    [anon_sym_U_DQUOTE] = ACTIONS(7160),
    [anon_sym_u8_DQUOTE] = ACTIONS(7160),
    [anon_sym_DQUOTE] = ACTIONS(7160),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7160),
    [anon_sym_LR_DQUOTE] = ACTIONS(7160),
    [anon_sym_uR_DQUOTE] = ACTIONS(7160),
    [anon_sym_UR_DQUOTE] = ACTIONS(7160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7160),
    [sym_literal_suffix] = ACTIONS(7158),
  },
  [3334] = {
    [sym_template_argument_list] = STATE(3330),
    [sym_identifier] = ACTIONS(7737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7739),
    [anon_sym_COMMA] = ACTIONS(7739),
    [anon_sym_RPAREN] = ACTIONS(7739),
    [aux_sym_preproc_if_token2] = ACTIONS(7739),
    [aux_sym_preproc_else_token1] = ACTIONS(7739),
    [aux_sym_preproc_elif_token1] = ACTIONS(7737),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7739),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7739),
    [anon_sym_LPAREN2] = ACTIONS(7739),
    [anon_sym_DASH] = ACTIONS(7737),
    [anon_sym_PLUS] = ACTIONS(7737),
    [anon_sym_STAR] = ACTIONS(7737),
    [anon_sym_SLASH] = ACTIONS(7737),
    [anon_sym_PERCENT] = ACTIONS(7737),
    [anon_sym_PIPE_PIPE] = ACTIONS(7739),
    [anon_sym_AMP_AMP] = ACTIONS(7739),
    [anon_sym_PIPE] = ACTIONS(7737),
    [anon_sym_CARET] = ACTIONS(7737),
    [anon_sym_AMP] = ACTIONS(7737),
    [anon_sym_EQ_EQ] = ACTIONS(7739),
    [anon_sym_BANG_EQ] = ACTIONS(7739),
    [anon_sym_GT] = ACTIONS(7737),
    [anon_sym_GT_EQ] = ACTIONS(7739),
    [anon_sym_LT_EQ] = ACTIONS(7737),
    [anon_sym_LT] = ACTIONS(7741),
    [anon_sym_LT_LT] = ACTIONS(7737),
    [anon_sym_GT_GT] = ACTIONS(7737),
    [anon_sym_COLON] = ACTIONS(7737),
    [anon_sym_SEMI] = ACTIONS(7739),
    [anon_sym___attribute__] = ACTIONS(7737),
    [anon_sym___attribute] = ACTIONS(7737),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_RBRACE] = ACTIONS(7739),
    [anon_sym_LBRACK] = ACTIONS(7739),
    [anon_sym_RBRACK] = ACTIONS(7739),
    [anon_sym_EQ] = ACTIONS(7737),
    [anon_sym_QMARK] = ACTIONS(7739),
    [anon_sym_STAR_EQ] = ACTIONS(7739),
    [anon_sym_SLASH_EQ] = ACTIONS(7739),
    [anon_sym_PERCENT_EQ] = ACTIONS(7739),
    [anon_sym_PLUS_EQ] = ACTIONS(7739),
    [anon_sym_DASH_EQ] = ACTIONS(7739),
    [anon_sym_LT_LT_EQ] = ACTIONS(7739),
    [anon_sym_GT_GT_EQ] = ACTIONS(7739),
    [anon_sym_AMP_EQ] = ACTIONS(7739),
    [anon_sym_CARET_EQ] = ACTIONS(7739),
    [anon_sym_PIPE_EQ] = ACTIONS(7739),
    [anon_sym_and_eq] = ACTIONS(7737),
    [anon_sym_or_eq] = ACTIONS(7737),
    [anon_sym_xor_eq] = ACTIONS(7737),
    [anon_sym_LT_EQ_GT] = ACTIONS(7739),
    [anon_sym_or] = ACTIONS(7737),
    [anon_sym_and] = ACTIONS(7737),
    [anon_sym_bitor] = ACTIONS(7737),
    [anon_sym_xor] = ACTIONS(7737),
    [anon_sym_bitand] = ACTIONS(7737),
    [anon_sym_not_eq] = ACTIONS(7737),
    [anon_sym_is] = ACTIONS(7737),
    [anon_sym_as] = ACTIONS(7737),
    [anon_sym_DASH_DASH] = ACTIONS(7739),
    [anon_sym_PLUS_PLUS] = ACTIONS(7739),
    [anon_sym_DOT] = ACTIONS(7737),
    [anon_sym_DOT_STAR] = ACTIONS(7739),
    [anon_sym_DASH_GT] = ACTIONS(7739),
    [sym_comment] = ACTIONS(3),
  },
  [3335] = {
    [sym_identifier] = ACTIONS(7288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7290),
    [anon_sym_COMMA] = ACTIONS(7290),
    [anon_sym_LPAREN2] = ACTIONS(7290),
    [anon_sym_DASH] = ACTIONS(7288),
    [anon_sym_PLUS] = ACTIONS(7288),
    [anon_sym_STAR] = ACTIONS(7288),
    [anon_sym_SLASH] = ACTIONS(7288),
    [anon_sym_PERCENT] = ACTIONS(7288),
    [anon_sym_PIPE_PIPE] = ACTIONS(7290),
    [anon_sym_AMP_AMP] = ACTIONS(7290),
    [anon_sym_PIPE] = ACTIONS(7288),
    [anon_sym_CARET] = ACTIONS(7288),
    [anon_sym_AMP] = ACTIONS(7288),
    [anon_sym_EQ_EQ] = ACTIONS(7290),
    [anon_sym_BANG_EQ] = ACTIONS(7290),
    [anon_sym_GT] = ACTIONS(7288),
    [anon_sym_GT_EQ] = ACTIONS(7290),
    [anon_sym_LT_EQ] = ACTIONS(7288),
    [anon_sym_LT] = ACTIONS(7288),
    [anon_sym_LT_LT] = ACTIONS(7288),
    [anon_sym_GT_GT] = ACTIONS(7288),
    [anon_sym_SEMI] = ACTIONS(7290),
    [anon_sym___attribute__] = ACTIONS(7288),
    [anon_sym___attribute] = ACTIONS(7288),
    [anon_sym_LBRACK] = ACTIONS(7290),
    [anon_sym_EQ] = ACTIONS(7288),
    [anon_sym_QMARK] = ACTIONS(7290),
    [anon_sym_STAR_EQ] = ACTIONS(7290),
    [anon_sym_SLASH_EQ] = ACTIONS(7290),
    [anon_sym_PERCENT_EQ] = ACTIONS(7290),
    [anon_sym_PLUS_EQ] = ACTIONS(7290),
    [anon_sym_DASH_EQ] = ACTIONS(7290),
    [anon_sym_LT_LT_EQ] = ACTIONS(7290),
    [anon_sym_GT_GT_EQ] = ACTIONS(7290),
    [anon_sym_AMP_EQ] = ACTIONS(7290),
    [anon_sym_CARET_EQ] = ACTIONS(7290),
    [anon_sym_PIPE_EQ] = ACTIONS(7290),
    [anon_sym_and_eq] = ACTIONS(7288),
    [anon_sym_or_eq] = ACTIONS(7288),
    [anon_sym_xor_eq] = ACTIONS(7288),
    [anon_sym_LT_EQ_GT] = ACTIONS(7290),
    [anon_sym_or] = ACTIONS(7288),
    [anon_sym_and] = ACTIONS(7288),
    [anon_sym_bitor] = ACTIONS(7288),
    [anon_sym_xor] = ACTIONS(7288),
    [anon_sym_bitand] = ACTIONS(7288),
    [anon_sym_not_eq] = ACTIONS(7288),
    [anon_sym_is] = ACTIONS(7288),
    [anon_sym_as] = ACTIONS(7288),
    [anon_sym_DASH_DASH] = ACTIONS(7290),
    [anon_sym_PLUS_PLUS] = ACTIONS(7290),
    [anon_sym_DOT] = ACTIONS(7288),
    [anon_sym_DOT_STAR] = ACTIONS(7290),
    [anon_sym_DASH_GT] = ACTIONS(7290),
    [anon_sym_L_DQUOTE] = ACTIONS(7290),
    [anon_sym_u_DQUOTE] = ACTIONS(7290),
    [anon_sym_U_DQUOTE] = ACTIONS(7290),
    [anon_sym_u8_DQUOTE] = ACTIONS(7290),
    [anon_sym_DQUOTE] = ACTIONS(7290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7290),
    [anon_sym_LR_DQUOTE] = ACTIONS(7290),
    [anon_sym_uR_DQUOTE] = ACTIONS(7290),
    [anon_sym_UR_DQUOTE] = ACTIONS(7290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7290),
    [sym_literal_suffix] = ACTIONS(7288),
  },
  [3336] = {
    [sym_string_literal] = STATE(3241),
    [sym_raw_string_literal] = STATE(3241),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7388),
    [anon_sym_COMMA] = ACTIONS(7388),
    [anon_sym_RPAREN] = ACTIONS(7388),
    [anon_sym_LPAREN2] = ACTIONS(7388),
    [anon_sym_DASH] = ACTIONS(7386),
    [anon_sym_PLUS] = ACTIONS(7386),
    [anon_sym_STAR] = ACTIONS(7386),
    [anon_sym_SLASH] = ACTIONS(7386),
    [anon_sym_PERCENT] = ACTIONS(7386),
    [anon_sym_PIPE_PIPE] = ACTIONS(7388),
    [anon_sym_AMP_AMP] = ACTIONS(7388),
    [anon_sym_PIPE] = ACTIONS(7386),
    [anon_sym_CARET] = ACTIONS(7386),
    [anon_sym_AMP] = ACTIONS(7386),
    [anon_sym_EQ_EQ] = ACTIONS(7388),
    [anon_sym_BANG_EQ] = ACTIONS(7388),
    [anon_sym_GT] = ACTIONS(7386),
    [anon_sym_GT_EQ] = ACTIONS(7388),
    [anon_sym_LT_EQ] = ACTIONS(7386),
    [anon_sym_LT] = ACTIONS(7386),
    [anon_sym_LT_LT] = ACTIONS(7386),
    [anon_sym_GT_GT] = ACTIONS(7386),
    [anon_sym_LBRACK] = ACTIONS(7388),
    [anon_sym_EQ] = ACTIONS(7386),
    [anon_sym_QMARK] = ACTIONS(7388),
    [anon_sym_STAR_EQ] = ACTIONS(7388),
    [anon_sym_SLASH_EQ] = ACTIONS(7388),
    [anon_sym_PERCENT_EQ] = ACTIONS(7388),
    [anon_sym_PLUS_EQ] = ACTIONS(7388),
    [anon_sym_DASH_EQ] = ACTIONS(7388),
    [anon_sym_LT_LT_EQ] = ACTIONS(7388),
    [anon_sym_GT_GT_EQ] = ACTIONS(7388),
    [anon_sym_AMP_EQ] = ACTIONS(7388),
    [anon_sym_CARET_EQ] = ACTIONS(7388),
    [anon_sym_PIPE_EQ] = ACTIONS(7388),
    [anon_sym_and_eq] = ACTIONS(7386),
    [anon_sym_or_eq] = ACTIONS(7386),
    [anon_sym_xor_eq] = ACTIONS(7386),
    [anon_sym_LT_EQ_GT] = ACTIONS(7388),
    [anon_sym_or] = ACTIONS(7386),
    [anon_sym_and] = ACTIONS(7386),
    [anon_sym_bitor] = ACTIONS(7386),
    [anon_sym_xor] = ACTIONS(7386),
    [anon_sym_bitand] = ACTIONS(7386),
    [anon_sym_not_eq] = ACTIONS(7386),
    [anon_sym_is] = ACTIONS(7386),
    [anon_sym_as] = ACTIONS(7386),
    [anon_sym_DASH_DASH] = ACTIONS(7388),
    [anon_sym_PLUS_PLUS] = ACTIONS(7388),
    [anon_sym_DOT] = ACTIONS(7386),
    [anon_sym_DOT_STAR] = ACTIONS(7388),
    [anon_sym_DASH_GT] = ACTIONS(7386),
    [anon_sym_L_DQUOTE] = ACTIONS(6765),
    [anon_sym_u_DQUOTE] = ACTIONS(6765),
    [anon_sym_U_DQUOTE] = ACTIONS(6765),
    [anon_sym_u8_DQUOTE] = ACTIONS(6765),
    [anon_sym_DQUOTE] = ACTIONS(6765),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6767),
    [anon_sym_LR_DQUOTE] = ACTIONS(6767),
    [anon_sym_uR_DQUOTE] = ACTIONS(6767),
    [anon_sym_UR_DQUOTE] = ACTIONS(6767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6767),
    [anon_sym_DASH_GT_STAR] = ACTIONS(7388),
    [sym_literal_suffix] = ACTIONS(7386),
  },
  [3337] = {
    [sym_string_literal] = STATE(3374),
    [sym_raw_string_literal] = STATE(3374),
    [aux_sym_concatenated_string_repeat1] = STATE(3374),
    [sym_identifier] = ACTIONS(7744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7190),
    [anon_sym_COMMA] = ACTIONS(7190),
    [anon_sym_RPAREN] = ACTIONS(7190),
    [anon_sym_LPAREN2] = ACTIONS(7190),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_STAR] = ACTIONS(7192),
    [anon_sym_SLASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [anon_sym_PIPE_PIPE] = ACTIONS(7190),
    [anon_sym_AMP_AMP] = ACTIONS(7190),
    [anon_sym_PIPE] = ACTIONS(7192),
    [anon_sym_CARET] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(7192),
    [anon_sym_EQ_EQ] = ACTIONS(7190),
    [anon_sym_BANG_EQ] = ACTIONS(7190),
    [anon_sym_GT] = ACTIONS(7192),
    [anon_sym_GT_EQ] = ACTIONS(7190),
    [anon_sym_LT_EQ] = ACTIONS(7192),
    [anon_sym_LT] = ACTIONS(7192),
    [anon_sym_LT_LT] = ACTIONS(7192),
    [anon_sym_GT_GT] = ACTIONS(7192),
    [anon_sym_LBRACK] = ACTIONS(7190),
    [anon_sym_EQ] = ACTIONS(7192),
    [anon_sym_QMARK] = ACTIONS(7190),
    [anon_sym_STAR_EQ] = ACTIONS(7190),
    [anon_sym_SLASH_EQ] = ACTIONS(7190),
    [anon_sym_PERCENT_EQ] = ACTIONS(7190),
    [anon_sym_PLUS_EQ] = ACTIONS(7190),
    [anon_sym_DASH_EQ] = ACTIONS(7190),
    [anon_sym_LT_LT_EQ] = ACTIONS(7190),
    [anon_sym_GT_GT_EQ] = ACTIONS(7190),
    [anon_sym_AMP_EQ] = ACTIONS(7190),
    [anon_sym_CARET_EQ] = ACTIONS(7190),
    [anon_sym_PIPE_EQ] = ACTIONS(7190),
    [anon_sym_LT_EQ_GT] = ACTIONS(7190),
    [anon_sym_or] = ACTIONS(7192),
    [anon_sym_and] = ACTIONS(7192),
    [anon_sym_bitor] = ACTIONS(7192),
    [anon_sym_xor] = ACTIONS(7192),
    [anon_sym_bitand] = ACTIONS(7192),
    [anon_sym_not_eq] = ACTIONS(7192),
    [anon_sym_is] = ACTIONS(7192),
    [anon_sym_as] = ACTIONS(7192),
    [anon_sym_DASH_DASH] = ACTIONS(7190),
    [anon_sym_PLUS_PLUS] = ACTIONS(7190),
    [anon_sym_DOT] = ACTIONS(7192),
    [anon_sym_DOT_STAR] = ACTIONS(7190),
    [anon_sym_DASH_GT] = ACTIONS(7192),
    [anon_sym_L_DQUOTE] = ACTIONS(5383),
    [anon_sym_u_DQUOTE] = ACTIONS(5383),
    [anon_sym_U_DQUOTE] = ACTIONS(5383),
    [anon_sym_u8_DQUOTE] = ACTIONS(5383),
    [anon_sym_DQUOTE] = ACTIONS(5383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5385),
    [anon_sym_LR_DQUOTE] = ACTIONS(5385),
    [anon_sym_uR_DQUOTE] = ACTIONS(5385),
    [anon_sym_UR_DQUOTE] = ACTIONS(5385),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5385),
    [anon_sym_DASH_GT_STAR] = ACTIONS(7190),
    [sym_literal_suffix] = ACTIONS(7192),
  },
  [3338] = {
    [sym_identifier] = ACTIONS(7746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7748),
    [anon_sym_COMMA] = ACTIONS(7748),
    [anon_sym_RPAREN] = ACTIONS(7748),
    [aux_sym_preproc_if_token2] = ACTIONS(7748),
    [aux_sym_preproc_else_token1] = ACTIONS(7748),
    [aux_sym_preproc_elif_token1] = ACTIONS(7746),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7748),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7748),
    [anon_sym_LPAREN2] = ACTIONS(7748),
    [anon_sym_DASH] = ACTIONS(7746),
    [anon_sym_PLUS] = ACTIONS(7746),
    [anon_sym_STAR] = ACTIONS(7746),
    [anon_sym_SLASH] = ACTIONS(7746),
    [anon_sym_PERCENT] = ACTIONS(7746),
    [anon_sym_PIPE_PIPE] = ACTIONS(7748),
    [anon_sym_AMP_AMP] = ACTIONS(7748),
    [anon_sym_PIPE] = ACTIONS(7746),
    [anon_sym_CARET] = ACTIONS(7746),
    [anon_sym_AMP] = ACTIONS(7746),
    [anon_sym_EQ_EQ] = ACTIONS(7748),
    [anon_sym_BANG_EQ] = ACTIONS(7748),
    [anon_sym_GT] = ACTIONS(7746),
    [anon_sym_GT_EQ] = ACTIONS(7748),
    [anon_sym_LT_EQ] = ACTIONS(7746),
    [anon_sym_LT] = ACTIONS(7746),
    [anon_sym_LT_LT] = ACTIONS(7746),
    [anon_sym_GT_GT] = ACTIONS(7746),
    [anon_sym_COLON] = ACTIONS(7748),
    [anon_sym_SEMI] = ACTIONS(7748),
    [anon_sym___attribute__] = ACTIONS(7746),
    [anon_sym___attribute] = ACTIONS(7746),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7748),
    [anon_sym_RBRACE] = ACTIONS(7748),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_RBRACK] = ACTIONS(7748),
    [anon_sym_EQ] = ACTIONS(7746),
    [anon_sym_QMARK] = ACTIONS(7748),
    [anon_sym_STAR_EQ] = ACTIONS(7748),
    [anon_sym_SLASH_EQ] = ACTIONS(7748),
    [anon_sym_PERCENT_EQ] = ACTIONS(7748),
    [anon_sym_PLUS_EQ] = ACTIONS(7748),
    [anon_sym_DASH_EQ] = ACTIONS(7748),
    [anon_sym_LT_LT_EQ] = ACTIONS(7748),
    [anon_sym_GT_GT_EQ] = ACTIONS(7748),
    [anon_sym_AMP_EQ] = ACTIONS(7748),
    [anon_sym_CARET_EQ] = ACTIONS(7748),
    [anon_sym_PIPE_EQ] = ACTIONS(7748),
    [anon_sym_and_eq] = ACTIONS(7746),
    [anon_sym_or_eq] = ACTIONS(7746),
    [anon_sym_xor_eq] = ACTIONS(7746),
    [anon_sym_LT_EQ_GT] = ACTIONS(7748),
    [anon_sym_or] = ACTIONS(7746),
    [anon_sym_and] = ACTIONS(7746),
    [anon_sym_bitor] = ACTIONS(7746),
    [anon_sym_xor] = ACTIONS(7746),
    [anon_sym_bitand] = ACTIONS(7746),
    [anon_sym_not_eq] = ACTIONS(7746),
    [anon_sym_is] = ACTIONS(7746),
    [anon_sym_as] = ACTIONS(7746),
    [anon_sym_DASH_DASH] = ACTIONS(7748),
    [anon_sym_PLUS_PLUS] = ACTIONS(7748),
    [anon_sym_DOT] = ACTIONS(7746),
    [anon_sym_DOT_STAR] = ACTIONS(7748),
    [anon_sym_DASH_GT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(3),
  },
  [3339] = {
    [sym_identifier] = ACTIONS(7750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7752),
    [anon_sym_COMMA] = ACTIONS(7752),
    [anon_sym_RPAREN] = ACTIONS(7752),
    [aux_sym_preproc_if_token2] = ACTIONS(7752),
    [aux_sym_preproc_else_token1] = ACTIONS(7752),
    [aux_sym_preproc_elif_token1] = ACTIONS(7750),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7752),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7752),
    [anon_sym_LPAREN2] = ACTIONS(7752),
    [anon_sym_DASH] = ACTIONS(7750),
    [anon_sym_PLUS] = ACTIONS(7750),
    [anon_sym_STAR] = ACTIONS(7750),
    [anon_sym_SLASH] = ACTIONS(7750),
    [anon_sym_PERCENT] = ACTIONS(7750),
    [anon_sym_PIPE_PIPE] = ACTIONS(7752),
    [anon_sym_AMP_AMP] = ACTIONS(7752),
    [anon_sym_PIPE] = ACTIONS(7750),
    [anon_sym_CARET] = ACTIONS(7750),
    [anon_sym_AMP] = ACTIONS(7750),
    [anon_sym_EQ_EQ] = ACTIONS(7752),
    [anon_sym_BANG_EQ] = ACTIONS(7752),
    [anon_sym_GT] = ACTIONS(7750),
    [anon_sym_GT_EQ] = ACTIONS(7752),
    [anon_sym_LT_EQ] = ACTIONS(7750),
    [anon_sym_LT] = ACTIONS(7750),
    [anon_sym_LT_LT] = ACTIONS(7750),
    [anon_sym_GT_GT] = ACTIONS(7750),
    [anon_sym_COLON] = ACTIONS(7752),
    [anon_sym_SEMI] = ACTIONS(7752),
    [anon_sym___attribute__] = ACTIONS(7750),
    [anon_sym___attribute] = ACTIONS(7750),
    [anon_sym_LBRACE] = ACTIONS(7752),
    [anon_sym_RBRACE] = ACTIONS(7752),
    [anon_sym_LBRACK] = ACTIONS(7752),
    [anon_sym_RBRACK] = ACTIONS(7752),
    [anon_sym_EQ] = ACTIONS(7750),
    [anon_sym_QMARK] = ACTIONS(7752),
    [anon_sym_STAR_EQ] = ACTIONS(7752),
    [anon_sym_SLASH_EQ] = ACTIONS(7752),
    [anon_sym_PERCENT_EQ] = ACTIONS(7752),
    [anon_sym_PLUS_EQ] = ACTIONS(7752),
    [anon_sym_DASH_EQ] = ACTIONS(7752),
    [anon_sym_LT_LT_EQ] = ACTIONS(7752),
    [anon_sym_GT_GT_EQ] = ACTIONS(7752),
    [anon_sym_AMP_EQ] = ACTIONS(7752),
    [anon_sym_CARET_EQ] = ACTIONS(7752),
    [anon_sym_PIPE_EQ] = ACTIONS(7752),
    [anon_sym_and_eq] = ACTIONS(7750),
    [anon_sym_or_eq] = ACTIONS(7750),
    [anon_sym_xor_eq] = ACTIONS(7750),
    [anon_sym_LT_EQ_GT] = ACTIONS(7752),
    [anon_sym_or] = ACTIONS(7750),
    [anon_sym_and] = ACTIONS(7750),
    [anon_sym_bitor] = ACTIONS(7750),
    [anon_sym_xor] = ACTIONS(7750),
    [anon_sym_bitand] = ACTIONS(7750),
    [anon_sym_not_eq] = ACTIONS(7750),
    [anon_sym_is] = ACTIONS(7750),
    [anon_sym_as] = ACTIONS(7750),
    [anon_sym_DASH_DASH] = ACTIONS(7752),
    [anon_sym_PLUS_PLUS] = ACTIONS(7752),
    [anon_sym_DOT] = ACTIONS(7750),
    [anon_sym_DOT_STAR] = ACTIONS(7752),
    [anon_sym_DASH_GT] = ACTIONS(7752),
    [sym_comment] = ACTIONS(3),
  },
  [3340] = {
    [sym_string_literal] = STATE(3340),
    [sym_raw_string_literal] = STATE(3340),
    [aux_sym_concatenated_string_repeat1] = STATE(3340),
    [sym_identifier] = ACTIONS(7754),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7205),
    [anon_sym_COMMA] = ACTIONS(7205),
    [anon_sym_RPAREN] = ACTIONS(7205),
    [anon_sym_LPAREN2] = ACTIONS(7205),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_PLUS] = ACTIONS(7207),
    [anon_sym_STAR] = ACTIONS(7207),
    [anon_sym_SLASH] = ACTIONS(7207),
    [anon_sym_PERCENT] = ACTIONS(7207),
    [anon_sym_PIPE_PIPE] = ACTIONS(7205),
    [anon_sym_AMP_AMP] = ACTIONS(7205),
    [anon_sym_PIPE] = ACTIONS(7207),
    [anon_sym_CARET] = ACTIONS(7207),
    [anon_sym_AMP] = ACTIONS(7207),
    [anon_sym_EQ_EQ] = ACTIONS(7205),
    [anon_sym_BANG_EQ] = ACTIONS(7205),
    [anon_sym_GT] = ACTIONS(7207),
    [anon_sym_GT_EQ] = ACTIONS(7205),
    [anon_sym_LT_EQ] = ACTIONS(7207),
    [anon_sym_LT] = ACTIONS(7207),
    [anon_sym_LT_LT] = ACTIONS(7207),
    [anon_sym_GT_GT] = ACTIONS(7207),
    [anon_sym_LBRACK] = ACTIONS(7205),
    [anon_sym_EQ] = ACTIONS(7207),
    [anon_sym_QMARK] = ACTIONS(7205),
    [anon_sym_STAR_EQ] = ACTIONS(7205),
    [anon_sym_SLASH_EQ] = ACTIONS(7205),
    [anon_sym_PERCENT_EQ] = ACTIONS(7205),
    [anon_sym_PLUS_EQ] = ACTIONS(7205),
    [anon_sym_DASH_EQ] = ACTIONS(7205),
    [anon_sym_LT_LT_EQ] = ACTIONS(7205),
    [anon_sym_GT_GT_EQ] = ACTIONS(7205),
    [anon_sym_AMP_EQ] = ACTIONS(7205),
    [anon_sym_CARET_EQ] = ACTIONS(7205),
    [anon_sym_PIPE_EQ] = ACTIONS(7205),
    [anon_sym_LT_EQ_GT] = ACTIONS(7205),
    [anon_sym_or] = ACTIONS(7207),
    [anon_sym_and] = ACTIONS(7207),
    [anon_sym_bitor] = ACTIONS(7207),
    [anon_sym_xor] = ACTIONS(7207),
    [anon_sym_bitand] = ACTIONS(7207),
    [anon_sym_not_eq] = ACTIONS(7207),
    [anon_sym_is] = ACTIONS(7207),
    [anon_sym_as] = ACTIONS(7207),
    [anon_sym_DASH_DASH] = ACTIONS(7205),
    [anon_sym_PLUS_PLUS] = ACTIONS(7205),
    [anon_sym_DOT] = ACTIONS(7207),
    [anon_sym_DOT_STAR] = ACTIONS(7205),
    [anon_sym_DASH_GT] = ACTIONS(7207),
    [anon_sym_L_DQUOTE] = ACTIONS(7757),
    [anon_sym_u_DQUOTE] = ACTIONS(7757),
    [anon_sym_U_DQUOTE] = ACTIONS(7757),
    [anon_sym_u8_DQUOTE] = ACTIONS(7757),
    [anon_sym_DQUOTE] = ACTIONS(7757),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7760),
    [anon_sym_LR_DQUOTE] = ACTIONS(7760),
    [anon_sym_uR_DQUOTE] = ACTIONS(7760),
    [anon_sym_UR_DQUOTE] = ACTIONS(7760),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7760),
    [anon_sym_DASH_GT_STAR] = ACTIONS(7205),
    [sym_literal_suffix] = ACTIONS(7207),
  },
  [3341] = {
    [sym_identifier] = ACTIONS(4716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4718),
    [anon_sym_COMMA] = ACTIONS(4718),
    [anon_sym_RPAREN] = ACTIONS(4718),
    [aux_sym_preproc_if_token2] = ACTIONS(4718),
    [aux_sym_preproc_else_token1] = ACTIONS(4718),
    [aux_sym_preproc_elif_token1] = ACTIONS(4716),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4718),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4718),
    [anon_sym_LPAREN2] = ACTIONS(4718),
    [anon_sym_DASH] = ACTIONS(4716),
    [anon_sym_PLUS] = ACTIONS(4716),
    [anon_sym_STAR] = ACTIONS(4716),
    [anon_sym_SLASH] = ACTIONS(4716),
    [anon_sym_PERCENT] = ACTIONS(4716),
    [anon_sym_PIPE_PIPE] = ACTIONS(4718),
    [anon_sym_AMP_AMP] = ACTIONS(4718),
    [anon_sym_PIPE] = ACTIONS(4716),
    [anon_sym_CARET] = ACTIONS(4716),
    [anon_sym_AMP] = ACTIONS(4716),
    [anon_sym_EQ_EQ] = ACTIONS(4718),
    [anon_sym_BANG_EQ] = ACTIONS(4718),
    [anon_sym_GT] = ACTIONS(4716),
    [anon_sym_GT_EQ] = ACTIONS(4718),
    [anon_sym_LT_EQ] = ACTIONS(4716),
    [anon_sym_LT] = ACTIONS(4716),
    [anon_sym_LT_LT] = ACTIONS(4716),
    [anon_sym_GT_GT] = ACTIONS(4716),
    [anon_sym_COLON] = ACTIONS(4718),
    [anon_sym_SEMI] = ACTIONS(4718),
    [anon_sym___attribute__] = ACTIONS(4716),
    [anon_sym___attribute] = ACTIONS(4716),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4718),
    [anon_sym_RBRACE] = ACTIONS(4718),
    [anon_sym_LBRACK] = ACTIONS(4716),
    [anon_sym_RBRACK] = ACTIONS(4718),
    [anon_sym_EQ] = ACTIONS(4716),
    [anon_sym_QMARK] = ACTIONS(4718),
    [anon_sym_STAR_EQ] = ACTIONS(4718),
    [anon_sym_SLASH_EQ] = ACTIONS(4718),
    [anon_sym_PERCENT_EQ] = ACTIONS(4718),
    [anon_sym_PLUS_EQ] = ACTIONS(4718),
    [anon_sym_DASH_EQ] = ACTIONS(4718),
    [anon_sym_LT_LT_EQ] = ACTIONS(4718),
    [anon_sym_GT_GT_EQ] = ACTIONS(4718),
    [anon_sym_AMP_EQ] = ACTIONS(4718),
    [anon_sym_CARET_EQ] = ACTIONS(4718),
    [anon_sym_PIPE_EQ] = ACTIONS(4718),
    [anon_sym_and_eq] = ACTIONS(4716),
    [anon_sym_or_eq] = ACTIONS(4716),
    [anon_sym_xor_eq] = ACTIONS(4716),
    [anon_sym_LT_EQ_GT] = ACTIONS(4718),
    [anon_sym_or] = ACTIONS(4716),
    [anon_sym_and] = ACTIONS(4716),
    [anon_sym_bitor] = ACTIONS(4716),
    [anon_sym_xor] = ACTIONS(4716),
    [anon_sym_bitand] = ACTIONS(4716),
    [anon_sym_not_eq] = ACTIONS(4716),
    [anon_sym_is] = ACTIONS(4716),
    [anon_sym_as] = ACTIONS(4716),
    [anon_sym_DASH_DASH] = ACTIONS(4718),
    [anon_sym_PLUS_PLUS] = ACTIONS(4718),
    [anon_sym_DOT] = ACTIONS(4716),
    [anon_sym_DOT_STAR] = ACTIONS(4718),
    [anon_sym_DASH_GT] = ACTIONS(4718),
    [sym_comment] = ACTIONS(3),
  },
  [3342] = {
    [sym_identifier] = ACTIONS(2243),
    [anon_sym_LPAREN2] = ACTIONS(2247),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_out] = ACTIONS(2243),
    [anon_sym_inout] = ACTIONS(2243),
    [anon_sym_virtual] = ACTIONS(2243),
    [anon_sym_extern] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym___attribute] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2247),
    [anon_sym___declspec] = ACTIONS(2243),
    [anon_sym___based] = ACTIONS(2243),
    [anon_sym_LBRACK] = ACTIONS(2255),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_register] = ACTIONS(2243),
    [anon_sym_inline] = ACTIONS(2243),
    [anon_sym___inline] = ACTIONS(2243),
    [anon_sym___inline__] = ACTIONS(2243),
    [anon_sym___forceinline] = ACTIONS(2243),
    [anon_sym_thread_local] = ACTIONS(2243),
    [anon_sym___thread] = ACTIONS(2243),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym__Nonnull] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [anon_sym_DOT] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2243),
    [anon_sym_let] = ACTIONS(2243),
    [anon_sym_This] = ACTIONS(2243),
    [anon_sym_operator] = ACTIONS(2243),
    [anon_sym_precise] = ACTIONS(2243),
    [anon_sym_shared] = ACTIONS(2243),
    [anon_sym_groupshared] = ACTIONS(2243),
    [anon_sym_uniform] = ACTIONS(2243),
    [anon_sym_row_major] = ACTIONS(2243),
    [anon_sym_column_major] = ACTIONS(2243),
    [anon_sym_globallycoherent] = ACTIONS(2243),
    [anon_sym_centroid] = ACTIONS(2243),
    [anon_sym_noperspective] = ACTIONS(2243),
    [anon_sym_nointerpolation] = ACTIONS(2243),
    [anon_sym_sample] = ACTIONS(2243),
    [anon_sym_linear] = ACTIONS(2243),
    [anon_sym_snorm] = ACTIONS(2243),
    [anon_sym_unorm] = ACTIONS(2243),
    [anon_sym_point] = ACTIONS(2243),
    [anon_sym_line] = ACTIONS(2243),
    [anon_sym_triangleadj] = ACTIONS(2243),
    [anon_sym_lineadj] = ACTIONS(2243),
    [anon_sym_triangle] = ACTIONS(2243),
  },
  [3343] = {
    [sym_identifier] = ACTIONS(7763),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7765),
    [anon_sym_COMMA] = ACTIONS(7765),
    [anon_sym_RPAREN] = ACTIONS(7765),
    [aux_sym_preproc_if_token2] = ACTIONS(7765),
    [aux_sym_preproc_else_token1] = ACTIONS(7765),
    [aux_sym_preproc_elif_token1] = ACTIONS(7763),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7765),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7765),
    [anon_sym_LPAREN2] = ACTIONS(7765),
    [anon_sym_DASH] = ACTIONS(7763),
    [anon_sym_PLUS] = ACTIONS(7763),
    [anon_sym_STAR] = ACTIONS(7763),
    [anon_sym_SLASH] = ACTIONS(7763),
    [anon_sym_PERCENT] = ACTIONS(7763),
    [anon_sym_PIPE_PIPE] = ACTIONS(7765),
    [anon_sym_AMP_AMP] = ACTIONS(7765),
    [anon_sym_PIPE] = ACTIONS(7763),
    [anon_sym_CARET] = ACTIONS(7763),
    [anon_sym_AMP] = ACTIONS(7763),
    [anon_sym_EQ_EQ] = ACTIONS(7765),
    [anon_sym_BANG_EQ] = ACTIONS(7765),
    [anon_sym_GT] = ACTIONS(7763),
    [anon_sym_GT_EQ] = ACTIONS(7765),
    [anon_sym_LT_EQ] = ACTIONS(7763),
    [anon_sym_LT] = ACTIONS(7763),
    [anon_sym_LT_LT] = ACTIONS(7763),
    [anon_sym_GT_GT] = ACTIONS(7763),
    [anon_sym_COLON] = ACTIONS(7765),
    [anon_sym_SEMI] = ACTIONS(7765),
    [anon_sym___attribute__] = ACTIONS(7763),
    [anon_sym___attribute] = ACTIONS(7763),
    [anon_sym_LBRACE] = ACTIONS(7765),
    [anon_sym_RBRACE] = ACTIONS(7765),
    [anon_sym_LBRACK] = ACTIONS(7765),
    [anon_sym_RBRACK] = ACTIONS(7765),
    [anon_sym_EQ] = ACTIONS(7763),
    [anon_sym_QMARK] = ACTIONS(7765),
    [anon_sym_STAR_EQ] = ACTIONS(7765),
    [anon_sym_SLASH_EQ] = ACTIONS(7765),
    [anon_sym_PERCENT_EQ] = ACTIONS(7765),
    [anon_sym_PLUS_EQ] = ACTIONS(7765),
    [anon_sym_DASH_EQ] = ACTIONS(7765),
    [anon_sym_LT_LT_EQ] = ACTIONS(7765),
    [anon_sym_GT_GT_EQ] = ACTIONS(7765),
    [anon_sym_AMP_EQ] = ACTIONS(7765),
    [anon_sym_CARET_EQ] = ACTIONS(7765),
    [anon_sym_PIPE_EQ] = ACTIONS(7765),
    [anon_sym_and_eq] = ACTIONS(7763),
    [anon_sym_or_eq] = ACTIONS(7763),
    [anon_sym_xor_eq] = ACTIONS(7763),
    [anon_sym_LT_EQ_GT] = ACTIONS(7765),
    [anon_sym_or] = ACTIONS(7763),
    [anon_sym_and] = ACTIONS(7763),
    [anon_sym_bitor] = ACTIONS(7763),
    [anon_sym_xor] = ACTIONS(7763),
    [anon_sym_bitand] = ACTIONS(7763),
    [anon_sym_not_eq] = ACTIONS(7763),
    [anon_sym_is] = ACTIONS(7763),
    [anon_sym_as] = ACTIONS(7763),
    [anon_sym_DASH_DASH] = ACTIONS(7765),
    [anon_sym_PLUS_PLUS] = ACTIONS(7765),
    [anon_sym_DOT] = ACTIONS(7763),
    [anon_sym_DOT_STAR] = ACTIONS(7765),
    [anon_sym_DASH_GT] = ACTIONS(7765),
    [sym_comment] = ACTIONS(3),
  },
  [3344] = {
    [sym_attribute_specifier] = STATE(3229),
    [sym_enumerator_list] = STATE(3145),
    [sym__enum_base_clause] = STATE(3128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3504),
    [anon_sym_COMMA] = ACTIONS(3504),
    [anon_sym_RPAREN] = ACTIONS(3504),
    [anon_sym_LPAREN2] = ACTIONS(3504),
    [anon_sym_DASH] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(3502),
    [anon_sym_STAR] = ACTIONS(3502),
    [anon_sym_SLASH] = ACTIONS(3502),
    [anon_sym_PERCENT] = ACTIONS(3502),
    [anon_sym_PIPE_PIPE] = ACTIONS(3504),
    [anon_sym_AMP_AMP] = ACTIONS(3504),
    [anon_sym_PIPE] = ACTIONS(3502),
    [anon_sym_CARET] = ACTIONS(3502),
    [anon_sym_AMP] = ACTIONS(3502),
    [anon_sym_EQ_EQ] = ACTIONS(3504),
    [anon_sym_BANG_EQ] = ACTIONS(3504),
    [anon_sym_GT] = ACTIONS(3502),
    [anon_sym_GT_EQ] = ACTIONS(3504),
    [anon_sym_LT_EQ] = ACTIONS(3502),
    [anon_sym_LT] = ACTIONS(3502),
    [anon_sym_LT_LT] = ACTIONS(3502),
    [anon_sym_GT_GT] = ACTIONS(3502),
    [anon_sym_COLON] = ACTIONS(7767),
    [anon_sym_SEMI] = ACTIONS(3504),
    [anon_sym___attribute__] = ACTIONS(7769),
    [anon_sym___attribute] = ACTIONS(7254),
    [anon_sym_LBRACE] = ACTIONS(7384),
    [anon_sym_RBRACE] = ACTIONS(3504),
    [anon_sym_LBRACK] = ACTIONS(3504),
    [anon_sym_RBRACK] = ACTIONS(3504),
    [anon_sym_EQ] = ACTIONS(3502),
    [anon_sym_QMARK] = ACTIONS(3504),
    [anon_sym_STAR_EQ] = ACTIONS(3504),
    [anon_sym_SLASH_EQ] = ACTIONS(3504),
    [anon_sym_PERCENT_EQ] = ACTIONS(3504),
    [anon_sym_PLUS_EQ] = ACTIONS(3504),
    [anon_sym_DASH_EQ] = ACTIONS(3504),
    [anon_sym_LT_LT_EQ] = ACTIONS(3504),
    [anon_sym_GT_GT_EQ] = ACTIONS(3504),
    [anon_sym_AMP_EQ] = ACTIONS(3504),
    [anon_sym_CARET_EQ] = ACTIONS(3504),
    [anon_sym_PIPE_EQ] = ACTIONS(3504),
    [anon_sym_and_eq] = ACTIONS(3504),
    [anon_sym_or_eq] = ACTIONS(3504),
    [anon_sym_xor_eq] = ACTIONS(3504),
    [anon_sym_LT_EQ_GT] = ACTIONS(3504),
    [anon_sym_or] = ACTIONS(3502),
    [anon_sym_and] = ACTIONS(3502),
    [anon_sym_bitor] = ACTIONS(3504),
    [anon_sym_xor] = ACTIONS(3502),
    [anon_sym_bitand] = ACTIONS(3504),
    [anon_sym_not_eq] = ACTIONS(3504),
    [anon_sym_is] = ACTIONS(3504),
    [anon_sym_as] = ACTIONS(3504),
    [anon_sym_DASH_DASH] = ACTIONS(3504),
    [anon_sym_PLUS_PLUS] = ACTIONS(3504),
    [anon_sym_DOT] = ACTIONS(3502),
    [anon_sym_DOT_STAR] = ACTIONS(3504),
    [anon_sym_DASH_GT] = ACTIONS(3504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3504),
    [anon_sym_let] = ACTIONS(3504),
    [anon_sym_This] = ACTIONS(3504),
  },
  [3345] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7152),
    [anon_sym_COMMA] = ACTIONS(7152),
    [anon_sym_LPAREN2] = ACTIONS(7152),
    [anon_sym_DASH] = ACTIONS(7150),
    [anon_sym_PLUS] = ACTIONS(7150),
    [anon_sym_STAR] = ACTIONS(7150),
    [anon_sym_SLASH] = ACTIONS(7150),
    [anon_sym_PERCENT] = ACTIONS(7150),
    [anon_sym_PIPE_PIPE] = ACTIONS(7152),
    [anon_sym_AMP_AMP] = ACTIONS(7152),
    [anon_sym_PIPE] = ACTIONS(7150),
    [anon_sym_CARET] = ACTIONS(7150),
    [anon_sym_AMP] = ACTIONS(7150),
    [anon_sym_EQ_EQ] = ACTIONS(7152),
    [anon_sym_BANG_EQ] = ACTIONS(7152),
    [anon_sym_GT] = ACTIONS(7150),
    [anon_sym_GT_EQ] = ACTIONS(7152),
    [anon_sym_LT_EQ] = ACTIONS(7150),
    [anon_sym_LT] = ACTIONS(7150),
    [anon_sym_LT_LT] = ACTIONS(7150),
    [anon_sym_GT_GT] = ACTIONS(7150),
    [anon_sym_SEMI] = ACTIONS(7152),
    [anon_sym___attribute__] = ACTIONS(7150),
    [anon_sym___attribute] = ACTIONS(7150),
    [anon_sym_LBRACK] = ACTIONS(7152),
    [anon_sym_EQ] = ACTIONS(7150),
    [anon_sym_QMARK] = ACTIONS(7152),
    [anon_sym_STAR_EQ] = ACTIONS(7152),
    [anon_sym_SLASH_EQ] = ACTIONS(7152),
    [anon_sym_PERCENT_EQ] = ACTIONS(7152),
    [anon_sym_PLUS_EQ] = ACTIONS(7152),
    [anon_sym_DASH_EQ] = ACTIONS(7152),
    [anon_sym_LT_LT_EQ] = ACTIONS(7152),
    [anon_sym_GT_GT_EQ] = ACTIONS(7152),
    [anon_sym_AMP_EQ] = ACTIONS(7152),
    [anon_sym_CARET_EQ] = ACTIONS(7152),
    [anon_sym_PIPE_EQ] = ACTIONS(7152),
    [anon_sym_and_eq] = ACTIONS(7150),
    [anon_sym_or_eq] = ACTIONS(7150),
    [anon_sym_xor_eq] = ACTIONS(7150),
    [anon_sym_LT_EQ_GT] = ACTIONS(7152),
    [anon_sym_or] = ACTIONS(7150),
    [anon_sym_and] = ACTIONS(7150),
    [anon_sym_bitor] = ACTIONS(7150),
    [anon_sym_xor] = ACTIONS(7150),
    [anon_sym_bitand] = ACTIONS(7150),
    [anon_sym_not_eq] = ACTIONS(7150),
    [anon_sym_is] = ACTIONS(7150),
    [anon_sym_as] = ACTIONS(7150),
    [anon_sym_DASH_DASH] = ACTIONS(7152),
    [anon_sym_PLUS_PLUS] = ACTIONS(7152),
    [anon_sym_DOT] = ACTIONS(7150),
    [anon_sym_DOT_STAR] = ACTIONS(7152),
    [anon_sym_DASH_GT] = ACTIONS(7152),
    [anon_sym_L_DQUOTE] = ACTIONS(7152),
    [anon_sym_u_DQUOTE] = ACTIONS(7152),
    [anon_sym_U_DQUOTE] = ACTIONS(7152),
    [anon_sym_u8_DQUOTE] = ACTIONS(7152),
    [anon_sym_DQUOTE] = ACTIONS(7152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7152),
    [anon_sym_LR_DQUOTE] = ACTIONS(7152),
    [anon_sym_uR_DQUOTE] = ACTIONS(7152),
    [anon_sym_UR_DQUOTE] = ACTIONS(7152),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7152),
    [sym_literal_suffix] = ACTIONS(7150),
  },
  [3346] = {
    [sym_identifier] = ACTIONS(7158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7160),
    [anon_sym_COMMA] = ACTIONS(7160),
    [anon_sym_RPAREN] = ACTIONS(7160),
    [anon_sym_LPAREN2] = ACTIONS(7160),
    [anon_sym_DASH] = ACTIONS(7158),
    [anon_sym_PLUS] = ACTIONS(7158),
    [anon_sym_STAR] = ACTIONS(7158),
    [anon_sym_SLASH] = ACTIONS(7158),
    [anon_sym_PERCENT] = ACTIONS(7158),
    [anon_sym_PIPE_PIPE] = ACTIONS(7160),
    [anon_sym_AMP_AMP] = ACTIONS(7160),
    [anon_sym_PIPE] = ACTIONS(7158),
    [anon_sym_CARET] = ACTIONS(7158),
    [anon_sym_AMP] = ACTIONS(7158),
    [anon_sym_EQ_EQ] = ACTIONS(7160),
    [anon_sym_BANG_EQ] = ACTIONS(7160),
    [anon_sym_GT] = ACTIONS(7158),
    [anon_sym_GT_EQ] = ACTIONS(7160),
    [anon_sym_LT_EQ] = ACTIONS(7158),
    [anon_sym_LT] = ACTIONS(7158),
    [anon_sym_LT_LT] = ACTIONS(7158),
    [anon_sym_GT_GT] = ACTIONS(7158),
    [anon_sym_LBRACK] = ACTIONS(7160),
    [anon_sym_EQ] = ACTIONS(7158),
    [anon_sym_QMARK] = ACTIONS(7160),
    [anon_sym_STAR_EQ] = ACTIONS(7160),
    [anon_sym_SLASH_EQ] = ACTIONS(7160),
    [anon_sym_PERCENT_EQ] = ACTIONS(7160),
    [anon_sym_PLUS_EQ] = ACTIONS(7160),
    [anon_sym_DASH_EQ] = ACTIONS(7160),
    [anon_sym_LT_LT_EQ] = ACTIONS(7160),
    [anon_sym_GT_GT_EQ] = ACTIONS(7160),
    [anon_sym_AMP_EQ] = ACTIONS(7160),
    [anon_sym_CARET_EQ] = ACTIONS(7160),
    [anon_sym_PIPE_EQ] = ACTIONS(7160),
    [anon_sym_and_eq] = ACTIONS(7158),
    [anon_sym_or_eq] = ACTIONS(7158),
    [anon_sym_xor_eq] = ACTIONS(7158),
    [anon_sym_LT_EQ_GT] = ACTIONS(7160),
    [anon_sym_or] = ACTIONS(7158),
    [anon_sym_and] = ACTIONS(7158),
    [anon_sym_bitor] = ACTIONS(7158),
    [anon_sym_xor] = ACTIONS(7158),
    [anon_sym_bitand] = ACTIONS(7158),
    [anon_sym_not_eq] = ACTIONS(7158),
    [anon_sym_is] = ACTIONS(7158),
    [anon_sym_as] = ACTIONS(7158),
    [anon_sym_DASH_DASH] = ACTIONS(7160),
    [anon_sym_PLUS_PLUS] = ACTIONS(7160),
    [anon_sym_DOT] = ACTIONS(7158),
    [anon_sym_DOT_STAR] = ACTIONS(7160),
    [anon_sym_DASH_GT] = ACTIONS(7158),
    [anon_sym_L_DQUOTE] = ACTIONS(7160),
    [anon_sym_u_DQUOTE] = ACTIONS(7160),
    [anon_sym_U_DQUOTE] = ACTIONS(7160),
    [anon_sym_u8_DQUOTE] = ACTIONS(7160),
    [anon_sym_DQUOTE] = ACTIONS(7160),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7160),
    [anon_sym_LR_DQUOTE] = ACTIONS(7160),
    [anon_sym_uR_DQUOTE] = ACTIONS(7160),
    [anon_sym_UR_DQUOTE] = ACTIONS(7160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7160),
    [anon_sym_DASH_GT_STAR] = ACTIONS(7160),
    [sym_literal_suffix] = ACTIONS(7158),
  },
  [3347] = {
    [sym_identifier] = ACTIONS(7763),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7765),
    [anon_sym_COMMA] = ACTIONS(7765),
    [anon_sym_RPAREN] = ACTIONS(7765),
    [aux_sym_preproc_if_token2] = ACTIONS(7765),
    [aux_sym_preproc_else_token1] = ACTIONS(7765),
    [aux_sym_preproc_elif_token1] = ACTIONS(7763),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7765),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7765),
    [anon_sym_LPAREN2] = ACTIONS(7765),
    [anon_sym_DASH] = ACTIONS(7763),
    [anon_sym_PLUS] = ACTIONS(7763),
    [anon_sym_STAR] = ACTIONS(7763),
    [anon_sym_SLASH] = ACTIONS(7763),
    [anon_sym_PERCENT] = ACTIONS(7763),
    [anon_sym_PIPE_PIPE] = ACTIONS(7765),
    [anon_sym_AMP_AMP] = ACTIONS(7765),
    [anon_sym_PIPE] = ACTIONS(7763),
    [anon_sym_CARET] = ACTIONS(7763),
    [anon_sym_AMP] = ACTIONS(7763),
    [anon_sym_EQ_EQ] = ACTIONS(7765),
    [anon_sym_BANG_EQ] = ACTIONS(7765),
    [anon_sym_GT] = ACTIONS(7763),
    [anon_sym_GT_EQ] = ACTIONS(7765),
    [anon_sym_LT_EQ] = ACTIONS(7763),
    [anon_sym_LT] = ACTIONS(7763),
    [anon_sym_LT_LT] = ACTIONS(7763),
    [anon_sym_GT_GT] = ACTIONS(7763),
    [anon_sym_COLON] = ACTIONS(7765),
    [anon_sym_SEMI] = ACTIONS(7765),
    [anon_sym___attribute__] = ACTIONS(7763),
    [anon_sym___attribute] = ACTIONS(7763),
    [anon_sym_LBRACE] = ACTIONS(7765),
    [anon_sym_RBRACE] = ACTIONS(7765),
    [anon_sym_LBRACK] = ACTIONS(7765),
    [anon_sym_RBRACK] = ACTIONS(7765),
    [anon_sym_EQ] = ACTIONS(7763),
    [anon_sym_QMARK] = ACTIONS(7765),
    [anon_sym_STAR_EQ] = ACTIONS(7765),
    [anon_sym_SLASH_EQ] = ACTIONS(7765),
    [anon_sym_PERCENT_EQ] = ACTIONS(7765),
    [anon_sym_PLUS_EQ] = ACTIONS(7765),
    [anon_sym_DASH_EQ] = ACTIONS(7765),
    [anon_sym_LT_LT_EQ] = ACTIONS(7765),
    [anon_sym_GT_GT_EQ] = ACTIONS(7765),
    [anon_sym_AMP_EQ] = ACTIONS(7765),
    [anon_sym_CARET_EQ] = ACTIONS(7765),
    [anon_sym_PIPE_EQ] = ACTIONS(7765),
    [anon_sym_and_eq] = ACTIONS(7763),
    [anon_sym_or_eq] = ACTIONS(7763),
    [anon_sym_xor_eq] = ACTIONS(7763),
    [anon_sym_LT_EQ_GT] = ACTIONS(7765),
    [anon_sym_or] = ACTIONS(7763),
    [anon_sym_and] = ACTIONS(7763),
    [anon_sym_bitor] = ACTIONS(7763),
    [anon_sym_xor] = ACTIONS(7763),
    [anon_sym_bitand] = ACTIONS(7763),
    [anon_sym_not_eq] = ACTIONS(7763),
    [anon_sym_is] = ACTIONS(7763),
    [anon_sym_as] = ACTIONS(7763),
    [anon_sym_DASH_DASH] = ACTIONS(7765),
    [anon_sym_PLUS_PLUS] = ACTIONS(7765),
    [anon_sym_DOT] = ACTIONS(7763),
    [anon_sym_DOT_STAR] = ACTIONS(7765),
    [anon_sym_DASH_GT] = ACTIONS(7765),
    [sym_comment] = ACTIONS(3),
  },
  [3348] = {
    [sym_identifier] = ACTIONS(7763),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7765),
    [anon_sym_COMMA] = ACTIONS(7765),
    [anon_sym_RPAREN] = ACTIONS(7765),
    [aux_sym_preproc_if_token2] = ACTIONS(7765),
    [aux_sym_preproc_else_token1] = ACTIONS(7765),
    [aux_sym_preproc_elif_token1] = ACTIONS(7763),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7765),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7765),
    [anon_sym_LPAREN2] = ACTIONS(7765),
    [anon_sym_DASH] = ACTIONS(7763),
    [anon_sym_PLUS] = ACTIONS(7763),
    [anon_sym_STAR] = ACTIONS(7763),
    [anon_sym_SLASH] = ACTIONS(7763),
    [anon_sym_PERCENT] = ACTIONS(7763),
    [anon_sym_PIPE_PIPE] = ACTIONS(7765),
    [anon_sym_AMP_AMP] = ACTIONS(7765),
    [anon_sym_PIPE] = ACTIONS(7763),
    [anon_sym_CARET] = ACTIONS(7763),
    [anon_sym_AMP] = ACTIONS(7763),
    [anon_sym_EQ_EQ] = ACTIONS(7765),
    [anon_sym_BANG_EQ] = ACTIONS(7765),
    [anon_sym_GT] = ACTIONS(7763),
    [anon_sym_GT_EQ] = ACTIONS(7765),
    [anon_sym_LT_EQ] = ACTIONS(7763),
    [anon_sym_LT] = ACTIONS(7763),
    [anon_sym_LT_LT] = ACTIONS(7763),
    [anon_sym_GT_GT] = ACTIONS(7763),
    [anon_sym_COLON] = ACTIONS(7765),
    [anon_sym_SEMI] = ACTIONS(7765),
    [anon_sym___attribute__] = ACTIONS(7763),
    [anon_sym___attribute] = ACTIONS(7763),
    [anon_sym_LBRACE] = ACTIONS(7765),
    [anon_sym_RBRACE] = ACTIONS(7765),
    [anon_sym_LBRACK] = ACTIONS(7765),
    [anon_sym_RBRACK] = ACTIONS(7765),
    [anon_sym_EQ] = ACTIONS(7763),
    [anon_sym_QMARK] = ACTIONS(7765),
    [anon_sym_STAR_EQ] = ACTIONS(7765),
    [anon_sym_SLASH_EQ] = ACTIONS(7765),
    [anon_sym_PERCENT_EQ] = ACTIONS(7765),
    [anon_sym_PLUS_EQ] = ACTIONS(7765),
    [anon_sym_DASH_EQ] = ACTIONS(7765),
    [anon_sym_LT_LT_EQ] = ACTIONS(7765),
    [anon_sym_GT_GT_EQ] = ACTIONS(7765),
    [anon_sym_AMP_EQ] = ACTIONS(7765),
    [anon_sym_CARET_EQ] = ACTIONS(7765),
    [anon_sym_PIPE_EQ] = ACTIONS(7765),
    [anon_sym_and_eq] = ACTIONS(7763),
    [anon_sym_or_eq] = ACTIONS(7763),
    [anon_sym_xor_eq] = ACTIONS(7763),
    [anon_sym_LT_EQ_GT] = ACTIONS(7765),
    [anon_sym_or] = ACTIONS(7763),
    [anon_sym_and] = ACTIONS(7763),
    [anon_sym_bitor] = ACTIONS(7763),
    [anon_sym_xor] = ACTIONS(7763),
    [anon_sym_bitand] = ACTIONS(7763),
    [anon_sym_not_eq] = ACTIONS(7763),
    [anon_sym_is] = ACTIONS(7763),
    [anon_sym_as] = ACTIONS(7763),
    [anon_sym_DASH_DASH] = ACTIONS(7765),
    [anon_sym_PLUS_PLUS] = ACTIONS(7765),
    [anon_sym_DOT] = ACTIONS(7763),
    [anon_sym_DOT_STAR] = ACTIONS(7765),
    [anon_sym_DASH_GT] = ACTIONS(7765),
    [sym_comment] = ACTIONS(3),
  },
  [3349] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7160),
    [anon_sym_COMMA] = ACTIONS(7160),
    [anon_sym_LPAREN2] = ACTIONS(7160),
    [anon_sym_DASH] = ACTIONS(7158),
    [anon_sym_PLUS] = ACTIONS(7158),
    [anon_sym_STAR] = ACTIONS(7158),
    [anon_sym_SLASH] = ACTIONS(7158),
    [anon_sym_PERCENT] = ACTIONS(7158),
    [anon_sym_PIPE_PIPE] = ACTIONS(7160),
    [anon_sym_AMP_AMP] = ACTIONS(7160),
    [anon_sym_PIPE] = ACTIONS(7158),
    [anon_sym_CARET] = ACTIONS(7158),
    [anon_sym_AMP] = ACTIONS(7158),
    [anon_sym_EQ_EQ] = ACTIONS(7160),
    [anon_sym_BANG_EQ] = ACTIONS(7160),
    [anon_sym_GT] = ACTIONS(7158),
    [anon_sym_GT_EQ] = ACTIONS(7160),
    [anon_sym_LT_EQ] = ACTIONS(7158),
    [anon_sym_LT] = ACTIONS(7158),
    [anon_sym_LT_LT] = ACTIONS(7158),
    [anon_sym_GT_GT] = ACTIONS(7158),
    [anon_sym_SEMI] = ACTIONS(7160),
    [anon_sym___attribute__] = ACTIONS(7158),
    [anon_sym___attribute] = ACTIONS(7158),
    [anon_sym_LBRACK] = ACTIONS(7160),
    [anon_sym_EQ] = ACTIONS(7158),
    [anon_sym_QMARK] = ACTIONS(7160),
    [anon_sym_STAR_EQ] = ACTIONS(7160),
    [anon_sym_SLASH_EQ] = ACTIONS(7160),
    [anon_sym_PERCENT_EQ] = ACTIONS(7160),
    [anon_sym_PLUS_EQ] = ACTIONS(7160),
    [anon_sym_DASH_EQ] = ACTIONS(7160),
    [anon_sym_LT_LT_EQ] = ACTIONS(7160),
    [anon_sym_GT_GT_EQ] = ACTIONS(7160),
    [anon_sym_AMP_EQ] = ACTIONS(7160),
    [anon_sym_CARET_EQ] = ACTIONS(7160),
    [anon_sym_PIPE_EQ] = ACTIONS(7160),
    [anon_sym_and_eq] = ACTIONS(7158),
    [anon_sym_or_eq] = ACTIONS(7158),
    [anon_sym_xor_eq] = ACTIONS(7158),
    [anon_sym_LT_EQ_GT] = ACTIONS(7160),
    [anon_sym_or] = ACTIONS(7158),
    [anon_sym_and] = ACTIONS(7158),
    [anon_sym_bitor] = ACTIONS(7158),
    [anon_sym_xor] = ACTIONS(7158),
    [anon_sym_bitand] = ACTIONS(7158),
    [anon_sym_not_eq] = ACTIONS(7158),
    [anon_sym_is] = ACTIONS(7158),
    [anon_sym_as] = ACTIONS(7158),
    [anon_sym_DASH_DASH] = ACTIONS(7160),
    [anon_sym_PLUS_PLUS] = ACTIONS(7160),
    [anon_sym_DOT] = ACTIONS(7158),
    [anon_sym_DOT_STAR] = ACTIONS(7160),
    [anon_sym_DASH_GT] = ACTIONS(7160),
    [anon_sym_L_DQUOTE] = ACTIONS(7160),
    [anon_sym_u_DQUOTE] = ACTIONS(7160),
    [anon_sym_U_DQUOTE] = ACTIONS(7160),
    [anon_sym_u8_DQUOTE] = ACTIONS(7160),
    [anon_sym_DQUOTE] = ACTIONS(7160),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7160),
    [anon_sym_LR_DQUOTE] = ACTIONS(7160),
    [anon_sym_uR_DQUOTE] = ACTIONS(7160),
    [anon_sym_UR_DQUOTE] = ACTIONS(7160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7160),
    [sym_literal_suffix] = ACTIONS(7158),
  },
  [3350] = {
    [sym_argument_list] = STATE(3465),
    [sym_subscript_argument_list] = STATE(3430),
    [sym_identifier] = ACTIONS(7771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7773),
    [anon_sym_COMMA] = ACTIONS(7773),
    [anon_sym_RPAREN] = ACTIONS(7773),
    [aux_sym_preproc_if_token2] = ACTIONS(7773),
    [aux_sym_preproc_else_token1] = ACTIONS(7773),
    [aux_sym_preproc_elif_token1] = ACTIONS(7771),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7773),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7773),
    [anon_sym_LPAREN2] = ACTIONS(7358),
    [anon_sym_DASH] = ACTIONS(7771),
    [anon_sym_PLUS] = ACTIONS(7771),
    [anon_sym_STAR] = ACTIONS(7771),
    [anon_sym_SLASH] = ACTIONS(7771),
    [anon_sym_PERCENT] = ACTIONS(7771),
    [anon_sym_PIPE_PIPE] = ACTIONS(7773),
    [anon_sym_AMP_AMP] = ACTIONS(7773),
    [anon_sym_PIPE] = ACTIONS(7771),
    [anon_sym_CARET] = ACTIONS(7771),
    [anon_sym_AMP] = ACTIONS(7771),
    [anon_sym_EQ_EQ] = ACTIONS(7773),
    [anon_sym_BANG_EQ] = ACTIONS(7773),
    [anon_sym_GT] = ACTIONS(7771),
    [anon_sym_GT_EQ] = ACTIONS(7773),
    [anon_sym_LT_EQ] = ACTIONS(7771),
    [anon_sym_LT] = ACTIONS(7771),
    [anon_sym_LT_LT] = ACTIONS(7771),
    [anon_sym_GT_GT] = ACTIONS(7771),
    [anon_sym_SEMI] = ACTIONS(7773),
    [anon_sym___attribute__] = ACTIONS(7771),
    [anon_sym___attribute] = ACTIONS(7771),
    [anon_sym_RBRACE] = ACTIONS(7773),
    [anon_sym_LBRACK] = ACTIONS(7775),
    [anon_sym_RBRACK] = ACTIONS(7773),
    [anon_sym_EQ] = ACTIONS(7771),
    [anon_sym_QMARK] = ACTIONS(7773),
    [anon_sym_STAR_EQ] = ACTIONS(7773),
    [anon_sym_SLASH_EQ] = ACTIONS(7773),
    [anon_sym_PERCENT_EQ] = ACTIONS(7773),
    [anon_sym_PLUS_EQ] = ACTIONS(7773),
    [anon_sym_DASH_EQ] = ACTIONS(7773),
    [anon_sym_LT_LT_EQ] = ACTIONS(7773),
    [anon_sym_GT_GT_EQ] = ACTIONS(7773),
    [anon_sym_AMP_EQ] = ACTIONS(7773),
    [anon_sym_CARET_EQ] = ACTIONS(7773),
    [anon_sym_PIPE_EQ] = ACTIONS(7773),
    [anon_sym_and_eq] = ACTIONS(7771),
    [anon_sym_or_eq] = ACTIONS(7771),
    [anon_sym_xor_eq] = ACTIONS(7771),
    [anon_sym_LT_EQ_GT] = ACTIONS(7773),
    [anon_sym_or] = ACTIONS(7771),
    [anon_sym_and] = ACTIONS(7771),
    [anon_sym_bitor] = ACTIONS(7771),
    [anon_sym_xor] = ACTIONS(7771),
    [anon_sym_bitand] = ACTIONS(7771),
    [anon_sym_not_eq] = ACTIONS(7771),
    [anon_sym_is] = ACTIONS(7771),
    [anon_sym_as] = ACTIONS(7771),
    [anon_sym_DASH_DASH] = ACTIONS(7777),
    [anon_sym_PLUS_PLUS] = ACTIONS(7777),
    [anon_sym_DOT] = ACTIONS(7779),
    [anon_sym_DOT_STAR] = ACTIONS(7781),
    [anon_sym_DASH_GT] = ACTIONS(7781),
    [sym_comment] = ACTIONS(3),
  },
  [3351] = {
    [sym_template_argument_list] = STATE(3325),
    [sym_identifier] = ACTIONS(7783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7785),
    [anon_sym_COMMA] = ACTIONS(7785),
    [anon_sym_RPAREN] = ACTIONS(7785),
    [aux_sym_preproc_if_token2] = ACTIONS(7785),
    [aux_sym_preproc_else_token1] = ACTIONS(7785),
    [aux_sym_preproc_elif_token1] = ACTIONS(7783),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7785),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7785),
    [anon_sym_LPAREN2] = ACTIONS(7785),
    [anon_sym_DASH] = ACTIONS(7783),
    [anon_sym_PLUS] = ACTIONS(7783),
    [anon_sym_STAR] = ACTIONS(7783),
    [anon_sym_SLASH] = ACTIONS(7783),
    [anon_sym_PERCENT] = ACTIONS(7783),
    [anon_sym_PIPE_PIPE] = ACTIONS(7785),
    [anon_sym_AMP_AMP] = ACTIONS(7785),
    [anon_sym_PIPE] = ACTIONS(7783),
    [anon_sym_CARET] = ACTIONS(7783),
    [anon_sym_AMP] = ACTIONS(7783),
    [anon_sym_EQ_EQ] = ACTIONS(7785),
    [anon_sym_BANG_EQ] = ACTIONS(7785),
    [anon_sym_GT] = ACTIONS(7783),
    [anon_sym_GT_EQ] = ACTIONS(7785),
    [anon_sym_LT_EQ] = ACTIONS(7783),
    [anon_sym_LT] = ACTIONS(7787),
    [anon_sym_LT_LT] = ACTIONS(7783),
    [anon_sym_GT_GT] = ACTIONS(7783),
    [anon_sym_COLON] = ACTIONS(7785),
    [anon_sym_SEMI] = ACTIONS(7785),
    [anon_sym___attribute__] = ACTIONS(7783),
    [anon_sym___attribute] = ACTIONS(7783),
    [anon_sym_RBRACE] = ACTIONS(7785),
    [anon_sym_LBRACK] = ACTIONS(7785),
    [anon_sym_RBRACK] = ACTIONS(7785),
    [anon_sym_EQ] = ACTIONS(7783),
    [anon_sym_QMARK] = ACTIONS(7785),
    [anon_sym_STAR_EQ] = ACTIONS(7785),
    [anon_sym_SLASH_EQ] = ACTIONS(7785),
    [anon_sym_PERCENT_EQ] = ACTIONS(7785),
    [anon_sym_PLUS_EQ] = ACTIONS(7785),
    [anon_sym_DASH_EQ] = ACTIONS(7785),
    [anon_sym_LT_LT_EQ] = ACTIONS(7785),
    [anon_sym_GT_GT_EQ] = ACTIONS(7785),
    [anon_sym_AMP_EQ] = ACTIONS(7785),
    [anon_sym_CARET_EQ] = ACTIONS(7785),
    [anon_sym_PIPE_EQ] = ACTIONS(7785),
    [anon_sym_and_eq] = ACTIONS(7783),
    [anon_sym_or_eq] = ACTIONS(7783),
    [anon_sym_xor_eq] = ACTIONS(7783),
    [anon_sym_LT_EQ_GT] = ACTIONS(7785),
    [anon_sym_or] = ACTIONS(7783),
    [anon_sym_and] = ACTIONS(7783),
    [anon_sym_bitor] = ACTIONS(7783),
    [anon_sym_xor] = ACTIONS(7783),
    [anon_sym_bitand] = ACTIONS(7783),
    [anon_sym_not_eq] = ACTIONS(7783),
    [anon_sym_is] = ACTIONS(7783),
    [anon_sym_as] = ACTIONS(7783),
    [anon_sym_DASH_DASH] = ACTIONS(7785),
    [anon_sym_PLUS_PLUS] = ACTIONS(7785),
    [anon_sym_DOT] = ACTIONS(7783),
    [anon_sym_DOT_STAR] = ACTIONS(7785),
    [anon_sym_DASH_GT] = ACTIONS(7785),
    [sym_comment] = ACTIONS(3),
  },
  [3352] = {
    [sym_identifier] = ACTIONS(7790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(7792),
    [anon_sym_RPAREN] = ACTIONS(7792),
    [aux_sym_preproc_if_token2] = ACTIONS(7792),
    [aux_sym_preproc_else_token1] = ACTIONS(7792),
    [aux_sym_preproc_elif_token1] = ACTIONS(7790),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7792),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7792),
    [anon_sym_LPAREN2] = ACTIONS(7792),
    [anon_sym_DASH] = ACTIONS(7790),
    [anon_sym_PLUS] = ACTIONS(7790),
    [anon_sym_STAR] = ACTIONS(7790),
    [anon_sym_SLASH] = ACTIONS(7790),
    [anon_sym_PERCENT] = ACTIONS(7790),
    [anon_sym_PIPE_PIPE] = ACTIONS(7792),
    [anon_sym_AMP_AMP] = ACTIONS(7792),
    [anon_sym_PIPE] = ACTIONS(7790),
    [anon_sym_CARET] = ACTIONS(7790),
    [anon_sym_AMP] = ACTIONS(7790),
    [anon_sym_EQ_EQ] = ACTIONS(7792),
    [anon_sym_BANG_EQ] = ACTIONS(7792),
    [anon_sym_GT] = ACTIONS(7790),
    [anon_sym_GT_EQ] = ACTIONS(7792),
    [anon_sym_LT_EQ] = ACTIONS(7790),
    [anon_sym_LT] = ACTIONS(7790),
    [anon_sym_LT_LT] = ACTIONS(7790),
    [anon_sym_GT_GT] = ACTIONS(7790),
    [anon_sym_COLON] = ACTIONS(7792),
    [anon_sym_SEMI] = ACTIONS(7792),
    [anon_sym___attribute__] = ACTIONS(7790),
    [anon_sym___attribute] = ACTIONS(7790),
    [anon_sym_LBRACE] = ACTIONS(7792),
    [anon_sym_RBRACE] = ACTIONS(7792),
    [anon_sym_LBRACK] = ACTIONS(7792),
    [anon_sym_RBRACK] = ACTIONS(7792),
    [anon_sym_EQ] = ACTIONS(7790),
    [anon_sym_QMARK] = ACTIONS(7792),
    [anon_sym_STAR_EQ] = ACTIONS(7792),
    [anon_sym_SLASH_EQ] = ACTIONS(7792),
    [anon_sym_PERCENT_EQ] = ACTIONS(7792),
    [anon_sym_PLUS_EQ] = ACTIONS(7792),
    [anon_sym_DASH_EQ] = ACTIONS(7792),
    [anon_sym_LT_LT_EQ] = ACTIONS(7792),
    [anon_sym_GT_GT_EQ] = ACTIONS(7792),
    [anon_sym_AMP_EQ] = ACTIONS(7792),
    [anon_sym_CARET_EQ] = ACTIONS(7792),
    [anon_sym_PIPE_EQ] = ACTIONS(7792),
    [anon_sym_and_eq] = ACTIONS(7790),
    [anon_sym_or_eq] = ACTIONS(7790),
    [anon_sym_xor_eq] = ACTIONS(7790),
    [anon_sym_LT_EQ_GT] = ACTIONS(7792),
    [anon_sym_or] = ACTIONS(7790),
    [anon_sym_and] = ACTIONS(7790),
    [anon_sym_bitor] = ACTIONS(7790),
    [anon_sym_xor] = ACTIONS(7790),
    [anon_sym_bitand] = ACTIONS(7790),
    [anon_sym_not_eq] = ACTIONS(7790),
    [anon_sym_is] = ACTIONS(7790),
    [anon_sym_as] = ACTIONS(7790),
    [anon_sym_DASH_DASH] = ACTIONS(7792),
    [anon_sym_PLUS_PLUS] = ACTIONS(7792),
    [anon_sym_DOT] = ACTIONS(7790),
    [anon_sym_DOT_STAR] = ACTIONS(7792),
    [anon_sym_DASH_GT] = ACTIONS(7792),
    [sym_comment] = ACTIONS(3),
  },
  [3353] = {
    [sym_argument_list] = STATE(3465),
    [sym_subscript_argument_list] = STATE(3430),
    [sym_identifier] = ACTIONS(7794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7796),
    [anon_sym_COMMA] = ACTIONS(7796),
    [anon_sym_RPAREN] = ACTIONS(7796),
    [aux_sym_preproc_if_token2] = ACTIONS(7796),
    [aux_sym_preproc_else_token1] = ACTIONS(7796),
    [aux_sym_preproc_elif_token1] = ACTIONS(7794),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7796),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7796),
    [anon_sym_LPAREN2] = ACTIONS(7358),
    [anon_sym_DASH] = ACTIONS(7794),
    [anon_sym_PLUS] = ACTIONS(7794),
    [anon_sym_STAR] = ACTIONS(7794),
    [anon_sym_SLASH] = ACTIONS(7794),
    [anon_sym_PERCENT] = ACTIONS(7794),
    [anon_sym_PIPE_PIPE] = ACTIONS(7796),
    [anon_sym_AMP_AMP] = ACTIONS(7796),
    [anon_sym_PIPE] = ACTIONS(7794),
    [anon_sym_CARET] = ACTIONS(7794),
    [anon_sym_AMP] = ACTIONS(7794),
    [anon_sym_EQ_EQ] = ACTIONS(7796),
    [anon_sym_BANG_EQ] = ACTIONS(7796),
    [anon_sym_GT] = ACTIONS(7794),
    [anon_sym_GT_EQ] = ACTIONS(7796),
    [anon_sym_LT_EQ] = ACTIONS(7794),
    [anon_sym_LT] = ACTIONS(7794),
    [anon_sym_LT_LT] = ACTIONS(7794),
    [anon_sym_GT_GT] = ACTIONS(7794),
    [anon_sym_SEMI] = ACTIONS(7796),
    [anon_sym___attribute__] = ACTIONS(7794),
    [anon_sym___attribute] = ACTIONS(7794),
    [anon_sym_RBRACE] = ACTIONS(7796),
    [anon_sym_LBRACK] = ACTIONS(7775),
    [anon_sym_RBRACK] = ACTIONS(7796),
    [anon_sym_EQ] = ACTIONS(7794),
    [anon_sym_QMARK] = ACTIONS(7796),
    [anon_sym_STAR_EQ] = ACTIONS(7796),
    [anon_sym_SLASH_EQ] = ACTIONS(7796),
    [anon_sym_PERCENT_EQ] = ACTIONS(7796),
    [anon_sym_PLUS_EQ] = ACTIONS(7796),
    [anon_sym_DASH_EQ] = ACTIONS(7796),
    [anon_sym_LT_LT_EQ] = ACTIONS(7796),
    [anon_sym_GT_GT_EQ] = ACTIONS(7796),
    [anon_sym_AMP_EQ] = ACTIONS(7796),
    [anon_sym_CARET_EQ] = ACTIONS(7796),
    [anon_sym_PIPE_EQ] = ACTIONS(7796),
    [anon_sym_and_eq] = ACTIONS(7794),
    [anon_sym_or_eq] = ACTIONS(7794),
    [anon_sym_xor_eq] = ACTIONS(7794),
    [anon_sym_LT_EQ_GT] = ACTIONS(7796),
    [anon_sym_or] = ACTIONS(7794),
    [anon_sym_and] = ACTIONS(7794),
    [anon_sym_bitor] = ACTIONS(7794),
    [anon_sym_xor] = ACTIONS(7794),
    [anon_sym_bitand] = ACTIONS(7794),
    [anon_sym_not_eq] = ACTIONS(7794),
    [anon_sym_is] = ACTIONS(7794),
    [anon_sym_as] = ACTIONS(7794),
    [anon_sym_DASH_DASH] = ACTIONS(7777),
    [anon_sym_PLUS_PLUS] = ACTIONS(7777),
    [anon_sym_DOT] = ACTIONS(7779),
    [anon_sym_DOT_STAR] = ACTIONS(7781),
    [anon_sym_DASH_GT] = ACTIONS(7781),
    [sym_comment] = ACTIONS(3),
  },
  [3354] = {
    [sym_identifier] = ACTIONS(7798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7800),
    [anon_sym_COMMA] = ACTIONS(7800),
    [anon_sym_RPAREN] = ACTIONS(7800),
    [aux_sym_preproc_if_token2] = ACTIONS(7800),
    [aux_sym_preproc_else_token1] = ACTIONS(7800),
    [aux_sym_preproc_elif_token1] = ACTIONS(7798),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7800),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7800),
    [anon_sym_LPAREN2] = ACTIONS(7800),
    [anon_sym_DASH] = ACTIONS(7798),
    [anon_sym_PLUS] = ACTIONS(7798),
    [anon_sym_STAR] = ACTIONS(7798),
    [anon_sym_SLASH] = ACTIONS(7798),
    [anon_sym_PERCENT] = ACTIONS(7798),
    [anon_sym_PIPE_PIPE] = ACTIONS(7800),
    [anon_sym_AMP_AMP] = ACTIONS(7800),
    [anon_sym_PIPE] = ACTIONS(7798),
    [anon_sym_CARET] = ACTIONS(7798),
    [anon_sym_AMP] = ACTIONS(7798),
    [anon_sym_EQ_EQ] = ACTIONS(7800),
    [anon_sym_BANG_EQ] = ACTIONS(7800),
    [anon_sym_GT] = ACTIONS(7798),
    [anon_sym_GT_EQ] = ACTIONS(7800),
    [anon_sym_LT_EQ] = ACTIONS(7798),
    [anon_sym_LT] = ACTIONS(7798),
    [anon_sym_LT_LT] = ACTIONS(7798),
    [anon_sym_GT_GT] = ACTIONS(7798),
    [anon_sym_COLON] = ACTIONS(7800),
    [anon_sym_SEMI] = ACTIONS(7800),
    [anon_sym___attribute__] = ACTIONS(7798),
    [anon_sym___attribute] = ACTIONS(7798),
    [anon_sym_RBRACE] = ACTIONS(7800),
    [anon_sym_LBRACK] = ACTIONS(7798),
    [anon_sym_RBRACK] = ACTIONS(7800),
    [anon_sym_EQ] = ACTIONS(7798),
    [anon_sym_QMARK] = ACTIONS(7800),
    [anon_sym_STAR_EQ] = ACTIONS(7800),
    [anon_sym_SLASH_EQ] = ACTIONS(7800),
    [anon_sym_PERCENT_EQ] = ACTIONS(7800),
    [anon_sym_PLUS_EQ] = ACTIONS(7800),
    [anon_sym_DASH_EQ] = ACTIONS(7800),
    [anon_sym_LT_LT_EQ] = ACTIONS(7800),
    [anon_sym_GT_GT_EQ] = ACTIONS(7800),
    [anon_sym_AMP_EQ] = ACTIONS(7800),
    [anon_sym_CARET_EQ] = ACTIONS(7800),
    [anon_sym_PIPE_EQ] = ACTIONS(7800),
    [anon_sym_and_eq] = ACTIONS(7798),
    [anon_sym_or_eq] = ACTIONS(7798),
    [anon_sym_xor_eq] = ACTIONS(7798),
    [anon_sym_LT_EQ_GT] = ACTIONS(7800),
    [anon_sym_or] = ACTIONS(7798),
    [anon_sym_and] = ACTIONS(7798),
    [anon_sym_bitor] = ACTIONS(7798),
    [anon_sym_xor] = ACTIONS(7798),
    [anon_sym_bitand] = ACTIONS(7798),
    [anon_sym_not_eq] = ACTIONS(7798),
    [anon_sym_is] = ACTIONS(7798),
    [anon_sym_as] = ACTIONS(7798),
    [anon_sym_DASH_DASH] = ACTIONS(7800),
    [anon_sym_PLUS_PLUS] = ACTIONS(7800),
    [anon_sym_DOT] = ACTIONS(7798),
    [anon_sym_DOT_STAR] = ACTIONS(7800),
    [anon_sym_DASH_GT] = ACTIONS(7800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(7802),
  },
  [3355] = {
    [sym_argument_list] = STATE(3465),
    [sym_subscript_argument_list] = STATE(3430),
    [sym_identifier] = ACTIONS(7804),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7806),
    [anon_sym_COMMA] = ACTIONS(7806),
    [anon_sym_RPAREN] = ACTIONS(7806),
    [aux_sym_preproc_if_token2] = ACTIONS(7806),
    [aux_sym_preproc_else_token1] = ACTIONS(7806),
    [aux_sym_preproc_elif_token1] = ACTIONS(7804),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7806),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7806),
    [anon_sym_LPAREN2] = ACTIONS(7358),
    [anon_sym_DASH] = ACTIONS(7804),
    [anon_sym_PLUS] = ACTIONS(7804),
    [anon_sym_STAR] = ACTIONS(7804),
    [anon_sym_SLASH] = ACTIONS(7804),
    [anon_sym_PERCENT] = ACTIONS(7804),
    [anon_sym_PIPE_PIPE] = ACTIONS(7806),
    [anon_sym_AMP_AMP] = ACTIONS(7806),
    [anon_sym_PIPE] = ACTIONS(7804),
    [anon_sym_CARET] = ACTIONS(7804),
    [anon_sym_AMP] = ACTIONS(7804),
    [anon_sym_EQ_EQ] = ACTIONS(7806),
    [anon_sym_BANG_EQ] = ACTIONS(7806),
    [anon_sym_GT] = ACTIONS(7804),
    [anon_sym_GT_EQ] = ACTIONS(7806),
    [anon_sym_LT_EQ] = ACTIONS(7804),
    [anon_sym_LT] = ACTIONS(7804),
    [anon_sym_LT_LT] = ACTIONS(7804),
    [anon_sym_GT_GT] = ACTIONS(7804),
    [anon_sym_SEMI] = ACTIONS(7806),
    [anon_sym___attribute__] = ACTIONS(7804),
    [anon_sym___attribute] = ACTIONS(7804),
    [anon_sym_RBRACE] = ACTIONS(7806),
    [anon_sym_LBRACK] = ACTIONS(7775),
    [anon_sym_RBRACK] = ACTIONS(7806),
    [anon_sym_EQ] = ACTIONS(7804),
    [anon_sym_QMARK] = ACTIONS(7806),
    [anon_sym_STAR_EQ] = ACTIONS(7806),
    [anon_sym_SLASH_EQ] = ACTIONS(7806),
    [anon_sym_PERCENT_EQ] = ACTIONS(7806),
    [anon_sym_PLUS_EQ] = ACTIONS(7806),
    [anon_sym_DASH_EQ] = ACTIONS(7806),
    [anon_sym_LT_LT_EQ] = ACTIONS(7806),
    [anon_sym_GT_GT_EQ] = ACTIONS(7806),
    [anon_sym_AMP_EQ] = ACTIONS(7806),
    [anon_sym_CARET_EQ] = ACTIONS(7806),
    [anon_sym_PIPE_EQ] = ACTIONS(7806),
    [anon_sym_and_eq] = ACTIONS(7804),
    [anon_sym_or_eq] = ACTIONS(7804),
    [anon_sym_xor_eq] = ACTIONS(7804),
    [anon_sym_LT_EQ_GT] = ACTIONS(7806),
    [anon_sym_or] = ACTIONS(7804),
    [anon_sym_and] = ACTIONS(7804),
    [anon_sym_bitor] = ACTIONS(7804),
    [anon_sym_xor] = ACTIONS(7804),
    [anon_sym_bitand] = ACTIONS(7804),
    [anon_sym_not_eq] = ACTIONS(7804),
    [anon_sym_is] = ACTIONS(7804),
    [anon_sym_as] = ACTIONS(7804),
    [anon_sym_DASH_DASH] = ACTIONS(7777),
    [anon_sym_PLUS_PLUS] = ACTIONS(7777),
    [anon_sym_DOT] = ACTIONS(7779),
    [anon_sym_DOT_STAR] = ACTIONS(7781),
    [anon_sym_DASH_GT] = ACTIONS(7781),
    [sym_comment] = ACTIONS(3),
  },
  [3356] = {
    [sym_identifier] = ACTIONS(3362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3352),
    [anon_sym_COMMA] = ACTIONS(3352),
    [anon_sym_LPAREN2] = ACTIONS(3352),
    [anon_sym_DASH] = ACTIONS(3362),
    [anon_sym_PLUS] = ACTIONS(3362),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_SLASH] = ACTIONS(3362),
    [anon_sym_PERCENT] = ACTIONS(3352),
    [anon_sym_PIPE_PIPE] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_PIPE] = ACTIONS(3362),
    [anon_sym_CARET] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3362),
    [anon_sym_EQ_EQ] = ACTIONS(3352),
    [anon_sym_BANG_EQ] = ACTIONS(3352),
    [anon_sym_GT] = ACTIONS(3362),
    [anon_sym_GT_EQ] = ACTIONS(3362),
    [anon_sym_LT_EQ] = ACTIONS(3362),
    [anon_sym_LT] = ACTIONS(3362),
    [anon_sym_LT_LT] = ACTIONS(3352),
    [anon_sym_GT_GT] = ACTIONS(3362),
    [anon_sym___extension__] = ACTIONS(3362),
    [anon_sym___attribute__] = ACTIONS(3362),
    [anon_sym___attribute] = ACTIONS(3362),
    [anon_sym_LBRACE] = ACTIONS(3352),
    [anon_sym_signed] = ACTIONS(3362),
    [anon_sym_unsigned] = ACTIONS(3362),
    [anon_sym_long] = ACTIONS(3362),
    [anon_sym_short] = ACTIONS(3362),
    [anon_sym_LBRACK] = ACTIONS(3352),
    [anon_sym_const] = ACTIONS(3362),
    [anon_sym_constexpr] = ACTIONS(3362),
    [anon_sym_volatile] = ACTIONS(3362),
    [anon_sym_restrict] = ACTIONS(3362),
    [anon_sym___restrict__] = ACTIONS(3362),
    [anon_sym__Atomic] = ACTIONS(3362),
    [anon_sym__Noreturn] = ACTIONS(3362),
    [anon_sym_noreturn] = ACTIONS(3362),
    [anon_sym__Nonnull] = ACTIONS(3362),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_constinit] = ACTIONS(3362),
    [anon_sym_consteval] = ACTIONS(3362),
    [anon_sym_alignas] = ACTIONS(3362),
    [anon_sym__Alignas] = ACTIONS(3362),
    [sym_primitive_type] = ACTIONS(3362),
    [anon_sym_QMARK] = ACTIONS(3352),
    [anon_sym_LT_EQ_GT] = ACTIONS(3352),
    [anon_sym_or] = ACTIONS(3362),
    [anon_sym_and] = ACTIONS(3362),
    [anon_sym_bitor] = ACTIONS(3362),
    [anon_sym_xor] = ACTIONS(3362),
    [anon_sym_bitand] = ACTIONS(3362),
    [anon_sym_not_eq] = ACTIONS(3362),
    [anon_sym_is] = ACTIONS(3362),
    [anon_sym_as] = ACTIONS(3362),
    [anon_sym_DASH_DASH] = ACTIONS(3352),
    [anon_sym_PLUS_PLUS] = ACTIONS(3352),
    [anon_sym_DOT] = ACTIONS(3362),
    [anon_sym_DOT_STAR] = ACTIONS(3352),
    [anon_sym_DASH_GT] = ACTIONS(3352),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_This] = ACTIONS(3362),
    [anon_sym_GT2] = ACTIONS(3352),
  },
  [3357] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7313),
    [anon_sym_COMMA] = ACTIONS(7313),
    [anon_sym_LPAREN2] = ACTIONS(7313),
    [anon_sym_DASH] = ACTIONS(7311),
    [anon_sym_PLUS] = ACTIONS(7311),
    [anon_sym_STAR] = ACTIONS(7311),
    [anon_sym_SLASH] = ACTIONS(7311),
    [anon_sym_PERCENT] = ACTIONS(7311),
    [anon_sym_PIPE_PIPE] = ACTIONS(7313),
    [anon_sym_AMP_AMP] = ACTIONS(7313),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_CARET] = ACTIONS(7311),
    [anon_sym_AMP] = ACTIONS(7311),
    [anon_sym_EQ_EQ] = ACTIONS(7313),
    [anon_sym_BANG_EQ] = ACTIONS(7313),
    [anon_sym_GT] = ACTIONS(7311),
    [anon_sym_GT_EQ] = ACTIONS(7313),
    [anon_sym_LT_EQ] = ACTIONS(7311),
    [anon_sym_LT] = ACTIONS(7311),
    [anon_sym_LT_LT] = ACTIONS(7311),
    [anon_sym_GT_GT] = ACTIONS(7311),
    [anon_sym_SEMI] = ACTIONS(7313),
    [anon_sym___attribute__] = ACTIONS(7311),
    [anon_sym___attribute] = ACTIONS(7311),
    [anon_sym_LBRACK] = ACTIONS(7313),
    [anon_sym_EQ] = ACTIONS(7311),
    [anon_sym_QMARK] = ACTIONS(7313),
    [anon_sym_STAR_EQ] = ACTIONS(7313),
    [anon_sym_SLASH_EQ] = ACTIONS(7313),
    [anon_sym_PERCENT_EQ] = ACTIONS(7313),
    [anon_sym_PLUS_EQ] = ACTIONS(7313),
    [anon_sym_DASH_EQ] = ACTIONS(7313),
    [anon_sym_LT_LT_EQ] = ACTIONS(7313),
    [anon_sym_GT_GT_EQ] = ACTIONS(7313),
    [anon_sym_AMP_EQ] = ACTIONS(7313),
    [anon_sym_CARET_EQ] = ACTIONS(7313),
    [anon_sym_PIPE_EQ] = ACTIONS(7313),
    [anon_sym_and_eq] = ACTIONS(7311),
    [anon_sym_or_eq] = ACTIONS(7311),
    [anon_sym_xor_eq] = ACTIONS(7311),
    [anon_sym_LT_EQ_GT] = ACTIONS(7313),
    [anon_sym_or] = ACTIONS(7311),
    [anon_sym_and] = ACTIONS(7311),
    [anon_sym_bitor] = ACTIONS(7311),
    [anon_sym_xor] = ACTIONS(7311),
    [anon_sym_bitand] = ACTIONS(7311),
    [anon_sym_not_eq] = ACTIONS(7311),
    [anon_sym_is] = ACTIONS(7311),
    [anon_sym_as] = ACTIONS(7311),
    [anon_sym_DASH_DASH] = ACTIONS(7313),
    [anon_sym_PLUS_PLUS] = ACTIONS(7313),
    [anon_sym_DOT] = ACTIONS(7311),
    [anon_sym_DOT_STAR] = ACTIONS(7313),
    [anon_sym_DASH_GT] = ACTIONS(7313),
    [anon_sym_L_DQUOTE] = ACTIONS(7313),
    [anon_sym_u_DQUOTE] = ACTIONS(7313),
    [anon_sym_U_DQUOTE] = ACTIONS(7313),
    [anon_sym_u8_DQUOTE] = ACTIONS(7313),
    [anon_sym_DQUOTE] = ACTIONS(7313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7313),
    [anon_sym_LR_DQUOTE] = ACTIONS(7313),
    [anon_sym_uR_DQUOTE] = ACTIONS(7313),
    [anon_sym_UR_DQUOTE] = ACTIONS(7313),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7313),
    [sym_literal_suffix] = ACTIONS(7311),
  },
  [3358] = {
    [sym_attribute_specifier] = STATE(3816),
    [sym_field_declaration_list] = STATE(3631),
    [sym_virtual_specifier] = STATE(9512),
    [sym_base_class_clause] = STATE(10393),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_PERCENT] = ACTIONS(2893),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_PIPE] = ACTIONS(2893),
    [anon_sym_CARET] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_EQ_EQ] = ACTIONS(2895),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_GT] = ACTIONS(2893),
    [anon_sym_GT_EQ] = ACTIONS(2893),
    [anon_sym_LT_EQ] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_LT_LT] = ACTIONS(2893),
    [anon_sym_GT_GT] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(7252),
    [anon_sym___attribute__] = ACTIONS(7808),
    [anon_sym___attribute] = ACTIONS(7810),
    [anon_sym_LBRACE] = ACTIONS(7812),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_EQ] = ACTIONS(2893),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_STAR_EQ] = ACTIONS(2895),
    [anon_sym_SLASH_EQ] = ACTIONS(2895),
    [anon_sym_PERCENT_EQ] = ACTIONS(2895),
    [anon_sym_PLUS_EQ] = ACTIONS(2895),
    [anon_sym_DASH_EQ] = ACTIONS(2895),
    [anon_sym_LT_LT_EQ] = ACTIONS(2895),
    [anon_sym_GT_GT_EQ] = ACTIONS(2893),
    [anon_sym_AMP_EQ] = ACTIONS(2895),
    [anon_sym_CARET_EQ] = ACTIONS(2895),
    [anon_sym_PIPE_EQ] = ACTIONS(2895),
    [anon_sym_and_eq] = ACTIONS(2895),
    [anon_sym_or_eq] = ACTIONS(2895),
    [anon_sym_xor_eq] = ACTIONS(2895),
    [anon_sym_LT_EQ_GT] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2893),
    [anon_sym_and] = ACTIONS(2893),
    [anon_sym_bitor] = ACTIONS(2895),
    [anon_sym_xor] = ACTIONS(2893),
    [anon_sym_bitand] = ACTIONS(2895),
    [anon_sym_not_eq] = ACTIONS(2895),
    [anon_sym_is] = ACTIONS(2895),
    [anon_sym_as] = ACTIONS(2895),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2893),
    [anon_sym_DOT_STAR] = ACTIONS(2895),
    [anon_sym_DASH_GT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2895),
    [anon_sym_let] = ACTIONS(2895),
    [anon_sym_This] = ACTIONS(2895),
    [anon_sym_final] = ACTIONS(7352),
    [anon_sym_override] = ACTIONS(7352),
    [anon_sym_GT2] = ACTIONS(2895),
  },
  [3359] = {
    [sym_identifier] = ACTIONS(7814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7816),
    [anon_sym_COMMA] = ACTIONS(7816),
    [anon_sym_RPAREN] = ACTIONS(7816),
    [aux_sym_preproc_if_token2] = ACTIONS(7816),
    [aux_sym_preproc_else_token1] = ACTIONS(7816),
    [aux_sym_preproc_elif_token1] = ACTIONS(7814),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7816),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7816),
    [anon_sym_LPAREN2] = ACTIONS(7816),
    [anon_sym_DASH] = ACTIONS(7814),
    [anon_sym_PLUS] = ACTIONS(7814),
    [anon_sym_STAR] = ACTIONS(7814),
    [anon_sym_SLASH] = ACTIONS(7814),
    [anon_sym_PERCENT] = ACTIONS(7814),
    [anon_sym_PIPE_PIPE] = ACTIONS(7816),
    [anon_sym_AMP_AMP] = ACTIONS(7816),
    [anon_sym_PIPE] = ACTIONS(7814),
    [anon_sym_CARET] = ACTIONS(7814),
    [anon_sym_AMP] = ACTIONS(7814),
    [anon_sym_EQ_EQ] = ACTIONS(7816),
    [anon_sym_BANG_EQ] = ACTIONS(7816),
    [anon_sym_GT] = ACTIONS(7814),
    [anon_sym_GT_EQ] = ACTIONS(7816),
    [anon_sym_LT_EQ] = ACTIONS(7814),
    [anon_sym_LT] = ACTIONS(7814),
    [anon_sym_LT_LT] = ACTIONS(7814),
    [anon_sym_GT_GT] = ACTIONS(7814),
    [anon_sym_COLON] = ACTIONS(7816),
    [anon_sym_SEMI] = ACTIONS(7816),
    [anon_sym___attribute__] = ACTIONS(7814),
    [anon_sym___attribute] = ACTIONS(7814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7816),
    [anon_sym_RBRACE] = ACTIONS(7816),
    [anon_sym_LBRACK] = ACTIONS(7814),
    [anon_sym_RBRACK] = ACTIONS(7816),
    [anon_sym_EQ] = ACTIONS(7814),
    [anon_sym_QMARK] = ACTIONS(7816),
    [anon_sym_STAR_EQ] = ACTIONS(7816),
    [anon_sym_SLASH_EQ] = ACTIONS(7816),
    [anon_sym_PERCENT_EQ] = ACTIONS(7816),
    [anon_sym_PLUS_EQ] = ACTIONS(7816),
    [anon_sym_DASH_EQ] = ACTIONS(7816),
    [anon_sym_LT_LT_EQ] = ACTIONS(7816),
    [anon_sym_GT_GT_EQ] = ACTIONS(7816),
    [anon_sym_AMP_EQ] = ACTIONS(7816),
    [anon_sym_CARET_EQ] = ACTIONS(7816),
    [anon_sym_PIPE_EQ] = ACTIONS(7816),
    [anon_sym_and_eq] = ACTIONS(7814),
    [anon_sym_or_eq] = ACTIONS(7814),
    [anon_sym_xor_eq] = ACTIONS(7814),
    [anon_sym_LT_EQ_GT] = ACTIONS(7816),
    [anon_sym_or] = ACTIONS(7814),
    [anon_sym_and] = ACTIONS(7814),
    [anon_sym_bitor] = ACTIONS(7814),
    [anon_sym_xor] = ACTIONS(7814),
    [anon_sym_bitand] = ACTIONS(7814),
    [anon_sym_not_eq] = ACTIONS(7814),
    [anon_sym_is] = ACTIONS(7814),
    [anon_sym_as] = ACTIONS(7814),
    [anon_sym_DASH_DASH] = ACTIONS(7816),
    [anon_sym_PLUS_PLUS] = ACTIONS(7816),
    [anon_sym_DOT] = ACTIONS(7814),
    [anon_sym_DOT_STAR] = ACTIONS(7816),
    [anon_sym_DASH_GT] = ACTIONS(7816),
    [sym_comment] = ACTIONS(3),
  },
  [3360] = {
    [sym_identifier] = ACTIONS(7818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7820),
    [anon_sym_COMMA] = ACTIONS(7820),
    [anon_sym_RPAREN] = ACTIONS(7820),
    [aux_sym_preproc_if_token2] = ACTIONS(7820),
    [aux_sym_preproc_else_token1] = ACTIONS(7820),
    [aux_sym_preproc_elif_token1] = ACTIONS(7818),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7820),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7820),
    [anon_sym_LPAREN2] = ACTIONS(7820),
    [anon_sym_DASH] = ACTIONS(7818),
    [anon_sym_PLUS] = ACTIONS(7818),
    [anon_sym_STAR] = ACTIONS(7818),
    [anon_sym_SLASH] = ACTIONS(7818),
    [anon_sym_PERCENT] = ACTIONS(7818),
    [anon_sym_PIPE_PIPE] = ACTIONS(7820),
    [anon_sym_AMP_AMP] = ACTIONS(7820),
    [anon_sym_PIPE] = ACTIONS(7818),
    [anon_sym_CARET] = ACTIONS(7818),
    [anon_sym_AMP] = ACTIONS(7818),
    [anon_sym_EQ_EQ] = ACTIONS(7820),
    [anon_sym_BANG_EQ] = ACTIONS(7820),
    [anon_sym_GT] = ACTIONS(7818),
    [anon_sym_GT_EQ] = ACTIONS(7820),
    [anon_sym_LT_EQ] = ACTIONS(7818),
    [anon_sym_LT] = ACTIONS(7818),
    [anon_sym_LT_LT] = ACTIONS(7818),
    [anon_sym_GT_GT] = ACTIONS(7818),
    [anon_sym_COLON] = ACTIONS(7820),
    [anon_sym_SEMI] = ACTIONS(7820),
    [anon_sym___attribute__] = ACTIONS(7818),
    [anon_sym___attribute] = ACTIONS(7818),
    [anon_sym_LBRACE] = ACTIONS(7820),
    [anon_sym_RBRACE] = ACTIONS(7820),
    [anon_sym_LBRACK] = ACTIONS(7820),
    [anon_sym_RBRACK] = ACTIONS(7820),
    [anon_sym_EQ] = ACTIONS(7818),
    [anon_sym_QMARK] = ACTIONS(7820),
    [anon_sym_STAR_EQ] = ACTIONS(7820),
    [anon_sym_SLASH_EQ] = ACTIONS(7820),
    [anon_sym_PERCENT_EQ] = ACTIONS(7820),
    [anon_sym_PLUS_EQ] = ACTIONS(7820),
    [anon_sym_DASH_EQ] = ACTIONS(7820),
    [anon_sym_LT_LT_EQ] = ACTIONS(7820),
    [anon_sym_GT_GT_EQ] = ACTIONS(7820),
    [anon_sym_AMP_EQ] = ACTIONS(7820),
    [anon_sym_CARET_EQ] = ACTIONS(7820),
    [anon_sym_PIPE_EQ] = ACTIONS(7820),
    [anon_sym_and_eq] = ACTIONS(7818),
    [anon_sym_or_eq] = ACTIONS(7818),
    [anon_sym_xor_eq] = ACTIONS(7818),
    [anon_sym_LT_EQ_GT] = ACTIONS(7820),
    [anon_sym_or] = ACTIONS(7818),
    [anon_sym_and] = ACTIONS(7818),
    [anon_sym_bitor] = ACTIONS(7818),
    [anon_sym_xor] = ACTIONS(7818),
    [anon_sym_bitand] = ACTIONS(7818),
    [anon_sym_not_eq] = ACTIONS(7818),
    [anon_sym_is] = ACTIONS(7818),
    [anon_sym_as] = ACTIONS(7818),
    [anon_sym_DASH_DASH] = ACTIONS(7820),
    [anon_sym_PLUS_PLUS] = ACTIONS(7820),
    [anon_sym_DOT] = ACTIONS(7818),
    [anon_sym_DOT_STAR] = ACTIONS(7820),
    [anon_sym_DASH_GT] = ACTIONS(7820),
    [sym_comment] = ACTIONS(3),
  },
  [3361] = {
    [sym_identifier] = ACTIONS(7822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7824),
    [anon_sym_COMMA] = ACTIONS(7824),
    [anon_sym_RPAREN] = ACTIONS(7824),
    [aux_sym_preproc_if_token2] = ACTIONS(7824),
    [aux_sym_preproc_else_token1] = ACTIONS(7824),
    [aux_sym_preproc_elif_token1] = ACTIONS(7822),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7824),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7824),
    [anon_sym_LPAREN2] = ACTIONS(7824),
    [anon_sym_DASH] = ACTIONS(7822),
    [anon_sym_PLUS] = ACTIONS(7822),
    [anon_sym_STAR] = ACTIONS(7822),
    [anon_sym_SLASH] = ACTIONS(7822),
    [anon_sym_PERCENT] = ACTIONS(7822),
    [anon_sym_PIPE_PIPE] = ACTIONS(7824),
    [anon_sym_AMP_AMP] = ACTIONS(7824),
    [anon_sym_PIPE] = ACTIONS(7822),
    [anon_sym_CARET] = ACTIONS(7822),
    [anon_sym_AMP] = ACTIONS(7822),
    [anon_sym_EQ_EQ] = ACTIONS(7824),
    [anon_sym_BANG_EQ] = ACTIONS(7824),
    [anon_sym_GT] = ACTIONS(7822),
    [anon_sym_GT_EQ] = ACTIONS(7824),
    [anon_sym_LT_EQ] = ACTIONS(7822),
    [anon_sym_LT] = ACTIONS(7822),
    [anon_sym_LT_LT] = ACTIONS(7822),
    [anon_sym_GT_GT] = ACTIONS(7822),
    [anon_sym_COLON] = ACTIONS(7824),
    [anon_sym_SEMI] = ACTIONS(7824),
    [anon_sym___attribute__] = ACTIONS(7822),
    [anon_sym___attribute] = ACTIONS(7822),
    [anon_sym_LBRACE] = ACTIONS(7824),
    [anon_sym_RBRACE] = ACTIONS(7824),
    [anon_sym_LBRACK] = ACTIONS(7824),
    [anon_sym_RBRACK] = ACTIONS(7824),
    [anon_sym_EQ] = ACTIONS(7822),
    [anon_sym_QMARK] = ACTIONS(7824),
    [anon_sym_STAR_EQ] = ACTIONS(7824),
    [anon_sym_SLASH_EQ] = ACTIONS(7824),
    [anon_sym_PERCENT_EQ] = ACTIONS(7824),
    [anon_sym_PLUS_EQ] = ACTIONS(7824),
    [anon_sym_DASH_EQ] = ACTIONS(7824),
    [anon_sym_LT_LT_EQ] = ACTIONS(7824),
    [anon_sym_GT_GT_EQ] = ACTIONS(7824),
    [anon_sym_AMP_EQ] = ACTIONS(7824),
    [anon_sym_CARET_EQ] = ACTIONS(7824),
    [anon_sym_PIPE_EQ] = ACTIONS(7824),
    [anon_sym_and_eq] = ACTIONS(7822),
    [anon_sym_or_eq] = ACTIONS(7822),
    [anon_sym_xor_eq] = ACTIONS(7822),
    [anon_sym_LT_EQ_GT] = ACTIONS(7824),
    [anon_sym_or] = ACTIONS(7822),
    [anon_sym_and] = ACTIONS(7822),
    [anon_sym_bitor] = ACTIONS(7822),
    [anon_sym_xor] = ACTIONS(7822),
    [anon_sym_bitand] = ACTIONS(7822),
    [anon_sym_not_eq] = ACTIONS(7822),
    [anon_sym_is] = ACTIONS(7822),
    [anon_sym_as] = ACTIONS(7822),
    [anon_sym_DASH_DASH] = ACTIONS(7824),
    [anon_sym_PLUS_PLUS] = ACTIONS(7824),
    [anon_sym_DOT] = ACTIONS(7822),
    [anon_sym_DOT_STAR] = ACTIONS(7824),
    [anon_sym_DASH_GT] = ACTIONS(7824),
    [sym_comment] = ACTIONS(3),
  },
  [3362] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7290),
    [anon_sym_COMMA] = ACTIONS(7290),
    [anon_sym_LPAREN2] = ACTIONS(7290),
    [anon_sym_DASH] = ACTIONS(7288),
    [anon_sym_PLUS] = ACTIONS(7288),
    [anon_sym_STAR] = ACTIONS(7288),
    [anon_sym_SLASH] = ACTIONS(7288),
    [anon_sym_PERCENT] = ACTIONS(7288),
    [anon_sym_PIPE_PIPE] = ACTIONS(7290),
    [anon_sym_AMP_AMP] = ACTIONS(7290),
    [anon_sym_PIPE] = ACTIONS(7288),
    [anon_sym_CARET] = ACTIONS(7288),
    [anon_sym_AMP] = ACTIONS(7288),
    [anon_sym_EQ_EQ] = ACTIONS(7290),
    [anon_sym_BANG_EQ] = ACTIONS(7290),
    [anon_sym_GT] = ACTIONS(7288),
    [anon_sym_GT_EQ] = ACTIONS(7290),
    [anon_sym_LT_EQ] = ACTIONS(7288),
    [anon_sym_LT] = ACTIONS(7288),
    [anon_sym_LT_LT] = ACTIONS(7288),
    [anon_sym_GT_GT] = ACTIONS(7288),
    [anon_sym_SEMI] = ACTIONS(7290),
    [anon_sym___attribute__] = ACTIONS(7288),
    [anon_sym___attribute] = ACTIONS(7288),
    [anon_sym_LBRACK] = ACTIONS(7290),
    [anon_sym_EQ] = ACTIONS(7288),
    [anon_sym_QMARK] = ACTIONS(7290),
    [anon_sym_STAR_EQ] = ACTIONS(7290),
    [anon_sym_SLASH_EQ] = ACTIONS(7290),
    [anon_sym_PERCENT_EQ] = ACTIONS(7290),
    [anon_sym_PLUS_EQ] = ACTIONS(7290),
    [anon_sym_DASH_EQ] = ACTIONS(7290),
    [anon_sym_LT_LT_EQ] = ACTIONS(7290),
    [anon_sym_GT_GT_EQ] = ACTIONS(7290),
    [anon_sym_AMP_EQ] = ACTIONS(7290),
    [anon_sym_CARET_EQ] = ACTIONS(7290),
    [anon_sym_PIPE_EQ] = ACTIONS(7290),
    [anon_sym_and_eq] = ACTIONS(7288),
    [anon_sym_or_eq] = ACTIONS(7288),
    [anon_sym_xor_eq] = ACTIONS(7288),
    [anon_sym_LT_EQ_GT] = ACTIONS(7290),
    [anon_sym_or] = ACTIONS(7288),
    [anon_sym_and] = ACTIONS(7288),
    [anon_sym_bitor] = ACTIONS(7288),
    [anon_sym_xor] = ACTIONS(7288),
    [anon_sym_bitand] = ACTIONS(7288),
    [anon_sym_not_eq] = ACTIONS(7288),
    [anon_sym_is] = ACTIONS(7288),
    [anon_sym_as] = ACTIONS(7288),
    [anon_sym_DASH_DASH] = ACTIONS(7290),
    [anon_sym_PLUS_PLUS] = ACTIONS(7290),
    [anon_sym_DOT] = ACTIONS(7288),
    [anon_sym_DOT_STAR] = ACTIONS(7290),
    [anon_sym_DASH_GT] = ACTIONS(7290),
    [anon_sym_L_DQUOTE] = ACTIONS(7290),
    [anon_sym_u_DQUOTE] = ACTIONS(7290),
    [anon_sym_U_DQUOTE] = ACTIONS(7290),
    [anon_sym_u8_DQUOTE] = ACTIONS(7290),
    [anon_sym_DQUOTE] = ACTIONS(7290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7290),
    [anon_sym_LR_DQUOTE] = ACTIONS(7290),
    [anon_sym_uR_DQUOTE] = ACTIONS(7290),
    [anon_sym_UR_DQUOTE] = ACTIONS(7290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7290),
    [sym_literal_suffix] = ACTIONS(7288),
  },
  [3363] = {
    [sym_identifier] = ACTIONS(7150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7152),
    [anon_sym_COMMA] = ACTIONS(7152),
    [anon_sym_RPAREN] = ACTIONS(7152),
    [anon_sym_LPAREN2] = ACTIONS(7152),
    [anon_sym_DASH] = ACTIONS(7150),
    [anon_sym_PLUS] = ACTIONS(7150),
    [anon_sym_STAR] = ACTIONS(7150),
    [anon_sym_SLASH] = ACTIONS(7150),
    [anon_sym_PERCENT] = ACTIONS(7150),
    [anon_sym_PIPE_PIPE] = ACTIONS(7152),
    [anon_sym_AMP_AMP] = ACTIONS(7152),
    [anon_sym_PIPE] = ACTIONS(7150),
    [anon_sym_CARET] = ACTIONS(7150),
    [anon_sym_AMP] = ACTIONS(7150),
    [anon_sym_EQ_EQ] = ACTIONS(7152),
    [anon_sym_BANG_EQ] = ACTIONS(7152),
    [anon_sym_GT] = ACTIONS(7150),
    [anon_sym_GT_EQ] = ACTIONS(7152),
    [anon_sym_LT_EQ] = ACTIONS(7150),
    [anon_sym_LT] = ACTIONS(7150),
    [anon_sym_LT_LT] = ACTIONS(7150),
    [anon_sym_GT_GT] = ACTIONS(7150),
    [anon_sym_LBRACK] = ACTIONS(7152),
    [anon_sym_EQ] = ACTIONS(7150),
    [anon_sym_QMARK] = ACTIONS(7152),
    [anon_sym_STAR_EQ] = ACTIONS(7152),
    [anon_sym_SLASH_EQ] = ACTIONS(7152),
    [anon_sym_PERCENT_EQ] = ACTIONS(7152),
    [anon_sym_PLUS_EQ] = ACTIONS(7152),
    [anon_sym_DASH_EQ] = ACTIONS(7152),
    [anon_sym_LT_LT_EQ] = ACTIONS(7152),
    [anon_sym_GT_GT_EQ] = ACTIONS(7152),
    [anon_sym_AMP_EQ] = ACTIONS(7152),
    [anon_sym_CARET_EQ] = ACTIONS(7152),
    [anon_sym_PIPE_EQ] = ACTIONS(7152),
    [anon_sym_and_eq] = ACTIONS(7150),
    [anon_sym_or_eq] = ACTIONS(7150),
    [anon_sym_xor_eq] = ACTIONS(7150),
    [anon_sym_LT_EQ_GT] = ACTIONS(7152),
    [anon_sym_or] = ACTIONS(7150),
    [anon_sym_and] = ACTIONS(7150),
    [anon_sym_bitor] = ACTIONS(7150),
    [anon_sym_xor] = ACTIONS(7150),
    [anon_sym_bitand] = ACTIONS(7150),
    [anon_sym_not_eq] = ACTIONS(7150),
    [anon_sym_is] = ACTIONS(7150),
    [anon_sym_as] = ACTIONS(7150),
    [anon_sym_DASH_DASH] = ACTIONS(7152),
    [anon_sym_PLUS_PLUS] = ACTIONS(7152),
    [anon_sym_DOT] = ACTIONS(7150),
    [anon_sym_DOT_STAR] = ACTIONS(7152),
    [anon_sym_DASH_GT] = ACTIONS(7150),
    [anon_sym_L_DQUOTE] = ACTIONS(7152),
    [anon_sym_u_DQUOTE] = ACTIONS(7152),
    [anon_sym_U_DQUOTE] = ACTIONS(7152),
    [anon_sym_u8_DQUOTE] = ACTIONS(7152),
    [anon_sym_DQUOTE] = ACTIONS(7152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7152),
    [anon_sym_LR_DQUOTE] = ACTIONS(7152),
    [anon_sym_uR_DQUOTE] = ACTIONS(7152),
    [anon_sym_UR_DQUOTE] = ACTIONS(7152),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7152),
    [anon_sym_DASH_GT_STAR] = ACTIONS(7152),
    [sym_literal_suffix] = ACTIONS(7150),
  },
  [3364] = {
    [sym_argument_list] = STATE(3465),
    [sym_subscript_argument_list] = STATE(3430),
    [sym_identifier] = ACTIONS(7826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7828),
    [anon_sym_COMMA] = ACTIONS(7828),
    [anon_sym_RPAREN] = ACTIONS(7828),
    [aux_sym_preproc_if_token2] = ACTIONS(7828),
    [aux_sym_preproc_else_token1] = ACTIONS(7828),
    [aux_sym_preproc_elif_token1] = ACTIONS(7826),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7828),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7828),
    [anon_sym_LPAREN2] = ACTIONS(7358),
    [anon_sym_DASH] = ACTIONS(7826),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_STAR] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7826),
    [anon_sym_PERCENT] = ACTIONS(7826),
    [anon_sym_PIPE_PIPE] = ACTIONS(7828),
    [anon_sym_AMP_AMP] = ACTIONS(7828),
    [anon_sym_PIPE] = ACTIONS(7826),
    [anon_sym_CARET] = ACTIONS(7826),
    [anon_sym_AMP] = ACTIONS(7826),
    [anon_sym_EQ_EQ] = ACTIONS(7828),
    [anon_sym_BANG_EQ] = ACTIONS(7828),
    [anon_sym_GT] = ACTIONS(7826),
    [anon_sym_GT_EQ] = ACTIONS(7828),
    [anon_sym_LT_EQ] = ACTIONS(7826),
    [anon_sym_LT] = ACTIONS(7826),
    [anon_sym_LT_LT] = ACTIONS(7826),
    [anon_sym_GT_GT] = ACTIONS(7826),
    [anon_sym_SEMI] = ACTIONS(7828),
    [anon_sym___attribute__] = ACTIONS(7826),
    [anon_sym___attribute] = ACTIONS(7826),
    [anon_sym_RBRACE] = ACTIONS(7828),
    [anon_sym_LBRACK] = ACTIONS(7775),
    [anon_sym_RBRACK] = ACTIONS(7828),
    [anon_sym_EQ] = ACTIONS(7826),
    [anon_sym_QMARK] = ACTIONS(7828),
    [anon_sym_STAR_EQ] = ACTIONS(7828),
    [anon_sym_SLASH_EQ] = ACTIONS(7828),
    [anon_sym_PERCENT_EQ] = ACTIONS(7828),
    [anon_sym_PLUS_EQ] = ACTIONS(7828),
    [anon_sym_DASH_EQ] = ACTIONS(7828),
    [anon_sym_LT_LT_EQ] = ACTIONS(7828),
    [anon_sym_GT_GT_EQ] = ACTIONS(7828),
    [anon_sym_AMP_EQ] = ACTIONS(7828),
    [anon_sym_CARET_EQ] = ACTIONS(7828),
    [anon_sym_PIPE_EQ] = ACTIONS(7828),
    [anon_sym_and_eq] = ACTIONS(7826),
    [anon_sym_or_eq] = ACTIONS(7826),
    [anon_sym_xor_eq] = ACTIONS(7826),
    [anon_sym_LT_EQ_GT] = ACTIONS(7828),
    [anon_sym_or] = ACTIONS(7826),
    [anon_sym_and] = ACTIONS(7826),
    [anon_sym_bitor] = ACTIONS(7826),
    [anon_sym_xor] = ACTIONS(7826),
    [anon_sym_bitand] = ACTIONS(7826),
    [anon_sym_not_eq] = ACTIONS(7826),
    [anon_sym_is] = ACTIONS(7826),
    [anon_sym_as] = ACTIONS(7826),
    [anon_sym_DASH_DASH] = ACTIONS(7828),
    [anon_sym_PLUS_PLUS] = ACTIONS(7828),
    [anon_sym_DOT] = ACTIONS(7779),
    [anon_sym_DOT_STAR] = ACTIONS(7781),
    [anon_sym_DASH_GT] = ACTIONS(7781),
    [sym_comment] = ACTIONS(3),
  },
  [3365] = {
    [sym_identifier] = ACTIONS(7288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7290),
    [anon_sym_COMMA] = ACTIONS(7290),
    [anon_sym_RPAREN] = ACTIONS(7290),
    [anon_sym_LPAREN2] = ACTIONS(7290),
    [anon_sym_DASH] = ACTIONS(7288),
    [anon_sym_PLUS] = ACTIONS(7288),
    [anon_sym_STAR] = ACTIONS(7288),
    [anon_sym_SLASH] = ACTIONS(7288),
    [anon_sym_PERCENT] = ACTIONS(7288),
    [anon_sym_PIPE_PIPE] = ACTIONS(7290),
    [anon_sym_AMP_AMP] = ACTIONS(7290),
    [anon_sym_PIPE] = ACTIONS(7288),
    [anon_sym_CARET] = ACTIONS(7288),
    [anon_sym_AMP] = ACTIONS(7288),
    [anon_sym_EQ_EQ] = ACTIONS(7290),
    [anon_sym_BANG_EQ] = ACTIONS(7290),
    [anon_sym_GT] = ACTIONS(7288),
    [anon_sym_GT_EQ] = ACTIONS(7290),
    [anon_sym_LT_EQ] = ACTIONS(7288),
    [anon_sym_LT] = ACTIONS(7288),
    [anon_sym_LT_LT] = ACTIONS(7288),
    [anon_sym_GT_GT] = ACTIONS(7288),
    [anon_sym_LBRACK] = ACTIONS(7290),
    [anon_sym_EQ] = ACTIONS(7288),
    [anon_sym_QMARK] = ACTIONS(7290),
    [anon_sym_STAR_EQ] = ACTIONS(7290),
    [anon_sym_SLASH_EQ] = ACTIONS(7290),
    [anon_sym_PERCENT_EQ] = ACTIONS(7290),
    [anon_sym_PLUS_EQ] = ACTIONS(7290),
    [anon_sym_DASH_EQ] = ACTIONS(7290),
    [anon_sym_LT_LT_EQ] = ACTIONS(7290),
    [anon_sym_GT_GT_EQ] = ACTIONS(7290),
    [anon_sym_AMP_EQ] = ACTIONS(7290),
    [anon_sym_CARET_EQ] = ACTIONS(7290),
    [anon_sym_PIPE_EQ] = ACTIONS(7290),
    [anon_sym_and_eq] = ACTIONS(7288),
    [anon_sym_or_eq] = ACTIONS(7288),
    [anon_sym_xor_eq] = ACTIONS(7288),
    [anon_sym_LT_EQ_GT] = ACTIONS(7290),
    [anon_sym_or] = ACTIONS(7288),
    [anon_sym_and] = ACTIONS(7288),
    [anon_sym_bitor] = ACTIONS(7288),
    [anon_sym_xor] = ACTIONS(7288),
    [anon_sym_bitand] = ACTIONS(7288),
    [anon_sym_not_eq] = ACTIONS(7288),
    [anon_sym_is] = ACTIONS(7288),
    [anon_sym_as] = ACTIONS(7288),
    [anon_sym_DASH_DASH] = ACTIONS(7290),
    [anon_sym_PLUS_PLUS] = ACTIONS(7290),
    [anon_sym_DOT] = ACTIONS(7288),
    [anon_sym_DOT_STAR] = ACTIONS(7290),
    [anon_sym_DASH_GT] = ACTIONS(7288),
    [anon_sym_L_DQUOTE] = ACTIONS(7290),
    [anon_sym_u_DQUOTE] = ACTIONS(7290),
    [anon_sym_U_DQUOTE] = ACTIONS(7290),
    [anon_sym_u8_DQUOTE] = ACTIONS(7290),
    [anon_sym_DQUOTE] = ACTIONS(7290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7290),
    [anon_sym_LR_DQUOTE] = ACTIONS(7290),
    [anon_sym_uR_DQUOTE] = ACTIONS(7290),
    [anon_sym_UR_DQUOTE] = ACTIONS(7290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7290),
    [anon_sym_DASH_GT_STAR] = ACTIONS(7290),
    [sym_literal_suffix] = ACTIONS(7288),
  },
  [3366] = {
    [sym_identifier] = ACTIONS(7311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7313),
    [anon_sym_COMMA] = ACTIONS(7313),
    [anon_sym_RPAREN] = ACTIONS(7313),
    [anon_sym_LPAREN2] = ACTIONS(7313),
    [anon_sym_DASH] = ACTIONS(7311),
    [anon_sym_PLUS] = ACTIONS(7311),
    [anon_sym_STAR] = ACTIONS(7311),
    [anon_sym_SLASH] = ACTIONS(7311),
    [anon_sym_PERCENT] = ACTIONS(7311),
    [anon_sym_PIPE_PIPE] = ACTIONS(7313),
    [anon_sym_AMP_AMP] = ACTIONS(7313),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_CARET] = ACTIONS(7311),
    [anon_sym_AMP] = ACTIONS(7311),
    [anon_sym_EQ_EQ] = ACTIONS(7313),
    [anon_sym_BANG_EQ] = ACTIONS(7313),
    [anon_sym_GT] = ACTIONS(7311),
    [anon_sym_GT_EQ] = ACTIONS(7313),
    [anon_sym_LT_EQ] = ACTIONS(7311),
    [anon_sym_LT] = ACTIONS(7311),
    [anon_sym_LT_LT] = ACTIONS(7311),
    [anon_sym_GT_GT] = ACTIONS(7311),
    [anon_sym_LBRACK] = ACTIONS(7313),
    [anon_sym_EQ] = ACTIONS(7311),
    [anon_sym_QMARK] = ACTIONS(7313),
    [anon_sym_STAR_EQ] = ACTIONS(7313),
    [anon_sym_SLASH_EQ] = ACTIONS(7313),
    [anon_sym_PERCENT_EQ] = ACTIONS(7313),
    [anon_sym_PLUS_EQ] = ACTIONS(7313),
    [anon_sym_DASH_EQ] = ACTIONS(7313),
    [anon_sym_LT_LT_EQ] = ACTIONS(7313),
    [anon_sym_GT_GT_EQ] = ACTIONS(7313),
    [anon_sym_AMP_EQ] = ACTIONS(7313),
    [anon_sym_CARET_EQ] = ACTIONS(7313),
    [anon_sym_PIPE_EQ] = ACTIONS(7313),
    [anon_sym_and_eq] = ACTIONS(7311),
    [anon_sym_or_eq] = ACTIONS(7311),
    [anon_sym_xor_eq] = ACTIONS(7311),
    [anon_sym_LT_EQ_GT] = ACTIONS(7313),
    [anon_sym_or] = ACTIONS(7311),
    [anon_sym_and] = ACTIONS(7311),
    [anon_sym_bitor] = ACTIONS(7311),
    [anon_sym_xor] = ACTIONS(7311),
    [anon_sym_bitand] = ACTIONS(7311),
    [anon_sym_not_eq] = ACTIONS(7311),
    [anon_sym_is] = ACTIONS(7311),
    [anon_sym_as] = ACTIONS(7311),
    [anon_sym_DASH_DASH] = ACTIONS(7313),
    [anon_sym_PLUS_PLUS] = ACTIONS(7313),
    [anon_sym_DOT] = ACTIONS(7311),
    [anon_sym_DOT_STAR] = ACTIONS(7313),
    [anon_sym_DASH_GT] = ACTIONS(7311),
    [anon_sym_L_DQUOTE] = ACTIONS(7313),
    [anon_sym_u_DQUOTE] = ACTIONS(7313),
    [anon_sym_U_DQUOTE] = ACTIONS(7313),
    [anon_sym_u8_DQUOTE] = ACTIONS(7313),
    [anon_sym_DQUOTE] = ACTIONS(7313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7313),
    [anon_sym_LR_DQUOTE] = ACTIONS(7313),
    [anon_sym_uR_DQUOTE] = ACTIONS(7313),
    [anon_sym_UR_DQUOTE] = ACTIONS(7313),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7313),
    [anon_sym_DASH_GT_STAR] = ACTIONS(7313),
    [sym_literal_suffix] = ACTIONS(7311),
  },
  [3367] = {
    [sym_attribute_specifier] = STATE(2904),
    [sym_enumerator_list] = STATE(2833),
    [sym__enum_base_clause] = STATE(2784),
    [anon_sym_LPAREN2] = ACTIONS(3504),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_AMP_AMP] = ACTIONS(3504),
    [anon_sym_AMP] = ACTIONS(3502),
    [anon_sym_COLON] = ACTIONS(7830),
    [anon_sym___extension__] = ACTIONS(3504),
    [anon_sym_in] = ACTIONS(3502),
    [anon_sym_out] = ACTIONS(3504),
    [anon_sym_inout] = ACTIONS(3504),
    [anon_sym_virtual] = ACTIONS(3504),
    [anon_sym_extern] = ACTIONS(3504),
    [anon_sym___attribute__] = ACTIONS(7434),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3504),
    [anon_sym___declspec] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(6963),
    [anon_sym_LBRACK] = ACTIONS(3502),
    [anon_sym_static] = ACTIONS(3504),
    [anon_sym_register] = ACTIONS(3504),
    [anon_sym_inline] = ACTIONS(3504),
    [anon_sym___inline] = ACTIONS(3502),
    [anon_sym___inline__] = ACTIONS(3504),
    [anon_sym___forceinline] = ACTIONS(3504),
    [anon_sym_thread_local] = ACTIONS(3504),
    [anon_sym___thread] = ACTIONS(3504),
    [anon_sym_const] = ACTIONS(3502),
    [anon_sym_constexpr] = ACTIONS(3504),
    [anon_sym_volatile] = ACTIONS(3504),
    [anon_sym_restrict] = ACTIONS(3504),
    [anon_sym___restrict__] = ACTIONS(3504),
    [anon_sym__Atomic] = ACTIONS(3504),
    [anon_sym__Noreturn] = ACTIONS(3504),
    [anon_sym_noreturn] = ACTIONS(3504),
    [anon_sym__Nonnull] = ACTIONS(3504),
    [anon_sym_mutable] = ACTIONS(3504),
    [anon_sym_constinit] = ACTIONS(3504),
    [anon_sym_consteval] = ACTIONS(3504),
    [anon_sym_alignas] = ACTIONS(3504),
    [anon_sym__Alignas] = ACTIONS(3504),
    [anon_sym_DOT] = ACTIONS(3504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3504),
    [anon_sym_let] = ACTIONS(3504),
    [anon_sym_This] = ACTIONS(3504),
    [anon_sym_precise] = ACTIONS(3504),
    [anon_sym_shared] = ACTIONS(3504),
    [anon_sym_groupshared] = ACTIONS(3504),
    [anon_sym_uniform] = ACTIONS(3504),
    [anon_sym_row_major] = ACTIONS(3504),
    [anon_sym_column_major] = ACTIONS(3504),
    [anon_sym_globallycoherent] = ACTIONS(3504),
    [anon_sym_centroid] = ACTIONS(3504),
    [anon_sym_noperspective] = ACTIONS(3504),
    [anon_sym_nointerpolation] = ACTIONS(3504),
    [anon_sym_sample] = ACTIONS(3504),
    [anon_sym_linear] = ACTIONS(3504),
    [anon_sym_snorm] = ACTIONS(3504),
    [anon_sym_unorm] = ACTIONS(3504),
    [anon_sym_point] = ACTIONS(3504),
    [anon_sym_line] = ACTIONS(3502),
    [anon_sym_triangleadj] = ACTIONS(3504),
    [anon_sym_lineadj] = ACTIONS(3504),
    [anon_sym_triangle] = ACTIONS(3502),
  },
  [3368] = {
    [sym_string_literal] = STATE(3261),
    [sym_raw_string_literal] = STATE(3261),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7388),
    [anon_sym_COMMA] = ACTIONS(7388),
    [anon_sym_LPAREN2] = ACTIONS(7388),
    [anon_sym_DASH] = ACTIONS(7386),
    [anon_sym_PLUS] = ACTIONS(7386),
    [anon_sym_STAR] = ACTIONS(7386),
    [anon_sym_SLASH] = ACTIONS(7386),
    [anon_sym_PERCENT] = ACTIONS(7386),
    [anon_sym_PIPE_PIPE] = ACTIONS(7388),
    [anon_sym_AMP_AMP] = ACTIONS(7388),
    [anon_sym_PIPE] = ACTIONS(7386),
    [anon_sym_CARET] = ACTIONS(7386),
    [anon_sym_AMP] = ACTIONS(7386),
    [anon_sym_EQ_EQ] = ACTIONS(7388),
    [anon_sym_BANG_EQ] = ACTIONS(7388),
    [anon_sym_GT] = ACTIONS(7386),
    [anon_sym_GT_EQ] = ACTIONS(7386),
    [anon_sym_LT_EQ] = ACTIONS(7386),
    [anon_sym_LT] = ACTIONS(7386),
    [anon_sym_LT_LT] = ACTIONS(7386),
    [anon_sym_GT_GT] = ACTIONS(7386),
    [anon_sym_LBRACK] = ACTIONS(7388),
    [anon_sym_EQ] = ACTIONS(7386),
    [anon_sym_QMARK] = ACTIONS(7388),
    [anon_sym_STAR_EQ] = ACTIONS(7388),
    [anon_sym_SLASH_EQ] = ACTIONS(7388),
    [anon_sym_PERCENT_EQ] = ACTIONS(7388),
    [anon_sym_PLUS_EQ] = ACTIONS(7388),
    [anon_sym_DASH_EQ] = ACTIONS(7388),
    [anon_sym_LT_LT_EQ] = ACTIONS(7388),
    [anon_sym_GT_GT_EQ] = ACTIONS(7386),
    [anon_sym_AMP_EQ] = ACTIONS(7388),
    [anon_sym_CARET_EQ] = ACTIONS(7388),
    [anon_sym_PIPE_EQ] = ACTIONS(7388),
    [anon_sym_and_eq] = ACTIONS(7386),
    [anon_sym_or_eq] = ACTIONS(7386),
    [anon_sym_xor_eq] = ACTIONS(7386),
    [anon_sym_LT_EQ_GT] = ACTIONS(7388),
    [anon_sym_or] = ACTIONS(7386),
    [anon_sym_and] = ACTIONS(7386),
    [anon_sym_bitor] = ACTIONS(7386),
    [anon_sym_xor] = ACTIONS(7386),
    [anon_sym_bitand] = ACTIONS(7386),
    [anon_sym_not_eq] = ACTIONS(7386),
    [anon_sym_is] = ACTIONS(7386),
    [anon_sym_as] = ACTIONS(7386),
    [anon_sym_DASH_DASH] = ACTIONS(7388),
    [anon_sym_PLUS_PLUS] = ACTIONS(7388),
    [anon_sym_DOT] = ACTIONS(7386),
    [anon_sym_DOT_STAR] = ACTIONS(7388),
    [anon_sym_DASH_GT] = ACTIONS(7388),
    [anon_sym_L_DQUOTE] = ACTIONS(7600),
    [anon_sym_u_DQUOTE] = ACTIONS(7600),
    [anon_sym_U_DQUOTE] = ACTIONS(7600),
    [anon_sym_u8_DQUOTE] = ACTIONS(7600),
    [anon_sym_DQUOTE] = ACTIONS(7600),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(7388),
    [anon_sym_R_DQUOTE] = ACTIONS(7602),
    [anon_sym_LR_DQUOTE] = ACTIONS(7602),
    [anon_sym_uR_DQUOTE] = ACTIONS(7602),
    [anon_sym_UR_DQUOTE] = ACTIONS(7602),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7602),
    [sym_literal_suffix] = ACTIONS(7386),
  },
  [3369] = {
    [sym_identifier] = ACTIONS(7832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7834),
    [anon_sym_COMMA] = ACTIONS(7834),
    [anon_sym_RPAREN] = ACTIONS(7834),
    [aux_sym_preproc_if_token2] = ACTIONS(7834),
    [aux_sym_preproc_else_token1] = ACTIONS(7834),
    [aux_sym_preproc_elif_token1] = ACTIONS(7832),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7834),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7834),
    [anon_sym_LPAREN2] = ACTIONS(7834),
    [anon_sym_DASH] = ACTIONS(7832),
    [anon_sym_PLUS] = ACTIONS(7832),
    [anon_sym_STAR] = ACTIONS(7832),
    [anon_sym_SLASH] = ACTIONS(7832),
    [anon_sym_PERCENT] = ACTIONS(7832),
    [anon_sym_PIPE_PIPE] = ACTIONS(7834),
    [anon_sym_AMP_AMP] = ACTIONS(7834),
    [anon_sym_PIPE] = ACTIONS(7832),
    [anon_sym_CARET] = ACTIONS(7832),
    [anon_sym_AMP] = ACTIONS(7832),
    [anon_sym_EQ_EQ] = ACTIONS(7834),
    [anon_sym_BANG_EQ] = ACTIONS(7834),
    [anon_sym_GT] = ACTIONS(7832),
    [anon_sym_GT_EQ] = ACTIONS(7834),
    [anon_sym_LT_EQ] = ACTIONS(7832),
    [anon_sym_LT] = ACTIONS(7832),
    [anon_sym_LT_LT] = ACTIONS(7832),
    [anon_sym_GT_GT] = ACTIONS(7832),
    [anon_sym_COLON] = ACTIONS(7834),
    [anon_sym_SEMI] = ACTIONS(7834),
    [anon_sym___attribute__] = ACTIONS(7832),
    [anon_sym___attribute] = ACTIONS(7832),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(7834),
    [anon_sym_RBRACE] = ACTIONS(7834),
    [anon_sym_LBRACK] = ACTIONS(7832),
    [anon_sym_RBRACK] = ACTIONS(7834),
    [anon_sym_EQ] = ACTIONS(7832),
    [anon_sym_QMARK] = ACTIONS(7834),
    [anon_sym_STAR_EQ] = ACTIONS(7834),
    [anon_sym_SLASH_EQ] = ACTIONS(7834),
    [anon_sym_PERCENT_EQ] = ACTIONS(7834),
    [anon_sym_PLUS_EQ] = ACTIONS(7834),
    [anon_sym_DASH_EQ] = ACTIONS(7834),
    [anon_sym_LT_LT_EQ] = ACTIONS(7834),
    [anon_sym_GT_GT_EQ] = ACTIONS(7834),
    [anon_sym_AMP_EQ] = ACTIONS(7834),
    [anon_sym_CARET_EQ] = ACTIONS(7834),
    [anon_sym_PIPE_EQ] = ACTIONS(7834),
    [anon_sym_and_eq] = ACTIONS(7832),
    [anon_sym_or_eq] = ACTIONS(7832),
    [anon_sym_xor_eq] = ACTIONS(7832),
    [anon_sym_LT_EQ_GT] = ACTIONS(7834),
    [anon_sym_or] = ACTIONS(7832),
    [anon_sym_and] = ACTIONS(7832),
    [anon_sym_bitor] = ACTIONS(7832),
    [anon_sym_xor] = ACTIONS(7832),
    [anon_sym_bitand] = ACTIONS(7832),
    [anon_sym_not_eq] = ACTIONS(7832),
    [anon_sym_is] = ACTIONS(7832),
    [anon_sym_as] = ACTIONS(7832),
    [anon_sym_DASH_DASH] = ACTIONS(7834),
    [anon_sym_PLUS_PLUS] = ACTIONS(7834),
    [anon_sym_DOT] = ACTIONS(7832),
    [anon_sym_DOT_STAR] = ACTIONS(7834),
    [anon_sym_DASH_GT] = ACTIONS(7834),
    [sym_comment] = ACTIONS(3),
  },
  [3370] = {
    [sym_argument_list] = STATE(3465),
    [sym_subscript_argument_list] = STATE(3430),
    [sym_identifier] = ACTIONS(7836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7838),
    [anon_sym_COMMA] = ACTIONS(7838),
    [anon_sym_RPAREN] = ACTIONS(7838),
    [aux_sym_preproc_if_token2] = ACTIONS(7838),
    [aux_sym_preproc_else_token1] = ACTIONS(7838),
    [aux_sym_preproc_elif_token1] = ACTIONS(7836),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7838),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7838),
    [anon_sym_LPAREN2] = ACTIONS(7358),
    [anon_sym_DASH] = ACTIONS(7836),
    [anon_sym_PLUS] = ACTIONS(7836),
    [anon_sym_STAR] = ACTIONS(7836),
    [anon_sym_SLASH] = ACTIONS(7836),
    [anon_sym_PERCENT] = ACTIONS(7836),
    [anon_sym_PIPE_PIPE] = ACTIONS(7838),
    [anon_sym_AMP_AMP] = ACTIONS(7838),
    [anon_sym_PIPE] = ACTIONS(7836),
    [anon_sym_CARET] = ACTIONS(7836),
    [anon_sym_AMP] = ACTIONS(7836),
    [anon_sym_EQ_EQ] = ACTIONS(7838),
    [anon_sym_BANG_EQ] = ACTIONS(7838),
    [anon_sym_GT] = ACTIONS(7836),
    [anon_sym_GT_EQ] = ACTIONS(7838),
    [anon_sym_LT_EQ] = ACTIONS(7836),
    [anon_sym_LT] = ACTIONS(7836),
    [anon_sym_LT_LT] = ACTIONS(7836),
    [anon_sym_GT_GT] = ACTIONS(7836),
    [anon_sym_SEMI] = ACTIONS(7838),
    [anon_sym___attribute__] = ACTIONS(7836),
    [anon_sym___attribute] = ACTIONS(7836),
    [anon_sym_RBRACE] = ACTIONS(7838),
    [anon_sym_LBRACK] = ACTIONS(7775),
    [anon_sym_RBRACK] = ACTIONS(7838),
    [anon_sym_EQ] = ACTIONS(7836),
    [anon_sym_QMARK] = ACTIONS(7838),
    [anon_sym_STAR_EQ] = ACTIONS(7838),
    [anon_sym_SLASH_EQ] = ACTIONS(7838),
    [anon_sym_PERCENT_EQ] = ACTIONS(7838),
    [anon_sym_PLUS_EQ] = ACTIONS(7838),
    [anon_sym_DASH_EQ] = ACTIONS(7838),
    [anon_sym_LT_LT_EQ] = ACTIONS(7838),
    [anon_sym_GT_GT_EQ] = ACTIONS(7838),
    [anon_sym_AMP_EQ] = ACTIONS(7838),
    [anon_sym_CARET_EQ] = ACTIONS(7838),
    [anon_sym_PIPE_EQ] = ACTIONS(7838),
    [anon_sym_and_eq] = ACTIONS(7836),
    [anon_sym_or_eq] = ACTIONS(7836),
    [anon_sym_xor_eq] = ACTIONS(7836),
    [anon_sym_LT_EQ_GT] = ACTIONS(7838),
    [anon_sym_or] = ACTIONS(7836),
    [anon_sym_and] = ACTIONS(7836),
    [anon_sym_bitor] = ACTIONS(7836),
    [anon_sym_xor] = ACTIONS(7836),
    [anon_sym_bitand] = ACTIONS(7836),
    [anon_sym_not_eq] = ACTIONS(7836),
    [anon_sym_is] = ACTIONS(7836),
    [anon_sym_as] = ACTIONS(7836),
    [anon_sym_DASH_DASH] = ACTIONS(7838),
    [anon_sym_PLUS_PLUS] = ACTIONS(7838),
    [anon_sym_DOT] = ACTIONS(7779),
    [anon_sym_DOT_STAR] = ACTIONS(7781),
    [anon_sym_DASH_GT] = ACTIONS(7781),
    [sym_comment] = ACTIONS(3),
  },
  [3371] = {
    [sym_attribute_specifier] = STATE(2854),
    [sym_enumerator_list] = STATE(2824),
    [sym__enum_base_clause] = STATE(2783),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(7830),
    [anon_sym___extension__] = ACTIONS(3480),
    [anon_sym_in] = ACTIONS(3478),
    [anon_sym_out] = ACTIONS(3480),
    [anon_sym_inout] = ACTIONS(3480),
    [anon_sym_virtual] = ACTIONS(3480),
    [anon_sym_extern] = ACTIONS(3480),
    [anon_sym___attribute__] = ACTIONS(7434),
    [anon_sym___attribute] = ACTIONS(6726),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3480),
    [anon_sym___declspec] = ACTIONS(3480),
    [anon_sym_LBRACE] = ACTIONS(6963),
    [anon_sym_LBRACK] = ACTIONS(3478),
    [anon_sym_static] = ACTIONS(3480),
    [anon_sym_register] = ACTIONS(3480),
    [anon_sym_inline] = ACTIONS(3480),
    [anon_sym___inline] = ACTIONS(3478),
    [anon_sym___inline__] = ACTIONS(3480),
    [anon_sym___forceinline] = ACTIONS(3480),
    [anon_sym_thread_local] = ACTIONS(3480),
    [anon_sym___thread] = ACTIONS(3480),
    [anon_sym_const] = ACTIONS(3478),
    [anon_sym_constexpr] = ACTIONS(3480),
    [anon_sym_volatile] = ACTIONS(3480),
    [anon_sym_restrict] = ACTIONS(3480),
    [anon_sym___restrict__] = ACTIONS(3480),
    [anon_sym__Atomic] = ACTIONS(3480),
    [anon_sym__Noreturn] = ACTIONS(3480),
    [anon_sym_noreturn] = ACTIONS(3480),
    [anon_sym__Nonnull] = ACTIONS(3480),
    [anon_sym_mutable] = ACTIONS(3480),
    [anon_sym_constinit] = ACTIONS(3480),
    [anon_sym_consteval] = ACTIONS(3480),
    [anon_sym_alignas] = ACTIONS(3480),
    [anon_sym__Alignas] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_This] = ACTIONS(3480),
    [anon_sym_precise] = ACTIONS(3480),
    [anon_sym_shared] = ACTIONS(3480),
    [anon_sym_groupshared] = ACTIONS(3480),
    [anon_sym_uniform] = ACTIONS(3480),
    [anon_sym_row_major] = ACTIONS(3480),
    [anon_sym_column_major] = ACTIONS(3480),
    [anon_sym_globallycoherent] = ACTIONS(3480),
    [anon_sym_centroid] = ACTIONS(3480),
    [anon_sym_noperspective] = ACTIONS(3480),
    [anon_sym_nointerpolation] = ACTIONS(3480),
    [anon_sym_sample] = ACTIONS(3480),
    [anon_sym_linear] = ACTIONS(3480),
    [anon_sym_snorm] = ACTIONS(3480),
    [anon_sym_unorm] = ACTIONS(3480),
    [anon_sym_point] = ACTIONS(3480),
    [anon_sym_line] = ACTIONS(3478),
    [anon_sym_triangleadj] = ACTIONS(3480),
    [anon_sym_lineadj] = ACTIONS(3480),
    [anon_sym_triangle] = ACTIONS(3478),
  },
  [3372] = {
    [sym_identifier] = ACTIONS(4860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4862),
    [anon_sym_COMMA] = ACTIONS(4862),
    [anon_sym_RPAREN] = ACTIONS(4862),
    [aux_sym_preproc_if_token2] = ACTIONS(4862),
    [aux_sym_preproc_else_token1] = ACTIONS(4862),
    [aux_sym_preproc_elif_token1] = ACTIONS(4860),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4862),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4862),
    [anon_sym_LPAREN2] = ACTIONS(4862),
    [anon_sym_DASH] = ACTIONS(4860),
    [anon_sym_PLUS] = ACTIONS(4860),
    [anon_sym_STAR] = ACTIONS(4860),
    [anon_sym_SLASH] = ACTIONS(4860),
    [anon_sym_PERCENT] = ACTIONS(4860),
    [anon_sym_PIPE_PIPE] = ACTIONS(4862),
    [anon_sym_AMP_AMP] = ACTIONS(4862),
    [anon_sym_PIPE] = ACTIONS(4860),
    [anon_sym_CARET] = ACTIONS(4860),
    [anon_sym_AMP] = ACTIONS(4860),
    [anon_sym_EQ_EQ] = ACTIONS(4862),
    [anon_sym_BANG_EQ] = ACTIONS(4862),
    [anon_sym_GT] = ACTIONS(4860),
    [anon_sym_GT_EQ] = ACTIONS(4862),
    [anon_sym_LT_EQ] = ACTIONS(4860),
    [anon_sym_LT] = ACTIONS(4860),
    [anon_sym_LT_LT] = ACTIONS(4860),
    [anon_sym_GT_GT] = ACTIONS(4860),
    [anon_sym_COLON] = ACTIONS(4862),
    [anon_sym_SEMI] = ACTIONS(4862),
    [anon_sym___attribute__] = ACTIONS(4860),
    [anon_sym___attribute] = ACTIONS(4860),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4862),
    [anon_sym_RBRACE] = ACTIONS(4862),
    [anon_sym_LBRACK] = ACTIONS(4860),
    [anon_sym_RBRACK] = ACTIONS(4862),
    [anon_sym_EQ] = ACTIONS(4860),
    [anon_sym_QMARK] = ACTIONS(4862),
    [anon_sym_STAR_EQ] = ACTIONS(4862),
    [anon_sym_SLASH_EQ] = ACTIONS(4862),
    [anon_sym_PERCENT_EQ] = ACTIONS(4862),
    [anon_sym_PLUS_EQ] = ACTIONS(4862),
    [anon_sym_DASH_EQ] = ACTIONS(4862),
    [anon_sym_LT_LT_EQ] = ACTIONS(4862),
    [anon_sym_GT_GT_EQ] = ACTIONS(4862),
    [anon_sym_AMP_EQ] = ACTIONS(4862),
    [anon_sym_CARET_EQ] = ACTIONS(4862),
    [anon_sym_PIPE_EQ] = ACTIONS(4862),
    [anon_sym_and_eq] = ACTIONS(4860),
    [anon_sym_or_eq] = ACTIONS(4860),
    [anon_sym_xor_eq] = ACTIONS(4860),
    [anon_sym_LT_EQ_GT] = ACTIONS(4862),
    [anon_sym_or] = ACTIONS(4860),
    [anon_sym_and] = ACTIONS(4860),
    [anon_sym_bitor] = ACTIONS(4860),
    [anon_sym_xor] = ACTIONS(4860),
    [anon_sym_bitand] = ACTIONS(4860),
    [anon_sym_not_eq] = ACTIONS(4860),
    [anon_sym_is] = ACTIONS(4860),
    [anon_sym_as] = ACTIONS(4860),
    [anon_sym_DASH_DASH] = ACTIONS(4862),
    [anon_sym_PLUS_PLUS] = ACTIONS(4862),
    [anon_sym_DOT] = ACTIONS(4860),
    [anon_sym_DOT_STAR] = ACTIONS(4862),
    [anon_sym_DASH_GT] = ACTIONS(4862),
    [sym_comment] = ACTIONS(3),
  },
  [3373] = {
    [sym_identifier] = ACTIONS(4242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4240),
    [anon_sym_COMMA] = ACTIONS(4240),
    [anon_sym_LPAREN2] = ACTIONS(4240),
    [anon_sym_DASH] = ACTIONS(4242),
    [anon_sym_PLUS] = ACTIONS(4242),
    [anon_sym_STAR] = ACTIONS(4240),
    [anon_sym_SLASH] = ACTIONS(4242),
    [anon_sym_PERCENT] = ACTIONS(4240),
    [anon_sym_PIPE_PIPE] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4240),
    [anon_sym_PIPE] = ACTIONS(4242),
    [anon_sym_CARET] = ACTIONS(4240),
    [anon_sym_AMP] = ACTIONS(4242),
    [anon_sym_EQ_EQ] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(4240),
    [anon_sym_GT] = ACTIONS(4242),
    [anon_sym_GT_EQ] = ACTIONS(4242),
    [anon_sym_LT_EQ] = ACTIONS(4242),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_LT_LT] = ACTIONS(4240),
    [anon_sym_GT_GT] = ACTIONS(4242),
    [anon_sym___extension__] = ACTIONS(4242),
    [anon_sym___attribute__] = ACTIONS(4242),
    [anon_sym___attribute] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_signed] = ACTIONS(4242),
    [anon_sym_unsigned] = ACTIONS(4242),
    [anon_sym_long] = ACTIONS(4242),
    [anon_sym_short] = ACTIONS(4242),
    [anon_sym_LBRACK] = ACTIONS(4240),
    [anon_sym_const] = ACTIONS(4242),
    [anon_sym_constexpr] = ACTIONS(4242),
    [anon_sym_volatile] = ACTIONS(4242),
    [anon_sym_restrict] = ACTIONS(4242),
    [anon_sym___restrict__] = ACTIONS(4242),
    [anon_sym__Atomic] = ACTIONS(4242),
    [anon_sym__Noreturn] = ACTIONS(4242),
    [anon_sym_noreturn] = ACTIONS(4242),
    [anon_sym__Nonnull] = ACTIONS(4242),
    [anon_sym_mutable] = ACTIONS(4242),
    [anon_sym_constinit] = ACTIONS(4242),
    [anon_sym_consteval] = ACTIONS(4242),
    [anon_sym_alignas] = ACTIONS(4242),
    [anon_sym__Alignas] = ACTIONS(4242),
    [sym_primitive_type] = ACTIONS(4242),
    [anon_sym_QMARK] = ACTIONS(4240),
    [anon_sym_LT_EQ_GT] = ACTIONS(4240),
    [anon_sym_or] = ACTIONS(4242),
    [anon_sym_and] = ACTIONS(4242),
    [anon_sym_bitor] = ACTIONS(4242),
    [anon_sym_xor] = ACTIONS(4242),
    [anon_sym_bitand] = ACTIONS(4242),
    [anon_sym_not_eq] = ACTIONS(4242),
    [anon_sym_is] = ACTIONS(4242),
    [anon_sym_as] = ACTIONS(4242),
    [anon_sym_DASH_DASH] = ACTIONS(4240),
    [anon_sym_PLUS_PLUS] = ACTIONS(4240),
    [anon_sym_DOT] = ACTIONS(4242),
    [anon_sym_DOT_STAR] = ACTIONS(4240),
    [anon_sym_DASH_GT] = ACTIONS(4240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4242),
    [anon_sym_let] = ACTIONS(4242),
    [anon_sym_This] = ACTIONS(4242),
    [anon_sym_GT2] = ACTIONS(4240),
  },
  [3374] = {
    [sym_string_literal] = STATE(3340),
    [sym_raw_string_literal] = STATE(3340),
    [aux_sym_concatenated_string_repeat1] = STATE(3340),
    [sym_identifier] = ACTIONS(7840),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7217),
    [anon_sym_COMMA] = ACTIONS(7217),
    [anon_sym_RPAREN] = ACTIONS(7217),
    [anon_sym_LPAREN2] = ACTIONS(7217),
    [anon_sym_DASH] = ACTIONS(7219),
    [anon_sym_PLUS] = ACTIONS(7219),
    [anon_sym_STAR] = ACTIONS(7219),
    [anon_sym_SLASH] = ACTIONS(7219),
    [anon_sym_PERCENT] = ACTIONS(7219),
    [anon_sym_PIPE_PIPE] = ACTIONS(7217),
    [anon_sym_AMP_AMP] = ACTIONS(7217),
    [anon_sym_PIPE] = ACTIONS(7219),
    [anon_sym_CARET] = ACTIONS(7219),
    [anon_sym_AMP] = ACTIONS(7219),
    [anon_sym_EQ_EQ] = ACTIONS(7217),
    [anon_sym_BANG_EQ] = ACTIONS(7217),
    [anon_sym_GT] = ACTIONS(7219),
    [anon_sym_GT_EQ] = ACTIONS(7217),
    [anon_sym_LT_EQ] = ACTIONS(7219),
    [anon_sym_LT] = ACTIONS(7219),
    [anon_sym_LT_LT] = ACTIONS(7219),
    [anon_sym_GT_GT] = ACTIONS(7219),
    [anon_sym_LBRACK] = ACTIONS(7217),
    [anon_sym_EQ] = ACTIONS(7219),
    [anon_sym_QMARK] = ACTIONS(7217),
    [anon_sym_STAR_EQ] = ACTIONS(7217),
    [anon_sym_SLASH_EQ] = ACTIONS(7217),
    [anon_sym_PERCENT_EQ] = ACTIONS(7217),
    [anon_sym_PLUS_EQ] = ACTIONS(7217),
    [anon_sym_DASH_EQ] = ACTIONS(7217),
    [anon_sym_LT_LT_EQ] = ACTIONS(7217),
    [anon_sym_GT_GT_EQ] = ACTIONS(7217),
    [anon_sym_AMP_EQ] = ACTIONS(7217),
    [anon_sym_CARET_EQ] = ACTIONS(7217),
    [anon_sym_PIPE_EQ] = ACTIONS(7217),
    [anon_sym_LT_EQ_GT] = ACTIONS(7217),
    [anon_sym_or] = ACTIONS(7219),
    [anon_sym_and] = ACTIONS(7219),
    [anon_sym_bitor] = ACTIONS(7219),
    [anon_sym_xor] = ACTIONS(7219),
    [anon_sym_bitand] = ACTIONS(7219),
    [anon_sym_not_eq] = ACTIONS(7219),
    [anon_sym_is] = ACTIONS(7219),
    [anon_sym_as] = ACTIONS(7219),
    [anon_sym_DASH_DASH] = ACTIONS(7217),
    [anon_sym_PLUS_PLUS] = ACTIONS(7217),
    [anon_sym_DOT] = ACTIONS(7219),
    [anon_sym_DOT_STAR] = ACTIONS(7217),
    [anon_sym_DASH_GT] = ACTIONS(7219),
    [anon_sym_L_DQUOTE] = ACTIONS(5383),
    [anon_sym_u_DQUOTE] = ACTIONS(5383),
    [anon_sym_U_DQUOTE] = ACTIONS(5383),
    [anon_sym_u8_DQUOTE] = ACTIONS(5383),
    [anon_sym_DQUOTE] = ACTIONS(5383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5385),
    [anon_sym_LR_DQUOTE] = ACTIONS(5385),
    [anon_sym_uR_DQUOTE] = ACTIONS(5385),
    [anon_sym_UR_DQUOTE] = ACTIONS(5385),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5385),
    [anon_sym_DASH_GT_STAR] = ACTIONS(7217),
    [sym_literal_suffix] = ACTIONS(7219),
  },
  [3375] = {
    [sym_identifier] = ACTIONS(7842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7844),
    [anon_sym_COMMA] = ACTIONS(7844),
    [anon_sym_RPAREN] = ACTIONS(7844),
    [aux_sym_preproc_if_token2] = ACTIONS(7844),
    [aux_sym_preproc_else_token1] = ACTIONS(7844),
    [aux_sym_preproc_elif_token1] = ACTIONS(7842),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7844),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7844),
    [anon_sym_LPAREN2] = ACTIONS(7844),
    [anon_sym_DASH] = ACTIONS(7842),
    [anon_sym_PLUS] = ACTIONS(7842),
    [anon_sym_STAR] = ACTIONS(7842),
    [anon_sym_SLASH] = ACTIONS(7842),
    [anon_sym_PERCENT] = ACTIONS(7842),
    [anon_sym_PIPE_PIPE] = ACTIONS(7844),
    [anon_sym_AMP_AMP] = ACTIONS(7844),
    [anon_sym_PIPE] = ACTIONS(7842),
    [anon_sym_CARET] = ACTIONS(7842),
    [anon_sym_AMP] = ACTIONS(7842),
    [anon_sym_EQ_EQ] = ACTIONS(7844),
    [anon_sym_BANG_EQ] = ACTIONS(7844),
    [anon_sym_GT] = ACTIONS(7842),
    [anon_sym_GT_EQ] = ACTIONS(7844),
    [anon_sym_LT_EQ] = ACTIONS(7842),
    [anon_sym_LT] = ACTIONS(7842),
    [anon_sym_LT_LT] = ACTIONS(7842),
    [anon_sym_GT_GT] = ACTIONS(7842),
    [anon_sym_COLON] = ACTIONS(7844),
    [anon_sym_SEMI] = ACTIONS(7844),
    [anon_sym___attribute__] = ACTIONS(7842),
    [anon_sym___attribute] = ACTIONS(7842),
    [anon_sym_LBRACE] = ACTIONS(7844),
    [anon_sym_RBRACE] = ACTIONS(7844),
    [anon_sym_LBRACK] = ACTIONS(7844),
    [anon_sym_RBRACK] = ACTIONS(7844),
    [anon_sym_EQ] = ACTIONS(7842),
    [anon_sym_QMARK] = ACTIONS(7844),
    [anon_sym_STAR_EQ] = ACTIONS(7844),
    [anon_sym_SLASH_EQ] = ACTIONS(7844),
    [anon_sym_PERCENT_EQ] = ACTIONS(7844),
    [anon_sym_PLUS_EQ] = ACTIONS(7844),
    [anon_sym_DASH_EQ] = ACTIONS(7844),
    [anon_sym_LT_LT_EQ] = ACTIONS(7844),
    [anon_sym_GT_GT_EQ] = ACTIONS(7844),
    [anon_sym_AMP_EQ] = ACTIONS(7844),
    [anon_sym_CARET_EQ] = ACTIONS(7844),
    [anon_sym_PIPE_EQ] = ACTIONS(7844),
    [anon_sym_and_eq] = ACTIONS(7842),
    [anon_sym_or_eq] = ACTIONS(7842),
    [anon_sym_xor_eq] = ACTIONS(7842),
    [anon_sym_LT_EQ_GT] = ACTIONS(7844),
    [anon_sym_or] = ACTIONS(7842),
    [anon_sym_and] = ACTIONS(7842),
    [anon_sym_bitor] = ACTIONS(7842),
    [anon_sym_xor] = ACTIONS(7842),
    [anon_sym_bitand] = ACTIONS(7842),
    [anon_sym_not_eq] = ACTIONS(7842),
    [anon_sym_is] = ACTIONS(7842),
    [anon_sym_as] = ACTIONS(7842),
    [anon_sym_DASH_DASH] = ACTIONS(7844),
    [anon_sym_PLUS_PLUS] = ACTIONS(7844),
    [anon_sym_DOT] = ACTIONS(7842),
    [anon_sym_DOT_STAR] = ACTIONS(7844),
    [anon_sym_DASH_GT] = ACTIONS(7844),
    [sym_comment] = ACTIONS(3),
  },
  [3376] = {
    [sym_argument_list] = STATE(3465),
    [sym_subscript_argument_list] = STATE(3430),
    [sym_identifier] = ACTIONS(7846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7848),
    [anon_sym_COMMA] = ACTIONS(7848),
    [anon_sym_RPAREN] = ACTIONS(7848),
    [aux_sym_preproc_if_token2] = ACTIONS(7848),
    [aux_sym_preproc_else_token1] = ACTIONS(7848),
    [aux_sym_preproc_elif_token1] = ACTIONS(7846),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7848),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7848),
    [anon_sym_LPAREN2] = ACTIONS(7358),
    [anon_sym_DASH] = ACTIONS(7846),
    [anon_sym_PLUS] = ACTIONS(7846),
    [anon_sym_STAR] = ACTIONS(7846),
    [anon_sym_SLASH] = ACTIONS(7846),
    [anon_sym_PERCENT] = ACTIONS(7846),
    [anon_sym_PIPE_PIPE] = ACTIONS(7848),
    [anon_sym_AMP_AMP] = ACTIONS(7848),
    [anon_sym_PIPE] = ACTIONS(7846),
    [anon_sym_CARET] = ACTIONS(7846),
    [anon_sym_AMP] = ACTIONS(7846),
    [anon_sym_EQ_EQ] = ACTIONS(7848),
    [anon_sym_BANG_EQ] = ACTIONS(7848),
    [anon_sym_GT] = ACTIONS(7846),
    [anon_sym_GT_EQ] = ACTIONS(7848),
    [anon_sym_LT_EQ] = ACTIONS(7846),
    [anon_sym_LT] = ACTIONS(7846),
    [anon_sym_LT_LT] = ACTIONS(7846),
    [anon_sym_GT_GT] = ACTIONS(7846),
    [anon_sym_SEMI] = ACTIONS(7848),
    [anon_sym___attribute__] = ACTIONS(7846),
    [anon_sym___attribute] = ACTIONS(7846),
    [anon_sym_RBRACE] = ACTIONS(7848),
    [anon_sym_LBRACK] = ACTIONS(7775),
    [anon_sym_RBRACK] = ACTIONS(7848),
    [anon_sym_EQ] = ACTIONS(7846),
    [anon_sym_QMARK] = ACTIONS(7848),
    [anon_sym_STAR_EQ] = ACTIONS(7848),
    [anon_sym_SLASH_EQ] = ACTIONS(7848),
    [anon_sym_PERCENT_EQ] = ACTIONS(7848),
    [anon_sym_PLUS_EQ] = ACTIONS(7848),
    [anon_sym_DASH_EQ] = ACTIONS(7848),
    [anon_sym_LT_LT_EQ] = ACTIONS(7848),
    [anon_sym_GT_GT_EQ] = ACTIONS(7848),
    [anon_sym_AMP_EQ] = ACTIONS(7848),
    [anon_sym_CARET_EQ] = ACTIONS(7848),
    [anon_sym_PIPE_EQ] = ACTIONS(7848),
    [anon_sym_and_eq] = ACTIONS(7846),
    [anon_sym_or_eq] = ACTIONS(7846),
    [anon_sym_xor_eq] = ACTIONS(7846),
    [anon_sym_LT_EQ_GT] = ACTIONS(7848),
    [anon_sym_or] = ACTIONS(7846),
    [anon_sym_and] = ACTIONS(7846),
    [anon_sym_bitor] = ACTIONS(7846),
    [anon_sym_xor] = ACTIONS(7846),
    [anon_sym_bitand] = ACTIONS(7846),
    [anon_sym_not_eq] = ACTIONS(7846),
    [anon_sym_is] = ACTIONS(7846),
    [anon_sym_as] = ACTIONS(7846),
    [anon_sym_DASH_DASH] = ACTIONS(7777),
    [anon_sym_PLUS_PLUS] = ACTIONS(7777),
    [anon_sym_DOT] = ACTIONS(7779),
    [anon_sym_DOT_STAR] = ACTIONS(7781),
    [anon_sym_DASH_GT] = ACTIONS(7781),
    [sym_comment] = ACTIONS(3),
  },
  [3377] = {
    [sym_template_argument_list] = STATE(2953),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3775),
    [anon_sym_COMMA] = ACTIONS(3775),
    [anon_sym_LPAREN2] = ACTIONS(3775),
    [anon_sym_DASH] = ACTIONS(3777),
    [anon_sym_PLUS] = ACTIONS(3777),
    [anon_sym_STAR] = ACTIONS(3777),
    [anon_sym_SLASH] = ACTIONS(3777),
    [anon_sym_PERCENT] = ACTIONS(3777),
    [anon_sym_PIPE_PIPE] = ACTIONS(3775),
    [anon_sym_AMP_AMP] = ACTIONS(3775),
    [anon_sym_PIPE] = ACTIONS(3777),
    [anon_sym_CARET] = ACTIONS(3777),
    [anon_sym_AMP] = ACTIONS(3777),
    [anon_sym_EQ_EQ] = ACTIONS(3775),
    [anon_sym_BANG_EQ] = ACTIONS(3775),
    [anon_sym_GT] = ACTIONS(3777),
    [anon_sym_GT_EQ] = ACTIONS(3777),
    [anon_sym_LT_EQ] = ACTIONS(3777),
    [anon_sym_LT] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3777),
    [anon_sym_GT_GT] = ACTIONS(3777),
    [anon_sym___attribute__] = ACTIONS(3775),
    [anon_sym___attribute] = ACTIONS(3777),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(3775),
    [anon_sym_signed] = ACTIONS(7850),
    [anon_sym_unsigned] = ACTIONS(7850),
    [anon_sym_long] = ACTIONS(7850),
    [anon_sym_short] = ACTIONS(7850),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_EQ] = ACTIONS(3777),
    [anon_sym_QMARK] = ACTIONS(3775),
    [anon_sym_STAR_EQ] = ACTIONS(3775),
    [anon_sym_SLASH_EQ] = ACTIONS(3775),
    [anon_sym_PERCENT_EQ] = ACTIONS(3775),
    [anon_sym_PLUS_EQ] = ACTIONS(3775),
    [anon_sym_DASH_EQ] = ACTIONS(3775),
    [anon_sym_LT_LT_EQ] = ACTIONS(3775),
    [anon_sym_GT_GT_EQ] = ACTIONS(3777),
    [anon_sym_AMP_EQ] = ACTIONS(3775),
    [anon_sym_CARET_EQ] = ACTIONS(3775),
    [anon_sym_PIPE_EQ] = ACTIONS(3775),
    [anon_sym_and_eq] = ACTIONS(3775),
    [anon_sym_or_eq] = ACTIONS(3775),
    [anon_sym_xor_eq] = ACTIONS(3775),
    [anon_sym_LT_EQ_GT] = ACTIONS(3775),
    [anon_sym_or] = ACTIONS(3777),
    [anon_sym_and] = ACTIONS(3777),
    [anon_sym_bitor] = ACTIONS(3775),
    [anon_sym_xor] = ACTIONS(3777),
    [anon_sym_bitand] = ACTIONS(3775),
    [anon_sym_not_eq] = ACTIONS(3775),
    [anon_sym_is] = ACTIONS(3775),
    [anon_sym_as] = ACTIONS(3775),
    [anon_sym_DASH_DASH] = ACTIONS(3775),
    [anon_sym_PLUS_PLUS] = ACTIONS(3775),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_DOT_STAR] = ACTIONS(3775),
    [anon_sym_DASH_GT] = ACTIONS(3775),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3775),
    [anon_sym_let] = ACTIONS(3775),
    [anon_sym_This] = ACTIONS(3775),
    [anon_sym_GT2] = ACTIONS(3775),
  },
  [3378] = {
    [sym_attribute_specifier] = STATE(3213),
    [sym_enumerator_list] = STATE(3152),
    [sym__enum_base_clause] = STATE(3114),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3480),
    [anon_sym_RPAREN] = ACTIONS(3480),
    [anon_sym_LPAREN2] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3478),
    [anon_sym_PLUS] = ACTIONS(3478),
    [anon_sym_STAR] = ACTIONS(3478),
    [anon_sym_SLASH] = ACTIONS(3478),
    [anon_sym_PERCENT] = ACTIONS(3478),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_PIPE] = ACTIONS(3478),
    [anon_sym_CARET] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_EQ_EQ] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3480),
    [anon_sym_GT] = ACTIONS(3478),
    [anon_sym_GT_EQ] = ACTIONS(3480),
    [anon_sym_LT_EQ] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_LT_LT] = ACTIONS(3478),
    [anon_sym_GT_GT] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(7767),
    [anon_sym_SEMI] = ACTIONS(3480),
    [anon_sym___attribute__] = ACTIONS(7769),
    [anon_sym___attribute] = ACTIONS(7254),
    [anon_sym_LBRACE] = ACTIONS(7384),
    [anon_sym_RBRACE] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_RBRACK] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_STAR_EQ] = ACTIONS(3480),
    [anon_sym_SLASH_EQ] = ACTIONS(3480),
    [anon_sym_PERCENT_EQ] = ACTIONS(3480),
    [anon_sym_PLUS_EQ] = ACTIONS(3480),
    [anon_sym_DASH_EQ] = ACTIONS(3480),
    [anon_sym_LT_LT_EQ] = ACTIONS(3480),
    [anon_sym_GT_GT_EQ] = ACTIONS(3480),
    [anon_sym_AMP_EQ] = ACTIONS(3480),
    [anon_sym_CARET_EQ] = ACTIONS(3480),
    [anon_sym_PIPE_EQ] = ACTIONS(3480),
    [anon_sym_and_eq] = ACTIONS(3480),
    [anon_sym_or_eq] = ACTIONS(3480),
    [anon_sym_xor_eq] = ACTIONS(3480),
    [anon_sym_LT_EQ_GT] = ACTIONS(3480),
    [anon_sym_or] = ACTIONS(3478),
    [anon_sym_and] = ACTIONS(3478),
    [anon_sym_bitor] = ACTIONS(3480),
    [anon_sym_xor] = ACTIONS(3478),
    [anon_sym_bitand] = ACTIONS(3480),
    [anon_sym_not_eq] = ACTIONS(3480),
    [anon_sym_is] = ACTIONS(3480),
    [anon_sym_as] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3480),
    [anon_sym_PLUS_PLUS] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3478),
    [anon_sym_DOT_STAR] = ACTIONS(3480),
    [anon_sym_DASH_GT] = ACTIONS(3480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3480),
    [anon_sym_This] = ACTIONS(3480),
  },
  [3379] = {
    [sym_argument_list] = STATE(3465),
    [sym_subscript_argument_list] = STATE(3430),
    [sym_identifier] = ACTIONS(7852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7854),
    [anon_sym_COMMA] = ACTIONS(7854),
    [anon_sym_RPAREN] = ACTIONS(7854),
    [aux_sym_preproc_if_token2] = ACTIONS(7854),
    [aux_sym_preproc_else_token1] = ACTIONS(7854),
    [aux_sym_preproc_elif_token1] = ACTIONS(7852),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7854),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7854),
    [anon_sym_LPAREN2] = ACTIONS(7358),
    [anon_sym_DASH] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7852),
    [anon_sym_STAR] = ACTIONS(7852),
    [anon_sym_SLASH] = ACTIONS(7852),
    [anon_sym_PERCENT] = ACTIONS(7852),
    [anon_sym_PIPE_PIPE] = ACTIONS(7854),
    [anon_sym_AMP_AMP] = ACTIONS(7854),
    [anon_sym_PIPE] = ACTIONS(7852),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_AMP] = ACTIONS(7852),
    [anon_sym_EQ_EQ] = ACTIONS(7854),
    [anon_sym_BANG_EQ] = ACTIONS(7854),
    [anon_sym_GT] = ACTIONS(7852),
    [anon_sym_GT_EQ] = ACTIONS(7854),
    [anon_sym_LT_EQ] = ACTIONS(7852),
    [anon_sym_LT] = ACTIONS(7852),
    [anon_sym_LT_LT] = ACTIONS(7852),
    [anon_sym_GT_GT] = ACTIONS(7852),
    [anon_sym_SEMI] = ACTIONS(7854),
    [anon_sym___attribute__] = ACTIONS(7852),
    [anon_sym___attribute] = ACTIONS(7852),
    [anon_sym_RBRACE] = ACTIONS(7854),
    [anon_sym_LBRACK] = ACTIONS(7775),
    [anon_sym_RBRACK] = ACTIONS(7854),
    [anon_sym_EQ] = ACTIONS(7852),
    [anon_sym_QMARK] = ACTIONS(7854),
    [anon_sym_STAR_EQ] = ACTIONS(7854),
    [anon_sym_SLASH_EQ] = ACTIONS(7854),
    [anon_sym_PERCENT_EQ] = ACTIONS(7854),
    [anon_sym_PLUS_EQ] = ACTIONS(7854),
    [anon_sym_DASH_EQ] = ACTIONS(7854),
    [anon_sym_LT_LT_EQ] = ACTIONS(7854),
    [anon_sym_GT_GT_EQ] = ACTIONS(7854),
    [anon_sym_AMP_EQ] = ACTIONS(7854),
    [anon_sym_CARET_EQ] = ACTIONS(7854),
    [anon_sym_PIPE_EQ] = ACTIONS(7854),
    [anon_sym_and_eq] = ACTIONS(7852),
    [anon_sym_or_eq] = ACTIONS(7852),
    [anon_sym_xor_eq] = ACTIONS(7852),
    [anon_sym_LT_EQ_GT] = ACTIONS(7854),
    [anon_sym_or] = ACTIONS(7852),
    [anon_sym_and] = ACTIONS(7852),
    [anon_sym_bitor] = ACTIONS(7852),
    [anon_sym_xor] = ACTIONS(7852),
    [anon_sym_bitand] = ACTIONS(7852),
    [anon_sym_not_eq] = ACTIONS(7852),
    [anon_sym_is] = ACTIONS(7852),
    [anon_sym_as] = ACTIONS(7852),
    [anon_sym_DASH_DASH] = ACTIONS(7777),
    [anon_sym_PLUS_PLUS] = ACTIONS(7777),
    [anon_sym_DOT] = ACTIONS(7779),
    [anon_sym_DOT_STAR] = ACTIONS(7781),
    [anon_sym_DASH_GT] = ACTIONS(7781),
    [sym_comment] = ACTIONS(3),
  },
  [3380] = {
    [sym_identifier] = ACTIONS(7856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(7858),
    [anon_sym_RPAREN] = ACTIONS(7858),
    [aux_sym_preproc_if_token2] = ACTIONS(7858),
    [aux_sym_preproc_else_token1] = ACTIONS(7858),
    [aux_sym_preproc_elif_token1] = ACTIONS(7856),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7858),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7858),
    [anon_sym_LPAREN2] = ACTIONS(7858),
    [anon_sym_DASH] = ACTIONS(7856),
    [anon_sym_PLUS] = ACTIONS(7856),
    [anon_sym_STAR] = ACTIONS(7856),
    [anon_sym_SLASH] = ACTIONS(7856),
    [anon_sym_PERCENT] = ACTIONS(7856),
    [anon_sym_PIPE_PIPE] = ACTIONS(7858),
    [anon_sym_AMP_AMP] = ACTIONS(7858),
    [anon_sym_PIPE] = ACTIONS(7856),
    [anon_sym_CARET] = ACTIONS(7856),
    [anon_sym_AMP] = ACTIONS(7856),
    [anon_sym_EQ_EQ] = ACTIONS(7858),
    [anon_sym_BANG_EQ] = ACTIONS(7858),
    [anon_sym_GT] = ACTIONS(7856),
    [anon_sym_GT_EQ] = ACTIONS(7858),
    [anon_sym_LT_EQ] = ACTIONS(7856),
    [anon_sym_LT] = ACTIONS(7856),
    [anon_sym_LT_LT] = ACTIONS(7856),
    [anon_sym_GT_GT] = ACTIONS(7856),
    [anon_sym_COLON] = ACTIONS(7858),
    [anon_sym_SEMI] = ACTIONS(7858),
    [anon_sym___attribute__] = ACTIONS(7856),
    [anon_sym___attribute] = ACTIONS(7856),
    [anon_sym_RBRACE] = ACTIONS(7858),
    [anon_sym_LBRACK] = ACTIONS(7858),
    [anon_sym_RBRACK] = ACTIONS(7858),
    [anon_sym_EQ] = ACTIONS(7856),
    [anon_sym_QMARK] = ACTIONS(7858),
    [anon_sym_STAR_EQ] = ACTIONS(7858),
    [anon_sym_SLASH_EQ] = ACTIONS(7858),
    [anon_sym_PERCENT_EQ] = ACTIONS(7858),
    [anon_sym_PLUS_EQ] = ACTIONS(7858),
    [anon_sym_DASH_EQ] = ACTIONS(7858),
    [anon_sym_LT_LT_EQ] = ACTIONS(7858),
    [anon_sym_GT_GT_EQ] = ACTIONS(7858),
    [anon_sym_AMP_EQ] = ACTIONS(7858),
    [anon_sym_CARET_EQ] = ACTIONS(7858),
    [anon_sym_PIPE_EQ] = ACTIONS(7858),
    [anon_sym_and_eq] = ACTIONS(7856),
    [anon_sym_or_eq] = ACTIONS(7856),
    [anon_sym_xor_eq] = ACTIONS(7856),
    [anon_sym_LT_EQ_GT] = ACTIONS(7858),
    [anon_sym_or] = ACTIONS(7856),
    [anon_sym_and] = ACTIONS(7856),
    [anon_sym_bitor] = ACTIONS(7856),
    [anon_sym_xor] = ACTIONS(7856),
    [anon_sym_bitand] = ACTIONS(7856),
    [anon_sym_not_eq] = ACTIONS(7856),
    [anon_sym_is] = ACTIONS(7856),
    [anon_sym_as] = ACTIONS(7856),
    [anon_sym_DASH_DASH] = ACTIONS(7858),
    [anon_sym_PLUS_PLUS] = ACTIONS(7858),
    [anon_sym_DOT] = ACTIONS(7856),
    [anon_sym_DOT_STAR] = ACTIONS(7858),
    [anon_sym_DASH_GT] = ACTIONS(7858),
    [sym_comment] = ACTIONS(3),
  },
  [3381] = {
    [sym_identifier] = ACTIONS(7860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(7862),
    [anon_sym_RPAREN] = ACTIONS(7862),
    [aux_sym_preproc_if_token2] = ACTIONS(7862),
    [aux_sym_preproc_else_token1] = ACTIONS(7862),
    [aux_sym_preproc_elif_token1] = ACTIONS(7860),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7862),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7862),
    [anon_sym_LPAREN2] = ACTIONS(7862),
    [anon_sym_DASH] = ACTIONS(7860),
    [anon_sym_PLUS] = ACTIONS(7860),
    [anon_sym_STAR] = ACTIONS(7860),
    [anon_sym_SLASH] = ACTIONS(7860),
    [anon_sym_PERCENT] = ACTIONS(7860),
    [anon_sym_PIPE_PIPE] = ACTIONS(7862),
    [anon_sym_AMP_AMP] = ACTIONS(7862),
    [anon_sym_PIPE] = ACTIONS(7860),
    [anon_sym_CARET] = ACTIONS(7860),
    [anon_sym_AMP] = ACTIONS(7860),
    [anon_sym_EQ_EQ] = ACTIONS(7862),
    [anon_sym_BANG_EQ] = ACTIONS(7862),
    [anon_sym_GT] = ACTIONS(7860),
    [anon_sym_GT_EQ] = ACTIONS(7862),
    [anon_sym_LT_EQ] = ACTIONS(7860),
    [anon_sym_LT] = ACTIONS(7860),
    [anon_sym_LT_LT] = ACTIONS(7860),
    [anon_sym_GT_GT] = ACTIONS(7860),
    [anon_sym_COLON] = ACTIONS(7862),
    [anon_sym_SEMI] = ACTIONS(7862),
    [anon_sym___attribute__] = ACTIONS(7860),
    [anon_sym___attribute] = ACTIONS(7860),
    [anon_sym_RBRACE] = ACTIONS(7862),
    [anon_sym_LBRACK] = ACTIONS(7862),
    [anon_sym_RBRACK] = ACTIONS(7862),
    [anon_sym_EQ] = ACTIONS(7860),
    [anon_sym_QMARK] = ACTIONS(7862),
    [anon_sym_STAR_EQ] = ACTIONS(7862),
    [anon_sym_SLASH_EQ] = ACTIONS(7862),
    [anon_sym_PERCENT_EQ] = ACTIONS(7862),
    [anon_sym_PLUS_EQ] = ACTIONS(7862),
    [anon_sym_DASH_EQ] = ACTIONS(7862),
    [anon_sym_LT_LT_EQ] = ACTIONS(7862),
    [anon_sym_GT_GT_EQ] = ACTIONS(7862),
    [anon_sym_AMP_EQ] = ACTIONS(7862),
    [anon_sym_CARET_EQ] = ACTIONS(7862),
    [anon_sym_PIPE_EQ] = ACTIONS(7862),
    [anon_sym_and_eq] = ACTIONS(7860),
    [anon_sym_or_eq] = ACTIONS(7860),
    [anon_sym_xor_eq] = ACTIONS(7860),
    [anon_sym_LT_EQ_GT] = ACTIONS(7862),
    [anon_sym_or] = ACTIONS(7860),
    [anon_sym_and] = ACTIONS(7860),
    [anon_sym_bitor] = ACTIONS(7860),
    [anon_sym_xor] = ACTIONS(7860),
    [anon_sym_bitand] = ACTIONS(7860),
    [anon_sym_not_eq] = ACTIONS(7860),
    [anon_sym_is] = ACTIONS(7860),
    [anon_sym_as] = ACTIONS(7860),
    [anon_sym_DASH_DASH] = ACTIONS(7862),
    [anon_sym_PLUS_PLUS] = ACTIONS(7862),
    [anon_sym_DOT] = ACTIONS(7860),
    [anon_sym_DOT_STAR] = ACTIONS(7862),
    [anon_sym_DASH_GT] = ACTIONS(7862),
    [sym_comment] = ACTIONS(3),
  },
  [3382] = {
    [sym_identifier] = ACTIONS(7798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7800),
    [anon_sym_COMMA] = ACTIONS(7800),
    [anon_sym_RPAREN] = ACTIONS(7800),
    [aux_sym_preproc_if_token2] = ACTIONS(7800),
    [aux_sym_preproc_else_token1] = ACTIONS(7800),
    [aux_sym_preproc_elif_token1] = ACTIONS(7798),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7800),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7800),
    [anon_sym_LPAREN2] = ACTIONS(7800),
    [anon_sym_DASH] = ACTIONS(7798),
    [anon_sym_PLUS] = ACTIONS(7798),
    [anon_sym_STAR] = ACTIONS(7798),
    [anon_sym_SLASH] = ACTIONS(7798),
    [anon_sym_PERCENT] = ACTIONS(7798),
    [anon_sym_PIPE_PIPE] = ACTIONS(7800),
    [anon_sym_AMP_AMP] = ACTIONS(7800),
    [anon_sym_PIPE] = ACTIONS(7798),
    [anon_sym_CARET] = ACTIONS(7798),
    [anon_sym_AMP] = ACTIONS(7798),
    [anon_sym_EQ_EQ] = ACTIONS(7800),
    [anon_sym_BANG_EQ] = ACTIONS(7800),
    [anon_sym_GT] = ACTIONS(7798),
    [anon_sym_GT_EQ] = ACTIONS(7800),
    [anon_sym_LT_EQ] = ACTIONS(7798),
    [anon_sym_LT] = ACTIONS(7798),
    [anon_sym_LT_LT] = ACTIONS(7798),
    [anon_sym_GT_GT] = ACTIONS(7798),
    [anon_sym_COLON] = ACTIONS(7800),
    [anon_sym_SEMI] = ACTIONS(7800),
    [anon_sym___attribute__] = ACTIONS(7798),
    [anon_sym___attribute] = ACTIONS(7798),
    [anon_sym_RBRACE] = ACTIONS(7800),
    [anon_sym_LBRACK] = ACTIONS(7800),
    [anon_sym_RBRACK] = ACTIONS(7800),
    [anon_sym_EQ] = ACTIONS(7798),
    [anon_sym_QMARK] = ACTIONS(7800),
    [anon_sym_STAR_EQ] = ACTIONS(7800),
    [anon_sym_SLASH_EQ] = ACTIONS(7800),
    [anon_sym_PERCENT_EQ] = ACTIONS(7800),
    [anon_sym_PLUS_EQ] = ACTIONS(7800),
    [anon_sym_DASH_EQ] = ACTIONS(7800),
    [anon_sym_LT_LT_EQ] = ACTIONS(7800),
    [anon_sym_GT_GT_EQ] = ACTIONS(7800),
    [anon_sym_AMP_EQ] = ACTIONS(7800),
    [anon_sym_CARET_EQ] = ACTIONS(7800),
    [anon_sym_PIPE_EQ] = ACTIONS(7800),
    [anon_sym_and_eq] = ACTIONS(7798),
    [anon_sym_or_eq] = ACTIONS(7798),
    [anon_sym_xor_eq] = ACTIONS(7798),
    [anon_sym_LT_EQ_GT] = ACTIONS(7800),
    [anon_sym_or] = ACTIONS(7798),
    [anon_sym_and] = ACTIONS(7798),
    [anon_sym_bitor] = ACTIONS(7798),
    [anon_sym_xor] = ACTIONS(7798),
    [anon_sym_bitand] = ACTIONS(7798),
    [anon_sym_not_eq] = ACTIONS(7798),
    [anon_sym_is] = ACTIONS(7798),
    [anon_sym_as] = ACTIONS(7798),
    [anon_sym_DASH_DASH] = ACTIONS(7800),
    [anon_sym_PLUS_PLUS] = ACTIONS(7800),
    [anon_sym_DOT] = ACTIONS(7798),
    [anon_sym_DOT_STAR] = ACTIONS(7800),
    [anon_sym_DASH_GT] = ACTIONS(7800),
    [sym_comment] = ACTIONS(3),
  },
  [3383] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3391),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4166),
    [anon_sym_COMMA] = ACTIONS(4166),
    [anon_sym_RPAREN] = ACTIONS(4166),
    [anon_sym_LPAREN2] = ACTIONS(4166),
    [anon_sym_DASH] = ACTIONS(4164),
    [anon_sym_PLUS] = ACTIONS(4164),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4164),
    [anon_sym_PERCENT] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(4166),
    [anon_sym_AMP_AMP] = ACTIONS(4166),
    [anon_sym_PIPE] = ACTIONS(4164),
    [anon_sym_CARET] = ACTIONS(4164),
    [anon_sym_AMP] = ACTIONS(4164),
    [anon_sym_EQ_EQ] = ACTIONS(4166),
    [anon_sym_BANG_EQ] = ACTIONS(4166),
    [anon_sym_GT] = ACTIONS(4164),
    [anon_sym_GT_EQ] = ACTIONS(4166),
    [anon_sym_LT_EQ] = ACTIONS(4164),
    [anon_sym_LT] = ACTIONS(4164),
    [anon_sym_LT_LT] = ACTIONS(4164),
    [anon_sym_GT_GT] = ACTIONS(4164),
    [anon_sym___attribute__] = ACTIONS(4166),
    [anon_sym___attribute] = ACTIONS(4164),
    [anon_sym_LBRACE] = ACTIONS(4166),
    [anon_sym_signed] = ACTIONS(7864),
    [anon_sym_unsigned] = ACTIONS(7864),
    [anon_sym_long] = ACTIONS(7864),
    [anon_sym_short] = ACTIONS(7864),
    [anon_sym_LBRACK] = ACTIONS(4166),
    [anon_sym_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(4166),
    [anon_sym_STAR_EQ] = ACTIONS(4166),
    [anon_sym_SLASH_EQ] = ACTIONS(4166),
    [anon_sym_PERCENT_EQ] = ACTIONS(4166),
    [anon_sym_PLUS_EQ] = ACTIONS(4166),
    [anon_sym_DASH_EQ] = ACTIONS(4166),
    [anon_sym_LT_LT_EQ] = ACTIONS(4166),
    [anon_sym_GT_GT_EQ] = ACTIONS(4166),
    [anon_sym_AMP_EQ] = ACTIONS(4166),
    [anon_sym_CARET_EQ] = ACTIONS(4166),
    [anon_sym_PIPE_EQ] = ACTIONS(4166),
    [anon_sym_and_eq] = ACTIONS(4166),
    [anon_sym_or_eq] = ACTIONS(4166),
    [anon_sym_xor_eq] = ACTIONS(4166),
    [anon_sym_LT_EQ_GT] = ACTIONS(4166),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_bitor] = ACTIONS(4166),
    [anon_sym_xor] = ACTIONS(4164),
    [anon_sym_bitand] = ACTIONS(4166),
    [anon_sym_not_eq] = ACTIONS(4166),
    [anon_sym_is] = ACTIONS(4166),
    [anon_sym_as] = ACTIONS(4166),
    [anon_sym_DASH_DASH] = ACTIONS(4166),
    [anon_sym_PLUS_PLUS] = ACTIONS(4166),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_DOT_STAR] = ACTIONS(4166),
    [anon_sym_DASH_GT] = ACTIONS(4164),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4166),
    [anon_sym_let] = ACTIONS(4166),
    [anon_sym_This] = ACTIONS(4166),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4166),
  },
  [3384] = {
    [sym_identifier] = ACTIONS(7866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7868),
    [anon_sym_COMMA] = ACTIONS(7868),
    [anon_sym_RPAREN] = ACTIONS(7868),
    [aux_sym_preproc_if_token2] = ACTIONS(7868),
    [aux_sym_preproc_else_token1] = ACTIONS(7868),
    [aux_sym_preproc_elif_token1] = ACTIONS(7866),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7868),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7868),
    [anon_sym_LPAREN2] = ACTIONS(7868),
    [anon_sym_DASH] = ACTIONS(7866),
    [anon_sym_PLUS] = ACTIONS(7866),
    [anon_sym_STAR] = ACTIONS(7866),
    [anon_sym_SLASH] = ACTIONS(7866),
    [anon_sym_PERCENT] = ACTIONS(7866),
    [anon_sym_PIPE_PIPE] = ACTIONS(7868),
    [anon_sym_AMP_AMP] = ACTIONS(7868),
    [anon_sym_PIPE] = ACTIONS(7866),
    [anon_sym_CARET] = ACTIONS(7866),
    [anon_sym_AMP] = ACTIONS(7866),
    [anon_sym_EQ_EQ] = ACTIONS(7868),
    [anon_sym_BANG_EQ] = ACTIONS(7868),
    [anon_sym_GT] = ACTIONS(7866),
    [anon_sym_GT_EQ] = ACTIONS(7868),
    [anon_sym_LT_EQ] = ACTIONS(7866),
    [anon_sym_LT] = ACTIONS(7866),
    [anon_sym_LT_LT] = ACTIONS(7866),
    [anon_sym_GT_GT] = ACTIONS(7866),
    [anon_sym_COLON] = ACTIONS(7868),
    [anon_sym_SEMI] = ACTIONS(7868),
    [anon_sym___attribute__] = ACTIONS(7866),
    [anon_sym___attribute] = ACTIONS(7866),
    [anon_sym_RBRACE] = ACTIONS(7868),
    [anon_sym_LBRACK] = ACTIONS(7868),
    [anon_sym_RBRACK] = ACTIONS(7868),
    [anon_sym_EQ] = ACTIONS(7866),
    [anon_sym_QMARK] = ACTIONS(7868),
    [anon_sym_STAR_EQ] = ACTIONS(7868),
    [anon_sym_SLASH_EQ] = ACTIONS(7868),
    [anon_sym_PERCENT_EQ] = ACTIONS(7868),
    [anon_sym_PLUS_EQ] = ACTIONS(7868),
    [anon_sym_DASH_EQ] = ACTIONS(7868),
    [anon_sym_LT_LT_EQ] = ACTIONS(7868),
    [anon_sym_GT_GT_EQ] = ACTIONS(7868),
    [anon_sym_AMP_EQ] = ACTIONS(7868),
    [anon_sym_CARET_EQ] = ACTIONS(7868),
    [anon_sym_PIPE_EQ] = ACTIONS(7868),
    [anon_sym_and_eq] = ACTIONS(7866),
    [anon_sym_or_eq] = ACTIONS(7866),
    [anon_sym_xor_eq] = ACTIONS(7866),
    [anon_sym_LT_EQ_GT] = ACTIONS(7868),
    [anon_sym_or] = ACTIONS(7866),
    [anon_sym_and] = ACTIONS(7866),
    [anon_sym_bitor] = ACTIONS(7866),
    [anon_sym_xor] = ACTIONS(7866),
    [anon_sym_bitand] = ACTIONS(7866),
    [anon_sym_not_eq] = ACTIONS(7866),
    [anon_sym_is] = ACTIONS(7866),
    [anon_sym_as] = ACTIONS(7866),
    [anon_sym_DASH_DASH] = ACTIONS(7868),
    [anon_sym_PLUS_PLUS] = ACTIONS(7868),
    [anon_sym_DOT] = ACTIONS(7866),
    [anon_sym_DOT_STAR] = ACTIONS(7868),
    [anon_sym_DASH_GT] = ACTIONS(7868),
    [sym_comment] = ACTIONS(3),
  },
  [3385] = {
    [sym_template_argument_list] = STATE(3515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2229),
    [anon_sym_COMMA] = ACTIONS(2229),
    [anon_sym_RPAREN] = ACTIONS(2229),
    [anon_sym_LPAREN2] = ACTIONS(2229),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2222),
    [anon_sym_SLASH] = ACTIONS(2222),
    [anon_sym_PERCENT] = ACTIONS(2222),
    [anon_sym_PIPE_PIPE] = ACTIONS(2229),
    [anon_sym_AMP_AMP] = ACTIONS(2229),
    [anon_sym_PIPE] = ACTIONS(2222),
    [anon_sym_CARET] = ACTIONS(2222),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_EQ_EQ] = ACTIONS(2229),
    [anon_sym_BANG_EQ] = ACTIONS(2229),
    [anon_sym_GT] = ACTIONS(2222),
    [anon_sym_GT_EQ] = ACTIONS(2229),
    [anon_sym_LT_EQ] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(7870),
    [anon_sym_LT_LT] = ACTIONS(2222),
    [anon_sym_GT_GT] = ACTIONS(2222),
    [anon_sym_COLON] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2229),
    [anon_sym___attribute] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2229),
    [anon_sym_EQ] = ACTIONS(2222),
    [anon_sym_QMARK] = ACTIONS(2229),
    [anon_sym_STAR_EQ] = ACTIONS(2229),
    [anon_sym_SLASH_EQ] = ACTIONS(2229),
    [anon_sym_PERCENT_EQ] = ACTIONS(2229),
    [anon_sym_PLUS_EQ] = ACTIONS(2229),
    [anon_sym_DASH_EQ] = ACTIONS(2229),
    [anon_sym_LT_LT_EQ] = ACTIONS(2229),
    [anon_sym_GT_GT_EQ] = ACTIONS(2229),
    [anon_sym_AMP_EQ] = ACTIONS(2229),
    [anon_sym_CARET_EQ] = ACTIONS(2229),
    [anon_sym_PIPE_EQ] = ACTIONS(2229),
    [anon_sym_and_eq] = ACTIONS(2229),
    [anon_sym_or_eq] = ACTIONS(2229),
    [anon_sym_xor_eq] = ACTIONS(2229),
    [anon_sym_LT_EQ_GT] = ACTIONS(2229),
    [anon_sym_or] = ACTIONS(2222),
    [anon_sym_and] = ACTIONS(2222),
    [anon_sym_bitor] = ACTIONS(2229),
    [anon_sym_xor] = ACTIONS(2222),
    [anon_sym_bitand] = ACTIONS(2229),
    [anon_sym_not_eq] = ACTIONS(2229),
    [anon_sym_is] = ACTIONS(2229),
    [anon_sym_as] = ACTIONS(2229),
    [anon_sym_DASH_DASH] = ACTIONS(2229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2229),
    [anon_sym_DOT] = ACTIONS(2222),
    [anon_sym_DOT_STAR] = ACTIONS(2229),
    [anon_sym_DASH_GT] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2229),
    [anon_sym_let] = ACTIONS(2229),
    [anon_sym_This] = ACTIONS(2229),
    [anon_sym_final] = ACTIONS(2229),
    [anon_sym_override] = ACTIONS(2229),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2229),
  },
  [3386] = {
    [sym_identifier] = ACTIONS(7873),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7875),
    [anon_sym_COMMA] = ACTIONS(7875),
    [anon_sym_RPAREN] = ACTIONS(7875),
    [aux_sym_preproc_if_token2] = ACTIONS(7875),
    [aux_sym_preproc_else_token1] = ACTIONS(7875),
    [aux_sym_preproc_elif_token1] = ACTIONS(7873),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7875),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7875),
    [anon_sym_LPAREN2] = ACTIONS(7875),
    [anon_sym_DASH] = ACTIONS(7873),
    [anon_sym_PLUS] = ACTIONS(7873),
    [anon_sym_STAR] = ACTIONS(7873),
    [anon_sym_SLASH] = ACTIONS(7873),
    [anon_sym_PERCENT] = ACTIONS(7873),
    [anon_sym_PIPE_PIPE] = ACTIONS(7875),
    [anon_sym_AMP_AMP] = ACTIONS(7875),
    [anon_sym_PIPE] = ACTIONS(7873),
    [anon_sym_CARET] = ACTIONS(7873),
    [anon_sym_AMP] = ACTIONS(7873),
    [anon_sym_EQ_EQ] = ACTIONS(7875),
    [anon_sym_BANG_EQ] = ACTIONS(7875),
    [anon_sym_GT] = ACTIONS(7873),
    [anon_sym_GT_EQ] = ACTIONS(7875),
    [anon_sym_LT_EQ] = ACTIONS(7873),
    [anon_sym_LT] = ACTIONS(7873),
    [anon_sym_LT_LT] = ACTIONS(7873),
    [anon_sym_GT_GT] = ACTIONS(7873),
    [anon_sym_COLON] = ACTIONS(7875),
    [anon_sym_SEMI] = ACTIONS(7875),
    [anon_sym___attribute__] = ACTIONS(7873),
    [anon_sym___attribute] = ACTIONS(7873),
    [anon_sym_RBRACE] = ACTIONS(7875),
    [anon_sym_LBRACK] = ACTIONS(7875),
    [anon_sym_RBRACK] = ACTIONS(7875),
    [anon_sym_EQ] = ACTIONS(7873),
    [anon_sym_QMARK] = ACTIONS(7875),
    [anon_sym_STAR_EQ] = ACTIONS(7875),
    [anon_sym_SLASH_EQ] = ACTIONS(7875),
    [anon_sym_PERCENT_EQ] = ACTIONS(7875),
    [anon_sym_PLUS_EQ] = ACTIONS(7875),
    [anon_sym_DASH_EQ] = ACTIONS(7875),
    [anon_sym_LT_LT_EQ] = ACTIONS(7875),
    [anon_sym_GT_GT_EQ] = ACTIONS(7875),
    [anon_sym_AMP_EQ] = ACTIONS(7875),
    [anon_sym_CARET_EQ] = ACTIONS(7875),
    [anon_sym_PIPE_EQ] = ACTIONS(7875),
    [anon_sym_and_eq] = ACTIONS(7873),
    [anon_sym_or_eq] = ACTIONS(7873),
    [anon_sym_xor_eq] = ACTIONS(7873),
    [anon_sym_LT_EQ_GT] = ACTIONS(7875),
    [anon_sym_or] = ACTIONS(7873),
    [anon_sym_and] = ACTIONS(7873),
    [anon_sym_bitor] = ACTIONS(7873),
    [anon_sym_xor] = ACTIONS(7873),
    [anon_sym_bitand] = ACTIONS(7873),
    [anon_sym_not_eq] = ACTIONS(7873),
    [anon_sym_is] = ACTIONS(7873),
    [anon_sym_as] = ACTIONS(7873),
    [anon_sym_DASH_DASH] = ACTIONS(7875),
    [anon_sym_PLUS_PLUS] = ACTIONS(7875),
    [anon_sym_DOT] = ACTIONS(7873),
    [anon_sym_DOT_STAR] = ACTIONS(7875),
    [anon_sym_DASH_GT] = ACTIONS(7875),
    [sym_comment] = ACTIONS(3),
  },
  [3387] = {
    [sym_identifier] = ACTIONS(7877),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7879),
    [anon_sym_COMMA] = ACTIONS(7879),
    [anon_sym_RPAREN] = ACTIONS(7879),
    [aux_sym_preproc_if_token2] = ACTIONS(7879),
    [aux_sym_preproc_else_token1] = ACTIONS(7879),
    [aux_sym_preproc_elif_token1] = ACTIONS(7877),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7879),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7879),
    [anon_sym_LPAREN2] = ACTIONS(7879),
    [anon_sym_DASH] = ACTIONS(7877),
    [anon_sym_PLUS] = ACTIONS(7877),
    [anon_sym_STAR] = ACTIONS(7877),
    [anon_sym_SLASH] = ACTIONS(7877),
    [anon_sym_PERCENT] = ACTIONS(7877),
    [anon_sym_PIPE_PIPE] = ACTIONS(7879),
    [anon_sym_AMP_AMP] = ACTIONS(7879),
    [anon_sym_PIPE] = ACTIONS(7877),
    [anon_sym_CARET] = ACTIONS(7877),
    [anon_sym_AMP] = ACTIONS(7877),
    [anon_sym_EQ_EQ] = ACTIONS(7879),
    [anon_sym_BANG_EQ] = ACTIONS(7879),
    [anon_sym_GT] = ACTIONS(7877),
    [anon_sym_GT_EQ] = ACTIONS(7879),
    [anon_sym_LT_EQ] = ACTIONS(7877),
    [anon_sym_LT] = ACTIONS(7877),
    [anon_sym_LT_LT] = ACTIONS(7877),
    [anon_sym_GT_GT] = ACTIONS(7877),
    [anon_sym_COLON] = ACTIONS(7879),
    [anon_sym_SEMI] = ACTIONS(7879),
    [anon_sym___attribute__] = ACTIONS(7877),
    [anon_sym___attribute] = ACTIONS(7877),
    [anon_sym_RBRACE] = ACTIONS(7879),
    [anon_sym_LBRACK] = ACTIONS(7879),
    [anon_sym_RBRACK] = ACTIONS(7879),
    [anon_sym_EQ] = ACTIONS(7877),
    [anon_sym_QMARK] = ACTIONS(7879),
    [anon_sym_STAR_EQ] = ACTIONS(7879),
    [anon_sym_SLASH_EQ] = ACTIONS(7879),
    [anon_sym_PERCENT_EQ] = ACTIONS(7879),
    [anon_sym_PLUS_EQ] = ACTIONS(7879),
    [anon_sym_DASH_EQ] = ACTIONS(7879),
    [anon_sym_LT_LT_EQ] = ACTIONS(7879),
    [anon_sym_GT_GT_EQ] = ACTIONS(7879),
    [anon_sym_AMP_EQ] = ACTIONS(7879),
    [anon_sym_CARET_EQ] = ACTIONS(7879),
    [anon_sym_PIPE_EQ] = ACTIONS(7879),
    [anon_sym_and_eq] = ACTIONS(7877),
    [anon_sym_or_eq] = ACTIONS(7877),
    [anon_sym_xor_eq] = ACTIONS(7877),
    [anon_sym_LT_EQ_GT] = ACTIONS(7879),
    [anon_sym_or] = ACTIONS(7877),
    [anon_sym_and] = ACTIONS(7877),
    [anon_sym_bitor] = ACTIONS(7877),
    [anon_sym_xor] = ACTIONS(7877),
    [anon_sym_bitand] = ACTIONS(7877),
    [anon_sym_not_eq] = ACTIONS(7877),
    [anon_sym_is] = ACTIONS(7877),
    [anon_sym_as] = ACTIONS(7877),
    [anon_sym_DASH_DASH] = ACTIONS(7879),
    [anon_sym_PLUS_PLUS] = ACTIONS(7879),
    [anon_sym_DOT] = ACTIONS(7877),
    [anon_sym_DOT_STAR] = ACTIONS(7879),
    [anon_sym_DASH_GT] = ACTIONS(7879),
    [sym_comment] = ACTIONS(3),
  },
  [3388] = {
    [sym_identifier] = ACTIONS(6170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6172),
    [anon_sym_COMMA] = ACTIONS(6172),
    [anon_sym_RPAREN] = ACTIONS(6172),
    [aux_sym_preproc_if_token2] = ACTIONS(6172),
    [aux_sym_preproc_else_token1] = ACTIONS(6172),
    [aux_sym_preproc_elif_token1] = ACTIONS(6170),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6172),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6172),
    [anon_sym_LPAREN2] = ACTIONS(6172),
    [anon_sym_DASH] = ACTIONS(6170),
    [anon_sym_PLUS] = ACTIONS(6170),
    [anon_sym_STAR] = ACTIONS(6170),
    [anon_sym_SLASH] = ACTIONS(6170),
    [anon_sym_PERCENT] = ACTIONS(6170),
    [anon_sym_PIPE_PIPE] = ACTIONS(6172),
    [anon_sym_AMP_AMP] = ACTIONS(6172),
    [anon_sym_PIPE] = ACTIONS(6170),
    [anon_sym_CARET] = ACTIONS(6170),
    [anon_sym_AMP] = ACTIONS(6170),
    [anon_sym_EQ_EQ] = ACTIONS(6172),
    [anon_sym_BANG_EQ] = ACTIONS(6172),
    [anon_sym_GT] = ACTIONS(6170),
    [anon_sym_GT_EQ] = ACTIONS(6172),
    [anon_sym_LT_EQ] = ACTIONS(6170),
    [anon_sym_LT] = ACTIONS(6170),
    [anon_sym_LT_LT] = ACTIONS(6170),
    [anon_sym_GT_GT] = ACTIONS(6170),
    [anon_sym_COLON] = ACTIONS(6172),
    [anon_sym_SEMI] = ACTIONS(6172),
    [anon_sym___attribute__] = ACTIONS(6170),
    [anon_sym___attribute] = ACTIONS(6170),
    [anon_sym_RBRACE] = ACTIONS(6172),
    [anon_sym_LBRACK] = ACTIONS(6172),
    [anon_sym_RBRACK] = ACTIONS(6172),
    [anon_sym_EQ] = ACTIONS(6170),
    [anon_sym_QMARK] = ACTIONS(6172),
    [anon_sym_STAR_EQ] = ACTIONS(6172),
    [anon_sym_SLASH_EQ] = ACTIONS(6172),
    [anon_sym_PERCENT_EQ] = ACTIONS(6172),
    [anon_sym_PLUS_EQ] = ACTIONS(6172),
    [anon_sym_DASH_EQ] = ACTIONS(6172),
    [anon_sym_LT_LT_EQ] = ACTIONS(6172),
    [anon_sym_GT_GT_EQ] = ACTIONS(6172),
    [anon_sym_AMP_EQ] = ACTIONS(6172),
    [anon_sym_CARET_EQ] = ACTIONS(6172),
    [anon_sym_PIPE_EQ] = ACTIONS(6172),
    [anon_sym_and_eq] = ACTIONS(6170),
    [anon_sym_or_eq] = ACTIONS(6170),
    [anon_sym_xor_eq] = ACTIONS(6170),
    [anon_sym_LT_EQ_GT] = ACTIONS(6172),
    [anon_sym_or] = ACTIONS(6170),
    [anon_sym_and] = ACTIONS(6170),
    [anon_sym_bitor] = ACTIONS(6170),
    [anon_sym_xor] = ACTIONS(6170),
    [anon_sym_bitand] = ACTIONS(6170),
    [anon_sym_not_eq] = ACTIONS(6170),
    [anon_sym_is] = ACTIONS(6170),
    [anon_sym_as] = ACTIONS(6170),
    [anon_sym_DASH_DASH] = ACTIONS(6172),
    [anon_sym_PLUS_PLUS] = ACTIONS(6172),
    [anon_sym_DOT] = ACTIONS(6170),
    [anon_sym_DOT_STAR] = ACTIONS(6172),
    [anon_sym_DASH_GT] = ACTIONS(6172),
    [sym_comment] = ACTIONS(3),
  },
  [3389] = {
    [sym_identifier] = ACTIONS(7881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7883),
    [anon_sym_COMMA] = ACTIONS(7883),
    [anon_sym_RPAREN] = ACTIONS(7883),
    [aux_sym_preproc_if_token2] = ACTIONS(7883),
    [aux_sym_preproc_else_token1] = ACTIONS(7883),
    [aux_sym_preproc_elif_token1] = ACTIONS(7881),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7883),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7883),
    [anon_sym_LPAREN2] = ACTIONS(7883),
    [anon_sym_DASH] = ACTIONS(7881),
    [anon_sym_PLUS] = ACTIONS(7881),
    [anon_sym_STAR] = ACTIONS(7881),
    [anon_sym_SLASH] = ACTIONS(7881),
    [anon_sym_PERCENT] = ACTIONS(7881),
    [anon_sym_PIPE_PIPE] = ACTIONS(7883),
    [anon_sym_AMP_AMP] = ACTIONS(7883),
    [anon_sym_PIPE] = ACTIONS(7881),
    [anon_sym_CARET] = ACTIONS(7881),
    [anon_sym_AMP] = ACTIONS(7881),
    [anon_sym_EQ_EQ] = ACTIONS(7883),
    [anon_sym_BANG_EQ] = ACTIONS(7883),
    [anon_sym_GT] = ACTIONS(7881),
    [anon_sym_GT_EQ] = ACTIONS(7883),
    [anon_sym_LT_EQ] = ACTIONS(7881),
    [anon_sym_LT] = ACTIONS(7881),
    [anon_sym_LT_LT] = ACTIONS(7881),
    [anon_sym_GT_GT] = ACTIONS(7881),
    [anon_sym_COLON] = ACTIONS(7883),
    [anon_sym_SEMI] = ACTIONS(7883),
    [anon_sym___attribute__] = ACTIONS(7881),
    [anon_sym___attribute] = ACTIONS(7881),
    [anon_sym_RBRACE] = ACTIONS(7883),
    [anon_sym_LBRACK] = ACTIONS(7883),
    [anon_sym_RBRACK] = ACTIONS(7883),
    [anon_sym_EQ] = ACTIONS(7881),
    [anon_sym_QMARK] = ACTIONS(7883),
    [anon_sym_STAR_EQ] = ACTIONS(7883),
    [anon_sym_SLASH_EQ] = ACTIONS(7883),
    [anon_sym_PERCENT_EQ] = ACTIONS(7883),
    [anon_sym_PLUS_EQ] = ACTIONS(7883),
    [anon_sym_DASH_EQ] = ACTIONS(7883),
    [anon_sym_LT_LT_EQ] = ACTIONS(7883),
    [anon_sym_GT_GT_EQ] = ACTIONS(7883),
    [anon_sym_AMP_EQ] = ACTIONS(7883),
    [anon_sym_CARET_EQ] = ACTIONS(7883),
    [anon_sym_PIPE_EQ] = ACTIONS(7883),
    [anon_sym_and_eq] = ACTIONS(7881),
    [anon_sym_or_eq] = ACTIONS(7881),
    [anon_sym_xor_eq] = ACTIONS(7881),
    [anon_sym_LT_EQ_GT] = ACTIONS(7883),
    [anon_sym_or] = ACTIONS(7881),
    [anon_sym_and] = ACTIONS(7881),
    [anon_sym_bitor] = ACTIONS(7881),
    [anon_sym_xor] = ACTIONS(7881),
    [anon_sym_bitand] = ACTIONS(7881),
    [anon_sym_not_eq] = ACTIONS(7881),
    [anon_sym_is] = ACTIONS(7881),
    [anon_sym_as] = ACTIONS(7881),
    [anon_sym_DASH_DASH] = ACTIONS(7883),
    [anon_sym_PLUS_PLUS] = ACTIONS(7883),
    [anon_sym_DOT] = ACTIONS(7881),
    [anon_sym_DOT_STAR] = ACTIONS(7883),
    [anon_sym_DASH_GT] = ACTIONS(7883),
    [sym_comment] = ACTIONS(3),
  },
  [3390] = {
    [sym_identifier] = ACTIONS(7885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7887),
    [anon_sym_COMMA] = ACTIONS(7887),
    [anon_sym_RPAREN] = ACTIONS(7887),
    [aux_sym_preproc_if_token2] = ACTIONS(7887),
    [aux_sym_preproc_else_token1] = ACTIONS(7887),
    [aux_sym_preproc_elif_token1] = ACTIONS(7885),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7887),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7887),
    [anon_sym_LPAREN2] = ACTIONS(7887),
    [anon_sym_DASH] = ACTIONS(7885),
    [anon_sym_PLUS] = ACTIONS(7885),
    [anon_sym_STAR] = ACTIONS(7885),
    [anon_sym_SLASH] = ACTIONS(7885),
    [anon_sym_PERCENT] = ACTIONS(7885),
    [anon_sym_PIPE_PIPE] = ACTIONS(7887),
    [anon_sym_AMP_AMP] = ACTIONS(7887),
    [anon_sym_PIPE] = ACTIONS(7885),
    [anon_sym_CARET] = ACTIONS(7885),
    [anon_sym_AMP] = ACTIONS(7885),
    [anon_sym_EQ_EQ] = ACTIONS(7887),
    [anon_sym_BANG_EQ] = ACTIONS(7887),
    [anon_sym_GT] = ACTIONS(7885),
    [anon_sym_GT_EQ] = ACTIONS(7887),
    [anon_sym_LT_EQ] = ACTIONS(7885),
    [anon_sym_LT] = ACTIONS(7885),
    [anon_sym_LT_LT] = ACTIONS(7885),
    [anon_sym_GT_GT] = ACTIONS(7885),
    [anon_sym_COLON] = ACTIONS(7887),
    [anon_sym_SEMI] = ACTIONS(7887),
    [anon_sym___attribute__] = ACTIONS(7885),
    [anon_sym___attribute] = ACTIONS(7885),
    [anon_sym_RBRACE] = ACTIONS(7887),
    [anon_sym_LBRACK] = ACTIONS(7887),
    [anon_sym_RBRACK] = ACTIONS(7887),
    [anon_sym_EQ] = ACTIONS(7885),
    [anon_sym_QMARK] = ACTIONS(7887),
    [anon_sym_STAR_EQ] = ACTIONS(7887),
    [anon_sym_SLASH_EQ] = ACTIONS(7887),
    [anon_sym_PERCENT_EQ] = ACTIONS(7887),
    [anon_sym_PLUS_EQ] = ACTIONS(7887),
    [anon_sym_DASH_EQ] = ACTIONS(7887),
    [anon_sym_LT_LT_EQ] = ACTIONS(7887),
    [anon_sym_GT_GT_EQ] = ACTIONS(7887),
    [anon_sym_AMP_EQ] = ACTIONS(7887),
    [anon_sym_CARET_EQ] = ACTIONS(7887),
    [anon_sym_PIPE_EQ] = ACTIONS(7887),
    [anon_sym_and_eq] = ACTIONS(7885),
    [anon_sym_or_eq] = ACTIONS(7885),
    [anon_sym_xor_eq] = ACTIONS(7885),
    [anon_sym_LT_EQ_GT] = ACTIONS(7887),
    [anon_sym_or] = ACTIONS(7885),
    [anon_sym_and] = ACTIONS(7885),
    [anon_sym_bitor] = ACTIONS(7885),
    [anon_sym_xor] = ACTIONS(7885),
    [anon_sym_bitand] = ACTIONS(7885),
    [anon_sym_not_eq] = ACTIONS(7885),
    [anon_sym_is] = ACTIONS(7885),
    [anon_sym_as] = ACTIONS(7885),
    [anon_sym_DASH_DASH] = ACTIONS(7887),
    [anon_sym_PLUS_PLUS] = ACTIONS(7887),
    [anon_sym_DOT] = ACTIONS(7885),
    [anon_sym_DOT_STAR] = ACTIONS(7887),
    [anon_sym_DASH_GT] = ACTIONS(7887),
    [sym_comment] = ACTIONS(3),
  },
  [3391] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4062),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_RPAREN] = ACTIONS(4062),
    [anon_sym_LPAREN2] = ACTIONS(4062),
    [anon_sym_DASH] = ACTIONS(4064),
    [anon_sym_PLUS] = ACTIONS(4064),
    [anon_sym_STAR] = ACTIONS(4064),
    [anon_sym_SLASH] = ACTIONS(4064),
    [anon_sym_PERCENT] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE] = ACTIONS(4062),
    [anon_sym_AMP_AMP] = ACTIONS(4062),
    [anon_sym_PIPE] = ACTIONS(4064),
    [anon_sym_CARET] = ACTIONS(4064),
    [anon_sym_AMP] = ACTIONS(4064),
    [anon_sym_EQ_EQ] = ACTIONS(4062),
    [anon_sym_BANG_EQ] = ACTIONS(4062),
    [anon_sym_GT] = ACTIONS(4064),
    [anon_sym_GT_EQ] = ACTIONS(4062),
    [anon_sym_LT_EQ] = ACTIONS(4064),
    [anon_sym_LT] = ACTIONS(4064),
    [anon_sym_LT_LT] = ACTIONS(4064),
    [anon_sym_GT_GT] = ACTIONS(4064),
    [anon_sym___attribute__] = ACTIONS(4062),
    [anon_sym___attribute] = ACTIONS(4064),
    [anon_sym_LBRACE] = ACTIONS(4062),
    [anon_sym_signed] = ACTIONS(7889),
    [anon_sym_unsigned] = ACTIONS(7889),
    [anon_sym_long] = ACTIONS(7889),
    [anon_sym_short] = ACTIONS(7889),
    [anon_sym_LBRACK] = ACTIONS(4062),
    [anon_sym_EQ] = ACTIONS(4064),
    [anon_sym_QMARK] = ACTIONS(4062),
    [anon_sym_STAR_EQ] = ACTIONS(4062),
    [anon_sym_SLASH_EQ] = ACTIONS(4062),
    [anon_sym_PERCENT_EQ] = ACTIONS(4062),
    [anon_sym_PLUS_EQ] = ACTIONS(4062),
    [anon_sym_DASH_EQ] = ACTIONS(4062),
    [anon_sym_LT_LT_EQ] = ACTIONS(4062),
    [anon_sym_GT_GT_EQ] = ACTIONS(4062),
    [anon_sym_AMP_EQ] = ACTIONS(4062),
    [anon_sym_CARET_EQ] = ACTIONS(4062),
    [anon_sym_PIPE_EQ] = ACTIONS(4062),
    [anon_sym_and_eq] = ACTIONS(4062),
    [anon_sym_or_eq] = ACTIONS(4062),
    [anon_sym_xor_eq] = ACTIONS(4062),
    [anon_sym_LT_EQ_GT] = ACTIONS(4062),
    [anon_sym_or] = ACTIONS(4064),
    [anon_sym_and] = ACTIONS(4064),
    [anon_sym_bitor] = ACTIONS(4062),
    [anon_sym_xor] = ACTIONS(4064),
    [anon_sym_bitand] = ACTIONS(4062),
    [anon_sym_not_eq] = ACTIONS(4062),
    [anon_sym_is] = ACTIONS(4062),
    [anon_sym_as] = ACTIONS(4062),
    [anon_sym_DASH_DASH] = ACTIONS(4062),
    [anon_sym_PLUS_PLUS] = ACTIONS(4062),
    [anon_sym_DOT] = ACTIONS(4064),
    [anon_sym_DOT_STAR] = ACTIONS(4062),
    [anon_sym_DASH_GT] = ACTIONS(4064),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4062),
    [anon_sym_let] = ACTIONS(4062),
    [anon_sym_This] = ACTIONS(4062),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4062),
  },
  [3392] = {
    [sym_template_argument_list] = STATE(3515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2408),
    [anon_sym_COMMA] = ACTIONS(2408),
    [anon_sym_RPAREN] = ACTIONS(2408),
    [anon_sym_LPAREN2] = ACTIONS(2408),
    [anon_sym_DASH] = ACTIONS(2410),
    [anon_sym_PLUS] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(2410),
    [anon_sym_SLASH] = ACTIONS(2410),
    [anon_sym_PERCENT] = ACTIONS(2410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2408),
    [anon_sym_AMP_AMP] = ACTIONS(2408),
    [anon_sym_PIPE] = ACTIONS(2410),
    [anon_sym_CARET] = ACTIONS(2410),
    [anon_sym_AMP] = ACTIONS(2410),
    [anon_sym_EQ_EQ] = ACTIONS(2408),
    [anon_sym_BANG_EQ] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2410),
    [anon_sym_GT_EQ] = ACTIONS(2408),
    [anon_sym_LT_EQ] = ACTIONS(2410),
    [anon_sym_LT] = ACTIONS(7891),
    [anon_sym_LT_LT] = ACTIONS(2410),
    [anon_sym_GT_GT] = ACTIONS(2410),
    [anon_sym_COLON] = ACTIONS(2410),
    [anon_sym___attribute__] = ACTIONS(2408),
    [anon_sym___attribute] = ACTIONS(2410),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2408),
    [anon_sym_EQ] = ACTIONS(2410),
    [anon_sym_QMARK] = ACTIONS(2408),
    [anon_sym_STAR_EQ] = ACTIONS(2408),
    [anon_sym_SLASH_EQ] = ACTIONS(2408),
    [anon_sym_PERCENT_EQ] = ACTIONS(2408),
    [anon_sym_PLUS_EQ] = ACTIONS(2408),
    [anon_sym_DASH_EQ] = ACTIONS(2408),
    [anon_sym_LT_LT_EQ] = ACTIONS(2408),
    [anon_sym_GT_GT_EQ] = ACTIONS(2408),
    [anon_sym_AMP_EQ] = ACTIONS(2408),
    [anon_sym_CARET_EQ] = ACTIONS(2408),
    [anon_sym_PIPE_EQ] = ACTIONS(2408),
    [anon_sym_and_eq] = ACTIONS(2408),
    [anon_sym_or_eq] = ACTIONS(2408),
    [anon_sym_xor_eq] = ACTIONS(2408),
    [anon_sym_LT_EQ_GT] = ACTIONS(2408),
    [anon_sym_or] = ACTIONS(2410),
    [anon_sym_and] = ACTIONS(2410),
    [anon_sym_bitor] = ACTIONS(2408),
    [anon_sym_xor] = ACTIONS(2410),
    [anon_sym_bitand] = ACTIONS(2408),
    [anon_sym_not_eq] = ACTIONS(2408),
    [anon_sym_is] = ACTIONS(2408),
    [anon_sym_as] = ACTIONS(2408),
    [anon_sym_DASH_DASH] = ACTIONS(2408),
    [anon_sym_PLUS_PLUS] = ACTIONS(2408),
    [anon_sym_DOT] = ACTIONS(2410),
    [anon_sym_DOT_STAR] = ACTIONS(2408),
    [anon_sym_DASH_GT] = ACTIONS(2410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2408),
    [anon_sym_let] = ACTIONS(2408),
    [anon_sym_This] = ACTIONS(2408),
    [anon_sym_final] = ACTIONS(2408),
    [anon_sym_override] = ACTIONS(2408),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2408),
  },
  [3393] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4071),
    [anon_sym_COMMA] = ACTIONS(4071),
    [anon_sym_RPAREN] = ACTIONS(4071),
    [anon_sym_LPAREN2] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(4073),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(4073),
    [anon_sym_SLASH] = ACTIONS(4073),
    [anon_sym_PERCENT] = ACTIONS(4073),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_CARET] = ACTIONS(4073),
    [anon_sym_AMP] = ACTIONS(4073),
    [anon_sym_EQ_EQ] = ACTIONS(4071),
    [anon_sym_BANG_EQ] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_EQ] = ACTIONS(4071),
    [anon_sym_LT_EQ] = ACTIONS(4073),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4073),
    [anon_sym___attribute__] = ACTIONS(4071),
    [anon_sym___attribute] = ACTIONS(4073),
    [anon_sym_LBRACE] = ACTIONS(4071),
    [anon_sym_signed] = ACTIONS(7889),
    [anon_sym_unsigned] = ACTIONS(7889),
    [anon_sym_long] = ACTIONS(7889),
    [anon_sym_short] = ACTIONS(7889),
    [anon_sym_LBRACK] = ACTIONS(4071),
    [anon_sym_EQ] = ACTIONS(4073),
    [anon_sym_QMARK] = ACTIONS(4071),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4071),
    [anon_sym_or_eq] = ACTIONS(4071),
    [anon_sym_xor_eq] = ACTIONS(4071),
    [anon_sym_LT_EQ_GT] = ACTIONS(4071),
    [anon_sym_or] = ACTIONS(4073),
    [anon_sym_and] = ACTIONS(4073),
    [anon_sym_bitor] = ACTIONS(4071),
    [anon_sym_xor] = ACTIONS(4073),
    [anon_sym_bitand] = ACTIONS(4071),
    [anon_sym_not_eq] = ACTIONS(4071),
    [anon_sym_is] = ACTIONS(4071),
    [anon_sym_as] = ACTIONS(4071),
    [anon_sym_DASH_DASH] = ACTIONS(4071),
    [anon_sym_PLUS_PLUS] = ACTIONS(4071),
    [anon_sym_DOT] = ACTIONS(4073),
    [anon_sym_DOT_STAR] = ACTIONS(4071),
    [anon_sym_DASH_GT] = ACTIONS(4073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4071),
    [anon_sym_let] = ACTIONS(4071),
    [anon_sym_This] = ACTIONS(4071),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4071),
  },
  [3394] = {
    [sym_identifier] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7895),
    [anon_sym_COMMA] = ACTIONS(7895),
    [anon_sym_RPAREN] = ACTIONS(7895),
    [aux_sym_preproc_if_token2] = ACTIONS(7895),
    [aux_sym_preproc_else_token1] = ACTIONS(7895),
    [aux_sym_preproc_elif_token1] = ACTIONS(7893),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7895),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7895),
    [anon_sym_LPAREN2] = ACTIONS(7895),
    [anon_sym_DASH] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_STAR] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [anon_sym_PIPE_PIPE] = ACTIONS(7895),
    [anon_sym_AMP_AMP] = ACTIONS(7895),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7895),
    [anon_sym_BANG_EQ] = ACTIONS(7895),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7895),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_COLON] = ACTIONS(7895),
    [anon_sym_SEMI] = ACTIONS(7895),
    [anon_sym___attribute__] = ACTIONS(7893),
    [anon_sym___attribute] = ACTIONS(7893),
    [anon_sym_RBRACE] = ACTIONS(7895),
    [anon_sym_LBRACK] = ACTIONS(7895),
    [anon_sym_RBRACK] = ACTIONS(7895),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_QMARK] = ACTIONS(7895),
    [anon_sym_STAR_EQ] = ACTIONS(7895),
    [anon_sym_SLASH_EQ] = ACTIONS(7895),
    [anon_sym_PERCENT_EQ] = ACTIONS(7895),
    [anon_sym_PLUS_EQ] = ACTIONS(7895),
    [anon_sym_DASH_EQ] = ACTIONS(7895),
    [anon_sym_LT_LT_EQ] = ACTIONS(7895),
    [anon_sym_GT_GT_EQ] = ACTIONS(7895),
    [anon_sym_AMP_EQ] = ACTIONS(7895),
    [anon_sym_CARET_EQ] = ACTIONS(7895),
    [anon_sym_PIPE_EQ] = ACTIONS(7895),
    [anon_sym_and_eq] = ACTIONS(7893),
    [anon_sym_or_eq] = ACTIONS(7893),
    [anon_sym_xor_eq] = ACTIONS(7893),
    [anon_sym_LT_EQ_GT] = ACTIONS(7895),
    [anon_sym_or] = ACTIONS(7893),
    [anon_sym_and] = ACTIONS(7893),
    [anon_sym_bitor] = ACTIONS(7893),
    [anon_sym_xor] = ACTIONS(7893),
    [anon_sym_bitand] = ACTIONS(7893),
    [anon_sym_not_eq] = ACTIONS(7893),
    [anon_sym_is] = ACTIONS(7893),
    [anon_sym_as] = ACTIONS(7893),
    [anon_sym_DASH_DASH] = ACTIONS(7895),
    [anon_sym_PLUS_PLUS] = ACTIONS(7895),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_DOT_STAR] = ACTIONS(7895),
    [anon_sym_DASH_GT] = ACTIONS(7895),
    [sym_comment] = ACTIONS(3),
  },
  [3395] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4080),
    [anon_sym_RPAREN] = ACTIONS(4080),
    [anon_sym_LPAREN2] = ACTIONS(4080),
    [anon_sym_DASH] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(4078),
    [anon_sym_STAR] = ACTIONS(4078),
    [anon_sym_SLASH] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [anon_sym_PIPE_PIPE] = ACTIONS(4080),
    [anon_sym_AMP_AMP] = ACTIONS(4080),
    [anon_sym_PIPE] = ACTIONS(4078),
    [anon_sym_CARET] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(4078),
    [anon_sym_EQ_EQ] = ACTIONS(4080),
    [anon_sym_BANG_EQ] = ACTIONS(4080),
    [anon_sym_GT] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4080),
    [anon_sym_LT_EQ] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_LT_LT] = ACTIONS(4078),
    [anon_sym_GT_GT] = ACTIONS(4078),
    [anon_sym___attribute__] = ACTIONS(4080),
    [anon_sym___attribute] = ACTIONS(4078),
    [anon_sym_LBRACE] = ACTIONS(4080),
    [anon_sym_signed] = ACTIONS(7889),
    [anon_sym_unsigned] = ACTIONS(7889),
    [anon_sym_long] = ACTIONS(7889),
    [anon_sym_short] = ACTIONS(7889),
    [anon_sym_LBRACK] = ACTIONS(4080),
    [anon_sym_EQ] = ACTIONS(4078),
    [anon_sym_QMARK] = ACTIONS(4080),
    [anon_sym_STAR_EQ] = ACTIONS(4080),
    [anon_sym_SLASH_EQ] = ACTIONS(4080),
    [anon_sym_PERCENT_EQ] = ACTIONS(4080),
    [anon_sym_PLUS_EQ] = ACTIONS(4080),
    [anon_sym_DASH_EQ] = ACTIONS(4080),
    [anon_sym_LT_LT_EQ] = ACTIONS(4080),
    [anon_sym_GT_GT_EQ] = ACTIONS(4080),
    [anon_sym_AMP_EQ] = ACTIONS(4080),
    [anon_sym_CARET_EQ] = ACTIONS(4080),
    [anon_sym_PIPE_EQ] = ACTIONS(4080),
    [anon_sym_and_eq] = ACTIONS(4080),
    [anon_sym_or_eq] = ACTIONS(4080),
    [anon_sym_xor_eq] = ACTIONS(4080),
    [anon_sym_LT_EQ_GT] = ACTIONS(4080),
    [anon_sym_or] = ACTIONS(4078),
    [anon_sym_and] = ACTIONS(4078),
    [anon_sym_bitor] = ACTIONS(4080),
    [anon_sym_xor] = ACTIONS(4078),
    [anon_sym_bitand] = ACTIONS(4080),
    [anon_sym_not_eq] = ACTIONS(4080),
    [anon_sym_is] = ACTIONS(4080),
    [anon_sym_as] = ACTIONS(4080),
    [anon_sym_DASH_DASH] = ACTIONS(4080),
    [anon_sym_PLUS_PLUS] = ACTIONS(4080),
    [anon_sym_DOT] = ACTIONS(4078),
    [anon_sym_DOT_STAR] = ACTIONS(4080),
    [anon_sym_DASH_GT] = ACTIONS(4078),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4080),
    [anon_sym_let] = ACTIONS(4080),
    [anon_sym_This] = ACTIONS(4080),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4080),
  },
  [3396] = {
    [sym_identifier] = ACTIONS(7897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_COMMA] = ACTIONS(7899),
    [anon_sym_RPAREN] = ACTIONS(7899),
    [aux_sym_preproc_if_token2] = ACTIONS(7899),
    [aux_sym_preproc_else_token1] = ACTIONS(7899),
    [aux_sym_preproc_elif_token1] = ACTIONS(7897),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7899),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7899),
    [anon_sym_LPAREN2] = ACTIONS(7899),
    [anon_sym_DASH] = ACTIONS(7897),
    [anon_sym_PLUS] = ACTIONS(7897),
    [anon_sym_STAR] = ACTIONS(7897),
    [anon_sym_SLASH] = ACTIONS(7897),
    [anon_sym_PERCENT] = ACTIONS(7897),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_PIPE] = ACTIONS(7897),
    [anon_sym_CARET] = ACTIONS(7897),
    [anon_sym_AMP] = ACTIONS(7897),
    [anon_sym_EQ_EQ] = ACTIONS(7899),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_GT] = ACTIONS(7897),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7897),
    [anon_sym_LT] = ACTIONS(7897),
    [anon_sym_LT_LT] = ACTIONS(7897),
    [anon_sym_GT_GT] = ACTIONS(7897),
    [anon_sym_COLON] = ACTIONS(7899),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym___attribute__] = ACTIONS(7897),
    [anon_sym___attribute] = ACTIONS(7897),
    [anon_sym_RBRACE] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_RBRACK] = ACTIONS(7899),
    [anon_sym_EQ] = ACTIONS(7897),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_and_eq] = ACTIONS(7897),
    [anon_sym_or_eq] = ACTIONS(7897),
    [anon_sym_xor_eq] = ACTIONS(7897),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7897),
    [anon_sym_and] = ACTIONS(7897),
    [anon_sym_bitor] = ACTIONS(7897),
    [anon_sym_xor] = ACTIONS(7897),
    [anon_sym_bitand] = ACTIONS(7897),
    [anon_sym_not_eq] = ACTIONS(7897),
    [anon_sym_is] = ACTIONS(7897),
    [anon_sym_as] = ACTIONS(7897),
    [anon_sym_DASH_DASH] = ACTIONS(7899),
    [anon_sym_PLUS_PLUS] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7897),
    [anon_sym_DOT_STAR] = ACTIONS(7899),
    [anon_sym_DASH_GT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(3),
  },
  [3397] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3393),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4180),
    [anon_sym_COMMA] = ACTIONS(4180),
    [anon_sym_RPAREN] = ACTIONS(4180),
    [anon_sym_LPAREN2] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4178),
    [anon_sym_PLUS] = ACTIONS(4178),
    [anon_sym_STAR] = ACTIONS(4178),
    [anon_sym_SLASH] = ACTIONS(4178),
    [anon_sym_PERCENT] = ACTIONS(4178),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_PIPE] = ACTIONS(4178),
    [anon_sym_CARET] = ACTIONS(4178),
    [anon_sym_AMP] = ACTIONS(4178),
    [anon_sym_EQ_EQ] = ACTIONS(4180),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4178),
    [anon_sym_GT_EQ] = ACTIONS(4180),
    [anon_sym_LT_EQ] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_LT_LT] = ACTIONS(4178),
    [anon_sym_GT_GT] = ACTIONS(4178),
    [anon_sym___attribute__] = ACTIONS(4180),
    [anon_sym___attribute] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_signed] = ACTIONS(7901),
    [anon_sym_unsigned] = ACTIONS(7901),
    [anon_sym_long] = ACTIONS(7901),
    [anon_sym_short] = ACTIONS(7901),
    [anon_sym_LBRACK] = ACTIONS(4180),
    [anon_sym_EQ] = ACTIONS(4178),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_STAR_EQ] = ACTIONS(4180),
    [anon_sym_SLASH_EQ] = ACTIONS(4180),
    [anon_sym_PERCENT_EQ] = ACTIONS(4180),
    [anon_sym_PLUS_EQ] = ACTIONS(4180),
    [anon_sym_DASH_EQ] = ACTIONS(4180),
    [anon_sym_LT_LT_EQ] = ACTIONS(4180),
    [anon_sym_GT_GT_EQ] = ACTIONS(4180),
    [anon_sym_AMP_EQ] = ACTIONS(4180),
    [anon_sym_CARET_EQ] = ACTIONS(4180),
    [anon_sym_PIPE_EQ] = ACTIONS(4180),
    [anon_sym_and_eq] = ACTIONS(4180),
    [anon_sym_or_eq] = ACTIONS(4180),
    [anon_sym_xor_eq] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4178),
    [anon_sym_and] = ACTIONS(4178),
    [anon_sym_bitor] = ACTIONS(4180),
    [anon_sym_xor] = ACTIONS(4178),
    [anon_sym_bitand] = ACTIONS(4180),
    [anon_sym_not_eq] = ACTIONS(4180),
    [anon_sym_is] = ACTIONS(4180),
    [anon_sym_as] = ACTIONS(4180),
    [anon_sym_DASH_DASH] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4178),
    [anon_sym_DOT_STAR] = ACTIONS(4180),
    [anon_sym_DASH_GT] = ACTIONS(4178),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4180),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_This] = ACTIONS(4180),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4180),
  },
  [3398] = {
    [sym_identifier] = ACTIONS(7903),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7905),
    [anon_sym_RPAREN] = ACTIONS(7905),
    [aux_sym_preproc_if_token2] = ACTIONS(7905),
    [aux_sym_preproc_else_token1] = ACTIONS(7905),
    [aux_sym_preproc_elif_token1] = ACTIONS(7903),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7905),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7905),
    [anon_sym_LPAREN2] = ACTIONS(7905),
    [anon_sym_DASH] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_STAR] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_PIPE] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7903),
    [anon_sym_GT_EQ] = ACTIONS(7905),
    [anon_sym_LT_EQ] = ACTIONS(7903),
    [anon_sym_LT] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_COLON] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7905),
    [anon_sym___attribute__] = ACTIONS(7903),
    [anon_sym___attribute] = ACTIONS(7903),
    [anon_sym_RBRACE] = ACTIONS(7905),
    [anon_sym_LBRACK] = ACTIONS(7905),
    [anon_sym_RBRACK] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7905),
    [anon_sym_STAR_EQ] = ACTIONS(7905),
    [anon_sym_SLASH_EQ] = ACTIONS(7905),
    [anon_sym_PERCENT_EQ] = ACTIONS(7905),
    [anon_sym_PLUS_EQ] = ACTIONS(7905),
    [anon_sym_DASH_EQ] = ACTIONS(7905),
    [anon_sym_LT_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT_GT_EQ] = ACTIONS(7905),
    [anon_sym_AMP_EQ] = ACTIONS(7905),
    [anon_sym_CARET_EQ] = ACTIONS(7905),
    [anon_sym_PIPE_EQ] = ACTIONS(7905),
    [anon_sym_and_eq] = ACTIONS(7903),
    [anon_sym_or_eq] = ACTIONS(7903),
    [anon_sym_xor_eq] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7905),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_bitor] = ACTIONS(7903),
    [anon_sym_xor] = ACTIONS(7903),
    [anon_sym_bitand] = ACTIONS(7903),
    [anon_sym_not_eq] = ACTIONS(7903),
    [anon_sym_is] = ACTIONS(7903),
    [anon_sym_as] = ACTIONS(7903),
    [anon_sym_DASH_DASH] = ACTIONS(7905),
    [anon_sym_PLUS_PLUS] = ACTIONS(7905),
    [anon_sym_DOT] = ACTIONS(7903),
    [anon_sym_DOT_STAR] = ACTIONS(7905),
    [anon_sym_DASH_GT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(3),
  },
  [3399] = {
    [sym_identifier] = ACTIONS(7907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7909),
    [anon_sym_COMMA] = ACTIONS(7909),
    [anon_sym_RPAREN] = ACTIONS(7909),
    [aux_sym_preproc_if_token2] = ACTIONS(7909),
    [aux_sym_preproc_else_token1] = ACTIONS(7909),
    [aux_sym_preproc_elif_token1] = ACTIONS(7907),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7909),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7909),
    [anon_sym_LPAREN2] = ACTIONS(7909),
    [anon_sym_DASH] = ACTIONS(7907),
    [anon_sym_PLUS] = ACTIONS(7907),
    [anon_sym_STAR] = ACTIONS(7907),
    [anon_sym_SLASH] = ACTIONS(7907),
    [anon_sym_PERCENT] = ACTIONS(7907),
    [anon_sym_PIPE_PIPE] = ACTIONS(7909),
    [anon_sym_AMP_AMP] = ACTIONS(7909),
    [anon_sym_PIPE] = ACTIONS(7907),
    [anon_sym_CARET] = ACTIONS(7907),
    [anon_sym_AMP] = ACTIONS(7907),
    [anon_sym_EQ_EQ] = ACTIONS(7909),
    [anon_sym_BANG_EQ] = ACTIONS(7909),
    [anon_sym_GT] = ACTIONS(7907),
    [anon_sym_GT_EQ] = ACTIONS(7909),
    [anon_sym_LT_EQ] = ACTIONS(7907),
    [anon_sym_LT] = ACTIONS(7907),
    [anon_sym_LT_LT] = ACTIONS(7907),
    [anon_sym_GT_GT] = ACTIONS(7907),
    [anon_sym_COLON] = ACTIONS(7909),
    [anon_sym_SEMI] = ACTIONS(7909),
    [anon_sym___attribute__] = ACTIONS(7907),
    [anon_sym___attribute] = ACTIONS(7907),
    [anon_sym_RBRACE] = ACTIONS(7909),
    [anon_sym_LBRACK] = ACTIONS(7909),
    [anon_sym_RBRACK] = ACTIONS(7909),
    [anon_sym_EQ] = ACTIONS(7907),
    [anon_sym_QMARK] = ACTIONS(7909),
    [anon_sym_STAR_EQ] = ACTIONS(7909),
    [anon_sym_SLASH_EQ] = ACTIONS(7909),
    [anon_sym_PERCENT_EQ] = ACTIONS(7909),
    [anon_sym_PLUS_EQ] = ACTIONS(7909),
    [anon_sym_DASH_EQ] = ACTIONS(7909),
    [anon_sym_LT_LT_EQ] = ACTIONS(7909),
    [anon_sym_GT_GT_EQ] = ACTIONS(7909),
    [anon_sym_AMP_EQ] = ACTIONS(7909),
    [anon_sym_CARET_EQ] = ACTIONS(7909),
    [anon_sym_PIPE_EQ] = ACTIONS(7909),
    [anon_sym_and_eq] = ACTIONS(7907),
    [anon_sym_or_eq] = ACTIONS(7907),
    [anon_sym_xor_eq] = ACTIONS(7907),
    [anon_sym_LT_EQ_GT] = ACTIONS(7909),
    [anon_sym_or] = ACTIONS(7907),
    [anon_sym_and] = ACTIONS(7907),
    [anon_sym_bitor] = ACTIONS(7907),
    [anon_sym_xor] = ACTIONS(7907),
    [anon_sym_bitand] = ACTIONS(7907),
    [anon_sym_not_eq] = ACTIONS(7907),
    [anon_sym_is] = ACTIONS(7907),
    [anon_sym_as] = ACTIONS(7907),
    [anon_sym_DASH_DASH] = ACTIONS(7909),
    [anon_sym_PLUS_PLUS] = ACTIONS(7909),
    [anon_sym_DOT] = ACTIONS(7907),
    [anon_sym_DOT_STAR] = ACTIONS(7909),
    [anon_sym_DASH_GT] = ACTIONS(7909),
    [sym_comment] = ACTIONS(3),
  },
  [3400] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7160),
    [anon_sym_COMMA] = ACTIONS(7160),
    [anon_sym_RPAREN] = ACTIONS(7160),
    [anon_sym_LPAREN2] = ACTIONS(7160),
    [anon_sym_DASH] = ACTIONS(7158),
    [anon_sym_PLUS] = ACTIONS(7158),
    [anon_sym_STAR] = ACTIONS(7158),
    [anon_sym_SLASH] = ACTIONS(7158),
    [anon_sym_PERCENT] = ACTIONS(7158),
    [anon_sym_PIPE_PIPE] = ACTIONS(7160),
    [anon_sym_AMP_AMP] = ACTIONS(7160),
    [anon_sym_PIPE] = ACTIONS(7158),
    [anon_sym_CARET] = ACTIONS(7158),
    [anon_sym_AMP] = ACTIONS(7158),
    [anon_sym_EQ_EQ] = ACTIONS(7160),
    [anon_sym_BANG_EQ] = ACTIONS(7160),
    [anon_sym_GT] = ACTIONS(7158),
    [anon_sym_GT_EQ] = ACTIONS(7160),
    [anon_sym_LT_EQ] = ACTIONS(7158),
    [anon_sym_LT] = ACTIONS(7158),
    [anon_sym_LT_LT] = ACTIONS(7158),
    [anon_sym_GT_GT] = ACTIONS(7158),
    [anon_sym_LBRACK] = ACTIONS(7160),
    [anon_sym_EQ] = ACTIONS(7158),
    [anon_sym_QMARK] = ACTIONS(7160),
    [anon_sym_STAR_EQ] = ACTIONS(7160),
    [anon_sym_SLASH_EQ] = ACTIONS(7160),
    [anon_sym_PERCENT_EQ] = ACTIONS(7160),
    [anon_sym_PLUS_EQ] = ACTIONS(7160),
    [anon_sym_DASH_EQ] = ACTIONS(7160),
    [anon_sym_LT_LT_EQ] = ACTIONS(7160),
    [anon_sym_GT_GT_EQ] = ACTIONS(7160),
    [anon_sym_AMP_EQ] = ACTIONS(7160),
    [anon_sym_CARET_EQ] = ACTIONS(7160),
    [anon_sym_PIPE_EQ] = ACTIONS(7160),
    [anon_sym_and_eq] = ACTIONS(7158),
    [anon_sym_or_eq] = ACTIONS(7158),
    [anon_sym_xor_eq] = ACTIONS(7158),
    [anon_sym_LT_EQ_GT] = ACTIONS(7160),
    [anon_sym_or] = ACTIONS(7158),
    [anon_sym_and] = ACTIONS(7158),
    [anon_sym_bitor] = ACTIONS(7158),
    [anon_sym_xor] = ACTIONS(7158),
    [anon_sym_bitand] = ACTIONS(7158),
    [anon_sym_not_eq] = ACTIONS(7158),
    [anon_sym_is] = ACTIONS(7158),
    [anon_sym_as] = ACTIONS(7158),
    [anon_sym_DASH_DASH] = ACTIONS(7160),
    [anon_sym_PLUS_PLUS] = ACTIONS(7160),
    [anon_sym_DOT] = ACTIONS(7158),
    [anon_sym_DOT_STAR] = ACTIONS(7160),
    [anon_sym_DASH_GT] = ACTIONS(7158),
    [anon_sym_L_DQUOTE] = ACTIONS(7160),
    [anon_sym_u_DQUOTE] = ACTIONS(7160),
    [anon_sym_U_DQUOTE] = ACTIONS(7160),
    [anon_sym_u8_DQUOTE] = ACTIONS(7160),
    [anon_sym_DQUOTE] = ACTIONS(7160),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7160),
    [anon_sym_LR_DQUOTE] = ACTIONS(7160),
    [anon_sym_uR_DQUOTE] = ACTIONS(7160),
    [anon_sym_UR_DQUOTE] = ACTIONS(7160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7160),
    [anon_sym_DASH_GT_STAR] = ACTIONS(7160),
    [sym_literal_suffix] = ACTIONS(7158),
  },
  [3401] = {
    [sym_identifier] = ACTIONS(7418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7416),
    [anon_sym_COMMA] = ACTIONS(7416),
    [anon_sym_RPAREN] = ACTIONS(7416),
    [aux_sym_preproc_if_token2] = ACTIONS(7416),
    [aux_sym_preproc_else_token1] = ACTIONS(7416),
    [aux_sym_preproc_elif_token1] = ACTIONS(7418),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7416),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7416),
    [anon_sym_LPAREN2] = ACTIONS(7416),
    [anon_sym_DASH] = ACTIONS(7418),
    [anon_sym_PLUS] = ACTIONS(7418),
    [anon_sym_STAR] = ACTIONS(7418),
    [anon_sym_SLASH] = ACTIONS(7418),
    [anon_sym_PERCENT] = ACTIONS(7418),
    [anon_sym_PIPE_PIPE] = ACTIONS(7416),
    [anon_sym_AMP_AMP] = ACTIONS(7416),
    [anon_sym_PIPE] = ACTIONS(7418),
    [anon_sym_CARET] = ACTIONS(7418),
    [anon_sym_AMP] = ACTIONS(7418),
    [anon_sym_EQ_EQ] = ACTIONS(7416),
    [anon_sym_BANG_EQ] = ACTIONS(7416),
    [anon_sym_GT] = ACTIONS(7418),
    [anon_sym_GT_EQ] = ACTIONS(7416),
    [anon_sym_LT_EQ] = ACTIONS(7418),
    [anon_sym_LT] = ACTIONS(7418),
    [anon_sym_LT_LT] = ACTIONS(7418),
    [anon_sym_GT_GT] = ACTIONS(7418),
    [anon_sym_COLON] = ACTIONS(7416),
    [anon_sym_SEMI] = ACTIONS(7416),
    [anon_sym___attribute__] = ACTIONS(7418),
    [anon_sym___attribute] = ACTIONS(7418),
    [anon_sym_RBRACE] = ACTIONS(7416),
    [anon_sym_LBRACK] = ACTIONS(7416),
    [anon_sym_RBRACK] = ACTIONS(7416),
    [anon_sym_EQ] = ACTIONS(7418),
    [anon_sym_QMARK] = ACTIONS(7416),
    [anon_sym_STAR_EQ] = ACTIONS(7416),
    [anon_sym_SLASH_EQ] = ACTIONS(7416),
    [anon_sym_PERCENT_EQ] = ACTIONS(7416),
    [anon_sym_PLUS_EQ] = ACTIONS(7416),
    [anon_sym_DASH_EQ] = ACTIONS(7416),
    [anon_sym_LT_LT_EQ] = ACTIONS(7416),
    [anon_sym_GT_GT_EQ] = ACTIONS(7416),
    [anon_sym_AMP_EQ] = ACTIONS(7416),
    [anon_sym_CARET_EQ] = ACTIONS(7416),
    [anon_sym_PIPE_EQ] = ACTIONS(7416),
    [anon_sym_and_eq] = ACTIONS(7418),
    [anon_sym_or_eq] = ACTIONS(7418),
    [anon_sym_xor_eq] = ACTIONS(7418),
    [anon_sym_LT_EQ_GT] = ACTIONS(7416),
    [anon_sym_or] = ACTIONS(7418),
    [anon_sym_and] = ACTIONS(7418),
    [anon_sym_bitor] = ACTIONS(7418),
    [anon_sym_xor] = ACTIONS(7418),
    [anon_sym_bitand] = ACTIONS(7418),
    [anon_sym_not_eq] = ACTIONS(7418),
    [anon_sym_is] = ACTIONS(7418),
    [anon_sym_as] = ACTIONS(7418),
    [anon_sym_DASH_DASH] = ACTIONS(7416),
    [anon_sym_PLUS_PLUS] = ACTIONS(7416),
    [anon_sym_DOT] = ACTIONS(7418),
    [anon_sym_DOT_STAR] = ACTIONS(7416),
    [anon_sym_DASH_GT] = ACTIONS(7416),
    [sym_comment] = ACTIONS(3),
  },
  [3402] = {
    [sym_identifier] = ACTIONS(2181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_RPAREN] = ACTIONS(2170),
    [aux_sym_preproc_if_token2] = ACTIONS(2170),
    [aux_sym_preproc_else_token1] = ACTIONS(2170),
    [aux_sym_preproc_elif_token1] = ACTIONS(2181),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2170),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(2181),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(2170),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym___attribute__] = ACTIONS(2181),
    [anon_sym___attribute] = ACTIONS(2181),
    [anon_sym_RBRACE] = ACTIONS(2170),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_RBRACK] = ACTIONS(2170),
    [anon_sym_EQ] = ACTIONS(2181),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2170),
    [anon_sym_SLASH_EQ] = ACTIONS(2170),
    [anon_sym_PERCENT_EQ] = ACTIONS(2170),
    [anon_sym_PLUS_EQ] = ACTIONS(2170),
    [anon_sym_DASH_EQ] = ACTIONS(2170),
    [anon_sym_LT_LT_EQ] = ACTIONS(2170),
    [anon_sym_GT_GT_EQ] = ACTIONS(2170),
    [anon_sym_AMP_EQ] = ACTIONS(2170),
    [anon_sym_CARET_EQ] = ACTIONS(2170),
    [anon_sym_PIPE_EQ] = ACTIONS(2170),
    [anon_sym_and_eq] = ACTIONS(2181),
    [anon_sym_or_eq] = ACTIONS(2181),
    [anon_sym_xor_eq] = ACTIONS(2181),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [sym_comment] = ACTIONS(3),
  },
  [3403] = {
    [sym_identifier] = ACTIONS(7911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7913),
    [anon_sym_COMMA] = ACTIONS(7913),
    [anon_sym_RPAREN] = ACTIONS(7913),
    [aux_sym_preproc_if_token2] = ACTIONS(7913),
    [aux_sym_preproc_else_token1] = ACTIONS(7913),
    [aux_sym_preproc_elif_token1] = ACTIONS(7911),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7913),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7913),
    [anon_sym_LPAREN2] = ACTIONS(7913),
    [anon_sym_DASH] = ACTIONS(7911),
    [anon_sym_PLUS] = ACTIONS(7911),
    [anon_sym_STAR] = ACTIONS(7911),
    [anon_sym_SLASH] = ACTIONS(7911),
    [anon_sym_PERCENT] = ACTIONS(7911),
    [anon_sym_PIPE_PIPE] = ACTIONS(7913),
    [anon_sym_AMP_AMP] = ACTIONS(7913),
    [anon_sym_PIPE] = ACTIONS(7911),
    [anon_sym_CARET] = ACTIONS(7911),
    [anon_sym_AMP] = ACTIONS(7911),
    [anon_sym_EQ_EQ] = ACTIONS(7913),
    [anon_sym_BANG_EQ] = ACTIONS(7913),
    [anon_sym_GT] = ACTIONS(7911),
    [anon_sym_GT_EQ] = ACTIONS(7913),
    [anon_sym_LT_EQ] = ACTIONS(7911),
    [anon_sym_LT] = ACTIONS(7911),
    [anon_sym_LT_LT] = ACTIONS(7911),
    [anon_sym_GT_GT] = ACTIONS(7911),
    [anon_sym_COLON] = ACTIONS(7913),
    [anon_sym_SEMI] = ACTIONS(7913),
    [anon_sym___attribute__] = ACTIONS(7911),
    [anon_sym___attribute] = ACTIONS(7911),
    [anon_sym_RBRACE] = ACTIONS(7913),
    [anon_sym_LBRACK] = ACTIONS(7913),
    [anon_sym_RBRACK] = ACTIONS(7913),
    [anon_sym_EQ] = ACTIONS(7911),
    [anon_sym_QMARK] = ACTIONS(7913),
    [anon_sym_STAR_EQ] = ACTIONS(7913),
    [anon_sym_SLASH_EQ] = ACTIONS(7913),
    [anon_sym_PERCENT_EQ] = ACTIONS(7913),
    [anon_sym_PLUS_EQ] = ACTIONS(7913),
    [anon_sym_DASH_EQ] = ACTIONS(7913),
    [anon_sym_LT_LT_EQ] = ACTIONS(7913),
    [anon_sym_GT_GT_EQ] = ACTIONS(7913),
    [anon_sym_AMP_EQ] = ACTIONS(7913),
    [anon_sym_CARET_EQ] = ACTIONS(7913),
    [anon_sym_PIPE_EQ] = ACTIONS(7913),
    [anon_sym_and_eq] = ACTIONS(7911),
    [anon_sym_or_eq] = ACTIONS(7911),
    [anon_sym_xor_eq] = ACTIONS(7911),
    [anon_sym_LT_EQ_GT] = ACTIONS(7913),
    [anon_sym_or] = ACTIONS(7911),
    [anon_sym_and] = ACTIONS(7911),
    [anon_sym_bitor] = ACTIONS(7911),
    [anon_sym_xor] = ACTIONS(7911),
    [anon_sym_bitand] = ACTIONS(7911),
    [anon_sym_not_eq] = ACTIONS(7911),
    [anon_sym_is] = ACTIONS(7911),
    [anon_sym_as] = ACTIONS(7911),
    [anon_sym_DASH_DASH] = ACTIONS(7913),
    [anon_sym_PLUS_PLUS] = ACTIONS(7913),
    [anon_sym_DOT] = ACTIONS(7911),
    [anon_sym_DOT_STAR] = ACTIONS(7913),
    [anon_sym_DASH_GT] = ACTIONS(7913),
    [sym_comment] = ACTIONS(3),
  },
  [3404] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7152),
    [anon_sym_COMMA] = ACTIONS(7152),
    [anon_sym_RPAREN] = ACTIONS(7152),
    [anon_sym_LPAREN2] = ACTIONS(7152),
    [anon_sym_DASH] = ACTIONS(7150),
    [anon_sym_PLUS] = ACTIONS(7150),
    [anon_sym_STAR] = ACTIONS(7150),
    [anon_sym_SLASH] = ACTIONS(7150),
    [anon_sym_PERCENT] = ACTIONS(7150),
    [anon_sym_PIPE_PIPE] = ACTIONS(7152),
    [anon_sym_AMP_AMP] = ACTIONS(7152),
    [anon_sym_PIPE] = ACTIONS(7150),
    [anon_sym_CARET] = ACTIONS(7150),
    [anon_sym_AMP] = ACTIONS(7150),
    [anon_sym_EQ_EQ] = ACTIONS(7152),
    [anon_sym_BANG_EQ] = ACTIONS(7152),
    [anon_sym_GT] = ACTIONS(7150),
    [anon_sym_GT_EQ] = ACTIONS(7152),
    [anon_sym_LT_EQ] = ACTIONS(7150),
    [anon_sym_LT] = ACTIONS(7150),
    [anon_sym_LT_LT] = ACTIONS(7150),
    [anon_sym_GT_GT] = ACTIONS(7150),
    [anon_sym_LBRACK] = ACTIONS(7152),
    [anon_sym_EQ] = ACTIONS(7150),
    [anon_sym_QMARK] = ACTIONS(7152),
    [anon_sym_STAR_EQ] = ACTIONS(7152),
    [anon_sym_SLASH_EQ] = ACTIONS(7152),
    [anon_sym_PERCENT_EQ] = ACTIONS(7152),
    [anon_sym_PLUS_EQ] = ACTIONS(7152),
    [anon_sym_DASH_EQ] = ACTIONS(7152),
    [anon_sym_LT_LT_EQ] = ACTIONS(7152),
    [anon_sym_GT_GT_EQ] = ACTIONS(7152),
    [anon_sym_AMP_EQ] = ACTIONS(7152),
    [anon_sym_CARET_EQ] = ACTIONS(7152),
    [anon_sym_PIPE_EQ] = ACTIONS(7152),
    [anon_sym_and_eq] = ACTIONS(7150),
    [anon_sym_or_eq] = ACTIONS(7150),
    [anon_sym_xor_eq] = ACTIONS(7150),
    [anon_sym_LT_EQ_GT] = ACTIONS(7152),
    [anon_sym_or] = ACTIONS(7150),
    [anon_sym_and] = ACTIONS(7150),
    [anon_sym_bitor] = ACTIONS(7150),
    [anon_sym_xor] = ACTIONS(7150),
    [anon_sym_bitand] = ACTIONS(7150),
    [anon_sym_not_eq] = ACTIONS(7150),
    [anon_sym_is] = ACTIONS(7150),
    [anon_sym_as] = ACTIONS(7150),
    [anon_sym_DASH_DASH] = ACTIONS(7152),
    [anon_sym_PLUS_PLUS] = ACTIONS(7152),
    [anon_sym_DOT] = ACTIONS(7150),
    [anon_sym_DOT_STAR] = ACTIONS(7152),
    [anon_sym_DASH_GT] = ACTIONS(7150),
    [anon_sym_L_DQUOTE] = ACTIONS(7152),
    [anon_sym_u_DQUOTE] = ACTIONS(7152),
    [anon_sym_U_DQUOTE] = ACTIONS(7152),
    [anon_sym_u8_DQUOTE] = ACTIONS(7152),
    [anon_sym_DQUOTE] = ACTIONS(7152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7152),
    [anon_sym_LR_DQUOTE] = ACTIONS(7152),
    [anon_sym_uR_DQUOTE] = ACTIONS(7152),
    [anon_sym_UR_DQUOTE] = ACTIONS(7152),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7152),
    [anon_sym_DASH_GT_STAR] = ACTIONS(7152),
    [sym_literal_suffix] = ACTIONS(7150),
  },
  [3405] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4187),
    [anon_sym_COMMA] = ACTIONS(4187),
    [anon_sym_RPAREN] = ACTIONS(4187),
    [anon_sym_LPAREN2] = ACTIONS(4187),
    [anon_sym_DASH] = ACTIONS(4185),
    [anon_sym_PLUS] = ACTIONS(4185),
    [anon_sym_STAR] = ACTIONS(4185),
    [anon_sym_SLASH] = ACTIONS(4185),
    [anon_sym_PERCENT] = ACTIONS(4185),
    [anon_sym_PIPE_PIPE] = ACTIONS(4187),
    [anon_sym_AMP_AMP] = ACTIONS(4187),
    [anon_sym_PIPE] = ACTIONS(4185),
    [anon_sym_CARET] = ACTIONS(4185),
    [anon_sym_AMP] = ACTIONS(4185),
    [anon_sym_EQ_EQ] = ACTIONS(4187),
    [anon_sym_BANG_EQ] = ACTIONS(4187),
    [anon_sym_GT] = ACTIONS(4185),
    [anon_sym_GT_EQ] = ACTIONS(4187),
    [anon_sym_LT_EQ] = ACTIONS(4185),
    [anon_sym_LT] = ACTIONS(4185),
    [anon_sym_LT_LT] = ACTIONS(4185),
    [anon_sym_GT_GT] = ACTIONS(4185),
    [anon_sym___attribute__] = ACTIONS(4187),
    [anon_sym___attribute] = ACTIONS(4185),
    [anon_sym_LBRACE] = ACTIONS(4187),
    [anon_sym_signed] = ACTIONS(7889),
    [anon_sym_unsigned] = ACTIONS(7889),
    [anon_sym_long] = ACTIONS(7889),
    [anon_sym_short] = ACTIONS(7889),
    [anon_sym_LBRACK] = ACTIONS(4187),
    [anon_sym_EQ] = ACTIONS(4185),
    [anon_sym_QMARK] = ACTIONS(4187),
    [anon_sym_STAR_EQ] = ACTIONS(4187),
    [anon_sym_SLASH_EQ] = ACTIONS(4187),
    [anon_sym_PERCENT_EQ] = ACTIONS(4187),
    [anon_sym_PLUS_EQ] = ACTIONS(4187),
    [anon_sym_DASH_EQ] = ACTIONS(4187),
    [anon_sym_LT_LT_EQ] = ACTIONS(4187),
    [anon_sym_GT_GT_EQ] = ACTIONS(4187),
    [anon_sym_AMP_EQ] = ACTIONS(4187),
    [anon_sym_CARET_EQ] = ACTIONS(4187),
    [anon_sym_PIPE_EQ] = ACTIONS(4187),
    [anon_sym_and_eq] = ACTIONS(4187),
    [anon_sym_or_eq] = ACTIONS(4187),
    [anon_sym_xor_eq] = ACTIONS(4187),
    [anon_sym_LT_EQ_GT] = ACTIONS(4187),
    [anon_sym_or] = ACTIONS(4185),
    [anon_sym_and] = ACTIONS(4185),
    [anon_sym_bitor] = ACTIONS(4187),
    [anon_sym_xor] = ACTIONS(4185),
    [anon_sym_bitand] = ACTIONS(4187),
    [anon_sym_not_eq] = ACTIONS(4187),
    [anon_sym_is] = ACTIONS(4187),
    [anon_sym_as] = ACTIONS(4187),
    [anon_sym_DASH_DASH] = ACTIONS(4187),
    [anon_sym_PLUS_PLUS] = ACTIONS(4187),
    [anon_sym_DOT] = ACTIONS(4185),
    [anon_sym_DOT_STAR] = ACTIONS(4187),
    [anon_sym_DASH_GT] = ACTIONS(4185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4187),
    [anon_sym_let] = ACTIONS(4187),
    [anon_sym_This] = ACTIONS(4187),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4187),
  },
  [3406] = {
    [sym_identifier] = ACTIONS(2404),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2402),
    [anon_sym_COMMA] = ACTIONS(2402),
    [anon_sym_RPAREN] = ACTIONS(2402),
    [aux_sym_preproc_if_token2] = ACTIONS(2402),
    [aux_sym_preproc_else_token1] = ACTIONS(2402),
    [aux_sym_preproc_elif_token1] = ACTIONS(2404),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2402),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2402),
    [anon_sym_LPAREN2] = ACTIONS(2402),
    [anon_sym_DASH] = ACTIONS(2404),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_STAR] = ACTIONS(2404),
    [anon_sym_SLASH] = ACTIONS(2404),
    [anon_sym_PERCENT] = ACTIONS(2404),
    [anon_sym_PIPE_PIPE] = ACTIONS(2402),
    [anon_sym_AMP_AMP] = ACTIONS(2402),
    [anon_sym_PIPE] = ACTIONS(2404),
    [anon_sym_CARET] = ACTIONS(2404),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_EQ_EQ] = ACTIONS(2402),
    [anon_sym_BANG_EQ] = ACTIONS(2402),
    [anon_sym_GT] = ACTIONS(2404),
    [anon_sym_GT_EQ] = ACTIONS(2402),
    [anon_sym_LT_EQ] = ACTIONS(2404),
    [anon_sym_LT] = ACTIONS(2404),
    [anon_sym_LT_LT] = ACTIONS(2404),
    [anon_sym_GT_GT] = ACTIONS(2404),
    [anon_sym_COLON] = ACTIONS(2402),
    [anon_sym_SEMI] = ACTIONS(2402),
    [anon_sym___attribute__] = ACTIONS(2404),
    [anon_sym___attribute] = ACTIONS(2404),
    [anon_sym_RBRACE] = ACTIONS(2402),
    [anon_sym_LBRACK] = ACTIONS(2402),
    [anon_sym_RBRACK] = ACTIONS(2402),
    [anon_sym_EQ] = ACTIONS(2404),
    [anon_sym_QMARK] = ACTIONS(2402),
    [anon_sym_STAR_EQ] = ACTIONS(2402),
    [anon_sym_SLASH_EQ] = ACTIONS(2402),
    [anon_sym_PERCENT_EQ] = ACTIONS(2402),
    [anon_sym_PLUS_EQ] = ACTIONS(2402),
    [anon_sym_DASH_EQ] = ACTIONS(2402),
    [anon_sym_LT_LT_EQ] = ACTIONS(2402),
    [anon_sym_GT_GT_EQ] = ACTIONS(2402),
    [anon_sym_AMP_EQ] = ACTIONS(2402),
    [anon_sym_CARET_EQ] = ACTIONS(2402),
    [anon_sym_PIPE_EQ] = ACTIONS(2402),
    [anon_sym_and_eq] = ACTIONS(2404),
    [anon_sym_or_eq] = ACTIONS(2404),
    [anon_sym_xor_eq] = ACTIONS(2404),
    [anon_sym_LT_EQ_GT] = ACTIONS(2402),
    [anon_sym_or] = ACTIONS(2404),
    [anon_sym_and] = ACTIONS(2404),
    [anon_sym_bitor] = ACTIONS(2404),
    [anon_sym_xor] = ACTIONS(2404),
    [anon_sym_bitand] = ACTIONS(2404),
    [anon_sym_not_eq] = ACTIONS(2404),
    [anon_sym_is] = ACTIONS(2404),
    [anon_sym_as] = ACTIONS(2404),
    [anon_sym_DASH_DASH] = ACTIONS(2402),
    [anon_sym_PLUS_PLUS] = ACTIONS(2402),
    [anon_sym_DOT] = ACTIONS(2404),
    [anon_sym_DOT_STAR] = ACTIONS(2402),
    [anon_sym_DASH_GT] = ACTIONS(2402),
    [sym_comment] = ACTIONS(3),
  },
  [3407] = {
    [sym_identifier] = ACTIONS(7915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7917),
    [anon_sym_COMMA] = ACTIONS(7917),
    [anon_sym_RPAREN] = ACTIONS(7917),
    [aux_sym_preproc_if_token2] = ACTIONS(7917),
    [aux_sym_preproc_else_token1] = ACTIONS(7917),
    [aux_sym_preproc_elif_token1] = ACTIONS(7915),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7917),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7917),
    [anon_sym_LPAREN2] = ACTIONS(7917),
    [anon_sym_DASH] = ACTIONS(7915),
    [anon_sym_PLUS] = ACTIONS(7915),
    [anon_sym_STAR] = ACTIONS(7915),
    [anon_sym_SLASH] = ACTIONS(7915),
    [anon_sym_PERCENT] = ACTIONS(7915),
    [anon_sym_PIPE_PIPE] = ACTIONS(7917),
    [anon_sym_AMP_AMP] = ACTIONS(7917),
    [anon_sym_PIPE] = ACTIONS(7915),
    [anon_sym_CARET] = ACTIONS(7915),
    [anon_sym_AMP] = ACTIONS(7915),
    [anon_sym_EQ_EQ] = ACTIONS(7917),
    [anon_sym_BANG_EQ] = ACTIONS(7917),
    [anon_sym_GT] = ACTIONS(7915),
    [anon_sym_GT_EQ] = ACTIONS(7917),
    [anon_sym_LT_EQ] = ACTIONS(7915),
    [anon_sym_LT] = ACTIONS(7915),
    [anon_sym_LT_LT] = ACTIONS(7915),
    [anon_sym_GT_GT] = ACTIONS(7915),
    [anon_sym_COLON] = ACTIONS(7917),
    [anon_sym_SEMI] = ACTIONS(7917),
    [anon_sym___attribute__] = ACTIONS(7915),
    [anon_sym___attribute] = ACTIONS(7915),
    [anon_sym_RBRACE] = ACTIONS(7917),
    [anon_sym_LBRACK] = ACTIONS(7917),
    [anon_sym_RBRACK] = ACTIONS(7917),
    [anon_sym_EQ] = ACTIONS(7915),
    [anon_sym_QMARK] = ACTIONS(7917),
    [anon_sym_STAR_EQ] = ACTIONS(7917),
    [anon_sym_SLASH_EQ] = ACTIONS(7917),
    [anon_sym_PERCENT_EQ] = ACTIONS(7917),
    [anon_sym_PLUS_EQ] = ACTIONS(7917),
    [anon_sym_DASH_EQ] = ACTIONS(7917),
    [anon_sym_LT_LT_EQ] = ACTIONS(7917),
    [anon_sym_GT_GT_EQ] = ACTIONS(7917),
    [anon_sym_AMP_EQ] = ACTIONS(7917),
    [anon_sym_CARET_EQ] = ACTIONS(7917),
    [anon_sym_PIPE_EQ] = ACTIONS(7917),
    [anon_sym_and_eq] = ACTIONS(7915),
    [anon_sym_or_eq] = ACTIONS(7915),
    [anon_sym_xor_eq] = ACTIONS(7915),
    [anon_sym_LT_EQ_GT] = ACTIONS(7917),
    [anon_sym_or] = ACTIONS(7915),
    [anon_sym_and] = ACTIONS(7915),
    [anon_sym_bitor] = ACTIONS(7915),
    [anon_sym_xor] = ACTIONS(7915),
    [anon_sym_bitand] = ACTIONS(7915),
    [anon_sym_not_eq] = ACTIONS(7915),
    [anon_sym_is] = ACTIONS(7915),
    [anon_sym_as] = ACTIONS(7915),
    [anon_sym_DASH_DASH] = ACTIONS(7917),
    [anon_sym_PLUS_PLUS] = ACTIONS(7917),
    [anon_sym_DOT] = ACTIONS(7915),
    [anon_sym_DOT_STAR] = ACTIONS(7917),
    [anon_sym_DASH_GT] = ACTIONS(7917),
    [sym_comment] = ACTIONS(3),
  },
  [3408] = {
    [sym_identifier] = ACTIONS(6106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4215),
    [anon_sym_COMMA] = ACTIONS(4215),
    [anon_sym_RPAREN] = ACTIONS(4215),
    [aux_sym_preproc_if_token2] = ACTIONS(4215),
    [aux_sym_preproc_else_token1] = ACTIONS(4215),
    [aux_sym_preproc_elif_token1] = ACTIONS(6106),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4215),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4215),
    [anon_sym_LPAREN2] = ACTIONS(4215),
    [anon_sym_DASH] = ACTIONS(6106),
    [anon_sym_PLUS] = ACTIONS(6106),
    [anon_sym_STAR] = ACTIONS(6106),
    [anon_sym_SLASH] = ACTIONS(6106),
    [anon_sym_PERCENT] = ACTIONS(6106),
    [anon_sym_PIPE_PIPE] = ACTIONS(4215),
    [anon_sym_AMP_AMP] = ACTIONS(4215),
    [anon_sym_PIPE] = ACTIONS(6106),
    [anon_sym_CARET] = ACTIONS(6106),
    [anon_sym_AMP] = ACTIONS(6106),
    [anon_sym_EQ_EQ] = ACTIONS(4215),
    [anon_sym_BANG_EQ] = ACTIONS(4215),
    [anon_sym_GT] = ACTIONS(6106),
    [anon_sym_GT_EQ] = ACTIONS(4215),
    [anon_sym_LT_EQ] = ACTIONS(6106),
    [anon_sym_LT] = ACTIONS(6106),
    [anon_sym_LT_LT] = ACTIONS(6106),
    [anon_sym_GT_GT] = ACTIONS(6106),
    [anon_sym_COLON] = ACTIONS(4215),
    [anon_sym_SEMI] = ACTIONS(4215),
    [anon_sym___attribute__] = ACTIONS(6106),
    [anon_sym___attribute] = ACTIONS(6106),
    [anon_sym_RBRACE] = ACTIONS(4215),
    [anon_sym_LBRACK] = ACTIONS(4215),
    [anon_sym_RBRACK] = ACTIONS(4215),
    [anon_sym_EQ] = ACTIONS(6106),
    [anon_sym_QMARK] = ACTIONS(4215),
    [anon_sym_STAR_EQ] = ACTIONS(4215),
    [anon_sym_SLASH_EQ] = ACTIONS(4215),
    [anon_sym_PERCENT_EQ] = ACTIONS(4215),
    [anon_sym_PLUS_EQ] = ACTIONS(4215),
    [anon_sym_DASH_EQ] = ACTIONS(4215),
    [anon_sym_LT_LT_EQ] = ACTIONS(4215),
    [anon_sym_GT_GT_EQ] = ACTIONS(4215),
    [anon_sym_AMP_EQ] = ACTIONS(4215),
    [anon_sym_CARET_EQ] = ACTIONS(4215),
    [anon_sym_PIPE_EQ] = ACTIONS(4215),
    [anon_sym_and_eq] = ACTIONS(6106),
    [anon_sym_or_eq] = ACTIONS(6106),
    [anon_sym_xor_eq] = ACTIONS(6106),
    [anon_sym_LT_EQ_GT] = ACTIONS(4215),
    [anon_sym_or] = ACTIONS(6106),
    [anon_sym_and] = ACTIONS(6106),
    [anon_sym_bitor] = ACTIONS(6106),
    [anon_sym_xor] = ACTIONS(6106),
    [anon_sym_bitand] = ACTIONS(6106),
    [anon_sym_not_eq] = ACTIONS(6106),
    [anon_sym_is] = ACTIONS(6106),
    [anon_sym_as] = ACTIONS(6106),
    [anon_sym_DASH_DASH] = ACTIONS(4215),
    [anon_sym_PLUS_PLUS] = ACTIONS(4215),
    [anon_sym_DOT] = ACTIONS(6106),
    [anon_sym_DOT_STAR] = ACTIONS(4215),
    [anon_sym_DASH_GT] = ACTIONS(4215),
    [sym_comment] = ACTIONS(3),
  },
  [3409] = {
    [sym_identifier] = ACTIONS(7919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7921),
    [anon_sym_COMMA] = ACTIONS(7921),
    [anon_sym_RPAREN] = ACTIONS(7921),
    [aux_sym_preproc_if_token2] = ACTIONS(7921),
    [aux_sym_preproc_else_token1] = ACTIONS(7921),
    [aux_sym_preproc_elif_token1] = ACTIONS(7919),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7921),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7921),
    [anon_sym_LPAREN2] = ACTIONS(7921),
    [anon_sym_DASH] = ACTIONS(7919),
    [anon_sym_PLUS] = ACTIONS(7919),
    [anon_sym_STAR] = ACTIONS(7919),
    [anon_sym_SLASH] = ACTIONS(7919),
    [anon_sym_PERCENT] = ACTIONS(7919),
    [anon_sym_PIPE_PIPE] = ACTIONS(7921),
    [anon_sym_AMP_AMP] = ACTIONS(7921),
    [anon_sym_PIPE] = ACTIONS(7919),
    [anon_sym_CARET] = ACTIONS(7919),
    [anon_sym_AMP] = ACTIONS(7919),
    [anon_sym_EQ_EQ] = ACTIONS(7921),
    [anon_sym_BANG_EQ] = ACTIONS(7921),
    [anon_sym_GT] = ACTIONS(7919),
    [anon_sym_GT_EQ] = ACTIONS(7921),
    [anon_sym_LT_EQ] = ACTIONS(7919),
    [anon_sym_LT] = ACTIONS(7919),
    [anon_sym_LT_LT] = ACTIONS(7919),
    [anon_sym_GT_GT] = ACTIONS(7919),
    [anon_sym_COLON] = ACTIONS(7921),
    [anon_sym_SEMI] = ACTIONS(7921),
    [anon_sym___attribute__] = ACTIONS(7919),
    [anon_sym___attribute] = ACTIONS(7919),
    [anon_sym_RBRACE] = ACTIONS(7921),
    [anon_sym_LBRACK] = ACTIONS(7921),
    [anon_sym_RBRACK] = ACTIONS(7921),
    [anon_sym_EQ] = ACTIONS(7919),
    [anon_sym_QMARK] = ACTIONS(7921),
    [anon_sym_STAR_EQ] = ACTIONS(7921),
    [anon_sym_SLASH_EQ] = ACTIONS(7921),
    [anon_sym_PERCENT_EQ] = ACTIONS(7921),
    [anon_sym_PLUS_EQ] = ACTIONS(7921),
    [anon_sym_DASH_EQ] = ACTIONS(7921),
    [anon_sym_LT_LT_EQ] = ACTIONS(7921),
    [anon_sym_GT_GT_EQ] = ACTIONS(7921),
    [anon_sym_AMP_EQ] = ACTIONS(7921),
    [anon_sym_CARET_EQ] = ACTIONS(7921),
    [anon_sym_PIPE_EQ] = ACTIONS(7921),
    [anon_sym_and_eq] = ACTIONS(7919),
    [anon_sym_or_eq] = ACTIONS(7919),
    [anon_sym_xor_eq] = ACTIONS(7919),
    [anon_sym_LT_EQ_GT] = ACTIONS(7921),
    [anon_sym_or] = ACTIONS(7919),
    [anon_sym_and] = ACTIONS(7919),
    [anon_sym_bitor] = ACTIONS(7919),
    [anon_sym_xor] = ACTIONS(7919),
    [anon_sym_bitand] = ACTIONS(7919),
    [anon_sym_not_eq] = ACTIONS(7919),
    [anon_sym_is] = ACTIONS(7919),
    [anon_sym_as] = ACTIONS(7919),
    [anon_sym_DASH_DASH] = ACTIONS(7921),
    [anon_sym_PLUS_PLUS] = ACTIONS(7921),
    [anon_sym_DOT] = ACTIONS(7919),
    [anon_sym_DOT_STAR] = ACTIONS(7921),
    [anon_sym_DASH_GT] = ACTIONS(7921),
    [sym_comment] = ACTIONS(3),
  },
  [3410] = {
    [sym_identifier] = ACTIONS(7923),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7925),
    [anon_sym_COMMA] = ACTIONS(7925),
    [anon_sym_RPAREN] = ACTIONS(7925),
    [aux_sym_preproc_if_token2] = ACTIONS(7925),
    [aux_sym_preproc_else_token1] = ACTIONS(7925),
    [aux_sym_preproc_elif_token1] = ACTIONS(7923),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7925),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7925),
    [anon_sym_LPAREN2] = ACTIONS(7925),
    [anon_sym_DASH] = ACTIONS(7923),
    [anon_sym_PLUS] = ACTIONS(7923),
    [anon_sym_STAR] = ACTIONS(7923),
    [anon_sym_SLASH] = ACTIONS(7923),
    [anon_sym_PERCENT] = ACTIONS(7923),
    [anon_sym_PIPE_PIPE] = ACTIONS(7925),
    [anon_sym_AMP_AMP] = ACTIONS(7925),
    [anon_sym_PIPE] = ACTIONS(7923),
    [anon_sym_CARET] = ACTIONS(7923),
    [anon_sym_AMP] = ACTIONS(7923),
    [anon_sym_EQ_EQ] = ACTIONS(7925),
    [anon_sym_BANG_EQ] = ACTIONS(7925),
    [anon_sym_GT] = ACTIONS(7923),
    [anon_sym_GT_EQ] = ACTIONS(7925),
    [anon_sym_LT_EQ] = ACTIONS(7923),
    [anon_sym_LT] = ACTIONS(7923),
    [anon_sym_LT_LT] = ACTIONS(7923),
    [anon_sym_GT_GT] = ACTIONS(7923),
    [anon_sym_COLON] = ACTIONS(7925),
    [anon_sym_SEMI] = ACTIONS(7925),
    [anon_sym___attribute__] = ACTIONS(7923),
    [anon_sym___attribute] = ACTIONS(7923),
    [anon_sym_RBRACE] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(7925),
    [anon_sym_RBRACK] = ACTIONS(7925),
    [anon_sym_EQ] = ACTIONS(7923),
    [anon_sym_QMARK] = ACTIONS(7925),
    [anon_sym_STAR_EQ] = ACTIONS(7925),
    [anon_sym_SLASH_EQ] = ACTIONS(7925),
    [anon_sym_PERCENT_EQ] = ACTIONS(7925),
    [anon_sym_PLUS_EQ] = ACTIONS(7925),
    [anon_sym_DASH_EQ] = ACTIONS(7925),
    [anon_sym_LT_LT_EQ] = ACTIONS(7925),
    [anon_sym_GT_GT_EQ] = ACTIONS(7925),
    [anon_sym_AMP_EQ] = ACTIONS(7925),
    [anon_sym_CARET_EQ] = ACTIONS(7925),
    [anon_sym_PIPE_EQ] = ACTIONS(7925),
    [anon_sym_and_eq] = ACTIONS(7923),
    [anon_sym_or_eq] = ACTIONS(7923),
    [anon_sym_xor_eq] = ACTIONS(7923),
    [anon_sym_LT_EQ_GT] = ACTIONS(7925),
    [anon_sym_or] = ACTIONS(7923),
    [anon_sym_and] = ACTIONS(7923),
    [anon_sym_bitor] = ACTIONS(7923),
    [anon_sym_xor] = ACTIONS(7923),
    [anon_sym_bitand] = ACTIONS(7923),
    [anon_sym_not_eq] = ACTIONS(7923),
    [anon_sym_is] = ACTIONS(7923),
    [anon_sym_as] = ACTIONS(7923),
    [anon_sym_DASH_DASH] = ACTIONS(7925),
    [anon_sym_PLUS_PLUS] = ACTIONS(7925),
    [anon_sym_DOT] = ACTIONS(7923),
    [anon_sym_DOT_STAR] = ACTIONS(7925),
    [anon_sym_DASH_GT] = ACTIONS(7925),
    [sym_comment] = ACTIONS(3),
  },
  [3411] = {
    [sym_identifier] = ACTIONS(7927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7929),
    [anon_sym_COMMA] = ACTIONS(7929),
    [anon_sym_RPAREN] = ACTIONS(7929),
    [aux_sym_preproc_if_token2] = ACTIONS(7929),
    [aux_sym_preproc_else_token1] = ACTIONS(7929),
    [aux_sym_preproc_elif_token1] = ACTIONS(7927),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7929),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7929),
    [anon_sym_LPAREN2] = ACTIONS(7929),
    [anon_sym_DASH] = ACTIONS(7927),
    [anon_sym_PLUS] = ACTIONS(7927),
    [anon_sym_STAR] = ACTIONS(7927),
    [anon_sym_SLASH] = ACTIONS(7927),
    [anon_sym_PERCENT] = ACTIONS(7927),
    [anon_sym_PIPE_PIPE] = ACTIONS(7929),
    [anon_sym_AMP_AMP] = ACTIONS(7929),
    [anon_sym_PIPE] = ACTIONS(7927),
    [anon_sym_CARET] = ACTIONS(7927),
    [anon_sym_AMP] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7929),
    [anon_sym_BANG_EQ] = ACTIONS(7929),
    [anon_sym_GT] = ACTIONS(7927),
    [anon_sym_GT_EQ] = ACTIONS(7929),
    [anon_sym_LT_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(7927),
    [anon_sym_LT_LT] = ACTIONS(7927),
    [anon_sym_GT_GT] = ACTIONS(7927),
    [anon_sym_COLON] = ACTIONS(7929),
    [anon_sym_SEMI] = ACTIONS(7929),
    [anon_sym___attribute__] = ACTIONS(7927),
    [anon_sym___attribute] = ACTIONS(7927),
    [anon_sym_RBRACE] = ACTIONS(7929),
    [anon_sym_LBRACK] = ACTIONS(7929),
    [anon_sym_RBRACK] = ACTIONS(7929),
    [anon_sym_EQ] = ACTIONS(7927),
    [anon_sym_QMARK] = ACTIONS(7929),
    [anon_sym_STAR_EQ] = ACTIONS(7929),
    [anon_sym_SLASH_EQ] = ACTIONS(7929),
    [anon_sym_PERCENT_EQ] = ACTIONS(7929),
    [anon_sym_PLUS_EQ] = ACTIONS(7929),
    [anon_sym_DASH_EQ] = ACTIONS(7929),
    [anon_sym_LT_LT_EQ] = ACTIONS(7929),
    [anon_sym_GT_GT_EQ] = ACTIONS(7929),
    [anon_sym_AMP_EQ] = ACTIONS(7929),
    [anon_sym_CARET_EQ] = ACTIONS(7929),
    [anon_sym_PIPE_EQ] = ACTIONS(7929),
    [anon_sym_and_eq] = ACTIONS(7927),
    [anon_sym_or_eq] = ACTIONS(7927),
    [anon_sym_xor_eq] = ACTIONS(7927),
    [anon_sym_LT_EQ_GT] = ACTIONS(7929),
    [anon_sym_or] = ACTIONS(7927),
    [anon_sym_and] = ACTIONS(7927),
    [anon_sym_bitor] = ACTIONS(7927),
    [anon_sym_xor] = ACTIONS(7927),
    [anon_sym_bitand] = ACTIONS(7927),
    [anon_sym_not_eq] = ACTIONS(7927),
    [anon_sym_is] = ACTIONS(7927),
    [anon_sym_as] = ACTIONS(7927),
    [anon_sym_DASH_DASH] = ACTIONS(7929),
    [anon_sym_PLUS_PLUS] = ACTIONS(7929),
    [anon_sym_DOT] = ACTIONS(7927),
    [anon_sym_DOT_STAR] = ACTIONS(7929),
    [anon_sym_DASH_GT] = ACTIONS(7929),
    [sym_comment] = ACTIONS(3),
  },
  [3412] = {
    [sym_identifier] = ACTIONS(7931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7933),
    [anon_sym_COMMA] = ACTIONS(7933),
    [anon_sym_RPAREN] = ACTIONS(7933),
    [aux_sym_preproc_if_token2] = ACTIONS(7933),
    [aux_sym_preproc_else_token1] = ACTIONS(7933),
    [aux_sym_preproc_elif_token1] = ACTIONS(7931),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7933),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7933),
    [anon_sym_LPAREN2] = ACTIONS(7933),
    [anon_sym_DASH] = ACTIONS(7931),
    [anon_sym_PLUS] = ACTIONS(7931),
    [anon_sym_STAR] = ACTIONS(7931),
    [anon_sym_SLASH] = ACTIONS(7931),
    [anon_sym_PERCENT] = ACTIONS(7931),
    [anon_sym_PIPE_PIPE] = ACTIONS(7933),
    [anon_sym_AMP_AMP] = ACTIONS(7933),
    [anon_sym_PIPE] = ACTIONS(7931),
    [anon_sym_CARET] = ACTIONS(7931),
    [anon_sym_AMP] = ACTIONS(7931),
    [anon_sym_EQ_EQ] = ACTIONS(7933),
    [anon_sym_BANG_EQ] = ACTIONS(7933),
    [anon_sym_GT] = ACTIONS(7931),
    [anon_sym_GT_EQ] = ACTIONS(7933),
    [anon_sym_LT_EQ] = ACTIONS(7931),
    [anon_sym_LT] = ACTIONS(7931),
    [anon_sym_LT_LT] = ACTIONS(7931),
    [anon_sym_GT_GT] = ACTIONS(7931),
    [anon_sym_COLON] = ACTIONS(7933),
    [anon_sym_SEMI] = ACTIONS(7933),
    [anon_sym___attribute__] = ACTIONS(7931),
    [anon_sym___attribute] = ACTIONS(7931),
    [anon_sym_RBRACE] = ACTIONS(7933),
    [anon_sym_LBRACK] = ACTIONS(7933),
    [anon_sym_RBRACK] = ACTIONS(7933),
    [anon_sym_EQ] = ACTIONS(7931),
    [anon_sym_QMARK] = ACTIONS(7933),
    [anon_sym_STAR_EQ] = ACTIONS(7933),
    [anon_sym_SLASH_EQ] = ACTIONS(7933),
    [anon_sym_PERCENT_EQ] = ACTIONS(7933),
    [anon_sym_PLUS_EQ] = ACTIONS(7933),
    [anon_sym_DASH_EQ] = ACTIONS(7933),
    [anon_sym_LT_LT_EQ] = ACTIONS(7933),
    [anon_sym_GT_GT_EQ] = ACTIONS(7933),
    [anon_sym_AMP_EQ] = ACTIONS(7933),
    [anon_sym_CARET_EQ] = ACTIONS(7933),
    [anon_sym_PIPE_EQ] = ACTIONS(7933),
    [anon_sym_and_eq] = ACTIONS(7931),
    [anon_sym_or_eq] = ACTIONS(7931),
    [anon_sym_xor_eq] = ACTIONS(7931),
    [anon_sym_LT_EQ_GT] = ACTIONS(7933),
    [anon_sym_or] = ACTIONS(7931),
    [anon_sym_and] = ACTIONS(7931),
    [anon_sym_bitor] = ACTIONS(7931),
    [anon_sym_xor] = ACTIONS(7931),
    [anon_sym_bitand] = ACTIONS(7931),
    [anon_sym_not_eq] = ACTIONS(7931),
    [anon_sym_is] = ACTIONS(7931),
    [anon_sym_as] = ACTIONS(7931),
    [anon_sym_DASH_DASH] = ACTIONS(7933),
    [anon_sym_PLUS_PLUS] = ACTIONS(7933),
    [anon_sym_DOT] = ACTIONS(7931),
    [anon_sym_DOT_STAR] = ACTIONS(7933),
    [anon_sym_DASH_GT] = ACTIONS(7933),
    [sym_comment] = ACTIONS(3),
  },
  [3413] = {
    [sym_identifier] = ACTIONS(6298),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6300),
    [anon_sym_COMMA] = ACTIONS(6300),
    [anon_sym_RPAREN] = ACTIONS(6300),
    [aux_sym_preproc_if_token2] = ACTIONS(6300),
    [aux_sym_preproc_else_token1] = ACTIONS(6300),
    [aux_sym_preproc_elif_token1] = ACTIONS(6298),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6300),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6300),
    [anon_sym_LPAREN2] = ACTIONS(6300),
    [anon_sym_DASH] = ACTIONS(6298),
    [anon_sym_PLUS] = ACTIONS(6298),
    [anon_sym_STAR] = ACTIONS(6298),
    [anon_sym_SLASH] = ACTIONS(6298),
    [anon_sym_PERCENT] = ACTIONS(6298),
    [anon_sym_PIPE_PIPE] = ACTIONS(6300),
    [anon_sym_AMP_AMP] = ACTIONS(6300),
    [anon_sym_PIPE] = ACTIONS(6298),
    [anon_sym_CARET] = ACTIONS(6298),
    [anon_sym_AMP] = ACTIONS(6298),
    [anon_sym_EQ_EQ] = ACTIONS(6300),
    [anon_sym_BANG_EQ] = ACTIONS(6300),
    [anon_sym_GT] = ACTIONS(6298),
    [anon_sym_GT_EQ] = ACTIONS(6300),
    [anon_sym_LT_EQ] = ACTIONS(6298),
    [anon_sym_LT] = ACTIONS(6298),
    [anon_sym_LT_LT] = ACTIONS(6298),
    [anon_sym_GT_GT] = ACTIONS(6298),
    [anon_sym_COLON] = ACTIONS(6300),
    [anon_sym_SEMI] = ACTIONS(6300),
    [anon_sym___attribute__] = ACTIONS(6298),
    [anon_sym___attribute] = ACTIONS(6298),
    [anon_sym_RBRACE] = ACTIONS(6300),
    [anon_sym_LBRACK] = ACTIONS(6300),
    [anon_sym_RBRACK] = ACTIONS(6300),
    [anon_sym_EQ] = ACTIONS(6298),
    [anon_sym_QMARK] = ACTIONS(6300),
    [anon_sym_STAR_EQ] = ACTIONS(6300),
    [anon_sym_SLASH_EQ] = ACTIONS(6300),
    [anon_sym_PERCENT_EQ] = ACTIONS(6300),
    [anon_sym_PLUS_EQ] = ACTIONS(6300),
    [anon_sym_DASH_EQ] = ACTIONS(6300),
    [anon_sym_LT_LT_EQ] = ACTIONS(6300),
    [anon_sym_GT_GT_EQ] = ACTIONS(6300),
    [anon_sym_AMP_EQ] = ACTIONS(6300),
    [anon_sym_CARET_EQ] = ACTIONS(6300),
    [anon_sym_PIPE_EQ] = ACTIONS(6300),
    [anon_sym_and_eq] = ACTIONS(6298),
    [anon_sym_or_eq] = ACTIONS(6298),
    [anon_sym_xor_eq] = ACTIONS(6298),
    [anon_sym_LT_EQ_GT] = ACTIONS(6300),
    [anon_sym_or] = ACTIONS(6298),
    [anon_sym_and] = ACTIONS(6298),
    [anon_sym_bitor] = ACTIONS(6298),
    [anon_sym_xor] = ACTIONS(6298),
    [anon_sym_bitand] = ACTIONS(6298),
    [anon_sym_not_eq] = ACTIONS(6298),
    [anon_sym_is] = ACTIONS(6298),
    [anon_sym_as] = ACTIONS(6298),
    [anon_sym_DASH_DASH] = ACTIONS(6300),
    [anon_sym_PLUS_PLUS] = ACTIONS(6300),
    [anon_sym_DOT] = ACTIONS(6298),
    [anon_sym_DOT_STAR] = ACTIONS(6300),
    [anon_sym_DASH_GT] = ACTIONS(6300),
    [sym_comment] = ACTIONS(3),
  },
  [3414] = {
    [sym_identifier] = ACTIONS(7935),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7937),
    [anon_sym_COMMA] = ACTIONS(7937),
    [anon_sym_RPAREN] = ACTIONS(7937),
    [aux_sym_preproc_if_token2] = ACTIONS(7937),
    [aux_sym_preproc_else_token1] = ACTIONS(7937),
    [aux_sym_preproc_elif_token1] = ACTIONS(7935),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7937),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7937),
    [anon_sym_LPAREN2] = ACTIONS(7937),
    [anon_sym_DASH] = ACTIONS(7935),
    [anon_sym_PLUS] = ACTIONS(7935),
    [anon_sym_STAR] = ACTIONS(7935),
    [anon_sym_SLASH] = ACTIONS(7935),
    [anon_sym_PERCENT] = ACTIONS(7935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7937),
    [anon_sym_AMP_AMP] = ACTIONS(7937),
    [anon_sym_PIPE] = ACTIONS(7935),
    [anon_sym_CARET] = ACTIONS(7935),
    [anon_sym_AMP] = ACTIONS(7935),
    [anon_sym_EQ_EQ] = ACTIONS(7937),
    [anon_sym_BANG_EQ] = ACTIONS(7937),
    [anon_sym_GT] = ACTIONS(7935),
    [anon_sym_GT_EQ] = ACTIONS(7937),
    [anon_sym_LT_EQ] = ACTIONS(7935),
    [anon_sym_LT] = ACTIONS(7935),
    [anon_sym_LT_LT] = ACTIONS(7935),
    [anon_sym_GT_GT] = ACTIONS(7935),
    [anon_sym_COLON] = ACTIONS(7937),
    [anon_sym_SEMI] = ACTIONS(7937),
    [anon_sym___attribute__] = ACTIONS(7935),
    [anon_sym___attribute] = ACTIONS(7935),
    [anon_sym_RBRACE] = ACTIONS(7937),
    [anon_sym_LBRACK] = ACTIONS(7937),
    [anon_sym_RBRACK] = ACTIONS(7937),
    [anon_sym_EQ] = ACTIONS(7935),
    [anon_sym_QMARK] = ACTIONS(7937),
    [anon_sym_STAR_EQ] = ACTIONS(7937),
    [anon_sym_SLASH_EQ] = ACTIONS(7937),
    [anon_sym_PERCENT_EQ] = ACTIONS(7937),
    [anon_sym_PLUS_EQ] = ACTIONS(7937),
    [anon_sym_DASH_EQ] = ACTIONS(7937),
    [anon_sym_LT_LT_EQ] = ACTIONS(7937),
    [anon_sym_GT_GT_EQ] = ACTIONS(7937),
    [anon_sym_AMP_EQ] = ACTIONS(7937),
    [anon_sym_CARET_EQ] = ACTIONS(7937),
    [anon_sym_PIPE_EQ] = ACTIONS(7937),
    [anon_sym_and_eq] = ACTIONS(7935),
    [anon_sym_or_eq] = ACTIONS(7935),
    [anon_sym_xor_eq] = ACTIONS(7935),
    [anon_sym_LT_EQ_GT] = ACTIONS(7937),
    [anon_sym_or] = ACTIONS(7935),
    [anon_sym_and] = ACTIONS(7935),
    [anon_sym_bitor] = ACTIONS(7935),
    [anon_sym_xor] = ACTIONS(7935),
    [anon_sym_bitand] = ACTIONS(7935),
    [anon_sym_not_eq] = ACTIONS(7935),
    [anon_sym_is] = ACTIONS(7935),
    [anon_sym_as] = ACTIONS(7935),
    [anon_sym_DASH_DASH] = ACTIONS(7937),
    [anon_sym_PLUS_PLUS] = ACTIONS(7937),
    [anon_sym_DOT] = ACTIONS(7935),
    [anon_sym_DOT_STAR] = ACTIONS(7937),
    [anon_sym_DASH_GT] = ACTIONS(7937),
    [sym_comment] = ACTIONS(3),
  },
  [3415] = {
    [sym_identifier] = ACTIONS(7939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7941),
    [anon_sym_COMMA] = ACTIONS(7941),
    [anon_sym_RPAREN] = ACTIONS(7941),
    [aux_sym_preproc_if_token2] = ACTIONS(7941),
    [aux_sym_preproc_else_token1] = ACTIONS(7941),
    [aux_sym_preproc_elif_token1] = ACTIONS(7939),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7941),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7941),
    [anon_sym_LPAREN2] = ACTIONS(7941),
    [anon_sym_DASH] = ACTIONS(7939),
    [anon_sym_PLUS] = ACTIONS(7939),
    [anon_sym_STAR] = ACTIONS(7939),
    [anon_sym_SLASH] = ACTIONS(7939),
    [anon_sym_PERCENT] = ACTIONS(7939),
    [anon_sym_PIPE_PIPE] = ACTIONS(7941),
    [anon_sym_AMP_AMP] = ACTIONS(7941),
    [anon_sym_PIPE] = ACTIONS(7939),
    [anon_sym_CARET] = ACTIONS(7939),
    [anon_sym_AMP] = ACTIONS(7939),
    [anon_sym_EQ_EQ] = ACTIONS(7941),
    [anon_sym_BANG_EQ] = ACTIONS(7941),
    [anon_sym_GT] = ACTIONS(7939),
    [anon_sym_GT_EQ] = ACTIONS(7941),
    [anon_sym_LT_EQ] = ACTIONS(7939),
    [anon_sym_LT] = ACTIONS(7939),
    [anon_sym_LT_LT] = ACTIONS(7939),
    [anon_sym_GT_GT] = ACTIONS(7939),
    [anon_sym_COLON] = ACTIONS(7941),
    [anon_sym_SEMI] = ACTIONS(7941),
    [anon_sym___attribute__] = ACTIONS(7939),
    [anon_sym___attribute] = ACTIONS(7939),
    [anon_sym_RBRACE] = ACTIONS(7941),
    [anon_sym_LBRACK] = ACTIONS(7941),
    [anon_sym_RBRACK] = ACTIONS(7941),
    [anon_sym_EQ] = ACTIONS(7939),
    [anon_sym_QMARK] = ACTIONS(7941),
    [anon_sym_STAR_EQ] = ACTIONS(7941),
    [anon_sym_SLASH_EQ] = ACTIONS(7941),
    [anon_sym_PERCENT_EQ] = ACTIONS(7941),
    [anon_sym_PLUS_EQ] = ACTIONS(7941),
    [anon_sym_DASH_EQ] = ACTIONS(7941),
    [anon_sym_LT_LT_EQ] = ACTIONS(7941),
    [anon_sym_GT_GT_EQ] = ACTIONS(7941),
    [anon_sym_AMP_EQ] = ACTIONS(7941),
    [anon_sym_CARET_EQ] = ACTIONS(7941),
    [anon_sym_PIPE_EQ] = ACTIONS(7941),
    [anon_sym_and_eq] = ACTIONS(7939),
    [anon_sym_or_eq] = ACTIONS(7939),
    [anon_sym_xor_eq] = ACTIONS(7939),
    [anon_sym_LT_EQ_GT] = ACTIONS(7941),
    [anon_sym_or] = ACTIONS(7939),
    [anon_sym_and] = ACTIONS(7939),
    [anon_sym_bitor] = ACTIONS(7939),
    [anon_sym_xor] = ACTIONS(7939),
    [anon_sym_bitand] = ACTIONS(7939),
    [anon_sym_not_eq] = ACTIONS(7939),
    [anon_sym_is] = ACTIONS(7939),
    [anon_sym_as] = ACTIONS(7939),
    [anon_sym_DASH_DASH] = ACTIONS(7941),
    [anon_sym_PLUS_PLUS] = ACTIONS(7941),
    [anon_sym_DOT] = ACTIONS(7939),
    [anon_sym_DOT_STAR] = ACTIONS(7941),
    [anon_sym_DASH_GT] = ACTIONS(7941),
    [sym_comment] = ACTIONS(3),
  },
  [3416] = {
    [sym_identifier] = ACTIONS(7943),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7945),
    [anon_sym_COMMA] = ACTIONS(7945),
    [anon_sym_RPAREN] = ACTIONS(7945),
    [aux_sym_preproc_if_token2] = ACTIONS(7945),
    [aux_sym_preproc_else_token1] = ACTIONS(7945),
    [aux_sym_preproc_elif_token1] = ACTIONS(7943),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7945),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7945),
    [anon_sym_LPAREN2] = ACTIONS(7945),
    [anon_sym_DASH] = ACTIONS(7943),
    [anon_sym_PLUS] = ACTIONS(7943),
    [anon_sym_STAR] = ACTIONS(7943),
    [anon_sym_SLASH] = ACTIONS(7943),
    [anon_sym_PERCENT] = ACTIONS(7943),
    [anon_sym_PIPE_PIPE] = ACTIONS(7945),
    [anon_sym_AMP_AMP] = ACTIONS(7945),
    [anon_sym_PIPE] = ACTIONS(7943),
    [anon_sym_CARET] = ACTIONS(7943),
    [anon_sym_AMP] = ACTIONS(7943),
    [anon_sym_EQ_EQ] = ACTIONS(7945),
    [anon_sym_BANG_EQ] = ACTIONS(7945),
    [anon_sym_GT] = ACTIONS(7943),
    [anon_sym_GT_EQ] = ACTIONS(7945),
    [anon_sym_LT_EQ] = ACTIONS(7943),
    [anon_sym_LT] = ACTIONS(7943),
    [anon_sym_LT_LT] = ACTIONS(7943),
    [anon_sym_GT_GT] = ACTIONS(7943),
    [anon_sym_COLON] = ACTIONS(7945),
    [anon_sym_SEMI] = ACTIONS(7945),
    [anon_sym___attribute__] = ACTIONS(7943),
    [anon_sym___attribute] = ACTIONS(7943),
    [anon_sym_RBRACE] = ACTIONS(7945),
    [anon_sym_LBRACK] = ACTIONS(7945),
    [anon_sym_RBRACK] = ACTIONS(7945),
    [anon_sym_EQ] = ACTIONS(7943),
    [anon_sym_QMARK] = ACTIONS(7945),
    [anon_sym_STAR_EQ] = ACTIONS(7945),
    [anon_sym_SLASH_EQ] = ACTIONS(7945),
    [anon_sym_PERCENT_EQ] = ACTIONS(7945),
    [anon_sym_PLUS_EQ] = ACTIONS(7945),
    [anon_sym_DASH_EQ] = ACTIONS(7945),
    [anon_sym_LT_LT_EQ] = ACTIONS(7945),
    [anon_sym_GT_GT_EQ] = ACTIONS(7945),
    [anon_sym_AMP_EQ] = ACTIONS(7945),
    [anon_sym_CARET_EQ] = ACTIONS(7945),
    [anon_sym_PIPE_EQ] = ACTIONS(7945),
    [anon_sym_and_eq] = ACTIONS(7943),
    [anon_sym_or_eq] = ACTIONS(7943),
    [anon_sym_xor_eq] = ACTIONS(7943),
    [anon_sym_LT_EQ_GT] = ACTIONS(7945),
    [anon_sym_or] = ACTIONS(7943),
    [anon_sym_and] = ACTIONS(7943),
    [anon_sym_bitor] = ACTIONS(7943),
    [anon_sym_xor] = ACTIONS(7943),
    [anon_sym_bitand] = ACTIONS(7943),
    [anon_sym_not_eq] = ACTIONS(7943),
    [anon_sym_is] = ACTIONS(7943),
    [anon_sym_as] = ACTIONS(7943),
    [anon_sym_DASH_DASH] = ACTIONS(7945),
    [anon_sym_PLUS_PLUS] = ACTIONS(7945),
    [anon_sym_DOT] = ACTIONS(7943),
    [anon_sym_DOT_STAR] = ACTIONS(7945),
    [anon_sym_DASH_GT] = ACTIONS(7945),
    [sym_comment] = ACTIONS(3),
  },
  [3417] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7313),
    [anon_sym_COMMA] = ACTIONS(7313),
    [anon_sym_RPAREN] = ACTIONS(7313),
    [anon_sym_LPAREN2] = ACTIONS(7313),
    [anon_sym_DASH] = ACTIONS(7311),
    [anon_sym_PLUS] = ACTIONS(7311),
    [anon_sym_STAR] = ACTIONS(7311),
    [anon_sym_SLASH] = ACTIONS(7311),
    [anon_sym_PERCENT] = ACTIONS(7311),
    [anon_sym_PIPE_PIPE] = ACTIONS(7313),
    [anon_sym_AMP_AMP] = ACTIONS(7313),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_CARET] = ACTIONS(7311),
    [anon_sym_AMP] = ACTIONS(7311),
    [anon_sym_EQ_EQ] = ACTIONS(7313),
    [anon_sym_BANG_EQ] = ACTIONS(7313),
    [anon_sym_GT] = ACTIONS(7311),
    [anon_sym_GT_EQ] = ACTIONS(7313),
    [anon_sym_LT_EQ] = ACTIONS(7311),
    [anon_sym_LT] = ACTIONS(7311),
    [anon_sym_LT_LT] = ACTIONS(7311),
    [anon_sym_GT_GT] = ACTIONS(7311),
    [anon_sym_LBRACK] = ACTIONS(7313),
    [anon_sym_EQ] = ACTIONS(7311),
    [anon_sym_QMARK] = ACTIONS(7313),
    [anon_sym_STAR_EQ] = ACTIONS(7313),
    [anon_sym_SLASH_EQ] = ACTIONS(7313),
    [anon_sym_PERCENT_EQ] = ACTIONS(7313),
    [anon_sym_PLUS_EQ] = ACTIONS(7313),
    [anon_sym_DASH_EQ] = ACTIONS(7313),
    [anon_sym_LT_LT_EQ] = ACTIONS(7313),
    [anon_sym_GT_GT_EQ] = ACTIONS(7313),
    [anon_sym_AMP_EQ] = ACTIONS(7313),
    [anon_sym_CARET_EQ] = ACTIONS(7313),
    [anon_sym_PIPE_EQ] = ACTIONS(7313),
    [anon_sym_and_eq] = ACTIONS(7311),
    [anon_sym_or_eq] = ACTIONS(7311),
    [anon_sym_xor_eq] = ACTIONS(7311),
    [anon_sym_LT_EQ_GT] = ACTIONS(7313),
    [anon_sym_or] = ACTIONS(7311),
    [anon_sym_and] = ACTIONS(7311),
    [anon_sym_bitor] = ACTIONS(7311),
    [anon_sym_xor] = ACTIONS(7311),
    [anon_sym_bitand] = ACTIONS(7311),
    [anon_sym_not_eq] = ACTIONS(7311),
    [anon_sym_is] = ACTIONS(7311),
    [anon_sym_as] = ACTIONS(7311),
    [anon_sym_DASH_DASH] = ACTIONS(7313),
    [anon_sym_PLUS_PLUS] = ACTIONS(7313),
    [anon_sym_DOT] = ACTIONS(7311),
    [anon_sym_DOT_STAR] = ACTIONS(7313),
    [anon_sym_DASH_GT] = ACTIONS(7311),
    [anon_sym_L_DQUOTE] = ACTIONS(7313),
    [anon_sym_u_DQUOTE] = ACTIONS(7313),
    [anon_sym_U_DQUOTE] = ACTIONS(7313),
    [anon_sym_u8_DQUOTE] = ACTIONS(7313),
    [anon_sym_DQUOTE] = ACTIONS(7313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7313),
    [anon_sym_LR_DQUOTE] = ACTIONS(7313),
    [anon_sym_uR_DQUOTE] = ACTIONS(7313),
    [anon_sym_UR_DQUOTE] = ACTIONS(7313),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7313),
    [anon_sym_DASH_GT_STAR] = ACTIONS(7313),
    [sym_literal_suffix] = ACTIONS(7311),
  },
  [3418] = {
    [sym_identifier] = ACTIONS(7947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7949),
    [anon_sym_COMMA] = ACTIONS(7949),
    [anon_sym_RPAREN] = ACTIONS(7949),
    [aux_sym_preproc_if_token2] = ACTIONS(7949),
    [aux_sym_preproc_else_token1] = ACTIONS(7949),
    [aux_sym_preproc_elif_token1] = ACTIONS(7947),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7949),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7949),
    [anon_sym_LPAREN2] = ACTIONS(7949),
    [anon_sym_DASH] = ACTIONS(7947),
    [anon_sym_PLUS] = ACTIONS(7947),
    [anon_sym_STAR] = ACTIONS(7947),
    [anon_sym_SLASH] = ACTIONS(7947),
    [anon_sym_PERCENT] = ACTIONS(7947),
    [anon_sym_PIPE_PIPE] = ACTIONS(7949),
    [anon_sym_AMP_AMP] = ACTIONS(7949),
    [anon_sym_PIPE] = ACTIONS(7947),
    [anon_sym_CARET] = ACTIONS(7947),
    [anon_sym_AMP] = ACTIONS(7947),
    [anon_sym_EQ_EQ] = ACTIONS(7949),
    [anon_sym_BANG_EQ] = ACTIONS(7949),
    [anon_sym_GT] = ACTIONS(7947),
    [anon_sym_GT_EQ] = ACTIONS(7949),
    [anon_sym_LT_EQ] = ACTIONS(7947),
    [anon_sym_LT] = ACTIONS(7947),
    [anon_sym_LT_LT] = ACTIONS(7947),
    [anon_sym_GT_GT] = ACTIONS(7947),
    [anon_sym_COLON] = ACTIONS(7949),
    [anon_sym_SEMI] = ACTIONS(7949),
    [anon_sym___attribute__] = ACTIONS(7947),
    [anon_sym___attribute] = ACTIONS(7947),
    [anon_sym_RBRACE] = ACTIONS(7949),
    [anon_sym_LBRACK] = ACTIONS(7949),
    [anon_sym_RBRACK] = ACTIONS(7949),
    [anon_sym_EQ] = ACTIONS(7947),
    [anon_sym_QMARK] = ACTIONS(7949),
    [anon_sym_STAR_EQ] = ACTIONS(7949),
    [anon_sym_SLASH_EQ] = ACTIONS(7949),
    [anon_sym_PERCENT_EQ] = ACTIONS(7949),
    [anon_sym_PLUS_EQ] = ACTIONS(7949),
    [anon_sym_DASH_EQ] = ACTIONS(7949),
    [anon_sym_LT_LT_EQ] = ACTIONS(7949),
    [anon_sym_GT_GT_EQ] = ACTIONS(7949),
    [anon_sym_AMP_EQ] = ACTIONS(7949),
    [anon_sym_CARET_EQ] = ACTIONS(7949),
    [anon_sym_PIPE_EQ] = ACTIONS(7949),
    [anon_sym_and_eq] = ACTIONS(7947),
    [anon_sym_or_eq] = ACTIONS(7947),
    [anon_sym_xor_eq] = ACTIONS(7947),
    [anon_sym_LT_EQ_GT] = ACTIONS(7949),
    [anon_sym_or] = ACTIONS(7947),
    [anon_sym_and] = ACTIONS(7947),
    [anon_sym_bitor] = ACTIONS(7947),
    [anon_sym_xor] = ACTIONS(7947),
    [anon_sym_bitand] = ACTIONS(7947),
    [anon_sym_not_eq] = ACTIONS(7947),
    [anon_sym_is] = ACTIONS(7947),
    [anon_sym_as] = ACTIONS(7947),
    [anon_sym_DASH_DASH] = ACTIONS(7949),
    [anon_sym_PLUS_PLUS] = ACTIONS(7949),
    [anon_sym_DOT] = ACTIONS(7947),
    [anon_sym_DOT_STAR] = ACTIONS(7949),
    [anon_sym_DASH_GT] = ACTIONS(7949),
    [sym_comment] = ACTIONS(3),
  },
  [3419] = {
    [sym_identifier] = ACTIONS(7951),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7953),
    [anon_sym_COMMA] = ACTIONS(7953),
    [anon_sym_RPAREN] = ACTIONS(7953),
    [aux_sym_preproc_if_token2] = ACTIONS(7953),
    [aux_sym_preproc_else_token1] = ACTIONS(7953),
    [aux_sym_preproc_elif_token1] = ACTIONS(7951),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7953),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7953),
    [anon_sym_LPAREN2] = ACTIONS(7953),
    [anon_sym_DASH] = ACTIONS(7951),
    [anon_sym_PLUS] = ACTIONS(7951),
    [anon_sym_STAR] = ACTIONS(7951),
    [anon_sym_SLASH] = ACTIONS(7951),
    [anon_sym_PERCENT] = ACTIONS(7951),
    [anon_sym_PIPE_PIPE] = ACTIONS(7953),
    [anon_sym_AMP_AMP] = ACTIONS(7953),
    [anon_sym_PIPE] = ACTIONS(7951),
    [anon_sym_CARET] = ACTIONS(7951),
    [anon_sym_AMP] = ACTIONS(7951),
    [anon_sym_EQ_EQ] = ACTIONS(7953),
    [anon_sym_BANG_EQ] = ACTIONS(7953),
    [anon_sym_GT] = ACTIONS(7951),
    [anon_sym_GT_EQ] = ACTIONS(7953),
    [anon_sym_LT_EQ] = ACTIONS(7951),
    [anon_sym_LT] = ACTIONS(7951),
    [anon_sym_LT_LT] = ACTIONS(7951),
    [anon_sym_GT_GT] = ACTIONS(7951),
    [anon_sym_COLON] = ACTIONS(7953),
    [anon_sym_SEMI] = ACTIONS(7953),
    [anon_sym___attribute__] = ACTIONS(7951),
    [anon_sym___attribute] = ACTIONS(7951),
    [anon_sym_RBRACE] = ACTIONS(7953),
    [anon_sym_LBRACK] = ACTIONS(7953),
    [anon_sym_RBRACK] = ACTIONS(7953),
    [anon_sym_EQ] = ACTIONS(7951),
    [anon_sym_QMARK] = ACTIONS(7953),
    [anon_sym_STAR_EQ] = ACTIONS(7953),
    [anon_sym_SLASH_EQ] = ACTIONS(7953),
    [anon_sym_PERCENT_EQ] = ACTIONS(7953),
    [anon_sym_PLUS_EQ] = ACTIONS(7953),
    [anon_sym_DASH_EQ] = ACTIONS(7953),
    [anon_sym_LT_LT_EQ] = ACTIONS(7953),
    [anon_sym_GT_GT_EQ] = ACTIONS(7953),
    [anon_sym_AMP_EQ] = ACTIONS(7953),
    [anon_sym_CARET_EQ] = ACTIONS(7953),
    [anon_sym_PIPE_EQ] = ACTIONS(7953),
    [anon_sym_and_eq] = ACTIONS(7951),
    [anon_sym_or_eq] = ACTIONS(7951),
    [anon_sym_xor_eq] = ACTIONS(7951),
    [anon_sym_LT_EQ_GT] = ACTIONS(7953),
    [anon_sym_or] = ACTIONS(7951),
    [anon_sym_and] = ACTIONS(7951),
    [anon_sym_bitor] = ACTIONS(7951),
    [anon_sym_xor] = ACTIONS(7951),
    [anon_sym_bitand] = ACTIONS(7951),
    [anon_sym_not_eq] = ACTIONS(7951),
    [anon_sym_is] = ACTIONS(7951),
    [anon_sym_as] = ACTIONS(7951),
    [anon_sym_DASH_DASH] = ACTIONS(7953),
    [anon_sym_PLUS_PLUS] = ACTIONS(7953),
    [anon_sym_DOT] = ACTIONS(7951),
    [anon_sym_DOT_STAR] = ACTIONS(7953),
    [anon_sym_DASH_GT] = ACTIONS(7953),
    [sym_comment] = ACTIONS(3),
  },
  [3420] = {
    [sym_identifier] = ACTIONS(7955),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7957),
    [anon_sym_COMMA] = ACTIONS(7957),
    [anon_sym_RPAREN] = ACTIONS(7957),
    [aux_sym_preproc_if_token2] = ACTIONS(7957),
    [aux_sym_preproc_else_token1] = ACTIONS(7957),
    [aux_sym_preproc_elif_token1] = ACTIONS(7955),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7957),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7957),
    [anon_sym_LPAREN2] = ACTIONS(7957),
    [anon_sym_DASH] = ACTIONS(7955),
    [anon_sym_PLUS] = ACTIONS(7955),
    [anon_sym_STAR] = ACTIONS(7955),
    [anon_sym_SLASH] = ACTIONS(7955),
    [anon_sym_PERCENT] = ACTIONS(7955),
    [anon_sym_PIPE_PIPE] = ACTIONS(7957),
    [anon_sym_AMP_AMP] = ACTIONS(7957),
    [anon_sym_PIPE] = ACTIONS(7955),
    [anon_sym_CARET] = ACTIONS(7955),
    [anon_sym_AMP] = ACTIONS(7955),
    [anon_sym_EQ_EQ] = ACTIONS(7957),
    [anon_sym_BANG_EQ] = ACTIONS(7957),
    [anon_sym_GT] = ACTIONS(7955),
    [anon_sym_GT_EQ] = ACTIONS(7957),
    [anon_sym_LT_EQ] = ACTIONS(7955),
    [anon_sym_LT] = ACTIONS(7955),
    [anon_sym_LT_LT] = ACTIONS(7955),
    [anon_sym_GT_GT] = ACTIONS(7955),
    [anon_sym_COLON] = ACTIONS(7957),
    [anon_sym_SEMI] = ACTIONS(7957),
    [anon_sym___attribute__] = ACTIONS(7955),
    [anon_sym___attribute] = ACTIONS(7955),
    [anon_sym_RBRACE] = ACTIONS(7957),
    [anon_sym_LBRACK] = ACTIONS(7957),
    [anon_sym_RBRACK] = ACTIONS(7957),
    [anon_sym_EQ] = ACTIONS(7955),
    [anon_sym_QMARK] = ACTIONS(7957),
    [anon_sym_STAR_EQ] = ACTIONS(7957),
    [anon_sym_SLASH_EQ] = ACTIONS(7957),
    [anon_sym_PERCENT_EQ] = ACTIONS(7957),
    [anon_sym_PLUS_EQ] = ACTIONS(7957),
    [anon_sym_DASH_EQ] = ACTIONS(7957),
    [anon_sym_LT_LT_EQ] = ACTIONS(7957),
    [anon_sym_GT_GT_EQ] = ACTIONS(7957),
    [anon_sym_AMP_EQ] = ACTIONS(7957),
    [anon_sym_CARET_EQ] = ACTIONS(7957),
    [anon_sym_PIPE_EQ] = ACTIONS(7957),
    [anon_sym_and_eq] = ACTIONS(7955),
    [anon_sym_or_eq] = ACTIONS(7955),
    [anon_sym_xor_eq] = ACTIONS(7955),
    [anon_sym_LT_EQ_GT] = ACTIONS(7957),
    [anon_sym_or] = ACTIONS(7955),
    [anon_sym_and] = ACTIONS(7955),
    [anon_sym_bitor] = ACTIONS(7955),
    [anon_sym_xor] = ACTIONS(7955),
    [anon_sym_bitand] = ACTIONS(7955),
    [anon_sym_not_eq] = ACTIONS(7955),
    [anon_sym_is] = ACTIONS(7955),
    [anon_sym_as] = ACTIONS(7955),
    [anon_sym_DASH_DASH] = ACTIONS(7957),
    [anon_sym_PLUS_PLUS] = ACTIONS(7957),
    [anon_sym_DOT] = ACTIONS(7955),
    [anon_sym_DOT_STAR] = ACTIONS(7957),
    [anon_sym_DASH_GT] = ACTIONS(7957),
    [sym_comment] = ACTIONS(3),
  },
  [3421] = {
    [sym_identifier] = ACTIONS(6781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6783),
    [anon_sym_COMMA] = ACTIONS(6783),
    [anon_sym_RPAREN] = ACTIONS(6783),
    [aux_sym_preproc_if_token2] = ACTIONS(6783),
    [aux_sym_preproc_else_token1] = ACTIONS(6783),
    [aux_sym_preproc_elif_token1] = ACTIONS(6781),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6783),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6783),
    [anon_sym_LPAREN2] = ACTIONS(6783),
    [anon_sym_DASH] = ACTIONS(6781),
    [anon_sym_PLUS] = ACTIONS(6781),
    [anon_sym_STAR] = ACTIONS(6781),
    [anon_sym_SLASH] = ACTIONS(6781),
    [anon_sym_PERCENT] = ACTIONS(6781),
    [anon_sym_PIPE_PIPE] = ACTIONS(7959),
    [anon_sym_AMP_AMP] = ACTIONS(7961),
    [anon_sym_PIPE] = ACTIONS(6781),
    [anon_sym_CARET] = ACTIONS(6781),
    [anon_sym_AMP] = ACTIONS(6781),
    [anon_sym_EQ_EQ] = ACTIONS(6783),
    [anon_sym_BANG_EQ] = ACTIONS(6783),
    [anon_sym_GT] = ACTIONS(6781),
    [anon_sym_GT_EQ] = ACTIONS(6783),
    [anon_sym_LT_EQ] = ACTIONS(6781),
    [anon_sym_LT] = ACTIONS(6781),
    [anon_sym_LT_LT] = ACTIONS(6781),
    [anon_sym_GT_GT] = ACTIONS(6781),
    [anon_sym_COLON] = ACTIONS(6783),
    [anon_sym_SEMI] = ACTIONS(6783),
    [anon_sym___attribute__] = ACTIONS(6781),
    [anon_sym___attribute] = ACTIONS(6781),
    [anon_sym_RBRACE] = ACTIONS(6783),
    [anon_sym_LBRACK] = ACTIONS(6783),
    [anon_sym_RBRACK] = ACTIONS(6783),
    [anon_sym_EQ] = ACTIONS(6781),
    [anon_sym_QMARK] = ACTIONS(6783),
    [anon_sym_STAR_EQ] = ACTIONS(6783),
    [anon_sym_SLASH_EQ] = ACTIONS(6783),
    [anon_sym_PERCENT_EQ] = ACTIONS(6783),
    [anon_sym_PLUS_EQ] = ACTIONS(6783),
    [anon_sym_DASH_EQ] = ACTIONS(6783),
    [anon_sym_LT_LT_EQ] = ACTIONS(6783),
    [anon_sym_GT_GT_EQ] = ACTIONS(6783),
    [anon_sym_AMP_EQ] = ACTIONS(6783),
    [anon_sym_CARET_EQ] = ACTIONS(6783),
    [anon_sym_PIPE_EQ] = ACTIONS(6783),
    [anon_sym_and_eq] = ACTIONS(6781),
    [anon_sym_or_eq] = ACTIONS(6781),
    [anon_sym_xor_eq] = ACTIONS(6781),
    [anon_sym_LT_EQ_GT] = ACTIONS(6783),
    [anon_sym_or] = ACTIONS(7963),
    [anon_sym_and] = ACTIONS(7965),
    [anon_sym_bitor] = ACTIONS(6781),
    [anon_sym_xor] = ACTIONS(6781),
    [anon_sym_bitand] = ACTIONS(6781),
    [anon_sym_not_eq] = ACTIONS(6781),
    [anon_sym_is] = ACTIONS(6781),
    [anon_sym_as] = ACTIONS(6781),
    [anon_sym_DASH_DASH] = ACTIONS(6783),
    [anon_sym_PLUS_PLUS] = ACTIONS(6783),
    [anon_sym_DOT] = ACTIONS(6781),
    [anon_sym_DOT_STAR] = ACTIONS(6783),
    [anon_sym_DASH_GT] = ACTIONS(6783),
    [sym_comment] = ACTIONS(3),
  },
  [3422] = {
    [sym_template_argument_list] = STATE(3515),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3439),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2176),
    [anon_sym_COMMA] = ACTIONS(2176),
    [anon_sym_RPAREN] = ACTIONS(2176),
    [anon_sym_LPAREN2] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2168),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_STAR] = ACTIONS(2168),
    [anon_sym_SLASH] = ACTIONS(2168),
    [anon_sym_PERCENT] = ACTIONS(2168),
    [anon_sym_PIPE_PIPE] = ACTIONS(2176),
    [anon_sym_AMP_AMP] = ACTIONS(2176),
    [anon_sym_PIPE] = ACTIONS(2168),
    [anon_sym_CARET] = ACTIONS(2168),
    [anon_sym_AMP] = ACTIONS(2168),
    [anon_sym_EQ_EQ] = ACTIONS(2176),
    [anon_sym_BANG_EQ] = ACTIONS(2176),
    [anon_sym_GT] = ACTIONS(2168),
    [anon_sym_GT_EQ] = ACTIONS(2176),
    [anon_sym_LT_EQ] = ACTIONS(2168),
    [anon_sym_LT] = ACTIONS(7891),
    [anon_sym_LT_LT] = ACTIONS(2168),
    [anon_sym_GT_GT] = ACTIONS(2168),
    [anon_sym_COLON_COLON] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2176),
    [anon_sym_signed] = ACTIONS(7711),
    [anon_sym_unsigned] = ACTIONS(7711),
    [anon_sym_long] = ACTIONS(7711),
    [anon_sym_short] = ACTIONS(7711),
    [anon_sym_LBRACK] = ACTIONS(2176),
    [anon_sym_EQ] = ACTIONS(2168),
    [anon_sym_QMARK] = ACTIONS(2176),
    [anon_sym_STAR_EQ] = ACTIONS(2176),
    [anon_sym_SLASH_EQ] = ACTIONS(2176),
    [anon_sym_PERCENT_EQ] = ACTIONS(2176),
    [anon_sym_PLUS_EQ] = ACTIONS(2176),
    [anon_sym_DASH_EQ] = ACTIONS(2176),
    [anon_sym_LT_LT_EQ] = ACTIONS(2176),
    [anon_sym_GT_GT_EQ] = ACTIONS(2176),
    [anon_sym_AMP_EQ] = ACTIONS(2176),
    [anon_sym_CARET_EQ] = ACTIONS(2176),
    [anon_sym_PIPE_EQ] = ACTIONS(2176),
    [anon_sym_and_eq] = ACTIONS(2176),
    [anon_sym_or_eq] = ACTIONS(2176),
    [anon_sym_xor_eq] = ACTIONS(2176),
    [anon_sym_LT_EQ_GT] = ACTIONS(2176),
    [anon_sym_or] = ACTIONS(2168),
    [anon_sym_and] = ACTIONS(2168),
    [anon_sym_bitor] = ACTIONS(2176),
    [anon_sym_xor] = ACTIONS(2168),
    [anon_sym_bitand] = ACTIONS(2176),
    [anon_sym_not_eq] = ACTIONS(2176),
    [anon_sym_is] = ACTIONS(2176),
    [anon_sym_as] = ACTIONS(2176),
    [anon_sym_DASH_DASH] = ACTIONS(2176),
    [anon_sym_PLUS_PLUS] = ACTIONS(2176),
    [anon_sym_DOT] = ACTIONS(2168),
    [anon_sym_DOT_STAR] = ACTIONS(2176),
    [anon_sym_DASH_GT] = ACTIONS(2168),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2176),
    [anon_sym_let] = ACTIONS(2176),
    [anon_sym_This] = ACTIONS(2176),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2176),
  },
  [3423] = {
    [sym_identifier] = ACTIONS(7967),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7969),
    [anon_sym_COMMA] = ACTIONS(7969),
    [anon_sym_RPAREN] = ACTIONS(7969),
    [aux_sym_preproc_if_token2] = ACTIONS(7969),
    [aux_sym_preproc_else_token1] = ACTIONS(7969),
    [aux_sym_preproc_elif_token1] = ACTIONS(7967),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7969),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7969),
    [anon_sym_LPAREN2] = ACTIONS(7969),
    [anon_sym_DASH] = ACTIONS(7967),
    [anon_sym_PLUS] = ACTIONS(7967),
    [anon_sym_STAR] = ACTIONS(7967),
    [anon_sym_SLASH] = ACTIONS(7967),
    [anon_sym_PERCENT] = ACTIONS(7967),
    [anon_sym_PIPE_PIPE] = ACTIONS(7969),
    [anon_sym_AMP_AMP] = ACTIONS(7969),
    [anon_sym_PIPE] = ACTIONS(7967),
    [anon_sym_CARET] = ACTIONS(7967),
    [anon_sym_AMP] = ACTIONS(7967),
    [anon_sym_EQ_EQ] = ACTIONS(7969),
    [anon_sym_BANG_EQ] = ACTIONS(7969),
    [anon_sym_GT] = ACTIONS(7967),
    [anon_sym_GT_EQ] = ACTIONS(7969),
    [anon_sym_LT_EQ] = ACTIONS(7967),
    [anon_sym_LT] = ACTIONS(7967),
    [anon_sym_LT_LT] = ACTIONS(7967),
    [anon_sym_GT_GT] = ACTIONS(7967),
    [anon_sym_COLON] = ACTIONS(7969),
    [anon_sym_SEMI] = ACTIONS(7969),
    [anon_sym___attribute__] = ACTIONS(7967),
    [anon_sym___attribute] = ACTIONS(7967),
    [anon_sym_RBRACE] = ACTIONS(7969),
    [anon_sym_LBRACK] = ACTIONS(7969),
    [anon_sym_RBRACK] = ACTIONS(7969),
    [anon_sym_EQ] = ACTIONS(7967),
    [anon_sym_QMARK] = ACTIONS(7969),
    [anon_sym_STAR_EQ] = ACTIONS(7969),
    [anon_sym_SLASH_EQ] = ACTIONS(7969),
    [anon_sym_PERCENT_EQ] = ACTIONS(7969),
    [anon_sym_PLUS_EQ] = ACTIONS(7969),
    [anon_sym_DASH_EQ] = ACTIONS(7969),
    [anon_sym_LT_LT_EQ] = ACTIONS(7969),
    [anon_sym_GT_GT_EQ] = ACTIONS(7969),
    [anon_sym_AMP_EQ] = ACTIONS(7969),
    [anon_sym_CARET_EQ] = ACTIONS(7969),
    [anon_sym_PIPE_EQ] = ACTIONS(7969),
    [anon_sym_and_eq] = ACTIONS(7967),
    [anon_sym_or_eq] = ACTIONS(7967),
    [anon_sym_xor_eq] = ACTIONS(7967),
    [anon_sym_LT_EQ_GT] = ACTIONS(7969),
    [anon_sym_or] = ACTIONS(7967),
    [anon_sym_and] = ACTIONS(7967),
    [anon_sym_bitor] = ACTIONS(7967),
    [anon_sym_xor] = ACTIONS(7967),
    [anon_sym_bitand] = ACTIONS(7967),
    [anon_sym_not_eq] = ACTIONS(7967),
    [anon_sym_is] = ACTIONS(7967),
    [anon_sym_as] = ACTIONS(7967),
    [anon_sym_DASH_DASH] = ACTIONS(7969),
    [anon_sym_PLUS_PLUS] = ACTIONS(7969),
    [anon_sym_DOT] = ACTIONS(7967),
    [anon_sym_DOT_STAR] = ACTIONS(7969),
    [anon_sym_DASH_GT] = ACTIONS(7969),
    [sym_comment] = ACTIONS(3),
  },
  [3424] = {
    [sym_identifier] = ACTIONS(7971),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7973),
    [anon_sym_COMMA] = ACTIONS(7973),
    [anon_sym_RPAREN] = ACTIONS(7973),
    [aux_sym_preproc_if_token2] = ACTIONS(7973),
    [aux_sym_preproc_else_token1] = ACTIONS(7973),
    [aux_sym_preproc_elif_token1] = ACTIONS(7971),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7973),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7973),
    [anon_sym_LPAREN2] = ACTIONS(7973),
    [anon_sym_DASH] = ACTIONS(7971),
    [anon_sym_PLUS] = ACTIONS(7971),
    [anon_sym_STAR] = ACTIONS(7971),
    [anon_sym_SLASH] = ACTIONS(7971),
    [anon_sym_PERCENT] = ACTIONS(7971),
    [anon_sym_PIPE_PIPE] = ACTIONS(7973),
    [anon_sym_AMP_AMP] = ACTIONS(7973),
    [anon_sym_PIPE] = ACTIONS(7971),
    [anon_sym_CARET] = ACTIONS(7971),
    [anon_sym_AMP] = ACTIONS(7971),
    [anon_sym_EQ_EQ] = ACTIONS(7973),
    [anon_sym_BANG_EQ] = ACTIONS(7973),
    [anon_sym_GT] = ACTIONS(7971),
    [anon_sym_GT_EQ] = ACTIONS(7973),
    [anon_sym_LT_EQ] = ACTIONS(7971),
    [anon_sym_LT] = ACTIONS(7971),
    [anon_sym_LT_LT] = ACTIONS(7971),
    [anon_sym_GT_GT] = ACTIONS(7971),
    [anon_sym_COLON] = ACTIONS(7973),
    [anon_sym_SEMI] = ACTIONS(7973),
    [anon_sym___attribute__] = ACTIONS(7971),
    [anon_sym___attribute] = ACTIONS(7971),
    [anon_sym_RBRACE] = ACTIONS(7973),
    [anon_sym_LBRACK] = ACTIONS(7973),
    [anon_sym_RBRACK] = ACTIONS(7973),
    [anon_sym_EQ] = ACTIONS(7971),
    [anon_sym_QMARK] = ACTIONS(7973),
    [anon_sym_STAR_EQ] = ACTIONS(7973),
    [anon_sym_SLASH_EQ] = ACTIONS(7973),
    [anon_sym_PERCENT_EQ] = ACTIONS(7973),
    [anon_sym_PLUS_EQ] = ACTIONS(7973),
    [anon_sym_DASH_EQ] = ACTIONS(7973),
    [anon_sym_LT_LT_EQ] = ACTIONS(7973),
    [anon_sym_GT_GT_EQ] = ACTIONS(7973),
    [anon_sym_AMP_EQ] = ACTIONS(7973),
    [anon_sym_CARET_EQ] = ACTIONS(7973),
    [anon_sym_PIPE_EQ] = ACTIONS(7973),
    [anon_sym_and_eq] = ACTIONS(7971),
    [anon_sym_or_eq] = ACTIONS(7971),
    [anon_sym_xor_eq] = ACTIONS(7971),
    [anon_sym_LT_EQ_GT] = ACTIONS(7973),
    [anon_sym_or] = ACTIONS(7971),
    [anon_sym_and] = ACTIONS(7971),
    [anon_sym_bitor] = ACTIONS(7971),
    [anon_sym_xor] = ACTIONS(7971),
    [anon_sym_bitand] = ACTIONS(7971),
    [anon_sym_not_eq] = ACTIONS(7971),
    [anon_sym_is] = ACTIONS(7971),
    [anon_sym_as] = ACTIONS(7971),
    [anon_sym_DASH_DASH] = ACTIONS(7973),
    [anon_sym_PLUS_PLUS] = ACTIONS(7973),
    [anon_sym_DOT] = ACTIONS(7971),
    [anon_sym_DOT_STAR] = ACTIONS(7973),
    [anon_sym_DASH_GT] = ACTIONS(7973),
    [sym_comment] = ACTIONS(3),
  },
  [3425] = {
    [sym_identifier] = ACTIONS(7975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7977),
    [anon_sym_COMMA] = ACTIONS(7977),
    [anon_sym_RPAREN] = ACTIONS(7977),
    [aux_sym_preproc_if_token2] = ACTIONS(7977),
    [aux_sym_preproc_else_token1] = ACTIONS(7977),
    [aux_sym_preproc_elif_token1] = ACTIONS(7975),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7977),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7977),
    [anon_sym_LPAREN2] = ACTIONS(7977),
    [anon_sym_DASH] = ACTIONS(7975),
    [anon_sym_PLUS] = ACTIONS(7975),
    [anon_sym_STAR] = ACTIONS(7975),
    [anon_sym_SLASH] = ACTIONS(7975),
    [anon_sym_PERCENT] = ACTIONS(7975),
    [anon_sym_PIPE_PIPE] = ACTIONS(7977),
    [anon_sym_AMP_AMP] = ACTIONS(7977),
    [anon_sym_PIPE] = ACTIONS(7975),
    [anon_sym_CARET] = ACTIONS(7975),
    [anon_sym_AMP] = ACTIONS(7975),
    [anon_sym_EQ_EQ] = ACTIONS(7977),
    [anon_sym_BANG_EQ] = ACTIONS(7977),
    [anon_sym_GT] = ACTIONS(7975),
    [anon_sym_GT_EQ] = ACTIONS(7977),
    [anon_sym_LT_EQ] = ACTIONS(7975),
    [anon_sym_LT] = ACTIONS(7975),
    [anon_sym_LT_LT] = ACTIONS(7975),
    [anon_sym_GT_GT] = ACTIONS(7975),
    [anon_sym_COLON] = ACTIONS(7977),
    [anon_sym_SEMI] = ACTIONS(7977),
    [anon_sym___attribute__] = ACTIONS(7975),
    [anon_sym___attribute] = ACTIONS(7975),
    [anon_sym_RBRACE] = ACTIONS(7977),
    [anon_sym_LBRACK] = ACTIONS(7977),
    [anon_sym_RBRACK] = ACTIONS(7977),
    [anon_sym_EQ] = ACTIONS(7975),
    [anon_sym_QMARK] = ACTIONS(7977),
    [anon_sym_STAR_EQ] = ACTIONS(7977),
    [anon_sym_SLASH_EQ] = ACTIONS(7977),
    [anon_sym_PERCENT_EQ] = ACTIONS(7977),
    [anon_sym_PLUS_EQ] = ACTIONS(7977),
    [anon_sym_DASH_EQ] = ACTIONS(7977),
    [anon_sym_LT_LT_EQ] = ACTIONS(7977),
    [anon_sym_GT_GT_EQ] = ACTIONS(7977),
    [anon_sym_AMP_EQ] = ACTIONS(7977),
    [anon_sym_CARET_EQ] = ACTIONS(7977),
    [anon_sym_PIPE_EQ] = ACTIONS(7977),
    [anon_sym_and_eq] = ACTIONS(7975),
    [anon_sym_or_eq] = ACTIONS(7975),
    [anon_sym_xor_eq] = ACTIONS(7975),
    [anon_sym_LT_EQ_GT] = ACTIONS(7977),
    [anon_sym_or] = ACTIONS(7975),
    [anon_sym_and] = ACTIONS(7975),
    [anon_sym_bitor] = ACTIONS(7975),
    [anon_sym_xor] = ACTIONS(7975),
    [anon_sym_bitand] = ACTIONS(7975),
    [anon_sym_not_eq] = ACTIONS(7975),
    [anon_sym_is] = ACTIONS(7975),
    [anon_sym_as] = ACTIONS(7975),
    [anon_sym_DASH_DASH] = ACTIONS(7977),
    [anon_sym_PLUS_PLUS] = ACTIONS(7977),
    [anon_sym_DOT] = ACTIONS(7975),
    [anon_sym_DOT_STAR] = ACTIONS(7977),
    [anon_sym_DASH_GT] = ACTIONS(7977),
    [sym_comment] = ACTIONS(3),
  },
  [3426] = {
    [sym_identifier] = ACTIONS(7979),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7981),
    [anon_sym_COMMA] = ACTIONS(7981),
    [anon_sym_RPAREN] = ACTIONS(7981),
    [aux_sym_preproc_if_token2] = ACTIONS(7981),
    [aux_sym_preproc_else_token1] = ACTIONS(7981),
    [aux_sym_preproc_elif_token1] = ACTIONS(7979),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7981),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7981),
    [anon_sym_LPAREN2] = ACTIONS(7981),
    [anon_sym_DASH] = ACTIONS(7979),
    [anon_sym_PLUS] = ACTIONS(7979),
    [anon_sym_STAR] = ACTIONS(7979),
    [anon_sym_SLASH] = ACTIONS(7979),
    [anon_sym_PERCENT] = ACTIONS(7979),
    [anon_sym_PIPE_PIPE] = ACTIONS(7981),
    [anon_sym_AMP_AMP] = ACTIONS(7981),
    [anon_sym_PIPE] = ACTIONS(7979),
    [anon_sym_CARET] = ACTIONS(7979),
    [anon_sym_AMP] = ACTIONS(7979),
    [anon_sym_EQ_EQ] = ACTIONS(7981),
    [anon_sym_BANG_EQ] = ACTIONS(7981),
    [anon_sym_GT] = ACTIONS(7979),
    [anon_sym_GT_EQ] = ACTIONS(7981),
    [anon_sym_LT_EQ] = ACTIONS(7979),
    [anon_sym_LT] = ACTIONS(7979),
    [anon_sym_LT_LT] = ACTIONS(7979),
    [anon_sym_GT_GT] = ACTIONS(7979),
    [anon_sym_COLON] = ACTIONS(7981),
    [anon_sym_SEMI] = ACTIONS(7981),
    [anon_sym___attribute__] = ACTIONS(7979),
    [anon_sym___attribute] = ACTIONS(7979),
    [anon_sym_RBRACE] = ACTIONS(7981),
    [anon_sym_LBRACK] = ACTIONS(7981),
    [anon_sym_RBRACK] = ACTIONS(7981),
    [anon_sym_EQ] = ACTIONS(7979),
    [anon_sym_QMARK] = ACTIONS(7981),
    [anon_sym_STAR_EQ] = ACTIONS(7981),
    [anon_sym_SLASH_EQ] = ACTIONS(7981),
    [anon_sym_PERCENT_EQ] = ACTIONS(7981),
    [anon_sym_PLUS_EQ] = ACTIONS(7981),
    [anon_sym_DASH_EQ] = ACTIONS(7981),
    [anon_sym_LT_LT_EQ] = ACTIONS(7981),
    [anon_sym_GT_GT_EQ] = ACTIONS(7981),
    [anon_sym_AMP_EQ] = ACTIONS(7981),
    [anon_sym_CARET_EQ] = ACTIONS(7981),
    [anon_sym_PIPE_EQ] = ACTIONS(7981),
    [anon_sym_and_eq] = ACTIONS(7979),
    [anon_sym_or_eq] = ACTIONS(7979),
    [anon_sym_xor_eq] = ACTIONS(7979),
    [anon_sym_LT_EQ_GT] = ACTIONS(7981),
    [anon_sym_or] = ACTIONS(7979),
    [anon_sym_and] = ACTIONS(7979),
    [anon_sym_bitor] = ACTIONS(7979),
    [anon_sym_xor] = ACTIONS(7979),
    [anon_sym_bitand] = ACTIONS(7979),
    [anon_sym_not_eq] = ACTIONS(7979),
    [anon_sym_is] = ACTIONS(7979),
    [anon_sym_as] = ACTIONS(7979),
    [anon_sym_DASH_DASH] = ACTIONS(7981),
    [anon_sym_PLUS_PLUS] = ACTIONS(7981),
    [anon_sym_DOT] = ACTIONS(7979),
    [anon_sym_DOT_STAR] = ACTIONS(7981),
    [anon_sym_DASH_GT] = ACTIONS(7981),
    [sym_comment] = ACTIONS(3),
  },
  [3427] = {
    [sym_identifier] = ACTIONS(6112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6114),
    [anon_sym_COMMA] = ACTIONS(6114),
    [anon_sym_RPAREN] = ACTIONS(6114),
    [aux_sym_preproc_if_token2] = ACTIONS(6114),
    [aux_sym_preproc_else_token1] = ACTIONS(6114),
    [aux_sym_preproc_elif_token1] = ACTIONS(6112),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6114),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6114),
    [anon_sym_LPAREN2] = ACTIONS(6114),
    [anon_sym_DASH] = ACTIONS(6112),
    [anon_sym_PLUS] = ACTIONS(6112),
    [anon_sym_STAR] = ACTIONS(6112),
    [anon_sym_SLASH] = ACTIONS(6112),
    [anon_sym_PERCENT] = ACTIONS(6112),
    [anon_sym_PIPE_PIPE] = ACTIONS(6114),
    [anon_sym_AMP_AMP] = ACTIONS(6114),
    [anon_sym_PIPE] = ACTIONS(6112),
    [anon_sym_CARET] = ACTIONS(6112),
    [anon_sym_AMP] = ACTIONS(6112),
    [anon_sym_EQ_EQ] = ACTIONS(6114),
    [anon_sym_BANG_EQ] = ACTIONS(6114),
    [anon_sym_GT] = ACTIONS(6112),
    [anon_sym_GT_EQ] = ACTIONS(6114),
    [anon_sym_LT_EQ] = ACTIONS(6112),
    [anon_sym_LT] = ACTIONS(6112),
    [anon_sym_LT_LT] = ACTIONS(6112),
    [anon_sym_GT_GT] = ACTIONS(6112),
    [anon_sym_COLON] = ACTIONS(6114),
    [anon_sym_SEMI] = ACTIONS(6114),
    [anon_sym___attribute__] = ACTIONS(6112),
    [anon_sym___attribute] = ACTIONS(6112),
    [anon_sym_RBRACE] = ACTIONS(6114),
    [anon_sym_LBRACK] = ACTIONS(6114),
    [anon_sym_RBRACK] = ACTIONS(6114),
    [anon_sym_EQ] = ACTIONS(6112),
    [anon_sym_QMARK] = ACTIONS(6114),
    [anon_sym_STAR_EQ] = ACTIONS(6114),
    [anon_sym_SLASH_EQ] = ACTIONS(6114),
    [anon_sym_PERCENT_EQ] = ACTIONS(6114),
    [anon_sym_PLUS_EQ] = ACTIONS(6114),
    [anon_sym_DASH_EQ] = ACTIONS(6114),
    [anon_sym_LT_LT_EQ] = ACTIONS(6114),
    [anon_sym_GT_GT_EQ] = ACTIONS(6114),
    [anon_sym_AMP_EQ] = ACTIONS(6114),
    [anon_sym_CARET_EQ] = ACTIONS(6114),
    [anon_sym_PIPE_EQ] = ACTIONS(6114),
    [anon_sym_and_eq] = ACTIONS(6112),
    [anon_sym_or_eq] = ACTIONS(6112),
    [anon_sym_xor_eq] = ACTIONS(6112),
    [anon_sym_LT_EQ_GT] = ACTIONS(6114),
    [anon_sym_or] = ACTIONS(6112),
    [anon_sym_and] = ACTIONS(6112),
    [anon_sym_bitor] = ACTIONS(6112),
    [anon_sym_xor] = ACTIONS(6112),
    [anon_sym_bitand] = ACTIONS(6112),
    [anon_sym_not_eq] = ACTIONS(6112),
    [anon_sym_is] = ACTIONS(6112),
    [anon_sym_as] = ACTIONS(6112),
    [anon_sym_DASH_DASH] = ACTIONS(6114),
    [anon_sym_PLUS_PLUS] = ACTIONS(6114),
    [anon_sym_DOT] = ACTIONS(6112),
    [anon_sym_DOT_STAR] = ACTIONS(6114),
    [anon_sym_DASH_GT] = ACTIONS(6114),
    [sym_comment] = ACTIONS(3),
  },
  [3428] = {
    [sym_identifier] = ACTIONS(7983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7985),
    [anon_sym_COMMA] = ACTIONS(7985),
    [anon_sym_RPAREN] = ACTIONS(7985),
    [aux_sym_preproc_if_token2] = ACTIONS(7985),
    [aux_sym_preproc_else_token1] = ACTIONS(7985),
    [aux_sym_preproc_elif_token1] = ACTIONS(7983),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7985),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7985),
    [anon_sym_LPAREN2] = ACTIONS(7985),
    [anon_sym_DASH] = ACTIONS(7983),
    [anon_sym_PLUS] = ACTIONS(7983),
    [anon_sym_STAR] = ACTIONS(7983),
    [anon_sym_SLASH] = ACTIONS(7983),
    [anon_sym_PERCENT] = ACTIONS(7983),
    [anon_sym_PIPE_PIPE] = ACTIONS(7985),
    [anon_sym_AMP_AMP] = ACTIONS(7985),
    [anon_sym_PIPE] = ACTIONS(7983),
    [anon_sym_CARET] = ACTIONS(7983),
    [anon_sym_AMP] = ACTIONS(7983),
    [anon_sym_EQ_EQ] = ACTIONS(7985),
    [anon_sym_BANG_EQ] = ACTIONS(7985),
    [anon_sym_GT] = ACTIONS(7983),
    [anon_sym_GT_EQ] = ACTIONS(7985),
    [anon_sym_LT_EQ] = ACTIONS(7983),
    [anon_sym_LT] = ACTIONS(7983),
    [anon_sym_LT_LT] = ACTIONS(7983),
    [anon_sym_GT_GT] = ACTIONS(7983),
    [anon_sym_COLON] = ACTIONS(7985),
    [anon_sym_SEMI] = ACTIONS(7985),
    [anon_sym___attribute__] = ACTIONS(7983),
    [anon_sym___attribute] = ACTIONS(7983),
    [anon_sym_RBRACE] = ACTIONS(7985),
    [anon_sym_LBRACK] = ACTIONS(7985),
    [anon_sym_RBRACK] = ACTIONS(7985),
    [anon_sym_EQ] = ACTIONS(7983),
    [anon_sym_QMARK] = ACTIONS(7985),
    [anon_sym_STAR_EQ] = ACTIONS(7985),
    [anon_sym_SLASH_EQ] = ACTIONS(7985),
    [anon_sym_PERCENT_EQ] = ACTIONS(7985),
    [anon_sym_PLUS_EQ] = ACTIONS(7985),
    [anon_sym_DASH_EQ] = ACTIONS(7985),
    [anon_sym_LT_LT_EQ] = ACTIONS(7985),
    [anon_sym_GT_GT_EQ] = ACTIONS(7985),
    [anon_sym_AMP_EQ] = ACTIONS(7985),
    [anon_sym_CARET_EQ] = ACTIONS(7985),
    [anon_sym_PIPE_EQ] = ACTIONS(7985),
    [anon_sym_and_eq] = ACTIONS(7983),
    [anon_sym_or_eq] = ACTIONS(7983),
    [anon_sym_xor_eq] = ACTIONS(7983),
    [anon_sym_LT_EQ_GT] = ACTIONS(7985),
    [anon_sym_or] = ACTIONS(7983),
    [anon_sym_and] = ACTIONS(7983),
    [anon_sym_bitor] = ACTIONS(7983),
    [anon_sym_xor] = ACTIONS(7983),
    [anon_sym_bitand] = ACTIONS(7983),
    [anon_sym_not_eq] = ACTIONS(7983),
    [anon_sym_is] = ACTIONS(7983),
    [anon_sym_as] = ACTIONS(7983),
    [anon_sym_DASH_DASH] = ACTIONS(7985),
    [anon_sym_PLUS_PLUS] = ACTIONS(7985),
    [anon_sym_DOT] = ACTIONS(7983),
    [anon_sym_DOT_STAR] = ACTIONS(7985),
    [anon_sym_DASH_GT] = ACTIONS(7985),
    [sym_comment] = ACTIONS(3),
  },
  [3429] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3997),
    [anon_sym_COMMA] = ACTIONS(3997),
    [anon_sym_RPAREN] = ACTIONS(3997),
    [anon_sym_LPAREN2] = ACTIONS(3997),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_STAR] = ACTIONS(3995),
    [anon_sym_SLASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3995),
    [anon_sym_PIPE_PIPE] = ACTIONS(3997),
    [anon_sym_AMP_AMP] = ACTIONS(3997),
    [anon_sym_PIPE] = ACTIONS(3995),
    [anon_sym_CARET] = ACTIONS(3995),
    [anon_sym_AMP] = ACTIONS(3995),
    [anon_sym_EQ_EQ] = ACTIONS(3997),
    [anon_sym_BANG_EQ] = ACTIONS(3997),
    [anon_sym_GT] = ACTIONS(3995),
    [anon_sym_GT_EQ] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3995),
    [anon_sym_LT] = ACTIONS(3995),
    [anon_sym_LT_LT] = ACTIONS(3995),
    [anon_sym_GT_GT] = ACTIONS(3995),
    [anon_sym___attribute__] = ACTIONS(3997),
    [anon_sym___attribute] = ACTIONS(3995),
    [anon_sym_LBRACE] = ACTIONS(3997),
    [anon_sym_signed] = ACTIONS(7889),
    [anon_sym_unsigned] = ACTIONS(7889),
    [anon_sym_long] = ACTIONS(7889),
    [anon_sym_short] = ACTIONS(7889),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [anon_sym_EQ] = ACTIONS(3995),
    [anon_sym_QMARK] = ACTIONS(3997),
    [anon_sym_STAR_EQ] = ACTIONS(3997),
    [anon_sym_SLASH_EQ] = ACTIONS(3997),
    [anon_sym_PERCENT_EQ] = ACTIONS(3997),
    [anon_sym_PLUS_EQ] = ACTIONS(3997),
    [anon_sym_DASH_EQ] = ACTIONS(3997),
    [anon_sym_LT_LT_EQ] = ACTIONS(3997),
    [anon_sym_GT_GT_EQ] = ACTIONS(3997),
    [anon_sym_AMP_EQ] = ACTIONS(3997),
    [anon_sym_CARET_EQ] = ACTIONS(3997),
    [anon_sym_PIPE_EQ] = ACTIONS(3997),
    [anon_sym_and_eq] = ACTIONS(3997),
    [anon_sym_or_eq] = ACTIONS(3997),
    [anon_sym_xor_eq] = ACTIONS(3997),
    [anon_sym_LT_EQ_GT] = ACTIONS(3997),
    [anon_sym_or] = ACTIONS(3995),
    [anon_sym_and] = ACTIONS(3995),
    [anon_sym_bitor] = ACTIONS(3997),
    [anon_sym_xor] = ACTIONS(3995),
    [anon_sym_bitand] = ACTIONS(3997),
    [anon_sym_not_eq] = ACTIONS(3997),
    [anon_sym_is] = ACTIONS(3997),
    [anon_sym_as] = ACTIONS(3997),
    [anon_sym_DASH_DASH] = ACTIONS(3997),
    [anon_sym_PLUS_PLUS] = ACTIONS(3997),
    [anon_sym_DOT] = ACTIONS(3995),
    [anon_sym_DOT_STAR] = ACTIONS(3997),
    [anon_sym_DASH_GT] = ACTIONS(3995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3997),
    [anon_sym_let] = ACTIONS(3997),
    [anon_sym_This] = ACTIONS(3997),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3997),
  },
  [3430] = {
    [sym_identifier] = ACTIONS(7987),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7989),
    [anon_sym_COMMA] = ACTIONS(7989),
    [anon_sym_RPAREN] = ACTIONS(7989),
    [aux_sym_preproc_if_token2] = ACTIONS(7989),
    [aux_sym_preproc_else_token1] = ACTIONS(7989),
    [aux_sym_preproc_elif_token1] = ACTIONS(7987),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7989),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7989),
    [anon_sym_LPAREN2] = ACTIONS(7989),
    [anon_sym_DASH] = ACTIONS(7987),
    [anon_sym_PLUS] = ACTIONS(7987),
    [anon_sym_STAR] = ACTIONS(7987),
    [anon_sym_SLASH] = ACTIONS(7987),
    [anon_sym_PERCENT] = ACTIONS(7987),
    [anon_sym_PIPE_PIPE] = ACTIONS(7989),
    [anon_sym_AMP_AMP] = ACTIONS(7989),
    [anon_sym_PIPE] = ACTIONS(7987),
    [anon_sym_CARET] = ACTIONS(7987),
    [anon_sym_AMP] = ACTIONS(7987),
    [anon_sym_EQ_EQ] = ACTIONS(7989),
    [anon_sym_BANG_EQ] = ACTIONS(7989),
    [anon_sym_GT] = ACTIONS(7987),
    [anon_sym_GT_EQ] = ACTIONS(7989),
    [anon_sym_LT_EQ] = ACTIONS(7987),
    [anon_sym_LT] = ACTIONS(7987),
    [anon_sym_LT_LT] = ACTIONS(7987),
    [anon_sym_GT_GT] = ACTIONS(7987),
    [anon_sym_COLON] = ACTIONS(7989),
    [anon_sym_SEMI] = ACTIONS(7989),
    [anon_sym___attribute__] = ACTIONS(7987),
    [anon_sym___attribute] = ACTIONS(7987),
    [anon_sym_RBRACE] = ACTIONS(7989),
    [anon_sym_LBRACK] = ACTIONS(7989),
    [anon_sym_RBRACK] = ACTIONS(7989),
    [anon_sym_EQ] = ACTIONS(7987),
    [anon_sym_QMARK] = ACTIONS(7989),
    [anon_sym_STAR_EQ] = ACTIONS(7989),
    [anon_sym_SLASH_EQ] = ACTIONS(7989),
    [anon_sym_PERCENT_EQ] = ACTIONS(7989),
    [anon_sym_PLUS_EQ] = ACTIONS(7989),
    [anon_sym_DASH_EQ] = ACTIONS(7989),
    [anon_sym_LT_LT_EQ] = ACTIONS(7989),
    [anon_sym_GT_GT_EQ] = ACTIONS(7989),
    [anon_sym_AMP_EQ] = ACTIONS(7989),
    [anon_sym_CARET_EQ] = ACTIONS(7989),
    [anon_sym_PIPE_EQ] = ACTIONS(7989),
    [anon_sym_and_eq] = ACTIONS(7987),
    [anon_sym_or_eq] = ACTIONS(7987),
    [anon_sym_xor_eq] = ACTIONS(7987),
    [anon_sym_LT_EQ_GT] = ACTIONS(7989),
    [anon_sym_or] = ACTIONS(7987),
    [anon_sym_and] = ACTIONS(7987),
    [anon_sym_bitor] = ACTIONS(7987),
    [anon_sym_xor] = ACTIONS(7987),
    [anon_sym_bitand] = ACTIONS(7987),
    [anon_sym_not_eq] = ACTIONS(7987),
    [anon_sym_is] = ACTIONS(7987),
    [anon_sym_as] = ACTIONS(7987),
    [anon_sym_DASH_DASH] = ACTIONS(7989),
    [anon_sym_PLUS_PLUS] = ACTIONS(7989),
    [anon_sym_DOT] = ACTIONS(7987),
    [anon_sym_DOT_STAR] = ACTIONS(7989),
    [anon_sym_DASH_GT] = ACTIONS(7989),
    [sym_comment] = ACTIONS(3),
  },
  [3431] = {
    [sym_identifier] = ACTIONS(6120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6122),
    [anon_sym_COMMA] = ACTIONS(6122),
    [anon_sym_RPAREN] = ACTIONS(6122),
    [aux_sym_preproc_if_token2] = ACTIONS(6122),
    [aux_sym_preproc_else_token1] = ACTIONS(6122),
    [aux_sym_preproc_elif_token1] = ACTIONS(6120),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6122),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6122),
    [anon_sym_LPAREN2] = ACTIONS(6122),
    [anon_sym_DASH] = ACTIONS(6120),
    [anon_sym_PLUS] = ACTIONS(6120),
    [anon_sym_STAR] = ACTIONS(6120),
    [anon_sym_SLASH] = ACTIONS(6120),
    [anon_sym_PERCENT] = ACTIONS(6120),
    [anon_sym_PIPE_PIPE] = ACTIONS(6122),
    [anon_sym_AMP_AMP] = ACTIONS(6122),
    [anon_sym_PIPE] = ACTIONS(6120),
    [anon_sym_CARET] = ACTIONS(6120),
    [anon_sym_AMP] = ACTIONS(6120),
    [anon_sym_EQ_EQ] = ACTIONS(6122),
    [anon_sym_BANG_EQ] = ACTIONS(6122),
    [anon_sym_GT] = ACTIONS(6120),
    [anon_sym_GT_EQ] = ACTIONS(6122),
    [anon_sym_LT_EQ] = ACTIONS(6120),
    [anon_sym_LT] = ACTIONS(6120),
    [anon_sym_LT_LT] = ACTIONS(6120),
    [anon_sym_GT_GT] = ACTIONS(6120),
    [anon_sym_COLON] = ACTIONS(6122),
    [anon_sym_SEMI] = ACTIONS(6122),
    [anon_sym___attribute__] = ACTIONS(6120),
    [anon_sym___attribute] = ACTIONS(6120),
    [anon_sym_RBRACE] = ACTIONS(6122),
    [anon_sym_LBRACK] = ACTIONS(6122),
    [anon_sym_RBRACK] = ACTIONS(6122),
    [anon_sym_EQ] = ACTIONS(6120),
    [anon_sym_QMARK] = ACTIONS(6122),
    [anon_sym_STAR_EQ] = ACTIONS(6122),
    [anon_sym_SLASH_EQ] = ACTIONS(6122),
    [anon_sym_PERCENT_EQ] = ACTIONS(6122),
    [anon_sym_PLUS_EQ] = ACTIONS(6122),
    [anon_sym_DASH_EQ] = ACTIONS(6122),
    [anon_sym_LT_LT_EQ] = ACTIONS(6122),
    [anon_sym_GT_GT_EQ] = ACTIONS(6122),
    [anon_sym_AMP_EQ] = ACTIONS(6122),
    [anon_sym_CARET_EQ] = ACTIONS(6122),
    [anon_sym_PIPE_EQ] = ACTIONS(6122),
    [anon_sym_and_eq] = ACTIONS(6120),
    [anon_sym_or_eq] = ACTIONS(6120),
    [anon_sym_xor_eq] = ACTIONS(6120),
    [anon_sym_LT_EQ_GT] = ACTIONS(6122),
    [anon_sym_or] = ACTIONS(6120),
    [anon_sym_and] = ACTIONS(6120),
    [anon_sym_bitor] = ACTIONS(6120),
    [anon_sym_xor] = ACTIONS(6120),
    [anon_sym_bitand] = ACTIONS(6120),
    [anon_sym_not_eq] = ACTIONS(6120),
    [anon_sym_is] = ACTIONS(6120),
    [anon_sym_as] = ACTIONS(6120),
    [anon_sym_DASH_DASH] = ACTIONS(6122),
    [anon_sym_PLUS_PLUS] = ACTIONS(6122),
    [anon_sym_DOT] = ACTIONS(6120),
    [anon_sym_DOT_STAR] = ACTIONS(6122),
    [anon_sym_DASH_GT] = ACTIONS(6122),
    [sym_comment] = ACTIONS(3),
  },
  [3432] = {
    [sym_identifier] = ACTIONS(7991),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7993),
    [anon_sym_COMMA] = ACTIONS(7993),
    [anon_sym_RPAREN] = ACTIONS(7993),
    [aux_sym_preproc_if_token2] = ACTIONS(7993),
    [aux_sym_preproc_else_token1] = ACTIONS(7993),
    [aux_sym_preproc_elif_token1] = ACTIONS(7991),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7993),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7993),
    [anon_sym_LPAREN2] = ACTIONS(7993),
    [anon_sym_DASH] = ACTIONS(7991),
    [anon_sym_PLUS] = ACTIONS(7991),
    [anon_sym_STAR] = ACTIONS(7991),
    [anon_sym_SLASH] = ACTIONS(7991),
    [anon_sym_PERCENT] = ACTIONS(7991),
    [anon_sym_PIPE_PIPE] = ACTIONS(7993),
    [anon_sym_AMP_AMP] = ACTIONS(7993),
    [anon_sym_PIPE] = ACTIONS(7991),
    [anon_sym_CARET] = ACTIONS(7991),
    [anon_sym_AMP] = ACTIONS(7991),
    [anon_sym_EQ_EQ] = ACTIONS(7993),
    [anon_sym_BANG_EQ] = ACTIONS(7993),
    [anon_sym_GT] = ACTIONS(7991),
    [anon_sym_GT_EQ] = ACTIONS(7993),
    [anon_sym_LT_EQ] = ACTIONS(7991),
    [anon_sym_LT] = ACTIONS(7991),
    [anon_sym_LT_LT] = ACTIONS(7991),
    [anon_sym_GT_GT] = ACTIONS(7991),
    [anon_sym_COLON] = ACTIONS(7993),
    [anon_sym_SEMI] = ACTIONS(7993),
    [anon_sym___attribute__] = ACTIONS(7991),
    [anon_sym___attribute] = ACTIONS(7991),
    [anon_sym_RBRACE] = ACTIONS(7993),
    [anon_sym_LBRACK] = ACTIONS(7993),
    [anon_sym_RBRACK] = ACTIONS(7993),
    [anon_sym_EQ] = ACTIONS(7991),
    [anon_sym_QMARK] = ACTIONS(7993),
    [anon_sym_STAR_EQ] = ACTIONS(7993),
    [anon_sym_SLASH_EQ] = ACTIONS(7993),
    [anon_sym_PERCENT_EQ] = ACTIONS(7993),
    [anon_sym_PLUS_EQ] = ACTIONS(7993),
    [anon_sym_DASH_EQ] = ACTIONS(7993),
    [anon_sym_LT_LT_EQ] = ACTIONS(7993),
    [anon_sym_GT_GT_EQ] = ACTIONS(7993),
    [anon_sym_AMP_EQ] = ACTIONS(7993),
    [anon_sym_CARET_EQ] = ACTIONS(7993),
    [anon_sym_PIPE_EQ] = ACTIONS(7993),
    [anon_sym_and_eq] = ACTIONS(7991),
    [anon_sym_or_eq] = ACTIONS(7991),
    [anon_sym_xor_eq] = ACTIONS(7991),
    [anon_sym_LT_EQ_GT] = ACTIONS(7993),
    [anon_sym_or] = ACTIONS(7991),
    [anon_sym_and] = ACTIONS(7991),
    [anon_sym_bitor] = ACTIONS(7991),
    [anon_sym_xor] = ACTIONS(7991),
    [anon_sym_bitand] = ACTIONS(7991),
    [anon_sym_not_eq] = ACTIONS(7991),
    [anon_sym_is] = ACTIONS(7991),
    [anon_sym_as] = ACTIONS(7991),
    [anon_sym_DASH_DASH] = ACTIONS(7993),
    [anon_sym_PLUS_PLUS] = ACTIONS(7993),
    [anon_sym_DOT] = ACTIONS(7991),
    [anon_sym_DOT_STAR] = ACTIONS(7993),
    [anon_sym_DASH_GT] = ACTIONS(7993),
    [sym_comment] = ACTIONS(3),
  },
  [3433] = {
    [sym_identifier] = ACTIONS(5487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5483),
    [anon_sym_COMMA] = ACTIONS(5483),
    [anon_sym_RPAREN] = ACTIONS(5483),
    [aux_sym_preproc_if_token2] = ACTIONS(5483),
    [aux_sym_preproc_else_token1] = ACTIONS(5483),
    [aux_sym_preproc_elif_token1] = ACTIONS(5487),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5483),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5483),
    [anon_sym_LPAREN2] = ACTIONS(5483),
    [anon_sym_DASH] = ACTIONS(5487),
    [anon_sym_PLUS] = ACTIONS(5487),
    [anon_sym_STAR] = ACTIONS(5487),
    [anon_sym_SLASH] = ACTIONS(5487),
    [anon_sym_PERCENT] = ACTIONS(5487),
    [anon_sym_PIPE_PIPE] = ACTIONS(5483),
    [anon_sym_AMP_AMP] = ACTIONS(5483),
    [anon_sym_PIPE] = ACTIONS(5487),
    [anon_sym_CARET] = ACTIONS(5487),
    [anon_sym_AMP] = ACTIONS(5487),
    [anon_sym_EQ_EQ] = ACTIONS(5483),
    [anon_sym_BANG_EQ] = ACTIONS(5483),
    [anon_sym_GT] = ACTIONS(5487),
    [anon_sym_GT_EQ] = ACTIONS(5483),
    [anon_sym_LT_EQ] = ACTIONS(5487),
    [anon_sym_LT] = ACTIONS(5487),
    [anon_sym_LT_LT] = ACTIONS(5487),
    [anon_sym_GT_GT] = ACTIONS(5487),
    [anon_sym_COLON] = ACTIONS(5483),
    [anon_sym_SEMI] = ACTIONS(5483),
    [anon_sym___attribute__] = ACTIONS(5487),
    [anon_sym___attribute] = ACTIONS(5487),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_LBRACK] = ACTIONS(5483),
    [anon_sym_RBRACK] = ACTIONS(5483),
    [anon_sym_EQ] = ACTIONS(5487),
    [anon_sym_QMARK] = ACTIONS(5483),
    [anon_sym_STAR_EQ] = ACTIONS(5483),
    [anon_sym_SLASH_EQ] = ACTIONS(5483),
    [anon_sym_PERCENT_EQ] = ACTIONS(5483),
    [anon_sym_PLUS_EQ] = ACTIONS(5483),
    [anon_sym_DASH_EQ] = ACTIONS(5483),
    [anon_sym_LT_LT_EQ] = ACTIONS(5483),
    [anon_sym_GT_GT_EQ] = ACTIONS(5483),
    [anon_sym_AMP_EQ] = ACTIONS(5483),
    [anon_sym_CARET_EQ] = ACTIONS(5483),
    [anon_sym_PIPE_EQ] = ACTIONS(5483),
    [anon_sym_and_eq] = ACTIONS(5487),
    [anon_sym_or_eq] = ACTIONS(5487),
    [anon_sym_xor_eq] = ACTIONS(5487),
    [anon_sym_LT_EQ_GT] = ACTIONS(5483),
    [anon_sym_or] = ACTIONS(5487),
    [anon_sym_and] = ACTIONS(5487),
    [anon_sym_bitor] = ACTIONS(5487),
    [anon_sym_xor] = ACTIONS(5487),
    [anon_sym_bitand] = ACTIONS(5487),
    [anon_sym_not_eq] = ACTIONS(5487),
    [anon_sym_is] = ACTIONS(5487),
    [anon_sym_as] = ACTIONS(5487),
    [anon_sym_DASH_DASH] = ACTIONS(5483),
    [anon_sym_PLUS_PLUS] = ACTIONS(5483),
    [anon_sym_DOT] = ACTIONS(5487),
    [anon_sym_DOT_STAR] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
  },
  [3434] = {
    [sym_identifier] = ACTIONS(6156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6158),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(6158),
    [aux_sym_preproc_if_token2] = ACTIONS(6158),
    [aux_sym_preproc_else_token1] = ACTIONS(6158),
    [aux_sym_preproc_elif_token1] = ACTIONS(6156),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6158),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6158),
    [anon_sym_LPAREN2] = ACTIONS(6158),
    [anon_sym_DASH] = ACTIONS(6156),
    [anon_sym_PLUS] = ACTIONS(6156),
    [anon_sym_STAR] = ACTIONS(6156),
    [anon_sym_SLASH] = ACTIONS(6156),
    [anon_sym_PERCENT] = ACTIONS(6156),
    [anon_sym_PIPE_PIPE] = ACTIONS(6158),
    [anon_sym_AMP_AMP] = ACTIONS(6158),
    [anon_sym_PIPE] = ACTIONS(6156),
    [anon_sym_CARET] = ACTIONS(6156),
    [anon_sym_AMP] = ACTIONS(6156),
    [anon_sym_EQ_EQ] = ACTIONS(6158),
    [anon_sym_BANG_EQ] = ACTIONS(6158),
    [anon_sym_GT] = ACTIONS(6156),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6156),
    [anon_sym_LT] = ACTIONS(6156),
    [anon_sym_LT_LT] = ACTIONS(6156),
    [anon_sym_GT_GT] = ACTIONS(6156),
    [anon_sym_COLON] = ACTIONS(6158),
    [anon_sym_SEMI] = ACTIONS(6158),
    [anon_sym___attribute__] = ACTIONS(6156),
    [anon_sym___attribute] = ACTIONS(6156),
    [anon_sym_RBRACE] = ACTIONS(6158),
    [anon_sym_LBRACK] = ACTIONS(6158),
    [anon_sym_RBRACK] = ACTIONS(6158),
    [anon_sym_EQ] = ACTIONS(6156),
    [anon_sym_QMARK] = ACTIONS(6158),
    [anon_sym_STAR_EQ] = ACTIONS(6158),
    [anon_sym_SLASH_EQ] = ACTIONS(6158),
    [anon_sym_PERCENT_EQ] = ACTIONS(6158),
    [anon_sym_PLUS_EQ] = ACTIONS(6158),
    [anon_sym_DASH_EQ] = ACTIONS(6158),
    [anon_sym_LT_LT_EQ] = ACTIONS(6158),
    [anon_sym_GT_GT_EQ] = ACTIONS(6158),
    [anon_sym_AMP_EQ] = ACTIONS(6158),
    [anon_sym_CARET_EQ] = ACTIONS(6158),
    [anon_sym_PIPE_EQ] = ACTIONS(6158),
    [anon_sym_and_eq] = ACTIONS(6156),
    [anon_sym_or_eq] = ACTIONS(6156),
    [anon_sym_xor_eq] = ACTIONS(6156),
    [anon_sym_LT_EQ_GT] = ACTIONS(6158),
    [anon_sym_or] = ACTIONS(6156),
    [anon_sym_and] = ACTIONS(6156),
    [anon_sym_bitor] = ACTIONS(6156),
    [anon_sym_xor] = ACTIONS(6156),
    [anon_sym_bitand] = ACTIONS(6156),
    [anon_sym_not_eq] = ACTIONS(6156),
    [anon_sym_is] = ACTIONS(6156),
    [anon_sym_as] = ACTIONS(6156),
    [anon_sym_DASH_DASH] = ACTIONS(6158),
    [anon_sym_PLUS_PLUS] = ACTIONS(6158),
    [anon_sym_DOT] = ACTIONS(6156),
    [anon_sym_DOT_STAR] = ACTIONS(6158),
    [anon_sym_DASH_GT] = ACTIONS(6158),
    [sym_comment] = ACTIONS(3),
  },
  [3435] = {
    [sym_identifier] = ACTIONS(7995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7997),
    [anon_sym_COMMA] = ACTIONS(7997),
    [anon_sym_RPAREN] = ACTIONS(7997),
    [aux_sym_preproc_if_token2] = ACTIONS(7997),
    [aux_sym_preproc_else_token1] = ACTIONS(7997),
    [aux_sym_preproc_elif_token1] = ACTIONS(7995),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7997),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7997),
    [anon_sym_LPAREN2] = ACTIONS(7997),
    [anon_sym_DASH] = ACTIONS(7995),
    [anon_sym_PLUS] = ACTIONS(7995),
    [anon_sym_STAR] = ACTIONS(7995),
    [anon_sym_SLASH] = ACTIONS(7995),
    [anon_sym_PERCENT] = ACTIONS(7995),
    [anon_sym_PIPE_PIPE] = ACTIONS(7997),
    [anon_sym_AMP_AMP] = ACTIONS(7997),
    [anon_sym_PIPE] = ACTIONS(7995),
    [anon_sym_CARET] = ACTIONS(7995),
    [anon_sym_AMP] = ACTIONS(7995),
    [anon_sym_EQ_EQ] = ACTIONS(7997),
    [anon_sym_BANG_EQ] = ACTIONS(7997),
    [anon_sym_GT] = ACTIONS(7995),
    [anon_sym_GT_EQ] = ACTIONS(7997),
    [anon_sym_LT_EQ] = ACTIONS(7995),
    [anon_sym_LT] = ACTIONS(7995),
    [anon_sym_LT_LT] = ACTIONS(7995),
    [anon_sym_GT_GT] = ACTIONS(7995),
    [anon_sym_COLON] = ACTIONS(7997),
    [anon_sym_SEMI] = ACTIONS(7997),
    [anon_sym___attribute__] = ACTIONS(7995),
    [anon_sym___attribute] = ACTIONS(7995),
    [anon_sym_RBRACE] = ACTIONS(7997),
    [anon_sym_LBRACK] = ACTIONS(7997),
    [anon_sym_RBRACK] = ACTIONS(7997),
    [anon_sym_EQ] = ACTIONS(7995),
    [anon_sym_QMARK] = ACTIONS(7997),
    [anon_sym_STAR_EQ] = ACTIONS(7997),
    [anon_sym_SLASH_EQ] = ACTIONS(7997),
    [anon_sym_PERCENT_EQ] = ACTIONS(7997),
    [anon_sym_PLUS_EQ] = ACTIONS(7997),
    [anon_sym_DASH_EQ] = ACTIONS(7997),
    [anon_sym_LT_LT_EQ] = ACTIONS(7997),
    [anon_sym_GT_GT_EQ] = ACTIONS(7997),
    [anon_sym_AMP_EQ] = ACTIONS(7997),
    [anon_sym_CARET_EQ] = ACTIONS(7997),
    [anon_sym_PIPE_EQ] = ACTIONS(7997),
    [anon_sym_and_eq] = ACTIONS(7995),
    [anon_sym_or_eq] = ACTIONS(7995),
    [anon_sym_xor_eq] = ACTIONS(7995),
    [anon_sym_LT_EQ_GT] = ACTIONS(7997),
    [anon_sym_or] = ACTIONS(7995),
    [anon_sym_and] = ACTIONS(7995),
    [anon_sym_bitor] = ACTIONS(7995),
    [anon_sym_xor] = ACTIONS(7995),
    [anon_sym_bitand] = ACTIONS(7995),
    [anon_sym_not_eq] = ACTIONS(7995),
    [anon_sym_is] = ACTIONS(7995),
    [anon_sym_as] = ACTIONS(7995),
    [anon_sym_DASH_DASH] = ACTIONS(7997),
    [anon_sym_PLUS_PLUS] = ACTIONS(7997),
    [anon_sym_DOT] = ACTIONS(7995),
    [anon_sym_DOT_STAR] = ACTIONS(7997),
    [anon_sym_DASH_GT] = ACTIONS(7997),
    [sym_comment] = ACTIONS(3),
  },
  [3436] = {
    [sym_identifier] = ACTIONS(6124),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6126),
    [anon_sym_COMMA] = ACTIONS(6126),
    [anon_sym_RPAREN] = ACTIONS(6126),
    [aux_sym_preproc_if_token2] = ACTIONS(6126),
    [aux_sym_preproc_else_token1] = ACTIONS(6126),
    [aux_sym_preproc_elif_token1] = ACTIONS(6124),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6126),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6126),
    [anon_sym_LPAREN2] = ACTIONS(6126),
    [anon_sym_DASH] = ACTIONS(6124),
    [anon_sym_PLUS] = ACTIONS(6124),
    [anon_sym_STAR] = ACTIONS(6124),
    [anon_sym_SLASH] = ACTIONS(6124),
    [anon_sym_PERCENT] = ACTIONS(6124),
    [anon_sym_PIPE_PIPE] = ACTIONS(6126),
    [anon_sym_AMP_AMP] = ACTIONS(6126),
    [anon_sym_PIPE] = ACTIONS(6124),
    [anon_sym_CARET] = ACTIONS(6124),
    [anon_sym_AMP] = ACTIONS(6124),
    [anon_sym_EQ_EQ] = ACTIONS(6126),
    [anon_sym_BANG_EQ] = ACTIONS(6126),
    [anon_sym_GT] = ACTIONS(6124),
    [anon_sym_GT_EQ] = ACTIONS(6126),
    [anon_sym_LT_EQ] = ACTIONS(6124),
    [anon_sym_LT] = ACTIONS(6124),
    [anon_sym_LT_LT] = ACTIONS(6124),
    [anon_sym_GT_GT] = ACTIONS(6124),
    [anon_sym_COLON] = ACTIONS(6126),
    [anon_sym_SEMI] = ACTIONS(6126),
    [anon_sym___attribute__] = ACTIONS(6124),
    [anon_sym___attribute] = ACTIONS(6124),
    [anon_sym_RBRACE] = ACTIONS(6126),
    [anon_sym_LBRACK] = ACTIONS(6126),
    [anon_sym_RBRACK] = ACTIONS(6126),
    [anon_sym_EQ] = ACTIONS(6124),
    [anon_sym_QMARK] = ACTIONS(6126),
    [anon_sym_STAR_EQ] = ACTIONS(6126),
    [anon_sym_SLASH_EQ] = ACTIONS(6126),
    [anon_sym_PERCENT_EQ] = ACTIONS(6126),
    [anon_sym_PLUS_EQ] = ACTIONS(6126),
    [anon_sym_DASH_EQ] = ACTIONS(6126),
    [anon_sym_LT_LT_EQ] = ACTIONS(6126),
    [anon_sym_GT_GT_EQ] = ACTIONS(6126),
    [anon_sym_AMP_EQ] = ACTIONS(6126),
    [anon_sym_CARET_EQ] = ACTIONS(6126),
    [anon_sym_PIPE_EQ] = ACTIONS(6126),
    [anon_sym_and_eq] = ACTIONS(6124),
    [anon_sym_or_eq] = ACTIONS(6124),
    [anon_sym_xor_eq] = ACTIONS(6124),
    [anon_sym_LT_EQ_GT] = ACTIONS(6126),
    [anon_sym_or] = ACTIONS(6124),
    [anon_sym_and] = ACTIONS(6124),
    [anon_sym_bitor] = ACTIONS(6124),
    [anon_sym_xor] = ACTIONS(6124),
    [anon_sym_bitand] = ACTIONS(6124),
    [anon_sym_not_eq] = ACTIONS(6124),
    [anon_sym_is] = ACTIONS(6124),
    [anon_sym_as] = ACTIONS(6124),
    [anon_sym_DASH_DASH] = ACTIONS(6126),
    [anon_sym_PLUS_PLUS] = ACTIONS(6126),
    [anon_sym_DOT] = ACTIONS(6124),
    [anon_sym_DOT_STAR] = ACTIONS(6126),
    [anon_sym_DASH_GT] = ACTIONS(6126),
    [sym_comment] = ACTIONS(3),
  },
  [3437] = {
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_unaligned_ptr_modifier] = STATE(5091),
    [sym_ms_pointer_modifier] = STATE(4976),
    [sym__declarator] = STATE(8366),
    [sym__abstract_declarator] = STATE(8878),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_abstract_parenthesized_declarator] = STATE(7454),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_abstract_pointer_declarator] = STATE(7454),
    [sym_function_declarator] = STATE(8054),
    [sym_abstract_function_declarator] = STATE(7454),
    [sym_array_declarator] = STATE(8054),
    [sym_abstract_array_declarator] = STATE(7454),
    [sym_type_qualifier] = STATE(3808),
    [sym_alignas_qualifier] = STATE(5539),
    [sym_parameter_list] = STATE(3873),
    [sym_decltype] = STATE(11339),
    [sym_reference_declarator] = STATE(8054),
    [sym_abstract_reference_declarator] = STATE(7454),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym__function_declarator_seq] = STATE(7543),
    [sym_template_type] = STATE(11339),
    [sym_template_function] = STATE(8054),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7421),
    [sym_qualified_identifier] = STATE(8054),
    [sym_operator_name] = STATE(8054),
    [aux_sym__type_definition_type_repeat1] = STATE(3808),
    [aux_sym_pointer_declarator_repeat1] = STATE(4976),
    [sym_identifier] = ACTIONS(6718),
    [anon_sym_RPAREN] = ACTIONS(7410),
    [anon_sym_LPAREN2] = ACTIONS(5344),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(5346),
    [anon_sym_AMP_AMP] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym___extension__] = ACTIONS(5368),
    [anon_sym_COLON_COLON] = ACTIONS(7999),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(5364),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(5364),
    [sym_ms_signed_ptr_modifier] = ACTIONS(5364),
    [anon_sym__unaligned] = ACTIONS(5366),
    [anon_sym___unaligned] = ACTIONS(5366),
    [anon_sym_LBRACK] = ACTIONS(7408),
    [anon_sym_const] = ACTIONS(5368),
    [anon_sym_constexpr] = ACTIONS(5368),
    [anon_sym_volatile] = ACTIONS(5368),
    [anon_sym_restrict] = ACTIONS(5368),
    [anon_sym___restrict__] = ACTIONS(5368),
    [anon_sym__Atomic] = ACTIONS(5368),
    [anon_sym__Noreturn] = ACTIONS(5368),
    [anon_sym_noreturn] = ACTIONS(5368),
    [anon_sym__Nonnull] = ACTIONS(5368),
    [anon_sym_mutable] = ACTIONS(5368),
    [anon_sym_constinit] = ACTIONS(5368),
    [anon_sym_consteval] = ACTIONS(5368),
    [anon_sym_alignas] = ACTIONS(5370),
    [anon_sym__Alignas] = ACTIONS(5370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(2861),
  },
  [3438] = {
    [sym_identifier] = ACTIONS(6806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6808),
    [anon_sym_COMMA] = ACTIONS(6808),
    [anon_sym_RPAREN] = ACTIONS(6808),
    [aux_sym_preproc_if_token2] = ACTIONS(6808),
    [aux_sym_preproc_else_token1] = ACTIONS(6808),
    [aux_sym_preproc_elif_token1] = ACTIONS(6806),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6808),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6808),
    [anon_sym_LPAREN2] = ACTIONS(6808),
    [anon_sym_DASH] = ACTIONS(6806),
    [anon_sym_PLUS] = ACTIONS(6806),
    [anon_sym_STAR] = ACTIONS(6806),
    [anon_sym_SLASH] = ACTIONS(6806),
    [anon_sym_PERCENT] = ACTIONS(6806),
    [anon_sym_PIPE_PIPE] = ACTIONS(6808),
    [anon_sym_AMP_AMP] = ACTIONS(7961),
    [anon_sym_PIPE] = ACTIONS(6806),
    [anon_sym_CARET] = ACTIONS(6806),
    [anon_sym_AMP] = ACTIONS(6806),
    [anon_sym_EQ_EQ] = ACTIONS(6808),
    [anon_sym_BANG_EQ] = ACTIONS(6808),
    [anon_sym_GT] = ACTIONS(6806),
    [anon_sym_GT_EQ] = ACTIONS(6808),
    [anon_sym_LT_EQ] = ACTIONS(6806),
    [anon_sym_LT] = ACTIONS(6806),
    [anon_sym_LT_LT] = ACTIONS(6806),
    [anon_sym_GT_GT] = ACTIONS(6806),
    [anon_sym_COLON] = ACTIONS(6808),
    [anon_sym_SEMI] = ACTIONS(6808),
    [anon_sym___attribute__] = ACTIONS(6806),
    [anon_sym___attribute] = ACTIONS(6806),
    [anon_sym_RBRACE] = ACTIONS(6808),
    [anon_sym_LBRACK] = ACTIONS(6808),
    [anon_sym_RBRACK] = ACTIONS(6808),
    [anon_sym_EQ] = ACTIONS(6806),
    [anon_sym_QMARK] = ACTIONS(6808),
    [anon_sym_STAR_EQ] = ACTIONS(6808),
    [anon_sym_SLASH_EQ] = ACTIONS(6808),
    [anon_sym_PERCENT_EQ] = ACTIONS(6808),
    [anon_sym_PLUS_EQ] = ACTIONS(6808),
    [anon_sym_DASH_EQ] = ACTIONS(6808),
    [anon_sym_LT_LT_EQ] = ACTIONS(6808),
    [anon_sym_GT_GT_EQ] = ACTIONS(6808),
    [anon_sym_AMP_EQ] = ACTIONS(6808),
    [anon_sym_CARET_EQ] = ACTIONS(6808),
    [anon_sym_PIPE_EQ] = ACTIONS(6808),
    [anon_sym_and_eq] = ACTIONS(6806),
    [anon_sym_or_eq] = ACTIONS(6806),
    [anon_sym_xor_eq] = ACTIONS(6806),
    [anon_sym_LT_EQ_GT] = ACTIONS(6808),
    [anon_sym_or] = ACTIONS(6806),
    [anon_sym_and] = ACTIONS(7965),
    [anon_sym_bitor] = ACTIONS(6806),
    [anon_sym_xor] = ACTIONS(6806),
    [anon_sym_bitand] = ACTIONS(6806),
    [anon_sym_not_eq] = ACTIONS(6806),
    [anon_sym_is] = ACTIONS(6806),
    [anon_sym_as] = ACTIONS(6806),
    [anon_sym_DASH_DASH] = ACTIONS(6808),
    [anon_sym_PLUS_PLUS] = ACTIONS(6808),
    [anon_sym_DOT] = ACTIONS(6806),
    [anon_sym_DOT_STAR] = ACTIONS(6808),
    [anon_sym_DASH_GT] = ACTIONS(6808),
    [sym_comment] = ACTIONS(3),
  },
  [3439] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4095),
    [anon_sym_COMMA] = ACTIONS(4095),
    [anon_sym_RPAREN] = ACTIONS(4095),
    [anon_sym_LPAREN2] = ACTIONS(4095),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4093),
    [anon_sym_SLASH] = ACTIONS(4093),
    [anon_sym_PERCENT] = ACTIONS(4093),
    [anon_sym_PIPE_PIPE] = ACTIONS(4095),
    [anon_sym_AMP_AMP] = ACTIONS(4095),
    [anon_sym_PIPE] = ACTIONS(4093),
    [anon_sym_CARET] = ACTIONS(4093),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_EQ_EQ] = ACTIONS(4095),
    [anon_sym_BANG_EQ] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_GT_EQ] = ACTIONS(4095),
    [anon_sym_LT_EQ] = ACTIONS(4093),
    [anon_sym_LT] = ACTIONS(4093),
    [anon_sym_LT_LT] = ACTIONS(4093),
    [anon_sym_GT_GT] = ACTIONS(4093),
    [anon_sym___attribute__] = ACTIONS(4095),
    [anon_sym___attribute] = ACTIONS(4093),
    [anon_sym_LBRACE] = ACTIONS(4095),
    [anon_sym_signed] = ACTIONS(7889),
    [anon_sym_unsigned] = ACTIONS(7889),
    [anon_sym_long] = ACTIONS(7889),
    [anon_sym_short] = ACTIONS(7889),
    [anon_sym_LBRACK] = ACTIONS(4095),
    [anon_sym_EQ] = ACTIONS(4093),
    [anon_sym_QMARK] = ACTIONS(4095),
    [anon_sym_STAR_EQ] = ACTIONS(4095),
    [anon_sym_SLASH_EQ] = ACTIONS(4095),
    [anon_sym_PERCENT_EQ] = ACTIONS(4095),
    [anon_sym_PLUS_EQ] = ACTIONS(4095),
    [anon_sym_DASH_EQ] = ACTIONS(4095),
    [anon_sym_LT_LT_EQ] = ACTIONS(4095),
    [anon_sym_GT_GT_EQ] = ACTIONS(4095),
    [anon_sym_AMP_EQ] = ACTIONS(4095),
    [anon_sym_CARET_EQ] = ACTIONS(4095),
    [anon_sym_PIPE_EQ] = ACTIONS(4095),
    [anon_sym_and_eq] = ACTIONS(4095),
    [anon_sym_or_eq] = ACTIONS(4095),
    [anon_sym_xor_eq] = ACTIONS(4095),
    [anon_sym_LT_EQ_GT] = ACTIONS(4095),
    [anon_sym_or] = ACTIONS(4093),
    [anon_sym_and] = ACTIONS(4093),
    [anon_sym_bitor] = ACTIONS(4095),
    [anon_sym_xor] = ACTIONS(4093),
    [anon_sym_bitand] = ACTIONS(4095),
    [anon_sym_not_eq] = ACTIONS(4095),
    [anon_sym_is] = ACTIONS(4095),
    [anon_sym_as] = ACTIONS(4095),
    [anon_sym_DASH_DASH] = ACTIONS(4095),
    [anon_sym_PLUS_PLUS] = ACTIONS(4095),
    [anon_sym_DOT] = ACTIONS(4093),
    [anon_sym_DOT_STAR] = ACTIONS(4095),
    [anon_sym_DASH_GT] = ACTIONS(4093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4095),
    [anon_sym_let] = ACTIONS(4095),
    [anon_sym_This] = ACTIONS(4095),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4095),
  },
  [3440] = {
    [sym_identifier] = ACTIONS(6144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6146),
    [anon_sym_COMMA] = ACTIONS(6146),
    [anon_sym_RPAREN] = ACTIONS(6146),
    [aux_sym_preproc_if_token2] = ACTIONS(6146),
    [aux_sym_preproc_else_token1] = ACTIONS(6146),
    [aux_sym_preproc_elif_token1] = ACTIONS(6144),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6146),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6146),
    [anon_sym_LPAREN2] = ACTIONS(6146),
    [anon_sym_DASH] = ACTIONS(6144),
    [anon_sym_PLUS] = ACTIONS(6144),
    [anon_sym_STAR] = ACTIONS(6144),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6144),
    [anon_sym_PIPE_PIPE] = ACTIONS(6146),
    [anon_sym_AMP_AMP] = ACTIONS(6146),
    [anon_sym_PIPE] = ACTIONS(6144),
    [anon_sym_CARET] = ACTIONS(6144),
    [anon_sym_AMP] = ACTIONS(6144),
    [anon_sym_EQ_EQ] = ACTIONS(6146),
    [anon_sym_BANG_EQ] = ACTIONS(6146),
    [anon_sym_GT] = ACTIONS(6144),
    [anon_sym_GT_EQ] = ACTIONS(6146),
    [anon_sym_LT_EQ] = ACTIONS(6144),
    [anon_sym_LT] = ACTIONS(6144),
    [anon_sym_LT_LT] = ACTIONS(6144),
    [anon_sym_GT_GT] = ACTIONS(6144),
    [anon_sym_COLON] = ACTIONS(6146),
    [anon_sym_SEMI] = ACTIONS(6146),
    [anon_sym___attribute__] = ACTIONS(6144),
    [anon_sym___attribute] = ACTIONS(6144),
    [anon_sym_RBRACE] = ACTIONS(6146),
    [anon_sym_LBRACK] = ACTIONS(6146),
    [anon_sym_RBRACK] = ACTIONS(6146),
    [anon_sym_EQ] = ACTIONS(6144),
    [anon_sym_QMARK] = ACTIONS(6146),
    [anon_sym_STAR_EQ] = ACTIONS(6146),
    [anon_sym_SLASH_EQ] = ACTIONS(6146),
    [anon_sym_PERCENT_EQ] = ACTIONS(6146),
    [anon_sym_PLUS_EQ] = ACTIONS(6146),
    [anon_sym_DASH_EQ] = ACTIONS(6146),
    [anon_sym_LT_LT_EQ] = ACTIONS(6146),
    [anon_sym_GT_GT_EQ] = ACTIONS(6146),
    [anon_sym_AMP_EQ] = ACTIONS(6146),
    [anon_sym_CARET_EQ] = ACTIONS(6146),
    [anon_sym_PIPE_EQ] = ACTIONS(6146),
    [anon_sym_and_eq] = ACTIONS(6144),
    [anon_sym_or_eq] = ACTIONS(6144),
    [anon_sym_xor_eq] = ACTIONS(6144),
    [anon_sym_LT_EQ_GT] = ACTIONS(6146),
    [anon_sym_or] = ACTIONS(6144),
    [anon_sym_and] = ACTIONS(6144),
    [anon_sym_bitor] = ACTIONS(6144),
    [anon_sym_xor] = ACTIONS(6144),
    [anon_sym_bitand] = ACTIONS(6144),
    [anon_sym_not_eq] = ACTIONS(6144),
    [anon_sym_is] = ACTIONS(6144),
    [anon_sym_as] = ACTIONS(6144),
    [anon_sym_DASH_DASH] = ACTIONS(6146),
    [anon_sym_PLUS_PLUS] = ACTIONS(6146),
    [anon_sym_DOT] = ACTIONS(6144),
    [anon_sym_DOT_STAR] = ACTIONS(6146),
    [anon_sym_DASH_GT] = ACTIONS(6146),
    [sym_comment] = ACTIONS(3),
  },
  [3441] = {
    [sym_identifier] = ACTIONS(8001),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8003),
    [anon_sym_COMMA] = ACTIONS(8003),
    [anon_sym_RPAREN] = ACTIONS(8003),
    [aux_sym_preproc_if_token2] = ACTIONS(8003),
    [aux_sym_preproc_else_token1] = ACTIONS(8003),
    [aux_sym_preproc_elif_token1] = ACTIONS(8001),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(8003),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(8003),
    [anon_sym_LPAREN2] = ACTIONS(8003),
    [anon_sym_DASH] = ACTIONS(8001),
    [anon_sym_PLUS] = ACTIONS(8001),
    [anon_sym_STAR] = ACTIONS(8001),
    [anon_sym_SLASH] = ACTIONS(8001),
    [anon_sym_PERCENT] = ACTIONS(8001),
    [anon_sym_PIPE_PIPE] = ACTIONS(8003),
    [anon_sym_AMP_AMP] = ACTIONS(8003),
    [anon_sym_PIPE] = ACTIONS(8001),
    [anon_sym_CARET] = ACTIONS(8001),
    [anon_sym_AMP] = ACTIONS(8001),
    [anon_sym_EQ_EQ] = ACTIONS(8003),
    [anon_sym_BANG_EQ] = ACTIONS(8003),
    [anon_sym_GT] = ACTIONS(8001),
    [anon_sym_GT_EQ] = ACTIONS(8003),
    [anon_sym_LT_EQ] = ACTIONS(8001),
    [anon_sym_LT] = ACTIONS(8001),
    [anon_sym_LT_LT] = ACTIONS(8001),
    [anon_sym_GT_GT] = ACTIONS(8001),
    [anon_sym_COLON] = ACTIONS(8003),
    [anon_sym_SEMI] = ACTIONS(8003),
    [anon_sym___attribute__] = ACTIONS(8001),
    [anon_sym___attribute] = ACTIONS(8001),
    [anon_sym_RBRACE] = ACTIONS(8003),
    [anon_sym_LBRACK] = ACTIONS(8003),
    [anon_sym_RBRACK] = ACTIONS(8003),
    [anon_sym_EQ] = ACTIONS(8001),
    [anon_sym_QMARK] = ACTIONS(8003),
    [anon_sym_STAR_EQ] = ACTIONS(8003),
    [anon_sym_SLASH_EQ] = ACTIONS(8003),
    [anon_sym_PERCENT_EQ] = ACTIONS(8003),
    [anon_sym_PLUS_EQ] = ACTIONS(8003),
    [anon_sym_DASH_EQ] = ACTIONS(8003),
    [anon_sym_LT_LT_EQ] = ACTIONS(8003),
    [anon_sym_GT_GT_EQ] = ACTIONS(8003),
    [anon_sym_AMP_EQ] = ACTIONS(8003),
    [anon_sym_CARET_EQ] = ACTIONS(8003),
    [anon_sym_PIPE_EQ] = ACTIONS(8003),
    [anon_sym_and_eq] = ACTIONS(8001),
    [anon_sym_or_eq] = ACTIONS(8001),
    [anon_sym_xor_eq] = ACTIONS(8001),
    [anon_sym_LT_EQ_GT] = ACTIONS(8003),
    [anon_sym_or] = ACTIONS(8001),
    [anon_sym_and] = ACTIONS(8001),
    [anon_sym_bitor] = ACTIONS(8001),
    [anon_sym_xor] = ACTIONS(8001),
    [anon_sym_bitand] = ACTIONS(8001),
    [anon_sym_not_eq] = ACTIONS(8001),
    [anon_sym_is] = ACTIONS(8001),
    [anon_sym_as] = ACTIONS(8001),
    [anon_sym_DASH_DASH] = ACTIONS(8003),
    [anon_sym_PLUS_PLUS] = ACTIONS(8003),
    [anon_sym_DOT] = ACTIONS(8001),
    [anon_sym_DOT_STAR] = ACTIONS(8003),
    [anon_sym_DASH_GT] = ACTIONS(8003),
    [sym_comment] = ACTIONS(3),
  },
  [3442] = {
    [sym_identifier] = ACTIONS(8005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8007),
    [anon_sym_COMMA] = ACTIONS(8007),
    [anon_sym_RPAREN] = ACTIONS(8007),
    [aux_sym_preproc_if_token2] = ACTIONS(8007),
    [aux_sym_preproc_else_token1] = ACTIONS(8007),
    [aux_sym_preproc_elif_token1] = ACTIONS(8005),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(8007),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(8007),
    [anon_sym_LPAREN2] = ACTIONS(8007),
    [anon_sym_DASH] = ACTIONS(8005),
    [anon_sym_PLUS] = ACTIONS(8005),
    [anon_sym_STAR] = ACTIONS(8005),
    [anon_sym_SLASH] = ACTIONS(8005),
    [anon_sym_PERCENT] = ACTIONS(8005),
    [anon_sym_PIPE_PIPE] = ACTIONS(8007),
    [anon_sym_AMP_AMP] = ACTIONS(8007),
    [anon_sym_PIPE] = ACTIONS(8005),
    [anon_sym_CARET] = ACTIONS(8005),
    [anon_sym_AMP] = ACTIONS(8005),
    [anon_sym_EQ_EQ] = ACTIONS(8007),
    [anon_sym_BANG_EQ] = ACTIONS(8007),
    [anon_sym_GT] = ACTIONS(8005),
    [anon_sym_GT_EQ] = ACTIONS(8007),
    [anon_sym_LT_EQ] = ACTIONS(8005),
    [anon_sym_LT] = ACTIONS(8005),
    [anon_sym_LT_LT] = ACTIONS(8005),
    [anon_sym_GT_GT] = ACTIONS(8005),
    [anon_sym_COLON] = ACTIONS(8007),
    [anon_sym_SEMI] = ACTIONS(8007),
    [anon_sym___attribute__] = ACTIONS(8005),
    [anon_sym___attribute] = ACTIONS(8005),
    [anon_sym_RBRACE] = ACTIONS(8007),
    [anon_sym_LBRACK] = ACTIONS(8007),
    [anon_sym_RBRACK] = ACTIONS(8007),
    [anon_sym_EQ] = ACTIONS(8005),
    [anon_sym_QMARK] = ACTIONS(8007),
    [anon_sym_STAR_EQ] = ACTIONS(8007),
    [anon_sym_SLASH_EQ] = ACTIONS(8007),
    [anon_sym_PERCENT_EQ] = ACTIONS(8007),
    [anon_sym_PLUS_EQ] = ACTIONS(8007),
    [anon_sym_DASH_EQ] = ACTIONS(8007),
    [anon_sym_LT_LT_EQ] = ACTIONS(8007),
    [anon_sym_GT_GT_EQ] = ACTIONS(8007),
    [anon_sym_AMP_EQ] = ACTIONS(8007),
    [anon_sym_CARET_EQ] = ACTIONS(8007),
    [anon_sym_PIPE_EQ] = ACTIONS(8007),
    [anon_sym_and_eq] = ACTIONS(8005),
    [anon_sym_or_eq] = ACTIONS(8005),
    [anon_sym_xor_eq] = ACTIONS(8005),
    [anon_sym_LT_EQ_GT] = ACTIONS(8007),
    [anon_sym_or] = ACTIONS(8005),
    [anon_sym_and] = ACTIONS(8005),
    [anon_sym_bitor] = ACTIONS(8005),
    [anon_sym_xor] = ACTIONS(8005),
    [anon_sym_bitand] = ACTIONS(8005),
    [anon_sym_not_eq] = ACTIONS(8005),
    [anon_sym_is] = ACTIONS(8005),
    [anon_sym_as] = ACTIONS(8005),
    [anon_sym_DASH_DASH] = ACTIONS(8007),
    [anon_sym_PLUS_PLUS] = ACTIONS(8007),
    [anon_sym_DOT] = ACTIONS(8005),
    [anon_sym_DOT_STAR] = ACTIONS(8007),
    [anon_sym_DASH_GT] = ACTIONS(8007),
    [sym_comment] = ACTIONS(3),
  },
  [3443] = {
    [sym_identifier] = ACTIONS(7158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7160),
    [anon_sym_COMMA] = ACTIONS(7160),
    [anon_sym_LPAREN2] = ACTIONS(7160),
    [anon_sym_DASH] = ACTIONS(7158),
    [anon_sym_PLUS] = ACTIONS(7158),
    [anon_sym_STAR] = ACTIONS(7158),
    [anon_sym_SLASH] = ACTIONS(7158),
    [anon_sym_PERCENT] = ACTIONS(7158),
    [anon_sym_PIPE_PIPE] = ACTIONS(7160),
    [anon_sym_AMP_AMP] = ACTIONS(7160),
    [anon_sym_PIPE] = ACTIONS(7158),
    [anon_sym_CARET] = ACTIONS(7158),
    [anon_sym_AMP] = ACTIONS(7158),
    [anon_sym_EQ_EQ] = ACTIONS(7160),
    [anon_sym_BANG_EQ] = ACTIONS(7160),
    [anon_sym_GT] = ACTIONS(7158),
    [anon_sym_GT_EQ] = ACTIONS(7158),
    [anon_sym_LT_EQ] = ACTIONS(7158),
    [anon_sym_LT] = ACTIONS(7158),
    [anon_sym_LT_LT] = ACTIONS(7158),
    [anon_sym_GT_GT] = ACTIONS(7158),
    [anon_sym_LBRACK] = ACTIONS(7160),
    [anon_sym_EQ] = ACTIONS(7158),
    [anon_sym_QMARK] = ACTIONS(7160),
    [anon_sym_STAR_EQ] = ACTIONS(7160),
    [anon_sym_SLASH_EQ] = ACTIONS(7160),
    [anon_sym_PERCENT_EQ] = ACTIONS(7160),
    [anon_sym_PLUS_EQ] = ACTIONS(7160),
    [anon_sym_DASH_EQ] = ACTIONS(7160),
    [anon_sym_LT_LT_EQ] = ACTIONS(7160),
    [anon_sym_GT_GT_EQ] = ACTIONS(7158),
    [anon_sym_AMP_EQ] = ACTIONS(7160),
    [anon_sym_CARET_EQ] = ACTIONS(7160),
    [anon_sym_PIPE_EQ] = ACTIONS(7160),
    [anon_sym_and_eq] = ACTIONS(7158),
    [anon_sym_or_eq] = ACTIONS(7158),
    [anon_sym_xor_eq] = ACTIONS(7158),
    [anon_sym_LT_EQ_GT] = ACTIONS(7160),
    [anon_sym_or] = ACTIONS(7158),
    [anon_sym_and] = ACTIONS(7158),
    [anon_sym_bitor] = ACTIONS(7158),
    [anon_sym_xor] = ACTIONS(7158),
    [anon_sym_bitand] = ACTIONS(7158),
    [anon_sym_not_eq] = ACTIONS(7158),
    [anon_sym_is] = ACTIONS(7158),
    [anon_sym_as] = ACTIONS(7158),
    [anon_sym_DASH_DASH] = ACTIONS(7160),
    [anon_sym_PLUS_PLUS] = ACTIONS(7160),
    [anon_sym_DOT] = ACTIONS(7158),
    [anon_sym_DOT_STAR] = ACTIONS(7160),
    [anon_sym_DASH_GT] = ACTIONS(7160),
    [anon_sym_L_DQUOTE] = ACTIONS(7160),
    [anon_sym_u_DQUOTE] = ACTIONS(7160),
    [anon_sym_U_DQUOTE] = ACTIONS(7160),
    [anon_sym_u8_DQUOTE] = ACTIONS(7160),
    [anon_sym_DQUOTE] = ACTIONS(7160),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(7160),
    [anon_sym_R_DQUOTE] = ACTIONS(7160),
    [anon_sym_LR_DQUOTE] = ACTIONS(7160),
    [anon_sym_uR_DQUOTE] = ACTIONS(7160),
    [anon_sym_UR_DQUOTE] = ACTIONS(7160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7160),
    [sym_literal_suffix] = ACTIONS(7158),
  },
  [3444] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7290),
    [anon_sym_COMMA] = ACTIONS(7290),
    [anon_sym_RPAREN] = ACTIONS(7290),
    [anon_sym_LPAREN2] = ACTIONS(7290),
    [anon_sym_DASH] = ACTIONS(7288),
    [anon_sym_PLUS] = ACTIONS(7288),
    [anon_sym_STAR] = ACTIONS(7288),
    [anon_sym_SLASH] = ACTIONS(7288),
    [anon_sym_PERCENT] = ACTIONS(7288),
    [anon_sym_PIPE_PIPE] = ACTIONS(7290),
    [anon_sym_AMP_AMP] = ACTIONS(7290),
    [anon_sym_PIPE] = ACTIONS(7288),
    [anon_sym_CARET] = ACTIONS(7288),
    [anon_sym_AMP] = ACTIONS(7288),
    [anon_sym_EQ_EQ] = ACTIONS(7290),
    [anon_sym_BANG_EQ] = ACTIONS(7290),
    [anon_sym_GT] = ACTIONS(7288),
    [anon_sym_GT_EQ] = ACTIONS(7290),
    [anon_sym_LT_EQ] = ACTIONS(7288),
    [anon_sym_LT] = ACTIONS(7288),
    [anon_sym_LT_LT] = ACTIONS(7288),
    [anon_sym_GT_GT] = ACTIONS(7288),
    [anon_sym_LBRACK] = ACTIONS(7290),
    [anon_sym_EQ] = ACTIONS(7288),
    [anon_sym_QMARK] = ACTIONS(7290),
    [anon_sym_STAR_EQ] = ACTIONS(7290),
    [anon_sym_SLASH_EQ] = ACTIONS(7290),
    [anon_sym_PERCENT_EQ] = ACTIONS(7290),
    [anon_sym_PLUS_EQ] = ACTIONS(7290),
    [anon_sym_DASH_EQ] = ACTIONS(7290),
    [anon_sym_LT_LT_EQ] = ACTIONS(7290),
    [anon_sym_GT_GT_EQ] = ACTIONS(7290),
    [anon_sym_AMP_EQ] = ACTIONS(7290),
    [anon_sym_CARET_EQ] = ACTIONS(7290),
    [anon_sym_PIPE_EQ] = ACTIONS(7290),
    [anon_sym_and_eq] = ACTIONS(7288),
    [anon_sym_or_eq] = ACTIONS(7288),
    [anon_sym_xor_eq] = ACTIONS(7288),
    [anon_sym_LT_EQ_GT] = ACTIONS(7290),
    [anon_sym_or] = ACTIONS(7288),
    [anon_sym_and] = ACTIONS(7288),
    [anon_sym_bitor] = ACTIONS(7288),
    [anon_sym_xor] = ACTIONS(7288),
    [anon_sym_bitand] = ACTIONS(7288),
    [anon_sym_not_eq] = ACTIONS(7288),
    [anon_sym_is] = ACTIONS(7288),
    [anon_sym_as] = ACTIONS(7288),
    [anon_sym_DASH_DASH] = ACTIONS(7290),
    [anon_sym_PLUS_PLUS] = ACTIONS(7290),
    [anon_sym_DOT] = ACTIONS(7288),
    [anon_sym_DOT_STAR] = ACTIONS(7290),
    [anon_sym_DASH_GT] = ACTIONS(7288),
    [anon_sym_L_DQUOTE] = ACTIONS(7290),
    [anon_sym_u_DQUOTE] = ACTIONS(7290),
    [anon_sym_U_DQUOTE] = ACTIONS(7290),
    [anon_sym_u8_DQUOTE] = ACTIONS(7290),
    [anon_sym_DQUOTE] = ACTIONS(7290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(7290),
    [anon_sym_LR_DQUOTE] = ACTIONS(7290),
    [anon_sym_uR_DQUOTE] = ACTIONS(7290),
    [anon_sym_UR_DQUOTE] = ACTIONS(7290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7290),
    [anon_sym_DASH_GT_STAR] = ACTIONS(7290),
    [sym_literal_suffix] = ACTIONS(7288),
  },
  [3445] = {
    [sym_identifier] = ACTIONS(2181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_RPAREN] = ACTIONS(2170),
    [aux_sym_preproc_if_token2] = ACTIONS(2170),
    [aux_sym_preproc_else_token1] = ACTIONS(2170),
    [aux_sym_preproc_elif_token1] = ACTIONS(2181),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2170),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2170),
    [anon_sym_LPAREN2] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2181),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_PERCENT] = ACTIONS(2181),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE] = ACTIONS(2181),
    [anon_sym_CARET] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2181),
    [anon_sym_EQ_EQ] = ACTIONS(2170),
    [anon_sym_BANG_EQ] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2181),
    [anon_sym_GT_EQ] = ACTIONS(2170),
    [anon_sym_LT_EQ] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(2181),
    [anon_sym_LT_LT] = ACTIONS(2181),
    [anon_sym_GT_GT] = ACTIONS(2181),
    [anon_sym_COLON] = ACTIONS(2170),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym___attribute__] = ACTIONS(2181),
    [anon_sym___attribute] = ACTIONS(2181),
    [anon_sym_RBRACE] = ACTIONS(2170),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_RBRACK] = ACTIONS(2170),
    [anon_sym_EQ] = ACTIONS(2181),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_STAR_EQ] = ACTIONS(2170),
    [anon_sym_SLASH_EQ] = ACTIONS(2170),
    [anon_sym_PERCENT_EQ] = ACTIONS(2170),
    [anon_sym_PLUS_EQ] = ACTIONS(2170),
    [anon_sym_DASH_EQ] = ACTIONS(2170),
    [anon_sym_LT_LT_EQ] = ACTIONS(2170),
    [anon_sym_GT_GT_EQ] = ACTIONS(2170),
    [anon_sym_AMP_EQ] = ACTIONS(2170),
    [anon_sym_CARET_EQ] = ACTIONS(2170),
    [anon_sym_PIPE_EQ] = ACTIONS(2170),
    [anon_sym_and_eq] = ACTIONS(2181),
    [anon_sym_or_eq] = ACTIONS(2181),
    [anon_sym_xor_eq] = ACTIONS(2181),
    [anon_sym_LT_EQ_GT] = ACTIONS(2170),
    [anon_sym_or] = ACTIONS(2181),
    [anon_sym_and] = ACTIONS(2181),
    [anon_sym_bitor] = ACTIONS(2181),
    [anon_sym_xor] = ACTIONS(2181),
    [anon_sym_bitand] = ACTIONS(2181),
    [anon_sym_not_eq] = ACTIONS(2181),
    [anon_sym_is] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_DOT_STAR] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [sym_comment] = ACTIONS(3),
  },
  [3446] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4100),
    [anon_sym_COMMA] = ACTIONS(4100),
    [anon_sym_RPAREN] = ACTIONS(4100),
    [anon_sym_LPAREN2] = ACTIONS(4100),
    [anon_sym_DASH] = ACTIONS(4102),
    [anon_sym_PLUS] = ACTIONS(4102),
    [anon_sym_STAR] = ACTIONS(4102),
    [anon_sym_SLASH] = ACTIONS(4102),
    [anon_sym_PERCENT] = ACTIONS(4102),
    [anon_sym_PIPE_PIPE] = ACTIONS(4100),
    [anon_sym_AMP_AMP] = ACTIONS(4100),
    [anon_sym_PIPE] = ACTIONS(4102),
    [anon_sym_CARET] = ACTIONS(4102),
    [anon_sym_AMP] = ACTIONS(4102),
    [anon_sym_EQ_EQ] = ACTIONS(4100),
    [anon_sym_BANG_EQ] = ACTIONS(4100),
    [anon_sym_GT] = ACTIONS(4102),
    [anon_sym_GT_EQ] = ACTIONS(4100),
    [anon_sym_LT_EQ] = ACTIONS(4102),
    [anon_sym_LT] = ACTIONS(4102),
    [anon_sym_LT_LT] = ACTIONS(4102),
    [anon_sym_GT_GT] = ACTIONS(4102),
    [anon_sym___attribute__] = ACTIONS(4100),
    [anon_sym___attribute] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(4100),
    [anon_sym_signed] = ACTIONS(7889),
    [anon_sym_unsigned] = ACTIONS(7889),
    [anon_sym_long] = ACTIONS(7889),
    [anon_sym_short] = ACTIONS(7889),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [anon_sym_EQ] = ACTIONS(4102),
    [anon_sym_QMARK] = ACTIONS(4100),
    [anon_sym_STAR_EQ] = ACTIONS(4100),
    [anon_sym_SLASH_EQ] = ACTIONS(4100),
    [anon_sym_PERCENT_EQ] = ACTIONS(4100),
    [anon_sym_PLUS_EQ] = ACTIONS(4100),
    [anon_sym_DASH_EQ] = ACTIONS(4100),
    [anon_sym_LT_LT_EQ] = ACTIONS(4100),
    [anon_sym_GT_GT_EQ] = ACTIONS(4100),
    [anon_sym_AMP_EQ] = ACTIONS(4100),
    [anon_sym_CARET_EQ] = ACTIONS(4100),
    [anon_sym_PIPE_EQ] = ACTIONS(4100),
    [anon_sym_and_eq] = ACTIONS(4100),
    [anon_sym_or_eq] = ACTIONS(4100),
    [anon_sym_xor_eq] = ACTIONS(4100),
    [anon_sym_LT_EQ_GT] = ACTIONS(4100),
    [anon_sym_or] = ACTIONS(4102),
    [anon_sym_and] = ACTIONS(4102),
    [anon_sym_bitor] = ACTIONS(4100),
    [anon_sym_xor] = ACTIONS(4102),
    [anon_sym_bitand] = ACTIONS(4100),
    [anon_sym_not_eq] = ACTIONS(4100),
    [anon_sym_is] = ACTIONS(4100),
    [anon_sym_as] = ACTIONS(4100),
    [anon_sym_DASH_DASH] = ACTIONS(4100),
    [anon_sym_PLUS_PLUS] = ACTIONS(4100),
    [anon_sym_DOT] = ACTIONS(4102),
    [anon_sym_DOT_STAR] = ACTIONS(4100),
    [anon_sym_DASH_GT] = ACTIONS(4102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4100),
    [anon_sym_let] = ACTIONS(4100),
    [anon_sym_This] = ACTIONS(4100),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4100),
  },
  [3447] = {
    [sym_identifier] = ACTIONS(8009),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8011),
    [anon_sym_COMMA] = ACTIONS(8011),
    [anon_sym_RPAREN] = ACTIONS(8011),
    [aux_sym_preproc_if_token2] = ACTIONS(8011),
    [aux_sym_preproc_else_token1] = ACTIONS(8011),
    [aux_sym_preproc_elif_token1] = ACTIONS(8009),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(8011),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(8011),
    [anon_sym_LPAREN2] = ACTIONS(8011),
    [anon_sym_DASH] = ACTIONS(8009),
    [anon_sym_PLUS] = ACTIONS(8009),
    [anon_sym_STAR] = ACTIONS(8009),
    [anon_sym_SLASH] = ACTIONS(8009),
    [anon_sym_PERCENT] = ACTIONS(8009),
    [anon_sym_PIPE_PIPE] = ACTIONS(8011),
    [anon_sym_AMP_AMP] = ACTIONS(8011),
    [anon_sym_PIPE] = ACTIONS(8009),
    [anon_sym_CARET] = ACTIONS(8009),
    [anon_sym_AMP] = ACTIONS(8009),
    [anon_sym_EQ_EQ] = ACTIONS(8011),
    [anon_sym_BANG_EQ] = ACTIONS(8011),
    [anon_sym_GT] = ACTIONS(8009),
    [anon_sym_GT_EQ] = ACTIONS(8011),
    [anon_sym_LT_EQ] = ACTIONS(8009),
    [anon_sym_LT] = ACTIONS(8009),
    [anon_sym_LT_LT] = ACTIONS(8009),
    [anon_sym_GT_GT] = ACTIONS(8009),
    [anon_sym_COLON] = ACTIONS(8011),
    [anon_sym_SEMI] = ACTIONS(8011),
    [anon_sym___attribute__] = ACTIONS(8009),
    [anon_sym___attribute] = ACTIONS(8009),
    [anon_sym_RBRACE] = ACTIONS(8011),
    [anon_sym_LBRACK] = ACTIONS(8011),
    [anon_sym_RBRACK] = ACTIONS(8011),
    [anon_sym_EQ] = ACTIONS(8009),
    [anon_sym_QMARK] = ACTIONS(8011),
    [anon_sym_STAR_EQ] = ACTIONS(8011),
    [anon_sym_SLASH_EQ] = ACTIONS(8011),
    [anon_sym_PERCENT_EQ] = ACTIONS(8011),
    [anon_sym_PLUS_EQ] = ACTIONS(8011),
    [anon_sym_DASH_EQ] = ACTIONS(8011),
    [anon_sym_LT_LT_EQ] = ACTIONS(8011),
    [anon_sym_GT_GT_EQ] = ACTIONS(8011),
    [anon_sym_AMP_EQ] = ACTIONS(8011),
    [anon_sym_CARET_EQ] = ACTIONS(8011),
    [anon_sym_PIPE_EQ] = ACTIONS(8011),
    [anon_sym_and_eq] = ACTIONS(8009),
    [anon_sym_or_eq] = ACTIONS(8009),
    [anon_sym_xor_eq] = ACTIONS(8009),
    [anon_sym_LT_EQ_GT] = ACTIONS(8011),
    [anon_sym_or] = ACTIONS(8009),
    [anon_sym_and] = ACTIONS(8009),
    [anon_sym_bitor] = ACTIONS(8009),
    [anon_sym_xor] = ACTIONS(8009),
    [anon_sym_bitand] = ACTIONS(8009),
    [anon_sym_not_eq] = ACTIONS(8009),
    [anon_sym_is] = ACTIONS(8009),
    [anon_sym_as] = ACTIONS(8009),
    [anon_sym_DASH_DASH] = ACTIONS(8011),
    [anon_sym_PLUS_PLUS] = ACTIONS(8011),
    [anon_sym_DOT] = ACTIONS(8009),
    [anon_sym_DOT_STAR] = ACTIONS(8011),
    [anon_sym_DASH_GT] = ACTIONS(8011),
    [sym_comment] = ACTIONS(3),
  },
  [3448] = {
    [sym_identifier] = ACTIONS(8013),
    [anon_sym_LPAREN2] = ACTIONS(8015),
    [anon_sym_TILDE] = ACTIONS(8017),
    [anon_sym_STAR] = ACTIONS(8017),
    [anon_sym_AMP_AMP] = ACTIONS(8017),
    [anon_sym_AMP] = ACTIONS(8013),
    [anon_sym___extension__] = ACTIONS(8013),
    [anon_sym_in] = ACTIONS(8013),
    [anon_sym_out] = ACTIONS(8013),
    [anon_sym_inout] = ACTIONS(8013),
    [anon_sym_virtual] = ACTIONS(8013),
    [anon_sym_extern] = ACTIONS(8013),
    [anon_sym___attribute__] = ACTIONS(8013),
    [anon_sym___attribute] = ACTIONS(8013),
    [anon_sym_COLON_COLON] = ACTIONS(8017),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(8017),
    [anon_sym___declspec] = ACTIONS(8013),
    [anon_sym___based] = ACTIONS(8013),
    [anon_sym_LBRACK] = ACTIONS(8013),
    [anon_sym_static] = ACTIONS(8013),
    [anon_sym_register] = ACTIONS(8013),
    [anon_sym_inline] = ACTIONS(8013),
    [anon_sym___inline] = ACTIONS(8013),
    [anon_sym___inline__] = ACTIONS(8013),
    [anon_sym___forceinline] = ACTIONS(8013),
    [anon_sym_thread_local] = ACTIONS(8013),
    [anon_sym___thread] = ACTIONS(8013),
    [anon_sym_const] = ACTIONS(8013),
    [anon_sym_constexpr] = ACTIONS(8013),
    [anon_sym_volatile] = ACTIONS(8013),
    [anon_sym_restrict] = ACTIONS(8013),
    [anon_sym___restrict__] = ACTIONS(8013),
    [anon_sym__Atomic] = ACTIONS(8013),
    [anon_sym__Noreturn] = ACTIONS(8013),
    [anon_sym_noreturn] = ACTIONS(8013),
    [anon_sym__Nonnull] = ACTIONS(8013),
    [anon_sym_mutable] = ACTIONS(8013),
    [anon_sym_constinit] = ACTIONS(8013),
    [anon_sym_consteval] = ACTIONS(8013),
    [anon_sym_alignas] = ACTIONS(8013),
    [anon_sym__Alignas] = ACTIONS(8013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(8013),
    [anon_sym_explicit] = ACTIONS(8013),
    [anon_sym_template] = ACTIONS(8013),
    [anon_sym_operator] = ACTIONS(8013),
    [anon_sym_precise] = ACTIONS(8013),
    [anon_sym_shared] = ACTIONS(8013),
    [anon_sym_groupshared] = ACTIONS(8013),
    [anon_sym_uniform] = ACTIONS(8013),
    [anon_sym_row_major] = ACTIONS(8013),
    [anon_sym_column_major] = ACTIONS(8013),
    [anon_sym_globallycoherent] = ACTIONS(8013),
    [anon_sym_centroid] = ACTIONS(8013),
    [anon_sym_noperspective] = ACTIONS(8013),
    [anon_sym_nointerpolation] = ACTIONS(8013),
    [anon_sym_sample] = ACTIONS(8013),
    [anon_sym_linear] = ACTIONS(8013),
    [anon_sym_snorm] = ACTIONS(8013),
    [anon_sym_unorm] = ACTIONS(8013),
    [anon_sym_point] = ACTIONS(8013),
    [anon_sym_line] = ACTIONS(8013),
    [anon_sym_triangleadj] = ACTIONS(8013),
    [anon_sym_lineadj] = ACTIONS(8013),
    [anon_sym_triangle] = ACTIONS(8013),
  },
  [3449] = {
    [sym_identifier] = ACTIONS(8019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8021),
    [anon_sym_COMMA] = ACTIONS(8021),
    [anon_sym_RPAREN] = ACTIONS(8021),
    [aux_sym_preproc_if_token2] = ACTIONS(8021),
    [aux_sym_preproc_else_token1] = ACTIONS(8021),
    [aux_sym_preproc_elif_token1] = ACTIONS(8019),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(8021),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(8021),
    [anon_sym_LPAREN2] = ACTIONS(8021),
    [anon_sym_DASH] = ACTIONS(8019),
    [anon_sym_PLUS] = ACTIONS(8019),
    [anon_sym_STAR] = ACTIONS(8019),
    [anon_sym_SLASH] = ACTIONS(8019),
    [anon_sym_PERCENT] = ACTIONS(8019),
    [anon_sym_PIPE_PIPE] = ACTIONS(8021),
    [anon_sym_AMP_AMP] = ACTIONS(8021),
    [anon_sym_PIPE] = ACTIONS(8019),
    [anon_sym_CARET] = ACTIONS(8019),
    [anon_sym_AMP] = ACTIONS(8019),
    [anon_sym_EQ_EQ] = ACTIONS(8021),
    [anon_sym_BANG_EQ] = ACTIONS(8021),
    [anon_sym_GT] = ACTIONS(8019),
    [anon_sym_GT_EQ] = ACTIONS(8021),
    [anon_sym_LT_EQ] = ACTIONS(8019),
    [anon_sym_LT] = ACTIONS(8019),
    [anon_sym_LT_LT] = ACTIONS(8019),
    [anon_sym_GT_GT] = ACTIONS(8019),
    [anon_sym_COLON] = ACTIONS(8021),
    [anon_sym_SEMI] = ACTIONS(8021),
    [anon_sym___attribute__] = ACTIONS(8019),
    [anon_sym___attribute] = ACTIONS(8019),
    [anon_sym_RBRACE] = ACTIONS(8021),
    [anon_sym_LBRACK] = ACTIONS(8021),
    [anon_sym_RBRACK] = ACTIONS(8021),
    [anon_sym_EQ] = ACTIONS(8019),
    [anon_sym_QMARK] = ACTIONS(8021),
    [anon_sym_STAR_EQ] = ACTIONS(8021),
    [anon_sym_SLASH_EQ] = ACTIONS(8021),
    [anon_sym_PERCENT_EQ] = ACTIONS(8021),
    [anon_sym_PLUS_EQ] = ACTIONS(8021),
    [anon_sym_DASH_EQ] = ACTIONS(8021),
    [anon_sym_LT_LT_EQ] = ACTIONS(8021),
    [anon_sym_GT_GT_EQ] = ACTIONS(8021),
    [anon_sym_AMP_EQ] = ACTIONS(8021),
    [anon_sym_CARET_EQ] = ACTIONS(8021),
    [anon_sym_PIPE_EQ] = ACTIONS(8021),
    [anon_sym_and_eq] = ACTIONS(8019),
    [anon_sym_or_eq] = ACTIONS(8019),
    [anon_sym_xor_eq] = ACTIONS(8019),
    [anon_sym_LT_EQ_GT] = ACTIONS(8021),
    [anon_sym_or] = ACTIONS(8019),
    [anon_sym_and] = ACTIONS(8019),
    [anon_sym_bitor] = ACTIONS(8019),
    [anon_sym_xor] = ACTIONS(8019),
    [anon_sym_bitand] = ACTIONS(8019),
    [anon_sym_not_eq] = ACTIONS(8019),
    [anon_sym_is] = ACTIONS(8019),
    [anon_sym_as] = ACTIONS(8019),
    [anon_sym_DASH_DASH] = ACTIONS(8021),
    [anon_sym_PLUS_PLUS] = ACTIONS(8021),
    [anon_sym_DOT] = ACTIONS(8019),
    [anon_sym_DOT_STAR] = ACTIONS(8021),
    [anon_sym_DASH_GT] = ACTIONS(8021),
    [sym_comment] = ACTIONS(3),
  },
  [3450] = {
    [sym_identifier] = ACTIONS(8023),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8025),
    [anon_sym_COMMA] = ACTIONS(8025),
    [anon_sym_RPAREN] = ACTIONS(8025),
    [aux_sym_preproc_if_token2] = ACTIONS(8025),
    [aux_sym_preproc_else_token1] = ACTIONS(8025),
    [aux_sym_preproc_elif_token1] = ACTIONS(8023),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(8025),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(8025),
    [anon_sym_LPAREN2] = ACTIONS(8025),
    [anon_sym_DASH] = ACTIONS(8023),
    [anon_sym_PLUS] = ACTIONS(8023),
    [anon_sym_STAR] = ACTIONS(8023),
    [anon_sym_SLASH] = ACTIONS(8023),
    [anon_sym_PERCENT] = ACTIONS(8023),
    [anon_sym_PIPE_PIPE] = ACTIONS(8025),
    [anon_sym_AMP_AMP] = ACTIONS(8025),
    [anon_sym_PIPE] = ACTIONS(8023),
    [anon_sym_CARET] = ACTIONS(8023),
    [anon_sym_AMP] = ACTIONS(8023),
    [anon_sym_EQ_EQ] = ACTIONS(8025),
    [anon_sym_BANG_EQ] = ACTIONS(8025),
    [anon_sym_GT] = ACTIONS(8023),
    [anon_sym_GT_EQ] = ACTIONS(8025),
    [anon_sym_LT_EQ] = ACTIONS(8023),
    [anon_sym_LT] = ACTIONS(8023),
    [anon_sym_LT_LT] = ACTIONS(8023),
    [anon_sym_GT_GT] = ACTIONS(8023),
    [anon_sym_COLON] = ACTIONS(8025),
    [anon_sym_SEMI] = ACTIONS(8025),
    [anon_sym___attribute__] = ACTIONS(8023),
    [anon_sym___attribute] = ACTIONS(8023),
    [anon_sym_RBRACE] = ACTIONS(8025),
    [anon_sym_LBRACK] = ACTIONS(8025),
    [anon_sym_RBRACK] = ACTIONS(8025),
    [anon_sym_EQ] = ACTIONS(8023),
    [anon_sym_QMARK] = ACTIONS(8025),
    [anon_sym_STAR_EQ] = ACTIONS(8025),
    [anon_sym_SLASH_EQ] = ACTIONS(8025),
    [anon_sym_PERCENT_EQ] = ACTIONS(8025),
    [anon_sym_PLUS_EQ] = ACTIONS(8025),
    [anon_sym_DASH_EQ] = ACTIONS(8025),
    [anon_sym_LT_LT_EQ] = ACTIONS(8025),
    [anon_sym_GT_GT_EQ] = ACTIONS(8025),
    [anon_sym_AMP_EQ] = ACTIONS(8025),
    [anon_sym_CARET_EQ] = ACTIONS(8025),
    [anon_sym_PIPE_EQ] = ACTIONS(8025),
    [anon_sym_and_eq] = ACTIONS(8023),
    [anon_sym_or_eq] = ACTIONS(8023),
    [anon_sym_xor_eq] = ACTIONS(8023),
    [anon_sym_LT_EQ_GT] = ACTIONS(8025),
    [anon_sym_or] = ACTIONS(8023),
    [anon_sym_and] = ACTIONS(8023),
    [anon_sym_bitor] = ACTIONS(8023),
    [anon_sym_xor] = ACTIONS(8023),
    [anon_sym_bitand] = ACTIONS(8023),
    [anon_sym_not_eq] = ACTIONS(8023),
    [anon_sym_is] = ACTIONS(8023),
    [anon_sym_as] = ACTIONS(8023),
    [anon_sym_DASH_DASH] = ACTIONS(8025),
    [anon_sym_PLUS_PLUS] = ACTIONS(8025),
    [anon_sym_DOT] = ACTIONS(8023),
    [anon_sym_DOT_STAR] = ACTIONS(8025),
    [anon_sym_DASH_GT] = ACTIONS(8025),
    [sym_comment] = ACTIONS(3),
  },
  [3451] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4113),
    [anon_sym_COMMA] = ACTIONS(4113),
    [anon_sym_RPAREN] = ACTIONS(4113),
    [anon_sym_LPAREN2] = ACTIONS(4113),
    [anon_sym_DASH] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4111),
    [anon_sym_STAR] = ACTIONS(4111),
    [anon_sym_SLASH] = ACTIONS(4111),
    [anon_sym_PERCENT] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4111),
    [anon_sym_CARET] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4111),
    [anon_sym_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4111),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym___attribute__] = ACTIONS(4113),
    [anon_sym___attribute] = ACTIONS(4111),
    [anon_sym_LBRACE] = ACTIONS(4113),
    [anon_sym_signed] = ACTIONS(8027),
    [anon_sym_unsigned] = ACTIONS(8027),
    [anon_sym_long] = ACTIONS(8027),
    [anon_sym_short] = ACTIONS(8027),
    [anon_sym_LBRACK] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(4111),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_STAR_EQ] = ACTIONS(4113),
    [anon_sym_SLASH_EQ] = ACTIONS(4113),
    [anon_sym_PERCENT_EQ] = ACTIONS(4113),
    [anon_sym_PLUS_EQ] = ACTIONS(4113),
    [anon_sym_DASH_EQ] = ACTIONS(4113),
    [anon_sym_LT_LT_EQ] = ACTIONS(4113),
    [anon_sym_GT_GT_EQ] = ACTIONS(4113),
    [anon_sym_AMP_EQ] = ACTIONS(4113),
    [anon_sym_CARET_EQ] = ACTIONS(4113),
    [anon_sym_PIPE_EQ] = ACTIONS(4113),
    [anon_sym_and_eq] = ACTIONS(4113),
    [anon_sym_or_eq] = ACTIONS(4113),
    [anon_sym_xor_eq] = ACTIONS(4113),
    [anon_sym_LT_EQ_GT] = ACTIONS(4113),
    [anon_sym_or] = ACTIONS(4111),
    [anon_sym_and] = ACTIONS(4111),
    [anon_sym_bitor] = ACTIONS(4113),
    [anon_sym_xor] = ACTIONS(4111),
    [anon_sym_bitand] = ACTIONS(4113),
    [anon_sym_not_eq] = ACTIONS(4113),
    [anon_sym_is] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(4113),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(4111),
    [anon_sym_DOT_STAR] = ACTIONS(4113),
    [anon_sym_DASH_GT] = ACTIONS(4111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4113),
    [anon_sym_let] = ACTIONS(4113),
    [anon_sym_This] = ACTIONS(4113),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4113),
  },
  [3452] = {
    [sym_identifier] = ACTIONS(6302),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6304),
    [anon_sym_COMMA] = ACTIONS(6304),
    [anon_sym_RPAREN] = ACTIONS(6304),
    [aux_sym_preproc_if_token2] = ACTIONS(6304),
    [aux_sym_preproc_else_token1] = ACTIONS(6304),
    [aux_sym_preproc_elif_token1] = ACTIONS(6302),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6304),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6304),
    [anon_sym_LPAREN2] = ACTIONS(6304),
    [anon_sym_DASH] = ACTIONS(6302),
    [anon_sym_PLUS] = ACTIONS(6302),
    [anon_sym_STAR] = ACTIONS(6302),
    [anon_sym_SLASH] = ACTIONS(6302),
    [anon_sym_PERCENT] = ACTIONS(6302),
    [anon_sym_PIPE_PIPE] = ACTIONS(6304),
    [anon_sym_AMP_AMP] = ACTIONS(6304),
    [anon_sym_PIPE] = ACTIONS(6302),
    [anon_sym_CARET] = ACTIONS(6302),
    [anon_sym_AMP] = ACTIONS(6302),
    [anon_sym_EQ_EQ] = ACTIONS(6304),
    [anon_sym_BANG_EQ] = ACTIONS(6304),
    [anon_sym_GT] = ACTIONS(6302),
    [anon_sym_GT_EQ] = ACTIONS(6304),
    [anon_sym_LT_EQ] = ACTIONS(6302),
    [anon_sym_LT] = ACTIONS(6302),
    [anon_sym_LT_LT] = ACTIONS(6302),
    [anon_sym_GT_GT] = ACTIONS(6302),
    [anon_sym_COLON] = ACTIONS(6304),
    [anon_sym_SEMI] = ACTIONS(6304),
    [anon_sym___attribute__] = ACTIONS(6302),
    [anon_sym___attribute] = ACTIONS(6302),
    [anon_sym_RBRACE] = ACTIONS(6304),
    [anon_sym_LBRACK] = ACTIONS(6304),
    [anon_sym_RBRACK] = ACTIONS(6304),
    [anon_sym_EQ] = ACTIONS(6302),
    [anon_sym_QMARK] = ACTIONS(6304),
    [anon_sym_STAR_EQ] = ACTIONS(6304),
    [anon_sym_SLASH_EQ] = ACTIONS(6304),
    [anon_sym_PERCENT_EQ] = ACTIONS(6304),
    [anon_sym_PLUS_EQ] = ACTIONS(6304),
    [anon_sym_DASH_EQ] = ACTIONS(6304),
    [anon_sym_LT_LT_EQ] = ACTIONS(6304),
    [anon_sym_GT_GT_EQ] = ACTIONS(6304),
    [anon_sym_AMP_EQ] = ACTIONS(6304),
    [anon_sym_CARET_EQ] = ACTIONS(6304),
    [anon_sym_PIPE_EQ] = ACTIONS(6304),
    [anon_sym_and_eq] = ACTIONS(6302),
    [anon_sym_or_eq] = ACTIONS(6302),
    [anon_sym_xor_eq] = ACTIONS(6302),
    [anon_sym_LT_EQ_GT] = ACTIONS(6304),
    [anon_sym_or] = ACTIONS(6302),
    [anon_sym_and] = ACTIONS(6302),
    [anon_sym_bitor] = ACTIONS(6302),
    [anon_sym_xor] = ACTIONS(6302),
    [anon_sym_bitand] = ACTIONS(6302),
    [anon_sym_not_eq] = ACTIONS(6302),
    [anon_sym_is] = ACTIONS(6302),
    [anon_sym_as] = ACTIONS(6302),
    [anon_sym_DASH_DASH] = ACTIONS(6304),
    [anon_sym_PLUS_PLUS] = ACTIONS(6304),
    [anon_sym_DOT] = ACTIONS(6302),
    [anon_sym_DOT_STAR] = ACTIONS(6304),
    [anon_sym_DASH_GT] = ACTIONS(6304),
    [sym_comment] = ACTIONS(3),
  },
  [3453] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4051),
    [anon_sym_COMMA] = ACTIONS(4051),
    [anon_sym_RPAREN] = ACTIONS(4051),
    [anon_sym_LPAREN2] = ACTIONS(4051),
    [anon_sym_DASH] = ACTIONS(4053),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_STAR] = ACTIONS(4053),
    [anon_sym_SLASH] = ACTIONS(4053),
    [anon_sym_PERCENT] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4051),
    [anon_sym_AMP_AMP] = ACTIONS(4051),
    [anon_sym_PIPE] = ACTIONS(4053),
    [anon_sym_CARET] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4053),
    [anon_sym_EQ_EQ] = ACTIONS(4051),
    [anon_sym_BANG_EQ] = ACTIONS(4051),
    [anon_sym_GT] = ACTIONS(4053),
    [anon_sym_GT_EQ] = ACTIONS(4051),
    [anon_sym_LT_EQ] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4053),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym___attribute__] = ACTIONS(4051),
    [anon_sym___attribute] = ACTIONS(4053),
    [anon_sym_LBRACE] = ACTIONS(4051),
    [anon_sym_signed] = ACTIONS(8029),
    [anon_sym_unsigned] = ACTIONS(8029),
    [anon_sym_long] = ACTIONS(8029),
    [anon_sym_short] = ACTIONS(8029),
    [anon_sym_LBRACK] = ACTIONS(4051),
    [anon_sym_EQ] = ACTIONS(4053),
    [anon_sym_QMARK] = ACTIONS(4051),
    [anon_sym_STAR_EQ] = ACTIONS(4051),
    [anon_sym_SLASH_EQ] = ACTIONS(4051),
    [anon_sym_PERCENT_EQ] = ACTIONS(4051),
    [anon_sym_PLUS_EQ] = ACTIONS(4051),
    [anon_sym_DASH_EQ] = ACTIONS(4051),
    [anon_sym_LT_LT_EQ] = ACTIONS(4051),
    [anon_sym_GT_GT_EQ] = ACTIONS(4051),
    [anon_sym_AMP_EQ] = ACTIONS(4051),
    [anon_sym_CARET_EQ] = ACTIONS(4051),
    [anon_sym_PIPE_EQ] = ACTIONS(4051),
    [anon_sym_and_eq] = ACTIONS(4051),
    [anon_sym_or_eq] = ACTIONS(4051),
    [anon_sym_xor_eq] = ACTIONS(4051),
    [anon_sym_LT_EQ_GT] = ACTIONS(4051),
    [anon_sym_or] = ACTIONS(4053),
    [anon_sym_and] = ACTIONS(4053),
    [anon_sym_bitor] = ACTIONS(4051),
    [anon_sym_xor] = ACTIONS(4053),
    [anon_sym_bitand] = ACTIONS(4051),
    [anon_sym_not_eq] = ACTIONS(4051),
    [anon_sym_is] = ACTIONS(4051),
    [anon_sym_as] = ACTIONS(4051),
    [anon_sym_DASH_DASH] = ACTIONS(4051),
    [anon_sym_PLUS_PLUS] = ACTIONS(4051),
    [anon_sym_DOT] = ACTIONS(4053),
    [anon_sym_DOT_STAR] = ACTIONS(4051),
    [anon_sym_DASH_GT] = ACTIONS(4053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4051),
    [anon_sym_let] = ACTIONS(4051),
    [anon_sym_This] = ACTIONS(4051),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4051),
  },
  [3454] = {
    [sym_identifier] = ACTIONS(6128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6130),
    [anon_sym_COMMA] = ACTIONS(6130),
    [anon_sym_RPAREN] = ACTIONS(6130),
    [aux_sym_preproc_if_token2] = ACTIONS(6130),
    [aux_sym_preproc_else_token1] = ACTIONS(6130),
    [aux_sym_preproc_elif_token1] = ACTIONS(6128),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6130),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6130),
    [anon_sym_LPAREN2] = ACTIONS(6130),
    [anon_sym_DASH] = ACTIONS(6128),
    [anon_sym_PLUS] = ACTIONS(6128),
    [anon_sym_STAR] = ACTIONS(6128),
    [anon_sym_SLASH] = ACTIONS(6128),
    [anon_sym_PERCENT] = ACTIONS(6128),
    [anon_sym_PIPE_PIPE] = ACTIONS(6130),
    [anon_sym_AMP_AMP] = ACTIONS(6130),
    [anon_sym_PIPE] = ACTIONS(6128),
    [anon_sym_CARET] = ACTIONS(6128),
    [anon_sym_AMP] = ACTIONS(6128),
    [anon_sym_EQ_EQ] = ACTIONS(6130),
    [anon_sym_BANG_EQ] = ACTIONS(6130),
    [anon_sym_GT] = ACTIONS(6128),
    [anon_sym_GT_EQ] = ACTIONS(6130),
    [anon_sym_LT_EQ] = ACTIONS(6128),
    [anon_sym_LT] = ACTIONS(6128),
    [anon_sym_LT_LT] = ACTIONS(6128),
    [anon_sym_GT_GT] = ACTIONS(6128),
    [anon_sym_COLON] = ACTIONS(6130),
    [anon_sym_SEMI] = ACTIONS(6130),
    [anon_sym___attribute__] = ACTIONS(6128),
    [anon_sym___attribute] = ACTIONS(6128),
    [anon_sym_RBRACE] = ACTIONS(6130),
    [anon_sym_LBRACK] = ACTIONS(6130),
    [anon_sym_RBRACK] = ACTIONS(6130),
    [anon_sym_EQ] = ACTIONS(6128),
    [anon_sym_QMARK] = ACTIONS(6130),
    [anon_sym_STAR_EQ] = ACTIONS(6130),
    [anon_sym_SLASH_EQ] = ACTIONS(6130),
    [anon_sym_PERCENT_EQ] = ACTIONS(6130),
    [anon_sym_PLUS_EQ] = ACTIONS(6130),
    [anon_sym_DASH_EQ] = ACTIONS(6130),
    [anon_sym_LT_LT_EQ] = ACTIONS(6130),
    [anon_sym_GT_GT_EQ] = ACTIONS(6130),
    [anon_sym_AMP_EQ] = ACTIONS(6130),
    [anon_sym_CARET_EQ] = ACTIONS(6130),
    [anon_sym_PIPE_EQ] = ACTIONS(6130),
    [anon_sym_and_eq] = ACTIONS(6128),
    [anon_sym_or_eq] = ACTIONS(6128),
    [anon_sym_xor_eq] = ACTIONS(6128),
    [anon_sym_LT_EQ_GT] = ACTIONS(6130),
    [anon_sym_or] = ACTIONS(6128),
    [anon_sym_and] = ACTIONS(6128),
    [anon_sym_bitor] = ACTIONS(6128),
    [anon_sym_xor] = ACTIONS(6128),
    [anon_sym_bitand] = ACTIONS(6128),
    [anon_sym_not_eq] = ACTIONS(6128),
    [anon_sym_is] = ACTIONS(6128),
    [anon_sym_as] = ACTIONS(6128),
    [anon_sym_DASH_DASH] = ACTIONS(6130),
    [anon_sym_PLUS_PLUS] = ACTIONS(6130),
    [anon_sym_DOT] = ACTIONS(6128),
    [anon_sym_DOT_STAR] = ACTIONS(6130),
    [anon_sym_DASH_GT] = ACTIONS(6130),
    [sym_comment] = ACTIONS(3),
  },
  [3455] = {
    [sym_identifier] = ACTIONS(6136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6138),
    [anon_sym_COMMA] = ACTIONS(6138),
    [anon_sym_RPAREN] = ACTIONS(6138),
    [aux_sym_preproc_if_token2] = ACTIONS(6138),
    [aux_sym_preproc_else_token1] = ACTIONS(6138),
    [aux_sym_preproc_elif_token1] = ACTIONS(6136),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6138),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6138),
    [anon_sym_LPAREN2] = ACTIONS(6138),
    [anon_sym_DASH] = ACTIONS(6136),
    [anon_sym_PLUS] = ACTIONS(6136),
    [anon_sym_STAR] = ACTIONS(6136),
    [anon_sym_SLASH] = ACTIONS(6136),
    [anon_sym_PERCENT] = ACTIONS(6136),
    [anon_sym_PIPE_PIPE] = ACTIONS(6138),
    [anon_sym_AMP_AMP] = ACTIONS(6138),
    [anon_sym_PIPE] = ACTIONS(6136),
    [anon_sym_CARET] = ACTIONS(6136),
    [anon_sym_AMP] = ACTIONS(6136),
    [anon_sym_EQ_EQ] = ACTIONS(6138),
    [anon_sym_BANG_EQ] = ACTIONS(6138),
    [anon_sym_GT] = ACTIONS(6136),
    [anon_sym_GT_EQ] = ACTIONS(6138),
    [anon_sym_LT_EQ] = ACTIONS(6136),
    [anon_sym_LT] = ACTIONS(6136),
    [anon_sym_LT_LT] = ACTIONS(6136),
    [anon_sym_GT_GT] = ACTIONS(6136),
    [anon_sym_COLON] = ACTIONS(6138),
    [anon_sym_SEMI] = ACTIONS(6138),
    [anon_sym___attribute__] = ACTIONS(6136),
    [anon_sym___attribute] = ACTIONS(6136),
    [anon_sym_RBRACE] = ACTIONS(6138),
    [anon_sym_LBRACK] = ACTIONS(6138),
    [anon_sym_RBRACK] = ACTIONS(6138),
    [anon_sym_EQ] = ACTIONS(6136),
    [anon_sym_QMARK] = ACTIONS(6138),
    [anon_sym_STAR_EQ] = ACTIONS(6138),
    [anon_sym_SLASH_EQ] = ACTIONS(6138),
    [anon_sym_PERCENT_EQ] = ACTIONS(6138),
    [anon_sym_PLUS_EQ] = ACTIONS(6138),
    [anon_sym_DASH_EQ] = ACTIONS(6138),
    [anon_sym_LT_LT_EQ] = ACTIONS(6138),
    [anon_sym_GT_GT_EQ] = ACTIONS(6138),
    [anon_sym_AMP_EQ] = ACTIONS(6138),
    [anon_sym_CARET_EQ] = ACTIONS(6138),
    [anon_sym_PIPE_EQ] = ACTIONS(6138),
    [anon_sym_and_eq] = ACTIONS(6136),
    [anon_sym_or_eq] = ACTIONS(6136),
    [anon_sym_xor_eq] = ACTIONS(6136),
    [anon_sym_LT_EQ_GT] = ACTIONS(6138),
    [anon_sym_or] = ACTIONS(6136),
    [anon_sym_and] = ACTIONS(6136),
    [anon_sym_bitor] = ACTIONS(6136),
    [anon_sym_xor] = ACTIONS(6136),
    [anon_sym_bitand] = ACTIONS(6136),
    [anon_sym_not_eq] = ACTIONS(6136),
    [anon_sym_is] = ACTIONS(6136),
    [anon_sym_as] = ACTIONS(6136),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DOT] = ACTIONS(6136),
    [anon_sym_DOT_STAR] = ACTIONS(6138),
    [anon_sym_DASH_GT] = ACTIONS(6138),
    [sym_comment] = ACTIONS(3),
  },
  [3456] = {
    [sym_identifier] = ACTIONS(8031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8033),
    [anon_sym_COMMA] = ACTIONS(8033),
    [anon_sym_RPAREN] = ACTIONS(8033),
    [aux_sym_preproc_if_token2] = ACTIONS(8033),
    [aux_sym_preproc_else_token1] = ACTIONS(8033),
    [aux_sym_preproc_elif_token1] = ACTIONS(8031),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(8033),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(8033),
    [anon_sym_LPAREN2] = ACTIONS(8033),
    [anon_sym_DASH] = ACTIONS(8031),
    [anon_sym_PLUS] = ACTIONS(8031),
    [anon_sym_STAR] = ACTIONS(8031),
    [anon_sym_SLASH] = ACTIONS(8031),
    [anon_sym_PERCENT] = ACTIONS(8031),
    [anon_sym_PIPE_PIPE] = ACTIONS(8033),
    [anon_sym_AMP_AMP] = ACTIONS(8033),
    [anon_sym_PIPE] = ACTIONS(8031),
    [anon_sym_CARET] = ACTIONS(8031),
    [anon_sym_AMP] = ACTIONS(8031),
    [anon_sym_EQ_EQ] = ACTIONS(8033),
    [anon_sym_BANG_EQ] = ACTIONS(8033),
    [anon_sym_GT] = ACTIONS(8031),
    [anon_sym_GT_EQ] = ACTIONS(8033),
    [anon_sym_LT_EQ] = ACTIONS(8031),
    [anon_sym_LT] = ACTIONS(8031),
    [anon_sym_LT_LT] = ACTIONS(8031),
    [anon_sym_GT_GT] = ACTIONS(8031),
    [anon_sym_COLON] = ACTIONS(8033),
    [anon_sym_SEMI] = ACTIONS(8033),
    [anon_sym___attribute__] = ACTIONS(8031),
    [anon_sym___attribute] = ACTIONS(8031),
    [anon_sym_RBRACE] = ACTIONS(8033),
    [anon_sym_LBRACK] = ACTIONS(8033),
    [anon_sym_RBRACK] = ACTIONS(8033),
    [anon_sym_EQ] = ACTIONS(8031),
    [anon_sym_QMARK] = ACTIONS(8033),
    [anon_sym_STAR_EQ] = ACTIONS(8033),
    [anon_sym_SLASH_EQ] = ACTIONS(8033),
    [anon_sym_PERCENT_EQ] = ACTIONS(8033),
    [anon_sym_PLUS_EQ] = ACTIONS(8033),
    [anon_sym_DASH_EQ] = ACTIONS(8033),
    [anon_sym_LT_LT_EQ] = ACTIONS(8033),
    [anon_sym_GT_GT_EQ] = ACTIONS(8033),
    [anon_sym_AMP_EQ] = ACTIONS(8033),
    [anon_sym_CARET_EQ] = ACTIONS(8033),
    [anon_sym_PIPE_EQ] = ACTIONS(8033),
    [anon_sym_and_eq] = ACTIONS(8031),
    [anon_sym_or_eq] = ACTIONS(8031),
    [anon_sym_xor_eq] = ACTIONS(8031),
    [anon_sym_LT_EQ_GT] = ACTIONS(8033),
    [anon_sym_or] = ACTIONS(8031),
    [anon_sym_and] = ACTIONS(8031),
    [anon_sym_bitor] = ACTIONS(8031),
    [anon_sym_xor] = ACTIONS(8031),
    [anon_sym_bitand] = ACTIONS(8031),
    [anon_sym_not_eq] = ACTIONS(8031),
    [anon_sym_is] = ACTIONS(8031),
    [anon_sym_as] = ACTIONS(8031),
    [anon_sym_DASH_DASH] = ACTIONS(8033),
    [anon_sym_PLUS_PLUS] = ACTIONS(8033),
    [anon_sym_DOT] = ACTIONS(8031),
    [anon_sym_DOT_STAR] = ACTIONS(8033),
    [anon_sym_DASH_GT] = ACTIONS(8033),
    [sym_comment] = ACTIONS(3),
  },
  [3457] = {
    [sym_identifier] = ACTIONS(2234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2224),
    [anon_sym_COMMA] = ACTIONS(2224),
    [anon_sym_RPAREN] = ACTIONS(2224),
    [aux_sym_preproc_if_token2] = ACTIONS(2224),
    [aux_sym_preproc_else_token1] = ACTIONS(2224),
    [aux_sym_preproc_elif_token1] = ACTIONS(2234),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2224),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2224),
    [anon_sym_LPAREN2] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_PIPE_PIPE] = ACTIONS(2224),
    [anon_sym_AMP_AMP] = ACTIONS(2224),
    [anon_sym_PIPE] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2234),
    [anon_sym_EQ_EQ] = ACTIONS(2224),
    [anon_sym_BANG_EQ] = ACTIONS(2224),
    [anon_sym_GT] = ACTIONS(2234),
    [anon_sym_GT_EQ] = ACTIONS(2224),
    [anon_sym_LT_EQ] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2234),
    [anon_sym_LT_LT] = ACTIONS(2234),
    [anon_sym_GT_GT] = ACTIONS(2234),
    [anon_sym_COLON] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2234),
    [anon_sym___attribute] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_RBRACK] = ACTIONS(2224),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_QMARK] = ACTIONS(2224),
    [anon_sym_STAR_EQ] = ACTIONS(2224),
    [anon_sym_SLASH_EQ] = ACTIONS(2224),
    [anon_sym_PERCENT_EQ] = ACTIONS(2224),
    [anon_sym_PLUS_EQ] = ACTIONS(2224),
    [anon_sym_DASH_EQ] = ACTIONS(2224),
    [anon_sym_LT_LT_EQ] = ACTIONS(2224),
    [anon_sym_GT_GT_EQ] = ACTIONS(2224),
    [anon_sym_AMP_EQ] = ACTIONS(2224),
    [anon_sym_CARET_EQ] = ACTIONS(2224),
    [anon_sym_PIPE_EQ] = ACTIONS(2224),
    [anon_sym_and_eq] = ACTIONS(2234),
    [anon_sym_or_eq] = ACTIONS(2234),
    [anon_sym_xor_eq] = ACTIONS(2234),
    [anon_sym_LT_EQ_GT] = ACTIONS(2224),
    [anon_sym_or] = ACTIONS(2234),
    [anon_sym_and] = ACTIONS(2234),
    [anon_sym_bitor] = ACTIONS(2234),
    [anon_sym_xor] = ACTIONS(2234),
    [anon_sym_bitand] = ACTIONS(2234),
    [anon_sym_not_eq] = ACTIONS(2234),
    [anon_sym_is] = ACTIONS(2234),
    [anon_sym_as] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2224),
    [anon_sym_PLUS_PLUS] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(2234),
    [anon_sym_DOT_STAR] = ACTIONS(2224),
    [anon_sym_DASH_GT] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
  },
  [3458] = {
    [sym_identifier] = ACTIONS(2234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2224),
    [anon_sym_COMMA] = ACTIONS(2224),
    [anon_sym_RPAREN] = ACTIONS(2224),
    [aux_sym_preproc_if_token2] = ACTIONS(2224),
    [aux_sym_preproc_else_token1] = ACTIONS(2224),
    [aux_sym_preproc_elif_token1] = ACTIONS(2234),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2224),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2224),
    [anon_sym_LPAREN2] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_PIPE_PIPE] = ACTIONS(2224),
    [anon_sym_AMP_AMP] = ACTIONS(2224),
    [anon_sym_PIPE] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2234),
    [anon_sym_EQ_EQ] = ACTIONS(2224),
    [anon_sym_BANG_EQ] = ACTIONS(2224),
    [anon_sym_GT] = ACTIONS(2234),
    [anon_sym_GT_EQ] = ACTIONS(2224),
    [anon_sym_LT_EQ] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2234),
    [anon_sym_LT_LT] = ACTIONS(2234),
    [anon_sym_GT_GT] = ACTIONS(2234),
    [anon_sym_COLON] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2234),
    [anon_sym___attribute] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_RBRACK] = ACTIONS(2224),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_QMARK] = ACTIONS(2224),
    [anon_sym_STAR_EQ] = ACTIONS(2224),
    [anon_sym_SLASH_EQ] = ACTIONS(2224),
    [anon_sym_PERCENT_EQ] = ACTIONS(2224),
    [anon_sym_PLUS_EQ] = ACTIONS(2224),
    [anon_sym_DASH_EQ] = ACTIONS(2224),
    [anon_sym_LT_LT_EQ] = ACTIONS(2224),
    [anon_sym_GT_GT_EQ] = ACTIONS(2224),
    [anon_sym_AMP_EQ] = ACTIONS(2224),
    [anon_sym_CARET_EQ] = ACTIONS(2224),
    [anon_sym_PIPE_EQ] = ACTIONS(2224),
    [anon_sym_and_eq] = ACTIONS(2234),
    [anon_sym_or_eq] = ACTIONS(2234),
    [anon_sym_xor_eq] = ACTIONS(2234),
    [anon_sym_LT_EQ_GT] = ACTIONS(2224),
    [anon_sym_or] = ACTIONS(2234),
    [anon_sym_and] = ACTIONS(2234),
    [anon_sym_bitor] = ACTIONS(2234),
    [anon_sym_xor] = ACTIONS(2234),
    [anon_sym_bitand] = ACTIONS(2234),
    [anon_sym_not_eq] = ACTIONS(2234),
    [anon_sym_is] = ACTIONS(2234),
    [anon_sym_as] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2224),
    [anon_sym_PLUS_PLUS] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(2234),
    [anon_sym_DOT_STAR] = ACTIONS(2224),
    [anon_sym_DASH_GT] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
  },
  [3459] = {
    [sym_identifier] = ACTIONS(8035),
    [anon_sym_LPAREN2] = ACTIONS(8037),
    [anon_sym_TILDE] = ACTIONS(8037),
    [anon_sym_STAR] = ACTIONS(8037),
    [anon_sym_AMP_AMP] = ACTIONS(8037),
    [anon_sym_AMP] = ACTIONS(8035),
    [anon_sym___extension__] = ACTIONS(8035),
    [anon_sym_in] = ACTIONS(8035),
    [anon_sym_out] = ACTIONS(8035),
    [anon_sym_inout] = ACTIONS(8035),
    [anon_sym_virtual] = ACTIONS(8035),
    [anon_sym_extern] = ACTIONS(8035),
    [anon_sym___attribute__] = ACTIONS(8035),
    [anon_sym___attribute] = ACTIONS(8035),
    [anon_sym_COLON_COLON] = ACTIONS(8037),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(8037),
    [anon_sym___declspec] = ACTIONS(8035),
    [anon_sym___based] = ACTIONS(8035),
    [anon_sym_LBRACK] = ACTIONS(8035),
    [anon_sym_static] = ACTIONS(8035),
    [anon_sym_register] = ACTIONS(8035),
    [anon_sym_inline] = ACTIONS(8035),
    [anon_sym___inline] = ACTIONS(8035),
    [anon_sym___inline__] = ACTIONS(8035),
    [anon_sym___forceinline] = ACTIONS(8035),
    [anon_sym_thread_local] = ACTIONS(8035),
    [anon_sym___thread] = ACTIONS(8035),
    [anon_sym_const] = ACTIONS(8035),
    [anon_sym_constexpr] = ACTIONS(8035),
    [anon_sym_volatile] = ACTIONS(8035),
    [anon_sym_restrict] = ACTIONS(8035),
    [anon_sym___restrict__] = ACTIONS(8035),
    [anon_sym__Atomic] = ACTIONS(8035),
    [anon_sym__Noreturn] = ACTIONS(8035),
    [anon_sym_noreturn] = ACTIONS(8035),
    [anon_sym__Nonnull] = ACTIONS(8035),
    [anon_sym_mutable] = ACTIONS(8035),
    [anon_sym_constinit] = ACTIONS(8035),
    [anon_sym_consteval] = ACTIONS(8035),
    [anon_sym_alignas] = ACTIONS(8035),
    [anon_sym__Alignas] = ACTIONS(8035),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(8035),
    [anon_sym_explicit] = ACTIONS(8035),
    [anon_sym_template] = ACTIONS(8035),
    [anon_sym_operator] = ACTIONS(8035),
    [anon_sym_precise] = ACTIONS(8035),
    [anon_sym_shared] = ACTIONS(8035),
    [anon_sym_groupshared] = ACTIONS(8035),
    [anon_sym_uniform] = ACTIONS(8035),
    [anon_sym_row_major] = ACTIONS(8035),
    [anon_sym_column_major] = ACTIONS(8035),
    [anon_sym_globallycoherent] = ACTIONS(8035),
    [anon_sym_centroid] = ACTIONS(8035),
    [anon_sym_noperspective] = ACTIONS(8035),
    [anon_sym_nointerpolation] = ACTIONS(8035),
    [anon_sym_sample] = ACTIONS(8035),
    [anon_sym_linear] = ACTIONS(8035),
    [anon_sym_snorm] = ACTIONS(8035),
    [anon_sym_unorm] = ACTIONS(8035),
    [anon_sym_point] = ACTIONS(8035),
    [anon_sym_line] = ACTIONS(8035),
    [anon_sym_triangleadj] = ACTIONS(8035),
    [anon_sym_lineadj] = ACTIONS(8035),
    [anon_sym_triangle] = ACTIONS(8035),
  },
  [3460] = {
    [sym_identifier] = ACTIONS(2234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2224),
    [anon_sym_COMMA] = ACTIONS(2224),
    [anon_sym_RPAREN] = ACTIONS(2224),
    [aux_sym_preproc_if_token2] = ACTIONS(2224),
    [aux_sym_preproc_else_token1] = ACTIONS(2224),
    [aux_sym_preproc_elif_token1] = ACTIONS(2234),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2224),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2224),
    [anon_sym_LPAREN2] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_PIPE_PIPE] = ACTIONS(2224),
    [anon_sym_AMP_AMP] = ACTIONS(2224),
    [anon_sym_PIPE] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2234),
    [anon_sym_EQ_EQ] = ACTIONS(2224),
    [anon_sym_BANG_EQ] = ACTIONS(2224),
    [anon_sym_GT] = ACTIONS(2234),
    [anon_sym_GT_EQ] = ACTIONS(2224),
    [anon_sym_LT_EQ] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2234),
    [anon_sym_LT_LT] = ACTIONS(2234),
    [anon_sym_GT_GT] = ACTIONS(2234),
    [anon_sym_COLON] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2234),
    [anon_sym___attribute] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_RBRACK] = ACTIONS(2224),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_QMARK] = ACTIONS(2224),
    [anon_sym_STAR_EQ] = ACTIONS(2224),
    [anon_sym_SLASH_EQ] = ACTIONS(2224),
    [anon_sym_PERCENT_EQ] = ACTIONS(2224),
    [anon_sym_PLUS_EQ] = ACTIONS(2224),
    [anon_sym_DASH_EQ] = ACTIONS(2224),
    [anon_sym_LT_LT_EQ] = ACTIONS(2224),
    [anon_sym_GT_GT_EQ] = ACTIONS(2224),
    [anon_sym_AMP_EQ] = ACTIONS(2224),
    [anon_sym_CARET_EQ] = ACTIONS(2224),
    [anon_sym_PIPE_EQ] = ACTIONS(2224),
    [anon_sym_and_eq] = ACTIONS(2234),
    [anon_sym_or_eq] = ACTIONS(2234),
    [anon_sym_xor_eq] = ACTIONS(2234),
    [anon_sym_LT_EQ_GT] = ACTIONS(2224),
    [anon_sym_or] = ACTIONS(2234),
    [anon_sym_and] = ACTIONS(2234),
    [anon_sym_bitor] = ACTIONS(2234),
    [anon_sym_xor] = ACTIONS(2234),
    [anon_sym_bitand] = ACTIONS(2234),
    [anon_sym_not_eq] = ACTIONS(2234),
    [anon_sym_is] = ACTIONS(2234),
    [anon_sym_as] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2224),
    [anon_sym_PLUS_PLUS] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(2234),
    [anon_sym_DOT_STAR] = ACTIONS(2224),
    [anon_sym_DASH_GT] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
  },
  [3461] = {
    [sym_identifier] = ACTIONS(2414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2412),
    [anon_sym_COMMA] = ACTIONS(2412),
    [anon_sym_RPAREN] = ACTIONS(2412),
    [aux_sym_preproc_if_token2] = ACTIONS(2412),
    [aux_sym_preproc_else_token1] = ACTIONS(2412),
    [aux_sym_preproc_elif_token1] = ACTIONS(2414),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2412),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2412),
    [anon_sym_LPAREN2] = ACTIONS(2412),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_STAR] = ACTIONS(2414),
    [anon_sym_SLASH] = ACTIONS(2414),
    [anon_sym_PERCENT] = ACTIONS(2414),
    [anon_sym_PIPE_PIPE] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_PIPE] = ACTIONS(2414),
    [anon_sym_CARET] = ACTIONS(2414),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_EQ_EQ] = ACTIONS(2412),
    [anon_sym_BANG_EQ] = ACTIONS(2412),
    [anon_sym_GT] = ACTIONS(2414),
    [anon_sym_GT_EQ] = ACTIONS(2412),
    [anon_sym_LT_EQ] = ACTIONS(2414),
    [anon_sym_LT] = ACTIONS(2414),
    [anon_sym_LT_LT] = ACTIONS(2414),
    [anon_sym_GT_GT] = ACTIONS(2414),
    [anon_sym_COLON] = ACTIONS(2412),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym___attribute__] = ACTIONS(2414),
    [anon_sym___attribute] = ACTIONS(2414),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [anon_sym_LBRACK] = ACTIONS(2412),
    [anon_sym_RBRACK] = ACTIONS(2412),
    [anon_sym_EQ] = ACTIONS(2414),
    [anon_sym_QMARK] = ACTIONS(2412),
    [anon_sym_STAR_EQ] = ACTIONS(2412),
    [anon_sym_SLASH_EQ] = ACTIONS(2412),
    [anon_sym_PERCENT_EQ] = ACTIONS(2412),
    [anon_sym_PLUS_EQ] = ACTIONS(2412),
    [anon_sym_DASH_EQ] = ACTIONS(2412),
    [anon_sym_LT_LT_EQ] = ACTIONS(2412),
    [anon_sym_GT_GT_EQ] = ACTIONS(2412),
    [anon_sym_AMP_EQ] = ACTIONS(2412),
    [anon_sym_CARET_EQ] = ACTIONS(2412),
    [anon_sym_PIPE_EQ] = ACTIONS(2412),
    [anon_sym_and_eq] = ACTIONS(2414),
    [anon_sym_or_eq] = ACTIONS(2414),
    [anon_sym_xor_eq] = ACTIONS(2414),
    [anon_sym_LT_EQ_GT] = ACTIONS(2412),
    [anon_sym_or] = ACTIONS(2414),
    [anon_sym_and] = ACTIONS(2414),
    [anon_sym_bitor] = ACTIONS(2414),
    [anon_sym_xor] = ACTIONS(2414),
    [anon_sym_bitand] = ACTIONS(2414),
    [anon_sym_not_eq] = ACTIONS(2414),
    [anon_sym_is] = ACTIONS(2414),
    [anon_sym_as] = ACTIONS(2414),
    [anon_sym_DASH_DASH] = ACTIONS(2412),
    [anon_sym_PLUS_PLUS] = ACTIONS(2412),
    [anon_sym_DOT] = ACTIONS(2414),
    [anon_sym_DOT_STAR] = ACTIONS(2412),
    [anon_sym_DASH_GT] = ACTIONS(2412),
    [sym_comment] = ACTIONS(3),
  },
  [3462] = {
    [sym_identifier] = ACTIONS(7311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7313),
    [anon_sym_COMMA] = ACTIONS(7313),
    [anon_sym_LPAREN2] = ACTIONS(7313),
    [anon_sym_DASH] = ACTIONS(7311),
    [anon_sym_PLUS] = ACTIONS(7311),
    [anon_sym_STAR] = ACTIONS(7311),
    [anon_sym_SLASH] = ACTIONS(7311),
    [anon_sym_PERCENT] = ACTIONS(7311),
    [anon_sym_PIPE_PIPE] = ACTIONS(7313),
    [anon_sym_AMP_AMP] = ACTIONS(7313),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_CARET] = ACTIONS(7311),
    [anon_sym_AMP] = ACTIONS(7311),
    [anon_sym_EQ_EQ] = ACTIONS(7313),
    [anon_sym_BANG_EQ] = ACTIONS(7313),
    [anon_sym_GT] = ACTIONS(7311),
    [anon_sym_GT_EQ] = ACTIONS(7311),
    [anon_sym_LT_EQ] = ACTIONS(7311),
    [anon_sym_LT] = ACTIONS(7311),
    [anon_sym_LT_LT] = ACTIONS(7311),
    [anon_sym_GT_GT] = ACTIONS(7311),
    [anon_sym_LBRACK] = ACTIONS(7313),
    [anon_sym_EQ] = ACTIONS(7311),
    [anon_sym_QMARK] = ACTIONS(7313),
    [anon_sym_STAR_EQ] = ACTIONS(7313),
    [anon_sym_SLASH_EQ] = ACTIONS(7313),
    [anon_sym_PERCENT_EQ] = ACTIONS(7313),
    [anon_sym_PLUS_EQ] = ACTIONS(7313),
    [anon_sym_DASH_EQ] = ACTIONS(7313),
    [anon_sym_LT_LT_EQ] = ACTIONS(7313),
    [anon_sym_GT_GT_EQ] = ACTIONS(7311),
    [anon_sym_AMP_EQ] = ACTIONS(7313),
    [anon_sym_CARET_EQ] = ACTIONS(7313),
    [anon_sym_PIPE_EQ] = ACTIONS(7313),
    [anon_sym_and_eq] = ACTIONS(7311),
    [anon_sym_or_eq] = ACTIONS(7311),
    [anon_sym_xor_eq] = ACTIONS(7311),
    [anon_sym_LT_EQ_GT] = ACTIONS(7313),
    [anon_sym_or] = ACTIONS(7311),
    [anon_sym_and] = ACTIONS(7311),
    [anon_sym_bitor] = ACTIONS(7311),
    [anon_sym_xor] = ACTIONS(7311),
    [anon_sym_bitand] = ACTIONS(7311),
    [anon_sym_not_eq] = ACTIONS(7311),
    [anon_sym_is] = ACTIONS(7311),
    [anon_sym_as] = ACTIONS(7311),
    [anon_sym_DASH_DASH] = ACTIONS(7313),
    [anon_sym_PLUS_PLUS] = ACTIONS(7313),
    [anon_sym_DOT] = ACTIONS(7311),
    [anon_sym_DOT_STAR] = ACTIONS(7313),
    [anon_sym_DASH_GT] = ACTIONS(7313),
    [anon_sym_L_DQUOTE] = ACTIONS(7313),
    [anon_sym_u_DQUOTE] = ACTIONS(7313),
    [anon_sym_U_DQUOTE] = ACTIONS(7313),
    [anon_sym_u8_DQUOTE] = ACTIONS(7313),
    [anon_sym_DQUOTE] = ACTIONS(7313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(7313),
    [anon_sym_R_DQUOTE] = ACTIONS(7313),
    [anon_sym_LR_DQUOTE] = ACTIONS(7313),
    [anon_sym_uR_DQUOTE] = ACTIONS(7313),
    [anon_sym_UR_DQUOTE] = ACTIONS(7313),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7313),
    [sym_literal_suffix] = ACTIONS(7311),
  },
  [3463] = {
    [sym_identifier] = ACTIONS(7150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7152),
    [anon_sym_COMMA] = ACTIONS(7152),
    [anon_sym_LPAREN2] = ACTIONS(7152),
    [anon_sym_DASH] = ACTIONS(7150),
    [anon_sym_PLUS] = ACTIONS(7150),
    [anon_sym_STAR] = ACTIONS(7150),
    [anon_sym_SLASH] = ACTIONS(7150),
    [anon_sym_PERCENT] = ACTIONS(7150),
    [anon_sym_PIPE_PIPE] = ACTIONS(7152),
    [anon_sym_AMP_AMP] = ACTIONS(7152),
    [anon_sym_PIPE] = ACTIONS(7150),
    [anon_sym_CARET] = ACTIONS(7150),
    [anon_sym_AMP] = ACTIONS(7150),
    [anon_sym_EQ_EQ] = ACTIONS(7152),
    [anon_sym_BANG_EQ] = ACTIONS(7152),
    [anon_sym_GT] = ACTIONS(7150),
    [anon_sym_GT_EQ] = ACTIONS(7150),
    [anon_sym_LT_EQ] = ACTIONS(7150),
    [anon_sym_LT] = ACTIONS(7150),
    [anon_sym_LT_LT] = ACTIONS(7150),
    [anon_sym_GT_GT] = ACTIONS(7150),
    [anon_sym_LBRACK] = ACTIONS(7152),
    [anon_sym_EQ] = ACTIONS(7150),
    [anon_sym_QMARK] = ACTIONS(7152),
    [anon_sym_STAR_EQ] = ACTIONS(7152),
    [anon_sym_SLASH_EQ] = ACTIONS(7152),
    [anon_sym_PERCENT_EQ] = ACTIONS(7152),
    [anon_sym_PLUS_EQ] = ACTIONS(7152),
    [anon_sym_DASH_EQ] = ACTIONS(7152),
    [anon_sym_LT_LT_EQ] = ACTIONS(7152),
    [anon_sym_GT_GT_EQ] = ACTIONS(7150),
    [anon_sym_AMP_EQ] = ACTIONS(7152),
    [anon_sym_CARET_EQ] = ACTIONS(7152),
    [anon_sym_PIPE_EQ] = ACTIONS(7152),
    [anon_sym_and_eq] = ACTIONS(7150),
    [anon_sym_or_eq] = ACTIONS(7150),
    [anon_sym_xor_eq] = ACTIONS(7150),
    [anon_sym_LT_EQ_GT] = ACTIONS(7152),
    [anon_sym_or] = ACTIONS(7150),
    [anon_sym_and] = ACTIONS(7150),
    [anon_sym_bitor] = ACTIONS(7150),
    [anon_sym_xor] = ACTIONS(7150),
    [anon_sym_bitand] = ACTIONS(7150),
    [anon_sym_not_eq] = ACTIONS(7150),
    [anon_sym_is] = ACTIONS(7150),
    [anon_sym_as] = ACTIONS(7150),
    [anon_sym_DASH_DASH] = ACTIONS(7152),
    [anon_sym_PLUS_PLUS] = ACTIONS(7152),
    [anon_sym_DOT] = ACTIONS(7150),
    [anon_sym_DOT_STAR] = ACTIONS(7152),
    [anon_sym_DASH_GT] = ACTIONS(7152),
    [anon_sym_L_DQUOTE] = ACTIONS(7152),
    [anon_sym_u_DQUOTE] = ACTIONS(7152),
    [anon_sym_U_DQUOTE] = ACTIONS(7152),
    [anon_sym_u8_DQUOTE] = ACTIONS(7152),
    [anon_sym_DQUOTE] = ACTIONS(7152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(7152),
    [anon_sym_R_DQUOTE] = ACTIONS(7152),
    [anon_sym_LR_DQUOTE] = ACTIONS(7152),
    [anon_sym_uR_DQUOTE] = ACTIONS(7152),
    [anon_sym_UR_DQUOTE] = ACTIONS(7152),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7152),
    [sym_literal_suffix] = ACTIONS(7150),
  },
  [3464] = {
    [sym_identifier] = ACTIONS(8039),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8041),
    [anon_sym_COMMA] = ACTIONS(8041),
    [anon_sym_RPAREN] = ACTIONS(8041),
    [aux_sym_preproc_if_token2] = ACTIONS(8041),
    [aux_sym_preproc_else_token1] = ACTIONS(8041),
    [aux_sym_preproc_elif_token1] = ACTIONS(8039),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(8041),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(8041),
    [anon_sym_LPAREN2] = ACTIONS(8041),
    [anon_sym_DASH] = ACTIONS(8039),
    [anon_sym_PLUS] = ACTIONS(8039),
    [anon_sym_STAR] = ACTIONS(8039),
    [anon_sym_SLASH] = ACTIONS(8039),
    [anon_sym_PERCENT] = ACTIONS(8039),
    [anon_sym_PIPE_PIPE] = ACTIONS(8041),
    [anon_sym_AMP_AMP] = ACTIONS(8041),
    [anon_sym_PIPE] = ACTIONS(8039),
    [anon_sym_CARET] = ACTIONS(8039),
    [anon_sym_AMP] = ACTIONS(8039),
    [anon_sym_EQ_EQ] = ACTIONS(8041),
    [anon_sym_BANG_EQ] = ACTIONS(8041),
    [anon_sym_GT] = ACTIONS(8039),
    [anon_sym_GT_EQ] = ACTIONS(8041),
    [anon_sym_LT_EQ] = ACTIONS(8039),
    [anon_sym_LT] = ACTIONS(8039),
    [anon_sym_LT_LT] = ACTIONS(8039),
    [anon_sym_GT_GT] = ACTIONS(8039),
    [anon_sym_COLON] = ACTIONS(8041),
    [anon_sym_SEMI] = ACTIONS(8041),
    [anon_sym___attribute__] = ACTIONS(8039),
    [anon_sym___attribute] = ACTIONS(8039),
    [anon_sym_RBRACE] = ACTIONS(8041),
    [anon_sym_LBRACK] = ACTIONS(8041),
    [anon_sym_RBRACK] = ACTIONS(8041),
    [anon_sym_EQ] = ACTIONS(8039),
    [anon_sym_QMARK] = ACTIONS(8041),
    [anon_sym_STAR_EQ] = ACTIONS(8041),
    [anon_sym_SLASH_EQ] = ACTIONS(8041),
    [anon_sym_PERCENT_EQ] = ACTIONS(8041),
    [anon_sym_PLUS_EQ] = ACTIONS(8041),
    [anon_sym_DASH_EQ] = ACTIONS(8041),
    [anon_sym_LT_LT_EQ] = ACTIONS(8041),
    [anon_sym_GT_GT_EQ] = ACTIONS(8041),
    [anon_sym_AMP_EQ] = ACTIONS(8041),
    [anon_sym_CARET_EQ] = ACTIONS(8041),
    [anon_sym_PIPE_EQ] = ACTIONS(8041),
    [anon_sym_and_eq] = ACTIONS(8039),
    [anon_sym_or_eq] = ACTIONS(8039),
    [anon_sym_xor_eq] = ACTIONS(8039),
    [anon_sym_LT_EQ_GT] = ACTIONS(8041),
    [anon_sym_or] = ACTIONS(8039),
    [anon_sym_and] = ACTIONS(8039),
    [anon_sym_bitor] = ACTIONS(8039),
    [anon_sym_xor] = ACTIONS(8039),
    [anon_sym_bitand] = ACTIONS(8039),
    [anon_sym_not_eq] = ACTIONS(8039),
    [anon_sym_is] = ACTIONS(8039),
    [anon_sym_as] = ACTIONS(8039),
    [anon_sym_DASH_DASH] = ACTIONS(8041),
    [anon_sym_PLUS_PLUS] = ACTIONS(8041),
    [anon_sym_DOT] = ACTIONS(8039),
    [anon_sym_DOT_STAR] = ACTIONS(8041),
    [anon_sym_DASH_GT] = ACTIONS(8041),
    [sym_comment] = ACTIONS(3),
  },
  [3465] = {
    [sym_identifier] = ACTIONS(7947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7949),
    [anon_sym_COMMA] = ACTIONS(7949),
    [anon_sym_RPAREN] = ACTIONS(7949),
    [aux_sym_preproc_if_token2] = ACTIONS(7949),
    [aux_sym_preproc_else_token1] = ACTIONS(7949),
    [aux_sym_preproc_elif_token1] = ACTIONS(7947),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(7949),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(7949),
    [anon_sym_LPAREN2] = ACTIONS(7949),
    [anon_sym_DASH] = ACTIONS(7947),
    [anon_sym_PLUS] = ACTIONS(7947),
    [anon_sym_STAR] = ACTIONS(7947),
    [anon_sym_SLASH] = ACTIONS(7947),
    [anon_sym_PERCENT] = ACTIONS(7947),
    [anon_sym_PIPE_PIPE] = ACTIONS(7949),
    [anon_sym_AMP_AMP] = ACTIONS(7949),
    [anon_sym_PIPE] = ACTIONS(7947),
    [anon_sym_CARET] = ACTIONS(7947),
    [anon_sym_AMP] = ACTIONS(7947),
    [anon_sym_EQ_EQ] = ACTIONS(7949),
    [anon_sym_BANG_EQ] = ACTIONS(7949),
    [anon_sym_GT] = ACTIONS(7947),
    [anon_sym_GT_EQ] = ACTIONS(7949),
    [anon_sym_LT_EQ] = ACTIONS(7947),
    [anon_sym_LT] = ACTIONS(7947),
    [anon_sym_LT_LT] = ACTIONS(7947),
    [anon_sym_GT_GT] = ACTIONS(7947),
    [anon_sym_COLON] = ACTIONS(7949),
    [anon_sym_SEMI] = ACTIONS(7949),
    [anon_sym___attribute__] = ACTIONS(7947),
    [anon_sym___attribute] = ACTIONS(7947),
    [anon_sym_RBRACE] = ACTIONS(7949),
    [anon_sym_LBRACK] = ACTIONS(7949),
    [anon_sym_RBRACK] = ACTIONS(7949),
    [anon_sym_EQ] = ACTIONS(7947),
    [anon_sym_QMARK] = ACTIONS(7949),
    [anon_sym_STAR_EQ] = ACTIONS(7949),
    [anon_sym_SLASH_EQ] = ACTIONS(7949),
    [anon_sym_PERCENT_EQ] = ACTIONS(7949),
    [anon_sym_PLUS_EQ] = ACTIONS(7949),
    [anon_sym_DASH_EQ] = ACTIONS(7949),
    [anon_sym_LT_LT_EQ] = ACTIONS(7949),
    [anon_sym_GT_GT_EQ] = ACTIONS(7949),
    [anon_sym_AMP_EQ] = ACTIONS(7949),
    [anon_sym_CARET_EQ] = ACTIONS(7949),
    [anon_sym_PIPE_EQ] = ACTIONS(7949),
    [anon_sym_and_eq] = ACTIONS(7947),
    [anon_sym_or_eq] = ACTIONS(7947),
    [anon_sym_xor_eq] = ACTIONS(7947),
    [anon_sym_LT_EQ_GT] = ACTIONS(7949),
    [anon_sym_or] = ACTIONS(7947),
    [anon_sym_and] = ACTIONS(7947),
    [anon_sym_bitor] = ACTIONS(7947),
    [anon_sym_xor] = ACTIONS(7947),
    [anon_sym_bitand] = ACTIONS(7947),
    [anon_sym_not_eq] = ACTIONS(7947),
    [anon_sym_is] = ACTIONS(7947),
    [anon_sym_as] = ACTIONS(7947),
    [anon_sym_DASH_DASH] = ACTIONS(7949),
    [anon_sym_PLUS_PLUS] = ACTIONS(7949),
    [anon_sym_DOT] = ACTIONS(7947),
    [anon_sym_DOT_STAR] = ACTIONS(7949),
    [anon_sym_DASH_GT] = ACTIONS(7949),
    [sym_comment] = ACTIONS(3),
  },
  [3466] = {
    [sym_identifier] = ACTIONS(8043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8045),
    [anon_sym_COMMA] = ACTIONS(8045),
    [anon_sym_RPAREN] = ACTIONS(8045),
    [aux_sym_preproc_if_token2] = ACTIONS(8045),
    [aux_sym_preproc_else_token1] = ACTIONS(8045),
    [aux_sym_preproc_elif_token1] = ACTIONS(8043),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(8045),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(8045),
    [anon_sym_LPAREN2] = ACTIONS(8045),
    [anon_sym_DASH] = ACTIONS(8043),
    [anon_sym_PLUS] = ACTIONS(8043),
    [anon_sym_STAR] = ACTIONS(8043),
    [anon_sym_SLASH] = ACTIONS(8043),
    [anon_sym_PERCENT] = ACTIONS(8043),
    [anon_sym_PIPE_PIPE] = ACTIONS(8045),
    [anon_sym_AMP_AMP] = ACTIONS(8045),
    [anon_sym_PIPE] = ACTIONS(8043),
    [anon_sym_CARET] = ACTIONS(8043),
    [anon_sym_AMP] = ACTIONS(8043),
    [anon_sym_EQ_EQ] = ACTIONS(8045),
    [anon_sym_BANG_EQ] = ACTIONS(8045),
    [anon_sym_GT] = ACTIONS(8043),
    [anon_sym_GT_EQ] = ACTIONS(8045),
    [anon_sym_LT_EQ] = ACTIONS(8043),
    [anon_sym_LT] = ACTIONS(8043),
    [anon_sym_LT_LT] = ACTIONS(8043),
    [anon_sym_GT_GT] = ACTIONS(8043),
    [anon_sym_COLON] = ACTIONS(8045),
    [anon_sym_SEMI] = ACTIONS(8045),
    [anon_sym___attribute__] = ACTIONS(8043),
    [anon_sym___attribute] = ACTIONS(8043),
    [anon_sym_RBRACE] = ACTIONS(8045),
    [anon_sym_LBRACK] = ACTIONS(8045),
    [anon_sym_RBRACK] = ACTIONS(8045),
    [anon_sym_EQ] = ACTIONS(8043),
    [anon_sym_QMARK] = ACTIONS(8045),
    [anon_sym_STAR_EQ] = ACTIONS(8045),
    [anon_sym_SLASH_EQ] = ACTIONS(8045),
    [anon_sym_PERCENT_EQ] = ACTIONS(8045),
    [anon_sym_PLUS_EQ] = ACTIONS(8045),
    [anon_sym_DASH_EQ] = ACTIONS(8045),
    [anon_sym_LT_LT_EQ] = ACTIONS(8045),
    [anon_sym_GT_GT_EQ] = ACTIONS(8045),
    [anon_sym_AMP_EQ] = ACTIONS(8045),
    [anon_sym_CARET_EQ] = ACTIONS(8045),
    [anon_sym_PIPE_EQ] = ACTIONS(8045),
    [anon_sym_and_eq] = ACTIONS(8043),
    [anon_sym_or_eq] = ACTIONS(8043),
    [anon_sym_xor_eq] = ACTIONS(8043),
    [anon_sym_LT_EQ_GT] = ACTIONS(8045),
    [anon_sym_or] = ACTIONS(8043),
    [anon_sym_and] = ACTIONS(8043),
    [anon_sym_bitor] = ACTIONS(8043),
    [anon_sym_xor] = ACTIONS(8043),
    [anon_sym_bitand] = ACTIONS(8043),
    [anon_sym_not_eq] = ACTIONS(8043),
    [anon_sym_is] = ACTIONS(8043),
    [anon_sym_as] = ACTIONS(8043),
    [anon_sym_DASH_DASH] = ACTIONS(8045),
    [anon_sym_PLUS_PLUS] = ACTIONS(8045),
    [anon_sym_DOT] = ACTIONS(8043),
    [anon_sym_DOT_STAR] = ACTIONS(8045),
    [anon_sym_DASH_GT] = ACTIONS(8045),
    [sym_comment] = ACTIONS(3),
  },
  [3467] = {
    [sym_identifier] = ACTIONS(6160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6162),
    [anon_sym_COMMA] = ACTIONS(6162),
    [anon_sym_RPAREN] = ACTIONS(6162),
    [aux_sym_preproc_if_token2] = ACTIONS(6162),
    [aux_sym_preproc_else_token1] = ACTIONS(6162),
    [aux_sym_preproc_elif_token1] = ACTIONS(6160),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6162),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6162),
    [anon_sym_LPAREN2] = ACTIONS(6162),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_PERCENT] = ACTIONS(6160),
    [anon_sym_PIPE_PIPE] = ACTIONS(6162),
    [anon_sym_AMP_AMP] = ACTIONS(6162),
    [anon_sym_PIPE] = ACTIONS(6160),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_AMP] = ACTIONS(6160),
    [anon_sym_EQ_EQ] = ACTIONS(6162),
    [anon_sym_BANG_EQ] = ACTIONS(6162),
    [anon_sym_GT] = ACTIONS(6160),
    [anon_sym_GT_EQ] = ACTIONS(6162),
    [anon_sym_LT_EQ] = ACTIONS(6160),
    [anon_sym_LT] = ACTIONS(6160),
    [anon_sym_LT_LT] = ACTIONS(6160),
    [anon_sym_GT_GT] = ACTIONS(6160),
    [anon_sym_COLON] = ACTIONS(6162),
    [anon_sym_SEMI] = ACTIONS(6162),
    [anon_sym___attribute__] = ACTIONS(6160),
    [anon_sym___attribute] = ACTIONS(6160),
    [anon_sym_RBRACE] = ACTIONS(6162),
    [anon_sym_LBRACK] = ACTIONS(6162),
    [anon_sym_RBRACK] = ACTIONS(6162),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_QMARK] = ACTIONS(6162),
    [anon_sym_STAR_EQ] = ACTIONS(6162),
    [anon_sym_SLASH_EQ] = ACTIONS(6162),
    [anon_sym_PERCENT_EQ] = ACTIONS(6162),
    [anon_sym_PLUS_EQ] = ACTIONS(6162),
    [anon_sym_DASH_EQ] = ACTIONS(6162),
    [anon_sym_LT_LT_EQ] = ACTIONS(6162),
    [anon_sym_GT_GT_EQ] = ACTIONS(6162),
    [anon_sym_AMP_EQ] = ACTIONS(6162),
    [anon_sym_CARET_EQ] = ACTIONS(6162),
    [anon_sym_PIPE_EQ] = ACTIONS(6162),
    [anon_sym_and_eq] = ACTIONS(6160),
    [anon_sym_or_eq] = ACTIONS(6160),
    [anon_sym_xor_eq] = ACTIONS(6160),
    [anon_sym_LT_EQ_GT] = ACTIONS(6162),
    [anon_sym_or] = ACTIONS(6160),
    [anon_sym_and] = ACTIONS(6160),
    [anon_sym_bitor] = ACTIONS(6160),
    [anon_sym_xor] = ACTIONS(6160),
    [anon_sym_bitand] = ACTIONS(6160),
    [anon_sym_not_eq] = ACTIONS(6160),
    [anon_sym_is] = ACTIONS(6160),
    [anon_sym_as] = ACTIONS(6160),
    [anon_sym_DASH_DASH] = ACTIONS(6162),
    [anon_sym_PLUS_PLUS] = ACTIONS(6162),
    [anon_sym_DOT] = ACTIONS(6160),
    [anon_sym_DOT_STAR] = ACTIONS(6162),
    [anon_sym_DASH_GT] = ACTIONS(6162),
    [sym_comment] = ACTIONS(3),
  },
  [3468] = {
    [sym_identifier] = ACTIONS(2234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2224),
    [anon_sym_COMMA] = ACTIONS(2224),
    [anon_sym_RPAREN] = ACTIONS(2224),
    [aux_sym_preproc_if_token2] = ACTIONS(2224),
    [aux_sym_preproc_else_token1] = ACTIONS(2224),
    [aux_sym_preproc_elif_token1] = ACTIONS(2234),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2224),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2224),
    [anon_sym_LPAREN2] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_PIPE_PIPE] = ACTIONS(2224),
    [anon_sym_AMP_AMP] = ACTIONS(2224),
    [anon_sym_PIPE] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2234),
    [anon_sym_EQ_EQ] = ACTIONS(2224),
    [anon_sym_BANG_EQ] = ACTIONS(2224),
    [anon_sym_GT] = ACTIONS(2234),
    [anon_sym_GT_EQ] = ACTIONS(2224),
    [anon_sym_LT_EQ] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2234),
    [anon_sym_LT_LT] = ACTIONS(2234),
    [anon_sym_GT_GT] = ACTIONS(2234),
    [anon_sym_COLON] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2234),
    [anon_sym___attribute] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_RBRACK] = ACTIONS(2224),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_QMARK] = ACTIONS(2224),
    [anon_sym_STAR_EQ] = ACTIONS(2224),
    [anon_sym_SLASH_EQ] = ACTIONS(2224),
    [anon_sym_PERCENT_EQ] = ACTIONS(2224),
    [anon_sym_PLUS_EQ] = ACTIONS(2224),
    [anon_sym_DASH_EQ] = ACTIONS(2224),
    [anon_sym_LT_LT_EQ] = ACTIONS(2224),
    [anon_sym_GT_GT_EQ] = ACTIONS(2224),
    [anon_sym_AMP_EQ] = ACTIONS(2224),
    [anon_sym_CARET_EQ] = ACTIONS(2224),
    [anon_sym_PIPE_EQ] = ACTIONS(2224),
    [anon_sym_and_eq] = ACTIONS(2234),
    [anon_sym_or_eq] = ACTIONS(2234),
    [anon_sym_xor_eq] = ACTIONS(2234),
    [anon_sym_LT_EQ_GT] = ACTIONS(2224),
    [anon_sym_or] = ACTIONS(2234),
    [anon_sym_and] = ACTIONS(2234),
    [anon_sym_bitor] = ACTIONS(2234),
    [anon_sym_xor] = ACTIONS(2234),
    [anon_sym_bitand] = ACTIONS(2234),
    [anon_sym_not_eq] = ACTIONS(2234),
    [anon_sym_is] = ACTIONS(2234),
    [anon_sym_as] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2224),
    [anon_sym_PLUS_PLUS] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(2234),
    [anon_sym_DOT_STAR] = ACTIONS(2224),
    [anon_sym_DASH_GT] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
  },
  [3469] = {
    [sym_identifier] = ACTIONS(6164),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6166),
    [anon_sym_COMMA] = ACTIONS(6166),
    [anon_sym_RPAREN] = ACTIONS(6166),
    [aux_sym_preproc_if_token2] = ACTIONS(6166),
    [aux_sym_preproc_else_token1] = ACTIONS(6166),
    [aux_sym_preproc_elif_token1] = ACTIONS(6164),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6166),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6166),
    [anon_sym_LPAREN2] = ACTIONS(6166),
    [anon_sym_DASH] = ACTIONS(6164),
    [anon_sym_PLUS] = ACTIONS(6164),
    [anon_sym_STAR] = ACTIONS(6164),
    [anon_sym_SLASH] = ACTIONS(6164),
    [anon_sym_PERCENT] = ACTIONS(6164),
    [anon_sym_PIPE_PIPE] = ACTIONS(6166),
    [anon_sym_AMP_AMP] = ACTIONS(6166),
    [anon_sym_PIPE] = ACTIONS(6164),
    [anon_sym_CARET] = ACTIONS(6164),
    [anon_sym_AMP] = ACTIONS(6164),
    [anon_sym_EQ_EQ] = ACTIONS(6166),
    [anon_sym_BANG_EQ] = ACTIONS(6166),
    [anon_sym_GT] = ACTIONS(6164),
    [anon_sym_GT_EQ] = ACTIONS(6166),
    [anon_sym_LT_EQ] = ACTIONS(6164),
    [anon_sym_LT] = ACTIONS(6164),
    [anon_sym_LT_LT] = ACTIONS(6164),
    [anon_sym_GT_GT] = ACTIONS(6164),
    [anon_sym_COLON] = ACTIONS(6166),
    [anon_sym_SEMI] = ACTIONS(6166),
    [anon_sym___attribute__] = ACTIONS(6164),
    [anon_sym___attribute] = ACTIONS(6164),
    [anon_sym_RBRACE] = ACTIONS(6166),
    [anon_sym_LBRACK] = ACTIONS(6166),
    [anon_sym_RBRACK] = ACTIONS(6166),
    [anon_sym_EQ] = ACTIONS(6164),
    [anon_sym_QMARK] = ACTIONS(6166),
    [anon_sym_STAR_EQ] = ACTIONS(6166),
    [anon_sym_SLASH_EQ] = ACTIONS(6166),
    [anon_sym_PERCENT_EQ] = ACTIONS(6166),
    [anon_sym_PLUS_EQ] = ACTIONS(6166),
    [anon_sym_DASH_EQ] = ACTIONS(6166),
    [anon_sym_LT_LT_EQ] = ACTIONS(6166),
    [anon_sym_GT_GT_EQ] = ACTIONS(6166),
    [anon_sym_AMP_EQ] = ACTIONS(6166),
    [anon_sym_CARET_EQ] = ACTIONS(6166),
    [anon_sym_PIPE_EQ] = ACTIONS(6166),
    [anon_sym_and_eq] = ACTIONS(6164),
    [anon_sym_or_eq] = ACTIONS(6164),
    [anon_sym_xor_eq] = ACTIONS(6164),
    [anon_sym_LT_EQ_GT] = ACTIONS(6166),
    [anon_sym_or] = ACTIONS(6164),
    [anon_sym_and] = ACTIONS(6164),
    [anon_sym_bitor] = ACTIONS(6164),
    [anon_sym_xor] = ACTIONS(6164),
    [anon_sym_bitand] = ACTIONS(6164),
    [anon_sym_not_eq] = ACTIONS(6164),
    [anon_sym_is] = ACTIONS(6164),
    [anon_sym_as] = ACTIONS(6164),
    [anon_sym_DASH_DASH] = ACTIONS(6166),
    [anon_sym_PLUS_PLUS] = ACTIONS(6166),
    [anon_sym_DOT] = ACTIONS(6164),
    [anon_sym_DOT_STAR] = ACTIONS(6166),
    [anon_sym_DASH_GT] = ACTIONS(6166),
    [sym_comment] = ACTIONS(3),
  },
  [3470] = {
    [sym_identifier] = ACTIONS(2234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2224),
    [anon_sym_COMMA] = ACTIONS(2224),
    [anon_sym_RPAREN] = ACTIONS(2224),
    [aux_sym_preproc_if_token2] = ACTIONS(2224),
    [aux_sym_preproc_else_token1] = ACTIONS(2224),
    [aux_sym_preproc_elif_token1] = ACTIONS(2234),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2224),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2224),
    [anon_sym_LPAREN2] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_PIPE_PIPE] = ACTIONS(2224),
    [anon_sym_AMP_AMP] = ACTIONS(2224),
    [anon_sym_PIPE] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2234),
    [anon_sym_EQ_EQ] = ACTIONS(2224),
    [anon_sym_BANG_EQ] = ACTIONS(2224),
    [anon_sym_GT] = ACTIONS(2234),
    [anon_sym_GT_EQ] = ACTIONS(2224),
    [anon_sym_LT_EQ] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2234),
    [anon_sym_LT_LT] = ACTIONS(2234),
    [anon_sym_GT_GT] = ACTIONS(2234),
    [anon_sym_COLON] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2234),
    [anon_sym___attribute] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_RBRACK] = ACTIONS(2224),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_QMARK] = ACTIONS(2224),
    [anon_sym_STAR_EQ] = ACTIONS(2224),
    [anon_sym_SLASH_EQ] = ACTIONS(2224),
    [anon_sym_PERCENT_EQ] = ACTIONS(2224),
    [anon_sym_PLUS_EQ] = ACTIONS(2224),
    [anon_sym_DASH_EQ] = ACTIONS(2224),
    [anon_sym_LT_LT_EQ] = ACTIONS(2224),
    [anon_sym_GT_GT_EQ] = ACTIONS(2224),
    [anon_sym_AMP_EQ] = ACTIONS(2224),
    [anon_sym_CARET_EQ] = ACTIONS(2224),
    [anon_sym_PIPE_EQ] = ACTIONS(2224),
    [anon_sym_and_eq] = ACTIONS(2234),
    [anon_sym_or_eq] = ACTIONS(2234),
    [anon_sym_xor_eq] = ACTIONS(2234),
    [anon_sym_LT_EQ_GT] = ACTIONS(2224),
    [anon_sym_or] = ACTIONS(2234),
    [anon_sym_and] = ACTIONS(2234),
    [anon_sym_bitor] = ACTIONS(2234),
    [anon_sym_xor] = ACTIONS(2234),
    [anon_sym_bitand] = ACTIONS(2234),
    [anon_sym_not_eq] = ACTIONS(2234),
    [anon_sym_is] = ACTIONS(2234),
    [anon_sym_as] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2224),
    [anon_sym_PLUS_PLUS] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(2234),
    [anon_sym_DOT_STAR] = ACTIONS(2224),
    [anon_sym_DASH_GT] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
  },
  [3471] = {
    [sym_identifier] = ACTIONS(2234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2224),
    [anon_sym_COMMA] = ACTIONS(2224),
    [anon_sym_RPAREN] = ACTIONS(2224),
    [aux_sym_preproc_if_token2] = ACTIONS(2224),
    [aux_sym_preproc_else_token1] = ACTIONS(2224),
    [aux_sym_preproc_elif_token1] = ACTIONS(2234),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2224),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2224),
    [anon_sym_LPAREN2] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2234),
    [anon_sym_PIPE_PIPE] = ACTIONS(2224),
    [anon_sym_AMP_AMP] = ACTIONS(2224),
    [anon_sym_PIPE] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_AMP] = ACTIONS(2234),
    [anon_sym_EQ_EQ] = ACTIONS(2224),
    [anon_sym_BANG_EQ] = ACTIONS(2224),
    [anon_sym_GT] = ACTIONS(2234),
    [anon_sym_GT_EQ] = ACTIONS(2224),
    [anon_sym_LT_EQ] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2234),
    [anon_sym_LT_LT] = ACTIONS(2234),
    [anon_sym_GT_GT] = ACTIONS(2234),
    [anon_sym_COLON] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2224),
    [anon_sym___attribute__] = ACTIONS(2234),
    [anon_sym___attribute] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_RBRACK] = ACTIONS(2224),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_QMARK] = ACTIONS(2224),
    [anon_sym_STAR_EQ] = ACTIONS(2224),
    [anon_sym_SLASH_EQ] = ACTIONS(2224),
    [anon_sym_PERCENT_EQ] = ACTIONS(2224),
    [anon_sym_PLUS_EQ] = ACTIONS(2224),
    [anon_sym_DASH_EQ] = ACTIONS(2224),
    [anon_sym_LT_LT_EQ] = ACTIONS(2224),
    [anon_sym_GT_GT_EQ] = ACTIONS(2224),
    [anon_sym_AMP_EQ] = ACTIONS(2224),
    [anon_sym_CARET_EQ] = ACTIONS(2224),
    [anon_sym_PIPE_EQ] = ACTIONS(2224),
    [anon_sym_and_eq] = ACTIONS(2234),
    [anon_sym_or_eq] = ACTIONS(2234),
    [anon_sym_xor_eq] = ACTIONS(2234),
    [anon_sym_LT_EQ_GT] = ACTIONS(2224),
    [anon_sym_or] = ACTIONS(2234),
    [anon_sym_and] = ACTIONS(2234),
    [anon_sym_bitor] = ACTIONS(2234),
    [anon_sym_xor] = ACTIONS(2234),
    [anon_sym_bitand] = ACTIONS(2234),
    [anon_sym_not_eq] = ACTIONS(2234),
    [anon_sym_is] = ACTIONS(2234),
    [anon_sym_as] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2224),
    [anon_sym_PLUS_PLUS] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(2234),
    [anon_sym_DOT_STAR] = ACTIONS(2224),
    [anon_sym_DASH_GT] = ACTIONS(2224),
    [sym_comment] = ACTIONS(3),
  },
  [3472] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(3395),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2972),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_RPAREN] = ACTIONS(2972),
    [anon_sym_LPAREN2] = ACTIONS(2972),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_STAR] = ACTIONS(2974),
    [anon_sym_SLASH] = ACTIONS(2974),
    [anon_sym_PERCENT] = ACTIONS(2974),
    [anon_sym_PIPE_PIPE] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_PIPE] = ACTIONS(2974),
    [anon_sym_CARET] = ACTIONS(2974),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_EQ_EQ] = ACTIONS(2972),
    [anon_sym_BANG_EQ] = ACTIONS(2972),
    [anon_sym_GT] = ACTIONS(2974),
    [anon_sym_GT_EQ] = ACTIONS(2972),
    [anon_sym_LT_EQ] = ACTIONS(2974),
    [anon_sym_LT] = ACTIONS(2974),
    [anon_sym_LT_LT] = ACTIONS(2974),
    [anon_sym_GT_GT] = ACTIONS(2974),
    [anon_sym___attribute__] = ACTIONS(2972),
    [anon_sym___attribute] = ACTIONS(2974),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_signed] = ACTIONS(8047),
    [anon_sym_unsigned] = ACTIONS(8047),
    [anon_sym_long] = ACTIONS(8047),
    [anon_sym_short] = ACTIONS(8047),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_EQ] = ACTIONS(2974),
    [anon_sym_QMARK] = ACTIONS(2972),
    [anon_sym_STAR_EQ] = ACTIONS(2972),
    [anon_sym_SLASH_EQ] = ACTIONS(2972),
    [anon_sym_PERCENT_EQ] = ACTIONS(2972),
    [anon_sym_PLUS_EQ] = ACTIONS(2972),
    [anon_sym_DASH_EQ] = ACTIONS(2972),
    [anon_sym_LT_LT_EQ] = ACTIONS(2972),
    [anon_sym_GT_GT_EQ] = ACTIONS(2972),
    [anon_sym_AMP_EQ] = ACTIONS(2972),
    [anon_sym_CARET_EQ] = ACTIONS(2972),
    [anon_sym_PIPE_EQ] = ACTIONS(2972),
    [anon_sym_and_eq] = ACTIONS(2972),
    [anon_sym_or_eq] = ACTIONS(2972),
    [anon_sym_xor_eq] = ACTIONS(2972),
    [anon_sym_LT_EQ_GT] = ACTIONS(2972),
    [anon_sym_or] = ACTIONS(2974),
    [anon_sym_and] = ACTIONS(2974),
    [anon_sym_bitor] = ACTIONS(2972),
    [anon_sym_xor] = ACTIONS(2974),
    [anon_sym_bitand] = ACTIONS(2972),
    [anon_sym_not_eq] = ACTIONS(2972),
    [anon_sym_is] = ACTIONS(2972),
    [anon_sym_as] = ACTIONS(2972),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_DOT] = ACTIONS(2974),
    [anon_sym_DOT_STAR] = ACTIONS(2972),
    [anon_sym_DASH_GT] = ACTIONS(2974),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(2972),
    [anon_sym_let] = ACTIONS(2972),
    [anon_sym_This] = ACTIONS(2972),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2972),
  },
  [3473] = {
    [sym_identifier] = ACTIONS(8049),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8051),
    [anon_sym_COMMA] = ACTIONS(8051),
    [anon_sym_RPAREN] = ACTIONS(8051),
    [aux_sym_preproc_if_token2] = ACTIONS(8051),
    [aux_sym_preproc_else_token1] = ACTIONS(8051),
    [aux_sym_preproc_elif_token1] = ACTIONS(8049),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(8051),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(8051),
    [anon_sym_LPAREN2] = ACTIONS(8051),
    [anon_sym_DASH] = ACTIONS(8049),
    [anon_sym_PLUS] = ACTIONS(8049),
    [anon_sym_STAR] = ACTIONS(8049),
    [anon_sym_SLASH] = ACTIONS(8049),
    [anon_sym_PERCENT] = ACTIONS(8049),
    [anon_sym_PIPE_PIPE] = ACTIONS(8051),
    [anon_sym_AMP_AMP] = ACTIONS(8051),
    [anon_sym_PIPE] = ACTIONS(8049),
    [anon_sym_CARET] = ACTIONS(8049),
    [anon_sym_AMP] = ACTIONS(8049),
    [anon_sym_EQ_EQ] = ACTIONS(8051),
    [anon_sym_BANG_EQ] = ACTIONS(8051),
    [anon_sym_GT] = ACTIONS(8049),
    [anon_sym_GT_EQ] = ACTIONS(8051),
    [anon_sym_LT_EQ] = ACTIONS(8049),
    [anon_sym_LT] = ACTIONS(8049),
    [anon_sym_LT_LT] = ACTIONS(8049),
    [anon_sym_GT_GT] = ACTIONS(8049),
    [anon_sym_COLON] = ACTIONS(8051),
    [anon_sym_SEMI] = ACTIONS(8051),
    [anon_sym___attribute__] = ACTIONS(8049),
    [anon_sym___attribute] = ACTIONS(8049),
    [anon_sym_RBRACE] = ACTIONS(8051),
    [anon_sym_LBRACK] = ACTIONS(8051),
    [anon_sym_RBRACK] = ACTIONS(8051),
    [anon_sym_EQ] = ACTIONS(8049),
    [anon_sym_QMARK] = ACTIONS(8051),
    [anon_sym_STAR_EQ] = ACTIONS(8051),
    [anon_sym_SLASH_EQ] = ACTIONS(8051),
    [anon_sym_PERCENT_EQ] = ACTIONS(8051),
    [anon_sym_PLUS_EQ] = ACTIONS(8051),
    [anon_sym_DASH_EQ] = ACTIONS(8051),
    [anon_sym_LT_LT_EQ] = ACTIONS(8051),
    [anon_sym_GT_GT_EQ] = ACTIONS(8051),
    [anon_sym_AMP_EQ] = ACTIONS(8051),
    [anon_sym_CARET_EQ] = ACTIONS(8051),
    [anon_sym_PIPE_EQ] = ACTIONS(8051),
    [anon_sym_and_eq] = ACTIONS(8049),
    [anon_sym_or_eq] = ACTIONS(8049),
    [anon_sym_xor_eq] = ACTIONS(8049),
    [anon_sym_LT_EQ_GT] = ACTIONS(8051),
    [anon_sym_or] = ACTIONS(8049),
    [anon_sym_and] = ACTIONS(8049),
    [anon_sym_bitor] = ACTIONS(8049),
    [anon_sym_xor] = ACTIONS(8049),
    [anon_sym_bitand] = ACTIONS(8049),
    [anon_sym_not_eq] = ACTIONS(8049),
    [anon_sym_is] = ACTIONS(8049),
    [anon_sym_as] = ACTIONS(8049),
    [anon_sym_DASH_DASH] = ACTIONS(8051),
    [anon_sym_PLUS_PLUS] = ACTIONS(8051),
    [anon_sym_DOT] = ACTIONS(8049),
    [anon_sym_DOT_STAR] = ACTIONS(8051),
    [anon_sym_DASH_GT] = ACTIONS(8051),
    [sym_comment] = ACTIONS(3),
  },
  [3474] = {
    [sym_identifier] = ACTIONS(6322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6324),
    [anon_sym_COMMA] = ACTIONS(6324),
    [anon_sym_RPAREN] = ACTIONS(6324),
    [aux_sym_preproc_if_token2] = ACTIONS(6324),
    [aux_sym_preproc_else_token1] = ACTIONS(6324),
    [aux_sym_preproc_elif_token1] = ACTIONS(6322),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6324),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6324),
    [anon_sym_LPAREN2] = ACTIONS(6324),
    [anon_sym_DASH] = ACTIONS(6322),
    [anon_sym_PLUS] = ACTIONS(6322),
    [anon_sym_STAR] = ACTIONS(6322),
    [anon_sym_SLASH] = ACTIONS(6322),
    [anon_sym_PERCENT] = ACTIONS(6322),
    [anon_sym_PIPE_PIPE] = ACTIONS(6324),
    [anon_sym_AMP_AMP] = ACTIONS(6324),
    [anon_sym_PIPE] = ACTIONS(6322),
    [anon_sym_CARET] = ACTIONS(6322),
    [anon_sym_AMP] = ACTIONS(6322),
    [anon_sym_EQ_EQ] = ACTIONS(6324),
    [anon_sym_BANG_EQ] = ACTIONS(6324),
    [anon_sym_GT] = ACTIONS(6322),
    [anon_sym_GT_EQ] = ACTIONS(6324),
    [anon_sym_LT_EQ] = ACTIONS(6322),
    [anon_sym_LT] = ACTIONS(6322),
    [anon_sym_LT_LT] = ACTIONS(6322),
    [anon_sym_GT_GT] = ACTIONS(6322),
    [anon_sym_COLON] = ACTIONS(6324),
    [anon_sym_SEMI] = ACTIONS(6324),
    [anon_sym___attribute__] = ACTIONS(6322),
    [anon_sym___attribute] = ACTIONS(6322),
    [anon_sym_RBRACE] = ACTIONS(6324),
    [anon_sym_LBRACK] = ACTIONS(6324),
    [anon_sym_RBRACK] = ACTIONS(6324),
    [anon_sym_EQ] = ACTIONS(6322),
    [anon_sym_QMARK] = ACTIONS(6324),
    [anon_sym_STAR_EQ] = ACTIONS(6324),
    [anon_sym_SLASH_EQ] = ACTIONS(6324),
    [anon_sym_PERCENT_EQ] = ACTIONS(6324),
    [anon_sym_PLUS_EQ] = ACTIONS(6324),
    [anon_sym_DASH_EQ] = ACTIONS(6324),
    [anon_sym_LT_LT_EQ] = ACTIONS(6324),
    [anon_sym_GT_GT_EQ] = ACTIONS(6324),
    [anon_sym_AMP_EQ] = ACTIONS(6324),
    [anon_sym_CARET_EQ] = ACTIONS(6324),
    [anon_sym_PIPE_EQ] = ACTIONS(6324),
    [anon_sym_and_eq] = ACTIONS(6322),
    [anon_sym_or_eq] = ACTIONS(6322),
    [anon_sym_xor_eq] = ACTIONS(6322),
    [anon_sym_LT_EQ_GT] = ACTIONS(6324),
    [anon_sym_or] = ACTIONS(6322),
    [anon_sym_and] = ACTIONS(6322),
    [anon_sym_bitor] = ACTIONS(6322),
    [anon_sym_xor] = ACTIONS(6322),
    [anon_sym_bitand] = ACTIONS(6322),
    [anon_sym_not_eq] = ACTIONS(6322),
    [anon_sym_is] = ACTIONS(6322),
    [anon_sym_as] = ACTIONS(6322),
    [anon_sym_DASH_DASH] = ACTIONS(6324),
    [anon_sym_PLUS_PLUS] = ACTIONS(6324),
    [anon_sym_DOT] = ACTIONS(6322),
    [anon_sym_DOT_STAR] = ACTIONS(6324),
    [anon_sym_DASH_GT] = ACTIONS(6324),
    [sym_comment] = ACTIONS(3),
  },
  [3475] = {
    [sym_identifier] = ACTIONS(6322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6324),
    [anon_sym_COMMA] = ACTIONS(6324),
    [anon_sym_RPAREN] = ACTIONS(6324),
    [aux_sym_preproc_if_token2] = ACTIONS(6324),
    [aux_sym_preproc_else_token1] = ACTIONS(6324),
    [aux_sym_preproc_elif_token1] = ACTIONS(6322),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6324),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6324),
    [anon_sym_LPAREN2] = ACTIONS(6324),
    [anon_sym_DASH] = ACTIONS(6322),
    [anon_sym_PLUS] = ACTIONS(6322),
    [anon_sym_STAR] = ACTIONS(6322),
    [anon_sym_SLASH] = ACTIONS(6322),
    [anon_sym_PERCENT] = ACTIONS(6322),
    [anon_sym_PIPE_PIPE] = ACTIONS(6324),
    [anon_sym_AMP_AMP] = ACTIONS(6324),
    [anon_sym_PIPE] = ACTIONS(6322),
    [anon_sym_CARET] = ACTIONS(6322),
    [anon_sym_AMP] = ACTIONS(6322),
    [anon_sym_EQ_EQ] = ACTIONS(6324),
    [anon_sym_BANG_EQ] = ACTIONS(6324),
    [anon_sym_GT] = ACTIONS(6322),
    [anon_sym_GT_EQ] = ACTIONS(6324),
    [anon_sym_LT_EQ] = ACTIONS(6322),
    [anon_sym_LT] = ACTIONS(6322),
    [anon_sym_LT_LT] = ACTIONS(6322),
    [anon_sym_GT_GT] = ACTIONS(6322),
    [anon_sym_COLON] = ACTIONS(6324),
    [anon_sym_SEMI] = ACTIONS(6324),
    [anon_sym___attribute__] = ACTIONS(6322),
    [anon_sym___attribute] = ACTIONS(6322),
    [anon_sym_RBRACE] = ACTIONS(6324),
    [anon_sym_LBRACK] = ACTIONS(6324),
    [anon_sym_RBRACK] = ACTIONS(6324),
    [anon_sym_EQ] = ACTIONS(6322),
    [anon_sym_QMARK] = ACTIONS(6324),
    [anon_sym_STAR_EQ] = ACTIONS(6324),
    [anon_sym_SLASH_EQ] = ACTIONS(6324),
    [anon_sym_PERCENT_EQ] = ACTIONS(6324),
    [anon_sym_PLUS_EQ] = ACTIONS(6324),
    [anon_sym_DASH_EQ] = ACTIONS(6324),
    [anon_sym_LT_LT_EQ] = ACTIONS(6324),
    [anon_sym_GT_GT_EQ] = ACTIONS(6324),
    [anon_sym_AMP_EQ] = ACTIONS(6324),
    [anon_sym_CARET_EQ] = ACTIONS(6324),
    [anon_sym_PIPE_EQ] = ACTIONS(6324),
    [anon_sym_and_eq] = ACTIONS(6322),
    [anon_sym_or_eq] = ACTIONS(6322),
    [anon_sym_xor_eq] = ACTIONS(6322),
    [anon_sym_LT_EQ_GT] = ACTIONS(6324),
    [anon_sym_or] = ACTIONS(6322),
    [anon_sym_and] = ACTIONS(6322),
    [anon_sym_bitor] = ACTIONS(6322),
    [anon_sym_xor] = ACTIONS(6322),
    [anon_sym_bitand] = ACTIONS(6322),
    [anon_sym_not_eq] = ACTIONS(6322),
    [anon_sym_is] = ACTIONS(6322),
    [anon_sym_as] = ACTIONS(6322),
    [anon_sym_DASH_DASH] = ACTIONS(6324),
    [anon_sym_PLUS_PLUS] = ACTIONS(6324),
    [anon_sym_DOT] = ACTIONS(6322),
    [anon_sym_DOT_STAR] = ACTIONS(6324),
    [anon_sym_DASH_GT] = ACTIONS(6324),
    [sym_comment] = ACTIONS(3),
  },
  [3476] = {
    [sym_identifier] = ACTIONS(6322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6324),
    [anon_sym_COMMA] = ACTIONS(6324),
    [anon_sym_RPAREN] = ACTIONS(6324),
    [aux_sym_preproc_if_token2] = ACTIONS(6324),
    [aux_sym_preproc_else_token1] = ACTIONS(6324),
    [aux_sym_preproc_elif_token1] = ACTIONS(6322),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6324),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6324),
    [anon_sym_LPAREN2] = ACTIONS(6324),
    [anon_sym_DASH] = ACTIONS(6322),
    [anon_sym_PLUS] = ACTIONS(6322),
    [anon_sym_STAR] = ACTIONS(6322),
    [anon_sym_SLASH] = ACTIONS(6322),
    [anon_sym_PERCENT] = ACTIONS(6322),
    [anon_sym_PIPE_PIPE] = ACTIONS(6324),
    [anon_sym_AMP_AMP] = ACTIONS(6324),
    [anon_sym_PIPE] = ACTIONS(6322),
    [anon_sym_CARET] = ACTIONS(6322),
    [anon_sym_AMP] = ACTIONS(6322),
    [anon_sym_EQ_EQ] = ACTIONS(6324),
    [anon_sym_BANG_EQ] = ACTIONS(6324),
    [anon_sym_GT] = ACTIONS(6322),
    [anon_sym_GT_EQ] = ACTIONS(6324),
    [anon_sym_LT_EQ] = ACTIONS(6322),
    [anon_sym_LT] = ACTIONS(6322),
    [anon_sym_LT_LT] = ACTIONS(6322),
    [anon_sym_GT_GT] = ACTIONS(6322),
    [anon_sym_COLON] = ACTIONS(6324),
    [anon_sym_SEMI] = ACTIONS(6324),
    [anon_sym___attribute__] = ACTIONS(6322),
    [anon_sym___attribute] = ACTIONS(6322),
    [anon_sym_RBRACE] = ACTIONS(6324),
    [anon_sym_LBRACK] = ACTIONS(6324),
    [anon_sym_RBRACK] = ACTIONS(6324),
    [anon_sym_EQ] = ACTIONS(6322),
    [anon_sym_QMARK] = ACTIONS(6324),
    [anon_sym_STAR_EQ] = ACTIONS(6324),
    [anon_sym_SLASH_EQ] = ACTIONS(6324),
    [anon_sym_PERCENT_EQ] = ACTIONS(6324),
    [anon_sym_PLUS_EQ] = ACTIONS(6324),
    [anon_sym_DASH_EQ] = ACTIONS(6324),
    [anon_sym_LT_LT_EQ] = ACTIONS(6324),
    [anon_sym_GT_GT_EQ] = ACTIONS(6324),
    [anon_sym_AMP_EQ] = ACTIONS(6324),
    [anon_sym_CARET_EQ] = ACTIONS(6324),
    [anon_sym_PIPE_EQ] = ACTIONS(6324),
    [anon_sym_and_eq] = ACTIONS(6322),
    [anon_sym_or_eq] = ACTIONS(6322),
    [anon_sym_xor_eq] = ACTIONS(6322),
    [anon_sym_LT_EQ_GT] = ACTIONS(6324),
    [anon_sym_or] = ACTIONS(6322),
    [anon_sym_and] = ACTIONS(6322),
    [anon_sym_bitor] = ACTIONS(6322),
    [anon_sym_xor] = ACTIONS(6322),
    [anon_sym_bitand] = ACTIONS(6322),
    [anon_sym_not_eq] = ACTIONS(6322),
    [anon_sym_is] = ACTIONS(6322),
    [anon_sym_as] = ACTIONS(6322),
    [anon_sym_DASH_DASH] = ACTIONS(6324),
    [anon_sym_PLUS_PLUS] = ACTIONS(6324),
    [anon_sym_DOT] = ACTIONS(6322),
    [anon_sym_DOT_STAR] = ACTIONS(6324),
    [anon_sym_DASH_GT] = ACTIONS(6324),
    [sym_comment] = ACTIONS(3),
  },
  [3477] = {
    [sym_identifier] = ACTIONS(8053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8055),
    [anon_sym_COMMA] = ACTIONS(8055),
    [anon_sym_RPAREN] = ACTIONS(8055),
    [aux_sym_preproc_if_token2] = ACTIONS(8055),
    [aux_sym_preproc_else_token1] = ACTIONS(8055),
    [aux_sym_preproc_elif_token1] = ACTIONS(8053),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(8055),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(8055),
    [anon_sym_LPAREN2] = ACTIONS(8055),
    [anon_sym_DASH] = ACTIONS(8053),
    [anon_sym_PLUS] = ACTIONS(8053),
    [anon_sym_STAR] = ACTIONS(8053),
    [anon_sym_SLASH] = ACTIONS(8053),
    [anon_sym_PERCENT] = ACTIONS(8053),
    [anon_sym_PIPE_PIPE] = ACTIONS(8055),
    [anon_sym_AMP_AMP] = ACTIONS(8055),
    [anon_sym_PIPE] = ACTIONS(8053),
    [anon_sym_CARET] = ACTIONS(8053),
    [anon_sym_AMP] = ACTIONS(8053),
    [anon_sym_EQ_EQ] = ACTIONS(8055),
    [anon_sym_BANG_EQ] = ACTIONS(8055),
    [anon_sym_GT] = ACTIONS(8053),
    [anon_sym_GT_EQ] = ACTIONS(8055),
    [anon_sym_LT_EQ] = ACTIONS(8053),
    [anon_sym_LT] = ACTIONS(8053),
    [anon_sym_LT_LT] = ACTIONS(8053),
    [anon_sym_GT_GT] = ACTIONS(8053),
    [anon_sym_COLON] = ACTIONS(8055),
    [anon_sym_SEMI] = ACTIONS(8055),
    [anon_sym___attribute__] = ACTIONS(8053),
    [anon_sym___attribute] = ACTIONS(8053),
    [anon_sym_RBRACE] = ACTIONS(8055),
    [anon_sym_LBRACK] = ACTIONS(8055),
    [anon_sym_RBRACK] = ACTIONS(8055),
    [anon_sym_EQ] = ACTIONS(8053),
    [anon_sym_QMARK] = ACTIONS(8055),
    [anon_sym_STAR_EQ] = ACTIONS(8055),
    [anon_sym_SLASH_EQ] = ACTIONS(8055),
    [anon_sym_PERCENT_EQ] = ACTIONS(8055),
    [anon_sym_PLUS_EQ] = ACTIONS(8055),
    [anon_sym_DASH_EQ] = ACTIONS(8055),
    [anon_sym_LT_LT_EQ] = ACTIONS(8055),
    [anon_sym_GT_GT_EQ] = ACTIONS(8055),
    [anon_sym_AMP_EQ] = ACTIONS(8055),
    [anon_sym_CARET_EQ] = ACTIONS(8055),
    [anon_sym_PIPE_EQ] = ACTIONS(8055),
    [anon_sym_and_eq] = ACTIONS(8053),
    [anon_sym_or_eq] = ACTIONS(8053),
    [anon_sym_xor_eq] = ACTIONS(8053),
    [anon_sym_LT_EQ_GT] = ACTIONS(8055),
    [anon_sym_or] = ACTIONS(8053),
    [anon_sym_and] = ACTIONS(8053),
    [anon_sym_bitor] = ACTIONS(8053),
    [anon_sym_xor] = ACTIONS(8053),
    [anon_sym_bitand] = ACTIONS(8053),
    [anon_sym_not_eq] = ACTIONS(8053),
    [anon_sym_is] = ACTIONS(8053),
    [anon_sym_as] = ACTIONS(8053),
    [anon_sym_DASH_DASH] = ACTIONS(8055),
    [anon_sym_PLUS_PLUS] = ACTIONS(8055),
    [anon_sym_DOT] = ACTIONS(8053),
    [anon_sym_DOT_STAR] = ACTIONS(8055),
    [anon_sym_DASH_GT] = ACTIONS(8055),
    [sym_comment] = ACTIONS(3),
  },
  [3478] = {
    [sym_identifier] = ACTIONS(8057),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8059),
    [anon_sym_COMMA] = ACTIONS(8059),
    [anon_sym_RPAREN] = ACTIONS(8059),
    [aux_sym_preproc_if_token2] = ACTIONS(8059),
    [aux_sym_preproc_else_token1] = ACTIONS(8059),
    [aux_sym_preproc_elif_token1] = ACTIONS(8057),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(8059),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(8059),
    [anon_sym_LPAREN2] = ACTIONS(8059),
    [anon_sym_DASH] = ACTIONS(8057),
    [anon_sym_PLUS] = ACTIONS(8057),
    [anon_sym_STAR] = ACTIONS(8057),
    [anon_sym_SLASH] = ACTIONS(8057),
    [anon_sym_PERCENT] = ACTIONS(8057),
    [anon_sym_PIPE_PIPE] = ACTIONS(8059),
    [anon_sym_AMP_AMP] = ACTIONS(8059),
    [anon_sym_PIPE] = ACTIONS(8057),
    [anon_sym_CARET] = ACTIONS(8057),
    [anon_sym_AMP] = ACTIONS(8057),
    [anon_sym_EQ_EQ] = ACTIONS(8059),
    [anon_sym_BANG_EQ] = ACTIONS(8059),
    [anon_sym_GT] = ACTIONS(8057),
    [anon_sym_GT_EQ] = ACTIONS(8059),
    [anon_sym_LT_EQ] = ACTIONS(8057),
    [anon_sym_LT] = ACTIONS(8057),
    [anon_sym_LT_LT] = ACTIONS(8057),
    [anon_sym_GT_GT] = ACTIONS(8057),
    [anon_sym_COLON] = ACTIONS(8059),
    [anon_sym_SEMI] = ACTIONS(8059),
    [anon_sym___attribute__] = ACTIONS(8057),
    [anon_sym___attribute] = ACTIONS(8057),
    [anon_sym_RBRACE] = ACTIONS(8059),
    [anon_sym_LBRACK] = ACTIONS(8059),
    [anon_sym_RBRACK] = ACTIONS(8059),
    [anon_sym_EQ] = ACTIONS(8057),
    [anon_sym_QMARK] = ACTIONS(8059),
    [anon_sym_STAR_EQ] = ACTIONS(8059),
    [anon_sym_SLASH_EQ] = ACTIONS(8059),
    [anon_sym_PERCENT_EQ] = ACTIONS(8059),
    [anon_sym_PLUS_EQ] = ACTIONS(8059),
    [anon_sym_DASH_EQ] = ACTIONS(8059),
    [anon_sym_LT_LT_EQ] = ACTIONS(8059),
    [anon_sym_GT_GT_EQ] = ACTIONS(8059),
    [anon_sym_AMP_EQ] = ACTIONS(8059),
    [anon_sym_CARET_EQ] = ACTIONS(8059),
    [anon_sym_PIPE_EQ] = ACTIONS(8059),
    [anon_sym_and_eq] = ACTIONS(8057),
    [anon_sym_or_eq] = ACTIONS(8057),
    [anon_sym_xor_eq] = ACTIONS(8057),
    [anon_sym_LT_EQ_GT] = ACTIONS(8059),
    [anon_sym_or] = ACTIONS(8057),
    [anon_sym_and] = ACTIONS(8057),
    [anon_sym_bitor] = ACTIONS(8057),
    [anon_sym_xor] = ACTIONS(8057),
    [anon_sym_bitand] = ACTIONS(8057),
    [anon_sym_not_eq] = ACTIONS(8057),
    [anon_sym_is] = ACTIONS(8057),
    [anon_sym_as] = ACTIONS(8057),
    [anon_sym_DASH_DASH] = ACTIONS(8059),
    [anon_sym_PLUS_PLUS] = ACTIONS(8059),
    [anon_sym_DOT] = ACTIONS(8057),
    [anon_sym_DOT_STAR] = ACTIONS(8059),
    [anon_sym_DASH_GT] = ACTIONS(8059),
    [sym_comment] = ACTIONS(3),
  },
  [3479] = {
    [sym_identifier] = ACTIONS(8061),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8063),
    [anon_sym_COMMA] = ACTIONS(8063),
    [anon_sym_RPAREN] = ACTIONS(8063),
    [aux_sym_preproc_if_token2] = ACTIONS(8063),
    [aux_sym_preproc_else_token1] = ACTIONS(8063),
    [aux_sym_preproc_elif_token1] = ACTIONS(8061),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(8063),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(8063),
    [anon_sym_LPAREN2] = ACTIONS(8063),
    [anon_sym_DASH] = ACTIONS(8061),
    [anon_sym_PLUS] = ACTIONS(8061),
    [anon_sym_STAR] = ACTIONS(8061),
    [anon_sym_SLASH] = ACTIONS(8061),
    [anon_sym_PERCENT] = ACTIONS(8061),
    [anon_sym_PIPE_PIPE] = ACTIONS(8063),
    [anon_sym_AMP_AMP] = ACTIONS(8063),
    [anon_sym_PIPE] = ACTIONS(8061),
    [anon_sym_CARET] = ACTIONS(8061),
    [anon_sym_AMP] = ACTIONS(8061),
    [anon_sym_EQ_EQ] = ACTIONS(8063),
    [anon_sym_BANG_EQ] = ACTIONS(8063),
    [anon_sym_GT] = ACTIONS(8061),
    [anon_sym_GT_EQ] = ACTIONS(8063),
    [anon_sym_LT_EQ] = ACTIONS(8061),
    [anon_sym_LT] = ACTIONS(8061),
    [anon_sym_LT_LT] = ACTIONS(8061),
    [anon_sym_GT_GT] = ACTIONS(8061),
    [anon_sym_COLON] = ACTIONS(8063),
    [anon_sym_SEMI] = ACTIONS(8063),
    [anon_sym___attribute__] = ACTIONS(8061),
    [anon_sym___attribute] = ACTIONS(8061),
    [anon_sym_RBRACE] = ACTIONS(8063),
    [anon_sym_LBRACK] = ACTIONS(8063),
    [anon_sym_RBRACK] = ACTIONS(8063),
    [anon_sym_EQ] = ACTIONS(8061),
    [anon_sym_QMARK] = ACTIONS(8063),
    [anon_sym_STAR_EQ] = ACTIONS(8063),
    [anon_sym_SLASH_EQ] = ACTIONS(8063),
    [anon_sym_PERCENT_EQ] = ACTIONS(8063),
    [anon_sym_PLUS_EQ] = ACTIONS(8063),
    [anon_sym_DASH_EQ] = ACTIONS(8063),
    [anon_sym_LT_LT_EQ] = ACTIONS(8063),
    [anon_sym_GT_GT_EQ] = ACTIONS(8063),
    [anon_sym_AMP_EQ] = ACTIONS(8063),
    [anon_sym_CARET_EQ] = ACTIONS(8063),
    [anon_sym_PIPE_EQ] = ACTIONS(8063),
    [anon_sym_and_eq] = ACTIONS(8061),
    [anon_sym_or_eq] = ACTIONS(8061),
    [anon_sym_xor_eq] = ACTIONS(8061),
    [anon_sym_LT_EQ_GT] = ACTIONS(8063),
    [anon_sym_or] = ACTIONS(8061),
    [anon_sym_and] = ACTIONS(8061),
    [anon_sym_bitor] = ACTIONS(8061),
    [anon_sym_xor] = ACTIONS(8061),
    [anon_sym_bitand] = ACTIONS(8061),
    [anon_sym_not_eq] = ACTIONS(8061),
    [anon_sym_is] = ACTIONS(8061),
    [anon_sym_as] = ACTIONS(8061),
    [anon_sym_DASH_DASH] = ACTIONS(8063),
    [anon_sym_PLUS_PLUS] = ACTIONS(8063),
    [anon_sym_DOT] = ACTIONS(8061),
    [anon_sym_DOT_STAR] = ACTIONS(8063),
    [anon_sym_DASH_GT] = ACTIONS(8063),
    [sym_comment] = ACTIONS(3),
  },
  [3480] = {
    [sym_identifier] = ACTIONS(7288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7290),
    [anon_sym_COMMA] = ACTIONS(7290),
    [anon_sym_LPAREN2] = ACTIONS(7290),
    [anon_sym_DASH] = ACTIONS(7288),
    [anon_sym_PLUS] = ACTIONS(7288),
    [anon_sym_STAR] = ACTIONS(7288),
    [anon_sym_SLASH] = ACTIONS(7288),
    [anon_sym_PERCENT] = ACTIONS(7288),
    [anon_sym_PIPE_PIPE] = ACTIONS(7290),
    [anon_sym_AMP_AMP] = ACTIONS(7290),
    [anon_sym_PIPE] = ACTIONS(7288),
    [anon_sym_CARET] = ACTIONS(7288),
    [anon_sym_AMP] = ACTIONS(7288),
    [anon_sym_EQ_EQ] = ACTIONS(7290),
    [anon_sym_BANG_EQ] = ACTIONS(7290),
    [anon_sym_GT] = ACTIONS(7288),
    [anon_sym_GT_EQ] = ACTIONS(7288),
    [anon_sym_LT_EQ] = ACTIONS(7288),
    [anon_sym_LT] = ACTIONS(7288),
    [anon_sym_LT_LT] = ACTIONS(7288),
    [anon_sym_GT_GT] = ACTIONS(7288),
    [anon_sym_LBRACK] = ACTIONS(7290),
    [anon_sym_EQ] = ACTIONS(7288),
    [anon_sym_QMARK] = ACTIONS(7290),
    [anon_sym_STAR_EQ] = ACTIONS(7290),
    [anon_sym_SLASH_EQ] = ACTIONS(7290),
    [anon_sym_PERCENT_EQ] = ACTIONS(7290),
    [anon_sym_PLUS_EQ] = ACTIONS(7290),
    [anon_sym_DASH_EQ] = ACTIONS(7290),
    [anon_sym_LT_LT_EQ] = ACTIONS(7290),
    [anon_sym_GT_GT_EQ] = ACTIONS(7288),
    [anon_sym_AMP_EQ] = ACTIONS(7290),
    [anon_sym_CARET_EQ] = ACTIONS(7290),
    [anon_sym_PIPE_EQ] = ACTIONS(7290),
    [anon_sym_and_eq] = ACTIONS(7288),
    [anon_sym_or_eq] = ACTIONS(7288),
    [anon_sym_xor_eq] = ACTIONS(7288),
    [anon_sym_LT_EQ_GT] = ACTIONS(7290),
    [anon_sym_or] = ACTIONS(7288),
    [anon_sym_and] = ACTIONS(7288),
    [anon_sym_bitor] = ACTIONS(7288),
    [anon_sym_xor] = ACTIONS(7288),
    [anon_sym_bitand] = ACTIONS(7288),
    [anon_sym_not_eq] = ACTIONS(7288),
    [anon_sym_is] = ACTIONS(7288),
    [anon_sym_as] = ACTIONS(7288),
    [anon_sym_DASH_DASH] = ACTIONS(7290),
    [anon_sym_PLUS_PLUS] = ACTIONS(7290),
    [anon_sym_DOT] = ACTIONS(7288),
    [anon_sym_DOT_STAR] = ACTIONS(7290),
    [anon_sym_DASH_GT] = ACTIONS(7290),
    [anon_sym_L_DQUOTE] = ACTIONS(7290),
    [anon_sym_u_DQUOTE] = ACTIONS(7290),
    [anon_sym_U_DQUOTE] = ACTIONS(7290),
    [anon_sym_u8_DQUOTE] = ACTIONS(7290),
    [anon_sym_DQUOTE] = ACTIONS(7290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(7290),
    [anon_sym_R_DQUOTE] = ACTIONS(7290),
    [anon_sym_LR_DQUOTE] = ACTIONS(7290),
    [anon_sym_uR_DQUOTE] = ACTIONS(7290),
    [anon_sym_UR_DQUOTE] = ACTIONS(7290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(7290),
    [sym_literal_suffix] = ACTIONS(7288),
  },
  [3481] = {
    [sym_ms_based_modifier] = STATE(11547),
    [sym_ms_unaligned_ptr_modifier] = STATE(5091),
    [sym_ms_pointer_modifier] = STATE(3437),
    [sym__declarator] = STATE(8468),
    [sym__abstract_declarator] = STATE(8839),
    [sym_parenthesized_declarator] = STATE(8054),
    [sym_abstract_parenthesized_declarator] = STATE(7454),
    [sym_attributed_declarator] = STATE(8054),
    [sym_pointer_declarator] = STATE(8054),
    [sym_abstract_pointer_declarator] = STATE(7454),
    [sym_function_declarator] = STATE(8054),
    [sym_abstract_function_declarator] = STATE(7454),
    [sym_array_declarator] = STATE(8054),
    [sym_abstract_array_declarator] = STATE(7454),
    [sym_type_qualifier] = STATE(3872),
    [sym_alignas_qualifier] = STATE(5539),
    [sym_parameter_list] = STATE(3873),
    [sym_decltype] = STATE(11339),
    [sym_reference_declarator] = STATE(8054),
    [sym_abstract_reference_declarator] = STATE(7454),
    [sym_structured_binding_declarator] = STATE(8054),
    [sym__function_declarator_seq] = STATE(7543),
    [sym_template_type] = STATE(11339),
    [sym_template_function] = STATE(8054),
    [sym_destructor_name] = STATE(8054),
    [sym_dependent_type_identifier] = STATE(11339),
    [sym__scope_resolution] = STATE(7421),
    [sym_qualified_identifier] = STATE(8054),
    [sym_operator_name] = STATE(8054),
    [aux_sym__type_definition_type_repeat1] = STATE(3872),
    [aux_sym_pointer_declarator_repeat1] = STATE(3437),
    [sym_identifier] = ACTIONS(6718),
    [anon_sym_RPAREN] = ACTIONS(7396),
    [anon_sym_LPAREN2] = ACTIONS(5344),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(5346),
    [anon_sym_AMP_AMP] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym___extension__] = ACTIONS(5368),
    [anon_sym_COLON_COLON] = ACTIONS(7999),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(5364),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(5364),
    [sym_ms_signed_ptr_modifier] = ACTIONS(5364),
    [anon_sym__unaligned] = ACTIONS(5366),
    [anon_sym___unaligned] = ACTIONS(5366),
    [anon_sym_LBRACK] = ACTIONS(7408),
    [anon_sym_const] = ACTIONS(5368),
    [anon_sym_constexpr] = ACTIONS(5368),
    [anon_sym_volatile] = ACTIONS(5368),
    [anon_sym_restrict] = ACTIONS(5368),
    [anon_sym___restrict__] = ACTIONS(5368),
    [anon_sym__Atomic] = ACTIONS(5368),
    [anon_sym__Noreturn] = ACTIONS(5368),
    [anon_sym_noreturn] = ACTIONS(5368),
    [anon_sym__Nonnull] = ACTIONS(5368),
    [anon_sym_mutable] = ACTIONS(5368),
    [anon_sym_constinit] = ACTIONS(5368),
    [anon_sym_consteval] = ACTIONS(5368),
    [anon_sym_alignas] = ACTIONS(5370),
    [anon_sym__Alignas] = ACTIONS(5370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1816),
    [anon_sym_operator] = ACTIONS(2861),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7160), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [71] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7720), 1,
      anon_sym___attribute__,
    ACTIONS(7722), 1,
      anon_sym___attribute,
    ACTIONS(8065), 1,
      anon_sym_COLON,
    ACTIONS(8067), 1,
      anon_sym_LBRACE,
    STATE(3558), 1,
      sym__enum_base_clause,
    STATE(3596), 1,
      sym_enumerator_list,
    STATE(3744), 1,
      sym_attribute_specifier,
    ACTIONS(3502), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3504), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8055), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8053), 37,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_interface,
      anon_sym_extension,
  [227] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8069), 1,
      anon_sym_LT,
    STATE(3522), 1,
      sym_template_argument_list,
    ACTIONS(2222), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2229), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8059), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8057), 37,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_interface,
      anon_sym_extension,
  [375] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7720), 1,
      anon_sym___attribute__,
    ACTIONS(7722), 1,
      anon_sym___attribute,
    ACTIONS(8065), 1,
      anon_sym_COLON,
    ACTIONS(8067), 1,
      anon_sym_LBRACE,
    STATE(3561), 1,
      sym__enum_base_clause,
    STATE(3599), 1,
      sym_enumerator_list,
    STATE(3791), 1,
      sym_attribute_specifier,
    ACTIONS(3478), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3480), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [460] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(8072), 1,
      anon_sym___attribute__,
    ACTIONS(8074), 1,
      anon_sym___attribute,
    ACTIONS(8076), 1,
      anon_sym_LBRACE,
    STATE(3739), 1,
      sym_field_declaration_list,
    STATE(4347), 1,
      sym_attribute_specifier,
    STATE(9471), 1,
      sym_virtual_specifier,
    STATE(10549), 1,
      sym_base_class_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2893), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2895), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7953), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7951), 37,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_interface,
      anon_sym_extension,
  [620] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2420), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
    ACTIONS(2422), 35,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [693] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2420), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
    ACTIONS(2422), 35,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
    ACTIONS(2418), 35,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [837] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_DOT,
    ACTIONS(6959), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4254), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4252), 54,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_in,
      anon_sym_out,
      anon_sym_inout,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_operator,
      anon_sym_precise,
      anon_sym_shared,
      anon_sym_groupshared,
      anon_sym_uniform,
      anon_sym_row_major,
      anon_sym_column_major,
      anon_sym_globallycoherent,
      anon_sym_centroid,
      anon_sym_noperspective,
      anon_sym_nointerpolation,
      anon_sym_sample,
      anon_sym_linear,
      anon_sym_snorm,
      anon_sym_unorm,
      anon_sym_point,
      anon_sym_line,
      anon_sym_triangleadj,
      anon_sym_lineadj,
      anon_sym_triangle,
  [912] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2422), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2420), 41,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [985] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2422), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2420), 41,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [1058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7288), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7290), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [1129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7313), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [1200] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8078), 1,
      anon_sym_LT,
    STATE(3522), 1,
      sym_template_argument_list,
    ACTIONS(2410), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2408), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [1277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2418), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2416), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [1348] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3337), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(5383), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5385), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(7386), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(7388), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [1425] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    STATE(2953), 1,
      sym_template_argument_list,
    STATE(3553), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8080), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3777), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3775), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [1504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2428), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2426), 41,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [1577] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_DOT,
    ACTIONS(6959), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4246), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4244), 54,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_in,
      anon_sym_out,
      anon_sym_inout,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_operator,
      anon_sym_precise,
      anon_sym_shared,
      anon_sym_groupshared,
      anon_sym_uniform,
      anon_sym_row_major,
      anon_sym_column_major,
      anon_sym_globallycoherent,
      anon_sym_centroid,
      anon_sym_noperspective,
      anon_sym_nointerpolation,
      anon_sym_sample,
      anon_sym_linear,
      anon_sym_snorm,
      anon_sym_unorm,
      anon_sym_point,
      anon_sym_line,
      anon_sym_triangleadj,
      anon_sym_lineadj,
      anon_sym_triangle,
  [1652] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2878), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8082), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4078), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4080), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [1727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7150), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7152), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [1798] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2878), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8082), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4093), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4095), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [1873] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3509), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8084), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4111), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4113), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [1948] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3510), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8086), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4053), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4051), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [2023] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2878), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8082), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3995), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3997), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [2098] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2878), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8082), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4102), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4100), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [2173] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3516), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4164), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4166), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [2248] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3517), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8090), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4178), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4180), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [2323] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2878), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8082), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4185), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4187), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [2398] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3504), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8092), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2974), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2972), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [2473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2250), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [2544] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2878), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8082), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4064), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4062), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [2619] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2878), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8082), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4073), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4071), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [2694] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8078), 1,
      anon_sym_LT,
    STATE(3506), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3522), 1,
      sym_template_argument_list,
    ACTIONS(7850), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2168), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2176), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [2775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2420), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
    ACTIONS(2422), 34,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [2845] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8094), 1,
      anon_sym_DOT,
    ACTIONS(8096), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4252), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(4254), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2919] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8094), 1,
      anon_sym_DOT,
    ACTIONS(8096), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4244), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(4246), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2250), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [3063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2420), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [3133] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7808), 1,
      anon_sym___attribute__,
    ACTIONS(7810), 1,
      anon_sym___attribute,
    ACTIONS(8098), 1,
      anon_sym_COLON,
    ACTIONS(8100), 1,
      anon_sym_LBRACE,
    STATE(3604), 1,
      sym__enum_base_clause,
    STATE(3630), 1,
      sym_enumerator_list,
    STATE(3813), 1,
      sym_attribute_specifier,
    ACTIONS(3478), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3480), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [3217] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7808), 1,
      anon_sym___attribute__,
    ACTIONS(7810), 1,
      anon_sym___attribute,
    ACTIONS(8098), 1,
      anon_sym_COLON,
    ACTIONS(8100), 1,
      anon_sym_LBRACE,
    STATE(3607), 1,
      sym__enum_base_clause,
    STATE(3633), 1,
      sym_enumerator_list,
    STATE(3821), 1,
      sym_attribute_specifier,
    ACTIONS(3502), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3504), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [3301] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8102), 1,
      sym_identifier,
    STATE(3531), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2209), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2211), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(7219), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7217), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3379] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8104), 1,
      sym_identifier,
    STATE(3526), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2209), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2211), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(7192), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7190), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3457] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2428), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2426), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [3529] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(5344), 1,
      anon_sym_LPAREN2,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7398), 1,
      anon_sym_STAR,
    ACTIONS(7400), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7402), 1,
      anon_sym_AMP,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7408), 1,
      anon_sym_LBRACK,
    STATE(3727), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7901), 1,
      sym__declarator,
    STATE(8361), 1,
      sym__abstract_declarator,
    STATE(10947), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7412), 3,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7410), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [3649] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(5344), 1,
      anon_sym_LPAREN2,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7398), 1,
      anon_sym_STAR,
    ACTIONS(7400), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7402), 1,
      anon_sym_AMP,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7408), 1,
      anon_sym_LBRACK,
    STATE(3727), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7944), 1,
      sym__declarator,
    STATE(8362), 1,
      sym__abstract_declarator,
    STATE(10947), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8108), 3,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8106), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [3769] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8110), 1,
      sym_identifier,
    STATE(3531), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(8113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(8116), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(7207), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7205), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(7160), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [3917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2418), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2416), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [3987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7150), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(7152), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [4057] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3395), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8047), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2883), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2881), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [4131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7288), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(7290), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [4201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(7313), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [4271] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2422), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2420), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [4343] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2422), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2420), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [4415] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym_requires,
    ACTIONS(8155), 1,
      anon_sym_where,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(5417), 1,
      sym__function_attributes_start,
    STATE(6042), 1,
      sym_ref_qualifier,
    STATE(7039), 1,
      sym__function_attributes_end,
    STATE(7315), 1,
      sym_trailing_return_type,
    STATE(7459), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8145), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5009), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7723), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6449), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8119), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [4542] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3545), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8158), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4164), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4166), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [4615] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3546), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8160), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4178), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4180), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [4688] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2939), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8162), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4185), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4187), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [4761] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3550), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8164), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2974), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2972), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [4834] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2939), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8162), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4064), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4062), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [4907] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2939), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8162), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4073), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4071), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [4980] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3504), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8092), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2883), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2881), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [5053] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8166), 1,
      anon_sym_LT,
    STATE(3595), 1,
      sym_template_argument_list,
    ACTIONS(2410), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2408), 41,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [5128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(7313), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [5197] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2939), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8162), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4078), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4080), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [5270] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8172), 1,
      anon_sym_where,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(5419), 1,
      sym__function_attributes_start,
    STATE(6001), 1,
      sym_ref_qualifier,
    STATE(7030), 1,
      sym__function_attributes_end,
    STATE(7300), 1,
      sym_trailing_return_type,
    STATE(7459), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5009), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8168), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6470), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8119), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [5397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7150), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(7152), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [5466] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2939), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8162), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4093), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4095), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [5539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2420), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [5608] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3565), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8174), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4111), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4113), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [5681] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8176), 1,
      anon_sym_LT,
    STATE(3595), 1,
      sym_template_argument_list,
    ACTIONS(2222), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2229), 41,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [5756] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8179), 1,
      anon_sym_DOT,
    ACTIONS(7362), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4244), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(4246), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5829] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7720), 1,
      anon_sym___attribute__,
    ACTIONS(7722), 1,
      anon_sym___attribute,
    ACTIONS(8067), 1,
      anon_sym_LBRACE,
    STATE(3572), 1,
      sym_enumerator_list,
    STATE(3725), 1,
      sym_attribute_specifier,
    ACTIONS(3993), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3991), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [5908] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3566), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8181), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4053), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4051), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [5981] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8179), 1,
      anon_sym_DOT,
    ACTIONS(7362), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4252), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(4254), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6054] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7720), 1,
      anon_sym___attribute__,
    ACTIONS(7722), 1,
      anon_sym___attribute,
    ACTIONS(8067), 1,
      anon_sym_LBRACE,
    STATE(3567), 1,
      sym_enumerator_list,
    STATE(3719), 1,
      sym_attribute_specifier,
    ACTIONS(3989), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3987), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [6133] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8166), 1,
      anon_sym_LT,
    STATE(3553), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3595), 1,
      sym_template_argument_list,
    ACTIONS(8080), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2168), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2176), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [6212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(7160), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [6281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7288), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(7290), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [6350] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2939), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8162), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3995), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3997), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [6423] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2939), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8162), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4102), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4100), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [6496] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7720), 1,
      anon_sym___attribute__,
    ACTIONS(7722), 1,
      anon_sym___attribute,
    STATE(3742), 1,
      sym_attribute_specifier,
    ACTIONS(4060), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4058), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [6570] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(5344), 1,
      anon_sym_LPAREN2,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7408), 1,
      anon_sym_LBRACK,
    ACTIONS(7562), 1,
      anon_sym_STAR,
    ACTIONS(7564), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7566), 1,
      anon_sym_AMP,
    STATE(4273), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7944), 1,
      sym__declarator,
    STATE(8740), 1,
      sym__abstract_declarator,
    STATE(10947), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8106), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8108), 3,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [6688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2300), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2302), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [6756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2260), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2262), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [6824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2428), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2426), 41,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [6894] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7720), 1,
      anon_sym___attribute__,
    ACTIONS(7722), 1,
      anon_sym___attribute,
    STATE(3788), 1,
      sym_attribute_specifier,
    ACTIONS(4087), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4085), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [6968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2304), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2306), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [7036] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7720), 1,
      anon_sym___attribute__,
    ACTIONS(7722), 1,
      anon_sym___attribute,
    STATE(3796), 1,
      sym_attribute_specifier,
    ACTIONS(4176), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4174), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [7110] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7720), 1,
      anon_sym___attribute__,
    ACTIONS(7722), 1,
      anon_sym___attribute,
    STATE(3766), 1,
      sym_attribute_specifier,
    ACTIONS(4004), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4002), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [7184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2308), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2310), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [7252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2312), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2314), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [7320] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_LBRACE,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8185), 1,
      anon_sym_LBRACK,
    STATE(3882), 1,
      sym_new_declarator,
    STATE(4642), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8187), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7368), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7370), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [7400] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7720), 1,
      anon_sym___attribute__,
    ACTIONS(7722), 1,
      anon_sym___attribute,
    STATE(3746), 1,
      sym_attribute_specifier,
    ACTIONS(4014), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4012), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [7474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2280), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2282), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [7542] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7720), 1,
      anon_sym___attribute__,
    ACTIONS(7722), 1,
      anon_sym___attribute,
    STATE(3729), 1,
      sym_attribute_specifier,
    ACTIONS(4010), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4008), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [7616] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7720), 1,
      anon_sym___attribute__,
    ACTIONS(7722), 1,
      anon_sym___attribute,
    STATE(3801), 1,
      sym_attribute_specifier,
    ACTIONS(4091), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4089), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [7690] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_LBRACE,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8185), 1,
      anon_sym_LBRACK,
    STATE(3866), 1,
      sym_new_declarator,
    STATE(4620), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8187), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7376), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7378), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [7770] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7720), 1,
      anon_sym___attribute__,
    ACTIONS(7722), 1,
      anon_sym___attribute,
    STATE(3736), 1,
      sym_attribute_specifier,
    ACTIONS(4200), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4198), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [7844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2268), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2270), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [7912] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(5344), 1,
      anon_sym_LPAREN2,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7408), 1,
      anon_sym_LBRACK,
    ACTIONS(7507), 1,
      anon_sym_STAR,
    ACTIONS(7509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7511), 1,
      anon_sym_AMP,
    STATE(4120), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7944), 1,
      sym__declarator,
    STATE(8761), 1,
      sym__abstract_declarator,
    STATE(10947), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8106), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8108), 3,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [8030] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8072), 1,
      anon_sym___attribute__,
    ACTIONS(8074), 1,
      anon_sym___attribute,
    ACTIONS(8189), 1,
      anon_sym_COLON,
    ACTIONS(8191), 1,
      anon_sym_LBRACE,
    STATE(3708), 1,
      sym__enum_base_clause,
    STATE(3783), 1,
      sym_enumerator_list,
    STATE(4341), 1,
      sym_attribute_specifier,
    ACTIONS(3478), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3480), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [8112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2272), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2274), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [8180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2276), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2278), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [8248] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8193), 1,
      anon_sym___attribute__,
    ACTIONS(8196), 1,
      anon_sym___attribute,
    ACTIONS(8199), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8202), 1,
      anon_sym_DASH_GT,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8206), 1,
      anon_sym_where,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(5530), 1,
      sym__function_attributes_start,
    STATE(6126), 1,
      sym_ref_qualifier,
    STATE(6941), 1,
      sym__function_attributes_end,
    STATE(7002), 1,
      sym_trailing_return_type,
    STATE(7618), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5009), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7822), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6493), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8119), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [8374] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8072), 1,
      anon_sym___attribute__,
    ACTIONS(8074), 1,
      anon_sym___attribute,
    ACTIONS(8189), 1,
      anon_sym_COLON,
    ACTIONS(8191), 1,
      anon_sym_LBRACE,
    STATE(3699), 1,
      sym__enum_base_clause,
    STATE(3752), 1,
      sym_enumerator_list,
    STATE(4358), 1,
      sym_attribute_specifier,
    ACTIONS(3502), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3504), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [8456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2284), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2286), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [8524] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym_DOT,
    ACTIONS(7442), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4252), 8,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym_line,
      anon_sym_triangle,
    ACTIONS(4254), 48,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_out,
      anon_sym_inout,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_precise,
      anon_sym_shared,
      anon_sym_groupshared,
      anon_sym_uniform,
      anon_sym_row_major,
      anon_sym_column_major,
      anon_sym_globallycoherent,
      anon_sym_centroid,
      anon_sym_noperspective,
      anon_sym_nointerpolation,
      anon_sym_sample,
      anon_sym_linear,
      anon_sym_snorm,
      anon_sym_unorm,
      anon_sym_point,
      anon_sym_triangleadj,
      anon_sym_lineadj,
  [8596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2288), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2290), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [8664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2250), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [8732] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7720), 1,
      anon_sym___attribute__,
    ACTIONS(7722), 1,
      anon_sym___attribute,
    STATE(3765), 1,
      sym_attribute_specifier,
    ACTIONS(4156), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4154), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [8806] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2252), 2,
      anon_sym_AMP,
      anon_sym_DOT,
    ACTIONS(2243), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_const,
    ACTIONS(2247), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_GT2,
    ACTIONS(2255), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(2250), 19,
      anon_sym___extension__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2245), 20,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2292), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2294), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [8950] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7720), 1,
      anon_sym___attribute__,
    ACTIONS(7722), 1,
      anon_sym___attribute,
    STATE(3717), 1,
      sym_attribute_specifier,
    ACTIONS(4107), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4109), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [9024] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      anon_sym_DOT,
    ACTIONS(7442), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4244), 8,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym_line,
      anon_sym_triangle,
    ACTIONS(4246), 48,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_out,
      anon_sym_inout,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_precise,
      anon_sym_shared,
      anon_sym_groupshared,
      anon_sym_uniform,
      anon_sym_row_major,
      anon_sym_column_major,
      anon_sym_globallycoherent,
      anon_sym_centroid,
      anon_sym_noperspective,
      anon_sym_nointerpolation,
      anon_sym_sample,
      anon_sym_linear,
      anon_sym_snorm,
      anon_sym_unorm,
      anon_sym_point,
      anon_sym_triangleadj,
      anon_sym_lineadj,
  [9096] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_LBRACE,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8185), 1,
      anon_sym_LBRACK,
    STATE(3841), 1,
      sym_new_declarator,
    STATE(4540), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8187), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7354), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7356), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [9176] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_LBRACE,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8185), 1,
      anon_sym_LBRACK,
    STATE(3849), 1,
      sym_new_declarator,
    STATE(4638), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8187), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7372), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7374), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [9256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2239), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2241), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [9324] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7808), 1,
      anon_sym___attribute__,
    ACTIONS(7810), 1,
      anon_sym___attribute,
    ACTIONS(8100), 1,
      anon_sym_LBRACE,
    STATE(3634), 1,
      sym_enumerator_list,
    STATE(3825), 1,
      sym_attribute_specifier,
    ACTIONS(3989), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3987), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [9402] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7720), 1,
      anon_sym___attribute__,
    ACTIONS(7722), 1,
      anon_sym___attribute,
    STATE(3747), 1,
      sym_attribute_specifier,
    ACTIONS(4045), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4043), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [9476] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(5344), 1,
      anon_sym_LPAREN2,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7408), 1,
      anon_sym_LBRACK,
    ACTIONS(7562), 1,
      anon_sym_STAR,
    ACTIONS(7564), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7566), 1,
      anon_sym_AMP,
    STATE(4273), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7901), 1,
      sym__declarator,
    STATE(8675), 1,
      sym__abstract_declarator,
    STATE(10947), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7410), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7412), 3,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [9594] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7808), 1,
      anon_sym___attribute__,
    ACTIONS(7810), 1,
      anon_sym___attribute,
    ACTIONS(8100), 1,
      anon_sym_LBRACE,
    STATE(3637), 1,
      sym_enumerator_list,
    STATE(3836), 1,
      sym_attribute_specifier,
    ACTIONS(3993), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3991), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [9672] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8193), 1,
      anon_sym___attribute__,
    ACTIONS(8196), 1,
      anon_sym___attribute,
    ACTIONS(8199), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8202), 1,
      anon_sym_DASH_GT,
    ACTIONS(8211), 1,
      anon_sym_requires,
    ACTIONS(8214), 1,
      anon_sym_where,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(5606), 1,
      sym__function_attributes_start,
    STATE(6127), 1,
      sym_ref_qualifier,
    STATE(6934), 1,
      sym__function_attributes_end,
    STATE(7034), 1,
      sym_trailing_return_type,
    STATE(7618), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8208), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5009), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7508), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6497), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8119), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [9798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2296), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2298), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [9866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2264), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2266), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [9934] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7720), 1,
      anon_sym___attribute__,
    ACTIONS(7722), 1,
      anon_sym___attribute,
    STATE(3720), 1,
      sym_attribute_specifier,
    ACTIONS(4049), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4047), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [10008] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8217), 1,
      anon_sym_LT,
    STATE(3685), 1,
      sym_template_argument_list,
    ACTIONS(2229), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2222), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [10082] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(5344), 1,
      anon_sym_LPAREN2,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7408), 1,
      anon_sym_LBRACK,
    ACTIONS(7507), 1,
      anon_sym_STAR,
    ACTIONS(7509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7511), 1,
      anon_sym_AMP,
    STATE(4120), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7901), 1,
      sym__declarator,
    STATE(8726), 1,
      sym__abstract_declarator,
    STATE(10947), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7410), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7412), 3,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [10200] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8217), 1,
      anon_sym_LT,
    STATE(3685), 1,
      sym_template_argument_list,
    ACTIONS(2408), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2410), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [10274] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8233), 1,
      anon_sym_GT_EQ,
    ACTIONS(8237), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8239), 1,
      anon_sym_not_eq,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8219), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8223), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8225), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8227), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8229), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8241), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8221), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8231), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7771), 8,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
    ACTIONS(7773), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [10379] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8199), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8243), 1,
      anon_sym_DASH_GT,
    ACTIONS(8245), 1,
      anon_sym_where,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(5700), 1,
      sym__function_attributes_start,
    STATE(6226), 1,
      sym_ref_qualifier,
    STATE(7129), 1,
      sym__function_attributes_end,
    STATE(7412), 1,
      sym_trailing_return_type,
    STATE(7618), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5009), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8187), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6537), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8119), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [10504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8039), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(8041), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [10571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2224), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [10638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2224), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [10705] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3550), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8164), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2883), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2881), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [10776] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7808), 1,
      anon_sym___attribute__,
    ACTIONS(7810), 1,
      anon_sym___attribute,
    STATE(3811), 1,
      sym_attribute_specifier,
    ACTIONS(4004), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4002), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [10849] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7808), 1,
      anon_sym___attribute__,
    ACTIONS(7810), 1,
      anon_sym___attribute,
    STATE(3815), 1,
      sym_attribute_specifier,
    ACTIONS(4091), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4089), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [10922] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8199), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8211), 1,
      anon_sym_requires,
    ACTIONS(8243), 1,
      anon_sym_DASH_GT,
    ACTIONS(8247), 1,
      anon_sym_where,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(5742), 1,
      sym__function_attributes_start,
    STATE(6228), 1,
      sym_ref_qualifier,
    STATE(7172), 1,
      sym__function_attributes_end,
    STATE(7441), 1,
      sym_trailing_return_type,
    STATE(7618), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8208), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5009), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7828), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6549), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8119), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [11047] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8233), 1,
      anon_sym_GT_EQ,
    ACTIONS(8237), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8239), 1,
      anon_sym_not_eq,
    ACTIONS(8254), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8256), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8258), 1,
      anon_sym_or,
    ACTIONS(8260), 1,
      anon_sym_and,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8219), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8223), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8225), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8227), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8229), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8241), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8221), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8231), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8250), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(8252), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [11160] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8233), 1,
      anon_sym_GT_EQ,
    ACTIONS(8237), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8239), 1,
      anon_sym_not_eq,
    ACTIONS(8254), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8256), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8258), 1,
      anon_sym_or,
    ACTIONS(8260), 1,
      anon_sym_and,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8219), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8223), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8225), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8227), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8229), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8241), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8221), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8231), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8262), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(8264), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [11273] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7808), 1,
      anon_sym___attribute__,
    ACTIONS(7810), 1,
      anon_sym___attribute,
    STATE(3820), 1,
      sym_attribute_specifier,
    ACTIONS(4200), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4198), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [11346] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8221), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7773), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(7771), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
  [11429] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8219), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8221), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7771), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(7773), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [11514] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8219), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8221), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7771), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(7773), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [11601] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7808), 1,
      anon_sym___attribute__,
    ACTIONS(7810), 1,
      anon_sym___attribute,
    STATE(3824), 1,
      sym_attribute_specifier,
    ACTIONS(4107), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4109), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [11674] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7808), 1,
      anon_sym___attribute__,
    ACTIONS(7810), 1,
      anon_sym___attribute,
    STATE(3829), 1,
      sym_attribute_specifier,
    ACTIONS(4010), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4008), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [11747] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7808), 1,
      anon_sym___attribute__,
    ACTIONS(7810), 1,
      anon_sym___attribute,
    STATE(3830), 1,
      sym_attribute_specifier,
    ACTIONS(4014), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4012), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [11820] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7808), 1,
      anon_sym___attribute__,
    ACTIONS(7810), 1,
      anon_sym___attribute,
    STATE(3835), 1,
      sym_attribute_specifier,
    ACTIONS(4156), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4154), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [11893] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7808), 1,
      anon_sym___attribute__,
    ACTIONS(7810), 1,
      anon_sym___attribute,
    STATE(3837), 1,
      sym_attribute_specifier,
    ACTIONS(4060), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4058), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [11966] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7808), 1,
      anon_sym___attribute__,
    ACTIONS(7810), 1,
      anon_sym___attribute,
    STATE(3838), 1,
      sym_attribute_specifier,
    ACTIONS(4045), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4043), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [12039] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7808), 1,
      anon_sym___attribute__,
    ACTIONS(7810), 1,
      anon_sym___attribute,
    STATE(3839), 1,
      sym_attribute_specifier,
    ACTIONS(4049), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4047), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [12112] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7808), 1,
      anon_sym___attribute__,
    ACTIONS(7810), 1,
      anon_sym___attribute,
    STATE(3842), 1,
      sym_attribute_specifier,
    ACTIONS(4087), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4085), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [12185] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7808), 1,
      anon_sym___attribute__,
    ACTIONS(7810), 1,
      anon_sym___attribute,
    STATE(3843), 1,
      sym_attribute_specifier,
    ACTIONS(4176), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4174), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [12258] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8233), 1,
      anon_sym_GT_EQ,
    ACTIONS(8237), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8239), 1,
      anon_sym_not_eq,
    ACTIONS(8254), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8256), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8258), 1,
      anon_sym_or,
    ACTIONS(8260), 1,
      anon_sym_and,
    ACTIONS(8268), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_QMARK,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8219), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8223), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8225), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8227), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8229), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8241), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8221), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8231), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8266), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(8270), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [12375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2224), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [12442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2224), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [12509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2956), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2954), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [12576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2224), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [12643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2224), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [12710] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8233), 1,
      anon_sym_GT_EQ,
    ACTIONS(8237), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8239), 1,
      anon_sym_not_eq,
    ACTIONS(8254), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8256), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8258), 1,
      anon_sym_or,
    ACTIONS(8260), 1,
      anon_sym_and,
    ACTIONS(8268), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_QMARK,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8219), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8223), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8225), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8227), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8229), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8241), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8221), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8231), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8274), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(8276), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [12827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(7313), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [12894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(7160), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [12961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2974), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2972), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [13028] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5266), 1,
      anon_sym_LBRACE,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8280), 1,
      anon_sym_LBRACK,
    STATE(4216), 1,
      sym_new_declarator,
    STATE(4798), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8282), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7376), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7378), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [13107] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5266), 1,
      anon_sym_LBRACE,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8280), 1,
      anon_sym_LBRACK,
    STATE(4155), 1,
      sym_new_declarator,
    STATE(4778), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8282), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7354), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7356), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [13186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7288), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(7290), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [13253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2552), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [13320] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7150), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(7152), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [13387] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8233), 1,
      anon_sym_GT_EQ,
    ACTIONS(8237), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8239), 1,
      anon_sym_not_eq,
    ACTIONS(8254), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8256), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8258), 1,
      anon_sym_or,
    ACTIONS(8260), 1,
      anon_sym_and,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8219), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8223), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8225), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8227), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8229), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8241), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8221), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8231), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8284), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(8286), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [13500] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8233), 1,
      anon_sym_GT_EQ,
    ACTIONS(8237), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8239), 1,
      anon_sym_not_eq,
    ACTIONS(8254), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8256), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8258), 1,
      anon_sym_or,
    ACTIONS(8260), 1,
      anon_sym_and,
    ACTIONS(8268), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_QMARK,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8219), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8223), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8225), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8227), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8229), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8241), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8221), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8231), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7911), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(7913), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [13617] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8233), 1,
      anon_sym_GT_EQ,
    ACTIONS(8237), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8239), 1,
      anon_sym_not_eq,
    ACTIONS(8256), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8260), 1,
      anon_sym_and,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8219), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8223), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8225), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8227), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8229), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8241), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8221), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8231), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7771), 7,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      sym_identifier,
    ACTIONS(7773), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [13726] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5266), 1,
      anon_sym_LBRACE,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8280), 1,
      anon_sym_LBRACK,
    STATE(4034), 1,
      sym_new_declarator,
    STATE(4756), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8282), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7372), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7374), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [13805] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8233), 1,
      anon_sym_GT_EQ,
    ACTIONS(8237), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8239), 1,
      anon_sym_not_eq,
    ACTIONS(8254), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8256), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8258), 1,
      anon_sym_or,
    ACTIONS(8260), 1,
      anon_sym_and,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8219), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8223), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8225), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8227), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8229), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8241), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8221), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8231), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8288), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(8290), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [13918] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8233), 1,
      anon_sym_GT_EQ,
    ACTIONS(8237), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8239), 1,
      anon_sym_not_eq,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8219), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8225), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8227), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8229), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8241), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8221), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8231), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7771), 10,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      sym_identifier,
    ACTIONS(7773), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [14021] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8233), 1,
      anon_sym_GT_EQ,
    ACTIONS(8237), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8239), 1,
      anon_sym_not_eq,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8219), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8227), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8229), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8241), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8221), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8231), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7771), 12,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      sym_identifier,
    ACTIONS(7773), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [14122] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8233), 1,
      anon_sym_GT_EQ,
    ACTIONS(8237), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8239), 1,
      anon_sym_not_eq,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8219), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8229), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8241), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8221), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8231), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7771), 14,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      sym_identifier,
    ACTIONS(7773), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [14221] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5266), 1,
      anon_sym_LBRACE,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8280), 1,
      anon_sym_LBRACK,
    STATE(4083), 1,
      sym_new_declarator,
    STATE(4665), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8282), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7368), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7370), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [14300] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8233), 1,
      anon_sym_GT_EQ,
    ACTIONS(8237), 1,
      anon_sym_LT_EQ_GT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8219), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8241), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8221), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8231), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7771), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7773), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [14395] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8237), 1,
      anon_sym_LT_EQ_GT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8219), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8241), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8221), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7771), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7773), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [14486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2550), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2548), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [14553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3026), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3024), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [14620] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8233), 1,
      anon_sym_GT_EQ,
    ACTIONS(8237), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8239), 1,
      anon_sym_not_eq,
    ACTIONS(8254), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8256), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8258), 1,
      anon_sym_or,
    ACTIONS(8260), 1,
      anon_sym_and,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8219), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8223), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8225), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8227), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8229), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8241), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8221), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8231), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8292), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(8294), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [14733] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2982), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2980), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [14800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8298), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(8296), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [14866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8302), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(8300), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [14932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2302), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2300), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [14998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8306), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(8304), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [15064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3026), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3024), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [15130] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8308), 1,
      sym_literal_suffix,
    ACTIONS(2181), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2170), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [15198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3629), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3631), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [15264] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8199), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8310), 1,
      anon_sym_DASH_GT,
    ACTIONS(8312), 1,
      anon_sym_requires,
    ACTIONS(8315), 1,
      anon_sym_where,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(5942), 1,
      sym__function_attributes_start,
    STATE(6321), 1,
      sym_ref_qualifier,
    STATE(7230), 1,
      sym__function_attributes_end,
    STATE(7540), 1,
      sym_trailing_return_type,
    STATE(7618), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8208), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5009), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7912), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6682), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8119), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [15388] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2420), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2422), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [15456] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2420), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2422), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [15524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2418), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [15590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3476), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3474), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [15656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8320), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(8318), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [15722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8324), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(8322), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [15788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2260), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [15854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2420), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2422), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [15920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2243), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [15986] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(2255), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2245), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [16054] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8199), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8310), 1,
      anon_sym_DASH_GT,
    ACTIONS(8326), 1,
      anon_sym_requires,
    ACTIONS(8328), 1,
      anon_sym_where,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(5877), 1,
      sym__function_attributes_start,
    STATE(6276), 1,
      sym_ref_qualifier,
    STATE(7295), 1,
      sym__function_attributes_end,
    STATE(7468), 1,
      sym_trailing_return_type,
    STATE(7618), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5009), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8392), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6585), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8119), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [16178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2270), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2268), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [16244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2266), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2264), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [16310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2294), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2292), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [16376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2286), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2284), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [16442] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2426), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2428), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [16510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2278), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2276), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [16576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2241), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2239), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [16642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2282), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2280), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [16708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2304), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [16774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2550), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2548), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [16840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(8332), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [16906] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8072), 1,
      anon_sym___attribute__,
    ACTIONS(8074), 1,
      anon_sym___attribute,
    ACTIONS(8191), 1,
      anon_sym_LBRACE,
    STATE(3776), 1,
      sym_enumerator_list,
    STATE(4372), 1,
      sym_attribute_specifier,
    ACTIONS(3993), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3991), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [16982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2552), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [17048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2956), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2954), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [17114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2288), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [17180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2310), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2308), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [17246] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2883), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2881), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [17314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2974), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2972), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [17380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2314), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2312), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [17446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2879), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2877), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [17512] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8072), 1,
      anon_sym___attribute__,
    ACTIONS(8074), 1,
      anon_sym___attribute,
    ACTIONS(8191), 1,
      anon_sym_LBRACE,
    STATE(3714), 1,
      sym_enumerator_list,
    STATE(4360), 1,
      sym_attribute_specifier,
    ACTIONS(3989), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3987), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [17588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2982), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2980), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [17654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2296), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [17720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2274), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2272), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [17786] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5321), 1,
      anon_sym_LBRACE,
    ACTIONS(8334), 1,
      anon_sym_LPAREN2,
    ACTIONS(8336), 1,
      anon_sym_LBRACK,
    STATE(4599), 1,
      sym_new_declarator,
    STATE(4880), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8338), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7372), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7374), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [17863] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_const,
    ACTIONS(2252), 2,
      anon_sym_AMP,
      anon_sym_DOT,
    ACTIONS(2247), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
    ACTIONS(2255), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(2250), 19,
      anon_sym___extension__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2245), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [17936] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8072), 1,
      anon_sym___attribute__,
    ACTIONS(8074), 1,
      anon_sym___attribute,
    STATE(4373), 1,
      sym_attribute_specifier,
    ACTIONS(4060), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4058), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [18007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3050), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3048), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [18072] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8340), 1,
      anon_sym_LPAREN2,
    ACTIONS(8342), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8344), 1,
      anon_sym_LBRACK,
    STATE(4351), 1,
      sym_parameter_list,
    STATE(3853), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7554), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7556), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [18147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2978), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2976), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [18212] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5321), 1,
      anon_sym_LBRACE,
    ACTIONS(8334), 1,
      anon_sym_LPAREN2,
    ACTIONS(8336), 1,
      anon_sym_LBRACK,
    STATE(4596), 1,
      sym_new_declarator,
    STATE(4893), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8338), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7368), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7370), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [18289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3022), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3020), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [18354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3006), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3004), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [18419] = 52,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8346), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8348), 1,
      anon_sym_COMMA,
    ACTIONS(8350), 1,
      anon_sym_RPAREN,
    ACTIONS(8352), 1,
      anon_sym_DASH,
    ACTIONS(8354), 1,
      anon_sym_PLUS,
    ACTIONS(8356), 1,
      anon_sym_STAR,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    ACTIONS(8360), 1,
      anon_sym_PERCENT,
    ACTIONS(8362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8366), 1,
      anon_sym_PIPE,
    ACTIONS(8368), 1,
      anon_sym_CARET,
    ACTIONS(8370), 1,
      anon_sym_AMP,
    ACTIONS(8372), 1,
      anon_sym_EQ_EQ,
    ACTIONS(8374), 1,
      anon_sym_BANG_EQ,
    ACTIONS(8376), 1,
      anon_sym_GT,
    ACTIONS(8378), 1,
      anon_sym_GT_EQ,
    ACTIONS(8380), 1,
      anon_sym_LT_EQ,
    ACTIONS(8382), 1,
      anon_sym_LT,
    ACTIONS(8384), 1,
      anon_sym_LT_LT,
    ACTIONS(8386), 1,
      anon_sym_GT_GT,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8390), 1,
      anon_sym_EQ,
    ACTIONS(8392), 1,
      anon_sym_QMARK,
    ACTIONS(8394), 1,
      anon_sym_STAR_EQ,
    ACTIONS(8396), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(8398), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(8400), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(8402), 1,
      anon_sym_DASH_EQ,
    ACTIONS(8404), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(8406), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(8408), 1,
      anon_sym_AMP_EQ,
    ACTIONS(8410), 1,
      anon_sym_CARET_EQ,
    ACTIONS(8412), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(8418), 1,
      anon_sym_or,
    ACTIONS(8420), 1,
      anon_sym_and,
    ACTIONS(8422), 1,
      anon_sym_bitor,
    ACTIONS(8424), 1,
      anon_sym_xor,
    ACTIONS(8426), 1,
      anon_sym_bitand,
    ACTIONS(8428), 1,
      anon_sym_not_eq,
    ACTIONS(8434), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8436), 1,
      anon_sym_DASH_GT_STAR,
    STATE(2291), 1,
      sym__binary_fold_operator,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    STATE(10791), 1,
      sym__fold_operator,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8414), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(8416), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [18582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3010), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3008), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [18647] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8072), 1,
      anon_sym___attribute__,
    ACTIONS(8074), 1,
      anon_sym___attribute,
    STATE(4340), 1,
      sym_attribute_specifier,
    ACTIONS(4004), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4002), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [18718] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8438), 1,
      anon_sym_DOT,
    ACTIONS(8187), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4252), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(4254), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [18787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2986), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2984), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [18852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2934), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2932), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [18917] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8193), 1,
      anon_sym___attribute__,
    ACTIONS(8196), 1,
      anon_sym___attribute,
    ACTIONS(8440), 1,
      anon_sym_DASH_GT,
    ACTIONS(8442), 1,
      anon_sym_where,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_attributes_start,
    STATE(6408), 1,
      sym_ref_qualifier,
    STATE(7333), 1,
      sym__function_attributes_end,
    STATE(7459), 1,
      sym_where_clause,
    STATE(7501), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5009), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8337), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6813), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8119), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [19040] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8072), 1,
      anon_sym___attribute__,
    ACTIONS(8074), 1,
      anon_sym___attribute,
    STATE(4344), 1,
      sym_attribute_specifier,
    ACTIONS(4091), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4089), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [19111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2926), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2924), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [19176] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8072), 1,
      anon_sym___attribute__,
    ACTIONS(8074), 1,
      anon_sym___attribute,
    STATE(4357), 1,
      sym_attribute_specifier,
    ACTIONS(4200), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4198), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [19247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2998), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2996), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [19312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3042), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3040), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [19377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(8332), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [19442] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8072), 1,
      anon_sym___attribute__,
    ACTIONS(8074), 1,
      anon_sym___attribute,
    STATE(4375), 1,
      sym_attribute_specifier,
    ACTIONS(4049), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4047), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [19513] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2883), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2881), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [19580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2960), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2958), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [19645] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5321), 1,
      anon_sym_LBRACE,
    ACTIONS(8334), 1,
      anon_sym_LPAREN2,
    ACTIONS(8336), 1,
      anon_sym_LBRACK,
    STATE(4580), 1,
      sym_new_declarator,
    STATE(4894), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8338), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7376), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7378), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [19722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2938), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2936), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [19787] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8072), 1,
      anon_sym___attribute__,
    ACTIONS(8074), 1,
      anon_sym___attribute,
    STATE(4362), 1,
      sym_attribute_specifier,
    ACTIONS(4010), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4008), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [19858] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(7911), 1,
      anon_sym_EQ,
    ACTIONS(8268), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8450), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8452), 1,
      anon_sym_PIPE,
    ACTIONS(8456), 1,
      anon_sym_AMP,
    ACTIONS(8462), 1,
      anon_sym_GT_EQ,
    ACTIONS(8466), 1,
      anon_sym_QMARK,
    ACTIONS(8470), 1,
      anon_sym_or,
    ACTIONS(8472), 1,
      anon_sym_and,
    ACTIONS(8474), 1,
      anon_sym_bitor,
    ACTIONS(8476), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8444), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8454), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8464), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8446), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8458), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8460), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8468), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7913), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [19973] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8308), 1,
      sym_literal_suffix,
    ACTIONS(2181), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
    ACTIONS(2170), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [20040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2990), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2988), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [20105] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5321), 1,
      anon_sym_LBRACE,
    ACTIONS(8334), 1,
      anon_sym_LPAREN2,
    ACTIONS(8336), 1,
      anon_sym_LBRACK,
    STATE(4533), 1,
      sym_new_declarator,
    STATE(4924), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(8338), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7354), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7356), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [20182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2964), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2962), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [20247] = 52,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8346), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8348), 1,
      anon_sym_COMMA,
    ACTIONS(8352), 1,
      anon_sym_DASH,
    ACTIONS(8354), 1,
      anon_sym_PLUS,
    ACTIONS(8356), 1,
      anon_sym_STAR,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    ACTIONS(8360), 1,
      anon_sym_PERCENT,
    ACTIONS(8362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8366), 1,
      anon_sym_PIPE,
    ACTIONS(8368), 1,
      anon_sym_CARET,
    ACTIONS(8370), 1,
      anon_sym_AMP,
    ACTIONS(8372), 1,
      anon_sym_EQ_EQ,
    ACTIONS(8374), 1,
      anon_sym_BANG_EQ,
    ACTIONS(8376), 1,
      anon_sym_GT,
    ACTIONS(8378), 1,
      anon_sym_GT_EQ,
    ACTIONS(8380), 1,
      anon_sym_LT_EQ,
    ACTIONS(8382), 1,
      anon_sym_LT,
    ACTIONS(8384), 1,
      anon_sym_LT_LT,
    ACTIONS(8386), 1,
      anon_sym_GT_GT,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8390), 1,
      anon_sym_EQ,
    ACTIONS(8392), 1,
      anon_sym_QMARK,
    ACTIONS(8394), 1,
      anon_sym_STAR_EQ,
    ACTIONS(8396), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(8398), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(8400), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(8402), 1,
      anon_sym_DASH_EQ,
    ACTIONS(8404), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(8406), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(8408), 1,
      anon_sym_AMP_EQ,
    ACTIONS(8410), 1,
      anon_sym_CARET_EQ,
    ACTIONS(8412), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(8418), 1,
      anon_sym_or,
    ACTIONS(8420), 1,
      anon_sym_and,
    ACTIONS(8422), 1,
      anon_sym_bitor,
    ACTIONS(8424), 1,
      anon_sym_xor,
    ACTIONS(8426), 1,
      anon_sym_bitand,
    ACTIONS(8428), 1,
      anon_sym_not_eq,
    ACTIONS(8434), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8436), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(8478), 1,
      anon_sym_RPAREN,
    STATE(2291), 1,
      sym__binary_fold_operator,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    STATE(10791), 1,
      sym__fold_operator,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8414), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(8416), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [20410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2930), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2928), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [20475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3002), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3000), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [20540] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8438), 1,
      anon_sym_DOT,
    ACTIONS(8187), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4244), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(4246), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [20609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3042), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3040), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [20674] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2229), 1,
      anon_sym_LBRACE,
    ACTIONS(5546), 1,
      anon_sym_LT,
    STATE(3845), 1,
      sym_template_argument_list,
    ACTIONS(2234), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2224), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [20747] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7318), 4,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(7320), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2170), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2181), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
  [20816] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8072), 1,
      anon_sym___attribute__,
    ACTIONS(8074), 1,
      anon_sym___attribute,
    STATE(4371), 1,
      sym_attribute_specifier,
    ACTIONS(4156), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4154), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [20887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4248), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4250), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [20952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3012), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [21017] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym_requires,
    ACTIONS(8193), 1,
      anon_sym___attribute__,
    ACTIONS(8196), 1,
      anon_sym___attribute,
    ACTIONS(8440), 1,
      anon_sym_DASH_GT,
    ACTIONS(8480), 1,
      anon_sym_where,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(6071), 1,
      sym__function_attributes_start,
    STATE(6384), 1,
      sym_ref_qualifier,
    STATE(7337), 1,
      sym__function_attributes_end,
    STATE(7459), 1,
      sym_where_clause,
    STATE(7514), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8145), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5009), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7980), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6795), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8119), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [21140] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8072), 1,
      anon_sym___attribute__,
    ACTIONS(8074), 1,
      anon_sym___attribute,
    STATE(4364), 1,
      sym_attribute_specifier,
    ACTIONS(4014), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4012), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [21211] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8266), 1,
      anon_sym_EQ,
    ACTIONS(8268), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8450), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8452), 1,
      anon_sym_PIPE,
    ACTIONS(8456), 1,
      anon_sym_AMP,
    ACTIONS(8462), 1,
      anon_sym_GT_EQ,
    ACTIONS(8466), 1,
      anon_sym_QMARK,
    ACTIONS(8470), 1,
      anon_sym_or,
    ACTIONS(8472), 1,
      anon_sym_and,
    ACTIONS(8474), 1,
      anon_sym_bitor,
    ACTIONS(8476), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8444), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8454), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8464), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8446), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8458), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8460), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8468), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8270), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [21326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3042), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3040), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [21391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2934), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2932), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [21456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2952), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2950), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [21521] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8446), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7771), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [21602] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8450), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8452), 1,
      anon_sym_PIPE,
    ACTIONS(8456), 1,
      anon_sym_AMP,
    ACTIONS(8462), 1,
      anon_sym_GT_EQ,
    ACTIONS(8472), 1,
      anon_sym_and,
    ACTIONS(8474), 1,
      anon_sym_bitor,
    ACTIONS(8476), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7771), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8444), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8454), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8464), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8446), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8458), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8460), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8468), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7773), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [21709] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8452), 1,
      anon_sym_PIPE,
    ACTIONS(8456), 1,
      anon_sym_AMP,
    ACTIONS(8462), 1,
      anon_sym_GT_EQ,
    ACTIONS(8474), 1,
      anon_sym_bitor,
    ACTIONS(8476), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8444), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8454), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8464), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7771), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(8446), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8458), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8460), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8468), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7773), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [21812] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8456), 1,
      anon_sym_AMP,
    ACTIONS(8462), 1,
      anon_sym_GT_EQ,
    ACTIONS(8476), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8444), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8454), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8464), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8446), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8458), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8460), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8468), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7773), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [21911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3056), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [21976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3034), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3032), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [22041] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_where,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6101), 1,
      sym__function_attributes_start,
    STATE(6371), 1,
      sym_ref_qualifier,
    STATE(7459), 1,
      sym_where_clause,
    STATE(7477), 1,
      sym__function_attributes_end,
    STATE(7631), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5110), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5366), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8603), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6761), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8119), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [22164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2940), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [22229] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8456), 1,
      anon_sym_AMP,
    ACTIONS(8462), 1,
      anon_sym_GT_EQ,
    ACTIONS(8476), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8444), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8464), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8446), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8458), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8460), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8468), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [22326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2992), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [22391] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8462), 1,
      anon_sym_GT_EQ,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8444), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8464), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8446), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8458), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8460), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8468), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
  [22484] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8462), 1,
      anon_sym_GT_EQ,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8444), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8464), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8446), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8460), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8468), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [22575] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8250), 1,
      anon_sym_EQ,
    ACTIONS(8448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8450), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8452), 1,
      anon_sym_PIPE,
    ACTIONS(8456), 1,
      anon_sym_AMP,
    ACTIONS(8462), 1,
      anon_sym_GT_EQ,
    ACTIONS(8470), 1,
      anon_sym_or,
    ACTIONS(8472), 1,
      anon_sym_and,
    ACTIONS(8474), 1,
      anon_sym_bitor,
    ACTIONS(8476), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8444), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8454), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8464), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8446), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8458), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8460), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8468), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8252), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [22686] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2883), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2881), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [22751] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8444), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8464), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8446), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8468), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [22838] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8072), 1,
      anon_sym___attribute__,
    ACTIONS(8074), 1,
      anon_sym___attribute,
    STATE(4380), 1,
      sym_attribute_specifier,
    ACTIONS(4087), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4085), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [22909] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8284), 1,
      anon_sym_EQ,
    ACTIONS(8448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8450), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8452), 1,
      anon_sym_PIPE,
    ACTIONS(8456), 1,
      anon_sym_AMP,
    ACTIONS(8462), 1,
      anon_sym_GT_EQ,
    ACTIONS(8470), 1,
      anon_sym_or,
    ACTIONS(8472), 1,
      anon_sym_and,
    ACTIONS(8474), 1,
      anon_sym_bitor,
    ACTIONS(8476), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8444), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8454), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8464), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8446), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8458), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8460), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8468), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8286), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [23020] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8072), 1,
      anon_sym___attribute__,
    ACTIONS(8074), 1,
      anon_sym___attribute,
    STATE(4381), 1,
      sym_attribute_specifier,
    ACTIONS(4176), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4174), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [23091] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8340), 1,
      anon_sym_LPAREN2,
    ACTIONS(8342), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8344), 1,
      anon_sym_LBRACK,
    STATE(4351), 1,
      sym_parameter_list,
    STATE(3853), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7494), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7496), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [23166] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2948), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2946), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [23231] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8444), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8446), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7771), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [23314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3052), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [23379] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8072), 1,
      anon_sym___attribute__,
    ACTIONS(8074), 1,
      anon_sym___attribute,
    STATE(4359), 1,
      sym_attribute_specifier,
    ACTIONS(4107), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4109), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [23450] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8072), 1,
      anon_sym___attribute__,
    ACTIONS(8074), 1,
      anon_sym___attribute,
    STATE(4374), 1,
      sym_attribute_specifier,
    ACTIONS(4045), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4043), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [23521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2879), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2877), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [23586] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8444), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8464), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8446), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7771), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [23671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2883), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2881), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [23736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3018), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3016), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [23801] = 52,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8346), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8348), 1,
      anon_sym_COMMA,
    ACTIONS(8352), 1,
      anon_sym_DASH,
    ACTIONS(8354), 1,
      anon_sym_PLUS,
    ACTIONS(8356), 1,
      anon_sym_STAR,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    ACTIONS(8360), 1,
      anon_sym_PERCENT,
    ACTIONS(8362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8366), 1,
      anon_sym_PIPE,
    ACTIONS(8368), 1,
      anon_sym_CARET,
    ACTIONS(8370), 1,
      anon_sym_AMP,
    ACTIONS(8372), 1,
      anon_sym_EQ_EQ,
    ACTIONS(8374), 1,
      anon_sym_BANG_EQ,
    ACTIONS(8376), 1,
      anon_sym_GT,
    ACTIONS(8378), 1,
      anon_sym_GT_EQ,
    ACTIONS(8380), 1,
      anon_sym_LT_EQ,
    ACTIONS(8382), 1,
      anon_sym_LT,
    ACTIONS(8384), 1,
      anon_sym_LT_LT,
    ACTIONS(8386), 1,
      anon_sym_GT_GT,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8390), 1,
      anon_sym_EQ,
    ACTIONS(8392), 1,
      anon_sym_QMARK,
    ACTIONS(8394), 1,
      anon_sym_STAR_EQ,
    ACTIONS(8396), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(8398), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(8400), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(8402), 1,
      anon_sym_DASH_EQ,
    ACTIONS(8404), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(8406), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(8408), 1,
      anon_sym_AMP_EQ,
    ACTIONS(8410), 1,
      anon_sym_CARET_EQ,
    ACTIONS(8412), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(8418), 1,
      anon_sym_or,
    ACTIONS(8420), 1,
      anon_sym_and,
    ACTIONS(8422), 1,
      anon_sym_bitor,
    ACTIONS(8424), 1,
      anon_sym_xor,
    ACTIONS(8426), 1,
      anon_sym_bitand,
    ACTIONS(8428), 1,
      anon_sym_not_eq,
    ACTIONS(8434), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8436), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(8493), 1,
      anon_sym_RPAREN,
    STATE(2291), 1,
      sym__binary_fold_operator,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    STATE(10791), 1,
      sym__fold_operator,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8414), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(8416), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [23964] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2229), 1,
      anon_sym_LBRACE,
    ACTIONS(5529), 1,
      anon_sym_LT,
    STATE(3686), 1,
      sym_template_argument_list,
    ACTIONS(2234), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2224), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [24037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3038), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3036), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [24102] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8292), 1,
      anon_sym_EQ,
    ACTIONS(8448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8450), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8452), 1,
      anon_sym_PIPE,
    ACTIONS(8456), 1,
      anon_sym_AMP,
    ACTIONS(8462), 1,
      anon_sym_GT_EQ,
    ACTIONS(8470), 1,
      anon_sym_or,
    ACTIONS(8472), 1,
      anon_sym_and,
    ACTIONS(8474), 1,
      anon_sym_bitor,
    ACTIONS(8476), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8444), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8454), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8464), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8446), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8458), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8460), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8468), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8294), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [24213] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8340), 1,
      anon_sym_LPAREN2,
    ACTIONS(8342), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8344), 1,
      anon_sym_LBRACK,
    STATE(4351), 1,
      sym_parameter_list,
    STATE(3853), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7585), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7587), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [24288] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8262), 1,
      anon_sym_EQ,
    ACTIONS(8448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8450), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8452), 1,
      anon_sym_PIPE,
    ACTIONS(8456), 1,
      anon_sym_AMP,
    ACTIONS(8462), 1,
      anon_sym_GT_EQ,
    ACTIONS(8470), 1,
      anon_sym_or,
    ACTIONS(8472), 1,
      anon_sym_and,
    ACTIONS(8474), 1,
      anon_sym_bitor,
    ACTIONS(8476), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8444), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8454), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8464), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8446), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8458), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8460), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8468), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8264), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [24399] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8268), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8274), 1,
      anon_sym_EQ,
    ACTIONS(8448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8450), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8452), 1,
      anon_sym_PIPE,
    ACTIONS(8456), 1,
      anon_sym_AMP,
    ACTIONS(8462), 1,
      anon_sym_GT_EQ,
    ACTIONS(8466), 1,
      anon_sym_QMARK,
    ACTIONS(8470), 1,
      anon_sym_or,
    ACTIONS(8472), 1,
      anon_sym_and,
    ACTIONS(8474), 1,
      anon_sym_bitor,
    ACTIONS(8476), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8444), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8454), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8464), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8446), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8458), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8460), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8468), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8276), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [24514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3030), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3028), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [24579] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8288), 1,
      anon_sym_EQ,
    ACTIONS(8448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8450), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8452), 1,
      anon_sym_PIPE,
    ACTIONS(8456), 1,
      anon_sym_AMP,
    ACTIONS(8462), 1,
      anon_sym_GT_EQ,
    ACTIONS(8470), 1,
      anon_sym_or,
    ACTIONS(8472), 1,
      anon_sym_and,
    ACTIONS(8474), 1,
      anon_sym_bitor,
    ACTIONS(8476), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8444), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8454), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8464), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8446), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8458), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8460), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8468), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8290), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [24690] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8340), 1,
      anon_sym_LPAREN2,
    ACTIONS(8342), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8344), 1,
      anon_sym_LBRACK,
    STATE(4351), 1,
      sym_parameter_list,
    STATE(3853), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7570), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7572), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [24765] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8340), 1,
      anon_sym_LPAREN2,
    ACTIONS(8342), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8344), 1,
      anon_sym_LBRACK,
    STATE(4351), 1,
      sym_parameter_list,
    STATE(3853), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7558), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7560), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [24840] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym_requires,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8495), 1,
      anon_sym_where,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6109), 1,
      sym__function_attributes_start,
    STATE(6406), 1,
      sym_ref_qualifier,
    STATE(7459), 1,
      sym_where_clause,
    STATE(7470), 1,
      sym__function_attributes_end,
    STATE(7699), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8145), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5110), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5366), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8283), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6802), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8119), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [24963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3046), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3044), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [25028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2974), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2972), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [25092] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8498), 1,
      anon_sym_DOT,
    ACTIONS(8282), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4244), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(4246), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [25160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2948), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2946), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [25224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2952), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2950), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [25288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3052), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [25352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2956), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2954), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [25416] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(5344), 1,
      anon_sym_LPAREN2,
    ACTIONS(5346), 1,
      anon_sym_STAR,
    ACTIONS(5348), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5350), 1,
      anon_sym_AMP,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(7408), 1,
      anon_sym_LBRACK,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8106), 1,
      anon_sym_RPAREN,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7421), 1,
      sym__scope_resolution,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8385), 1,
      sym__declarator,
    STATE(8842), 1,
      sym__abstract_declarator,
    STATE(11547), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [25528] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8498), 1,
      anon_sym_DOT,
    ACTIONS(8282), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4252), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(4254), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [25596] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    STATE(2953), 1,
      sym_template_argument_list,
    STATE(4508), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8500), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3777), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3775), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [25668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3034), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3032), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [25732] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8506), 1,
      anon_sym_PIPE,
    ACTIONS(8510), 1,
      anon_sym_AMP,
    ACTIONS(8516), 1,
      anon_sym_GT_EQ,
    ACTIONS(8522), 1,
      anon_sym_bitor,
    ACTIONS(8524), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8502), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8504), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8512), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8514), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8520), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 4,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7773), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [25834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3038), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3036), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [25898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3042), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3040), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [25962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3046), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3044), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [26026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3050), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3048), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [26090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3042), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3040), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [26154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3042), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3040), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [26218] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8526), 1,
      anon_sym_LPAREN2,
    ACTIONS(8528), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8530), 1,
      anon_sym_LBRACK,
    STATE(4587), 1,
      sym_parameter_list,
    STATE(3890), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7554), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7556), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [26292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2960), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2958), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [26356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2964), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2962), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [26420] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8268), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8506), 1,
      anon_sym_PIPE,
    ACTIONS(8510), 1,
      anon_sym_AMP,
    ACTIONS(8516), 1,
      anon_sym_GT_EQ,
    ACTIONS(8522), 1,
      anon_sym_bitor,
    ACTIONS(8524), 1,
      anon_sym_bitand,
    ACTIONS(8532), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8534), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_or,
    ACTIONS(8540), 1,
      anon_sym_and,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8274), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(8502), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8504), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8512), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8514), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8520), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8276), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [26534] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP,
    ACTIONS(8516), 1,
      anon_sym_GT_EQ,
    ACTIONS(8524), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8502), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8504), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8512), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8514), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8520), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 5,
      anon_sym_PIPE,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7773), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [26632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2978), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2976), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [26696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3022), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3020), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [26760] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8510), 1,
      anon_sym_AMP,
    ACTIONS(8516), 1,
      anon_sym_GT_EQ,
    ACTIONS(8524), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8502), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8504), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8512), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8514), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8520), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [26856] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8516), 1,
      anon_sym_GT_EQ,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8502), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8504), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8512), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8514), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8520), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
  [26948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2934), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2932), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [27012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2926), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2924), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [27076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2930), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2928), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [27140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2934), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2932), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [27204] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8516), 1,
      anon_sym_GT_EQ,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8502), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8504), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8514), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8520), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [27294] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8544), 1,
      anon_sym_RPAREN,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(10087), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [27408] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8268), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8506), 1,
      anon_sym_PIPE,
    ACTIONS(8510), 1,
      anon_sym_AMP,
    ACTIONS(8516), 1,
      anon_sym_GT_EQ,
    ACTIONS(8522), 1,
      anon_sym_bitor,
    ACTIONS(8524), 1,
      anon_sym_bitand,
    ACTIONS(8532), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8534), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_or,
    ACTIONS(8540), 1,
      anon_sym_and,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7911), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(8502), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8504), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8512), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8514), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8520), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7913), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [27522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3056), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [27586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2986), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2984), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [27650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2990), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2988), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [27714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3002), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3000), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [27778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3006), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3004), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [27842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3010), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3008), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [27906] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_LBRACE,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    STATE(4640), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7671), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7673), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [27976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3018), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3016), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [28040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3030), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3028), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [28104] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3527), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(2209), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2211), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(7386), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(7388), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [28174] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(2255), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2245), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [28240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2992), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [28304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2550), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2548), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [28368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2998), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2996), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [28432] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_LBRACE,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    STATE(4616), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7658), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7660), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [28502] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8506), 1,
      anon_sym_PIPE,
    ACTIONS(8510), 1,
      anon_sym_AMP,
    ACTIONS(8516), 1,
      anon_sym_GT_EQ,
    ACTIONS(8522), 1,
      anon_sym_bitor,
    ACTIONS(8524), 1,
      anon_sym_bitand,
    ACTIONS(8532), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8534), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8538), 1,
      anon_sym_or,
    ACTIONS(8540), 1,
      anon_sym_and,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8292), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(8502), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8504), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8512), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8514), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8520), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8294), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [28612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4248), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4250), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [28676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2552), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [28740] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8342), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3858), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7594), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7596), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [28808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3026), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3024), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [28872] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(8550), 1,
      anon_sym_LBRACE,
    STATE(4907), 1,
      sym_field_declaration_list,
    STATE(5017), 1,
      sym_attribute_specifier,
    STATE(9528), 1,
      sym_virtual_specifier,
    STATE(10453), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(2893), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2895), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [28952] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(8554), 1,
      anon_sym_requires,
    ACTIONS(8557), 1,
      anon_sym_where,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6199), 1,
      sym__function_attributes_start,
    STATE(6461), 1,
      sym_ref_qualifier,
    STATE(7459), 1,
      sym_where_clause,
    STATE(7623), 1,
      sym__function_attributes_end,
    STATE(7744), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8145), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5110), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5366), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8503), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6873), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8119), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [29074] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8566), 1,
      anon_sym_DASH_GT,
    ACTIONS(8571), 1,
      anon_sym_noexcept,
    ACTIONS(8573), 1,
      anon_sym_throw,
    ACTIONS(8575), 1,
      anon_sym_requires,
    ACTIONS(8578), 1,
      anon_sym_where,
    STATE(6169), 1,
      sym__function_attributes_start,
    STATE(6329), 1,
      sym_alignas_qualifier,
    STATE(6472), 1,
      sym_ref_qualifier,
    STATE(7459), 1,
      sym_where_clause,
    STATE(7572), 1,
      sym__function_attributes_end,
    STATE(7850), 1,
      sym_trailing_return_type,
    STATE(8986), 1,
      sym_gnu_asm_expression,
    ACTIONS(8133), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(8562), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(8564), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8568), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5330), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6044), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8416), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    STATE(6845), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8119), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(8560), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [29190] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8581), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3858), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(4482), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7648), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [29258] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8526), 1,
      anon_sym_LPAREN2,
    ACTIONS(8528), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8530), 1,
      anon_sym_LBRACK,
    STATE(4587), 1,
      sym_parameter_list,
    STATE(3890), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7570), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7572), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [29332] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8506), 1,
      anon_sym_PIPE,
    ACTIONS(8510), 1,
      anon_sym_AMP,
    ACTIONS(8516), 1,
      anon_sym_GT_EQ,
    ACTIONS(8522), 1,
      anon_sym_bitor,
    ACTIONS(8524), 1,
      anon_sym_bitand,
    ACTIONS(8532), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8534), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8538), 1,
      anon_sym_or,
    ACTIONS(8540), 1,
      anon_sym_and,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8250), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(8502), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8504), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8512), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8514), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8520), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8252), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [29442] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8506), 1,
      anon_sym_PIPE,
    ACTIONS(8510), 1,
      anon_sym_AMP,
    ACTIONS(8516), 1,
      anon_sym_GT_EQ,
    ACTIONS(8522), 1,
      anon_sym_bitor,
    ACTIONS(8524), 1,
      anon_sym_bitand,
    ACTIONS(8532), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8534), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8538), 1,
      anon_sym_or,
    ACTIONS(8540), 1,
      anon_sym_and,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8262), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(8502), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8504), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8512), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8514), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8520), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8264), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [29552] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8504), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7771), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [29632] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8502), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8504), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7771), 13,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [29714] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8526), 1,
      anon_sym_LPAREN2,
    ACTIONS(8528), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8530), 1,
      anon_sym_LBRACK,
    STATE(4587), 1,
      sym_parameter_list,
    STATE(3890), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7558), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7560), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [29788] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8502), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8504), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7771), 11,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [29872] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_LBRACE,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    STATE(4528), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7683), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7685), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [29942] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8526), 1,
      anon_sym_LPAREN2,
    ACTIONS(8528), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8530), 1,
      anon_sym_LBRACK,
    STATE(4587), 1,
      sym_parameter_list,
    STATE(3890), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7494), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7496), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [30016] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8526), 1,
      anon_sym_LPAREN2,
    ACTIONS(8528), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8530), 1,
      anon_sym_LBRACK,
    STATE(4587), 1,
      sym_parameter_list,
    STATE(3890), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7585), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7587), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [30090] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8566), 1,
      anon_sym_DASH_GT,
    ACTIONS(8571), 1,
      anon_sym_noexcept,
    ACTIONS(8573), 1,
      anon_sym_throw,
    ACTIONS(8586), 1,
      anon_sym_requires,
    ACTIONS(8588), 1,
      anon_sym_where,
    STATE(6227), 1,
      sym__function_attributes_start,
    STATE(6329), 1,
      sym_alignas_qualifier,
    STATE(6476), 1,
      sym_ref_qualifier,
    STATE(7459), 1,
      sym_where_clause,
    STATE(7598), 1,
      sym__function_attributes_end,
    STATE(7741), 1,
      sym_trailing_return_type,
    STATE(8986), 1,
      sym_gnu_asm_expression,
    ACTIONS(8133), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(8562), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(8564), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5330), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6044), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8811), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    STATE(6820), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8119), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(8560), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [30206] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8268), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8506), 1,
      anon_sym_PIPE,
    ACTIONS(8510), 1,
      anon_sym_AMP,
    ACTIONS(8516), 1,
      anon_sym_GT_EQ,
    ACTIONS(8522), 1,
      anon_sym_bitor,
    ACTIONS(8524), 1,
      anon_sym_bitand,
    ACTIONS(8532), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8534), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_or,
    ACTIONS(8540), 1,
      anon_sym_and,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8266), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(8502), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8504), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8512), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8514), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8520), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8270), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [30320] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2229), 1,
      anon_sym_LBRACE,
    ACTIONS(7261), 1,
      anon_sym_LT,
    STATE(4257), 1,
      sym_template_argument_list,
    ACTIONS(2234), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2224), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [30392] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(5344), 1,
      anon_sym_LPAREN2,
    ACTIONS(5346), 1,
      anon_sym_STAR,
    ACTIONS(5348), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5350), 1,
      anon_sym_AMP,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(7408), 1,
      anon_sym_LBRACK,
    ACTIONS(7410), 1,
      anon_sym_RPAREN,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7421), 1,
      sym__scope_resolution,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8366), 1,
      sym__declarator,
    STATE(8878), 1,
      sym__abstract_declarator,
    STATE(11547), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [30504] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8592), 1,
      anon_sym_where,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6215), 1,
      sym__function_attributes_start,
    STATE(6420), 1,
      sym_ref_qualifier,
    STATE(7459), 1,
      sym_where_clause,
    STATE(7571), 1,
      sym__function_attributes_end,
    STATE(7833), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5110), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5366), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8782), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6842), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8119), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [30626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3012), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [30690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2883), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2881), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [30754] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8506), 1,
      anon_sym_PIPE,
    ACTIONS(8510), 1,
      anon_sym_AMP,
    ACTIONS(8516), 1,
      anon_sym_GT_EQ,
    ACTIONS(8522), 1,
      anon_sym_bitor,
    ACTIONS(8524), 1,
      anon_sym_bitand,
    ACTIONS(8534), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8540), 1,
      anon_sym_and,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8502), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7771), 3,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(8504), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8512), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8514), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8520), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7773), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [30860] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8506), 1,
      anon_sym_PIPE,
    ACTIONS(8510), 1,
      anon_sym_AMP,
    ACTIONS(8516), 1,
      anon_sym_GT_EQ,
    ACTIONS(8522), 1,
      anon_sym_bitor,
    ACTIONS(8524), 1,
      anon_sym_bitand,
    ACTIONS(8532), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8534), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8538), 1,
      anon_sym_or,
    ACTIONS(8540), 1,
      anon_sym_and,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8284), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(8502), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8504), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8512), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8514), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8520), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8286), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [30970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2883), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2881), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [31034] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8506), 1,
      anon_sym_PIPE,
    ACTIONS(8510), 1,
      anon_sym_AMP,
    ACTIONS(8516), 1,
      anon_sym_GT_EQ,
    ACTIONS(8522), 1,
      anon_sym_bitor,
    ACTIONS(8524), 1,
      anon_sym_bitand,
    ACTIONS(8532), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8534), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8538), 1,
      anon_sym_or,
    ACTIONS(8540), 1,
      anon_sym_and,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8288), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(8502), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8504), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8512), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8514), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8520), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8290), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [31144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2982), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2980), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [31208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2938), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2936), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [31272] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_LBRACE,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    STATE(4550), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7695), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7697), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [31342] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8152), 1,
      anon_sym_requires,
    ACTIONS(8594), 1,
      anon_sym_where,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(6217), 1,
      sym__function_attributes_start,
    STATE(6438), 1,
      sym_ref_qualifier,
    STATE(7459), 1,
      sym_where_clause,
    STATE(7553), 1,
      sym__function_attributes_end,
    STATE(7768), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5009), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8615), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6856), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8119), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [31464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2940), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [31528] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8502), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8518), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8504), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8520), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 11,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [31614] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10065), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [31725] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5809), 1,
      sym_type_specifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(8794), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4447), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [31836] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5411), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(8728), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4420), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [31947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6156), 25,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6158), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [32010] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8528), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3925), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7594), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7596), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [32077] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5037), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7721), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4392), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [32188] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8644), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7771), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [32269] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8650), 1,
      sym_identifier,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      anon_sym_enum,
    ACTIONS(8656), 1,
      anon_sym_class,
    ACTIONS(8658), 1,
      anon_sym_struct,
    ACTIONS(8660), 1,
      anon_sym_union,
    ACTIONS(8662), 1,
      anon_sym_typename,
    ACTIONS(8664), 1,
      anon_sym_interface,
    ACTIONS(8666), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5443), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(8518), 1,
      sym_type_descriptor,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4422), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [32380] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(11344), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [32491] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9914), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [32602] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8650), 1,
      sym_identifier,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      anon_sym_enum,
    ACTIONS(8656), 1,
      anon_sym_class,
    ACTIONS(8658), 1,
      anon_sym_struct,
    ACTIONS(8660), 1,
      anon_sym_union,
    ACTIONS(8662), 1,
      anon_sym_typename,
    ACTIONS(8664), 1,
      anon_sym_interface,
    ACTIONS(8666), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5443), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7621), 1,
      sym_type_descriptor,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4422), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [32713] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8650), 1,
      sym_identifier,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      anon_sym_enum,
    ACTIONS(8656), 1,
      anon_sym_class,
    ACTIONS(8658), 1,
      anon_sym_struct,
    ACTIONS(8660), 1,
      anon_sym_union,
    ACTIONS(8662), 1,
      anon_sym_typename,
    ACTIONS(8664), 1,
      anon_sym_interface,
    ACTIONS(8666), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5443), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7604), 1,
      sym_type_descriptor,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4422), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [32824] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(8668), 1,
      anon_sym_STAR,
    ACTIONS(8670), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8672), 1,
      anon_sym_AMP,
    ACTIONS(8674), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7370), 1,
      sym__scope_resolution,
    STATE(8646), 1,
      sym__declarator,
    STATE(11143), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5057), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [32933] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9672), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [33044] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5037), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7867), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4392), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [33155] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5089), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7921), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4426), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [33266] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8650), 1,
      sym_identifier,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      anon_sym_enum,
    ACTIONS(8656), 1,
      anon_sym_class,
    ACTIONS(8658), 1,
      anon_sym_struct,
    ACTIONS(8660), 1,
      anon_sym_union,
    ACTIONS(8662), 1,
      anon_sym_typename,
    ACTIONS(8664), 1,
      anon_sym_interface,
    ACTIONS(8666), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5098), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7583), 1,
      sym_type_descriptor,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4401), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [33377] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5248), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8532), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4345), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [33488] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5089), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7930), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4426), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [33599] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5089), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7621), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4426), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [33710] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5089), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7604), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4426), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [33821] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5248), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8066), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4345), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [33932] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4998), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8096), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4417), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [34043] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5816), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(8887), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4450), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [34154] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5816), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(8778), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4450), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [34265] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5816), 1,
      sym_type_specifier,
    STATE(7541), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4450), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [34376] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5816), 1,
      sym_type_specifier,
    STATE(7486), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4450), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [34487] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5771), 1,
      sym_type_specifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(8819), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4427), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [34598] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8678), 1,
      sym_identifier,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8686), 1,
      anon_sym_enum,
    ACTIONS(8688), 1,
      anon_sym_class,
    ACTIONS(8690), 1,
      anon_sym_struct,
    ACTIONS(8692), 1,
      anon_sym_union,
    ACTIONS(8694), 1,
      anon_sym_typename,
    ACTIONS(8696), 1,
      anon_sym_interface,
    ACTIONS(8698), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5224), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5876), 1,
      sym_type_specifier,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(8803), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4424), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8682), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [34709] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5260), 1,
      sym_type_specifier,
    STATE(8252), 1,
      sym_type_descriptor,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4421), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [34820] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5260), 1,
      sym_type_specifier,
    STATE(8275), 1,
      sym_type_descriptor,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4421), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [34931] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5260), 1,
      sym_type_specifier,
    STATE(7541), 1,
      sym_type_descriptor,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4421), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [35042] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5260), 1,
      sym_type_specifier,
    STATE(7486), 1,
      sym_type_descriptor,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4421), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [35153] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8700), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7798), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7800), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [35218] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5251), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7473), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4418), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [35329] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4998), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8554), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4417), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [35440] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5083), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7976), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4449), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [35551] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2229), 1,
      anon_sym_LBRACE,
    ACTIONS(7258), 1,
      anon_sym_LT,
    STATE(4334), 1,
      sym_template_argument_list,
    ACTIONS(2234), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2224), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [35622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6112), 25,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6114), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [35685] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8702), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3925), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(4482), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7648), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [35752] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5248), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8188), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4345), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [35863] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8274), 1,
      anon_sym_EQ,
    ACTIONS(8346), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8392), 1,
      anon_sym_QMARK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8705), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8707), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8709), 1,
      anon_sym_PIPE,
    ACTIONS(8713), 1,
      anon_sym_AMP,
    ACTIONS(8719), 1,
      anon_sym_GT_EQ,
    ACTIONS(8723), 1,
      anon_sym_or,
    ACTIONS(8725), 1,
      anon_sym_and,
    ACTIONS(8727), 1,
      anon_sym_bitor,
    ACTIONS(8729), 1,
      anon_sym_bitand,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8644), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8416), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8715), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8717), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8276), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [35976] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(8668), 1,
      anon_sym_STAR,
    ACTIONS(8670), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8672), 1,
      anon_sym_AMP,
    ACTIONS(8674), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7370), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym__declarator,
    STATE(11143), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5045), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [36085] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(11646), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [36196] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5248), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8299), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4345), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [36307] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5299), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(8351), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4397), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [36418] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8731), 1,
      sym_identifier,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8737), 1,
      anon_sym_enum,
    ACTIONS(8739), 1,
      anon_sym_class,
    ACTIONS(8741), 1,
      anon_sym_struct,
    ACTIONS(8743), 1,
      anon_sym_union,
    ACTIONS(8745), 1,
      anon_sym_typename,
    ACTIONS(8747), 1,
      anon_sym_interface,
    ACTIONS(8749), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5394), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6236), 1,
      sym_type_specifier,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(9211), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4379), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8735), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [36529] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(11620), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [36640] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5299), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(8848), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4397), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [36751] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8751), 1,
      sym_identifier,
    ACTIONS(8753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8757), 1,
      sym_primitive_type,
    ACTIONS(8759), 1,
      anon_sym_enum,
    ACTIONS(8761), 1,
      anon_sym_class,
    ACTIONS(8763), 1,
      anon_sym_struct,
    ACTIONS(8765), 1,
      anon_sym_union,
    ACTIONS(8767), 1,
      anon_sym_typename,
    ACTIONS(8769), 1,
      anon_sym_interface,
    ACTIONS(8771), 1,
      anon_sym_extension,
    STATE(324), 1,
      sym_qualified_type_identifier,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5215), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5408), 1,
      sym_type_specifier,
    STATE(7583), 1,
      sym_type_descriptor,
    STATE(8727), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4318), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(125), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8755), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(315), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [36862] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5248), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7541), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4345), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [36973] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8751), 1,
      sym_identifier,
    ACTIONS(8753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8757), 1,
      sym_primitive_type,
    ACTIONS(8759), 1,
      anon_sym_enum,
    ACTIONS(8761), 1,
      anon_sym_class,
    ACTIONS(8763), 1,
      anon_sym_struct,
    ACTIONS(8765), 1,
      anon_sym_union,
    ACTIONS(8767), 1,
      anon_sym_typename,
    ACTIONS(8769), 1,
      anon_sym_interface,
    ACTIONS(8771), 1,
      anon_sym_extension,
    STATE(324), 1,
      sym_qualified_type_identifier,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5215), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6154), 1,
      sym_type_specifier,
    STATE(7621), 1,
      sym_type_descriptor,
    STATE(8727), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4443), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(125), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8755), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(315), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [37084] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5248), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7486), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4345), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [37195] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5299), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(8248), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4397), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [37306] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5037), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7687), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4392), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [37417] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8678), 1,
      sym_identifier,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8686), 1,
      anon_sym_enum,
    ACTIONS(8688), 1,
      anon_sym_class,
    ACTIONS(8690), 1,
      anon_sym_struct,
    ACTIONS(8692), 1,
      anon_sym_union,
    ACTIONS(8694), 1,
      anon_sym_typename,
    ACTIONS(8696), 1,
      anon_sym_interface,
    ACTIONS(8698), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5224), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5876), 1,
      sym_type_specifier,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(8921), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4424), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8682), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [37528] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(11430), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [37639] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9816), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [37750] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(7583), 1,
      sym_type_descriptor,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [37861] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9830), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [37972] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4835), 1,
      sym_type_specifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7523), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4425), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [38083] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5037), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7785), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4392), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [38194] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8773), 1,
      anon_sym_LT,
    STATE(2953), 1,
      sym_template_argument_list,
    STATE(3086), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6763), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2168), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(2176), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [38267] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(8960), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [38378] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5037), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7789), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4392), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [38489] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5037), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7621), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4392), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [38600] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5037), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7604), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4392), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [38711] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5411), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8551), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4420), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [38822] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5411), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8575), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4420), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [38933] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5411), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8580), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4420), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [39044] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5411), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7541), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4420), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [39155] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5411), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7486), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4420), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [39266] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8678), 1,
      sym_identifier,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8686), 1,
      anon_sym_enum,
    ACTIONS(8688), 1,
      anon_sym_class,
    ACTIONS(8690), 1,
      anon_sym_struct,
    ACTIONS(8692), 1,
      anon_sym_union,
    ACTIONS(8694), 1,
      anon_sym_typename,
    ACTIONS(8696), 1,
      anon_sym_interface,
    ACTIONS(8698), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5224), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5327), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8202), 1,
      sym_type_descriptor,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4430), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8682), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [39377] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5564), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(8693), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4428), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [39488] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5564), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(8698), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4428), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [39599] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5564), 1,
      sym_type_specifier,
    STATE(7541), 1,
      sym_type_descriptor,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4428), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [39710] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5564), 1,
      sym_type_specifier,
    STATE(7486), 1,
      sym_type_descriptor,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4428), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [39821] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5083), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7473), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4449), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [39932] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5771), 1,
      sym_type_specifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(8869), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4427), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [40043] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(11522), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [40154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3399), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [40217] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8775), 1,
      anon_sym_STAR,
    ACTIONS(8777), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8779), 1,
      anon_sym_AMP,
    ACTIONS(8781), 1,
      anon_sym_COLON_COLON,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7449), 1,
      sym__scope_resolution,
    STATE(8833), 1,
      sym__declarator,
    STATE(11283), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5030), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [40326] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11122), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [40437] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8678), 1,
      sym_identifier,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8686), 1,
      anon_sym_enum,
    ACTIONS(8688), 1,
      anon_sym_class,
    ACTIONS(8690), 1,
      anon_sym_struct,
    ACTIONS(8692), 1,
      anon_sym_union,
    ACTIONS(8694), 1,
      anon_sym_typename,
    ACTIONS(8696), 1,
      anon_sym_interface,
    ACTIONS(8698), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5224), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5876), 1,
      sym_type_specifier,
    STATE(7541), 1,
      sym_type_descriptor,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4424), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8682), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [40548] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5089), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7837), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4426), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [40659] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11261), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [40770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3399), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [40833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2404), 25,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(2402), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [40896] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9993), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [41007] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2452), 1,
      anon_sym_STAR,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7421), 1,
      sym__scope_resolution,
    STATE(8366), 1,
      sym__declarator,
    STATE(11547), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5067), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [41116] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5809), 1,
      sym_type_specifier,
    STATE(7486), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4447), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [41227] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8678), 1,
      sym_identifier,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8686), 1,
      anon_sym_enum,
    ACTIONS(8688), 1,
      anon_sym_class,
    ACTIONS(8690), 1,
      anon_sym_struct,
    ACTIONS(8692), 1,
      anon_sym_union,
    ACTIONS(8694), 1,
      anon_sym_typename,
    ACTIONS(8696), 1,
      anon_sym_interface,
    ACTIONS(8698), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5224), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5327), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8265), 1,
      sym_type_descriptor,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4430), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8682), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [41338] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5299), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(8665), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4397), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [41449] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8678), 1,
      sym_identifier,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8686), 1,
      anon_sym_enum,
    ACTIONS(8688), 1,
      anon_sym_class,
    ACTIONS(8690), 1,
      anon_sym_struct,
    ACTIONS(8692), 1,
      anon_sym_union,
    ACTIONS(8694), 1,
      anon_sym_typename,
    ACTIONS(8696), 1,
      anon_sym_interface,
    ACTIONS(8698), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5224), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5327), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7473), 1,
      sym_type_descriptor,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4430), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8682), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [41560] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(11400), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [41671] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10263), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [41782] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5248), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8302), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4345), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [41893] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6099), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9105), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4432), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [42004] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10293), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [42115] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8650), 1,
      sym_identifier,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      anon_sym_enum,
    ACTIONS(8656), 1,
      anon_sym_class,
    ACTIONS(8658), 1,
      anon_sym_struct,
    ACTIONS(8660), 1,
      anon_sym_union,
    ACTIONS(8662), 1,
      anon_sym_typename,
    ACTIONS(8664), 1,
      anon_sym_interface,
    ACTIONS(8666), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5098), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(8002), 1,
      sym_type_descriptor,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4401), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [42226] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5411), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(8661), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4420), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [42337] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    STATE(2953), 1,
      sym_template_argument_list,
    STATE(3086), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6763), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3777), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(3775), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [42408] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8650), 1,
      sym_identifier,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      anon_sym_enum,
    ACTIONS(8656), 1,
      anon_sym_class,
    ACTIONS(8658), 1,
      anon_sym_struct,
    ACTIONS(8660), 1,
      anon_sym_union,
    ACTIONS(8662), 1,
      anon_sym_typename,
    ACTIONS(8664), 1,
      anon_sym_interface,
    ACTIONS(8666), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5098), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7931), 1,
      sym_type_descriptor,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4401), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [42519] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8650), 1,
      sym_identifier,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      anon_sym_enum,
    ACTIONS(8656), 1,
      anon_sym_class,
    ACTIONS(8658), 1,
      anon_sym_struct,
    ACTIONS(8660), 1,
      anon_sym_union,
    ACTIONS(8662), 1,
      anon_sym_typename,
    ACTIONS(8664), 1,
      anon_sym_interface,
    ACTIONS(8666), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5098), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7621), 1,
      sym_type_descriptor,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4401), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [42630] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8650), 1,
      sym_identifier,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      anon_sym_enum,
    ACTIONS(8656), 1,
      anon_sym_class,
    ACTIONS(8658), 1,
      anon_sym_struct,
    ACTIONS(8660), 1,
      anon_sym_union,
    ACTIONS(8662), 1,
      anon_sym_typename,
    ACTIONS(8664), 1,
      anon_sym_interface,
    ACTIONS(8666), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5098), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7604), 1,
      sym_type_descriptor,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4401), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [42741] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5411), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8529), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4420), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [42852] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9231), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [42963] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9228), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [43074] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5229), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7541), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4415), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [43185] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5229), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7486), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4415), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [43296] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5481), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7473), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [43407] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8783), 1,
      anon_sym_STAR,
    ACTIONS(8785), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8787), 1,
      anon_sym_AMP,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7901), 1,
      sym__declarator,
    STATE(10947), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5081), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [43516] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8789), 1,
      anon_sym_STAR,
    ACTIONS(8791), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8793), 1,
      anon_sym_AMP,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(8068), 1,
      sym__declarator,
    STATE(11397), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4256), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5069), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [43625] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(11421), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [43736] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5037), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7583), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4392), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [43847] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8731), 1,
      sym_identifier,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8737), 1,
      anon_sym_enum,
    ACTIONS(8739), 1,
      anon_sym_class,
    ACTIONS(8741), 1,
      anon_sym_struct,
    ACTIONS(8743), 1,
      anon_sym_union,
    ACTIONS(8745), 1,
      anon_sym_typename,
    ACTIONS(8747), 1,
      anon_sym_interface,
    ACTIONS(8749), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5394), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5553), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8682), 1,
      sym_type_descriptor,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4517), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8735), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [43958] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(10917), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [44069] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8731), 1,
      sym_identifier,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8737), 1,
      anon_sym_enum,
    ACTIONS(8739), 1,
      anon_sym_class,
    ACTIONS(8741), 1,
      anon_sym_struct,
    ACTIONS(8743), 1,
      anon_sym_union,
    ACTIONS(8745), 1,
      anon_sym_typename,
    ACTIONS(8747), 1,
      anon_sym_interface,
    ACTIONS(8749), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5394), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5553), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8701), 1,
      sym_type_descriptor,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4517), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8735), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [44180] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6099), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9135), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4432), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [44291] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6099), 1,
      sym_type_specifier,
    STATE(7541), 1,
      sym_type_descriptor,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4432), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [44402] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8731), 1,
      sym_identifier,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8737), 1,
      anon_sym_enum,
    ACTIONS(8739), 1,
      anon_sym_class,
    ACTIONS(8741), 1,
      anon_sym_struct,
    ACTIONS(8743), 1,
      anon_sym_union,
    ACTIONS(8745), 1,
      anon_sym_typename,
    ACTIONS(8747), 1,
      anon_sym_interface,
    ACTIONS(8749), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5394), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6236), 1,
      sym_type_specifier,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(9212), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4379), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8735), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [44513] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8731), 1,
      sym_identifier,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8737), 1,
      anon_sym_enum,
    ACTIONS(8739), 1,
      anon_sym_class,
    ACTIONS(8741), 1,
      anon_sym_struct,
    ACTIONS(8743), 1,
      anon_sym_union,
    ACTIONS(8745), 1,
      anon_sym_typename,
    ACTIONS(8747), 1,
      anon_sym_interface,
    ACTIONS(8749), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5394), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6236), 1,
      sym_type_specifier,
    STATE(7541), 1,
      sym_type_descriptor,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4379), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8735), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [44624] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8731), 1,
      sym_identifier,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8737), 1,
      anon_sym_enum,
    ACTIONS(8739), 1,
      anon_sym_class,
    ACTIONS(8741), 1,
      anon_sym_struct,
    ACTIONS(8743), 1,
      anon_sym_union,
    ACTIONS(8745), 1,
      anon_sym_typename,
    ACTIONS(8747), 1,
      anon_sym_interface,
    ACTIONS(8749), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5394), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6236), 1,
      sym_type_specifier,
    STATE(7486), 1,
      sym_type_descriptor,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4379), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8735), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [44735] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4835), 1,
      sym_type_specifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7422), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4425), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [44846] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8731), 1,
      sym_identifier,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8737), 1,
      anon_sym_enum,
    ACTIONS(8739), 1,
      anon_sym_class,
    ACTIONS(8741), 1,
      anon_sym_struct,
    ACTIONS(8743), 1,
      anon_sym_union,
    ACTIONS(8745), 1,
      anon_sym_typename,
    ACTIONS(8747), 1,
      anon_sym_interface,
    ACTIONS(8749), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5394), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5553), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7541), 1,
      sym_type_descriptor,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4517), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8735), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [44957] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11134), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45068] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9667), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45179] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6099), 1,
      sym_type_specifier,
    STATE(7486), 1,
      sym_type_descriptor,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4432), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45290] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8737), 1,
      anon_sym_enum,
    ACTIONS(8739), 1,
      anon_sym_class,
    ACTIONS(8741), 1,
      anon_sym_struct,
    ACTIONS(8743), 1,
      anon_sym_union,
    ACTIONS(8745), 1,
      anon_sym_typename,
    ACTIONS(8747), 1,
      anon_sym_interface,
    ACTIONS(8749), 1,
      anon_sym_extension,
    ACTIONS(8795), 1,
      sym_identifier,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5394), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6236), 1,
      sym_type_specifier,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(11494), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4379), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8735), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45401] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9677), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45512] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4835), 1,
      sym_type_specifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7495), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4425), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45623] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8385), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5068), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45732] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8751), 1,
      sym_identifier,
    ACTIONS(8753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8757), 1,
      sym_primitive_type,
    ACTIONS(8759), 1,
      anon_sym_enum,
    ACTIONS(8761), 1,
      anon_sym_class,
    ACTIONS(8763), 1,
      anon_sym_struct,
    ACTIONS(8765), 1,
      anon_sym_union,
    ACTIONS(8767), 1,
      anon_sym_typename,
    ACTIONS(8769), 1,
      anon_sym_interface,
    ACTIONS(8771), 1,
      anon_sym_extension,
    STATE(324), 1,
      sym_qualified_type_identifier,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5215), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6154), 1,
      sym_type_specifier,
    STATE(8727), 1,
      sym__scope_resolution,
    STATE(9095), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4443), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(125), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8755), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(315), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45843] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4835), 1,
      sym_type_specifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7499), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4425), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45954] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4835), 1,
      sym_type_specifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7621), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4425), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [46065] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4835), 1,
      sym_type_specifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7604), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4425), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [46176] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5411), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8314), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4420), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [46287] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5229), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8217), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4415), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [46398] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5229), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8241), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4415), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [46509] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4998), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7541), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4417), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [46620] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4998), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7486), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4417), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [46731] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2883), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2881), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [46796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 25,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6130), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [46859] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10760), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [46970] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11272), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [47081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6298), 25,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6300), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [47144] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8775), 1,
      anon_sym_STAR,
    ACTIONS(8777), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8779), 1,
      anon_sym_AMP,
    ACTIONS(8781), 1,
      anon_sym_COLON_COLON,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7449), 1,
      sym__scope_resolution,
    STATE(8833), 1,
      sym__declarator,
    STATE(11283), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4040), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5030), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [47253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6136), 25,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6138), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [47316] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5266), 1,
      anon_sym_LBRACE,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    STATE(4797), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7658), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7660), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [47385] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5037), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(8067), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4392), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [47496] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8731), 1,
      sym_identifier,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8737), 1,
      anon_sym_enum,
    ACTIONS(8739), 1,
      anon_sym_class,
    ACTIONS(8741), 1,
      anon_sym_struct,
    ACTIONS(8743), 1,
      anon_sym_union,
    ACTIONS(8745), 1,
      anon_sym_typename,
    ACTIONS(8747), 1,
      anon_sym_interface,
    ACTIONS(8749), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5394), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5553), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7486), 1,
      sym_type_descriptor,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4517), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8735), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [47607] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(11487), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [47718] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9788), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [47829] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6234), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9292), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4407), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [47940] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8775), 1,
      anon_sym_STAR,
    ACTIONS(8777), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8779), 1,
      anon_sym_AMP,
    ACTIONS(8781), 1,
      anon_sym_COLON_COLON,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7449), 1,
      sym__scope_resolution,
    STATE(8835), 1,
      sym__declarator,
    STATE(11283), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5047), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [48049] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9803), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [48160] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8807), 1,
      anon_sym_LT,
    STATE(1456), 1,
      sym_template_argument_list,
    ACTIONS(7783), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7785), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [48227] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5771), 1,
      sym_type_specifier,
    STATE(8629), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4427), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [48338] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4998), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7674), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4417), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [48449] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4998), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7678), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4417), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [48560] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5251), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7541), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4418), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [48671] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5251), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7486), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4418), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [48782] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8807), 1,
      anon_sym_LT,
    STATE(1494), 1,
      sym_template_argument_list,
    ACTIONS(7783), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7785), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [48849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6160), 25,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6162), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [48912] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11063), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [49023] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8678), 1,
      sym_identifier,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8686), 1,
      anon_sym_enum,
    ACTIONS(8688), 1,
      anon_sym_class,
    ACTIONS(8690), 1,
      anon_sym_struct,
    ACTIONS(8692), 1,
      anon_sym_union,
    ACTIONS(8694), 1,
      anon_sym_typename,
    ACTIONS(8696), 1,
      anon_sym_interface,
    ACTIONS(8698), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5224), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5876), 1,
      sym_type_specifier,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(8918), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4424), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8682), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [49134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6144), 25,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6146), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [49197] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11098), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [49308] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9893), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [49419] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5411), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8510), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4420), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [49530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2879), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2877), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [49593] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9899), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [49704] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8775), 1,
      anon_sym_STAR,
    ACTIONS(8777), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8779), 1,
      anon_sym_AMP,
    ACTIONS(8781), 1,
      anon_sym_COLON_COLON,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7449), 1,
      sym__scope_resolution,
    STATE(8831), 1,
      sym__declarator,
    STATE(11283), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3967), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5013), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [49813] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4998), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7902), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4417), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [49924] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5251), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8235), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4418), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [50035] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5251), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8243), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4418), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [50146] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5083), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7541), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4449), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [50257] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5083), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7486), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4449), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [50368] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8810), 1,
      sym_identifier,
    STATE(4208), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(7424), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(7426), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(7192), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7190), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [50439] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(11542), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [50550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6164), 25,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6166), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [50613] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6234), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9232), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4407), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [50724] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(11591), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [50835] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9982), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [50946] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2452), 1,
      anon_sym_STAR,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7421), 1,
      sym__scope_resolution,
    STATE(8366), 1,
      sym__declarator,
    STATE(11547), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4295), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5067), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [51055] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10000), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [51166] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(11641), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [51277] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5248), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(8865), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4345), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [51388] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5083), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7977), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4449), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [51499] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5083), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7990), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4449), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [51610] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5771), 1,
      sym_type_specifier,
    STATE(7541), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4427), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [51721] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5771), 1,
      sym_type_specifier,
    STATE(7486), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4427), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [51832] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11090), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [51943] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8789), 1,
      anon_sym_STAR,
    ACTIONS(8791), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8793), 1,
      anon_sym_AMP,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(8143), 1,
      sym__declarator,
    STATE(11397), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4227), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5060), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [52052] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10059), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [52163] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8366), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4017), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5056), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [52272] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6234), 1,
      sym_type_specifier,
    STATE(7541), 1,
      sym_type_descriptor,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4407), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [52383] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5266), 1,
      anon_sym_LBRACE,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    STATE(4666), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7695), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7697), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [52452] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4998), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7949), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4417), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [52563] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5771), 1,
      sym_type_specifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(8852), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4427), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [52674] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5771), 1,
      sym_type_specifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(8857), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4427), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [52785] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5481), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7541), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [52896] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5481), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7486), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [53007] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6234), 1,
      sym_type_specifier,
    STATE(7486), 1,
      sym_type_descriptor,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4407), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [53118] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10100), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [53229] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8678), 1,
      sym_identifier,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8686), 1,
      anon_sym_enum,
    ACTIONS(8688), 1,
      anon_sym_class,
    ACTIONS(8690), 1,
      anon_sym_struct,
    ACTIONS(8692), 1,
      anon_sym_union,
    ACTIONS(8694), 1,
      anon_sym_typename,
    ACTIONS(8696), 1,
      anon_sym_interface,
    ACTIONS(8698), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5224), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5876), 1,
      sym_type_specifier,
    STATE(7486), 1,
      sym_type_descriptor,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4424), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8682), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [53340] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10107), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [53451] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8644), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8416), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7771), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [53536] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4998), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7601), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4417), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [53647] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5481), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(8747), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [53758] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5481), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(8634), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [53869] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7836), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7838), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [53944] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10132), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [54055] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5299), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7621), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4397), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [54166] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10136), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [54277] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5037), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(8287), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4392), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [54388] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5083), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7965), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4449), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [54499] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10163), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [54610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3621), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3623), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [54673] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10168), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [54784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 25,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6324), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [54847] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5083), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7948), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4449), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [54958] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8678), 1,
      sym_identifier,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8686), 1,
      anon_sym_enum,
    ACTIONS(8688), 1,
      anon_sym_class,
    ACTIONS(8690), 1,
      anon_sym_struct,
    ACTIONS(8692), 1,
      anon_sym_union,
    ACTIONS(8694), 1,
      anon_sym_typename,
    ACTIONS(8696), 1,
      anon_sym_interface,
    ACTIONS(8698), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5224), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5327), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8425), 1,
      sym_type_descriptor,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4430), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8682), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [55069] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10195), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [55180] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5248), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(9179), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4345), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [55291] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10199), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [55402] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(11545), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [55513] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5083), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7826), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4449), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [55624] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8751), 1,
      sym_identifier,
    ACTIONS(8753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8757), 1,
      sym_primitive_type,
    ACTIONS(8759), 1,
      anon_sym_enum,
    ACTIONS(8761), 1,
      anon_sym_class,
    ACTIONS(8763), 1,
      anon_sym_struct,
    ACTIONS(8765), 1,
      anon_sym_union,
    ACTIONS(8767), 1,
      anon_sym_typename,
    ACTIONS(8769), 1,
      anon_sym_interface,
    ACTIONS(8771), 1,
      anon_sym_extension,
    STATE(324), 1,
      sym_qualified_type_identifier,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5215), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6154), 1,
      sym_type_specifier,
    STATE(7604), 1,
      sym_type_descriptor,
    STATE(8727), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4443), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(125), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8755), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(315), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [55735] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10224), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [55846] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8266), 1,
      anon_sym_EQ,
    ACTIONS(8346), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8392), 1,
      anon_sym_QMARK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8705), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8707), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8709), 1,
      anon_sym_PIPE,
    ACTIONS(8713), 1,
      anon_sym_AMP,
    ACTIONS(8719), 1,
      anon_sym_GT_EQ,
    ACTIONS(8723), 1,
      anon_sym_or,
    ACTIONS(8725), 1,
      anon_sym_and,
    ACTIONS(8727), 1,
      anon_sym_bitor,
    ACTIONS(8729), 1,
      anon_sym_bitand,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8644), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8416), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8715), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8717), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8270), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [55959] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10228), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [56070] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(10660), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [56181] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5771), 1,
      sym_type_specifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(8704), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4427), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [56292] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8193), 1,
      anon_sym___attribute__,
    ACTIONS(8196), 1,
      anon_sym___attribute,
    ACTIONS(8812), 1,
      anon_sym_DASH_GT,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(8816), 1,
      anon_sym_where,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(6339), 1,
      sym__function_attributes_start,
    STATE(6530), 1,
      sym_ref_qualifier,
    STATE(7459), 1,
      sym_where_clause,
    STATE(7533), 1,
      sym__function_attributes_end,
    STATE(7656), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5009), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8768), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6880), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8119), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [56413] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10251), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [56524] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8678), 1,
      sym_identifier,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8686), 1,
      anon_sym_enum,
    ACTIONS(8688), 1,
      anon_sym_class,
    ACTIONS(8690), 1,
      anon_sym_struct,
    ACTIONS(8692), 1,
      anon_sym_union,
    ACTIONS(8694), 1,
      anon_sym_typename,
    ACTIONS(8696), 1,
      anon_sym_interface,
    ACTIONS(8698), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5224), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5327), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8475), 1,
      sym_type_descriptor,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4430), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8682), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [56635] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10257), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [56746] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6234), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(11422), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4407), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [56857] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4998), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8353), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4417), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [56968] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5299), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7604), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4397), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [57079] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10289), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [57190] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8783), 1,
      anon_sym_STAR,
    ACTIONS(8785), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8787), 1,
      anon_sym_AMP,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7998), 1,
      sym__declarator,
    STATE(10947), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3997), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5079), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [57299] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10297), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [57410] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7804), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7806), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [57487] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4998), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8284), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4417), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [57598] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10324), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [57709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 25,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6324), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [57772] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10325), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [57883] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7852), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7854), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [57960] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9739), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [58071] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11112), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [58182] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9824), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [58293] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5248), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8592), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4345), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [58404] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10149), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [58515] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5248), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(8924), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4345), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [58626] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10232), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [58737] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8678), 1,
      sym_identifier,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8686), 1,
      anon_sym_enum,
    ACTIONS(8688), 1,
      anon_sym_class,
    ACTIONS(8690), 1,
      anon_sym_struct,
    ACTIONS(8692), 1,
      anon_sym_union,
    ACTIONS(8694), 1,
      anon_sym_typename,
    ACTIONS(8696), 1,
      anon_sym_interface,
    ACTIONS(8698), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5224), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5327), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8479), 1,
      sym_type_descriptor,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4430), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8682), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [58848] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9620), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [58959] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8731), 1,
      sym_identifier,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8737), 1,
      anon_sym_enum,
    ACTIONS(8739), 1,
      anon_sym_class,
    ACTIONS(8741), 1,
      anon_sym_struct,
    ACTIONS(8743), 1,
      anon_sym_union,
    ACTIONS(8745), 1,
      anon_sym_typename,
    ACTIONS(8747), 1,
      anon_sym_interface,
    ACTIONS(8749), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5394), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5553), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7473), 1,
      sym_type_descriptor,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4517), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8735), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [59070] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9642), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [59181] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8678), 1,
      sym_identifier,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8686), 1,
      anon_sym_enum,
    ACTIONS(8688), 1,
      anon_sym_class,
    ACTIONS(8690), 1,
      anon_sym_struct,
    ACTIONS(8692), 1,
      anon_sym_union,
    ACTIONS(8694), 1,
      anon_sym_typename,
    ACTIONS(8696), 1,
      anon_sym_interface,
    ACTIONS(8698), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5224), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5327), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7541), 1,
      sym_type_descriptor,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4430), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8682), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [59292] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9703), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [59403] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(8936), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [59514] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9709), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [59625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 25,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6324), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [59688] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9750), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [59799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3560), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3562), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [59862] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9775), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [59973] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5266), 1,
      anon_sym_LBRACE,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    STATE(4803), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7671), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7673), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [60042] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9843), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [60153] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7794), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7796), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [60230] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9866), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [60341] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8678), 1,
      sym_identifier,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8686), 1,
      anon_sym_enum,
    ACTIONS(8688), 1,
      anon_sym_class,
    ACTIONS(8690), 1,
      anon_sym_struct,
    ACTIONS(8692), 1,
      anon_sym_union,
    ACTIONS(8694), 1,
      anon_sym_typename,
    ACTIONS(8696), 1,
      anon_sym_interface,
    ACTIONS(8698), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5224), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5327), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7486), 1,
      sym_type_descriptor,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4430), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8682), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [60452] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9940), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [60563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3560), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3562), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [60626] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9950), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [60737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8332), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8330), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
  [60800] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10009), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [60911] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4998), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8039), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4417), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [61022] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10029), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [61133] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10089), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [61244] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4694), 1,
      sym_alignas_qualifier,
    ACTIONS(8821), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3681), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(8818), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(3683), 24,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [61315] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      sym_primitive_type,
    ACTIONS(8830), 1,
      anon_sym_enum,
    ACTIONS(8832), 1,
      anon_sym_class,
    ACTIONS(8834), 1,
      anon_sym_struct,
    ACTIONS(8836), 1,
      anon_sym_union,
    ACTIONS(8838), 1,
      anon_sym_typename,
    ACTIONS(8840), 1,
      anon_sym_interface,
    ACTIONS(8842), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(6223), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6508), 1,
      sym_type_specifier,
    STATE(7218), 1,
      sym__type_definition_type,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4437), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8826), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [61426] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4835), 1,
      sym_type_specifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7583), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4425), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [61537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3450), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3452), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [61600] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8193), 1,
      anon_sym___attribute__,
    ACTIONS(8196), 1,
      anon_sym___attribute,
    ACTIONS(8812), 1,
      anon_sym_DASH_GT,
    ACTIONS(8844), 1,
      anon_sym_requires,
    ACTIONS(8847), 1,
      anon_sym_where,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(6261), 1,
      sym__function_attributes_start,
    STATE(6489), 1,
      sym_ref_qualifier,
    STATE(7459), 1,
      sym_where_clause,
    STATE(7460), 1,
      sym__function_attributes_end,
    STATE(7663), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8145), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5009), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8257), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6881), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8119), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [61721] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8850), 1,
      anon_sym_LT,
    STATE(3845), 1,
      sym_template_argument_list,
    ACTIONS(7783), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7785), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [61788] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5334), 1,
      sym_type_specifier,
    STATE(8463), 1,
      sym_type_descriptor,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4451), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [61899] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8185), 1,
      anon_sym_LBRACK,
    STATE(4339), 1,
      sym_new_declarator,
    ACTIONS(7713), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7715), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [61966] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8284), 1,
      anon_sym_EQ,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8705), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8707), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8709), 1,
      anon_sym_PIPE,
    ACTIONS(8713), 1,
      anon_sym_AMP,
    ACTIONS(8719), 1,
      anon_sym_GT_EQ,
    ACTIONS(8723), 1,
      anon_sym_or,
    ACTIONS(8725), 1,
      anon_sym_and,
    ACTIONS(8727), 1,
      anon_sym_bitor,
    ACTIONS(8729), 1,
      anon_sym_bitand,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8644), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8416), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8715), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8717), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8286), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [62075] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5248), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(8667), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4345), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [62186] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5784), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(8799), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4429), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [62297] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      sym_primitive_type,
    ACTIONS(8830), 1,
      anon_sym_enum,
    ACTIONS(8832), 1,
      anon_sym_class,
    ACTIONS(8834), 1,
      anon_sym_struct,
    ACTIONS(8836), 1,
      anon_sym_union,
    ACTIONS(8838), 1,
      anon_sym_typename,
    ACTIONS(8840), 1,
      anon_sym_interface,
    ACTIONS(8842), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(6223), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6508), 1,
      sym_type_specifier,
    STATE(7222), 1,
      sym__type_definition_type,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4437), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8826), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [62408] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5784), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(8804), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4429), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [62519] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5784), 1,
      sym_type_specifier,
    STATE(7541), 1,
      sym_type_descriptor,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4429), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [62630] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5784), 1,
      sym_type_specifier,
    STATE(7486), 1,
      sym_type_descriptor,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4429), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [62741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3560), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3562), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [62804] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5809), 1,
      sym_type_specifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(8790), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4447), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [62915] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5334), 1,
      sym_type_specifier,
    STATE(8470), 1,
      sym_type_descriptor,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4451), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [63026] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5299), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(8293), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4397), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [63137] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10495), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [63248] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11299), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [63359] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4998), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8502), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4417), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [63470] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5809), 1,
      sym_type_specifier,
    STATE(7541), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4447), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [63581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2414), 25,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(2412), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [63644] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5248), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(8943), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4345), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [63755] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5334), 1,
      sym_type_specifier,
    STATE(7541), 1,
      sym_type_descriptor,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4451), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [63866] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8783), 1,
      anon_sym_STAR,
    ACTIONS(8785), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8787), 1,
      anon_sym_AMP,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7901), 1,
      sym__declarator,
    STATE(10947), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4212), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5081), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [63975] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(7541), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [64086] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(7486), 1,
      sym_type_descriptor,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [64197] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5334), 1,
      sym_type_specifier,
    STATE(7486), 1,
      sym_type_descriptor,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4451), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [64308] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4998), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7473), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4417), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [64419] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9780), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [64530] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6099), 1,
      sym_type_specifier,
    STATE(7583), 1,
      sym_type_descriptor,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4432), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [64641] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      sym_primitive_type,
    ACTIONS(8830), 1,
      anon_sym_enum,
    ACTIONS(8832), 1,
      anon_sym_class,
    ACTIONS(8834), 1,
      anon_sym_struct,
    ACTIONS(8836), 1,
      anon_sym_union,
    ACTIONS(8838), 1,
      anon_sym_typename,
    ACTIONS(8840), 1,
      anon_sym_interface,
    ACTIONS(8842), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(6223), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6508), 1,
      sym_type_specifier,
    STATE(7258), 1,
      sym__type_definition_type,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4437), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8826), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [64752] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5083), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8090), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4449), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [64863] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8853), 1,
      anon_sym_LT,
    STATE(4433), 1,
      sym_template_argument_list,
    ACTIONS(7726), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7728), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [64932] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      sym_primitive_type,
    ACTIONS(8830), 1,
      anon_sym_enum,
    ACTIONS(8832), 1,
      anon_sym_class,
    ACTIONS(8834), 1,
      anon_sym_struct,
    ACTIONS(8836), 1,
      anon_sym_union,
    ACTIONS(8838), 1,
      anon_sym_typename,
    ACTIONS(8840), 1,
      anon_sym_interface,
    ACTIONS(8842), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(6223), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6508), 1,
      sym_type_specifier,
    STATE(7261), 1,
      sym__type_definition_type,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4437), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8826), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [65043] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5229), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7473), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4415), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [65154] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(7541), 1,
      sym_type_descriptor,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [65265] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5564), 1,
      sym_type_specifier,
    STATE(7473), 1,
      sym_type_descriptor,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4428), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [65376] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8856), 1,
      sym_identifier,
    STATE(4243), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(7424), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(7426), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(7219), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7217), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [65447] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(11609), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [65558] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5083), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8138), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4449), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [65669] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      sym_primitive_type,
    ACTIONS(8830), 1,
      anon_sym_enum,
    ACTIONS(8832), 1,
      anon_sym_class,
    ACTIONS(8834), 1,
      anon_sym_struct,
    ACTIONS(8836), 1,
      anon_sym_union,
    ACTIONS(8838), 1,
      anon_sym_typename,
    ACTIONS(8840), 1,
      anon_sym_interface,
    ACTIONS(8842), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(6223), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6508), 1,
      sym_type_specifier,
    STATE(7267), 1,
      sym__type_definition_type,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4437), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8826), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [65780] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8783), 1,
      anon_sym_STAR,
    ACTIONS(8785), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8787), 1,
      anon_sym_AMP,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7944), 1,
      sym__declarator,
    STATE(10947), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5022), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [65889] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      sym_primitive_type,
    ACTIONS(8830), 1,
      anon_sym_enum,
    ACTIONS(8832), 1,
      anon_sym_class,
    ACTIONS(8834), 1,
      anon_sym_struct,
    ACTIONS(8836), 1,
      anon_sym_union,
    ACTIONS(8838), 1,
      anon_sym_typename,
    ACTIONS(8840), 1,
      anon_sym_interface,
    ACTIONS(8842), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(6223), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6508), 1,
      sym_type_specifier,
    STATE(7269), 1,
      sym__type_definition_type,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4437), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8826), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [66000] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      sym_primitive_type,
    ACTIONS(8830), 1,
      anon_sym_enum,
    ACTIONS(8832), 1,
      anon_sym_class,
    ACTIONS(8834), 1,
      anon_sym_struct,
    ACTIONS(8836), 1,
      anon_sym_union,
    ACTIONS(8838), 1,
      anon_sym_typename,
    ACTIONS(8840), 1,
      anon_sym_interface,
    ACTIONS(8842), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(6223), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6508), 1,
      sym_type_specifier,
    STATE(7270), 1,
      sym__type_definition_type,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4437), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8826), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [66111] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5248), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8632), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4345), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [66222] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5266), 1,
      anon_sym_LBRACE,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    STATE(4726), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7683), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7685), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [66291] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7771), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [66370] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      sym_primitive_type,
    ACTIONS(8830), 1,
      anon_sym_enum,
    ACTIONS(8832), 1,
      anon_sym_class,
    ACTIONS(8834), 1,
      anon_sym_struct,
    ACTIONS(8836), 1,
      anon_sym_union,
    ACTIONS(8838), 1,
      anon_sym_typename,
    ACTIONS(8840), 1,
      anon_sym_interface,
    ACTIONS(8842), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(6223), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6508), 1,
      sym_type_specifier,
    STATE(7271), 1,
      sym__type_definition_type,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4437), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8826), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [66481] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7771), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [66558] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      sym_primitive_type,
    ACTIONS(8830), 1,
      anon_sym_enum,
    ACTIONS(8832), 1,
      anon_sym_class,
    ACTIONS(8834), 1,
      anon_sym_struct,
    ACTIONS(8836), 1,
      anon_sym_union,
    ACTIONS(8838), 1,
      anon_sym_typename,
    ACTIONS(8840), 1,
      anon_sym_interface,
    ACTIONS(8842), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(6223), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6508), 1,
      sym_type_specifier,
    STATE(7272), 1,
      sym__type_definition_type,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4437), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8826), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [66669] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8707), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8709), 1,
      anon_sym_PIPE,
    ACTIONS(8713), 1,
      anon_sym_AMP,
    ACTIONS(8719), 1,
      anon_sym_GT_EQ,
    ACTIONS(8725), 1,
      anon_sym_and,
    ACTIONS(8727), 1,
      anon_sym_bitor,
    ACTIONS(8729), 1,
      anon_sym_bitand,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(7771), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8644), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8416), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8715), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8717), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [66774] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8751), 1,
      sym_identifier,
    ACTIONS(8753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8757), 1,
      sym_primitive_type,
    ACTIONS(8759), 1,
      anon_sym_enum,
    ACTIONS(8761), 1,
      anon_sym_class,
    ACTIONS(8763), 1,
      anon_sym_struct,
    ACTIONS(8765), 1,
      anon_sym_union,
    ACTIONS(8767), 1,
      anon_sym_typename,
    ACTIONS(8769), 1,
      anon_sym_interface,
    ACTIONS(8771), 1,
      anon_sym_extension,
    STATE(324), 1,
      sym_qualified_type_identifier,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5215), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5408), 1,
      sym_type_specifier,
    STATE(8594), 1,
      sym_type_descriptor,
    STATE(8727), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4318), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(125), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8755), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(315), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [66885] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      sym_primitive_type,
    ACTIONS(8830), 1,
      anon_sym_enum,
    ACTIONS(8832), 1,
      anon_sym_class,
    ACTIONS(8834), 1,
      anon_sym_struct,
    ACTIONS(8836), 1,
      anon_sym_union,
    ACTIONS(8838), 1,
      anon_sym_typename,
    ACTIONS(8840), 1,
      anon_sym_interface,
    ACTIONS(8842), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(6223), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6508), 1,
      sym_type_specifier,
    STATE(7273), 1,
      sym__type_definition_type,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4437), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8826), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [66996] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8751), 1,
      sym_identifier,
    ACTIONS(8753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8757), 1,
      sym_primitive_type,
    ACTIONS(8759), 1,
      anon_sym_enum,
    ACTIONS(8761), 1,
      anon_sym_class,
    ACTIONS(8763), 1,
      anon_sym_struct,
    ACTIONS(8765), 1,
      anon_sym_union,
    ACTIONS(8767), 1,
      anon_sym_typename,
    ACTIONS(8769), 1,
      anon_sym_interface,
    ACTIONS(8771), 1,
      anon_sym_extension,
    STATE(324), 1,
      sym_qualified_type_identifier,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5215), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5408), 1,
      sym_type_specifier,
    STATE(8558), 1,
      sym_type_descriptor,
    STATE(8727), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4318), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(125), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8755), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(315), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [67107] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      sym_primitive_type,
    ACTIONS(8830), 1,
      anon_sym_enum,
    ACTIONS(8832), 1,
      anon_sym_class,
    ACTIONS(8834), 1,
      anon_sym_struct,
    ACTIONS(8836), 1,
      anon_sym_union,
    ACTIONS(8838), 1,
      anon_sym_typename,
    ACTIONS(8840), 1,
      anon_sym_interface,
    ACTIONS(8842), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(6223), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6508), 1,
      sym_type_specifier,
    STATE(7274), 1,
      sym__type_definition_type,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4437), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8826), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [67218] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8751), 1,
      sym_identifier,
    ACTIONS(8753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8757), 1,
      sym_primitive_type,
    ACTIONS(8759), 1,
      anon_sym_enum,
    ACTIONS(8761), 1,
      anon_sym_class,
    ACTIONS(8763), 1,
      anon_sym_struct,
    ACTIONS(8765), 1,
      anon_sym_union,
    ACTIONS(8767), 1,
      anon_sym_typename,
    ACTIONS(8769), 1,
      anon_sym_interface,
    ACTIONS(8771), 1,
      anon_sym_extension,
    STATE(324), 1,
      sym_qualified_type_identifier,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5215), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5408), 1,
      sym_type_specifier,
    STATE(7621), 1,
      sym_type_descriptor,
    STATE(8727), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4318), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(125), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8755), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(315), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [67329] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8789), 1,
      anon_sym_STAR,
    ACTIONS(8791), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8793), 1,
      anon_sym_AMP,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(8037), 1,
      sym__declarator,
    STATE(11397), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5048), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [67438] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      sym_primitive_type,
    ACTIONS(8830), 1,
      anon_sym_enum,
    ACTIONS(8832), 1,
      anon_sym_class,
    ACTIONS(8834), 1,
      anon_sym_struct,
    ACTIONS(8836), 1,
      anon_sym_union,
    ACTIONS(8838), 1,
      anon_sym_typename,
    ACTIONS(8840), 1,
      anon_sym_interface,
    ACTIONS(8842), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(6223), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6508), 1,
      sym_type_specifier,
    STATE(7275), 1,
      sym__type_definition_type,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4437), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8826), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [67549] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8262), 1,
      anon_sym_EQ,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8705), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8707), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8709), 1,
      anon_sym_PIPE,
    ACTIONS(8713), 1,
      anon_sym_AMP,
    ACTIONS(8719), 1,
      anon_sym_GT_EQ,
    ACTIONS(8723), 1,
      anon_sym_or,
    ACTIONS(8725), 1,
      anon_sym_and,
    ACTIONS(8727), 1,
      anon_sym_bitor,
    ACTIONS(8729), 1,
      anon_sym_bitand,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8644), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8416), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8715), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8717), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8264), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [67658] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      sym_primitive_type,
    ACTIONS(8830), 1,
      anon_sym_enum,
    ACTIONS(8832), 1,
      anon_sym_class,
    ACTIONS(8834), 1,
      anon_sym_struct,
    ACTIONS(8836), 1,
      anon_sym_union,
    ACTIONS(8838), 1,
      anon_sym_typename,
    ACTIONS(8840), 1,
      anon_sym_interface,
    ACTIONS(8842), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(6223), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6508), 1,
      sym_type_specifier,
    STATE(7276), 1,
      sym__type_definition_type,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4437), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8826), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [67769] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2452), 1,
      anon_sym_STAR,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7421), 1,
      sym__scope_resolution,
    STATE(8468), 1,
      sym__declarator,
    STATE(11547), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3975), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5040), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [67878] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8678), 1,
      sym_identifier,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8686), 1,
      anon_sym_enum,
    ACTIONS(8688), 1,
      anon_sym_class,
    ACTIONS(8690), 1,
      anon_sym_struct,
    ACTIONS(8692), 1,
      anon_sym_union,
    ACTIONS(8694), 1,
      anon_sym_typename,
    ACTIONS(8696), 1,
      anon_sym_interface,
    ACTIONS(8698), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5224), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5876), 1,
      sym_type_specifier,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(8829), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4424), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8682), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [67989] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      sym_primitive_type,
    ACTIONS(8830), 1,
      anon_sym_enum,
    ACTIONS(8832), 1,
      anon_sym_class,
    ACTIONS(8834), 1,
      anon_sym_struct,
    ACTIONS(8836), 1,
      anon_sym_union,
    ACTIONS(8838), 1,
      anon_sym_typename,
    ACTIONS(8840), 1,
      anon_sym_interface,
    ACTIONS(8842), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(6223), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6508), 1,
      sym_type_specifier,
    STATE(7278), 1,
      sym__type_definition_type,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4437), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8826), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [68100] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      sym_primitive_type,
    ACTIONS(8830), 1,
      anon_sym_enum,
    ACTIONS(8832), 1,
      anon_sym_class,
    ACTIONS(8834), 1,
      anon_sym_struct,
    ACTIONS(8836), 1,
      anon_sym_union,
    ACTIONS(8838), 1,
      anon_sym_typename,
    ACTIONS(8840), 1,
      anon_sym_interface,
    ACTIONS(8842), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(6223), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6508), 1,
      sym_type_specifier,
    STATE(7279), 1,
      sym__type_definition_type,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4437), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8826), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [68211] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      sym_primitive_type,
    ACTIONS(8830), 1,
      anon_sym_enum,
    ACTIONS(8832), 1,
      anon_sym_class,
    ACTIONS(8834), 1,
      anon_sym_struct,
    ACTIONS(8836), 1,
      anon_sym_union,
    ACTIONS(8838), 1,
      anon_sym_typename,
    ACTIONS(8840), 1,
      anon_sym_interface,
    ACTIONS(8842), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(6223), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6508), 1,
      sym_type_specifier,
    STATE(7364), 1,
      sym__type_definition_type,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4437), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8826), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [68322] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      sym_primitive_type,
    ACTIONS(8830), 1,
      anon_sym_enum,
    ACTIONS(8832), 1,
      anon_sym_class,
    ACTIONS(8834), 1,
      anon_sym_struct,
    ACTIONS(8836), 1,
      anon_sym_union,
    ACTIONS(8838), 1,
      anon_sym_typename,
    ACTIONS(8840), 1,
      anon_sym_interface,
    ACTIONS(8842), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(6223), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6508), 1,
      sym_type_specifier,
    STATE(7281), 1,
      sym__type_definition_type,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4437), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8826), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [68433] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8751), 1,
      sym_identifier,
    ACTIONS(8753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8757), 1,
      sym_primitive_type,
    ACTIONS(8759), 1,
      anon_sym_enum,
    ACTIONS(8761), 1,
      anon_sym_class,
    ACTIONS(8763), 1,
      anon_sym_struct,
    ACTIONS(8765), 1,
      anon_sym_union,
    ACTIONS(8767), 1,
      anon_sym_typename,
    ACTIONS(8769), 1,
      anon_sym_interface,
    ACTIONS(8771), 1,
      anon_sym_extension,
    STATE(324), 1,
      sym_qualified_type_identifier,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5215), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5408), 1,
      sym_type_specifier,
    STATE(7604), 1,
      sym_type_descriptor,
    STATE(8727), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4318), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(125), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8755), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(315), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [68544] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8709), 1,
      anon_sym_PIPE,
    ACTIONS(8713), 1,
      anon_sym_AMP,
    ACTIONS(8719), 1,
      anon_sym_GT_EQ,
    ACTIONS(8727), 1,
      anon_sym_bitor,
    ACTIONS(8729), 1,
      anon_sym_bitand,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8644), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7771), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(8416), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8715), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8717), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [68645] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(10953), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [68756] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7911), 1,
      anon_sym_EQ,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8346), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8392), 1,
      anon_sym_QMARK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8705), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8707), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8709), 1,
      anon_sym_PIPE,
    ACTIONS(8713), 1,
      anon_sym_AMP,
    ACTIONS(8719), 1,
      anon_sym_GT_EQ,
    ACTIONS(8723), 1,
      anon_sym_or,
    ACTIONS(8725), 1,
      anon_sym_and,
    ACTIONS(8727), 1,
      anon_sym_bitor,
    ACTIONS(8729), 1,
      anon_sym_bitand,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8644), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8416), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8715), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8717), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7913), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [68869] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8737), 1,
      anon_sym_enum,
    ACTIONS(8739), 1,
      anon_sym_class,
    ACTIONS(8741), 1,
      anon_sym_struct,
    ACTIONS(8743), 1,
      anon_sym_union,
    ACTIONS(8745), 1,
      anon_sym_typename,
    ACTIONS(8747), 1,
      anon_sym_interface,
    ACTIONS(8749), 1,
      anon_sym_extension,
    ACTIONS(8858), 1,
      sym_identifier,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5394), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6236), 1,
      sym_type_specifier,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(10971), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4379), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8735), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [68980] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6234), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(10988), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4407), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [69091] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8860), 1,
      sym_identifier,
    STATE(4243), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(8863), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(8866), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(7207), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7205), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [69162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3450), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3452), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [69225] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5299), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(8424), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4397), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [69336] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7846), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7848), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [69413] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      anon_sym_EQ,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8705), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8707), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8709), 1,
      anon_sym_PIPE,
    ACTIONS(8713), 1,
      anon_sym_AMP,
    ACTIONS(8719), 1,
      anon_sym_GT_EQ,
    ACTIONS(8723), 1,
      anon_sym_or,
    ACTIONS(8725), 1,
      anon_sym_and,
    ACTIONS(8727), 1,
      anon_sym_bitor,
    ACTIONS(8729), 1,
      anon_sym_bitand,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8644), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8416), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8715), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8717), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8294), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [69522] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8678), 1,
      sym_identifier,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8686), 1,
      anon_sym_enum,
    ACTIONS(8688), 1,
      anon_sym_class,
    ACTIONS(8690), 1,
      anon_sym_struct,
    ACTIONS(8692), 1,
      anon_sym_union,
    ACTIONS(8694), 1,
      anon_sym_typename,
    ACTIONS(8696), 1,
      anon_sym_interface,
    ACTIONS(8698), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5224), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5327), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8426), 1,
      sym_type_descriptor,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4430), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8682), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [69633] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7826), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7828), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [69708] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8807), 1,
      anon_sym_LT,
    STATE(3686), 1,
      sym_template_argument_list,
    ACTIONS(7783), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7785), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [69775] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5037), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7847), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4392), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [69886] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8751), 1,
      sym_identifier,
    ACTIONS(8753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8757), 1,
      sym_primitive_type,
    ACTIONS(8759), 1,
      anon_sym_enum,
    ACTIONS(8761), 1,
      anon_sym_class,
    ACTIONS(8763), 1,
      anon_sym_struct,
    ACTIONS(8765), 1,
      anon_sym_union,
    ACTIONS(8767), 1,
      anon_sym_typename,
    ACTIONS(8769), 1,
      anon_sym_interface,
    ACTIONS(8771), 1,
      anon_sym_extension,
    STATE(324), 1,
      sym_qualified_type_identifier,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5215), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6154), 1,
      sym_type_specifier,
    STATE(8727), 1,
      sym__scope_resolution,
    STATE(9079), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4443), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(125), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8755), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(315), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [69997] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4998), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(7726), 1,
      sym_type_descriptor,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4417), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [70108] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8250), 1,
      anon_sym_EQ,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8705), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8707), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8709), 1,
      anon_sym_PIPE,
    ACTIONS(8713), 1,
      anon_sym_AMP,
    ACTIONS(8719), 1,
      anon_sym_GT_EQ,
    ACTIONS(8723), 1,
      anon_sym_or,
    ACTIONS(8725), 1,
      anon_sym_and,
    ACTIONS(8727), 1,
      anon_sym_bitor,
    ACTIONS(8729), 1,
      anon_sym_bitand,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8644), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8416), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8715), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8717), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8252), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [70217] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(7486), 1,
      sym_type_descriptor,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [70328] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8789), 1,
      anon_sym_STAR,
    ACTIONS(8791), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8793), 1,
      anon_sym_AMP,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(8143), 1,
      sym__declarator,
    STATE(11397), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5060), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [70437] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(2255), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2245), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70502] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8468), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4279), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5050), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [70611] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3527), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(2209), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2211), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(7386), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7388), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [70680] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(8668), 1,
      anon_sym_STAR,
    ACTIONS(8670), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8672), 1,
      anon_sym_AMP,
    ACTIONS(8674), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7370), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym__declarator,
    STATE(11143), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3898), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5045), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [70789] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(10887), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [70900] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8713), 1,
      anon_sym_AMP,
    ACTIONS(8719), 1,
      anon_sym_GT_EQ,
    ACTIONS(8729), 1,
      anon_sym_bitand,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8644), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8416), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8715), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8717), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7771), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7773), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_DASH_GT_STAR,
  [70997] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(11633), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [71108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3621), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3623), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [71171] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8193), 1,
      anon_sym___attribute__,
    ACTIONS(8196), 1,
      anon_sym___attribute,
    ACTIONS(8554), 1,
      anon_sym_requires,
    ACTIONS(8869), 1,
      anon_sym_DASH_GT,
    ACTIONS(8871), 1,
      anon_sym_where,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(6319), 1,
      sym__function_attributes_start,
    STATE(6513), 1,
      sym_ref_qualifier,
    STATE(7455), 1,
      sym__function_attributes_end,
    STATE(7459), 1,
      sym_where_clause,
    STATE(7705), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8145), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5009), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8268), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6874), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8119), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [71292] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8713), 1,
      anon_sym_AMP,
    ACTIONS(8719), 1,
      anon_sym_GT_EQ,
    ACTIONS(8729), 1,
      anon_sym_bitand,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8644), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8416), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8715), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8717), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7771), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_DASH_GT_STAR,
  [71387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6170), 25,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6172), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [71450] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6191), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(10019), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4412), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [71561] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6234), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11103), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4407), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [71672] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8874), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7798), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7800), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3450), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3452), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [71800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6120), 25,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6122), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [71863] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8193), 1,
      anon_sym___attribute__,
    ACTIONS(8196), 1,
      anon_sym___attribute,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8869), 1,
      anon_sym_DASH_GT,
    ACTIONS(8876), 1,
      anon_sym_where,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(6239), 1,
      sym__function_attributes_start,
    STATE(6499), 1,
      sym_ref_qualifier,
    STATE(7459), 1,
      sym_where_clause,
    STATE(7490), 1,
      sym__function_attributes_end,
    STATE(7651), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5009), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8735), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6883), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8119), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [71984] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8678), 1,
      sym_identifier,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8686), 1,
      anon_sym_enum,
    ACTIONS(8688), 1,
      anon_sym_class,
    ACTIONS(8690), 1,
      anon_sym_struct,
    ACTIONS(8692), 1,
      anon_sym_union,
    ACTIONS(8694), 1,
      anon_sym_typename,
    ACTIONS(8696), 1,
      anon_sym_interface,
    ACTIONS(8698), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5224), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5876), 1,
      sym_type_specifier,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(8970), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4424), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8682), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [72095] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8678), 1,
      sym_identifier,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8686), 1,
      anon_sym_enum,
    ACTIONS(8688), 1,
      anon_sym_class,
    ACTIONS(8690), 1,
      anon_sym_struct,
    ACTIONS(8692), 1,
      anon_sym_union,
    ACTIONS(8694), 1,
      anon_sym_typename,
    ACTIONS(8696), 1,
      anon_sym_interface,
    ACTIONS(8698), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5224), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5876), 1,
      sym_type_specifier,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(8903), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4424), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8682), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [72206] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5260), 1,
      sym_type_specifier,
    STATE(7473), 1,
      sym_type_descriptor,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4421), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [72317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6302), 25,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6304), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [72380] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5299), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(8404), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4397), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [72491] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8366), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5056), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [72600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6124), 25,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6126), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [72663] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8308), 1,
      sym_literal_suffix,
    ACTIONS(2170), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2181), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
  [72728] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      sym_primitive_type,
    ACTIONS(8830), 1,
      anon_sym_enum,
    ACTIONS(8832), 1,
      anon_sym_class,
    ACTIONS(8834), 1,
      anon_sym_struct,
    ACTIONS(8836), 1,
      anon_sym_union,
    ACTIONS(8838), 1,
      anon_sym_typename,
    ACTIONS(8840), 1,
      anon_sym_interface,
    ACTIONS(8842), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(6223), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6508), 1,
      sym_type_specifier,
    STATE(7348), 1,
      sym__type_definition_type,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4437), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8826), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [72839] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(8668), 1,
      anon_sym_STAR,
    ACTIONS(8670), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8672), 1,
      anon_sym_AMP,
    ACTIONS(8674), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7370), 1,
      sym__scope_resolution,
    STATE(8724), 1,
      sym__declarator,
    STATE(11143), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3928), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5058), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [72948] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8288), 1,
      anon_sym_EQ,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8705), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8707), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8709), 1,
      anon_sym_PIPE,
    ACTIONS(8713), 1,
      anon_sym_AMP,
    ACTIONS(8719), 1,
      anon_sym_GT_EQ,
    ACTIONS(8723), 1,
      anon_sym_or,
    ACTIONS(8725), 1,
      anon_sym_and,
    ACTIONS(8727), 1,
      anon_sym_bitor,
    ACTIONS(8729), 1,
      anon_sym_bitand,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8644), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8711), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8416), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8715), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8717), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8290), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [73057] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5334), 1,
      sym_type_specifier,
    STATE(7473), 1,
      sym_type_descriptor,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4451), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [73168] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11073), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [73279] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11252), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [73390] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8719), 1,
      anon_sym_GT_EQ,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8644), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8416), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8715), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8717), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7771), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_DASH_GT_STAR,
  [73481] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8737), 1,
      anon_sym_enum,
    ACTIONS(8739), 1,
      anon_sym_class,
    ACTIONS(8741), 1,
      anon_sym_struct,
    ACTIONS(8743), 1,
      anon_sym_union,
    ACTIONS(8745), 1,
      anon_sym_typename,
    ACTIONS(8747), 1,
      anon_sym_interface,
    ACTIONS(8749), 1,
      anon_sym_extension,
    ACTIONS(8878), 1,
      sym_identifier,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5394), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6236), 1,
      sym_type_specifier,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(11254), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4379), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8735), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [73592] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6234), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11260), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4407), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [73703] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5089), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(7895), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4426), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [73814] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8650), 1,
      sym_identifier,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      anon_sym_enum,
    ACTIONS(8656), 1,
      anon_sym_class,
    ACTIONS(8658), 1,
      anon_sym_struct,
    ACTIONS(8660), 1,
      anon_sym_union,
    ACTIONS(8662), 1,
      anon_sym_typename,
    ACTIONS(8664), 1,
      anon_sym_interface,
    ACTIONS(8666), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5443), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(8512), 1,
      sym_type_descriptor,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4422), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [73925] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11322), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [74036] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6234), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11328), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4407), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [74147] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2452), 1,
      anon_sym_STAR,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7421), 1,
      sym__scope_resolution,
    STATE(8385), 1,
      sym__declarator,
    STATE(11547), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5025), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [74256] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(11363), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [74367] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6234), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(11367), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4407), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [74478] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11200), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [74589] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(11391), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [74700] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6234), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(11395), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4407), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [74811] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5299), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(8317), 1,
      sym_type_descriptor,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(4397), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [74922] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5893), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11271), 1,
      sym_type_descriptor,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(4383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [75033] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8644), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7771), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [75116] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8719), 1,
      anon_sym_GT_EQ,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8430), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8644), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8416), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8717), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7771), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [75205] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8880), 1,
      anon_sym_LT,
    STATE(4433), 1,
      sym_template_argument_list,
    ACTIONS(7737), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7739), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [75274] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8850), 1,
      anon_sym_LT,
    STATE(2999), 1,
      sym_template_argument_list,
    ACTIONS(7783), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7785), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [75341] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8250), 1,
      anon_sym_EQ,
    ACTIONS(8887), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8891), 1,
      anon_sym_PIPE,
    ACTIONS(8895), 1,
      anon_sym_AMP,
    ACTIONS(8901), 1,
      anon_sym_GT_EQ,
    ACTIONS(8907), 1,
      anon_sym_or,
    ACTIONS(8909), 1,
      anon_sym_and,
    ACTIONS(8911), 1,
      anon_sym_bitor,
    ACTIONS(8913), 1,
      anon_sym_bitand,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8893), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8885), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8897), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8899), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8905), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8252), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [75449] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4504), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8919), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4073), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4071), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [75515] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8921), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8927), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8929), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8945), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_or,
    ACTIONS(8951), 1,
      anon_sym_and,
    ACTIONS(8953), 1,
      anon_sym_bitor,
    ACTIONS(8955), 1,
      anon_sym_bitand,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8266), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(8923), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8957), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8925), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8947), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8939), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8270), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [75625] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8927), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8929), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8949), 1,
      anon_sym_or,
    ACTIONS(8951), 1,
      anon_sym_and,
    ACTIONS(8953), 1,
      anon_sym_bitor,
    ACTIONS(8955), 1,
      anon_sym_bitand,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8288), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(8923), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8957), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8925), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8947), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8939), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8290), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [75731] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8280), 1,
      anon_sym_LBRACK,
    STATE(4600), 1,
      sym_new_declarator,
    ACTIONS(7713), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7715), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [75797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7418), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7416), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [75859] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8921), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8927), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8929), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8945), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_or,
    ACTIONS(8951), 1,
      anon_sym_and,
    ACTIONS(8953), 1,
      anon_sym_bitor,
    ACTIONS(8955), 1,
      anon_sym_bitand,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8274), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(8923), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8957), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8925), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8947), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8939), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8276), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [75969] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8571), 1,
      anon_sym_noexcept,
    ACTIONS(8573), 1,
      anon_sym_throw,
    ACTIONS(8963), 1,
      anon_sym_DASH_GT,
    ACTIONS(8965), 1,
      anon_sym_requires,
    ACTIONS(8968), 1,
      anon_sym_where,
    STATE(2738), 1,
      sym_alignas_qualifier,
    STATE(6405), 1,
      sym__function_attributes_start,
    STATE(6552), 1,
      sym_ref_qualifier,
    STATE(7459), 1,
      sym_where_clause,
    STATE(7831), 1,
      sym__function_attributes_end,
    STATE(8118), 1,
      sym_trailing_return_type,
    STATE(9020), 1,
      sym_gnu_asm_expression,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8119), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(8133), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(8568), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5589), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6177), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8596), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    STATE(6907), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6720), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [76083] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2205), 1,
      anon_sym_EQ,
    ACTIONS(2207), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(2181), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2170), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [76149] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6761), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_LPAREN2,
    ACTIONS(7481), 1,
      anon_sym_LBRACK,
    ACTIONS(2181), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2170), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [76217] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6761), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_LPAREN2,
    ACTIONS(7481), 1,
      anon_sym_LBRACK,
    ACTIONS(2181), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2170), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [76285] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8751), 1,
      sym_identifier,
    ACTIONS(8753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8757), 1,
      sym_primitive_type,
    ACTIONS(8759), 1,
      anon_sym_enum,
    ACTIONS(8761), 1,
      anon_sym_class,
    ACTIONS(8763), 1,
      anon_sym_struct,
    ACTIONS(8765), 1,
      anon_sym_union,
    ACTIONS(8767), 1,
      anon_sym_typename,
    ACTIONS(8769), 1,
      anon_sym_interface,
    ACTIONS(8771), 1,
      anon_sym_extension,
    STATE(324), 1,
      sym_qualified_type_identifier,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5215), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5449), 1,
      sym_type_specifier,
    STATE(8727), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(125), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8755), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(315), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [76393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3012), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [76455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2883), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2881), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [76517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8039), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8041), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [76579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2938), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2936), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [76641] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8971), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8974), 1,
      anon_sym_DASH_GT,
    ACTIONS(8976), 1,
      anon_sym_requires,
    ACTIONS(8979), 1,
      anon_sym_where,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6409), 1,
      sym__function_attributes_start,
    STATE(6554), 1,
      sym_ref_qualifier,
    STATE(7618), 1,
      sym_where_clause,
    STATE(7704), 1,
      sym__function_attributes_end,
    STATE(7939), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8208), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5110), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5366), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8544), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8119), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(6910), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [76761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2940), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [76823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2992), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [76885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2998), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2996), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [76947] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8982), 1,
      anon_sym_DOT,
    ACTIONS(8338), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4244), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(4246), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2948), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2946), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [77075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2952), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2950), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [77137] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8571), 1,
      anon_sym_noexcept,
    ACTIONS(8573), 1,
      anon_sym_throw,
    ACTIONS(8963), 1,
      anon_sym_DASH_GT,
    ACTIONS(8984), 1,
      anon_sym_requires,
    ACTIONS(8986), 1,
      anon_sym_where,
    STATE(2738), 1,
      sym_alignas_qualifier,
    STATE(6358), 1,
      sym__function_attributes_start,
    STATE(6558), 1,
      sym_ref_qualifier,
    STATE(7459), 1,
      sym_where_clause,
    STATE(7827), 1,
      sym__function_attributes_end,
    STATE(8058), 1,
      sym_trailing_return_type,
    STATE(9020), 1,
      sym_gnu_asm_expression,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8119), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(8133), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5589), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6177), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9070), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    STATE(6899), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6720), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [77251] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8554), 1,
      anon_sym_requires,
    ACTIONS(8988), 1,
      anon_sym_DASH_GT,
    ACTIONS(8990), 1,
      anon_sym_where,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(6383), 1,
      sym__function_attributes_start,
    STATE(6574), 1,
      sym_ref_qualifier,
    STATE(7459), 1,
      sym_where_clause,
    STATE(7798), 1,
      sym__function_attributes_end,
    STATE(8135), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8145), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5009), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8707), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8119), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(6894), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [77371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3052), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [77433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7995), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7997), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [77495] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(2255), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2245), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [77559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7675), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7677), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7679), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7681), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7691), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7693), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77745] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8993), 1,
      sym_literal_suffix,
    ACTIONS(2170), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
    ACTIONS(2181), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [77809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7822), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7824), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3034), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3032), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [77933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3038), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3036), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [77995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3042), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3040), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [78057] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9001), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(8999), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(8997), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(8995), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [78123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3046), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3044), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [78185] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5226), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [78293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7707), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7709), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [78355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3050), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3048), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [78417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3042), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3040), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [78479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3042), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3040), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [78541] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4427), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(9003), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(4423), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(4421), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [78607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7626), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7628), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [78669] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9005), 1,
      anon_sym_LT,
    STATE(4634), 1,
      sym_template_argument_list,
    ACTIONS(7726), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7728), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [78737] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9008), 1,
      anon_sym_LT,
    STATE(4257), 1,
      sym_template_argument_list,
    ACTIONS(7783), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7785), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [78803] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8434), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8436), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(9011), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9013), 1,
      anon_sym_COMMA,
    ACTIONS(9015), 1,
      anon_sym_RPAREN,
    ACTIONS(9017), 1,
      anon_sym_DASH,
    ACTIONS(9019), 1,
      anon_sym_PLUS,
    ACTIONS(9021), 1,
      anon_sym_STAR,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9025), 1,
      anon_sym_PERCENT,
    ACTIONS(9027), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9029), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9031), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_CARET,
    ACTIONS(9035), 1,
      anon_sym_AMP,
    ACTIONS(9037), 1,
      anon_sym_EQ_EQ,
    ACTIONS(9039), 1,
      anon_sym_BANG_EQ,
    ACTIONS(9041), 1,
      anon_sym_GT,
    ACTIONS(9043), 1,
      anon_sym_GT_EQ,
    ACTIONS(9045), 1,
      anon_sym_LT_EQ,
    ACTIONS(9047), 1,
      anon_sym_LT,
    ACTIONS(9049), 1,
      anon_sym_LT_LT,
    ACTIONS(9051), 1,
      anon_sym_GT_GT,
    ACTIONS(9053), 1,
      anon_sym_EQ,
    ACTIONS(9055), 1,
      anon_sym_QMARK,
    ACTIONS(9057), 1,
      anon_sym_STAR_EQ,
    ACTIONS(9059), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(9061), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(9063), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(9065), 1,
      anon_sym_DASH_EQ,
    ACTIONS(9067), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(9069), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(9071), 1,
      anon_sym_AMP_EQ,
    ACTIONS(9073), 1,
      anon_sym_CARET_EQ,
    ACTIONS(9075), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(9079), 1,
      anon_sym_or,
    ACTIONS(9081), 1,
      anon_sym_and,
    ACTIONS(9083), 1,
      anon_sym_bitor,
    ACTIONS(9085), 1,
      anon_sym_xor,
    ACTIONS(9087), 1,
      anon_sym_bitand,
    ACTIONS(9089), 1,
      anon_sym_not_eq,
    STATE(2291), 1,
      sym__binary_fold_operator,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    STATE(10791), 1,
      sym__fold_operator,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9077), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [78961] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8434), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8436), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(9011), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9013), 1,
      anon_sym_COMMA,
    ACTIONS(9017), 1,
      anon_sym_DASH,
    ACTIONS(9019), 1,
      anon_sym_PLUS,
    ACTIONS(9021), 1,
      anon_sym_STAR,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9025), 1,
      anon_sym_PERCENT,
    ACTIONS(9027), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9029), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9031), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_CARET,
    ACTIONS(9035), 1,
      anon_sym_AMP,
    ACTIONS(9037), 1,
      anon_sym_EQ_EQ,
    ACTIONS(9039), 1,
      anon_sym_BANG_EQ,
    ACTIONS(9041), 1,
      anon_sym_GT,
    ACTIONS(9043), 1,
      anon_sym_GT_EQ,
    ACTIONS(9045), 1,
      anon_sym_LT_EQ,
    ACTIONS(9047), 1,
      anon_sym_LT,
    ACTIONS(9049), 1,
      anon_sym_LT_LT,
    ACTIONS(9051), 1,
      anon_sym_GT_GT,
    ACTIONS(9053), 1,
      anon_sym_EQ,
    ACTIONS(9055), 1,
      anon_sym_QMARK,
    ACTIONS(9057), 1,
      anon_sym_STAR_EQ,
    ACTIONS(9059), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(9061), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(9063), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(9065), 1,
      anon_sym_DASH_EQ,
    ACTIONS(9067), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(9069), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(9071), 1,
      anon_sym_AMP_EQ,
    ACTIONS(9073), 1,
      anon_sym_CARET_EQ,
    ACTIONS(9075), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(9079), 1,
      anon_sym_or,
    ACTIONS(9081), 1,
      anon_sym_and,
    ACTIONS(9083), 1,
      anon_sym_bitor,
    ACTIONS(9085), 1,
      anon_sym_xor,
    ACTIONS(9087), 1,
      anon_sym_bitand,
    ACTIONS(9089), 1,
      anon_sym_not_eq,
    ACTIONS(9093), 1,
      anon_sym_RPAREN,
    STATE(2291), 1,
      sym__binary_fold_operator,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    STATE(10791), 1,
      sym__fold_operator,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9077), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [79119] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6761), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7481), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    ACTIONS(2181), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2170), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2960), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2958), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [79249] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2964), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2962), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [79311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2978), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2976), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [79373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3022), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3020), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [79435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2934), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2932), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [79497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2926), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2924), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [79559] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7420), 1,
      anon_sym_EQ,
    ACTIONS(7422), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(2181), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2170), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [79625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2930), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2928), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [79687] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9095), 1,
      anon_sym_LT,
    STATE(4619), 1,
      sym_template_argument_list,
    ACTIONS(2408), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2410), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [79755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2934), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2932), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [79817] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2205), 1,
      anon_sym_EQ,
    ACTIONS(6761), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_LPAREN2,
    ACTIONS(7481), 1,
      anon_sym_LBRACK,
    ACTIONS(2207), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(2181), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2170), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [79889] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8957), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7846), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7848), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [79965] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9097), 1,
      anon_sym_LT,
    STATE(4619), 1,
      sym_template_argument_list,
    ACTIONS(2229), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2222), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [80033] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9008), 1,
      anon_sym_LT,
    STATE(3073), 1,
      sym_template_argument_list,
    ACTIONS(7783), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7785), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3056), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [80161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2986), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2984), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [80223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2990), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2988), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [80285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3002), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3000), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [80347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3006), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3004), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [80409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3010), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3008), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [80471] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6761), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7481), 1,
      anon_sym_LBRACK,
    ACTIONS(7475), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    ACTIONS(2181), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2170), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80539] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9106), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(9104), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(9102), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(9100), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [80605] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8731), 1,
      sym_identifier,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8737), 1,
      anon_sym_enum,
    ACTIONS(8739), 1,
      anon_sym_class,
    ACTIONS(8741), 1,
      anon_sym_struct,
    ACTIONS(8743), 1,
      anon_sym_union,
    ACTIONS(8745), 1,
      anon_sym_typename,
    ACTIONS(8747), 1,
      anon_sym_interface,
    ACTIONS(8749), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5394), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6179), 1,
      sym_type_specifier,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8735), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [80713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3018), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3016), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [80775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3030), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3028), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [80837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9110), 25,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(9108), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [80899] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5943), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [81007] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9112), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7798), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7800), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81071] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8434), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8436), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(9011), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9013), 1,
      anon_sym_COMMA,
    ACTIONS(9017), 1,
      anon_sym_DASH,
    ACTIONS(9019), 1,
      anon_sym_PLUS,
    ACTIONS(9021), 1,
      anon_sym_STAR,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9025), 1,
      anon_sym_PERCENT,
    ACTIONS(9027), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9029), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9031), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_CARET,
    ACTIONS(9035), 1,
      anon_sym_AMP,
    ACTIONS(9037), 1,
      anon_sym_EQ_EQ,
    ACTIONS(9039), 1,
      anon_sym_BANG_EQ,
    ACTIONS(9041), 1,
      anon_sym_GT,
    ACTIONS(9043), 1,
      anon_sym_GT_EQ,
    ACTIONS(9045), 1,
      anon_sym_LT_EQ,
    ACTIONS(9047), 1,
      anon_sym_LT,
    ACTIONS(9049), 1,
      anon_sym_LT_LT,
    ACTIONS(9051), 1,
      anon_sym_GT_GT,
    ACTIONS(9053), 1,
      anon_sym_EQ,
    ACTIONS(9055), 1,
      anon_sym_QMARK,
    ACTIONS(9057), 1,
      anon_sym_STAR_EQ,
    ACTIONS(9059), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(9061), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(9063), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(9065), 1,
      anon_sym_DASH_EQ,
    ACTIONS(9067), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(9069), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(9071), 1,
      anon_sym_AMP_EQ,
    ACTIONS(9073), 1,
      anon_sym_CARET_EQ,
    ACTIONS(9075), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(9079), 1,
      anon_sym_or,
    ACTIONS(9081), 1,
      anon_sym_and,
    ACTIONS(9083), 1,
      anon_sym_bitor,
    ACTIONS(9085), 1,
      anon_sym_xor,
    ACTIONS(9087), 1,
      anon_sym_bitand,
    ACTIONS(9089), 1,
      anon_sym_not_eq,
    ACTIONS(9114), 1,
      anon_sym_RPAREN,
    STATE(2291), 1,
      sym__binary_fold_operator,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    STATE(10791), 1,
      sym__fold_operator,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9077), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [81229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2883), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2881), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [81291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4716), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4718), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81353] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7404), 1,
      anon_sym___attribute,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9118), 1,
      anon_sym_STAR,
    ACTIONS(9120), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9122), 1,
      anon_sym_AMP,
    ACTIONS(9124), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    STATE(3608), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(5657), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7368), 1,
      sym__abstract_declarator,
    STATE(7556), 1,
      sym__function_declarator_seq,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9126), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9128), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4389), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5099), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(7396), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [81453] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7412), 1,
      anon_sym___attribute,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9118), 1,
      anon_sym_STAR,
    ACTIONS(9120), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9122), 1,
      anon_sym_AMP,
    ACTIONS(9124), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    STATE(3608), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(5657), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7425), 1,
      sym__abstract_declarator,
    STATE(7556), 1,
      sym__function_declarator_seq,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9126), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9128), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5088), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5328), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(7410), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [81553] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8850), 1,
      anon_sym_LT,
    STATE(1514), 1,
      sym_template_argument_list,
    ACTIONS(7783), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7785), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81619] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4419), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(9132), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(4405), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(4403), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [81685] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5080), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [81793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4860), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4862), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81855] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8434), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8436), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(9011), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9013), 1,
      anon_sym_COMMA,
    ACTIONS(9017), 1,
      anon_sym_DASH,
    ACTIONS(9019), 1,
      anon_sym_PLUS,
    ACTIONS(9021), 1,
      anon_sym_STAR,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9025), 1,
      anon_sym_PERCENT,
    ACTIONS(9027), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9029), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9031), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_CARET,
    ACTIONS(9035), 1,
      anon_sym_AMP,
    ACTIONS(9037), 1,
      anon_sym_EQ_EQ,
    ACTIONS(9039), 1,
      anon_sym_BANG_EQ,
    ACTIONS(9041), 1,
      anon_sym_GT,
    ACTIONS(9043), 1,
      anon_sym_GT_EQ,
    ACTIONS(9045), 1,
      anon_sym_LT_EQ,
    ACTIONS(9047), 1,
      anon_sym_LT,
    ACTIONS(9049), 1,
      anon_sym_LT_LT,
    ACTIONS(9051), 1,
      anon_sym_GT_GT,
    ACTIONS(9053), 1,
      anon_sym_EQ,
    ACTIONS(9055), 1,
      anon_sym_QMARK,
    ACTIONS(9057), 1,
      anon_sym_STAR_EQ,
    ACTIONS(9059), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(9061), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(9063), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(9065), 1,
      anon_sym_DASH_EQ,
    ACTIONS(9067), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(9069), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(9071), 1,
      anon_sym_AMP_EQ,
    ACTIONS(9073), 1,
      anon_sym_CARET_EQ,
    ACTIONS(9075), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(9079), 1,
      anon_sym_or,
    ACTIONS(9081), 1,
      anon_sym_and,
    ACTIONS(9083), 1,
      anon_sym_bitor,
    ACTIONS(9085), 1,
      anon_sym_xor,
    ACTIONS(9087), 1,
      anon_sym_bitand,
    ACTIONS(9089), 1,
      anon_sym_not_eq,
    ACTIONS(9134), 1,
      anon_sym_RPAREN,
    STATE(2291), 1,
      sym__binary_fold_operator,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    STATE(10791), 1,
      sym__fold_operator,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9077), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [82013] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9136), 1,
      anon_sym_LT,
    STATE(116), 1,
      sym_template_argument_list,
    ACTIONS(7783), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7785), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [82079] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9145), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(9143), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(9141), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(9139), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [82145] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5310), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [82253] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(7911), 1,
      anon_sym_EQ,
    ACTIONS(8268), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8450), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8452), 1,
      anon_sym_PIPE,
    ACTIONS(8456), 1,
      anon_sym_AMP,
    ACTIONS(8462), 1,
      anon_sym_GT_EQ,
    ACTIONS(8466), 1,
      anon_sym_QMARK,
    ACTIONS(8470), 1,
      anon_sym_or,
    ACTIONS(8472), 1,
      anon_sym_and,
    ACTIONS(8474), 1,
      anon_sym_bitor,
    ACTIONS(8476), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8444), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8454), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8464), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9147), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8446), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8458), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8460), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8468), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7913), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [82367] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8434), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8436), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(9011), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9013), 1,
      anon_sym_COMMA,
    ACTIONS(9017), 1,
      anon_sym_DASH,
    ACTIONS(9019), 1,
      anon_sym_PLUS,
    ACTIONS(9021), 1,
      anon_sym_STAR,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9025), 1,
      anon_sym_PERCENT,
    ACTIONS(9027), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9029), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9031), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_CARET,
    ACTIONS(9035), 1,
      anon_sym_AMP,
    ACTIONS(9037), 1,
      anon_sym_EQ_EQ,
    ACTIONS(9039), 1,
      anon_sym_BANG_EQ,
    ACTIONS(9041), 1,
      anon_sym_GT,
    ACTIONS(9043), 1,
      anon_sym_GT_EQ,
    ACTIONS(9045), 1,
      anon_sym_LT_EQ,
    ACTIONS(9047), 1,
      anon_sym_LT,
    ACTIONS(9049), 1,
      anon_sym_LT_LT,
    ACTIONS(9051), 1,
      anon_sym_GT_GT,
    ACTIONS(9053), 1,
      anon_sym_EQ,
    ACTIONS(9055), 1,
      anon_sym_QMARK,
    ACTIONS(9057), 1,
      anon_sym_STAR_EQ,
    ACTIONS(9059), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(9061), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(9063), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(9065), 1,
      anon_sym_DASH_EQ,
    ACTIONS(9067), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(9069), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(9071), 1,
      anon_sym_AMP_EQ,
    ACTIONS(9073), 1,
      anon_sym_CARET_EQ,
    ACTIONS(9075), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(9079), 1,
      anon_sym_or,
    ACTIONS(9081), 1,
      anon_sym_and,
    ACTIONS(9083), 1,
      anon_sym_bitor,
    ACTIONS(9085), 1,
      anon_sym_xor,
    ACTIONS(9087), 1,
      anon_sym_bitand,
    ACTIONS(9089), 1,
      anon_sym_not_eq,
    ACTIONS(9149), 1,
      anon_sym_RPAREN,
    STATE(2291), 1,
      sym__binary_fold_operator,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    STATE(10791), 1,
      sym__fold_operator,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9077), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [82525] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9157), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(9155), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(9153), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(9151), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [82591] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8650), 1,
      sym_identifier,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      anon_sym_enum,
    ACTIONS(8656), 1,
      anon_sym_class,
    ACTIONS(8658), 1,
      anon_sym_struct,
    ACTIONS(8660), 1,
      anon_sym_union,
    ACTIONS(8662), 1,
      anon_sym_typename,
    ACTIONS(8664), 1,
      anon_sym_interface,
    ACTIONS(8666), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5103), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [82699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8332), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
    ACTIONS(8330), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
  [82761] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8434), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8436), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(9011), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9013), 1,
      anon_sym_COMMA,
    ACTIONS(9017), 1,
      anon_sym_DASH,
    ACTIONS(9019), 1,
      anon_sym_PLUS,
    ACTIONS(9021), 1,
      anon_sym_STAR,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9025), 1,
      anon_sym_PERCENT,
    ACTIONS(9027), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9029), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9031), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_CARET,
    ACTIONS(9035), 1,
      anon_sym_AMP,
    ACTIONS(9037), 1,
      anon_sym_EQ_EQ,
    ACTIONS(9039), 1,
      anon_sym_BANG_EQ,
    ACTIONS(9041), 1,
      anon_sym_GT,
    ACTIONS(9043), 1,
      anon_sym_GT_EQ,
    ACTIONS(9045), 1,
      anon_sym_LT_EQ,
    ACTIONS(9047), 1,
      anon_sym_LT,
    ACTIONS(9049), 1,
      anon_sym_LT_LT,
    ACTIONS(9051), 1,
      anon_sym_GT_GT,
    ACTIONS(9053), 1,
      anon_sym_EQ,
    ACTIONS(9055), 1,
      anon_sym_QMARK,
    ACTIONS(9057), 1,
      anon_sym_STAR_EQ,
    ACTIONS(9059), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(9061), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(9063), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(9065), 1,
      anon_sym_DASH_EQ,
    ACTIONS(9067), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(9069), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(9071), 1,
      anon_sym_AMP_EQ,
    ACTIONS(9073), 1,
      anon_sym_CARET_EQ,
    ACTIONS(9075), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(9079), 1,
      anon_sym_or,
    ACTIONS(9081), 1,
      anon_sym_and,
    ACTIONS(9083), 1,
      anon_sym_bitor,
    ACTIONS(9085), 1,
      anon_sym_xor,
    ACTIONS(9087), 1,
      anon_sym_bitand,
    ACTIONS(9089), 1,
      anon_sym_not_eq,
    ACTIONS(9159), 1,
      anon_sym_RPAREN,
    STATE(2291), 1,
      sym__binary_fold_operator,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    STATE(10791), 1,
      sym__fold_operator,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9077), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [82919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2224), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [82981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2224), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [83043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2224), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [83105] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6210), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [83213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2224), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [83275] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8434), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8436), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(9011), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9013), 1,
      anon_sym_COMMA,
    ACTIONS(9017), 1,
      anon_sym_DASH,
    ACTIONS(9019), 1,
      anon_sym_PLUS,
    ACTIONS(9021), 1,
      anon_sym_STAR,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9025), 1,
      anon_sym_PERCENT,
    ACTIONS(9027), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9029), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9031), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_CARET,
    ACTIONS(9035), 1,
      anon_sym_AMP,
    ACTIONS(9037), 1,
      anon_sym_EQ_EQ,
    ACTIONS(9039), 1,
      anon_sym_BANG_EQ,
    ACTIONS(9041), 1,
      anon_sym_GT,
    ACTIONS(9043), 1,
      anon_sym_GT_EQ,
    ACTIONS(9045), 1,
      anon_sym_LT_EQ,
    ACTIONS(9047), 1,
      anon_sym_LT,
    ACTIONS(9049), 1,
      anon_sym_LT_LT,
    ACTIONS(9051), 1,
      anon_sym_GT_GT,
    ACTIONS(9053), 1,
      anon_sym_EQ,
    ACTIONS(9055), 1,
      anon_sym_QMARK,
    ACTIONS(9057), 1,
      anon_sym_STAR_EQ,
    ACTIONS(9059), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(9061), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(9063), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(9065), 1,
      anon_sym_DASH_EQ,
    ACTIONS(9067), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(9069), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(9071), 1,
      anon_sym_AMP_EQ,
    ACTIONS(9073), 1,
      anon_sym_CARET_EQ,
    ACTIONS(9075), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(9079), 1,
      anon_sym_or,
    ACTIONS(9081), 1,
      anon_sym_and,
    ACTIONS(9083), 1,
      anon_sym_bitor,
    ACTIONS(9085), 1,
      anon_sym_xor,
    ACTIONS(9087), 1,
      anon_sym_bitand,
    ACTIONS(9089), 1,
      anon_sym_not_eq,
    ACTIONS(9161), 1,
      anon_sym_RPAREN,
    STATE(2291), 1,
      sym__binary_fold_operator,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    STATE(10791), 1,
      sym__fold_operator,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9077), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [83433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2224), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [83495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2224), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [83557] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6192), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [83665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7832), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7834), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [83727] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8434), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8436), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(9011), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9013), 1,
      anon_sym_COMMA,
    ACTIONS(9017), 1,
      anon_sym_DASH,
    ACTIONS(9019), 1,
      anon_sym_PLUS,
    ACTIONS(9021), 1,
      anon_sym_STAR,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9025), 1,
      anon_sym_PERCENT,
    ACTIONS(9027), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9029), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9031), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_CARET,
    ACTIONS(9035), 1,
      anon_sym_AMP,
    ACTIONS(9037), 1,
      anon_sym_EQ_EQ,
    ACTIONS(9039), 1,
      anon_sym_BANG_EQ,
    ACTIONS(9041), 1,
      anon_sym_GT,
    ACTIONS(9043), 1,
      anon_sym_GT_EQ,
    ACTIONS(9045), 1,
      anon_sym_LT_EQ,
    ACTIONS(9047), 1,
      anon_sym_LT,
    ACTIONS(9049), 1,
      anon_sym_LT_LT,
    ACTIONS(9051), 1,
      anon_sym_GT_GT,
    ACTIONS(9053), 1,
      anon_sym_EQ,
    ACTIONS(9055), 1,
      anon_sym_QMARK,
    ACTIONS(9057), 1,
      anon_sym_STAR_EQ,
    ACTIONS(9059), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(9061), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(9063), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(9065), 1,
      anon_sym_DASH_EQ,
    ACTIONS(9067), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(9069), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(9071), 1,
      anon_sym_AMP_EQ,
    ACTIONS(9073), 1,
      anon_sym_CARET_EQ,
    ACTIONS(9075), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(9079), 1,
      anon_sym_or,
    ACTIONS(9081), 1,
      anon_sym_and,
    ACTIONS(9083), 1,
      anon_sym_bitor,
    ACTIONS(9085), 1,
      anon_sym_xor,
    ACTIONS(9087), 1,
      anon_sym_bitand,
    ACTIONS(9089), 1,
      anon_sym_not_eq,
    ACTIONS(9163), 1,
      anon_sym_RPAREN,
    STATE(2291), 1,
      sym__binary_fold_operator,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    STATE(10791), 1,
      sym__fold_operator,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9077), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [83885] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5264), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [83993] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8434), 1,
      anon_sym_DOT_STAR,
    ACTIONS(8436), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(9011), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9013), 1,
      anon_sym_COMMA,
    ACTIONS(9017), 1,
      anon_sym_DASH,
    ACTIONS(9019), 1,
      anon_sym_PLUS,
    ACTIONS(9021), 1,
      anon_sym_STAR,
    ACTIONS(9023), 1,
      anon_sym_SLASH,
    ACTIONS(9025), 1,
      anon_sym_PERCENT,
    ACTIONS(9027), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9029), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9031), 1,
      anon_sym_PIPE,
    ACTIONS(9033), 1,
      anon_sym_CARET,
    ACTIONS(9035), 1,
      anon_sym_AMP,
    ACTIONS(9037), 1,
      anon_sym_EQ_EQ,
    ACTIONS(9039), 1,
      anon_sym_BANG_EQ,
    ACTIONS(9041), 1,
      anon_sym_GT,
    ACTIONS(9043), 1,
      anon_sym_GT_EQ,
    ACTIONS(9045), 1,
      anon_sym_LT_EQ,
    ACTIONS(9047), 1,
      anon_sym_LT,
    ACTIONS(9049), 1,
      anon_sym_LT_LT,
    ACTIONS(9051), 1,
      anon_sym_GT_GT,
    ACTIONS(9053), 1,
      anon_sym_EQ,
    ACTIONS(9055), 1,
      anon_sym_QMARK,
    ACTIONS(9057), 1,
      anon_sym_STAR_EQ,
    ACTIONS(9059), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(9061), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(9063), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(9065), 1,
      anon_sym_DASH_EQ,
    ACTIONS(9067), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(9069), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(9071), 1,
      anon_sym_AMP_EQ,
    ACTIONS(9073), 1,
      anon_sym_CARET_EQ,
    ACTIONS(9075), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(9079), 1,
      anon_sym_or,
    ACTIONS(9081), 1,
      anon_sym_and,
    ACTIONS(9083), 1,
      anon_sym_bitor,
    ACTIONS(9085), 1,
      anon_sym_xor,
    ACTIONS(9087), 1,
      anon_sym_bitand,
    ACTIONS(9089), 1,
      anon_sym_not_eq,
    ACTIONS(9165), 1,
      anon_sym_RPAREN,
    STATE(2291), 1,
      sym__binary_fold_operator,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    STATE(10791), 1,
      sym__fold_operator,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9077), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [84151] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5008), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84259] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5213), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84367] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9167), 1,
      anon_sym_LT,
    STATE(4634), 1,
      sym_template_argument_list,
    ACTIONS(7737), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7739), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [84435] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5387), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84543] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5298), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84651] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8650), 1,
      sym_identifier,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      anon_sym_enum,
    ACTIONS(8656), 1,
      anon_sym_class,
    ACTIONS(8658), 1,
      anon_sym_struct,
    ACTIONS(8660), 1,
      anon_sym_union,
    ACTIONS(8662), 1,
      anon_sym_typename,
    ACTIONS(8664), 1,
      anon_sym_interface,
    ACTIONS(8666), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5448), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84759] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4504), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8919), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4064), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4062), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [84825] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8678), 1,
      sym_identifier,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8686), 1,
      anon_sym_enum,
    ACTIONS(8688), 1,
      anon_sym_class,
    ACTIONS(8690), 1,
      anon_sym_struct,
    ACTIONS(8692), 1,
      anon_sym_union,
    ACTIONS(8694), 1,
      anon_sym_typename,
    ACTIONS(8696), 1,
      anon_sym_interface,
    ACTIONS(8698), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5224), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6000), 1,
      sym_type_specifier,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8682), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84933] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4838), 1,
      sym_type_specifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85041] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5096), 1,
      sym_type_specifier,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85149] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5659), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85257] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5524), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85365] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5737), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85473] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8678), 1,
      sym_identifier,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8686), 1,
      anon_sym_enum,
    ACTIONS(8688), 1,
      anon_sym_class,
    ACTIONS(8690), 1,
      anon_sym_struct,
    ACTIONS(8692), 1,
      anon_sym_union,
    ACTIONS(8694), 1,
      anon_sym_typename,
    ACTIONS(8696), 1,
      anon_sym_interface,
    ACTIONS(8698), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5224), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5319), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8682), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4248), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4250), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_DASH_GT_STAR,
  [85643] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6132), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85751] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7733), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7735), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [85815] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8268), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8450), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8452), 1,
      anon_sym_PIPE,
    ACTIONS(8456), 1,
      anon_sym_AMP,
    ACTIONS(8462), 1,
      anon_sym_GT_EQ,
    ACTIONS(8466), 1,
      anon_sym_QMARK,
    ACTIONS(8470), 1,
      anon_sym_or,
    ACTIONS(8472), 1,
      anon_sym_and,
    ACTIONS(8474), 1,
      anon_sym_bitor,
    ACTIONS(8476), 1,
      anon_sym_bitand,
    ACTIONS(8493), 1,
      anon_sym_RPAREN,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9172), 1,
      anon_sym_EQ,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8444), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8454), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8464), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8446), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8458), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8460), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8468), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8414), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [85931] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7836), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7838), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [86005] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8927), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8929), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8949), 1,
      anon_sym_or,
    ACTIONS(8951), 1,
      anon_sym_and,
    ACTIONS(8953), 1,
      anon_sym_bitor,
    ACTIONS(8955), 1,
      anon_sym_bitand,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8250), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(8923), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8957), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8925), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8947), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8939), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8252), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [86111] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      sym_primitive_type,
    ACTIONS(8830), 1,
      anon_sym_enum,
    ACTIONS(8832), 1,
      anon_sym_class,
    ACTIONS(8834), 1,
      anon_sym_struct,
    ACTIONS(8836), 1,
      anon_sym_union,
    ACTIONS(8838), 1,
      anon_sym_typename,
    ACTIONS(8840), 1,
      anon_sym_interface,
    ACTIONS(8842), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(6223), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6478), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8826), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [86219] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8957), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7804), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7806), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [86295] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8957), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7852), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7854), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [86371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7798), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7800), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86433] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8927), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8929), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8949), 1,
      anon_sym_or,
    ACTIONS(8951), 1,
      anon_sym_and,
    ACTIONS(8953), 1,
      anon_sym_bitor,
    ACTIONS(8955), 1,
      anon_sym_bitand,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8262), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(8923), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8957), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8925), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8947), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8939), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8264), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [86539] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7826), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7828), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [86613] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8751), 1,
      sym_identifier,
    ACTIONS(8753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8757), 1,
      sym_primitive_type,
    ACTIONS(8759), 1,
      anon_sym_enum,
    ACTIONS(8761), 1,
      anon_sym_class,
    ACTIONS(8763), 1,
      anon_sym_struct,
    ACTIONS(8765), 1,
      anon_sym_union,
    ACTIONS(8767), 1,
      anon_sym_typename,
    ACTIONS(8769), 1,
      anon_sym_interface,
    ACTIONS(8771), 1,
      anon_sym_extension,
    STATE(324), 1,
      sym_qualified_type_identifier,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5215), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6083), 1,
      sym_type_specifier,
    STATE(8727), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(125), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8755), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(315), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [86721] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(9174), 1,
      anon_sym_DASH_GT,
    ACTIONS(9176), 1,
      anon_sym_where,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6404), 1,
      sym__function_attributes_start,
    STATE(6570), 1,
      sym_ref_qualifier,
    STATE(7459), 1,
      sym_where_clause,
    STATE(7856), 1,
      sym__function_attributes_end,
    STATE(8106), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5110), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5366), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9182), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8119), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(6900), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [86841] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8844), 1,
      anon_sym_requires,
    ACTIONS(9174), 1,
      anon_sym_DASH_GT,
    ACTIONS(9178), 1,
      anon_sym_where,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6375), 1,
      sym__function_attributes_start,
    STATE(6567), 1,
      sym_ref_qualifier,
    STATE(7459), 1,
      sym_where_clause,
    STATE(7860), 1,
      sym__function_attributes_end,
    STATE(8112), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8145), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5110), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5366), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8713), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8119), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(6911), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [86961] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(8554), 1,
      anon_sym_requires,
    ACTIONS(9181), 1,
      anon_sym_where,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6365), 1,
      sym__function_attributes_start,
    STATE(6538), 1,
      sym_ref_qualifier,
    STATE(7459), 1,
      sym_where_clause,
    STATE(7869), 1,
      sym__function_attributes_end,
    STATE(8023), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5110), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5366), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8996), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8119), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
    STATE(6892), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [87081] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5782), 1,
      sym_type_specifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [87189] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5480), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [87297] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5097), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [87405] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5776), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [87513] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5318), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [87621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7746), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7748), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [87683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7418), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7416), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [87745] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8927), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8929), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8949), 1,
      anon_sym_or,
    ACTIONS(8951), 1,
      anon_sym_and,
    ACTIONS(8953), 1,
      anon_sym_bitor,
    ACTIONS(8955), 1,
      anon_sym_bitand,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8284), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(8923), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8957), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8925), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8947), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8939), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8286), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [87851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7662), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7664), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [87913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7641), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7643), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [87975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7699), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7701), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [88037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7622), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7624), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [88099] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8921), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8927), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8929), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8945), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_or,
    ACTIONS(8951), 1,
      anon_sym_and,
    ACTIONS(8953), 1,
      anon_sym_bitor,
    ACTIONS(8955), 1,
      anon_sym_bitand,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(7911), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(8923), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8957), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8925), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8947), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8939), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7913), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [88209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7995), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7997), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [88271] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9095), 1,
      anon_sym_LT,
    STATE(4508), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4619), 1,
      sym_template_argument_list,
    ACTIONS(8500), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2168), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2176), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [88343] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8957), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8925), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7771), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [88421] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8957), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7771), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [88497] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8971), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8974), 1,
      anon_sym_DASH_GT,
    ACTIONS(9183), 1,
      anon_sym_requires,
    ACTIONS(9185), 1,
      anon_sym_where,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6391), 1,
      sym__function_attributes_start,
    STATE(6571), 1,
      sym_ref_qualifier,
    STATE(7618), 1,
      sym_where_clause,
    STATE(7690), 1,
      sym__function_attributes_end,
    STATE(7946), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5110), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5366), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8926), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8119), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(6897), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [88617] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8929), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8951), 1,
      anon_sym_and,
    ACTIONS(8953), 1,
      anon_sym_bitor,
    ACTIONS(8955), 1,
      anon_sym_bitand,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8923), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8957), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7771), 3,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
    ACTIONS(8925), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8947), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8939), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [88719] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8953), 1,
      anon_sym_bitor,
    ACTIONS(8955), 1,
      anon_sym_bitand,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8923), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8957), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8925), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8947), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 4,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(8939), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [88817] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8955), 1,
      anon_sym_bitand,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8923), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8957), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8925), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8947), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8939), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7771), 5,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7773), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_GT2,
  [88911] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8955), 1,
      anon_sym_bitand,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8923), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8957), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8925), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8947), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8939), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7771), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_GT2,
  [89003] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8923), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8957), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8925), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8947), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8939), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7771), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_GT2,
  [89091] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8923), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8957), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8925), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8947), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8939), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7771), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [89177] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8923), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8957), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8925), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8947), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [89261] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8923), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8957), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8925), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7771), 14,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [89341] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8923), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8957), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8925), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7771), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [89423] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8982), 1,
      anon_sym_DOT,
    ACTIONS(8338), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4252), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(4254), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [89489] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8957), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7794), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7796), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [89565] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7836), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7838), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [89639] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7804), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7806), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [89715] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7852), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7854), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [89791] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8262), 1,
      anon_sym_EQ,
    ACTIONS(8887), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8891), 1,
      anon_sym_PIPE,
    ACTIONS(8895), 1,
      anon_sym_AMP,
    ACTIONS(8901), 1,
      anon_sym_GT_EQ,
    ACTIONS(8907), 1,
      anon_sym_or,
    ACTIONS(8909), 1,
      anon_sym_and,
    ACTIONS(8911), 1,
      anon_sym_bitor,
    ACTIONS(8913), 1,
      anon_sym_bitand,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8893), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8885), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8897), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8899), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8905), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8264), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [89899] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7826), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7828), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [89973] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8284), 1,
      anon_sym_EQ,
    ACTIONS(8887), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8891), 1,
      anon_sym_PIPE,
    ACTIONS(8895), 1,
      anon_sym_AMP,
    ACTIONS(8901), 1,
      anon_sym_GT_EQ,
    ACTIONS(8907), 1,
      anon_sym_or,
    ACTIONS(8909), 1,
      anon_sym_and,
    ACTIONS(8911), 1,
      anon_sym_bitor,
    ACTIONS(8913), 1,
      anon_sym_bitand,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8893), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8885), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8897), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8899), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8905), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8286), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [90081] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7911), 1,
      anon_sym_EQ,
    ACTIONS(8268), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8887), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8891), 1,
      anon_sym_PIPE,
    ACTIONS(8895), 1,
      anon_sym_AMP,
    ACTIONS(8901), 1,
      anon_sym_GT_EQ,
    ACTIONS(8907), 1,
      anon_sym_or,
    ACTIONS(8909), 1,
      anon_sym_and,
    ACTIONS(8911), 1,
      anon_sym_bitor,
    ACTIONS(8913), 1,
      anon_sym_bitand,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9187), 1,
      anon_sym_QMARK,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8893), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8885), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8897), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8899), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8905), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7913), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [90193] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8885), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7771), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [90271] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7771), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [90347] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8891), 1,
      anon_sym_PIPE,
    ACTIONS(8895), 1,
      anon_sym_AMP,
    ACTIONS(8901), 1,
      anon_sym_GT_EQ,
    ACTIONS(8909), 1,
      anon_sym_and,
    ACTIONS(8911), 1,
      anon_sym_bitor,
    ACTIONS(8913), 1,
      anon_sym_bitand,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7771), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8893), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8885), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8897), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8899), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8905), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7773), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [90451] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8891), 1,
      anon_sym_PIPE,
    ACTIONS(8895), 1,
      anon_sym_AMP,
    ACTIONS(8901), 1,
      anon_sym_GT_EQ,
    ACTIONS(8911), 1,
      anon_sym_bitor,
    ACTIONS(8913), 1,
      anon_sym_bitand,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8893), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7771), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(8885), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8897), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8899), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8905), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7773), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [90551] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8895), 1,
      anon_sym_AMP,
    ACTIONS(8901), 1,
      anon_sym_GT_EQ,
    ACTIONS(8913), 1,
      anon_sym_bitand,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8893), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8885), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8897), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8899), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8905), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7773), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [90647] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8895), 1,
      anon_sym_AMP,
    ACTIONS(8901), 1,
      anon_sym_GT_EQ,
    ACTIONS(8913), 1,
      anon_sym_bitand,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8885), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8897), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8899), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8905), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [90741] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8901), 1,
      anon_sym_GT_EQ,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8885), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8897), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8899), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8905), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
  [90831] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8901), 1,
      anon_sym_GT_EQ,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8885), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8899), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8905), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [90919] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8885), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8905), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [91003] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8885), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7771), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [91083] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8885), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7771), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7773), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [91165] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7794), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7796), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [91241] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8292), 1,
      anon_sym_EQ,
    ACTIONS(8887), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8891), 1,
      anon_sym_PIPE,
    ACTIONS(8895), 1,
      anon_sym_AMP,
    ACTIONS(8901), 1,
      anon_sym_GT_EQ,
    ACTIONS(8907), 1,
      anon_sym_or,
    ACTIONS(8909), 1,
      anon_sym_and,
    ACTIONS(8911), 1,
      anon_sym_bitor,
    ACTIONS(8913), 1,
      anon_sym_bitand,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8893), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8885), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8897), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8899), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8905), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8294), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [91349] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8266), 1,
      anon_sym_EQ,
    ACTIONS(8268), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8887), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8891), 1,
      anon_sym_PIPE,
    ACTIONS(8895), 1,
      anon_sym_AMP,
    ACTIONS(8901), 1,
      anon_sym_GT_EQ,
    ACTIONS(8907), 1,
      anon_sym_or,
    ACTIONS(8909), 1,
      anon_sym_and,
    ACTIONS(8911), 1,
      anon_sym_bitor,
    ACTIONS(8913), 1,
      anon_sym_bitand,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9187), 1,
      anon_sym_QMARK,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8893), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8885), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8897), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8899), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8905), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8270), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [91461] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8288), 1,
      anon_sym_EQ,
    ACTIONS(8887), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8891), 1,
      anon_sym_PIPE,
    ACTIONS(8895), 1,
      anon_sym_AMP,
    ACTIONS(8901), 1,
      anon_sym_GT_EQ,
    ACTIONS(8907), 1,
      anon_sym_or,
    ACTIONS(8909), 1,
      anon_sym_and,
    ACTIONS(8911), 1,
      anon_sym_bitor,
    ACTIONS(8913), 1,
      anon_sym_bitand,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8893), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8885), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8897), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8899), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8905), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8290), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [91569] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8268), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8274), 1,
      anon_sym_EQ,
    ACTIONS(8887), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8891), 1,
      anon_sym_PIPE,
    ACTIONS(8895), 1,
      anon_sym_AMP,
    ACTIONS(8901), 1,
      anon_sym_GT_EQ,
    ACTIONS(8907), 1,
      anon_sym_or,
    ACTIONS(8909), 1,
      anon_sym_and,
    ACTIONS(8911), 1,
      anon_sym_bitor,
    ACTIONS(8913), 1,
      anon_sym_bitand,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9187), 1,
      anon_sym_QMARK,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8893), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8903), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8885), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8897), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8899), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8905), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8276), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [91681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7798), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7800), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [91743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7610), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7612), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7814), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7816), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7618), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7620), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91929] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8133), 1,
      anon_sym_LBRACK,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8988), 1,
      anon_sym_DASH_GT,
    ACTIONS(9189), 1,
      anon_sym_where,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(6367), 1,
      sym__function_attributes_start,
    STATE(6551), 1,
      sym_ref_qualifier,
    STATE(7459), 1,
      sym_where_clause,
    STATE(7791), 1,
      sym__function_attributes_end,
    STATE(8077), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5009), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9040), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8119), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(6914), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [92049] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4504), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9191), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2915), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2913), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [92115] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7777), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7846), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7848), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [92191] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8927), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8929), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8931), 1,
      anon_sym_PIPE,
    ACTIONS(8935), 1,
      anon_sym_AMP,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8949), 1,
      anon_sym_or,
    ACTIONS(8951), 1,
      anon_sym_and,
    ACTIONS(8953), 1,
      anon_sym_bitor,
    ACTIONS(8955), 1,
      anon_sym_bitand,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8292), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(8923), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8933), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8941), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8957), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8925), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8937), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8947), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8939), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8294), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [92297] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4504), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8919), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4078), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4080), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [92363] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4504), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8919), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4093), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4095), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [92429] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4511), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9194), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4111), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4113), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [92495] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4512), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9196), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4053), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4051), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [92561] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4504), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8919), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3995), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3997), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [92627] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4504), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8919), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4102), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4100), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [92693] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4423), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9198), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4164), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4166), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [92759] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4308), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9200), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4178), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4180), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [92825] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4504), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8919), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4185), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4187), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [92891] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4507), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9202), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2974), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2972), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [92957] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8731), 1,
      sym_identifier,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8737), 1,
      anon_sym_enum,
    ACTIONS(8739), 1,
      anon_sym_class,
    ACTIONS(8741), 1,
      anon_sym_struct,
    ACTIONS(8743), 1,
      anon_sym_union,
    ACTIONS(8745), 1,
      anon_sym_typename,
    ACTIONS(8747), 1,
      anon_sym_interface,
    ACTIONS(8749), 1,
      anon_sym_extension,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5394), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5514), 1,
      sym_type_specifier,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8735), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [93065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7679), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7681), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [93126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2170), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7150), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7152), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [93248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4716), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4718), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [93309] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2426), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2428), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [93372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7975), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7977), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7983), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7985), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7947), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7949), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7877), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7879), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2224), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7979), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7981), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2224), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7641), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7643), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [93860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9204), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7798), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7800), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [93923] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9206), 1,
      sym_identifier,
    STATE(4567), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(6802), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6804), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(7217), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(7219), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
  [93992] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5321), 1,
      anon_sym_LBRACE,
    ACTIONS(8334), 1,
      anon_sym_LPAREN2,
    STATE(4941), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7671), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7673), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7699), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7701), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7622), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7624), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94181] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2420), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2422), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [94244] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2420), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2422), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [94307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4860), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4862), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8053), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8055), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7873), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7875), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7288), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7290), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [94551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7750), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7752), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94612] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9208), 1,
      sym_literal_suffix,
    ACTIONS(2170), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(2181), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
  [94675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7160), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [94736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7662), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7664), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7610), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7612), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7618), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7620), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7707), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7709), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7763), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7765), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7955), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7957), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7923), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7925), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8043), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8045), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95224] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9210), 1,
      anon_sym_LT,
    STATE(4334), 1,
      sym_template_argument_list,
    ACTIONS(7783), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7785), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [95289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7881), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7883), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7885), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7887), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7893), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7895), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2270), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2268), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [95533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7763), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7765), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2274), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2272), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [95655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2278), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2276), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [95716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7763), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7765), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7790), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7792), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7903), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7905), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7897), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7899), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95960] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9213), 1,
      anon_sym_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    STATE(4806), 1,
      sym__enum_base_clause,
    STATE(4906), 1,
      sym_enumerator_list,
    STATE(5014), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(3478), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3480), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [96033] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9213), 1,
      anon_sym_COLON,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    STATE(4807), 1,
      sym__enum_base_clause,
    STATE(4909), 1,
      sym_enumerator_list,
    STATE(5024), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(3502), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3504), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [96106] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9217), 1,
      sym_identifier,
    STATE(4567), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(9220), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(9223), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(7205), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(7207), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
  [96175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2241), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2239), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [96236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2282), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2280), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [96297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6324), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2286), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2284), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [96419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7907), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7909), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6324), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6324), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7818), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7820), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6160), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6162), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6164), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6166), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7842), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7844), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7592), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(2181), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2170), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96909] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5321), 1,
      anon_sym_LBRACE,
    ACTIONS(8334), 1,
      anon_sym_LPAREN2,
    STATE(4855), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7683), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7685), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2288), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [97037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2294), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2292), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [97098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2296), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [97159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2266), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2264), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [97220] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9226), 1,
      anon_sym_LT,
    STATE(146), 1,
      sym_template_argument_list,
    ACTIONS(7783), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7785), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [97285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2414), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2412), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7626), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7628), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [97407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7798), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7800), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4250), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(4248), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [97529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2302), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2300), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [97590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2260), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [97651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2304), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [97712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6298), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6300), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7931), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7933), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7313), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [97895] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5321), 1,
      anon_sym_LBRACE,
    ACTIONS(8334), 1,
      anon_sym_LPAREN2,
    STATE(4861), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7695), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7697), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2310), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2308), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [98023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2314), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2312), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [98084] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5321), 1,
      anon_sym_LBRACE,
    ACTIONS(8334), 1,
      anon_sym_LPAREN2,
    STATE(4891), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7658), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7660), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7822), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7824), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [98212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8332), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(8330), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
  [98273] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9210), 1,
      anon_sym_LT,
    STATE(3077), 1,
      sym_template_argument_list,
    ACTIONS(7783), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7785), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [98338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5487), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5483), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8001), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8003), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6106), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4215), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2404), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2402), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98582] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9229), 1,
      sym_identifier,
    STATE(4532), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(6802), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6804), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(7190), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(7192), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
  [98651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7991), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7993), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7943), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7945), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7856), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7858), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7814), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7816), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [98895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6130), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6136), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6138), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [99017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7746), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7748), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [99078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7418), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7416), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [99139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7967), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7969), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [99200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7951), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7953), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [99261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2418), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [99322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2243), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [99383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7971), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7973), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [99444] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4064), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(7424), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(7426), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(7386), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7388), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [99511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6112), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6114), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [99572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6156), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6158), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [99633] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9231), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9233), 1,
      anon_sym_and,
    ACTIONS(6806), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6808), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [99698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8031), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8033), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [99759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6144), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6146), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [99820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7832), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7834), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [99881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8023), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8025), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [99942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7947), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7949), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [100003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7987), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7989), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [100064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8009), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8011), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [100125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6170), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6172), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [100186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7675), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7677), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [100247] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7733), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7735), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [100310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8057), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8059), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [100371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2224), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [100432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7911), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7913), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [100493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7935), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7937), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [100554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7691), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7693), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [100615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8019), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8021), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [100676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7866), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7868), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [100737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8005), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8007), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [100798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2170), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [100859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7939), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7941), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [100920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6302), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6304), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [100981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7860), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7862), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [101042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8061), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8063), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [101103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6120), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6122), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [101164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6124), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6126), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [101225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2224), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [101286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2224), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [101347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2224), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [101408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7995), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7997), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [101469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8049), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8051), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [101530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8039), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8041), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [101591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7919), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7921), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [101652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7915), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7917), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [101713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7927), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7929), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [101774] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9231), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9233), 1,
      anon_sym_and,
    ACTIONS(9235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9237), 1,
      anon_sym_or,
    ACTIONS(6781), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6783), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [101843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7763), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7765), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [101903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(7160), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [101963] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8284), 1,
      anon_sym_EQ,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(9247), 1,
      anon_sym_PIPE,
    ACTIONS(9249), 1,
      anon_sym_CARET,
    ACTIONS(9251), 1,
      anon_sym_AMP,
    ACTIONS(9257), 1,
      anon_sym_GT_EQ,
    ACTIONS(9261), 1,
      anon_sym_bitor,
    ACTIONS(9263), 1,
      anon_sym_xor,
    ACTIONS(9265), 1,
      anon_sym_bitand,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9239), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9243), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9245), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9241), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9253), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9255), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8286), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [102067] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8773), 1,
      anon_sym_LT,
    STATE(2953), 1,
      sym_template_argument_list,
    ACTIONS(2410), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(2408), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [102133] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7794), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(7796), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [102207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8005), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(8007), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7955), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7957), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8043), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(8045), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6160), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6162), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7881), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7883), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7951), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7953), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7939), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7941), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7856), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7858), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8009), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(8011), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102747] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6800), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(6798), 12,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(2181), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2170), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102811] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7787), 1,
      anon_sym_LT,
    STATE(3108), 1,
      sym_template_argument_list,
    ACTIONS(7783), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7785), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [102875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8057), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(8059), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8049), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(8051), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [102995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7915), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7917), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103055] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8292), 1,
      anon_sym_EQ,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(9247), 1,
      anon_sym_PIPE,
    ACTIONS(9249), 1,
      anon_sym_CARET,
    ACTIONS(9251), 1,
      anon_sym_AMP,
    ACTIONS(9257), 1,
      anon_sym_GT_EQ,
    ACTIONS(9261), 1,
      anon_sym_bitor,
    ACTIONS(9263), 1,
      anon_sym_xor,
    ACTIONS(9265), 1,
      anon_sym_bitand,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9239), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9243), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9245), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9241), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9253), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9255), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8294), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [103159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7947), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7949), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6164), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6166), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7919), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7921), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7885), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7887), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7893), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7895), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7995), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7997), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7975), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7977), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7860), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7862), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8061), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(8063), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7927), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7929), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7931), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7933), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103819] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8266), 1,
      anon_sym_EQ,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(9011), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9055), 1,
      anon_sym_QMARK,
    ACTIONS(9247), 1,
      anon_sym_PIPE,
    ACTIONS(9249), 1,
      anon_sym_CARET,
    ACTIONS(9251), 1,
      anon_sym_AMP,
    ACTIONS(9257), 1,
      anon_sym_GT_EQ,
    ACTIONS(9261), 1,
      anon_sym_bitor,
    ACTIONS(9263), 1,
      anon_sym_xor,
    ACTIONS(9265), 1,
      anon_sym_bitand,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9239), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9243), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9245), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9241), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9253), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9255), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8270), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [103927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7983), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7985), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [103987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7897), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7899), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [104047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3352), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(3362), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [104107] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(2255), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2245), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [104169] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9267), 1,
      anon_sym_LT,
    STATE(2953), 1,
      sym_template_argument_list,
    ACTIONS(2222), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(2229), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [104235] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8288), 1,
      anon_sym_EQ,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(9247), 1,
      anon_sym_PIPE,
    ACTIONS(9249), 1,
      anon_sym_CARET,
    ACTIONS(9251), 1,
      anon_sym_AMP,
    ACTIONS(9257), 1,
      anon_sym_GT_EQ,
    ACTIONS(9261), 1,
      anon_sym_bitor,
    ACTIONS(9263), 1,
      anon_sym_xor,
    ACTIONS(9265), 1,
      anon_sym_bitand,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9239), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9243), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9245), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9241), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9253), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9255), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8290), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [104339] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9270), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9272), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9274), 1,
      anon_sym_or,
    ACTIONS(9276), 1,
      anon_sym_and,
    ACTIONS(6781), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6783), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [104407] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4507), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9202), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2883), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2881), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [104471] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9278), 1,
      anon_sym_LBRACK,
    STATE(4817), 1,
      sym_new_declarator,
    ACTIONS(7713), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7715), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [104535] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9280), 1,
      anon_sym_STAR,
    ACTIONS(9282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9284), 1,
      anon_sym_AMP,
    ACTIONS(9288), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    STATE(3540), 1,
      sym_parameter_list,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7627), 1,
      sym__abstract_declarator,
    ACTIONS(9290), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9292), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4702), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5214), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(7396), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [104631] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9280), 1,
      anon_sym_STAR,
    ACTIONS(9282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9284), 1,
      anon_sym_AMP,
    ACTIONS(9288), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    STATE(3540), 1,
      sym_parameter_list,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7614), 1,
      sym__abstract_declarator,
    ACTIONS(9290), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9292), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5235), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(7410), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [104727] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7530), 1,
      anon_sym_EQ,
    ACTIONS(7653), 1,
      anon_sym_COMMA,
    ACTIONS(7655), 1,
      anon_sym_RBRACK,
    ACTIONS(7532), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(2181), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2170), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [104795] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2205), 1,
      anon_sym_EQ,
    ACTIONS(2218), 1,
      anon_sym_SEMI,
    ACTIONS(6761), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_LPAREN2,
    ACTIONS(7481), 1,
      anon_sym_LBRACK,
    ACTIONS(2207), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(2170), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2181), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
  [104867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7947), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7949), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [104927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7987), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7989), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [104987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(4242), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [105047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7750), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7752), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7842), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7844), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6112), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6114), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6144), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6146), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8031), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(8033), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105347] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8336), 1,
      anon_sym_LBRACK,
    STATE(4814), 1,
      sym_new_declarator,
    ACTIONS(7713), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7715), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [105411] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8274), 1,
      anon_sym_EQ,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(9011), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9055), 1,
      anon_sym_QMARK,
    ACTIONS(9247), 1,
      anon_sym_PIPE,
    ACTIONS(9249), 1,
      anon_sym_CARET,
    ACTIONS(9251), 1,
      anon_sym_AMP,
    ACTIONS(9257), 1,
      anon_sym_GT_EQ,
    ACTIONS(9261), 1,
      anon_sym_bitor,
    ACTIONS(9263), 1,
      anon_sym_xor,
    ACTIONS(9265), 1,
      anon_sym_bitand,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9239), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9243), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9245), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9241), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9253), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9255), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8276), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [105519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7798), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7800), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105579] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7911), 1,
      anon_sym_EQ,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(9011), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9055), 1,
      anon_sym_QMARK,
    ACTIONS(9247), 1,
      anon_sym_PIPE,
    ACTIONS(9249), 1,
      anon_sym_CARET,
    ACTIONS(9251), 1,
      anon_sym_AMP,
    ACTIONS(9257), 1,
      anon_sym_GT_EQ,
    ACTIONS(9261), 1,
      anon_sym_bitor,
    ACTIONS(9263), 1,
      anon_sym_xor,
    ACTIONS(9265), 1,
      anon_sym_bitand,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9239), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9243), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9245), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9241), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9253), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9255), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7913), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [105687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7923), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7925), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7991), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7993), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105807] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9300), 1,
      anon_sym_COMMA,
    ACTIONS(9302), 1,
      anon_sym_RBRACK,
    ACTIONS(2181), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2170), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [105871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8001), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(8003), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [105931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2420), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2422), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
  [105991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2170), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [106051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7288), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(7290), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [106111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(7313), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [106171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2170), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [106231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7979), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7981), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [106291] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(2255), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2245), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [106353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7877), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7879), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [106413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6298), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6300), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [106473] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7530), 1,
      anon_sym_EQ,
    ACTIONS(7532), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(2181), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2170), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [106537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5487), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5483), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [106597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8023), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(8025), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [106657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6302), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6304), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [106717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2224), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [106777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2224), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [106837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2224), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [106897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2224), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [106957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2224), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [107017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2224), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [107077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2268), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2270), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6324), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [107197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6324), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [107257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6324), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [107317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2272), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2274), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2276), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2278), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2239), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2241), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2280), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2282), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107557] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7666), 1,
      anon_sym_COMMA,
    ACTIONS(7668), 1,
      anon_sym_RBRACK,
    ACTIONS(2181), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2170), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2284), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2286), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6106), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4215), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [107741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2288), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2290), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2292), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2294), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107861] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7836), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(7838), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [107933] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8250), 1,
      anon_sym_EQ,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(9247), 1,
      anon_sym_PIPE,
    ACTIONS(9249), 1,
      anon_sym_CARET,
    ACTIONS(9251), 1,
      anon_sym_AMP,
    ACTIONS(9257), 1,
      anon_sym_GT_EQ,
    ACTIONS(9261), 1,
      anon_sym_bitor,
    ACTIONS(9263), 1,
      anon_sym_xor,
    ACTIONS(9265), 1,
      anon_sym_bitand,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9239), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9243), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9245), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9241), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9253), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9255), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8252), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [108037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7911), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7913), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [108097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7935), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7937), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [108157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6120), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6122), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [108217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6124), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6126), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [108277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2414), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2412), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [108337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2296), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2298), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2264), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2266), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2300), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2302), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108517] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9241), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7771), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(7773), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [108593] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7771), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(7773), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [108667] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7771), 1,
      anon_sym_EQ,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(9247), 1,
      anon_sym_PIPE,
    ACTIONS(9249), 1,
      anon_sym_CARET,
    ACTIONS(9251), 1,
      anon_sym_AMP,
    ACTIONS(9257), 1,
      anon_sym_GT_EQ,
    ACTIONS(9261), 1,
      anon_sym_bitor,
    ACTIONS(9263), 1,
      anon_sym_xor,
    ACTIONS(9265), 1,
      anon_sym_bitand,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9239), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9245), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9241), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9253), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9255), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_DASH_GT_STAR,
  [108769] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7771), 1,
      anon_sym_EQ,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(9247), 1,
      anon_sym_PIPE,
    ACTIONS(9249), 1,
      anon_sym_CARET,
    ACTIONS(9251), 1,
      anon_sym_AMP,
    ACTIONS(9257), 1,
      anon_sym_GT_EQ,
    ACTIONS(9261), 1,
      anon_sym_bitor,
    ACTIONS(9263), 1,
      anon_sym_xor,
    ACTIONS(9265), 1,
      anon_sym_bitand,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9239), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9241), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9253), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9255), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH_GT_STAR,
  [108869] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(9249), 1,
      anon_sym_CARET,
    ACTIONS(9251), 1,
      anon_sym_AMP,
    ACTIONS(9257), 1,
      anon_sym_GT_EQ,
    ACTIONS(9263), 1,
      anon_sym_xor,
    ACTIONS(9265), 1,
      anon_sym_bitand,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(7771), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9239), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9241), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9253), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9255), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_DASH_GT_STAR,
  [108965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2404), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2402), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [109025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6130), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [109085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6136), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6138), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [109145] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(9251), 1,
      anon_sym_AMP,
    ACTIONS(9257), 1,
      anon_sym_GT_EQ,
    ACTIONS(9265), 1,
      anon_sym_bitand,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9239), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7771), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
    ACTIONS(9077), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9241), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9253), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9255), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_DASH_GT_STAR,
  [109237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8039), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(8041), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [109297] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(9257), 1,
      anon_sym_GT_EQ,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9239), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9241), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9253), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9255), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7771), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(7773), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_DASH_GT_STAR,
  [109385] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(9257), 1,
      anon_sym_GT_EQ,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9239), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9241), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9255), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7771), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(7773), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [109471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7866), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7868), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [109531] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7804), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(7806), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [109605] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7852), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(7854), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [109679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7873), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7875), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [109739] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9239), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9241), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7771), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(7773), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [109821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8053), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(8055), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [109881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7903), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7905), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [109941] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9239), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9241), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7771), 9,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(7773), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [110019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2260), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2262), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110079] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9239), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9241), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7771), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(7773), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_GT_STAR,
  [110159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2304), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2306), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2308), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2310), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110279] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8262), 1,
      anon_sym_EQ,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    ACTIONS(9247), 1,
      anon_sym_PIPE,
    ACTIONS(9249), 1,
      anon_sym_CARET,
    ACTIONS(9251), 1,
      anon_sym_AMP,
    ACTIONS(9257), 1,
      anon_sym_GT_EQ,
    ACTIONS(9261), 1,
      anon_sym_bitor,
    ACTIONS(9263), 1,
      anon_sym_xor,
    ACTIONS(9265), 1,
      anon_sym_bitand,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(9091), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9239), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9243), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9245), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9259), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9077), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9241), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9253), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9255), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8264), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [110383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2312), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2314), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110443] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8388), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_DOT_STAR,
    STATE(4629), 1,
      sym_argument_list,
    STATE(4630), 1,
      sym_subscript_argument_list,
    ACTIONS(8432), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7826), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(7828), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [110515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7763), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7765), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [110575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7150), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(7152), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [110635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7763), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7765), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [110695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7790), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7792), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [110755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7907), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7909), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [110815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7943), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7945), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [110875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7818), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7820), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [110935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7967), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7969), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [110995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7971), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7973), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [111055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6156), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6158), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [111115] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7687), 1,
      anon_sym_EQ,
    ACTIONS(7689), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(2181), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2170), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [111179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7418), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7416), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [111239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6170), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6172), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [111299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8019), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(8021), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [111359] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9272), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9276), 1,
      anon_sym_and,
    ACTIONS(6806), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6808), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [111423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7939), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7941), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [111482] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    STATE(4910), 1,
      sym_enumerator_list,
    STATE(5027), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(3989), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3987), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [111549] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    STATE(4913), 1,
      sym_enumerator_list,
    STATE(5036), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(3993), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3991), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [111616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7313), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [111675] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7804), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(7806), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [111748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7903), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7905), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [111807] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7794), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(7796), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [111880] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7836), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(7838), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [111951] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(9307), 1,
      anon_sym___attribute__,
    ACTIONS(9309), 1,
      anon_sym___attribute,
    ACTIONS(9311), 1,
      anon_sym_LBRACE,
    STATE(5160), 1,
      sym_field_declaration_list,
    STATE(5398), 1,
      sym_attribute_specifier,
    STATE(9446), 1,
      sym_virtual_specifier,
    STATE(10681), 1,
      sym_base_class_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2893), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2895), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [112028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7822), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7824), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [112087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7288), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7290), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [112146] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4607), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(6802), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6804), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(7388), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(7386), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
  [112211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7822), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7824), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7150), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7152), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [112329] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 1,
      anon_sym___attribute__,
    ACTIONS(7348), 1,
      anon_sym___attribute,
    ACTIONS(7414), 1,
      anon_sym_LBRACE,
    ACTIONS(9313), 1,
      anon_sym_COLON,
    STATE(3048), 1,
      sym_attribute_specifier,
    STATE(3139), 1,
      sym__enum_base_clause,
    STATE(3188), 1,
      sym_enumerator_list,
    ACTIONS(3478), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(3480), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [112402] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 1,
      anon_sym___attribute__,
    ACTIONS(7348), 1,
      anon_sym___attribute,
    ACTIONS(7414), 1,
      anon_sym_LBRACE,
    ACTIONS(9313), 1,
      anon_sym_COLON,
    STATE(3046), 1,
      sym_attribute_specifier,
    STATE(3132), 1,
      sym__enum_base_clause,
    STATE(3226), 1,
      sym_enumerator_list,
    ACTIONS(3502), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(3504), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [112475] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    STATE(2953), 1,
      sym_template_argument_list,
    STATE(4963), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9315), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3777), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(3775), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [112542] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2205), 1,
      anon_sym_EQ,
    ACTIONS(2218), 1,
      anon_sym_SEMI,
    ACTIONS(2207), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(2181), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2170), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112607] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9124), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9317), 1,
      anon_sym_STAR,
    ACTIONS(9319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9321), 1,
      anon_sym_AMP,
    STATE(3623), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(5657), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7713), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9126), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9128), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4827), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5315), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7396), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [112702] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7852), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(7854), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [112775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8043), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(8045), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112834] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7826), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(7828), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [112905] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9124), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9317), 1,
      anon_sym_STAR,
    ACTIONS(9319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9321), 1,
      anon_sym_AMP,
    STATE(3623), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(5657), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7731), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9126), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9128), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5328), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5336), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [113000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(8332), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6106), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4215), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8993), 1,
      sym_literal_suffix,
    ACTIONS(2181), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2170), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113179] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7771), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(7773), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [113252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7160), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [113311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6124), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6126), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8057), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8059), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113427] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9118), 1,
      anon_sym_STAR,
    ACTIONS(9120), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9122), 1,
      anon_sym_AMP,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9325), 1,
      anon_sym___attribute,
    ACTIONS(9327), 1,
      anon_sym_DOT,
    STATE(3608), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7390), 1,
      sym__abstract_declarator,
    STATE(7556), 1,
      sym__function_declarator_seq,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5095), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9329), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9323), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [113517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7939), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7941), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7881), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7883), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113633] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9118), 1,
      anon_sym_STAR,
    ACTIONS(9120), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9122), 1,
      anon_sym_AMP,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9327), 1,
      anon_sym_DOT,
    ACTIONS(9333), 1,
      anon_sym___attribute,
    STATE(3608), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7418), 1,
      sym__abstract_declarator,
    STATE(7556), 1,
      sym__function_declarator_seq,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5101), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9329), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9331), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [113723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8053), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8055), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8019), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(8021), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8005), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(8007), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7903), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7905), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8031), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8033), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8049), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8051), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7915), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7917), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114129] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7404), 1,
      anon_sym___attribute,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9124), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9335), 1,
      anon_sym_STAR,
    ACTIONS(9337), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9339), 1,
      anon_sym_AMP,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(5657), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7748), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9126), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9128), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4847), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5399), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7396), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [114225] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7412), 1,
      anon_sym___attribute,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9124), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9335), 1,
      anon_sym_STAR,
    ACTIONS(9337), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9339), 1,
      anon_sym_AMP,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(5657), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7752), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9126), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9128), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5328), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5355), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [114321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7955), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7957), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [114379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8001), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(8003), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [114437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6324), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7885), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7887), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [114553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7893), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7895), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [114611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7979), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7981), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [114669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6106), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4215), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7979), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7981), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7877), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7879), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [114843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6170), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6172), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6324), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7919), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7921), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [115017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7911), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7913), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [115075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7955), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7957), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [115133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6324), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [115191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8043), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8045), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [115249] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7927), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7929), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [115307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7931), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7933), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [115365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7881), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7883), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [115423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7885), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7887), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [115481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7893), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7895), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [115539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7967), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7969), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [115597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7971), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7973), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [115655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7860), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7862), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [115713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8061), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8063), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [115771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7919), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7921), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [115829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7927), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7929), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [115887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7931), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7933), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [115945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7975), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7977), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [116003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7983), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7985), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [116061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7975), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7977), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7983), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7985), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7935), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7937), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [116235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7943), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7945), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [116293] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9341), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9343), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6781), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6783), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [116355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8001), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8003), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [116413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6120), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6122), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [116471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7856), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7858), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [116529] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7404), 1,
      anon_sym___attribute,
    ACTIONS(9288), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9345), 1,
      anon_sym_STAR,
    ACTIONS(9347), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9349), 1,
      anon_sym_AMP,
    STATE(3755), 1,
      sym_parameter_list,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7762), 1,
      sym__abstract_declarator,
    ACTIONS(9290), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9292), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4887), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5436), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7396), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [116625] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7412), 1,
      anon_sym___attribute,
    ACTIONS(9288), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9345), 1,
      anon_sym_STAR,
    ACTIONS(9347), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9349), 1,
      anon_sym_AMP,
    STATE(3755), 1,
      sym_parameter_list,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7764), 1,
      sym__abstract_declarator,
    ACTIONS(9290), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9292), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5365), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [116721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2170), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [116779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7866), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7868), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8023), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(8025), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7967), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7969), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [116953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7951), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7953), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [117011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8005), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8007), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [117069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7971), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7973), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [117127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6156), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6158), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [117185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7856), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7858), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7860), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7862), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2414), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2412), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [117359] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(9358), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(9355), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9353), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(9351), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [117425] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5054), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4004), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4002), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7911), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7913), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117545] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5016), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4091), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4089), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7866), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7868), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [117665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2404), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2402), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [117723] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5023), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4200), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4198), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117785] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5026), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4107), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4109), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117847] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5029), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4010), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4008), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117909] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5031), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4014), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4012), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117971] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5035), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4156), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4154), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118033] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5038), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4060), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4058), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118095] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5039), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4045), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4043), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118157] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5041), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4049), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4047), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118219] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5043), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4087), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4085), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118281] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5044), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4176), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4174), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7288), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(7290), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [118401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7877), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7879), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [118459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(7313), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [118517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7935), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7937), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118575] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(9278), 1,
      anon_sym_LBRACK,
    ACTIONS(9361), 1,
      anon_sym_LPAREN2,
    STATE(4991), 1,
      sym_new_declarator,
    STATE(4918), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(9363), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7372), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7374), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8031), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(8033), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8061), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(8063), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2170), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8049), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(8051), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7873), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7875), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [118935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7873), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7875), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118993] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(9278), 1,
      anon_sym_LBRACK,
    ACTIONS(9361), 1,
      anon_sym_LPAREN2,
    STATE(5012), 1,
      sym_new_declarator,
    STATE(4925), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(9363), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7354), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7356), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7915), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7917), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6160), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6162), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [119179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6164), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6166), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [119237] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(9278), 1,
      anon_sym_LBRACK,
    ACTIONS(9361), 1,
      anon_sym_LPAREN2,
    STATE(5007), 1,
      sym_new_declarator,
    STATE(4870), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(9363), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7376), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7378), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119307] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9124), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9365), 1,
      anon_sym_STAR,
    ACTIONS(9367), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9369), 1,
      anon_sym_AMP,
    STATE(3676), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(5657), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7840), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9126), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9128), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4934), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5374), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7396), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [119401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6130), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [119459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6136), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6138), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [119517] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9124), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9365), 1,
      anon_sym_STAR,
    ACTIONS(9367), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9369), 1,
      anon_sym_AMP,
    STATE(3676), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(5657), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7844), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9126), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9128), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5328), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5378), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [119611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6298), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6300), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [119669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7150), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(7152), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [119727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(7160), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [119785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5487), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5483), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5487), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5483), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [119901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8023), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8025), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [119959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8019), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(8021), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [120017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6302), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6304), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [120075] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(9278), 1,
      anon_sym_LBRACK,
    ACTIONS(9361), 1,
      anon_sym_LPAREN2,
    STATE(5003), 1,
      sym_new_declarator,
    STATE(4841), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(9363), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7368), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7370), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120145] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6112), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6114), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [120203] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9343), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6806), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6808), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [120263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6144), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6146), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [120321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7943), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7945), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120379] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(9278), 1,
      anon_sym_LBRACK,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(5117), 1,
      sym_new_declarator,
    STATE(4870), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7376), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(7378), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3026), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3024), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120505] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3327), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9375), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3995), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(3997), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [120566] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3327), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9375), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4102), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(4100), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [120627] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4959), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9377), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4164), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(4166), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [120688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2956), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2954), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120745] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4960), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9379), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4178), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(4180), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [120806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2974), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2972), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120863] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3327), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9375), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4185), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(4187), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [120924] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4979), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9381), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2974), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(2972), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [120985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2982), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2980), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121042] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3327), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9375), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4064), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(4062), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [121103] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3327), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9375), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4073), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(4071), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [121164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7150), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7152), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [121221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7313), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [121278] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3327), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9375), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4093), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(4095), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [121339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2550), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2548), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121396] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(5344), 1,
      anon_sym_LPAREN2,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7408), 1,
      anon_sym_LBRACK,
    ACTIONS(7507), 1,
      anon_sym_STAR,
    ACTIONS(9383), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9389), 1,
      anon_sym_AMP,
    ACTIONS(9391), 1,
      anon_sym_COLON,
    ACTIONS(9393), 1,
      anon_sym_EQ,
    STATE(4120), 1,
      sym_parameter_list,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7689), 1,
      sym__declarator,
    STATE(8249), 1,
      sym__abstract_declarator,
    STATE(8844), 1,
      sym_abstract_reference_declarator,
    STATE(9863), 1,
      sym_variadic_declarator,
    STATE(9873), 1,
      sym_variadic_reference_declarator,
    STATE(9879), 1,
      sym_semantics,
    STATE(10947), 1,
      sym_ms_based_modifier,
    ACTIONS(8129), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(9385), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(8751), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7454), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [121511] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(9278), 1,
      anon_sym_LBRACK,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(5122), 1,
      sym_new_declarator,
    STATE(4918), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7372), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(7374), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121580] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9395), 1,
      anon_sym_LT,
    STATE(4990), 1,
      sym_template_argument_list,
    ACTIONS(2222), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(2229), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [121643] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9398), 1,
      anon_sym_LT,
    STATE(4963), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4990), 1,
      sym_template_argument_list,
    ACTIONS(9315), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2168), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2176), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [121710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7288), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7290), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [121767] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9400), 1,
      sym_identifier,
    ACTIONS(9410), 1,
      sym_primitive_type,
    STATE(5105), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5147), 1,
      sym_alignas_qualifier,
    ACTIONS(9407), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9405), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3423), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3428), 12,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9402), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [121840] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4950), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9412), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4111), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(4113), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [121901] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(5344), 1,
      anon_sym_LPAREN2,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7408), 1,
      anon_sym_LBRACK,
    ACTIONS(7562), 1,
      anon_sym_STAR,
    ACTIONS(9383), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9389), 1,
      anon_sym_AMP,
    ACTIONS(9391), 1,
      anon_sym_COLON,
    ACTIONS(9414), 1,
      anon_sym_EQ,
    STATE(4273), 1,
      sym_parameter_list,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7692), 1,
      sym__declarator,
    STATE(8297), 1,
      sym__abstract_declarator,
    STATE(8868), 1,
      sym_abstract_reference_declarator,
    STATE(9863), 1,
      sym_variadic_declarator,
    STATE(9873), 1,
      sym_variadic_reference_declarator,
    STATE(9879), 1,
      sym_semantics,
    STATE(10947), 1,
      sym_ms_based_modifier,
    ACTIONS(8129), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(9385), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8751), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7454), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [122016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2552), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [122073] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4951), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9416), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4053), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(4051), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [122134] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9418), 1,
      sym_identifier,
    ACTIONS(9428), 1,
      sym_primitive_type,
    STATE(5147), 1,
      sym_alignas_qualifier,
    STATE(5286), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9425), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5010), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9423), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3540), 12,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(3542), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(9420), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122207] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(9433), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(9430), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9353), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(9351), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [122272] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(9278), 1,
      anon_sym_LBRACK,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(5167), 1,
      sym_new_declarator,
    STATE(4925), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7354), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(7356), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [122341] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9436), 1,
      sym_identifier,
    ACTIONS(9446), 1,
      sym_primitive_type,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(5108), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9443), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4982), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9441), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3423), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_GT2,
    ACTIONS(3428), 12,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9438), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122414] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3327), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9375), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4078), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(4080), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [122475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7160), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [122532] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9398), 1,
      anon_sym_LT,
    STATE(4990), 1,
      sym_template_argument_list,
    ACTIONS(2410), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(2408), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [122595] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9448), 1,
      sym_identifier,
    ACTIONS(9458), 1,
      sym_primitive_type,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(5270), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9455), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9453), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3540), 12,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(3542), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_GT2,
    ACTIONS(9450), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122668] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(9278), 1,
      anon_sym_LBRACK,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(5145), 1,
      sym_new_declarator,
    STATE(4841), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7368), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(7370), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [122737] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9460), 1,
      anon_sym_LT,
    STATE(2953), 1,
      sym_template_argument_list,
    ACTIONS(2229), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2222), 35,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [122799] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2422), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(2420), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [122857] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9462), 1,
      anon_sym_DOT,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4244), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
    ACTIONS(4246), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [122917] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9462), 1,
      anon_sym_DOT,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4252), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
    ACTIONS(4254), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [122977] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9288), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9464), 1,
      anon_sym_STAR,
    ACTIONS(9466), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9468), 1,
      anon_sym_AMP,
    STATE(3551), 1,
      sym_parameter_list,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8089), 1,
      sym__abstract_declarator,
    ACTIONS(9290), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9292), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5728), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [123069] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7404), 1,
      anon_sym___attribute,
    ACTIONS(9288), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9470), 1,
      anon_sym_STAR,
    ACTIONS(9472), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9474), 1,
      anon_sym_AMP,
    STATE(4172), 1,
      sym_parameter_list,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8034), 1,
      sym__abstract_declarator,
    ACTIONS(9290), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9292), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4992), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5697), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7396), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [123163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(2250), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [123219] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(9361), 1,
      anon_sym_LPAREN2,
    STATE(4869), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7658), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7660), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [123281] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7412), 1,
      anon_sym___attribute,
    ACTIONS(9288), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9470), 1,
      anon_sym_STAR,
    ACTIONS(9472), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9474), 1,
      anon_sym_AMP,
    STATE(4172), 1,
      sym_parameter_list,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8042), 1,
      sym__abstract_declarator,
    ACTIONS(9290), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9292), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5704), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [123375] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2883), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2881), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [123433] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9307), 1,
      anon_sym___attribute__,
    ACTIONS(9309), 1,
      anon_sym___attribute,
    ACTIONS(9476), 1,
      anon_sym_COLON,
    ACTIONS(9478), 1,
      anon_sym_LBRACE,
    STATE(5082), 1,
      sym__enum_base_clause,
    STATE(5159), 1,
      sym_enumerator_list,
    STATE(5391), 1,
      sym_attribute_specifier,
    ACTIONS(3478), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3480), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [123503] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9288), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9464), 1,
      anon_sym_STAR,
    ACTIONS(9466), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9468), 1,
      anon_sym_AMP,
    STATE(3551), 1,
      sym_parameter_list,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8062), 1,
      sym__abstract_declarator,
    ACTIONS(9290), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9292), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4988), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5756), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7396), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [123595] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9307), 1,
      anon_sym___attribute__,
    ACTIONS(9309), 1,
      anon_sym___attribute,
    ACTIONS(9476), 1,
      anon_sym_COLON,
    ACTIONS(9478), 1,
      anon_sym_LBRACE,
    STATE(5086), 1,
      sym__enum_base_clause,
    STATE(5165), 1,
      sym_enumerator_list,
    STATE(5415), 1,
      sym_attribute_specifier,
    ACTIONS(3502), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3504), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [123665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2879), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2877), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [123721] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9280), 1,
      anon_sym_STAR,
    ACTIONS(9282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9284), 1,
      anon_sym_AMP,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9480), 1,
      anon_sym_DOT,
    STATE(3540), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7602), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5278), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9323), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [123807] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2428), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(2426), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [123865] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(7404), 1,
      anon_sym___attribute,
    ACTIONS(9288), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9484), 1,
      anon_sym_STAR,
    ACTIONS(9486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9488), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4265), 1,
      sym_parameter_list,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8049), 1,
      sym__abstract_declarator,
    ACTIONS(9290), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9292), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5004), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5693), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7396), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [123959] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5364), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9494), 1,
      anon_sym_STAR,
    ACTIONS(9496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9498), 1,
      anon_sym_AMP,
    STATE(3800), 1,
      sym_parameter_list,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8166), 1,
      sym__abstract_declarator,
    ACTIONS(9502), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9504), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5005), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5681), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7396), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124051] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9460), 1,
      anon_sym_LT,
    STATE(2953), 1,
      sym_template_argument_list,
    ACTIONS(2408), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2410), 35,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [124113] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(9361), 1,
      anon_sym_LPAREN2,
    STATE(4848), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7695), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7697), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [124175] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(7412), 1,
      anon_sym___attribute,
    ACTIONS(9288), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9484), 1,
      anon_sym_STAR,
    ACTIONS(9486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9488), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4265), 1,
      sym_parameter_list,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8051), 1,
      sym__abstract_declarator,
    ACTIONS(9290), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9292), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5695), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124269] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5364), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9494), 1,
      anon_sym_STAR,
    ACTIONS(9496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9498), 1,
      anon_sym_AMP,
    STATE(3800), 1,
      sym_parameter_list,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8011), 1,
      sym__abstract_declarator,
    ACTIONS(9502), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9504), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5686), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2418), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(2416), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [124417] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(9361), 1,
      anon_sym_LPAREN2,
    STATE(4853), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7683), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7685), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [124479] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9280), 1,
      anon_sym_STAR,
    ACTIONS(9282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9284), 1,
      anon_sym_AMP,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9480), 1,
      anon_sym_DOT,
    STATE(3540), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7576), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5220), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9331), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [124565] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    STATE(4694), 1,
      sym_alignas_qualifier,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5239), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5308), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6955), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9510), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9508), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [124635] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5147), 1,
      sym_alignas_qualifier,
    ACTIONS(9515), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5010), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3681), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(9512), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(3683), 18,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [124699] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2422), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(2420), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [124757] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(9361), 1,
      anon_sym_LPAREN2,
    STATE(4840), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7671), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7673), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [124819] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8775), 1,
      anon_sym_STAR,
    ACTIONS(8777), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8779), 1,
      anon_sym_AMP,
    ACTIONS(8781), 1,
      anon_sym_COLON_COLON,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7449), 1,
      sym__scope_resolution,
    STATE(8833), 1,
      sym__declarator,
    STATE(11283), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3038), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3036), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [124967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3042), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3040), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3046), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3044), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3050), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3048), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125132] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9124), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9518), 1,
      anon_sym_STAR,
    ACTIONS(9520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9522), 1,
      anon_sym_AMP,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(5657), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8204), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9126), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9128), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5078), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5980), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7396), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [125223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(2420), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [125278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3042), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3040), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3042), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3040), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125388] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8783), 1,
      anon_sym_STAR,
    ACTIONS(8785), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8787), 1,
      anon_sym_AMP,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7900), 1,
      sym__declarator,
    STATE(10947), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [125481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2960), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2958), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2964), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2962), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125591] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2452), 1,
      anon_sym_STAR,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7421), 1,
      sym__scope_resolution,
    STATE(8496), 1,
      sym__declarator,
    STATE(11547), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [125684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2978), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2976), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3022), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3020), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2934), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2932), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2926), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2924), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125904] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8775), 1,
      anon_sym_STAR,
    ACTIONS(8777), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8779), 1,
      anon_sym_AMP,
    ACTIONS(8781), 1,
      anon_sym_COLON_COLON,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7449), 1,
      sym__scope_resolution,
    STATE(8835), 1,
      sym__declarator,
    STATE(11283), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [125997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2930), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2928), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126052] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5364), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9524), 1,
      anon_sym_STAR,
    ACTIONS(9526), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9528), 1,
      anon_sym_AMP,
    STATE(3856), 1,
      sym_parameter_list,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8240), 1,
      sym__abstract_declarator,
    ACTIONS(9502), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9504), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5052), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6021), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7396), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [126143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2934), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2932), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126198] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9530), 1,
      anon_sym_STAR,
    ACTIONS(9532), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9534), 1,
      anon_sym_AMP,
    STATE(3857), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(6509), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8304), 1,
      sym__abstract_declarator,
    ACTIONS(9538), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9540), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5053), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5928), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7396), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(9536), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7404), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9296), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [126287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3056), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2986), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2984), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126397] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9317), 1,
      anon_sym_STAR,
    ACTIONS(9319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9321), 1,
      anon_sym_AMP,
    ACTIONS(9327), 1,
      anon_sym_DOT,
    STATE(3623), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7686), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5337), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9329), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9323), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [126482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2990), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2988), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3002), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3000), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126592] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2452), 1,
      anon_sym_STAR,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7421), 1,
      sym__scope_resolution,
    STATE(8366), 1,
      sym__declarator,
    STATE(11547), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [126685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3006), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3004), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3010), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3008), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3018), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3016), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3030), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3028), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126905] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(8668), 1,
      anon_sym_STAR,
    ACTIONS(8670), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8672), 1,
      anon_sym_AMP,
    ACTIONS(8674), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7370), 1,
      sym__scope_resolution,
    STATE(8646), 1,
      sym__declarator,
    STATE(11143), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [126998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9544), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(9542), 35,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [127053] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8775), 1,
      anon_sym_STAR,
    ACTIONS(8777), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8779), 1,
      anon_sym_AMP,
    ACTIONS(8781), 1,
      anon_sym_COLON_COLON,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7449), 1,
      sym__scope_resolution,
    STATE(8897), 1,
      sym__declarator,
    STATE(11283), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [127146] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8789), 1,
      anon_sym_STAR,
    ACTIONS(8791), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8793), 1,
      anon_sym_AMP,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(8055), 1,
      sym__declarator,
    STATE(11397), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [127239] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9546), 1,
      anon_sym_DOT,
    ACTIONS(9363), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4252), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(4254), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127298] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8366), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [127391] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9546), 1,
      anon_sym_DOT,
    ACTIONS(9363), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4244), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(4246), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127450] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5364), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9524), 1,
      anon_sym_STAR,
    ACTIONS(9526), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9528), 1,
      anon_sym_AMP,
    STATE(3856), 1,
      sym_parameter_list,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8288), 1,
      sym__abstract_declarator,
    ACTIONS(9502), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9504), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5954), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [127541] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9530), 1,
      anon_sym_STAR,
    ACTIONS(9532), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9534), 1,
      anon_sym_AMP,
    STATE(3857), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(6509), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8310), 1,
      sym__abstract_declarator,
    ACTIONS(9538), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9540), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6022), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6340), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(7410), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(9536), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7412), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9296), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [127630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3034), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3032), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127685] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(2953), 1,
      sym_template_argument_list,
    STATE(5244), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9548), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3777), 5,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3775), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [127750] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8385), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [127843] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(8668), 1,
      anon_sym_STAR,
    ACTIONS(8670), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8672), 1,
      anon_sym_AMP,
    ACTIONS(8674), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7370), 1,
      sym__scope_resolution,
    STATE(8658), 1,
      sym__declarator,
    STATE(11143), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [127936] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(8668), 1,
      anon_sym_STAR,
    ACTIONS(8670), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8672), 1,
      anon_sym_AMP,
    ACTIONS(8674), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7370), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym__declarator,
    STATE(11143), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [128029] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2406), 1,
      anon_sym_LT,
    STATE(210), 1,
      sym_template_argument_list,
    STATE(5244), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9548), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2168), 5,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2176), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [128094] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8789), 1,
      anon_sym_STAR,
    ACTIONS(8791), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8793), 1,
      anon_sym_AMP,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(8037), 1,
      sym__declarator,
    STATE(11397), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [128187] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9550), 1,
      anon_sym_LT,
    STATE(5227), 1,
      sym_template_argument_list,
    STATE(5231), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6796), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2168), 5,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(2176), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [128252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3012), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [128307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2883), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2881), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [128362] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(2953), 1,
      sym_template_argument_list,
    STATE(5231), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6796), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3777), 5,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(3775), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [128427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9554), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(9552), 35,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [128482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2883), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2881), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [128537] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2452), 1,
      anon_sym_STAR,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7421), 1,
      sym__scope_resolution,
    STATE(8385), 1,
      sym__declarator,
    STATE(11547), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [128630] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8496), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [128723] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8789), 1,
      anon_sym_STAR,
    ACTIONS(8791), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8793), 1,
      anon_sym_AMP,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(8143), 1,
      sym__declarator,
    STATE(11397), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [128816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2938), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2936), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [128871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2940), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [128926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2992), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [128981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2998), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2996), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [129036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2948), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2946), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [129091] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4979), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9381), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2883), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2881), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [129150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2952), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2950), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [129205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(3052), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [129260] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9124), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9518), 1,
      anon_sym_STAR,
    ACTIONS(9520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9522), 1,
      anon_sym_AMP,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(5657), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8218), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9126), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9128), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5328), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6063), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [129351] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8783), 1,
      anon_sym_STAR,
    ACTIONS(8785), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8787), 1,
      anon_sym_AMP,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7901), 1,
      sym__declarator,
    STATE(10947), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [129444] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9317), 1,
      anon_sym_STAR,
    ACTIONS(9319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9321), 1,
      anon_sym_AMP,
    ACTIONS(9327), 1,
      anon_sym_DOT,
    STATE(3623), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7719), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5322), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9329), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9331), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [129529] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8783), 1,
      anon_sym_STAR,
    ACTIONS(8785), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8787), 1,
      anon_sym_AMP,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7944), 1,
      sym__declarator,
    STATE(10947), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [129622] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9307), 1,
      anon_sym___attribute__,
    ACTIONS(9309), 1,
      anon_sym___attribute,
    ACTIONS(9478), 1,
      anon_sym_LBRACE,
    STATE(5166), 1,
      sym_enumerator_list,
    STATE(5429), 1,
      sym_attribute_specifier,
    ACTIONS(3989), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3987), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [129686] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9325), 1,
      anon_sym___attribute,
    ACTIONS(9345), 1,
      anon_sym_STAR,
    ACTIONS(9347), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9349), 1,
      anon_sym_AMP,
    ACTIONS(9556), 1,
      anon_sym_DOT,
    STATE(3755), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7758), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5407), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9323), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [129772] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9124), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9558), 1,
      anon_sym_STAR,
    ACTIONS(9560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9562), 1,
      anon_sym_AMP,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(5657), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8428), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9126), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9128), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5085), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7396), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [129862] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9124), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9558), 1,
      anon_sym_STAR,
    ACTIONS(9560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9562), 1,
      anon_sym_AMP,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(5657), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8432), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9126), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9128), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5328), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6141), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [129952] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9307), 1,
      anon_sym___attribute__,
    ACTIONS(9309), 1,
      anon_sym___attribute,
    ACTIONS(9478), 1,
      anon_sym_LBRACE,
    STATE(5172), 1,
      sym_enumerator_list,
    STATE(5453), 1,
      sym_attribute_specifier,
    ACTIONS(3993), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3991), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [130016] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(9278), 1,
      anon_sym_LBRACK,
    ACTIONS(9361), 1,
      anon_sym_LPAREN2,
    STATE(5007), 1,
      sym_new_declarator,
    STATE(4870), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7376), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(7378), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [130082] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8108), 1,
      anon_sym___attribute,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9118), 1,
      anon_sym_STAR,
    ACTIONS(9120), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9122), 1,
      anon_sym_AMP,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    STATE(3608), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7440), 1,
      sym__abstract_declarator,
    STATE(7556), 1,
      sym__function_declarator_seq,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8106), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [130164] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9325), 1,
      anon_sym___attribute,
    ACTIONS(9327), 1,
      anon_sym_DOT,
    ACTIONS(9335), 1,
      anon_sym_STAR,
    ACTIONS(9337), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9339), 1,
      anon_sym_AMP,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7745), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5384), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9329), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9323), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130250] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7404), 1,
      anon_sym___attribute,
    ACTIONS(9288), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9564), 1,
      anon_sym_STAR,
    ACTIONS(9566), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9568), 1,
      anon_sym_AMP,
    STATE(3727), 1,
      sym_parameter_list,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8358), 1,
      sym__abstract_declarator,
    ACTIONS(9290), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9292), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5093), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6159), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7396), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9544), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(9542), 34,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [130396] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9124), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9570), 1,
      anon_sym_STAR,
    ACTIONS(9572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9574), 1,
      anon_sym_AMP,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4323), 1,
      sym_parameter_list,
    STATE(5657), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8394), 1,
      sym__abstract_declarator,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9126), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9128), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5328), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6163), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130486] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7412), 1,
      anon_sym___attribute,
    ACTIONS(9288), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9564), 1,
      anon_sym_STAR,
    ACTIONS(9566), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9568), 1,
      anon_sym_AMP,
    STATE(3727), 1,
      sym_parameter_list,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8361), 1,
      sym__abstract_declarator,
    ACTIONS(9290), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9292), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6162), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9554), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(9552), 34,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [130632] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9118), 1,
      anon_sym_STAR,
    ACTIONS(9120), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9122), 1,
      anon_sym_AMP,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9578), 1,
      anon_sym___attribute,
    STATE(3608), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7415), 1,
      sym__abstract_declarator,
    STATE(7556), 1,
      sym__function_declarator_seq,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9576), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [130714] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9327), 1,
      anon_sym_DOT,
    ACTIONS(9333), 1,
      anon_sym___attribute,
    ACTIONS(9335), 1,
      anon_sym_STAR,
    ACTIONS(9337), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9339), 1,
      anon_sym_AMP,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7751), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5422), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9329), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9331), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130800] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9333), 1,
      anon_sym___attribute,
    ACTIONS(9345), 1,
      anon_sym_STAR,
    ACTIONS(9347), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9349), 1,
      anon_sym_AMP,
    ACTIONS(9556), 1,
      anon_sym_DOT,
    STATE(3755), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7760), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5354), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9331), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130886] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9365), 1,
      anon_sym_STAR,
    ACTIONS(9367), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9369), 1,
      anon_sym_AMP,
    ACTIONS(9580), 1,
      anon_sym_DOT,
    STATE(3676), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7839), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5364), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9329), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9323), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130970] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7412), 1,
      anon_sym___attribute,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9118), 1,
      anon_sym_STAR,
    ACTIONS(9120), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9122), 1,
      anon_sym_AMP,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    STATE(3608), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7425), 1,
      sym__abstract_declarator,
    STATE(7556), 1,
      sym__function_declarator_seq,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(7410), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [131052] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(9278), 1,
      anon_sym_LBRACK,
    ACTIONS(9361), 1,
      anon_sym_LPAREN2,
    STATE(5003), 1,
      sym_new_declarator,
    STATE(4841), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7368), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(7370), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [131118] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9118), 1,
      anon_sym_STAR,
    ACTIONS(9120), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9122), 1,
      anon_sym_AMP,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9584), 1,
      anon_sym___attribute,
    STATE(3608), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7437), 1,
      sym__abstract_declarator,
    STATE(7556), 1,
      sym__function_declarator_seq,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9582), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [131200] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(9278), 1,
      anon_sym_LBRACK,
    ACTIONS(9361), 1,
      anon_sym_LPAREN2,
    STATE(4991), 1,
      sym_new_declarator,
    STATE(4918), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7372), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(7374), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [131266] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9365), 1,
      anon_sym_STAR,
    ACTIONS(9367), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9369), 1,
      anon_sym_AMP,
    ACTIONS(9580), 1,
      anon_sym_DOT,
    STATE(3676), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7843), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5376), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9329), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9331), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [131350] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9124), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9570), 1,
      anon_sym_STAR,
    ACTIONS(9572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9574), 1,
      anon_sym_AMP,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4323), 1,
      sym_parameter_list,
    STATE(5657), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8387), 1,
      sym__abstract_declarator,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9126), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9128), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5092), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6114), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7396), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [131440] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5106), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2915), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(9586), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4121), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4124), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [131500] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5106), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9586), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2913), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2915), 29,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [131558] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5107), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9589), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2913), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_GT2,
    ACTIONS(2915), 29,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [131616] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5107), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2915), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(9589), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4121), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_GT2,
    ACTIONS(4124), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [131676] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(9278), 1,
      anon_sym_LBRACK,
    ACTIONS(9361), 1,
      anon_sym_LPAREN2,
    STATE(5012), 1,
      sym_new_declarator,
    STATE(4925), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7354), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(7356), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [131742] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    STATE(2663), 1,
      sym_alignas_qualifier,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5557), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7524), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9510), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9508), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [131810] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(5344), 1,
      anon_sym_LPAREN2,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7398), 1,
      anon_sym_STAR,
    ACTIONS(7400), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7402), 1,
      anon_sym_AMP,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7408), 1,
      anon_sym_LBRACK,
    ACTIONS(9383), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(3727), 1,
      sym_parameter_list,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8000), 1,
      sym__declarator,
    STATE(8459), 1,
      sym__abstract_declarator,
    STATE(10047), 1,
      sym_variadic_declarator,
    STATE(10947), 1,
      sym_ms_based_modifier,
    ACTIONS(9594), 3,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9592), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [131910] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9600), 1,
      anon_sym_SLASH,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9596), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7771), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
    ACTIONS(7773), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [131983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6124), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6126), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [132036] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9606), 1,
      anon_sym_STAR,
    ACTIONS(9608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9610), 1,
      anon_sym_AMP,
    ACTIONS(9616), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3198), 1,
      sym__type_declarator,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(11420), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6222), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [132125] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5364), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9618), 1,
      anon_sym_STAR,
    ACTIONS(9620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9622), 1,
      anon_sym_AMP,
    STATE(4445), 1,
      sym_parameter_list,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8572), 1,
      sym__abstract_declarator,
    ACTIONS(9502), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9504), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5116), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7396), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [132214] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5364), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9618), 1,
      anon_sym_STAR,
    ACTIONS(9620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9622), 1,
      anon_sym_AMP,
    STATE(4445), 1,
      sym_parameter_list,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8589), 1,
      sym__abstract_declarator,
    ACTIONS(9502), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9504), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6195), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [132303] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(4853), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7683), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(7685), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [132362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2404), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(2402), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [132415] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9600), 1,
      anon_sym_SLASH,
    ACTIONS(9624), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9630), 1,
      anon_sym_CARET,
    ACTIONS(9638), 1,
      anon_sym_GT_EQ,
    ACTIONS(9642), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9644), 1,
      anon_sym_or,
    ACTIONS(9646), 1,
      anon_sym_and,
    ACTIONS(9648), 1,
      anon_sym_xor,
    ACTIONS(9650), 1,
      anon_sym_not_eq,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8250), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9596), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9628), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(9632), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(9634), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9640), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9652), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9636), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8252), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [132518] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9600), 1,
      anon_sym_SLASH,
    ACTIONS(9624), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9630), 1,
      anon_sym_CARET,
    ACTIONS(9638), 1,
      anon_sym_GT_EQ,
    ACTIONS(9642), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9644), 1,
      anon_sym_or,
    ACTIONS(9646), 1,
      anon_sym_and,
    ACTIONS(9648), 1,
      anon_sym_xor,
    ACTIONS(9650), 1,
      anon_sym_not_eq,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8262), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9596), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9628), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(9632), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(9634), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9640), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9652), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9636), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8264), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [132621] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9654), 1,
      anon_sym_STAR,
    ACTIONS(9656), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9658), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8973), 1,
      sym__type_declarator,
    STATE(11243), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5123), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6198), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [132710] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(4869), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7658), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(7660), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [132769] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9654), 1,
      anon_sym_STAR,
    ACTIONS(9656), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9658), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8938), 1,
      sym__type_declarator,
    STATE(11243), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6213), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [132858] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9654), 1,
      anon_sym_STAR,
    ACTIONS(9656), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9658), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8938), 1,
      sym__type_declarator,
    STATE(11243), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5125), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6213), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [132947] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9654), 1,
      anon_sym_STAR,
    ACTIONS(9656), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9658), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8961), 1,
      sym__type_declarator,
    STATE(11243), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6218), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [133036] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7396), 1,
      anon_sym_COMMA,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9660), 1,
      anon_sym_STAR,
    ACTIONS(9662), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9664), 1,
      anon_sym_AMP,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8519), 1,
      sym__abstract_declarator,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5129), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6180), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7404), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [133123] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9600), 1,
      anon_sym_SLASH,
    ACTIONS(9624), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9630), 1,
      anon_sym_CARET,
    ACTIONS(9638), 1,
      anon_sym_GT_EQ,
    ACTIONS(9642), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9644), 1,
      anon_sym_or,
    ACTIONS(9646), 1,
      anon_sym_and,
    ACTIONS(9648), 1,
      anon_sym_xor,
    ACTIONS(9650), 1,
      anon_sym_not_eq,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9672), 1,
      anon_sym_QMARK,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9596), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9628), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(9632), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(9634), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9640), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9652), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9666), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(9636), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9670), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [133230] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9676), 1,
      anon_sym_LPAREN2,
    ACTIONS(9678), 1,
      anon_sym_STAR,
    ACTIONS(9680), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9682), 1,
      anon_sym_AMP,
    ACTIONS(9686), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3868), 1,
      sym__type_declarator,
    STATE(4535), 1,
      sym_pointer_type_declarator,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(11577), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6197), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9684), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4530), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [133319] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7410), 1,
      anon_sym_COMMA,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9660), 1,
      anon_sym_STAR,
    ACTIONS(9662), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9664), 1,
      anon_sym_AMP,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8524), 1,
      sym__abstract_declarator,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6186), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7412), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [133406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7951), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7953), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [133459] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9688), 1,
      sym_identifier,
    ACTIONS(9690), 1,
      anon_sym_LPAREN2,
    ACTIONS(9692), 1,
      anon_sym_STAR,
    ACTIONS(9694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9696), 1,
      anon_sym_AMP,
    ACTIONS(9700), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3793), 1,
      sym__type_declarator,
    STATE(4458), 1,
      sym_pointer_type_declarator,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(11304), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6231), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9698), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4456), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [133548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4242), 33,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [133601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8057), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(8059), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [133654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6112), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6114), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [133707] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(9288), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9702), 1,
      anon_sym_STAR,
    ACTIONS(9704), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9706), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4331), 1,
      sym_parameter_list,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8583), 1,
      sym__abstract_declarator,
    ACTIONS(9290), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9292), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5136), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6173), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7396), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [133796] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(9288), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9702), 1,
      anon_sym_STAR,
    ACTIONS(9704), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9706), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4331), 1,
      sym_parameter_list,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8590), 1,
      sym__abstract_declarator,
    ACTIONS(9290), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9292), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6176), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [133885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6170), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6172), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [133938] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5479), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LPAREN2,
    ACTIONS(9710), 1,
      anon_sym_LBRACK,
    STATE(5472), 1,
      sym_new_declarator,
    STATE(6078), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(9712), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7376), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7378), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [134003] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7305), 1,
      sym_identifier,
    ACTIONS(7309), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3090), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9717), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7307), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3540), 10,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(3542), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(9714), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [134072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6156), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6158), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [134125] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9720), 1,
      sym_identifier,
    ACTIONS(9722), 1,
      anon_sym_LPAREN2,
    ACTIONS(9724), 1,
      anon_sym_STAR,
    ACTIONS(9726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9728), 1,
      anon_sym_AMP,
    ACTIONS(9732), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8122), 1,
      sym_pointer_type_declarator,
    STATE(8812), 1,
      sym__type_declarator,
    STATE(11642), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5200), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6230), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9730), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(8102), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [134214] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9720), 1,
      sym_identifier,
    ACTIONS(9722), 1,
      anon_sym_LPAREN2,
    ACTIONS(9732), 1,
      sym_primitive_type,
    ACTIONS(9734), 1,
      anon_sym_STAR,
    ACTIONS(9736), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9738), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7642), 1,
      sym__type_declarator,
    STATE(8122), 1,
      sym_pointer_type_declarator,
    STATE(11691), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6220), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9730), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(8102), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [134303] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9720), 1,
      sym_identifier,
    ACTIONS(9722), 1,
      anon_sym_LPAREN2,
    ACTIONS(9732), 1,
      sym_primitive_type,
    ACTIONS(9734), 1,
      anon_sym_STAR,
    ACTIONS(9736), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9738), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7642), 1,
      sym__type_declarator,
    STATE(8122), 1,
      sym_pointer_type_declarator,
    STATE(11691), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5206), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6220), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9730), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(8102), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [134392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6120), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6122), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [134445] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(4848), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7695), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(7697), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [134504] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9676), 1,
      anon_sym_LPAREN2,
    ACTIONS(9678), 1,
      anon_sym_STAR,
    ACTIONS(9680), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9682), 1,
      anon_sym_AMP,
    ACTIONS(9686), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3859), 1,
      sym__type_declarator,
    STATE(4535), 1,
      sym_pointer_type_declarator,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(11577), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5185), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6209), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9684), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4530), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [134593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3352), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3362), 33,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [134646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6144), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6146), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [134699] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9550), 1,
      anon_sym_LT,
    STATE(5227), 1,
      sym_template_argument_list,
    ACTIONS(2410), 5,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(2408), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [134758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6298), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6300), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [134811] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9307), 1,
      anon_sym___attribute__,
    ACTIONS(9309), 1,
      anon_sym___attribute,
    STATE(5390), 1,
      sym_attribute_specifier,
    ACTIONS(4004), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4002), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [134870] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9307), 1,
      anon_sym___attribute__,
    ACTIONS(9309), 1,
      anon_sym___attribute,
    STATE(5397), 1,
      sym_attribute_specifier,
    ACTIONS(4091), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4089), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [134929] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9688), 1,
      sym_identifier,
    ACTIONS(9690), 1,
      anon_sym_LPAREN2,
    ACTIONS(9692), 1,
      anon_sym_STAR,
    ACTIONS(9694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9696), 1,
      anon_sym_AMP,
    ACTIONS(9700), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3716), 1,
      sym__type_declarator,
    STATE(4458), 1,
      sym_pointer_type_declarator,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(11304), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6212), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9698), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4456), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [135018] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5479), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LPAREN2,
    ACTIONS(9710), 1,
      anon_sym_LBRACK,
    STATE(5537), 1,
      sym_new_declarator,
    STATE(6091), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(9712), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7372), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7374), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [135083] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9688), 1,
      sym_identifier,
    ACTIONS(9690), 1,
      anon_sym_LPAREN2,
    ACTIONS(9692), 1,
      anon_sym_STAR,
    ACTIONS(9694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9696), 1,
      anon_sym_AMP,
    ACTIONS(9700), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3716), 1,
      sym__type_declarator,
    STATE(4458), 1,
      sym_pointer_type_declarator,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(11304), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5131), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6212), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9698), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4456), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [135172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6160), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6162), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [135225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6164), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6166), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [135278] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9307), 1,
      anon_sym___attribute__,
    ACTIONS(9309), 1,
      anon_sym___attribute,
    STATE(5414), 1,
      sym_attribute_specifier,
    ACTIONS(4200), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4198), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [135337] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9307), 1,
      anon_sym___attribute__,
    ACTIONS(9309), 1,
      anon_sym___attribute,
    STATE(5428), 1,
      sym_attribute_specifier,
    ACTIONS(4107), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4109), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [135396] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9307), 1,
      anon_sym___attribute__,
    ACTIONS(9309), 1,
      anon_sym___attribute,
    STATE(5434), 1,
      sym_attribute_specifier,
    ACTIONS(4010), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4008), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [135455] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9307), 1,
      anon_sym___attribute__,
    ACTIONS(9309), 1,
      anon_sym___attribute,
    STATE(5437), 1,
      sym_attribute_specifier,
    ACTIONS(4014), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4012), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [135514] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9720), 1,
      sym_identifier,
    ACTIONS(9722), 1,
      anon_sym_LPAREN2,
    ACTIONS(9732), 1,
      sym_primitive_type,
    ACTIONS(9734), 1,
      anon_sym_STAR,
    ACTIONS(9736), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9738), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7635), 1,
      sym__type_declarator,
    STATE(8122), 1,
      sym_pointer_type_declarator,
    STATE(11691), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5142), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6202), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9730), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(8102), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [135603] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7264), 1,
      sym_identifier,
    ACTIONS(7272), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(5400), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9745), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5139), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9743), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3423), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3428), 10,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9740), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [135672] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9606), 1,
      anon_sym_STAR,
    ACTIONS(9608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9610), 1,
      anon_sym_AMP,
    ACTIONS(9616), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3252), 1,
      sym__type_declarator,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(11420), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6194), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [135761] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9307), 1,
      anon_sym___attribute__,
    ACTIONS(9309), 1,
      anon_sym___attribute,
    STATE(5452), 1,
      sym_attribute_specifier,
    ACTIONS(4156), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4154), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [135820] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9307), 1,
      anon_sym___attribute__,
    ACTIONS(9309), 1,
      anon_sym___attribute,
    STATE(5455), 1,
      sym_attribute_specifier,
    ACTIONS(4060), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4058), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [135879] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(4840), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7671), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(7673), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [135938] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9307), 1,
      anon_sym___attribute__,
    ACTIONS(9309), 1,
      anon_sym___attribute,
    STATE(5403), 1,
      sym_attribute_specifier,
    ACTIONS(4045), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4043), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [135997] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9307), 1,
      anon_sym___attribute__,
    ACTIONS(9309), 1,
      anon_sym___attribute,
    STATE(5345), 1,
      sym_attribute_specifier,
    ACTIONS(4049), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4047), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [136056] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9550), 1,
      anon_sym_LT,
    STATE(5227), 1,
      sym_template_argument_list,
    ACTIONS(2222), 5,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(2229), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [136115] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9600), 1,
      anon_sym_SLASH,
    ACTIONS(9624), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9630), 1,
      anon_sym_CARET,
    ACTIONS(9638), 1,
      anon_sym_GT_EQ,
    ACTIONS(9642), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9644), 1,
      anon_sym_or,
    ACTIONS(9646), 1,
      anon_sym_and,
    ACTIONS(9648), 1,
      anon_sym_xor,
    ACTIONS(9650), 1,
      anon_sym_not_eq,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8284), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9596), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9628), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(9632), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(9634), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9640), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9652), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9636), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8286), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [136218] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9307), 1,
      anon_sym___attribute__,
    ACTIONS(9309), 1,
      anon_sym___attribute,
    STATE(5352), 1,
      sym_attribute_specifier,
    ACTIONS(4087), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4085), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [136277] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9307), 1,
      anon_sym___attribute__,
    ACTIONS(9309), 1,
      anon_sym___attribute,
    STATE(5353), 1,
      sym_attribute_specifier,
    ACTIONS(4176), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4174), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [136336] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5479), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LPAREN2,
    ACTIONS(9710), 1,
      anon_sym_LBRACK,
    STATE(5560), 1,
      sym_new_declarator,
    STATE(6069), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(9712), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7368), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7370), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [136401] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5479), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LPAREN2,
    ACTIONS(9710), 1,
      anon_sym_LBRACK,
    STATE(5540), 1,
      sym_new_declarator,
    STATE(6168), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(9712), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(7354), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7356), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [136466] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9600), 1,
      anon_sym_SLASH,
    ACTIONS(9624), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9630), 1,
      anon_sym_CARET,
    ACTIONS(9638), 1,
      anon_sym_GT_EQ,
    ACTIONS(9642), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9644), 1,
      anon_sym_or,
    ACTIONS(9646), 1,
      anon_sym_and,
    ACTIONS(9648), 1,
      anon_sym_xor,
    ACTIONS(9650), 1,
      anon_sym_not_eq,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9672), 1,
      anon_sym_QMARK,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8274), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9596), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9628), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(9632), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(9634), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9640), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9652), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9636), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8276), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [136573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8053), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(8055), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [136626] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7904), 1,
      sym__type_declarator,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5183), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6211), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [136715] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9600), 1,
      anon_sym_SLASH,
    ACTIONS(9624), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9630), 1,
      anon_sym_CARET,
    ACTIONS(9638), 1,
      anon_sym_GT_EQ,
    ACTIONS(9642), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9644), 1,
      anon_sym_or,
    ACTIONS(9646), 1,
      anon_sym_and,
    ACTIONS(9648), 1,
      anon_sym_xor,
    ACTIONS(9650), 1,
      anon_sym_not_eq,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9672), 1,
      anon_sym_QMARK,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7911), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9596), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9628), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(9632), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(9634), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9640), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9652), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9636), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7913), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [136822] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9688), 1,
      sym_identifier,
    ACTIONS(9690), 1,
      anon_sym_LPAREN2,
    ACTIONS(9692), 1,
      anon_sym_STAR,
    ACTIONS(9694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9696), 1,
      anon_sym_AMP,
    ACTIONS(9700), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3798), 1,
      sym__type_declarator,
    STATE(4458), 1,
      sym_pointer_type_declarator,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(11304), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5153), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6205), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9698), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4456), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [136911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6130), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [136964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6136), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6138), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [137017] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7954), 1,
      sym__type_declarator,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6216), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [137106] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7954), 1,
      sym__type_declarator,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5186), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6216), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [137195] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9676), 1,
      anon_sym_LPAREN2,
    ACTIONS(9678), 1,
      anon_sym_STAR,
    ACTIONS(9680), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9682), 1,
      anon_sym_AMP,
    ACTIONS(9686), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3819), 1,
      sym__type_declarator,
    STATE(4535), 1,
      sym_pointer_type_declarator,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(11577), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6172), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9684), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4530), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [137284] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7973), 1,
      sym__type_declarator,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6221), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [137373] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9676), 1,
      anon_sym_LPAREN2,
    ACTIONS(9678), 1,
      anon_sym_STAR,
    ACTIONS(9680), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9682), 1,
      anon_sym_AMP,
    ACTIONS(9686), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3819), 1,
      sym__type_declarator,
    STATE(4535), 1,
      sym_pointer_type_declarator,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(11577), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5128), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6172), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9684), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4530), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [137462] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9600), 1,
      anon_sym_SLASH,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7773), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
    ACTIONS(7771), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
  [137533] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9600), 1,
      anon_sym_SLASH,
    ACTIONS(9626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9630), 1,
      anon_sym_CARET,
    ACTIONS(9638), 1,
      anon_sym_GT_EQ,
    ACTIONS(9642), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9646), 1,
      anon_sym_and,
    ACTIONS(9648), 1,
      anon_sym_xor,
    ACTIONS(9650), 1,
      anon_sym_not_eq,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9596), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9628), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(9632), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(9634), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9640), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9652), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 3,
      aux_sym_preproc_elif_token1,
      anon_sym_or,
      sym_identifier,
    ACTIONS(9636), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
  [137632] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9600), 1,
      anon_sym_SLASH,
    ACTIONS(9630), 1,
      anon_sym_CARET,
    ACTIONS(9638), 1,
      anon_sym_GT_EQ,
    ACTIONS(9642), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9648), 1,
      anon_sym_xor,
    ACTIONS(9650), 1,
      anon_sym_not_eq,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9596), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9628), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(9632), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(9634), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9640), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9652), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9636), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7771), 4,
      aux_sym_preproc_elif_token1,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
    ACTIONS(7773), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
  [137727] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9600), 1,
      anon_sym_SLASH,
    ACTIONS(9630), 1,
      anon_sym_CARET,
    ACTIONS(9638), 1,
      anon_sym_GT_EQ,
    ACTIONS(9642), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9648), 1,
      anon_sym_xor,
    ACTIONS(9650), 1,
      anon_sym_not_eq,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9596), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9632), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(9634), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9640), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9652), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9636), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7771), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      sym_identifier,
    ACTIONS(7773), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
  [137820] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9600), 1,
      anon_sym_SLASH,
    ACTIONS(9638), 1,
      anon_sym_GT_EQ,
    ACTIONS(9642), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9650), 1,
      anon_sym_not_eq,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9596), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9632), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(9634), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9640), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9652), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9636), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7771), 7,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      sym_identifier,
    ACTIONS(7773), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
  [137909] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9600), 1,
      anon_sym_SLASH,
    ACTIONS(9638), 1,
      anon_sym_GT_EQ,
    ACTIONS(9642), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9650), 1,
      anon_sym_not_eq,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9596), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9634), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9640), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9652), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9636), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7771), 9,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      sym_identifier,
    ACTIONS(7773), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
  [137996] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9600), 1,
      anon_sym_SLASH,
    ACTIONS(9638), 1,
      anon_sym_GT_EQ,
    ACTIONS(9642), 1,
      anon_sym_LT_EQ_GT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9596), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9640), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9652), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9636), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7771), 10,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7773), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
  [138079] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9600), 1,
      anon_sym_SLASH,
    ACTIONS(9642), 1,
      anon_sym_LT_EQ_GT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9596), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9640), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9652), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 13,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7773), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
  [138158] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9606), 1,
      anon_sym_STAR,
    ACTIONS(9608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9610), 1,
      anon_sym_AMP,
    ACTIONS(9616), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3239), 1,
      sym__type_declarator,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(11420), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5114), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6203), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [138247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6324), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [138300] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6324), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [138353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6324), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [138406] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9720), 1,
      sym_identifier,
    ACTIONS(9722), 1,
      anon_sym_LPAREN2,
    ACTIONS(9724), 1,
      anon_sym_STAR,
    ACTIONS(9726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9728), 1,
      anon_sym_AMP,
    ACTIONS(9732), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8122), 1,
      sym_pointer_type_declarator,
    STATE(8816), 1,
      sym__type_declarator,
    STATE(11642), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6232), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9730), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(8102), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [138495] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9720), 1,
      sym_identifier,
    ACTIONS(9722), 1,
      anon_sym_LPAREN2,
    ACTIONS(9724), 1,
      anon_sym_STAR,
    ACTIONS(9726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9728), 1,
      anon_sym_AMP,
    ACTIONS(9732), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8122), 1,
      sym_pointer_type_declarator,
    STATE(8816), 1,
      sym__type_declarator,
    STATE(11642), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5203), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6232), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9730), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(8102), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [138584] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9600), 1,
      anon_sym_SLASH,
    ACTIONS(9624), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9630), 1,
      anon_sym_CARET,
    ACTIONS(9638), 1,
      anon_sym_GT_EQ,
    ACTIONS(9642), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9644), 1,
      anon_sym_or,
    ACTIONS(9646), 1,
      anon_sym_and,
    ACTIONS(9648), 1,
      anon_sym_xor,
    ACTIONS(9650), 1,
      anon_sym_not_eq,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8288), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9596), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9628), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(9632), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(9634), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9640), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9652), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9636), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8290), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [138687] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9720), 1,
      sym_identifier,
    ACTIONS(9722), 1,
      anon_sym_LPAREN2,
    ACTIONS(9724), 1,
      anon_sym_STAR,
    ACTIONS(9726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9728), 1,
      anon_sym_AMP,
    ACTIONS(9732), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8122), 1,
      sym_pointer_type_declarator,
    STATE(8818), 1,
      sym__type_declarator,
    STATE(11642), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6233), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9730), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(8102), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [138776] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9600), 1,
      anon_sym_SLASH,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9596), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9640), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7773), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
    ACTIONS(7771), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      sym_identifier,
  [138851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6302), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6304), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [138904] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9720), 1,
      sym_identifier,
    ACTIONS(9722), 1,
      anon_sym_LPAREN2,
    ACTIONS(9732), 1,
      sym_primitive_type,
    ACTIONS(9734), 1,
      anon_sym_STAR,
    ACTIONS(9736), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9738), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7646), 1,
      sym__type_declarator,
    STATE(8122), 1,
      sym_pointer_type_declarator,
    STATE(11691), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6207), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9730), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(8102), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [138993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2414), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(2412), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [139046] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9600), 1,
      anon_sym_SLASH,
    ACTIONS(9624), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9630), 1,
      anon_sym_CARET,
    ACTIONS(9638), 1,
      anon_sym_GT_EQ,
    ACTIONS(9642), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9644), 1,
      anon_sym_or,
    ACTIONS(9646), 1,
      anon_sym_and,
    ACTIONS(9648), 1,
      anon_sym_xor,
    ACTIONS(9650), 1,
      anon_sym_not_eq,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8292), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9596), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9628), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(9632), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(9634), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9640), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9652), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9636), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8294), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [139149] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9600), 1,
      anon_sym_SLASH,
    ACTIONS(9624), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9630), 1,
      anon_sym_CARET,
    ACTIONS(9638), 1,
      anon_sym_GT_EQ,
    ACTIONS(9642), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9644), 1,
      anon_sym_or,
    ACTIONS(9646), 1,
      anon_sym_and,
    ACTIONS(9648), 1,
      anon_sym_xor,
    ACTIONS(9650), 1,
      anon_sym_not_eq,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9672), 1,
      anon_sym_QMARK,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8266), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9596), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9628), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(9632), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(9634), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9640), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9652), 2,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9636), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8270), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [139256] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9606), 1,
      anon_sym_STAR,
    ACTIONS(9608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9610), 1,
      anon_sym_AMP,
    ACTIONS(9616), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3198), 1,
      sym__type_declarator,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(11420), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9612), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5164), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6222), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9288), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [139345] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5254), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2974), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(9754), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2972), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [139401] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5107), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4073), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9756), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4071), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [139457] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9333), 1,
      anon_sym___attribute,
    ACTIONS(9470), 1,
      anon_sym_STAR,
    ACTIONS(9472), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9474), 1,
      anon_sym_AMP,
    ACTIONS(9758), 1,
      anon_sym_DOT,
    STATE(4172), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8007), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5703), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9331), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [139541] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9280), 1,
      anon_sym_STAR,
    ACTIONS(9282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9284), 1,
      anon_sym_AMP,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    STATE(3540), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7614), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(7410), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [139619] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9760), 1,
      sym_identifier,
    ACTIONS(9762), 1,
      sym_primitive_type,
    STATE(2719), 1,
      sym_alignas_qualifier,
    STATE(3050), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6818), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5222), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7366), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3423), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(3428), 11,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6813), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [139687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2314), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2312), 31,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [139739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2550), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(2548), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [139791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2270), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2268), 31,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [139843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2274), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2272), 31,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [139895] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9280), 1,
      anon_sym_STAR,
    ACTIONS(9282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9284), 1,
      anon_sym_AMP,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    STATE(3540), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7578), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9582), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [139973] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9288), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9764), 1,
      anon_sym_STAR,
    ACTIONS(9766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9768), 1,
      anon_sym_AMP,
    STATE(3883), 1,
      sym_parameter_list,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8652), 1,
      sym__abstract_declarator,
    ACTIONS(9290), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9292), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5223), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6280), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7396), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_requires,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [140061] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      sym_identifier,
    ACTIONS(9774), 1,
      sym_primitive_type,
    STATE(2719), 1,
      sym_alignas_qualifier,
    STATE(5833), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6831), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2679), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9772), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3542), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(3540), 11,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6826), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [140129] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9288), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9764), 1,
      anon_sym_STAR,
    ACTIONS(9766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9768), 1,
      anon_sym_AMP,
    STATE(3883), 1,
      sym_parameter_list,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8670), 1,
      sym__abstract_declarator,
    ACTIONS(9290), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9292), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6285), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7410), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_requires,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [140217] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9776), 1,
      sym_identifier,
    ACTIONS(9781), 1,
      sym_primitive_type,
    STATE(5147), 1,
      sym_alignas_qualifier,
    STATE(5479), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9407), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5296), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9779), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3423), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(3428), 10,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9402), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [140285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2278), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2276), 31,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [140337] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9464), 1,
      anon_sym_STAR,
    ACTIONS(9466), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9468), 1,
      anon_sym_AMP,
    ACTIONS(9480), 1,
      anon_sym_DOT,
    STATE(3551), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8036), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5707), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9331), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [140419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2243), 31,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [140471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2241), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2239), 31,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [140523] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9494), 1,
      anon_sym_STAR,
    ACTIONS(9496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9498), 1,
      anon_sym_AMP,
    ACTIONS(9556), 1,
      anon_sym_DOT,
    STATE(3800), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8147), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5673), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9323), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [140605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3026), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(3024), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [140657] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5269), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4093), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(9783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4095), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [140713] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(9791), 1,
      anon_sym_SLASH,
    ACTIONS(9797), 1,
      anon_sym_PIPE,
    ACTIONS(9801), 1,
      anon_sym_AMP,
    ACTIONS(9807), 1,
      anon_sym_GT_EQ,
    ACTIONS(9811), 1,
      anon_sym_SEMI,
    ACTIONS(9813), 1,
      anon_sym_QMARK,
    ACTIONS(9817), 1,
      anon_sym_bitor,
    ACTIONS(9819), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9103), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10835), 1,
      sym_attribute_specifier,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9787), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9789), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9793), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9795), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9799), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9803), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9805), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9815), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [140821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(8332), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [140873] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5107), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4078), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9756), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4080), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [140929] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9280), 1,
      anon_sym_STAR,
    ACTIONS(9282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9284), 1,
      anon_sym_AMP,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    STATE(3540), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7603), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8106), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [141007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2260), 31,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [141059] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7404), 1,
      anon_sym___attribute,
    ACTIONS(9288), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9821), 1,
      anon_sym_STAR,
    ACTIONS(9823), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9825), 1,
      anon_sym_AMP,
    STATE(4120), 1,
      sym_parameter_list,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8627), 1,
      sym__abstract_declarator,
    ACTIONS(9290), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9292), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5262), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6292), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7396), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_GT2,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [141149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2956), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(2954), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [141201] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    STATE(4694), 1,
      sym_alignas_qualifier,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9829), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9827), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [141263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2974), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(2972), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [141315] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(7404), 1,
      anon_sym___attribute,
    ACTIONS(9288), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9831), 1,
      anon_sym_STAR,
    ACTIONS(9833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9835), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4273), 1,
      sym_parameter_list,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8610), 1,
      sym__abstract_declarator,
    ACTIONS(9290), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9292), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5243), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6349), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7396), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [141405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2282), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2280), 31,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [141457] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(7412), 1,
      anon_sym___attribute,
    ACTIONS(9288), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9831), 1,
      anon_sym_STAR,
    ACTIONS(9833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9835), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4273), 1,
      sym_parameter_list,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8675), 1,
      sym__abstract_declarator,
    ACTIONS(9290), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9292), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6299), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7410), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [141547] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5107), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4093), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9756), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4095), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [141603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2286), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2284), 31,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [141655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2982), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(2980), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [141707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2302), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2300), 31,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [141759] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9464), 1,
      anon_sym_STAR,
    ACTIONS(9466), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9468), 1,
      anon_sym_AMP,
    ACTIONS(9480), 1,
      anon_sym_DOT,
    STATE(3551), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8134), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5865), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9323), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [141841] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5263), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4111), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9837), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4113), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [141897] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5265), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4053), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9839), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4051), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [141953] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9325), 1,
      anon_sym___attribute,
    ACTIONS(9470), 1,
      anon_sym_STAR,
    ACTIONS(9472), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9474), 1,
      anon_sym_AMP,
    ACTIONS(9758), 1,
      anon_sym_DOT,
    STATE(4172), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8155), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5689), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9323), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [142037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2304), 31,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [142089] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8308), 1,
      sym_literal_suffix,
    ACTIONS(2181), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2170), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [142143] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5269), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4078), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(9783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4080), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [142199] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5364), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9841), 1,
      anon_sym_STAR,
    ACTIONS(9843), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9845), 1,
      anon_sym_AMP,
    STATE(3767), 1,
      sym_parameter_list,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8597), 1,
      sym__abstract_declarator,
    ACTIONS(9502), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9504), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5297), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6302), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7396), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [142287] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9847), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6806), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6808), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [142341] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5269), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4064), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(9783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4062), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [142397] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2426), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2428), 31,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [142451] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9847), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9849), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(6781), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6783), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [142507] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9325), 1,
      anon_sym___attribute,
    ACTIONS(9484), 1,
      anon_sym_STAR,
    ACTIONS(9486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9488), 1,
      anon_sym_AMP,
    ACTIONS(9851), 1,
      anon_sym_DOT,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4265), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8032), 1,
      sym__abstract_declarator,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5692), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9323), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [142591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2310), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2308), 31,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [142643] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7412), 1,
      anon_sym___attribute,
    ACTIONS(9288), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9821), 1,
      anon_sym_STAR,
    ACTIONS(9823), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9825), 1,
      anon_sym_AMP,
    STATE(4120), 1,
      sym_parameter_list,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8726), 1,
      sym__abstract_declarator,
    ACTIONS(9290), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9292), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6301), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7410), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_GT2,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [142733] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5107), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3995), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9756), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3997), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [142789] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9494), 1,
      anon_sym_STAR,
    ACTIONS(9496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9498), 1,
      anon_sym_AMP,
    ACTIONS(9556), 1,
      anon_sym_DOT,
    STATE(3800), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8027), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5682), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9331), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [142871] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5107), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4102), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9756), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4100), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [142927] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5293), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4164), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9853), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4166), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [142983] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5212), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4178), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9855), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4180), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [143039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2288), 31,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [143091] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5269), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2915), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(9857), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2913), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [143147] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5107), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4185), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9756), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4187), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [143203] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5269), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4073), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(9783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4071), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [143259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2266), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2264), 31,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [143311] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5269), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3995), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(9783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3997), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [143367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2294), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2292), 31,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [143419] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5234), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2974), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9860), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2972), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [143475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(2552), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [143527] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5271), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4178), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(9862), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4180), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [143583] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9280), 1,
      anon_sym_STAR,
    ACTIONS(9282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9284), 1,
      anon_sym_AMP,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    STATE(3540), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7575), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9576), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [143661] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(9791), 1,
      anon_sym_SLASH,
    ACTIONS(9797), 1,
      anon_sym_PIPE,
    ACTIONS(9801), 1,
      anon_sym_AMP,
    ACTIONS(9807), 1,
      anon_sym_GT_EQ,
    ACTIONS(9813), 1,
      anon_sym_QMARK,
    ACTIONS(9817), 1,
      anon_sym_bitor,
    ACTIONS(9819), 1,
      anon_sym_bitand,
    ACTIONS(9864), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9143), 1,
      aux_sym_field_declaration_repeat1,
    STATE(11677), 1,
      sym_attribute_specifier,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9787), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9789), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9793), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9795), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9799), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9803), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9805), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9815), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [143769] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5273), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4111), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(9866), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4113), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [143825] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5292), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4053), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(9868), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4051), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [143881] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(9791), 1,
      anon_sym_SLASH,
    ACTIONS(9797), 1,
      anon_sym_PIPE,
    ACTIONS(9801), 1,
      anon_sym_AMP,
    ACTIONS(9807), 1,
      anon_sym_GT_EQ,
    ACTIONS(9813), 1,
      anon_sym_QMARK,
    ACTIONS(9817), 1,
      anon_sym_bitor,
    ACTIONS(9819), 1,
      anon_sym_bitand,
    ACTIONS(9870), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9205), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10985), 1,
      sym_attribute_specifier,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9787), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9789), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9793), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9795), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9799), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9803), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9805), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9815), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [143989] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    STATE(5613), 1,
      sym_field_declaration_list,
    STATE(5849), 1,
      sym_attribute_specifier,
    STATE(9379), 1,
      sym_virtual_specifier,
    STATE(10466), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9872), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(2895), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2893), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [144057] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5234), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2883), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9860), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2881), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [144113] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5254), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2883), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(9754), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2881), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [144169] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5269), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4185), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(9783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4187), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [144225] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    STATE(4694), 1,
      sym_alignas_qualifier,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9510), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9508), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [144287] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(5344), 1,
      anon_sym_LPAREN2,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7398), 1,
      anon_sym_STAR,
    ACTIONS(7400), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7402), 1,
      anon_sym_AMP,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7408), 1,
      anon_sym_LBRACK,
    STATE(3727), 1,
      sym_parameter_list,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8000), 1,
      sym__declarator,
    STATE(8459), 1,
      sym__abstract_declarator,
    STATE(10947), 1,
      sym_ms_based_modifier,
    ACTIONS(9594), 3,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9592), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [144381] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2420), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2422), 31,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [144435] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2420), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2422), 31,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [144489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2418), 31,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [144541] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5269), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4102), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(9783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4100), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [144597] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5107), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4064), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9756), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4062), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [144653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2296), 31,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [144705] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5257), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4164), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(9876), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4166), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [144761] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9878), 1,
      sym_identifier,
    ACTIONS(9883), 1,
      sym_primitive_type,
    STATE(5147), 1,
      sym_alignas_qualifier,
    STATE(5740), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9425), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5010), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9881), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3542), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(3540), 10,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9420), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [144829] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5364), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9841), 1,
      anon_sym_STAR,
    ACTIONS(9843), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9845), 1,
      anon_sym_AMP,
    STATE(3767), 1,
      sym_parameter_list,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8631), 1,
      sym__abstract_declarator,
    ACTIONS(9502), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9504), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6247), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7410), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [144917] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9333), 1,
      anon_sym___attribute,
    ACTIONS(9484), 1,
      anon_sym_STAR,
    ACTIONS(9486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9488), 1,
      anon_sym_AMP,
    ACTIONS(9851), 1,
      anon_sym_DOT,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4265), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8041), 1,
      sym__abstract_declarator,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5694), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9331), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [145001] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9327), 1,
      anon_sym_DOT,
    ACTIONS(9518), 1,
      anon_sym_STAR,
    ACTIONS(9520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9522), 1,
      anon_sym_AMP,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8197), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5945), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9329), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9323), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [145082] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9460), 1,
      anon_sym_LT,
    STATE(2953), 1,
      sym_template_argument_list,
    STATE(3086), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2168), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6763), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2176), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [145143] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5364), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(5519), 1,
      anon_sym_STAR,
    ACTIONS(5521), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5523), 1,
      anon_sym_AMP,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8878), 1,
      sym__abstract_declarator,
    ACTIONS(9502), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9504), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6370), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7410), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [145230] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(9885), 1,
      sym_identifier,
    ACTIONS(9887), 1,
      anon_sym_LPAREN2,
    ACTIONS(9889), 1,
      anon_sym_STAR,
    ACTIONS(9891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9893), 1,
      anon_sym_AMP,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(8774), 1,
      sym__field_declarator,
    STATE(9120), 1,
      sym_operator_name,
    STATE(11011), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6373), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8244), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [145315] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7404), 1,
      sym_identifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9895), 1,
      anon_sym_STAR,
    ACTIONS(9897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9899), 1,
      anon_sym_AMP,
    STATE(3869), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(6509), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8872), 1,
      sym__abstract_declarator,
    ACTIONS(9538), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9540), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5312), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6359), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7396), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(9536), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9296), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [145400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7834), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(7832), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [145451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2420), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2422), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [145502] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(9887), 1,
      anon_sym_LPAREN2,
    ACTIONS(9901), 1,
      sym_identifier,
    ACTIONS(9903), 1,
      anon_sym_STAR,
    ACTIONS(9905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9907), 1,
      anon_sym_AMP,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7854), 1,
      sym__field_declarator,
    STATE(8031), 1,
      sym_operator_name,
    STATE(10874), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5321), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8244), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [145587] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2883), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2881), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [145640] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9913), 1,
      anon_sym___attribute__,
    ACTIONS(9916), 1,
      anon_sym___attribute,
    STATE(5308), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(9911), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(9909), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [145697] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(2953), 1,
      sym_template_argument_list,
    STATE(3086), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3777), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6763), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3775), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [145758] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9327), 1,
      anon_sym_DOT,
    ACTIONS(9518), 1,
      anon_sym_STAR,
    ACTIONS(9520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9522), 1,
      anon_sym_AMP,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8211), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6036), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9329), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9331), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [145839] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(9887), 1,
      anon_sym_LPAREN2,
    ACTIONS(9901), 1,
      sym_identifier,
    ACTIONS(9903), 1,
      anon_sym_STAR,
    ACTIONS(9905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9907), 1,
      anon_sym_AMP,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7854), 1,
      sym__field_declarator,
    STATE(8031), 1,
      sym_operator_name,
    STATE(10874), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8244), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [145924] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7412), 1,
      sym_identifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9895), 1,
      anon_sym_STAR,
    ACTIONS(9897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9899), 1,
      anon_sym_AMP,
    STATE(3869), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(6509), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8877), 1,
      sym__abstract_declarator,
    ACTIONS(9538), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9540), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6340), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6374), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7410), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(9536), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9296), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [146009] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(9885), 1,
      sym_identifier,
    ACTIONS(9887), 1,
      anon_sym_LPAREN2,
    ACTIONS(9889), 1,
      anon_sym_STAR,
    ACTIONS(9891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9893), 1,
      anon_sym_AMP,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(8776), 1,
      sym__field_declarator,
    STATE(9120), 1,
      sym_operator_name,
    STATE(11011), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6377), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8244), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [146094] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(2953), 1,
      sym_template_argument_list,
    STATE(5812), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3777), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9919), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3775), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [146155] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9317), 1,
      anon_sym_STAR,
    ACTIONS(9319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9321), 1,
      anon_sym_AMP,
    STATE(3623), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7731), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [146232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7816), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(7814), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [146283] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(210), 1,
      sym_template_argument_list,
    ACTIONS(2222), 5,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2229), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [146340] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9524), 1,
      anon_sym_STAR,
    ACTIONS(9526), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9528), 1,
      anon_sym_AMP,
    ACTIONS(9851), 1,
      anon_sym_DOT,
    STATE(3856), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8215), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6035), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9331), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [146421] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9530), 1,
      anon_sym_STAR,
    ACTIONS(9532), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9534), 1,
      anon_sym_AMP,
    ACTIONS(9921), 1,
      anon_sym_DOT,
    STATE(3857), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8308), 1,
      sym__abstract_declarator,
    ACTIONS(9540), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6033), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9331), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(9923), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9333), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9296), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [146502] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(9885), 1,
      sym_identifier,
    ACTIONS(9887), 1,
      anon_sym_LPAREN2,
    ACTIONS(9889), 1,
      anon_sym_STAR,
    ACTIONS(9891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9893), 1,
      anon_sym_AMP,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(8774), 1,
      sym__field_declarator,
    STATE(9120), 1,
      sym_operator_name,
    STATE(11011), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5313), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6373), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8244), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [146587] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(9887), 1,
      anon_sym_LPAREN2,
    ACTIONS(9901), 1,
      sym_identifier,
    ACTIONS(9903), 1,
      anon_sym_STAR,
    ACTIONS(9905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9907), 1,
      anon_sym_AMP,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7864), 1,
      sym__field_declarator,
    STATE(8031), 1,
      sym_operator_name,
    STATE(10874), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6363), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8244), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [146672] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9317), 1,
      anon_sym_STAR,
    ACTIONS(9319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9321), 1,
      anon_sym_AMP,
    STATE(3623), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7632), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9582), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [146749] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(9885), 1,
      sym_identifier,
    ACTIONS(9887), 1,
      anon_sym_LPAREN2,
    ACTIONS(9889), 1,
      anon_sym_STAR,
    ACTIONS(9891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9893), 1,
      anon_sym_AMP,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(8882), 1,
      sym__field_declarator,
    STATE(9120), 1,
      sym_operator_name,
    STATE(11011), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5302), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6382), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8244), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [146834] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    STATE(5706), 1,
      sym_field_declaration_list,
    STATE(6056), 1,
      sym_attribute_specifier,
    STATE(9494), 1,
      sym_virtual_specifier,
    STATE(10757), 1,
      sym_base_class_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2893), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2895), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [146903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2879), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2877), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [146954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7748), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(7746), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [147005] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9530), 1,
      anon_sym_STAR,
    ACTIONS(9532), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9534), 1,
      anon_sym_AMP,
    ACTIONS(9921), 1,
      anon_sym_DOT,
    STATE(3857), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8301), 1,
      sym__abstract_declarator,
    ACTIONS(9540), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5958), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9323), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(9923), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9325), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9296), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [147086] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9927), 1,
      sym_ms_restrict_modifier,
    STATE(5657), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(9930), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9933), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5328), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(9351), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9353), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [147147] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(210), 1,
      sym_template_argument_list,
    STATE(5244), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2168), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9548), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2176), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [147208] = 9,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6329), 1,
      sym_alignas_qualifier,
    ACTIONS(8564), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5912), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6955), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9508), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(8560), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9510), 14,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [147271] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9936), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9938), 1,
      anon_sym_and,
    ACTIONS(6806), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6808), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [147326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(8332), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [147377] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(9887), 1,
      anon_sym_LPAREN2,
    ACTIONS(9901), 1,
      sym_identifier,
    ACTIONS(9903), 1,
      anon_sym_STAR,
    ACTIONS(9905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9907), 1,
      anon_sym_AMP,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7780), 1,
      sym__field_declarator,
    STATE(8031), 1,
      sym_operator_name,
    STATE(10874), 1,
      sym_ms_based_modifier,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5311), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6366), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8244), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [147462] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9524), 1,
      anon_sym_STAR,
    ACTIONS(9526), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9528), 1,
      anon_sym_AMP,
    ACTIONS(9851), 1,
      anon_sym_DOT,
    STATE(3856), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8194), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5902), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9323), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [147543] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(210), 1,
      sym_template_argument_list,
    ACTIONS(2410), 5,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2408), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [147600] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9317), 1,
      anon_sym_STAR,
    ACTIONS(9319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9321), 1,
      anon_sym_AMP,
    STATE(3623), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7633), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8106), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [147677] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9317), 1,
      anon_sym_STAR,
    ACTIONS(9319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9321), 1,
      anon_sym_AMP,
    STATE(3623), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7718), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9576), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [147754] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(2953), 1,
      sym_template_argument_list,
    STATE(5687), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9940), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3775), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(3777), 27,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [147815] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9936), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9938), 1,
      anon_sym_and,
    ACTIONS(9942), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9944), 1,
      anon_sym_or,
    ACTIONS(6781), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6783), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [147874] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9946), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7648), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(4482), 31,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_private,
      anon_sym_template,
      anon_sym_try,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [147929] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8308), 1,
      sym_literal_suffix,
    ACTIONS(2181), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
    ACTIONS(2170), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [147982] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5364), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(5519), 1,
      anon_sym_STAR,
    ACTIONS(5521), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5523), 1,
      anon_sym_AMP,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8839), 1,
      sym__abstract_declarator,
    ACTIONS(9502), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9504), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5301), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6398), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7396), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [148069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3042), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3040), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [148119] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(9949), 1,
      anon_sym_COLON,
    ACTIONS(9951), 1,
      anon_sym_LBRACE,
    STATE(5513), 1,
      sym__enum_base_clause,
    STATE(5701), 1,
      sym_enumerator_list,
    STATE(5998), 1,
      sym_attribute_specifier,
    ACTIONS(3478), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3480), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [148183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3006), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3004), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [148233] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7771), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7773), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [148311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3010), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3008), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [148361] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(9969), 1,
      anon_sym_RPAREN,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9983), 1,
      anon_sym_SEMI,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9820), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [148463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3012), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [148513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2883), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2881), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [148563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2883), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2881), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [148613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3018), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3016), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [148663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3030), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3028), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [148713] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9345), 1,
      anon_sym_STAR,
    ACTIONS(9347), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9349), 1,
      anon_sym_AMP,
    ACTIONS(9584), 1,
      anon_sym___attribute,
    STATE(3755), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7761), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9582), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [148791] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8108), 1,
      anon_sym___attribute,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9335), 1,
      anon_sym_STAR,
    ACTIONS(9337), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9339), 1,
      anon_sym_AMP,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7757), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8106), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [148869] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(9949), 1,
      anon_sym_COLON,
    ACTIONS(9951), 1,
      anon_sym_LBRACE,
    STATE(5593), 1,
      sym__enum_base_clause,
    STATE(5806), 1,
      sym_enumerator_list,
    STATE(5884), 1,
      sym_attribute_specifier,
    ACTIONS(3502), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3504), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [148933] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7771), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [149005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2938), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2936), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [149055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2940), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [149105] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8250), 1,
      anon_sym___attribute,
    ACTIONS(9791), 1,
      anon_sym_SLASH,
    ACTIONS(9797), 1,
      anon_sym_PIPE,
    ACTIONS(9801), 1,
      anon_sym_AMP,
    ACTIONS(9807), 1,
      anon_sym_GT_EQ,
    ACTIONS(9817), 1,
      anon_sym_bitor,
    ACTIONS(9819), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9787), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9789), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9793), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9795), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9799), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9803), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9805), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9815), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8252), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [149199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2992), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [149249] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2998), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2996), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [149299] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [149373] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9365), 1,
      anon_sym_STAR,
    ACTIONS(9367), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9369), 1,
      anon_sym_AMP,
    STATE(3676), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7842), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9576), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [149449] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(8108), 1,
      anon_sym___attribute,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9345), 1,
      anon_sym_STAR,
    ACTIONS(9347), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9349), 1,
      anon_sym_AMP,
    STATE(3755), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7765), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8106), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [149527] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    STATE(2663), 1,
      sym_alignas_qualifier,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5367), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9510), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9508), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [149587] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9994), 1,
      anon_sym_const,
    STATE(2663), 1,
      sym_alignas_qualifier,
    ACTIONS(9997), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5367), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3683), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9991), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(3681), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [149647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2948), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2946), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [149697] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8284), 1,
      anon_sym___attribute,
    ACTIONS(9791), 1,
      anon_sym_SLASH,
    ACTIONS(9797), 1,
      anon_sym_PIPE,
    ACTIONS(9801), 1,
      anon_sym_AMP,
    ACTIONS(9807), 1,
      anon_sym_GT_EQ,
    ACTIONS(9817), 1,
      anon_sym_bitor,
    ACTIONS(9819), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9787), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9789), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9793), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9795), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9799), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9803), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9805), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9815), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8286), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [149791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2952), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2950), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [149841] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(5344), 1,
      anon_sym_LPAREN2,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7408), 1,
      anon_sym_LBRACK,
    ACTIONS(7507), 1,
      anon_sym_STAR,
    ACTIONS(7509), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7511), 1,
      anon_sym_AMP,
    STATE(4120), 1,
      sym_parameter_list,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8000), 1,
      sym__declarator,
    STATE(8663), 1,
      sym__abstract_declarator,
    STATE(10947), 1,
      sym_ms_based_modifier,
    ACTIONS(9592), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(9594), 3,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [149933] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8294), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [150025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3052), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [150075] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9365), 1,
      anon_sym_STAR,
    ACTIONS(9367), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9369), 1,
      anon_sym_AMP,
    STATE(3676), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7844), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [150151] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9791), 1,
      anon_sym_SLASH,
    ACTIONS(9797), 1,
      anon_sym_PIPE,
    ACTIONS(9801), 1,
      anon_sym_AMP,
    ACTIONS(9807), 1,
      anon_sym_GT_EQ,
    ACTIONS(9813), 1,
      anon_sym_QMARK,
    ACTIONS(9817), 1,
      anon_sym_bitor,
    ACTIONS(9819), 1,
      anon_sym_bitand,
    ACTIONS(10002), 1,
      anon_sym___attribute,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9787), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9789), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9793), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9795), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9799), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9803), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9805), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9815), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10000), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [150249] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9365), 1,
      anon_sym_STAR,
    ACTIONS(9367), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9369), 1,
      anon_sym_AMP,
    STATE(3676), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7845), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9582), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [150325] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(7911), 1,
      anon_sym___attribute,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9791), 1,
      anon_sym_SLASH,
    ACTIONS(9797), 1,
      anon_sym_PIPE,
    ACTIONS(9801), 1,
      anon_sym_AMP,
    ACTIONS(9807), 1,
      anon_sym_GT_EQ,
    ACTIONS(9813), 1,
      anon_sym_QMARK,
    ACTIONS(9817), 1,
      anon_sym_bitor,
    ACTIONS(9819), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9787), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9789), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9793), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9795), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9799), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7913), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
    ACTIONS(9803), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9805), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9815), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [150423] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9365), 1,
      anon_sym_STAR,
    ACTIONS(9367), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9369), 1,
      anon_sym_AMP,
    STATE(3676), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7846), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8106), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [150499] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8270), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [150595] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8274), 1,
      anon_sym___attribute,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9791), 1,
      anon_sym_SLASH,
    ACTIONS(9797), 1,
      anon_sym_PIPE,
    ACTIONS(9801), 1,
      anon_sym_AMP,
    ACTIONS(9807), 1,
      anon_sym_GT_EQ,
    ACTIONS(9813), 1,
      anon_sym_QMARK,
    ACTIONS(9817), 1,
      anon_sym_bitor,
    ACTIONS(9819), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9787), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9789), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9793), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9795), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9799), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8276), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
    ACTIONS(9803), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9805), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9815), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [150693] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8264), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [150785] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8252), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [150877] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7771), 1,
      anon_sym_PIPE,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7773), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [150963] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9335), 1,
      anon_sym_STAR,
    ACTIONS(9337), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9339), 1,
      anon_sym_AMP,
    ACTIONS(9578), 1,
      anon_sym___attribute,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7750), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9576), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [151041] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9878), 1,
      sym_identifier,
    ACTIONS(9883), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(5740), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9717), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9881), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3542), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3540), 10,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9714), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [151107] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7771), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [151177] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9333), 1,
      anon_sym___attribute,
    ACTIONS(9556), 1,
      anon_sym_DOT,
    ACTIONS(9564), 1,
      anon_sym_STAR,
    ACTIONS(9566), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9568), 1,
      anon_sym_AMP,
    STATE(3727), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8343), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6161), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9331), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [151259] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(5344), 1,
      anon_sym_LPAREN2,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7408), 1,
      anon_sym_LBRACK,
    ACTIONS(7562), 1,
      anon_sym_STAR,
    ACTIONS(7564), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7566), 1,
      anon_sym_AMP,
    STATE(4273), 1,
      sym_parameter_list,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8000), 1,
      sym__declarator,
    STATE(8642), 1,
      sym__abstract_declarator,
    STATE(10947), 1,
      sym_ms_based_modifier,
    ACTIONS(9592), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(9594), 3,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [151351] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    STATE(2663), 1,
      sym_alignas_qualifier,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5367), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9829), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9827), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [151411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3034), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3032), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [151461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3038), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3036), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [151511] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8266), 1,
      anon_sym___attribute,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9791), 1,
      anon_sym_SLASH,
    ACTIONS(9797), 1,
      anon_sym_PIPE,
    ACTIONS(9801), 1,
      anon_sym_AMP,
    ACTIONS(9807), 1,
      anon_sym_GT_EQ,
    ACTIONS(9813), 1,
      anon_sym_QMARK,
    ACTIONS(9817), 1,
      anon_sym_bitor,
    ACTIONS(9819), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9787), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9789), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9793), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9795), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9799), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8270), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
    ACTIONS(9803), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9805), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9815), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [151609] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5364), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10004), 1,
      anon_sym_STAR,
    ACTIONS(10006), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10008), 1,
      anon_sym_AMP,
    STATE(4446), 1,
      sym_parameter_list,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8955), 1,
      sym__abstract_declarator,
    ACTIONS(9502), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9504), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6425), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7410), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_requires,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [151695] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9776), 1,
      sym_identifier,
    ACTIONS(9781), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(5878), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9745), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5385), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(10010), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3423), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3428), 10,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9740), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [151761] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7773), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [151849] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10012), 1,
      anon_sym_DOT,
    ACTIONS(9712), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4244), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(4246), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [151903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3046), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3044), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [151953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3050), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3048), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [152003] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7412), 1,
      anon_sym___attribute,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9335), 1,
      anon_sym_STAR,
    ACTIONS(9337), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9339), 1,
      anon_sym_AMP,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7752), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [152081] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2881), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2915), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(7112), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4121), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(4124), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [152137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3042), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3040), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [152187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3042), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3040), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [152237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3002), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3000), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [152287] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7771), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [152355] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5364), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10004), 1,
      anon_sym_STAR,
    ACTIONS(10006), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10008), 1,
      anon_sym_AMP,
    STATE(4446), 1,
      sym_parameter_list,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8969), 1,
      sym__abstract_declarator,
    ACTIONS(9502), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9504), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5393), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6455), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7396), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_requires,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [152441] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9791), 1,
      anon_sym_SLASH,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9789), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7771), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
    ACTIONS(7773), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [152509] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9345), 1,
      anon_sym_STAR,
    ACTIONS(9347), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9349), 1,
      anon_sym_AMP,
    ACTIONS(9578), 1,
      anon_sym___attribute,
    STATE(3755), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7759), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9576), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [152587] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9570), 1,
      anon_sym_STAR,
    ACTIONS(9572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9574), 1,
      anon_sym_AMP,
    ACTIONS(10014), 1,
      anon_sym_DOT,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4323), 1,
      sym_parameter_list,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8382), 1,
      sym__abstract_declarator,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6073), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(10016), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9323), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [152667] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7771), 1,
      anon_sym___attribute,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9791), 1,
      anon_sym_SLASH,
    ACTIONS(9797), 1,
      anon_sym_PIPE,
    ACTIONS(9801), 1,
      anon_sym_AMP,
    ACTIONS(9807), 1,
      anon_sym_GT_EQ,
    ACTIONS(9817), 1,
      anon_sym_bitor,
    ACTIONS(9819), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9787), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9789), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9795), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9799), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9803), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9805), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9815), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7773), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
  [152759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4248), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4250), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [152809] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9325), 1,
      anon_sym___attribute,
    ACTIONS(9556), 1,
      anon_sym_DOT,
    ACTIONS(9564), 1,
      anon_sym_STAR,
    ACTIONS(9566), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9568), 1,
      anon_sym_AMP,
    STATE(3727), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8319), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6158), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9323), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [152891] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7771), 1,
      anon_sym___attribute,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9791), 1,
      anon_sym_SLASH,
    ACTIONS(9797), 1,
      anon_sym_PIPE,
    ACTIONS(9801), 1,
      anon_sym_AMP,
    ACTIONS(9807), 1,
      anon_sym_GT_EQ,
    ACTIONS(9817), 1,
      anon_sym_bitor,
    ACTIONS(9819), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9787), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9789), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9799), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9803), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9805), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9815), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7773), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [152981] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8276), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [153077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2960), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2958), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [153127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2964), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2962), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [153177] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10018), 1,
      anon_sym_COMMA,
    ACTIONS(10020), 1,
      anon_sym_SEMI,
    ACTIONS(10022), 1,
      anon_sym_RBRACE,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(10239), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [153279] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10031), 1,
      anon_sym_requires,
    ACTIONS(10034), 1,
      anon_sym_where,
    STATE(6049), 1,
      sym_ref_qualifier,
    STATE(7040), 1,
      sym__function_attributes_end,
    STATE(7318), 1,
      sym_trailing_return_type,
    STATE(7549), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7724), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6452), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [153375] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9791), 1,
      anon_sym_SLASH,
    ACTIONS(9801), 1,
      anon_sym_AMP,
    ACTIONS(9807), 1,
      anon_sym_GT_EQ,
    ACTIONS(9819), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7771), 2,
      anon_sym_PIPE,
      anon_sym___attribute,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9787), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9789), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9799), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9803), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9805), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9815), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7773), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [153461] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8172), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    STATE(6043), 1,
      sym_ref_qualifier,
    STATE(7031), 1,
      sym__function_attributes_end,
    STATE(7303), 1,
      sym_trailing_return_type,
    STATE(7549), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8170), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6430), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [153557] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9791), 1,
      anon_sym_SLASH,
    ACTIONS(9801), 1,
      anon_sym_AMP,
    ACTIONS(9807), 1,
      anon_sym_GT_EQ,
    ACTIONS(9819), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7771), 2,
      anon_sym_PIPE,
      anon_sym___attribute,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9787), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9789), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9803), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9805), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9815), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7773), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [153641] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8262), 1,
      anon_sym___attribute,
    ACTIONS(9791), 1,
      anon_sym_SLASH,
    ACTIONS(9797), 1,
      anon_sym_PIPE,
    ACTIONS(9801), 1,
      anon_sym_AMP,
    ACTIONS(9807), 1,
      anon_sym_GT_EQ,
    ACTIONS(9817), 1,
      anon_sym_bitor,
    ACTIONS(9819), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9787), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9789), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9793), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9795), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9799), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9803), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9805), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9815), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8264), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [153735] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9335), 1,
      anon_sym_STAR,
    ACTIONS(9337), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9339), 1,
      anon_sym_AMP,
    ACTIONS(9584), 1,
      anon_sym___attribute,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7753), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9582), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [153813] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9791), 1,
      anon_sym_SLASH,
    ACTIONS(9807), 1,
      anon_sym_GT_EQ,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9787), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9789), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7771), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym___attribute,
    ACTIONS(9803), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9805), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9815), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7773), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [153893] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8288), 1,
      anon_sym___attribute,
    ACTIONS(9791), 1,
      anon_sym_SLASH,
    ACTIONS(9797), 1,
      anon_sym_PIPE,
    ACTIONS(9801), 1,
      anon_sym_AMP,
    ACTIONS(9807), 1,
      anon_sym_GT_EQ,
    ACTIONS(9817), 1,
      anon_sym_bitor,
    ACTIONS(9819), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9787), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9789), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9793), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9795), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9799), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9803), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9805), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9815), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8290), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [153987] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10037), 1,
      anon_sym_LBRACE,
    STATE(5617), 1,
      sym_enumerator_list,
    STATE(5630), 1,
      sym_attribute_specifier,
    ACTIONS(9872), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(3987), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3989), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [154045] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10037), 1,
      anon_sym_LBRACE,
    STATE(5620), 1,
      sym_enumerator_list,
    STATE(5643), 1,
      sym_attribute_specifier,
    ACTIONS(9872), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(3991), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3993), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [154103] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7773), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
  [154193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2978), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2976), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [154243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3022), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3020), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [154293] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9872), 1,
      anon_sym___attribute,
    ACTIONS(10037), 1,
      anon_sym_LBRACE,
    ACTIONS(10039), 1,
      anon_sym_COLON,
    ACTIONS(10041), 1,
      anon_sym___attribute__,
    STATE(5425), 1,
      sym__enum_base_clause,
    STATE(5611), 1,
      sym_enumerator_list,
    STATE(5840), 1,
      sym_attribute_specifier,
    ACTIONS(3478), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(3480), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [154357] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7771), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7773), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [154437] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9791), 1,
      anon_sym_SLASH,
    ACTIONS(9807), 1,
      anon_sym_GT_EQ,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9787), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9789), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7771), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym___attribute,
    ACTIONS(9805), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9815), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7773), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [154515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2934), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2932), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [154565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2926), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2924), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [154615] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9791), 1,
      anon_sym_SLASH,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9787), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9789), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9815), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
    ACTIONS(7773), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [154689] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7412), 1,
      anon_sym___attribute,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9345), 1,
      anon_sym_STAR,
    ACTIONS(9347), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9349), 1,
      anon_sym_AMP,
    STATE(3755), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7764), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [154767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2930), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2928), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [154817] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9872), 1,
      anon_sym___attribute,
    ACTIONS(10037), 1,
      anon_sym_LBRACE,
    ACTIONS(10039), 1,
      anon_sym_COLON,
    ACTIONS(10041), 1,
      anon_sym___attribute__,
    STATE(5426), 1,
      sym__enum_base_clause,
    STATE(5615), 1,
      sym_enumerator_list,
    STATE(5761), 1,
      sym_attribute_specifier,
    ACTIONS(3502), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(3504), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [154881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2934), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2932), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [154931] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8290), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [155023] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9791), 1,
      anon_sym_SLASH,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9787), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9789), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7771), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
    ACTIONS(7773), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [155093] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8286), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [155185] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9558), 1,
      anon_sym_STAR,
    ACTIONS(9560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9562), 1,
      anon_sym_AMP,
    ACTIONS(9580), 1,
      anon_sym_DOT,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8427), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9329), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9323), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [155265] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9124), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(10043), 1,
      anon_sym_STAR,
    ACTIONS(10045), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10047), 1,
      anon_sym_AMP,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4464), 1,
      sym_parameter_list,
    STATE(5657), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8988), 1,
      sym__abstract_declarator,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9126), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9128), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5454), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6442), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7396), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [155351] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9791), 1,
      anon_sym_SLASH,
    ACTIONS(9797), 1,
      anon_sym_PIPE,
    ACTIONS(9801), 1,
      anon_sym_AMP,
    ACTIONS(9807), 1,
      anon_sym_GT_EQ,
    ACTIONS(9813), 1,
      anon_sym_QMARK,
    ACTIONS(9817), 1,
      anon_sym_bitor,
    ACTIONS(9819), 1,
      anon_sym_bitand,
    ACTIONS(10051), 1,
      anon_sym___attribute,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9787), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9789), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9793), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9795), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9799), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9803), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9805), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9815), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10049), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [155449] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7771), 1,
      anon_sym_PIPE,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7773), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [155533] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10012), 1,
      anon_sym_DOT,
    ACTIONS(9712), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4252), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(4254), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [155587] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9558), 1,
      anon_sym_STAR,
    ACTIONS(9560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9562), 1,
      anon_sym_AMP,
    ACTIONS(9580), 1,
      anon_sym_DOT,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8431), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6140), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9329), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9331), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [155667] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9570), 1,
      anon_sym_STAR,
    ACTIONS(9572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9574), 1,
      anon_sym_AMP,
    ACTIONS(10014), 1,
      anon_sym_DOT,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4323), 1,
      sym_parameter_list,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8391), 1,
      sym__abstract_declarator,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6122), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(10016), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9331), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [155747] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7913), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [155843] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9791), 1,
      anon_sym_SLASH,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9787), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9789), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7771), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
    ACTIONS(7773), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [155915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3056), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [155965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2986), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2984), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [156015] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9124), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(10043), 1,
      anon_sym_STAR,
    ACTIONS(10045), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10047), 1,
      anon_sym_AMP,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4464), 1,
      sym_parameter_list,
    STATE(5657), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8998), 1,
      sym__abstract_declarator,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9126), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9128), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5328), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6471), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7410), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [156101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2990), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2988), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [156151] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(8292), 1,
      anon_sym___attribute,
    ACTIONS(9791), 1,
      anon_sym_SLASH,
    ACTIONS(9797), 1,
      anon_sym_PIPE,
    ACTIONS(9801), 1,
      anon_sym_AMP,
    ACTIONS(9807), 1,
      anon_sym_GT_EQ,
    ACTIONS(9817), 1,
      anon_sym_bitor,
    ACTIONS(9819), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9787), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9789), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9793), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9795), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9799), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9803), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9805), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9815), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8294), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [156245] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10091), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10200), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2877), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2879), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [156393] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10093), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9839), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156492] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10095), 1,
      anon_sym_COMMA,
    ACTIONS(10097), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9844), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [156591] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10020), 1,
      anon_sym_SEMI,
    ACTIONS(10099), 1,
      anon_sym_COMMA,
    ACTIONS(10102), 1,
      anon_sym_RBRACE,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [156690] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10104), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9846), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156789] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10106), 1,
      anon_sym_COMMA,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10132), 1,
      anon_sym_RBRACK,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(10035), 1,
      aux_sym_subscript_argument_list_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [156888] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10142), 1,
      anon_sym_COMMA,
    ACTIONS(10145), 1,
      anon_sym_SEMI,
    ACTIONS(10147), 1,
      anon_sym_RBRACE,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [156987] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7410), 1,
      anon_sym_COMMA,
    ACTIONS(7412), 1,
      sym_identifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10149), 1,
      anon_sym_STAR,
    ACTIONS(10151), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10153), 1,
      anon_sym_AMP,
    STATE(4330), 1,
      sym_parameter_list,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9111), 1,
      sym__abstract_declarator,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6506), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [157070] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10155), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9996), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [157169] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9550), 1,
      anon_sym_LT,
    STATE(5227), 1,
      sym_template_argument_list,
    ACTIONS(2229), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2222), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [157224] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9550), 1,
      anon_sym_LT,
    STATE(5227), 1,
      sym_template_argument_list,
    ACTIONS(2408), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2410), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [157279] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5364), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10157), 1,
      anon_sym_STAR,
    ACTIONS(10159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10161), 1,
      anon_sym_AMP,
    STATE(4444), 1,
      sym_parameter_list,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9036), 1,
      sym__abstract_declarator,
    ACTIONS(7396), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(9502), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9504), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5470), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6482), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [157364] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5364), 1,
      sym_ms_restrict_modifier,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10157), 1,
      anon_sym_STAR,
    ACTIONS(10159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10161), 1,
      anon_sym_AMP,
    STATE(4444), 1,
      sym_parameter_list,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9044), 1,
      sym__abstract_declarator,
    ACTIONS(7410), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(9502), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9504), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6484), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [157449] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10163), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10027), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157548] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5479), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LPAREN2,
    STATE(6093), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7683), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7685), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [157603] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10165), 1,
      anon_sym_LT,
    STATE(5227), 1,
      sym_template_argument_list,
    STATE(5231), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2168), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6796), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2176), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [157662] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10167), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(10051), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [157761] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10145), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [157858] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10169), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(10082), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [157957] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10171), 1,
      anon_sym_RPAREN,
    ACTIONS(10173), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [158056] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10175), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9997), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [158155] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 1,
      sym_primitive_type,
    STATE(5106), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9586), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4121), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(4124), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [158210] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9618), 1,
      anon_sym_STAR,
    ACTIONS(9620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9622), 1,
      anon_sym_AMP,
    ACTIONS(9758), 1,
      anon_sym_DOT,
    STATE(4445), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8565), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6193), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9331), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [158289] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9618), 1,
      anon_sym_STAR,
    ACTIONS(9620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9622), 1,
      anon_sym_AMP,
    ACTIONS(9758), 1,
      anon_sym_DOT,
    STATE(4445), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8563), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6185), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9323), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [158368] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10179), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10177), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [158465] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10181), 1,
      anon_sym_COMMA,
    ACTIONS(10183), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(10186), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [158564] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10185), 1,
      anon_sym_COMMA,
    ACTIONS(10187), 1,
      anon_sym_RBRACE,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(10201), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [158663] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10189), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10212), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158762] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10191), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10147), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158861] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10193), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(10267), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [158960] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10195), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(10272), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [159059] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8308), 1,
      sym_literal_suffix,
    ACTIONS(2181), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
    ACTIONS(2170), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [159110] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(9288), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10197), 1,
      anon_sym_STAR,
    ACTIONS(10199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10201), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4503), 1,
      sym_parameter_list,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9187), 1,
      sym__abstract_declarator,
    ACTIONS(7396), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(9290), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9292), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5502), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6535), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [159195] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10203), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9700), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159294] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10205), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10311), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159393] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10095), 1,
      anon_sym_COMMA,
    ACTIONS(10207), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(10314), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [159492] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10209), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10321), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159591] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5539), 1,
      sym_alignas_qualifier,
    ACTIONS(10214), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3681), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3683), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(10211), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [159648] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10217), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9736), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159747] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10095), 1,
      anon_sym_COMMA,
    ACTIONS(10219), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(10032), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [159846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2881), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2883), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [159897] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10095), 1,
      anon_sym_COMMA,
    ACTIONS(10221), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9777), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [159996] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10223), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9800), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160095] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10225), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10033), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160194] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(9288), 1,
      sym_ms_restrict_modifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10197), 1,
      anon_sym_STAR,
    ACTIONS(10199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10201), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4503), 1,
      sym_parameter_list,
    STATE(5046), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9165), 1,
      sym__abstract_declarator,
    ACTIONS(7410), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(9290), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9292), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4899), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6510), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [160279] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10181), 1,
      anon_sym_COMMA,
    ACTIONS(10227), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9636), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [160378] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10229), 1,
      anon_sym_COMMA,
    ACTIONS(10231), 1,
      anon_sym_RBRACE,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9639), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [160477] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10233), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9646), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160576] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10235), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9669), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [160675] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10237), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9671), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [160774] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10239), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9679), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160873] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10095), 1,
      anon_sym_COMMA,
    ACTIONS(10241), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9682), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [160972] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10243), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9684), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161071] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10106), 1,
      anon_sym_COMMA,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    ACTIONS(10245), 1,
      anon_sym_RBRACK,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(10068), 1,
      aux_sym_subscript_argument_list_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [161170] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10247), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9761), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [161269] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(9951), 1,
      anon_sym_LBRACE,
    STATE(5678), 1,
      sym_enumerator_list,
    STATE(5959), 1,
      sym_attribute_specifier,
    ACTIONS(3989), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3987), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [161328] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9331), 1,
      anon_sym_COMMA,
    ACTIONS(9660), 1,
      anon_sym_STAR,
    ACTIONS(9662), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9664), 1,
      anon_sym_AMP,
    ACTIONS(10249), 1,
      anon_sym_DOT,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8508), 1,
      sym__abstract_declarator,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6181), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9923), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9333), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [161407] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10181), 1,
      anon_sym_COMMA,
    ACTIONS(10251), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9762), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [161506] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10253), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9767), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161605] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10095), 1,
      anon_sym_COMMA,
    ACTIONS(10255), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9715), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [161704] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10257), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9790), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [161803] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10259), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9791), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [161902] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10261), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9807), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162001] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10263), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9809), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162100] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10265), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9969), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162199] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10267), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9774), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [162298] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9702), 1,
      anon_sym_STAR,
    ACTIONS(9704), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9706), 1,
      anon_sym_AMP,
    ACTIONS(9851), 1,
      anon_sym_DOT,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4331), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8543), 1,
      sym__abstract_declarator,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6175), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9331), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [162377] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10269), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9885), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162476] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10271), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9895), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [162575] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10273), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9896), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [162674] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10275), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9900), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162773] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10277), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9904), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162872] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8202), 1,
      anon_sym_DASH_GT,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8206), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10279), 1,
      anon_sym___attribute__,
    ACTIONS(10282), 1,
      anon_sym___attribute,
    ACTIONS(10285), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6152), 1,
      sym_ref_qualifier,
    STATE(6943), 1,
      sym__function_attributes_end,
    STATE(7004), 1,
      sym_trailing_return_type,
    STATE(7624), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7838), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6514), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [162967] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10288), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9974), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163066] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10290), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9984), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [163165] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10292), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9986), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [163264] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10294), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10001), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163363] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10296), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10005), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163462] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7396), 1,
      anon_sym_COMMA,
    ACTIONS(7404), 1,
      sym_identifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10149), 1,
      anon_sym_STAR,
    ACTIONS(10151), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10153), 1,
      anon_sym_AMP,
    STATE(4330), 1,
      sym_parameter_list,
    STATE(5091), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9086), 1,
      sym__abstract_declarator,
    ACTIONS(5366), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5465), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6515), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5364), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [163545] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5479), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LPAREN2,
    STATE(6077), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7658), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7660), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [163600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4242), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [163649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3352), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3362), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [163698] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5479), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LPAREN2,
    STATE(6157), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7671), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7673), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [163753] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10298), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10050), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163852] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10300), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10066), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163951] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10302), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10069), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164050] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10181), 1,
      anon_sym_COMMA,
    ACTIONS(10304), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9822), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [164149] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10306), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9821), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [164248] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10308), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10108), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164347] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10310), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10111), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164446] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10312), 1,
      anon_sym_COMMA,
    ACTIONS(10314), 1,
      anon_sym_RBRACE,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9851), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [164545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(8332), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [164594] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10316), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10126), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164693] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10318), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10137), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164792] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10320), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10139), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164891] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9323), 1,
      anon_sym_COMMA,
    ACTIONS(9660), 1,
      anon_sym_STAR,
    ACTIONS(9662), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9664), 1,
      anon_sym_AMP,
    ACTIONS(10249), 1,
      anon_sym_DOT,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8568), 1,
      sym__abstract_declarator,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6196), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9923), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9325), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [164970] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10322), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10157), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165069] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10324), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10169), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165168] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10326), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10171), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165267] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10328), 1,
      anon_sym___attribute__,
    ACTIONS(10331), 1,
      anon_sym___attribute,
    STATE(5557), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(9911), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(9909), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [165322] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10334), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10188), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165421] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10336), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10203), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165520] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5479), 1,
      anon_sym_LBRACE,
    ACTIONS(9708), 1,
      anon_sym_LPAREN2,
    STATE(6080), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(7695), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7697), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [165575] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10338), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10219), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165674] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10340), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10229), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165773] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10342), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10235), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165872] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9702), 1,
      anon_sym_STAR,
    ACTIONS(9704), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9706), 1,
      anon_sym_AMP,
    ACTIONS(9851), 1,
      anon_sym_DOT,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4331), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8536), 1,
      sym__abstract_declarator,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6204), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9323), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [165951] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10022), 1,
      anon_sym_RBRACE,
    ACTIONS(10344), 1,
      anon_sym_COMMA,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(10239), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [166050] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10181), 1,
      anon_sym_COMMA,
    ACTIONS(10346), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9912), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [166149] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10348), 1,
      anon_sym_COMMA,
    ACTIONS(10350), 1,
      anon_sym_RBRACE,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9917), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [166248] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10352), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9920), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166347] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10354), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10243), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166446] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10356), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10258), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166545] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10358), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9935), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166644] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10360), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10262), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166743] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10181), 1,
      anon_sym_COMMA,
    ACTIONS(10362), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9689), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [166842] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10364), 1,
      anon_sym_COMMA,
    ACTIONS(10366), 1,
      anon_sym_RBRACE,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9694), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [166941] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10368), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10282), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167040] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10370), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10298), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167139] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10372), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10302), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167238] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10374), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10315), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167337] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10376), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9887), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167436] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10378), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9635), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167535] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10380), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9710), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167634] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10382), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9610), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167733] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10384), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9841), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167832] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10386), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9925), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167931] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10388), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10092), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168030] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10390), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10236), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168129] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10392), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10254), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168228] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10181), 1,
      anon_sym_COMMA,
    ACTIONS(10394), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9796), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [168327] = 9,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2738), 1,
      sym_alignas_qualifier,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6183), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6324), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7524), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9508), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(6720), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9510), 14,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [168388] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10396), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10015), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168487] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10398), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9648), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168586] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10400), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9660), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168685] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(9951), 1,
      anon_sym_LBRACE,
    STATE(5813), 1,
      sym_enumerator_list,
    STATE(5957), 1,
      sym_attribute_specifier,
    ACTIONS(3993), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3991), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [168744] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10402), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9688), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168843] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10404), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9713), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168942] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10406), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9719), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169041] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10408), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9729), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169140] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10410), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9778), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169239] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10412), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9784), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169338] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10414), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9823), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169437] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10416), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9874), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169536] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10418), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9906), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169635] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10420), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9921), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169734] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10422), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9957), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169833] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10424), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9959), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169932] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8202), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10279), 1,
      anon_sym___attribute__,
    ACTIONS(10282), 1,
      anon_sym___attribute,
    ACTIONS(10285), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10429), 1,
      anon_sym_requires,
    ACTIONS(10432), 1,
      anon_sym_where,
    STATE(6139), 1,
      sym_ref_qualifier,
    STATE(6938), 1,
      sym__function_attributes_end,
    STATE(7035), 1,
      sym_trailing_return_type,
    STATE(7624), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10426), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7509), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6500), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [170027] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5839), 1,
      sym_attribute_specifier,
    ACTIONS(9872), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4002), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4004), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [170080] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5848), 1,
      sym_attribute_specifier,
    ACTIONS(9872), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4089), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4091), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [170133] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10435), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(9975), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [170232] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5873), 1,
      sym_attribute_specifier,
    ACTIONS(9872), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4198), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4200), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [170285] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5629), 1,
      sym_attribute_specifier,
    ACTIONS(9872), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4109), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4107), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [170338] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10437), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10030), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [170437] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5632), 1,
      sym_attribute_specifier,
    ACTIONS(9872), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4008), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4010), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [170490] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5633), 1,
      sym_attribute_specifier,
    ACTIONS(9872), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4012), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4014), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [170543] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5642), 1,
      sym_attribute_specifier,
    ACTIONS(9872), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4154), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4156), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [170596] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10439), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10037), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [170695] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5644), 1,
      sym_attribute_specifier,
    ACTIONS(9872), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4058), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4060), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [170748] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5645), 1,
      sym_attribute_specifier,
    ACTIONS(9872), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4043), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4045), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [170801] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5646), 1,
      sym_attribute_specifier,
    ACTIONS(9872), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4047), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4049), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [170854] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5652), 1,
      sym_attribute_specifier,
    ACTIONS(9872), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4085), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4087), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [170907] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5653), 1,
      sym_attribute_specifier,
    ACTIONS(9872), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4174), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4176), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [170960] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10106), 1,
      anon_sym_COMMA,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    ACTIONS(10441), 1,
      anon_sym_RBRACK,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9952), 1,
      aux_sym_subscript_argument_list_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [171059] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9983), 1,
      anon_sym_SEMI,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    STATE(9820), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [171158] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    ACTIONS(10443), 1,
      anon_sym_GT2,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    STATE(10093), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [171257] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    STATE(6008), 1,
      sym_attribute_specifier,
    ACTIONS(4049), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4047), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [171311] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7771), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [171381] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7836), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(7838), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [171441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2972), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2974), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [171489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2976), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2978), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [171537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3020), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3022), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [171585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2934), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [171633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2924), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2926), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [171681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2928), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2930), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [171729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2934), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [171777] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(2255), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2245), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [171827] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10445), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [171923] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10447), 1,
      anon_sym_COMMA,
    ACTIONS(10449), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [172019] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10451), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [172115] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10145), 1,
      anon_sym_COLON,
    ACTIONS(10453), 1,
      anon_sym_COMMA,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10479), 1,
      anon_sym_QMARK,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [172211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2980), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2982), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [172259] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    STATE(5984), 1,
      sym_attribute_specifier,
    ACTIONS(4045), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4043), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [172313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3058), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [172361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2984), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2986), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [172409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2988), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2990), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [172457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3002), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [172505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3004), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3006), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [172553] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10487), 1,
      anon_sym_COMMA,
    ACTIONS(10489), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [172649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3010), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [172697] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10491), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [172791] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8294), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [172881] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10493), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [172977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3016), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3018), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [173025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3028), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3030), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [173073] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10495), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [173169] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10497), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [173265] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10499), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [173361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9542), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      sym_ms_restrict_modifier,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9544), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [173409] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10501), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [173505] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9556), 1,
      anon_sym_DOT,
    ACTIONS(9764), 1,
      anon_sym_STAR,
    ACTIONS(9766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9768), 1,
      anon_sym_AMP,
    STATE(3883), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8599), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6284), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9331), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_requires,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [173583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9552), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      sym_ms_restrict_modifier,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9554), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [173631] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8270), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [173725] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8270), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [173819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2881), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2883), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [173867] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10173), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [173963] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8290), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [174053] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8252), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [174143] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10503), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [174239] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10147), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [174333] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10505), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [174427] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9670), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [174521] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10507), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [174617] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10509), 1,
      anon_sym_COMMA,
    ACTIONS(10511), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [174713] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9494), 1,
      anon_sym_STAR,
    ACTIONS(9496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9498), 1,
      anon_sym_AMP,
    STATE(3800), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8022), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9576), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [174787] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8286), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [174877] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8276), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [174971] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10513), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [175065] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10515), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [175161] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    STATE(5964), 1,
      sym_attribute_specifier,
    ACTIONS(4060), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4058), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [175215] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8264), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [175305] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10453), 1,
      anon_sym_COMMA,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10479), 1,
      anon_sym_QMARK,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    ACTIONS(10517), 1,
      anon_sym_COLON,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [175401] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9494), 1,
      anon_sym_STAR,
    ACTIONS(9496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9498), 1,
      anon_sym_AMP,
    STATE(3800), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8011), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [175475] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9494), 1,
      anon_sym_STAR,
    ACTIONS(9496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9498), 1,
      anon_sym_AMP,
    STATE(3800), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8046), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9582), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [175549] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    STATE(5883), 1,
      sym_attribute_specifier,
    ACTIONS(4200), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4198), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [175603] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5690), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(10519), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4080), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(4078), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [175655] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10521), 1,
      anon_sym_COMMA,
    ACTIONS(10523), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [175751] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9494), 1,
      anon_sym_STAR,
    ACTIONS(9496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9498), 1,
      anon_sym_AMP,
    STATE(3800), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8013), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8106), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [175825] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5690), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(10519), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4095), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(4093), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [175877] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10453), 1,
      anon_sym_COMMA,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10479), 1,
      anon_sym_QMARK,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    ACTIONS(10525), 1,
      anon_sym_COLON,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [175973] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9470), 1,
      anon_sym_STAR,
    ACTIONS(9472), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9474), 1,
      anon_sym_AMP,
    ACTIONS(9578), 1,
      anon_sym___attribute,
    STATE(4172), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8172), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9576), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [176049] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5690), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(10527), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2913), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2915), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [176101] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10530), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [176197] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9484), 1,
      anon_sym_STAR,
    ACTIONS(9486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9488), 1,
      anon_sym_AMP,
    ACTIONS(9578), 1,
      anon_sym___attribute,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4265), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8040), 1,
      sym__abstract_declarator,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9576), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [176273] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(7412), 1,
      anon_sym___attribute,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9484), 1,
      anon_sym_STAR,
    ACTIONS(9486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9488), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4265), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8051), 1,
      sym__abstract_declarator,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [176349] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9484), 1,
      anon_sym_STAR,
    ACTIONS(9486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9488), 1,
      anon_sym_AMP,
    ACTIONS(9584), 1,
      anon_sym___attribute,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4265), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8043), 1,
      sym__abstract_declarator,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9582), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [176425] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(8108), 1,
      anon_sym___attribute,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9484), 1,
      anon_sym_STAR,
    ACTIONS(9486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9488), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4265), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8053), 1,
      sym__abstract_declarator,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8106), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [176501] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(10534), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [176597] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7412), 1,
      anon_sym___attribute,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9470), 1,
      anon_sym_STAR,
    ACTIONS(9472), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9474), 1,
      anon_sym_AMP,
    STATE(4172), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8042), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [176673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3012), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [176721] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10177), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [176815] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8243), 1,
      anon_sym_DASH_GT,
    ACTIONS(8245), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10285), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6182), 1,
      sym_ref_qualifier,
    STATE(7145), 1,
      sym__function_attributes_end,
    STATE(7436), 1,
      sym_trailing_return_type,
    STATE(7624), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8183), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6545), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [176909] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    STATE(6039), 1,
      sym_attribute_specifier,
    ACTIONS(4107), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4109), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [176963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2881), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2883), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [177011] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9470), 1,
      anon_sym_STAR,
    ACTIONS(9472), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9474), 1,
      anon_sym_AMP,
    ACTIONS(9584), 1,
      anon_sym___attribute,
    STATE(4172), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8012), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9582), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [177087] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(8108), 1,
      anon_sym___attribute,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9470), 1,
      anon_sym_STAR,
    ACTIONS(9472), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9474), 1,
      anon_sym_AMP,
    STATE(4172), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8044), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8106), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [177163] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10453), 1,
      anon_sym_COMMA,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10479), 1,
      anon_sym_QMARK,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    ACTIONS(10536), 1,
      anon_sym_COLON,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [177259] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    STATE(5981), 1,
      sym_attribute_specifier,
    ACTIONS(4010), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4008), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [177313] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9464), 1,
      anon_sym_STAR,
    ACTIONS(9466), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9468), 1,
      anon_sym_AMP,
    STATE(3551), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8052), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9582), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [177387] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7794), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(7796), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [177449] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10538), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177543] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10540), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [177639] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7771), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [177711] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    STATE(5938), 1,
      sym_attribute_specifier,
    ACTIONS(4014), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4012), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [177765] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    STATE(5944), 1,
      sym_attribute_specifier,
    ACTIONS(4004), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4002), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [177819] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8290), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177909] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10542), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [178003] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    STATE(325), 1,
      sym_attribute_specifier,
    STATE(6390), 1,
      sym_field_declaration_list,
    STATE(9581), 1,
      sym_virtual_specifier,
    STATE(10664), 1,
      sym_base_class_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2893), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2895), 27,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [178069] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10544), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [178165] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7771), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(7773), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [178231] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5730), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(10546), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4113), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(4111), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [178283] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10453), 1,
      anon_sym_COMMA,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10479), 1,
      anon_sym_QMARK,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    ACTIONS(10548), 1,
      anon_sym_COLON,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [178379] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5738), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(10550), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4051), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(4053), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [178431] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5778), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(10552), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4166), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(4164), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [178483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5783), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(10554), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4180), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(4178), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [178535] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9710), 1,
      anon_sym_LBRACK,
    STATE(5888), 1,
      sym_new_declarator,
    ACTIONS(7713), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7715), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [178587] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10556), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [178681] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7771), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(7773), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [178743] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10165), 1,
      anon_sym_LT,
    STATE(5227), 1,
      sym_template_argument_list,
    ACTIONS(2229), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2222), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [178797] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9464), 1,
      anon_sym_STAR,
    ACTIONS(9466), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9468), 1,
      anon_sym_AMP,
    STATE(3551), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8048), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8106), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [178871] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6761), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_LPAREN2,
    ACTIONS(7481), 1,
      anon_sym_LBRACK,
    ACTIONS(2181), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(2170), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [178925] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5690), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(10519), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3997), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(3995), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [178977] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10165), 1,
      anon_sym_LT,
    STATE(5227), 1,
      sym_template_argument_list,
    ACTIONS(2408), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2410), 29,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [179031] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(9951), 1,
      anon_sym_LBRACE,
    ACTIONS(10558), 1,
      anon_sym_COLON,
    STATE(5513), 1,
      sym__enum_base_clause,
    STATE(5701), 1,
      sym_enumerator_list,
    STATE(5998), 1,
      sym_attribute_specifier,
    ACTIONS(3478), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3480), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [179093] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10453), 1,
      anon_sym_COMMA,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10479), 1,
      anon_sym_QMARK,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    ACTIONS(10560), 1,
      anon_sym_COLON,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [179189] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    STATE(6053), 1,
      sym_attribute_specifier,
    ACTIONS(4091), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4089), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [179243] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(9951), 1,
      anon_sym_LBRACE,
    ACTIONS(10558), 1,
      anon_sym_COLON,
    STATE(5593), 1,
      sym__enum_base_clause,
    STATE(5806), 1,
      sym_enumerator_list,
    STATE(5884), 1,
      sym_attribute_specifier,
    ACTIONS(3502), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3504), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [179305] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9550), 1,
      anon_sym_LT,
    STATE(5227), 1,
      sym_template_argument_list,
    STATE(5687), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9940), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2176), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2168), 25,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [179363] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9333), 1,
      anon_sym___attribute,
    ACTIONS(9831), 1,
      anon_sym_STAR,
    ACTIONS(9833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9835), 1,
      anon_sym_AMP,
    ACTIONS(9851), 1,
      anon_sym_DOT,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4273), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8755), 1,
      sym__abstract_declarator,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6353), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9331), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [179443] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5690), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(10519), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4100), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(4102), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [179495] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8286), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [179585] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5690), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(10519), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4187), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(4185), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [179637] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5684), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(10562), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2972), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2974), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [179689] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8243), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10285), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10429), 1,
      anon_sym_requires,
    ACTIONS(10564), 1,
      anon_sym_where,
    STATE(6174), 1,
      sym_ref_qualifier,
    STATE(7085), 1,
      sym__function_attributes_end,
    STATE(7419), 1,
      sym_trailing_return_type,
    STATE(7624), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10426), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7874), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6543), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [179783] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10567), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [179879] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_GT2,
  [179967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4250), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4248), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [180015] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7913), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [180109] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8294), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [180199] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8276), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [180293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2936), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2938), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [180341] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10569), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [180437] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10571), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [180533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2940), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2942), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [180581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2994), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [180629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2996), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2998), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [180677] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10573), 1,
      anon_sym_COMMA,
    ACTIONS(10575), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [180773] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9464), 1,
      anon_sym_STAR,
    ACTIONS(9466), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9468), 1,
      anon_sym_AMP,
    STATE(3551), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8089), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [180847] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10165), 1,
      anon_sym_LT,
    STATE(5227), 1,
      sym_template_argument_list,
    ACTIONS(2410), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(2408), 33,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [180901] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10165), 1,
      anon_sym_LT,
    STATE(5227), 1,
      sym_template_argument_list,
    ACTIONS(2222), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(2229), 33,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [180955] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8252), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [181045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2946), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2948), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [181093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2962), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2964), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [181141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2950), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2952), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [181189] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7771), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [181251] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10453), 1,
      anon_sym_COMMA,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10479), 1,
      anon_sym_QMARK,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    ACTIONS(10577), 1,
      anon_sym_COLON,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [181347] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7794), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7796), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [181409] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7826), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(7828), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [181469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3052), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3054), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [181517] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10579), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [181611] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9147), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [181705] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT2,
  [181791] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9556), 1,
      anon_sym_DOT,
    ACTIONS(9764), 1,
      anon_sym_STAR,
    ACTIONS(9766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9768), 1,
      anon_sym_AMP,
    STATE(3883), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8691), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6279), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9323), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_requires,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [181869] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10491), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [181963] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10581), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [182059] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10583), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [182155] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7771), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [182221] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9333), 1,
      anon_sym___attribute,
    ACTIONS(9758), 1,
      anon_sym_DOT,
    ACTIONS(9821), 1,
      anon_sym_STAR,
    ACTIONS(9823), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9825), 1,
      anon_sym_AMP,
    STATE(4120), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8639), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6296), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9331), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_GT2,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [182301] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7773), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
  [182389] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5690), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(10519), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4062), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(4064), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [182441] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10585), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [182537] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10587), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [182631] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7773), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [182717] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9556), 1,
      anon_sym_DOT,
    ACTIONS(9841), 1,
      anon_sym_STAR,
    ACTIONS(9843), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9845), 1,
      anon_sym_AMP,
    STATE(3767), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8688), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6275), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9331), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [182795] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5690), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(10519), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4071), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(4073), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [182847] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9325), 1,
      anon_sym___attribute,
    ACTIONS(9831), 1,
      anon_sym_STAR,
    ACTIONS(9833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9835), 1,
      anon_sym_AMP,
    ACTIONS(9851), 1,
      anon_sym_DOT,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4273), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8733), 1,
      sym__abstract_declarator,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6348), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9323), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [182927] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10102), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [183021] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10491), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [183115] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10491), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [183209] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7771), 1,
      anon_sym_PIPE,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7773), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [183293] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8286), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [183383] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10479), 1,
      anon_sym_QMARK,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7913), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [183477] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7771), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [183543] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7773), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
  [183631] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7773), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [183717] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7771), 1,
      anon_sym_PIPE,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7773), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [183801] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7771), 1,
      anon_sym_PIPE,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7773), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [183883] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7771), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7773), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [183961] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7771), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7773), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [184037] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [184109] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7771), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [184177] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7771), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [184247] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8294), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [184337] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10479), 1,
      anon_sym_QMARK,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8270), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [184431] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8290), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [184521] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10479), 1,
      anon_sym_QMARK,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8276), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [184615] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10589), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [184709] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    STATE(5956), 1,
      sym_attribute_specifier,
    ACTIONS(4156), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4154), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [184763] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(284), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4078), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(10591), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4080), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [184815] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8252), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [184905] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9556), 1,
      anon_sym_DOT,
    ACTIONS(9841), 1,
      anon_sym_STAR,
    ACTIONS(9843), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9845), 1,
      anon_sym_AMP,
    STATE(3767), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8664), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6269), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9323), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [184983] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8264), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [185073] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7771), 1,
      anon_sym_PIPE,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7773), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [185155] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(284), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4093), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(10591), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4095), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [185207] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    STATE(5894), 1,
      sym_attribute_specifier,
    ACTIONS(4087), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4085), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [185261] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10593), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [185357] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10595), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [185451] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9325), 1,
      anon_sym___attribute,
    ACTIONS(9758), 1,
      anon_sym_DOT,
    ACTIONS(9821), 1,
      anon_sym_STAR,
    ACTIONS(9823), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9825), 1,
      anon_sym_AMP,
    STATE(4120), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8659), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6291), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9323), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_GT2,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [185531] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5825), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4111), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(10597), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4113), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [185583] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5826), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4053), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(10599), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4051), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [185635] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7771), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7773), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [185713] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(253), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2354), 1,
      anon_sym_enum,
    ACTIONS(2356), 1,
      anon_sym_class,
    ACTIONS(2358), 1,
      anon_sym_struct,
    ACTIONS(2360), 1,
      anon_sym_union,
    ACTIONS(2384), 1,
      anon_sym_typename,
    ACTIONS(2396), 1,
      anon_sym_interface,
    ACTIONS(2398), 1,
      anon_sym_extension,
    ACTIONS(2470), 1,
      sym_primitive_type,
    ACTIONS(5525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10601), 1,
      sym_identifier,
    ACTIONS(10603), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10607), 1,
      anon_sym_EQ,
    STATE(2717), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2888), 1,
      sym_qualified_type_identifier,
    STATE(3067), 1,
      sym_type_specifier,
    STATE(8769), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    ACTIONS(10605), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(2842), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(251), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(203), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2839), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [185805] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10020), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [185901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2548), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2550), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [185949] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10609), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [186043] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9170), 1,
      anon_sym_COMMA,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10611), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [186139] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(284), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3995), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(10591), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3997), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [186191] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(284), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4102), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(10591), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4100), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [186243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3026), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [186291] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5841), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4164), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(10613), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4166), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [186343] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7836), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7838), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [186403] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7804), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7806), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [186465] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5842), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4178), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(10615), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4180), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [186517] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7852), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7854), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [186579] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(284), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4185), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(10591), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4187), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [186631] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7826), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7828), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [186691] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5807), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2974), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(10617), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2972), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [186743] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7771), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7773), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [186819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2552), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2554), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [186867] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(3058), 1,
      sym_attribute_specifier,
    STATE(6522), 1,
      sym_field_declaration_list,
    STATE(9589), 1,
      sym_virtual_specifier,
    STATE(10715), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8129), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(2895), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(2893), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [186931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3032), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3034), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [186979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3036), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3038), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [187027] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(284), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4064), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(10591), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4062), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [187079] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(284), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4073), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(10591), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4071), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [187131] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [187203] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    STATE(5909), 1,
      sym_attribute_specifier,
    ACTIONS(4176), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4174), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [187257] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10453), 1,
      anon_sym_COMMA,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10479), 1,
      anon_sym_QMARK,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    ACTIONS(10619), 1,
      anon_sym_COLON,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [187353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3040), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3042), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [187401] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10621), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [187495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3044), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3046), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [187543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3048), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3050), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [187591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3040), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3042), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [187639] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10623), 1,
      anon_sym_COMMA,
    ACTIONS(10625), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [187735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3040), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3042), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [187783] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7771), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
  [187851] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10453), 1,
      anon_sym_COMMA,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10479), 1,
      anon_sym_QMARK,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    ACTIONS(10627), 1,
      anon_sym_COLON,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [187947] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10453), 1,
      anon_sym_COMMA,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10479), 1,
      anon_sym_QMARK,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    ACTIONS(10629), 1,
      anon_sym_COLON,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [188043] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(7913), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [188137] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10453), 1,
      anon_sym_COMMA,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10479), 1,
      anon_sym_QMARK,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    ACTIONS(10631), 1,
      anon_sym_COLON,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [188233] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7771), 1,
      anon_sym_PIPE,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_GT2,
  [188317] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7771), 1,
      anon_sym_PIPE,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_GT2,
  [188399] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10453), 1,
      anon_sym_COMMA,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10479), 1,
      anon_sym_QMARK,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    ACTIONS(10633), 1,
      anon_sym_COLON,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [188495] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(7771), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_GT2,
  [188573] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(7771), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [188649] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10542), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [188743] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(7771), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7773), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [188817] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9464), 1,
      anon_sym_STAR,
    ACTIONS(9466), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9468), 1,
      anon_sym_AMP,
    STATE(3551), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8035), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9576), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [188891] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10453), 1,
      anon_sym_COMMA,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10479), 1,
      anon_sym_QMARK,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    ACTIONS(10635), 1,
      anon_sym_COLON,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [188987] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7771), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(7773), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [189055] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10453), 1,
      anon_sym_COMMA,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10479), 1,
      anon_sym_QMARK,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    ACTIONS(10637), 1,
      anon_sym_COLON,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [189151] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7804), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(7806), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [189213] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    ACTIONS(10053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10061), 1,
      anon_sym_SLASH,
    ACTIONS(10067), 1,
      anon_sym_PIPE,
    ACTIONS(10071), 1,
      anon_sym_AMP,
    ACTIONS(10077), 1,
      anon_sym_LT_LT,
    ACTIONS(10079), 1,
      anon_sym_GT_GT,
    ACTIONS(10081), 1,
      anon_sym_QMARK,
    ACTIONS(10085), 1,
      anon_sym_bitor,
    ACTIONS(10087), 1,
      anon_sym_bitand,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10057), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10059), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10063), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10065), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10069), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10587), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(10073), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10083), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(10075), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [189307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2954), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2956), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [189355] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    ACTIONS(8943), 1,
      anon_sym_LBRACK,
    ACTIONS(8959), 1,
      anon_sym_DOT,
    STATE(4705), 1,
      sym_argument_list,
    STATE(4706), 1,
      sym_subscript_argument_list,
    ACTIONS(8961), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(10089), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7852), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(7854), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_GT2,
  [189417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2958), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2960), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [189465] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(8264), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [189555] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10639), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [189648] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9325), 1,
      sym_identifier,
    ACTIONS(9895), 1,
      anon_sym_STAR,
    ACTIONS(9897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9899), 1,
      anon_sym_AMP,
    ACTIONS(9921), 1,
      anon_sym_DOT,
    STATE(3869), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8860), 1,
      sym__abstract_declarator,
    ACTIONS(9540), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6402), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9323), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(9923), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9296), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [189725] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8310), 1,
      anon_sym_DASH_GT,
    ACTIONS(8326), 1,
      anon_sym_requires,
    ACTIONS(8328), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10285), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6278), 1,
      sym_ref_qualifier,
    STATE(7296), 1,
      sym__function_attributes_end,
    STATE(7469), 1,
      sym_trailing_return_type,
    STATE(7624), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8395), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6591), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [189818] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 1,
      sym_primitive_type,
    STATE(2881), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7112), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4121), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(4124), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [189871] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10641), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [189964] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10643), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [190057] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6617), 1,
      anon_sym_RBRACK,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [190150] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10645), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [190243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2960), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2958), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [190290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2964), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2962), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [190337] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    ACTIONS(10647), 1,
      anon_sym_RBRACK,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [190430] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10649), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [190523] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10651), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [190616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7822), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7824), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [190663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8332), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(8330), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      sym_literal_suffix,
  [190710] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    ACTIONS(10653), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10655), 1,
      anon_sym_RBRACK,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [190803] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    ACTIONS(10657), 1,
      anon_sym_RBRACK,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [190896] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10479), 1,
      anon_sym_QMARK,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    ACTIONS(10659), 1,
      anon_sym_COLON,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [190989] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(5519), 1,
      anon_sym_STAR,
    ACTIONS(5521), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5523), 1,
      anon_sym_AMP,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9851), 1,
      anon_sym_DOT,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8875), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6401), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9323), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [191066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3018), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3016), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [191113] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10661), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [191206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2934), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2932), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [191253] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10663), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [191346] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10665), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [191439] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10667), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [191532] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6559), 1,
      anon_sym_RBRACK,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [191625] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10669), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [191718] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9524), 1,
      anon_sym_STAR,
    ACTIONS(9526), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9528), 1,
      anon_sym_AMP,
    STATE(3856), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8213), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9576), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [191791] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10671), 1,
      anon_sym_RBRACE,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [191884] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6537), 1,
      anon_sym_RBRACK,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [191977] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10479), 1,
      anon_sym_QMARK,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    ACTIONS(10673), 1,
      anon_sym_COLON,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [192070] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10675), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [192163] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    ACTIONS(10653), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10677), 1,
      anon_sym_RBRACK,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [192256] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10679), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [192349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3030), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3028), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [192396] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10681), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [192489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3042), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3040), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [192536] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6329), 1,
      sym_alignas_qualifier,
    ACTIONS(8564), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9827), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(8560), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9829), 14,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [192591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3026), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3024), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [192638] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10683), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [192731] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10685), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [192824] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6598), 1,
      anon_sym_RBRACK,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [192917] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10687), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [193010] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10689), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [193103] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6609), 1,
      anon_sym_RBRACK,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [193196] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10691), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [193289] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10693), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [193382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2883), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2881), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [193429] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10695), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [193522] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10697), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [193615] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6541), 1,
      anon_sym_RBRACK,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [193708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2948), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2946), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [193755] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10699), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [193848] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9530), 1,
      anon_sym_STAR,
    ACTIONS(9532), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9534), 1,
      anon_sym_AMP,
    STATE(3857), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8310), 1,
      sym__abstract_declarator,
    ACTIONS(9540), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7410), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(7412), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9296), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [193921] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10179), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [194014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2550), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2548), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [194061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3042), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3040), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [194108] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10701), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [194201] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10703), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [194294] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10705), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [194387] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10707), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [194480] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10709), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [194573] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 1,
      anon_sym_RBRACK,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [194666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2930), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2928), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [194713] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    ACTIONS(10711), 1,
      anon_sym_RBRACK,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [194806] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10713), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [194899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2934), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2932), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [194946] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8310), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10285), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10715), 1,
      anon_sym_requires,
    ACTIONS(10718), 1,
      anon_sym_where,
    STATE(6317), 1,
      sym_ref_qualifier,
    STATE(7231), 1,
      sym__function_attributes_end,
    STATE(7544), 1,
      sym_trailing_return_type,
    STATE(7624), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10426), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7913), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6694), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [195039] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(5519), 1,
      anon_sym_STAR,
    ACTIONS(5521), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5523), 1,
      anon_sym_AMP,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9851), 1,
      anon_sym_DOT,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8837), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6381), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9331), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [195116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3034), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3032), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [195163] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9518), 1,
      anon_sym_STAR,
    ACTIONS(9520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9522), 1,
      anon_sym_AMP,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8209), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9576), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [195236] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10721), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [195329] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10723), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [195422] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10725), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [195515] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6575), 1,
      anon_sym_RBRACK,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [195608] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10727), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [195701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2982), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2980), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [195748] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10729), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [195841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2952), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2950), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [195888] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9524), 1,
      anon_sym_STAR,
    ACTIONS(9526), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9528), 1,
      anon_sym_AMP,
    STATE(3856), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8195), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8106), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [195961] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10731), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [196054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3056), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [196101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2986), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2984), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [196148] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9530), 1,
      anon_sym_STAR,
    ACTIONS(9532), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9534), 1,
      anon_sym_AMP,
    STATE(3857), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8307), 1,
      sym__abstract_declarator,
    ACTIONS(9540), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9576), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(9578), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9296), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [196221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3022), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3020), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [196268] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6625), 1,
      anon_sym_RBRACK,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [196361] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10733), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [196454] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10735), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [196547] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10737), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [196640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2990), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2988), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [196687] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10739), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [196780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3012), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [196827] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6603), 1,
      anon_sym_RBRACK,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [196920] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6329), 1,
      sym_alignas_qualifier,
    ACTIONS(10744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3681), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(10741), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(3683), 14,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [196975] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6336), 1,
      sym_alignas_qualifier,
    ACTIONS(10750), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3683), 9,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(3681), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(10747), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [197030] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(210), 1,
      sym_template_argument_list,
    STATE(5812), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2168), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9919), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2176), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [197087] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6643), 1,
      anon_sym_RBRACK,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [197180] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10753), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [197273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2992), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [197320] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10755), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [197413] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10757), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [197506] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9208), 1,
      sym_literal_suffix,
    ACTIONS(2170), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(2181), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
  [197555] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9327), 1,
      anon_sym_DOT,
    ACTIONS(9329), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4252), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4254), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [197606] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10759), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [197699] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6641), 1,
      anon_sym_RBRACK,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [197792] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9518), 1,
      anon_sym_STAR,
    ACTIONS(9520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9522), 1,
      anon_sym_AMP,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8218), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [197865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2926), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2924), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [197912] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10761), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [198005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3052), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [198052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3002), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3000), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [198099] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      anon_sym_RBRACK,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [198192] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9480), 1,
      anon_sym_DOT,
    ACTIONS(4252), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4254), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [198243] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6508), 1,
      anon_sym_RBRACK,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [198336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2938), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2936), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [198383] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10763), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [198476] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10765), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [198569] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10767), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [198662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2552), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [198709] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10769), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [198802] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10479), 1,
      anon_sym_QMARK,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    ACTIONS(10771), 1,
      anon_sym_COLON,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [198895] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9327), 1,
      anon_sym_DOT,
    ACTIONS(9329), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4244), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4246), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [198946] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10773), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [199039] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10775), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [199132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3038), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3036), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [199179] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10777), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [199272] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9333), 1,
      sym_identifier,
    ACTIONS(9895), 1,
      anon_sym_STAR,
    ACTIONS(9897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9899), 1,
      anon_sym_AMP,
    ACTIONS(9921), 1,
      anon_sym_DOT,
    STATE(3869), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8864), 1,
      sym__abstract_declarator,
    ACTIONS(9540), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6376), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9331), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(9923), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9296), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [199349] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8172), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    STATE(7031), 1,
      sym__function_attributes_end,
    STATE(7303), 1,
      sym_trailing_return_type,
    STATE(7549), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8170), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6430), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [199436] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10779), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [199529] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10479), 1,
      anon_sym_QMARK,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    ACTIONS(10781), 1,
      anon_sym_COLON,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [199622] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10783), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [199715] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2212), 1,
      sym__fold_operator,
    ACTIONS(10787), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(10785), 25,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [199764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2883), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2881), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [199811] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6555), 1,
      anon_sym_RBRACK,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [199904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3006), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3004), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [199951] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10789), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [200044] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10791), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [200137] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10793), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [200230] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    ACTIONS(10795), 1,
      anon_sym_RBRACK,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [200323] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10797), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [200416] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10799), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [200509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3010), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3008), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [200556] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10801), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [200649] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6615), 1,
      anon_sym_RBRACK,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [200742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2998), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2996), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [200789] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    ACTIONS(10803), 1,
      anon_sym_RBRACK,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [200882] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10805), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [200975] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9524), 1,
      anon_sym_STAR,
    ACTIONS(9526), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9528), 1,
      anon_sym_AMP,
    STATE(3856), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8288), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [201048] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9530), 1,
      anon_sym_STAR,
    ACTIONS(9532), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9534), 1,
      anon_sym_AMP,
    STATE(3857), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8179), 1,
      sym__abstract_declarator,
    ACTIONS(9540), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8106), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(8108), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9296), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [201121] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10807), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [201214] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10809), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [201307] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10811), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [201400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3042), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3040), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [201447] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10813), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [201540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2956), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2954), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [201587] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10815), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [201680] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6523), 1,
      anon_sym_RBRACK,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [201773] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10817), 1,
      anon_sym_COMMA,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [201866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2940), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [201913] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9530), 1,
      anon_sym_STAR,
    ACTIONS(9532), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9534), 1,
      anon_sym_AMP,
    STATE(3857), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8178), 1,
      sym__abstract_declarator,
    ACTIONS(9540), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9582), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(9584), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9296), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [201986] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6629), 1,
      anon_sym_RBRACK,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [202079] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9524), 1,
      anon_sym_STAR,
    ACTIONS(9526), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9528), 1,
      anon_sym_AMP,
    STATE(3856), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8180), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9582), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [202152] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9518), 1,
      anon_sym_STAR,
    ACTIONS(9520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9522), 1,
      anon_sym_AMP,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8219), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9582), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [202225] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6557), 1,
      anon_sym_RBRACK,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [202318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2974), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2972), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [202365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2978), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2976), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [202412] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10819), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [202505] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10821), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [202598] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10031), 1,
      anon_sym_requires,
    ACTIONS(10034), 1,
      anon_sym_where,
    STATE(7040), 1,
      sym__function_attributes_end,
    STATE(7318), 1,
      sym_trailing_return_type,
    STATE(7549), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7724), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6452), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [202685] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8172), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    STATE(7032), 1,
      sym__function_attributes_end,
    STATE(7304), 1,
      sym_trailing_return_type,
    STATE(7537), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8173), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6421), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10823), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [202772] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6329), 1,
      sym_alignas_qualifier,
    ACTIONS(8564), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9508), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(8560), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9510), 14,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [202827] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(8915), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10459), 1,
      anon_sym_SLASH,
    ACTIONS(10465), 1,
      anon_sym_PIPE,
    ACTIONS(10469), 1,
      anon_sym_AMP,
    ACTIONS(10475), 1,
      anon_sym_GT_EQ,
    ACTIONS(10479), 1,
      anon_sym_QMARK,
    ACTIONS(10483), 1,
      anon_sym_bitor,
    ACTIONS(10485), 1,
      anon_sym_bitand,
    ACTIONS(10827), 1,
      anon_sym_COLON,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(8917), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10455), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10457), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10461), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10463), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10467), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10477), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10471), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10473), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10481), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [202920] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10829), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [203013] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    ACTIONS(10831), 1,
      anon_sym_RBRACK,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [203106] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    ACTIONS(10833), 1,
      anon_sym_RBRACK,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [203199] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(10838), 1,
      anon_sym_requires,
    ACTIONS(10841), 1,
      anon_sym_where,
    STATE(7041), 1,
      sym__function_attributes_end,
    STATE(7319), 1,
      sym_trailing_return_type,
    STATE(7537), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7725), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6456), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10823), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [203286] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10844), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [203379] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10846), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [203472] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10848), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [203565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3046), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3044), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [203612] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    ACTIONS(10850), 1,
      anon_sym_RBRACK,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [203705] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10852), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [203798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3050), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3048), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [203845] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10854), 1,
      anon_sym_RPAREN,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [203938] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10856), 1,
      anon_sym_COMMA,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [204031] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10858), 1,
      anon_sym_COMMA,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [204124] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10860), 1,
      anon_sym_COMMA,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [204217] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10862), 1,
      anon_sym_COMMA,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [204310] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10864), 1,
      anon_sym_COMMA,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [204403] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9518), 1,
      anon_sym_STAR,
    ACTIONS(9520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9522), 1,
      anon_sym_AMP,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8222), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8106), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [204476] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    ACTIONS(10866), 1,
      anon_sym_SEMI,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [204569] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6564), 1,
      anon_sym_RBRACK,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10112), 1,
      anon_sym_SLASH,
    ACTIONS(10118), 1,
      anon_sym_PIPE,
    ACTIONS(10122), 1,
      anon_sym_AMP,
    ACTIONS(10128), 1,
      anon_sym_GT_EQ,
    ACTIONS(10134), 1,
      anon_sym_QMARK,
    ACTIONS(10138), 1,
      anon_sym_bitor,
    ACTIONS(10140), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(10108), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10110), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10114), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10116), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10120), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(10130), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10124), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(10126), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10136), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
  [204662] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9480), 1,
      anon_sym_DOT,
    ACTIONS(4244), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4246), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [204713] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10868), 1,
      anon_sym_COMMA,
    ACTIONS(10870), 1,
      anon_sym_RBRACK,
    ACTIONS(2181), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(2170), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [204763] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    ACTIONS(10873), 1,
      sym_identifier,
    ACTIONS(10875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10879), 1,
      sym_primitive_type,
    ACTIONS(10881), 1,
      anon_sym_enum,
    ACTIONS(10883), 1,
      anon_sym_class,
    ACTIONS(10885), 1,
      anon_sym_struct,
    ACTIONS(10887), 1,
      anon_sym_union,
    ACTIONS(10891), 1,
      anon_sym_decltype,
    ACTIONS(10893), 1,
      anon_sym_typename,
    ACTIONS(10895), 1,
      anon_sym_interface,
    ACTIONS(10897), 1,
      anon_sym_extension,
    STATE(2788), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3650), 1,
      sym_type_specifier,
    STATE(3878), 1,
      sym_qualified_type_identifier,
    STATE(6323), 1,
      sym_argument_list,
    STATE(8655), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(3735), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10889), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10877), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3875), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [204851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8005), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(8007), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [204897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2170), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [204943] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8440), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10031), 1,
      anon_sym_requires,
    ACTIONS(10279), 1,
      anon_sym___attribute__,
    ACTIONS(10282), 1,
      anon_sym___attribute,
    ACTIONS(10899), 1,
      anon_sym_where,
    STATE(6368), 1,
      sym_ref_qualifier,
    STATE(7338), 1,
      sym__function_attributes_end,
    STATE(7515), 1,
      sym_trailing_return_type,
    STATE(7549), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7981), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6804), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
  [205035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6106), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4215), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [205081] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9570), 1,
      anon_sym_STAR,
    ACTIONS(9572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9574), 1,
      anon_sym_AMP,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4323), 1,
      sym_parameter_list,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8390), 1,
      sym__abstract_declarator,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6798), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9576), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [205153] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    STATE(5849), 1,
      sym_attribute_specifier,
    STATE(6532), 1,
      sym_field_declaration_list,
    STATE(9593), 1,
      sym_virtual_specifier,
    STATE(10727), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(2895), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2893), 22,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_requires,
      anon_sym_where,
  [205215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7951), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7953), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [205261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8023), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(8025), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [205307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7967), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7969), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [205353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7971), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7973), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [205399] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    ACTIONS(10902), 1,
      sym_identifier,
    ACTIONS(10904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10908), 1,
      sym_primitive_type,
    ACTIONS(10910), 1,
      anon_sym_enum,
    ACTIONS(10912), 1,
      anon_sym_class,
    ACTIONS(10914), 1,
      anon_sym_struct,
    ACTIONS(10916), 1,
      anon_sym_union,
    ACTIONS(10920), 1,
      anon_sym_decltype,
    ACTIONS(10922), 1,
      anon_sym_typename,
    ACTIONS(10924), 1,
      anon_sym_interface,
    ACTIONS(10926), 1,
      anon_sym_extension,
    STATE(2778), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3602), 1,
      sym_type_specifier,
    STATE(3787), 1,
      sym_qualified_type_identifier,
    STATE(6260), 1,
      sym_argument_list,
    STATE(8746), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(3704), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10918), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10906), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3774), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [205487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7955), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7957), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [205533] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_SEMI,
    ACTIONS(6761), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7475), 1,
      anon_sym_LPAREN2,
    ACTIONS(7481), 1,
      anon_sym_LBRACK,
    ACTIONS(2181), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(2170), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [205587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7877), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7879), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [205633] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(10014), 1,
      anon_sym_DOT,
    ACTIONS(10043), 1,
      anon_sym_STAR,
    ACTIONS(10045), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10047), 1,
      anon_sym_AMP,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4464), 1,
      sym_parameter_list,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8994), 1,
      sym__abstract_declarator,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6451), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9331), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10016), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [205709] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    ACTIONS(10928), 1,
      sym_identifier,
    ACTIONS(10930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10934), 1,
      sym_primitive_type,
    ACTIONS(10936), 1,
      anon_sym_enum,
    ACTIONS(10938), 1,
      anon_sym_class,
    ACTIONS(10940), 1,
      anon_sym_struct,
    ACTIONS(10942), 1,
      anon_sym_union,
    ACTIONS(10946), 1,
      anon_sym_decltype,
    ACTIONS(10948), 1,
      anon_sym_typename,
    ACTIONS(10950), 1,
      anon_sym_interface,
    ACTIONS(10952), 1,
      anon_sym_extension,
    STATE(3068), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4919), 1,
      sym_type_specifier,
    STATE(5066), 1,
      sym_qualified_type_identifier,
    STATE(6242), 1,
      sym_argument_list,
    STATE(8723), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(4993), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10944), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10932), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5063), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [205797] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8789), 1,
      anon_sym_STAR,
    ACTIONS(8791), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8793), 1,
      anon_sym_AMP,
    ACTIONS(10954), 1,
      sym_identifier,
    STATE(6851), 1,
      sym_ms_call_modifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7638), 1,
      sym__declarator,
    STATE(9240), 1,
      sym_type_hinted_declarator,
    STATE(9698), 1,
      sym_init_declarator,
    STATE(11397), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [205881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8057), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(8059), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [205927] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    ACTIONS(10928), 1,
      sym_identifier,
    ACTIONS(10930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10934), 1,
      sym_primitive_type,
    ACTIONS(10936), 1,
      anon_sym_enum,
    ACTIONS(10938), 1,
      anon_sym_class,
    ACTIONS(10940), 1,
      anon_sym_struct,
    ACTIONS(10942), 1,
      anon_sym_union,
    ACTIONS(10946), 1,
      anon_sym_decltype,
    ACTIONS(10948), 1,
      anon_sym_typename,
    ACTIONS(10950), 1,
      anon_sym_interface,
    ACTIONS(10952), 1,
      anon_sym_extension,
    STATE(3068), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4926), 1,
      sym_type_specifier,
    STATE(5066), 1,
      sym_qualified_type_identifier,
    STATE(6251), 1,
      sym_argument_list,
    STATE(8723), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(4993), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10944), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10932), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5063), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [206015] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10956), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6806), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6808), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [206063] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(3516), 1,
      anon_sym_LBRACE,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(10958), 1,
      anon_sym_COLON,
    STATE(321), 1,
      sym_attribute_specifier,
    STATE(6170), 1,
      sym__enum_base_clause,
    STATE(6388), 1,
      sym_enumerator_list,
    ACTIONS(3478), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3480), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [206123] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(3516), 1,
      anon_sym_LBRACE,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(10958), 1,
      anon_sym_COLON,
    STATE(298), 1,
      sym_attribute_specifier,
    STATE(6171), 1,
      sym__enum_base_clause,
    STATE(6394), 1,
      sym_enumerator_list,
    ACTIONS(3502), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3504), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [206183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7935), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7937), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [206229] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8789), 1,
      anon_sym_STAR,
    ACTIONS(8791), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8793), 1,
      anon_sym_AMP,
    ACTIONS(10954), 1,
      sym_identifier,
    STATE(6841), 1,
      sym_ms_call_modifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7644), 1,
      sym__declarator,
    STATE(9247), 1,
      sym_type_hinted_declarator,
    STATE(10077), 1,
      sym_init_declarator,
    STATE(11397), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [206313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7979), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7981), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [206359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8043), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(8045), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [206405] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    ACTIONS(10960), 1,
      sym_identifier,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10966), 1,
      sym_primitive_type,
    ACTIONS(10968), 1,
      anon_sym_enum,
    ACTIONS(10970), 1,
      anon_sym_class,
    ACTIONS(10972), 1,
      anon_sym_struct,
    ACTIONS(10974), 1,
      anon_sym_union,
    ACTIONS(10978), 1,
      anon_sym_decltype,
    ACTIONS(10980), 1,
      anon_sym_typename,
    ACTIONS(10982), 1,
      anon_sym_interface,
    ACTIONS(10984), 1,
      anon_sym_extension,
    STATE(3156), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5154), 1,
      sym_type_specifier,
    STATE(5351), 1,
      sym_qualified_type_identifier,
    STATE(6347), 1,
      sym_argument_list,
    STATE(8676), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(5307), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10976), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10964), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5350), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [206493] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    ACTIONS(10986), 1,
      sym_identifier,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10992), 1,
      sym_primitive_type,
    ACTIONS(10994), 1,
      anon_sym_enum,
    ACTIONS(10996), 1,
      anon_sym_class,
    ACTIONS(10998), 1,
      anon_sym_struct,
    ACTIONS(11000), 1,
      anon_sym_union,
    ACTIONS(11004), 1,
      anon_sym_decltype,
    ACTIONS(11006), 1,
      anon_sym_typename,
    ACTIONS(11008), 1,
      anon_sym_interface,
    ACTIONS(11010), 1,
      anon_sym_extension,
    STATE(2739), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3106), 1,
      sym_type_specifier,
    STATE(3192), 1,
      sym_qualified_type_identifier,
    STATE(6304), 1,
      sym_argument_list,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(3140), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(11002), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10990), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3189), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [206581] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    ACTIONS(10986), 1,
      sym_identifier,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10992), 1,
      sym_primitive_type,
    ACTIONS(10994), 1,
      anon_sym_enum,
    ACTIONS(10996), 1,
      anon_sym_class,
    ACTIONS(10998), 1,
      anon_sym_struct,
    ACTIONS(11000), 1,
      anon_sym_union,
    ACTIONS(11004), 1,
      anon_sym_decltype,
    ACTIONS(11006), 1,
      anon_sym_typename,
    ACTIONS(11008), 1,
      anon_sym_interface,
    ACTIONS(11010), 1,
      anon_sym_extension,
    STATE(2739), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3100), 1,
      sym_type_specifier,
    STATE(3192), 1,
      sym_qualified_type_identifier,
    STATE(6310), 1,
      sym_argument_list,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(3140), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(11002), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10990), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3189), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [206669] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    ACTIONS(10902), 1,
      sym_identifier,
    ACTIONS(10904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10908), 1,
      sym_primitive_type,
    ACTIONS(10910), 1,
      anon_sym_enum,
    ACTIONS(10912), 1,
      anon_sym_class,
    ACTIONS(10914), 1,
      anon_sym_struct,
    ACTIONS(10916), 1,
      anon_sym_union,
    ACTIONS(10920), 1,
      anon_sym_decltype,
    ACTIONS(10922), 1,
      anon_sym_typename,
    ACTIONS(10924), 1,
      anon_sym_interface,
    ACTIONS(10926), 1,
      anon_sym_extension,
    STATE(2778), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3601), 1,
      sym_type_specifier,
    STATE(3787), 1,
      sym_qualified_type_identifier,
    STATE(6294), 1,
      sym_argument_list,
    STATE(8746), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(3704), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10918), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10906), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3774), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [206757] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9851), 1,
      anon_sym_DOT,
    ACTIONS(10004), 1,
      anon_sym_STAR,
    ACTIONS(10006), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10008), 1,
      anon_sym_AMP,
    STATE(4446), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8942), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6467), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9323), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_requires,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [206833] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8789), 1,
      anon_sym_STAR,
    ACTIONS(8791), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8793), 1,
      anon_sym_AMP,
    ACTIONS(10954), 1,
      sym_identifier,
    STATE(6821), 1,
      sym_ms_call_modifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7648), 1,
      sym__declarator,
    STATE(9289), 1,
      sym_type_hinted_declarator,
    STATE(10189), 1,
      sym_init_declarator,
    STATE(11397), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [206917] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    STATE(6369), 1,
      sym_ref_qualifier,
    STATE(7471), 1,
      sym__function_attributes_end,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7641), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8607), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6759), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [207009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7939), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7941), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [207055] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    ACTIONS(10960), 1,
      sym_identifier,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10966), 1,
      sym_primitive_type,
    ACTIONS(10968), 1,
      anon_sym_enum,
    ACTIONS(10970), 1,
      anon_sym_class,
    ACTIONS(10972), 1,
      anon_sym_struct,
    ACTIONS(10974), 1,
      anon_sym_union,
    ACTIONS(10978), 1,
      anon_sym_decltype,
    ACTIONS(10980), 1,
      anon_sym_typename,
    ACTIONS(10982), 1,
      anon_sym_interface,
    ACTIONS(10984), 1,
      anon_sym_extension,
    STATE(3156), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5175), 1,
      sym_type_specifier,
    STATE(5351), 1,
      sym_qualified_type_identifier,
    STATE(6249), 1,
      sym_argument_list,
    STATE(8676), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(5307), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10976), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10964), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5350), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [207143] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8789), 1,
      anon_sym_STAR,
    ACTIONS(8791), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8793), 1,
      anon_sym_AMP,
    ACTIONS(10954), 1,
      sym_identifier,
    STATE(6859), 1,
      sym_ms_call_modifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7738), 1,
      sym__declarator,
    STATE(9310), 1,
      sym_type_hinted_declarator,
    STATE(10300), 1,
      sym_init_declarator,
    STATE(11397), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [207227] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      sym_literal_suffix,
    ACTIONS(2181), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
    ACTIONS(2170), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [207277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7881), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7883), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [207323] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8789), 1,
      anon_sym_STAR,
    ACTIONS(8791), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8793), 1,
      anon_sym_AMP,
    ACTIONS(10954), 1,
      sym_identifier,
    STATE(6835), 1,
      sym_ms_call_modifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7710), 1,
      sym__declarator,
    STATE(9218), 1,
      sym_type_hinted_declarator,
    STATE(9849), 1,
      sym_init_declarator,
    STATE(11397), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [207407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7885), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7887), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [207453] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10031), 1,
      anon_sym_requires,
    ACTIONS(11012), 1,
      anon_sym_where,
    STATE(6360), 1,
      sym_ref_qualifier,
    STATE(7494), 1,
      sym__function_attributes_end,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7714), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8285), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6800), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [207545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7893), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7895), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [207591] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8789), 1,
      anon_sym_STAR,
    ACTIONS(8791), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8793), 1,
      anon_sym_AMP,
    ACTIONS(10954), 1,
      sym_identifier,
    STATE(6869), 1,
      sym_ms_call_modifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7640), 1,
      sym__declarator,
    STATE(9272), 1,
      sym_type_hinted_declarator,
    STATE(9949), 1,
      sym_init_declarator,
    STATE(11397), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [207675] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 1,
      anon_sym___attribute__,
    ACTIONS(7348), 1,
      anon_sym___attribute,
    ACTIONS(7414), 1,
      anon_sym_LBRACE,
    ACTIONS(11015), 1,
      anon_sym_COLON,
    STATE(3048), 1,
      sym_attribute_specifier,
    STATE(3139), 1,
      sym__enum_base_clause,
    STATE(3188), 1,
      sym_enumerator_list,
    ACTIONS(3478), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(3480), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [207735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8053), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(8055), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [207781] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9570), 1,
      anon_sym_STAR,
    ACTIONS(9572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9574), 1,
      anon_sym_AMP,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4323), 1,
      sym_parameter_list,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8394), 1,
      sym__abstract_declarator,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6798), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [207853] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10996), 1,
      anon_sym_class,
    ACTIONS(10998), 1,
      anon_sym_struct,
    ACTIONS(11000), 1,
      anon_sym_union,
    ACTIONS(11004), 1,
      anon_sym_decltype,
    ACTIONS(11008), 1,
      anon_sym_interface,
    ACTIONS(11010), 1,
      anon_sym_extension,
    ACTIONS(11017), 1,
      sym_identifier,
    ACTIONS(11021), 1,
      sym_primitive_type,
    ACTIONS(11023), 1,
      anon_sym_enum,
    ACTIONS(11025), 1,
      anon_sym_typename,
    STATE(2735), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3106), 1,
      sym_type_specifier,
    STATE(3192), 1,
      sym_qualified_type_identifier,
    STATE(6270), 1,
      sym_argument_list,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(3140), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(11002), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11019), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3189), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [207941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7866), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7868), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [207987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8001), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(8003), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [208033] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10037), 1,
      anon_sym_LBRACE,
    ACTIONS(11027), 1,
      anon_sym_COLON,
    STATE(5425), 1,
      sym__enum_base_clause,
    STATE(5611), 1,
      sym_enumerator_list,
    STATE(5840), 1,
      sym_attribute_specifier,
    ACTIONS(9872), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(3480), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(3478), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [208091] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10996), 1,
      anon_sym_class,
    ACTIONS(10998), 1,
      anon_sym_struct,
    ACTIONS(11000), 1,
      anon_sym_union,
    ACTIONS(11004), 1,
      anon_sym_decltype,
    ACTIONS(11008), 1,
      anon_sym_interface,
    ACTIONS(11010), 1,
      anon_sym_extension,
    ACTIONS(11017), 1,
      sym_identifier,
    ACTIONS(11021), 1,
      sym_primitive_type,
    ACTIONS(11023), 1,
      anon_sym_enum,
    ACTIONS(11025), 1,
      anon_sym_typename,
    STATE(2735), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3100), 1,
      sym_type_specifier,
    STATE(3192), 1,
      sym_qualified_type_identifier,
    STATE(6289), 1,
      sym_argument_list,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(3140), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(11002), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11019), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3189), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [208179] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10037), 1,
      anon_sym_LBRACE,
    ACTIONS(11027), 1,
      anon_sym_COLON,
    STATE(5426), 1,
      sym__enum_base_clause,
    STATE(5615), 1,
      sym_enumerator_list,
    STATE(5761), 1,
      sym_attribute_specifier,
    ACTIONS(9872), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(3504), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(3502), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [208237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7911), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7913), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [208283] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9570), 1,
      anon_sym_STAR,
    ACTIONS(9572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9574), 1,
      anon_sym_AMP,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4323), 1,
      sym_parameter_list,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8396), 1,
      sym__abstract_declarator,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6798), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9582), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [208355] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10165), 1,
      anon_sym_LT,
    STATE(5227), 1,
      sym_template_argument_list,
    STATE(5687), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9940), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2176), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2168), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [208411] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8548), 1,
      sym_primitive_type,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    ACTIONS(11029), 1,
      sym_identifier,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11035), 1,
      anon_sym_enum,
    ACTIONS(11037), 1,
      anon_sym_class,
    ACTIONS(11039), 1,
      anon_sym_struct,
    ACTIONS(11041), 1,
      anon_sym_union,
    ACTIONS(11043), 1,
      anon_sym_typename,
    ACTIONS(11045), 1,
      anon_sym_interface,
    ACTIONS(11047), 1,
      anon_sym_extension,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(3065), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4966), 1,
      sym_type_specifier,
    STATE(6263), 1,
      sym_argument_list,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11033), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [208499] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10956), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(11049), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(6781), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6783), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [208549] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8202), 1,
      anon_sym_DASH_GT,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8206), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10279), 1,
      anon_sym___attribute__,
    ACTIONS(10282), 1,
      anon_sym___attribute,
    ACTIONS(10285), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6943), 1,
      sym__function_attributes_end,
    STATE(7004), 1,
      sym_trailing_return_type,
    STATE(7624), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7838), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6514), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [208635] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8202), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10279), 1,
      anon_sym___attribute__,
    ACTIONS(10282), 1,
      anon_sym___attribute,
    ACTIONS(10285), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10429), 1,
      anon_sym_requires,
    ACTIONS(10432), 1,
      anon_sym_where,
    STATE(6938), 1,
      sym__function_attributes_end,
    STATE(7035), 1,
      sym_trailing_return_type,
    STATE(7624), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10426), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7509), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6500), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [208721] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    ACTIONS(7775), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_DOT,
    ACTIONS(9668), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9957), 1,
      anon_sym_SLASH,
    ACTIONS(9961), 1,
      anon_sym_GT_EQ,
    ACTIONS(9975), 1,
      anon_sym_PIPE,
    ACTIONS(9979), 1,
      anon_sym_AMP,
    ACTIONS(9985), 1,
      anon_sym_QMARK,
    ACTIONS(9987), 1,
      anon_sym_bitor,
    ACTIONS(9989), 1,
      anon_sym_bitand,
    STATE(3430), 1,
      sym_subscript_argument_list,
    STATE(3465), 1,
      sym_argument_list,
    ACTIONS(7781), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(9305), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9955), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9963), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9973), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9977), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9959), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9965), 3,
      anon_sym_LT_EQ_GT,
      anon_sym_is,
      anon_sym_as,
    ACTIONS(9981), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [208811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7943), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7945), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [208857] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    ACTIONS(11051), 1,
      sym_identifier,
    ACTIONS(11053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11057), 1,
      sym_primitive_type,
    ACTIONS(11059), 1,
      anon_sym_enum,
    ACTIONS(11061), 1,
      anon_sym_class,
    ACTIONS(11063), 1,
      anon_sym_struct,
    ACTIONS(11065), 1,
      anon_sym_union,
    ACTIONS(11069), 1,
      anon_sym_decltype,
    ACTIONS(11071), 1,
      anon_sym_typename,
    ACTIONS(11073), 1,
      anon_sym_interface,
    ACTIONS(11075), 1,
      anon_sym_extension,
    STATE(2815), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3712), 1,
      sym_type_specifier,
    STATE(4386), 1,
      sym_qualified_type_identifier,
    STATE(6297), 1,
      sym_argument_list,
    STATE(8630), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(4027), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(11067), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11055), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4320), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [208945] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 1,
      anon_sym___attribute__,
    ACTIONS(7348), 1,
      anon_sym___attribute,
    ACTIONS(7414), 1,
      anon_sym_LBRACE,
    ACTIONS(11015), 1,
      anon_sym_COLON,
    STATE(3046), 1,
      sym_attribute_specifier,
    STATE(3132), 1,
      sym__enum_base_clause,
    STATE(3226), 1,
      sym_enumerator_list,
    ACTIONS(3502), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(3504), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [209005] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9851), 1,
      anon_sym_DOT,
    ACTIONS(10004), 1,
      anon_sym_STAR,
    ACTIONS(10006), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10008), 1,
      anon_sym_AMP,
    STATE(4446), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9021), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6473), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9331), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_requires,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [209081] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    ACTIONS(11051), 1,
      sym_identifier,
    ACTIONS(11053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11057), 1,
      sym_primitive_type,
    ACTIONS(11059), 1,
      anon_sym_enum,
    ACTIONS(11061), 1,
      anon_sym_class,
    ACTIONS(11063), 1,
      anon_sym_struct,
    ACTIONS(11065), 1,
      anon_sym_union,
    ACTIONS(11069), 1,
      anon_sym_decltype,
    ACTIONS(11071), 1,
      anon_sym_typename,
    ACTIONS(11073), 1,
      anon_sym_interface,
    ACTIONS(11075), 1,
      anon_sym_extension,
    STATE(2815), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3743), 1,
      sym_type_specifier,
    STATE(4386), 1,
      sym_qualified_type_identifier,
    STATE(6306), 1,
      sym_argument_list,
    STATE(8630), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(4027), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(11067), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11055), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4320), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [209169] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8548), 1,
      sym_primitive_type,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    ACTIONS(11029), 1,
      sym_identifier,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11035), 1,
      anon_sym_enum,
    ACTIONS(11037), 1,
      anon_sym_class,
    ACTIONS(11039), 1,
      anon_sym_struct,
    ACTIONS(11041), 1,
      anon_sym_union,
    ACTIONS(11043), 1,
      anon_sym_typename,
    ACTIONS(11045), 1,
      anon_sym_interface,
    ACTIONS(11047), 1,
      anon_sym_extension,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(3065), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5102), 1,
      sym_type_specifier,
    STATE(6307), 1,
      sym_argument_list,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11033), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [209257] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8789), 1,
      anon_sym_STAR,
    ACTIONS(8791), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8793), 1,
      anon_sym_AMP,
    ACTIONS(10954), 1,
      sym_identifier,
    STATE(6872), 1,
      sym_ms_call_modifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7680), 1,
      sym__declarator,
    STATE(9219), 1,
      sym_type_hinted_declarator,
    STATE(9748), 1,
      sym_init_declarator,
    STATE(11397), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [209341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7856), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7858), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [209387] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9558), 1,
      anon_sym_STAR,
    ACTIONS(9560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9562), 1,
      anon_sym_AMP,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8430), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9576), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [209459] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9558), 1,
      anon_sym_STAR,
    ACTIONS(9560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9562), 1,
      anon_sym_AMP,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8432), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [209531] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8202), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11077), 1,
      anon_sym___attribute__,
    ACTIONS(11080), 1,
      anon_sym___attribute,
    ACTIONS(11083), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11089), 1,
      anon_sym_requires,
    ACTIONS(11092), 1,
      anon_sym_where,
    STATE(6944), 1,
      sym__function_attributes_end,
    STATE(7036), 1,
      sym_trailing_return_type,
    STATE(7626), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(11086), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7510), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6504), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10823), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [209617] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9558), 1,
      anon_sym_STAR,
    ACTIONS(9560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9562), 1,
      anon_sym_AMP,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8433), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9582), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [209689] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9558), 1,
      anon_sym_STAR,
    ACTIONS(9560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9562), 1,
      anon_sym_AMP,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(4694), 1,
      sym_alignas_qualifier,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8434), 1,
      sym__abstract_declarator,
    ACTIONS(8137), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4168), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8106), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(8125), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [209761] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8548), 1,
      sym_primitive_type,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    ACTIONS(11029), 1,
      sym_identifier,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11035), 1,
      anon_sym_enum,
    ACTIONS(11037), 1,
      anon_sym_class,
    ACTIONS(11039), 1,
      anon_sym_struct,
    ACTIONS(11041), 1,
      anon_sym_union,
    ACTIONS(11043), 1,
      anon_sym_typename,
    ACTIONS(11045), 1,
      anon_sym_interface,
    ACTIONS(11047), 1,
      anon_sym_extension,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(3065), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5109), 1,
      sym_type_specifier,
    STATE(6315), 1,
      sym_argument_list,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11033), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [209849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8031), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(8033), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [209895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7860), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7862), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [209941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8061), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(8063), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [209987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7919), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7921), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [210033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7927), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7929), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [210079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7903), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7905), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [210125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8049), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(8051), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [210171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7931), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7933), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [210217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7915), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7917), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [210263] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8202), 1,
      anon_sym_DASH_GT,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8206), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11077), 1,
      anon_sym___attribute__,
    ACTIONS(11080), 1,
      anon_sym___attribute,
    ACTIONS(11083), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6936), 1,
      sym__function_attributes_end,
    STATE(7006), 1,
      sym_trailing_return_type,
    STATE(7626), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7848), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6479), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10823), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [210349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5487), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5483), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [210395] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(10014), 1,
      anon_sym_DOT,
    ACTIONS(10043), 1,
      anon_sym_STAR,
    ACTIONS(10045), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10047), 1,
      anon_sym_AMP,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4464), 1,
      sym_parameter_list,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8985), 1,
      sym__abstract_declarator,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6414), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9323), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10016), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [210471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7975), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7977), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [210517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7983), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7985), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [210563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8019), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(8021), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [210609] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9564), 1,
      anon_sym_STAR,
    ACTIONS(9566), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9568), 1,
      anon_sym_AMP,
    ACTIONS(9578), 1,
      anon_sym___attribute,
    STATE(3727), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8335), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9576), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [210683] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7412), 1,
      anon_sym___attribute,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9564), 1,
      anon_sym_STAR,
    ACTIONS(9566), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9568), 1,
      anon_sym_AMP,
    STATE(3727), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8361), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [210757] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8548), 1,
      sym_primitive_type,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    ACTIONS(11029), 1,
      sym_identifier,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11035), 1,
      anon_sym_enum,
    ACTIONS(11037), 1,
      anon_sym_class,
    ACTIONS(11039), 1,
      anon_sym_struct,
    ACTIONS(11041), 1,
      anon_sym_union,
    ACTIONS(11043), 1,
      anon_sym_typename,
    ACTIONS(11045), 1,
      anon_sym_interface,
    ACTIONS(11047), 1,
      anon_sym_extension,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(3065), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4977), 1,
      sym_type_specifier,
    STATE(6266), 1,
      sym_argument_list,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11033), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [210845] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9564), 1,
      anon_sym_STAR,
    ACTIONS(9566), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9568), 1,
      anon_sym_AMP,
    ACTIONS(9584), 1,
      anon_sym___attribute,
    STATE(3727), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8345), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9582), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [210919] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(8108), 1,
      anon_sym___attribute,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9564), 1,
      anon_sym_STAR,
    ACTIONS(9566), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9568), 1,
      anon_sym_AMP,
    STATE(3727), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8362), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8106), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [210993] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9570), 1,
      anon_sym_STAR,
    ACTIONS(9572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9574), 1,
      anon_sym_AMP,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4323), 1,
      sym_parameter_list,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8398), 1,
      sym__abstract_declarator,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6798), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8106), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [211065] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    ACTIONS(10873), 1,
      sym_identifier,
    ACTIONS(10875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10879), 1,
      sym_primitive_type,
    ACTIONS(10881), 1,
      anon_sym_enum,
    ACTIONS(10883), 1,
      anon_sym_class,
    ACTIONS(10885), 1,
      anon_sym_struct,
    ACTIONS(10887), 1,
      anon_sym_union,
    ACTIONS(10891), 1,
      anon_sym_decltype,
    ACTIONS(10893), 1,
      anon_sym_typename,
    ACTIONS(10895), 1,
      anon_sym_interface,
    ACTIONS(10897), 1,
      anon_sym_extension,
    STATE(2788), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3657), 1,
      sym_type_specifier,
    STATE(3878), 1,
      sym_qualified_type_identifier,
    STATE(6333), 1,
      sym_argument_list,
    STATE(8655), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(3735), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10889), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10877), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3875), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [211153] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(5344), 1,
      anon_sym_LPAREN2,
    ACTIONS(5346), 1,
      anon_sym_STAR,
    ACTIONS(5348), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5350), 1,
      anon_sym_AMP,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(7408), 1,
      anon_sym_LBRACK,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9592), 1,
      anon_sym_RPAREN,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(7421), 1,
      sym__scope_resolution,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8485), 1,
      sym__declarator,
    STATE(8856), 1,
      sym__abstract_declarator,
    STATE(11547), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [211239] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11095), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(6166), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(9909), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(9911), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [211289] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8440), 1,
      anon_sym_DASH_GT,
    ACTIONS(8442), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10279), 1,
      anon_sym___attribute__,
    ACTIONS(10282), 1,
      anon_sym___attribute,
    STATE(6380), 1,
      sym_ref_qualifier,
    STATE(7334), 1,
      sym__function_attributes_end,
    STATE(7503), 1,
      sym_trailing_return_type,
    STATE(7549), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8338), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6814), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
  [211381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7873), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7875), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [211427] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8566), 1,
      anon_sym_DASH_GT,
    ACTIONS(8571), 1,
      anon_sym_noexcept,
    ACTIONS(8573), 1,
      anon_sym_throw,
    ACTIONS(11101), 1,
      anon_sym_requires,
    ACTIONS(11104), 1,
      anon_sym_where,
    STATE(6444), 1,
      sym_ref_qualifier,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7589), 1,
      sym__function_attributes_end,
    STATE(7871), 1,
      sym_trailing_return_type,
    STATE(8986), 1,
      sym_gnu_asm_expression,
    ACTIONS(8562), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(10026), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(11098), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7531), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8417), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    STATE(6834), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
  [211514] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(3516), 1,
      anon_sym_LBRACE,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    STATE(317), 1,
      sym_attribute_specifier,
    STATE(6395), 1,
      sym_enumerator_list,
    ACTIONS(3989), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3987), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [211569] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(3516), 1,
      anon_sym_LBRACE,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    STATE(306), 1,
      sym_attribute_specifier,
    STATE(6399), 1,
      sym_enumerator_list,
    ACTIONS(3993), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(3991), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [211624] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9676), 1,
      anon_sym_LPAREN2,
    ACTIONS(9678), 1,
      anon_sym_STAR,
    ACTIONS(9680), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9682), 1,
      anon_sym_AMP,
    ACTIONS(9686), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3868), 1,
      sym__type_declarator,
    STATE(4535), 1,
      sym_pointer_type_declarator,
    STATE(11577), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9684), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4530), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [211697] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9702), 1,
      anon_sym_STAR,
    ACTIONS(9704), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9706), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4331), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8590), 1,
      sym__abstract_declarator,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [211768] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8243), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11083), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11089), 1,
      anon_sym_requires,
    ACTIONS(11107), 1,
      anon_sym_where,
    STATE(7139), 1,
      sym__function_attributes_end,
    STATE(7404), 1,
      sym_trailing_return_type,
    STATE(7626), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(11086), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7852), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6560), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10823), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [211853] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9702), 1,
      anon_sym_STAR,
    ACTIONS(9704), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9706), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4331), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8550), 1,
      sym__abstract_declarator,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9582), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [211924] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9702), 1,
      anon_sym_STAR,
    ACTIONS(9704), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9706), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4331), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8539), 1,
      sym__abstract_declarator,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8106), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [211995] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2738), 1,
      sym_alignas_qualifier,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6178), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9508), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(6720), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9510), 14,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [212048] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2738), 1,
      sym_alignas_qualifier,
    ACTIONS(11113), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6178), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3681), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(11110), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(3683), 14,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [212101] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9331), 1,
      anon_sym_COMMA,
    ACTIONS(9333), 1,
      sym_identifier,
    ACTIONS(10149), 1,
      anon_sym_STAR,
    ACTIONS(10151), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10153), 1,
      anon_sym_AMP,
    ACTIONS(10249), 1,
      anon_sym_DOT,
    STATE(4330), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9121), 1,
      sym__abstract_declarator,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6534), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9923), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [212176] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7410), 1,
      anon_sym_COMMA,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9660), 1,
      anon_sym_STAR,
    ACTIONS(9662), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9664), 1,
      anon_sym_AMP,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8524), 1,
      sym__abstract_declarator,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7412), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [212247] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9582), 1,
      anon_sym_COMMA,
    ACTIONS(9660), 1,
      anon_sym_STAR,
    ACTIONS(9662), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9664), 1,
      anon_sym_AMP,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8509), 1,
      sym__abstract_declarator,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9584), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [212318] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8243), 1,
      anon_sym_DASH_GT,
    ACTIONS(8245), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11083), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7061), 1,
      sym__function_attributes_end,
    STATE(7375), 1,
      sym_trailing_return_type,
    STATE(7626), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8198), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6547), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10823), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [212403] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2738), 1,
      sym_alignas_qualifier,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6178), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9827), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(6720), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(9829), 14,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [212456] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10037), 1,
      anon_sym_LBRACE,
    ACTIONS(11116), 1,
      anon_sym_COLON,
    STATE(5761), 1,
      sym_attribute_specifier,
    STATE(6361), 1,
      sym__enum_base_clause,
    STATE(6480), 1,
      sym_enumerator_list,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(3504), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3502), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [212513] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9618), 1,
      anon_sym_STAR,
    ACTIONS(9620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9622), 1,
      anon_sym_AMP,
    STATE(4445), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8564), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9576), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [212584] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(8106), 1,
      anon_sym_COMMA,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9660), 1,
      anon_sym_STAR,
    ACTIONS(9662), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9664), 1,
      anon_sym_AMP,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8505), 1,
      sym__abstract_declarator,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8108), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [212655] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9618), 1,
      anon_sym_STAR,
    ACTIONS(9620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9622), 1,
      anon_sym_AMP,
    STATE(4445), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8589), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7410), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [212726] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11118), 1,
      sym_identifier,
    ACTIONS(11124), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(6413), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9717), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(11121), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3542), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(3540), 7,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9714), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [212787] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9872), 1,
      anon_sym___attribute,
    ACTIONS(10037), 1,
      anon_sym_LBRACE,
    ACTIONS(10041), 1,
      anon_sym___attribute__,
    ACTIONS(11127), 1,
      anon_sym_COLON,
    STATE(5425), 1,
      sym__enum_base_clause,
    STATE(5611), 1,
      sym_enumerator_list,
    STATE(5840), 1,
      sym_attribute_specifier,
    ACTIONS(3478), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(3480), 28,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [212846] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9872), 1,
      anon_sym___attribute,
    ACTIONS(10037), 1,
      anon_sym_LBRACE,
    ACTIONS(10041), 1,
      anon_sym___attribute__,
    ACTIONS(11127), 1,
      anon_sym_COLON,
    STATE(5426), 1,
      sym__enum_base_clause,
    STATE(5615), 1,
      sym_enumerator_list,
    STATE(5761), 1,
      sym_attribute_specifier,
    ACTIONS(3502), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(3504), 28,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [212905] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9758), 1,
      anon_sym_DOT,
    ACTIONS(10157), 1,
      anon_sym_STAR,
    ACTIONS(10159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10161), 1,
      anon_sym_AMP,
    STATE(4444), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9059), 1,
      sym__abstract_declarator,
    ACTIONS(9323), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6505), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [212980] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9758), 1,
      anon_sym_DOT,
    ACTIONS(10157), 1,
      anon_sym_STAR,
    ACTIONS(10159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10161), 1,
      anon_sym_AMP,
    STATE(4444), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9200), 1,
      sym__abstract_declarator,
    ACTIONS(9331), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6511), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [213055] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9618), 1,
      anon_sym_STAR,
    ACTIONS(9620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9622), 1,
      anon_sym_AMP,
    STATE(4445), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8567), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9582), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [213126] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9606), 1,
      anon_sym_STAR,
    ACTIONS(9608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9610), 1,
      anon_sym_AMP,
    ACTIONS(9616), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3167), 1,
      sym__type_declarator,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(11420), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [213199] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9618), 1,
      anon_sym_STAR,
    ACTIONS(9620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9622), 1,
      anon_sym_AMP,
    STATE(4445), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8553), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8106), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [213270] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9576), 1,
      anon_sym_COMMA,
    ACTIONS(9660), 1,
      anon_sym_STAR,
    ACTIONS(9662), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9664), 1,
      anon_sym_AMP,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8593), 1,
      sym__abstract_declarator,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9578), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [213341] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9676), 1,
      anon_sym_LPAREN2,
    ACTIONS(9678), 1,
      anon_sym_STAR,
    ACTIONS(9680), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9682), 1,
      anon_sym_AMP,
    ACTIONS(9686), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3867), 1,
      sym__type_declarator,
    STATE(4535), 1,
      sym_pointer_type_declarator,
    STATE(11577), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9684), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4530), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [213414] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9654), 1,
      anon_sym_STAR,
    ACTIONS(9656), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9658), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8938), 1,
      sym__type_declarator,
    STATE(11243), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [213487] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(11129), 1,
      anon_sym_requires,
    ACTIONS(11132), 1,
      anon_sym_where,
    STATE(6418), 1,
      sym_ref_qualifier,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7558), 1,
      sym__function_attributes_end,
    STATE(7795), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8367), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6863), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [213578] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5479), 1,
      anon_sym_LBRACE,
    ACTIONS(11135), 1,
      anon_sym_LPAREN2,
    STATE(4680), 1,
      sym_argument_list,
    STATE(5254), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6082), 1,
      sym_initializer_list,
    ACTIONS(2883), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(9754), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2881), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [213635] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5807), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2883), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(10617), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2881), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [213684] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9720), 1,
      sym_identifier,
    ACTIONS(9722), 1,
      anon_sym_LPAREN2,
    ACTIONS(9732), 1,
      sym_primitive_type,
    ACTIONS(9734), 1,
      anon_sym_STAR,
    ACTIONS(9736), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9738), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(7642), 1,
      sym__type_declarator,
    STATE(8122), 1,
      sym_pointer_type_declarator,
    STATE(11691), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9730), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(8102), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [213757] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9606), 1,
      anon_sym_STAR,
    ACTIONS(9608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9610), 1,
      anon_sym_AMP,
    ACTIONS(9616), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3198), 1,
      sym__type_declarator,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(11420), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [213830] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9702), 1,
      anon_sym_STAR,
    ACTIONS(9704), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9706), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4331), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8541), 1,
      sym__abstract_declarator,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9576), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [213901] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9688), 1,
      sym_identifier,
    ACTIONS(9690), 1,
      anon_sym_LPAREN2,
    ACTIONS(9692), 1,
      anon_sym_STAR,
    ACTIONS(9694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9696), 1,
      anon_sym_AMP,
    ACTIONS(9700), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3716), 1,
      sym__type_declarator,
    STATE(4458), 1,
      sym_pointer_type_declarator,
    STATE(11304), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9698), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4456), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [213974] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5684), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(10562), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2881), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2883), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [214023] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9720), 1,
      sym_identifier,
    ACTIONS(9722), 1,
      anon_sym_LPAREN2,
    ACTIONS(9732), 1,
      sym_primitive_type,
    ACTIONS(9734), 1,
      anon_sym_STAR,
    ACTIONS(9736), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9738), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(7650), 1,
      sym__type_declarator,
    STATE(8122), 1,
      sym_pointer_type_declarator,
    STATE(11691), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9730), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(8102), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [214096] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3681), 1,
      anon_sym_COLON_COLON,
    STATE(2663), 1,
      sym_alignas_qualifier,
    ACTIONS(11138), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9994), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(3683), 18,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_interface,
      anon_sym_extension,
  [214149] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9676), 1,
      anon_sym_LPAREN2,
    ACTIONS(9678), 1,
      anon_sym_STAR,
    ACTIONS(9680), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9682), 1,
      anon_sym_AMP,
    ACTIONS(9686), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3819), 1,
      sym__type_declarator,
    STATE(4535), 1,
      sym_pointer_type_declarator,
    STATE(11577), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9684), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4530), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [214222] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9851), 1,
      anon_sym_DOT,
    ACTIONS(10197), 1,
      anon_sym_STAR,
    ACTIONS(10199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10201), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4503), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9090), 1,
      sym__abstract_declarator,
    ACTIONS(9331), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6507), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [214297] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(7954), 1,
      sym__type_declarator,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [214370] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9688), 1,
      sym_identifier,
    ACTIONS(9690), 1,
      anon_sym_LPAREN2,
    ACTIONS(9692), 1,
      anon_sym_STAR,
    ACTIONS(9694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9696), 1,
      anon_sym_AMP,
    ACTIONS(9700), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3793), 1,
      sym__type_declarator,
    STATE(4458), 1,
      sym_pointer_type_declarator,
    STATE(11304), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9698), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4456), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [214443] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9654), 1,
      anon_sym_STAR,
    ACTIONS(9656), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9658), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8961), 1,
      sym__type_declarator,
    STATE(11243), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [214516] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(2953), 1,
      sym_template_argument_list,
    STATE(6468), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3775), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(3777), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [214569] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8592), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    STATE(6424), 1,
      sym_ref_qualifier,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7622), 1,
      sym__function_attributes_end,
    STATE(7802), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8892), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6822), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [214660] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(7973), 1,
      sym__type_declarator,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [214733] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8594), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10031), 1,
      anon_sym_requires,
    STATE(6459), 1,
      sym_ref_qualifier,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7569), 1,
      sym__function_attributes_end,
    STATE(7782), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8616), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6838), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [214824] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9654), 1,
      anon_sym_STAR,
    ACTIONS(9656), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9658), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8928), 1,
      sym__type_declarator,
    STATE(11243), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [214897] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_SEMI,
    ACTIONS(2181), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(2170), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [214944] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9720), 1,
      sym_identifier,
    ACTIONS(9722), 1,
      anon_sym_LPAREN2,
    ACTIONS(9732), 1,
      sym_primitive_type,
    ACTIONS(9734), 1,
      anon_sym_STAR,
    ACTIONS(9736), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9738), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(7646), 1,
      sym__type_declarator,
    STATE(8122), 1,
      sym_pointer_type_declarator,
    STATE(11691), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9730), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(8102), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [215017] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(7979), 1,
      sym__type_declarator,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [215090] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9606), 1,
      anon_sym_STAR,
    ACTIONS(9608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9610), 1,
      anon_sym_AMP,
    ACTIONS(9616), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3252), 1,
      sym__type_declarator,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(11420), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [215163] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11141), 1,
      sym_identifier,
    ACTIONS(11147), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(6453), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9745), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6188), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(11144), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3423), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(3428), 7,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(9740), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [215224] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7414), 1,
      anon_sym_LBRACE,
    ACTIONS(11150), 1,
      anon_sym_COLON,
    STATE(3048), 1,
      sym_attribute_specifier,
    STATE(6385), 1,
      sym__enum_base_clause,
    STATE(6521), 1,
      sym_enumerator_list,
    ACTIONS(8129), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(3480), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(3478), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [215281] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7414), 1,
      anon_sym_LBRACE,
    ACTIONS(11150), 1,
      anon_sym_COLON,
    STATE(3046), 1,
      sym_attribute_specifier,
    STATE(6386), 1,
      sym__enum_base_clause,
    STATE(6524), 1,
      sym_enumerator_list,
    ACTIONS(8129), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(3504), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(3502), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [215338] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8243), 1,
      anon_sym_DASH_GT,
    ACTIONS(8245), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10285), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7145), 1,
      sym__function_attributes_end,
    STATE(7436), 1,
      sym_trailing_return_type,
    STATE(7624), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8183), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6545), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [215423] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8566), 1,
      anon_sym_DASH_GT,
    ACTIONS(8571), 1,
      anon_sym_noexcept,
    ACTIONS(8573), 1,
      anon_sym_throw,
    ACTIONS(8586), 1,
      anon_sym_requires,
    ACTIONS(8588), 1,
      anon_sym_where,
    STATE(6417), 1,
      sym_ref_qualifier,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7615), 1,
      sym__function_attributes_end,
    STATE(7870), 1,
      sym_trailing_return_type,
    STATE(8986), 1,
      sym_gnu_asm_expression,
    ACTIONS(8562), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(10026), 2,
      anon_sym_LBRACK,
      sym_identifier,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7531), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8817), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    STATE(6865), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
  [215510] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8243), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10285), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10429), 1,
      anon_sym_requires,
    ACTIONS(10564), 1,
      anon_sym_where,
    STATE(7085), 1,
      sym__function_attributes_end,
    STATE(7419), 1,
      sym_trailing_return_type,
    STATE(7624), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10426), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7874), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6543), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [215595] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(5344), 1,
      anon_sym_LPAREN2,
    ACTIONS(5346), 1,
      anon_sym_STAR,
    ACTIONS(5348), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5350), 1,
      anon_sym_AMP,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(7408), 1,
      anon_sym_LBRACK,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(7421), 1,
      sym__scope_resolution,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8845), 1,
      sym__declarator,
    STATE(9237), 1,
      sym__abstract_declarator,
    STATE(11547), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [215678] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9720), 1,
      sym_identifier,
    ACTIONS(9722), 1,
      anon_sym_LPAREN2,
    ACTIONS(9724), 1,
      anon_sym_STAR,
    ACTIONS(9726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9728), 1,
      anon_sym_AMP,
    ACTIONS(9732), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(8122), 1,
      sym_pointer_type_declarator,
    STATE(8816), 1,
      sym__type_declarator,
    STATE(11642), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9730), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(8102), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [215751] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9688), 1,
      sym_identifier,
    ACTIONS(9690), 1,
      anon_sym_LPAREN2,
    ACTIONS(9692), 1,
      anon_sym_STAR,
    ACTIONS(9694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9696), 1,
      anon_sym_AMP,
    ACTIONS(9700), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(3779), 1,
      sym__type_declarator,
    STATE(4458), 1,
      sym_pointer_type_declarator,
    STATE(11304), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9698), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4456), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [215824] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9720), 1,
      sym_identifier,
    ACTIONS(9722), 1,
      anon_sym_LPAREN2,
    ACTIONS(9724), 1,
      anon_sym_STAR,
    ACTIONS(9726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9728), 1,
      anon_sym_AMP,
    ACTIONS(9732), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(8122), 1,
      sym_pointer_type_declarator,
    STATE(8818), 1,
      sym__type_declarator,
    STATE(11642), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9730), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(8102), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [215897] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9720), 1,
      sym_identifier,
    ACTIONS(9722), 1,
      anon_sym_LPAREN2,
    ACTIONS(9724), 1,
      anon_sym_STAR,
    ACTIONS(9726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9728), 1,
      anon_sym_AMP,
    ACTIONS(9732), 1,
      sym_primitive_type,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(8122), 1,
      sym_pointer_type_declarator,
    STATE(8820), 1,
      sym__type_declarator,
    STATE(11642), 1,
      sym_ms_based_modifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9730), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(8102), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [215970] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9851), 1,
      anon_sym_DOT,
    ACTIONS(10197), 1,
      anon_sym_STAR,
    ACTIONS(10199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10201), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4503), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9206), 1,
      sym__abstract_declarator,
    ACTIONS(9323), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6503), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [216045] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10037), 1,
      anon_sym_LBRACE,
    ACTIONS(11116), 1,
      anon_sym_COLON,
    STATE(5840), 1,
      sym_attribute_specifier,
    STATE(6393), 1,
      sym__enum_base_clause,
    STATE(6531), 1,
      sym_enumerator_list,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(3480), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3478), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [216102] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9323), 1,
      anon_sym_COMMA,
    ACTIONS(9325), 1,
      sym_identifier,
    ACTIONS(10149), 1,
      anon_sym_STAR,
    ACTIONS(10151), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10153), 1,
      anon_sym_AMP,
    ACTIONS(10249), 1,
      anon_sym_DOT,
    STATE(4330), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9026), 1,
      sym__abstract_declarator,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6498), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9923), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [216177] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(253), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2470), 1,
      sym_primitive_type,
    ACTIONS(2474), 1,
      anon_sym_class,
    ACTIONS(2476), 1,
      anon_sym_struct,
    ACTIONS(2478), 1,
      anon_sym_union,
    ACTIONS(2490), 1,
      anon_sym_interface,
    ACTIONS(2492), 1,
      anon_sym_extension,
    ACTIONS(4401), 1,
      sym_identifier,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4413), 1,
      anon_sym_enum,
    ACTIONS(4415), 1,
      anon_sym_typename,
    STATE(2888), 1,
      sym_qualified_type_identifier,
    STATE(3101), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3593), 1,
      sym_type_specifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(2842), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(251), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4411), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2839), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [216259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4242), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [216303] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8869), 1,
      anon_sym_DASH_GT,
    ACTIONS(8876), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10279), 1,
      anon_sym___attribute__,
    ACTIONS(10282), 1,
      anon_sym___attribute,
    STATE(6492), 1,
      sym_ref_qualifier,
    STATE(7491), 1,
      sym__function_attributes_end,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7652), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8736), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6876), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [216393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4250), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(4248), 29,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [216437] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(6831), 1,
      sym_ms_call_modifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8320), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [216515] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10928), 1,
      sym_identifier,
    ACTIONS(10930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10934), 1,
      sym_primitive_type,
    ACTIONS(10936), 1,
      anon_sym_enum,
    ACTIONS(10938), 1,
      anon_sym_class,
    ACTIONS(10940), 1,
      anon_sym_struct,
    ACTIONS(10942), 1,
      anon_sym_union,
    ACTIONS(10946), 1,
      anon_sym_decltype,
    ACTIONS(10948), 1,
      anon_sym_typename,
    ACTIONS(10950), 1,
      anon_sym_interface,
    ACTIONS(10952), 1,
      anon_sym_extension,
    STATE(3068), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4930), 1,
      sym_type_specifier,
    STATE(5066), 1,
      sym_qualified_type_identifier,
    STATE(8723), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(4993), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10944), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10932), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5063), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [216597] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(6847), 1,
      sym_ms_call_modifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8318), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [216675] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8751), 1,
      sym_identifier,
    ACTIONS(8753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8757), 1,
      sym_primitive_type,
    ACTIONS(8759), 1,
      anon_sym_enum,
    ACTIONS(8761), 1,
      anon_sym_class,
    ACTIONS(8763), 1,
      anon_sym_struct,
    ACTIONS(8765), 1,
      anon_sym_union,
    ACTIONS(8767), 1,
      anon_sym_typename,
    ACTIONS(8769), 1,
      anon_sym_interface,
    ACTIONS(8771), 1,
      anon_sym_extension,
    STATE(324), 1,
      sym_qualified_type_identifier,
    STATE(5215), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6684), 1,
      sym_type_specifier,
    STATE(8727), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(125), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8755), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(315), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [216757] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(6867), 1,
      sym_ms_call_modifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8321), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [216835] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8751), 1,
      sym_identifier,
    ACTIONS(8753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8757), 1,
      sym_primitive_type,
    ACTIONS(8759), 1,
      anon_sym_enum,
    ACTIONS(8761), 1,
      anon_sym_class,
    ACTIONS(8763), 1,
      anon_sym_struct,
    ACTIONS(8765), 1,
      anon_sym_union,
    ACTIONS(8767), 1,
      anon_sym_typename,
    ACTIONS(8769), 1,
      anon_sym_interface,
    ACTIONS(8771), 1,
      anon_sym_extension,
    STATE(324), 1,
      sym_qualified_type_identifier,
    STATE(5215), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6620), 1,
      sym_type_specifier,
    STATE(8727), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(125), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8755), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(315), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [216917] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9841), 1,
      anon_sym_STAR,
    ACTIONS(9843), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9845), 1,
      anon_sym_AMP,
    STATE(3767), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8734), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8106), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [216987] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(6818), 1,
      sym_ms_call_modifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8384), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [217065] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10960), 1,
      sym_identifier,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10966), 1,
      sym_primitive_type,
    ACTIONS(10968), 1,
      anon_sym_enum,
    ACTIONS(10970), 1,
      anon_sym_class,
    ACTIONS(10972), 1,
      anon_sym_struct,
    ACTIONS(10974), 1,
      anon_sym_union,
    ACTIONS(10978), 1,
      anon_sym_decltype,
    ACTIONS(10980), 1,
      anon_sym_typename,
    ACTIONS(10982), 1,
      anon_sym_interface,
    ACTIONS(10984), 1,
      anon_sym_extension,
    STATE(3156), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5174), 1,
      sym_type_specifier,
    STATE(5351), 1,
      sym_qualified_type_identifier,
    STATE(8676), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(5307), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10976), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10964), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5350), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [217147] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10928), 1,
      sym_identifier,
    ACTIONS(10930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10934), 1,
      sym_primitive_type,
    ACTIONS(10936), 1,
      anon_sym_enum,
    ACTIONS(10938), 1,
      anon_sym_class,
    ACTIONS(10940), 1,
      anon_sym_struct,
    ACTIONS(10942), 1,
      anon_sym_union,
    ACTIONS(10946), 1,
      anon_sym_decltype,
    ACTIONS(10948), 1,
      anon_sym_typename,
    ACTIONS(10950), 1,
      anon_sym_interface,
    ACTIONS(10952), 1,
      anon_sym_extension,
    STATE(3068), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5049), 1,
      sym_type_specifier,
    STATE(5066), 1,
      sym_qualified_type_identifier,
    STATE(8723), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(4993), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10944), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10932), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5063), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [217229] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10928), 1,
      sym_identifier,
    ACTIONS(10930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10934), 1,
      sym_primitive_type,
    ACTIONS(10936), 1,
      anon_sym_enum,
    ACTIONS(10938), 1,
      anon_sym_class,
    ACTIONS(10940), 1,
      anon_sym_struct,
    ACTIONS(10942), 1,
      anon_sym_union,
    ACTIONS(10946), 1,
      anon_sym_decltype,
    ACTIONS(10948), 1,
      anon_sym_typename,
    ACTIONS(10950), 1,
      anon_sym_interface,
    ACTIONS(10952), 1,
      anon_sym_extension,
    STATE(3068), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4943), 1,
      sym_type_specifier,
    STATE(5066), 1,
      sym_qualified_type_identifier,
    STATE(8723), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(4993), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10944), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10932), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5063), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [217311] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(6846), 1,
      sym_ms_call_modifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8372), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [217389] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11051), 1,
      sym_identifier,
    ACTIONS(11053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11057), 1,
      sym_primitive_type,
    ACTIONS(11059), 1,
      anon_sym_enum,
    ACTIONS(11061), 1,
      anon_sym_class,
    ACTIONS(11063), 1,
      anon_sym_struct,
    ACTIONS(11065), 1,
      anon_sym_union,
    ACTIONS(11069), 1,
      anon_sym_decltype,
    ACTIONS(11071), 1,
      anon_sym_typename,
    ACTIONS(11073), 1,
      anon_sym_interface,
    ACTIONS(11075), 1,
      anon_sym_extension,
    STATE(2815), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4327), 1,
      sym_type_specifier,
    STATE(4386), 1,
      sym_qualified_type_identifier,
    STATE(8630), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(4027), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(11067), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11055), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4320), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [217471] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8731), 1,
      sym_identifier,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8737), 1,
      anon_sym_enum,
    ACTIONS(8739), 1,
      anon_sym_class,
    ACTIONS(8741), 1,
      anon_sym_struct,
    ACTIONS(8743), 1,
      anon_sym_union,
    ACTIONS(8745), 1,
      anon_sym_typename,
    ACTIONS(8747), 1,
      anon_sym_interface,
    ACTIONS(8749), 1,
      anon_sym_extension,
    STATE(5394), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6807), 1,
      sym_type_specifier,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8735), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [217553] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(6819), 1,
      sym_ms_call_modifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8457), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [217631] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11051), 1,
      sym_identifier,
    ACTIONS(11053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11057), 1,
      sym_primitive_type,
    ACTIONS(11059), 1,
      anon_sym_enum,
    ACTIONS(11061), 1,
      anon_sym_class,
    ACTIONS(11063), 1,
      anon_sym_struct,
    ACTIONS(11065), 1,
      anon_sym_union,
    ACTIONS(11069), 1,
      anon_sym_decltype,
    ACTIONS(11071), 1,
      anon_sym_typename,
    ACTIONS(11073), 1,
      anon_sym_interface,
    ACTIONS(11075), 1,
      anon_sym_extension,
    STATE(2815), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4386), 1,
      sym_qualified_type_identifier,
    STATE(4474), 1,
      sym_type_specifier,
    STATE(8630), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(4027), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(11067), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11055), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4320), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [217713] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2452), 1,
      anon_sym_STAR,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    STATE(6816), 1,
      sym_ms_call_modifier,
    STATE(7421), 1,
      sym__scope_resolution,
    STATE(8849), 1,
      sym__declarator,
    STATE(11547), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [217791] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8678), 1,
      sym_identifier,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8686), 1,
      anon_sym_enum,
    ACTIONS(8688), 1,
      anon_sym_class,
    ACTIONS(8690), 1,
      anon_sym_struct,
    ACTIONS(8692), 1,
      anon_sym_union,
    ACTIONS(8694), 1,
      anon_sym_typename,
    ACTIONS(8696), 1,
      anon_sym_interface,
    ACTIONS(8698), 1,
      anon_sym_extension,
    STATE(5224), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6550), 1,
      sym_type_specifier,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8682), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [217873] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6372), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [217955] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10902), 1,
      sym_identifier,
    ACTIONS(10904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10908), 1,
      sym_primitive_type,
    ACTIONS(10910), 1,
      anon_sym_enum,
    ACTIONS(10912), 1,
      anon_sym_class,
    ACTIONS(10914), 1,
      anon_sym_struct,
    ACTIONS(10916), 1,
      anon_sym_union,
    ACTIONS(10920), 1,
      anon_sym_decltype,
    ACTIONS(10922), 1,
      anon_sym_typename,
    ACTIONS(10924), 1,
      anon_sym_interface,
    ACTIONS(10926), 1,
      anon_sym_extension,
    STATE(2778), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3583), 1,
      sym_type_specifier,
    STATE(3787), 1,
      sym_qualified_type_identifier,
    STATE(8746), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(3704), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10918), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10906), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3774), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [218037] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8812), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10279), 1,
      anon_sym___attribute__,
    ACTIONS(10282), 1,
      anon_sym___attribute,
    ACTIONS(11152), 1,
      anon_sym_requires,
    ACTIONS(11155), 1,
      anon_sym_where,
    STATE(6491), 1,
      sym_ref_qualifier,
    STATE(7461), 1,
      sym__function_attributes_end,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7664), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8258), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6888), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [218127] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      anon_sym_enum,
    ACTIONS(1045), 1,
      anon_sym_class,
    ACTIONS(1047), 1,
      anon_sym_struct,
    ACTIONS(1049), 1,
      anon_sym_union,
    ACTIONS(1053), 1,
      anon_sym_decltype,
    ACTIONS(1055), 1,
      anon_sym_typename,
    ACTIONS(1057), 1,
      anon_sym_interface,
    ACTIONS(1059), 1,
      anon_sym_extension,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11158), 1,
      sym_identifier,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11162), 1,
      sym_primitive_type,
    STATE(424), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(762), 1,
      sym_type_specifier,
    STATE(800), 1,
      sym_qualified_type_identifier,
    STATE(8763), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(756), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1051), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(1039), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(755), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [218209] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8548), 1,
      sym_primitive_type,
    ACTIONS(11029), 1,
      sym_identifier,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11035), 1,
      anon_sym_enum,
    ACTIONS(11037), 1,
      anon_sym_class,
    ACTIONS(11039), 1,
      anon_sym_struct,
    ACTIONS(11041), 1,
      anon_sym_union,
    ACTIONS(11043), 1,
      anon_sym_typename,
    ACTIONS(11045), 1,
      anon_sym_interface,
    ACTIONS(11047), 1,
      anon_sym_extension,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(3065), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4948), 1,
      sym_type_specifier,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11033), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [218291] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(253), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2354), 1,
      anon_sym_enum,
    ACTIONS(2356), 1,
      anon_sym_class,
    ACTIONS(2358), 1,
      anon_sym_struct,
    ACTIONS(2360), 1,
      anon_sym_union,
    ACTIONS(2384), 1,
      anon_sym_typename,
    ACTIONS(2396), 1,
      anon_sym_interface,
    ACTIONS(2398), 1,
      anon_sym_extension,
    ACTIONS(2470), 1,
      sym_primitive_type,
    ACTIONS(5515), 1,
      sym_identifier,
    ACTIONS(5525), 1,
      anon_sym_COLON_COLON,
    STATE(2717), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2888), 1,
      sym_qualified_type_identifier,
    STATE(3067), 1,
      sym_type_specifier,
    STATE(8769), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(2842), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(251), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(203), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2839), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [218373] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(253), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2354), 1,
      anon_sym_enum,
    ACTIONS(2356), 1,
      anon_sym_class,
    ACTIONS(2358), 1,
      anon_sym_struct,
    ACTIONS(2360), 1,
      anon_sym_union,
    ACTIONS(2384), 1,
      anon_sym_typename,
    ACTIONS(2396), 1,
      anon_sym_interface,
    ACTIONS(2398), 1,
      anon_sym_extension,
    ACTIONS(2470), 1,
      sym_primitive_type,
    ACTIONS(5515), 1,
      sym_identifier,
    ACTIONS(5525), 1,
      anon_sym_COLON_COLON,
    STATE(2717), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2888), 1,
      sym_qualified_type_identifier,
    STATE(3075), 1,
      sym_type_specifier,
    STATE(8769), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(2842), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(251), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(203), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2839), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [218455] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8548), 1,
      sym_primitive_type,
    ACTIONS(11029), 1,
      sym_identifier,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11035), 1,
      anon_sym_enum,
    ACTIONS(11037), 1,
      anon_sym_class,
    ACTIONS(11039), 1,
      anon_sym_struct,
    ACTIONS(11041), 1,
      anon_sym_union,
    ACTIONS(11043), 1,
      anon_sym_typename,
    ACTIONS(11045), 1,
      anon_sym_interface,
    ACTIONS(11047), 1,
      anon_sym_extension,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(3065), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4983), 1,
      sym_type_specifier,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11033), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [218537] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(73), 1,
      anon_sym_enum,
    ACTIONS(75), 1,
      anon_sym_class,
    ACTIONS(77), 1,
      anon_sym_struct,
    ACTIONS(79), 1,
      anon_sym_union,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(131), 1,
      anon_sym_typename,
    ACTIONS(169), 1,
      anon_sym_interface,
    ACTIONS(171), 1,
      anon_sym_extension,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11164), 1,
      sym_identifier,
    ACTIONS(11166), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11168), 1,
      sym_primitive_type,
    STATE(324), 1,
      sym_qualified_type_identifier,
    STATE(389), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(843), 1,
      sym_type_specifier,
    STATE(8640), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(125), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(59), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(315), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [218619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(4242), 29,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [218663] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9841), 1,
      anon_sym_STAR,
    ACTIONS(9843), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9845), 1,
      anon_sym_AMP,
    STATE(3767), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8681), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9576), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [218733] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10996), 1,
      anon_sym_class,
    ACTIONS(10998), 1,
      anon_sym_struct,
    ACTIONS(11000), 1,
      anon_sym_union,
    ACTIONS(11004), 1,
      anon_sym_decltype,
    ACTIONS(11008), 1,
      anon_sym_interface,
    ACTIONS(11010), 1,
      anon_sym_extension,
    ACTIONS(11017), 1,
      sym_identifier,
    ACTIONS(11021), 1,
      sym_primitive_type,
    ACTIONS(11023), 1,
      anon_sym_enum,
    ACTIONS(11025), 1,
      anon_sym_typename,
    STATE(2735), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3110), 1,
      sym_type_specifier,
    STATE(3192), 1,
      sym_qualified_type_identifier,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(3140), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(11002), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11019), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3189), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [218815] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 1,
      anon_sym_enum,
    ACTIONS(1045), 1,
      anon_sym_class,
    ACTIONS(1047), 1,
      anon_sym_struct,
    ACTIONS(1049), 1,
      anon_sym_union,
    ACTIONS(1053), 1,
      anon_sym_decltype,
    ACTIONS(1055), 1,
      anon_sym_typename,
    ACTIONS(1057), 1,
      anon_sym_interface,
    ACTIONS(1059), 1,
      anon_sym_extension,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11158), 1,
      sym_identifier,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11162), 1,
      sym_primitive_type,
    STATE(424), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(800), 1,
      sym_qualified_type_identifier,
    STATE(819), 1,
      sym_type_specifier,
    STATE(8763), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(756), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1051), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(1039), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(755), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [218897] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10986), 1,
      sym_identifier,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10992), 1,
      sym_primitive_type,
    ACTIONS(10994), 1,
      anon_sym_enum,
    ACTIONS(10996), 1,
      anon_sym_class,
    ACTIONS(10998), 1,
      anon_sym_struct,
    ACTIONS(11000), 1,
      anon_sym_union,
    ACTIONS(11004), 1,
      anon_sym_decltype,
    ACTIONS(11006), 1,
      anon_sym_typename,
    ACTIONS(11008), 1,
      anon_sym_interface,
    ACTIONS(11010), 1,
      anon_sym_extension,
    STATE(2739), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3192), 1,
      sym_qualified_type_identifier,
    STATE(3557), 1,
      sym_type_specifier,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(3140), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(11002), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10990), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3189), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [218979] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8650), 1,
      sym_identifier,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      anon_sym_enum,
    ACTIONS(8656), 1,
      anon_sym_class,
    ACTIONS(8658), 1,
      anon_sym_struct,
    ACTIONS(8660), 1,
      anon_sym_union,
    ACTIONS(8662), 1,
      anon_sym_typename,
    ACTIONS(8664), 1,
      anon_sym_interface,
    ACTIONS(8666), 1,
      anon_sym_extension,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(6362), 1,
      sym_type_specifier,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [219061] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2825), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_class,
    ACTIONS(2829), 1,
      anon_sym_struct,
    ACTIONS(2831), 1,
      anon_sym_union,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(2859), 1,
      anon_sym_typename,
    ACTIONS(2873), 1,
      anon_sym_interface,
    ACTIONS(2875), 1,
      anon_sym_extension,
    ACTIONS(8542), 1,
      sym_identifier,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8548), 1,
      sym_primitive_type,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6407), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [219143] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9841), 1,
      anon_sym_STAR,
    ACTIONS(9843), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9845), 1,
      anon_sym_AMP,
    STATE(3767), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8700), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9582), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [219213] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8310), 1,
      anon_sym_DASH_GT,
    ACTIONS(8326), 1,
      anon_sym_requires,
    ACTIONS(8328), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10285), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7296), 1,
      sym__function_attributes_end,
    STATE(7469), 1,
      sym_trailing_return_type,
    STATE(7624), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8395), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6591), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [219297] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10996), 1,
      anon_sym_class,
    ACTIONS(10998), 1,
      anon_sym_struct,
    ACTIONS(11000), 1,
      anon_sym_union,
    ACTIONS(11004), 1,
      anon_sym_decltype,
    ACTIONS(11008), 1,
      anon_sym_interface,
    ACTIONS(11010), 1,
      anon_sym_extension,
    ACTIONS(11017), 1,
      sym_identifier,
    ACTIONS(11021), 1,
      sym_primitive_type,
    ACTIONS(11023), 1,
      anon_sym_enum,
    ACTIONS(11025), 1,
      anon_sym_typename,
    STATE(2735), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3192), 1,
      sym_qualified_type_identifier,
    STATE(3520), 1,
      sym_type_specifier,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(3140), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(11002), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11019), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3189), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [219379] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8310), 1,
      anon_sym_DASH_GT,
    ACTIONS(8326), 1,
      anon_sym_requires,
    ACTIONS(8328), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11083), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7297), 1,
      sym__function_attributes_end,
    STATE(7472), 1,
      sym_trailing_return_type,
    STATE(7626), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8399), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6599), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10823), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [219463] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9764), 1,
      anon_sym_STAR,
    ACTIONS(9766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9768), 1,
      anon_sym_AMP,
    STATE(3883), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8598), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9576), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_requires,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [219533] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9764), 1,
      anon_sym_STAR,
    ACTIONS(9766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9768), 1,
      anon_sym_AMP,
    STATE(3883), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8670), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7410), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_requires,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [219603] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6066), 1,
      sym_type_specifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [219685] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(6871), 1,
      sym_ms_call_modifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8414), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [219763] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8678), 1,
      sym_identifier,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8686), 1,
      anon_sym_enum,
    ACTIONS(8688), 1,
      anon_sym_class,
    ACTIONS(8690), 1,
      anon_sym_struct,
    ACTIONS(8692), 1,
      anon_sym_union,
    ACTIONS(8694), 1,
      anon_sym_typename,
    ACTIONS(8696), 1,
      anon_sym_interface,
    ACTIONS(8698), 1,
      anon_sym_extension,
    STATE(5224), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6542), 1,
      sym_type_specifier,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8682), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [219845] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9764), 1,
      anon_sym_STAR,
    ACTIONS(9766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9768), 1,
      anon_sym_AMP,
    STATE(3883), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8600), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9582), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_requires,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [219915] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9764), 1,
      anon_sym_STAR,
    ACTIONS(9766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9768), 1,
      anon_sym_AMP,
    STATE(3883), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8678), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8106), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_requires,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [219985] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(6823), 1,
      sym_ms_call_modifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8446), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [220063] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10902), 1,
      sym_identifier,
    ACTIONS(10904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10908), 1,
      sym_primitive_type,
    ACTIONS(10910), 1,
      anon_sym_enum,
    ACTIONS(10912), 1,
      anon_sym_class,
    ACTIONS(10914), 1,
      anon_sym_struct,
    ACTIONS(10916), 1,
      anon_sym_union,
    ACTIONS(10920), 1,
      anon_sym_decltype,
    ACTIONS(10922), 1,
      anon_sym_typename,
    ACTIONS(10924), 1,
      anon_sym_interface,
    ACTIONS(10926), 1,
      anon_sym_extension,
    STATE(2778), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3748), 1,
      sym_type_specifier,
    STATE(3787), 1,
      sym_qualified_type_identifier,
    STATE(8746), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(3704), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10918), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10906), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3774), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [220145] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(6829), 1,
      sym_ms_call_modifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8456), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [220223] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10996), 1,
      anon_sym_class,
    ACTIONS(10998), 1,
      anon_sym_struct,
    ACTIONS(11000), 1,
      anon_sym_union,
    ACTIONS(11004), 1,
      anon_sym_decltype,
    ACTIONS(11008), 1,
      anon_sym_interface,
    ACTIONS(11010), 1,
      anon_sym_extension,
    ACTIONS(11017), 1,
      sym_identifier,
    ACTIONS(11021), 1,
      sym_primitive_type,
    ACTIONS(11023), 1,
      anon_sym_enum,
    ACTIONS(11025), 1,
      anon_sym_typename,
    STATE(2735), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3104), 1,
      sym_type_specifier,
    STATE(3192), 1,
      sym_qualified_type_identifier,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(3140), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(11002), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11019), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3189), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [220305] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8650), 1,
      sym_identifier,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      anon_sym_enum,
    ACTIONS(8656), 1,
      anon_sym_class,
    ACTIONS(8658), 1,
      anon_sym_struct,
    ACTIONS(8660), 1,
      anon_sym_union,
    ACTIONS(8662), 1,
      anon_sym_typename,
    ACTIONS(8664), 1,
      anon_sym_interface,
    ACTIONS(8666), 1,
      anon_sym_extension,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(6364), 1,
      sym_type_specifier,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [220387] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9578), 1,
      anon_sym___attribute,
    ACTIONS(9821), 1,
      anon_sym_STAR,
    ACTIONS(9823), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9825), 1,
      anon_sym_AMP,
    STATE(4120), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8720), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9576), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_GT2,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [220459] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7412), 1,
      anon_sym___attribute,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9821), 1,
      anon_sym_STAR,
    ACTIONS(9823), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9825), 1,
      anon_sym_AMP,
    STATE(4120), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8726), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7410), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_GT2,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [220531] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10996), 1,
      anon_sym_class,
    ACTIONS(10998), 1,
      anon_sym_struct,
    ACTIONS(11000), 1,
      anon_sym_union,
    ACTIONS(11004), 1,
      anon_sym_decltype,
    ACTIONS(11008), 1,
      anon_sym_interface,
    ACTIONS(11010), 1,
      anon_sym_extension,
    ACTIONS(11017), 1,
      sym_identifier,
    ACTIONS(11021), 1,
      sym_primitive_type,
    ACTIONS(11023), 1,
      anon_sym_enum,
    ACTIONS(11025), 1,
      anon_sym_typename,
    STATE(2735), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3192), 1,
      sym_qualified_type_identifier,
    STATE(3521), 1,
      sym_type_specifier,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(3140), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(11002), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11019), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3189), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [220613] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10902), 1,
      sym_identifier,
    ACTIONS(10904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10908), 1,
      sym_primitive_type,
    ACTIONS(10910), 1,
      anon_sym_enum,
    ACTIONS(10912), 1,
      anon_sym_class,
    ACTIONS(10914), 1,
      anon_sym_struct,
    ACTIONS(10916), 1,
      anon_sym_union,
    ACTIONS(10920), 1,
      anon_sym_decltype,
    ACTIONS(10922), 1,
      anon_sym_typename,
    ACTIONS(10924), 1,
      anon_sym_interface,
    ACTIONS(10926), 1,
      anon_sym_extension,
    STATE(2778), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3578), 1,
      sym_type_specifier,
    STATE(3787), 1,
      sym_qualified_type_identifier,
    STATE(8746), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(3704), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10918), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10906), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3774), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [220695] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10986), 1,
      sym_identifier,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10992), 1,
      sym_primitive_type,
    ACTIONS(10994), 1,
      anon_sym_enum,
    ACTIONS(10996), 1,
      anon_sym_class,
    ACTIONS(10998), 1,
      anon_sym_struct,
    ACTIONS(11000), 1,
      anon_sym_union,
    ACTIONS(11004), 1,
      anon_sym_decltype,
    ACTIONS(11006), 1,
      anon_sym_typename,
    ACTIONS(11008), 1,
      anon_sym_interface,
    ACTIONS(11010), 1,
      anon_sym_extension,
    STATE(2739), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3192), 1,
      sym_qualified_type_identifier,
    STATE(3560), 1,
      sym_type_specifier,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(3140), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(11002), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10990), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3189), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [220777] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9584), 1,
      anon_sym___attribute,
    ACTIONS(9821), 1,
      anon_sym_STAR,
    ACTIONS(9823), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9825), 1,
      anon_sym_AMP,
    STATE(4120), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8651), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9582), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_GT2,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [220849] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11051), 1,
      sym_identifier,
    ACTIONS(11053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11057), 1,
      sym_primitive_type,
    ACTIONS(11059), 1,
      anon_sym_enum,
    ACTIONS(11061), 1,
      anon_sym_class,
    ACTIONS(11063), 1,
      anon_sym_struct,
    ACTIONS(11065), 1,
      anon_sym_union,
    ACTIONS(11069), 1,
      anon_sym_decltype,
    ACTIONS(11071), 1,
      anon_sym_typename,
    ACTIONS(11073), 1,
      anon_sym_interface,
    ACTIONS(11075), 1,
      anon_sym_extension,
    STATE(2815), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3737), 1,
      sym_type_specifier,
    STATE(4386), 1,
      sym_qualified_type_identifier,
    STATE(8630), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(4027), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(11067), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11055), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4320), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [220931] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6502), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [221013] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(8108), 1,
      anon_sym___attribute,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9831), 1,
      anon_sym_STAR,
    ACTIONS(9833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9835), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4273), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8740), 1,
      sym__abstract_declarator,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8106), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [221085] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(6833), 1,
      sym_ms_call_modifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8493), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [221163] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(8108), 1,
      anon_sym___attribute,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9296), 1,
      anon_sym_const,
    ACTIONS(9821), 1,
      anon_sym_STAR,
    ACTIONS(9823), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9825), 1,
      anon_sym_AMP,
    STATE(4120), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8761), 1,
      sym__abstract_declarator,
    ACTIONS(9298), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8106), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_GT2,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9286), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [221235] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9841), 1,
      anon_sym_STAR,
    ACTIONS(9843), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9845), 1,
      anon_sym_AMP,
    STATE(3767), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8631), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7410), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [221305] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(5995), 1,
      sym_type_specifier,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [221387] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10986), 1,
      sym_identifier,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10992), 1,
      sym_primitive_type,
    ACTIONS(10994), 1,
      anon_sym_enum,
    ACTIONS(10996), 1,
      anon_sym_class,
    ACTIONS(10998), 1,
      anon_sym_struct,
    ACTIONS(11000), 1,
      anon_sym_union,
    ACTIONS(11004), 1,
      anon_sym_decltype,
    ACTIONS(11006), 1,
      anon_sym_typename,
    ACTIONS(11008), 1,
      anon_sym_interface,
    ACTIONS(11010), 1,
      anon_sym_extension,
    STATE(2739), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3110), 1,
      sym_type_specifier,
    STATE(3192), 1,
      sym_qualified_type_identifier,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(3140), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(11002), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10990), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3189), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [221469] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8757), 1,
      sym_primitive_type,
    ACTIONS(11170), 1,
      sym_identifier,
    ACTIONS(11172), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11176), 1,
      anon_sym_enum,
    ACTIONS(11178), 1,
      anon_sym_class,
    ACTIONS(11180), 1,
      anon_sym_struct,
    ACTIONS(11182), 1,
      anon_sym_union,
    ACTIONS(11184), 1,
      anon_sym_typename,
    ACTIONS(11186), 1,
      anon_sym_interface,
    ACTIONS(11188), 1,
      anon_sym_extension,
    STATE(324), 1,
      sym_qualified_type_identifier,
    STATE(6447), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8669), 1,
      sym__scope_resolution,
    STATE(9150), 1,
      sym_type_specifier,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(125), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11174), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(315), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [221551] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11051), 1,
      sym_identifier,
    ACTIONS(11053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11057), 1,
      sym_primitive_type,
    ACTIONS(11059), 1,
      anon_sym_enum,
    ACTIONS(11061), 1,
      anon_sym_class,
    ACTIONS(11063), 1,
      anon_sym_struct,
    ACTIONS(11065), 1,
      anon_sym_union,
    ACTIONS(11069), 1,
      anon_sym_decltype,
    ACTIONS(11071), 1,
      anon_sym_typename,
    ACTIONS(11073), 1,
      anon_sym_interface,
    ACTIONS(11075), 1,
      anon_sym_extension,
    STATE(2815), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3718), 1,
      sym_type_specifier,
    STATE(4386), 1,
      sym_qualified_type_identifier,
    STATE(8630), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(4027), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(11067), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11055), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4320), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [221633] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8548), 1,
      sym_primitive_type,
    ACTIONS(11029), 1,
      sym_identifier,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11035), 1,
      anon_sym_enum,
    ACTIONS(11037), 1,
      anon_sym_class,
    ACTIONS(11039), 1,
      anon_sym_struct,
    ACTIONS(11041), 1,
      anon_sym_union,
    ACTIONS(11043), 1,
      anon_sym_typename,
    ACTIONS(11045), 1,
      anon_sym_interface,
    ACTIONS(11047), 1,
      anon_sym_extension,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(3065), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5087), 1,
      sym_type_specifier,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11033), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [221715] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(6870), 1,
      sym_ms_call_modifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8499), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [221793] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10960), 1,
      sym_identifier,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10966), 1,
      sym_primitive_type,
    ACTIONS(10968), 1,
      anon_sym_enum,
    ACTIONS(10970), 1,
      anon_sym_class,
    ACTIONS(10972), 1,
      anon_sym_struct,
    ACTIONS(10974), 1,
      anon_sym_union,
    ACTIONS(10978), 1,
      anon_sym_decltype,
    ACTIONS(10980), 1,
      anon_sym_typename,
    ACTIONS(10982), 1,
      anon_sym_interface,
    ACTIONS(10984), 1,
      anon_sym_extension,
    STATE(3156), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5351), 1,
      sym_qualified_type_identifier,
    STATE(5396), 1,
      sym_type_specifier,
    STATE(8676), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(5307), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10976), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10964), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5350), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [221875] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10986), 1,
      sym_identifier,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10992), 1,
      sym_primitive_type,
    ACTIONS(10994), 1,
      anon_sym_enum,
    ACTIONS(10996), 1,
      anon_sym_class,
    ACTIONS(10998), 1,
      anon_sym_struct,
    ACTIONS(11000), 1,
      anon_sym_union,
    ACTIONS(11004), 1,
      anon_sym_decltype,
    ACTIONS(11006), 1,
      anon_sym_typename,
    ACTIONS(11008), 1,
      anon_sym_interface,
    ACTIONS(11010), 1,
      anon_sym_extension,
    STATE(2739), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3104), 1,
      sym_type_specifier,
    STATE(3192), 1,
      sym_qualified_type_identifier,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(3140), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(11002), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10990), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3189), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [221957] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_enum,
    ACTIONS(213), 1,
      anon_sym_class,
    ACTIONS(215), 1,
      anon_sym_struct,
    ACTIONS(217), 1,
      anon_sym_union,
    ACTIONS(253), 1,
      anon_sym_decltype,
    ACTIONS(255), 1,
      anon_sym_typename,
    ACTIONS(277), 1,
      anon_sym_interface,
    ACTIONS(279), 1,
      anon_sym_extension,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2470), 1,
      sym_primitive_type,
    ACTIONS(4401), 1,
      sym_identifier,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    STATE(2717), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2888), 1,
      sym_qualified_type_identifier,
    STATE(3041), 1,
      sym_type_specifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(2842), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(251), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(203), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2839), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [222039] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(6826), 1,
      sym_ms_call_modifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8315), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [222117] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8620), 1,
      sym_identifier,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8626), 1,
      sym_primitive_type,
    ACTIONS(8628), 1,
      anon_sym_enum,
    ACTIONS(8630), 1,
      anon_sym_class,
    ACTIONS(8632), 1,
      anon_sym_struct,
    ACTIONS(8634), 1,
      anon_sym_union,
    ACTIONS(8638), 1,
      anon_sym_typename,
    ACTIONS(8640), 1,
      anon_sym_interface,
    ACTIONS(8642), 1,
      anon_sym_extension,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5922), 1,
      sym_qualified_type_identifier,
    STATE(5977), 1,
      sym_type_specifier,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8636), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6006), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [222199] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(73), 1,
      anon_sym_enum,
    ACTIONS(75), 1,
      anon_sym_class,
    ACTIONS(77), 1,
      anon_sym_struct,
    ACTIONS(79), 1,
      anon_sym_union,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(131), 1,
      anon_sym_typename,
    ACTIONS(169), 1,
      anon_sym_interface,
    ACTIONS(171), 1,
      anon_sym_extension,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11164), 1,
      sym_identifier,
    ACTIONS(11166), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11168), 1,
      sym_primitive_type,
    STATE(324), 1,
      sym_qualified_type_identifier,
    STATE(389), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(826), 1,
      sym_type_specifier,
    STATE(8640), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(125), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(59), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(315), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [222281] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8548), 1,
      sym_primitive_type,
    ACTIONS(11029), 1,
      sym_identifier,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11035), 1,
      anon_sym_enum,
    ACTIONS(11037), 1,
      anon_sym_class,
    ACTIONS(11039), 1,
      anon_sym_struct,
    ACTIONS(11041), 1,
      anon_sym_union,
    ACTIONS(11043), 1,
      anon_sym_typename,
    ACTIONS(11045), 1,
      anon_sym_interface,
    ACTIONS(11047), 1,
      anon_sym_extension,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(3065), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5100), 1,
      sym_type_specifier,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11033), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [222363] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(253), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2470), 1,
      sym_primitive_type,
    ACTIONS(2474), 1,
      anon_sym_class,
    ACTIONS(2476), 1,
      anon_sym_struct,
    ACTIONS(2478), 1,
      anon_sym_union,
    ACTIONS(2490), 1,
      anon_sym_interface,
    ACTIONS(2492), 1,
      anon_sym_extension,
    ACTIONS(4401), 1,
      sym_identifier,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4413), 1,
      anon_sym_enum,
    ACTIONS(4415), 1,
      anon_sym_typename,
    STATE(2888), 1,
      sym_qualified_type_identifier,
    STATE(3101), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3600), 1,
      sym_type_specifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(2842), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(251), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4411), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2839), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [222445] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8310), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11083), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11190), 1,
      anon_sym_requires,
    ACTIONS(11193), 1,
      anon_sym_where,
    STATE(7232), 1,
      sym__function_attributes_end,
    STATE(7545), 1,
      sym_trailing_return_type,
    STATE(7626), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(11086), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7914), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6741), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10823), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [222529] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8548), 1,
      sym_primitive_type,
    ACTIONS(11029), 1,
      sym_identifier,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11035), 1,
      anon_sym_enum,
    ACTIONS(11037), 1,
      anon_sym_class,
    ACTIONS(11039), 1,
      anon_sym_struct,
    ACTIONS(11041), 1,
      anon_sym_union,
    ACTIONS(11043), 1,
      anon_sym_typename,
    ACTIONS(11045), 1,
      anon_sym_interface,
    ACTIONS(11047), 1,
      anon_sym_extension,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(3065), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4987), 1,
      sym_type_specifier,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11033), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [222611] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8869), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10279), 1,
      anon_sym___attribute__,
    ACTIONS(10282), 1,
      anon_sym___attribute,
    ACTIONS(11129), 1,
      anon_sym_requires,
    ACTIONS(11196), 1,
      anon_sym_where,
    STATE(6518), 1,
      sym_ref_qualifier,
    STATE(7456), 1,
      sym__function_attributes_end,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7706), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8269), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6875), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [222701] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(6828), 1,
      sym_ms_call_modifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8331), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [222779] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8310), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10285), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10715), 1,
      anon_sym_requires,
    ACTIONS(10718), 1,
      anon_sym_where,
    STATE(7231), 1,
      sym__function_attributes_end,
    STATE(7544), 1,
      sym_trailing_return_type,
    STATE(7624), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10426), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7913), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6694), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [222863] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(6836), 1,
      sym_ms_call_modifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8333), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [222941] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10873), 1,
      sym_identifier,
    ACTIONS(10875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10879), 1,
      sym_primitive_type,
    ACTIONS(10881), 1,
      anon_sym_enum,
    ACTIONS(10883), 1,
      anon_sym_class,
    ACTIONS(10885), 1,
      anon_sym_struct,
    ACTIONS(10887), 1,
      anon_sym_union,
    ACTIONS(10891), 1,
      anon_sym_decltype,
    ACTIONS(10893), 1,
      anon_sym_typename,
    ACTIONS(10895), 1,
      anon_sym_interface,
    ACTIONS(10897), 1,
      anon_sym_extension,
    STATE(2788), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3662), 1,
      sym_type_specifier,
    STATE(3878), 1,
      sym_qualified_type_identifier,
    STATE(8655), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(3735), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10889), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10877), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3875), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [223023] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11199), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(6324), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(9909), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DASH_GT,
    ACTIONS(9911), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [223071] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(6840), 1,
      sym_ms_call_modifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8347), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [223149] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(6860), 1,
      sym_ms_call_modifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8363), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [223227] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10960), 1,
      sym_identifier,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10966), 1,
      sym_primitive_type,
    ACTIONS(10968), 1,
      anon_sym_enum,
    ACTIONS(10970), 1,
      anon_sym_class,
    ACTIONS(10972), 1,
      anon_sym_struct,
    ACTIONS(10974), 1,
      anon_sym_union,
    ACTIONS(10978), 1,
      anon_sym_decltype,
    ACTIONS(10980), 1,
      anon_sym_typename,
    ACTIONS(10982), 1,
      anon_sym_interface,
    ACTIONS(10984), 1,
      anon_sym_extension,
    STATE(3156), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5351), 1,
      sym_qualified_type_identifier,
    STATE(5447), 1,
      sym_type_specifier,
    STATE(8676), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(5307), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10976), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10964), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5350), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [223309] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_enum,
    ACTIONS(213), 1,
      anon_sym_class,
    ACTIONS(215), 1,
      anon_sym_struct,
    ACTIONS(217), 1,
      anon_sym_union,
    ACTIONS(253), 1,
      anon_sym_decltype,
    ACTIONS(255), 1,
      anon_sym_typename,
    ACTIONS(277), 1,
      anon_sym_interface,
    ACTIONS(279), 1,
      anon_sym_extension,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2470), 1,
      sym_primitive_type,
    ACTIONS(4401), 1,
      sym_identifier,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    STATE(2717), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2888), 1,
      sym_qualified_type_identifier,
    STATE(3047), 1,
      sym_type_specifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(2842), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(251), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(203), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2839), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [223391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3352), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(3362), 29,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [223435] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5092), 1,
      anon_sym_enum,
    ACTIONS(5094), 1,
      anon_sym_class,
    ACTIONS(5096), 1,
      anon_sym_struct,
    ACTIONS(5098), 1,
      anon_sym_union,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(5128), 1,
      anon_sym_typename,
    ACTIONS(5142), 1,
      anon_sym_interface,
    ACTIONS(5144), 1,
      anon_sym_extension,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8616), 1,
      sym_identifier,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(5986), 1,
      sym_type_specifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [223517] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10928), 1,
      sym_identifier,
    ACTIONS(10930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10934), 1,
      sym_primitive_type,
    ACTIONS(10936), 1,
      anon_sym_enum,
    ACTIONS(10938), 1,
      anon_sym_class,
    ACTIONS(10940), 1,
      anon_sym_struct,
    ACTIONS(10942), 1,
      anon_sym_union,
    ACTIONS(10946), 1,
      anon_sym_decltype,
    ACTIONS(10948), 1,
      anon_sym_typename,
    ACTIONS(10950), 1,
      anon_sym_interface,
    ACTIONS(10952), 1,
      anon_sym_extension,
    STATE(3068), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5051), 1,
      sym_type_specifier,
    STATE(5066), 1,
      sym_qualified_type_identifier,
    STATE(8723), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(4993), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10944), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10932), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5063), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [223599] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8757), 1,
      sym_primitive_type,
    ACTIONS(11170), 1,
      sym_identifier,
    ACTIONS(11172), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11176), 1,
      anon_sym_enum,
    ACTIONS(11178), 1,
      anon_sym_class,
    ACTIONS(11180), 1,
      anon_sym_struct,
    ACTIONS(11182), 1,
      anon_sym_union,
    ACTIONS(11184), 1,
      anon_sym_typename,
    ACTIONS(11186), 1,
      anon_sym_interface,
    ACTIONS(11188), 1,
      anon_sym_extension,
    STATE(324), 1,
      sym_qualified_type_identifier,
    STATE(6447), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8669), 1,
      sym__scope_resolution,
    STATE(9102), 1,
      sym_type_specifier,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(125), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11174), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(315), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [223681] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10873), 1,
      sym_identifier,
    ACTIONS(10875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10879), 1,
      sym_primitive_type,
    ACTIONS(10881), 1,
      anon_sym_enum,
    ACTIONS(10883), 1,
      anon_sym_class,
    ACTIONS(10885), 1,
      anon_sym_struct,
    ACTIONS(10887), 1,
      anon_sym_union,
    ACTIONS(10891), 1,
      anon_sym_decltype,
    ACTIONS(10893), 1,
      anon_sym_typename,
    ACTIONS(10895), 1,
      anon_sym_interface,
    ACTIONS(10897), 1,
      anon_sym_extension,
    STATE(2788), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3649), 1,
      sym_type_specifier,
    STATE(3878), 1,
      sym_qualified_type_identifier,
    STATE(8655), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(3735), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10889), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10877), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3875), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [223763] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8757), 1,
      sym_primitive_type,
    ACTIONS(11170), 1,
      sym_identifier,
    ACTIONS(11172), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11176), 1,
      anon_sym_enum,
    ACTIONS(11178), 1,
      anon_sym_class,
    ACTIONS(11180), 1,
      anon_sym_struct,
    ACTIONS(11182), 1,
      anon_sym_union,
    ACTIONS(11184), 1,
      anon_sym_typename,
    ACTIONS(11186), 1,
      anon_sym_interface,
    ACTIONS(11188), 1,
      anon_sym_extension,
    STATE(324), 1,
      sym_qualified_type_identifier,
    STATE(6447), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8669), 1,
      sym__scope_resolution,
    STATE(9038), 1,
      sym_type_specifier,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(125), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11174), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(315), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [223845] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(6817), 1,
      sym_ms_call_modifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8328), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [223923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3352), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3362), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [223967] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10873), 1,
      sym_identifier,
    ACTIONS(10875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10879), 1,
      sym_primitive_type,
    ACTIONS(10881), 1,
      anon_sym_enum,
    ACTIONS(10883), 1,
      anon_sym_class,
    ACTIONS(10885), 1,
      anon_sym_struct,
    ACTIONS(10887), 1,
      anon_sym_union,
    ACTIONS(10891), 1,
      anon_sym_decltype,
    ACTIONS(10893), 1,
      anon_sym_typename,
    ACTIONS(10895), 1,
      anon_sym_interface,
    ACTIONS(10897), 1,
      anon_sym_extension,
    STATE(2788), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3803), 1,
      sym_type_specifier,
    STATE(3878), 1,
      sym_qualified_type_identifier,
    STATE(8655), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(3735), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10889), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10877), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3875), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [224049] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(6849), 1,
      sym_ms_call_modifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8464), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [224127] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8812), 1,
      anon_sym_DASH_GT,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(8816), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10279), 1,
      anon_sym___attribute__,
    ACTIONS(10282), 1,
      anon_sym___attribute,
    STATE(6483), 1,
      sym_ref_qualifier,
    STATE(7536), 1,
      sym__function_attributes_end,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7657), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8722), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6882), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [224217] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6509), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(11205), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(6340), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(11202), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9353), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(9351), 21,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [224269] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(6850), 1,
      sym_ms_call_modifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8466), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [224347] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10873), 1,
      sym_identifier,
    ACTIONS(10875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10879), 1,
      sym_primitive_type,
    ACTIONS(10881), 1,
      anon_sym_enum,
    ACTIONS(10883), 1,
      anon_sym_class,
    ACTIONS(10885), 1,
      anon_sym_struct,
    ACTIONS(10887), 1,
      anon_sym_union,
    ACTIONS(10891), 1,
      anon_sym_decltype,
    ACTIONS(10893), 1,
      anon_sym_typename,
    ACTIONS(10895), 1,
      anon_sym_interface,
    ACTIONS(10897), 1,
      anon_sym_extension,
    STATE(2788), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3809), 1,
      sym_type_specifier,
    STATE(3878), 1,
      sym_qualified_type_identifier,
    STATE(8655), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(3735), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10889), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10877), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3875), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [224429] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10902), 1,
      sym_identifier,
    ACTIONS(10904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10908), 1,
      sym_primitive_type,
    ACTIONS(10910), 1,
      anon_sym_enum,
    ACTIONS(10912), 1,
      anon_sym_class,
    ACTIONS(10914), 1,
      anon_sym_struct,
    ACTIONS(10916), 1,
      anon_sym_union,
    ACTIONS(10920), 1,
      anon_sym_decltype,
    ACTIONS(10922), 1,
      anon_sym_typename,
    ACTIONS(10924), 1,
      anon_sym_interface,
    ACTIONS(10926), 1,
      anon_sym_extension,
    STATE(2778), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3724), 1,
      sym_type_specifier,
    STATE(3787), 1,
      sym_qualified_type_identifier,
    STATE(8746), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(3704), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10918), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10906), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3774), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [224511] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8684), 1,
      sym_primitive_type,
    ACTIONS(8731), 1,
      sym_identifier,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8737), 1,
      anon_sym_enum,
    ACTIONS(8739), 1,
      anon_sym_class,
    ACTIONS(8741), 1,
      anon_sym_struct,
    ACTIONS(8743), 1,
      anon_sym_union,
    ACTIONS(8745), 1,
      anon_sym_typename,
    ACTIONS(8747), 1,
      anon_sym_interface,
    ACTIONS(8749), 1,
      anon_sym_extension,
    STATE(5394), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6773), 1,
      sym_type_specifier,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8735), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [224593] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      sym_primitive_type,
    ACTIONS(8830), 1,
      anon_sym_enum,
    ACTIONS(8832), 1,
      anon_sym_class,
    ACTIONS(8834), 1,
      anon_sym_struct,
    ACTIONS(8836), 1,
      anon_sym_union,
    ACTIONS(8838), 1,
      anon_sym_typename,
    ACTIONS(8840), 1,
      anon_sym_interface,
    ACTIONS(8842), 1,
      anon_sym_extension,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(6223), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6774), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8826), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [224675] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8757), 1,
      sym_primitive_type,
    ACTIONS(11170), 1,
      sym_identifier,
    ACTIONS(11172), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11176), 1,
      anon_sym_enum,
    ACTIONS(11178), 1,
      anon_sym_class,
    ACTIONS(11180), 1,
      anon_sym_struct,
    ACTIONS(11182), 1,
      anon_sym_union,
    ACTIONS(11184), 1,
      anon_sym_typename,
    ACTIONS(11186), 1,
      anon_sym_interface,
    ACTIONS(11188), 1,
      anon_sym_extension,
    STATE(324), 1,
      sym_qualified_type_identifier,
    STATE(6447), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8669), 1,
      sym__scope_resolution,
    STATE(9152), 1,
      sym_type_specifier,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(256), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(125), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11174), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(315), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [224757] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10960), 1,
      sym_identifier,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10966), 1,
      sym_primitive_type,
    ACTIONS(10968), 1,
      anon_sym_enum,
    ACTIONS(10970), 1,
      anon_sym_class,
    ACTIONS(10972), 1,
      anon_sym_struct,
    ACTIONS(10974), 1,
      anon_sym_union,
    ACTIONS(10978), 1,
      anon_sym_decltype,
    ACTIONS(10980), 1,
      anon_sym_typename,
    ACTIONS(10982), 1,
      anon_sym_interface,
    ACTIONS(10984), 1,
      anon_sym_extension,
    STATE(3156), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5138), 1,
      sym_type_specifier,
    STATE(5351), 1,
      sym_qualified_type_identifier,
    STATE(8676), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(5307), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(10976), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(10964), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5350), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [224839] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9578), 1,
      anon_sym___attribute,
    ACTIONS(9831), 1,
      anon_sym_STAR,
    ACTIONS(9833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9835), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4273), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8753), 1,
      sym__abstract_declarator,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9576), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [224911] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(7412), 1,
      anon_sym___attribute,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9831), 1,
      anon_sym_STAR,
    ACTIONS(9833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9835), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4273), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8675), 1,
      sym__abstract_declarator,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7410), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [224983] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      sym_primitive_type,
    ACTIONS(8830), 1,
      anon_sym_enum,
    ACTIONS(8832), 1,
      anon_sym_class,
    ACTIONS(8834), 1,
      anon_sym_struct,
    ACTIONS(8836), 1,
      anon_sym_union,
    ACTIONS(8838), 1,
      anon_sym_typename,
    ACTIONS(8840), 1,
      anon_sym_interface,
    ACTIONS(8842), 1,
      anon_sym_extension,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(6223), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6788), 1,
      sym_type_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(8826), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [225065] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(6855), 1,
      sym_ms_call_modifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8483), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [225143] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_decltype,
    ACTIONS(8548), 1,
      sym_primitive_type,
    ACTIONS(11029), 1,
      sym_identifier,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11035), 1,
      anon_sym_enum,
    ACTIONS(11037), 1,
      anon_sym_class,
    ACTIONS(11039), 1,
      anon_sym_struct,
    ACTIONS(11041), 1,
      anon_sym_union,
    ACTIONS(11043), 1,
      anon_sym_typename,
    ACTIONS(11045), 1,
      anon_sym_interface,
    ACTIONS(11047), 1,
      anon_sym_extension,
    STATE(3038), 1,
      sym_qualified_type_identifier,
    STATE(3065), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4986), 1,
      sym_type_specifier,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(2997), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2855), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11033), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3062), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [225225] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9584), 1,
      anon_sym___attribute,
    ACTIONS(9831), 1,
      anon_sym_STAR,
    ACTIONS(9833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9835), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4273), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8765), 1,
      sym__abstract_declarator,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9582), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [225297] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(253), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2470), 1,
      sym_primitive_type,
    ACTIONS(2472), 1,
      anon_sym_enum,
    ACTIONS(2474), 1,
      anon_sym_class,
    ACTIONS(2476), 1,
      anon_sym_struct,
    ACTIONS(2478), 1,
      anon_sym_union,
    ACTIONS(2480), 1,
      anon_sym_typename,
    ACTIONS(2490), 1,
      anon_sym_interface,
    ACTIONS(2492), 1,
      anon_sym_extension,
    ACTIONS(4401), 1,
      sym_identifier,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    STATE(2717), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2888), 1,
      sym_qualified_type_identifier,
    STATE(3503), 1,
      sym_type_specifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(2842), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(251), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(203), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2839), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [225379] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(253), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2470), 1,
      sym_primitive_type,
    ACTIONS(2472), 1,
      anon_sym_enum,
    ACTIONS(2474), 1,
      anon_sym_class,
    ACTIONS(2476), 1,
      anon_sym_struct,
    ACTIONS(2478), 1,
      anon_sym_union,
    ACTIONS(2480), 1,
      anon_sym_typename,
    ACTIONS(2490), 1,
      anon_sym_interface,
    ACTIONS(2492), 1,
      anon_sym_extension,
    ACTIONS(4401), 1,
      sym_identifier,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    STATE(2717), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2888), 1,
      sym_qualified_type_identifier,
    STATE(3493), 1,
      sym_type_specifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(2842), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(251), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(203), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2839), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [225461] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(6825), 1,
      sym_ms_call_modifier,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8388), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [225539] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5126), 1,
      anon_sym_decltype,
    ACTIONS(8596), 1,
      sym_identifier,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8600), 1,
      sym_primitive_type,
    ACTIONS(8602), 1,
      anon_sym_enum,
    ACTIONS(8604), 1,
      anon_sym_class,
    ACTIONS(8606), 1,
      anon_sym_struct,
    ACTIONS(8608), 1,
      anon_sym_union,
    ACTIONS(8610), 1,
      anon_sym_typename,
    ACTIONS(8612), 1,
      anon_sym_interface,
    ACTIONS(8614), 1,
      anon_sym_extension,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5663), 1,
      sym_qualified_type_identifier,
    STATE(6501), 1,
      sym_type_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_dependent_type_identifier,
    STATE(5498), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5122), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5702), 10,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
      sym_interface_specifier,
      sym_extension_specifier,
      sym_associatedtype_specifier,
  [225621] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8571), 1,
      anon_sym_noexcept,
    ACTIONS(8573), 1,
      anon_sym_throw,
    ACTIONS(8963), 1,
      anon_sym_DASH_GT,
    ACTIONS(8984), 1,
      anon_sym_requires,
    ACTIONS(8986), 1,
      anon_sym_where,
    STATE(6540), 1,
      sym_ref_qualifier,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7873), 1,
      sym__function_attributes_end,
    STATE(8149), 1,
      sym_trailing_return_type,
    STATE(9020), 1,
      sym_gnu_asm_expression,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(10024), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(10026), 2,
      anon_sym_LBRACK,
      sym_identifier,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7712), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(9170), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    STATE(6891), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [225706] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7412), 1,
      sym_identifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9895), 1,
      anon_sym_STAR,
    ACTIONS(9897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9899), 1,
      anon_sym_AMP,
    STATE(3869), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8877), 1,
      sym__abstract_declarator,
    ACTIONS(9540), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7410), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9296), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [225775] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(10838), 1,
      anon_sym_requires,
    ACTIONS(11208), 1,
      anon_sym_where,
    STATE(7521), 1,
      sym__function_attributes_end,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7732), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8286), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6812), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [225858] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10037), 1,
      anon_sym_LBRACE,
    STATE(5643), 1,
      sym_attribute_specifier,
    STATE(6494), 1,
      sym_enumerator_list,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(3991), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3993), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [225909] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9580), 1,
      anon_sym_DOT,
    ACTIONS(4244), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9329), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4246), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [225956] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(9887), 1,
      anon_sym_LPAREN2,
    ACTIONS(9901), 1,
      sym_identifier,
    ACTIONS(9903), 1,
      anon_sym_STAR,
    ACTIONS(9905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9907), 1,
      anon_sym_AMP,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7754), 1,
      sym__field_declarator,
    STATE(8031), 1,
      sym_operator_name,
    STATE(10874), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8244), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [226025] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9580), 1,
      anon_sym_DOT,
    ACTIONS(4252), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9329), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4254), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [226072] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(9181), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(11129), 1,
      anon_sym_requires,
    STATE(6553), 1,
      sym_ref_qualifier,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7755), 1,
      sym__function_attributes_end,
    STATE(8099), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9000), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
    STATE(6893), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [226161] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(9887), 1,
      anon_sym_LPAREN2,
    ACTIONS(9901), 1,
      sym_identifier,
    ACTIONS(9903), 1,
      anon_sym_STAR,
    ACTIONS(9905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9907), 1,
      anon_sym_AMP,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7854), 1,
      sym__field_declarator,
    STATE(8031), 1,
      sym_operator_name,
    STATE(10874), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8244), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [226230] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8988), 1,
      anon_sym_DASH_GT,
    ACTIONS(9189), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    STATE(6555), 1,
      sym_ref_qualifier,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7792), 1,
      sym__function_attributes_end,
    STATE(8078), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9055), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(6901), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [226319] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8440), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(10838), 1,
      anon_sym_requires,
    ACTIONS(11077), 1,
      anon_sym___attribute__,
    ACTIONS(11080), 1,
      anon_sym___attribute,
    ACTIONS(11211), 1,
      anon_sym_where,
    STATE(7339), 1,
      sym__function_attributes_end,
    STATE(7517), 1,
      sym_trailing_return_type,
    STATE(7537), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7982), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6805), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
  [226402] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    STATE(7478), 1,
      sym__function_attributes_end,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7645), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8609), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6764), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [226485] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(5519), 1,
      anon_sym_STAR,
    ACTIONS(5521), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5523), 1,
      anon_sym_AMP,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8842), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8106), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [226554] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    STATE(7471), 1,
      sym__function_attributes_end,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7641), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8607), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6759), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [226637] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9851), 1,
      anon_sym_DOT,
    ACTIONS(4252), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4254), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [226684] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(9885), 1,
      sym_identifier,
    ACTIONS(9887), 1,
      anon_sym_LPAREN2,
    ACTIONS(9889), 1,
      anon_sym_STAR,
    ACTIONS(9891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9893), 1,
      anon_sym_AMP,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(8776), 1,
      sym__field_declarator,
    STATE(9120), 1,
      sym_operator_name,
    STATE(11011), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8244), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [226753] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(8108), 1,
      sym_identifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9895), 1,
      anon_sym_STAR,
    ACTIONS(9897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9899), 1,
      anon_sym_AMP,
    STATE(3869), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8880), 1,
      sym__abstract_declarator,
    ACTIONS(9540), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8106), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9296), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [226822] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9174), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(11152), 1,
      anon_sym_requires,
    ACTIONS(11214), 1,
      anon_sym_where,
    STATE(6539), 1,
      sym_ref_qualifier,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7861), 1,
      sym__function_attributes_end,
    STATE(8114), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(6903), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [226911] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9584), 1,
      sym_identifier,
    ACTIONS(9895), 1,
      anon_sym_STAR,
    ACTIONS(9897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9899), 1,
      anon_sym_AMP,
    STATE(3869), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8866), 1,
      sym__abstract_declarator,
    ACTIONS(9540), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9582), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9296), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [226980] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(9885), 1,
      sym_identifier,
    ACTIONS(9887), 1,
      anon_sym_LPAREN2,
    ACTIONS(9889), 1,
      anon_sym_STAR,
    ACTIONS(9891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9893), 1,
      anon_sym_AMP,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(8779), 1,
      sym__field_declarator,
    STATE(9120), 1,
      sym_operator_name,
    STATE(11011), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8244), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [227049] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    STATE(320), 1,
      sym_attribute_specifier,
    ACTIONS(4004), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4002), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [227098] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    STATE(323), 1,
      sym_attribute_specifier,
    ACTIONS(4091), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4089), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [227147] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8440), 1,
      anon_sym_DASH_GT,
    ACTIONS(8442), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11077), 1,
      anon_sym___attribute__,
    ACTIONS(11080), 1,
      anon_sym___attribute,
    STATE(7335), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_trailing_return_type,
    STATE(7537), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8339), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6771), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
  [227230] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(5519), 1,
      anon_sym_STAR,
    ACTIONS(5521), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5523), 1,
      anon_sym_AMP,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8879), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9582), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [227299] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(9885), 1,
      sym_identifier,
    ACTIONS(9887), 1,
      anon_sym_LPAREN2,
    ACTIONS(9889), 1,
      anon_sym_STAR,
    ACTIONS(9891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9893), 1,
      anon_sym_AMP,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(8774), 1,
      sym__field_declarator,
    STATE(9120), 1,
      sym_operator_name,
    STATE(11011), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8244), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [227368] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8988), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(11129), 1,
      anon_sym_requires,
    ACTIONS(11217), 1,
      anon_sym_where,
    STATE(6559), 1,
      sym_ref_qualifier,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7799), 1,
      sym__function_attributes_end,
    STATE(8136), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8708), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(6890), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [227457] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8440), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10031), 1,
      anon_sym_requires,
    ACTIONS(10279), 1,
      anon_sym___attribute__,
    ACTIONS(10282), 1,
      anon_sym___attribute,
    ACTIONS(10899), 1,
      anon_sym_where,
    STATE(7338), 1,
      sym__function_attributes_end,
    STATE(7515), 1,
      sym_trailing_return_type,
    STATE(7549), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7981), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6804), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
  [227540] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7414), 1,
      anon_sym_LBRACE,
    STATE(3021), 1,
      sym_attribute_specifier,
    STATE(6525), 1,
      sym_enumerator_list,
    ACTIONS(8129), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(3987), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(3989), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [227591] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7414), 1,
      anon_sym_LBRACE,
    STATE(3032), 1,
      sym_attribute_specifier,
    STATE(6528), 1,
      sym_enumerator_list,
    ACTIONS(8129), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(3991), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(3993), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [227642] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    STATE(297), 1,
      sym_attribute_specifier,
    ACTIONS(4200), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4198), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [227691] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    STATE(303), 1,
      sym_attribute_specifier,
    ACTIONS(4107), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4109), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [227740] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(9887), 1,
      anon_sym_LPAREN2,
    ACTIONS(9901), 1,
      sym_identifier,
    ACTIONS(9903), 1,
      anon_sym_STAR,
    ACTIONS(9905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9907), 1,
      anon_sym_AMP,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7864), 1,
      sym__field_declarator,
    STATE(8031), 1,
      sym_operator_name,
    STATE(10874), 1,
      sym_ms_based_modifier,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8244), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [227809] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    STATE(286), 1,
      sym_attribute_specifier,
    ACTIONS(4010), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4008), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [227858] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8974), 1,
      anon_sym_DASH_GT,
    ACTIONS(9183), 1,
      anon_sym_requires,
    ACTIONS(9185), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(11220), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6565), 1,
      sym_ref_qualifier,
    STATE(7624), 1,
      sym_where_clause,
    STATE(7694), 1,
      sym__function_attributes_end,
    STATE(8004), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9006), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(6904), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [227947] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    STATE(287), 1,
      sym_attribute_specifier,
    ACTIONS(4014), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4012), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [227996] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10037), 1,
      anon_sym_LBRACE,
    STATE(5630), 1,
      sym_attribute_specifier,
    STATE(6485), 1,
      sym_enumerator_list,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(3987), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3989), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [228047] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    STATE(329), 1,
      sym_attribute_specifier,
    ACTIONS(4156), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4154), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [228096] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    STATE(307), 1,
      sym_attribute_specifier,
    ACTIONS(4060), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4058), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [228145] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    STATE(310), 1,
      sym_attribute_specifier,
    ACTIONS(4045), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4043), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [228194] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    STATE(311), 1,
      sym_attribute_specifier,
    ACTIONS(4049), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4047), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [228243] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(5519), 1,
      anon_sym_STAR,
    ACTIONS(5521), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5523), 1,
      anon_sym_AMP,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8878), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7410), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [228312] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    STATE(316), 1,
      sym_attribute_specifier,
    ACTIONS(4087), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4085), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [228361] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    STATE(319), 1,
      sym_attribute_specifier,
    ACTIONS(4176), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4174), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [228410] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(5519), 1,
      anon_sym_STAR,
    ACTIONS(5521), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5523), 1,
      anon_sym_AMP,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8863), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9576), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [228479] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9578), 1,
      sym_identifier,
    ACTIONS(9895), 1,
      anon_sym_STAR,
    ACTIONS(9897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9899), 1,
      anon_sym_AMP,
    STATE(3869), 1,
      sym_parameter_list,
    STATE(6336), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8862), 1,
      sym__abstract_declarator,
    ACTIONS(9540), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5969), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9576), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9296), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [228548] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(5525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(10603), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10607), 1,
      anon_sym_EQ,
    ACTIONS(11223), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2897), 1,
      sym__class_declaration,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(7095), 1,
      sym_ms_declspec_modifier,
    STATE(8769), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(10605), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(2737), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7096), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6783), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [228639] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(9174), 1,
      anon_sym_DASH_GT,
    ACTIONS(9176), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    STATE(6573), 1,
      sym_ref_qualifier,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7857), 1,
      sym__function_attributes_end,
    STATE(8107), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9184), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(6902), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [228728] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8571), 1,
      anon_sym_noexcept,
    ACTIONS(8573), 1,
      anon_sym_throw,
    ACTIONS(8963), 1,
      anon_sym_DASH_GT,
    ACTIONS(11225), 1,
      anon_sym_requires,
    ACTIONS(11228), 1,
      anon_sym_where,
    STATE(6536), 1,
      sym_ref_qualifier,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7865), 1,
      sym__function_attributes_end,
    STATE(8016), 1,
      sym_trailing_return_type,
    STATE(9020), 1,
      sym_gnu_asm_expression,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(10024), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(10026), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(11098), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7712), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8770), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    STATE(6909), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [228813] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10031), 1,
      anon_sym_requires,
    ACTIONS(11012), 1,
      anon_sym_where,
    STATE(7494), 1,
      sym__function_attributes_end,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7714), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8285), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6800), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [228896] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9851), 1,
      anon_sym_DOT,
    ACTIONS(4244), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(9373), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4246), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [228943] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8440), 1,
      anon_sym_DASH_GT,
    ACTIONS(8442), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10279), 1,
      anon_sym___attribute__,
    ACTIONS(10282), 1,
      anon_sym___attribute,
    STATE(7334), 1,
      sym__function_attributes_end,
    STATE(7503), 1,
      sym_trailing_return_type,
    STATE(7549), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8338), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6814), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
  [229026] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8123), 1,
      anon_sym_AMP,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8974), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(11220), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11231), 1,
      anon_sym_requires,
    ACTIONS(11234), 1,
      anon_sym_where,
    STATE(6563), 1,
      sym_ref_qualifier,
    STATE(7624), 1,
      sym_where_clause,
    STATE(7730), 1,
      sym__function_attributes_end,
    STATE(8005), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10426), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8545), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(6898), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [229115] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11239), 1,
      anon_sym_LBRACE,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4733), 1,
      sym_compound_statement,
    STATE(6445), 1,
      sym_template_parameter_list,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10754), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [229191] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10165), 1,
      anon_sym_LT,
    ACTIONS(11243), 1,
      anon_sym_COLON,
    STATE(5227), 1,
      sym_template_argument_list,
    STATE(5687), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9940), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2176), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2168), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [229245] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11245), 1,
      anon_sym_LBRACE,
    ACTIONS(11247), 1,
      anon_sym_requires,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4932), 1,
      sym_compound_statement,
    STATE(6556), 1,
      sym_requires_clause,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10518), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [229321] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2881), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(11249), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4187), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(4185), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [229367] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(10043), 1,
      anon_sym_STAR,
    ACTIONS(10045), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10047), 1,
      anon_sym_AMP,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4464), 1,
      sym_parameter_list,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8993), 1,
      sym__abstract_declarator,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6798), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9576), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [229435] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11252), 1,
      anon_sym_LBRACE,
    STATE(1767), 1,
      sym_compound_statement,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6435), 1,
      sym_template_parameter_list,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10467), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [229511] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10165), 1,
      anon_sym_LT,
    ACTIONS(11254), 1,
      anon_sym_COLON,
    STATE(5227), 1,
      sym_template_argument_list,
    STATE(5687), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9940), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2176), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2168), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [229565] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8566), 1,
      anon_sym_DASH_GT,
    ACTIONS(8571), 1,
      anon_sym_noexcept,
    ACTIONS(8573), 1,
      anon_sym_throw,
    ACTIONS(8586), 1,
      anon_sym_requires,
    ACTIONS(8588), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7616), 1,
      sym__function_attributes_end,
    STATE(7766), 1,
      sym_trailing_return_type,
    STATE(8986), 1,
      sym_gnu_asm_expression,
    ACTIONS(8562), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(10825), 2,
      anon_sym_LBRACK,
      sym_identifier,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7531), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8821), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    STATE(6852), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
  [229643] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11256), 1,
      anon_sym_requires,
    ACTIONS(11259), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7560), 1,
      sym__function_attributes_end,
    STATE(7816), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8442), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6830), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10823), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [229725] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6474), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2972), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(2974), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [229769] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8592), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7622), 1,
      sym__function_attributes_end,
    STATE(7802), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8892), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6822), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [229851] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8172), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    STATE(7033), 1,
      sym__function_attributes_end,
    STATE(7305), 1,
      sym_trailing_return_type,
    STATE(7465), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8175), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [229927] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11247), 1,
      anon_sym_requires,
    ACTIONS(11266), 1,
      anon_sym_LBRACE,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4612), 1,
      sym_compound_statement,
    STATE(6561), 1,
      sym_requires_clause,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10353), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [230003] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4277), 1,
      sym_compound_statement,
    STATE(6434), 1,
      sym_template_parameter_list,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10522), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [230079] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8592), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7564), 1,
      sym__function_attributes_end,
    STATE(7888), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8889), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6839), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10823), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [230161] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10004), 1,
      anon_sym_STAR,
    ACTIONS(10006), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10008), 1,
      anon_sym_AMP,
    STATE(4446), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8980), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8106), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_requires,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [230229] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11247), 1,
      anon_sym_requires,
    ACTIONS(11268), 1,
      anon_sym_LBRACE,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6546), 1,
      sym_requires_clause,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(7162), 1,
      sym_compound_statement,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10732), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [230305] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11247), 1,
      anon_sym_requires,
    ACTIONS(11270), 1,
      anon_sym_LBRACE,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5181), 1,
      sym_compound_statement,
    STATE(6562), 1,
      sym_requires_clause,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10509), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [230381] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11247), 1,
      anon_sym_requires,
    STATE(1663), 1,
      sym_compound_statement,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6548), 1,
      sym_requires_clause,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10400), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [230457] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11272), 1,
      anon_sym_LBRACE,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3452), 1,
      sym_compound_statement,
    STATE(6443), 1,
      sym_template_parameter_list,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10510), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [230533] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8172), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    STATE(7032), 1,
      sym__function_attributes_end,
    STATE(7304), 1,
      sym_trailing_return_type,
    STATE(7537), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [230609] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11268), 1,
      anon_sym_LBRACE,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6426), 1,
      sym_template_parameter_list,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(7146), 1,
      sym_compound_statement,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10633), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [230685] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6462), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(11274), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4051), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(4053), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [230731] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11270), 1,
      anon_sym_LBRACE,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5205), 1,
      sym_compound_statement,
    STATE(6427), 1,
      sym_template_parameter_list,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10347), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [230807] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11247), 1,
      anon_sym_requires,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4028), 1,
      sym_compound_statement,
    STATE(6568), 1,
      sym_requires_clause,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10564), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [230883] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11247), 1,
      anon_sym_requires,
    ACTIONS(11252), 1,
      anon_sym_LBRACE,
    STATE(1663), 1,
      sym_compound_statement,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6566), 1,
      sym_requires_clause,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10621), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [230959] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    STATE(1767), 1,
      sym_compound_statement,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6428), 1,
      sym_template_parameter_list,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10388), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [231035] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11277), 1,
      anon_sym_LBRACE,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4277), 1,
      sym_compound_statement,
    STATE(6440), 1,
      sym_template_parameter_list,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10402), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [231111] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8594), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10031), 1,
      anon_sym_requires,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7569), 1,
      sym__function_attributes_end,
    STATE(7782), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8616), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6838), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [231193] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11266), 1,
      anon_sym_LBRACE,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4645), 1,
      sym_compound_statement,
    STATE(6422), 1,
      sym_template_parameter_list,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10692), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [231269] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11247), 1,
      anon_sym_requires,
    ACTIONS(11277), 1,
      anon_sym_LBRACE,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4028), 1,
      sym_compound_statement,
    STATE(6564), 1,
      sym_requires_clause,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10546), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [231345] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9460), 1,
      anon_sym_LT,
    STATE(2953), 1,
      sym_template_argument_list,
    STATE(6468), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2176), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(11279), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2168), 22,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [231397] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(10043), 1,
      anon_sym_STAR,
    ACTIONS(10045), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10047), 1,
      anon_sym_AMP,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4464), 1,
      sym_parameter_list,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8998), 1,
      sym__abstract_declarator,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6798), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7410), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [231465] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11247), 1,
      anon_sym_requires,
    ACTIONS(11272), 1,
      anon_sym_LBRACE,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3454), 1,
      sym_compound_statement,
    STATE(6557), 1,
      sym_requires_clause,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10721), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [231541] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8566), 1,
      anon_sym_DASH_GT,
    ACTIONS(8571), 1,
      anon_sym_noexcept,
    ACTIONS(8573), 1,
      anon_sym_throw,
    ACTIONS(11284), 1,
      anon_sym_requires,
    ACTIONS(11287), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7599), 1,
      sym__function_attributes_end,
    STATE(7883), 1,
      sym_trailing_return_type,
    STATE(8986), 1,
      sym_gnu_asm_expression,
    ACTIONS(8562), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(10825), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(11281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7531), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8418), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    STATE(6866), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
  [231619] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11239), 1,
      anon_sym_LBRACE,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11247), 1,
      anon_sym_requires,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4769), 1,
      sym_compound_statement,
    STATE(6544), 1,
      sym_requires_clause,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10499), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [231695] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9770), 1,
      sym_identifier,
    ACTIONS(9774), 1,
      sym_primitive_type,
    STATE(2719), 1,
      sym_alignas_qualifier,
    STATE(5833), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(11292), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2679), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3542), 4,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_GT2,
    ACTIONS(9772), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3540), 5,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11290), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [231753] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9760), 1,
      sym_identifier,
    ACTIONS(9762), 1,
      sym_primitive_type,
    STATE(2719), 1,
      sym_alignas_qualifier,
    STATE(6586), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(11292), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6446), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3423), 4,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_GT2,
    ACTIONS(11294), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3428), 5,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11290), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [231811] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3683), 1,
      anon_sym_AMP,
    ACTIONS(10211), 1,
      anon_sym_const,
    STATE(5539), 1,
      sym_alignas_qualifier,
    ACTIONS(11299), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(11296), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(3681), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [231863] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10031), 1,
      anon_sym_requires,
    ACTIONS(10034), 1,
      anon_sym_where,
    STATE(7040), 1,
      sym__function_attributes_end,
    STATE(7318), 1,
      sym_trailing_return_type,
    STATE(7549), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7724), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [231939] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2881), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(11302), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4062), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(4064), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [231985] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(10043), 1,
      anon_sym_STAR,
    ACTIONS(10045), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10047), 1,
      anon_sym_AMP,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4464), 1,
      sym_parameter_list,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8999), 1,
      sym__abstract_declarator,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6798), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9582), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [232053] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(10838), 1,
      anon_sym_requires,
    ACTIONS(10841), 1,
      anon_sym_where,
    STATE(7041), 1,
      sym__function_attributes_end,
    STATE(7319), 1,
      sym_trailing_return_type,
    STATE(7537), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7725), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [232129] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2881), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(11305), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4121), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(4124), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [232175] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2881), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(11309), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4071), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(4073), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [232221] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10004), 1,
      anon_sym_STAR,
    ACTIONS(10006), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10008), 1,
      anon_sym_AMP,
    STATE(4446), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8955), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7410), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_requires,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [232289] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11315), 1,
      anon_sym_requires,
    ACTIONS(11318), 1,
      anon_sym_where,
    STATE(7042), 1,
      sym__function_attributes_end,
    STATE(7320), 1,
      sym_trailing_return_type,
    STATE(7465), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(11312), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7727), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [232365] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11321), 1,
      anon_sym_LBRACE,
    STATE(1767), 1,
      sym_compound_statement,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6466), 1,
      sym_template_parameter_list,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10478), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [232441] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11247), 1,
      anon_sym_requires,
    ACTIONS(11323), 1,
      anon_sym_LBRACE,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6572), 1,
      sym_requires_clause,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(6958), 1,
      sym_compound_statement,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10777), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [232517] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8594), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(10838), 1,
      anon_sym_requires,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7587), 1,
      sym__function_attributes_end,
    STATE(7808), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8617), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6832), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10823), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [232599] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2881), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(11325), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3997), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(3995), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [232645] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(11129), 1,
      anon_sym_requires,
    ACTIONS(11132), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7558), 1,
      sym__function_attributes_end,
    STATE(7795), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8367), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6863), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [232727] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2881), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(11328), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4100), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(4102), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [232773] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10165), 1,
      anon_sym_LT,
    ACTIONS(11331), 1,
      anon_sym_COLON,
    STATE(5227), 1,
      sym_template_argument_list,
    STATE(5687), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9940), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2176), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2168), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [232827] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6450), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(11333), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4166), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(4164), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [232873] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11245), 1,
      anon_sym_LBRACE,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4942), 1,
      sym_compound_statement,
    STATE(6412), 1,
      sym_template_parameter_list,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10377), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [232949] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11247), 1,
      anon_sym_requires,
    ACTIONS(11321), 1,
      anon_sym_LBRACE,
    STATE(1663), 1,
      sym_compound_statement,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6541), 1,
      sym_requires_clause,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10481), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [233025] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10004), 1,
      anon_sym_STAR,
    ACTIONS(10006), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10008), 1,
      anon_sym_AMP,
    STATE(4446), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9014), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9576), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_requires,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [233093] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2881), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(11336), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4095), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(4093), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [233139] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6460), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(11339), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4113), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(4111), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [233185] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8172), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    STATE(7031), 1,
      sym__function_attributes_end,
    STATE(7303), 1,
      sym_trailing_return_type,
    STATE(7549), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8170), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [233261] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(10043), 1,
      anon_sym_STAR,
    ACTIONS(10045), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10047), 1,
      anon_sym_AMP,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4464), 1,
      sym_parameter_list,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(9003), 1,
      sym__abstract_declarator,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6798), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8106), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [233329] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8566), 1,
      anon_sym_DASH_GT,
    ACTIONS(8571), 1,
      anon_sym_noexcept,
    ACTIONS(8573), 1,
      anon_sym_throw,
    ACTIONS(11101), 1,
      anon_sym_requires,
    ACTIONS(11104), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7589), 1,
      sym__function_attributes_end,
    STATE(7871), 1,
      sym_trailing_return_type,
    STATE(8986), 1,
      sym_gnu_asm_expression,
    ACTIONS(8562), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(10026), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(11098), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7531), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8417), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    STATE(6834), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
  [233407] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10004), 1,
      anon_sym_STAR,
    ACTIONS(10006), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10008), 1,
      anon_sym_AMP,
    STATE(4446), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8983), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9582), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_requires,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [233475] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2881), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(11342), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4080), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(4078), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [233521] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6454), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(11345), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4180), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_DOT,
    ACTIONS(4178), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [233567] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8566), 1,
      anon_sym_DASH_GT,
    ACTIONS(8571), 1,
      anon_sym_noexcept,
    ACTIONS(8573), 1,
      anon_sym_throw,
    ACTIONS(8586), 1,
      anon_sym_requires,
    ACTIONS(8588), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7615), 1,
      sym__function_attributes_end,
    STATE(7870), 1,
      sym_trailing_return_type,
    STATE(8986), 1,
      sym_gnu_asm_expression,
    ACTIONS(8562), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(10026), 2,
      anon_sym_LBRACK,
      sym_identifier,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7531), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8817), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    STATE(6865), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
  [233645] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11323), 1,
      anon_sym_LBRACE,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6458), 1,
      sym_template_parameter_list,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(7048), 1,
      sym_compound_statement,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10731), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [233721] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11352), 1,
      anon_sym_DOT,
    STATE(2912), 1,
      sym_alignas_qualifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6853), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(11350), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(11354), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11348), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [233774] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8202), 1,
      anon_sym_DASH_GT,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8206), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11356), 1,
      anon_sym___attribute__,
    ACTIONS(11359), 1,
      anon_sym___attribute,
    ACTIONS(11362), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6946), 1,
      sym__function_attributes_end,
    STATE(7055), 1,
      sym_trailing_return_type,
    STATE(7617), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7849), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [233849] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5642), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4154), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(4156), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [233894] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5839), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4002), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(4004), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [233939] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10157), 1,
      anon_sym_STAR,
    ACTIONS(10159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10161), 1,
      anon_sym_AMP,
    STATE(4444), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9044), 1,
      sym__abstract_declarator,
    ACTIONS(7410), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [234006] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8812), 1,
      anon_sym_DASH_GT,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(8816), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11077), 1,
      anon_sym___attribute__,
    ACTIONS(11080), 1,
      anon_sym___attribute,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7538), 1,
      sym__function_attributes_end,
    STATE(7658), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8653), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6884), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [234087] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10157), 1,
      anon_sym_STAR,
    ACTIONS(10159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10161), 1,
      anon_sym_AMP,
    STATE(4444), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9047), 1,
      sym__abstract_declarator,
    ACTIONS(8106), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [234154] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5644), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4058), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(4060), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [234199] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5645), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4043), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(4045), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [234244] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5848), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4089), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(4091), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [234289] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5646), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4047), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(4049), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [234334] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8812), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10279), 1,
      anon_sym___attribute__,
    ACTIONS(10282), 1,
      anon_sym___attribute,
    ACTIONS(11152), 1,
      anon_sym_requires,
    ACTIONS(11155), 1,
      anon_sym_where,
    STATE(7461), 1,
      sym__function_attributes_end,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7664), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8258), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6888), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [234415] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_LBRACE,
    ACTIONS(7115), 1,
      anon_sym_LPAREN2,
    STATE(3093), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4525), 1,
      sym_argument_list,
    STATE(4526), 1,
      sym_initializer_list,
    ACTIONS(2883), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(7326), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2881), 22,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [234468] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8812), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11077), 1,
      anon_sym___attribute__,
    ACTIONS(11080), 1,
      anon_sym___attribute,
    ACTIONS(11365), 1,
      anon_sym_requires,
    ACTIONS(11368), 1,
      anon_sym_where,
    STATE(7462), 1,
      sym__function_attributes_end,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7665), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8259), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6878), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [234549] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8869), 1,
      anon_sym_DASH_GT,
    ACTIONS(8876), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11077), 1,
      anon_sym___attribute__,
    ACTIONS(11080), 1,
      anon_sym___attribute,
    STATE(7502), 1,
      sym__function_attributes_end,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7653), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8738), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6879), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [234630] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8202), 1,
      anon_sym_DASH_GT,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8206), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10279), 1,
      anon_sym___attribute__,
    ACTIONS(10282), 1,
      anon_sym___attribute,
    ACTIONS(10285), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6943), 1,
      sym__function_attributes_end,
    STATE(7004), 1,
      sym_trailing_return_type,
    STATE(7624), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7838), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [234705] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5652), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4085), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(4087), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [234750] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5653), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4174), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(4176), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [234795] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3836), 1,
      anon_sym_LPAREN2,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    STATE(3093), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3418), 1,
      sym_argument_list,
    STATE(4856), 1,
      sym_initializer_list,
    ACTIONS(2883), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(7326), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2881), 22,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [234848] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8202), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10279), 1,
      anon_sym___attribute__,
    ACTIONS(10282), 1,
      anon_sym___attribute,
    ACTIONS(10285), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10429), 1,
      anon_sym_requires,
    ACTIONS(10432), 1,
      anon_sym_where,
    STATE(6938), 1,
      sym__function_attributes_end,
    STATE(7035), 1,
      sym_trailing_return_type,
    STATE(7624), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10426), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7509), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [234923] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9576), 1,
      anon_sym_COMMA,
    ACTIONS(9578), 1,
      sym_identifier,
    ACTIONS(10149), 1,
      anon_sym_STAR,
    ACTIONS(10151), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10153), 1,
      anon_sym_AMP,
    STATE(4330), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9113), 1,
      sym__abstract_declarator,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [234990] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8869), 1,
      anon_sym_DASH_GT,
    ACTIONS(8876), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10279), 1,
      anon_sym___attribute__,
    ACTIONS(10282), 1,
      anon_sym___attribute,
    STATE(7491), 1,
      sym__function_attributes_end,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7652), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8736), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6876), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [235071] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8202), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11077), 1,
      anon_sym___attribute__,
    ACTIONS(11080), 1,
      anon_sym___attribute,
    ACTIONS(11083), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11089), 1,
      anon_sym_requires,
    ACTIONS(11092), 1,
      anon_sym_where,
    STATE(6944), 1,
      sym__function_attributes_end,
    STATE(7036), 1,
      sym_trailing_return_type,
    STATE(7626), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(11086), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7510), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [235146] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9758), 1,
      anon_sym_DOT,
    ACTIONS(4252), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4254), 26,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [235191] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9758), 1,
      anon_sym_DOT,
    ACTIONS(4244), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(9482), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4246), 26,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [235236] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10197), 1,
      anon_sym_STAR,
    ACTIONS(10199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10201), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4503), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9089), 1,
      sym__abstract_declarator,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9576), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [235303] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8202), 1,
      anon_sym_DASH_GT,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11356), 1,
      anon_sym___attribute__,
    ACTIONS(11359), 1,
      anon_sym___attribute,
    ACTIONS(11362), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11374), 1,
      anon_sym_requires,
    ACTIONS(11377), 1,
      anon_sym_where,
    STATE(6933), 1,
      sym__function_attributes_end,
    STATE(7037), 1,
      sym_trailing_return_type,
    STATE(7617), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(11371), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7511), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [235378] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10157), 1,
      anon_sym_STAR,
    ACTIONS(10159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10161), 1,
      anon_sym_AMP,
    STATE(4444), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9199), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9576), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [235445] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(8106), 1,
      anon_sym_COMMA,
    ACTIONS(8108), 1,
      sym_identifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10149), 1,
      anon_sym_STAR,
    ACTIONS(10151), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10153), 1,
      anon_sym_AMP,
    STATE(4330), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9133), 1,
      sym__abstract_declarator,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [235512] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10197), 1,
      anon_sym_STAR,
    ACTIONS(10199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10201), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4503), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9117), 1,
      sym__abstract_declarator,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9582), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [235579] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11352), 1,
      anon_sym_DOT,
    STATE(2912), 1,
      sym_alignas_qualifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6862), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(11354), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(11382), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(11380), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [235632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9544), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(9542), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [235673] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10197), 1,
      anon_sym_STAR,
    ACTIONS(10199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10201), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4503), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9041), 1,
      sym__abstract_declarator,
    ACTIONS(8106), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [235740] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_const,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10157), 1,
      anon_sym_STAR,
    ACTIONS(10159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10161), 1,
      anon_sym_AMP,
    STATE(4444), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9136), 1,
      sym__abstract_declarator,
    ACTIONS(9506), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9582), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9500), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [235807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9554), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(9552), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [235848] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8869), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10279), 1,
      anon_sym___attribute__,
    ACTIONS(10282), 1,
      anon_sym___attribute,
    ACTIONS(11129), 1,
      anon_sym_requires,
    ACTIONS(11196), 1,
      anon_sym_where,
    STATE(7456), 1,
      sym__function_attributes_end,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7706), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8269), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6875), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [235929] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8202), 1,
      anon_sym_DASH_GT,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8206), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11077), 1,
      anon_sym___attribute__,
    ACTIONS(11080), 1,
      anon_sym___attribute,
    ACTIONS(11083), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6936), 1,
      sym__function_attributes_end,
    STATE(7006), 1,
      sym_trailing_return_type,
    STATE(7626), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7848), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [236004] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7410), 1,
      anon_sym_COMMA,
    ACTIONS(7412), 1,
      sym_identifier,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10149), 1,
      anon_sym_STAR,
    ACTIONS(10151), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10153), 1,
      anon_sym_AMP,
    STATE(4330), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9111), 1,
      sym__abstract_declarator,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [236071] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3045), 1,
      sym_attribute_specifier,
    ACTIONS(8129), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4002), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(4004), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [236116] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3053), 1,
      sym_attribute_specifier,
    ACTIONS(8129), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4089), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(4091), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [236161] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8869), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11077), 1,
      anon_sym___attribute__,
    ACTIONS(11080), 1,
      anon_sym___attribute,
    ACTIONS(11256), 1,
      anon_sym_requires,
    ACTIONS(11384), 1,
      anon_sym_where,
    STATE(7457), 1,
      sym__function_attributes_end,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7707), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8270), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6886), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [236242] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5873), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4198), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(4200), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [236287] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3022), 1,
      sym_attribute_specifier,
    ACTIONS(8129), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4198), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(4200), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [236332] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3020), 1,
      sym_attribute_specifier,
    ACTIONS(8129), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4109), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(4107), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [236377] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3014), 1,
      sym_attribute_specifier,
    ACTIONS(8129), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4008), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(4010), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [236422] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3035), 1,
      sym_attribute_specifier,
    ACTIONS(8129), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4012), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(4014), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [236467] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3031), 1,
      sym_attribute_specifier,
    ACTIONS(8129), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4154), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(4156), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [236512] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3033), 1,
      sym_attribute_specifier,
    ACTIONS(8129), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4058), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(4060), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [236557] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3037), 1,
      sym_attribute_specifier,
    ACTIONS(8129), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4043), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(4045), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [236602] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3039), 1,
      sym_attribute_specifier,
    ACTIONS(8129), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4047), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(4049), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [236647] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3060), 1,
      sym_attribute_specifier,
    ACTIONS(8129), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4085), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(4087), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [236692] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3054), 1,
      sym_attribute_specifier,
    ACTIONS(8129), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4174), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(4176), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [236737] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8812), 1,
      anon_sym_DASH_GT,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(8816), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10279), 1,
      anon_sym___attribute__,
    ACTIONS(10282), 1,
      anon_sym___attribute,
    STATE(7536), 1,
      sym__function_attributes_end,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7657), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8722), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(6882), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [236818] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5629), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4109), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(4107), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [236863] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5632), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4008), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(4010), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [236908] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5633), 1,
      sym_attribute_specifier,
    ACTIONS(7348), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(4012), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(4014), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [236953] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9582), 1,
      anon_sym_COMMA,
    ACTIONS(9584), 1,
      sym_identifier,
    ACTIONS(10149), 1,
      anon_sym_STAR,
    ACTIONS(10151), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10153), 1,
      anon_sym_AMP,
    STATE(4330), 1,
      sym_parameter_list,
    STATE(5539), 1,
      sym_alignas_qualifier,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9114), 1,
      sym__abstract_declarator,
    ACTIONS(5370), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5495), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5368), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [237020] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(7266), 1,
      anon_sym_const,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10197), 1,
      anon_sym_STAR,
    ACTIONS(10199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10201), 1,
      anon_sym_AMP,
    STATE(2912), 1,
      sym_alignas_qualifier,
    STATE(4503), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9165), 1,
      sym__abstract_declarator,
    ACTIONS(7410), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(9492), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9490), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [237087] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8571), 1,
      anon_sym_noexcept,
    ACTIONS(8573), 1,
      anon_sym_throw,
    ACTIONS(8963), 1,
      anon_sym_DASH_GT,
    ACTIONS(11387), 1,
      anon_sym_requires,
    ACTIONS(11390), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7876), 1,
      sym__function_attributes_end,
    STATE(8045), 1,
      sym_trailing_return_type,
    STATE(9020), 1,
      sym_gnu_asm_expression,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(10823), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(10825), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(11281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7712), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8626), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    STATE(6906), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [237163] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8243), 1,
      anon_sym_DASH_GT,
    ACTIONS(8245), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10285), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7145), 1,
      sym__function_attributes_end,
    STATE(7436), 1,
      sym_trailing_return_type,
    STATE(7624), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8183), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [237237] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(9181), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(11129), 1,
      anon_sym_requires,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7755), 1,
      sym__function_attributes_end,
    STATE(8099), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9000), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
    STATE(6893), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [237317] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9174), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11365), 1,
      anon_sym_requires,
    ACTIONS(11393), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7862), 1,
      sym__function_attributes_end,
    STATE(8115), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8715), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(6912), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [237397] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8571), 1,
      anon_sym_noexcept,
    ACTIONS(8573), 1,
      anon_sym_throw,
    ACTIONS(8963), 1,
      anon_sym_DASH_GT,
    ACTIONS(8984), 1,
      anon_sym_requires,
    ACTIONS(8986), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7811), 1,
      sym__function_attributes_end,
    STATE(8057), 1,
      sym_trailing_return_type,
    STATE(9020), 1,
      sym_gnu_asm_expression,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(10823), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(10825), 2,
      anon_sym_LBRACK,
      sym_identifier,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7712), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(9067), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    STATE(6896), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [237473] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11321), 1,
      anon_sym_LBRACE,
    STATE(1675), 1,
      sym_compound_statement,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10483), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [237543] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9921), 1,
      anon_sym_DOT,
    ACTIONS(9923), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4254), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(4252), 21,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [237587] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8243), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11083), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11089), 1,
      anon_sym_requires,
    ACTIONS(11107), 1,
      anon_sym_where,
    STATE(7139), 1,
      sym__function_attributes_end,
    STATE(7404), 1,
      sym_trailing_return_type,
    STATE(7626), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(11086), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7852), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [237661] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11239), 1,
      anon_sym_LBRACE,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4668), 1,
      sym_compound_statement,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10544), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [237731] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8243), 1,
      anon_sym_DASH_GT,
    ACTIONS(8245), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11083), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7061), 1,
      sym__function_attributes_end,
    STATE(7375), 1,
      sym_trailing_return_type,
    STATE(7626), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [237805] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11268), 1,
      anon_sym_LBRACE,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(7185), 1,
      sym_compound_statement,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10348), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [237875] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8243), 1,
      anon_sym_DASH_GT,
    ACTIONS(8245), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11362), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7181), 1,
      sym__function_attributes_end,
    STATE(7376), 1,
      sym_trailing_return_type,
    STATE(7617), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8193), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [237949] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    STATE(1675), 1,
      sym_compound_statement,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10413), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [238019] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8243), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10285), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10429), 1,
      anon_sym_requires,
    ACTIONS(10564), 1,
      anon_sym_where,
    STATE(7085), 1,
      sym__function_attributes_end,
    STATE(7419), 1,
      sym_trailing_return_type,
    STATE(7624), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10426), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7874), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [238093] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9921), 1,
      anon_sym_DOT,
    ACTIONS(9923), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4246), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(4244), 21,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [238137] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8988), 1,
      anon_sym_DASH_GT,
    ACTIONS(9189), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7792), 1,
      sym__function_attributes_end,
    STATE(8078), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9055), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(6901), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [238217] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8571), 1,
      anon_sym_noexcept,
    ACTIONS(8573), 1,
      anon_sym_throw,
    ACTIONS(8963), 1,
      anon_sym_DASH_GT,
    ACTIONS(11225), 1,
      anon_sym_requires,
    ACTIONS(11228), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7865), 1,
      sym__function_attributes_end,
    STATE(8016), 1,
      sym_trailing_return_type,
    STATE(9020), 1,
      sym_gnu_asm_expression,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(10024), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(10026), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(11098), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7712), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8770), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    STATE(6909), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [238293] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(9181), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11256), 1,
      anon_sym_requires,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7774), 1,
      sym__function_attributes_end,
    STATE(8121), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8898), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
    STATE(6913), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [238373] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8974), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(11220), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11231), 1,
      anon_sym_requires,
    ACTIONS(11234), 1,
      anon_sym_where,
    STATE(7624), 1,
      sym_where_clause,
    STATE(7730), 1,
      sym__function_attributes_end,
    STATE(8005), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10426), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8545), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(6898), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [238453] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8988), 1,
      anon_sym_DASH_GT,
    ACTIONS(9189), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7793), 1,
      sym__function_attributes_end,
    STATE(8079), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9063), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(6908), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [238533] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11245), 1,
      anon_sym_LBRACE,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4928), 1,
      sym_compound_statement,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10610), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [238603] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11272), 1,
      anon_sym_LBRACE,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(3467), 1,
      sym_compound_statement,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10780), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [238673] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8571), 1,
      anon_sym_noexcept,
    ACTIONS(8573), 1,
      anon_sym_throw,
    ACTIONS(8963), 1,
      anon_sym_DASH_GT,
    ACTIONS(8984), 1,
      anon_sym_requires,
    ACTIONS(8986), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7873), 1,
      sym__function_attributes_end,
    STATE(8149), 1,
      sym_trailing_return_type,
    STATE(9020), 1,
      sym_gnu_asm_expression,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(10024), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(10026), 2,
      anon_sym_LBRACK,
      sym_identifier,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7712), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(9170), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    STATE(6891), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [238749] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8988), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11256), 1,
      anon_sym_requires,
    ACTIONS(11396), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7800), 1,
      sym__function_attributes_end,
    STATE(8137), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8709), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(6905), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [238829] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8243), 1,
      anon_sym_DASH_GT,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11362), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11374), 1,
      anon_sym_requires,
    ACTIONS(11399), 1,
      anon_sym_where,
    STATE(7160), 1,
      sym__function_attributes_end,
    STATE(7428), 1,
      sym_trailing_return_type,
    STATE(7617), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(11371), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7887), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [238903] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11266), 1,
      anon_sym_LBRACE,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4576), 1,
      sym_compound_statement,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10537), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [238973] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11270), 1,
      anon_sym_LBRACE,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(5156), 1,
      sym_compound_statement,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10603), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [239043] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8974), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11402), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11405), 1,
      anon_sym_requires,
    ACTIONS(11408), 1,
      anon_sym_where,
    STATE(7626), 1,
      sym_where_clause,
    STATE(7736), 1,
      sym__function_attributes_end,
    STATE(7951), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(11086), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8546), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(6895), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [239123] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11277), 1,
      anon_sym_LBRACE,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4049), 1,
      sym_compound_statement,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10407), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [239193] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8974), 1,
      anon_sym_DASH_GT,
    ACTIONS(9183), 1,
      anon_sym_requires,
    ACTIONS(9185), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11402), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7626), 1,
      sym_where_clause,
    STATE(7695), 1,
      sym__function_attributes_end,
    STATE(7897), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9022), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(6915), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [239273] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11252), 1,
      anon_sym_LBRACE,
    STATE(1675), 1,
      sym_compound_statement,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10355), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [239343] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9174), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(11152), 1,
      anon_sym_requires,
    ACTIONS(11214), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7861), 1,
      sym__function_attributes_end,
    STATE(8114), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(6903), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [239423] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(4049), 1,
      sym_compound_statement,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10598), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [239493] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2883), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(2881), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [239537] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(9174), 1,
      anon_sym_DASH_GT,
    ACTIONS(9176), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7857), 1,
      sym__function_attributes_end,
    STATE(8107), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9184), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(6902), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [239617] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8974), 1,
      anon_sym_DASH_GT,
    ACTIONS(9183), 1,
      anon_sym_requires,
    ACTIONS(9185), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(11220), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7624), 1,
      sym_where_clause,
    STATE(7694), 1,
      sym__function_attributes_end,
    STATE(8004), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9006), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(6904), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [239697] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11323), 1,
      anon_sym_LBRACE,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6762), 1,
      sym_parameter_list,
    STATE(6966), 1,
      sym_compound_statement,
    STATE(8501), 1,
      sym_type_qualifier,
    STATE(10337), 1,
      sym_lambda_declarator,
    STATE(11161), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9096), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [239767] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(9174), 1,
      anon_sym_DASH_GT,
    ACTIONS(9176), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7858), 1,
      sym__function_attributes_end,
    STATE(8109), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9185), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(6889), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [239847] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(8988), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(11129), 1,
      anon_sym_requires,
    ACTIONS(11217), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7799), 1,
      sym__function_attributes_end,
    STATE(8136), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8708), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(6890), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [239927] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11411), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5749), 1,
      sym__class_declaration,
    STATE(5752), 1,
      sym__class_declaration_item,
    STATE(6487), 1,
      sym_field_declaration_list,
    STATE(7186), 1,
      sym_ms_declspec_modifier,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(9592), 1,
      sym_virtual_specifier,
    STATE(10725), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6074), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7187), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6750), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [240008] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(9311), 1,
      anon_sym_LBRACE,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11413), 1,
      sym_identifier,
    STATE(4999), 1,
      sym_template_type,
    STATE(5152), 1,
      sym_field_declaration_list,
    STATE(5359), 1,
      sym__class_declaration_item,
    STATE(5368), 1,
      sym__class_declaration,
    STATE(7201), 1,
      sym_ms_declspec_modifier,
    STATE(8676), 1,
      sym__scope_resolution,
    STATE(9440), 1,
      sym_virtual_specifier,
    STATE(10599), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4813), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7202), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6794), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [240089] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(9311), 1,
      anon_sym_LBRACE,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11413), 1,
      sym_identifier,
    STATE(4999), 1,
      sym_template_type,
    STATE(5152), 1,
      sym_field_declaration_list,
    STATE(5359), 1,
      sym__class_declaration_item,
    STATE(5370), 1,
      sym__class_declaration,
    STATE(7201), 1,
      sym_ms_declspec_modifier,
    STATE(8676), 1,
      sym__scope_resolution,
    STATE(9440), 1,
      sym_virtual_specifier,
    STATE(10599), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4813), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7202), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6794), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [240170] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11415), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5749), 1,
      sym__class_declaration,
    STATE(5752), 1,
      sym__class_declaration_item,
    STATE(7141), 1,
      sym_ms_declspec_modifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7142), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6754), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [240251] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8789), 1,
      anon_sym_STAR,
    ACTIONS(8791), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8793), 1,
      anon_sym_AMP,
    ACTIONS(10954), 1,
      sym_identifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(8352), 1,
      sym__declarator,
    STATE(9602), 1,
      sym_type_hinted_declarator,
    STATE(10577), 1,
      sym_init_declarator,
    STATE(11397), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [240324] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2897), 1,
      sym__class_declaration,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2807), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [240405] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11415), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5752), 1,
      sym__class_declaration_item,
    STATE(5753), 1,
      sym__class_declaration,
    STATE(7141), 1,
      sym_ms_declspec_modifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7142), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6754), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [240486] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11415), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5752), 1,
      sym__class_declaration_item,
    STATE(5754), 1,
      sym__class_declaration,
    STATE(7141), 1,
      sym_ms_declspec_modifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7142), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6754), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [240567] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2897), 1,
      sym__class_declaration,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2794), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [240648] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11419), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5749), 1,
      sym__class_declaration,
    STATE(5752), 1,
      sym__class_declaration_item,
    STATE(7107), 1,
      sym_ms_declspec_modifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7108), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6763), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [240729] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8310), 1,
      anon_sym_DASH_GT,
    ACTIONS(8326), 1,
      anon_sym_requires,
    ACTIONS(8328), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10285), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7296), 1,
      sym__function_attributes_end,
    STATE(7469), 1,
      sym_trailing_return_type,
    STATE(7624), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8395), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [240802] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2693), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4121), 4,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_GT2,
    ACTIONS(6775), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4124), 5,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(2915), 17,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [240847] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11415), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5752), 1,
      sym__class_declaration_item,
    STATE(5760), 1,
      sym__class_declaration,
    STATE(7141), 1,
      sym_ms_declspec_modifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7142), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6754), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [240928] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11419), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5752), 1,
      sym__class_declaration_item,
    STATE(5753), 1,
      sym__class_declaration,
    STATE(7107), 1,
      sym_ms_declspec_modifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7108), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6763), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [241009] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11415), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5752), 1,
      sym__class_declaration_item,
    STATE(5762), 1,
      sym__class_declaration,
    STATE(7141), 1,
      sym_ms_declspec_modifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7142), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6754), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [241090] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2897), 1,
      sym__class_declaration,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2800), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [241171] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8310), 1,
      anon_sym_DASH_GT,
    ACTIONS(8326), 1,
      anon_sym_requires,
    ACTIONS(8328), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11083), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7297), 1,
      sym__function_attributes_end,
    STATE(7472), 1,
      sym_trailing_return_type,
    STATE(7626), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8399), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [241244] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2899), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2800), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [241325] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2900), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2800), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [241406] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11419), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5752), 1,
      sym__class_declaration_item,
    STATE(5754), 1,
      sym__class_declaration,
    STATE(7107), 1,
      sym_ms_declspec_modifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7108), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6763), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [241487] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11421), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3055), 1,
      sym__class_declaration,
    STATE(3056), 1,
      sym__class_declaration_item,
    STATE(3225), 1,
      sym_field_declaration_list,
    STATE(7077), 1,
      sym_ms_declspec_modifier,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(9402), 1,
      sym_virtual_specifier,
    STATE(10341), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3099), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7078), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6752), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [241568] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2850), 1,
      sym__class_declaration,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(7137), 1,
      sym_ms_declspec_modifier,
    STATE(8606), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3084), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7143), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6782), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [241649] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11421), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3056), 1,
      sym__class_declaration_item,
    STATE(3057), 1,
      sym__class_declaration,
    STATE(3225), 1,
      sym_field_declaration_list,
    STATE(7077), 1,
      sym_ms_declspec_modifier,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(9402), 1,
      sym_virtual_specifier,
    STATE(10341), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3099), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7078), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6752), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [241730] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11421), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3023), 1,
      sym__class_declaration,
    STATE(3056), 1,
      sym__class_declaration_item,
    STATE(3225), 1,
      sym_field_declaration_list,
    STATE(7077), 1,
      sym_ms_declspec_modifier,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(9402), 1,
      sym_virtual_specifier,
    STATE(10341), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3099), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7078), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6752), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [241811] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8310), 1,
      anon_sym_DASH_GT,
    ACTIONS(8326), 1,
      anon_sym_requires,
    ACTIONS(8328), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11362), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7298), 1,
      sym__function_attributes_end,
    STATE(7474), 1,
      sym_trailing_return_type,
    STATE(7617), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8401), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [241884] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2897), 1,
      sym__class_declaration,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2802), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [241965] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2899), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2802), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [242046] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2899), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2794), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [242127] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2900), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2802), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [242208] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2858), 1,
      sym__class_declaration,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(7137), 1,
      sym_ms_declspec_modifier,
    STATE(8606), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3084), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7143), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6782), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [242289] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11419), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5752), 1,
      sym__class_declaration_item,
    STATE(5760), 1,
      sym__class_declaration,
    STATE(7107), 1,
      sym_ms_declspec_modifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7108), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6763), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [242370] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11419), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5752), 1,
      sym__class_declaration_item,
    STATE(5762), 1,
      sym__class_declaration,
    STATE(7107), 1,
      sym_ms_declspec_modifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7108), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6763), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [242451] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11421), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3016), 1,
      sym__class_declaration,
    STATE(3056), 1,
      sym__class_declaration_item,
    STATE(3225), 1,
      sym_field_declaration_list,
    STATE(7077), 1,
      sym_ms_declspec_modifier,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(9402), 1,
      sym_virtual_specifier,
    STATE(10341), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3099), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7078), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6752), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [242532] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11421), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3018), 1,
      sym__class_declaration,
    STATE(3056), 1,
      sym__class_declaration_item,
    STATE(3225), 1,
      sym_field_declaration_list,
    STATE(7077), 1,
      sym_ms_declspec_modifier,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(9402), 1,
      sym_virtual_specifier,
    STATE(10341), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3099), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7078), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6752), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [242613] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3023), 1,
      sym__class_declaration,
    STATE(3056), 1,
      sym__class_declaration_item,
    STATE(3225), 1,
      sym_field_declaration_list,
    STATE(7080), 1,
      sym_ms_declspec_modifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9402), 1,
      sym_virtual_specifier,
    STATE(10341), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3099), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7081), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6801), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [242694] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2900), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2794), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [242775] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2899), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2807), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [242856] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11427), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5749), 1,
      sym__class_declaration,
    STATE(5752), 1,
      sym__class_declaration_item,
    STATE(7113), 1,
      sym_ms_declspec_modifier,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7114), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6793), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [242937] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2897), 1,
      sym__class_declaration,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(7137), 1,
      sym_ms_declspec_modifier,
    STATE(8606), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3084), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7143), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6782), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [243018] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8789), 1,
      anon_sym_STAR,
    ACTIONS(8791), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8793), 1,
      anon_sym_AMP,
    ACTIONS(10954), 1,
      sym_identifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(7967), 1,
      sym__declarator,
    STATE(9213), 1,
      sym_type_hinted_declarator,
    STATE(9961), 1,
      sym_init_declarator,
    STATE(11397), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [243091] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11427), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5752), 1,
      sym__class_declaration_item,
    STATE(5753), 1,
      sym__class_declaration,
    STATE(7113), 1,
      sym_ms_declspec_modifier,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7114), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6793), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [243172] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11427), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5752), 1,
      sym__class_declaration_item,
    STATE(5754), 1,
      sym__class_declaration,
    STATE(7113), 1,
      sym_ms_declspec_modifier,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7114), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6793), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [243253] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11427), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5752), 1,
      sym__class_declaration_item,
    STATE(5760), 1,
      sym__class_declaration,
    STATE(7113), 1,
      sym_ms_declspec_modifier,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7114), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6793), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [243334] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11427), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5752), 1,
      sym__class_declaration_item,
    STATE(5762), 1,
      sym__class_declaration,
    STATE(7113), 1,
      sym_ms_declspec_modifier,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7114), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6793), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [243415] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2900), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2807), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [243496] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10014), 1,
      anon_sym_DOT,
    ACTIONS(4252), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(10016), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4254), 24,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [243539] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8789), 1,
      anon_sym_STAR,
    ACTIONS(8791), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8793), 1,
      anon_sym_AMP,
    ACTIONS(10954), 1,
      sym_identifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(8199), 1,
      sym__declarator,
    STATE(9213), 1,
      sym_type_hinted_declarator,
    STATE(9961), 1,
      sym_init_declarator,
    STATE(11397), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [243612] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(11429), 1,
      sym_identifier,
    ACTIONS(11431), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(289), 1,
      sym__class_declaration,
    STATE(290), 1,
      sym__class_declaration_item,
    STATE(6379), 1,
      sym_field_declaration_list,
    STATE(7205), 1,
      sym_ms_declspec_modifier,
    STATE(8684), 1,
      sym__scope_resolution,
    STATE(9579), 1,
      sym_virtual_specifier,
    STATE(10657), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5716), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7206), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6789), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [243693] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(11429), 1,
      sym_identifier,
    ACTIONS(11431), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(290), 1,
      sym__class_declaration_item,
    STATE(308), 1,
      sym__class_declaration,
    STATE(6379), 1,
      sym_field_declaration_list,
    STATE(7205), 1,
      sym_ms_declspec_modifier,
    STATE(8684), 1,
      sym__scope_resolution,
    STATE(9579), 1,
      sym_virtual_specifier,
    STATE(10657), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5716), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7206), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6789), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [243774] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8789), 1,
      anon_sym_STAR,
    ACTIONS(8791), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8793), 1,
      anon_sym_AMP,
    ACTIONS(10954), 1,
      sym_identifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(8264), 1,
      sym__declarator,
    STATE(9221), 1,
      sym_type_hinted_declarator,
    STATE(9720), 1,
      sym_init_declarator,
    STATE(11397), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [243847] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(11429), 1,
      sym_identifier,
    ACTIONS(11431), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(290), 1,
      sym__class_declaration_item,
    STATE(309), 1,
      sym__class_declaration,
    STATE(6379), 1,
      sym_field_declaration_list,
    STATE(7205), 1,
      sym_ms_declspec_modifier,
    STATE(8684), 1,
      sym__scope_resolution,
    STATE(9579), 1,
      sym_virtual_specifier,
    STATE(10657), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5716), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7206), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6789), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [243928] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5734), 1,
      sym_field_declaration_list,
    STATE(5988), 1,
      sym__class_declaration,
    STATE(6032), 1,
      sym__class_declaration_item,
    STATE(7090), 1,
      sym_ms_declspec_modifier,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(9490), 1,
      sym_virtual_specifier,
    STATE(10722), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5324), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7091), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6785), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [244009] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5734), 1,
      sym_field_declaration_list,
    STATE(5973), 1,
      sym__class_declaration,
    STATE(6032), 1,
      sym__class_declaration_item,
    STATE(7090), 1,
      sym_ms_declspec_modifier,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(9490), 1,
      sym_virtual_specifier,
    STATE(10722), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5324), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7091), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6785), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [244090] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5734), 1,
      sym_field_declaration_list,
    STATE(6018), 1,
      sym__class_declaration,
    STATE(6032), 1,
      sym__class_declaration_item,
    STATE(7090), 1,
      sym_ms_declspec_modifier,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(9490), 1,
      sym_virtual_specifier,
    STATE(10722), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5324), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7091), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6785), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [244171] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(11166), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(290), 1,
      sym__class_declaration_item,
    STATE(308), 1,
      sym__class_declaration,
    STATE(664), 1,
      sym_field_declaration_list,
    STATE(7131), 1,
      sym_ms_declspec_modifier,
    STATE(8640), 1,
      sym__scope_resolution,
    STATE(9463), 1,
      sym_virtual_specifier,
    STATE(10501), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7138), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6775), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [244252] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5734), 1,
      sym_field_declaration_list,
    STATE(5926), 1,
      sym__class_declaration,
    STATE(6032), 1,
      sym__class_declaration_item,
    STATE(7090), 1,
      sym_ms_declspec_modifier,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(9490), 1,
      sym_virtual_specifier,
    STATE(10722), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5324), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7091), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6785), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [244333] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(11429), 1,
      sym_identifier,
    ACTIONS(11431), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(290), 1,
      sym__class_declaration_item,
    STATE(293), 1,
      sym__class_declaration,
    STATE(6379), 1,
      sym_field_declaration_list,
    STATE(7205), 1,
      sym_ms_declspec_modifier,
    STATE(8684), 1,
      sym__scope_resolution,
    STATE(9579), 1,
      sym_virtual_specifier,
    STATE(10657), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5716), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7206), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6789), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [244414] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(11429), 1,
      sym_identifier,
    ACTIONS(11431), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(290), 1,
      sym__class_declaration_item,
    STATE(294), 1,
      sym__class_declaration,
    STATE(6379), 1,
      sym_field_declaration_list,
    STATE(7205), 1,
      sym_ms_declspec_modifier,
    STATE(8684), 1,
      sym__scope_resolution,
    STATE(9579), 1,
      sym_virtual_specifier,
    STATE(10657), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5716), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7206), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6789), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [244495] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5734), 1,
      sym_field_declaration_list,
    STATE(5953), 1,
      sym__class_declaration,
    STATE(6032), 1,
      sym__class_declaration_item,
    STATE(7090), 1,
      sym_ms_declspec_modifier,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(9490), 1,
      sym_virtual_specifier,
    STATE(10722), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5324), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7091), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6785), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [244576] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(289), 1,
      sym__class_declaration,
    STATE(290), 1,
      sym__class_declaration_item,
    STATE(6379), 1,
      sym_field_declaration_list,
    STATE(7100), 1,
      sym_ms_declspec_modifier,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(9579), 1,
      sym_virtual_specifier,
    STATE(10657), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5716), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7101), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6796), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [244657] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(290), 1,
      sym__class_declaration_item,
    STATE(308), 1,
      sym__class_declaration,
    STATE(6379), 1,
      sym_field_declaration_list,
    STATE(7100), 1,
      sym_ms_declspec_modifier,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(9579), 1,
      sym_virtual_specifier,
    STATE(10657), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5716), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7101), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6796), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [244738] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2899), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2813), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [244819] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2900), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2803), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [244900] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8076), 1,
      anon_sym_LBRACE,
    ACTIONS(11053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11435), 1,
      sym_identifier,
    STATE(3571), 1,
      sym_template_type,
    STATE(3728), 1,
      sym_field_declaration_list,
    STATE(4322), 1,
      sym__class_declaration,
    STATE(4324), 1,
      sym__class_declaration_item,
    STATE(7209), 1,
      sym_ms_declspec_modifier,
    STATE(8630), 1,
      sym__scope_resolution,
    STATE(9464), 1,
      sym_virtual_specifier,
    STATE(10507), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3488), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7140), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6768), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [244981] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(290), 1,
      sym__class_declaration_item,
    STATE(309), 1,
      sym__class_declaration,
    STATE(6379), 1,
      sym_field_declaration_list,
    STATE(7100), 1,
      sym_ms_declspec_modifier,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(9579), 1,
      sym_virtual_specifier,
    STATE(10657), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5716), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7101), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6796), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [245062] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2899), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2737), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [245143] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7812), 1,
      anon_sym_LBRACE,
    ACTIONS(10875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11437), 1,
      sym_identifier,
    STATE(3528), 1,
      sym_template_type,
    STATE(3622), 1,
      sym_field_declaration_list,
    STATE(3805), 1,
      sym__class_declaration,
    STATE(3884), 1,
      sym__class_declaration_item,
    STATE(7063), 1,
      sym_ms_declspec_modifier,
    STATE(8655), 1,
      sym__scope_resolution,
    STATE(9509), 1,
      sym_virtual_specifier,
    STATE(10383), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3358), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7064), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6758), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [245224] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(290), 1,
      sym__class_declaration_item,
    STATE(293), 1,
      sym__class_declaration,
    STATE(6379), 1,
      sym_field_declaration_list,
    STATE(7100), 1,
      sym_ms_declspec_modifier,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(9579), 1,
      sym_virtual_specifier,
    STATE(10657), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5716), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7101), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6796), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [245305] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(290), 1,
      sym__class_declaration_item,
    STATE(294), 1,
      sym__class_declaration,
    STATE(6379), 1,
      sym_field_declaration_list,
    STATE(7100), 1,
      sym_ms_declspec_modifier,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(9579), 1,
      sym_virtual_specifier,
    STATE(10657), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5716), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7101), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6796), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [245386] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7256), 1,
      anon_sym_LBRACE,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11439), 1,
      sym_identifier,
    STATE(3103), 1,
      sym_template_type,
    STATE(3162), 1,
      sym_field_declaration_list,
    STATE(3195), 1,
      sym__class_declaration,
    STATE(3196), 1,
      sym__class_declaration_item,
    STATE(7087), 1,
      sym_ms_declspec_modifier,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(9497), 1,
      sym_virtual_specifier,
    STATE(10778), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3015), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6776), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [245467] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8076), 1,
      anon_sym_LBRACE,
    ACTIONS(11053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11435), 1,
      sym_identifier,
    STATE(3571), 1,
      sym_template_type,
    STATE(3728), 1,
      sym_field_declaration_list,
    STATE(4324), 1,
      sym__class_declaration_item,
    STATE(4325), 1,
      sym__class_declaration,
    STATE(7209), 1,
      sym_ms_declspec_modifier,
    STATE(8630), 1,
      sym__scope_resolution,
    STATE(9464), 1,
      sym_virtual_specifier,
    STATE(10507), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3488), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7140), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6768), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [245548] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11441), 1,
      sym_identifier,
    STATE(398), 1,
      sym_template_type,
    STATE(711), 1,
      sym_field_declaration_list,
    STATE(758), 1,
      sym__class_declaration,
    STATE(759), 1,
      sym__class_declaration_item,
    STATE(7176), 1,
      sym_ms_declspec_modifier,
    STATE(8763), 1,
      sym__scope_resolution,
    STATE(9404), 1,
      sym_virtual_specifier,
    STATE(10370), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(260), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7177), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6811), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [245629] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8789), 1,
      anon_sym_STAR,
    ACTIONS(8791), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8793), 1,
      anon_sym_AMP,
    ACTIONS(10954), 1,
      sym_identifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(8184), 1,
      sym__declarator,
    STATE(9240), 1,
      sym_type_hinted_declarator,
    STATE(9698), 1,
      sym_init_declarator,
    STATE(11397), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [245702] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2897), 1,
      sym__class_declaration,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2795), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [245783] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11441), 1,
      sym_identifier,
    STATE(398), 1,
      sym_template_type,
    STATE(711), 1,
      sym_field_declaration_list,
    STATE(759), 1,
      sym__class_declaration_item,
    STATE(760), 1,
      sym__class_declaration,
    STATE(7176), 1,
      sym_ms_declspec_modifier,
    STATE(8763), 1,
      sym__scope_resolution,
    STATE(9404), 1,
      sym_virtual_specifier,
    STATE(10370), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(260), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7177), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6811), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [245864] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2899), 1,
      sym__class_declaration,
    STATE(7137), 1,
      sym_ms_declspec_modifier,
    STATE(8606), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3084), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7143), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6782), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [245945] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(11166), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(290), 1,
      sym__class_declaration_item,
    STATE(294), 1,
      sym__class_declaration,
    STATE(664), 1,
      sym_field_declaration_list,
    STATE(7131), 1,
      sym_ms_declspec_modifier,
    STATE(8640), 1,
      sym__scope_resolution,
    STATE(9463), 1,
      sym_virtual_specifier,
    STATE(10501), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7138), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6775), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [246026] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2900), 1,
      sym__class_declaration,
    STATE(7137), 1,
      sym_ms_declspec_modifier,
    STATE(8606), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3084), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7143), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6782), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [246107] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8076), 1,
      anon_sym_LBRACE,
    ACTIONS(11053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11435), 1,
      sym_identifier,
    STATE(3571), 1,
      sym_template_type,
    STATE(3728), 1,
      sym_field_declaration_list,
    STATE(4324), 1,
      sym__class_declaration_item,
    STATE(4326), 1,
      sym__class_declaration,
    STATE(7209), 1,
      sym_ms_declspec_modifier,
    STATE(8630), 1,
      sym__scope_resolution,
    STATE(9464), 1,
      sym_virtual_specifier,
    STATE(10507), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3488), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7140), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6768), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [246188] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2899), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2795), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [246269] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8789), 1,
      anon_sym_STAR,
    ACTIONS(8791), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8793), 1,
      anon_sym_AMP,
    ACTIONS(10954), 1,
      sym_identifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(8177), 1,
      sym__declarator,
    STATE(9213), 1,
      sym_type_hinted_declarator,
    STATE(9961), 1,
      sym_init_declarator,
    STATE(11397), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [246342] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7256), 1,
      anon_sym_LBRACE,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11439), 1,
      sym_identifier,
    STATE(3103), 1,
      sym_template_type,
    STATE(3162), 1,
      sym_field_declaration_list,
    STATE(3196), 1,
      sym__class_declaration_item,
    STATE(3199), 1,
      sym__class_declaration,
    STATE(7087), 1,
      sym_ms_declspec_modifier,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(9497), 1,
      sym_virtual_specifier,
    STATE(10778), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3015), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6776), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [246423] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8076), 1,
      anon_sym_LBRACE,
    ACTIONS(11053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11435), 1,
      sym_identifier,
    STATE(3571), 1,
      sym_template_type,
    STATE(3728), 1,
      sym_field_declaration_list,
    STATE(4324), 1,
      sym__class_declaration_item,
    STATE(4328), 1,
      sym__class_declaration,
    STATE(7209), 1,
      sym_ms_declspec_modifier,
    STATE(8630), 1,
      sym__scope_resolution,
    STATE(9464), 1,
      sym_virtual_specifier,
    STATE(10507), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3488), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7140), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6768), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [246504] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2897), 1,
      sym__class_declaration,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2797), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [246585] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2899), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2797), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [246666] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2900), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2797), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [246747] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11441), 1,
      sym_identifier,
    STATE(398), 1,
      sym_template_type,
    STATE(711), 1,
      sym_field_declaration_list,
    STATE(759), 1,
      sym__class_declaration_item,
    STATE(761), 1,
      sym__class_declaration,
    STATE(7176), 1,
      sym_ms_declspec_modifier,
    STATE(8763), 1,
      sym__scope_resolution,
    STATE(9404), 1,
      sym_virtual_specifier,
    STATE(10370), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(260), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7177), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6811), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [246828] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8076), 1,
      anon_sym_LBRACE,
    ACTIONS(11053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11435), 1,
      sym_identifier,
    STATE(3571), 1,
      sym_template_type,
    STATE(3728), 1,
      sym_field_declaration_list,
    STATE(4324), 1,
      sym__class_declaration_item,
    STATE(4329), 1,
      sym__class_declaration,
    STATE(7209), 1,
      sym_ms_declspec_modifier,
    STATE(8630), 1,
      sym__scope_resolution,
    STATE(9464), 1,
      sym_virtual_specifier,
    STATE(10507), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3488), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7140), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6768), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [246909] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2897), 1,
      sym__class_declaration,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2798), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [246990] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2899), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2798), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [247071] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2900), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2795), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [247152] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7812), 1,
      anon_sym_LBRACE,
    ACTIONS(10875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11437), 1,
      sym_identifier,
    STATE(3528), 1,
      sym_template_type,
    STATE(3622), 1,
      sym_field_declaration_list,
    STATE(3804), 1,
      sym__class_declaration,
    STATE(3884), 1,
      sym__class_declaration_item,
    STATE(7063), 1,
      sym_ms_declspec_modifier,
    STATE(8655), 1,
      sym__scope_resolution,
    STATE(9509), 1,
      sym_virtual_specifier,
    STATE(10383), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3358), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7064), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6758), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [247233] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7812), 1,
      anon_sym_LBRACE,
    ACTIONS(10875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11437), 1,
      sym_identifier,
    STATE(3528), 1,
      sym_template_type,
    STATE(3622), 1,
      sym_field_declaration_list,
    STATE(3848), 1,
      sym__class_declaration,
    STATE(3884), 1,
      sym__class_declaration_item,
    STATE(7063), 1,
      sym_ms_declspec_modifier,
    STATE(8655), 1,
      sym__scope_resolution,
    STATE(9509), 1,
      sym_virtual_specifier,
    STATE(10383), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3358), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7064), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6758), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [247314] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2900), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2798), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [247395] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8550), 1,
      anon_sym_LBRACE,
    ACTIONS(10930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11443), 1,
      sym_identifier,
    STATE(4522), 1,
      sym_template_type,
    STATE(4902), 1,
      sym_field_declaration_list,
    STATE(5070), 1,
      sym__class_declaration,
    STATE(5071), 1,
      sym__class_declaration_item,
    STATE(7164), 1,
      sym_ms_declspec_modifier,
    STATE(8723), 1,
      sym__scope_resolution,
    STATE(9523), 1,
      sym_virtual_specifier,
    STATE(10443), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3855), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7165), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6786), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [247476] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2858), 1,
      sym__class_declaration,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2737), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [247557] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11441), 1,
      sym_identifier,
    STATE(398), 1,
      sym_template_type,
    STATE(711), 1,
      sym_field_declaration_list,
    STATE(759), 1,
      sym__class_declaration_item,
    STATE(763), 1,
      sym__class_declaration,
    STATE(7176), 1,
      sym_ms_declspec_modifier,
    STATE(8763), 1,
      sym__scope_resolution,
    STATE(9404), 1,
      sym_virtual_specifier,
    STATE(10370), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(260), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7177), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6811), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [247638] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11441), 1,
      sym_identifier,
    STATE(398), 1,
      sym_template_type,
    STATE(711), 1,
      sym_field_declaration_list,
    STATE(759), 1,
      sym__class_declaration_item,
    STATE(764), 1,
      sym__class_declaration,
    STATE(7176), 1,
      sym_ms_declspec_modifier,
    STATE(8763), 1,
      sym__scope_resolution,
    STATE(9404), 1,
      sym_virtual_specifier,
    STATE(10370), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(260), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7177), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6811), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [247719] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8789), 1,
      anon_sym_STAR,
    ACTIONS(8791), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8793), 1,
      anon_sym_AMP,
    ACTIONS(10954), 1,
      sym_identifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(8292), 1,
      sym__declarator,
    STATE(9219), 1,
      sym_type_hinted_declarator,
    STATE(9748), 1,
      sym_init_declarator,
    STATE(11397), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [247792] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7256), 1,
      anon_sym_LBRACE,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11439), 1,
      sym_identifier,
    STATE(3103), 1,
      sym_template_type,
    STATE(3162), 1,
      sym_field_declaration_list,
    STATE(3196), 1,
      sym__class_declaration_item,
    STATE(3200), 1,
      sym__class_declaration,
    STATE(7087), 1,
      sym_ms_declspec_modifier,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(9497), 1,
      sym_virtual_specifier,
    STATE(10778), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3015), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6776), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [247873] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8550), 1,
      anon_sym_LBRACE,
    ACTIONS(10930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11443), 1,
      sym_identifier,
    STATE(4522), 1,
      sym_template_type,
    STATE(4902), 1,
      sym_field_declaration_list,
    STATE(5071), 1,
      sym__class_declaration_item,
    STATE(5072), 1,
      sym__class_declaration,
    STATE(7164), 1,
      sym_ms_declspec_modifier,
    STATE(8723), 1,
      sym__scope_resolution,
    STATE(9523), 1,
      sym_virtual_specifier,
    STATE(10443), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3855), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7165), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6786), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [247954] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8550), 1,
      anon_sym_LBRACE,
    ACTIONS(10930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11443), 1,
      sym_identifier,
    STATE(4522), 1,
      sym_template_type,
    STATE(4902), 1,
      sym_field_declaration_list,
    STATE(5071), 1,
      sym__class_declaration_item,
    STATE(5073), 1,
      sym__class_declaration,
    STATE(7164), 1,
      sym_ms_declspec_modifier,
    STATE(8723), 1,
      sym__scope_resolution,
    STATE(9523), 1,
      sym_virtual_specifier,
    STATE(10443), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3855), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7165), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6786), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [248035] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(5525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11445), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2897), 1,
      sym__class_declaration,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(7095), 1,
      sym_ms_declspec_modifier,
    STATE(8769), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2737), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7096), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6783), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [248116] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(5525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11445), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2899), 1,
      sym__class_declaration,
    STATE(7095), 1,
      sym_ms_declspec_modifier,
    STATE(8769), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2737), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7096), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6783), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [248197] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8550), 1,
      anon_sym_LBRACE,
    ACTIONS(10930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11443), 1,
      sym_identifier,
    STATE(4522), 1,
      sym_template_type,
    STATE(4902), 1,
      sym_field_declaration_list,
    STATE(5071), 1,
      sym__class_declaration_item,
    STATE(5074), 1,
      sym__class_declaration,
    STATE(7164), 1,
      sym_ms_declspec_modifier,
    STATE(8723), 1,
      sym__scope_resolution,
    STATE(9523), 1,
      sym_virtual_specifier,
    STATE(10443), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3855), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7165), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6786), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [248278] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8550), 1,
      anon_sym_LBRACE,
    ACTIONS(10930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11443), 1,
      sym_identifier,
    STATE(4522), 1,
      sym_template_type,
    STATE(4902), 1,
      sym_field_declaration_list,
    STATE(5071), 1,
      sym__class_declaration_item,
    STATE(5076), 1,
      sym__class_declaration,
    STATE(7164), 1,
      sym_ms_declspec_modifier,
    STATE(8723), 1,
      sym__scope_resolution,
    STATE(9523), 1,
      sym_virtual_specifier,
    STATE(10443), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3855), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7165), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6786), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [248359] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6474), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2881), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_DOT,
    ACTIONS(11447), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2883), 22,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [248402] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8310), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10285), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10715), 1,
      anon_sym_requires,
    ACTIONS(10718), 1,
      anon_sym_where,
    STATE(7231), 1,
      sym__function_attributes_end,
    STATE(7544), 1,
      sym_trailing_return_type,
    STATE(7624), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10426), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7913), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [248475] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(11166), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(289), 1,
      sym__class_declaration,
    STATE(290), 1,
      sym__class_declaration_item,
    STATE(664), 1,
      sym_field_declaration_list,
    STATE(7131), 1,
      sym_ms_declspec_modifier,
    STATE(8640), 1,
      sym__scope_resolution,
    STATE(9463), 1,
      sym_virtual_specifier,
    STATE(10501), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7138), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6775), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [248556] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10014), 1,
      anon_sym_DOT,
    ACTIONS(4244), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(10016), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4246), 24,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [248599] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2883), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(2881), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [248640] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5734), 1,
      sym_field_declaration_list,
    STATE(5988), 1,
      sym__class_declaration,
    STATE(6032), 1,
      sym__class_declaration_item,
    STATE(7105), 1,
      sym_ms_declspec_modifier,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(9490), 1,
      sym_virtual_specifier,
    STATE(10722), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5324), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7106), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6815), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [248721] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5734), 1,
      sym_field_declaration_list,
    STATE(5973), 1,
      sym__class_declaration,
    STATE(6032), 1,
      sym__class_declaration_item,
    STATE(7105), 1,
      sym_ms_declspec_modifier,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(9490), 1,
      sym_virtual_specifier,
    STATE(10722), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5324), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7106), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6815), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [248802] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7256), 1,
      anon_sym_LBRACE,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11439), 1,
      sym_identifier,
    STATE(3103), 1,
      sym_template_type,
    STATE(3162), 1,
      sym_field_declaration_list,
    STATE(3196), 1,
      sym__class_declaration_item,
    STATE(3204), 1,
      sym__class_declaration,
    STATE(7087), 1,
      sym_ms_declspec_modifier,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(9497), 1,
      sym_virtual_specifier,
    STATE(10778), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3015), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6776), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [248883] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5734), 1,
      sym_field_declaration_list,
    STATE(6018), 1,
      sym__class_declaration,
    STATE(6032), 1,
      sym__class_declaration_item,
    STATE(7105), 1,
      sym_ms_declspec_modifier,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(9490), 1,
      sym_virtual_specifier,
    STATE(10722), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5324), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7106), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6815), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [248964] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5734), 1,
      sym_field_declaration_list,
    STATE(5926), 1,
      sym__class_declaration,
    STATE(6032), 1,
      sym__class_declaration_item,
    STATE(7105), 1,
      sym_ms_declspec_modifier,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(9490), 1,
      sym_virtual_specifier,
    STATE(10722), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5324), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7106), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6815), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [249045] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5734), 1,
      sym_field_declaration_list,
    STATE(5953), 1,
      sym__class_declaration,
    STATE(6032), 1,
      sym__class_declaration_item,
    STATE(7105), 1,
      sym_ms_declspec_modifier,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(9490), 1,
      sym_virtual_specifier,
    STATE(10722), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5324), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7106), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6815), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [249126] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(11166), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(290), 1,
      sym__class_declaration_item,
    STATE(293), 1,
      sym__class_declaration,
    STATE(664), 1,
      sym_field_declaration_list,
    STATE(7131), 1,
      sym_ms_declspec_modifier,
    STATE(8640), 1,
      sym__scope_resolution,
    STATE(9463), 1,
      sym_virtual_specifier,
    STATE(10501), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7138), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6775), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [249207] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2897), 1,
      sym__class_declaration,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2811), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [249288] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8310), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11083), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11190), 1,
      anon_sym_requires,
    ACTIONS(11193), 1,
      anon_sym_where,
    STATE(7232), 1,
      sym__function_attributes_end,
    STATE(7545), 1,
      sym_trailing_return_type,
    STATE(7626), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(11086), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7914), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [249361] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2899), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2811), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [249442] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3055), 1,
      sym__class_declaration,
    STATE(3056), 1,
      sym__class_declaration_item,
    STATE(3225), 1,
      sym_field_declaration_list,
    STATE(7080), 1,
      sym_ms_declspec_modifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9402), 1,
      sym_virtual_specifier,
    STATE(10341), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3099), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7081), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6801), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [249523] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7256), 1,
      anon_sym_LBRACE,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11439), 1,
      sym_identifier,
    STATE(3103), 1,
      sym_template_type,
    STATE(3162), 1,
      sym_field_declaration_list,
    STATE(3196), 1,
      sym__class_declaration_item,
    STATE(3205), 1,
      sym__class_declaration,
    STATE(7087), 1,
      sym_ms_declspec_modifier,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(9497), 1,
      sym_virtual_specifier,
    STATE(10778), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3015), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6776), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [249604] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2897), 1,
      sym__class_declaration,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2809), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [249685] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2899), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2809), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [249766] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2900), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2809), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [249847] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(5525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11445), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2900), 1,
      sym__class_declaration,
    STATE(7095), 1,
      sym_ms_declspec_modifier,
    STATE(8769), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2737), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7096), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6783), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [249928] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2900), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2737), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [250009] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(5525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11445), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2850), 1,
      sym__class_declaration,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(7095), 1,
      sym_ms_declspec_modifier,
    STATE(8769), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2737), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7096), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6783), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [250090] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(5525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11445), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2858), 1,
      sym__class_declaration,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(7095), 1,
      sym_ms_declspec_modifier,
    STATE(8769), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2737), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7096), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6783), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [250171] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(11166), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(290), 1,
      sym__class_declaration_item,
    STATE(309), 1,
      sym__class_declaration,
    STATE(664), 1,
      sym_field_declaration_list,
    STATE(7131), 1,
      sym_ms_declspec_modifier,
    STATE(8640), 1,
      sym__scope_resolution,
    STATE(9463), 1,
      sym_virtual_specifier,
    STATE(10501), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7138), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6775), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [250252] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2897), 1,
      sym__class_declaration,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2812), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [250333] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2899), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2812), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [250414] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2900), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2812), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [250495] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2900), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2811), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [250576] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2897), 1,
      sym__class_declaration,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2813), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [250657] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8789), 1,
      anon_sym_STAR,
    ACTIONS(8791), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8793), 1,
      anon_sym_AMP,
    ACTIONS(10954), 1,
      sym_identifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(8223), 1,
      sym__declarator,
    STATE(9289), 1,
      sym_type_hinted_declarator,
    STATE(10189), 1,
      sym_init_declarator,
    STATE(11397), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [250730] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3055), 1,
      sym__class_declaration,
    STATE(3056), 1,
      sym__class_declaration_item,
    STATE(6517), 1,
      sym_field_declaration_list,
    STATE(7208), 1,
      sym_ms_declspec_modifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9588), 1,
      sym_virtual_specifier,
    STATE(10713), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5838), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7056), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6778), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [250811] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3056), 1,
      sym__class_declaration_item,
    STATE(3057), 1,
      sym__class_declaration,
    STATE(6517), 1,
      sym_field_declaration_list,
    STATE(7208), 1,
      sym_ms_declspec_modifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9588), 1,
      sym_virtual_specifier,
    STATE(10713), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5838), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7056), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6778), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [250892] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3023), 1,
      sym__class_declaration,
    STATE(3056), 1,
      sym__class_declaration_item,
    STATE(6517), 1,
      sym_field_declaration_list,
    STATE(7208), 1,
      sym_ms_declspec_modifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9588), 1,
      sym_virtual_specifier,
    STATE(10713), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5838), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7056), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6778), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [250973] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3016), 1,
      sym__class_declaration,
    STATE(3056), 1,
      sym__class_declaration_item,
    STATE(6517), 1,
      sym_field_declaration_list,
    STATE(7208), 1,
      sym_ms_declspec_modifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9588), 1,
      sym_virtual_specifier,
    STATE(10713), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5838), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7056), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6778), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [251054] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3018), 1,
      sym__class_declaration,
    STATE(3056), 1,
      sym__class_declaration_item,
    STATE(6517), 1,
      sym_field_declaration_list,
    STATE(7208), 1,
      sym_ms_declspec_modifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9588), 1,
      sym_virtual_specifier,
    STATE(10713), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5838), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7056), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6778), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [251135] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7724), 1,
      anon_sym_LBRACE,
    ACTIONS(10904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11450), 1,
      sym_identifier,
    STATE(3502), 1,
      sym_template_type,
    STATE(3582), 1,
      sym_field_declaration_list,
    STATE(3738), 1,
      sym__class_declaration,
    STATE(3768), 1,
      sym__class_declaration_item,
    STATE(7173), 1,
      sym_ms_declspec_modifier,
    STATE(8746), 1,
      sym__scope_resolution,
    STATE(9571), 1,
      sym_virtual_specifier,
    STATE(10634), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7174), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6755), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [251216] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2897), 1,
      sym__class_declaration,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2808), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [251297] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2899), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2808), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [251378] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2900), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2808), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [251459] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7724), 1,
      anon_sym_LBRACE,
    ACTIONS(10904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11450), 1,
      sym_identifier,
    STATE(3502), 1,
      sym_template_type,
    STATE(3582), 1,
      sym_field_declaration_list,
    STATE(3768), 1,
      sym__class_declaration_item,
    STATE(3770), 1,
      sym__class_declaration,
    STATE(7173), 1,
      sym_ms_declspec_modifier,
    STATE(8746), 1,
      sym__scope_resolution,
    STATE(9571), 1,
      sym_virtual_specifier,
    STATE(10634), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7174), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6755), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [251540] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3016), 1,
      sym__class_declaration,
    STATE(3056), 1,
      sym__class_declaration_item,
    STATE(3225), 1,
      sym_field_declaration_list,
    STATE(7080), 1,
      sym_ms_declspec_modifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9402), 1,
      sym_virtual_specifier,
    STATE(10341), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3099), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7081), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6801), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [251621] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7724), 1,
      anon_sym_LBRACE,
    ACTIONS(10904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11450), 1,
      sym_identifier,
    STATE(3502), 1,
      sym_template_type,
    STATE(3582), 1,
      sym_field_declaration_list,
    STATE(3731), 1,
      sym__class_declaration,
    STATE(3768), 1,
      sym__class_declaration_item,
    STATE(7173), 1,
      sym_ms_declspec_modifier,
    STATE(8746), 1,
      sym__scope_resolution,
    STATE(9571), 1,
      sym_virtual_specifier,
    STATE(10634), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7174), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6755), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [251702] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2897), 1,
      sym__class_declaration,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2810), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [251783] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2899), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2810), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [251864] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2900), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2810), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [251945] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3018), 1,
      sym__class_declaration,
    STATE(3056), 1,
      sym__class_declaration_item,
    STATE(3225), 1,
      sym_field_declaration_list,
    STATE(7080), 1,
      sym_ms_declspec_modifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9402), 1,
      sym_virtual_specifier,
    STATE(10341), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3099), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7081), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6801), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [252026] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(9311), 1,
      anon_sym_LBRACE,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11413), 1,
      sym_identifier,
    STATE(4999), 1,
      sym_template_type,
    STATE(5152), 1,
      sym_field_declaration_list,
    STATE(5358), 1,
      sym__class_declaration,
    STATE(5359), 1,
      sym__class_declaration_item,
    STATE(7201), 1,
      sym_ms_declspec_modifier,
    STATE(8676), 1,
      sym__scope_resolution,
    STATE(9440), 1,
      sym_virtual_specifier,
    STATE(10599), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4813), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7202), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6794), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [252107] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2900), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2813), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [252188] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(9311), 1,
      anon_sym_LBRACE,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11413), 1,
      sym_identifier,
    STATE(4999), 1,
      sym_template_type,
    STATE(5152), 1,
      sym_field_declaration_list,
    STATE(5359), 1,
      sym__class_declaration_item,
    STATE(5361), 1,
      sym__class_declaration,
    STATE(7201), 1,
      sym_ms_declspec_modifier,
    STATE(8676), 1,
      sym__scope_resolution,
    STATE(9440), 1,
      sym_virtual_specifier,
    STATE(10599), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4813), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7202), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6794), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [252269] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11411), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5752), 1,
      sym__class_declaration_item,
    STATE(5753), 1,
      sym__class_declaration,
    STATE(6487), 1,
      sym_field_declaration_list,
    STATE(7186), 1,
      sym_ms_declspec_modifier,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(9592), 1,
      sym_virtual_specifier,
    STATE(10725), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6074), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7187), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6750), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [252350] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8789), 1,
      anon_sym_STAR,
    ACTIONS(8791), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8793), 1,
      anon_sym_AMP,
    ACTIONS(10954), 1,
      sym_identifier,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(8232), 1,
      sym__declarator,
    STATE(9247), 1,
      sym_type_hinted_declarator,
    STATE(10077), 1,
      sym_init_declarator,
    STATE(11397), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [252423] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11411), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5752), 1,
      sym__class_declaration_item,
    STATE(5754), 1,
      sym__class_declaration,
    STATE(6487), 1,
      sym_field_declaration_list,
    STATE(7186), 1,
      sym_ms_declspec_modifier,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(9592), 1,
      sym_virtual_specifier,
    STATE(10725), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6074), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7187), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6750), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [252504] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7724), 1,
      anon_sym_LBRACE,
    ACTIONS(10904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11450), 1,
      sym_identifier,
    STATE(3502), 1,
      sym_template_type,
    STATE(3582), 1,
      sym_field_declaration_list,
    STATE(3768), 1,
      sym__class_declaration_item,
    STATE(3780), 1,
      sym__class_declaration,
    STATE(7173), 1,
      sym_ms_declspec_modifier,
    STATE(8746), 1,
      sym__scope_resolution,
    STATE(9571), 1,
      sym_virtual_specifier,
    STATE(10634), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7174), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6755), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [252585] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(9311), 1,
      anon_sym_LBRACE,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11413), 1,
      sym_identifier,
    STATE(4999), 1,
      sym_template_type,
    STATE(5152), 1,
      sym_field_declaration_list,
    STATE(5359), 1,
      sym__class_declaration_item,
    STATE(5362), 1,
      sym__class_declaration,
    STATE(7201), 1,
      sym_ms_declspec_modifier,
    STATE(8676), 1,
      sym__scope_resolution,
    STATE(9440), 1,
      sym_virtual_specifier,
    STATE(10599), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4813), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7202), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6794), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [252666] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2897), 1,
      sym__class_declaration,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2737), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [252747] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3056), 1,
      sym__class_declaration_item,
    STATE(3057), 1,
      sym__class_declaration,
    STATE(3225), 1,
      sym_field_declaration_list,
    STATE(7080), 1,
      sym_ms_declspec_modifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9402), 1,
      sym_virtual_specifier,
    STATE(10341), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3099), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7081), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6801), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [252828] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7724), 1,
      anon_sym_LBRACE,
    ACTIONS(10904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11450), 1,
      sym_identifier,
    STATE(3502), 1,
      sym_template_type,
    STATE(3582), 1,
      sym_field_declaration_list,
    STATE(3760), 1,
      sym__class_declaration,
    STATE(3768), 1,
      sym__class_declaration_item,
    STATE(7173), 1,
      sym_ms_declspec_modifier,
    STATE(8746), 1,
      sym__scope_resolution,
    STATE(9571), 1,
      sym_virtual_specifier,
    STATE(10634), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7174), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6755), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [252909] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11411), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5752), 1,
      sym__class_declaration_item,
    STATE(5760), 1,
      sym__class_declaration,
    STATE(6487), 1,
      sym_field_declaration_list,
    STATE(7186), 1,
      sym_ms_declspec_modifier,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(9592), 1,
      sym_virtual_specifier,
    STATE(10725), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6074), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7187), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6750), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [252990] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11411), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5752), 1,
      sym__class_declaration_item,
    STATE(5762), 1,
      sym__class_declaration,
    STATE(6487), 1,
      sym_field_declaration_list,
    STATE(7186), 1,
      sym_ms_declspec_modifier,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(9592), 1,
      sym_virtual_specifier,
    STATE(10725), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6074), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7187), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6750), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [253071] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8310), 1,
      anon_sym_DASH_GT,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11362), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11452), 1,
      anon_sym_requires,
    ACTIONS(11455), 1,
      anon_sym_where,
    STATE(7233), 1,
      sym__function_attributes_end,
    STATE(7547), 1,
      sym_trailing_return_type,
    STATE(7617), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(11371), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7915), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [253144] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2897), 1,
      sym__class_declaration,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2803), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [253225] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(2899), 1,
      sym__class_declaration,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2803), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [253306] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7812), 1,
      anon_sym_LBRACE,
    ACTIONS(10875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11437), 1,
      sym_identifier,
    STATE(3528), 1,
      sym_template_type,
    STATE(3622), 1,
      sym_field_declaration_list,
    STATE(3881), 1,
      sym__class_declaration,
    STATE(3884), 1,
      sym__class_declaration_item,
    STATE(7063), 1,
      sym_ms_declspec_modifier,
    STATE(8655), 1,
      sym__scope_resolution,
    STATE(9509), 1,
      sym_virtual_specifier,
    STATE(10383), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3358), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7064), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6758), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [253387] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7812), 1,
      anon_sym_LBRACE,
    ACTIONS(10875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11437), 1,
      sym_identifier,
    STATE(3528), 1,
      sym_template_type,
    STATE(3622), 1,
      sym_field_declaration_list,
    STATE(3846), 1,
      sym__class_declaration,
    STATE(3884), 1,
      sym__class_declaration_item,
    STATE(7063), 1,
      sym_ms_declspec_modifier,
    STATE(8655), 1,
      sym__scope_resolution,
    STATE(9509), 1,
      sym_virtual_specifier,
    STATE(10383), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3358), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7064), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6758), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [253468] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2850), 1,
      sym__class_declaration,
    STATE(2898), 1,
      sym__class_declaration_item,
    STATE(7147), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2737), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7148), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6777), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [253549] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11458), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [253589] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11460), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [253629] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11462), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [253669] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11411), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5852), 1,
      sym__class_declaration_item,
    STATE(6487), 1,
      sym_field_declaration_list,
    STATE(7193), 1,
      sym_ms_declspec_modifier,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(9592), 1,
      sym_virtual_specifier,
    STATE(10725), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6074), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7191), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7577), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [253747] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11464), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [253787] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11421), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3029), 1,
      sym__class_declaration_item,
    STATE(3225), 1,
      sym_field_declaration_list,
    STATE(7169), 1,
      sym_ms_declspec_modifier,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(9402), 1,
      sym_virtual_specifier,
    STATE(10341), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3099), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7159), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7577), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [253865] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11466), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [253905] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11415), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5852), 1,
      sym__class_declaration_item,
    STATE(7150), 1,
      sym_ms_declspec_modifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7149), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7577), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [253983] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7724), 1,
      anon_sym_LBRACE,
    ACTIONS(10904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11450), 1,
      sym_identifier,
    STATE(3502), 1,
      sym_template_type,
    STATE(3582), 1,
      sym_field_declaration_list,
    STATE(3749), 1,
      sym__class_declaration_item,
    STATE(7070), 1,
      sym_ms_declspec_modifier,
    STATE(8746), 1,
      sym__scope_resolution,
    STATE(9571), 1,
      sym_virtual_specifier,
    STATE(10634), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7069), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7577), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [254061] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11468), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [254101] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11470), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [254141] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7812), 1,
      anon_sym_LBRACE,
    ACTIONS(10875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11437), 1,
      sym_identifier,
    STATE(3528), 1,
      sym_template_type,
    STATE(3622), 1,
      sym_field_declaration_list,
    STATE(3818), 1,
      sym__class_declaration_item,
    STATE(7066), 1,
      sym_ms_declspec_modifier,
    STATE(8655), 1,
      sym__scope_resolution,
    STATE(9509), 1,
      sym_virtual_specifier,
    STATE(10383), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3358), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7065), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7577), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [254219] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    STATE(7478), 1,
      sym__function_attributes_end,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7645), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8609), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [254291] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11472), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [254331] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    STATE(7471), 1,
      sym__function_attributes_end,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7641), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8607), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [254403] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11474), 1,
      anon_sym_LBRACE,
    ACTIONS(11476), 1,
      anon_sym_DASH_GT,
    ACTIONS(11478), 1,
      anon_sym_requires,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(8169), 1,
      sym_type_qualifier,
    STATE(9633), 1,
      sym_trailing_return_type,
    STATE(10899), 1,
      sym_requires_clause,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(8775), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8836), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [254467] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11419), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5852), 1,
      sym__class_declaration_item,
    STATE(7110), 1,
      sym_ms_declspec_modifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7109), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7577), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [254545] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    STATE(7464), 1,
      sym__function_attributes_end,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7649), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8611), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [254617] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11480), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [254657] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11482), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [254697] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11484), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [254737] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8076), 1,
      anon_sym_LBRACE,
    ACTIONS(11053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11435), 1,
      sym_identifier,
    STATE(3571), 1,
      sym_template_type,
    STATE(3728), 1,
      sym_field_declaration_list,
    STATE(4349), 1,
      sym__class_declaration_item,
    STATE(7058), 1,
      sym_ms_declspec_modifier,
    STATE(8630), 1,
      sym__scope_resolution,
    STATE(9464), 1,
      sym_virtual_specifier,
    STATE(10507), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3488), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7057), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7577), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [254815] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11486), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [254855] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11488), 1,
      anon_sym_LBRACE,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(6808), 1,
      sym_parameter_list,
    STATE(8489), 1,
      sym_type_qualifier,
    STATE(10948), 1,
      sym_trailing_return_type,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9069), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [254919] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8440), 1,
      anon_sym_DASH_GT,
    ACTIONS(8442), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11356), 1,
      anon_sym___attribute__,
    ACTIONS(11359), 1,
      anon_sym___attribute,
    STATE(7336), 1,
      sym__function_attributes_end,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7506), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8340), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
  [254991] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11490), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [255031] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10249), 1,
      anon_sym_DOT,
    ACTIONS(9923), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4246), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
    ACTIONS(4244), 21,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [255073] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11352), 1,
      anon_sym_DOT,
    ACTIONS(4254), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(11354), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4252), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [255115] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(11166), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(327), 1,
      sym__class_declaration_item,
    STATE(664), 1,
      sym_field_declaration_list,
    STATE(7128), 1,
      sym_ms_declspec_modifier,
    STATE(8640), 1,
      sym__scope_resolution,
    STATE(9463), 1,
      sym_virtual_specifier,
    STATE(10501), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7118), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7577), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [255193] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7256), 1,
      anon_sym_LBRACE,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11439), 1,
      sym_identifier,
    STATE(3103), 1,
      sym_template_type,
    STATE(3162), 1,
      sym_field_declaration_list,
    STATE(3220), 1,
      sym__class_declaration_item,
    STATE(7123), 1,
      sym_ms_declspec_modifier,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(9497), 1,
      sym_virtual_specifier,
    STATE(10778), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3015), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7089), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7577), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [255271] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2892), 1,
      sym__class_declaration_item,
    STATE(7155), 1,
      sym_ms_declspec_modifier,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2737), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7154), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7577), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [255349] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3029), 1,
      sym__class_declaration_item,
    STATE(6517), 1,
      sym_field_declaration_list,
    STATE(7196), 1,
      sym_ms_declspec_modifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9588), 1,
      sym_virtual_specifier,
    STATE(10713), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5838), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7195), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7577), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [255427] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11492), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [255467] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11494), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [255507] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11496), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [255547] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2892), 1,
      sym__class_declaration_item,
    STATE(7175), 1,
      sym_ms_declspec_modifier,
    STATE(8606), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3084), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7171), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7577), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [255625] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(5525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11445), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2892), 1,
      sym__class_declaration_item,
    STATE(7098), 1,
      sym_ms_declspec_modifier,
    STATE(8769), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2737), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7097), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7577), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [255703] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11498), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [255743] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5734), 1,
      sym_field_declaration_list,
    STATE(5931), 1,
      sym__class_declaration_item,
    STATE(7093), 1,
      sym_ms_declspec_modifier,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(9490), 1,
      sym_virtual_specifier,
    STATE(10722), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5324), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7092), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7577), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [255821] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8550), 1,
      anon_sym_LBRACE,
    ACTIONS(10930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11443), 1,
      sym_identifier,
    STATE(4522), 1,
      sym_template_type,
    STATE(4902), 1,
      sym_field_declaration_list,
    STATE(5021), 1,
      sym__class_declaration_item,
    STATE(7168), 1,
      sym_ms_declspec_modifier,
    STATE(8723), 1,
      sym__scope_resolution,
    STATE(9523), 1,
      sym_virtual_specifier,
    STATE(10443), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3855), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7167), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7577), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [255899] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11500), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [255939] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11352), 1,
      anon_sym_DOT,
    ACTIONS(4246), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(11354), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4244), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [255981] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(11429), 1,
      sym_identifier,
    ACTIONS(11431), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(327), 1,
      sym__class_declaration_item,
    STATE(6379), 1,
      sym_field_declaration_list,
    STATE(7071), 1,
      sym_ms_declspec_modifier,
    STATE(8684), 1,
      sym__scope_resolution,
    STATE(9579), 1,
      sym_virtual_specifier,
    STATE(10657), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5716), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7068), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7577), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [256059] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11502), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [256099] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11504), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [256139] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11506), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [256179] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11427), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5852), 1,
      sym__class_declaration_item,
    STATE(7116), 1,
      sym_ms_declspec_modifier,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7115), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7577), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [256257] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(9311), 1,
      anon_sym_LBRACE,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11413), 1,
      sym_identifier,
    STATE(4999), 1,
      sym_template_type,
    STATE(5152), 1,
      sym_field_declaration_list,
    STATE(5402), 1,
      sym__class_declaration_item,
    STATE(7204), 1,
      sym_ms_declspec_modifier,
    STATE(8676), 1,
      sym__scope_resolution,
    STATE(9440), 1,
      sym_virtual_specifier,
    STATE(10599), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4813), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7203), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7577), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [256335] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8440), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10031), 1,
      anon_sym_requires,
    ACTIONS(10279), 1,
      anon_sym___attribute__,
    ACTIONS(10282), 1,
      anon_sym___attribute,
    ACTIONS(10899), 1,
      anon_sym_where,
    STATE(7338), 1,
      sym__function_attributes_end,
    STATE(7515), 1,
      sym_trailing_return_type,
    STATE(7549), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7981), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
  [256407] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(327), 1,
      sym__class_declaration_item,
    STATE(6379), 1,
      sym_field_declaration_list,
    STATE(7103), 1,
      sym_ms_declspec_modifier,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(9579), 1,
      sym_virtual_specifier,
    STATE(10657), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5716), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7102), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7577), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [256485] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11508), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [256525] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9994), 1,
      anon_sym_const,
    STATE(2663), 1,
      sym_alignas_qualifier,
    ACTIONS(3683), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(9997), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6798), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3681), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(9991), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [256573] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11510), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [256613] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(10838), 1,
      anon_sym_requires,
    ACTIONS(11208), 1,
      anon_sym_where,
    STATE(7521), 1,
      sym__function_attributes_end,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7732), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8286), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [256685] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3029), 1,
      sym__class_declaration_item,
    STATE(3225), 1,
      sym_field_declaration_list,
    STATE(7210), 1,
      sym_ms_declspec_modifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9402), 1,
      sym_virtual_specifier,
    STATE(10341), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3099), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7136), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7577), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [256763] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10031), 1,
      anon_sym_requires,
    ACTIONS(11012), 1,
      anon_sym_where,
    STATE(7494), 1,
      sym__function_attributes_end,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7714), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8285), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [256835] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11512), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [256875] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8440), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(10838), 1,
      anon_sym_requires,
    ACTIONS(11077), 1,
      anon_sym___attribute__,
    ACTIONS(11080), 1,
      anon_sym___attribute,
    ACTIONS(11211), 1,
      anon_sym_where,
    STATE(7339), 1,
      sym__function_attributes_end,
    STATE(7517), 1,
      sym_trailing_return_type,
    STATE(7537), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7982), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
  [256947] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8440), 1,
      anon_sym_DASH_GT,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11315), 1,
      anon_sym_requires,
    ACTIONS(11356), 1,
      anon_sym___attribute__,
    ACTIONS(11359), 1,
      anon_sym___attribute,
    ACTIONS(11514), 1,
      anon_sym_where,
    STATE(7340), 1,
      sym__function_attributes_end,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7518), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(11312), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7983), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
  [257019] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11517), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [257059] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10249), 1,
      anon_sym_DOT,
    ACTIONS(9923), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
    ACTIONS(4254), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
    ACTIONS(4252), 21,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [257101] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11476), 1,
      anon_sym_DASH_GT,
    ACTIONS(11478), 1,
      anon_sym_requires,
    ACTIONS(11519), 1,
      anon_sym_LBRACE,
    STATE(2663), 1,
      sym_alignas_qualifier,
    STATE(8084), 1,
      sym_type_qualifier,
    STATE(10097), 1,
      sym_trailing_return_type,
    STATE(11052), 1,
      sym_requires_clause,
    ACTIONS(8487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(8815), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8813), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8483), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [257165] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11521), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [257205] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11523), 1,
      sym_identifier,
    ACTIONS(3012), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3014), 20,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [257245] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11441), 1,
      sym_identifier,
    STATE(398), 1,
      sym_template_type,
    STATE(711), 1,
      sym_field_declaration_list,
    STATE(775), 1,
      sym__class_declaration_item,
    STATE(7179), 1,
      sym_ms_declspec_modifier,
    STATE(8763), 1,
      sym__scope_resolution,
    STATE(9404), 1,
      sym_virtual_specifier,
    STATE(10370), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(260), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7178), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7577), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [257323] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11315), 1,
      anon_sym_requires,
    ACTIONS(11525), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7525), 1,
      sym__function_attributes_end,
    STATE(7733), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(11312), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8289), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [257395] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8440), 1,
      anon_sym_DASH_GT,
    ACTIONS(8442), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10279), 1,
      anon_sym___attribute__,
    ACTIONS(10282), 1,
      anon_sym___attribute,
    STATE(7334), 1,
      sym__function_attributes_end,
    STATE(7503), 1,
      sym_trailing_return_type,
    STATE(7549), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8338), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
  [257467] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8440), 1,
      anon_sym_DASH_GT,
    ACTIONS(8442), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11077), 1,
      anon_sym___attribute__,
    ACTIONS(11080), 1,
      anon_sym___attribute,
    STATE(7335), 1,
      sym__function_attributes_end,
    STATE(7505), 1,
      sym_trailing_return_type,
    STATE(7537), 1,
      sym_where_clause,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8339), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
  [257539] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6732), 1,
      anon_sym___declspec,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5734), 1,
      sym_field_declaration_list,
    STATE(5931), 1,
      sym__class_declaration_item,
    STATE(7126), 1,
      sym_ms_declspec_modifier,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(9490), 1,
      sym_virtual_specifier,
    STATE(10722), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6734), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5324), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7125), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7577), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [257617] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2452), 1,
      anon_sym_STAR,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    STATE(7421), 1,
      sym__scope_resolution,
    STATE(8845), 1,
      sym__declarator,
    STATE(11547), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [257684] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8334), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [257751] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8397), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [257818] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8440), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [257885] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8566), 1,
      anon_sym_DASH_GT,
    ACTIONS(8586), 1,
      anon_sym_requires,
    ACTIONS(8588), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7615), 1,
      sym__function_attributes_end,
    STATE(7870), 1,
      sym_trailing_return_type,
    STATE(8986), 1,
      sym_gnu_asm_expression,
    ACTIONS(8562), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(10026), 2,
      anon_sym_LBRACK,
      sym_identifier,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7531), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8817), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
  [257952] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8379), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [258019] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8592), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7564), 1,
      sym__function_attributes_end,
    STATE(7888), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8889), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [258090] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8490), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [258157] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2452), 1,
      anon_sym_STAR,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    STATE(7421), 1,
      sym__scope_resolution,
    STATE(8773), 1,
      sym__declarator,
    STATE(11547), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [258224] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8370), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [258291] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8346), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [258358] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8783), 1,
      anon_sym_STAR,
    ACTIONS(8785), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8787), 1,
      anon_sym_AMP,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(8000), 1,
      sym__declarator,
    STATE(10947), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [258425] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8354), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [258492] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8491), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [258559] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11528), 1,
      anon_sym_requires,
    ACTIONS(11531), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7582), 1,
      sym__function_attributes_end,
    STATE(7821), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(11312), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8500), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [258630] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8359), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [258697] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8594), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11315), 1,
      anon_sym_requires,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7619), 1,
      sym__function_attributes_end,
    STATE(7809), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8618), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [258768] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8313), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [258835] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8566), 1,
      anon_sym_DASH_GT,
    ACTIONS(11284), 1,
      anon_sym_requires,
    ACTIONS(11287), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7599), 1,
      sym__function_attributes_end,
    STATE(7883), 1,
      sym_trailing_return_type,
    STATE(8986), 1,
      sym_gnu_asm_expression,
    ACTIONS(8562), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(10825), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(11281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7531), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8418), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
  [258902] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8462), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [258969] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8356), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [259036] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8485), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [259103] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8594), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(10838), 1,
      anon_sym_requires,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7587), 1,
      sym__function_attributes_end,
    STATE(7808), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8617), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [259174] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8592), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7573), 1,
      sym__function_attributes_end,
    STATE(7885), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8807), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [259245] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8360), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [259312] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8445), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [259379] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8592), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7622), 1,
      sym__function_attributes_end,
    STATE(7802), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8892), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [259450] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8775), 1,
      anon_sym_STAR,
    ACTIONS(8777), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8779), 1,
      anon_sym_AMP,
    ACTIONS(8781), 1,
      anon_sym_COLON_COLON,
    STATE(7449), 1,
      sym__scope_resolution,
    STATE(8870), 1,
      sym__declarator,
    STATE(11283), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [259517] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2452), 1,
      anon_sym_STAR,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    STATE(7421), 1,
      sym__scope_resolution,
    STATE(8841), 1,
      sym__declarator,
    STATE(11547), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [259584] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8566), 1,
      anon_sym_DASH_GT,
    ACTIONS(11101), 1,
      anon_sym_requires,
    ACTIONS(11104), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7589), 1,
      sym__function_attributes_end,
    STATE(7871), 1,
      sym_trailing_return_type,
    STATE(8986), 1,
      sym_gnu_asm_expression,
    ACTIONS(8562), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(10026), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(11098), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7531), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8417), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
  [259651] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8336), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [259718] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8380), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [259785] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2452), 1,
      anon_sym_STAR,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    STATE(7421), 1,
      sym__scope_resolution,
    STATE(8894), 1,
      sym__declarator,
    STATE(11547), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [259852] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8481), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [259919] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8482), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [259986] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8422), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [260053] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8566), 1,
      anon_sym_DASH_GT,
    ACTIONS(8586), 1,
      anon_sym_requires,
    ACTIONS(8588), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7585), 1,
      sym__function_attributes_end,
    STATE(7778), 1,
      sym_trailing_return_type,
    STATE(8986), 1,
      sym_gnu_asm_expression,
    ACTIONS(8562), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(11264), 2,
      anon_sym_LBRACK,
      sym_identifier,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7531), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8824), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(11262), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
  [260120] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2912), 1,
      sym_alignas_qualifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(11536), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(11534), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [260165] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8789), 1,
      anon_sym_STAR,
    ACTIONS(8791), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8793), 1,
      anon_sym_AMP,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(8070), 1,
      sym__declarator,
    STATE(11397), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [260232] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8486), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [260299] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8594), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10031), 1,
      anon_sym_requires,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7569), 1,
      sym__function_attributes_end,
    STATE(7782), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8616), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [260370] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(8668), 1,
      anon_sym_STAR,
    ACTIONS(8670), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8672), 1,
      anon_sym_AMP,
    ACTIONS(8674), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    STATE(7370), 1,
      sym__scope_resolution,
    STATE(8725), 1,
      sym__declarator,
    STATE(11143), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [260437] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7394), 1,
      sym_identifier,
    ACTIONS(8668), 1,
      anon_sym_STAR,
    ACTIONS(8670), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8672), 1,
      anon_sym_AMP,
    ACTIONS(8674), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    STATE(7370), 1,
      sym__scope_resolution,
    STATE(8569), 1,
      sym__declarator,
    STATE(11143), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [260504] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8323), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [260571] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8369), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [260638] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2452), 1,
      anon_sym_STAR,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    STATE(7421), 1,
      sym__scope_resolution,
    STATE(8485), 1,
      sym__declarator,
    STATE(11547), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [260705] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2912), 1,
      sym_alignas_qualifier,
    ACTIONS(7270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(11540), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(11538), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(7266), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [260750] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11256), 1,
      anon_sym_requires,
    ACTIONS(11259), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7560), 1,
      sym__function_attributes_end,
    STATE(7816), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8442), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [260821] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2452), 1,
      anon_sym_STAR,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    STATE(7421), 1,
      sym__scope_resolution,
    STATE(8861), 1,
      sym__declarator,
    STATE(11547), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [260888] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8566), 1,
      anon_sym_DASH_GT,
    ACTIONS(8586), 1,
      anon_sym_requires,
    ACTIONS(8588), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7616), 1,
      sym__function_attributes_end,
    STATE(7766), 1,
      sym_trailing_return_type,
    STATE(8986), 1,
      sym_gnu_asm_expression,
    ACTIONS(8562), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(10825), 2,
      anon_sym_LBRACK,
      sym_identifier,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7531), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8821), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
  [260955] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8566), 1,
      anon_sym_DASH_GT,
    ACTIONS(11545), 1,
      anon_sym_requires,
    ACTIONS(11548), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7600), 1,
      sym__function_attributes_end,
    STATE(7884), 1,
      sym_trailing_return_type,
    STATE(8986), 1,
      sym_gnu_asm_expression,
    ACTIONS(8562), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(11264), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(11542), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7531), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8419), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(11262), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
  [261022] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8381), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [261089] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8775), 1,
      anon_sym_STAR,
    ACTIONS(8777), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8779), 1,
      anon_sym_AMP,
    ACTIONS(8781), 1,
      anon_sym_COLON_COLON,
    STATE(7449), 1,
      sym__scope_resolution,
    STATE(8832), 1,
      sym__declarator,
    STATE(11283), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [261156] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8386), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [261223] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8332), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [261290] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8454), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [261357] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2448), 1,
      anon_sym_LPAREN2,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8676), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      sym_identifier,
    ACTIONS(8799), 1,
      anon_sym_STAR,
    ACTIONS(8801), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8803), 1,
      anon_sym_AMP,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(8497), 1,
      sym__declarator,
    STATE(11256), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8054), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [261424] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(11129), 1,
      anon_sym_requires,
    ACTIONS(11132), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7558), 1,
      sym__function_attributes_end,
    STATE(7795), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8367), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [261495] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8869), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10279), 1,
      anon_sym___attribute__,
    ACTIONS(10282), 1,
      anon_sym___attribute,
    ACTIONS(11129), 1,
      anon_sym_requires,
    ACTIONS(11196), 1,
      anon_sym_where,
    STATE(7456), 1,
      sym__function_attributes_end,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7706), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8269), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [261565] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8869), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11077), 1,
      anon_sym___attribute__,
    ACTIONS(11080), 1,
      anon_sym___attribute,
    ACTIONS(11256), 1,
      anon_sym_requires,
    ACTIONS(11384), 1,
      anon_sym_where,
    STATE(7457), 1,
      sym__function_attributes_end,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7707), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8270), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [261635] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8869), 1,
      anon_sym_DASH_GT,
    ACTIONS(8876), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11077), 1,
      anon_sym___attribute__,
    ACTIONS(11080), 1,
      anon_sym___attribute,
    STATE(7502), 1,
      sym__function_attributes_end,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7653), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8738), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [261705] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2222), 1,
      anon_sym_const,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(2722), 1,
      sym_template_argument_list,
    ACTIONS(2229), 24,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
  [261747] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8812), 1,
      anon_sym_DASH_GT,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11356), 1,
      anon_sym___attribute__,
    ACTIONS(11359), 1,
      anon_sym___attribute,
    ACTIONS(11551), 1,
      anon_sym_requires,
    ACTIONS(11554), 1,
      anon_sym_where,
    STATE(7463), 1,
      sym__function_attributes_end,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7666), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(11312), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8261), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [261817] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8869), 1,
      anon_sym_DASH_GT,
    ACTIONS(8876), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11356), 1,
      anon_sym___attribute__,
    ACTIONS(11359), 1,
      anon_sym___attribute,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7504), 1,
      sym__function_attributes_end,
    STATE(7654), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8739), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [261887] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8812), 1,
      anon_sym_DASH_GT,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(8816), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10279), 1,
      anon_sym___attribute__,
    ACTIONS(10282), 1,
      anon_sym___attribute,
    STATE(7536), 1,
      sym__function_attributes_end,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7657), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8722), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [261957] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8812), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10279), 1,
      anon_sym___attribute__,
    ACTIONS(10282), 1,
      anon_sym___attribute,
    ACTIONS(11152), 1,
      anon_sym_requires,
    ACTIONS(11155), 1,
      anon_sym_where,
    STATE(7461), 1,
      sym__function_attributes_end,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7664), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8258), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [262027] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8812), 1,
      anon_sym_DASH_GT,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(8816), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11077), 1,
      anon_sym___attribute__,
    ACTIONS(11080), 1,
      anon_sym___attribute,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7538), 1,
      sym__function_attributes_end,
    STATE(7658), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8653), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [262097] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8869), 1,
      anon_sym_DASH_GT,
    ACTIONS(8876), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10279), 1,
      anon_sym___attribute__,
    ACTIONS(10282), 1,
      anon_sym___attribute,
    STATE(7491), 1,
      sym__function_attributes_end,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7652), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8736), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [262167] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8812), 1,
      anon_sym_DASH_GT,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(8816), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11356), 1,
      anon_sym___attribute__,
    ACTIONS(11359), 1,
      anon_sym___attribute,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7539), 1,
      sym__function_attributes_end,
    STATE(7659), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8638), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [262237] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9118), 1,
      anon_sym_STAR,
    ACTIONS(9120), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9122), 1,
      anon_sym_AMP,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9594), 1,
      anon_sym___attribute,
    STATE(3608), 1,
      sym_parameter_list,
    STATE(7380), 1,
      sym__abstract_declarator,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9592), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [262291] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8869), 1,
      anon_sym_DASH_GT,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11356), 1,
      anon_sym___attribute__,
    ACTIONS(11359), 1,
      anon_sym___attribute,
    ACTIONS(11528), 1,
      anon_sym_requires,
    ACTIONS(11557), 1,
      anon_sym_where,
    STATE(7458), 1,
      sym__function_attributes_end,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7708), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(11312), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8271), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [262361] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2410), 1,
      anon_sym_const,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(2722), 1,
      sym_template_argument_list,
    ACTIONS(2408), 24,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
  [262403] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8812), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11077), 1,
      anon_sym___attribute__,
    ACTIONS(11080), 1,
      anon_sym___attribute,
    ACTIONS(11365), 1,
      anon_sym_requires,
    ACTIONS(11368), 1,
      anon_sym_where,
    STATE(7462), 1,
      sym__function_attributes_end,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7665), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8259), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [262473] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(9174), 1,
      anon_sym_DASH_GT,
    ACTIONS(9176), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7859), 1,
      sym__function_attributes_end,
    STATE(8110), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9186), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [262542] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8988), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11256), 1,
      anon_sym_requires,
    ACTIONS(11396), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7800), 1,
      sym__function_attributes_end,
    STATE(8137), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8709), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [262611] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8963), 1,
      anon_sym_DASH_GT,
    ACTIONS(8984), 1,
      anon_sym_requires,
    ACTIONS(8986), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7811), 1,
      sym__function_attributes_end,
    STATE(8057), 1,
      sym_trailing_return_type,
    STATE(9020), 1,
      sym_gnu_asm_expression,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(10823), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(10825), 2,
      anon_sym_LBRACK,
      sym_identifier,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7712), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(9067), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
  [262676] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(9181), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(11129), 1,
      anon_sym_requires,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7755), 1,
      sym__function_attributes_end,
    STATE(8099), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9000), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
  [262745] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(9181), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11256), 1,
      anon_sym_requires,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7774), 1,
      sym__function_attributes_end,
    STATE(8121), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8898), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
  [262814] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8988), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(11129), 1,
      anon_sym_requires,
    ACTIONS(11217), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7799), 1,
      sym__function_attributes_end,
    STATE(8136), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8708), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [262883] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8974), 1,
      anon_sym_DASH_GT,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11560), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11563), 1,
      anon_sym_requires,
    ACTIONS(11566), 1,
      anon_sym_where,
    STATE(7617), 1,
      sym_where_clause,
    STATE(7629), 1,
      sym__function_attributes_end,
    STATE(7952), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(11371), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8547), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
  [262952] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8963), 1,
      anon_sym_DASH_GT,
    ACTIONS(8984), 1,
      anon_sym_requires,
    ACTIONS(8986), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7747), 1,
      sym__function_attributes_end,
    STATE(8069), 1,
      sym_trailing_return_type,
    STATE(9020), 1,
      sym_gnu_asm_expression,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(11262), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(11264), 2,
      anon_sym_LBRACK,
      sym_identifier,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7712), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(9142), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
  [263017] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8974), 1,
      anon_sym_DASH_GT,
    ACTIONS(9183), 1,
      anon_sym_requires,
    ACTIONS(9185), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(11220), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7624), 1,
      sym_where_clause,
    STATE(7694), 1,
      sym__function_attributes_end,
    STATE(8004), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9006), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
  [263086] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8974), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11402), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11405), 1,
      anon_sym_requires,
    ACTIONS(11408), 1,
      anon_sym_where,
    STATE(7626), 1,
      sym_where_clause,
    STATE(7736), 1,
      sym__function_attributes_end,
    STATE(7951), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(11086), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8546), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
  [263155] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8963), 1,
      anon_sym_DASH_GT,
    ACTIONS(8984), 1,
      anon_sym_requires,
    ACTIONS(8986), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7873), 1,
      sym__function_attributes_end,
    STATE(8149), 1,
      sym_trailing_return_type,
    STATE(9020), 1,
      sym_gnu_asm_expression,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(10024), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(10026), 2,
      anon_sym_LBRACK,
      sym_identifier,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7712), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(9170), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
  [263220] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(9174), 1,
      anon_sym_DASH_GT,
    ACTIONS(9176), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7857), 1,
      sym__function_attributes_end,
    STATE(8107), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9184), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [263289] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8988), 1,
      anon_sym_DASH_GT,
    ACTIONS(9189), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7793), 1,
      sym__function_attributes_end,
    STATE(8079), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9063), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [263358] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(9174), 1,
      anon_sym_DASH_GT,
    ACTIONS(9176), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7858), 1,
      sym__function_attributes_end,
    STATE(8109), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9185), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [263427] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9174), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11365), 1,
      anon_sym_requires,
    ACTIONS(11393), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7862), 1,
      sym__function_attributes_end,
    STATE(8115), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8715), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [263496] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8974), 1,
      anon_sym_DASH_GT,
    ACTIONS(9183), 1,
      anon_sym_requires,
    ACTIONS(9185), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11402), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7626), 1,
      sym_where_clause,
    STATE(7695), 1,
      sym__function_attributes_end,
    STATE(7897), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9022), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
  [263565] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8988), 1,
      anon_sym_DASH_GT,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11528), 1,
      anon_sym_requires,
    ACTIONS(11569), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7801), 1,
      sym__function_attributes_end,
    STATE(8139), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(11312), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8710), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [263634] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8963), 1,
      anon_sym_DASH_GT,
    ACTIONS(11572), 1,
      anon_sym_requires,
    ACTIONS(11575), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7746), 1,
      sym__function_attributes_end,
    STATE(8072), 1,
      sym_trailing_return_type,
    STATE(9020), 1,
      sym_gnu_asm_expression,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(11262), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(11264), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(11542), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7712), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8732), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
  [263699] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8963), 1,
      anon_sym_DASH_GT,
    ACTIONS(11225), 1,
      anon_sym_requires,
    ACTIONS(11228), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7865), 1,
      sym__function_attributes_end,
    STATE(8016), 1,
      sym_trailing_return_type,
    STATE(9020), 1,
      sym_gnu_asm_expression,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(10024), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(10026), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(11098), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7712), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8770), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
  [263764] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8988), 1,
      anon_sym_DASH_GT,
    ACTIONS(9189), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7794), 1,
      sym__function_attributes_end,
    STATE(8080), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9071), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [263833] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8963), 1,
      anon_sym_DASH_GT,
    ACTIONS(11387), 1,
      anon_sym_requires,
    ACTIONS(11390), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7876), 1,
      sym__function_attributes_end,
    STATE(8045), 1,
      sym_trailing_return_type,
    STATE(9020), 1,
      sym_gnu_asm_expression,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(10823), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
    ACTIONS(10825), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(11281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7712), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8626), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8141), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
  [263898] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8974), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(11220), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11231), 1,
      anon_sym_requires,
    ACTIONS(11234), 1,
      anon_sym_where,
    STATE(7624), 1,
      sym_where_clause,
    STATE(7730), 1,
      sym__function_attributes_end,
    STATE(8005), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10426), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8545), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
  [263967] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9174), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(11152), 1,
      anon_sym_requires,
    ACTIONS(11214), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7861), 1,
      sym__function_attributes_end,
    STATE(8114), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [264036] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9174), 1,
      anon_sym_DASH_GT,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11551), 1,
      anon_sym_requires,
    ACTIONS(11578), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7863), 1,
      sym__function_attributes_end,
    STATE(8116), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(11312), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8716), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [264105] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(9181), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11528), 1,
      anon_sym_requires,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7807), 1,
      sym__function_attributes_end,
    STATE(8145), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9002), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
  [264174] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8988), 1,
      anon_sym_DASH_GT,
    ACTIONS(9189), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7792), 1,
      sym__function_attributes_end,
    STATE(8078), 1,
      sym_trailing_return_type,
    STATE(8935), 1,
      sym_gnu_asm_expression,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6949), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6969), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9055), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [264243] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8141), 1,
      anon_sym___asm,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(8974), 1,
      anon_sym_DASH_GT,
    ACTIONS(9183), 1,
      anon_sym_requires,
    ACTIONS(9185), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11560), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7617), 1,
      sym_where_clause,
    STATE(7696), 1,
      sym__function_attributes_end,
    STATE(7903), 1,
      sym_trailing_return_type,
    STATE(8912), 1,
      sym_gnu_asm_expression,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8139), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(7135), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7489), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8905), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
  [264312] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9280), 1,
      anon_sym_STAR,
    ACTIONS(9282), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9284), 1,
      anon_sym_AMP,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    STATE(3540), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7613), 1,
      sym__abstract_declarator,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9592), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [264362] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(7403), 1,
      sym_ms_call_modifier,
    STATE(8948), 1,
      sym__type_declarator,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(11581), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [264420] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(7432), 1,
      sym_ms_call_modifier,
    STATE(8968), 1,
      sym__type_declarator,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(11581), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [264478] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(7394), 1,
      sym_ms_call_modifier,
    STATE(8947), 1,
      sym__type_declarator,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(11581), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [264536] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(7452), 1,
      sym_ms_call_modifier,
    STATE(8939), 1,
      sym__type_declarator,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(11581), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [264594] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11413), 1,
      sym_identifier,
    ACTIONS(11583), 1,
      anon_sym_LPAREN2,
    ACTIONS(11585), 1,
      anon_sym_LBRACE,
    ACTIONS(11589), 1,
      anon_sym_requires,
    STATE(4999), 1,
      sym_template_type,
    STATE(5150), 1,
      sym_requirement_seq,
    STATE(6433), 1,
      sym_lambda_capture_specifier,
    STATE(8676), 1,
      sym__scope_resolution,
    STATE(10412), 1,
      sym_requires_parameter_list,
    ACTIONS(11587), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6125), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [264655] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9317), 1,
      anon_sym_STAR,
    ACTIONS(9319), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9321), 1,
      anon_sym_AMP,
    STATE(3623), 1,
      sym_parameter_list,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7716), 1,
      sym__abstract_declarator,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9592), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [264704] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(10875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11437), 1,
      sym_identifier,
    ACTIONS(11591), 1,
      anon_sym_LPAREN2,
    ACTIONS(11593), 1,
      anon_sym_LBRACE,
    ACTIONS(11597), 1,
      anon_sym_requires,
    STATE(3528), 1,
      sym_template_type,
    STATE(4729), 1,
      sym_requirement_seq,
    STATE(6410), 1,
      sym_lambda_capture_specifier,
    STATE(8655), 1,
      sym__scope_resolution,
    STATE(10714), 1,
      sym_requires_parameter_list,
    ACTIONS(11595), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4698), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [264765] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11421), 1,
      sym_identifier,
    ACTIONS(11599), 1,
      anon_sym_LPAREN2,
    ACTIONS(11601), 1,
      anon_sym_LBRACE,
    ACTIONS(11605), 1,
      anon_sym_requires,
    STATE(3008), 1,
      sym_template_type,
    STATE(4031), 1,
      sym_requirement_seq,
    STATE(6437), 1,
      sym_lambda_capture_specifier,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(10579), 1,
      sym_requires_parameter_list,
    ACTIONS(11603), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5259), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [264826] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6781), 1,
      anon_sym_const,
    ACTIONS(11607), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(11609), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6783), 20,
      anon_sym_LPAREN2,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
  [264863] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(10930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11443), 1,
      sym_identifier,
    ACTIONS(11599), 1,
      anon_sym_LPAREN2,
    ACTIONS(11601), 1,
      anon_sym_LBRACE,
    ACTIONS(11605), 1,
      anon_sym_requires,
    STATE(4031), 1,
      sym_requirement_seq,
    STATE(4522), 1,
      sym_template_type,
    STATE(6437), 1,
      sym_lambda_capture_specifier,
    STATE(8723), 1,
      sym__scope_resolution,
    STATE(10579), 1,
      sym_requires_parameter_list,
    ACTIONS(11611), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5339), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [264924] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(10904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11450), 1,
      sym_identifier,
    ACTIONS(11613), 1,
      anon_sym_LPAREN2,
    ACTIONS(11615), 1,
      anon_sym_LBRACE,
    ACTIONS(11619), 1,
      anon_sym_requires,
    STATE(3502), 1,
      sym_template_type,
    STATE(4593), 1,
      sym_requirement_seq,
    STATE(6439), 1,
      sym_lambda_capture_specifier,
    STATE(8746), 1,
      sym__scope_resolution,
    STATE(10583), 1,
      sym_requires_parameter_list,
    ACTIONS(11617), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4659), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [264985] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6806), 1,
      anon_sym_const,
    ACTIONS(11609), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6808), 22,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
  [265020] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(11053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11435), 1,
      sym_identifier,
    ACTIONS(11621), 1,
      anon_sym_LPAREN2,
    ACTIONS(11623), 1,
      anon_sym_LBRACE,
    ACTIONS(11627), 1,
      anon_sym_requires,
    STATE(3571), 1,
      sym_template_type,
    STATE(4935), 1,
      sym_requirement_seq,
    STATE(6465), 1,
      sym_lambda_capture_specifier,
    STATE(8630), 1,
      sym__scope_resolution,
    STATE(10369), 1,
      sym_requires_parameter_list,
    ACTIONS(11625), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4882), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [265081] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11439), 1,
      sym_identifier,
    ACTIONS(11629), 1,
      anon_sym_LPAREN2,
    ACTIONS(11631), 1,
      anon_sym_LBRACE,
    ACTIONS(11635), 1,
      anon_sym_requires,
    STATE(3103), 1,
      sym_template_type,
    STATE(3413), 1,
      sym_requirement_seq,
    STATE(6429), 1,
      sym_lambda_capture_specifier,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(10496), 1,
      sym_requires_parameter_list,
    ACTIONS(11633), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3421), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [265142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11639), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(11637), 14,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
      anon_sym_where,
  [265175] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11641), 1,
      anon_sym_COLON,
    ACTIONS(11643), 1,
      anon_sym_SEMI,
    ACTIONS(11645), 1,
      anon_sym_LBRACE,
    ACTIONS(11647), 1,
      anon_sym_LBRACK,
    ACTIONS(11649), 1,
      anon_sym_EQ,
    ACTIONS(11651), 1,
      anon_sym_try,
    STATE(2003), 1,
      sym_compound_statement,
    STATE(2004), 1,
      sym_default_method_clause,
    STATE(2005), 1,
      sym_delete_method_clause,
    STATE(2006), 1,
      sym_pure_virtual_clause,
    STATE(2007), 1,
      sym_try_statement,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(8205), 1,
      sym__function_declarator_seq,
    STATE(9049), 1,
      sym_bitfield_clause,
    STATE(9050), 1,
      sym_initializer_list,
    STATE(9058), 1,
      aux_sym_field_declaration_repeat1,
    STATE(11634), 1,
      sym_attribute_specifier,
    STATE(8087), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [265249] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8202), 1,
      anon_sym_DASH_GT,
    ACTIONS(11660), 1,
      anon_sym_requires,
    ACTIONS(11663), 1,
      anon_sym_where,
    STATE(7038), 1,
      sym_trailing_return_type,
    STATE(7608), 1,
      sym_where_clause,
    ACTIONS(11655), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11657), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7512), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [265297] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8202), 1,
      anon_sym_DASH_GT,
    ACTIONS(10429), 1,
      anon_sym_requires,
    ACTIONS(10432), 1,
      anon_sym_where,
    STATE(7035), 1,
      sym_trailing_return_type,
    STATE(7624), 1,
      sym_where_clause,
    ACTIONS(10026), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10426), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7509), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [265345] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11641), 1,
      anon_sym_COLON,
    ACTIONS(11647), 1,
      anon_sym_LBRACK,
    ACTIONS(11666), 1,
      anon_sym_SEMI,
    ACTIONS(11668), 1,
      anon_sym_LBRACE,
    ACTIONS(11670), 1,
      anon_sym_EQ,
    ACTIONS(11672), 1,
      anon_sym_try,
    STATE(1994), 1,
      sym_delete_method_clause,
    STATE(2455), 1,
      sym_compound_statement,
    STATE(2456), 1,
      sym_default_method_clause,
    STATE(2457), 1,
      sym_pure_virtual_clause,
    STATE(2458), 1,
      sym_try_statement,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(8205), 1,
      sym__function_declarator_seq,
    STATE(9157), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9163), 1,
      sym_bitfield_clause,
    STATE(9171), 1,
      sym_initializer_list,
    STATE(11209), 1,
      sym_attribute_specifier,
    STATE(8087), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [265419] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8202), 1,
      anon_sym_DASH_GT,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8206), 1,
      anon_sym_where,
    STATE(7055), 1,
      sym_trailing_return_type,
    STATE(7617), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(11264), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7849), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [265467] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9365), 1,
      anon_sym_STAR,
    ACTIONS(9367), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9369), 1,
      anon_sym_AMP,
    STATE(3676), 1,
      sym_parameter_list,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7841), 1,
      sym__abstract_declarator,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9592), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [265515] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8202), 1,
      anon_sym_DASH_GT,
    ACTIONS(11089), 1,
      anon_sym_requires,
    ACTIONS(11092), 1,
      anon_sym_where,
    STATE(7036), 1,
      sym_trailing_return_type,
    STATE(7626), 1,
      sym_where_clause,
    ACTIONS(10825), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11086), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7510), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [265563] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11641), 1,
      anon_sym_COLON,
    ACTIONS(11647), 1,
      anon_sym_LBRACK,
    ACTIONS(11674), 1,
      anon_sym_SEMI,
    ACTIONS(11676), 1,
      anon_sym_LBRACE,
    ACTIONS(11678), 1,
      anon_sym_EQ,
    ACTIONS(11680), 1,
      anon_sym_try,
    STATE(1799), 1,
      sym_compound_statement,
    STATE(1800), 1,
      sym_default_method_clause,
    STATE(1801), 1,
      sym_delete_method_clause,
    STATE(1802), 1,
      sym_pure_virtual_clause,
    STATE(1803), 1,
      sym_try_statement,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(8205), 1,
      sym__function_declarator_seq,
    STATE(9180), 1,
      sym_bitfield_clause,
    STATE(9181), 1,
      sym_initializer_list,
    STATE(9191), 1,
      aux_sym_field_declaration_repeat1,
    STATE(11584), 1,
      sym_attribute_specifier,
    STATE(8087), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [265637] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9335), 1,
      anon_sym_STAR,
    ACTIONS(9337), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9339), 1,
      anon_sym_AMP,
    ACTIONS(9594), 1,
      anon_sym___attribute,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(7749), 1,
      sym__abstract_declarator,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9592), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [265687] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8202), 1,
      anon_sym_DASH_GT,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8206), 1,
      anon_sym_where,
    STATE(7004), 1,
      sym_trailing_return_type,
    STATE(7624), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(10026), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7838), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [265735] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9345), 1,
      anon_sym_STAR,
    ACTIONS(9347), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9349), 1,
      anon_sym_AMP,
    ACTIONS(9594), 1,
      anon_sym___attribute,
    STATE(3755), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(7763), 1,
      sym__abstract_declarator,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9592), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [265785] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8202), 1,
      anon_sym_DASH_GT,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8206), 1,
      anon_sym_where,
    STATE(7006), 1,
      sym_trailing_return_type,
    STATE(7626), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(10825), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7848), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [265833] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8202), 1,
      anon_sym_DASH_GT,
    ACTIONS(11374), 1,
      anon_sym_requires,
    ACTIONS(11377), 1,
      anon_sym_where,
    STATE(7037), 1,
      sym_trailing_return_type,
    STATE(7617), 1,
      sym_where_clause,
    ACTIONS(11264), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11371), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7511), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [265881] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(9885), 1,
      sym_identifier,
    ACTIONS(9887), 1,
      anon_sym_LPAREN2,
    ACTIONS(9889), 1,
      anon_sym_STAR,
    ACTIONS(9891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9893), 1,
      anon_sym_AMP,
    STATE(7593), 1,
      sym_ms_call_modifier,
    STATE(8797), 1,
      sym__field_declarator,
    STATE(9120), 1,
      sym_operator_name,
    STATE(11011), 1,
      sym_ms_based_modifier,
    ACTIONS(2817), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(8244), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [265935] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8202), 1,
      anon_sym_DASH_GT,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8206), 1,
      anon_sym_where,
    STATE(7008), 1,
      sym_trailing_return_type,
    STATE(7608), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(11655), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7853), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [265983] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11686), 1,
      anon_sym_LPAREN2,
    ACTIONS(11684), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(11682), 12,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [266016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11690), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(11688), 12,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [266047] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11694), 1,
      anon_sym_LBRACK,
    STATE(5308), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6955), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11692), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [266088] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11698), 1,
      anon_sym_LBRACK,
    STATE(5308), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11696), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [266129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11702), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(11700), 12,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [266160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11706), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(11704), 12,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [266191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11710), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(11708), 12,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [266222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11714), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(11712), 12,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [266253] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7021), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11698), 9,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11696), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [266287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6124), 10,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6126), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [266317] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11421), 1,
      sym_identifier,
    ACTIONS(11605), 1,
      anon_sym_requires,
    ACTIONS(11716), 1,
      anon_sym_LPAREN2,
    STATE(3008), 1,
      sym_template_type,
    STATE(6437), 1,
      sym_lambda_capture_specifier,
    STATE(8677), 1,
      sym__scope_resolution,
    ACTIONS(11718), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4052), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [266369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 10,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6130), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [266399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6136), 10,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6138), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [266429] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11415), 1,
      sym_identifier,
    ACTIONS(11720), 1,
      anon_sym_LPAREN2,
    ACTIONS(11724), 1,
      anon_sym_requires,
    STATE(5258), 1,
      sym_template_type,
    STATE(6477), 1,
      sym_lambda_capture_specifier,
    STATE(8644), 1,
      sym__scope_resolution,
    ACTIONS(11722), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7199), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [266481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6112), 10,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6114), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [266511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6156), 10,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6158), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [266541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6144), 10,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6146), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [266571] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(11411), 1,
      sym_identifier,
    ACTIONS(11605), 1,
      anon_sym_requires,
    ACTIONS(11716), 1,
      anon_sym_LPAREN2,
    ACTIONS(11726), 1,
      anon_sym_COLON_COLON,
    STATE(5258), 1,
      sym_template_type,
    STATE(6437), 1,
      sym_lambda_capture_specifier,
    STATE(8705), 1,
      sym__scope_resolution,
    ACTIONS(11728), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(8185), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [266623] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(11411), 1,
      sym_identifier,
    ACTIONS(11605), 1,
      anon_sym_requires,
    ACTIONS(11716), 1,
      anon_sym_LPAREN2,
    ACTIONS(11726), 1,
      anon_sym_COLON_COLON,
    STATE(5258), 1,
      sym_template_type,
    STATE(6437), 1,
      sym_lambda_capture_specifier,
    STATE(8705), 1,
      sym__scope_resolution,
    ACTIONS(11718), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4052), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [266675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6160), 10,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6162), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [266705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6164), 10,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6166), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [266735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6170), 10,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6172), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [266765] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7021), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11694), 9,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11692), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [266799] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11415), 1,
      sym_identifier,
    ACTIONS(11720), 1,
      anon_sym_LPAREN2,
    ACTIONS(11724), 1,
      anon_sym_requires,
    STATE(5258), 1,
      sym_template_type,
    STATE(6477), 1,
      sym_lambda_capture_specifier,
    STATE(8644), 1,
      sym__scope_resolution,
    ACTIONS(11730), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7083), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [266851] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11415), 1,
      sym_identifier,
    ACTIONS(11720), 1,
      anon_sym_LPAREN2,
    ACTIONS(11724), 1,
      anon_sym_requires,
    STATE(5258), 1,
      sym_template_type,
    STATE(6477), 1,
      sym_lambda_capture_specifier,
    STATE(8644), 1,
      sym__scope_resolution,
    ACTIONS(11732), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6963), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [266903] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(141), 1,
      anon_sym_operator,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(4449), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(11734), 1,
      sym_identifier,
    ACTIONS(11736), 1,
      anon_sym_template,
    STATE(2720), 1,
      sym_qualified_type_identifier,
    STATE(2721), 1,
      sym_dependent_type_identifier,
    STATE(2723), 1,
      sym_template_type,
    STATE(3618), 1,
      sym_pointer_type_declarator,
    STATE(3619), 1,
      sym_template_function,
    STATE(3640), 1,
      sym_destructor_name,
    STATE(3641), 1,
      sym_dependent_identifier,
    STATE(3643), 1,
      sym_qualified_identifier,
    STATE(3644), 1,
      sym_operator_name,
    STATE(6972), 1,
      sym__scope_resolution,
    STATE(9475), 1,
      sym_operator_cast,
    STATE(9493), 1,
      sym_qualified_operator_cast_identifier,
    STATE(10936), 1,
      sym_ms_based_modifier,
    STATE(11339), 1,
      sym_decltype,
  [266973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6120), 10,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6122), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [267003] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11419), 1,
      sym_identifier,
    ACTIONS(11589), 1,
      anon_sym_requires,
    ACTIONS(11738), 1,
      anon_sym_LPAREN2,
    STATE(5258), 1,
      sym_template_type,
    STATE(6433), 1,
      sym_lambda_capture_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    ACTIONS(11740), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7851), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [267055] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(10930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11443), 1,
      sym_identifier,
    ACTIONS(11605), 1,
      anon_sym_requires,
    ACTIONS(11716), 1,
      anon_sym_LPAREN2,
    STATE(4522), 1,
      sym_template_type,
    STATE(6437), 1,
      sym_lambda_capture_specifier,
    STATE(8723), 1,
      sym__scope_resolution,
    ACTIONS(11742), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5331), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [267107] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(10930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11443), 1,
      sym_identifier,
    ACTIONS(11605), 1,
      anon_sym_requires,
    ACTIONS(11716), 1,
      anon_sym_LPAREN2,
    STATE(4522), 1,
      sym_template_type,
    STATE(6437), 1,
      sym_lambda_capture_specifier,
    STATE(8723), 1,
      sym__scope_resolution,
    ACTIONS(11718), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4052), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [267159] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(11411), 1,
      sym_identifier,
    ACTIONS(11605), 1,
      anon_sym_requires,
    ACTIONS(11716), 1,
      anon_sym_LPAREN2,
    ACTIONS(11726), 1,
      anon_sym_COLON_COLON,
    STATE(5258), 1,
      sym_template_type,
    STATE(6437), 1,
      sym_lambda_capture_specifier,
    STATE(8705), 1,
      sym__scope_resolution,
    ACTIONS(11744), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(8236), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [267211] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(11746), 1,
      sym_identifier,
    ACTIONS(11748), 1,
      anon_sym_LPAREN2,
    ACTIONS(11750), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11754), 1,
      anon_sym_requires,
    STATE(2691), 1,
      sym_template_type,
    STATE(6415), 1,
      sym_lambda_capture_specifier,
    STATE(8752), 1,
      sym__scope_resolution,
    ACTIONS(11752), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2699), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [267263] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(11746), 1,
      sym_identifier,
    ACTIONS(11748), 1,
      anon_sym_LPAREN2,
    ACTIONS(11750), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11754), 1,
      anon_sym_requires,
    STATE(2691), 1,
      sym_template_type,
    STATE(6415), 1,
      sym_lambda_capture_specifier,
    STATE(8752), 1,
      sym__scope_resolution,
    ACTIONS(11756), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(1668), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [267315] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7021), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11758), 9,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11760), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [267349] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9470), 1,
      anon_sym_STAR,
    ACTIONS(9472), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9474), 1,
      anon_sym_AMP,
    ACTIONS(9594), 1,
      anon_sym___attribute,
    STATE(4172), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8038), 1,
      sym__abstract_declarator,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9592), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [267397] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11419), 1,
      sym_identifier,
    ACTIONS(11589), 1,
      anon_sym_requires,
    ACTIONS(11738), 1,
      anon_sym_LPAREN2,
    STATE(5258), 1,
      sym_template_type,
    STATE(6433), 1,
      sym_lambda_capture_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    ACTIONS(11762), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7779), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [267449] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11419), 1,
      sym_identifier,
    ACTIONS(11589), 1,
      anon_sym_requires,
    ACTIONS(11738), 1,
      anon_sym_LPAREN2,
    STATE(5258), 1,
      sym_template_type,
    STATE(6433), 1,
      sym_lambda_capture_specifier,
    STATE(8601), 1,
      sym__scope_resolution,
    ACTIONS(11764), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5148), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [267501] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(9606), 1,
      anon_sym_STAR,
    ACTIONS(11766), 1,
      sym_identifier,
    ACTIONS(11768), 1,
      anon_sym_TILDE,
    ACTIONS(11770), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11772), 1,
      anon_sym_template,
    ACTIONS(11774), 1,
      anon_sym_operator,
    STATE(399), 1,
      sym_template_type,
    STATE(400), 1,
      sym_dependent_type_identifier,
    STATE(401), 1,
      sym_qualified_type_identifier,
    STATE(3618), 1,
      sym_pointer_type_declarator,
    STATE(3619), 1,
      sym_template_function,
    STATE(3640), 1,
      sym_destructor_name,
    STATE(3641), 1,
      sym_dependent_identifier,
    STATE(3643), 1,
      sym_qualified_identifier,
    STATE(3644), 1,
      sym_operator_name,
    STATE(6984), 1,
      sym__scope_resolution,
    STATE(9475), 1,
      sym_operator_cast,
    STATE(9493), 1,
      sym_qualified_operator_cast_identifier,
    STATE(11339), 1,
      sym_decltype,
    STATE(11420), 1,
      sym_ms_based_modifier,
  [267571] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(9606), 1,
      anon_sym_STAR,
    ACTIONS(11768), 1,
      anon_sym_TILDE,
    ACTIONS(11774), 1,
      anon_sym_operator,
    ACTIONS(11776), 1,
      sym_identifier,
    ACTIONS(11778), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11780), 1,
      anon_sym_template,
    STATE(205), 1,
      sym_template_type,
    STATE(206), 1,
      sym_dependent_type_identifier,
    STATE(214), 1,
      sym_qualified_type_identifier,
    STATE(3618), 1,
      sym_pointer_type_declarator,
    STATE(3619), 1,
      sym_template_function,
    STATE(3640), 1,
      sym_destructor_name,
    STATE(3641), 1,
      sym_dependent_identifier,
    STATE(3643), 1,
      sym_qualified_identifier,
    STATE(3644), 1,
      sym_operator_name,
    STATE(6985), 1,
      sym__scope_resolution,
    STATE(9475), 1,
      sym_operator_cast,
    STATE(9493), 1,
      sym_qualified_operator_cast_identifier,
    STATE(11339), 1,
      sym_decltype,
    STATE(11420), 1,
      sym_ms_based_modifier,
  [267641] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11427), 1,
      sym_identifier,
    ACTIONS(11720), 1,
      anon_sym_LPAREN2,
    ACTIONS(11724), 1,
      anon_sym_requires,
    STATE(5258), 1,
      sym_template_type,
    STATE(6477), 1,
      sym_lambda_capture_specifier,
    STATE(8679), 1,
      sym__scope_resolution,
    ACTIONS(11782), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7991), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [267693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11786), 1,
      anon_sym_const,
    ACTIONS(11784), 21,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
  [267723] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(8753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11433), 1,
      sym_identifier,
    ACTIONS(11748), 1,
      anon_sym_LPAREN2,
    ACTIONS(11754), 1,
      anon_sym_requires,
    STATE(207), 1,
      sym_template_type,
    STATE(6436), 1,
      sym_lambda_capture_specifier,
    STATE(8727), 1,
      sym__scope_resolution,
    ACTIONS(11788), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(8130), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [267775] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(8753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11433), 1,
      sym_identifier,
    ACTIONS(11748), 1,
      anon_sym_LPAREN2,
    ACTIONS(11754), 1,
      anon_sym_requires,
    STATE(207), 1,
      sym_template_type,
    STATE(6436), 1,
      sym_lambda_capture_specifier,
    STATE(8727), 1,
      sym__scope_resolution,
    ACTIONS(11756), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(1668), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [267827] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9494), 1,
      anon_sym_STAR,
    ACTIONS(9496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9498), 1,
      anon_sym_AMP,
    STATE(3800), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8167), 1,
      sym__abstract_declarator,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9592), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [267873] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9484), 1,
      anon_sym_STAR,
    ACTIONS(9486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9488), 1,
      anon_sym_AMP,
    ACTIONS(9594), 1,
      anon_sym___attribute,
    STATE(4265), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8050), 1,
      sym__abstract_declarator,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9592), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [267921] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(11605), 1,
      anon_sym_requires,
    ACTIONS(11716), 1,
      anon_sym_LPAREN2,
    ACTIONS(11790), 1,
      sym_identifier,
    ACTIONS(11792), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(6423), 1,
      sym_lambda_capture_specifier,
    STATE(8741), 1,
      sym__scope_resolution,
    ACTIONS(11794), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(9316), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [267973] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11427), 1,
      sym_identifier,
    ACTIONS(11720), 1,
      anon_sym_LPAREN2,
    ACTIONS(11724), 1,
      anon_sym_requires,
    STATE(5258), 1,
      sym_template_type,
    STATE(6477), 1,
      sym_lambda_capture_specifier,
    STATE(8679), 1,
      sym__scope_resolution,
    ACTIONS(11796), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7996), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [268025] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11427), 1,
      sym_identifier,
    ACTIONS(11720), 1,
      anon_sym_LPAREN2,
    ACTIONS(11724), 1,
      anon_sym_requires,
    STATE(5258), 1,
      sym_template_type,
    STATE(6477), 1,
      sym_lambda_capture_specifier,
    STATE(8679), 1,
      sym__scope_resolution,
    ACTIONS(11732), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6963), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [268077] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11439), 1,
      sym_identifier,
    ACTIONS(11635), 1,
      anon_sym_requires,
    ACTIONS(11798), 1,
      anon_sym_LPAREN2,
    STATE(3103), 1,
      sym_template_type,
    STATE(6429), 1,
      sym_lambda_capture_specifier,
    STATE(8689), 1,
      sym__scope_resolution,
    ACTIONS(11800), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3438), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [268129] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11439), 1,
      sym_identifier,
    ACTIONS(11635), 1,
      anon_sym_requires,
    ACTIONS(11798), 1,
      anon_sym_LPAREN2,
    STATE(3103), 1,
      sym_template_type,
    STATE(6429), 1,
      sym_lambda_capture_specifier,
    STATE(8689), 1,
      sym__scope_resolution,
    ACTIONS(11802), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3440), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [268181] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(11053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11435), 1,
      sym_identifier,
    ACTIONS(11627), 1,
      anon_sym_requires,
    ACTIONS(11804), 1,
      anon_sym_LPAREN2,
    STATE(3571), 1,
      sym_template_type,
    STATE(6465), 1,
      sym_lambda_capture_specifier,
    STATE(8630), 1,
      sym__scope_resolution,
    ACTIONS(11806), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4945), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [268233] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(11053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11435), 1,
      sym_identifier,
    ACTIONS(11627), 1,
      anon_sym_requires,
    ACTIONS(11804), 1,
      anon_sym_LPAREN2,
    STATE(3571), 1,
      sym_template_type,
    STATE(6465), 1,
      sym_lambda_capture_specifier,
    STATE(8630), 1,
      sym__scope_resolution,
    ACTIONS(11808), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4946), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [268285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2414), 10,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(2412), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [268315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2404), 10,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(2402), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [268345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11812), 1,
      anon_sym_const,
    ACTIONS(11810), 21,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
  [268375] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8206), 1,
      anon_sym_where,
    STATE(7624), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(10026), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7838), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [268417] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11816), 1,
      anon_sym_LPAREN2,
    STATE(7264), 1,
      sym_preproc_argument_list,
    ACTIONS(11818), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(11814), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [268451] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8206), 1,
      anon_sym_where,
    STATE(7626), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(10825), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7848), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [268493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11822), 1,
      anon_sym_const,
    ACTIONS(11820), 21,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
  [268523] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8206), 1,
      anon_sym_where,
    STATE(7617), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(11264), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7849), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [268565] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(10875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11437), 1,
      sym_identifier,
    ACTIONS(11597), 1,
      anon_sym_requires,
    ACTIONS(11824), 1,
      anon_sym_LPAREN2,
    STATE(3528), 1,
      sym_template_type,
    STATE(6410), 1,
      sym_lambda_capture_specifier,
    STATE(8655), 1,
      sym__scope_resolution,
    ACTIONS(11826), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4711), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [268617] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8206), 1,
      anon_sym_where,
    STATE(7625), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(11830), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7855), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [268659] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11433), 1,
      sym_identifier,
    ACTIONS(11832), 1,
      anon_sym_LPAREN2,
    ACTIONS(11836), 1,
      anon_sym_requires,
    STATE(207), 1,
      sym_template_type,
    STATE(6431), 1,
      sym_lambda_capture_specifier,
    STATE(8636), 1,
      sym__scope_resolution,
    ACTIONS(11834), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7561), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [268711] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11433), 1,
      sym_identifier,
    ACTIONS(11832), 1,
      anon_sym_LPAREN2,
    ACTIONS(11836), 1,
      anon_sym_requires,
    STATE(207), 1,
      sym_template_type,
    STATE(6431), 1,
      sym_lambda_capture_specifier,
    STATE(8636), 1,
      sym__scope_resolution,
    ACTIONS(11838), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7584), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [268763] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11433), 1,
      sym_identifier,
    ACTIONS(11832), 1,
      anon_sym_LPAREN2,
    ACTIONS(11836), 1,
      anon_sym_requires,
    STATE(207), 1,
      sym_template_type,
    STATE(6431), 1,
      sym_lambda_capture_specifier,
    STATE(8636), 1,
      sym__scope_resolution,
    ACTIONS(11840), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7122), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [268815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5540), 1,
      anon_sym_const,
    ACTIONS(5538), 21,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
  [268845] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11429), 1,
      sym_identifier,
    ACTIONS(11832), 1,
      anon_sym_LPAREN2,
    ACTIONS(11836), 1,
      anon_sym_requires,
    STATE(207), 1,
      sym_template_type,
    STATE(6431), 1,
      sym_lambda_capture_specifier,
    STATE(8635), 1,
      sym__scope_resolution,
    ACTIONS(11842), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7121), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [268897] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11429), 1,
      sym_identifier,
    ACTIONS(11832), 1,
      anon_sym_LPAREN2,
    ACTIONS(11836), 1,
      anon_sym_requires,
    STATE(207), 1,
      sym_template_type,
    STATE(6431), 1,
      sym_lambda_capture_specifier,
    STATE(8635), 1,
      sym__scope_resolution,
    ACTIONS(11840), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7122), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [268949] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(9606), 1,
      anon_sym_STAR,
    ACTIONS(11768), 1,
      anon_sym_TILDE,
    ACTIONS(11774), 1,
      anon_sym_operator,
    ACTIONS(11844), 1,
      sym_identifier,
    ACTIONS(11846), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11848), 1,
      anon_sym_template,
    STATE(2720), 1,
      sym_qualified_type_identifier,
    STATE(2721), 1,
      sym_dependent_type_identifier,
    STATE(2723), 1,
      sym_template_type,
    STATE(3618), 1,
      sym_pointer_type_declarator,
    STATE(3619), 1,
      sym_template_function,
    STATE(3640), 1,
      sym_destructor_name,
    STATE(3641), 1,
      sym_dependent_identifier,
    STATE(3643), 1,
      sym_qualified_identifier,
    STATE(3644), 1,
      sym_operator_name,
    STATE(7015), 1,
      sym__scope_resolution,
    STATE(9475), 1,
      sym_operator_cast,
    STATE(9493), 1,
      sym_qualified_operator_cast_identifier,
    STATE(11339), 1,
      sym_decltype,
    STATE(11420), 1,
      sym_ms_based_modifier,
  [269019] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9464), 1,
      anon_sym_STAR,
    ACTIONS(9466), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9468), 1,
      anon_sym_AMP,
    STATE(3551), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8108), 1,
      sym__abstract_declarator,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9592), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [269065] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(11748), 1,
      anon_sym_LPAREN2,
    ACTIONS(11754), 1,
      anon_sym_requires,
    ACTIONS(11850), 1,
      sym_identifier,
    ACTIONS(11852), 1,
      anon_sym_COLON_COLON,
    STATE(2729), 1,
      sym_template_type,
    STATE(6457), 1,
      sym_lambda_capture_specifier,
    STATE(8674), 1,
      sym__scope_resolution,
    ACTIONS(11854), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6925), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [269117] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    ACTIONS(11605), 1,
      anon_sym_requires,
    ACTIONS(11716), 1,
      anon_sym_LPAREN2,
    STATE(3008), 1,
      sym_template_type,
    STATE(6437), 1,
      sym_lambda_capture_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    ACTIONS(11856), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7570), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [269169] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    ACTIONS(11605), 1,
      anon_sym_requires,
    ACTIONS(11716), 1,
      anon_sym_LPAREN2,
    STATE(3008), 1,
      sym_template_type,
    STATE(6437), 1,
      sym_lambda_capture_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    ACTIONS(11718), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4052), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [269221] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    ACTIONS(11605), 1,
      anon_sym_requires,
    ACTIONS(11716), 1,
      anon_sym_LPAREN2,
    STATE(3008), 1,
      sym_template_type,
    STATE(6437), 1,
      sym_lambda_capture_specifier,
    STATE(8666), 1,
      sym__scope_resolution,
    ACTIONS(11858), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7579), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [269273] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11860), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(7021), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(4482), 9,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(7648), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [269307] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11413), 1,
      sym_identifier,
    ACTIONS(11589), 1,
      anon_sym_requires,
    ACTIONS(11738), 1,
      anon_sym_LPAREN2,
    STATE(4999), 1,
      sym_template_type,
    STATE(6433), 1,
      sym_lambda_capture_specifier,
    STATE(8676), 1,
      sym__scope_resolution,
    ACTIONS(11863), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6088), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [269359] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11413), 1,
      sym_identifier,
    ACTIONS(11589), 1,
      anon_sym_requires,
    ACTIONS(11738), 1,
      anon_sym_LPAREN2,
    STATE(4999), 1,
      sym_template_type,
    STATE(6433), 1,
      sym_lambda_capture_specifier,
    STATE(8676), 1,
      sym__scope_resolution,
    ACTIONS(11764), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5148), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [269411] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11429), 1,
      sym_identifier,
    ACTIONS(11832), 1,
      anon_sym_LPAREN2,
    ACTIONS(11836), 1,
      anon_sym_requires,
    STATE(207), 1,
      sym_template_type,
    STATE(6431), 1,
      sym_lambda_capture_specifier,
    STATE(8635), 1,
      sym__scope_resolution,
    ACTIONS(11865), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7074), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [269463] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(10904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11450), 1,
      sym_identifier,
    ACTIONS(11619), 1,
      anon_sym_requires,
    ACTIONS(11867), 1,
      anon_sym_LPAREN2,
    STATE(3502), 1,
      sym_template_type,
    STATE(6439), 1,
      sym_lambda_capture_specifier,
    STATE(8746), 1,
      sym__scope_resolution,
    ACTIONS(11869), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4624), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [269515] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(10904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11450), 1,
      sym_identifier,
    ACTIONS(11619), 1,
      anon_sym_requires,
    ACTIONS(11867), 1,
      anon_sym_LPAREN2,
    STATE(3502), 1,
      sym_template_type,
    STATE(6439), 1,
      sym_lambda_capture_specifier,
    STATE(8746), 1,
      sym__scope_resolution,
    ACTIONS(11871), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4626), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [269567] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(8753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11433), 1,
      sym_identifier,
    ACTIONS(11748), 1,
      anon_sym_LPAREN2,
    ACTIONS(11754), 1,
      anon_sym_requires,
    STATE(207), 1,
      sym_template_type,
    STATE(6436), 1,
      sym_lambda_capture_specifier,
    STATE(8727), 1,
      sym__scope_resolution,
    ACTIONS(11873), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(8098), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [269619] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(11605), 1,
      anon_sym_requires,
    ACTIONS(11716), 1,
      anon_sym_LPAREN2,
    ACTIONS(11790), 1,
      sym_identifier,
    ACTIONS(11792), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(6423), 1,
      sym_lambda_capture_specifier,
    STATE(8741), 1,
      sym__scope_resolution,
    ACTIONS(11875), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(9244), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [269671] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(11605), 1,
      anon_sym_requires,
    ACTIONS(11716), 1,
      anon_sym_LPAREN2,
    ACTIONS(11790), 1,
      sym_identifier,
    ACTIONS(11792), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(6423), 1,
      sym_lambda_capture_specifier,
    STATE(8741), 1,
      sym__scope_resolution,
    ACTIONS(11718), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4052), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [269723] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8172), 1,
      anon_sym_where,
    STATE(7303), 1,
      sym_trailing_return_type,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8170), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [269767] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8172), 1,
      anon_sym_where,
    STATE(7304), 1,
      sym_trailing_return_type,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [269811] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8172), 1,
      anon_sym_where,
    STATE(7305), 1,
      sym_trailing_return_type,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8175), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [269855] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8172), 1,
      anon_sym_where,
    STATE(7308), 1,
      sym_trailing_return_type,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8008), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [269899] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10429), 1,
      anon_sym_requires,
    ACTIONS(10432), 1,
      anon_sym_where,
    STATE(7624), 1,
      sym_where_clause,
    ACTIONS(10026), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10426), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7509), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [269941] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11089), 1,
      anon_sym_requires,
    ACTIONS(11092), 1,
      anon_sym_where,
    STATE(7626), 1,
      sym_where_clause,
    ACTIONS(10825), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11086), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7510), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [269983] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11374), 1,
      anon_sym_requires,
    ACTIONS(11377), 1,
      anon_sym_where,
    STATE(7617), 1,
      sym_where_clause,
    ACTIONS(11264), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11371), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7511), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [270025] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11660), 1,
      anon_sym_requires,
    ACTIONS(11663), 1,
      anon_sym_where,
    STATE(7608), 1,
      sym_where_clause,
    ACTIONS(11655), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11657), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7512), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [270067] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11880), 1,
      anon_sym_requires,
    ACTIONS(11883), 1,
      anon_sym_where,
    STATE(7625), 1,
      sym_where_clause,
    ACTIONS(11830), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11877), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7513), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [270109] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(10031), 1,
      anon_sym_requires,
    ACTIONS(10034), 1,
      anon_sym_where,
    STATE(7318), 1,
      sym_trailing_return_type,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7724), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [270153] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(10838), 1,
      anon_sym_requires,
    ACTIONS(10841), 1,
      anon_sym_where,
    STATE(7319), 1,
      sym_trailing_return_type,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7725), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [270197] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(11315), 1,
      anon_sym_requires,
    ACTIONS(11318), 1,
      anon_sym_where,
    STATE(7320), 1,
      sym_trailing_return_type,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11312), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7727), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [270241] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(11889), 1,
      anon_sym_requires,
    ACTIONS(11892), 1,
      anon_sym_where,
    STATE(7322), 1,
      sym_trailing_return_type,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11886), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [270285] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(11748), 1,
      anon_sym_LPAREN2,
    ACTIONS(11754), 1,
      anon_sym_requires,
    ACTIONS(11850), 1,
      sym_identifier,
    ACTIONS(11852), 1,
      anon_sym_COLON_COLON,
    STATE(2729), 1,
      sym_template_type,
    STATE(6457), 1,
      sym_lambda_capture_specifier,
    STATE(8674), 1,
      sym__scope_resolution,
    ACTIONS(11895), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6928), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [270337] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(11748), 1,
      anon_sym_LPAREN2,
    ACTIONS(11754), 1,
      anon_sym_requires,
    ACTIONS(11850), 1,
      sym_identifier,
    ACTIONS(11852), 1,
      anon_sym_COLON_COLON,
    STATE(2729), 1,
      sym_template_type,
    STATE(6457), 1,
      sym_lambda_capture_specifier,
    STATE(8674), 1,
      sym__scope_resolution,
    ACTIONS(11756), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(1668), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [270389] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(11746), 1,
      sym_identifier,
    ACTIONS(11748), 1,
      anon_sym_LPAREN2,
    ACTIONS(11750), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11754), 1,
      anon_sym_requires,
    STATE(2691), 1,
      sym_template_type,
    STATE(6415), 1,
      sym_lambda_capture_specifier,
    STATE(8752), 1,
      sym__scope_resolution,
    ACTIONS(11897), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2697), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [270441] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(10875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11437), 1,
      sym_identifier,
    ACTIONS(11597), 1,
      anon_sym_requires,
    ACTIONS(11824), 1,
      anon_sym_LPAREN2,
    STATE(3528), 1,
      sym_template_type,
    STATE(6410), 1,
      sym_lambda_capture_specifier,
    STATE(8655), 1,
      sym__scope_resolution,
    ACTIONS(11899), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4804), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [270493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6298), 10,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6300), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [270523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6302), 10,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6304), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [270553] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(141), 1,
      anon_sym_operator,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2464), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(11901), 1,
      sym_identifier,
    ACTIONS(11903), 1,
      anon_sym_template,
    STATE(2720), 1,
      sym_qualified_type_identifier,
    STATE(2721), 1,
      sym_dependent_type_identifier,
    STATE(2723), 1,
      sym_template_type,
    STATE(3618), 1,
      sym_pointer_type_declarator,
    STATE(3619), 1,
      sym_template_function,
    STATE(3640), 1,
      sym_destructor_name,
    STATE(3641), 1,
      sym_dependent_identifier,
    STATE(3643), 1,
      sym_qualified_identifier,
    STATE(3644), 1,
      sym_operator_name,
    STATE(7049), 1,
      sym__scope_resolution,
    STATE(9475), 1,
      sym_operator_cast,
    STATE(9493), 1,
      sym_qualified_operator_cast_identifier,
    STATE(10936), 1,
      sym_ms_based_modifier,
    STATE(11339), 1,
      sym_decltype,
  [270623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 10,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6324), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [270653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 10,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6324), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [270683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 10,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6324), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [270713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11907), 1,
      anon_sym_const,
    ACTIONS(11905), 21,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
  [270743] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11421), 1,
      sym_identifier,
    ACTIONS(11605), 1,
      anon_sym_requires,
    ACTIONS(11716), 1,
      anon_sym_LPAREN2,
    STATE(3008), 1,
      sym_template_type,
    STATE(6437), 1,
      sym_lambda_capture_specifier,
    STATE(8677), 1,
      sym__scope_resolution,
    ACTIONS(11909), 2,
      sym_true,
      sym_false,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5256), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [270795] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8206), 1,
      anon_sym_where,
    STATE(7608), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(11655), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7853), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [270837] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3059), 1,
      sym__class_declaration_item,
    STATE(6517), 1,
      sym_field_declaration_list,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9588), 1,
      sym_virtual_specifier,
    STATE(10713), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5838), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [270896] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8076), 1,
      anon_sym_LBRACE,
    ACTIONS(11053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11435), 1,
      sym_identifier,
    STATE(3571), 1,
      sym_template_type,
    STATE(3728), 1,
      sym_field_declaration_list,
    STATE(4361), 1,
      sym__class_declaration_item,
    STATE(8630), 1,
      sym__scope_resolution,
    STATE(9464), 1,
      sym_virtual_specifier,
    STATE(10507), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3488), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [270955] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8076), 1,
      anon_sym_LBRACE,
    ACTIONS(11053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11435), 1,
      sym_identifier,
    STATE(3571), 1,
      sym_template_type,
    STATE(3728), 1,
      sym_field_declaration_list,
    STATE(4366), 1,
      sym__class_declaration_item,
    STATE(8630), 1,
      sym__scope_resolution,
    STATE(9464), 1,
      sym_virtual_specifier,
    STATE(10507), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3488), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7059), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [271014] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8076), 1,
      anon_sym_LBRACE,
    ACTIONS(11053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11435), 1,
      sym_identifier,
    STATE(3571), 1,
      sym_template_type,
    STATE(3728), 1,
      sym_field_declaration_list,
    STATE(4376), 1,
      sym__class_declaration_item,
    STATE(8630), 1,
      sym__scope_resolution,
    STATE(9464), 1,
      sym_virtual_specifier,
    STATE(10507), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3488), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [271073] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11421), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3040), 1,
      sym__class_declaration_item,
    STATE(3225), 1,
      sym_field_declaration_list,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(9402), 1,
      sym_virtual_specifier,
    STATE(10341), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3099), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [271132] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8243), 1,
      anon_sym_DASH_GT,
    ACTIONS(8245), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    STATE(7376), 1,
      sym_trailing_return_type,
    STATE(7617), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8193), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [271177] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2876), 1,
      sym__class_declaration_item,
    STATE(8606), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3084), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [271236] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7812), 1,
      anon_sym_LBRACE,
    ACTIONS(10875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11437), 1,
      sym_identifier,
    STATE(3528), 1,
      sym_template_type,
    STATE(3622), 1,
      sym_field_declaration_list,
    STATE(3814), 1,
      sym__class_declaration_item,
    STATE(8655), 1,
      sym__scope_resolution,
    STATE(9509), 1,
      sym_virtual_specifier,
    STATE(10383), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3358), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7065), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [271295] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7812), 1,
      anon_sym_LBRACE,
    ACTIONS(10875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11437), 1,
      sym_identifier,
    STATE(3528), 1,
      sym_template_type,
    STATE(3622), 1,
      sym_field_declaration_list,
    STATE(3817), 1,
      sym__class_declaration_item,
    STATE(8655), 1,
      sym__scope_resolution,
    STATE(9509), 1,
      sym_virtual_specifier,
    STATE(10383), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3358), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [271354] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7812), 1,
      anon_sym_LBRACE,
    ACTIONS(10875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11437), 1,
      sym_identifier,
    STATE(3528), 1,
      sym_template_type,
    STATE(3622), 1,
      sym_field_declaration_list,
    STATE(3828), 1,
      sym__class_declaration_item,
    STATE(8655), 1,
      sym__scope_resolution,
    STATE(9509), 1,
      sym_virtual_specifier,
    STATE(10383), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3358), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [271413] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7812), 1,
      anon_sym_LBRACE,
    ACTIONS(10875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11437), 1,
      sym_identifier,
    STATE(3528), 1,
      sym_template_type,
    STATE(3622), 1,
      sym_field_declaration_list,
    STATE(3831), 1,
      sym__class_declaration_item,
    STATE(8655), 1,
      sym__scope_resolution,
    STATE(9509), 1,
      sym_virtual_specifier,
    STATE(10383), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3358), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7067), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [271472] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7812), 1,
      anon_sym_LBRACE,
    ACTIONS(10875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11437), 1,
      sym_identifier,
    STATE(3528), 1,
      sym_template_type,
    STATE(3622), 1,
      sym_field_declaration_list,
    STATE(3840), 1,
      sym__class_declaration_item,
    STATE(8655), 1,
      sym__scope_resolution,
    STATE(9509), 1,
      sym_virtual_specifier,
    STATE(10383), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3358), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [271531] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11429), 1,
      sym_identifier,
    ACTIONS(11431), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(305), 1,
      sym__class_declaration_item,
    STATE(6379), 1,
      sym_field_declaration_list,
    STATE(8684), 1,
      sym__scope_resolution,
    STATE(9579), 1,
      sym_virtual_specifier,
    STATE(10657), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5716), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [271590] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7724), 1,
      anon_sym_LBRACE,
    ACTIONS(10904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11450), 1,
      sym_identifier,
    STATE(3502), 1,
      sym_template_type,
    STATE(3582), 1,
      sym_field_declaration_list,
    STATE(3726), 1,
      sym__class_declaration_item,
    STATE(8746), 1,
      sym__scope_resolution,
    STATE(9571), 1,
      sym_virtual_specifier,
    STATE(10634), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [271649] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7724), 1,
      anon_sym_LBRACE,
    ACTIONS(10904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11450), 1,
      sym_identifier,
    STATE(3502), 1,
      sym_template_type,
    STATE(3582), 1,
      sym_field_declaration_list,
    STATE(3759), 1,
      sym__class_declaration_item,
    STATE(8746), 1,
      sym__scope_resolution,
    STATE(9571), 1,
      sym_virtual_specifier,
    STATE(10634), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7072), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [271708] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11429), 1,
      sym_identifier,
    ACTIONS(11431), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(288), 1,
      sym__class_declaration_item,
    STATE(6379), 1,
      sym_field_declaration_list,
    STATE(8684), 1,
      sym__scope_resolution,
    STATE(9579), 1,
      sym_virtual_specifier,
    STATE(10657), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5716), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7075), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [271767] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7724), 1,
      anon_sym_LBRACE,
    ACTIONS(10904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11450), 1,
      sym_identifier,
    STATE(3502), 1,
      sym_template_type,
    STATE(3582), 1,
      sym_field_declaration_list,
    STATE(3722), 1,
      sym__class_declaration_item,
    STATE(8746), 1,
      sym__scope_resolution,
    STATE(9571), 1,
      sym_virtual_specifier,
    STATE(10634), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [271826] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11911), 1,
      anon_sym_COMMA,
    ACTIONS(11913), 1,
      anon_sym_RPAREN,
    ACTIONS(11919), 1,
      anon_sym_SLASH,
    ACTIONS(11921), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(11923), 1,
      anon_sym_AMP_AMP,
    ACTIONS(11925), 1,
      anon_sym_PIPE,
    ACTIONS(11927), 1,
      anon_sym_CARET,
    ACTIONS(11929), 1,
      anon_sym_AMP,
    STATE(10109), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(11915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11917), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(11931), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11933), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(11935), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(11937), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [271881] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6781), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11939), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(11941), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6783), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [271914] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11429), 1,
      sym_identifier,
    ACTIONS(11431), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(312), 1,
      sym__class_declaration_item,
    STATE(6379), 1,
      sym_field_declaration_list,
    STATE(8684), 1,
      sym__scope_resolution,
    STATE(9579), 1,
      sym_virtual_specifier,
    STATE(10657), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5716), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [271973] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11911), 1,
      anon_sym_COMMA,
    ACTIONS(11919), 1,
      anon_sym_SLASH,
    ACTIONS(11921), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(11923), 1,
      anon_sym_AMP_AMP,
    ACTIONS(11925), 1,
      anon_sym_PIPE,
    ACTIONS(11927), 1,
      anon_sym_CARET,
    ACTIONS(11929), 1,
      anon_sym_AMP,
    ACTIONS(11943), 1,
      anon_sym_RPAREN,
    STATE(10230), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(11915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11917), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(11931), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11933), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(11935), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(11937), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [272028] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11421), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3052), 1,
      sym__class_declaration_item,
    STATE(3225), 1,
      sym_field_declaration_list,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(9402), 1,
      sym_virtual_specifier,
    STATE(10341), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3099), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7159), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [272087] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11421), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3059), 1,
      sym__class_declaration_item,
    STATE(3225), 1,
      sym_field_declaration_list,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(9402), 1,
      sym_virtual_specifier,
    STATE(10341), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3099), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [272146] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9524), 1,
      anon_sym_STAR,
    ACTIONS(9526), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9528), 1,
      anon_sym_AMP,
    STATE(3856), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8247), 1,
      sym__abstract_declarator,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9592), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [272191] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3052), 1,
      sym__class_declaration_item,
    STATE(3225), 1,
      sym_field_declaration_list,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9402), 1,
      sym_virtual_specifier,
    STATE(10341), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3099), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7136), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [272250] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3059), 1,
      sym__class_declaration_item,
    STATE(3225), 1,
      sym_field_declaration_list,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9402), 1,
      sym_virtual_specifier,
    STATE(10341), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3099), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [272309] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11166), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(312), 1,
      sym__class_declaration_item,
    STATE(664), 1,
      sym_field_declaration_list,
    STATE(8640), 1,
      sym__scope_resolution,
    STATE(9463), 1,
      sym_virtual_specifier,
    STATE(10501), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [272368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6806), 1,
      anon_sym___attribute,
    ACTIONS(11945), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6808), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [272399] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11947), 1,
      sym_identifier,
    ACTIONS(11949), 1,
      anon_sym_RPAREN,
    ACTIONS(11951), 1,
      anon_sym_LPAREN2,
    ACTIONS(11953), 1,
      anon_sym_defined,
    ACTIONS(11959), 1,
      sym_number_literal,
    ACTIONS(11955), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(11957), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11961), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7073), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [272442] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8243), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11089), 1,
      anon_sym_requires,
    ACTIONS(11107), 1,
      anon_sym_where,
    STATE(7404), 1,
      sym_trailing_return_type,
    STATE(7626), 1,
      sym_where_clause,
    ACTIONS(11086), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7852), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [272487] = 5,
    ACTIONS(11814), 1,
      anon_sym_LF,
    ACTIONS(11963), 1,
      anon_sym_LPAREN2,
    ACTIONS(11965), 1,
      sym_comment,
    STATE(7446), 1,
      sym_preproc_argument_list,
    ACTIONS(11818), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [272520] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7256), 1,
      anon_sym_LBRACE,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11439), 1,
      sym_identifier,
    STATE(3103), 1,
      sym_template_type,
    STATE(3162), 1,
      sym_field_declaration_list,
    STATE(3214), 1,
      sym__class_declaration_item,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(9497), 1,
      sym_virtual_specifier,
    STATE(10778), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3015), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7089), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [272579] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7256), 1,
      anon_sym_LBRACE,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11439), 1,
      sym_identifier,
    STATE(3103), 1,
      sym_template_type,
    STATE(3162), 1,
      sym_field_declaration_list,
    STATE(3218), 1,
      sym__class_declaration_item,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(9497), 1,
      sym_virtual_specifier,
    STATE(10778), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3015), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [272638] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7256), 1,
      anon_sym_LBRACE,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11439), 1,
      sym_identifier,
    STATE(3103), 1,
      sym_template_type,
    STATE(3162), 1,
      sym_field_declaration_list,
    STATE(3234), 1,
      sym__class_declaration_item,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(9497), 1,
      sym_virtual_specifier,
    STATE(10778), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3015), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [272697] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5734), 1,
      sym_field_declaration_list,
    STATE(6026), 1,
      sym__class_declaration_item,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(9490), 1,
      sym_virtual_specifier,
    STATE(10722), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5324), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7092), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [272756] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5734), 1,
      sym_field_declaration_list,
    STATE(5911), 1,
      sym__class_declaration_item,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(9490), 1,
      sym_virtual_specifier,
    STATE(10722), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5324), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [272815] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5734), 1,
      sym_field_declaration_list,
    STATE(5941), 1,
      sym__class_declaration_item,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(9490), 1,
      sym_virtual_specifier,
    STATE(10722), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5324), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [272874] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5734), 1,
      sym_field_declaration_list,
    STATE(5896), 1,
      sym__class_declaration_item,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(9490), 1,
      sym_virtual_specifier,
    STATE(10722), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5324), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7094), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [272933] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5734), 1,
      sym_field_declaration_list,
    STATE(6015), 1,
      sym__class_declaration_item,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(9490), 1,
      sym_virtual_specifier,
    STATE(10722), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5324), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [272992] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(5525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11445), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2863), 1,
      sym__class_declaration_item,
    STATE(8769), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2737), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7097), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [273051] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(5525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11445), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2891), 1,
      sym__class_declaration_item,
    STATE(8769), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2737), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [273110] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(5525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11445), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2896), 1,
      sym__class_declaration_item,
    STATE(8769), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2737), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [273169] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(5525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11445), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2840), 1,
      sym__class_declaration_item,
    STATE(8769), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2737), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7099), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [273228] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(5525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11445), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2876), 1,
      sym__class_declaration_item,
    STATE(8769), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2737), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [273287] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(322), 1,
      sym__class_declaration_item,
    STATE(6379), 1,
      sym_field_declaration_list,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(9579), 1,
      sym_virtual_specifier,
    STATE(10657), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5716), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7102), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [273346] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(326), 1,
      sym__class_declaration_item,
    STATE(6379), 1,
      sym_field_declaration_list,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(9579), 1,
      sym_virtual_specifier,
    STATE(10657), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5716), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [273405] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(305), 1,
      sym__class_declaration_item,
    STATE(6379), 1,
      sym_field_declaration_list,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(9579), 1,
      sym_virtual_specifier,
    STATE(10657), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5716), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [273464] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(288), 1,
      sym__class_declaration_item,
    STATE(6379), 1,
      sym_field_declaration_list,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(9579), 1,
      sym_virtual_specifier,
    STATE(10657), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5716), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7104), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [273523] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(312), 1,
      sym__class_declaration_item,
    STATE(6379), 1,
      sym_field_declaration_list,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(9579), 1,
      sym_virtual_specifier,
    STATE(10657), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5716), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [273582] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5734), 1,
      sym_field_declaration_list,
    STATE(6026), 1,
      sym__class_declaration_item,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(9490), 1,
      sym_virtual_specifier,
    STATE(10722), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5324), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7125), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [273641] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5734), 1,
      sym_field_declaration_list,
    STATE(5911), 1,
      sym__class_declaration_item,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(9490), 1,
      sym_virtual_specifier,
    STATE(10722), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5324), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [273700] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11419), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5846), 1,
      sym__class_declaration_item,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7109), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [273759] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11419), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5850), 1,
      sym__class_declaration_item,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [273818] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11419), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5631), 1,
      sym__class_declaration_item,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [273877] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11419), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5634), 1,
      sym__class_declaration_item,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7111), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [273936] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11419), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5648), 1,
      sym__class_declaration_item,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [273995] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(9887), 1,
      anon_sym_LPAREN2,
    ACTIONS(9901), 1,
      sym_identifier,
    ACTIONS(9903), 1,
      anon_sym_STAR,
    ACTIONS(9905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9907), 1,
      anon_sym_AMP,
    ACTIONS(11967), 1,
      anon_sym_SEMI,
    STATE(6935), 1,
      sym__field_declarator,
    STATE(8031), 1,
      sym_operator_name,
    STATE(10868), 1,
      sym_attribute_specifier,
    STATE(10874), 1,
      sym_ms_based_modifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(8244), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [274048] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11427), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5846), 1,
      sym__class_declaration_item,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7115), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [274107] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11427), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5850), 1,
      sym__class_declaration_item,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [274166] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11427), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5631), 1,
      sym__class_declaration_item,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [274225] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11427), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5634), 1,
      sym__class_declaration_item,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7117), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [274284] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11427), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5648), 1,
      sym__class_declaration_item,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [274343] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11166), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(305), 1,
      sym__class_declaration_item,
    STATE(664), 1,
      sym_field_declaration_list,
    STATE(8640), 1,
      sym__scope_resolution,
    STATE(9463), 1,
      sym_virtual_specifier,
    STATE(10501), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [274402] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11947), 1,
      sym_identifier,
    ACTIONS(11951), 1,
      anon_sym_LPAREN2,
    ACTIONS(11953), 1,
      anon_sym_defined,
    ACTIONS(11969), 1,
      anon_sym_RPAREN,
    ACTIONS(11971), 1,
      sym_number_literal,
    ACTIONS(11955), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(11957), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11961), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7132), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [274445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6112), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6114), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [274474] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6806), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11941), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6808), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [274505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6144), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6146), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [274534] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7256), 1,
      anon_sym_LBRACE,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11439), 1,
      sym_identifier,
    STATE(3103), 1,
      sym_template_type,
    STATE(3162), 1,
      sym_field_declaration_list,
    STATE(3238), 1,
      sym__class_declaration_item,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(9497), 1,
      sym_virtual_specifier,
    STATE(10778), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3015), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7127), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [274593] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(9887), 1,
      anon_sym_LPAREN2,
    ACTIONS(9901), 1,
      sym_identifier,
    ACTIONS(9903), 1,
      anon_sym_STAR,
    ACTIONS(9905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9907), 1,
      anon_sym_AMP,
    ACTIONS(11973), 1,
      anon_sym_SEMI,
    STATE(6939), 1,
      sym__field_declarator,
    STATE(8031), 1,
      sym_operator_name,
    STATE(10874), 1,
      sym_ms_based_modifier,
    STATE(11255), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(8244), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [274646] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5734), 1,
      sym_field_declaration_list,
    STATE(5941), 1,
      sym__class_declaration_item,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(9490), 1,
      sym_virtual_specifier,
    STATE(10722), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5324), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [274705] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5734), 1,
      sym_field_declaration_list,
    STATE(5896), 1,
      sym__class_declaration_item,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(9490), 1,
      sym_virtual_specifier,
    STATE(10722), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5324), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7133), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [274764] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7256), 1,
      anon_sym_LBRACE,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11439), 1,
      sym_identifier,
    STATE(3103), 1,
      sym_template_type,
    STATE(3162), 1,
      sym_field_declaration_list,
    STATE(3251), 1,
      sym__class_declaration_item,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(9497), 1,
      sym_virtual_specifier,
    STATE(10778), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3015), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [274823] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11166), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(288), 1,
      sym__class_declaration_item,
    STATE(664), 1,
      sym_field_declaration_list,
    STATE(8640), 1,
      sym__scope_resolution,
    STATE(9463), 1,
      sym_virtual_specifier,
    STATE(10501), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7082), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [274882] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8243), 1,
      anon_sym_DASH_GT,
    ACTIONS(8245), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    STATE(7436), 1,
      sym_trailing_return_type,
    STATE(7624), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8183), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [274927] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(9887), 1,
      anon_sym_LPAREN2,
    ACTIONS(9901), 1,
      sym_identifier,
    ACTIONS(9903), 1,
      anon_sym_STAR,
    ACTIONS(9905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9907), 1,
      anon_sym_AMP,
    ACTIONS(11975), 1,
      anon_sym_SEMI,
    STATE(6932), 1,
      sym__field_declarator,
    STATE(8031), 1,
      sym_operator_name,
    STATE(10874), 1,
      sym_ms_based_modifier,
    STATE(11050), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(8244), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [274980] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11166), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(322), 1,
      sym__class_declaration_item,
    STATE(664), 1,
      sym_field_declaration_list,
    STATE(8640), 1,
      sym__scope_resolution,
    STATE(9463), 1,
      sym_virtual_specifier,
    STATE(10501), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7118), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [275039] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11911), 1,
      anon_sym_COMMA,
    ACTIONS(11919), 1,
      anon_sym_SLASH,
    ACTIONS(11921), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(11923), 1,
      anon_sym_AMP_AMP,
    ACTIONS(11925), 1,
      anon_sym_PIPE,
    ACTIONS(11927), 1,
      anon_sym_CARET,
    ACTIONS(11929), 1,
      anon_sym_AMP,
    ACTIONS(11977), 1,
      anon_sym_RPAREN,
    STATE(9960), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(11915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11917), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(11931), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11933), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(11935), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(11937), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [275094] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5734), 1,
      sym_field_declaration_list,
    STATE(6015), 1,
      sym__class_declaration_item,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(9490), 1,
      sym_virtual_specifier,
    STATE(10722), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5324), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [275153] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(11698), 1,
      anon_sym_LBRACK,
    STATE(5557), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7542), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11696), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [275192] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(11694), 1,
      anon_sym_LBRACK,
    STATE(5557), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7524), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11692), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [275231] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3028), 1,
      sym__class_declaration_item,
    STATE(3225), 1,
      sym_field_declaration_list,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9402), 1,
      sym_virtual_specifier,
    STATE(10341), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3099), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [275290] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2863), 1,
      sym__class_declaration_item,
    STATE(8606), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3084), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7171), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [275349] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11166), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(326), 1,
      sym__class_declaration_item,
    STATE(664), 1,
      sym_field_declaration_list,
    STATE(8640), 1,
      sym__scope_resolution,
    STATE(9463), 1,
      sym_virtual_specifier,
    STATE(10501), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [275408] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8243), 1,
      anon_sym_DASH_GT,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11374), 1,
      anon_sym_requires,
    ACTIONS(11399), 1,
      anon_sym_where,
    STATE(7428), 1,
      sym_trailing_return_type,
    STATE(7617), 1,
      sym_where_clause,
    ACTIONS(11371), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7887), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [275453] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8076), 1,
      anon_sym_LBRACE,
    ACTIONS(11053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11435), 1,
      sym_identifier,
    STATE(3571), 1,
      sym_template_type,
    STATE(3728), 1,
      sym_field_declaration_list,
    STATE(4348), 1,
      sym__class_declaration_item,
    STATE(8630), 1,
      sym__scope_resolution,
    STATE(9464), 1,
      sym_virtual_specifier,
    STATE(10507), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3488), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [275512] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11415), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5846), 1,
      sym__class_declaration_item,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7149), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [275571] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11415), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5850), 1,
      sym__class_declaration_item,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [275630] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2891), 1,
      sym__class_declaration_item,
    STATE(8606), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3084), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [275689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6298), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6300), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [275718] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8243), 1,
      anon_sym_DASH_GT,
    ACTIONS(8245), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    STATE(7375), 1,
      sym_trailing_return_type,
    STATE(7626), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [275763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6302), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6304), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [275792] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2863), 1,
      sym__class_declaration_item,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2737), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7154), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [275851] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2891), 1,
      sym__class_declaration_item,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2737), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [275910] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11415), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5631), 1,
      sym__class_declaration_item,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [275969] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11415), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5634), 1,
      sym__class_declaration_item,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7156), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [276028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6324), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6324), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6324), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276115] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2896), 1,
      sym__class_declaration_item,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2737), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [276174] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2840), 1,
      sym__class_declaration_item,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2737), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7157), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [276233] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11415), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5608), 1,
      sym_field_declaration_list,
    STATE(5648), 1,
      sym__class_declaration_item,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(9367), 1,
      sym_virtual_specifier,
    STATE(10640), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5283), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [276292] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2876), 1,
      sym__class_declaration_item,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2737), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [276351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6120), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6122), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276380] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11421), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3028), 1,
      sym__class_declaration_item,
    STATE(3225), 1,
      sym_field_declaration_list,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(9402), 1,
      sym_virtual_specifier,
    STATE(10341), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3099), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [276439] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8243), 1,
      anon_sym_DASH_GT,
    ACTIONS(11655), 1,
      anon_sym_LBRACK,
    ACTIONS(11660), 1,
      anon_sym_requires,
    ACTIONS(11979), 1,
      anon_sym_where,
    STATE(7438), 1,
      sym_trailing_return_type,
    STATE(7608), 1,
      sym_where_clause,
    ACTIONS(11657), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7819), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [276484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6124), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6126), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6130), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6136), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6138), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [276571] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8550), 1,
      anon_sym_LBRACE,
    ACTIONS(10930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11443), 1,
      sym_identifier,
    STATE(4522), 1,
      sym_template_type,
    STATE(4902), 1,
      sym_field_declaration_list,
    STATE(5015), 1,
      sym__class_declaration_item,
    STATE(8723), 1,
      sym__scope_resolution,
    STATE(9523), 1,
      sym_virtual_specifier,
    STATE(10443), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3855), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7167), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [276630] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8550), 1,
      anon_sym_LBRACE,
    ACTIONS(10930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11443), 1,
      sym_identifier,
    STATE(4522), 1,
      sym_template_type,
    STATE(4902), 1,
      sym_field_declaration_list,
    STATE(5020), 1,
      sym__class_declaration_item,
    STATE(8723), 1,
      sym__scope_resolution,
    STATE(9523), 1,
      sym_virtual_specifier,
    STATE(10443), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3855), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [276689] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9518), 1,
      anon_sym_STAR,
    ACTIONS(9520), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9522), 1,
      anon_sym_AMP,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8207), 1,
      sym__abstract_declarator,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9592), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [276734] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8550), 1,
      anon_sym_LBRACE,
    ACTIONS(10930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11443), 1,
      sym_identifier,
    STATE(4522), 1,
      sym_template_type,
    STATE(4902), 1,
      sym_field_declaration_list,
    STATE(5028), 1,
      sym__class_declaration_item,
    STATE(8723), 1,
      sym__scope_resolution,
    STATE(9523), 1,
      sym_virtual_specifier,
    STATE(10443), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3855), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [276793] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8550), 1,
      anon_sym_LBRACE,
    ACTIONS(10930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11443), 1,
      sym_identifier,
    STATE(4522), 1,
      sym_template_type,
    STATE(4902), 1,
      sym_field_declaration_list,
    STATE(5033), 1,
      sym__class_declaration_item,
    STATE(8723), 1,
      sym__scope_resolution,
    STATE(9523), 1,
      sym_virtual_specifier,
    STATE(10443), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3855), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7170), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [276852] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11421), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3036), 1,
      sym__class_declaration_item,
    STATE(3225), 1,
      sym_field_declaration_list,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(9402), 1,
      sym_virtual_specifier,
    STATE(10341), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3099), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7060), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [276911] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8550), 1,
      anon_sym_LBRACE,
    ACTIONS(10930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11443), 1,
      sym_identifier,
    STATE(4522), 1,
      sym_template_type,
    STATE(4902), 1,
      sym_field_declaration_list,
    STATE(5042), 1,
      sym__class_declaration_item,
    STATE(8723), 1,
      sym__scope_resolution,
    STATE(9523), 1,
      sym_virtual_specifier,
    STATE(10443), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3855), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [276970] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2896), 1,
      sym__class_declaration_item,
    STATE(8606), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3084), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [277029] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8243), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10429), 1,
      anon_sym_requires,
    ACTIONS(10564), 1,
      anon_sym_where,
    STATE(7419), 1,
      sym_trailing_return_type,
    STATE(7624), 1,
      sym_where_clause,
    ACTIONS(10426), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7874), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [277074] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7724), 1,
      anon_sym_LBRACE,
    ACTIONS(10904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11450), 1,
      sym_identifier,
    STATE(3502), 1,
      sym_template_type,
    STATE(3582), 1,
      sym_field_declaration_list,
    STATE(3758), 1,
      sym__class_declaration_item,
    STATE(8746), 1,
      sym__scope_resolution,
    STATE(9571), 1,
      sym_virtual_specifier,
    STATE(10634), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7069), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [277133] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7724), 1,
      anon_sym_LBRACE,
    ACTIONS(10904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11450), 1,
      sym_identifier,
    STATE(3502), 1,
      sym_template_type,
    STATE(3582), 1,
      sym_field_declaration_list,
    STATE(3732), 1,
      sym__class_declaration_item,
    STATE(8746), 1,
      sym__scope_resolution,
    STATE(9571), 1,
      sym_virtual_specifier,
    STATE(10634), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3328), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [277192] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    STATE(2729), 1,
      sym_template_type,
    STATE(2834), 1,
      sym_field_declaration_list,
    STATE(2840), 1,
      sym__class_declaration_item,
    STATE(8606), 1,
      sym__scope_resolution,
    STATE(9597), 1,
      sym_virtual_specifier,
    STATE(10748), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3084), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7062), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [277251] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11441), 1,
      sym_identifier,
    STATE(398), 1,
      sym_template_type,
    STATE(711), 1,
      sym_field_declaration_list,
    STATE(771), 1,
      sym__class_declaration_item,
    STATE(8763), 1,
      sym__scope_resolution,
    STATE(9404), 1,
      sym_virtual_specifier,
    STATE(10370), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(260), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7178), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [277310] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11441), 1,
      sym_identifier,
    STATE(398), 1,
      sym_template_type,
    STATE(711), 1,
      sym_field_declaration_list,
    STATE(774), 1,
      sym__class_declaration_item,
    STATE(8763), 1,
      sym__scope_resolution,
    STATE(9404), 1,
      sym_virtual_specifier,
    STATE(10370), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(260), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [277369] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11441), 1,
      sym_identifier,
    STATE(398), 1,
      sym_template_type,
    STATE(711), 1,
      sym_field_declaration_list,
    STATE(782), 1,
      sym__class_declaration_item,
    STATE(8763), 1,
      sym__scope_resolution,
    STATE(9404), 1,
      sym_virtual_specifier,
    STATE(10370), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(260), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [277428] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11441), 1,
      sym_identifier,
    STATE(398), 1,
      sym_template_type,
    STATE(711), 1,
      sym_field_declaration_list,
    STATE(785), 1,
      sym__class_declaration_item,
    STATE(8763), 1,
      sym__scope_resolution,
    STATE(9404), 1,
      sym_virtual_specifier,
    STATE(10370), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(260), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7180), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [277487] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11441), 1,
      sym_identifier,
    STATE(398), 1,
      sym_template_type,
    STATE(711), 1,
      sym_field_declaration_list,
    STATE(795), 1,
      sym__class_declaration_item,
    STATE(8763), 1,
      sym__scope_resolution,
    STATE(9404), 1,
      sym_virtual_specifier,
    STATE(10370), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(260), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [277546] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8243), 1,
      anon_sym_DASH_GT,
    ACTIONS(8245), 1,
      anon_sym_where,
    ACTIONS(11655), 1,
      anon_sym_LBRACK,
    STATE(7435), 1,
      sym_trailing_return_type,
    STATE(7608), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8201), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [277591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2414), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2412), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [277620] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9530), 1,
      anon_sym_STAR,
    ACTIONS(9532), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9534), 1,
      anon_sym_AMP,
    STATE(3857), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8305), 1,
      sym__abstract_declarator,
    ACTIONS(9592), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(9594), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [277667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6156), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6158), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [277696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6160), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6162), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [277725] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11411), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5846), 1,
      sym__class_declaration_item,
    STATE(6487), 1,
      sym_field_declaration_list,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(9592), 1,
      sym_virtual_specifier,
    STATE(10725), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6074), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7191), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [277784] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11411), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5850), 1,
      sym__class_declaration_item,
    STATE(6487), 1,
      sym_field_declaration_list,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(9592), 1,
      sym_virtual_specifier,
    STATE(10725), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6074), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [277843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6164), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6166), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [277872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6170), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6172), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [277901] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(141), 1,
      anon_sym_operator,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(6728), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(11982), 1,
      sym_identifier,
    ACTIONS(11984), 1,
      anon_sym_template,
    STATE(3618), 1,
      sym_pointer_type_declarator,
    STATE(3619), 1,
      sym_template_function,
    STATE(3640), 1,
      sym_destructor_name,
    STATE(3641), 1,
      sym_dependent_identifier,
    STATE(3643), 1,
      sym_qualified_identifier,
    STATE(3644), 1,
      sym_operator_name,
    STATE(7190), 1,
      sym__scope_resolution,
    STATE(9475), 1,
      sym_operator_cast,
    STATE(9493), 1,
      sym_qualified_operator_cast_identifier,
    STATE(10936), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [277964] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11411), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5631), 1,
      sym__class_declaration_item,
    STATE(6487), 1,
      sym_field_declaration_list,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(9592), 1,
      sym_virtual_specifier,
    STATE(10725), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6074), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [278023] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11947), 1,
      sym_identifier,
    ACTIONS(11951), 1,
      anon_sym_LPAREN2,
    ACTIONS(11953), 1,
      anon_sym_defined,
    ACTIONS(11986), 1,
      anon_sym_RPAREN,
    ACTIONS(11988), 1,
      sym_number_literal,
    ACTIONS(11955), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(11957), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11961), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7076), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [278066] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11411), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5634), 1,
      sym__class_declaration_item,
    STATE(6487), 1,
      sym_field_declaration_list,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(9592), 1,
      sym_virtual_specifier,
    STATE(10725), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6074), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7198), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [278125] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3040), 1,
      sym__class_declaration_item,
    STATE(3225), 1,
      sym_field_declaration_list,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9402), 1,
      sym_virtual_specifier,
    STATE(10341), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3099), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [278184] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3028), 1,
      sym__class_declaration_item,
    STATE(6517), 1,
      sym_field_declaration_list,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9588), 1,
      sym_virtual_specifier,
    STATE(10713), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5838), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [278243] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3036), 1,
      sym__class_declaration_item,
    STATE(6517), 1,
      sym_field_declaration_list,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9588), 1,
      sym_virtual_specifier,
    STATE(10713), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7197), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [278302] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3040), 1,
      sym__class_declaration_item,
    STATE(6517), 1,
      sym_field_declaration_list,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9588), 1,
      sym_virtual_specifier,
    STATE(10713), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5838), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [278361] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    ACTIONS(11411), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5648), 1,
      sym__class_declaration_item,
    STATE(6487), 1,
      sym_field_declaration_list,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(9592), 1,
      sym_virtual_specifier,
    STATE(10725), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6074), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [278420] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6781), 1,
      anon_sym___attribute,
    ACTIONS(11945), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(11990), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(6783), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [278453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2404), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2402), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [278482] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9311), 1,
      anon_sym_LBRACE,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11413), 1,
      sym_identifier,
    STATE(4999), 1,
      sym_template_type,
    STATE(5152), 1,
      sym_field_declaration_list,
    STATE(5343), 1,
      sym__class_declaration_item,
    STATE(8676), 1,
      sym__scope_resolution,
    STATE(9440), 1,
      sym_virtual_specifier,
    STATE(10599), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4813), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7203), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [278541] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9311), 1,
      anon_sym_LBRACE,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11413), 1,
      sym_identifier,
    STATE(4999), 1,
      sym_template_type,
    STATE(5152), 1,
      sym_field_declaration_list,
    STATE(5401), 1,
      sym__class_declaration_item,
    STATE(8676), 1,
      sym__scope_resolution,
    STATE(9440), 1,
      sym_virtual_specifier,
    STATE(10599), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4813), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [278600] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9311), 1,
      anon_sym_LBRACE,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11413), 1,
      sym_identifier,
    STATE(4999), 1,
      sym_template_type,
    STATE(5152), 1,
      sym_field_declaration_list,
    STATE(5433), 1,
      sym__class_declaration_item,
    STATE(8676), 1,
      sym__scope_resolution,
    STATE(9440), 1,
      sym_virtual_specifier,
    STATE(10599), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4813), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [278659] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9311), 1,
      anon_sym_LBRACE,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11413), 1,
      sym_identifier,
    STATE(4999), 1,
      sym_template_type,
    STATE(5152), 1,
      sym_field_declaration_list,
    STATE(5439), 1,
      sym__class_declaration_item,
    STATE(8676), 1,
      sym__scope_resolution,
    STATE(9440), 1,
      sym_virtual_specifier,
    STATE(10599), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4813), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7207), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [278718] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11429), 1,
      sym_identifier,
    ACTIONS(11431), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(322), 1,
      sym__class_declaration_item,
    STATE(6379), 1,
      sym_field_declaration_list,
    STATE(8684), 1,
      sym__scope_resolution,
    STATE(9579), 1,
      sym_virtual_specifier,
    STATE(10657), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5716), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7068), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [278777] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11429), 1,
      sym_identifier,
    ACTIONS(11431), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(326), 1,
      sym__class_declaration_item,
    STATE(6379), 1,
      sym_field_declaration_list,
    STATE(8684), 1,
      sym__scope_resolution,
    STATE(9579), 1,
      sym_virtual_specifier,
    STATE(10657), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5716), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [278836] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9311), 1,
      anon_sym_LBRACE,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11413), 1,
      sym_identifier,
    STATE(4999), 1,
      sym_template_type,
    STATE(5152), 1,
      sym_field_declaration_list,
    STATE(5347), 1,
      sym__class_declaration_item,
    STATE(8676), 1,
      sym__scope_resolution,
    STATE(9440), 1,
      sym_virtual_specifier,
    STATE(10599), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4813), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [278895] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3052), 1,
      sym__class_declaration_item,
    STATE(6517), 1,
      sym_field_declaration_list,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9588), 1,
      sym_virtual_specifier,
    STATE(10713), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7195), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [278954] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8076), 1,
      anon_sym_LBRACE,
    ACTIONS(11053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11435), 1,
      sym_identifier,
    STATE(3571), 1,
      sym_template_type,
    STATE(3728), 1,
      sym_field_declaration_list,
    STATE(4342), 1,
      sym__class_declaration_item,
    STATE(8630), 1,
      sym__scope_resolution,
    STATE(9464), 1,
      sym_virtual_specifier,
    STATE(10507), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3488), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7057), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [279013] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3036), 1,
      sym__class_declaration_item,
    STATE(3225), 1,
      sym_field_declaration_list,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(9402), 1,
      sym_virtual_specifier,
    STATE(10341), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3099), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(7194), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [279072] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9570), 1,
      anon_sym_STAR,
    ACTIONS(9572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9574), 1,
      anon_sym_AMP,
    STATE(4323), 1,
      sym_parameter_list,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8389), 1,
      sym__abstract_declarator,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9592), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [279116] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12000), 1,
      anon_sym_RBRACK,
    ACTIONS(12002), 1,
      sym_this,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [279168] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(9678), 1,
      anon_sym_STAR,
    ACTIONS(12004), 1,
      sym_identifier,
    ACTIONS(12006), 1,
      anon_sym_TILDE,
    ACTIONS(12008), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12010), 1,
      anon_sym_template,
    ACTIONS(12012), 1,
      anon_sym_operator,
    STATE(205), 1,
      sym_template_type,
    STATE(206), 1,
      sym_dependent_type_identifier,
    STATE(214), 1,
      sym_qualified_type_identifier,
    STATE(4734), 1,
      sym_pointer_type_declarator,
    STATE(4735), 1,
      sym_template_function,
    STATE(4736), 1,
      sym_destructor_name,
    STATE(4737), 1,
      sym_dependent_identifier,
    STATE(4738), 1,
      sym_qualified_identifier,
    STATE(4739), 1,
      sym_operator_name,
    STATE(7213), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
    STATE(11577), 1,
      sym_ms_based_modifier,
  [279232] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12014), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [279284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4860), 9,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(4862), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [279312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12018), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(12016), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [279340] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11947), 1,
      sym_identifier,
    ACTIONS(11951), 1,
      anon_sym_LPAREN2,
    ACTIONS(11953), 1,
      anon_sym_defined,
    ACTIONS(12020), 1,
      sym_number_literal,
    ACTIONS(11955), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(11957), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11961), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7382), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [279380] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8378), 1,
      sym__type_declarator,
    STATE(9294), 1,
      sym__type_definition_declarators,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [279430] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12032), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7417), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [279470] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12036), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [279522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12040), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(12038), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [279550] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8378), 1,
      sym__type_declarator,
    STATE(9217), 1,
      sym__type_definition_declarators,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [279600] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12042), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [279652] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12044), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7388), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [279692] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(9692), 1,
      anon_sym_STAR,
    ACTIONS(12046), 1,
      sym_identifier,
    ACTIONS(12048), 1,
      anon_sym_TILDE,
    ACTIONS(12050), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12052), 1,
      anon_sym_template,
    ACTIONS(12054), 1,
      anon_sym_operator,
    STATE(205), 1,
      sym_template_type,
    STATE(206), 1,
      sym_dependent_type_identifier,
    STATE(214), 1,
      sym_qualified_type_identifier,
    STATE(4527), 1,
      sym_qualified_identifier,
    STATE(4529), 1,
      sym_operator_name,
    STATE(4636), 1,
      sym_dependent_identifier,
    STATE(4650), 1,
      sym_pointer_type_declarator,
    STATE(4651), 1,
      sym_template_function,
    STATE(4652), 1,
      sym_destructor_name,
    STATE(7225), 1,
      sym__scope_resolution,
    STATE(11304), 1,
      sym_ms_based_modifier,
    STATE(11339), 1,
      sym_decltype,
  [279756] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12056), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [279808] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11947), 1,
      sym_identifier,
    ACTIONS(11951), 1,
      anon_sym_LPAREN2,
    ACTIONS(11953), 1,
      anon_sym_defined,
    ACTIONS(12058), 1,
      sym_number_literal,
    ACTIONS(11955), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(11957), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11961), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7427), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [279848] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12060), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7450), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [279888] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11919), 1,
      anon_sym_SLASH,
    ACTIONS(11921), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(11923), 1,
      anon_sym_AMP_AMP,
    ACTIONS(11925), 1,
      anon_sym_PIPE,
    ACTIONS(11927), 1,
      anon_sym_CARET,
    ACTIONS(11929), 1,
      anon_sym_AMP,
    ACTIONS(11915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11917), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(11931), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11933), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(11935), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(11937), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12062), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [279938] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8310), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10715), 1,
      anon_sym_requires,
    ACTIONS(10718), 1,
      anon_sym_where,
    STATE(7544), 1,
      sym_trailing_return_type,
    STATE(7624), 1,
      sym_where_clause,
    ACTIONS(10426), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7913), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [279982] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8310), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11190), 1,
      anon_sym_requires,
    ACTIONS(11193), 1,
      anon_sym_where,
    STATE(7545), 1,
      sym_trailing_return_type,
    STATE(7626), 1,
      sym_where_clause,
    ACTIONS(11086), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7914), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [280026] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8310), 1,
      anon_sym_DASH_GT,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11452), 1,
      anon_sym_requires,
    ACTIONS(11455), 1,
      anon_sym_where,
    STATE(7547), 1,
      sym_trailing_return_type,
    STATE(7617), 1,
      sym_where_clause,
    ACTIONS(11371), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7915), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [280070] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8310), 1,
      anon_sym_DASH_GT,
    ACTIONS(11655), 1,
      anon_sym_LBRACK,
    ACTIONS(12064), 1,
      anon_sym_requires,
    ACTIONS(12067), 1,
      anon_sym_where,
    STATE(7548), 1,
      sym_trailing_return_type,
    STATE(7608), 1,
      sym_where_clause,
    ACTIONS(11657), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7916), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [280114] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12070), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [280166] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12072), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [280218] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12074), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7430), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [280258] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12076), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [280310] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11947), 1,
      sym_identifier,
    ACTIONS(11951), 1,
      anon_sym_LPAREN2,
    ACTIONS(11953), 1,
      anon_sym_defined,
    ACTIONS(12078), 1,
      sym_number_literal,
    ACTIONS(11955), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(11957), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11961), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7247), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [280350] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(9606), 1,
      anon_sym_STAR,
    ACTIONS(12080), 1,
      sym_identifier,
    ACTIONS(12082), 1,
      anon_sym_TILDE,
    ACTIONS(12084), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12086), 1,
      anon_sym_template,
    ACTIONS(12088), 1,
      anon_sym_operator,
    STATE(205), 1,
      sym_template_type,
    STATE(206), 1,
      sym_dependent_type_identifier,
    STATE(214), 1,
      sym_qualified_type_identifier,
    STATE(3457), 1,
      sym_pointer_type_declarator,
    STATE(3458), 1,
      sym_template_function,
    STATE(3460), 1,
      sym_destructor_name,
    STATE(3468), 1,
      sym_dependent_identifier,
    STATE(3470), 1,
      sym_qualified_identifier,
    STATE(3471), 1,
      sym_operator_name,
    STATE(7239), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
    STATE(11420), 1,
      sym_ms_based_modifier,
  [280414] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12090), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7374), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [280454] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(5352), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(12092), 1,
      sym_identifier,
    ACTIONS(12094), 1,
      anon_sym_template,
    STATE(2720), 1,
      sym_qualified_type_identifier,
    STATE(2721), 1,
      sym_dependent_type_identifier,
    STATE(2723), 1,
      sym_template_type,
    STATE(3618), 1,
      sym_pointer_type_declarator,
    STATE(3619), 1,
      sym_template_function,
    STATE(3640), 1,
      sym_destructor_name,
    STATE(3641), 1,
      sym_dependent_identifier,
    STATE(3643), 1,
      sym_qualified_identifier,
    STATE(3644), 1,
      sym_operator_name,
    STATE(7241), 1,
      sym__scope_resolution,
    STATE(10936), 1,
      sym_ms_based_modifier,
    STATE(11339), 1,
      sym_decltype,
  [280518] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12096), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [280570] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12098), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7408), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [280610] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9564), 1,
      anon_sym_STAR,
    ACTIONS(9566), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9568), 1,
      anon_sym_AMP,
    ACTIONS(9594), 1,
      anon_sym___attribute,
    STATE(3727), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8459), 1,
      sym__abstract_declarator,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9592), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [280656] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6077), 1,
      anon_sym_RBRACK,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12100), 1,
      sym_identifier,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [280708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12104), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(12102), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [280736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12108), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(12106), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [280764] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11947), 1,
      sym_identifier,
    ACTIONS(11951), 1,
      anon_sym_LPAREN2,
    ACTIONS(11953), 1,
      anon_sym_defined,
    ACTIONS(12110), 1,
      sym_number_literal,
    ACTIONS(11955), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(11957), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11961), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7307), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [280804] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11947), 1,
      sym_identifier,
    ACTIONS(11951), 1,
      anon_sym_LPAREN2,
    ACTIONS(11953), 1,
      anon_sym_defined,
    ACTIONS(12112), 1,
      sym_number_literal,
    ACTIONS(11955), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(11957), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11961), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7309), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [280844] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11947), 1,
      sym_identifier,
    ACTIONS(11951), 1,
      anon_sym_LPAREN2,
    ACTIONS(11953), 1,
      anon_sym_defined,
    ACTIONS(12114), 1,
      sym_number_literal,
    ACTIONS(11955), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(11957), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11961), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7312), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [280884] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11947), 1,
      sym_identifier,
    ACTIONS(11951), 1,
      anon_sym_LPAREN2,
    ACTIONS(11953), 1,
      anon_sym_defined,
    ACTIONS(12116), 1,
      sym_number_literal,
    ACTIONS(11955), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(11957), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11961), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7313), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [280924] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11947), 1,
      sym_identifier,
    ACTIONS(11951), 1,
      anon_sym_LPAREN2,
    ACTIONS(11953), 1,
      anon_sym_defined,
    ACTIONS(12118), 1,
      sym_number_literal,
    ACTIONS(11955), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(11957), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11961), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7316), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [280964] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11947), 1,
      sym_identifier,
    ACTIONS(11951), 1,
      anon_sym_LPAREN2,
    ACTIONS(11953), 1,
      anon_sym_defined,
    ACTIONS(12120), 1,
      sym_number_literal,
    ACTIONS(11955), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(11957), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11961), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7324), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [281004] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11947), 1,
      sym_identifier,
    ACTIONS(11951), 1,
      anon_sym_LPAREN2,
    ACTIONS(11953), 1,
      anon_sym_defined,
    ACTIONS(12122), 1,
      sym_number_literal,
    ACTIONS(11955), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(11957), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11961), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7326), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [281044] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11947), 1,
      sym_identifier,
    ACTIONS(11951), 1,
      anon_sym_LPAREN2,
    ACTIONS(11953), 1,
      anon_sym_defined,
    ACTIONS(12124), 1,
      sym_number_literal,
    ACTIONS(11955), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(11957), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11961), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7327), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [281084] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11947), 1,
      sym_identifier,
    ACTIONS(11951), 1,
      anon_sym_LPAREN2,
    ACTIONS(11953), 1,
      anon_sym_defined,
    ACTIONS(12126), 1,
      sym_number_literal,
    ACTIONS(11955), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(11957), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11961), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7328), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [281124] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11947), 1,
      sym_identifier,
    ACTIONS(11951), 1,
      anon_sym_LPAREN2,
    ACTIONS(11953), 1,
      anon_sym_defined,
    ACTIONS(12128), 1,
      sym_number_literal,
    ACTIONS(11955), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(11957), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11961), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7329), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [281164] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8378), 1,
      sym__type_declarator,
    STATE(9254), 1,
      sym__type_definition_declarators,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [281214] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12130), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [281266] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12132), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7409), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [281306] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8378), 1,
      sym__type_declarator,
    STATE(9226), 1,
      sym__type_definition_declarators,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [281356] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12134), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [281408] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(9692), 1,
      anon_sym_STAR,
    ACTIONS(12136), 1,
      sym_identifier,
    ACTIONS(12138), 1,
      anon_sym_TILDE,
    ACTIONS(12140), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12142), 1,
      anon_sym_template,
    ACTIONS(12144), 1,
      anon_sym_operator,
    STATE(205), 1,
      sym_template_type,
    STATE(206), 1,
      sym_dependent_type_identifier,
    STATE(214), 1,
      sym_qualified_type_identifier,
    STATE(4404), 1,
      sym_pointer_type_declarator,
    STATE(4405), 1,
      sym_template_function,
    STATE(4406), 1,
      sym_destructor_name,
    STATE(4408), 1,
      sym_dependent_identifier,
    STATE(4410), 1,
      sym_qualified_identifier,
    STATE(4411), 1,
      sym_operator_name,
    STATE(7263), 1,
      sym__scope_resolution,
    STATE(11304), 1,
      sym_ms_based_modifier,
    STATE(11339), 1,
      sym_decltype,
  [281472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12148), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(12146), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [281500] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12150), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [281552] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12152), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [281604] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8378), 1,
      sym__type_declarator,
    STATE(9274), 1,
      sym__type_definition_declarators,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [281654] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12154), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [281706] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8378), 1,
      sym__type_declarator,
    STATE(9271), 1,
      sym__type_definition_declarators,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [281756] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8378), 1,
      sym__type_declarator,
    STATE(9210), 1,
      sym__type_definition_declarators,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [281806] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8378), 1,
      sym__type_declarator,
    STATE(9279), 1,
      sym__type_definition_declarators,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [281856] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8378), 1,
      sym__type_declarator,
    STATE(9252), 1,
      sym__type_definition_declarators,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [281906] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8378), 1,
      sym__type_declarator,
    STATE(9280), 1,
      sym__type_definition_declarators,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [281956] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8378), 1,
      sym__type_declarator,
    STATE(9285), 1,
      sym__type_definition_declarators,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [282006] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8378), 1,
      sym__type_declarator,
    STATE(9208), 1,
      sym__type_definition_declarators,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [282056] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8378), 1,
      sym__type_declarator,
    STATE(9307), 1,
      sym__type_definition_declarators,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [282106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12158), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(12156), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [282134] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8378), 1,
      sym__type_declarator,
    STATE(9301), 1,
      sym__type_definition_declarators,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [282184] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8378), 1,
      sym__type_declarator,
    STATE(9241), 1,
      sym__type_definition_declarators,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [282234] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(9692), 1,
      anon_sym_STAR,
    ACTIONS(12048), 1,
      anon_sym_TILDE,
    ACTIONS(12054), 1,
      anon_sym_operator,
    ACTIONS(12160), 1,
      sym_identifier,
    ACTIONS(12162), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12164), 1,
      anon_sym_template,
    STATE(2720), 1,
      sym_qualified_type_identifier,
    STATE(2721), 1,
      sym_dependent_type_identifier,
    STATE(2723), 1,
      sym_template_type,
    STATE(4527), 1,
      sym_qualified_identifier,
    STATE(4529), 1,
      sym_operator_name,
    STATE(4636), 1,
      sym_dependent_identifier,
    STATE(4650), 1,
      sym_pointer_type_declarator,
    STATE(4651), 1,
      sym_template_function,
    STATE(4652), 1,
      sym_destructor_name,
    STATE(7280), 1,
      sym__scope_resolution,
    STATE(11304), 1,
      sym_ms_based_modifier,
    STATE(11339), 1,
      sym_decltype,
  [282298] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8378), 1,
      sym__type_declarator,
    STATE(9308), 1,
      sym__type_definition_declarators,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [282348] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(5536), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(12166), 1,
      sym_identifier,
    ACTIONS(12168), 1,
      anon_sym_template,
    STATE(2720), 1,
      sym_qualified_type_identifier,
    STATE(2721), 1,
      sym_dependent_type_identifier,
    STATE(2723), 1,
      sym_template_type,
    STATE(3618), 1,
      sym_pointer_type_declarator,
    STATE(3619), 1,
      sym_template_function,
    STATE(3640), 1,
      sym_destructor_name,
    STATE(3641), 1,
      sym_dependent_identifier,
    STATE(3643), 1,
      sym_qualified_identifier,
    STATE(3644), 1,
      sym_operator_name,
    STATE(7282), 1,
      sym__scope_resolution,
    STATE(10936), 1,
      sym_ms_based_modifier,
    STATE(11339), 1,
      sym_decltype,
  [282412] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12170), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7369), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [282452] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(9692), 1,
      anon_sym_STAR,
    ACTIONS(12048), 1,
      anon_sym_TILDE,
    ACTIONS(12054), 1,
      anon_sym_operator,
    ACTIONS(12172), 1,
      sym_identifier,
    ACTIONS(12174), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12176), 1,
      anon_sym_template,
    STATE(2967), 1,
      sym_qualified_type_identifier,
    STATE(3003), 1,
      sym_template_type,
    STATE(3004), 1,
      sym_dependent_type_identifier,
    STATE(4527), 1,
      sym_qualified_identifier,
    STATE(4529), 1,
      sym_operator_name,
    STATE(4636), 1,
      sym_dependent_identifier,
    STATE(4650), 1,
      sym_pointer_type_declarator,
    STATE(4651), 1,
      sym_template_function,
    STATE(4652), 1,
      sym_destructor_name,
    STATE(7284), 1,
      sym__scope_resolution,
    STATE(11304), 1,
      sym_ms_based_modifier,
    STATE(11339), 1,
      sym_decltype,
  [282516] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12182), 1,
      anon_sym_AMP,
    STATE(7344), 1,
      aux_sym_interface_requirements_repeat1,
    ACTIONS(12178), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12180), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [282548] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12184), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [282600] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12186), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [282652] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12188), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7389), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [282692] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7321), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(12190), 6,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12192), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [282724] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(9692), 1,
      anon_sym_STAR,
    ACTIONS(12138), 1,
      anon_sym_TILDE,
    ACTIONS(12144), 1,
      anon_sym_operator,
    ACTIONS(12194), 1,
      sym_identifier,
    ACTIONS(12196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12198), 1,
      anon_sym_template,
    STATE(2967), 1,
      sym_qualified_type_identifier,
    STATE(3003), 1,
      sym_template_type,
    STATE(3004), 1,
      sym_dependent_type_identifier,
    STATE(4404), 1,
      sym_pointer_type_declarator,
    STATE(4405), 1,
      sym_template_function,
    STATE(4406), 1,
      sym_destructor_name,
    STATE(4408), 1,
      sym_dependent_identifier,
    STATE(4410), 1,
      sym_qualified_identifier,
    STATE(4411), 1,
      sym_operator_name,
    STATE(7290), 1,
      sym__scope_resolution,
    STATE(11304), 1,
      sym_ms_based_modifier,
    STATE(11339), 1,
      sym_decltype,
  [282788] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12200), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [282840] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12202), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [282892] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12204), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [282944] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12206), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7413), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [282984] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8310), 1,
      anon_sym_DASH_GT,
    ACTIONS(8326), 1,
      anon_sym_requires,
    ACTIONS(8328), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    STATE(7469), 1,
      sym_trailing_return_type,
    STATE(7624), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8395), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [283028] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8310), 1,
      anon_sym_DASH_GT,
    ACTIONS(8326), 1,
      anon_sym_requires,
    ACTIONS(8328), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    STATE(7472), 1,
      sym_trailing_return_type,
    STATE(7626), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8399), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [283072] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8310), 1,
      anon_sym_DASH_GT,
    ACTIONS(8326), 1,
      anon_sym_requires,
    ACTIONS(8328), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    STATE(7474), 1,
      sym_trailing_return_type,
    STATE(7617), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8401), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [283116] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8310), 1,
      anon_sym_DASH_GT,
    ACTIONS(8326), 1,
      anon_sym_requires,
    ACTIONS(8328), 1,
      anon_sym_where,
    ACTIONS(11655), 1,
      anon_sym_LBRACK,
    STATE(7476), 1,
      sym_trailing_return_type,
    STATE(7608), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8402), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [283160] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(9606), 1,
      anon_sym_STAR,
    ACTIONS(12082), 1,
      anon_sym_TILDE,
    ACTIONS(12088), 1,
      anon_sym_operator,
    ACTIONS(12208), 1,
      sym_identifier,
    ACTIONS(12210), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12212), 1,
      anon_sym_template,
    STATE(2967), 1,
      sym_qualified_type_identifier,
    STATE(3003), 1,
      sym_template_type,
    STATE(3004), 1,
      sym_dependent_type_identifier,
    STATE(3457), 1,
      sym_pointer_type_declarator,
    STATE(3458), 1,
      sym_template_function,
    STATE(3460), 1,
      sym_destructor_name,
    STATE(3468), 1,
      sym_dependent_identifier,
    STATE(3470), 1,
      sym_qualified_identifier,
    STATE(3471), 1,
      sym_operator_name,
    STATE(7299), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
    STATE(11420), 1,
      sym_ms_based_modifier,
  [283224] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8172), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8170), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [283262] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12214), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [283314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12218), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(12216), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [283342] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8172), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [283380] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8172), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8175), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [283418] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8172), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8008), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [283456] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12220), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [283508] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11919), 1,
      anon_sym_SLASH,
    ACTIONS(11917), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(12224), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(12222), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [283540] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8172), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8009), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [283578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12224), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(12222), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [283606] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12226), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [283658] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12228), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7396), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [283698] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11919), 1,
      anon_sym_SLASH,
    ACTIONS(11923), 1,
      anon_sym_AMP_AMP,
    ACTIONS(11925), 1,
      anon_sym_PIPE,
    ACTIONS(11927), 1,
      anon_sym_CARET,
    ACTIONS(11929), 1,
      anon_sym_AMP,
    ACTIONS(11915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11917), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(11931), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11933), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(11935), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(11937), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12222), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
  [283746] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11919), 1,
      anon_sym_SLASH,
    ACTIONS(11925), 1,
      anon_sym_PIPE,
    ACTIONS(11927), 1,
      anon_sym_CARET,
    ACTIONS(11929), 1,
      anon_sym_AMP,
    ACTIONS(11915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11917), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(11931), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11933), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(11935), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(11937), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12222), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [283792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8332), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [283820] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10031), 1,
      anon_sym_requires,
    ACTIONS(10034), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7724), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [283858] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11919), 1,
      anon_sym_SLASH,
    ACTIONS(11927), 1,
      anon_sym_CARET,
    ACTIONS(11929), 1,
      anon_sym_AMP,
    ACTIONS(12224), 1,
      anon_sym_PIPE,
    ACTIONS(11915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11917), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(11931), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11933), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(11935), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(11937), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12222), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [283904] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12230), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7433), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [283944] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10838), 1,
      anon_sym_requires,
    ACTIONS(10841), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7725), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [283982] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11315), 1,
      anon_sym_requires,
    ACTIONS(11318), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11312), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7727), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [284020] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11889), 1,
      anon_sym_requires,
    ACTIONS(11892), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11886), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7728), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [284058] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12236), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7321), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(12232), 6,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12234), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [284090] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12242), 1,
      anon_sym_requires,
    ACTIONS(12245), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(12239), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7729), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [284128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12250), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(12248), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [284156] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11919), 1,
      anon_sym_SLASH,
    ACTIONS(11929), 1,
      anon_sym_AMP,
    ACTIONS(12224), 1,
      anon_sym_PIPE,
    ACTIONS(11915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11917), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(11931), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11933), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(11935), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(11937), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12222), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [284200] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(9558), 1,
      anon_sym_STAR,
    ACTIONS(9560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9562), 1,
      anon_sym_AMP,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8429), 1,
      sym__abstract_declarator,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9592), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [284244] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11919), 1,
      anon_sym_SLASH,
    ACTIONS(11915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11917), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(11931), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11933), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(11935), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(11937), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12224), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(12222), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [284286] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11919), 1,
      anon_sym_SLASH,
    ACTIONS(11915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11917), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(11933), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(11935), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(11937), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12224), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(12222), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [284326] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11919), 1,
      anon_sym_SLASH,
    ACTIONS(11915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11917), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(11937), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12224), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(12222), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [284362] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11919), 1,
      anon_sym_SLASH,
    ACTIONS(11915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11917), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(12224), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(12222), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [284396] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(9606), 1,
      anon_sym_STAR,
    ACTIONS(12082), 1,
      anon_sym_TILDE,
    ACTIONS(12088), 1,
      anon_sym_operator,
    ACTIONS(12252), 1,
      sym_identifier,
    ACTIONS(12254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12256), 1,
      anon_sym_template,
    STATE(2720), 1,
      sym_qualified_type_identifier,
    STATE(2721), 1,
      sym_dependent_type_identifier,
    STATE(2723), 1,
      sym_template_type,
    STATE(3457), 1,
      sym_pointer_type_declarator,
    STATE(3458), 1,
      sym_template_function,
    STATE(3460), 1,
      sym_destructor_name,
    STATE(3468), 1,
      sym_dependent_identifier,
    STATE(3470), 1,
      sym_qualified_identifier,
    STATE(3471), 1,
      sym_operator_name,
    STATE(7330), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
    STATE(11420), 1,
      sym_ms_based_modifier,
  [284460] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12258), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7372), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [284500] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12260), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7395), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [284540] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8440), 1,
      anon_sym_DASH_GT,
    ACTIONS(8442), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym___attribute,
    STATE(7503), 1,
      sym_trailing_return_type,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8338), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [284584] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8440), 1,
      anon_sym_DASH_GT,
    ACTIONS(8442), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym___attribute,
    STATE(7505), 1,
      sym_trailing_return_type,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8339), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [284628] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8440), 1,
      anon_sym_DASH_GT,
    ACTIONS(8442), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym___attribute,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7506), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8340), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [284672] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8440), 1,
      anon_sym_DASH_GT,
    ACTIONS(8442), 1,
      anon_sym_where,
    ACTIONS(11655), 1,
      anon_sym___attribute,
    STATE(7507), 1,
      sym_trailing_return_type,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8341), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [284716] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8440), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym___attribute,
    ACTIONS(10031), 1,
      anon_sym_requires,
    ACTIONS(10899), 1,
      anon_sym_where,
    STATE(7515), 1,
      sym_trailing_return_type,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7981), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [284760] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8440), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym___attribute,
    ACTIONS(10838), 1,
      anon_sym_requires,
    ACTIONS(11211), 1,
      anon_sym_where,
    STATE(7517), 1,
      sym_trailing_return_type,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7982), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [284804] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8440), 1,
      anon_sym_DASH_GT,
    ACTIONS(11264), 1,
      anon_sym___attribute,
    ACTIONS(11315), 1,
      anon_sym_requires,
    ACTIONS(11514), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7518), 1,
      sym_trailing_return_type,
    ACTIONS(11312), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7983), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [284848] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8440), 1,
      anon_sym_DASH_GT,
    ACTIONS(11655), 1,
      anon_sym___attribute,
    ACTIONS(11889), 1,
      anon_sym_requires,
    ACTIONS(12262), 1,
      anon_sym_where,
    STATE(7520), 1,
      sym_trailing_return_type,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11886), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7984), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [284892] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12265), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7398), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [284932] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11947), 1,
      sym_identifier,
    ACTIONS(11951), 1,
      anon_sym_LPAREN2,
    ACTIONS(11953), 1,
      anon_sym_defined,
    ACTIONS(12267), 1,
      sym_number_literal,
    ACTIONS(11955), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(11957), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11961), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7229), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [284972] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6077), 1,
      anon_sym_RBRACK,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [285024] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12273), 1,
      anon_sym_AMP,
    STATE(7344), 1,
      aux_sym_interface_requirements_repeat1,
    ACTIONS(12269), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12271), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [285056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4716), 9,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(4718), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [285084] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(9678), 1,
      anon_sym_STAR,
    ACTIONS(12006), 1,
      anon_sym_TILDE,
    ACTIONS(12012), 1,
      anon_sym_operator,
    ACTIONS(12276), 1,
      sym_identifier,
    ACTIONS(12278), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12280), 1,
      anon_sym_template,
    STATE(4734), 1,
      sym_pointer_type_declarator,
    STATE(4735), 1,
      sym_template_function,
    STATE(4736), 1,
      sym_destructor_name,
    STATE(4737), 1,
      sym_dependent_identifier,
    STATE(4738), 1,
      sym_qualified_identifier,
    STATE(4739), 1,
      sym_operator_name,
    STATE(5289), 1,
      sym_template_type,
    STATE(5290), 1,
      sym_dependent_type_identifier,
    STATE(5305), 1,
      sym_qualified_type_identifier,
    STATE(7346), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
    STATE(11577), 1,
      sym_ms_based_modifier,
  [285148] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12282), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7381), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [285188] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8378), 1,
      sym__type_declarator,
    STATE(9309), 1,
      sym__type_definition_declarators,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [285238] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12284), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7383), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [285278] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12286), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7386), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [285318] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(9606), 1,
      anon_sym_STAR,
    ACTIONS(11768), 1,
      anon_sym_TILDE,
    ACTIONS(12288), 1,
      sym_identifier,
    ACTIONS(12290), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12292), 1,
      anon_sym_template,
    ACTIONS(12294), 1,
      anon_sym_operator,
    STATE(205), 1,
      sym_template_type,
    STATE(206), 1,
      sym_dependent_type_identifier,
    STATE(214), 1,
      sym_qualified_type_identifier,
    STATE(3618), 1,
      sym_pointer_type_declarator,
    STATE(3619), 1,
      sym_template_function,
    STATE(3640), 1,
      sym_destructor_name,
    STATE(3641), 1,
      sym_dependent_identifier,
    STATE(3643), 1,
      sym_qualified_identifier,
    STATE(3644), 1,
      sym_operator_name,
    STATE(7351), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
    STATE(11420), 1,
      sym_ms_based_modifier,
  [285382] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12296), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7392), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [285422] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12298), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7397), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [285462] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12300), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [285514] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12302), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [285566] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12304), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7401), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [285606] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12306), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7402), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [285646] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12308), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [285698] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6079), 1,
      anon_sym_EQ,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11996), 1,
      anon_sym_AMP,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12002), 1,
      sym_this,
    ACTIONS(12310), 1,
      anon_sym_RBRACK,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10432), 1,
      sym_lambda_default_capture,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(9692), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [285750] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12312), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7405), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [285790] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12314), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7411), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [285830] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      sym_identifier,
    ACTIONS(12024), 1,
      anon_sym_LPAREN2,
    ACTIONS(12026), 1,
      anon_sym_defined,
    ACTIONS(12316), 1,
      sym_number_literal,
    ACTIONS(12028), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(12030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12034), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(7365), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [285870] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12182), 1,
      anon_sym_AMP,
    STATE(7285), 1,
      aux_sym_interface_requirements_repeat1,
    ACTIONS(12318), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12320), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [285902] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8378), 1,
      sym__type_declarator,
    STATE(9306), 1,
      sym__type_definition_declarators,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [285952] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12222), 1,
      anon_sym_LF,
    ACTIONS(12322), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12324), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(12224), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [285983] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9720), 1,
      sym_identifier,
    ACTIONS(9722), 1,
      anon_sym_LPAREN2,
    ACTIONS(9732), 1,
      sym_primitive_type,
    ACTIONS(9734), 1,
      anon_sym_STAR,
    ACTIONS(9736), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9738), 1,
      anon_sym_AMP,
    STATE(7637), 1,
      sym__type_declarator,
    STATE(8122), 1,
      sym_pointer_type_declarator,
    STATE(11691), 1,
      sym_ms_based_modifier,
    ACTIONS(9730), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(8102), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [286030] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12326), 1,
      anon_sym_AMP,
    STATE(7367), 1,
      aux_sym_interface_requirements_repeat1,
    ACTIONS(12269), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12271), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [286061] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12331), 1,
      anon_sym___attribute,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3608), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [286096] = 12,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12335), 1,
      anon_sym_LF,
    ACTIONS(12337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(12339), 1,
      anon_sym_AMP_AMP,
    ACTIONS(12341), 1,
      anon_sym_PIPE,
    ACTIONS(12343), 1,
      anon_sym_CARET,
    ACTIONS(12345), 1,
      anon_sym_AMP,
    ACTIONS(12322), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(12351), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12324), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(12349), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [286141] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8674), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9724), 1,
      anon_sym_STAR,
    ACTIONS(12353), 1,
      sym_identifier,
    ACTIONS(12355), 1,
      anon_sym_template,
    STATE(7370), 1,
      sym__scope_resolution,
    STATE(8131), 1,
      sym_pointer_type_declarator,
    STATE(8133), 1,
      sym_template_function,
    STATE(8141), 1,
      sym_destructor_name,
    STATE(8144), 1,
      sym_dependent_identifier,
    STATE(8146), 1,
      sym_qualified_identifier,
    STATE(8150), 1,
      sym_operator_name,
    STATE(11642), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [286198] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9720), 1,
      sym_identifier,
    ACTIONS(9722), 1,
      anon_sym_LPAREN2,
    ACTIONS(9724), 1,
      anon_sym_STAR,
    ACTIONS(9726), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9728), 1,
      anon_sym_AMP,
    ACTIONS(9732), 1,
      sym_primitive_type,
    STATE(8122), 1,
      sym_pointer_type_declarator,
    STATE(8814), 1,
      sym__type_declarator,
    STATE(11642), 1,
      sym_ms_based_modifier,
    ACTIONS(9730), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(8102), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [286245] = 12,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(12339), 1,
      anon_sym_AMP_AMP,
    ACTIONS(12341), 1,
      anon_sym_PIPE,
    ACTIONS(12343), 1,
      anon_sym_CARET,
    ACTIONS(12345), 1,
      anon_sym_AMP,
    ACTIONS(12357), 1,
      anon_sym_LF,
    ACTIONS(12322), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(12351), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12324), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(12349), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [286290] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12248), 1,
      anon_sym_LF,
    ACTIONS(12250), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [286317] = 12,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(12339), 1,
      anon_sym_AMP_AMP,
    ACTIONS(12341), 1,
      anon_sym_PIPE,
    ACTIONS(12343), 1,
      anon_sym_CARET,
    ACTIONS(12345), 1,
      anon_sym_AMP,
    ACTIONS(12359), 1,
      anon_sym_LF,
    ACTIONS(12322), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(12351), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12324), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(12349), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [286362] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8245), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    STATE(7617), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8193), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [286401] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8245), 1,
      anon_sym_where,
    ACTIONS(11655), 1,
      anon_sym_LBRACK,
    STATE(7608), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8201), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [286440] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12038), 1,
      anon_sym_LF,
    ACTIONS(12040), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [286467] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12361), 1,
      sym_identifier,
    ACTIONS(12363), 1,
      anon_sym_template,
    STATE(3618), 1,
      sym_pointer_type_declarator,
    STATE(3619), 1,
      sym_template_function,
    STATE(3640), 1,
      sym_destructor_name,
    STATE(3641), 1,
      sym_dependent_identifier,
    STATE(3643), 1,
      sym_qualified_identifier,
    STATE(3644), 1,
      sym_operator_name,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10936), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [286524] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12216), 1,
      anon_sym_LF,
    ACTIONS(12218), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [286551] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    ACTIONS(12367), 1,
      anon_sym___attribute,
    STATE(3608), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [286586] = 4,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12222), 1,
      anon_sym_LF,
    ACTIONS(12324), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(12224), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [286615] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11919), 1,
      anon_sym_SLASH,
    ACTIONS(11921), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(11923), 1,
      anon_sym_AMP_AMP,
    ACTIONS(11925), 1,
      anon_sym_PIPE,
    ACTIONS(11927), 1,
      anon_sym_CARET,
    ACTIONS(11929), 1,
      anon_sym_AMP,
    ACTIONS(12369), 1,
      anon_sym_RPAREN,
    ACTIONS(11915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11917), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(11931), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11933), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(11935), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(11937), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [286664] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12222), 1,
      anon_sym_LF,
    ACTIONS(12224), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [286691] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9676), 1,
      anon_sym_LPAREN2,
    ACTIONS(9678), 1,
      anon_sym_STAR,
    ACTIONS(9680), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9682), 1,
      anon_sym_AMP,
    ACTIONS(9686), 1,
      sym_primitive_type,
    STATE(3864), 1,
      sym__type_declarator,
    STATE(4535), 1,
      sym_pointer_type_declarator,
    STATE(11577), 1,
      sym_ms_based_modifier,
    ACTIONS(9684), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4530), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [286738] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9654), 1,
      anon_sym_STAR,
    ACTIONS(9656), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9658), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8927), 1,
      sym__type_declarator,
    STATE(11243), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [286785] = 12,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12222), 1,
      anon_sym_LF,
    ACTIONS(12224), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(12339), 1,
      anon_sym_AMP_AMP,
    ACTIONS(12341), 1,
      anon_sym_PIPE,
    ACTIONS(12343), 1,
      anon_sym_CARET,
    ACTIONS(12345), 1,
      anon_sym_AMP,
    ACTIONS(12322), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(12351), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12324), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(12349), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [286830] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9702), 1,
      anon_sym_STAR,
    ACTIONS(9704), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9706), 1,
      anon_sym_AMP,
    STATE(4331), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8585), 1,
      sym__abstract_declarator,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9592), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [286873] = 12,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(12339), 1,
      anon_sym_AMP_AMP,
    ACTIONS(12341), 1,
      anon_sym_PIPE,
    ACTIONS(12343), 1,
      anon_sym_CARET,
    ACTIONS(12345), 1,
      anon_sym_AMP,
    ACTIONS(12371), 1,
      anon_sym_LF,
    ACTIONS(12322), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(12351), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12324), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(12349), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [286918] = 12,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(12339), 1,
      anon_sym_AMP_AMP,
    ACTIONS(12341), 1,
      anon_sym_PIPE,
    ACTIONS(12343), 1,
      anon_sym_CARET,
    ACTIONS(12345), 1,
      anon_sym_AMP,
    ACTIONS(12373), 1,
      anon_sym_LF,
    ACTIONS(12322), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(12351), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12324), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(12349), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [286963] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    ACTIONS(12377), 1,
      anon_sym___attribute,
    STATE(3608), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [286998] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9688), 1,
      sym_identifier,
    ACTIONS(9690), 1,
      anon_sym_LPAREN2,
    ACTIONS(9692), 1,
      anon_sym_STAR,
    ACTIONS(9694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9696), 1,
      anon_sym_AMP,
    ACTIONS(9700), 1,
      sym_primitive_type,
    STATE(3799), 1,
      sym__type_declarator,
    STATE(4458), 1,
      sym_pointer_type_declarator,
    STATE(11304), 1,
      sym_ms_based_modifier,
    ACTIONS(9698), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4456), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [287045] = 11,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12222), 1,
      anon_sym_LF,
    ACTIONS(12341), 1,
      anon_sym_PIPE,
    ACTIONS(12343), 1,
      anon_sym_CARET,
    ACTIONS(12345), 1,
      anon_sym_AMP,
    ACTIONS(12224), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(12322), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(12351), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12324), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(12349), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [287088] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(5024), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12379), 1,
      sym_identifier,
    ACTIONS(12381), 1,
      anon_sym_COLON_COLON,
    STATE(1308), 1,
      sym_template_type,
    STATE(1356), 1,
      sym_field_declaration_list,
    STATE(7557), 1,
      sym_attribute_declaration,
    STATE(8647), 1,
      sym__scope_resolution,
    STATE(9378), 1,
      sym_virtual_specifier,
    STATE(10508), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1272), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [287143] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8950), 1,
      sym__type_declarator,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [287190] = 12,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(12339), 1,
      anon_sym_AMP_AMP,
    ACTIONS(12341), 1,
      anon_sym_PIPE,
    ACTIONS(12343), 1,
      anon_sym_CARET,
    ACTIONS(12345), 1,
      anon_sym_AMP,
    ACTIONS(12383), 1,
      anon_sym_LF,
    ACTIONS(12322), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(12351), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12324), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(12349), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [287235] = 12,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(12339), 1,
      anon_sym_AMP_AMP,
    ACTIONS(12341), 1,
      anon_sym_PIPE,
    ACTIONS(12343), 1,
      anon_sym_CARET,
    ACTIONS(12345), 1,
      anon_sym_AMP,
    ACTIONS(12385), 1,
      anon_sym_LF,
    ACTIONS(12322), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(12351), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12324), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(12349), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [287280] = 10,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12222), 1,
      anon_sym_LF,
    ACTIONS(12343), 1,
      anon_sym_CARET,
    ACTIONS(12345), 1,
      anon_sym_AMP,
    ACTIONS(12322), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(12351), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12224), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
    ACTIONS(12324), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(12349), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [287321] = 12,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(12339), 1,
      anon_sym_AMP_AMP,
    ACTIONS(12341), 1,
      anon_sym_PIPE,
    ACTIONS(12343), 1,
      anon_sym_CARET,
    ACTIONS(12345), 1,
      anon_sym_AMP,
    ACTIONS(12387), 1,
      anon_sym_LF,
    ACTIONS(12322), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(12351), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12324), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(12349), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [287366] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8805), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(12389), 1,
      sym_identifier,
    ACTIONS(12391), 1,
      anon_sym_template,
    STATE(3618), 1,
      sym_pointer_type_declarator,
    STATE(3619), 1,
      sym_template_function,
    STATE(3640), 1,
      sym_destructor_name,
    STATE(3641), 1,
      sym_dependent_identifier,
    STATE(3643), 1,
      sym_qualified_identifier,
    STATE(3644), 1,
      sym_operator_name,
    STATE(7399), 1,
      sym__scope_resolution,
    STATE(10936), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [287423] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9734), 1,
      anon_sym_STAR,
    ACTIONS(12353), 1,
      sym_identifier,
    ACTIONS(12355), 1,
      anon_sym_template,
    STATE(7400), 1,
      sym__scope_resolution,
    STATE(8131), 1,
      sym_pointer_type_declarator,
    STATE(8133), 1,
      sym_template_function,
    STATE(8141), 1,
      sym_destructor_name,
    STATE(8144), 1,
      sym_dependent_identifier,
    STATE(8146), 1,
      sym_qualified_identifier,
    STATE(8150), 1,
      sym_operator_name,
    STATE(11691), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [287480] = 9,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12222), 1,
      anon_sym_LF,
    ACTIONS(12345), 1,
      anon_sym_AMP,
    ACTIONS(12322), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(12351), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12324), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(12224), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(12349), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [287519] = 8,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12222), 1,
      anon_sym_LF,
    ACTIONS(12322), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(12351), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12324), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(12349), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(12224), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
  [287556] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8995), 1,
      sym__type_declarator,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [287603] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11374), 1,
      anon_sym_requires,
    ACTIONS(11399), 1,
      anon_sym_where,
    STATE(7617), 1,
      sym_where_clause,
    ACTIONS(11371), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7887), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [287642] = 7,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12222), 1,
      anon_sym_LF,
    ACTIONS(12322), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12351), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12324), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(12349), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(12224), 7,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [287677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12269), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12271), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [287704] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2944), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12393), 1,
      sym_identifier,
    ACTIONS(12395), 1,
      anon_sym_COLON_COLON,
    STATE(528), 1,
      sym_template_type,
    STATE(867), 1,
      sym_field_declaration_list,
    STATE(7568), 1,
      sym_attribute_declaration,
    STATE(8624), 1,
      sym__scope_resolution,
    STATE(9519), 1,
      sym_virtual_specifier,
    STATE(10433), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(291), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [287759] = 12,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(12339), 1,
      anon_sym_AMP_AMP,
    ACTIONS(12341), 1,
      anon_sym_PIPE,
    ACTIONS(12343), 1,
      anon_sym_CARET,
    ACTIONS(12345), 1,
      anon_sym_AMP,
    ACTIONS(12397), 1,
      anon_sym_LF,
    ACTIONS(12322), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(12351), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12324), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(12349), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [287804] = 12,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(12339), 1,
      anon_sym_AMP_AMP,
    ACTIONS(12341), 1,
      anon_sym_PIPE,
    ACTIONS(12343), 1,
      anon_sym_CARET,
    ACTIONS(12345), 1,
      anon_sym_AMP,
    ACTIONS(12399), 1,
      anon_sym_LF,
    ACTIONS(12322), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(12351), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12324), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(12349), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [287849] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11790), 1,
      sym_identifier,
    ACTIONS(12401), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(799), 1,
      sym_field_declaration_list,
    STATE(7562), 1,
      sym_attribute_declaration,
    STATE(8604), 1,
      sym__scope_resolution,
    STATE(9432), 1,
      sym_virtual_specifier,
    STATE(10456), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(8672), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [287904] = 6,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12222), 1,
      anon_sym_LF,
    ACTIONS(12322), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12351), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12324), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(12224), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [287937] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8245), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    STATE(7624), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8183), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [287976] = 12,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(12339), 1,
      anon_sym_AMP_AMP,
    ACTIONS(12341), 1,
      anon_sym_PIPE,
    ACTIONS(12343), 1,
      anon_sym_CARET,
    ACTIONS(12345), 1,
      anon_sym_AMP,
    ACTIONS(12403), 1,
      anon_sym_LF,
    ACTIONS(12322), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(12351), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12324), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(12349), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [288021] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9618), 1,
      anon_sym_STAR,
    ACTIONS(9620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9622), 1,
      anon_sym_AMP,
    STATE(4445), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8577), 1,
      sym__abstract_declarator,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(9592), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [288064] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    ACTIONS(12407), 1,
      anon_sym___attribute,
    STATE(3608), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [288099] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12409), 1,
      anon_sym_AMP,
    STATE(7444), 1,
      aux_sym_interface_requirements_repeat1,
    ACTIONS(12318), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12320), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [288130] = 12,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(12339), 1,
      anon_sym_AMP_AMP,
    ACTIONS(12341), 1,
      anon_sym_PIPE,
    ACTIONS(12343), 1,
      anon_sym_CARET,
    ACTIONS(12345), 1,
      anon_sym_AMP,
    ACTIONS(12411), 1,
      anon_sym_LF,
    ACTIONS(12322), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(12351), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12324), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(12349), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [288175] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    ACTIONS(12415), 1,
      anon_sym___attribute,
    STATE(3608), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [288210] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11089), 1,
      anon_sym_requires,
    ACTIONS(11107), 1,
      anon_sym_where,
    STATE(7626), 1,
      sym_where_clause,
    ACTIONS(11086), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7852), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [288249] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9720), 1,
      sym_identifier,
    ACTIONS(9722), 1,
      anon_sym_LPAREN2,
    ACTIONS(9732), 1,
      sym_primitive_type,
    ACTIONS(9734), 1,
      anon_sym_STAR,
    ACTIONS(9736), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9738), 1,
      anon_sym_AMP,
    STATE(8122), 1,
      sym_pointer_type_declarator,
    STATE(8533), 1,
      sym__type_declarator,
    STATE(11691), 1,
      sym_ms_based_modifier,
    ACTIONS(9730), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(8102), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [288296] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(7999), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(11982), 1,
      sym_identifier,
    ACTIONS(11984), 1,
      anon_sym_template,
    STATE(3618), 1,
      sym_pointer_type_declarator,
    STATE(3619), 1,
      sym_template_function,
    STATE(3640), 1,
      sym_destructor_name,
    STATE(3641), 1,
      sym_dependent_identifier,
    STATE(3643), 1,
      sym_qualified_identifier,
    STATE(3644), 1,
      sym_operator_name,
    STATE(7421), 1,
      sym__scope_resolution,
    STATE(10936), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [288353] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12417), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(12425), 1,
      anon_sym_EQ,
    STATE(7492), 1,
      sym_interface_requirements,
    STATE(7493), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12423), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12419), 12,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [288390] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12156), 1,
      anon_sym_LF,
    ACTIONS(12158), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [288417] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12016), 1,
      anon_sym_LF,
    ACTIONS(12018), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [288444] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    ACTIONS(12429), 1,
      anon_sym___attribute,
    STATE(3608), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [288479] = 3,
    ACTIONS(8332), 1,
      anon_sym_LF,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(8330), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [288506] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11919), 1,
      anon_sym_SLASH,
    ACTIONS(11921), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(11923), 1,
      anon_sym_AMP_AMP,
    ACTIONS(11925), 1,
      anon_sym_PIPE,
    ACTIONS(11927), 1,
      anon_sym_CARET,
    ACTIONS(11929), 1,
      anon_sym_AMP,
    ACTIONS(12431), 1,
      anon_sym_RPAREN,
    ACTIONS(11915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(11917), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(11931), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(11933), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(11935), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(11937), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [288555] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11655), 1,
      anon_sym_LBRACK,
    ACTIONS(11660), 1,
      anon_sym_requires,
    ACTIONS(11979), 1,
      anon_sym_where,
    STATE(7608), 1,
      sym_where_clause,
    ACTIONS(11657), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7819), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [288594] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12102), 1,
      anon_sym_LF,
    ACTIONS(12104), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [288621] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12106), 1,
      anon_sym_LF,
    ACTIONS(12108), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [288648] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(12433), 1,
      sym_identifier,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12437), 1,
      anon_sym_template,
    STATE(3618), 1,
      sym_pointer_type_declarator,
    STATE(3619), 1,
      sym_template_function,
    STATE(3640), 1,
      sym_destructor_name,
    STATE(3641), 1,
      sym_dependent_identifier,
    STATE(3643), 1,
      sym_qualified_identifier,
    STATE(3644), 1,
      sym_operator_name,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(10936), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [288705] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8992), 1,
      sym__type_declarator,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [288752] = 12,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(12339), 1,
      anon_sym_AMP_AMP,
    ACTIONS(12341), 1,
      anon_sym_PIPE,
    ACTIONS(12343), 1,
      anon_sym_CARET,
    ACTIONS(12345), 1,
      anon_sym_AMP,
    ACTIONS(12439), 1,
      anon_sym_LF,
    ACTIONS(12322), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(12351), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12324), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(12349), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [288797] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9606), 1,
      anon_sym_STAR,
    ACTIONS(9608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9610), 1,
      anon_sym_AMP,
    ACTIONS(9616), 1,
      sym_primitive_type,
    STATE(3201), 1,
      sym__type_declarator,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(11420), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [288844] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8245), 1,
      anon_sym_where,
    ACTIONS(11830), 1,
      anon_sym_LBRACK,
    STATE(7625), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8200), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [288883] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8204), 1,
      anon_sym_requires,
    ACTIONS(8245), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    STATE(7626), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [288922] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    ACTIONS(12443), 1,
      anon_sym___attribute,
    STATE(3608), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [288957] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11830), 1,
      anon_sym_LBRACK,
    ACTIONS(11880), 1,
      anon_sym_requires,
    ACTIONS(12445), 1,
      anon_sym_where,
    STATE(7625), 1,
      sym_where_clause,
    ACTIONS(11877), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7740), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [288996] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9592), 1,
      anon_sym_COMMA,
    ACTIONS(9660), 1,
      anon_sym_STAR,
    ACTIONS(9662), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9664), 1,
      anon_sym_AMP,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8522), 1,
      sym__abstract_declarator,
    ACTIONS(9594), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [289041] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    ACTIONS(12450), 1,
      anon_sym___attribute,
    STATE(3608), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [289076] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10429), 1,
      anon_sym_requires,
    ACTIONS(10564), 1,
      anon_sym_where,
    STATE(7624), 1,
      sym_where_clause,
    ACTIONS(10426), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7874), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [289115] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11166), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(487), 1,
      sym_field_declaration_list,
    STATE(7581), 1,
      sym_attribute_declaration,
    STATE(8640), 1,
      sym__scope_resolution,
    STATE(9334), 1,
      sym_virtual_specifier,
    STATE(10484), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(246), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [289170] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12452), 1,
      sym_identifier,
    ACTIONS(12454), 1,
      anon_sym_COLON_COLON,
    STATE(259), 1,
      sym_template_type,
    STATE(407), 1,
      sym_field_declaration_list,
    STATE(7555), 1,
      sym_attribute_declaration,
    STATE(8637), 1,
      sym__scope_resolution,
    STATE(9374), 1,
      sym_virtual_specifier,
    STATE(10772), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(244), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [289225] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12409), 1,
      anon_sym_AMP,
    STATE(7367), 1,
      aux_sym_interface_requirements_repeat1,
    ACTIONS(12178), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12180), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [289256] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12232), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12456), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7445), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(12234), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [289287] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12146), 1,
      anon_sym_LF,
    ACTIONS(12148), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [289314] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8571), 1,
      sym__type_declarator,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [289361] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11441), 1,
      sym_identifier,
    STATE(398), 1,
      sym_template_type,
    STATE(799), 1,
      sym_field_declaration_list,
    STATE(7606), 1,
      sym_attribute_declaration,
    STATE(8763), 1,
      sym__scope_resolution,
    STATE(9364), 1,
      sym_virtual_specifier,
    STATE(10593), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(314), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [289416] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(2450), 1,
      anon_sym_TILDE,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(8781), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9654), 1,
      anon_sym_STAR,
    ACTIONS(11982), 1,
      sym_identifier,
    ACTIONS(11984), 1,
      anon_sym_template,
    STATE(3618), 1,
      sym_pointer_type_declarator,
    STATE(3619), 1,
      sym_template_function,
    STATE(3640), 1,
      sym_destructor_name,
    STATE(3641), 1,
      sym_dependent_identifier,
    STATE(3643), 1,
      sym_qualified_identifier,
    STATE(3644), 1,
      sym_operator_name,
    STATE(7449), 1,
      sym__scope_resolution,
    STATE(11243), 1,
      sym_ms_based_modifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [289473] = 12,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12337), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(12339), 1,
      anon_sym_AMP_AMP,
    ACTIONS(12341), 1,
      anon_sym_PIPE,
    ACTIONS(12343), 1,
      anon_sym_CARET,
    ACTIONS(12345), 1,
      anon_sym_AMP,
    ACTIONS(12459), 1,
      anon_sym_LF,
    ACTIONS(12322), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(12347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(12351), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(12324), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(12349), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [289518] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(12190), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(7445), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(12192), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [289549] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(8989), 1,
      sym__type_declarator,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [289596] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      anon_sym_LPAREN2,
    ACTIONS(9616), 1,
      sym_primitive_type,
    ACTIONS(9748), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9752), 1,
      anon_sym_AMP,
    STATE(3273), 1,
      sym_pointer_type_declarator,
    STATE(7961), 1,
      sym__type_declarator,
    STATE(10936), 1,
      sym_ms_based_modifier,
    ACTIONS(9614), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3277), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [289643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12461), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12463), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [289669] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8869), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym___attribute,
    ACTIONS(11129), 1,
      anon_sym_requires,
    ACTIONS(11196), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7706), 1,
      sym_trailing_return_type,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8269), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [289711] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8869), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym___attribute,
    ACTIONS(11256), 1,
      anon_sym_requires,
    ACTIONS(11384), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7707), 1,
      sym_trailing_return_type,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8270), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [289753] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8869), 1,
      anon_sym_DASH_GT,
    ACTIONS(11264), 1,
      anon_sym___attribute,
    ACTIONS(11528), 1,
      anon_sym_requires,
    ACTIONS(11557), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7708), 1,
      sym_trailing_return_type,
    ACTIONS(11312), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8271), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [289795] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8869), 1,
      anon_sym_DASH_GT,
    ACTIONS(11655), 1,
      anon_sym___attribute,
    ACTIONS(12465), 1,
      anon_sym_requires,
    ACTIONS(12468), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    STATE(7709), 1,
      sym_trailing_return_type,
    ACTIONS(11886), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8272), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [289837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10026), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(10024), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [289863] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8812), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym___attribute,
    ACTIONS(11152), 1,
      anon_sym_requires,
    ACTIONS(11155), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7664), 1,
      sym_trailing_return_type,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8258), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [289905] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8812), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym___attribute,
    ACTIONS(11365), 1,
      anon_sym_requires,
    ACTIONS(11368), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7665), 1,
      sym_trailing_return_type,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8259), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [289947] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8812), 1,
      anon_sym_DASH_GT,
    ACTIONS(11264), 1,
      anon_sym___attribute,
    ACTIONS(11551), 1,
      anon_sym_requires,
    ACTIONS(11554), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7666), 1,
      sym_trailing_return_type,
    ACTIONS(11312), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8261), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [289989] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8812), 1,
      anon_sym_DASH_GT,
    ACTIONS(11655), 1,
      anon_sym___attribute,
    ACTIONS(12471), 1,
      anon_sym_requires,
    ACTIONS(12474), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    STATE(7667), 1,
      sym_trailing_return_type,
    ACTIONS(11886), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8262), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [290031] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    STATE(7628), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8613), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [290071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11655), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11653), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [290097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12477), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12479), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [290123] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9764), 1,
      anon_sym_STAR,
    ACTIONS(9766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9768), 1,
      anon_sym_AMP,
    STATE(3883), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8595), 1,
      sym__abstract_declarator,
    ACTIONS(9592), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_requires,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [290165] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8326), 1,
      anon_sym_requires,
    ACTIONS(8328), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    STATE(7624), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8395), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [290203] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8326), 1,
      anon_sym_requires,
    ACTIONS(8328), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    STATE(7626), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8399), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [290241] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(10031), 1,
      anon_sym_requires,
    ACTIONS(11012), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7714), 1,
      sym_trailing_return_type,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8285), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [290281] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7645), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8609), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [290321] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8326), 1,
      anon_sym_requires,
    ACTIONS(8328), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    STATE(7617), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8401), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [290359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12481), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12483), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [290385] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8326), 1,
      anon_sym_requires,
    ACTIONS(8328), 1,
      anon_sym_where,
    ACTIONS(11655), 1,
      anon_sym_LBRACK,
    STATE(7608), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8402), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [290423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12485), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12487), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [290449] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8326), 1,
      anon_sym_requires,
    ACTIONS(8328), 1,
      anon_sym_where,
    ACTIONS(11830), 1,
      anon_sym_LBRACK,
    STATE(7625), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8403), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [290487] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7641), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8607), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [290527] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7649), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8611), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [290567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12489), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12491), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [290593] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9841), 1,
      anon_sym_STAR,
    ACTIONS(9843), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9845), 1,
      anon_sym_AMP,
    STATE(3767), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8621), 1,
      sym__abstract_declarator,
    ACTIONS(9592), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [290635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12493), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12495), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [290661] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11790), 1,
      sym_identifier,
    ACTIONS(11792), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12497), 1,
      anon_sym_virtual,
    STATE(207), 1,
      sym_template_type,
    STATE(8494), 1,
      sym_access_specifier,
    STATE(8741), 1,
      sym__scope_resolution,
    STATE(7550), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9350), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(12499), 3,
      anon_sym_private,
      anon_sym_public,
      anon_sym_protected,
  [290709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12269), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12271), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [290735] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11790), 1,
      sym_identifier,
    ACTIONS(11792), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12501), 1,
      anon_sym_virtual,
    STATE(207), 1,
      sym_template_type,
    STATE(8436), 1,
      sym_access_specifier,
    STATE(8741), 1,
      sym__scope_resolution,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9304), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(12499), 3,
      anon_sym_private,
      anon_sym_public,
      anon_sym_protected,
  [290783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12503), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12505), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [290809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12507), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12509), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [290835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12511), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12513), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [290861] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11790), 1,
      sym_identifier,
    ACTIONS(11792), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12515), 1,
      anon_sym_virtual,
    STATE(207), 1,
      sym_template_type,
    STATE(8330), 1,
      sym_access_specifier,
    STATE(8741), 1,
      sym__scope_resolution,
    STATE(7484), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9282), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(12499), 3,
      anon_sym_private,
      anon_sym_public,
      anon_sym_protected,
  [290909] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11694), 7,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11692), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [290939] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8869), 1,
      anon_sym_DASH_GT,
    ACTIONS(8876), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym___attribute,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7652), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8736), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [290981] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8869), 1,
      anon_sym_DASH_GT,
    ACTIONS(8876), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym___attribute,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7653), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8738), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [291023] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12417), 1,
      anon_sym_COMMA,
    ACTIONS(12521), 1,
      anon_sym_EQ,
    STATE(7496), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12519), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12517), 13,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [291055] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12417), 1,
      anon_sym_COMMA,
    STATE(7497), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12519), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12517), 14,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [291085] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(10838), 1,
      anon_sym_requires,
    ACTIONS(11208), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7732), 1,
      sym_trailing_return_type,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8286), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [291125] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12417), 1,
      anon_sym_COMMA,
    STATE(7498), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12525), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12523), 14,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [291155] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12417), 1,
      anon_sym_COMMA,
    STATE(7497), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12525), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12523), 14,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [291185] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12527), 1,
      anon_sym_COMMA,
    STATE(7497), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12532), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12530), 14,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [291215] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12417), 1,
      anon_sym_COMMA,
    STATE(7497), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12536), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12534), 14,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [291245] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12417), 1,
      anon_sym_COMMA,
    STATE(7500), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12536), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12534), 14,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [291275] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12417), 1,
      anon_sym_COMMA,
    STATE(7497), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12540), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12538), 14,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [291305] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8442), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym___attribute,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8338), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [291343] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8869), 1,
      anon_sym_DASH_GT,
    ACTIONS(8876), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym___attribute,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7654), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8739), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [291385] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8442), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym___attribute,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8339), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [291423] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8869), 1,
      anon_sym_DASH_GT,
    ACTIONS(8876), 1,
      anon_sym_where,
    ACTIONS(11655), 1,
      anon_sym___attribute,
    STATE(7535), 1,
      sym_where_clause,
    STATE(7655), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8742), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [291465] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8442), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym___attribute,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8340), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [291503] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8442), 1,
      anon_sym_where,
    ACTIONS(11655), 1,
      anon_sym___attribute,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8341), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [291541] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8442), 1,
      anon_sym_where,
    ACTIONS(11830), 1,
      anon_sym___attribute,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8342), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [291579] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10432), 1,
      anon_sym_where,
    STATE(7624), 1,
      sym_where_clause,
    ACTIONS(10026), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10024), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [291609] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11092), 1,
      anon_sym_where,
    STATE(7626), 1,
      sym_where_clause,
    ACTIONS(10825), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10823), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [291639] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11377), 1,
      anon_sym_where,
    STATE(7617), 1,
      sym_where_clause,
    ACTIONS(11264), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11262), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [291669] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11663), 1,
      anon_sym_where,
    STATE(7608), 1,
      sym_where_clause,
    ACTIONS(11655), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11653), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [291699] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11883), 1,
      anon_sym_where,
    STATE(7625), 1,
      sym_where_clause,
    ACTIONS(11830), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11828), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [291729] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12546), 1,
      anon_sym_where,
    STATE(7605), 1,
      sym_where_clause,
    ACTIONS(12544), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12542), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [291759] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10026), 1,
      anon_sym___attribute,
    ACTIONS(10031), 1,
      anon_sym_requires,
    ACTIONS(10899), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7981), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [291797] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10825), 1,
      anon_sym___attribute,
    ACTIONS(10838), 1,
      anon_sym_requires,
    ACTIONS(11211), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7982), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [291835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12549), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12551), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [291861] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11264), 1,
      anon_sym___attribute,
    ACTIONS(11315), 1,
      anon_sym_requires,
    ACTIONS(11514), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11312), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7983), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [291899] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11655), 1,
      anon_sym___attribute,
    ACTIONS(11889), 1,
      anon_sym_requires,
    ACTIONS(12262), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11886), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7984), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [291937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12553), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12555), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [291963] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11830), 1,
      anon_sym___attribute,
    ACTIONS(12242), 1,
      anon_sym_requires,
    ACTIONS(12557), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(12239), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7890), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [292001] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(11315), 1,
      anon_sym_requires,
    ACTIONS(11525), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7733), 1,
      sym_trailing_return_type,
    ACTIONS(11312), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8289), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [292041] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9594), 1,
      anon_sym___attribute,
    ACTIONS(9821), 1,
      anon_sym_STAR,
    ACTIONS(9823), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9825), 1,
      anon_sym_AMP,
    STATE(4120), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8663), 1,
      sym__abstract_declarator,
    ACTIONS(9592), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_GT2,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [292085] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12560), 1,
      anon_sym_COLON,
    ACTIONS(12563), 1,
      anon_sym_EQ,
    STATE(7574), 1,
      sym_interface_requirements,
    ACTIONS(12532), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12530), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [292117] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11698), 7,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11696), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [292147] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(11889), 1,
      anon_sym_requires,
    ACTIONS(12566), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    STATE(7734), 1,
      sym_trailing_return_type,
    ACTIONS(11886), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8295), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [292187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12569), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12571), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [292213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12573), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12575), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [292239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12577), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12579), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [292265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12581), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12583), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [292291] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8562), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(6166), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6980), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11696), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(11698), 6,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [292325] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8562), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(6166), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6955), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11692), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(11694), 6,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [292359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12585), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12587), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [292385] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8812), 1,
      anon_sym_DASH_GT,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(8816), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym___attribute,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7657), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8722), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [292427] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9594), 1,
      anon_sym___attribute,
    ACTIONS(9831), 1,
      anon_sym_STAR,
    ACTIONS(9833), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9835), 1,
      anon_sym_AMP,
    STATE(4273), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8642), 1,
      sym__abstract_declarator,
    ACTIONS(9592), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [292471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11830), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11828), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [292497] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8812), 1,
      anon_sym_DASH_GT,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(8816), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym___attribute,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7658), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8653), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [292539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11264), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11262), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [292565] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8812), 1,
      anon_sym_DASH_GT,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(8816), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym___attribute,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7659), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8638), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [292607] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8812), 1,
      anon_sym_DASH_GT,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(8816), 1,
      anon_sym_where,
    ACTIONS(11655), 1,
      anon_sym___attribute,
    STATE(7535), 1,
      sym_where_clause,
    STATE(7660), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8662), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [292649] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10715), 1,
      anon_sym_requires,
    ACTIONS(10718), 1,
      anon_sym_where,
    STATE(7624), 1,
      sym_where_clause,
    ACTIONS(10426), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7913), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [292687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12589), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12591), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [292713] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11758), 7,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(11760), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [292743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12593), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12595), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [292769] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11190), 1,
      anon_sym_requires,
    ACTIONS(11193), 1,
      anon_sym_where,
    STATE(7626), 1,
      sym_where_clause,
    ACTIONS(11086), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7914), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [292807] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11452), 1,
      anon_sym_requires,
    ACTIONS(11455), 1,
      anon_sym_where,
    STATE(7617), 1,
      sym_where_clause,
    ACTIONS(11371), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7915), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [292845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12544), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(12542), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [292871] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11655), 1,
      anon_sym_LBRACK,
    ACTIONS(12064), 1,
      anon_sym_requires,
    ACTIONS(12067), 1,
      anon_sym_where,
    STATE(7608), 1,
      sym_where_clause,
    ACTIONS(11657), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7916), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [292909] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11830), 1,
      anon_sym_LBRACK,
    ACTIONS(12597), 1,
      anon_sym_requires,
    ACTIONS(12600), 1,
      anon_sym_where,
    STATE(7625), 1,
      sym_where_clause,
    ACTIONS(11877), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(7917), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [292947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10825), 8,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(10823), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [292973] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11790), 1,
      sym_identifier,
    ACTIONS(11792), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12603), 1,
      anon_sym_virtual,
    STATE(207), 1,
      sym_template_type,
    STATE(8409), 1,
      sym_access_specifier,
    STATE(8741), 1,
      sym__scope_resolution,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9358), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(12499), 3,
      anon_sym_private,
      anon_sym_public,
      anon_sym_protected,
  [293021] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12605), 1,
      sym_identifier,
    ACTIONS(7217), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(7592), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(12607), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(12609), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [293052] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(9887), 1,
      anon_sym_LPAREN2,
    ACTIONS(9901), 1,
      sym_identifier,
    ACTIONS(9903), 1,
      anon_sym_STAR,
    ACTIONS(9905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9907), 1,
      anon_sym_AMP,
    STATE(7797), 1,
      sym__field_declarator,
    STATE(8031), 1,
      sym_operator_name,
    STATE(10874), 1,
      sym_ms_based_modifier,
    STATE(8244), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [293095] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8594), 1,
      anon_sym_where,
    ACTIONS(10031), 1,
      anon_sym_requires,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7782), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8616), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [293134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12461), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12463), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [293159] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    ACTIONS(12452), 1,
      sym_identifier,
    ACTIONS(12454), 1,
      anon_sym_COLON_COLON,
    STATE(259), 1,
      sym_template_type,
    STATE(453), 1,
      sym_field_declaration_list,
    STATE(8637), 1,
      sym__scope_resolution,
    STATE(9397), 1,
      sym_virtual_specifier,
    STATE(10601), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(243), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [293208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12593), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12595), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [293233] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(5024), 1,
      anon_sym_LBRACE,
    ACTIONS(12379), 1,
      sym_identifier,
    ACTIONS(12381), 1,
      anon_sym_COLON_COLON,
    STATE(1308), 1,
      sym_template_type,
    STATE(1371), 1,
      sym_field_declaration_list,
    STATE(8647), 1,
      sym__scope_resolution,
    STATE(9382), 1,
      sym_virtual_specifier,
    STATE(10677), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1270), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [293282] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(11256), 1,
      anon_sym_requires,
    ACTIONS(11259), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7816), 1,
      sym_trailing_return_type,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8442), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [293321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12477), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12479), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [293346] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(11528), 1,
      anon_sym_requires,
    ACTIONS(11531), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7821), 1,
      sym_trailing_return_type,
    ACTIONS(11312), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8500), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [293385] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6781), 1,
      anon_sym_LBRACK,
    ACTIONS(12611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(12613), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6783), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [293414] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(11790), 1,
      sym_identifier,
    ACTIONS(12401), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(833), 1,
      sym_field_declaration_list,
    STATE(8604), 1,
      sym__scope_resolution,
    STATE(9455), 1,
      sym_virtual_specifier,
    STATE(10429), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(8696), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [293463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12485), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12487), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [293488] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8592), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7885), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8807), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [293527] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12615), 1,
      anon_sym_AMP,
    ACTIONS(12617), 1,
      sym_this,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(10442), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [293570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12503), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12505), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [293595] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9895), 1,
      anon_sym_STAR,
    ACTIONS(9897), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9899), 1,
      anon_sym_AMP,
    STATE(3869), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8873), 1,
      sym__abstract_declarator,
    ACTIONS(9592), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [293636] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2944), 1,
      anon_sym_LBRACE,
    ACTIONS(12393), 1,
      sym_identifier,
    ACTIONS(12395), 1,
      anon_sym_COLON_COLON,
    STATE(528), 1,
      sym_template_type,
    STATE(717), 1,
      sym_field_declaration_list,
    STATE(8624), 1,
      sym__scope_resolution,
    STATE(9549), 1,
      sym_virtual_specifier,
    STATE(10551), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(292), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [293685] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8594), 1,
      anon_sym_where,
    ACTIONS(10838), 1,
      anon_sym_requires,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7808), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8617), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [293724] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6806), 1,
      anon_sym___attribute,
    ACTIONS(12619), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6808), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [293751] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8592), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7802), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8892), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [293790] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8566), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      sym_identifier,
    ACTIONS(11101), 1,
      anon_sym_requires,
    ACTIONS(11104), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7871), 1,
      sym_trailing_return_type,
    ACTIONS(11098), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8417), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [293831] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8592), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    STATE(7879), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8828), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [293870] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12625), 1,
      anon_sym_EQ,
    ACTIONS(12623), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12621), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [293897] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3540), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [293928] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3540), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [293959] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12632), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(12637), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(12635), 3,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    STATE(7577), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
    ACTIONS(12630), 7,
      anon_sym_COLON,
      anon_sym___declspec,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
  [293990] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3540), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [294021] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6781), 1,
      anon_sym___attribute,
    ACTIONS(12619), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(12640), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(6783), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [294050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12585), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12587), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [294075] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(11166), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(498), 1,
      sym_field_declaration_list,
    STATE(8640), 1,
      sym__scope_resolution,
    STATE(9436), 1,
      sym_virtual_specifier,
    STATE(10523), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(245), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [294124] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(12465), 1,
      anon_sym_requires,
    ACTIONS(12642), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    STATE(7825), 1,
      sym_trailing_return_type,
    ACTIONS(11886), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8420), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [294163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12481), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12483), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [294188] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(12613), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6808), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [294215] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8566), 1,
      anon_sym_DASH_GT,
    ACTIONS(8586), 1,
      anon_sym_requires,
    ACTIONS(8588), 1,
      anon_sym_where,
    ACTIONS(11655), 1,
      sym_identifier,
    STATE(7535), 1,
      sym_where_clause,
    STATE(7830), 1,
      sym_trailing_return_type,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8826), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [294256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12553), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12555), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [294281] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8594), 1,
      anon_sym_where,
    ACTIONS(11315), 1,
      anon_sym_requires,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7809), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8618), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [294320] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12573), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12575), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [294345] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8566), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      sym_identifier,
    ACTIONS(11284), 1,
      anon_sym_requires,
    ACTIONS(11287), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7883), 1,
      sym_trailing_return_type,
    ACTIONS(11281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8418), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [294386] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    ACTIONS(12647), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(7742), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(9529), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [294419] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6071), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11992), 1,
      sym_identifier,
    ACTIONS(11994), 1,
      anon_sym_STAR,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12615), 1,
      anon_sym_AMP,
    ACTIONS(12649), 1,
      sym_this,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(10118), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [294462] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12651), 1,
      sym_identifier,
    ACTIONS(7205), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(7592), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(12654), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(12657), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [294493] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(9885), 1,
      sym_identifier,
    ACTIONS(9887), 1,
      anon_sym_LPAREN2,
    ACTIONS(9889), 1,
      anon_sym_STAR,
    ACTIONS(9891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9893), 1,
      anon_sym_AMP,
    STATE(8840), 1,
      sym__field_declarator,
    STATE(9120), 1,
      sym_operator_name,
    STATE(11011), 1,
      sym_ms_based_modifier,
    STATE(8244), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [294536] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(9887), 1,
      anon_sym_LPAREN2,
    ACTIONS(9901), 1,
      sym_identifier,
    ACTIONS(9903), 1,
      anon_sym_STAR,
    ACTIONS(9905), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9907), 1,
      anon_sym_AMP,
    STATE(7722), 1,
      sym__field_declarator,
    STATE(8031), 1,
      sym_operator_name,
    STATE(10874), 1,
      sym_ms_based_modifier,
    STATE(8244), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [294579] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12660), 1,
      sym_identifier,
    ACTIONS(7190), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(7551), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(12607), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(12609), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [294610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12489), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12491), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [294635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12493), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12495), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [294660] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8566), 1,
      anon_sym_DASH_GT,
    ACTIONS(8586), 1,
      anon_sym_requires,
    ACTIONS(8588), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      sym_identifier,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7870), 1,
      sym_trailing_return_type,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8817), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [294701] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8566), 1,
      anon_sym_DASH_GT,
    ACTIONS(11264), 1,
      sym_identifier,
    ACTIONS(11545), 1,
      anon_sym_requires,
    ACTIONS(11548), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7884), 1,
      sym_trailing_return_type,
    ACTIONS(11542), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8419), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [294742] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8566), 1,
      anon_sym_DASH_GT,
    ACTIONS(11655), 1,
      sym_identifier,
    ACTIONS(12665), 1,
      anon_sym_requires,
    ACTIONS(12668), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    STATE(7886), 1,
      sym_trailing_return_type,
    ACTIONS(12662), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8504), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [294783] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12671), 1,
      anon_sym_COMMA,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(12675), 1,
      anon_sym_EQ,
    STATE(7672), 1,
      sym_interface_requirements,
    STATE(7673), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [294816] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3540), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [294847] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3540), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [294878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12507), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12509), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [294903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12511), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12513), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [294928] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2560), 1,
      anon_sym_COLON,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11441), 1,
      sym_identifier,
    STATE(398), 1,
      sym_template_type,
    STATE(833), 1,
      sym_field_declaration_list,
    STATE(8763), 1,
      sym__scope_resolution,
    STATE(9336), 1,
      sym_virtual_specifier,
    STATE(10468), 1,
      sym_base_class_clause,
    ACTIONS(2564), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(295), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [294977] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(5519), 1,
      anon_sym_STAR,
    ACTIONS(5521), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5523), 1,
      anon_sym_AMP,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8856), 1,
      sym__abstract_declarator,
    ACTIONS(9592), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [295018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11830), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11828), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [295043] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(9885), 1,
      sym_identifier,
    ACTIONS(9887), 1,
      anon_sym_LPAREN2,
    ACTIONS(9889), 1,
      anon_sym_STAR,
    ACTIONS(9891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9893), 1,
      anon_sym_AMP,
    STATE(8883), 1,
      sym__field_declarator,
    STATE(9120), 1,
      sym_operator_name,
    STATE(11011), 1,
      sym_ms_based_modifier,
    STATE(8244), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [295086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12549), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12551), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [295111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12569), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12571), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [295136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12581), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12583), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [295161] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3540), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [295192] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3540), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [295223] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8566), 1,
      anon_sym_DASH_GT,
    ACTIONS(8586), 1,
      anon_sym_requires,
    ACTIONS(8588), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      sym_identifier,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7766), 1,
      sym_trailing_return_type,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8821), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [295264] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8566), 1,
      anon_sym_DASH_GT,
    ACTIONS(8586), 1,
      anon_sym_requires,
    ACTIONS(8588), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      sym_identifier,
    STATE(7465), 1,
      sym_where_clause,
    STATE(7778), 1,
      sym_trailing_return_type,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8824), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [295305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11655), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11653), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [295330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10026), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10024), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [295355] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8143), 1,
      anon_sym_DASH_GT,
    ACTIONS(8594), 1,
      anon_sym_where,
    ACTIONS(11889), 1,
      anon_sym_requires,
    STATE(7535), 1,
      sym_where_clause,
    STATE(7815), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8619), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [295394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12577), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12579), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [295419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12589), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12591), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [295444] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8592), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(7888), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8889), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [295483] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(11129), 1,
      anon_sym_requires,
    ACTIONS(11132), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(7795), 1,
      sym_trailing_return_type,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8367), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [295522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10825), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10823), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [295547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12544), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12542), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [295572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11264), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11262), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [295597] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3540), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [295628] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8491), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8622), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [295662] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8974), 1,
      anon_sym_DASH_GT,
    ACTIONS(11655), 1,
      anon_sym_LBRACK,
    ACTIONS(12677), 1,
      anon_sym_requires,
    ACTIONS(12680), 1,
      anon_sym_where,
    STATE(7608), 1,
      sym_where_clause,
    STATE(7953), 1,
      sym_trailing_return_type,
    ACTIONS(11657), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8548), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [295702] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2406), 1,
      anon_sym_LT,
    STATE(7909), 1,
      sym_template_argument_list,
    ACTIONS(2234), 3,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2224), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [295732] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8491), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8607), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [295766] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3623), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [295796] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3623), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [295826] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11172), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12683), 1,
      sym_identifier,
    ACTIONS(12685), 1,
      sym_primitive_type,
    STATE(6447), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8669), 1,
      sym__scope_resolution,
    STATE(302), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(11174), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [295866] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7570), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12687), 1,
      anon_sym_LBRACK,
    STATE(8091), 1,
      sym_parameter_list,
    STATE(7781), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7572), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [295900] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12689), 1,
      sym_identifier,
    ACTIONS(12691), 1,
      sym_primitive_type,
    STATE(3156), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8676), 1,
      sym__scope_resolution,
    STATE(5240), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(10964), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [295940] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7558), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12687), 1,
      anon_sym_LBRACK,
    STATE(8091), 1,
      sym_parameter_list,
    STATE(7781), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7560), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [295974] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      anon_sym_LBRACE,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12693), 1,
      anon_sym_COLON,
    ACTIONS(12695), 1,
      anon_sym_SEMI,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    ACTIONS(12701), 1,
      anon_sym_try,
    STATE(529), 1,
      sym_compound_statement,
    STATE(530), 1,
      sym_try_statement,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(10088), 1,
      aux_sym_declaration_repeat1,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [296024] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12703), 1,
      sym_identifier,
    ACTIONS(12705), 1,
      sym_primitive_type,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(5628), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [296064] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11651), 1,
      anon_sym_try,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    ACTIONS(12707), 1,
      anon_sym_COLON,
    ACTIONS(12709), 1,
      anon_sym_SEMI,
    ACTIONS(12711), 1,
      anon_sym_LBRACE,
    STATE(2240), 1,
      sym_compound_statement,
    STATE(2241), 1,
      sym_try_statement,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(9965), 1,
      aux_sym_declaration_repeat1,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [296114] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8491), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8609), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [296148] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7554), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12687), 1,
      anon_sym_LBRACK,
    STATE(8091), 1,
      sym_parameter_list,
    STATE(7781), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7556), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [296182] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12713), 1,
      sym_identifier,
    ACTIONS(12715), 1,
      sym_primitive_type,
    STATE(2735), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(3230), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(11019), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [296222] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1093), 1,
      anon_sym_LBRACE,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    ACTIONS(12717), 1,
      anon_sym_COLON,
    ACTIONS(12719), 1,
      anon_sym_SEMI,
    ACTIONS(12721), 1,
      anon_sym_try,
    STATE(1076), 1,
      sym_compound_statement,
    STATE(1132), 1,
      sym_try_statement,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(10148), 1,
      aux_sym_declaration_repeat1,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [296272] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8491), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8611), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [296306] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7585), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12687), 1,
      anon_sym_LBRACK,
    STATE(8091), 1,
      sym_parameter_list,
    STATE(7781), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7587), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [296340] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10004), 1,
      anon_sym_STAR,
    ACTIONS(10006), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10008), 1,
      anon_sym_AMP,
    STATE(4446), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8974), 1,
      sym__abstract_declarator,
    ACTIONS(9592), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_requires,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [296380] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    ACTIONS(12723), 1,
      anon_sym_COLON,
    ACTIONS(12725), 1,
      anon_sym_SEMI,
    ACTIONS(12727), 1,
      anon_sym_try,
    STATE(986), 1,
      sym_compound_statement,
    STATE(992), 1,
      sym_try_statement,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(10213), 1,
      aux_sym_declaration_repeat1,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [296430] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_requires,
    ACTIONS(8491), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8613), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [296464] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7494), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12687), 1,
      anon_sym_LBRACK,
    STATE(8091), 1,
      sym_parameter_list,
    STATE(7781), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7496), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [296498] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8876), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym___attribute,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8736), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [296534] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8876), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym___attribute,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8738), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [296570] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8876), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym___attribute,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8739), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [296606] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8876), 1,
      anon_sym_where,
    ACTIONS(11655), 1,
      anon_sym___attribute,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8742), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [296642] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8876), 1,
      anon_sym_where,
    ACTIONS(11830), 1,
      anon_sym___attribute,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8745), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [296678] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(8816), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym___attribute,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8722), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [296714] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(8816), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym___attribute,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8653), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [296750] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(8816), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym___attribute,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8638), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [296786] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(8816), 1,
      anon_sym_where,
    ACTIONS(11655), 1,
      anon_sym___attribute,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8662), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [296822] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(8816), 1,
      anon_sym_where,
    ACTIONS(11830), 1,
      anon_sym___attribute,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8749), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [296858] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12729), 1,
      sym_identifier,
    ACTIONS(12731), 1,
      sym_primitive_type,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(6038), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [296898] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12729), 1,
      sym_identifier,
    ACTIONS(12731), 1,
      sym_primitive_type,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(6038), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8624), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [296938] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10026), 1,
      anon_sym___attribute,
    ACTIONS(11152), 1,
      anon_sym_requires,
    ACTIONS(11155), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8258), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [296974] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10825), 1,
      anon_sym___attribute,
    ACTIONS(11365), 1,
      anon_sym_requires,
    ACTIONS(11368), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8259), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [297010] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11264), 1,
      anon_sym___attribute,
    ACTIONS(11551), 1,
      anon_sym_requires,
    ACTIONS(11554), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11312), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8261), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [297046] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11655), 1,
      anon_sym___attribute,
    ACTIONS(12471), 1,
      anon_sym_requires,
    ACTIONS(12474), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11886), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8262), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [297082] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11830), 1,
      anon_sym___attribute,
    ACTIONS(12733), 1,
      anon_sym_requires,
    ACTIONS(12736), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(12239), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8263), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [297118] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11166), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12739), 1,
      sym_identifier,
    ACTIONS(12741), 1,
      sym_primitive_type,
    STATE(389), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8640), 1,
      sym__scope_resolution,
    STATE(302), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(59), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [297158] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2406), 1,
      anon_sym_LT,
    STATE(7909), 1,
      sym_template_argument_list,
    ACTIONS(7330), 3,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6761), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [297188] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12743), 1,
      sym_identifier,
    ACTIONS(12745), 1,
      sym_primitive_type,
    STATE(5394), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(5628), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8735), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [297228] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2410), 1,
      anon_sym_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(2953), 1,
      sym_template_argument_list,
    ACTIONS(2408), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
  [297258] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12671), 1,
      anon_sym_COMMA,
    ACTIONS(12747), 1,
      anon_sym_EQ,
    STATE(7675), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [297286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12671), 1,
      anon_sym_COMMA,
    STATE(7676), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [297312] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12671), 1,
      anon_sym_COMMA,
    STATE(7677), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [297338] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12671), 1,
      anon_sym_COMMA,
    STATE(7676), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [297364] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12749), 1,
      anon_sym_COMMA,
    STATE(7676), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [297390] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12671), 1,
      anon_sym_COMMA,
    STATE(7676), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [297416] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12671), 1,
      anon_sym_COMMA,
    STATE(7679), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [297442] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12671), 1,
      anon_sym_COMMA,
    STATE(7676), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [297468] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(917), 1,
      anon_sym_LBRACE,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    ACTIONS(12752), 1,
      anon_sym_COLON,
    ACTIONS(12754), 1,
      anon_sym_SEMI,
    ACTIONS(12756), 1,
      anon_sym_try,
    STATE(1041), 1,
      sym_compound_statement,
    STATE(1087), 1,
      sym_try_statement,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(9869), 1,
      aux_sym_declaration_repeat1,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [297518] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12683), 1,
      sym_identifier,
    ACTIONS(12685), 1,
      sym_primitive_type,
    STATE(5215), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8727), 1,
      sym__scope_resolution,
    STATE(302), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8755), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [297558] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12758), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7798), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(7800), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [297584] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12760), 1,
      sym_identifier,
    ACTIONS(12762), 1,
      sym_primitive_type,
    STATE(2815), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8630), 1,
      sym__scope_resolution,
    STATE(3802), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(11055), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [297624] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(12048), 1,
      anon_sym_TILDE,
    ACTIONS(12764), 1,
      sym_identifier,
    ACTIONS(12766), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12769), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12771), 1,
      anon_sym_template,
    STATE(8154), 1,
      sym__scope_resolution,
    STATE(10592), 1,
      sym_operator_name,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(4608), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [297666] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2222), 1,
      anon_sym_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(2953), 1,
      sym_template_argument_list,
    ACTIONS(2229), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
  [297696] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3623), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [297726] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(12423), 1,
      anon_sym_LBRACK,
    ACTIONS(12773), 1,
      anon_sym_COMMA,
    ACTIONS(12775), 1,
      anon_sym_EQ,
    STATE(7817), 1,
      sym_interface_requirements,
    STATE(7942), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 10,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [297760] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12777), 1,
      sym_identifier,
    ACTIONS(12779), 1,
      sym_primitive_type,
    STATE(3065), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(3017), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(11033), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [297800] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12783), 1,
      anon_sym_COLON,
    ACTIONS(12785), 1,
      anon_sym_EQ,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(10146), 1,
      sym_semantics,
    ACTIONS(12781), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8648), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [297846] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8974), 1,
      anon_sym_DASH_GT,
    ACTIONS(9183), 1,
      anon_sym_requires,
    ACTIONS(9185), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    STATE(7624), 1,
      sym_where_clause,
    STATE(8004), 1,
      sym_trailing_return_type,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9006), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [297886] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12787), 1,
      sym_identifier,
    ACTIONS(12789), 1,
      sym_primitive_type,
    STATE(2778), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8746), 1,
      sym__scope_resolution,
    STATE(3648), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(10906), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [297926] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12783), 1,
      anon_sym_COLON,
    ACTIONS(12791), 1,
      anon_sym_EQ,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(10146), 1,
      sym_semantics,
    ACTIONS(12781), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8648), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [297972] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12779), 1,
      sym_primitive_type,
    ACTIONS(12793), 1,
      sym_identifier,
    STATE(5163), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(3017), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2819), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [298012] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8974), 1,
      anon_sym_DASH_GT,
    ACTIONS(9183), 1,
      anon_sym_requires,
    ACTIONS(9185), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    STATE(7626), 1,
      sym_where_clause,
    STATE(7897), 1,
      sym_trailing_return_type,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9022), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [298052] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8974), 1,
      anon_sym_DASH_GT,
    ACTIONS(9183), 1,
      anon_sym_requires,
    ACTIONS(9185), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    STATE(7617), 1,
      sym_where_clause,
    STATE(7903), 1,
      sym_trailing_return_type,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8905), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [298092] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8974), 1,
      anon_sym_DASH_GT,
    ACTIONS(9183), 1,
      anon_sym_requires,
    ACTIONS(9185), 1,
      anon_sym_where,
    ACTIONS(11655), 1,
      anon_sym_LBRACK,
    STATE(7608), 1,
      sym_where_clause,
    STATE(7925), 1,
      sym_trailing_return_type,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8917), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [298132] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12795), 1,
      sym_identifier,
    ACTIONS(12797), 1,
      sym_primitive_type,
    STATE(6223), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(3017), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8826), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [298172] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12799), 1,
      sym_identifier,
    ACTIONS(12801), 1,
      sym_primitive_type,
    STATE(3068), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8723), 1,
      sym__scope_resolution,
    STATE(4955), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(10932), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [298212] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10031), 1,
      anon_sym_requires,
    ACTIONS(11012), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8285), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [298246] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12803), 1,
      sym_identifier,
    ACTIONS(12805), 1,
      sym_primitive_type,
    STATE(2788), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8655), 1,
      sym__scope_resolution,
    STATE(3705), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(10877), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [298286] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12807), 1,
      sym_identifier,
    ACTIONS(12809), 1,
      sym_primitive_type,
    STATE(3101), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(2826), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(4411), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [298326] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12807), 1,
      sym_identifier,
    ACTIONS(12809), 1,
      sym_primitive_type,
    STATE(2717), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8769), 1,
      sym__scope_resolution,
    STATE(2826), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(203), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [298366] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12703), 1,
      sym_identifier,
    ACTIONS(12705), 1,
      sym_primitive_type,
    STATE(4970), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(5628), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(5088), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [298406] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8974), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(11231), 1,
      anon_sym_requires,
    ACTIONS(11234), 1,
      anon_sym_where,
    STATE(7624), 1,
      sym_where_clause,
    STATE(8005), 1,
      sym_trailing_return_type,
    ACTIONS(10426), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8545), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [298446] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10026), 1,
      anon_sym___attribute,
    ACTIONS(11129), 1,
      anon_sym_requires,
    ACTIONS(11196), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8269), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [298482] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10825), 1,
      anon_sym___attribute,
    ACTIONS(11256), 1,
      anon_sym_requires,
    ACTIONS(11384), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8270), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [298518] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11264), 1,
      anon_sym___attribute,
    ACTIONS(11528), 1,
      anon_sym_requires,
    ACTIONS(11557), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11312), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8271), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [298554] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11655), 1,
      anon_sym___attribute,
    ACTIONS(12465), 1,
      anon_sym_requires,
    ACTIONS(12468), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11886), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8272), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [298590] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11830), 1,
      anon_sym___attribute,
    ACTIONS(12811), 1,
      anon_sym_requires,
    ACTIONS(12814), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(12239), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8273), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [298626] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11680), 1,
      anon_sym_try,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    ACTIONS(12817), 1,
      anon_sym_COLON,
    ACTIONS(12819), 1,
      anon_sym_SEMI,
    ACTIONS(12821), 1,
      anon_sym_LBRACE,
    STATE(1760), 1,
      sym_compound_statement,
    STATE(1761), 1,
      sym_try_statement,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(9876), 1,
      aux_sym_declaration_repeat1,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [298676] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(6324), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7542), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11696), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_DASH_GT,
    ACTIONS(11698), 6,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [298708] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6726), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(6324), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7524), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11692), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_DASH_GT,
    ACTIONS(11694), 6,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [298740] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3623), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [298770] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10838), 1,
      anon_sym_requires,
    ACTIONS(11208), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8286), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [298804] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9116), 1,
      anon_sym_LPAREN2,
    ACTIONS(9130), 1,
      anon_sym_LBRACK,
    ACTIONS(10043), 1,
      anon_sym_STAR,
    ACTIONS(10045), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10047), 1,
      anon_sym_AMP,
    STATE(4464), 1,
      sym_parameter_list,
    STATE(7556), 1,
      sym__function_declarator_seq,
    STATE(8991), 1,
      sym__abstract_declarator,
    ACTIONS(9592), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
    STATE(7554), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [298844] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3623), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [298874] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12823), 1,
      sym_identifier,
    ACTIONS(12825), 1,
      sym_primitive_type,
    STATE(2739), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(3230), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(10990), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [298914] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3623), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [298944] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3623), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [298974] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12827), 1,
      sym_identifier,
    ACTIONS(12829), 1,
      sym_primitive_type,
    STATE(424), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8763), 1,
      sym__scope_resolution,
    STATE(779), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1039), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [299014] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(12423), 1,
      anon_sym_LBRACK,
    ACTIONS(12831), 1,
      anon_sym_COMMA,
    ACTIONS(12833), 1,
      anon_sym_EQ,
    STATE(7783), 1,
      sym_interface_requirements,
    STATE(7784), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 10,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [299048] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11641), 1,
      anon_sym_COLON,
    ACTIONS(11647), 1,
      anon_sym_LBRACK,
    ACTIONS(12837), 1,
      anon_sym___attribute,
    ACTIONS(12839), 1,
      anon_sym_EQ,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(8205), 1,
      sym__function_declarator_seq,
    STATE(9495), 1,
      sym_bitfield_clause,
    STATE(9496), 1,
      sym_initializer_list,
    STATE(8087), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(12835), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [299094] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10034), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10024), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [299120] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10841), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10823), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [299146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11318), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11262), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [299172] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12841), 1,
      anon_sym_COLON,
    ACTIONS(12844), 1,
      anon_sym_EQ,
    STATE(7872), 1,
      sym_interface_requirements,
    ACTIONS(12530), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [299200] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11892), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11653), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [299226] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12245), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(11828), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [299252] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12847), 1,
      anon_sym_where,
    STATE(7487), 1,
      sym_where_clause,
    ACTIONS(12542), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [299278] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8974), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11405), 1,
      anon_sym_requires,
    ACTIONS(11408), 1,
      anon_sym_where,
    STATE(7626), 1,
      sym_where_clause,
    STATE(7951), 1,
      sym_trailing_return_type,
    ACTIONS(11086), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8546), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [299318] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3623), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [299348] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11315), 1,
      anon_sym_requires,
    ACTIONS(11525), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11312), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8289), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [299382] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11889), 1,
      anon_sym_requires,
    ACTIONS(12566), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11886), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8295), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [299416] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12242), 1,
      anon_sym_requires,
    ACTIONS(12850), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(12239), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8296), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [299450] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12807), 1,
      sym_identifier,
    ACTIONS(12809), 1,
      sym_primitive_type,
    STATE(2717), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(2826), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(203), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [299490] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8974), 1,
      anon_sym_DASH_GT,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11563), 1,
      anon_sym_requires,
    ACTIONS(11566), 1,
      anon_sym_where,
    STATE(7617), 1,
      sym_where_clause,
    STATE(7952), 1,
      sym_trailing_return_type,
    ACTIONS(11371), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8547), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [299530] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12743), 1,
      sym_identifier,
    ACTIONS(12745), 1,
      sym_primitive_type,
    STATE(5224), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(5628), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8682), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [299570] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11321), 1,
      anon_sym_LBRACE,
    ACTIONS(11672), 1,
      anon_sym_try,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    ACTIONS(12853), 1,
      anon_sym_COLON,
    ACTIONS(12855), 1,
      anon_sym_SEMI,
    STATE(2166), 1,
      sym_compound_statement,
    STATE(2167), 1,
      sym_try_statement,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(9628), 1,
      aux_sym_declaration_repeat1,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [299620] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    STATE(7742), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(9621), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [299649] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12544), 1,
      anon_sym_LBRACK,
    ACTIONS(12857), 1,
      anon_sym_where,
    STATE(7605), 1,
      sym_where_clause,
    ACTIONS(12542), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [299676] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8586), 1,
      anon_sym_requires,
    ACTIONS(8588), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      sym_identifier,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8817), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [299711] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(7595), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(7388), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(12607), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(12609), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [299738] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10157), 1,
      anon_sym_STAR,
    ACTIONS(10159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10161), 1,
      anon_sym_AMP,
    STATE(4444), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9042), 1,
      sym__abstract_declarator,
    ACTIONS(9592), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [299777] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11129), 1,
      anon_sym_requires,
    ACTIONS(11132), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8367), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [299810] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    ACTIONS(12377), 1,
      anon_sym___attribute,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [299841] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8963), 1,
      anon_sym_DASH_GT,
    ACTIONS(11655), 1,
      sym_identifier,
    ACTIONS(12860), 1,
      anon_sym_requires,
    ACTIONS(12863), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    STATE(8142), 1,
      sym_trailing_return_type,
    ACTIONS(12662), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8605), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [299880] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8963), 1,
      anon_sym_DASH_GT,
    ACTIONS(8984), 1,
      anon_sym_requires,
    ACTIONS(8986), 1,
      anon_sym_where,
    ACTIONS(11655), 1,
      sym_identifier,
    STATE(7535), 1,
      sym_where_clause,
    STATE(8105), 1,
      sym_trailing_return_type,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9159), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [299919] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12331), 1,
      anon_sym___attribute,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [299950] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    ACTIONS(12367), 1,
      anon_sym___attribute,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [299981] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    ACTIONS(12407), 1,
      anon_sym___attribute,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [300012] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    ACTIONS(12415), 1,
      anon_sym___attribute,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [300043] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    ACTIONS(12429), 1,
      anon_sym___attribute,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [300074] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    ACTIONS(12443), 1,
      anon_sym___attribute,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [300105] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11647), 1,
      anon_sym_LBRACK,
    ACTIONS(12868), 1,
      anon_sym___attribute,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(8205), 1,
      sym__function_declarator_seq,
    STATE(8087), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(12866), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [300140] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(9181), 1,
      anon_sym_where,
    ACTIONS(11256), 1,
      anon_sym_requires,
    STATE(7537), 1,
      sym_where_clause,
    STATE(8121), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8898), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [300177] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    STATE(7742), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(10144), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [300206] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    ACTIONS(12450), 1,
      anon_sym___attribute,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [300237] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12377), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3755), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [300268] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12407), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3755), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [300299] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12415), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3755), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [300330] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12443), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3755), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [300361] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12331), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3755), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [300392] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12367), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3755), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [300423] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12429), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3755), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [300454] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12450), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3755), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [300485] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8586), 1,
      anon_sym_requires,
    ACTIONS(8588), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      sym_identifier,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8824), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [300520] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12872), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(7021), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(12870), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [300547] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8594), 1,
      anon_sym_where,
    ACTIONS(10031), 1,
      anon_sym_requires,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8616), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [300580] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12874), 1,
      sym_identifier,
    ACTIONS(12876), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(12878), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(12880), 1,
      aux_sym_preproc_elif_token1,
    STATE(8471), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8487), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8997), 1,
      sym_enumerator,
    ACTIONS(12882), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(11371), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(11383), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [300619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7798), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(7800), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [300642] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2406), 1,
      anon_sym_LT,
    STATE(7909), 1,
      sym_template_argument_list,
    ACTIONS(7783), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(7785), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [300669] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    STATE(7742), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(9847), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [300698] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(12048), 1,
      anon_sym_TILDE,
    ACTIONS(12764), 1,
      sym_identifier,
    ACTIONS(12769), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12771), 1,
      anon_sym_template,
    STATE(8154), 1,
      sym__scope_resolution,
    STATE(10592), 1,
      sym_operator_name,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(4608), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [300737] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(9181), 1,
      anon_sym_where,
    ACTIONS(11528), 1,
      anon_sym_requires,
    STATE(7465), 1,
      sym_where_clause,
    STATE(8145), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9002), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [300774] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    STATE(7742), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(9890), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [300803] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(12082), 1,
      anon_sym_TILDE,
    ACTIONS(12884), 1,
      sym_identifier,
    ACTIONS(12886), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12888), 1,
      anon_sym_template,
    STATE(8025), 1,
      sym__scope_resolution,
    STATE(10755), 1,
      sym_operator_name,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(3432), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [300842] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    STATE(7742), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(9918), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [300871] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8586), 1,
      anon_sym_requires,
    ACTIONS(8588), 1,
      anon_sym_where,
    ACTIONS(11655), 1,
      sym_identifier,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8826), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [300906] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6806), 1,
      anon_sym___attribute,
    ACTIONS(12890), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6808), 12,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [300931] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11647), 1,
      anon_sym_LBRACK,
    ACTIONS(12894), 1,
      anon_sym___attribute,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(8205), 1,
      sym__function_declarator_seq,
    STATE(8087), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(12892), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [300966] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7594), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(7021), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7596), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [300993] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8594), 1,
      anon_sym_where,
    ACTIONS(10838), 1,
      anon_sym_requires,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8617), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [301026] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym_LBRACK,
    ACTIONS(12831), 1,
      anon_sym_COMMA,
    ACTIONS(12896), 1,
      anon_sym_EQ,
    STATE(7786), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [301055] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym_LBRACK,
    ACTIONS(12831), 1,
      anon_sym_COMMA,
    STATE(7787), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 12,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [301082] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_LBRACK,
    ACTIONS(12831), 1,
      anon_sym_COMMA,
    STATE(7788), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 12,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [301109] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_LBRACK,
    ACTIONS(12831), 1,
      anon_sym_COMMA,
    STATE(7787), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 12,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [301136] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12532), 1,
      anon_sym_LBRACK,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
    STATE(7787), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 12,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [301163] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym_LBRACK,
    ACTIONS(12831), 1,
      anon_sym_COMMA,
    STATE(7787), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 12,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [301190] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym_LBRACK,
    ACTIONS(12831), 1,
      anon_sym_COMMA,
    STATE(7790), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 12,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [301217] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12540), 1,
      anon_sym_LBRACK,
    ACTIONS(12831), 1,
      anon_sym_COMMA,
    STATE(7787), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 12,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [301244] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8988), 1,
      anon_sym_DASH_GT,
    ACTIONS(9189), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(8078), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9055), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [301281] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8988), 1,
      anon_sym_DASH_GT,
    ACTIONS(9189), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(8079), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9063), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [301318] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8988), 1,
      anon_sym_DASH_GT,
    ACTIONS(9189), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    STATE(8080), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9071), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [301355] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8988), 1,
      anon_sym_DASH_GT,
    ACTIONS(9189), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    STATE(8082), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9076), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [301392] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11256), 1,
      anon_sym_requires,
    ACTIONS(11259), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8442), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [301425] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12901), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4482), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(7796), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7648), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_using,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [301452] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11647), 1,
      anon_sym_LBRACK,
    ACTIONS(12906), 1,
      anon_sym___attribute,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(8205), 1,
      sym__function_declarator_seq,
    STATE(8087), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(12904), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [301487] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8988), 1,
      anon_sym_DASH_GT,
    ACTIONS(11129), 1,
      anon_sym_requires,
    ACTIONS(11217), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(8136), 1,
      sym_trailing_return_type,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8708), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [301524] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8988), 1,
      anon_sym_DASH_GT,
    ACTIONS(11256), 1,
      anon_sym_requires,
    ACTIONS(11396), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(8137), 1,
      sym_trailing_return_type,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8709), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [301561] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8988), 1,
      anon_sym_DASH_GT,
    ACTIONS(11528), 1,
      anon_sym_requires,
    ACTIONS(11569), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    STATE(8139), 1,
      sym_trailing_return_type,
    ACTIONS(11312), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8710), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [301598] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8988), 1,
      anon_sym_DASH_GT,
    ACTIONS(12465), 1,
      anon_sym_requires,
    ACTIONS(12908), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    STATE(8140), 1,
      sym_trailing_return_type,
    ACTIONS(11886), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8711), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [301635] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8592), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8889), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [301668] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    STATE(7742), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(10008), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [301697] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    STATE(7742), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(9632), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [301726] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    STATE(7742), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(9932), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [301755] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    STATE(7742), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(9705), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [301784] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(9181), 1,
      anon_sym_where,
    ACTIONS(12465), 1,
      anon_sym_requires,
    STATE(7535), 1,
      sym_where_clause,
    STATE(8153), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9004), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [301821] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8594), 1,
      anon_sym_where,
    ACTIONS(11315), 1,
      anon_sym_requires,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8618), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [301854] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8594), 1,
      anon_sym_where,
    ACTIONS(11889), 1,
      anon_sym_requires,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8619), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [301887] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    STATE(7742), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(10851), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [301916] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8963), 1,
      anon_sym_DASH_GT,
    ACTIONS(8984), 1,
      anon_sym_requires,
    ACTIONS(8986), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      sym_identifier,
    STATE(7465), 1,
      sym_where_clause,
    STATE(8069), 1,
      sym_trailing_return_type,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9142), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [301955] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    STATE(7742), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(10129), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [301984] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2406), 1,
      anon_sym_LT,
    STATE(210), 1,
      sym_template_argument_list,
    ACTIONS(2222), 2,
      anon_sym_COLON,
      anon_sym___attribute,
    ACTIONS(2229), 10,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [302013] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    STATE(7742), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(10208), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [302042] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8594), 1,
      anon_sym_where,
    ACTIONS(12242), 1,
      anon_sym_requires,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8620), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [302075] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11528), 1,
      anon_sym_requires,
    ACTIONS(11531), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11312), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8500), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [302108] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym_LBRACK,
    ACTIONS(12773), 1,
      anon_sym_COMMA,
    ACTIONS(12911), 1,
      anon_sym_EQ,
    STATE(7950), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [302137] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12874), 1,
      sym_identifier,
    ACTIONS(12878), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(12880), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(12913), 1,
      aux_sym_preproc_if_token2,
    STATE(8371), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8376), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8997), 1,
      sym_enumerator,
    ACTIONS(12882), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(11602), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(11625), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [302176] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11830), 1,
      anon_sym_LBRACK,
    ACTIONS(12445), 1,
      anon_sym_where,
    STATE(7625), 1,
      sym_where_clause,
    ACTIONS(11828), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [302203] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12874), 1,
      sym_identifier,
    ACTIONS(12878), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(12880), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(12915), 1,
      aux_sym_preproc_if_token2,
    STATE(8329), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8377), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8997), 1,
      sym_enumerator,
    ACTIONS(12882), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(11311), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(11557), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [302242] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12465), 1,
      anon_sym_requires,
    ACTIONS(12642), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11886), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8420), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [302275] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8206), 1,
      anon_sym_where,
    STATE(7624), 1,
      sym_where_clause,
    ACTIONS(10026), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10024), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [302302] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    STATE(7742), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(9741), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [302331] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    STATE(7742), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(9766), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [302360] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12811), 1,
      anon_sym_requires,
    ACTIONS(12917), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(12239), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8365), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [302393] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12423), 1,
      anon_sym___attribute,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(12920), 1,
      anon_sym_COMMA,
    ACTIONS(12922), 1,
      anon_sym_EQ,
    STATE(7974), 1,
      sym_interface_requirements,
    STATE(7975), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [302426] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8963), 1,
      anon_sym_DASH_GT,
    ACTIONS(8984), 1,
      anon_sym_requires,
    ACTIONS(8986), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      sym_identifier,
    STATE(7549), 1,
      sym_where_clause,
    STATE(8149), 1,
      sym_trailing_return_type,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9170), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [302465] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10564), 1,
      anon_sym_where,
    STATE(7624), 1,
      sym_where_clause,
    ACTIONS(10024), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [302492] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    STATE(7742), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(9696), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [302521] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8586), 1,
      anon_sym_requires,
    ACTIONS(8588), 1,
      anon_sym_where,
    ACTIONS(11830), 1,
      sym_identifier,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8827), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [302556] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8963), 1,
      anon_sym_DASH_GT,
    ACTIONS(10026), 1,
      sym_identifier,
    ACTIONS(11225), 1,
      anon_sym_requires,
    ACTIONS(11228), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(8016), 1,
      sym_trailing_return_type,
    ACTIONS(11098), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8770), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [302595] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10197), 1,
      anon_sym_STAR,
    ACTIONS(10199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10201), 1,
      anon_sym_AMP,
    STATE(4503), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9198), 1,
      sym__abstract_declarator,
    ACTIONS(9592), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [302634] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8592), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8892), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [302667] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12874), 1,
      sym_identifier,
    ACTIONS(12878), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(12880), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(12924), 1,
      aux_sym_preproc_if_token2,
    STATE(8383), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8393), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8997), 1,
      sym_enumerator,
    ACTIONS(12882), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(11335), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(11353), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [302706] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(12082), 1,
      anon_sym_TILDE,
    ACTIONS(12884), 1,
      sym_identifier,
    ACTIONS(12926), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12928), 1,
      anon_sym_template,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(10505), 1,
      sym_operator_name,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(3432), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [302745] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    STATE(7742), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(11206), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [302774] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(12930), 1,
      anon_sym_COMMA,
    ACTIONS(12932), 1,
      anon_sym_EQ,
    STATE(7918), 1,
      sym_interface_requirements,
    STATE(7919), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12423), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12419), 8,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_GT2,
      anon_sym_try,
  [302807] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8206), 1,
      anon_sym_where,
    STATE(7626), 1,
      sym_where_clause,
    ACTIONS(10825), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10823), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [302834] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3676), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [302863] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3676), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [302892] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3676), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [302921] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3676), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [302950] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3676), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [302979] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3676), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [303008] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3676), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [303037] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3676), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [303066] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12532), 1,
      anon_sym_LBRACK,
    ACTIONS(12560), 1,
      anon_sym_COLON,
    ACTIONS(12934), 1,
      anon_sym_EQ,
    STATE(7906), 1,
      sym_interface_requirements,
    ACTIONS(12530), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [303095] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8206), 1,
      anon_sym_where,
    STATE(7617), 1,
      sym_where_clause,
    ACTIONS(11264), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11262), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [303122] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8206), 1,
      anon_sym_where,
    STATE(7608), 1,
      sym_where_clause,
    ACTIONS(11655), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11653), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [303149] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10026), 1,
      sym_identifier,
    ACTIONS(11101), 1,
      anon_sym_requires,
    ACTIONS(11104), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(11098), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8417), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [303184] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6781), 1,
      anon_sym___attribute,
    ACTIONS(12890), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(12936), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(6783), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [303211] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11399), 1,
      anon_sym_where,
    STATE(7617), 1,
      sym_where_clause,
    ACTIONS(11262), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [303238] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8206), 1,
      anon_sym_where,
    STATE(7625), 1,
      sym_where_clause,
    ACTIONS(11830), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11828), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [303265] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11647), 1,
      anon_sym_LBRACK,
    ACTIONS(12940), 1,
      anon_sym___attribute,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(8205), 1,
      sym__function_declarator_seq,
    STATE(8087), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(12938), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [303300] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8206), 1,
      anon_sym_where,
    STATE(7605), 1,
      sym_where_clause,
    ACTIONS(12544), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12542), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [303327] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(9174), 1,
      anon_sym_DASH_GT,
    ACTIONS(9176), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(8107), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9184), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [303364] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(9174), 1,
      anon_sym_DASH_GT,
    ACTIONS(9176), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(8109), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9185), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [303401] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(9174), 1,
      anon_sym_DASH_GT,
    ACTIONS(9176), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    STATE(8110), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9186), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [303438] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(9174), 1,
      anon_sym_DASH_GT,
    ACTIONS(9176), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    STATE(8111), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9188), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [303475] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9174), 1,
      anon_sym_DASH_GT,
    ACTIONS(11152), 1,
      anon_sym_requires,
    ACTIONS(11214), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    STATE(8114), 1,
      sym_trailing_return_type,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [303512] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9174), 1,
      anon_sym_DASH_GT,
    ACTIONS(11365), 1,
      anon_sym_requires,
    ACTIONS(11393), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(8115), 1,
      sym_trailing_return_type,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8715), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [303549] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9174), 1,
      anon_sym_DASH_GT,
    ACTIONS(11551), 1,
      anon_sym_requires,
    ACTIONS(11578), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    STATE(8116), 1,
      sym_trailing_return_type,
    ACTIONS(11312), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8716), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [303586] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9174), 1,
      anon_sym_DASH_GT,
    ACTIONS(12471), 1,
      anon_sym_requires,
    ACTIONS(12942), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    STATE(8117), 1,
      sym_trailing_return_type,
    ACTIONS(11886), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8717), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [303623] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11647), 1,
      anon_sym_LBRACK,
    ACTIONS(12947), 1,
      anon_sym___attribute,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(8205), 1,
      sym__function_declarator_seq,
    STATE(8087), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(12945), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [303658] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8963), 1,
      anon_sym_DASH_GT,
    ACTIONS(10825), 1,
      sym_identifier,
    ACTIONS(11387), 1,
      anon_sym_requires,
    ACTIONS(11390), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    STATE(8045), 1,
      sym_trailing_return_type,
    ACTIONS(11281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8626), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [303697] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    STATE(7742), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(11589), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [303726] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12532), 1,
      anon_sym_LBRACK,
    ACTIONS(12560), 1,
      anon_sym_COLON,
    ACTIONS(12949), 1,
      anon_sym_EQ,
    STATE(7958), 1,
      sym_interface_requirements,
    ACTIONS(12530), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [303755] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(12006), 1,
      anon_sym_TILDE,
    ACTIONS(12952), 1,
      sym_identifier,
    ACTIONS(12954), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12956), 1,
      anon_sym_template,
    STATE(8021), 1,
      sym__scope_resolution,
    STATE(10606), 1,
      sym_operator_name,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(4718), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [303794] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8552), 1,
      anon_sym_DASH_GT,
    ACTIONS(9181), 1,
      anon_sym_where,
    ACTIONS(11129), 1,
      anon_sym_requires,
    STATE(7549), 1,
      sym_where_clause,
    STATE(8099), 1,
      sym_trailing_return_type,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9000), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [303831] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8586), 1,
      anon_sym_requires,
    ACTIONS(8588), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      sym_identifier,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8821), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [303866] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10825), 1,
      sym_identifier,
    ACTIONS(11284), 1,
      anon_sym_requires,
    ACTIONS(11287), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(11281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8418), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [303901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12958), 1,
      anon_sym_EQ,
    ACTIONS(12621), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [303924] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8963), 1,
      anon_sym_DASH_GT,
    ACTIONS(8984), 1,
      anon_sym_requires,
    ACTIONS(8986), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      sym_identifier,
    STATE(7537), 1,
      sym_where_clause,
    STATE(8057), 1,
      sym_trailing_return_type,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9067), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [303963] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11107), 1,
      anon_sym_where,
    STATE(7626), 1,
      sym_where_clause,
    ACTIONS(10823), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [303990] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    STATE(7742), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(11061), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [304019] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8963), 1,
      anon_sym_DASH_GT,
    ACTIONS(11264), 1,
      sym_identifier,
    ACTIONS(11572), 1,
      anon_sym_requires,
    ACTIONS(11575), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    STATE(8072), 1,
      sym_trailing_return_type,
    ACTIONS(11542), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8732), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [304058] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    STATE(7742), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(11237), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [304087] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    STATE(7742), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(11389), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [304116] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8592), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8843), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [304149] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(10149), 1,
      anon_sym_STAR,
    ACTIONS(10151), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10153), 1,
      anon_sym_AMP,
    STATE(4330), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9148), 1,
      sym__abstract_declarator,
    ACTIONS(9592), 2,
      anon_sym_COMMA,
      sym_identifier,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [304188] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    STATE(7742), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(11530), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [304217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7995), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(7997), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [304240] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11264), 1,
      sym_identifier,
    ACTIONS(11545), 1,
      anon_sym_requires,
    ACTIONS(11548), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11542), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8419), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [304275] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11655), 1,
      sym_identifier,
    ACTIONS(12665), 1,
      anon_sym_requires,
    ACTIONS(12668), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(12662), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8504), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [304310] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8592), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8828), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [304343] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11830), 1,
      sym_identifier,
    ACTIONS(12964), 1,
      anon_sym_requires,
    ACTIONS(12967), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(12961), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8421), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [304378] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11655), 1,
      anon_sym_LBRACK,
    ACTIONS(11979), 1,
      anon_sym_where,
    STATE(7608), 1,
      sym_where_clause,
    ACTIONS(11653), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [304405] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(8592), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8807), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [304438] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    STATE(7742), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(9644), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [304467] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12544), 1,
      anon_sym___attribute,
    ACTIONS(12970), 1,
      anon_sym_where,
    STATE(7487), 1,
      sym_where_clause,
    ACTIONS(12542), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [304493] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12532), 1,
      anon_sym_LBRACK,
    ACTIONS(12973), 1,
      anon_sym_COMMA,
    STATE(7891), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [304519] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9951), 1,
      anon_sym_LBRACE,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5713), 1,
      sym_enumerator_list,
    STATE(8636), 1,
      sym__scope_resolution,
    ACTIONS(12976), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5732), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [304559] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6963), 1,
      anon_sym_LBRACE,
    ACTIONS(11445), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2832), 1,
      sym_enumerator_list,
    STATE(8769), 1,
      sym__scope_resolution,
    ACTIONS(12978), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2943), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [304599] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8100), 1,
      anon_sym_LBRACE,
    ACTIONS(10875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11437), 1,
      sym_identifier,
    STATE(3528), 1,
      sym_template_type,
    STATE(3621), 1,
      sym_enumerator_list,
    STATE(8655), 1,
      sym__scope_resolution,
    ACTIONS(12980), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3524), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [304639] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12560), 1,
      anon_sym_COLON,
    ACTIONS(12982), 1,
      anon_sym_EQ,
    STATE(8075), 1,
      sym_interface_requirements,
    ACTIONS(12532), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12530), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_GT2,
      anon_sym_try,
  [304667] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      anon_sym_LBRACE,
    ACTIONS(7330), 1,
      anon_sym_LBRACK,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    ACTIONS(12987), 1,
      anon_sym_SEMI,
    ACTIONS(12989), 1,
      anon_sym_EQ,
    ACTIONS(12991), 1,
      anon_sym_try,
    STATE(519), 1,
      sym_compound_statement,
    STATE(10482), 1,
      sym_field_initializer_list,
    ACTIONS(6761), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(570), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [304705] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9183), 1,
      anon_sym_requires,
    ACTIONS(9185), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    STATE(7617), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8905), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [304739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 1,
      sym_identifier,
    ACTIONS(7313), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [304761] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7330), 1,
      anon_sym_LBRACK,
    ACTIONS(11321), 1,
      anon_sym_LBRACE,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    ACTIONS(12993), 1,
      anon_sym_SEMI,
    ACTIONS(12995), 1,
      anon_sym_EQ,
    ACTIONS(12997), 1,
      anon_sym_try,
    STATE(2062), 1,
      sym_compound_statement,
    STATE(10742), 1,
      sym_field_initializer_list,
    ACTIONS(6761), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2063), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [304799] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(13001), 1,
      anon_sym___attribute,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(12999), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [304833] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(13005), 1,
      anon_sym___attribute,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(13003), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [304867] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(13007), 1,
      anon_sym_COMMA,
    ACTIONS(13009), 1,
      anon_sym_EQ,
    STATE(8303), 1,
      sym_interface_requirements,
    STATE(8460), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [304897] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9183), 1,
      anon_sym_requires,
    ACTIONS(9185), 1,
      anon_sym_where,
    ACTIONS(11655), 1,
      anon_sym_LBRACK,
    STATE(7608), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8917), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [304931] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7502), 1,
      anon_sym_LBRACK,
    ACTIONS(7570), 1,
      anon_sym___attribute,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    STATE(3274), 1,
      sym_parameter_list,
    STATE(8026), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7572), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_try,
  [304963] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7330), 1,
      anon_sym_LBRACK,
    ACTIONS(12821), 1,
      anon_sym_LBRACE,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    ACTIONS(13011), 1,
      anon_sym_SEMI,
    ACTIONS(13013), 1,
      anon_sym_EQ,
    ACTIONS(13015), 1,
      anon_sym_try,
    STATE(1733), 1,
      sym_compound_statement,
    STATE(10726), 1,
      sym_field_initializer_list,
    ACTIONS(6761), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1735), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [305001] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12623), 1,
      anon_sym_LBRACK,
    ACTIONS(13017), 1,
      anon_sym_EQ,
    ACTIONS(12621), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [305025] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11790), 1,
      sym_identifier,
    ACTIONS(11792), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(8542), 1,
      sym_access_specifier,
    STATE(8741), 1,
      sym__scope_resolution,
    STATE(9303), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(12499), 3,
      anon_sym_private,
      anon_sym_public,
      anon_sym_protected,
  [305063] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8067), 1,
      anon_sym_LBRACE,
    ACTIONS(10904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11450), 1,
      sym_identifier,
    STATE(3502), 1,
      sym_template_type,
    STATE(3575), 1,
      sym_enumerator_list,
    STATE(8746), 1,
      sym__scope_resolution,
    ACTIONS(13019), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3487), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [305103] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2255), 3,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2245), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [305127] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11790), 1,
      sym_identifier,
    ACTIONS(11792), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(8562), 1,
      sym_access_specifier,
    STATE(8741), 1,
      sym__scope_resolution,
    STATE(9482), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(12499), 3,
      anon_sym_private,
      anon_sym_public,
      anon_sym_protected,
  [305165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7418), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(7416), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [305187] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(10718), 1,
      anon_sym_where,
    STATE(7624), 1,
      sym_where_clause,
    ACTIONS(10024), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [305213] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11193), 1,
      anon_sym_where,
    STATE(7626), 1,
      sym_where_clause,
    ACTIONS(10823), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [305239] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11455), 1,
      anon_sym_where,
    STATE(7617), 1,
      sym_where_clause,
    ACTIONS(11262), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [305265] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11655), 1,
      anon_sym_LBRACK,
    ACTIONS(12067), 1,
      anon_sym_where,
    STATE(7608), 1,
      sym_where_clause,
    ACTIONS(11653), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [305291] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11830), 1,
      anon_sym_LBRACK,
    ACTIONS(12600), 1,
      anon_sym_where,
    STATE(7625), 1,
      sym_where_clause,
    ACTIONS(11828), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [305317] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12544), 1,
      anon_sym_LBRACK,
    ACTIONS(13021), 1,
      anon_sym_where,
    STATE(7605), 1,
      sym_where_clause,
    ACTIONS(12542), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [305343] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12930), 1,
      anon_sym_COMMA,
    ACTIONS(13024), 1,
      anon_sym_EQ,
    STATE(7922), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12519), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12517), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_GT2,
      anon_sym_try,
  [305371] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12930), 1,
      anon_sym_COMMA,
    STATE(7923), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12519), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12517), 10,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [305397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 1,
      sym_identifier,
    ACTIONS(7160), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [305419] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12930), 1,
      anon_sym_COMMA,
    STATE(7929), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12525), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12523), 10,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [305445] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12930), 1,
      anon_sym_COMMA,
    STATE(7923), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12525), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12523), 10,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [305471] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13026), 1,
      anon_sym_COMMA,
    STATE(7923), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12532), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12530), 10,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [305497] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10037), 1,
      anon_sym_LBRACE,
    ACTIONS(11419), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5607), 1,
      sym_enumerator_list,
    STATE(8601), 1,
      sym__scope_resolution,
    ACTIONS(13029), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(6189), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [305537] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9183), 1,
      anon_sym_requires,
    ACTIONS(9185), 1,
      anon_sym_where,
    ACTIONS(11830), 1,
      anon_sym_LBRACK,
    STATE(7625), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8925), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [305571] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9951), 1,
      anon_sym_LBRACE,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5713), 1,
      sym_enumerator_list,
    STATE(8635), 1,
      sym__scope_resolution,
    ACTIONS(13031), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5344), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [305611] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(7330), 1,
      anon_sym_LBRACK,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    ACTIONS(13033), 1,
      anon_sym_SEMI,
    ACTIONS(13035), 1,
      anon_sym_EQ,
    ACTIONS(13037), 1,
      anon_sym_try,
    STATE(1005), 1,
      sym_compound_statement,
    STATE(10342), 1,
      sym_field_initializer_list,
    ACTIONS(6761), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1006), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [305649] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym_LBRACK,
    ACTIONS(12773), 1,
      anon_sym_COMMA,
    STATE(7891), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [305675] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12930), 1,
      anon_sym_COMMA,
    STATE(7923), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12536), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12534), 10,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [305701] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12930), 1,
      anon_sym_COMMA,
    STATE(7935), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12536), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12534), 10,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [305727] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym_LBRACK,
    ACTIONS(12773), 1,
      anon_sym_COMMA,
    STATE(7959), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [305753] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(7414), 1,
      anon_sym_LBRACE,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11421), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3224), 1,
      sym_enumerator_list,
    STATE(8677), 1,
      sym__scope_resolution,
    ACTIONS(13039), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4819), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [305793] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11790), 1,
      sym_identifier,
    ACTIONS(11792), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(8525), 1,
      sym_access_specifier,
    STATE(8741), 1,
      sym__scope_resolution,
    STATE(9304), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(12499), 3,
      anon_sym_private,
      anon_sym_public,
      anon_sym_protected,
  [305831] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1093), 1,
      anon_sym_LBRACE,
    ACTIONS(7330), 1,
      anon_sym_LBRACK,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    ACTIONS(13041), 1,
      anon_sym_SEMI,
    ACTIONS(13043), 1,
      anon_sym_EQ,
    ACTIONS(13045), 1,
      anon_sym_try,
    STATE(895), 1,
      sym_compound_statement,
    STATE(10373), 1,
      sym_field_initializer_list,
    ACTIONS(6761), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(896), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [305869] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12930), 1,
      anon_sym_COMMA,
    STATE(7923), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12540), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12538), 10,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [305895] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(7330), 1,
      anon_sym_LBRACK,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    ACTIONS(13035), 1,
      anon_sym_EQ,
    ACTIONS(13037), 1,
      anon_sym_try,
    ACTIONS(13047), 1,
      anon_sym_SEMI,
    STATE(1011), 1,
      sym_compound_statement,
    STATE(10691), 1,
      sym_field_initializer_list,
    ACTIONS(6761), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1012), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [305933] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(3484), 1,
      anon_sym_LBRACE,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11441), 1,
      sym_identifier,
    STATE(398), 1,
      sym_template_type,
    STATE(708), 1,
      sym_enumerator_list,
    STATE(8763), 1,
      sym__scope_resolution,
    ACTIONS(13049), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(409), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [305973] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6963), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    STATE(2729), 1,
      sym_template_type,
    STATE(2832), 1,
      sym_enumerator_list,
    STATE(8606), 1,
      sym__scope_resolution,
    ACTIONS(13051), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3207), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [306013] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(11231), 1,
      anon_sym_requires,
    ACTIONS(11234), 1,
      anon_sym_where,
    STATE(7624), 1,
      sym_where_clause,
    ACTIONS(10426), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8545), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [306047] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(3516), 1,
      anon_sym_LBRACE,
    ACTIONS(11166), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(644), 1,
      sym_enumerator_list,
    STATE(8640), 1,
      sym__scope_resolution,
    ACTIONS(13053), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(419), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [306087] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10037), 1,
      anon_sym_LBRACE,
    ACTIONS(11415), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5607), 1,
      sym_enumerator_list,
    STATE(8644), 1,
      sym__scope_resolution,
    ACTIONS(13055), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5430), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [306127] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym_LBRACK,
    ACTIONS(12773), 1,
      anon_sym_COMMA,
    STATE(7891), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [306153] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(3516), 1,
      anon_sym_LBRACE,
    ACTIONS(11429), 1,
      sym_identifier,
    ACTIONS(11431), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(6378), 1,
      sym_enumerator_list,
    STATE(8684), 1,
      sym__scope_resolution,
    ACTIONS(13057), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(8119), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [306193] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(13061), 1,
      anon_sym___attribute,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(13059), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [306227] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10037), 1,
      anon_sym_LBRACE,
    ACTIONS(11427), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5607), 1,
      sym_enumerator_list,
    STATE(8679), 1,
      sym__scope_resolution,
    ACTIONS(13063), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(6118), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [306267] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9183), 1,
      anon_sym_requires,
    ACTIONS(9185), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    STATE(7624), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9006), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [306301] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    ACTIONS(10930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11443), 1,
      sym_identifier,
    STATE(4522), 1,
      sym_template_type,
    STATE(4900), 1,
      sym_enumerator_list,
    STATE(8723), 1,
      sym__scope_resolution,
    ACTIONS(13065), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4565), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [306341] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12423), 1,
      anon_sym___attribute,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(13067), 1,
      anon_sym_COMMA,
    ACTIONS(13069), 1,
      anon_sym_EQ,
    STATE(8083), 1,
      sym_interface_requirements,
    STATE(8251), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 8,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [306373] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(13071), 1,
      anon_sym_COMMA,
    ACTIONS(13073), 1,
      anon_sym_EQ,
    STATE(8210), 1,
      sym_interface_requirements,
    STATE(8214), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 9,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [306403] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_LBRACK,
    ACTIONS(12773), 1,
      anon_sym_COMMA,
    STATE(7891), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [306429] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11563), 1,
      anon_sym_requires,
    ACTIONS(11566), 1,
      anon_sym_where,
    STATE(7617), 1,
      sym_where_clause,
    ACTIONS(11371), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8547), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [306463] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11655), 1,
      anon_sym_LBRACK,
    ACTIONS(12677), 1,
      anon_sym_requires,
    ACTIONS(12680), 1,
      anon_sym_where,
    STATE(7608), 1,
      sym_where_clause,
    ACTIONS(11657), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8548), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [306497] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11830), 1,
      anon_sym_LBRACK,
    ACTIONS(13075), 1,
      anon_sym_requires,
    ACTIONS(13078), 1,
      anon_sym_where,
    STATE(7625), 1,
      sym_where_clause,
    ACTIONS(11877), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8549), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [306531] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7502), 1,
      anon_sym_LBRACK,
    ACTIONS(7554), 1,
      anon_sym___attribute,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    STATE(3274), 1,
      sym_parameter_list,
    STATE(8026), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7556), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_try,
  [306563] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(3516), 1,
      anon_sym_LBRACE,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(6378), 1,
      sym_enumerator_list,
    STATE(8636), 1,
      sym__scope_resolution,
    ACTIONS(13081), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(6089), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [306603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7288), 1,
      sym_identifier,
    ACTIONS(7290), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [306625] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(7414), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(6516), 1,
      sym_enumerator_list,
    STATE(8666), 1,
      sym__scope_resolution,
    ACTIONS(13083), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(6224), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [306665] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12623), 1,
      anon_sym_LBRACK,
    ACTIONS(13085), 1,
      anon_sym_EQ,
    ACTIONS(12621), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [306689] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12540), 1,
      anon_sym_LBRACK,
    ACTIONS(12773), 1,
      anon_sym_COMMA,
    STATE(7891), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [306715] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(7384), 1,
      anon_sym_LBRACE,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11439), 1,
      sym_identifier,
    STATE(3103), 1,
      sym_template_type,
    STATE(3151), 1,
      sym_enumerator_list,
    STATE(8689), 1,
      sym__scope_resolution,
    ACTIONS(13088), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3263), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [306755] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7502), 1,
      anon_sym_LBRACK,
    ACTIONS(7558), 1,
      anon_sym___attribute,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    STATE(3274), 1,
      sym_parameter_list,
    STATE(8026), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7560), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_try,
  [306787] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10037), 1,
      anon_sym_LBRACE,
    ACTIONS(11411), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(6481), 1,
      sym_enumerator_list,
    STATE(8731), 1,
      sym__scope_resolution,
    ACTIONS(13090), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(6235), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [306827] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7330), 1,
      anon_sym_LBRACK,
    ACTIONS(11321), 1,
      anon_sym_LBRACE,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    ACTIONS(12995), 1,
      anon_sym_EQ,
    ACTIONS(12997), 1,
      anon_sym_try,
    ACTIONS(13092), 1,
      anon_sym_SEMI,
    STATE(2097), 1,
      sym_compound_statement,
    STATE(10519), 1,
      sym_field_initializer_list,
    ACTIONS(6761), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2098), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [306865] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7330), 1,
      anon_sym_LBRACK,
    ACTIONS(12821), 1,
      anon_sym_LBRACE,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    ACTIONS(13013), 1,
      anon_sym_EQ,
    ACTIONS(13015), 1,
      anon_sym_try,
    ACTIONS(13094), 1,
      anon_sym_SEMI,
    STATE(1764), 1,
      sym_compound_statement,
    STATE(10506), 1,
      sym_field_initializer_list,
    ACTIONS(6761), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1766), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [306903] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12423), 1,
      anon_sym___attribute,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(13096), 1,
      anon_sym_COMMA,
    ACTIONS(13098), 1,
      anon_sym_EQ,
    STATE(8076), 1,
      sym_interface_requirements,
    STATE(8233), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 8,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [306935] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(9478), 1,
      anon_sym_LBRACE,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11413), 1,
      sym_identifier,
    STATE(4999), 1,
      sym_template_type,
    STATE(5151), 1,
      sym_enumerator_list,
    STATE(8676), 1,
      sym__scope_resolution,
    ACTIONS(13100), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4994), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [306975] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(13102), 1,
      anon_sym_COLON,
    ACTIONS(13104), 1,
      anon_sym_SEMI,
    ACTIONS(13106), 1,
      anon_sym_EQ,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(9645), 1,
      aux_sym_declaration_repeat1,
    STATE(10881), 1,
      sym_initializer_list,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [307019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7150), 1,
      sym_identifier,
    ACTIONS(7152), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [307041] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1093), 1,
      anon_sym_LBRACE,
    ACTIONS(7330), 1,
      anon_sym_LBRACK,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    ACTIONS(13043), 1,
      anon_sym_EQ,
    ACTIONS(13045), 1,
      anon_sym_try,
    ACTIONS(13108), 1,
      anon_sym_SEMI,
    STATE(936), 1,
      sym_compound_statement,
    STATE(10520), 1,
      sym_field_initializer_list,
    ACTIONS(6761), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(937), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [307079] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6963), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    STATE(2729), 1,
      sym_template_type,
    STATE(2832), 1,
      sym_enumerator_list,
    STATE(8606), 1,
      sym__scope_resolution,
    ACTIONS(13110), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3371), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [307119] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      anon_sym_LBRACE,
    ACTIONS(7330), 1,
      anon_sym_LBRACK,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    ACTIONS(12989), 1,
      anon_sym_EQ,
    ACTIONS(12991), 1,
      anon_sym_try,
    ACTIONS(13112), 1,
      anon_sym_SEMI,
    STATE(533), 1,
      sym_compound_statement,
    STATE(10409), 1,
      sym_field_initializer_list,
    ACTIONS(6761), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(534), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [307157] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11790), 1,
      sym_identifier,
    ACTIONS(11792), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(8506), 1,
      sym_access_specifier,
    STATE(8741), 1,
      sym__scope_resolution,
    STATE(9358), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(12499), 3,
      anon_sym_private,
      anon_sym_public,
      anon_sym_protected,
  [307195] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7502), 1,
      anon_sym_LBRACK,
    ACTIONS(7585), 1,
      anon_sym___attribute,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    STATE(3274), 1,
      sym_parameter_list,
    STATE(8026), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7587), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_try,
  [307227] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym___attribute,
    ACTIONS(12920), 1,
      anon_sym_COMMA,
    ACTIONS(13114), 1,
      anon_sym_EQ,
    STATE(7978), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 10,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [307255] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym___attribute,
    ACTIONS(12920), 1,
      anon_sym_COMMA,
    STATE(7986), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [307281] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12532), 1,
      anon_sym___attribute,
    ACTIONS(12841), 1,
      anon_sym_COLON,
    ACTIONS(13116), 1,
      anon_sym_EQ,
    STATE(8148), 1,
      sym_interface_requirements,
    ACTIONS(12530), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [307309] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym___attribute,
    ACTIONS(12920), 1,
      anon_sym_COMMA,
    STATE(7988), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [307335] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym___attribute,
    ACTIONS(12920), 1,
      anon_sym_COMMA,
    STATE(7986), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [307361] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7494), 1,
      anon_sym___attribute,
    ACTIONS(7502), 1,
      anon_sym_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    STATE(3274), 1,
      sym_parameter_list,
    STATE(8026), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7496), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_try,
  [307393] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10026), 1,
      anon_sym___attribute,
    ACTIONS(10899), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10024), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [307419] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10825), 1,
      anon_sym___attribute,
    ACTIONS(11211), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10823), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [307445] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11264), 1,
      anon_sym___attribute,
    ACTIONS(11514), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11262), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [307471] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11655), 1,
      anon_sym___attribute,
    ACTIONS(12262), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11653), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [307497] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11830), 1,
      anon_sym___attribute,
    ACTIONS(12557), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(11828), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [307523] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7330), 1,
      anon_sym_LBRACK,
    ACTIONS(12711), 1,
      anon_sym_LBRACE,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    ACTIONS(13119), 1,
      anon_sym_SEMI,
    ACTIONS(13121), 1,
      anon_sym_EQ,
    ACTIONS(13123), 1,
      anon_sym_try,
    STATE(2228), 1,
      sym_compound_statement,
    STATE(10462), 1,
      sym_field_initializer_list,
    ACTIONS(6761), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2229), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [307561] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12532), 1,
      anon_sym___attribute,
    ACTIONS(13125), 1,
      anon_sym_COMMA,
    STATE(7986), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [307587] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2406), 1,
      anon_sym_LT,
    STATE(210), 1,
      sym_template_argument_list,
    STATE(5812), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(9919), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2176), 6,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [307617] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym___attribute,
    ACTIONS(12920), 1,
      anon_sym_COMMA,
    STATE(7986), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [307643] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8191), 1,
      anon_sym_LBRACE,
    ACTIONS(11053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11435), 1,
      sym_identifier,
    STATE(3571), 1,
      sym_template_type,
    STATE(3723), 1,
      sym_enumerator_list,
    STATE(8630), 1,
      sym__scope_resolution,
    ACTIONS(13128), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3587), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [307683] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym___attribute,
    ACTIONS(12920), 1,
      anon_sym_COMMA,
    STATE(8001), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [307709] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13130), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(13132), 1,
      anon_sym_AMP_AMP,
    ACTIONS(13134), 1,
      anon_sym_or,
    ACTIONS(13136), 1,
      anon_sym_and,
    ACTIONS(6781), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6783), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [307739] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(917), 1,
      anon_sym_LBRACE,
    ACTIONS(7330), 1,
      anon_sym_LBRACK,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    ACTIONS(13138), 1,
      anon_sym_SEMI,
    ACTIONS(13140), 1,
      anon_sym_EQ,
    ACTIONS(13142), 1,
      anon_sym_try,
    STATE(887), 1,
      sym_compound_statement,
    STATE(10360), 1,
      sym_field_initializer_list,
    ACTIONS(6761), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(894), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [307777] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(7414), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3224), 1,
      sym_enumerator_list,
    STATE(8666), 1,
      sym__scope_resolution,
    ACTIONS(13144), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(6112), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [307817] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6963), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2832), 1,
      sym_enumerator_list,
    STATE(8754), 1,
      sym__scope_resolution,
    ACTIONS(13146), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2917), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [307857] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7330), 1,
      anon_sym_LBRACK,
    ACTIONS(12711), 1,
      anon_sym_LBRACE,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    ACTIONS(13121), 1,
      anon_sym_EQ,
    ACTIONS(13123), 1,
      anon_sym_try,
    ACTIONS(13148), 1,
      anon_sym_SEMI,
    STATE(2244), 1,
      sym_compound_statement,
    STATE(10628), 1,
      sym_field_initializer_list,
    ACTIONS(6761), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2245), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [307895] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13132), 1,
      anon_sym_AMP_AMP,
    ACTIONS(13136), 1,
      anon_sym_and,
    ACTIONS(6806), 6,
      anon_sym_or,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
    ACTIONS(6808), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [307921] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(7384), 1,
      anon_sym_LBRACE,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11439), 1,
      sym_identifier,
    STATE(3103), 1,
      sym_template_type,
    STATE(3151), 1,
      sym_enumerator_list,
    STATE(8689), 1,
      sym__scope_resolution,
    ACTIONS(13150), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3378), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [307961] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(13154), 1,
      anon_sym___attribute,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(13152), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [307995] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(917), 1,
      anon_sym_LBRACE,
    ACTIONS(7330), 1,
      anon_sym_LBRACK,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    ACTIONS(13140), 1,
      anon_sym_EQ,
    ACTIONS(13142), 1,
      anon_sym_try,
    ACTIONS(13156), 1,
      anon_sym_SEMI,
    STATE(1093), 1,
      sym_compound_statement,
    STATE(10608), 1,
      sym_field_initializer_list,
    ACTIONS(6761), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1094), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [308033] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(13160), 1,
      anon_sym___attribute,
    STATE(3590), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(13158), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [308067] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12540), 1,
      anon_sym___attribute,
    ACTIONS(12920), 1,
      anon_sym_COMMA,
    STATE(7986), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [308093] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_LBRACK,
    ACTIONS(12773), 1,
      anon_sym_COMMA,
    STATE(7928), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [308119] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13164), 1,
      anon_sym_COLON,
    STATE(8161), 1,
      sym_semantics,
    ACTIONS(13167), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(13162), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [308145] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9183), 1,
      anon_sym_requires,
    ACTIONS(9185), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    STATE(7626), 1,
      sym_where_clause,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9022), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [308179] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11405), 1,
      anon_sym_requires,
    ACTIONS(11408), 1,
      anon_sym_where,
    STATE(7626), 1,
      sym_where_clause,
    ACTIONS(11086), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7451), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8546), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [308213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13171), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(13169), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [308234] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12415), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4172), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [308263] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8172), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(11828), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [308286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8172), 1,
      anon_sym_where,
    STATE(7487), 1,
      sym_where_clause,
    ACTIONS(12542), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [308309] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(13173), 1,
      sym_identifier,
    ACTIONS(13175), 1,
      anon_sym_COLON_COLON,
    STATE(8163), 1,
      sym__scope_resolution,
    STATE(9852), 1,
      sym_field_initializer,
    STATE(10655), 1,
      sym_operator_name,
    STATE(9444), 2,
      sym_template_method,
      sym_qualified_field_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [308346] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3800), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [308373] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12443), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4172), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [308402] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3800), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [308429] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(7330), 1,
      anon_sym_LBRACK,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    ACTIONS(13035), 1,
      anon_sym_EQ,
    ACTIONS(13037), 1,
      anon_sym_try,
    STATE(1005), 1,
      sym_compound_statement,
    STATE(10342), 1,
      sym_field_initializer_list,
    ACTIONS(6761), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1006), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [308464] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13183), 1,
      anon_sym_RBRACE,
    ACTIONS(13181), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10334), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(11067), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(8412), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [308497] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10825), 1,
      sym_identifier,
    ACTIONS(11387), 1,
      anon_sym_requires,
    ACTIONS(11390), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(11281), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8626), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [308530] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13185), 1,
      anon_sym_RBRACE,
    ACTIONS(13181), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10391), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(11019), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(8020), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [308563] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6286), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13187), 1,
      sym_identifier,
    STATE(7378), 1,
      sym__scope_resolution,
    ACTIONS(6288), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(10764), 2,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [308598] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13189), 1,
      anon_sym_RBRACE,
    ACTIONS(13181), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10410), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(11364), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(8160), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [308631] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13191), 1,
      anon_sym_RBRACE,
    ACTIONS(13181), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10405), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(11040), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(8412), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [308664] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(12954), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12956), 1,
      anon_sym_template,
    ACTIONS(13193), 1,
      sym_identifier,
    STATE(4660), 1,
      sym_qualified_field_identifier,
    STATE(4790), 1,
      sym_template_method,
    STATE(4792), 1,
      sym_dependent_field_identifier,
    STATE(8021), 1,
      sym__scope_resolution,
    STATE(10606), 1,
      sym_operator_name,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [308703] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3800), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [308730] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9181), 1,
      anon_sym_where,
    ACTIONS(11129), 1,
      anon_sym_requires,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9000), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [308761] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13197), 1,
      anon_sym_LT,
    STATE(8229), 1,
      sym_template_argument_list,
    ACTIONS(13199), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(13195), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [308786] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(12886), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12888), 1,
      anon_sym_template,
    ACTIONS(13201), 1,
      sym_identifier,
    STATE(3343), 1,
      sym_template_method,
    STATE(3347), 1,
      sym_dependent_field_identifier,
    STATE(3348), 1,
      sym_qualified_field_identifier,
    STATE(8025), 1,
      sym__scope_resolution,
    STATE(10755), 1,
      sym_operator_name,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [308825] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7594), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(7796), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7596), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_try,
  [308850] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3800), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [308877] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13203), 1,
      anon_sym_RBRACE,
    ACTIONS(13181), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10566), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(11287), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(8412), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [308910] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13205), 1,
      anon_sym_RBRACE,
    ACTIONS(13181), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10653), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(11002), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(8412), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [308943] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13207), 1,
      anon_sym_RBRACE,
    ACTIONS(13181), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10451), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(11106), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(8033), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [308976] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13197), 1,
      anon_sym_LT,
    STATE(8196), 1,
      sym_template_argument_list,
    ACTIONS(13211), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(13209), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [309001] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12377), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4265), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [309030] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13213), 1,
      anon_sym_RBRACE,
    ACTIONS(13181), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10460), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(11120), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(8412), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [309063] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12331), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4172), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [309092] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3551), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [309119] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3551), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [309146] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(13059), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [309177] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12367), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4172), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [309206] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(13215), 1,
      anon_sym_EQ,
    STATE(8451), 1,
      sym_interface_requirements,
    ACTIONS(12530), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [309231] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12407), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4265), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [309260] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12415), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4265), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [309289] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12429), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4172), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [309318] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12443), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4265), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [309347] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12450), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4172), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [309376] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11264), 1,
      sym_identifier,
    ACTIONS(11572), 1,
      anon_sym_requires,
    ACTIONS(11575), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11542), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8732), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [309409] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3800), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [309436] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13218), 1,
      anon_sym_RBRACE,
    ACTIONS(13181), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10676), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10794), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(8412), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [309469] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3551), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [309496] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12331), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4265), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [309525] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12367), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4265), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [309554] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12429), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4265), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [309583] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3551), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [309610] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12450), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4265), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [309639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7330), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6761), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [309660] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(12999), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [309691] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(917), 1,
      anon_sym_LBRACE,
    ACTIONS(7330), 1,
      anon_sym_LBRACK,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    ACTIONS(13140), 1,
      anon_sym_EQ,
    ACTIONS(13142), 1,
      anon_sym_try,
    STATE(1093), 1,
      sym_compound_statement,
    STATE(10608), 1,
      sym_field_initializer_list,
    ACTIONS(6761), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1094), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [309726] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8984), 1,
      anon_sym_requires,
    ACTIONS(8986), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      sym_identifier,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9142), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [309759] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8984), 1,
      anon_sym_requires,
    ACTIONS(8986), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      sym_identifier,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9170), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [309792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13222), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(13220), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [309813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13226), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(13224), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [309834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13230), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(13228), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [309855] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3551), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [309882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8039), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(8041), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [309903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13234), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(13232), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [309924] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(13173), 1,
      sym_identifier,
    ACTIONS(13175), 1,
      anon_sym_COLON_COLON,
    STATE(8163), 1,
      sym__scope_resolution,
    STATE(10417), 1,
      sym_field_initializer,
    STATE(10655), 1,
      sym_operator_name,
    STATE(9444), 2,
      sym_template_method,
      sym_qualified_field_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [309961] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(13236), 1,
      anon_sym_COMMA,
    ACTIONS(13238), 1,
      anon_sym_EQ,
    STATE(8228), 1,
      aux_sym_where_clause_repeat1,
    STATE(8274), 1,
      sym_interface_requirements,
    ACTIONS(12419), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_GT2,
      anon_sym_try,
  [309990] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(12423), 1,
      anon_sym_LBRACK,
    ACTIONS(13240), 1,
      anon_sym_COMMA,
    ACTIONS(13242), 1,
      anon_sym_EQ,
    STATE(8368), 1,
      sym_interface_requirements,
    STATE(8552), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [310021] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(13152), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [310052] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8984), 1,
      anon_sym_requires,
    ACTIONS(8986), 1,
      anon_sym_where,
    ACTIONS(11655), 1,
      sym_identifier,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9159), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [310085] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(13158), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [310116] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      anon_sym_LBRACE,
    ACTIONS(7330), 1,
      anon_sym_LBRACK,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    ACTIONS(12989), 1,
      anon_sym_EQ,
    ACTIONS(12991), 1,
      anon_sym_try,
    STATE(533), 1,
      sym_compound_statement,
    STATE(10409), 1,
      sym_field_initializer_list,
    ACTIONS(6761), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(534), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [310151] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11655), 1,
      sym_identifier,
    ACTIONS(12860), 1,
      anon_sym_requires,
    ACTIONS(12863), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(12662), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8605), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [310184] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13244), 1,
      anon_sym_RBRACE,
    ACTIONS(13181), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10542), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(11477), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(8095), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [310217] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13246), 1,
      anon_sym_RBRACE,
    ACTIONS(13181), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10477), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(11617), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(8159), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [310250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13248), 1,
      anon_sym_EQ,
    ACTIONS(12623), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(12621), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_GT2,
      anon_sym_try,
  [310273] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym___attribute,
    ACTIONS(13096), 1,
      anon_sym_COMMA,
    ACTIONS(13251), 1,
      anon_sym_EQ,
    STATE(8238), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 9,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [310300] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(9189), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9055), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [310331] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(9189), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9063), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [310362] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(9189), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9071), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [310393] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(9189), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9076), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [310424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7610), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(7612), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [310445] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_requires,
    ACTIONS(9189), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9080), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [310476] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym___attribute,
    ACTIONS(13067), 1,
      anon_sym_COMMA,
    ACTIONS(13253), 1,
      anon_sym_EQ,
    STATE(8256), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [310503] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11476), 1,
      anon_sym_DASH_GT,
    ACTIONS(11478), 1,
      anon_sym_requires,
    ACTIONS(13255), 1,
      anon_sym_LBRACE,
    STATE(9979), 1,
      sym_trailing_return_type,
    STATE(11612), 1,
      sym_requires_clause,
    STATE(8785), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8784), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [310540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7618), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(7620), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [310561] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13257), 1,
      anon_sym_RBRACE,
    ACTIONS(13181), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10661), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10956), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(8015), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [310594] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13261), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(7021), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(13259), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [310619] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13263), 1,
      anon_sym_RBRACE,
    ACTIONS(13181), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10346), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(11329), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(8097), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [310652] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3551), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [310679] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12532), 1,
      anon_sym___attribute,
    ACTIONS(12841), 1,
      anon_sym_COLON,
    ACTIONS(13265), 1,
      anon_sym_EQ,
    STATE(8294), 1,
      sym_interface_requirements,
    ACTIONS(12530), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [310706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7626), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(7628), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [310727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13269), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(13267), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [310748] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(5519), 1,
      anon_sym_STAR,
    ACTIONS(5521), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5523), 1,
      anon_sym_AMP,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9237), 1,
      sym__abstract_declarator,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [310783] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(12926), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12928), 1,
      anon_sym_template,
    ACTIONS(13201), 1,
      sym_identifier,
    STATE(3343), 1,
      sym_template_method,
    STATE(3347), 1,
      sym_dependent_field_identifier,
    STATE(3348), 1,
      sym_qualified_field_identifier,
    STATE(8094), 1,
      sym__scope_resolution,
    STATE(10505), 1,
      sym_operator_name,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [310822] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13271), 1,
      anon_sym_RBRACE,
    ACTIONS(13181), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10574), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(11544), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(8412), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [310855] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(13273), 1,
      anon_sym_EQ,
    STATE(8357), 1,
      sym_interface_requirements,
    ACTIONS(12530), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [310880] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13275), 1,
      anon_sym_RBRACE,
    ACTIONS(13181), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10335), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10966), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(8412), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [310913] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6781), 1,
      anon_sym_LBRACK,
    ACTIONS(13277), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(13279), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6783), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [310938] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9181), 1,
      anon_sym_where,
    ACTIONS(11256), 1,
      anon_sym_requires,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8898), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [310969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7662), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(7664), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [310990] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1093), 1,
      anon_sym_LBRACE,
    ACTIONS(7330), 1,
      anon_sym_LBRACK,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    ACTIONS(13043), 1,
      anon_sym_EQ,
    ACTIONS(13045), 1,
      anon_sym_try,
    STATE(895), 1,
      sym_compound_statement,
    STATE(10373), 1,
      sym_field_initializer_list,
    ACTIONS(6761), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(896), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [311025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7641), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(7643), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [311046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7699), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(7701), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [311067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13283), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(13281), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [311088] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8984), 1,
      anon_sym_requires,
    ACTIONS(8986), 1,
      anon_sym_where,
    ACTIONS(11830), 1,
      sym_identifier,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9207), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [311121] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(9176), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9184), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [311152] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(9176), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9185), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [311183] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3551), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [311210] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(9176), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9186), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [311241] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(9176), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9188), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [311272] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8814), 1,
      anon_sym_requires,
    ACTIONS(9176), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9189), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [311303] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11152), 1,
      anon_sym_requires,
    ACTIONS(11214), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [311334] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1093), 1,
      anon_sym_LBRACE,
    ACTIONS(7330), 1,
      anon_sym_LBRACK,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    ACTIONS(13043), 1,
      anon_sym_EQ,
    ACTIONS(13045), 1,
      anon_sym_try,
    STATE(936), 1,
      sym_compound_statement,
    STATE(10520), 1,
      sym_field_initializer_list,
    ACTIONS(6761), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(937), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [311369] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11365), 1,
      anon_sym_requires,
    ACTIONS(11393), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8715), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [311400] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11551), 1,
      anon_sym_requires,
    ACTIONS(11578), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11312), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8716), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [311431] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12471), 1,
      anon_sym_requires,
    ACTIONS(12942), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11886), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8717), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [311462] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12733), 1,
      anon_sym_requires,
    ACTIONS(13285), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(12239), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8718), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [311493] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10026), 1,
      sym_identifier,
    ACTIONS(11225), 1,
      anon_sym_requires,
    ACTIONS(11228), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(11098), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8770), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [311526] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(3516), 1,
      anon_sym_LBRACE,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(13288), 1,
      anon_sym_COLON,
    STATE(321), 1,
      sym_attribute_specifier,
    STATE(6170), 1,
      sym__enum_base_clause,
    STATE(6388), 1,
      sym_enumerator_list,
    ACTIONS(3480), 6,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [311559] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(3516), 1,
      anon_sym_LBRACE,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(13288), 1,
      anon_sym_COLON,
    STATE(298), 1,
      sym_attribute_specifier,
    STATE(6171), 1,
      sym__enum_base_clause,
    STATE(6394), 1,
      sym_enumerator_list,
    ACTIONS(3504), 6,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
      anon_sym_GT2,
  [311592] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9181), 1,
      anon_sym_where,
    ACTIONS(11528), 1,
      anon_sym_requires,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9002), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [311623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7622), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(7624), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [311644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7675), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(7677), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [311665] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    ACTIONS(9841), 1,
      anon_sym_STAR,
    ACTIONS(9843), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9845), 1,
      anon_sym_AMP,
    STATE(3767), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(8876), 1,
      sym__abstract_declarator,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [311700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7679), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(7681), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [311721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7691), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(7693), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [311742] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(7330), 1,
      anon_sym_LBRACK,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    ACTIONS(13035), 1,
      anon_sym_EQ,
    ACTIONS(13037), 1,
      anon_sym_try,
    STATE(1011), 1,
      sym_compound_statement,
    STATE(10691), 1,
      sym_field_initializer_list,
    ACTIONS(6761), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1012), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [311777] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13290), 1,
      anon_sym_RBRACE,
    ACTIONS(13181), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10637), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(11154), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(8047), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [311810] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(917), 1,
      anon_sym_LBRACE,
    ACTIONS(7330), 1,
      anon_sym_LBRACK,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    ACTIONS(13140), 1,
      anon_sym_EQ,
    ACTIONS(13142), 1,
      anon_sym_try,
    STATE(887), 1,
      sym_compound_statement,
    STATE(10360), 1,
      sym_field_initializer_list,
    ACTIONS(6761), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(894), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [311845] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(13279), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6808), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK_LBRACK,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [311868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2224), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [311889] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2406), 1,
      anon_sym_LT,
    ACTIONS(7330), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_COLON,
    STATE(7909), 1,
      sym_template_argument_list,
    STATE(9417), 1,
      sym_type_hint,
    ACTIONS(6761), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [311920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2224), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [311941] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3551), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [311968] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11129), 1,
      anon_sym_requires,
    ACTIONS(11217), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10028), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8708), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [311999] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11256), 1,
      anon_sym_requires,
    ACTIONS(11396), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10835), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8709), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [312030] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11528), 1,
      anon_sym_requires,
    ACTIONS(11569), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11312), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8710), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11262), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [312061] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12532), 1,
      anon_sym___attribute,
    ACTIONS(12841), 1,
      anon_sym_COLON,
    ACTIONS(13295), 1,
      anon_sym_EQ,
    STATE(8206), 1,
      sym_interface_requirements,
    ACTIONS(12530), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [312088] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12465), 1,
      anon_sym_requires,
    ACTIONS(12908), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11886), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8711), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [312119] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12811), 1,
      anon_sym_requires,
    ACTIONS(13297), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(12239), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8712), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [312150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2224), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [312171] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11830), 1,
      sym_identifier,
    ACTIONS(13300), 1,
      anon_sym_requires,
    ACTIONS(13303), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(12961), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(8623), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [312204] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(13003), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [312235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2224), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [312256] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9181), 1,
      anon_sym_where,
    ACTIONS(12465), 1,
      anon_sym_requires,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9004), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11653), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [312287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2224), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [312308] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3800), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [312335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12623), 1,
      anon_sym___attribute,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(12621), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [312358] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8984), 1,
      anon_sym_requires,
    ACTIONS(8986), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      sym_identifier,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(8584), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9067), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10823), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [312391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2224), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [312412] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13309), 1,
      anon_sym_RBRACE,
    ACTIONS(13181), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10743), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10883), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(8156), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [312445] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13311), 1,
      anon_sym_RBRACE,
    ACTIONS(13181), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10440), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(11091), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(8028), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [312478] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9181), 1,
      anon_sym_where,
    ACTIONS(12811), 1,
      anon_sym_requires,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(8168), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(7289), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(9005), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(11828), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [312509] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(12769), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12771), 1,
      anon_sym_template,
    ACTIONS(13313), 1,
      sym_identifier,
    STATE(4549), 1,
      sym_template_method,
    STATE(4558), 1,
      sym_dependent_field_identifier,
    STATE(4561), 1,
      sym_qualified_field_identifier,
    STATE(8154), 1,
      sym__scope_resolution,
    STATE(10592), 1,
      sym_operator_name,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [312548] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12377), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4172), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [312577] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13315), 1,
      anon_sym_RBRACE,
    ACTIONS(13181), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10782), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(10911), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(8412), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [312610] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_LPAREN2,
    ACTIONS(5519), 1,
      anon_sym_STAR,
    ACTIONS(5521), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5523), 1,
      anon_sym_AMP,
    ACTIONS(9294), 1,
      anon_sym_LBRACK,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(7543), 1,
      sym__function_declarator_seq,
    STATE(9230), 1,
      sym__abstract_declarator,
    STATE(7454), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [312645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7707), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(7709), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [312666] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13317), 1,
      anon_sym_RBRACE,
    ACTIONS(13181), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10439), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(11232), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(8412), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [312699] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13319), 1,
      anon_sym_RBRACE,
    ACTIONS(13181), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10638), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(11725), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(8412), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [312732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13323), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(13321), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [312753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13327), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(13325), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [312774] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(13175), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13329), 1,
      sym_identifier,
    ACTIONS(13331), 1,
      anon_sym_template,
    STATE(3343), 1,
      sym_template_method,
    STATE(3347), 1,
      sym_dependent_field_identifier,
    STATE(3348), 1,
      sym_qualified_field_identifier,
    STATE(8163), 1,
      sym__scope_resolution,
    STATE(10655), 1,
      sym_operator_name,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [312813] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      anon_sym_LBRACE,
    ACTIONS(7330), 1,
      anon_sym_LBRACK,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    ACTIONS(12989), 1,
      anon_sym_EQ,
    ACTIONS(12991), 1,
      anon_sym_try,
    STATE(519), 1,
      sym_compound_statement,
    STATE(10482), 1,
      sym_field_initializer_list,
    ACTIONS(6761), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(570), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [312848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13335), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(13333), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [312869] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3800), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [312896] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3800), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [312923] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8172), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10024), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [312946] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11476), 1,
      anon_sym_DASH_GT,
    ACTIONS(11478), 1,
      anon_sym_requires,
    ACTIONS(13337), 1,
      anon_sym_LBRACE,
    STATE(10090), 1,
      sym_trailing_return_type,
    STATE(11035), 1,
      sym_requires_clause,
    STATE(8810), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8808), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [312983] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8172), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10823), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [313006] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13339), 1,
      anon_sym_RBRACE,
    ACTIONS(13181), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10430), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(11488), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(8029), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [313039] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12407), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4172), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 8,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [313068] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8172), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11262), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [313091] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13341), 1,
      anon_sym_RBRACE,
    ACTIONS(13181), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10511), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(11089), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(8176), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [313124] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8172), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11653), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [313147] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13179), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13343), 1,
      anon_sym_RBRACE,
    ACTIONS(13181), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(10689), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(11279), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(8412), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [313180] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    ACTIONS(13104), 1,
      anon_sym_SEMI,
    ACTIONS(13345), 1,
      anon_sym_COLON,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(9645), 1,
      aux_sym_declaration_repeat1,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [313218] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3857), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(12443), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [313246] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3857), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(12450), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [313274] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3856), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [313300] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6963), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    STATE(2729), 1,
      sym_template_type,
    STATE(2820), 1,
      sym_enumerator_list,
    STATE(8606), 1,
      sym__scope_resolution,
    STATE(3208), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [313336] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(3516), 1,
      anon_sym_LBRACE,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(6387), 1,
      sym_enumerator_list,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(6090), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [313372] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8245), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    STATE(7626), 1,
      sym_where_clause,
    ACTIONS(10823), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [313396] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12693), 1,
      anon_sym_COLON,
    ACTIONS(12695), 1,
      anon_sym_SEMI,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(10088), 1,
      aux_sym_declaration_repeat1,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [313434] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13347), 1,
      anon_sym_AMP_AMP,
    ACTIONS(13349), 1,
      anon_sym_and,
    ACTIONS(6808), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK,
    ACTIONS(6806), 6,
      anon_sym_or,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [313458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13353), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(13351), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [313478] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8245), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    STATE(7624), 1,
      sym_where_clause,
    ACTIONS(10024), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [313502] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13236), 1,
      anon_sym_COMMA,
    STATE(8250), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [313524] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10037), 1,
      anon_sym_LBRACE,
    ACTIONS(11419), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5610), 1,
      sym_enumerator_list,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(6190), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [313560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13357), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(13355), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [313580] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8191), 1,
      anon_sym_LBRACE,
    ACTIONS(11053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11435), 1,
      sym_identifier,
    STATE(3571), 1,
      sym_template_type,
    STATE(3730), 1,
      sym_enumerator_list,
    STATE(8630), 1,
      sym__scope_resolution,
    STATE(3591), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [313616] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(7384), 1,
      anon_sym_LBRACE,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11439), 1,
      sym_identifier,
    STATE(3103), 1,
      sym_template_type,
    STATE(3148), 1,
      sym_enumerator_list,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(3264), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [313652] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8245), 1,
      anon_sym_where,
    ACTIONS(11655), 1,
      anon_sym_LBRACK,
    STATE(7608), 1,
      sym_where_clause,
    ACTIONS(11653), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [313676] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3856), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [313702] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3856), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [313728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7790), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(7792), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [313748] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [313774] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8245), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    STATE(7617), 1,
      sym_where_clause,
    ACTIONS(11262), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [313798] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    ACTIONS(13102), 1,
      anon_sym_COLON,
    ACTIONS(13104), 1,
      anon_sym_SEMI,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(9645), 1,
      aux_sym_declaration_repeat1,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [313836] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8245), 1,
      anon_sym_where,
    ACTIONS(12544), 1,
      anon_sym_LBRACK,
    STATE(7605), 1,
      sym_where_clause,
    ACTIONS(12542), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [313860] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8245), 1,
      anon_sym_where,
    ACTIONS(11830), 1,
      anon_sym_LBRACK,
    STATE(7625), 1,
      sym_where_clause,
    ACTIONS(11828), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [313884] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(13359), 1,
      anon_sym_COMMA,
    ACTIONS(13361), 1,
      anon_sym_EQ,
    STATE(8473), 1,
      sym_interface_requirements,
    STATE(8474), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(12423), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [313914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13236), 1,
      anon_sym_COMMA,
    STATE(8260), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [313936] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [313962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13365), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(13363), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [313982] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12623), 1,
      anon_sym___attribute,
    ACTIONS(13367), 1,
      anon_sym_EQ,
    ACTIONS(12621), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [314004] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [314030] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9951), 1,
      anon_sym_LBRACE,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5683), 1,
      sym_enumerator_list,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(5735), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [314066] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [314092] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13071), 1,
      anon_sym_COMMA,
    ACTIONS(13369), 1,
      anon_sym_EQ,
    STATE(8221), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 9,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [314116] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [314142] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(5525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6963), 1,
      anon_sym_LBRACE,
    ACTIONS(11445), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2820), 1,
      sym_enumerator_list,
    STATE(8769), 1,
      sym__scope_resolution,
    STATE(2945), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [314178] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3856), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [314204] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13071), 1,
      anon_sym_COMMA,
    STATE(8224), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 10,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [314226] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3856), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [314252] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13236), 1,
      anon_sym_COMMA,
    STATE(8260), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [314274] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13071), 1,
      anon_sym_COMMA,
    STATE(8226), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 10,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [314296] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [314322] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [314348] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10037), 1,
      anon_sym_LBRACE,
    ACTIONS(11411), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(6519), 1,
      sym_enumerator_list,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(6184), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [314384] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13071), 1,
      anon_sym_COMMA,
    STATE(8224), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 10,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [314406] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [314432] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    ACTIONS(12723), 1,
      anon_sym_COLON,
    ACTIONS(12725), 1,
      anon_sym_SEMI,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(10213), 1,
      aux_sym_declaration_repeat1,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [314470] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13371), 1,
      anon_sym_COMMA,
    STATE(8224), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 10,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [314492] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8100), 1,
      anon_sym_LBRACE,
    ACTIONS(10875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11437), 1,
      sym_identifier,
    STATE(3528), 1,
      sym_template_type,
    STATE(3626), 1,
      sym_enumerator_list,
    STATE(8655), 1,
      sym__scope_resolution,
    STATE(3525), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [314528] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13071), 1,
      anon_sym_COMMA,
    STATE(8224), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 10,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [314550] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10037), 1,
      anon_sym_LBRACE,
    ACTIONS(11415), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5610), 1,
      sym_enumerator_list,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(5438), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [314586] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13236), 1,
      anon_sym_COMMA,
    STATE(8260), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [314608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7733), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(7735), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [314628] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(7414), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3186), 1,
      sym_enumerator_list,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(6131), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [314664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13376), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(13374), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [314684] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    ACTIONS(12717), 1,
      anon_sym_COLON,
    ACTIONS(12719), 1,
      anon_sym_SEMI,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(10148), 1,
      aux_sym_declaration_repeat1,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [314722] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym___attribute,
    ACTIONS(13096), 1,
      anon_sym_COMMA,
    STATE(8239), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 9,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [314746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13380), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(13378), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [314766] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym___attribute,
    ACTIONS(13096), 1,
      anon_sym_COMMA,
    STATE(8242), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 9,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [314790] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13347), 1,
      anon_sym_AMP_AMP,
    ACTIONS(13349), 1,
      anon_sym_and,
    ACTIONS(13382), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(13384), 1,
      anon_sym_or,
    ACTIONS(6783), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(6781), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [314818] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(3516), 1,
      anon_sym_LBRACE,
    ACTIONS(11166), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(698), 1,
      sym_enumerator_list,
    STATE(8640), 1,
      sym__scope_resolution,
    STATE(472), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [314854] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym___attribute,
    ACTIONS(13096), 1,
      anon_sym_COMMA,
    STATE(8239), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 9,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [314878] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12532), 1,
      anon_sym___attribute,
    ACTIONS(13386), 1,
      anon_sym_COMMA,
    STATE(8239), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 9,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [314902] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3856), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [314928] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13071), 1,
      anon_sym_COMMA,
    STATE(8255), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 10,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [314950] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym___attribute,
    ACTIONS(13096), 1,
      anon_sym_COMMA,
    STATE(8239), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 9,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [314974] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym___attribute,
    ACTIONS(13096), 1,
      anon_sym_COMMA,
    STATE(8245), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 9,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [314998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13211), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(13209), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [315018] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12540), 1,
      anon_sym___attribute,
    ACTIONS(13096), 1,
      anon_sym_COMMA,
    STATE(8239), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 9,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [315042] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(3516), 1,
      anon_sym_LBRACE,
    ACTIONS(11429), 1,
      sym_identifier,
    ACTIONS(11431), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(6387), 1,
      sym_enumerator_list,
    STATE(8684), 1,
      sym__scope_resolution,
    STATE(8120), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [315078] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3856), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [315104] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(12423), 1,
      anon_sym_LBRACK,
    ACTIONS(13389), 1,
      anon_sym_COMMA,
    ACTIONS(13391), 1,
      anon_sym_EQ,
    STATE(8324), 1,
      sym_interface_requirements,
    STATE(8326), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [315134] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    ACTIONS(12783), 1,
      anon_sym_COLON,
    STATE(4120), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    STATE(10238), 1,
      sym_semantics,
    ACTIONS(12781), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(8756), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [315170] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13236), 1,
      anon_sym_COMMA,
    STATE(8260), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [315192] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym___attribute,
    ACTIONS(13067), 1,
      anon_sym_COMMA,
    STATE(8266), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [315216] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym___attribute,
    ACTIONS(13067), 1,
      anon_sym_COMMA,
    STATE(8267), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [315240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7390), 6,
      anon_sym_AMP,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(7392), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
  [315260] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(7414), 1,
      anon_sym_LBRACE,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11425), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(6520), 1,
      sym_enumerator_list,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(6225), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [315296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13071), 1,
      anon_sym_COMMA,
    STATE(8224), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 10,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [315318] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym___attribute,
    ACTIONS(13067), 1,
      anon_sym_COMMA,
    STATE(8266), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [315342] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10026), 1,
      anon_sym___attribute,
    ACTIONS(11155), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10024), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [315366] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10825), 1,
      anon_sym___attribute,
    ACTIONS(11368), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10823), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [315390] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11264), 1,
      anon_sym___attribute,
    ACTIONS(11554), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11262), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [315414] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13393), 1,
      anon_sym_COMMA,
    STATE(8260), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [315436] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11655), 1,
      anon_sym___attribute,
    ACTIONS(12474), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11653), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [315460] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11830), 1,
      anon_sym___attribute,
    ACTIONS(12736), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(11828), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [315484] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12544), 1,
      anon_sym___attribute,
    ACTIONS(13396), 1,
      anon_sym_where,
    STATE(7487), 1,
      sym_where_clause,
    ACTIONS(12542), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [315508] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    ACTIONS(13399), 1,
      anon_sym_COLON,
    ACTIONS(13401), 1,
      anon_sym_SEMI,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(9746), 1,
      aux_sym_declaration_repeat1,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [315546] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(13403), 1,
      anon_sym_COMMA,
    ACTIONS(13405), 1,
      anon_sym_EQ,
    STATE(8507), 1,
      sym_interface_requirements,
    STATE(8660), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(12423), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [315576] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12532), 1,
      anon_sym___attribute,
    ACTIONS(13407), 1,
      anon_sym_COMMA,
    STATE(8266), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [315600] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym___attribute,
    ACTIONS(13067), 1,
      anon_sym_COMMA,
    STATE(8266), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [315624] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10026), 1,
      anon_sym___attribute,
    ACTIONS(11196), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10024), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [315648] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10825), 1,
      anon_sym___attribute,
    ACTIONS(11384), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10823), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [315672] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11264), 1,
      anon_sym___attribute,
    ACTIONS(11557), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11262), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [315696] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11655), 1,
      anon_sym___attribute,
    ACTIONS(12468), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11653), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [315720] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11830), 1,
      anon_sym___attribute,
    ACTIONS(12814), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(11828), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [315744] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12544), 1,
      anon_sym___attribute,
    ACTIONS(13410), 1,
      anon_sym_where,
    STATE(7487), 1,
      sym_where_clause,
    ACTIONS(12542), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [315768] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13236), 1,
      anon_sym_COMMA,
    ACTIONS(13413), 1,
      anon_sym_EQ,
    STATE(8203), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_GT2,
      anon_sym_try,
  [315792] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym___attribute,
    ACTIONS(13067), 1,
      anon_sym_COMMA,
    STATE(8276), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [315816] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12540), 1,
      anon_sym___attribute,
    ACTIONS(13067), 1,
      anon_sym_COMMA,
    STATE(8266), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [315840] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(7414), 1,
      anon_sym_LBRACE,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11421), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3186), 1,
      sym_enumerator_list,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(4820), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [315876] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(3484), 1,
      anon_sym_LBRACE,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11441), 1,
      sym_identifier,
    STATE(398), 1,
      sym_template_type,
    STATE(712), 1,
      sym_enumerator_list,
    STATE(8763), 1,
      sym__scope_resolution,
    STATE(414), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [315912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13417), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(13415), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [315932] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6963), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    STATE(2729), 1,
      sym_template_type,
    STATE(2820), 1,
      sym_enumerator_list,
    STATE(8606), 1,
      sym__scope_resolution,
    STATE(3367), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [315968] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(9478), 1,
      anon_sym_LBRACE,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11413), 1,
      sym_identifier,
    STATE(4999), 1,
      sym_template_type,
    STATE(5158), 1,
      sym_enumerator_list,
    STATE(8676), 1,
      sym__scope_resolution,
    STATE(4996), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [316004] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10037), 1,
      anon_sym_LBRACE,
    ACTIONS(11427), 1,
      sym_identifier,
    STATE(5258), 1,
      sym_template_type,
    STATE(5610), 1,
      sym_enumerator_list,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(6120), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [316040] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11012), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10024), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [316062] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(13419), 1,
      anon_sym_COMMA,
    ACTIONS(13421), 1,
      anon_sym_EQ,
    STATE(8526), 1,
      sym_interface_requirements,
    STATE(8744), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 7,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [316090] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11208), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10823), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [316112] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11525), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11262), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [316134] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(12532), 1,
      anon_sym_LBRACK,
    ACTIONS(13423), 1,
      anon_sym_EQ,
    STATE(8566), 1,
      sym_interface_requirements,
    ACTIONS(12530), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [316160] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3856), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [316186] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12566), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11653), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [316208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13427), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(13425), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [316228] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8067), 1,
      anon_sym_LBRACE,
    ACTIONS(10904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11450), 1,
      sym_identifier,
    STATE(3502), 1,
      sym_template_type,
    STATE(3584), 1,
      sym_enumerator_list,
    STATE(8746), 1,
      sym__scope_resolution,
    STATE(3483), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [316264] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    ACTIONS(12752), 1,
      anon_sym_COLON,
    ACTIONS(12754), 1,
      anon_sym_SEMI,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(9869), 1,
      aux_sym_declaration_repeat1,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [316302] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(12423), 1,
      anon_sym_LBRACK,
    ACTIONS(13429), 1,
      anon_sym_COMMA,
    ACTIONS(13431), 1,
      anon_sym_EQ,
    STATE(8355), 1,
      sym_interface_requirements,
    STATE(8540), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [316332] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12623), 1,
      anon_sym___attribute,
    ACTIONS(13433), 1,
      anon_sym_EQ,
    ACTIONS(12621), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [316354] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12850), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(11828), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [316376] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13435), 1,
      anon_sym_where,
    STATE(7487), 1,
      sym_where_clause,
    ACTIONS(12542), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [316398] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    ACTIONS(12783), 1,
      anon_sym_COLON,
    STATE(4273), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    STATE(10238), 1,
      sym_semantics,
    ACTIONS(12781), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8756), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [316434] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9951), 1,
      anon_sym_LBRACE,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(207), 1,
      sym_template_type,
    STATE(5683), 1,
      sym_enumerator_list,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(5356), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [316470] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13236), 1,
      anon_sym_COMMA,
    STATE(8216), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [316492] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(9215), 1,
      anon_sym_LBRACE,
    ACTIONS(10930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11443), 1,
      sym_identifier,
    STATE(4522), 1,
      sym_template_type,
    STATE(4905), 1,
      sym_enumerator_list,
    STATE(8723), 1,
      sym__scope_resolution,
    STATE(4566), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [316528] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3857), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(12377), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [316556] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12841), 1,
      anon_sym_COLON,
    ACTIONS(13438), 1,
      anon_sym_EQ,
    STATE(8484), 1,
      sym_interface_requirements,
    ACTIONS(12530), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_GT2,
      anon_sym_try,
  [316580] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13007), 1,
      anon_sym_COMMA,
    ACTIONS(13441), 1,
      anon_sym_EQ,
    STATE(8465), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [316604] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3857), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(12331), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [316632] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3857), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(12367), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [316660] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6963), 1,
      anon_sym_LBRACE,
    ACTIONS(11417), 1,
      sym_identifier,
    STATE(2729), 1,
      sym_template_type,
    STATE(2820), 1,
      sym_enumerator_list,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(2918), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [316696] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3857), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(12407), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [316724] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3857), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(12415), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [316752] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(7384), 1,
      anon_sym_LBRACE,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11439), 1,
      sym_identifier,
    STATE(3103), 1,
      sym_template_type,
    STATE(3148), 1,
      sym_enumerator_list,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(3344), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [316788] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3857), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(12429), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [316816] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(7595), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(12607), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(12609), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [316838] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13443), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(10842), 1,
      sym_qualified_identifier,
    ACTIONS(13445), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [316869] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12721), 1,
      anon_sym_try,
    STATE(1149), 1,
      sym_compound_statement,
    STATE(1151), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [316904] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12423), 1,
      anon_sym___attribute,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(13447), 1,
      anon_sym_COMMA,
    ACTIONS(13449), 1,
      anon_sym_EQ,
    STATE(8573), 1,
      sym_interface_requirements,
    STATE(8574), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [316933] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(917), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12756), 1,
      anon_sym_try,
    STATE(917), 1,
      sym_compound_statement,
    STATE(918), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [316968] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13451), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(11053), 1,
      sym_qualified_identifier,
    ACTIONS(13453), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [316999] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_LBRACK,
    ACTIONS(13389), 1,
      anon_sym_COMMA,
    STATE(8423), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 8,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [317022] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11651), 1,
      anon_sym_try,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12711), 1,
      anon_sym_LBRACE,
    STATE(2256), 1,
      sym_compound_statement,
    STATE(2257), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [317057] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12377), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3727), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [317084] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12727), 1,
      anon_sym_try,
    STATE(955), 1,
      sym_compound_statement,
    STATE(956), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [317119] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11651), 1,
      anon_sym_try,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12711), 1,
      anon_sym_LBRACE,
    STATE(2263), 1,
      sym_compound_statement,
    STATE(2264), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [317154] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13455), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(11087), 1,
      sym_qualified_identifier,
    ACTIONS(13457), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [317185] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11321), 1,
      anon_sym_LBRACE,
    ACTIONS(11672), 1,
      anon_sym_try,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    STATE(2169), 1,
      sym_compound_statement,
    STATE(2170), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [317220] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym_LBRACK,
    ACTIONS(13389), 1,
      anon_sym_COMMA,
    ACTIONS(13459), 1,
      anon_sym_EQ,
    STATE(8327), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [317245] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13461), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(11151), 1,
      sym_qualified_identifier,
    ACTIONS(13463), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [317276] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym_LBRACK,
    ACTIONS(13389), 1,
      anon_sym_COMMA,
    STATE(8350), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 8,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [317299] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_LBRACK,
    ACTIONS(13389), 1,
      anon_sym_COMMA,
    STATE(8350), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 8,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [317322] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(317), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12701), 1,
      anon_sym_try,
    STATE(578), 1,
      sym_compound_statement,
    STATE(579), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [317357] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12874), 1,
      sym_identifier,
    ACTIONS(13465), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(13467), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(13469), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(13471), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8809), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(11198), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [317386] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11790), 1,
      sym_identifier,
    ACTIONS(11792), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13473), 1,
      anon_sym_virtual,
    STATE(207), 1,
      sym_template_type,
    STATE(8741), 1,
      sym__scope_resolution,
    STATE(9304), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [317419] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11321), 1,
      anon_sym_LBRACE,
    ACTIONS(11672), 1,
      anon_sym_try,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    STATE(2171), 1,
      sym_compound_statement,
    STATE(2172), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [317454] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(917), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12756), 1,
      anon_sym_try,
    STATE(953), 1,
      sym_compound_statement,
    STATE(954), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [317489] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11321), 1,
      anon_sym_LBRACE,
    ACTIONS(11672), 1,
      anon_sym_try,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    STATE(2174), 1,
      sym_compound_statement,
    STATE(2175), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [317524] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(317), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12701), 1,
      anon_sym_try,
    STATE(615), 1,
      sym_compound_statement,
    STATE(617), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [317559] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12407), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3727), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [317586] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(317), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12701), 1,
      anon_sym_try,
    STATE(586), 1,
      sym_compound_statement,
    STATE(627), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [317621] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8442), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym___attribute,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10024), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [317644] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8442), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym___attribute,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10823), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [317667] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8442), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym___attribute,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11262), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [317690] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8442), 1,
      anon_sym_where,
    ACTIONS(11655), 1,
      anon_sym___attribute,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11653), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [317713] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8442), 1,
      anon_sym_where,
    ACTIONS(11830), 1,
      anon_sym___attribute,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(11828), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [317736] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8442), 1,
      anon_sym_where,
    ACTIONS(12544), 1,
      anon_sym___attribute,
    STATE(7487), 1,
      sym_where_clause,
    ACTIONS(12542), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [317759] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12415), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3727), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [317786] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13475), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(10894), 1,
      sym_qualified_identifier,
    ACTIONS(13477), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [317817] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12443), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3727), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [317844] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(917), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12756), 1,
      anon_sym_try,
    STATE(957), 1,
      sym_compound_statement,
    STATE(958), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [317879] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(917), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12756), 1,
      anon_sym_try,
    STATE(959), 1,
      sym_compound_statement,
    STATE(960), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [317914] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13479), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(11065), 1,
      sym_qualified_identifier,
    ACTIONS(13481), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [317945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7392), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(7390), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
  [317964] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12532), 1,
      anon_sym_LBRACK,
    ACTIONS(13483), 1,
      anon_sym_COMMA,
    STATE(8350), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 8,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [317987] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12532), 1,
      anon_sym_LBRACK,
    ACTIONS(12560), 1,
      anon_sym_COLON,
    ACTIONS(13486), 1,
      anon_sym_EQ,
    STATE(8538), 1,
      sym_interface_requirements,
    ACTIONS(12530), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [318012] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    ACTIONS(13490), 1,
      anon_sym_COLON,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    ACTIONS(13488), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [318045] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(13492), 1,
      anon_sym_COMMA,
    ACTIONS(13494), 1,
      anon_sym_EQ,
    STATE(8560), 1,
      sym_interface_requirements,
    STATE(8692), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 6,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [318072] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11321), 1,
      anon_sym_LBRACE,
    ACTIONS(11672), 1,
      anon_sym_try,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    STATE(2188), 1,
      sym_compound_statement,
    STATE(2189), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [318107] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym_LBRACK,
    ACTIONS(13429), 1,
      anon_sym_COMMA,
    ACTIONS(13496), 1,
      anon_sym_EQ,
    STATE(8513), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [318132] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11321), 1,
      anon_sym_LBRACE,
    ACTIONS(11672), 1,
      anon_sym_try,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    STATE(2190), 1,
      sym_compound_statement,
    STATE(2191), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [318167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13498), 1,
      anon_sym_EQ,
    ACTIONS(12621), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [318186] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12331), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3727), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [318213] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12727), 1,
      anon_sym_try,
    STATE(1037), 1,
      sym_compound_statement,
    STATE(1038), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [318248] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(917), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12756), 1,
      anon_sym_try,
    STATE(979), 1,
      sym_compound_statement,
    STATE(980), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [318283] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12429), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3727), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [318310] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12450), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3727), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [318337] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11321), 1,
      anon_sym_LBRACE,
    ACTIONS(11672), 1,
      anon_sym_try,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    STATE(2192), 1,
      sym_compound_statement,
    STATE(2193), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [318372] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13500), 1,
      sym_identifier,
    ACTIONS(13502), 1,
      anon_sym_COLON,
    ACTIONS(13504), 1,
      sym_system_lib_string,
    STATE(9653), 1,
      sym_string_literal,
    STATE(9735), 1,
      sym_module_name,
    STATE(9753), 1,
      sym_module_partition,
    ACTIONS(6899), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [318401] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13506), 1,
      anon_sym_where,
    STATE(7487), 1,
      sym_where_clause,
    ACTIONS(12542), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [318422] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(13003), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [318451] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11259), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10823), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [318472] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym_LBRACK,
    ACTIONS(13240), 1,
      anon_sym_COMMA,
    ACTIONS(13509), 1,
      anon_sym_EQ,
    STATE(8555), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [318497] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11321), 1,
      anon_sym_LBRACE,
    ACTIONS(11672), 1,
      anon_sym_try,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    STATE(2194), 1,
      sym_compound_statement,
    STATE(2195), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [318532] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(317), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12701), 1,
      anon_sym_try,
    STATE(619), 1,
      sym_compound_statement,
    STATE(620), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [318567] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13511), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(13513), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(13515), 1,
      aux_sym_preproc_elif_token1,
    STATE(8786), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(10970), 1,
      sym_enumerator,
    ACTIONS(13517), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(11274), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [318598] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(317), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12701), 1,
      anon_sym_try,
    STATE(621), 1,
      sym_compound_statement,
    STATE(623), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [318633] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13519), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(10788), 1,
      sym_qualified_identifier,
    ACTIONS(13521), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [318664] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(6286), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11998), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13187), 1,
      sym_identifier,
    STATE(7378), 1,
      sym__scope_resolution,
    STATE(10764), 2,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [318695] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12540), 1,
      anon_sym_LBRACK,
    ACTIONS(13389), 1,
      anon_sym_COMMA,
    STATE(8350), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 8,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [318718] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12874), 1,
      sym_identifier,
    ACTIONS(13467), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(13469), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(13523), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(13471), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8809), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(11286), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [318747] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13513), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(13515), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(13525), 1,
      aux_sym_preproc_if_token2,
    STATE(8786), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(10970), 1,
      sym_enumerator,
    ACTIONS(13517), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(10946), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [318778] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7502), 1,
      anon_sym_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(13527), 1,
      anon_sym_COMMA,
    ACTIONS(13531), 1,
      anon_sym___attribute,
    STATE(3274), 1,
      sym_parameter_list,
    STATE(9295), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(13529), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
    STATE(8026), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [318811] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12727), 1,
      anon_sym_try,
    STATE(928), 1,
      sym_compound_statement,
    STATE(929), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [318846] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11651), 1,
      anon_sym_try,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12711), 1,
      anon_sym_LBRACE,
    STATE(2272), 1,
      sym_compound_statement,
    STATE(2273), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [318881] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11651), 1,
      anon_sym_try,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12711), 1,
      anon_sym_LBRACE,
    STATE(2274), 1,
      sym_compound_statement,
    STATE(2275), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [318916] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(4323), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [318941] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13513), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(13515), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(13533), 1,
      aux_sym_preproc_if_token2,
    STATE(8786), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(10970), 1,
      sym_enumerator,
    ACTIONS(13517), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(11493), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [318972] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11651), 1,
      anon_sym_try,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12711), 1,
      anon_sym_LBRACE,
    STATE(2276), 1,
      sym_compound_statement,
    STATE(2277), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [319007] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(13059), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [319036] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11651), 1,
      anon_sym_try,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12711), 1,
      anon_sym_LBRACE,
    STATE(2254), 1,
      sym_compound_statement,
    STATE(2255), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [319071] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(4323), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [319096] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(317), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12701), 1,
      anon_sym_try,
    STATE(589), 1,
      sym_compound_statement,
    STATE(590), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [319131] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(4323), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [319156] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(4323), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [319181] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(4323), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [319206] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8328), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    STATE(7624), 1,
      sym_where_clause,
    ACTIONS(10024), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [319229] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12874), 1,
      sym_identifier,
    ACTIONS(13467), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(13469), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(13535), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(13471), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8809), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(11504), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [319258] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(4323), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [319283] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8328), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    STATE(7626), 1,
      sym_where_clause,
    ACTIONS(10823), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [319306] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(4323), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [319331] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11651), 1,
      anon_sym_try,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12711), 1,
      anon_sym_LBRACE,
    STATE(2281), 1,
      sym_compound_statement,
    STATE(2282), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [319366] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(4323), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [319391] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8328), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    STATE(7617), 1,
      sym_where_clause,
    ACTIONS(11262), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [319414] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13537), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(11509), 1,
      sym_qualified_identifier,
    ACTIONS(13539), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [319445] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8328), 1,
      anon_sym_where,
    ACTIONS(11655), 1,
      anon_sym_LBRACK,
    STATE(7608), 1,
      sym_where_clause,
    ACTIONS(11653), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [319468] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8328), 1,
      anon_sym_where,
    ACTIONS(11830), 1,
      anon_sym_LBRACK,
    STATE(7625), 1,
      sym_where_clause,
    ACTIONS(11828), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [319491] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8328), 1,
      anon_sym_where,
    ACTIONS(12544), 1,
      anon_sym_LBRACK,
    STATE(7605), 1,
      sym_where_clause,
    ACTIONS(12542), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [319514] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12532), 1,
      anon_sym_LBRACK,
    ACTIONS(12560), 1,
      anon_sym_COLON,
    ACTIONS(13541), 1,
      anon_sym_EQ,
    STATE(8515), 1,
      sym_interface_requirements,
    ACTIONS(12530), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [319539] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12924), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13513), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(13515), 1,
      aux_sym_preproc_elif_token1,
    STATE(8383), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(10970), 1,
      sym_enumerator,
    ACTIONS(13517), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(11335), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [319570] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13544), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(10923), 1,
      sym_qualified_identifier,
    ACTIONS(13546), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [319601] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13548), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(11108), 1,
      sym_qualified_identifier,
    ACTIONS(13550), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [319632] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13513), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(13515), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(13552), 1,
      aux_sym_preproc_if_token2,
    STATE(8377), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(10970), 1,
      sym_enumerator,
    ACTIONS(13517), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(11311), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [319663] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11790), 1,
      sym_identifier,
    ACTIONS(11792), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13554), 1,
      anon_sym_virtual,
    STATE(207), 1,
      sym_template_type,
    STATE(8741), 1,
      sym__scope_resolution,
    STATE(9482), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [319696] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12874), 1,
      sym_identifier,
    ACTIONS(13467), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(13469), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(13556), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(13471), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8393), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(11353), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [319725] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13513), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(13515), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(13558), 1,
      aux_sym_preproc_if_token2,
    STATE(8371), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(10970), 1,
      sym_enumerator,
    ACTIONS(13517), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(11602), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [319756] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13560), 1,
      sym_identifier,
    ACTIONS(13563), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(13569), 1,
      sym_preproc_directive,
    ACTIONS(13572), 1,
      anon_sym_RBRACE,
    ACTIONS(13566), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(11026), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8412), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [319785] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13574), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(11603), 1,
      sym_qualified_identifier,
    ACTIONS(13576), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [319816] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12727), 1,
      anon_sym_try,
    STATE(984), 1,
      sym_compound_statement,
    STATE(985), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [319851] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13502), 1,
      anon_sym_COLON,
    ACTIONS(13578), 1,
      sym_identifier,
    ACTIONS(13580), 1,
      sym_system_lib_string,
    STATE(10054), 1,
      sym_string_literal,
    STATE(10057), 1,
      sym_module_name,
    STATE(10058), 1,
      sym_module_partition,
    ACTIONS(6899), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [319880] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11104), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10026), 4,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(10024), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [319903] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11287), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10825), 4,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(10823), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [319926] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11548), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11264), 4,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(11262), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [319949] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12668), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11655), 4,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(11653), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [319972] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12917), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(11828), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [319993] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13582), 1,
      anon_sym_where,
    STATE(7487), 1,
      sym_where_clause,
    ACTIONS(12544), 4,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(12542), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [320016] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(317), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12701), 1,
      anon_sym_try,
    STATE(572), 1,
      sym_compound_statement,
    STATE(573), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [320051] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym_LBRACK,
    ACTIONS(13389), 1,
      anon_sym_COMMA,
    STATE(8350), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 8,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [320074] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym_LBRACK,
    ACTIONS(13389), 1,
      anon_sym_COMMA,
    STATE(8375), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 8,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [320097] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(13585), 1,
      anon_sym_EQ,
    STATE(8673), 1,
      sym_interface_requirements,
    ACTIONS(12530), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(12532), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [320122] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12841), 1,
      anon_sym_COLON,
    ACTIONS(13587), 1,
      anon_sym_EQ,
    STATE(8523), 1,
      sym_interface_requirements,
    ACTIONS(12530), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(12532), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [320147] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [320172] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [320197] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [320222] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [320247] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [320272] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [320297] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [320322] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [320347] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13590), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(10876), 1,
      sym_qualified_identifier,
    ACTIONS(13592), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [320378] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11790), 1,
      sym_identifier,
    ACTIONS(11792), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13594), 1,
      anon_sym_virtual,
    STATE(207), 1,
      sym_template_type,
    STATE(8741), 1,
      sym__scope_resolution,
    STATE(9303), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [320411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2268), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2270), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [320430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2272), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2274), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [320449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2276), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2278), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [320468] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12727), 1,
      anon_sym_try,
    STATE(1068), 1,
      sym_compound_statement,
    STATE(1069), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [320503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2239), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2241), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [320522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11531), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11262), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [320543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2280), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2282), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [320562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2284), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2286), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [320581] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12721), 1,
      anon_sym_try,
    STATE(1141), 1,
      sym_compound_statement,
    STATE(1143), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [320616] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12721), 1,
      anon_sym_try,
    STATE(1035), 1,
      sym_try_statement,
    STATE(1146), 1,
      sym_compound_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [320651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2288), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2290), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [320670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2292), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2294), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [320689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2296), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2298), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [320708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2264), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2266), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [320727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13596), 1,
      anon_sym_EQ,
    ACTIONS(12621), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
      anon_sym_where,
  [320746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2300), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2302), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [320765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2260), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2262), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [320784] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12727), 1,
      anon_sym_try,
    STATE(1042), 1,
      sym_compound_statement,
    STATE(1043), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [320819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2304), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2306), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [320838] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12721), 1,
      anon_sym_try,
    STATE(920), 1,
      sym_compound_statement,
    STATE(925), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [320873] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12727), 1,
      anon_sym_try,
    STATE(1044), 1,
      sym_compound_statement,
    STATE(1045), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [320908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2308), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2310), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [320927] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12367), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3727), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [320954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13007), 1,
      anon_sym_COMMA,
    STATE(8467), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [320975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2312), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(2314), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [320994] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11680), 1,
      anon_sym_try,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12821), 1,
      anon_sym_LBRACE,
    STATE(1808), 1,
      sym_compound_statement,
    STATE(1809), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [321029] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13007), 1,
      anon_sym_COMMA,
    STATE(8469), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [321050] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11680), 1,
      anon_sym_try,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12821), 1,
      anon_sym_LBRACE,
    STATE(1810), 1,
      sym_compound_statement,
    STATE(1811), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [321085] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13007), 1,
      anon_sym_COMMA,
    STATE(8467), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [321106] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11680), 1,
      anon_sym_try,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12821), 1,
      anon_sym_LBRACE,
    STATE(1667), 1,
      sym_try_statement,
    STATE(1755), 1,
      sym_compound_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [321141] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13599), 1,
      anon_sym_COMMA,
    STATE(8467), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [321162] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(13152), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [321191] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13007), 1,
      anon_sym_COMMA,
    STATE(8467), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [321212] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13007), 1,
      anon_sym_COMMA,
    STATE(8472), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [321233] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13513), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(13515), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(13602), 1,
      aux_sym_preproc_if_token2,
    STATE(8786), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(10970), 1,
      sym_enumerator,
    ACTIONS(13517), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(11398), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [321264] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13007), 1,
      anon_sym_COMMA,
    STATE(8467), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [321285] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13359), 1,
      anon_sym_COMMA,
    ACTIONS(13604), 1,
      anon_sym_EQ,
    STATE(8476), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
    ACTIONS(12519), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [321310] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13359), 1,
      anon_sym_COMMA,
    STATE(8477), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 4,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(12519), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [321333] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13359), 1,
      anon_sym_COMMA,
    STATE(8478), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 4,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(12525), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [321356] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13359), 1,
      anon_sym_COMMA,
    STATE(8477), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 4,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(12525), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [321379] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13606), 1,
      anon_sym_COMMA,
    STATE(8477), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 4,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(12532), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [321402] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13359), 1,
      anon_sym_COMMA,
    STATE(8477), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 4,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(12536), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [321425] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13359), 1,
      anon_sym_COMMA,
    STATE(8480), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 4,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(12536), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [321448] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13359), 1,
      anon_sym_COMMA,
    STATE(8477), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 4,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
    ACTIONS(12540), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [321471] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11680), 1,
      anon_sym_try,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12821), 1,
      anon_sym_LBRACE,
    STATE(1659), 1,
      sym_try_statement,
    STATE(1806), 1,
      sym_compound_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [321506] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11680), 1,
      anon_sym_try,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12821), 1,
      anon_sym_LBRACE,
    STATE(1669), 1,
      sym_compound_statement,
    STATE(1672), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [321541] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11680), 1,
      anon_sym_try,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12821), 1,
      anon_sym_LBRACE,
    STATE(1673), 1,
      sym_compound_statement,
    STATE(1677), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [321576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13609), 1,
      anon_sym_EQ,
    ACTIONS(12621), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_GT2,
      anon_sym_try,
  [321595] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(13158), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [321624] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11680), 1,
      anon_sym_try,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12821), 1,
      anon_sym_LBRACE,
    STATE(1693), 1,
      sym_compound_statement,
    STATE(1696), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [321659] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12874), 1,
      sym_identifier,
    ACTIONS(13467), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(13469), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(13612), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(13471), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8809), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(11431), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [321688] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12876), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(13513), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(13515), 1,
      aux_sym_preproc_elif_token1,
    STATE(8471), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(10970), 1,
      sym_enumerator,
    ACTIONS(13517), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(11371), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [321719] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(13614), 1,
      anon_sym_LBRACE,
    STATE(11030), 1,
      sym_trailing_return_type,
    STATE(9081), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9101), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [321750] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12721), 1,
      anon_sym_try,
    STATE(1092), 1,
      sym_compound_statement,
    STATE(1118), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [321785] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12721), 1,
      anon_sym_try,
    STATE(1122), 1,
      sym_compound_statement,
    STATE(1123), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [321820] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13616), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(11258), 1,
      sym_qualified_identifier,
    ACTIONS(13618), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [321851] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12721), 1,
      anon_sym_try,
    STATE(1125), 1,
      sym_compound_statement,
    STATE(1127), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [321886] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11790), 1,
      sym_identifier,
    ACTIONS(11792), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13620), 1,
      anon_sym_virtual,
    STATE(207), 1,
      sym_template_type,
    STATE(8741), 1,
      sym__scope_resolution,
    STATE(9358), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [321919] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12874), 1,
      sym_identifier,
    ACTIONS(13467), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(13469), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(13622), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(13471), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8487), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(11383), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [321948] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(12999), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [321977] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(917), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12756), 1,
      anon_sym_try,
    STATE(891), 1,
      sym_compound_statement,
    STATE(892), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [322012] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13624), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(11611), 1,
      sym_qualified_identifier,
    ACTIONS(13626), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [322043] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(917), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12756), 1,
      anon_sym_try,
    STATE(906), 1,
      sym_compound_statement,
    STATE(907), 1,
      sym_try_statement,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [322078] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12642), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11653), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [322099] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8148), 1,
      anon_sym_noexcept,
    ACTIONS(8150), 1,
      anon_sym_throw,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11488), 1,
      anon_sym_LBRACE,
    STATE(10948), 1,
      sym_trailing_return_type,
    STATE(9153), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(9069), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [322130] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(13628), 1,
      anon_sym_EQ,
    STATE(8650), 1,
      sym_interface_requirements,
    ACTIONS(12530), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [322153] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11132), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10024), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [322174] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12967), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(11830), 4,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(11828), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [322197] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12448), 1,
      anon_sym_COMMA,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12450), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [322223] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11790), 1,
      sym_identifier,
    ACTIONS(11792), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(8741), 1,
      sym__scope_resolution,
    STATE(9482), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [322253] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13403), 1,
      anon_sym_COMMA,
    ACTIONS(13630), 1,
      anon_sym_EQ,
    STATE(8685), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(12519), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [322277] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12413), 1,
      anon_sym_COMMA,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12415), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [322303] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12441), 1,
      anon_sym_COMMA,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12443), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [322329] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12532), 1,
      anon_sym___attribute,
    ACTIONS(12841), 1,
      anon_sym_COLON,
    ACTIONS(13632), 1,
      anon_sym_EQ,
    STATE(8668), 1,
      sym_interface_requirements,
    ACTIONS(12530), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [322353] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13639), 1,
      anon_sym_delete,
    ACTIONS(13641), 1,
      anon_sym_new,
    ACTIONS(13637), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(13635), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [322375] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_LBRACK,
    ACTIONS(13429), 1,
      anon_sym_COMMA,
    STATE(8517), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [322397] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_LBRACK,
    ACTIONS(13429), 1,
      anon_sym_COMMA,
    STATE(8514), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [322419] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12532), 1,
      anon_sym_LBRACK,
    ACTIONS(13643), 1,
      anon_sym_COMMA,
    STATE(8514), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [322441] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12623), 1,
      anon_sym_LBRACK,
    ACTIONS(13646), 1,
      anon_sym_EQ,
    ACTIONS(12621), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [322461] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13649), 1,
      anon_sym_delete,
    ACTIONS(13651), 1,
      anon_sym_new,
    ACTIONS(13637), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(13635), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [322483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym_LBRACK,
    ACTIONS(13429), 1,
      anon_sym_COMMA,
    STATE(8514), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [322505] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym_LBRACK,
    ACTIONS(13429), 1,
      anon_sym_COMMA,
    STATE(8521), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [322527] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12329), 1,
      anon_sym_COMMA,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12331), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [322553] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12872), 1,
      anon_sym_LBRACK,
    STATE(7796), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(12870), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [322575] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12540), 1,
      anon_sym_LBRACK,
    ACTIONS(13429), 1,
      anon_sym_COMMA,
    STATE(8514), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [322597] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12367), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [322623] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13653), 1,
      anon_sym_EQ,
    ACTIONS(12621), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
    ACTIONS(12623), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [322643] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12427), 1,
      anon_sym_COMMA,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12429), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [322669] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11790), 1,
      sym_identifier,
    ACTIONS(11792), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(8741), 1,
      sym__scope_resolution,
    STATE(9303), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [322699] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13419), 1,
      anon_sym_COMMA,
    ACTIONS(13656), 1,
      anon_sym_EQ,
    STATE(8748), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 7,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [322721] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13658), 1,
      anon_sym_delete,
    ACTIONS(13660), 1,
      anon_sym_new,
    ACTIONS(13637), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(13635), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [322743] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13662), 1,
      anon_sym_delete,
    ACTIONS(13664), 1,
      anon_sym_new,
    ACTIONS(13637), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(13635), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [322765] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12423), 1,
      anon_sym___attribute,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(13666), 1,
      anon_sym_COMMA,
    ACTIONS(13668), 1,
      anon_sym_EQ,
    STATE(8657), 1,
      sym_interface_requirements,
    STATE(8798), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [322793] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13670), 1,
      anon_sym_delete,
    ACTIONS(13672), 1,
      anon_sym_new,
    ACTIONS(13637), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(13635), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [322815] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12783), 1,
      anon_sym_COLON,
    ACTIONS(13167), 1,
      anon_sym_LBRACK,
    STATE(8161), 1,
      sym_semantics,
    ACTIONS(13162), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [322837] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(13674), 1,
      anon_sym_COMMA,
    ACTIONS(13676), 1,
      anon_sym_EQ,
    STATE(8787), 1,
      sym_interface_requirements,
    STATE(8788), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_try,
  [322863] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12687), 1,
      anon_sym_LBRACK,
    STATE(8091), 1,
      sym_parameter_list,
    STATE(7781), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(13678), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
  [322889] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13682), 1,
      anon_sym_LBRACK,
    STATE(9412), 1,
      sym_gnu_asm_input_operand,
    STATE(11070), 1,
      sym_string_literal,
    ACTIONS(13680), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [322913] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13684), 1,
      anon_sym_delete,
    ACTIONS(13686), 1,
      anon_sym_new,
    ACTIONS(13637), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(13635), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [322935] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4331), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [322959] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13690), 1,
      anon_sym_LBRACK,
    STATE(9472), 1,
      sym_gnu_asm_output_operand,
    STATE(11510), 1,
      sym_string_literal,
    ACTIONS(13688), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [322983] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12623), 1,
      anon_sym_LBRACK,
    ACTIONS(13692), 1,
      anon_sym_EQ,
    ACTIONS(12621), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [323003] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4331), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [323027] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym_LBRACK,
    ACTIONS(13429), 1,
      anon_sym_COMMA,
    STATE(8514), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [323049] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4331), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [323073] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11790), 1,
      sym_identifier,
    ACTIONS(11792), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(8741), 1,
      sym__scope_resolution,
    STATE(9277), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [323103] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4331), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [323127] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    ACTIONS(11234), 1,
      anon_sym_where,
    STATE(7624), 1,
      sym_where_clause,
    ACTIONS(10024), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [323149] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    ACTIONS(11408), 1,
      anon_sym_where,
    STATE(7626), 1,
      sym_where_clause,
    ACTIONS(10823), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [323171] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    ACTIONS(11566), 1,
      anon_sym_where,
    STATE(7617), 1,
      sym_where_clause,
    ACTIONS(11262), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [323193] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11655), 1,
      anon_sym_LBRACK,
    ACTIONS(12680), 1,
      anon_sym_where,
    STATE(7608), 1,
      sym_where_clause,
    ACTIONS(11653), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [323215] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11830), 1,
      anon_sym_LBRACK,
    ACTIONS(13078), 1,
      anon_sym_where,
    STATE(7625), 1,
      sym_where_clause,
    ACTIONS(11828), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [323237] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12544), 1,
      anon_sym_LBRACK,
    ACTIONS(13694), 1,
      anon_sym_where,
    STATE(7605), 1,
      sym_where_clause,
    ACTIONS(12542), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [323259] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4331), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [323283] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12423), 1,
      anon_sym___attribute,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(13697), 1,
      anon_sym_COMMA,
    ACTIONS(13699), 1,
      anon_sym_EQ,
    STATE(8703), 1,
      sym_interface_requirements,
    STATE(8881), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 4,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [323311] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym_LBRACK,
    ACTIONS(13240), 1,
      anon_sym_COMMA,
    STATE(8556), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [323333] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4445), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [323357] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12841), 1,
      anon_sym_COLON,
    ACTIONS(13701), 1,
      anon_sym_EQ,
    STATE(8750), 1,
      sym_interface_requirements,
    ACTIONS(12530), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [323379] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_LBRACK,
    ACTIONS(13240), 1,
      anon_sym_COMMA,
    STATE(8556), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [323401] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12532), 1,
      anon_sym_LBRACK,
    ACTIONS(13703), 1,
      anon_sym_COMMA,
    STATE(8556), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [323423] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym_LBRACK,
    ACTIONS(13240), 1,
      anon_sym_COMMA,
    STATE(8556), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [323445] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym_LBRACK,
    ACTIONS(13240), 1,
      anon_sym_COMMA,
    STATE(8559), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [323467] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12540), 1,
      anon_sym_LBRACK,
    ACTIONS(13240), 1,
      anon_sym_COMMA,
    STATE(8556), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [323489] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13492), 1,
      anon_sym_COMMA,
    ACTIONS(13706), 1,
      anon_sym_EQ,
    STATE(8694), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 7,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [323511] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13708), 1,
      anon_sym_delete,
    ACTIONS(13710), 1,
      anon_sym_new,
    ACTIONS(13637), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(13635), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [323533] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11790), 1,
      sym_identifier,
    ACTIONS(11792), 1,
      anon_sym_COLON_COLON,
    STATE(207), 1,
      sym_template_type,
    STATE(8741), 1,
      sym__scope_resolution,
    STATE(9587), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [323563] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4445), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [323587] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4445), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [323611] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4445), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [323635] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12623), 1,
      anon_sym_LBRACK,
    ACTIONS(13712), 1,
      anon_sym_EQ,
    ACTIONS(12621), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [323655] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4445), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [323679] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12375), 1,
      anon_sym_COMMA,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12377), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [323705] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(13714), 1,
      anon_sym_EQ,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(10881), 1,
      sym_initializer_list,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [323737] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13716), 1,
      anon_sym_delete,
    ACTIONS(13718), 1,
      anon_sym_new,
    ACTIONS(13637), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(13635), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [323759] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7502), 1,
      anon_sym_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(13722), 1,
      anon_sym___attribute,
    STATE(3274), 1,
      sym_parameter_list,
    STATE(8026), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(13720), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [323787] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4445), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [323811] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym___attribute,
    ACTIONS(13447), 1,
      anon_sym_COMMA,
    ACTIONS(13724), 1,
      anon_sym_EQ,
    STATE(8576), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [323835] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym___attribute,
    ACTIONS(13447), 1,
      anon_sym_COMMA,
    STATE(8578), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [323857] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym___attribute,
    ACTIONS(13447), 1,
      anon_sym_COMMA,
    STATE(8579), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [323879] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym___attribute,
    ACTIONS(13447), 1,
      anon_sym_COMMA,
    STATE(8578), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [323901] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4445), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [323925] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12532), 1,
      anon_sym___attribute,
    ACTIONS(13726), 1,
      anon_sym_COMMA,
    STATE(8578), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [323947] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym___attribute,
    ACTIONS(13447), 1,
      anon_sym_COMMA,
    STATE(8578), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [323969] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym___attribute,
    ACTIONS(13447), 1,
      anon_sym_COMMA,
    STATE(8581), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [323991] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12540), 1,
      anon_sym___attribute,
    ACTIONS(13447), 1,
      anon_sym_COMMA,
    STATE(8578), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [324013] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13718), 1,
      anon_sym_new,
    ACTIONS(13729), 1,
      anon_sym_delete,
    ACTIONS(13637), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(13635), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [324035] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4331), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [324059] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13718), 1,
      anon_sym_new,
    ACTIONS(13731), 1,
      anon_sym_delete,
    ACTIONS(13637), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(13635), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [324081] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4331), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [324105] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13660), 1,
      anon_sym_new,
    ACTIONS(13733), 1,
      anon_sym_delete,
    ACTIONS(13637), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(13635), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [324127] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13664), 1,
      anon_sym_new,
    ACTIONS(13735), 1,
      anon_sym_delete,
    ACTIONS(13637), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(13635), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [324149] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13737), 1,
      anon_sym_delete,
    ACTIONS(13739), 1,
      anon_sym_new,
    ACTIONS(13637), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(13635), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [324171] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4445), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 6,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [324195] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4331), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [324219] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(13741), 1,
      sym_identifier,
    ACTIONS(13743), 1,
      anon_sym_COLON_COLON,
    STATE(3692), 1,
      sym_template_type,
    STATE(8706), 1,
      sym__scope_resolution,
    STATE(3682), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(11339), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [324249] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(13745), 1,
      anon_sym_COMMA,
    ACTIONS(13747), 1,
      anon_sym_EQ,
    STATE(8884), 1,
      sym_interface_requirements,
    STATE(9012), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [324275] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12405), 1,
      anon_sym_COMMA,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4314), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12407), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [324301] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_LBRACK,
    ACTIONS(13240), 1,
      anon_sym_COMMA,
    STATE(8557), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [324323] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3883), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_requires,
  [324346] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11228), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(10026), 4,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [324367] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3767), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [324390] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3883), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_requires,
  [324413] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3883), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_requires,
  [324436] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3883), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_requires,
  [324459] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(8598), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13749), 1,
      sym_identifier,
    ACTIONS(13751), 1,
      anon_sym_template,
    STATE(5289), 1,
      sym_template_type,
    STATE(5290), 1,
      sym_dependent_type_identifier,
    STATE(5305), 1,
      sym_qualified_type_identifier,
    STATE(8601), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [324490] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13461), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(11151), 1,
      sym_qualified_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [324517] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8491), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10024), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [324536] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12401), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13753), 1,
      sym_identifier,
    STATE(205), 1,
      sym_template_type,
    STATE(206), 1,
      sym_dependent_type_identifier,
    STATE(2967), 1,
      sym_qualified_type_identifier,
    STATE(8604), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [324567] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13303), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(11828), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(11830), 4,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [324588] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(11423), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13755), 1,
      sym_identifier,
    ACTIONS(13757), 1,
      anon_sym_template,
    STATE(2721), 1,
      sym_dependent_type_identifier,
    STATE(2723), 1,
      sym_template_type,
    STATE(2921), 1,
      sym_qualified_type_identifier,
    STATE(8606), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [324619] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8491), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10823), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [324638] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13419), 1,
      anon_sym_COMMA,
    STATE(8760), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 7,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [324657] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8491), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11262), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [324676] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12331), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4273), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
  [324701] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8491), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11653), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [324720] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13537), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(11509), 1,
      sym_qualified_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [324747] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8491), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(11828), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [324766] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13451), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(11053), 1,
      sym_qualified_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [324793] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8594), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10024), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_requires,
  [324812] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8594), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10823), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_requires,
  [324831] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8594), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11262), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_requires,
  [324850] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8594), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11653), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_requires,
  [324869] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8594), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(11828), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_requires,
  [324888] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8594), 1,
      anon_sym_where,
    STATE(7487), 1,
      sym_where_clause,
    ACTIONS(12542), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_requires,
  [324907] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3767), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [324930] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8491), 1,
      anon_sym_where,
    STATE(7487), 1,
      sym_where_clause,
    ACTIONS(12542), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [324949] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13759), 1,
      anon_sym_where,
    STATE(7487), 1,
      sym_where_clause,
    ACTIONS(12542), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(12544), 4,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [324970] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(12395), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13762), 1,
      sym_identifier,
    ACTIONS(13764), 1,
      anon_sym_template,
    STATE(523), 1,
      sym_template_type,
    STATE(524), 1,
      sym_dependent_type_identifier,
    STATE(526), 1,
      sym_qualified_type_identifier,
    STATE(8624), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [325001] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13766), 1,
      sym_identifier,
    ACTIONS(13770), 1,
      sym_system_lib_string,
    STATE(11556), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(13768), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [325022] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11575), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11262), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(11264), 4,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [325043] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12331), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4120), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_GT2,
  [325068] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    ACTIONS(13003), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [325095] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(13772), 1,
      anon_sym_COMMA,
    ACTIONS(13774), 1,
      anon_sym_EQ,
    STATE(8932), 1,
      sym_interface_requirements,
    STATE(9072), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [325120] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(11053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13776), 1,
      sym_identifier,
    ACTIONS(13778), 1,
      anon_sym_template,
    STATE(3490), 1,
      sym_template_type,
    STATE(3491), 1,
      sym_dependent_type_identifier,
    STATE(3519), 1,
      sym_qualified_type_identifier,
    STATE(8630), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [325151] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3767), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [325174] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(13780), 1,
      anon_sym_EQ,
    STATE(8952), 1,
      sym_interface_requirements,
    ACTIONS(12530), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [325195] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13782), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(11434), 1,
      sym_qualified_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [325222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13419), 1,
      anon_sym_COMMA,
    STATE(8645), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 7,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [325241] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(8622), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13784), 1,
      sym_identifier,
    ACTIONS(13786), 1,
      anon_sym_template,
    STATE(205), 1,
      sym_template_type,
    STATE(206), 1,
      sym_dependent_type_identifier,
    STATE(2921), 1,
      sym_qualified_type_identifier,
    STATE(8635), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [325272] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(8652), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13788), 1,
      sym_identifier,
    ACTIONS(13790), 1,
      anon_sym_template,
    STATE(205), 1,
      sym_template_type,
    STATE(206), 1,
      sym_dependent_type_identifier,
    STATE(2921), 1,
      sym_qualified_type_identifier,
    STATE(8636), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [325303] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(12454), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13792), 1,
      sym_identifier,
    ACTIONS(13794), 1,
      anon_sym_template,
    STATE(261), 1,
      sym_template_type,
    STATE(265), 1,
      sym_dependent_type_identifier,
    STATE(266), 1,
      sym_qualified_type_identifier,
    STATE(8637), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [325334] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8816), 1,
      anon_sym_where,
    ACTIONS(11655), 1,
      anon_sym___attribute,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11653), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [325355] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12415), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4120), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_GT2,
  [325380] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(11166), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13784), 1,
      sym_identifier,
    ACTIONS(13786), 1,
      anon_sym_template,
    STATE(205), 1,
      sym_template_type,
    STATE(206), 1,
      sym_dependent_type_identifier,
    STATE(214), 1,
      sym_qualified_type_identifier,
    STATE(8640), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [325411] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5777), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13796), 1,
      sym_identifier,
    ACTIONS(13798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13800), 1,
      anon_sym_inline,
    STATE(1136), 1,
      sym_declaration_list,
    STATE(8979), 1,
      sym_attribute_declaration,
    STATE(10591), 1,
      sym_nested_namespace_specifier,
    STATE(11683), 1,
      sym__namespace_specifier,
  [325442] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12367), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4273), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
  [325467] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(3686), 1,
      sym_template_argument_list,
    ACTIONS(7330), 2,
      anon_sym_COLON,
      anon_sym_LBRACK,
    ACTIONS(6761), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [325490] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(8618), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13802), 1,
      sym_identifier,
    ACTIONS(13804), 1,
      anon_sym_template,
    STATE(5289), 1,
      sym_template_type,
    STATE(5290), 1,
      sym_dependent_type_identifier,
    STATE(5305), 1,
      sym_qualified_type_identifier,
    STATE(8644), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [325521] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13419), 1,
      anon_sym_COMMA,
    STATE(8760), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 7,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [325540] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    ACTIONS(13059), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [325567] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(12381), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13806), 1,
      sym_identifier,
    ACTIONS(13808), 1,
      anon_sym_template,
    STATE(1306), 1,
      sym_qualified_type_identifier,
    STATE(1325), 1,
      sym_template_type,
    STATE(1326), 1,
      sym_dependent_type_identifier,
    STATE(8647), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [325598] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(12783), 1,
      anon_sym_COLON,
    STATE(9818), 1,
      sym_semantics,
    STATE(5308), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(13810), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [325623] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5781), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13800), 1,
      anon_sym_inline,
    ACTIONS(13812), 1,
      sym_identifier,
    STATE(1075), 1,
      sym_declaration_list,
    STATE(8977), 1,
      sym_attribute_declaration,
    STATE(10560), 1,
      sym_nested_namespace_specifier,
    STATE(11683), 1,
      sym__namespace_specifier,
  [325654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13814), 1,
      anon_sym_EQ,
    ACTIONS(12621), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [325671] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12443), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4120), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_GT2,
  [325696] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3883), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_requires,
  [325719] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8816), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym___attribute,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11262), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [325740] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13816), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(11105), 1,
      sym_qualified_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [325767] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(10875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13818), 1,
      sym_identifier,
    ACTIONS(13820), 1,
      anon_sym_template,
    STATE(3538), 1,
      sym_template_type,
    STATE(3539), 1,
      sym_dependent_type_identifier,
    STATE(3554), 1,
      sym_qualified_type_identifier,
    STATE(8655), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [325798] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5781), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13800), 1,
      anon_sym_inline,
    ACTIONS(13822), 1,
      sym_identifier,
    STATE(993), 1,
      sym_declaration_list,
    STATE(8911), 1,
      sym_attribute_declaration,
    STATE(10428), 1,
      sym_nested_namespace_specifier,
    STATE(11683), 1,
      sym__namespace_specifier,
  [325829] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym___attribute,
    ACTIONS(13666), 1,
      anon_sym_COMMA,
    ACTIONS(13824), 1,
      anon_sym_EQ,
    STATE(8800), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [325852] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    ACTIONS(12999), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [325879] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12377), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4120), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_GT2,
  [325904] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13403), 1,
      anon_sym_COMMA,
    STATE(8686), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(12519), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [325925] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12532), 1,
      anon_sym___attribute,
    ACTIONS(12841), 1,
      anon_sym_COLON,
    ACTIONS(13826), 1,
      anon_sym_EQ,
    STATE(8822), 1,
      sym_interface_requirements,
    ACTIONS(12530), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [325948] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8816), 1,
      anon_sym_where,
    ACTIONS(11830), 1,
      anon_sym___attribute,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(11828), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [325969] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12367), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4120), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_GT2,
  [325994] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3767), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [326017] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(12423), 1,
      anon_sym_LBRACK,
    ACTIONS(13828), 1,
      anon_sym_COMMA,
    ACTIONS(13830), 1,
      anon_sym_EQ,
    STATE(9011), 1,
      sym_interface_requirements,
    STATE(9078), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [326044] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(8546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13832), 1,
      sym_identifier,
    ACTIONS(13834), 1,
      anon_sym_template,
    STATE(2967), 1,
      sym_qualified_type_identifier,
    STATE(3003), 1,
      sym_template_type,
    STATE(3004), 1,
      sym_dependent_type_identifier,
    STATE(8666), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [326075] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(13836), 1,
      anon_sym_EQ,
    STATE(8934), 1,
      sym_interface_requirements,
    ACTIONS(12530), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_try,
  [326096] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12623), 1,
      anon_sym___attribute,
    ACTIONS(13839), 1,
      anon_sym_EQ,
    ACTIONS(12621), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [326115] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(11172), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13786), 1,
      anon_sym_template,
    ACTIONS(13842), 1,
      sym_identifier,
    STATE(205), 1,
      sym_template_type,
    STATE(206), 1,
      sym_dependent_type_identifier,
    STATE(214), 1,
      sym_qualified_type_identifier,
    STATE(8669), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [326146] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3883), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_requires,
  [326169] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13844), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(11490), 1,
      sym_qualified_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [326196] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(835), 1,
      sym_field_declaration_list,
    STATE(9456), 1,
      sym_virtual_specifier,
    STATE(10431), 1,
      sym_base_class_clause,
    ACTIONS(2568), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
  [326223] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13846), 1,
      anon_sym_EQ,
    ACTIONS(12621), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(12623), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [326242] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(11852), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13848), 1,
      sym_identifier,
    ACTIONS(13850), 1,
      anon_sym_template,
    STATE(2720), 1,
      sym_qualified_type_identifier,
    STATE(2721), 1,
      sym_dependent_type_identifier,
    STATE(2723), 1,
      sym_template_type,
    STATE(8674), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [326273] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12429), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4273), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
  [326298] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13852), 1,
      sym_identifier,
    ACTIONS(13854), 1,
      anon_sym_template,
    STATE(4985), 1,
      sym_template_type,
    STATE(5011), 1,
      sym_dependent_type_identifier,
    STATE(5019), 1,
      sym_qualified_type_identifier,
    STATE(8676), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [326329] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(11031), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13834), 1,
      anon_sym_template,
    ACTIONS(13856), 1,
      sym_identifier,
    STATE(2967), 1,
      sym_qualified_type_identifier,
    STATE(3003), 1,
      sym_template_type,
    STATE(3004), 1,
      sym_dependent_type_identifier,
    STATE(8677), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [326360] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3883), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_requires,
  [326383] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(8680), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13804), 1,
      anon_sym_template,
    ACTIONS(13858), 1,
      sym_identifier,
    STATE(5289), 1,
      sym_template_type,
    STATE(5290), 1,
      sym_dependent_type_identifier,
    STATE(5305), 1,
      sym_qualified_type_identifier,
    STATE(8679), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [326414] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13860), 1,
      sym_identifier,
    ACTIONS(13862), 1,
      sym_system_lib_string,
    STATE(10972), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(13768), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [326435] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3767), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [326458] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13403), 1,
      anon_sym_COMMA,
    STATE(8771), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(12525), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [326479] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13864), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(11259), 1,
      sym_qualified_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [326506] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(11431), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13786), 1,
      anon_sym_template,
    ACTIONS(13842), 1,
      sym_identifier,
    STATE(205), 1,
      sym_template_type,
    STATE(206), 1,
      sym_dependent_type_identifier,
    STATE(2921), 1,
      sym_qualified_type_identifier,
    STATE(8684), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [326537] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13403), 1,
      anon_sym_COMMA,
    STATE(8686), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(12525), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [326558] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13866), 1,
      anon_sym_COMMA,
    STATE(8686), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(12532), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [326579] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(3686), 1,
      sym_template_argument_list,
    ACTIONS(2234), 2,
      anon_sym_COLON,
      anon_sym_LBRACK,
    ACTIONS(2224), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [326602] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3767), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [326625] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(10988), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13869), 1,
      sym_identifier,
    ACTIONS(13871), 1,
      anon_sym_template,
    STATE(3107), 1,
      sym_template_type,
    STATE(3109), 1,
      sym_dependent_type_identifier,
    STATE(3126), 1,
      sym_qualified_type_identifier,
    STATE(8689), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [326656] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13590), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(10876), 1,
      sym_qualified_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [326683] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3883), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_requires,
  [326706] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13492), 1,
      anon_sym_COMMA,
    STATE(8695), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 7,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [326725] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13492), 1,
      anon_sym_COMMA,
    STATE(8697), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 7,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [326744] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13492), 1,
      anon_sym_COMMA,
    STATE(8695), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 7,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [326763] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13873), 1,
      anon_sym_COMMA,
    STATE(8695), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 7,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [326782] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(828), 1,
      sym_field_declaration_list,
    STATE(9473), 1,
      sym_virtual_specifier,
    STATE(10570), 1,
      sym_base_class_clause,
    ACTIONS(2558), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(7352), 2,
      anon_sym_final,
      anon_sym_override,
  [326809] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13492), 1,
      anon_sym_COMMA,
    STATE(8695), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 7,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [326828] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13492), 1,
      anon_sym_COMMA,
    STATE(8699), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 7,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [326847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13492), 1,
      anon_sym_COMMA,
    STATE(8695), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 7,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [326866] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3767), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [326889] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13403), 1,
      anon_sym_COMMA,
    STATE(8702), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(12536), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [326910] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13403), 1,
      anon_sym_COMMA,
    STATE(8686), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(12540), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [326931] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym___attribute,
    ACTIONS(13697), 1,
      anon_sym_COMMA,
    ACTIONS(13876), 1,
      anon_sym_EQ,
    STATE(8888), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 5,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [326954] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(13878), 1,
      anon_sym_COMMA,
    ACTIONS(13880), 1,
      anon_sym_EQ,
    STATE(8850), 1,
      sym_interface_requirements,
    STATE(8851), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [326979] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(11726), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13882), 1,
      sym_identifier,
    ACTIONS(13884), 1,
      anon_sym_template,
    STATE(3490), 1,
      sym_template_type,
    STATE(3491), 1,
      sym_dependent_type_identifier,
    STATE(3519), 1,
      sym_qualified_type_identifier,
    STATE(8705), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [327010] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(13743), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13886), 1,
      sym_identifier,
    ACTIONS(13888), 1,
      anon_sym_template,
    STATE(3677), 1,
      sym_template_type,
    STATE(3678), 1,
      sym_dependent_type_identifier,
    STATE(3684), 1,
      sym_qualified_type_identifier,
    STATE(8706), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [327041] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11217), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10024), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [327060] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11396), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10823), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [327079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11569), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11262), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [327098] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12908), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11653), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [327117] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13297), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(11828), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [327136] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13890), 1,
      anon_sym_where,
    STATE(7487), 1,
      sym_where_clause,
    ACTIONS(12542), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [327155] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11214), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10024), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [327174] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11393), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10823), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [327193] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11578), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11262), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [327212] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12942), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11653), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [327231] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13285), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(11828), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [327250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13893), 1,
      anon_sym_where,
    STATE(7487), 1,
      sym_where_clause,
    ACTIONS(12542), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [327269] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5779), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13800), 1,
      anon_sym_inline,
    ACTIONS(13896), 1,
      sym_identifier,
    STATE(1113), 1,
      sym_declaration_list,
    STATE(9017), 1,
      sym_attribute_declaration,
    STATE(10464), 1,
      sym_nested_namespace_specifier,
    STATE(11683), 1,
      sym__namespace_specifier,
  [327300] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12407), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4120), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_GT2,
  [327325] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13898), 1,
      sym_identifier,
    ACTIONS(13900), 1,
      sym_system_lib_string,
    STATE(11084), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(13768), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [327346] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8816), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym___attribute,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [327367] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(10930), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13902), 1,
      sym_identifier,
    ACTIONS(13904), 1,
      anon_sym_template,
    STATE(4536), 1,
      sym_template_type,
    STATE(4537), 1,
      sym_dependent_type_identifier,
    STATE(4721), 1,
      sym_qualified_type_identifier,
    STATE(8723), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [327398] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    ACTIONS(13152), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [327425] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    ACTIONS(13158), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [327452] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12429), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4120), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_GT2,
  [327477] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(8753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13788), 1,
      sym_identifier,
    ACTIONS(13790), 1,
      anon_sym_template,
    STATE(205), 1,
      sym_template_type,
    STATE(206), 1,
      sym_dependent_type_identifier,
    STATE(214), 1,
      sym_qualified_type_identifier,
    STATE(8727), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [327508] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12532), 1,
      anon_sym___attribute,
    ACTIONS(12841), 1,
      anon_sym_COLON,
    ACTIONS(13906), 1,
      anon_sym_EQ,
    STATE(8896), 1,
      sym_interface_requirements,
    ACTIONS(12530), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [327531] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13624), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(11611), 1,
      sym_qualified_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [327558] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13908), 1,
      sym_identifier,
    ACTIONS(13910), 1,
      sym_system_lib_string,
    STATE(11385), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(13768), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [327579] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(8733), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13751), 1,
      anon_sym_template,
    ACTIONS(13882), 1,
      sym_identifier,
    STATE(5289), 1,
      sym_template_type,
    STATE(5290), 1,
      sym_dependent_type_identifier,
    STATE(5305), 1,
      sym_qualified_type_identifier,
    STATE(8731), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [327610] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12863), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11653), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(11655), 4,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [327631] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12377), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4273), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
  [327656] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3767), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [327679] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8876), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym___attribute,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [327700] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8876), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym___attribute,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [327721] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5773), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13800), 1,
      anon_sym_inline,
    ACTIONS(13912), 1,
      sym_identifier,
    STATE(549), 1,
      sym_declaration_list,
    STATE(9001), 1,
      sym_attribute_declaration,
    STATE(10647), 1,
      sym_nested_namespace_specifier,
    STATE(11683), 1,
      sym__namespace_specifier,
  [327752] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8876), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym___attribute,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11262), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [327773] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8876), 1,
      anon_sym_where,
    ACTIONS(11655), 1,
      anon_sym___attribute,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11653), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [327794] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12450), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4273), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
  [327819] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(11792), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13753), 1,
      sym_identifier,
    STATE(205), 1,
      sym_template_type,
    STATE(206), 1,
      sym_dependent_type_identifier,
    STATE(214), 1,
      sym_qualified_type_identifier,
    STATE(8741), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [327850] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8876), 1,
      anon_sym_where,
    ACTIONS(11830), 1,
      anon_sym___attribute,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(11828), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [327871] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5777), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13800), 1,
      anon_sym_inline,
    ACTIONS(13914), 1,
      sym_identifier,
    STATE(1124), 1,
      sym_declaration_list,
    STATE(8919), 1,
      sym_attribute_declaration,
    STATE(10556), 1,
      sym_nested_namespace_specifier,
    STATE(11683), 1,
      sym__namespace_specifier,
  [327902] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13419), 1,
      anon_sym_COMMA,
    STATE(8760), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 7,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [327921] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8876), 1,
      anon_sym_where,
    ACTIONS(12544), 1,
      anon_sym___attribute,
    STATE(7487), 1,
      sym_where_clause,
    ACTIONS(12542), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [327942] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(10904), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13916), 1,
      sym_identifier,
    ACTIONS(13918), 1,
      anon_sym_template,
    STATE(3494), 1,
      sym_template_type,
    STATE(3495), 1,
      sym_dependent_type_identifier,
    STATE(3523), 1,
      sym_qualified_type_identifier,
    STATE(8746), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [327973] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13419), 1,
      anon_sym_COMMA,
    STATE(8608), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 7,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [327992] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13419), 1,
      anon_sym_COMMA,
    STATE(8760), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 7,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [328011] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8816), 1,
      anon_sym_where,
    ACTIONS(12544), 1,
      anon_sym___attribute,
    STATE(7487), 1,
      sym_where_clause,
    ACTIONS(12542), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [328032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13920), 1,
      anon_sym_EQ,
    ACTIONS(12621), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [328049] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(12783), 1,
      anon_sym_COLON,
    STATE(9612), 1,
      sym_semantics,
    STATE(5308), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(13922), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [328074] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(11750), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13924), 1,
      sym_identifier,
    ACTIONS(13926), 1,
      anon_sym_template,
    STATE(2689), 1,
      sym_dependent_type_identifier,
    STATE(2700), 1,
      sym_template_type,
    STATE(2701), 1,
      sym_qualified_type_identifier,
    STATE(8752), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [328105] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12407), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4273), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
  [328130] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(4409), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13755), 1,
      sym_identifier,
    ACTIONS(13757), 1,
      anon_sym_template,
    STATE(2720), 1,
      sym_qualified_type_identifier,
    STATE(2721), 1,
      sym_dependent_type_identifier,
    STATE(2723), 1,
      sym_template_type,
    STATE(8754), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [328161] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12415), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4273), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
  [328186] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(12783), 1,
      anon_sym_COLON,
    STATE(9819), 1,
      sym_semantics,
    STATE(5308), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(13810), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [328211] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13928), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(11376), 1,
      sym_qualified_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [328238] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5773), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13800), 1,
      anon_sym_inline,
    ACTIONS(13930), 1,
      sym_identifier,
    STATE(576), 1,
      sym_declaration_list,
    STATE(9013), 1,
      sym_attribute_declaration,
    STATE(10753), 1,
      sym_nested_namespace_specifier,
    STATE(11683), 1,
      sym__namespace_specifier,
  [328269] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13932), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(11249), 1,
      sym_qualified_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [328296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13934), 1,
      anon_sym_COMMA,
    STATE(8760), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 7,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      anon_sym_where,
  [328315] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12450), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4120), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_GT2,
  [328340] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13937), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(11054), 1,
      sym_qualified_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [328367] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(11160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13939), 1,
      sym_identifier,
    ACTIONS(13941), 1,
      anon_sym_template,
    STATE(399), 1,
      sym_template_type,
    STATE(400), 1,
      sym_dependent_type_identifier,
    STATE(401), 1,
      sym_qualified_type_identifier,
    STATE(8763), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [328398] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13479), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(11065), 1,
      sym_qualified_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [328425] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12443), 1,
      anon_sym___attribute,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4273), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
  [328450] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1816), 1,
      anon_sym_template,
    ACTIONS(12435), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13548), 1,
      sym_identifier,
    STATE(7431), 1,
      sym__scope_resolution,
    STATE(11108), 1,
      sym_qualified_identifier,
    STATE(11339), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [328477] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5779), 1,
      anon_sym_LBRACE,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13800), 1,
      anon_sym_inline,
    ACTIONS(13943), 1,
      sym_identifier,
    STATE(1091), 1,
      sym_declaration_list,
    STATE(9007), 1,
      sym_attribute_declaration,
    STATE(10512), 1,
      sym_nested_namespace_specifier,
    STATE(11683), 1,
      sym__namespace_specifier,
  [328508] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8816), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym___attribute,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [328529] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13945), 1,
      sym_identifier,
    ACTIONS(13947), 1,
      anon_sym_template,
    STATE(2720), 1,
      sym_qualified_type_identifier,
    STATE(2721), 1,
      sym_dependent_type_identifier,
    STATE(2723), 1,
      sym_template_type,
    STATE(8769), 1,
      sym__scope_resolution,
    STATE(11339), 1,
      sym_decltype,
  [328560] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11390), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10823), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(10825), 4,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [328581] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13403), 1,
      anon_sym_COMMA,
    STATE(8686), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
    ACTIONS(12536), 5,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_where,
  [328602] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(13949), 1,
      anon_sym_SEMI,
    ACTIONS(13951), 1,
      anon_sym_EQ,
    STATE(2953), 1,
      sym_template_argument_list,
    STATE(9556), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [328628] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(13953), 1,
      anon_sym_SEMI,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [328654] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11647), 1,
      anon_sym_LBRACK,
    ACTIONS(12938), 1,
      anon_sym_RPAREN,
    STATE(4464), 1,
      sym_parameter_list,
    STATE(8205), 1,
      sym__function_declarator_seq,
    STATE(9190), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [328680] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11476), 1,
      anon_sym_DASH_GT,
    ACTIONS(11478), 1,
      anon_sym_requires,
    ACTIONS(13337), 1,
      anon_sym_LBRACE,
    STATE(10090), 1,
      sym_trailing_return_type,
    STATE(11035), 1,
      sym_requires_clause,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [328706] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11647), 1,
      anon_sym_LBRACK,
    ACTIONS(12945), 1,
      anon_sym_RPAREN,
    STATE(4464), 1,
      sym_parameter_list,
    STATE(8205), 1,
      sym__function_declarator_seq,
    STATE(9190), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [328732] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym___attribute,
    ACTIONS(13697), 1,
      anon_sym_COMMA,
    STATE(8890), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 5,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [328752] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym___attribute,
    ACTIONS(13697), 1,
      anon_sym_COMMA,
    STATE(8780), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 5,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [328772] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11647), 1,
      anon_sym_LBRACK,
    ACTIONS(12866), 1,
      anon_sym_RPAREN,
    STATE(4464), 1,
      sym_parameter_list,
    STATE(8205), 1,
      sym__function_declarator_seq,
    STATE(9190), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [328798] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12540), 1,
      anon_sym___attribute,
    ACTIONS(13697), 1,
      anon_sym_COMMA,
    STATE(8890), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 5,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [328818] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(7783), 1,
      anon_sym_LBRACK,
    STATE(3686), 1,
      sym_template_argument_list,
    ACTIONS(7785), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [328838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8592), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10024), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [328856] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11476), 1,
      anon_sym_DASH_GT,
    ACTIONS(11478), 1,
      anon_sym_requires,
    ACTIONS(13955), 1,
      anon_sym_LBRACE,
    STATE(9870), 1,
      sym_trailing_return_type,
    STATE(10994), 1,
      sym_requires_clause,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [328882] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11476), 1,
      anon_sym_DASH_GT,
    ACTIONS(11478), 1,
      anon_sym_requires,
    ACTIONS(13957), 1,
      anon_sym_LBRACE,
    STATE(9889), 1,
      sym_trailing_return_type,
    STATE(11092), 1,
      sym_requires_clause,
    STATE(8830), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [328908] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11476), 1,
      anon_sym_DASH_GT,
    ACTIONS(11478), 1,
      anon_sym_requires,
    ACTIONS(13957), 1,
      anon_sym_LBRACE,
    STATE(9889), 1,
      sym_trailing_return_type,
    STATE(11092), 1,
      sym_requires_clause,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [328934] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13959), 1,
      sym_identifier,
    ACTIONS(13964), 1,
      aux_sym_preproc_elif_token1,
    STATE(8786), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(10970), 1,
      sym_enumerator,
    ACTIONS(13962), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [328956] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13674), 1,
      anon_sym_COMMA,
    ACTIONS(13966), 1,
      anon_sym_EQ,
    STATE(8791), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_try,
  [328976] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13674), 1,
      anon_sym_COMMA,
    STATE(8792), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [328994] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(13968), 1,
      anon_sym_SEMI,
    ACTIONS(13970), 1,
      anon_sym_EQ,
    STATE(2953), 1,
      sym_template_argument_list,
    STATE(9569), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [329020] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13674), 1,
      anon_sym_COMMA,
    STATE(8793), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [329038] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13674), 1,
      anon_sym_COMMA,
    STATE(8792), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [329056] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13972), 1,
      anon_sym_COMMA,
    STATE(8792), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [329074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13674), 1,
      anon_sym_COMMA,
    STATE(8792), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [329092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13674), 1,
      anon_sym_COMMA,
    STATE(8796), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [329110] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_COMMA,
    ACTIONS(13975), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(13977), 1,
      anon_sym_RBRACK,
    ACTIONS(13980), 1,
      anon_sym_EQ,
    STATE(2953), 1,
      sym_template_argument_list,
    STATE(9611), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [329138] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13674), 1,
      anon_sym_COMMA,
    STATE(8792), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [329156] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11647), 1,
      anon_sym_LBRACK,
    ACTIONS(13982), 1,
      anon_sym_RPAREN,
    STATE(4464), 1,
      sym_parameter_list,
    STATE(8205), 1,
      sym__function_declarator_seq,
    STATE(9190), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [329182] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym___attribute,
    ACTIONS(13666), 1,
      anon_sym_COMMA,
    STATE(8801), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [329202] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym___attribute,
    ACTIONS(13666), 1,
      anon_sym_COMMA,
    STATE(8802), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [329222] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym___attribute,
    ACTIONS(13666), 1,
      anon_sym_COMMA,
    STATE(8801), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [329242] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12532), 1,
      anon_sym___attribute,
    ACTIONS(13984), 1,
      anon_sym_COMMA,
    STATE(8801), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [329262] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym___attribute,
    ACTIONS(13666), 1,
      anon_sym_COMMA,
    STATE(8801), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [329282] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(13987), 1,
      anon_sym_COMMA,
    ACTIONS(13989), 1,
      anon_sym_EQ,
    STATE(9018), 1,
      sym_interface_requirements,
    STATE(9019), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [329306] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym___attribute,
    ACTIONS(13666), 1,
      anon_sym_COMMA,
    STATE(8805), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [329326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12540), 1,
      anon_sym___attribute,
    ACTIONS(13666), 1,
      anon_sym_COMMA,
    STATE(8801), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [329346] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(13991), 1,
      anon_sym_SEMI,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [329372] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8592), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11653), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [329390] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11476), 1,
      anon_sym_DASH_GT,
    ACTIONS(11478), 1,
      anon_sym_requires,
    ACTIONS(13993), 1,
      anon_sym_LBRACE,
    STATE(9968), 1,
      sym_trailing_return_type,
    STATE(11541), 1,
      sym_requires_clause,
    STATE(8783), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [329416] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13995), 1,
      sym_identifier,
    ACTIONS(14000), 1,
      aux_sym_preproc_elif_token1,
    STATE(8809), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    ACTIONS(13998), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [329436] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11476), 1,
      anon_sym_DASH_GT,
    ACTIONS(11478), 1,
      anon_sym_requires,
    ACTIONS(13993), 1,
      anon_sym_LBRACE,
    STATE(9968), 1,
      sym_trailing_return_type,
    STATE(11541), 1,
      sym_requires_clause,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [329462] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      sym_identifier,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10024), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [329482] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12687), 1,
      anon_sym_LBRACK,
    STATE(8091), 1,
      sym_parameter_list,
    ACTIONS(7572), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(8929), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [329506] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11476), 1,
      anon_sym_DASH_GT,
    ACTIONS(11478), 1,
      anon_sym_requires,
    ACTIONS(13255), 1,
      anon_sym_LBRACE,
    STATE(9979), 1,
      sym_trailing_return_type,
    STATE(11612), 1,
      sym_requires_clause,
    STATE(8785), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [329532] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12687), 1,
      anon_sym_LBRACK,
    STATE(8091), 1,
      sym_parameter_list,
    ACTIONS(7560), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(8929), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [329556] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11476), 1,
      anon_sym_DASH_GT,
    ACTIONS(11478), 1,
      anon_sym_requires,
    ACTIONS(13255), 1,
      anon_sym_LBRACE,
    STATE(9979), 1,
      sym_trailing_return_type,
    STATE(11612), 1,
      sym_requires_clause,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [329582] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12687), 1,
      anon_sym_LBRACK,
    STATE(8091), 1,
      sym_parameter_list,
    ACTIONS(7556), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(8929), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [329606] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      sym_identifier,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10823), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [329626] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12687), 1,
      anon_sym_LBRACK,
    STATE(8091), 1,
      sym_parameter_list,
    ACTIONS(7587), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(8929), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [329650] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(14002), 1,
      anon_sym_EQ,
    STATE(9057), 1,
      sym_interface_requirements,
    ACTIONS(12530), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [329670] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12687), 1,
      anon_sym_LBRACK,
    STATE(8091), 1,
      sym_parameter_list,
    ACTIONS(7496), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(8929), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [329694] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      sym_identifier,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11262), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [329714] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12623), 1,
      anon_sym___attribute,
    ACTIONS(14004), 1,
      anon_sym_EQ,
    ACTIONS(12621), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [329732] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13682), 1,
      anon_sym_LBRACK,
    STATE(9781), 1,
      sym_gnu_asm_input_operand,
    STATE(11070), 1,
      sym_string_literal,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [329752] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_where,
    ACTIONS(11655), 1,
      sym_identifier,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11653), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [329772] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(14006), 1,
      anon_sym_SEMI,
    ACTIONS(14008), 1,
      anon_sym_EQ,
    STATE(2953), 1,
      sym_template_argument_list,
    STATE(9574), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [329798] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_where,
    ACTIONS(11830), 1,
      sym_identifier,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(11828), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [329818] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_where,
    ACTIONS(12544), 1,
      sym_identifier,
    STATE(7487), 1,
      sym_where_clause,
    ACTIONS(12542), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
  [329838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8592), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(11828), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [329856] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(14010), 1,
      anon_sym_COMMA,
    ACTIONS(14012), 1,
      anon_sym_EQ,
    STATE(9062), 1,
      sym_interface_requirements,
    STATE(9296), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [329880] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11476), 1,
      anon_sym_DASH_GT,
    ACTIONS(11478), 1,
      anon_sym_requires,
    ACTIONS(14014), 1,
      anon_sym_LBRACE,
    STATE(10206), 1,
      sym_trailing_return_type,
    STATE(11292), 1,
      sym_requires_clause,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [329906] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(13152), 1,
      anon_sym_COLON,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [329932] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(13158), 1,
      anon_sym_COLON,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [329958] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(13003), 1,
      anon_sym_COLON,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [329984] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(14016), 1,
      anon_sym_SEMI,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [330010] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(13059), 1,
      anon_sym_COLON,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [330036] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11476), 1,
      anon_sym_DASH_GT,
    ACTIONS(11478), 1,
      anon_sym_requires,
    ACTIONS(13337), 1,
      anon_sym_LBRACE,
    STATE(10090), 1,
      sym_trailing_return_type,
    STATE(11035), 1,
      sym_requires_clause,
    STATE(8810), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [330062] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [330084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14020), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(14018), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [330100] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [330122] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11647), 1,
      anon_sym_LBRACK,
    ACTIONS(14022), 1,
      anon_sym_RPAREN,
    STATE(4464), 1,
      sym_parameter_list,
    STATE(8205), 1,
      sym__function_declarator_seq,
    STATE(9190), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [330148] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(14024), 1,
      anon_sym_SEMI,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [330174] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [330196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8592), 1,
      anon_sym_where,
    STATE(7487), 1,
      sym_where_clause,
    ACTIONS(12542), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [330214] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12461), 1,
      anon_sym___attribute,
    ACTIONS(14026), 1,
      anon_sym_EQ,
    ACTIONS(12463), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [330232] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(14028), 1,
      anon_sym_RPAREN,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [330258] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2234), 1,
      anon_sym_LBRACK,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(7909), 1,
      sym_template_argument_list,
    ACTIONS(2224), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [330280] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(14030), 1,
      anon_sym_SEMI,
    ACTIONS(14032), 1,
      anon_sym_EQ,
    STATE(2953), 1,
      sym_template_argument_list,
    STATE(9535), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [330306] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(12532), 1,
      anon_sym_LBRACK,
    ACTIONS(14034), 1,
      anon_sym_EQ,
    STATE(9154), 1,
      sym_interface_requirements,
    ACTIONS(12530), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [330328] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(14036), 1,
      anon_sym_RPAREN,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [330354] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13878), 1,
      anon_sym_COMMA,
    ACTIONS(14038), 1,
      anon_sym_EQ,
    STATE(8853), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 5,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [330374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13878), 1,
      anon_sym_COMMA,
    STATE(8854), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 6,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_requires,
  [330392] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13878), 1,
      anon_sym_COMMA,
    STATE(8855), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 6,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_requires,
  [330410] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13878), 1,
      anon_sym_COMMA,
    STATE(8854), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 6,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_requires,
  [330428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14040), 1,
      anon_sym_COMMA,
    STATE(8854), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 6,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_requires,
  [330446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13878), 1,
      anon_sym_COMMA,
    STATE(8854), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 6,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_requires,
  [330464] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [330486] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13878), 1,
      anon_sym_COMMA,
    STATE(8858), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 6,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_requires,
  [330504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13878), 1,
      anon_sym_COMMA,
    STATE(8854), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 6,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_requires,
  [330522] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(14043), 1,
      anon_sym_SEMI,
    ACTIONS(14045), 1,
      anon_sym_EQ,
    STATE(2953), 1,
      sym_template_argument_list,
    STATE(9500), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [330548] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3869), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
  [330570] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(14047), 1,
      anon_sym_SEMI,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [330596] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3869), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
  [330618] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [330640] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3869), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
  [330662] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(14049), 1,
      anon_sym_COMMA,
    ACTIONS(14051), 1,
      anon_sym_EQ,
    STATE(9073), 1,
      sym_interface_requirements,
    STATE(9224), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [330686] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3869), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
  [330708] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14055), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(14057), 1,
      anon_sym_EQ,
    ACTIONS(14053), 6,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [330726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12461), 1,
      anon_sym___attribute,
    ACTIONS(14059), 1,
      anon_sym_EQ,
    ACTIONS(12463), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [330744] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12841), 1,
      anon_sym_COLON,
    ACTIONS(14061), 1,
      anon_sym_EQ,
    STATE(8963), 1,
      sym_interface_requirements,
    ACTIONS(12530), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [330764] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(14064), 1,
      anon_sym_COLON,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [330790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14068), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(14066), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [330806] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3869), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
  [330828] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3869), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
  [330850] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(14070), 1,
      anon_sym_SEMI,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [330876] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [330898] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3767), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(14072), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [330920] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3869), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
  [330942] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [330964] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [330986] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(3869), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_identifier,
  [331008] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym___attribute,
    ACTIONS(13697), 1,
      anon_sym_COMMA,
    STATE(8890), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 5,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [331028] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11647), 1,
      anon_sym_LBRACK,
    ACTIONS(12892), 1,
      anon_sym_RPAREN,
    STATE(4464), 1,
      sym_parameter_list,
    STATE(8205), 1,
      sym__function_declarator_seq,
    STATE(9190), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [331054] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(11647), 1,
      anon_sym_LBRACK,
    ACTIONS(12904), 1,
      anon_sym_RPAREN,
    STATE(4464), 1,
      sym_parameter_list,
    STATE(8205), 1,
      sym__function_declarator_seq,
    STATE(9190), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [331080] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13745), 1,
      anon_sym_COMMA,
    ACTIONS(14074), 1,
      anon_sym_EQ,
    STATE(8949), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [331100] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(7330), 1,
      anon_sym_LBRACK,
    STATE(7909), 1,
      sym_template_argument_list,
    ACTIONS(6761), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [331122] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(14076), 1,
      anon_sym_SEMI,
    ACTIONS(14078), 1,
      anon_sym_EQ,
    STATE(2953), 1,
      sym_template_argument_list,
    STATE(9546), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [331148] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym___attribute,
    ACTIONS(13697), 1,
      anon_sym_COMMA,
    STATE(8777), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 5,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [331168] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym___attribute,
    ACTIONS(13697), 1,
      anon_sym_COMMA,
    STATE(8890), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 5,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [331188] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8592), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11262), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [331206] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12532), 1,
      anon_sym___attribute,
    ACTIONS(14080), 1,
      anon_sym_COMMA,
    STATE(8890), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 5,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [331226] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(14083), 1,
      anon_sym_SEMI,
    ACTIONS(14085), 1,
      anon_sym_EQ,
    STATE(2953), 1,
      sym_template_argument_list,
    STATE(9577), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [331252] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8592), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10823), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [331270] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13690), 1,
      anon_sym_LBRACK,
    STATE(10116), 1,
      sym_gnu_asm_output_operand,
    STATE(11510), 1,
      sym_string_literal,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [331290] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(14087), 1,
      anon_sym_SEMI,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [331316] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(14089), 1,
      anon_sym_SEMI,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8531), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [331342] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12623), 1,
      anon_sym___attribute,
    ACTIONS(14091), 1,
      anon_sym_EQ,
    ACTIONS(12621), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [331360] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    ACTIONS(12999), 1,
      anon_sym_COLON,
    STATE(3687), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(7767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [331386] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9181), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11262), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [331403] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14095), 1,
      anon_sym_EQ,
    ACTIONS(14097), 1,
      anon_sym_GT2,
    STATE(9537), 1,
      sym_interface_requirements,
    STATE(10158), 1,
      aux_sym_template_argument_list_repeat1,
  [331428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13745), 1,
      anon_sym_COMMA,
    STATE(8967), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [331445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14099), 1,
      anon_sym_LPAREN2,
    STATE(8916), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(14101), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [331462] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14103), 1,
      anon_sym_EQ,
    ACTIONS(14105), 1,
      anon_sym_GT2,
    STATE(9461), 1,
      sym_interface_requirements,
    STATE(9937), 1,
      aux_sym_template_argument_list_repeat1,
  [331487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13987), 1,
      anon_sym_COMMA,
    STATE(8913), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 5,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      sym_identifier,
  [331504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13987), 1,
      anon_sym_COMMA,
    STATE(8906), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 5,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      sym_identifier,
  [331521] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9185), 1,
      anon_sym_where,
    ACTIONS(11655), 1,
      anon_sym_LBRACK,
    STATE(7608), 1,
      sym_where_clause,
    ACTIONS(11653), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [331540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14107), 1,
      anon_sym_COMMA,
    STATE(8906), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 5,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      sym_identifier,
  [331557] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14110), 1,
      anon_sym_LPAREN2,
    STATE(8907), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(14112), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [331574] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14115), 1,
      anon_sym_EQ,
    ACTIONS(14117), 1,
      anon_sym_GT2,
    STATE(9403), 1,
      sym_interface_requirements,
    STATE(9712), 1,
      aux_sym_template_argument_list_repeat1,
  [331599] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14119), 1,
      anon_sym_EQ,
    ACTIONS(14121), 1,
      anon_sym_GT2,
    STATE(9385), 1,
      sym_interface_requirements,
    STATE(9649), 1,
      aux_sym_template_argument_list_repeat1,
  [331624] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14123), 1,
      anon_sym_EQ,
    ACTIONS(14125), 1,
      anon_sym_GT2,
    STATE(9449), 1,
      sym_interface_requirements,
    STATE(9603), 1,
      aux_sym_template_argument_list_repeat1,
  [331649] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5781), 1,
      anon_sym_LBRACE,
    ACTIONS(13798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13800), 1,
      anon_sym_inline,
    ACTIONS(14127), 1,
      sym_identifier,
    STATE(1049), 1,
      sym_declaration_list,
    STATE(10531), 1,
      sym_nested_namespace_specifier,
    STATE(11683), 1,
      sym__namespace_specifier,
  [331674] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    STATE(7134), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(7524), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [331695] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13987), 1,
      anon_sym_COMMA,
    STATE(8906), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 5,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      sym_identifier,
  [331712] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14129), 1,
      anon_sym_EQ,
    ACTIONS(14131), 1,
      anon_sym_GT2,
    STATE(9515), 1,
      sym_interface_requirements,
    STATE(10095), 1,
      aux_sym_template_argument_list_repeat1,
  [331737] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12697), 1,
      anon_sym_LBRACK,
    STATE(3616), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym__function_declarator_seq,
    STATE(8520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [331760] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14133), 1,
      anon_sym_LPAREN2,
    STATE(8907), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(14101), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [331777] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9185), 1,
      anon_sym_where,
    ACTIONS(11830), 1,
      anon_sym_LBRACK,
    STATE(7625), 1,
      sym_where_clause,
    ACTIONS(11828), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [331796] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12841), 1,
      anon_sym_COLON,
    ACTIONS(14135), 1,
      anon_sym_EQ,
    STATE(9147), 1,
      sym_interface_requirements,
    ACTIONS(12530), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [331815] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5777), 1,
      anon_sym_LBRACE,
    ACTIONS(13796), 1,
      sym_identifier,
    ACTIONS(13798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13800), 1,
      anon_sym_inline,
    STATE(1136), 1,
      sym_declaration_list,
    STATE(10591), 1,
      sym_nested_namespace_specifier,
    STATE(11683), 1,
      sym__namespace_specifier,
  [331840] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14138), 1,
      anon_sym_LPAREN2,
    STATE(8922), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(14101), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [331857] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13987), 1,
      anon_sym_COMMA,
    STATE(8930), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 5,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      sym_identifier,
  [331874] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14140), 1,
      anon_sym_LPAREN2,
    STATE(8907), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(14101), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [331891] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14142), 1,
      anon_sym_EQ,
    ACTIONS(14144), 1,
      anon_sym_GT2,
    STATE(9477), 1,
      sym_interface_requirements,
    STATE(9976), 1,
      aux_sym_template_argument_list_repeat1,
  [331916] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(14146), 1,
      anon_sym_EQ,
    STATE(9229), 1,
      sym_interface_requirements,
    ACTIONS(12530), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [331935] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9185), 1,
      anon_sym_where,
    ACTIONS(12544), 1,
      anon_sym_LBRACK,
    STATE(7605), 1,
      sym_where_clause,
    ACTIONS(12542), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [331954] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9185), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      anon_sym_LBRACK,
    STATE(7624), 1,
      sym_where_clause,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [331973] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7502), 1,
      anon_sym_LBRACK,
    ACTIONS(7560), 1,
      anon_sym_COLON,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    STATE(3274), 1,
      sym_parameter_list,
    STATE(9084), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [331996] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7496), 1,
      anon_sym_COLON,
    ACTIONS(7502), 1,
      anon_sym_LBRACK,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    STATE(3274), 1,
      sym_parameter_list,
    STATE(9084), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [332019] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7594), 1,
      anon_sym_LBRACK,
    STATE(7796), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(7596), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [332038] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13987), 1,
      anon_sym_COMMA,
    STATE(8906), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 5,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      sym_identifier,
  [332055] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14148), 1,
      anon_sym_LBRACK,
    ACTIONS(14150), 1,
      anon_sym_EQ,
    ACTIONS(14152), 1,
      anon_sym_DOT,
    STATE(8959), 4,
      sym_subscript_designator,
      sym_subscript_range_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [332074] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13772), 1,
      anon_sym_COMMA,
    ACTIONS(14154), 1,
      anon_sym_EQ,
    STATE(9108), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [332093] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14156), 1,
      anon_sym_LPAREN2,
    STATE(8944), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(14101), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [332110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14158), 1,
      anon_sym_EQ,
    ACTIONS(12621), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_try,
  [332125] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym___attribute__,
    ACTIONS(8129), 1,
      anon_sym___attribute,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6950), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6955), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [332146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13745), 1,
      anon_sym_COMMA,
    STATE(8953), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [332163] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14161), 1,
      anon_sym_EQ,
    ACTIONS(14163), 1,
      anon_sym_GT2,
    STATE(9555), 1,
      sym_interface_requirements,
    STATE(10214), 1,
      aux_sym_template_argument_list_repeat1,
  [332188] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7502), 1,
      anon_sym_LBRACK,
    ACTIONS(7556), 1,
      anon_sym_COLON,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    STATE(3274), 1,
      sym_parameter_list,
    STATE(9084), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [332211] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7502), 1,
      anon_sym_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(14165), 1,
      anon_sym_RPAREN,
    STATE(3274), 1,
      sym_parameter_list,
    STATE(8026), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [332234] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14167), 1,
      anon_sym_EQ,
    ACTIONS(14169), 1,
      anon_sym_GT2,
    STATE(9498), 1,
      sym_interface_requirements,
    STATE(10052), 1,
      aux_sym_template_argument_list_repeat1,
  [332259] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14171), 1,
      anon_sym_EQ,
    ACTIONS(14173), 1,
      anon_sym_GT2,
    STATE(9550), 1,
      sym_interface_requirements,
    STATE(10190), 1,
      aux_sym_template_argument_list_repeat1,
  [332284] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4446), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_requires,
  [332305] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(14175), 1,
      anon_sym_COMMA,
    ACTIONS(14177), 1,
      anon_sym_EQ,
    STATE(9192), 1,
      sym_interface_requirements,
    STATE(9268), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12419), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [332328] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14179), 1,
      anon_sym_LPAREN2,
    STATE(8907), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(14101), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [332345] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14181), 1,
      anon_sym_LPAREN2,
    STATE(8946), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(14101), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [332362] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14183), 1,
      anon_sym_LPAREN2,
    STATE(8907), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(14101), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [332379] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7502), 1,
      anon_sym_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(14185), 1,
      anon_sym_RPAREN,
    STATE(3274), 1,
      sym_parameter_list,
    STATE(8026), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [332402] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7502), 1,
      anon_sym_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(14187), 1,
      anon_sym_RPAREN,
    STATE(3274), 1,
      sym_parameter_list,
    STATE(8026), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [332425] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13745), 1,
      anon_sym_COMMA,
    STATE(8967), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [332442] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7502), 1,
      anon_sym_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(14189), 1,
      anon_sym_RPAREN,
    STATE(3274), 1,
      sym_parameter_list,
    STATE(8026), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [332465] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(13975), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(13980), 1,
      anon_sym_EQ,
    STATE(2953), 1,
      sym_template_argument_list,
    ACTIONS(7653), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [332488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14191), 1,
      anon_sym_EQ,
    ACTIONS(12621), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [332503] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13745), 1,
      anon_sym_COMMA,
    STATE(8967), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [332520] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(7783), 1,
      anon_sym_LBRACK,
    STATE(7909), 1,
      sym_template_argument_list,
    ACTIONS(7785), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [332539] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4446), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_requires,
  [332560] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14193), 1,
      anon_sym_EQ,
    ACTIONS(14195), 1,
      anon_sym_GT2,
    STATE(9584), 1,
      sym_interface_requirements,
    STATE(10284), 1,
      aux_sym_template_argument_list_repeat1,
  [332585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14197), 1,
      anon_sym_LPAREN2,
    STATE(8958), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(14101), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [332602] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14199), 1,
      anon_sym_LPAREN2,
    STATE(8907), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(14101), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [332619] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14201), 1,
      anon_sym_LBRACK,
    ACTIONS(14204), 1,
      anon_sym_EQ,
    ACTIONS(14206), 1,
      anon_sym_DOT,
    STATE(8959), 4,
      sym_subscript_designator,
      sym_subscript_range_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [332638] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13745), 1,
      anon_sym_COMMA,
    STATE(8900), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [332655] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7502), 1,
      anon_sym_LBRACK,
    ACTIONS(7587), 1,
      anon_sym_COLON,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    STATE(3274), 1,
      sym_parameter_list,
    STATE(9084), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [332678] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14209), 1,
      anon_sym_EQ,
    ACTIONS(14211), 1,
      anon_sym_GT2,
    STATE(9407), 1,
      sym_interface_requirements,
    STATE(9716), 1,
      aux_sym_template_argument_list_repeat1,
  [332703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14213), 1,
      anon_sym_EQ,
    ACTIONS(12621), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [332718] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14216), 1,
      anon_sym_LPAREN2,
    STATE(8965), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(14101), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [332735] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14218), 1,
      anon_sym_LPAREN2,
    STATE(8907), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(14101), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [332752] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14220), 1,
      anon_sym_EQ,
    ACTIONS(14222), 1,
      anon_sym_GT2,
    STATE(9457), 1,
      sym_interface_requirements,
    STATE(9923), 1,
      aux_sym_template_argument_list_repeat1,
  [332777] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14224), 1,
      anon_sym_COMMA,
    STATE(8967), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [332794] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7502), 1,
      anon_sym_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(14227), 1,
      anon_sym_RPAREN,
    STATE(3274), 1,
      sym_parameter_list,
    STATE(8026), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [332817] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4446), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_requires,
  [332838] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(14229), 1,
      anon_sym_EQ,
    STATE(9299), 1,
      sym_interface_requirements,
    ACTIONS(12530), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [332857] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14231), 1,
      anon_sym_LPAREN2,
    STATE(8972), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(14101), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [332874] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14233), 1,
      anon_sym_LPAREN2,
    STATE(8907), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(14101), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [332891] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7502), 1,
      anon_sym_LBRACK,
    ACTIONS(7572), 1,
      anon_sym_COLON,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    STATE(3274), 1,
      sym_parameter_list,
    STATE(9084), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [332914] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4446), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_requires,
  [332935] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14235), 1,
      anon_sym_EQ,
    ACTIONS(14237), 1,
      anon_sym_GT2,
    STATE(9558), 1,
      sym_interface_requirements,
    STATE(10221), 1,
      aux_sym_template_argument_list_repeat1,
  [332960] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14239), 1,
      anon_sym_EQ,
    ACTIONS(14241), 1,
      anon_sym_GT2,
    STATE(9531), 1,
      sym_interface_requirements,
    STATE(10127), 1,
      aux_sym_template_argument_list_repeat1,
  [332985] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5781), 1,
      anon_sym_LBRACE,
    ACTIONS(13798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13800), 1,
      anon_sym_inline,
    ACTIONS(13822), 1,
      sym_identifier,
    STATE(993), 1,
      sym_declaration_list,
    STATE(10428), 1,
      sym_nested_namespace_specifier,
    STATE(11683), 1,
      sym__namespace_specifier,
  [333010] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14243), 1,
      anon_sym_EQ,
    ACTIONS(14245), 1,
      anon_sym_GT2,
    STATE(9423), 1,
      sym_interface_requirements,
    STATE(9771), 1,
      aux_sym_template_argument_list_repeat1,
  [333035] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5777), 1,
      anon_sym_LBRACE,
    ACTIONS(13798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13800), 1,
      anon_sym_inline,
    ACTIONS(14247), 1,
      sym_identifier,
    STATE(999), 1,
      sym_declaration_list,
    STATE(10635), 1,
      sym_nested_namespace_specifier,
    STATE(11683), 1,
      sym__namespace_specifier,
  [333060] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4446), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_requires,
  [333081] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14249), 1,
      anon_sym_EQ,
    ACTIONS(14251), 1,
      anon_sym_GT2,
    STATE(9326), 1,
      sym_interface_requirements,
    STATE(9665), 1,
      aux_sym_template_argument_list_repeat1,
  [333106] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14253), 1,
      anon_sym_EQ,
    ACTIONS(14255), 1,
      anon_sym_GT2,
    STATE(9330), 1,
      sym_interface_requirements,
    STATE(10113), 1,
      aux_sym_template_argument_list_repeat1,
  [333131] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4446), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_requires,
  [333152] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(13975), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14257), 1,
      anon_sym_EQ,
    STATE(2953), 1,
      sym_template_argument_list,
    ACTIONS(7666), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [333175] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(4464), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
  [333196] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8562), 1,
      anon_sym___attribute,
    ACTIONS(14259), 1,
      anon_sym___attribute__,
    STATE(6955), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7530), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [333217] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(3330), 1,
      sym_template_argument_list,
    STATE(10041), 2,
      sym_argument_list,
      sym_initializer_list,
  [333240] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(4464), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
  [333261] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7502), 1,
      anon_sym_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(14261), 1,
      anon_sym_RPAREN,
    STATE(3274), 1,
      sym_parameter_list,
    STATE(8026), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [333284] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14263), 1,
      anon_sym_EQ,
    ACTIONS(14265), 1,
      anon_sym_GT2,
    STATE(9332), 1,
      sym_interface_requirements,
    STATE(9607), 1,
      aux_sym_template_argument_list_repeat1,
  [333309] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(4464), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
  [333330] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7502), 1,
      anon_sym_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(14267), 1,
      anon_sym_RPAREN,
    STATE(3274), 1,
      sym_parameter_list,
    STATE(8026), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [333353] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(4464), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
  [333374] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(4464), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
  [333395] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7502), 1,
      anon_sym_LBRACK,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(14269), 1,
      anon_sym_RPAREN,
    STATE(3274), 1,
      sym_parameter_list,
    STATE(8026), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [333418] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9181), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10024), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [333435] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14273), 1,
      anon_sym_COMMA,
    ACTIONS(14275), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(14271), 5,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [333452] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(4464), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
  [333473] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(4464), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
  [333494] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9181), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10823), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [333511] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5773), 1,
      anon_sym_LBRACE,
    ACTIONS(13798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13800), 1,
      anon_sym_inline,
    ACTIONS(13930), 1,
      sym_identifier,
    STATE(576), 1,
      sym_declaration_list,
    STATE(10753), 1,
      sym_nested_namespace_specifier,
    STATE(11683), 1,
      sym__namespace_specifier,
  [333536] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9181), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11653), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [333553] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12333), 1,
      anon_sym_LBRACK,
    STATE(4464), 1,
      sym_parameter_list,
    STATE(7611), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
  [333574] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9181), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(11828), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [333591] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9181), 1,
      anon_sym_where,
    STATE(7487), 1,
      sym_where_clause,
    ACTIONS(12542), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [333608] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9185), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      anon_sym_LBRACK,
    STATE(7626), 1,
      sym_where_clause,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [333627] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5779), 1,
      anon_sym_LBRACE,
    ACTIONS(13798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13800), 1,
      anon_sym_inline,
    ACTIONS(13896), 1,
      sym_identifier,
    STATE(1113), 1,
      sym_declaration_list,
    STATE(10464), 1,
      sym_nested_namespace_specifier,
    STATE(11683), 1,
      sym__namespace_specifier,
  [333652] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14277), 1,
      anon_sym_EQ,
    ACTIONS(14279), 1,
      anon_sym_GT2,
    STATE(9337), 1,
      sym_interface_requirements,
    STATE(9690), 1,
      aux_sym_template_argument_list_repeat1,
  [333677] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14281), 1,
      anon_sym_EQ,
    ACTIONS(14283), 1,
      anon_sym_GT2,
    STATE(9338), 1,
      sym_interface_requirements,
    STATE(9734), 1,
      aux_sym_template_argument_list_repeat1,
  [333702] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14285), 1,
      anon_sym_EQ,
    ACTIONS(14287), 1,
      anon_sym_GT2,
    STATE(9344), 1,
      sym_interface_requirements,
    STATE(9832), 1,
      aux_sym_template_argument_list_repeat1,
  [333727] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym_LBRACK,
    ACTIONS(13828), 1,
      anon_sym_COMMA,
    ACTIONS(14289), 1,
      anon_sym_EQ,
    STATE(9091), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [333748] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13745), 1,
      anon_sym_COMMA,
    STATE(8967), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [333765] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5773), 1,
      anon_sym_LBRACE,
    ACTIONS(13798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13800), 1,
      anon_sym_inline,
    ACTIONS(14291), 1,
      sym_identifier,
    STATE(547), 1,
      sym_declaration_list,
    STATE(10607), 1,
      sym_nested_namespace_specifier,
    STATE(11683), 1,
      sym__namespace_specifier,
  [333790] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4446), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_requires,
  [333811] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14293), 1,
      anon_sym_EQ,
    ACTIONS(14295), 1,
      anon_sym_GT2,
    STATE(9348), 1,
      sym_interface_requirements,
    STATE(9926), 1,
      aux_sym_template_argument_list_repeat1,
  [333836] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14297), 1,
      anon_sym_EQ,
    ACTIONS(14299), 1,
      anon_sym_GT2,
    STATE(9351), 1,
      sym_interface_requirements,
    STATE(9980), 1,
      aux_sym_template_argument_list_repeat1,
  [333861] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5779), 1,
      anon_sym_LBRACE,
    ACTIONS(13798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13800), 1,
      anon_sym_inline,
    ACTIONS(14301), 1,
      sym_identifier,
    STATE(1098), 1,
      sym_declaration_list,
    STATE(10435), 1,
      sym_nested_namespace_specifier,
    STATE(11683), 1,
      sym__namespace_specifier,
  [333886] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13987), 1,
      anon_sym_COMMA,
    ACTIONS(14303), 1,
      anon_sym_EQ,
    STATE(8904), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 4,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      sym_identifier,
  [333905] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13987), 1,
      anon_sym_COMMA,
    STATE(8906), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 5,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      sym_identifier,
  [333922] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6726), 1,
      anon_sym___attribute,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7434), 1,
      anon_sym___attribute__,
    STATE(7524), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7711), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [333943] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4446), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_requires,
  [333964] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9185), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      anon_sym_LBRACK,
    STATE(7617), 1,
      sym_where_clause,
    ACTIONS(11262), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [333983] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14305), 1,
      anon_sym_EQ,
    ACTIONS(14307), 1,
      anon_sym_GT2,
    STATE(9598), 1,
      sym_interface_requirements,
    STATE(10317), 1,
      aux_sym_template_argument_list_repeat1,
  [334008] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14309), 1,
      anon_sym_EQ,
    ACTIONS(14311), 1,
      anon_sym_GT2,
    STATE(9572), 1,
      sym_interface_requirements,
    STATE(10245), 1,
      aux_sym_template_argument_list_repeat1,
  [334033] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(12727), 1,
      anon_sym_try,
    ACTIONS(14313), 1,
      anon_sym_SEMI,
    ACTIONS(14315), 1,
      anon_sym_EQ,
    STATE(1010), 2,
      sym_compound_statement,
      sym_try_statement,
  [334053] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4330), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 2,
      anon_sym_COMMA,
      sym_identifier,
  [334073] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14317), 1,
      anon_sym_RBRACE,
    ACTIONS(14319), 1,
      anon_sym_get,
    ACTIONS(14321), 1,
      anon_sym_set,
    STATE(9034), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [334093] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_get,
    ACTIONS(14321), 1,
      anon_sym_set,
    ACTIONS(14323), 1,
      anon_sym_RBRACE,
    STATE(9043), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [334113] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14325), 1,
      anon_sym_EQ,
    ACTIONS(14327), 1,
      anon_sym_GT2,
    STATE(9576), 1,
      sym_interface_requirements,
    STATE(10250), 1,
      aux_sym_template_argument_list_repeat1,
  [334135] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(14329), 1,
      anon_sym_SEMI,
    STATE(9214), 1,
      aux_sym_field_declaration_repeat1,
    STATE(11581), 1,
      sym_attribute_specifier,
  [334157] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14331), 1,
      anon_sym_EQ,
    ACTIONS(14333), 1,
      anon_sym_GT2,
    STATE(9352), 1,
      sym_interface_requirements,
    STATE(10007), 1,
      aux_sym_template_argument_list_repeat1,
  [334179] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(14335), 1,
      anon_sym_SEMI,
    STATE(9144), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10814), 1,
      sym_attribute_specifier,
  [334201] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14337), 1,
      anon_sym_EQ,
    ACTIONS(14339), 1,
      anon_sym_GT2,
    STATE(9343), 1,
      sym_interface_requirements,
    STATE(9814), 1,
      aux_sym_template_argument_list_repeat1,
  [334223] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14341), 1,
      anon_sym_RBRACE,
    ACTIONS(14343), 1,
      anon_sym_get,
    ACTIONS(14346), 1,
      anon_sym_set,
    STATE(9034), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [334243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14349), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(14351), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [334257] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4444), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [334277] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14093), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14355), 1,
      anon_sym_EQ,
    STATE(9758), 1,
      sym_interface_requirements,
    ACTIONS(14353), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [334297] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14357), 1,
      anon_sym_DOT,
    ACTIONS(4254), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(10016), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [334313] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_get,
    ACTIONS(14321), 1,
      anon_sym_set,
    ACTIONS(14359), 1,
      anon_sym_RBRACE,
    STATE(9066), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [334333] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9189), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [334349] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4503), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [334369] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4444), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [334389] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_get,
    ACTIONS(14321), 1,
      anon_sym_set,
    ACTIONS(14361), 1,
      anon_sym_RBRACE,
    STATE(9034), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [334409] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4444), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [334429] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_get,
    ACTIONS(14321), 1,
      anon_sym_set,
    ACTIONS(14363), 1,
      anon_sym_RBRACE,
    STATE(9178), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [334449] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1093), 1,
      anon_sym_LBRACE,
    ACTIONS(12721), 1,
      anon_sym_try,
    ACTIONS(14365), 1,
      anon_sym_SEMI,
    ACTIONS(14367), 1,
      anon_sym_EQ,
    STATE(940), 2,
      sym_compound_statement,
      sym_try_statement,
  [334469] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4444), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [334489] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_get,
    ACTIONS(14321), 1,
      anon_sym_set,
    ACTIONS(14369), 1,
      anon_sym_RBRACE,
    STATE(9027), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [334509] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(14371), 1,
      anon_sym_SEMI,
    STATE(9051), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10895), 1,
      sym_attribute_specifier,
  [334531] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(14373), 1,
      anon_sym_SEMI,
    STATE(9056), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10904), 1,
      sym_attribute_specifier,
  [334553] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(14375), 1,
      anon_sym_SEMI,
    STATE(9214), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10888), 1,
      sym_attribute_specifier,
  [334575] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_get,
    ACTIONS(14321), 1,
      anon_sym_set,
    ACTIONS(14377), 1,
      anon_sym_RBRACE,
    STATE(9034), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [334595] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_get,
    ACTIONS(14321), 1,
      anon_sym_set,
    ACTIONS(14379), 1,
      anon_sym_RBRACE,
    STATE(9139), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [334615] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14381), 1,
      anon_sym_EQ,
    ACTIONS(14383), 1,
      anon_sym_GT2,
    STATE(9538), 1,
      sym_interface_requirements,
    STATE(10162), 1,
      aux_sym_template_argument_list_repeat1,
  [334637] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9189), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [334653] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(14385), 1,
      anon_sym_SEMI,
    STATE(9214), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10891), 1,
      sym_attribute_specifier,
  [334675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14387), 1,
      anon_sym_EQ,
    ACTIONS(12621), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [334689] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(14389), 1,
      anon_sym_SEMI,
    STATE(9214), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10945), 1,
      sym_attribute_specifier,
  [334711] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4444), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [334731] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14391), 1,
      anon_sym_EQ,
    ACTIONS(14393), 1,
      anon_sym_GT2,
    STATE(9479), 1,
      sym_interface_requirements,
    STATE(9981), 1,
      aux_sym_template_argument_list_repeat1,
  [334753] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_get,
    ACTIONS(14321), 1,
      anon_sym_set,
    ACTIONS(14395), 1,
      anon_sym_RBRACE,
    STATE(9034), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [334773] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14010), 1,
      anon_sym_COMMA,
    ACTIONS(14397), 1,
      anon_sym_EQ,
    STATE(9215), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [334791] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9189), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11262), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [334807] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14399), 1,
      anon_sym_EQ,
    ACTIONS(14401), 1,
      anon_sym_GT2,
    STATE(9516), 1,
      sym_interface_requirements,
    STATE(10099), 1,
      aux_sym_template_argument_list_repeat1,
  [334829] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_get,
    ACTIONS(14321), 1,
      anon_sym_set,
    ACTIONS(14403), 1,
      anon_sym_RBRACE,
    STATE(9141), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [334849] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_get,
    ACTIONS(14321), 1,
      anon_sym_set,
    ACTIONS(14405), 1,
      anon_sym_RBRACE,
    STATE(9034), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [334869] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8986), 1,
      anon_sym_where,
    ACTIONS(11264), 1,
      sym_identifier,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11262), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [334887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(11086), 1,
      sym_string_literal,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [334901] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(13614), 1,
      anon_sym_LBRACE,
    STATE(11030), 1,
      sym_trailing_return_type,
    STATE(9081), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [334921] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8986), 1,
      anon_sym_where,
    ACTIONS(10026), 1,
      sym_identifier,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10024), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [334939] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9189), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11653), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [334955] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13772), 1,
      anon_sym_COMMA,
    STATE(9112), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [334971] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14049), 1,
      anon_sym_COMMA,
    ACTIONS(14407), 1,
      anon_sym_EQ,
    STATE(9242), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [334989] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11321), 1,
      anon_sym_LBRACE,
    ACTIONS(11672), 1,
      anon_sym_try,
    ACTIONS(14409), 1,
      anon_sym_SEMI,
    ACTIONS(14411), 1,
      anon_sym_EQ,
    STATE(2100), 2,
      sym_compound_statement,
      sym_try_statement,
  [335009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14413), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(14415), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [335023] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9189), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(11828), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [335039] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_get,
    ACTIONS(14321), 1,
      anon_sym_set,
    ACTIONS(14417), 1,
      anon_sym_RBRACE,
    STATE(9034), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [335059] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      anon_sym_LBRACK,
    ACTIONS(13828), 1,
      anon_sym_COMMA,
    STATE(9093), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [335077] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_LBRACK,
    ACTIONS(13828), 1,
      anon_sym_COMMA,
    STATE(9094), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [335095] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9189), 1,
      anon_sym_where,
    STATE(7487), 1,
      sym_where_clause,
    ACTIONS(12542), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [335111] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(14419), 1,
      anon_sym_LBRACE,
    STATE(11521), 1,
      sym_trailing_return_type,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [335131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13964), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(13962), 5,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [335145] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14421), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(14423), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [335159] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7594), 1,
      anon_sym_LBRACK,
    ACTIONS(8131), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7596), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(7021), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [335177] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(14425), 1,
      anon_sym_LBRACE,
    STATE(11027), 1,
      sym_trailing_return_type,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [335197] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4330), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 2,
      anon_sym_COMMA,
      sym_identifier,
  [335217] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(917), 1,
      anon_sym_LBRACE,
    ACTIONS(12756), 1,
      anon_sym_try,
    ACTIONS(14427), 1,
      anon_sym_SEMI,
    ACTIONS(14429), 1,
      anon_sym_EQ,
    STATE(905), 2,
      sym_compound_statement,
      sym_try_statement,
  [335237] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14431), 1,
      anon_sym_EQ,
    ACTIONS(14433), 1,
      anon_sym_GT2,
    STATE(9430), 1,
      sym_interface_requirements,
    STATE(9787), 1,
      aux_sym_template_argument_list_repeat1,
  [335259] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4503), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [335279] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4503), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [335299] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_LBRACK,
    ACTIONS(13828), 1,
      anon_sym_COMMA,
    STATE(9093), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [335317] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_get,
    ACTIONS(14321), 1,
      anon_sym_set,
    ACTIONS(14435), 1,
      anon_sym_RBRACE,
    STATE(9034), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [335337] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12532), 1,
      anon_sym_LBRACK,
    ACTIONS(14437), 1,
      anon_sym_COMMA,
    STATE(9093), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [335355] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym_LBRACK,
    ACTIONS(13828), 1,
      anon_sym_COMMA,
    STATE(9093), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [335373] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym_LBRACK,
    ACTIONS(13828), 1,
      anon_sym_COMMA,
    STATE(9097), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [335391] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11488), 1,
      anon_sym_LBRACE,
    STATE(10948), 1,
      sym_trailing_return_type,
    STATE(9153), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [335411] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12540), 1,
      anon_sym_LBRACK,
    ACTIONS(13828), 1,
      anon_sym_COMMA,
    STATE(9093), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [335429] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14440), 1,
      anon_sym_EQ,
    ACTIONS(14442), 1,
      anon_sym_GT2,
    STATE(9504), 1,
      sym_interface_requirements,
    STATE(10076), 1,
      aux_sym_template_argument_list_repeat1,
  [335451] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11321), 1,
      anon_sym_LBRACE,
    ACTIONS(11672), 1,
      anon_sym_try,
    ACTIONS(14444), 1,
      anon_sym_SEMI,
    ACTIONS(14446), 1,
      anon_sym_EQ,
    STATE(2076), 2,
      sym_compound_statement,
      sym_try_statement,
  [335471] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7118), 1,
      anon_sym_LT,
    ACTIONS(7783), 1,
      anon_sym_LBRACK,
    STATE(3064), 1,
      sym_template_argument_list,
    ACTIONS(7785), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [335489] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(14419), 1,
      anon_sym_LBRACE,
    STATE(11521), 1,
      sym_trailing_return_type,
    STATE(9085), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [335509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14357), 1,
      anon_sym_DOT,
    ACTIONS(14448), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(10016), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [335525] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(14450), 1,
      anon_sym_SEMI,
    STATE(9214), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10855), 1,
      sym_attribute_specifier,
  [335547] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14452), 1,
      anon_sym_EQ,
    ACTIONS(14454), 1,
      anon_sym_GT2,
    STATE(9389), 1,
      sym_interface_requirements,
    STATE(9666), 1,
      aux_sym_template_argument_list_repeat1,
  [335569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13772), 1,
      anon_sym_COMMA,
    STATE(9129), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [335585] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(14456), 1,
      anon_sym_SEMI,
    STATE(9030), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10995), 1,
      sym_attribute_specifier,
  [335607] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(13199), 1,
      anon_sym_LBRACK,
    STATE(8229), 1,
      sym_template_argument_list,
    ACTIONS(13195), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [335625] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13772), 1,
      anon_sym_COMMA,
    STATE(9112), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [335641] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1093), 1,
      anon_sym_LBRACE,
    ACTIONS(12721), 1,
      anon_sym_try,
    ACTIONS(14458), 1,
      anon_sym_SEMI,
    ACTIONS(14460), 1,
      anon_sym_EQ,
    STATE(898), 2,
      sym_compound_statement,
      sym_try_statement,
  [335661] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(12727), 1,
      anon_sym_try,
    ACTIONS(14462), 1,
      anon_sym_SEMI,
    ACTIONS(14464), 1,
      anon_sym_EQ,
    STATE(1014), 2,
      sym_compound_statement,
      sym_try_statement,
  [335681] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4330), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 2,
      anon_sym_COMMA,
      sym_identifier,
  [335701] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14466), 1,
      anon_sym_COMMA,
    STATE(9112), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [335717] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4330), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 2,
      anon_sym_COMMA,
      sym_identifier,
  [335737] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4330), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 2,
      anon_sym_COMMA,
      sym_identifier,
  [335757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14349), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(14351), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [335771] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11680), 1,
      anon_sym_try,
    ACTIONS(12821), 1,
      anon_sym_LBRACE,
    ACTIONS(14469), 1,
      anon_sym_SEMI,
    ACTIONS(14471), 1,
      anon_sym_EQ,
    STATE(1741), 2,
      sym_compound_statement,
      sym_try_statement,
  [335791] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4503), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [335811] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(14473), 1,
      anon_sym_SEMI,
    STATE(9214), 1,
      aux_sym_field_declaration_repeat1,
    STATE(11009), 1,
      sym_attribute_specifier,
  [335833] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14475), 1,
      anon_sym_EQ,
    ACTIONS(14477), 1,
      anon_sym_GT2,
    STATE(9552), 1,
      sym_interface_requirements,
    STATE(10194), 1,
      aux_sym_template_argument_list_repeat1,
  [335855] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(13211), 1,
      anon_sym_LBRACK,
    STATE(8196), 1,
      sym_template_argument_list,
    ACTIONS(13209), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [335873] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4330), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 2,
      anon_sym_COMMA,
      sym_identifier,
  [335893] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14479), 1,
      anon_sym_EQ,
    ACTIONS(14481), 1,
      anon_sym_GT2,
    STATE(9601), 1,
      sym_interface_requirements,
    STATE(10323), 1,
      aux_sym_template_argument_list_repeat1,
  [335915] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14483), 1,
      anon_sym_EQ,
    ACTIONS(14485), 1,
      anon_sym_GT2,
    STATE(9480), 1,
      sym_interface_requirements,
    STATE(9992), 1,
      aux_sym_template_argument_list_repeat1,
  [335937] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(14487), 1,
      anon_sym_SEMI,
    STATE(9214), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10856), 1,
      sym_attribute_specifier,
  [335959] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14489), 1,
      anon_sym_EQ,
    ACTIONS(14491), 1,
      anon_sym_GT2,
    STATE(9499), 1,
      sym_interface_requirements,
    STATE(10056), 1,
      aux_sym_template_argument_list_repeat1,
  [335981] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7064), 1,
      anon_sym_LT,
    ACTIONS(7783), 1,
      anon_sym_LBRACK,
    STATE(3064), 1,
      sym_template_argument_list,
    ACTIONS(7785), 3,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [335999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14493), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(14495), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [336013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14497), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(14499), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [336027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13772), 1,
      anon_sym_COMMA,
    STATE(9112), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [336043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14501), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(14503), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [336057] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_get,
    ACTIONS(14321), 1,
      anon_sym_set,
    ACTIONS(14505), 1,
      anon_sym_RBRACE,
    STATE(9052), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [336077] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_get,
    ACTIONS(14321), 1,
      anon_sym_set,
    ACTIONS(14507), 1,
      anon_sym_RBRACE,
    STATE(9034), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [336097] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4330), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12448), 2,
      anon_sym_COMMA,
      sym_identifier,
  [336117] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(14509), 1,
      anon_sym_SEMI,
    STATE(9214), 1,
      aux_sym_field_declaration_repeat1,
    STATE(11021), 1,
      sym_attribute_specifier,
  [336139] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13772), 1,
      anon_sym_COMMA,
    STATE(9164), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [336155] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4444), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12441), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [336175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13572), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(14511), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [336189] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_get,
    ACTIONS(14321), 1,
      anon_sym_set,
    ACTIONS(14513), 1,
      anon_sym_RBRACE,
    STATE(9034), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [336209] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_get,
    ACTIONS(14321), 1,
      anon_sym_set,
    ACTIONS(14515), 1,
      anon_sym_RBRACE,
    STATE(9034), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [336229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14517), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(14519), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [336243] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_get,
    ACTIONS(14321), 1,
      anon_sym_set,
    ACTIONS(14521), 1,
      anon_sym_RBRACE,
    STATE(9034), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [336263] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8986), 1,
      anon_sym_where,
    ACTIONS(11655), 1,
      sym_identifier,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11653), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [336281] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(14523), 1,
      anon_sym_SEMI,
    STATE(9214), 1,
      aux_sym_field_declaration_repeat1,
    STATE(11380), 1,
      sym_attribute_specifier,
  [336303] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(14525), 1,
      anon_sym_SEMI,
    STATE(9214), 1,
      aux_sym_field_declaration_repeat1,
    STATE(11396), 1,
      sym_attribute_specifier,
  [336325] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_get,
    ACTIONS(14321), 1,
      anon_sym_set,
    ACTIONS(14527), 1,
      anon_sym_RBRACE,
    STATE(9061), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [336345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14529), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(14531), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [336359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14533), 1,
      anon_sym_EQ,
    ACTIONS(12621), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
      sym_identifier,
  [336373] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4330), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 2,
      anon_sym_COMMA,
      sym_identifier,
  [336393] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(14536), 1,
      anon_sym_SEMI,
    STATE(9124), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10837), 1,
      sym_attribute_specifier,
  [336415] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14357), 1,
      anon_sym_DOT,
    ACTIONS(4246), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(10016), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [336431] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14538), 1,
      anon_sym_EQ,
    ACTIONS(14540), 1,
      anon_sym_GT2,
    STATE(9435), 1,
      sym_interface_requirements,
    STATE(9815), 1,
      aux_sym_template_argument_list_repeat1,
  [336453] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14357), 1,
      anon_sym_DOT,
    ACTIONS(14542), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(10016), 3,
      anon_sym_var,
      anon_sym_let,
      anon_sym_This,
  [336469] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(13614), 1,
      anon_sym_LBRACE,
    STATE(11030), 1,
      sym_trailing_return_type,
    STATE(5340), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [336489] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12623), 1,
      anon_sym_LBRACK,
    ACTIONS(14544), 1,
      anon_sym_EQ,
    ACTIONS(12621), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [336505] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14546), 1,
      anon_sym_EQ,
    ACTIONS(14548), 1,
      anon_sym_GT2,
    STATE(9559), 1,
      sym_interface_requirements,
    STATE(10223), 1,
      aux_sym_template_argument_list_repeat1,
  [336527] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14550), 1,
      anon_sym_EQ,
    ACTIONS(14552), 1,
      anon_sym_GT2,
    STATE(9327), 1,
      sym_interface_requirements,
    STATE(9730), 1,
      aux_sym_template_argument_list_repeat1,
  [336549] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(14554), 1,
      anon_sym_SEMI,
    STATE(9214), 1,
      aux_sym_field_declaration_repeat1,
    STATE(11374), 1,
      sym_attribute_specifier,
  [336571] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14556), 1,
      anon_sym_EQ,
    ACTIONS(14558), 1,
      anon_sym_GT2,
    STATE(9532), 1,
      sym_interface_requirements,
    STATE(10131), 1,
      aux_sym_template_argument_list_repeat1,
  [336593] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8986), 1,
      anon_sym_where,
    ACTIONS(11830), 1,
      sym_identifier,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(11828), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [336611] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14560), 1,
      anon_sym_EQ,
    ACTIONS(14562), 1,
      anon_sym_GT2,
    STATE(9331), 1,
      sym_interface_requirements,
    STATE(10145), 1,
      aux_sym_template_argument_list_repeat1,
  [336633] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14564), 1,
      anon_sym_EQ,
    ACTIONS(14566), 1,
      anon_sym_GT2,
    STATE(9450), 1,
      sym_interface_requirements,
    STATE(9892), 1,
      aux_sym_template_argument_list_repeat1,
  [336655] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(14568), 1,
      anon_sym_SEMI,
    STATE(9214), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10840), 1,
      sym_attribute_specifier,
  [336677] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(14570), 1,
      anon_sym_SEMI,
    STATE(9118), 1,
      aux_sym_field_declaration_repeat1,
    STATE(11165), 1,
      sym_attribute_specifier,
  [336699] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13772), 1,
      anon_sym_COMMA,
    STATE(9112), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [336715] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4503), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12427), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [336735] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14572), 1,
      anon_sym_EQ,
    ACTIONS(14574), 1,
      anon_sym_GT2,
    STATE(9333), 1,
      sym_interface_requirements,
    STATE(9615), 1,
      aux_sym_template_argument_list_repeat1,
  [336757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14529), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(14531), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [336771] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(14576), 1,
      anon_sym_SEMI,
    STATE(9214), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10841), 1,
      sym_attribute_specifier,
  [336793] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14578), 1,
      anon_sym_EQ,
    ACTIONS(14580), 1,
      anon_sym_GT2,
    STATE(9318), 1,
      sym_interface_requirements,
    STATE(9699), 1,
      aux_sym_template_argument_list_repeat1,
  [336815] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8986), 1,
      anon_sym_where,
    ACTIONS(10825), 1,
      sym_identifier,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10823), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [336833] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(14582), 1,
      anon_sym_SEMI,
    STATE(9134), 1,
      aux_sym_field_declaration_repeat1,
    STATE(11291), 1,
      sym_attribute_specifier,
  [336855] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      anon_sym_LBRACE,
    ACTIONS(12701), 1,
      anon_sym_try,
    ACTIONS(14584), 1,
      anon_sym_SEMI,
    ACTIONS(14586), 1,
      anon_sym_EQ,
    STATE(618), 2,
      sym_compound_statement,
      sym_try_statement,
  [336875] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14588), 1,
      anon_sym_EQ,
    ACTIONS(14590), 1,
      anon_sym_GT2,
    STATE(9578), 1,
      sym_interface_requirements,
    STATE(10259), 1,
      aux_sym_template_argument_list_repeat1,
  [336897] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_get,
    ACTIONS(14321), 1,
      anon_sym_set,
    ACTIONS(14592), 1,
      anon_sym_RBRACE,
    STATE(9132), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [336917] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_get,
    ACTIONS(14321), 1,
      anon_sym_set,
    ACTIONS(14594), 1,
      anon_sym_RBRACE,
    STATE(9077), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [336937] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14596), 1,
      anon_sym_EQ,
    ACTIONS(14598), 1,
      anon_sym_GT2,
    STATE(9339), 1,
      sym_interface_requirements,
    STATE(9740), 1,
      aux_sym_template_argument_list_repeat1,
  [336959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(11340), 1,
      sym_string_literal,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [336973] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_get,
    ACTIONS(14321), 1,
      anon_sym_set,
    ACTIONS(14600), 1,
      anon_sym_RBRACE,
    STATE(9034), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [336993] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12841), 1,
      anon_sym_COLON,
    ACTIONS(14602), 1,
      anon_sym_EQ,
    STATE(9293), 1,
      sym_interface_requirements,
    ACTIONS(12530), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [337011] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(14604), 1,
      anon_sym_SEMI,
    STATE(9162), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10799), 1,
      sym_attribute_specifier,
  [337033] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(14606), 1,
      anon_sym_SEMI,
    STATE(9168), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10802), 1,
      sym_attribute_specifier,
  [337055] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9176), 1,
      anon_sym_where,
    STATE(7549), 1,
      sym_where_clause,
    ACTIONS(10024), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [337071] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11651), 1,
      anon_sym_try,
    ACTIONS(12711), 1,
      anon_sym_LBRACE,
    ACTIONS(14608), 1,
      anon_sym_SEMI,
    ACTIONS(14610), 1,
      anon_sym_EQ,
    STATE(2247), 2,
      sym_compound_statement,
      sym_try_statement,
  [337091] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9176), 1,
      anon_sym_where,
    STATE(7537), 1,
      sym_where_clause,
    ACTIONS(10823), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [337107] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9176), 1,
      anon_sym_where,
    STATE(7465), 1,
      sym_where_clause,
    ACTIONS(11262), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [337123] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9176), 1,
      anon_sym_where,
    STATE(7535), 1,
      sym_where_clause,
    ACTIONS(11653), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [337139] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4503), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12329), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [337159] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9176), 1,
      anon_sym_where,
    STATE(7546), 1,
      sym_where_clause,
    ACTIONS(11828), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [337175] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9176), 1,
      anon_sym_where,
    STATE(7487), 1,
      sym_where_clause,
    ACTIONS(12542), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [337191] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13261), 1,
      anon_sym_LBRACK,
    ACTIONS(13259), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(7796), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [337209] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(14612), 1,
      anon_sym_SEMI,
    STATE(9214), 1,
      aux_sym_field_declaration_repeat1,
    STATE(10805), 1,
      sym_attribute_specifier,
  [337231] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14175), 1,
      anon_sym_COMMA,
    ACTIONS(14614), 1,
      anon_sym_EQ,
    STATE(9300), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [337249] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_get,
    ACTIONS(14321), 1,
      anon_sym_set,
    ACTIONS(14616), 1,
      anon_sym_RBRACE,
    STATE(9092), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [337269] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_get,
    ACTIONS(14321), 1,
      anon_sym_set,
    ACTIONS(14618), 1,
      anon_sym_RBRACE,
    STATE(9138), 1,
      aux_sym_subscript_declaration_repeat1,
    STATE(9604), 2,
      sym_property_get,
      sym_property_set,
  [337289] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14620), 1,
      anon_sym_EQ,
    ACTIONS(14622), 1,
      anon_sym_GT2,
    STATE(9345), 1,
      sym_interface_requirements,
    STATE(9842), 1,
      aux_sym_template_argument_list_repeat1,
  [337311] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11651), 1,
      anon_sym_try,
    ACTIONS(12711), 1,
      anon_sym_LBRACE,
    ACTIONS(14624), 1,
      anon_sym_SEMI,
    ACTIONS(14626), 1,
      anon_sym_EQ,
    STATE(2233), 2,
      sym_compound_statement,
      sym_try_statement,
  [337331] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      anon_sym_LBRACE,
    ACTIONS(12701), 1,
      anon_sym_try,
    ACTIONS(14628), 1,
      anon_sym_SEMI,
    ACTIONS(14630), 1,
      anon_sym_EQ,
    STATE(536), 2,
      sym_compound_statement,
      sym_try_statement,
  [337351] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4503), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12365), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [337371] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4444), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12405), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [337391] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4444), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12413), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [337411] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(917), 1,
      anon_sym_LBRACE,
    ACTIONS(12756), 1,
      anon_sym_try,
    ACTIONS(14632), 1,
      anon_sym_SEMI,
    ACTIONS(14634), 1,
      anon_sym_EQ,
    STATE(1097), 2,
      sym_compound_statement,
      sym_try_statement,
  [337431] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11680), 1,
      anon_sym_try,
    ACTIONS(12821), 1,
      anon_sym_LBRACE,
    ACTIONS(14636), 1,
      anon_sym_SEMI,
    ACTIONS(14638), 1,
      anon_sym_EQ,
    STATE(1772), 2,
      sym_compound_statement,
      sym_try_statement,
  [337451] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14640), 1,
      anon_sym_EQ,
    ACTIONS(14642), 1,
      anon_sym_GT2,
    STATE(9585), 1,
      sym_interface_requirements,
    STATE(10288), 1,
      aux_sym_template_argument_list_repeat1,
  [337473] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14644), 1,
      anon_sym_EQ,
    ACTIONS(14646), 1,
      anon_sym_GT2,
    STATE(9349), 1,
      sym_interface_requirements,
    STATE(9936), 1,
      aux_sym_template_argument_list_repeat1,
  [337495] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(14648), 1,
      anon_sym_SEMI,
    STATE(9214), 1,
      aux_sym_field_declaration_repeat1,
    STATE(11004), 1,
      sym_attribute_specifier,
  [337517] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    STATE(4503), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
    ACTIONS(12375), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [337537] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8986), 1,
      anon_sym_where,
    ACTIONS(12544), 1,
      sym_identifier,
    STATE(7487), 1,
      sym_where_clause,
    ACTIONS(12542), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [337555] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14650), 1,
      anon_sym_SEMI,
    STATE(9297), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [337572] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14652), 1,
      anon_sym_COMMA,
    STATE(9209), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [337587] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14655), 1,
      anon_sym_SEMI,
    STATE(9249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [337604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14010), 1,
      anon_sym_COMMA,
    STATE(9238), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [337619] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14010), 1,
      anon_sym_COMMA,
    STATE(9264), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [337634] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    ACTIONS(14657), 1,
      anon_sym_COLON,
    ACTIONS(14659), 1,
      anon_sym_SEMI,
    STATE(9652), 1,
      aux_sym_declaration_repeat1,
  [337653] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14661), 1,
      anon_sym_COMMA,
    ACTIONS(14666), 1,
      anon_sym___attribute,
    STATE(9214), 1,
      aux_sym_field_declaration_repeat1,
    ACTIONS(14664), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [337670] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14010), 1,
      anon_sym_COMMA,
    STATE(9216), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [337685] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14668), 1,
      anon_sym_COMMA,
    STATE(9216), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [337700] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14671), 1,
      anon_sym_SEMI,
    STATE(9243), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [337717] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    ACTIONS(14673), 1,
      anon_sym_COLON,
    ACTIONS(14675), 1,
      anon_sym_SEMI,
    STATE(9878), 1,
      aux_sym_declaration_repeat1,
  [337736] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    ACTIONS(14677), 1,
      anon_sym_COLON,
    ACTIONS(14679), 1,
      anon_sym_SEMI,
    STATE(9872), 1,
      aux_sym_declaration_repeat1,
  [337755] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14681), 1,
      anon_sym_SEMI,
    STATE(5557), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [337772] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    ACTIONS(14683), 1,
      anon_sym_COLON,
    ACTIONS(14685), 1,
      anon_sym_SEMI,
    STATE(9749), 1,
      aux_sym_declaration_repeat1,
  [337791] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14687), 1,
      anon_sym_COMMA,
    STATE(9222), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12530), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [337806] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14690), 1,
      anon_sym_SEMI,
    STATE(5557), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [337823] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14049), 1,
      anon_sym_COMMA,
    STATE(9222), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [337838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14049), 1,
      anon_sym_COMMA,
    STATE(9222), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [337853] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14692), 1,
      anon_sym_SEMI,
    STATE(9276), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [337870] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14175), 1,
      anon_sym_COMMA,
    STATE(9209), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [337885] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14049), 1,
      anon_sym_COMMA,
    STATE(9275), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [337900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14694), 1,
      anon_sym_EQ,
    ACTIONS(12621), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [337913] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    ACTIONS(14696), 1,
      anon_sym_RPAREN,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
  [337932] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14049), 1,
      anon_sym_COMMA,
    STATE(9225), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [337947] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14175), 1,
      anon_sym_COMMA,
    STATE(9239), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [337962] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13800), 1,
      anon_sym_inline,
    ACTIONS(14698), 1,
      sym_identifier,
    STATE(10270), 1,
      sym__namespace_specifier,
    STATE(10673), 1,
      sym_nested_namespace_specifier,
  [337981] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13502), 1,
      anon_sym_COLON,
    ACTIONS(14700), 1,
      anon_sym_SEMI,
    STATE(9728), 1,
      sym_module_partition,
    STATE(11032), 1,
      sym_attribute_declaration,
  [338000] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14702), 1,
      anon_sym_SEMI,
    STATE(5557), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [338017] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13800), 1,
      anon_sym_inline,
    ACTIONS(14704), 1,
      sym_identifier,
    STATE(10990), 1,
      sym_nested_namespace_specifier,
    STATE(11683), 1,
      sym__namespace_specifier,
  [338036] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    ACTIONS(14706), 1,
      anon_sym_RPAREN,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
  [338055] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14010), 1,
      anon_sym_COMMA,
    STATE(9216), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12534), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [338070] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14175), 1,
      anon_sym_COMMA,
    STATE(9209), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [338085] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    ACTIONS(14708), 1,
      anon_sym_COLON,
    ACTIONS(14710), 1,
      anon_sym_SEMI,
    STATE(10121), 1,
      aux_sym_declaration_repeat1,
  [338104] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14712), 1,
      anon_sym_SEMI,
    STATE(9266), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [338121] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14049), 1,
      anon_sym_COMMA,
    STATE(9222), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [338136] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14714), 1,
      anon_sym_SEMI,
    STATE(5557), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [338153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14716), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6808), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACE,
      anon_sym_or,
  [338166] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14718), 1,
      anon_sym_SEMI,
    STATE(5557), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [338183] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13502), 1,
      anon_sym_COLON,
    ACTIONS(14720), 1,
      anon_sym_SEMI,
    STATE(10078), 1,
      sym_module_partition,
    STATE(10987), 1,
      sym_attribute_declaration,
  [338202] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    ACTIONS(14722), 1,
      anon_sym_COLON,
    ACTIONS(14724), 1,
      anon_sym_SEMI,
    STATE(10154), 1,
      aux_sym_declaration_repeat1,
  [338221] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14728), 1,
      anon_sym_DOT,
    STATE(9248), 1,
      aux_sym_module_name_repeat1,
    ACTIONS(14726), 3,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [338236] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14731), 1,
      anon_sym_SEMI,
    STATE(5557), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [338253] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(3330), 1,
      sym_template_argument_list,
    ACTIONS(7728), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
  [338270] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7064), 1,
      anon_sym_LT,
    ACTIONS(7783), 1,
      anon_sym_LBRACK,
    STATE(3043), 1,
      sym_template_argument_list,
    ACTIONS(7785), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [338287] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14733), 1,
      anon_sym_SEMI,
    STATE(9317), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [338304] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14735), 1,
      anon_sym_SEMI,
    STATE(5557), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [338321] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14737), 1,
      anon_sym_SEMI,
    STATE(9235), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [338338] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13800), 1,
      anon_sym_inline,
    ACTIONS(14739), 1,
      sym_identifier,
    STATE(11069), 1,
      sym_nested_namespace_specifier,
    STATE(11683), 1,
      sym__namespace_specifier,
  [338357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14741), 2,
      anon_sym_class,
      anon_sym_typename,
    STATE(10684), 3,
      sym_type_parameter_declaration,
      sym_variadic_type_parameter_declaration,
      sym_optional_type_parameter_declaration,
  [338370] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14743), 1,
      anon_sym_SEMI,
    STATE(5557), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [338387] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14745), 1,
      anon_sym_SEMI,
    STATE(5557), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [338404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14749), 1,
      anon_sym_DOT,
    STATE(9248), 1,
      aux_sym_module_name_repeat1,
    ACTIONS(14747), 3,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [338419] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13800), 1,
      anon_sym_inline,
    ACTIONS(14698), 1,
      sym_identifier,
    STATE(9884), 1,
      sym__namespace_specifier,
    STATE(10343), 1,
      sym_nested_namespace_specifier,
  [338438] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14751), 1,
      anon_sym_COMMA,
    ACTIONS(14756), 1,
      anon_sym___attribute,
    STATE(9261), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(14754), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [338455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14758), 5,
      anon_sym_LPAREN2,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [338466] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(14760), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
    STATE(3360), 1,
      sym_template_method,
    STATE(10655), 1,
      sym_operator_name,
  [338485] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14010), 1,
      anon_sym_COMMA,
    STATE(9216), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [338500] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(14762), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
    STATE(3360), 1,
      sym_template_method,
    STATE(10755), 1,
      sym_operator_name,
  [338519] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14764), 1,
      anon_sym_SEMI,
    STATE(5557), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [338536] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(176), 1,
      sym_template_argument_list,
    ACTIONS(2224), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [338553] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14175), 1,
      anon_sym_COMMA,
    STATE(9209), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [338568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14768), 1,
      anon_sym_COLON_COLON,
    ACTIONS(14766), 4,
      anon_sym_virtual,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
  [338581] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    ACTIONS(14772), 1,
      anon_sym_COLON_COLON,
    STATE(10781), 1,
      sym_argument_list,
    ACTIONS(14770), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [338598] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14774), 1,
      anon_sym_SEMI,
    STATE(9257), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [338615] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    ACTIONS(14776), 1,
      anon_sym_COLON,
    ACTIONS(14778), 1,
      anon_sym_SEMI,
    STATE(9967), 1,
      aux_sym_declaration_repeat1,
  [338634] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    ACTIONS(14782), 1,
      anon_sym_COLON_COLON,
    STATE(10515), 1,
      sym_argument_list,
    ACTIONS(14780), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [338651] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14784), 1,
      anon_sym_SEMI,
    STATE(9288), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [338668] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14049), 1,
      anon_sym_COMMA,
    STATE(9222), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12538), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [338683] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14786), 1,
      anon_sym_SEMI,
    STATE(5557), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [338700] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14788), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14790), 1,
      anon_sym_COMMA,
    STATE(9481), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(14792), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [338717] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7064), 1,
      anon_sym_LT,
    ACTIONS(7783), 1,
      anon_sym_LBRACK,
    STATE(3342), 1,
      sym_template_argument_list,
    ACTIONS(7785), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [338734] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14794), 1,
      anon_sym_SEMI,
    STATE(9253), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [338751] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14796), 1,
      anon_sym_SEMI,
    STATE(9291), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [338768] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14749), 1,
      anon_sym_DOT,
    STATE(9259), 1,
      aux_sym_module_name_repeat1,
    ACTIONS(14798), 3,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [338783] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14790), 1,
      anon_sym_COMMA,
    ACTIONS(14800), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(9376), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(14802), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [338800] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    ACTIONS(14804), 1,
      anon_sym_RPAREN,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
  [338819] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14806), 1,
      anon_sym_SEMI,
    STATE(5557), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [338836] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14808), 1,
      anon_sym_SEMI,
    STATE(9258), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [338853] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(14810), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
    STATE(4796), 1,
      sym_template_method,
    STATE(10606), 1,
      sym_operator_name,
  [338872] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12874), 1,
      sym_identifier,
    ACTIONS(14812), 1,
      aux_sym_preproc_if_token2,
    STATE(8997), 1,
      sym_enumerator,
    STATE(9321), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(9322), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [338891] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14814), 1,
      anon_sym_SEMI,
    STATE(5557), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [338908] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    ACTIONS(14816), 1,
      anon_sym_COLON,
    ACTIONS(14818), 1,
      anon_sym_SEMI,
    STATE(9850), 1,
      aux_sym_declaration_repeat1,
  [338927] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13800), 1,
      anon_sym_inline,
    ACTIONS(14820), 1,
      sym_identifier,
    STATE(11347), 1,
      sym_nested_namespace_specifier,
    STATE(11683), 1,
      sym__namespace_specifier,
  [338946] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14822), 1,
      anon_sym_SEMI,
    STATE(5557), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [338963] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14175), 1,
      anon_sym_COMMA,
    STATE(9227), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [338978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14824), 1,
      anon_sym_EQ,
    ACTIONS(12621), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [338991] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14826), 1,
      anon_sym_SEMI,
    STATE(9220), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [339008] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13527), 1,
      anon_sym_COMMA,
    ACTIONS(14830), 1,
      anon_sym___attribute,
    STATE(9261), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(14828), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [339025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14010), 1,
      anon_sym_COMMA,
    STATE(9216), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12517), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [339040] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14832), 1,
      anon_sym_SEMI,
    STATE(5557), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [339057] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14834), 1,
      anon_sym_SEMI,
    STATE(5557), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [339074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14836), 1,
      anon_sym_EQ,
    ACTIONS(12621), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      sym_identifier,
  [339087] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14175), 1,
      anon_sym_COMMA,
    STATE(9209), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(12523), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [339102] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14838), 1,
      anon_sym_SEMI,
    STATE(9245), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [339119] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13800), 1,
      anon_sym_inline,
    ACTIONS(14840), 1,
      sym_identifier,
    STATE(11503), 1,
      sym_nested_namespace_specifier,
    STATE(11683), 1,
      sym__namespace_specifier,
  [339138] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14790), 1,
      anon_sym_COMMA,
    ACTIONS(14842), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(9355), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(14844), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [339155] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14790), 1,
      anon_sym_COMMA,
    ACTIONS(14846), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(9421), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(14848), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [339172] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(14850), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
    STATE(4575), 1,
      sym_template_method,
    STATE(10592), 1,
      sym_operator_name,
  [339191] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14852), 1,
      anon_sym_SEMI,
    STATE(9223), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [339208] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14854), 1,
      anon_sym_SEMI,
    STATE(9315), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [339225] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14856), 1,
      anon_sym_SEMI,
    STATE(9298), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [339242] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14858), 1,
      anon_sym_SEMI,
    STATE(9284), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [339259] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    ACTIONS(14860), 1,
      anon_sym_COLON,
    ACTIONS(14862), 1,
      anon_sym_SEMI,
    STATE(9630), 1,
      aux_sym_declaration_repeat1,
  [339278] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    ACTIONS(12628), 1,
      anon_sym_LBRACK,
    ACTIONS(14864), 1,
      anon_sym_RPAREN,
    STATE(3873), 1,
      sym_parameter_list,
    STATE(7526), 1,
      sym__function_declarator_seq,
  [339297] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COLON,
    ACTIONS(14868), 1,
      anon_sym_EQ,
    STATE(10153), 1,
      sym_interface_requirements,
    ACTIONS(14866), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [339314] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10603), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10607), 1,
      anon_sym_EQ,
    ACTIONS(14870), 1,
      sym_identifier,
    ACTIONS(10605), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [339331] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2861), 1,
      anon_sym_operator,
    ACTIONS(14762), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
    STATE(3360), 1,
      sym_template_method,
    STATE(10505), 1,
      sym_operator_name,
  [339350] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14872), 1,
      anon_sym_SEMI,
    STATE(5557), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [339367] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6783), 1,
      anon_sym_LBRACE,
    ACTIONS(14716), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(14874), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
  [339382] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(8485), 1,
      anon_sym___attribute__,
    ACTIONS(14876), 1,
      anon_sym_SEMI,
    STATE(5557), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [339399] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14878), 1,
      anon_sym_EQ,
    ACTIONS(14880), 1,
      anon_sym_GT2,
    STATE(9707), 1,
      aux_sym_template_argument_list_repeat1,
  [339415] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(14882), 1,
      anon_sym_DQUOTE,
    ACTIONS(14884), 1,
      aux_sym_string_literal_token1,
    ACTIONS(14886), 1,
      sym_escape_sequence,
    STATE(9323), 1,
      aux_sym_string_literal_repeat1,
  [339431] = 4,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(14888), 1,
      anon_sym_SQUOTE,
    STATE(9485), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(14890), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [339445] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(14892), 1,
      aux_sym_preproc_if_token2,
    STATE(8786), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(10970), 1,
      sym_enumerator,
  [339461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12874), 1,
      sym_identifier,
    ACTIONS(14894), 1,
      aux_sym_preproc_if_token2,
    STATE(8809), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [339475] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(14896), 1,
      anon_sym_DQUOTE,
    ACTIONS(14898), 1,
      aux_sym_string_literal_token1,
    ACTIONS(14900), 1,
      sym_escape_sequence,
    STATE(9488), 1,
      aux_sym_string_literal_repeat1,
  [339491] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(14898), 1,
      aux_sym_string_literal_token1,
    ACTIONS(14900), 1,
      sym_escape_sequence,
    ACTIONS(14902), 1,
      anon_sym_DQUOTE,
    STATE(9488), 1,
      aux_sym_string_literal_repeat1,
  [339507] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14904), 1,
      anon_sym___except,
    ACTIONS(14906), 1,
      anon_sym___finally,
    STATE(518), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [339521] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14908), 1,
      anon_sym_EQ,
    ACTIONS(14910), 1,
      anon_sym_GT2,
    STATE(9786), 1,
      aux_sym_template_argument_list_repeat1,
  [339537] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14912), 1,
      anon_sym_EQ,
    ACTIONS(14914), 1,
      anon_sym_GT2,
    STATE(9798), 1,
      aux_sym_template_argument_list_repeat1,
  [339553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10051), 1,
      anon_sym___attribute,
    ACTIONS(10049), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [339565] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13177), 1,
      sym_identifier,
    ACTIONS(14812), 1,
      aux_sym_preproc_if_token2,
    STATE(9321), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(10970), 1,
      sym_enumerator,
  [339581] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14916), 1,
      anon_sym_EQ,
    ACTIONS(14918), 1,
      anon_sym_GT2,
    STATE(10174), 1,
      aux_sym_template_argument_list_repeat1,
  [339597] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14920), 1,
      anon_sym_EQ,
    ACTIONS(14922), 1,
      anon_sym_GT2,
    STATE(10181), 1,
      aux_sym_template_argument_list_repeat1,
  [339613] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14924), 1,
      anon_sym_EQ,
    ACTIONS(14926), 1,
      anon_sym_GT2,
    STATE(9627), 1,
      aux_sym_template_argument_list_repeat1,
  [339629] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14928), 1,
      anon_sym_EQ,
    ACTIONS(14930), 1,
      anon_sym_GT2,
    STATE(9637), 1,
      aux_sym_template_argument_list_repeat1,
  [339645] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(498), 1,
      sym_field_declaration_list,
    STATE(10523), 1,
      sym_base_class_clause,
  [339661] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5777), 1,
      anon_sym_LBRACE,
    ACTIONS(14932), 1,
      anon_sym_COLON_COLON,
    ACTIONS(14934), 1,
      anon_sym_EQ,
    STATE(1148), 1,
      sym_declaration_list,
  [339677] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(829), 1,
      sym_field_declaration_list,
    STATE(10740), 1,
      sym_base_class_clause,
  [339693] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14936), 1,
      anon_sym_EQ,
    ACTIONS(14938), 1,
      anon_sym_GT2,
    STATE(9704), 1,
      aux_sym_template_argument_list_repeat1,
  [339709] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14940), 1,
      anon_sym_EQ,
    ACTIONS(14942), 1,
      anon_sym_GT2,
    STATE(9755), 1,
      aux_sym_template_argument_list_repeat1,
  [339725] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14944), 1,
      anon_sym_EQ,
    ACTIONS(14946), 1,
      anon_sym_GT2,
    STATE(9768), 1,
      aux_sym_template_argument_list_repeat1,
  [339741] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12874), 1,
      sym_identifier,
    ACTIONS(14948), 1,
      aux_sym_preproc_if_token2,
    STATE(9322), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [339755] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14950), 1,
      anon_sym_COMMA,
    STATE(9341), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(14953), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [339769] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(830), 1,
      sym_field_declaration_list,
    STATE(10745), 1,
      sym_base_class_clause,
  [339785] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14955), 1,
      anon_sym_EQ,
    ACTIONS(14957), 1,
      anon_sym_GT2,
    STATE(9656), 1,
      aux_sym_template_argument_list_repeat1,
  [339801] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14959), 1,
      anon_sym_EQ,
    ACTIONS(14961), 1,
      anon_sym_GT2,
    STATE(9848), 1,
      aux_sym_template_argument_list_repeat1,
  [339817] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14963), 1,
      anon_sym_EQ,
    ACTIONS(14965), 1,
      anon_sym_GT2,
    STATE(9859), 1,
      aux_sym_template_argument_list_repeat1,
  [339833] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11585), 1,
      anon_sym_LBRACE,
    ACTIONS(14967), 1,
      anon_sym_LPAREN2,
    STATE(5150), 1,
      sym_requirement_seq,
    STATE(10412), 1,
      sym_requires_parameter_list,
  [339849] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14969), 1,
      anon_sym_COMMA,
    STATE(9360), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(14971), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [339863] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14973), 1,
      anon_sym_EQ,
    ACTIONS(14975), 1,
      anon_sym_GT2,
    STATE(9942), 1,
      aux_sym_template_argument_list_repeat1,
  [339879] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14977), 1,
      anon_sym_EQ,
    ACTIONS(14979), 1,
      anon_sym_GT2,
    STATE(9945), 1,
      aux_sym_template_argument_list_repeat1,
  [339895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14981), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(14983), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [339907] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14985), 1,
      anon_sym_EQ,
    ACTIONS(14987), 1,
      anon_sym_GT2,
    STATE(10011), 1,
      aux_sym_template_argument_list_repeat1,
  [339923] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14989), 1,
      anon_sym_EQ,
    ACTIONS(14991), 1,
      anon_sym_GT2,
    STATE(10022), 1,
      aux_sym_template_argument_list_repeat1,
  [339939] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(176), 1,
      sym_template_argument_list,
    ACTIONS(7785), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [339953] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14993), 1,
      anon_sym_COMMA,
    STATE(9354), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(14983), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [339967] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14790), 1,
      anon_sym_COMMA,
    STATE(9354), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(14792), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [339981] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14790), 1,
      anon_sym_COMMA,
    STATE(9481), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(14792), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [339995] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(14996), 1,
      anon_sym_DQUOTE,
    ACTIONS(14998), 1,
      aux_sym_string_literal_token1,
    ACTIONS(15000), 1,
      sym_escape_sequence,
    STATE(9369), 1,
      aux_sym_string_literal_repeat1,
  [340011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15002), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(15004), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [340023] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15006), 1,
      anon_sym___except,
    ACTIONS(15008), 1,
      anon_sym___finally,
    STATE(832), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [340037] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15010), 1,
      anon_sym_COMMA,
    STATE(9360), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(15013), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [340051] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15015), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15017), 1,
      anon_sym_LPAREN,
    ACTIONS(15019), 1,
      sym_preproc_arg,
    STATE(10614), 1,
      sym_preproc_params,
  [340067] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    STATE(9882), 1,
      sym_compound_statement,
    STATE(10649), 1,
      sym_field_initializer_list,
  [340083] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5321), 1,
      anon_sym_LBRACE,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    STATE(4525), 1,
      sym_argument_list,
    STATE(4916), 1,
      sym_initializer_list,
  [340099] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(833), 1,
      sym_field_declaration_list,
    STATE(10468), 1,
      sym_base_class_clause,
  [340115] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15021), 1,
      anon_sym___except,
    ACTIONS(15023), 1,
      anon_sym___finally,
    STATE(832), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [340129] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(15025), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
    STATE(1192), 1,
      sym_template_parameter_list,
  [340145] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    STATE(5614), 1,
      sym_field_declaration_list,
    STATE(10479), 1,
      sym_base_class_clause,
  [340161] = 4,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15027), 1,
      anon_sym_SQUOTE,
    STATE(9485), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(14890), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [340175] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(14898), 1,
      aux_sym_string_literal_token1,
    ACTIONS(14900), 1,
      sym_escape_sequence,
    ACTIONS(15029), 1,
      anon_sym_DQUOTE,
    STATE(9488), 1,
      aux_sym_string_literal_repeat1,
  [340191] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(15031), 1,
      anon_sym_SEMI,
    STATE(2953), 1,
      sym_template_argument_list,
  [340207] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11623), 1,
      anon_sym_LBRACE,
    ACTIONS(14967), 1,
      anon_sym_LPAREN2,
    STATE(4935), 1,
      sym_requirement_seq,
    STATE(10369), 1,
      sym_requires_parameter_list,
  [340223] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15033), 1,
      anon_sym___except,
    ACTIONS(15035), 1,
      anon_sym___finally,
    STATE(716), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [340237] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(14032), 1,
      anon_sym_EQ,
    STATE(9535), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [340251] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(453), 1,
      sym_field_declaration_list,
    STATE(10601), 1,
      sym_base_class_clause,
  [340267] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14790), 1,
      anon_sym_COMMA,
    STATE(9421), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(14848), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [340281] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14790), 1,
      anon_sym_COMMA,
    STATE(9354), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(14848), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [340295] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(15037), 1,
      anon_sym_SEMI,
    STATE(2953), 1,
      sym_template_argument_list,
  [340311] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5024), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(1371), 1,
      sym_field_declaration_list,
    STATE(10677), 1,
      sym_base_class_clause,
  [340327] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    STATE(5618), 1,
      sym_field_declaration_list,
    STATE(10371), 1,
      sym_base_class_clause,
  [340343] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7724), 1,
      anon_sym_LBRACE,
    STATE(3605), 1,
      sym_field_declaration_list,
    STATE(10695), 1,
      sym_base_class_clause,
  [340359] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    STATE(9908), 1,
      sym_compound_statement,
    STATE(10418), 1,
      sym_field_initializer_list,
  [340375] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5024), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(1383), 1,
      sym_field_declaration_list,
    STATE(10701), 1,
      sym_base_class_clause,
  [340391] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5024), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(1384), 1,
      sym_field_declaration_list,
    STATE(10704), 1,
      sym_base_class_clause,
  [340407] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15017), 1,
      anon_sym_LPAREN,
    ACTIONS(15039), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15041), 1,
      sym_preproc_arg,
    STATE(10678), 1,
      sym_preproc_params,
  [340423] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15043), 1,
      anon_sym_EQ,
    ACTIONS(15045), 1,
      anon_sym_GT2,
    STATE(9668), 1,
      aux_sym_template_argument_list_repeat1,
  [340439] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(15047), 1,
      anon_sym_EQ,
    STATE(9560), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [340453] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(15049), 1,
      anon_sym_SEMI,
    STATE(2953), 1,
      sym_template_argument_list,
  [340469] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5024), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(1393), 1,
      sym_field_declaration_list,
    STATE(10420), 1,
      sym_base_class_clause,
  [340485] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15051), 1,
      anon_sym_EQ,
    ACTIONS(15053), 1,
      anon_sym_GT2,
    STATE(9675), 1,
      aux_sym_template_argument_list_repeat1,
  [340501] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15055), 1,
      anon_sym_DQUOTE,
    ACTIONS(15057), 1,
      aux_sym_string_literal_token1,
    ACTIONS(15059), 1,
      sym_escape_sequence,
    STATE(9409), 1,
      aux_sym_string_literal_repeat1,
  [340517] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15061), 1,
      sym_identifier,
    ACTIONS(15063), 1,
      anon_sym_COLON,
    ACTIONS(15065), 1,
      anon_sym_SEMI,
    STATE(9246), 1,
      sym_module_name,
  [340533] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15017), 1,
      anon_sym_LPAREN,
    ACTIONS(15067), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15069), 1,
      sym_preproc_arg,
    STATE(10739), 1,
      sym_preproc_params,
  [340549] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14749), 1,
      anon_sym_DOT,
    ACTIONS(14798), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(15071), 1,
      anon_sym_SEMI,
    STATE(9517), 1,
      aux_sym_module_name_repeat1,
  [340565] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14790), 1,
      anon_sym_COMMA,
    STATE(9355), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(14844), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [340579] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4964), 1,
      anon_sym_LBRACE,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    STATE(3387), 1,
      sym_initializer_list,
    STATE(3418), 1,
      sym_argument_list,
  [340595] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(2821), 1,
      sym_field_declaration_list,
    STATE(10351), 1,
      sym_base_class_clause,
  [340611] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(486), 1,
      sym_field_declaration_list,
    STATE(10382), 1,
      sym_base_class_clause,
  [340627] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(489), 1,
      sym_field_declaration_list,
    STATE(10438), 1,
      sym_base_class_clause,
  [340643] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15073), 1,
      anon_sym_DQUOTE,
    ACTIONS(15075), 1,
      aux_sym_string_literal_token1,
    ACTIONS(15077), 1,
      sym_escape_sequence,
    STATE(9406), 1,
      aux_sym_string_literal_repeat1,
  [340659] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15017), 1,
      anon_sym_LPAREN,
    ACTIONS(15079), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15081), 1,
      sym_preproc_arg,
    STATE(10469), 1,
      sym_preproc_params,
  [340675] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(15025), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
    STATE(1184), 1,
      sym_template_parameter_list,
  [340691] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(3191), 1,
      sym_field_declaration_list,
    STATE(10565), 1,
      sym_base_class_clause,
  [340707] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15083), 1,
      anon_sym_EQ,
    ACTIONS(15085), 1,
      anon_sym_GT2,
    STATE(10142), 1,
      aux_sym_template_argument_list_repeat1,
  [340723] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(701), 1,
      sym_field_declaration_list,
    STATE(10555), 1,
      sym_base_class_clause,
  [340739] = 4,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15087), 1,
      anon_sym_SQUOTE,
    STATE(9485), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(14890), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [340753] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(14898), 1,
      aux_sym_string_literal_token1,
    ACTIONS(14900), 1,
      sym_escape_sequence,
    ACTIONS(15089), 1,
      anon_sym_DQUOTE,
    STATE(9488), 1,
      aux_sym_string_literal_repeat1,
  [340769] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15091), 1,
      anon_sym_EQ,
    ACTIONS(15093), 1,
      anon_sym_GT2,
    STATE(9817), 1,
      aux_sym_template_argument_list_repeat1,
  [340785] = 4,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15095), 1,
      anon_sym_SQUOTE,
    STATE(9485), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(14890), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [340799] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(14898), 1,
      aux_sym_string_literal_token1,
    ACTIONS(14900), 1,
      sym_escape_sequence,
    ACTIONS(15097), 1,
      anon_sym_DQUOTE,
    STATE(9488), 1,
      aux_sym_string_literal_repeat1,
  [340815] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14967), 1,
      anon_sym_LPAREN2,
    ACTIONS(15099), 1,
      anon_sym_LBRACE,
    STATE(7144), 1,
      sym_requirement_seq,
    STATE(10612), 1,
      sym_requires_parameter_list,
  [340831] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15101), 1,
      anon_sym_COMMA,
    STATE(9522), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(15103), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [340845] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15105), 1,
      anon_sym_COMMA,
    STATE(9527), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(15107), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [340859] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(15109), 1,
      anon_sym_SEMI,
    ACTIONS(15111), 1,
      anon_sym_noexcept,
    STATE(10833), 1,
      sym_trailing_return_type,
  [340875] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5779), 1,
      anon_sym_LBRACE,
    ACTIONS(14932), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15113), 1,
      anon_sym_EQ,
    STATE(1070), 1,
      sym_declaration_list,
  [340891] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(15115), 1,
      anon_sym_SEMI,
    STATE(2953), 1,
      sym_template_argument_list,
  [340907] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(15117), 1,
      anon_sym_using,
    STATE(7796), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [340921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15119), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
  [340931] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(675), 1,
      sym_field_declaration_list,
    STATE(10702), 1,
      sym_base_class_clause,
  [340947] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11615), 1,
      anon_sym_LBRACE,
    ACTIONS(14967), 1,
      anon_sym_LPAREN2,
    STATE(4593), 1,
      sym_requirement_seq,
    STATE(10583), 1,
      sym_requires_parameter_list,
  [340963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14726), 4,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOT,
  [340973] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14790), 1,
      anon_sym_COMMA,
    STATE(9354), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(14844), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [340987] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(15121), 1,
      anon_sym_SEMI,
    STATE(2953), 1,
      sym_template_argument_list,
  [341003] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15123), 1,
      anon_sym_EQ,
    ACTIONS(15125), 1,
      anon_sym_GT2,
    STATE(9789), 1,
      aux_sym_template_argument_list_repeat1,
  [341019] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    STATE(10280), 1,
      sym_compound_statement,
    STATE(10378), 1,
      sym_field_initializer_list,
  [341035] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(15025), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
    STATE(1193), 1,
      sym_template_parameter_list,
  [341051] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(15127), 1,
      anon_sym_SEMI,
    STATE(2953), 1,
      sym_template_argument_list,
  [341067] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(379), 1,
      sym_field_declaration_list,
    STATE(10534), 1,
      sym_base_class_clause,
  [341083] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2224), 1,
      anon_sym_SEMI,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(2999), 1,
      sym_template_argument_list,
  [341099] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(15129), 1,
      anon_sym_SEMI,
    STATE(2953), 1,
      sym_template_argument_list,
  [341115] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15131), 1,
      anon_sym_EQ,
    ACTIONS(15133), 1,
      anon_sym_GT2,
    STATE(9801), 1,
      aux_sym_template_argument_list_repeat1,
  [341131] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15135), 1,
      anon_sym___except,
    ACTIONS(15137), 1,
      anon_sym___finally,
    STATE(496), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [341145] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(833), 1,
      sym_field_declaration_list,
    STATE(10429), 1,
      sym_base_class_clause,
  [341161] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(650), 1,
      sym_field_declaration_list,
    STATE(10437), 1,
      sym_base_class_clause,
  [341177] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(15025), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
    STATE(1187), 1,
      sym_template_parameter_list,
  [341193] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15139), 1,
      anon_sym_EQ,
    ACTIONS(15141), 1,
      anon_sym_GT2,
    STATE(9828), 1,
      aux_sym_template_argument_list_repeat1,
  [341209] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(506), 1,
      sym_field_declaration_list,
    STATE(10620), 1,
      sym_base_class_clause,
  [341225] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(507), 1,
      sym_field_declaration_list,
    STATE(10622), 1,
      sym_base_class_clause,
  [341241] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15143), 1,
      anon_sym_DQUOTE,
    ACTIONS(15145), 1,
      aux_sym_string_literal_token1,
    ACTIONS(15147), 1,
      sym_escape_sequence,
    STATE(9442), 1,
      aux_sym_string_literal_repeat1,
  [341257] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(3237), 1,
      sym_field_declaration_list,
    STATE(10465), 1,
      sym_base_class_clause,
  [341273] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(9311), 1,
      anon_sym_LBRACE,
    STATE(5161), 1,
      sym_field_declaration_list,
    STATE(10683), 1,
      sym_base_class_clause,
  [341289] = 4,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15149), 1,
      anon_sym_SQUOTE,
    STATE(9485), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(14890), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [341303] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(14898), 1,
      aux_sym_string_literal_token1,
    ACTIONS(14900), 1,
      sym_escape_sequence,
    ACTIONS(15151), 1,
      anon_sym_DQUOTE,
    STATE(9488), 1,
      aux_sym_string_literal_repeat1,
  [341319] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11593), 1,
      anon_sym_LBRACE,
    ACTIONS(14967), 1,
      anon_sym_LPAREN2,
    STATE(4729), 1,
      sym_requirement_seq,
    STATE(10714), 1,
      sym_requires_parameter_list,
  [341335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(10044), 2,
      sym_argument_list,
      sym_initializer_list,
  [341349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15153), 1,
      sym_identifier,
    ACTIONS(15155), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [341361] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(9311), 1,
      anon_sym_LBRACE,
    STATE(5168), 1,
      sym_field_declaration_list,
    STATE(10336), 1,
      sym_base_class_clause,
  [341377] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    STATE(9659), 1,
      sym_compound_statement,
    STATE(10744), 1,
      sym_field_initializer_list,
  [341393] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(15025), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
    STATE(1197), 1,
      sym_template_parameter_list,
  [341409] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15157), 1,
      anon_sym_EQ,
    ACTIONS(15159), 1,
      anon_sym_GT2,
    STATE(9894), 1,
      aux_sym_template_argument_list_repeat1,
  [341425] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15161), 1,
      anon_sym_EQ,
    ACTIONS(15163), 1,
      anon_sym_GT2,
    STATE(9897), 1,
      aux_sym_template_argument_list_repeat1,
  [341441] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    STATE(10156), 1,
      sym_compound_statement,
    STATE(10422), 1,
      sym_field_initializer_list,
  [341457] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(15025), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
    STATE(1191), 1,
      sym_template_parameter_list,
  [341473] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(10576), 1,
      sym_argument_list,
    ACTIONS(15165), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [341487] = 4,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15167), 1,
      anon_sym_SQUOTE,
    STATE(9485), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(14890), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [341501] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(829), 1,
      sym_field_declaration_list,
    STATE(10572), 1,
      sym_base_class_clause,
  [341517] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(830), 1,
      sym_field_declaration_list,
    STATE(10573), 1,
      sym_base_class_clause,
  [341533] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15169), 1,
      anon_sym_EQ,
    ACTIONS(15171), 1,
      anon_sym_GT2,
    STATE(9970), 1,
      aux_sym_template_argument_list_repeat1,
  [341549] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(14898), 1,
      aux_sym_string_literal_token1,
    ACTIONS(14900), 1,
      sym_escape_sequence,
    ACTIONS(15173), 1,
      anon_sym_DQUOTE,
    STATE(9488), 1,
      aux_sym_string_literal_repeat1,
  [341565] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15175), 1,
      anon_sym_DQUOTE,
    ACTIONS(15177), 1,
      aux_sym_string_literal_token1,
    ACTIONS(15179), 1,
      sym_escape_sequence,
    STATE(9466), 1,
      aux_sym_string_literal_repeat1,
  [341581] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    STATE(9631), 1,
      sym_compound_statement,
    STATE(10492), 1,
      sym_field_initializer_list,
  [341597] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15181), 1,
      anon_sym_EQ,
    ACTIONS(15183), 1,
      anon_sym_GT2,
    STATE(9994), 1,
      aux_sym_template_argument_list_repeat1,
  [341613] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(15025), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
    STATE(1185), 1,
      sym_template_parameter_list,
  [341629] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(647), 1,
      sym_field_declaration_list,
    STATE(10582), 1,
      sym_base_class_clause,
  [341645] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(8076), 1,
      anon_sym_LBRACE,
    STATE(3756), 1,
      sym_field_declaration_list,
    STATE(10550), 1,
      sym_base_class_clause,
  [341661] = 4,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15185), 1,
      anon_sym_SQUOTE,
    STATE(9485), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(14890), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [341675] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(14898), 1,
      aux_sym_string_literal_token1,
    ACTIONS(14900), 1,
      sym_escape_sequence,
    ACTIONS(15187), 1,
      anon_sym_DQUOTE,
    STATE(9488), 1,
      aux_sym_string_literal_repeat1,
  [341691] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14967), 1,
      anon_sym_LPAREN2,
    ACTIONS(15189), 1,
      anon_sym_LBRACE,
    STATE(7047), 1,
      sym_requirement_seq,
    STATE(10513), 1,
      sym_requires_parameter_list,
  [341707] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15191), 1,
      anon_sym_DQUOTE,
    ACTIONS(15193), 1,
      aux_sym_string_literal_token1,
    ACTIONS(15195), 1,
      sym_escape_sequence,
    STATE(9458), 1,
      aux_sym_string_literal_repeat1,
  [341723] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(12985), 1,
      anon_sym_COLON,
    STATE(9751), 1,
      sym_compound_statement,
    STATE(10559), 1,
      sym_field_initializer_list,
  [341739] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(15197), 1,
      anon_sym_SEMI,
    STATE(2953), 1,
      sym_template_argument_list,
  [341755] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(8076), 1,
      anon_sym_LBRACE,
    STATE(3784), 1,
      sym_field_declaration_list,
    STATE(10575), 1,
      sym_base_class_clause,
  [341771] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15101), 1,
      anon_sym_COMMA,
    STATE(9411), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(15199), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [341785] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(838), 1,
      sym_field_declaration_list,
    STATE(10659), 1,
      sym_base_class_clause,
  [341801] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5773), 1,
      anon_sym_LBRACE,
    ACTIONS(14932), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15201), 1,
      anon_sym_EQ,
    STATE(603), 1,
      sym_declaration_list,
  [341817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15203), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [341827] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11631), 1,
      anon_sym_LBRACE,
    ACTIONS(14967), 1,
      anon_sym_LPAREN2,
    STATE(3413), 1,
      sym_requirement_seq,
    STATE(10496), 1,
      sym_requires_parameter_list,
  [341843] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15205), 1,
      anon_sym_EQ,
    ACTIONS(15207), 1,
      anon_sym_GT2,
    STATE(9983), 1,
      aux_sym_template_argument_list_repeat1,
  [341859] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15209), 1,
      anon_sym_DQUOTE,
    ACTIONS(15211), 1,
      aux_sym_string_literal_token1,
    ACTIONS(15213), 1,
      sym_escape_sequence,
    STATE(9503), 1,
      aux_sym_string_literal_repeat1,
  [341875] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15215), 1,
      anon_sym_EQ,
    ACTIONS(15217), 1,
      anon_sym_GT2,
    STATE(9998), 1,
      aux_sym_template_argument_list_repeat1,
  [341891] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15219), 1,
      anon_sym_EQ,
    ACTIONS(15221), 1,
      anon_sym_GT2,
    STATE(10017), 1,
      aux_sym_template_argument_list_repeat1,
  [341907] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14790), 1,
      anon_sym_COMMA,
    STATE(9354), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(15223), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [341921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(15227), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [341933] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15017), 1,
      anon_sym_LPAREN,
    ACTIONS(15229), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15231), 1,
      sym_preproc_arg,
    STATE(10380), 1,
      sym_preproc_params,
  [341949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14790), 1,
      anon_sym_COMMA,
    STATE(9590), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(15223), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [341963] = 4,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15233), 1,
      anon_sym_SQUOTE,
    STATE(9485), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(15235), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [341977] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5266), 1,
      anon_sym_LBRACE,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    STATE(4680), 1,
      sym_argument_list,
    STATE(4728), 1,
      sym_initializer_list,
  [341993] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15238), 1,
      anon_sym_DQUOTE,
    ACTIONS(15240), 1,
      aux_sym_string_literal_token1,
    ACTIONS(15242), 1,
      sym_escape_sequence,
    STATE(9492), 1,
      aux_sym_string_literal_repeat1,
  [342009] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15244), 1,
      anon_sym_DQUOTE,
    ACTIONS(15246), 1,
      aux_sym_string_literal_token1,
    ACTIONS(15249), 1,
      sym_escape_sequence,
    STATE(9488), 1,
      aux_sym_string_literal_repeat1,
  [342025] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(15252), 1,
      anon_sym_SEMI,
    STATE(2953), 1,
      sym_template_argument_list,
  [342041] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    STATE(5712), 1,
      sym_field_declaration_list,
    STATE(10758), 1,
      sym_base_class_clause,
  [342057] = 4,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15254), 1,
      anon_sym_SQUOTE,
    STATE(9485), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(14890), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [342071] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(14898), 1,
      aux_sym_string_literal_token1,
    ACTIONS(14900), 1,
      sym_escape_sequence,
    ACTIONS(15256), 1,
      anon_sym_DQUOTE,
    STATE(9488), 1,
      aux_sym_string_literal_repeat1,
  [342087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15203), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [342097] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    STATE(5641), 1,
      sym_field_declaration_list,
    STATE(10784), 1,
      sym_base_class_clause,
  [342113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15260), 1,
      anon_sym___attribute,
    ACTIONS(15258), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [342125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15264), 1,
      anon_sym___attribute,
    ACTIONS(15262), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [342137] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7256), 1,
      anon_sym_LBRACE,
    STATE(3166), 1,
      sym_field_declaration_list,
    STATE(10459), 1,
      sym_base_class_clause,
  [342153] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15266), 1,
      anon_sym_EQ,
    ACTIONS(15268), 1,
      anon_sym_GT2,
    STATE(10061), 1,
      aux_sym_template_argument_list_repeat1,
  [342169] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15270), 1,
      anon_sym_EQ,
    ACTIONS(15272), 1,
      anon_sym_GT2,
    STATE(10062), 1,
      aux_sym_template_argument_list_repeat1,
  [342185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(15274), 1,
      anon_sym_EQ,
    STATE(7796), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [342199] = 4,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15276), 1,
      anon_sym_SQUOTE,
    STATE(9485), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(14890), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [342213] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(15278), 1,
      anon_sym_using,
    STATE(7796), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [342227] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(14898), 1,
      aux_sym_string_literal_token1,
    ACTIONS(14900), 1,
      sym_escape_sequence,
    ACTIONS(15280), 1,
      anon_sym_DQUOTE,
    STATE(9488), 1,
      aux_sym_string_literal_repeat1,
  [342243] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15282), 1,
      anon_sym_EQ,
    ACTIONS(15284), 1,
      anon_sym_GT2,
    STATE(9752), 1,
      aux_sym_template_argument_list_repeat1,
  [342259] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(15286), 1,
      anon_sym_EQ,
    STATE(9565), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [342273] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14967), 1,
      anon_sym_LPAREN2,
    ACTIONS(15288), 1,
      anon_sym_LBRACE,
    STATE(1765), 1,
      sym_requirement_seq,
    STATE(10449), 1,
      sym_requires_parameter_list,
  [342289] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15290), 1,
      anon_sym_DQUOTE,
    ACTIONS(15292), 1,
      aux_sym_string_literal_token1,
    ACTIONS(15294), 1,
      sym_escape_sequence,
    STATE(9511), 1,
      aux_sym_string_literal_repeat1,
  [342305] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15296), 1,
      anon_sym_DQUOTE,
    ACTIONS(15298), 1,
      aux_sym_string_literal_token1,
    ACTIONS(15300), 1,
      sym_escape_sequence,
    STATE(9324), 1,
      aux_sym_string_literal_repeat1,
  [342321] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7812), 1,
      anon_sym_LBRACE,
    STATE(3632), 1,
      sym_field_declaration_list,
    STATE(10394), 1,
      sym_base_class_clause,
  [342337] = 4,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15302), 1,
      anon_sym_SQUOTE,
    STATE(9485), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(14890), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [342351] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(14898), 1,
      aux_sym_string_literal_token1,
    ACTIONS(14900), 1,
      sym_escape_sequence,
    ACTIONS(15304), 1,
      anon_sym_DQUOTE,
    STATE(9488), 1,
      aux_sym_string_literal_repeat1,
  [342367] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7812), 1,
      anon_sym_LBRACE,
    STATE(3635), 1,
      sym_field_declaration_list,
    STATE(10406), 1,
      sym_base_class_clause,
  [342383] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(15306), 1,
      anon_sym_SEMI,
    STATE(2953), 1,
      sym_template_argument_list,
  [342399] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(15308), 1,
      anon_sym_SEMI,
    STATE(2953), 1,
      sym_template_argument_list,
  [342415] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15310), 1,
      anon_sym_EQ,
    ACTIONS(15312), 1,
      anon_sym_GT2,
    STATE(10101), 1,
      aux_sym_template_argument_list_repeat1,
  [342431] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15314), 1,
      anon_sym_EQ,
    ACTIONS(15316), 1,
      anon_sym_GT2,
    STATE(10105), 1,
      aux_sym_template_argument_list_repeat1,
  [342447] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14747), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(14749), 1,
      anon_sym_DOT,
    ACTIONS(15318), 1,
      anon_sym_SEMI,
    STATE(9248), 1,
      aux_sym_module_name_repeat1,
  [342463] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15320), 1,
      anon_sym___except,
    ACTIONS(15322), 1,
      anon_sym___finally,
    STATE(1370), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [342477] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(717), 1,
      sym_field_declaration_list,
    STATE(10551), 1,
      sym_base_class_clause,
  [342493] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15324), 1,
      anon_sym_DQUOTE,
    ACTIONS(15326), 1,
      aux_sym_string_literal_token1,
    ACTIONS(15328), 1,
      sym_escape_sequence,
    STATE(9525), 1,
      aux_sym_string_literal_repeat1,
  [342509] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(15330), 1,
      anon_sym_SEMI,
    STATE(2953), 1,
      sym_template_argument_list,
  [342525] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15332), 1,
      anon_sym_COMMA,
    STATE(9522), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(15335), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [342539] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(8550), 1,
      anon_sym_LBRACE,
    STATE(4908), 1,
      sym_field_declaration_list,
    STATE(10454), 1,
      sym_base_class_clause,
  [342555] = 4,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15337), 1,
      anon_sym_SQUOTE,
    STATE(9485), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(14890), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [342569] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(14898), 1,
      aux_sym_string_literal_token1,
    ACTIONS(14900), 1,
      sym_escape_sequence,
    ACTIONS(15339), 1,
      anon_sym_DQUOTE,
    STATE(9488), 1,
      aux_sym_string_literal_repeat1,
  [342585] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15017), 1,
      anon_sym_LPAREN,
    ACTIONS(15341), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15343), 1,
      sym_preproc_arg,
    STATE(10463), 1,
      sym_preproc_params,
  [342601] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15105), 1,
      anon_sym_COMMA,
    STATE(9341), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(15345), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [342615] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(8550), 1,
      anon_sym_LBRACE,
    STATE(4911), 1,
      sym_field_declaration_list,
    STATE(10461), 1,
      sym_base_class_clause,
  [342631] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14969), 1,
      anon_sym_COMMA,
    STATE(9347), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(15347), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [342645] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7256), 1,
      anon_sym_LBRACE,
    STATE(3164), 1,
      sym_field_declaration_list,
    STATE(10571), 1,
      sym_base_class_clause,
  [342661] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15349), 1,
      anon_sym_EQ,
    ACTIONS(15351), 1,
      anon_sym_GT2,
    STATE(10133), 1,
      aux_sym_template_argument_list_repeat1,
  [342677] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15353), 1,
      anon_sym_EQ,
    ACTIONS(15355), 1,
      anon_sym_GT2,
    STATE(10134), 1,
      aux_sym_template_argument_list_repeat1,
  [342693] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15357), 1,
      anon_sym_DQUOTE,
    ACTIONS(15359), 1,
      aux_sym_string_literal_token1,
    ACTIONS(15361), 1,
      sym_escape_sequence,
    STATE(9536), 1,
      aux_sym_string_literal_repeat1,
  [342709] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5781), 1,
      anon_sym_LBRACE,
    ACTIONS(14932), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15363), 1,
      anon_sym_EQ,
    STATE(930), 1,
      sym_declaration_list,
  [342725] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(15365), 1,
      anon_sym_EQ,
    STATE(7796), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [342739] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(14898), 1,
      aux_sym_string_literal_token1,
    ACTIONS(14900), 1,
      sym_escape_sequence,
    ACTIONS(15367), 1,
      anon_sym_DQUOTE,
    STATE(9488), 1,
      aux_sym_string_literal_repeat1,
  [342755] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15369), 1,
      anon_sym_EQ,
    ACTIONS(15371), 1,
      anon_sym_GT2,
    STATE(10164), 1,
      aux_sym_template_argument_list_repeat1,
  [342771] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15373), 1,
      anon_sym_EQ,
    ACTIONS(15375), 1,
      anon_sym_GT2,
    STATE(10166), 1,
      aux_sym_template_argument_list_repeat1,
  [342787] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(10706), 1,
      sym_argument_list,
    ACTIONS(15377), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [342801] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15379), 1,
      anon_sym_DQUOTE,
    ACTIONS(15381), 1,
      aux_sym_string_literal_token1,
    ACTIONS(15383), 1,
      sym_escape_sequence,
    STATE(9542), 1,
      aux_sym_string_literal_repeat1,
  [342817] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11601), 1,
      anon_sym_LBRACE,
    ACTIONS(14967), 1,
      anon_sym_LPAREN2,
    STATE(4031), 1,
      sym_requirement_seq,
    STATE(10579), 1,
      sym_requires_parameter_list,
  [342833] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(14898), 1,
      aux_sym_string_literal_token1,
    ACTIONS(14900), 1,
      sym_escape_sequence,
    ACTIONS(15385), 1,
      anon_sym_DQUOTE,
    STATE(9488), 1,
      aux_sym_string_literal_repeat1,
  [342849] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5479), 1,
      anon_sym_LBRACE,
    ACTIONS(8278), 1,
      anon_sym_LPAREN2,
    STATE(4680), 1,
      sym_argument_list,
    STATE(6082), 1,
      sym_initializer_list,
  [342865] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(15025), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
    STATE(9256), 1,
      sym_template_parameter_list,
  [342881] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(15387), 1,
      anon_sym_SEMI,
    STATE(2953), 1,
      sym_template_argument_list,
  [342897] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(15389), 1,
      anon_sym_EQ,
    STATE(7796), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [342911] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(15391), 1,
      anon_sym_using,
    STATE(7796), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [342925] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(14045), 1,
      anon_sym_EQ,
    STATE(9500), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [342939] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(726), 1,
      sym_field_declaration_list,
    STATE(10629), 1,
      sym_base_class_clause,
  [342955] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15393), 1,
      anon_sym_EQ,
    ACTIONS(15395), 1,
      anon_sym_GT2,
    STATE(10196), 1,
      aux_sym_template_argument_list_repeat1,
  [342971] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(727), 1,
      sym_field_declaration_list,
    STATE(10630), 1,
      sym_base_class_clause,
  [342987] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15397), 1,
      anon_sym_EQ,
    ACTIONS(15399), 1,
      anon_sym_GT2,
    STATE(10197), 1,
      aux_sym_template_argument_list_repeat1,
  [343003] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15401), 1,
      anon_sym_DQUOTE,
    ACTIONS(15403), 1,
      aux_sym_string_literal_token1,
    ACTIONS(15405), 1,
      sym_escape_sequence,
    STATE(9554), 1,
      aux_sym_string_literal_repeat1,
  [343019] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(14898), 1,
      aux_sym_string_literal_token1,
    ACTIONS(14900), 1,
      sym_escape_sequence,
    ACTIONS(15407), 1,
      anon_sym_DQUOTE,
    STATE(9488), 1,
      aux_sym_string_literal_repeat1,
  [343035] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15409), 1,
      anon_sym_EQ,
    ACTIONS(15411), 1,
      anon_sym_GT2,
    STATE(10266), 1,
      aux_sym_template_argument_list_repeat1,
  [343051] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(15413), 1,
      anon_sym_EQ,
    STATE(7796), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [343065] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(14078), 1,
      anon_sym_EQ,
    STATE(9546), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [343079] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15415), 1,
      anon_sym_EQ,
    ACTIONS(15417), 1,
      anon_sym_GT2,
    STATE(10225), 1,
      aux_sym_template_argument_list_repeat1,
  [343095] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15419), 1,
      anon_sym_EQ,
    ACTIONS(15421), 1,
      anon_sym_GT2,
    STATE(10226), 1,
      aux_sym_template_argument_list_repeat1,
  [343111] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(15423), 1,
      anon_sym_EQ,
    STATE(7796), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [343125] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13951), 1,
      anon_sym_EQ,
    STATE(9556), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [343139] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15425), 1,
      anon_sym_DQUOTE,
    ACTIONS(15427), 1,
      aux_sym_string_literal_token1,
    ACTIONS(15429), 1,
      sym_escape_sequence,
    STATE(9567), 1,
      aux_sym_string_literal_repeat1,
  [343155] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(15431), 1,
      anon_sym_SEMI,
    STATE(2953), 1,
      sym_template_argument_list,
  [343171] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(509), 1,
      sym_field_declaration_list,
    STATE(10699), 1,
      sym_base_class_clause,
  [343187] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(15433), 1,
      anon_sym_EQ,
    STATE(7796), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [343201] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13970), 1,
      anon_sym_EQ,
    STATE(9569), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [343215] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(14898), 1,
      aux_sym_string_literal_token1,
    ACTIONS(14900), 1,
      sym_escape_sequence,
    ACTIONS(15435), 1,
      anon_sym_DQUOTE,
    STATE(9488), 1,
      aux_sym_string_literal_repeat1,
  [343231] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(736), 1,
      sym_field_declaration_list,
    STATE(10687), 1,
      sym_base_class_clause,
  [343247] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(15437), 1,
      anon_sym_EQ,
    STATE(7796), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [343261] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(14008), 1,
      anon_sym_EQ,
    STATE(9574), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [343275] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7724), 1,
      anon_sym_LBRACE,
    STATE(3579), 1,
      sym_field_declaration_list,
    STATE(10408), 1,
      sym_base_class_clause,
  [343291] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15439), 1,
      anon_sym_EQ,
    ACTIONS(15441), 1,
      anon_sym_GT2,
    STATE(10252), 1,
      aux_sym_template_argument_list_repeat1,
  [343307] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    ACTIONS(7358), 1,
      anon_sym_LPAREN2,
    STATE(3418), 1,
      sym_argument_list,
    STATE(4856), 1,
      sym_initializer_list,
  [343323] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(15443), 1,
      anon_sym_EQ,
    STATE(7796), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [343337] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(14085), 1,
      anon_sym_EQ,
    STATE(9577), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [343351] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15445), 1,
      anon_sym_EQ,
    ACTIONS(15447), 1,
      anon_sym_GT2,
    STATE(10255), 1,
      aux_sym_template_argument_list_repeat1,
  [343367] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(15449), 1,
      anon_sym_EQ,
    STATE(7796), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [343381] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15451), 1,
      anon_sym_EQ,
    ACTIONS(15453), 1,
      anon_sym_GT2,
    STATE(10286), 1,
      aux_sym_template_argument_list_repeat1,
  [343397] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(6392), 1,
      sym_field_declaration_list,
    STATE(10665), 1,
      sym_base_class_clause,
  [343413] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15455), 1,
      anon_sym_DQUOTE,
    ACTIONS(15457), 1,
      aux_sym_string_literal_token1,
    ACTIONS(15459), 1,
      sym_escape_sequence,
    STATE(9582), 1,
      aux_sym_string_literal_repeat1,
  [343429] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(6396), 1,
      sym_field_declaration_list,
    STATE(10667), 1,
      sym_base_class_clause,
  [343445] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(14898), 1,
      aux_sym_string_literal_token1,
    ACTIONS(14900), 1,
      sym_escape_sequence,
    ACTIONS(15461), 1,
      anon_sym_DQUOTE,
    STATE(9488), 1,
      aux_sym_string_literal_repeat1,
  [343461] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15463), 1,
      anon_sym_DQUOTE,
    ACTIONS(15465), 1,
      aux_sym_string_literal_token1,
    ACTIONS(15467), 1,
      sym_escape_sequence,
    STATE(9600), 1,
      aux_sym_string_literal_repeat1,
  [343477] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15469), 1,
      anon_sym_EQ,
    ACTIONS(15471), 1,
      anon_sym_GT2,
    STATE(10290), 1,
      aux_sym_template_argument_list_repeat1,
  [343493] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15473), 1,
      anon_sym_EQ,
    ACTIONS(15475), 1,
      anon_sym_GT2,
    STATE(10295), 1,
      aux_sym_template_argument_list_repeat1,
  [343509] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15017), 1,
      anon_sym_LPAREN,
    ACTIONS(15477), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15479), 1,
      sym_preproc_arg,
    STATE(10632), 1,
      sym_preproc_params,
  [343525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15481), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(15483), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [343537] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(6523), 1,
      sym_field_declaration_list,
    STATE(10716), 1,
      sym_base_class_clause,
  [343553] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(6526), 1,
      sym_field_declaration_list,
    STATE(10717), 1,
      sym_base_class_clause,
  [343569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14790), 1,
      anon_sym_COMMA,
    STATE(9354), 1,
      aux_sym_base_class_clause_repeat1,
    ACTIONS(15485), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [343583] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_LBRACE,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    STATE(4525), 1,
      sym_argument_list,
    STATE(4526), 1,
      sym_initializer_list,
  [343599] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    STATE(6533), 1,
      sym_field_declaration_list,
    STATE(10728), 1,
      sym_base_class_clause,
  [343615] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    STATE(6486), 1,
      sym_field_declaration_list,
    STATE(10729), 1,
      sym_base_class_clause,
  [343631] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15487), 1,
      anon_sym_DQUOTE,
    ACTIONS(15489), 1,
      aux_sym_string_literal_token1,
    ACTIONS(15491), 1,
      sym_escape_sequence,
    STATE(9596), 1,
      aux_sym_string_literal_repeat1,
  [343647] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(838), 1,
      sym_field_declaration_list,
    STATE(10587), 1,
      sym_base_class_clause,
  [343663] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(14898), 1,
      aux_sym_string_literal_token1,
    ACTIONS(14900), 1,
      sym_escape_sequence,
    ACTIONS(15493), 1,
      anon_sym_DQUOTE,
    STATE(9488), 1,
      aux_sym_string_literal_repeat1,
  [343679] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(2819), 1,
      sym_field_declaration_list,
    STATE(10642), 1,
      sym_base_class_clause,
  [343695] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15495), 1,
      anon_sym_EQ,
    ACTIONS(15497), 1,
      anon_sym_GT2,
    STATE(10326), 1,
      aux_sym_template_argument_list_repeat1,
  [343711] = 4,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15499), 1,
      anon_sym_SQUOTE,
    STATE(9485), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(14890), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [343725] = 5,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(14898), 1,
      aux_sym_string_literal_token1,
    ACTIONS(14900), 1,
      sym_escape_sequence,
    ACTIONS(15501), 1,
      anon_sym_DQUOTE,
    STATE(9488), 1,
      aux_sym_string_literal_repeat1,
  [343741] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15503), 1,
      anon_sym_EQ,
    ACTIONS(15505), 1,
      anon_sym_GT2,
    STATE(10328), 1,
      aux_sym_template_argument_list_repeat1,
  [343757] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12699), 1,
      anon_sym_EQ,
    ACTIONS(13490), 1,
      anon_sym_COLON,
    ACTIONS(13488), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [343771] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15159), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [343784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15507), 3,
      anon_sym_RBRACE,
      anon_sym_get,
      anon_sym_set,
  [343793] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15509), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [343806] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5777), 1,
      anon_sym_LBRACE,
    ACTIONS(14932), 1,
      anon_sym_COLON_COLON,
    STATE(970), 1,
      sym_declaration_list,
  [343819] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14926), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [343832] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15511), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [343845] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10312), 1,
      anon_sym_COMMA,
    ACTIONS(10314), 1,
      anon_sym_RBRACE,
    STATE(9851), 1,
      aux_sym_initializer_list_repeat1,
  [343858] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15513), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [343871] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7525), 1,
      anon_sym_COMMA,
    ACTIONS(15515), 1,
      anon_sym_RBRACK,
    STATE(10048), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [343884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15517), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [343893] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15519), 1,
      anon_sym_COMMA,
    ACTIONS(15521), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(10176), 1,
      aux_sym_attribute_declaration_repeat1,
  [343906] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10181), 1,
      anon_sym_COMMA,
    ACTIONS(10227), 1,
      anon_sym_RPAREN,
    STATE(9636), 1,
      aux_sym_argument_list_repeat1,
  [343919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14930), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [343932] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15523), 1,
      anon_sym_COMMA,
    ACTIONS(15525), 1,
      anon_sym_RBRACK,
    STATE(10122), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [343945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5781), 1,
      anon_sym_LBRACE,
    ACTIONS(14932), 1,
      anon_sym_COLON_COLON,
    STATE(1040), 1,
      sym_declaration_list,
  [343958] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10229), 1,
      anon_sym_COMMA,
    ACTIONS(10231), 1,
      anon_sym_RBRACE,
    STATE(9639), 1,
      aux_sym_initializer_list_repeat1,
  [343971] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10364), 1,
      anon_sym_COMMA,
    ACTIONS(10366), 1,
      anon_sym_RBRACE,
    STATE(9694), 1,
      aux_sym_initializer_list_repeat1,
  [343984] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15527), 1,
      anon_sym_GT2,
    STATE(9638), 1,
      aux_sym_template_argument_list_repeat1,
  [343997] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15529), 1,
      anon_sym_RPAREN,
    ACTIONS(15531), 1,
      anon_sym_COLON,
    STATE(9643), 1,
      sym_gnu_asm_output_operand_list,
  [344010] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(15533), 1,
      anon_sym_LBRACE,
    STATE(11588), 1,
      sym_trailing_return_type,
  [344023] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(15535), 1,
      anon_sym_SEMI,
    STATE(11014), 1,
      sym_base_class_clause,
  [344036] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15537), 1,
      anon_sym_COMMA,
    ACTIONS(15540), 1,
      anon_sym_GT2,
    STATE(9624), 1,
      aux_sym_template_parameter_list_repeat1,
  [344049] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15542), 1,
      anon_sym_default,
    ACTIONS(15544), 1,
      anon_sym_delete,
    ACTIONS(15546), 1,
      aux_sym_pure_virtual_clause_token1,
  [344062] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15548), 1,
      anon_sym_GT2,
    STATE(9650), 1,
      aux_sym_template_argument_list_repeat1,
  [344075] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15527), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [344088] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15550), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [344101] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15552), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [344114] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15554), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [344127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15556), 1,
      anon_sym_catch,
    STATE(1644), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [344138] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15531), 1,
      anon_sym_COLON,
    ACTIONS(15558), 1,
      anon_sym_RPAREN,
    STATE(9701), 1,
      sym_gnu_asm_output_operand_list,
  [344151] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11478), 1,
      anon_sym_requires,
    ACTIONS(13337), 1,
      anon_sym_LBRACE,
    STATE(11035), 1,
      sym_requires_clause,
  [344164] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15560), 1,
      anon_sym_GT2,
    STATE(9717), 1,
      aux_sym_template_argument_list_repeat1,
  [344177] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15562), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [344190] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10181), 1,
      anon_sym_COMMA,
    ACTIONS(15564), 1,
      anon_sym_RPAREN,
    STATE(10304), 1,
      aux_sym_argument_list_repeat1,
  [344203] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10398), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [344216] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15566), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [344229] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6041), 1,
      anon_sym_RBRACE,
    ACTIONS(15568), 1,
      anon_sym_COMMA,
    STATE(9706), 1,
      aux_sym_initializer_list_repeat1,
  [344242] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15570), 1,
      anon_sym_RPAREN,
    ACTIONS(15572), 1,
      anon_sym_COLON,
    STATE(11068), 1,
      sym_gnu_asm_goto_list,
  [344255] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15574), 1,
      anon_sym_RPAREN,
    ACTIONS(15576), 1,
      anon_sym_COLON,
    STATE(9733), 1,
      sym_gnu_asm_clobber_list,
  [344268] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15566), 1,
      anon_sym_GT2,
    STATE(9657), 1,
      aux_sym_template_argument_list_repeat1,
  [344281] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15578), 1,
      anon_sym_RPAREN,
    ACTIONS(15580), 1,
      anon_sym_COLON,
    STATE(9663), 1,
      sym_gnu_asm_input_operand_list,
  [344294] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15531), 1,
      anon_sym_COLON,
    ACTIONS(15582), 1,
      anon_sym_RPAREN,
    STATE(9664), 1,
      sym_gnu_asm_output_operand_list,
  [344307] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15584), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [344320] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15586), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [344333] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10022), 1,
      anon_sym_RBRACE,
    ACTIONS(10344), 1,
      anon_sym_COMMA,
    STATE(10239), 1,
      aux_sym_initializer_list_repeat1,
  [344346] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10400), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [344359] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15045), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [344372] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15588), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [344385] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15590), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [344398] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15592), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [344411] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(15594), 1,
      anon_sym_SEMI,
    STATE(11046), 1,
      sym_attribute_declaration,
  [344424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15556), 1,
      anon_sym_catch,
    STATE(1638), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [344435] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15596), 1,
      anon_sym_COMMA,
    ACTIONS(15598), 1,
      anon_sym_RPAREN,
    STATE(9742), 1,
      aux_sym_parameter_list_repeat1,
  [344448] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10217), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [344461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15600), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [344474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15602), 1,
      anon_sym_EQ,
    ACTIONS(14053), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [344485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15604), 1,
      anon_sym_catch,
    STATE(1815), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [344496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15606), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [344509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    ACTIONS(15610), 1,
      anon_sym_constexpr,
    STATE(1258), 1,
      sym_condition_clause,
  [344522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15612), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [344535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15576), 1,
      anon_sym_COLON,
    ACTIONS(15614), 1,
      anon_sym_RPAREN,
    STATE(9673), 1,
      sym_gnu_asm_clobber_list,
  [344548] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15580), 1,
      anon_sym_COLON,
    ACTIONS(15616), 1,
      anon_sym_RPAREN,
    STATE(9674), 1,
      sym_gnu_asm_input_operand_list,
  [344561] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14910), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [344574] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15053), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [344587] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15618), 1,
      anon_sym_GT2,
    STATE(9676), 1,
      aux_sym_template_argument_list_repeat1,
  [344600] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15618), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [344613] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15620), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [344626] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15622), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [344639] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15624), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [344652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15612), 1,
      anon_sym_GT2,
    STATE(9754), 1,
      aux_sym_template_argument_list_repeat1,
  [344665] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15572), 1,
      anon_sym_COLON,
    ACTIONS(15626), 1,
      anon_sym_RPAREN,
    STATE(11362), 1,
      sym_gnu_asm_goto_list,
  [344678] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15576), 1,
      anon_sym_COLON,
    ACTIONS(15628), 1,
      anon_sym_RPAREN,
    STATE(9678), 1,
      sym_gnu_asm_clobber_list,
  [344691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10239), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [344704] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15630), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [344717] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15630), 1,
      anon_sym_GT2,
    STATE(9681), 1,
      aux_sym_template_argument_list_repeat1,
  [344730] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15572), 1,
      anon_sym_COLON,
    ACTIONS(15632), 1,
      anon_sym_RPAREN,
    STATE(11405), 1,
      sym_gnu_asm_goto_list,
  [344743] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10243), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [344756] = 4,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15634), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(15636), 1,
      anon_sym_LPAREN2,
    STATE(11497), 1,
      sym_preproc_argument_list,
  [344769] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15638), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [344782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10095), 1,
      anon_sym_COMMA,
    ACTIONS(15640), 1,
      anon_sym_RPAREN,
    STATE(10123), 1,
      aux_sym_generic_expression_repeat1,
  [344795] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5773), 1,
      anon_sym_LBRACE,
    ACTIONS(14932), 1,
      anon_sym_COLON_COLON,
    STATE(546), 1,
      sym_declaration_list,
  [344808] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15642), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [344821] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15644), 1,
      anon_sym_GT2,
    STATE(9691), 1,
      aux_sym_template_argument_list_repeat1,
  [344834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10145), 3,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
  [344843] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15646), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [344856] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15648), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [344869] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10181), 1,
      anon_sym_COMMA,
    ACTIONS(15650), 1,
      anon_sym_RPAREN,
    STATE(10304), 1,
      aux_sym_argument_list_repeat1,
  [344882] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14938), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [344895] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15652), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [344908] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15523), 1,
      anon_sym_COMMA,
    ACTIONS(15654), 1,
      anon_sym_RBRACK,
    STATE(9616), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [344921] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5777), 1,
      anon_sym_LBRACE,
    ACTIONS(14932), 1,
      anon_sym_COLON_COLON,
    STATE(1029), 1,
      sym_declaration_list,
  [344934] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6057), 1,
      anon_sym_RBRACE,
    ACTIONS(15656), 1,
      anon_sym_COMMA,
    STATE(9706), 1,
      aux_sym_initializer_list_repeat1,
  [344947] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15580), 1,
      anon_sym_COLON,
    ACTIONS(15658), 1,
      anon_sym_RPAREN,
    STATE(10038), 1,
      sym_gnu_asm_input_operand_list,
  [344960] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15531), 1,
      anon_sym_COLON,
    ACTIONS(15660), 1,
      anon_sym_RPAREN,
    STATE(10045), 1,
      sym_gnu_asm_output_operand_list,
  [344973] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15519), 1,
      anon_sym_COMMA,
    ACTIONS(15662), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(9792), 1,
      aux_sym_attribute_declaration_repeat1,
  [344986] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15664), 1,
      anon_sym_SEMI,
    STATE(10102), 1,
      aux_sym_declaration_repeat1,
  [344999] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14880), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345012] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15666), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15580), 1,
      anon_sym_COLON,
    ACTIONS(15668), 1,
      anon_sym_RPAREN,
    STATE(9810), 1,
      sym_gnu_asm_input_operand_list,
  [345038] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15519), 1,
      anon_sym_COMMA,
    ACTIONS(15670), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(9731), 1,
      aux_sym_attribute_declaration_repeat1,
  [345051] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15672), 1,
      anon_sym_GT2,
    STATE(9708), 1,
      aux_sym_template_argument_list_repeat1,
  [345064] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15672), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345077] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15531), 1,
      anon_sym_COLON,
    ACTIONS(15674), 1,
      anon_sym_RPAREN,
    STATE(9811), 1,
      sym_gnu_asm_output_operand_list,
  [345090] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10147), 1,
      anon_sym_RBRACE,
    ACTIONS(15676), 1,
      anon_sym_COMMA,
    STATE(9706), 1,
      aux_sym_initializer_list_repeat1,
  [345103] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10404), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345116] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15679), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345129] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15679), 1,
      anon_sym_GT2,
    STATE(9718), 1,
      aux_sym_template_argument_list_repeat1,
  [345142] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15681), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15556), 1,
      anon_sym_catch,
    STATE(1646), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [345166] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15085), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345179] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10406), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345192] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15683), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345205] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10095), 1,
      anon_sym_COMMA,
    ACTIONS(15685), 1,
      anon_sym_RPAREN,
    STATE(10123), 1,
      aux_sym_generic_expression_repeat1,
  [345218] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15093), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345231] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15687), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345244] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15689), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345257] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15691), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345270] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15693), 1,
      anon_sym_SEMI,
    STATE(9747), 1,
      aux_sym_declaration_repeat1,
  [345283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15695), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [345292] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15697), 1,
      sym_identifier,
    STATE(2724), 1,
      sym_template_type,
    STATE(3617), 1,
      sym_template_function,
  [345305] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15699), 1,
      sym_identifier,
    STATE(2724), 1,
      sym_template_type,
    STATE(3617), 1,
      sym_template_function,
  [345318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15701), 1,
      anon_sym_COMMA,
    ACTIONS(15704), 1,
      anon_sym_RPAREN,
    STATE(9724), 1,
      aux_sym_requires_parameter_list_repeat1,
  [345331] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15706), 1,
      anon_sym_GT2,
    STATE(9737), 1,
      aux_sym_template_argument_list_repeat1,
  [345344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15708), 1,
      anon_sym_catch,
    STATE(608), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [345355] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15576), 1,
      anon_sym_COLON,
    ACTIONS(15710), 1,
      anon_sym_RPAREN,
    STATE(9640), 1,
      sym_gnu_asm_clobber_list,
  [345368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(15712), 1,
      anon_sym_SEMI,
    STATE(11220), 1,
      sym_attribute_declaration,
  [345381] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15714), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345394] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14914), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345407] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15519), 1,
      anon_sym_COMMA,
    ACTIONS(15716), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(10176), 1,
      aux_sym_attribute_declaration_repeat1,
  [345420] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10181), 1,
      anon_sym_COMMA,
    ACTIONS(10251), 1,
      anon_sym_RPAREN,
    STATE(9762), 1,
      aux_sym_argument_list_repeat1,
  [345433] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15572), 1,
      anon_sym_COLON,
    ACTIONS(15718), 1,
      anon_sym_RPAREN,
    STATE(11551), 1,
      sym_gnu_asm_goto_list,
  [345446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14942), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345459] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(15720), 1,
      anon_sym_SEMI,
    STATE(11171), 1,
      sym_attribute_declaration,
  [345472] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10223), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345485] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15722), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345498] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15572), 1,
      anon_sym_COLON,
    ACTIONS(15724), 1,
      anon_sym_RPAREN,
    STATE(11144), 1,
      sym_gnu_asm_goto_list,
  [345511] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15726), 1,
      anon_sym_GT2,
    STATE(9804), 1,
      aux_sym_template_argument_list_repeat1,
  [345524] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14946), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345537] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15531), 1,
      anon_sym_COLON,
    ACTIONS(15728), 1,
      anon_sym_RPAREN,
    STATE(9765), 1,
      sym_gnu_asm_output_operand_list,
  [345550] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15596), 1,
      anon_sym_COMMA,
    ACTIONS(15730), 1,
      anon_sym_RPAREN,
    STATE(9825), 1,
      aux_sym_parameter_list_repeat1,
  [345563] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15732), 1,
      anon_sym_GT2,
    STATE(9772), 1,
      aux_sym_template_argument_list_repeat1,
  [345576] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15576), 1,
      anon_sym_COLON,
    ACTIONS(15734), 1,
      anon_sym_RPAREN,
    STATE(10143), 1,
      sym_gnu_asm_clobber_list,
  [345589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15604), 1,
      anon_sym_catch,
    STATE(1817), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [345600] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15736), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [345613] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15738), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [345626] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15740), 1,
      anon_sym_SEMI,
    STATE(9871), 1,
      aux_sym_declaration_repeat1,
  [345639] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15742), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [345652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15744), 1,
      anon_sym_GT2,
    STATE(9770), 1,
      aux_sym_template_argument_list_repeat1,
  [345665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15746), 1,
      anon_sym_catch,
    STATE(1818), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [345676] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10191), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345689] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(15748), 1,
      anon_sym_SEMI,
    STATE(11178), 1,
      sym_attribute_declaration,
  [345702] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15750), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345715] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15744), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345728] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15752), 1,
      sym_identifier,
    ACTIONS(15754), 1,
      anon_sym_using,
    STATE(10305), 1,
      sym_attribute,
  [345741] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    ACTIONS(15756), 1,
      anon_sym_constexpr,
    STATE(1221), 1,
      sym_condition_clause,
  [345754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15760), 1,
      anon_sym_EQ,
    ACTIONS(15758), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [345765] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    STATE(9599), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(15762), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [345776] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15580), 1,
      anon_sym_COLON,
    ACTIONS(15764), 1,
      anon_sym_RPAREN,
    STATE(9641), 1,
      sym_gnu_asm_input_operand_list,
  [345789] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15766), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [345802] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10181), 1,
      anon_sym_COMMA,
    ACTIONS(15768), 1,
      anon_sym_RPAREN,
    STATE(10304), 1,
      aux_sym_argument_list_repeat1,
  [345815] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15770), 1,
      sym_identifier,
    STATE(3013), 1,
      sym_template_type,
    STATE(4321), 1,
      sym_template_function,
  [345828] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    ACTIONS(15772), 1,
      anon_sym_constexpr,
    STATE(1213), 1,
      sym_condition_clause,
  [345841] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15580), 1,
      anon_sym_COLON,
    ACTIONS(15774), 1,
      anon_sym_RPAREN,
    STATE(9783), 1,
      sym_gnu_asm_input_operand_list,
  [345854] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15531), 1,
      anon_sym_COLON,
    ACTIONS(15776), 1,
      anon_sym_RPAREN,
    STATE(9785), 1,
      sym_gnu_asm_output_operand_list,
  [345867] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15778), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10410), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345893] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15780), 1,
      anon_sym_default,
    ACTIONS(15782), 1,
      anon_sym_delete,
    ACTIONS(15784), 1,
      aux_sym_pure_virtual_clause_token1,
  [345906] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15786), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15125), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345932] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15788), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [345945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    ACTIONS(15790), 1,
      anon_sym_constexpr,
    STATE(1232), 1,
      sym_condition_clause,
  [345958] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15792), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [345971] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15786), 1,
      anon_sym_GT2,
    STATE(9782), 1,
      aux_sym_template_argument_list_repeat1,
  [345984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15746), 1,
      anon_sym_catch,
    STATE(1819), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [345995] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10095), 1,
      anon_sym_COMMA,
    ACTIONS(15794), 1,
      anon_sym_RPAREN,
    STATE(10123), 1,
      aux_sym_generic_expression_repeat1,
  [346008] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10412), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346021] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15796), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346034] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15796), 1,
      anon_sym_GT2,
    STATE(10173), 1,
      aux_sym_template_argument_list_repeat1,
  [346047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15798), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [346056] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15800), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346069] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15576), 1,
      anon_sym_COLON,
    ACTIONS(15802), 1,
      anon_sym_RPAREN,
    STATE(9795), 1,
      sym_gnu_asm_clobber_list,
  [346082] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15804), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346095] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15580), 1,
      anon_sym_COLON,
    ACTIONS(15806), 1,
      anon_sym_RPAREN,
    STATE(9797), 1,
      sym_gnu_asm_input_operand_list,
  [346108] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15726), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346121] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15133), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346134] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15808), 1,
      anon_sym_GT2,
    STATE(9802), 1,
      aux_sym_template_argument_list_repeat1,
  [346147] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15808), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346160] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15810), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [346173] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15812), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [346186] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15519), 1,
      anon_sym_COMMA,
    ACTIONS(15814), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(10176), 1,
      aux_sym_attribute_declaration_repeat1,
  [346199] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(15816), 1,
      anon_sym_LBRACE,
    STATE(11573), 1,
      sym_trailing_return_type,
  [346212] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10181), 1,
      anon_sym_COMMA,
    ACTIONS(10346), 1,
      anon_sym_RPAREN,
    STATE(9912), 1,
      aux_sym_argument_list_repeat1,
  [346225] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15572), 1,
      anon_sym_COLON,
    ACTIONS(15818), 1,
      anon_sym_RPAREN,
    STATE(11616), 1,
      sym_gnu_asm_goto_list,
  [346238] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10181), 1,
      anon_sym_COMMA,
    ACTIONS(15820), 1,
      anon_sym_RPAREN,
    STATE(10304), 1,
      aux_sym_argument_list_repeat1,
  [346251] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15576), 1,
      anon_sym_COLON,
    ACTIONS(15822), 1,
      anon_sym_RPAREN,
    STATE(9806), 1,
      sym_gnu_asm_clobber_list,
  [346264] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10384), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346277] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5779), 1,
      anon_sym_LBRACE,
    ACTIONS(14932), 1,
      anon_sym_COLON_COLON,
    STATE(1059), 1,
      sym_declaration_list,
  [346290] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15824), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346303] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10261), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346316] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15826), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346329] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15826), 1,
      anon_sym_GT2,
    STATE(9808), 1,
      aux_sym_template_argument_list_repeat1,
  [346342] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15828), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346355] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10348), 1,
      anon_sym_COMMA,
    ACTIONS(10350), 1,
      anon_sym_RBRACE,
    STATE(9917), 1,
      aux_sym_initializer_list_repeat1,
  [346368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15572), 1,
      anon_sym_COLON,
    ACTIONS(15830), 1,
      anon_sym_RPAREN,
    STATE(11630), 1,
      sym_gnu_asm_goto_list,
  [346381] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10263), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346394] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15832), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346407] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15834), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346420] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15576), 1,
      anon_sym_COLON,
    ACTIONS(15836), 1,
      anon_sym_RPAREN,
    STATE(9826), 1,
      sym_gnu_asm_clobber_list,
  [346433] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15580), 1,
      anon_sym_COLON,
    ACTIONS(15838), 1,
      anon_sym_RPAREN,
    STATE(9827), 1,
      sym_gnu_asm_input_operand_list,
  [346446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7156), 1,
      anon_sym_EQ,
    ACTIONS(7154), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [346457] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15840), 1,
      anon_sym_GT2,
    STATE(9834), 1,
      aux_sym_template_argument_list_repeat1,
  [346470] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14957), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346483] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15141), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15842), 1,
      anon_sym_GT2,
    STATE(9829), 1,
      aux_sym_template_argument_list_repeat1,
  [346509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15842), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15844), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [346531] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15844), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [346540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15846), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [346553] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15848), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [346566] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10181), 1,
      anon_sym_COMMA,
    ACTIONS(15850), 1,
      anon_sym_RPAREN,
    STATE(10304), 1,
      aux_sym_argument_list_repeat1,
  [346579] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15852), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346592] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15828), 1,
      anon_sym_GT2,
    STATE(9886), 1,
      aux_sym_template_argument_list_repeat1,
  [346605] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15854), 1,
      anon_sym_COMMA,
    ACTIONS(15857), 1,
      anon_sym_RPAREN,
    STATE(9825), 1,
      aux_sym_parameter_list_repeat1,
  [346618] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15572), 1,
      anon_sym_COLON,
    ACTIONS(15859), 1,
      anon_sym_RPAREN,
    STATE(10872), 1,
      sym_gnu_asm_goto_list,
  [346631] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15576), 1,
      anon_sym_COLON,
    ACTIONS(15861), 1,
      anon_sym_RPAREN,
    STATE(9837), 1,
      sym_gnu_asm_clobber_list,
  [346644] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10093), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346657] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15863), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346670] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15863), 1,
      anon_sym_GT2,
    STATE(9840), 1,
      aux_sym_template_argument_list_repeat1,
  [346683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15865), 1,
      sym_identifier,
    ACTIONS(15867), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [346694] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14961), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346707] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(15869), 1,
      anon_sym_SEMI,
    STATE(11219), 1,
      sym_trailing_return_type,
  [346720] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15871), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346733] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3238), 1,
      anon_sym_while,
    ACTIONS(15873), 1,
      anon_sym_else,
    STATE(422), 1,
      sym_else_clause,
  [346746] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5773), 1,
      anon_sym_LBRACE,
    ACTIONS(14932), 1,
      anon_sym_COLON_COLON,
    STATE(604), 1,
      sym_declaration_list,
  [346759] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15572), 1,
      anon_sym_COLON,
    ACTIONS(15875), 1,
      anon_sym_RPAREN,
    STATE(10893), 1,
      sym_gnu_asm_goto_list,
  [346772] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15519), 1,
      anon_sym_COMMA,
    ACTIONS(15877), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(9861), 1,
      aux_sym_attribute_declaration_repeat1,
  [346785] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10104), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346798] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15879), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10386), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14965), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346837] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15881), 1,
      anon_sym_GT2,
    STATE(9862), 1,
      aux_sym_template_argument_list_repeat1,
  [346850] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10095), 1,
      anon_sym_COMMA,
    ACTIONS(15883), 1,
      anon_sym_RPAREN,
    STATE(10123), 1,
      aux_sym_generic_expression_repeat1,
  [346863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15746), 1,
      anon_sym_catch,
    STATE(1821), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [346874] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15885), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346887] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15531), 1,
      anon_sym_COLON,
    ACTIONS(15887), 1,
      anon_sym_RPAREN,
    STATE(9931), 1,
      sym_gnu_asm_output_operand_list,
  [346900] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15881), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [346913] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15889), 1,
      anon_sym_SEMI,
    STATE(9877), 1,
      aux_sym_declaration_repeat1,
  [346926] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15891), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [346939] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_RBRACE,
    ACTIONS(15893), 1,
      anon_sym_COMMA,
    STATE(9706), 1,
      aux_sym_initializer_list_repeat1,
  [346952] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15895), 1,
      anon_sym_COMMA,
    ACTIONS(15897), 1,
      anon_sym_LBRACE,
    STATE(10043), 1,
      aux_sym_field_initializer_list_repeat1,
  [346965] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15899), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
    STATE(8063), 1,
      sym_template_function,
  [346978] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15901), 1,
      sym_identifier,
    STATE(2724), 1,
      sym_template_type,
    STATE(4655), 1,
      sym_template_function,
  [346991] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15752), 1,
      sym_identifier,
    ACTIONS(15754), 1,
      anon_sym_using,
    STATE(10083), 1,
      sym_attribute,
  [347004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15752), 1,
      sym_identifier,
    ACTIONS(15754), 1,
      anon_sym_using,
    STATE(10204), 1,
      sym_attribute,
  [347017] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15903), 1,
      anon_sym_GT2,
    STATE(9938), 1,
      aux_sym_template_argument_list_repeat1,
  [347030] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    ACTIONS(15905), 1,
      anon_sym_constexpr,
    STATE(1260), 1,
      sym_condition_clause,
  [347043] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10416), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [347056] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    STATE(9320), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(15907), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [347067] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15519), 1,
      anon_sym_COMMA,
    ACTIONS(15909), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(10176), 1,
      aux_sym_attribute_declaration_repeat1,
  [347080] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15911), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [347093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15913), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [347102] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15915), 1,
      anon_sym_COMMA,
    ACTIONS(15918), 1,
      anon_sym_RPAREN,
    STATE(9864), 1,
      aux_sym_throw_specifier_repeat1,
  [347115] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15920), 1,
      anon_sym_default,
    ACTIONS(15922), 1,
      anon_sym_delete,
    ACTIONS(15924), 1,
      aux_sym_pure_virtual_clause_token1,
  [347128] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15911), 1,
      anon_sym_GT2,
    STATE(9891), 1,
      aux_sym_template_argument_list_repeat1,
  [347141] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15926), 1,
      anon_sym_GT2,
    STATE(9888), 1,
      aux_sym_template_argument_list_repeat1,
  [347154] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    ACTIONS(15928), 1,
      anon_sym_constexpr,
    STATE(1248), 1,
      sym_condition_clause,
  [347167] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15930), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [347180] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11478), 1,
      anon_sym_requires,
    ACTIONS(15932), 1,
      anon_sym_LBRACE,
    STATE(11290), 1,
      sym_requires_clause,
  [347193] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15934), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [347206] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15936), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [347219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15913), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [347228] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10418), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [347241] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15596), 1,
      anon_sym_COMMA,
    ACTIONS(15938), 1,
      anon_sym_RPAREN,
    STATE(9943), 1,
      aux_sym_parameter_list_repeat1,
  [347254] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15940), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [347267] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15942), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [347280] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15944), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [347293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13922), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [347302] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15946), 1,
      anon_sym_COMMA,
    ACTIONS(15948), 1,
      anon_sym_GT2,
    STATE(9624), 1,
      aux_sym_template_parameter_list_repeat1,
  [347315] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(15950), 1,
      anon_sym_SEMI,
    STATE(11594), 1,
      sym_base_class_clause,
  [347328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15708), 1,
      anon_sym_catch,
    STATE(636), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [347339] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10106), 1,
      anon_sym_COMMA,
    ACTIONS(10441), 1,
      anon_sym_RBRACK,
    STATE(9952), 1,
      aux_sym_subscript_argument_list_repeat1,
  [347352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15954), 1,
      anon_sym_COLON_COLON,
    ACTIONS(15952), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [347363] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15956), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [347376] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15958), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [347389] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10378), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [347402] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15960), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [347415] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11478), 1,
      anon_sym_requires,
    ACTIONS(14014), 1,
      anon_sym_LBRACE,
    STATE(11292), 1,
      sym_requires_clause,
  [347428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15531), 1,
      anon_sym_COLON,
    ACTIONS(15962), 1,
      anon_sym_RPAREN,
    STATE(9910), 1,
      sym_gnu_asm_output_operand_list,
  [347441] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15964), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [347454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15163), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [347467] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15966), 1,
      anon_sym_GT2,
    STATE(9898), 1,
      aux_sym_template_argument_list_repeat1,
  [347480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15966), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [347493] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15968), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [347506] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(15970), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [347519] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10275), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [347532] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15972), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [347545] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15972), 1,
      anon_sym_GT2,
    STATE(9901), 1,
      aux_sym_template_argument_list_repeat1,
  [347558] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10277), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [347571] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15974), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [347584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15752), 1,
      sym_identifier,
    ACTIONS(15754), 1,
      anon_sym_using,
    STATE(10031), 1,
      sym_attribute,
  [347597] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    STATE(9501), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(15976), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [347608] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15978), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [347621] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15980), 1,
      anon_sym_default,
    ACTIONS(15982), 1,
      anon_sym_delete,
    ACTIONS(15984), 1,
      aux_sym_pure_virtual_clause_token1,
  [347634] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15986), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [347647] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15988), 1,
      anon_sym_GT2,
    STATE(9924), 1,
      aux_sym_template_argument_list_repeat1,
  [347660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15990), 1,
      anon_sym_catch,
    STATE(633), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [347671] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15992), 1,
      anon_sym_COMMA,
    ACTIONS(15994), 1,
      anon_sym_RPAREN,
    STATE(10175), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [347684] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15580), 1,
      anon_sym_COLON,
    ACTIONS(15996), 1,
      anon_sym_RPAREN,
    STATE(9727), 1,
      sym_gnu_asm_input_operand_list,
  [347697] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15998), 1,
      anon_sym_COMMA,
    ACTIONS(16000), 1,
      anon_sym_RPAREN,
    STATE(9724), 1,
      aux_sym_requires_parameter_list_repeat1,
  [347710] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10181), 1,
      anon_sym_COMMA,
    ACTIONS(16002), 1,
      anon_sym_RPAREN,
    STATE(10304), 1,
      aux_sym_argument_list_repeat1,
  [347723] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16004), 1,
      anon_sym_GT2,
    STATE(9934), 1,
      aux_sym_template_argument_list_repeat1,
  [347736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16006), 1,
      anon_sym_GT2,
    STATE(9662), 1,
      aux_sym_template_argument_list_repeat1,
  [347749] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5779), 1,
      anon_sym_LBRACE,
    ACTIONS(14932), 1,
      anon_sym_COLON_COLON,
    STATE(931), 1,
      sym_declaration_list,
  [347762] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    STATE(9454), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(16008), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [347773] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6039), 1,
      anon_sym_RBRACE,
    ACTIONS(16010), 1,
      anon_sym_COMMA,
    STATE(9706), 1,
      aux_sym_initializer_list_repeat1,
  [347786] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15531), 1,
      anon_sym_COLON,
    ACTIONS(16012), 1,
      anon_sym_RPAREN,
    STATE(9760), 1,
      sym_gnu_asm_output_operand_list,
  [347799] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(16014), 1,
      anon_sym_SEMI,
    STATE(11576), 1,
      sym_base_class_clause,
  [347812] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16016), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [347825] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16018), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [347838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16020), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [347847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15171), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [347860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16022), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [347873] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16024), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [347886] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14975), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [347899] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_while,
    ACTIONS(15873), 1,
      anon_sym_else,
    STATE(460), 1,
      sym_else_clause,
  [347912] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15752), 1,
      sym_identifier,
    ACTIONS(15754), 1,
      anon_sym_using,
    STATE(10233), 1,
      sym_attribute,
  [347925] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    STATE(9368), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(16026), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [347936] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16028), 1,
      anon_sym_COMMA,
    ACTIONS(16031), 1,
      anon_sym_LBRACE,
    STATE(9930), 1,
      aux_sym_field_initializer_list_repeat1,
  [347949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15580), 1,
      anon_sym_COLON,
    ACTIONS(16033), 1,
      anon_sym_RPAREN,
    STATE(9985), 1,
      sym_gnu_asm_input_operand_list,
  [347962] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15531), 1,
      anon_sym_COLON,
    ACTIONS(16035), 1,
      anon_sym_RPAREN,
    STATE(9989), 1,
      sym_gnu_asm_output_operand_list,
  [347975] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16037), 1,
      anon_sym_default,
    ACTIONS(16039), 1,
      anon_sym_delete,
    ACTIONS(16041), 1,
      aux_sym_pure_virtual_clause_token1,
  [347988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16043), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348001] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16045), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348014] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14979), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15183), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348040] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16047), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348053] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15519), 1,
      anon_sym_COMMA,
    ACTIONS(16049), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(9955), 1,
      aux_sym_attribute_declaration_repeat1,
  [348066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16051), 1,
      anon_sym_GT2,
    STATE(9947), 1,
      aux_sym_template_argument_list_repeat1,
  [348079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16053), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
    STATE(3617), 1,
      sym_template_function,
  [348092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16051), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348105] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15596), 1,
      anon_sym_COMMA,
    ACTIONS(16055), 1,
      anon_sym_RPAREN,
    STATE(9825), 1,
      aux_sym_parameter_list_repeat1,
  [348118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10181), 1,
      anon_sym_COMMA,
    ACTIONS(10394), 1,
      anon_sym_RPAREN,
    STATE(9796), 1,
      aux_sym_argument_list_repeat1,
  [348131] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10422), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348144] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10609), 1,
      anon_sym_RBRACK,
    ACTIONS(16057), 1,
      anon_sym_COMMA,
    STATE(9946), 1,
      aux_sym_subscript_argument_list_repeat1,
  [348157] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16060), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15708), 1,
      anon_sym_catch,
    STATE(638), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [348181] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(16062), 1,
      anon_sym_SEMI,
    STATE(9966), 1,
      aux_sym_declaration_repeat1,
  [348194] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16060), 1,
      anon_sym_GT2,
    STATE(9958), 1,
      aux_sym_template_argument_list_repeat1,
  [348207] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16064), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
    STATE(4655), 1,
      sym_template_function,
  [348220] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10106), 1,
      anon_sym_COMMA,
    ACTIONS(16066), 1,
      anon_sym_RBRACK,
    STATE(9946), 1,
      aux_sym_subscript_argument_list_repeat1,
  [348233] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15752), 1,
      sym_identifier,
    ACTIONS(15754), 1,
      anon_sym_using,
    STATE(9702), 1,
      sym_attribute,
  [348246] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    STATE(9405), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(16068), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [348257] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15519), 1,
      anon_sym_COMMA,
    ACTIONS(16070), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(10176), 1,
      aux_sym_attribute_declaration_repeat1,
  [348270] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16072), 1,
      anon_sym_default,
    ACTIONS(16074), 1,
      anon_sym_delete,
    ACTIONS(16076), 1,
      aux_sym_pure_virtual_clause_token1,
  [348283] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10424), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16078), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348309] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16080), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11911), 1,
      anon_sym_COMMA,
    ACTIONS(16082), 1,
      anon_sym_RPAREN,
    STATE(10070), 1,
      aux_sym_preproc_argument_list_repeat1,
  [348335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(16084), 1,
      anon_sym_SEMI,
    STATE(9651), 1,
      aux_sym_declaration_repeat1,
  [348348] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16086), 1,
      anon_sym_GT2,
    STATE(9977), 1,
      aux_sym_template_argument_list_repeat1,
  [348361] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14749), 1,
      anon_sym_DOT,
    ACTIONS(16088), 1,
      anon_sym_SEMI,
    STATE(9248), 1,
      aux_sym_module_name_repeat1,
  [348374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16090), 1,
      anon_sym_COMMA,
    ACTIONS(16092), 1,
      anon_sym_RPAREN,
    STATE(9864), 1,
      aux_sym_throw_specifier_repeat1,
  [348387] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(16094), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [348400] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(16096), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [348413] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(16098), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [348426] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11478), 1,
      anon_sym_requires,
    ACTIONS(13955), 1,
      anon_sym_LBRACE,
    STATE(10994), 1,
      sym_requires_clause,
  [348439] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16100), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348452] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16006), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348465] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16102), 1,
      anon_sym_GT2,
    STATE(9990), 1,
      aux_sym_template_argument_list_repeat1,
  [348478] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15752), 1,
      sym_identifier,
    ACTIONS(15754), 1,
      anon_sym_using,
    STATE(9838), 1,
      sym_attribute,
  [348491] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    STATE(9441), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(16104), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [348502] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16106), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348515] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16108), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348528] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15207), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348541] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16110), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348554] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16112), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
    STATE(3464), 1,
      sym_template_function,
  [348567] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11478), 1,
      anon_sym_requires,
    ACTIONS(13957), 1,
      anon_sym_LBRACE,
    STATE(11092), 1,
      sym_requires_clause,
  [348580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14987), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348593] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15217), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348606] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16114), 1,
      anon_sym_GT2,
    STATE(9999), 1,
      aux_sym_template_argument_list_repeat1,
  [348619] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16114), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348632] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(16116), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [348645] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15576), 1,
      anon_sym_COLON,
    ACTIONS(16118), 1,
      anon_sym_RPAREN,
    STATE(10331), 1,
      sym_gnu_asm_clobber_list,
  [348658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(16120), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [348671] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15752), 1,
      sym_identifier,
    ACTIONS(15754), 1,
      anon_sym_using,
    STATE(9939), 1,
      sym_attribute,
  [348684] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    STATE(9465), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(16122), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [348695] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15580), 1,
      anon_sym_COLON,
    ACTIONS(16124), 1,
      anon_sym_RPAREN,
    STATE(10016), 1,
      sym_gnu_asm_input_operand_list,
  [348708] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16126), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348721] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16128), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
    STATE(3617), 1,
      sym_template_function,
  [348734] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15221), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348747] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16130), 1,
      anon_sym_GT2,
    STATE(10018), 1,
      aux_sym_template_argument_list_repeat1,
  [348760] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16130), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348773] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16132), 1,
      anon_sym_COMMA,
    ACTIONS(16135), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [348786] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(16137), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [348799] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(16139), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [348812] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10294), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348825] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16141), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16141), 1,
      anon_sym_GT2,
    STATE(10004), 1,
      aux_sym_template_argument_list_repeat1,
  [348851] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10296), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15227), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [348873] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    STATE(9491), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(16143), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [348884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16145), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348897] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16147), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15596), 1,
      anon_sym_COMMA,
    ACTIONS(16149), 1,
      anon_sym_RPAREN,
    STATE(10014), 1,
      aux_sym_parameter_list_repeat1,
  [348923] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14991), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348936] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15531), 1,
      anon_sym_COLON,
    ACTIONS(16151), 1,
      anon_sym_RPAREN,
    STATE(9695), 1,
      sym_gnu_asm_output_operand_list,
  [348949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16153), 1,
      anon_sym_GT2,
    STATE(10025), 1,
      aux_sym_template_argument_list_repeat1,
  [348962] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    STATE(9510), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(16155), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [348973] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16153), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [348986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15990), 1,
      anon_sym_catch,
    STATE(258), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [348997] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    STATE(9524), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(16157), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [349008] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15596), 1,
      anon_sym_COMMA,
    ACTIONS(16159), 1,
      anon_sym_RPAREN,
    STATE(9825), 1,
      aux_sym_parameter_list_repeat1,
  [349021] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16161), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [349034] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15576), 1,
      anon_sym_COLON,
    ACTIONS(16163), 1,
      anon_sym_RPAREN,
    STATE(10026), 1,
      sym_gnu_asm_clobber_list,
  [349047] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10163), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [349060] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16165), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [349073] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16165), 1,
      anon_sym_GT2,
    STATE(10028), 1,
      aux_sym_template_argument_list_repeat1,
  [349086] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    ACTIONS(16167), 1,
      anon_sym_constexpr,
    STATE(1207), 1,
      sym_condition_clause,
  [349099] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15596), 1,
      anon_sym_COMMA,
    ACTIONS(16169), 1,
      anon_sym_RPAREN,
    STATE(9825), 1,
      aux_sym_parameter_list_repeat1,
  [349112] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10437), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [349125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16171), 3,
      anon_sym_RBRACE,
      anon_sym_get,
      anon_sym_set,
  [349134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16173), 3,
      anon_sym_RBRACE,
      anon_sym_get,
      anon_sym_set,
  [349143] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16175), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [349156] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15572), 1,
      anon_sym_COLON,
    ACTIONS(16177), 1,
      anon_sym_RPAREN,
    STATE(10858), 1,
      sym_gnu_asm_goto_list,
  [349169] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10225), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [349182] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16179), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [349195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16175), 1,
      anon_sym_GT2,
    STATE(10036), 1,
      aux_sym_template_argument_list_repeat1,
  [349208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10439), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [349221] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15519), 1,
      anon_sym_COMMA,
    ACTIONS(16181), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(10103), 1,
      aux_sym_attribute_declaration_repeat1,
  [349234] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10095), 1,
      anon_sym_COMMA,
    ACTIONS(16183), 1,
      anon_sym_RPAREN,
    STATE(10123), 1,
      aux_sym_generic_expression_repeat1,
  [349247] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16185), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [349260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16187), 1,
      anon_sym_catch,
    STATE(300), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [349271] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10106), 1,
      anon_sym_COMMA,
    ACTIONS(16189), 1,
      anon_sym_RBRACK,
    STATE(9946), 1,
      aux_sym_subscript_argument_list_repeat1,
  [349284] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16191), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [349297] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16193), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [349310] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15576), 1,
      anon_sym_COLON,
    ACTIONS(16195), 1,
      anon_sym_RPAREN,
    STATE(9738), 1,
      sym_gnu_asm_clobber_list,
  [349323] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16197), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
    STATE(4321), 1,
      sym_template_function,
  [349336] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16199), 1,
      anon_sym_GT2,
    STATE(9714), 1,
      aux_sym_template_argument_list_repeat1,
  [349349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16201), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16203), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [349360] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14749), 1,
      anon_sym_DOT,
    ACTIONS(15318), 1,
      anon_sym_SEMI,
    STATE(9963), 1,
      aux_sym_module_name_repeat1,
  [349373] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15895), 1,
      anon_sym_COMMA,
    ACTIONS(16205), 1,
      anon_sym_LBRACE,
    STATE(9930), 1,
      aux_sym_field_initializer_list_repeat1,
  [349386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16207), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16209), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [349397] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15580), 1,
      anon_sym_COLON,
    ACTIONS(16211), 1,
      anon_sym_RPAREN,
    STATE(9744), 1,
      sym_gnu_asm_input_operand_list,
  [349410] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16213), 1,
      anon_sym_GT2,
    STATE(10053), 1,
      aux_sym_template_argument_list_repeat1,
  [349423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16215), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [349432] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16217), 1,
      anon_sym_COMMA,
    ACTIONS(16220), 1,
      anon_sym_RBRACK,
    STATE(10048), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [349445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    ACTIONS(16222), 1,
      anon_sym_constexpr,
    STATE(1230), 1,
      sym_condition_clause,
  [349458] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16224), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [349471] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(16226), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [349484] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15268), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [349497] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16228), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [349510] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(16230), 1,
      anon_sym_SEMI,
    STATE(11095), 1,
      sym_attribute_declaration,
  [349523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15990), 1,
      anon_sym_catch,
    STATE(635), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [349534] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15272), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [349547] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(16232), 1,
      anon_sym_SEMI,
    STATE(11097), 1,
      sym_attribute_declaration,
  [349560] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(16234), 1,
      anon_sym_SEMI,
    STATE(11101), 1,
      sym_attribute_declaration,
  [349573] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16236), 1,
      anon_sym_GT2,
    STATE(10063), 1,
      aux_sym_template_argument_list_repeat1,
  [349586] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15752), 1,
      sym_identifier,
    ACTIONS(15754), 1,
      anon_sym_using,
    STATE(9697), 1,
      sym_attribute,
  [349599] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16236), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [349612] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10300), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [349625] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16238), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [349638] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    ACTIONS(16240), 1,
      anon_sym_constexpr,
    STATE(1233), 1,
      sym_condition_clause,
  [349651] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16238), 1,
      anon_sym_GT2,
    STATE(10067), 1,
      aux_sym_template_argument_list_repeat1,
  [349664] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10302), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [349677] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16242), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [349690] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10106), 1,
      anon_sym_COMMA,
    ACTIONS(16244), 1,
      anon_sym_RBRACK,
    STATE(9946), 1,
      aux_sym_subscript_argument_list_repeat1,
  [349703] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16246), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [349716] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12062), 1,
      anon_sym_RPAREN,
    ACTIONS(16248), 1,
      anon_sym_COMMA,
    STATE(10070), 1,
      aux_sym_preproc_argument_list_repeat1,
  [349729] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3094), 1,
      anon_sym_while,
    ACTIONS(15873), 1,
      anon_sym_else,
    STATE(475), 1,
      sym_else_clause,
  [349742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15604), 1,
      anon_sym_catch,
    STATE(1828), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [349753] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16251), 1,
      anon_sym_COMMA,
    ACTIONS(16254), 1,
      anon_sym_RPAREN,
    STATE(10073), 1,
      aux_sym_preproc_params_repeat1,
  [349766] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    ACTIONS(16258), 1,
      anon_sym_RPAREN,
    STATE(10237), 1,
      aux_sym_preproc_params_repeat1,
  [349779] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    STATE(9408), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(16260), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [349790] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15284), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [349803] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(16262), 1,
      anon_sym_SEMI,
    STATE(10151), 1,
      aux_sym_declaration_repeat1,
  [349816] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(16264), 1,
      anon_sym_SEMI,
    STATE(11280), 1,
      sym_attribute_declaration,
  [349829] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16266), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
    STATE(3617), 1,
      sym_template_function,
  [349842] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16268), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
    STATE(3617), 1,
      sym_template_function,
  [349855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16270), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [349864] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(16272), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [349877] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15519), 1,
      anon_sym_COMMA,
    ACTIONS(16274), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(10247), 1,
      aux_sym_attribute_declaration_repeat1,
  [349890] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16276), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
    STATE(3617), 1,
      sym_template_function,
  [349903] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16278), 1,
      anon_sym_GT2,
    STATE(10096), 1,
      aux_sym_template_argument_list_repeat1,
  [349916] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16280), 1,
      anon_sym_COMMA,
    ACTIONS(16283), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [349929] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16090), 1,
      anon_sym_COMMA,
    ACTIONS(16285), 1,
      anon_sym_RPAREN,
    STATE(9964), 1,
      aux_sym_throw_specifier_repeat1,
  [349942] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(16287), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [349955] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16289), 1,
      anon_sym_GT2,
    STATE(9779), 1,
      aux_sym_template_argument_list_repeat1,
  [349968] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11478), 1,
      anon_sym_requires,
    ACTIONS(13993), 1,
      anon_sym_LBRACE,
    STATE(11541), 1,
      sym_requires_clause,
  [349981] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16291), 1,
      anon_sym_GT2,
    STATE(10114), 1,
      aux_sym_template_argument_list_repeat1,
  [349994] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16293), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350007] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16295), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16297), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [350029] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15312), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350042] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16299), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350055] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11478), 1,
      anon_sym_requires,
    ACTIONS(13255), 1,
      anon_sym_LBRACE,
    STATE(11612), 1,
      sym_requires_clause,
  [350068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8049), 1,
      anon_sym___attribute,
    ACTIONS(8051), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [350079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15316), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16301), 1,
      anon_sym_GT2,
    STATE(10106), 1,
      aux_sym_template_argument_list_repeat1,
  [350105] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16301), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(16303), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [350131] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15519), 1,
      anon_sym_COMMA,
    ACTIONS(16305), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(10176), 1,
      aux_sym_attribute_declaration_repeat1,
  [350144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7915), 1,
      anon_sym___attribute,
    ACTIONS(7917), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [350155] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10308), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350168] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16307), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350181] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16307), 1,
      anon_sym_GT2,
    STATE(10110), 1,
      aux_sym_template_argument_list_repeat1,
  [350194] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10310), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350207] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11911), 1,
      anon_sym_COMMA,
    ACTIONS(16309), 1,
      anon_sym_RPAREN,
    STATE(10070), 1,
      aux_sym_preproc_argument_list_repeat1,
  [350220] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16311), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350233] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16313), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350246] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10181), 1,
      anon_sym_COMMA,
    ACTIONS(10183), 1,
      anon_sym_RPAREN,
    STATE(10186), 1,
      aux_sym_argument_list_repeat1,
  [350259] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14918), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350272] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16315), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15004), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [350294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16317), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [350303] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10185), 1,
      anon_sym_COMMA,
    ACTIONS(10187), 1,
      anon_sym_RBRACE,
    STATE(10201), 1,
      aux_sym_initializer_list_repeat1,
  [350316] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15523), 1,
      anon_sym_COMMA,
    ACTIONS(16319), 1,
      anon_sym_RBRACK,
    STATE(10316), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [350329] = 4,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15636), 1,
      anon_sym_LPAREN2,
    ACTIONS(16321), 1,
      aux_sym_preproc_include_token2,
    STATE(11497), 1,
      sym_preproc_argument_list,
  [350342] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16323), 1,
      sym_identifier,
    STATE(3013), 1,
      sym_template_type,
    STATE(4655), 1,
      sym_template_function,
  [350355] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(16325), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [350368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16327), 1,
      anon_sym_COMMA,
    ACTIONS(16330), 1,
      anon_sym_RBRACK,
    STATE(10122), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [350381] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16332), 1,
      anon_sym_COMMA,
    ACTIONS(16335), 1,
      anon_sym_RPAREN,
    STATE(10123), 1,
      aux_sym_generic_expression_repeat1,
  [350394] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16337), 1,
      anon_sym_GT2,
    STATE(9670), 1,
      aux_sym_template_argument_list_repeat1,
  [350407] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16339), 1,
      anon_sym_GT2,
    STATE(10128), 1,
      aux_sym_template_argument_list_repeat1,
  [350420] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16341), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350433] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15351), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16343), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350459] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15531), 1,
      anon_sym_COLON,
    ACTIONS(16345), 1,
      anon_sym_RPAREN,
    STATE(10207), 1,
      sym_gnu_asm_output_operand_list,
  [350472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16347), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [350481] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15355), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350494] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16349), 1,
      anon_sym_GT2,
    STATE(10135), 1,
      aux_sym_template_argument_list_repeat1,
  [350507] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16349), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350520] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10318), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350533] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16351), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350546] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16351), 1,
      anon_sym_GT2,
    STATE(10138), 1,
      aux_sym_template_argument_list_repeat1,
  [350559] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10320), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350572] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16353), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16355), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350598] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16357), 1,
      anon_sym_GT2,
    STATE(10215), 1,
      aux_sym_template_argument_list_repeat1,
  [350611] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    ACTIONS(16359), 1,
      anon_sym_constexpr,
    STATE(1231), 1,
      sym_condition_clause,
  [350624] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16289), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350637] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15572), 1,
      anon_sym_COLON,
    ACTIONS(16361), 1,
      anon_sym_RPAREN,
    STATE(11110), 1,
      sym_gnu_asm_goto_list,
  [350650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16363), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [350659] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(14922), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13810), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [350681] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10265), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350694] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(16365), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [350707] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16367), 1,
      anon_sym_GT2,
    STATE(10218), 1,
      aux_sym_template_argument_list_repeat1,
  [350720] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16369), 1,
      sym_identifier,
    STATE(3013), 1,
      sym_template_type,
    STATE(3464), 1,
      sym_template_function,
  [350733] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(16371), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [350746] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3779), 1,
      anon_sym_LT,
    ACTIONS(7785), 1,
      anon_sym_SEMI,
    STATE(2999), 1,
      sym_template_argument_list,
  [350759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16375), 1,
      anon_sym_EQ,
    ACTIONS(16373), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [350770] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(16377), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [350783] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16379), 1,
      anon_sym_GT2,
    STATE(10159), 1,
      aux_sym_template_argument_list_repeat1,
  [350796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16381), 1,
      anon_sym_catch,
    STATE(639), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [350807] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16383), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350820] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15371), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350833] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16385), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15519), 1,
      anon_sym_COMMA,
    ACTIONS(16387), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(10176), 1,
      aux_sym_attribute_declaration_repeat1,
  [350859] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10106), 1,
      anon_sym_COMMA,
    ACTIONS(10132), 1,
      anon_sym_RBRACK,
    STATE(10035), 1,
      aux_sym_subscript_argument_list_repeat1,
  [350872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15375), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350885] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16389), 1,
      anon_sym_GT2,
    STATE(10167), 1,
      aux_sym_template_argument_list_repeat1,
  [350898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16389), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350911] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16391), 1,
      anon_sym_default,
    ACTIONS(16393), 1,
      anon_sym_delete,
    ACTIONS(16395), 1,
      aux_sym_pure_virtual_clause_token1,
  [350924] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10324), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350937] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16397), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350950] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16397), 1,
      anon_sym_GT2,
    STATE(10170), 1,
      aux_sym_template_argument_list_repeat1,
  [350963] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10326), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350976] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16399), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [350989] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16401), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351002] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10106), 1,
      anon_sym_COMMA,
    ACTIONS(10245), 1,
      anon_sym_RBRACK,
    STATE(10068), 1,
      aux_sym_subscript_argument_list_repeat1,
  [351015] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16403), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351028] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16367), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351041] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15992), 1,
      anon_sym_COMMA,
    ACTIONS(16405), 1,
      anon_sym_RPAREN,
    STATE(10182), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [351054] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16407), 1,
      anon_sym_COMMA,
    ACTIONS(16410), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(10176), 1,
      aux_sym_attribute_declaration_repeat1,
  [351067] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5781), 1,
      anon_sym_LBRACE,
    ACTIONS(14932), 1,
      anon_sym_COLON_COLON,
    STATE(1003), 1,
      sym_declaration_list,
  [351080] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16412), 1,
      sym_identifier,
    STATE(2724), 1,
      sym_template_type,
    STATE(3617), 1,
      sym_template_function,
  [351093] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15596), 1,
      anon_sym_COMMA,
    ACTIONS(16414), 1,
      anon_sym_RPAREN,
    STATE(10021), 1,
      aux_sym_parameter_list_repeat1,
  [351106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7072), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [351115] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10390), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351128] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16416), 1,
      anon_sym_COMMA,
    ACTIONS(16419), 1,
      anon_sym_RPAREN,
    STATE(10182), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [351141] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10181), 1,
      anon_sym_COMMA,
    ACTIONS(10304), 1,
      anon_sym_RPAREN,
    STATE(9822), 1,
      aux_sym_argument_list_repeat1,
  [351154] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16421), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
    STATE(3617), 1,
      sym_template_function,
  [351167] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16423), 1,
      anon_sym_GT2,
    STATE(10191), 1,
      aux_sym_template_argument_list_repeat1,
  [351180] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10181), 1,
      anon_sym_COMMA,
    ACTIONS(16425), 1,
      anon_sym_RPAREN,
    STATE(10304), 1,
      aux_sym_argument_list_repeat1,
  [351193] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    ACTIONS(16427), 1,
      anon_sym_constexpr,
    STATE(1224), 1,
      sym_condition_clause,
  [351206] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16429), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351219] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(16431), 1,
      anon_sym_SEMI,
    STATE(9687), 1,
      aux_sym_declaration_repeat1,
  [351232] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15395), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351245] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16433), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16435), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [351267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym___attribute,
    ACTIONS(7887), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [351278] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15399), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351291] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16437), 1,
      anon_sym_GT2,
    STATE(10198), 1,
      aux_sym_template_argument_list_repeat1,
  [351304] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16437), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351317] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10091), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351330] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16439), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351343] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16439), 1,
      anon_sym_GT2,
    STATE(10202), 1,
      aux_sym_template_argument_list_repeat1,
  [351356] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10336), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351369] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6037), 1,
      anon_sym_RBRACE,
    ACTIONS(16441), 1,
      anon_sym_COMMA,
    STATE(9706), 1,
      aux_sym_initializer_list_repeat1,
  [351382] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16443), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351395] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16445), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351408] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15519), 1,
      anon_sym_COMMA,
    ACTIONS(16447), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(10292), 1,
      aux_sym_attribute_declaration_repeat1,
  [351421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7893), 1,
      anon_sym___attribute,
    ACTIONS(7895), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [351432] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11478), 1,
      anon_sym_requires,
    ACTIONS(16449), 1,
      anon_sym_LBRACE,
    STATE(11368), 1,
      sym_requires_clause,
  [351445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15580), 1,
      anon_sym_COLON,
    ACTIONS(16451), 1,
      anon_sym_RPAREN,
    STATE(10248), 1,
      sym_gnu_asm_input_operand_list,
  [351458] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15531), 1,
      anon_sym_COLON,
    ACTIONS(16453), 1,
      anon_sym_RPAREN,
    STATE(10253), 1,
      sym_gnu_asm_output_operand_list,
  [351471] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16455), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [351480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15946), 1,
      anon_sym_COMMA,
    ACTIONS(16457), 1,
      anon_sym_GT2,
    STATE(9880), 1,
      aux_sym_template_parameter_list_repeat1,
  [351493] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16459), 1,
      sym_identifier,
    STATE(2724), 1,
      sym_template_type,
    STATE(3464), 1,
      sym_template_function,
  [351506] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16461), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351519] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(16463), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [351532] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15411), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351545] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16465), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16467), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [351567] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16469), 1,
      anon_sym_GT2,
    STATE(10222), 1,
      aux_sym_template_argument_list_repeat1,
  [351580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16471), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351593] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16473), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351606] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7525), 1,
      anon_sym_COMMA,
    ACTIONS(16475), 1,
      anon_sym_RBRACK,
    STATE(9611), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [351619] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15417), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351632] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16477), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351645] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15421), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16479), 1,
      anon_sym_GT2,
    STATE(10227), 1,
      aux_sym_template_argument_list_repeat1,
  [351671] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16479), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351684] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10340), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351697] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16481), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351710] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16481), 1,
      anon_sym_GT2,
    STATE(10234), 1,
      aux_sym_template_argument_list_repeat1,
  [351723] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10342), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11911), 1,
      anon_sym_COMMA,
    ACTIONS(16483), 1,
      anon_sym_RPAREN,
    STATE(10070), 1,
      aux_sym_preproc_argument_list_repeat1,
  [351749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16381), 1,
      anon_sym_catch,
    STATE(640), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [351760] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16471), 1,
      anon_sym_GT2,
    STATE(10249), 1,
      aux_sym_template_argument_list_repeat1,
  [351773] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15519), 1,
      anon_sym_COMMA,
    ACTIONS(16485), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(9613), 1,
      aux_sym_attribute_declaration_repeat1,
  [351786] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16487), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351799] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16489), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351812] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10392), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351825] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16256), 1,
      anon_sym_COMMA,
    ACTIONS(16491), 1,
      anon_sym_RPAREN,
    STATE(10073), 1,
      aux_sym_preproc_params_repeat1,
  [351838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13810), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [351847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_RBRACE,
    ACTIONS(16493), 1,
      anon_sym_COMMA,
    STATE(9706), 1,
      aux_sym_initializer_list_repeat1,
  [351860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16495), 1,
      sym_identifier,
    STATE(4772), 1,
      sym_template_function,
    STATE(5291), 1,
      sym_template_type,
  [351873] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16497), 1,
      anon_sym_GT2,
    STATE(10246), 1,
      aux_sym_template_argument_list_repeat1,
  [351886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7860), 1,
      anon_sym___attribute,
    ACTIONS(7862), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [351897] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16499), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8061), 1,
      anon_sym___attribute,
    ACTIONS(8063), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [351921] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15441), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351934] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16501), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351947] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15519), 1,
      anon_sym_COMMA,
    ACTIONS(16503), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(10176), 1,
      aux_sym_attribute_declaration_repeat1,
  [351960] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15576), 1,
      anon_sym_COLON,
    ACTIONS(16505), 1,
      anon_sym_RPAREN,
    STATE(10278), 1,
      sym_gnu_asm_clobber_list,
  [351973] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16507), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351986] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15447), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [351999] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16509), 1,
      anon_sym_GT2,
    STATE(10256), 1,
      aux_sym_template_argument_list_repeat1,
  [352012] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16509), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15580), 1,
      anon_sym_COLON,
    ACTIONS(16511), 1,
      anon_sym_RPAREN,
    STATE(10279), 1,
      sym_gnu_asm_input_operand_list,
  [352038] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16513), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352051] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10356), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352064] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16515), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352077] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16515), 1,
      anon_sym_GT2,
    STATE(10261), 1,
      aux_sym_template_argument_list_repeat1,
  [352090] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10360), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352103] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15453), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16381), 1,
      anon_sym_catch,
    STATE(630), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [352127] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16517), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352140] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16519), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352153] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16521), 1,
      anon_sym_GT2,
    STATE(10287), 1,
      aux_sym_template_argument_list_repeat1,
  [352166] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7927), 1,
      anon_sym___attribute,
    ACTIONS(7929), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [352177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7931), 1,
      anon_sym___attribute,
    ACTIONS(7933), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [352188] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16521), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352201] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(16523), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [352214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14932), 3,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
  [352223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7856), 1,
      anon_sym___attribute,
    ACTIONS(7858), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [352234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15954), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16525), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [352245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16529), 1,
      anon_sym_RPAREN,
    ACTIONS(16527), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [352256] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(16531), 1,
      anon_sym_SEMI,
    STATE(9995), 1,
      aux_sym_declaration_repeat1,
  [352269] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16533), 1,
      sym_identifier,
    STATE(2724), 1,
      sym_template_type,
    STATE(3617), 1,
      sym_template_function,
  [352282] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16535), 3,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
  [352291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15483), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [352300] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16537), 1,
      anon_sym_GT2,
    STATE(10285), 1,
      aux_sym_template_argument_list_repeat1,
  [352313] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    ACTIONS(16539), 1,
      anon_sym_constexpr,
    STATE(1202), 1,
      sym_condition_clause,
  [352326] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15572), 1,
      anon_sym_COLON,
    ACTIONS(16541), 1,
      anon_sym_RPAREN,
    STATE(11618), 1,
      sym_gnu_asm_goto_list,
  [352339] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15576), 1,
      anon_sym_COLON,
    ACTIONS(16543), 1,
      anon_sym_RPAREN,
    STATE(10309), 1,
      sym_gnu_asm_clobber_list,
  [352352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16187), 1,
      anon_sym_catch,
    STATE(285), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [352363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16545), 1,
      anon_sym_catch,
    STATE(1316), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [352374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16547), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7983), 1,
      anon_sym___attribute,
    ACTIONS(7985), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [352398] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15471), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352411] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16549), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352424] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10205), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352437] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16551), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352450] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15475), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352463] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16553), 1,
      anon_sym_GT2,
    STATE(10296), 1,
      aux_sym_template_argument_list_repeat1,
  [352476] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16553), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352489] = 4,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15636), 1,
      anon_sym_LPAREN2,
    ACTIONS(16555), 1,
      aux_sym_preproc_include_token2,
    STATE(11497), 1,
      sym_preproc_argument_list,
  [352502] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15519), 1,
      anon_sym_COMMA,
    ACTIONS(16557), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(10176), 1,
      aux_sym_attribute_declaration_repeat1,
  [352515] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16551), 1,
      anon_sym_GT2,
    STATE(10313), 1,
      aux_sym_template_argument_list_repeat1,
  [352528] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16559), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
    STATE(4772), 1,
      sym_template_function,
  [352541] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10370), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352554] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16561), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352567] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16561), 1,
      anon_sym_GT2,
    STATE(10299), 1,
      aux_sym_template_argument_list_repeat1,
  [352580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10372), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352593] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16563), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352606] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    ACTIONS(16565), 1,
      anon_sym_SEMI,
    STATE(9629), 1,
      aux_sym_declaration_repeat1,
  [352619] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10181), 1,
      anon_sym_COMMA,
    ACTIONS(10362), 1,
      anon_sym_RPAREN,
    STATE(9689), 1,
      aux_sym_argument_list_repeat1,
  [352632] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16567), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352645] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(16569), 1,
      anon_sym_SEMI,
    STATE(10023), 1,
      sym_compound_statement,
  [352658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10589), 1,
      anon_sym_RPAREN,
    ACTIONS(16571), 1,
      anon_sym_COMMA,
    STATE(10304), 1,
      aux_sym_argument_list_repeat1,
  [352671] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15519), 1,
      anon_sym_COMMA,
    ACTIONS(16574), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(10160), 1,
      aux_sym_attribute_declaration_repeat1,
  [352684] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15998), 1,
      anon_sym_COMMA,
    ACTIONS(16576), 1,
      anon_sym_RPAREN,
    STATE(9911), 1,
      aux_sym_requires_parameter_list_repeat1,
  [352697] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(16578), 1,
      anon_sym_SEMI,
    STATE(10024), 1,
      sym_compound_statement,
  [352710] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16580), 1,
      sym_identifier,
    STATE(402), 1,
      sym_template_type,
    STATE(3617), 1,
      sym_template_function,
  [352723] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15572), 1,
      anon_sym_COLON,
    ACTIONS(16582), 1,
      anon_sym_RPAREN,
    STATE(11638), 1,
      sym_gnu_asm_goto_list,
  [352736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16584), 1,
      anon_sym_GT2,
    STATE(10318), 1,
      aux_sym_template_argument_list_repeat1,
  [352749] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10209), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352762] = 4,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15636), 1,
      anon_sym_LPAREN2,
    ACTIONS(16586), 1,
      aux_sym_preproc_include_token2,
    STATE(11497), 1,
      sym_preproc_argument_list,
  [352775] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16588), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352788] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10095), 1,
      anon_sym_COMMA,
    ACTIONS(16590), 1,
      anon_sym_RPAREN,
    STATE(10123), 1,
      aux_sym_generic_expression_repeat1,
  [352801] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16592), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352814] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15523), 1,
      anon_sym_COMMA,
    ACTIONS(16594), 1,
      anon_sym_RBRACK,
    STATE(10122), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [352827] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15497), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352840] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16596), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352853] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16598), 1,
      sym_identifier,
    STATE(2724), 1,
      sym_template_type,
    STATE(3617), 1,
      sym_template_function,
  [352866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(16600), 1,
      anon_sym_LBRACE,
    STATE(11162), 1,
      sym_trailing_return_type,
  [352879] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16602), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352892] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15752), 1,
      sym_identifier,
    ACTIONS(15754), 1,
      anon_sym_using,
    STATE(10521), 1,
      sym_attribute,
  [352905] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(15505), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16604), 1,
      anon_sym_GT2,
    STATE(10330), 1,
      aux_sym_template_argument_list_repeat1,
  [352931] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16606), 1,
      anon_sym_GT2,
    STATE(9605), 1,
      aux_sym_template_argument_list_repeat1,
  [352944] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16604), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16187), 1,
      anon_sym_catch,
    STATE(257), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [352968] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(10376), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [352981] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16608), 1,
      anon_sym_GT2,
    STATE(9608), 1,
      aux_sym_template_argument_list_repeat1,
  [352994] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10055), 1,
      anon_sym_COMMA,
    ACTIONS(16606), 1,
      anon_sym_GT2,
    STATE(10086), 1,
      aux_sym_template_argument_list_repeat1,
  [353007] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15572), 1,
      anon_sym_COLON,
    ACTIONS(16610), 1,
      anon_sym_RPAREN,
    STATE(10844), 1,
      sym_gnu_asm_goto_list,
  [353020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16612), 1,
      anon_sym_LPAREN2,
    ACTIONS(16614), 1,
      sym_raw_string_delimiter,
  [353030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(9365), 1,
      sym_compound_statement,
  [353040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
    ACTIONS(16618), 1,
      anon_sym_RBRACE,
  [353050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
    ACTIONS(16620), 1,
      anon_sym_RBRACE,
  [353060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9311), 1,
      anon_sym_LBRACE,
    STATE(5173), 1,
      sym_field_declaration_list,
  [353070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11323), 1,
      anon_sym_LBRACE,
    STATE(6968), 1,
      sym_compound_statement,
  [353080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12821), 1,
      anon_sym_LBRACE,
    STATE(1649), 1,
      sym_compound_statement,
  [353090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9460), 1,
      anon_sym_LT,
    STATE(2953), 1,
      sym_template_argument_list,
  [353100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(917), 1,
      anon_sym_LBRACE,
    STATE(827), 1,
      sym_compound_statement,
  [353110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(3191), 1,
      sym_field_declaration_list,
  [353120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(996), 1,
      sym_compound_statement,
  [353130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15952), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [353138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    STATE(10749), 1,
      sym_parameter_list,
  [353148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12711), 1,
      anon_sym_LBRACE,
    STATE(1967), 1,
      sym_compound_statement,
  [353158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13275), 1,
      anon_sym_RBRACE,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
  [353168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11270), 1,
      anon_sym_LBRACE,
    STATE(5182), 1,
      sym_compound_statement,
  [353178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11268), 1,
      anon_sym_LBRACE,
    STATE(7189), 1,
      sym_compound_statement,
  [353188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16622), 1,
      anon_sym_LPAREN2,
    STATE(11158), 1,
      sym_parenthesized_expression,
  [353198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    STATE(10320), 1,
      sym_parameter_list,
  [353208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    STATE(2830), 1,
      sym_field_declaration_list,
  [353218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10505), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [353226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11266), 1,
      anon_sym_LBRACE,
    STATE(4577), 1,
      sym_compound_statement,
  [353236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    STATE(10359), 1,
      sym_condition_clause,
  [353246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11252), 1,
      anon_sym_LBRACE,
    STATE(1681), 1,
      sym_compound_statement,
  [353256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    STATE(1213), 1,
      sym_condition_clause,
  [353266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    STATE(10500), 1,
      sym_parameter_list,
  [353276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    STATE(1255), 1,
      sym_condition_clause,
  [353286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(917), 1,
      anon_sym_LBRACE,
    STATE(858), 1,
      sym_compound_statement,
  [353296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(917), 1,
      anon_sym_LBRACE,
    STATE(919), 1,
      sym_compound_statement,
  [353306] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(16624), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(16626), 1,
      sym_preproc_arg,
  [353316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16254), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [353324] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(16628), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(16630), 1,
      sym_preproc_arg,
  [353334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(10012), 1,
      sym_compound_statement,
  [353344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16632), 1,
      anon_sym_LT,
    STATE(3330), 1,
      sym_template_argument_list,
  [353354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    STATE(1235), 1,
      sym_condition_clause,
  [353364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      anon_sym_LBRACE,
    STATE(378), 1,
      sym_compound_statement,
  [353374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16632), 1,
      anon_sym_LT,
    STATE(3105), 1,
      sym_template_argument_list,
  [353384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11623), 1,
      anon_sym_LBRACE,
    STATE(4833), 1,
      sym_requirement_seq,
  [353394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    STATE(701), 1,
      sym_field_declaration_list,
  [353404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    STATE(5621), 1,
      sym_field_declaration_list,
  [353414] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(16634), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(16636), 1,
      sym_preproc_arg,
  [353424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1093), 1,
      anon_sym_LBRACE,
    STATE(932), 1,
      sym_compound_statement,
  [353434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(9726), 1,
      sym_compound_statement,
  [353444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16638), 1,
      sym_identifier,
    STATE(3492), 1,
      sym_template_type,
  [353454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    STATE(379), 1,
      sym_field_declaration_list,
  [353464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11245), 1,
      anon_sym_LBRACE,
    STATE(4933), 1,
      sym_compound_statement,
  [353474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(10034), 1,
      sym_compound_statement,
  [353484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15061), 1,
      sym_identifier,
    STATE(10386), 1,
      sym_module_name,
  [353494] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(16640), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(16642), 1,
      sym_preproc_arg,
  [353504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16644), 1,
      anon_sym_LT,
    STATE(3515), 1,
      sym_template_argument_list,
  [353514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    STATE(380), 1,
      sym_field_declaration_list,
  [353524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7812), 1,
      anon_sym_LBRACE,
    STATE(3632), 1,
      sym_field_declaration_list,
  [353534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    STATE(10779), 1,
      sym_condition_clause,
  [353544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7724), 1,
      anon_sym_LBRACE,
    STATE(3605), 1,
      sym_field_declaration_list,
  [353554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16646), 2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [353562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(10072), 1,
      sym_compound_statement,
  [353572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(1665), 1,
      sym_compound_statement,
  [353582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    STATE(1242), 1,
      sym_condition_clause,
  [353592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6744), 1,
      anon_sym_LT,
    STATE(2688), 1,
      sym_template_argument_list,
  [353602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13191), 1,
      anon_sym_RBRACE,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
  [353612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16648), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
  [353622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7812), 1,
      anon_sym_LBRACE,
    STATE(3635), 1,
      sym_field_declaration_list,
  [353632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7812), 1,
      anon_sym_LBRACE,
    STATE(3636), 1,
      sym_field_declaration_list,
  [353642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16650), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [353650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10102), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [353658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    STATE(1225), 1,
      sym_condition_clause,
  [353668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(11038), 1,
      sym_argument_list,
  [353678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(9518), 1,
      sym_compound_statement,
  [353688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(1676), 1,
      sym_compound_statement,
  [353698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16652), 1,
      anon_sym_if,
    ACTIONS(16654), 1,
      anon_sym_for,
  [353708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11277), 1,
      anon_sym_LBRACE,
    STATE(4033), 1,
      sym_compound_statement,
  [353718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6288), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [353726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5479), 1,
      anon_sym_LBRACE,
    STATE(6082), 1,
      sym_initializer_list,
  [353736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
    ACTIONS(16656), 1,
      anon_sym_RBRACE,
  [353746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7812), 1,
      anon_sym_LBRACE,
    STATE(3638), 1,
      sym_field_declaration_list,
  [353756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11277), 1,
      anon_sym_LBRACE,
    STATE(4267), 1,
      sym_compound_statement,
  [353766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7724), 1,
      anon_sym_LBRACE,
    STATE(3611), 1,
      sym_field_declaration_list,
  [353776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      anon_sym_LBRACE,
    STATE(591), 1,
      sym_compound_statement,
  [353786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13319), 1,
      anon_sym_RBRACE,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
  [353796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16658), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [353804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11585), 1,
      anon_sym_LBRACE,
    STATE(5113), 1,
      sym_requirement_seq,
  [353814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(1681), 1,
      sym_compound_statement,
  [353824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16622), 1,
      anon_sym_LPAREN2,
    STATE(11297), 1,
      sym_parenthesized_expression,
  [353834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    STATE(10561), 1,
      sym_parameter_list,
  [353844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    STATE(10586), 1,
      sym_parameter_list,
  [353854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16031), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [353862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(10055), 1,
      sym_compound_statement,
  [353872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16660), 1,
      anon_sym_if,
    ACTIONS(16662), 1,
      anon_sym_for,
  [353882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5024), 1,
      anon_sym_LBRACE,
    STATE(1397), 1,
      sym_field_declaration_list,
  [353892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16622), 1,
      anon_sym_LPAREN2,
    STATE(10615), 1,
      sym_parenthesized_expression,
  [353902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(10231), 1,
      sym_compound_statement,
  [353912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16622), 1,
      anon_sym_LPAREN2,
    STATE(11266), 1,
      sym_parenthesized_expression,
  [353922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    STATE(830), 1,
      sym_field_declaration_list,
  [353932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    STATE(9622), 1,
      sym_parameter_list,
  [353942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(827), 1,
      sym_compound_statement,
  [353952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16622), 1,
      anon_sym_LPAREN2,
    STATE(10625), 1,
      sym_parenthesized_expression,
  [353962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5781), 1,
      anon_sym_LBRACE,
    STATE(1052), 1,
      sym_declaration_list,
  [353972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    STATE(829), 1,
      sym_field_declaration_list,
  [353982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13205), 1,
      anon_sym_RBRACE,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
  [353992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    STATE(830), 1,
      sym_field_declaration_list,
  [354002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15654), 1,
      anon_sym_RBRACK,
    ACTIONS(16664), 1,
      anon_sym_COMMA,
  [354012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_LBRACE,
    STATE(717), 1,
      sym_field_declaration_list,
  [354022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(11499), 1,
      sym_argument_list,
  [354032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5779), 1,
      anon_sym_LBRACE,
    STATE(933), 1,
      sym_declaration_list,
  [354042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16666), 1,
      sym_identifier,
    STATE(3679), 1,
      sym_template_type,
  [354052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    STATE(686), 1,
      sym_field_declaration_list,
  [354062] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    STATE(381), 1,
      sym_field_declaration_list,
  [354072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
    ACTIONS(16668), 1,
      anon_sym_RBRACE,
  [354082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13203), 1,
      anon_sym_RBRACE,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
  [354092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_LBRACE,
    STATE(4526), 1,
      sym_initializer_list,
  [354102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16330), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [354110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8550), 1,
      anon_sym_LBRACE,
    STATE(4908), 1,
      sym_field_declaration_list,
  [354120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(9431), 1,
      sym_compound_statement,
  [354130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    STATE(1224), 1,
      sym_condition_clause,
  [354140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5266), 1,
      anon_sym_LBRACE,
    STATE(4728), 1,
      sym_initializer_list,
  [354150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12821), 1,
      anon_sym_LBRACE,
    STATE(1794), 1,
      sym_compound_statement,
  [354160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16670), 1,
      anon_sym_LT,
    STATE(3595), 1,
      sym_template_argument_list,
  [354170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15288), 1,
      anon_sym_LBRACE,
    STATE(1662), 1,
      sym_requirement_seq,
  [354180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16672), 1,
      anon_sym_if,
    ACTIONS(16674), 1,
      anon_sym_for,
  [354190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13213), 1,
      anon_sym_RBRACE,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
  [354200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1093), 1,
      anon_sym_LBRACE,
    STATE(674), 1,
      sym_compound_statement,
  [354210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8550), 1,
      anon_sym_LBRACE,
    STATE(4911), 1,
      sym_field_declaration_list,
  [354220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8550), 1,
      anon_sym_LBRACE,
    STATE(4912), 1,
      sym_field_declaration_list,
  [354230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16676), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [354238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    STATE(833), 1,
      sym_field_declaration_list,
  [354248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14932), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16678), 1,
      anon_sym_SEMI,
  [354258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7256), 1,
      anon_sym_LBRACE,
    STATE(3164), 1,
      sym_field_declaration_list,
  [354268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7256), 1,
      anon_sym_LBRACE,
    STATE(3147), 1,
      sym_field_declaration_list,
  [354278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
    ACTIONS(16680), 1,
      anon_sym_RBRACE,
  [354288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8550), 1,
      anon_sym_LBRACE,
    STATE(4914), 1,
      sym_field_declaration_list,
  [354298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12711), 1,
      anon_sym_LBRACE,
    STATE(2242), 1,
      sym_compound_statement,
  [354308] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(16682), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(16684), 1,
      sym_preproc_arg,
  [354318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5779), 1,
      anon_sym_LBRACE,
    STATE(1107), 1,
      sym_declaration_list,
  [354328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(3171), 1,
      sym_field_declaration_list,
  [354338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    STATE(5618), 1,
      sym_field_declaration_list,
  [354348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11252), 1,
      anon_sym_LBRACE,
    STATE(1665), 1,
      sym_compound_statement,
  [354358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    STATE(829), 1,
      sym_field_declaration_list,
  [354368] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(16686), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(16688), 1,
      sym_preproc_arg,
  [354378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(10281), 1,
      sym_compound_statement,
  [354388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16690), 1,
      sym_identifier,
    STATE(3499), 1,
      sym_template_type,
  [354398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(11142), 1,
      sym_argument_list,
  [354408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16692), 1,
      sym_identifier,
    STATE(5006), 1,
      sym_template_type,
  [354418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16694), 1,
      anon_sym_if,
    ACTIONS(16696), 1,
      anon_sym_for,
  [354428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2966), 1,
      anon_sym_LT,
    STATE(403), 1,
      sym_template_argument_list,
  [354438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16698), 1,
      sym_identifier,
    ACTIONS(16700), 1,
      anon_sym_RPAREN,
  [354448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13317), 1,
      anon_sym_RBRACE,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
  [354458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11321), 1,
      anon_sym_LBRACE,
    STATE(1665), 1,
      sym_compound_statement,
  [354468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    STATE(5619), 1,
      sym_field_declaration_list,
  [354478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2046), 1,
      anon_sym_LBRACE,
    STATE(1351), 1,
      sym_compound_statement,
  [354488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11321), 1,
      anon_sym_LBRACE,
    STATE(1676), 1,
      sym_compound_statement,
  [354498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      anon_sym_LBRACE,
    STATE(532), 1,
      sym_compound_statement,
  [354508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11321), 1,
      anon_sym_LBRACE,
    STATE(1681), 1,
      sym_compound_statement,
  [354518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    STATE(498), 1,
      sym_field_declaration_list,
  [354528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16702), 1,
      sym_identifier,
    STATE(525), 1,
      sym_template_type,
  [354538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16704), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [354546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    STATE(1211), 1,
      sym_condition_clause,
  [354556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    STATE(10480), 1,
      sym_parameter_list,
  [354566] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(16706), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(16708), 1,
      sym_preproc_arg,
  [354576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(917), 1,
      anon_sym_LBRACE,
    STATE(695), 1,
      sym_compound_statement,
  [354586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8217), 1,
      anon_sym_LT,
    STATE(3685), 1,
      sym_template_argument_list,
  [354596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(9654), 1,
      sym_compound_statement,
  [354606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14932), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16710), 1,
      anon_sym_SEMI,
  [354616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16622), 1,
      anon_sym_LPAREN2,
    STATE(10645), 1,
      sym_parenthesized_expression,
  [354626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16712), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [354634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11631), 1,
      anon_sym_LBRACE,
    STATE(3436), 1,
      sym_requirement_seq,
  [354644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16714), 1,
      sym_identifier,
    STATE(2724), 1,
      sym_template_type,
  [354654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16716), 1,
      sym_identifier,
    STATE(5291), 1,
      sym_template_type,
  [354664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11239), 1,
      anon_sym_LBRACE,
    STATE(4681), 1,
      sym_compound_statement,
  [354674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      anon_sym_LBRACE,
    STATE(333), 1,
      sym_compound_statement,
  [354684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    STATE(647), 1,
      sym_field_declaration_list,
  [354694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16718), 1,
      sym_identifier,
    STATE(402), 1,
      sym_template_type,
  [354704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16720), 1,
      sym_identifier,
    ACTIONS(16722), 1,
      anon_sym_LPAREN2,
  [354714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10609), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [354722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16724), 1,
      anon_sym_LT,
    STATE(3352), 1,
      sym_template_argument_list,
  [354732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12821), 1,
      anon_sym_LBRACE,
    STATE(1702), 1,
      sym_compound_statement,
  [354742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8076), 1,
      anon_sym_LBRACE,
    STATE(3756), 1,
      sym_field_declaration_list,
  [354752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5024), 1,
      anon_sym_LBRACE,
    STATE(1371), 1,
      sym_field_declaration_list,
  [354762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11270), 1,
      anon_sym_LBRACE,
    STATE(5157), 1,
      sym_compound_statement,
  [354772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11272), 1,
      anon_sym_LBRACE,
    STATE(3455), 1,
      sym_compound_statement,
  [354782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13343), 1,
      anon_sym_RBRACE,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
  [354792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5779), 1,
      anon_sym_LBRACE,
    STATE(1120), 1,
      sym_declaration_list,
  [354802] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15189), 1,
      anon_sym_LBRACE,
    STATE(6956), 1,
      sym_requirement_seq,
  [354812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9550), 1,
      anon_sym_LT,
    STATE(5227), 1,
      sym_template_argument_list,
  [354822] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16726), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [354830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(503), 1,
      sym_compound_statement,
  [354840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14932), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16728), 1,
      anon_sym_SEMI,
  [354850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11245), 1,
      anon_sym_LBRACE,
    STATE(4929), 1,
      sym_compound_statement,
  [354860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11321), 1,
      anon_sym_LBRACE,
    STATE(2121), 1,
      sym_compound_statement,
  [354870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1093), 1,
      anon_sym_LBRACE,
    STATE(990), 1,
      sym_compound_statement,
  [354880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16410), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [354888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(4033), 1,
      sym_compound_statement,
  [354898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    STATE(506), 1,
      sym_field_declaration_list,
  [354908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10165), 1,
      anon_sym_LT,
    STATE(5227), 1,
      sym_template_argument_list,
  [354918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    STATE(1229), 1,
      sym_condition_clause,
  [354928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16730), 1,
      sym_identifier,
    STATE(1305), 1,
      sym_template_type,
  [354938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    STATE(10735), 1,
      sym_condition_clause,
  [354948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15061), 1,
      sym_identifier,
    STATE(9234), 1,
      sym_module_name,
  [354958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(9359), 1,
      sym_compound_statement,
  [354968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16644), 1,
      anon_sym_LT,
    STATE(4433), 1,
      sym_template_argument_list,
  [354978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5781), 1,
      anon_sym_LBRACE,
    STATE(1004), 1,
      sym_declaration_list,
  [354988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15857), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [354996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(2722), 1,
      sym_template_argument_list,
  [355006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    STATE(386), 1,
      sym_field_declaration_list,
  [355016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7064), 1,
      anon_sym_LT,
    STATE(2722), 1,
      sym_template_argument_list,
  [355026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(9711), 1,
      sym_compound_statement,
  [355036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11266), 1,
      anon_sym_LBRACE,
    STATE(4632), 1,
      sym_compound_statement,
  [355046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16732), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [355054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    STATE(9793), 1,
      sym_parameter_list,
  [355064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16734), 1,
      sym_identifier,
    STATE(3013), 1,
      sym_template_type,
  [355074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(11057), 1,
      sym_argument_list,
  [355084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13271), 1,
      anon_sym_RBRACE,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
  [355094] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(16736), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(16738), 1,
      sym_preproc_arg,
  [355104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11239), 1,
      anon_sym_LBRACE,
    STATE(4802), 1,
      sym_compound_statement,
  [355114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1093), 1,
      anon_sym_LBRACE,
    STATE(724), 1,
      sym_compound_statement,
  [355124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11277), 1,
      anon_sym_LBRACE,
    STATE(4066), 1,
      sym_compound_statement,
  [355134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    STATE(507), 1,
      sym_field_declaration_list,
  [355144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2406), 1,
      anon_sym_LT,
    STATE(210), 1,
      sym_template_argument_list,
  [355154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8076), 1,
      anon_sym_LBRACE,
    STATE(3784), 1,
      sym_field_declaration_list,
  [355164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8076), 1,
      anon_sym_LBRACE,
    STATE(3734), 1,
      sym_field_declaration_list,
  [355174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_LBRACE,
    STATE(726), 1,
      sym_field_declaration_list,
  [355184] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15704), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [355192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    STATE(10338), 1,
      sym_parameter_list,
  [355202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    STATE(675), 1,
      sym_field_declaration_list,
  [355212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    STATE(696), 1,
      sym_field_declaration_list,
  [355222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5777), 1,
      anon_sym_LBRACE,
    STATE(1150), 1,
      sym_declaration_list,
  [355232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_LBRACE,
    STATE(727), 1,
      sym_field_declaration_list,
  [355242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_LBRACE,
    STATE(4856), 1,
      sym_initializer_list,
  [355252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(9776), 1,
      sym_compound_statement,
  [355262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5781), 1,
      anon_sym_LBRACE,
    STATE(946), 1,
      sym_declaration_list,
  [355272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11321), 1,
      anon_sym_LBRACE,
    STATE(2445), 1,
      sym_compound_statement,
  [355282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16740), 1,
      sym_identifier,
    STATE(5291), 1,
      sym_template_type,
  [355292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(3237), 1,
      sym_field_declaration_list,
  [355302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(4066), 1,
      sym_compound_statement,
  [355312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(3240), 1,
      sym_field_declaration_list,
  [355322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
    ACTIONS(16742), 1,
      anon_sym_RBRACE,
  [355332] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(837), 1,
      sym_compound_statement,
  [355342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    STATE(650), 1,
      sym_field_declaration_list,
  [355352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16744), 1,
      sym_identifier,
    STATE(3533), 1,
      sym_template_type,
  [355362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    STATE(838), 1,
      sym_field_declaration_list,
  [355372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7256), 1,
      anon_sym_LBRACE,
    STATE(3160), 1,
      sym_field_declaration_list,
  [355382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    STATE(839), 1,
      sym_field_declaration_list,
  [355392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    STATE(840), 1,
      sym_field_declaration_list,
  [355402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
    ACTIONS(16746), 1,
      anon_sym_RBRACE,
  [355412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8076), 1,
      anon_sym_LBRACE,
    STATE(3778), 1,
      sym_field_declaration_list,
  [355422] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16748), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [355430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13488), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [355438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3202), 1,
      anon_sym_LT,
    STATE(527), 1,
      sym_template_argument_list,
  [355448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11601), 1,
      anon_sym_LBRACE,
    STATE(4280), 1,
      sym_requirement_seq,
  [355458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16750), 1,
      sym_identifier,
    STATE(2724), 1,
      sym_template_type,
  [355468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16752), 1,
      anon_sym_LT,
    STATE(4619), 1,
      sym_template_argument_list,
  [355478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    STATE(652), 1,
      sym_field_declaration_list,
  [355488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11615), 1,
      anon_sym_LBRACE,
    STATE(4649), 1,
      sym_requirement_seq,
  [355498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14932), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16754), 1,
      anon_sym_SEMI,
  [355508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    STATE(2821), 1,
      sym_field_declaration_list,
  [355518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11321), 1,
      anon_sym_LBRACE,
    STATE(1951), 1,
      sym_compound_statement,
  [355528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    STATE(844), 1,
      sym_field_declaration_list,
  [355538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(10927), 1,
      sym_argument_list,
  [355548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16756), 1,
      anon_sym_LT,
    STATE(4634), 1,
      sym_template_argument_list,
  [355558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10177), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [355566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5777), 1,
      anon_sym_LBRACE,
    STATE(1000), 1,
      sym_declaration_list,
  [355576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16644), 1,
      anon_sym_LT,
    STATE(4562), 1,
      sym_template_argument_list,
  [355586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    STATE(833), 1,
      sym_field_declaration_list,
  [355596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    STATE(10345), 1,
      sym_parameter_list,
  [355606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      anon_sym_LBRACE,
    STATE(482), 1,
      sym_compound_statement,
  [355616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16622), 1,
      anon_sym_LPAREN2,
    STATE(10733), 1,
      sym_parenthesized_expression,
  [355626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16758), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [355634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(4267), 1,
      sym_compound_statement,
  [355644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9311), 1,
      anon_sym_LBRACE,
    STATE(5161), 1,
      sym_field_declaration_list,
  [355654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16760), 1,
      sym_identifier,
    ACTIONS(16762), 1,
      anon_sym_LPAREN2,
  [355664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    STATE(486), 1,
      sym_field_declaration_list,
  [355674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2046), 1,
      anon_sym_LBRACE,
    STATE(1381), 1,
      sym_compound_statement,
  [355684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11270), 1,
      anon_sym_LBRACE,
    STATE(5137), 1,
      sym_compound_statement,
  [355694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16764), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [355702] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(16766), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(16768), 1,
      sym_preproc_arg,
  [355712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16756), 1,
      anon_sym_LT,
    STATE(4793), 1,
      sym_template_argument_list,
  [355722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5773), 1,
      anon_sym_LBRACE,
    STATE(606), 1,
      sym_declaration_list,
  [355732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(917), 1,
      anon_sym_LBRACE,
    STATE(885), 1,
      sym_compound_statement,
  [355742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    STATE(489), 1,
      sym_field_declaration_list,
  [355752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11245), 1,
      anon_sym_LBRACE,
    STATE(4857), 1,
      sym_compound_statement,
  [355762] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(16770), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(16772), 1,
      sym_preproc_arg,
  [355772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15099), 1,
      anon_sym_LBRACE,
    STATE(7161), 1,
      sym_requirement_seq,
  [355782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16740), 1,
      sym_identifier,
    STATE(3492), 1,
      sym_template_type,
  [355792] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(16774), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(16776), 1,
      sym_preproc_arg,
  [355802] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(508), 1,
      sym_compound_statement,
  [355812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    STATE(10447), 1,
      sym_parameter_list,
  [355822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    STATE(509), 1,
      sym_field_declaration_list,
  [355832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(11424), 1,
      sym_argument_list,
  [355842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16622), 1,
      anon_sym_LPAREN2,
    STATE(11284), 1,
      sym_parenthesized_expression,
  [355852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    STATE(510), 1,
      sym_field_declaration_list,
  [355862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11252), 1,
      anon_sym_LBRACE,
    STATE(1676), 1,
      sym_compound_statement,
  [355872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    STATE(512), 1,
      sym_field_declaration_list,
  [355882] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(16778), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(16780), 1,
      sym_preproc_arg,
  [355892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(210), 1,
      sym_template_argument_list,
  [355902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1093), 1,
      anon_sym_LBRACE,
    STATE(735), 1,
      sym_compound_statement,
  [355912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    STATE(10490), 1,
      sym_parameter_list,
  [355922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_LBRACE,
    STATE(736), 1,
      sym_field_declaration_list,
  [355932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12711), 1,
      anon_sym_LBRACE,
    STATE(2265), 1,
      sym_compound_statement,
  [355942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_LBRACE,
    STATE(715), 1,
      sym_field_declaration_list,
  [355952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_LBRACE,
    STATE(738), 1,
      sym_field_declaration_list,
  [355962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9300), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [355970] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(16782), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(16784), 1,
      sym_preproc_arg,
  [355980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11268), 1,
      anon_sym_LBRACE,
    STATE(7163), 1,
      sym_compound_statement,
  [355990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7724), 1,
      anon_sym_LBRACE,
    STATE(3579), 1,
      sym_field_declaration_list,
  [356000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5777), 1,
      anon_sym_LBRACE,
    STATE(1154), 1,
      sym_declaration_list,
  [356010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2797), 1,
      anon_sym_LT,
    STATE(264), 1,
      sym_template_argument_list,
  [356020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13218), 1,
      anon_sym_RBRACE,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
  [356030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
    ACTIONS(16786), 1,
      anon_sym_RBRACE,
  [356040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    STATE(10752), 1,
      sym_condition_clause,
  [356050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    STATE(5614), 1,
      sym_field_declaration_list,
  [356060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(11135), 1,
      sym_argument_list,
  [356070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    STATE(2822), 1,
      sym_field_declaration_list,
  [356080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    STATE(1222), 1,
      sym_condition_clause,
  [356090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    STATE(10682), 1,
      sym_condition_clause,
  [356100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2046), 1,
      anon_sym_LBRACE,
    STATE(1392), 1,
      sym_compound_statement,
  [356110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    STATE(1212), 1,
      sym_condition_clause,
  [356120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5773), 1,
      anon_sym_LBRACE,
    STATE(607), 1,
      sym_declaration_list,
  [356130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(10877), 1,
      sym_argument_list,
  [356140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(9948), 1,
      sym_compound_statement,
  [356150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16788), 1,
      anon_sym_LPAREN2,
    ACTIONS(16790), 1,
      sym_raw_string_delimiter,
  [356160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16792), 1,
      anon_sym_LPAREN2,
    ACTIONS(16794), 1,
      sym_raw_string_delimiter,
  [356170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(10260), 1,
      sym_compound_statement,
  [356180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
    ACTIONS(16796), 1,
      anon_sym_RBRACE,
  [356190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5321), 1,
      anon_sym_LBRACE,
    STATE(4916), 1,
      sym_initializer_list,
  [356200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(3352), 1,
      sym_template_argument_list,
  [356210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(10327), 1,
      sym_compound_statement,
  [356220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    STATE(6392), 1,
      sym_field_declaration_list,
  [356230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    STATE(10783), 1,
      sym_parameter_list,
  [356240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    STATE(844), 1,
      sym_field_declaration_list,
  [356250] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15918), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [356258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13183), 1,
      anon_sym_RBRACE,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
  [356268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(11015), 1,
      sym_argument_list,
  [356278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(11520), 1,
      sym_argument_list,
  [356288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    STATE(6396), 1,
      sym_field_declaration_list,
  [356298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    STATE(6397), 1,
      sym_field_declaration_list,
  [356308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16798), 1,
      sym_identifier,
    STATE(4618), 1,
      sym_template_type,
  [356318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    STATE(6400), 1,
      sym_field_declaration_list,
  [356328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16800), 1,
      sym_identifier,
    STATE(3102), 1,
      sym_template_type,
  [356338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(9372), 1,
      sym_compound_statement,
  [356348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15025), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
  [356358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(11102), 1,
      sym_argument_list,
  [356368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    STATE(1248), 1,
      sym_condition_clause,
  [356378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16525), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [356386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(11164), 1,
      sym_argument_list,
  [356396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16802), 1,
      anon_sym_if,
    ACTIONS(16804), 1,
      anon_sym_for,
  [356406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
    ACTIONS(16806), 1,
      anon_sym_RBRACE,
  [356416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5024), 1,
      anon_sym_LBRACE,
    STATE(1383), 1,
      sym_field_declaration_list,
  [356426] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(16808), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(16810), 1,
      sym_preproc_arg,
  [356436] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(16812), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(16814), 1,
      sym_preproc_arg,
  [356446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 1,
      anon_sym_LT,
    STATE(1307), 1,
      sym_template_argument_list,
  [356456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9311), 1,
      anon_sym_LBRACE,
    STATE(5168), 1,
      sym_field_declaration_list,
  [356466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1093), 1,
      anon_sym_LBRACE,
    STATE(870), 1,
      sym_compound_statement,
  [356476] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9311), 1,
      anon_sym_LBRACE,
    STATE(5169), 1,
      sym_field_declaration_list,
  [356486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16816), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [356494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16818), 1,
      sym_identifier,
    STATE(204), 1,
      sym_template_type,
  [356504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5024), 1,
      anon_sym_LBRACE,
    STATE(1393), 1,
      sym_field_declaration_list,
  [356514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_LBRACE,
    STATE(742), 1,
      sym_field_declaration_list,
  [356524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    STATE(1204), 1,
      sym_condition_clause,
  [356534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
    ACTIONS(16820), 1,
      anon_sym_RBRACE,
  [356544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16220), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [356552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(987), 1,
      sym_compound_statement,
  [356562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11266), 1,
      anon_sym_LBRACE,
    STATE(4613), 1,
      sym_compound_statement,
  [356572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(10839), 1,
      sym_argument_list,
  [356582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(9325), 1,
      sym_compound_statement,
  [356592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7724), 1,
      anon_sym_LBRACE,
    STATE(3574), 1,
      sym_field_declaration_list,
  [356602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    STATE(1232), 1,
      sym_condition_clause,
  [356612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16822), 1,
      anon_sym_if,
    ACTIONS(16824), 1,
      anon_sym_for,
  [356622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16826), 1,
      sym_identifier,
    STATE(2690), 1,
      sym_template_type,
  [356632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
    STATE(513), 1,
      sym_field_declaration_list,
  [356642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4964), 1,
      anon_sym_LBRACE,
    STATE(3387), 1,
      sym_initializer_list,
  [356652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5024), 1,
      anon_sym_LBRACE,
    STATE(1394), 1,
      sym_field_declaration_list,
  [356662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    STATE(693), 1,
      sym_field_declaration_list,
  [356672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7118), 1,
      anon_sym_LT,
    STATE(2722), 1,
      sym_template_argument_list,
  [356682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5024), 1,
      anon_sym_LBRACE,
    STATE(1395), 1,
      sym_field_declaration_list,
  [356692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9371), 1,
      anon_sym_LPAREN2,
    STATE(11080), 1,
      sym_argument_list,
  [356702] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16828), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [356710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16830), 1,
      sym_identifier,
    STATE(2724), 1,
      sym_template_type,
  [356720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16622), 1,
      anon_sym_LPAREN2,
    STATE(10826), 1,
      sym_parenthesized_expression,
  [356730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16832), 1,
      sym_identifier,
    STATE(263), 1,
      sym_template_type,
  [356740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    STATE(1230), 1,
      sym_condition_clause,
  [356750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10589), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [356758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    STATE(1250), 1,
      sym_condition_clause,
  [356768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(6523), 1,
      sym_field_declaration_list,
  [356778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11593), 1,
      anon_sym_LBRACE,
    STATE(4758), 1,
      sym_requirement_seq,
  [356788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(6526), 1,
      sym_field_declaration_list,
  [356798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(6527), 1,
      sym_field_declaration_list,
  [356808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(6529), 1,
      sym_field_declaration_list,
  [356818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15540), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [356826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11237), 1,
      anon_sym_LPAREN2,
    STATE(10452), 1,
      sym_parameter_list,
  [356836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16834), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [356844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11272), 1,
      anon_sym_LBRACE,
    STATE(3469), 1,
      sym_compound_statement,
  [356854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    STATE(5712), 1,
      sym_field_declaration_list,
  [356864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(2953), 1,
      sym_template_argument_list,
  [356874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10147), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [356882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    STATE(6533), 1,
      sym_field_declaration_list,
  [356892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12821), 1,
      anon_sym_LBRACE,
    STATE(1763), 1,
      sym_compound_statement,
  [356902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    STATE(6486), 1,
      sym_field_declaration_list,
  [356912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    STATE(6488), 1,
      sym_field_declaration_list,
  [356922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9874), 1,
      anon_sym_LBRACE,
    STATE(6495), 1,
      sym_field_declaration_list,
  [356932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5024), 1,
      anon_sym_LBRACE,
    STATE(1384), 1,
      sym_field_declaration_list,
  [356942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11323), 1,
      anon_sym_LBRACE,
    STATE(6959), 1,
      sym_compound_statement,
  [356952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11268), 1,
      anon_sym_LBRACE,
    STATE(7188), 1,
      sym_compound_statement,
  [356962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(917), 1,
      anon_sym_LBRACE,
    STATE(837), 1,
      sym_compound_statement,
  [356972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10165), 1,
      anon_sym_LT,
    STATE(4990), 1,
      sym_template_argument_list,
  [356982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(493), 1,
      sym_compound_statement,
  [356992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16622), 1,
      anon_sym_LPAREN2,
    STATE(10567), 1,
      sym_parenthesized_expression,
  [357002] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(16836), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(16838), 1,
      sym_preproc_arg,
  [357012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    STATE(838), 1,
      sym_field_declaration_list,
  [357022] = 3,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(16840), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(16842), 1,
      sym_preproc_arg,
  [357032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    STATE(839), 1,
      sym_field_declaration_list,
  [357042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16756), 1,
      anon_sym_LT,
    STATE(3522), 1,
      sym_template_argument_list,
  [357052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11321), 1,
      anon_sym_LBRACE,
    STATE(2095), 1,
      sym_compound_statement,
  [357062] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13315), 1,
      anon_sym_RBRACE,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
  [357072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(9745), 1,
      sym_compound_statement,
  [357082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    STATE(840), 1,
      sym_field_declaration_list,
  [357092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16844), 1,
      anon_sym_LPAREN2,
    ACTIONS(16846), 1,
      sym_raw_string_delimiter,
  [357102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    STATE(1217), 1,
      sym_condition_clause,
  [357112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6858), 1,
      anon_sym_LBRACE,
    STATE(2819), 1,
      sym_field_declaration_list,
  [357122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12711), 1,
      anon_sym_LBRACE,
    STATE(1999), 1,
      sym_compound_statement,
  [357132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3779), 1,
      anon_sym_LT,
    STATE(3330), 1,
      sym_template_argument_list,
  [357142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    STATE(1207), 1,
      sym_condition_clause,
  [357152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(317), 1,
      anon_sym_LBRACE,
    STATE(412), 1,
      sym_compound_statement,
  [357162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5773), 1,
      anon_sym_LBRACE,
    STATE(548), 1,
      sym_declaration_list,
  [357172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11239), 1,
      anon_sym_LBRACE,
    STATE(4770), 1,
      sym_compound_statement,
  [357182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16632), 1,
      anon_sym_LT,
    STATE(3352), 1,
      sym_template_argument_list,
  [357192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16848), 1,
      anon_sym_LPAREN2,
    ACTIONS(16850), 1,
      sym_raw_string_delimiter,
  [357202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    STATE(5641), 1,
      sym_field_declaration_list,
  [357212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    STATE(5625), 1,
      sym_field_declaration_list,
  [357222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16852), 1,
      anon_sym_LPAREN2,
    ACTIONS(16854), 1,
      sym_raw_string_delimiter,
  [357232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16856), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [357240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15608), 1,
      anon_sym_LPAREN2,
    STATE(1234), 1,
      sym_condition_clause,
  [357250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16622), 1,
      anon_sym_LPAREN2,
    STATE(10367), 1,
      sym_parenthesized_expression,
  [357260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16858), 1,
      anon_sym_LPAREN2,
    ACTIONS(16860), 1,
      sym_raw_string_delimiter,
  [357270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7666), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [357278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16862), 1,
      anon_sym_LPAREN2,
    ACTIONS(16864), 1,
      sym_raw_string_delimiter,
  [357288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16866), 1,
      anon_sym_LPAREN2,
    ACTIONS(16868), 1,
      sym_raw_string_delimiter,
  [357298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16870), 1,
      anon_sym_LPAREN2,
    ACTIONS(16872), 1,
      sym_raw_string_delimiter,
  [357308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16874), 1,
      anon_sym_LPAREN2,
    ACTIONS(16876), 1,
      sym_raw_string_delimiter,
  [357318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16878), 1,
      anon_sym_LPAREN2,
    ACTIONS(16880), 1,
      sym_raw_string_delimiter,
  [357328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16882), 1,
      anon_sym_LPAREN2,
    ACTIONS(16884), 1,
      sym_raw_string_delimiter,
  [357338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16886), 1,
      anon_sym_LPAREN2,
    ACTIONS(16888), 1,
      sym_raw_string_delimiter,
  [357348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    STATE(453), 1,
      sym_field_declaration_list,
  [357358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16890), 1,
      anon_sym_LPAREN2,
    ACTIONS(16892), 1,
      sym_raw_string_delimiter,
  [357368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16894), 1,
      anon_sym_LPAREN2,
    ACTIONS(16896), 1,
      sym_raw_string_delimiter,
  [357378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16898), 1,
      anon_sym_LPAREN2,
    ACTIONS(16900), 1,
      sym_raw_string_delimiter,
  [357388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10171), 1,
      anon_sym_RPAREN,
    ACTIONS(10173), 1,
      anon_sym_SEMI,
  [357398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11323), 1,
      anon_sym_LBRACE,
    STATE(6967), 1,
      sym_compound_statement,
  [357408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7256), 1,
      anon_sym_LBRACE,
    STATE(3166), 1,
      sym_field_declaration_list,
  [357418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2046), 1,
      anon_sym_LBRACE,
    STATE(1359), 1,
      sym_compound_statement,
  [357428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11272), 1,
      anon_sym_LBRACE,
    STATE(3388), 1,
      sym_compound_statement,
  [357438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16902), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [357446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
    ACTIONS(16904), 1,
      anon_sym_RBRACE,
  [357456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(363), 1,
      sym_compound_statement,
  [357466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9925), 1,
      anon_sym_LBRACE,
    STATE(5844), 1,
      sym_field_declaration_list,
  [357476] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(9845), 1,
      sym_compound_statement,
  [357486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16906), 1,
      anon_sym_LPAREN2,
  [357493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16908), 1,
      sym_raw_string_delimiter,
  [357500] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14043), 1,
      anon_sym_SEMI,
  [357507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16910), 1,
      aux_sym_preproc_if_token2,
  [357514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_DASH_GT_STAR,
  [357521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16914), 1,
      anon_sym_DOT_DOT_DOT,
  [357528] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16916), 1,
      anon_sym_RPAREN,
  [357535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16918), 1,
      anon_sym_SEMI,
  [357542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16806), 1,
      anon_sym_RBRACE,
  [357549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16920), 1,
      sym_identifier,
  [357556] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16922), 1,
      anon_sym_RPAREN,
  [357563] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16924), 1,
      anon_sym_RPAREN,
  [357570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16926), 1,
      anon_sym_RPAREN,
  [357577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16928), 1,
      anon_sym_SEMI,
  [357584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16930), 1,
      anon_sym_RPAREN,
  [357591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16932), 1,
      sym_raw_string_delimiter,
  [357598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16934), 1,
      anon_sym_SEMI,
  [357605] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16936), 1,
      anon_sym_RPAREN,
  [357612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16938), 1,
      anon_sym_RPAREN,
  [357619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16940), 1,
      anon_sym_SEMI,
  [357626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_SLASH_EQ,
  [357633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16942), 1,
      anon_sym_RPAREN,
  [357640] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(16944), 1,
      aux_sym_preproc_include_token2,
  [357647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16946), 1,
      anon_sym_RPAREN,
  [357654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_PERCENT_EQ,
  [357661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16948), 1,
      sym_raw_string_delimiter,
  [357668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16950), 1,
      sym_identifier,
  [357675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16952), 1,
      anon_sym_RPAREN,
  [357682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16954), 1,
      anon_sym_SEMI,
  [357689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16956), 1,
      anon_sym_SEMI,
  [357696] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16958), 1,
      anon_sym_RPAREN,
  [357703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16960), 1,
      anon_sym_SEMI,
  [357710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16962), 1,
      anon_sym_DQUOTE,
  [357717] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(16964), 1,
      aux_sym_preproc_include_token2,
  [357724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16966), 1,
      sym_raw_string_delimiter,
  [357731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10631), 1,
      anon_sym_COLON,
  [357738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16968), 1,
      aux_sym_preproc_if_token2,
  [357745] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16970), 1,
      anon_sym_RPAREN,
  [357752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10544), 1,
      anon_sym_RPAREN,
  [357759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16972), 1,
      anon_sym_RPAREN,
  [357766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16974), 1,
      anon_sym_SEMI,
  [357773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16976), 1,
      aux_sym_preproc_if_token2,
  [357780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16978), 1,
      sym_identifier,
  [357787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16980), 1,
      sym_raw_string_delimiter,
  [357794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16982), 1,
      sym_identifier,
  [357801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16984), 1,
      anon_sym_SEMI,
  [357808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16986), 1,
      aux_sym_preproc_if_token2,
  [357815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15869), 1,
      anon_sym_SEMI,
  [357822] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16988), 1,
      anon_sym_RPAREN,
  [357829] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16990), 1,
      anon_sym_SEMI,
  [357836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16992), 1,
      anon_sym_LPAREN2,
  [357843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16994), 1,
      anon_sym_SEMI,
  [357850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16996), 1,
      sym_raw_string_delimiter,
  [357857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16998), 1,
      anon_sym_RPAREN,
  [357864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17000), 1,
      anon_sym_SEMI,
  [357871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17002), 1,
      anon_sym_SEMI,
  [357878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13968), 1,
      anon_sym_SEMI,
  [357885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17004), 1,
      anon_sym_RPAREN,
  [357892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17006), 1,
      anon_sym_RPAREN,
  [357899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_PLUS_EQ,
  [357906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_DASH_EQ,
  [357913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17008), 1,
      sym_raw_string_delimiter,
  [357920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_PERCENT,
  [357927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17010), 1,
      aux_sym_preproc_if_token2,
  [357934] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(17012), 1,
      aux_sym_preproc_include_token2,
  [357941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17014), 1,
      anon_sym_RPAREN,
  [357948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_LT_LT_EQ,
  [357955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17016), 1,
      anon_sym_RPAREN,
  [357962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17018), 1,
      anon_sym_SEMI,
  [357969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17020), 1,
      anon_sym_SEMI,
  [357976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17022), 1,
      anon_sym_SEMI,
  [357983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17024), 1,
      anon_sym_RPAREN,
  [357990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17026), 1,
      anon_sym_RPAREN,
  [357997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17028), 1,
      anon_sym_RPAREN,
  [358004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17030), 1,
      anon_sym_RPAREN,
  [358011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17032), 1,
      anon_sym_LPAREN2,
  [358018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17034), 1,
      anon_sym_RPAREN,
  [358025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17036), 1,
      anon_sym_SEMI,
  [358032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17038), 1,
      anon_sym_SEMI,
  [358039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9969), 1,
      anon_sym_RPAREN,
  [358046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17040), 1,
      anon_sym_DQUOTE,
  [358053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17042), 1,
      anon_sym_RPAREN,
  [358060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17044), 1,
      anon_sym_SEMI,
  [358067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10497), 1,
      anon_sym_SEMI,
  [358074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17046), 1,
      anon_sym_RPAREN,
  [358081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10581), 1,
      anon_sym_SEMI,
  [358088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17048), 1,
      anon_sym_RPAREN,
  [358095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17050), 1,
      anon_sym_RPAREN,
  [358102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17052), 1,
      anon_sym_STAR,
  [358109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17054), 1,
      anon_sym_RPAREN,
  [358116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15252), 1,
      anon_sym_SEMI,
  [358123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17056), 1,
      anon_sym_RPAREN,
  [358130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_GT_GT_EQ,
  [358137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10769), 1,
      anon_sym_RPAREN,
  [358144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17058), 1,
      sym_identifier,
  [358151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17060), 1,
      anon_sym_RPAREN,
  [358158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17062), 1,
      anon_sym_RPAREN,
  [358165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13315), 1,
      anon_sym_RBRACE,
  [358172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17064), 1,
      anon_sym_RPAREN,
  [358179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17066), 1,
      anon_sym_RPAREN,
  [358186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17068), 1,
      anon_sym_RPAREN,
  [358193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17070), 1,
      anon_sym_RPAREN,
  [358200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17072), 1,
      anon_sym_SEMI,
  [358207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_PIPE_PIPE,
  [358214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10451), 1,
      anon_sym_RPAREN,
  [358221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17074), 1,
      anon_sym_SEMI,
  [358228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17076), 1,
      anon_sym_RPAREN,
  [358235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17078), 1,
      anon_sym_RPAREN,
  [358242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14083), 1,
      anon_sym_SEMI,
  [358249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17080), 1,
      anon_sym_SEMI,
  [358256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17082), 1,
      aux_sym_preproc_if_token2,
  [358263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_AMP_AMP,
  [358270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17084), 1,
      anon_sym_LPAREN2,
  [358277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13337), 1,
      anon_sym_LBRACE,
  [358284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17086), 1,
      anon_sym_LPAREN2,
  [358291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17088), 1,
      anon_sym_LPAREN2,
  [358298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17090), 1,
      anon_sym_LPAREN2,
  [358305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_PIPE,
  [358312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17092), 1,
      anon_sym_SEMI,
  [358319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17094), 1,
      anon_sym_LPAREN2,
  [358326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10783), 1,
      anon_sym_RPAREN,
  [358333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17096), 1,
      anon_sym_LPAREN2,
  [358340] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12248), 1,
      aux_sym_preproc_include_token2,
  [358347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_CARET,
  [358354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17098), 1,
      aux_sym_preproc_if_token2,
  [358361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16904), 1,
      anon_sym_RBRACE,
  [358368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17100), 1,
      anon_sym_LPAREN2,
  [358375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17102), 1,
      anon_sym_RPAREN,
  [358382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17104), 1,
      anon_sym_RPAREN,
  [358389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17106), 1,
      sym_raw_string_delimiter,
  [358396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17108), 1,
      anon_sym_LPAREN2,
  [358403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17110), 1,
      anon_sym_SEMI,
  [358410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17112), 1,
      anon_sym_import,
  [358417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17114), 1,
      sym_identifier,
  [358424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17116), 1,
      sym_identifier,
  [358431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17118), 1,
      anon_sym_LPAREN2,
  [358438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17120), 1,
      anon_sym_while,
  [358445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14030), 1,
      anon_sym_SEMI,
  [358452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17122), 1,
      anon_sym_LPAREN2,
  [358459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17124), 1,
      anon_sym_RPAREN,
  [358466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17126), 1,
      anon_sym_DQUOTE,
  [358473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17128), 1,
      anon_sym_RPAREN,
  [358480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10585), 1,
      anon_sym_SEMI,
  [358487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17130), 1,
      anon_sym_SEMI,
  [358494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17132), 1,
      sym_identifier,
  [358501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17134), 1,
      anon_sym_EQ,
  [358508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17136), 1,
      sym_raw_string_content,
  [358515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_AMP,
  [358522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17138), 1,
      aux_sym_preproc_if_token2,
  [358529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17140), 1,
      anon_sym_SEMI,
  [358536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17142), 1,
      anon_sym_STAR,
  [358543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17144), 1,
      anon_sym_LPAREN2,
  [358550] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10022), 1,
      anon_sym_RBRACE,
  [358557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17146), 1,
      aux_sym_preproc_if_token2,
  [358564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17148), 1,
      sym_identifier,
  [358571] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17150), 1,
      anon_sym_RBRACK,
  [358578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10020), 1,
      anon_sym_SEMI,
  [358585] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17152), 1,
      sym_identifier,
  [358592] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17154), 1,
      sym_identifier,
  [358599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17156), 1,
      anon_sym_SEMI,
  [358606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17158), 1,
      aux_sym_preproc_if_token2,
  [358613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17160), 1,
      anon_sym_STAR,
  [358620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13614), 1,
      anon_sym_LBRACE,
  [358627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17162), 1,
      anon_sym_RBRACE,
  [358634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17164), 1,
      anon_sym_DQUOTE,
  [358641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17166), 1,
      sym_identifier,
  [358648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17168), 1,
      anon_sym_RPAREN,
  [358655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17170), 1,
      anon_sym_COMMA,
  [358662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10701), 1,
      anon_sym_RPAREN,
  [358669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17172), 1,
      sym_identifier,
  [358676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13183), 1,
      anon_sym_RBRACE,
  [358683] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10611), 1,
      anon_sym_RPAREN,
  [358690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10530), 1,
      anon_sym_SEMI,
  [358697] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12038), 1,
      aux_sym_preproc_include_token2,
  [358704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_AMP_EQ,
  [358711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17174), 1,
      anon_sym_SEMI,
  [358718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17176), 1,
      anon_sym_SEMI,
  [358725] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10577), 1,
      anon_sym_COLON,
  [358732] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9112), 1,
      sym_identifier,
  [358739] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(17178), 1,
      aux_sym_preproc_include_token2,
  [358746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16620), 1,
      anon_sym_RBRACE,
  [358753] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14257), 1,
      anon_sym_EQ,
  [358760] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17180), 1,
      sym_identifier,
  [358767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17182), 1,
      anon_sym_SEMI,
  [358774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14273), 1,
      anon_sym_COMMA,
  [358781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17184), 1,
      sym_identifier,
  [358788] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(16586), 1,
      aux_sym_preproc_include_token2,
  [358795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17186), 1,
      anon_sym_COLON,
  [358802] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17188), 1,
      anon_sym_RPAREN,
  [358809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17190), 1,
      anon_sym_RPAREN,
  [358816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17192), 1,
      aux_sym_preproc_if_token2,
  [358823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17194), 1,
      anon_sym_RPAREN,
  [358830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17196), 1,
      sym_identifier,
  [358837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17198), 1,
      anon_sym_SEMI,
  [358844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17200), 1,
      sym_identifier,
  [358851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7802), 1,
      sym_identifier,
  [358858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17202), 1,
      anon_sym_SEMI,
  [358865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17204), 1,
      aux_sym_preproc_if_token2,
  [358872] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17206), 1,
      anon_sym_while,
  [358879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17208), 1,
      anon_sym_SEMI,
  [358886] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(17210), 1,
      aux_sym_preproc_include_token2,
  [358893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17212), 1,
      anon_sym_SEMI,
  [358900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17214), 1,
      anon_sym_COLON,
  [358907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17216), 1,
      aux_sym_preproc_if_token2,
  [358914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17218), 1,
      anon_sym_SEMI,
  [358921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17220), 1,
      sym_raw_string_content,
  [358928] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17222), 1,
      anon_sym_SEMI,
  [358935] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17224), 1,
      sym_identifier,
  [358942] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15932), 1,
      anon_sym_LBRACE,
  [358949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17226), 1,
      anon_sym_SEMI,
  [358956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17228), 1,
      sym_identifier,
  [358963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17230), 1,
      sym_identifier,
  [358970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17232), 1,
      sym_identifier,
  [358977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17234), 1,
      sym_identifier,
  [358984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17236), 1,
      anon_sym_SEMI,
  [358991] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(17238), 1,
      aux_sym_preproc_include_token2,
  [358998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16796), 1,
      anon_sym_RBRACE,
  [359005] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(17240), 1,
      aux_sym_preproc_include_token2,
  [359012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17242), 1,
      anon_sym_SEMI,
  [359019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 1,
      anon_sym_SEMI,
  [359026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17244), 1,
      anon_sym_RPAREN,
  [359033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17246), 1,
      anon_sym_RPAREN,
  [359040] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17248), 1,
      sym_identifier,
  [359047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17250), 1,
      anon_sym_SEMI,
  [359054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10793), 1,
      anon_sym_RPAREN,
  [359061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17252), 1,
      anon_sym_STAR,
  [359068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_EQ_EQ,
  [359075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17254), 1,
      anon_sym_RPAREN,
  [359082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17256), 1,
      anon_sym_SEMI,
  [359089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17258), 1,
      anon_sym_RPAREN,
  [359096] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17260), 1,
      sym_identifier,
  [359103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10791), 1,
      anon_sym_RPAREN,
  [359110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17262), 1,
      anon_sym_SEMI,
  [359117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13191), 1,
      anon_sym_RBRACE,
  [359124] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17264), 1,
      anon_sym_RPAREN,
  [359131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17266), 1,
      anon_sym_SEMI,
  [359138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17268), 1,
      anon_sym_DQUOTE,
  [359145] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17270), 1,
      anon_sym_RPAREN,
  [359152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10548), 1,
      anon_sym_COLON,
  [359159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17272), 1,
      sym_identifier,
  [359166] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16616), 1,
      anon_sym_COMMA,
  [359173] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17274), 1,
      anon_sym_LBRACE,
  [359180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17276), 1,
      sym_identifier,
  [359187] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(17278), 1,
      aux_sym_preproc_include_token2,
  [359194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14419), 1,
      anon_sym_LBRACE,
  [359201] = 2,
    ACTIONS(7152), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11965), 1,
      sym_comment,
  [359208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17280), 1,
      anon_sym_SEMI,
  [359215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17282), 1,
      anon_sym_RPAREN,
  [359222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17284), 1,
      anon_sym_SEMI,
  [359229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13993), 1,
      anon_sym_LBRACE,
  [359236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8700), 1,
      sym_identifier,
  [359243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17286), 1,
      sym_identifier,
  [359250] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17288), 1,
      anon_sym_RPAREN,
  [359257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17290), 1,
      anon_sym_DQUOTE,
  [359264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16656), 1,
      anon_sym_RBRACE,
  [359271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17292), 1,
      anon_sym_SEMI,
  [359278] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17294), 1,
      anon_sym_RBRACE,
  [359285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17296), 1,
      anon_sym_SEMI,
  [359292] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17298), 1,
      anon_sym_SEMI,
  [359299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17300), 1,
      anon_sym_COLON,
  [359306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17302), 1,
      anon_sym_SEMI,
  [359313] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17304), 1,
      sym_identifier,
  [359320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17306), 1,
      anon_sym_LPAREN2,
  [359327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17308), 1,
      anon_sym_DQUOTE,
  [359334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17310), 1,
      anon_sym_SEMI,
  [359341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17312), 1,
      anon_sym_RPAREN,
  [359348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13255), 1,
      anon_sym_LBRACE,
  [359355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15308), 1,
      anon_sym_SEMI,
  [359362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15306), 1,
      anon_sym_SEMI,
  [359369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17314), 1,
      sym_identifier,
  [359376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17316), 1,
      anon_sym_SEMI,
  [359383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17318), 1,
      anon_sym_RPAREN,
  [359390] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10171), 1,
      anon_sym_RPAREN,
  [359397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17320), 1,
      anon_sym_LPAREN2,
  [359404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17322), 1,
      sym_identifier,
  [359411] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17324), 1,
      anon_sym_RPAREN,
  [359418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17326), 1,
      sym_raw_string_delimiter,
  [359425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17328), 1,
      anon_sym_SEMI,
  [359432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17330), 1,
      anon_sym_LPAREN2,
  [359439] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15115), 1,
      anon_sym_SEMI,
  [359446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17332), 1,
      anon_sym_DQUOTE,
  [359453] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16618), 1,
      anon_sym_RBRACE,
  [359460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17334), 1,
      anon_sym_RPAREN,
  [359467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17336), 1,
      anon_sym_SEMI,
  [359474] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17338), 1,
      anon_sym_LPAREN2,
  [359481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17340), 1,
      anon_sym_EQ,
  [359488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17342), 1,
      sym_identifier,
  [359495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17344), 1,
      anon_sym_RPAREN,
  [359502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17346), 1,
      sym_identifier,
  [359509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10637), 1,
      anon_sym_COLON,
  [359516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17348), 1,
      aux_sym_preproc_if_token2,
  [359523] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10777), 1,
      anon_sym_RPAREN,
  [359530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10187), 1,
      anon_sym_RBRACE,
  [359537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10501), 1,
      anon_sym_RPAREN,
  [359544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17350), 1,
      anon_sym_RPAREN,
  [359551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10807), 1,
      anon_sym_RPAREN,
  [359558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17352), 1,
      aux_sym_preproc_if_token2,
  [359565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_BANG_EQ,
  [359572] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(16321), 1,
      aux_sym_preproc_include_token2,
  [359579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10809), 1,
      anon_sym_RPAREN,
  [359586] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17354), 1,
      anon_sym_LPAREN2,
  [359593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14006), 1,
      anon_sym_SEMI,
  [359600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17356), 1,
      anon_sym_DQUOTE,
  [359607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13343), 1,
      anon_sym_RBRACE,
  [359614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17358), 1,
      anon_sym_SEMI,
  [359621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13203), 1,
      anon_sym_RBRACE,
  [359628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14014), 1,
      anon_sym_LBRACE,
  [359635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17360), 1,
      anon_sym_RBRACK,
  [359642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17362), 1,
      aux_sym_preproc_if_token2,
  [359649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17364), 1,
      anon_sym_SEMI,
  [359656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17366), 1,
      sym_identifier,
  [359663] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17368), 1,
      anon_sym_SEMI,
  [359670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17370), 1,
      anon_sym_SEMI,
  [359677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17372), 1,
      anon_sym_SEMI,
  [359684] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(17374), 1,
      aux_sym_preproc_include_token2,
  [359691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17376), 1,
      anon_sym_SEMI,
  [359698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17378), 1,
      anon_sym_RPAREN,
  [359705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17380), 1,
      anon_sym_COLON,
  [359712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10813), 1,
      anon_sym_RPAREN,
  [359719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15049), 1,
      anon_sym_SEMI,
  [359726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13213), 1,
      anon_sym_RBRACE,
  [359733] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(17382), 1,
      aux_sym_preproc_include_token2,
  [359740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15330), 1,
      anon_sym_SEMI,
  [359747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17384), 1,
      sym_identifier,
  [359754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17386), 1,
      anon_sym_RPAREN,
  [359761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17388), 1,
      sym_identifier,
  [359768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17390), 1,
      anon_sym_LBRACE,
  [359775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10569), 1,
      anon_sym_RPAREN,
  [359782] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(17392), 1,
      aux_sym_preproc_include_token2,
  [359789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17394), 1,
      anon_sym_RPAREN,
  [359796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10445), 1,
      anon_sym_RPAREN,
  [359803] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(17396), 1,
      aux_sym_preproc_include_token2,
  [359810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17398), 1,
      anon_sym_RPAREN,
  [359817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17400), 1,
      anon_sym_SEMI,
  [359824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16680), 1,
      anon_sym_RBRACE,
  [359831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17402), 1,
      anon_sym_SEMI,
  [359838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17404), 1,
      anon_sym_RPAREN,
  [359845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17406), 1,
      anon_sym_RPAREN,
  [359852] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6585), 1,
      anon_sym_SEMI,
  [359859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17408), 1,
      anon_sym_DQUOTE,
  [359866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17410), 1,
      anon_sym_SEMI,
  [359873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17412), 1,
      anon_sym_DQUOTE,
  [359880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_CARET_EQ,
  [359887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17414), 1,
      anon_sym_RPAREN,
  [359894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17416), 1,
      sym_identifier,
  [359901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17418), 1,
      aux_sym_preproc_if_token2,
  [359908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_GT,
  [359915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17420), 1,
      anon_sym_RPAREN,
  [359922] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17422), 1,
      anon_sym_SEMI,
  [359929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17424), 1,
      anon_sym_STAR,
  [359936] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17426), 1,
      anon_sym_RPAREN,
  [359943] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17428), 1,
      sym_identifier,
  [359950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17430), 1,
      sym_identifier,
  [359957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17432), 1,
      anon_sym_DQUOTE,
  [359964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17434), 1,
      sym_identifier,
  [359971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17436), 1,
      aux_sym_preproc_if_token2,
  [359978] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17438), 1,
      anon_sym_RPAREN,
  [359985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17440), 1,
      anon_sym_STAR,
  [359992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17442), 1,
      anon_sym_RPAREN,
  [359999] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_GT_EQ,
  [360006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17444), 1,
      anon_sym_DQUOTE,
  [360013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_LT_EQ,
  [360020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10525), 1,
      anon_sym_COLON,
  [360027] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_PIPE_EQ,
  [360034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17446), 1,
      sym_identifier,
  [360041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15037), 1,
      anon_sym_SEMI,
  [360048] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8493), 1,
      anon_sym_RPAREN,
  [360055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17448), 1,
      aux_sym_preproc_if_token2,
  [360062] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13218), 1,
      anon_sym_RBRACE,
  [360069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17450), 1,
      anon_sym_RPAREN,
  [360076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_or,
  [360083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17452), 1,
      anon_sym_RPAREN,
  [360090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17454), 1,
      anon_sym_SEMI,
  [360097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_and,
  [360104] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17456), 1,
      sym_identifier,
  [360111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11488), 1,
      anon_sym_LBRACE,
  [360118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17458), 1,
      anon_sym_LBRACE,
  [360125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17460), 1,
      anon_sym_LBRACE,
  [360132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17462), 1,
      anon_sym_RPAREN,
  [360139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17464), 1,
      anon_sym_SEMI,
  [360146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7033), 1,
      anon_sym_SEMI,
  [360153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10848), 1,
      anon_sym_RPAREN,
  [360160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17466), 1,
      ts_builtin_sym_end,
  [360167] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17468), 1,
      anon_sym_SEMI,
  [360174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_bitor,
  [360181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17470), 1,
      anon_sym_SEMI,
  [360188] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17472), 1,
      aux_sym_preproc_if_token2,
  [360195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17474), 1,
      anon_sym_RPAREN,
  [360202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6481), 1,
      anon_sym_SEMI,
  [360209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17476), 1,
      anon_sym_RPAREN,
  [360216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17478), 1,
      sym_identifier,
  [360223] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17480), 1,
      anon_sym_SEMI,
  [360230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17482), 1,
      anon_sym_SEMI,
  [360237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17484), 1,
      anon_sym_RPAREN,
  [360244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17486), 1,
      anon_sym_SEMI,
  [360251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17488), 1,
      anon_sym_SEMI,
  [360258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17490), 1,
      anon_sym_SEMI,
  [360265] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17492), 1,
      anon_sym_SEMI,
  [360272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7043), 1,
      anon_sym_SEMI,
  [360279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17494), 1,
      anon_sym_COLON,
  [360286] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17496), 1,
      sym_identifier,
  [360293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_xor,
  [360300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17498), 1,
      anon_sym_DQUOTE,
  [360307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17500), 1,
      sym_identifier,
  [360314] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10629), 1,
      anon_sym_COLON,
  [360321] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_LT,
  [360328] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17502), 1,
      anon_sym_RPAREN,
  [360335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17504), 1,
      anon_sym_RPAREN,
  [360342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10536), 1,
      anon_sym_COLON,
  [360349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17506), 1,
      anon_sym_RPAREN,
  [360356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17508), 1,
      sym_identifier,
  [360363] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17510), 1,
      anon_sym_RPAREN,
  [360370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17512), 1,
      aux_sym_preproc_if_token2,
  [360377] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17514), 1,
      anon_sym_LBRACE,
  [360384] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17516), 1,
      anon_sym_SEMI,
  [360391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17518), 1,
      anon_sym_DQUOTE,
  [360398] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17520), 1,
      sym_identifier,
  [360405] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17522), 1,
      sym_identifier,
  [360412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6437), 1,
      anon_sym_DOT_DOT_DOT,
  [360419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17524), 1,
      sym_identifier,
  [360426] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17526), 1,
      anon_sym_RPAREN,
  [360433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17528), 1,
      sym_raw_string_delimiter,
  [360440] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(17530), 1,
      aux_sym_preproc_include_token2,
  [360447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17532), 1,
      anon_sym_SEMI,
  [360454] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17534), 1,
      anon_sym_RPAREN,
  [360461] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_LT_LT,
  [360468] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17536), 1,
      anon_sym_LPAREN2,
  [360475] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10691), 1,
      anon_sym_RPAREN,
  [360482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17538), 1,
      sym_identifier,
  [360489] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17540), 1,
      anon_sym_SEMI,
  [360496] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(17542), 1,
      aux_sym_preproc_include_token2,
  [360503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17544), 1,
      anon_sym_SEMI,
  [360510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17546), 1,
      sym_identifier,
  [360517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17548), 1,
      anon_sym_SEMI,
  [360524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17550), 1,
      anon_sym_SEMI,
  [360531] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17552), 1,
      sym_identifier,
  [360538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17554), 1,
      anon_sym_LPAREN2,
  [360545] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17556), 1,
      anon_sym_LPAREN2,
  [360552] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17558), 1,
      anon_sym_LPAREN2,
  [360559] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17560), 1,
      anon_sym_LPAREN2,
  [360566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17562), 1,
      anon_sym_RPAREN,
  [360573] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17564), 1,
      anon_sym_LPAREN2,
  [360580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6416), 1,
      anon_sym_DOT_DOT_DOT,
  [360587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10583), 1,
      anon_sym_SEMI,
  [360594] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17566), 1,
      anon_sym_RPAREN,
  [360601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10366), 1,
      anon_sym_RBRACE,
  [360608] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16668), 1,
      anon_sym_RBRACE,
  [360615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17568), 1,
      sym_identifier,
  [360622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17570), 1,
      anon_sym_while,
  [360629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17572), 1,
      anon_sym_LPAREN2,
  [360636] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17574), 1,
      anon_sym_LPAREN2,
  [360643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17576), 1,
      anon_sym_RPAREN,
  [360650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10651), 1,
      anon_sym_RPAREN,
  [360657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17578), 1,
      sym_raw_string_delimiter,
  [360664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10503), 1,
      anon_sym_SEMI,
  [360671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17580), 1,
      anon_sym_EQ,
  [360678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17582), 1,
      sym_raw_string_content,
  [360685] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17584), 1,
      anon_sym_STAR,
  [360692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17586), 1,
      anon_sym_LPAREN2,
  [360699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10767), 1,
      anon_sym_RPAREN,
  [360706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6422), 1,
      anon_sym_DOT_DOT_DOT,
  [360713] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17588), 1,
      anon_sym_SEMI,
  [360720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10560), 1,
      anon_sym_COLON,
  [360727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15121), 1,
      anon_sym_SEMI,
  [360734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_COMMA,
  [360741] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17590), 1,
      anon_sym_RPAREN,
  [360748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17592), 1,
      anon_sym_COMMA,
  [360755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17594), 1,
      anon_sym_LPAREN2,
  [360762] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17596), 1,
      sym_identifier,
  [360769] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17598), 1,
      anon_sym_SEMI,
  [360776] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17600), 1,
      anon_sym_STAR,
  [360783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17602), 1,
      anon_sym_RPAREN,
  [360790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13949), 1,
      anon_sym_SEMI,
  [360797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15387), 1,
      anon_sym_SEMI,
  [360804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17604), 1,
      anon_sym_COLON,
  [360811] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17606), 1,
      anon_sym_SEMI,
  [360818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_bitand,
  [360825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17608), 1,
      sym_identifier,
  [360832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10540), 1,
      anon_sym_SEMI,
  [360839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17610), 1,
      aux_sym_preproc_if_token2,
  [360846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17612), 1,
      anon_sym_SEMI,
  [360853] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17614), 1,
      anon_sym_RBRACE,
  [360860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6382), 1,
      anon_sym_DOT_DOT_DOT,
  [360867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17616), 1,
      anon_sym_DQUOTE,
  [360874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17618), 1,
      anon_sym_RPAREN,
  [360881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17620), 1,
      anon_sym_SEMI,
  [360888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17622), 1,
      anon_sym_SEMI,
  [360895] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10619), 1,
      anon_sym_COLON,
  [360902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17624), 1,
      aux_sym_preproc_if_token2,
  [360909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17626), 1,
      sym_identifier,
  [360916] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17628), 1,
      anon_sym_RPAREN,
  [360923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17630), 1,
      anon_sym_RBRACE,
  [360930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17632), 1,
      sym_identifier,
  [360937] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16820), 1,
      anon_sym_RBRACE,
  [360944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17634), 1,
      anon_sym_SEMI,
  [360951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17636), 1,
      anon_sym_DQUOTE,
  [360958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6390), 1,
      anon_sym_DOT_DOT_DOT,
  [360965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17638), 1,
      anon_sym_STAR,
  [360972] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17640), 1,
      anon_sym_SEMI,
  [360979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6398), 1,
      anon_sym_DOT_DOT_DOT,
  [360986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17642), 1,
      aux_sym_preproc_if_token2,
  [360993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16742), 1,
      anon_sym_RBRACE,
  [361000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17644), 1,
      anon_sym_LPAREN2,
  [361007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17646), 1,
      anon_sym_SEMI,
  [361014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17648), 1,
      anon_sym_LBRACE,
  [361021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17650), 1,
      anon_sym_SEMI,
  [361028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16449), 1,
      anon_sym_LBRACE,
  [361035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17652), 1,
      aux_sym_preproc_if_token2,
  [361042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6404), 1,
      anon_sym_DOT_DOT_DOT,
  [361049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17654), 1,
      anon_sym_SEMI,
  [361056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17656), 1,
      anon_sym_RPAREN,
  [361063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17658), 1,
      anon_sym_SEMI,
  [361070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17660), 1,
      anon_sym_RPAREN,
  [361077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17662), 1,
      anon_sym_LBRACE,
  [361084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT_DOT,
  [361091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10493), 1,
      anon_sym_SEMI,
  [361098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10231), 1,
      anon_sym_RBRACE,
  [361105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17664), 1,
      anon_sym_RPAREN,
  [361112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17666), 1,
      anon_sym_STAR,
  [361119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17668), 1,
      anon_sym_RPAREN,
  [361126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17670), 1,
      anon_sym_LPAREN2,
  [361133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17672), 1,
      anon_sym_LPAREN2,
  [361140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17674), 1,
      anon_sym_LPAREN2,
  [361147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17676), 1,
      anon_sym_SEMI,
  [361154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17678), 1,
      anon_sym_LPAREN2,
  [361161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17680), 1,
      aux_sym_preproc_if_token2,
  [361168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10663), 1,
      anon_sym_RPAREN,
  [361175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17682), 1,
      anon_sym_while,
  [361182] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12016), 1,
      aux_sym_preproc_include_token2,
  [361189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17684), 1,
      anon_sym_LPAREN2,
  [361196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17686), 1,
      anon_sym_RPAREN,
  [361203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17688), 1,
      anon_sym_RPAREN,
  [361210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_DOT_STAR,
  [361217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17690), 1,
      sym_raw_string_content,
  [361224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17692), 1,
      sym_identifier,
  [361231] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17694), 1,
      anon_sym_RPAREN,
  [361238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17696), 1,
      anon_sym_COMMA,
  [361245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10173), 1,
      anon_sym_SEMI,
  [361252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17698), 1,
      sym_this,
  [361259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17700), 1,
      sym_identifier,
  [361266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17702), 1,
      anon_sym_RPAREN,
  [361273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17704), 1,
      anon_sym_SEMI,
  [361280] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17706), 1,
      anon_sym_COLON,
  [361287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13275), 1,
      anon_sym_RBRACE,
  [361294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17708), 1,
      anon_sym_DQUOTE,
  [361301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17710), 1,
      anon_sym_private,
  [361308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17712), 1,
      anon_sym_RPAREN,
  [361315] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10499), 1,
      anon_sym_SEMI,
  [361322] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6413), 1,
      anon_sym_DOT_DOT_DOT,
  [361329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17714), 1,
      aux_sym_preproc_if_token2,
  [361336] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17716), 1,
      anon_sym_DQUOTE,
  [361343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17718), 1,
      anon_sym_SEMI,
  [361350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17720), 1,
      anon_sym_RPAREN,
  [361357] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_COLON_COLON,
  [361364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17722), 1,
      anon_sym_LPAREN2,
  [361371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6385), 1,
      anon_sym_DOT_DOT_DOT,
  [361378] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(17724), 1,
      aux_sym_preproc_include_token2,
  [361385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6407), 1,
      anon_sym_DOT_DOT_DOT,
  [361392] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17726), 1,
      anon_sym_SEMI,
  [361399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17728), 1,
      anon_sym_SEMI,
  [361406] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17730), 1,
      anon_sym_DQUOTE,
  [361413] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17732), 1,
      anon_sym_SEMI,
  [361420] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17734), 1,
      anon_sym_LPAREN2,
  [361427] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17736), 1,
      anon_sym_LPAREN2,
  [361434] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17738), 1,
      anon_sym_LPAREN2,
  [361441] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17740), 1,
      anon_sym_DQUOTE,
  [361448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17742), 1,
      anon_sym_LPAREN2,
  [361455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17744), 1,
      aux_sym_preproc_if_token2,
  [361462] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17746), 1,
      anon_sym_SEMI,
  [361469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17748), 1,
      anon_sym_while,
  [361476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17750), 1,
      anon_sym_LPAREN2,
  [361483] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6395), 1,
      anon_sym_DOT_DOT_DOT,
  [361490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17752), 1,
      anon_sym_EQ,
  [361497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17754), 1,
      anon_sym_EQ,
  [361504] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17756), 1,
      sym_raw_string_content,
  [361511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17758), 1,
      anon_sym_DQUOTE,
  [361518] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17760), 1,
      anon_sym_RPAREN,
  [361525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17762), 1,
      anon_sym_COMMA,
  [361532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13319), 1,
      anon_sym_RBRACE,
  [361539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17764), 1,
      sym_identifier,
  [361546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17766), 1,
      anon_sym_RPAREN,
  [361553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17768), 1,
      anon_sym_COLON,
  [361560] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17770), 1,
      anon_sym_LBRACE,
  [361567] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17772), 1,
      anon_sym_RBRACE,
  [361574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17774), 1,
      aux_sym_preproc_if_token2,
  [361581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17776), 1,
      aux_sym_preproc_if_token2,
  [361588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10567), 1,
      anon_sym_SEMI,
  [361595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17778), 1,
      anon_sym_SEMI,
  [361602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17780), 1,
      anon_sym_SEMI,
  [361609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17782), 1,
      anon_sym_SEMI,
  [361616] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15431), 1,
      anon_sym_SEMI,
  [361623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17784), 1,
      anon_sym_LPAREN2,
  [361630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17786), 1,
      anon_sym_LPAREN2,
  [361637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17788), 1,
      anon_sym_LPAREN2,
  [361644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17790), 1,
      anon_sym_SEMI,
  [361651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17792), 1,
      anon_sym_LPAREN2,
  [361658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17794), 1,
      anon_sym_DQUOTE,
  [361665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17796), 1,
      aux_sym_preproc_if_token2,
  [361672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17798), 1,
      anon_sym_LPAREN2,
  [361679] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(15634), 1,
      aux_sym_preproc_include_token2,
  [361686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10314), 1,
      anon_sym_RBRACE,
  [361693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17800), 1,
      anon_sym_EQ,
  [361700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17802), 1,
      sym_raw_string_content,
  [361707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17804), 1,
      anon_sym_RPAREN,
  [361714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17806), 1,
      sym_raw_string_delimiter,
  [361721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17808), 1,
      anon_sym_COMMA,
  [361728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_GT_GT,
  [361735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17810), 1,
      sym_identifier,
  [361742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17812), 1,
      anon_sym_RPAREN,
  [361749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17814), 1,
      anon_sym_COLON,
  [361756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17816), 1,
      anon_sym_SEMI,
  [361763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17818), 1,
      anon_sym_STAR,
  [361770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17820), 1,
      aux_sym_preproc_if_token2,
  [361777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14768), 1,
      anon_sym_COLON,
  [361784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17822), 1,
      anon_sym_SEMI,
  [361791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17824), 1,
      sym_identifier,
  [361798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10681), 1,
      anon_sym_RPAREN,
  [361805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17826), 1,
      anon_sym_LPAREN2,
  [361812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17828), 1,
      anon_sym_LPAREN2,
  [361819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17830), 1,
      anon_sym_RPAREN,
  [361826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17832), 1,
      anon_sym_LPAREN2,
  [361833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17834), 1,
      anon_sym_RPAREN,
  [361840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17836), 1,
      anon_sym_RPAREN,
  [361847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17838), 1,
      anon_sym_RPAREN,
  [361854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17840), 1,
      sym_identifier,
  [361861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17842), 1,
      anon_sym_EQ,
  [361868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17844), 1,
      sym_raw_string_content,
  [361875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17846), 1,
      aux_sym_preproc_if_token2,
  [361882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17848), 1,
      anon_sym_RPAREN,
  [361889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17850), 1,
      anon_sym_RPAREN,
  [361896] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17852), 1,
      anon_sym_SEMI,
  [361903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17854), 1,
      anon_sym_RPAREN,
  [361910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7003), 1,
      anon_sym_SEMI,
  [361917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17856), 1,
      anon_sym_RPAREN,
  [361924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17858), 1,
      anon_sym_STAR,
  [361931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17860), 1,
      anon_sym_RPAREN,
  [361938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17862), 1,
      anon_sym_COLON,
  [361945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17864), 1,
      sym_identifier,
  [361952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17866), 1,
      anon_sym_RPAREN,
  [361959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17868), 1,
      anon_sym_LPAREN2,
  [361966] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17870), 1,
      anon_sym_LPAREN2,
  [361973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17872), 1,
      anon_sym_LPAREN2,
  [361980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17874), 1,
      anon_sym_DQUOTE,
  [361987] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17876), 1,
      sym_raw_string_content,
  [361994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17878), 1,
      anon_sym_SEMI,
  [362001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17880), 1,
      aux_sym_preproc_if_token2,
  [362008] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17882), 1,
      anon_sym_RPAREN,
  [362015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17884), 1,
      anon_sym_RPAREN,
  [362022] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15127), 1,
      anon_sym_SEMI,
  [362029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17886), 1,
      anon_sym_RPAREN,
  [362036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17888), 1,
      sym_identifier,
  [362043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17890), 1,
      anon_sym_SEMI,
  [362050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17892), 1,
      sym_identifier,
  [362057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10735), 1,
      anon_sym_RPAREN,
  [362064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17894), 1,
      anon_sym_LPAREN2,
  [362071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17896), 1,
      anon_sym_LPAREN2,
  [362078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17898), 1,
      anon_sym_LPAREN2,
  [362085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17900), 1,
      aux_sym_preproc_if_token2,
  [362092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17902), 1,
      sym_raw_string_content,
  [362099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17904), 1,
      anon_sym_DQUOTE,
  [362106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17906), 1,
      anon_sym_RPAREN,
  [362113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17908), 1,
      anon_sym_LPAREN2,
  [362120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17910), 1,
      anon_sym_LPAREN2,
  [362127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17912), 1,
      anon_sym_LPAREN2,
  [362134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17914), 1,
      sym_raw_string_content,
  [362141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17916), 1,
      anon_sym_RPAREN,
  [362148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17918), 1,
      anon_sym_LPAREN2,
  [362155] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17920), 1,
      anon_sym_LPAREN2,
  [362162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17922), 1,
      anon_sym_LPAREN2,
  [362169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17924), 1,
      sym_raw_string_content,
  [362176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17926), 1,
      anon_sym_RPAREN,
  [362183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17928), 1,
      anon_sym_LPAREN2,
  [362190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17930), 1,
      anon_sym_LPAREN2,
  [362197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17932), 1,
      sym_raw_string_content,
  [362204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17934), 1,
      anon_sym_RPAREN,
  [362211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17936), 1,
      anon_sym_LPAREN2,
  [362218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17938), 1,
      anon_sym_LPAREN2,
  [362225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17940), 1,
      sym_raw_string_content,
  [362232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17942), 1,
      anon_sym_RPAREN,
  [362239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17944), 1,
      anon_sym_LPAREN2,
  [362246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17946), 1,
      sym_raw_string_content,
  [362253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17948), 1,
      anon_sym_RPAREN,
  [362260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17950), 1,
      anon_sym_LPAREN2,
  [362267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17952), 1,
      sym_raw_string_content,
  [362274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17954), 1,
      anon_sym_RPAREN,
  [362281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17956), 1,
      anon_sym_LPAREN2,
  [362288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17958), 1,
      sym_raw_string_content,
  [362295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17960), 1,
      anon_sym_RPAREN,
  [362302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17962), 1,
      anon_sym_LPAREN2,
  [362309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17964), 1,
      sym_raw_string_content,
  [362316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17966), 1,
      anon_sym_RPAREN,
  [362323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13271), 1,
      anon_sym_RBRACE,
  [362330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17968), 1,
      anon_sym_RPAREN,
  [362337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17970), 1,
      anon_sym_LPAREN2,
  [362344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17972), 1,
      anon_sym_LPAREN2,
  [362351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17974), 1,
      sym_identifier,
  [362358] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(17976), 1,
      aux_sym_preproc_include_token2,
  [362365] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(17978), 1,
      aux_sym_preproc_include_token2,
  [362372] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(17980), 1,
      aux_sym_preproc_include_token2,
  [362379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17982), 1,
      anon_sym_DQUOTE,
  [362386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12758), 1,
      sym_identifier,
  [362393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17984), 1,
      anon_sym_SEMI,
  [362400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13205), 1,
      anon_sym_RBRACE,
  [362407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7039), 1,
      anon_sym_SEMI,
  [362414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15197), 1,
      anon_sym_SEMI,
  [362421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10627), 1,
      anon_sym_COLON,
  [362428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17986), 1,
      anon_sym_RPAREN,
  [362435] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17988), 1,
      aux_sym_preproc_if_token2,
  [362442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17990), 1,
      sym_identifier,
  [362449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17992), 1,
      anon_sym_LPAREN2,
  [362456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17994), 1,
      aux_sym_preproc_if_token2,
  [362463] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(12146), 1,
      aux_sym_preproc_include_token2,
  [362470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17996), 1,
      aux_sym_preproc_if_token2,
  [362477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17998), 1,
      anon_sym_RPAREN,
  [362484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18000), 1,
      anon_sym_RPAREN,
  [362491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18002), 1,
      sym_identifier,
  [362498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18004), 1,
      sym_raw_string_content,
  [362505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18006), 1,
      anon_sym_SEMI,
  [362512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18008), 1,
      aux_sym_preproc_if_token2,
  [362519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8350), 1,
      anon_sym_RPAREN,
  [362526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18010), 1,
      anon_sym_SEMI,
  [362533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10593), 1,
      anon_sym_SEMI,
  [362540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18012), 1,
      anon_sym_SEMI,
  [362547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15129), 1,
      anon_sym_SEMI,
  [362554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18014), 1,
      anon_sym_LPAREN2,
  [362561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18016), 1,
      anon_sym_SEMI,
  [362568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18018), 1,
      aux_sym_preproc_if_token2,
  [362575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_DASH,
  [362582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18020), 1,
      aux_sym_preproc_if_token2,
  [362589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18022), 1,
      anon_sym_RPAREN,
  [362596] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(18024), 1,
      aux_sym_preproc_include_token2,
  [362603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18026), 1,
      anon_sym_SEMI,
  [362610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18028), 1,
      anon_sym_RBRACE,
  [362617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18030), 1,
      anon_sym_RPAREN,
  [362624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18032), 1,
      anon_sym_RPAREN,
  [362631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14425), 1,
      anon_sym_LBRACE,
  [362638] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18034), 1,
      anon_sym_SEMI,
  [362645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18036), 1,
      anon_sym_COLON,
  [362652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18038), 1,
      anon_sym_SEMI,
  [362659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10697), 1,
      anon_sym_RPAREN,
  [362666] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18040), 1,
      anon_sym_LBRACE,
  [362673] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18042), 1,
      aux_sym_preproc_if_token2,
  [362680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18044), 1,
      anon_sym_COLON,
  [362687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18046), 1,
      anon_sym_RPAREN,
  [362694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18048), 1,
      anon_sym_RPAREN,
  [362701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18050), 1,
      anon_sym_COLON,
  [362708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18052), 1,
      sym_raw_string_delimiter,
  [362715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18054), 1,
      aux_sym_preproc_if_token2,
  [362722] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18056), 1,
      anon_sym_RPAREN,
  [362729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18058), 1,
      anon_sym_SEMI,
  [362736] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18060), 1,
      anon_sym_SEMI,
  [362743] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18062), 1,
      sym_identifier,
  [362750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18064), 1,
      anon_sym_RPAREN,
  [362757] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18066), 1,
      anon_sym_SEMI,
  [362764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18068), 1,
      anon_sym_SEMI,
  [362771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13955), 1,
      anon_sym_LBRACE,
  [362778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18070), 1,
      anon_sym_SEMI,
  [362785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18072), 1,
      sym_identifier,
  [362792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16746), 1,
      anon_sym_RBRACE,
  [362799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18074), 1,
      anon_sym_SEMI,
  [362806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18076), 1,
      anon_sym_DQUOTE,
  [362813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18078), 1,
      anon_sym_STAR,
  [362820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_EQ,
  [362827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18080), 1,
      anon_sym_RPAREN,
  [362834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18082), 1,
      sym_identifier,
  [362841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18084), 1,
      anon_sym_RPAREN,
  [362848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18086), 1,
      aux_sym_preproc_if_token2,
  [362855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18088), 1,
      sym_raw_string_content,
  [362862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7013), 1,
      anon_sym_SEMI,
  [362869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18090), 1,
      anon_sym_RPAREN,
  [362876] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(16555), 1,
      aux_sym_preproc_include_token2,
  [362883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18092), 1,
      aux_sym_preproc_if_token2,
  [362890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18094), 1,
      anon_sym_RPAREN,
  [362897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18096), 1,
      anon_sym_RPAREN,
  [362904] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(18098), 1,
      aux_sym_preproc_include_token2,
  [362911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_PLUS,
  [362918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18100), 1,
      anon_sym_RPAREN,
  [362925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8478), 1,
      anon_sym_RPAREN,
  [362932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18102), 1,
      anon_sym_SEMI,
  [362939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7035), 1,
      anon_sym_SEMI,
  [362946] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18104), 1,
      anon_sym_RPAREN,
  [362953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18106), 1,
      anon_sym_RPAREN,
  [362960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18108), 1,
      anon_sym_RPAREN,
  [362967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18110), 1,
      anon_sym_RPAREN,
  [362974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18112), 1,
      aux_sym_preproc_if_token2,
  [362981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18114), 1,
      anon_sym_RPAREN,
  [362988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_STAR,
  [362995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18116), 1,
      anon_sym_LBRACE,
  [363002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18118), 1,
      anon_sym_LBRACE,
  [363009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18120), 1,
      anon_sym_RPAREN,
  [363016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18122), 1,
      anon_sym_SEMI,
  [363023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18124), 1,
      anon_sym_STAR,
  [363030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18126), 1,
      sym_identifier,
  [363037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18128), 1,
      anon_sym_DQUOTE,
  [363044] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18130), 1,
      anon_sym_RPAREN,
  [363051] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18132), 1,
      anon_sym_SEMI,
  [363058] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18134), 1,
      anon_sym_DQUOTE,
  [363065] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18136), 1,
      anon_sym_DQUOTE,
  [363072] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18138), 1,
      anon_sym_SEMI,
  [363079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18140), 1,
      sym_raw_string_delimiter,
  [363086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18142), 1,
      sym_identifier,
  [363093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10633), 1,
      anon_sym_COLON,
  [363100] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18144), 1,
      anon_sym_LBRACE,
  [363107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18146), 1,
      anon_sym_RPAREN,
  [363114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18148), 1,
      sym_raw_string_delimiter,
  [363121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18150), 1,
      anon_sym_SEMI,
  [363128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10675), 1,
      anon_sym_RPAREN,
  [363135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10350), 1,
      anon_sym_RBRACE,
  [363142] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18152), 1,
      anon_sym_SEMI,
  [363149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18154), 1,
      sym_identifier,
  [363156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18156), 1,
      anon_sym_SEMI,
  [363163] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18158), 1,
      sym_identifier,
  [363170] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18160), 1,
      anon_sym_COLON,
  [363177] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18162), 1,
      aux_sym_preproc_if_token2,
  [363184] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18164), 1,
      anon_sym_DQUOTE,
  [363191] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18166), 1,
      anon_sym_SEMI,
  [363198] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18168), 1,
      aux_sym_preproc_if_token2,
  [363205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14076), 1,
      anon_sym_SEMI,
  [363212] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18170), 1,
      anon_sym_RPAREN,
  [363219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18172), 1,
      anon_sym_LBRACE,
  [363226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18174), 1,
      anon_sym_DQUOTE,
  [363233] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18176), 1,
      sym_identifier,
  [363240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18178), 1,
      anon_sym_SEMI,
  [363247] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18180), 1,
      anon_sym_LBRACE,
  [363254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18182), 1,
      anon_sym_SEMI,
  [363261] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15031), 1,
      anon_sym_SEMI,
  [363268] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13957), 1,
      anon_sym_LBRACE,
  [363275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18184), 1,
      sym_identifier,
  [363282] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18186), 1,
      sym_identifier,
  [363289] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10495), 1,
      anon_sym_SEMI,
  [363296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18188), 1,
      anon_sym_RPAREN,
  [363303] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13317), 1,
      anon_sym_RBRACE,
  [363310] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18190), 1,
      anon_sym_RPAREN,
  [363317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18192), 1,
      aux_sym_preproc_if_token2,
  [363324] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18194), 1,
      anon_sym_SEMI,
  [363331] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9204), 1,
      sym_identifier,
  [363338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18196), 1,
      anon_sym_RPAREN,
  [363345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10635), 1,
      anon_sym_COLON,
  [363352] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18198), 1,
      anon_sym_RPAREN,
  [363359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18200), 1,
      aux_sym_preproc_if_token2,
  [363366] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18202), 1,
      anon_sym_LPAREN2,
  [363373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18204), 1,
      anon_sym_LPAREN2,
  [363380] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18206), 1,
      sym_identifier,
  [363387] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18208), 1,
      anon_sym_RPAREN,
  [363394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18210), 1,
      anon_sym_RPAREN,
  [363401] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18212), 1,
      anon_sym_RPAREN,
  [363408] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18214), 1,
      anon_sym_LPAREN2,
  [363415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18216), 1,
      anon_sym_RPAREN,
  [363422] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18218), 1,
      anon_sym_SEMI,
  [363429] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18220), 1,
      sym_identifier,
  [363436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18222), 1,
      sym_raw_string_content,
  [363443] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18224), 1,
      anon_sym_COLON,
  [363450] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18226), 1,
      anon_sym_RPAREN,
  [363457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18228), 1,
      sym_raw_string_delimiter,
  [363464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18230), 1,
      anon_sym_RPAREN,
  [363471] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18232), 1,
      anon_sym_COMMA,
  [363478] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18234), 1,
      anon_sym_STAR,
  [363485] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18236), 1,
      anon_sym_LPAREN2,
  [363492] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18238), 1,
      anon_sym_LPAREN2,
  [363499] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18240), 1,
      sym_identifier,
  [363506] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18242), 1,
      anon_sym_RPAREN,
  [363513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18244), 1,
      anon_sym_DQUOTE,
  [363520] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18246), 1,
      anon_sym_LPAREN2,
  [363527] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18248), 1,
      sym_identifier,
  [363534] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18250), 1,
      sym_raw_string_content,
  [363541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10507), 1,
      anon_sym_SEMI,
  [363548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18252), 1,
      anon_sym_SEMI,
  [363555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18254), 1,
      anon_sym_SEMI,
  [363562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18256), 1,
      anon_sym_LPAREN2,
  [363569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18258), 1,
      sym_identifier,
  [363576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6636), 1,
      anon_sym_SEMI,
  [363583] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10765), 1,
      anon_sym_RPAREN,
  [363590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18260), 1,
      sym_identifier,
  [363597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18262), 1,
      sym_raw_string_content,
  [363604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18264), 1,
      anon_sym_SEMI,
  [363611] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10515), 1,
      anon_sym_RPAREN,
  [363618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18266), 1,
      anon_sym_LPAREN2,
  [363625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18268), 1,
      sym_identifier,
  [363632] = 2,
    ACTIONS(7160), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11965), 1,
      sym_comment,
  [363639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10571), 1,
      anon_sym_SEMI,
  [363646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18270), 1,
      sym_identifier,
  [363653] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18272), 1,
      sym_raw_string_content,
  [363660] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18274), 1,
      sym_identifier,
  [363667] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18276), 1,
      anon_sym_LPAREN2,
  [363674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18278), 1,
      sym_identifier,
  [363681] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18280), 1,
      anon_sym_RPAREN,
  [363688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18282), 1,
      sym_identifier,
  [363695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18284), 1,
      sym_raw_string_content,
  [363702] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18286), 1,
      anon_sym_RPAREN,
  [363709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18288), 1,
      sym_identifier,
  [363716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18290), 1,
      sym_raw_string_content,
  [363723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18292), 1,
      anon_sym_SEMI,
  [363730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18294), 1,
      sym_raw_string_content,
  [363737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_STAR_EQ,
  [363744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18296), 1,
      sym_raw_string_content,
  [363751] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18298), 1,
      sym_raw_string_delimiter,
  [363758] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18300), 1,
      sym_raw_string_content,
  [363765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15954), 1,
      anon_sym_COLON_COLON,
  [363772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18302), 1,
      sym_raw_string_content,
  [363779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18304), 1,
      anon_sym_LBRACE,
  [363786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18306), 1,
      sym_raw_string_content,
  [363793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18308), 1,
      anon_sym_SEMI,
  [363800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18310), 1,
      sym_raw_string_content,
  [363807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18312), 1,
      anon_sym_DOT_DOT_DOT,
  [363814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18315), 1,
      sym_raw_string_content,
  [363821] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18317), 1,
      anon_sym_STAR,
  [363828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18319), 1,
      sym_raw_string_content,
  [363835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18321), 1,
      anon_sym_COLON,
  [363842] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18323), 1,
      sym_raw_string_content,
  [363849] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18325), 1,
      anon_sym_LPAREN2,
  [363856] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18327), 1,
      anon_sym_LPAREN2,
  [363863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18329), 1,
      anon_sym_DQUOTE,
  [363870] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18331), 1,
      anon_sym_SLASH,
  [363877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18333), 1,
      anon_sym_LPAREN2,
  [363884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10517), 1,
      anon_sym_COLON,
  [363891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18335), 1,
      aux_sym_preproc_if_token2,
  [363898] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18337), 1,
      anon_sym_LPAREN2,
  [363905] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18339), 1,
      anon_sym_LPAREN2,
  [363912] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18341), 1,
      anon_sym_LPAREN2,
  [363919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18343), 1,
      anon_sym_LPAREN2,
  [363926] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18345), 1,
      anon_sym_LPAREN2,
  [363933] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8874), 1,
      sym_identifier,
  [363940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18347), 1,
      anon_sym_LPAREN2,
  [363947] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18349), 1,
      anon_sym_LPAREN2,
  [363954] = 2,
    ACTIONS(11965), 1,
      sym_comment,
    ACTIONS(18351), 1,
      aux_sym_preproc_include_token2,
  [363961] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18353), 1,
      anon_sym_LPAREN2,
  [363968] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18355), 1,
      anon_sym_LPAREN2,
  [363975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18357), 1,
      anon_sym_LPAREN2,
  [363982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18359), 1,
      anon_sym_LPAREN2,
  [363989] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18361), 1,
      anon_sym_LPAREN2,
  [363996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18363), 1,
      anon_sym_LPAREN2,
  [364003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18365), 1,
      anon_sym_LPAREN2,
  [364010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18367), 1,
      anon_sym_LPAREN2,
  [364017] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18369), 1,
      anon_sym_LPAREN2,
  [364024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18371), 1,
      anon_sym_LPAREN2,
  [364031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18373), 1,
      anon_sym_LPAREN2,
  [364038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18375), 1,
      anon_sym_SEMI,
  [364045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18377), 1,
      aux_sym_preproc_if_token2,
  [364052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18379), 1,
      anon_sym_RPAREN,
  [364059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16786), 1,
      anon_sym_RBRACE,
  [364066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(16912), 1,
      anon_sym_not_eq,
  [364073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18381), 1,
      anon_sym_LPAREN2,
  [364080] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18383), 1,
      anon_sym_LPAREN2,
  [364087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18385), 1,
      anon_sym_LPAREN2,
  [364094] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18387), 1,
      anon_sym_LPAREN2,
  [364101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18389), 1,
      anon_sym_LPAREN2,
  [364108] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(18391), 1,
      anon_sym_EQ,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(3482)] = 0,
  [SMALL_STATE(3483)] = 71,
  [SMALL_STATE(3484)] = 156,
  [SMALL_STATE(3485)] = 227,
  [SMALL_STATE(3486)] = 304,
  [SMALL_STATE(3487)] = 375,
  [SMALL_STATE(3488)] = 460,
  [SMALL_STATE(3489)] = 549,
  [SMALL_STATE(3490)] = 620,
  [SMALL_STATE(3491)] = 693,
  [SMALL_STATE(3492)] = 766,
  [SMALL_STATE(3493)] = 837,
  [SMALL_STATE(3494)] = 912,
  [SMALL_STATE(3495)] = 985,
  [SMALL_STATE(3496)] = 1058,
  [SMALL_STATE(3497)] = 1129,
  [SMALL_STATE(3498)] = 1200,
  [SMALL_STATE(3499)] = 1277,
  [SMALL_STATE(3500)] = 1348,
  [SMALL_STATE(3501)] = 1425,
  [SMALL_STATE(3502)] = 1504,
  [SMALL_STATE(3503)] = 1577,
  [SMALL_STATE(3504)] = 1652,
  [SMALL_STATE(3505)] = 1727,
  [SMALL_STATE(3506)] = 1798,
  [SMALL_STATE(3507)] = 1873,
  [SMALL_STATE(3508)] = 1948,
  [SMALL_STATE(3509)] = 2023,
  [SMALL_STATE(3510)] = 2098,
  [SMALL_STATE(3511)] = 2173,
  [SMALL_STATE(3512)] = 2248,
  [SMALL_STATE(3513)] = 2323,
  [SMALL_STATE(3514)] = 2398,
  [SMALL_STATE(3515)] = 2473,
  [SMALL_STATE(3516)] = 2544,
  [SMALL_STATE(3517)] = 2619,
  [SMALL_STATE(3518)] = 2694,
  [SMALL_STATE(3519)] = 2775,
  [SMALL_STATE(3520)] = 2845,
  [SMALL_STATE(3521)] = 2919,
  [SMALL_STATE(3522)] = 2993,
  [SMALL_STATE(3523)] = 3063,
  [SMALL_STATE(3524)] = 3133,
  [SMALL_STATE(3525)] = 3217,
  [SMALL_STATE(3526)] = 3301,
  [SMALL_STATE(3527)] = 3379,
  [SMALL_STATE(3528)] = 3457,
  [SMALL_STATE(3529)] = 3529,
  [SMALL_STATE(3530)] = 3649,
  [SMALL_STATE(3531)] = 3769,
  [SMALL_STATE(3532)] = 3847,
  [SMALL_STATE(3533)] = 3917,
  [SMALL_STATE(3534)] = 3987,
  [SMALL_STATE(3535)] = 4057,
  [SMALL_STATE(3536)] = 4131,
  [SMALL_STATE(3537)] = 4201,
  [SMALL_STATE(3538)] = 4271,
  [SMALL_STATE(3539)] = 4343,
  [SMALL_STATE(3540)] = 4415,
  [SMALL_STATE(3541)] = 4542,
  [SMALL_STATE(3542)] = 4615,
  [SMALL_STATE(3543)] = 4688,
  [SMALL_STATE(3544)] = 4761,
  [SMALL_STATE(3545)] = 4834,
  [SMALL_STATE(3546)] = 4907,
  [SMALL_STATE(3547)] = 4980,
  [SMALL_STATE(3548)] = 5053,
  [SMALL_STATE(3549)] = 5128,
  [SMALL_STATE(3550)] = 5197,
  [SMALL_STATE(3551)] = 5270,
  [SMALL_STATE(3552)] = 5397,
  [SMALL_STATE(3553)] = 5466,
  [SMALL_STATE(3554)] = 5539,
  [SMALL_STATE(3555)] = 5608,
  [SMALL_STATE(3556)] = 5681,
  [SMALL_STATE(3557)] = 5756,
  [SMALL_STATE(3558)] = 5829,
  [SMALL_STATE(3559)] = 5908,
  [SMALL_STATE(3560)] = 5981,
  [SMALL_STATE(3561)] = 6054,
  [SMALL_STATE(3562)] = 6133,
  [SMALL_STATE(3563)] = 6212,
  [SMALL_STATE(3564)] = 6281,
  [SMALL_STATE(3565)] = 6350,
  [SMALL_STATE(3566)] = 6423,
  [SMALL_STATE(3567)] = 6496,
  [SMALL_STATE(3568)] = 6570,
  [SMALL_STATE(3569)] = 6688,
  [SMALL_STATE(3570)] = 6756,
  [SMALL_STATE(3571)] = 6824,
  [SMALL_STATE(3572)] = 6894,
  [SMALL_STATE(3573)] = 6968,
  [SMALL_STATE(3574)] = 7036,
  [SMALL_STATE(3575)] = 7110,
  [SMALL_STATE(3576)] = 7184,
  [SMALL_STATE(3577)] = 7252,
  [SMALL_STATE(3578)] = 7320,
  [SMALL_STATE(3579)] = 7400,
  [SMALL_STATE(3580)] = 7474,
  [SMALL_STATE(3581)] = 7542,
  [SMALL_STATE(3582)] = 7616,
  [SMALL_STATE(3583)] = 7690,
  [SMALL_STATE(3584)] = 7770,
  [SMALL_STATE(3585)] = 7844,
  [SMALL_STATE(3586)] = 7912,
  [SMALL_STATE(3587)] = 8030,
  [SMALL_STATE(3588)] = 8112,
  [SMALL_STATE(3589)] = 8180,
  [SMALL_STATE(3590)] = 8248,
  [SMALL_STATE(3591)] = 8374,
  [SMALL_STATE(3592)] = 8456,
  [SMALL_STATE(3593)] = 8524,
  [SMALL_STATE(3594)] = 8596,
  [SMALL_STATE(3595)] = 8664,
  [SMALL_STATE(3596)] = 8732,
  [SMALL_STATE(3597)] = 8806,
  [SMALL_STATE(3598)] = 8882,
  [SMALL_STATE(3599)] = 8950,
  [SMALL_STATE(3600)] = 9024,
  [SMALL_STATE(3601)] = 9096,
  [SMALL_STATE(3602)] = 9176,
  [SMALL_STATE(3603)] = 9256,
  [SMALL_STATE(3604)] = 9324,
  [SMALL_STATE(3605)] = 9402,
  [SMALL_STATE(3606)] = 9476,
  [SMALL_STATE(3607)] = 9594,
  [SMALL_STATE(3608)] = 9672,
  [SMALL_STATE(3609)] = 9798,
  [SMALL_STATE(3610)] = 9866,
  [SMALL_STATE(3611)] = 9934,
  [SMALL_STATE(3612)] = 10008,
  [SMALL_STATE(3613)] = 10082,
  [SMALL_STATE(3614)] = 10200,
  [SMALL_STATE(3615)] = 10274,
  [SMALL_STATE(3616)] = 10379,
  [SMALL_STATE(3617)] = 10504,
  [SMALL_STATE(3618)] = 10571,
  [SMALL_STATE(3619)] = 10638,
  [SMALL_STATE(3620)] = 10705,
  [SMALL_STATE(3621)] = 10776,
  [SMALL_STATE(3622)] = 10849,
  [SMALL_STATE(3623)] = 10922,
  [SMALL_STATE(3624)] = 11047,
  [SMALL_STATE(3625)] = 11160,
  [SMALL_STATE(3626)] = 11273,
  [SMALL_STATE(3627)] = 11346,
  [SMALL_STATE(3628)] = 11429,
  [SMALL_STATE(3629)] = 11514,
  [SMALL_STATE(3630)] = 11601,
  [SMALL_STATE(3631)] = 11674,
  [SMALL_STATE(3632)] = 11747,
  [SMALL_STATE(3633)] = 11820,
  [SMALL_STATE(3634)] = 11893,
  [SMALL_STATE(3635)] = 11966,
  [SMALL_STATE(3636)] = 12039,
  [SMALL_STATE(3637)] = 12112,
  [SMALL_STATE(3638)] = 12185,
  [SMALL_STATE(3639)] = 12258,
  [SMALL_STATE(3640)] = 12375,
  [SMALL_STATE(3641)] = 12442,
  [SMALL_STATE(3642)] = 12509,
  [SMALL_STATE(3643)] = 12576,
  [SMALL_STATE(3644)] = 12643,
  [SMALL_STATE(3645)] = 12710,
  [SMALL_STATE(3646)] = 12827,
  [SMALL_STATE(3647)] = 12894,
  [SMALL_STATE(3648)] = 12961,
  [SMALL_STATE(3649)] = 13028,
  [SMALL_STATE(3650)] = 13107,
  [SMALL_STATE(3651)] = 13186,
  [SMALL_STATE(3652)] = 13253,
  [SMALL_STATE(3653)] = 13320,
  [SMALL_STATE(3654)] = 13387,
  [SMALL_STATE(3655)] = 13500,
  [SMALL_STATE(3656)] = 13617,
  [SMALL_STATE(3657)] = 13726,
  [SMALL_STATE(3658)] = 13805,
  [SMALL_STATE(3659)] = 13918,
  [SMALL_STATE(3660)] = 14021,
  [SMALL_STATE(3661)] = 14122,
  [SMALL_STATE(3662)] = 14221,
  [SMALL_STATE(3663)] = 14300,
  [SMALL_STATE(3664)] = 14395,
  [SMALL_STATE(3665)] = 14486,
  [SMALL_STATE(3666)] = 14553,
  [SMALL_STATE(3667)] = 14620,
  [SMALL_STATE(3668)] = 14733,
  [SMALL_STATE(3669)] = 14800,
  [SMALL_STATE(3670)] = 14866,
  [SMALL_STATE(3671)] = 14932,
  [SMALL_STATE(3672)] = 14998,
  [SMALL_STATE(3673)] = 15064,
  [SMALL_STATE(3674)] = 15130,
  [SMALL_STATE(3675)] = 15198,
  [SMALL_STATE(3676)] = 15264,
  [SMALL_STATE(3677)] = 15388,
  [SMALL_STATE(3678)] = 15456,
  [SMALL_STATE(3679)] = 15524,
  [SMALL_STATE(3680)] = 15590,
  [SMALL_STATE(3681)] = 15656,
  [SMALL_STATE(3682)] = 15722,
  [SMALL_STATE(3683)] = 15788,
  [SMALL_STATE(3684)] = 15854,
  [SMALL_STATE(3685)] = 15920,
  [SMALL_STATE(3686)] = 15986,
  [SMALL_STATE(3687)] = 16054,
  [SMALL_STATE(3688)] = 16178,
  [SMALL_STATE(3689)] = 16244,
  [SMALL_STATE(3690)] = 16310,
  [SMALL_STATE(3691)] = 16376,
  [SMALL_STATE(3692)] = 16442,
  [SMALL_STATE(3693)] = 16510,
  [SMALL_STATE(3694)] = 16576,
  [SMALL_STATE(3695)] = 16642,
  [SMALL_STATE(3696)] = 16708,
  [SMALL_STATE(3697)] = 16774,
  [SMALL_STATE(3698)] = 16840,
  [SMALL_STATE(3699)] = 16906,
  [SMALL_STATE(3700)] = 16982,
  [SMALL_STATE(3701)] = 17048,
  [SMALL_STATE(3702)] = 17114,
  [SMALL_STATE(3703)] = 17180,
  [SMALL_STATE(3704)] = 17246,
  [SMALL_STATE(3705)] = 17314,
  [SMALL_STATE(3706)] = 17380,
  [SMALL_STATE(3707)] = 17446,
  [SMALL_STATE(3708)] = 17512,
  [SMALL_STATE(3709)] = 17588,
  [SMALL_STATE(3710)] = 17654,
  [SMALL_STATE(3711)] = 17720,
  [SMALL_STATE(3712)] = 17786,
  [SMALL_STATE(3713)] = 17863,
  [SMALL_STATE(3714)] = 17936,
  [SMALL_STATE(3715)] = 18007,
  [SMALL_STATE(3716)] = 18072,
  [SMALL_STATE(3717)] = 18147,
  [SMALL_STATE(3718)] = 18212,
  [SMALL_STATE(3719)] = 18289,
  [SMALL_STATE(3720)] = 18354,
  [SMALL_STATE(3721)] = 18419,
  [SMALL_STATE(3722)] = 18582,
  [SMALL_STATE(3723)] = 18647,
  [SMALL_STATE(3724)] = 18718,
  [SMALL_STATE(3725)] = 18787,
  [SMALL_STATE(3726)] = 18852,
  [SMALL_STATE(3727)] = 18917,
  [SMALL_STATE(3728)] = 19040,
  [SMALL_STATE(3729)] = 19111,
  [SMALL_STATE(3730)] = 19176,
  [SMALL_STATE(3731)] = 19247,
  [SMALL_STATE(3732)] = 19312,
  [SMALL_STATE(3733)] = 19377,
  [SMALL_STATE(3734)] = 19442,
  [SMALL_STATE(3735)] = 19513,
  [SMALL_STATE(3736)] = 19580,
  [SMALL_STATE(3737)] = 19645,
  [SMALL_STATE(3738)] = 19722,
  [SMALL_STATE(3739)] = 19787,
  [SMALL_STATE(3740)] = 19858,
  [SMALL_STATE(3741)] = 19973,
  [SMALL_STATE(3742)] = 20040,
  [SMALL_STATE(3743)] = 20105,
  [SMALL_STATE(3744)] = 20182,
  [SMALL_STATE(3745)] = 20247,
  [SMALL_STATE(3746)] = 20410,
  [SMALL_STATE(3747)] = 20475,
  [SMALL_STATE(3748)] = 20540,
  [SMALL_STATE(3749)] = 20609,
  [SMALL_STATE(3750)] = 20674,
  [SMALL_STATE(3751)] = 20747,
  [SMALL_STATE(3752)] = 20816,
  [SMALL_STATE(3753)] = 20887,
  [SMALL_STATE(3754)] = 20952,
  [SMALL_STATE(3755)] = 21017,
  [SMALL_STATE(3756)] = 21140,
  [SMALL_STATE(3757)] = 21211,
  [SMALL_STATE(3758)] = 21326,
  [SMALL_STATE(3759)] = 21391,
  [SMALL_STATE(3760)] = 21456,
  [SMALL_STATE(3761)] = 21521,
  [SMALL_STATE(3762)] = 21602,
  [SMALL_STATE(3763)] = 21709,
  [SMALL_STATE(3764)] = 21812,
  [SMALL_STATE(3765)] = 21911,
  [SMALL_STATE(3766)] = 21976,
  [SMALL_STATE(3767)] = 22041,
  [SMALL_STATE(3768)] = 22164,
  [SMALL_STATE(3769)] = 22229,
  [SMALL_STATE(3770)] = 22326,
  [SMALL_STATE(3771)] = 22391,
  [SMALL_STATE(3772)] = 22484,
  [SMALL_STATE(3773)] = 22575,
  [SMALL_STATE(3774)] = 22686,
  [SMALL_STATE(3775)] = 22751,
  [SMALL_STATE(3776)] = 22838,
  [SMALL_STATE(3777)] = 22909,
  [SMALL_STATE(3778)] = 23020,
  [SMALL_STATE(3779)] = 23091,
  [SMALL_STATE(3780)] = 23166,
  [SMALL_STATE(3781)] = 23231,
  [SMALL_STATE(3782)] = 23314,
  [SMALL_STATE(3783)] = 23379,
  [SMALL_STATE(3784)] = 23450,
  [SMALL_STATE(3785)] = 23521,
  [SMALL_STATE(3786)] = 23586,
  [SMALL_STATE(3787)] = 23671,
  [SMALL_STATE(3788)] = 23736,
  [SMALL_STATE(3789)] = 23801,
  [SMALL_STATE(3790)] = 23964,
  [SMALL_STATE(3791)] = 24037,
  [SMALL_STATE(3792)] = 24102,
  [SMALL_STATE(3793)] = 24213,
  [SMALL_STATE(3794)] = 24288,
  [SMALL_STATE(3795)] = 24399,
  [SMALL_STATE(3796)] = 24514,
  [SMALL_STATE(3797)] = 24579,
  [SMALL_STATE(3798)] = 24690,
  [SMALL_STATE(3799)] = 24765,
  [SMALL_STATE(3800)] = 24840,
  [SMALL_STATE(3801)] = 24963,
  [SMALL_STATE(3802)] = 25028,
  [SMALL_STATE(3803)] = 25092,
  [SMALL_STATE(3804)] = 25160,
  [SMALL_STATE(3805)] = 25224,
  [SMALL_STATE(3806)] = 25288,
  [SMALL_STATE(3807)] = 25352,
  [SMALL_STATE(3808)] = 25416,
  [SMALL_STATE(3809)] = 25528,
  [SMALL_STATE(3810)] = 25596,
  [SMALL_STATE(3811)] = 25668,
  [SMALL_STATE(3812)] = 25732,
  [SMALL_STATE(3813)] = 25834,
  [SMALL_STATE(3814)] = 25898,
  [SMALL_STATE(3815)] = 25962,
  [SMALL_STATE(3816)] = 26026,
  [SMALL_STATE(3817)] = 26090,
  [SMALL_STATE(3818)] = 26154,
  [SMALL_STATE(3819)] = 26218,
  [SMALL_STATE(3820)] = 26292,
  [SMALL_STATE(3821)] = 26356,
  [SMALL_STATE(3822)] = 26420,
  [SMALL_STATE(3823)] = 26534,
  [SMALL_STATE(3824)] = 26632,
  [SMALL_STATE(3825)] = 26696,
  [SMALL_STATE(3826)] = 26760,
  [SMALL_STATE(3827)] = 26856,
  [SMALL_STATE(3828)] = 26948,
  [SMALL_STATE(3829)] = 27012,
  [SMALL_STATE(3830)] = 27076,
  [SMALL_STATE(3831)] = 27140,
  [SMALL_STATE(3832)] = 27204,
  [SMALL_STATE(3833)] = 27294,
  [SMALL_STATE(3834)] = 27408,
  [SMALL_STATE(3835)] = 27522,
  [SMALL_STATE(3836)] = 27586,
  [SMALL_STATE(3837)] = 27650,
  [SMALL_STATE(3838)] = 27714,
  [SMALL_STATE(3839)] = 27778,
  [SMALL_STATE(3840)] = 27842,
  [SMALL_STATE(3841)] = 27906,
  [SMALL_STATE(3842)] = 27976,
  [SMALL_STATE(3843)] = 28040,
  [SMALL_STATE(3844)] = 28104,
  [SMALL_STATE(3845)] = 28174,
  [SMALL_STATE(3846)] = 28240,
  [SMALL_STATE(3847)] = 28304,
  [SMALL_STATE(3848)] = 28368,
  [SMALL_STATE(3849)] = 28432,
  [SMALL_STATE(3850)] = 28502,
  [SMALL_STATE(3851)] = 28612,
  [SMALL_STATE(3852)] = 28676,
  [SMALL_STATE(3853)] = 28740,
  [SMALL_STATE(3854)] = 28808,
  [SMALL_STATE(3855)] = 28872,
  [SMALL_STATE(3856)] = 28952,
  [SMALL_STATE(3857)] = 29074,
  [SMALL_STATE(3858)] = 29190,
  [SMALL_STATE(3859)] = 29258,
  [SMALL_STATE(3860)] = 29332,
  [SMALL_STATE(3861)] = 29442,
  [SMALL_STATE(3862)] = 29552,
  [SMALL_STATE(3863)] = 29632,
  [SMALL_STATE(3864)] = 29714,
  [SMALL_STATE(3865)] = 29788,
  [SMALL_STATE(3866)] = 29872,
  [SMALL_STATE(3867)] = 29942,
  [SMALL_STATE(3868)] = 30016,
  [SMALL_STATE(3869)] = 30090,
  [SMALL_STATE(3870)] = 30206,
  [SMALL_STATE(3871)] = 30320,
  [SMALL_STATE(3872)] = 30392,
  [SMALL_STATE(3873)] = 30504,
  [SMALL_STATE(3874)] = 30626,
  [SMALL_STATE(3875)] = 30690,
  [SMALL_STATE(3876)] = 30754,
  [SMALL_STATE(3877)] = 30860,
  [SMALL_STATE(3878)] = 30970,
  [SMALL_STATE(3879)] = 31034,
  [SMALL_STATE(3880)] = 31144,
  [SMALL_STATE(3881)] = 31208,
  [SMALL_STATE(3882)] = 31272,
  [SMALL_STATE(3883)] = 31342,
  [SMALL_STATE(3884)] = 31464,
  [SMALL_STATE(3885)] = 31528,
  [SMALL_STATE(3886)] = 31614,
  [SMALL_STATE(3887)] = 31725,
  [SMALL_STATE(3888)] = 31836,
  [SMALL_STATE(3889)] = 31947,
  [SMALL_STATE(3890)] = 32010,
  [SMALL_STATE(3891)] = 32077,
  [SMALL_STATE(3892)] = 32188,
  [SMALL_STATE(3893)] = 32269,
  [SMALL_STATE(3894)] = 32380,
  [SMALL_STATE(3895)] = 32491,
  [SMALL_STATE(3896)] = 32602,
  [SMALL_STATE(3897)] = 32713,
  [SMALL_STATE(3898)] = 32824,
  [SMALL_STATE(3899)] = 32933,
  [SMALL_STATE(3900)] = 33044,
  [SMALL_STATE(3901)] = 33155,
  [SMALL_STATE(3902)] = 33266,
  [SMALL_STATE(3903)] = 33377,
  [SMALL_STATE(3904)] = 33488,
  [SMALL_STATE(3905)] = 33599,
  [SMALL_STATE(3906)] = 33710,
  [SMALL_STATE(3907)] = 33821,
  [SMALL_STATE(3908)] = 33932,
  [SMALL_STATE(3909)] = 34043,
  [SMALL_STATE(3910)] = 34154,
  [SMALL_STATE(3911)] = 34265,
  [SMALL_STATE(3912)] = 34376,
  [SMALL_STATE(3913)] = 34487,
  [SMALL_STATE(3914)] = 34598,
  [SMALL_STATE(3915)] = 34709,
  [SMALL_STATE(3916)] = 34820,
  [SMALL_STATE(3917)] = 34931,
  [SMALL_STATE(3918)] = 35042,
  [SMALL_STATE(3919)] = 35153,
  [SMALL_STATE(3920)] = 35218,
  [SMALL_STATE(3921)] = 35329,
  [SMALL_STATE(3922)] = 35440,
  [SMALL_STATE(3923)] = 35551,
  [SMALL_STATE(3924)] = 35622,
  [SMALL_STATE(3925)] = 35685,
  [SMALL_STATE(3926)] = 35752,
  [SMALL_STATE(3927)] = 35863,
  [SMALL_STATE(3928)] = 35976,
  [SMALL_STATE(3929)] = 36085,
  [SMALL_STATE(3930)] = 36196,
  [SMALL_STATE(3931)] = 36307,
  [SMALL_STATE(3932)] = 36418,
  [SMALL_STATE(3933)] = 36529,
  [SMALL_STATE(3934)] = 36640,
  [SMALL_STATE(3935)] = 36751,
  [SMALL_STATE(3936)] = 36862,
  [SMALL_STATE(3937)] = 36973,
  [SMALL_STATE(3938)] = 37084,
  [SMALL_STATE(3939)] = 37195,
  [SMALL_STATE(3940)] = 37306,
  [SMALL_STATE(3941)] = 37417,
  [SMALL_STATE(3942)] = 37528,
  [SMALL_STATE(3943)] = 37639,
  [SMALL_STATE(3944)] = 37750,
  [SMALL_STATE(3945)] = 37861,
  [SMALL_STATE(3946)] = 37972,
  [SMALL_STATE(3947)] = 38083,
  [SMALL_STATE(3948)] = 38194,
  [SMALL_STATE(3949)] = 38267,
  [SMALL_STATE(3950)] = 38378,
  [SMALL_STATE(3951)] = 38489,
  [SMALL_STATE(3952)] = 38600,
  [SMALL_STATE(3953)] = 38711,
  [SMALL_STATE(3954)] = 38822,
  [SMALL_STATE(3955)] = 38933,
  [SMALL_STATE(3956)] = 39044,
  [SMALL_STATE(3957)] = 39155,
  [SMALL_STATE(3958)] = 39266,
  [SMALL_STATE(3959)] = 39377,
  [SMALL_STATE(3960)] = 39488,
  [SMALL_STATE(3961)] = 39599,
  [SMALL_STATE(3962)] = 39710,
  [SMALL_STATE(3963)] = 39821,
  [SMALL_STATE(3964)] = 39932,
  [SMALL_STATE(3965)] = 40043,
  [SMALL_STATE(3966)] = 40154,
  [SMALL_STATE(3967)] = 40217,
  [SMALL_STATE(3968)] = 40326,
  [SMALL_STATE(3969)] = 40437,
  [SMALL_STATE(3970)] = 40548,
  [SMALL_STATE(3971)] = 40659,
  [SMALL_STATE(3972)] = 40770,
  [SMALL_STATE(3973)] = 40833,
  [SMALL_STATE(3974)] = 40896,
  [SMALL_STATE(3975)] = 41007,
  [SMALL_STATE(3976)] = 41116,
  [SMALL_STATE(3977)] = 41227,
  [SMALL_STATE(3978)] = 41338,
  [SMALL_STATE(3979)] = 41449,
  [SMALL_STATE(3980)] = 41560,
  [SMALL_STATE(3981)] = 41671,
  [SMALL_STATE(3982)] = 41782,
  [SMALL_STATE(3983)] = 41893,
  [SMALL_STATE(3984)] = 42004,
  [SMALL_STATE(3985)] = 42115,
  [SMALL_STATE(3986)] = 42226,
  [SMALL_STATE(3987)] = 42337,
  [SMALL_STATE(3988)] = 42408,
  [SMALL_STATE(3989)] = 42519,
  [SMALL_STATE(3990)] = 42630,
  [SMALL_STATE(3991)] = 42741,
  [SMALL_STATE(3992)] = 42852,
  [SMALL_STATE(3993)] = 42963,
  [SMALL_STATE(3994)] = 43074,
  [SMALL_STATE(3995)] = 43185,
  [SMALL_STATE(3996)] = 43296,
  [SMALL_STATE(3997)] = 43407,
  [SMALL_STATE(3998)] = 43516,
  [SMALL_STATE(3999)] = 43625,
  [SMALL_STATE(4000)] = 43736,
  [SMALL_STATE(4001)] = 43847,
  [SMALL_STATE(4002)] = 43958,
  [SMALL_STATE(4003)] = 44069,
  [SMALL_STATE(4004)] = 44180,
  [SMALL_STATE(4005)] = 44291,
  [SMALL_STATE(4006)] = 44402,
  [SMALL_STATE(4007)] = 44513,
  [SMALL_STATE(4008)] = 44624,
  [SMALL_STATE(4009)] = 44735,
  [SMALL_STATE(4010)] = 44846,
  [SMALL_STATE(4011)] = 44957,
  [SMALL_STATE(4012)] = 45068,
  [SMALL_STATE(4013)] = 45179,
  [SMALL_STATE(4014)] = 45290,
  [SMALL_STATE(4015)] = 45401,
  [SMALL_STATE(4016)] = 45512,
  [SMALL_STATE(4017)] = 45623,
  [SMALL_STATE(4018)] = 45732,
  [SMALL_STATE(4019)] = 45843,
  [SMALL_STATE(4020)] = 45954,
  [SMALL_STATE(4021)] = 46065,
  [SMALL_STATE(4022)] = 46176,
  [SMALL_STATE(4023)] = 46287,
  [SMALL_STATE(4024)] = 46398,
  [SMALL_STATE(4025)] = 46509,
  [SMALL_STATE(4026)] = 46620,
  [SMALL_STATE(4027)] = 46731,
  [SMALL_STATE(4028)] = 46796,
  [SMALL_STATE(4029)] = 46859,
  [SMALL_STATE(4030)] = 46970,
  [SMALL_STATE(4031)] = 47081,
  [SMALL_STATE(4032)] = 47144,
  [SMALL_STATE(4033)] = 47253,
  [SMALL_STATE(4034)] = 47316,
  [SMALL_STATE(4035)] = 47385,
  [SMALL_STATE(4036)] = 47496,
  [SMALL_STATE(4037)] = 47607,
  [SMALL_STATE(4038)] = 47718,
  [SMALL_STATE(4039)] = 47829,
  [SMALL_STATE(4040)] = 47940,
  [SMALL_STATE(4041)] = 48049,
  [SMALL_STATE(4042)] = 48160,
  [SMALL_STATE(4043)] = 48227,
  [SMALL_STATE(4044)] = 48338,
  [SMALL_STATE(4045)] = 48449,
  [SMALL_STATE(4046)] = 48560,
  [SMALL_STATE(4047)] = 48671,
  [SMALL_STATE(4048)] = 48782,
  [SMALL_STATE(4049)] = 48849,
  [SMALL_STATE(4050)] = 48912,
  [SMALL_STATE(4051)] = 49023,
  [SMALL_STATE(4052)] = 49134,
  [SMALL_STATE(4053)] = 49197,
  [SMALL_STATE(4054)] = 49308,
  [SMALL_STATE(4055)] = 49419,
  [SMALL_STATE(4056)] = 49530,
  [SMALL_STATE(4057)] = 49593,
  [SMALL_STATE(4058)] = 49704,
  [SMALL_STATE(4059)] = 49813,
  [SMALL_STATE(4060)] = 49924,
  [SMALL_STATE(4061)] = 50035,
  [SMALL_STATE(4062)] = 50146,
  [SMALL_STATE(4063)] = 50257,
  [SMALL_STATE(4064)] = 50368,
  [SMALL_STATE(4065)] = 50439,
  [SMALL_STATE(4066)] = 50550,
  [SMALL_STATE(4067)] = 50613,
  [SMALL_STATE(4068)] = 50724,
  [SMALL_STATE(4069)] = 50835,
  [SMALL_STATE(4070)] = 50946,
  [SMALL_STATE(4071)] = 51055,
  [SMALL_STATE(4072)] = 51166,
  [SMALL_STATE(4073)] = 51277,
  [SMALL_STATE(4074)] = 51388,
  [SMALL_STATE(4075)] = 51499,
  [SMALL_STATE(4076)] = 51610,
  [SMALL_STATE(4077)] = 51721,
  [SMALL_STATE(4078)] = 51832,
  [SMALL_STATE(4079)] = 51943,
  [SMALL_STATE(4080)] = 52052,
  [SMALL_STATE(4081)] = 52163,
  [SMALL_STATE(4082)] = 52272,
  [SMALL_STATE(4083)] = 52383,
  [SMALL_STATE(4084)] = 52452,
  [SMALL_STATE(4085)] = 52563,
  [SMALL_STATE(4086)] = 52674,
  [SMALL_STATE(4087)] = 52785,
  [SMALL_STATE(4088)] = 52896,
  [SMALL_STATE(4089)] = 53007,
  [SMALL_STATE(4090)] = 53118,
  [SMALL_STATE(4091)] = 53229,
  [SMALL_STATE(4092)] = 53340,
  [SMALL_STATE(4093)] = 53451,
  [SMALL_STATE(4094)] = 53536,
  [SMALL_STATE(4095)] = 53647,
  [SMALL_STATE(4096)] = 53758,
  [SMALL_STATE(4097)] = 53869,
  [SMALL_STATE(4098)] = 53944,
  [SMALL_STATE(4099)] = 54055,
  [SMALL_STATE(4100)] = 54166,
  [SMALL_STATE(4101)] = 54277,
  [SMALL_STATE(4102)] = 54388,
  [SMALL_STATE(4103)] = 54499,
  [SMALL_STATE(4104)] = 54610,
  [SMALL_STATE(4105)] = 54673,
  [SMALL_STATE(4106)] = 54784,
  [SMALL_STATE(4107)] = 54847,
  [SMALL_STATE(4108)] = 54958,
  [SMALL_STATE(4109)] = 55069,
  [SMALL_STATE(4110)] = 55180,
  [SMALL_STATE(4111)] = 55291,
  [SMALL_STATE(4112)] = 55402,
  [SMALL_STATE(4113)] = 55513,
  [SMALL_STATE(4114)] = 55624,
  [SMALL_STATE(4115)] = 55735,
  [SMALL_STATE(4116)] = 55846,
  [SMALL_STATE(4117)] = 55959,
  [SMALL_STATE(4118)] = 56070,
  [SMALL_STATE(4119)] = 56181,
  [SMALL_STATE(4120)] = 56292,
  [SMALL_STATE(4121)] = 56413,
  [SMALL_STATE(4122)] = 56524,
  [SMALL_STATE(4123)] = 56635,
  [SMALL_STATE(4124)] = 56746,
  [SMALL_STATE(4125)] = 56857,
  [SMALL_STATE(4126)] = 56968,
  [SMALL_STATE(4127)] = 57079,
  [SMALL_STATE(4128)] = 57190,
  [SMALL_STATE(4129)] = 57299,
  [SMALL_STATE(4130)] = 57410,
  [SMALL_STATE(4131)] = 57487,
  [SMALL_STATE(4132)] = 57598,
  [SMALL_STATE(4133)] = 57709,
  [SMALL_STATE(4134)] = 57772,
  [SMALL_STATE(4135)] = 57883,
  [SMALL_STATE(4136)] = 57960,
  [SMALL_STATE(4137)] = 58071,
  [SMALL_STATE(4138)] = 58182,
  [SMALL_STATE(4139)] = 58293,
  [SMALL_STATE(4140)] = 58404,
  [SMALL_STATE(4141)] = 58515,
  [SMALL_STATE(4142)] = 58626,
  [SMALL_STATE(4143)] = 58737,
  [SMALL_STATE(4144)] = 58848,
  [SMALL_STATE(4145)] = 58959,
  [SMALL_STATE(4146)] = 59070,
  [SMALL_STATE(4147)] = 59181,
  [SMALL_STATE(4148)] = 59292,
  [SMALL_STATE(4149)] = 59403,
  [SMALL_STATE(4150)] = 59514,
  [SMALL_STATE(4151)] = 59625,
  [SMALL_STATE(4152)] = 59688,
  [SMALL_STATE(4153)] = 59799,
  [SMALL_STATE(4154)] = 59862,
  [SMALL_STATE(4155)] = 59973,
  [SMALL_STATE(4156)] = 60042,
  [SMALL_STATE(4157)] = 60153,
  [SMALL_STATE(4158)] = 60230,
  [SMALL_STATE(4159)] = 60341,
  [SMALL_STATE(4160)] = 60452,
  [SMALL_STATE(4161)] = 60563,
  [SMALL_STATE(4162)] = 60626,
  [SMALL_STATE(4163)] = 60737,
  [SMALL_STATE(4164)] = 60800,
  [SMALL_STATE(4165)] = 60911,
  [SMALL_STATE(4166)] = 61022,
  [SMALL_STATE(4167)] = 61133,
  [SMALL_STATE(4168)] = 61244,
  [SMALL_STATE(4169)] = 61315,
  [SMALL_STATE(4170)] = 61426,
  [SMALL_STATE(4171)] = 61537,
  [SMALL_STATE(4172)] = 61600,
  [SMALL_STATE(4173)] = 61721,
  [SMALL_STATE(4174)] = 61788,
  [SMALL_STATE(4175)] = 61899,
  [SMALL_STATE(4176)] = 61966,
  [SMALL_STATE(4177)] = 62075,
  [SMALL_STATE(4178)] = 62186,
  [SMALL_STATE(4179)] = 62297,
  [SMALL_STATE(4180)] = 62408,
  [SMALL_STATE(4181)] = 62519,
  [SMALL_STATE(4182)] = 62630,
  [SMALL_STATE(4183)] = 62741,
  [SMALL_STATE(4184)] = 62804,
  [SMALL_STATE(4185)] = 62915,
  [SMALL_STATE(4186)] = 63026,
  [SMALL_STATE(4187)] = 63137,
  [SMALL_STATE(4188)] = 63248,
  [SMALL_STATE(4189)] = 63359,
  [SMALL_STATE(4190)] = 63470,
  [SMALL_STATE(4191)] = 63581,
  [SMALL_STATE(4192)] = 63644,
  [SMALL_STATE(4193)] = 63755,
  [SMALL_STATE(4194)] = 63866,
  [SMALL_STATE(4195)] = 63975,
  [SMALL_STATE(4196)] = 64086,
  [SMALL_STATE(4197)] = 64197,
  [SMALL_STATE(4198)] = 64308,
  [SMALL_STATE(4199)] = 64419,
  [SMALL_STATE(4200)] = 64530,
  [SMALL_STATE(4201)] = 64641,
  [SMALL_STATE(4202)] = 64752,
  [SMALL_STATE(4203)] = 64863,
  [SMALL_STATE(4204)] = 64932,
  [SMALL_STATE(4205)] = 65043,
  [SMALL_STATE(4206)] = 65154,
  [SMALL_STATE(4207)] = 65265,
  [SMALL_STATE(4208)] = 65376,
  [SMALL_STATE(4209)] = 65447,
  [SMALL_STATE(4210)] = 65558,
  [SMALL_STATE(4211)] = 65669,
  [SMALL_STATE(4212)] = 65780,
  [SMALL_STATE(4213)] = 65889,
  [SMALL_STATE(4214)] = 66000,
  [SMALL_STATE(4215)] = 66111,
  [SMALL_STATE(4216)] = 66222,
  [SMALL_STATE(4217)] = 66291,
  [SMALL_STATE(4218)] = 66370,
  [SMALL_STATE(4219)] = 66481,
  [SMALL_STATE(4220)] = 66558,
  [SMALL_STATE(4221)] = 66669,
  [SMALL_STATE(4222)] = 66774,
  [SMALL_STATE(4223)] = 66885,
  [SMALL_STATE(4224)] = 66996,
  [SMALL_STATE(4225)] = 67107,
  [SMALL_STATE(4226)] = 67218,
  [SMALL_STATE(4227)] = 67329,
  [SMALL_STATE(4228)] = 67438,
  [SMALL_STATE(4229)] = 67549,
  [SMALL_STATE(4230)] = 67658,
  [SMALL_STATE(4231)] = 67769,
  [SMALL_STATE(4232)] = 67878,
  [SMALL_STATE(4233)] = 67989,
  [SMALL_STATE(4234)] = 68100,
  [SMALL_STATE(4235)] = 68211,
  [SMALL_STATE(4236)] = 68322,
  [SMALL_STATE(4237)] = 68433,
  [SMALL_STATE(4238)] = 68544,
  [SMALL_STATE(4239)] = 68645,
  [SMALL_STATE(4240)] = 68756,
  [SMALL_STATE(4241)] = 68869,
  [SMALL_STATE(4242)] = 68980,
  [SMALL_STATE(4243)] = 69091,
  [SMALL_STATE(4244)] = 69162,
  [SMALL_STATE(4245)] = 69225,
  [SMALL_STATE(4246)] = 69336,
  [SMALL_STATE(4247)] = 69413,
  [SMALL_STATE(4248)] = 69522,
  [SMALL_STATE(4249)] = 69633,
  [SMALL_STATE(4250)] = 69708,
  [SMALL_STATE(4251)] = 69775,
  [SMALL_STATE(4252)] = 69886,
  [SMALL_STATE(4253)] = 69997,
  [SMALL_STATE(4254)] = 70108,
  [SMALL_STATE(4255)] = 70217,
  [SMALL_STATE(4256)] = 70328,
  [SMALL_STATE(4257)] = 70437,
  [SMALL_STATE(4258)] = 70502,
  [SMALL_STATE(4259)] = 70611,
  [SMALL_STATE(4260)] = 70680,
  [SMALL_STATE(4261)] = 70789,
  [SMALL_STATE(4262)] = 70900,
  [SMALL_STATE(4263)] = 70997,
  [SMALL_STATE(4264)] = 71108,
  [SMALL_STATE(4265)] = 71171,
  [SMALL_STATE(4266)] = 71292,
  [SMALL_STATE(4267)] = 71387,
  [SMALL_STATE(4268)] = 71450,
  [SMALL_STATE(4269)] = 71561,
  [SMALL_STATE(4270)] = 71672,
  [SMALL_STATE(4271)] = 71737,
  [SMALL_STATE(4272)] = 71800,
  [SMALL_STATE(4273)] = 71863,
  [SMALL_STATE(4274)] = 71984,
  [SMALL_STATE(4275)] = 72095,
  [SMALL_STATE(4276)] = 72206,
  [SMALL_STATE(4277)] = 72317,
  [SMALL_STATE(4278)] = 72380,
  [SMALL_STATE(4279)] = 72491,
  [SMALL_STATE(4280)] = 72600,
  [SMALL_STATE(4281)] = 72663,
  [SMALL_STATE(4282)] = 72728,
  [SMALL_STATE(4283)] = 72839,
  [SMALL_STATE(4284)] = 72948,
  [SMALL_STATE(4285)] = 73057,
  [SMALL_STATE(4286)] = 73168,
  [SMALL_STATE(4287)] = 73279,
  [SMALL_STATE(4288)] = 73390,
  [SMALL_STATE(4289)] = 73481,
  [SMALL_STATE(4290)] = 73592,
  [SMALL_STATE(4291)] = 73703,
  [SMALL_STATE(4292)] = 73814,
  [SMALL_STATE(4293)] = 73925,
  [SMALL_STATE(4294)] = 74036,
  [SMALL_STATE(4295)] = 74147,
  [SMALL_STATE(4296)] = 74256,
  [SMALL_STATE(4297)] = 74367,
  [SMALL_STATE(4298)] = 74478,
  [SMALL_STATE(4299)] = 74589,
  [SMALL_STATE(4300)] = 74700,
  [SMALL_STATE(4301)] = 74811,
  [SMALL_STATE(4302)] = 74922,
  [SMALL_STATE(4303)] = 75033,
  [SMALL_STATE(4304)] = 75116,
  [SMALL_STATE(4305)] = 75205,
  [SMALL_STATE(4306)] = 75274,
  [SMALL_STATE(4307)] = 75341,
  [SMALL_STATE(4308)] = 75449,
  [SMALL_STATE(4309)] = 75515,
  [SMALL_STATE(4310)] = 75625,
  [SMALL_STATE(4311)] = 75731,
  [SMALL_STATE(4312)] = 75797,
  [SMALL_STATE(4313)] = 75859,
  [SMALL_STATE(4314)] = 75969,
  [SMALL_STATE(4315)] = 76083,
  [SMALL_STATE(4316)] = 76149,
  [SMALL_STATE(4317)] = 76217,
  [SMALL_STATE(4318)] = 76285,
  [SMALL_STATE(4319)] = 76393,
  [SMALL_STATE(4320)] = 76455,
  [SMALL_STATE(4321)] = 76517,
  [SMALL_STATE(4322)] = 76579,
  [SMALL_STATE(4323)] = 76641,
  [SMALL_STATE(4324)] = 76761,
  [SMALL_STATE(4325)] = 76823,
  [SMALL_STATE(4326)] = 76885,
  [SMALL_STATE(4327)] = 76947,
  [SMALL_STATE(4328)] = 77013,
  [SMALL_STATE(4329)] = 77075,
  [SMALL_STATE(4330)] = 77137,
  [SMALL_STATE(4331)] = 77251,
  [SMALL_STATE(4332)] = 77371,
  [SMALL_STATE(4333)] = 77433,
  [SMALL_STATE(4334)] = 77495,
  [SMALL_STATE(4335)] = 77559,
  [SMALL_STATE(4336)] = 77621,
  [SMALL_STATE(4337)] = 77683,
  [SMALL_STATE(4338)] = 77745,
  [SMALL_STATE(4339)] = 77809,
  [SMALL_STATE(4340)] = 77871,
  [SMALL_STATE(4341)] = 77933,
  [SMALL_STATE(4342)] = 77995,
  [SMALL_STATE(4343)] = 78057,
  [SMALL_STATE(4344)] = 78123,
  [SMALL_STATE(4345)] = 78185,
  [SMALL_STATE(4346)] = 78293,
  [SMALL_STATE(4347)] = 78355,
  [SMALL_STATE(4348)] = 78417,
  [SMALL_STATE(4349)] = 78479,
  [SMALL_STATE(4350)] = 78541,
  [SMALL_STATE(4351)] = 78607,
  [SMALL_STATE(4352)] = 78669,
  [SMALL_STATE(4353)] = 78737,
  [SMALL_STATE(4354)] = 78803,
  [SMALL_STATE(4355)] = 78961,
  [SMALL_STATE(4356)] = 79119,
  [SMALL_STATE(4357)] = 79187,
  [SMALL_STATE(4358)] = 79249,
  [SMALL_STATE(4359)] = 79311,
  [SMALL_STATE(4360)] = 79373,
  [SMALL_STATE(4361)] = 79435,
  [SMALL_STATE(4362)] = 79497,
  [SMALL_STATE(4363)] = 79559,
  [SMALL_STATE(4364)] = 79625,
  [SMALL_STATE(4365)] = 79687,
  [SMALL_STATE(4366)] = 79755,
  [SMALL_STATE(4367)] = 79817,
  [SMALL_STATE(4368)] = 79889,
  [SMALL_STATE(4369)] = 79965,
  [SMALL_STATE(4370)] = 80033,
  [SMALL_STATE(4371)] = 80099,
  [SMALL_STATE(4372)] = 80161,
  [SMALL_STATE(4373)] = 80223,
  [SMALL_STATE(4374)] = 80285,
  [SMALL_STATE(4375)] = 80347,
  [SMALL_STATE(4376)] = 80409,
  [SMALL_STATE(4377)] = 80471,
  [SMALL_STATE(4378)] = 80539,
  [SMALL_STATE(4379)] = 80605,
  [SMALL_STATE(4380)] = 80713,
  [SMALL_STATE(4381)] = 80775,
  [SMALL_STATE(4382)] = 80837,
  [SMALL_STATE(4383)] = 80899,
  [SMALL_STATE(4384)] = 81007,
  [SMALL_STATE(4385)] = 81071,
  [SMALL_STATE(4386)] = 81229,
  [SMALL_STATE(4387)] = 81291,
  [SMALL_STATE(4388)] = 81353,
  [SMALL_STATE(4389)] = 81453,
  [SMALL_STATE(4390)] = 81553,
  [SMALL_STATE(4391)] = 81619,
  [SMALL_STATE(4392)] = 81685,
  [SMALL_STATE(4393)] = 81793,
  [SMALL_STATE(4394)] = 81855,
  [SMALL_STATE(4395)] = 82013,
  [SMALL_STATE(4396)] = 82079,
  [SMALL_STATE(4397)] = 82145,
  [SMALL_STATE(4398)] = 82253,
  [SMALL_STATE(4399)] = 82367,
  [SMALL_STATE(4400)] = 82525,
  [SMALL_STATE(4401)] = 82591,
  [SMALL_STATE(4402)] = 82699,
  [SMALL_STATE(4403)] = 82761,
  [SMALL_STATE(4404)] = 82919,
  [SMALL_STATE(4405)] = 82981,
  [SMALL_STATE(4406)] = 83043,
  [SMALL_STATE(4407)] = 83105,
  [SMALL_STATE(4408)] = 83213,
  [SMALL_STATE(4409)] = 83275,
  [SMALL_STATE(4410)] = 83433,
  [SMALL_STATE(4411)] = 83495,
  [SMALL_STATE(4412)] = 83557,
  [SMALL_STATE(4413)] = 83665,
  [SMALL_STATE(4414)] = 83727,
  [SMALL_STATE(4415)] = 83885,
  [SMALL_STATE(4416)] = 83993,
  [SMALL_STATE(4417)] = 84151,
  [SMALL_STATE(4418)] = 84259,
  [SMALL_STATE(4419)] = 84367,
  [SMALL_STATE(4420)] = 84435,
  [SMALL_STATE(4421)] = 84543,
  [SMALL_STATE(4422)] = 84651,
  [SMALL_STATE(4423)] = 84759,
  [SMALL_STATE(4424)] = 84825,
  [SMALL_STATE(4425)] = 84933,
  [SMALL_STATE(4426)] = 85041,
  [SMALL_STATE(4427)] = 85149,
  [SMALL_STATE(4428)] = 85257,
  [SMALL_STATE(4429)] = 85365,
  [SMALL_STATE(4430)] = 85473,
  [SMALL_STATE(4431)] = 85581,
  [SMALL_STATE(4432)] = 85643,
  [SMALL_STATE(4433)] = 85751,
  [SMALL_STATE(4434)] = 85815,
  [SMALL_STATE(4435)] = 85931,
  [SMALL_STATE(4436)] = 86005,
  [SMALL_STATE(4437)] = 86111,
  [SMALL_STATE(4438)] = 86219,
  [SMALL_STATE(4439)] = 86295,
  [SMALL_STATE(4440)] = 86371,
  [SMALL_STATE(4441)] = 86433,
  [SMALL_STATE(4442)] = 86539,
  [SMALL_STATE(4443)] = 86613,
  [SMALL_STATE(4444)] = 86721,
  [SMALL_STATE(4445)] = 86841,
  [SMALL_STATE(4446)] = 86961,
  [SMALL_STATE(4447)] = 87081,
  [SMALL_STATE(4448)] = 87189,
  [SMALL_STATE(4449)] = 87297,
  [SMALL_STATE(4450)] = 87405,
  [SMALL_STATE(4451)] = 87513,
  [SMALL_STATE(4452)] = 87621,
  [SMALL_STATE(4453)] = 87683,
  [SMALL_STATE(4454)] = 87745,
  [SMALL_STATE(4455)] = 87851,
  [SMALL_STATE(4456)] = 87913,
  [SMALL_STATE(4457)] = 87975,
  [SMALL_STATE(4458)] = 88037,
  [SMALL_STATE(4459)] = 88099,
  [SMALL_STATE(4460)] = 88209,
  [SMALL_STATE(4461)] = 88271,
  [SMALL_STATE(4462)] = 88343,
  [SMALL_STATE(4463)] = 88421,
  [SMALL_STATE(4464)] = 88497,
  [SMALL_STATE(4465)] = 88617,
  [SMALL_STATE(4466)] = 88719,
  [SMALL_STATE(4467)] = 88817,
  [SMALL_STATE(4468)] = 88911,
  [SMALL_STATE(4469)] = 89003,
  [SMALL_STATE(4470)] = 89091,
  [SMALL_STATE(4471)] = 89177,
  [SMALL_STATE(4472)] = 89261,
  [SMALL_STATE(4473)] = 89341,
  [SMALL_STATE(4474)] = 89423,
  [SMALL_STATE(4475)] = 89489,
  [SMALL_STATE(4476)] = 89565,
  [SMALL_STATE(4477)] = 89639,
  [SMALL_STATE(4478)] = 89715,
  [SMALL_STATE(4479)] = 89791,
  [SMALL_STATE(4480)] = 89899,
  [SMALL_STATE(4481)] = 89973,
  [SMALL_STATE(4482)] = 90081,
  [SMALL_STATE(4483)] = 90193,
  [SMALL_STATE(4484)] = 90271,
  [SMALL_STATE(4485)] = 90347,
  [SMALL_STATE(4486)] = 90451,
  [SMALL_STATE(4487)] = 90551,
  [SMALL_STATE(4488)] = 90647,
  [SMALL_STATE(4489)] = 90741,
  [SMALL_STATE(4490)] = 90831,
  [SMALL_STATE(4491)] = 90919,
  [SMALL_STATE(4492)] = 91003,
  [SMALL_STATE(4493)] = 91083,
  [SMALL_STATE(4494)] = 91165,
  [SMALL_STATE(4495)] = 91241,
  [SMALL_STATE(4496)] = 91349,
  [SMALL_STATE(4497)] = 91461,
  [SMALL_STATE(4498)] = 91569,
  [SMALL_STATE(4499)] = 91681,
  [SMALL_STATE(4500)] = 91743,
  [SMALL_STATE(4501)] = 91805,
  [SMALL_STATE(4502)] = 91867,
  [SMALL_STATE(4503)] = 91929,
  [SMALL_STATE(4504)] = 92049,
  [SMALL_STATE(4505)] = 92115,
  [SMALL_STATE(4506)] = 92191,
  [SMALL_STATE(4507)] = 92297,
  [SMALL_STATE(4508)] = 92363,
  [SMALL_STATE(4509)] = 92429,
  [SMALL_STATE(4510)] = 92495,
  [SMALL_STATE(4511)] = 92561,
  [SMALL_STATE(4512)] = 92627,
  [SMALL_STATE(4513)] = 92693,
  [SMALL_STATE(4514)] = 92759,
  [SMALL_STATE(4515)] = 92825,
  [SMALL_STATE(4516)] = 92891,
  [SMALL_STATE(4517)] = 92957,
  [SMALL_STATE(4518)] = 93065,
  [SMALL_STATE(4519)] = 93126,
  [SMALL_STATE(4520)] = 93187,
  [SMALL_STATE(4521)] = 93248,
  [SMALL_STATE(4522)] = 93309,
  [SMALL_STATE(4523)] = 93372,
  [SMALL_STATE(4524)] = 93433,
  [SMALL_STATE(4525)] = 93494,
  [SMALL_STATE(4526)] = 93555,
  [SMALL_STATE(4527)] = 93616,
  [SMALL_STATE(4528)] = 93677,
  [SMALL_STATE(4529)] = 93738,
  [SMALL_STATE(4530)] = 93799,
  [SMALL_STATE(4531)] = 93860,
  [SMALL_STATE(4532)] = 93923,
  [SMALL_STATE(4533)] = 93992,
  [SMALL_STATE(4534)] = 94059,
  [SMALL_STATE(4535)] = 94120,
  [SMALL_STATE(4536)] = 94181,
  [SMALL_STATE(4537)] = 94244,
  [SMALL_STATE(4538)] = 94307,
  [SMALL_STATE(4539)] = 94368,
  [SMALL_STATE(4540)] = 94429,
  [SMALL_STATE(4541)] = 94490,
  [SMALL_STATE(4542)] = 94551,
  [SMALL_STATE(4543)] = 94612,
  [SMALL_STATE(4544)] = 94675,
  [SMALL_STATE(4545)] = 94736,
  [SMALL_STATE(4546)] = 94797,
  [SMALL_STATE(4547)] = 94858,
  [SMALL_STATE(4548)] = 94919,
  [SMALL_STATE(4549)] = 94980,
  [SMALL_STATE(4550)] = 95041,
  [SMALL_STATE(4551)] = 95102,
  [SMALL_STATE(4552)] = 95163,
  [SMALL_STATE(4553)] = 95224,
  [SMALL_STATE(4554)] = 95289,
  [SMALL_STATE(4555)] = 95350,
  [SMALL_STATE(4556)] = 95411,
  [SMALL_STATE(4557)] = 95472,
  [SMALL_STATE(4558)] = 95533,
  [SMALL_STATE(4559)] = 95594,
  [SMALL_STATE(4560)] = 95655,
  [SMALL_STATE(4561)] = 95716,
  [SMALL_STATE(4562)] = 95777,
  [SMALL_STATE(4563)] = 95838,
  [SMALL_STATE(4564)] = 95899,
  [SMALL_STATE(4565)] = 95960,
  [SMALL_STATE(4566)] = 96033,
  [SMALL_STATE(4567)] = 96106,
  [SMALL_STATE(4568)] = 96175,
  [SMALL_STATE(4569)] = 96236,
  [SMALL_STATE(4570)] = 96297,
  [SMALL_STATE(4571)] = 96358,
  [SMALL_STATE(4572)] = 96419,
  [SMALL_STATE(4573)] = 96480,
  [SMALL_STATE(4574)] = 96541,
  [SMALL_STATE(4575)] = 96602,
  [SMALL_STATE(4576)] = 96663,
  [SMALL_STATE(4577)] = 96724,
  [SMALL_STATE(4578)] = 96785,
  [SMALL_STATE(4579)] = 96846,
  [SMALL_STATE(4580)] = 96909,
  [SMALL_STATE(4581)] = 96976,
  [SMALL_STATE(4582)] = 97037,
  [SMALL_STATE(4583)] = 97098,
  [SMALL_STATE(4584)] = 97159,
  [SMALL_STATE(4585)] = 97220,
  [SMALL_STATE(4586)] = 97285,
  [SMALL_STATE(4587)] = 97346,
  [SMALL_STATE(4588)] = 97407,
  [SMALL_STATE(4589)] = 97468,
  [SMALL_STATE(4590)] = 97529,
  [SMALL_STATE(4591)] = 97590,
  [SMALL_STATE(4592)] = 97651,
  [SMALL_STATE(4593)] = 97712,
  [SMALL_STATE(4594)] = 97773,
  [SMALL_STATE(4595)] = 97834,
  [SMALL_STATE(4596)] = 97895,
  [SMALL_STATE(4597)] = 97962,
  [SMALL_STATE(4598)] = 98023,
  [SMALL_STATE(4599)] = 98084,
  [SMALL_STATE(4600)] = 98151,
  [SMALL_STATE(4601)] = 98212,
  [SMALL_STATE(4602)] = 98273,
  [SMALL_STATE(4603)] = 98338,
  [SMALL_STATE(4604)] = 98399,
  [SMALL_STATE(4605)] = 98460,
  [SMALL_STATE(4606)] = 98521,
  [SMALL_STATE(4607)] = 98582,
  [SMALL_STATE(4608)] = 98651,
  [SMALL_STATE(4609)] = 98712,
  [SMALL_STATE(4610)] = 98773,
  [SMALL_STATE(4611)] = 98834,
  [SMALL_STATE(4612)] = 98895,
  [SMALL_STATE(4613)] = 98956,
  [SMALL_STATE(4614)] = 99017,
  [SMALL_STATE(4615)] = 99078,
  [SMALL_STATE(4616)] = 99139,
  [SMALL_STATE(4617)] = 99200,
  [SMALL_STATE(4618)] = 99261,
  [SMALL_STATE(4619)] = 99322,
  [SMALL_STATE(4620)] = 99383,
  [SMALL_STATE(4621)] = 99444,
  [SMALL_STATE(4622)] = 99511,
  [SMALL_STATE(4623)] = 99572,
  [SMALL_STATE(4624)] = 99633,
  [SMALL_STATE(4625)] = 99698,
  [SMALL_STATE(4626)] = 99759,
  [SMALL_STATE(4627)] = 99820,
  [SMALL_STATE(4628)] = 99881,
  [SMALL_STATE(4629)] = 99942,
  [SMALL_STATE(4630)] = 100003,
  [SMALL_STATE(4631)] = 100064,
  [SMALL_STATE(4632)] = 100125,
  [SMALL_STATE(4633)] = 100186,
  [SMALL_STATE(4634)] = 100247,
  [SMALL_STATE(4635)] = 100310,
  [SMALL_STATE(4636)] = 100371,
  [SMALL_STATE(4637)] = 100432,
  [SMALL_STATE(4638)] = 100493,
  [SMALL_STATE(4639)] = 100554,
  [SMALL_STATE(4640)] = 100615,
  [SMALL_STATE(4641)] = 100676,
  [SMALL_STATE(4642)] = 100737,
  [SMALL_STATE(4643)] = 100798,
  [SMALL_STATE(4644)] = 100859,
  [SMALL_STATE(4645)] = 100920,
  [SMALL_STATE(4646)] = 100981,
  [SMALL_STATE(4647)] = 101042,
  [SMALL_STATE(4648)] = 101103,
  [SMALL_STATE(4649)] = 101164,
  [SMALL_STATE(4650)] = 101225,
  [SMALL_STATE(4651)] = 101286,
  [SMALL_STATE(4652)] = 101347,
  [SMALL_STATE(4653)] = 101408,
  [SMALL_STATE(4654)] = 101469,
  [SMALL_STATE(4655)] = 101530,
  [SMALL_STATE(4656)] = 101591,
  [SMALL_STATE(4657)] = 101652,
  [SMALL_STATE(4658)] = 101713,
  [SMALL_STATE(4659)] = 101774,
  [SMALL_STATE(4660)] = 101843,
  [SMALL_STATE(4661)] = 101903,
  [SMALL_STATE(4662)] = 101963,
  [SMALL_STATE(4663)] = 102067,
  [SMALL_STATE(4664)] = 102133,
  [SMALL_STATE(4665)] = 102207,
  [SMALL_STATE(4666)] = 102267,
  [SMALL_STATE(4667)] = 102327,
  [SMALL_STATE(4668)] = 102387,
  [SMALL_STATE(4669)] = 102447,
  [SMALL_STATE(4670)] = 102507,
  [SMALL_STATE(4671)] = 102567,
  [SMALL_STATE(4672)] = 102627,
  [SMALL_STATE(4673)] = 102687,
  [SMALL_STATE(4674)] = 102747,
  [SMALL_STATE(4675)] = 102811,
  [SMALL_STATE(4676)] = 102875,
  [SMALL_STATE(4677)] = 102935,
  [SMALL_STATE(4678)] = 102995,
  [SMALL_STATE(4679)] = 103055,
  [SMALL_STATE(4680)] = 103159,
  [SMALL_STATE(4681)] = 103219,
  [SMALL_STATE(4682)] = 103279,
  [SMALL_STATE(4683)] = 103339,
  [SMALL_STATE(4684)] = 103399,
  [SMALL_STATE(4685)] = 103459,
  [SMALL_STATE(4686)] = 103519,
  [SMALL_STATE(4687)] = 103579,
  [SMALL_STATE(4688)] = 103639,
  [SMALL_STATE(4689)] = 103699,
  [SMALL_STATE(4690)] = 103759,
  [SMALL_STATE(4691)] = 103819,
  [SMALL_STATE(4692)] = 103927,
  [SMALL_STATE(4693)] = 103987,
  [SMALL_STATE(4694)] = 104047,
  [SMALL_STATE(4695)] = 104107,
  [SMALL_STATE(4696)] = 104169,
  [SMALL_STATE(4697)] = 104235,
  [SMALL_STATE(4698)] = 104339,
  [SMALL_STATE(4699)] = 104407,
  [SMALL_STATE(4700)] = 104471,
  [SMALL_STATE(4701)] = 104535,
  [SMALL_STATE(4702)] = 104631,
  [SMALL_STATE(4703)] = 104727,
  [SMALL_STATE(4704)] = 104795,
  [SMALL_STATE(4705)] = 104867,
  [SMALL_STATE(4706)] = 104927,
  [SMALL_STATE(4707)] = 104987,
  [SMALL_STATE(4708)] = 105047,
  [SMALL_STATE(4709)] = 105107,
  [SMALL_STATE(4710)] = 105167,
  [SMALL_STATE(4711)] = 105227,
  [SMALL_STATE(4712)] = 105287,
  [SMALL_STATE(4713)] = 105347,
  [SMALL_STATE(4714)] = 105411,
  [SMALL_STATE(4715)] = 105519,
  [SMALL_STATE(4716)] = 105579,
  [SMALL_STATE(4717)] = 105687,
  [SMALL_STATE(4718)] = 105747,
  [SMALL_STATE(4719)] = 105807,
  [SMALL_STATE(4720)] = 105871,
  [SMALL_STATE(4721)] = 105931,
  [SMALL_STATE(4722)] = 105991,
  [SMALL_STATE(4723)] = 106051,
  [SMALL_STATE(4724)] = 106111,
  [SMALL_STATE(4725)] = 106171,
  [SMALL_STATE(4726)] = 106231,
  [SMALL_STATE(4727)] = 106291,
  [SMALL_STATE(4728)] = 106353,
  [SMALL_STATE(4729)] = 106413,
  [SMALL_STATE(4730)] = 106473,
  [SMALL_STATE(4731)] = 106537,
  [SMALL_STATE(4732)] = 106597,
  [SMALL_STATE(4733)] = 106657,
  [SMALL_STATE(4734)] = 106717,
  [SMALL_STATE(4735)] = 106777,
  [SMALL_STATE(4736)] = 106837,
  [SMALL_STATE(4737)] = 106897,
  [SMALL_STATE(4738)] = 106957,
  [SMALL_STATE(4739)] = 107017,
  [SMALL_STATE(4740)] = 107077,
  [SMALL_STATE(4741)] = 107137,
  [SMALL_STATE(4742)] = 107197,
  [SMALL_STATE(4743)] = 107257,
  [SMALL_STATE(4744)] = 107317,
  [SMALL_STATE(4745)] = 107377,
  [SMALL_STATE(4746)] = 107437,
  [SMALL_STATE(4747)] = 107497,
  [SMALL_STATE(4748)] = 107557,
  [SMALL_STATE(4749)] = 107621,
  [SMALL_STATE(4750)] = 107681,
  [SMALL_STATE(4751)] = 107741,
  [SMALL_STATE(4752)] = 107801,
  [SMALL_STATE(4753)] = 107861,
  [SMALL_STATE(4754)] = 107933,
  [SMALL_STATE(4755)] = 108037,
  [SMALL_STATE(4756)] = 108097,
  [SMALL_STATE(4757)] = 108157,
  [SMALL_STATE(4758)] = 108217,
  [SMALL_STATE(4759)] = 108277,
  [SMALL_STATE(4760)] = 108337,
  [SMALL_STATE(4761)] = 108397,
  [SMALL_STATE(4762)] = 108457,
  [SMALL_STATE(4763)] = 108517,
  [SMALL_STATE(4764)] = 108593,
  [SMALL_STATE(4765)] = 108667,
  [SMALL_STATE(4766)] = 108769,
  [SMALL_STATE(4767)] = 108869,
  [SMALL_STATE(4768)] = 108965,
  [SMALL_STATE(4769)] = 109025,
  [SMALL_STATE(4770)] = 109085,
  [SMALL_STATE(4771)] = 109145,
  [SMALL_STATE(4772)] = 109237,
  [SMALL_STATE(4773)] = 109297,
  [SMALL_STATE(4774)] = 109385,
  [SMALL_STATE(4775)] = 109471,
  [SMALL_STATE(4776)] = 109531,
  [SMALL_STATE(4777)] = 109605,
  [SMALL_STATE(4778)] = 109679,
  [SMALL_STATE(4779)] = 109739,
  [SMALL_STATE(4780)] = 109821,
  [SMALL_STATE(4781)] = 109881,
  [SMALL_STATE(4782)] = 109941,
  [SMALL_STATE(4783)] = 110019,
  [SMALL_STATE(4784)] = 110079,
  [SMALL_STATE(4785)] = 110159,
  [SMALL_STATE(4786)] = 110219,
  [SMALL_STATE(4787)] = 110279,
  [SMALL_STATE(4788)] = 110383,
  [SMALL_STATE(4789)] = 110443,
  [SMALL_STATE(4790)] = 110515,
  [SMALL_STATE(4791)] = 110575,
  [SMALL_STATE(4792)] = 110635,
  [SMALL_STATE(4793)] = 110695,
  [SMALL_STATE(4794)] = 110755,
  [SMALL_STATE(4795)] = 110815,
  [SMALL_STATE(4796)] = 110875,
  [SMALL_STATE(4797)] = 110935,
  [SMALL_STATE(4798)] = 110995,
  [SMALL_STATE(4799)] = 111055,
  [SMALL_STATE(4800)] = 111115,
  [SMALL_STATE(4801)] = 111179,
  [SMALL_STATE(4802)] = 111239,
  [SMALL_STATE(4803)] = 111299,
  [SMALL_STATE(4804)] = 111359,
  [SMALL_STATE(4805)] = 111423,
  [SMALL_STATE(4806)] = 111482,
  [SMALL_STATE(4807)] = 111549,
  [SMALL_STATE(4808)] = 111616,
  [SMALL_STATE(4809)] = 111675,
  [SMALL_STATE(4810)] = 111748,
  [SMALL_STATE(4811)] = 111807,
  [SMALL_STATE(4812)] = 111880,
  [SMALL_STATE(4813)] = 111951,
  [SMALL_STATE(4814)] = 112028,
  [SMALL_STATE(4815)] = 112087,
  [SMALL_STATE(4816)] = 112146,
  [SMALL_STATE(4817)] = 112211,
  [SMALL_STATE(4818)] = 112270,
  [SMALL_STATE(4819)] = 112329,
  [SMALL_STATE(4820)] = 112402,
  [SMALL_STATE(4821)] = 112475,
  [SMALL_STATE(4822)] = 112542,
  [SMALL_STATE(4823)] = 112607,
  [SMALL_STATE(4824)] = 112702,
  [SMALL_STATE(4825)] = 112775,
  [SMALL_STATE(4826)] = 112834,
  [SMALL_STATE(4827)] = 112905,
  [SMALL_STATE(4828)] = 113000,
  [SMALL_STATE(4829)] = 113059,
  [SMALL_STATE(4830)] = 113118,
  [SMALL_STATE(4831)] = 113179,
  [SMALL_STATE(4832)] = 113252,
  [SMALL_STATE(4833)] = 113311,
  [SMALL_STATE(4834)] = 113369,
  [SMALL_STATE(4835)] = 113427,
  [SMALL_STATE(4836)] = 113517,
  [SMALL_STATE(4837)] = 113575,
  [SMALL_STATE(4838)] = 113633,
  [SMALL_STATE(4839)] = 113723,
  [SMALL_STATE(4840)] = 113781,
  [SMALL_STATE(4841)] = 113839,
  [SMALL_STATE(4842)] = 113897,
  [SMALL_STATE(4843)] = 113955,
  [SMALL_STATE(4844)] = 114013,
  [SMALL_STATE(4845)] = 114071,
  [SMALL_STATE(4846)] = 114129,
  [SMALL_STATE(4847)] = 114225,
  [SMALL_STATE(4848)] = 114321,
  [SMALL_STATE(4849)] = 114379,
  [SMALL_STATE(4850)] = 114437,
  [SMALL_STATE(4851)] = 114495,
  [SMALL_STATE(4852)] = 114553,
  [SMALL_STATE(4853)] = 114611,
  [SMALL_STATE(4854)] = 114669,
  [SMALL_STATE(4855)] = 114727,
  [SMALL_STATE(4856)] = 114785,
  [SMALL_STATE(4857)] = 114843,
  [SMALL_STATE(4858)] = 114901,
  [SMALL_STATE(4859)] = 114959,
  [SMALL_STATE(4860)] = 115017,
  [SMALL_STATE(4861)] = 115075,
  [SMALL_STATE(4862)] = 115133,
  [SMALL_STATE(4863)] = 115191,
  [SMALL_STATE(4864)] = 115249,
  [SMALL_STATE(4865)] = 115307,
  [SMALL_STATE(4866)] = 115365,
  [SMALL_STATE(4867)] = 115423,
  [SMALL_STATE(4868)] = 115481,
  [SMALL_STATE(4869)] = 115539,
  [SMALL_STATE(4870)] = 115597,
  [SMALL_STATE(4871)] = 115655,
  [SMALL_STATE(4872)] = 115713,
  [SMALL_STATE(4873)] = 115771,
  [SMALL_STATE(4874)] = 115829,
  [SMALL_STATE(4875)] = 115887,
  [SMALL_STATE(4876)] = 115945,
  [SMALL_STATE(4877)] = 116003,
  [SMALL_STATE(4878)] = 116061,
  [SMALL_STATE(4879)] = 116119,
  [SMALL_STATE(4880)] = 116177,
  [SMALL_STATE(4881)] = 116235,
  [SMALL_STATE(4882)] = 116293,
  [SMALL_STATE(4883)] = 116355,
  [SMALL_STATE(4884)] = 116413,
  [SMALL_STATE(4885)] = 116471,
  [SMALL_STATE(4886)] = 116529,
  [SMALL_STATE(4887)] = 116625,
  [SMALL_STATE(4888)] = 116721,
  [SMALL_STATE(4889)] = 116779,
  [SMALL_STATE(4890)] = 116837,
  [SMALL_STATE(4891)] = 116895,
  [SMALL_STATE(4892)] = 116953,
  [SMALL_STATE(4893)] = 117011,
  [SMALL_STATE(4894)] = 117069,
  [SMALL_STATE(4895)] = 117127,
  [SMALL_STATE(4896)] = 117185,
  [SMALL_STATE(4897)] = 117243,
  [SMALL_STATE(4898)] = 117301,
  [SMALL_STATE(4899)] = 117359,
  [SMALL_STATE(4900)] = 117425,
  [SMALL_STATE(4901)] = 117487,
  [SMALL_STATE(4902)] = 117545,
  [SMALL_STATE(4903)] = 117607,
  [SMALL_STATE(4904)] = 117665,
  [SMALL_STATE(4905)] = 117723,
  [SMALL_STATE(4906)] = 117785,
  [SMALL_STATE(4907)] = 117847,
  [SMALL_STATE(4908)] = 117909,
  [SMALL_STATE(4909)] = 117971,
  [SMALL_STATE(4910)] = 118033,
  [SMALL_STATE(4911)] = 118095,
  [SMALL_STATE(4912)] = 118157,
  [SMALL_STATE(4913)] = 118219,
  [SMALL_STATE(4914)] = 118281,
  [SMALL_STATE(4915)] = 118343,
  [SMALL_STATE(4916)] = 118401,
  [SMALL_STATE(4917)] = 118459,
  [SMALL_STATE(4918)] = 118517,
  [SMALL_STATE(4919)] = 118575,
  [SMALL_STATE(4920)] = 118645,
  [SMALL_STATE(4921)] = 118703,
  [SMALL_STATE(4922)] = 118761,
  [SMALL_STATE(4923)] = 118819,
  [SMALL_STATE(4924)] = 118877,
  [SMALL_STATE(4925)] = 118935,
  [SMALL_STATE(4926)] = 118993,
  [SMALL_STATE(4927)] = 119063,
  [SMALL_STATE(4928)] = 119121,
  [SMALL_STATE(4929)] = 119179,
  [SMALL_STATE(4930)] = 119237,
  [SMALL_STATE(4931)] = 119307,
  [SMALL_STATE(4932)] = 119401,
  [SMALL_STATE(4933)] = 119459,
  [SMALL_STATE(4934)] = 119517,
  [SMALL_STATE(4935)] = 119611,
  [SMALL_STATE(4936)] = 119669,
  [SMALL_STATE(4937)] = 119727,
  [SMALL_STATE(4938)] = 119785,
  [SMALL_STATE(4939)] = 119843,
  [SMALL_STATE(4940)] = 119901,
  [SMALL_STATE(4941)] = 119959,
  [SMALL_STATE(4942)] = 120017,
  [SMALL_STATE(4943)] = 120075,
  [SMALL_STATE(4944)] = 120145,
  [SMALL_STATE(4945)] = 120203,
  [SMALL_STATE(4946)] = 120263,
  [SMALL_STATE(4947)] = 120321,
  [SMALL_STATE(4948)] = 120379,
  [SMALL_STATE(4949)] = 120448,
  [SMALL_STATE(4950)] = 120505,
  [SMALL_STATE(4951)] = 120566,
  [SMALL_STATE(4952)] = 120627,
  [SMALL_STATE(4953)] = 120688,
  [SMALL_STATE(4954)] = 120745,
  [SMALL_STATE(4955)] = 120806,
  [SMALL_STATE(4956)] = 120863,
  [SMALL_STATE(4957)] = 120924,
  [SMALL_STATE(4958)] = 120985,
  [SMALL_STATE(4959)] = 121042,
  [SMALL_STATE(4960)] = 121103,
  [SMALL_STATE(4961)] = 121164,
  [SMALL_STATE(4962)] = 121221,
  [SMALL_STATE(4963)] = 121278,
  [SMALL_STATE(4964)] = 121339,
  [SMALL_STATE(4965)] = 121396,
  [SMALL_STATE(4966)] = 121511,
  [SMALL_STATE(4967)] = 121580,
  [SMALL_STATE(4968)] = 121643,
  [SMALL_STATE(4969)] = 121710,
  [SMALL_STATE(4970)] = 121767,
  [SMALL_STATE(4971)] = 121840,
  [SMALL_STATE(4972)] = 121901,
  [SMALL_STATE(4973)] = 122016,
  [SMALL_STATE(4974)] = 122073,
  [SMALL_STATE(4975)] = 122134,
  [SMALL_STATE(4976)] = 122207,
  [SMALL_STATE(4977)] = 122272,
  [SMALL_STATE(4978)] = 122341,
  [SMALL_STATE(4979)] = 122414,
  [SMALL_STATE(4980)] = 122475,
  [SMALL_STATE(4981)] = 122532,
  [SMALL_STATE(4982)] = 122595,
  [SMALL_STATE(4983)] = 122668,
  [SMALL_STATE(4984)] = 122737,
  [SMALL_STATE(4985)] = 122799,
  [SMALL_STATE(4986)] = 122857,
  [SMALL_STATE(4987)] = 122917,
  [SMALL_STATE(4988)] = 122977,
  [SMALL_STATE(4989)] = 123069,
  [SMALL_STATE(4990)] = 123163,
  [SMALL_STATE(4991)] = 123219,
  [SMALL_STATE(4992)] = 123281,
  [SMALL_STATE(4993)] = 123375,
  [SMALL_STATE(4994)] = 123433,
  [SMALL_STATE(4995)] = 123503,
  [SMALL_STATE(4996)] = 123595,
  [SMALL_STATE(4997)] = 123665,
  [SMALL_STATE(4998)] = 123721,
  [SMALL_STATE(4999)] = 123807,
  [SMALL_STATE(5000)] = 123865,
  [SMALL_STATE(5001)] = 123959,
  [SMALL_STATE(5002)] = 124051,
  [SMALL_STATE(5003)] = 124113,
  [SMALL_STATE(5004)] = 124175,
  [SMALL_STATE(5005)] = 124269,
  [SMALL_STATE(5006)] = 124361,
  [SMALL_STATE(5007)] = 124417,
  [SMALL_STATE(5008)] = 124479,
  [SMALL_STATE(5009)] = 124565,
  [SMALL_STATE(5010)] = 124635,
  [SMALL_STATE(5011)] = 124699,
  [SMALL_STATE(5012)] = 124757,
  [SMALL_STATE(5013)] = 124819,
  [SMALL_STATE(5014)] = 124912,
  [SMALL_STATE(5015)] = 124967,
  [SMALL_STATE(5016)] = 125022,
  [SMALL_STATE(5017)] = 125077,
  [SMALL_STATE(5018)] = 125132,
  [SMALL_STATE(5019)] = 125223,
  [SMALL_STATE(5020)] = 125278,
  [SMALL_STATE(5021)] = 125333,
  [SMALL_STATE(5022)] = 125388,
  [SMALL_STATE(5023)] = 125481,
  [SMALL_STATE(5024)] = 125536,
  [SMALL_STATE(5025)] = 125591,
  [SMALL_STATE(5026)] = 125684,
  [SMALL_STATE(5027)] = 125739,
  [SMALL_STATE(5028)] = 125794,
  [SMALL_STATE(5029)] = 125849,
  [SMALL_STATE(5030)] = 125904,
  [SMALL_STATE(5031)] = 125997,
  [SMALL_STATE(5032)] = 126052,
  [SMALL_STATE(5033)] = 126143,
  [SMALL_STATE(5034)] = 126198,
  [SMALL_STATE(5035)] = 126287,
  [SMALL_STATE(5036)] = 126342,
  [SMALL_STATE(5037)] = 126397,
  [SMALL_STATE(5038)] = 126482,
  [SMALL_STATE(5039)] = 126537,
  [SMALL_STATE(5040)] = 126592,
  [SMALL_STATE(5041)] = 126685,
  [SMALL_STATE(5042)] = 126740,
  [SMALL_STATE(5043)] = 126795,
  [SMALL_STATE(5044)] = 126850,
  [SMALL_STATE(5045)] = 126905,
  [SMALL_STATE(5046)] = 126998,
  [SMALL_STATE(5047)] = 127053,
  [SMALL_STATE(5048)] = 127146,
  [SMALL_STATE(5049)] = 127239,
  [SMALL_STATE(5050)] = 127298,
  [SMALL_STATE(5051)] = 127391,
  [SMALL_STATE(5052)] = 127450,
  [SMALL_STATE(5053)] = 127541,
  [SMALL_STATE(5054)] = 127630,
  [SMALL_STATE(5055)] = 127685,
  [SMALL_STATE(5056)] = 127750,
  [SMALL_STATE(5057)] = 127843,
  [SMALL_STATE(5058)] = 127936,
  [SMALL_STATE(5059)] = 128029,
  [SMALL_STATE(5060)] = 128094,
  [SMALL_STATE(5061)] = 128187,
  [SMALL_STATE(5062)] = 128252,
  [SMALL_STATE(5063)] = 128307,
  [SMALL_STATE(5064)] = 128362,
  [SMALL_STATE(5065)] = 128427,
  [SMALL_STATE(5066)] = 128482,
  [SMALL_STATE(5067)] = 128537,
  [SMALL_STATE(5068)] = 128630,
  [SMALL_STATE(5069)] = 128723,
  [SMALL_STATE(5070)] = 128816,
  [SMALL_STATE(5071)] = 128871,
  [SMALL_STATE(5072)] = 128926,
  [SMALL_STATE(5073)] = 128981,
  [SMALL_STATE(5074)] = 129036,
  [SMALL_STATE(5075)] = 129091,
  [SMALL_STATE(5076)] = 129150,
  [SMALL_STATE(5077)] = 129205,
  [SMALL_STATE(5078)] = 129260,
  [SMALL_STATE(5079)] = 129351,
  [SMALL_STATE(5080)] = 129444,
  [SMALL_STATE(5081)] = 129529,
  [SMALL_STATE(5082)] = 129622,
  [SMALL_STATE(5083)] = 129686,
  [SMALL_STATE(5084)] = 129772,
  [SMALL_STATE(5085)] = 129862,
  [SMALL_STATE(5086)] = 129952,
  [SMALL_STATE(5087)] = 130016,
  [SMALL_STATE(5088)] = 130082,
  [SMALL_STATE(5089)] = 130164,
  [SMALL_STATE(5090)] = 130250,
  [SMALL_STATE(5091)] = 130342,
  [SMALL_STATE(5092)] = 130396,
  [SMALL_STATE(5093)] = 130486,
  [SMALL_STATE(5094)] = 130578,
  [SMALL_STATE(5095)] = 130632,
  [SMALL_STATE(5096)] = 130714,
  [SMALL_STATE(5097)] = 130800,
  [SMALL_STATE(5098)] = 130886,
  [SMALL_STATE(5099)] = 130970,
  [SMALL_STATE(5100)] = 131052,
  [SMALL_STATE(5101)] = 131118,
  [SMALL_STATE(5102)] = 131200,
  [SMALL_STATE(5103)] = 131266,
  [SMALL_STATE(5104)] = 131350,
  [SMALL_STATE(5105)] = 131440,
  [SMALL_STATE(5106)] = 131500,
  [SMALL_STATE(5107)] = 131558,
  [SMALL_STATE(5108)] = 131616,
  [SMALL_STATE(5109)] = 131676,
  [SMALL_STATE(5110)] = 131742,
  [SMALL_STATE(5111)] = 131810,
  [SMALL_STATE(5112)] = 131910,
  [SMALL_STATE(5113)] = 131983,
  [SMALL_STATE(5114)] = 132036,
  [SMALL_STATE(5115)] = 132125,
  [SMALL_STATE(5116)] = 132214,
  [SMALL_STATE(5117)] = 132303,
  [SMALL_STATE(5118)] = 132362,
  [SMALL_STATE(5119)] = 132415,
  [SMALL_STATE(5120)] = 132518,
  [SMALL_STATE(5121)] = 132621,
  [SMALL_STATE(5122)] = 132710,
  [SMALL_STATE(5123)] = 132769,
  [SMALL_STATE(5124)] = 132858,
  [SMALL_STATE(5125)] = 132947,
  [SMALL_STATE(5126)] = 133036,
  [SMALL_STATE(5127)] = 133123,
  [SMALL_STATE(5128)] = 133230,
  [SMALL_STATE(5129)] = 133319,
  [SMALL_STATE(5130)] = 133406,
  [SMALL_STATE(5131)] = 133459,
  [SMALL_STATE(5132)] = 133548,
  [SMALL_STATE(5133)] = 133601,
  [SMALL_STATE(5134)] = 133654,
  [SMALL_STATE(5135)] = 133707,
  [SMALL_STATE(5136)] = 133796,
  [SMALL_STATE(5137)] = 133885,
  [SMALL_STATE(5138)] = 133938,
  [SMALL_STATE(5139)] = 134003,
  [SMALL_STATE(5140)] = 134072,
  [SMALL_STATE(5141)] = 134125,
  [SMALL_STATE(5142)] = 134214,
  [SMALL_STATE(5143)] = 134303,
  [SMALL_STATE(5144)] = 134392,
  [SMALL_STATE(5145)] = 134445,
  [SMALL_STATE(5146)] = 134504,
  [SMALL_STATE(5147)] = 134593,
  [SMALL_STATE(5148)] = 134646,
  [SMALL_STATE(5149)] = 134699,
  [SMALL_STATE(5150)] = 134758,
  [SMALL_STATE(5151)] = 134811,
  [SMALL_STATE(5152)] = 134870,
  [SMALL_STATE(5153)] = 134929,
  [SMALL_STATE(5154)] = 135018,
  [SMALL_STATE(5155)] = 135083,
  [SMALL_STATE(5156)] = 135172,
  [SMALL_STATE(5157)] = 135225,
  [SMALL_STATE(5158)] = 135278,
  [SMALL_STATE(5159)] = 135337,
  [SMALL_STATE(5160)] = 135396,
  [SMALL_STATE(5161)] = 135455,
  [SMALL_STATE(5162)] = 135514,
  [SMALL_STATE(5163)] = 135603,
  [SMALL_STATE(5164)] = 135672,
  [SMALL_STATE(5165)] = 135761,
  [SMALL_STATE(5166)] = 135820,
  [SMALL_STATE(5167)] = 135879,
  [SMALL_STATE(5168)] = 135938,
  [SMALL_STATE(5169)] = 135997,
  [SMALL_STATE(5170)] = 136056,
  [SMALL_STATE(5171)] = 136115,
  [SMALL_STATE(5172)] = 136218,
  [SMALL_STATE(5173)] = 136277,
  [SMALL_STATE(5174)] = 136336,
  [SMALL_STATE(5175)] = 136401,
  [SMALL_STATE(5176)] = 136466,
  [SMALL_STATE(5177)] = 136573,
  [SMALL_STATE(5178)] = 136626,
  [SMALL_STATE(5179)] = 136715,
  [SMALL_STATE(5180)] = 136822,
  [SMALL_STATE(5181)] = 136911,
  [SMALL_STATE(5182)] = 136964,
  [SMALL_STATE(5183)] = 137017,
  [SMALL_STATE(5184)] = 137106,
  [SMALL_STATE(5185)] = 137195,
  [SMALL_STATE(5186)] = 137284,
  [SMALL_STATE(5187)] = 137373,
  [SMALL_STATE(5188)] = 137462,
  [SMALL_STATE(5189)] = 137533,
  [SMALL_STATE(5190)] = 137632,
  [SMALL_STATE(5191)] = 137727,
  [SMALL_STATE(5192)] = 137820,
  [SMALL_STATE(5193)] = 137909,
  [SMALL_STATE(5194)] = 137996,
  [SMALL_STATE(5195)] = 138079,
  [SMALL_STATE(5196)] = 138158,
  [SMALL_STATE(5197)] = 138247,
  [SMALL_STATE(5198)] = 138300,
  [SMALL_STATE(5199)] = 138353,
  [SMALL_STATE(5200)] = 138406,
  [SMALL_STATE(5201)] = 138495,
  [SMALL_STATE(5202)] = 138584,
  [SMALL_STATE(5203)] = 138687,
  [SMALL_STATE(5204)] = 138776,
  [SMALL_STATE(5205)] = 138851,
  [SMALL_STATE(5206)] = 138904,
  [SMALL_STATE(5207)] = 138993,
  [SMALL_STATE(5208)] = 139046,
  [SMALL_STATE(5209)] = 139149,
  [SMALL_STATE(5210)] = 139256,
  [SMALL_STATE(5211)] = 139345,
  [SMALL_STATE(5212)] = 139401,
  [SMALL_STATE(5213)] = 139457,
  [SMALL_STATE(5214)] = 139541,
  [SMALL_STATE(5215)] = 139619,
  [SMALL_STATE(5216)] = 139687,
  [SMALL_STATE(5217)] = 139739,
  [SMALL_STATE(5218)] = 139791,
  [SMALL_STATE(5219)] = 139843,
  [SMALL_STATE(5220)] = 139895,
  [SMALL_STATE(5221)] = 139973,
  [SMALL_STATE(5222)] = 140061,
  [SMALL_STATE(5223)] = 140129,
  [SMALL_STATE(5224)] = 140217,
  [SMALL_STATE(5225)] = 140285,
  [SMALL_STATE(5226)] = 140337,
  [SMALL_STATE(5227)] = 140419,
  [SMALL_STATE(5228)] = 140471,
  [SMALL_STATE(5229)] = 140523,
  [SMALL_STATE(5230)] = 140605,
  [SMALL_STATE(5231)] = 140657,
  [SMALL_STATE(5232)] = 140713,
  [SMALL_STATE(5233)] = 140821,
  [SMALL_STATE(5234)] = 140873,
  [SMALL_STATE(5235)] = 140929,
  [SMALL_STATE(5236)] = 141007,
  [SMALL_STATE(5237)] = 141059,
  [SMALL_STATE(5238)] = 141149,
  [SMALL_STATE(5239)] = 141201,
  [SMALL_STATE(5240)] = 141263,
  [SMALL_STATE(5241)] = 141315,
  [SMALL_STATE(5242)] = 141405,
  [SMALL_STATE(5243)] = 141457,
  [SMALL_STATE(5244)] = 141547,
  [SMALL_STATE(5245)] = 141603,
  [SMALL_STATE(5246)] = 141655,
  [SMALL_STATE(5247)] = 141707,
  [SMALL_STATE(5248)] = 141759,
  [SMALL_STATE(5249)] = 141841,
  [SMALL_STATE(5250)] = 141897,
  [SMALL_STATE(5251)] = 141953,
  [SMALL_STATE(5252)] = 142037,
  [SMALL_STATE(5253)] = 142089,
  [SMALL_STATE(5254)] = 142143,
  [SMALL_STATE(5255)] = 142199,
  [SMALL_STATE(5256)] = 142287,
  [SMALL_STATE(5257)] = 142341,
  [SMALL_STATE(5258)] = 142397,
  [SMALL_STATE(5259)] = 142451,
  [SMALL_STATE(5260)] = 142507,
  [SMALL_STATE(5261)] = 142591,
  [SMALL_STATE(5262)] = 142643,
  [SMALL_STATE(5263)] = 142733,
  [SMALL_STATE(5264)] = 142789,
  [SMALL_STATE(5265)] = 142871,
  [SMALL_STATE(5266)] = 142927,
  [SMALL_STATE(5267)] = 142983,
  [SMALL_STATE(5268)] = 143039,
  [SMALL_STATE(5269)] = 143091,
  [SMALL_STATE(5270)] = 143147,
  [SMALL_STATE(5271)] = 143203,
  [SMALL_STATE(5272)] = 143259,
  [SMALL_STATE(5273)] = 143311,
  [SMALL_STATE(5274)] = 143367,
  [SMALL_STATE(5275)] = 143419,
  [SMALL_STATE(5276)] = 143475,
  [SMALL_STATE(5277)] = 143527,
  [SMALL_STATE(5278)] = 143583,
  [SMALL_STATE(5279)] = 143661,
  [SMALL_STATE(5280)] = 143769,
  [SMALL_STATE(5281)] = 143825,
  [SMALL_STATE(5282)] = 143881,
  [SMALL_STATE(5283)] = 143989,
  [SMALL_STATE(5284)] = 144057,
  [SMALL_STATE(5285)] = 144113,
  [SMALL_STATE(5286)] = 144169,
  [SMALL_STATE(5287)] = 144225,
  [SMALL_STATE(5288)] = 144287,
  [SMALL_STATE(5289)] = 144381,
  [SMALL_STATE(5290)] = 144435,
  [SMALL_STATE(5291)] = 144489,
  [SMALL_STATE(5292)] = 144541,
  [SMALL_STATE(5293)] = 144597,
  [SMALL_STATE(5294)] = 144653,
  [SMALL_STATE(5295)] = 144705,
  [SMALL_STATE(5296)] = 144761,
  [SMALL_STATE(5297)] = 144829,
  [SMALL_STATE(5298)] = 144917,
  [SMALL_STATE(5299)] = 145001,
  [SMALL_STATE(5300)] = 145082,
  [SMALL_STATE(5301)] = 145143,
  [SMALL_STATE(5302)] = 145230,
  [SMALL_STATE(5303)] = 145315,
  [SMALL_STATE(5304)] = 145400,
  [SMALL_STATE(5305)] = 145451,
  [SMALL_STATE(5306)] = 145502,
  [SMALL_STATE(5307)] = 145587,
  [SMALL_STATE(5308)] = 145640,
  [SMALL_STATE(5309)] = 145697,
  [SMALL_STATE(5310)] = 145758,
  [SMALL_STATE(5311)] = 145839,
  [SMALL_STATE(5312)] = 145924,
  [SMALL_STATE(5313)] = 146009,
  [SMALL_STATE(5314)] = 146094,
  [SMALL_STATE(5315)] = 146155,
  [SMALL_STATE(5316)] = 146232,
  [SMALL_STATE(5317)] = 146283,
  [SMALL_STATE(5318)] = 146340,
  [SMALL_STATE(5319)] = 146421,
  [SMALL_STATE(5320)] = 146502,
  [SMALL_STATE(5321)] = 146587,
  [SMALL_STATE(5322)] = 146672,
  [SMALL_STATE(5323)] = 146749,
  [SMALL_STATE(5324)] = 146834,
  [SMALL_STATE(5325)] = 146903,
  [SMALL_STATE(5326)] = 146954,
  [SMALL_STATE(5327)] = 147005,
  [SMALL_STATE(5328)] = 147086,
  [SMALL_STATE(5329)] = 147147,
  [SMALL_STATE(5330)] = 147208,
  [SMALL_STATE(5331)] = 147271,
  [SMALL_STATE(5332)] = 147326,
  [SMALL_STATE(5333)] = 147377,
  [SMALL_STATE(5334)] = 147462,
  [SMALL_STATE(5335)] = 147543,
  [SMALL_STATE(5336)] = 147600,
  [SMALL_STATE(5337)] = 147677,
  [SMALL_STATE(5338)] = 147754,
  [SMALL_STATE(5339)] = 147815,
  [SMALL_STATE(5340)] = 147874,
  [SMALL_STATE(5341)] = 147929,
  [SMALL_STATE(5342)] = 147982,
  [SMALL_STATE(5343)] = 148069,
  [SMALL_STATE(5344)] = 148119,
  [SMALL_STATE(5345)] = 148183,
  [SMALL_STATE(5346)] = 148233,
  [SMALL_STATE(5347)] = 148311,
  [SMALL_STATE(5348)] = 148361,
  [SMALL_STATE(5349)] = 148463,
  [SMALL_STATE(5350)] = 148513,
  [SMALL_STATE(5351)] = 148563,
  [SMALL_STATE(5352)] = 148613,
  [SMALL_STATE(5353)] = 148663,
  [SMALL_STATE(5354)] = 148713,
  [SMALL_STATE(5355)] = 148791,
  [SMALL_STATE(5356)] = 148869,
  [SMALL_STATE(5357)] = 148933,
  [SMALL_STATE(5358)] = 149005,
  [SMALL_STATE(5359)] = 149055,
  [SMALL_STATE(5360)] = 149105,
  [SMALL_STATE(5361)] = 149199,
  [SMALL_STATE(5362)] = 149249,
  [SMALL_STATE(5363)] = 149299,
  [SMALL_STATE(5364)] = 149373,
  [SMALL_STATE(5365)] = 149449,
  [SMALL_STATE(5366)] = 149527,
  [SMALL_STATE(5367)] = 149587,
  [SMALL_STATE(5368)] = 149647,
  [SMALL_STATE(5369)] = 149697,
  [SMALL_STATE(5370)] = 149791,
  [SMALL_STATE(5371)] = 149841,
  [SMALL_STATE(5372)] = 149933,
  [SMALL_STATE(5373)] = 150025,
  [SMALL_STATE(5374)] = 150075,
  [SMALL_STATE(5375)] = 150151,
  [SMALL_STATE(5376)] = 150249,
  [SMALL_STATE(5377)] = 150325,
  [SMALL_STATE(5378)] = 150423,
  [SMALL_STATE(5379)] = 150499,
  [SMALL_STATE(5380)] = 150595,
  [SMALL_STATE(5381)] = 150693,
  [SMALL_STATE(5382)] = 150785,
  [SMALL_STATE(5383)] = 150877,
  [SMALL_STATE(5384)] = 150963,
  [SMALL_STATE(5385)] = 151041,
  [SMALL_STATE(5386)] = 151107,
  [SMALL_STATE(5387)] = 151177,
  [SMALL_STATE(5388)] = 151259,
  [SMALL_STATE(5389)] = 151351,
  [SMALL_STATE(5390)] = 151411,
  [SMALL_STATE(5391)] = 151461,
  [SMALL_STATE(5392)] = 151511,
  [SMALL_STATE(5393)] = 151609,
  [SMALL_STATE(5394)] = 151695,
  [SMALL_STATE(5395)] = 151761,
  [SMALL_STATE(5396)] = 151849,
  [SMALL_STATE(5397)] = 151903,
  [SMALL_STATE(5398)] = 151953,
  [SMALL_STATE(5399)] = 152003,
  [SMALL_STATE(5400)] = 152081,
  [SMALL_STATE(5401)] = 152137,
  [SMALL_STATE(5402)] = 152187,
  [SMALL_STATE(5403)] = 152237,
  [SMALL_STATE(5404)] = 152287,
  [SMALL_STATE(5405)] = 152355,
  [SMALL_STATE(5406)] = 152441,
  [SMALL_STATE(5407)] = 152509,
  [SMALL_STATE(5408)] = 152587,
  [SMALL_STATE(5409)] = 152667,
  [SMALL_STATE(5410)] = 152759,
  [SMALL_STATE(5411)] = 152809,
  [SMALL_STATE(5412)] = 152891,
  [SMALL_STATE(5413)] = 152981,
  [SMALL_STATE(5414)] = 153077,
  [SMALL_STATE(5415)] = 153127,
  [SMALL_STATE(5416)] = 153177,
  [SMALL_STATE(5417)] = 153279,
  [SMALL_STATE(5418)] = 153375,
  [SMALL_STATE(5419)] = 153461,
  [SMALL_STATE(5420)] = 153557,
  [SMALL_STATE(5421)] = 153641,
  [SMALL_STATE(5422)] = 153735,
  [SMALL_STATE(5423)] = 153813,
  [SMALL_STATE(5424)] = 153893,
  [SMALL_STATE(5425)] = 153987,
  [SMALL_STATE(5426)] = 154045,
  [SMALL_STATE(5427)] = 154103,
  [SMALL_STATE(5428)] = 154193,
  [SMALL_STATE(5429)] = 154243,
  [SMALL_STATE(5430)] = 154293,
  [SMALL_STATE(5431)] = 154357,
  [SMALL_STATE(5432)] = 154437,
  [SMALL_STATE(5433)] = 154515,
  [SMALL_STATE(5434)] = 154565,
  [SMALL_STATE(5435)] = 154615,
  [SMALL_STATE(5436)] = 154689,
  [SMALL_STATE(5437)] = 154767,
  [SMALL_STATE(5438)] = 154817,
  [SMALL_STATE(5439)] = 154881,
  [SMALL_STATE(5440)] = 154931,
  [SMALL_STATE(5441)] = 155023,
  [SMALL_STATE(5442)] = 155093,
  [SMALL_STATE(5443)] = 155185,
  [SMALL_STATE(5444)] = 155265,
  [SMALL_STATE(5445)] = 155351,
  [SMALL_STATE(5446)] = 155449,
  [SMALL_STATE(5447)] = 155533,
  [SMALL_STATE(5448)] = 155587,
  [SMALL_STATE(5449)] = 155667,
  [SMALL_STATE(5450)] = 155747,
  [SMALL_STATE(5451)] = 155843,
  [SMALL_STATE(5452)] = 155915,
  [SMALL_STATE(5453)] = 155965,
  [SMALL_STATE(5454)] = 156015,
  [SMALL_STATE(5455)] = 156101,
  [SMALL_STATE(5456)] = 156151,
  [SMALL_STATE(5457)] = 156245,
  [SMALL_STATE(5458)] = 156344,
  [SMALL_STATE(5459)] = 156393,
  [SMALL_STATE(5460)] = 156492,
  [SMALL_STATE(5461)] = 156591,
  [SMALL_STATE(5462)] = 156690,
  [SMALL_STATE(5463)] = 156789,
  [SMALL_STATE(5464)] = 156888,
  [SMALL_STATE(5465)] = 156987,
  [SMALL_STATE(5466)] = 157070,
  [SMALL_STATE(5467)] = 157169,
  [SMALL_STATE(5468)] = 157224,
  [SMALL_STATE(5469)] = 157279,
  [SMALL_STATE(5470)] = 157364,
  [SMALL_STATE(5471)] = 157449,
  [SMALL_STATE(5472)] = 157548,
  [SMALL_STATE(5473)] = 157603,
  [SMALL_STATE(5474)] = 157662,
  [SMALL_STATE(5475)] = 157761,
  [SMALL_STATE(5476)] = 157858,
  [SMALL_STATE(5477)] = 157957,
  [SMALL_STATE(5478)] = 158056,
  [SMALL_STATE(5479)] = 158155,
  [SMALL_STATE(5480)] = 158210,
  [SMALL_STATE(5481)] = 158289,
  [SMALL_STATE(5482)] = 158368,
  [SMALL_STATE(5483)] = 158465,
  [SMALL_STATE(5484)] = 158564,
  [SMALL_STATE(5485)] = 158663,
  [SMALL_STATE(5486)] = 158762,
  [SMALL_STATE(5487)] = 158861,
  [SMALL_STATE(5488)] = 158960,
  [SMALL_STATE(5489)] = 159059,
  [SMALL_STATE(5490)] = 159110,
  [SMALL_STATE(5491)] = 159195,
  [SMALL_STATE(5492)] = 159294,
  [SMALL_STATE(5493)] = 159393,
  [SMALL_STATE(5494)] = 159492,
  [SMALL_STATE(5495)] = 159591,
  [SMALL_STATE(5496)] = 159648,
  [SMALL_STATE(5497)] = 159747,
  [SMALL_STATE(5498)] = 159846,
  [SMALL_STATE(5499)] = 159897,
  [SMALL_STATE(5500)] = 159996,
  [SMALL_STATE(5501)] = 160095,
  [SMALL_STATE(5502)] = 160194,
  [SMALL_STATE(5503)] = 160279,
  [SMALL_STATE(5504)] = 160378,
  [SMALL_STATE(5505)] = 160477,
  [SMALL_STATE(5506)] = 160576,
  [SMALL_STATE(5507)] = 160675,
  [SMALL_STATE(5508)] = 160774,
  [SMALL_STATE(5509)] = 160873,
  [SMALL_STATE(5510)] = 160972,
  [SMALL_STATE(5511)] = 161071,
  [SMALL_STATE(5512)] = 161170,
  [SMALL_STATE(5513)] = 161269,
  [SMALL_STATE(5514)] = 161328,
  [SMALL_STATE(5515)] = 161407,
  [SMALL_STATE(5516)] = 161506,
  [SMALL_STATE(5517)] = 161605,
  [SMALL_STATE(5518)] = 161704,
  [SMALL_STATE(5519)] = 161803,
  [SMALL_STATE(5520)] = 161902,
  [SMALL_STATE(5521)] = 162001,
  [SMALL_STATE(5522)] = 162100,
  [SMALL_STATE(5523)] = 162199,
  [SMALL_STATE(5524)] = 162298,
  [SMALL_STATE(5525)] = 162377,
  [SMALL_STATE(5526)] = 162476,
  [SMALL_STATE(5527)] = 162575,
  [SMALL_STATE(5528)] = 162674,
  [SMALL_STATE(5529)] = 162773,
  [SMALL_STATE(5530)] = 162872,
  [SMALL_STATE(5531)] = 162967,
  [SMALL_STATE(5532)] = 163066,
  [SMALL_STATE(5533)] = 163165,
  [SMALL_STATE(5534)] = 163264,
  [SMALL_STATE(5535)] = 163363,
  [SMALL_STATE(5536)] = 163462,
  [SMALL_STATE(5537)] = 163545,
  [SMALL_STATE(5538)] = 163600,
  [SMALL_STATE(5539)] = 163649,
  [SMALL_STATE(5540)] = 163698,
  [SMALL_STATE(5541)] = 163753,
  [SMALL_STATE(5542)] = 163852,
  [SMALL_STATE(5543)] = 163951,
  [SMALL_STATE(5544)] = 164050,
  [SMALL_STATE(5545)] = 164149,
  [SMALL_STATE(5546)] = 164248,
  [SMALL_STATE(5547)] = 164347,
  [SMALL_STATE(5548)] = 164446,
  [SMALL_STATE(5549)] = 164545,
  [SMALL_STATE(5550)] = 164594,
  [SMALL_STATE(5551)] = 164693,
  [SMALL_STATE(5552)] = 164792,
  [SMALL_STATE(5553)] = 164891,
  [SMALL_STATE(5554)] = 164970,
  [SMALL_STATE(5555)] = 165069,
  [SMALL_STATE(5556)] = 165168,
  [SMALL_STATE(5557)] = 165267,
  [SMALL_STATE(5558)] = 165322,
  [SMALL_STATE(5559)] = 165421,
  [SMALL_STATE(5560)] = 165520,
  [SMALL_STATE(5561)] = 165575,
  [SMALL_STATE(5562)] = 165674,
  [SMALL_STATE(5563)] = 165773,
  [SMALL_STATE(5564)] = 165872,
  [SMALL_STATE(5565)] = 165951,
  [SMALL_STATE(5566)] = 166050,
  [SMALL_STATE(5567)] = 166149,
  [SMALL_STATE(5568)] = 166248,
  [SMALL_STATE(5569)] = 166347,
  [SMALL_STATE(5570)] = 166446,
  [SMALL_STATE(5571)] = 166545,
  [SMALL_STATE(5572)] = 166644,
  [SMALL_STATE(5573)] = 166743,
  [SMALL_STATE(5574)] = 166842,
  [SMALL_STATE(5575)] = 166941,
  [SMALL_STATE(5576)] = 167040,
  [SMALL_STATE(5577)] = 167139,
  [SMALL_STATE(5578)] = 167238,
  [SMALL_STATE(5579)] = 167337,
  [SMALL_STATE(5580)] = 167436,
  [SMALL_STATE(5581)] = 167535,
  [SMALL_STATE(5582)] = 167634,
  [SMALL_STATE(5583)] = 167733,
  [SMALL_STATE(5584)] = 167832,
  [SMALL_STATE(5585)] = 167931,
  [SMALL_STATE(5586)] = 168030,
  [SMALL_STATE(5587)] = 168129,
  [SMALL_STATE(5588)] = 168228,
  [SMALL_STATE(5589)] = 168327,
  [SMALL_STATE(5590)] = 168388,
  [SMALL_STATE(5591)] = 168487,
  [SMALL_STATE(5592)] = 168586,
  [SMALL_STATE(5593)] = 168685,
  [SMALL_STATE(5594)] = 168744,
  [SMALL_STATE(5595)] = 168843,
  [SMALL_STATE(5596)] = 168942,
  [SMALL_STATE(5597)] = 169041,
  [SMALL_STATE(5598)] = 169140,
  [SMALL_STATE(5599)] = 169239,
  [SMALL_STATE(5600)] = 169338,
  [SMALL_STATE(5601)] = 169437,
  [SMALL_STATE(5602)] = 169536,
  [SMALL_STATE(5603)] = 169635,
  [SMALL_STATE(5604)] = 169734,
  [SMALL_STATE(5605)] = 169833,
  [SMALL_STATE(5606)] = 169932,
  [SMALL_STATE(5607)] = 170027,
  [SMALL_STATE(5608)] = 170080,
  [SMALL_STATE(5609)] = 170133,
  [SMALL_STATE(5610)] = 170232,
  [SMALL_STATE(5611)] = 170285,
  [SMALL_STATE(5612)] = 170338,
  [SMALL_STATE(5613)] = 170437,
  [SMALL_STATE(5614)] = 170490,
  [SMALL_STATE(5615)] = 170543,
  [SMALL_STATE(5616)] = 170596,
  [SMALL_STATE(5617)] = 170695,
  [SMALL_STATE(5618)] = 170748,
  [SMALL_STATE(5619)] = 170801,
  [SMALL_STATE(5620)] = 170854,
  [SMALL_STATE(5621)] = 170907,
  [SMALL_STATE(5622)] = 170960,
  [SMALL_STATE(5623)] = 171059,
  [SMALL_STATE(5624)] = 171158,
  [SMALL_STATE(5625)] = 171257,
  [SMALL_STATE(5626)] = 171311,
  [SMALL_STATE(5627)] = 171381,
  [SMALL_STATE(5628)] = 171441,
  [SMALL_STATE(5629)] = 171489,
  [SMALL_STATE(5630)] = 171537,
  [SMALL_STATE(5631)] = 171585,
  [SMALL_STATE(5632)] = 171633,
  [SMALL_STATE(5633)] = 171681,
  [SMALL_STATE(5634)] = 171729,
  [SMALL_STATE(5635)] = 171777,
  [SMALL_STATE(5636)] = 171827,
  [SMALL_STATE(5637)] = 171923,
  [SMALL_STATE(5638)] = 172019,
  [SMALL_STATE(5639)] = 172115,
  [SMALL_STATE(5640)] = 172211,
  [SMALL_STATE(5641)] = 172259,
  [SMALL_STATE(5642)] = 172313,
  [SMALL_STATE(5643)] = 172361,
  [SMALL_STATE(5644)] = 172409,
  [SMALL_STATE(5645)] = 172457,
  [SMALL_STATE(5646)] = 172505,
  [SMALL_STATE(5647)] = 172553,
  [SMALL_STATE(5648)] = 172649,
  [SMALL_STATE(5649)] = 172697,
  [SMALL_STATE(5650)] = 172791,
  [SMALL_STATE(5651)] = 172881,
  [SMALL_STATE(5652)] = 172977,
  [SMALL_STATE(5653)] = 173025,
  [SMALL_STATE(5654)] = 173073,
  [SMALL_STATE(5655)] = 173169,
  [SMALL_STATE(5656)] = 173265,
  [SMALL_STATE(5657)] = 173361,
  [SMALL_STATE(5658)] = 173409,
  [SMALL_STATE(5659)] = 173505,
  [SMALL_STATE(5660)] = 173583,
  [SMALL_STATE(5661)] = 173631,
  [SMALL_STATE(5662)] = 173725,
  [SMALL_STATE(5663)] = 173819,
  [SMALL_STATE(5664)] = 173867,
  [SMALL_STATE(5665)] = 173963,
  [SMALL_STATE(5666)] = 174053,
  [SMALL_STATE(5667)] = 174143,
  [SMALL_STATE(5668)] = 174239,
  [SMALL_STATE(5669)] = 174333,
  [SMALL_STATE(5670)] = 174427,
  [SMALL_STATE(5671)] = 174521,
  [SMALL_STATE(5672)] = 174617,
  [SMALL_STATE(5673)] = 174713,
  [SMALL_STATE(5674)] = 174787,
  [SMALL_STATE(5675)] = 174877,
  [SMALL_STATE(5676)] = 174971,
  [SMALL_STATE(5677)] = 175065,
  [SMALL_STATE(5678)] = 175161,
  [SMALL_STATE(5679)] = 175215,
  [SMALL_STATE(5680)] = 175305,
  [SMALL_STATE(5681)] = 175401,
  [SMALL_STATE(5682)] = 175475,
  [SMALL_STATE(5683)] = 175549,
  [SMALL_STATE(5684)] = 175603,
  [SMALL_STATE(5685)] = 175655,
  [SMALL_STATE(5686)] = 175751,
  [SMALL_STATE(5687)] = 175825,
  [SMALL_STATE(5688)] = 175877,
  [SMALL_STATE(5689)] = 175973,
  [SMALL_STATE(5690)] = 176049,
  [SMALL_STATE(5691)] = 176101,
  [SMALL_STATE(5692)] = 176197,
  [SMALL_STATE(5693)] = 176273,
  [SMALL_STATE(5694)] = 176349,
  [SMALL_STATE(5695)] = 176425,
  [SMALL_STATE(5696)] = 176501,
  [SMALL_STATE(5697)] = 176597,
  [SMALL_STATE(5698)] = 176673,
  [SMALL_STATE(5699)] = 176721,
  [SMALL_STATE(5700)] = 176815,
  [SMALL_STATE(5701)] = 176909,
  [SMALL_STATE(5702)] = 176963,
  [SMALL_STATE(5703)] = 177011,
  [SMALL_STATE(5704)] = 177087,
  [SMALL_STATE(5705)] = 177163,
  [SMALL_STATE(5706)] = 177259,
  [SMALL_STATE(5707)] = 177313,
  [SMALL_STATE(5708)] = 177387,
  [SMALL_STATE(5709)] = 177449,
  [SMALL_STATE(5710)] = 177543,
  [SMALL_STATE(5711)] = 177639,
  [SMALL_STATE(5712)] = 177711,
  [SMALL_STATE(5713)] = 177765,
  [SMALL_STATE(5714)] = 177819,
  [SMALL_STATE(5715)] = 177909,
  [SMALL_STATE(5716)] = 178003,
  [SMALL_STATE(5717)] = 178069,
  [SMALL_STATE(5718)] = 178165,
  [SMALL_STATE(5719)] = 178231,
  [SMALL_STATE(5720)] = 178283,
  [SMALL_STATE(5721)] = 178379,
  [SMALL_STATE(5722)] = 178431,
  [SMALL_STATE(5723)] = 178483,
  [SMALL_STATE(5724)] = 178535,
  [SMALL_STATE(5725)] = 178587,
  [SMALL_STATE(5726)] = 178681,
  [SMALL_STATE(5727)] = 178743,
  [SMALL_STATE(5728)] = 178797,
  [SMALL_STATE(5729)] = 178871,
  [SMALL_STATE(5730)] = 178925,
  [SMALL_STATE(5731)] = 178977,
  [SMALL_STATE(5732)] = 179031,
  [SMALL_STATE(5733)] = 179093,
  [SMALL_STATE(5734)] = 179189,
  [SMALL_STATE(5735)] = 179243,
  [SMALL_STATE(5736)] = 179305,
  [SMALL_STATE(5737)] = 179363,
  [SMALL_STATE(5738)] = 179443,
  [SMALL_STATE(5739)] = 179495,
  [SMALL_STATE(5740)] = 179585,
  [SMALL_STATE(5741)] = 179637,
  [SMALL_STATE(5742)] = 179689,
  [SMALL_STATE(5743)] = 179783,
  [SMALL_STATE(5744)] = 179879,
  [SMALL_STATE(5745)] = 179967,
  [SMALL_STATE(5746)] = 180015,
  [SMALL_STATE(5747)] = 180109,
  [SMALL_STATE(5748)] = 180199,
  [SMALL_STATE(5749)] = 180293,
  [SMALL_STATE(5750)] = 180341,
  [SMALL_STATE(5751)] = 180437,
  [SMALL_STATE(5752)] = 180533,
  [SMALL_STATE(5753)] = 180581,
  [SMALL_STATE(5754)] = 180629,
  [SMALL_STATE(5755)] = 180677,
  [SMALL_STATE(5756)] = 180773,
  [SMALL_STATE(5757)] = 180847,
  [SMALL_STATE(5758)] = 180901,
  [SMALL_STATE(5759)] = 180955,
  [SMALL_STATE(5760)] = 181045,
  [SMALL_STATE(5761)] = 181093,
  [SMALL_STATE(5762)] = 181141,
  [SMALL_STATE(5763)] = 181189,
  [SMALL_STATE(5764)] = 181251,
  [SMALL_STATE(5765)] = 181347,
  [SMALL_STATE(5766)] = 181409,
  [SMALL_STATE(5767)] = 181469,
  [SMALL_STATE(5768)] = 181517,
  [SMALL_STATE(5769)] = 181611,
  [SMALL_STATE(5770)] = 181705,
  [SMALL_STATE(5771)] = 181791,
  [SMALL_STATE(5772)] = 181869,
  [SMALL_STATE(5773)] = 181963,
  [SMALL_STATE(5774)] = 182059,
  [SMALL_STATE(5775)] = 182155,
  [SMALL_STATE(5776)] = 182221,
  [SMALL_STATE(5777)] = 182301,
  [SMALL_STATE(5778)] = 182389,
  [SMALL_STATE(5779)] = 182441,
  [SMALL_STATE(5780)] = 182537,
  [SMALL_STATE(5781)] = 182631,
  [SMALL_STATE(5782)] = 182717,
  [SMALL_STATE(5783)] = 182795,
  [SMALL_STATE(5784)] = 182847,
  [SMALL_STATE(5785)] = 182927,
  [SMALL_STATE(5786)] = 183021,
  [SMALL_STATE(5787)] = 183115,
  [SMALL_STATE(5788)] = 183209,
  [SMALL_STATE(5789)] = 183293,
  [SMALL_STATE(5790)] = 183383,
  [SMALL_STATE(5791)] = 183477,
  [SMALL_STATE(5792)] = 183543,
  [SMALL_STATE(5793)] = 183631,
  [SMALL_STATE(5794)] = 183717,
  [SMALL_STATE(5795)] = 183801,
  [SMALL_STATE(5796)] = 183883,
  [SMALL_STATE(5797)] = 183961,
  [SMALL_STATE(5798)] = 184037,
  [SMALL_STATE(5799)] = 184109,
  [SMALL_STATE(5800)] = 184177,
  [SMALL_STATE(5801)] = 184247,
  [SMALL_STATE(5802)] = 184337,
  [SMALL_STATE(5803)] = 184431,
  [SMALL_STATE(5804)] = 184521,
  [SMALL_STATE(5805)] = 184615,
  [SMALL_STATE(5806)] = 184709,
  [SMALL_STATE(5807)] = 184763,
  [SMALL_STATE(5808)] = 184815,
  [SMALL_STATE(5809)] = 184905,
  [SMALL_STATE(5810)] = 184983,
  [SMALL_STATE(5811)] = 185073,
  [SMALL_STATE(5812)] = 185155,
  [SMALL_STATE(5813)] = 185207,
  [SMALL_STATE(5814)] = 185261,
  [SMALL_STATE(5815)] = 185357,
  [SMALL_STATE(5816)] = 185451,
  [SMALL_STATE(5817)] = 185531,
  [SMALL_STATE(5818)] = 185583,
  [SMALL_STATE(5819)] = 185635,
  [SMALL_STATE(5820)] = 185713,
  [SMALL_STATE(5821)] = 185805,
  [SMALL_STATE(5822)] = 185901,
  [SMALL_STATE(5823)] = 185949,
  [SMALL_STATE(5824)] = 186043,
  [SMALL_STATE(5825)] = 186139,
  [SMALL_STATE(5826)] = 186191,
  [SMALL_STATE(5827)] = 186243,
  [SMALL_STATE(5828)] = 186291,
  [SMALL_STATE(5829)] = 186343,
  [SMALL_STATE(5830)] = 186403,
  [SMALL_STATE(5831)] = 186465,
  [SMALL_STATE(5832)] = 186517,
  [SMALL_STATE(5833)] = 186579,
  [SMALL_STATE(5834)] = 186631,
  [SMALL_STATE(5835)] = 186691,
  [SMALL_STATE(5836)] = 186743,
  [SMALL_STATE(5837)] = 186819,
  [SMALL_STATE(5838)] = 186867,
  [SMALL_STATE(5839)] = 186931,
  [SMALL_STATE(5840)] = 186979,
  [SMALL_STATE(5841)] = 187027,
  [SMALL_STATE(5842)] = 187079,
  [SMALL_STATE(5843)] = 187131,
  [SMALL_STATE(5844)] = 187203,
  [SMALL_STATE(5845)] = 187257,
  [SMALL_STATE(5846)] = 187353,
  [SMALL_STATE(5847)] = 187401,
  [SMALL_STATE(5848)] = 187495,
  [SMALL_STATE(5849)] = 187543,
  [SMALL_STATE(5850)] = 187591,
  [SMALL_STATE(5851)] = 187639,
  [SMALL_STATE(5852)] = 187735,
  [SMALL_STATE(5853)] = 187783,
  [SMALL_STATE(5854)] = 187851,
  [SMALL_STATE(5855)] = 187947,
  [SMALL_STATE(5856)] = 188043,
  [SMALL_STATE(5857)] = 188137,
  [SMALL_STATE(5858)] = 188233,
  [SMALL_STATE(5859)] = 188317,
  [SMALL_STATE(5860)] = 188399,
  [SMALL_STATE(5861)] = 188495,
  [SMALL_STATE(5862)] = 188573,
  [SMALL_STATE(5863)] = 188649,
  [SMALL_STATE(5864)] = 188743,
  [SMALL_STATE(5865)] = 188817,
  [SMALL_STATE(5866)] = 188891,
  [SMALL_STATE(5867)] = 188987,
  [SMALL_STATE(5868)] = 189055,
  [SMALL_STATE(5869)] = 189151,
  [SMALL_STATE(5870)] = 189213,
  [SMALL_STATE(5871)] = 189307,
  [SMALL_STATE(5872)] = 189355,
  [SMALL_STATE(5873)] = 189417,
  [SMALL_STATE(5874)] = 189465,
  [SMALL_STATE(5875)] = 189555,
  [SMALL_STATE(5876)] = 189648,
  [SMALL_STATE(5877)] = 189725,
  [SMALL_STATE(5878)] = 189818,
  [SMALL_STATE(5879)] = 189871,
  [SMALL_STATE(5880)] = 189964,
  [SMALL_STATE(5881)] = 190057,
  [SMALL_STATE(5882)] = 190150,
  [SMALL_STATE(5883)] = 190243,
  [SMALL_STATE(5884)] = 190290,
  [SMALL_STATE(5885)] = 190337,
  [SMALL_STATE(5886)] = 190430,
  [SMALL_STATE(5887)] = 190523,
  [SMALL_STATE(5888)] = 190616,
  [SMALL_STATE(5889)] = 190663,
  [SMALL_STATE(5890)] = 190710,
  [SMALL_STATE(5891)] = 190803,
  [SMALL_STATE(5892)] = 190896,
  [SMALL_STATE(5893)] = 190989,
  [SMALL_STATE(5894)] = 191066,
  [SMALL_STATE(5895)] = 191113,
  [SMALL_STATE(5896)] = 191206,
  [SMALL_STATE(5897)] = 191253,
  [SMALL_STATE(5898)] = 191346,
  [SMALL_STATE(5899)] = 191439,
  [SMALL_STATE(5900)] = 191532,
  [SMALL_STATE(5901)] = 191625,
  [SMALL_STATE(5902)] = 191718,
  [SMALL_STATE(5903)] = 191791,
  [SMALL_STATE(5904)] = 191884,
  [SMALL_STATE(5905)] = 191977,
  [SMALL_STATE(5906)] = 192070,
  [SMALL_STATE(5907)] = 192163,
  [SMALL_STATE(5908)] = 192256,
  [SMALL_STATE(5909)] = 192349,
  [SMALL_STATE(5910)] = 192396,
  [SMALL_STATE(5911)] = 192489,
  [SMALL_STATE(5912)] = 192536,
  [SMALL_STATE(5913)] = 192591,
  [SMALL_STATE(5914)] = 192638,
  [SMALL_STATE(5915)] = 192731,
  [SMALL_STATE(5916)] = 192824,
  [SMALL_STATE(5917)] = 192917,
  [SMALL_STATE(5918)] = 193010,
  [SMALL_STATE(5919)] = 193103,
  [SMALL_STATE(5920)] = 193196,
  [SMALL_STATE(5921)] = 193289,
  [SMALL_STATE(5922)] = 193382,
  [SMALL_STATE(5923)] = 193429,
  [SMALL_STATE(5924)] = 193522,
  [SMALL_STATE(5925)] = 193615,
  [SMALL_STATE(5926)] = 193708,
  [SMALL_STATE(5927)] = 193755,
  [SMALL_STATE(5928)] = 193848,
  [SMALL_STATE(5929)] = 193921,
  [SMALL_STATE(5930)] = 194014,
  [SMALL_STATE(5931)] = 194061,
  [SMALL_STATE(5932)] = 194108,
  [SMALL_STATE(5933)] = 194201,
  [SMALL_STATE(5934)] = 194294,
  [SMALL_STATE(5935)] = 194387,
  [SMALL_STATE(5936)] = 194480,
  [SMALL_STATE(5937)] = 194573,
  [SMALL_STATE(5938)] = 194666,
  [SMALL_STATE(5939)] = 194713,
  [SMALL_STATE(5940)] = 194806,
  [SMALL_STATE(5941)] = 194899,
  [SMALL_STATE(5942)] = 194946,
  [SMALL_STATE(5943)] = 195039,
  [SMALL_STATE(5944)] = 195116,
  [SMALL_STATE(5945)] = 195163,
  [SMALL_STATE(5946)] = 195236,
  [SMALL_STATE(5947)] = 195329,
  [SMALL_STATE(5948)] = 195422,
  [SMALL_STATE(5949)] = 195515,
  [SMALL_STATE(5950)] = 195608,
  [SMALL_STATE(5951)] = 195701,
  [SMALL_STATE(5952)] = 195748,
  [SMALL_STATE(5953)] = 195841,
  [SMALL_STATE(5954)] = 195888,
  [SMALL_STATE(5955)] = 195961,
  [SMALL_STATE(5956)] = 196054,
  [SMALL_STATE(5957)] = 196101,
  [SMALL_STATE(5958)] = 196148,
  [SMALL_STATE(5959)] = 196221,
  [SMALL_STATE(5960)] = 196268,
  [SMALL_STATE(5961)] = 196361,
  [SMALL_STATE(5962)] = 196454,
  [SMALL_STATE(5963)] = 196547,
  [SMALL_STATE(5964)] = 196640,
  [SMALL_STATE(5965)] = 196687,
  [SMALL_STATE(5966)] = 196780,
  [SMALL_STATE(5967)] = 196827,
  [SMALL_STATE(5968)] = 196920,
  [SMALL_STATE(5969)] = 196975,
  [SMALL_STATE(5970)] = 197030,
  [SMALL_STATE(5971)] = 197087,
  [SMALL_STATE(5972)] = 197180,
  [SMALL_STATE(5973)] = 197273,
  [SMALL_STATE(5974)] = 197320,
  [SMALL_STATE(5975)] = 197413,
  [SMALL_STATE(5976)] = 197506,
  [SMALL_STATE(5977)] = 197555,
  [SMALL_STATE(5978)] = 197606,
  [SMALL_STATE(5979)] = 197699,
  [SMALL_STATE(5980)] = 197792,
  [SMALL_STATE(5981)] = 197865,
  [SMALL_STATE(5982)] = 197912,
  [SMALL_STATE(5983)] = 198005,
  [SMALL_STATE(5984)] = 198052,
  [SMALL_STATE(5985)] = 198099,
  [SMALL_STATE(5986)] = 198192,
  [SMALL_STATE(5987)] = 198243,
  [SMALL_STATE(5988)] = 198336,
  [SMALL_STATE(5989)] = 198383,
  [SMALL_STATE(5990)] = 198476,
  [SMALL_STATE(5991)] = 198569,
  [SMALL_STATE(5992)] = 198662,
  [SMALL_STATE(5993)] = 198709,
  [SMALL_STATE(5994)] = 198802,
  [SMALL_STATE(5995)] = 198895,
  [SMALL_STATE(5996)] = 198946,
  [SMALL_STATE(5997)] = 199039,
  [SMALL_STATE(5998)] = 199132,
  [SMALL_STATE(5999)] = 199179,
  [SMALL_STATE(6000)] = 199272,
  [SMALL_STATE(6001)] = 199349,
  [SMALL_STATE(6002)] = 199436,
  [SMALL_STATE(6003)] = 199529,
  [SMALL_STATE(6004)] = 199622,
  [SMALL_STATE(6005)] = 199715,
  [SMALL_STATE(6006)] = 199764,
  [SMALL_STATE(6007)] = 199811,
  [SMALL_STATE(6008)] = 199904,
  [SMALL_STATE(6009)] = 199951,
  [SMALL_STATE(6010)] = 200044,
  [SMALL_STATE(6011)] = 200137,
  [SMALL_STATE(6012)] = 200230,
  [SMALL_STATE(6013)] = 200323,
  [SMALL_STATE(6014)] = 200416,
  [SMALL_STATE(6015)] = 200509,
  [SMALL_STATE(6016)] = 200556,
  [SMALL_STATE(6017)] = 200649,
  [SMALL_STATE(6018)] = 200742,
  [SMALL_STATE(6019)] = 200789,
  [SMALL_STATE(6020)] = 200882,
  [SMALL_STATE(6021)] = 200975,
  [SMALL_STATE(6022)] = 201048,
  [SMALL_STATE(6023)] = 201121,
  [SMALL_STATE(6024)] = 201214,
  [SMALL_STATE(6025)] = 201307,
  [SMALL_STATE(6026)] = 201400,
  [SMALL_STATE(6027)] = 201447,
  [SMALL_STATE(6028)] = 201540,
  [SMALL_STATE(6029)] = 201587,
  [SMALL_STATE(6030)] = 201680,
  [SMALL_STATE(6031)] = 201773,
  [SMALL_STATE(6032)] = 201866,
  [SMALL_STATE(6033)] = 201913,
  [SMALL_STATE(6034)] = 201986,
  [SMALL_STATE(6035)] = 202079,
  [SMALL_STATE(6036)] = 202152,
  [SMALL_STATE(6037)] = 202225,
  [SMALL_STATE(6038)] = 202318,
  [SMALL_STATE(6039)] = 202365,
  [SMALL_STATE(6040)] = 202412,
  [SMALL_STATE(6041)] = 202505,
  [SMALL_STATE(6042)] = 202598,
  [SMALL_STATE(6043)] = 202685,
  [SMALL_STATE(6044)] = 202772,
  [SMALL_STATE(6045)] = 202827,
  [SMALL_STATE(6046)] = 202920,
  [SMALL_STATE(6047)] = 203013,
  [SMALL_STATE(6048)] = 203106,
  [SMALL_STATE(6049)] = 203199,
  [SMALL_STATE(6050)] = 203286,
  [SMALL_STATE(6051)] = 203379,
  [SMALL_STATE(6052)] = 203472,
  [SMALL_STATE(6053)] = 203565,
  [SMALL_STATE(6054)] = 203612,
  [SMALL_STATE(6055)] = 203705,
  [SMALL_STATE(6056)] = 203798,
  [SMALL_STATE(6057)] = 203845,
  [SMALL_STATE(6058)] = 203938,
  [SMALL_STATE(6059)] = 204031,
  [SMALL_STATE(6060)] = 204124,
  [SMALL_STATE(6061)] = 204217,
  [SMALL_STATE(6062)] = 204310,
  [SMALL_STATE(6063)] = 204403,
  [SMALL_STATE(6064)] = 204476,
  [SMALL_STATE(6065)] = 204569,
  [SMALL_STATE(6066)] = 204662,
  [SMALL_STATE(6067)] = 204713,
  [SMALL_STATE(6068)] = 204763,
  [SMALL_STATE(6069)] = 204851,
  [SMALL_STATE(6070)] = 204897,
  [SMALL_STATE(6071)] = 204943,
  [SMALL_STATE(6072)] = 205035,
  [SMALL_STATE(6073)] = 205081,
  [SMALL_STATE(6074)] = 205153,
  [SMALL_STATE(6075)] = 205215,
  [SMALL_STATE(6076)] = 205261,
  [SMALL_STATE(6077)] = 205307,
  [SMALL_STATE(6078)] = 205353,
  [SMALL_STATE(6079)] = 205399,
  [SMALL_STATE(6080)] = 205487,
  [SMALL_STATE(6081)] = 205533,
  [SMALL_STATE(6082)] = 205587,
  [SMALL_STATE(6083)] = 205633,
  [SMALL_STATE(6084)] = 205709,
  [SMALL_STATE(6085)] = 205797,
  [SMALL_STATE(6086)] = 205881,
  [SMALL_STATE(6087)] = 205927,
  [SMALL_STATE(6088)] = 206015,
  [SMALL_STATE(6089)] = 206063,
  [SMALL_STATE(6090)] = 206123,
  [SMALL_STATE(6091)] = 206183,
  [SMALL_STATE(6092)] = 206229,
  [SMALL_STATE(6093)] = 206313,
  [SMALL_STATE(6094)] = 206359,
  [SMALL_STATE(6095)] = 206405,
  [SMALL_STATE(6096)] = 206493,
  [SMALL_STATE(6097)] = 206581,
  [SMALL_STATE(6098)] = 206669,
  [SMALL_STATE(6099)] = 206757,
  [SMALL_STATE(6100)] = 206833,
  [SMALL_STATE(6101)] = 206917,
  [SMALL_STATE(6102)] = 207009,
  [SMALL_STATE(6103)] = 207055,
  [SMALL_STATE(6104)] = 207143,
  [SMALL_STATE(6105)] = 207227,
  [SMALL_STATE(6106)] = 207277,
  [SMALL_STATE(6107)] = 207323,
  [SMALL_STATE(6108)] = 207407,
  [SMALL_STATE(6109)] = 207453,
  [SMALL_STATE(6110)] = 207545,
  [SMALL_STATE(6111)] = 207591,
  [SMALL_STATE(6112)] = 207675,
  [SMALL_STATE(6113)] = 207735,
  [SMALL_STATE(6114)] = 207781,
  [SMALL_STATE(6115)] = 207853,
  [SMALL_STATE(6116)] = 207941,
  [SMALL_STATE(6117)] = 207987,
  [SMALL_STATE(6118)] = 208033,
  [SMALL_STATE(6119)] = 208091,
  [SMALL_STATE(6120)] = 208179,
  [SMALL_STATE(6121)] = 208237,
  [SMALL_STATE(6122)] = 208283,
  [SMALL_STATE(6123)] = 208355,
  [SMALL_STATE(6124)] = 208411,
  [SMALL_STATE(6125)] = 208499,
  [SMALL_STATE(6126)] = 208549,
  [SMALL_STATE(6127)] = 208635,
  [SMALL_STATE(6128)] = 208721,
  [SMALL_STATE(6129)] = 208811,
  [SMALL_STATE(6130)] = 208857,
  [SMALL_STATE(6131)] = 208945,
  [SMALL_STATE(6132)] = 209005,
  [SMALL_STATE(6133)] = 209081,
  [SMALL_STATE(6134)] = 209169,
  [SMALL_STATE(6135)] = 209257,
  [SMALL_STATE(6136)] = 209341,
  [SMALL_STATE(6137)] = 209387,
  [SMALL_STATE(6138)] = 209459,
  [SMALL_STATE(6139)] = 209531,
  [SMALL_STATE(6140)] = 209617,
  [SMALL_STATE(6141)] = 209689,
  [SMALL_STATE(6142)] = 209761,
  [SMALL_STATE(6143)] = 209849,
  [SMALL_STATE(6144)] = 209895,
  [SMALL_STATE(6145)] = 209941,
  [SMALL_STATE(6146)] = 209987,
  [SMALL_STATE(6147)] = 210033,
  [SMALL_STATE(6148)] = 210079,
  [SMALL_STATE(6149)] = 210125,
  [SMALL_STATE(6150)] = 210171,
  [SMALL_STATE(6151)] = 210217,
  [SMALL_STATE(6152)] = 210263,
  [SMALL_STATE(6153)] = 210349,
  [SMALL_STATE(6154)] = 210395,
  [SMALL_STATE(6155)] = 210471,
  [SMALL_STATE(6156)] = 210517,
  [SMALL_STATE(6157)] = 210563,
  [SMALL_STATE(6158)] = 210609,
  [SMALL_STATE(6159)] = 210683,
  [SMALL_STATE(6160)] = 210757,
  [SMALL_STATE(6161)] = 210845,
  [SMALL_STATE(6162)] = 210919,
  [SMALL_STATE(6163)] = 210993,
  [SMALL_STATE(6164)] = 211065,
  [SMALL_STATE(6165)] = 211153,
  [SMALL_STATE(6166)] = 211239,
  [SMALL_STATE(6167)] = 211289,
  [SMALL_STATE(6168)] = 211381,
  [SMALL_STATE(6169)] = 211427,
  [SMALL_STATE(6170)] = 211514,
  [SMALL_STATE(6171)] = 211569,
  [SMALL_STATE(6172)] = 211624,
  [SMALL_STATE(6173)] = 211697,
  [SMALL_STATE(6174)] = 211768,
  [SMALL_STATE(6175)] = 211853,
  [SMALL_STATE(6176)] = 211924,
  [SMALL_STATE(6177)] = 211995,
  [SMALL_STATE(6178)] = 212048,
  [SMALL_STATE(6179)] = 212101,
  [SMALL_STATE(6180)] = 212176,
  [SMALL_STATE(6181)] = 212247,
  [SMALL_STATE(6182)] = 212318,
  [SMALL_STATE(6183)] = 212403,
  [SMALL_STATE(6184)] = 212456,
  [SMALL_STATE(6185)] = 212513,
  [SMALL_STATE(6186)] = 212584,
  [SMALL_STATE(6187)] = 212655,
  [SMALL_STATE(6188)] = 212726,
  [SMALL_STATE(6189)] = 212787,
  [SMALL_STATE(6190)] = 212846,
  [SMALL_STATE(6191)] = 212905,
  [SMALL_STATE(6192)] = 212980,
  [SMALL_STATE(6193)] = 213055,
  [SMALL_STATE(6194)] = 213126,
  [SMALL_STATE(6195)] = 213199,
  [SMALL_STATE(6196)] = 213270,
  [SMALL_STATE(6197)] = 213341,
  [SMALL_STATE(6198)] = 213414,
  [SMALL_STATE(6199)] = 213487,
  [SMALL_STATE(6200)] = 213578,
  [SMALL_STATE(6201)] = 213635,
  [SMALL_STATE(6202)] = 213684,
  [SMALL_STATE(6203)] = 213757,
  [SMALL_STATE(6204)] = 213830,
  [SMALL_STATE(6205)] = 213901,
  [SMALL_STATE(6206)] = 213974,
  [SMALL_STATE(6207)] = 214023,
  [SMALL_STATE(6208)] = 214096,
  [SMALL_STATE(6209)] = 214149,
  [SMALL_STATE(6210)] = 214222,
  [SMALL_STATE(6211)] = 214297,
  [SMALL_STATE(6212)] = 214370,
  [SMALL_STATE(6213)] = 214443,
  [SMALL_STATE(6214)] = 214516,
  [SMALL_STATE(6215)] = 214569,
  [SMALL_STATE(6216)] = 214660,
  [SMALL_STATE(6217)] = 214733,
  [SMALL_STATE(6218)] = 214824,
  [SMALL_STATE(6219)] = 214897,
  [SMALL_STATE(6220)] = 214944,
  [SMALL_STATE(6221)] = 215017,
  [SMALL_STATE(6222)] = 215090,
  [SMALL_STATE(6223)] = 215163,
  [SMALL_STATE(6224)] = 215224,
  [SMALL_STATE(6225)] = 215281,
  [SMALL_STATE(6226)] = 215338,
  [SMALL_STATE(6227)] = 215423,
  [SMALL_STATE(6228)] = 215510,
  [SMALL_STATE(6229)] = 215595,
  [SMALL_STATE(6230)] = 215678,
  [SMALL_STATE(6231)] = 215751,
  [SMALL_STATE(6232)] = 215824,
  [SMALL_STATE(6233)] = 215897,
  [SMALL_STATE(6234)] = 215970,
  [SMALL_STATE(6235)] = 216045,
  [SMALL_STATE(6236)] = 216102,
  [SMALL_STATE(6237)] = 216177,
  [SMALL_STATE(6238)] = 216259,
  [SMALL_STATE(6239)] = 216303,
  [SMALL_STATE(6240)] = 216393,
  [SMALL_STATE(6241)] = 216437,
  [SMALL_STATE(6242)] = 216515,
  [SMALL_STATE(6243)] = 216597,
  [SMALL_STATE(6244)] = 216675,
  [SMALL_STATE(6245)] = 216757,
  [SMALL_STATE(6246)] = 216835,
  [SMALL_STATE(6247)] = 216917,
  [SMALL_STATE(6248)] = 216987,
  [SMALL_STATE(6249)] = 217065,
  [SMALL_STATE(6250)] = 217147,
  [SMALL_STATE(6251)] = 217229,
  [SMALL_STATE(6252)] = 217311,
  [SMALL_STATE(6253)] = 217389,
  [SMALL_STATE(6254)] = 217471,
  [SMALL_STATE(6255)] = 217553,
  [SMALL_STATE(6256)] = 217631,
  [SMALL_STATE(6257)] = 217713,
  [SMALL_STATE(6258)] = 217791,
  [SMALL_STATE(6259)] = 217873,
  [SMALL_STATE(6260)] = 217955,
  [SMALL_STATE(6261)] = 218037,
  [SMALL_STATE(6262)] = 218127,
  [SMALL_STATE(6263)] = 218209,
  [SMALL_STATE(6264)] = 218291,
  [SMALL_STATE(6265)] = 218373,
  [SMALL_STATE(6266)] = 218455,
  [SMALL_STATE(6267)] = 218537,
  [SMALL_STATE(6268)] = 218619,
  [SMALL_STATE(6269)] = 218663,
  [SMALL_STATE(6270)] = 218733,
  [SMALL_STATE(6271)] = 218815,
  [SMALL_STATE(6272)] = 218897,
  [SMALL_STATE(6273)] = 218979,
  [SMALL_STATE(6274)] = 219061,
  [SMALL_STATE(6275)] = 219143,
  [SMALL_STATE(6276)] = 219213,
  [SMALL_STATE(6277)] = 219297,
  [SMALL_STATE(6278)] = 219379,
  [SMALL_STATE(6279)] = 219463,
  [SMALL_STATE(6280)] = 219533,
  [SMALL_STATE(6281)] = 219603,
  [SMALL_STATE(6282)] = 219685,
  [SMALL_STATE(6283)] = 219763,
  [SMALL_STATE(6284)] = 219845,
  [SMALL_STATE(6285)] = 219915,
  [SMALL_STATE(6286)] = 219985,
  [SMALL_STATE(6287)] = 220063,
  [SMALL_STATE(6288)] = 220145,
  [SMALL_STATE(6289)] = 220223,
  [SMALL_STATE(6290)] = 220305,
  [SMALL_STATE(6291)] = 220387,
  [SMALL_STATE(6292)] = 220459,
  [SMALL_STATE(6293)] = 220531,
  [SMALL_STATE(6294)] = 220613,
  [SMALL_STATE(6295)] = 220695,
  [SMALL_STATE(6296)] = 220777,
  [SMALL_STATE(6297)] = 220849,
  [SMALL_STATE(6298)] = 220931,
  [SMALL_STATE(6299)] = 221013,
  [SMALL_STATE(6300)] = 221085,
  [SMALL_STATE(6301)] = 221163,
  [SMALL_STATE(6302)] = 221235,
  [SMALL_STATE(6303)] = 221305,
  [SMALL_STATE(6304)] = 221387,
  [SMALL_STATE(6305)] = 221469,
  [SMALL_STATE(6306)] = 221551,
  [SMALL_STATE(6307)] = 221633,
  [SMALL_STATE(6308)] = 221715,
  [SMALL_STATE(6309)] = 221793,
  [SMALL_STATE(6310)] = 221875,
  [SMALL_STATE(6311)] = 221957,
  [SMALL_STATE(6312)] = 222039,
  [SMALL_STATE(6313)] = 222117,
  [SMALL_STATE(6314)] = 222199,
  [SMALL_STATE(6315)] = 222281,
  [SMALL_STATE(6316)] = 222363,
  [SMALL_STATE(6317)] = 222445,
  [SMALL_STATE(6318)] = 222529,
  [SMALL_STATE(6319)] = 222611,
  [SMALL_STATE(6320)] = 222701,
  [SMALL_STATE(6321)] = 222779,
  [SMALL_STATE(6322)] = 222863,
  [SMALL_STATE(6323)] = 222941,
  [SMALL_STATE(6324)] = 223023,
  [SMALL_STATE(6325)] = 223071,
  [SMALL_STATE(6326)] = 223149,
  [SMALL_STATE(6327)] = 223227,
  [SMALL_STATE(6328)] = 223309,
  [SMALL_STATE(6329)] = 223391,
  [SMALL_STATE(6330)] = 223435,
  [SMALL_STATE(6331)] = 223517,
  [SMALL_STATE(6332)] = 223599,
  [SMALL_STATE(6333)] = 223681,
  [SMALL_STATE(6334)] = 223763,
  [SMALL_STATE(6335)] = 223845,
  [SMALL_STATE(6336)] = 223923,
  [SMALL_STATE(6337)] = 223967,
  [SMALL_STATE(6338)] = 224049,
  [SMALL_STATE(6339)] = 224127,
  [SMALL_STATE(6340)] = 224217,
  [SMALL_STATE(6341)] = 224269,
  [SMALL_STATE(6342)] = 224347,
  [SMALL_STATE(6343)] = 224429,
  [SMALL_STATE(6344)] = 224511,
  [SMALL_STATE(6345)] = 224593,
  [SMALL_STATE(6346)] = 224675,
  [SMALL_STATE(6347)] = 224757,
  [SMALL_STATE(6348)] = 224839,
  [SMALL_STATE(6349)] = 224911,
  [SMALL_STATE(6350)] = 224983,
  [SMALL_STATE(6351)] = 225065,
  [SMALL_STATE(6352)] = 225143,
  [SMALL_STATE(6353)] = 225225,
  [SMALL_STATE(6354)] = 225297,
  [SMALL_STATE(6355)] = 225379,
  [SMALL_STATE(6356)] = 225461,
  [SMALL_STATE(6357)] = 225539,
  [SMALL_STATE(6358)] = 225621,
  [SMALL_STATE(6359)] = 225706,
  [SMALL_STATE(6360)] = 225775,
  [SMALL_STATE(6361)] = 225858,
  [SMALL_STATE(6362)] = 225909,
  [SMALL_STATE(6363)] = 225956,
  [SMALL_STATE(6364)] = 226025,
  [SMALL_STATE(6365)] = 226072,
  [SMALL_STATE(6366)] = 226161,
  [SMALL_STATE(6367)] = 226230,
  [SMALL_STATE(6368)] = 226319,
  [SMALL_STATE(6369)] = 226402,
  [SMALL_STATE(6370)] = 226485,
  [SMALL_STATE(6371)] = 226554,
  [SMALL_STATE(6372)] = 226637,
  [SMALL_STATE(6373)] = 226684,
  [SMALL_STATE(6374)] = 226753,
  [SMALL_STATE(6375)] = 226822,
  [SMALL_STATE(6376)] = 226911,
  [SMALL_STATE(6377)] = 226980,
  [SMALL_STATE(6378)] = 227049,
  [SMALL_STATE(6379)] = 227098,
  [SMALL_STATE(6380)] = 227147,
  [SMALL_STATE(6381)] = 227230,
  [SMALL_STATE(6382)] = 227299,
  [SMALL_STATE(6383)] = 227368,
  [SMALL_STATE(6384)] = 227457,
  [SMALL_STATE(6385)] = 227540,
  [SMALL_STATE(6386)] = 227591,
  [SMALL_STATE(6387)] = 227642,
  [SMALL_STATE(6388)] = 227691,
  [SMALL_STATE(6389)] = 227740,
  [SMALL_STATE(6390)] = 227809,
  [SMALL_STATE(6391)] = 227858,
  [SMALL_STATE(6392)] = 227947,
  [SMALL_STATE(6393)] = 227996,
  [SMALL_STATE(6394)] = 228047,
  [SMALL_STATE(6395)] = 228096,
  [SMALL_STATE(6396)] = 228145,
  [SMALL_STATE(6397)] = 228194,
  [SMALL_STATE(6398)] = 228243,
  [SMALL_STATE(6399)] = 228312,
  [SMALL_STATE(6400)] = 228361,
  [SMALL_STATE(6401)] = 228410,
  [SMALL_STATE(6402)] = 228479,
  [SMALL_STATE(6403)] = 228548,
  [SMALL_STATE(6404)] = 228639,
  [SMALL_STATE(6405)] = 228728,
  [SMALL_STATE(6406)] = 228813,
  [SMALL_STATE(6407)] = 228896,
  [SMALL_STATE(6408)] = 228943,
  [SMALL_STATE(6409)] = 229026,
  [SMALL_STATE(6410)] = 229115,
  [SMALL_STATE(6411)] = 229191,
  [SMALL_STATE(6412)] = 229245,
  [SMALL_STATE(6413)] = 229321,
  [SMALL_STATE(6414)] = 229367,
  [SMALL_STATE(6415)] = 229435,
  [SMALL_STATE(6416)] = 229511,
  [SMALL_STATE(6417)] = 229565,
  [SMALL_STATE(6418)] = 229643,
  [SMALL_STATE(6419)] = 229725,
  [SMALL_STATE(6420)] = 229769,
  [SMALL_STATE(6421)] = 229851,
  [SMALL_STATE(6422)] = 229927,
  [SMALL_STATE(6423)] = 230003,
  [SMALL_STATE(6424)] = 230079,
  [SMALL_STATE(6425)] = 230161,
  [SMALL_STATE(6426)] = 230229,
  [SMALL_STATE(6427)] = 230305,
  [SMALL_STATE(6428)] = 230381,
  [SMALL_STATE(6429)] = 230457,
  [SMALL_STATE(6430)] = 230533,
  [SMALL_STATE(6431)] = 230609,
  [SMALL_STATE(6432)] = 230685,
  [SMALL_STATE(6433)] = 230731,
  [SMALL_STATE(6434)] = 230807,
  [SMALL_STATE(6435)] = 230883,
  [SMALL_STATE(6436)] = 230959,
  [SMALL_STATE(6437)] = 231035,
  [SMALL_STATE(6438)] = 231111,
  [SMALL_STATE(6439)] = 231193,
  [SMALL_STATE(6440)] = 231269,
  [SMALL_STATE(6441)] = 231345,
  [SMALL_STATE(6442)] = 231397,
  [SMALL_STATE(6443)] = 231465,
  [SMALL_STATE(6444)] = 231541,
  [SMALL_STATE(6445)] = 231619,
  [SMALL_STATE(6446)] = 231695,
  [SMALL_STATE(6447)] = 231753,
  [SMALL_STATE(6448)] = 231811,
  [SMALL_STATE(6449)] = 231863,
  [SMALL_STATE(6450)] = 231939,
  [SMALL_STATE(6451)] = 231985,
  [SMALL_STATE(6452)] = 232053,
  [SMALL_STATE(6453)] = 232129,
  [SMALL_STATE(6454)] = 232175,
  [SMALL_STATE(6455)] = 232221,
  [SMALL_STATE(6456)] = 232289,
  [SMALL_STATE(6457)] = 232365,
  [SMALL_STATE(6458)] = 232441,
  [SMALL_STATE(6459)] = 232517,
  [SMALL_STATE(6460)] = 232599,
  [SMALL_STATE(6461)] = 232645,
  [SMALL_STATE(6462)] = 232727,
  [SMALL_STATE(6463)] = 232773,
  [SMALL_STATE(6464)] = 232827,
  [SMALL_STATE(6465)] = 232873,
  [SMALL_STATE(6466)] = 232949,
  [SMALL_STATE(6467)] = 233025,
  [SMALL_STATE(6468)] = 233093,
  [SMALL_STATE(6469)] = 233139,
  [SMALL_STATE(6470)] = 233185,
  [SMALL_STATE(6471)] = 233261,
  [SMALL_STATE(6472)] = 233329,
  [SMALL_STATE(6473)] = 233407,
  [SMALL_STATE(6474)] = 233475,
  [SMALL_STATE(6475)] = 233521,
  [SMALL_STATE(6476)] = 233567,
  [SMALL_STATE(6477)] = 233645,
  [SMALL_STATE(6478)] = 233721,
  [SMALL_STATE(6479)] = 233774,
  [SMALL_STATE(6480)] = 233849,
  [SMALL_STATE(6481)] = 233894,
  [SMALL_STATE(6482)] = 233939,
  [SMALL_STATE(6483)] = 234006,
  [SMALL_STATE(6484)] = 234087,
  [SMALL_STATE(6485)] = 234154,
  [SMALL_STATE(6486)] = 234199,
  [SMALL_STATE(6487)] = 234244,
  [SMALL_STATE(6488)] = 234289,
  [SMALL_STATE(6489)] = 234334,
  [SMALL_STATE(6490)] = 234415,
  [SMALL_STATE(6491)] = 234468,
  [SMALL_STATE(6492)] = 234549,
  [SMALL_STATE(6493)] = 234630,
  [SMALL_STATE(6494)] = 234705,
  [SMALL_STATE(6495)] = 234750,
  [SMALL_STATE(6496)] = 234795,
  [SMALL_STATE(6497)] = 234848,
  [SMALL_STATE(6498)] = 234923,
  [SMALL_STATE(6499)] = 234990,
  [SMALL_STATE(6500)] = 235071,
  [SMALL_STATE(6501)] = 235146,
  [SMALL_STATE(6502)] = 235191,
  [SMALL_STATE(6503)] = 235236,
  [SMALL_STATE(6504)] = 235303,
  [SMALL_STATE(6505)] = 235378,
  [SMALL_STATE(6506)] = 235445,
  [SMALL_STATE(6507)] = 235512,
  [SMALL_STATE(6508)] = 235579,
  [SMALL_STATE(6509)] = 235632,
  [SMALL_STATE(6510)] = 235673,
  [SMALL_STATE(6511)] = 235740,
  [SMALL_STATE(6512)] = 235807,
  [SMALL_STATE(6513)] = 235848,
  [SMALL_STATE(6514)] = 235929,
  [SMALL_STATE(6515)] = 236004,
  [SMALL_STATE(6516)] = 236071,
  [SMALL_STATE(6517)] = 236116,
  [SMALL_STATE(6518)] = 236161,
  [SMALL_STATE(6519)] = 236242,
  [SMALL_STATE(6520)] = 236287,
  [SMALL_STATE(6521)] = 236332,
  [SMALL_STATE(6522)] = 236377,
  [SMALL_STATE(6523)] = 236422,
  [SMALL_STATE(6524)] = 236467,
  [SMALL_STATE(6525)] = 236512,
  [SMALL_STATE(6526)] = 236557,
  [SMALL_STATE(6527)] = 236602,
  [SMALL_STATE(6528)] = 236647,
  [SMALL_STATE(6529)] = 236692,
  [SMALL_STATE(6530)] = 236737,
  [SMALL_STATE(6531)] = 236818,
  [SMALL_STATE(6532)] = 236863,
  [SMALL_STATE(6533)] = 236908,
  [SMALL_STATE(6534)] = 236953,
  [SMALL_STATE(6535)] = 237020,
  [SMALL_STATE(6536)] = 237087,
  [SMALL_STATE(6537)] = 237163,
  [SMALL_STATE(6538)] = 237237,
  [SMALL_STATE(6539)] = 237317,
  [SMALL_STATE(6540)] = 237397,
  [SMALL_STATE(6541)] = 237473,
  [SMALL_STATE(6542)] = 237543,
  [SMALL_STATE(6543)] = 237587,
  [SMALL_STATE(6544)] = 237661,
  [SMALL_STATE(6545)] = 237731,
  [SMALL_STATE(6546)] = 237805,
  [SMALL_STATE(6547)] = 237875,
  [SMALL_STATE(6548)] = 237949,
  [SMALL_STATE(6549)] = 238019,
  [SMALL_STATE(6550)] = 238093,
  [SMALL_STATE(6551)] = 238137,
  [SMALL_STATE(6552)] = 238217,
  [SMALL_STATE(6553)] = 238293,
  [SMALL_STATE(6554)] = 238373,
  [SMALL_STATE(6555)] = 238453,
  [SMALL_STATE(6556)] = 238533,
  [SMALL_STATE(6557)] = 238603,
  [SMALL_STATE(6558)] = 238673,
  [SMALL_STATE(6559)] = 238749,
  [SMALL_STATE(6560)] = 238829,
  [SMALL_STATE(6561)] = 238903,
  [SMALL_STATE(6562)] = 238973,
  [SMALL_STATE(6563)] = 239043,
  [SMALL_STATE(6564)] = 239123,
  [SMALL_STATE(6565)] = 239193,
  [SMALL_STATE(6566)] = 239273,
  [SMALL_STATE(6567)] = 239343,
  [SMALL_STATE(6568)] = 239423,
  [SMALL_STATE(6569)] = 239493,
  [SMALL_STATE(6570)] = 239537,
  [SMALL_STATE(6571)] = 239617,
  [SMALL_STATE(6572)] = 239697,
  [SMALL_STATE(6573)] = 239767,
  [SMALL_STATE(6574)] = 239847,
  [SMALL_STATE(6575)] = 239927,
  [SMALL_STATE(6576)] = 240008,
  [SMALL_STATE(6577)] = 240089,
  [SMALL_STATE(6578)] = 240170,
  [SMALL_STATE(6579)] = 240251,
  [SMALL_STATE(6580)] = 240324,
  [SMALL_STATE(6581)] = 240405,
  [SMALL_STATE(6582)] = 240486,
  [SMALL_STATE(6583)] = 240567,
  [SMALL_STATE(6584)] = 240648,
  [SMALL_STATE(6585)] = 240729,
  [SMALL_STATE(6586)] = 240802,
  [SMALL_STATE(6587)] = 240847,
  [SMALL_STATE(6588)] = 240928,
  [SMALL_STATE(6589)] = 241009,
  [SMALL_STATE(6590)] = 241090,
  [SMALL_STATE(6591)] = 241171,
  [SMALL_STATE(6592)] = 241244,
  [SMALL_STATE(6593)] = 241325,
  [SMALL_STATE(6594)] = 241406,
  [SMALL_STATE(6595)] = 241487,
  [SMALL_STATE(6596)] = 241568,
  [SMALL_STATE(6597)] = 241649,
  [SMALL_STATE(6598)] = 241730,
  [SMALL_STATE(6599)] = 241811,
  [SMALL_STATE(6600)] = 241884,
  [SMALL_STATE(6601)] = 241965,
  [SMALL_STATE(6602)] = 242046,
  [SMALL_STATE(6603)] = 242127,
  [SMALL_STATE(6604)] = 242208,
  [SMALL_STATE(6605)] = 242289,
  [SMALL_STATE(6606)] = 242370,
  [SMALL_STATE(6607)] = 242451,
  [SMALL_STATE(6608)] = 242532,
  [SMALL_STATE(6609)] = 242613,
  [SMALL_STATE(6610)] = 242694,
  [SMALL_STATE(6611)] = 242775,
  [SMALL_STATE(6612)] = 242856,
  [SMALL_STATE(6613)] = 242937,
  [SMALL_STATE(6614)] = 243018,
  [SMALL_STATE(6615)] = 243091,
  [SMALL_STATE(6616)] = 243172,
  [SMALL_STATE(6617)] = 243253,
  [SMALL_STATE(6618)] = 243334,
  [SMALL_STATE(6619)] = 243415,
  [SMALL_STATE(6620)] = 243496,
  [SMALL_STATE(6621)] = 243539,
  [SMALL_STATE(6622)] = 243612,
  [SMALL_STATE(6623)] = 243693,
  [SMALL_STATE(6624)] = 243774,
  [SMALL_STATE(6625)] = 243847,
  [SMALL_STATE(6626)] = 243928,
  [SMALL_STATE(6627)] = 244009,
  [SMALL_STATE(6628)] = 244090,
  [SMALL_STATE(6629)] = 244171,
  [SMALL_STATE(6630)] = 244252,
  [SMALL_STATE(6631)] = 244333,
  [SMALL_STATE(6632)] = 244414,
  [SMALL_STATE(6633)] = 244495,
  [SMALL_STATE(6634)] = 244576,
  [SMALL_STATE(6635)] = 244657,
  [SMALL_STATE(6636)] = 244738,
  [SMALL_STATE(6637)] = 244819,
  [SMALL_STATE(6638)] = 244900,
  [SMALL_STATE(6639)] = 244981,
  [SMALL_STATE(6640)] = 245062,
  [SMALL_STATE(6641)] = 245143,
  [SMALL_STATE(6642)] = 245224,
  [SMALL_STATE(6643)] = 245305,
  [SMALL_STATE(6644)] = 245386,
  [SMALL_STATE(6645)] = 245467,
  [SMALL_STATE(6646)] = 245548,
  [SMALL_STATE(6647)] = 245629,
  [SMALL_STATE(6648)] = 245702,
  [SMALL_STATE(6649)] = 245783,
  [SMALL_STATE(6650)] = 245864,
  [SMALL_STATE(6651)] = 245945,
  [SMALL_STATE(6652)] = 246026,
  [SMALL_STATE(6653)] = 246107,
  [SMALL_STATE(6654)] = 246188,
  [SMALL_STATE(6655)] = 246269,
  [SMALL_STATE(6656)] = 246342,
  [SMALL_STATE(6657)] = 246423,
  [SMALL_STATE(6658)] = 246504,
  [SMALL_STATE(6659)] = 246585,
  [SMALL_STATE(6660)] = 246666,
  [SMALL_STATE(6661)] = 246747,
  [SMALL_STATE(6662)] = 246828,
  [SMALL_STATE(6663)] = 246909,
  [SMALL_STATE(6664)] = 246990,
  [SMALL_STATE(6665)] = 247071,
  [SMALL_STATE(6666)] = 247152,
  [SMALL_STATE(6667)] = 247233,
  [SMALL_STATE(6668)] = 247314,
  [SMALL_STATE(6669)] = 247395,
  [SMALL_STATE(6670)] = 247476,
  [SMALL_STATE(6671)] = 247557,
  [SMALL_STATE(6672)] = 247638,
  [SMALL_STATE(6673)] = 247719,
  [SMALL_STATE(6674)] = 247792,
  [SMALL_STATE(6675)] = 247873,
  [SMALL_STATE(6676)] = 247954,
  [SMALL_STATE(6677)] = 248035,
  [SMALL_STATE(6678)] = 248116,
  [SMALL_STATE(6679)] = 248197,
  [SMALL_STATE(6680)] = 248278,
  [SMALL_STATE(6681)] = 248359,
  [SMALL_STATE(6682)] = 248402,
  [SMALL_STATE(6683)] = 248475,
  [SMALL_STATE(6684)] = 248556,
  [SMALL_STATE(6685)] = 248599,
  [SMALL_STATE(6686)] = 248640,
  [SMALL_STATE(6687)] = 248721,
  [SMALL_STATE(6688)] = 248802,
  [SMALL_STATE(6689)] = 248883,
  [SMALL_STATE(6690)] = 248964,
  [SMALL_STATE(6691)] = 249045,
  [SMALL_STATE(6692)] = 249126,
  [SMALL_STATE(6693)] = 249207,
  [SMALL_STATE(6694)] = 249288,
  [SMALL_STATE(6695)] = 249361,
  [SMALL_STATE(6696)] = 249442,
  [SMALL_STATE(6697)] = 249523,
  [SMALL_STATE(6698)] = 249604,
  [SMALL_STATE(6699)] = 249685,
  [SMALL_STATE(6700)] = 249766,
  [SMALL_STATE(6701)] = 249847,
  [SMALL_STATE(6702)] = 249928,
  [SMALL_STATE(6703)] = 250009,
  [SMALL_STATE(6704)] = 250090,
  [SMALL_STATE(6705)] = 250171,
  [SMALL_STATE(6706)] = 250252,
  [SMALL_STATE(6707)] = 250333,
  [SMALL_STATE(6708)] = 250414,
  [SMALL_STATE(6709)] = 250495,
  [SMALL_STATE(6710)] = 250576,
  [SMALL_STATE(6711)] = 250657,
  [SMALL_STATE(6712)] = 250730,
  [SMALL_STATE(6713)] = 250811,
  [SMALL_STATE(6714)] = 250892,
  [SMALL_STATE(6715)] = 250973,
  [SMALL_STATE(6716)] = 251054,
  [SMALL_STATE(6717)] = 251135,
  [SMALL_STATE(6718)] = 251216,
  [SMALL_STATE(6719)] = 251297,
  [SMALL_STATE(6720)] = 251378,
  [SMALL_STATE(6721)] = 251459,
  [SMALL_STATE(6722)] = 251540,
  [SMALL_STATE(6723)] = 251621,
  [SMALL_STATE(6724)] = 251702,
  [SMALL_STATE(6725)] = 251783,
  [SMALL_STATE(6726)] = 251864,
  [SMALL_STATE(6727)] = 251945,
  [SMALL_STATE(6728)] = 252026,
  [SMALL_STATE(6729)] = 252107,
  [SMALL_STATE(6730)] = 252188,
  [SMALL_STATE(6731)] = 252269,
  [SMALL_STATE(6732)] = 252350,
  [SMALL_STATE(6733)] = 252423,
  [SMALL_STATE(6734)] = 252504,
  [SMALL_STATE(6735)] = 252585,
  [SMALL_STATE(6736)] = 252666,
  [SMALL_STATE(6737)] = 252747,
  [SMALL_STATE(6738)] = 252828,
  [SMALL_STATE(6739)] = 252909,
  [SMALL_STATE(6740)] = 252990,
  [SMALL_STATE(6741)] = 253071,
  [SMALL_STATE(6742)] = 253144,
  [SMALL_STATE(6743)] = 253225,
  [SMALL_STATE(6744)] = 253306,
  [SMALL_STATE(6745)] = 253387,
  [SMALL_STATE(6746)] = 253468,
  [SMALL_STATE(6747)] = 253549,
  [SMALL_STATE(6748)] = 253589,
  [SMALL_STATE(6749)] = 253629,
  [SMALL_STATE(6750)] = 253669,
  [SMALL_STATE(6751)] = 253747,
  [SMALL_STATE(6752)] = 253787,
  [SMALL_STATE(6753)] = 253865,
  [SMALL_STATE(6754)] = 253905,
  [SMALL_STATE(6755)] = 253983,
  [SMALL_STATE(6756)] = 254061,
  [SMALL_STATE(6757)] = 254101,
  [SMALL_STATE(6758)] = 254141,
  [SMALL_STATE(6759)] = 254219,
  [SMALL_STATE(6760)] = 254291,
  [SMALL_STATE(6761)] = 254331,
  [SMALL_STATE(6762)] = 254403,
  [SMALL_STATE(6763)] = 254467,
  [SMALL_STATE(6764)] = 254545,
  [SMALL_STATE(6765)] = 254617,
  [SMALL_STATE(6766)] = 254657,
  [SMALL_STATE(6767)] = 254697,
  [SMALL_STATE(6768)] = 254737,
  [SMALL_STATE(6769)] = 254815,
  [SMALL_STATE(6770)] = 254855,
  [SMALL_STATE(6771)] = 254919,
  [SMALL_STATE(6772)] = 254991,
  [SMALL_STATE(6773)] = 255031,
  [SMALL_STATE(6774)] = 255073,
  [SMALL_STATE(6775)] = 255115,
  [SMALL_STATE(6776)] = 255193,
  [SMALL_STATE(6777)] = 255271,
  [SMALL_STATE(6778)] = 255349,
  [SMALL_STATE(6779)] = 255427,
  [SMALL_STATE(6780)] = 255467,
  [SMALL_STATE(6781)] = 255507,
  [SMALL_STATE(6782)] = 255547,
  [SMALL_STATE(6783)] = 255625,
  [SMALL_STATE(6784)] = 255703,
  [SMALL_STATE(6785)] = 255743,
  [SMALL_STATE(6786)] = 255821,
  [SMALL_STATE(6787)] = 255899,
  [SMALL_STATE(6788)] = 255939,
  [SMALL_STATE(6789)] = 255981,
  [SMALL_STATE(6790)] = 256059,
  [SMALL_STATE(6791)] = 256099,
  [SMALL_STATE(6792)] = 256139,
  [SMALL_STATE(6793)] = 256179,
  [SMALL_STATE(6794)] = 256257,
  [SMALL_STATE(6795)] = 256335,
  [SMALL_STATE(6796)] = 256407,
  [SMALL_STATE(6797)] = 256485,
  [SMALL_STATE(6798)] = 256525,
  [SMALL_STATE(6799)] = 256573,
  [SMALL_STATE(6800)] = 256613,
  [SMALL_STATE(6801)] = 256685,
  [SMALL_STATE(6802)] = 256763,
  [SMALL_STATE(6803)] = 256835,
  [SMALL_STATE(6804)] = 256875,
  [SMALL_STATE(6805)] = 256947,
  [SMALL_STATE(6806)] = 257019,
  [SMALL_STATE(6807)] = 257059,
  [SMALL_STATE(6808)] = 257101,
  [SMALL_STATE(6809)] = 257165,
  [SMALL_STATE(6810)] = 257205,
  [SMALL_STATE(6811)] = 257245,
  [SMALL_STATE(6812)] = 257323,
  [SMALL_STATE(6813)] = 257395,
  [SMALL_STATE(6814)] = 257467,
  [SMALL_STATE(6815)] = 257539,
  [SMALL_STATE(6816)] = 257617,
  [SMALL_STATE(6817)] = 257684,
  [SMALL_STATE(6818)] = 257751,
  [SMALL_STATE(6819)] = 257818,
  [SMALL_STATE(6820)] = 257885,
  [SMALL_STATE(6821)] = 257952,
  [SMALL_STATE(6822)] = 258019,
  [SMALL_STATE(6823)] = 258090,
  [SMALL_STATE(6824)] = 258157,
  [SMALL_STATE(6825)] = 258224,
  [SMALL_STATE(6826)] = 258291,
  [SMALL_STATE(6827)] = 258358,
  [SMALL_STATE(6828)] = 258425,
  [SMALL_STATE(6829)] = 258492,
  [SMALL_STATE(6830)] = 258559,
  [SMALL_STATE(6831)] = 258630,
  [SMALL_STATE(6832)] = 258697,
  [SMALL_STATE(6833)] = 258768,
  [SMALL_STATE(6834)] = 258835,
  [SMALL_STATE(6835)] = 258902,
  [SMALL_STATE(6836)] = 258969,
  [SMALL_STATE(6837)] = 259036,
  [SMALL_STATE(6838)] = 259103,
  [SMALL_STATE(6839)] = 259174,
  [SMALL_STATE(6840)] = 259245,
  [SMALL_STATE(6841)] = 259312,
  [SMALL_STATE(6842)] = 259379,
  [SMALL_STATE(6843)] = 259450,
  [SMALL_STATE(6844)] = 259517,
  [SMALL_STATE(6845)] = 259584,
  [SMALL_STATE(6846)] = 259651,
  [SMALL_STATE(6847)] = 259718,
  [SMALL_STATE(6848)] = 259785,
  [SMALL_STATE(6849)] = 259852,
  [SMALL_STATE(6850)] = 259919,
  [SMALL_STATE(6851)] = 259986,
  [SMALL_STATE(6852)] = 260053,
  [SMALL_STATE(6853)] = 260120,
  [SMALL_STATE(6854)] = 260165,
  [SMALL_STATE(6855)] = 260232,
  [SMALL_STATE(6856)] = 260299,
  [SMALL_STATE(6857)] = 260370,
  [SMALL_STATE(6858)] = 260437,
  [SMALL_STATE(6859)] = 260504,
  [SMALL_STATE(6860)] = 260571,
  [SMALL_STATE(6861)] = 260638,
  [SMALL_STATE(6862)] = 260705,
  [SMALL_STATE(6863)] = 260750,
  [SMALL_STATE(6864)] = 260821,
  [SMALL_STATE(6865)] = 260888,
  [SMALL_STATE(6866)] = 260955,
  [SMALL_STATE(6867)] = 261022,
  [SMALL_STATE(6868)] = 261089,
  [SMALL_STATE(6869)] = 261156,
  [SMALL_STATE(6870)] = 261223,
  [SMALL_STATE(6871)] = 261290,
  [SMALL_STATE(6872)] = 261357,
  [SMALL_STATE(6873)] = 261424,
  [SMALL_STATE(6874)] = 261495,
  [SMALL_STATE(6875)] = 261565,
  [SMALL_STATE(6876)] = 261635,
  [SMALL_STATE(6877)] = 261705,
  [SMALL_STATE(6878)] = 261747,
  [SMALL_STATE(6879)] = 261817,
  [SMALL_STATE(6880)] = 261887,
  [SMALL_STATE(6881)] = 261957,
  [SMALL_STATE(6882)] = 262027,
  [SMALL_STATE(6883)] = 262097,
  [SMALL_STATE(6884)] = 262167,
  [SMALL_STATE(6885)] = 262237,
  [SMALL_STATE(6886)] = 262291,
  [SMALL_STATE(6887)] = 262361,
  [SMALL_STATE(6888)] = 262403,
  [SMALL_STATE(6889)] = 262473,
  [SMALL_STATE(6890)] = 262542,
  [SMALL_STATE(6891)] = 262611,
  [SMALL_STATE(6892)] = 262676,
  [SMALL_STATE(6893)] = 262745,
  [SMALL_STATE(6894)] = 262814,
  [SMALL_STATE(6895)] = 262883,
  [SMALL_STATE(6896)] = 262952,
  [SMALL_STATE(6897)] = 263017,
  [SMALL_STATE(6898)] = 263086,
  [SMALL_STATE(6899)] = 263155,
  [SMALL_STATE(6900)] = 263220,
  [SMALL_STATE(6901)] = 263289,
  [SMALL_STATE(6902)] = 263358,
  [SMALL_STATE(6903)] = 263427,
  [SMALL_STATE(6904)] = 263496,
  [SMALL_STATE(6905)] = 263565,
  [SMALL_STATE(6906)] = 263634,
  [SMALL_STATE(6907)] = 263699,
  [SMALL_STATE(6908)] = 263764,
  [SMALL_STATE(6909)] = 263833,
  [SMALL_STATE(6910)] = 263898,
  [SMALL_STATE(6911)] = 263967,
  [SMALL_STATE(6912)] = 264036,
  [SMALL_STATE(6913)] = 264105,
  [SMALL_STATE(6914)] = 264174,
  [SMALL_STATE(6915)] = 264243,
  [SMALL_STATE(6916)] = 264312,
  [SMALL_STATE(6917)] = 264362,
  [SMALL_STATE(6918)] = 264420,
  [SMALL_STATE(6919)] = 264478,
  [SMALL_STATE(6920)] = 264536,
  [SMALL_STATE(6921)] = 264594,
  [SMALL_STATE(6922)] = 264655,
  [SMALL_STATE(6923)] = 264704,
  [SMALL_STATE(6924)] = 264765,
  [SMALL_STATE(6925)] = 264826,
  [SMALL_STATE(6926)] = 264863,
  [SMALL_STATE(6927)] = 264924,
  [SMALL_STATE(6928)] = 264985,
  [SMALL_STATE(6929)] = 265020,
  [SMALL_STATE(6930)] = 265081,
  [SMALL_STATE(6931)] = 265142,
  [SMALL_STATE(6932)] = 265175,
  [SMALL_STATE(6933)] = 265249,
  [SMALL_STATE(6934)] = 265297,
  [SMALL_STATE(6935)] = 265345,
  [SMALL_STATE(6936)] = 265419,
  [SMALL_STATE(6937)] = 265467,
  [SMALL_STATE(6938)] = 265515,
  [SMALL_STATE(6939)] = 265563,
  [SMALL_STATE(6940)] = 265637,
  [SMALL_STATE(6941)] = 265687,
  [SMALL_STATE(6942)] = 265735,
  [SMALL_STATE(6943)] = 265785,
  [SMALL_STATE(6944)] = 265833,
  [SMALL_STATE(6945)] = 265881,
  [SMALL_STATE(6946)] = 265935,
  [SMALL_STATE(6947)] = 265983,
  [SMALL_STATE(6948)] = 266016,
  [SMALL_STATE(6949)] = 266047,
  [SMALL_STATE(6950)] = 266088,
  [SMALL_STATE(6951)] = 266129,
  [SMALL_STATE(6952)] = 266160,
  [SMALL_STATE(6953)] = 266191,
  [SMALL_STATE(6954)] = 266222,
  [SMALL_STATE(6955)] = 266253,
  [SMALL_STATE(6956)] = 266287,
  [SMALL_STATE(6957)] = 266317,
  [SMALL_STATE(6958)] = 266369,
  [SMALL_STATE(6959)] = 266399,
  [SMALL_STATE(6960)] = 266429,
  [SMALL_STATE(6961)] = 266481,
  [SMALL_STATE(6962)] = 266511,
  [SMALL_STATE(6963)] = 266541,
  [SMALL_STATE(6964)] = 266571,
  [SMALL_STATE(6965)] = 266623,
  [SMALL_STATE(6966)] = 266675,
  [SMALL_STATE(6967)] = 266705,
  [SMALL_STATE(6968)] = 266735,
  [SMALL_STATE(6969)] = 266765,
  [SMALL_STATE(6970)] = 266799,
  [SMALL_STATE(6971)] = 266851,
  [SMALL_STATE(6972)] = 266903,
  [SMALL_STATE(6973)] = 266973,
  [SMALL_STATE(6974)] = 267003,
  [SMALL_STATE(6975)] = 267055,
  [SMALL_STATE(6976)] = 267107,
  [SMALL_STATE(6977)] = 267159,
  [SMALL_STATE(6978)] = 267211,
  [SMALL_STATE(6979)] = 267263,
  [SMALL_STATE(6980)] = 267315,
  [SMALL_STATE(6981)] = 267349,
  [SMALL_STATE(6982)] = 267397,
  [SMALL_STATE(6983)] = 267449,
  [SMALL_STATE(6984)] = 267501,
  [SMALL_STATE(6985)] = 267571,
  [SMALL_STATE(6986)] = 267641,
  [SMALL_STATE(6987)] = 267693,
  [SMALL_STATE(6988)] = 267723,
  [SMALL_STATE(6989)] = 267775,
  [SMALL_STATE(6990)] = 267827,
  [SMALL_STATE(6991)] = 267873,
  [SMALL_STATE(6992)] = 267921,
  [SMALL_STATE(6993)] = 267973,
  [SMALL_STATE(6994)] = 268025,
  [SMALL_STATE(6995)] = 268077,
  [SMALL_STATE(6996)] = 268129,
  [SMALL_STATE(6997)] = 268181,
  [SMALL_STATE(6998)] = 268233,
  [SMALL_STATE(6999)] = 268285,
  [SMALL_STATE(7000)] = 268315,
  [SMALL_STATE(7001)] = 268345,
  [SMALL_STATE(7002)] = 268375,
  [SMALL_STATE(7003)] = 268417,
  [SMALL_STATE(7004)] = 268451,
  [SMALL_STATE(7005)] = 268493,
  [SMALL_STATE(7006)] = 268523,
  [SMALL_STATE(7007)] = 268565,
  [SMALL_STATE(7008)] = 268617,
  [SMALL_STATE(7009)] = 268659,
  [SMALL_STATE(7010)] = 268711,
  [SMALL_STATE(7011)] = 268763,
  [SMALL_STATE(7012)] = 268815,
  [SMALL_STATE(7013)] = 268845,
  [SMALL_STATE(7014)] = 268897,
  [SMALL_STATE(7015)] = 268949,
  [SMALL_STATE(7016)] = 269019,
  [SMALL_STATE(7017)] = 269065,
  [SMALL_STATE(7018)] = 269117,
  [SMALL_STATE(7019)] = 269169,
  [SMALL_STATE(7020)] = 269221,
  [SMALL_STATE(7021)] = 269273,
  [SMALL_STATE(7022)] = 269307,
  [SMALL_STATE(7023)] = 269359,
  [SMALL_STATE(7024)] = 269411,
  [SMALL_STATE(7025)] = 269463,
  [SMALL_STATE(7026)] = 269515,
  [SMALL_STATE(7027)] = 269567,
  [SMALL_STATE(7028)] = 269619,
  [SMALL_STATE(7029)] = 269671,
  [SMALL_STATE(7030)] = 269723,
  [SMALL_STATE(7031)] = 269767,
  [SMALL_STATE(7032)] = 269811,
  [SMALL_STATE(7033)] = 269855,
  [SMALL_STATE(7034)] = 269899,
  [SMALL_STATE(7035)] = 269941,
  [SMALL_STATE(7036)] = 269983,
  [SMALL_STATE(7037)] = 270025,
  [SMALL_STATE(7038)] = 270067,
  [SMALL_STATE(7039)] = 270109,
  [SMALL_STATE(7040)] = 270153,
  [SMALL_STATE(7041)] = 270197,
  [SMALL_STATE(7042)] = 270241,
  [SMALL_STATE(7043)] = 270285,
  [SMALL_STATE(7044)] = 270337,
  [SMALL_STATE(7045)] = 270389,
  [SMALL_STATE(7046)] = 270441,
  [SMALL_STATE(7047)] = 270493,
  [SMALL_STATE(7048)] = 270523,
  [SMALL_STATE(7049)] = 270553,
  [SMALL_STATE(7050)] = 270623,
  [SMALL_STATE(7051)] = 270653,
  [SMALL_STATE(7052)] = 270683,
  [SMALL_STATE(7053)] = 270713,
  [SMALL_STATE(7054)] = 270743,
  [SMALL_STATE(7055)] = 270795,
  [SMALL_STATE(7056)] = 270837,
  [SMALL_STATE(7057)] = 270896,
  [SMALL_STATE(7058)] = 270955,
  [SMALL_STATE(7059)] = 271014,
  [SMALL_STATE(7060)] = 271073,
  [SMALL_STATE(7061)] = 271132,
  [SMALL_STATE(7062)] = 271177,
  [SMALL_STATE(7063)] = 271236,
  [SMALL_STATE(7064)] = 271295,
  [SMALL_STATE(7065)] = 271354,
  [SMALL_STATE(7066)] = 271413,
  [SMALL_STATE(7067)] = 271472,
  [SMALL_STATE(7068)] = 271531,
  [SMALL_STATE(7069)] = 271590,
  [SMALL_STATE(7070)] = 271649,
  [SMALL_STATE(7071)] = 271708,
  [SMALL_STATE(7072)] = 271767,
  [SMALL_STATE(7073)] = 271826,
  [SMALL_STATE(7074)] = 271881,
  [SMALL_STATE(7075)] = 271914,
  [SMALL_STATE(7076)] = 271973,
  [SMALL_STATE(7077)] = 272028,
  [SMALL_STATE(7078)] = 272087,
  [SMALL_STATE(7079)] = 272146,
  [SMALL_STATE(7080)] = 272191,
  [SMALL_STATE(7081)] = 272250,
  [SMALL_STATE(7082)] = 272309,
  [SMALL_STATE(7083)] = 272368,
  [SMALL_STATE(7084)] = 272399,
  [SMALL_STATE(7085)] = 272442,
  [SMALL_STATE(7086)] = 272487,
  [SMALL_STATE(7087)] = 272520,
  [SMALL_STATE(7088)] = 272579,
  [SMALL_STATE(7089)] = 272638,
  [SMALL_STATE(7090)] = 272697,
  [SMALL_STATE(7091)] = 272756,
  [SMALL_STATE(7092)] = 272815,
  [SMALL_STATE(7093)] = 272874,
  [SMALL_STATE(7094)] = 272933,
  [SMALL_STATE(7095)] = 272992,
  [SMALL_STATE(7096)] = 273051,
  [SMALL_STATE(7097)] = 273110,
  [SMALL_STATE(7098)] = 273169,
  [SMALL_STATE(7099)] = 273228,
  [SMALL_STATE(7100)] = 273287,
  [SMALL_STATE(7101)] = 273346,
  [SMALL_STATE(7102)] = 273405,
  [SMALL_STATE(7103)] = 273464,
  [SMALL_STATE(7104)] = 273523,
  [SMALL_STATE(7105)] = 273582,
  [SMALL_STATE(7106)] = 273641,
  [SMALL_STATE(7107)] = 273700,
  [SMALL_STATE(7108)] = 273759,
  [SMALL_STATE(7109)] = 273818,
  [SMALL_STATE(7110)] = 273877,
  [SMALL_STATE(7111)] = 273936,
  [SMALL_STATE(7112)] = 273995,
  [SMALL_STATE(7113)] = 274048,
  [SMALL_STATE(7114)] = 274107,
  [SMALL_STATE(7115)] = 274166,
  [SMALL_STATE(7116)] = 274225,
  [SMALL_STATE(7117)] = 274284,
  [SMALL_STATE(7118)] = 274343,
  [SMALL_STATE(7119)] = 274402,
  [SMALL_STATE(7120)] = 274445,
  [SMALL_STATE(7121)] = 274474,
  [SMALL_STATE(7122)] = 274505,
  [SMALL_STATE(7123)] = 274534,
  [SMALL_STATE(7124)] = 274593,
  [SMALL_STATE(7125)] = 274646,
  [SMALL_STATE(7126)] = 274705,
  [SMALL_STATE(7127)] = 274764,
  [SMALL_STATE(7128)] = 274823,
  [SMALL_STATE(7129)] = 274882,
  [SMALL_STATE(7130)] = 274927,
  [SMALL_STATE(7131)] = 274980,
  [SMALL_STATE(7132)] = 275039,
  [SMALL_STATE(7133)] = 275094,
  [SMALL_STATE(7134)] = 275153,
  [SMALL_STATE(7135)] = 275192,
  [SMALL_STATE(7136)] = 275231,
  [SMALL_STATE(7137)] = 275290,
  [SMALL_STATE(7138)] = 275349,
  [SMALL_STATE(7139)] = 275408,
  [SMALL_STATE(7140)] = 275453,
  [SMALL_STATE(7141)] = 275512,
  [SMALL_STATE(7142)] = 275571,
  [SMALL_STATE(7143)] = 275630,
  [SMALL_STATE(7144)] = 275689,
  [SMALL_STATE(7145)] = 275718,
  [SMALL_STATE(7146)] = 275763,
  [SMALL_STATE(7147)] = 275792,
  [SMALL_STATE(7148)] = 275851,
  [SMALL_STATE(7149)] = 275910,
  [SMALL_STATE(7150)] = 275969,
  [SMALL_STATE(7151)] = 276028,
  [SMALL_STATE(7152)] = 276057,
  [SMALL_STATE(7153)] = 276086,
  [SMALL_STATE(7154)] = 276115,
  [SMALL_STATE(7155)] = 276174,
  [SMALL_STATE(7156)] = 276233,
  [SMALL_STATE(7157)] = 276292,
  [SMALL_STATE(7158)] = 276351,
  [SMALL_STATE(7159)] = 276380,
  [SMALL_STATE(7160)] = 276439,
  [SMALL_STATE(7161)] = 276484,
  [SMALL_STATE(7162)] = 276513,
  [SMALL_STATE(7163)] = 276542,
  [SMALL_STATE(7164)] = 276571,
  [SMALL_STATE(7165)] = 276630,
  [SMALL_STATE(7166)] = 276689,
  [SMALL_STATE(7167)] = 276734,
  [SMALL_STATE(7168)] = 276793,
  [SMALL_STATE(7169)] = 276852,
  [SMALL_STATE(7170)] = 276911,
  [SMALL_STATE(7171)] = 276970,
  [SMALL_STATE(7172)] = 277029,
  [SMALL_STATE(7173)] = 277074,
  [SMALL_STATE(7174)] = 277133,
  [SMALL_STATE(7175)] = 277192,
  [SMALL_STATE(7176)] = 277251,
  [SMALL_STATE(7177)] = 277310,
  [SMALL_STATE(7178)] = 277369,
  [SMALL_STATE(7179)] = 277428,
  [SMALL_STATE(7180)] = 277487,
  [SMALL_STATE(7181)] = 277546,
  [SMALL_STATE(7182)] = 277591,
  [SMALL_STATE(7183)] = 277620,
  [SMALL_STATE(7184)] = 277667,
  [SMALL_STATE(7185)] = 277696,
  [SMALL_STATE(7186)] = 277725,
  [SMALL_STATE(7187)] = 277784,
  [SMALL_STATE(7188)] = 277843,
  [SMALL_STATE(7189)] = 277872,
  [SMALL_STATE(7190)] = 277901,
  [SMALL_STATE(7191)] = 277964,
  [SMALL_STATE(7192)] = 278023,
  [SMALL_STATE(7193)] = 278066,
  [SMALL_STATE(7194)] = 278125,
  [SMALL_STATE(7195)] = 278184,
  [SMALL_STATE(7196)] = 278243,
  [SMALL_STATE(7197)] = 278302,
  [SMALL_STATE(7198)] = 278361,
  [SMALL_STATE(7199)] = 278420,
  [SMALL_STATE(7200)] = 278453,
  [SMALL_STATE(7201)] = 278482,
  [SMALL_STATE(7202)] = 278541,
  [SMALL_STATE(7203)] = 278600,
  [SMALL_STATE(7204)] = 278659,
  [SMALL_STATE(7205)] = 278718,
  [SMALL_STATE(7206)] = 278777,
  [SMALL_STATE(7207)] = 278836,
  [SMALL_STATE(7208)] = 278895,
  [SMALL_STATE(7209)] = 278954,
  [SMALL_STATE(7210)] = 279013,
  [SMALL_STATE(7211)] = 279072,
  [SMALL_STATE(7212)] = 279116,
  [SMALL_STATE(7213)] = 279168,
  [SMALL_STATE(7214)] = 279232,
  [SMALL_STATE(7215)] = 279284,
  [SMALL_STATE(7216)] = 279312,
  [SMALL_STATE(7217)] = 279340,
  [SMALL_STATE(7218)] = 279380,
  [SMALL_STATE(7219)] = 279430,
  [SMALL_STATE(7220)] = 279470,
  [SMALL_STATE(7221)] = 279522,
  [SMALL_STATE(7222)] = 279550,
  [SMALL_STATE(7223)] = 279600,
  [SMALL_STATE(7224)] = 279652,
  [SMALL_STATE(7225)] = 279692,
  [SMALL_STATE(7226)] = 279756,
  [SMALL_STATE(7227)] = 279808,
  [SMALL_STATE(7228)] = 279848,
  [SMALL_STATE(7229)] = 279888,
  [SMALL_STATE(7230)] = 279938,
  [SMALL_STATE(7231)] = 279982,
  [SMALL_STATE(7232)] = 280026,
  [SMALL_STATE(7233)] = 280070,
  [SMALL_STATE(7234)] = 280114,
  [SMALL_STATE(7235)] = 280166,
  [SMALL_STATE(7236)] = 280218,
  [SMALL_STATE(7237)] = 280258,
  [SMALL_STATE(7238)] = 280310,
  [SMALL_STATE(7239)] = 280350,
  [SMALL_STATE(7240)] = 280414,
  [SMALL_STATE(7241)] = 280454,
  [SMALL_STATE(7242)] = 280518,
  [SMALL_STATE(7243)] = 280570,
  [SMALL_STATE(7244)] = 280610,
  [SMALL_STATE(7245)] = 280656,
  [SMALL_STATE(7246)] = 280708,
  [SMALL_STATE(7247)] = 280736,
  [SMALL_STATE(7248)] = 280764,
  [SMALL_STATE(7249)] = 280804,
  [SMALL_STATE(7250)] = 280844,
  [SMALL_STATE(7251)] = 280884,
  [SMALL_STATE(7252)] = 280924,
  [SMALL_STATE(7253)] = 280964,
  [SMALL_STATE(7254)] = 281004,
  [SMALL_STATE(7255)] = 281044,
  [SMALL_STATE(7256)] = 281084,
  [SMALL_STATE(7257)] = 281124,
  [SMALL_STATE(7258)] = 281164,
  [SMALL_STATE(7259)] = 281214,
  [SMALL_STATE(7260)] = 281266,
  [SMALL_STATE(7261)] = 281306,
  [SMALL_STATE(7262)] = 281356,
  [SMALL_STATE(7263)] = 281408,
  [SMALL_STATE(7264)] = 281472,
  [SMALL_STATE(7265)] = 281500,
  [SMALL_STATE(7266)] = 281552,
  [SMALL_STATE(7267)] = 281604,
  [SMALL_STATE(7268)] = 281654,
  [SMALL_STATE(7269)] = 281706,
  [SMALL_STATE(7270)] = 281756,
  [SMALL_STATE(7271)] = 281806,
  [SMALL_STATE(7272)] = 281856,
  [SMALL_STATE(7273)] = 281906,
  [SMALL_STATE(7274)] = 281956,
  [SMALL_STATE(7275)] = 282006,
  [SMALL_STATE(7276)] = 282056,
  [SMALL_STATE(7277)] = 282106,
  [SMALL_STATE(7278)] = 282134,
  [SMALL_STATE(7279)] = 282184,
  [SMALL_STATE(7280)] = 282234,
  [SMALL_STATE(7281)] = 282298,
  [SMALL_STATE(7282)] = 282348,
  [SMALL_STATE(7283)] = 282412,
  [SMALL_STATE(7284)] = 282452,
  [SMALL_STATE(7285)] = 282516,
  [SMALL_STATE(7286)] = 282548,
  [SMALL_STATE(7287)] = 282600,
  [SMALL_STATE(7288)] = 282652,
  [SMALL_STATE(7289)] = 282692,
  [SMALL_STATE(7290)] = 282724,
  [SMALL_STATE(7291)] = 282788,
  [SMALL_STATE(7292)] = 282840,
  [SMALL_STATE(7293)] = 282892,
  [SMALL_STATE(7294)] = 282944,
  [SMALL_STATE(7295)] = 282984,
  [SMALL_STATE(7296)] = 283028,
  [SMALL_STATE(7297)] = 283072,
  [SMALL_STATE(7298)] = 283116,
  [SMALL_STATE(7299)] = 283160,
  [SMALL_STATE(7300)] = 283224,
  [SMALL_STATE(7301)] = 283262,
  [SMALL_STATE(7302)] = 283314,
  [SMALL_STATE(7303)] = 283342,
  [SMALL_STATE(7304)] = 283380,
  [SMALL_STATE(7305)] = 283418,
  [SMALL_STATE(7306)] = 283456,
  [SMALL_STATE(7307)] = 283508,
  [SMALL_STATE(7308)] = 283540,
  [SMALL_STATE(7309)] = 283578,
  [SMALL_STATE(7310)] = 283606,
  [SMALL_STATE(7311)] = 283658,
  [SMALL_STATE(7312)] = 283698,
  [SMALL_STATE(7313)] = 283746,
  [SMALL_STATE(7314)] = 283792,
  [SMALL_STATE(7315)] = 283820,
  [SMALL_STATE(7316)] = 283858,
  [SMALL_STATE(7317)] = 283904,
  [SMALL_STATE(7318)] = 283944,
  [SMALL_STATE(7319)] = 283982,
  [SMALL_STATE(7320)] = 284020,
  [SMALL_STATE(7321)] = 284058,
  [SMALL_STATE(7322)] = 284090,
  [SMALL_STATE(7323)] = 284128,
  [SMALL_STATE(7324)] = 284156,
  [SMALL_STATE(7325)] = 284200,
  [SMALL_STATE(7326)] = 284244,
  [SMALL_STATE(7327)] = 284286,
  [SMALL_STATE(7328)] = 284326,
  [SMALL_STATE(7329)] = 284362,
  [SMALL_STATE(7330)] = 284396,
  [SMALL_STATE(7331)] = 284460,
  [SMALL_STATE(7332)] = 284500,
  [SMALL_STATE(7333)] = 284540,
  [SMALL_STATE(7334)] = 284584,
  [SMALL_STATE(7335)] = 284628,
  [SMALL_STATE(7336)] = 284672,
  [SMALL_STATE(7337)] = 284716,
  [SMALL_STATE(7338)] = 284760,
  [SMALL_STATE(7339)] = 284804,
  [SMALL_STATE(7340)] = 284848,
  [SMALL_STATE(7341)] = 284892,
  [SMALL_STATE(7342)] = 284932,
  [SMALL_STATE(7343)] = 284972,
  [SMALL_STATE(7344)] = 285024,
  [SMALL_STATE(7345)] = 285056,
  [SMALL_STATE(7346)] = 285084,
  [SMALL_STATE(7347)] = 285148,
  [SMALL_STATE(7348)] = 285188,
  [SMALL_STATE(7349)] = 285238,
  [SMALL_STATE(7350)] = 285278,
  [SMALL_STATE(7351)] = 285318,
  [SMALL_STATE(7352)] = 285382,
  [SMALL_STATE(7353)] = 285422,
  [SMALL_STATE(7354)] = 285462,
  [SMALL_STATE(7355)] = 285514,
  [SMALL_STATE(7356)] = 285566,
  [SMALL_STATE(7357)] = 285606,
  [SMALL_STATE(7358)] = 285646,
  [SMALL_STATE(7359)] = 285698,
  [SMALL_STATE(7360)] = 285750,
  [SMALL_STATE(7361)] = 285790,
  [SMALL_STATE(7362)] = 285830,
  [SMALL_STATE(7363)] = 285870,
  [SMALL_STATE(7364)] = 285902,
  [SMALL_STATE(7365)] = 285952,
  [SMALL_STATE(7366)] = 285983,
  [SMALL_STATE(7367)] = 286030,
  [SMALL_STATE(7368)] = 286061,
  [SMALL_STATE(7369)] = 286096,
  [SMALL_STATE(7370)] = 286141,
  [SMALL_STATE(7371)] = 286198,
  [SMALL_STATE(7372)] = 286245,
  [SMALL_STATE(7373)] = 286290,
  [SMALL_STATE(7374)] = 286317,
  [SMALL_STATE(7375)] = 286362,
  [SMALL_STATE(7376)] = 286401,
  [SMALL_STATE(7377)] = 286440,
  [SMALL_STATE(7378)] = 286467,
  [SMALL_STATE(7379)] = 286524,
  [SMALL_STATE(7380)] = 286551,
  [SMALL_STATE(7381)] = 286586,
  [SMALL_STATE(7382)] = 286615,
  [SMALL_STATE(7383)] = 286664,
  [SMALL_STATE(7384)] = 286691,
  [SMALL_STATE(7385)] = 286738,
  [SMALL_STATE(7386)] = 286785,
  [SMALL_STATE(7387)] = 286830,
  [SMALL_STATE(7388)] = 286873,
  [SMALL_STATE(7389)] = 286918,
  [SMALL_STATE(7390)] = 286963,
  [SMALL_STATE(7391)] = 286998,
  [SMALL_STATE(7392)] = 287045,
  [SMALL_STATE(7393)] = 287088,
  [SMALL_STATE(7394)] = 287143,
  [SMALL_STATE(7395)] = 287190,
  [SMALL_STATE(7396)] = 287235,
  [SMALL_STATE(7397)] = 287280,
  [SMALL_STATE(7398)] = 287321,
  [SMALL_STATE(7399)] = 287366,
  [SMALL_STATE(7400)] = 287423,
  [SMALL_STATE(7401)] = 287480,
  [SMALL_STATE(7402)] = 287519,
  [SMALL_STATE(7403)] = 287556,
  [SMALL_STATE(7404)] = 287603,
  [SMALL_STATE(7405)] = 287642,
  [SMALL_STATE(7406)] = 287677,
  [SMALL_STATE(7407)] = 287704,
  [SMALL_STATE(7408)] = 287759,
  [SMALL_STATE(7409)] = 287804,
  [SMALL_STATE(7410)] = 287849,
  [SMALL_STATE(7411)] = 287904,
  [SMALL_STATE(7412)] = 287937,
  [SMALL_STATE(7413)] = 287976,
  [SMALL_STATE(7414)] = 288021,
  [SMALL_STATE(7415)] = 288064,
  [SMALL_STATE(7416)] = 288099,
  [SMALL_STATE(7417)] = 288130,
  [SMALL_STATE(7418)] = 288175,
  [SMALL_STATE(7419)] = 288210,
  [SMALL_STATE(7420)] = 288249,
  [SMALL_STATE(7421)] = 288296,
  [SMALL_STATE(7422)] = 288353,
  [SMALL_STATE(7423)] = 288390,
  [SMALL_STATE(7424)] = 288417,
  [SMALL_STATE(7425)] = 288444,
  [SMALL_STATE(7426)] = 288479,
  [SMALL_STATE(7427)] = 288506,
  [SMALL_STATE(7428)] = 288555,
  [SMALL_STATE(7429)] = 288594,
  [SMALL_STATE(7430)] = 288621,
  [SMALL_STATE(7431)] = 288648,
  [SMALL_STATE(7432)] = 288705,
  [SMALL_STATE(7433)] = 288752,
  [SMALL_STATE(7434)] = 288797,
  [SMALL_STATE(7435)] = 288844,
  [SMALL_STATE(7436)] = 288883,
  [SMALL_STATE(7437)] = 288922,
  [SMALL_STATE(7438)] = 288957,
  [SMALL_STATE(7439)] = 288996,
  [SMALL_STATE(7440)] = 289041,
  [SMALL_STATE(7441)] = 289076,
  [SMALL_STATE(7442)] = 289115,
  [SMALL_STATE(7443)] = 289170,
  [SMALL_STATE(7444)] = 289225,
  [SMALL_STATE(7445)] = 289256,
  [SMALL_STATE(7446)] = 289287,
  [SMALL_STATE(7447)] = 289314,
  [SMALL_STATE(7448)] = 289361,
  [SMALL_STATE(7449)] = 289416,
  [SMALL_STATE(7450)] = 289473,
  [SMALL_STATE(7451)] = 289518,
  [SMALL_STATE(7452)] = 289549,
  [SMALL_STATE(7453)] = 289596,
  [SMALL_STATE(7454)] = 289643,
  [SMALL_STATE(7455)] = 289669,
  [SMALL_STATE(7456)] = 289711,
  [SMALL_STATE(7457)] = 289753,
  [SMALL_STATE(7458)] = 289795,
  [SMALL_STATE(7459)] = 289837,
  [SMALL_STATE(7460)] = 289863,
  [SMALL_STATE(7461)] = 289905,
  [SMALL_STATE(7462)] = 289947,
  [SMALL_STATE(7463)] = 289989,
  [SMALL_STATE(7464)] = 290031,
  [SMALL_STATE(7465)] = 290071,
  [SMALL_STATE(7466)] = 290097,
  [SMALL_STATE(7467)] = 290123,
  [SMALL_STATE(7468)] = 290165,
  [SMALL_STATE(7469)] = 290203,
  [SMALL_STATE(7470)] = 290241,
  [SMALL_STATE(7471)] = 290281,
  [SMALL_STATE(7472)] = 290321,
  [SMALL_STATE(7473)] = 290359,
  [SMALL_STATE(7474)] = 290385,
  [SMALL_STATE(7475)] = 290423,
  [SMALL_STATE(7476)] = 290449,
  [SMALL_STATE(7477)] = 290487,
  [SMALL_STATE(7478)] = 290527,
  [SMALL_STATE(7479)] = 290567,
  [SMALL_STATE(7480)] = 290593,
  [SMALL_STATE(7481)] = 290635,
  [SMALL_STATE(7482)] = 290661,
  [SMALL_STATE(7483)] = 290709,
  [SMALL_STATE(7484)] = 290735,
  [SMALL_STATE(7485)] = 290783,
  [SMALL_STATE(7486)] = 290809,
  [SMALL_STATE(7487)] = 290835,
  [SMALL_STATE(7488)] = 290861,
  [SMALL_STATE(7489)] = 290909,
  [SMALL_STATE(7490)] = 290939,
  [SMALL_STATE(7491)] = 290981,
  [SMALL_STATE(7492)] = 291023,
  [SMALL_STATE(7493)] = 291055,
  [SMALL_STATE(7494)] = 291085,
  [SMALL_STATE(7495)] = 291125,
  [SMALL_STATE(7496)] = 291155,
  [SMALL_STATE(7497)] = 291185,
  [SMALL_STATE(7498)] = 291215,
  [SMALL_STATE(7499)] = 291245,
  [SMALL_STATE(7500)] = 291275,
  [SMALL_STATE(7501)] = 291305,
  [SMALL_STATE(7502)] = 291343,
  [SMALL_STATE(7503)] = 291385,
  [SMALL_STATE(7504)] = 291423,
  [SMALL_STATE(7505)] = 291465,
  [SMALL_STATE(7506)] = 291503,
  [SMALL_STATE(7507)] = 291541,
  [SMALL_STATE(7508)] = 291579,
  [SMALL_STATE(7509)] = 291609,
  [SMALL_STATE(7510)] = 291639,
  [SMALL_STATE(7511)] = 291669,
  [SMALL_STATE(7512)] = 291699,
  [SMALL_STATE(7513)] = 291729,
  [SMALL_STATE(7514)] = 291759,
  [SMALL_STATE(7515)] = 291797,
  [SMALL_STATE(7516)] = 291835,
  [SMALL_STATE(7517)] = 291861,
  [SMALL_STATE(7518)] = 291899,
  [SMALL_STATE(7519)] = 291937,
  [SMALL_STATE(7520)] = 291963,
  [SMALL_STATE(7521)] = 292001,
  [SMALL_STATE(7522)] = 292041,
  [SMALL_STATE(7523)] = 292085,
  [SMALL_STATE(7524)] = 292117,
  [SMALL_STATE(7525)] = 292147,
  [SMALL_STATE(7526)] = 292187,
  [SMALL_STATE(7527)] = 292213,
  [SMALL_STATE(7528)] = 292239,
  [SMALL_STATE(7529)] = 292265,
  [SMALL_STATE(7530)] = 292291,
  [SMALL_STATE(7531)] = 292325,
  [SMALL_STATE(7532)] = 292359,
  [SMALL_STATE(7533)] = 292385,
  [SMALL_STATE(7534)] = 292427,
  [SMALL_STATE(7535)] = 292471,
  [SMALL_STATE(7536)] = 292497,
  [SMALL_STATE(7537)] = 292539,
  [SMALL_STATE(7538)] = 292565,
  [SMALL_STATE(7539)] = 292607,
  [SMALL_STATE(7540)] = 292649,
  [SMALL_STATE(7541)] = 292687,
  [SMALL_STATE(7542)] = 292713,
  [SMALL_STATE(7543)] = 292743,
  [SMALL_STATE(7544)] = 292769,
  [SMALL_STATE(7545)] = 292807,
  [SMALL_STATE(7546)] = 292845,
  [SMALL_STATE(7547)] = 292871,
  [SMALL_STATE(7548)] = 292909,
  [SMALL_STATE(7549)] = 292947,
  [SMALL_STATE(7550)] = 292973,
  [SMALL_STATE(7551)] = 293021,
  [SMALL_STATE(7552)] = 293052,
  [SMALL_STATE(7553)] = 293095,
  [SMALL_STATE(7554)] = 293134,
  [SMALL_STATE(7555)] = 293159,
  [SMALL_STATE(7556)] = 293208,
  [SMALL_STATE(7557)] = 293233,
  [SMALL_STATE(7558)] = 293282,
  [SMALL_STATE(7559)] = 293321,
  [SMALL_STATE(7560)] = 293346,
  [SMALL_STATE(7561)] = 293385,
  [SMALL_STATE(7562)] = 293414,
  [SMALL_STATE(7563)] = 293463,
  [SMALL_STATE(7564)] = 293488,
  [SMALL_STATE(7565)] = 293527,
  [SMALL_STATE(7566)] = 293570,
  [SMALL_STATE(7567)] = 293595,
  [SMALL_STATE(7568)] = 293636,
  [SMALL_STATE(7569)] = 293685,
  [SMALL_STATE(7570)] = 293724,
  [SMALL_STATE(7571)] = 293751,
  [SMALL_STATE(7572)] = 293790,
  [SMALL_STATE(7573)] = 293831,
  [SMALL_STATE(7574)] = 293870,
  [SMALL_STATE(7575)] = 293897,
  [SMALL_STATE(7576)] = 293928,
  [SMALL_STATE(7577)] = 293959,
  [SMALL_STATE(7578)] = 293990,
  [SMALL_STATE(7579)] = 294021,
  [SMALL_STATE(7580)] = 294050,
  [SMALL_STATE(7581)] = 294075,
  [SMALL_STATE(7582)] = 294124,
  [SMALL_STATE(7583)] = 294163,
  [SMALL_STATE(7584)] = 294188,
  [SMALL_STATE(7585)] = 294215,
  [SMALL_STATE(7586)] = 294256,
  [SMALL_STATE(7587)] = 294281,
  [SMALL_STATE(7588)] = 294320,
  [SMALL_STATE(7589)] = 294345,
  [SMALL_STATE(7590)] = 294386,
  [SMALL_STATE(7591)] = 294419,
  [SMALL_STATE(7592)] = 294462,
  [SMALL_STATE(7593)] = 294493,
  [SMALL_STATE(7594)] = 294536,
  [SMALL_STATE(7595)] = 294579,
  [SMALL_STATE(7596)] = 294610,
  [SMALL_STATE(7597)] = 294635,
  [SMALL_STATE(7598)] = 294660,
  [SMALL_STATE(7599)] = 294701,
  [SMALL_STATE(7600)] = 294742,
  [SMALL_STATE(7601)] = 294783,
  [SMALL_STATE(7602)] = 294816,
  [SMALL_STATE(7603)] = 294847,
  [SMALL_STATE(7604)] = 294878,
  [SMALL_STATE(7605)] = 294903,
  [SMALL_STATE(7606)] = 294928,
  [SMALL_STATE(7607)] = 294977,
  [SMALL_STATE(7608)] = 295018,
  [SMALL_STATE(7609)] = 295043,
  [SMALL_STATE(7610)] = 295086,
  [SMALL_STATE(7611)] = 295111,
  [SMALL_STATE(7612)] = 295136,
  [SMALL_STATE(7613)] = 295161,
  [SMALL_STATE(7614)] = 295192,
  [SMALL_STATE(7615)] = 295223,
  [SMALL_STATE(7616)] = 295264,
  [SMALL_STATE(7617)] = 295305,
  [SMALL_STATE(7618)] = 295330,
  [SMALL_STATE(7619)] = 295355,
  [SMALL_STATE(7620)] = 295394,
  [SMALL_STATE(7621)] = 295419,
  [SMALL_STATE(7622)] = 295444,
  [SMALL_STATE(7623)] = 295483,
  [SMALL_STATE(7624)] = 295522,
  [SMALL_STATE(7625)] = 295547,
  [SMALL_STATE(7626)] = 295572,
  [SMALL_STATE(7627)] = 295597,
  [SMALL_STATE(7628)] = 295628,
  [SMALL_STATE(7629)] = 295662,
  [SMALL_STATE(7630)] = 295702,
  [SMALL_STATE(7631)] = 295732,
  [SMALL_STATE(7632)] = 295766,
  [SMALL_STATE(7633)] = 295796,
  [SMALL_STATE(7634)] = 295826,
  [SMALL_STATE(7635)] = 295866,
  [SMALL_STATE(7636)] = 295900,
  [SMALL_STATE(7637)] = 295940,
  [SMALL_STATE(7638)] = 295974,
  [SMALL_STATE(7639)] = 296024,
  [SMALL_STATE(7640)] = 296064,
  [SMALL_STATE(7641)] = 296114,
  [SMALL_STATE(7642)] = 296148,
  [SMALL_STATE(7643)] = 296182,
  [SMALL_STATE(7644)] = 296222,
  [SMALL_STATE(7645)] = 296272,
  [SMALL_STATE(7646)] = 296306,
  [SMALL_STATE(7647)] = 296340,
  [SMALL_STATE(7648)] = 296380,
  [SMALL_STATE(7649)] = 296430,
  [SMALL_STATE(7650)] = 296464,
  [SMALL_STATE(7651)] = 296498,
  [SMALL_STATE(7652)] = 296534,
  [SMALL_STATE(7653)] = 296570,
  [SMALL_STATE(7654)] = 296606,
  [SMALL_STATE(7655)] = 296642,
  [SMALL_STATE(7656)] = 296678,
  [SMALL_STATE(7657)] = 296714,
  [SMALL_STATE(7658)] = 296750,
  [SMALL_STATE(7659)] = 296786,
  [SMALL_STATE(7660)] = 296822,
  [SMALL_STATE(7661)] = 296858,
  [SMALL_STATE(7662)] = 296898,
  [SMALL_STATE(7663)] = 296938,
  [SMALL_STATE(7664)] = 296974,
  [SMALL_STATE(7665)] = 297010,
  [SMALL_STATE(7666)] = 297046,
  [SMALL_STATE(7667)] = 297082,
  [SMALL_STATE(7668)] = 297118,
  [SMALL_STATE(7669)] = 297158,
  [SMALL_STATE(7670)] = 297188,
  [SMALL_STATE(7671)] = 297228,
  [SMALL_STATE(7672)] = 297258,
  [SMALL_STATE(7673)] = 297286,
  [SMALL_STATE(7674)] = 297312,
  [SMALL_STATE(7675)] = 297338,
  [SMALL_STATE(7676)] = 297364,
  [SMALL_STATE(7677)] = 297390,
  [SMALL_STATE(7678)] = 297416,
  [SMALL_STATE(7679)] = 297442,
  [SMALL_STATE(7680)] = 297468,
  [SMALL_STATE(7681)] = 297518,
  [SMALL_STATE(7682)] = 297558,
  [SMALL_STATE(7683)] = 297584,
  [SMALL_STATE(7684)] = 297624,
  [SMALL_STATE(7685)] = 297666,
  [SMALL_STATE(7686)] = 297696,
  [SMALL_STATE(7687)] = 297726,
  [SMALL_STATE(7688)] = 297760,
  [SMALL_STATE(7689)] = 297800,
  [SMALL_STATE(7690)] = 297846,
  [SMALL_STATE(7691)] = 297886,
  [SMALL_STATE(7692)] = 297926,
  [SMALL_STATE(7693)] = 297972,
  [SMALL_STATE(7694)] = 298012,
  [SMALL_STATE(7695)] = 298052,
  [SMALL_STATE(7696)] = 298092,
  [SMALL_STATE(7697)] = 298132,
  [SMALL_STATE(7698)] = 298172,
  [SMALL_STATE(7699)] = 298212,
  [SMALL_STATE(7700)] = 298246,
  [SMALL_STATE(7701)] = 298286,
  [SMALL_STATE(7702)] = 298326,
  [SMALL_STATE(7703)] = 298366,
  [SMALL_STATE(7704)] = 298406,
  [SMALL_STATE(7705)] = 298446,
  [SMALL_STATE(7706)] = 298482,
  [SMALL_STATE(7707)] = 298518,
  [SMALL_STATE(7708)] = 298554,
  [SMALL_STATE(7709)] = 298590,
  [SMALL_STATE(7710)] = 298626,
  [SMALL_STATE(7711)] = 298676,
  [SMALL_STATE(7712)] = 298708,
  [SMALL_STATE(7713)] = 298740,
  [SMALL_STATE(7714)] = 298770,
  [SMALL_STATE(7715)] = 298804,
  [SMALL_STATE(7716)] = 298844,
  [SMALL_STATE(7717)] = 298874,
  [SMALL_STATE(7718)] = 298914,
  [SMALL_STATE(7719)] = 298944,
  [SMALL_STATE(7720)] = 298974,
  [SMALL_STATE(7721)] = 299014,
  [SMALL_STATE(7722)] = 299048,
  [SMALL_STATE(7723)] = 299094,
  [SMALL_STATE(7724)] = 299120,
  [SMALL_STATE(7725)] = 299146,
  [SMALL_STATE(7726)] = 299172,
  [SMALL_STATE(7727)] = 299200,
  [SMALL_STATE(7728)] = 299226,
  [SMALL_STATE(7729)] = 299252,
  [SMALL_STATE(7730)] = 299278,
  [SMALL_STATE(7731)] = 299318,
  [SMALL_STATE(7732)] = 299348,
  [SMALL_STATE(7733)] = 299382,
  [SMALL_STATE(7734)] = 299416,
  [SMALL_STATE(7735)] = 299450,
  [SMALL_STATE(7736)] = 299490,
  [SMALL_STATE(7737)] = 299530,
  [SMALL_STATE(7738)] = 299570,
  [SMALL_STATE(7739)] = 299620,
  [SMALL_STATE(7740)] = 299649,
  [SMALL_STATE(7741)] = 299676,
  [SMALL_STATE(7742)] = 299711,
  [SMALL_STATE(7743)] = 299738,
  [SMALL_STATE(7744)] = 299777,
  [SMALL_STATE(7745)] = 299810,
  [SMALL_STATE(7746)] = 299841,
  [SMALL_STATE(7747)] = 299880,
  [SMALL_STATE(7748)] = 299919,
  [SMALL_STATE(7749)] = 299950,
  [SMALL_STATE(7750)] = 299981,
  [SMALL_STATE(7751)] = 300012,
  [SMALL_STATE(7752)] = 300043,
  [SMALL_STATE(7753)] = 300074,
  [SMALL_STATE(7754)] = 300105,
  [SMALL_STATE(7755)] = 300140,
  [SMALL_STATE(7756)] = 300177,
  [SMALL_STATE(7757)] = 300206,
  [SMALL_STATE(7758)] = 300237,
  [SMALL_STATE(7759)] = 300268,
  [SMALL_STATE(7760)] = 300299,
  [SMALL_STATE(7761)] = 300330,
  [SMALL_STATE(7762)] = 300361,
  [SMALL_STATE(7763)] = 300392,
  [SMALL_STATE(7764)] = 300423,
  [SMALL_STATE(7765)] = 300454,
  [SMALL_STATE(7766)] = 300485,
  [SMALL_STATE(7767)] = 300520,
  [SMALL_STATE(7768)] = 300547,
  [SMALL_STATE(7769)] = 300580,
  [SMALL_STATE(7770)] = 300619,
  [SMALL_STATE(7771)] = 300642,
  [SMALL_STATE(7772)] = 300669,
  [SMALL_STATE(7773)] = 300698,
  [SMALL_STATE(7774)] = 300737,
  [SMALL_STATE(7775)] = 300774,
  [SMALL_STATE(7776)] = 300803,
  [SMALL_STATE(7777)] = 300842,
  [SMALL_STATE(7778)] = 300871,
  [SMALL_STATE(7779)] = 300906,
  [SMALL_STATE(7780)] = 300931,
  [SMALL_STATE(7781)] = 300966,
  [SMALL_STATE(7782)] = 300993,
  [SMALL_STATE(7783)] = 301026,
  [SMALL_STATE(7784)] = 301055,
  [SMALL_STATE(7785)] = 301082,
  [SMALL_STATE(7786)] = 301109,
  [SMALL_STATE(7787)] = 301136,
  [SMALL_STATE(7788)] = 301163,
  [SMALL_STATE(7789)] = 301190,
  [SMALL_STATE(7790)] = 301217,
  [SMALL_STATE(7791)] = 301244,
  [SMALL_STATE(7792)] = 301281,
  [SMALL_STATE(7793)] = 301318,
  [SMALL_STATE(7794)] = 301355,
  [SMALL_STATE(7795)] = 301392,
  [SMALL_STATE(7796)] = 301425,
  [SMALL_STATE(7797)] = 301452,
  [SMALL_STATE(7798)] = 301487,
  [SMALL_STATE(7799)] = 301524,
  [SMALL_STATE(7800)] = 301561,
  [SMALL_STATE(7801)] = 301598,
  [SMALL_STATE(7802)] = 301635,
  [SMALL_STATE(7803)] = 301668,
  [SMALL_STATE(7804)] = 301697,
  [SMALL_STATE(7805)] = 301726,
  [SMALL_STATE(7806)] = 301755,
  [SMALL_STATE(7807)] = 301784,
  [SMALL_STATE(7808)] = 301821,
  [SMALL_STATE(7809)] = 301854,
  [SMALL_STATE(7810)] = 301887,
  [SMALL_STATE(7811)] = 301916,
  [SMALL_STATE(7812)] = 301955,
  [SMALL_STATE(7813)] = 301984,
  [SMALL_STATE(7814)] = 302013,
  [SMALL_STATE(7815)] = 302042,
  [SMALL_STATE(7816)] = 302075,
  [SMALL_STATE(7817)] = 302108,
  [SMALL_STATE(7818)] = 302137,
  [SMALL_STATE(7819)] = 302176,
  [SMALL_STATE(7820)] = 302203,
  [SMALL_STATE(7821)] = 302242,
  [SMALL_STATE(7822)] = 302275,
  [SMALL_STATE(7823)] = 302302,
  [SMALL_STATE(7824)] = 302331,
  [SMALL_STATE(7825)] = 302360,
  [SMALL_STATE(7826)] = 302393,
  [SMALL_STATE(7827)] = 302426,
  [SMALL_STATE(7828)] = 302465,
  [SMALL_STATE(7829)] = 302492,
  [SMALL_STATE(7830)] = 302521,
  [SMALL_STATE(7831)] = 302556,
  [SMALL_STATE(7832)] = 302595,
  [SMALL_STATE(7833)] = 302634,
  [SMALL_STATE(7834)] = 302667,
  [SMALL_STATE(7835)] = 302706,
  [SMALL_STATE(7836)] = 302745,
  [SMALL_STATE(7837)] = 302774,
  [SMALL_STATE(7838)] = 302807,
  [SMALL_STATE(7839)] = 302834,
  [SMALL_STATE(7840)] = 302863,
  [SMALL_STATE(7841)] = 302892,
  [SMALL_STATE(7842)] = 302921,
  [SMALL_STATE(7843)] = 302950,
  [SMALL_STATE(7844)] = 302979,
  [SMALL_STATE(7845)] = 303008,
  [SMALL_STATE(7846)] = 303037,
  [SMALL_STATE(7847)] = 303066,
  [SMALL_STATE(7848)] = 303095,
  [SMALL_STATE(7849)] = 303122,
  [SMALL_STATE(7850)] = 303149,
  [SMALL_STATE(7851)] = 303184,
  [SMALL_STATE(7852)] = 303211,
  [SMALL_STATE(7853)] = 303238,
  [SMALL_STATE(7854)] = 303265,
  [SMALL_STATE(7855)] = 303300,
  [SMALL_STATE(7856)] = 303327,
  [SMALL_STATE(7857)] = 303364,
  [SMALL_STATE(7858)] = 303401,
  [SMALL_STATE(7859)] = 303438,
  [SMALL_STATE(7860)] = 303475,
  [SMALL_STATE(7861)] = 303512,
  [SMALL_STATE(7862)] = 303549,
  [SMALL_STATE(7863)] = 303586,
  [SMALL_STATE(7864)] = 303623,
  [SMALL_STATE(7865)] = 303658,
  [SMALL_STATE(7866)] = 303697,
  [SMALL_STATE(7867)] = 303726,
  [SMALL_STATE(7868)] = 303755,
  [SMALL_STATE(7869)] = 303794,
  [SMALL_STATE(7870)] = 303831,
  [SMALL_STATE(7871)] = 303866,
  [SMALL_STATE(7872)] = 303901,
  [SMALL_STATE(7873)] = 303924,
  [SMALL_STATE(7874)] = 303963,
  [SMALL_STATE(7875)] = 303990,
  [SMALL_STATE(7876)] = 304019,
  [SMALL_STATE(7877)] = 304058,
  [SMALL_STATE(7878)] = 304087,
  [SMALL_STATE(7879)] = 304116,
  [SMALL_STATE(7880)] = 304149,
  [SMALL_STATE(7881)] = 304188,
  [SMALL_STATE(7882)] = 304217,
  [SMALL_STATE(7883)] = 304240,
  [SMALL_STATE(7884)] = 304275,
  [SMALL_STATE(7885)] = 304310,
  [SMALL_STATE(7886)] = 304343,
  [SMALL_STATE(7887)] = 304378,
  [SMALL_STATE(7888)] = 304405,
  [SMALL_STATE(7889)] = 304438,
  [SMALL_STATE(7890)] = 304467,
  [SMALL_STATE(7891)] = 304493,
  [SMALL_STATE(7892)] = 304519,
  [SMALL_STATE(7893)] = 304559,
  [SMALL_STATE(7894)] = 304599,
  [SMALL_STATE(7895)] = 304639,
  [SMALL_STATE(7896)] = 304667,
  [SMALL_STATE(7897)] = 304705,
  [SMALL_STATE(7898)] = 304739,
  [SMALL_STATE(7899)] = 304761,
  [SMALL_STATE(7900)] = 304799,
  [SMALL_STATE(7901)] = 304833,
  [SMALL_STATE(7902)] = 304867,
  [SMALL_STATE(7903)] = 304897,
  [SMALL_STATE(7904)] = 304931,
  [SMALL_STATE(7905)] = 304963,
  [SMALL_STATE(7906)] = 305001,
  [SMALL_STATE(7907)] = 305025,
  [SMALL_STATE(7908)] = 305063,
  [SMALL_STATE(7909)] = 305103,
  [SMALL_STATE(7910)] = 305127,
  [SMALL_STATE(7911)] = 305165,
  [SMALL_STATE(7912)] = 305187,
  [SMALL_STATE(7913)] = 305213,
  [SMALL_STATE(7914)] = 305239,
  [SMALL_STATE(7915)] = 305265,
  [SMALL_STATE(7916)] = 305291,
  [SMALL_STATE(7917)] = 305317,
  [SMALL_STATE(7918)] = 305343,
  [SMALL_STATE(7919)] = 305371,
  [SMALL_STATE(7920)] = 305397,
  [SMALL_STATE(7921)] = 305419,
  [SMALL_STATE(7922)] = 305445,
  [SMALL_STATE(7923)] = 305471,
  [SMALL_STATE(7924)] = 305497,
  [SMALL_STATE(7925)] = 305537,
  [SMALL_STATE(7926)] = 305571,
  [SMALL_STATE(7927)] = 305611,
  [SMALL_STATE(7928)] = 305649,
  [SMALL_STATE(7929)] = 305675,
  [SMALL_STATE(7930)] = 305701,
  [SMALL_STATE(7931)] = 305727,
  [SMALL_STATE(7932)] = 305753,
  [SMALL_STATE(7933)] = 305793,
  [SMALL_STATE(7934)] = 305831,
  [SMALL_STATE(7935)] = 305869,
  [SMALL_STATE(7936)] = 305895,
  [SMALL_STATE(7937)] = 305933,
  [SMALL_STATE(7938)] = 305973,
  [SMALL_STATE(7939)] = 306013,
  [SMALL_STATE(7940)] = 306047,
  [SMALL_STATE(7941)] = 306087,
  [SMALL_STATE(7942)] = 306127,
  [SMALL_STATE(7943)] = 306153,
  [SMALL_STATE(7944)] = 306193,
  [SMALL_STATE(7945)] = 306227,
  [SMALL_STATE(7946)] = 306267,
  [SMALL_STATE(7947)] = 306301,
  [SMALL_STATE(7948)] = 306341,
  [SMALL_STATE(7949)] = 306373,
  [SMALL_STATE(7950)] = 306403,
  [SMALL_STATE(7951)] = 306429,
  [SMALL_STATE(7952)] = 306463,
  [SMALL_STATE(7953)] = 306497,
  [SMALL_STATE(7954)] = 306531,
  [SMALL_STATE(7955)] = 306563,
  [SMALL_STATE(7956)] = 306603,
  [SMALL_STATE(7957)] = 306625,
  [SMALL_STATE(7958)] = 306665,
  [SMALL_STATE(7959)] = 306689,
  [SMALL_STATE(7960)] = 306715,
  [SMALL_STATE(7961)] = 306755,
  [SMALL_STATE(7962)] = 306787,
  [SMALL_STATE(7963)] = 306827,
  [SMALL_STATE(7964)] = 306865,
  [SMALL_STATE(7965)] = 306903,
  [SMALL_STATE(7966)] = 306935,
  [SMALL_STATE(7967)] = 306975,
  [SMALL_STATE(7968)] = 307019,
  [SMALL_STATE(7969)] = 307041,
  [SMALL_STATE(7970)] = 307079,
  [SMALL_STATE(7971)] = 307119,
  [SMALL_STATE(7972)] = 307157,
  [SMALL_STATE(7973)] = 307195,
  [SMALL_STATE(7974)] = 307227,
  [SMALL_STATE(7975)] = 307255,
  [SMALL_STATE(7976)] = 307281,
  [SMALL_STATE(7977)] = 307309,
  [SMALL_STATE(7978)] = 307335,
  [SMALL_STATE(7979)] = 307361,
  [SMALL_STATE(7980)] = 307393,
  [SMALL_STATE(7981)] = 307419,
  [SMALL_STATE(7982)] = 307445,
  [SMALL_STATE(7983)] = 307471,
  [SMALL_STATE(7984)] = 307497,
  [SMALL_STATE(7985)] = 307523,
  [SMALL_STATE(7986)] = 307561,
  [SMALL_STATE(7987)] = 307587,
  [SMALL_STATE(7988)] = 307617,
  [SMALL_STATE(7989)] = 307643,
  [SMALL_STATE(7990)] = 307683,
  [SMALL_STATE(7991)] = 307709,
  [SMALL_STATE(7992)] = 307739,
  [SMALL_STATE(7993)] = 307777,
  [SMALL_STATE(7994)] = 307817,
  [SMALL_STATE(7995)] = 307857,
  [SMALL_STATE(7996)] = 307895,
  [SMALL_STATE(7997)] = 307921,
  [SMALL_STATE(7998)] = 307961,
  [SMALL_STATE(7999)] = 307995,
  [SMALL_STATE(8000)] = 308033,
  [SMALL_STATE(8001)] = 308067,
  [SMALL_STATE(8002)] = 308093,
  [SMALL_STATE(8003)] = 308119,
  [SMALL_STATE(8004)] = 308145,
  [SMALL_STATE(8005)] = 308179,
  [SMALL_STATE(8006)] = 308213,
  [SMALL_STATE(8007)] = 308234,
  [SMALL_STATE(8008)] = 308263,
  [SMALL_STATE(8009)] = 308286,
  [SMALL_STATE(8010)] = 308309,
  [SMALL_STATE(8011)] = 308346,
  [SMALL_STATE(8012)] = 308373,
  [SMALL_STATE(8013)] = 308402,
  [SMALL_STATE(8014)] = 308429,
  [SMALL_STATE(8015)] = 308464,
  [SMALL_STATE(8016)] = 308497,
  [SMALL_STATE(8017)] = 308530,
  [SMALL_STATE(8018)] = 308563,
  [SMALL_STATE(8019)] = 308598,
  [SMALL_STATE(8020)] = 308631,
  [SMALL_STATE(8021)] = 308664,
  [SMALL_STATE(8022)] = 308703,
  [SMALL_STATE(8023)] = 308730,
  [SMALL_STATE(8024)] = 308761,
  [SMALL_STATE(8025)] = 308786,
  [SMALL_STATE(8026)] = 308825,
  [SMALL_STATE(8027)] = 308850,
  [SMALL_STATE(8028)] = 308877,
  [SMALL_STATE(8029)] = 308910,
  [SMALL_STATE(8030)] = 308943,
  [SMALL_STATE(8031)] = 308976,
  [SMALL_STATE(8032)] = 309001,
  [SMALL_STATE(8033)] = 309030,
  [SMALL_STATE(8034)] = 309063,
  [SMALL_STATE(8035)] = 309092,
  [SMALL_STATE(8036)] = 309119,
  [SMALL_STATE(8037)] = 309146,
  [SMALL_STATE(8038)] = 309177,
  [SMALL_STATE(8039)] = 309206,
  [SMALL_STATE(8040)] = 309231,
  [SMALL_STATE(8041)] = 309260,
  [SMALL_STATE(8042)] = 309289,
  [SMALL_STATE(8043)] = 309318,
  [SMALL_STATE(8044)] = 309347,
  [SMALL_STATE(8045)] = 309376,
  [SMALL_STATE(8046)] = 309409,
  [SMALL_STATE(8047)] = 309436,
  [SMALL_STATE(8048)] = 309469,
  [SMALL_STATE(8049)] = 309496,
  [SMALL_STATE(8050)] = 309525,
  [SMALL_STATE(8051)] = 309554,
  [SMALL_STATE(8052)] = 309583,
  [SMALL_STATE(8053)] = 309610,
  [SMALL_STATE(8054)] = 309639,
  [SMALL_STATE(8055)] = 309660,
  [SMALL_STATE(8056)] = 309691,
  [SMALL_STATE(8057)] = 309726,
  [SMALL_STATE(8058)] = 309759,
  [SMALL_STATE(8059)] = 309792,
  [SMALL_STATE(8060)] = 309813,
  [SMALL_STATE(8061)] = 309834,
  [SMALL_STATE(8062)] = 309855,
  [SMALL_STATE(8063)] = 309882,
  [SMALL_STATE(8064)] = 309903,
  [SMALL_STATE(8065)] = 309924,
  [SMALL_STATE(8066)] = 309961,
  [SMALL_STATE(8067)] = 309990,
  [SMALL_STATE(8068)] = 310021,
  [SMALL_STATE(8069)] = 310052,
  [SMALL_STATE(8070)] = 310085,
  [SMALL_STATE(8071)] = 310116,
  [SMALL_STATE(8072)] = 310151,
  [SMALL_STATE(8073)] = 310184,
  [SMALL_STATE(8074)] = 310217,
  [SMALL_STATE(8075)] = 310250,
  [SMALL_STATE(8076)] = 310273,
  [SMALL_STATE(8077)] = 310300,
  [SMALL_STATE(8078)] = 310331,
  [SMALL_STATE(8079)] = 310362,
  [SMALL_STATE(8080)] = 310393,
  [SMALL_STATE(8081)] = 310424,
  [SMALL_STATE(8082)] = 310445,
  [SMALL_STATE(8083)] = 310476,
  [SMALL_STATE(8084)] = 310503,
  [SMALL_STATE(8085)] = 310540,
  [SMALL_STATE(8086)] = 310561,
  [SMALL_STATE(8087)] = 310594,
  [SMALL_STATE(8088)] = 310619,
  [SMALL_STATE(8089)] = 310652,
  [SMALL_STATE(8090)] = 310679,
  [SMALL_STATE(8091)] = 310706,
  [SMALL_STATE(8092)] = 310727,
  [SMALL_STATE(8093)] = 310748,
  [SMALL_STATE(8094)] = 310783,
  [SMALL_STATE(8095)] = 310822,
  [SMALL_STATE(8096)] = 310855,
  [SMALL_STATE(8097)] = 310880,
  [SMALL_STATE(8098)] = 310913,
  [SMALL_STATE(8099)] = 310938,
  [SMALL_STATE(8100)] = 310969,
  [SMALL_STATE(8101)] = 310990,
  [SMALL_STATE(8102)] = 311025,
  [SMALL_STATE(8103)] = 311046,
  [SMALL_STATE(8104)] = 311067,
  [SMALL_STATE(8105)] = 311088,
  [SMALL_STATE(8106)] = 311121,
  [SMALL_STATE(8107)] = 311152,
  [SMALL_STATE(8108)] = 311183,
  [SMALL_STATE(8109)] = 311210,
  [SMALL_STATE(8110)] = 311241,
  [SMALL_STATE(8111)] = 311272,
  [SMALL_STATE(8112)] = 311303,
  [SMALL_STATE(8113)] = 311334,
  [SMALL_STATE(8114)] = 311369,
  [SMALL_STATE(8115)] = 311400,
  [SMALL_STATE(8116)] = 311431,
  [SMALL_STATE(8117)] = 311462,
  [SMALL_STATE(8118)] = 311493,
  [SMALL_STATE(8119)] = 311526,
  [SMALL_STATE(8120)] = 311559,
  [SMALL_STATE(8121)] = 311592,
  [SMALL_STATE(8122)] = 311623,
  [SMALL_STATE(8123)] = 311644,
  [SMALL_STATE(8124)] = 311665,
  [SMALL_STATE(8125)] = 311700,
  [SMALL_STATE(8126)] = 311721,
  [SMALL_STATE(8127)] = 311742,
  [SMALL_STATE(8128)] = 311777,
  [SMALL_STATE(8129)] = 311810,
  [SMALL_STATE(8130)] = 311845,
  [SMALL_STATE(8131)] = 311868,
  [SMALL_STATE(8132)] = 311889,
  [SMALL_STATE(8133)] = 311920,
  [SMALL_STATE(8134)] = 311941,
  [SMALL_STATE(8135)] = 311968,
  [SMALL_STATE(8136)] = 311999,
  [SMALL_STATE(8137)] = 312030,
  [SMALL_STATE(8138)] = 312061,
  [SMALL_STATE(8139)] = 312088,
  [SMALL_STATE(8140)] = 312119,
  [SMALL_STATE(8141)] = 312150,
  [SMALL_STATE(8142)] = 312171,
  [SMALL_STATE(8143)] = 312204,
  [SMALL_STATE(8144)] = 312235,
  [SMALL_STATE(8145)] = 312256,
  [SMALL_STATE(8146)] = 312287,
  [SMALL_STATE(8147)] = 312308,
  [SMALL_STATE(8148)] = 312335,
  [SMALL_STATE(8149)] = 312358,
  [SMALL_STATE(8150)] = 312391,
  [SMALL_STATE(8151)] = 312412,
  [SMALL_STATE(8152)] = 312445,
  [SMALL_STATE(8153)] = 312478,
  [SMALL_STATE(8154)] = 312509,
  [SMALL_STATE(8155)] = 312548,
  [SMALL_STATE(8156)] = 312577,
  [SMALL_STATE(8157)] = 312610,
  [SMALL_STATE(8158)] = 312645,
  [SMALL_STATE(8159)] = 312666,
  [SMALL_STATE(8160)] = 312699,
  [SMALL_STATE(8161)] = 312732,
  [SMALL_STATE(8162)] = 312753,
  [SMALL_STATE(8163)] = 312774,
  [SMALL_STATE(8164)] = 312813,
  [SMALL_STATE(8165)] = 312848,
  [SMALL_STATE(8166)] = 312869,
  [SMALL_STATE(8167)] = 312896,
  [SMALL_STATE(8168)] = 312923,
  [SMALL_STATE(8169)] = 312946,
  [SMALL_STATE(8170)] = 312983,
  [SMALL_STATE(8171)] = 313006,
  [SMALL_STATE(8172)] = 313039,
  [SMALL_STATE(8173)] = 313068,
  [SMALL_STATE(8174)] = 313091,
  [SMALL_STATE(8175)] = 313124,
  [SMALL_STATE(8176)] = 313147,
  [SMALL_STATE(8177)] = 313180,
  [SMALL_STATE(8178)] = 313218,
  [SMALL_STATE(8179)] = 313246,
  [SMALL_STATE(8180)] = 313274,
  [SMALL_STATE(8181)] = 313300,
  [SMALL_STATE(8182)] = 313336,
  [SMALL_STATE(8183)] = 313372,
  [SMALL_STATE(8184)] = 313396,
  [SMALL_STATE(8185)] = 313434,
  [SMALL_STATE(8186)] = 313458,
  [SMALL_STATE(8187)] = 313478,
  [SMALL_STATE(8188)] = 313502,
  [SMALL_STATE(8189)] = 313524,
  [SMALL_STATE(8190)] = 313560,
  [SMALL_STATE(8191)] = 313580,
  [SMALL_STATE(8192)] = 313616,
  [SMALL_STATE(8193)] = 313652,
  [SMALL_STATE(8194)] = 313676,
  [SMALL_STATE(8195)] = 313702,
  [SMALL_STATE(8196)] = 313728,
  [SMALL_STATE(8197)] = 313748,
  [SMALL_STATE(8198)] = 313774,
  [SMALL_STATE(8199)] = 313798,
  [SMALL_STATE(8200)] = 313836,
  [SMALL_STATE(8201)] = 313860,
  [SMALL_STATE(8202)] = 313884,
  [SMALL_STATE(8203)] = 313914,
  [SMALL_STATE(8204)] = 313936,
  [SMALL_STATE(8205)] = 313962,
  [SMALL_STATE(8206)] = 313982,
  [SMALL_STATE(8207)] = 314004,
  [SMALL_STATE(8208)] = 314030,
  [SMALL_STATE(8209)] = 314066,
  [SMALL_STATE(8210)] = 314092,
  [SMALL_STATE(8211)] = 314116,
  [SMALL_STATE(8212)] = 314142,
  [SMALL_STATE(8213)] = 314178,
  [SMALL_STATE(8214)] = 314204,
  [SMALL_STATE(8215)] = 314226,
  [SMALL_STATE(8216)] = 314252,
  [SMALL_STATE(8217)] = 314274,
  [SMALL_STATE(8218)] = 314296,
  [SMALL_STATE(8219)] = 314322,
  [SMALL_STATE(8220)] = 314348,
  [SMALL_STATE(8221)] = 314384,
  [SMALL_STATE(8222)] = 314406,
  [SMALL_STATE(8223)] = 314432,
  [SMALL_STATE(8224)] = 314470,
  [SMALL_STATE(8225)] = 314492,
  [SMALL_STATE(8226)] = 314528,
  [SMALL_STATE(8227)] = 314550,
  [SMALL_STATE(8228)] = 314586,
  [SMALL_STATE(8229)] = 314608,
  [SMALL_STATE(8230)] = 314628,
  [SMALL_STATE(8231)] = 314664,
  [SMALL_STATE(8232)] = 314684,
  [SMALL_STATE(8233)] = 314722,
  [SMALL_STATE(8234)] = 314746,
  [SMALL_STATE(8235)] = 314766,
  [SMALL_STATE(8236)] = 314790,
  [SMALL_STATE(8237)] = 314818,
  [SMALL_STATE(8238)] = 314854,
  [SMALL_STATE(8239)] = 314878,
  [SMALL_STATE(8240)] = 314902,
  [SMALL_STATE(8241)] = 314928,
  [SMALL_STATE(8242)] = 314950,
  [SMALL_STATE(8243)] = 314974,
  [SMALL_STATE(8244)] = 314998,
  [SMALL_STATE(8245)] = 315018,
  [SMALL_STATE(8246)] = 315042,
  [SMALL_STATE(8247)] = 315078,
  [SMALL_STATE(8248)] = 315104,
  [SMALL_STATE(8249)] = 315134,
  [SMALL_STATE(8250)] = 315170,
  [SMALL_STATE(8251)] = 315192,
  [SMALL_STATE(8252)] = 315216,
  [SMALL_STATE(8253)] = 315240,
  [SMALL_STATE(8254)] = 315260,
  [SMALL_STATE(8255)] = 315296,
  [SMALL_STATE(8256)] = 315318,
  [SMALL_STATE(8257)] = 315342,
  [SMALL_STATE(8258)] = 315366,
  [SMALL_STATE(8259)] = 315390,
  [SMALL_STATE(8260)] = 315414,
  [SMALL_STATE(8261)] = 315436,
  [SMALL_STATE(8262)] = 315460,
  [SMALL_STATE(8263)] = 315484,
  [SMALL_STATE(8264)] = 315508,
  [SMALL_STATE(8265)] = 315546,
  [SMALL_STATE(8266)] = 315576,
  [SMALL_STATE(8267)] = 315600,
  [SMALL_STATE(8268)] = 315624,
  [SMALL_STATE(8269)] = 315648,
  [SMALL_STATE(8270)] = 315672,
  [SMALL_STATE(8271)] = 315696,
  [SMALL_STATE(8272)] = 315720,
  [SMALL_STATE(8273)] = 315744,
  [SMALL_STATE(8274)] = 315768,
  [SMALL_STATE(8275)] = 315792,
  [SMALL_STATE(8276)] = 315816,
  [SMALL_STATE(8277)] = 315840,
  [SMALL_STATE(8278)] = 315876,
  [SMALL_STATE(8279)] = 315912,
  [SMALL_STATE(8280)] = 315932,
  [SMALL_STATE(8281)] = 315968,
  [SMALL_STATE(8282)] = 316004,
  [SMALL_STATE(8283)] = 316040,
  [SMALL_STATE(8284)] = 316062,
  [SMALL_STATE(8285)] = 316090,
  [SMALL_STATE(8286)] = 316112,
  [SMALL_STATE(8287)] = 316134,
  [SMALL_STATE(8288)] = 316160,
  [SMALL_STATE(8289)] = 316186,
  [SMALL_STATE(8290)] = 316208,
  [SMALL_STATE(8291)] = 316228,
  [SMALL_STATE(8292)] = 316264,
  [SMALL_STATE(8293)] = 316302,
  [SMALL_STATE(8294)] = 316332,
  [SMALL_STATE(8295)] = 316354,
  [SMALL_STATE(8296)] = 316376,
  [SMALL_STATE(8297)] = 316398,
  [SMALL_STATE(8298)] = 316434,
  [SMALL_STATE(8299)] = 316470,
  [SMALL_STATE(8300)] = 316492,
  [SMALL_STATE(8301)] = 316528,
  [SMALL_STATE(8302)] = 316556,
  [SMALL_STATE(8303)] = 316580,
  [SMALL_STATE(8304)] = 316604,
  [SMALL_STATE(8305)] = 316632,
  [SMALL_STATE(8306)] = 316660,
  [SMALL_STATE(8307)] = 316696,
  [SMALL_STATE(8308)] = 316724,
  [SMALL_STATE(8309)] = 316752,
  [SMALL_STATE(8310)] = 316788,
  [SMALL_STATE(8311)] = 316816,
  [SMALL_STATE(8312)] = 316838,
  [SMALL_STATE(8313)] = 316869,
  [SMALL_STATE(8314)] = 316904,
  [SMALL_STATE(8315)] = 316933,
  [SMALL_STATE(8316)] = 316968,
  [SMALL_STATE(8317)] = 316999,
  [SMALL_STATE(8318)] = 317022,
  [SMALL_STATE(8319)] = 317057,
  [SMALL_STATE(8320)] = 317084,
  [SMALL_STATE(8321)] = 317119,
  [SMALL_STATE(8322)] = 317154,
  [SMALL_STATE(8323)] = 317185,
  [SMALL_STATE(8324)] = 317220,
  [SMALL_STATE(8325)] = 317245,
  [SMALL_STATE(8326)] = 317276,
  [SMALL_STATE(8327)] = 317299,
  [SMALL_STATE(8328)] = 317322,
  [SMALL_STATE(8329)] = 317357,
  [SMALL_STATE(8330)] = 317386,
  [SMALL_STATE(8331)] = 317419,
  [SMALL_STATE(8332)] = 317454,
  [SMALL_STATE(8333)] = 317489,
  [SMALL_STATE(8334)] = 317524,
  [SMALL_STATE(8335)] = 317559,
  [SMALL_STATE(8336)] = 317586,
  [SMALL_STATE(8337)] = 317621,
  [SMALL_STATE(8338)] = 317644,
  [SMALL_STATE(8339)] = 317667,
  [SMALL_STATE(8340)] = 317690,
  [SMALL_STATE(8341)] = 317713,
  [SMALL_STATE(8342)] = 317736,
  [SMALL_STATE(8343)] = 317759,
  [SMALL_STATE(8344)] = 317786,
  [SMALL_STATE(8345)] = 317817,
  [SMALL_STATE(8346)] = 317844,
  [SMALL_STATE(8347)] = 317879,
  [SMALL_STATE(8348)] = 317914,
  [SMALL_STATE(8349)] = 317945,
  [SMALL_STATE(8350)] = 317964,
  [SMALL_STATE(8351)] = 317987,
  [SMALL_STATE(8352)] = 318012,
  [SMALL_STATE(8353)] = 318045,
  [SMALL_STATE(8354)] = 318072,
  [SMALL_STATE(8355)] = 318107,
  [SMALL_STATE(8356)] = 318132,
  [SMALL_STATE(8357)] = 318167,
  [SMALL_STATE(8358)] = 318186,
  [SMALL_STATE(8359)] = 318213,
  [SMALL_STATE(8360)] = 318248,
  [SMALL_STATE(8361)] = 318283,
  [SMALL_STATE(8362)] = 318310,
  [SMALL_STATE(8363)] = 318337,
  [SMALL_STATE(8364)] = 318372,
  [SMALL_STATE(8365)] = 318401,
  [SMALL_STATE(8366)] = 318422,
  [SMALL_STATE(8367)] = 318451,
  [SMALL_STATE(8368)] = 318472,
  [SMALL_STATE(8369)] = 318497,
  [SMALL_STATE(8370)] = 318532,
  [SMALL_STATE(8371)] = 318567,
  [SMALL_STATE(8372)] = 318598,
  [SMALL_STATE(8373)] = 318633,
  [SMALL_STATE(8374)] = 318664,
  [SMALL_STATE(8375)] = 318695,
  [SMALL_STATE(8376)] = 318718,
  [SMALL_STATE(8377)] = 318747,
  [SMALL_STATE(8378)] = 318778,
  [SMALL_STATE(8379)] = 318811,
  [SMALL_STATE(8380)] = 318846,
  [SMALL_STATE(8381)] = 318881,
  [SMALL_STATE(8382)] = 318916,
  [SMALL_STATE(8383)] = 318941,
  [SMALL_STATE(8384)] = 318972,
  [SMALL_STATE(8385)] = 319007,
  [SMALL_STATE(8386)] = 319036,
  [SMALL_STATE(8387)] = 319071,
  [SMALL_STATE(8388)] = 319096,
  [SMALL_STATE(8389)] = 319131,
  [SMALL_STATE(8390)] = 319156,
  [SMALL_STATE(8391)] = 319181,
  [SMALL_STATE(8392)] = 319206,
  [SMALL_STATE(8393)] = 319229,
  [SMALL_STATE(8394)] = 319258,
  [SMALL_STATE(8395)] = 319283,
  [SMALL_STATE(8396)] = 319306,
  [SMALL_STATE(8397)] = 319331,
  [SMALL_STATE(8398)] = 319366,
  [SMALL_STATE(8399)] = 319391,
  [SMALL_STATE(8400)] = 319414,
  [SMALL_STATE(8401)] = 319445,
  [SMALL_STATE(8402)] = 319468,
  [SMALL_STATE(8403)] = 319491,
  [SMALL_STATE(8404)] = 319514,
  [SMALL_STATE(8405)] = 319539,
  [SMALL_STATE(8406)] = 319570,
  [SMALL_STATE(8407)] = 319601,
  [SMALL_STATE(8408)] = 319632,
  [SMALL_STATE(8409)] = 319663,
  [SMALL_STATE(8410)] = 319696,
  [SMALL_STATE(8411)] = 319725,
  [SMALL_STATE(8412)] = 319756,
  [SMALL_STATE(8413)] = 319785,
  [SMALL_STATE(8414)] = 319816,
  [SMALL_STATE(8415)] = 319851,
  [SMALL_STATE(8416)] = 319880,
  [SMALL_STATE(8417)] = 319903,
  [SMALL_STATE(8418)] = 319926,
  [SMALL_STATE(8419)] = 319949,
  [SMALL_STATE(8420)] = 319972,
  [SMALL_STATE(8421)] = 319993,
  [SMALL_STATE(8422)] = 320016,
  [SMALL_STATE(8423)] = 320051,
  [SMALL_STATE(8424)] = 320074,
  [SMALL_STATE(8425)] = 320097,
  [SMALL_STATE(8426)] = 320122,
  [SMALL_STATE(8427)] = 320147,
  [SMALL_STATE(8428)] = 320172,
  [SMALL_STATE(8429)] = 320197,
  [SMALL_STATE(8430)] = 320222,
  [SMALL_STATE(8431)] = 320247,
  [SMALL_STATE(8432)] = 320272,
  [SMALL_STATE(8433)] = 320297,
  [SMALL_STATE(8434)] = 320322,
  [SMALL_STATE(8435)] = 320347,
  [SMALL_STATE(8436)] = 320378,
  [SMALL_STATE(8437)] = 320411,
  [SMALL_STATE(8438)] = 320430,
  [SMALL_STATE(8439)] = 320449,
  [SMALL_STATE(8440)] = 320468,
  [SMALL_STATE(8441)] = 320503,
  [SMALL_STATE(8442)] = 320522,
  [SMALL_STATE(8443)] = 320543,
  [SMALL_STATE(8444)] = 320562,
  [SMALL_STATE(8445)] = 320581,
  [SMALL_STATE(8446)] = 320616,
  [SMALL_STATE(8447)] = 320651,
  [SMALL_STATE(8448)] = 320670,
  [SMALL_STATE(8449)] = 320689,
  [SMALL_STATE(8450)] = 320708,
  [SMALL_STATE(8451)] = 320727,
  [SMALL_STATE(8452)] = 320746,
  [SMALL_STATE(8453)] = 320765,
  [SMALL_STATE(8454)] = 320784,
  [SMALL_STATE(8455)] = 320819,
  [SMALL_STATE(8456)] = 320838,
  [SMALL_STATE(8457)] = 320873,
  [SMALL_STATE(8458)] = 320908,
  [SMALL_STATE(8459)] = 320927,
  [SMALL_STATE(8460)] = 320954,
  [SMALL_STATE(8461)] = 320975,
  [SMALL_STATE(8462)] = 320994,
  [SMALL_STATE(8463)] = 321029,
  [SMALL_STATE(8464)] = 321050,
  [SMALL_STATE(8465)] = 321085,
  [SMALL_STATE(8466)] = 321106,
  [SMALL_STATE(8467)] = 321141,
  [SMALL_STATE(8468)] = 321162,
  [SMALL_STATE(8469)] = 321191,
  [SMALL_STATE(8470)] = 321212,
  [SMALL_STATE(8471)] = 321233,
  [SMALL_STATE(8472)] = 321264,
  [SMALL_STATE(8473)] = 321285,
  [SMALL_STATE(8474)] = 321310,
  [SMALL_STATE(8475)] = 321333,
  [SMALL_STATE(8476)] = 321356,
  [SMALL_STATE(8477)] = 321379,
  [SMALL_STATE(8478)] = 321402,
  [SMALL_STATE(8479)] = 321425,
  [SMALL_STATE(8480)] = 321448,
  [SMALL_STATE(8481)] = 321471,
  [SMALL_STATE(8482)] = 321506,
  [SMALL_STATE(8483)] = 321541,
  [SMALL_STATE(8484)] = 321576,
  [SMALL_STATE(8485)] = 321595,
  [SMALL_STATE(8486)] = 321624,
  [SMALL_STATE(8487)] = 321659,
  [SMALL_STATE(8488)] = 321688,
  [SMALL_STATE(8489)] = 321719,
  [SMALL_STATE(8490)] = 321750,
  [SMALL_STATE(8491)] = 321785,
  [SMALL_STATE(8492)] = 321820,
  [SMALL_STATE(8493)] = 321851,
  [SMALL_STATE(8494)] = 321886,
  [SMALL_STATE(8495)] = 321919,
  [SMALL_STATE(8496)] = 321948,
  [SMALL_STATE(8497)] = 321977,
  [SMALL_STATE(8498)] = 322012,
  [SMALL_STATE(8499)] = 322043,
  [SMALL_STATE(8500)] = 322078,
  [SMALL_STATE(8501)] = 322099,
  [SMALL_STATE(8502)] = 322130,
  [SMALL_STATE(8503)] = 322153,
  [SMALL_STATE(8504)] = 322174,
  [SMALL_STATE(8505)] = 322197,
  [SMALL_STATE(8506)] = 322223,
  [SMALL_STATE(8507)] = 322253,
  [SMALL_STATE(8508)] = 322277,
  [SMALL_STATE(8509)] = 322303,
  [SMALL_STATE(8510)] = 322329,
  [SMALL_STATE(8511)] = 322353,
  [SMALL_STATE(8512)] = 322375,
  [SMALL_STATE(8513)] = 322397,
  [SMALL_STATE(8514)] = 322419,
  [SMALL_STATE(8515)] = 322441,
  [SMALL_STATE(8516)] = 322461,
  [SMALL_STATE(8517)] = 322483,
  [SMALL_STATE(8518)] = 322505,
  [SMALL_STATE(8519)] = 322527,
  [SMALL_STATE(8520)] = 322553,
  [SMALL_STATE(8521)] = 322575,
  [SMALL_STATE(8522)] = 322597,
  [SMALL_STATE(8523)] = 322623,
  [SMALL_STATE(8524)] = 322643,
  [SMALL_STATE(8525)] = 322669,
  [SMALL_STATE(8526)] = 322699,
  [SMALL_STATE(8527)] = 322721,
  [SMALL_STATE(8528)] = 322743,
  [SMALL_STATE(8529)] = 322765,
  [SMALL_STATE(8530)] = 322793,
  [SMALL_STATE(8531)] = 322815,
  [SMALL_STATE(8532)] = 322837,
  [SMALL_STATE(8533)] = 322863,
  [SMALL_STATE(8534)] = 322889,
  [SMALL_STATE(8535)] = 322913,
  [SMALL_STATE(8536)] = 322935,
  [SMALL_STATE(8537)] = 322959,
  [SMALL_STATE(8538)] = 322983,
  [SMALL_STATE(8539)] = 323003,
  [SMALL_STATE(8540)] = 323027,
  [SMALL_STATE(8541)] = 323049,
  [SMALL_STATE(8542)] = 323073,
  [SMALL_STATE(8543)] = 323103,
  [SMALL_STATE(8544)] = 323127,
  [SMALL_STATE(8545)] = 323149,
  [SMALL_STATE(8546)] = 323171,
  [SMALL_STATE(8547)] = 323193,
  [SMALL_STATE(8548)] = 323215,
  [SMALL_STATE(8549)] = 323237,
  [SMALL_STATE(8550)] = 323259,
  [SMALL_STATE(8551)] = 323283,
  [SMALL_STATE(8552)] = 323311,
  [SMALL_STATE(8553)] = 323333,
  [SMALL_STATE(8554)] = 323357,
  [SMALL_STATE(8555)] = 323379,
  [SMALL_STATE(8556)] = 323401,
  [SMALL_STATE(8557)] = 323423,
  [SMALL_STATE(8558)] = 323445,
  [SMALL_STATE(8559)] = 323467,
  [SMALL_STATE(8560)] = 323489,
  [SMALL_STATE(8561)] = 323511,
  [SMALL_STATE(8562)] = 323533,
  [SMALL_STATE(8563)] = 323563,
  [SMALL_STATE(8564)] = 323587,
  [SMALL_STATE(8565)] = 323611,
  [SMALL_STATE(8566)] = 323635,
  [SMALL_STATE(8567)] = 323655,
  [SMALL_STATE(8568)] = 323679,
  [SMALL_STATE(8569)] = 323705,
  [SMALL_STATE(8570)] = 323737,
  [SMALL_STATE(8571)] = 323759,
  [SMALL_STATE(8572)] = 323787,
  [SMALL_STATE(8573)] = 323811,
  [SMALL_STATE(8574)] = 323835,
  [SMALL_STATE(8575)] = 323857,
  [SMALL_STATE(8576)] = 323879,
  [SMALL_STATE(8577)] = 323901,
  [SMALL_STATE(8578)] = 323925,
  [SMALL_STATE(8579)] = 323947,
  [SMALL_STATE(8580)] = 323969,
  [SMALL_STATE(8581)] = 323991,
  [SMALL_STATE(8582)] = 324013,
  [SMALL_STATE(8583)] = 324035,
  [SMALL_STATE(8584)] = 324059,
  [SMALL_STATE(8585)] = 324081,
  [SMALL_STATE(8586)] = 324105,
  [SMALL_STATE(8587)] = 324127,
  [SMALL_STATE(8588)] = 324149,
  [SMALL_STATE(8589)] = 324171,
  [SMALL_STATE(8590)] = 324195,
  [SMALL_STATE(8591)] = 324219,
  [SMALL_STATE(8592)] = 324249,
  [SMALL_STATE(8593)] = 324275,
  [SMALL_STATE(8594)] = 324301,
  [SMALL_STATE(8595)] = 324323,
  [SMALL_STATE(8596)] = 324346,
  [SMALL_STATE(8597)] = 324367,
  [SMALL_STATE(8598)] = 324390,
  [SMALL_STATE(8599)] = 324413,
  [SMALL_STATE(8600)] = 324436,
  [SMALL_STATE(8601)] = 324459,
  [SMALL_STATE(8602)] = 324490,
  [SMALL_STATE(8603)] = 324517,
  [SMALL_STATE(8604)] = 324536,
  [SMALL_STATE(8605)] = 324567,
  [SMALL_STATE(8606)] = 324588,
  [SMALL_STATE(8607)] = 324619,
  [SMALL_STATE(8608)] = 324638,
  [SMALL_STATE(8609)] = 324657,
  [SMALL_STATE(8610)] = 324676,
  [SMALL_STATE(8611)] = 324701,
  [SMALL_STATE(8612)] = 324720,
  [SMALL_STATE(8613)] = 324747,
  [SMALL_STATE(8614)] = 324766,
  [SMALL_STATE(8615)] = 324793,
  [SMALL_STATE(8616)] = 324812,
  [SMALL_STATE(8617)] = 324831,
  [SMALL_STATE(8618)] = 324850,
  [SMALL_STATE(8619)] = 324869,
  [SMALL_STATE(8620)] = 324888,
  [SMALL_STATE(8621)] = 324907,
  [SMALL_STATE(8622)] = 324930,
  [SMALL_STATE(8623)] = 324949,
  [SMALL_STATE(8624)] = 324970,
  [SMALL_STATE(8625)] = 325001,
  [SMALL_STATE(8626)] = 325022,
  [SMALL_STATE(8627)] = 325043,
  [SMALL_STATE(8628)] = 325068,
  [SMALL_STATE(8629)] = 325095,
  [SMALL_STATE(8630)] = 325120,
  [SMALL_STATE(8631)] = 325151,
  [SMALL_STATE(8632)] = 325174,
  [SMALL_STATE(8633)] = 325195,
  [SMALL_STATE(8634)] = 325222,
  [SMALL_STATE(8635)] = 325241,
  [SMALL_STATE(8636)] = 325272,
  [SMALL_STATE(8637)] = 325303,
  [SMALL_STATE(8638)] = 325334,
  [SMALL_STATE(8639)] = 325355,
  [SMALL_STATE(8640)] = 325380,
  [SMALL_STATE(8641)] = 325411,
  [SMALL_STATE(8642)] = 325442,
  [SMALL_STATE(8643)] = 325467,
  [SMALL_STATE(8644)] = 325490,
  [SMALL_STATE(8645)] = 325521,
  [SMALL_STATE(8646)] = 325540,
  [SMALL_STATE(8647)] = 325567,
  [SMALL_STATE(8648)] = 325598,
  [SMALL_STATE(8649)] = 325623,
  [SMALL_STATE(8650)] = 325654,
  [SMALL_STATE(8651)] = 325671,
  [SMALL_STATE(8652)] = 325696,
  [SMALL_STATE(8653)] = 325719,
  [SMALL_STATE(8654)] = 325740,
  [SMALL_STATE(8655)] = 325767,
  [SMALL_STATE(8656)] = 325798,
  [SMALL_STATE(8657)] = 325829,
  [SMALL_STATE(8658)] = 325852,
  [SMALL_STATE(8659)] = 325879,
  [SMALL_STATE(8660)] = 325904,
  [SMALL_STATE(8661)] = 325925,
  [SMALL_STATE(8662)] = 325948,
  [SMALL_STATE(8663)] = 325969,
  [SMALL_STATE(8664)] = 325994,
  [SMALL_STATE(8665)] = 326017,
  [SMALL_STATE(8666)] = 326044,
  [SMALL_STATE(8667)] = 326075,
  [SMALL_STATE(8668)] = 326096,
  [SMALL_STATE(8669)] = 326115,
  [SMALL_STATE(8670)] = 326146,
  [SMALL_STATE(8671)] = 326169,
  [SMALL_STATE(8672)] = 326196,
  [SMALL_STATE(8673)] = 326223,
  [SMALL_STATE(8674)] = 326242,
  [SMALL_STATE(8675)] = 326273,
  [SMALL_STATE(8676)] = 326298,
  [SMALL_STATE(8677)] = 326329,
  [SMALL_STATE(8678)] = 326360,
  [SMALL_STATE(8679)] = 326383,
  [SMALL_STATE(8680)] = 326414,
  [SMALL_STATE(8681)] = 326435,
  [SMALL_STATE(8682)] = 326458,
  [SMALL_STATE(8683)] = 326479,
  [SMALL_STATE(8684)] = 326506,
  [SMALL_STATE(8685)] = 326537,
  [SMALL_STATE(8686)] = 326558,
  [SMALL_STATE(8687)] = 326579,
  [SMALL_STATE(8688)] = 326602,
  [SMALL_STATE(8689)] = 326625,
  [SMALL_STATE(8690)] = 326656,
  [SMALL_STATE(8691)] = 326683,
  [SMALL_STATE(8692)] = 326706,
  [SMALL_STATE(8693)] = 326725,
  [SMALL_STATE(8694)] = 326744,
  [SMALL_STATE(8695)] = 326763,
  [SMALL_STATE(8696)] = 326782,
  [SMALL_STATE(8697)] = 326809,
  [SMALL_STATE(8698)] = 326828,
  [SMALL_STATE(8699)] = 326847,
  [SMALL_STATE(8700)] = 326866,
  [SMALL_STATE(8701)] = 326889,
  [SMALL_STATE(8702)] = 326910,
  [SMALL_STATE(8703)] = 326931,
  [SMALL_STATE(8704)] = 326954,
  [SMALL_STATE(8705)] = 326979,
  [SMALL_STATE(8706)] = 327010,
  [SMALL_STATE(8707)] = 327041,
  [SMALL_STATE(8708)] = 327060,
  [SMALL_STATE(8709)] = 327079,
  [SMALL_STATE(8710)] = 327098,
  [SMALL_STATE(8711)] = 327117,
  [SMALL_STATE(8712)] = 327136,
  [SMALL_STATE(8713)] = 327155,
  [SMALL_STATE(8714)] = 327174,
  [SMALL_STATE(8715)] = 327193,
  [SMALL_STATE(8716)] = 327212,
  [SMALL_STATE(8717)] = 327231,
  [SMALL_STATE(8718)] = 327250,
  [SMALL_STATE(8719)] = 327269,
  [SMALL_STATE(8720)] = 327300,
  [SMALL_STATE(8721)] = 327325,
  [SMALL_STATE(8722)] = 327346,
  [SMALL_STATE(8723)] = 327367,
  [SMALL_STATE(8724)] = 327398,
  [SMALL_STATE(8725)] = 327425,
  [SMALL_STATE(8726)] = 327452,
  [SMALL_STATE(8727)] = 327477,
  [SMALL_STATE(8728)] = 327508,
  [SMALL_STATE(8729)] = 327531,
  [SMALL_STATE(8730)] = 327558,
  [SMALL_STATE(8731)] = 327579,
  [SMALL_STATE(8732)] = 327610,
  [SMALL_STATE(8733)] = 327631,
  [SMALL_STATE(8734)] = 327656,
  [SMALL_STATE(8735)] = 327679,
  [SMALL_STATE(8736)] = 327700,
  [SMALL_STATE(8737)] = 327721,
  [SMALL_STATE(8738)] = 327752,
  [SMALL_STATE(8739)] = 327773,
  [SMALL_STATE(8740)] = 327794,
  [SMALL_STATE(8741)] = 327819,
  [SMALL_STATE(8742)] = 327850,
  [SMALL_STATE(8743)] = 327871,
  [SMALL_STATE(8744)] = 327902,
  [SMALL_STATE(8745)] = 327921,
  [SMALL_STATE(8746)] = 327942,
  [SMALL_STATE(8747)] = 327973,
  [SMALL_STATE(8748)] = 327992,
  [SMALL_STATE(8749)] = 328011,
  [SMALL_STATE(8750)] = 328032,
  [SMALL_STATE(8751)] = 328049,
  [SMALL_STATE(8752)] = 328074,
  [SMALL_STATE(8753)] = 328105,
  [SMALL_STATE(8754)] = 328130,
  [SMALL_STATE(8755)] = 328161,
  [SMALL_STATE(8756)] = 328186,
  [SMALL_STATE(8757)] = 328211,
  [SMALL_STATE(8758)] = 328238,
  [SMALL_STATE(8759)] = 328269,
  [SMALL_STATE(8760)] = 328296,
  [SMALL_STATE(8761)] = 328315,
  [SMALL_STATE(8762)] = 328340,
  [SMALL_STATE(8763)] = 328367,
  [SMALL_STATE(8764)] = 328398,
  [SMALL_STATE(8765)] = 328425,
  [SMALL_STATE(8766)] = 328450,
  [SMALL_STATE(8767)] = 328477,
  [SMALL_STATE(8768)] = 328508,
  [SMALL_STATE(8769)] = 328529,
  [SMALL_STATE(8770)] = 328560,
  [SMALL_STATE(8771)] = 328581,
  [SMALL_STATE(8772)] = 328602,
  [SMALL_STATE(8773)] = 328628,
  [SMALL_STATE(8774)] = 328654,
  [SMALL_STATE(8775)] = 328680,
  [SMALL_STATE(8776)] = 328706,
  [SMALL_STATE(8777)] = 328732,
  [SMALL_STATE(8778)] = 328752,
  [SMALL_STATE(8779)] = 328772,
  [SMALL_STATE(8780)] = 328798,
  [SMALL_STATE(8781)] = 328818,
  [SMALL_STATE(8782)] = 328838,
  [SMALL_STATE(8783)] = 328856,
  [SMALL_STATE(8784)] = 328882,
  [SMALL_STATE(8785)] = 328908,
  [SMALL_STATE(8786)] = 328934,
  [SMALL_STATE(8787)] = 328956,
  [SMALL_STATE(8788)] = 328976,
  [SMALL_STATE(8789)] = 328994,
  [SMALL_STATE(8790)] = 329020,
  [SMALL_STATE(8791)] = 329038,
  [SMALL_STATE(8792)] = 329056,
  [SMALL_STATE(8793)] = 329074,
  [SMALL_STATE(8794)] = 329092,
  [SMALL_STATE(8795)] = 329110,
  [SMALL_STATE(8796)] = 329138,
  [SMALL_STATE(8797)] = 329156,
  [SMALL_STATE(8798)] = 329182,
  [SMALL_STATE(8799)] = 329202,
  [SMALL_STATE(8800)] = 329222,
  [SMALL_STATE(8801)] = 329242,
  [SMALL_STATE(8802)] = 329262,
  [SMALL_STATE(8803)] = 329282,
  [SMALL_STATE(8804)] = 329306,
  [SMALL_STATE(8805)] = 329326,
  [SMALL_STATE(8806)] = 329346,
  [SMALL_STATE(8807)] = 329372,
  [SMALL_STATE(8808)] = 329390,
  [SMALL_STATE(8809)] = 329416,
  [SMALL_STATE(8810)] = 329436,
  [SMALL_STATE(8811)] = 329462,
  [SMALL_STATE(8812)] = 329482,
  [SMALL_STATE(8813)] = 329506,
  [SMALL_STATE(8814)] = 329532,
  [SMALL_STATE(8815)] = 329556,
  [SMALL_STATE(8816)] = 329582,
  [SMALL_STATE(8817)] = 329606,
  [SMALL_STATE(8818)] = 329626,
  [SMALL_STATE(8819)] = 329650,
  [SMALL_STATE(8820)] = 329670,
  [SMALL_STATE(8821)] = 329694,
  [SMALL_STATE(8822)] = 329714,
  [SMALL_STATE(8823)] = 329732,
  [SMALL_STATE(8824)] = 329752,
  [SMALL_STATE(8825)] = 329772,
  [SMALL_STATE(8826)] = 329798,
  [SMALL_STATE(8827)] = 329818,
  [SMALL_STATE(8828)] = 329838,
  [SMALL_STATE(8829)] = 329856,
  [SMALL_STATE(8830)] = 329880,
  [SMALL_STATE(8831)] = 329906,
  [SMALL_STATE(8832)] = 329932,
  [SMALL_STATE(8833)] = 329958,
  [SMALL_STATE(8834)] = 329984,
  [SMALL_STATE(8835)] = 330010,
  [SMALL_STATE(8836)] = 330036,
  [SMALL_STATE(8837)] = 330062,
  [SMALL_STATE(8838)] = 330084,
  [SMALL_STATE(8839)] = 330100,
  [SMALL_STATE(8840)] = 330122,
  [SMALL_STATE(8841)] = 330148,
  [SMALL_STATE(8842)] = 330174,
  [SMALL_STATE(8843)] = 330196,
  [SMALL_STATE(8844)] = 330214,
  [SMALL_STATE(8845)] = 330232,
  [SMALL_STATE(8846)] = 330258,
  [SMALL_STATE(8847)] = 330280,
  [SMALL_STATE(8848)] = 330306,
  [SMALL_STATE(8849)] = 330328,
  [SMALL_STATE(8850)] = 330354,
  [SMALL_STATE(8851)] = 330374,
  [SMALL_STATE(8852)] = 330392,
  [SMALL_STATE(8853)] = 330410,
  [SMALL_STATE(8854)] = 330428,
  [SMALL_STATE(8855)] = 330446,
  [SMALL_STATE(8856)] = 330464,
  [SMALL_STATE(8857)] = 330486,
  [SMALL_STATE(8858)] = 330504,
  [SMALL_STATE(8859)] = 330522,
  [SMALL_STATE(8860)] = 330548,
  [SMALL_STATE(8861)] = 330570,
  [SMALL_STATE(8862)] = 330596,
  [SMALL_STATE(8863)] = 330618,
  [SMALL_STATE(8864)] = 330640,
  [SMALL_STATE(8865)] = 330662,
  [SMALL_STATE(8866)] = 330686,
  [SMALL_STATE(8867)] = 330708,
  [SMALL_STATE(8868)] = 330726,
  [SMALL_STATE(8869)] = 330744,
  [SMALL_STATE(8870)] = 330764,
  [SMALL_STATE(8871)] = 330790,
  [SMALL_STATE(8872)] = 330806,
  [SMALL_STATE(8873)] = 330828,
  [SMALL_STATE(8874)] = 330850,
  [SMALL_STATE(8875)] = 330876,
  [SMALL_STATE(8876)] = 330898,
  [SMALL_STATE(8877)] = 330920,
  [SMALL_STATE(8878)] = 330942,
  [SMALL_STATE(8879)] = 330964,
  [SMALL_STATE(8880)] = 330986,
  [SMALL_STATE(8881)] = 331008,
  [SMALL_STATE(8882)] = 331028,
  [SMALL_STATE(8883)] = 331054,
  [SMALL_STATE(8884)] = 331080,
  [SMALL_STATE(8885)] = 331100,
  [SMALL_STATE(8886)] = 331122,
  [SMALL_STATE(8887)] = 331148,
  [SMALL_STATE(8888)] = 331168,
  [SMALL_STATE(8889)] = 331188,
  [SMALL_STATE(8890)] = 331206,
  [SMALL_STATE(8891)] = 331226,
  [SMALL_STATE(8892)] = 331252,
  [SMALL_STATE(8893)] = 331270,
  [SMALL_STATE(8894)] = 331290,
  [SMALL_STATE(8895)] = 331316,
  [SMALL_STATE(8896)] = 331342,
  [SMALL_STATE(8897)] = 331360,
  [SMALL_STATE(8898)] = 331386,
  [SMALL_STATE(8899)] = 331403,
  [SMALL_STATE(8900)] = 331428,
  [SMALL_STATE(8901)] = 331445,
  [SMALL_STATE(8902)] = 331462,
  [SMALL_STATE(8903)] = 331487,
  [SMALL_STATE(8904)] = 331504,
  [SMALL_STATE(8905)] = 331521,
  [SMALL_STATE(8906)] = 331540,
  [SMALL_STATE(8907)] = 331557,
  [SMALL_STATE(8908)] = 331574,
  [SMALL_STATE(8909)] = 331599,
  [SMALL_STATE(8910)] = 331624,
  [SMALL_STATE(8911)] = 331649,
  [SMALL_STATE(8912)] = 331674,
  [SMALL_STATE(8913)] = 331695,
  [SMALL_STATE(8914)] = 331712,
  [SMALL_STATE(8915)] = 331737,
  [SMALL_STATE(8916)] = 331760,
  [SMALL_STATE(8917)] = 331777,
  [SMALL_STATE(8918)] = 331796,
  [SMALL_STATE(8919)] = 331815,
  [SMALL_STATE(8920)] = 331840,
  [SMALL_STATE(8921)] = 331857,
  [SMALL_STATE(8922)] = 331874,
  [SMALL_STATE(8923)] = 331891,
  [SMALL_STATE(8924)] = 331916,
  [SMALL_STATE(8925)] = 331935,
  [SMALL_STATE(8926)] = 331954,
  [SMALL_STATE(8927)] = 331973,
  [SMALL_STATE(8928)] = 331996,
  [SMALL_STATE(8929)] = 332019,
  [SMALL_STATE(8930)] = 332038,
  [SMALL_STATE(8931)] = 332055,
  [SMALL_STATE(8932)] = 332074,
  [SMALL_STATE(8933)] = 332093,
  [SMALL_STATE(8934)] = 332110,
  [SMALL_STATE(8935)] = 332125,
  [SMALL_STATE(8936)] = 332146,
  [SMALL_STATE(8937)] = 332163,
  [SMALL_STATE(8938)] = 332188,
  [SMALL_STATE(8939)] = 332211,
  [SMALL_STATE(8940)] = 332234,
  [SMALL_STATE(8941)] = 332259,
  [SMALL_STATE(8942)] = 332284,
  [SMALL_STATE(8943)] = 332305,
  [SMALL_STATE(8944)] = 332328,
  [SMALL_STATE(8945)] = 332345,
  [SMALL_STATE(8946)] = 332362,
  [SMALL_STATE(8947)] = 332379,
  [SMALL_STATE(8948)] = 332402,
  [SMALL_STATE(8949)] = 332425,
  [SMALL_STATE(8950)] = 332442,
  [SMALL_STATE(8951)] = 332465,
  [SMALL_STATE(8952)] = 332488,
  [SMALL_STATE(8953)] = 332503,
  [SMALL_STATE(8954)] = 332520,
  [SMALL_STATE(8955)] = 332539,
  [SMALL_STATE(8956)] = 332560,
  [SMALL_STATE(8957)] = 332585,
  [SMALL_STATE(8958)] = 332602,
  [SMALL_STATE(8959)] = 332619,
  [SMALL_STATE(8960)] = 332638,
  [SMALL_STATE(8961)] = 332655,
  [SMALL_STATE(8962)] = 332678,
  [SMALL_STATE(8963)] = 332703,
  [SMALL_STATE(8964)] = 332718,
  [SMALL_STATE(8965)] = 332735,
  [SMALL_STATE(8966)] = 332752,
  [SMALL_STATE(8967)] = 332777,
  [SMALL_STATE(8968)] = 332794,
  [SMALL_STATE(8969)] = 332817,
  [SMALL_STATE(8970)] = 332838,
  [SMALL_STATE(8971)] = 332857,
  [SMALL_STATE(8972)] = 332874,
  [SMALL_STATE(8973)] = 332891,
  [SMALL_STATE(8974)] = 332914,
  [SMALL_STATE(8975)] = 332935,
  [SMALL_STATE(8976)] = 332960,
  [SMALL_STATE(8977)] = 332985,
  [SMALL_STATE(8978)] = 333010,
  [SMALL_STATE(8979)] = 333035,
  [SMALL_STATE(8980)] = 333060,
  [SMALL_STATE(8981)] = 333081,
  [SMALL_STATE(8982)] = 333106,
  [SMALL_STATE(8983)] = 333131,
  [SMALL_STATE(8984)] = 333152,
  [SMALL_STATE(8985)] = 333175,
  [SMALL_STATE(8986)] = 333196,
  [SMALL_STATE(8987)] = 333217,
  [SMALL_STATE(8988)] = 333240,
  [SMALL_STATE(8989)] = 333261,
  [SMALL_STATE(8990)] = 333284,
  [SMALL_STATE(8991)] = 333309,
  [SMALL_STATE(8992)] = 333330,
  [SMALL_STATE(8993)] = 333353,
  [SMALL_STATE(8994)] = 333374,
  [SMALL_STATE(8995)] = 333395,
  [SMALL_STATE(8996)] = 333418,
  [SMALL_STATE(8997)] = 333435,
  [SMALL_STATE(8998)] = 333452,
  [SMALL_STATE(8999)] = 333473,
  [SMALL_STATE(9000)] = 333494,
  [SMALL_STATE(9001)] = 333511,
  [SMALL_STATE(9002)] = 333536,
  [SMALL_STATE(9003)] = 333553,
  [SMALL_STATE(9004)] = 333574,
  [SMALL_STATE(9005)] = 333591,
  [SMALL_STATE(9006)] = 333608,
  [SMALL_STATE(9007)] = 333627,
  [SMALL_STATE(9008)] = 333652,
  [SMALL_STATE(9009)] = 333677,
  [SMALL_STATE(9010)] = 333702,
  [SMALL_STATE(9011)] = 333727,
  [SMALL_STATE(9012)] = 333748,
  [SMALL_STATE(9013)] = 333765,
  [SMALL_STATE(9014)] = 333790,
  [SMALL_STATE(9015)] = 333811,
  [SMALL_STATE(9016)] = 333836,
  [SMALL_STATE(9017)] = 333861,
  [SMALL_STATE(9018)] = 333886,
  [SMALL_STATE(9019)] = 333905,
  [SMALL_STATE(9020)] = 333922,
  [SMALL_STATE(9021)] = 333943,
  [SMALL_STATE(9022)] = 333964,
  [SMALL_STATE(9023)] = 333983,
  [SMALL_STATE(9024)] = 334008,
  [SMALL_STATE(9025)] = 334033,
  [SMALL_STATE(9026)] = 334053,
  [SMALL_STATE(9027)] = 334073,
  [SMALL_STATE(9028)] = 334093,
  [SMALL_STATE(9029)] = 334113,
  [SMALL_STATE(9030)] = 334135,
  [SMALL_STATE(9031)] = 334157,
  [SMALL_STATE(9032)] = 334179,
  [SMALL_STATE(9033)] = 334201,
  [SMALL_STATE(9034)] = 334223,
  [SMALL_STATE(9035)] = 334243,
  [SMALL_STATE(9036)] = 334257,
  [SMALL_STATE(9037)] = 334277,
  [SMALL_STATE(9038)] = 334297,
  [SMALL_STATE(9039)] = 334313,
  [SMALL_STATE(9040)] = 334333,
  [SMALL_STATE(9041)] = 334349,
  [SMALL_STATE(9042)] = 334369,
  [SMALL_STATE(9043)] = 334389,
  [SMALL_STATE(9044)] = 334409,
  [SMALL_STATE(9045)] = 334429,
  [SMALL_STATE(9046)] = 334449,
  [SMALL_STATE(9047)] = 334469,
  [SMALL_STATE(9048)] = 334489,
  [SMALL_STATE(9049)] = 334509,
  [SMALL_STATE(9050)] = 334531,
  [SMALL_STATE(9051)] = 334553,
  [SMALL_STATE(9052)] = 334575,
  [SMALL_STATE(9053)] = 334595,
  [SMALL_STATE(9054)] = 334615,
  [SMALL_STATE(9055)] = 334637,
  [SMALL_STATE(9056)] = 334653,
  [SMALL_STATE(9057)] = 334675,
  [SMALL_STATE(9058)] = 334689,
  [SMALL_STATE(9059)] = 334711,
  [SMALL_STATE(9060)] = 334731,
  [SMALL_STATE(9061)] = 334753,
  [SMALL_STATE(9062)] = 334773,
  [SMALL_STATE(9063)] = 334791,
  [SMALL_STATE(9064)] = 334807,
  [SMALL_STATE(9065)] = 334829,
  [SMALL_STATE(9066)] = 334849,
  [SMALL_STATE(9067)] = 334869,
  [SMALL_STATE(9068)] = 334887,
  [SMALL_STATE(9069)] = 334901,
  [SMALL_STATE(9070)] = 334921,
  [SMALL_STATE(9071)] = 334939,
  [SMALL_STATE(9072)] = 334955,
  [SMALL_STATE(9073)] = 334971,
  [SMALL_STATE(9074)] = 334989,
  [SMALL_STATE(9075)] = 335009,
  [SMALL_STATE(9076)] = 335023,
  [SMALL_STATE(9077)] = 335039,
  [SMALL_STATE(9078)] = 335059,
  [SMALL_STATE(9079)] = 335077,
  [SMALL_STATE(9080)] = 335095,
  [SMALL_STATE(9081)] = 335111,
  [SMALL_STATE(9082)] = 335131,
  [SMALL_STATE(9083)] = 335145,
  [SMALL_STATE(9084)] = 335159,
  [SMALL_STATE(9085)] = 335177,
  [SMALL_STATE(9086)] = 335197,
  [SMALL_STATE(9087)] = 335217,
  [SMALL_STATE(9088)] = 335237,
  [SMALL_STATE(9089)] = 335259,
  [SMALL_STATE(9090)] = 335279,
  [SMALL_STATE(9091)] = 335299,
  [SMALL_STATE(9092)] = 335317,
  [SMALL_STATE(9093)] = 335337,
  [SMALL_STATE(9094)] = 335355,
  [SMALL_STATE(9095)] = 335373,
  [SMALL_STATE(9096)] = 335391,
  [SMALL_STATE(9097)] = 335411,
  [SMALL_STATE(9098)] = 335429,
  [SMALL_STATE(9099)] = 335451,
  [SMALL_STATE(9100)] = 335471,
  [SMALL_STATE(9101)] = 335489,
  [SMALL_STATE(9102)] = 335509,
  [SMALL_STATE(9103)] = 335525,
  [SMALL_STATE(9104)] = 335547,
  [SMALL_STATE(9105)] = 335569,
  [SMALL_STATE(9106)] = 335585,
  [SMALL_STATE(9107)] = 335607,
  [SMALL_STATE(9108)] = 335625,
  [SMALL_STATE(9109)] = 335641,
  [SMALL_STATE(9110)] = 335661,
  [SMALL_STATE(9111)] = 335681,
  [SMALL_STATE(9112)] = 335701,
  [SMALL_STATE(9113)] = 335717,
  [SMALL_STATE(9114)] = 335737,
  [SMALL_STATE(9115)] = 335757,
  [SMALL_STATE(9116)] = 335771,
  [SMALL_STATE(9117)] = 335791,
  [SMALL_STATE(9118)] = 335811,
  [SMALL_STATE(9119)] = 335833,
  [SMALL_STATE(9120)] = 335855,
  [SMALL_STATE(9121)] = 335873,
  [SMALL_STATE(9122)] = 335893,
  [SMALL_STATE(9123)] = 335915,
  [SMALL_STATE(9124)] = 335937,
  [SMALL_STATE(9125)] = 335959,
  [SMALL_STATE(9126)] = 335981,
  [SMALL_STATE(9127)] = 335999,
  [SMALL_STATE(9128)] = 336013,
  [SMALL_STATE(9129)] = 336027,
  [SMALL_STATE(9130)] = 336043,
  [SMALL_STATE(9131)] = 336057,
  [SMALL_STATE(9132)] = 336077,
  [SMALL_STATE(9133)] = 336097,
  [SMALL_STATE(9134)] = 336117,
  [SMALL_STATE(9135)] = 336139,
  [SMALL_STATE(9136)] = 336155,
  [SMALL_STATE(9137)] = 336175,
  [SMALL_STATE(9138)] = 336189,
  [SMALL_STATE(9139)] = 336209,
  [SMALL_STATE(9140)] = 336229,
  [SMALL_STATE(9141)] = 336243,
  [SMALL_STATE(9142)] = 336263,
  [SMALL_STATE(9143)] = 336281,
  [SMALL_STATE(9144)] = 336303,
  [SMALL_STATE(9145)] = 336325,
  [SMALL_STATE(9146)] = 336345,
  [SMALL_STATE(9147)] = 336359,
  [SMALL_STATE(9148)] = 336373,
  [SMALL_STATE(9149)] = 336393,
  [SMALL_STATE(9150)] = 336415,
  [SMALL_STATE(9151)] = 336431,
  [SMALL_STATE(9152)] = 336453,
  [SMALL_STATE(9153)] = 336469,
  [SMALL_STATE(9154)] = 336489,
  [SMALL_STATE(9155)] = 336505,
  [SMALL_STATE(9156)] = 336527,
  [SMALL_STATE(9157)] = 336549,
  [SMALL_STATE(9158)] = 336571,
  [SMALL_STATE(9159)] = 336593,
  [SMALL_STATE(9160)] = 336611,
  [SMALL_STATE(9161)] = 336633,
  [SMALL_STATE(9162)] = 336655,
  [SMALL_STATE(9163)] = 336677,
  [SMALL_STATE(9164)] = 336699,
  [SMALL_STATE(9165)] = 336715,
  [SMALL_STATE(9166)] = 336735,
  [SMALL_STATE(9167)] = 336757,
  [SMALL_STATE(9168)] = 336771,
  [SMALL_STATE(9169)] = 336793,
  [SMALL_STATE(9170)] = 336815,
  [SMALL_STATE(9171)] = 336833,
  [SMALL_STATE(9172)] = 336855,
  [SMALL_STATE(9173)] = 336875,
  [SMALL_STATE(9174)] = 336897,
  [SMALL_STATE(9175)] = 336917,
  [SMALL_STATE(9176)] = 336937,
  [SMALL_STATE(9177)] = 336959,
  [SMALL_STATE(9178)] = 336973,
  [SMALL_STATE(9179)] = 336993,
  [SMALL_STATE(9180)] = 337011,
  [SMALL_STATE(9181)] = 337033,
  [SMALL_STATE(9182)] = 337055,
  [SMALL_STATE(9183)] = 337071,
  [SMALL_STATE(9184)] = 337091,
  [SMALL_STATE(9185)] = 337107,
  [SMALL_STATE(9186)] = 337123,
  [SMALL_STATE(9187)] = 337139,
  [SMALL_STATE(9188)] = 337159,
  [SMALL_STATE(9189)] = 337175,
  [SMALL_STATE(9190)] = 337191,
  [SMALL_STATE(9191)] = 337209,
  [SMALL_STATE(9192)] = 337231,
  [SMALL_STATE(9193)] = 337249,
  [SMALL_STATE(9194)] = 337269,
  [SMALL_STATE(9195)] = 337289,
  [SMALL_STATE(9196)] = 337311,
  [SMALL_STATE(9197)] = 337331,
  [SMALL_STATE(9198)] = 337351,
  [SMALL_STATE(9199)] = 337371,
  [SMALL_STATE(9200)] = 337391,
  [SMALL_STATE(9201)] = 337411,
  [SMALL_STATE(9202)] = 337431,
  [SMALL_STATE(9203)] = 337451,
  [SMALL_STATE(9204)] = 337473,
  [SMALL_STATE(9205)] = 337495,
  [SMALL_STATE(9206)] = 337517,
  [SMALL_STATE(9207)] = 337537,
  [SMALL_STATE(9208)] = 337555,
  [SMALL_STATE(9209)] = 337572,
  [SMALL_STATE(9210)] = 337587,
  [SMALL_STATE(9211)] = 337604,
  [SMALL_STATE(9212)] = 337619,
  [SMALL_STATE(9213)] = 337634,
  [SMALL_STATE(9214)] = 337653,
  [SMALL_STATE(9215)] = 337670,
  [SMALL_STATE(9216)] = 337685,
  [SMALL_STATE(9217)] = 337700,
  [SMALL_STATE(9218)] = 337717,
  [SMALL_STATE(9219)] = 337736,
  [SMALL_STATE(9220)] = 337755,
  [SMALL_STATE(9221)] = 337772,
  [SMALL_STATE(9222)] = 337791,
  [SMALL_STATE(9223)] = 337806,
  [SMALL_STATE(9224)] = 337823,
  [SMALL_STATE(9225)] = 337838,
  [SMALL_STATE(9226)] = 337853,
  [SMALL_STATE(9227)] = 337870,
  [SMALL_STATE(9228)] = 337885,
  [SMALL_STATE(9229)] = 337900,
  [SMALL_STATE(9230)] = 337913,
  [SMALL_STATE(9231)] = 337932,
  [SMALL_STATE(9232)] = 337947,
  [SMALL_STATE(9233)] = 337962,
  [SMALL_STATE(9234)] = 337981,
  [SMALL_STATE(9235)] = 338000,
  [SMALL_STATE(9236)] = 338017,
  [SMALL_STATE(9237)] = 338036,
  [SMALL_STATE(9238)] = 338055,
  [SMALL_STATE(9239)] = 338070,
  [SMALL_STATE(9240)] = 338085,
  [SMALL_STATE(9241)] = 338104,
  [SMALL_STATE(9242)] = 338121,
  [SMALL_STATE(9243)] = 338136,
  [SMALL_STATE(9244)] = 338153,
  [SMALL_STATE(9245)] = 338166,
  [SMALL_STATE(9246)] = 338183,
  [SMALL_STATE(9247)] = 338202,
  [SMALL_STATE(9248)] = 338221,
  [SMALL_STATE(9249)] = 338236,
  [SMALL_STATE(9250)] = 338253,
  [SMALL_STATE(9251)] = 338270,
  [SMALL_STATE(9252)] = 338287,
  [SMALL_STATE(9253)] = 338304,
  [SMALL_STATE(9254)] = 338321,
  [SMALL_STATE(9255)] = 338338,
  [SMALL_STATE(9256)] = 338357,
  [SMALL_STATE(9257)] = 338370,
  [SMALL_STATE(9258)] = 338387,
  [SMALL_STATE(9259)] = 338404,
  [SMALL_STATE(9260)] = 338419,
  [SMALL_STATE(9261)] = 338438,
  [SMALL_STATE(9262)] = 338455,
  [SMALL_STATE(9263)] = 338466,
  [SMALL_STATE(9264)] = 338485,
  [SMALL_STATE(9265)] = 338500,
  [SMALL_STATE(9266)] = 338519,
  [SMALL_STATE(9267)] = 338536,
  [SMALL_STATE(9268)] = 338553,
  [SMALL_STATE(9269)] = 338568,
  [SMALL_STATE(9270)] = 338581,
  [SMALL_STATE(9271)] = 338598,
  [SMALL_STATE(9272)] = 338615,
  [SMALL_STATE(9273)] = 338634,
  [SMALL_STATE(9274)] = 338651,
  [SMALL_STATE(9275)] = 338668,
  [SMALL_STATE(9276)] = 338683,
  [SMALL_STATE(9277)] = 338700,
  [SMALL_STATE(9278)] = 338717,
  [SMALL_STATE(9279)] = 338734,
  [SMALL_STATE(9280)] = 338751,
  [SMALL_STATE(9281)] = 338768,
  [SMALL_STATE(9282)] = 338783,
  [SMALL_STATE(9283)] = 338800,
  [SMALL_STATE(9284)] = 338819,
  [SMALL_STATE(9285)] = 338836,
  [SMALL_STATE(9286)] = 338853,
  [SMALL_STATE(9287)] = 338872,
  [SMALL_STATE(9288)] = 338891,
  [SMALL_STATE(9289)] = 338908,
  [SMALL_STATE(9290)] = 338927,
  [SMALL_STATE(9291)] = 338946,
  [SMALL_STATE(9292)] = 338963,
  [SMALL_STATE(9293)] = 338978,
  [SMALL_STATE(9294)] = 338991,
  [SMALL_STATE(9295)] = 339008,
  [SMALL_STATE(9296)] = 339025,
  [SMALL_STATE(9297)] = 339040,
  [SMALL_STATE(9298)] = 339057,
  [SMALL_STATE(9299)] = 339074,
  [SMALL_STATE(9300)] = 339087,
  [SMALL_STATE(9301)] = 339102,
  [SMALL_STATE(9302)] = 339119,
  [SMALL_STATE(9303)] = 339138,
  [SMALL_STATE(9304)] = 339155,
  [SMALL_STATE(9305)] = 339172,
  [SMALL_STATE(9306)] = 339191,
  [SMALL_STATE(9307)] = 339208,
  [SMALL_STATE(9308)] = 339225,
  [SMALL_STATE(9309)] = 339242,
  [SMALL_STATE(9310)] = 339259,
  [SMALL_STATE(9311)] = 339278,
  [SMALL_STATE(9312)] = 339297,
  [SMALL_STATE(9313)] = 339314,
  [SMALL_STATE(9314)] = 339331,
  [SMALL_STATE(9315)] = 339350,
  [SMALL_STATE(9316)] = 339367,
  [SMALL_STATE(9317)] = 339382,
  [SMALL_STATE(9318)] = 339399,
  [SMALL_STATE(9319)] = 339415,
  [SMALL_STATE(9320)] = 339431,
  [SMALL_STATE(9321)] = 339445,
  [SMALL_STATE(9322)] = 339461,
  [SMALL_STATE(9323)] = 339475,
  [SMALL_STATE(9324)] = 339491,
  [SMALL_STATE(9325)] = 339507,
  [SMALL_STATE(9326)] = 339521,
  [SMALL_STATE(9327)] = 339537,
  [SMALL_STATE(9328)] = 339553,
  [SMALL_STATE(9329)] = 339565,
  [SMALL_STATE(9330)] = 339581,
  [SMALL_STATE(9331)] = 339597,
  [SMALL_STATE(9332)] = 339613,
  [SMALL_STATE(9333)] = 339629,
  [SMALL_STATE(9334)] = 339645,
  [SMALL_STATE(9335)] = 339661,
  [SMALL_STATE(9336)] = 339677,
  [SMALL_STATE(9337)] = 339693,
  [SMALL_STATE(9338)] = 339709,
  [SMALL_STATE(9339)] = 339725,
  [SMALL_STATE(9340)] = 339741,
  [SMALL_STATE(9341)] = 339755,
  [SMALL_STATE(9342)] = 339769,
  [SMALL_STATE(9343)] = 339785,
  [SMALL_STATE(9344)] = 339801,
  [SMALL_STATE(9345)] = 339817,
  [SMALL_STATE(9346)] = 339833,
  [SMALL_STATE(9347)] = 339849,
  [SMALL_STATE(9348)] = 339863,
  [SMALL_STATE(9349)] = 339879,
  [SMALL_STATE(9350)] = 339895,
  [SMALL_STATE(9351)] = 339907,
  [SMALL_STATE(9352)] = 339923,
  [SMALL_STATE(9353)] = 339939,
  [SMALL_STATE(9354)] = 339953,
  [SMALL_STATE(9355)] = 339967,
  [SMALL_STATE(9356)] = 339981,
  [SMALL_STATE(9357)] = 339995,
  [SMALL_STATE(9358)] = 340011,
  [SMALL_STATE(9359)] = 340023,
  [SMALL_STATE(9360)] = 340037,
  [SMALL_STATE(9361)] = 340051,
  [SMALL_STATE(9362)] = 340067,
  [SMALL_STATE(9363)] = 340083,
  [SMALL_STATE(9364)] = 340099,
  [SMALL_STATE(9365)] = 340115,
  [SMALL_STATE(9366)] = 340129,
  [SMALL_STATE(9367)] = 340145,
  [SMALL_STATE(9368)] = 340161,
  [SMALL_STATE(9369)] = 340175,
  [SMALL_STATE(9370)] = 340191,
  [SMALL_STATE(9371)] = 340207,
  [SMALL_STATE(9372)] = 340223,
  [SMALL_STATE(9373)] = 340237,
  [SMALL_STATE(9374)] = 340251,
  [SMALL_STATE(9375)] = 340267,
  [SMALL_STATE(9376)] = 340281,
  [SMALL_STATE(9377)] = 340295,
  [SMALL_STATE(9378)] = 340311,
  [SMALL_STATE(9379)] = 340327,
  [SMALL_STATE(9380)] = 340343,
  [SMALL_STATE(9381)] = 340359,
  [SMALL_STATE(9382)] = 340375,
  [SMALL_STATE(9383)] = 340391,
  [SMALL_STATE(9384)] = 340407,
  [SMALL_STATE(9385)] = 340423,
  [SMALL_STATE(9386)] = 340439,
  [SMALL_STATE(9387)] = 340453,
  [SMALL_STATE(9388)] = 340469,
  [SMALL_STATE(9389)] = 340485,
  [SMALL_STATE(9390)] = 340501,
  [SMALL_STATE(9391)] = 340517,
  [SMALL_STATE(9392)] = 340533,
  [SMALL_STATE(9393)] = 340549,
  [SMALL_STATE(9394)] = 340565,
  [SMALL_STATE(9395)] = 340579,
  [SMALL_STATE(9396)] = 340595,
  [SMALL_STATE(9397)] = 340611,
  [SMALL_STATE(9398)] = 340627,
  [SMALL_STATE(9399)] = 340643,
  [SMALL_STATE(9400)] = 340659,
  [SMALL_STATE(9401)] = 340675,
  [SMALL_STATE(9402)] = 340691,
  [SMALL_STATE(9403)] = 340707,
  [SMALL_STATE(9404)] = 340723,
  [SMALL_STATE(9405)] = 340739,
  [SMALL_STATE(9406)] = 340753,
  [SMALL_STATE(9407)] = 340769,
  [SMALL_STATE(9408)] = 340785,
  [SMALL_STATE(9409)] = 340799,
  [SMALL_STATE(9410)] = 340815,
  [SMALL_STATE(9411)] = 340831,
  [SMALL_STATE(9412)] = 340845,
  [SMALL_STATE(9413)] = 340859,
  [SMALL_STATE(9414)] = 340875,
  [SMALL_STATE(9415)] = 340891,
  [SMALL_STATE(9416)] = 340907,
  [SMALL_STATE(9417)] = 340921,
  [SMALL_STATE(9418)] = 340931,
  [SMALL_STATE(9419)] = 340947,
  [SMALL_STATE(9420)] = 340963,
  [SMALL_STATE(9421)] = 340973,
  [SMALL_STATE(9422)] = 340987,
  [SMALL_STATE(9423)] = 341003,
  [SMALL_STATE(9424)] = 341019,
  [SMALL_STATE(9425)] = 341035,
  [SMALL_STATE(9426)] = 341051,
  [SMALL_STATE(9427)] = 341067,
  [SMALL_STATE(9428)] = 341083,
  [SMALL_STATE(9429)] = 341099,
  [SMALL_STATE(9430)] = 341115,
  [SMALL_STATE(9431)] = 341131,
  [SMALL_STATE(9432)] = 341145,
  [SMALL_STATE(9433)] = 341161,
  [SMALL_STATE(9434)] = 341177,
  [SMALL_STATE(9435)] = 341193,
  [SMALL_STATE(9436)] = 341209,
  [SMALL_STATE(9437)] = 341225,
  [SMALL_STATE(9438)] = 341241,
  [SMALL_STATE(9439)] = 341257,
  [SMALL_STATE(9440)] = 341273,
  [SMALL_STATE(9441)] = 341289,
  [SMALL_STATE(9442)] = 341303,
  [SMALL_STATE(9443)] = 341319,
  [SMALL_STATE(9444)] = 341335,
  [SMALL_STATE(9445)] = 341349,
  [SMALL_STATE(9446)] = 341361,
  [SMALL_STATE(9447)] = 341377,
  [SMALL_STATE(9448)] = 341393,
  [SMALL_STATE(9449)] = 341409,
  [SMALL_STATE(9450)] = 341425,
  [SMALL_STATE(9451)] = 341441,
  [SMALL_STATE(9452)] = 341457,
  [SMALL_STATE(9453)] = 341473,
  [SMALL_STATE(9454)] = 341487,
  [SMALL_STATE(9455)] = 341501,
  [SMALL_STATE(9456)] = 341517,
  [SMALL_STATE(9457)] = 341533,
  [SMALL_STATE(9458)] = 341549,
  [SMALL_STATE(9459)] = 341565,
  [SMALL_STATE(9460)] = 341581,
  [SMALL_STATE(9461)] = 341597,
  [SMALL_STATE(9462)] = 341613,
  [SMALL_STATE(9463)] = 341629,
  [SMALL_STATE(9464)] = 341645,
  [SMALL_STATE(9465)] = 341661,
  [SMALL_STATE(9466)] = 341675,
  [SMALL_STATE(9467)] = 341691,
  [SMALL_STATE(9468)] = 341707,
  [SMALL_STATE(9469)] = 341723,
  [SMALL_STATE(9470)] = 341739,
  [SMALL_STATE(9471)] = 341755,
  [SMALL_STATE(9472)] = 341771,
  [SMALL_STATE(9473)] = 341785,
  [SMALL_STATE(9474)] = 341801,
  [SMALL_STATE(9475)] = 341817,
  [SMALL_STATE(9476)] = 341827,
  [SMALL_STATE(9477)] = 341843,
  [SMALL_STATE(9478)] = 341859,
  [SMALL_STATE(9479)] = 341875,
  [SMALL_STATE(9480)] = 341891,
  [SMALL_STATE(9481)] = 341907,
  [SMALL_STATE(9482)] = 341921,
  [SMALL_STATE(9483)] = 341933,
  [SMALL_STATE(9484)] = 341949,
  [SMALL_STATE(9485)] = 341963,
  [SMALL_STATE(9486)] = 341977,
  [SMALL_STATE(9487)] = 341993,
  [SMALL_STATE(9488)] = 342009,
  [SMALL_STATE(9489)] = 342025,
  [SMALL_STATE(9490)] = 342041,
  [SMALL_STATE(9491)] = 342057,
  [SMALL_STATE(9492)] = 342071,
  [SMALL_STATE(9493)] = 342087,
  [SMALL_STATE(9494)] = 342097,
  [SMALL_STATE(9495)] = 342113,
  [SMALL_STATE(9496)] = 342125,
  [SMALL_STATE(9497)] = 342137,
  [SMALL_STATE(9498)] = 342153,
  [SMALL_STATE(9499)] = 342169,
  [SMALL_STATE(9500)] = 342185,
  [SMALL_STATE(9501)] = 342199,
  [SMALL_STATE(9502)] = 342213,
  [SMALL_STATE(9503)] = 342227,
  [SMALL_STATE(9504)] = 342243,
  [SMALL_STATE(9505)] = 342259,
  [SMALL_STATE(9506)] = 342273,
  [SMALL_STATE(9507)] = 342289,
  [SMALL_STATE(9508)] = 342305,
  [SMALL_STATE(9509)] = 342321,
  [SMALL_STATE(9510)] = 342337,
  [SMALL_STATE(9511)] = 342351,
  [SMALL_STATE(9512)] = 342367,
  [SMALL_STATE(9513)] = 342383,
  [SMALL_STATE(9514)] = 342399,
  [SMALL_STATE(9515)] = 342415,
  [SMALL_STATE(9516)] = 342431,
  [SMALL_STATE(9517)] = 342447,
  [SMALL_STATE(9518)] = 342463,
  [SMALL_STATE(9519)] = 342477,
  [SMALL_STATE(9520)] = 342493,
  [SMALL_STATE(9521)] = 342509,
  [SMALL_STATE(9522)] = 342525,
  [SMALL_STATE(9523)] = 342539,
  [SMALL_STATE(9524)] = 342555,
  [SMALL_STATE(9525)] = 342569,
  [SMALL_STATE(9526)] = 342585,
  [SMALL_STATE(9527)] = 342601,
  [SMALL_STATE(9528)] = 342615,
  [SMALL_STATE(9529)] = 342631,
  [SMALL_STATE(9530)] = 342645,
  [SMALL_STATE(9531)] = 342661,
  [SMALL_STATE(9532)] = 342677,
  [SMALL_STATE(9533)] = 342693,
  [SMALL_STATE(9534)] = 342709,
  [SMALL_STATE(9535)] = 342725,
  [SMALL_STATE(9536)] = 342739,
  [SMALL_STATE(9537)] = 342755,
  [SMALL_STATE(9538)] = 342771,
  [SMALL_STATE(9539)] = 342787,
  [SMALL_STATE(9540)] = 342801,
  [SMALL_STATE(9541)] = 342817,
  [SMALL_STATE(9542)] = 342833,
  [SMALL_STATE(9543)] = 342849,
  [SMALL_STATE(9544)] = 342865,
  [SMALL_STATE(9545)] = 342881,
  [SMALL_STATE(9546)] = 342897,
  [SMALL_STATE(9547)] = 342911,
  [SMALL_STATE(9548)] = 342925,
  [SMALL_STATE(9549)] = 342939,
  [SMALL_STATE(9550)] = 342955,
  [SMALL_STATE(9551)] = 342971,
  [SMALL_STATE(9552)] = 342987,
  [SMALL_STATE(9553)] = 343003,
  [SMALL_STATE(9554)] = 343019,
  [SMALL_STATE(9555)] = 343035,
  [SMALL_STATE(9556)] = 343051,
  [SMALL_STATE(9557)] = 343065,
  [SMALL_STATE(9558)] = 343079,
  [SMALL_STATE(9559)] = 343095,
  [SMALL_STATE(9560)] = 343111,
  [SMALL_STATE(9561)] = 343125,
  [SMALL_STATE(9562)] = 343139,
  [SMALL_STATE(9563)] = 343155,
  [SMALL_STATE(9564)] = 343171,
  [SMALL_STATE(9565)] = 343187,
  [SMALL_STATE(9566)] = 343201,
  [SMALL_STATE(9567)] = 343215,
  [SMALL_STATE(9568)] = 343231,
  [SMALL_STATE(9569)] = 343247,
  [SMALL_STATE(9570)] = 343261,
  [SMALL_STATE(9571)] = 343275,
  [SMALL_STATE(9572)] = 343291,
  [SMALL_STATE(9573)] = 343307,
  [SMALL_STATE(9574)] = 343323,
  [SMALL_STATE(9575)] = 343337,
  [SMALL_STATE(9576)] = 343351,
  [SMALL_STATE(9577)] = 343367,
  [SMALL_STATE(9578)] = 343381,
  [SMALL_STATE(9579)] = 343397,
  [SMALL_STATE(9580)] = 343413,
  [SMALL_STATE(9581)] = 343429,
  [SMALL_STATE(9582)] = 343445,
  [SMALL_STATE(9583)] = 343461,
  [SMALL_STATE(9584)] = 343477,
  [SMALL_STATE(9585)] = 343493,
  [SMALL_STATE(9586)] = 343509,
  [SMALL_STATE(9587)] = 343525,
  [SMALL_STATE(9588)] = 343537,
  [SMALL_STATE(9589)] = 343553,
  [SMALL_STATE(9590)] = 343569,
  [SMALL_STATE(9591)] = 343583,
  [SMALL_STATE(9592)] = 343599,
  [SMALL_STATE(9593)] = 343615,
  [SMALL_STATE(9594)] = 343631,
  [SMALL_STATE(9595)] = 343647,
  [SMALL_STATE(9596)] = 343663,
  [SMALL_STATE(9597)] = 343679,
  [SMALL_STATE(9598)] = 343695,
  [SMALL_STATE(9599)] = 343711,
  [SMALL_STATE(9600)] = 343725,
  [SMALL_STATE(9601)] = 343741,
  [SMALL_STATE(9602)] = 343757,
  [SMALL_STATE(9603)] = 343771,
  [SMALL_STATE(9604)] = 343784,
  [SMALL_STATE(9605)] = 343793,
  [SMALL_STATE(9606)] = 343806,
  [SMALL_STATE(9607)] = 343819,
  [SMALL_STATE(9608)] = 343832,
  [SMALL_STATE(9609)] = 343845,
  [SMALL_STATE(9610)] = 343858,
  [SMALL_STATE(9611)] = 343871,
  [SMALL_STATE(9612)] = 343884,
  [SMALL_STATE(9613)] = 343893,
  [SMALL_STATE(9614)] = 343906,
  [SMALL_STATE(9615)] = 343919,
  [SMALL_STATE(9616)] = 343932,
  [SMALL_STATE(9617)] = 343945,
  [SMALL_STATE(9618)] = 343958,
  [SMALL_STATE(9619)] = 343971,
  [SMALL_STATE(9620)] = 343984,
  [SMALL_STATE(9621)] = 343997,
  [SMALL_STATE(9622)] = 344010,
  [SMALL_STATE(9623)] = 344023,
  [SMALL_STATE(9624)] = 344036,
  [SMALL_STATE(9625)] = 344049,
  [SMALL_STATE(9626)] = 344062,
  [SMALL_STATE(9627)] = 344075,
  [SMALL_STATE(9628)] = 344088,
  [SMALL_STATE(9629)] = 344101,
  [SMALL_STATE(9630)] = 344114,
  [SMALL_STATE(9631)] = 344127,
  [SMALL_STATE(9632)] = 344138,
  [SMALL_STATE(9633)] = 344151,
  [SMALL_STATE(9634)] = 344164,
  [SMALL_STATE(9635)] = 344177,
  [SMALL_STATE(9636)] = 344190,
  [SMALL_STATE(9637)] = 344203,
  [SMALL_STATE(9638)] = 344216,
  [SMALL_STATE(9639)] = 344229,
  [SMALL_STATE(9640)] = 344242,
  [SMALL_STATE(9641)] = 344255,
  [SMALL_STATE(9642)] = 344268,
  [SMALL_STATE(9643)] = 344281,
  [SMALL_STATE(9644)] = 344294,
  [SMALL_STATE(9645)] = 344307,
  [SMALL_STATE(9646)] = 344320,
  [SMALL_STATE(9647)] = 344333,
  [SMALL_STATE(9648)] = 344346,
  [SMALL_STATE(9649)] = 344359,
  [SMALL_STATE(9650)] = 344372,
  [SMALL_STATE(9651)] = 344385,
  [SMALL_STATE(9652)] = 344398,
  [SMALL_STATE(9653)] = 344411,
  [SMALL_STATE(9654)] = 344424,
  [SMALL_STATE(9655)] = 344435,
  [SMALL_STATE(9656)] = 344448,
  [SMALL_STATE(9657)] = 344461,
  [SMALL_STATE(9658)] = 344474,
  [SMALL_STATE(9659)] = 344485,
  [SMALL_STATE(9660)] = 344496,
  [SMALL_STATE(9661)] = 344509,
  [SMALL_STATE(9662)] = 344522,
  [SMALL_STATE(9663)] = 344535,
  [SMALL_STATE(9664)] = 344548,
  [SMALL_STATE(9665)] = 344561,
  [SMALL_STATE(9666)] = 344574,
  [SMALL_STATE(9667)] = 344587,
  [SMALL_STATE(9668)] = 344600,
  [SMALL_STATE(9669)] = 344613,
  [SMALL_STATE(9670)] = 344626,
  [SMALL_STATE(9671)] = 344639,
  [SMALL_STATE(9672)] = 344652,
  [SMALL_STATE(9673)] = 344665,
  [SMALL_STATE(9674)] = 344678,
  [SMALL_STATE(9675)] = 344691,
  [SMALL_STATE(9676)] = 344704,
  [SMALL_STATE(9677)] = 344717,
  [SMALL_STATE(9678)] = 344730,
  [SMALL_STATE(9679)] = 344743,
  [SMALL_STATE(9680)] = 344756,
  [SMALL_STATE(9681)] = 344769,
  [SMALL_STATE(9682)] = 344782,
  [SMALL_STATE(9683)] = 344795,
  [SMALL_STATE(9684)] = 344808,
  [SMALL_STATE(9685)] = 344821,
  [SMALL_STATE(9686)] = 344834,
  [SMALL_STATE(9687)] = 344843,
  [SMALL_STATE(9688)] = 344856,
  [SMALL_STATE(9689)] = 344869,
  [SMALL_STATE(9690)] = 344882,
  [SMALL_STATE(9691)] = 344895,
  [SMALL_STATE(9692)] = 344908,
  [SMALL_STATE(9693)] = 344921,
  [SMALL_STATE(9694)] = 344934,
  [SMALL_STATE(9695)] = 344947,
  [SMALL_STATE(9696)] = 344960,
  [SMALL_STATE(9697)] = 344973,
  [SMALL_STATE(9698)] = 344986,
  [SMALL_STATE(9699)] = 344999,
  [SMALL_STATE(9700)] = 345012,
  [SMALL_STATE(9701)] = 345025,
  [SMALL_STATE(9702)] = 345038,
  [SMALL_STATE(9703)] = 345051,
  [SMALL_STATE(9704)] = 345064,
  [SMALL_STATE(9705)] = 345077,
  [SMALL_STATE(9706)] = 345090,
  [SMALL_STATE(9707)] = 345103,
  [SMALL_STATE(9708)] = 345116,
  [SMALL_STATE(9709)] = 345129,
  [SMALL_STATE(9710)] = 345142,
  [SMALL_STATE(9711)] = 345155,
  [SMALL_STATE(9712)] = 345166,
  [SMALL_STATE(9713)] = 345179,
  [SMALL_STATE(9714)] = 345192,
  [SMALL_STATE(9715)] = 345205,
  [SMALL_STATE(9716)] = 345218,
  [SMALL_STATE(9717)] = 345231,
  [SMALL_STATE(9718)] = 345244,
  [SMALL_STATE(9719)] = 345257,
  [SMALL_STATE(9720)] = 345270,
  [SMALL_STATE(9721)] = 345283,
  [SMALL_STATE(9722)] = 345292,
  [SMALL_STATE(9723)] = 345305,
  [SMALL_STATE(9724)] = 345318,
  [SMALL_STATE(9725)] = 345331,
  [SMALL_STATE(9726)] = 345344,
  [SMALL_STATE(9727)] = 345355,
  [SMALL_STATE(9728)] = 345368,
  [SMALL_STATE(9729)] = 345381,
  [SMALL_STATE(9730)] = 345394,
  [SMALL_STATE(9731)] = 345407,
  [SMALL_STATE(9732)] = 345420,
  [SMALL_STATE(9733)] = 345433,
  [SMALL_STATE(9734)] = 345446,
  [SMALL_STATE(9735)] = 345459,
  [SMALL_STATE(9736)] = 345472,
  [SMALL_STATE(9737)] = 345485,
  [SMALL_STATE(9738)] = 345498,
  [SMALL_STATE(9739)] = 345511,
  [SMALL_STATE(9740)] = 345524,
  [SMALL_STATE(9741)] = 345537,
  [SMALL_STATE(9742)] = 345550,
  [SMALL_STATE(9743)] = 345563,
  [SMALL_STATE(9744)] = 345576,
  [SMALL_STATE(9745)] = 345589,
  [SMALL_STATE(9746)] = 345600,
  [SMALL_STATE(9747)] = 345613,
  [SMALL_STATE(9748)] = 345626,
  [SMALL_STATE(9749)] = 345639,
  [SMALL_STATE(9750)] = 345652,
  [SMALL_STATE(9751)] = 345665,
  [SMALL_STATE(9752)] = 345676,
  [SMALL_STATE(9753)] = 345689,
  [SMALL_STATE(9754)] = 345702,
  [SMALL_STATE(9755)] = 345715,
  [SMALL_STATE(9756)] = 345728,
  [SMALL_STATE(9757)] = 345741,
  [SMALL_STATE(9758)] = 345754,
  [SMALL_STATE(9759)] = 345765,
  [SMALL_STATE(9760)] = 345776,
  [SMALL_STATE(9761)] = 345789,
  [SMALL_STATE(9762)] = 345802,
  [SMALL_STATE(9763)] = 345815,
  [SMALL_STATE(9764)] = 345828,
  [SMALL_STATE(9765)] = 345841,
  [SMALL_STATE(9766)] = 345854,
  [SMALL_STATE(9767)] = 345867,
  [SMALL_STATE(9768)] = 345880,
  [SMALL_STATE(9769)] = 345893,
  [SMALL_STATE(9770)] = 345906,
  [SMALL_STATE(9771)] = 345919,
  [SMALL_STATE(9772)] = 345932,
  [SMALL_STATE(9773)] = 345945,
  [SMALL_STATE(9774)] = 345958,
  [SMALL_STATE(9775)] = 345971,
  [SMALL_STATE(9776)] = 345984,
  [SMALL_STATE(9777)] = 345995,
  [SMALL_STATE(9778)] = 346008,
  [SMALL_STATE(9779)] = 346021,
  [SMALL_STATE(9780)] = 346034,
  [SMALL_STATE(9781)] = 346047,
  [SMALL_STATE(9782)] = 346056,
  [SMALL_STATE(9783)] = 346069,
  [SMALL_STATE(9784)] = 346082,
  [SMALL_STATE(9785)] = 346095,
  [SMALL_STATE(9786)] = 346108,
  [SMALL_STATE(9787)] = 346121,
  [SMALL_STATE(9788)] = 346134,
  [SMALL_STATE(9789)] = 346147,
  [SMALL_STATE(9790)] = 346160,
  [SMALL_STATE(9791)] = 346173,
  [SMALL_STATE(9792)] = 346186,
  [SMALL_STATE(9793)] = 346199,
  [SMALL_STATE(9794)] = 346212,
  [SMALL_STATE(9795)] = 346225,
  [SMALL_STATE(9796)] = 346238,
  [SMALL_STATE(9797)] = 346251,
  [SMALL_STATE(9798)] = 346264,
  [SMALL_STATE(9799)] = 346277,
  [SMALL_STATE(9800)] = 346290,
  [SMALL_STATE(9801)] = 346303,
  [SMALL_STATE(9802)] = 346316,
  [SMALL_STATE(9803)] = 346329,
  [SMALL_STATE(9804)] = 346342,
  [SMALL_STATE(9805)] = 346355,
  [SMALL_STATE(9806)] = 346368,
  [SMALL_STATE(9807)] = 346381,
  [SMALL_STATE(9808)] = 346394,
  [SMALL_STATE(9809)] = 346407,
  [SMALL_STATE(9810)] = 346420,
  [SMALL_STATE(9811)] = 346433,
  [SMALL_STATE(9812)] = 346446,
  [SMALL_STATE(9813)] = 346457,
  [SMALL_STATE(9814)] = 346470,
  [SMALL_STATE(9815)] = 346483,
  [SMALL_STATE(9816)] = 346496,
  [SMALL_STATE(9817)] = 346509,
  [SMALL_STATE(9818)] = 346522,
  [SMALL_STATE(9819)] = 346531,
  [SMALL_STATE(9820)] = 346540,
  [SMALL_STATE(9821)] = 346553,
  [SMALL_STATE(9822)] = 346566,
  [SMALL_STATE(9823)] = 346579,
  [SMALL_STATE(9824)] = 346592,
  [SMALL_STATE(9825)] = 346605,
  [SMALL_STATE(9826)] = 346618,
  [SMALL_STATE(9827)] = 346631,
  [SMALL_STATE(9828)] = 346644,
  [SMALL_STATE(9829)] = 346657,
  [SMALL_STATE(9830)] = 346670,
  [SMALL_STATE(9831)] = 346683,
  [SMALL_STATE(9832)] = 346694,
  [SMALL_STATE(9833)] = 346707,
  [SMALL_STATE(9834)] = 346720,
  [SMALL_STATE(9835)] = 346733,
  [SMALL_STATE(9836)] = 346746,
  [SMALL_STATE(9837)] = 346759,
  [SMALL_STATE(9838)] = 346772,
  [SMALL_STATE(9839)] = 346785,
  [SMALL_STATE(9840)] = 346798,
  [SMALL_STATE(9841)] = 346811,
  [SMALL_STATE(9842)] = 346824,
  [SMALL_STATE(9843)] = 346837,
  [SMALL_STATE(9844)] = 346850,
  [SMALL_STATE(9845)] = 346863,
  [SMALL_STATE(9846)] = 346874,
  [SMALL_STATE(9847)] = 346887,
  [SMALL_STATE(9848)] = 346900,
  [SMALL_STATE(9849)] = 346913,
  [SMALL_STATE(9850)] = 346926,
  [SMALL_STATE(9851)] = 346939,
  [SMALL_STATE(9852)] = 346952,
  [SMALL_STATE(9853)] = 346965,
  [SMALL_STATE(9854)] = 346978,
  [SMALL_STATE(9855)] = 346991,
  [SMALL_STATE(9856)] = 347004,
  [SMALL_STATE(9857)] = 347017,
  [SMALL_STATE(9858)] = 347030,
  [SMALL_STATE(9859)] = 347043,
  [SMALL_STATE(9860)] = 347056,
  [SMALL_STATE(9861)] = 347067,
  [SMALL_STATE(9862)] = 347080,
  [SMALL_STATE(9863)] = 347093,
  [SMALL_STATE(9864)] = 347102,
  [SMALL_STATE(9865)] = 347115,
  [SMALL_STATE(9866)] = 347128,
  [SMALL_STATE(9867)] = 347141,
  [SMALL_STATE(9868)] = 347154,
  [SMALL_STATE(9869)] = 347167,
  [SMALL_STATE(9870)] = 347180,
  [SMALL_STATE(9871)] = 347193,
  [SMALL_STATE(9872)] = 347206,
  [SMALL_STATE(9873)] = 347219,
  [SMALL_STATE(9874)] = 347228,
  [SMALL_STATE(9875)] = 347241,
  [SMALL_STATE(9876)] = 347254,
  [SMALL_STATE(9877)] = 347267,
  [SMALL_STATE(9878)] = 347280,
  [SMALL_STATE(9879)] = 347293,
  [SMALL_STATE(9880)] = 347302,
  [SMALL_STATE(9881)] = 347315,
  [SMALL_STATE(9882)] = 347328,
  [SMALL_STATE(9883)] = 347339,
  [SMALL_STATE(9884)] = 347352,
  [SMALL_STATE(9885)] = 347363,
  [SMALL_STATE(9886)] = 347376,
  [SMALL_STATE(9887)] = 347389,
  [SMALL_STATE(9888)] = 347402,
  [SMALL_STATE(9889)] = 347415,
  [SMALL_STATE(9890)] = 347428,
  [SMALL_STATE(9891)] = 347441,
  [SMALL_STATE(9892)] = 347454,
  [SMALL_STATE(9893)] = 347467,
  [SMALL_STATE(9894)] = 347480,
  [SMALL_STATE(9895)] = 347493,
  [SMALL_STATE(9896)] = 347506,
  [SMALL_STATE(9897)] = 347519,
  [SMALL_STATE(9898)] = 347532,
  [SMALL_STATE(9899)] = 347545,
  [SMALL_STATE(9900)] = 347558,
  [SMALL_STATE(9901)] = 347571,
  [SMALL_STATE(9902)] = 347584,
  [SMALL_STATE(9903)] = 347597,
  [SMALL_STATE(9904)] = 347608,
  [SMALL_STATE(9905)] = 347621,
  [SMALL_STATE(9906)] = 347634,
  [SMALL_STATE(9907)] = 347647,
  [SMALL_STATE(9908)] = 347660,
  [SMALL_STATE(9909)] = 347671,
  [SMALL_STATE(9910)] = 347684,
  [SMALL_STATE(9911)] = 347697,
  [SMALL_STATE(9912)] = 347710,
  [SMALL_STATE(9913)] = 347723,
  [SMALL_STATE(9914)] = 347736,
  [SMALL_STATE(9915)] = 347749,
  [SMALL_STATE(9916)] = 347762,
  [SMALL_STATE(9917)] = 347773,
  [SMALL_STATE(9918)] = 347786,
  [SMALL_STATE(9919)] = 347799,
  [SMALL_STATE(9920)] = 347812,
  [SMALL_STATE(9921)] = 347825,
  [SMALL_STATE(9922)] = 347838,
  [SMALL_STATE(9923)] = 347847,
  [SMALL_STATE(9924)] = 347860,
  [SMALL_STATE(9925)] = 347873,
  [SMALL_STATE(9926)] = 347886,
  [SMALL_STATE(9927)] = 347899,
  [SMALL_STATE(9928)] = 347912,
  [SMALL_STATE(9929)] = 347925,
  [SMALL_STATE(9930)] = 347936,
  [SMALL_STATE(9931)] = 347949,
  [SMALL_STATE(9932)] = 347962,
  [SMALL_STATE(9933)] = 347975,
  [SMALL_STATE(9934)] = 347988,
  [SMALL_STATE(9935)] = 348001,
  [SMALL_STATE(9936)] = 348014,
  [SMALL_STATE(9937)] = 348027,
  [SMALL_STATE(9938)] = 348040,
  [SMALL_STATE(9939)] = 348053,
  [SMALL_STATE(9940)] = 348066,
  [SMALL_STATE(9941)] = 348079,
  [SMALL_STATE(9942)] = 348092,
  [SMALL_STATE(9943)] = 348105,
  [SMALL_STATE(9944)] = 348118,
  [SMALL_STATE(9945)] = 348131,
  [SMALL_STATE(9946)] = 348144,
  [SMALL_STATE(9947)] = 348157,
  [SMALL_STATE(9948)] = 348170,
  [SMALL_STATE(9949)] = 348181,
  [SMALL_STATE(9950)] = 348194,
  [SMALL_STATE(9951)] = 348207,
  [SMALL_STATE(9952)] = 348220,
  [SMALL_STATE(9953)] = 348233,
  [SMALL_STATE(9954)] = 348246,
  [SMALL_STATE(9955)] = 348257,
  [SMALL_STATE(9956)] = 348270,
  [SMALL_STATE(9957)] = 348283,
  [SMALL_STATE(9958)] = 348296,
  [SMALL_STATE(9959)] = 348309,
  [SMALL_STATE(9960)] = 348322,
  [SMALL_STATE(9961)] = 348335,
  [SMALL_STATE(9962)] = 348348,
  [SMALL_STATE(9963)] = 348361,
  [SMALL_STATE(9964)] = 348374,
  [SMALL_STATE(9965)] = 348387,
  [SMALL_STATE(9966)] = 348400,
  [SMALL_STATE(9967)] = 348413,
  [SMALL_STATE(9968)] = 348426,
  [SMALL_STATE(9969)] = 348439,
  [SMALL_STATE(9970)] = 348452,
  [SMALL_STATE(9971)] = 348465,
  [SMALL_STATE(9972)] = 348478,
  [SMALL_STATE(9973)] = 348491,
  [SMALL_STATE(9974)] = 348502,
  [SMALL_STATE(9975)] = 348515,
  [SMALL_STATE(9976)] = 348528,
  [SMALL_STATE(9977)] = 348541,
  [SMALL_STATE(9978)] = 348554,
  [SMALL_STATE(9979)] = 348567,
  [SMALL_STATE(9980)] = 348580,
  [SMALL_STATE(9981)] = 348593,
  [SMALL_STATE(9982)] = 348606,
  [SMALL_STATE(9983)] = 348619,
  [SMALL_STATE(9984)] = 348632,
  [SMALL_STATE(9985)] = 348645,
  [SMALL_STATE(9986)] = 348658,
  [SMALL_STATE(9987)] = 348671,
  [SMALL_STATE(9988)] = 348684,
  [SMALL_STATE(9989)] = 348695,
  [SMALL_STATE(9990)] = 348708,
  [SMALL_STATE(9991)] = 348721,
  [SMALL_STATE(9992)] = 348734,
  [SMALL_STATE(9993)] = 348747,
  [SMALL_STATE(9994)] = 348760,
  [SMALL_STATE(9995)] = 348773,
  [SMALL_STATE(9996)] = 348786,
  [SMALL_STATE(9997)] = 348799,
  [SMALL_STATE(9998)] = 348812,
  [SMALL_STATE(9999)] = 348825,
  [SMALL_STATE(10000)] = 348838,
  [SMALL_STATE(10001)] = 348851,
  [SMALL_STATE(10002)] = 348864,
  [SMALL_STATE(10003)] = 348873,
  [SMALL_STATE(10004)] = 348884,
  [SMALL_STATE(10005)] = 348897,
  [SMALL_STATE(10006)] = 348910,
  [SMALL_STATE(10007)] = 348923,
  [SMALL_STATE(10008)] = 348936,
  [SMALL_STATE(10009)] = 348949,
  [SMALL_STATE(10010)] = 348962,
  [SMALL_STATE(10011)] = 348973,
  [SMALL_STATE(10012)] = 348986,
  [SMALL_STATE(10013)] = 348997,
  [SMALL_STATE(10014)] = 349008,
  [SMALL_STATE(10015)] = 349021,
  [SMALL_STATE(10016)] = 349034,
  [SMALL_STATE(10017)] = 349047,
  [SMALL_STATE(10018)] = 349060,
  [SMALL_STATE(10019)] = 349073,
  [SMALL_STATE(10020)] = 349086,
  [SMALL_STATE(10021)] = 349099,
  [SMALL_STATE(10022)] = 349112,
  [SMALL_STATE(10023)] = 349125,
  [SMALL_STATE(10024)] = 349134,
  [SMALL_STATE(10025)] = 349143,
  [SMALL_STATE(10026)] = 349156,
  [SMALL_STATE(10027)] = 349169,
  [SMALL_STATE(10028)] = 349182,
  [SMALL_STATE(10029)] = 349195,
  [SMALL_STATE(10030)] = 349208,
  [SMALL_STATE(10031)] = 349221,
  [SMALL_STATE(10032)] = 349234,
  [SMALL_STATE(10033)] = 349247,
  [SMALL_STATE(10034)] = 349260,
  [SMALL_STATE(10035)] = 349271,
  [SMALL_STATE(10036)] = 349284,
  [SMALL_STATE(10037)] = 349297,
  [SMALL_STATE(10038)] = 349310,
  [SMALL_STATE(10039)] = 349323,
  [SMALL_STATE(10040)] = 349336,
  [SMALL_STATE(10041)] = 349349,
  [SMALL_STATE(10042)] = 349360,
  [SMALL_STATE(10043)] = 349373,
  [SMALL_STATE(10044)] = 349386,
  [SMALL_STATE(10045)] = 349397,
  [SMALL_STATE(10046)] = 349410,
  [SMALL_STATE(10047)] = 349423,
  [SMALL_STATE(10048)] = 349432,
  [SMALL_STATE(10049)] = 349445,
  [SMALL_STATE(10050)] = 349458,
  [SMALL_STATE(10051)] = 349471,
  [SMALL_STATE(10052)] = 349484,
  [SMALL_STATE(10053)] = 349497,
  [SMALL_STATE(10054)] = 349510,
  [SMALL_STATE(10055)] = 349523,
  [SMALL_STATE(10056)] = 349534,
  [SMALL_STATE(10057)] = 349547,
  [SMALL_STATE(10058)] = 349560,
  [SMALL_STATE(10059)] = 349573,
  [SMALL_STATE(10060)] = 349586,
  [SMALL_STATE(10061)] = 349599,
  [SMALL_STATE(10062)] = 349612,
  [SMALL_STATE(10063)] = 349625,
  [SMALL_STATE(10064)] = 349638,
  [SMALL_STATE(10065)] = 349651,
  [SMALL_STATE(10066)] = 349664,
  [SMALL_STATE(10067)] = 349677,
  [SMALL_STATE(10068)] = 349690,
  [SMALL_STATE(10069)] = 349703,
  [SMALL_STATE(10070)] = 349716,
  [SMALL_STATE(10071)] = 349729,
  [SMALL_STATE(10072)] = 349742,
  [SMALL_STATE(10073)] = 349753,
  [SMALL_STATE(10074)] = 349766,
  [SMALL_STATE(10075)] = 349779,
  [SMALL_STATE(10076)] = 349790,
  [SMALL_STATE(10077)] = 349803,
  [SMALL_STATE(10078)] = 349816,
  [SMALL_STATE(10079)] = 349829,
  [SMALL_STATE(10080)] = 349842,
  [SMALL_STATE(10081)] = 349855,
  [SMALL_STATE(10082)] = 349864,
  [SMALL_STATE(10083)] = 349877,
  [SMALL_STATE(10084)] = 349890,
  [SMALL_STATE(10085)] = 349903,
  [SMALL_STATE(10086)] = 349916,
  [SMALL_STATE(10087)] = 349929,
  [SMALL_STATE(10088)] = 349942,
  [SMALL_STATE(10089)] = 349955,
  [SMALL_STATE(10090)] = 349968,
  [SMALL_STATE(10091)] = 349981,
  [SMALL_STATE(10092)] = 349994,
  [SMALL_STATE(10093)] = 350007,
  [SMALL_STATE(10094)] = 350020,
  [SMALL_STATE(10095)] = 350029,
  [SMALL_STATE(10096)] = 350042,
  [SMALL_STATE(10097)] = 350055,
  [SMALL_STATE(10098)] = 350068,
  [SMALL_STATE(10099)] = 350079,
  [SMALL_STATE(10100)] = 350092,
  [SMALL_STATE(10101)] = 350105,
  [SMALL_STATE(10102)] = 350118,
  [SMALL_STATE(10103)] = 350131,
  [SMALL_STATE(10104)] = 350144,
  [SMALL_STATE(10105)] = 350155,
  [SMALL_STATE(10106)] = 350168,
  [SMALL_STATE(10107)] = 350181,
  [SMALL_STATE(10108)] = 350194,
  [SMALL_STATE(10109)] = 350207,
  [SMALL_STATE(10110)] = 350220,
  [SMALL_STATE(10111)] = 350233,
  [SMALL_STATE(10112)] = 350246,
  [SMALL_STATE(10113)] = 350259,
  [SMALL_STATE(10114)] = 350272,
  [SMALL_STATE(10115)] = 350285,
  [SMALL_STATE(10116)] = 350294,
  [SMALL_STATE(10117)] = 350303,
  [SMALL_STATE(10118)] = 350316,
  [SMALL_STATE(10119)] = 350329,
  [SMALL_STATE(10120)] = 350342,
  [SMALL_STATE(10121)] = 350355,
  [SMALL_STATE(10122)] = 350368,
  [SMALL_STATE(10123)] = 350381,
  [SMALL_STATE(10124)] = 350394,
  [SMALL_STATE(10125)] = 350407,
  [SMALL_STATE(10126)] = 350420,
  [SMALL_STATE(10127)] = 350433,
  [SMALL_STATE(10128)] = 350446,
  [SMALL_STATE(10129)] = 350459,
  [SMALL_STATE(10130)] = 350472,
  [SMALL_STATE(10131)] = 350481,
  [SMALL_STATE(10132)] = 350494,
  [SMALL_STATE(10133)] = 350507,
  [SMALL_STATE(10134)] = 350520,
  [SMALL_STATE(10135)] = 350533,
  [SMALL_STATE(10136)] = 350546,
  [SMALL_STATE(10137)] = 350559,
  [SMALL_STATE(10138)] = 350572,
  [SMALL_STATE(10139)] = 350585,
  [SMALL_STATE(10140)] = 350598,
  [SMALL_STATE(10141)] = 350611,
  [SMALL_STATE(10142)] = 350624,
  [SMALL_STATE(10143)] = 350637,
  [SMALL_STATE(10144)] = 350650,
  [SMALL_STATE(10145)] = 350659,
  [SMALL_STATE(10146)] = 350672,
  [SMALL_STATE(10147)] = 350681,
  [SMALL_STATE(10148)] = 350694,
  [SMALL_STATE(10149)] = 350707,
  [SMALL_STATE(10150)] = 350720,
  [SMALL_STATE(10151)] = 350733,
  [SMALL_STATE(10152)] = 350746,
  [SMALL_STATE(10153)] = 350759,
  [SMALL_STATE(10154)] = 350770,
  [SMALL_STATE(10155)] = 350783,
  [SMALL_STATE(10156)] = 350796,
  [SMALL_STATE(10157)] = 350807,
  [SMALL_STATE(10158)] = 350820,
  [SMALL_STATE(10159)] = 350833,
  [SMALL_STATE(10160)] = 350846,
  [SMALL_STATE(10161)] = 350859,
  [SMALL_STATE(10162)] = 350872,
  [SMALL_STATE(10163)] = 350885,
  [SMALL_STATE(10164)] = 350898,
  [SMALL_STATE(10165)] = 350911,
  [SMALL_STATE(10166)] = 350924,
  [SMALL_STATE(10167)] = 350937,
  [SMALL_STATE(10168)] = 350950,
  [SMALL_STATE(10169)] = 350963,
  [SMALL_STATE(10170)] = 350976,
  [SMALL_STATE(10171)] = 350989,
  [SMALL_STATE(10172)] = 351002,
  [SMALL_STATE(10173)] = 351015,
  [SMALL_STATE(10174)] = 351028,
  [SMALL_STATE(10175)] = 351041,
  [SMALL_STATE(10176)] = 351054,
  [SMALL_STATE(10177)] = 351067,
  [SMALL_STATE(10178)] = 351080,
  [SMALL_STATE(10179)] = 351093,
  [SMALL_STATE(10180)] = 351106,
  [SMALL_STATE(10181)] = 351115,
  [SMALL_STATE(10182)] = 351128,
  [SMALL_STATE(10183)] = 351141,
  [SMALL_STATE(10184)] = 351154,
  [SMALL_STATE(10185)] = 351167,
  [SMALL_STATE(10186)] = 351180,
  [SMALL_STATE(10187)] = 351193,
  [SMALL_STATE(10188)] = 351206,
  [SMALL_STATE(10189)] = 351219,
  [SMALL_STATE(10190)] = 351232,
  [SMALL_STATE(10191)] = 351245,
  [SMALL_STATE(10192)] = 351258,
  [SMALL_STATE(10193)] = 351267,
  [SMALL_STATE(10194)] = 351278,
  [SMALL_STATE(10195)] = 351291,
  [SMALL_STATE(10196)] = 351304,
  [SMALL_STATE(10197)] = 351317,
  [SMALL_STATE(10198)] = 351330,
  [SMALL_STATE(10199)] = 351343,
  [SMALL_STATE(10200)] = 351356,
  [SMALL_STATE(10201)] = 351369,
  [SMALL_STATE(10202)] = 351382,
  [SMALL_STATE(10203)] = 351395,
  [SMALL_STATE(10204)] = 351408,
  [SMALL_STATE(10205)] = 351421,
  [SMALL_STATE(10206)] = 351432,
  [SMALL_STATE(10207)] = 351445,
  [SMALL_STATE(10208)] = 351458,
  [SMALL_STATE(10209)] = 351471,
  [SMALL_STATE(10210)] = 351480,
  [SMALL_STATE(10211)] = 351493,
  [SMALL_STATE(10212)] = 351506,
  [SMALL_STATE(10213)] = 351519,
  [SMALL_STATE(10214)] = 351532,
  [SMALL_STATE(10215)] = 351545,
  [SMALL_STATE(10216)] = 351558,
  [SMALL_STATE(10217)] = 351567,
  [SMALL_STATE(10218)] = 351580,
  [SMALL_STATE(10219)] = 351593,
  [SMALL_STATE(10220)] = 351606,
  [SMALL_STATE(10221)] = 351619,
  [SMALL_STATE(10222)] = 351632,
  [SMALL_STATE(10223)] = 351645,
  [SMALL_STATE(10224)] = 351658,
  [SMALL_STATE(10225)] = 351671,
  [SMALL_STATE(10226)] = 351684,
  [SMALL_STATE(10227)] = 351697,
  [SMALL_STATE(10228)] = 351710,
  [SMALL_STATE(10229)] = 351723,
  [SMALL_STATE(10230)] = 351736,
  [SMALL_STATE(10231)] = 351749,
  [SMALL_STATE(10232)] = 351760,
  [SMALL_STATE(10233)] = 351773,
  [SMALL_STATE(10234)] = 351786,
  [SMALL_STATE(10235)] = 351799,
  [SMALL_STATE(10236)] = 351812,
  [SMALL_STATE(10237)] = 351825,
  [SMALL_STATE(10238)] = 351838,
  [SMALL_STATE(10239)] = 351847,
  [SMALL_STATE(10240)] = 351860,
  [SMALL_STATE(10241)] = 351873,
  [SMALL_STATE(10242)] = 351886,
  [SMALL_STATE(10243)] = 351897,
  [SMALL_STATE(10244)] = 351910,
  [SMALL_STATE(10245)] = 351921,
  [SMALL_STATE(10246)] = 351934,
  [SMALL_STATE(10247)] = 351947,
  [SMALL_STATE(10248)] = 351960,
  [SMALL_STATE(10249)] = 351973,
  [SMALL_STATE(10250)] = 351986,
  [SMALL_STATE(10251)] = 351999,
  [SMALL_STATE(10252)] = 352012,
  [SMALL_STATE(10253)] = 352025,
  [SMALL_STATE(10254)] = 352038,
  [SMALL_STATE(10255)] = 352051,
  [SMALL_STATE(10256)] = 352064,
  [SMALL_STATE(10257)] = 352077,
  [SMALL_STATE(10258)] = 352090,
  [SMALL_STATE(10259)] = 352103,
  [SMALL_STATE(10260)] = 352116,
  [SMALL_STATE(10261)] = 352127,
  [SMALL_STATE(10262)] = 352140,
  [SMALL_STATE(10263)] = 352153,
  [SMALL_STATE(10264)] = 352166,
  [SMALL_STATE(10265)] = 352177,
  [SMALL_STATE(10266)] = 352188,
  [SMALL_STATE(10267)] = 352201,
  [SMALL_STATE(10268)] = 352214,
  [SMALL_STATE(10269)] = 352223,
  [SMALL_STATE(10270)] = 352234,
  [SMALL_STATE(10271)] = 352245,
  [SMALL_STATE(10272)] = 352256,
  [SMALL_STATE(10273)] = 352269,
  [SMALL_STATE(10274)] = 352282,
  [SMALL_STATE(10275)] = 352291,
  [SMALL_STATE(10276)] = 352300,
  [SMALL_STATE(10277)] = 352313,
  [SMALL_STATE(10278)] = 352326,
  [SMALL_STATE(10279)] = 352339,
  [SMALL_STATE(10280)] = 352352,
  [SMALL_STATE(10281)] = 352363,
  [SMALL_STATE(10282)] = 352374,
  [SMALL_STATE(10283)] = 352387,
  [SMALL_STATE(10284)] = 352398,
  [SMALL_STATE(10285)] = 352411,
  [SMALL_STATE(10286)] = 352424,
  [SMALL_STATE(10287)] = 352437,
  [SMALL_STATE(10288)] = 352450,
  [SMALL_STATE(10289)] = 352463,
  [SMALL_STATE(10290)] = 352476,
  [SMALL_STATE(10291)] = 352489,
  [SMALL_STATE(10292)] = 352502,
  [SMALL_STATE(10293)] = 352515,
  [SMALL_STATE(10294)] = 352528,
  [SMALL_STATE(10295)] = 352541,
  [SMALL_STATE(10296)] = 352554,
  [SMALL_STATE(10297)] = 352567,
  [SMALL_STATE(10298)] = 352580,
  [SMALL_STATE(10299)] = 352593,
  [SMALL_STATE(10300)] = 352606,
  [SMALL_STATE(10301)] = 352619,
  [SMALL_STATE(10302)] = 352632,
  [SMALL_STATE(10303)] = 352645,
  [SMALL_STATE(10304)] = 352658,
  [SMALL_STATE(10305)] = 352671,
  [SMALL_STATE(10306)] = 352684,
  [SMALL_STATE(10307)] = 352697,
  [SMALL_STATE(10308)] = 352710,
  [SMALL_STATE(10309)] = 352723,
  [SMALL_STATE(10310)] = 352736,
  [SMALL_STATE(10311)] = 352749,
  [SMALL_STATE(10312)] = 352762,
  [SMALL_STATE(10313)] = 352775,
  [SMALL_STATE(10314)] = 352788,
  [SMALL_STATE(10315)] = 352801,
  [SMALL_STATE(10316)] = 352814,
  [SMALL_STATE(10317)] = 352827,
  [SMALL_STATE(10318)] = 352840,
  [SMALL_STATE(10319)] = 352853,
  [SMALL_STATE(10320)] = 352866,
  [SMALL_STATE(10321)] = 352879,
  [SMALL_STATE(10322)] = 352892,
  [SMALL_STATE(10323)] = 352905,
  [SMALL_STATE(10324)] = 352918,
  [SMALL_STATE(10325)] = 352931,
  [SMALL_STATE(10326)] = 352944,
  [SMALL_STATE(10327)] = 352957,
  [SMALL_STATE(10328)] = 352968,
  [SMALL_STATE(10329)] = 352981,
  [SMALL_STATE(10330)] = 352994,
  [SMALL_STATE(10331)] = 353007,
  [SMALL_STATE(10332)] = 353020,
  [SMALL_STATE(10333)] = 353030,
  [SMALL_STATE(10334)] = 353040,
  [SMALL_STATE(10335)] = 353050,
  [SMALL_STATE(10336)] = 353060,
  [SMALL_STATE(10337)] = 353070,
  [SMALL_STATE(10338)] = 353080,
  [SMALL_STATE(10339)] = 353090,
  [SMALL_STATE(10340)] = 353100,
  [SMALL_STATE(10341)] = 353110,
  [SMALL_STATE(10342)] = 353120,
  [SMALL_STATE(10343)] = 353130,
  [SMALL_STATE(10344)] = 353138,
  [SMALL_STATE(10345)] = 353148,
  [SMALL_STATE(10346)] = 353158,
  [SMALL_STATE(10347)] = 353168,
  [SMALL_STATE(10348)] = 353178,
  [SMALL_STATE(10349)] = 353188,
  [SMALL_STATE(10350)] = 353198,
  [SMALL_STATE(10351)] = 353208,
  [SMALL_STATE(10352)] = 353218,
  [SMALL_STATE(10353)] = 353226,
  [SMALL_STATE(10354)] = 353236,
  [SMALL_STATE(10355)] = 353246,
  [SMALL_STATE(10356)] = 353256,
  [SMALL_STATE(10357)] = 353266,
  [SMALL_STATE(10358)] = 353276,
  [SMALL_STATE(10359)] = 353286,
  [SMALL_STATE(10360)] = 353296,
  [SMALL_STATE(10361)] = 353306,
  [SMALL_STATE(10362)] = 353316,
  [SMALL_STATE(10363)] = 353324,
  [SMALL_STATE(10364)] = 353334,
  [SMALL_STATE(10365)] = 353344,
  [SMALL_STATE(10366)] = 353354,
  [SMALL_STATE(10367)] = 353364,
  [SMALL_STATE(10368)] = 353374,
  [SMALL_STATE(10369)] = 353384,
  [SMALL_STATE(10370)] = 353394,
  [SMALL_STATE(10371)] = 353404,
  [SMALL_STATE(10372)] = 353414,
  [SMALL_STATE(10373)] = 353424,
  [SMALL_STATE(10374)] = 353434,
  [SMALL_STATE(10375)] = 353444,
  [SMALL_STATE(10376)] = 353454,
  [SMALL_STATE(10377)] = 353464,
  [SMALL_STATE(10378)] = 353474,
  [SMALL_STATE(10379)] = 353484,
  [SMALL_STATE(10380)] = 353494,
  [SMALL_STATE(10381)] = 353504,
  [SMALL_STATE(10382)] = 353514,
  [SMALL_STATE(10383)] = 353524,
  [SMALL_STATE(10384)] = 353534,
  [SMALL_STATE(10385)] = 353544,
  [SMALL_STATE(10386)] = 353554,
  [SMALL_STATE(10387)] = 353562,
  [SMALL_STATE(10388)] = 353572,
  [SMALL_STATE(10389)] = 353582,
  [SMALL_STATE(10390)] = 353592,
  [SMALL_STATE(10391)] = 353602,
  [SMALL_STATE(10392)] = 353612,
  [SMALL_STATE(10393)] = 353622,
  [SMALL_STATE(10394)] = 353632,
  [SMALL_STATE(10395)] = 353642,
  [SMALL_STATE(10396)] = 353650,
  [SMALL_STATE(10397)] = 353658,
  [SMALL_STATE(10398)] = 353668,
  [SMALL_STATE(10399)] = 353678,
  [SMALL_STATE(10400)] = 353688,
  [SMALL_STATE(10401)] = 353698,
  [SMALL_STATE(10402)] = 353708,
  [SMALL_STATE(10403)] = 353718,
  [SMALL_STATE(10404)] = 353726,
  [SMALL_STATE(10405)] = 353736,
  [SMALL_STATE(10406)] = 353746,
  [SMALL_STATE(10407)] = 353756,
  [SMALL_STATE(10408)] = 353766,
  [SMALL_STATE(10409)] = 353776,
  [SMALL_STATE(10410)] = 353786,
  [SMALL_STATE(10411)] = 353796,
  [SMALL_STATE(10412)] = 353804,
  [SMALL_STATE(10413)] = 353814,
  [SMALL_STATE(10414)] = 353824,
  [SMALL_STATE(10415)] = 353834,
  [SMALL_STATE(10416)] = 353844,
  [SMALL_STATE(10417)] = 353854,
  [SMALL_STATE(10418)] = 353862,
  [SMALL_STATE(10419)] = 353872,
  [SMALL_STATE(10420)] = 353882,
  [SMALL_STATE(10421)] = 353892,
  [SMALL_STATE(10422)] = 353902,
  [SMALL_STATE(10423)] = 353912,
  [SMALL_STATE(10424)] = 353922,
  [SMALL_STATE(10425)] = 353932,
  [SMALL_STATE(10426)] = 353942,
  [SMALL_STATE(10427)] = 353952,
  [SMALL_STATE(10428)] = 353962,
  [SMALL_STATE(10429)] = 353972,
  [SMALL_STATE(10430)] = 353982,
  [SMALL_STATE(10431)] = 353992,
  [SMALL_STATE(10432)] = 354002,
  [SMALL_STATE(10433)] = 354012,
  [SMALL_STATE(10434)] = 354022,
  [SMALL_STATE(10435)] = 354032,
  [SMALL_STATE(10436)] = 354042,
  [SMALL_STATE(10437)] = 354052,
  [SMALL_STATE(10438)] = 354062,
  [SMALL_STATE(10439)] = 354072,
  [SMALL_STATE(10440)] = 354082,
  [SMALL_STATE(10441)] = 354092,
  [SMALL_STATE(10442)] = 354102,
  [SMALL_STATE(10443)] = 354110,
  [SMALL_STATE(10444)] = 354120,
  [SMALL_STATE(10445)] = 354130,
  [SMALL_STATE(10446)] = 354140,
  [SMALL_STATE(10447)] = 354150,
  [SMALL_STATE(10448)] = 354160,
  [SMALL_STATE(10449)] = 354170,
  [SMALL_STATE(10450)] = 354180,
  [SMALL_STATE(10451)] = 354190,
  [SMALL_STATE(10452)] = 354200,
  [SMALL_STATE(10453)] = 354210,
  [SMALL_STATE(10454)] = 354220,
  [SMALL_STATE(10455)] = 354230,
  [SMALL_STATE(10456)] = 354238,
  [SMALL_STATE(10457)] = 354248,
  [SMALL_STATE(10458)] = 354258,
  [SMALL_STATE(10459)] = 354268,
  [SMALL_STATE(10460)] = 354278,
  [SMALL_STATE(10461)] = 354288,
  [SMALL_STATE(10462)] = 354298,
  [SMALL_STATE(10463)] = 354308,
  [SMALL_STATE(10464)] = 354318,
  [SMALL_STATE(10465)] = 354328,
  [SMALL_STATE(10466)] = 354338,
  [SMALL_STATE(10467)] = 354348,
  [SMALL_STATE(10468)] = 354358,
  [SMALL_STATE(10469)] = 354368,
  [SMALL_STATE(10470)] = 354378,
  [SMALL_STATE(10471)] = 354388,
  [SMALL_STATE(10472)] = 354398,
  [SMALL_STATE(10473)] = 354408,
  [SMALL_STATE(10474)] = 354418,
  [SMALL_STATE(10475)] = 354428,
  [SMALL_STATE(10476)] = 354438,
  [SMALL_STATE(10477)] = 354448,
  [SMALL_STATE(10478)] = 354458,
  [SMALL_STATE(10479)] = 354468,
  [SMALL_STATE(10480)] = 354478,
  [SMALL_STATE(10481)] = 354488,
  [SMALL_STATE(10482)] = 354498,
  [SMALL_STATE(10483)] = 354508,
  [SMALL_STATE(10484)] = 354518,
  [SMALL_STATE(10485)] = 354528,
  [SMALL_STATE(10486)] = 354538,
  [SMALL_STATE(10487)] = 354546,
  [SMALL_STATE(10488)] = 354556,
  [SMALL_STATE(10489)] = 354566,
  [SMALL_STATE(10490)] = 354576,
  [SMALL_STATE(10491)] = 354586,
  [SMALL_STATE(10492)] = 354596,
  [SMALL_STATE(10493)] = 354606,
  [SMALL_STATE(10494)] = 354616,
  [SMALL_STATE(10495)] = 354626,
  [SMALL_STATE(10496)] = 354634,
  [SMALL_STATE(10497)] = 354644,
  [SMALL_STATE(10498)] = 354654,
  [SMALL_STATE(10499)] = 354664,
  [SMALL_STATE(10500)] = 354674,
  [SMALL_STATE(10501)] = 354684,
  [SMALL_STATE(10502)] = 354694,
  [SMALL_STATE(10503)] = 354704,
  [SMALL_STATE(10504)] = 354714,
  [SMALL_STATE(10505)] = 354722,
  [SMALL_STATE(10506)] = 354732,
  [SMALL_STATE(10507)] = 354742,
  [SMALL_STATE(10508)] = 354752,
  [SMALL_STATE(10509)] = 354762,
  [SMALL_STATE(10510)] = 354772,
  [SMALL_STATE(10511)] = 354782,
  [SMALL_STATE(10512)] = 354792,
  [SMALL_STATE(10513)] = 354802,
  [SMALL_STATE(10514)] = 354812,
  [SMALL_STATE(10515)] = 354822,
  [SMALL_STATE(10516)] = 354830,
  [SMALL_STATE(10517)] = 354840,
  [SMALL_STATE(10518)] = 354850,
  [SMALL_STATE(10519)] = 354860,
  [SMALL_STATE(10520)] = 354870,
  [SMALL_STATE(10521)] = 354880,
  [SMALL_STATE(10522)] = 354888,
  [SMALL_STATE(10523)] = 354898,
  [SMALL_STATE(10524)] = 354908,
  [SMALL_STATE(10525)] = 354918,
  [SMALL_STATE(10526)] = 354928,
  [SMALL_STATE(10527)] = 354938,
  [SMALL_STATE(10528)] = 354948,
  [SMALL_STATE(10529)] = 354958,
  [SMALL_STATE(10530)] = 354968,
  [SMALL_STATE(10531)] = 354978,
  [SMALL_STATE(10532)] = 354988,
  [SMALL_STATE(10533)] = 354996,
  [SMALL_STATE(10534)] = 355006,
  [SMALL_STATE(10535)] = 355016,
  [SMALL_STATE(10536)] = 355026,
  [SMALL_STATE(10537)] = 355036,
  [SMALL_STATE(10538)] = 355046,
  [SMALL_STATE(10539)] = 355054,
  [SMALL_STATE(10540)] = 355064,
  [SMALL_STATE(10541)] = 355074,
  [SMALL_STATE(10542)] = 355084,
  [SMALL_STATE(10543)] = 355094,
  [SMALL_STATE(10544)] = 355104,
  [SMALL_STATE(10545)] = 355114,
  [SMALL_STATE(10546)] = 355124,
  [SMALL_STATE(10547)] = 355134,
  [SMALL_STATE(10548)] = 355144,
  [SMALL_STATE(10549)] = 355154,
  [SMALL_STATE(10550)] = 355164,
  [SMALL_STATE(10551)] = 355174,
  [SMALL_STATE(10552)] = 355184,
  [SMALL_STATE(10553)] = 355192,
  [SMALL_STATE(10554)] = 355202,
  [SMALL_STATE(10555)] = 355212,
  [SMALL_STATE(10556)] = 355222,
  [SMALL_STATE(10557)] = 355232,
  [SMALL_STATE(10558)] = 355242,
  [SMALL_STATE(10559)] = 355252,
  [SMALL_STATE(10560)] = 355262,
  [SMALL_STATE(10561)] = 355272,
  [SMALL_STATE(10562)] = 355282,
  [SMALL_STATE(10563)] = 355292,
  [SMALL_STATE(10564)] = 355302,
  [SMALL_STATE(10565)] = 355312,
  [SMALL_STATE(10566)] = 355322,
  [SMALL_STATE(10567)] = 355332,
  [SMALL_STATE(10568)] = 355342,
  [SMALL_STATE(10569)] = 355352,
  [SMALL_STATE(10570)] = 355362,
  [SMALL_STATE(10571)] = 355372,
  [SMALL_STATE(10572)] = 355382,
  [SMALL_STATE(10573)] = 355392,
  [SMALL_STATE(10574)] = 355402,
  [SMALL_STATE(10575)] = 355412,
  [SMALL_STATE(10576)] = 355422,
  [SMALL_STATE(10577)] = 355430,
  [SMALL_STATE(10578)] = 355438,
  [SMALL_STATE(10579)] = 355448,
  [SMALL_STATE(10580)] = 355458,
  [SMALL_STATE(10581)] = 355468,
  [SMALL_STATE(10582)] = 355478,
  [SMALL_STATE(10583)] = 355488,
  [SMALL_STATE(10584)] = 355498,
  [SMALL_STATE(10585)] = 355508,
  [SMALL_STATE(10586)] = 355518,
  [SMALL_STATE(10587)] = 355528,
  [SMALL_STATE(10588)] = 355538,
  [SMALL_STATE(10589)] = 355548,
  [SMALL_STATE(10590)] = 355558,
  [SMALL_STATE(10591)] = 355566,
  [SMALL_STATE(10592)] = 355576,
  [SMALL_STATE(10593)] = 355586,
  [SMALL_STATE(10594)] = 355596,
  [SMALL_STATE(10595)] = 355606,
  [SMALL_STATE(10596)] = 355616,
  [SMALL_STATE(10597)] = 355626,
  [SMALL_STATE(10598)] = 355634,
  [SMALL_STATE(10599)] = 355644,
  [SMALL_STATE(10600)] = 355654,
  [SMALL_STATE(10601)] = 355664,
  [SMALL_STATE(10602)] = 355674,
  [SMALL_STATE(10603)] = 355684,
  [SMALL_STATE(10604)] = 355694,
  [SMALL_STATE(10605)] = 355702,
  [SMALL_STATE(10606)] = 355712,
  [SMALL_STATE(10607)] = 355722,
  [SMALL_STATE(10608)] = 355732,
  [SMALL_STATE(10609)] = 355742,
  [SMALL_STATE(10610)] = 355752,
  [SMALL_STATE(10611)] = 355762,
  [SMALL_STATE(10612)] = 355772,
  [SMALL_STATE(10613)] = 355782,
  [SMALL_STATE(10614)] = 355792,
  [SMALL_STATE(10615)] = 355802,
  [SMALL_STATE(10616)] = 355812,
  [SMALL_STATE(10617)] = 355822,
  [SMALL_STATE(10618)] = 355832,
  [SMALL_STATE(10619)] = 355842,
  [SMALL_STATE(10620)] = 355852,
  [SMALL_STATE(10621)] = 355862,
  [SMALL_STATE(10622)] = 355872,
  [SMALL_STATE(10623)] = 355882,
  [SMALL_STATE(10624)] = 355892,
  [SMALL_STATE(10625)] = 355902,
  [SMALL_STATE(10626)] = 355912,
  [SMALL_STATE(10627)] = 355922,
  [SMALL_STATE(10628)] = 355932,
  [SMALL_STATE(10629)] = 355942,
  [SMALL_STATE(10630)] = 355952,
  [SMALL_STATE(10631)] = 355962,
  [SMALL_STATE(10632)] = 355970,
  [SMALL_STATE(10633)] = 355980,
  [SMALL_STATE(10634)] = 355990,
  [SMALL_STATE(10635)] = 356000,
  [SMALL_STATE(10636)] = 356010,
  [SMALL_STATE(10637)] = 356020,
  [SMALL_STATE(10638)] = 356030,
  [SMALL_STATE(10639)] = 356040,
  [SMALL_STATE(10640)] = 356050,
  [SMALL_STATE(10641)] = 356060,
  [SMALL_STATE(10642)] = 356070,
  [SMALL_STATE(10643)] = 356080,
  [SMALL_STATE(10644)] = 356090,
  [SMALL_STATE(10645)] = 356100,
  [SMALL_STATE(10646)] = 356110,
  [SMALL_STATE(10647)] = 356120,
  [SMALL_STATE(10648)] = 356130,
  [SMALL_STATE(10649)] = 356140,
  [SMALL_STATE(10650)] = 356150,
  [SMALL_STATE(10651)] = 356160,
  [SMALL_STATE(10652)] = 356170,
  [SMALL_STATE(10653)] = 356180,
  [SMALL_STATE(10654)] = 356190,
  [SMALL_STATE(10655)] = 356200,
  [SMALL_STATE(10656)] = 356210,
  [SMALL_STATE(10657)] = 356220,
  [SMALL_STATE(10658)] = 356230,
  [SMALL_STATE(10659)] = 356240,
  [SMALL_STATE(10660)] = 356250,
  [SMALL_STATE(10661)] = 356258,
  [SMALL_STATE(10662)] = 356268,
  [SMALL_STATE(10663)] = 356278,
  [SMALL_STATE(10664)] = 356288,
  [SMALL_STATE(10665)] = 356298,
  [SMALL_STATE(10666)] = 356308,
  [SMALL_STATE(10667)] = 356318,
  [SMALL_STATE(10668)] = 356328,
  [SMALL_STATE(10669)] = 356338,
  [SMALL_STATE(10670)] = 356348,
  [SMALL_STATE(10671)] = 356358,
  [SMALL_STATE(10672)] = 356368,
  [SMALL_STATE(10673)] = 356378,
  [SMALL_STATE(10674)] = 356386,
  [SMALL_STATE(10675)] = 356396,
  [SMALL_STATE(10676)] = 356406,
  [SMALL_STATE(10677)] = 356416,
  [SMALL_STATE(10678)] = 356426,
  [SMALL_STATE(10679)] = 356436,
  [SMALL_STATE(10680)] = 356446,
  [SMALL_STATE(10681)] = 356456,
  [SMALL_STATE(10682)] = 356466,
  [SMALL_STATE(10683)] = 356476,
  [SMALL_STATE(10684)] = 356486,
  [SMALL_STATE(10685)] = 356494,
  [SMALL_STATE(10686)] = 356504,
  [SMALL_STATE(10687)] = 356514,
  [SMALL_STATE(10688)] = 356524,
  [SMALL_STATE(10689)] = 356534,
  [SMALL_STATE(10690)] = 356544,
  [SMALL_STATE(10691)] = 356552,
  [SMALL_STATE(10692)] = 356562,
  [SMALL_STATE(10693)] = 356572,
  [SMALL_STATE(10694)] = 356582,
  [SMALL_STATE(10695)] = 356592,
  [SMALL_STATE(10696)] = 356602,
  [SMALL_STATE(10697)] = 356612,
  [SMALL_STATE(10698)] = 356622,
  [SMALL_STATE(10699)] = 356632,
  [SMALL_STATE(10700)] = 356642,
  [SMALL_STATE(10701)] = 356652,
  [SMALL_STATE(10702)] = 356662,
  [SMALL_STATE(10703)] = 356672,
  [SMALL_STATE(10704)] = 356682,
  [SMALL_STATE(10705)] = 356692,
  [SMALL_STATE(10706)] = 356702,
  [SMALL_STATE(10707)] = 356710,
  [SMALL_STATE(10708)] = 356720,
  [SMALL_STATE(10709)] = 356730,
  [SMALL_STATE(10710)] = 356740,
  [SMALL_STATE(10711)] = 356750,
  [SMALL_STATE(10712)] = 356758,
  [SMALL_STATE(10713)] = 356768,
  [SMALL_STATE(10714)] = 356778,
  [SMALL_STATE(10715)] = 356788,
  [SMALL_STATE(10716)] = 356798,
  [SMALL_STATE(10717)] = 356808,
  [SMALL_STATE(10718)] = 356818,
  [SMALL_STATE(10719)] = 356826,
  [SMALL_STATE(10720)] = 356836,
  [SMALL_STATE(10721)] = 356844,
  [SMALL_STATE(10722)] = 356854,
  [SMALL_STATE(10723)] = 356864,
  [SMALL_STATE(10724)] = 356874,
  [SMALL_STATE(10725)] = 356882,
  [SMALL_STATE(10726)] = 356892,
  [SMALL_STATE(10727)] = 356902,
  [SMALL_STATE(10728)] = 356912,
  [SMALL_STATE(10729)] = 356922,
  [SMALL_STATE(10730)] = 356932,
  [SMALL_STATE(10731)] = 356942,
  [SMALL_STATE(10732)] = 356952,
  [SMALL_STATE(10733)] = 356962,
  [SMALL_STATE(10734)] = 356972,
  [SMALL_STATE(10735)] = 356982,
  [SMALL_STATE(10736)] = 356992,
  [SMALL_STATE(10737)] = 357002,
  [SMALL_STATE(10738)] = 357012,
  [SMALL_STATE(10739)] = 357022,
  [SMALL_STATE(10740)] = 357032,
  [SMALL_STATE(10741)] = 357042,
  [SMALL_STATE(10742)] = 357052,
  [SMALL_STATE(10743)] = 357062,
  [SMALL_STATE(10744)] = 357072,
  [SMALL_STATE(10745)] = 357082,
  [SMALL_STATE(10746)] = 357092,
  [SMALL_STATE(10747)] = 357102,
  [SMALL_STATE(10748)] = 357112,
  [SMALL_STATE(10749)] = 357122,
  [SMALL_STATE(10750)] = 357132,
  [SMALL_STATE(10751)] = 357142,
  [SMALL_STATE(10752)] = 357152,
  [SMALL_STATE(10753)] = 357162,
  [SMALL_STATE(10754)] = 357172,
  [SMALL_STATE(10755)] = 357182,
  [SMALL_STATE(10756)] = 357192,
  [SMALL_STATE(10757)] = 357202,
  [SMALL_STATE(10758)] = 357212,
  [SMALL_STATE(10759)] = 357222,
  [SMALL_STATE(10760)] = 357232,
  [SMALL_STATE(10761)] = 357240,
  [SMALL_STATE(10762)] = 357250,
  [SMALL_STATE(10763)] = 357260,
  [SMALL_STATE(10764)] = 357270,
  [SMALL_STATE(10765)] = 357278,
  [SMALL_STATE(10766)] = 357288,
  [SMALL_STATE(10767)] = 357298,
  [SMALL_STATE(10768)] = 357308,
  [SMALL_STATE(10769)] = 357318,
  [SMALL_STATE(10770)] = 357328,
  [SMALL_STATE(10771)] = 357338,
  [SMALL_STATE(10772)] = 357348,
  [SMALL_STATE(10773)] = 357358,
  [SMALL_STATE(10774)] = 357368,
  [SMALL_STATE(10775)] = 357378,
  [SMALL_STATE(10776)] = 357388,
  [SMALL_STATE(10777)] = 357398,
  [SMALL_STATE(10778)] = 357408,
  [SMALL_STATE(10779)] = 357418,
  [SMALL_STATE(10780)] = 357428,
  [SMALL_STATE(10781)] = 357438,
  [SMALL_STATE(10782)] = 357446,
  [SMALL_STATE(10783)] = 357456,
  [SMALL_STATE(10784)] = 357466,
  [SMALL_STATE(10785)] = 357476,
  [SMALL_STATE(10786)] = 357486,
  [SMALL_STATE(10787)] = 357493,
  [SMALL_STATE(10788)] = 357500,
  [SMALL_STATE(10789)] = 357507,
  [SMALL_STATE(10790)] = 357514,
  [SMALL_STATE(10791)] = 357521,
  [SMALL_STATE(10792)] = 357528,
  [SMALL_STATE(10793)] = 357535,
  [SMALL_STATE(10794)] = 357542,
  [SMALL_STATE(10795)] = 357549,
  [SMALL_STATE(10796)] = 357556,
  [SMALL_STATE(10797)] = 357563,
  [SMALL_STATE(10798)] = 357570,
  [SMALL_STATE(10799)] = 357577,
  [SMALL_STATE(10800)] = 357584,
  [SMALL_STATE(10801)] = 357591,
  [SMALL_STATE(10802)] = 357598,
  [SMALL_STATE(10803)] = 357605,
  [SMALL_STATE(10804)] = 357612,
  [SMALL_STATE(10805)] = 357619,
  [SMALL_STATE(10806)] = 357626,
  [SMALL_STATE(10807)] = 357633,
  [SMALL_STATE(10808)] = 357640,
  [SMALL_STATE(10809)] = 357647,
  [SMALL_STATE(10810)] = 357654,
  [SMALL_STATE(10811)] = 357661,
  [SMALL_STATE(10812)] = 357668,
  [SMALL_STATE(10813)] = 357675,
  [SMALL_STATE(10814)] = 357682,
  [SMALL_STATE(10815)] = 357689,
  [SMALL_STATE(10816)] = 357696,
  [SMALL_STATE(10817)] = 357703,
  [SMALL_STATE(10818)] = 357710,
  [SMALL_STATE(10819)] = 357717,
  [SMALL_STATE(10820)] = 357724,
  [SMALL_STATE(10821)] = 357731,
  [SMALL_STATE(10822)] = 357738,
  [SMALL_STATE(10823)] = 357745,
  [SMALL_STATE(10824)] = 357752,
  [SMALL_STATE(10825)] = 357759,
  [SMALL_STATE(10826)] = 357766,
  [SMALL_STATE(10827)] = 357773,
  [SMALL_STATE(10828)] = 357780,
  [SMALL_STATE(10829)] = 357787,
  [SMALL_STATE(10830)] = 357794,
  [SMALL_STATE(10831)] = 357801,
  [SMALL_STATE(10832)] = 357808,
  [SMALL_STATE(10833)] = 357815,
  [SMALL_STATE(10834)] = 357822,
  [SMALL_STATE(10835)] = 357829,
  [SMALL_STATE(10836)] = 357836,
  [SMALL_STATE(10837)] = 357843,
  [SMALL_STATE(10838)] = 357850,
  [SMALL_STATE(10839)] = 357857,
  [SMALL_STATE(10840)] = 357864,
  [SMALL_STATE(10841)] = 357871,
  [SMALL_STATE(10842)] = 357878,
  [SMALL_STATE(10843)] = 357885,
  [SMALL_STATE(10844)] = 357892,
  [SMALL_STATE(10845)] = 357899,
  [SMALL_STATE(10846)] = 357906,
  [SMALL_STATE(10847)] = 357913,
  [SMALL_STATE(10848)] = 357920,
  [SMALL_STATE(10849)] = 357927,
  [SMALL_STATE(10850)] = 357934,
  [SMALL_STATE(10851)] = 357941,
  [SMALL_STATE(10852)] = 357948,
  [SMALL_STATE(10853)] = 357955,
  [SMALL_STATE(10854)] = 357962,
  [SMALL_STATE(10855)] = 357969,
  [SMALL_STATE(10856)] = 357976,
  [SMALL_STATE(10857)] = 357983,
  [SMALL_STATE(10858)] = 357990,
  [SMALL_STATE(10859)] = 357997,
  [SMALL_STATE(10860)] = 358004,
  [SMALL_STATE(10861)] = 358011,
  [SMALL_STATE(10862)] = 358018,
  [SMALL_STATE(10863)] = 358025,
  [SMALL_STATE(10864)] = 358032,
  [SMALL_STATE(10865)] = 358039,
  [SMALL_STATE(10866)] = 358046,
  [SMALL_STATE(10867)] = 358053,
  [SMALL_STATE(10868)] = 358060,
  [SMALL_STATE(10869)] = 358067,
  [SMALL_STATE(10870)] = 358074,
  [SMALL_STATE(10871)] = 358081,
  [SMALL_STATE(10872)] = 358088,
  [SMALL_STATE(10873)] = 358095,
  [SMALL_STATE(10874)] = 358102,
  [SMALL_STATE(10875)] = 358109,
  [SMALL_STATE(10876)] = 358116,
  [SMALL_STATE(10877)] = 358123,
  [SMALL_STATE(10878)] = 358130,
  [SMALL_STATE(10879)] = 358137,
  [SMALL_STATE(10880)] = 358144,
  [SMALL_STATE(10881)] = 358151,
  [SMALL_STATE(10882)] = 358158,
  [SMALL_STATE(10883)] = 358165,
  [SMALL_STATE(10884)] = 358172,
  [SMALL_STATE(10885)] = 358179,
  [SMALL_STATE(10886)] = 358186,
  [SMALL_STATE(10887)] = 358193,
  [SMALL_STATE(10888)] = 358200,
  [SMALL_STATE(10889)] = 358207,
  [SMALL_STATE(10890)] = 358214,
  [SMALL_STATE(10891)] = 358221,
  [SMALL_STATE(10892)] = 358228,
  [SMALL_STATE(10893)] = 358235,
  [SMALL_STATE(10894)] = 358242,
  [SMALL_STATE(10895)] = 358249,
  [SMALL_STATE(10896)] = 358256,
  [SMALL_STATE(10897)] = 358263,
  [SMALL_STATE(10898)] = 358270,
  [SMALL_STATE(10899)] = 358277,
  [SMALL_STATE(10900)] = 358284,
  [SMALL_STATE(10901)] = 358291,
  [SMALL_STATE(10902)] = 358298,
  [SMALL_STATE(10903)] = 358305,
  [SMALL_STATE(10904)] = 358312,
  [SMALL_STATE(10905)] = 358319,
  [SMALL_STATE(10906)] = 358326,
  [SMALL_STATE(10907)] = 358333,
  [SMALL_STATE(10908)] = 358340,
  [SMALL_STATE(10909)] = 358347,
  [SMALL_STATE(10910)] = 358354,
  [SMALL_STATE(10911)] = 358361,
  [SMALL_STATE(10912)] = 358368,
  [SMALL_STATE(10913)] = 358375,
  [SMALL_STATE(10914)] = 358382,
  [SMALL_STATE(10915)] = 358389,
  [SMALL_STATE(10916)] = 358396,
  [SMALL_STATE(10917)] = 358403,
  [SMALL_STATE(10918)] = 358410,
  [SMALL_STATE(10919)] = 358417,
  [SMALL_STATE(10920)] = 358424,
  [SMALL_STATE(10921)] = 358431,
  [SMALL_STATE(10922)] = 358438,
  [SMALL_STATE(10923)] = 358445,
  [SMALL_STATE(10924)] = 358452,
  [SMALL_STATE(10925)] = 358459,
  [SMALL_STATE(10926)] = 358466,
  [SMALL_STATE(10927)] = 358473,
  [SMALL_STATE(10928)] = 358480,
  [SMALL_STATE(10929)] = 358487,
  [SMALL_STATE(10930)] = 358494,
  [SMALL_STATE(10931)] = 358501,
  [SMALL_STATE(10932)] = 358508,
  [SMALL_STATE(10933)] = 358515,
  [SMALL_STATE(10934)] = 358522,
  [SMALL_STATE(10935)] = 358529,
  [SMALL_STATE(10936)] = 358536,
  [SMALL_STATE(10937)] = 358543,
  [SMALL_STATE(10938)] = 358550,
  [SMALL_STATE(10939)] = 358557,
  [SMALL_STATE(10940)] = 358564,
  [SMALL_STATE(10941)] = 358571,
  [SMALL_STATE(10942)] = 358578,
  [SMALL_STATE(10943)] = 358585,
  [SMALL_STATE(10944)] = 358592,
  [SMALL_STATE(10945)] = 358599,
  [SMALL_STATE(10946)] = 358606,
  [SMALL_STATE(10947)] = 358613,
  [SMALL_STATE(10948)] = 358620,
  [SMALL_STATE(10949)] = 358627,
  [SMALL_STATE(10950)] = 358634,
  [SMALL_STATE(10951)] = 358641,
  [SMALL_STATE(10952)] = 358648,
  [SMALL_STATE(10953)] = 358655,
  [SMALL_STATE(10954)] = 358662,
  [SMALL_STATE(10955)] = 358669,
  [SMALL_STATE(10956)] = 358676,
  [SMALL_STATE(10957)] = 358683,
  [SMALL_STATE(10958)] = 358690,
  [SMALL_STATE(10959)] = 358697,
  [SMALL_STATE(10960)] = 358704,
  [SMALL_STATE(10961)] = 358711,
  [SMALL_STATE(10962)] = 358718,
  [SMALL_STATE(10963)] = 358725,
  [SMALL_STATE(10964)] = 358732,
  [SMALL_STATE(10965)] = 358739,
  [SMALL_STATE(10966)] = 358746,
  [SMALL_STATE(10967)] = 358753,
  [SMALL_STATE(10968)] = 358760,
  [SMALL_STATE(10969)] = 358767,
  [SMALL_STATE(10970)] = 358774,
  [SMALL_STATE(10971)] = 358781,
  [SMALL_STATE(10972)] = 358788,
  [SMALL_STATE(10973)] = 358795,
  [SMALL_STATE(10974)] = 358802,
  [SMALL_STATE(10975)] = 358809,
  [SMALL_STATE(10976)] = 358816,
  [SMALL_STATE(10977)] = 358823,
  [SMALL_STATE(10978)] = 358830,
  [SMALL_STATE(10979)] = 358837,
  [SMALL_STATE(10980)] = 358844,
  [SMALL_STATE(10981)] = 358851,
  [SMALL_STATE(10982)] = 358858,
  [SMALL_STATE(10983)] = 358865,
  [SMALL_STATE(10984)] = 358872,
  [SMALL_STATE(10985)] = 358879,
  [SMALL_STATE(10986)] = 358886,
  [SMALL_STATE(10987)] = 358893,
  [SMALL_STATE(10988)] = 358900,
  [SMALL_STATE(10989)] = 358907,
  [SMALL_STATE(10990)] = 358914,
  [SMALL_STATE(10991)] = 358921,
  [SMALL_STATE(10992)] = 358928,
  [SMALL_STATE(10993)] = 358935,
  [SMALL_STATE(10994)] = 358942,
  [SMALL_STATE(10995)] = 358949,
  [SMALL_STATE(10996)] = 358956,
  [SMALL_STATE(10997)] = 358963,
  [SMALL_STATE(10998)] = 358970,
  [SMALL_STATE(10999)] = 358977,
  [SMALL_STATE(11000)] = 358984,
  [SMALL_STATE(11001)] = 358991,
  [SMALL_STATE(11002)] = 358998,
  [SMALL_STATE(11003)] = 359005,
  [SMALL_STATE(11004)] = 359012,
  [SMALL_STATE(11005)] = 359019,
  [SMALL_STATE(11006)] = 359026,
  [SMALL_STATE(11007)] = 359033,
  [SMALL_STATE(11008)] = 359040,
  [SMALL_STATE(11009)] = 359047,
  [SMALL_STATE(11010)] = 359054,
  [SMALL_STATE(11011)] = 359061,
  [SMALL_STATE(11012)] = 359068,
  [SMALL_STATE(11013)] = 359075,
  [SMALL_STATE(11014)] = 359082,
  [SMALL_STATE(11015)] = 359089,
  [SMALL_STATE(11016)] = 359096,
  [SMALL_STATE(11017)] = 359103,
  [SMALL_STATE(11018)] = 359110,
  [SMALL_STATE(11019)] = 359117,
  [SMALL_STATE(11020)] = 359124,
  [SMALL_STATE(11021)] = 359131,
  [SMALL_STATE(11022)] = 359138,
  [SMALL_STATE(11023)] = 359145,
  [SMALL_STATE(11024)] = 359152,
  [SMALL_STATE(11025)] = 359159,
  [SMALL_STATE(11026)] = 359166,
  [SMALL_STATE(11027)] = 359173,
  [SMALL_STATE(11028)] = 359180,
  [SMALL_STATE(11029)] = 359187,
  [SMALL_STATE(11030)] = 359194,
  [SMALL_STATE(11031)] = 359201,
  [SMALL_STATE(11032)] = 359208,
  [SMALL_STATE(11033)] = 359215,
  [SMALL_STATE(11034)] = 359222,
  [SMALL_STATE(11035)] = 359229,
  [SMALL_STATE(11036)] = 359236,
  [SMALL_STATE(11037)] = 359243,
  [SMALL_STATE(11038)] = 359250,
  [SMALL_STATE(11039)] = 359257,
  [SMALL_STATE(11040)] = 359264,
  [SMALL_STATE(11041)] = 359271,
  [SMALL_STATE(11042)] = 359278,
  [SMALL_STATE(11043)] = 359285,
  [SMALL_STATE(11044)] = 359292,
  [SMALL_STATE(11045)] = 359299,
  [SMALL_STATE(11046)] = 359306,
  [SMALL_STATE(11047)] = 359313,
  [SMALL_STATE(11048)] = 359320,
  [SMALL_STATE(11049)] = 359327,
  [SMALL_STATE(11050)] = 359334,
  [SMALL_STATE(11051)] = 359341,
  [SMALL_STATE(11052)] = 359348,
  [SMALL_STATE(11053)] = 359355,
  [SMALL_STATE(11054)] = 359362,
  [SMALL_STATE(11055)] = 359369,
  [SMALL_STATE(11056)] = 359376,
  [SMALL_STATE(11057)] = 359383,
  [SMALL_STATE(11058)] = 359390,
  [SMALL_STATE(11059)] = 359397,
  [SMALL_STATE(11060)] = 359404,
  [SMALL_STATE(11061)] = 359411,
  [SMALL_STATE(11062)] = 359418,
  [SMALL_STATE(11063)] = 359425,
  [SMALL_STATE(11064)] = 359432,
  [SMALL_STATE(11065)] = 359439,
  [SMALL_STATE(11066)] = 359446,
  [SMALL_STATE(11067)] = 359453,
  [SMALL_STATE(11068)] = 359460,
  [SMALL_STATE(11069)] = 359467,
  [SMALL_STATE(11070)] = 359474,
  [SMALL_STATE(11071)] = 359481,
  [SMALL_STATE(11072)] = 359488,
  [SMALL_STATE(11073)] = 359495,
  [SMALL_STATE(11074)] = 359502,
  [SMALL_STATE(11075)] = 359509,
  [SMALL_STATE(11076)] = 359516,
  [SMALL_STATE(11077)] = 359523,
  [SMALL_STATE(11078)] = 359530,
  [SMALL_STATE(11079)] = 359537,
  [SMALL_STATE(11080)] = 359544,
  [SMALL_STATE(11081)] = 359551,
  [SMALL_STATE(11082)] = 359558,
  [SMALL_STATE(11083)] = 359565,
  [SMALL_STATE(11084)] = 359572,
  [SMALL_STATE(11085)] = 359579,
  [SMALL_STATE(11086)] = 359586,
  [SMALL_STATE(11087)] = 359593,
  [SMALL_STATE(11088)] = 359600,
  [SMALL_STATE(11089)] = 359607,
  [SMALL_STATE(11090)] = 359614,
  [SMALL_STATE(11091)] = 359621,
  [SMALL_STATE(11092)] = 359628,
  [SMALL_STATE(11093)] = 359635,
  [SMALL_STATE(11094)] = 359642,
  [SMALL_STATE(11095)] = 359649,
  [SMALL_STATE(11096)] = 359656,
  [SMALL_STATE(11097)] = 359663,
  [SMALL_STATE(11098)] = 359670,
  [SMALL_STATE(11099)] = 359677,
  [SMALL_STATE(11100)] = 359684,
  [SMALL_STATE(11101)] = 359691,
  [SMALL_STATE(11102)] = 359698,
  [SMALL_STATE(11103)] = 359705,
  [SMALL_STATE(11104)] = 359712,
  [SMALL_STATE(11105)] = 359719,
  [SMALL_STATE(11106)] = 359726,
  [SMALL_STATE(11107)] = 359733,
  [SMALL_STATE(11108)] = 359740,
  [SMALL_STATE(11109)] = 359747,
  [SMALL_STATE(11110)] = 359754,
  [SMALL_STATE(11111)] = 359761,
  [SMALL_STATE(11112)] = 359768,
  [SMALL_STATE(11113)] = 359775,
  [SMALL_STATE(11114)] = 359782,
  [SMALL_STATE(11115)] = 359789,
  [SMALL_STATE(11116)] = 359796,
  [SMALL_STATE(11117)] = 359803,
  [SMALL_STATE(11118)] = 359810,
  [SMALL_STATE(11119)] = 359817,
  [SMALL_STATE(11120)] = 359824,
  [SMALL_STATE(11121)] = 359831,
  [SMALL_STATE(11122)] = 359838,
  [SMALL_STATE(11123)] = 359845,
  [SMALL_STATE(11124)] = 359852,
  [SMALL_STATE(11125)] = 359859,
  [SMALL_STATE(11126)] = 359866,
  [SMALL_STATE(11127)] = 359873,
  [SMALL_STATE(11128)] = 359880,
  [SMALL_STATE(11129)] = 359887,
  [SMALL_STATE(11130)] = 359894,
  [SMALL_STATE(11131)] = 359901,
  [SMALL_STATE(11132)] = 359908,
  [SMALL_STATE(11133)] = 359915,
  [SMALL_STATE(11134)] = 359922,
  [SMALL_STATE(11135)] = 359929,
  [SMALL_STATE(11136)] = 359936,
  [SMALL_STATE(11137)] = 359943,
  [SMALL_STATE(11138)] = 359950,
  [SMALL_STATE(11139)] = 359957,
  [SMALL_STATE(11140)] = 359964,
  [SMALL_STATE(11141)] = 359971,
  [SMALL_STATE(11142)] = 359978,
  [SMALL_STATE(11143)] = 359985,
  [SMALL_STATE(11144)] = 359992,
  [SMALL_STATE(11145)] = 359999,
  [SMALL_STATE(11146)] = 360006,
  [SMALL_STATE(11147)] = 360013,
  [SMALL_STATE(11148)] = 360020,
  [SMALL_STATE(11149)] = 360027,
  [SMALL_STATE(11150)] = 360034,
  [SMALL_STATE(11151)] = 360041,
  [SMALL_STATE(11152)] = 360048,
  [SMALL_STATE(11153)] = 360055,
  [SMALL_STATE(11154)] = 360062,
  [SMALL_STATE(11155)] = 360069,
  [SMALL_STATE(11156)] = 360076,
  [SMALL_STATE(11157)] = 360083,
  [SMALL_STATE(11158)] = 360090,
  [SMALL_STATE(11159)] = 360097,
  [SMALL_STATE(11160)] = 360104,
  [SMALL_STATE(11161)] = 360111,
  [SMALL_STATE(11162)] = 360118,
  [SMALL_STATE(11163)] = 360125,
  [SMALL_STATE(11164)] = 360132,
  [SMALL_STATE(11165)] = 360139,
  [SMALL_STATE(11166)] = 360146,
  [SMALL_STATE(11167)] = 360153,
  [SMALL_STATE(11168)] = 360160,
  [SMALL_STATE(11169)] = 360167,
  [SMALL_STATE(11170)] = 360174,
  [SMALL_STATE(11171)] = 360181,
  [SMALL_STATE(11172)] = 360188,
  [SMALL_STATE(11173)] = 360195,
  [SMALL_STATE(11174)] = 360202,
  [SMALL_STATE(11175)] = 360209,
  [SMALL_STATE(11176)] = 360216,
  [SMALL_STATE(11177)] = 360223,
  [SMALL_STATE(11178)] = 360230,
  [SMALL_STATE(11179)] = 360237,
  [SMALL_STATE(11180)] = 360244,
  [SMALL_STATE(11181)] = 360251,
  [SMALL_STATE(11182)] = 360258,
  [SMALL_STATE(11183)] = 360265,
  [SMALL_STATE(11184)] = 360272,
  [SMALL_STATE(11185)] = 360279,
  [SMALL_STATE(11186)] = 360286,
  [SMALL_STATE(11187)] = 360293,
  [SMALL_STATE(11188)] = 360300,
  [SMALL_STATE(11189)] = 360307,
  [SMALL_STATE(11190)] = 360314,
  [SMALL_STATE(11191)] = 360321,
  [SMALL_STATE(11192)] = 360328,
  [SMALL_STATE(11193)] = 360335,
  [SMALL_STATE(11194)] = 360342,
  [SMALL_STATE(11195)] = 360349,
  [SMALL_STATE(11196)] = 360356,
  [SMALL_STATE(11197)] = 360363,
  [SMALL_STATE(11198)] = 360370,
  [SMALL_STATE(11199)] = 360377,
  [SMALL_STATE(11200)] = 360384,
  [SMALL_STATE(11201)] = 360391,
  [SMALL_STATE(11202)] = 360398,
  [SMALL_STATE(11203)] = 360405,
  [SMALL_STATE(11204)] = 360412,
  [SMALL_STATE(11205)] = 360419,
  [SMALL_STATE(11206)] = 360426,
  [SMALL_STATE(11207)] = 360433,
  [SMALL_STATE(11208)] = 360440,
  [SMALL_STATE(11209)] = 360447,
  [SMALL_STATE(11210)] = 360454,
  [SMALL_STATE(11211)] = 360461,
  [SMALL_STATE(11212)] = 360468,
  [SMALL_STATE(11213)] = 360475,
  [SMALL_STATE(11214)] = 360482,
  [SMALL_STATE(11215)] = 360489,
  [SMALL_STATE(11216)] = 360496,
  [SMALL_STATE(11217)] = 360503,
  [SMALL_STATE(11218)] = 360510,
  [SMALL_STATE(11219)] = 360517,
  [SMALL_STATE(11220)] = 360524,
  [SMALL_STATE(11221)] = 360531,
  [SMALL_STATE(11222)] = 360538,
  [SMALL_STATE(11223)] = 360545,
  [SMALL_STATE(11224)] = 360552,
  [SMALL_STATE(11225)] = 360559,
  [SMALL_STATE(11226)] = 360566,
  [SMALL_STATE(11227)] = 360573,
  [SMALL_STATE(11228)] = 360580,
  [SMALL_STATE(11229)] = 360587,
  [SMALL_STATE(11230)] = 360594,
  [SMALL_STATE(11231)] = 360601,
  [SMALL_STATE(11232)] = 360608,
  [SMALL_STATE(11233)] = 360615,
  [SMALL_STATE(11234)] = 360622,
  [SMALL_STATE(11235)] = 360629,
  [SMALL_STATE(11236)] = 360636,
  [SMALL_STATE(11237)] = 360643,
  [SMALL_STATE(11238)] = 360650,
  [SMALL_STATE(11239)] = 360657,
  [SMALL_STATE(11240)] = 360664,
  [SMALL_STATE(11241)] = 360671,
  [SMALL_STATE(11242)] = 360678,
  [SMALL_STATE(11243)] = 360685,
  [SMALL_STATE(11244)] = 360692,
  [SMALL_STATE(11245)] = 360699,
  [SMALL_STATE(11246)] = 360706,
  [SMALL_STATE(11247)] = 360713,
  [SMALL_STATE(11248)] = 360720,
  [SMALL_STATE(11249)] = 360727,
  [SMALL_STATE(11250)] = 360734,
  [SMALL_STATE(11251)] = 360741,
  [SMALL_STATE(11252)] = 360748,
  [SMALL_STATE(11253)] = 360755,
  [SMALL_STATE(11254)] = 360762,
  [SMALL_STATE(11255)] = 360769,
  [SMALL_STATE(11256)] = 360776,
  [SMALL_STATE(11257)] = 360783,
  [SMALL_STATE(11258)] = 360790,
  [SMALL_STATE(11259)] = 360797,
  [SMALL_STATE(11260)] = 360804,
  [SMALL_STATE(11261)] = 360811,
  [SMALL_STATE(11262)] = 360818,
  [SMALL_STATE(11263)] = 360825,
  [SMALL_STATE(11264)] = 360832,
  [SMALL_STATE(11265)] = 360839,
  [SMALL_STATE(11266)] = 360846,
  [SMALL_STATE(11267)] = 360853,
  [SMALL_STATE(11268)] = 360860,
  [SMALL_STATE(11269)] = 360867,
  [SMALL_STATE(11270)] = 360874,
  [SMALL_STATE(11271)] = 360881,
  [SMALL_STATE(11272)] = 360888,
  [SMALL_STATE(11273)] = 360895,
  [SMALL_STATE(11274)] = 360902,
  [SMALL_STATE(11275)] = 360909,
  [SMALL_STATE(11276)] = 360916,
  [SMALL_STATE(11277)] = 360923,
  [SMALL_STATE(11278)] = 360930,
  [SMALL_STATE(11279)] = 360937,
  [SMALL_STATE(11280)] = 360944,
  [SMALL_STATE(11281)] = 360951,
  [SMALL_STATE(11282)] = 360958,
  [SMALL_STATE(11283)] = 360965,
  [SMALL_STATE(11284)] = 360972,
  [SMALL_STATE(11285)] = 360979,
  [SMALL_STATE(11286)] = 360986,
  [SMALL_STATE(11287)] = 360993,
  [SMALL_STATE(11288)] = 361000,
  [SMALL_STATE(11289)] = 361007,
  [SMALL_STATE(11290)] = 361014,
  [SMALL_STATE(11291)] = 361021,
  [SMALL_STATE(11292)] = 361028,
  [SMALL_STATE(11293)] = 361035,
  [SMALL_STATE(11294)] = 361042,
  [SMALL_STATE(11295)] = 361049,
  [SMALL_STATE(11296)] = 361056,
  [SMALL_STATE(11297)] = 361063,
  [SMALL_STATE(11298)] = 361070,
  [SMALL_STATE(11299)] = 361077,
  [SMALL_STATE(11300)] = 361084,
  [SMALL_STATE(11301)] = 361091,
  [SMALL_STATE(11302)] = 361098,
  [SMALL_STATE(11303)] = 361105,
  [SMALL_STATE(11304)] = 361112,
  [SMALL_STATE(11305)] = 361119,
  [SMALL_STATE(11306)] = 361126,
  [SMALL_STATE(11307)] = 361133,
  [SMALL_STATE(11308)] = 361140,
  [SMALL_STATE(11309)] = 361147,
  [SMALL_STATE(11310)] = 361154,
  [SMALL_STATE(11311)] = 361161,
  [SMALL_STATE(11312)] = 361168,
  [SMALL_STATE(11313)] = 361175,
  [SMALL_STATE(11314)] = 361182,
  [SMALL_STATE(11315)] = 361189,
  [SMALL_STATE(11316)] = 361196,
  [SMALL_STATE(11317)] = 361203,
  [SMALL_STATE(11318)] = 361210,
  [SMALL_STATE(11319)] = 361217,
  [SMALL_STATE(11320)] = 361224,
  [SMALL_STATE(11321)] = 361231,
  [SMALL_STATE(11322)] = 361238,
  [SMALL_STATE(11323)] = 361245,
  [SMALL_STATE(11324)] = 361252,
  [SMALL_STATE(11325)] = 361259,
  [SMALL_STATE(11326)] = 361266,
  [SMALL_STATE(11327)] = 361273,
  [SMALL_STATE(11328)] = 361280,
  [SMALL_STATE(11329)] = 361287,
  [SMALL_STATE(11330)] = 361294,
  [SMALL_STATE(11331)] = 361301,
  [SMALL_STATE(11332)] = 361308,
  [SMALL_STATE(11333)] = 361315,
  [SMALL_STATE(11334)] = 361322,
  [SMALL_STATE(11335)] = 361329,
  [SMALL_STATE(11336)] = 361336,
  [SMALL_STATE(11337)] = 361343,
  [SMALL_STATE(11338)] = 361350,
  [SMALL_STATE(11339)] = 361357,
  [SMALL_STATE(11340)] = 361364,
  [SMALL_STATE(11341)] = 361371,
  [SMALL_STATE(11342)] = 361378,
  [SMALL_STATE(11343)] = 361385,
  [SMALL_STATE(11344)] = 361392,
  [SMALL_STATE(11345)] = 361399,
  [SMALL_STATE(11346)] = 361406,
  [SMALL_STATE(11347)] = 361413,
  [SMALL_STATE(11348)] = 361420,
  [SMALL_STATE(11349)] = 361427,
  [SMALL_STATE(11350)] = 361434,
  [SMALL_STATE(11351)] = 361441,
  [SMALL_STATE(11352)] = 361448,
  [SMALL_STATE(11353)] = 361455,
  [SMALL_STATE(11354)] = 361462,
  [SMALL_STATE(11355)] = 361469,
  [SMALL_STATE(11356)] = 361476,
  [SMALL_STATE(11357)] = 361483,
  [SMALL_STATE(11358)] = 361490,
  [SMALL_STATE(11359)] = 361497,
  [SMALL_STATE(11360)] = 361504,
  [SMALL_STATE(11361)] = 361511,
  [SMALL_STATE(11362)] = 361518,
  [SMALL_STATE(11363)] = 361525,
  [SMALL_STATE(11364)] = 361532,
  [SMALL_STATE(11365)] = 361539,
  [SMALL_STATE(11366)] = 361546,
  [SMALL_STATE(11367)] = 361553,
  [SMALL_STATE(11368)] = 361560,
  [SMALL_STATE(11369)] = 361567,
  [SMALL_STATE(11370)] = 361574,
  [SMALL_STATE(11371)] = 361581,
  [SMALL_STATE(11372)] = 361588,
  [SMALL_STATE(11373)] = 361595,
  [SMALL_STATE(11374)] = 361602,
  [SMALL_STATE(11375)] = 361609,
  [SMALL_STATE(11376)] = 361616,
  [SMALL_STATE(11377)] = 361623,
  [SMALL_STATE(11378)] = 361630,
  [SMALL_STATE(11379)] = 361637,
  [SMALL_STATE(11380)] = 361644,
  [SMALL_STATE(11381)] = 361651,
  [SMALL_STATE(11382)] = 361658,
  [SMALL_STATE(11383)] = 361665,
  [SMALL_STATE(11384)] = 361672,
  [SMALL_STATE(11385)] = 361679,
  [SMALL_STATE(11386)] = 361686,
  [SMALL_STATE(11387)] = 361693,
  [SMALL_STATE(11388)] = 361700,
  [SMALL_STATE(11389)] = 361707,
  [SMALL_STATE(11390)] = 361714,
  [SMALL_STATE(11391)] = 361721,
  [SMALL_STATE(11392)] = 361728,
  [SMALL_STATE(11393)] = 361735,
  [SMALL_STATE(11394)] = 361742,
  [SMALL_STATE(11395)] = 361749,
  [SMALL_STATE(11396)] = 361756,
  [SMALL_STATE(11397)] = 361763,
  [SMALL_STATE(11398)] = 361770,
  [SMALL_STATE(11399)] = 361777,
  [SMALL_STATE(11400)] = 361784,
  [SMALL_STATE(11401)] = 361791,
  [SMALL_STATE(11402)] = 361798,
  [SMALL_STATE(11403)] = 361805,
  [SMALL_STATE(11404)] = 361812,
  [SMALL_STATE(11405)] = 361819,
  [SMALL_STATE(11406)] = 361826,
  [SMALL_STATE(11407)] = 361833,
  [SMALL_STATE(11408)] = 361840,
  [SMALL_STATE(11409)] = 361847,
  [SMALL_STATE(11410)] = 361854,
  [SMALL_STATE(11411)] = 361861,
  [SMALL_STATE(11412)] = 361868,
  [SMALL_STATE(11413)] = 361875,
  [SMALL_STATE(11414)] = 361882,
  [SMALL_STATE(11415)] = 361889,
  [SMALL_STATE(11416)] = 361896,
  [SMALL_STATE(11417)] = 361903,
  [SMALL_STATE(11418)] = 361910,
  [SMALL_STATE(11419)] = 361917,
  [SMALL_STATE(11420)] = 361924,
  [SMALL_STATE(11421)] = 361931,
  [SMALL_STATE(11422)] = 361938,
  [SMALL_STATE(11423)] = 361945,
  [SMALL_STATE(11424)] = 361952,
  [SMALL_STATE(11425)] = 361959,
  [SMALL_STATE(11426)] = 361966,
  [SMALL_STATE(11427)] = 361973,
  [SMALL_STATE(11428)] = 361980,
  [SMALL_STATE(11429)] = 361987,
  [SMALL_STATE(11430)] = 361994,
  [SMALL_STATE(11431)] = 362001,
  [SMALL_STATE(11432)] = 362008,
  [SMALL_STATE(11433)] = 362015,
  [SMALL_STATE(11434)] = 362022,
  [SMALL_STATE(11435)] = 362029,
  [SMALL_STATE(11436)] = 362036,
  [SMALL_STATE(11437)] = 362043,
  [SMALL_STATE(11438)] = 362050,
  [SMALL_STATE(11439)] = 362057,
  [SMALL_STATE(11440)] = 362064,
  [SMALL_STATE(11441)] = 362071,
  [SMALL_STATE(11442)] = 362078,
  [SMALL_STATE(11443)] = 362085,
  [SMALL_STATE(11444)] = 362092,
  [SMALL_STATE(11445)] = 362099,
  [SMALL_STATE(11446)] = 362106,
  [SMALL_STATE(11447)] = 362113,
  [SMALL_STATE(11448)] = 362120,
  [SMALL_STATE(11449)] = 362127,
  [SMALL_STATE(11450)] = 362134,
  [SMALL_STATE(11451)] = 362141,
  [SMALL_STATE(11452)] = 362148,
  [SMALL_STATE(11453)] = 362155,
  [SMALL_STATE(11454)] = 362162,
  [SMALL_STATE(11455)] = 362169,
  [SMALL_STATE(11456)] = 362176,
  [SMALL_STATE(11457)] = 362183,
  [SMALL_STATE(11458)] = 362190,
  [SMALL_STATE(11459)] = 362197,
  [SMALL_STATE(11460)] = 362204,
  [SMALL_STATE(11461)] = 362211,
  [SMALL_STATE(11462)] = 362218,
  [SMALL_STATE(11463)] = 362225,
  [SMALL_STATE(11464)] = 362232,
  [SMALL_STATE(11465)] = 362239,
  [SMALL_STATE(11466)] = 362246,
  [SMALL_STATE(11467)] = 362253,
  [SMALL_STATE(11468)] = 362260,
  [SMALL_STATE(11469)] = 362267,
  [SMALL_STATE(11470)] = 362274,
  [SMALL_STATE(11471)] = 362281,
  [SMALL_STATE(11472)] = 362288,
  [SMALL_STATE(11473)] = 362295,
  [SMALL_STATE(11474)] = 362302,
  [SMALL_STATE(11475)] = 362309,
  [SMALL_STATE(11476)] = 362316,
  [SMALL_STATE(11477)] = 362323,
  [SMALL_STATE(11478)] = 362330,
  [SMALL_STATE(11479)] = 362337,
  [SMALL_STATE(11480)] = 362344,
  [SMALL_STATE(11481)] = 362351,
  [SMALL_STATE(11482)] = 362358,
  [SMALL_STATE(11483)] = 362365,
  [SMALL_STATE(11484)] = 362372,
  [SMALL_STATE(11485)] = 362379,
  [SMALL_STATE(11486)] = 362386,
  [SMALL_STATE(11487)] = 362393,
  [SMALL_STATE(11488)] = 362400,
  [SMALL_STATE(11489)] = 362407,
  [SMALL_STATE(11490)] = 362414,
  [SMALL_STATE(11491)] = 362421,
  [SMALL_STATE(11492)] = 362428,
  [SMALL_STATE(11493)] = 362435,
  [SMALL_STATE(11494)] = 362442,
  [SMALL_STATE(11495)] = 362449,
  [SMALL_STATE(11496)] = 362456,
  [SMALL_STATE(11497)] = 362463,
  [SMALL_STATE(11498)] = 362470,
  [SMALL_STATE(11499)] = 362477,
  [SMALL_STATE(11500)] = 362484,
  [SMALL_STATE(11501)] = 362491,
  [SMALL_STATE(11502)] = 362498,
  [SMALL_STATE(11503)] = 362505,
  [SMALL_STATE(11504)] = 362512,
  [SMALL_STATE(11505)] = 362519,
  [SMALL_STATE(11506)] = 362526,
  [SMALL_STATE(11507)] = 362533,
  [SMALL_STATE(11508)] = 362540,
  [SMALL_STATE(11509)] = 362547,
  [SMALL_STATE(11510)] = 362554,
  [SMALL_STATE(11511)] = 362561,
  [SMALL_STATE(11512)] = 362568,
  [SMALL_STATE(11513)] = 362575,
  [SMALL_STATE(11514)] = 362582,
  [SMALL_STATE(11515)] = 362589,
  [SMALL_STATE(11516)] = 362596,
  [SMALL_STATE(11517)] = 362603,
  [SMALL_STATE(11518)] = 362610,
  [SMALL_STATE(11519)] = 362617,
  [SMALL_STATE(11520)] = 362624,
  [SMALL_STATE(11521)] = 362631,
  [SMALL_STATE(11522)] = 362638,
  [SMALL_STATE(11523)] = 362645,
  [SMALL_STATE(11524)] = 362652,
  [SMALL_STATE(11525)] = 362659,
  [SMALL_STATE(11526)] = 362666,
  [SMALL_STATE(11527)] = 362673,
  [SMALL_STATE(11528)] = 362680,
  [SMALL_STATE(11529)] = 362687,
  [SMALL_STATE(11530)] = 362694,
  [SMALL_STATE(11531)] = 362701,
  [SMALL_STATE(11532)] = 362708,
  [SMALL_STATE(11533)] = 362715,
  [SMALL_STATE(11534)] = 362722,
  [SMALL_STATE(11535)] = 362729,
  [SMALL_STATE(11536)] = 362736,
  [SMALL_STATE(11537)] = 362743,
  [SMALL_STATE(11538)] = 362750,
  [SMALL_STATE(11539)] = 362757,
  [SMALL_STATE(11540)] = 362764,
  [SMALL_STATE(11541)] = 362771,
  [SMALL_STATE(11542)] = 362778,
  [SMALL_STATE(11543)] = 362785,
  [SMALL_STATE(11544)] = 362792,
  [SMALL_STATE(11545)] = 362799,
  [SMALL_STATE(11546)] = 362806,
  [SMALL_STATE(11547)] = 362813,
  [SMALL_STATE(11548)] = 362820,
  [SMALL_STATE(11549)] = 362827,
  [SMALL_STATE(11550)] = 362834,
  [SMALL_STATE(11551)] = 362841,
  [SMALL_STATE(11552)] = 362848,
  [SMALL_STATE(11553)] = 362855,
  [SMALL_STATE(11554)] = 362862,
  [SMALL_STATE(11555)] = 362869,
  [SMALL_STATE(11556)] = 362876,
  [SMALL_STATE(11557)] = 362883,
  [SMALL_STATE(11558)] = 362890,
  [SMALL_STATE(11559)] = 362897,
  [SMALL_STATE(11560)] = 362904,
  [SMALL_STATE(11561)] = 362911,
  [SMALL_STATE(11562)] = 362918,
  [SMALL_STATE(11563)] = 362925,
  [SMALL_STATE(11564)] = 362932,
  [SMALL_STATE(11565)] = 362939,
  [SMALL_STATE(11566)] = 362946,
  [SMALL_STATE(11567)] = 362953,
  [SMALL_STATE(11568)] = 362960,
  [SMALL_STATE(11569)] = 362967,
  [SMALL_STATE(11570)] = 362974,
  [SMALL_STATE(11571)] = 362981,
  [SMALL_STATE(11572)] = 362988,
  [SMALL_STATE(11573)] = 362995,
  [SMALL_STATE(11574)] = 363002,
  [SMALL_STATE(11575)] = 363009,
  [SMALL_STATE(11576)] = 363016,
  [SMALL_STATE(11577)] = 363023,
  [SMALL_STATE(11578)] = 363030,
  [SMALL_STATE(11579)] = 363037,
  [SMALL_STATE(11580)] = 363044,
  [SMALL_STATE(11581)] = 363051,
  [SMALL_STATE(11582)] = 363058,
  [SMALL_STATE(11583)] = 363065,
  [SMALL_STATE(11584)] = 363072,
  [SMALL_STATE(11585)] = 363079,
  [SMALL_STATE(11586)] = 363086,
  [SMALL_STATE(11587)] = 363093,
  [SMALL_STATE(11588)] = 363100,
  [SMALL_STATE(11589)] = 363107,
  [SMALL_STATE(11590)] = 363114,
  [SMALL_STATE(11591)] = 363121,
  [SMALL_STATE(11592)] = 363128,
  [SMALL_STATE(11593)] = 363135,
  [SMALL_STATE(11594)] = 363142,
  [SMALL_STATE(11595)] = 363149,
  [SMALL_STATE(11596)] = 363156,
  [SMALL_STATE(11597)] = 363163,
  [SMALL_STATE(11598)] = 363170,
  [SMALL_STATE(11599)] = 363177,
  [SMALL_STATE(11600)] = 363184,
  [SMALL_STATE(11601)] = 363191,
  [SMALL_STATE(11602)] = 363198,
  [SMALL_STATE(11603)] = 363205,
  [SMALL_STATE(11604)] = 363212,
  [SMALL_STATE(11605)] = 363219,
  [SMALL_STATE(11606)] = 363226,
  [SMALL_STATE(11607)] = 363233,
  [SMALL_STATE(11608)] = 363240,
  [SMALL_STATE(11609)] = 363247,
  [SMALL_STATE(11610)] = 363254,
  [SMALL_STATE(11611)] = 363261,
  [SMALL_STATE(11612)] = 363268,
  [SMALL_STATE(11613)] = 363275,
  [SMALL_STATE(11614)] = 363282,
  [SMALL_STATE(11615)] = 363289,
  [SMALL_STATE(11616)] = 363296,
  [SMALL_STATE(11617)] = 363303,
  [SMALL_STATE(11618)] = 363310,
  [SMALL_STATE(11619)] = 363317,
  [SMALL_STATE(11620)] = 363324,
  [SMALL_STATE(11621)] = 363331,
  [SMALL_STATE(11622)] = 363338,
  [SMALL_STATE(11623)] = 363345,
  [SMALL_STATE(11624)] = 363352,
  [SMALL_STATE(11625)] = 363359,
  [SMALL_STATE(11626)] = 363366,
  [SMALL_STATE(11627)] = 363373,
  [SMALL_STATE(11628)] = 363380,
  [SMALL_STATE(11629)] = 363387,
  [SMALL_STATE(11630)] = 363394,
  [SMALL_STATE(11631)] = 363401,
  [SMALL_STATE(11632)] = 363408,
  [SMALL_STATE(11633)] = 363415,
  [SMALL_STATE(11634)] = 363422,
  [SMALL_STATE(11635)] = 363429,
  [SMALL_STATE(11636)] = 363436,
  [SMALL_STATE(11637)] = 363443,
  [SMALL_STATE(11638)] = 363450,
  [SMALL_STATE(11639)] = 363457,
  [SMALL_STATE(11640)] = 363464,
  [SMALL_STATE(11641)] = 363471,
  [SMALL_STATE(11642)] = 363478,
  [SMALL_STATE(11643)] = 363485,
  [SMALL_STATE(11644)] = 363492,
  [SMALL_STATE(11645)] = 363499,
  [SMALL_STATE(11646)] = 363506,
  [SMALL_STATE(11647)] = 363513,
  [SMALL_STATE(11648)] = 363520,
  [SMALL_STATE(11649)] = 363527,
  [SMALL_STATE(11650)] = 363534,
  [SMALL_STATE(11651)] = 363541,
  [SMALL_STATE(11652)] = 363548,
  [SMALL_STATE(11653)] = 363555,
  [SMALL_STATE(11654)] = 363562,
  [SMALL_STATE(11655)] = 363569,
  [SMALL_STATE(11656)] = 363576,
  [SMALL_STATE(11657)] = 363583,
  [SMALL_STATE(11658)] = 363590,
  [SMALL_STATE(11659)] = 363597,
  [SMALL_STATE(11660)] = 363604,
  [SMALL_STATE(11661)] = 363611,
  [SMALL_STATE(11662)] = 363618,
  [SMALL_STATE(11663)] = 363625,
  [SMALL_STATE(11664)] = 363632,
  [SMALL_STATE(11665)] = 363639,
  [SMALL_STATE(11666)] = 363646,
  [SMALL_STATE(11667)] = 363653,
  [SMALL_STATE(11668)] = 363660,
  [SMALL_STATE(11669)] = 363667,
  [SMALL_STATE(11670)] = 363674,
  [SMALL_STATE(11671)] = 363681,
  [SMALL_STATE(11672)] = 363688,
  [SMALL_STATE(11673)] = 363695,
  [SMALL_STATE(11674)] = 363702,
  [SMALL_STATE(11675)] = 363709,
  [SMALL_STATE(11676)] = 363716,
  [SMALL_STATE(11677)] = 363723,
  [SMALL_STATE(11678)] = 363730,
  [SMALL_STATE(11679)] = 363737,
  [SMALL_STATE(11680)] = 363744,
  [SMALL_STATE(11681)] = 363751,
  [SMALL_STATE(11682)] = 363758,
  [SMALL_STATE(11683)] = 363765,
  [SMALL_STATE(11684)] = 363772,
  [SMALL_STATE(11685)] = 363779,
  [SMALL_STATE(11686)] = 363786,
  [SMALL_STATE(11687)] = 363793,
  [SMALL_STATE(11688)] = 363800,
  [SMALL_STATE(11689)] = 363807,
  [SMALL_STATE(11690)] = 363814,
  [SMALL_STATE(11691)] = 363821,
  [SMALL_STATE(11692)] = 363828,
  [SMALL_STATE(11693)] = 363835,
  [SMALL_STATE(11694)] = 363842,
  [SMALL_STATE(11695)] = 363849,
  [SMALL_STATE(11696)] = 363856,
  [SMALL_STATE(11697)] = 363863,
  [SMALL_STATE(11698)] = 363870,
  [SMALL_STATE(11699)] = 363877,
  [SMALL_STATE(11700)] = 363884,
  [SMALL_STATE(11701)] = 363891,
  [SMALL_STATE(11702)] = 363898,
  [SMALL_STATE(11703)] = 363905,
  [SMALL_STATE(11704)] = 363912,
  [SMALL_STATE(11705)] = 363919,
  [SMALL_STATE(11706)] = 363926,
  [SMALL_STATE(11707)] = 363933,
  [SMALL_STATE(11708)] = 363940,
  [SMALL_STATE(11709)] = 363947,
  [SMALL_STATE(11710)] = 363954,
  [SMALL_STATE(11711)] = 363961,
  [SMALL_STATE(11712)] = 363968,
  [SMALL_STATE(11713)] = 363975,
  [SMALL_STATE(11714)] = 363982,
  [SMALL_STATE(11715)] = 363989,
  [SMALL_STATE(11716)] = 363996,
  [SMALL_STATE(11717)] = 364003,
  [SMALL_STATE(11718)] = 364010,
  [SMALL_STATE(11719)] = 364017,
  [SMALL_STATE(11720)] = 364024,
  [SMALL_STATE(11721)] = 364031,
  [SMALL_STATE(11722)] = 364038,
  [SMALL_STATE(11723)] = 364045,
  [SMALL_STATE(11724)] = 364052,
  [SMALL_STATE(11725)] = 364059,
  [SMALL_STATE(11726)] = 364066,
  [SMALL_STATE(11727)] = 364073,
  [SMALL_STATE(11728)] = 364080,
  [SMALL_STATE(11729)] = 364087,
  [SMALL_STATE(11730)] = 364094,
  [SMALL_STATE(11731)] = 364101,
  [SMALL_STATE(11732)] = 364108,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8680),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11060),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7283),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11176),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10611),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2314),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6861),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1554),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4282),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2919),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2770),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10836),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8406),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8586),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9855),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11064),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10641),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3122),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1630),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2914),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2857),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2663),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10916),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7940),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6683),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6629),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6705),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10141),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10527),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2237),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11637),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10525),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11048),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11177),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11564),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11668),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1955),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11212),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11235),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11253),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8901),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6105),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9916),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9468),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6219),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4849),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11288),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3448),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6267),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9391),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8364),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1460),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1156),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10364),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2202),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1894),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8649),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10921),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11096),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2205),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10650),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2206),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6124),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6924),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2916),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6692),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6651),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10918),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1352),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8730),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10930),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10938),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7288),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10944),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10489),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4169),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2771),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8373),
  [199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2717),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1629),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2860),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2801),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7994),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6736),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6640),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6702),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9661),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10354),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2461),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11185),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10761),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1251),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10902),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11215),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11217),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11138),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10529),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11508),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10955),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5341),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4922),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2886),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11227),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6328),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10374),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8767),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11480),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11481),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1960),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2462),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10935),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7448),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6746),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6670),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1375),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8625),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11202),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7331),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11203),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7219),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11150),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10679),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(452),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4201),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2775),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8413),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2893),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10064),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10639),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2502),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10973),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10366),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1256),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11479),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1660),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11535),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11536),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11221),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10694),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11608),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10656),
  [351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1993),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8737),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11627),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11628),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1946),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2490),
  [363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11610),
  [365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7443),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1020),
  [369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 3, 0, 80),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef, 3, 0, 10),
  [377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef, 2, 0, 10),
  [379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 4, 0, 80),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(594),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(962),
  [405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1375),
  [408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8625),
  [411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11202),
  [414] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7331),
  [417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0),
  [419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11203),
  [422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10679),
  [425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(253),
  [428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2314),
  [431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2290),
  [434] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2314),
  [437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1418),
  [440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6861),
  [443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1554),
  [446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(514),
  [449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(452),
  [452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4201),
  [455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2919),
  [458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2775),
  [461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10836),
  [464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8413),
  [467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8586),
  [470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9855),
  [473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11064),
  [476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10641),
  [479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3122),
  [482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(47),
  [485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2717),
  [488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1630),
  [491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2914),
  [494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2893),
  [497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2663),
  [500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10916),
  [503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2801),
  [506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7994),
  [509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6736),
  [512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6640),
  [515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6702),
  [518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10064),
  [521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10639),
  [524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2502),
  [527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10973),
  [530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10366),
  [533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1256),
  [536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11479),
  [539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1660),
  [542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11535),
  [545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11536),
  [548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11221),
  [551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10694),
  [554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11608),
  [557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2288),
  [560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1955),
  [563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11212),
  [566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11235),
  [569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11253),
  [572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8901),
  [575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5341),
  [578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9916),
  [581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9468),
  [584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4922),
  [587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4849),
  [590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2886),
  [593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11227),
  [596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3448),
  [599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6328),
  [602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1457),
  [605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1156),
  [608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10656),
  [611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2202),
  [614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1993),
  [617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8737),
  [620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11627),
  [623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11628),
  [626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1946),
  [629] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2490),
  [632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10650),
  [635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2206),
  [638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6124),
  [641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6924),
  [644] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11610),
  [647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2916),
  [650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7443),
  [653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6746),
  [656] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6670),
  [659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0),
  [661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(113),
  [664] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8680),
  [667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(11060),
  [670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7283),
  [673] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(11176),
  [676] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10611),
  [679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(253),
  [682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2314),
  [685] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2290),
  [688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2314),
  [691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1418),
  [694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6861),
  [697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1554),
  [700] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(989),
  [703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(376),
  [706] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4282),
  [709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2919),
  [712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2770),
  [715] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10836),
  [718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8406),
  [721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8586),
  [724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9855),
  [727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(11064),
  [730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10641),
  [733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3122),
  [736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(30),
  [739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(389),
  [742] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1630),
  [745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2914),
  [748] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2857),
  [751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2663),
  [754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10916),
  [757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(614),
  [760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7940),
  [763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6683),
  [766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6629),
  [769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6705),
  [772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10141),
  [775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10527),
  [778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2237),
  [781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(11637),
  [784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10525),
  [787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1215),
  [790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(11048),
  [793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1754),
  [796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(11177),
  [799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(11564),
  [802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(11668),
  [805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2288),
  [808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1955),
  [811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(11212),
  [814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(11235),
  [817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(11253),
  [820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8901),
  [823] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6105),
  [826] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9916),
  [829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9468),
  [832] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6219),
  [835] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4849),
  [838] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(313),
  [841] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(11288),
  [844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3448),
  [847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6267),
  [850] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(45),
  [853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9391),
  [856] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8364),
  [859] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1460),
  [862] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1156),
  [865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10364),
  [868] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2202),
  [871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1894),
  [874] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8649),
  [877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10921),
  [880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(11096),
  [883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1893),
  [886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2205),
  [889] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10650),
  [892] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2206),
  [895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6124),
  [898] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6924),
  [901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2916),
  [904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6692),
  [907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6651),
  [910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(10918),
  [913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 1, 0, 0),
  [915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1401),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1390),
  [926] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8721),
  [929] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11130),
  [932] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7341),
  [935] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10920),
  [938] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10543),
  [941] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(757),
  [944] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(511),
  [947] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4228),
  [950] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2776),
  [953] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8312),
  [956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(58),
  [959] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2841),
  [962] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9757),
  [965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10644),
  [968] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2514),
  [971] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11523),
  [974] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10643),
  [977] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1259),
  [980] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11626),
  [983] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1684),
  [986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10982),
  [989] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10992),
  [992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10940),
  [995] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10669),
  [998] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11309),
  [1001] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1458),
  [1004] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10652),
  [1007] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1911),
  [1010] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8743),
  [1013] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11654),
  [1016] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11645),
  [1019] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1915),
  [1022] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2503),
  [1025] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11337),
  [1028] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7407),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(424),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [1043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7937),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6646),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6649),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6661),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11406),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6262),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6671),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6672),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1390),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8721),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11130),
  [1075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7341),
  [1077] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 2, 0, 0),
  [1079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10920),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10543),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [1085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(511),
  [1087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4228),
  [1089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2776),
  [1091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8312),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [1095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2841),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9757),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10644),
  [1101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2514),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11523),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10643),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11626),
  [1111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1684),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10982),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10992),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10940),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10669),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11309),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1458),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10652),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8743),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11654),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11645),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1915),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2503),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11337),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7407),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4191),
  [1145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3973),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1357),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10444),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10815),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10528),
  [1163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8415),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10831),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7442),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [1173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 1, 0, 0),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [1183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1401),
  [1186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8730),
  [1189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10930),
  [1192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7288),
  [1195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10944),
  [1198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10489),
  [1201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(834),
  [1204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(517),
  [1207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4169),
  [1210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2771),
  [1213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8373),
  [1216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(33),
  [1219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0),
  [1221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2860),
  [1224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9661),
  [1227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10354),
  [1230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2461),
  [1233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11185),
  [1236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10761),
  [1239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1251),
  [1242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10902),
  [1245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1742),
  [1248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11215),
  [1251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11217),
  [1254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11138),
  [1257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10529),
  [1260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11508),
  [1263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1459),
  [1266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10374),
  [1269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1906),
  [1272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8767),
  [1275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11480),
  [1278] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(11481),
  [1281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1960),
  [1284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2462),
  [1287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(10935),
  [1290] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7448),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4586),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4606),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5207),
  [1315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5118),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4898),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4904),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4759),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4768),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2696),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7182),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7200),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6999),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7000),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [1343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(112),
  [1346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8730),
  [1349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10930),
  [1352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7288),
  [1355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10944),
  [1358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10489),
  [1361] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(253),
  [1364] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2314),
  [1367] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2290),
  [1370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2314),
  [1373] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1418),
  [1376] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6861),
  [1379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1554),
  [1382] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(834),
  [1385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(517),
  [1388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4169),
  [1391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2919),
  [1394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2771),
  [1397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10836),
  [1400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8373),
  [1403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8586),
  [1406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9855),
  [1409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11064),
  [1412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10641),
  [1415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3122),
  [1418] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(33),
  [1421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0),
  [1423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(424),
  [1426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1630),
  [1429] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2914),
  [1432] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2860),
  [1435] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2663),
  [1438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10916),
  [1441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(585),
  [1444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7937),
  [1447] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6646),
  [1450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6649),
  [1453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6661),
  [1456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9661),
  [1459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10354),
  [1462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2461),
  [1465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11185),
  [1468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10761),
  [1471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1251),
  [1474] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10902),
  [1477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1742),
  [1480] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11215),
  [1483] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11217),
  [1486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11138),
  [1489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10529),
  [1492] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11508),
  [1495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2288),
  [1498] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1955),
  [1501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11212),
  [1504] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11235),
  [1507] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11253),
  [1510] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8901),
  [1513] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5341),
  [1516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9916),
  [1519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9468),
  [1522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4922),
  [1525] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4849),
  [1528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(754),
  [1531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11406),
  [1534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3448),
  [1537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6262),
  [1540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1459),
  [1543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1156),
  [1546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10374),
  [1549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2202),
  [1552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1906),
  [1555] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8767),
  [1558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11480),
  [1561] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11481),
  [1564] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1960),
  [1567] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2462),
  [1570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10650),
  [1573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2206),
  [1576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6124),
  [1579] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6924),
  [1582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10935),
  [1585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2916),
  [1588] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7448),
  [1591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6671),
  [1594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6672),
  [1597] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1423),
  [1600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0),
  [1602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1158),
  [1605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2314),
  [1608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2314),
  [1611] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2422),
  [1614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0),
  [1616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2422),
  [1619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(514),
  [1622] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(882),
  [1625] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4201),
  [1628] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2666),
  [1631] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2914),
  [1634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10836),
  [1637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8586),
  [1640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9902),
  [1643] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11064),
  [1646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(47),
  [1649] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2717),
  [1652] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1632),
  [1655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2663),
  [1658] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10916),
  [1661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2801),
  [1664] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7994),
  [1667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6736),
  [1670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6640),
  [1673] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6702),
  [1676] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10064),
  [1679] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10639),
  [1682] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10366),
  [1685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1256),
  [1688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11479),
  [1691] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1660),
  [1694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11535),
  [1697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11536),
  [1700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11221),
  [1703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10694),
  [1706] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11608),
  [1709] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2288),
  [1712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1955),
  [1715] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11212),
  [1718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11235),
  [1721] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11253),
  [1724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8901),
  [1727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5341),
  [1730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9916),
  [1733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9468),
  [1736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4922),
  [1739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4849),
  [1742] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2886),
  [1745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11227),
  [1748] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6328),
  [1751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10670),
  [1754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10656),
  [1757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2202),
  [1760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1993),
  [1763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1946),
  [1766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2490),
  [1769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10650),
  [1772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2206),
  [1775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6124),
  [1778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6924),
  [1781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11610),
  [1784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2916),
  [1787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7443),
  [1790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6746),
  [1793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6670),
  [1796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, 0, 14),
  [1798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1428),
  [1800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, 0, 14),
  [1802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [1804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2422),
  [1806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2422),
  [1808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [1810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2666),
  [1812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9902),
  [1814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1632),
  [1816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10670),
  [1818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, 0, 0),
  [1820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, 0, 0),
  [1822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [1824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 2, 0, 0),
  [1826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 2, 0, 0),
  [1828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [1830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 4, 0, 14),
  [1832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 4, 0, 14),
  [1834] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1428),
  [1837] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(478),
  [1840] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(877),
  [1843] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4282),
  [1846] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(30),
  [1849] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10141),
  [1852] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10527),
  [1855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10525),
  [1858] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1215),
  [1861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11048),
  [1864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1754),
  [1867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11177),
  [1870] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11564),
  [1873] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11668),
  [1876] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10444),
  [1879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10815),
  [1882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10364),
  [1885] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1894),
  [1888] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1893),
  [1891] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2205),
  [1894] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10831),
  [1897] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7442),
  [1900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1420),
  [1902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [1904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1420),
  [1907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(834),
  [1910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(880),
  [1913] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4169),
  [1916] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(33),
  [1919] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9661),
  [1922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10354),
  [1925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10761),
  [1928] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1251),
  [1931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10902),
  [1934] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1742),
  [1937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11215),
  [1940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11217),
  [1943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11138),
  [1946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10529),
  [1949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11508),
  [1952] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10374),
  [1955] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1906),
  [1958] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1960),
  [1961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2462),
  [1964] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10935),
  [1967] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7448),
  [1970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1424),
  [1972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [1974] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1424),
  [1977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(757),
  [1980] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(737),
  [1983] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4228),
  [1986] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(58),
  [1989] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9757),
  [1992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10644),
  [1995] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10643),
  [1998] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1259),
  [2001] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11626),
  [2004] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1684),
  [2007] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10982),
  [2010] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10992),
  [2013] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10940),
  [2016] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10669),
  [2019] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11309),
  [2022] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10652),
  [2025] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1911),
  [2028] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1915),
  [2031] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2503),
  [2034] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11337),
  [2037] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7407),
  [2040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [2042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1427),
  [2044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [2046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [2048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9858),
  [2050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10384),
  [2052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2489),
  [2054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11531),
  [2056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10646),
  [2058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1201),
  [2060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11643),
  [2062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1705),
  [2064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11539),
  [2066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11540),
  [2068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11137),
  [2070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10399),
  [2072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10854),
  [2074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10470),
  [2076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1966),
  [2078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1970),
  [2080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2515),
  [2082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10863),
  [2084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7393),
  [2086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(845),
  [2088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4218),
  [2090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1426),
  [2092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10277),
  [2094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10688),
  [2096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11224),
  [2098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10333),
  [2100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7410),
  [2102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1427),
  [2105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1380),
  [2108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(845),
  [2111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4218),
  [2114] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(62),
  [2117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9858),
  [2120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10384),
  [2123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10646),
  [2126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1201),
  [2129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11643),
  [2132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1705),
  [2135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11539),
  [2138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11540),
  [2141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(11137),
  [2144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10399),
  [2147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10854),
  [2150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10470),
  [2153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1966),
  [2156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1970),
  [2159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2515),
  [2162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10863),
  [2165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7393),
  [2168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 1),
  [2170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [2172] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [2176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1),
  [2178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [2181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [2183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [2186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1290),
  [2189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [2191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8871),
  [2193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1),
  [2196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym__class_name, 1, 0, 1),
  [2199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [2201] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [2205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1876),
  [2207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [2209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9357),
  [2211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10756),
  [2213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1278),
  [2216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [2218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [2220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [2222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34),
  [2224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_identifier, 2, 0, 33),
  [2226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_qualified_identifier, 2, 0, 33), REDUCE(sym_qualified_type_identifier, 2, 0, 34),
  [2229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34),
  [2231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 33), REDUCE(sym_qualified_type_identifier, 2, 0, 34),
  [2234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 33),
  [2236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 33), SHIFT(1297),
  [2239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 3, 2, 0),
  [2241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 3, 2, 0),
  [2243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_type, 2, 0, 16),
  [2245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_function, 2, 0, 17),
  [2247] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_template_type, 2, 0, 16), REDUCE(sym_template_function, 2, 0, 17),
  [2250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_type, 2, 0, 16),
  [2252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_template_type, 2, 0, 16), REDUCE(sym_template_function, 2, 0, 17),
  [2255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_function, 2, 0, 17),
  [2257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 33), SHIFT(1284),
  [2260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 6, 3, 0),
  [2262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 6, 3, 0),
  [2264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 5, 3, 0),
  [2266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 5, 3, 0),
  [2268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 2, 0, 0),
  [2270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 2, 0, 0),
  [2272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 3, 1, 0),
  [2274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 3, 1, 0),
  [2276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 3, 3, 0),
  [2278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 3, 3, 0),
  [2280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, 4, 0),
  [2282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, 4, 0),
  [2284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, 1, 0),
  [2286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, 1, 0),
  [2288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, 3, 0),
  [2290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, 3, 0),
  [2292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, 2, 0),
  [2294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, 2, 0),
  [2296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 5, 4, 0),
  [2298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 5, 4, 0),
  [2300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 6, 4, 0),
  [2302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 6, 4, 0),
  [2304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 7, 4, 0),
  [2306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 7, 4, 0),
  [2308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 7, 3, 0),
  [2310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 7, 3, 0),
  [2312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 8, 4, 0),
  [2314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 8, 4, 0),
  [2316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1422),
  [2318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [2320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [2322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4223),
  [2324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11501),
  [2326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9856),
  [2328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7343),
  [2330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11025),
  [2332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1421),
  [2334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6005),
  [2336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11605),
  [2338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [2342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2421),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [2346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [2348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2667),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8516),
  [2352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2884),
  [2354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7893),
  [2356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6677),
  [2358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6678),
  [2360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6701),
  [2362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [2364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1965),
  [2366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11350),
  [2368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11705),
  [2370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11730),
  [2372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8957),
  [2374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4830),
  [2376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9954),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9487),
  [2380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4888),
  [2382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4883),
  [2384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6264),
  [2386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2155),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10766),
  [2390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2156),
  [2392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6130),
  [2394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6929),
  [2396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6703),
  [2398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6704),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [2402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 3, 0, 0),
  [2404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 3, 0, 0),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [2408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_name, 1, 0, 1),
  [2410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_name, 1, 0, 1),
  [2412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 2, 0, 0),
  [2414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 2, 0, 0),
  [2416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_type_identifier, 2, 0, 0),
  [2418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_type_identifier, 2, 0, 0),
  [2420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type_identifier, 2, 0, 33),
  [2422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 33),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8838),
  [2426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_name, 1, 0, 0),
  [2428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_name, 1, 0, 0),
  [2430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3083),
  [2432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11275),
  [2434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7294),
  [2436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1687),
  [2438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11140),
  [2440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [2442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7311),
  [2444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11436),
  [2446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10361),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6257),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10943),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4231),
  [2454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6861),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [2458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2890),
  [2460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4233),
  [2462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8322),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7049),
  [2466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10998),
  [2468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2848),
  [2470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2774),
  [2472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7938),
  [2474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6613),
  [2476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6650),
  [2478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6652),
  [2480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6354),
  [2482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11399),
  [2484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9448),
  [2486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1571),
  [2488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11662),
  [2490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6596),
  [2492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6604),
  [2494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10616),
  [2496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10350),
  [2498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4241),
  [2500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11205),
  [2502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3, 0, 80),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [2506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [2508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 3, 0, 10),
  [2510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [2514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 2, 0, 10),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [2518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2028),
  [2520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, 0, 80),
  [2522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2080),
  [2524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1785),
  [2526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [2528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2017),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [2532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2441),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [2536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1759),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [2540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1997),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [2544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1773),
  [2546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2019),
  [2548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [2550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [2552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [2554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [2556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 3, 0, 47),
  [2558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 3, 0, 47),
  [2560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7488),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [2564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7586),
  [2566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 2, 0, 10),
  [2568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 2, 0, 10),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [2572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_statement, 1, 0, 0),
  [2574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_specifiers, 1, 0, 2), REDUCE(sym__top_level_statement, 1, 0, 0),
  [2577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_statement, 1, 0, 0),
  [2579] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration_specifiers, 1, 0, 2), REDUCE(sym__top_level_statement, 1, 0, 0),
  [2582] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__top_level_statement, 1, 0, 0), SHIFT(1007),
  [2585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__top_level_statement, 1, 0, 0), SHIFT(2738),
  [2588] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__top_level_statement, 1, 0, 0), SHIFT(2773),
  [2591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__top_level_statement, 1, 0, 0), SHIFT(2955),
  [2594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__top_level_statement, 1, 0, 0), SHIFT(10898),
  [2597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__top_level_statement, 1, 0, 0), SHIFT(10060),
  [2600] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__top_level_statement, 1, 0, 0), SHIFT(10900),
  [2603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__top_level_statement, 1, 0, 0), SHIFT(11223),
  [2606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6314),
  [2608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [2610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__top_level_statement, 1, 0, 0), SHIFT(2954),
  [2613] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_specifiers, 1, 0, 2), REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0),
  [2616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0),
  [2618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration_specifiers, 1, 0, 2), REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0),
  [2621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0),
  [2623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0), SHIFT(1095),
  [2626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0), SHIFT(2738),
  [2629] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0), SHIFT(2773),
  [2632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0), SHIFT(2955),
  [2635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0), SHIFT(10898),
  [2638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0), SHIFT(10060),
  [2641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0), SHIFT(10900),
  [2644] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0), SHIFT(11223),
  [2647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6271),
  [2649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [2651] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0), SHIFT(2954),
  [2654] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3083),
  [2657] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11275),
  [2660] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7294),
  [2663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0),
  [2665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11140),
  [2668] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10361),
  [2671] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6257),
  [2674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10943),
  [2677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4231),
  [2680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6861),
  [2683] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6861),
  [2686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(249),
  [2689] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2890),
  [2692] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4233),
  [2695] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2919),
  [2698] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2914),
  [2701] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10836),
  [2704] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8322),
  [2707] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7049),
  [2710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9856),
  [2713] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11064),
  [2716] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10641),
  [2719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2717),
  [2722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10998),
  [2725] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2663),
  [2728] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2848),
  [2731] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10916),
  [2734] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2774),
  [2737] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7938),
  [2740] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6613),
  [2743] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6650),
  [2746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6652),
  [2749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2886),
  [2752] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11227),
  [2755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3448),
  [2758] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6354),
  [2761] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11399),
  [2764] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9448),
  [2767] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1156),
  [2770] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1571),
  [2773] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11662),
  [2776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2916),
  [2779] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6596),
  [2782] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6604),
  [2785] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10616),
  [2788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10350),
  [2791] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4241),
  [2794] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11205),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [2799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2686),
  [2801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [2805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [2807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2317),
  [2809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [2811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1565),
  [2813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1437),
  [2815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8561),
  [2817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8253),
  [2819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5163),
  [2821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7245),
  [2823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6490),
  [2825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7993),
  [2827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6696),
  [2829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6737),
  [2831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6609),
  [2833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [2835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1983),
  [2837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10905),
  [2839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11695),
  [2841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11727),
  [2843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8933),
  [2845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4338),
  [2847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9759),
  [2849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9583),
  [2851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4643),
  [2853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4604),
  [2855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3044),
  [2857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10907),
  [2859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6274),
  [2861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4350),
  [2863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2158),
  [2865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10651),
  [2867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2159),
  [2869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6079),
  [2871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6927),
  [2873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6722),
  [2875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6727),
  [2877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decltype, 4, 0, 0),
  [2879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decltype, 4, 0, 0),
  [2881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0),
  [2883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 0),
  [2885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, 0, 9),
  [2887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, 0, 9),
  [2889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10357),
  [2891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10658),
  [2893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 1, 0, 6),
  [2895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 1, 0, 6),
  [2897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11440),
  [2899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [2901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0),
  [2903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0),
  [2905] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10357),
  [2908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10658),
  [2911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11222),
  [2913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [2915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [2917] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(284),
  [2920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_try_statement, 3, 0, 9),
  [2922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_try_statement, 3, 0, 9),
  [2924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 50),
  [2926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 50),
  [2928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 9),
  [2930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 9),
  [2932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 3, 0, 103),
  [2934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 3, 0, 103),
  [2936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_specifier, 2, 0, 12),
  [2938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_specifier, 2, 0, 12),
  [2940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 1, 0, 13),
  [2942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 1, 0, 13),
  [2944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [2946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_specifier, 2, 0, 12),
  [2948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_specifier, 2, 0, 12),
  [2950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_specifier, 2, 0, 12),
  [2952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extension_specifier, 2, 0, 12),
  [2954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 3, 0, 0),
  [2956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 3, 0, 0),
  [2958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 46),
  [2960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 46),
  [2962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 47),
  [2964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 47),
  [2966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [2968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_try_statement, 4, 0, 46),
  [2970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_try_statement, 4, 0, 46),
  [2972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_base_clause, 2, 0, 99),
  [2974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__enum_base_clause, 2, 0, 99),
  [2976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 48),
  [2978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 48),
  [2980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 4, 0, 0),
  [2982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 4, 0, 0),
  [2984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 98),
  [2986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 98),
  [2988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 101),
  [2990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 101),
  [2992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 2, 0, 12),
  [2994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 2, 0, 12),
  [2996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 2, 0, 12),
  [2998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 2, 0, 12),
  [3000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 4, 0, 104),
  [3002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 4, 0, 104),
  [3004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 4, 0, 46),
  [3006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 4, 0, 46),
  [3008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 4, 0, 150),
  [3010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 4, 0, 150),
  [3012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_placeholder_type_specifier, 1, 0, 0),
  [3014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_placeholder_type_specifier, 1, 0, 0),
  [3016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 6, 0, 148),
  [3018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 6, 0, 148),
  [3020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 49),
  [3022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 49),
  [3024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 2, 0, 0),
  [3026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 2, 0, 0),
  [3028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 5, 0, 149),
  [3030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 5, 0, 149),
  [3032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 9),
  [3034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 9),
  [3036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 10),
  [3038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 10),
  [3040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 2, 0, 12),
  [3042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 2, 0, 12),
  [3044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 11),
  [3046] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 11),
  [3048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 6),
  [3050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 6),
  [3052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_placeholder_type_specifier, 2, 0, 27),
  [3054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_placeholder_type_specifier, 2, 0, 27),
  [3056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 96),
  [3058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 96),
  [3060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10919),
  [3062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7240),
  [3064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11607),
  [3066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10737),
  [3068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [3070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2864),
  [3072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4211),
  [3074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8492),
  [3076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3847),
  [3078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2835),
  [3080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9401),
  [3082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1580),
  [3084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11644),
  [3086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10415),
  [3088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10425),
  [3090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4014),
  [3092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10980),
  [3094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 180),
  [3096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 180),
  [3098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1261),
  [3100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11423),
  [3103] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7332),
  [3106] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11393),
  [3109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10623),
  [3112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(332),
  [3115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2902),
  [3118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4235),
  [3121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8344),
  [3124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2862),
  [3127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9462),
  [3130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1574),
  [3133] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11669),
  [3136] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10344),
  [3139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10539),
  [3142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4289),
  [3145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11401),
  [3148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 3, 0, 168),
  [3150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 3, 0, 168),
  [3152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11423),
  [3154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7332),
  [3156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 2, 0, 0),
  [3158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11393),
  [3160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10623),
  [3162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [3164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2902),
  [3166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4235),
  [3168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8344),
  [3170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2862),
  [3172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9462),
  [3174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1574),
  [3176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11669),
  [3178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10344),
  [3180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10539),
  [3182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4289),
  [3184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11401),
  [3186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 1, 0, 0),
  [3188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [3190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2859),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [3196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2895),
  [3198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [3200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [3202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [3204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [3206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [3212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 105),
  [3214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 105),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [3218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [3220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [3224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [3226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [3228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3665),
  [3230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3652),
  [3232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [3234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [3236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [3238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, 0, 51),
  [3240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, 0, 51),
  [3242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5822),
  [3246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5837),
  [3248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [3250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [3252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [3254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [3256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [3258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [3260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [3262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5217),
  [3264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5276),
  [3266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3852),
  [3268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [3270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5930),
  [3272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5992),
  [3274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [3276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3697),
  [3278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3700),
  [3280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4964),
  [3284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4973),
  [3286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10919),
  [3289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7240),
  [3292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11607),
  [3295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10737),
  [3298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(374),
  [3301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2864),
  [3304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4211),
  [3307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8492),
  [3310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0),
  [3312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2835),
  [3315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9401),
  [3318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1580),
  [3321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11644),
  [3324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10415),
  [3327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10425),
  [3330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4014),
  [3333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10980),
  [3336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [3338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [3340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(3135),
  [3343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1158),
  [3346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2314),
  [3349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2422),
  [3352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0),
  [3354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2422),
  [3357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2425),
  [3360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4214),
  [3362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0),
  [3364] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(8586),
  [3367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(7343),
  [3370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(9573),
  [3373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(11288),
  [3376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(10670),
  [3379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 6, 0, 135),
  [3381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 6, 0, 135),
  [3383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_except_clause, 3, 0, 187),
  [3385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_except_clause, 3, 0, 187),
  [3387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 5, 0, 188),
  [3389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 5, 0, 188),
  [3391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 5, 0, 189),
  [3393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 5, 0, 189),
  [3395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 5, 0, 190),
  [3397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 5, 0, 190),
  [3399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 6, 0, 209),
  [3401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 6, 0, 209),
  [3403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 210),
  [3405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 210),
  [3407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, 0, 211),
  [3409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 211),
  [3411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 6, 0, 214),
  [3413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 6, 0, 214),
  [3415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [3417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [3419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 2, 0, 0),
  [3421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 2, 0, 0),
  [3423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 1, 0, 0),
  [3425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(653),
  [3428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0),
  [3430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(854),
  [3433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(670),
  [3436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(11307),
  [3439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(684),
  [3442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_return_statement, 3, 0, 0),
  [3444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_return_statement, 3, 0, 0),
  [3446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_yield_statement, 3, 0, 0),
  [3448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_yield_statement, 3, 0, 0),
  [3450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 3, 0, 68),
  [3452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 3, 0, 68),
  [3454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_return_statement, 2, 0, 0),
  [3456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_return_statement, 2, 0, 0),
  [3458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 4, 0, 87),
  [3460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 4, 0, 87),
  [3462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_leave_statement, 2, 0, 0),
  [3464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_leave_statement, 2, 0, 0),
  [3466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_discard_statement, 2, 0, 0),
  [3468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_discard_statement, 2, 0, 0),
  [3470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 2, 0, 9),
  [3472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 2, 0, 9),
  [3474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [3476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [3478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, 0, 10),
  [3480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, 0, 10),
  [3482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7720),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8174),
  [3486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3, 0, 0),
  [3488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3, 0, 0),
  [3490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [3492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [3494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, 0, 52),
  [3496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, 0, 52),
  [3498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 3, 0, 53),
  [3500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 3, 0, 53),
  [3502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 47),
  [3504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 47),
  [3506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, 0, 52),
  [3508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, 0, 52),
  [3510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, 0, 54),
  [3512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, 0, 54),
  [3514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7668),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8128),
  [3518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 106),
  [3520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 106),
  [3522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(669),
  [3525] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(824),
  [3528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(704),
  [3531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(11462),
  [3534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(668),
  [3537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(687),
  [3540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0),
  [3542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 0),
  [3544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(824),
  [3547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(688),
  [3550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(11462),
  [3553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(681),
  [3556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_statement, 2, 0, 0),
  [3558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_statement, 2, 0, 0),
  [3560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, 0, 118),
  [3562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4, 0, 118),
  [3564] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(706),
  [3567] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(854),
  [3570] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(703),
  [3573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(11307),
  [3576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(702),
  [3579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, 0, 135),
  [3581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, 0, 135),
  [3583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4204),
  [3585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 3, 0, 46),
  [3587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 3, 0, 46),
  [3589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, 0, 87),
  [3591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, 0, 87),
  [3593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 3, 0, 48),
  [3595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 3, 0, 48),
  [3597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, 0, 0),
  [3599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, 0, 0),
  [3601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 153),
  [3603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 153),
  [3605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, 0, 0),
  [3607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, 0, 0),
  [3609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, 0, 154),
  [3611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, 0, 154),
  [3613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 158),
  [3615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, 0, 158),
  [3617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_range_loop, 5, 0, 159),
  [3619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_range_loop, 5, 0, 159),
  [3621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 5, 0, 174),
  [3623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 5, 0, 174),
  [3625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [3627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [3629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [3631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [3633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [3635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [3637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_finally_clause, 2, 0, 9),
  [3639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_finally_clause, 2, 0, 9),
  [3641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 4, 0, 96),
  [3643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 4, 0, 96),
  [3645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 4, 0, 95),
  [3647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 4, 0, 95),
  [3649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 4, 0, 141),
  [3651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 4, 0, 141),
  [3653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_try_statement, 3, 0, 9),
  [3655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_try_statement, 3, 0, 9),
  [3657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4230),
  [3659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4179),
  [3661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 25),
  [3663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 25),
  [3665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_assert_declaration, 7, 0, 227),
  [3667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_assert_declaration, 7, 0, 227),
  [3669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 2, 0, 0),
  [3671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 2, 0, 0),
  [3673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_declaration, 2, 0, 26),
  [3675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_declaration, 2, 0, 26),
  [3677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 3, 0, 69),
  [3679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 3, 0, 69),
  [3681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0),
  [3683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0),
  [3685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(854),
  [3688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(11307),
  [3691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 70),
  [3693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 70),
  [3695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 77),
  [3697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 77),
  [3699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 5),
  [3701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 5),
  [3703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 3, 0, 5),
  [3705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 3, 0, 5),
  [3707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_definition, 3, 0, 77),
  [3709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_definition, 3, 0, 77),
  [3711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 4, 0, 78),
  [3713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 4, 0, 78),
  [3715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 4, 0, 79),
  [3717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 4, 0, 79),
  [3719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 4, 0, 80),
  [3721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 4, 0, 80),
  [3723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, 0, 81),
  [3725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, 0, 81),
  [3727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, 0, 10),
  [3729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, 0, 10),
  [3731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_linkage_specification, 3, 0, 44),
  [3733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_linkage_specification, 3, 0, 44),
  [3735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_declaration, 4, 0, 0),
  [3737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_declaration, 4, 0, 0),
  [3739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_declaration, 3, 0, 0),
  [3741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_declaration, 3, 0, 0),
  [3743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_include, 3, 0, 36),
  [3745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_include, 3, 0, 36),
  [3747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 4, 0, 94),
  [3749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 4, 0, 94),
  [3751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 4, 0, 95),
  [3753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 4, 0, 95),
  [3755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 4, 0, 96),
  [3757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 4, 0, 96),
  [3759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 2, 0, 9),
  [3761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 2, 0, 9),
  [3763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_declaration, 6, 0, 185),
  [3765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_declaration, 6, 0, 185),
  [3767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_instantiation, 4, 0, 60),
  [3769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_instantiation, 4, 0, 60),
  [3771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_declaration, 4, 0, 59),
  [3773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_declaration, 4, 0, 59),
  [3775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_base_clause, 2, 0, 100),
  [3777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__enum_base_clause, 2, 0, 100),
  [3779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [3781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10719),
  [3784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 26),
  [3786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 26),
  [3788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [3790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [3792] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 116),
  [3794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 116),
  [3796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 3, 0, 0),
  [3798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 3, 0, 0),
  [3800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_declaration, 3, 0, 5),
  [3802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_declaration, 3, 0, 5),
  [3804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, 0, 46),
  [3806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, 0, 46),
  [3808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 4, 0, 0),
  [3810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 4, 0, 0),
  [3812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 120),
  [3814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 120),
  [3816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_method_clause, 3, 0, 0),
  [3818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_method_clause, 3, 0, 0),
  [3820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_method_clause, 3, 0, 0),
  [3822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_method_clause, 3, 0, 0),
  [3824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pure_virtual_clause, 3, 0, 0),
  [3826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pure_virtual_clause, 3, 0, 0),
  [3828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__empty_declaration, 2, 0, 0),
  [3830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__empty_declaration, 2, 0, 0),
  [3832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 5, 0, 0),
  [3834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 5, 0, 0),
  [3836] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(1751),
  [3839] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(1603),
  [3842] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(662),
  [3845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, 0, 212),
  [3847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, 0, 212),
  [3849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 3, 0, 10),
  [3851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 3, 0, 10),
  [3853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 4, 0, 125),
  [3855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 4, 0, 125),
  [3857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 4, 0, 128),
  [3859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 4, 0, 128),
  [3861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 5, 0, 129),
  [3863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 5, 0, 129),
  [3865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 130),
  [3867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 130),
  [3869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 80),
  [3871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 80),
  [3873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 5, 0, 131),
  [3875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 5, 0, 131),
  [3877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 3, 0, 10),
  [3879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 3, 0, 10),
  [3881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_instantiation, 3, 0, 5),
  [3883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_instantiation, 3, 0, 5),
  [3885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_declaration, 3, 0, 59),
  [3887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_declaration, 3, 0, 59),
  [3889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_declaration, 5, 0, 136),
  [3891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_declaration, 5, 0, 136),
  [3893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 3, 0, 37),
  [3895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 3, 0, 37),
  [3897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [3899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [3901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, 0, 62),
  [3903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, 0, 62),
  [3905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 5, 0, 143),
  [3907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 5, 0, 143),
  [3909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 5, 0, 144),
  [3911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 5, 0, 144),
  [3913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, 0, 48),
  [3915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, 0, 48),
  [3917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10626),
  [3919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 2, 0, 26),
  [3921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 2, 0, 26),
  [3923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_alias_definition, 5, 0, 169),
  [3925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_alias_definition, 5, 0, 169),
  [3927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_alias_definition, 5, 0, 170),
  [3929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_alias_definition, 5, 0, 170),
  [3931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_assert_declaration, 5, 0, 171),
  [3933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_assert_declaration, 5, 0, 171),
  [3935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concept_definition, 5, 0, 10),
  [3937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concept_definition, 5, 0, 10),
  [3939] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(679),
  [3942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 176),
  [3944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 176),
  [3946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10626),
  [3949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_definition, 2, 0, 25),
  [3951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_definition, 2, 0, 25),
  [3953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 181),
  [3955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 181),
  [3957] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(824),
  [3960] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(11462),
  [3963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_declaration, 5, 0, 0),
  [3965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_declaration, 5, 0, 0),
  [3967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 2, 0, 3),
  [3969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 2, 0, 3),
  [3971] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__block_item, 1, 0, 0), REDUCE(sym_statement, 1, 0, 0),
  [3974] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__block_item, 1, 0, 0), REDUCE(sym_statement, 1, 0, 0),
  [3977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 6, 0, 183),
  [3979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 6, 0, 183),
  [3981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10719),
  [3983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 5, 0, 182),
  [3985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 5, 0, 182),
  [3987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 49),
  [3989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 49),
  [3991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 98),
  [3993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 98),
  [3995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 20),
  [3997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, 0, 20),
  [3999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 20), SHIFT(672),
  [4002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, 0, 9),
  [4004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, 0, 9),
  [4006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [4008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 50),
  [4010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 50),
  [4012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 9),
  [4014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 9),
  [4016] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(3135),
  [4019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [4021] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(2425),
  [4024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0),
  [4026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(8586),
  [4029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_statement, 1, 0, 0),
  [4031] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(9573),
  [4034] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(11288),
  [4037] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(10670),
  [4040] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 20), SHIFT(284),
  [4043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 104),
  [4045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 104),
  [4047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 46),
  [4049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 46),
  [4051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, -1, 35),
  [4053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 35),
  [4055] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 35), SHIFT(666),
  [4058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 101),
  [4060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 101),
  [4062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 4, 0, 45),
  [4064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 4, 0, 45),
  [4066] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 4, 0, 45), SHIFT(284),
  [4069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [4071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 4, -1, 76),
  [4073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 4, -1, 76),
  [4075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 4, -1, 76), SHIFT(284),
  [4078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 2),
  [4080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 2),
  [4082] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 2), SHIFT(672),
  [4085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 148),
  [4087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 148),
  [4089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 1, 0, 11),
  [4091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 1, 0, 11),
  [4093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 18),
  [4095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, -1, 18),
  [4097] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 18), SHIFT(672),
  [4100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, -1, 35),
  [4102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 35),
  [4104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 35), SHIFT(284),
  [4107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 48),
  [4109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 48),
  [4111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 20),
  [4113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 20),
  [4115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 20), SHIFT(642),
  [4118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 35), SHIFT(680),
  [4121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [4124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [4127] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT(284),
  [4131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(3135),
  [4134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [4136] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(2425),
  [4139] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(8586),
  [4142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(9573),
  [4145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(11288),
  [4148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(10670),
  [4151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(672),
  [4154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 96),
  [4156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 96),
  [4158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 2), SHIFT(284),
  [4161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 35), SHIFT(672),
  [4164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 45),
  [4166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, 0, 45),
  [4168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 45), SHIFT(691),
  [4171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 20), SHIFT(649),
  [4174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 4, 0, 149),
  [4176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 4, 0, 149),
  [4178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 76),
  [4180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, -1, 76),
  [4182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 76), SHIFT(692),
  [4185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 0),
  [4187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, 0, 0),
  [4189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 0), SHIFT(672),
  [4192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 4, 0, 45), SHIFT(672),
  [4195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 4, -1, 76), SHIFT(672),
  [4198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 46),
  [4200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 46),
  [4202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 45), SHIFT(658),
  [4205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 0), SHIFT(284),
  [4208] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT(672),
  [4212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 76), SHIFT(661),
  [4215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 2, 0, 0),
  [4217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(3135),
  [4220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [4222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(2425),
  [4225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(8586),
  [4228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(9573),
  [4231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(11288),
  [4234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(10670),
  [4237] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 18), SHIFT(284),
  [4240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alignas_qualifier, 4, 0, 0),
  [4242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alignas_qualifier, 4, 0, 0),
  [4244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_type, 2, -1, 0),
  [4246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_type, 2, -1, 0),
  [4248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_specifier, 4, 0, 0),
  [4250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_specifier, 4, 0, 0),
  [4252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associatedtype_specifier, 3, 0, 0),
  [4254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associatedtype_specifier, 3, 0, 0),
  [4256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0), REDUCE(sym__class_name, 1, 0, 0),
  [4259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4220),
  [4261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4225),
  [4263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_expression_statement, 1, 0, 0),
  [4265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_expression_statement, 1, 0, 0),
  [4267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4, 0, 56),
  [4269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4, 0, 56),
  [4271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__top_level_item, 1, 0, 0), REDUCE(sym__top_level_statement, 1, 0, 0),
  [4274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__top_level_item, 1, 0, 0), REDUCE(sym__top_level_statement, 1, 0, 0),
  [4277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_expression_statement, 2, 0, 0),
  [4279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_expression_statement, 2, 0, 0),
  [4281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 5, 0, 47),
  [4283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 5, 0, 47),
  [4285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 5, 0, 164),
  [4287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 5, 0, 164),
  [4289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 5, 0, 109),
  [4291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 5, 0, 109),
  [4293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 5, 0, 47),
  [4295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 5, 0, 47),
  [4297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 5, 0, 110),
  [4299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 5, 0, 110),
  [4301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 5, 0, 111),
  [4303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 5, 0, 111),
  [4305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, 0, 0),
  [4307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, 0, 0),
  [4309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 4, 0, 111),
  [4311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 4, 0, 111),
  [4313] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(3255),
  [4316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2057),
  [4319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(8516),
  [4322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(9363),
  [4325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, 0, 0),
  [4327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, 0, 0),
  [4329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4, 0, 10),
  [4331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4, 0, 10),
  [4333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 6, 0, 164),
  [4335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 6, 0, 164),
  [4337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_declaration, 2, 0, 0),
  [4339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_declaration, 2, 0, 0),
  [4341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_module_fragment_declaration, 2, 0, 0),
  [4343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_module_fragment_declaration, 2, 0, 0),
  [4345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_declaration, 3, 0, 0),
  [4347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_declaration, 3, 0, 0),
  [4349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 3, 0, 10),
  [4351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 3, 0, 10),
  [4353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 3, 0, 56),
  [4355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 3, 0, 56),
  [4357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3, 0, 0),
  [4359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3, 0, 0),
  [4361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 3, 0, 10),
  [4363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 3, 0, 10),
  [4365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 3, 0, 57),
  [4367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 3, 0, 57),
  [4369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_declaration, 4, 0, 0),
  [4371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_declaration, 4, 0, 0),
  [4373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 4, 0, 47),
  [4375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 4, 0, 47),
  [4377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4, 0, 109),
  [4379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4, 0, 109),
  [4381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4, 0, 47),
  [4383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4, 0, 47),
  [4385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4, 0, 57),
  [4387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4, 0, 57),
  [4389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4, 0, 110),
  [4391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4, 0, 110),
  [4393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_private_module_fragment_declaration, 4, 0, 0),
  [4395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_private_module_fragment_declaration, 4, 0, 0),
  [4397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 4, 0, 10),
  [4399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 4, 0, 10),
  [4401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2823),
  [4403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4499),
  [4405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4499),
  [4407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2662),
  [4409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8754),
  [4411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3101),
  [4413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7970),
  [4415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6316),
  [4417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3919),
  [4419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11036),
  [4421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7770),
  [4423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7770),
  [4425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7682),
  [4427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11486),
  [4429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2695),
  [4431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [4433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7343),
  [4435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3222),
  [4437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2425),
  [4439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8316),
  [4441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9756),
  [4443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9573),
  [4445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2827),
  [4447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11658),
  [4449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6972),
  [4451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1998),
  [4453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11655),
  [4455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7045),
  [4457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11675),
  [4459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11670),
  [4461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(3210),
  [4464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1158),
  [4467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2314),
  [4470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2314),
  [4473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2422),
  [4476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(514),
  [4479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2425),
  [4482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0),
  [4484] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8586),
  [4487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9756),
  [4490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(47),
  [4493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1632),
  [4496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9573),
  [4499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10064),
  [4502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10639),
  [4505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2502),
  [4508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10973),
  [4511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10366),
  [4514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1256),
  [4517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11479),
  [4520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1660),
  [4523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11535),
  [4526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11536),
  [4529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11221),
  [4532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10694),
  [4535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11608),
  [4538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2288),
  [4541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1955),
  [4544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11212),
  [4547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11235),
  [4550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11253),
  [4553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8901),
  [4556] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(5341),
  [4559] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9916),
  [4562] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9468),
  [4565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(4922),
  [4568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(4849),
  [4571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11288),
  [4574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10670),
  [4577] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10656),
  [4580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2202),
  [4583] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1993),
  [4586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1946),
  [4589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2490),
  [4592] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10650),
  [4595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2206),
  [4598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6124),
  [4601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6924),
  [4604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11610),
  [4607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7443),
  [4610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10951),
  [4612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2875),
  [4614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9434),
  [4616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1577),
  [4618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3210),
  [4620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8435),
  [4622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3197),
  [4624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8407),
  [4626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(3244),
  [4629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(834),
  [4632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(33),
  [4635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9661),
  [4638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10354),
  [4641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2461),
  [4644] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11185),
  [4647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10761),
  [4650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1251),
  [4653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10902),
  [4656] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1742),
  [4659] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11215),
  [4662] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11217),
  [4665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11138),
  [4668] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10529),
  [4671] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11508),
  [4674] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10374),
  [4677] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1906),
  [4680] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1960),
  [4683] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2462),
  [4686] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10935),
  [4689] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7448),
  [4692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11666),
  [4694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2855),
  [4696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9452),
  [4698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1579),
  [4700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11635),
  [4702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2836),
  [4704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9366),
  [4706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1582),
  [4708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11649),
  [4710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2843),
  [4712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9425),
  [4714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1578),
  [4716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 3, 0, 0),
  [4718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 3, 0, 0),
  [4720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3244),
  [4722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8400),
  [4724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(3222),
  [4727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(757),
  [4730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(58),
  [4733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9757),
  [4736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10644),
  [4739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2514),
  [4742] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11523),
  [4745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10643),
  [4748] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1259),
  [4751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11626),
  [4754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1684),
  [4757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10982),
  [4760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10992),
  [4763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10940),
  [4766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10669),
  [4769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11309),
  [4772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10652),
  [4775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1911),
  [4778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1915),
  [4781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2503),
  [4784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11337),
  [4787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7407),
  [4790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11672),
  [4792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11663),
  [4794] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(3197),
  [4797] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(478),
  [4800] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(30),
  [4803] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10141),
  [4806] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10527),
  [4809] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2237),
  [4812] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11637),
  [4815] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10525),
  [4818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1215),
  [4821] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11048),
  [4824] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1754),
  [4827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11177),
  [4830] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11564),
  [4833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11668),
  [4836] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10444),
  [4839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10815),
  [4842] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10364),
  [4845] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1894),
  [4848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1893),
  [4851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2205),
  [4854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10831),
  [4857] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7442),
  [4860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 4, 0, 0),
  [4862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 4, 0, 0),
  [4864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3242),
  [4866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3223),
  [4868] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(3242),
  [4871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10277),
  [4874] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2489),
  [4877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11531),
  [4880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10688),
  [4883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11224),
  [4886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10333),
  [4889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7410),
  [4892] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(3223),
  [4895] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1380),
  [4898] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(62),
  [4901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9858),
  [4904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10384),
  [4907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10646),
  [4910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1201),
  [4913] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11643),
  [4916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1705),
  [4919] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11539),
  [4922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11540),
  [4925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(11137),
  [4928] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10399),
  [4931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10854),
  [4934] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10470),
  [4937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1966),
  [4940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1970),
  [4943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2515),
  [4946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(10863),
  [4949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7393),
  [4952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 4, 0, 45),
  [4954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 4, 0, 45),
  [4956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2449),
  [4958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [4960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2426),
  [4962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8530),
  [4964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [4966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9395),
  [4968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1973),
  [4970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11225),
  [4972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11699),
  [4974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11728),
  [4976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8920),
  [4978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3674),
  [4980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10013),
  [4982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9438),
  [4984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3445),
  [4986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3441),
  [4988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2401),
  [4990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10763),
  [4992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2402),
  [4994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6096),
  [4996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6930),
  [4998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2952),
  [5000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2360),
  [5002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [5004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2163),
  [5006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8570),
  [5008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1940),
  [5010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3741),
  [5012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9860),
  [5014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9508),
  [5016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2340),
  [5018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10746),
  [5020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2341),
  [5022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6115),
  [5024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [5026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3141),
  [5028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2447),
  [5030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [5032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2410),
  [5034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8584),
  [5036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1899),
  [5038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4281),
  [5040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10010),
  [5042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9580),
  [5044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2354),
  [5046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10773),
  [5048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2355),
  [5050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [5052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3221),
  [5054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2353),
  [5056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [5058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9591),
  [5060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1, 0, 0), REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [5063] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration_modifiers, 1, 0, 0), REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [5066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [5068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [5070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_modifiers, 1, 0, 0),
  [5072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1, 0, 0),
  [5074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2698),
  [5076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [5078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [5080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2403),
  [5082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [5084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1435),
  [5086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8535),
  [5088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4970),
  [5090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6200),
  [5092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7941),
  [5094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6578),
  [5096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6581),
  [5098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6582),
  [5100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [5102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [5104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11308),
  [5106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11702),
  [5108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11729),
  [5110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8945),
  [5112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5976),
  [5114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9929),
  [5116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9459),
  [5118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6070),
  [5120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6117),
  [5122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5698),
  [5124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6790),
  [5126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11381),
  [5128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6281),
  [5130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5218),
  [5132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2054),
  [5134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10765),
  [5136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [5138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6095),
  [5140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6921),
  [5142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6587),
  [5144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6589),
  [5146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6797),
  [5148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [5150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6767),
  [5152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [5154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2598),
  [5156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [5158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2618),
  [5160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8582),
  [5162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1957),
  [5164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2629),
  [5166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2630),
  [5168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6769),
  [5170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [5172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6757),
  [5174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [5176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6792),
  [5178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [5180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6747),
  [5182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [5184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6765),
  [5186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2930),
  [5188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6749),
  [5190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2765),
  [5192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6780),
  [5194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [5196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6791),
  [5198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [5200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6748),
  [5202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2979),
  [5204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6760),
  [5206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [5208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6766),
  [5210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [5212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6772),
  [5214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [5216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6781),
  [5218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8437),
  [5220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6784),
  [5222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4740),
  [5224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6787),
  [5226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2957),
  [5228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6799),
  [5230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [5232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6803),
  [5234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [5236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6810),
  [5238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [5240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6806),
  [5242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3688),
  [5244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6751),
  [5246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [5248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6753),
  [5250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [5252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6756),
  [5254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4557),
  [5256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3279),
  [5258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2437),
  [5260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [5262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2390),
  [5264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8588),
  [5266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [5268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9486),
  [5270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1912),
  [5272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11379),
  [5274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11708),
  [5276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11731),
  [5278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8971),
  [5280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4543),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9973),
  [5284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9520),
  [5286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4722),
  [5288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4720),
  [5290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2196),
  [5292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10768),
  [5294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2197),
  [5296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6164),
  [5298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6923),
  [5300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6809),
  [5302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2990),
  [5304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10488),
  [5306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6779),
  [5308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10488),
  [5311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2727),
  [5313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [5315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6496),
  [5317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3255),
  [5319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2057),
  [5321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [5323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9363),
  [5325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1203),
  [5327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1282),
  [5330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [5332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2764),
  [5334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [5336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [5338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2913),
  [5340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10006),
  [5342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5304),
  [5344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [5346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [5348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6165),
  [5350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6165),
  [5352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7241),
  [5354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1507),
  [5356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3157),
  [5358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [5360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [5362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1530),
  [5364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5091),
  [5366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5094),
  [5368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5539),
  [5370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10901),
  [5372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [5374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3163),
  [5376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1531),
  [5378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1291),
  [5381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1852),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9540),
  [5385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10770),
  [5387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2443),
  [5389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [5391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2367),
  [5393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8511),
  [5395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [5397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1986),
  [5399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5253),
  [5401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10003),
  [5403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2364),
  [5405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2365),
  [5407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6084),
  [5409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6926),
  [5411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [5413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [5415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3135),
  [5417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3134),
  [5419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2439),
  [5421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [5423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2323),
  [5425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8527),
  [5427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1954),
  [5429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5489),
  [5431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9988),
  [5433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9562),
  [5435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2320),
  [5437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10332),
  [5439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2321),
  [5441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3301),
  [5443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2652),
  [5445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2652),
  [5447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2636),
  [5449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8587),
  [5451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1982),
  [5453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2654),
  [5455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2655),
  [5457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6134),
  [5459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3318),
  [5461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2590),
  [5463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [5465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2463),
  [5467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8528),
  [5469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1948),
  [5471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2592),
  [5473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2593),
  [5475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3281),
  [5477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2342),
  [5479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [5481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9543),
  [5483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_pack_expansion, 2, 0, 28),
  [5485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [5487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_pack_expansion, 2, 0, 28),
  [5489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [5491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(3281),
  [5494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2342),
  [5497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(8535),
  [5500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(9543),
  [5503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(3221),
  [5506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2353),
  [5509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(8561),
  [5512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(9591),
  [5515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2887),
  [5517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [5519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5342),
  [5521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7607),
  [5523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7607),
  [5525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8769),
  [5527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1515),
  [5529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 33), SHIFT(1281),
  [5532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2989),
  [5534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [5536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7282),
  [5538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 2, 0, 0),
  [5540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 2, 0, 0),
  [5542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [5544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [5546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 33), SHIFT(1279),
  [5549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3078),
  [5551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [5553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [5555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [5557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [5559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [5561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2616),
  [5563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2599),
  [5565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [5567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [5569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1548),
  [5571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3072),
  [5573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [5575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3113),
  [5577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11404),
  [5579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [5581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1493),
  [5583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3271),
  [5585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [5587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1501),
  [5589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4547),
  [5591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [5593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4639),
  [5595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [5597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7529),
  [5599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3177),
  [5601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [5603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1502),
  [5605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7516),
  [5607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [5609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8231),
  [5611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [5613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8126),
  [5615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [5617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8061),
  [5619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [5621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1509),
  [5623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8234),
  [5625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [5627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [5629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8085),
  [5631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [5633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [5635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7610),
  [5637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [5639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7481),
  [5641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [5643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7612),
  [5645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [5647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1525),
  [5649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7580),
  [5651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [5653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1526),
  [5655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4502),
  [5657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [5659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7597),
  [5661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [5663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4337),
  [5665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [5667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [5669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8006),
  [5671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [5673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1521),
  [5675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7532),
  [5677] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2952),
  [5680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1166),
  [5683] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2360),
  [5686] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2163),
  [5689] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(8570),
  [5692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(7343),
  [5695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1168),
  [5698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2317),
  [5701] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2162),
  [5704] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2162),
  [5707] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(3318),
  [5710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1173),
  [5713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2590),
  [5716] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2590),
  [5719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2463),
  [5722] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(8528),
  [5725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2591),
  [5728] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1948),
  [5731] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(11212),
  [5734] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(11235),
  [5737] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(11253),
  [5740] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(8901),
  [5743] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(5341),
  [5746] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(9916),
  [5749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(9468),
  [5752] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(4922),
  [5755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(4849),
  [5758] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2592),
  [5761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(10650),
  [5764] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2593),
  [5767] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6134),
  [5770] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6924),
  [5773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [5775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2309),
  [5777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [5779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [5781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [5783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2829),
  [5785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6742),
  [5787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6743),
  [5789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6637),
  [5791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6658),
  [5793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6659),
  [5795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6660),
  [5797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6600),
  [5799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6601),
  [5801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6603),
  [5803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6663),
  [5805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6664),
  [5807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6668),
  [5809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6693),
  [5811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6695),
  [5813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6709),
  [5815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6648),
  [5817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6654),
  [5819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6665),
  [5821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6706),
  [5823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6707),
  [5825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6708),
  [5827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6698),
  [5829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6699),
  [5831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6700),
  [5833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6590),
  [5835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6592),
  [5837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6593),
  [5839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6718),
  [5841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6719),
  [5843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6720),
  [5845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6710),
  [5847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6636),
  [5849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6729),
  [5851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6583),
  [5853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6602),
  [5855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6610),
  [5857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6580),
  [5859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6611),
  [5861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6619),
  [5863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6724),
  [5865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6725),
  [5867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6726),
  [5869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3675),
  [5871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [5873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4895),
  [5875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8591),
  [5877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3165),
  [5879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11593),
  [5881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4605),
  [5883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [5885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4799),
  [5887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11078),
  [5889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4854),
  [5891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [5893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [5895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3431),
  [5897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11231),
  [5899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6072),
  [5901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5140),
  [5903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7158),
  [5905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4648),
  [5907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7184),
  [5909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6973),
  [5911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6962),
  [5913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11386),
  [5915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3408),
  [5917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4623),
  [5919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3889),
  [5921] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(3135),
  [5924] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1158),
  [5927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(2314),
  [5930] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(2314),
  [5933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(2422),
  [5936] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(3675),
  [5939] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(2425),
  [5942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(8586),
  [5945] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(2040),
  [5948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0),
  [5950] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(7343),
  [5953] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(9573),
  [5956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(2288),
  [5959] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1955),
  [5962] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(11212),
  [5965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(11235),
  [5968] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(11253),
  [5971] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(8901),
  [5974] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(5341),
  [5977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(9916),
  [5980] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(9468),
  [5983] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(4922),
  [5986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(4849),
  [5989] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(11288),
  [5992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(8591),
  [5995] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(10670),
  [5998] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(2202),
  [6001] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(10650),
  [6004] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(2206),
  [6007] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(6124),
  [6010] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(6924),
  [6013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4272),
  [6015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4829),
  [6017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11302),
  [6019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4750),
  [6021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5144),
  [6023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4757),
  [6025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4805),
  [6027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [6029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4884),
  [6031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10049),
  [6033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10912),
  [6035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4552),
  [6037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4836),
  [6039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4644),
  [6041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4671),
  [6043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10187),
  [6045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11495),
  [6047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4863),
  [6049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9773),
  [6051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11632),
  [6053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4825),
  [6055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3466),
  [6057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6102),
  [6059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6094),
  [6061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3415),
  [6063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4667),
  [6065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9764),
  [6067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10937),
  [6069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3283),
  [6071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10996),
  [6073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [6075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [6077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7012),
  [6079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10403),
  [6081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6067),
  [6083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3194),
  [6085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6403),
  [6087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5820),
  [6089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9544),
  [6091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2681),
  [6093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10553),
  [6095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10553),
  [6098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10179),
  [6100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4413),
  [6102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9655),
  [6104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4627),
  [6106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 2, 0, 0),
  [6108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9875),
  [6110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [6112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__requirement_clause_constraint, 3, 0, 0),
  [6114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__requirement_clause_constraint, 3, 0, 0),
  [6116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [6120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requirement_seq, 2, 0, 0),
  [6122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requirement_seq, 2, 0, 0),
  [6124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_expression, 3, 0, 67),
  [6126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_expression, 3, 0, 67),
  [6128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, 0, 73),
  [6130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, 0, 73),
  [6132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4617),
  [6134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [6136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, 0, 74),
  [6138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, 0, 74),
  [6140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 68),
  [6142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 68),
  [6144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint_conjunction, 3, 0, 55),
  [6146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_conjunction, 3, 0, 55),
  [6148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 193),
  [6150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 193),
  [6152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 194),
  [6154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 194),
  [6156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requirement_seq, 3, 0, 0),
  [6158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requirement_seq, 3, 0, 0),
  [6160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 4, 0, 126),
  [6162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 4, 0, 126),
  [6164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 4, 0, 127),
  [6166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 4, 0, 127),
  [6168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3489),
  [6170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 5, 0, 179),
  [6172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 5, 0, 179),
  [6174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [6176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 130),
  [6178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 130),
  [6180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5130),
  [6182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 80),
  [6184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 80),
  [6186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, 0, 131),
  [6188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, 0, 131),
  [6190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_declaration, 5, 0, 216),
  [6192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_declaration, 5, 0, 216),
  [6194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_declaration, 5, 0, 217),
  [6196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_declaration, 5, 0, 217),
  [6198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [6200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11121),
  [6202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1943),
  [6204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11126),
  [6206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, 0, 58),
  [6208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, 0, 58),
  [6210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 5, 0, 217),
  [6212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, 0, 217),
  [6214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declaration_list_item, 2, 0, 0),
  [6216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_list_item, 2, 0, 0),
  [6218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 207),
  [6220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 207),
  [6222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 68),
  [6224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 68),
  [6226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 219),
  [6228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 219),
  [6230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 193),
  [6232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 193),
  [6234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [6236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 220),
  [6238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 220),
  [6240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4670),
  [6242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 194),
  [6244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 194),
  [6246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, 0, 183),
  [6248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, 0, 183),
  [6250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6075),
  [6252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_declaration, 6, 0, 229),
  [6254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_declaration, 6, 0, 229),
  [6256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 6, 0, 230),
  [6258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, 0, 230),
  [6260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 6, 0, 229),
  [6262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, 0, 229),
  [6264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 207),
  [6266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 207),
  [6268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 231),
  [6270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 231),
  [6272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4892),
  [6274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [6276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3419),
  [6278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 219),
  [6280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 219),
  [6282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [6284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3286),
  [6286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10978),
  [6288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_default_capture, 1, 0, 0),
  [6290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, 0, 80),
  [6292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, 0, 80),
  [6294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 220),
  [6296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 220),
  [6298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_expression, 2, 0, 21),
  [6300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_expression, 2, 0, 21),
  [6302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 2, 0, 32),
  [6304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 2, 0, 32),
  [6306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 7, 0, 237),
  [6308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 7, 0, 237),
  [6310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 7, 0, 231),
  [6312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 7, 0, 231),
  [6314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 81),
  [6316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 81),
  [6318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 10),
  [6320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 10),
  [6322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fold_expression, 3, 0, 40),
  [6324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fold_expression, 3, 0, 40),
  [6326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11653),
  [6328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1974),
  [6330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11660),
  [6332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10532),
  [6334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11169),
  [6336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1892),
  [6338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11183),
  [6340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, 0, 10),
  [6342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, 0, 10),
  [6344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_declaration, 4, 0, 192),
  [6346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_declaration, 4, 0, 192),
  [6348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_init_declaration, 3, 0, 0),
  [6350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_declaration, 3, 0, 0),
  [6352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associatedtype_declaration, 3, 0, 112),
  [6354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associatedtype_declaration, 3, 0, 112),
  [6356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 58),
  [6358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 58),
  [6360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 68),
  [6362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 68),
  [6364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associatedtype_declaration, 4, 0, 112),
  [6366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associatedtype_declaration, 4, 0, 112),
  [6368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_method_definition, 3, 0, 69),
  [6370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_method_definition, 3, 0, 69),
  [6372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_method_definition, 3, 0, 68),
  [6374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_method_definition, 3, 0, 68),
  [6376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [6378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10416),
  [6380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10594),
  [6382] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10806),
  [6385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10960),
  [6388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4717),
  [6390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10810),
  [6393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4551),
  [6395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(11149),
  [6398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10845),
  [6401] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10594),
  [6404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10846),
  [6407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(11128),
  [6410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10852),
  [6413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10878),
  [6416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(11548),
  [6419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10416),
  [6422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(11679),
  [6425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [6427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 201),
  [6429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [6431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2451),
  [6433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2164),
  [6435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 107),
  [6437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(11250),
  [6440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2225),
  [6442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2168),
  [6444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2337),
  [6446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [6448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 80),
  [6450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2381),
  [6452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [6454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2211),
  [6456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 2, 1, 107),
  [6458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2482),
  [6460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [6462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2243),
  [6464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [6466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2634),
  [6468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 2, 1, 0),
  [6470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 157),
  [6472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2650),
  [6474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2096),
  [6476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2358),
  [6478] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(11392),
  [6481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [6483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7220),
  [6485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [6487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [6489] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(11262),
  [6492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(11083),
  [6495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10903),
  [6498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10909),
  [6501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11236),
  [6503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [6505] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10933),
  [6508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8060),
  [6510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10897),
  [6513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8290),
  [6515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10848),
  [6518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10889),
  [6521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [6523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3292),
  [6525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6953),
  [6527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11315),
  [6529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [6531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [6533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11384),
  [6535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [6537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7485),
  [6539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [6541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8190),
  [6543] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(11132),
  [6546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(11145),
  [6549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(11159),
  [6552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(11170),
  [6555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8059),
  [6557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4518),
  [6559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3321),
  [6561] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(11147),
  [6564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7620),
  [6566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(11561),
  [6569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(11012),
  [6572] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(11572),
  [6575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7475),
  [6577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(11191),
  [6580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [6582] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(11211),
  [6585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [6587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(11698),
  [6590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [6592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7563),
  [6594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11704),
  [6596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [6598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7596),
  [6600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(11726),
  [6603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4548),
  [6605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [6607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [6609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4336),
  [6611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [6613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [6615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8125),
  [6617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7479),
  [6619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11356),
  [6621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [6623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [6625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7566),
  [6627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [6629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4346),
  [6631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(11156),
  [6634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [6636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [6638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(11513),
  [6641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7528),
  [6643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8158),
  [6645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [6647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10924),
  [6649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [6651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [6653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(11187),
  [6656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [6658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7291),
  [6660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7310),
  [6662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7234),
  [6664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7237),
  [6666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7242),
  [6668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7265),
  [6670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7266),
  [6672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7268),
  [6674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7214),
  [6676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7226),
  [6678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4719),
  [6680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7287),
  [6682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3138),
  [6684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3161),
  [6686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7223),
  [6688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7212),
  [6690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7286),
  [6692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7306),
  [6694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3133),
  [6696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7235),
  [6698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7259),
  [6700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7262),
  [6702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7301),
  [6704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7293),
  [6706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7292),
  [6708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7354),
  [6710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7355),
  [6712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7359),
  [6714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7358),
  [6716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2906),
  [6718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8643),
  [6720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2738),
  [6722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3010),
  [6724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2955),
  [6726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10898),
  [6728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7190),
  [6730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10060),
  [6732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10900),
  [6734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11223),
  [6736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2954),
  [6738] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2719),
  [6741] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(11378),
  [6744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [6746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameter_list, 2, 0, 0),
  [6748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter_list, 2, 0, 0),
  [6750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameter_list, 4, 0, 0),
  [6752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter_list, 4, 0, 0),
  [6754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameter_list, 3, 0, 0),
  [6756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter_list, 3, 0, 0),
  [6758] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1279),
  [6761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0),
  [6763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3086),
  [6765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9399),
  [6767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10759),
  [6769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2732),
  [6772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(11448),
  [6775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2693),
  [6778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1285),
  [6781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_clause, 2, 0, 22),
  [6783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_clause, 2, 0, 22),
  [6785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6978),
  [6787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6979),
  [6789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6978),
  [6791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6979),
  [6793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1288),
  [6796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5231),
  [6798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [6800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1858),
  [6802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9533),
  [6804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10769),
  [6806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint_disjunction, 3, 0, 55),
  [6808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_disjunction, 3, 0, 55),
  [6810] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(2744),
  [6813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(2719),
  [6816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2734),
  [6818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(11378),
  [6821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2768),
  [6823] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(2751),
  [6826] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(2719),
  [6829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2752),
  [6831] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(11378),
  [6834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2746),
  [6836] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2726),
  [6839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1304),
  [6842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3319),
  [6844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2732),
  [6846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2780),
  [6848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11448),
  [6850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3317),
  [6852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3270),
  [6854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3272),
  [6856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3266),
  [6858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [6860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(3175),
  [6863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2779),
  [6865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3174),
  [6867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(3181),
  [6870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3182),
  [6872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3180),
  [6874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2762),
  [6876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2745),
  [6878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2760),
  [6880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2761),
  [6882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2762),
  [6885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2759),
  [6887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2743),
  [6889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 3, 0, 20),
  [6891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 3, 0, 20),
  [6893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2772),
  [6895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_class_specifier, 1, 0, 0),
  [6897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_class_specifier, 1, 0, 0),
  [6899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9478),
  [6901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0),
  [6903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0),
  [6905] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2738),
  [6908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2772),
  [6911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2955),
  [6914] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(10898),
  [6917] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(10060),
  [6920] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(10900),
  [6923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(11223),
  [6926] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2954),
  [6929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, 0, 2),
  [6931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, 0, 2),
  [6933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3397),
  [6935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2845),
  [6937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3405),
  [6939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11441),
  [6941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3383),
  [6943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3453),
  [6945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2818),
  [6947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3451),
  [6949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 1, 0, 2),
  [6951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 1, 0, 2),
  [6953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [6955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2773),
  [6957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6311),
  [6959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2867),
  [6961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [6963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8171),
  [6965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [6967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [6969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [6971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3508),
  [6973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2907),
  [6975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2889),
  [6977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11471),
  [6979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3507),
  [6981] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2845),
  [6984] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(11441),
  [6987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3512),
  [6989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3513),
  [6991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3511),
  [6993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [6995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [6997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6265),
  [6999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [7001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [7003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [7005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [7007] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2912),
  [7010] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(11349),
  [7013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [7015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [7017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [7019] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2907),
  [7022] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(11471),
  [7025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, 0, 20),
  [7027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, 0, 20),
  [7029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2769),
  [7031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [7033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [7035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [7037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [7039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [7041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [7043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [7045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3559),
  [7047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2959),
  [7049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2935),
  [7051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11468),
  [7053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3555),
  [7055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3542),
  [7057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3543),
  [7059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3541),
  [7061] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2828),
  [7064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [7066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hlsl_attribute, 3, 0, 0),
  [7068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hlsl_attribute, 3, 0, 0),
  [7070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_designator, 3, 0, 0),
  [7072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_designator, 3, 0, 0),
  [7074] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1),
  [7077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1570),
  [7079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1575),
  [7081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8641),
  [7083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1572),
  [7085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1573),
  [7087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1583),
  [7089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8656),
  [7091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8719),
  [7093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1581),
  [7095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4213),
  [7097] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2959),
  [7100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(11468),
  [7103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1576),
  [7105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_declspec_modifier, 4, 0, 0),
  [7107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_declspec_modifier, 4, 0, 0),
  [7109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2878),
  [7112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2881),
  [7115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(1664),
  [7118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [7120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4234),
  [7122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8758),
  [7124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4236),
  [7126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2663),
  [7129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2906),
  [7132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2914),
  [7135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(10836),
  [7138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(9856),
  [7141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(11064),
  [7144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(10916),
  [7147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2916),
  [7150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2, 0, 0),
  [7152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2, 0, 0),
  [7154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_declaration, 2, 0, 112),
  [7156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6346),
  [7158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3, 0, 0),
  [7160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3, 0, 0),
  [7162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualifiers, 1, 0, 0),
  [7164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualifiers, 1, 0, 0),
  [7166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7735),
  [7168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__constructor_specifiers, 1, 0, 0), REDUCE(aux_sym__declaration_specifiers_repeat1, 1, 0, 0),
  [7171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constructor_specifiers, 1, 0, 0),
  [7173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__constructor_specifiers, 1, 0, 0),
  [7175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__constructor_specifiers, 1, 0, 0), REDUCE(aux_sym__declaration_specifiers_repeat1, 1, 0, 0),
  [7178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 1, 0, 0),
  [7180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2939),
  [7183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7702),
  [7185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1286),
  [7188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2987),
  [7190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [7192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [7194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_clause, 4, 0, 152),
  [7196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_clause, 4, 0, 152),
  [7198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_clause, 3, 0, 14),
  [7200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_clause, 3, 0, 14),
  [7202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2984),
  [7205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [7207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [7209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(9438),
  [7212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(10763),
  [7215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2984),
  [7217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 3, 0, 0),
  [7219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 3, 0, 0),
  [7221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0),
  [7223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0),
  [7225] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2738),
  [7228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(3010),
  [7231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2955),
  [7234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(10898),
  [7237] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(10060),
  [7240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(10900),
  [7243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(11223),
  [7246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(3448),
  [7249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2954),
  [7252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7488),
  [7254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11403),
  [7256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [7258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 33), SHIFT(1295),
  [7261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 33), SHIFT(1285),
  [7264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3080),
  [7266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2912),
  [7268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3127),
  [7270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11349),
  [7272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3079),
  [7274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(4510),
  [7277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3116),
  [7279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4509),
  [7281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(4514),
  [7284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4515),
  [7286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4513),
  [7288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 5, 0, 0),
  [7290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 5, 0, 0),
  [7292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0),
  [7294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0),
  [7296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(3113),
  [7299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(3072),
  [7302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(11404),
  [7305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3082),
  [7307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3090),
  [7309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3097),
  [7311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 7, 0, 228),
  [7313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 7, 0, 228),
  [7315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1302),
  [7318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1877),
  [7320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [7322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [7324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3089),
  [7326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [7328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [7330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0),
  [7332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2881),
  [7334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 33), SHIFT(1286),
  [7337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6355),
  [7339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34), SHIFT(1286),
  [7342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [7344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [7346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11348),
  [7348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11348),
  [7350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [7352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7586),
  [7354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 45),
  [7356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 45),
  [7358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [7360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [7362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3206),
  [7364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2744),
  [7366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3050),
  [7368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 92),
  [7370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 92),
  [7372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, 0, 20),
  [7374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, 0, 20),
  [7376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 65),
  [7378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 65),
  [7380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2751),
  [7382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3173),
  [7384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8152),
  [7386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string, 1, 0, 0),
  [7388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string, 1, 0, 0),
  [7390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_call_modifier, 1, 0, 0),
  [7392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_call_modifier, 1, 0, 0),
  [7394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7669),
  [7396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 1, 1, 0),
  [7398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [7400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5288),
  [7402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5288),
  [7404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 1, 1, 0),
  [7406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7400),
  [7408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [7410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 0),
  [7412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 0),
  [7414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8074),
  [7416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructor_name, 2, 0, 0),
  [7418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructor_name, 2, 0, 0),
  [7420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1851),
  [7422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [7424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9594),
  [7426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10774),
  [7428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [7430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2773),
  [7432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2955),
  [7434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10898),
  [7436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10900),
  [7438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11223),
  [7440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6237),
  [7442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2867),
  [7444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2954),
  [7446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9319),
  [7448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10775),
  [7450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3316),
  [7452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3154),
  [7454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2769),
  [7456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3154),
  [7459] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(9319),
  [7462] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(10775),
  [7465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4974),
  [7467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3356),
  [7469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3326),
  [7471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11465),
  [7473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4971),
  [7475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_expression, 1, 0, 0),
  [7478] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1281),
  [7481] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_expression, 1, 0, 0),
  [7484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3144),
  [7486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4954),
  [7488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4956),
  [7490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4952),
  [7492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1853),
  [7494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 5, 1, 175),
  [7496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 5, 1, 175),
  [7498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [7500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9953),
  [7502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1497),
  [7504] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(3169),
  [7507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [7509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5371),
  [7511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5371),
  [7513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3169),
  [7515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3178),
  [7517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3179),
  [7519] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3356),
  [7522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(11465),
  [7525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11055),
  [7527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(8162),
  [7530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [7532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [7534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3184),
  [7536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3185),
  [7538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3172),
  [7540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3243),
  [7542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(10455),
  [7545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__lambda_capture_identifier, 1, 0, 0), SHIFT(11055),
  [7548] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__lambda_capture_identifier, 1, 0, 0), SHIFT(8162),
  [7552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1881),
  [7554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 3, 1, 41),
  [7556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 3, 1, 41),
  [7558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_type_declarator, 2, 1, 0),
  [7560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_type_declarator, 2, 1, 0),
  [7562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [7564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5388),
  [7566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5388),
  [7568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7735),
  [7570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 2, 1, 5),
  [7572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 2, 1, 5),
  [7574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3193),
  [7576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3243),
  [7579] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(9399),
  [7582] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(10759),
  [7585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 4, 1, 86),
  [7587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 4, 1, 86),
  [7589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1298),
  [7592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [7594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_type_declarator, 2, 0, 0),
  [7596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_type_declarator, 2, 0, 0),
  [7598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3268),
  [7600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9553),
  [7602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10771),
  [7604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2726),
  [7606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7717),
  [7608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [7610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type_declarator, 3, -10, 0),
  [7612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 3, -10, 0),
  [7614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3276),
  [7616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [7618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 3, 0, 26),
  [7620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 3, 0, 26),
  [7622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 43),
  [7624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 43),
  [7626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type_declarator, 2, 0, 88),
  [7628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type_declarator, 2, 0, 88),
  [7630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3314),
  [7632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3276),
  [7635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(9553),
  [7638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(10771),
  [7641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 0),
  [7643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 0),
  [7645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1295),
  [7648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0),
  [7650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(9953),
  [7653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_capture_identifier, 1, 0, 0),
  [7655] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__lambda_capture_identifier, 1, 0, 0),
  [7658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 64),
  [7660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 64),
  [7662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 42),
  [7664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 42),
  [7666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_capture_identifier, 2, 0, 0),
  [7668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__lambda_capture_identifier, 2, 0, 0),
  [7671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 91),
  [7673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 91),
  [7675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type_declarator, 4, -10, 0),
  [7677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 4, -10, 0),
  [7679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, 0, 121),
  [7681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, 0, 121),
  [7683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 115),
  [7685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 115),
  [7687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1885),
  [7689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [7691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, 0, 26),
  [7693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, 0, 26),
  [7695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 139),
  [7697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 139),
  [7699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 1),
  [7701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 1),
  [7703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3262),
  [7705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [7707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 5, 0, 177),
  [7709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 5, 0, 177),
  [7711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3439),
  [7713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_declarator, 3, 0, 172),
  [7715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_declarator, 3, 0, 172),
  [7717] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(3327),
  [7720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11377),
  [7722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11377),
  [7724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [7726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 123),
  [7728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_field_identifier, 2, 1, 123),
  [7730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 123), SHIFT(1286),
  [7733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_method, 2, 0, 122),
  [7735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_method, 2, 0, 122),
  [7737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 71),
  [7739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, 1, 71),
  [7741] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 71), SHIFT(1286),
  [7744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3374),
  [7746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [7748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [7750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [7752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [7754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3340),
  [7757] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(9540),
  [7760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(10770),
  [7763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 0, 33),
  [7765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_field_identifier, 2, 0, 33),
  [7767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7643),
  [7769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11403),
  [7771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 55),
  [7773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 55),
  [7775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [7777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3450),
  [7779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7776),
  [7781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7776),
  [7783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 75),
  [7785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_identifier, 3, 0, 75),
  [7787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 75), SHIFT(1286),
  [7790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_method, 2, 0, 17),
  [7792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_method, 2, 0, 17),
  [7794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, 0, 85),
  [7796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, 0, 85),
  [7798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_name, 2, 0, 0),
  [7800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_name, 2, 0, 0),
  [7802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3435),
  [7804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 4),
  [7806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 4),
  [7808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11457),
  [7810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11457),
  [7812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [7814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [7816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [7818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_field_identifier, 2, 0, 0),
  [7820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_field_identifier, 2, 0, 0),
  [7822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_declarator, 4, 0, 172),
  [7824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_declarator, 4, 0, 172),
  [7826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_await_expression, 2, 0, 4),
  [7828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_await_expression, 2, 0, 4),
  [7830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7701),
  [7832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [7834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [7836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 4),
  [7838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 4),
  [7840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3340),
  [7842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 40),
  [7844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 40),
  [7846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_expression, 2, 0, 4),
  [7848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_expression, 2, 0, 4),
  [7850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3506),
  [7852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 2, 0, 14),
  [7854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 2, 0, 14),
  [7856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 4, 0, 108),
  [7858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 4, 0, 108),
  [7860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 7, 0, 225),
  [7862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 7, 0, 225),
  [7864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3391),
  [7866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_literal_expression, 4, 0, 85),
  [7868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_literal_expression, 4, 0, 85),
  [7870] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34), SHIFT(1285),
  [7873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 90),
  [7875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 90),
  [7877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_literal_expression, 2, 0, 8),
  [7879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_literal_expression, 2, 0, 8),
  [7881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_offsetof_expression, 6, 0, 202),
  [7883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_offsetof_expression, 6, 0, 202),
  [7885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 6, 0, 204),
  [7887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 6, 0, 204),
  [7889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2828),
  [7891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [7893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 6, 0, 205),
  [7895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 6, 0, 205),
  [7897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_user_defined_literal, 2, 0, 0),
  [7899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_user_defined_literal, 2, 0, 0),
  [7901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3393),
  [7903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 3, 0, 0),
  [7905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 3, 0, 0),
  [7907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_argument_list, 3, 0, 0),
  [7909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_argument_list, 3, 0, 0),
  [7911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, 0, 55),
  [7913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 55),
  [7915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 5, 0, 163),
  [7917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 5, 0, 163),
  [7919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 8, 0, 0),
  [7921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 8, 0, 0),
  [7923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_argument_list, 2, 0, 0),
  [7925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_argument_list, 2, 0, 0),
  [7927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 8, 0, 235),
  [7929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 8, 0, 235),
  [7931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 8, 0, 236),
  [7933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 8, 0, 236),
  [7935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 63),
  [7937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 63),
  [7939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 4, 0, 0),
  [7941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 4, 0, 0),
  [7943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alignof_expression, 4, 0, 45),
  [7945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alignof_expression, 4, 0, 45),
  [7947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, 0, 7),
  [7949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, 0, 7),
  [7951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [7953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [7955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 6, 0, 186),
  [7957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 6, 0, 186),
  [7959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6995),
  [7961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6996),
  [7963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6995),
  [7965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6996),
  [7967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 113),
  [7969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 113),
  [7971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 114),
  [7973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 114),
  [7975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 9, 0, 0),
  [7977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 9, 0, 0),
  [7979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 173),
  [7981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 173),
  [7983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 9, 0, 240),
  [7985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 9, 0, 240),
  [7987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 2, 0, 30),
  [7989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 2, 0, 30),
  [7991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, 0, 72),
  [7993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, 0, 72),
  [7995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_name, 3, 0, 0),
  [7997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_name, 3, 0, 0),
  [7999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7421),
  [8001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_null, 1, 0, 0),
  [8003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_null, 1, 0, 0),
  [8005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 138),
  [8007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 138),
  [8009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_argument_list, 4, 0, 0),
  [8011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_argument_list, 4, 0, 0),
  [8013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_function_specifier, 1, 0, 0),
  [8015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [8017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_function_specifier, 1, 0, 0),
  [8019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 137),
  [8021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 137),
  [8023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 29),
  [8025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 29),
  [8027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3429),
  [8029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3446),
  [8031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 5, 0, 160),
  [8033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 5, 0, 160),
  [8035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_function_specifier, 4, 0, 0),
  [8037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_function_specifier, 4, 0, 0),
  [8039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_identifier, 2, 0, 0),
  [8041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_identifier, 2, 0, 0),
  [8043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 5, 0, 0),
  [8045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 5, 0, 0),
  [8047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3395),
  [8049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 5, 0, 162),
  [8051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 5, 0, 162),
  [8053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 0),
  [8055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 0),
  [8057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 0),
  [8059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 0),
  [8061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 7, 0, 226),
  [8063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 7, 0, 226),
  [8065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7691),
  [8067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8019),
  [8069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34), SHIFT(1295),
  [8072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11452),
  [8074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11452),
  [8076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [8078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [8080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3553),
  [8082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2878),
  [8084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3509),
  [8086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3510),
  [8088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [8090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3517),
  [8092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3504),
  [8094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6277),
  [8096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3206),
  [8098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7700),
  [8100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8017),
  [8102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3531),
  [8104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3526),
  [8106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 0),
  [8108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 0),
  [8110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3531),
  [8113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(9357),
  [8116] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(10756),
  [8119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23),
  [8121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6931),
  [8123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6931),
  [8125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4694),
  [8127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11306),
  [8129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11306),
  [8131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9928),
  [8133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 23),
  [8135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4694),
  [8137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11426),
  [8139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8964),
  [8141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8964),
  [8143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4198),
  [8145] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(7519),
  [8148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6947),
  [8150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11059),
  [8152] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(6960),
  [8155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(4094),
  [8158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3545),
  [8160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3546),
  [8162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2939),
  [8164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3550),
  [8166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [8168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7519),
  [8170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6960),
  [8172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3907),
  [8174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3565),
  [8176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34), SHIFT(1298),
  [8179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6295),
  [8181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3566),
  [8183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [8185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [8187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3782),
  [8189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7683),
  [8191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8073),
  [8193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(11306),
  [8196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(11306),
  [8199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(9928),
  [8202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4170),
  [8204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7024),
  [8206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3970),
  [8208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(7586),
  [8211] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(7024),
  [8214] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(4009),
  [8217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [8219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2427),
  [8221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2428),
  [8223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2431),
  [8225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2432),
  [8227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2433),
  [8229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [8231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2435),
  [8233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2435),
  [8235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2436),
  [8237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [8239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2434),
  [8241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2357),
  [8243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4000),
  [8245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3939),
  [8247] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(3891),
  [8250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extension_expression, 2, 0, 0),
  [8252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_expression, 2, 0, 0),
  [8254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [8256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [8258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2429),
  [8260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2430),
  [8262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 2, 0, 0),
  [8264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 2, 0, 0),
  [8266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 4, 0, 124),
  [8268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3433),
  [8270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 4, 0, 124),
  [8272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [8274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, 0, 178),
  [8276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, 0, 178),
  [8278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [8280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [8282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3806),
  [8284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 3, 0, 0),
  [8286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 3, 0, 0),
  [8288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 5, 0, 0),
  [8290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 5, 0, 0),
  [8292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 4, 0, 0),
  [8294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 4, 0, 0),
  [8296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_requirement, 6, 0, 0),
  [8298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_requirement, 6, 0, 0),
  [8300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__requirement, 1, 0, 66),
  [8302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__requirement, 1, 0, 66),
  [8304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_requirement, 4, 0, 0),
  [8306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_requirement, 4, 0, 0),
  [8308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3396),
  [8310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3902),
  [8312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(7009),
  [8315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(3940),
  [8318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_requirement, 5, 0, 0),
  [8320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_requirement, 5, 0, 0),
  [8322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_requirement, 2, 0, 0),
  [8324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_requirement, 2, 0, 0),
  [8326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7009),
  [8328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4186),
  [8330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char_literal, 3, 0, 0),
  [8332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char_literal, 3, 0, 0),
  [8334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [8336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [8338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4332),
  [8340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [8342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9972),
  [8344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1524),
  [8346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4603),
  [8348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [8350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4542),
  [8352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1979),
  [8354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [8356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1934),
  [8358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1991),
  [8360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1942),
  [8362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [8364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [8366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [8368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1898),
  [8370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1900),
  [8372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [8374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [8376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [8378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [8380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1927),
  [8382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1939),
  [8384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1941),
  [8386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1891),
  [8388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [8390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1834),
  [8392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [8394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [8396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [8398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [8400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [8402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [8404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [8406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [8408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [8410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [8412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [8414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [8416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [8418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1989),
  [8420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1920),
  [8422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [8424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1988),
  [8426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [8428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [8430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4628),
  [8432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7773),
  [8434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7684),
  [8436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11689),
  [8438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6343),
  [8440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3963),
  [8442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4022),
  [8444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2176),
  [8446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [8448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [8450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [8452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2180),
  [8454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2181),
  [8456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2182),
  [8458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [8460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2184),
  [8462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [8464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2185),
  [8466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [8468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [8470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2178),
  [8472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2179),
  [8474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [8476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [8478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4708),
  [8480] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(4113),
  [8483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2663),
  [8485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10836),
  [8487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10916),
  [8489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4205),
  [8491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3903),
  [8493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3339),
  [8495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(4084),
  [8498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6342),
  [8500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4508),
  [8502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2411),
  [8504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2412),
  [8506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2415),
  [8508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2416),
  [8510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2417),
  [8512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [8514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2419),
  [8516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [8518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2420),
  [8520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [8522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [8524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [8526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [8528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9987),
  [8530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [8532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [8534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [8536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [8538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2413),
  [8540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2414),
  [8542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5300),
  [8544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6948),
  [8546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8666),
  [8548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3081),
  [8550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [8552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4285),
  [8554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(7020),
  [8557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(4059),
  [8560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6329),
  [8562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11461),
  [8564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11474),
  [8566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3979),
  [8568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(7519),
  [8571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6947),
  [8573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11059),
  [8575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(6986),
  [8578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(3958),
  [8581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(9972),
  [8584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7519),
  [8586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6986),
  [8588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3914),
  [8590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7020),
  [8592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4139),
  [8594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4119),
  [8596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5473),
  [8598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8601),
  [8600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5285),
  [8602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7924),
  [8604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6584),
  [8606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6588),
  [8608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6594),
  [8610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6298),
  [8612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6605),
  [8614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6606),
  [8616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5061),
  [8618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8644),
  [8620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5059),
  [8622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8635),
  [8624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4978),
  [8626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5284),
  [8628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7926),
  [8630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6686),
  [8632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6687),
  [8634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6689),
  [8636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5966),
  [8638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6303),
  [8640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6690),
  [8642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6691),
  [8644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2383),
  [8646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2384),
  [8648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7773),
  [8650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5329),
  [8652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8636),
  [8654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7892),
  [8656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6626),
  [8658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6627),
  [8660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6628),
  [8662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6273),
  [8664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6630),
  [8666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6633),
  [8668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4283),
  [8670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6857),
  [8672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6857),
  [8674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7370),
  [8676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10998),
  [8678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5736),
  [8680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8679),
  [8682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5224),
  [8684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6206),
  [8686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7945),
  [8688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6612),
  [8690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6615),
  [8692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6616),
  [8694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6258),
  [8696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6617),
  [8698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6618),
  [8700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4333),
  [8702] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(9987),
  [8705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [8707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [8709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2387),
  [8711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2388),
  [8713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2389),
  [8715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [8717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2405),
  [8719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [8721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2407),
  [8723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2385),
  [8725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2386),
  [8727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [8729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [8731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6123),
  [8733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8731),
  [8735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5394),
  [8737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7962),
  [8739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6575),
  [8741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6731),
  [8743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6733),
  [8745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6344),
  [8747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6739),
  [8749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6740),
  [8751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5970),
  [8753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8727),
  [8755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5215),
  [8757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6201),
  [8759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7955),
  [8761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6634),
  [8763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6635),
  [8765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6639),
  [8767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6244),
  [8769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6642),
  [8771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6643),
  [8773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1304),
  [8775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4058),
  [8777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6868),
  [8779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6868),
  [8781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7449),
  [8783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4128),
  [8785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6827),
  [8787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6827),
  [8789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3998),
  [8791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6854),
  [8793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6854),
  [8795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6411),
  [8797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8885),
  [8799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4258),
  [8801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6837),
  [8803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6837),
  [8805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7399),
  [8807] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 75), SHIFT(1281),
  [8810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4208),
  [8812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3920),
  [8814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6974),
  [8816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3953),
  [8818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4694),
  [8821] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(11426),
  [8824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6441),
  [8826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6223),
  [8828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6681),
  [8830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7957),
  [8832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6712),
  [8834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6713),
  [8836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6714),
  [8838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6350),
  [8840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6715),
  [8842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6716),
  [8844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(6974),
  [8847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(4102),
  [8850] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 75), SHIFT(1279),
  [8853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 123), SHIFT(1285),
  [8856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4243),
  [8858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6416),
  [8860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(4243),
  [8863] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(9594),
  [8866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(10774),
  [8869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4276),
  [8871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(4107),
  [8874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4460),
  [8876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3991),
  [8878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6463),
  [8880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 71), SHIFT(1285),
  [8883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2619),
  [8885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2620),
  [8887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [8889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [8891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2623),
  [8893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2624),
  [8895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2625),
  [8897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [8899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2627),
  [8901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [8903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2628),
  [8905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [8907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2621),
  [8909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2622),
  [8911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [8913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [8915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7835),
  [8917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7835),
  [8919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4504),
  [8921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4731),
  [8923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2391),
  [8925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2392),
  [8927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [8929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [8931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2395),
  [8933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2396),
  [8935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2397),
  [8937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [8939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2399),
  [8941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2400),
  [8943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [8945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [8947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [8949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2393),
  [8951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2394),
  [8953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [8955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [8957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4732),
  [8959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7868),
  [8961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7868),
  [8963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4145),
  [8965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(6977),
  [8968] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(3977),
  [8971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(10060),
  [8974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3935),
  [8976] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(7027),
  [8979] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(4035),
  [8982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6256),
  [8984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6977),
  [8986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4232),
  [8988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4207),
  [8990] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(4125),
  [8993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4564),
  [8995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4440),
  [8997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4440),
  [8999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4270),
  [9001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11707),
  [9003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7682),
  [9005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 123), SHIFT(1295),
  [9008] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 75), SHIFT(1285),
  [9011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4939),
  [9013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11204),
  [9015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4622),
  [9017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1985),
  [9019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1950),
  [9021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1963),
  [9023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1945),
  [9025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1904),
  [9027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [9029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [9031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1922),
  [9033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1929),
  [9035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [9037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [9039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [9041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1937),
  [9043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [9045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1968),
  [9047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1975),
  [9049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1976),
  [9051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1987),
  [9053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11228),
  [9055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [9057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11246),
  [9059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11268),
  [9061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11282),
  [9063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11285),
  [9065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11294),
  [9067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11300),
  [9069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11334),
  [9071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11341),
  [9073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11343),
  [9075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11357),
  [9077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [9079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [9081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [9083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [9085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [9087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [9089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [9091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4940),
  [9093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3924),
  [9095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [9097] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34), SHIFT(1302),
  [9100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3382),
  [9102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3382),
  [9104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [9106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10981),
  [9108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__binary_fold_operator, 3, 0, 133),
  [9110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binary_fold_operator, 3, 0, 133),
  [9112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4653),
  [9114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3427),
  [9116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [9118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4388),
  [9120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6885),
  [9122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6885),
  [9124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5657),
  [9126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5657),
  [9128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5660),
  [9130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1520),
  [9132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3919),
  [9134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5134),
  [9136] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 75), SHIFT(1297),
  [9139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4588),
  [9141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4588),
  [9143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4384),
  [9145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10964),
  [9147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_initializer, 4, 0, 142),
  [9149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [9151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4715),
  [9153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4715),
  [9155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4531),
  [9157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11621),
  [9159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4944),
  [9161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7120),
  [9163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4710),
  [9165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6961),
  [9167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 71), SHIFT(1295),
  [9170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [9172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1879),
  [9174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3996),
  [9176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4073),
  [9178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(4131),
  [9181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4043),
  [9183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7027),
  [9185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3978),
  [9187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [9189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4192),
  [9191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(4504),
  [9194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4511),
  [9196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4512),
  [9198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4423),
  [9200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4308),
  [9202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4507),
  [9204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4685),
  [9206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4567),
  [9208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4693),
  [9210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 75), SHIFT(1295),
  [9213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7698),
  [9215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8030),
  [9217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(4567),
  [9220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(9533),
  [9223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(10769),
  [9226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 75), SHIFT(1284),
  [9229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4532),
  [9231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7026),
  [9233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7026),
  [9235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7025),
  [9237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7025),
  [9239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2064),
  [9241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [9243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [9245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [9247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2068),
  [9249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2069),
  [9251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2070),
  [9253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [9255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2072),
  [9257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [9259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2073),
  [9261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [9263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [9265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [9267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34), SHIFT(1304),
  [9270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7046),
  [9272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7007),
  [9274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7046),
  [9276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7007),
  [9278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [9280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4701),
  [9282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6916),
  [9284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6916),
  [9286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6336),
  [9288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5046),
  [9290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5046),
  [9292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5065),
  [9294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [9296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6336),
  [9298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11453),
  [9300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_capture, 2, 0, 0),
  [9302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__lambda_capture, 2, 0, 0),
  [9305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4890),
  [9307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11447),
  [9309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11447),
  [9311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [9313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7688),
  [9315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4963),
  [9317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4823),
  [9319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6922),
  [9321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6922),
  [9323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 1, 0, 2),
  [9325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 1, 0, 2),
  [9327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6313),
  [9329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5983),
  [9331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 20),
  [9333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 2, 0, 20),
  [9335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4846),
  [9337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6940),
  [9339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6940),
  [9341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6997),
  [9343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6998),
  [9345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4886),
  [9347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6942),
  [9349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6942),
  [9351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0),
  [9353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0),
  [9355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5046),
  [9358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5065),
  [9361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [9363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5077),
  [9365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4931),
  [9367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6937),
  [9369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6937),
  [9371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [9373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3019),
  [9375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [9377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4959),
  [9379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4960),
  [9381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4979),
  [9383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9445),
  [9385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 1, 0, 58),
  [9387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5111),
  [9389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5111),
  [9391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10795),
  [9393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [9395] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34), SHIFT(1288),
  [9398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [9400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5281),
  [9402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(5147),
  [9405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5105),
  [9407] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(11458),
  [9410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5280),
  [9412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4950),
  [9414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [9416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4951),
  [9418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5277),
  [9420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(5147),
  [9423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5286),
  [9425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(11458),
  [9428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5295),
  [9430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5091),
  [9433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5094),
  [9436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5250),
  [9438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(4694),
  [9441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5108),
  [9443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(11426),
  [9446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5249),
  [9448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5267),
  [9450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(4694),
  [9453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5270),
  [9455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(11426),
  [9458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5266),
  [9460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [9462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6318),
  [9464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4995),
  [9466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7016),
  [9468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7016),
  [9470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4989),
  [9472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6981),
  [9474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6981),
  [9476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7636),
  [9478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8086),
  [9480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6330),
  [9482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5767),
  [9484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5000),
  [9486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6991),
  [9488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6991),
  [9490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2912),
  [9492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11349),
  [9494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5001),
  [9496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6990),
  [9498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6990),
  [9500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5539),
  [9502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5091),
  [9504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5094),
  [9506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10901),
  [9508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_start, 1, 0, 0),
  [9510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_start, 1, 0, 0),
  [9512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5147),
  [9515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(11458),
  [9518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5018),
  [9520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7166),
  [9522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7166),
  [9524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5032),
  [9526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7079),
  [9528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7079),
  [9530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5034),
  [9532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7183),
  [9534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7183),
  [9536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6509),
  [9538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6512),
  [9540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11453),
  [9542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_pointer_modifier, 1, 0, 0),
  [9544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_pointer_modifier, 1, 0, 0),
  [9546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6250),
  [9548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5244),
  [9550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [9552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1, 0, 0),
  [9554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1, 0, 0),
  [9556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6330),
  [9558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5084),
  [9560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7325),
  [9562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7325),
  [9564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5090),
  [9566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7244),
  [9568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7244),
  [9570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5104),
  [9572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7211),
  [9574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7211),
  [9576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 2),
  [9578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 2, 0, 2),
  [9580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6290),
  [9582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 20),
  [9584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 3, 0, 20),
  [9586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(5106),
  [9589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(5107),
  [9592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_reference_declarator, 1, 0, 0),
  [9594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_reference_declarator, 1, 0, 0),
  [9596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2369),
  [9598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [9600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2370),
  [9602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3315),
  [9604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6918),
  [9606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5196),
  [9608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7434),
  [9610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7434),
  [9612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5065),
  [9614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3285),
  [9616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3277),
  [9618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5115),
  [9620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7414),
  [9622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7414),
  [9624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [9626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [9628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2373),
  [9630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [9632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2375),
  [9634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [9636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2377),
  [9638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [9640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [9642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [9644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2371),
  [9646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2372),
  [9648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2374),
  [9650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2376),
  [9652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2379),
  [9654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5121),
  [9656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7385),
  [9658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7385),
  [9660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5126),
  [9662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7439),
  [9664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7439),
  [9666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator, 3, 0, 147),
  [9668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4938),
  [9670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 3, 0, 147),
  [9672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [9674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4534),
  [9676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6917),
  [9678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5146),
  [9680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7384),
  [9682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7384),
  [9684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4545),
  [9686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4530),
  [9688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4457),
  [9690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6920),
  [9692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5180),
  [9694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7391),
  [9696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7391),
  [9698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4455),
  [9700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4456),
  [9702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5135),
  [9704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7387),
  [9706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7387),
  [9708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [9710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [9712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5373),
  [9714] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(2912),
  [9717] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(11349),
  [9720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8103),
  [9722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6919),
  [9724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5141),
  [9726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7371),
  [9728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7371),
  [9730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8100),
  [9732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8102),
  [9734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5162),
  [9736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7366),
  [9738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7366),
  [9740] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(2912),
  [9743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5400),
  [9745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(11349),
  [9748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5178),
  [9750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7453),
  [9752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7453),
  [9754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5254),
  [9756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5107),
  [9758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6357),
  [9760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5818),
  [9762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5817),
  [9764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5221),
  [9766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7467),
  [9768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7467),
  [9770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5831),
  [9772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5833),
  [9774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5828),
  [9776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(5721),
  [9779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5479),
  [9781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5719),
  [9783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5269),
  [9785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7594),
  [9787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2326),
  [9789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [9791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2327),
  [9793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [9795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [9797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2330),
  [9799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [9801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2332),
  [9803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [9805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2334),
  [9807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [9809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [9811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [9813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [9815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [9817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [9819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [9821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5237),
  [9823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7522),
  [9825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7522),
  [9827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_start, 2, 0, 0),
  [9829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_start, 2, 0, 0),
  [9831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5241),
  [9833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7534),
  [9835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7534),
  [9837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5263),
  [9839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5265),
  [9841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5255),
  [9843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7480),
  [9845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7480),
  [9847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6957),
  [9849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7054),
  [9851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6259),
  [9853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5293),
  [9855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5212),
  [9857] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(5269),
  [9860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5234),
  [9862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5271),
  [9864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [9866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5273),
  [9868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5292),
  [9870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [9872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11425),
  [9874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [9876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5257),
  [9878] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(5723),
  [9881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5740),
  [9883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5722),
  [9885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9107),
  [9887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6945),
  [9889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5323),
  [9891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7609),
  [9893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7609),
  [9895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5303),
  [9897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7567),
  [9899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7567),
  [9901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8024),
  [9903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5333),
  [9905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7552),
  [9907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7552),
  [9909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0),
  [9911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0),
  [9913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(11306),
  [9916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(11306),
  [9919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5812),
  [9921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6283),
  [9923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5767),
  [9925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [9927] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5657),
  [9930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5657),
  [9933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5660),
  [9936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6976),
  [9938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6976),
  [9940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5687),
  [9942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6975),
  [9944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6975),
  [9946] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(10060),
  [9949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7661),
  [9951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8151),
  [9953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2633),
  [9955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [9957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2638),
  [9959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2013),
  [9961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [9963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [9965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [9967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6579),
  [9969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_range_loop_body, 4, 0, 199),
  [9971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2649),
  [9973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [9975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2008),
  [9977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [9979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2011),
  [9981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [9983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [9985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [9987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [9989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [9991] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2663),
  [9994] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2663),
  [9997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(10916),
  [10000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitfield_clause, 2, 0, 0),
  [10002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bitfield_clause, 2, 0, 0),
  [10004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5405),
  [10006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7647),
  [10008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7647),
  [10010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5878),
  [10012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6327),
  [10014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6246),
  [10016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [10018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [10020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [10022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4810),
  [10024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23),
  [10026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 23),
  [10028] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(7519),
  [10031] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(6960),
  [10034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(4094),
  [10037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8088),
  [10039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7639),
  [10041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11425),
  [10043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5444),
  [10045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7715),
  [10047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7715),
  [10049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 4, 0, 182),
  [10051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 4, 0, 182),
  [10053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6153),
  [10055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [10057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2343),
  [10059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [10061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2344),
  [10063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [10065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [10067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2347),
  [10069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [10071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2349),
  [10073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [10075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2351),
  [10077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [10079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2352),
  [10081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [10083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [10085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [10087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [10089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6076),
  [10091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [10093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [10095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4269),
  [10097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6146),
  [10099] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 145), SHIFT(1958),
  [10102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 145),
  [10104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [10106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [10108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2466),
  [10110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [10112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2467),
  [10114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [10116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [10118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2470),
  [10120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [10122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2472),
  [10124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [10126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2474),
  [10128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [10130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [10132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4794),
  [10134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [10136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [10138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [10140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [10142] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0), SHIFT(1958),
  [10145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comma_expression, 3, 0, 83),
  [10147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0),
  [10149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5536),
  [10151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7880),
  [10153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7880),
  [10155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [10157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5469),
  [10159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7743),
  [10161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7743),
  [10163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [10165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [10167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [10169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [10171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2982),
  [10173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [10175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [10177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_declarator, 3, 0, 117),
  [10179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_declaration, 4, 0, 196),
  [10181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [10183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4780),
  [10185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [10187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4842),
  [10189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [10191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [10193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [10195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [10197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5490),
  [10199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7832),
  [10201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7832),
  [10203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [10205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [10207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4873),
  [10209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [10211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5539),
  [10214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(10901),
  [10217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3012),
  [10219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4656),
  [10221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3409),
  [10223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3009),
  [10225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [10227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6113),
  [10229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [10231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4781),
  [10233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [10235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [10237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [10239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [10241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4682),
  [10243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [10245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3399),
  [10247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [10249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6254),
  [10251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4839),
  [10253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [10255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4859),
  [10257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4104),
  [10259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4264),
  [10261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [10263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [10265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [10267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [10269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2920),
  [10271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [10273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [10275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2934),
  [10277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2922),
  [10279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(11306),
  [10282] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(11306),
  [10285] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(9928),
  [10288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2766),
  [10290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [10292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [10294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2755),
  [10296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2757),
  [10298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [10300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [10302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [10304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4539),
  [10306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [10308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [10310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [10312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [10314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3398),
  [10316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2980),
  [10318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [10320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [10322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [10324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [10326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [10328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(10836),
  [10331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(10836),
  [10334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [10336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [10338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [10340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [10342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [10344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [10346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3477),
  [10348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [10350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4563),
  [10352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2998),
  [10354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8438),
  [10356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8452),
  [10358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [10360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8455),
  [10362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5177),
  [10364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [10366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6148),
  [10368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4744),
  [10370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4762),
  [10372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4785),
  [10374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2958),
  [10376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [10378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2946),
  [10380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [10382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5219),
  [10384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5247),
  [10386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5252),
  [10388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [10390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [10392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2714),
  [10394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [10396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [10398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [10400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [10402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3588),
  [10404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3569),
  [10406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3573),
  [10408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3711),
  [10410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3671),
  [10412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3696),
  [10414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [10416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [10418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [10420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [10422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [10424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [10426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(7586),
  [10429] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(7024),
  [10432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(4009),
  [10435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4559),
  [10437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4590),
  [10439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4592),
  [10441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4572),
  [10443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [10445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 156),
  [10447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7810),
  [10449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11099),
  [10451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 200),
  [10453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [10455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2639),
  [10457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [10459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2600),
  [10461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [10463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2641),
  [10465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2642),
  [10467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2643),
  [10469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2644),
  [10471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [10473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2646),
  [10475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [10477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [10479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [10481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2648),
  [10483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2642),
  [10485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [10487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7875),
  [10489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11000),
  [10491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter_declaration, 4, 0, 207),
  [10493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [10495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [10497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [10499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [10501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 5, 1, 221),
  [10503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [10505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 146),
  [10507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [10509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7877),
  [10511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11327),
  [10513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 4, 0, 0),
  [10515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 197),
  [10517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [10519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5690),
  [10521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7878),
  [10523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11018),
  [10525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [10527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(5690),
  [10530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [10532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7881),
  [10534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11375),
  [10536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2261),
  [10538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 6, 4, 0),
  [10540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [10542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_initializer, 3, 0, 83),
  [10544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 198),
  [10546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5730),
  [10548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [10550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5738),
  [10552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5778),
  [10554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5783),
  [10556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 5, 4, 0),
  [10558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7662),
  [10560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [10562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5684),
  [10564] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(3891),
  [10567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3680),
  [10569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [10571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [10573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7836),
  [10575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11354),
  [10577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2484),
  [10579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 1, 0),
  [10581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [10583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [10585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [10587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter_declaration, 3, 0, 167),
  [10589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [10591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [10593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [10595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 4, 0, 208),
  [10597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5825),
  [10599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5826),
  [10601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2910),
  [10603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9831),
  [10605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_declaration, 1, 0, 0),
  [10607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6332),
  [10609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_argument_list_repeat1, 2, 0, 0),
  [10611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 155),
  [10613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5841),
  [10615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5842),
  [10617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5807),
  [10619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [10621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_initializer, 5, 0, 191),
  [10623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7866),
  [10625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11511),
  [10627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [10629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [10631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [10633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [10635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2651),
  [10637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [10639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [10641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [10643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5458),
  [10645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [10647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2925),
  [10649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [10651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [10653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [10655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2825),
  [10657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [10659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [10661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [10663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2950),
  [10665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [10667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [10669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10192),
  [10671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9413),
  [10673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [10675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5538),
  [10677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10180),
  [10679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9721),
  [10681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [10683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [10685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3459),
  [10687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3011),
  [10689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [10691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [10693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [10695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [10697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6268),
  [10699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [10701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4707),
  [10703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [10705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [10707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [10709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5325),
  [10711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4311),
  [10713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_left_fold, 3, 0, 55),
  [10715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(7009),
  [10718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(3940),
  [10721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [10723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2866),
  [10725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [10727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [10729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [10731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3707),
  [10733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10216),
  [10735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2852),
  [10737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [10739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4056),
  [10741] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6329),
  [10744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(11474),
  [10747] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6336),
  [10750] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(11453),
  [10753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [10755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [10757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [10759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [10761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10130),
  [10763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [10765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assignment_expression_lhs, 3, 0, 55),
  [10767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2716),
  [10769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [10771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [10773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3785),
  [10775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [10777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2905),
  [10779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binary_fold, 3, 0, 84),
  [10781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [10783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2664),
  [10785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [10787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2212),
  [10789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [10791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6238),
  [10793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2731),
  [10795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4175),
  [10797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4997),
  [10799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [10801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6952),
  [10803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4713),
  [10805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [10807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_range_loop_body, 5, 0, 222),
  [10809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3118),
  [10811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [10813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5132),
  [10815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [10817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4124),
  [10819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [10821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [10823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23),
  [10825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 23),
  [10827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [10829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [10831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5724),
  [10833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9922),
  [10835] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(7519),
  [10838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(6960),
  [10841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(4094),
  [10844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [10846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [10848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [10850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4700),
  [10852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [10854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [10856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4242),
  [10858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4290),
  [10860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4294),
  [10862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4297),
  [10864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4300),
  [10866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [10868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_capture, 1, 0, 0),
  [10870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__lambda_capture, 1, 0, 0),
  [10873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3518),
  [10875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8655),
  [10877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2788),
  [10879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3547),
  [10881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7894),
  [10883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6744),
  [10885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6745),
  [10887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6667),
  [10889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3874),
  [10891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11449),
  [10893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6337),
  [10895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6666),
  [10897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6641),
  [10899] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(4113),
  [10902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3422),
  [10904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8746),
  [10906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2778),
  [10908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3535),
  [10910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7908),
  [10912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6717),
  [10914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6721),
  [10916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6723),
  [10918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3754),
  [10920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11310),
  [10922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6287),
  [10924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6734),
  [10926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6738),
  [10928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4461),
  [10930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8723),
  [10932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3068),
  [10934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4699),
  [10936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7947),
  [10938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6669),
  [10940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6675),
  [10942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6676),
  [10944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5062),
  [10946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11454),
  [10948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6331),
  [10950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6679),
  [10952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6680),
  [10954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8132),
  [10956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7023),
  [10958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7681),
  [10960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4968),
  [10962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8676),
  [10964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3156),
  [10966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5075),
  [10968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7966),
  [10970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6728),
  [10972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6730),
  [10974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6735),
  [10976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5349),
  [10978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11427),
  [10980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6309),
  [10982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6576),
  [10984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6577),
  [10986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3256),
  [10988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8689),
  [10990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2739),
  [10992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3332),
  [10994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7960),
  [10996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6644),
  [10998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6656),
  [11000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6674),
  [11002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3187),
  [11004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11352),
  [11006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6272),
  [11008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6688),
  [11010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6697),
  [11012] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(4084),
  [11015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7693),
  [11017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3149),
  [11019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2735),
  [11021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3311),
  [11023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7997),
  [11025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6293),
  [11027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7737),
  [11029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3948),
  [11031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8677),
  [11033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3065),
  [11035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7932),
  [11037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6595),
  [11039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6597),
  [11041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6598),
  [11043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6352),
  [11045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6607),
  [11047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6608),
  [11049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7022),
  [11051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3562),
  [11053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8630),
  [11055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2815),
  [11057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3620),
  [11059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7989),
  [11061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6638),
  [11063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6645),
  [11065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6653),
  [11067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4319),
  [11069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11442),
  [11071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6253),
  [11073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6657),
  [11075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6662),
  [11077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(11306),
  [11080] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(11306),
  [11083] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(9928),
  [11086] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(7586),
  [11089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(7024),
  [11092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(4009),
  [11095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(11461),
  [11098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(7519),
  [11101] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(6986),
  [11104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(3958),
  [11107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(3891),
  [11110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2738),
  [11113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(11223),
  [11116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7670),
  [11118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(6475),
  [11121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(6413),
  [11124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(6464),
  [11127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7703),
  [11129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(7020),
  [11132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(4059),
  [11135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(1707),
  [11138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(10916),
  [11141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(6432),
  [11144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(6453),
  [11147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(6469),
  [11150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7697),
  [11152] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(6974),
  [11155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(4102),
  [11158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(605),
  [11160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8763),
  [11162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [11164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [11166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8640),
  [11168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [11170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7987),
  [11172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8669),
  [11174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6447),
  [11176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7943),
  [11178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6622),
  [11180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6623),
  [11182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6625),
  [11184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6305),
  [11186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6631),
  [11188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6632),
  [11190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(7009),
  [11193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(3940),
  [11196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(4107),
  [11199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(10898),
  [11202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(6509),
  [11205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(6512),
  [11208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(4084),
  [11211] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(4113),
  [11214] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(4131),
  [11217] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(4125),
  [11220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(10060),
  [11223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2956),
  [11225] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(6977),
  [11228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(3977),
  [11231] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(7027),
  [11234] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(4035),
  [11237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [11239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [11241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3944),
  [11243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4137),
  [11245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [11247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7017),
  [11249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 0), SHIFT(2881),
  [11252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [11254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4188),
  [11256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(7020),
  [11259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(4059),
  [11262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23),
  [11264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 23),
  [11266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [11268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [11270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [11272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [11274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 35), SHIFT(6462),
  [11277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [11279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6468),
  [11281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(7519),
  [11284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(6986),
  [11287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(3958),
  [11290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2719),
  [11292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11378),
  [11294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6586),
  [11296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5539),
  [11299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(10901),
  [11302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 4, 0, 45), SHIFT(2881),
  [11305] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT(2881),
  [11309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 4, -1, 76), SHIFT(2881),
  [11312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(7519),
  [11315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(6960),
  [11318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(4094),
  [11321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [11323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [11325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 20), SHIFT(2881),
  [11328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 35), SHIFT(2881),
  [11331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4209),
  [11333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 45), SHIFT(6450),
  [11336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 18), SHIFT(2881),
  [11339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 20), SHIFT(6460),
  [11342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 2), SHIFT(2881),
  [11345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 76), SHIFT(6454),
  [11348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 2, 0, 20),
  [11350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 2, 0, 20),
  [11352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6345),
  [11354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3019),
  [11356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(11306),
  [11359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(11306),
  [11362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(9928),
  [11365] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(6974),
  [11368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(4102),
  [11371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(7586),
  [11374] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(7024),
  [11377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(4009),
  [11380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 1, 0, 2),
  [11382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 1, 0, 2),
  [11384] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(4107),
  [11387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(6977),
  [11390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(3977),
  [11393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(4131),
  [11396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(4125),
  [11399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(3891),
  [11402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(10060),
  [11405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(7027),
  [11408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(4035),
  [11411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5731),
  [11413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4981),
  [11415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5149),
  [11417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2861),
  [11419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5757),
  [11421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4663),
  [11423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8606),
  [11425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5002),
  [11427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5468),
  [11429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [11431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8684),
  [11433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5335),
  [11435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3548),
  [11437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3498),
  [11439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3098),
  [11441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [11443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4365),
  [11445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2923),
  [11447] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(6474),
  [11450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3392),
  [11452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(7009),
  [11455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(3940),
  [11458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9088),
  [11460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9158),
  [11462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9060),
  [11464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9195),
  [11466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9204),
  [11468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9031),
  [11470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9173),
  [11472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9054),
  [11474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 1, 0, 23),
  [11476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4200),
  [11478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6992),
  [11480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9161),
  [11482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9119),
  [11484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9123),
  [11486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9151),
  [11488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 1, 0, 0),
  [11490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9155),
  [11492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9312),
  [11494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9125),
  [11496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9029),
  [11498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9203),
  [11500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9122),
  [11502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9156),
  [11504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9064),
  [11506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9104),
  [11508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9098),
  [11510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9160),
  [11512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9166),
  [11514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(4113),
  [11517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9176),
  [11519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 2, 0, 59),
  [11521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9033),
  [11523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9169),
  [11525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(4084),
  [11528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(7020),
  [11531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(4059),
  [11534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 3, 0, 20),
  [11536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 3, 0, 20),
  [11538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 2, 0, 2),
  [11540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 2, 0, 2),
  [11542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(7519),
  [11545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(6986),
  [11548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(3958),
  [11551] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(6974),
  [11554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(4102),
  [11557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(4107),
  [11560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(10060),
  [11563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(7027),
  [11566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(4035),
  [11569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(4125),
  [11572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(6977),
  [11575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(3977),
  [11578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(4131),
  [11581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8349),
  [11583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [11585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [11587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6125),
  [11589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9346),
  [11591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [11593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [11595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4698),
  [11597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9443),
  [11599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [11601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [11603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5259),
  [11605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9541),
  [11607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7043),
  [11609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7044),
  [11611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5339),
  [11613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [11615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [11617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4659),
  [11619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9419),
  [11621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [11623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [11625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4882),
  [11627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9371),
  [11629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [11631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [11633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3421),
  [11635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9476),
  [11637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_qualifier, 1, 0, 0),
  [11639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_qualifier, 1, 0, 0),
  [11641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [11643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [11645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [11647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1518),
  [11649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [11651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10785),
  [11653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23),
  [11655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 5, 0, 23),
  [11657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(7586),
  [11660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(7024),
  [11663] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(4009),
  [11666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [11668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [11670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [11672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10387),
  [11674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [11676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [11678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [11680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10536),
  [11682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_noexcept, 1, 0, 0),
  [11684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_noexcept, 1, 0, 0),
  [11686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [11688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_specifier, 3, 0, 0),
  [11690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_specifier, 3, 0, 0),
  [11692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_end, 1, 0, 0),
  [11694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_end, 1, 0, 0),
  [11696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_end, 2, 0, 0),
  [11698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_end, 2, 0, 0),
  [11700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_specifier, 5, 0, 0),
  [11702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_specifier, 5, 0, 0),
  [11704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_noexcept, 4, 0, 0),
  [11706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_noexcept, 4, 0, 0),
  [11708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_noexcept, 3, 0, 0),
  [11710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_noexcept, 3, 0, 0),
  [11712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_specifier, 4, 0, 0),
  [11714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_specifier, 4, 0, 0),
  [11716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [11718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4052),
  [11720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [11722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7199),
  [11724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9467),
  [11726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8705),
  [11728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8185),
  [11730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7083),
  [11732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6963),
  [11734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2973),
  [11736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10273),
  [11738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [11740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7851),
  [11742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5331),
  [11744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8236),
  [11746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2683),
  [11748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [11750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8752),
  [11752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2699),
  [11754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9506),
  [11756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1668),
  [11758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_end, 3, 0, 0),
  [11760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_end, 3, 0, 0),
  [11762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7779),
  [11764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5148),
  [11766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [11768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11597),
  [11770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6984),
  [11772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10308),
  [11774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [11776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [11778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6985),
  [11780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9941),
  [11782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7991),
  [11784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 6, 0, 0),
  [11786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 6, 0, 0),
  [11788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8130),
  [11790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7671),
  [11792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8741),
  [11794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9316),
  [11796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7996),
  [11798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [11800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3438),
  [11802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3440),
  [11804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [11806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4945),
  [11808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4946),
  [11810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 4, 0, 0),
  [11812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 4, 0, 0),
  [11814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__preproc_expression, 1, 0, 0),
  [11816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7084),
  [11818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__preproc_expression, 1, 0, 0),
  [11820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 3, 0, 0),
  [11822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 3, 0, 0),
  [11824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [11826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4711),
  [11828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23),
  [11830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 6, 0, 23),
  [11832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [11834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7561),
  [11836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9410),
  [11838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7584),
  [11840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7122),
  [11842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7121),
  [11844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1442),
  [11846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7015),
  [11848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10319),
  [11850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6887),
  [11852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8674),
  [11854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6925),
  [11856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7570),
  [11858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7579),
  [11860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(9928),
  [11863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6088),
  [11865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7074),
  [11867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [11869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4624),
  [11871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4626),
  [11873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8098),
  [11875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9244),
  [11877] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(7586),
  [11880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(7024),
  [11883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(4009),
  [11886] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(7519),
  [11889] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(6960),
  [11892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(4094),
  [11895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6928),
  [11897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2697),
  [11899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4804),
  [11901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3294),
  [11903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10178),
  [11905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 5, 0, 0),
  [11907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 5, 0, 0),
  [11909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5256),
  [11911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7342),
  [11913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7216),
  [11915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7248),
  [11917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7249),
  [11919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7249),
  [11921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7250),
  [11923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7251),
  [11925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7252),
  [11927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7253),
  [11929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7254),
  [11931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7255),
  [11933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7256),
  [11935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7256),
  [11937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7257),
  [11939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7013),
  [11941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7014),
  [11943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11314),
  [11945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6971),
  [11947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7003),
  [11949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7323),
  [11951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7217),
  [11953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10503),
  [11955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7238),
  [11957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7238),
  [11959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7073),
  [11961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9903),
  [11963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7119),
  [11965] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [11967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [11969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7373),
  [11971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7132),
  [11973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [11975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [11977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7424),
  [11979] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(3891),
  [11982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8687),
  [11984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10080),
  [11986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10908),
  [11988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7076),
  [11990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6970),
  [11992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8951),
  [11994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11324),
  [11996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8018),
  [11998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7378),
  [12000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [12002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9692),
  [12004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3923),
  [12006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10997),
  [12008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7213),
  [12010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10294),
  [12012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4400),
  [12014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [12016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 3, 0, 0),
  [12018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 3, 0, 0),
  [12020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7382),
  [12022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7086),
  [12024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7227),
  [12026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10600),
  [12028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7236),
  [12030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7236),
  [12032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7417),
  [12034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10075),
  [12036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [12038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 4, 0, 0),
  [12040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 4, 0, 0),
  [12042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [12044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7388),
  [12046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3871),
  [12048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10830),
  [12050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7225),
  [12052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9951),
  [12054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4396),
  [12056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [12058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7427),
  [12060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7450),
  [12062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2, 0, 0),
  [12064] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(7009),
  [12067] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(3940),
  [12070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [12072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [12074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7430),
  [12076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [12078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7247),
  [12080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3278),
  [12082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11233),
  [12084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7239),
  [12086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9978),
  [12088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4378),
  [12090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7374),
  [12092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3042),
  [12094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9723),
  [12096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [12098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7408),
  [12100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8795),
  [12102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 2, 0, 0),
  [12104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 2, 0, 0),
  [12106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_unary_expression, 2, 0, 4),
  [12108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_unary_expression, 2, 0, 4),
  [12110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7307),
  [12112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7309),
  [12114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7312),
  [12116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7313),
  [12118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7316),
  [12120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7324),
  [12122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7326),
  [12124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7327),
  [12126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7328),
  [12128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7329),
  [12130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [12132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7409),
  [12134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [12136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3750),
  [12138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11595),
  [12140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7263),
  [12142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10039),
  [12144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4343),
  [12146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call_expression, 2, 0, 7),
  [12148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call_expression, 2, 0, 7),
  [12150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [12152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [12154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [12156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 4, 0, 0),
  [12158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 4, 0, 0),
  [12160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1469),
  [12162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7280),
  [12164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9854),
  [12166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3125),
  [12168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9722),
  [12170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7369),
  [12172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3049),
  [12174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7284),
  [12176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10120),
  [12178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_requirements, 3, 0, 0),
  [12180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_requirements, 3, 0, 0),
  [12182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10812),
  [12184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [12186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [12188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7389),
  [12190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_postfix, 1, 0, 0),
  [12192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_postfix, 1, 0, 0),
  [12194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3001),
  [12196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7290),
  [12198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9763),
  [12200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [12202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [12204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [12206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7413),
  [12208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3087),
  [12210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7299),
  [12212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10150),
  [12214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [12216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_parenthesized_expression, 3, 0, 0),
  [12218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_parenthesized_expression, 3, 0, 0),
  [12220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [12222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_binary_expression, 3, 0, 55),
  [12224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_binary_expression, 3, 0, 55),
  [12226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [12228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7396),
  [12230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7433),
  [12232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0),
  [12234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0),
  [12236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0), SHIFT_REPEAT(7519),
  [12239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(7519),
  [12242] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(6960),
  [12245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(4094),
  [12248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 2, 0, 0),
  [12250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 2, 0, 0),
  [12252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1477),
  [12254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7330),
  [12256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10211),
  [12258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7372),
  [12260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7395),
  [12262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(4113),
  [12265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7398),
  [12267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7229),
  [12269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_interface_requirements_repeat1, 2, 0, 0),
  [12271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interface_requirements_repeat1, 2, 0, 0),
  [12273] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_requirements_repeat1, 2, 0, 0), SHIFT_REPEAT(10812),
  [12276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3027),
  [12278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7346),
  [12280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10240),
  [12282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7381),
  [12284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7383),
  [12286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7386),
  [12288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3790),
  [12290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7351),
  [12292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10184),
  [12294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4391),
  [12296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7392),
  [12298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7397),
  [12300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [12302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [12304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7401),
  [12306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7402),
  [12308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [12310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [12312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7405),
  [12314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7411),
  [12316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7365),
  [12318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_requirements, 2, 0, 0),
  [12320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_requirements, 2, 0, 0),
  [12322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7347),
  [12324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7349),
  [12326] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_requirements_repeat1, 2, 0, 0), SHIFT_REPEAT(11263),
  [12329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 5),
  [12331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 5),
  [12333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1523),
  [12335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [12337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7350),
  [12339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7352),
  [12341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7353),
  [12343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7356),
  [12345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7357),
  [12347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7360),
  [12349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7361),
  [12351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7362),
  [12353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7630),
  [12355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9853),
  [12357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [12359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [12361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9267),
  [12363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10084),
  [12365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_reference_declarator, 2, 0, 0),
  [12367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_reference_declarator, 2, 0, 0),
  [12369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7302),
  [12371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8411),
  [12373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [12375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 38),
  [12377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 2, 0, 38),
  [12379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1273),
  [12381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8647),
  [12383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [12385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [12387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [12389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8846),
  [12391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9991),
  [12393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [12395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8624),
  [12397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8488),
  [12399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8495),
  [12401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8604),
  [12403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [12405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 82),
  [12407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 3, 0, 82),
  [12409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11263),
  [12411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [12413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 64),
  [12415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 3, 0, 64),
  [12417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3946),
  [12419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 2, 0, 0),
  [12421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10880),
  [12423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_where_clause, 2, 0, 0),
  [12425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4016),
  [12427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 41),
  [12429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 41),
  [12431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7379),
  [12433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9428),
  [12435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7431),
  [12437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10079),
  [12439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7769),
  [12441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 4, 0, 134),
  [12443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 4, 0, 134),
  [12445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(3891),
  [12448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 4, 1, 86),
  [12450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 4, 1, 86),
  [12452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [12454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8637),
  [12456] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0), SHIFT_REPEAT(7586),
  [12459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7818),
  [12461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__abstract_declarator, 1, 0, 0),
  [12463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__abstract_declarator, 1, 0, 0),
  [12465] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(7020),
  [12468] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(4107),
  [12471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(6974),
  [12474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(4102),
  [12477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_parenthesized_declarator, 4, 0, 0),
  [12479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 4, 0, 0),
  [12481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trailing_return_type, 2, 0, 0),
  [12483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trailing_return_type, 2, 0, 0),
  [12485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 4, 0, 184),
  [12487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 184),
  [12489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 4, 0, 121),
  [12491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 121),
  [12493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 4, 0, 26),
  [12495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 26),
  [12497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7972),
  [12499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9269),
  [12501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7907),
  [12503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 5, 0, 177),
  [12505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 5, 0, 177),
  [12507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_where_clause_repeat1, 5, 0, 0),
  [12509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 5, 0, 0),
  [12511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 8, 0, 23),
  [12513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 8, 0, 23),
  [12515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7933),
  [12517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 3, 0, 0),
  [12519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_where_clause, 3, 0, 0),
  [12521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4019),
  [12523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 4, 0, 0),
  [12525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_where_clause, 4, 0, 0),
  [12527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3946),
  [12530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0),
  [12532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0),
  [12534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 5, 0, 0),
  [12536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_where_clause, 5, 0, 0),
  [12538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 6, 0, 0),
  [12540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_where_clause, 6, 0, 0),
  [12542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23),
  [12544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 7, 0, 23),
  [12546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(4009),
  [12549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 2, 0, 0),
  [12551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 2, 0, 0),
  [12553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_virtual_specifier, 1, 0, 0),
  [12555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_virtual_specifier, 1, 0, 0),
  [12557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(4113),
  [12560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(10880),
  [12563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4020),
  [12566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(4084),
  [12569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_function_declarator, 2, 0, 24),
  [12571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 2, 0, 24),
  [12573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_parenthesized_declarator, 3, 0, 0),
  [12575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 3, 0, 0),
  [12577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 3, 0, 132),
  [12579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 132),
  [12581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 3, 0, 0),
  [12583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 0),
  [12585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 3, 0, 26),
  [12587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 26),
  [12589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_where_clause_repeat1, 4, 0, 0),
  [12591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 4, 0, 0),
  [12593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_function_declarator, 1, 0, 39),
  [12595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 1, 0, 39),
  [12597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(7009),
  [12600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(3940),
  [12603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7910),
  [12605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7592),
  [12607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9507),
  [12609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10767),
  [12611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7010),
  [12613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7011),
  [12615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8374),
  [12617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10442),
  [12619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7019),
  [12621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0),
  [12623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0),
  [12625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0), SHIFT_REPEAT(4021),
  [12628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [12630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0),
  [12632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(10898),
  [12635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0),
  [12637] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(11223),
  [12640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7018),
  [12642] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(4059),
  [12645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8311),
  [12647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 1, 0, 0),
  [12649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10118),
  [12651] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7592),
  [12654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(9507),
  [12657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(10767),
  [12660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7551),
  [12662] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(7519),
  [12665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(6986),
  [12668] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(3958),
  [12671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4253),
  [12673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11320),
  [12675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4044),
  [12677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(7027),
  [12680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(4035),
  [12683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5314),
  [12685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5835),
  [12687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1519),
  [12689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4821),
  [12691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4957),
  [12693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [12695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [12697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1527),
  [12699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [12701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10656),
  [12703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5064),
  [12705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5211),
  [12707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [12709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [12711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [12713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3142),
  [12715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3275),
  [12717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [12719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [12721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10652),
  [12723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [12725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [12727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10364),
  [12729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5055),
  [12731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5275),
  [12733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(6974),
  [12736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(4102),
  [12739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [12741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [12743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5338),
  [12745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5741),
  [12747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4045),
  [12749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4253),
  [12752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [12754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [12756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10374),
  [12758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7882),
  [12760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3501),
  [12762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3544),
  [12764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4305),
  [12766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(11318),
  [12769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8154),
  [12771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9305),
  [12773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4251),
  [12775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3985),
  [12777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3987),
  [12779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3095),
  [12781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, 0, 68),
  [12783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10795),
  [12785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2656),
  [12787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3322),
  [12789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3472),
  [12791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [12793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5309),
  [12795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6214),
  [12797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6419),
  [12799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3810),
  [12801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4516),
  [12803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3377),
  [12805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3514),
  [12807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2730),
  [12809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2763),
  [12811] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(7020),
  [12814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(4107),
  [12817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [12819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [12821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [12823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3112),
  [12825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3183),
  [12827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(625),
  [12829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [12831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3900),
  [12833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3947),
  [12835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 5),
  [12837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 5),
  [12839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [12841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(11320),
  [12844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4025),
  [12847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(4094),
  [12850] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(4084),
  [12853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [12855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [12857] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(3891),
  [12860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(6977),
  [12863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(3977),
  [12866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 5, 1, 175),
  [12868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_field_declarator, 5, 1, 175),
  [12870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_declarator, 2, 0, 0),
  [12872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_declarator, 2, 0, 0),
  [12874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8867),
  [12876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 3, 0, 80),
  [12878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9287),
  [12880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7317),
  [12882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11614),
  [12884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3334),
  [12886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8025),
  [12888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9265),
  [12890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6983),
  [12892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 2, 1, 5),
  [12894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_field_declarator, 2, 1, 5),
  [12896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3950),
  [12898] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3900),
  [12901] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(9855),
  [12904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_field_declarator, 2, 1, 0),
  [12906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_field_declarator, 2, 1, 0),
  [12908] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(4125),
  [12911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3988),
  [12913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9035),
  [12915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9167),
  [12917] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(4059),
  [12920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3922),
  [12922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4074),
  [12924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 2, 0, 10),
  [12926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8094),
  [12928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9314),
  [12930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4291),
  [12932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3901),
  [12934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3989),
  [12936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6982),
  [12938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 3, 1, 41),
  [12940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_field_declarator, 3, 1, 41),
  [12942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(4131),
  [12945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 4, 1, 86),
  [12947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_field_declarator, 4, 1, 86),
  [12949] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3951),
  [12952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4419),
  [12954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8021),
  [12956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9286),
  [12958] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0), SHIFT_REPEAT(4026),
  [12961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(7519),
  [12964] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(6986),
  [12967] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(3958),
  [12970] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(4113),
  [12973] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4251),
  [12976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8208),
  [12978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8212),
  [12980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8225),
  [12982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3905),
  [12985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8010),
  [12987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [12989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9769),
  [12991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9424),
  [12993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [12995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9865),
  [12997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9447),
  [12999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 5, 1, 175),
  [13001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_declarator, 5, 1, 175),
  [13003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 3, 1, 41),
  [13005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_declarator, 3, 1, 41),
  [13007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3908),
  [13009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4174),
  [13011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [13013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9933),
  [13015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9460),
  [13017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3990),
  [13019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8291),
  [13021] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(3940),
  [13024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3904),
  [13026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4291),
  [13029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8189),
  [13031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8298),
  [13033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [13035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9625),
  [13037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9381),
  [13039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8277),
  [13041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [13043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9905),
  [13045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9451),
  [13047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [13049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8278),
  [13051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8181),
  [13053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8237),
  [13055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8227),
  [13057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8246),
  [13059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 4, 1, 86),
  [13061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_declarator, 4, 1, 86),
  [13063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8282),
  [13065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8300),
  [13067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4210),
  [13069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3915),
  [13071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4165),
  [13073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4023),
  [13075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(7027),
  [13078] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(4035),
  [13081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8182),
  [13083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8254),
  [13085] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0), SHIFT_REPEAT(3952),
  [13088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8192),
  [13090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8220),
  [13092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [13094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [13096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4202),
  [13098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4060),
  [13100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8281),
  [13102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [13104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [13106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [13108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [13110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8280),
  [13112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [13114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4075),
  [13116] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4062),
  [13119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [13121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9956),
  [13123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9469),
  [13125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3922),
  [13128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8191),
  [13130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6993),
  [13132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6994),
  [13134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6993),
  [13136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6994),
  [13138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [13140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10165),
  [13142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9362),
  [13144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8230),
  [13146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8306),
  [13148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [13150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8309),
  [13152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 2, 1, 5),
  [13154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_declarator, 2, 1, 5),
  [13156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [13158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_declarator, 2, 1, 0),
  [13160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_declarator, 2, 1, 0),
  [13162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 2, 1, 24),
  [13164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declarator, 2, 1, 24), SHIFT(10795),
  [13167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 2, 1, 24),
  [13169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 3, 0, 26),
  [13171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 3, 0, 26),
  [13173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8987),
  [13175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8163),
  [13177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9658),
  [13179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7228),
  [13181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11109),
  [13183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5238),
  [13185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3673),
  [13187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8984),
  [13189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3666),
  [13191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3701),
  [13193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4352),
  [13195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1, 0, 102),
  [13197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [13199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1, 0, 102),
  [13201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3329),
  [13203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3227),
  [13205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2869),
  [13207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4949),
  [13209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1, 0, 0),
  [13211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1, 0, 0),
  [13213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4953),
  [13215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3994),
  [13218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [13220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 5, 0, 177),
  [13222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 5, 0, 177),
  [13224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, 0, 121),
  [13226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, 0, 121),
  [13228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, 0, 26),
  [13230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, 0, 26),
  [13232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_semantics, 2, 0, 0),
  [13234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_semantics, 2, 0, 0),
  [13236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3982),
  [13238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3926),
  [13240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4101),
  [13242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4222),
  [13244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3854),
  [13246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3034),
  [13248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0), SHIFT_REPEAT(3906),
  [13251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4061),
  [13253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3916),
  [13255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 3, 0, 59),
  [13257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5230),
  [13259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_field_declarator, 2, 0, 0),
  [13261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_field_declarator, 2, 0, 0),
  [13263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5827),
  [13265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4046),
  [13267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 4, -10, 0),
  [13269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_declarator, 4, -10, 0),
  [13271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3807),
  [13273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4193),
  [13275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5871),
  [13277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6988),
  [13279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6989),
  [13281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structured_binding_declarator, 4, -1, 0),
  [13283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_structured_binding_declarator, 4, -1, 0),
  [13285] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(4131),
  [13288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7634),
  [13290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [13292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), SHIFT(7420),
  [13295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3917),
  [13297] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(4125),
  [13300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(6977),
  [13303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(3977),
  [13306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0), SHIFT_REPEAT(4063),
  [13309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5913),
  [13311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [13313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4203),
  [13315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6028),
  [13317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [13319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3642),
  [13321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 3, 1, 24),
  [13323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 3, 1, 24),
  [13325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structured_binding_declarator, 3, -1, 0),
  [13327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_structured_binding_declarator, 3, -1, 0),
  [13329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9250),
  [13331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9263),
  [13333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 3, -10, 0),
  [13335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_declarator, 3, -10, 0),
  [13337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 2, 0, 23),
  [13339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [13341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [13343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [13345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [13347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6965),
  [13349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6965),
  [13351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 3, -10, 0),
  [13353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_field_declarator, 3, -10, 0),
  [13355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 5, 0, 177),
  [13357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 5, 0, 177),
  [13359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4248),
  [13361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4122),
  [13363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_field_declarator, 2, 1, 24),
  [13365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_field_declarator, 2, 1, 24),
  [13367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3918),
  [13369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4024),
  [13371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4165),
  [13374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, 0, 26),
  [13376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, 0, 26),
  [13378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 3, 0, 26),
  [13380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 3, 0, 26),
  [13382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6964),
  [13384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6964),
  [13386] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4202),
  [13389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4278),
  [13391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4301),
  [13393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3982),
  [13396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(4102),
  [13399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [13401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4171),
  [13403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4108),
  [13405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4001),
  [13407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4210),
  [13410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(4107),
  [13413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3930),
  [13415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 4, -10, 0),
  [13417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_field_declarator, 4, -10, 0),
  [13419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4189),
  [13421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4095),
  [13423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4226),
  [13425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, 0, 121),
  [13427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, 0, 121),
  [13429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3931),
  [13431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4292),
  [13433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4047),
  [13435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(4084),
  [13438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3936),
  [13441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4185),
  [13443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8789),
  [13445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8614),
  [13447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4055),
  [13449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3954),
  [13451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9514),
  [13453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8757),
  [13455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8825),
  [13457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8602),
  [13459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4245),
  [13461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9377),
  [13463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8654),
  [13465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11042),
  [13467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9340),
  [13469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7260),
  [13471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11111),
  [13473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8525),
  [13475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8891),
  [13477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8764),
  [13479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9415),
  [13481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8633),
  [13483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4278),
  [13486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3896),
  [13488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 5),
  [13490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [13492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3921),
  [13494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3959),
  [13496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3893),
  [13498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4197),
  [13500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9393),
  [13502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10379),
  [13504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9653),
  [13506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(4059),
  [13509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4224),
  [13511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9130),
  [13513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9329),
  [13515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7243),
  [13517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11189),
  [13519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8859),
  [13521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8612),
  [13523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11277),
  [13525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9083),
  [13527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7447),
  [13529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_declarators, 1, 0, 26),
  [13531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_declarators, 1, 0, 26),
  [13533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 3, 0, 10),
  [13535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 3, 0, 10),
  [13537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9429),
  [13539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8671),
  [13541] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4099),
  [13544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8847),
  [13546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8766),
  [13548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9521),
  [13550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8683),
  [13552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9146),
  [13554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8562),
  [13556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 2, 0, 10),
  [13558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9115),
  [13560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9658),
  [13563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7224),
  [13566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10993),
  [13569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10611),
  [13572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0),
  [13574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8886),
  [13576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8690),
  [13578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9281),
  [13580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10054),
  [13582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(3958),
  [13585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4010),
  [13587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4147),
  [13590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9489),
  [13592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8762),
  [13594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8542),
  [13596] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0), SHIFT_REPEAT(3995),
  [13599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3908),
  [13602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 4, 0, 80),
  [13604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4143),
  [13606] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4248),
  [13609] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0), SHIFT_REPEAT(3938),
  [13612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 4, 0, 80),
  [13614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 2, 0, 0),
  [13616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8772),
  [13618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8729),
  [13620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8506),
  [13622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 3, 0, 80),
  [13624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9370),
  [13626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8759),
  [13628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4087),
  [13630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4003),
  [13632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3956),
  [13635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scope_resolution, 1, 0, 0),
  [13637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution, 1, 0, 0),
  [13639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2368),
  [13641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6087),
  [13643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3931),
  [13646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0), SHIFT_REPEAT(4126),
  [13649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2157),
  [13651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6133),
  [13653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0), SHIFT_REPEAT(4159),
  [13656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4096),
  [13658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2324),
  [13660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6160),
  [13662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2464),
  [13664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6142),
  [13666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3986),
  [13668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4178),
  [13670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2356),
  [13672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6097),
  [13674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4177),
  [13676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4184),
  [13678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_hint, 2, 0, 0),
  [13680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 1, 0, 0),
  [13682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11028),
  [13684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2058),
  [13686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6103),
  [13688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 1, 0, 0),
  [13690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11438),
  [13692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3897),
  [13694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(4035),
  [13697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3888),
  [13699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3909),
  [13701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3961),
  [13703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4101),
  [13706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3960),
  [13708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [13710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6098),
  [13712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4237),
  [13714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [13716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2362),
  [13718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6119),
  [13720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 5),
  [13722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 5),
  [13724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3955),
  [13726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4055),
  [13729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2631),
  [13731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2227),
  [13733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2201),
  [13735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2637),
  [13737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2199),
  [13739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6068),
  [13741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3614),
  [13743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8706),
  [13745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4215),
  [13747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4149),
  [13749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5758),
  [13751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10562),
  [13753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7685),
  [13755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2865),
  [13757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10707),
  [13759] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(3977),
  [13762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [13764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10485),
  [13766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10291),
  [13768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9390),
  [13770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11556),
  [13772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [13774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3983),
  [13776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3556),
  [13778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10375),
  [13780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4206),
  [13782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9426),
  [13784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [13786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10392),
  [13788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5317),
  [13790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10685),
  [13792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [13794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10709),
  [13796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9606),
  [13798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9233),
  [13800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11072),
  [13802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5170),
  [13804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10498),
  [13806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1275),
  [13808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10526),
  [13810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 3, 0, 68),
  [13812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9534),
  [13814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4088),
  [13816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9387),
  [13818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3485),
  [13820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10569),
  [13822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9617),
  [13824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4180),
  [13826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4181),
  [13828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3934),
  [13830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4252),
  [13832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4984),
  [13834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10540),
  [13836] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4190),
  [13839] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0), SHIFT_REPEAT(3957),
  [13842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7813),
  [13844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9470),
  [13846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4036),
  [13848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6877),
  [13850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10580),
  [13852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4967),
  [13854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10473),
  [13856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4696),
  [13858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5467),
  [13860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10312),
  [13862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10972),
  [13864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9545),
  [13866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4108),
  [13869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3096),
  [13871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10668),
  [13873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3921),
  [13876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [13878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3964),
  [13880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4085),
  [13882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5727),
  [13884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10613),
  [13886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3612),
  [13888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10436),
  [13890] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(4125),
  [13893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23), SHIFT(4131),
  [13896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9799),
  [13898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10119),
  [13900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11084),
  [13902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4369),
  [13904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10666),
  [13906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3911),
  [13908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9680),
  [13910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11385),
  [13912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9474),
  [13914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9335),
  [13916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3385),
  [13918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10471),
  [13920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3962),
  [13922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, 0, 58),
  [13924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2680),
  [13926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10698),
  [13928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9563),
  [13930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9683),
  [13932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9422),
  [13934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4189),
  [13937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9513),
  [13939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [13941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10502),
  [13943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9414),
  [13945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2938),
  [13947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10497),
  [13949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [13951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3933),
  [13953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [13955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 4, 0, 23),
  [13957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 4, 0, 59),
  [13959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9658),
  [13962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0),
  [13964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0),
  [13966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3887),
  [13968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [13970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4030),
  [13972] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4177),
  [13975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10455),
  [13977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__lambda_capture_identifier, 1, 0, 0), SHIFT(8162),
  [13980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [13982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8186),
  [13984] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3986),
  [13987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4051),
  [13989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4275),
  [13991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [13993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 3, 0, 23),
  [13995] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0), SHIFT_REPEAT(8867),
  [13998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0),
  [14000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0),
  [14002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4005),
  [14004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4182),
  [14006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [14008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4050),
  [14010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4274),
  [14012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3932),
  [14014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 5, 0, 59),
  [14016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [14018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scope_resolution, 2, 0, 31),
  [14020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution, 2, 0, 31),
  [14022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8279),
  [14024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [14026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [14028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8092),
  [14030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [14032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4078),
  [14034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3937),
  [14036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8165),
  [14038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4086),
  [14040] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3964),
  [14043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [14045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4298),
  [14047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [14049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4141),
  [14051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3992),
  [14053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 1, 0, 6),
  [14055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator, 1, 0, 6),
  [14057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [14059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [14061] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4076),
  [14064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [14066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scope_resolution, 2, 0, 15),
  [14068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution, 2, 0, 15),
  [14070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [14072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast, 3, 0, 60),
  [14074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3949),
  [14076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [14078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4302),
  [14080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3888),
  [14083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [14085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4065),
  [14087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [14089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [14091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3912),
  [14093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10720),
  [14095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4103),
  [14097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [14099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7803),
  [14101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9262),
  [14103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3974),
  [14105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [14107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4051),
  [14110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_expression_repeat1, 2, 0, 0),
  [14112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(9262),
  [14115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4167),
  [14117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [14119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4012),
  [14121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [14123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4054),
  [14125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2940),
  [14127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10177),
  [14129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4090),
  [14131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3297),
  [14133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7829),
  [14135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3969),
  [14138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7775),
  [14140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7777),
  [14142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4069),
  [14144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2767),
  [14146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4195),
  [14148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [14150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [14152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10955),
  [14154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4004),
  [14156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7772),
  [14158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0), SHIFT_REPEAT(3976),
  [14161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3981),
  [14163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [14165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4500),
  [14167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4080),
  [14169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [14171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4109),
  [14173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [14175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4110),
  [14177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4039),
  [14179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7805),
  [14181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7804),
  [14183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7806),
  [14185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8081),
  [14187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4546),
  [14189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8123),
  [14191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4255),
  [14193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4127),
  [14195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4745),
  [14197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7812),
  [14199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7814),
  [14201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0), SHIFT_REPEAT(2219),
  [14204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0),
  [14206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0), SHIFT_REPEAT(10955),
  [14209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3943),
  [14211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [14213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0), SHIFT_REPEAT(4077),
  [14216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7739),
  [14218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7889),
  [14220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3895),
  [14222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3000),
  [14224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4215),
  [14227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3267),
  [14229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4007),
  [14231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7823),
  [14233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7824),
  [14235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4115),
  [14237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [14239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4098),
  [14241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2983),
  [14243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4038),
  [14245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [14247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9693),
  [14249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4136),
  [14251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5225),
  [14253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4140),
  [14255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [14257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [14259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11461),
  [14261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4335),
  [14263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4144),
  [14265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [14267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3291),
  [14269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4633),
  [14271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 1, 0, 0),
  [14273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9082),
  [14275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 1, 0, 0),
  [14277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4148),
  [14279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3589),
  [14281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4152),
  [14283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3693),
  [14285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4156),
  [14287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [14289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4018),
  [14291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9836),
  [14293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4160),
  [14295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [14297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4164),
  [14299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4560),
  [14301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9915),
  [14303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3941),
  [14305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4132),
  [14307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2941),
  [14309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4121),
  [14311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8439),
  [14313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [14315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [14317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [14319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10303),
  [14321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10307),
  [14323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [14325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [14327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8443),
  [14329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [14331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [14333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4569),
  [14335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [14337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [14339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [14341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_declaration_repeat1, 2, 0, 0),
  [14343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subscript_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(10303),
  [14346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subscript_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(10307),
  [14349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 4, 0, 80),
  [14351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 4, 0, 80),
  [14353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 3, 0),
  [14355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4187),
  [14357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6334),
  [14359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [14361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [14363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [14365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [14367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [14369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [14371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [14373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [14375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [14377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [14379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [14381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [14383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [14385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [14387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4013),
  [14389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [14391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [14393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2747),
  [14395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [14397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4006),
  [14399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [14401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3299),
  [14403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [14405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [14407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3993),
  [14409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [14411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [14413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 81),
  [14415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 81),
  [14417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [14419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 3, 0, 0),
  [14421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 10),
  [14423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 10),
  [14425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 4, 0, 0),
  [14427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [14429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [14431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [14433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [14435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [14437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3934),
  [14440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [14442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [14444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [14446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [14448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter_declaration, 3, 0, 166),
  [14450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [14452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [14454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [14456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [14458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [14460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [14462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [14464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [14466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3913),
  [14469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [14471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [14473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [14475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [14477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [14479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [14481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2961),
  [14483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [14485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [14487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [14489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [14491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [14493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 5, 0, 131),
  [14495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 5, 0, 131),
  [14497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 130),
  [14499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 130),
  [14501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 80),
  [14503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 80),
  [14505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [14507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [14509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [14511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0),
  [14513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [14515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [14517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 6, 0, 183),
  [14519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 6, 0, 183),
  [14521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [14523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [14525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [14527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [14529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 3, 0, 10),
  [14531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 3, 0, 10),
  [14533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 3, 0, 0), SHIFT_REPEAT(4091),
  [14536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [14538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [14540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [14542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter_declaration, 4, 0, 206),
  [14544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4114),
  [14546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [14548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [14550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [14552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5242),
  [14554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [14556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [14558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2986),
  [14560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [14562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [14564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [14566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2929),
  [14568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [14570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [14572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [14574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [14576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [14578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [14580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [14582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [14584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [14586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [14588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [14590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [14592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [14594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [14596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [14598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3695),
  [14600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [14602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4082),
  [14604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [14606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [14608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [14610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [14612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [14614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4067),
  [14616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [14618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [14620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [14622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [14624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [14626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [14628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [14630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [14632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [14634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2477),
  [14636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [14638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [14640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [14642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4747),
  [14644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [14646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [14648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [14650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [14652] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4110),
  [14655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [14657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [14659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [14661] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 195), SHIFT_REPEAT(7594),
  [14664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 195),
  [14666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 195),
  [14668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4274),
  [14671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [14673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [14675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [14677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [14679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [14681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [14683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [14685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4271),
  [14687] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4141),
  [14690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [14692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [14694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4196),
  [14696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7559),
  [14698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10268),
  [14700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [14702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [14704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10457),
  [14706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7466),
  [14708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [14710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [14712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [14714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [14716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7029),
  [14718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [14720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [14722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [14724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [14726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_name_repeat1, 2, 0, 0),
  [14728] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_name_repeat1, 2, 0, 0), SHIFT_REPEAT(10968),
  [14731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [14733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [14735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [14737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [14739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10584),
  [14741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9313),
  [14743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [14745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [14747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_name, 2, 0, 0),
  [14749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10968),
  [14751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 119), SHIFT_REPEAT(7447),
  [14754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 119),
  [14756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 119),
  [14758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_qualifier, 1, 0, 0),
  [14760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10750),
  [14762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10365),
  [14764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [14766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_access_specifier, 1, 0, 0),
  [14768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_access_specifier, 1, 0, 0),
  [14770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 6),
  [14772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11613),
  [14774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [14776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [14778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [14780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 4, 0, 140),
  [14782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11196),
  [14784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [14786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [14788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9484),
  [14790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7482),
  [14792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 5, 0, 0),
  [14794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [14796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [14798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_name, 1, 0, 0),
  [14800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9375),
  [14802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 2, 0, 0),
  [14804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7588),
  [14806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [14808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3115),
  [14810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10589),
  [14812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list, 1, 0, 0),
  [14814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [14816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [14818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [14820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10493),
  [14822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3117),
  [14824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4089),
  [14826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [14828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_declarators, 2, 0, 89),
  [14830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_declarators, 2, 0, 89),
  [14832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [14834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [14836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4008),
  [14838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [14840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10517),
  [14842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9356),
  [14844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 4, 0, 0),
  [14846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9394),
  [14848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 3, 0, 0),
  [14850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10530),
  [14852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [14854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [14856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [14858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [14860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [14862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [14864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7527),
  [14866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 3, 4, 0),
  [14868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [14870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9812),
  [14872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [14874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7028),
  [14876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [14878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [14880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3609),
  [14882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3324),
  [14884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9323),
  [14886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9323),
  [14888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3733),
  [14890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9485),
  [14892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list, 2, 0, 0),
  [14894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list_no_comma, 2, 0, 0),
  [14896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3333),
  [14898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9488),
  [14900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9488),
  [14902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3320),
  [14904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10762),
  [14906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10595),
  [14908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4138),
  [14910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5268),
  [14912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [14914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5294),
  [14916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4142),
  [14918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [14920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [14922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [14924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4146),
  [14926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [14928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [14930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [14932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__namespace_specifier, 1, 0, 19),
  [14934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9236),
  [14936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4150),
  [14938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3594),
  [14940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4154),
  [14942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3702),
  [14944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [14946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3710),
  [14948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list_no_comma, 1, 0, 0),
  [14950] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 223), SHIFT_REPEAT(8823),
  [14953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 223),
  [14955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [14957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [14959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4158),
  [14961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [14963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [14965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [14967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [14969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7756),
  [14971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 3, 0, 233),
  [14973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4162),
  [14975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [14977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [14979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [14981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10115),
  [14983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 2, 0, 0),
  [14985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4166),
  [14987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4581),
  [14989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [14991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4583),
  [14993] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(7482),
  [14996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3653),
  [14998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9369),
  [15000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9369),
  [15002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10002),
  [15004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 3, 0, 0),
  [15006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10596),
  [15008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10340),
  [15010] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 238), SHIFT_REPEAT(7756),
  [15013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 238),
  [15015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [15017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10271),
  [15019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11029),
  [15021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10736),
  [15023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10426),
  [15025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10723),
  [15027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5889),
  [15029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3647),
  [15031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [15033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10427),
  [15035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10545),
  [15037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [15039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [15041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11516),
  [15043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4015),
  [15045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [15047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3971),
  [15049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [15051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [15053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [15055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11031),
  [15057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9409),
  [15059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9409),
  [15061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9281),
  [15063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11331),
  [15065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [15067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [15069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11342),
  [15071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [15073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3363),
  [15075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9406),
  [15077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9406),
  [15079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [15081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11003),
  [15083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4199),
  [15085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [15087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4828),
  [15089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3346),
  [15091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3945),
  [15093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [15095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7426),
  [15097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11664),
  [15099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [15101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8893),
  [15103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 3, 0, 203),
  [15105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8823),
  [15107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 2, 0, 161),
  [15109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3672),
  [15111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9833),
  [15113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9290),
  [15115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [15117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8498),
  [15119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_hinted_declarator, 2, 0, 0),
  [15121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [15123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4041),
  [15125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [15127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [15129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [15131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [15133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [15135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10421),
  [15137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10516),
  [15139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [15141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [15143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3066),
  [15145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9442),
  [15147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9442),
  [15149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4601),
  [15151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3070),
  [15153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10094),
  [15155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_declarator, 1, 0, 0),
  [15157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4057),
  [15159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [15161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [15163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2937),
  [15165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 6, 0, 213),
  [15167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5332),
  [15169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [15171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2992),
  [15173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4544),
  [15175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4961),
  [15177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9466),
  [15179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9466),
  [15181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4268),
  [15183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [15185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5549),
  [15187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4980),
  [15189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [15191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4520),
  [15193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9458),
  [15195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9458),
  [15197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [15199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 2, 0, 161),
  [15201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9302),
  [15203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_operator_cast_identifier, 2, 0, 33),
  [15205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4071),
  [15207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2749),
  [15209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2908),
  [15211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9503),
  [15213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9503),
  [15215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [15217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2753),
  [15219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [15221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [15223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 6, 0, 0),
  [15225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10275),
  [15227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 4, 0, 0),
  [15229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [15231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11001),
  [15233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_char_literal_repeat1, 2, 0, 0),
  [15235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_char_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(9485),
  [15238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3552),
  [15240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9492),
  [15242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9492),
  [15244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0),
  [15246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(9488),
  [15249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(9488),
  [15252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [15254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5233),
  [15256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3563),
  [15258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 3, 0, 5),
  [15260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 3, 0, 5),
  [15262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 3, 0, 218),
  [15264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 3, 0, 218),
  [15266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3886),
  [15268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [15270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [15272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [15274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3965),
  [15276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7314),
  [15278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8325),
  [15280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2911),
  [15282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [15284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [15286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4002),
  [15288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [15290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7968),
  [15292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9511),
  [15294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9511),
  [15296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3269),
  [15298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9324),
  [15300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9324),
  [15302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4163),
  [15304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7920),
  [15306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [15308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [15310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4092),
  [15312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3302),
  [15314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [15316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [15318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [15320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10494),
  [15322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10602),
  [15324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3505),
  [15326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9525),
  [15328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9525),
  [15330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [15332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 223), SHIFT_REPEAT(8893),
  [15335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 223),
  [15337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3698),
  [15339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3482),
  [15341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [15343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11100),
  [15345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 3, 0, 203),
  [15347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 2, 0, 224),
  [15349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4100),
  [15351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [15353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [15355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2971),
  [15357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4936),
  [15359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9536),
  [15361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9536),
  [15363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9255),
  [15365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4112),
  [15367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4937),
  [15369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4105),
  [15371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [15373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2563),
  [15375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [15377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, 0, 93),
  [15379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3534),
  [15381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9542),
  [15383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9542),
  [15385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3532),
  [15387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [15389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3894),
  [15391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8348),
  [15393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4111),
  [15395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [15397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [15399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [15401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3463),
  [15403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9554),
  [15405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9554),
  [15407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3443),
  [15409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3984),
  [15411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [15413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3942),
  [15415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4117),
  [15417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [15419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [15421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [15423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3980),
  [15425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4818),
  [15427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9567),
  [15429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9567),
  [15431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [15433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4011),
  [15435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4832),
  [15437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4037),
  [15439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4123),
  [15441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8447),
  [15443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4053),
  [15445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [15447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8449),
  [15449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4068),
  [15451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [15453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [15455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3345),
  [15457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9582),
  [15459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9582),
  [15461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3349),
  [15463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3404),
  [15465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9600),
  [15467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9600),
  [15469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4129),
  [15471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4751),
  [15473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [15475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4760),
  [15477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [15479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10986),
  [15481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10081),
  [15483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 5, 0, 0),
  [15485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 7, 0, 0),
  [15487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4791),
  [15489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9596),
  [15491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9596),
  [15493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4661),
  [15495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4134),
  [15497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2963),
  [15499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4402),
  [15501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3400),
  [15503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [15505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [15507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_declaration_repeat1, 1, 0, 0),
  [15509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2947),
  [15511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [15513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5245),
  [15515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8104),
  [15517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 3, 0, 58),
  [15519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10322),
  [15521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7215),
  [15523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7565),
  [15525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7001),
  [15527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [15529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10269),
  [15531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8537),
  [15533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9048),
  [15535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [15537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1635),
  [15540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_parameter_list_repeat1, 2, 0, 0),
  [15542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10979),
  [15544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11056),
  [15546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11119),
  [15548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [15550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [15552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [15554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [15556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10553),
  [15558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6136),
  [15560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [15562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2948),
  [15564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6086),
  [15566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [15568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [15570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3381),
  [15572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10476),
  [15574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3479),
  [15576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7590),
  [15578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10098),
  [15580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8534),
  [15582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10104),
  [15584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [15586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [15588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [15590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [15592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [15594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [15596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [15598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4611),
  [15600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [15602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [15604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10416),
  [15606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [15608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [15610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10356),
  [15612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2991),
  [15614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10193),
  [15616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10205),
  [15618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [15620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [15622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5274),
  [15624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [15626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10242),
  [15628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10244),
  [15630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [15632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10265),
  [15634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [15636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7192),
  [15638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [15640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4686),
  [15642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [15644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3603),
  [15646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [15648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3592),
  [15650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5133),
  [15652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3598),
  [15654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7005),
  [15656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [15658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4923),
  [15660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4927),
  [15662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [15664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [15666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [15668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6149),
  [15670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3341),
  [15672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3610),
  [15674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6151),
  [15676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1633),
  [15679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3570),
  [15681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [15683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [15685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4878),
  [15687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [15689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3576),
  [15691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3577),
  [15693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4244),
  [15695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand, 4, 0, 232),
  [15697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9126),
  [15699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9100),
  [15701] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requires_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1816),
  [15704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_requires_parameter_list_repeat1, 2, 0, 0),
  [15706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [15708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10626),
  [15710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [15712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [15714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3691),
  [15716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [15718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3412),
  [15720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [15722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3690),
  [15724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4897),
  [15726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5272),
  [15728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4672),
  [15730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4614),
  [15732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [15734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4921),
  [15736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4153),
  [15738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4161),
  [15740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [15742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4183),
  [15744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3689),
  [15746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10594),
  [15748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [15750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [15752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9270),
  [15754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10828),
  [15756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10696),
  [15758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 3, 3, 0),
  [15760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4029),
  [15762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9599),
  [15764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3394),
  [15766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [15768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4834),
  [15770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4306),
  [15772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10358),
  [15774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4677),
  [15776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4678),
  [15778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [15780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11373),
  [15782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11517),
  [15784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11524),
  [15786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3683),
  [15788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [15790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10389),
  [15792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [15794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [15796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [15798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 161),
  [15800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3703),
  [15802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4683),
  [15804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3706),
  [15806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4684),
  [15808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [15810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3966),
  [15812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3972),
  [15814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [15816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9045),
  [15818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4687),
  [15820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3486),
  [15822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4688),
  [15824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2995),
  [15826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [15828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5236),
  [15830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4690),
  [15832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [15834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [15836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6108),
  [15838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6110),
  [15840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [15842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [15844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 4, 0, 68),
  [15846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [15848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [15850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4635),
  [15852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [15854] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1782),
  [15857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0),
  [15859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6144),
  [15861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6145),
  [15863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [15865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10597),
  [15867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_type_parameter_declaration, 2, 0, 0),
  [15869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3681),
  [15871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [15873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [15875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6150),
  [15877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4387),
  [15879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [15881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [15883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6155),
  [15885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [15887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4610),
  [15889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [15891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [15893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [15895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8065),
  [15897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 2, 0, 0),
  [15899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7771),
  [15901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4390),
  [15903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [15905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10672),
  [15907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9320),
  [15909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4393),
  [15911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [15913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter_declaration, 2, 0, 68),
  [15915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_throw_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(4118),
  [15918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_throw_specifier_repeat1, 2, 0, 0),
  [15920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11121),
  [15922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11124),
  [15924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11126),
  [15926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2928),
  [15928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10747),
  [15930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [15932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 5, 0, 23),
  [15934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [15936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [15938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [15940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [15942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [15944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [15946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [15948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2682),
  [15950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [15952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_namespace_specifier, 3, 0, 0),
  [15954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9260),
  [15956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2932),
  [15958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5261),
  [15960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2933),
  [15962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3380),
  [15964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [15966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2924),
  [15968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [15970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [15972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2936),
  [15974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2927),
  [15976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9501),
  [15978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [15980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11180),
  [15982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11181),
  [15984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11182),
  [15986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [15988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [15990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10658),
  [15992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11550),
  [15994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 2, 0, 234),
  [15996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3473),
  [15998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [16000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11526),
  [16002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [16004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [16006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [16008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9454),
  [16010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [16012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [16014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [16016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [16018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [16020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_range_designator, 5, 0, 215),
  [16022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2993),
  [16024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5216),
  [16026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9368),
  [16028] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8065),
  [16031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2, 0, 0),
  [16033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4654),
  [16035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4657),
  [16037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11653),
  [16039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11656),
  [16041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11660),
  [16043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [16045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [16047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [16049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4521),
  [16051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [16053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4585),
  [16055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [16057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subscript_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1883),
  [16060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [16062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [16064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4353),
  [16066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4631),
  [16068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9405),
  [16070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4538),
  [16072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11169),
  [16074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11174),
  [16076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11183),
  [16078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [16080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [16082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7377),
  [16084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [16086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [16088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [16090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4118),
  [16092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6951),
  [16094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [16096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [16098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [16100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [16102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4568),
  [16104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9441),
  [16106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [16108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4571),
  [16110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2750),
  [16112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [16114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [16116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [16118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4555),
  [16120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [16122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9465),
  [16124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4556),
  [16126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4582),
  [16128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8954),
  [16130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [16132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 119), SHIFT_REPEAT(6579),
  [16135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 119),
  [16137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [16139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [16141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2756),
  [16143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9491),
  [16145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2758),
  [16147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2741),
  [16149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5316),
  [16151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4896),
  [16153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4584),
  [16155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9510),
  [16157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9524),
  [16159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5326),
  [16161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [16163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4647),
  [16165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [16167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10487),
  [16169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4452),
  [16171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_get, 2, 0, 0),
  [16173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_set, 2, 0, 0),
  [16175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4591),
  [16177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4594),
  [16179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [16181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [16183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4523),
  [16185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [16187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10357),
  [16189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4673),
  [16191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4597),
  [16193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4598),
  [16195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4851),
  [16197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4173),
  [16199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [16201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10411),
  [16203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 2, 0, 102),
  [16205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 3, 0, 0),
  [16207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10486),
  [16209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 2, 0, 0),
  [16211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4852),
  [16213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [16215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_reference_declarator, 2, 0, 0),
  [16217] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_structured_binding_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(11055),
  [16220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_structured_binding_declarator_repeat1, 2, 0, 0),
  [16222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10397),
  [16224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [16226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [16228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [16230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [16232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [16234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [16236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [16238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [16240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10445),
  [16242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [16244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3447),
  [16246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [16248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7342),
  [16251] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2, 0, 0), SHIFT_REPEAT(10604),
  [16254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2, 0, 0),
  [16256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10604),
  [16258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10605),
  [16260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9408),
  [16262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [16264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [16266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10152),
  [16268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8781),
  [16270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 6, 0, 0),
  [16272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [16274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [16276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9353),
  [16278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [16280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1327),
  [16283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 0, 0),
  [16285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6954),
  [16287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [16289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [16291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [16293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [16295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [16297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_declarator, 2, 0, 0),
  [16299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [16301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3305),
  [16303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [16305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [16307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3307),
  [16309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7221),
  [16311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3309),
  [16313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3310),
  [16315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2709),
  [16317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 161),
  [16319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7053),
  [16321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [16323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4370),
  [16325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [16327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_lambda_capture_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(7565),
  [16330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_lambda_capture_specifier_repeat1, 2, 0, 0),
  [16332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(4269),
  [16335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 2, 0, 0),
  [16337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5228),
  [16339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2985),
  [16341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [16343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2969),
  [16345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4885),
  [16347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand, 4, 0, 232),
  [16349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2972),
  [16351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [16353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2977),
  [16355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2978),
  [16357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [16359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10710),
  [16361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4865),
  [16363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 224),
  [16365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [16367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [16369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4675),
  [16371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [16373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 4, 4, 0),
  [16375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [16377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [16379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [16381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10719),
  [16383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [16385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [16387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [16389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [16391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11041),
  [16393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11043),
  [16395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11044),
  [16397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [16399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [16401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [16403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [16405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 3, 0, 239),
  [16407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(10322),
  [16410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2, 0, 0),
  [16412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9278),
  [16414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4501),
  [16416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 241), SHIFT_REPEAT(11550),
  [16419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 241),
  [16421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4250),
  [16423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [16425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4676),
  [16427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10712),
  [16429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [16431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [16433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [16435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand, 7, 0, 242),
  [16437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [16439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [16441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [16443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [16445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [16447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [16449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 6, 0, 59),
  [16451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4844),
  [16453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4845),
  [16455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_designator, 2, 0, 97),
  [16457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2684),
  [16459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4048),
  [16461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [16463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [16465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [16467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand, 7, 0, 242),
  [16469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [16471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2713),
  [16473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [16475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8162),
  [16477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [16479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [16481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [16483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10959),
  [16485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7345),
  [16487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [16489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [16491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10363),
  [16493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [16495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4602),
  [16497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8441),
  [16499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8444),
  [16501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8448),
  [16503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [16505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4867),
  [16507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2715),
  [16509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8450),
  [16511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4868),
  [16513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [16515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8453),
  [16517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8458),
  [16519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8461),
  [16521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [16523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [16525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_namespace_specifier, 2, 0, 0),
  [16527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10074),
  [16529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10372),
  [16531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [16533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9251),
  [16535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__namespace_specifier, 2, 0, 61),
  [16537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4746),
  [16539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10751),
  [16541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4871),
  [16543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4872),
  [16545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10488),
  [16547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4749),
  [16549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4752),
  [16551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [16553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4761),
  [16555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [16557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2874),
  [16559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4553),
  [16561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4783),
  [16563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4786),
  [16565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [16567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4788),
  [16569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10023),
  [16571] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1835),
  [16574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2949),
  [16576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11199),
  [16578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10024),
  [16580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4395),
  [16582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4875),
  [16584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [16586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [16588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [16590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4876),
  [16592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [16594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6987),
  [16596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2964),
  [16598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4042),
  [16600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9174),
  [16602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [16604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2966),
  [16606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2944),
  [16608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [16610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4646),
  [16612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11466),
  [16614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11718),
  [16616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9137),
  [16618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5246),
  [16620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5640),
  [16622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [16624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [16626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11482),
  [16628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 4, 0, 0),
  [16630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 4, 0, 0),
  [16632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [16634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 2, 0, 0),
  [16636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 2, 0, 0),
  [16638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10448),
  [16640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [16642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11216),
  [16644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [16646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_partition, 2, 0, 0),
  [16648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10548),
  [16650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 2, 0),
  [16652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9868),
  [16654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11648),
  [16656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3709),
  [16658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, 0, 102),
  [16660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10020),
  [16662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11244),
  [16664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7591),
  [16666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10491),
  [16668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3030),
  [16670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [16672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10049),
  [16674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10912),
  [16676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_parameter_pack_expansion, 2, 0, 28),
  [16678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [16680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4958),
  [16682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [16684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11484),
  [16686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [16688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11208),
  [16690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10381),
  [16692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10734),
  [16694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9773),
  [16696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11632),
  [16698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9909),
  [16700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 1, 0, 0),
  [16702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10578),
  [16704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, 0, 0),
  [16706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [16708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11483),
  [16710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [16712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 4, 3, 0),
  [16714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10703),
  [16716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10514),
  [16718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10475),
  [16720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7246),
  [16722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10999),
  [16724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [16726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 5, 0, 140),
  [16728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [16730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10680),
  [16732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 234),
  [16734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10339),
  [16736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [16738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11710),
  [16740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10524),
  [16742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3245),
  [16744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10741),
  [16746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3880),
  [16748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 7, 0, 213),
  [16750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10533),
  [16752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [16754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [16756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [16758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_type_parameter_declaration, 3, 0, 165),
  [16760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7429),
  [16762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11537),
  [16764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10362),
  [16766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 3, 0, 0),
  [16768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 3, 0, 0),
  [16770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [16772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10965),
  [16774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [16776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10819),
  [16778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [16780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10850),
  [16782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [16784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10808),
  [16786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3668),
  [16788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10991),
  [16790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10861),
  [16792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10932),
  [16794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11696),
  [16796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2901),
  [16798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10581),
  [16800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10368),
  [16802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10187),
  [16804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11495),
  [16806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [16808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [16810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11107),
  [16812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [16814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11560),
  [16816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_template_parameter_declaration, 3, 0, 59),
  [16818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10624),
  [16820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [16822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9764),
  [16824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10937),
  [16826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10390),
  [16828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 4, 0, 93),
  [16830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10535),
  [16832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10636),
  [16834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_pack_expansion, 2, 0, 28),
  [16836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [16838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11117),
  [16840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [16842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11114),
  [16844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11242),
  [16846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10786),
  [16848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11319),
  [16850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11703),
  [16852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11360),
  [16854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11706),
  [16856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 5, 3, 0),
  [16858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11388),
  [16860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11709),
  [16862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11412),
  [16864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11711),
  [16866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11429),
  [16868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11712),
  [16870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11444),
  [16872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11713),
  [16874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11450),
  [16876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11714),
  [16878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11455),
  [16880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11715),
  [16882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11459),
  [16884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11716),
  [16886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11463),
  [16888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11717),
  [16890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11469),
  [16892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11719),
  [16894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11472),
  [16896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11720),
  [16898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11475),
  [16900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11721),
  [16902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, 0, 6),
  [16904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5951),
  [16906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11636),
  [16908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11066),
  [16910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [16912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4382),
  [16914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10823),
  [16916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4741),
  [16918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [16920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8064),
  [16922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [16924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11127),
  [16926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4850),
  [16928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [16930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4858),
  [16932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11139),
  [16934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [16936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4862),
  [16938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4742),
  [16940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [16942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11188),
  [16944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [16946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [16948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11201),
  [16950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7406),
  [16952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4743),
  [16954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [16956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [16958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11269),
  [16960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [16962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [16964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [16966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11281),
  [16968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 3, 0, 81),
  [16970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_right_fold, 3, 0, 55),
  [16972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11336),
  [16974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [16976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [16978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11598),
  [16980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11351),
  [16982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4615),
  [16984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [16986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [16988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11428),
  [16990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [16992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10705),
  [16994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [16996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11485),
  [16998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [17000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [17002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [17004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11546),
  [17006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4658),
  [17008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11582),
  [17010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [17012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [17014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11687),
  [17016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [17018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [17020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [17022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [17024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7151),
  [17026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4524),
  [17028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7152),
  [17030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7153),
  [17032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11553),
  [17034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4106),
  [17036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [17038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [17040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3646),
  [17042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [17044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [17046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [17048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6147),
  [17050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [17052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5306),
  [17054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [17056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5410),
  [17058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7416),
  [17060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_declaration, 3, 0, 151),
  [17062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [17064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [17066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4133),
  [17068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [17070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4609),
  [17072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [17074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [17076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6143),
  [17078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6156),
  [17080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [17082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [17084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10434),
  [17086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11074),
  [17088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [17090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [17092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [17094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4261),
  [17096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [17098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [17100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [17102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [17104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4151),
  [17106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11697),
  [17108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [17110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3119),
  [17112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11218),
  [17114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9526),
  [17116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [17118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [17120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10619),
  [17122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11278),
  [17124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3375),
  [17126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [17128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5745),
  [17130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [17132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9392),
  [17134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [17136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11407),
  [17138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [17140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [17142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5184),
  [17144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [17146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [17148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11722),
  [17150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9068),
  [17152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7911),
  [17154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [17156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [17158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9127),
  [17160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4194),
  [17162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 4, 0, 81),
  [17164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3497),
  [17166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9373),
  [17168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [17170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11037),
  [17172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10209),
  [17174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [17176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [17178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [17180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9420),
  [17182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [17184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11163),
  [17186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [17188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [17190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4712),
  [17192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 4, 0, 130),
  [17194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11207),
  [17196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11358),
  [17198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [17200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9623),
  [17202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [17204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 5, 0, 183),
  [17206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10423),
  [17208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [17210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [17212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [17214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [17216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef, 4, 0, 131),
  [17218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [17220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11562),
  [17222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [17224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8408),
  [17226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [17228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10967),
  [17230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4801),
  [17232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10220),
  [17234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11115),
  [17236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [17238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [17240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [17242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [17244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [17246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [17248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10892),
  [17250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [17252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5320),
  [17254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2915),
  [17256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [17258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4431),
  [17260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11013),
  [17262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [17264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [17266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [17268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3651),
  [17270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11022),
  [17272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9386),
  [17274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 5, 0, 0),
  [17276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11093),
  [17278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [17280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [17282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [17284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [17286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11604),
  [17288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [17290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [17292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [17294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 4, 0, 10),
  [17296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [17298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [17300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [17302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [17304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11622),
  [17306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [17308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4915),
  [17310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [17312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [17314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10690),
  [17316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [17318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3216),
  [17320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3833),
  [17322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9384),
  [17324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10864),
  [17326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10866),
  [17328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [17330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11016),
  [17332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4917),
  [17334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3411),
  [17336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [17338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [17340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [17342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10274),
  [17344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3416),
  [17346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11534),
  [17348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [17350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [17352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [17354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [17356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3564),
  [17358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [17360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9177),
  [17362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [17364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [17366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11071),
  [17368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [17370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [17372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [17374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [17376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [17378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3851),
  [17380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [17382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [17384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7820),
  [17386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4879),
  [17388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8410),
  [17390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9053),
  [17392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [17394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7277),
  [17396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [17398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [17400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [17402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [17404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4881),
  [17406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [17408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3549),
  [17410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [17412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3536),
  [17414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7423),
  [17416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9483),
  [17418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [17420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [17422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [17424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_based_modifier, 2, 0, 0),
  [17426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10915),
  [17428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10929),
  [17430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10961),
  [17432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3537),
  [17434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [17436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [17438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3753),
  [17440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4260),
  [17442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4864),
  [17444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4541),
  [17446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [17448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [17450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [17452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5197),
  [17454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [17456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9273),
  [17458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9145),
  [17460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9175),
  [17462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6240),
  [17464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [17466] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [17468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [17470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [17472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 5, 0, 183),
  [17474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [17476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5198),
  [17478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [17480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [17482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [17484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5199),
  [17486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [17488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [17490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [17492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [17494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [17496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11298),
  [17498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3480),
  [17500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8405),
  [17502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3456),
  [17504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [17506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11330),
  [17508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9453),
  [17510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4669),
  [17512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11518),
  [17514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_parameter_list, 3, 0, 0),
  [17516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [17518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3462),
  [17520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9586),
  [17522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [17524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9919),
  [17526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10817),
  [17528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10818),
  [17530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [17532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [17534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3389),
  [17536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4263),
  [17538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11433),
  [17540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [17542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [17544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [17546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10042),
  [17548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3669),
  [17550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [17552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11652),
  [17554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10693),
  [17556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [17558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [17560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4286),
  [17562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [17564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [17566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [17568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3401),
  [17570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10349),
  [17572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4072),
  [17574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11410),
  [17576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11596),
  [17578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11600),
  [17580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [17582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11435),
  [17584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5124),
  [17586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [17588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [17590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [17592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11543),
  [17594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [17596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11574),
  [17598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [17600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4081),
  [17602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11590),
  [17604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [17606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [17608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7483),
  [17610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [17612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [17614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 5, 0, 130),
  [17616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4815),
  [17618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [17620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [17622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [17624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9140),
  [17626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9361),
  [17628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [17630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 5, 0, 80),
  [17632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11296),
  [17634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [17636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4808),
  [17638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4032),
  [17640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [17642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11369),
  [17644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [17646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [17648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 6, 0, 23),
  [17650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [17652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [17654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [17656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4625),
  [17658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [17660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4843),
  [17662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9065),
  [17664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [17666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5155),
  [17668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7050),
  [17670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10663),
  [17672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [17674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3929),
  [17676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [17678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [17680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9075),
  [17682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10708),
  [17684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11008),
  [17686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7051),
  [17688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7052),
  [17690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11023),
  [17692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7363),
  [17694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [17696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11047),
  [17698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10631),
  [17700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10975),
  [17702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11062),
  [17704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [17706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [17708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [17710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10962),
  [17712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [17714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 3, 0, 81),
  [17716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3362),
  [17718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [17720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11039),
  [17722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [17724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [17726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [17728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [17730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [17732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [17734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10398),
  [17736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [17738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [17740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3357),
  [17742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [17744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 3, 0, 81),
  [17746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [17748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10414),
  [17750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11186),
  [17752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [17754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [17756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11195),
  [17758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [17760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10264),
  [17762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11214),
  [17764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11197),
  [17766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11239),
  [17768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [17770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 7, 0, 59),
  [17772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 6, 0, 183),
  [17774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [17776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 4, 0, 130),
  [17778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [17780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [17782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [17784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10472),
  [17786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [17788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3999),
  [17790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [17792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [17794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4969),
  [17796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 4, 0, 130),
  [17798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11325),
  [17800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [17802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11338),
  [17804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11345),
  [17806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11346),
  [17808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11365),
  [17810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [17812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11390),
  [17814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [17816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [17818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4079),
  [17820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 5, 0, 183),
  [17822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [17824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9881),
  [17826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10541),
  [17828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [17830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10283),
  [17832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [17834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11361),
  [17836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [17838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [17840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11192),
  [17842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [17844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11500),
  [17846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [17848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [17850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4837),
  [17852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [17854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11532),
  [17856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [17858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5210),
  [17860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4795),
  [17862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2092),
  [17864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9400),
  [17866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [17868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10588),
  [17870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [17872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [17874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4723),
  [17876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11575),
  [17878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [17880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 5, 0, 183),
  [17882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11585),
  [17884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4866),
  [17886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11583),
  [17888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [17890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [17892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10941),
  [17894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10618),
  [17896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [17898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [17900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef, 3, 0, 81),
  [17902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11624),
  [17904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [17906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11639),
  [17908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10648),
  [17910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [17912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [17914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11671),
  [17916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11681),
  [17918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10662),
  [17920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [17922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [17924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11724),
  [17926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10787),
  [17928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10671),
  [17930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [17932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10797),
  [17934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10801),
  [17936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10674),
  [17938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [17940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10807),
  [17942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10811),
  [17944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [17946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10816),
  [17948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10820),
  [17950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [17952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10825),
  [17954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10829),
  [17956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [17958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10834),
  [17960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10838),
  [17962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [17964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10843),
  [17966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10847),
  [17968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [17970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [17972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [17974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10931),
  [17976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [17978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [17980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [17982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4724),
  [17984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [17986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [17988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 4, 0, 131),
  [17990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11685),
  [17992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [17994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [17996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [17998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2685),
  [18000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11382),
  [18002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9505),
  [18004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10977),
  [18006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [18008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 4, 0, 131),
  [18010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [18012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [18014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [18016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [18018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [18020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [18022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [18024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [18026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [18028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 5, 0, 131),
  [18030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [18032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4589),
  [18034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [18036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [18038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [18040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_parameter_list, 4, 0, 0),
  [18042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [18044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [18046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4570),
  [18048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11601),
  [18050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [18052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11606),
  [18054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [18056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2877),
  [18058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [18060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [18062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11129),
  [18064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4573),
  [18066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [18068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [18070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [18072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11210),
  [18074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [18076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [18078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4070),
  [18080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4574),
  [18082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10538),
  [18084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3428),
  [18086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [18088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11136),
  [18090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4578),
  [18092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10949),
  [18094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [18096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4920),
  [18098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [18100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11146),
  [18102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [18104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [18106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3474),
  [18108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3475),
  [18110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [18112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [18114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4709),
  [18116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9193),
  [18118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9194),
  [18120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11088),
  [18122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [18124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5187),
  [18126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11559),
  [18128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7956),
  [18130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [18132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [18134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3331),
  [18136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3280),
  [18138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [18140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11125),
  [18142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11415),
  [18144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9028),
  [18146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11437),
  [18148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11445),
  [18150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [18152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [18154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4453),
  [18156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [18158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4312),
  [18160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11160),
  [18162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, 0, 130),
  [18164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3366),
  [18166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [18168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9128),
  [18170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4554),
  [18172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_parameter_list, 2, 0, 0),
  [18174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4962),
  [18176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [18178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [18180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9131),
  [18182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [18184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9539),
  [18186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7834),
  [18188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4689),
  [18190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4874),
  [18192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 4, 0, 131),
  [18194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [18196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6106),
  [18198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11579),
  [18200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11267),
  [18202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [18204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2602),
  [18206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11241),
  [18208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [18210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4692),
  [18212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [18214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [18216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4947),
  [18218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [18220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9548),
  [18222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11257),
  [18224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [18226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4877),
  [18228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11647),
  [18230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [18232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11586),
  [18234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5201),
  [18236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [18238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [18240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11732),
  [18242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6129),
  [18244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7898),
  [18246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [18248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9557),
  [18250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11326),
  [18252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [18254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [18256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [18258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11359),
  [18260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9561),
  [18262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11366),
  [18264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [18266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [18268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11387),
  [18270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9566),
  [18272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11394),
  [18274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11506),
  [18276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [18278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11411),
  [18280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10926),
  [18282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9570),
  [18284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11417),
  [18286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [18288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9575),
  [18290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11432),
  [18292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [18294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11446),
  [18296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11451),
  [18298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10950),
  [18300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11456),
  [18302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11460),
  [18304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9039),
  [18306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11464),
  [18308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [18310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11467),
  [18312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(10790),
  [18315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11470),
  [18317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5143),
  [18319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11473),
  [18321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [18323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11476),
  [18325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4239),
  [18327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11502),
  [18329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4595),
  [18331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4382),
  [18333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4287),
  [18335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [18337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4293),
  [18339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11650),
  [18341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11578),
  [18343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4296),
  [18345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11659),
  [18347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4299),
  [18349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11667),
  [18351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [18353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11673),
  [18355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11676),
  [18357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11678),
  [18359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11680),
  [18361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11682),
  [18363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11684),
  [18365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11686),
  [18367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11688),
  [18369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11690),
  [18371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11692),
  [18373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11694),
  [18375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [18377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [18379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11049),
  [18381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [18383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [18385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [18387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2660),
  [18389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [18391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token_raw_string_delimiter = 0,
  ts_external_token_raw_string_content = 1,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_raw_string_delimiter] = sym_raw_string_delimiter,
  [ts_external_token_raw_string_content] = sym_raw_string_content,
};

static const bool ts_external_scanner_states[4][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_raw_string_delimiter] = true,
    [ts_external_token_raw_string_content] = true,
  },
  [2] = {
    [ts_external_token_raw_string_delimiter] = true,
  },
  [3] = {
    [ts_external_token_raw_string_content] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_slang_external_scanner_create(void);
void tree_sitter_slang_external_scanner_destroy(void *);
bool tree_sitter_slang_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_slang_external_scanner_serialize(void *, char *);
void tree_sitter_slang_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_slang(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_slang_external_scanner_create,
      tree_sitter_slang_external_scanner_destroy,
      tree_sitter_slang_external_scanner_scan,
      tree_sitter_slang_external_scanner_serialize,
      tree_sitter_slang_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
